--
-- PostgreSQL database dump
--

-- Dumped from database version 13.4
-- Dumped by pg_dump version 13.4

-- Started on 2022-05-12 18:18:25 CEST

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- TOC entry 6 (class 2615 OID 3185447)
-- Name: OMOP_cdm_eunomia; Type: SCHEMA; Schema: -; Owner: juanma
--

CREATE SCHEMA "OMOP_cdm_eunomia";


ALTER SCHEMA "OMOP_cdm_eunomia" OWNER TO juanma;

SET default_tablespace = '';

SET default_table_access_method = heap;

--
-- TOC entry 201 (class 1259 OID 3185448)
-- Name: attribute_definition; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".attribute_definition (
    attribute_definition_id integer NOT NULL,
    attribute_name character varying(255) NOT NULL,
    attribute_description text,
    attribute_type_concept_id integer NOT NULL,
    attribute_syntax text
);


ALTER TABLE "OMOP_cdm_eunomia".attribute_definition OWNER TO juanma;

--
-- TOC entry 202 (class 1259 OID 3185454)
-- Name: care_site; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".care_site (
    care_site_id integer NOT NULL,
    care_site_name character varying(255),
    place_of_service_concept_id integer,
    location_id integer,
    care_site_source_value character varying(50),
    place_of_service_source_value character varying(50)
);


ALTER TABLE "OMOP_cdm_eunomia".care_site OWNER TO juanma;

--
-- TOC entry 203 (class 1259 OID 3185457)
-- Name: cdm_source; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".cdm_source (
    cdm_source_name character varying(255) NOT NULL,
    cdm_source_abbreviation character varying(25),
    cdm_holder character varying(255),
    source_description text,
    source_documentation_reference character varying(255),
    cdm_etl_reference character varying(255),
    source_release_date date,
    cdm_release_date date,
    cdm_version character varying(10),
    vocabulary_version character varying(20)
);


ALTER TABLE "OMOP_cdm_eunomia".cdm_source OWNER TO juanma;

--
-- TOC entry 204 (class 1259 OID 3185463)
-- Name: cohort; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".cohort (
    cohort_definition_id integer NOT NULL,
    subject_id integer NOT NULL,
    cohort_start_date date NOT NULL,
    cohort_end_date date NOT NULL
);


ALTER TABLE "OMOP_cdm_eunomia".cohort OWNER TO juanma;

--
-- TOC entry 205 (class 1259 OID 3185466)
-- Name: cohort_attribute; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".cohort_attribute (
    cohort_definition_id integer NOT NULL,
    subject_id integer NOT NULL,
    cohort_start_date date NOT NULL,
    cohort_end_date date NOT NULL,
    attribute_definition_id integer NOT NULL,
    value_as_number numeric,
    value_as_concept_id integer
);


ALTER TABLE "OMOP_cdm_eunomia".cohort_attribute OWNER TO juanma;

--
-- TOC entry 206 (class 1259 OID 3185472)
-- Name: cohort_definition; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".cohort_definition (
    cohort_definition_id integer NOT NULL,
    cohort_definition_name character varying(255) NOT NULL,
    cohort_definition_description text,
    definition_type_concept_id integer NOT NULL,
    cohort_definition_syntax text,
    subject_concept_id integer NOT NULL,
    cohort_initiation_date date
);


ALTER TABLE "OMOP_cdm_eunomia".cohort_definition OWNER TO juanma;

--
-- TOC entry 207 (class 1259 OID 3185478)
-- Name: concept; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".concept (
    concept_id integer NOT NULL,
    concept_name character varying(255) NOT NULL,
    domain_id character varying(20) NOT NULL,
    vocabulary_id character varying(20) NOT NULL,
    concept_class_id character varying(20) NOT NULL,
    standard_concept character varying(1),
    concept_code character varying(50) NOT NULL,
    valid_start_date date NOT NULL,
    valid_end_date date NOT NULL,
    invalid_reason character varying(1)
);


ALTER TABLE "OMOP_cdm_eunomia".concept OWNER TO juanma;

--
-- TOC entry 208 (class 1259 OID 3185481)
-- Name: concept_ancestor; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".concept_ancestor (
    ancestor_concept_id integer NOT NULL,
    descendant_concept_id integer NOT NULL,
    min_levels_of_separation integer NOT NULL,
    max_levels_of_separation integer NOT NULL
);


ALTER TABLE "OMOP_cdm_eunomia".concept_ancestor OWNER TO juanma;

--
-- TOC entry 209 (class 1259 OID 3185484)
-- Name: concept_class; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".concept_class (
    concept_class_id character varying(20) NOT NULL,
    concept_class_name character varying(255) NOT NULL,
    concept_class_concept_id integer NOT NULL
);


ALTER TABLE "OMOP_cdm_eunomia".concept_class OWNER TO juanma;

--
-- TOC entry 210 (class 1259 OID 3185487)
-- Name: concept_relationship; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".concept_relationship (
    concept_id_1 integer NOT NULL,
    concept_id_2 integer NOT NULL,
    relationship_id character varying(20) NOT NULL,
    valid_start_date date NOT NULL,
    valid_end_date date NOT NULL,
    invalid_reason character varying(1)
);


ALTER TABLE "OMOP_cdm_eunomia".concept_relationship OWNER TO juanma;

--
-- TOC entry 211 (class 1259 OID 3185490)
-- Name: concept_synonym; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".concept_synonym (
    concept_id integer NOT NULL,
    concept_synonym_name character varying(1000) NOT NULL,
    language_concept_id integer NOT NULL
);


ALTER TABLE "OMOP_cdm_eunomia".concept_synonym OWNER TO juanma;

--
-- TOC entry 212 (class 1259 OID 3185496)
-- Name: condition_era; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".condition_era (
    condition_era_id integer NOT NULL,
    person_id integer NOT NULL,
    condition_concept_id integer NOT NULL,
    condition_era_start_date date NOT NULL,
    condition_era_end_date date NOT NULL,
    condition_occurrence_count integer
);


ALTER TABLE "OMOP_cdm_eunomia".condition_era OWNER TO juanma;

--
-- TOC entry 213 (class 1259 OID 3185499)
-- Name: condition_occurrence; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".condition_occurrence (
    condition_occurrence_id integer NOT NULL,
    person_id integer NOT NULL,
    condition_concept_id integer NOT NULL,
    condition_start_date date NOT NULL,
    condition_start_datetime timestamp without time zone,
    condition_end_date date,
    condition_end_datetime timestamp without time zone,
    condition_type_concept_id integer NOT NULL,
    stop_reason character varying(20),
    provider_id integer,
    visit_occurrence_id integer,
    visit_detail_id integer,
    condition_source_value character varying(50),
    condition_source_concept_id integer,
    condition_status_source_value character varying(50),
    condition_status_concept_id integer
);


ALTER TABLE "OMOP_cdm_eunomia".condition_occurrence OWNER TO juanma;

--
-- TOC entry 214 (class 1259 OID 3185502)
-- Name: cost; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".cost (
    cost_id integer NOT NULL,
    cost_event_id integer NOT NULL,
    cost_domain_id character varying(20) NOT NULL,
    cost_type_concept_id integer NOT NULL,
    currency_concept_id integer,
    total_charge numeric,
    total_cost numeric,
    total_paid numeric,
    paid_by_payer numeric,
    paid_by_patient numeric,
    paid_patient_copay numeric,
    paid_patient_coinsurance numeric,
    paid_patient_deductible numeric,
    paid_by_primary numeric,
    paid_ingredient_cost numeric,
    paid_dispensing_fee numeric,
    payer_plan_period_id integer,
    amount_allowed numeric,
    revenue_code_concept_id integer,
    reveue_code_source_value character varying(50),
    drg_concept_id integer,
    drg_source_value character varying(3)
);


ALTER TABLE "OMOP_cdm_eunomia".cost OWNER TO juanma;

--
-- TOC entry 215 (class 1259 OID 3185508)
-- Name: death; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".death (
    person_id integer NOT NULL,
    death_date date NOT NULL,
    death_datetime timestamp without time zone,
    death_type_concept_id integer NOT NULL,
    cause_concept_id integer,
    cause_source_value character varying(50),
    cause_source_concept_id integer
);


ALTER TABLE "OMOP_cdm_eunomia".death OWNER TO juanma;

--
-- TOC entry 216 (class 1259 OID 3185511)
-- Name: device_exposure; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".device_exposure (
    device_exposure_id integer NOT NULL,
    person_id integer NOT NULL,
    device_concept_id integer NOT NULL,
    device_exposure_start_date date NOT NULL,
    device_exposure_start_datetime timestamp without time zone,
    device_exposure_end_date date,
    device_exposure_end_datetime timestamp without time zone,
    device_type_concept_id integer NOT NULL,
    unique_device_id character varying(50),
    quantity integer,
    provider_id integer,
    visit_occurrence_id integer,
    visit_detail_id integer,
    device_source_value character varying(100),
    device_source_concept_id integer
);


ALTER TABLE "OMOP_cdm_eunomia".device_exposure OWNER TO juanma;

--
-- TOC entry 217 (class 1259 OID 3185514)
-- Name: domain; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".domain (
    domain_id character varying(20) NOT NULL,
    domain_name character varying(255) NOT NULL,
    domain_concept_id integer NOT NULL
);


ALTER TABLE "OMOP_cdm_eunomia".domain OWNER TO juanma;

--
-- TOC entry 218 (class 1259 OID 3185517)
-- Name: dose_era; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".dose_era (
    dose_era_id integer NOT NULL,
    person_id integer NOT NULL,
    drug_concept_id integer NOT NULL,
    unit_concept_id integer NOT NULL,
    dose_value numeric NOT NULL,
    dose_era_start_date date NOT NULL,
    dose_era_end_date date NOT NULL
);


ALTER TABLE "OMOP_cdm_eunomia".dose_era OWNER TO juanma;

--
-- TOC entry 219 (class 1259 OID 3185523)
-- Name: drug_era; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".drug_era (
    drug_era_id integer NOT NULL,
    person_id integer NOT NULL,
    drug_concept_id integer NOT NULL,
    drug_era_start_date date NOT NULL,
    drug_era_end_date date NOT NULL,
    drug_exposure_count integer,
    gap_days integer
);


ALTER TABLE "OMOP_cdm_eunomia".drug_era OWNER TO juanma;

--
-- TOC entry 220 (class 1259 OID 3185526)
-- Name: drug_exposure; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".drug_exposure (
    drug_exposure_id integer NOT NULL,
    person_id integer NOT NULL,
    drug_concept_id integer NOT NULL,
    drug_exposure_start_date date NOT NULL,
    drug_exposure_start_datetime timestamp without time zone,
    drug_exposure_end_date date NOT NULL,
    drug_exposure_end_datetime timestamp without time zone,
    verbatim_end_date date,
    drug_type_concept_id integer NOT NULL,
    stop_reason character varying(20),
    refills integer,
    quantity numeric,
    days_supply integer,
    sig text,
    route_concept_id integer,
    lot_number character varying(50),
    provider_id integer,
    visit_occurrence_id integer,
    visit_detail_id integer,
    drug_source_value character varying(50),
    drug_source_concept_id integer,
    route_source_value character varying(50),
    dose_unit_source_value character varying(50)
);


ALTER TABLE "OMOP_cdm_eunomia".drug_exposure OWNER TO juanma;

--
-- TOC entry 221 (class 1259 OID 3185532)
-- Name: drug_strength; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".drug_strength (
    drug_concept_id integer NOT NULL,
    ingredient_concept_id integer NOT NULL,
    amount_value numeric,
    amount_unit_concept_id integer,
    numerator_value numeric,
    numerator_unit_concept_id integer,
    denominator_value numeric,
    denominator_unit_concept_id integer,
    box_size integer,
    valid_start_date date NOT NULL,
    valid_end_date date NOT NULL,
    invalid_reason character varying(1)
);


ALTER TABLE "OMOP_cdm_eunomia".drug_strength OWNER TO juanma;

--
-- TOC entry 222 (class 1259 OID 3185538)
-- Name: fact_relationship; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".fact_relationship (
    domain_concept_id_1 integer NOT NULL,
    fact_id_1 integer NOT NULL,
    domain_concept_id_2 integer NOT NULL,
    fact_id_2 integer NOT NULL,
    relationship_concept_id integer NOT NULL
);


ALTER TABLE "OMOP_cdm_eunomia".fact_relationship OWNER TO juanma;

--
-- TOC entry 223 (class 1259 OID 3185541)
-- Name: location; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".location (
    location_id integer NOT NULL,
    address_1 character varying(50),
    address_2 character varying(50),
    city character varying(50),
    state character varying(2),
    zip character varying(9),
    county character varying(20),
    location_source_value character varying(50)
);


ALTER TABLE "OMOP_cdm_eunomia".location OWNER TO juanma;

--
-- TOC entry 224 (class 1259 OID 3185544)
-- Name: measurement; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".measurement (
    measurement_id integer NOT NULL,
    person_id integer NOT NULL,
    measurement_concept_id integer NOT NULL,
    measurement_date date NOT NULL,
    measurement_datetime timestamp without time zone,
    measurement_time character varying(10),
    measurement_type_concept_id integer NOT NULL,
    operator_concept_id integer,
    value_as_number numeric,
    value_as_concept_id integer,
    unit_concept_id integer,
    range_low numeric,
    range_high numeric,
    provider_id integer,
    visit_occurrence_id integer,
    visit_detail_id integer,
    measurement_source_value character varying(50),
    measurement_source_concept_id integer,
    unit_source_value character varying(50),
    value_source_value character varying(50)
);


ALTER TABLE "OMOP_cdm_eunomia".measurement OWNER TO juanma;

--
-- TOC entry 225 (class 1259 OID 3185550)
-- Name: metadata; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".metadata (
    metadata_concept_id integer NOT NULL,
    metadata_type_concept_id integer NOT NULL,
    name character varying(250) NOT NULL,
    value_as_string text,
    value_as_concept_id integer,
    metadata_date date,
    metadata_datetime timestamp without time zone
);


ALTER TABLE "OMOP_cdm_eunomia".metadata OWNER TO juanma;

--
-- TOC entry 226 (class 1259 OID 3185556)
-- Name: note; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".note (
    note_id integer NOT NULL,
    person_id integer NOT NULL,
    note_date date NOT NULL,
    note_datetime timestamp without time zone,
    note_type_concept_id integer NOT NULL,
    note_class_concept_id integer NOT NULL,
    note_title character varying(250),
    note_text text,
    encoding_concept_id integer NOT NULL,
    language_concept_id integer NOT NULL,
    provider_id integer,
    visit_occurrence_id integer,
    visit_detail_id integer,
    note_source_value character varying(50)
);


ALTER TABLE "OMOP_cdm_eunomia".note OWNER TO juanma;

--
-- TOC entry 227 (class 1259 OID 3185562)
-- Name: note_nlp; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".note_nlp (
    note_nlp_id integer NOT NULL,
    note_id integer NOT NULL,
    section_concept_id integer,
    snippet character varying(250),
    "offset" character varying(250),
    lexical_variant character varying(250) NOT NULL,
    note_nlp_concept_id integer,
    note_nlp_source_concept_id integer,
    nlp_system character varying(250),
    nlp_date date NOT NULL,
    nlp_datetime timestamp without time zone,
    term_exists character varying(1),
    term_temporal character varying(50),
    term_modifiers character varying(2000)
);


ALTER TABLE "OMOP_cdm_eunomia".note_nlp OWNER TO juanma;

--
-- TOC entry 228 (class 1259 OID 3185568)
-- Name: observation; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".observation (
    observation_id integer NOT NULL,
    person_id integer NOT NULL,
    observation_concept_id integer NOT NULL,
    observation_date date NOT NULL,
    observation_datetime timestamp without time zone,
    observation_type_concept_id integer NOT NULL,
    value_as_number numeric,
    value_as_string character varying(60),
    value_as_concept_id integer,
    qualifier_concept_id integer,
    unit_concept_id integer,
    provider_id integer,
    visit_occurrence_id integer,
    visit_detail_id integer,
    observation_source_value character varying(50),
    observation_source_concept_id integer,
    unit_source_value character varying(50),
    qualifier_source_value character varying(50)
);


ALTER TABLE "OMOP_cdm_eunomia".observation OWNER TO juanma;

--
-- TOC entry 229 (class 1259 OID 3185574)
-- Name: observation_period; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".observation_period (
    observation_period_id integer NOT NULL,
    person_id integer NOT NULL,
    observation_period_start_date date NOT NULL,
    observation_period_end_date date NOT NULL,
    period_type_concept_id integer NOT NULL
);


ALTER TABLE "OMOP_cdm_eunomia".observation_period OWNER TO juanma;

--
-- TOC entry 230 (class 1259 OID 3185577)
-- Name: payer_plan_period; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".payer_plan_period (
    payer_plan_period_id integer NOT NULL,
    person_id integer NOT NULL,
    payer_plan_period_start_date date NOT NULL,
    payer_plan_period_end_date date NOT NULL,
    payer_concept_id integer,
    payer_source_value character varying(50),
    payer_source_concept_id integer,
    plan_concept_id integer,
    plan_source_value character varying(50),
    plan_source_concept_id integer,
    sponsor_concept_id integer,
    sponsor_source_value character varying(50),
    sponsor_source_concept_id integer,
    family_source_value character varying(50),
    stop_reason_concept_id integer,
    stop_reason_source_value character varying(50),
    stop_reason_source_concept_id integer
);


ALTER TABLE "OMOP_cdm_eunomia".payer_plan_period OWNER TO juanma;

--
-- TOC entry 231 (class 1259 OID 3185580)
-- Name: person; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".person (
    person_id integer NOT NULL,
    gender_concept_id integer NOT NULL,
    year_of_birth integer NOT NULL,
    month_of_birth integer,
    day_of_birth integer,
    birth_datetime timestamp without time zone,
    race_concept_id integer NOT NULL,
    ethnicity_concept_id integer NOT NULL,
    location_id integer,
    provider_id integer,
    care_site_id integer,
    person_source_value character varying(50),
    gender_source_value character varying(50),
    gender_source_concept_id integer,
    race_source_value character varying(50),
    race_source_concept_id integer,
    ethnicity_source_value character varying(50),
    ethnicity_source_concept_id integer
);


ALTER TABLE "OMOP_cdm_eunomia".person OWNER TO juanma;

--
-- TOC entry 232 (class 1259 OID 3185583)
-- Name: procedure_occurrence; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".procedure_occurrence (
    procedure_occurrence_id integer NOT NULL,
    person_id integer NOT NULL,
    procedure_concept_id integer NOT NULL,
    procedure_date date NOT NULL,
    procedure_datetime timestamp without time zone,
    procedure_type_concept_id integer NOT NULL,
    modifier_concept_id integer,
    quantity integer,
    provider_id integer,
    visit_occurrence_id integer,
    visit_detail_id integer,
    procedure_source_value character varying(50),
    procedure_source_concept_id integer,
    modifier_source_value character varying(50)
);


ALTER TABLE "OMOP_cdm_eunomia".procedure_occurrence OWNER TO juanma;

--
-- TOC entry 233 (class 1259 OID 3185586)
-- Name: provider; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".provider (
    provider_id integer NOT NULL,
    provider_name character varying(255),
    npi character varying(20),
    dea character varying(20),
    specialty_concept_id integer,
    care_site_id integer,
    year_of_birth integer,
    gender_concept_id integer,
    provider_source_value character varying(50),
    specialty_source_value character varying(50),
    specialty_source_concept_id integer,
    gender_source_value character varying(50),
    gender_source_concept_id integer
);


ALTER TABLE "OMOP_cdm_eunomia".provider OWNER TO juanma;

--
-- TOC entry 234 (class 1259 OID 3185589)
-- Name: relationship; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".relationship (
    relationship_id character varying(20) NOT NULL,
    relationship_name character varying(255) NOT NULL,
    is_hierarchical character varying(1) NOT NULL,
    defines_ancestry character varying(1) NOT NULL,
    reverse_relationship_id character varying(20) NOT NULL,
    relationship_concept_id integer NOT NULL
);


ALTER TABLE "OMOP_cdm_eunomia".relationship OWNER TO juanma;

--
-- TOC entry 235 (class 1259 OID 3185592)
-- Name: source_to_concept_map; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".source_to_concept_map (
    source_code character varying(50) NOT NULL,
    source_concept_id integer NOT NULL,
    source_vocabulary_id character varying(20) NOT NULL,
    source_code_description character varying(255),
    target_concept_id integer NOT NULL,
    target_vocabulary_id character varying(20) NOT NULL,
    valid_start_date date NOT NULL,
    valid_end_date date NOT NULL,
    invalid_reason character varying(1)
);


ALTER TABLE "OMOP_cdm_eunomia".source_to_concept_map OWNER TO juanma;

--
-- TOC entry 236 (class 1259 OID 3185595)
-- Name: specimen; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".specimen (
    specimen_id integer NOT NULL,
    person_id integer NOT NULL,
    specimen_concept_id integer NOT NULL,
    specimen_type_concept_id integer NOT NULL,
    specimen_date date NOT NULL,
    specimen_datetime timestamp without time zone,
    quantity numeric,
    unit_concept_id integer,
    anatomic_site_concept_id integer,
    disease_status_concept_id integer,
    specimen_source_id character varying(50),
    specimen_source_value character varying(50),
    unit_source_value character varying(50),
    anatomic_site_source_value character varying(50),
    disease_status_source_value character varying(50)
);


ALTER TABLE "OMOP_cdm_eunomia".specimen OWNER TO juanma;

--
-- TOC entry 237 (class 1259 OID 3185601)
-- Name: visit_detail; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".visit_detail (
    visit_detail_id integer NOT NULL,
    person_id integer NOT NULL,
    visit_detail_concept_id integer NOT NULL,
    visit_detail_start_date date NOT NULL,
    visit_detail_start_datetime timestamp without time zone,
    visit_detail_end_date date NOT NULL,
    visit_detail_end_datetime timestamp without time zone,
    visit_detail_type_concept_id integer NOT NULL,
    provider_id integer,
    care_site_id integer,
    admitting_source_concept_id integer,
    discharge_to_concept_id integer,
    preceding_visit_detail_id integer,
    visit_detail_source_value character varying(50),
    visit_detail_source_concept_id integer,
    admitting_source_value character varying(50),
    discharge_to_source_value character varying(50),
    visit_detail_parent_id integer,
    visit_occurrence_id integer NOT NULL
);


ALTER TABLE "OMOP_cdm_eunomia".visit_detail OWNER TO juanma;

--
-- TOC entry 238 (class 1259 OID 3185604)
-- Name: visit_occurrence; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".visit_occurrence (
    visit_occurrence_id integer NOT NULL,
    person_id integer NOT NULL,
    visit_concept_id integer NOT NULL,
    visit_start_date date NOT NULL,
    visit_start_datetime timestamp without time zone,
    visit_end_date date NOT NULL,
    visit_end_datetime timestamp without time zone,
    visit_type_concept_id integer NOT NULL,
    provider_id integer,
    care_site_id integer,
    visit_source_value character varying(50),
    visit_source_concept_id integer,
    admitting_source_concept_id integer,
    admitting_source_value character varying(50),
    discharge_to_concept_id integer,
    discharge_to_source_value character varying(50),
    preceding_visit_occurrence_id integer
);


ALTER TABLE "OMOP_cdm_eunomia".visit_occurrence OWNER TO juanma;

--
-- TOC entry 239 (class 1259 OID 3185607)
-- Name: vocabulary; Type: TABLE; Schema: OMOP_cdm_eunomia; Owner: juanma
--

CREATE TABLE "OMOP_cdm_eunomia".vocabulary (
    vocabulary_id character varying(20) NOT NULL,
    vocabulary_name character varying(255) NOT NULL,
    vocabulary_reference character varying(255) NOT NULL,
    vocabulary_version character varying(255),
    vocabulary_concept_id integer NOT NULL
);


ALTER TABLE "OMOP_cdm_eunomia".vocabulary OWNER TO juanma;

--
-- TOC entry 3879 (class 0 OID 3185448)
-- Dependencies: 201
-- Data for Name: attribute_definition; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".attribute_definition (attribute_definition_id, attribute_name, attribute_description, attribute_type_concept_id, attribute_syntax) FROM stdin;
\.


--
-- TOC entry 3880 (class 0 OID 3185454)
-- Dependencies: 202
-- Data for Name: care_site; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".care_site (care_site_id, care_site_name, place_of_service_concept_id, location_id, care_site_source_value, place_of_service_source_value) FROM stdin;
\.


--
-- TOC entry 3881 (class 0 OID 3185457)
-- Dependencies: 203
-- Data for Name: cdm_source; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".cdm_source (cdm_source_name, cdm_source_abbreviation, cdm_holder, source_description, source_documentation_reference, cdm_etl_reference, source_release_date, cdm_release_date, cdm_version, vocabulary_version) FROM stdin;
Synthea synthetic health database	Synthea	OHDSI Community	SyntheaTM is a Synthetic Patient Population Simulator. The goal is to output synthetic, realistic (but not real), patient data and associated health records in a variety of formats.	https://synthetichealth.github.io/synthea/	https://github.com/OHDSI/ETL-Synthea	2019-05-25	2019-05-25	v5.3.1	v5.0 18-JAN-19
\.


--
-- TOC entry 3882 (class 0 OID 3185463)
-- Dependencies: 204
-- Data for Name: cohort; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".cohort (cohort_definition_id, subject_id, cohort_start_date, cohort_end_date) FROM stdin;
\.


--
-- TOC entry 3883 (class 0 OID 3185466)
-- Dependencies: 205
-- Data for Name: cohort_attribute; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".cohort_attribute (cohort_definition_id, subject_id, cohort_start_date, cohort_end_date, attribute_definition_id, value_as_number, value_as_concept_id) FROM stdin;
\.


--
-- TOC entry 3884 (class 0 OID 3185472)
-- Dependencies: 206
-- Data for Name: cohort_definition; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".cohort_definition (cohort_definition_id, cohort_definition_name, cohort_definition_description, definition_type_concept_id, cohort_definition_syntax, subject_concept_id, cohort_initiation_date) FROM stdin;
\.


--
-- TOC entry 3885 (class 0 OID 3185478)
-- Dependencies: 207
-- Data for Name: concept; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".concept (concept_id, concept_name, domain_id, vocabulary_id, concept_class_id, standard_concept, concept_code, valid_start_date, valid_end_date, invalid_reason) FROM stdin;
35208414	Gastrointestinal hemorrhage, unspecified	Condition	ICD10CM	4-char billing code		K92.2	2007-01-01	2099-12-31	
1118088	celecoxib 200 MG Oral Capsule [Celebrex]	Drug	RxNorm	Branded Drug	S	213469	1970-01-01	2099-12-31	
40213201	pneumococcal polysaccharide vaccine, 23 valent	Drug	CVX	CVX	S	33	2008-12-01	2099-12-31	
1557272	Alendronate	Drug	RxNorm	Ingredient	S	46041	1970-01-01	2099-12-31	
4336464	Coronary artery bypass graft	Procedure	SNOMED	Procedure	S	232717009	1970-01-01	2099-12-31	
4295880	Intramuscular injection	Procedure	SNOMED	Procedure	S	76601001	1970-01-01	2099-12-31	
3020630	Protein serum/plasma	Measurement	LOINC	Lab Test	S	2885-2	1970-01-01	2099-12-31	
19129655	Ampicillin 100 MG/ML Injectable Solution	Drug	RxNorm	Clinical Drug	S	789980	2008-03-30	2099-12-31	
44923712	celecoxib 200 MG Oral Capsule [Celebrex]	Drug	NDC	11-digit NDC		00025152531	2000-01-01	2099-12-31	
1569708	Other diseases of digestive system	Condition	ICD10CM	3-char nonbill code		K92	2012-01-01	2099-12-31	
40213216	rotavirus, live, monovalent vaccine	Drug	CVX	CVX	S	119	2008-12-01	2099-12-31	
708298	Midazolam	Drug	RxNorm	Ingredient	S	6960	1970-01-01	2099-12-31	
4301346	Surgical manipulation of shoulder joint	Procedure	SNOMED	Procedure	S	387685009	1970-01-01	2099-12-31	
4246502	Neonatal screening	Procedure	SNOMED	Procedure	S	60151004	1970-01-01	2099-12-31	
3020655	Honey bee IgE Ab [Units/volume] in Serum	Measurement	LOINC	Lab Test	S	6844-5	1970-01-01	2099-12-31	
4116491	Escherichia coli urinary tract infection	Condition	SNOMED	Clinical Finding	S	301011002	1970-01-01	2099-12-31	
45011828	Diclofenac Sodium 75 MG Delayed Release Oral Tablet	Drug	NDC	11-digit NDC		00781178901	2000-01-01	2099-12-31	
40162359	Diclofenac Sodium 75 MG Delayed Release Oral Tablet	Drug	RxNorm	Clinical Drug	S	855926	2009-08-02	2099-12-31	
40213227	tetanus and diphtheria toxoids, adsorbed, preservative free, for adult use	Drug	CVX	CVX	S	113	2008-12-01	2099-12-31	
701322	Memantine	Drug	RxNorm	Ingredient	S	6719	1970-01-01	2099-12-31	
3002385	Erythrocyte distribution width [Ratio]	Measurement	LOINC	Lab Test	S	30385-9	1970-01-01	2099-12-31	
4199276	Removal of subcutaneous contraceptive	Procedure	SNOMED	Procedure	S	301807007	1970-01-01	2099-12-31	
3005136	Cladosporium herbarum IgE Ab [Units/volume] in Serum	Measurement	LOINC	Lab Test	S	6075-6	1970-01-01	2099-12-31	
4113008	Laceration of hand	Condition	SNOMED	Clinical Finding	S	284549007	1970-01-01	2099-12-31	
40213230	tetanus toxoid, reduced diphtheria toxoid, and acellular pertussis vaccine, adsorbed	Drug	CVX	CVX	S	115	2008-12-01	2099-12-31	
723013	Diazepam	Drug	RxNorm	Ingredient	S	3322	1970-01-01	2099-12-31	
3001247	Common Ragweed IgE Ab [Units/volume] in Serum	Measurement	LOINC	Lab Test	S	6085-5	1970-01-01	2099-12-31	
4234705	Evaluation of psychiatric state of patient	Procedure	SNOMED	Procedure	S	90407005	1970-01-01	2099-12-31	
3004501	Glucose lab	Measurement	LOINC	Lab Test	S	2345-7	1970-01-01	2099-12-31	
4156265	Facial laceration	Condition	SNOMED	Clinical Finding	S	370247008	1970-01-01	2099-12-31	
40213160	poliovirus vaccine, inactivated	Drug	CVX	CVX	S	10	2008-12-01	2099-12-31	
1129625	Diphenhydramine	Drug	RxNorm	Ingredient	S	3498	1970-01-01	2099-12-31	
3036780	American house dust mite IgE Ab [Units/volume] in Serum	Measurement	LOINC	Lab Test	S	6095-4	1970-01-01	2099-12-31	
4238715	Removal of intrauterine device	Procedure	SNOMED	Procedure	S	68254000	1970-01-01	2099-12-31	
3006734	White Oak IgE Ab [Units/volume] in Serum	Measurement	LOINC	Lab Test	S	6189-5	1970-01-01	2099-12-31	
4155034	Laceration of forearm	Condition	SNOMED	Clinical Finding	S	283371005	1970-01-01	2099-12-31	
40213180	meningococcal polysaccharide (groups A, C, Y and W-135) diphtheria toxoid conjugate vaccine (MCV4P)	Drug	CVX	CVX	S	114	2008-12-01	2099-12-31	
1149196	Cetirizine	Drug	RxNorm	Ingredient	S	20610	1970-01-01	2099-12-31	
3006451	Walnut IgE Ab [Units/volume] in Serum	Measurement	LOINC	Lab Test	S	6273-7	1970-01-01	2099-12-31	
4198190	Appendectomy	Procedure	SNOMED	Procedure	S	80146002	1970-01-01	2099-12-31	
3027970	Globulin [Mass/volume] in Serum by calculation	Measurement	LOINC	Lab Test	S	10834-0	1970-01-01	2099-12-31	
4109685	Laceration of foot	Condition	SNOMED	Clinical Finding	S	284551006	1970-01-01	2099-12-31	
40213251	varicella virus vaccine	Drug	CVX	CVX	S	21	2008-12-01	2099-12-31	
1149380	fluticasone	Drug	RxNorm	Ingredient	S	41126	1970-01-01	2099-12-31	
3006923	Alanine aminotransferase serum/plasma	Measurement	LOINC	Lab Test	S	1742-6	1970-01-01	2099-12-31	
4202832	Intubation	Procedure	SNOMED	Procedure	S	52765003	1970-01-01	2099-12-31	
3023103	Potassium serum/plasma	Measurement	LOINC	Lab Test	S	2823-3	1970-01-01	2099-12-31	
4048169	Allergy to house dust mite	Observation	SNOMED	Clinical Finding	S	232350006	1970-01-01	2099-12-31	
40213260	zoster vaccine, live	Drug	CVX	CVX	S	121	2008-12-01	2099-12-31	
1150770	Astemizole	Drug	RxNorm	Ingredient	S	42328	1970-01-01	2099-12-31	
3007461	Platelet count	Measurement	LOINC	Lab Test	S	26515-7	1970-01-01	2099-12-31	
4151422	Sputum examination	Procedure	SNOMED	Procedure	S	269911007	1970-01-01	2099-12-31	
3023430	Cat dander IgE Ab [Units/volume] in Serum	Measurement	LOINC	Lab Test	S	6833-8	1970-01-01	2099-12-31	
4240902	Allergy to peanuts	Observation	SNOMED	Clinical Finding	S	91935009	1970-01-01	2099-12-31	
40213281	diphtheria, tetanus toxoids and acellular pertussis vaccine	Drug	CVX	CVX	S	20	2008-12-01	2099-12-31	
1150836	Terfenadine	Drug	RxNorm	Ingredient	S	42330	1970-01-01	2099-12-31	
3008598	Thyroxine (T4) free [Mass/volume] in Serum or Plasma	Measurement	LOINC	Lab Test	S	3024-7	1970-01-01	2099-12-31	
4163872	Plain chest X-ray	Procedure	SNOMED	Procedure	S	399208008	1970-01-01	2099-12-31	
3027231	Wheat IgE Ab [Units/volume] in Serum	Measurement	LOINC	Lab Test	S	6276-0	1970-01-01	2099-12-31	
4052083	Measurement of respiratory function	Measurement	SNOMED	Procedure	S	23426006	1970-01-01	2099-12-31	
40213296	hepatitis A vaccine, adult dosage	Drug	CVX	CVX	S	52	2008-12-01	2099-12-31	
1124300	Diclofenac	Drug	RxNorm	Ingredient	S	3355	1970-01-01	2099-12-31	
3009201	Thyrotropin [Units/volume] in Serum or Plasma	Measurement	LOINC	Lab Test	S	3016-3	1970-01-01	2099-12-31	
4163951	Electrocardiographic procedure	Procedure	SNOMED	Procedure	S	29303009	1970-01-01	2099-12-31	
3026361	Red blood cell (RBC) count	Measurement	LOINC	Lab Test	S	26453-1	1970-01-01	2099-12-31	
4012477	Glucose tolerance test	Measurement	SNOMED	Procedure	S	113076002	1970-01-01	2099-12-31	
40213299	hepatitis A vaccine, pediatric/adolescent dosage, 2 dose schedule	Drug	CVX	CVX	S	83	2008-12-01	2099-12-31	
1153428	fexofenadine	Drug	RxNorm	Ingredient	S	87636	1970-01-01	2099-12-31	
3009542	Hematocrit	Measurement	LOINC	Lab Test	S	20570-8	1970-01-01	2099-12-31	
4163971	Laparoscopic cholecystectomy	Procedure	SNOMED	Procedure	S	45595009	1970-01-01	2099-12-31	
3024731	MCV	Measurement	LOINC	Lab Test	S	30428-7	1970-01-01	2099-12-31	
4047491	Radiography of humerus	Procedure	SNOMED	Procedure	S	1225002	1970-01-01	2099-12-31	
40213306	hepatitis B vaccine, adult dosage	Drug	CVX	CVX	S	43	2008-12-01	2099-12-31	
1107830	Loratadine	Drug	RxNorm	Ingredient	S	28889	1970-01-01	2099-12-31	
3010813	White Blood cell (WBC) count (leukocyte)	Measurement	LOINC	Lab Test	S	26464-8	1970-01-01	2099-12-31	
4094814	Bullet wound	Condition	SNOMED	Clinical Finding	S	262574004	1970-01-01	2099-12-31	
3024561	Albumin serum/plasma	Measurement	LOINC	Lab Test	S	1751-7	1970-01-01	2099-12-31	
4078793	Direct current cardioversion	Procedure	SNOMED	Procedure	S	180325003	1970-01-01	2099-12-31	
40213314	Haemophilus influenzae type b vaccine, PRP-OMP conjugate	Drug	CVX	CVX	S	49	2008-12-01	2099-12-31	
1110410	Morphine	Drug	RxNorm	Ingredient	S	7052	1970-01-01	2099-12-31	
3012494	Peanut IgE Ab [Units/volume] in Serum	Measurement	LOINC	Lab Test	S	6206-7	1970-01-01	2099-12-31	
4048695	Fracture of vertebral column without spinal cord injury	Condition	SNOMED	Clinical Finding	S	15724005	1970-01-01	2099-12-31	
40486433	Perennial allergic rhinitis	Condition	SNOMED	Clinical Finding	S	446096008	2011-01-31	2099-12-31	
4043071	Cognitive and behavioral therapy	Procedure	SNOMED	Procedure	S	228557008	1970-01-01	2099-12-31	
40213320	human papilloma virus vaccine, quadrivalent	Drug	CVX	CVX	S	62	2008-12-01	2099-12-31	
1115008	Naproxen	Drug	RxNorm	Ingredient	S	7258	1970-01-01	2099-12-31	
3013682	Urea nitrogen serum/plasma	Measurement	LOINC	Lab Test	S	3094-0	1970-01-01	2099-12-31	
4051466	Childhood asthma	Condition	SNOMED	Clinical Finding	S	233678006	1970-01-01	2099-12-31	
40769179	Percentage area affected by eczema Head and Neck [PhenX]	Measurement	LOINC	Clinical Observation	S	66519-0	2011-06-17	2099-12-31	
4037675	Brief general examination	Procedure	SNOMED	Procedure	S	162676008	1970-01-01	2099-12-31	
40213198	pneumococcal conjugate vaccine, 13 valent	Drug	CVX	CVX	S	133	2009-10-15	2099-12-31	
753626	Propofol	Drug	RxNorm	Ingredient	S	8782	1970-01-01	2099-12-31	
3011505	FEV1/FVC	Measurement	LOINC	Clinical Observation	S	19926-5	1970-01-01	2099-12-31	
4142905	Fracture of rib	Condition	SNOMED	Clinical Finding	S	33737001	1970-01-01	2099-12-31	
40769184	Percentage area affected by eczema Upper extremity - bilateral [PhenX]	Measurement	LOINC	Clinical Observation	S	66524-0	2011-06-17	2099-12-31	
4275113	Insertion of intrauterine contraceptive device	Procedure	SNOMED	Procedure	S	65200003	1970-01-01	2099-12-31	
40213154	Influenza, seasonal, injectable, preservative free	Drug	CVX	CVX	S	140	2011-11-04	2099-12-31	
1728416	Penicillin G	Drug	RxNorm	Ingredient	S	7980	1970-01-01	2099-12-31	
933724	Phenazopyridine	Drug	RxNorm	Ingredient	S	8120	1970-01-01	2099-12-31	
4144583	Diabetes mellitus due to cystic fibrosis	Condition	SNOMED	Clinical Finding	S	427089005	1970-01-01	2099-12-31	
40769189	Percentage area affected by eczema Trunk [PhenX]	Measurement	LOINC	Clinical Observation	S	66529-9	2011-06-17	2099-12-31	
4108705	Intravenous blood transfusion of packed cells	Procedure	SNOMED	Procedure	S	180207008	1970-01-01	2099-12-31	
42902245	{5 (Ethinyl Estradiol 0.02 MG / norethindrone acetate 1 MG Oral Tablet) / 7 (Ethinyl Estradiol 0.03 MG / norethindrone acetate 1 MG Oral Tablet) / 9 (Ethinyl Estradiol 0.035 MG / norethindrone acetate 1 MG Oral Tablet) / 7 (Ferrous fumarate 75 MG Oral Tab	Drug	RxNorm	Branded Pack	S	1359133	2012-12-03	2099-12-31	
738818	Doxylamine	Drug	RxNorm	Ingredient	S	3642	1970-01-01	2099-12-31	
926487	Pancreatin	Drug	RxNorm	Ingredient	S	7880	1970-01-01	2099-12-31	
4296204	First degree burn	Condition	SNOMED	Clinical Finding	S	403190006	1970-01-01	2099-12-31	
40769194	Percentage area affected by eczema Lower extremity - bilateral [PhenX]	Measurement	LOINC	Clinical Observation	S	66534-9	2011-06-17	2099-12-31	
4242997	Cholecystectomy	Procedure	SNOMED	Procedure	S	38102005	1970-01-01	2099-12-31	
40221415	{5 (dienogest 2 MG / estradiol valerate 2 MG Oral Tablet) / 17 (dienogest 3 MG / estradiol valerate 2 MG Oral Tablet) / 2 (estradiol valerate 1 MG Oral Tablet) / 2 (estradiol valerate 3 MG Oral Tablet) / 2 (Inert Ingredients 1 MG Oral Tablet) } Pack [Nata	Drug	RxNorm	Branded Pack	S	978950	2010-06-06	2099-12-31	
1124957	Oxycodone	Drug	RxNorm	Ingredient	S	7804	1970-01-01	2099-12-31	
1102527	Meperidine	Drug	RxNorm	Ingredient	S	6754	1970-01-01	2099-12-31	
4296205	Second degree burn	Condition	SNOMED	Clinical Finding	S	403191005	1970-01-01	2099-12-31	
3035995	Alkaline phosphatase serum/plasma	Measurement	LOINC	Lab Test	S	6768-6	1996-08-15	2099-12-31	
4293740	Injection of tetanus antitoxin	Procedure	SNOMED	Procedure	S	384700001	1970-01-01	2099-12-31	
43012433	21 DAY Ethinyl Estradiol 0.000625 MG/HR / Etonogestrel 0.005 MG/HR Vaginal Ring [NuvaRing]	Drug	RxNorm	Quant Branded Drug	S	1367439	2013-02-04	2099-12-31	
1125315	Acetaminophen	Drug	RxNorm	Ingredient	S	161	1970-01-01	2099-12-31	
782043	Isoflurane	Drug	RxNorm	Ingredient	S	6026	1970-01-01	2099-12-31	
4294548	Acute bacterial sinusitis	Condition	SNOMED	Clinical Finding	S	75498004	1970-01-01	2099-12-31	
1310034	3 ML Amiodarone hydrochloride 50 MG/ML Prefilled Syringe	Drug	RxNorm	Quant Clinical Drug	S	834357	2009-03-01	2099-12-31	
4243062	Radiography of wrist	Procedure	SNOMED	Procedure	S	60027007	1970-01-01	2099-12-31	
40169216	120 ACTUAT Fluticasone propionate 0.044 MG/ACTUAT Metered Dose Inhaler	Drug	RxNorm	Quant Clinical Drug	S	895994	2010-01-31	2099-12-31	
1125443	Dornase Alfa	Drug	RxNorm	Ingredient	S	337623	1970-01-01	2099-12-31	
791967	Lorazepam	Drug	RxNorm	Ingredient	S	6470	1970-01-01	2099-12-31	
4278672	Fracture of forearm	Condition	SNOMED	Clinical Finding	S	65966004	1970-01-01	2099-12-31	
40173590	Alendronic acid 10 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	904419	2010-04-04	2099-12-31	
4117038	Bilateral tubal ligation	Procedure	SNOMED	Procedure	S	287664005	1970-01-01	2099-12-31	
40243436	1 ML Atropine Sulfate 1 MG/ML Injection	Drug	RxNorm	Quant Clinical Drug	S	1190795	2011-11-06	2099-12-31	
1118084	celecoxib	Drug	RxNorm	Ingredient	S	140587	1970-01-01	2099-12-31	
920293	Nitrofurantoin	Drug	RxNorm	Ingredient	S	7454	1970-01-01	2099-12-31	
4237458	Fracture of clavicle	Condition	SNOMED	Clinical Finding	S	58150001	1970-01-01	2099-12-31	
42707627	rocuronium bromide 10 MG/ML Injectable Solution	Drug	RxNorm	Clinical Drug	S	1234995	2012-05-07	2099-12-31	
4107731	Subcutaneous immunotherapy	Procedure	SNOMED	Procedure	S	180256009	1970-01-01	2099-12-31	
40224132	0.65 ML medroxyprogesterone acetate 160 MG/ML Prefilled Syringe	Drug	RxNorm	Quant Clinical Drug	S	1000156	2010-09-05	2099-12-31	
1119510	Dextromethorphan	Drug	RxNorm	Ingredient	S	3289	1970-01-01	2099-12-31	
19010482	Cyclosporine	Drug	RxNorm	Ingredient	S	3008	1970-01-01	2099-12-31	
4283893	Sinusitis	Condition	SNOMED	Clinical Finding	S	36971009	1970-01-01	2099-12-31	
4216130	Percutaneous coronary intervention	Procedure	SNOMED	Procedure	S	415070008	1970-01-01	2099-12-31	
4218389	Whiplash injury to neck	Condition	SNOMED	Clinical Finding	S	39848009	1970-01-01	2099-12-31	
40224805	1 ML medroxyprogesterone acetate 150 MG/ML Injection	Drug	RxNorm	Quant Clinical Drug	S	1000126	2010-09-05	2099-12-31	
1137529	salmeterol	Drug	RxNorm	Ingredient	S	36117	1970-01-01	2099-12-31	
19078219	Sufentanil	Drug	RxNorm	Ingredient	S	56795	1970-01-01	2099-12-31	
4280726	Seasonal allergic rhinitis	Condition	SNOMED	Clinical Finding	S	367498001	1970-01-01	2099-12-31	
4306014	Allergy to tree pollen	Observation	SNOMED	Clinical Finding	S	419263009	1970-01-01	2099-12-31	
4310024	Angiodysplasia of stomach	Condition	SNOMED	Clinical Finding	S	424802006	1970-01-01	2099-12-31	
1154615	200 ACTUAT Albuterol 0.09 MG/ACTUAT Metered Dose Inhaler	Drug	RxNorm	Quant Clinical Drug	S	745679	2007-12-30	2099-12-31	
757627	Galantamine	Drug	RxNorm	Ingredient	S	4637	1970-01-01	2099-12-31	
19054876	dienogest	Drug	RxNorm	Ingredient	S	22968	1970-01-01	2099-12-31	
4285898	Polyp of colon	Condition	SNOMED	Clinical Finding	S	68496003	1970-01-01	2099-12-31	
19133679	{28 (Norethindrone 0.35 MG Oral Tablet) } Pack [Errin 28 Day]	Drug	RxNorm	Branded Pack	S	831533	2009-03-01	2099-12-31	
4146173	Injury of tendon of the rotator cuff of shoulder	Condition	SNOMED	Clinical Finding	S	307731004	1970-01-01	2099-12-31	
40220386	100 ML Propofol 10 MG/ML Injection	Drug	RxNorm	Quant Clinical Drug	S	1808217	2016-10-03	2099-12-31	
740275	Carbamazepine	Drug	RxNorm	Ingredient	S	2002	1970-01-01	2099-12-31	
19074841	12 HR Cefaclor 500 MG Extended Release Oral Tablet	Drug	RxNorm	Quant Clinical Drug	S	309043	1970-01-01	2099-12-31	
4149245	Rupture of patellar tendon	Condition	SNOMED	Clinical Finding	S	30832001	1970-01-01	2099-12-31	
44805732	Reinsertion of subcutaneous contraceptive	Procedure	SNOMED	Procedure	S	755621000000101	2014-04-01	2099-12-31	
4266809	Diverticular disease	Condition	SNOMED	Clinical Finding	S	397881000	1970-01-01	2099-12-31	
40223774	Donepezil hydrochloride 23 MG [Aricept]	Drug	RxNorm	Branded Drug Comp	S	998582	2010-08-01	2099-12-31	
1154029	Fentanyl	Drug	RxNorm	Ingredient	S	4337	1970-01-01	2099-12-31	
1127078	Acetaminophen 160 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	282464	1970-01-01	2099-12-31	
4152936	Laceration of thigh	Condition	SNOMED	Clinical Finding	S	283385000	1970-01-01	2099-12-31	
42535580	Ultrasonography of abdomen, right upper quadrant and epigastrium	Procedure	SNOMED	Procedure	S	426701000119108	2018-01-31	2099-12-31	
4230399	Closed fracture of hip	Condition	SNOMED	Clinical Finding	S	359817006	1970-01-01	2099-12-31	
40171902	Verapamil hydrochloride 40 MG	Drug	RxNorm	Clinical Drug Comp	S	897718	2010-02-28	2099-12-31	
1154343	Albuterol	Drug	RxNorm	Ingredient	S	435	1970-01-01	2099-12-31	
1127433	Acetaminophen 325 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	313782	1970-01-01	2099-12-31	
4166224	Rupture of appendix	Condition	SNOMED	Clinical Finding	S	47693006	1970-01-01	2099-12-31	
21494966	Physical findings of Abdomen by Palpation	Measurement	LOINC	Clinical Observation	S	80271-0	2016-06-24	2099-12-31	
4304110	Allergy to mold	Observation	SNOMED	Clinical Finding	S	419474003	1970-01-01	2099-12-31	
1718412	Levonorgestrel 0.000729 MG/HR Intrauterine System [Kyleena]	Drug	RxNorm	Branded Drug	S	1856546	2017-01-03	2099-12-31	
9201	Inpatient Visit	Visit	Visit	Visit	S	IP	1970-01-01	2099-12-31	
920300	Nitrofurantoin 5 MG/ML Oral Suspension	Drug	RxNorm	Clinical Drug	S	311989	1970-01-01	2099-12-31	
3014599	Egg white IgE Ab [Units/volume] in Serum	Measurement	LOINC	Lab Test	S	6106-9	1970-01-01	2099-12-31	
45769019	Female infertility due to cystic fibrosis	Condition	SNOMED	Clinical Finding	S	707577004	2015-01-31	2099-12-31	
4169137	Allergy to wheat	Observation	SNOMED	Clinical Finding	S	420174000	1970-01-01	2099-12-31	
40174880	Levothyroxine Sodium 0.075 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	966222	2010-04-04	2099-12-31	
9202	Outpatient Visit	Visit	Visit	Visit	S	OP	1970-01-01	2099-12-31	
920334	NITROFURANTOIN, MACROCRYSTALS 50 MG Oral Capsule	Drug	RxNorm	Clinical Drug	S	311995	1970-01-01	2099-12-31	
1332419	Amlodipine 5 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	197361	1970-01-01	2099-12-31	
45766064	History of single seizure	Observation	SNOMED	Context-dependent	S	703151001	2015-01-31	2099-12-31	
4219399	Allergy to fish	Observation	SNOMED	Clinical Finding	S	417532002	1970-01-01	2099-12-31	
40222846	Memantine hydrochloride 2 MG/ML Oral Solution	Drug	RxNorm	Clinical Drug	S	996740	2010-07-04	2099-12-31	
9203	Emergency Room Visit	Visit	Visit	Visit	S	ER	1970-01-01	2099-12-31	
19019273	Naproxen 500 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	198014	1970-01-01	2099-12-31	
19057271	Lorazepam 2 MG/ML Injectable Solution	Drug	RxNorm	Clinical Drug	S	238100	1970-01-01	2099-12-31	
46221626	Levonorgestrel 0.000813 MG/HR Intrauterine System [Liletta]	Drug	RxNorm	Branded Drug	S	1605257	2015-05-04	2099-12-31	
4314290	Cystic fibrosis sweat test	Measurement	SNOMED	Procedure	S	86964003	1970-01-01	2099-12-31	
40223768	Donepezil hydrochloride 10 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	997223	2010-08-01	2099-12-31	
0	No matching concept	Metadata	None	Undefined		No matching concept	1970-01-01	2099-12-31	
19007333	Methotrexate 10 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	105586	1970-01-01	2099-12-31	
1589505	Levonorgestrel	Drug	RxNorm	Ingredient	S	6373	1970-01-01	2099-12-31	
45892894	24 HR Donepezil hydrochloride 10 MG / Memantine hydrochloride 28 MG Extended Release Oral Capsule	Drug	RxNorm	Quant Clinical Drug	S	1599803	2015-03-02	2099-12-31	
4133840	Spirometry	Measurement	SNOMED	Procedure	S	127783003	1970-01-01	2099-12-31	
40223821	Fexofenadine hydrochloride 30 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	997488	2010-08-01	2099-12-31	
433644	Shellfish allergy	Observation	SNOMED	Clinical Finding	S	300913006	1970-01-01	2099-12-31	
19019979	Ibuprofen 100 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	198405	1970-01-01	2099-12-31	
705944	Methylphenidate	Drug	RxNorm	Ingredient	S	6901	1970-01-01	2099-12-31	
19112599	Chlorpheniramine Maleate 2 MG/ML Oral Solution	Drug	RxNorm	Clinical Drug	S	477045	1970-01-01	2099-12-31	
4252419	Radiologic examination of knee	Procedure	SNOMED	Procedure	S	74016001	1970-01-01	2099-12-31	
40223834	Fexofenadine hydrochloride 60 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	997501	2010-08-01	2099-12-31	
442116	Allergy to eggs	Observation	SNOMED	Clinical Finding	S	91930004	1970-01-01	2099-12-31	
19074843	Cefaclor 250 MG Oral Capsule	Drug	RxNorm	Clinical Drug	S	309045	1970-01-01	2099-12-31	
715997	donepezil	Drug	RxNorm	Ingredient	S	135447	1970-01-01	2099-12-31	
19077344	ferrous sulfate 325 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	310325	1970-01-01	2099-12-31	
4218408	Collection of blood specimen for laboratory	Procedure	SNOMED	Procedure	S	82078001	1970-01-01	2099-12-31	
40220960	alteplase 100 MG Injection	Drug	RxNorm	Clinical Drug	S	1804799	2016-10-03	2099-12-31	
438614	Allergy to nut	Observation	SNOMED	Clinical Finding	S	91934008	1970-01-01	2099-12-31	
19075001	Cefuroxime 250 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	309097	1970-01-01	2099-12-31	
1322184	clopidogrel	Drug	RxNorm	Ingredient	S	32968	1970-01-01	2099-12-31	
19078924	Midazolam 1 MG/ML Injectable Solution	Drug	RxNorm	Clinical Drug	S	311700	1970-01-01	2099-12-31	
4170947	Bone immobilization	Procedure	SNOMED	Procedure	S	274474001	1970-01-01	2099-12-31	
43012036	Chlorpheniramine Maleate 4 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	1363309	2013-01-07	2099-12-31	
198809	Acute cholecystitis	Condition	SNOMED	Clinical Finding	S	65275009	1970-01-01	2099-12-31	
19073183	Amoxicillin 250 MG Oral Capsule	Drug	RxNorm	Clinical Drug	S	308182	1970-01-01	2099-12-31	
1367571	heparin	Drug	RxNorm	Ingredient	S	5224	1970-01-01	2099-12-31	
19076374	Diazepam 5 MG/ML Injectable Solution	Drug	RxNorm	Clinical Drug	S	309845	1970-01-01	2099-12-31	
4230209	Psychiatric follow-up	Procedure	SNOMED	Procedure	S	88848003	1970-01-01	2099-12-31	
1594382	NDA020800 0.3 ML Epinephrine 1 MG/ML Auto-Injector	Drug	RxNorm	Clinical Drug	S	1870230	2017-08-07	2099-12-31	
195588	Cystitis	Condition	SNOMED	Clinical Finding	S	38822007	1970-01-01	2099-12-31	
19073188	Amoxicillin 500 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	308192	1970-01-01	2099-12-31	
1500211	Medroxyprogesterone	Drug	RxNorm	Ingredient	S	6691	1970-01-01	2099-12-31	
19079524	Sodium Chloride 9 MG/ML Injectable Solution	Drug	RxNorm	Clinical Drug	S	313002	1970-01-01	2099-12-31	
4337138	Transplant of lung	Procedure	SNOMED	Procedure	S	88039007	1970-01-01	2099-12-31	
43012754	Levonorgestrel 0.00354 MG/HR Drug Implant	Drug	RxNorm	Clinical Drug	S	1366343	2013-02-04	2099-12-31	
378001	Concussion with no loss of consciousness	Condition	SNOMED	Clinical Finding	S	62106007	1970-01-01	2099-12-31	
19075601	clopidogrel 75 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	309362	1970-01-01	2099-12-31	
1309944	Amiodarone	Drug	RxNorm	Ingredient	S	703	1970-01-01	2099-12-31	
19077572	Galantamine 4 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	310436	1970-01-01	2099-12-31	
4337611	Single lung transplant	Procedure	SNOMED	Procedure	S	232657004	1970-01-01	2099-12-31	
40229134	Acetaminophen 21.7 MG/ML / Dextromethorphan Hydrobromide 1 MG/ML / doxylamine succinate 0.417 MG/ML Oral Solution	Drug	RxNorm	Clinical Drug	S	1043400	2010-12-05	2099-12-31	
378419	Alzheimer's disease	Condition	SNOMED	Clinical Finding	S	26929004	1970-01-01	2099-12-31	
19059056	Aspirin 81 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	243670	1970-01-01	2099-12-31	
1305058	Methotrexate	Drug	RxNorm	Ingredient	S	6851	1970-01-01	2099-12-31	
19029476	Dornase Alfa 1 MG/ML Inhalant Solution [Pulmozyme]	Drug	RxNorm	Branded Drug	S	205532	1970-01-01	2099-12-31	
4168004	Burn injury	Observation	SNOMED	Morph Abnormality	S	48333001	1970-01-01	2099-12-31	
40236824	Phenazopyridine hydrochloride 100 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	1094107	2011-04-03	2099-12-31	
317009	Asthma	Condition	SNOMED	Clinical Finding	S	195967001	1970-01-01	2099-12-31	
19078461	Ibuprofen 200 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	310965	1970-01-01	2099-12-31	
1347450	alteplase	Drug	RxNorm	Ingredient	S	8410	1970-01-01	2099-12-31	
19045231	Pancreatin 600 MG Oral Tablet [Pancreatin 4X]	Drug	RxNorm	Branded Drug	S	210856	1970-01-01	2099-12-31	
19016749	remifentanil	Drug	RxNorm	Ingredient	S	73032	1970-01-01	2099-12-31	
40236446	Methylphenidate Hydrochloride 20 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	1091392	2011-03-06	2099-12-31	
317576	Coronary arteriosclerosis	Condition	SNOMED	Clinical Finding	S	53741008	1970-01-01	2099-12-31	
4323902	Lung volume reduction surgery	Procedure	SNOMED	Procedure	S	429609002	2008-01-31	2099-12-31	
1310149	Warfarin	Drug	RxNorm	Ingredient	S	11289	1970-01-01	2099-12-31	
19074679	Carbamazepine 20 MG/ML Oral Suspension [Tegretol]	Drug	RxNorm	Branded Drug	S	308971	1970-01-01	2099-12-31	
19003953	Rocuronium	Drug	RxNorm	Ingredient	S	68139	1970-01-01	2099-12-31	
1713671	Amoxicillin 250 MG / Clavulanate 125 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	562251	2005-09-11	2099-12-31	
258780	Emphysematous bronchitis	Condition	SNOMED	Clinical Finding	S	185086009	1970-01-01	2099-12-31	
4324181	History of cardiac arrest	Observation	SNOMED	Context-dependent	S	429007001	2008-01-31	2099-12-31	
1326303	Digoxin	Drug	RxNorm	Ingredient	S	3407	1970-01-01	2099-12-31	
1729720	Penicillin V	Drug	RxNorm	Ingredient	S	7984	1970-01-01	2099-12-31	
19006318	Penicillin G 375 MG/ML Injectable Solution	Drug	RxNorm	Clinical Drug	S	105078	1970-01-01	2099-12-31	
964261	Vitamin B 12 5 MG/ML Injectable Solution	Drug	RxNorm	Clinical Drug	S	2001499	2018-04-02	2099-12-31	
260139	Acute bronchitis	Condition	SNOMED	Clinical Finding	S	10509002	1970-01-01	2099-12-31	
40481087	Viral sinusitis	Condition	SNOMED	Clinical Finding	S	444814009	2010-07-31	2099-12-31	
1332418	Amlodipine	Drug	RxNorm	Ingredient	S	17767	1970-01-01	2099-12-31	
742185	atomoxetine	Drug	RxNorm	Ingredient	S	38400	1970-01-01	2099-12-31	
44816277	168 HR Ethinyl Estradiol 0.00146 MG/HR / norelgestromin 0.00625 MG/HR Transdermal System	Drug	RxNorm	Quant Clinical Drug	S	1534809	2014-05-05	2099-12-31	
40231925	Acetaminophen 325 MG / Oxycodone Hydrochloride 5 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	1049221	2011-01-02	2099-12-31	
133834	Atopic dermatitis	Condition	SNOMED	Clinical Finding	S	24079001	1970-01-01	2099-12-31	
3006906	Calcium serum/plasma serum/plasma	Measurement	LOINC	Lab Test	S	17861-6	1998-07-09	2099-12-31	
1361711	Nitroglycerin	Drug	RxNorm	Ingredient	S	4917	1970-01-01	2099-12-31	
1112807	Aspirin	Drug	RxNorm	Ingredient	S	1191	1970-01-01	2099-12-31	
35605482	2 ML Ondansetron 2 MG/ML Injection	Drug	RxNorm	Quant Clinical Drug	S	1740467	2016-05-02	2099-12-31	
1115171	Naproxen sodium 220 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	849574	2009-05-31	2099-12-31	
134438	Contact dermatitis	Condition	SNOMED	Clinical Finding	S	40275004	1970-01-01	2099-12-31	
3045716	Anion gap serum/plasma	Measurement	LOINC	Lab Test	S	33037-3	2002-11-06	2099-12-31	
372328	Otitis media	Condition	SNOMED	Clinical Finding	S	65363002	1970-01-01	2099-12-31	
967823	Sodium Chloride	Drug	RxNorm	Ingredient	S	9863	1970-01-01	2099-12-31	
35605858	1 ML Morphine Sulfate 5 MG/ML Injection	Drug	RxNorm	Quant Clinical Drug	S	1732136	2016-05-02	2099-12-31	
40163554	Warfarin Sodium 5 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	855332	2009-08-02	2099-12-31	
78272	Sprain of wrist	Condition	SNOMED	Clinical Finding	S	70704007	1970-01-01	2099-12-31	
3028833	Bilirubin.total [Mass/volume] in Blood	Measurement	LOINC	Lab Test	S	42719-5	2005-10-18	2099-12-31	
375671	Concussion with loss of consciousness	Condition	SNOMED	Clinical Finding	S	62564004	1970-01-01	2099-12-31	
1778162	Cefuroxime	Drug	RxNorm	Ingredient	S	2194	1970-01-01	2099-12-31	
40766240	Are you covered by health insurance or some other kind of health care plan [PhenX]	Measurement	LOINC	Clinical Observation	S	63513-6	2011-02-17	2099-12-31	
40162522	Acetaminophen 325 MG / Hydrocodone Bitartrate 7.5 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	857005	2009-08-02	2099-12-31	
80809	Rheumatoid arthritis	Condition	SNOMED	Clinical Finding	S	69896004	1970-01-01	2099-12-31	
40232448	Diphenhydramine Hydrochloride 25 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	1049630	2011-01-02	2099-12-31	
313217	Atrial fibrillation	Condition	SNOMED	Clinical Finding	S	49436004	1970-01-01	2099-12-31	
1512674	drospirenone	Drug	RxNorm	Ingredient	S	11636	1970-01-01	2099-12-31	
46275444	Piperacillin 4000 MG / tazobactam 500 MG Injection	Drug	RxNorm	Clinical Drug	S	1659149	2015-09-08	2099-12-31	
1519937	Etonogestrel 68 MG Drug Implant	Drug	RxNorm	Clinical Drug	S	389221	1970-01-01	2099-12-31	
81151	Sprain of ankle	Condition	SNOMED	Clinical Finding	S	44465007	1970-01-01	2099-12-31	
782047	Isoflurane 999 MG/ML Inhalant Solution	Drug	RxNorm	Clinical Drug	S	542347	2005-09-11	2099-12-31	
321042	Cardiac arrest	Condition	SNOMED	Clinical Finding	S	410429000	1970-01-01	2099-12-31	
1177480	Ibuprofen	Drug	RxNorm	Ingredient	S	5640	1970-01-01	2099-12-31	
46275916	1 ML Epinephrine 1 MG/ML Injection	Drug	RxNorm	Quant Clinical Drug	S	1660014	2015-09-08	2099-12-31	
1551192	Prednisone 5 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	312617	1970-01-01	2099-12-31	
28060	Streptococcal sore throat	Condition	SNOMED	Clinical Finding	S	43878008	1970-01-01	2099-12-31	
4048171	Perennial allergic rhinitis with seasonal variation	Condition	SNOMED	Clinical Finding	S	232353008	1970-01-01	2099-12-31	
261325	Pulmonary emphysema	Condition	SNOMED	Clinical Finding	S	87433001	1970-01-01	2099-12-31	
1192710	Chlorpheniramine	Drug	RxNorm	Ingredient	S	2400	1970-01-01	2099-12-31	
1396131	ferrous sulfate	Drug	RxNorm	Ingredient	S	24947	1970-01-01	2099-12-31	
1539411	Simvastatin 20 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	312961	1970-01-01	2099-12-31	
30753	Esophagitis	Condition	SNOMED	Clinical Finding	S	16761005	1970-01-01	2099-12-31	
4035415	Tear of meniscus of knee	Condition	SNOMED	Clinical Finding	S	239720000	1970-01-01	2099-12-31	
441267	Cystic fibrosis	Condition	SNOMED	Clinical Finding	S	190905008	1970-01-01	2099-12-31	
1343916	Epinephrine	Drug	RxNorm	Ingredient	S	3992	1970-01-01	2099-12-31	
1307863	Verapamil	Drug	RxNorm	Ingredient	S	11170	1970-01-01	2099-12-31	
1545959	atorvastatin 80 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	259255	1970-01-01	2099-12-31	
196456	Gallstone	Condition	SNOMED	Clinical Finding	S	235919008	1970-01-01	2099-12-31	
4112343	Acute viral pharyngitis	Condition	SNOMED	Clinical Finding	S	195662009	1970-01-01	2099-12-31	
439777	Anemia	Condition	SNOMED	Clinical Finding	S	271737000	1970-01-01	2099-12-31	
19039298	sevoflurane	Drug	RxNorm	Ingredient	S	36453	1970-01-01	2099-12-31	
1308738	Vitamin B 12	Drug	RxNorm	Ingredient	S	11248	1970-01-01	2099-12-31	
1150771	Astemizole 10 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	197378	1970-01-01	2099-12-31	
80180	Osteoarthritis	Condition	SNOMED	Clinical Finding	S	396275006	1970-01-01	2099-12-31	
914335	Atropine	Drug	RxNorm	Ingredient	S	1223	1970-01-01	2099-12-31	
380378	Epilepsy	Condition	SNOMED	Clinical Finding	S	84757009	1970-01-01	2099-12-31	
19059528	Alfentanil	Drug	RxNorm	Ingredient	S	480	1970-01-01	2099-12-31	
1501700	levothyroxine	Drug	RxNorm	Ingredient	S	10582	1970-01-01	2099-12-31	
1150837	Terfenadine 60 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	141918	1970-01-01	2099-12-31	
80502	Osteoporosis	Condition	SNOMED	Clinical Finding	S	64859006	1970-01-01	2099-12-31	
836654	Tacrine	Drug	RxNorm	Ingredient	S	10318	1970-01-01	2099-12-31	
381316	Cerebrovascular accident	Condition	SNOMED	Clinical Finding	S	230690007	1970-01-01	2099-12-31	
40479422	Injury of medial collateral ligament of knee	Condition	SNOMED	Clinical Finding	S	444448004	2010-01-31	2099-12-31	
1503184	Mestranol	Drug	RxNorm	Ingredient	S	6782	1970-01-01	2099-12-31	
1107882	Loratadine 10 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	311372	1970-01-01	2099-12-31	
81893	Ulcerative colitis	Condition	SNOMED	Clinical Finding	S	64766004	1970-01-01	2099-12-31	
836659	Tacrine 10 MG Oral Capsule	Drug	RxNorm	Clinical Drug	S	313185	1970-01-01	2099-12-31	
433125	Infection due to Staphylococcus aureus	Condition	SNOMED	Clinical Finding	S	406602003	1970-01-01	2099-12-31	
40479768	Injury of anterior cruciate ligament	Condition	SNOMED	Clinical Finding	S	444470001	2010-01-31	2099-12-31	
40480160	Pathological fracture due to osteoporosis	Condition	SNOMED	Clinical Finding	S	443165006	2010-01-31	2099-12-31	
1595799	Ferrous fumarate	Drug	RxNorm	Ingredient	S	24941	1970-01-01	2099-12-31	
198199	Pyelonephritis	Condition	SNOMED	Clinical Finding	S	45816000	1970-01-01	2099-12-31	
3000963	Hemoglobin	Measurement	LOINC	Lab Test	S	718-7	1970-01-01	2099-12-31	
440086	Child attention deficit disorder	Condition	SNOMED	Clinical Finding	S	192127007	1970-01-01	2099-12-31	
40478878	Cystic fibrosis 20 common mutation test	Measurement	SNOMED	Procedure	S	444260001	2010-01-31	2099-12-31	
4202451	Percutaneous mechanical thrombectomy of portal vein using fluoroscopic guidance	Procedure	SNOMED	Procedure	S	433112001	2009-01-31	2099-12-31	
1717327	Ampicillin	Drug	RxNorm	Ingredient	S	733	1970-01-01	2099-12-31	
255848	Pneumonia	Condition	SNOMED	Clinical Finding	S	233604007	1970-01-01	2099-12-31	
3001488	Cow milk IgE Ab [Units/volume] in Serum	Measurement	LOINC	Lab Test	S	7258-7	1970-01-01	2099-12-31	
440448	Appendicitis	Condition	SNOMED	Clinical Finding	S	74400008	1970-01-01	2099-12-31	
3006322	Oral temperature	Measurement	LOINC	Clinical Observation	S	8331-1	1996-09-06	2099-12-31	
19089061	Prednisone 2.5 MG [Deltasone]	Drug	RxNorm	Branded Drug Comp	S	567645	2005-09-11	2099-12-31	
1738521	Doxycycline	Drug	RxNorm	Ingredient	S	3640	1970-01-01	2099-12-31	
257012	Chronic sinusitis	Condition	SNOMED	Clinical Finding	S	40055000	1970-01-01	2099-12-31	
3019550	Sodium serum/plasma	Measurement	LOINC	Lab Test	S	2951-2	1970-01-01	2099-12-31	
4001336	Concussion injury of brain	Condition	SNOMED	Clinical Finding	S	110030002	1970-01-01	2099-12-31	
4125906	Suture open wound	Procedure	SNOMED	Procedure	S	288086009	1970-01-01	2099-12-31	
19115351	Diazepam 5 MG [Valium]	Drug	RxNorm	Branded Drug Comp	S	563026	2005-09-11	2099-12-31	
975125	Hydrocortisone	Drug	RxNorm	Ingredient	S	5492	1970-01-01	2099-12-31	
192671	Gastrointestinal hemorrhage	Condition	SNOMED	Clinical Finding	S	74474003	1970-01-01	2099-12-31	
3015632	Carbon dioxide serum/plasma	Measurement	LOINC	Lab Test	S	2028-9	1970-01-01	2099-12-31	
4029498	Seizure disorder	Condition	SNOMED	Clinical Finding	S	128613002	1970-01-01	2099-12-31	
4132546	Traumatic brain injury	Condition	SNOMED	Clinical Finding	S	127295002	1970-01-01	2099-12-31	
19128263	{7 (Ethinyl Estradiol 0.035 MG / norgestimate 0.18 MG Oral Tablet) / 7 (Ethinyl Estradiol 0.035 MG / norgestimate 0.215 MG Oral Tablet) / 7 (Ethinyl Estradiol 0.035 MG / norgestimate 0.25 MG Oral Tablet) / 7 (Inert Ingredients 1 MG Oral Tablet) } Pack [Tr	Drug	RxNorm	Branded Pack	S	751905	2008-01-27	2099-12-31	
1000560	Ondansetron	Drug	RxNorm	Ingredient	S	26225	1970-01-01	2099-12-31	
140673	Hypothyroidism	Condition	SNOMED	Clinical Finding	S	40930008	1970-01-01	2099-12-31	
3015076	Soybean IgE Ab [Units/volume] in Serum	Measurement	LOINC	Lab Test	S	6248-9	1970-01-01	2099-12-31	
4027663	Peptic ulcer	Condition	SNOMED	Clinical Finding	S	13200003	1970-01-01	2099-12-31	
4174876	Allergy to bee venom	Observation	SNOMED	Clinical Finding	S	424213003	1970-01-01	2099-12-31	
19127904	{24 (drospirenone 3 MG / Ethinyl Estradiol 0.02 MG Oral Tablet) / 4 (Inert Ingredients 1 MG Oral Tablet) } Pack [Yaz 28 Day]	Drug	RxNorm	Branded Pack	S	748856	2007-12-30	2099-12-31	
1741122	tazobactam	Drug	RxNorm	Ingredient	S	37617	1970-01-01	2099-12-31	
4066995	Fracture of vertebral column with spinal cord injury	Condition	SNOMED	Clinical Finding	S	1734006	1970-01-01	2099-12-31	
3016723	Creatinine serum/plasma	Measurement	LOINC	Lab Test	S	2160-0	1970-01-01	2099-12-31	
4043241	Familial Alzheimer's disease of early onset	Condition	SNOMED	Clinical Finding	S	230265002	1970-01-01	2099-12-31	
4139681	Allergy to dairy product	Observation	SNOMED	Clinical Finding	S	425525006	1970-01-01	2099-12-31	
19127918	{21 (Ethinyl Estradiol 0.03 MG / Levonorgestrel 0.15 MG Oral Tablet) / 7 (Inert Ingredients 1 MG Oral Tablet) } Pack [Levora 0.15/30 28 Day]	Drug	RxNorm	Branded Pack	S	748879	2007-12-30	2099-12-31	
1759842	Clavulanate	Drug	RxNorm	Ingredient	S	48203	1970-01-01	2099-12-31	
4059173	Fracture of ankle	Condition	SNOMED	Clinical Finding	S	16114001	1970-01-01	2099-12-31	
3021226	Shrimp IgE Ab [Units/volume] in Serum	Measurement	LOINC	Lab Test	S	6246-3	1970-01-01	2099-12-31	
4084167	Acute allergic reaction	Condition	SNOMED	Clinical Finding	S	241929008	1970-01-01	2099-12-31	
19018935	Digoxin 0.125 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	197604	1970-01-01	2099-12-31	
19127922	{28 (Norethindrone 0.35 MG Oral Tablet) } Pack [Camila 28 Day]	Drug	RxNorm	Branded Pack	S	748962	2007-12-30	2099-12-31	
1713332	Amoxicillin	Drug	RxNorm	Ingredient	S	723	1970-01-01	2099-12-31	
4056621	Recurrent urinary tract infection	Condition	SNOMED	Clinical Finding	S	197927001	1970-01-01	2099-12-31	
3019406	Latex IgE Ab [Units/volume] in Serum	Measurement	LOINC	Lab Test	S	6158-0	1970-01-01	2099-12-31	
4134304	Fracture subluxation of wrist	Condition	SNOMED	Clinical Finding	S	263102004	1970-01-01	2099-12-31	
19023398	sevoflurane 1000 MG/ML Inhalant Solution	Drug	RxNorm	Clinical Drug	S	200243	1970-01-01	2099-12-31	
19128009	{7 (Ethinyl Estradiol 0.01 MG Oral Tablet) / 84 (Ethinyl Estradiol 0.03 MG / Levonorgestrel 0.15 MG Oral Tablet) } Pack [Seasonique]	Drug	RxNorm	Branded Pack	S	749762	2007-12-30	2099-12-31	
1746114	Piperacillin	Drug	RxNorm	Ingredient	S	8339	1970-01-01	2099-12-31	
4299128	Third degree burn	Condition	SNOMED	Clinical Finding	S	403192003	1970-01-01	2099-12-31	
3014576	Chloride serum/plasma	Measurement	LOINC	Lab Test	S	2075-0	1970-01-01	2099-12-31	
4015189	Microbial culture of sputum	Measurement	SNOMED	Procedure	S	104173009	1970-01-01	2099-12-31	
19023423	desflurane 990 MG/ML Inhalant Solution	Drug	RxNorm	Clinical Drug	S	200252	1970-01-01	2099-12-31	
19128022	{7 (Ethinyl Estradiol 0.035 MG / norgestimate 0.18 MG Oral Tablet) / 7 (Ethinyl Estradiol 0.035 MG / norgestimate 0.215 MG Oral Tablet) / 7 (Ethinyl Estradiol 0.035 MG / norgestimate 0.25 MG Oral Tablet) / 7 (Inert Ingredients 1 MG Oral Tablet) } Pack [Or	Drug	RxNorm	Branded Pack	S	749785	2007-12-30	2099-12-31	
1768849	Cefaclor	Drug	RxNorm	Ingredient	S	2176	1970-01-01	2099-12-31	
4329847	Myocardial infarction	Condition	SNOMED	Clinical Finding	S	22298006	1970-01-01	2099-12-31	
3013721	Aspartate aminotransferase serum/plasma	Measurement	LOINC	Lab Test	S	1920-8	1970-01-01	2099-12-31	
4010253	Nasal sinus endoscopy	Procedure	SNOMED	Procedure	S	112790001	1970-01-01	2099-12-31	
19008572	Hydrocortisone 10 MG/ML Topical Cream	Drug	RxNorm	Clinical Drug	S	106258	1970-01-01	2099-12-31	
19127890	Inert Ingredients	Drug	RxNorm	Ingredient	S	748794	2007-12-30	2099-12-31	
1174888	Hydrocodone	Drug	RxNorm	Ingredient	S	5489	1970-01-01	2099-12-31	
439406	Allergy to animal dander	Observation	SNOMED	Clinical Finding	S	232347008	1970-01-01	2099-12-31	
3000876	Codfish IgE Ab [Units/volume] in Serum	Measurement	LOINC	Lab Test	S	6082-2	1970-01-01	2099-12-31	
4035793	Pulmonary rehabilitation	Procedure	SNOMED	Procedure	S	15081005	1970-01-01	2099-12-31	
19002770	desflurane	Drug	RxNorm	Ingredient	S	27340	1970-01-01	2099-12-31	
19123231	atomoxetine 100 MG Oral Capsule	Drug	RxNorm	Clinical Drug	S	608139	2006-02-26	2099-12-31	
1515774	norgestimate	Drug	RxNorm	Ingredient	S	31994	1970-01-01	2099-12-31	
443279	Attempted suicide - cut/stab	Observation	SNOMED	Clinical Finding	S	287185009	1970-01-01	2099-12-31	
3051031	History of Hospitalizations+Outpatient visits Narrative	Measurement	LOINC	Clinical Observation	S	46240-8	1970-01-01	2099-12-31	
4186930	Replacement of intrauterine contraceptive device	Procedure	SNOMED	Procedure	S	46706006	1970-01-01	2099-12-31	
19132304	Levonorgestrel 0.000833 MG/HR Intrauterine System [Mirena]	Drug	RxNorm	Branded Drug	S	807283	2008-09-28	2099-12-31	
44782520	Chronic paralysis due to lesion of spinal cord	Condition	SNOMED	Clinical Finding	S	698754002	2014-01-31	2099-12-31	
1518198	norelgestromin	Drug	RxNorm	Ingredient	S	326374	1970-01-01	2099-12-31	
4102123	Latex allergy	Observation	SNOMED	Clinical Finding	S	300916003	1970-01-01	2099-12-31	
4326177	Medication Reconciliation	Procedure	SNOMED	Procedure	S	430193006	2009-01-31	2099-12-31	
4191853	Allergy screening test	Procedure	SNOMED	Procedure	S	395142003	1970-01-01	2099-12-31	
19134077	cyclosporine, modified 100 MG [Neoral]	Drug	RxNorm	Branded Drug Comp	S	835900	2009-04-05	2099-12-31	
40758406	HIV status	Measurement	LOINC	Clinical Observation	S	55277-8	2009-03-26	2099-12-31	
1519936	Etonogestrel	Drug	RxNorm	Ingredient	S	14584	1970-01-01	2099-12-31	
4302207	Allergy to grass pollen	Observation	SNOMED	Clinical Finding	S	418689008	1970-01-01	2099-12-31	
4323208	History of appendectomy	Observation	SNOMED	Context-dependent	S	428251008	2008-01-31	2099-12-31	
4181917	Electroencephalogram	Procedure	SNOMED	Procedure	S	54550000	1970-01-01	2099-12-31	
19128065	{7 (Inert Ingredients 1 MG Oral Tablet) / 21 (Mestranol 0.05 MG / Norethindrone 1 MG Oral Tablet) } Pack [Norinyl 1+50 28 Day]	Drug	RxNorm	Branded Pack	S	749882	2007-12-30	2099-12-31	
46235214	Sexual orientation	Measurement	LOINC	Clinical Observation	S	76690-7	2015-03-13	2099-12-31	
1521369	Norethindrone	Drug	RxNorm	Ingredient	S	7514	1970-01-01	2099-12-31	
4024958	Throat culture	Measurement	SNOMED	Procedure	S	117015009	1970-01-01	2099-12-31	
40492359	Insertion of biventricular implantable cardioverter defibrillator	Procedure	SNOMED	Procedure	S	447365002	2011-01-31	2099-12-31	
4187458	Review of systems	Procedure	SNOMED	Procedure	S	415300000	1970-01-01	2099-12-31	
19129144	{28 (Norethindrone 0.35 MG Oral Tablet) } Pack [Jolivette 28 Day]	Drug	RxNorm	Branded Pack	S	757594	2008-03-02	2099-12-31	
37017711	Allergy to soy	Observation	SNOMED	Clinical Finding	S	714035009	2016-01-31	2099-12-31	
1551099	Prednisone	Drug	RxNorm	Ingredient	S	8640	1970-01-01	2099-12-31	
4024289	Radiography of ankle	Procedure	SNOMED	Procedure	S	19490002	1970-01-01	2099-12-31	
40169281	60 ACTUAT Fluticasone propionate 0.25 MG/ACTUAT / salmeterol 0.05 MG/ACTUAT Dry Powder Inhaler	Drug	RxNorm	Quant Clinical Drug	S	896209	2010-01-31	2099-12-31	
4145310	Pelvis X-ray	Procedure	SNOMED	Procedure	S	268425006	1970-01-01	2099-12-31	
19133768	Acetaminophen 750 MG / Hydrocodone Bitartrate 7.5 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	833036	2009-03-01	2099-12-31	
46233710	Doxycycline Monohydrate 100 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	1650142	2015-07-06	2099-12-31	
1539403	Simvastatin	Drug	RxNorm	Ingredient	S	36567	1970-01-01	2099-12-31	
4057420	Catheter ablation of tissue of heart	Procedure	SNOMED	Procedure	S	18286008	1970-01-01	2099-12-31	
40228214	cetirizine hydrochloride 10 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	1014678	2010-10-31	2099-12-31	
4197460	Injection of epinephrine	Procedure	SNOMED	Procedure	S	313191000	1970-01-01	2099-12-31	
19133873	Penicillin V Potassium 250 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	834061	2009-03-01	2099-12-31	
46233988	Doxycycline Monohydrate 50 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	1652673	2015-07-06	2099-12-31	
1545958	atorvastatin	Drug	RxNorm	Ingredient	S	83367	1970-01-01	2099-12-31	
4059978	Insertion of subcutaneous contraceptive	Procedure	SNOMED	Procedure	S	169553002	1970-01-01	2099-12-31	
40228230	cetirizine hydrochloride 5 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	1014676	2010-10-31	2099-12-31	
4195803	Bone density scan	Procedure	SNOMED	Procedure	S	312681000	1970-01-01	2099-12-31	
19133905	Penicillin V Potassium 500 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	834102	2009-03-01	2099-12-31	
44783196	Surgical manipulation of joint of knee	Procedure	SNOMED	Procedure	S	699253003	2014-01-31	2099-12-31	
1548195	Estradiol	Drug	RxNorm	Ingredient	S	4083	1970-01-01	2099-12-31	
4062501	Asthma screening	Procedure	SNOMED	Procedure	S	171231001	1970-01-01	2099-12-31	
40165015	Meperidine Hydrochloride 50 MG Oral Tablet	Drug	RxNorm	Clinical Drug	S	861467	2009-09-06	2099-12-31	
4330583	Vasectomy	Procedure	SNOMED	Procedure	S	22523008	1970-01-01	2099-12-31	
19125062	Loratadine 5 MG Chewable Tablet	Drug	RxNorm	Clinical Drug	S	665078	2006-12-17	2099-12-31	
1549786	Ethinyl Estradiol	Drug	RxNorm	Ingredient	S	4124	1970-01-01	2099-12-31	
4058899	Plain X-ray of clavicle	Procedure	SNOMED	Procedure	S	168594001	1970-01-01	2099-12-31	
4163874	History of myocardial infarction	Observation	SNOMED	Context-dependent	S	399211009	1970-01-01	2099-12-31	
3049273	DXA Radius and Ulna [T-score] Bone density	Measurement	LOINC	Clinical Observation	S	38265-5	1970-01-01	2099-12-31	
19126352	Nitroglycerin 0.4 MG/ACTUAT Mucosal Spray	Drug	RxNorm	Clinical Drug	S	705129	2007-05-27	2099-12-31	
8507	MALE	Gender	Gender	Gender	S	M	1970-01-01	2099-12-31	
8532	FEMALE	Gender	Gender	Gender	S	F	1970-01-01	2099-12-31	
\.


--
-- TOC entry 3886 (class 0 OID 3185481)
-- Dependencies: 208
-- Data for Name: concept_ancestor; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".concept_ancestor (ancestor_concept_id, descendant_concept_id, min_levels_of_separation, max_levels_of_separation) FROM stdin;
4180628	313217	5	6
4179141	4146173	2	2
21500574	1118084	4	4
21505770	1119510	0	0
21503967	40162522	5	6
36203060	40479422	4	4
36151386	1119510	0	0
21502552	1112807	4	4
40765628	40769189	2	2
44339646	19128009	2	2
44337799	1521369	0	0
44339264	1124957	0	0
45652937	1125315	0	0
45622421	1713332	0	0
45640391	1125315	0	0
45632061	1119510	0	0
45629773	1539403	0	0
45654298	1177480	0	0
45624364	19008572	2	3
45686394	975125	0	0
45781198	933724	0	0
45687104	46233710	2	3
45687749	19008572	2	3
46242471	1112807	0	0
45703024	1728416	0	0
46242546	40229134	2	3
45798499	1000560	0	0
46297520	1119510	0	0
45691093	1125315	0	0
46293532	1125315	0	0
45799320	1119510	0	0
46309333	1129625	0	0
45897346	1107882	2	3
253549	4048695	5	6
4179141	4149245	2	2
21500574	1177480	4	4
21505770	1192710	0	0
21500363	46275916	5	6
35902851	198809	4	4
36155724	1119510	0	0
21502552	1367571	4	4
40765628	40769179	2	2
44362889	40223834	2	3
44337803	933724	0	0
44339286	1539403	0	0
45652938	1125315	0	0
45622707	791967	0	0
45640297	1125315	0	0
45632149	1119510	0	0
45629693	1521369	0	0
45655401	1177480	0	0
45624375	43012036	2	3
45686437	975125	0	0
45781644	1717327	0	0
45687187	19074843	2	3
45687303	40232448	2	3
46242526	1115008	0	0
45702872	920293	0	0
46242294	19008572	2	3
45798500	1310149	0	0
46292863	1119510	0	0
45691287	1125315	0	0
46293704	1125315	0	0
45799552	1119510	0	0
46309473	1129625	0	0
45894646	43012036	2	3
253549	4149245	5	6
4154161	4296205	2	2
21500574	1305058	4	4
21505771	1174888	0	0
21505691	40173590	5	6
35802133	40480160	4	4
36155807	1119510	0	0
21502552	1310149	4	4
40765628	40769184	2	2
44362900	1154615	2	3
44337807	1115008	0	0
44339423	1738521	0	0
45653079	1125315	0	0
45622708	1343916	0	0
45640350	1125315	0	0
45632086	1119510	0	0
45629693	19127890	0	0
45654761	1177480	0	0
45624843	40162522	2	3
45686512	975125	0	0
45781652	1124300	0	0
45687237	1107882	2	3
45687230	1115171	2	3
46242529	1738521	0	0
45702874	1307863	0	0
46242368	19008572	2	3
45798510	1124300	0	0
46293239	1119510	0	0
45691366	1125315	0	0
46293589	1125315	0	0
45799671	1119510	0	0
46309362	1129625	0	0
45894753	43012036	2	3
253549	4278672	5	6
4154161	4299128	2	2
21500574	1112807	4	4
21505771	1129625	0	0
21505696	40236446	5	6
36002886	4048171	4	4
36155941	1119510	0	0
21502552	1322184	4	4
40765628	40769194	2	2
44363088	19059056	2	3
44337888	1000560	0	0
44339288	705944	0	0
45653127	1125315	0	0
45622661	1115008	0	0
45640480	1125315	0	0
45632160	1119510	0	0
45629693	1549786	0	0
45654876	1177480	0	0
45668913	40232448	2	3
45685530	975125	0	0
45781436	967823	0	0
45687171	40232448	2	3
45687690	40232448	2	3
46242531	757627	0	0
45702879	967823	0	0
46241199	40232448	2	3
45798292	967823	0	0
46293425	1119510	0	0
45691370	1125315	0	0
46293606	1125315	0	0
45799659	1119510	0	0
46303833	1129625	0	0
45894768	1127433	2	3
253549	40479768	5	6
4154161	4001336	2	2
21500574	19010482	4	4
21505771	1192710	0	0
21601238	46275916	5	6
36002141	4280726	4	4
36156016	1119510	0	0
4180941	4125906	4	4
37520653	44783196	2	2
44362914	40231925	2	3
44337890	1343916	0	0
44339290	975125	0	0
45653151	1125315	0	0
45622723	738818	0	0
45640534	1125315	0	0
45631865	1119510	0	0
45629671	1500211	0	0
45654802	1177480	0	0
45668842	40228230	2	3
45680343	975125	0	0
45781446	1115008	0	0
45687184	19075001	2	3
45687839	19077572	2	3
46240468	1192710	0	0
45702968	920293	0	0
46241250	1545959	2	3
45798300	1729720	0	0
46293304	1119510	0	0
45691344	1125315	0	0
46293610	1125315	0	0
45799578	1119510	0	0
46303855	1129625	0	0
45896749	40232448	2	3
253549	4066995	5	6
4027255	4329847	2	2
21500574	1129625	4	4
21505775	1174888	0	0
21604253	40229134	5	6
36002141	40486433	4	4
36155943	1119510	0	0
21502550	1000560	4	4
37219942	255848	2	2
44362916	1115171	2	3
44337891	1539403	0	0
44339090	1149380	0	0
45653423	1125315	0	0
45622950	738818	0	0
45640523	1125315	0	0
45632192	1119510	0	0
45629677	740275	0	0
45651402	1177480	0	0
45668889	920334	2	3
45676890	975125	0	0
45781202	967823	0	0
45687209	19075601	2	3
45684256	19019273	2	3
46240499	1539403	0	0
45702980	1729720	0	0
46241163	19077572	2	3
45798302	1112807	0	0
46293457	1119510	0	0
45690976	1125315	0	0
46293746	1125315	0	0
45796709	1119510	0	0
46303929	1129625	0	0
45896653	40163554	2	3
253549	40479422	5	6
4105895	4295880	2	2
21500574	1115008	4	4
21505776	1119510	0	0
21604253	19133768	5	6
36002868	40486433	4	4
36155882	1119510	0	0
21502550	975125	4	4
37622482	317576	2	2
44363103	40162522	2	3
44338028	1112807	0	0
44339293	1545958	0	0
45653425	1125315	0	0
45622557	1174888	0	0
45640442	1125315	0	0
45632006	1119510	0	0
45629620	1107830	0	0
45651651	1177480	0	0
45668843	19073183	2	3
45677086	975125	0	0
45781591	933724	0	0
45687210	19133905	2	3
45684374	40163554	2	3
46240710	1545958	0	0
45702986	1551099	0	0
46238234	1332419	2	3
45798424	1759842	0	0
46296565	1119510	0	0
45688744	1125315	0	0
46293751	1125315	0	0
45796843	1119510	0	0
46307067	1129625	0	0
45896421	782047	2	3
253549	4059173	5	6
4105895	4197460	2	2
21500574	1125315	4	4
21505819	1129625	0	0
21604253	40162522	5	6
36002139	433644	4	4
36156211	1119510	0	0
21502550	914335	4	4
40228299	42902245	2	2
44363026	40162522	2	3
44338031	1129625	0	0
44339580	1129625	0	0
45653531	1125315	0	0
45622736	1115008	0	0
45640538	1125315	0	0
45632012	1119510	0	0
45629628	738818	0	0
45651272	1177480	0	0
45668645	19075001	2	3
45677281	975125	0	0
45781215	738818	0	0
45687210	19133873	2	3
45684300	40223768	2	3
46240710	1332418	0	0
45703055	1332418	0	0
46238508	1127433	2	3
45798523	1107830	0	0
46296644	1119510	0	0
45688020	1125315	0	0
46293520	1125315	0	0
45796991	1119510	0	0
46306400	1129625	0	0
45896517	40232448	2	3
4024567	40481087	5	6
4043026	4047491	2	2
21502510	1713332	4	4
21503326	1149380	0	0
21603365	40229134	5	6
36002139	4240902	4	4
36156028	1119510	0	0
21502550	967823	4	4
37520731	4057420	2	2
44363228	19019273	2	3
44338035	1738521	0	0
44339386	1115008	0	0
45653103	1125315	0	0
45622868	1153428	0	0
45640610	1125315	0	0
45632213	1119510	0	0
45629757	1174888	0	0
45648308	1177480	0	0
45668661	1551192	2	3
45673977	975125	0	0
45778663	1124957	0	0
45684124	19008572	2	3
45684311	19078924	2	3
45703202	1112807	0	0
45703816	1548195	0	0
46238531	1332419	2	3
45798228	975125	0	0
46296803	1119510	0	0
45688115	1125315	0	0
46293811	1125315	0	0
45796801	1119510	0	0
46307077	1129625	0	0
45896772	19059056	2	3
4024567	28060	5	6
4178818	372328	2	2
21502510	1768849	4	4
21503373	1129625	0	0
21603365	40162522	5	6
35204998	4310024	4	4
36156029	1119510	0	0
21502550	1177480	4	4
37622481	381316	2	2
44363251	40232448	2	3
44338045	1192710	0	0
44339459	1177480	0	0
45652984	1125315	0	0
45622869	1102527	0	0
45640512	1125315	0	0
45632024	1119510	0	0
45629759	1310149	0	0
45648403	1177480	0	0
45668880	40229134	2	3
45673935	975125	0	0
45778878	967823	0	0
45684158	1107882	2	3
45684269	19077344	2	3
45703250	1124957	0	0
45703946	1107830	0	0
46238339	40232448	2	3
45795455	1153428	0	0
46296600	1119510	0	0
45688064	1125315	0	0
46293725	1125315	0	0
45797104	1119510	0	0
46304172	1129625	0	0
45896792	40236824	2	3
4028076	4048171	5	6
4178818	134438	2	2
21502510	1759842	4	4
21503373	975125	0	0
21603365	19133768	5	6
35205038	441267	4	4
36156132	1119510	0	0
36217216	19127922	3	4
40037552	40221415	2	2
44363252	1115171	2	3
45619727	738818	0	0
44339459	1174888	0	0
45653285	1125315	0	0
45622812	1728416	0	0
45640513	1125315	0	0
45634086	1119510	0	0
45629763	1192710	0	0
45648412	1177480	0	0
45668952	19007333	2	3
45674014	975125	0	0
45779076	967823	0	0
45684098	19023398	2	3
45685586	19075601	2	3
45703223	1501700	0	0
45703575	1149196	0	0
46238409	19059056	2	3
45795361	1589505	0	0
46296728	1119510	0	0
45688107	1125315	0	0
46293530	1125315	0	0
45796891	1119510	0	0
46304183	1129625	0	0
45803821	40229134	2	3
4162282	4112343	5	6
4178818	198199	2	2
21502510	1741122	4	4
21503365	975125	0	0
21496206	3049273	4	5
36203067	4156265	4	4
36156001	1119510	0	0
36217216	19128022	3	4
40758298	40758406	2	2
44363143	1154615	2	3
45619794	1310149	0	0
44339460	1129625	0	0
45653300	1125315	0	0
45622822	1713332	0	0
45640518	1125315	0	0
45634228	1119510	0	0
45629739	1729720	0	0
45645154	1177480	0	0
45670291	40173590	2	3
45673895	975125	0	0
45779085	1545958	0	0
45684206	19008572	2	3
45685467	43012036	2	3
45703180	1118084	0	0
45703771	1310149	0	0
46238635	19019273	2	3
45795361	19127890	0	0
46296660	1119510	0	0
45688088	1125315	0	0
46293952	1125315	0	0
45797038	1119510	0	0
46304101	1129625	0	0
45803602	40162522	2	3
432795	4132546	4	6
4178818	195588	2	2
21502510	1746114	4	4
21503366	975125	0	0
21604147	40173590	4	5
36000000	438614	4	4
36156195	1119510	0	0
36600000	4280726	4	4
37520664	4301346	2	2
44363181	1115171	2	3
45619795	1129625	0	0
44339461	1521369	0	0
45653326	1125315	0	0
45622822	1759842	0	0
45640559	1125315	0	0
45628849	1119510	0	0
45629741	738818	0	0
45645256	1177480	0	0
45670398	19078461	2	3
45673896	975125	0	0
45779195	1192710	0	0
45684239	19008572	2	3
45685478	1127433	2	3
45703206	705944	0	0
45703772	1192710	0	0
46238672	40232448	2	3
45795361	1549786	0	0
46296661	1119510	0	0
45688093	1125315	0	0
46293846	1125315	0	0
45797042	1119510	0	0
46320438	1129625	0	0
45803804	19018935	2	3
4024567	255848	4	6
4108616	4010253	2	2
21502510	1729720	4	4
21503367	975125	0	0
21604792	45892894	4	5
36000000	4139681	4	4
36156198	1119510	0	0
36600000	40480160	4	4
40789542	3006451	2	2
44363159	40232448	2	3
45619955	1112807	0	0
44339461	1549786	0	0
45653095	1125315	0	0
45622830	1332418	0	0
45640619	1125315	0	0
45629045	1119510	0	0
45629749	1759842	0	0
45645125	1177480	0	0
45666599	1115171	2	3
45673906	975125	0	0
45779197	1124957	0	0
45684129	40163554	2	3
45685704	1713671	2	3
45703362	1501700	0	0
45704070	1308738	0	0
46238754	1127433	2	3
45795364	1112807	0	0
46296517	1119510	0	0
45688133	1125315	0	0
46288728	1125315	0	0
45797083	1119510	0	0
46320124	1129625	0	0
45803866	40229134	2	3
4180628	4310024	4	6
4158691	4186930	2	2
21502510	1717327	4	4
21503344	1125315	0	0
21503965	19007333	4	5
36203066	4066995	4	4
36156206	1119510	0	0
36600000	4056621	5	5
40765347	3000963	2	2
44363193	40229134	2	3
45619826	1129625	0	0
44339463	1548195	0	0
45653361	1125315	0	0
45622746	1309944	0	0
45640756	1125315	0	0
45629161	1119510	0	0
45629749	1713332	0	0
45645460	1177480	0	0
45666857	19008572	2	3
45671370	975125	0	0
45779106	1174888	0	0
45684372	1127433	2	3
45685708	19133905	2	3
45703296	1738521	0	0
45703651	1728416	0	0
46238703	40169216	2	3
45795399	933724	0	0
46293572	1119510	0	0
45688140	1125315	0	0
46288617	1125315	0	0
45797027	1119510	0	0
46320460	1129625	0	0
45803673	40229134	2	3
255919	4156265	4	6
4042836	4029498	2	2
21502510	1174888	4	4
21503326	975125	0	0
21604070	42707627	4	5
36203066	40479768	4	4
36156435	1119510	0	0
36600000	81151	5	8
37520651	4301346	2	2
44363591	19133905	2	3
45619873	738818	0	0
44339268	1154029	0	0
45653133	1125315	0	0
45623042	1307863	0	0
45640757	1125315	0	0
45629164	1119510	0	0
45629750	1545958	0	0
45642529	1177480	0	0
45664254	40232448	2	3
45671246	975125	0	0
45779108	1192710	0	0
45680884	19008572	2	3
45685708	19133873	2	3
45703141	1307863	0	0
45703653	1308738	0	0
45897488	19018935	2	3
45795404	1738521	0	0
46293746	1119510	0	0
45688125	1125315	0	0
46288885	1125315	0	0
46318051	1119510	0	0
46320692	1129625	0	0
45803962	19008572	2	3
255919	4132546	4	6
4043161	4218408	2	2
21502510	1778162	4	4
21503375	975125	0	0
21500007	1713671	4	5
36203066	4048695	4	4
36158854	1119510	0	0
36600000	4149245	6	6
37520651	44783196	2	2
44358586	19019273	2	3
45620074	1149196	0	0
44339271	1713332	0	0
45653136	1125315	0	0
45622957	1154343	0	0
45637439	1125315	0	0
45629192	1119510	0	0
45629886	1713332	0	0
45642372	1177480	0	0
45664479	1154615	2	3
45670706	975125	0	0
45778879	1107830	0	0
45683993	1332419	2	3
45684391	40228230	2	3
45703253	1501700	0	0
45704079	1361711	0	0
45897557	40236446	2	3
45795407	1174888	0	0
46293811	1119510	0	0
45688174	1125315	0	0
46288816	1125315	0	0
46318054	1119510	0	0
46320631	1129625	0	0
45894840	42707627	2	3
4022922	4152936	4	6
4043161	4295880	2	2
21502510	1728416	4	4
21503351	1396131	0	0
21500007	46275444	4	5
36203066	40479422	4	4
36158858	1119510	0	0
36600000	40479768	7	7
37522278	4035793	3	3
44358687	40236824	2	3
45619980	1177480	0	0
44339588	1129625	0	0
45653442	1125315	0	0
45622973	1713332	0	0
45637502	1125315	0	0
45629096	1119510	0	0
45629886	1759842	0	0
45642405	1177480	0	0
45664280	1115171	2	3
45781372	975125	0	0
45778948	1149196	0	0
45680558	1127433	2	3
45684580	19059056	2	3
45703224	1309944	0	0
45703717	1124957	0	0
45897639	1127433	2	3
45795397	1149196	0	0
46293530	1119510	0	0
45688208	1125315	0	0
46288632	1125315	0	0
46317552	1119510	0	0
46321388	1129625	0	0
45896869	1107882	2	3
4022922	4149245	4	6
4043022	4202451	2	2
21500582	1174888	4	4
21500206	1361711	0	0
21500010	19074843	4	5
36203066	4001336	4	4
36158935	1119510	0	0
36600000	40479422	7	7
37522278	4197460	3	3
44356475	1115171	2	3
45620028	1177480	0	0
44339374	1539403	0	0
45653114	1125315	0	0
45623071	1115008	0	0
45637537	1125315	0	0
45629102	1119510	0	0
45629835	1713332	0	0
45642550	1177480	0	0
45664309	40229134	2	3
45781186	975125	0	0
45778957	1153428	0	0
45680558	19078461	2	3
45684581	40232448	2	3
45703422	791967	0	0
45703122	1545958	0	0
45897589	40229134	2	3
45795572	1332418	0	0
46288728	1119510	0	0
45688321	1125315	0	0
46291556	1125315	0	0
45793890	1119510	0	0
46320810	1129625	0	0
45650773	19018935	2	3
253549	40480160	4	6
4048365	4133840	2	2
21500582	1124957	4	4
21500544	708298	0	0
21500010	19075001	4	5
36102149	40486433	4	4
36158971	1119510	0	0
36600000	78272	9	9
37622481	317576	3	3
44356269	19008572	2	3
45620337	975125	0	0
44339097	1729720	0	0
45653299	1125315	0	0
45623058	1309944	0	0
45637160	1125315	0	0
45629257	1119510	0	0
45629846	1192710	0	0
45642477	1177480	0	0
45664548	40232448	2	3
45779017	975125	0	0
45778960	1124300	0	0
45783587	19075601	2	3
45684574	1115171	2	3
45703425	1124300	0	0
45703124	1551099	0	0
45897597	1107882	2	3
45795574	1112807	0	0
46288885	1119510	0	0
45688203	1125315	0	0
46291649	1125315	0	0
45794190	1119510	0	0
46314285	1129625	0	0
45675631	40236446	2	3
253549	4237458	4	6
4040396	4238715	2	2
21500582	1102527	4	4
21500544	791967	0	0
21500010	19074841	4	5
36102149	4280726	4	4
36158677	1119510	0	0
36300000	42535580	5	10
37622481	4310024	3	3
44356464	1115171	2	3
45620106	1738521	0	0
44816277	44816277	0	0
45649962	1125315	0	0
45623061	1124300	0	0
45637480	1125315	0	0
45629316	1119510	0	0
45629809	1124300	0	0
45642658	1177480	0	0
45778402	1332419	2	3
45779154	975125	0	0
45779161	1501700	0	0
45693193	40223768	2	3
45681447	1154615	2	3
45703230	1545958	0	0
45703127	1551099	0	0
45897642	19129655	2	3
45795577	933724	0	0
46288852	1119510	0	0
45688205	1125315	0	0
46291655	1125315	0	0
45794024	1119510	0	0
46314894	1129625	0	0
45894852	1551192	2	3
253549	4142905	4	6
4180941	4199276	2	2
21500582	1154029	4	4
21500561	705944	0	0
21500341	40229134	4	5
36203062	381316	4	4
36159085	1119510	0	0
36300000	4037675	6	9
40786258	3049273	3	3
44356471	19059056	2	3
45620075	1322184	0	0
44816279	44816277	0	0
45649985	1125315	0	0
45623062	1308738	0	0
45637483	1125315	0	0
45629271	1119510	0	0
45629775	1115008	0	0
45642797	1177480	0	0
45661668	1115171	2	3
45779184	975125	0	0
45779163	1174888	0	0
45671526	19078461	2	3
45681284	1115171	2	3
45703240	1551099	0	0
45703147	782043	0	0
45897711	40232448	2	3
45795464	1717327	0	0
46288649	1119510	0	0
45688244	1125315	0	0
46289487	1125315	0	0
45794153	1119510	0	0
46314173	1129625	0	0
45675431	19019273	2	3
4028071	198809	6	6
4040400	4163951	2	2
21500582	1110410	4	4
21500553	1192710	0	0
21500327	1107830	5	5
36203062	4329847	4	4
36158776	1119510	0	0
36300000	4243062	6	8
37622411	381316	3	3
44349379	40232448	2	3
45620201	975125	0	0
44805732	44805732	0	0
45649976	1125315	0	0
45622778	967823	0	0
45637322	1125315	0	0
45628278	1119510	0	0
45629933	1308738	0	0
45640254	1177480	0	0
45661775	40174880	2	3
45778791	975125	0	0
45778790	1501700	0	0
45692448	1332419	2	3
45681521	1115171	2	3
45703382	1112807	0	0
45703242	19127890	0	0
45895289	19019273	2	3
45795485	1000560	0	0
46291629	1119510	0	0
45688355	1125315	0	0
46289317	1125315	0	0
45794772	1119510	0	0
46314192	1129625	0	0
45675333	19019273	2	3
436670	4144583	6	6
4047779	261325	5	8
21500582	1112807	4	4
21003515	1000560	0	0
21500327	1192710	5	5
36203062	4094814	4	4
36159114	1119510	0	0
36300000	4151422	6	6
37622411	321042	3	3
44349357	40231925	2	3
45619965	1309944	0	0
45619686	791967	0	0
45649620	1125315	0	0
45622781	1124957	0	0
45637327	1125315	0	0
45626200	1119510	0	0
45629853	1367571	0	0
45640168	1177480	0	0
45661806	1332419	2	3
45708016	975125	0	0
45779250	738818	0	0
45692702	1107882	2	3
45681317	19008572	2	3
45703521	701322	0	0
45703242	1589505	0	0
45895456	40232448	2	3
45795593	914335	0	0
46291649	1119510	0	0
45688305	1125315	0	0
46288982	1125315	0	0
45794801	1119510	0	0
46314835	1129625	0	0
45650772	1551192	2	3
4162282	4048171	6	6
4047779	4001336	5	8
21500120	40221415	4	4
21004249	738818	0	0
21500327	1153428	5	5
36206173	3049273	4	4
36159122	1119510	0	0
36300000	4062501	7	7
37522284	4337138	3	3
44349417	40232448	2	3
45619876	1129625	0	0
44360447	723013	0	0
45649871	1125315	0	0
45622782	1115008	0	0
45637560	1125315	0	0
45626428	1119510	0	0
45629822	967823	0	0
45640258	1177480	0	0
45661146	40231925	2	3
45707992	975125	0	0
45779189	1174888	0	0
45676251	19078461	2	3
45681560	1127433	2	3
45703255	1310149	0	0
45703242	1549786	0	0
45895368	40165015	2	3
45795661	1124300	0	0
46289097	1119510	0	0
45688431	1125315	0	0
46243494	1125315	0	0
45794313	1119510	0	0
46314690	1129625	0	0
45894821	1107882	2	3
4024567	257012	3	6
4047779	4066995	5	8
4247371	380378	4	4
21004249	1192710	0	0
21500327	1125315	5	5
36203066	4230399	3	3
36159003	1119510	0	0
36300000	40479422	11	14
37520731	4336464	3	3
44349463	19008572	2	3
45619845	1112807	0	0
44360453	738818	0	0
45649957	1125315	0	0
45623119	740275	0	0
45637562	1125315	0	0
45626262	1119510	0	0
45629785	1124957	0	0
45639646	1177480	0	0
45661155	19078924	2	3
45705094	975125	0	0
45779340	1192710	0	0
45673417	19075601	2	3
45679754	40229134	2	3
45703265	975125	0	0
45703164	1149380	0	0
45895480	40232448	2	3
45795666	1549786	0	0
46288982	1119510	0	0
45688375	1125315	0	0
46243597	1125315	0	0
45794282	1119510	0	0
46317745	1129625	0	0
45650645	1551192	2	3
4102111	4285898	3	6
4047779	4237458	5	8
4247371	372328	4	4
21004249	1115008	0	0
21500327	1150836	5	5
36203066	4134304	3	3
36159147	1119510	0	0
36300000	4174876	8	9
37302323	4102123	3	3
44349451	19057271	2	3
45619848	1112807	0	0
44360457	1713332	0	0
45651886	1125315	0	0
45622769	1149196	0	0
45637265	1125315	0	0
45626302	1119510	0	0
45629787	791967	0	0
45639651	1177480	0	0
45661365	19019273	2	3
45633081	1548195	0	0
45779341	1713332	0	0
45680569	40228214	2	3
45679777	19008572	2	3
45703275	1154343	0	0
45703386	967823	0	0
45895385	40232448	2	3
45795666	19127890	0	0
46243599	1119510	0	0
45688169	1125315	0	0
46243598	1125315	0	0
45791453	1119510	0	0
46317093	1129625	0	0
45894954	40223768	2	3
320136	4280726	2	6
4047779	40480160	5	8
4247371	381316	4	4
21004387	1112807	0	0
21500327	1149196	5	5
36203066	4146173	3	3
36158929	1119510	0	0
36300000	4035415	8	12
37521809	4337611	3	3
44349429	1115171	2	3
45619850	1589505	0	0
44360457	1759842	0	0
45652002	1125315	0	0
45623160	1124957	0	0
45637269	1125315	0	0
45626305	1119510	0	0
45629788	701322	0	0
45639652	1177480	0	0
45777849	40229134	2	3
45633084	1124957	0	0
45779178	1110410	0	0
45680773	19078461	2	3
45679759	19057271	2	3
45703586	791967	0	0
45703192	1174888	0	0
45895249	19008572	2	3
45795666	1521369	0	0
46243487	1119510	0	0
45685006	1125315	0	0
46243599	1125315	0	0
45791709	1119510	0	0
46315097	1129625	0	0
45897164	46233988	2	3
4024567	4280726	3	7
4047779	4152936	5	7
21500093	1500211	4	4
21004232	1713332	0	0
35100000	4056621	5	5
36203066	4132546	3	3
36158915	1119510	0	0
36300000	4109685	8	12
37502347	4186930	3	3
44349749	40231925	2	3
45619910	1192710	0	0
44360460	933724	0	0
45651938	1125315	0	0
45623169	1154029	0	0
45637270	1125315	0	0
45626381	1119510	0	0
45629918	1728416	0	0
45639526	1177480	0	0
45777823	40229134	2	3
45633061	1149196	0	0
45779374	1192710	0	0
45677425	19078461	2	3
45697811	19019273	2	3
45703348	1174888	0	0
45703278	1192710	0	0
45895505	40232448	2	3
45795678	1539403	0	0
46243721	1119510	0	0
45684923	1125315	0	0
46243487	1125315	0	0
45791405	1119510	0	0
46315304	1129625	0	0
45897164	46233710	2	3
432795	40480160	7	7
4047779	4266809	5	7
21500136	19128065	4	4
21004249	1174888	0	0
21503650	1125315	5	5
35702124	28060	3	3
36159235	1119510	0	0
36300000	4112343	8	14
37502347	44805732	3	3
44349751	19133905	2	3
45619912	1322184	0	0
44360561	1154029	0	0
45650045	1125315	0	0
45621245	1332418	0	0
45637412	1125315	0	0
45626439	1119510	0	0
45629944	1539403	0	0
45636642	1177480	0	0
45654802	19078461	2	3
45633070	738818	0	0
45779125	19010482	0	0
45705521	19075601	2	3
45696898	920334	2	3
45703547	1778162	0	0
45703282	1107830	0	0
45895487	19008572	2	3
45795597	19010482	0	0
46243638	1119510	0	0
45684981	1125315	0	0
46243625	1125315	0	0
45791685	1119510	0	0
46309601	1129625	0	0
45803688	19075601	2	3
4022922	40479422	6	7
4047779	258780	5	9
21500136	19127918	4	4
21004387	975125	0	0
21503650	19003953	5	5
36002869	433644	3	3
36159082	1119510	0	0
36300000	321042	9	13
40490903	44805732	3	3
44349557	40162522	2	3
45619920	1112807	0	0
44360632	1129625	0	0
45646739	1125315	0	0
45621277	1149196	0	0
45639940	1125315	0	0
45626313	1119510	0	0
45629719	914335	0	0
45636974	1177480	0	0
45654849	19008572	2	3
45633136	1110410	0	0
45778924	791967	0	0
45686956	1332419	2	3
45697017	19133905	2	3
45703630	1107830	0	0
45703108	1729720	0	0
45894537	40162522	2	3
45795684	1548195	0	0
46243512	1119510	0	0
45685105	1125315	0	0
46243638	1125315	0	0
45791554	1119510	0	0
46309862	1129625	0	0
45894790	19078461	2	3
4022922	40479768	6	7
4047779	81893	5	11
21500136	19132304	4	4
21003586	914335	0	0
21503650	1112807	5	5
36002869	4219399	3	3
36159130	1119510	0	0
36300000	28060	9	12
40763497	3013682	3	3
44349660	40232448	2	3
45620001	1107830	0	0
44360651	967823	0	0
45646744	1125315	0	0
45621235	914335	0	0
45640208	1125315	0	0
45623148	1119510	0	0
45629800	1192710	0	0
45637250	1177480	0	0
45654793	40232448	2	3
45633142	738818	0	0
45779075	791967	0	0
45686879	19075601	2	3
45697018	40232448	2	3
45703505	914335	0	0
45703118	1000560	0	0
45803236	43012036	2	3
45795686	1153428	0	0
46243504	1119510	0	0
45685064	1125315	0	0
46243640	1125315	0	0
45791692	1119510	0	0
46309746	1129625	0	0
45894814	40223768	2	3
4024567	261325	4	7
4185115	4336464	5	8
21500136	19127904	4	4
21004249	1119510	0	0
21502584	708298	5	5
36002869	4240902	3	3
36159273	1119510	0	0
36300000	255848	9	12
40763497	3023103	3	3
44349861	40232448	2	3
45619886	738818	0	0
44360691	1332418	0	0
45646745	1125315	0	0
45621218	1149196	0	0
45640029	1125315	0	0
45622983	1119510	0	0
45629804	914335	0	0
45633285	1177480	0	0
45645239	1107882	2	3
45633115	1107830	0	0
45778989	1000560	0	0
45695657	19075601	2	3
45697308	1115171	2	3
45703301	1107830	0	0
45699801	1310149	0	0
45803421	1127433	2	3
45795689	1115008	0	0
46243655	1119510	0	0
45684713	1125315	0	0
46243642	1125315	0	0
45791837	1119510	0	0
46309912	1129625	0	0
45894819	40228214	2	3
4024567	260139	4	7
4180627	4107731	5	8
21500136	19128009	4	4
21004249	1177480	0	0
21502584	1125315	5	5
36002869	37017711	3	3
36159044	1119510	0	0
36300000	198199	9	12
40763497	3016723	3	3
44350046	40229134	2	3
45620126	791967	0	0
44360570	1115008	0	0
45646598	1125315	0	0
45621256	1778162	0	0
45639982	1125315	0	0
45623090	1119510	0	0
45629987	1149380	0	0
45633287	1177480	0	0
45655484	1545959	2	3
45633122	1174888	0	0
45707620	1589505	0	0
45693168	19075601	2	3
45693945	19008572	2	3
45703310	1149196	0	0
45700035	19002770	0	0
45803357	40229134	2	3
45795694	1549786	0	0
46243586	1119510	0	0
45685077	1125315	0	0
46243732	1125315	0	0
45791786	1119510	0	0
46304703	1129625	0	0
45894608	1107882	2	3
4024567	4294548	4	7
4180628	4237458	5	7
21500136	42902245	4	4
21004249	1112807	0	0
21502584	1115008	5	5
36203067	4109685	3	3
36159343	1119510	0	0
36300000	440448	9	14
37219970	317576	3	3
44341796	40232448	2	3
45619838	1177480	0	0
44360575	791967	0	0
45646879	1125315	0	0
45621259	1309944	0	0
45639945	1125315	0	0
45623011	1119510	0	0
45629988	1153428	0	0
45633223	1177480	0	0
45639569	1332419	2	3
45633128	1000560	0	0
45707624	1118084	0	0
45692638	1332419	2	3
45693946	40174880	2	3
45703314	1107830	0	0
45699813	1332418	0	0
45876069	3024561	2	3
45795694	1521369	0	0
46243811	1119510	0	0
45685083	1125315	0	0
46243611	1125315	0	0
45791585	1119510	0	0
46304704	1129625	0	0
45803818	1107882	2	3
4024567	40486433	4	7
4178818	4048171	5	7
21500136	19128263	4	4
21004386	1551099	0	0
21502584	740275	5	5
36203067	4152936	3	3
36159212	1119510	0	0
36300000	442116	9	10
37219970	321042	3	3
44342122	40229134	2	3
45620032	1149196	0	0
44360714	705944	0	0
45647035	1125315	0	0
45621171	1149196	0	0
45640084	1125315	0	0
45623013	1119510	0	0
45629990	1110410	0	0
45633451	1177480	0	0
45630227	1107882	2	3
45633088	1192710	0	0
45707629	1153428	0	0
45680940	19078461	2	3
45693954	40231925	2	3
45703326	1717327	0	0
45700048	1589505	0	0
45803527	40163554	2	3
45796826	1149196	0	0
46243772	1119510	0	0
45685110	1125315	0	0
46243523	1125315	0	0
45791826	1119510	0	0
46304945	1129625	0	0
45675321	1107882	2	3
4180628	40486433	4	7
4178818	4112343	5	7
21500136	40221415	4	4
21004571	914335	0	0
21502584	1119510	5	5
36203067	4296204	3	3
36159363	1119510	0	0
36300000	4169137	9	10
40760929	3013682	3	3
44341873	40162522	2	3
45620216	975125	0	0
44360717	1153428	0	0
45646844	1125315	0	0
45620973	1717327	0	0
45634207	1125315	0	0
45623019	1119510	0	0
45629770	1174888	0	0
45633621	1177480	0	0
45631207	40228214	2	3
45633162	1713332	0	0
45707637	1149196	0	0
45673098	19078461	2	3
45694085	40229134	2	3
45703330	1102527	0	0
45700119	1000560	0	0
45803507	1115171	2	3
45796936	1115008	0	0
46243838	1119510	0	0
45685137	1125315	0	0
46243649	1125315	0	0
45791730	1119510	0	0
46304763	1129625	0	0
45896962	1107882	2	3
4180628	260139	4	7
4043022	4336464	5	7
21500136	19128022	4	4
21004572	975125	0	0
21502584	705944	5	5
36203067	4113008	3	3
36159480	1119510	0	0
36300000	78272	9	15
40760929	3016723	3	3
44342020	1713671	2	3
45620042	1129625	0	0
44360720	1129625	0	0
45646848	1125315	0	0
45620974	723013	0	0
45634181	1125315	0	0
45623249	1119510	0	0
45626917	1310149	0	0
45633308	1177480	0	0
45636950	1539411	2	3
45633149	1521369	0	0
45707638	1343916	0	0
45692382	19078461	2	3
45693743	19018935	2	3
45703442	1107830	0	0
45700125	914335	0	0
45803606	19133873	2	3
45797138	1521369	0	0
46243752	1119510	0	0
45685140	1125315	0	0
46243504	1125315	0	0
45791750	1119510	0	0
46305277	1129625	0	0
45896991	1107882	2	3
4180628	4048695	4	7
4178545	4280726	5	6
21500136	46221626	4	4
21004493	1717327	0	0
21502584	742185	5	5
36203067	4155034	3	3
36159482	1119510	0	0
36300000	433125	10	10
36902266	440086	3	3
44342224	19008572	2	3
45620045	1112807	0	0
44360732	1192710	0	0
45646952	1125315	0	0
45621281	1110410	0	0
45634040	1125315	0	0
45624908	1119510	0	0
45626921	1326303	0	0
45633654	1177480	0	0
45633505	40173590	2	3
45633270	1548195	0	0
45707639	1192710	0	0
45680427	40228214	2	3
45694034	19019273	2	3
45703444	19003953	0	0
45699985	1102527	0	0
45803615	43012036	2	3
45797138	1549786	0	0
46243701	1119510	0	0
45685013	1125315	0	0
46243582	1125315	0	0
45791756	1119510	0	0
46321155	1129625	0	0
46317593	40223768	2	3
253549	81151	4	7
4178545	40486433	5	6
21500175	1557272	4	4
21004249	1149196	0	0
21502584	926487	5	5
36002139	4139681	3	3
36159488	1119510	0	0
36300000	45769019	10	12
37521609	4117038	3	3
44342093	40231925	2	3
45620047	1174888	0	0
44360741	1112807	0	0
45647137	1125315	0	0
45621241	1548195	0	0
45634051	1125315	0	0
45625112	1119510	0	0
45626702	738818	0	0
45633750	1177480	0	0
45666544	40173590	2	3
45633270	1512674	0	0
45707648	1545958	0	0
45692652	40228214	2	3
45694161	19008572	2	3
45703477	1174888	0	0
45700103	1149196	0	0
45803632	1551192	2	3
45796938	1107830	0	0
46243799	1119510	0	0
45685114	1125315	0	0
46243586	1125315	0	0
45791763	1119510	0	0
46321167	1129625	0	0
46313270	40232448	2	3
4012185	4336464	4	7
4180938	4047491	5	6
4229909	4048171	4	4
21004233	1713332	0	0
21503645	1174888	5	5
35802841	40480160	3	3
36159489	1119510	0	0
36300000	4219399	10	11
40789542	3012494	3	3
44342077	46221626	2	3
45620054	738818	0	0
44360896	1129625	0	0
45647245	1125315	0	0
45621269	1115008	0	0
45634149	1125315	0	0
45621629	1119510	0	0
45626985	1332418	0	0
45633698	1177480	0	0
45639680	1107882	2	3
45633173	1115008	0	0
45777908	1000560	0	0
45695718	40228214	2	3
45694016	19133873	2	3
45700219	1192710	0	0
45700239	1310149	0	0
45800836	19132304	2	3
45796947	967823	0	0
46241412	1119510	0	0
45684867	1125315	0	0
46243811	1125315	0	0
45791769	1119510	0	0
46320829	1129625	0	0
46313423	40232448	2	3
432795	4146173	5	7
4180938	42535580	5	6
4299725	4336464	4	4
21004346	1738521	0	0
21503645	1124300	5	5
35802841	4066995	3	3
36159500	1119510	0	0
36300000	313217	10	15
40789542	3006734	3	3
44342163	1551192	2	3
45620057	1177480	0	0
44360697	738818	0	0
45647075	1125315	0	0
45621138	1124300	0	0
45634154	1125315	0	0
45621530	1119510	0	0
45627026	1149196	0	0
45630288	1177480	0	0
45627223	1107882	2	3
45676449	1192710	0	0
45777924	1307863	0	0
45655222	19078461	2	3
45694028	35605482	2	3
45700369	1343916	0	0
45700111	975125	0	0
45801016	1115171	2	3
45796949	1738521	0	0
46241242	1119510	0	0
45685209	1125315	0	0
46243744	1125315	0	0
45789003	1119510	0	0
46321173	1129625	0	0
46313534	40231925	2	3
432795	4142905	5	7
4103662	375671	5	6
4306074	4337138	4	4
21004249	1129625	0	0
21503645	1110410	5	5
36203090	40480160	3	3
36159320	1119510	0	0
36303153	433125	8	8
37521341	4163971	3	3
44342253	19074843	2	3
45620060	1112807	0	0
44360672	1112807	0	0
45647080	1125315	0	0
45621142	1713332	0	0
45634398	1125315	0	0
45621664	1119510	0	0
45626699	1192710	0	0
45630474	1177480	0	0
45654781	19078461	2	3
45676781	1107830	0	0
45777862	1124300	0	0
45779408	1332419	2	3
45694896	40231925	2	3
45700401	1307863	0	0
45699933	1501700	0	0
45801074	40163554	2	3
45796952	1115008	0	0
46241313	1119510	0	0
45685840	1125315	0	0
46243766	1125315	0	0
45789006	1119510	0	0
46321184	1129625	0	0
46313331	1115171	2	3
4180628	133834	5	7
4103662	378001	5	6
4247120	81893	4	4
21004346	1728416	0	0
21503645	1112807	5	5
36203060	4146173	3	3
36159327	1119510	0	0
36303153	45769019	8	10
37220016	40486433	3	3
44342375	19073183	2	3
45620064	1177480	0	0
44360673	1192710	0	0
45647114	1125315	0	0
45621220	1539403	0	0
45634399	1125315	0	0
45621862	1119510	0	0
45626841	1192710	0	0
45630402	1177480	0	0
45648127	1332419	2	3
45676395	1110410	0	0
45777864	1343916	0	0
45690064	40228214	2	3
45690950	19018935	2	3
45700445	1549786	0	0
45699935	1192710	0	0
45800887	19008572	2	3
45797073	1738521	0	0
46241474	1119510	0	0
45685887	1125315	0	0
46243772	1125315	0	0
45789053	1119510	0	0
46321194	1129625	0	0
46313501	1115171	2	3
4180628	4149245	5	7
4115390	313217	5	6
21505881	40173590	4	5
21004496	1717327	0	0
21502620	1778162	5	5
36000000	439406	3	3
36159582	1119510	0	0
36303153	433644	8	9
37220016	4280726	3	3
44337822	1107882	2	3
45620064	1129625	0	0
44360674	1322184	0	0
45647142	1125315	0	0
45621296	1115008	0	0
45634506	1125315	0	0
45667317	1119510	0	0
45626968	1154029	0	0
45630691	1177480	0	0
45642624	1332419	2	3
45676401	933724	0	0
45692516	1125315	0	0
45781730	40228230	2	3
45690951	19008572	2	3
45700445	19127890	0	0
45699936	715997	0	0
45801183	19019273	2	3
45795701	1000560	0	0
46241335	1119510	0	0
45681890	1125315	0	0
46243834	1125315	0	0
45788941	1119510	0	0
46321080	1129625	0	0
46313544	40232448	2	3
4024567	258780	5	8
4103320	4048171	5	6
21500121	1551192	4	5
21004497	1717327	0	0
21502620	1728416	5	5
36000000	133834	3	3
36159585	1119510	0	0
36303153	40486433	7	12
37502339	4197460	3	3
44337826	40223834	2	3
45620111	1177480	0	0
44360699	1539403	0	0
45647152	1125315	0	0
45621267	1343916	0	0
45634507	1125315	0	0
45667491	1119510	0	0
45626819	1174888	0	0
45630758	1177480	0	0
45649225	1332419	2	3
45676454	1551099	0	0
45692519	1125315	0	0
45781730	40228214	2	3
45691060	40174880	2	3
45700445	1589505	0	0
45700153	967823	0	0
45799770	40229134	2	3
45795711	1118084	0	0
46241339	1119510	0	0
45682155	1125315	0	0
46243685	1125315	0	0
45789144	1119510	0	0
46320954	1129625	0	0
46314215	1115171	2	3
4024567	4048171	5	8
4027403	4337611	5	6
21501218	19079524	4	5
21001849	1713332	0	0
21502620	1746114	5	5
35902851	196456	3	3
36159614	1119510	0	0
36303153	4139681	7	8
37219785	258780	3	3
44337838	40236824	2	3
45619894	1115008	0	0
44360702	1551099	0	0
45646987	1125315	0	0
45621304	1000560	0	0
45634336	1125315	0	0
45665342	1119510	0	0
45626977	1545958	0	0
45627635	1177480	0	0
45660666	19078461	2	3
45676458	738818	0	0
45692604	1125315	0	0
45692386	1539411	2	3
45691039	1310034	2	3
45700447	1124300	0	0
45700159	1308738	0	0
45799771	1115171	2	3
45795719	1322184	0	0
46241351	1119510	0	0
45681967	1125315	0	0
46243838	1125315	0	0
45789138	1119510	0	0
46320967	1129625	0	0
46313945	1115171	2	3
432795	378001	5	8
4040392	4117038	5	6
4208786	4237458	4	5
21001857	1137529	0	0
21502620	1713332	5	5
21602567	19128065	3	3
36151143	1119510	0	0
36303153	442116	7	8
37219785	261325	3	3
44337847	1115171	2	3
45619896	791967	0	0
44360703	920293	0	0
45646993	1125315	0	0
45621307	1501700	0	0
45634241	1125315	0	0
45665165	1119510	0	0
45626962	1551099	0	0
45627655	1177480	0	0
45636594	19075601	2	3
45676845	1310149	0	0
45692390	1125315	0	0
45683943	40228214	2	3
45691206	40229134	2	3
45700305	914335	0	0
45699994	1713332	0	0
45799709	1332419	2	3
45792994	1174888	0	0
46241517	1119510	0	0
45682026	1125315	0	0
46243752	1125315	0	0
46301961	1119510	0	0
46321582	1129625	0	0
46313959	40231925	2	3
4024567	4112343	4	8
4042836	375671	5	6
4208786	4142905	4	5
21001857	1149380	0	0
21502620	1729720	5	5
36211375	4001336	3	3
36151146	1119510	0	0
36303153	4047491	7	8
40789541	3020655	3	3
44337684	19059056	2	3
45620092	1129625	0	0
44360857	1177480	0	0
45646994	1125315	0	0
45622168	1713332	0	0
45634341	1125315	0	0
45665306	1119510	0	0
45626939	1107830	0	0
45627686	1177480	0	0
45661221	1332419	2	3
45676981	1539403	0	0
45692655	1125315	0	0
45781780	19079524	2	3
45691188	1539411	2	3
45700324	1107830	0	0
45700004	723013	0	0
45799751	40162522	2	3
45792995	1738521	0	0
46241574	1119510	0	0
45682053	1125315	0	0
46243701	1125315	0	0
46301965	1119510	0	0
46321585	1129625	0	0
46313902	19019273	2	3
4028071	440448	7	7
4042836	4048171	5	6
4297887	4112343	4	5
21001842	1768849	0	0
21502620	1741122	5	5
21602627	933724	3	3
36151292	1119510	0	0
36303153	4048695	7	11
40786244	3009201	3	3
44363316	1127433	2	3
45620105	1137529	0	0
44360842	1177480	0	0
45647087	1125315	0	0
45621922	1361711	0	0
45634313	1125315	0	0
45665399	1119510	0	0
45627008	1549786	0	0
45624460	1177480	0	0
45668446	40228214	2	3
45676990	1310149	0	0
45692550	1125315	0	0
45682455	40228214	2	3
45691028	40163554	2	3
45700222	1107830	0	0
45700005	967823	0	0
45798171	40232448	2	3
45793001	1729720	0	0
46241655	1119510	0	0
45682060	1125315	0	0
46243817	1125315	0	0
46301827	1119510	0	0
46321588	1129625	0	0
46308405	46233710	2	3
4028071	313217	5	8
4154161	78272	5	5
4297887	4285898	4	5
21001860	975125	0	0
21502620	1768849	5	5
35902136	196456	3	3
36152440	1119510	0	0
36303153	321042	7	11
42889666	4066995	3	3
44363708	19018935	2	3
44777976	1149196	0	0
44360875	1129625	0	0
45647004	1125315	0	0
45621947	740275	0	0
45634471	1125315	0	0
45665380	1119510	0	0
45627008	1521369	0	0
45624488	1177480	0	0
45636508	40228214	2	3
45676994	1174888	0	0
45692615	1125315	0	0
45674495	40228214	2	3
45691129	19008572	2	3
45700374	1589505	0	0
45700104	1539403	0	0
45798407	1115171	2	3
45792981	1332418	0	0
46241556	1119510	0	0
45682067	1125315	0	0
46243902	1125315	0	0
46301801	1119510	0	0
46321589	1129625	0	0
46308049	1115171	2	3
255919	257012	5	7
4179141	78272	5	5
4247371	4132546	4	5
21001866	1551099	0	0
21502620	933724	5	5
36203042	4059173	3	3
36152277	1119510	0	0
36303153	255848	7	10
42889666	4048695	3	3
44363717	40236824	2	3
44777982	1738521	0	0
44360656	1118084	0	0
45647211	1125315	0	0
45621948	1124957	0	0
45634638	1125315	0	0
45665242	1119510	0	0
45627016	1310149	0	0
45624639	1177480	0	0
45624156	19075601	2	3
45676997	1549786	0	0
45692705	1125315	0	0
45783977	40228214	2	3
45688115	40162522	2	3
45700374	1549786	0	0
45700084	1115008	0	0
45798069	40229134	2	3
45792920	967823	0	0
46241613	1119510	0	0
45682092	1125315	0	0
46243779	1125315	0	0
46301887	1119510	0	0
46315694	1129625	0	0
46308517	19073183	2	3
255919	4112343	5	8
4154162	378001	5	5
21500562	19077572	4	5
21001849	1768849	0	0
21502620	1717327	5	5
36203042	4048695	3	3
36152284	1119510	0	0
36303153	381316	6	9
40786225	3013721	3	3
44363412	19059056	2	3
44777990	1124957	0	0
44360490	1177480	0	0
45647230	1125315	0	0
45621954	1174888	0	0
45634585	1125315	0	0
45665247	1119510	0	0
45628023	1501700	0	0
45624530	1177480	0	0
45666805	19078461	2	3
45676997	1589505	0	0
45692546	1125315	0	0
45680669	19079524	2	3
45688115	19133768	2	3
45700380	708298	0	0
45699926	967823	0	0
45798130	19008572	2	3
45792921	1713332	0	0
46241529	1119510	0	0
45682108	1125315	0	0
46243791	1125315	0	0
46302174	1119510	0	0
46316026	1129625	0	0
46308568	1551192	2	3
255919	40486433	6	8
4154162	375671	5	5
21500562	40222846	4	5
21001866	975125	0	0
21604489	19115351	4	4
35702767	4027663	3	3
36152287	1119510	0	0
36303153	4112343	6	12
37503997	4202451	3	3
44363417	920300	2	3
44777995	1124300	0	0
44360469	1129625	0	0
45647237	1125315	0	0
45622048	753626	0	0
45634276	1125315	0	0
45667429	1119510	0	0
45628030	914335	0	0
45624807	1177480	0	0
45624760	19075601	2	3
45676542	1343916	0	0
45692669	1125315	0	0
45677662	19078461	2	3
45688065	40232448	2	3
45700458	19010482	0	0
45700236	1713332	0	0
45798261	40229134	2	3
45792853	1115008	0	0
46238795	1119510	0	0
45682118	1125315	0	0
46243799	1125315	0	0
46302046	1119510	0	0
46315963	1129625	0	0
46308194	40174880	2	3
255919	378419	6	7
4180938	4202451	5	5
21500562	836659	4	5
21001878	1137529	0	0
21604489	723013	3	3
21602551	19127922	3	3
36152397	1119510	0	0
36303153	40479422	9	12
37521376	4330583	3	3
44363530	1127433	2	3
44777996	1112807	0	0
44360646	1000560	0	0
45645894	1125315	0	0
45621321	1118084	0	0
45634526	1125315	0	0
45667275	1119510	0	0
45628073	1149196	0	0
45624995	1177480	0	0
45666721	40223768	2	3
45676722	1548195	0	0
45692681	1125315	0	0
45692822	40228214	2	3
45688151	19078461	2	3
45700229	1112807	0	0
45700088	1501700	0	0
45798397	40229134	2	3
45793134	1115008	0	0
46238546	1119510	0	0
45682277	1125315	0	0
46243804	1125315	0	0
46302141	1119510	0	0
46315964	1129625	0	0
46308311	40229134	2	3
1107882	1107882	0	0
4040559	4163971	5	5
21500595	19078461	4	5
21001878	1149380	0	0
21604489	791967	3	3
21602551	19133679	3	3
36151398	1119510	0	0
36303153	4062501	5	5
42889648	378001	3	3
44363573	40232448	2	3
44777998	1124300	0	0
44360790	1124957	0	0
45645860	1125315	0	0
45621417	1549786	0	0
45634372	1125315	0	0
45662909	1119510	0	0
45628210	738818	0	0
45624998	1177480	0	0
45657997	40228214	2	3
45676462	1332418	0	0
45692694	1125315	0	0
45655014	40228214	2	3
45688323	920334	2	3
45700463	1361711	0	0
45700350	1308738	0	0
45798290	1107882	2	3
45793137	1174888	0	0
46238828	1119510	0	0
45682343	1125315	0	0
46243921	1125315	0	0
46299549	1119510	0	0
46315749	1129625	0	0
46308616	46275444	2	3
1580874	1000560	0	0
4154739	4134304	5	5
21500595	19019273	4	5
21001848	1713332	0	0
21604489	708298	3	3
21602551	19129144	3	3
36151458	1119510	0	0
36303153	4024958	5	6
42889648	375671	3	3
44363624	40229134	2	3
44778029	1177480	0	0
44360818	1305058	0	0
45643853	1125315	0	0
45621417	1521369	0	0
45634619	1125315	0	0
45662915	1119510	0	0
45628214	1557272	0	0
45624742	1177480	0	0
45645385	40228214	2	3
45676767	920293	0	0
45692709	1125315	0	0
45705338	19078461	2	3
45688333	1115171	2	3
45700498	1112807	0	0
45700207	1307863	0	0
45798412	19019273	2	3
45793137	1192710	0	0
46238829	1119510	0	0
45682460	1125315	0	0
46243922	1125315	0	0
46299384	1119510	0	0
46316038	1129625	0	0
46308692	40229134	2	3
1580858	1332418	0	0
4180627	4037675	5	5
4326426	4117038	4	5
21001848	1778162	0	0
21604489	19057271	3	6
21604034	1124300	3	3
36151496	1119510	0	0
36303153	4066995	5	11
37203783	4048171	3	3
44363553	1551192	2	3
44778007	933724	0	0
44360658	975125	0	0
45643855	1125315	0	0
45621342	1115008	0	0
45634620	1125315	0	0
45662966	1119510	0	0
45628216	723013	0	0
45668945	1177480	0	0
45666870	40228214	2	3
45676918	715997	0	0
45692716	1125315	0	0
45705491	40223768	2	3
45688194	19008572	2	3
45700327	1149196	0	0
45700363	1115008	0	0
45798300	19133905	2	3
45793140	967823	0	0
46238830	1119510	0	0
45682220	1125315	0	0
46241412	1125315	0	0
46299553	1119510	0	0
46315997	1129625	0	0
46308647	19008572	2	3
1580860	1115008	0	0
4042641	40492359	5	5
4322976	4186930	4	8
21001848	1717327	0	0
21604489	19076374	3	6
21604034	1177480	3	3
36151472	1119510	0	0
36303153	198809	5	11
37219939	258780	3	3
44363982	19008572	2	3
44778120	1129625	0	0
44360604	1112807	0	0
45643860	1125315	0	0
45621611	1124300	0	0
45634377	1125315	0	0
45662706	1119510	0	0
45628217	1549786	0	0
45668878	1177480	0	0
45666138	19078461	2	3
45676804	791967	0	0
45692620	1125315	0	0
45781381	19078461	2	3
45688355	19133768	2	3
45700335	1107830	0	0
45700355	967823	0	0
45798300	19133873	2	3
45793106	1174888	0	0
46238831	1119510	0	0
45682000	1125315	0	0
46241481	1125315	0	0
46299396	1119510	0	0
46312011	1129625	0	0
46312357	19126352	2	3
1580939	1501700	0	0
4041285	45769019	5	5
4322976	4107731	4	9
21001874	1551099	0	0
21604489	19078924	3	6
36203055	4001336	3	3
36151424	1119510	0	0
36303153	4043241	4	13
40789521	3036780	3	3
44356620	1127433	2	3
44778130	1729720	0	0
44360606	738818	0	0
45643926	1125315	0	0
45621732	1310149	0	0
45634386	1125315	0	0
45662850	1119510	0	0
45628217	1521369	0	0
45670398	1177480	0	0
45635087	40228214	2	3
45676491	1728416	0	0
45692701	1125315	0	0
45783714	40223768	2	3
45685164	1115171	2	3
45700337	19010482	0	0
45700489	1192710	0	0
45798424	1713671	2	3
45792866	1326303	0	0
46238561	1119510	0	0
45682369	1125315	0	0
46241313	1125315	0	0
46299205	1119510	0	0
46310305	1129625	0	0
46303166	1115171	2	3
1580942	1367571	0	0
4047779	4113008	5	5
4322976	40492359	4	10
21001882	1551099	0	0
21605007	1192710	4	4
36002872	4048171	3	3
36151748	1119510	0	0
36303153	4181917	4	5
40760921	3019550	3	3
44356751	19019273	2	3
44778131	1118084	0	0
44360620	1713332	0	0
45643866	1125315	0	0
45621426	1174888	0	0
45634607	1125315	0	0
45662863	1119510	0	0
45628217	1595799	0	0
45666565	1177480	0	0
45683497	40236446	2	3
45676916	1713332	0	0
45689581	1125315	0	0
45680785	40223768	2	3
45685064	40229134	2	3
45700342	1112807	0	0
45700286	1501700	0	0
45795455	40223834	2	3
45792867	1153428	0	0
46238760	1119510	0	0
45682176	1125315	0	0
46241315	1125315	0	0
46299240	1119510	0	0
46310372	1129625	0	0
45650532	19115351	1	1
1580779	1595799	0	0
4047779	4155034	5	5
4274025	4294548	4	9
21001879	1551099	0	0
21605007	1125443	4	4
36009725	4280726	3	3
36151750	1119510	0	0
36313966	198809	4	10
37203786	28060	2	3
44357096	19073183	2	3
44778030	1501700	0	0
44361161	1307863	0	0
45643928	1125315	0	0
45621323	1551099	0	0
45631284	1125315	0	0
45662974	1119510	0	0
45628224	1110410	0	0
45666596	1177480	0	0
45683504	19019273	2	3
45676805	738818	0	0
45689587	1125315	0	0
45705305	1332419	2	3
45685013	19133768	2	3
45700349	1154343	0	0
45700433	1308738	0	0
45795572	1332419	2	3
45793069	1112807	0	0
46238761	1119510	0	0
45682182	1125315	0	0
46241462	1125315	0	0
46299243	1119510	0	0
46310490	1129625	0	0
45897273	40223774	1	1
1580779	1521369	0	0
4178545	28060	5	5
4274025	378419	4	9
21001876	1149380	0	0
21605007	1119510	4	4
36009725	40486433	3	3
36151546	1119510	0	0
36313966	80180	4	6
37220048	4112343	2	3
44357010	19075001	2	3
44361607	1713332	0	0
44360885	738818	0	0
45643876	1125315	0	0
45621326	1521369	0	0
45631359	1125315	0	0
45664639	1119510	0	0
45628064	967823	0	0
45666552	1177480	0	0
45685493	40174880	2	3
45676818	1738521	0	0
45689123	1125315	0	0
45686733	19078461	2	3
45685222	19077572	2	3
45700467	1115008	0	0
45697843	1149196	0	0
45795416	1332419	2	3
45793077	1112807	0	0
46238809	1119510	0	0
45678634	1125315	0	0
46241474	1125315	0	0
46299247	1119510	0	0
46305306	1129625	0	0
46308205	46275916	1	1
1580876	975125	0	0
4178545	40481087	5	5
4274025	381316	4	7
21001871	1551099	0	0
21605007	1150770	4	4
36009869	4048171	3	3
36151591	1119510	0	0
36313966	4296204	6	9
40760921	3023103	2	3
44349779	19008572	2	3
44361327	1115008	0	0
44360890	791967	0	0
45643931	1125315	0	0
45621326	1549786	0	0
45631027	1125315	0	0
45664555	1119510	0	0
45627061	1149196	0	0
45666646	1177480	0	0
45685497	40232448	2	3
45676897	1192710	0	0
45689423	1125315	0	0
45683821	19078461	2	3
45685507	19077572	2	3
45700069	1118084	0	0
45697677	1521369	0	0
45795689	1115171	2	3
45792844	1717327	0	0
46239916	1119510	0	0
45678912	1125315	0	0
46241321	1125315	0	0
46299522	1119510	0	0
46305126	1129625	0	0
46303372	46275916	1	1
1580880	1115008	0	0
4178545	257012	5	5
4274025	195588	4	8
21001848	1768849	0	0
21605007	1150836	4	4
35902853	198809	3	3
36151592	1119510	0	0
36313966	4230399	6	11
37219945	4051466	2	3
44349794	40229134	2	3
44361611	1343916	0	0
44361077	738818	0	0
45643969	1125315	0	0
45621326	1595799	0	0
45631091	1125315	0	0
45664655	1119510	0	0
45627038	1154343	0	0
45666852	1177480	0	0
45680237	1551192	2	3
45676501	1124300	0	0
45691470	1125315	0	0
45692618	19078461	2	3
45685780	19078924	2	3
45700506	1124300	0	0
45697611	1549786	0	0
45796925	40229134	2	3
45792947	1332418	0	0
45897657	1119510	0	0
45678743	1125315	0	0
46241433	1125315	0	0
46299251	1119510	0	0
46305466	1129625	0	0
46309096	46275916	1	1
1580962	1149196	0	0
4103352	40486433	5	5
4274025	30753	4	8
21001900	1110410	0	0
21605007	1153428	4	4
35909435	198809	3	3
36151683	1119510	0	0
36313966	440448	6	11
36902269	378419	1	3
44349474	19008572	2	3
44361613	1310149	0	0
44361015	1149196	0	0
45643946	1125315	0	0
45621381	1154343	0	0
45631295	1125315	0	0
45664436	1119510	0	0
45627041	708298	0	0
45666805	1177480	0	0
45680090	40229134	2	3
45676880	1149196	0	0
45691621	1125315	0	0
45684135	19078461	2	3
45685718	920334	2	3
45700507	1192710	0	0
45697611	1589505	0	0
45796936	1115171	2	3
45792958	1124300	0	0
45897755	1119510	0	0
45678744	1125315	0	0
46241363	1125315	0	0
46301578	1119510	0	0
46305490	1129625	0	0
46307114	19079524	1	1
1580964	1129625	0	0
4103352	4280726	5	5
4247371	257012	4	6
21001853	1713332	0	0
21605007	1150837	4	7
36202157	4149245	3	4
36151779	1119510	0	0
36313966	4306014	6	7
37502350	4337138	2	4
44349475	40231925	2	3
44361622	738818	0	0
44360828	738818	0	0
45643939	1125315	0	0
45664835	738818	0	0
45631316	1125315	0	0
45663016	1119510	0	0
45627063	1115008	0	0
45664263	1177480	0	0
45680295	40229134	2	3
45676688	1713332	0	0
45691489	1125315	0	0
45686801	19078461	2	3
45685725	19008572	2	3
45700170	1367571	0	0
45697611	19127890	0	0
45797137	1545959	2	3
45793163	1153428	0	0
45897839	1119510	0	0
45678746	1125315	0	0
46241339	1125315	0	0
46301581	1119510	0	0
46306699	1129625	0	0
44361246	1125315	0	0
1580906	1539403	0	0
4043017	4337138	5	5
4247371	40481087	4	6
21001888	1738521	0	0
21605007	19029476	4	7
36000000	80809	3	4
36151852	1119510	0	0
36313966	4048169	6	7
42888893	40480160	4	4
44349976	40232448	2	3
44361601	1729720	0	0
44360833	1112807	0	0
45643891	1125315	0	0
45664898	723013	0	0
45633925	1125315	0	0
45659787	1119510	0	0
45627045	791967	0	0
45664204	1177480	0	0
45680380	1115171	2	3
45676688	1759842	0	0
45691606	1125315	0	0
45654841	19078461	2	3
45685731	40174880	2	3
45700257	1326303	0	0
45697809	1124300	0	0
45792994	40162522	2	3
45793166	1174888	0	0
45897866	1119510	0	0
45699779	46275916	1	1
46241341	1125315	0	0
46295371	1119510	0	0
46321686	1129625	0	0
44361247	1125315	0	0
1580916	1367571	0	0
4043018	4242997	5	5
4326426	4336464	4	6
21001890	1728416	0	0
21605007	19125062	4	7
35702761	4285898	3	4
36198912	1119510	0	0
36313966	4296205	6	6
37522278	4043071	4	4
44350088	40229134	2	3
44361502	1545958	0	0
44360629	1129625	0	0
45643912	1125315	0	0
45664909	1107830	0	0
45633899	1125315	0	0
45659599	1119510	0	0
45627083	1778162	0	0
45664534	1177480	0	0
45680407	19073188	2	3
45676769	791967	0	0
45691610	1125315	0	0
45686865	19078461	2	3
45685733	1551192	2	3
45700422	1112807	0	0
45697811	1115008	0	0
45792995	46233710	2	3
45793068	1110410	0	0
45897734	1119510	0	0
45688630	46275916	1	1
46241348	1125315	0	0
46295741	1119510	0	0
46321698	1129625	0	0
44361249	1125315	0	0
1580813	1361711	0	0
4180628	380378	5	5
4297090	4202451	3	6
21001891	1728416	0	0
21605007	43012036	4	7
35702778	81893	3	4
36198916	1119510	0	0
36313966	433125	7	7
37103722	4116491	3	4
44350077	19078461	2	3
44361508	1713332	0	0
44360630	1115008	0	0
45644067	1125315	0	0
45664878	1326303	0	0
45633823	1125315	0	0
45659534	1119510	0	0
45627071	1501700	0	0
45660971	1177480	0	0
45680392	19075601	2	3
45677048	1153428	0	0
45691613	1125315	0	0
45783725	19078461	2	3
45682153	1332419	2	3
45896815	1549786	0	0
45697774	967823	0	0
45793001	19133905	2	3
45793061	1149196	0	0
45897821	1119510	0	0
45694031	46275916	1	1
46241404	1125315	0	0
46296037	1119510	0	0
46321871	1129625	0	0
45650724	1125315	0	0
1580821	1154343	0	0
4180628	4144583	5	5
4297090	4015189	3	6
21001920	1154343	0	0
21605007	40223834	4	7
36203056	4142905	3	4
36159654	1119510	0	0
36313966	433644	7	8
42888893	4066995	3	4
44349839	40162522	2	3
44361627	1124300	0	0
44361039	1174888	0	0
45644070	1125315	0	0
45664934	738818	0	0
45633901	1125315	0	0
45659490	1119510	0	0
45627072	1149196	0	0
45661437	1177480	0	0
45680484	1115171	2	3
45676953	1174888	0	0
45691661	1125315	0	0
45701779	19078461	2	3
45682101	19008572	2	3
45896815	1521369	0	0
45697682	1713332	0	0
45793005	40232448	2	3
45793063	1741122	0	0
45897918	1119510	0	0
45706039	19079524	1	1
46241359	1125315	0	0
46296052	1119510	0	0
46315738	1129625	0	0
45650541	1125315	0	0
1580827	914335	0	0
4028071	260139	5	5
4208786	81151	3	6
21001922	1137529	0	0
21605007	40223821	4	7
35702767	4310024	3	4
36198892	1119510	0	0
36313966	4219399	7	8
37219970	4329847	3	4
44350150	40231925	2	3
44362743	1521369	0	0
44361041	1521369	0	0
45643915	1125315	0	0
45665008	1154029	0	0
45633842	1125315	0	0
45659493	1119510	0	0
45627055	1153428	0	0
45661644	1177480	0	0
45680497	19133768	2	3
45676954	1124300	0	0
45691624	1125315	0	0
45680590	19078461	2	3
45682106	1545959	2	3
45896820	1174888	0	0
45697798	1124300	0	0
45792852	1127433	2	3
45793063	1746114	0	0
45897764	1119510	0	0
45700603	19079524	1	1
46241446	1125315	0	0
46296246	1119510	0	0
46316286	1129625	0	0
45650281	1125315	0	0
1580830	1124300	0	0
4028071	196456	5	5
4274025	44782520	3	6
21001922	1154343	0	0
21605007	40228214	4	7
35702767	4266809	3	4
36198843	1119510	0	0
36313966	313217	7	12
37220041	4112343	3	4
44342506	40169281	2	3
44362751	1177480	0	0
44361041	1595799	0	0
45644046	1125315	0	0
45665081	1501700	0	0
45633844	1125315	0	0
45659701	1119510	0	0
45623810	1548195	0	0
45661370	1177480	0	0
45680365	1115171	2	3
45676955	1149196	0	0
45689713	1125315	0	0
45684220	19078461	2	3
45682036	19008572	2	3
45896821	1343916	0	0
45696898	920293	0	0
45792853	1115171	2	3
45793065	1713332	0	0
45897853	1119510	0	0
45684832	19127922	1	1
46241547	1125315	0	0
46295685	1119510	0	0
46316357	1129625	0	0
45650836	1125315	0	0
1580838	967823	0	0
4178818	40481087	5	5
4274025	257012	3	8
21001903	1551099	0	0
21605007	40229134	6	7
35702767	30753	3	4
36198941	1119510	0	0
35800000	375671	9	11
37521144	4108705	3	4
44342408	19073183	2	3
44362755	791967	0	0
44361041	1549786	0	0
45644015	1125315	0	0
45665083	1124957	0	0
45633946	1125315	0	0
45659853	1119510	0	0
45623818	1545958	0	0
45661176	1177480	0	0
45680356	19079524	2	3
45676958	738818	0	0
45689719	1125315	0	0
45698685	40174880	2	3
45682118	1127433	2	3
45896900	1713332	0	0
45696939	1192710	0	0
45793134	1115171	2	3
45793065	1759842	0	0
45897958	1119510	0	0
45684832	19133679	1	1
46241548	1125315	0	0
46295602	1119510	0	0
46316368	1129625	0	0
45650733	1125315	0	0
1580844	1332418	0	0
4178818	255848	5	5
4247371	4283893	3	5
21001877	1154343	0	0
21605007	40162522	6	7
21602819	1713671	3	4
36198946	1119510	0	0
35800000	257012	8	10
37102306	45769019	3	4
44342414	46275916	2	3
44362758	1177480	0	0
44361043	1512674	0	0
45644096	1125315	0	0
45664881	1115008	0	0
45631382	1125315	0	0
45659935	1119510	0	0
45623924	1310149	0	0
45661267	1177480	0	0
45680685	40228230	2	3
45676961	1310149	0	0
45689702	1125315	0	0
45686915	19078461	2	3
45682277	1127433	2	3
45896869	1107830	0	0
45696961	1367571	0	0
45792839	40232448	2	3
45793081	975125	0	0
45897960	1119510	0	0
45684832	19129144	1	1
46241495	1125315	0	0
46296425	1119510	0	0
46316062	1129625	0	0
45650736	1125315	0	0
1580847	1332418	0	0
4178818	257012	5	5
4208786	40480160	3	5
21001883	1728416	0	0
21605007	40232448	6	7
21602819	46275444	3	4
36198983	1119510	0	0
35800000	4132546	7	9
40760929	3023103	3	4
44342518	1127433	2	3
44362793	1177480	0	0
44361043	1549786	0	0
45644225	1125315	0	0
45664886	1551099	0	0
45631424	1125315	0	0
45656923	1119510	0	0
45623690	740275	0	0
45661278	1177480	0	0
45677086	19008572	2	3
45676964	1124957	0	0
45689703	1125315	0	0
45690050	19078461	2	3
45682251	19073183	2	3
45896851	1118084	0	0
45696942	1713332	0	0
45793203	40223768	2	3
45793209	1107830	0	0
45897990	1119510	0	0
45681820	19089061	1	1
46241517	1125315	0	0
46291237	1119510	0	0
46316660	1129625	0	0
45650467	1125315	0	0
1580955	715997	0	0
4043022	42535580	5	5
4269838	4108705	3	5
21001935	967823	0	0
21605007	19133768	6	7
21602627	40236824	3	6
36151812	1119510	0	0
35800000	40486433	6	11
37522308	4336464	3	4
44342551	40228230	2	3
44362796	1112807	0	0
44361044	933724	0	0
45644232	1125315	0	0
45664940	1153428	0	0
45631505	1125315	0	0
45656693	1119510	0	0
45623945	1115008	0	0
45654781	1177480	0	0
45677007	19019273	2	3
45676965	1501700	0	0
45689797	1125315	0	0
45701855	19078461	2	3
45682198	19019273	2	3
45896908	1112807	0	0
45696912	1192710	0	0
45792956	40232448	2	3
45793241	1549786	0	0
45897932	1119510	0	0
45672770	19074679	1	1
46241450	1125315	0	0
46291135	1119510	0	0
46316182	1129625	0	0
45650764	1125315	0	0
1588689	1512674	0	0
4043022	4323902	5	5
21500563	40223768	3	4
21001900	914335	0	0
21604180	40236446	4	7
36203062	4296204	3	6
36151819	1119510	0	0
35800000	4280726	6	11
37219945	441267	3	4
44342541	19019273	2	3
44362799	1129625	0	0
44361048	1129625	0	0
45641216	1125315	0	0
45664849	1717327	0	0
45631662	1125315	0	0
45656695	1119510	0	0
45624068	1174888	0	0
45634974	1129625	0	0
45679392	40223768	2	3
45677019	1539403	0	0
45689765	1125315	0	0
45699093	19078461	2	3
45682465	19018935	2	3
45697106	975125	0	0
45696962	791967	0	0
45793163	40223834	2	3
45793223	1713332	0	0
45895500	1119510	0	0
45772679	4304110	1	1
46241571	1125315	0	0
46291136	1119510	0	0
46316188	1129625	0	0
45650812	1125315	0	0
1589505	1589505	0	0
4274025	80180	3	5
21500563	836659	3	4
21001909	1551099	0	0
21604180	782047	4	7
35702738	4027663	3	6
36151803	1119510	0	0
35800000	4285898	6	9
37622411	317576	3	4
44342707	19133873	2	3
44362608	1322184	0	0
44361059	1149380	0	0
45640901	1125315	0	0
45665090	705944	0	0
45631665	1125315	0	0
45656700	1119510	0	0
45624072	1192710	0	0
45634895	1129625	0	0
45677173	35605482	2	3
45676941	738818	0	0
45689731	1125315	0	0
45680703	19078461	2	3
45678937	19125062	2	3
45697088	1149196	0	0
45696989	1154343	0	0
45793166	40162522	2	3
45793223	1759842	0	0
45895463	1119510	0	0
45703785	19079524	1	1
46241574	1125315	0	0
46291137	1119510	0	0
46310688	1129625	0	0
45650823	1125315	0	0
1367571	1367571	0	0
4274025	4066995	3	9
21500563	40222846	3	4
21001853	1759842	0	0
21604180	40222846	4	7
36100000	260139	3	5
36151719	1119510	0	0
35800000	4043241	11	12
37622411	4329847	3	4
43531392	4238715	2	3
45619689	1119510	0	0
44360755	1192710	0	0
45641227	1125315	0	0
45665092	1310149	0	0
45631384	1125315	0	0
45656710	1119510	0	0
45623806	1778162	0	0
45635051	1129625	0	0
45677144	1127433	2	3
45677094	19010482	0	0
45689842	1125315	0	0
45692532	19078461	2	3
45678867	43012036	2	3
45697096	1149380	0	0
45697008	1154029	0	0
45793215	40232448	2	3
45793241	1521369	0	0
45895536	1119510	0	0
45697864	46275916	1	1
46241453	1125315	0	0
46291142	1119510	0	0
46305655	1129625	0	0
45650683	1125315	0	0
1110410	1110410	0	0
4274025	40480160	3	9
21500563	19077572	3	4
21001875	1551099	0	0
21604180	40231925	6	7
36203062	4142905	3	8
36151828	1119510	0	0
36427861	1551099	0	0
37520685	44783196	4	4
44784217	313217	2	3
45619693	1119510	0	0
44361016	1124300	0	0
45641012	1125315	0	0
45665097	1124957	0	0
45631434	1125315	0	0
45657079	1119510	0	0
45623843	738818	0	0
45635203	1129625	0	0
45677200	19018935	2	3
45676979	1309944	0	0
45689750	1125315	0	0
45671665	19078461	2	3
45678920	19078461	2	3
45697213	1595799	0	0
45696934	1361711	0	0
45793341	1107882	2	3
45793341	1107830	0	0
45895542	1119510	0	0
45697465	46275916	1	1
46241613	1125315	0	0
46290922	1119510	0	0
46305736	1129625	0	0
45675332	1125315	0	0
1107830	1107830	0	0
4274025	4027663	3	7
4297887	4166224	3	4
21001882	975125	0	0
21604180	19133768	6	7
36206173	3023430	3	7
36151944	1119510	0	0
36427938	753626	0	0
37520685	4301346	4	4
44359490	46275444	2	3
45621961	1119510	0	0
44361018	1738521	0	0
45641116	1125315	0	0
45665016	1539403	0	0
45631403	1125315	0	0
45657228	1119510	0	0
45623773	1174888	0	0
45630137	1129625	0	0
45674081	40243436	2	3
45676708	1557272	0	0
45689708	1125315	0	0
45670042	19078461	2	3
45678949	1519937	2	3
45697208	740275	0	0
45696944	1557272	0	0
45793186	19059056	2	3
45792919	791967	0	0
45896696	1119510	0	0
45691219	46275916	1	1
46241616	1125315	0	0
46291152	1119510	0	0
46305749	1129625	0	0
45675600	1125315	0	0
1129625	1129625	0	0
4274025	4283893	4	7
19127890	19128022	3	4
21001924	1713332	0	0
21604180	705944	4	4
36206173	3019550	3	7
36151659	1119510	0	0
36426679	705944	0	0
37502350	4323902	2	5
44359501	19078461	2	3
45621608	1119510	0	0
44361021	19127890	0	0
45640912	1125315	0	0
45665107	1153428	0	0
45631550	1125315	0	0
45657271	1119510	0	0
45623916	1551099	0	0
45630142	1129625	0	0
45674099	40232448	2	3
45677062	791967	0	0
45690003	1125315	0	0
45708265	19078461	2	3
45679370	35605482	2	3
45697109	1107830	0	0
45696949	975125	0	0
45792081	1127433	2	3
45793328	1548195	0	0
45896731	1119510	0	0
45688055	46275916	1	1
46241597	1125315	0	0
46291201	1119510	0	0
46305791	1129625	0	0
45675484	1125315	0	0
964261	964261	0	0
4274025	4056621	4	7
19127890	19128263	3	4
21001947	1728416	0	0
21604180	1154029	4	4
36206173	3023103	3	7
36152085	1119510	0	0
36426867	1115008	0	0
37219945	4283893	2	5
44359502	40223834	2	3
45621671	1119510	0	0
44361021	1589505	0	0
45641017	1125315	0	0
45664861	1343916	0	0
45628426	1125315	0	0
45653557	1119510	0	0
45623956	1332418	0	0
45630078	1129625	0	0
45674218	1551192	2	3
45677116	1595799	0	0
45689920	1125315	0	0
45702220	19078461	2	3
45702986	1551192	2	3
45697118	1343916	0	0
45696919	1551099	0	0
45791978	40229134	2	3
45793411	1192710	0	0
45679532	1125315	0	0
45681900	46275916	1	1
46241600	1125315	0	0
46244837	1119510	0	0
46306021	1129625	0	0
45675445	1125315	0	0
701322	701322	0	0
4274025	261325	4	9
19127890	19128065	3	4
21001947	1738521	0	0
21604180	1112807	4	4
36206173	3014599	3	7
36151769	1119510	0	0
36424218	723013	0	0
37521375	4330583	5	5
44359764	43012036	2	3
45621977	1119510	0	0
44361021	1549786	0	0
45641132	1125315	0	0
45665059	19010482	0	0
45628140	1125315	0	0
45653560	1119510	0	0
45623977	1713332	0	0
45630019	1129625	0	0
45674000	19019273	2	3
45676534	914335	0	0
45690010	1125315	0	0
45698861	19078461	2	3
45685734	19019273	2	3
45697350	1149196	0	0
45696921	1153428	0	0
45791963	19078924	2	3
45793186	1112807	0	0
45679720	1125315	0	0
45682158	46275916	1	1
46241604	1125315	0	0
46244971	1119510	0	0
46306043	1129625	0	0
45675617	1125315	0	0
705944	705944	0	0
4274025	4285898	4	11
19127890	19127918	3	4
21001924	1746114	0	0
21604180	1110410	4	4
36206173	3004501	3	6
36151834	1119510	0	0
36424226	1124300	0	0
37502350	4337611	3	5
44359705	1115171	2	3
45619802	1119510	0	0
44341366	1551099	0	0
45641134	1125315	0	0
45665112	1124300	0	0
45628146	1125315	0	0
45653429	1119510	0	0
45623680	1153428	0	0
45629950	1129625	0	0
45674114	40163554	2	3
45676535	1551099	0	0
45689678	1125315	0	0
45779139	19078461	2	3
45691089	19019273	2	3
45697220	1361711	0	0
45696926	1192710	0	0
45790256	1127433	2	3
45793334	1112807	0	0
45679463	1125315	0	0
45697095	46275916	1	1
46241673	1125315	0	0
46239873	1119510	0	0
46322078	1129625	0	0
45675624	1125315	0	0
708298	708298	0	0
4274025	4029498	4	6
19127890	19127904	3	4
21001879	975125	0	0
21604180	19016749	4	4
36206173	3027231	3	6
36152244	1119510	0	0
36424236	19054876	0	0
37203786	4112343	3	5
44355625	1551192	2	3
45619818	1119510	0	0
44341455	1177480	0	0
45641137	1125315	0	0
45665216	1713332	0	0
45628148	1125315	0	0
45653224	1119510	0	0
45623682	1124957	0	0
45630389	1129625	0	0
45673771	40174880	2	3
45677117	1174888	0	0
45689876	1125315	0	0
45690195	19078461	2	3
45682043	19078924	2	3
45697223	1174888	0	0
45697017	1729720	0	0
45790707	40232448	2	3
45792132	1112807	0	0
45679471	1125315	0	0
45672407	46275916	1	1
46241526	1125315	0	0
46239963	1119510	0	0
46322290	1129625	0	0
45675708	1125315	0	0
438614	438614	0	0
4274025	372328	4	6
4208786	4146173	3	4
21001880	1728416	0	0
21602795	920334	4	7
36206173	3006906	3	6
36152252	1119510	0	0
36424373	1738521	0	0
36902269	4043241	3	5
44356160	1127433	2	3
45619806	1119510	0	0
44341337	1112807	0	0
45641145	1125315	0	0
45665218	1110410	0	0
45628536	1125315	0	0
45653650	1119510	0	0
45623686	1107830	0	0
45627143	1129625	0	0
45673934	40232448	2	3
45673493	1551099	0	0
45689935	1125315	0	0
45781836	19078461	2	3
45694148	19078924	2	3
45697425	914335	0	0
45696976	1149380	0	0
45790364	35605482	2	3
45792079	1367571	0	0
45679009	1125315	0	0
45706243	46275916	1	1
46241529	1125315	0	0
46240119	1119510	0	0
46322627	1129625	0	0
45675723	1125315	0	0
3020630	3020630	0	0
4274025	4218389	4	6
21500578	1127433	3	4
21600886	967823	0	0
21602795	19074843	4	7
36206173	3006734	3	6
36152253	1119510	0	0
36425373	1367571	0	0
37502344	4163971	3	5
44352661	19133873	2	3
44361376	1119510	0	0
44341459	1149380	0	0
45641253	1125315	0	0
45665226	1107830	0	0
45628668	1125315	0	0
45653700	1119510	0	0
45623966	1115008	0	0
45627185	1129625	0	0
45674263	40232448	2	3
45673485	1118084	0	0
45689686	1125315	0	0
45693201	19078461	2	3
45684751	46233988	2	3
45697430	1310149	0	0
45696892	1192710	0	0
45790335	19008572	2	3
45791842	1112807	0	0
45678963	1125315	0	0
45687774	19079524	1	1
46238757	1125315	0	0
46240122	1119510	0	0
46322080	1129625	0	0
45675589	1125315	0	0
3020655	3020655	0	0
4274025	4174876	4	5
4209223	4285898	3	3
21600270	1309944	0	0
21602795	19073183	4	7
36206173	3012494	3	6
36152417	1119510	0	0
36424390	1512674	0	0
37219945	40481087	3	6
44352838	40236824	2	3
44361542	1119510	0	0
44341460	1153428	0	0
45641299	1125315	0	0
45665131	1500211	0	0
45628512	1125315	0	0
45653686	1119510	0	0
45623969	967823	0	0
45627314	1129625	0	0
45674269	40223834	2	3
45673431	738818	0	0
45689632	1125315	0	0
45781663	40223768	2	3
45684751	46233710	2	3
45697433	1549786	0	0
45696894	1343916	0	0
45790307	1127433	2	3
45791943	1124300	0	0
45679086	1125315	0	0
45703204	19079524	1	1
46238758	1125315	0	0
45896629	1119510	0	0
46317129	1129625	0	0
45896982	1125315	0	0
3036780	3036780	0	0
4274025	140673	4	5
4300157	4146173	3	3
21600303	1343916	0	0
21602795	19133905	4	7
36206173	3027970	3	6
36152093	1119510	0	0
36416551	80502	0	0
37219945	28060	3	6
44352844	1115171	2	3
44361669	1119510	0	0
44341510	1589505	0	0
45641300	1125315	0	0
45664958	715997	0	0
45628305	1125315	0	0
45653243	1119510	0	0
45623980	967823	0	0
45627215	1129625	0	0
45674269	40223821	2	3
45673433	1717327	0	0
45689866	1125315	0	0
45690150	1332419	2	3
45705161	40174880	2	3
45697433	19127890	0	0
45697022	715997	0	0
45790539	1115171	2	3
45791952	1367571	0	0
45679152	1125315	0	0
45682685	19079524	1	1
46238459	1125315	0	0
45896592	1119510	0	0
46317147	1129625	0	0
45897039	1125315	0	0
3035995	3035995	0	0
4274025	317009	4	4
21600600	975125	3	3
21503381	1124300	0	0
21602795	46275444	5	7
36206173	3001247	3	6
36152238	1119510	0	0
36311902	4163951	0	0
37502342	4108705	3	6
44352826	40229134	2	3
44361702	1119510	0	0
44341510	1549786	0	0
45641260	1125315	0	0
45665145	1729720	0	0
45628307	1125315	0	0
45653823	1119510	0	0
45624062	1521369	0	0
45627543	1129625	0	0
45674358	1115171	2	3
45673605	1551099	0	0
45686767	1125315	0	0
45692888	1332419	2	3
45697682	19073183	2	3
45697433	1512674	0	0
45697026	1110410	0	0
45790606	40229134	2	3
45791963	708298	0	0
45679166	1125315	0	0
45678766	19079524	1	1
46238795	1125315	0	0
45896485	1119510	0	0
46317296	1129625	0	0
45896953	1125315	0	0
1112807	1112807	0	0
4274025	4094814	4	4
4212076	4230399	3	3
21503428	967823	0	0
21602795	1713671	6	7
36206173	3006451	3	5
36152068	1119510	0	0
36222374	40223834	1	2
37303796	134438	3	6
44353215	43012036	2	3
44360954	1119510	0	0
44341510	19127890	0	0
45641244	1125315	0	0
45665240	738818	0	0
45628355	1125315	0	0
45653826	1119510	0	0
45624062	1549786	0	0
45623901	1129625	0	0
45674049	1551192	2	3
45673519	1307863	0	0
45686780	1125315	0	0
45699090	1332419	2	3
45697682	19073188	2	3
45697436	1192710	0	0
45696999	933724	0	0
45787560	40231925	2	3
45791986	1361711	0	0
45679167	1125315	0	0
45682620	19079524	1	1
46238796	1125315	0	0
45896497	1119510	0	0
46311273	1129625	0	0
45897050	1125315	0	0
1115171	1115171	0	0
4274025	4139681	5	6
4324765	40479422	3	3
21503515	1308738	0	0
35200000	4112343	7	11
36217214	19128009	3	4
36152171	1119510	0	0
36222374	40223821	1	2
37302322	4296204	6	6
44352869	19008572	2	3
44361677	1119510	0	0
44341513	1115008	0	0
45642972	1125315	0	0
45665285	1551099	0	0
45628631	1125315	0	0
45653703	1119510	0	0
45624062	1595799	0	0
45625214	1129625	0	0
45674184	19078924	2	3
45673522	1310149	0	0
45686455	1125315	0	0
45705480	1332419	2	3
45703693	19078461	2	3
45697439	1107830	0	0
45697005	1107830	0	0
45787569	40165015	2	3
45790262	1107830	0	0
45678970	1125315	0	0
45703025	19079524	1	1
46238546	1125315	0	0
45896679	1119510	0	0
46311614	1129625	0	0
45897054	1125315	0	0
1115008	1115008	0	0
4274025	4169137	5	6
4324765	40479768	3	3
21500772	1308738	0	0
35200000	258780	8	11
36217214	19133679	3	4
36152214	1119510	0	0
36226418	19023398	1	2
37219945	257012	2	6
44353015	40222846	2	3
44361107	1119510	0	0
44341540	1129625	0	0
45642913	1125315	0	0
45665347	791967	0	0
45628728	1125315	0	0
45653745	1119510	0	0
45624063	1738521	0	0
45625248	1129625	0	0
45674349	40232448	2	3
45673527	1343916	0	0
45686866	1125315	0	0
45671544	40174880	2	3
45700363	19019273	2	3
45697440	1153428	0	0
45697077	1000560	0	0
45787668	1551192	2	3
45790241	967823	0	0
45679026	1125315	0	0
45690718	19079524	1	1
46238567	1125315	0	0
45896682	1119510	0	0
46311348	1129625	0	0
45897099	1125315	0	0
1119510	1119510	0	0
4274025	4001336	5	9
4229909	4280726	3	3
21500753	967823	0	0
35200000	4048171	8	11
36216998	1127078	1	2
36151987	1119510	0	0
36226326	19007333	1	2
37502350	4336464	6	7
44352915	1115171	2	3
44361270	1119510	0	0
44341549	1124300	0	0
45642931	1125315	0	0
45665256	1115008	0	0
45625164	1125315	0	0
45653767	1119510	0	0
45624088	1115008	0	0
45624217	1129625	0	0
45673889	19078924	2	3
45673530	1759842	0	0
45686677	1125315	0	0
45684043	1545959	2	3
45779682	1332419	2	3
45697120	1192710	0	0
45697033	1332418	0	0
45787625	40223834	2	3
45790265	1551099	0	0
45679129	1125315	0	0
45690718	46275916	1	1
46238826	1125315	0	0
45896686	1119510	0	0
46311827	1129625	0	0
45896922	1125315	0	0
1118084	1118084	0	0
4274025	4142905	5	9
4229909	40486433	3	3
21500754	967823	0	0
35200000	261325	7	10
36216998	1127433	1	2
36155101	1125315	0	0
36226327	19007333	1	2
37302322	133834	7	7
44349135	40231925	2	3
44361277	1119510	0	0
44338318	1119510	0	0
45643080	1125315	0	0
45662516	1149196	0	0
45625348	1125315	0	0
45650225	1119510	0	0
45623800	738818	0	0
45624355	1129625	0	0
45673896	19008572	2	3
45673530	1713332	0	0
45686615	1125315	0	0
45654931	1545959	2	3
45687962	19073183	2	3
45697261	1107830	0	0
45697048	1154343	0	0
45787629	40162522	2	3
45790369	1124300	0	0
45786006	1125315	0	0
45678625	46275916	1	1
46238828	1125315	0	0
45896554	1119510	0	0
46319315	1129625	0	0
45896969	1125315	0	0
1124957	1124957	0	0
4274025	40481087	5	8
21500543	738818	3	3
21500755	967823	0	0
35200000	40486433	7	10
36217055	19073188	1	2
36155158	1125315	0	0
36225011	19126352	1	2
37302323	134438	2	7
44349060	40231925	2	3
44361283	1119510	0	0
44338327	1119510	0	0
45642921	1125315	0	0
45662524	738818	0	0
45625329	1125315	0	0
45650165	1119510	0	0
45624096	1110410	0	0
45624381	1129625	0	0
45671085	1115171	2	3
45673531	1154029	0	0
45686624	1125315	0	0
45677434	1545959	2	3
45696942	19073183	2	3
45697396	967823	0	0
45697049	975125	0	0
45789173	19077572	2	3
45790280	1521369	0	0
45785847	1125315	0	0
45693774	46275916	1	1
46238829	1125315	0	0
45896510	1119510	0	0
46319734	1129625	0	0
45897000	1125315	0	0
4024289	4024289	0	0
4274025	28060	5	8
21500543	1129625	3	3
21500781	1308738	0	0
35200000	4294548	7	10
36217055	19073183	1	2
36154754	1125315	0	0
36215488	19019273	1	2
37502345	4330583	2	7
44348801	19019273	2	3
44361690	1119510	0	0
44338462	1119510	0	0
45643799	1125315	0	0
45662642	1322184	0	0
45625378	1125315	0	0
45650138	1119510	0	0
45623601	1192710	0	0
45624288	1129625	0	0
45671253	1115171	2	3
45673447	1149196	0	0
45686647	1125315	0	0
45694627	1539411	2	3
46240144	40173590	2	3
45697403	1307863	0	0
45697130	1501700	0	0
45789305	40231925	2	3
45790280	1549786	0	0
45785848	1125315	0	0
45693774	19079524	1	1
46238830	1125315	0	0
45894365	1119510	0	0
46313410	1119510	0	0
45897002	1125315	0	0
3005136	3005136	0	0
4274025	81151	5	10
4247371	4029498	3	3
21500782	1125315	0	0
35200000	260139	7	10
36216999	1127433	1	2
36154755	1125315	0	0
36215488	1115171	1	2
37502341	4198190	2	7
44351751	40162522	2	3
44360968	1119510	0	0
44338280	1119510	0	0
45641319	1125315	0	0
45662384	1305058	0	0
45625285	1125315	0	0
45650385	1119510	0	0
45623867	1521369	0	0
45624229	1129625	0	0
45671106	40163554	2	3
45673535	1521369	0	0
45686661	1125315	0	0
45681408	19079524	1	1
45684534	1332419	2	3
45697265	1000560	0	0
45697065	1149196	0	0
45789310	1115171	2	3
45790364	1000560	0	0
45786031	1125315	0	0
45673399	19079524	1	1
46238831	1125315	0	0
45894424	1119510	0	0
46313307	1119510	0	0
45897005	1125315	0	0
3006322	3006322	0	0
4274025	258780	5	10
4297887	28060	3	3
21500785	1595799	0	0
35200000	4280726	6	10
36216999	1127078	1	2
36154756	1125315	0	0
36222613	46275916	1	2
37219945	4294548	2	7
44349254	19008572	2	3
44361476	1119510	0	0
44338521	1119510	0	0
45641362	1125315	0	0
45662482	1124957	0	0
45625290	1125315	0	0
45650547	1119510	0	0
45623867	1549786	0	0
45668238	1129625	0	0
45671190	1127433	2	3
45673535	1549786	0	0
45686738	1125315	0	0
45678261	19079524	1	1
45693754	19073183	2	3
45697166	715997	0	0
45697232	1174888	0	0
45787825	1115171	2	3
45790366	1551099	0	0
45786036	1125315	0	0
45684685	19079524	1	1
46238561	1125315	0	0
45894511	1119510	0	0
46313437	1119510	0	0
45897136	1125315	0	0
3006451	3006451	0	0
4274025	4051466	5	5
4297887	196456	3	3
21500785	1396131	0	0
35200000	4283893	7	8
36217056	19073183	1	2
36154677	1125315	0	0
36222613	1594382	1	2
37219945	4280726	2	7
44349296	40236824	2	3
44361347	1119510	0	0
44338482	1119510	0	0
45641374	1125315	0	0
45662488	1107830	0	0
45625293	1125315	0	0
45650245	1119510	0	0
45623868	967823	0	0
45668422	1129625	0	0
45671144	40236824	2	3
45673538	738818	0	0
45686846	1125315	0	0
45675288	19079524	1	1
45672870	19073183	2	3
45697285	1308738	0	0
45697238	1174888	0	0
45787845	43012433	2	3
45790335	975125	0	0
45786543	1125315	0	0
45706694	19079524	1	1
46238640	1125315	0	0
45799942	1119510	0	0
46313457	1119510	0	0
45897083	1125315	0	0
3000876	3000876	0	0
4274025	4296205	5	5
4297090	4181917	3	3
21500785	1308738	0	0
35200000	257012	6	9
36216121	40162522	1	2
36154684	1125315	0	0
36215489	19019273	1	2
37219945	261325	3	7
44349317	1115171	2	3
44361306	1119510	0	0
44338484	1119510	0	0
45638136	1125315	0	0
45662581	967823	0	0
45625272	1125315	0	0
45650450	1119510	0	0
45623984	1308738	0	0
45668633	1129625	0	0
45671504	40232448	2	3
45673546	1713332	0	0
45686985	1125315	0	0
45678149	46275916	1	1
45699994	19073183	2	3
45697408	1154343	0	0
45697304	975125	0	0
45787871	40229134	2	3
45790291	1112807	0	0
45786544	1125315	0	0
45682084	19079524	1	1
46238617	1125315	0	0
46317845	1119510	0	0
46314235	1119510	0	0
45897086	1125315	0	0
3000963	3000963	0	0
4274025	78272	5	11
4297090	4151422	3	3
21500767	1308738	0	0
35200000	40481087	8	9
36216121	19133768	1	2
36154678	1125315	0	0
36215489	1115171	1	2
37219945	260139	3	7
44345055	40165015	2	3
44360980	1119510	0	0
44338252	1119510	0	0
45638137	1125315	0	0
45662586	1124957	0	0
45625419	1125315	0	0
45647280	1119510	0	0
45623993	1778162	0	0
45668782	1129625	0	0
45671289	40223834	2	3
45673546	1759842	0	0
45686883	1125315	0	0
45678149	19079524	1	1
45687603	40228214	2	3
45697414	1174888	0	0
45697307	1107830	0	0
45786307	40228214	2	3
45790303	1713332	0	0
45786549	1125315	0	0
45678943	19079524	1	1
46238759	1125315	0	0
46318078	1119510	0	0
46314236	1119510	0	0
45897270	1125315	0	0
3008598	3008598	0	0
4274025	4116491	5	7
4297090	4246502	3	3
21500734	1595799	0	0
35200000	28060	8	9
36216122	40162522	1	2
36155047	1125315	0	0
36222254	19075601	1	2
37219945	40486433	3	7
44345231	40174880	2	3
44360985	1119510	0	0
44338619	1119510	0	0
45638120	1125315	0	0
45662592	1110410	0	0
45625728	1125315	0	0
45647266	1119510	0	0
45624055	738818	0	0
45666343	1129625	0	0
45671510	19057271	2	3
45673555	1713332	0	0
45686821	1125315	0	0
45696278	19079524	1	1
45678514	1107882	2	3
45697419	1539403	0	0
45697308	1115008	0	0
45786325	40232448	2	3
45790397	1115008	0	0
45786561	1125315	0	0
45706889	19079524	1	1
46238760	1125315	0	0
46318082	1119510	0	0
46314016	1119510	0	0
45897111	1125315	0	0
1396131	1396131	0	0
4274025	198199	5	7
4297090	4133840	3	3
21500740	1192710	0	0
35200000	255848	7	9
36216122	19133768	1	2
36155128	1125315	0	0
36215522	1154615	1	2
37219945	4112343	2	8
44345154	35605482	2	3
44361480	1119510	0	0
44338234	1119510	0	0
45638151	1125315	0	0
45662282	740275	0	0
45625471	1125315	0	0
45649009	1119510	0	0
45623894	1115008	0	0
45667365	1129625	0	0
45671278	40163554	2	3
45673559	1310149	0	0
45686822	1125315	0	0
45702424	46275916	1	1
45681601	40228214	2	3
45697355	1192710	0	0
45693938	1174888	0	0
45786216	40229134	2	3
45790308	1717327	0	0
45786383	1125315	0	0
45678429	19079524	1	1
46238761	1125315	0	0
46317603	1119510	0	0
46314423	1119510	0	0
45897113	1125315	0	0
1500211	1500211	0	0
4274025	4166224	7	10
21502522	920300	5	6
21500721	1595799	0	0
35202051	28060	7	8
36218152	40228214	1	2
36154806	1125315	0	0
36416551	40480160	1	1
37103722	198199	3	5
44345157	19018935	2	3
44361153	1119510	0	0
44338392	1119510	0	0
45638075	1125315	0	0
45662284	1000560	0	0
45625640	1125315	0	0
45649042	1119510	0	0
45623595	1309944	0	0
45667341	1129625	0	0
45669810	1127433	2	3
45673564	1110410	0	0
45686964	1125315	0	0
45702424	19079524	1	1
45684756	19075001	2	3
45697367	1149196	0	0
45693945	975125	0	0
45786231	40229134	2	3
45790310	920293	0	0
45786134	1125315	0	0
45700672	19079524	1	1
46238809	1125315	0	0
46317825	1119510	0	0
46313627	1119510	0	0
45897292	1125315	0	0
1124300	1124300	0	0
4274025	4134304	7	11
21502522	920334	5	6
21500786	1595799	0	0
35202051	40481087	7	8
36216027	19018935	1	2
36155130	1125315	0	0
36313907	4010253	1	1
37103722	45769019	4	5
44345423	40229134	2	3
44357434	1119510	0	0
44338547	1119510	0	0
45637970	1125315	0	0
45662450	1174888	0	0
45625616	1125315	0	0
45649182	1119510	0	0
45623698	1000560	0	0
45666469	1129625	0	0
45669729	40174880	2	3
45673610	1115008	0	0
45687002	1125315	0	0
45706041	19079524	1	1
45681794	19019273	2	3
45697375	1149380	0	0
45693946	1501700	0	0
45786301	40162522	2	3
45790440	1112807	0	0
45786210	1125315	0	0
45700177	19079524	1	1
46238825	1125315	0	0
46318162	1119510	0	0
46308506	1119510	0	0
45894710	1125315	0	0
1125443	1125443	0	0
4274025	133834	7	9
21500136	40224132	5	6
21500786	1308738	0	0
35202051	255848	6	8
36216028	19018935	1	2
36155136	1125315	0	0
36427861	19089061	1	1
37502353	4337611	6	7
44345380	40232448	2	3
44357408	1119510	0	0
44338534	1119510	0	0
45638057	1125315	0	0
45662497	1115008	0	0
45625603	1125315	0	0
45647404	1119510	0	0
45624112	1308738	0	0
45666362	1129625	0	0
45669826	43012036	2	3
45673533	1000560	0	0
45687015	1125315	0	0
45706041	46275916	1	1
45705081	19078461	2	3
45697646	1149196	0	0
45693879	1343916	0	0
45786313	40231925	2	3
45790539	1115008	0	0
45786122	1125315	0	0
45700112	19079524	1	1
46240078	1125315	0	0
46317860	1119510	0	0
46307889	1119510	0	0
45894756	1125315	0	0
1125315	1125315	0	0
4274025	196456	7	7
21500136	44816277	5	6
21500786	1396131	0	0
35202051	4294548	6	9
36203047	4066995	1	2
36156449	1125315	0	0
36302172	4012477	2	2
37502353	4323902	4	8
44345717	40162522	2	3
44357385	1119510	0	0
44338630	1119510	0	0
45638042	1125315	0	0
45662287	1738521	0	0
45625805	1125315	0	0
45647408	1119510	0	0
45667867	738818	0	0
45664515	1129625	0	0
45669787	19075601	2	3
45673570	1548195	0	0
45687017	1125315	0	0
45678066	19079524	1	1
45681702	1107882	2	3
45697252	1110410	0	0
45693952	1124957	0	0
45786362	40222846	2	3
45790386	705944	0	0
45786166	1125315	0	0
45687815	19079524	1	1
46239916	1125315	0	0
46318139	1119510	0	0
46308409	1119510	0	0
45894760	1125315	0	0
914335	914335	0	0
4274025	4048171	6	10
21500136	1519937	5	6
21500701	1308738	0	0
35202051	40486433	6	9
36002872	4280726	1	2
36151054	1125315	0	0
36402186	80502	2	2
37502353	4197460	4	5
44345497	19018935	2	3
44357502	1119510	0	0
44341207	1119510	0	0
45638165	1125315	0	0
45662401	705944	0	0
45625676	1125315	0	0
45644213	1119510	0	0
45668022	715997	0	0
45663965	1129625	0	0
45670409	40223768	2	3
45673598	1501700	0	0
45686896	1125315	0	0
45702623	19079524	1	1
45672673	40174880	2	3
45697258	1367571	0	0
45693887	757627	0	0
46296886	1115171	2	3
45790668	715997	0	0
45786168	1125315	0	0
45687815	46275916	1	1
46240179	1125315	0	0
46317781	1119510	0	0
46308533	1119510	0	0
45894764	1125315	0	0
442116	442116	0	0
4274025	378001	6	10
21500136	40224805	5	6
21500710	1308738	0	0
35202051	260139	6	9
36153492	19128263	1	2
36150849	1125315	0	0
36312757	42535580	2	2
37502353	4330583	3	10
44345277	19018935	2	3
44357702	1119510	0	0
44359814	1119510	0	0
45638183	1125315	0	0
45662358	1124957	0	0
45625633	1125315	0	0
45644278	1119510	0	0
45667645	1549786	0	0
45664159	1129625	0	0
45670278	1545959	2	3
45673671	1738521	0	0
45686802	1125315	0	0
45702623	46275916	1	1
45783644	1107882	2	3
45697353	1107830	0	0
45693954	1124957	0	0
46296996	40232448	2	3
45790410	1326303	0	0
45786173	1125315	0	0
45706502	19079524	1	1
45897691	1125315	0	0
46318096	1119510	0	0
46308558	1119510	0	0
45894765	1125315	0	0
260131	260139	2	2
4274025	4266809	6	8
4246502	4246502	0	0
21500712	1396131	0	0
35202051	261325	6	9
36216955	1310034	1	2
36150930	1125315	0	0
36313276	439777	2	2
37502353	4337138	5	6
44345298	1127433	2	3
44357703	1119510	0	0
44359850	1119510	0	0
45638382	1125315	0	0
45662554	1154343	0	0
45625751	1125315	0	0
45644342	1119510	0	0
45667645	19127890	0	0
45664163	1129625	0	0
45781244	40232448	2	3
45673674	1332418	0	0
45686809	1125315	0	0
45672266	19079524	1	1
45688177	1107882	2	3
45697508	1501700	0	0
45693671	1137529	0	0
46296817	1107882	2	3
45793271	975125	0	0
45786184	1125315	0	0
45693724	19079524	1	1
45897697	1125315	0	0
46318168	1119510	0	0
46308297	1119510	0	0
45894594	1125315	0	0
256451	258780	2	2
4274025	45769019	6	7
21001192	975125	0	0
21500714	1308738	0	0
35202051	4048171	7	10
35902852	198809	1	2
36150907	1125315	0	0
36402192	140673	2	2
37502353	4108705	5	7
44345312	1713671	2	3
44357529	1119510	0	0
44359725	1119510	0	0
45638262	1125315	0	0
45662314	1326303	0	0
45625758	1125315	0	0
45644345	1119510	0	0
45667645	1589505	0	0
45664002	1129625	0	0
45781372	19008572	2	3
45673621	740275	0	0
45687034	1125315	0	0
45674815	19079524	1	1
45780285	1107882	2	3
45697566	1501700	0	0
45693671	1149380	0	0
46296924	19075001	2	3
45793288	1115008	0	0
45786296	1125315	0	0
45681957	46275916	1	1
45897870	1125315	0	0
46318193	1119510	0	0
46308570	1119510	0	0
45894846	1125315	0	0
4013842	439777	2	2
4274025	433644	6	7
21001125	1551099	0	0
21500721	1308738	0	0
35202051	258780	7	10
35702751	81893	1	2
36150913	1125315	0	0
36502198	4059173	2	4
37300000	4156265	6	6
44345519	40229134	2	3
44357649	1119510	0	0
44359730	1119510	0	0
45638270	1125315	0	0
45662691	1107830	0	0
45625723	1125315	0	0
45644201	1119510	0	0
45667975	914335	0	0
45664109	1129625	0	0
45781226	40174880	2	3
45673622	1124957	0	0
45687035	1125315	0	0
45680024	46275916	1	1
45706834	1107882	2	3
45697288	1000560	0	0
45694083	1192710	0	0
46297079	1127078	2	3
45793113	1107830	0	0
46292667	1125315	0	0
45681957	19079524	1	1
45897657	1125315	0	0
45794483	1119510	0	0
46308311	1119510	0	0
45894859	1125315	0	0
4016263	4134304	2	2
4274025	4240902	6	7
21001125	975125	0	0
21500727	1308738	0	0
35202051	4112343	6	10
21602517	40221415	1	4
36150992	1125315	0	0
36502198	4066995	2	4
37300000	4066995	7	8
44345483	40229134	2	3
44357760	1119510	0	0
44360001	1119510	0	0
45637128	1125315	0	0
45662701	1174888	0	0
45622067	1125315	0	0
45644433	1119510	0	0
45667991	1192710	0	0
45664094	1129625	0	0
45781389	1115171	2	3
45673628	1551099	0	0
45683553	1125315	0	0
45680024	19079524	1	1
45672667	1107882	2	3
45697420	975125	0	0
45693978	1343916	0	0
46293236	19075001	2	3
45793406	791967	0	0
46292737	1125315	0	0
45681721	19079524	1	1
45897665	1125315	0	0
45794403	1119510	0	0
46308750	1119510	0	0
45894888	1125315	0	0
437409	4001336	2	2
4274025	4109685	6	7
21001259	975125	0	0
21013536	1746114	0	0
21602359	19127904	6	8
21602657	40236824	1	4
36150961	1125315	0	0
36502198	4278672	2	4
37300000	4048695	7	8
44345503	40232448	2	3
44357875	1119510	0	0
44359837	1119510	0	0
45637132	1125315	0	0
45662321	1332418	0	0
45622124	1125315	0	0
45644462	1119510	0	0
45667996	967823	0	0
45660997	1129625	0	0
45781625	40229134	2	3
45673629	914335	0	0
45683577	1125315	0	0
45693311	19079524	1	1
46240339	1539411	2	3
45894782	1115008	0	0
45694056	1174888	0	0
46293113	40163554	2	3
45793203	715997	0	0
46292640	1125315	0	0
45681721	46275916	1	1
45897866	1125315	0	0
45794520	1119510	0	0
46308617	1119510	0	0
45894826	1125315	0	0
4015311	4015189	2	2
4274025	37017711	6	7
21001163	1551099	0	0
21013536	1741122	0	0
35202461	258780	6	9
36203055	375671	1	4
36151014	1125315	0	0
36502198	4142905	2	4
37300000	134438	3	8
44341263	46275444	2	3
44357881	1119510	0	0
44360070	1119510	0	0
45634945	1125315	0	0
45662601	1107830	0	0
45622146	1125315	0	0
45644299	1119510	0	0
45668002	1343916	0	0
45660631	1129625	0	0
45781700	1107882	2	3
45673711	914335	0	0
45683708	1125315	0	0
45702280	19079524	1	1
45703946	1107882	2	3
45894875	920293	0	0
45694056	1192710	0	0
46293426	19059056	2	3
45793480	1124957	0	0
46292643	1125315	0	0
45693626	19079524	1	1
45897734	1125315	0	0
46312374	1119510	0	0
46308473	1119510	0	0
45894683	1125315	0	0
4028074	78272	2	2
4274025	81893	6	12
21001267	967823	0	0
21013610	1305058	0	0
35202461	4112343	5	9
36203048	4142905	1	1
36151026	1125315	0	0
36502198	4237458	2	4
37300000	133834	3	10
44341399	1127433	2	3
44357884	1119510	0	0
44360078	1119510	0	0
45634892	1125315	0	0
45662514	738818	0	0
45622164	1125315	0	0
45644396	1119510	0	0
45668004	1110410	0	0
45660886	1129625	0	0
45781590	40232448	2	3
45673879	1367571	0	0
45683709	1125315	0	0
45696317	19079524	1	1
45782356	1332419	2	3
45894821	1107830	0	0
45694062	1153428	0	0
46293290	1551192	2	3
45793439	1192710	0	0
46292672	1125315	0	0
45688159	19079524	1	1
45897821	1125315	0	0
46312108	1119510	0	0
46308669	1119510	0	0
45894755	1125315	0	0
4024567	317009	2	2
4274025	441267	6	6
21001195	975125	0	0
21013645	1308738	0	0
35202461	4280726	4	8
36211378	4218389	1	1
36150766	1125315	0	0
36502199	80180	2	4
37300000	4109685	5	5
44344370	40162522	2	3
44357802	1119510	0	0
44360143	1119510	0	0
45634884	1125315	0	0
45662738	1717327	0	0
45625096	1125315	0	0
45641530	1119510	0	0
45667978	1174888	0	0
45657981	1129625	0	0
45781591	40236824	2	3
45673676	1192710	0	0
45683747	1125315	0	0
45679984	46275916	1	1
45681492	40173590	2	3
45694683	791967	0	0
45694078	1332418	0	0
46293314	1115171	2	3
45793298	1149196	0	0
46292797	1125315	0	0
45672689	46275916	1	1
45897910	1125315	0	0
46312109	1119510	0	0
46308670	1119510	0	0
45894695	1125315	0	0
254068	4283893	2	2
4274025	4113008	6	6
21001138	740275	0	0
21013627	1307863	0	0
35202461	4294548	5	8
36009740	438614	1	1
36151304	1125315	0	0
36302173	4015189	2	6
37300000	4155034	5	5
44344374	40232448	2	3
44353848	1119510	0	0
44359741	1119510	0	0
45634875	1125315	0	0
45662634	1308738	0	0
45624835	1125315	0	0
45641582	1119510	0	0
45667654	1332418	0	0
45657876	1129625	0	0
45778663	40231925	2	3
45673831	1551099	0	0
45683591	1125315	0	0
45679984	19079524	1	1
45688422	40173590	2	3
45694551	1124957	0	0
45694088	1110410	0	0
46296565	40229134	2	3
45793305	791967	0	0
46292821	1125315	0	0
45672689	19079524	1	1
45897874	1125315	0	0
46312329	1119510	0	0
46308714	1119510	0	0
45894699	1125315	0	0
1589542	19127918	2	2
4274025	4155034	6	6
21001258	975125	0	0
21013671	1307863	0	0
35202461	261325	5	8
36009740	4139681	1	1
36151307	1125315	0	0
36517012	81151	2	5
37300000	4113008	5	5
44344603	43012433	2	3
44354163	1119510	0	0
44360174	1119510	0	0
44362725	1119510	0	0
45662772	1551099	0	0
45624954	1125315	0	0
45641419	1119510	0	0
45667731	1713332	0	0
45657881	1129625	0	0
45779017	19008572	2	3
45673651	1557272	0	0
45683602	1125315	0	0
45680158	19079524	1	1
45780450	1332419	2	3
45694447	1759842	0	0
45693673	1361711	0	0
46296805	1115171	2	3
45793389	1154343	0	0
46293071	1125315	0	0
45696932	46275916	1	1
45897915	1125315	0	0
46312520	1119510	0	0
46308692	1119510	0	0
45894711	1125315	0	0
1589542	19128009	2	2
4274025	4278672	6	9
21001205	1343916	0	0
21013671	1326303	0	0
35202461	40486433	5	8
36009740	442116	1	1
36151316	1125315	0	0
36502199	80809	2	5
37300000	4102123	4	4
44341622	40232448	2	3
44355319	1119510	0	0
44359919	1119510	0	0
44361829	1119510	0	0
45662773	19059528	0	0
45622261	1125315	0	0
45641606	1119510	0	0
45667869	1759842	0	0
45658155	1129625	0	0
45778790	40174880	2	3
45673807	1115008	0	0
45683653	1125315	0	0
45675099	46275916	1	1
45703039	19079524	2	3
45694447	1713332	0	0
45693675	1307863	0	0
46296717	19008572	2	3
45793390	1322184	0	0
46292711	1125315	0	0
45696932	19079524	1	1
45897770	1125315	0	0
46312770	1119510	0	0
46312106	1119510	0	0
45894832	1125315	0	0
4010109	4301346	2	2
4274025	4048695	6	9
21001219	914335	0	0
21013658	715997	0	0
35202461	260139	5	8
36009740	4169137	1	1
36151348	1125315	0	0
36302173	4024958	2	5
42805599	1515774	0	0
44341633	46275444	2	3
44355351	1119510	0	0
44360187	1119510	0	0
44361756	1119510	0	0
45662526	1124957	0	0
45622330	1125315	0	0
45641613	1119510	0	0
45667869	1713332	0	0
45658157	1129625	0	0
45779340	43012036	2	3
45673515	701322	0	0
45683714	1125315	0	0
45675099	19079524	1	1
45784616	19075601	2	3
45694453	1110410	0	0
45693757	1115008	0	0
46293520	40162522	2	3
45793375	1124300	0	0
46293009	1125315	0	0
45685128	19079524	1	1
45897846	1125315	0	0
46312661	1119510	0	0
46312152	1119510	0	0
45894768	1125315	0	0
4010109	44783196	2	2
4029205	4293740	4	6
21001228	1124300	0	0
21013543	1307863	0	0
35300000	4144583	8	8
36002872	133834	1	1
36151326	1125315	0	0
36517149	4146173	2	3
42805599	19127890	0	0
44341685	40231925	2	3
44355355	1119510	0	0
44359970	1119510	0	0
44361834	1119510	0	0
45662719	1501700	0	0
45622305	1125315	0	0
45641664	1119510	0	0
45667880	1746114	0	0
45654640	1129625	0	0
45779341	19073183	2	3
45673846	738818	0	0
45683693	1125315	0	0
45699571	46275916	1	1
45678887	19075601	2	3
45694215	1107830	0	0
45693765	1361711	0	0
46293837	19057271	2	3
45793044	1501700	0	0
46292928	1125315	0	0
45690923	19079524	1	1
45897850	1125315	0	0
46312830	1119510	0	0
46312350	1119510	0	0
45894743	1125315	0	0
4028071	198199	3	5
4029205	4202451	4	7
21001149	1551099	0	0
21013671	1309944	0	0
21602754	1501700	0	0
36002869	134438	1	1
36151222	1125315	0	0
36502196	80502	2	3
42805599	1549786	0	0
44341657	19133905	2	3
44355464	1119510	0	0
44360280	1119510	0	0
44361769	1119510	0	0
45662726	1310149	0	0
45622373	1125315	0	0
45641786	1119510	0	0
45667880	1741122	0	0
45654564	1129625	0	0
45779375	1127433	2	3
45673851	1501700	0	0
45683658	1125315	0	0
45699571	19079524	1	1
45706491	19075601	2	3
45694216	975125	0	0
45693850	1153428	0	0
46288885	40229134	2	3
45793308	1192710	0	0
46293047	1125315	0	0
45699839	19079524	1	1
45897852	1125315	0	0
46312831	1119510	0	0
46311838	1119510	0	0
45894817	1125315	0	0
4020346	78272	3	5
4029205	4186930	4	7
21001116	1125315	0	0
21013672	1309944	0	0
21603392	1125443	0	0
36009700	4051466	1	1
36151242	1125315	0	0
36603316	4285898	2	3
42805680	715997	0	0
44341957	920334	2	3
44354286	1119510	0	0
44359901	1119510	0	0
44361966	1119510	0	0
45662775	1729720	0	0
45622558	1125315	0	0
45638247	1119510	0	0
45668007	1738521	0	0
45654657	1129625	0	0
45779165	40232448	2	3
45673954	1115008	0	0
45683734	1125315	0	0
45672521	19079524	1	1
45779671	40228214	2	3
45694194	1174888	0	0
45693766	1149196	0	0
46288900	1115171	2	3
45793310	1115008	0	0
46293048	1125315	0	0
45699964	19079524	1	1
45897960	1125315	0	0
46307057	1119510	0	0
46311915	1119510	0	0
45894818	1125315	0	0
4086181	4132546	3	5
4029205	4295880	4	5
21001248	975125	0	0
21013658	757627	0	0
21603641	1124300	0	0
35702735	441267	1	1
36151102	1125315	0	0
36225034	19127922	2	3
42805555	1177480	0	0
44341736	19133873	2	3
44354369	1119510	0	0
44353281	1119510	0	0
44362295	1119510	0	0
45662629	1124300	0	0
45622318	1125315	0	0
45640079	1119510	0	0
45668011	1308738	0	0
45654658	1129625	0	0
45707637	40228230	2	3
45673958	1149196	0	0
45683770	1125315	0	0
45705632	19079524	1	1
45705259	1539411	2	3
45694303	1174888	0	0
45693856	1332418	0	0
46288644	1115171	2	3
45793228	914335	0	0
46292659	1125315	0	0
45688215	19079524	1	1
45897988	1125315	0	0
46307154	1119510	0	0
46303613	1119510	0	0
45896562	1125315	0	0
4028076	40486433	4	5
4029205	4059978	4	4
21001191	1551099	0	0
21004615	1717327	0	0
21602837	1717327	0	0
36211374	4156265	1	1
36151386	1125315	0	0
36225034	19133679	2	3
42805785	1115008	0	0
44363048	40163554	2	3
44354436	1119510	0	0
44353319	1119510	0	0
44362064	1119510	0	0
45662847	1539403	0	0
45622319	1125315	0	0
45640200	1119510	0	0
45668012	914335	0	0
45654289	1129625	0	0
45707638	1594382	2	3
45673962	1115008	0	0
45683773	1125315	0	0
45706039	46275916	1	1
45684983	19075601	2	3
45694196	1738521	0	0
45693857	1307863	0	0
46288656	1115171	2	3
45793231	1741122	0	0
46292961	1125315	0	0
45688196	46275916	1	1
45897990	1125315	0	0
46307226	1119510	0	0
46303622	1119510	0	0
45896568	1125315	0	0
4028076	4280726	4	5
4029205	4202832	4	4
21001191	914335	0	0
21004494	1717327	0	0
21602735	1551099	0	0
36203073	4296204	1	1
36151155	1125315	0	0
36225034	19129144	2	3
42805788	914335	0	0
42802638	40174880	2	3
44354432	1119510	0	0
44353326	1119510	0	0
45655996	1119510	0	0
45662776	1000560	0	0
45622502	1125315	0	0
45638467	1119510	0	0
45670122	1154029	0	0
45654299	1129625	0	0
45707648	1545959	2	3
45673867	1000560	0	0
45683876	1125315	0	0
45678331	19079524	1	1
45784853	19078461	2	3
45694221	1174888	0	0
45693861	1174888	0	0
46288830	19019273	2	3
45793236	1107830	0	0
46293181	1125315	0	0
45688196	19079524	1	1
45897927	1125315	0	0
46307411	1119510	0	0
46303279	1119510	0	0
45896766	1125315	0	0
201618	81893	4	5
4029205	4145310	5	5
21001191	975125	0	0
21004495	1717327	0	0
21602737	975125	0	0
36203073	4296205	1	1
36155724	1125315	0	0
36225033	19133679	2	3
42805789	740275	0	0
44345264	19018935	2	3
44354461	1119510	0	0
44353244	1119510	0	0
45655832	1119510	0	0
45661406	723013	0	0
45622507	1125315	0	0
45638571	1119510	0	0
45670123	738818	0	0
45654611	1129625	0	0
45777937	40223768	2	3
45673869	1153428	0	0
45683888	1125315	0	0
45690208	19079524	1	1
45681591	19078461	2	3
45694296	1154343	0	0
45694050	1149196	0	0
46291631	43012036	2	3
45793460	723013	0	0
46293194	1125315	0	0
45700038	19079524	1	1
45897929	1125315	0	0
46307235	1119510	0	0
46303580	1119510	0	0
45896774	1125315	0	0
253549	4146173	4	5
4029205	4275113	5	7
21001252	975125	0	0
21004491	1717327	0	0
21604762	742185	0	0
36203073	4299128	1	1
36155726	1125315	0	0
36225033	19127922	2	3
42805650	723013	0	0
44344880	19019273	2	3
44350683	1119510	0	0
44353258	1119510	0	0
45656102	1119510	0	0
45661203	1746114	0	0
45622458	1125315	0	0
45638505	1119510	0	0
45670267	791967	0	0
45655435	1129625	0	0
45707818	40232448	2	3
45673824	1115008	0	0
45683889	1125315	0	0
45690208	46275916	1	1
45693408	40228214	2	3
45694307	1557272	0	0
45694151	1778162	0	0
46291649	40229134	2	3
45793455	1557272	0	0
46293210	1125315	0	0
45690864	19079524	1	1
45897708	1125315	0	0
46307236	1119510	0	0
46303722	1119510	0	0
45896530	1125315	0	0
4024567	4283893	4	5
4029205	4107731	5	7
21001283	1125315	0	0
21004199	1738521	0	0
21604206	19016749	0	0
35602665	4280726	1	1
36155807	1125315	0	0
36225033	19129144	2	3
42805739	920293	0	0
44353184	19019273	2	3
44350513	1119510	0	0
44353163	1119510	0	0
45656103	1119510	0	0
45661203	1741122	0	0
45622600	1125315	0	0
45635235	1119510	0	0
45670000	740275	0	0
45651234	1129625	0	0
45704945	1127433	2	3
45673942	1107830	0	0
45683879	1125315	0	0
45674837	46275916	1	1
45779899	1539411	2	3
45694227	1308738	0	0
45694152	1549786	0	0
46288935	40236446	2	3
45793345	1308738	0	0
46293420	1125315	0	0
45684781	46275916	1	1
45895341	1125315	0	0
46307241	1119510	0	0
46303676	1119510	0	0
45894897	1125315	0	0
4180628	317576	4	5
4029205	4301346	5	6
21001283	1129625	0	0
21004249	1125315	0	0
35507492	1332418	0	0
35909419	198809	1	1
36155836	1125315	0	0
36427938	40220386	2	3
42805741	920293	0	0
44355219	19075001	2	3
44350541	1119510	0	0
44355240	1119510	0	0
45655911	1119510	0	0
45661206	19127890	0	0
45622444	1125315	0	0
45635251	1119510	0	0
45670001	1174888	0	0
45651216	1129625	0	0
45705125	40232448	2	3
45674073	1149196	0	0
45683890	1125315	0	0
45674837	19079524	1	1
45685108	1539411	2	3
45694315	1112807	0	0
45694152	1515774	0	0
46289317	40231925	2	3
45793158	967823	0	0
46293166	1125315	0	0
45684781	19079524	1	1
45895500	1125315	0	0
46307267	1119510	0	0
46303559	1119510	0	0
45894903	1125315	0	0
4180628	4329847	4	5
4029205	40492359	5	9
21001283	1177480	0	0
21004249	1150836	0	0
35507625	1192710	0	0
35702748	440448	1	1
36155941	1125315	0	0
36426867	1115171	2	3
42805745	1713332	0	0
42802725	19019273	2	3
44350546	1119510	0	0
44355303	1119510	0	0
45656027	1119510	0	0
45661206	1515774	0	0
45622376	1125315	0	0
45635407	1119510	0	0
45670005	1192710	0	0
45651478	1129625	0	0
45704800	40163554	2	3
45670538	1149196	0	0
45683971	1125315	0	0
45691417	19079524	1	1
45690931	1539411	2	3
45694328	705944	0	0
45694098	1149196	0	0
46289069	1332419	2	3
45793349	1149196	0	0
46293232	1125315	0	0
45706602	19079524	1	1
45895502	1125315	0	0
46307593	1119510	0	0
46303789	1119510	0	0
45803591	1125315	0	0
4028071	4056621	4	5
4029205	4336464	6	10
21001283	1192710	0	0
21004249	1107830	0	0
35507625	1112807	0	0
35702743	192671	1	1
36155900	1125315	0	0
36426867	19019273	2	3
42805745	1759842	0	0
44363014	19019273	2	3
44350726	1119510	0	0
44355328	1119510	0	0
45656029	1119510	0	0
45661206	1549786	0	0
45620712	1125315	0	0
45635267	1119510	0	0
45670055	1107830	0	0
45651665	1129625	0	0
45704928	19077572	2	3
45670549	1000560	0	0
45683978	1125315	0	0
45696262	46275916	1	1
45706148	19079524	2	3
45694348	740275	0	0
45694155	1000560	0	0
46243630	19008572	2	3
45793259	1361711	0	0
46292844	1125315	0	0
45699929	19079524	1	1
45895463	1125315	0	0
46307545	1119510	0	0
46303619	1119510	0	0
45803625	1125315	0	0
4023995	317576	4	5
4029205	4037675	6	7
21001385	1717327	0	0
21011303	1361711	0	0
35507392	1149196	0	0
35702744	192671	1	1
36156016	1125315	0	0
36426668	19007333	2	3
42805695	1137529	0	0
44353107	19019273	2	3
44350941	1119510	0	0
44353447	1119510	0	0
45656405	1119510	0	0
45661284	1549786	0	0
45620828	1125315	0	0
45635359	1119510	0	0
45670012	1154343	0	0
45651561	1129625	0	0
45691799	19078461	2	3
45670656	1717327	0	0
45684000	1125315	0	0
45696755	19079524	1	1
45678759	1539411	2	3
45694349	1174888	0	0
45694161	975125	0	0
46243732	1127433	2	3
45793260	705944	0	0
46293398	1125315	0	0
45875957	3051031	2	2
45895542	1125315	0	0
46307312	1119510	0	0
46303755	1119510	0	0
45803821	1125315	0	0
4023995	4329847	4	5
4029205	4314290	6	6
21001430	975125	0	0
21011419	1154029	0	0
35507497	1149196	0	0
35702754	30753	1	1
36155838	1125315	0	0
36426679	40236446	2	3
42805695	1149380	0	0
44359019	1551192	2	3
44350919	1119510	0	0
44353409	1119510	0	0
45656411	1119510	0	0
45661284	19127890	0	0
45620938	1125315	0	0
45635533	1119510	0	0
45670079	1192710	0	0
45648510	1129625	0	0
45703632	40228214	2	3
45673280	967823	0	0
45684012	1125315	0	0
45687698	46275916	1	1
45682201	19079524	2	3
45694352	1154343	0	0
45694041	1192710	0	0
46243736	1115171	2	3
45793355	1549786	0	0
46287953	1125315	0	0
46239754	46233988	2	3
45896804	1125315	0	0
46307210	1119510	0	0
46303320	1119510	0	0
45803897	1125315	0	0
4022922	4035415	4	5
4029205	4243062	6	6
21001385	1729720	0	0
21011419	1110410	0	0
35507600	740275	0	0
35702775	4027663	1	1
36155943	1125315	0	0
36424292	40232448	2	3
42805699	1177480	0	0
44362653	1551192	2	3
44350925	1119510	0	0
44345742	1119510	0	0
45652628	1119510	0	0
45661284	1589505	0	0
45620984	1125315	0	0
45635645	1119510	0	0
45670081	1149196	0	0
45648427	1129625	0	0
45778879	1107882	2	3
45672997	1107830	0	0
45684018	1125315	0	0
45682476	19079524	1	1
45688319	40228214	2	3
45694261	1326303	0	0
45693752	1310149	0	0
46243586	40229134	2	3
45793355	19127890	0	0
46287955	1125315	0	0
46239754	46233710	2	3
45896728	1125315	0	0
46307632	1119510	0	0
46303697	1119510	0	0
45803899	1125315	0	0
4022922	4059173	4	5
4029205	4125906	6	6
21001430	1112807	0	0
21011415	1154029	0	0
35507614	740275	0	0
35604745	40224805	1	1
36155780	1125315	0	0
36424373	46233710	2	3
42805889	1738521	0	0
44341618	1545959	2	3
44350766	1119510	0	0
44345437	1119510	0	0
45652667	1119510	0	0
45661287	1548195	0	0
45620986	1125315	0	0
45635660	1119510	0	0
45670086	1192710	0	0
45645280	1129625	0	0
45670805	1107882	2	3
45673080	1115008	0	0
45680702	1125315	0	0
45677741	46275916	1	1
45685146	40228214	2	3
45694445	1310149	0	0
45693754	1713332	0	0
46243772	40229134	2	3
45793355	1515774	0	0
46288160	1125315	0	0
45894621	1107882	2	3
45875969	3004501	2	2
46307681	1119510	0	0
46303685	1119510	0	0
45803900	1125315	0	0
4022922	4109685	4	5
4029205	4195803	3	3
21001427	1728416	0	0
21004631	1728416	0	0
35507601	1713332	0	0
35605480	35605482	1	1
36155882	1125315	0	0
36424373	46233988	2	3
42805793	1713332	0	0
44359421	19123231	2	3
44346851	1119510	0	0
44348085	1119510	0	0
45652446	1119510	0	0
45661289	1713332	0	0
45621153	1125315	0	0
45634235	1119510	0	0
45670312	1192710	0	0
45645345	1129625	0	0
45676781	1107882	2	3
45673081	1307863	0	0
45680750	1125315	0	0
45679775	46275916	1	1
45684902	40228214	2	3
45694465	1107830	0	0
45694133	1308738	0	0
46241313	40229134	2	3
45793361	1549786	0	0
46288022	1125315	0	0
45796664	1107882	2	3
45875971	3049273	2	2
46302151	1119510	0	0
46304024	1119510	0	0
45803684	1125315	0	0
4027553	261325	2	5
4029205	4187458	3	3
21001283	738818	0	0
21004631	1717327	0	0
35507603	1153428	0	0
36002868	133834	1	1
36156211	1125315	0	0
36244035	19125062	2	3
42805793	1759842	0	0
44356246	40223834	2	3
44346947	1119510	0	0
44348037	1119510	0	0
45652639	1119510	0	0
45661542	1367571	0	0
45621046	1125315	0	0
45632284	1119510	0	0
45670314	1501700	0	0
45645452	1129625	0	0
45701293	1107882	2	3
45673003	738818	0	0
45680457	1125315	0	0
45708101	46275916	1	1
45706587	40228214	2	3
45694466	1112807	0	0
45694136	1124957	0	0
46241331	19057271	2	3
45793361	19127890	0	0
46287961	1125315	0	0
46240291	40173590	2	3
45791320	19128022	2	2
46302156	1119510	0	0
46303918	1119510	0	0
45803594	1125315	0	0
254068	4112343	2	5
4029205	4199276	3	3
21001283	1149196	0	0
21004620	1551099	0	0
35507671	740275	0	0
36002868	317009	1	1
36156217	1125315	0	0
36426817	35605858	2	3
42805810	742185	0	0
44356246	40223821	2	3
44346913	1119510	0	0
44345853	1119510	0	0
45655036	1119510	0	0
45659462	1110410	0	0
45620772	1125315	0	0
45632324	1119510	0	0
45670263	1713332	0	0
45645406	1129625	0	0
45778595	1107882	2	3
45673410	1728416	0	0
45680668	1125315	0	0
45763613	4285898	1	1
45693483	40228214	2	3
45694479	1112807	0	0
45694141	914335	0	0
46241352	920334	2	3
45793361	1521369	0	0
46288045	1125315	0	0
46244860	40223768	2	3
45791320	19128263	2	2
46302005	1119510	0	0
46303494	1119510	0	0
45803552	1125315	0	0
4034850	4015189	2	5
4029205	4163951	3	3
21000198	1738521	0	0
21004633	1717327	0	0
35507673	1115008	0	0
35604830	35605858	1	1
36156026	1125315	0	0
36217214	40232448	2	3
42805814	1124957	0	0
44352901	1545959	2	3
44346916	1119510	0	0
44345839	1119510	0	0
45655043	1119510	0	0
45659342	1539403	0	0
45620770	1125315	0	0
45632508	1119510	0	0
45670450	920293	0	0
45642367	1129625	0	0
45671147	19073183	2	3
45673131	740275	0	0
45680574	1125315	0	0
45763653	4230399	1	1
45693784	40228214	2	3
45694485	1112807	0	0
45694144	1367571	0	0
46241520	19059056	2	3
45793364	975125	0	0
46288056	1125315	0	0
45790835	19078461	2	3
45875968	3000963	2	3
46301868	1119510	0	0
46300876	1119510	0	0
45803602	1125315	0	0
4162282	40486433	5	5
4029205	4012477	3	6
21000199	1738521	0	0
21004633	1778162	0	0
35507607	1153428	0	0
36203051	134438	1	1
36156044	1125315	0	0
36425676	19019979	2	3
42805822	1515774	0	0
44351536	19123231	2	3
44347116	1119510	0	0
44345891	1119510	0	0
45655170	1119510	0	0
45659420	701322	0	0
45621202	1125315	0	0
45632355	1119510	0	0
45670452	1154343	0	0
45642409	1129625	0	0
45674274	1107882	2	3
45673136	1521369	0	0
45680436	1125315	0	0
45766333	4294548	1	1
45678776	40228214	2	3
45694489	1512674	0	0
45694148	708298	0	0
46241600	40162522	2	3
45793365	1149196	0	0
46288298	1125315	0	0
45896108	1107882	2	3
45875968	40766240	2	3
46302300	1119510	0	0
46300885	1119510	0	0
45803805	1125315	0	0
435244	440086	5	5
4029205	4010253	3	7
21000220	1738521	0	0
21004634	1728416	0	0
35507610	933724	0	0
36102149	4048171	5	5
36156027	1125315	0	0
36425676	19078461	2	3
42805544	1713332	0	0
44348645	1545959	2	3
44347038	1119510	0	0
44345921	1119510	0	0
45655334	1119510	0	0
45659376	1343916	0	0
45621205	1125315	0	0
45632612	1119510	0	0
45668067	1717327	0	0
45642439	1129625	0	0
45679291	1332419	2	3
45673004	1713332	0	0
45680710	1125315	0	0
45765647	4132546	1	1
45690828	40228214	2	3
45694613	1174888	0	0
45693862	1738521	0	0
46241603	19008572	2	3
45794637	1539403	0	0
46288301	1125315	0	0
45790801	40223768	2	3
45875968	40769179	2	3
46302395	1119510	0	0
46301079	1119510	0	0
45803866	1125315	0	0
437515	4144583	5	5
4029205	4323902	3	7
21000221	1738521	0	0
21004634	1778162	0	0
35507733	1322184	0	0
36100000	40486433	5	5
36156001	1125315	0	0
36217216	1127078	2	3
42805544	1759842	0	0
44345477	19019273	2	3
44347009	1119510	0	0
44345933	1119510	0	0
45655346	1119510	0	0
45659381	738818	0	0
45620904	1125315	0	0
45629465	1119510	0	0
45668116	1174888	0	0
45642585	1129625	0	0
45701137	1332419	2	3
45673004	1759842	0	0
45680721	1125315	0	0
45766714	134438	1	1
45699914	40228214	2	3
45694489	1549786	0	0
45693863	1557272	0	0
46241606	1115171	2	3
45794860	740275	0	0
46288311	1125315	0	0
45796553	19075001	2	3
45875968	40769194	2	3
46302257	1119510	0	0
46301694	1119510	0	0
45803845	1125315	0	0
432795	4113008	5	5
4029205	4163971	3	8
21000219	1738521	0	0
21004634	1717327	0	0
35507373	1125315	0	0
36102898	28060	5	5
36156195	1125315	0	0
36217216	19007333	2	3
42805549	1738521	0	0
44349312	1107882	2	3
44347024	1119510	0	0
44341222	1119510	0	0
45652778	1119510	0	0
45659435	1149196	0	0
45621089	1125315	0	0
45629168	1119510	0	0
45668153	1174888	0	0
45642578	1129625	0	0
45707879	19073183	2	3
45673087	1557272	0	0
45680722	1125315	0	0
45705650	46275916	1	1
45682622	40228214	2	3
45694435	1112807	0	0
45694016	1729720	0	0
46241628	19075601	2	3
45794730	705944	0	0
46288259	1125315	0	0
46244872	40223768	2	3
45875968	40769189	2	3
46302427	1119510	0	0
46301915	1119510	0	0
45803673	1125315	0	0
4101796	4001336	5	5
4029205	42535580	7	8
21000224	1738521	0	0
21004632	1728416	0	0
35507561	791967	0	0
36102898	433125	5	5
36156198	1125315	0	0
36300000	4310024	8	12
42805830	1500211	0	0
44341860	19078461	2	3
44347092	1119510	0	0
44338687	1119510	0	0
45652781	1119510	0	0
45659444	723013	0	0
45621193	1125315	0	0
45629605	1119510	0	0
45668155	967823	0	0
45642749	1129625	0	0
45669314	19078461	2	3
45673129	1000560	0	0
45680732	1125315	0	0
45703996	19079524	1	1
45693766	40228214	2	3
45694280	715997	0	0
45694017	1174888	0	0
46241673	40231925	2	3
45794807	1115008	0	0
46288203	1125315	0	0
46299474	1107882	2	3
45875968	40769184	2	3
46306832	1119510	0	0
46301336	1119510	0	0
45803678	1125315	0	0
4028071	4266809	5	5
4029205	4078793	2	2
21000222	1738521	0	0
21004632	1717327	0	0
35507567	1000560	0	0
35202461	441267	5	5
36156199	1125315	0	0
36300000	4152936	8	13
42805551	1551099	0	0
42803038	19075601	2	3
44347184	1119510	0	0
44338675	1119510	0	0
45652929	1119510	0	0
45659514	1713332	0	0
45621197	1125315	0	0
45629237	1119510	0	0
45668169	1000560	0	0
45640168	1129625	0	0
45698445	1107882	2	3
45670722	723013	0	0
45680558	1125315	0	0
45702426	40171902	1	1
45691001	40228214	2	3
45694602	975125	0	0
45693864	791967	0	0
46238795	40229134	2	3
45794658	1153428	0	0
46288335	1125315	0	0
45896062	19073183	2	3
46289275	46275916	1	1
46306867	1119510	0	0
46301192	1119510	0	0
45803954	1125315	0	0
4028071	255848	5	5
4029205	4191853	2	2
21000223	1738521	0	0
21004633	1728416	0	0
35507568	914335	0	0
36202155	81151	5	5
36156201	1125315	0	0
36300000	4285898	8	15
42805822	1549786	0	0
44352347	19078924	2	3
44347248	1119510	0	0
44338682	1119510	0	0
45652812	1119510	0	0
45659382	1501700	0	0
45621159	1125315	0	0
45629573	1119510	0	0
45668175	1115008	0	0
45639452	1129625	0	0
45633115	1107882	2	3
45700521	1129625	0	0
45680743	1125315	0	0
45699186	46275916	1	1
45706412	40228214	2	3
45694506	1551099	0	0
45694028	1000560	0	0
46238561	40229134	2	3
45794661	1110410	0	0
46288360	1125315	0	0
45791435	19073183	2	3
46301326	19079524	1	1
46306971	1119510	0	0
46301200	1119510	0	0
45803880	1125315	0	0
200174	133834	5	5
4199402	81893	10	11
21000217	1738521	0	0
21004635	1728416	0	0
35507572	1115008	0	0
36202155	40479422	5	5
36156202	1125315	0	0
36300000	4094814	8	8
42805824	1738521	0	0
44344696	1107882	2	3
44343221	1119510	0	0
44338741	1119510	0	0
45652765	1119510	0	0
45659386	1307863	0	0
45664674	1125315	0	0
45629475	1119510	0	0
45668190	1118084	0	0
45639593	1129625	0	0
45677220	1107882	2	3
45698987	1129625	0	0
45680862	1125315	0	0
45699528	46275916	1	1
45706856	19079524	2	3
45691242	1149196	0	0
45693990	967823	0	0
46238782	19076374	2	3
45794685	1115008	0	0
46288417	1125315	0	0
45787996	19073183	2	3
46301391	46275916	1	1
46299800	1119510	0	0
46301319	1119510	0	0
45803979	1125315	0	0
4024000	195588	5	5
4199402	4218389	4	5
21000242	1738521	0	0
21004635	1746114	0	0
35507374	1129625	0	0
35202461	4283893	5	6
36156203	1125315	0	0
36300000	4142905	9	13
42805577	1125315	0	0
44359234	1107882	2	3
44343229	1119510	0	0
44338882	1119510	0	0
45649459	1119510	0	0
45659396	753626	0	0
45664678	1125315	0	0
45629495	1119510	0	0
45668086	1501700	0	0
45639759	1129625	0	0
45686376	1545959	2	3
45698973	1129625	0	0
45680863	1125315	0	0
45696085	40171902	1	1
45691285	40228214	2	3
45691244	1112807	0	0
45693985	1110410	0	0
46238624	19077572	2	3
45794688	975125	0	0
46288443	1125315	0	0
45796532	19073183	2	3
46301478	46275916	1	1
46299907	1119510	0	0
46301309	1119510	0	0
45675364	19127904	3	4
4023995	4310024	5	5
4199402	4043241	9	10
21000247	1738521	0	0
21004635	1741122	0	0
35507734	1115008	0	0
35205038	28060	5	6
36156435	1125315	0	0
36300000	4001336	9	13
42805894	708298	0	0
44359444	1107882	2	3
44343285	1119510	0	0
44339050	1119510	0	0
45649535	1119510	0	0
45659354	1310149	0	0
45664598	1125315	0	0
45629409	1119510	0	0
45668088	1521369	0	0
45636313	1129625	0	0
45704576	19019273	2	3
45699005	1129625	0	0
45680888	1125315	0	0
45694630	19079524	1	1
45706215	40228214	2	3
45691329	1307863	0	0
45694112	1149196	0	0
46238818	19008572	2	3
45787926	1728416	0	0
46288456	1125315	0	0
45798316	40228214	2	3
46322460	19079524	2	3
46299926	1119510	0	0
46301405	1119510	0	0
45896768	19129144	3	4
254068	4048171	5	5
4199402	440448	9	9
21000227	1738521	0	0
21004635	1778162	0	0
35507736	1759842	0	0
35205038	40481087	5	6
36156437	1125315	0	0
36300000	4048695	9	13
42805895	1310149	0	0
44341645	1107882	2	3
44343113	1119510	0	0
44338806	1119510	0	0
45649601	1119510	0	0
45659357	1326303	0	0
45664712	1125315	0	0
45626510	1119510	0	0
45668183	1174888	0	0
45636509	1129625	0	0
45778896	1332419	2	3
45695514	1129625	0	0
45677405	1125315	0	0
45693724	46275916	1	1
45777725	19079524	2	3
45691322	1149196	0	0
45694034	1115008	0	0
46238825	1127433	2	3
45787930	975125	0	0
46288772	1125315	0	0
45795984	40223768	2	3
46321959	1107882	2	3
46299938	1119510	0	0
46301325	1119510	0	0
441840	313217	7	12
4199402	195588	5	8
21000235	1738521	0	0
21004635	1717327	0	0
35507736	1713332	0	0
36100000	258780	5	6
36156604	1125315	0	0
36300000	4146173	9	13
42805871	1322184	0	0
44362578	1332419	2	3
44343417	1119510	0	0
44339063	1119510	0	0
45649615	1119510	0	0
45659459	1308738	0	0
45664714	1125315	0	0
45626737	1119510	0	0
45668123	1347450	0	0
45636395	1129625	0	0
45680650	40228214	2	3
45695572	1129625	0	0
45677390	1125315	0	0
45691425	19079524	1	1
45690805	40228214	2	3
45691131	1112807	0	0
45694118	967823	0	0
46240079	1115171	2	3
45787943	1000560	0	0
46288803	1125315	0	0
45796385	1107882	2	3
46306989	1107882	2	3
46299870	1119510	0	0
46301409	1119510	0	0
441840	4048171	7	12
4199402	4142905	5	8
21000228	1738521	0	0
21004737	1308738	0	0
35507640	1125315	0	0
21604181	40220386	5	6
36158860	1125315	0	0
36300000	40481087	9	13
42805647	1115008	0	0
44356127	40173590	2	3
44343422	1119510	0	0
44339070	1119510	0	0
45649886	1119510	0	0
45659545	19003953	0	0
45667415	1125315	0	0
45626619	1119510	0	0
45668124	1153428	0	0
45636485	1129625	0	0
45692346	1332419	2	3
45695613	1129625	0	0
45677427	1125315	0	0
45687440	19079524	1	1
45694112	40228214	2	3
45691133	1192710	0	0
45694122	1307863	0	0
45897645	40232448	2	3
45787944	1738521	0	0
46288684	1125315	0	0
45893969	1107882	2	3
46311462	19075601	2	3
46300027	1119510	0	0
46301441	1119510	0	0
441840	81893	7	13
4199402	4285898	5	10
21502534	1307863	0	0
21004854	1717327	0	0
35507684	1713332	0	0
36102154	4056621	5	7
36158838	1125315	0	0
36300000	4149245	9	13
42805904	1177480	0	0
42802893	19078461	2	3
44343423	1119510	0	0
44360409	1119510	0	0
45649715	1119510	0	0
45659546	742185	0	0
45664745	1125315	0	0
45626540	1119510	0	0
45668130	920293	0	0
45636493	1129625	0	0
45683385	1332419	2	3
45695766	1129625	0	0
45677499	1125315	0	0
45681611	19079524	1	1
45678916	19079524	2	3
45691303	1112807	0	0
45694896	1124957	0	0
45897657	40229134	2	3
45787990	1115008	0	0
46288691	1125315	0	0
46293919	40222846	2	3
46321769	19078461	2	3
46300089	1119510	0	0
46301712	1119510	0	0
441840	433644	7	8
4199402	4066995	5	7
21502524	920293	0	0
21004855	975125	0	0
35507684	1759842	0	0
36203062	4156265	5	7
36158849	1125315	0	0
36300000	81151	9	14
42805905	1549786	0	0
44345193	40173590	2	3
44343465	1119510	0	0
44360396	1119510	0	0
45649941	1119510	0	0
45659547	1738521	0	0
45664822	1125315	0	0
45626979	1119510	0	0
45668319	1308738	0	0
45637250	1129625	0	0
45705050	40173590	2	3
45695833	1129625	0	0
45677323	1125315	0	0
45681515	46275916	1	1
45678489	19079524	2	3
45691305	1154029	0	0
45694415	975125	0	0
45897686	40163554	2	3
45787996	1713332	0	0
46288701	1125315	0	0
46244034	1107882	2	3
46310951	19078461	2	3
46300226	1119510	0	0
46319235	1119510	0	0
441840	441267	6	7
4199402	198199	5	7
21501259	967823	0	0
21004856	1728416	0	0
35507941	1154343	0	0
36203062	4132546	5	7
36158935	1125315	0	0
36300000	4230399	9	14
42805905	1519936	0	0
44355207	19075601	2	3
44343514	1119510	0	0
44360060	1119510	0	0
45649001	1119510	0	0
45659509	1174888	0	0
45664795	1125315	0	0
45623286	1119510	0	0
45668321	920293	0	0
45633536	1129625	0	0
45695190	1332419	2	3
45694511	1129625	0	0
45677541	1125315	0	0
45678625	19079524	1	1
45672772	19079524	2	3
45691324	740275	0	0
45690931	1539403	0	0
45897732	1551192	2	3
45787950	933724	0	0
46288761	1125315	0	0
45790939	1107882	2	3
46321908	19079524	2	3
46300040	1119510	0	0
46319770	1119510	0	0
441840	442116	6	7
4199402	78272	5	7
19010482	19010482	0	0
21004756	975125	0	0
35507576	1124300	0	0
35702767	4285898	5	7
36158677	1125315	0	0
36300000	40486433	9	14
42805794	715997	0	0
44352163	1332419	2	3
44343527	1119510	0	0
44360349	1119510	0	0
45649106	1119510	0	0
45659513	1310149	0	0
45664870	1125315	0	0
45623294	1119510	0	0
45668325	1124957	0	0
45633398	1129625	0	0
45676708	40173590	2	3
45692411	1129625	0	0
45677417	1125315	0	0
45678943	46275916	1	1
45697022	40223768	2	3
45802509	791967	0	0
45690939	975125	0	0
45897738	40224132	2	3
45787982	975125	0	0
46288716	1125315	0	0
46244219	1107882	2	3
46322127	40228214	2	3
46299996	1119510	0	0
46319771	1119510	0	0
441840	28060	6	9
4199402	140673	5	5
19010530	19134077	0	0
21004758	1595799	0	0
35507577	1501700	0	0
36102144	4294548	5	7
36159085	1125315	0	0
36300000	4296204	9	12
42805797	1125315	0	0
44345297	19075601	2	3
44343648	1119510	0	0
44360239	1119510	0	0
45646491	1119510	0	0
45659582	1551099	0	0
45664759	1125315	0	0
45623295	1119510	0	0
45668326	1307863	0	0
45633343	1129625	0	0
45707385	1332419	2	3
45692425	1129625	0	0
45677422	1125315	0	0
45678141	19127922	1	1
45682237	19078461	2	3
45802487	1545958	0	0
45690941	1717327	0	0
45897744	40232448	2	3
45788011	1149196	0	0
46244800	1125315	0	0
45801712	19078461	2	3
46321937	19078461	2	3
46300111	1119510	0	0
46322571	1119510	0	0
441840	255848	6	9
4199402	4029498	5	5
21003349	914335	0	0
21004758	1396131	0	0
35507642	975125	0	0
36102144	4116491	5	7
36159086	1125315	0	0
36300000	439406	9	10
42805800	19127890	0	0
44356224	19075601	2	3
44339818	1119510	0	0
44359936	1119510	0	0
45646528	1119510	0	0
45659529	1539403	0	0
45664968	1125315	0	0
45623513	1119510	0	0
45668286	705944	0	0
45633637	1129625	0	0
45698218	1332419	2	3
45692734	1129625	0	0
45677453	1125315	0	0
45678141	19133679	1	1
45678632	19078461	2	3
45802488	1153428	0	0
45690950	1326303	0	0
45897836	1539411	2	3
45787962	967823	0	0
46244804	1125315	0	0
45896089	1107882	2	3
46306460	19078461	2	3
46300113	1119510	0	0
46319844	1119510	0	0
441840	4149245	6	10
4199402	4166224	8	9
21003376	1129625	0	0
21004753	1746114	0	0
35507644	1129625	0	0
35802134	4285898	5	8
36159092	1125315	0	0
36300000	4306014	9	10
42805800	1589505	0	0
44345802	19079524	2	3
44339793	1119510	0	0
44359938	1119510	0	0
45646467	1119510	0	0
45659584	715997	0	0
45664879	1125315	0	0
45623520	1119510	0	0
45668106	1192710	0	0
45633440	1129625	0	0
45680418	40228214	2	3
45692390	1129625	0	0
45677593	1125315	0	0
45678141	19129144	1	1
45690780	19078461	2	3
45802323	1521369	0	0
45690951	975125	0	0
45897703	19059056	2	3
45788002	1124300	0	0
46244751	1125315	0	0
46242523	19078461	2	3
46316821	40228214	2	3
46300104	1119510	0	0
46319857	1119510	0	0
441840	4278672	6	10
4199402	258780	8	8
21003376	1343916	0	0
21004753	1741122	0	0
35507650	1129625	0	0
35205038	258780	5	8
36158776	1125315	0	0
36300000	4048169	9	10
42805800	1549786	0	0
44344946	19078461	2	3
44339906	1119510	0	0
44360306	1119510	0	0
45646646	1119510	0	0
45659472	1551099	0	0
45665068	1125315	0	0
45623363	1119510	0	0
45668108	1307863	0	0
45633544	1129625	0	0
45676402	19078461	2	3
45692615	1129625	0	0
45677700	1125315	0	0
45676347	19079524	1	1
45696917	19078461	2	3
45802323	1595799	0	0
45691054	1192710	0	0
45897917	40224805	2	3
45788024	1174888	0	0
46244656	1125315	0	0
45788113	19078461	2	3
46311229	19078461	2	3
46300340	1119510	0	0
46319936	1119510	0	0
441840	321042	6	10
4199402	372328	6	6
21003375	1129625	0	0
21004852	975125	0	0
35507651	1125315	0	0
35205038	4048171	5	8
36158903	1125315	0	0
36300000	4296205	9	9
42805553	1713332	0	0
44338265	19078461	2	3
44339885	1119510	0	0
44360262	1119510	0	0
45646605	1119510	0	0
45659473	1738521	0	0
45665071	1125315	0	0
45623630	1119510	0	0
45668161	738818	0	0
45633750	1129625	0	0
45698405	19078461	2	3
45692567	1129625	0	0
45677712	1125315	0	0
45769811	4001336	1	1
45690696	19078461	2	3
45802323	1549786	0	0
45691060	1501700	0	0
45897856	920300	2	3
45788026	1149196	0	0
46244657	1125315	0	0
46243963	40173590	2	3
45787463	1115171	2	3
46300245	1119510	0	0
46320058	1119510	0	0
441840	80502	5	7
4199402	4113008	6	6
21003385	1551099	0	0
21002821	1125315	0	0
35507652	1125315	0	0
36102154	4294548	5	8
36159114	1125315	0	0
36300000	4059173	10	13
42805520	967823	0	0
44345655	40228214	2	3
44339871	1119510	0	0
44362727	1119510	0	0
45646727	1119510	0	0
45656518	1174888	0	0
45664622	1125315	0	0
45623636	1119510	0	0
45668113	1548195	0	0
45630496	1129625	0	0
45683318	19078461	2	3
45692670	1129625	0	0
45677763	1125315	0	0
45702780	19079524	1	1
45780020	19078461	2	3
45802620	1549786	0	0
45691003	1713332	0	0
45897961	1107882	2	3
45788005	1192710	0	0
46243272	1125315	0	0
45801651	40173590	2	3
45787504	19059056	2	3
46300159	1119510	0	0
46319976	1119510	0	0
441840	260139	5	10
4199402	4155034	6	6
21003223	1129625	0	0
21002811	1124300	0	0
35507653	1125315	0	0
36100000	4056621	5	8
36158924	1125315	0	0
36300000	81893	10	16
42805911	1551099	0	0
44352766	1539411	2	3
44339876	1119510	0	0
44362800	1119510	0	0
45646585	1119510	0	0
45656316	738818	0	0
45664321	1125315	0	0
45667703	1119510	0	0
45665999	1332418	0	0
45630507	1129625	0	0
45669527	19075601	2	3
45692694	1129625	0	0
45677779	1125315	0	0
45702671	46275916	1	1
45694183	19078461	2	3
45802620	1521369	0	0
45691003	1759842	0	0
45895497	40232448	2	3
45788006	791967	0	0
46243284	1125315	0	0
45793455	40173590	2	3
45787509	782047	2	3
46296475	1119510	0	0
46320009	1119510	0	0
441840	4329847	5	11
4199402	380378	6	6
21003205	738818	0	0
21002812	975125	0	0
35507653	1119510	0	0
36203062	4001336	5	8
36159122	1125315	0	0
36300000	433644	10	11
42805922	1729720	0	0
44352685	40228214	2	3
44340117	1119510	0	0
44360555	1119510	0	0
45643811	1119510	0	0
45656536	1124957	0	0
45664329	1125315	0	0
45667842	1119510	0	0
45666000	1107830	0	0
45630323	1129625	0	0
45698518	19078461	2	3
45692709	1129625	0	0
45677781	1125315	0	0
45702668	46275916	1	1
45699715	19078461	2	3
45802631	1545958	0	0
45690898	1000560	0	0
45895570	19133873	2	3
45788038	757627	0	0
46243296	1125315	0	0
45798606	1332419	2	3
45787683	19074841	2	3
46296065	1119510	0	0
46320014	1119510	0	0
441840	133834	8	10
4199402	4109685	6	7
21003371	1000560	0	0
21002827	1115008	0	0
35507658	715997	0	0
36202157	40479768	5	10
36159003	1125315	0	0
36500000	381316	6	6
42805632	1557272	0	0
44359433	40228214	2	3
44340125	1119510	0	0
44360534	1119510	0	0
45643324	1119510	0	0
45656220	1361711	0	0
45662086	1125315	0	0
45667913	1119510	0	0
45665936	1310149	0	0
45630328	1129625	0	0
45674103	19075601	2	3
45692701	1129625	0	0
45677926	1125315	0	0
45696828	19079524	1	1
45706173	19078461	2	3
45802498	1124957	0	0
45690863	1107830	0	0
45895573	1332419	2	3
45788128	975125	0	0
46243301	1125315	0	0
46239381	40173590	2	3
45787739	19008572	2	3
46296348	1119510	0	0
46320029	1119510	0	0
441840	40479422	8	11
4199402	4056621	6	7
21003226	1129625	0	0
21002827	1551099	0	0
35507596	1174888	0	0
36203062	4230399	5	9
36158929	1125315	0	0
36500000	4310024	5	7
42805717	1119510	0	0
44345358	19079524	2	3
44340256	1119510	0	0
44360541	1119510	0	0
45643739	1119510	0	0
45656228	1343916	0	0
45662037	1125315	0	0
45667738	1119510	0	0
45665773	1309944	0	0
45630547	1129625	0	0
45779128	19078461	2	3
45689589	1129625	0	0
45677845	1125315	0	0
45692832	46275916	1	1
45780104	19078461	2	3
45802654	920293	0	0
45691080	1738521	0	0
45896724	19008572	2	3
45788040	723013	0	0
46243364	1125315	0	0
46294692	1332419	2	3
45787492	19019273	2	3
46318427	1119510	0	0
46319883	1119510	0	0
441840	4280726	4	11
4199402	4310024	6	7
21003246	914335	0	0
21002822	1125315	0	0
35507596	1125315	0	0
36203062	40479768	5	9
36159294	1125315	0	0
36500000	4280726	7	7
42805718	1149380	0	0
44359115	19078461	2	3
44340285	1119510	0	0
44353470	1119510	0	0
45643485	1119510	0	0
45656434	1149196	0	0
45662147	1125315	0	0
45667750	1119510	0	0
45665774	1717327	0	0
45630756	1129625	0	0
45707180	19075601	2	3
45689596	1129625	0	0
45677857	1125315	0	0
45692855	46275916	1	1
45706463	19078461	2	3
45802331	1332418	0	0
45691036	1713332	0	0
45896728	1127433	2	3
45788041	1149196	0	0
46243381	1125315	0	0
45801501	1332419	2	3
45801113	46233710	2	3
46318429	1119510	0	0
46313781	1119510	0	0
441840	134438	3	8
4199402	4294548	6	9
21003205	1125315	0	0
21002822	1112807	0	0
35507661	1112807	0	0
36203062	40479422	5	9
36159298	1125315	0	0
36500000	40486433	7	7
42805720	1307863	0	0
44352523	19078461	2	3
44338045	1119510	0	0
44353456	1119510	0	0
45643341	1119510	0	0
45656508	1367571	0	0
45662069	1125315	0	0
45667837	1119510	0	0
45665794	914335	0	0
45630575	1129625	0	0
45683257	19075601	2	3
45689275	1129625	0	0
45677791	1125315	0	0
45692887	46275916	1	1
45684735	19078461	2	3
45802567	967823	0	0
45691036	1759842	0	0
45896701	1713671	2	3
45788063	791967	0	0
46243370	1125315	0	0
46242380	19079524	2	3
45801205	1115171	2	3
46318452	1119510	0	0
46313826	1119510	0	0
441840	192671	2	7
4199402	4001336	6	8
21003220	1000560	0	0
21002811	1118084	0	0
35507479	1107830	0	0
36200000	4230399	5	11
36159235	1125315	0	0
36500000	317576	7	7
42902788	1310034	0	0
44353090	19078461	2	3
44338048	1119510	0	0
44353460	1119510	0	0
45643500	1119510	0	0
45656509	1309944	0	0
45662101	1125315	0	0
45667596	1119510	0	0
45665804	742185	0	0
45630582	1129625	0	0
45676407	40228214	2	3
45691624	1129625	0	0
45674401	1125315	0	0
45690025	46275916	1	1
45691035	19078461	2	3
45802585	1738521	0	0
45691039	1309944	0	0
45799698	19073183	2	3
45787972	1124957	0	0
46243332	1125315	0	0
45896077	19078461	2	3
45802355	19076374	2	3
46318454	1119510	0	0
46313798	1119510	0	0
1125443	19029476	2	3
4199402	4152936	6	8
21003250	1124300	0	0
21002827	1118084	0	0
35507482	1729720	0	0
36200000	4109685	5	9
36159130	1125315	0	0
36500000	134438	7	7
42902852	40224132	0	0
44359077	19078461	2	3
45619873	1119510	0	0
44353430	1119510	0	0
45643614	1119510	0	0
45656510	19127890	0	0
45662014	1125315	0	0
45668017	1119510	0	0
45665614	933724	0	0
45627588	1129625	0	0
45778723	19079524	2	3
45689697	1129625	0	0
45674005	1125315	0	0
45690088	46275916	1	1
45684614	40174880	2	3
45802389	1153428	0	0
45691089	1115008	0	0
46242289	1107882	2	3
45788104	1545958	0	0
46243320	1125315	0	0
45791529	19078461	2	3
45802515	40229134	2	3
46318574	1119510	0	0
46313687	1119510	0	0
920293	920334	2	3
4199402	261325	6	8
21003251	933724	0	0
21002839	1551099	0	0
35507485	1125315	0	0
36200000	4152936	5	10
36159131	1125315	0	0
36500000	40479768	6	11
42806840	1738521	0	0
44345088	19078461	2	3
45619849	1119510	0	0
44353649	1119510	0	0
45643631	1119510	0	0
45656510	1549786	0	0
45662173	1125315	0	0
45667861	1119510	0	0
45665615	967823	0	0
45627686	1129625	0	0
45780900	40228214	2	3
45689676	1129625	0	0
45674157	1125315	0	0
45688740	19079524	1	1
45700037	19078461	2	3
45802538	1149196	0	0
45691102	753626	0	0
45801071	46233710	2	3
45788051	1309944	0	0
46243416	1125315	0	0
45791216	19075601	2	3
45802406	19078461	2	3
46318534	1119510	0	0
46313725	1119510	0	0
4042650	4024289	2	3
4199402	81151	7	8
21003348	914335	0	0
21002813	975125	0	0
35507485	738818	0	0
21604344	1127078	0	3
36159343	1125315	0	0
36500000	40479422	6	11
42806978	1124957	0	0
44359352	19078461	2	3
45619886	1119510	0	0
44353419	1119510	0	0
45640743	1119510	0	0
45656450	1768849	0	0
45662269	1125315	0	0
45667249	1119510	0	0
45665904	1154343	0	0
45624613	1129625	0	0
45707824	19079524	2	3
45686779	1129625	0	0
45674282	1125315	0	0
45688519	19079524	1	1
45699731	19078461	2	3
45802402	1521369	0	0
45691188	1539403	0	0
45786045	19078461	2	3
45788219	1124957	0	0
46243468	1125315	0	0
45791068	19075601	2	3
45802939	1125315	0	0
46318677	1119510	0	0
46314041	1119510	0	0
4024656	4108705	2	3
4199402	4134304	7	8
21003119	1129625	0	0
21002844	1115008	0	0
35507485	1119510	0	0
21604344	1127433	0	3
36159293	1125315	0	0
36500000	78272	5	11
42806983	1129625	0	0
44362856	19078461	2	3
45620127	1119510	0	0
44353544	1119510	0	0
45640970	1119510	0	0
45656586	1149196	0	0
45662337	1125315	0	0
45665590	1119510	0	0
45665820	1149196	0	0
45624620	1129625	0	0
45676847	40228214	2	3
45686455	1129625	0	0
45674408	1125315	0	0
45683758	19079524	1	1
45684591	19078461	2	3
45802539	1115008	0	0
45690982	1110410	0	0
45798523	1107882	2	3
45788226	1174888	0	0
46243345	1125315	0	0
45798740	19075601	2	3
45802949	1125315	0	0
46318889	1119510	0	0
46314360	1119510	0	0
4165549	4198190	2	3
4199402	196456	7	7
21002691	1149380	0	0
21002844	1112807	0	0
35507641	1713332	0	0
35205189	4329847	0	0
36159212	1125315	0	0
36500000	4296204	5	8
42807194	1738521	0	0
44345523	19078461	2	3
45620213	1119510	0	0
44353666	1119510	0	0
45640729	1119510	0	0
45656371	1149196	0	0
45662050	1125315	0	0
45665680	1119510	0	0
45666022	1124300	0	0
45624451	1129625	0	0
45780810	19078461	2	3
45686693	1129625	0	0
45676229	1125315	0	0
45671438	19079524	1	1
45706494	19078461	2	3
45802540	914335	0	0
45690909	975125	0	0
46240804	1557272	0	0
45788262	1501700	0	0
46243348	1125315	0	0
46293961	19075601	2	3
45803213	1125315	0	0
46319028	1119510	0	0
46314363	1119510	0	0
201618	4166224	2	3
4199402	4266809	7	7
21002690	975125	0	0
21002845	975125	0	0
35507757	1000560	0	0
35204966	321042	0	0
36159404	1125315	0	0
36500000	4048171	8	8
42807022	705944	0	0
44362819	19078461	2	3
45620054	1119510	0	0
44353881	1119510	0	0
45640996	1119510	0	0
45656562	1332418	0	0
45662052	1125315	0	0
45665633	1119510	0	0
45666201	1332418	0	0
45624685	1129625	0	0
45685403	40228214	2	3
45686731	1129625	0	0
45676260	1125315	0	0
45688731	19079524	1	1
45685015	19078461	2	3
45802574	791967	0	0
45691285	1149196	0	0
46240805	1549786	0	0
45788239	1107830	0	0
46243419	1125315	0	0
45793390	19075601	2	3
45802957	1125315	0	0
46319097	1119510	0	0
46313849	1119510	0	0
1310149	40163554	2	3
4199402	375671	7	9
21002692	1149380	0	0
21002744	43012036	2	3
35507885	1759842	0	0
35204966	4324181	0	0
36159418	1125315	0	0
36500000	4113008	8	8
42806883	933724	0	0
44356177	19078461	2	3
45620067	1119510	0	0
44353519	1119510	0	0
45640984	1119510	0	0
45656259	1545958	0	0
45662210	1125315	0	0
45663134	1119510	0	0
45666053	1501700	0	0
45668467	1129625	0	0
45674073	40228214	2	3
45686985	1129625	0	0
45674414	1125315	0	0
45699218	19079524	1	1
45699721	19078461	2	3
45802632	1154343	0	0
45691259	1149196	0	0
46240805	1521369	0	0
45788241	1115008	0	0
46243479	1125315	0	0
45801511	19075601	2	3
45803069	1125315	0	0
46318776	1119510	0	0
46314068	1119510	0	0
1309944	1310034	2	3
4117930	313217	6	9
21002691	975125	0	0
21002744	19112599	2	3
35507885	1713332	0	0
35205160	317576	0	0
36159162	1125315	0	0
36500000	4152936	8	10
42807280	1738521	0	0
44345484	19078461	2	3
44361622	1119510	0	0
44353815	1119510	0	0
45641072	1119510	0	0
45656261	1115008	0	0
45662544	1125315	0	0
45663231	1119510	0	0
45666057	1713332	0	0
45668913	1129625	0	0
45686448	19078461	2	3
45687035	1129625	0	0
45674472	1125315	0	0
45702227	46275916	1	1
45780474	19078461	2	3
45802570	1192710	0	0
45691020	1115008	0	0
46240805	19127890	0	0
45788242	1549786	0	0
46243481	1125315	0	0
45791119	19075601	2	3
45803205	1125315	0	0
46313174	1119510	0	0
46314075	1119510	0	0
705944	40236446	2	3
4117930	4266809	6	6
21002322	1741122	0	0
21002744	40232448	2	3
35507888	1154343	0	0
21604086	19003953	0	0
36159174	1125315	0	0
36500000	4230399	5	10
42806991	1549786	0	0
44345401	19078461	2	3
44341469	1125315	0	0
44353939	1119510	0	0
45640935	1119510	0	0
45656593	1000560	0	0
45662260	1125315	0	0
45663184	1119510	0	0
45666059	738818	0	0
45668957	1129625	0	0
45695178	40228214	2	3
45683560	1129625	0	0
45674547	1125315	0	0
45702227	19079524	1	1
45782796	19078461	2	3
45688448	1501700	0	0
45691027	1551099	0	0
46240917	705944	0	0
45788272	1548195	0	0
46240852	1125315	0	0
46243684	19075601	2	3
45803313	1125315	0	0
46313177	1119510	0	0
46314372	1119510	0	0
1589505	1718412	2	3
4117930	255848	6	6
21002299	920293	0	0
21505757	40222846	2	3
35507890	1119510	0	0
21603967	1177480	0	0
36159369	1125315	0	0
36500000	4149245	4	10
42806991	1512674	0	0
44338115	19078461	2	3
45619689	1125315	0	0
44346021	1119510	0	0
45641047	1119510	0	0
45656467	1551099	0	0
45658830	1125315	0	0
45663347	1119510	0	0
45666064	1778162	0	0
45666636	1129625	0	0
45778587	1539411	2	3
45683708	1129625	0	0
45674432	1125315	0	0
45695379	19079524	1	1
45699922	19078461	2	3
45688456	933724	0	0
45691028	1310149	0	0
46241039	1000560	0	0
45788273	1115008	0	0
46240858	1125315	0	0
46238966	19075601	2	3
45803288	1125315	0	0
46312710	1119510	0	0
46314264	1119510	0	0
1589505	46221626	2	3
4117930	260139	6	6
21002321	1717327	0	0
21013432	19129655	2	3
35507873	1112807	0	0
21603968	1115008	0	0
36159543	1125315	0	0
36500000	4146173	4	10
42807242	1177480	0	0
44352684	1545959	2	3
45619706	1125315	0	0
44346190	1119510	0	0
45640939	1119510	0	0
45656472	1332418	0	0
45659078	1125315	0	0
45663358	1119510	0	0
45665665	738818	0	0
45666712	1129625	0	0
45676880	40228214	2	3
45683801	1129625	0	0
45674507	1125315	0	0
45689807	19079524	1	1
45780113	19078461	2	3
45688457	1112807	0	0
45691030	920293	0	0
46241025	1192710	0	0
45788254	1713332	0	0
46241050	1125315	0	0
45896210	19075601	2	3
45803390	1125315	0	0
46312960	1119510	0	0
46314535	1119510	0	0
723013	19076374	2	3
4117930	196456	6	6
21002321	1713332	0	0
21004223	19073188	2	3
35507820	1332418	0	0
21603980	1177480	0	0
36159363	1125315	0	0
36500000	81151	4	10
42807303	708298	0	0
44348791	1539411	2	3
45621554	1125315	0	0
44346195	1119510	0	0
45640822	1119510	0	0
45656042	1322184	0	0
45658967	1125315	0	0
45663405	1119510	0	0
45665668	1154029	0	0
45664247	1129625	0	0
45676880	40228230	2	3
45683781	1129625	0	0
45674436	1125315	0	0
45692707	19079524	1	1
45685101	19078461	2	3
45688459	1174888	0	0
45691343	1343916	0	0
46240975	1738521	0	0
45788159	1192710	0	0
46242537	1125315	0	0
46296697	40228214	2	3
45803392	1125315	0	0
46312697	1119510	0	0
46314592	1119510	0	0
715997	40223768	2	3
4117930	4056621	5	6
21002325	920293	0	0
21004223	19073183	2	3
35507901	1125315	0	0
21603312	1154343	0	0
36159488	1125315	0	0
36500000	4109685	8	9
42807306	1548195	0	0
44341723	40174880	2	3
45621608	1125315	0	0
44346153	1119510	0	0
45637669	1119510	0	0
45656615	1738521	0	0
45659083	1125315	0	0
45663373	1119510	0	0
45665925	1110410	0	0
45664254	1129625	0	0
45633061	40228214	2	3
45683850	1129625	0	0
45674525	1125315	0	0
45686763	19079524	1	1
45694103	19078461	2	3
45688282	1500211	0	0
45691355	1332418	0	0
46240985	1000560	0	0
45788201	1343916	0	0
46242546	1125315	0	0
45896200	19075601	2	3
45803400	1125315	0	0
46312605	1119510	0	0
46314551	1119510	0	0
715997	45892894	2	3
4117930	4310024	5	6
21002325	1717327	0	0
21004232	19073188	2	3
35507967	1551099	0	0
36156685	723013	0	0
36159489	1125315	0	0
36500000	4048695	4	9
42806922	1125315	0	0
44352675	1332419	2	3
45621610	1125315	0	0
44346258	1119510	0	0
45637847	1119510	0	0
45656594	1501700	0	0
45659085	1125315	0	0
45663194	1119510	0	0
45666109	1551099	0	0
45664263	1129625	0	0
45778886	1539411	2	3
45684060	1129625	0	0
45671471	1125315	0	0
45670075	19079524	1	1
45702971	19078461	2	3
45688542	1713332	0	0
45691316	1307863	0	0
46240988	1729720	0	0
45788324	1115008	0	0
46242486	1125315	0	0
46242374	40223768	2	3
45803130	1125315	0	0
46313148	1119510	0	0
46314567	1119510	0	0
1305058	19007333	2	3
4117930	45769019	5	6
21002325	1746114	0	0
21004232	19073183	2	3
35507968	967823	0	0
36156591	1501700	0	0
36159500	1125315	0	0
36500000	4035415	4	9
42806879	1125315	0	0
44352780	1539411	2	3
45621666	1125315	0	0
44346160	1119510	0	0
45637687	1119510	0	0
45656378	967823	0	0
45659091	1125315	0	0
45663456	1119510	0	0
45666038	1149196	0	0
45664269	1129625	0	0
45688968	40228214	2	3
45680702	1129625	0	0
45671604	1125315	0	0
45671618	19079524	1	1
45690729	1332419	2	3
45688640	975125	0	0
45691167	723013	0	0
46241100	705944	0	0
45788330	1500211	0	0
46242163	1125315	0	0
46244832	40228214	2	3
45803384	1125315	0	0
46313150	1119510	0	0
46314582	1119510	0	0
1308738	964261	2	3
4117930	4329847	5	8
21002227	926487	0	0
21004635	46275444	2	3
35507780	1125315	0	0
36156592	1713332	0	0
36159320	1125315	0	0
36500000	133834	9	9
42806879	1174888	0	0
44359432	1539411	2	3
45621696	1125315	0	0
44346310	1119510	0	0
45637889	1119510	0	0
45656543	1124957	0	0
45659118	1125315	0	0
45663459	1119510	0	0
45666095	1539403	0	0
45664368	1129625	0	0
45781100	40228214	2	3
45680750	1129625	0	0
45671642	1125315	0	0
45701784	46275916	1	1
45699900	1332419	2	3
45688528	1192710	0	0
45691384	1149196	0	0
46241110	1124957	0	0
45788116	1539403	0	0
46242166	1125315	0	0
45875959	40758406	2	3
45803326	1125315	0	0
46312928	1119510	0	0
46314674	1119510	0	0
975125	19008572	2	3
4117930	4116491	5	5
21001798	1746114	0	0
21004635	19129655	2	3
21604271	1102527	0	0
36156691	1343916	0	0
36159572	1125315	0	0
36313966	4280726	4	11
42807110	701322	0	0
44786893	3013682	1	1
45621717	1125315	0	0
44346228	1119510	0	0
45637909	1119510	0	0
45656241	1713332	0	0
45658979	1125315	0	0
45663596	1119510	0	0
45666190	1551099	0	0
45664548	1129625	0	0
45779076	19079524	2	3
45680763	1129625	0	0
45671647	1125315	0	0
45692911	19079524	1	1
45678678	1332419	2	3
45800047	1000560	0	0
45691129	975125	0	0
46241111	975125	0	0
45788082	1713332	0	0
46242170	1125315	0	0
45804315	40228214	2	3
45803075	1125315	0	0
46312932	1119510	0	0
46314686	1119510	0	0
967823	19079524	2	3
4117930	261325	5	7
21001801	1717327	0	0
21004233	19073183	2	3
21604272	1154029	0	0
36156692	1343916	0	0
36159584	1125315	0	0
36313966	257012	4	10
42807159	1125315	0	0
44786911	3016723	1	1
45619802	1125315	0	0
44346465	1119510	0	0
45637700	1119510	0	0
45656243	1343916	0	0
45658981	1125315	0	0
45659665	1119510	0	0
45666195	1361711	0	0
45661113	1129625	0	0
45695206	40228214	2	3
45680721	1129625	0	0
45671648	1125315	0	0
45695666	19079524	1	1
45703055	1332419	2	3
45799993	1192710	0	0
45691181	1107830	0	0
46240641	738818	0	0
45788081	1367571	0	0
46242490	1125315	0	0
45801573	40228214	2	3
45803079	1125315	0	0
46313223	1119510	0	0
46314340	1119510	0	0
4042646	4186930	3	3
4117930	321042	5	7
21001796	1759842	0	0
21004233	19073188	2	3
21603404	1119510	0	0
36156784	1119510	0	0
36159152	1125315	0	0
36313966	40479422	8	11
42807159	1124957	0	0
44359617	19074679	1	1
45619744	1125315	0	0
44346267	1119510	0	0
45634696	1119510	0	0
45656245	1343916	0	0
45659193	1125315	0	0
45659917	1119510	0	0
45666166	1149196	0	0
45661114	1129625	0	0
45778624	40228214	2	3
45680743	1129625	0	0
45671599	1125315	0	0
45708101	19079524	1	1
45684876	40174880	2	3
45799791	1149196	0	0
45691174	1192710	0	0
46240642	1107830	0	0
45788231	1332418	0	0
46242494	1125315	0	0
45787962	19079524	2	3
45800456	1125315	0	0
46313074	1119510	0	0
46315024	1119510	0	0
201618	440448	3	3
4117930	4166224	7	8
21001801	1713332	0	0
21601121	964261	2	3
21603398	1174888	0	0
36156787	1118084	0	0
36159585	1125315	0	0
36313966	4144583	8	8
42807198	1309944	0	0
44353136	46275916	1	1
45619820	1125315	0	0
44346383	1119510	0	0
45634669	1119510	0	0
45658433	723013	0	0
45659316	1125315	0	0
45659845	1119510	0	0
45666042	1153428	0	0
45661323	1129625	0	0
45698368	40228214	2	3
45677360	1129625	0	0
45671575	1125315	0	0
45677461	19079524	1	1
45876002	3008598	1	1
45800082	757627	0	0
45688744	1124957	0	0
46238197	1549786	0	0
45788363	1149196	0	0
46242362	1125315	0	0
46239324	40228214	2	3
45800485	1125315	0	0
46313236	1119510	0	0
46308793	1119510	0	0
254068	40481087	3	3
4117930	440448	8	8
21001801	1768849	0	0
21004633	19129655	2	3
21601747	1332418	0	0
36156768	1129625	0	0
36159597	1125315	0	0
36313966	4218389	5	7
42807203	1738521	0	0
44345292	19127922	1	1
44360997	1125315	0	0
44346644	1119510	0	0
45634673	1119510	0	0
45658355	1332418	0	0
44341743	1125315	0	0
45659846	1119510	0	0
45666199	1521369	0	0
45661278	1129625	0	0
45707695	40223768	2	3
45677404	1129625	0	0
45671629	1125315	0	0
45699186	19079524	1	1
45697275	19079524	1	1
45800056	1107830	0	0
45688381	967823	0	0
46238197	19127890	0	0
45788365	1124957	0	0
46241203	1125315	0	0
46238882	40228214	2	3
45800470	1125315	0	0
46307767	1119510	0	0
46308992	1119510	0	0
254068	28060	3	3
4042150	4198190	8	8
21001802	1713332	0	0
21002491	19019979	2	3
35507961	1551099	0	0
36156772	1119510	0	0
36159614	1125315	0	0
36313966	4051466	5	6
42807011	1595799	0	0
44345292	19133679	1	1
44360998	1125315	0	0
44339012	1119510	0	0
45634802	1119510	0	0
45658363	738818	0	0
44357596	1125315	0	0
45659868	1119510	0	0
45666049	1192710	0	0
45654793	1129625	0	0
45704551	40228214	2	3
45677607	1129625	0	0
45671540	1125315	0	0
45701653	46275916	1	1
45675904	19079524	1	1
45800090	1343916	0	0
45688020	1124957	0	0
46233988	46233988	0	0
45788082	1759842	0	0
46241209	1125315	0	0
45896664	19078461	2	3
45800518	1125315	0	0
46307833	1119510	0	0
46309421	1119510	0	0
254068	257012	3	3
1332450	1332419	1	1
21001801	1741122	0	0
21002491	1127078	2	3
35507929	740275	0	0
36156780	1119510	0	0
36159615	1125315	0	0
36313966	4174876	5	6
42807011	1521369	0	0
44345292	19129144	1	1
44360940	1125315	0	0
44339235	1119510	0	0
45634808	1119510	0	0
45658367	1343916	0	0
44357916	1125315	0	0
45649369	1129625	0	0
45665760	914335	0	0
45635062	1112807	0	0
45669478	40223768	2	3
45677326	1129625	0	0
45673015	1125315	0	0
45701653	19079524	1	1
45675920	19079524	1	1
45800200	975125	0	0
45688068	1000560	0	0
46240075	1112807	0	0
45788084	1595799	0	0
46241297	1125315	0	0
45896332	40228214	2	3
45800525	1125315	0	0
46307504	1119510	0	0
46308948	1119510	0	0
4024567	4051466	3	3
1322187	19075601	1	1
21001801	1759842	0	0
21004493	19129655	2	3
35507934	967823	0	0
36156619	1307863	0	0
36151146	1125315	0	0
36313966	30753	5	9
42807011	1549786	0	0
44362889	1153428	0	0
44361446	1125315	0	0
44339121	1119510	0	0
45634419	1119510	0	0
45658413	914335	0	0
44357894	1125315	0	0
45649441	1129625	0	0
45665762	1174888	0	0
45635103	1112807	0	0
45698744	40228214	2	3
45677533	1129625	0	0
45673147	1125315	0	0
45686755	19079524	1	1
45672963	19079524	1	1
45800202	1107830	0	0
45688115	1174888	0	0
46240076	1549786	0	0
45788084	1521369	0	0
46241248	1125315	0	0
46239578	40228214	2	3
45800492	1125315	0	0
46307508	1119510	0	0
46308896	1119510	0	0
4101796	381316	3	3
1539465	1539411	1	1
21001801	1746114	0	0
21002154	46275444	2	3
35507935	967823	0	0
36156620	967823	0	0
36151289	1125315	0	0
36313966	4035415	5	9
42807012	738818	0	0
44362962	1112807	0	0
44361373	1125315	0	0
44339125	1119510	0	0
45634552	1119510	0	0
45658376	1778162	0	0
44358058	1125315	0	0
45631774	1129625	0	0
45665887	738818	0	0
45635056	1112807	0	0
45676918	40223768	2	3
45677713	1129625	0	0
45673354	1125315	0	0
45692894	19079524	1	1
45675848	19079524	1	1
45800204	1149196	0	0
45688040	1545958	0	0
46240076	1512674	0	0
45788084	1549786	0	0
46241375	1125315	0	0
46239080	40228214	2	3
45800635	1125315	0	0
46307863	1119510	0	0
46309229	1119510	0	0
4011630	4029498	3	3
753630	40220386	1	1
21001801	1778162	0	0
21001950	46233710	2	3
35507976	1738521	0	0
36156298	1119510	0	0
36151282	1125315	0	0
36313966	4132546	5	9
42807063	1551099	0	0
44363068	1177480	0	0
44361372	1125315	0	0
44339023	1119510	0	0
45636907	1119510	0	0
45658417	1102527	0	0
44357717	1125315	0	0
45632049	1129625	0	0
45666257	1713332	0	0
45635085	1112807	0	0
45781241	19078461	2	3
45677480	1129625	0	0
45673318	1125315	0	0
45699045	19079524	1	1
45681043	19079524	1	1
45800213	975125	0	0
45688044	1332418	0	0
46239971	1107830	0	0
45788208	715997	0	0
46241282	1125315	0	0
46294109	40228214	2	3
45800638	1125315	0	0
46307864	1119510	0	0
46309119	1119510	0	0
4028074	4134304	3	3
1137537	40169281	1	1
21001804	1778162	0	0
21001950	46233988	2	3
35507978	1177480	0	0
36156232	1000560	0	0
36152163	1125315	0	0
36313966	380378	5	8
42807064	1778162	0	0
44362900	1154343	0	0
44361542	1125315	0	0
44339025	1119510	0	0
45637120	1119510	0	0
45658426	1713332	0	0
44357760	1125315	0	0
45632016	1129625	0	0
45666257	1759842	0	0
45635164	1112807	0	0
45683530	19078461	2	3
45677781	1129625	0	0
45673266	1125315	0	0
45680848	46275916	1	1
45676089	19079524	1	1
45800215	1778162	0	0
45688160	1322184	0	0
46240073	757627	0	0
45788337	1713332	0	0
46241229	1125315	0	0
45791253	19079524	2	3
45800561	1125315	0	0
46307935	1119510	0	0
46309334	1119510	0	0
252662	260139	3	3
1000599	35605482	1	1
21001802	1759842	0	0
21001692	40163554	2	3
35507590	1177480	0	0
36156398	975125	0	0
36152284	1125315	0	0
36313966	381316	5	8
42807176	1115008	0	0
44363088	1112807	0	0
44361547	1125315	0	0
44339263	1119510	0	0
45631644	1119510	0	0
45658447	1174888	0	0
44357910	1125315	0	0
45632226	1129625	0	0
45666260	1501700	0	0
45635137	1112807	0	0
45669673	40223768	2	3
45674401	1129625	0	0
45673101	1125315	0	0
45680848	19079524	1	1
45694310	19079524	1	1
45800221	1115008	0	0
45688126	1124957	0	0
46239987	1112807	0	0
45788337	1759842	0	0
46241269	1125315	0	0
46294544	40228214	2	3
45800531	1125315	0	0
46307718	1119510	0	0
46309256	1119510	0	0
201820	4144583	3	3
25297	4112343	1	1
21001802	1717327	0	0
21004386	1551192	2	3
35508001	1125315	0	0
35506945	1322184	0	0
36152391	1125315	0	0
36313966	378419	5	10
42806885	1310149	0	0
44363093	1107830	0	0
44361662	1125315	0	0
44339580	1119510	0	0
45631618	1119510	0	0
45656650	1551099	0	0
44357992	1125315	0	0
45634096	1129625	0	0
45666271	1115008	0	0
45635390	1112807	0	0
45677126	19078461	2	3
45674284	1129625	0	0
45671670	1125315	0	0
45701931	19079524	1	1
45703277	46275916	1	1
45800174	708298	0	0
45688165	1539403	0	0
46239987	1124957	0	0
46293988	1310149	0	0
46241272	1125315	0	0
46238179	40228214	2	3
45800694	1125315	0	0
46307726	1119510	0	0
46309183	1119510	0	0
260131	261325	3	3
1127495	1127078	1	1
21001804	1768849	0	0
21004634	19129655	2	3
35508049	715997	0	0
35506947	1589505	0	0
36151398	1125315	0	0
36313966	4152936	5	10
42807275	1545958	0	0
44362983	1115008	0	0
44361702	1125315	0	0
44339454	1119510	0	0
45631466	1119510	0	0
45656640	1115008	0	0
44357863	1125315	0	0
45634211	1129625	0	0
45665725	967823	0	0
45629980	1112807	0	0
45779055	19078461	2	3
45674394	1129625	0	0
45671663	1125315	0	0
45701931	46275916	1	1
45703277	19079524	1	1
45800188	1548195	0	0
45688319	1149196	0	0
46239990	1192710	0	0
46294014	975125	0	0
46241391	1125315	0	0
45893588	40228214	2	3
45800545	1125315	0	0
46308217	1119510	0	0
46309434	1119510	0	0
260131	258780	3	3
920335	920300	1	1
21001806	1717327	0	0
21001874	1551192	2	3
35102374	439777	2	2
35506824	1119510	0	0
36151458	1125315	0	0
36313966	4294548	5	11
42807276	1512674	0	0
44362914	1124957	0	0
44361579	1125315	0	0
44339588	1119510	0	0
45631651	1119510	0	0
45656632	1124300	0	0
44358095	1125315	0	0
45628972	1129625	0	0
45666089	791967	0	0
45630166	1112807	0	0
45677191	19078461	2	3
45674404	1129625	0	0
45669946	1125315	0	0
45702201	19079524	1	1
45697526	19079524	1	1
45799908	975125	0	0
45688321	1174888	0	0
46240041	1332418	0	0
46294020	1326303	0	0
46238440	1125315	0	0
45894123	19078461	2	3
45800720	1125315	0	0
46308266	1119510	0	0
46309472	1119510	0	0
437409	375671	3	3
440059	4280726	1	1
21001804	1713332	0	0
21001909	1551192	2	3
35102391	4280726	2	2
35506829	705944	0	0
36151496	1125315	0	0
36313966	4112343	5	11
42807276	19127890	0	0
44362916	1115008	0	0
44361677	1125315	0	0
44360451	1119510	0	0
45631806	1119510	0	0
45652901	1343916	0	0
44357874	1125315	0	0
45629049	1129625	0	0
45666244	715997	0	0
45627110	1112807	0	0
45695240	19078461	2	3
45674547	1129625	0	0
45669956	1125315	0	0
45674516	19079524	1	1
45700439	19079524	1	1
45800063	1112807	0	0
45688323	920293	0	0
46240047	967823	0	0
46293927	1738521	0	0
46238327	1125315	0	0
45796482	19079524	2	3
45800735	1125315	0	0
46308280	1119510	0	0
46309192	1119510	0	0
437409	378001	3	3
317009	4051466	1	1
21001804	1717327	0	0
21001912	1551192	2	3
35104392	4056621	2	2
35506818	1119510	0	0
36151602	1125315	0	0
36313966	4285898	5	12
42807276	1549786	0	0
44362919	1305058	0	0
44361269	1125315	0	0
44360453	1119510	0	0
45631782	1119510	0	0
45652908	1501700	0	0
44357975	1125315	0	0
45629050	1129625	0	0
45666168	1717327	0	0
45627511	1112807	0	0
45695276	19078461	2	3
45674529	1129625	0	0
45669979	1125315	0	0
45674413	46275916	1	1
45694233	19079524	1	1
45800354	975125	0	0
45688333	1115008	0	0
46240128	1000560	0	0
46293933	1115008	0	0
46238395	1125315	0	0
45893841	19078461	2	3
45800507	1125315	0	0
46307917	1119510	0	0
46309394	1119510	0	0
4013518	439777	3	3
318443	317576	1	1
21001806	1778162	0	0
21001903	1551192	2	3
21604186	782043	2	2
35506822	1501700	0	0
36151472	1125315	0	0
36313966	40486433	6	11
42807047	1549786	0	0
44362995	738818	0	0
44361277	1125315	0	0
44360582	1119510	0	0
45631736	1119510	0	0
45653050	1118084	0	0
44358075	1125315	0	0
45627886	1129625	0	0
45666250	1000560	0	0
45624044	1112807	0	0
45778634	19078461	2	3
45674578	1129625	0	0
45669983	1125315	0	0
45674413	19079524	1	1
45703381	19079524	1	1
45800359	1521369	0	0
45688194	975125	0	0
46240165	1729720	0	0
46293662	1551099	0	0
46238397	1125315	0	0
46239526	40228214	2	3
45800593	1125315	0	0
46308291	1119510	0	0
46309396	1119510	0	0
4148091	440086	3	3
256440	4283893	1	1
21001808	1746114	0	0
21001850	19075001	2	3
21604186	19039298	2	2
35506959	1119510	0	0
36151502	1125315	0	0
36313966	4156265	6	9
42807047	19127890	0	0
44363103	1174888	0	0
44360965	1125315	0	0
44360509	1119510	0	0
45632199	1119510	0	0
45653053	967823	0	0
44358082	1125315	0	0
45628009	1129625	0	0
45666254	1174888	0	0
45624136	1112807	0	0
45778617	19078461	2	3
45671555	1129625	0	0
45670155	1125315	0	0
45680835	19079524	1	1
45681060	19079524	1	1
45800359	19127890	0	0
45688203	1192710	0	0
46238234	1332418	0	0
46294131	1174888	0	0
46238502	1125315	0	0
46298769	40228214	2	3
45800699	1125315	0	0
46308179	1119510	0	0
46303659	1119510	0	0
4087571	4107731	3	3
140708	4066995	1	1
21001809	1746114	0	0
21001841	19075001	2	3
21604186	19002770	2	2
35506963	1177480	0	0
36151488	1125315	0	0
36313966	255848	6	9
42807047	1512674	0	0
44363243	738818	0	0
44361476	1125315	0	0
44360896	1119510	0	0
45632200	1119510	0	0
45653058	1107830	0	0
44358028	1125315	0	0
45626119	1129625	0	0
45666175	738818	0	0
45624186	1112807	0	0
45698267	19078461	2	3
45673346	1129625	0	0
45670157	1125315	0	0
45655021	46275916	1	1
45681060	46275916	1	1
45800359	1549786	0	0
45688205	1174888	0	0
46238238	1115008	0	0
46293776	975125	0	0
46238507	1125315	0	0
45791026	40228214	2	3
45800711	1125315	0	0
46308438	1119510	0	0
46306393	1119510	0	0
253549	80502	3	3
24818	4218389	1	1
21001806	1759842	0	0
21001741	19075001	2	3
35102392	4280726	2	2
35506838	1729720	0	0
36151454	1125315	0	0
36313966	28060	6	9
42807051	705944	0	0
44363026	1174888	0	0
44361304	1125315	0	0
44360697	1119510	0	0
45632152	1119510	0	0
45653040	791967	0	0
44358234	1125315	0	0
45626139	1129625	0	0
45666183	1000560	0	0
45624190	1112807	0	0
45669563	19078461	2	3
45669916	1129625	0	0
45670013	1125315	0	0
45655021	19079524	1	1
45673095	19079524	1	1
45800326	1174888	0	0
45688240	1343916	0	0
46238244	1107830	0	0
46293779	1192710	0	0
46238508	1125315	0	0
46291786	19079524	1	1
45800808	1125315	0	0
46308427	1119510	0	0
46307005	1119510	0	0
253549	4035415	3	3
31610	30753	1	1
21001809	1778162	0	0
21001860	46275916	2	3
35102395	4280726	2	2
35506841	975125	0	0
36151646	1125315	0	0
36313966	4048695	6	10
42806895	1343916	0	0
44363029	1149380	0	0
44361347	1125315	0	0
44360673	1119510	0	0
45628600	1119510	0	0
45652832	1310149	0	0
44358237	1125315	0	0
45626205	1129625	0	0
45663605	1107830	0	0
45624247	1112807	0	0
45780908	19078461	2	3
45783716	1129625	0	0
45669916	1125315	0	0
45684194	19079524	1	1
45703626	19079524	1	1
45800128	723013	0	0
45688244	1174888	0	0
46238216	1713332	0	0
46293780	1115008	0	0
46238532	1125315	0	0
46289784	19079524	1	1
45800814	1125315	0	0
46308413	1119510	0	0
46306477	1119510	0	0
4012176	4125906	3	3
73571	40480160	1	1
21001626	1112807	0	0
21013627	1551192	2	3
35102398	4280726	2	2
35506842	705944	0	0
36151607	1125315	0	0
36313966	321042	6	10
42807263	933724	0	0
44363031	740275	0	0
44361306	1125315	0	0
44360606	1119510	0	0
45628602	1119510	0	0
45652919	1322184	0	0
44358150	1125315	0	0
45626210	1129625	0	0
45663619	1149196	0	0
45668261	1112807	0	0
45633146	19078461	2	3
45783762	1129625	0	0
45783735	1125315	0	0
45686880	19079524	1	1
45691342	19079524	1	1
45685677	1305058	0	0
45688355	1174888	0	0
46238216	1759842	0	0
46293961	1322184	0	0
46238310	1125315	0	0
46295154	46275916	1	1
45800818	1125315	0	0
46308425	1119510	0	0
46307118	1119510	0	0
4012185	4057420	3	3
73553	80180	1	1
21001630	1332418	0	0
21503326	19008572	2	3
21603821	1500211	0	0
35506843	1177480	0	0
36151424	1125315	0	0
36313966	4146173	6	10
42807269	1548195	0	0
44363228	1115008	0	0
44360980	1125315	0	0
44360885	1119510	0	0
45631044	1119510	0	0
45653016	1174888	0	0
44358161	1125315	0	0
45626418	1129625	0	0
45663636	967823	0	0
45668403	1112807	0	0
45683241	19078461	2	3
45783757	1129625	0	0
45783768	1125315	0	0
45706099	19127918	2	2
45673113	19079524	1	1
45685900	1154343	0	0
45688358	1548195	0	0
46238284	1149196	0	0
46293537	1539403	0	0
46238318	1125315	0	0
46295154	19079524	1	1
45800839	1125315	0	0
46302645	1119510	0	0
46307073	1119510	0	0
4012907	4301346	3	3
75909	80502	1	1
21001654	1322184	0	0
21013411	19074843	2	3
21603058	920293	0	0
35507048	1332418	0	0
36151748	1125315	0	0
36313966	438614	6	7
42807153	1177480	0	0
44363461	1307863	0	0
44361312	1125315	0	0
44361077	1119510	0	0
45628856	1119510	0	0
45653021	738818	0	0
44357746	1125315	0	0
45626141	1129625	0	0
45663643	1332418	0	0
45668436	1112807	0	0
45671301	19078461	2	3
45783849	1129625	0	0
45783701	1125315	0	0
45784715	42902245	2	2
45694597	19079524	1	1
45685845	1367571	0	0
45688422	1557272	0	0
46238272	1115008	0	0
46294059	1192710	0	0
46238320	1125315	0	0
46289245	19079524	1	1
45800643	1125315	0	0
46302551	1119510	0	0
46306624	1119510	0	0
4012907	44783196	3	3
3049150	3006734	1	1
21001589	1361711	0	0
21013411	19073188	2	3
35104074	439777	0	0
35506845	1500211	0	0
36151750	1125315	0	0
36313966	442116	6	7
42807298	701322	0	0
44363246	1112807	0	0
44361494	1125315	0	0
44361169	1119510	0	0
45625742	1119510	0	0
45653171	1124957	0	0
44358266	1125315	0	0
45626327	1129625	0	0
45663649	1107830	0	0
45668594	1112807	0	0
45778596	19078461	2	3
45783794	1129625	0	0
45783825	1125315	0	0
45700048	19128009	2	2
45676122	46275916	1	1
45685852	967823	0	0
45688431	1192710	0	0
46238418	1149380	0	0
46294064	1192710	0	0
46238344	1125315	0	0
45787205	1549786	0	0
45800744	1125315	0	0
46302578	1119510	0	0
46304054	1119510	0	0
4042646	4117038	3	4
3049209	3001247	1	1
21001630	1539403	0	0
21001960	1127433	2	3
21603924	19010482	0	0
35506848	1589505	0	0
36151546	1125315	0	0
36313966	439406	6	7
42807301	1115008	0	0
44363054	1149196	0	0
44361139	1125315	0	0
44361172	1119510	0	0
45626013	1119510	0	0
45652938	1174888	0	0
44358269	1125315	0	0
45626366	1129625	0	0
45663655	1174888	0	0
45666018	1112807	0	0
45707831	19078461	2	3
45783808	1129625	0	0
45783836	1125315	0	0
45700048	19127918	2	2
45679447	19079524	1	1
45685518	914335	0	0
45688177	1107830	0	0
46238428	975125	0	0
46294032	701322	0	0
46238346	1125315	0	0
45787225	1102527	0	0
45797841	1125315	0	0
46302816	1119510	0	0
46304220	1119510	0	0
201618	4285898	3	4
3049209	3006734	1	1
21001626	1322184	0	0
21001960	1127078	2	3
35507285	1000560	0	0
35506942	1177480	0	0
36151551	1125315	0	0
36313966	4139681	6	7
42806968	1153428	0	0
44363104	1177480	0	0
44357373	1125315	0	0
44360828	1119510	0	0
45625883	1119510	0	0
45653120	1110410	0	0
44358187	1125315	0	0
45622799	1129625	0	0
45663382	1778162	0	0
45664612	1112807	0	0
45686327	19078461	2	3
45781455	1129625	0	0
45783881	1125315	0	0
45694152	19128022	2	2
45682130	46275916	1	1
45685302	914335	0	0
45688266	1361711	0	0
46238430	1174888	0	0
46294050	1192710	0	0
46238405	1125315	0	0
45787207	1124957	0	0
45797774	1125315	0	0
46302979	1119510	0	0
46304131	1119510	0	0
1595799	42902245	3	4
3049219	3001247	1	1
21001622	1112807	0	0
21001960	1115171	2	3
35507288	1119510	0	0
35506943	1549786	0	0
36151585	1125315	0	0
36313966	78272	6	12
42806969	1177480	0	0
44363060	1118084	0	0
44357434	1125315	0	0
44338294	1125315	0	0
45625885	1119510	0	0
45653079	738818	0	0
44358193	1125315	0	0
45622808	1129625	0	0
45663768	1000560	0	0
45663945	1112807	0	0
45704930	19078461	2	3
45781709	1129625	0	0
45783753	1125315	0	0
45706783	19008572	2	3
45675824	19079524	1	1
45685305	1174888	0	0
45688180	1332418	0	0
46238433	1713332	0	0
46294109	1149196	0	0
46238352	1125315	0	0
45787228	1521369	0	0
45797647	1125315	0	0
46303295	1119510	0	0
46304261	1119510	0	0
4020346	4278672	3	4
3050400	3006734	1	1
21001626	1310149	0	0
21002145	46275444	2	3
35507258	1539403	0	0
35506943	1512674	0	0
36151592	1125315	0	0
36313966	375671	7	11
42807004	1000560	0	0
44363212	967823	0	0
44357475	1125315	0	0
44338318	1125315	0	0
45625835	1119510	0	0
45653115	1545958	0	0
44358293	1125315	0	0
45622760	1129625	0	0
45663772	1192710	0	0
45664029	1112807	0	0
45671089	19078461	2	3
45781814	1129625	0	0
45783795	1125315	0	0
45706701	19008572	2	3
45697095	19079524	1	1
45685314	1110410	0	0
45688184	1551099	0	0
46238433	1759842	0	0
46294185	1149196	0	0
46238754	1125315	0	0
45787228	1595799	0	0
45797763	1125315	0	0
46303298	1119510	0	0
46304232	1119510	0	0
3039466	3023103	2	4
3050400	3001247	1	1
21001643	1545958	0	0
21013658	19077572	2	3
35507259	975125	0	0
35507041	1332418	0	0
36151724	1125315	0	0
36313966	4059173	7	10
42807342	1177480	0	0
44363141	967823	0	0
44357482	1125315	0	0
44338280	1125315	0	0
45625676	1119510	0	0
45653152	1308738	0	0
44358132	1125315	0	0
45622880	1129625	0	0
45663787	1192710	0	0
45664143	1112807	0	0
45704736	19078461	2	3
45781729	1129625	0	0
45783808	1125315	0	0
45706858	1115171	2	3
45688255	19079524	1	1
45685318	715997	0	0
45685055	1343916	0	0
46238435	1192710	0	0
46294190	1548195	0	0
46238706	1125315	0	0
45787228	1549786	0	0
45797915	1125315	0	0
46303236	1119510	0	0
46304120	1119510	0	0
254068	4294548	2	4
3050409	3006734	1	1
21001662	1112807	0	0
21001947	19133905	2	3
35507253	1125315	0	0
35506892	1149196	0	0
36151683	1125315	0	0
36313966	81893	7	13
42807215	701322	0	0
44363143	1154343	0	0
44357440	1125315	0	0
44338102	1125315	0	0
45626072	1119510	0	0
45653423	738818	0	0
44358255	1125315	0	0
45621512	1129625	0	0
45663742	1717327	0	0
45661030	1112807	0	0
45671104	19078461	2	3
45781767	1129625	0	0
45783989	1125315	0	0
45705181	19078924	2	3
45703534	46275916	1	1
45685319	1115008	0	0
45685007	1545958	0	0
46238436	1557272	0	0
46293795	1551099	0	0
46238477	1125315	0	0
45787548	967823	0	0
45797714	1125315	0	0
46300280	1119510	0	0
46304155	1119510	0	0
3039459	3000963	4	4
3050409	3001247	1	1
21001655	1310149	0	0
21001947	46233988	2	3
35507256	1119510	0	0
35506898	1129625	0	0
36151850	1125315	0	0
36313966	45769019	7	9
42807216	19127890	0	0
44363147	1500211	0	0
44357486	1125315	0	0
44338375	1125315	0	0
45625773	1119510	0	0
45653425	1174888	0	0
44358118	1125315	0	0
45621857	1129625	0	0
45663700	791967	0	0
45657996	1112807	0	0
45778905	19078461	2	3
45783504	1129625	0	0
45783990	1125315	0	0
45705240	1127433	2	3
45703482	46275916	1	1
45685321	1112807	0	0
45685058	1149196	0	0
46238332	1107830	0	0
46293899	1501700	0	0
46238755	1125315	0	0
45787463	1115008	0	0
45797888	1125315	0	0
46300291	1119510	0	0
46304292	1119510	0	0
4162282	28060	4	4
3050415	3006734	1	1
21001665	1305058	0	0
21001947	19133873	2	3
35507250	1119510	0	0
35506941	1174888	0	0
36198916	1125315	0	0
36302170	81893	9	15
42807216	1549786	0	0
44363149	1551099	0	0
44357555	1125315	0	0
44338482	1125315	0	0
45622841	1119510	0	0
45653530	1154343	0	0
44354504	1125315	0	0
45667278	1129625	0	0
45663706	1110410	0	0
45658147	1112807	0	0
45676634	19078461	2	3
45783568	1129625	0	0
45783993	1125315	0	0
45780010	40229134	2	3
45700298	19079524	1	1
45685351	1746114	0	0
45685062	1310149	0	0
46238333	1557272	0	0
46294114	1332418	0	0
46238491	1125315	0	0
45787710	1549786	0	0
45798025	1125315	0	0
46300293	1119510	0	0
46320081	1119510	0	0
4042640	4337611	4	4
3050415	3001247	1	1
21001669	1305058	0	0
21001947	46233710	2	3
35507250	1125315	0	0
35506904	1149380	0	0
36159654	1125315	0	0
36302170	433125	9	9
42807283	1768849	0	0
44363252	1115008	0	0
44357502	1125315	0	0
44338484	1125315	0	0
45622406	1119510	0	0
45653572	967823	0	0
44354647	1125315	0	0
45667405	1129625	0	0
45663708	1110410	0	0
45657894	1112807	0	0
45669919	19078461	2	3
45779245	1129625	0	0
45781562	1125315	0	0
45780167	19019273	2	3
45700458	19134077	1	1
45685351	1741122	0	0
45685105	1192710	0	0
46238305	1332418	0	0
46294507	742185	0	0
45897432	1125315	0	0
45787710	1515774	0	0
45797704	1125315	0	0
46300386	1119510	0	0
46320362	1119510	0	0
4020347	4134304	4	4
3050420	3006734	1	1
21001653	1367571	0	0
21002821	1127433	2	3
35507250	738818	0	0
35507131	1174888	0	0
36198892	1125315	0	0
36302170	45769019	9	11
42807339	1539403	0	0
44363284	1154343	0	0
44357678	1125315	0	0
44338434	1125315	0	0
45622415	1119510	0	0
45652981	1115008	0	0
44354518	1125315	0	0
45665035	1129625	0	0
45663711	1545958	0	0
45654661	1112807	0	0
45777982	19078461	2	3
45779287	1129625	0	0
45781308	1125315	0	0
45780175	19133768	2	3
45694952	19079524	1	1
45685360	1501700	0	0
45685108	1539403	0	0
46238307	967823	0	0
46294727	1149196	0	0
45897494	1125315	0	0
45787710	19127890	0	0
45797875	1125315	0	0
46300313	1119510	0	0
46320454	1119510	0	0
435742	4116491	4	4
3050426	3001247	1	1
21001661	1551099	0	0
21002821	1127078	2	3
35507290	1125315	0	0
35507108	1119510	0	0
36198837	1125315	0	0
36302170	4219399	9	10
42807340	1000560	0	0
44363337	1149380	0	0
44357702	1125315	0	0
44338503	1125315	0	0
45622416	1119510	0	0
45653357	1595799	0	0
44354528	1125315	0	0
45665355	1129625	0	0
45663799	1539403	0	0
45654597	1112807	0	0
45676760	19078461	2	3
45779291	1129625	0	0
45781816	1125315	0	0
45780175	40162522	2	3
45688443	46275916	1	1
45685257	1124957	0	0
45685164	1115008	0	0
46238261	1124300	0	0
46294474	1729720	0	0
45897459	1125315	0	0
45787509	782043	0	0
45797876	1125315	0	0
46300474	1119510	0	0
46320459	1119510	0	0
252662	258780	4	4
3050442	3006734	1	1
21001685	1310149	0	0
21001740	19075001	2	3
35507329	1115008	0	0
35506992	1177480	0	0
36198843	1125315	0	0
36302170	4048169	8	9
42804458	1545958	0	0
44363345	1308738	0	0
44357703	1125315	0	0
44338448	1125315	0	0
45622547	1119510	0	0
45653315	1154343	0	0
44354767	1125315	0	0
45667358	1129625	0	0
45663804	1396131	0	0
45654431	1112807	0	0
45669470	19078461	2	3
45780629	1129625	0	0
45781818	1125315	0	0
45780060	40174880	2	3
45685246	46275916	1	1
45685420	1343916	0	0
45685063	740275	0	0
46238363	1107830	0	0
46294149	1118084	0	0
45897495	1125315	0	0
45787779	1107830	0	0
45797796	1125315	0	0
46300545	1119510	0	0
46320366	1119510	0	0
252662	261325	4	4
3050442	3001247	1	1
21001643	1332418	0	0
21004199	46233988	2	3
35507294	791967	0	0
35506993	1500211	0	0
36198946	1125315	0	0
36302170	4306014	8	9
42804459	1545958	0	0
44363517	1124300	0	0
44357709	1125315	0	0
44338234	1125315	0	0
45622723	1119510	0	0
45653322	914335	0	0
44354772	1125315	0	0
45667455	1129625	0	0
45663805	1118084	0	0
45655516	1112807	0	0
45781314	19078461	2	3
45780862	1129625	0	0
45781289	1125315	0	0
45780127	782047	2	3
45682319	46275916	1	1
45685421	1124957	0	0
45685066	1551099	0	0
46238368	1124957	0	0
46294372	1192710	0	0
45897504	1125315	0	0
45787586	1153428	0	0
45797803	1125315	0	0
46300517	1119510	0	0
46320274	1119510	0	0
4024000	4056621	4	4
3050445	3001247	1	1
21001643	1539403	0	0
21004199	46233710	2	3
35507354	738818	0	0
35506987	1551099	0	0
36151821	1125315	0	0
36302170	4146173	8	12
42804484	1177480	0	0
44363175	975125	0	0
44357529	1125315	0	0
44338388	1125315	0	0
45622726	1119510	0	0
45653346	920293	0	0
44354723	1125315	0	0
45662461	1129625	0	0
45663428	1192710	0	0
45651483	1112807	0	0
45674273	19078461	2	3
45779454	1129625	0	0
45781611	1125315	0	0
45780194	40236824	2	3
45676299	19079524	1	1
45685504	708298	0	0
45684716	914335	0	0
46238246	1729720	0	0
46294375	1589505	0	0
45897518	1125315	0	0
45787572	1539403	0	0
45797931	1125315	0	0
46300626	1119510	0	0
46320333	1119510	0	0
4024000	198199	4	4
3050445	3006734	1	1
21001603	1551099	0	0
21001875	1551192	2	3
35507354	1119510	0	0
35506988	1548195	0	0
36151803	1125315	0	0
36302170	42535580	7	9
42804460	1539403	0	0
44363177	1000560	0	0
44357532	1125315	0	0
44338605	1125315	0	0
45622950	1119510	0	0
45653347	1738521	0	0
44354683	1125315	0	0
45662900	1129625	0	0
45663438	1124957	0	0
45651603	1112807	0	0
45671078	40223768	2	3
45779460	1129625	0	0
45781636	1125315	0	0
45780098	19018935	2	3
46272790	4024289	1	1
45685289	1102527	0	0
45684944	1192710	0	0
45897248	1361711	0	0
46293919	701322	0	0
45897572	1125315	0	0
45787683	1768849	0	0
45797717	1125315	0	0
46300735	1119510	0	0
46320592	1119510	0	0
4011630	380378	4	4
3050465	3006734	1	1
21001654	1367571	0	0
21001775	40232448	2	3
35507354	1125315	0	0
35506991	1129625	0	0
36152004	1125315	0	0
36302170	4218389	7	9
42805324	1728416	0	0
44363389	1112807	0	0
44357538	1125315	0	0
44338404	1125315	0	0
45622553	1119510	0	0
45653348	1124300	0	0
44354807	1125315	0	0
45664740	1129625	0	0
45663443	1149196	0	0
45651252	1112807	0	0
45633042	19078461	2	3
45708244	1129625	0	0
45781722	1125315	0	0
45780057	1127433	2	3
46272790	4252419	1	1
45685261	1112807	0	0
45685168	1149196	0	0
45897250	1149196	0	0
46294494	1778162	0	0
45897638	1125315	0	0
45787739	975125	0	0
45798061	1125315	0	0
46300598	1119510	0	0
46320650	1119510	0	0
4101796	4132546	4	4
3050465	3001247	1	1
21001288	1738521	0	0
21001775	19112599	2	3
35507330	1112807	0	0
35507109	705944	0	0
36151929	1125315	0	0
36302170	440086	7	9
42805457	1149380	0	0
44363181	1115008	0	0
44357628	1125315	0	0
44338547	1125315	0	0
45622824	1119510	0	0
45653089	1713332	0	0
44354898	1125315	0	0
45664552	1129625	0	0
45663898	1000560	0	0
45651347	1112807	0	0
45698234	19078461	2	3
45708325	1129625	0	0
45781542	1125315	0	0
45779781	1107882	2	3
45687679	738818	0	0
45685263	1107830	0	0
45685109	920293	0	0
45897265	1112807	0	0
46294596	1738521	0	0
45897639	1125315	0	0
45787740	975125	0	0
45797819	1125315	0	0
46300992	1119510	0	0
46320722	1119510	0	0
4042646	4275113	4	4
3037839	3024561	1	1
21001283	1150770	0	0
21013610	19007333	2	3
35507314	791967	0	0
35506996	920293	0	0
36151659	1125315	0	0
36302170	4132546	7	11
42805460	1322184	0	0
44363163	914335	0	0
44357629	1125315	0	0
44338534	1125315	0	0
45621237	1119510	0	0
45653089	1759842	0	0
44354623	1125315	0	0
45664434	1129625	0	0
45663855	1741122	0	0
45648294	1112807	0	0
45705097	1332419	2	3
45708328	1129625	0	0
45781290	1125315	0	0
45780153	920334	2	3
45687447	967823	0	0
45685266	1149196	0	0
45685110	1174888	0	0
45897293	1153428	0	0
46293973	1589505	0	0
45897589	1125315	0	0
45787741	1192710	0	0
45797946	1125315	0	0
46300916	1119510	0	0
46320410	1119510	0	0
4180628	192671	4	4
3037839	3013682	1	1
21001283	1112807	0	0
21002775	1551192	2	3
35507315	738818	0	0
35506998	1177480	0	0
36151872	1125315	0	0
36302170	4152936	7	12
42805465	1343916	0	0
44363287	1308738	0	0
44357649	1125315	0	0
44338630	1125315	0	0
45621112	1119510	0	0
45653090	1149196	0	0
44354993	1125315	0	0
45663001	1129625	0	0
45663855	1746114	0	0
45649208	1112807	0	0
45669399	1332419	2	3
45705551	1129625	0	0
45781545	1125315	0	0
45780154	40236446	2	3
45687451	1149196	0	0
45685269	1124957	0	0
45685222	757627	0	0
45897139	1124300	0	0
46293973	19127890	0	0
45897772	1125315	0	0
45787749	1000560	0	0
45797980	1125315	0	0
46300996	1119510	0	0
46320411	1119510	0	0
4180628	80502	4	4
3037839	3006906	1	1
21001283	1107830	0	0
21002775	19007333	2	3
35507315	1119510	0	0
35506998	1129625	0	0
36151981	1125315	0	0
36302170	40480160	6	12
42805658	1112807	0	0
44363258	1192710	0	0
44357650	1125315	0	0
44338638	1125315	0	0
45621260	1119510	0	0
45653357	1308738	0	0
44355011	1125315	0	0
45663037	1129625	0	0
45663858	1501700	0	0
45649231	1112807	0	0
45674247	1332419	2	3
45705399	1129625	0	0
45781546	1125315	0	0
45707022	40236446	2	3
45687460	1728416	0	0
45685425	1153428	0	0
45685084	1192710	0	0
45897147	1124957	0	0
46293973	1549786	0	0
45897643	1125315	0	0
45787700	1551099	0	0
45797991	1125315	0	0
46301002	1119510	0	0
46320434	1119510	0	0
4024567	441267	4	4
3037839	3004501	1	1
21001283	1153428	0	0
21002836	1127078	2	3
35507315	1125315	0	0
35506999	1177480	0	0
36152085	1125315	0	0
36302170	257012	6	12
42805416	1322184	0	0
44363260	1107830	0	0
44357587	1125315	0	0
44341207	1125315	0	0
45622001	1119510	0	0
45653361	1174888	0	0
44355036	1125315	0	0
45659791	1129625	0	0
45663868	1305058	0	0
45648379	1112807	0	0
45673674	1332419	2	3
45705321	1129625	0	0
45781842	1125315	0	0
45707026	19008572	2	3
45687598	1115008	0	0
45799951	1539403	0	0
45685132	967823	0	0
45897369	1361711	0	0
46294501	1713332	0	0
45897575	1125315	0	0
45787701	1305058	0	0
45797992	1125315	0	0
46301003	1119510	0	0
46320867	1119510	0	0
4017459	4198190	4	4
3037839	3016723	1	1
21001284	975125	0	0
21002836	1127433	2	3
35507266	1545958	0	0
35507034	1545958	0	0
36151764	1125315	0	0
36302170	198809	6	12
42805468	705944	0	0
44363186	1149380	0	0
44357957	1125315	0	0
44359814	1125315	0	0
45621315	1119510	0	0
45653542	1124300	0	0
44355078	1125315	0	0
45659613	1129625	0	0
45663546	1548195	0	0
45642445	1112807	0	0
45704761	1332419	2	3
45705423	1129625	0	0
45781689	1125315	0	0
45707125	40232448	2	3
45687600	1174888	0	0
45800009	791967	0	0
45685146	1149196	0	0
45897372	1124957	0	0
46294501	1759842	0	0
45897621	1125315	0	0
45787702	1124300	0	0
45797995	1125315	0	0
46301127	1119510	0	0
46320662	1119510	0	0
255919	4029498	4	4
3044031	3016723	1	1
21001352	975125	0	0
21001871	1551192	2	3
35507336	975125	0	0
35507056	1112807	0	0
36151769	1125315	0	0
36302170	4047491	6	9
42805341	1326303	0	0
44363193	738818	0	0
44357884	1125315	0	0
44359725	1125315	0	0
45664835	1119510	0	0
45653439	1332418	0	0
44354740	1125315	0	0
45659624	1129625	0	0
45663550	1174888	0	0
45642672	1112807	0	0
45692062	1332419	2	3
45705483	1129625	0	0
45781398	1125315	0	0
45706894	19057271	2	3
45687540	1107830	0	0
45800043	1153428	0	0
45684788	1521369	0	0
45897026	1115008	0	0
46294443	1124300	0	0
45897604	1125315	0	0
45787763	1713332	0	0
45797905	1125315	0	0
46319195	1119510	0	0
46320671	1119510	0	0
200174	4296204	4	4
3044460	3016723	1	1
21001299	975125	0	0
21001853	19074841	2	3
35507303	1129625	0	0
35507059	1153428	0	0
36151770	1125315	0	0
36302170	4062501	6	6
42805342	1125315	0	0
44363434	1738521	0	0
44357755	1125315	0	0
44359730	1125315	0	0
45664934	1119510	0	0
45653129	914335	0	0
44354741	1125315	0	0
45659927	1129625	0	0
45663924	1124957	0	0
45642566	1112807	0	0
45669593	40223768	2	3
45705466	1129625	0	0
45781529	1125315	0	0
45706149	19008572	2	3
45687551	1310149	0	0
45799872	723013	0	0
45684788	19127890	0	0
45897106	1112807	0	0
46294458	1153428	0	0
45895374	1125315	0	0
45787608	1713332	0	0
45799744	1125315	0	0
46319219	1119510	0	0
46320918	1119510	0	0
4023995	381316	4	4
3048501	3006734	1	1
21001373	975125	0	0
21001853	1713671	2	3
35507304	1119510	0	0
35507148	1129625	0	0
36152244	1125315	0	0
36302170	40479768	10	13
42804547	1545958	0	0
44363395	1112807	0	0
44357832	1125315	0	0
44359837	1125315	0	0
45664883	1119510	0	0
45653136	1174888	0	0
44354819	1125315	0	0
45656672	1129625	0	0
45663839	967823	0	0
45639416	1112807	0	0
45699361	1539411	2	3
45705498	1129625	0	0
45781532	1125315	0	0
45706198	1115171	2	3
45687552	19127890	0	0
45799788	1548195	0	0
45684788	1549786	0	0
45897221	1118084	0	0
46294686	975125	0	0
45895244	1125315	0	0
45787608	1759842	0	0
45795194	1125315	0	0
46319102	1119510	0	0
46321392	1119510	0	0
4023995	321042	4	4
3048501	3001247	1	1
21001374	975125	0	0
21004620	1551192	2	3
35306246	441267	0	0
35507136	1177480	0	0
36152252	1125315	0	0
36302170	4181917	5	6
42804543	1551099	0	0
44363197	1713332	0	0
44353848	1125315	0	0
44360143	1125315	0	0
45664845	1119510	0	0
45653294	967823	0	0
44351191	1125315	0	0
45656947	1129625	0	0
45663688	1124300	0	0
45639420	1112807	0	0
45669691	1539411	2	3
45705572	1129625	0	0
45781658	1125315	0	0
45706158	40223834	2	3
45687552	1548195	0	0
45799702	1154029	0	0
45684880	975125	0	0
45897211	1322184	0	0
46294619	1192710	0	0
45895422	1125315	0	0
45787611	1309944	0	0
45795335	1125315	0	0
46319481	1119510	0	0
46321395	1119510	0	0
254068	40486433	4	4
3048567	3006734	1	1
21001283	975125	0	0
21001688	40163554	2	3
21604793	40223768	1	4
35507105	1112807	0	0
36152080	1125315	0	0
36302170	40478878	5	6
42804576	1738521	0	0
44363197	1759842	0	0
44355300	1125315	0	0
44359967	1125315	0	0
45665189	1119510	0	0
45652952	1713332	0	0
44351194	1125315	0	0
45657006	1129625	0	0
45663449	738818	0	0
45639430	1112807	0	0
45684084	19078461	2	3
45705664	1129625	0	0
45781777	1125315	0	0
45706174	1127433	2	3
45687603	1149196	0	0
45799722	1738521	0	0
45685013	1174888	0	0
45897213	1738521	0	0
46293977	1153428	0	0
45895431	1125315	0	0
45787305	1332418	0	0
45795355	1125315	0	0
46319365	1119510	0	0
46315054	1119510	0	0
254068	4280726	4	4
3048567	3001247	1	1
21001283	1150836	0	0
21001839	19075001	2	3
21604186	19023398	1	4
35507106	1177480	0	0
36152418	1125315	0	0
36302170	4015189	4	8
42804757	1177480	0	0
44363203	1149380	0	0
44355448	1125315	0	0
44359675	1125315	0	0
45665135	1119510	0	0
45652956	1326303	0	0
44350870	1125315	0	0
45657202	1129625	0	0
45663450	967823	0	0
45639514	1112807	0	0
45692808	1539411	2	3
45701894	1129625	0	0
45783596	1125315	0	0
45706175	19073188	2	3
45687552	19054876	0	0
45799733	1551099	0	0
45685112	740275	0	0
45897218	1729720	0	0
46294720	1115008	0	0
45895252	1125315	0	0
45787492	1115008	0	0
45795435	1125315	0	0
46319146	1119510	0	0
46313872	1119510	0	0
4029205	4117038	3	7
3048584	3006734	1	1
21001378	1778162	0	0
21001839	19074841	2	3
21604186	782047	1	4
35507226	1548195	0	0
36152093	1125315	0	0
36302170	4145310	4	6
42804771	1177480	0	0
44363208	1107830	0	0
44355336	1125315	0	0
44359741	1125315	0	0
45665236	1119510	0	0
45653197	967823	0	0
44350873	1125315	0	0
45653687	1129625	0	0
45663558	1738521	0	0
45639534	1112807	0	0
45689833	1539411	2	3
45702067	1129625	0	0
45783778	1125315	0	0
45706292	19019273	2	3
45687639	1551099	0	0
45799680	1717327	0	0
45685113	1717327	0	0
45897305	791967	0	0
46294388	1192710	0	0
45895514	1125315	0	0
45800997	1361711	0	0
45795516	1125315	0	0
46319150	1119510	0	0
46314894	1119510	0	0
4047779	381316	3	6
3048584	3001247	1	1
21001349	914335	0	0
21001840	19074841	2	3
21604186	19023423	1	4
35507227	1129625	0	0
36152099	1125315	0	0
36302170	4052083	4	4
42804551	740275	0	0
44363289	1107830	0	0
44355269	1125315	0	0
44360174	1125315	0	0
45665172	1119510	0	0
45649934	1713332	0	0
44350875	1125315	0	0
45653783	1129625	0	0
45663576	1551099	0	0
45639654	1112807	0	0
45673398	19129144	3	4
45702139	1129625	0	0
45779237	1125315	0	0
45706293	19077344	2	3
45687640	1107830	0	0
45799687	1174888	0	0
45685116	920293	0	0
45897335	1174888	0	0
46294522	1118084	0	0
45895515	1125315	0	0
45801189	1548195	0	0
45795372	1125315	0	0
46319449	1119510	0	0
46314899	1119510	0	0
4047779	4283893	3	6
3048591	3024561	1	1
21001319	19010482	0	0
21001840	19075001	2	3
35104392	4280726	1	1
35507151	1177480	0	0
36152068	1125315	0	0
36502203	4149245	5	5
42804594	1539403	0	0
44363445	1307863	0	0
44355272	1125315	0	0
44359919	1125315	0	0
45665282	1119510	0	0
45649990	723013	0	0
44351168	1125315	0	0
45653804	1129625	0	0
45663584	1343916	0	0
45639665	1112807	0	0
45654931	1545958	0	0
45702022	1129625	0	0
45779238	1125315	0	0
45699710	42707627	2	3
45687541	1174888	0	0
45797317	1539403	0	0
45685125	1118084	0	0
45897339	1738521	0	0
46294525	967823	0	0
45895517	1125315	0	0
45801191	1118084	0	0
45795528	1125315	0	0
46319167	1119510	0	0
46314901	1119510	0	0
4047779	30753	3	7
3048591	3020630	1	1
21001358	975125	0	0
21001840	1713671	2	3
35104353	4280726	1	1
35507154	1149196	0	0
36152171	1125315	0	0
36502203	78272	8	8
42804597	1124300	0	0
44363271	1738521	0	0
44355380	1125315	0	0
44359970	1125315	0	0
45662294	1119510	0	0
45649994	967823	0	0
44351013	1125315	0	0
45650225	1129625	0	0
45663814	1115008	0	0
45639687	1112807	0	0
45654908	1124300	0	0
45699219	1129625	0	0
45779377	1125315	0	0
45699774	40229134	2	3
45687608	967823	0	0
45797339	1192710	0	0
45685127	967823	0	0
45897346	1107830	0	0
46294534	1118084	0	0
45894537	1125315	0	0
45801195	1551099	0	0
45795448	1125315	0	0
46319390	1119510	0	0
46314811	1119510	0	0
4047779	4310024	3	7
3048604	3001247	1	1
21600654	975125	0	0
21001882	1551192	2	3
35302583	441267	1	1
35507080	1515774	0	0
36151987	1125315	0	0
36502203	40479768	6	6
42804579	1177480	0	0
44363273	1124957	0	0
44355360	1125315	0	0
44360280	1125315	0	0
45662505	1119510	0	0
45649995	967823	0	0
44351016	1125315	0	0
45650349	1129625	0	0
45660285	1153428	0	0
45639623	1112807	0	0
45654909	1110410	0	0
45695932	1129625	0	0
45627300	40228214	2	3
45699742	40232448	2	3
45687645	1746114	0	0
45797367	715997	0	0
45685098	1192710	0	0
45897306	738818	0	0
46294539	1549786	0	0
45894562	1125315	0	0
45801200	1501700	0	0
45795304	1125315	0	0
46319490	1119510	0	0
46314821	1119510	0	0
4047779	195588	3	7
3048604	3006734	1	1
21506099	967823	0	0
21002839	1551192	2	3
35102367	439777	1	1
35507080	1549786	0	0
35809207	4048171	4	4
36502203	40479422	6	6
42804583	1177480	0	0
44363563	1713332	0	0
44355364	1125315	0	0
44360283	1125315	0	0
45662654	1119510	0	0
45649905	1549786	0	0
44351130	1125315	0	0
45650364	1129625	0	0
45660296	1738521	0	0
45639760	1112807	0	0
45654911	1310149	0	0
45695587	1129625	0	0
45642434	40223768	2	3
45699769	19019273	2	3
45687645	1741122	0	0
45797377	1738521	0	0
45685196	933724	0	0
45897315	1112807	0	0
46294539	1595799	0	0
45803193	1125315	0	0
45801104	1149196	0	0
45795378	1125315	0	0
46319538	1119510	0	0
46315082	1119510	0	0
4047779	4329847	3	8
3048875	3006734	1	1
21506100	967823	0	0
21002597	19075001	2	3
35104186	439777	1	1
35507125	1112807	0	0
36002868	4280726	4	4
36502203	81151	4	7
42804566	920293	0	0
44363323	738818	0	0
44354286	1125315	0	0
44359901	1125315	0	0
45662669	1119510	0	0
45649905	19127890	0	0
44351138	1125315	0	0
45649031	1129625	0	0
45660302	1343916	0	0
45639552	1112807	0	0
45655072	920293	0	0
45695881	1129625	0	0
45630203	40228214	2	3
45700147	40236824	2	3
45687649	738818	0	0
45797347	1107830	0	0
45685210	1153428	0	0
45897323	1107830	0	0
46294539	1521369	0	0
45803199	1125315	0	0
45801203	723013	0	0
45792717	1125315	0	0
46240001	1119510	0	0
46314767	1119510	0	0
4027384	4112343	3	9
3048875	3001247	1	1
21506102	1125315	0	0
21002597	19133905	2	3
21601237	1326303	4	4
35507127	920293	0	0
35708294	81893	4	4
36602217	4285898	5	5
42804592	1124300	0	0
44363292	1305058	0	0
44354355	1125315	0	0
44353309	1125315	0	0
45662514	1119510	0	0
45649905	1515774	0	0
44350883	1125315	0	0
45647369	1129625	0	0
45660306	1153428	0	0
45639916	1112807	0	0
45655014	1149196	0	0
45697328	1129625	0	0
45639590	40228214	2	3
45693380	1127433	2	3
45687576	708298	0	0
45797318	1729720	0	0
45685216	791967	0	0
45897355	1192710	0	0
46243886	1310149	0	0
45803421	1125315	0	0
45801113	1738521	0	0
45792719	1125315	0	0
46239885	1119510	0	0
46314940	1119510	0	0
4027384	260139	3	8
3048880	3001247	1	1
21506104	1125315	0	0
21002597	19074841	2	3
21601237	1343916	4	4
35507158	1115008	0	0
36102976	258780	4	4
36503288	80809	4	4
42804620	914335	0	0
44363301	1149380	0	0
44354432	1125315	0	0
44353319	1125315	0	0
45662727	1119510	0	0
45649757	1322184	0	0
44351146	1125315	0	0
45644273	1129625	0	0
45660282	1153428	0	0
45636585	1112807	0	0
45655016	1115008	0	0
45697871	1129625	0	0
45661370	19078461	2	3
45693510	42707627	2	3
45687578	975125	0	0
45797383	1521369	0	0
45685553	1738521	0	0
45897190	1149196	0	0
46243569	1309944	0	0
45803342	1125315	0	0
45801115	1332418	0	0
45792590	1125315	0	0
46239837	1119510	0	0
46314979	1119510	0	0
4027384	4294548	3	8
3048880	3006734	1	1
21506104	1192710	0	0
21002597	19133873	2	3
21601237	1539403	4	4
35507168	1149380	0	0
36102976	4048171	4	4
36503288	78272	4	9
42804629	1322184	0	0
44363302	738818	0	0
44354554	1125315	0	0
44353326	1125315	0	0
45662530	1119510	0	0
45649997	19127890	0	0
44350960	1125315	0	0
45644281	1129625	0	0
45660253	1343916	0	0
45633283	1112807	0	0
45655002	791967	0	0
45695999	1129625	0	0
45666494	40228214	2	3
45693574	1115171	2	3
45687779	1738521	0	0
45797385	1332418	0	0
45685554	1501700	0	0
45897191	975125	0	0
46243828	19010482	0	0
45803429	1125315	0	0
45801126	715997	0	0
45792591	1125315	0	0
46239838	1119510	0	0
46314919	1119510	0	0
4040392	4330583	3	7
3045262	3016723	1	1
21501247	19010482	0	0
21001686	40163554	2	3
21601237	1307863	4	4
35507174	1119510	0	0
35809212	40486433	4	4
36503288	4134304	6	9
42804630	1115008	0	0
44363230	1539403	0	0
44354452	1125315	0	0
44353337	1125315	0	0
45661222	1119510	0	0
45649997	1549786	0	0
44350971	1125315	0	0
45644410	1129625	0	0
45660391	1768849	0	0
45633386	1112807	0	0
45655008	1153428	0	0
45696067	1129625	0	0
45625155	40228214	2	3
45693726	40232448	2	3
45687594	1713332	0	0
45797387	975125	0	0
45685557	1343916	0	0
45897235	753626	0	0
46243571	1154343	0	0
45803270	1125315	0	0
45801137	1153428	0	0
45794548	1125315	0	0
46239944	1119510	0	0
46314908	1119510	0	0
4180628	4280726	3	7
3048238	3006734	1	1
21502520	1174888	0	0
21001848	19074841	2	3
21601237	1332418	4	4
35507129	1119510	0	0
35809212	4280726	4	4
36503288	81151	5	8
42804581	1000560	0	0
44363236	715997	0	0
44354666	1125315	0	0
44353244	1125315	0	0
45661216	1119510	0	0
45649967	1713332	0	0
44351028	1125315	0	0
45644377	1129625	0	0
45660310	1308738	0	0
45633557	1112807	0	0
45655109	738818	0	0
45692794	1129625	0	0
45661004	40228214	2	3
45693604	19074843	2	3
45687696	1107830	0	0
45797393	1192710	0	0
45685507	757627	0	0
45897118	967823	0	0
46243874	1332418	0	0
45803357	1125315	0	0
45802442	967823	0	0
45794568	1125315	0	0
46321960	1119510	0	0
46314910	1119510	0	0
4028071	4142905	3	6
3048257	3006734	1	1
21502622	1746114	0	0
21001848	19075001	2	3
21601237	1361711	4	4
35507129	1129625	0	0
35809320	4084167	4	4
36503288	4109685	6	7
42804696	1332418	0	0
44363591	1729720	0	0
42802374	1125315	0	0
44353258	1125315	0	0
45659381	1119510	0	0
45649971	1557272	0	0
44351149	1125315	0	0
45644210	1129625	0	0
45660336	1115008	0	0
45633692	1112807	0	0
45655184	1521369	0	0
45692820	1129625	0	0
45668554	40228214	2	3
45693958	19008572	2	3
45687609	1107830	0	0
45797395	1521369	0	0
45685780	708298	0	0
45897423	1149196	0	0
46243932	975125	0	0
45803367	1125315	0	0
45802355	723013	0	0
45794525	1125315	0	0
46321962	1119510	0	0
46314699	1119510	0	0
4028071	195588	3	6
3050489	3049273	1	1
21502622	1741122	0	0
21001848	19073188	2	3
21601237	1545959	4	7
35507244	1124300	0	0
36002139	4219399	4	4
36503288	4237458	5	7
42804690	1545958	0	0
44363303	791967	0	0
42802374	1124957	0	0
44353351	1125315	0	0
45659388	1119510	0	0
45651843	1149196	0	0
44352377	1125315	0	0
45644171	1129625	0	0
45660340	1192710	0	0
45633667	1112807	0	0
45655009	1332418	0	0
45692765	1129625	0	0
45636423	40228214	2	3
45693608	40229134	2	3
45687224	975125	0	0
45682416	723013	0	0
45685718	920293	0	0
45897356	1118084	0	0
46243933	1361711	0	0
45803455	1125315	0	0
45802447	1367571	0	0
45794610	1125315	0	0
46322225	1119510	0	0
46314700	1119510	0	0
4041285	195588	3	6
3049225	3006734	1	1
21502623	1759842	0	0
21001848	19073183	2	3
21601237	1310034	4	7
35507193	1149196	0	0
36002139	37017711	4	4
36503288	4035415	4	7
42804614	1713332	0	0
44363306	1343916	0	0
42802650	1728416	0	0
44353163	1125315	0	0
45659648	1119510	0	0
45651855	1548195	0	0
44352253	1125315	0	0
45644164	1129625	0	0
45660392	1192710	0	0
45630286	1112807	0	0
45654784	1115008	0	0
45692828	1129625	0	0
45636555	40228214	2	3
45693812	19078924	2	3
45687542	1332418	0	0
45682524	1149196	0	0
45685723	967823	0	0
45897332	1192710	0	0
46243861	1728416	0	0
45803471	1125315	0	0
45802454	1545958	0	0
45792779	1125315	0	0
46321749	1119510	0	0
46317746	1119510	0	0
4103320	4112343	3	6
3049225	3001247	1	1
21502623	1717327	0	0
21001796	19073188	2	3
21601237	19018935	4	7
35507196	1332418	0	0
36000000	4051466	4	4
36503288	4048695	4	7
42804677	1118084	0	0
44363329	1192710	0	0
42802751	1115008	0	0
44355240	1125315	0	0
45659526	1119510	0	0
45651985	1149196	0	0
44352260	1125315	0	0
45641492	1129625	0	0
45660393	1154029	0	0
45630470	1112807	0	0
45654785	738818	0	0
45692995	1129625	0	0
45642725	40228214	2	3
45693905	40229134	2	3
45687726	967823	0	0
45682442	1112807	0	0
45685725	975125	0	0
45897285	1521369	0	0
46243670	1174888	0	0
45803481	1125315	0	0
45802367	1551099	0	0
45792735	1125315	0	0
46322180	1119510	0	0
46317806	1119510	0	0
4028908	4015189	3	6
3049228	3006734	1	1
21502687	740275	0	0
21001796	19073183	2	3
21604180	19076374	4	7
35507198	19078219	0	0
36000000	4102123	4	4
36502202	4035415	5	8
42804554	19127890	0	0
44363569	1545958	0	0
42802714	1713332	0	0
44355303	1125315	0	0
45659403	1119510	0	0
45651991	1115008	0	0
44352362	1125315	0	0
45641561	1129625	0	0
45660359	738818	0	0
45630476	1112807	0	0
45655120	1549786	0	0
45693183	1129625	0	0
45639461	19079524	2	3
45693887	19077572	2	3
45687728	1717327	0	0
45682317	1149196	0	0
45685731	1501700	0	0
45897285	1595799	0	0
46243809	975125	0	0
45803485	1125315	0	0
45802228	975125	0	0
45792764	1125315	0	0
46322189	1119510	0	0
46317359	1119510	0	0
4042140	4029498	3	6
3049249	3001247	1	1
21500564	757627	0	0
21004346	46233710	2	3
21604180	40223768	4	7
35507201	1154029	0	0
36000000	442116	4	4
36502202	134438	6	6
42804554	1515774	0	0
44363663	1124300	0	0
42802714	1759842	0	0
44353447	1125315	0	0
45659511	1119510	0	0
45652002	738818	0	0
44352364	1125315	0	0
45641459	1129625	0	0
45660369	1501700	0	0
45631254	1112807	0	0
45655120	19127890	0	0
45693278	1129625	0	0
45661003	40223768	2	3
45691568	1551192	2	3
45687788	1192710	0	0
45682446	1102527	0	0
45685733	1551099	0	0
45897285	1549786	0	0
46243949	1192710	0	0
45803690	1125315	0	0
45802590	1174888	0	0
45792765	1125315	0	0
46322190	1119510	0	0
46315093	1119510	0	0
4027384	4283893	3	6
3049249	3006734	1	1
21500564	715997	0	0
21004346	46233988	2	3
21604180	19023398	4	7
35507204	1119510	0	0
36200000	196456	4	4
36502202	4109685	7	8
42804554	1549786	0	0
44358781	1000560	0	0
42802692	1589505	0	0
44345742	1125315	0	0
45659677	1119510	0	0
45652006	1551099	0	0
44351881	1125315	0	0
45641589	1129625	0	0
45660603	1115008	0	0
45630714	1112807	0	0
45655012	1124957	0	0
45689958	1129625	0	0
45658165	19078461	2	3
45690723	19076374	2	3
45687792	1539403	0	0
45682286	1192710	0	0
45685734	1115008	0	0
45897374	1112807	0	0
46243893	1102527	0	0
45803695	1125315	0	0
45801233	742185	0	0
45792882	1125315	0	0
46322050	1119510	0	0
46315315	1119510	0	0
4180628	257012	3	6
3045783	3019550	1	1
21500577	1125315	0	0
21001849	19075001	2	3
21604180	40220386	6	7
35507205	1115008	0	0
36203042	4230399	3	4
36503249	4237458	4	5
42804756	1738521	0	0
44358786	1310149	0	0
42802692	1549786	0	0
44345322	1125315	0	0
45656316	1119510	0	0
45650015	1501700	0	0
44351817	1125315	0	0
45641412	1129625	0	0
45660771	791967	0	0
45630763	1112807	0	0
45655089	1307863	0	0
45689963	1129625	0	0
45624172	40223768	2	3
45690632	40232448	2	3
45687613	1738521	0	0
45682288	1124300	0	0
45685747	1768849	0	0
45894922	1000560	0	0
46243675	1174888	0	0
45800751	1125315	0	0
45801262	1107830	0	0
45792858	1125315	0	0
46322479	1119510	0	0
46309502	1119510	0	0
4180628	195588	3	6
3045783	3023103	1	1
21500583	1154029	0	0
21001849	19074841	2	3
21604180	40162522	6	7
35506890	1713332	0	0
35702109	4285898	3	4
36503249	4048695	4	5
42804674	1177480	0	0
44358788	1322184	0	0
42802693	975125	0	0
44345437	1125315	0	0
45656557	1119510	0	0
45650039	1343916	0	0
44352370	1125315	0	0
45641650	1129625	0	0
45660463	1118084	0	0
45630653	1112807	0	0
45655285	1000560	0	0
45690049	1129625	0	0
45666528	40223768	2	3
45690692	19008572	2	3
45687617	1332418	0	0
45682295	1124957	0	0
45685882	1107830	0	0
45894914	1124957	0	0
46243678	1309944	0	0
45800893	1125315	0	0
45801236	1521369	0	0
45792970	1125315	0	0
46321925	1119510	0	0
46310079	1119510	0	0
4178367	4058899	3	5
3049512	3001247	1	1
21500583	1124957	0	0
21001849	19073188	2	3
21604180	40229134	6	7
21604201	1154029	0	0
36202155	4048695	3	4
36503249	4066995	4	5
42804707	1125315	0	0
44358898	1177480	0	0
42802704	1000560	0	0
44345791	1125315	0	0
45656561	1119510	0	0
45650046	1115008	0	0
44351257	1125315	0	0
45641759	1129625	0	0
45660617	1738521	0	0
45627571	1112807	0	0
45655093	1110410	0	0
45690077	1129625	0	0
45624530	19078461	2	3
45690616	40223834	2	3
45687749	975125	0	0
45682510	1124957	0	0
45685508	1310149	0	0
45894984	1118084	0	0
46243684	1322184	0	0
45800897	1125315	0	0
45801236	1549786	0	0
45792974	1125315	0	0
46321930	1119510	0	0
46309867	1119510	0	0
4041285	198199	3	5
3049512	3006734	1	1
21500580	1129625	0	0
21001849	1713671	2	3
21604180	19078219	4	4
21604202	19059528	0	0
36202155	40480160	3	4
36503249	4142905	4	5
42804708	1361711	0	0
44358577	1713332	0	0
42802830	1125315	0	0
44345639	1125315	0	0
45656603	1119510	0	0
45650083	1551099	0	0
44351252	1125315	0	0
45641666	1129625	0	0
45660618	1149380	0	0
45627525	1112807	0	0
45655098	975125	0	0
45687072	1129625	0	0
45666552	19078461	2	3
45690744	40224805	2	3
45687750	715997	0	0
45682514	1192710	0	0
45685562	1154029	0	0
45894987	1115008	0	0
46244779	1124957	0	0
45800658	1125315	0	0
45801236	1595799	0	0
45792977	1125315	0	0
46322139	1119510	0	0
46309874	1119510	0	0
4168335	4152936	3	5
3049558	3051031	1	1
21500580	1112807	0	0
21001849	19073183	2	3
21604180	753626	4	4
21604203	19078219	0	0
36151891	19127918	3	4
36503249	4059173	5	5
42804709	1713332	0	0
44358580	920293	0	0
42802857	791967	0	0
44348037	1125315	0	0
45656176	1119510	0	0
45650067	738818	0	0
44351288	1125315	0	0
45641725	1129625	0	0
45660620	1549786	0	0
45627634	1112807	0	0
45655290	1174888	0	0
45687133	1129625	0	0
45648403	19078461	2	3
45690884	40232448	2	3
45687230	1115008	0	0
45682398	1107830	0	0
45681881	1124300	0	0
45895004	715997	0	0
46244789	1000560	0	0
45800673	1125315	0	0
45801239	1549786	0	0
45792863	1125315	0	0
46322157	1119510	0	0
46309895	1119510	0	0
4103320	4294548	3	5
3053269	3001247	1	1
21500580	1125315	0	0
21001842	19074841	2	3
21604180	757627	4	4
36156236	1119510	0	0
36102976	4283893	1	1
36503249	4278672	5	5
42802009	1125315	0	0
44358584	1110410	0	0
42802768	701322	0	0
44348190	1125315	0	0
45658363	1119510	0	0
45650153	1713332	0	0
44347310	1125315	0	0
45638309	1129625	0	0
45660403	1367571	0	0
45627409	1112807	0	0
45655191	1343916	0	0
45687043	1129625	0	0
45668561	19078461	2	3
45690955	40232448	2	3
45687231	1713332	0	0
45682400	1343916	0	0
45681887	1149196	0	0
45895004	701322	0	0
46244893	1521369	0	0
45800864	1125315	0	0
45801239	19127890	0	0
45792792	1125315	0	0
46322481	1119510	0	0
46309899	1119510	0	0
4115259	261325	3	5
3053269	3006734	1	1
21500590	1112807	0	0
21001842	1713671	2	3
21604180	782043	4	4
36156287	1322184	0	0
35909441	198809	1	1
36503249	4134304	7	7
42802009	1124957	0	0
44358687	933724	0	0
42802770	1112807	0	0
44348420	1125315	0	0
45653066	1119510	0	0
45646739	738818	0	0
44347496	1125315	0	0
45638212	1129625	0	0
45660422	738818	0	0
45624346	1112807	0	0
45655293	1778162	0	0
45687289	1129625	0	0
45660857	19078461	2	3
45691000	19126352	2	3
45687850	1310149	0	0
45682430	967823	0	0
45681883	1110410	0	0
45894931	1112807	0	0
46244893	1549786	0	0
45800931	1125315	0	0
45801239	1589505	0	0
45792908	1125315	0	0
46322486	1119510	0	0
46309910	1119510	0	0
4027384	30753	3	5
3049843	3006734	1	1
21500590	1125315	0	0
21001879	1551192	2	3
21604180	19059528	4	4
36152470	1118084	0	0
36002886	81893	1	1
36503249	4230399	6	6
42801754	1000560	0	0
44358494	1501700	0	0
42802677	975125	0	0
44345803	1125315	0	0
45653011	1119510	0	0
45646740	1548195	0	0
44347485	1125315	0	0
45638466	1129625	0	0
45660434	1713332	0	0
45624452	1112807	0	0
45655250	1539403	0	0
45687099	1129625	0	0
45642550	19078461	2	3
45690885	19019273	2	3
45687839	757627	0	0
45794842	740275	0	0
45682153	1332418	0	0
45894933	1137529	0	0
46244859	914335	0	0
45801002	1125315	0	0
45801248	967823	0	0
45790129	1125315	0	0
46322065	1119510	0	0
46309556	1119510	0	0
4028387	4296204	3	5
3049861	3006734	1	1
21500591	1102527	0	0
21001907	1551192	2	3
21604180	1124957	4	4
36152553	723013	0	0
36002868	439406	1	1
36503269	4230399	7	7
42801853	701322	0	0
44358698	1149380	0	0
42802983	1125315	0	0
44345853	1125315	0	0
45653021	1119510	0	0
45646757	1551099	0	0
44347741	1125315	0	0
45638528	1129625	0	0
45660475	738818	0	0
45624792	1112807	0	0
45655032	1717327	0	0
45687240	1129625	0	0
45627213	19078461	2	3
45687696	1107882	2	3
45687304	1124957	0	0
45794843	740275	0	0
45682101	975125	0	0
45894935	1551099	0	0
46244860	715997	0	0
45801116	1125315	0	0
45801388	740275	0	0
45790131	1125315	0	0
46322495	1119510	0	0
46309543	1119510	0	0
4155793	4058899	3	5
3050719	3006734	1	1
21500591	1125315	0	0
21002783	1551192	2	3
21604180	701322	4	4
36152493	1192710	0	0
36009773	40486433	1	1
36503269	4134304	8	8
42801859	1589505	0	0
44358630	1521369	0	0
42802929	1589505	0	0
44345839	1125315	0	0
45653079	1119510	0	0
45646590	1149196	0	0
44347402	1125315	0	0
45638542	1129625	0	0
45660572	1713332	0	0
45624793	1112807	0	0
45655253	1115008	0	0
45687171	1129625	0	0
45661006	19078461	2	3
45687663	19008572	2	3
45684374	1310149	0	0
45794845	1192710	0	0
45681984	1149196	0	0
45894948	1589505	0	0
46244826	791967	0	0
45800968	1125315	0	0
45801229	1192710	0	0
45790052	1125315	0	0
46322509	1119510	0	0
46309958	1119510	0	0
4178683	4057420	3	5
3050752	3006734	1	1
21500592	1125315	0	0
21002783	19007333	2	3
21604180	19039298	4	4
36152498	975125	0	0
36009773	4280726	1	1
36503269	4048695	6	6
42801859	19127890	0	0
44358630	1549786	0	0
42802942	1332418	0	0
44345875	1125315	0	0
45653127	1119510	0	0
45646591	1115008	0	0
44347657	1125315	0	0
45638475	1129625	0	0
45660572	1759842	0	0
45668711	1112807	0	0
45700760	1174888	0	0
45687116	1129625	0	0
45630402	19078461	2	3
45687744	40231925	2	3
45684256	1115008	0	0
45794710	1545958	0	0
45682028	1110410	0	0
45895007	1000560	0	0
46244832	1149196	0	0
45800958	1125315	0	0
45801231	1539403	0	0
45789900	1125315	0	0
46316081	1119510	0	0
46309562	1119510	0	0
4180628	198199	3	5
3050752	3001247	1	1
21500592	1112807	0	0
21002811	19059056	2	3
21604180	1125315	4	4
36152480	1515774	0	0
36009799	80809	1	1
36503269	4066995	6	6
42801859	1549786	0	0
44358829	1713332	0	0
42802775	1125315	0	0
44345879	1125315	0	0
45653531	1119510	0	0
45646595	1115008	0	0
44347529	1125315	0	0
45638582	1129625	0	0
45660610	1343916	0	0
45668543	1112807	0	0
45700766	1124300	0	0
45684116	1129625	0	0
45627260	19078461	2	3
45688594	19019273	2	3
45684241	1107830	0	0
45794926	1332418	0	0
45682036	975125	0	0
45895008	1549786	0	0
46244871	1539403	0	0
45800979	1125315	0	0
45801335	1713332	0	0
45790150	1125315	0	0
46316224	1119510	0	0
46309974	1119510	0	0
4047779	372328	3	5
3052062	3006734	1	1
21500587	1125315	0	0
21002811	19019979	2	3
21602819	1717327	2	2
36152480	1549786	0	0
35708294	4027663	1	1
36503269	4278672	6	6
42801861	1149380	0	0
44358632	1177480	0	0
42802777	1124300	0	0
44345891	1125315	0	0
45653103	1119510	0	0
45646781	1548195	0	0
44347545	1125315	0	0
45635401	1129625	0	0
45660728	1501700	0	0
45668840	1112807	0	0
45700892	975125	0	0
45684084	1129625	0	0
45630428	40223768	2	3
45688490	40236824	2	3
45684343	1551099	0	0
45794928	1153428	0	0
45682039	1332418	0	0
45894966	1192710	0	0
46244872	715997	0	0
45800770	1125315	0	0
45801310	1307863	0	0
45790160	1125315	0	0
46316311	1119510	0	0
46309572	1119510	0	0
4047779	4218389	3	5
3052062	3001247	1	1
21500587	1112807	0	0
21002811	19019273	2	3
36002869	438614	2	2
36152554	1107830	0	0
36102976	257012	1	2
36503269	4059173	6	6
42801824	1305058	0	0
44358716	1149380	0	0
42802894	1177480	0	0
44345862	1125315	0	0
45653104	1119510	0	0
45646782	1000560	0	0
44347661	1125315	0	0
45635408	1129625	0	0
45660682	1110410	0	0
45668979	1112807	0	0
45700976	1551099	0	0
45684165	1129625	0	0
45624765	1332419	2	3
45684642	1127433	2	3
45684269	1396131	0	0
45794850	1149196	0	0
45681971	1115008	0	0
45894969	1124300	0	0
46243956	715997	0	0
45801046	1125315	0	0
45801291	1501700	0	0
45789923	1125315	0	0
46316316	1119510	0	0
46309574	1119510	0	0
4047779	4029498	3	5
3051724	3001247	1	1
21500588	1125315	0	0
21002846	1115171	2	3
36002869	4139681	2	2
36152482	1759842	0	0
36221037	43012754	1	2
36503269	4237458	5	6
42801866	1125315	0	0
44356307	1738521	0	0
42802799	1307863	0	0
44345958	1125315	0	0
45653278	1119510	0	0
45646744	738818	0	0
44347691	1125315	0	0
45635247	1129625	0	0
45660553	715997	0	0
45668958	1112807	0	0
45701485	1124957	0	0
45684231	1129625	0	0
45660928	19078461	2	3
45684612	40232448	2	3
45684270	1549786	0	0
45794821	1124957	0	0
45682043	708298	0	0
45895039	967823	0	0
46243963	1557272	0	0
45800875	1125315	0	0
45801339	975125	0	0
45789810	1125315	0	0
46316270	1119510	0	0
46309931	1119510	0	0
4027403	4293740	3	5
3051724	3006734	1	1
21500588	1112807	0	0
21002844	1115171	2	3
36002869	4169137	2	2
36152482	1713332	0	0
36221037	1718412	1	2
36503269	40480160	4	6
42801900	1192710	0	0
44356321	933724	0	0
42802893	1177480	0	0
44345933	1125315	0	0
45652988	1119510	0	0
45646745	738818	0	0
44347206	1125315	0	0
45635300	1129625	0	0
45660528	791967	0	0
45668921	1112807	0	0
45701540	1000560	0	0
45684317	1129625	0	0
45633308	19078461	2	3
45684798	1551192	2	3
45684274	1149196	0	0
45794876	715997	0	0
45682099	1557272	0	0
45895189	19003953	0	0
46243974	1149196	0	0
45801212	1125315	0	0
45801379	1107830	0	0
45789814	1125315	0	0
46311135	1119510	0	0
46309457	1119510	0	0
4042641	4202451	3	4
3050153	3014599	1	1
21500589	1174888	0	0
21002844	19019273	2	3
36002869	442116	2	2
36152485	1129625	0	0
36214470	1150771	1	2
36516993	40479422	5	6
42801900	1174888	0	0
44356256	1112807	0	0
42802870	920293	0	0
44345938	1125315	0	0
45653325	1119510	0	0
45646795	1361711	0	0
44347212	1125315	0	0
45635572	1129625	0	0
45660529	1154343	0	0
45668557	1112807	0	0
45701610	1307863	0	0
45684281	1129625	0	0
45668878	19078461	2	3
45684840	19059056	2	3
45685586	1322184	0	0
45794874	1738521	0	0
45681917	1713332	0	0
45894960	933724	0	0
46244051	1174888	0	0
45800777	1125315	0	0
45795764	1124300	0	0
45790175	1125315	0	0
46311214	1119510	0	0
46310155	1119510	0	0
4043016	44805732	3	4
3050153	3012494	1	1
21500589	1177480	0	0
21004249	19112599	2	3
36002869	4102123	2	2
36152488	1124300	0	0
36214805	19112599	1	2
36516993	40479768	5	6
42801904	1713332	0	0
44356247	1539403	0	0
42802658	1332418	0	0
44346034	1125315	0	0
45653339	1119510	0	0
45646869	757627	0	0
44347215	1125315	0	0
45632323	1129625	0	0
45660734	1149196	0	0
45668805	1112807	0	0
45701815	975125	0	0
45684354	1129625	0	0
45634991	19078461	2	3
45684726	40229134	2	3
45685450	1713332	0	0
45794714	1124957	0	0
45682092	1192710	0	0
45894962	708298	0	0
46244052	1115008	0	0
45801039	1125315	0	0
45795708	975125	0	0
45789992	1125315	0	0
46310857	1119510	0	0
46310156	1119510	0	0
4103352	40481087	3	4
3050153	3001488	1	1
21500589	1125315	0	0
21004249	40229134	2	3
36203066	4218389	2	2
36152586	19127890	0	0
36214807	43012036	1	2
36516993	40486433	4	4
42801904	1759842	0	0
44356282	715997	0	0
42802660	1154343	0	0
44341228	1125315	0	0
45653095	1119510	0	0
45646870	1154343	0	0
44347360	1125315	0	0
45632394	1129625	0	0
45660646	1778162	0	0
45668884	1112807	0	0
45701712	708298	0	0
45654798	1119510	0	0
45666596	19078461	2	3
45685030	40223834	2	3
45685450	1759842	0	0
45794880	1501700	0	0
45682116	1551099	0	0
45895008	1589505	0	0
46243978	1545958	0	0
45800888	1125315	0	0
45795710	1154343	0	0
45790092	1125315	0	0
46310861	1119510	0	0
46310158	1119510	0	0
4027384	195588	3	4
3050153	3006451	1	1
21500589	1112807	0	0
21004249	43012036	2	3
36203066	78272	2	2
36152586	1515774	0	0
36159556	19127904	1	2
36516993	4280726	4	4
42801908	1124300	0	0
44356341	1177480	0	0
42802944	1177480	0	0
44341182	1125315	0	0
45653442	1119510	0	0
45646879	1174888	0	0
44347922	1125315	0	0
45632287	1129625	0	0
45660788	1759842	0	0
45666511	1112807	0	0
45701734	1124957	0	0
45654855	1119510	0	0
45664517	19078461	2	3
45682585	1115171	2	3
45685467	1192710	0	0
45794907	1115008	0	0
45682272	1154343	0	0
45894972	1112807	0	0
46244005	1174888	0	0
45801087	1125315	0	0
45795801	1107830	0	0
45790085	1125315	0	0
46310933	1119510	0	0
46309769	1119510	0	0
4027384	372328	3	4
3050153	3021226	1	1
21500583	1110410	0	0
21001846	19073188	2	3
36203066	4113008	2	2
36152586	1549786	0	0
36222375	40223821	1	2
36313965	42535580	6	7
42801912	1738521	0	0
44356441	1174888	0	0
42802904	1551099	0	0
44341322	1125315	0	0
45653458	1119510	0	0
45646883	1322184	0	0
44347620	1125315	0	0
45632432	1129625	0	0
45660788	1713332	0	0
45666495	1112807	0	0
45701675	19003953	0	0
45654738	1119510	0	0
45624460	19078461	2	3
45682625	19078461	2	3
45685577	1124300	0	0
45794913	1192710	0	0
45682106	1545958	0	0
45894973	933724	0	0
46244034	1107830	0	0
45800993	1125315	0	0
45795765	19002770	0	0
45790086	1125315	0	0
46310935	1119510	0	0
46310059	1119510	0	0
4115259	255848	3	4
3050153	3000876	1	1
21500583	1102527	0	0
21001846	19075001	2	3
36203090	196456	2	2
36152455	1307863	0	0
36222375	40223834	1	2
36313965	4037675	6	6
42801979	1154343	0	0
44356442	1549786	0	0
42802905	715997	0	0
44338715	1125315	0	0
45649770	1119510	0	0
45646905	1501700	0	0
44343625	1125315	0	0
45632365	1129625	0	0
45657464	1759842	0	0
45666502	1112807	0	0
45701676	1713332	0	0
45655079	1119510	0	0
45664021	19078461	2	3
45681678	43012036	2	3
45685579	1000560	0	0
45794634	1326303	0	0
45682250	1149196	0	0
45894991	1107830	0	0
46244055	1545958	0	0
45801150	1125315	0	0
45795766	1729720	0	0
45790011	1125315	0	0
46310938	1119510	0	0
46310062	1119510	0	0
4103183	4329847	3	4
3050153	3027231	1	1
21500143	1500211	0	0
21001846	19129655	2	3
21604036	1177480	2	2
36152558	1192710	0	0
36221667	836659	1	2
36503263	4134304	5	8
42801830	1154343	0	0
44356442	1595799	0	0
42803034	1124300	0	0
44338722	1125315	0	0
45652002	1119510	0	0
45646888	1000560	0	0
44344842	1125315	0	0
45632442	1129625	0	0
45657464	1713332	0	0
45666444	1112807	0	0
45701677	975125	0	0
45655104	1119510	0	0
45642658	19078461	2	3
45681679	19023398	2	3
45685700	740275	0	0
45794779	1309944	0	0
45682251	1713332	0	0
45895026	1717327	0	0
46244181	1332418	0	0
45799700	1125315	0	0
45795778	1110410	0	0
45790188	1125315	0	0
46310942	1119510	0	0
46310007	1119510	0	0
4086181	381316	3	4
3050153	3015076	1	1
21500143	1548195	0	0
21001846	19073183	2	3
21604036	1124300	2	2
36152544	705944	0	0
36221668	836659	1	2
36503263	40479422	5	6
42801841	1154029	0	0
44356442	1521369	0	0
42802678	723013	0	0
44338649	1125315	0	0
45651938	1119510	0	0
45646826	1310149	0	0
44344725	1125315	0	0
45629297	1129625	0	0
45657465	1107830	0	0
45666520	1112807	0	0
45701797	1107830	0	0
45655109	1119510	0	0
45633223	19078461	2	3
45681939	1127433	2	3
45685704	1713332	0	0
45794940	1322184	0	0
45682382	1548195	0	0
45895036	1192710	0	0
46243988	1307863	0	0
45799770	1125315	0	0
45795822	1307863	0	0
45792021	1125315	0	0
46311163	1119510	0	0
46304428	1119510	0	0
4086181	4066995	3	4
3052929	3006734	1	1
21500146	1589505	0	0
21001846	1713671	2	3
36002868	4051466	2	2
36152550	1738521	0	0
36214641	40236824	1	2
36503263	40479768	5	6
42802142	1545958	0	0
44356444	920293	0	0
42802977	1115008	0	0
44338729	1125315	0	0
45650025	1119510	0	0
45646827	1551099	0	0
44344749	1125315	0	0
45629300	1129625	0	0
45657467	1124300	0	0
45666682	1112807	0	0
45701820	1713332	0	0
45654785	1119510	0	0
45664534	19078461	2	3
45681820	1551192	2	3
45685704	1759842	0	0
45679221	1332418	0	0
45682198	1115008	0	0
45894982	791967	0	0
46243993	1115008	0	0
45799751	1125315	0	0
45795784	1149196	0	0
45792078	1125315	0	0
46311185	1119510	0	0
46304430	1119510	0	0
4091532	4166224	3	4
3052929	3001247	1	1
21500147	1521369	0	0
21001924	19074841	2	3
36203060	4218389	2	2
36152552	1177480	0	0
1738521	46233710	2	3
36503263	4149245	4	5
42802036	1153428	0	0
44356450	1107830	0	0
42802978	1500211	0	0
44338772	1125315	0	0
45646673	1119510	0	0
45646841	1110410	0	0
44343724	1125315	0	0
45629510	1129625	0	0
45657480	1000560	0	0
45666706	1112807	0	0
45701793	723013	0	0
45655118	1119510	0	0
45624808	19079524	2	3
45681866	19019273	2	3
45685660	1107830	0	0
45679326	1107830	0	0
45682201	967823	0	0
45895107	975125	0	0
46244008	19010482	0	0
45799752	1125315	0	0
45795794	1174888	0	0
45787435	1125315	0	0
46311304	1119510	0	0
46304526	1119510	0	0
4181063	4112343	3	4
3052932	3001247	1	1
21500147	933724	0	0
21001924	19075001	2	3
21602657	933724	2	2
36152528	1549786	0	0
36213587	19127918	2	3
36503263	81151	4	6
42802175	1515774	0	0
44356452	1713332	0	0
42802982	1125315	0	0
44338682	1125315	0	0
45646739	1119510	0	0
45646924	1361711	0	0
44343732	1125315	0	0
45629378	1129625	0	0
45658564	1115008	0	0
45666858	1112807	0	0
45701935	1713332	0	0
45655201	1119510	0	0
45666788	1545959	2	3
45678570	40163554	2	3
45685708	1729720	0	0
45679383	1545958	0	0
45682324	975125	0	0
45895109	1174888	0	0
46240097	975125	0	0
45798065	1125315	0	0
45795794	1192710	0	0
45787436	1125315	0	0
46311594	1119510	0	0
46304410	1119510	0	0
4172024	4174876	3	4
3052932	3006734	1	1
21500147	1500211	0	0
21001924	19074843	2	3
36002874	80809	2	2
36152529	1713332	0	0
36213587	19128009	2	3
36502196	4059173	6	6
42802175	1549786	0	0
44356452	1759842	0	0
42802474	1332418	0	0
44338791	1125315	0	0
45646744	1119510	0	0
45646926	1728416	0	0
44343715	1125315	0	0
45629179	1129625	0	0
45658565	1192710	0	0
45664414	1112807	0	0
45701914	1729720	0	0
45700759	1119510	0	0
45635088	1332419	2	3
45678574	40162522	2	3
45685539	1343916	0	0
45678980	1112807	0	0
45682465	1326303	0	0
45895062	1332418	0	0
46238902	1192710	0	0
45798085	1125315	0	0
45795861	1000560	0	0
45787438	1125315	0	0
46322095	1119510	0	0
46304633	1119510	0	0
4103662	4132546	3	4
3052978	3001247	1	1
21500131	1548195	0	0
21001924	19073183	2	3
35702741	30753	2	2
36152532	1177480	0	0
36158196	19078461	2	3
36502196	4142905	5	6
42802224	1549786	0	0
44356343	1332418	0	0
42802578	1539403	0	0
44338732	1125315	0	0
45646848	1119510	0	0
45646954	1738521	0	0
44343956	1125315	0	0
45629601	1129625	0	0
45658547	1713332	0	0
45664304	1112807	0	0
45701772	1548195	0	0
45700839	1119510	0	0
45636777	1545959	2	3
45678696	40232448	2	3
45684429	1149196	0	0
45679272	975125	0	0
45681995	1107830	0	0
45895015	1112807	0	0
46238931	1332418	0	0
45798111	1125315	0	0
45795839	1174888	0	0
45787439	1125315	0	0
46322418	1119510	0	0
46304668	1119510	0	0
4176642	4107731	3	4
3052978	3006734	1	1
21500145	19127890	0	0
21001924	19073188	2	3
36211677	40480160	2	2
36152532	1174888	0	0
35507075	1545959	2	3
36502196	4237458	5	6
42801990	1107830	0	0
44356344	738818	0	0
44355398	1129625	0	0
44338736	1125315	0	0
45646952	1119510	0	0
45647105	1557272	0	0
44344038	1125315	0	0
45629549	1129625	0	0
45658344	1110410	0	0
45660965	1112807	0	0
45701874	1124957	0	0
45701611	1119510	0	0
45668550	1545959	2	3
45678554	19008572	2	3
45684394	967823	0	0
45679274	1115008	0	0
45682218	1501700	0	0
45895051	1713332	0	0
46238882	1149196	0	0
45798145	1125315	0	0
45795915	1551099	0	0
45787370	1125315	0	0
46322611	1119510	0	0
46304905	1119510	0	0
4178367	4024289	3	4
3052983	3006734	1	1
21500145	1589505	0	0
21013671	1310034	2	3
36203047	4048695	2	2
36152622	1549786	0	0
35506822	40174880	2	3
36502205	78272	6	8
42802063	1125315	0	0
44356293	1521369	0	0
44355398	1125315	0	0
44339050	1125315	0	0
45646862	1119510	0	0
45647133	1153428	0	0
44344046	1125315	0	0
45629567	1129625	0	0
45658346	967823	0	0
45661676	1112807	0	0
45701886	1713332	0	0
45701626	1119510	0	0
45664361	1539411	2	3
45678556	1154615	2	3
45684379	738818	0	0
45679225	1107830	0	0
45682230	1174888	0	0
45895052	791967	0	0
46238918	1107830	0	0
45798185	1125315	0	0
45795921	791967	0	0
45787475	1125315	0	0
46316495	1119510	0	0
46304911	1119510	0	0
4178367	4252419	3	4
3052983	3001247	1	1
21500145	1595799	0	0
21001866	1551192	2	3
36002141	81893	2	2
36152627	1153428	0	0
36217212	19126352	2	3
36502197	4142905	6	8
42802073	1125315	0	0
44356293	1549786	0	0
44355568	1177480	0	0
44339075	1125315	0	0
45646993	1119510	0	0
45647135	1717327	0	0
44344016	1125315	0	0
45629364	1129625	0	0
45658351	1521369	0	0
45661656	1112807	0	0
45701886	1759842	0	0
45701706	1119510	0	0
45633279	1545959	2	3
45678667	40231925	2	3
45684380	1154343	0	0
45679231	1112807	0	0
45682231	1501700	0	0
45895067	1112807	0	0
46238966	1322184	0	0
45798069	1125315	0	0
45795922	1000560	0	0
45787256	1125315	0	0
46316522	1119510	0	0
46305172	1119510	0	0
4042835	4294548	3	4
3053021	3006734	1	1
21500145	1521369	0	0
21002827	19019273	2	3
36203055	4132546	2	2
36152629	975125	0	0
1728416	19006318	2	3
36503289	4048171	6	6
42802073	1174888	0	0
44356358	1551099	0	0
44355524	1521369	0	0
44338908	1125315	0	0
45646994	1119510	0	0
45647138	1501700	0	0
44344223	1125315	0	0
45629483	1129625	0	0
45658401	1549786	0	0
45654775	1112807	0	0
45701967	1154343	0	0
45701795	1119510	0	0
45630921	1539411	2	3
45678908	19008572	2	3
45684472	1500211	0	0
45679145	1112807	0	0
45682364	975125	0	0
45895069	1124957	0	0
46238893	1192710	0	0
45798276	1125315	0	0
45795799	1361711	0	0
45787417	1125315	0	0
46317367	1119510	0	0
46305184	1119510	0	0
4040392	4238715	3	4
3053021	3001247	1	1
21500145	1503184	0	0
21002827	1551192	2	3
36002872	40486433	2	2
36152632	1149196	0	0
36157948	19078461	2	3
36502205	40479422	5	6
42801938	1177480	0	0
44356473	1124300	0	0
44355524	1549786	0	0
44338806	1125315	0	0
45647087	1119510	0	0
45647139	19010482	0	0
44340088	1125315	0	0
45629492	1129625	0	0
45658401	1518198	0	0
45654895	1112807	0	0
45701971	738818	0	0
45701764	1119510	0	0
45636894	1539411	2	3
45672404	40228230	2	3
45684397	1192710	0	0
45679342	1192710	0	0
45682377	975125	0	0
45895055	967823	0	0
46239033	1539403	0	0
45798159	1125315	0	0
45795866	1332418	0	0
45787196	1125315	0	0
46318012	1119510	0	0
46304500	1119510	0	0
4040721	4010253	3	4
3013094	3013721	1	1
21500145	1515774	0	0
21013433	46233710	2	3
21602553	19127922	2	2
36152633	1149196	0	0
21603968	19019273	2	3
36502205	40479768	5	6
42802151	1545958	0	0
44356475	1115008	0	0
44355574	1115008	0	0
44338798	1125315	0	0
45646109	1119510	0	0
45646709	1548195	0	0
44340093	1125315	0	0
45629414	1129625	0	0
45658386	1115008	0	0
45654883	1112807	0	0
45701974	1738521	0	0
45701806	1119510	0	0
45688793	1539411	2	3
45673384	40231925	2	3
45684406	19127890	0	0
45679348	1107830	0	0
45682010	1110410	0	0
45895133	1112807	0	0
46238980	1115008	0	0
45798261	1125315	0	0
45795982	1154343	0	0
45787483	1125315	0	0
46317538	1119510	0	0
46304961	1119510	0	0
4155793	4024289	3	4
3013094	3024561	1	1
21500145	1549786	0	0
21013433	19129655	2	3
21602553	19133679	2	2
36152626	1322184	0	0
35506892	40228214	2	3
36603422	78272	7	7
42802154	914335	0	0
44356269	975125	0	0
44355592	1549786	0	0
44338903	1125315	0	0
45645860	1119510	0	0
45647114	1174888	0	0
44340439	1125315	0	0
45631097	1129625	0	0
45657513	1778162	0	0
45634911	1149196	0	0
45701996	975125	0	0
45701921	1119510	0	0
45648856	1539411	2	3
45672723	1551192	2	3
45684406	1549786	0	0
45679352	1112807	0	0
45682014	1149380	0	0
45895212	1361711	0	0
46238981	1192710	0	0
45798397	1125315	0	0
45795809	1326303	0	0
45787280	1125315	0	0
46316840	1119510	0	0
46305194	1119510	0	0
4180628	44782520	3	4
3013094	3035995	1	1
21500145	1512674	0	0
21013433	920334	2	3
21602553	19129144	2	2
36152655	975125	0	0
36152237	19078461	2	3
36516772	4134304	7	8
42802156	1125315	0	0
44356350	975125	0	0
44355592	1521369	0	0
44339201	1125315	0	0
45643853	1119510	0	0
45647147	1713332	0	0
44340504	1125315	0	0
45626534	1129625	0	0
45657550	1549786	0	0
45634844	920293	0	0
45701998	1149380	0	0
45701971	1119510	0	0
45648644	1539411	2	3
45672649	920334	2	3
45684391	1149196	0	0
45679189	1539403	0	0
45678933	1115008	0	0
45895121	701322	0	0
46239068	1115008	0	0
45798508	1125315	0	0
45795850	1307863	0	0
45875962	21494966	2	2
46316841	1119510	0	0
46304936	1119510	0	0
4180628	372328	3	4
3013094	3006923	1	1
21500146	19127890	0	0
21013433	1713671	2	3
36153492	19128022	2	2
36152601	1119510	0	0
36152697	1107882	2	3
36516825	4134304	7	7
42802209	723013	0	0
44356463	975125	0	0
44355593	1119510	0	0
44339207	1125315	0	0
45643926	1119510	0	0
45647141	1174888	0	0
44340387	1125315	0	0
45626537	1129625	0	0
45657550	1521369	0	0
45634966	1501700	0	0
45701998	1137529	0	0
45698488	1119510	0	0
45651698	46275916	1	1
45672731	40232448	2	3
45684453	1326303	0	0
45679207	1305058	0	0
45678937	1107830	0	0
45895087	1361711	0	0
46239043	1332418	0	0
45798302	1125315	0	0
45795871	1307863	0	0
46244893	42902245	2	2
46311484	1119510	0	0
46320891	1119510	0	0
4042836	4132546	3	4
3013094	3020630	1	1
21500146	1521369	0	0
21013433	46233988	2	3
21602537	1500211	2	2
36152730	1741122	0	0
36157005	1107882	2	3
36503266	4134304	4	6
42802220	975125	0	0
44356464	1115008	0	0
44355501	1125315	0	0
44339063	1125315	0	0
45643928	1119510	0	0
45646861	715997	0	0
44340039	1125315	0	0
45626771	1129625	0	0
45657563	1326303	0	0
45634972	1713332	0	0
45701938	1124300	0	0
45698821	1119510	0	0
45651698	19079524	1	1
45672758	19059056	2	3
45684455	1309944	0	0
45679245	715997	0	0
45678759	1539403	0	0
45895197	1192710	0	0
46239035	975125	0	0
45795364	1125315	0	0
45795872	1149196	0	0
46243956	40223768	2	3
46311630	1119510	0	0
46321160	1119510	0	0
4042836	257012	3	4
1718400	19132304	1	1
21500146	1595799	0	0
21013433	920300	2	3
21602551	1521369	2	2
36152730	1746114	0	0
36156854	1107882	2	3
36502205	4146173	4	5
42802181	1154343	0	0
44356404	1177480	0	0
44355596	1539403	0	0
44339070	1125315	0	0
45643946	1119510	0	0
45646981	1154343	0	0
44339948	1125315	0	0
45626661	1129625	0	0
45657521	1539403	0	0
45634972	1759842	0	0
45701964	975125	0	0
45700548	1119510	0	0
45704402	19079524	1	1
45672856	40232448	2	3
45684473	1501700	0	0
45679252	1307863	0	0
45678760	975125	0	0
45895235	1549786	0	0
46239042	1192710	0	0
45795402	1125315	0	0
45795984	715997	0	0
46238947	19078461	2	3
46306376	1119510	0	0
46321559	1119510	0	0
4042836	40481087	3	4
1718400	1718412	1	1
21500146	1515774	0	0
21013433	19075001	2	3
36211382	4066995	2	2
36152567	1124300	0	0
21603266	40169281	2	3
36475214	1119510	0	0
42802077	1000560	0	0
44356483	1115008	0	0
44355600	1154343	0	0
44360302	1125315	0	0
45644070	1119510	0	0
45647197	1545958	0	0
44340369	1125315	0	0
45626582	1129625	0	0
45657576	1107830	0	0
45635064	1149196	0	0
45698817	1343916	0	0
45698943	1119510	0	0
45648780	46275916	1	1
45672982	40231925	2	3
45684407	1501700	0	0
45679182	1154343	0	0
45678883	19127890	0	0
45895235	1515774	0	0
46239002	920293	0	0
45795407	1125315	0	0
45795814	791967	0	0
45798614	19078461	2	3
46306501	1119510	0	0
46321191	1119510	0	0
4047779	140673	3	4
1718400	46221626	1	1
21500146	1549786	0	0
21002591	46233710	2	3
36211382	4048695	2	2
36152589	1149196	0	0
36152939	40228214	2	3
36475223	1521369	0	0
42802228	1124300	0	0
44356416	738818	0	0
44355531	1125315	0	0
44360316	1125315	0	0
45643992	1119510	0	0
44352155	1549786	0	0
44340032	1125315	0	0
45626687	1129625	0	0
45657659	1332418	0	0
45634941	1149196	0	0
45698853	1149196	0	0
45699029	1119510	0	0
45648780	19079524	1	1
45672845	40232448	2	3
45684416	1149196	0	0
45679441	715997	0	0
45678883	1549786	0	0
45895241	1343916	0	0
46238993	1192710	0	0
45795411	1125315	0	0
45795882	1551099	0	0
45787961	19078461	2	3
46306218	1119510	0	0
46321308	1119510	0	0
4027403	4295880	3	4
1718402	46221626	1	1
21500137	1521369	0	0
21002591	19074841	2	3
36009740	37017711	2	2
36152760	1149196	0	0
35506945	19075601	2	3
36475223	1549786	0	0
42802224	1589505	0	0
44356491	1332418	0	0
44355531	1119510	0	0
44360413	1125315	0	0
45644015	1119510	0	0
44352291	715997	0	0
44340637	1125315	0	0
45626868	1129625	0	0
45657666	1521369	0	0
45635001	1115008	0	0
45698863	1305058	0	0
45699043	1119510	0	0
45695031	19079524	1	1
45672850	19008572	2	3
45684440	1713332	0	0
45679445	1112807	0	0
45678634	1174888	0	0
45895324	738818	0	0
46238998	975125	0	0
45795570	1125315	0	0
45795892	975125	0	0
46239183	19078461	2	3
46306516	1119510	0	0
46321331	1119510	0	0
4028902	4151422	3	3
1718403	19132304	1	1
21012460	715997	0	0
21002591	19129655	2	3
36009740	433644	2	2
36152762	1119510	0	0
21502734	1310034	2	3
36475351	1149196	0	0
42802043	1177480	0	0
44356471	1112807	0	0
44355657	1119510	0	0
44360049	1125315	0	0
45641216	1119510	0	0
44352370	738818	0	0
44340196	1125315	0	0
45626904	1129625	0	0
45657666	1548195	0	0
45635035	1192710	0	0
45698880	791967	0	0
45698933	1119510	0	0
45642831	19079524	1	1
45672771	19076374	2	3
45684543	1332418	0	0
45679448	1154029	0	0
45678678	1332418	0	0
45895173	740275	0	0
46239292	975125	0	0
45795669	1125315	0	0
45796122	1000560	0	0
45798690	19078461	2	3
46306244	1119510	0	0
46321354	1119510	0	0
4040394	4108705	3	3
1718405	1718412	1	1
21013408	1551099	0	0
21002591	46275444	2	3
36009740	4240902	2	2
36152735	19003953	0	0
36156287	19075601	2	3
36475417	1119510	0	0
42802139	1115008	0	0
44356494	1177480	0	0
44355657	1125315	0	0
44360209	1125315	0	0
45640901	1119510	0	0
44352373	1521369	0	0
44340197	1125315	0	0
45623310	1129625	0	0
45657595	1174888	0	0
45635150	975125	0	0
45698884	1124300	0	0
45695474	1119510	0	0
45636743	46275916	1	1
45784682	40232448	2	3
45684574	1115008	0	0
45679492	1746114	0	0
45678867	1192710	0	0
45895091	1713332	0	0
46239056	1107830	0	0
45795547	1125315	0	0
45796043	1124957	0	0
45788231	1332419	2	3
46306468	1119510	0	0
46321108	1119510	0	0
4032257	42535580	3	3
1718411	1718412	1	1
21012460	701322	0	0
21002591	46233988	2	3
36009740	4219399	2	2
36152736	1177480	0	0
36152376	40228214	2	3
36475856	1119510	0	0
42802120	1551099	0	0
44356584	1149380	0	0
44355659	1551099	0	0
44360349	1125315	0	0
45640912	1119510	0	0
44352373	1549786	0	0
44340203	1125315	0	0
45623370	1129625	0	0
45657678	1107830	0	0
45635151	738818	0	0
45698480	708298	0	0
45695556	1119510	0	0
45636743	19079524	1	1
45784550	40232448	2	3
45684576	1539403	0	0
45679492	1741122	0	0
45678868	791967	0	0
45895091	1759842	0	0
46239187	1115008	0	0
45795658	1125315	0	0
45795932	967823	0	0
45896146	19078461	2	3
46306739	1119510	0	0
46320954	1119510	0	0
4176644	372328	3	3
1718993	1718412	1	1
21013408	19010482	0	0
21002591	19075001	2	3
36009869	4280726	2	2
36152880	1119510	0	0
36157655	19078461	2	3
36474269	1332418	0	0
42802048	975125	0	0
44356588	1112807	0	0
44355663	1361711	0	0
44360239	1125315	0	0
45641116	1119510	0	0
44352373	1595799	0	0
44340204	1125315	0	0
45623373	1129625	0	0
45657838	1000560	0	0
45635343	1149196	0	0
45698712	1738521	0	0
45695778	1119510	0	0
45645758	19079524	1	1
45784558	1551192	2	3
45681442	1115008	0	0
45679501	1343916	0	0
45678647	1539403	0	0
45895097	1149196	0	0
46239009	1713332	0	0
45795690	1125315	0	0
45795900	1124957	0	0
46299418	19078461	2	3
46306230	1119510	0	0
46321588	1119510	0	0
4176944	4294548	3	3
1545961	1545959	1	1
21013411	1717327	0	0
21002591	1713671	2	3
36009869	40486433	2	2
36152880	738818	0	0
36213586	19128009	2	3
36474281	1119510	0	0
42802051	1125315	0	0
44356590	1713332	0	0
44355664	1119510	0	0
44359936	1125315	0	0
45641130	1119510	0	0
44351211	1149196	0	0
44340324	1125315	0	0
45623374	1129625	0	0
45657683	1115008	0	0
45634992	1307863	0	0
45698723	1124957	0	0
45694383	1119510	0	0
45688814	19079524	1	1
45784788	40232448	2	3
45681447	1154343	0	0
45679651	1153428	0	0
45678916	967823	0	0
45895099	975125	0	0
46239093	1713332	0	0
45796925	1125315	0	0
45796049	791967	0	0
46298940	19078461	2	3
46306577	1119510	0	0
46321595	1119510	0	0
4148703	4330583	3	3
1326409	19018935	1	1
21013409	1551099	0	0
21002591	19074843	2	3
35702732	4266809	2	2
36152889	1115008	0	0
36213586	19127918	2	3
36473642	1548195	0	0
42802053	1149380	0	0
44356590	1759842	0	0
44355667	1125315	0	0
44359938	1125315	0	0
45641137	1119510	0	0
44351230	1149196	0	0
44337465	1125315	0	0
45623529	1129625	0	0
45657688	1729720	0	0
45634994	967823	0	0
45698484	1107830	0	0
45694701	1119510	0	0
45694997	19079524	1	1
45784665	40162522	2	3
45681454	1192710	0	0
45679291	1332418	0	0
45678851	1768849	0	0
45895151	967823	0	0
46239093	1759842	0	0
45796935	1125315	0	0
45790672	967823	0	0
46290880	19078461	2	3
46317158	1119510	0	0
46321457	1119510	0	0
4063381	258780	3	3
1150866	1150837	1	1
21013418	1305058	0	0
21002591	19073188	2	3
36203068	4066995	2	2
36152570	1149196	0	0
36152626	19075601	2	3
36473662	1119510	0	0
42802125	1307863	0	0
44356578	723013	0	0
44355667	1119510	0	0
44360306	1125315	0	0
45641139	1119510	0	0
44351280	1332418	0	0
44337366	1125315	0	0
45623743	1129625	0	0
45657677	19127890	0	0
45634984	1115008	0	0
45698488	738818	0	0
45692438	1119510	0	0
45627846	19079524	1	1
45784924	40163554	2	3
45681458	1521369	0	0
45792050	1149196	0	0
45678735	1549786	0	0
45895186	967823	0	0
46239101	975125	0	0
45796937	1125315	0	0
45790355	1192710	0	0
46239452	19078461	2	3
46317299	1119510	0	0
46315373	1119510	0	0
4042822	4330583	3	3
1150808	1150771	1	1
21013411	1778162	0	0
21002805	1551192	2	3
35902852	196456	2	2
36152462	1551099	0	0
36213592	42902245	2	3
36473711	1149196	0	0
42802231	975125	0	0
44356629	1174888	0	0
44355667	738818	0	0
44360262	1125315	0	0
45641253	1119510	0	0
44351323	1521369	0	0
45620324	1125315	0	0
45623422	1129625	0	0
45657677	1549786	0	0
45634985	738818	0	0
45698887	1545958	0	0
45692414	1119510	0	0
45688943	19079524	1	1
45784764	19008572	2	3
45681458	1595799	0	0
45792058	1115008	0	0
45678735	1589505	0	0
45895330	1149196	0	0
46239102	1118084	0	0
45797231	1125315	0	0
45790359	1149196	0	0
45801560	19078461	2	3
45896740	1125315	0	0
46315661	1119510	0	0
4028970	258780	3	3
764205	4056621	1	1
21013403	1551099	0	0
21002805	1115171	2	3
35902853	196456	2	2
36152463	1115008	0	0
36213593	42902245	2	3
36473773	1177480	0	0
42802236	1125315	0	0
44356631	1738521	0	0
44355669	1729720	0	0
44360270	1125315	0	0
45641300	1119510	0	0
44351323	19127890	0	0
45620277	1125315	0	0
45623452	1129625	0	0
45657542	1551099	0	0
45634986	1322184	0	0
45698675	1343916	0	0
45692427	1119510	0	0
45704399	19079524	1	1
45784734	19133905	2	3
45681458	1549786	0	0
45792103	1539403	0	0
45678854	967823	0	0
45894334	1309944	0	0
46239110	975125	0	0
45797233	1125315	0	0
45790459	1115008	0	0
46244086	19078461	2	3
45895704	1125315	0	0
46315667	1119510	0	0
4040560	4163971	3	3
443723	439777	1	1
21013390	1309944	0	0
21002805	19007333	2	3
35909418	198809	2	2
36152703	975125	0	0
36152633	40228214	2	3
36473817	1309944	0	0
42802236	1174888	0	0
44349193	1738521	0	0
44355670	975125	0	0
44360344	1125315	0	0
45641362	1119510	0	0
44351323	1549786	0	0
45620165	1125315	0	0
45623407	1129625	0	0
45657652	1310149	0	0
45635068	1000560	0	0
45698736	1549786	0	0
45692430	1119510	0	0
45666914	19079524	1	1
45784734	19133873	2	3
45681329	1332418	0	0
45792031	1713332	0	0
45678739	1521369	0	0
45894492	19010482	0	0
46239318	1149196	0	0
45796943	1125315	0	0
45790676	1332418	0	0
46244253	19078461	2	3
45895587	1125315	0	0
46315968	1119510	0	0
4027717	4186930	3	3
440320	4116491	1	1
21013433	1713332	0	0
21002805	19019979	2	3
35702777	4027663	2	2
36152576	933724	0	0
36156842	40228214	2	3
36473881	1125315	0	0
42802237	740275	0	0
44349312	1107830	0	0
44355671	1124300	0	0
44360346	1125315	0	0
45641374	1119510	0	0
44351256	1545958	0	0
45620187	1125315	0	0
45667907	1129625	0	0
45657775	738818	0	0
45635004	1115008	0	0
45698736	19127890	0	0
45692729	1119510	0	0
45676465	19079524	1	1
45782439	40224805	2	3
45681464	1551099	0	0
45792031	1759842	0	0
45678739	19127890	0	0
45894477	1174888	0	0
45790468	1545958	0	0
45792994	1125315	0	0
45790519	1332418	0	0
45793266	19078461	2	3
45895639	1125315	0	0
46315780	1119510	0	0
4133611	4001336	3	3
3050951	3016723	1	2
21013433	1717327	0	0
21002805	19059056	2	3
35508412	40162522	2	3
36152577	1119510	0	0
36157771	40228214	2	3
36473965	1124300	0	0
42801926	1149380	0	0
44349328	1192710	0	0
44355570	1125315	0	0
44362727	1125315	0	0
45641398	1119510	0	0
44351342	1717327	0	0
45620384	1125315	0	0
45667935	1129625	0	0
45657786	1107830	0	0
45634977	723013	0	0
45698736	1589505	0	0
45692519	1119510	0	0
45695037	19079524	1	1
45783590	42707627	2	3
45681472	1192710	0	0
45792258	1548195	0	0
45678739	1549786	0	0
45894313	1501700	0	0
45790474	740275	0	0
45793009	1125315	0	0
45790522	1115008	0	0
45801557	19078461	2	3
45895642	1125315	0	0
46316029	1119510	0	0
4028876	260139	3	3
3051542	3013682	1	2
21013457	740275	0	0
21600248	1310034	2	5
35508270	1115171	2	3
36152579	1124957	0	0
36152760	40228214	2	3
36474109	1125315	0	0
42801928	920293	0	0
44349328	1174888	0	0
44355723	1174888	0	0
44362523	1125315	0	0
45638137	1119510	0	0
44351287	1322184	0	0
45620441	1125315	0	0
45667613	1129625	0	0
45657787	1124957	0	0
45635092	1332418	0	0
45698685	1501700	0	0
45692431	1119510	0	0
45645661	19079524	1	1
45783579	19129655	2	3
45681473	738818	0	0
45792266	705944	0	0
45678742	1149196	0	0
45894408	1153428	0	0
45790613	1332418	0	0
45793017	1125315	0	0
45790525	1115008	0	0
46243775	19078461	2	3
45895578	1125315	0	0
46315592	1119510	0	0
4063579	4062501	3	3
1718406	1718412	1	2
21003385	975125	0	0
21600269	1310034	1	4
35508602	40224805	2	3
36152581	1107830	0	0
36152874	40228214	2	3
36468849	1177480	0	0
42802184	1545958	0	0
44349214	1149196	0	0
44355729	1713332	0	0
44362704	1125315	0	0
45638015	1119510	0	0
44351350	1713332	0	0
45620442	1125315	0	0
45667742	1129625	0	0
45657813	1110410	0	0
45635093	738818	0	0
45698687	1110410	0	0
45692491	1119510	0	0
45683153	19079524	1	1
45782678	1115171	2	3
45681583	1124957	0	0
45792062	1115008	0	0
45678744	1124957	0	0
45894412	1332418	0	0
45790418	1112807	0	0
45792825	1125315	0	0
45790638	1192710	0	0
46243853	19078461	2	3
45895626	1125315	0	0
46316009	1119510	0	0
4032377	4230209	3	3
320136	4112343	3	7
21003387	1129625	0	0
21503165	1119510	1	1
35508625	40229134	2	3
36152638	1589505	0	0
35507154	40228214	2	3
36475983	1177480	0	0
42801992	1548195	0	0
44349397	1177480	0	0
44355729	1759842	0	0
44350839	1125315	0	0
45637957	1119510	0	0
44351354	723013	0	0
45620550	1125315	0	0
45667743	1129625	0	0
45657822	1192710	0	0
45635042	1310149	0	0
45698911	1174888	0	0
45692604	1119510	0	0
45691704	19079524	1	1
45782969	40228230	2	3
45681197	1778162	0	0
45792251	1000560	0	0
45678949	1519936	0	0
45894413	1110410	0	0
45787596	705944	0	0
45792831	1125315	0	0
45790644	1115008	0	0
46294316	19078461	2	3
45895645	1125315	0	0
46310178	1119510	0	0
4032377	4234705	3	3
320136	261325	3	6
21003387	1343916	0	0
21503165	1125315	1	1
35508513	40229134	2	3
36152939	1149196	0	0
36152946	19078461	2	3
36476757	1149380	0	0
42802094	1521369	0	0
44349525	1307863	0	0
44355692	1110410	0	0
44350683	1125315	0	0
45637939	1119510	0	0
44351377	791967	0	0
45620362	1125315	0	0
45667817	1129625	0	0
45657522	1713332	0	0
45635057	1192710	0	0
45700518	1307863	0	0
45692550	1119510	0	0
45660118	19079524	1	1
45782855	40162522	2	3
45681284	1115008	0	0
45792338	1332418	0	0
45679366	1149196	0	0
45894495	1107830	0	0
45787766	1738521	0	0
45792756	1125315	0	0
45790661	1174888	0	0
45893946	19078461	2	3
45895664	1125315	0	0
46309811	1119510	0	0
4154739	4059173	3	3
320136	4294548	3	6
21003377	1192710	0	0
21503166	1119510	1	1
36203042	4142905	2	3
36152946	1177480	0	0
36157581	19078461	2	3
36476385	1129625	0	0
42802204	1322184	0	0
44349530	1521369	0	0
44355845	1107830	0	0
44350535	1125315	0	0
45638106	1119510	0	0
44347267	1545958	0	0
45620357	1125315	0	0
45665454	1129625	0	0
45657637	1124957	0	0
45635161	1500211	0	0
45700586	19127890	0	0
45692583	1119510	0	0
45704463	46275916	1	1
45782710	19018935	2	3
45681291	975125	0	0
45792197	975125	0	0
45679370	1000560	0	0
45894454	1149196	0	0
45787402	1307863	0	0
45793089	1125315	0	0
45790486	1174888	0	0
46294543	19078461	2	3
45895679	1125315	0	0
46310038	1119510	0	0
4154739	4048695	3	3
320136	40486433	3	6
21003377	1129625	0	0
21503166	1112807	1	1
35702718	4285898	2	3
36152607	1119510	0	0
35506942	19078461	2	3
36476385	1125315	0	0
42802101	1115008	0	0
44349530	1549786	0	0
44355542	1118084	0	0
44350541	1125315	0	0
45638151	1119510	0	0
44347473	791967	0	0
45620509	1125315	0	0
45665573	1129625	0	0
45657944	1501700	0	0
45635087	1149196	0	0
45700586	1549786	0	0
45692620	1119510	0	0
45704463	19079524	1	1
45782771	40231925	2	3
45681293	1326303	0	0
45792182	1112807	0	0
45705238	738818	0	0
45894456	19127890	0	0
45787426	1112807	0	0
45792852	1125315	0	0
45790487	1332418	0	0
46239541	19078461	2	3
45895686	1125315	0	0
46311900	1119510	0	0
4154739	4278672	3	3
320136	260139	3	6
21003402	19010482	0	0
21503166	1125315	1	1
36203060	4149245	2	3
36152611	738818	0	0
36157711	19078461	2	3
36476510	1125315	0	0
42802192	1119510	0	0
44349337	1545958	0	0
44355549	1112807	0	0
44350529	1125315	0	0
45638077	1119510	0	0
44347239	1545958	0	0
44362219	1125315	0	0
45665583	1129625	0	0
45657790	1107830	0	0
45635088	1332418	0	0
45700589	975125	0	0
45689619	1119510	0	0
45707121	19079524	1	1
45780544	40232448	2	3
45681298	975125	0	0
45792089	1174888	0	0
45705267	738818	0	0
45894456	1515774	0	0
45787432	1539403	0	0
45792931	1125315	0	0
45790618	1738521	0	0
45790976	19078461	2	3
45802504	1125315	0	0
46311849	1119510	0	0
4154739	4066995	3	3
77960	81151	3	5
21003378	975125	0	0
21503166	1129625	1	1
36152833	19008572	2	3
36152611	1119510	0	0
36157610	1332419	2	3
36476549	1119510	0	0
42802168	1738521	0	0
44349402	1322184	0	0
44355615	1308738	0	0
44350825	1125315	0	0
45637970	1119510	0	0
44347269	1778162	0	0
44362100	1125315	0	0
45665709	1129625	0	0
45654046	740275	0	0
45635381	1174888	0	0
45700526	914335	0	0
45689593	1119510	0	0
45645945	19079524	1	1
45780781	19133905	2	3
45681302	1149196	0	0
45792093	1124957	0	0
45780010	738818	0	0
45894456	1549786	0	0
45787408	1112807	0	0
45792935	1125315	0	0
45790492	1000560	0	0
45801472	1545959	2	3
45801989	1125315	0	0
46312027	1119510	0	0
4154739	40480160	3	3
3050940	3023103	3	5
21003400	19010482	0	0
21503166	738818	1	1
36153433	1127433	2	3
36152872	1119510	0	0
35507048	1332419	2	3
36476549	1125315	0	0
42807218	1545958	0	0
44349334	1713332	0	0
44355617	1177480	0	0
44350638	1125315	0	0
45638057	1119510	0	0
44347162	1149196	0	0
44362104	1125315	0	0
45663134	1129625	0	0
45654048	738818	0	0
45635382	1174888	0	0
45700615	1713332	0	0
45691569	1119510	0	0
45667161	19079524	1	1
45780632	19019273	2	3
45681502	1174888	0	0
45792096	1174888	0	0
45780053	738818	0	0
45894461	1174888	0	0
45787560	1124957	0	0
45793095	1125315	0	0
45790593	1549786	0	0
45796246	1545959	2	3
45801993	1125315	0	0
46310242	1119510	0	0
4103661	4066995	3	3
372887	4132546	3	3
21003404	19010482	0	0
21503166	1192710	1	1
36153336	1115171	2	3
36152923	1112807	0	0
1717327	19129655	2	3
36476622	1154343	0	0
42807040	1177480	0	0
44349354	723013	0	0
44355400	1177480	0	0
44350546	1125315	0	0
45638042	1119510	0	0
44347592	1153428	0	0
44362091	1125315	0	0
45663283	1129625	0	0
45654116	1174888	0	0
45635118	1192710	0	0
45700615	1759842	0	0
45691574	1119510	0	0
45704452	19079524	1	1
45780895	40162522	2	3
45681468	967823	0	0
45792097	1192710	0	0
45780138	738818	0	0
45894579	1332418	0	0
45787567	1112807	0	0
45793106	1125315	0	0
45790593	19127890	0	0
45790979	1332419	2	3
45801994	1125315	0	0
46310392	1119510	0	0
4042640	4337138	3	3
440142	317576	3	3
21003404	1551099	0	0
21503197	19010482	1	1
36153439	1127433	2	3
36152748	1124300	0	0
35507034	1545959	2	3
36427690	1746114	0	0
42807040	1174888	0	0
44349343	1124300	0	0
44355505	1129625	0	0
44350557	1125315	0	0
45638183	1119510	0	0
44347487	1551099	0	0
44362221	1125315	0	0
45663275	1129625	0	0
45654117	1107830	0	0
45635119	1308738	0	0
45700547	1149380	0	0
45689702	1119510	0	0
45669246	19079524	1	1
45780952	40236446	2	3
45681566	1124957	0	0
45792097	1112807	0	0
45706100	738818	0	0
45894580	1124957	0	0
45787568	1124300	0	0
45792840	1125315	0	0
45790593	1589505	0	0
46239457	1545959	2	3
45801954	1125315	0	0
46310506	1119510	0	0
4115574	196456	3	3
440142	321042	3	3
21003322	975125	0	0
21503064	1343916	1	1
36153041	1127433	2	3
36152898	975125	0	0
21502741	46233988	2	3
36426272	1107830	0	0
42807038	1551099	0	0
44349410	1539403	0	0
44355509	1112807	0	0
44350726	1125315	0	0
45638255	1119510	0	0
44347475	701322	0	0
44362323	1125315	0	0
45663349	1129625	0	0
45654120	1149196	0	0
45635392	1713332	0	0
45700549	1549786	0	0
45689765	1119510	0	0
45669387	19079524	1	1
45780291	19078924	2	3
45681436	738818	0	0
45792135	1124300	0	0
45706221	738818	0	0
45803000	1361711	0	0
45787569	1102527	0	0
45793104	1125315	0	0
45790596	705944	0	0
46243874	1332419	2	3
45801964	1125315	0	0
46310453	1119510	0	0
4040395	4010253	3	3
75053	4230399	3	3
21003393	975125	0	0
21503220	1308738	1	1
36153051	1115171	2	3
36153184	1177480	0	0
21502741	46233710	2	3
36426273	791967	0	0
42807056	1539403	0	0
44349357	1124957	0	0
44355717	1129625	0	0
44350941	1125315	0	0
45638436	1119510	0	0
44347481	1367571	0	0
44362326	1125315	0	0
45663665	1129625	0	0
45654195	1551099	0	0
45629889	1115008	0	0
45700549	1521369	0	0
45689708	1119510	0	0
45666873	19079524	1	1
45780266	40231925	2	3
45681440	1367571	0	0
45792136	1343916	0	0
45706165	738818	0	0
45803011	914335	0	0
45787660	1713332	0	0
45792869	1125315	0	0
45790599	1343916	0	0
46239540	1332419	2	3
45801951	1125315	0	0
46310414	1119510	0	0
4027553	255848	3	3
256440	4294548	3	3
21003394	1551099	0	0
21503258	1343916	1	1
36153083	1127433	2	3
36152665	1177480	0	0
21502759	40174880	2	3
36422742	1545958	0	0
42807058	705944	0	0
44349413	1515774	0	0
44355850	708298	0	0
44350925	1125315	0	0
45638270	1119510	0	0
44347272	1367571	0	0
44362330	1125315	0	0
45659991	1129625	0	0
45654199	1307863	0	0
45629897	1124300	0	0
45700549	1595799	0	0
45689871	1119510	0	0
45648486	46275916	1	1
45780202	19008572	2	3
45681312	1149196	0	0
45792139	1107830	0	0
45706176	738818	0	0
45802848	791967	0	0
45787660	1759842	0	0
45792957	1125315	0	0
45790732	1332418	0	0
46239043	1332419	2	3
45802164	1125315	0	0
46310653	1119510	0	0
4180938	4145310	3	3
443419	4156265	3	3
21003393	1551099	0	0
21503258	1119510	1	1
36153137	19008572	2	3
36152673	1124300	0	0
4180941	4275113	2	3
36422768	914335	0	0
42807091	1545958	0	0
44349512	1149380	0	0
44355864	1129625	0	0
44351058	1125315	0	0
45638279	1119510	0	0
44347603	1124300	0	0
44362261	1125315	0	0
45660009	1129625	0	0
45654202	1124957	0	0
45629899	1115008	0	0
45700573	1110410	0	0
45689686	1119510	0	0
45648515	19079524	1	1
45780328	40229134	2	3
45681419	1192710	0	0
45792268	1115008	0	0
45706265	738818	0	0
45803133	1000560	0	0
45787668	1551099	0	0
45793166	1125315	0	0
45790757	1367571	0	0
45788116	1539411	2	3
45801937	1125315	0	0
46310656	1119510	0	0
4088217	4293740	3	3
75865	4056621	3	3
21011418	1110410	0	0
21505763	914335	1	1
36153775	40223834	2	3
36153245	914335	0	0
21502750	1551192	2	3
36422731	1150770	0	0
42807125	1125315	0	0
44349514	1713332	0	0
44355864	1125315	0	0
44348371	1125315	0	0
45637128	1119510	0	0
44347498	1713332	0	0
44362199	1125315	0	0
45649367	1177480	0	0
45654211	1551099	0	0
45629900	1124957	0	0
45700574	1713332	0	0
45689632	1119510	0	0
45648540	46275916	1	1
45780275	19019273	2	3
45681422	1107830	0	0
45792270	1549786	0	0
45699774	738818	0	0
45803149	975125	0	0
45787525	967823	0	0
45793119	1125315	0	0
45790763	1500211	0	0
46290394	1539411	2	3
45801953	1125315	0	0
46310671	1119510	0	0
4088217	4197460	3	3
75865	198199	3	3
21011418	1154029	0	0
21505763	1192710	1	1
36153812	1115171	2	3
36152677	1589505	0	0
21603967	19078461	2	3
36314177	4012477	0	0
42807125	1124957	0	0
44349454	1118084	0	0
44355753	1125315	0	0
44348529	1125315	0	0
45634859	1119510	0	0
44347639	1305058	0	0
44362216	1125315	0	0
45649468	1177480	0	0
45654181	1149196	0	0
45629905	1326303	0	0
45700661	1124957	0	0
45689854	1119510	0	0
45645614	46275916	1	1
45780230	19018935	2	3
45681521	1115008	0	0
45792270	19127890	0	0
45699781	738818	0	0
45802823	1557272	0	0
45787669	1174888	0	0
45793067	1125315	0	0
45790845	1124300	0	0
45791073	1545959	2	3
45802040	1125315	0	0
46310569	1119510	0	0
4042645	4216130	3	3
134057	381316	3	3
21011412	1110410	0	0
21505957	1738521	1	1
36153544	1115171	2	3
36152798	1112807	0	0
21604344	40229134	2	3
36315060	4181917	0	0
42807128	1326303	0	0
44349463	975125	0	0
44355753	1119510	0	0
44348655	1125315	0	0
44362725	1129625	0	0
44347652	1332418	0	0
44362333	1125315	0	0
45632049	1177480	0	0
45654156	1548195	0	0
45629882	1595799	0	0
45698936	1322184	0	0
45689866	1119510	0	0
45642876	46275916	1	1
45780400	42707627	2	3
45681317	975125	0	0
45792270	1589505	0	0
45699818	738818	0	0
45803025	1322184	0	0
45787674	975125	0	0
45793080	1125315	0	0
45790854	1326303	0	0
46243978	1545959	2	3
45802045	1125315	0	0
46310596	1119510	0	0
4042673	4078793	3	3
443883	260139	3	3
21009234	1746114	0	0
21505772	1112807	1	1
36153672	40232448	2	3
36152639	1512674	0	0
21604344	40231925	2	3
40236824	40236824	0	0
42807317	742185	0	0
44349467	1308738	0	0
44355852	1545958	0	0
44346851	1125315	0	0
44361848	1129625	0	0
44347654	1115008	0	0
44362334	1125315	0	0
45632058	1177480	0	0
45654264	1589505	0	0
45629864	1110410	0	0
45698941	1501700	0	0
45686543	1119510	0	0
45642840	46275916	1	1
45777763	19133905	2	3
45681574	1107830	0	0
45792340	1000560	0	0
45693523	738818	0	0
45803093	1501700	0	0
45787676	1115008	0	0
45793218	1125315	0	0
45790548	1521369	0	0
46244285	1539411	2	3
45802046	1125315	0	0
46310755	1119510	0	0
4176967	4058899	3	3
443883	4112343	3	3
21011412	1154029	0	0
21505772	1125315	1	1
36154122	1115171	2	3
36152682	1119510	0	0
21502747	1545959	2	3
40236446	40236446	0	0
42807135	19039298	0	0
44349368	1118084	0	0
44355853	1125315	0	0
44346930	1125315	0	0
44361951	1129625	0	0
44347283	791967	0	0
44362411	1125315	0	0
45632127	1177480	0	0
45654264	1549786	0	0
45630009	1539403	0	0
45698943	738818	0	0
45686780	1119510	0	0
45685611	46275916	1	1
45777763	19133873	2	3
45681643	1149196	0	0
45792202	975125	0	0
45693494	738818	0	0
45802828	757627	0	0
45787625	1153428	0	0
45793220	1125315	0	0
45790557	1551099	0	0
46239701	1539411	2	3
45802105	1125315	0	0
46310770	1119510	0	0
4176967	4047491	3	3
440921	4296205	3	3
21011074	1112807	0	0
21505772	1129625	1	1
36154123	40232448	2	3
36152639	1549786	0	0
21502747	1539411	2	3
36429173	1150836	0	0
42807139	1728416	0	0
44349447	1174888	0	0
44355853	1124957	0	0
44346880	1125315	0	0
44362206	1129625	0	0
44347440	1738521	0	0
44362422	1125315	0	0
45632208	1177480	0	0
45654379	1326303	0	0
45630112	1551099	0	0
45698920	1115008	0	0
45686450	1119510	0	0
45685964	46275916	1	1
45777720	19019273	2	3
45681594	1539403	0	0
45792212	975125	0	0
45693608	738818	0	0
45802931	1551099	0	0
45787629	1174888	0	0
45793324	1125315	0	0
45790558	1115008	0	0
46239033	1539411	2	3
45802108	1125315	0	0
46310532	1119510	0	0
4115260	255848	3	3
75047	4134304	3	3
21011104	1367571	0	0
21505758	1177480	1	1
36153271	40229134	2	3
36152716	1177480	0	0
36217206	19008572	2	3
36429128	1741122	0	0
42807229	1115008	0	0
44349451	791967	0	0
44355869	1119510	0	0
44346947	1125315	0	0
44362171	1129625	0	0
44347738	1149196	0	0
44362475	1125315	0	0
45632017	1177480	0	0
45654387	738818	0	0
45630115	1589505	0	0
45698988	1549786	0	0
45686866	1119510	0	0
45636779	46275916	1	1
45777726	40229134	2	3
45681555	1332418	0	0
45792376	1112807	0	0
45693905	738818	0	0
45802937	1521369	0	0
45787722	1192710	0	0
45793027	1125315	0	0
45790564	967823	0	0
45804168	19127918	2	2
45802111	1125315	0	0
46304885	1119510	0	0
4154162	4132546	3	3
3050951	3045716	3	3
21011189	967823	0	0
21505772	1192710	1	1
36153996	19008572	2	3
36152874	1149196	0	0
36217210	19078924	2	3
36427783	1548195	0	0
42807236	19127890	0	0
44349608	1717327	0	0
44355956	1125315	0	0
44346916	1125315	0	0
45655998	1129625	0	0
44347742	1124300	0	0
44362564	1125315	0	0
45634073	1177480	0	0
45654310	738818	0	0
45630119	1124957	0	0
45698988	1512674	0	0
45686615	1119510	0	0
45633559	19079524	1	1
45777656	1115171	2	3
45681580	1149196	0	0
45792377	1153428	0	0
45690768	738818	0	0
45802937	1549786	0	0
45787723	1137529	0	0
45793334	1125315	0	0
45790979	1332418	0	0
45804168	19128009	2	2
45801919	1125315	0	0
46305431	1119510	0	0
4154162	4156265	3	3
3050951	3015632	3	3
21011191	967823	0	0
21505758	1129625	1	1
36153929	19077344	2	3
36153080	1112807	0	0
36217210	40224805	2	3
36426554	701322	0	0
42807236	1515774	0	0
44349429	1115008	0	0
44355873	1149196	0	0
44347048	1125315	0	0
45656327	1129625	0	0
44347451	1713332	0	0
44362450	1125315	0	0
45633949	1177480	0	0
45654311	1124957	0	0
45630127	1115008	0	0
45698988	19127890	0	0
45686738	1119510	0	0
45633766	46275916	1	1
45777796	19008572	2	3
45681630	1149196	0	0
45792384	19039298	0	0
45690819	738818	0	0
45802943	1512674	0	0
45787724	1174888	0	0
45792132	1125315	0	0
45790838	1551099	0	0
45787205	19128022	2	2
45802122	1125315	0	0
46305003	1119510	0	0
4103320	4283893	3	3
3033521	3000963	3	3
21011482	1551099	0	0
21503358	1343916	1	1
36153328	1115171	2	3
36152640	1107830	0	0
36217210	40220960	2	3
36426524	1500211	0	0
42807236	1549786	0	0
44349618	1549786	0	0
44355967	1551099	0	0
44347071	1125315	0	0
45656155	1129625	0	0
44347451	1759842	0	0
44362668	1125315	0	0
45634226	1177480	0	0
45654327	1149196	0	0
45630133	1174888	0	0
45699041	1115008	0	0
45686720	1119510	0	0
45633851	19079524	1	1
45777790	43012036	2	3
45681636	1332418	0	0
45792391	1115008	0	0
45687758	738818	0	0
45802943	19127890	0	0
45787735	1548195	0	0
45792081	1125315	0	0
45790957	975125	0	0
46296901	40232448	2	3
45801982	1125315	0	0
46305008	1119510	0	0
4181063	258780	3	3
3051542	3045716	3	3
21011491	723013	0	0
21503364	975125	1	1
36153330	1127433	2	3
36152646	1115008	0	0
36217210	46275916	2	3
36424040	1308738	0	0
42807238	1729720	0	0
44349619	975125	0	0
44355972	1129625	0	0
44347175	1125315	0	0
45656406	1129625	0	0
44347396	1729720	0	0
44362684	1125315	0	0
45634244	1177480	0	0
45654271	1545958	0	0
45630139	1521369	0	0
45698933	738818	0	0
45686883	1119510	0	0
45633871	46275916	1	1
45706422	40224805	2	3
45681612	738818	0	0
45675985	1192710	0	0
45687895	738818	0	0
45802943	1549786	0	0
45787759	967823	0	0
45790256	1125315	0	0
45790812	1519936	0	0
46296702	19073183	2	3
45802117	1125315	0	0
46305445	1119510	0	0
4181063	40486433	3	3
3051542	3015632	3	3
21011655	975125	0	0
21503371	1129625	1	1
36154133	1127433	2	3
36152908	1107830	0	0
36217220	40229134	2	3
36425676	1177480	0	0
42807286	1501700	0	0
44349621	1118084	0	0
44356088	1361711	0	0
44347009	1125315	0	0
45656409	1129625	0	0
44347398	1778162	0	0
44362440	1125315	0	0
45629263	1177480	0	0
45654313	1124957	0	0
45629882	1308738	0	0
45699008	1307863	0	0
45686964	1119510	0	0
45628268	46275916	1	1
45706450	19019273	2	3
45679754	738818	0	0
45675884	1124300	0	0
45687504	738818	0	0
45802945	1110410	0	0
45787791	975125	0	0
45790372	1125315	0	0
45790899	1322184	0	0
46295026	40232448	2	3
45802252	1125315	0	0
46305016	1119510	0	0
4103183	317576	3	3
443784	317576	3	3
21002690	1149380	0	0
21503371	975125	1	1
36154189	19057271	2	3
36152742	1107830	0	0
36217220	19112599	2	3
36426641	1503184	0	0
42807288	1125315	0	0
44349572	1149196	0	0
44356105	738818	0	0
44347022	1125315	0	0
45652522	1129625	0	0
44347399	1115008	0	0
44362487	1125315	0	0
45629070	1177480	0	0
45654402	1308738	0	0
45630251	1501700	0	0
45699111	1501700	0	0
45687002	1119510	0	0
45628658	19079524	1	1
45706462	19133768	2	3
45679777	975125	0	0
45676046	1149196	0	0
45684607	738818	0	0
45803101	723013	0	0
45787801	1149196	0	0
45790704	1125315	0	0
45790902	1124300	0	0
46295107	19018935	2	3
45802086	1125315	0	0
46305571	1119510	0	0
4103183	321042	3	3
443784	4310024	3	3
21002731	1521369	0	0
21503445	1125315	1	1
36154199	40232448	2	3
36152743	1153428	0	0
36217220	40222846	2	3
36423453	1768849	0	0
42807330	1000560	0	0
44349574	1000560	0	0
44356105	1125315	0	0
44347024	1125315	0	0
45652751	1129625	0	0
44347456	1551099	0	0
45661796	1125315	0	0
45627994	1177480	0	0
45654150	914335	0	0
45629866	1174888	0	0
45695458	1153428	0	0
45687015	1119510	0	0
45628409	19079524	1	1
45706462	40162522	2	3
45679759	791967	0	0
45675972	1545958	0	0
45684726	738818	0	0
45803102	1112807	0	0
45789173	757627	0	0
45790361	1125315	0	0
45790907	1713332	0	0
46295113	40236824	2	3
45802152	1125315	0	0
46305574	1119510	0	0
4103662	381316	3	3
320136	441267	3	3
21002731	1548195	0	0
21500540	740275	1	1
36154057	19008572	2	3
36152687	1521369	0	0
36217220	19074679	2	3
36423483	1118084	0	0
42807384	1177480	0	0
44349734	1361711	0	0
44356105	1119510	0	0
44347092	1125315	0	0
45655054	1129625	0	0
44347528	1310149	0	0
44355092	1125315	0	0
45626134	1177480	0	0
45654152	1332418	0	0
45629994	975125	0	0
45695466	1115008	0	0
45687017	1119510	0	0
45627877	46275916	1	1
45706668	1115171	2	3
45679416	1107830	0	0
45675973	975125	0	0
45681281	738818	0	0
45803108	1332418	0	0
45789335	1309944	0	0
45790299	1125315	0	0
45790572	1154029	0	0
46295173	19019273	2	3
45802156	1125315	0	0
46305330	1119510	0	0
4178367	4163872	3	3
443783	4056621	3	3
21002731	975125	0	0
21503445	1308738	1	1
36154110	1127433	2	3
36152810	1177480	0	0
36217214	19078461	2	3
36423477	1778162	0	0
42807390	1124300	0	0
44349373	1332418	0	0
44355862	1557272	0	0
44347111	1125315	0	0
45655180	1129625	0	0
44347529	1192710	0	0
44354966	1125315	0	0
45626327	1177480	0	0
45654243	757627	0	0
45630079	1149196	0	0
45695472	1551099	0	0
45687034	1119510	0	0
45676210	46275916	1	1
45706826	40232448	2	3
45679424	1110410	0	0
45676047	1115008	0	0
45681927	738818	0	0
45803218	1343916	0	0
45789286	1501700	0	0
45790347	1125315	0	0
45790626	1589505	0	0
46295153	40232448	2	3
45802089	1125315	0	0
46305332	1119510	0	0
4178367	4243062	3	3
443783	261325	3	3
21002731	1595799	0	0
21503592	967823	1	1
36154111	40232448	2	3
36152812	1119510	0	0
36217214	19125062	2	3
36423476	1778162	0	0
42807382	723013	0	0
44349749	1124957	0	0
42805192	1177480	0	0
44347297	1125315	0	0
45655314	1129625	0	0
44347560	975125	0	0
44354713	1125315	0	0
45626328	1177480	0	0
45654252	1115008	0	0
45630082	975125	0	0
45695474	738818	0	0
45683632	1119510	0	0
45625025	46275916	1	1
45706799	40231925	2	3
45678190	1521369	0	0
45676051	1115008	0	0
45681941	738818	0	0
45803059	1112807	0	0
45789298	1557272	0	0
45790243	1125315	0	0
45790626	1549786	0	0
46295408	1115171	2	3
45802127	1125315	0	0
46305506	1119510	0	0
4043686	4047491	3	3
444089	4266809	3	3
21002731	19054876	0	0
21503467	1595799	1	1
36156311	40232448	2	3
36152812	738818	0	0
36217214	40229134	2	3
36428377	1154343	0	0
42807366	1124300	0	0
44349751	1729720	0	0
42805196	701322	0	0
44347298	1125315	0	0
45652791	1129625	0	0
44347567	1713332	0	0
44355015	1125315	0	0
45626337	1177480	0	0
45654390	1778162	0	0
45630083	1124957	0	0
45695511	1308738	0	0
45683709	1119510	0	0
45625060	19079524	1	1
45706835	40232448	2	3
45678190	1548195	0	0
45676078	1192710	0	0
45681735	738818	0	0
45803242	1115008	0	0
45789305	1124957	0	0
45790291	1125315	0	0
45790786	1174888	0	0
46295213	35605482	2	3
45802248	1125315	0	0
46305360	1119510	0	0
4168644	438614	3	3
135930	80180	3	3
21002731	1589505	0	0
21503474	1595799	1	1
36156375	1551192	2	3
36152823	933724	0	0
4181063	260139	2	2
36423511	1149196	0	0
42809676	1177480	0	0
44349753	1153428	0	0
42805204	1738521	0	0
44347449	1125315	0	0
45652760	1129625	0	0
44347567	1759842	0	0
44355226	1125315	0	0
45626282	1177480	0	0
45654320	791967	0	0
45630099	1192710	0	0
45695644	1332418	0	0
45683747	1119510	0	0
45670485	19079524	1	1
45702765	40232448	2	3
45678191	738818	0	0
45676142	933724	0	0
45681944	738818	0	0
45803249	791967	0	0
45789307	1174888	0	0
45790307	1125315	0	0
45790789	715997	0	0
46295628	40224805	2	3
45802233	1125315	0	0
46305384	1119510	0	0
4168644	4306014	3	3
1521369	19127922	3	4
21002731	1549786	0	0
21503474	1396131	1	1
36154202	40162522	2	3
36152647	791967	0	0
4181063	255848	2	2
36502197	40480160	6	8
42807353	1549786	0	0
44349603	1112807	0	0
42805283	1713332	0	0
44347057	1125315	0	0
45652849	1129625	0	0
44347460	1115008	0	0
44355138	1125315	0	0
45626342	1177480	0	0
45654499	1717327	0	0
45630108	1741122	0	0
45695627	1153428	0	0
45683693	1119510	0	0
45670722	19115351	1	1
45703088	40231925	2	3
45678151	1501700	0	0
45676148	1115008	0	0
45673297	738818	0	0
45803250	975125	0	0
45789406	1717327	0	0
45790440	1125315	0	0
45790683	1557272	0	0
46295252	40232448	2	3
45802213	1125315	0	0
46306723	1119510	0	0
4168644	439406	3	3
1521369	42902245	3	4
21002731	1738521	0	0
21503474	1308738	1	1
36154247	35605482	2	3
36152648	1129625	0	0
4181063	80809	2	2
36502197	4066995	7	8
42810048	1177480	0	0
44349653	1396131	0	0
42805286	1549786	0	0
44343221	1125315	0	0
45649681	1129625	0	0
44347545	738818	0	0
44354940	1125315	0	0
45626366	1177480	0	0
45654447	738818	0	0
45630108	1746114	0	0
45695487	1307863	0	0
45683658	1119510	0	0
45669222	46275916	1	1
45703089	40229134	2	3
45678124	1717327	0	0
45676344	1310149	0	0
45784507	738818	0	0
45803205	1124957	0	0
45789411	1000560	0	0
45790532	1125315	0	0
45790685	1124957	0	0
46244325	40229134	2	3
45802343	1125315	0	0
46306979	1119510	0	0
4168644	4102123	3	3
1521369	19133679	3	4
21002731	1515774	0	0
21503478	967823	1	1
36154251	19018935	2	3
36152654	1539403	0	0
4181063	440448	2	2
36502197	4048695	7	8
42808536	1125315	0	0
44349654	1738521	0	0
42805286	1518198	0	0
44343229	1125315	0	0
45649649	1129625	0	0
44347871	1713332	0	0
44354945	1125315	0	0
45622801	1177480	0	0
45654392	1154343	0	0
45630227	1107830	0	0
45695657	1322184	0	0
45670732	1713332	0	0
45669201	46275916	1	1
45702869	40232448	2	3
45678092	1539403	0	0
45676483	920293	0	0
45784993	738818	0	0
45803311	1124957	0	0
45789310	1115008	0	0
45790535	1125315	0	0
45790687	1174888	0	0
46244337	40229134	2	3
45802335	1125315	0	0
46321684	1119510	0	0
4168644	4048169	3	3
1521369	19129144	3	4
21002731	19127890	0	0
21503584	1192710	1	1
36154294	1551192	2	3
36152688	1124300	0	0
4181063	134438	2	2
36502197	4059173	7	8
42808536	738818	0	0
44349659	1713332	0	0
42805212	1332418	0	0
44342974	1125315	0	0
45649830	1129625	0	0
44347775	1326303	0	0
44354949	1125315	0	0
45623224	1177480	0	0
45654506	708298	0	0
45630043	1310149	0	0
45695494	1521369	0	0
45670732	1759842	0	0
45666866	46275916	1	1
45702980	19133905	2	3
45678097	1115008	0	0
45676570	1361711	0	0
45782435	738818	0	0
45803313	1112807	0	0
45789312	914335	0	0
45790538	1125315	0	0
45790990	1174888	0	0
46244419	40232448	2	3
45799184	1125315	0	0
46321817	1119510	0	0
4168644	4304110	3	3
1521369	19128065	3	4
21002692	975125	0	0
21503469	1192710	1	1
36154284	1551192	2	3
36152689	1119510	0	0
4181060	44805732	2	2
36502197	40479422	7	8
42808536	1119510	0	0
44349557	1174888	0	0
42805213	1115008	0	0
44342977	1125315	0	0
45646323	1129625	0	0
44347777	1107830	0	0
44355051	1125315	0	0
45624897	1177480	0	0
45654507	742185	0	0
45630061	1154343	0	0
45695635	967823	0	0
45670883	1738521	0	0
45666974	46275916	1	1
45702980	19133873	2	3
45678081	791967	0	0
45676351	1501700	0	0
45782749	738818	0	0
45803314	1149196	0	0
45789315	967823	0	0
45790545	1125315	0	0
45790717	975125	0	0
46244497	1115171	2	3
45799390	1125315	0	0
46321718	1119510	0	0
4168644	4169137	3	3
135930	80502	3	4
21002694	1129625	0	0
21500744	967823	1	1
36154341	1127433	2	3
36152697	1107830	0	0
21603283	40169281	2	2
36502197	40479768	7	8
42810317	1125315	0	0
44349659	1759842	0	0
42805274	1125315	0	0
44343361	1125315	0	0
45646327	1129625	0	0
44347625	1192710	0	0
44355181	1125315	0	0
45624905	1177480	0	0
45654515	1000560	0	0
45630018	1149196	0	0
45695272	1713332	0	0
45670843	1192710	0	0
45666951	46275916	1	1
45703938	40232448	2	3
45678364	1115008	0	0
45789118	1545958	0	0
45782775	738818	0	0
45802968	967823	0	0
45787825	1115008	0	0
45790414	1125315	0	0
46297546	1115008	0	0
46244434	40236446	2	3
45799492	1125315	0	0
46321723	1119510	0	0
4168644	4302207	3	3
440142	4329847	3	4
21002745	1149196	0	0
21500709	1396131	1	1
35902849	198809	2	3
36153255	1192710	0	0
36102149	255848	2	2
36502197	4278672	7	8
42807391	1343916	0	0
44349562	1118084	0	0
42805289	715997	0	0
44343362	1125315	0	0
45646367	1129625	0	0
44347778	791967	0	0
44355202	1125315	0	0
45625103	1177480	0	0
45654255	1107830	0	0
45629915	1115008	0	0
45695433	715997	0	0
45670829	1149196	0	0
45707347	19079524	1	1
45703771	40163554	2	3
45678492	1551099	0	0
45789120	1310149	0	0
45780328	738818	0	0
45803210	1332418	0	0
45787826	1149380	0	0
45790418	1125315	0	0
46297692	1154029	0	0
46244596	40229134	2	3
45799621	1125315	0	0
46321792	1119510	0	0
4168644	4139681	3	3
320136	4283893	3	4
21002694	1192710	0	0
21500709	1308738	1	1
36203066	4156265	2	3
35529060	1177480	0	0
36102149	440448	2	2
36502197	4149245	7	8
42810072	1119510	0	0
44349700	933724	0	0
42805291	723013	0	0
44343071	1125315	0	0
45649109	1129625	0	0
44347576	1557272	0	0
45655494	1125315	0	0
45623258	1177480	0	0
45654455	1539403	0	0
45630027	1192710	0	0
45695517	1500211	0	0
45670836	920293	0	0
45704229	46275916	1	1
45704079	19126352	2	3
45678494	1778162	0	0
45789123	920293	0	0
45780306	738818	0	0
45803290	975125	0	0
45787827	1112807	0	0
45790606	1125315	0	0
46297699	1153428	0	0
46244606	40236824	2	3
45799392	1125315	0	0
46316468	1119510	0	0
4168644	442116	3	3
1515774	19128263	3	4
21002743	1150836	0	0
21500720	1595799	1	1
36152830	1545959	2	3
35529067	19127890	0	0
36102149	372328	2	2
36502197	4134304	9	10
42810072	1125315	0	0
44349664	742185	0	0
42805183	1124300	0	0
44343113	1125315	0	0
45646545	1129625	0	0
44347792	740275	0	0
44347846	1125315	0	0
45621404	1177480	0	0
45654080	1308738	0	0
45630191	1545958	0	0
45695578	1539403	0	0
45670767	738818	0	0
45704332	46275916	1	1
45703717	40231925	2	3
45678428	1153428	0	0
45789127	1192710	0	0
45777762	738818	0	0
45803119	1112807	0	0
45787908	1115008	0	0
45790501	1125315	0	0
46297716	1153428	0	0
46244458	19019273	2	3
45799449	1125315	0	0
46316410	1119510	0	0
4043016	4199276	3	3
1515774	19128022	3	4
21002745	1129625	0	0
21500720	1308738	1	1
36156274	1107882	2	3
35529067	1515774	0	0
36102149	4283893	2	2
36502197	78272	9	10
42810275	1112807	0	0
44349856	1115008	0	0
42805184	1332418	0	0
44343161	1125315	0	0
45646477	1129625	0	0
44347802	1115008	0	0
44347517	1125315	0	0
45621523	1177480	0	0
45654474	1110410	0	0
45629982	914335	0	0
45695645	1738521	0	0
45670775	1713332	0	0
45704538	46275916	1	1
45703129	40232448	2	3
45678131	1154343	0	0
45789130	1124300	0	0
45777726	738818	0	0
45803400	738818	0	0
45787845	1549786	0	0
45787597	1125315	0	0
46297721	1192710	0	0
46244459	43012036	2	3
45799456	1125315	0	0
46316404	1119510	0	0
4155793	4163872	3	3
134057	317576	3	4
21002731	1512674	0	0
21503179	40169281	1	1
36217219	1519937	2	3
35529067	1549786	0	0
36102149	195588	2	2
36502197	81151	6	9
42804734	1000560	0	0
44349859	1713332	0	0
42805220	1177480	0	0
44343407	1125315	0	0
45646458	1129625	0	0
44347214	1521369	0	0
44347826	1125315	0	0
45621766	1177480	0	0
45654456	1332418	0	0
45630276	1307863	0	0
45695441	1326303	0	0
45670775	1759842	0	0
45700802	40220386	1	1
45703108	19133905	2	3
45678141	1521369	0	0
45789390	1149196	0	0
45777748	738818	0	0
45803373	1149196	0	0
45787845	1519936	0	0
45787560	1125315	0	0
46297472	1549786	0	0
46244547	19059056	2	3
45799460	1125315	0	0
46316429	1119510	0	0
4155793	4243062	3	3
31057	4112343	3	4
21002745	1107830	0	0
21001868	1154615	1	1
36217219	43012754	2	3
35509184	1110410	0	0
21604753	705944	2	2
36502197	4230399	8	9
42804735	1738521	0	0
44349761	1326303	0	0
42805301	1118084	0	0
44343411	1125315	0	0
45646733	1129625	0	0
44347812	1539403	0	0
44347526	1125315	0	0
45621811	1177480	0	0
45654486	1110410	0	0
45630258	738818	0	0
45695619	1332418	0	0
45670821	1738521	0	0
45700982	46275916	1	1
45703147	782047	2	3
45678142	19127890	0	0
45789379	1174888	0	0
45703089	738818	0	0
45803260	1396131	0	0
45787875	1000560	0	0
45787669	1125315	0	0
46297637	1343916	0	0
45893781	46233710	2	3
45799319	1125315	0	0
46316605	1119510	0	0
4071689	381316	3	3
75909	4237458	3	4
21002745	1150836	0	0
21002499	19128263	1	1
36217219	1718412	2	3
35509188	1119510	0	0
21604753	742185	2	2
36208978	3004501	3	3
42804736	1125315	0	0
44350045	1124957	0	0
42805306	967823	0	0
44343422	1125315	0	0
45646767	1129625	0	0
44347363	1500211	0	0
44347717	1125315	0	0
45665266	1177480	0	0
45654494	1107830	0	0
45630259	19010482	0	0
45695816	1738521	0	0
45671092	1361711	0	0
45700887	46275916	1	1
45703165	1127433	2	3
45678142	1549786	0	0
45789319	1107830	0	0
45699984	738818	0	0
45803326	1124957	0	0
45787865	967823	0	0
45787629	1125315	0	0
46297576	914335	0	0
45789280	19078461	2	3
45799320	1125315	0	0
46316693	1119510	0	0
4168335	4109685	3	3
3050940	3016723	3	4
21002694	975125	0	0
21002499	42902245	1	1
36217219	19132304	2	3
36157065	1119510	0	0
4041268	4010253	2	2
36211303	381316	3	3
42804736	1174888	0	0
44350046	738818	0	0
42805293	1124300	0	0
44343423	1125315	0	0
45643458	1129625	0	0
44347781	1149380	0	0
44347720	1125315	0	0
45665370	1177480	0	0
45654086	791967	0	0
45630172	738818	0	0
45695849	708298	0	0
45670797	1738521	0	0
45694971	46275916	1	1
45703192	19133768	2	3
45678176	1149196	0	0
45789333	920293	0	0
45700199	738818	0	0
45803331	1124957	0	0
45788118	1149196	0	0
45787722	1125315	0	0
46297744	1124957	0	0
45802222	19075601	2	3
45799466	1125315	0	0
46316546	1119510	0	0
4168335	4155034	3	3
3050940	3013682	3	4
21002745	1192710	0	0
21002499	19128022	1	1
36217219	46221626	2	3
36157237	1129625	0	0
21603991	1118084	2	2
36211303	4329847	3	3
42804737	723013	0	0
44341980	1107830	0	0
42805295	1310149	0	0
44343501	1125315	0	0
45643700	1129625	0	0
44347922	1124957	0	0
44347722	1125315	0	0
45667455	1177480	0	0
45654369	1548195	0	0
45630175	1551099	0	0
45695670	1305058	0	0
45670799	1115008	0	0
45694999	46275916	1	1
45703192	40162522	2	3
45678182	1154029	0	0
45791746	967823	0	0
45700282	738818	0	0
45800456	738818	0	0
45788120	1521369	0	0
45787724	1125315	0	0
46297754	1174888	0	0
45802426	19075001	2	3
45799559	1125315	0	0
46316191	1119510	0	0
4168335	4113008	3	3
1512675	19127904	2	2
21002694	738818	0	0
21001920	1154615	1	1
36217219	43012433	2	3
36156633	1343916	0	0
19109535	40221415	2	2
36211303	4094814	3	3
42804709	1759842	0	0
44341760	1112807	0	0
42805281	1118084	0	0
44343515	1125315	0	0
45643577	1129625	0	0
44347931	1118084	0	0
44347913	1125315	0	0
45662801	1177480	0	0
45652033	920293	0	0
45630181	1124957	0	0
45695678	1174888	0	0
45670853	1512674	0	0
45688947	46275916	1	1
45703108	19133873	2	3
45678284	1717327	0	0
45791748	1000560	0	0
45696895	738818	0	0
45800463	1713332	0	0
45786307	1149196	0	0
45787726	1125315	0	0
46297643	967823	0	0
45793657	19078924	2	3
45799613	1125315	0	0
46310788	1119510	0	0
4090615	4149245	3	3
443783	44782520	2	2
21002708	1124300	0	0
21001857	40169281	1	1
36203090	4066995	2	3
36156634	1177480	0	0
35624868	4156265	2	2
36211325	4155034	3	3
42804811	1713332	0	0
44341765	1177480	0	0
42805361	1149380	0	0
44343477	1125315	0	0
45643690	1129625	0	0
44347685	1107830	0	0
44347957	1125315	0	0
45662751	1177480	0	0
45652042	1501700	0	0
45630183	1521369	0	0
45695727	1367571	0	0
45670853	19127890	0	0
45686174	19074679	1	1
45703118	35605482	2	3
45678292	1192710	0	0
45792111	967823	0	0
45693880	738818	0	0
45800463	1759842	0	0
45786329	708298	0	0
45787733	1125315	0	0
46297239	975125	0	0
45794630	19075001	2	3
45799540	1125315	0	0
46310690	1119510	0	0
4168166	4336464	3	3
443783	257012	2	2
21002745	738818	0	0
21001878	40169281	1	1
36153566	1107882	2	3
36157208	1512674	0	0
4112892	4295880	2	2
36211325	4109685	3	3
42804811	1759842	0	0
44341801	738818	0	0
44348936	701322	0	0
44343479	1125315	0	0
45643518	1129625	0	0
44347686	1154343	0	0
44348450	1125315	0	0
45664428	1177480	0	0
45652187	738818	0	0
45630354	1192710	0	0
45695718	1149196	0	0
45670853	1549786	0	0
45682386	19079524	1	1
45700111	19008572	2	3
45678294	738818	0	0
45792112	1112807	0	0
45693897	738818	0	0
45800400	1107830	0	0
45786223	1500211	0	0
45787792	1125315	0	0
46297427	975125	0	0
45788663	40223768	2	3
45799671	1125315	0	0
46305763	1119510	0	0
4180653	4181917	3	3
443783	4280726	2	2
21002745	1150770	0	0
21503379	1192710	1	1
36152955	1107882	2	3
36157258	1515774	0	0
35602099	4280726	2	2
36211325	4113008	3	3
42804666	1713332	0	0
44341803	1118084	0	0
44348944	1759842	0	0
44343484	1125315	0	0
45643761	1129625	0	0
44343618	1501700	0	0
44348553	1125315	0	0
45659659	1177480	0	0
45652193	914335	0	0
45630359	1310149	0	0
45695683	1149196	0	0
45670805	1107830	0	0
45659884	1107830	0	0
45700004	19076374	2	3
45678243	1310149	0	0
45792073	1154029	0	0
45693955	738818	0	0
45800412	967823	0	0
45786337	1548195	0	0
45787796	1125315	0	0
46297449	933724	0	0
46298457	40223768	2	3
45799578	1125315	0	0
46305830	1119510	0	0
4090614	40486433	3	3
31821	140673	2	2
21002745	1153428	0	0
21002491	40221415	1	1
36153762	1107882	2	3
36157258	19127890	0	0
4268896	44783196	2	2
35809117	195588	3	3
42804622	1000560	0	0
44342121	1000560	0	0
44348706	757627	0	0
44343527	1125315	0	0
45640699	1129625	0	0
44343349	1713332	0	0
44348556	1125315	0	0
45659619	1177480	0	0
45651962	1521369	0	0
45630365	1192710	0	0
45695758	1778162	0	0
45671015	1115008	0	0
45660029	1548195	0	0
45700084	1115171	2	3
45678264	1713332	0	0
45792076	1112807	0	0
45694085	738818	0	0
45800427	1778162	0	0
45786399	1000560	0	0
45787820	1125315	0	0
46297663	1174888	0	0
45788866	40223768	2	3
45799638	1125315	0	0
46305896	1119510	0	0
4090614	4280726	3	3
320136	4051466	2	2
21002775	1305058	0	0
21001919	1154615	1	1
36154366	40228214	2	3
36157258	1549786	0	0
36102932	28060	2	2
36211091	40479422	3	3
42804694	933724	0	0
44342122	738818	0	0
44348707	1521369	0	0
44339802	1125315	0	0
45640726	1129625	0	0
44343358	1124300	0	0
44348562	1125315	0	0
45659971	1177480	0	0
45651962	1595799	0	0
45630183	1549786	0	0
45695497	1124300	0	0
45670742	1192710	0	0
45660102	738818	0	0
45700236	19073183	2	3
45678247	1174888	0	0
45792070	1124957	0	0
45694158	738818	0	0
45800483	1107830	0	0
45786301	1174888	0	0
45789299	1125315	0	0
46297607	1115008	0	0
46244274	19078461	2	3
45799592	1125315	0	0
46305901	1119510	0	0
4154161	4155034	3	3
1521406	19128065	2	2
21002773	1746114	0	0
21013627	40171902	1	1
36218509	40221415	2	3
36157261	19127890	0	0
21604200	19059528	2	2
36211091	40479768	3	3
42804679	1713332	0	0
44341805	1192710	0	0
44348707	1549786	0	0
44339847	1125315	0	0
45641039	1129625	0	0
44343552	738818	0	0
44348001	1125315	0	0
45659823	1177480	0	0
45651962	1549786	0	0
45630203	1149196	0	0
45695687	920293	0	0
45670863	19002770	0	0
45661337	1717327	0	0
45700286	40174880	2	3
45678250	1192710	0	0
45789421	715997	0	0
45694015	738818	0	0
45800458	1326303	0	0
45786313	1124957	0	0
45789278	1125315	0	0
46297622	1153428	0	0
46295329	1107882	2	3
45799600	1125315	0	0
46306119	1119510	0	0
4154161	4152936	3	3
321588	317576	2	2
21002773	1717327	0	0
21002502	40221415	1	1
35508273	19078461	2	3
36157261	1549786	0	0
21604200	1154029	2	2
36211088	40479422	3	3
42804695	1545958	0	0
44341806	1549786	0	0
44348711	1125315	0	0
44339906	1125315	0	0
45640849	1129625	0	0
44343564	1118084	0	0
44348002	1125315	0	0
45659946	1177480	0	0
45652052	1500211	0	0
45630401	1551099	0	0
45695596	1149196	0	0
45671099	914335	0	0
45661465	715997	0	0
45682143	1192710	0	0
45678389	1110410	0	0
45789435	1778162	0	0
45691206	738818	0	0
45800437	1713332	0	0
45786362	701322	0	0
45789305	1125315	0	0
46298058	1738521	0	0
45788322	1107882	2	3
45796811	1125315	0	0
46305843	1119510	0	0
4154161	378001	3	3
440059	4056621	2	2
21002743	1149196	0	0
21002502	19128009	1	1
36154304	40228214	2	3
36156741	1589505	0	0
21604200	19016749	2	2
36211088	40479768	3	3
42804815	1125315	0	0
44341806	1515774	0	0
44348713	723013	0	0
44339775	1125315	0	0
45640852	1129625	0	0
44343579	1515774	0	0
44348105	1125315	0	0
45659784	1177480	0	0
45651968	1000560	0	0
45629956	1545958	0	0
45695601	723013	0	0
45671017	1153428	0	0
45661620	1367571	0	0
45679989	1107830	0	0
45678393	1124957	0	0
45789447	975125	0	0
45691093	738818	0	0
45800437	1759842	0	0
45786414	1307863	0	0
45789307	1125315	0	0
46297832	1192710	0	0
45788305	1107882	2	3
45796665	1125315	0	0
46306138	1119510	0	0
4154161	4113008	3	3
75053	4059173	2	2
21002743	1107830	0	0
21002502	42902245	1	1
36153639	19078461	2	3
36156821	1119510	0	0
21603940	1124300	2	2
36211088	81151	3	3
42804952	1115008	0	0
44341848	914335	0	0
44348494	1545958	0	0
44339754	1125315	0	0
45640874	1129625	0	0
44343579	1549786	0	0
44348111	1125315	0	0
45660049	1177480	0	0
45652196	1149196	0	0
45630392	1115008	0	0
45695602	1149196	0	0
45671020	1589505	0	0
45661298	701322	0	0
45680007	708298	0	0
45678210	967823	0	0
45789453	1174888	0	0
45691366	738818	0	0
45800472	708298	0	0
46296817	1107830	0	0
45789401	1125315	0	0
46297846	1192710	0	0
46295071	1107882	2	3
45796710	1125315	0	0
46306214	1119510	0	0
4154161	4109685	3	3
75053	4048695	2	2
21002743	1153428	0	0
21002502	19128065	1	1
36153941	19078461	2	3
36156750	1124300	0	0
4130851	4155034	2	2
36000000	134438	3	3
42804667	1545958	0	0
44341883	1154343	0	0
44349143	1119510	0	0
44339810	1125315	0	0
45640987	1129625	0	0
44344787	1501700	0	0
44348066	1125315	0	0
45656904	1177480	0	0
45652125	1124957	0	0
45627086	1539403	0	0
45695605	791967	0	0
45670917	967823	0	0
45661547	967823	0	0
45679946	1107830	0	0
45678235	1500211	0	0
45789465	1174888	0	0
45688741	738818	0	0
45800476	1112807	0	0
46296958	1153428	0	0
45787829	1125315	0	0
46297958	975125	0	0
45895826	1107882	2	3
45796868	1125315	0	0
46306028	1119510	0	0
4154161	375671	3	3
75053	4066995	2	2
21002743	1150770	0	0
21002502	19128263	1	1
36153655	19078461	2	3
36156751	1107830	0	0
21603311	1154343	2	2
35802848	4027663	3	3
42804642	1332418	0	0
44341889	738818	0	0
44349143	738818	0	0
44339885	1125315	0	0
45641071	1129625	0	0
44344789	975125	0	0
44348140	1125315	0	0
45657008	1177480	0	0
45652237	1326303	0	0
45627211	757627	0	0
45695698	1154343	0	0
45671036	967823	0	0
45661551	1174888	0	0
45679953	1343916	0	0
45678238	742185	0	0
45789472	1738521	0	0
45688107	738818	0	0
45800479	1115008	0	0
46296886	1115008	0	0
45787871	1125315	0	0
46297967	1332418	0	0
45801335	19073183	2	3
45796991	1125315	0	0
46305856	1119510	0	0
4154161	4296204	3	3
75053	4278672	2	2
21002744	738818	0	0
21002502	19128022	1	1
36153954	19078461	2	3
36156741	1549786	0	0
35204998	4324181	2	2
36211305	4156265	3	3
42804643	975125	0	0
44341892	1192710	0	0
44349151	975125	0	0
44339887	1125315	0	0
45640933	1129625	0	0
44344790	19003953	0	0
44348246	1125315	0	0
45657110	1177480	0	0
45652245	1174888	0	0
45627230	1713332	0	0
45695821	933724	0	0
45670958	1107830	0	0
45661659	1332418	0	0
45679967	1107830	0	0
45678240	1332418	0	0
45789477	1549786	0	0
45688169	738818	0	0
45800564	1713332	0	0
46296767	1174888	0	0
45787910	1125315	0	0
46297862	705944	0	0
45801262	1107882	2	3
45796801	1125315	0	0
46322299	1119510	0	0
4103352	4156265	3	3
75053	4237458	2	2
21002775	1551099	0	0
21002502	19127918	1	1
36153616	19078461	2	3
36157070	1000560	0	0
21604148	1557272	2	2
36207528	3013682	3	3
42804681	1000560	0	0
44341766	1118084	0	0
44348822	1119510	0	0
44339993	1125315	0	0
45641097	1129625	0	0
44344910	740275	0	0
44348214	1125315	0	0
45657184	1177480	0	0
45650895	920293	0	0
45627104	975125	0	0
45695827	1110410	0	0
45671058	1124957	0	0
45661668	1115008	0	0
45679970	975125	0	0
45678242	1115008	0	0
45789477	1515774	0	0
45685059	738818	0	0
45800513	1115008	0	0
46296997	1118084	0	0
45786083	1125315	0	0
46297906	967823	0	0
46239358	19073183	2	3
45796849	1125315	0	0
46322450	1119510	0	0
4103352	4283893	3	3
75053	40480160	2	2
21002326	1713332	0	0
21002502	19132304	1	1
36217220	920300	2	3
36157209	1539403	0	0
35204989	321042	2	2
36207528	3006906	3	3
42804644	1124957	0	0
44341864	1521369	0	0
44348572	1548195	0	0
44339975	1125315	0	0
45641283	1129625	0	0
44344823	1548195	0	0
44341580	1125315	0	0
45653082	1177480	0	0
45650901	1548195	0	0
45627229	1713332	0	0
45695832	1713332	0	0
45671061	1110410	0	0
45661369	967823	0	0
45679971	1107830	0	0
45678314	1154029	0	0
45789479	975125	0	0
45685064	738818	0	0
45800486	1589505	0	0
46297025	1112807	0	0
45786216	1125315	0	0
46297923	1174888	0	0
46239371	40229134	2	3
45796854	1125315	0	0
46322617	1119510	0	0
4043019	4181917	3	3
73553	80809	2	2
21002326	1759842	0	0
21500746	967823	1	1
36217210	1594382	2	3
36156759	705944	0	0
35204989	317576	2	2
36211136	4134304	3	3
42804644	1125315	0	0
44341865	933724	0	0
44348593	1125315	0	0
44340018	1125315	0	0
45641010	1129625	0	0
44344824	1746114	0	0
44340704	1125315	0	0
45653381	1177480	0	0
45650918	1545958	0	0
45627229	1759842	0	0
45695860	1110410	0	0
45670978	1332418	0	0
45661727	1713332	0	0
45680040	1551099	0	0
45678227	1310149	0	0
45789481	1115008	0	0
45681986	738818	0	0
45800443	1153428	0	0
46296924	1778162	0	0
45786231	1125315	0	0
46297929	1107830	0	0
46239459	19008572	2	3
45796975	1125315	0	0
46322618	1119510	0	0
4028908	4012477	3	3
443419	4155034	2	2
21002658	1551099	0	0
21002493	19128022	1	1
36217210	19006318	2	3
36156754	1119510	0	0
4141937	4337138	2	2
35809321	4084167	3	3
42804806	1174888	0	0
44342040	738818	0	0
44348867	1177480	0	0
44340173	1125315	0	0
45637730	1129625	0	0
44344824	1741122	0	0
44340654	1125315	0	0
45653648	1177480	0	0
45650981	1107830	0	0
45627239	975125	0	0
45695903	1153428	0	0
45671037	1102527	0	0
45661394	1124957	0	0
45680041	1367571	0	0
45678220	1545958	0	0
45789459	1549786	0	0
45682067	738818	0	0
45800527	967823	0	0
46296929	1112807	0	0
45786401	1125315	0	0
46297990	975125	0	0
46239548	1115171	2	3
45796981	1125315	0	0
46322626	1119510	0	0
4042835	257012	3	3
443419	4152936	2	2
21002327	1759842	0	0
21001812	1746114	0	0
36217210	964261	2	3
36156825	1124957	0	0
4092881	195588	2	2
36211089	78272	3	3
42804806	1125315	0	0
44341896	1332418	0	0
44348332	1149196	0	0
44339868	1125315	0	0
45637690	1129625	0	0
44344712	1107830	0	0
44340657	1125315	0	0
45653506	1177480	0	0
45650982	1174888	0	0
45627241	1107830	0	0
45695904	791967	0	0
45669691	1539403	0	0
45661396	1741122	0	0
45680283	1305058	0	0
45678220	1332418	0	0
45789428	1548195	0	0
45682000	738818	0	0
45800486	1549786	0	0
46297109	1000560	0	0
45786408	1125315	0	0
46297994	1107830	0	0
46239551	19059056	2	3
45796985	1125315	0	0
46316970	1119510	0	0
4072499	4035793	3	3
443419	4109685	2	2
21002327	1713332	0	0
21001816	1713332	0	0
36217210	1310034	2	3
36157232	1545958	0	0
4056681	4163872	2	2
35809215	4285898	3	3
42804915	1713332	0	0
44342043	933724	0	0
44348931	1125315	0	0
44339871	1125315	0	0
45637872	1129625	0	0
44344750	1310149	0	0
44340673	1125315	0	0
45650156	1177480	0	0
45650986	1115008	0	0
45627186	1192710	0	0
45694387	1149196	0	0
45669350	920293	0	0
45661396	1746114	0	0
45680023	933724	0	0
45678499	738818	0	0
45789492	1000560	0	0
45678912	738818	0	0
45800490	19010482	0	0
46296938	1112807	0	0
45786301	1125315	0	0
46297489	1307863	0	0
46239325	40231925	2	3
45796872	1125315	0	0
46311332	1119510	0	0
4177089	4125906	3	3
443419	4113008	2	2
21002328	1746114	0	0
21001819	1741122	0	0
36217210	19076374	2	3
36157210	1119510	0	0
4056681	4058899	2	2
36211258	40479422	3	3
42804915	1759842	0	0
44342153	1177480	0	0
44348933	1119510	0	0
44339876	1125315	0	0
45637780	1129625	0	0
44344813	1149196	0	0
44340744	1125315	0	0
45650241	1177480	0	0
45651017	1521369	0	0
45627192	1115008	0	0
45694709	1174888	0	0
45669365	740275	0	0
45660228	1115008	0	0
45679996	1713332	0	0
45678426	1149196	0	0
45789608	1000560	0	0
45678923	738818	0	0
45800620	1501700	0	0
46296939	1153428	0	0
45786313	1125315	0	0
46297398	1192710	0	0
46239658	40229134	2	3
45796967	1125315	0	0
46311410	1119510	0	0
4178818	80809	3	3
31057	28060	2	2
21002327	920293	0	0
21001819	1713332	0	0
36217210	40220386	2	3
36157269	1521369	0	0
4042505	80502	2	2
36211258	40479768	3	3
42804916	1717327	0	0
44341922	1149196	0	0
44348933	1125315	0	0
44340117	1125315	0	0
45637910	1129625	0	0
44343706	1322184	0	0
44340823	1125315	0	0
45650329	1177480	0	0
45651017	19127890	0	0
45627243	1713332	0	0
45694393	1713332	0	0
45669369	1192710	0	0
45660158	1149196	0	0
45680070	1551099	0	0
45678506	1149380	0	0
45789849	1310149	0	0
45706755	1112807	0	0
45800633	967823	0	0
46296933	1332418	0	0
45786363	1125315	0	0
46297765	753626	0	0
46239659	40224805	2	3
45796738	1125315	0	0
46311625	1119510	0	0
4178818	30753	3	3
257907	255848	2	2
21002327	1746114	0	0
21001816	1759842	0	0
36217214	1332419	2	3
36157269	1549786	0	0
4092876	196456	2	2
36502199	4146173	4	5
42804646	1124957	0	0
44342233	1548195	0	0
44348791	1539403	0	0
44340255	1125315	0	0
45637694	1129625	0	0
44343713	1759842	0	0
44340954	1125315	0	0
45650384	1177480	0	0
45651017	1549786	0	0
45627198	1738521	0	0
45694364	1549786	0	0
45669407	1118084	0	0
45660192	1137529	0	0
45680072	1343916	0	0
45678583	1149196	0	0
45789852	1115008	0	0
45705278	1112807	0	0
45800467	1332418	0	0
46297090	933724	0	0
46296767	1125315	0	0
46297799	1192710	0	0
46239611	19059056	2	3
45796879	1125315	0	0
46311814	1119510	0	0
4042836	381316	3	3
1515777	19128022	2	2
21002327	1778162	0	0
21001824	1746114	0	0
36217214	40223768	2	3
36157281	1119510	0	0
4181187	372328	2	2
36502199	4035415	4	5
42804883	1713332	0	0
44341942	933724	0	0
44348676	1125315	0	0
44340285	1125315	0	0
45637702	1129625	0	0
44343713	1713332	0	0
44340798	1125315	0	0
45650542	1177480	0	0
45651017	1503184	0	0
45627276	1521369	0	0
45694523	1124957	0	0
45669336	1107830	0	0
45660192	1149380	0	0
45679957	1361711	0	0
45678335	738818	0	0
45789856	975125	0	0
45705234	1112807	0	0
45800600	1332418	0	0
46297179	1332418	0	0
46296986	1125315	0	0
46289296	1322184	0	0
46239735	40232448	2	3
45797104	1125315	0	0
46311822	1119510	0	0
4042836	380378	3	3
1515777	19128263	2	2
21002328	920293	0	0
21001824	1741122	0	0
36217214	19075601	2	3
36156842	1149196	0	0
4144290	4324181	2	2
36502198	4230399	4	5
42804668	1124300	0	0
44342113	1000560	0	0
44348677	1125315	0	0
44340076	1125315	0	0
45634691	1129625	0	0
44343734	1124957	0	0
44340981	1125315	0	0
45650181	1177480	0	0
45650931	1124957	0	0
45627276	1549786	0	0
45694712	1154029	0	0
45669439	1308738	0	0
45658289	967823	0	0
45680010	1124300	0	0
45678336	1192710	0	0
45789863	1367571	0	0
45779998	1112807	0	0
45800602	1545958	0	0
46296966	1115008	0	0
46297008	1125315	0	0
46289301	1174888	0	0
45895940	40232448	2	3
45797038	1125315	0	0
46311423	1119510	0	0
4042836	4156265	3	3
256440	257012	2	2
21002328	1759842	0	0
21001833	1738521	0	0
36217214	19074843	2	3
36156844	1115008	0	0
4113552	4166224	2	2
36211071	4134304	3	5
42804669	1713332	0	0
44342020	1713332	0	0
44348677	1129625	0	0
44338028	1125315	0	0
45634679	1129625	0	0
44343823	1343916	0	0
44340832	1125315	0	0
45650204	1177480	0	0
45650991	967823	0	0
45627276	19127890	0	0
45692456	1118084	0	0
45669427	19039298	0	0
45658296	1322184	0	0
45680117	1308738	0	0
45678337	975125	0	0
45789869	1713332	0	0
45780180	1112807	0	0
45800534	1112807	0	0
46296967	1110410	0	0
46297021	1125315	0	0
46289140	1305058	0	0
45896157	1127433	2	3
45797208	1125315	0	0
46311435	1119510	0	0
4042836	372328	3	3
256440	40481087	2	2
21002337	1746114	0	0
21001813	1746114	0	0
36217216	19133873	2	3
36156981	1551099	0	0
4113552	440448	2	2
36211088	4134304	3	5
42804647	1149380	0	0
44341873	1174888	0	0
44348689	1154029	0	0
44338056	1125315	0	0
45634768	1129625	0	0
44343815	975125	0	0
44340769	1125315	0	0
45647257	1177480	0	0
45650906	1124957	0	0
45627236	1149196	0	0
45692463	1107830	0	0
45669527	1322184	0	0
45658330	967823	0	0
45680119	1396131	0	0
45678338	1115008	0	0
45789541	1551099	0	0
45780120	1112807	0	0
45800495	1174888	0	0
46297323	1110410	0	0
46297025	1125315	0	0
46289148	1326303	0	0
45896192	1551192	2	3
45797088	1125315	0	0
46311440	1119510	0	0
4047779	317009	3	3
135526	4066995	2	2
21002329	1746114	0	0
21001819	1759842	0	0
36217216	1150771	2	3
36156854	1107830	0	0
4201944	4151422	2	2
36211325	4152936	3	5
42804762	1322184	0	0
44341874	1107830	0	0
44348691	1153428	0	0
45619720	1125315	0	0
45634564	1129625	0	0
44343938	1110410	0	0
44340770	1125315	0	0
45647171	1177480	0	0
45650995	1322184	0	0
45627317	1310149	0	0
45692480	1174888	0	0
45669453	1115008	0	0
45658090	1153428	0	0
45680122	1738521	0	0
45678345	967823	0	0
45789456	1153428	0	0
45706122	1112807	0	0
45800505	1500211	0	0
46297331	1112807	0	0
46297054	1125315	0	0
46289166	914335	0	0
45895887	19133905	2	3
45797216	1125315	0	0
46319609	1119510	0	0
4180628	4051466	3	3
136779	4155034	2	2
21002333	1713332	0	0
21001827	1746114	0	0
36217216	920334	2	3
36156984	1177480	0	0
21600315	1361711	2	2
36211258	78272	5	5
42804923	1177480	0	0
44342154	1115008	0	0
44348871	1129625	0	0
45619727	1125315	0	0
45634754	1129625	0	0
44343872	1107830	0	0
44340952	1125315	0	0
45649032	1177480	0	0
45650919	1768849	0	0
45627107	738818	0	0
45692481	1124957	0	0
45669575	1124957	0	0
45658026	1717327	0	0
45680164	1500211	0	0
45678370	975125	0	0
45789459	1521369	0	0
45706197	1112807	0	0
45800509	1501700	0	0
46297522	975125	0	0
46296937	1125315	0	0
46289191	705944	0	0
45895994	1115171	2	3
45797024	1125315	0	0
46319394	1119510	0	0
4180628	140673	3	3
77960	80180	2	2
21002328	1778162	0	0
21001827	1741122	0	0
36217216	1332419	2	3
36157143	1539403	0	0
35204952	313217	2	2
36516972	4113008	5	5
42804652	1000560	0	0
44342163	1551099	0	0
44348872	1149380	0	0
45619778	1125315	0	0
45634780	1129625	0	0
44343947	1149196	0	0
44340843	1125315	0	0
45647340	1177480	0	0
45650923	1000560	0	0
45627109	738818	0	0
45692427	738818	0	0
45669399	1332418	0	0
45658093	791967	0	0
45680003	1326303	0	0
45678371	1192710	0	0
45789569	1112807	0	0
45706217	1112807	0	0
45800595	1307863	0	0
46297139	975125	0	0
46296938	1125315	0	0
46289209	791967	0	0
45896058	19008572	2	3
45797027	1125315	0	0
46319719	1119510	0	0
4180628	80180	3	3
76611	4146173	2	2
21002335	1746114	0	0
21001834	1768849	0	0
36217216	40223768	2	3
36157291	1112807	0	0
21604752	742185	2	2
36211315	81151	5	5
42804655	914335	0	0
44342286	1539403	0	0
44348999	705944	0	0
45619826	1125315	0	0
45637312	1129625	0	0
44343772	1308738	0	0
44341042	1125315	0	0
45647346	1177480	0	0
45650917	1110410	0	0
45627112	738818	0	0
45692431	738818	0	0
45669531	1310149	0	0
45658168	738818	0	0
45680013	1326303	0	0
45678418	1102527	0	0
45786488	1000560	0	0
45706570	1112807	0	0
45800599	757627	0	0
46297129	1115008	0	0
46294816	1115008	0	0
46289213	1115008	0	0
45896040	1127433	2	3
46318051	1125315	0	0
46319821	1119510	0	0
4029205	4326177	3	3
3048927	3023430	2	2
21002336	1741122	0	0
21001819	1778162	0	0
36217216	19125062	2	3
36157295	1129625	0	0
21604752	705944	2	2
36502197	4035415	5	5
42804657	1343916	0	0
44342020	1759842	0	0
44349001	1124957	0	0
45619873	1125315	0	0
45631471	1129625	0	0
44343677	920293	0	0
44340914	1125315	0	0
45647392	1177480	0	0
45651130	1713332	0	0
45627115	1521369	0	0
45692403	1107830	0	0
45669643	1000560	0	0
45658238	1310149	0	0
45680147	1738521	0	0
45678697	975125	0	0
45786533	1589505	0	0
45706250	1112807	0	0
45800702	967823	0	0
46292890	933724	0	0
46294933	753626	0	0
46289480	1149196	0	0
45896041	40163554	2	3
46318054	1125315	0	0
46317507	1119510	0	0
4029205	4052083	3	3
3048927	3005136	2	2
21002336	1746114	0	0
21001820	1738521	0	0
36217216	19078461	2	3
36157295	1177480	0	0
21603933	1124300	2	2
36211303	4113008	5	5
42804658	1343916	0	0
44342119	1153428	0	0
44349004	701322	0	0
45619837	1125315	0	0
45631649	1129625	0	0
44344038	738818	0	0
44340921	1125315	0	0
45644272	1177480	0	0
45651130	1759842	0	0
45627287	1501700	0	0
45692728	19003953	0	0
45669539	1174888	0	0
45658240	1000560	0	0
45680080	1551099	0	0
45678352	1000560	0	0
45786527	1738521	0	0
45700640	1112807	0	0
45800704	1192710	0	0
46293438	1501700	0	0
46294807	1107830	0	0
46289222	1000560	0	0
45895997	40229134	2	3
46317552	1125315	0	0
46317509	1119510	0	0
4027403	4186930	3	3
3049150	3005136	2	2
21002337	1741122	0	0
21001819	1717327	0	0
36202155	4278672	2	4
36157305	701322	0	0
21603302	1154343	2	2
36211303	4218389	5	5
42804763	914335	0	0
44342023	1112807	0	0
44349131	1125315	0	0
45619910	1125315	0	0
45628700	1129625	0	0
44344041	975125	0	0
44340922	1125315	0	0
45644281	1177480	0	0
45651190	791967	0	0
45627288	1322184	0	0
45692409	1545958	0	0
45669583	1174888	0	0
45658243	1595799	0	0
45677616	1310149	0	0
45675117	975125	0	0
45786837	1115008	0	0
45699886	1112807	0	0
45800537	738818	0	0
46293236	1778162	0	0
46294548	1501700	0	0
46289606	1738521	0	0
45896184	40232448	2	3
45793893	1125315	0	0
46317521	1119510	0	0
4027403	4059978	3	3
1759843	1713671	1	1
21002344	1759842	0	0
21001819	1738521	0	0
35902136	198809	2	4
36156990	1119510	0	0
21604182	753626	2	2
36211303	4296204	5	5
42804661	1343916	0	0
44341926	1713332	0	0
44349133	1129625	0	0
45619914	1125315	0	0
45631040	1129625	0	0
44344048	1307863	0	0
44340924	1125315	0	0
45644284	1177480	0	0
45651194	1149196	0	0
45627118	1551099	0	0
45692448	1332418	0	0
45669644	1124300	0	0
45658246	1149380	0	0
45677727	975125	0	0
45675121	1310149	0	0
45786733	1778162	0	0
45693571	1112807	0	0
45800808	1192710	0	0
46292916	1192710	0	0
46294364	1000560	0	0
46289264	1367571	0	0
45804352	40236446	2	3
45793887	1125315	0	0
46317268	1119510	0	0
4027403	4202832	3	3
1713545	19073183	1	1
21001804	1728416	0	0
21001823	1768849	0	0
36203060	81151	2	5
36156990	738818	0	0
36152480	19128022	2	2
36211303	4155034	5	5
42804866	1115008	0	0
44341926	1759842	0	0
44348940	708298	0	0
45620003	1125315	0	0
45628858	1129625	0	0
44343793	1110410	0	0
44340888	1125315	0	0
45644373	1177480	0	0
45651373	738818	0	0
45627122	1110410	0	0
45692520	1124957	0	0
45669510	1310149	0	0
45658118	1000560	0	0
45677545	1124957	0	0
45675176	1149196	0	0
45786509	1713332	0	0
45693607	1112807	0	0
45800818	1192710	0	0
46292918	1112807	0	0
46294281	1549786	0	0
46289271	920293	0	0
45804319	19018935	2	3
45793911	1125315	0	0
46317591	1125315	0	0
4067285	4242997	3	3
1713547	19073188	1	1
21001819	1746114	0	0
21001669	1551099	0	0
35702738	192671	2	5
36156861	1119510	0	0
36152480	19128263	2	2
36300000	375671	10	14
42804854	920293	0	0
44341928	708298	0	0
44348952	1548195	0	0
45619886	1125315	0	0
45628885	1129625	0	0
44343795	1192710	0	0
44340894	1125315	0	0
45644426	1177480	0	0
45651374	1124957	0	0
45627364	1501700	0	0
45692485	1154343	0	0
45669684	1501700	0	0
45704016	1713332	0	0
45677740	920293	0	0
45675157	738818	0	0
45786509	1759842	0	0
45693706	1112807	0	0
45800616	1115008	0	0
46293110	1501700	0	0
46294281	1521369	0	0
46289620	1332418	0	0
45804388	40163554	2	3
45794001	1125315	0	0
46313409	1125315	0	0
4067285	4117038	3	3
1154459	1154615	1	1
21000483	1551099	0	0
21001666	1551099	0	0
21602628	40236824	2	5
36156861	738818	0	0
21603966	19019273	2	2
36300000	4166224	10	14
42804986	1310149	0	0
44342104	1149196	0	0
44348942	738818	0	0
45620213	1125315	0	0
45625796	1129625	0	0
44343858	1307863	0	0
45637302	1125315	0	0
45644178	1177480	0	0
45651093	1539403	0	0
45627366	1124957	0	0
45692496	1107830	0	0
45669686	1343916	0	0
45704016	1759842	0	0
45677560	1110410	0	0
45675158	1548195	0	0
45786535	1149196	0	0
45691503	1112807	0	0
45800530	1332418	0	0
46293113	1310149	0	0
46294411	1305058	0	0
46289637	920293	0	0
45797167	19008572	2	3
45794186	1125315	0	0
46313410	1125315	0	0
4067285	4330583	3	3
4020466	4336464	1	1
21000482	1305058	0	0
21001796	1713332	0	0
36202157	375671	2	10
36156999	1153428	0	0
21603966	19078461	2	2
36300000	37017711	10	11
42804995	1177480	0	0
44342214	705944	0	0
44348942	1119510	0	0
45620250	1125315	0	0
45625921	1129625	0	0
44344162	1557272	0	0
45638161	19078461	2	3
45644511	1177480	0	0
45651280	1501700	0	0
45627369	1343916	0	0
45692501	1326303	0	0
45669521	738818	0	0
45704085	1738521	0	0
45677561	738818	0	0
45674849	1332418	0	0
45786725	1154343	0	0
45691447	1112807	0	0
45800843	967823	0	0
46293132	1149196	0	0
46294430	1192710	0	0
46289524	967823	0	0
45796694	19008572	2	3
45794190	1125315	0	0
46313418	1125315	0	0
4042140	4056621	6	8
3023227	3000963	1	1
21000485	1305058	0	0
21500574	19019979	6	7
35702738	440448	2	9
36157005	1107830	0	0
21603966	1115008	2	2
36300000	438614	9	10
42804998	1551099	0	0
44342224	975125	0	0
44348942	1125315	0	0
45620047	1125315	0	0
45625951	1129625	0	0
44343923	1738521	0	0
45640890	19078461	2	3
45644663	1177480	0	0
45651107	1713332	0	0
45627383	1738521	0	0
45692386	1539403	0	0
45669525	701322	0	0
45703842	1332418	0	0
45677563	1154029	0	0
45674852	975125	0	0
45786719	1309944	0	0
45690734	1112807	0	0
45800844	1124300	0	0
46293426	1112807	0	0
46294544	1149196	0	0
46289069	1332418	0	0
45796727	19018935	2	3
45794024	1125315	0	0
46313308	1125315	0	0
4042140	4048171	6	11
3002665	3006906	1	1
21000486	1305058	0	0
21500574	1115171	6	7
35702738	4166224	2	9
36157017	1589505	0	0
21603966	1177480	2	2
36300000	4156265	9	12
42804870	1713332	0	0
44342058	1124957	0	0
44348944	1713332	0	0
45620054	1125315	0	0
45625819	1129625	0	0
44344158	740275	0	0
45656538	19078461	2	3
45641544	1177480	0	0
45651160	1149196	0	0
45627388	1124300	0	0
45692514	1149380	0	0
45669603	1326303	0	0
45703636	1153428	0	0
45677518	1107830	0	0
45675272	1124300	0	0
45786664	1107830	0	0
45690740	1112807	0	0
45800845	1713332	0	0
46293136	1112807	0	0
46294667	1551099	0	0
46289786	975125	0	0
45796669	1551192	2	3
45794009	1125315	0	0
46313437	1125315	0	0
4042140	378001	6	10
3003169	3004501	1	1
21000482	975125	0	0
21500574	19007333	6	7
35702738	4266809	2	7
36157024	1153428	0	0
4180941	4202832	2	2
36300000	4266809	9	12
42805064	1149380	0	0
44342093	1124957	0	0
44348914	1738521	0	0
45620060	1125315	0	0
45625983	1129625	0	0
44344095	1192710	0	0
45631797	19078461	2	3
45641640	1177480	0	0
45647867	1738521	0	0
45627264	1343916	0	0
45692638	1332418	0	0
45669604	1174888	0	0
45703788	1118084	0	0
45677938	914335	0	0
45674935	738818	0	0
45786512	1112807	0	0
45687691	1112807	0	0
45800845	1759842	0	0
46293127	1174888	0	0
46294669	1738521	0	0
46289325	1310149	0	0
45791202	1551192	2	3
45794158	1125315	0	0
46313457	1125315	0	0
4029205	4330583	6	9
77162	81151	1	1
21000495	1305058	0	0
21500574	19078461	6	7
21602484	19128022	2	2
36157031	1129625	0	0
4180941	4010253	2	2
36300000	4299128	9	9
42804840	1129625	0	0
44342094	1595799	0	0
44348962	1129625	0	0
45620067	1125315	0	0
45622578	1129625	0	0
44343976	1115008	0	0
45656647	19078461	2	3
45638404	1177480	0	0
45647713	1589505	0	0
45627268	1154029	0	0
45692547	1124300	0	0
45669662	1153428	0	0
45704143	1500211	0	0
45677995	1154343	0	0
45674945	1545958	0	0
45786618	1174888	0	0
45687351	1112807	0	0
45800729	933724	0	0
46293432	1124957	0	0
46294670	1549786	0	0
46289787	1738521	0	0
45791405	40229134	2	3
45794824	1125315	0	0
46313517	1125315	0	0
4029205	4242997	6	7
77162	4059173	1	1
21000526	1305058	0	0
21500574	1127078	6	7
21602516	19128009	2	2
36157147	967823	0	0
4180941	4057420	2	2
36300000	4155034	8	11
42804979	1713332	0	0
44342094	1549786	0	0
44348962	1125315	0	0
45620092	1125315	0	0
45622841	1129625	0	0
44340081	1367571	0	0
45647179	19078461	2	3
45638394	1177480	0	0
45647899	1310149	0	0
45627269	1332418	0	0
45692554	1124957	0	0
45669607	1192710	0	0
45703982	1107830	0	0
45677520	1115008	0	0
45674856	914335	0	0
45786805	1545958	0	0
45687632	1112807	0	0
45800847	1729720	0	0
46293150	1545958	0	0
46294670	1521369	0	0
46289800	1124300	0	0
45791489	40232448	2	3
45794772	1125315	0	0
46313534	1125315	0	0
4029205	4252419	6	7
80004	4113008	1	1
19078461	19078461	0	0
21500175	40173590	6	7
21602568	19128065	2	2
36157156	1589505	0	0
4180941	4059978	2	2
36300000	380378	8	11
42804979	1759842	0	0
44342094	1521369	0	0
44348601	1759842	0	0
45620161	1125315	0	0
45622546	1129625	0	0
44340084	1115008	0	0
45641070	40228214	2	3
45640202	1177480	0	0
45647640	1000560	0	0
45627395	1778162	0	0
45692612	19010482	0	0
45669790	1548195	0	0
45703985	1174888	0	0
45677634	723013	0	0
45674858	738818	0	0
45786737	1551099	0	0
45687989	1112807	0	0
45800749	1332418	0	0
46293283	1713332	0	0
46294677	1192710	0	0
46289555	1343916	0	0
45791424	1551192	2	3
45794452	1125315	0	0
46313542	1125315	0	0
4029205	4058899	6	8
80502	40480160	1	1
19079524	19079524	0	0
21500582	19133768	6	7
21602537	1521369	2	2
36157169	967823	0	0
36217214	1150771	2	3
36300000	30753	8	12
42804980	1778162	0	0
44342096	1548195	0	0
44348923	1343916	0	0
44778120	1125315	0	0
45622651	1129625	0	0
44340091	1149196	0	0
45662823	19078461	2	3
45635211	1177480	0	0
45647643	791967	0	0
45627423	1551099	0	0
45692613	1154343	0	0
45669793	19010482	0	0
45703952	19127890	0	0
45678069	1192710	0	0
45675289	1192710	0	0
45786830	1112807	0	0
45687489	1112807	0	0
45800750	1549786	0	0
46293283	1759842	0	0
46294842	1115008	0	0
46289814	1192710	0	0
45791547	40229134	2	3
45794801	1125315	0	0
46313474	1125315	0	0
4027384	4048171	6	9
1519940	43012433	1	1
4297090	42535580	6	7
21500582	40165015	6	7
21602537	19054876	2	2
36157188	1501700	0	0
36217214	19133873	2	3
36300000	378419	8	13
42804875	1125315	0	0
44342073	738818	0	0
44348859	1154343	0	0
44361324	1125315	0	0
45622673	1129625	0	0
44340096	705944	0	0
45641011	19078461	2	3
45635562	1177480	0	0
45647904	1343916	0	0
45627486	1310149	0	0
45692591	1115008	0	0
45669478	715997	0	0
45703952	19054876	0	0
45677669	1305058	0	0
45675293	1192710	0	0
45786941	1332418	0	0
45687938	1112807	0	0
45797674	1107830	0	0
46293290	1551099	0	0
46296702	1713332	0	0
46289823	1118084	0	0
45791292	19008572	2	3
45794330	1125315	0	0
46313482	1125315	0	0
4027384	133834	6	6
443883	4084167	1	1
4297090	4047491	6	7
21500582	40231925	6	7
35508659	19128263	2	2
36157308	1119510	0	0
36217214	40173590	2	3
36300000	4294548	8	14
42804875	1174888	0	0
44342074	1539403	0	0
44348860	1125315	0	0
44361622	1125315	0	0
45622858	1129625	0	0
44340104	1107830	0	0
45646640	19078461	2	3
45635401	1177480	0	0
45647870	791967	0	0
45627487	1332418	0	0
45692673	975125	0	0
45669480	738818	0	0
45703952	1548195	0	0
45677998	1545958	0	0
45675210	1551099	0	0
45786811	1115008	0	0
45687940	1112807	0	0
45797836	701322	0	0
46293312	914335	0	0
46296765	1332418	0	0
46289582	1549786	0	0
46298473	19059056	2	3
45794332	1125315	0	0
46313376	1125315	0	0
4028387	133834	6	6
740348	19074679	1	1
4322976	4037675	6	8
21502510	19074843	6	7
35508659	19128022	2	2
36157194	1119510	0	0
36217214	40236824	2	3
36300000	4144583	11	11
42804971	1124300	0	0
44342077	1589505	0	0
44348866	1539403	0	0
44363023	40171902	1	1
45622776	1129625	0	0
44340145	715997	0	0
45631793	19078461	2	3
45632296	1177480	0	0
45647989	1192710	0	0
45627357	1551099	0	0
45692675	1729720	0	0
45669488	1548195	0	0
45703919	738818	0	0
45677871	1501700	0	0
45675211	738818	0	0
45786815	791967	0	0
45687903	1112807	0	0
45797647	1174888	0	0
46293314	1115008	0	0
46296879	708298	0	0
46289582	19127890	0	0
46298674	40232448	2	3
45794317	1125315	0	0
46313379	1125315	0	0
4029205	4024958	6	6
192956	198809	1	1
4274025	4296204	6	8
21502510	19133905	6	7
35502639	140673	2	2
36199678	1119510	0	0
36217214	19074679	2	3
36300000	4134304	11	15
42804972	1713332	0	0
44342102	1589505	0	0
44349113	19039298	0	0
44337665	19115351	1	1
45621312	1129625	0	0
44340147	1326303	0	0
45622696	19078461	2	3
45632310	1177480	0	0
45647916	1192710	0	0
45627512	1332418	0	0
45692682	723013	0	0
45669488	1512674	0	0
45703972	1501700	0	0
45677885	1154343	0	0
45675113	975125	0	0
45786949	1107830	0	0
45687974	1112807	0	0
45797763	1192710	0	0
46293264	1539403	0	0
46244044	1115008	0	0
46289987	967823	0	0
46298902	40236824	2	3
45794282	1125315	0	0
46313626	1125315	0	0
4029205	4163872	6	6
195632	4149245	1	1
21500574	1127433	6	7
21502510	19073183	6	7
21602003	1129625	2	2
36157310	723013	0	0
36217214	40222846	2	3
36300000	4084167	6	9
42804841	1115008	0	0
44342102	1549786	0	0
44349135	1124957	0	0
44784217	321042	1	1
45621288	1129625	0	0
44339937	1539403	0	0
45641363	19078461	2	3
45632323	1177480	0	0
45648001	723013	0	0
45627431	1361711	0	0
45692697	1124300	0	0
45669591	1107830	0	0
45704155	1124300	0	0
45678011	1124300	0	0
45675228	975125	0	0
45786740	1112807	0	0
45684749	1112807	0	0
45797651	1124957	0	0
46296446	967823	0	0
46244116	1149196	0	0
46289643	1000560	0	0
46298586	40163554	2	3
45794477	1125315	0	0
46313959	1125315	0	0
4032251	4243062	2	2
4001868	4301346	1	1
21500574	19059056	6	7
21502510	19129655	6	7
21602004	1129625	2	2
36157329	1738521	0	0
36217214	19073183	2	3
36300000	439777	5	11
42804843	1154343	0	0
44342243	1177480	0	0
44349135	1125315	0	0
44361661	19127918	3	4
45622017	1129625	0	0
44340505	19127890	0	0
45656208	19078461	2	3
45632402	1177480	0	0
45647907	1115008	0	0
45627223	1107830	0	0
45692624	1154029	0	0
45669497	1551099	0	0
45704113	1738521	0	0
45678014	975125	0	0
45675248	1713332	0	0
45786741	1000560	0	0
45684499	1112807	0	0
45797912	1332418	0	0
46296584	1124957	0	0
46244111	757627	0	0
46289656	1545958	0	0
46298724	40232448	2	3
45791453	1125315	0	0
46314016	1125315	0	0
4149795	44805732	2	2
1175452	3020630	1	1
4274025	192671	6	6
21502510	19133873	6	7
21603672	1343916	2	2
36157344	1112807	0	0
36217214	19133905	2	3
36208978	3014576	3	4
42804845	920293	0	0
44342295	1149196	0	0
44348601	1713332	0	0
44339931	19133679	3	4
45621996	1129625	0	0
44340505	1549786	0	0
45649708	19078461	2	3
45632496	1177480	0	0
45648050	1551099	0	0
45627447	1548195	0	0
45692775	1115008	0	0
45669500	1192710	0	0
45704120	1310149	0	0
45678015	1174888	0	0
45675254	19059528	0	0
45786631	1548195	0	0
45684840	1112807	0	0
45797777	1149196	0	0
46296697	1149196	0	0
46244207	1332418	0	0
46289721	1154343	0	0
46298556	19133873	2	3
45791456	1125315	0	0
46314423	1125315	0	0
4132546	375671	2	2
1175606	3023103	1	1
4208786	4230399	6	6
21502510	19073188	6	7
36157133	19128022	2	2
36157488	1119510	0	0
36217214	40163554	2	3
36208978	3000963	3	4
42804973	1738521	0	0
44342175	1107830	0	0
42802094	19133679	1	1
43531071	4275113	5	6
45621365	1129625	0	0
44340506	920293	0	0
45649845	19078461	2	3
45632561	1177480	0	0
45648056	1107830	0	0
45627448	1310149	0	0
45692719	1521369	0	0
45669593	715997	0	0
45704099	1115008	0	0
45678046	1149196	0	0
45675255	1310149	0	0
45786704	1309944	0	0
45682578	1112807	0	0
45797781	1000560	0	0
46296805	1115008	0	0
46244121	1500211	0	0
46289771	1124300	0	0
46298556	19133905	2	3
45791726	1125315	0	0
46313896	1125315	0	0
4132546	378001	2	2
1176181	3020630	1	1
4297090	4037675	6	6
21502510	1713671	6	7
21602628	933724	2	2
36157488	738818	0	0
36217214	40228214	2	3
36208978	3006906	3	4
42804975	1177480	0	0
44342375	1713332	0	0
42802094	19127922	1	1
43531072	4330583	4	6
45664896	1129625	0	0
44340510	1107830	0	0
44362009	19078461	2	3
45632519	1177480	0	0
45648057	19127890	0	0
45627251	1549786	0	0
45692719	19127890	0	0
45669765	1118084	0	0
45703780	738818	0	0
45677796	1778162	0	0
45675257	1115008	0	0
45786954	1557272	0	0
45682644	1112807	0	0
45797661	967823	0	0
46296717	975125	0	0
46244081	791967	0	0
46289594	975125	0	0
46299041	43012036	2	3
45791728	1125315	0	0
46308388	1125315	0	0
4103192	4329847	2	2
1175900	3008598	1	1
4247371	4048171	6	8
21502510	19075001	6	7
21602540	40224805	2	3
36157420	1107830	0	0
36217214	40223821	2	3
36208978	3009542	3	4
42804976	1310149	0	0
44342024	1557272	0	0
42802094	19129144	1	1
43531072	4117038	4	4
45664927	1129625	0	0
44340511	914335	0	0
45643929	40223768	2	3
45629431	1177480	0	0
45648057	1549786	0	0
45627251	1515774	0	0
45692719	1549786	0	0
45669772	1192710	0	0
45704031	1174888	0	0
45677816	1557272	0	0
45675236	975125	0	0
45786871	1589505	0	0
45681685	1112807	0	0
45797714	1174888	0	0
46296661	1192710	0	0
46244082	1110410	0	0
46289431	1107830	0	0
46299224	40232448	2	3
45791386	1125315	0	0
46308506	1125315	0	0
4063579	4246502	2	2
433524	4166224	1	1
4247371	375671	6	7
21502510	46275444	6	7
21602540	40224132	2	3
36157466	1107830	0	0
36217210	19129655	2	3
36207528	3016723	3	4
42805028	1153428	0	0
44342028	1149380	0	0
44786889	3023103	2	2
44786889	3013682	2	2
45664931	1129625	0	0
44340251	1713332	0	0
45637941	19078461	2	3
45629385	1177480	0	0
45648059	914335	0	0
45627251	19127890	0	0
45692723	1308738	0	0
45780877	791967	0	0
45703896	1308738	0	0
45677909	1192710	0	0
45674866	1107830	0	0
45786713	757627	0	0
45678512	1112807	0	0
45797715	1112807	0	0
46296810	1124957	0	0
46244021	1174888	0	0
46289744	1115008	0	0
46298939	40229134	2	3
45791405	1125315	0	0
46308533	1125315	0	0
4047120	440086	2	2
433524	440448	1	1
4247371	378001	6	7
21502510	19074841	6	7
35508755	1594382	2	3
36157468	1129625	0	0
36217210	46275444	2	3
36207528	3000963	3	4
42805032	19010482	0	0
44342034	1746114	0	0
45619703	1115171	2	3
44783379	4058899	2	2
45665096	1129625	0	0
44340251	1759842	0	0
45659395	19078461	2	3
45626640	1177480	0	0
45648077	1332418	0	0
45627296	1310149	0	0
45692844	715997	0	0
45780900	1149196	0	0
45703899	1000560	0	0
45677923	1308738	0	0
45675005	1115008	0	0
45786818	1738521	0	0
45672758	1112807	0	0
45797887	967823	0	0
46296815	1153428	0	0
46244085	1154343	0	0
46289750	1343916	0	0
46298760	40236824	2	3
45791709	1125315	0	0
46308529	1125315	0	0
4028876	255848	2	2
434621	80809	1	1
4274025	40479422	7	9
21500148	1539403	6	6
35508769	35605482	2	3
36157468	1119510	0	0
36217210	35605858	2	3
36207528	3024561	3	4
42804860	1115008	0	0
44342034	1741122	0	0
45619706	40162522	2	3
44782549	4066995	2	2
45665117	1129625	0	0
44340497	1548195	0	0
45646861	40223768	2	3
45626441	1177480	0	0
45647923	967823	0	0
45627454	1102527	0	0
45692699	1713332	0	0
45780718	723013	0	0
45704064	1361711	0	0
45677742	975125	0	0
45675051	1343916	0	0
45786919	1112807	0	0
45672761	1112807	0	0
45797895	1149196	0	0
46293557	1500211	0	0
46244129	1310149	0	0
46289926	1713332	0	0
46291664	40232448	2	3
45791685	1125315	0	0
46308558	1125315	0	0
4028902	4187458	2	2
257907	261325	1	1
21502709	1125315	7	7
21502709	40223834	9	10
35508683	19133873	2	3
36157365	1551099	0	0
36217210	42707627	2	3
35702800	4112343	3	4
42805061	1343916	0	0
44342133	1177480	0	0
45621976	40165015	2	3
44782549	4048695	2	2
45665055	1129625	0	0
44340236	1713332	0	0
45656382	19078461	2	3
45626728	1177480	0	0
45648081	1367571	0	0
45627461	1713332	0	0
45692803	1361711	0	0
45780797	1361711	0	0
45703904	1326303	0	0
45677823	1192710	0	0
45675126	1778162	0	0
45786927	920293	0	0
45784497	1112807	0	0
45797868	1539403	0	0
46293639	1738521	0	0
46244219	1107830	0	0
46289926	1759842	0	0
46290507	40163554	2	3
45791550	1125315	0	0
46308297	1125315	0	0
4028970	260139	2	2
260123	4294548	1	1
4208786	4134304	7	7
21502709	40228214	9	10
35508683	19133905	2	3
36157368	920293	0	0
36217210	19057271	2	3
36211258	81151	4	4
42803300	1539403	0	0
44342189	1713332	0	0
45619795	40232448	2	3
44337624	19128009	2	2
45665108	1129625	0	0
44340370	975125	0	0
45646890	19078461	2	3
45623312	1177480	0	0
45648148	1192710	0	0
45627461	1759842	0	0
45689272	1551099	0	0
45780905	1149380	0	0
45703906	1174888	0	0
45677837	1154343	0	0
45675096	1326303	0	0
45786769	967823	0	0
45784539	1112807	0	0
45797876	738818	0	0
46293679	701322	0	0
46244209	1332418	0	0
46289880	1308738	0	0
46290476	1115171	2	3
45791554	1125315	0	0
46308570	1125315	0	0
4168666	378419	2	2
1766555	19127904	1	2
4208786	78272	7	7
21502709	19125062	9	10
35508686	46275444	2	3
36157369	1115008	0	0
36217210	40243436	2	3
36211260	78272	4	4
42803276	1322184	0	0
44342390	1177480	0	0
44360997	40231925	2	3
44337624	19127918	2	2
45665142	1129625	0	0
44340371	1124300	0	0
45653162	19078461	2	3
45623365	1177480	0	0
45647857	1539403	0	0
45627462	975125	0	0
45689532	1738521	0	0
45780812	1326303	0	0
45703907	1174888	0	0
45677838	1717327	0	0
45675200	1308738	0	0
45786772	914335	0	0
45784618	1112807	0	0
45797881	1115008	0	0
46293606	1174888	0	0
46244225	1310149	0	0
46289835	1115008	0	0
46290428	42707627	2	3
45791697	1125315	0	0
46308311	1125315	0	0
4042645	4163951	2	2
77960	78272	3	6
21601120	1308738	2	2
21502709	1112807	7	7
35508981	1115171	2	3
36157373	1154343	0	0
36217216	40174880	2	3
36517140	40479422	4	4
42803279	1119510	0	0
44342182	1112807	0	0
44361403	1115171	2	3
44337577	19128009	2	2
45665176	1129625	0	0
44340373	1110410	0	0
45662563	19078461	2	3
45623329	1177480	0	0
45648164	933724	0	0
45627463	920293	0	0
45689422	1501700	0	0
45780816	1174888	0	0
45706791	715997	0	0
45677754	975125	0	0
45675266	738818	0	0
45786931	1192710	0	0
45784829	1112807	0	0
45798014	1149196	0	0
46293610	1174888	0	0
46244140	1124957	0	0
46289836	1343916	0	0
46290698	40232448	2	3
45791837	1125315	0	0
46308750	1125315	0	0
4059308	4163971	2	2
4002031	4336464	3	6
21500624	723013	2	2
21502709	1115008	7	7
35508845	40162522	2	3
36157376	1119510	0	0
36208978	3051031	2	3
36517140	40479768	4	4
42803287	975125	0	0
44342305	1192710	0	0
44361462	19008572	2	3
45637521	19128009	2	2
45662295	1129625	0	0
44340374	757627	0	0
45637681	19078461	2	3
45623747	1177480	0	0
45647825	1361711	0	0
45627538	1115008	0	0
45691616	1124300	0	0
45780835	1153428	0	0
45651760	705944	0	0
45677962	1153428	0	0
45676416	1192710	0	0
45786875	1174888	0	0
45784831	1112807	0	0
45797788	1124957	0	0
46293614	1115008	0	0
46244145	914335	0	0
46289839	1326303	0	0
46290863	19073188	2	3
45791786	1125315	0	0
46308612	1125315	0	0
4132552	4112343	2	2
74726	4134304	3	5
21500624	740275	2	2
4247371	4043241	7	8
35502093	140673	2	3
36157376	738818	0	0
36208195	3005136	2	3
36517012	40479422	4	4
42803295	1124300	0	0
44342007	1124300	0	0
44361374	19059056	2	3
45656037	19128022	1	2
45662697	1129625	0	0
44340379	705944	0	0
45641351	19078461	2	3
45623640	1177480	0	0
45648233	1332418	0	0
45627539	738818	0	0
45691511	1738521	0	0
45780914	1174888	0	0
45651472	1310149	0	0
45678050	1501700	0	0
45676338	975125	0	0
45786850	1521369	0	0
45782402	1112807	0	0
45797814	1545958	0	0
46293719	1713332	0	0
46244146	791967	0	0
46289842	975125	0	0
46290718	19078924	2	3
45791671	1125315	0	0
46308617	1125315	0	0
4132552	198809	2	2
193460	4152936	3	5
21500624	19074679	2	2
21500120	40173590	9	10
35506609	4144583	2	3
36157379	1115008	0	0
36208195	3036780	2	3
36517012	40479768	4	4
42803298	1545958	0	0
44342532	1332418	0	0
44361193	1115171	2	3
45656037	19128263	1	2
45662728	1129625	0	0
44340382	1107830	0	0
45652927	19078461	2	3
45623642	1177480	0	0
45648172	19054876	0	0
45627547	19010482	0	0
45691477	1778162	0	0
45783268	1717327	0	0
45651717	1738521	0	0
45678052	920293	0	0
45676423	1115008	0	0
45786851	1174888	0	0
45783586	1112807	0	0
45797973	1310149	0	0
46293520	1174888	0	0
46244159	1326303	0	0
46289902	1192710	0	0
46290779	40162522	2	3
45791831	1125315	0	0
46308473	1125315	0	0
4044889	4047491	2	2
193460	4149245	3	5
21500612	1343916	2	2
21500120	1551192	9	10
35508948	19008572	2	3
36157397	975125	0	0
36208195	3010813	2	3
36302172	4314290	4	4
42803299	1326303	0	0
44342316	1501700	0	0
44361547	40231925	2	3
44337577	19127918	1	2
45662433	1129625	0	0
44340537	975125	0	0
45640630	19079524	2	3
45623349	1177480	0	0
45648172	1548195	0	0
45627468	1738521	0	0
45691488	1551099	0	0
45783372	1192710	0	0
45651722	1154343	0	0
45677967	1107830	0	0
45676430	1307863	0	0
45786856	1154343	0	0
45782727	1112807	0	0
45797931	738818	0	0
46293809	1153428	0	0
46244161	1154029	0	0
46241667	1192710	0	0
46290814	40232448	2	3
45791729	1125315	0	0
46308660	1125315	0	0
4115260	261325	2	2
77960	4149245	3	4
21500215	1307863	2	2
21500120	1589505	7	7
35509044	40236824	2	3
36157403	1129625	0	0
36208195	3023430	2	3
36517149	4149245	4	4
42803432	1309944	0	0
44337665	723013	0	0
44361702	40229134	2	3
44778030	40174880	2	3
45662887	1129625	0	0
44340540	1000560	0	0
45637740	1332419	2	3
45667537	1177480	0	0
45648172	19127890	0	0
45627555	1310149	0	0
45691566	1501700	0	0
45783389	1174888	0	0
45651762	1521369	0	0
45678079	1310149	0	0
45676293	1000560	0	0
45786787	1124957	0	0
45782769	1112807	0	0
45797717	738818	0	0
46293730	1501700	0	0
46244249	1728416	0	0
46241669	1192710	0	0
46290815	40232448	2	3
45791730	1125315	0	0
46308670	1125315	0	0
4133611	4132546	2	2
75909	4142905	3	4
21503193	1759842	2	2
21500120	1500211	7	7
35509076	40229134	2	3
36157404	1119510	0	0
36217207	19023398	2	3
36211375	378001	4	4
42803435	1124300	0	0
44337826	1153428	0	0
44361679	1115171	2	3
44778286	40232448	2	3
45661355	1129625	0	0
44339943	1729720	0	0
45638234	1332419	2	3
45667886	1177480	0	0
45648173	1396131	0	0
45627560	1154343	0	0
45691579	967823	0	0
45783181	933724	0	0
45651783	1332418	0	0
45679563	738818	0	0
45676367	715997	0	0
45786959	1548195	0	0
45780850	1112807	0	0
45797898	967823	0	0
46293827	742185	0	0
46244149	1000560	0	0
46241637	914335	0	0
46290683	40236824	2	3
45791794	1125315	0	0
46308672	1125315	0	0
4027369	4310024	2	2
4022449	4146173	3	4
21503193	1343916	2	2
21500120	933724	7	7
35509096	40232448	2	3
36157337	1149196	0	0
36217209	43012433	2	3
36211375	375671	4	4
42803247	1729720	0	0
44337827	1149380	0	0
44361399	1115171	2	3
44778271	40231925	2	3
45659340	1129625	0	0
44340472	1110410	0	0
45637862	1332419	2	3
45667202	1177480	0	0
45648061	933724	0	0
45627569	19127890	0	0
45691516	975125	0	0
45783272	791967	0	0
45651691	1332418	0	0
45679713	1521369	0	0
45676370	1124957	0	0
45786960	1713332	0	0
45780948	1112807	0	0
45798044	1153428	0	0
46293735	1174888	0	0
46244228	1192710	0	0
46241568	1309944	0	0
46291113	40229134	2	3
45791795	1125315	0	0
46308674	1125315	0	0
4091532	4266809	2	2
4022201	4142905	3	4
21500216	1309944	2	2
21500120	1551099	7	7
36156889	1115171	2	3
36157448	1129625	0	0
36155989	1545959	2	3
36211065	4134304	4	4
42803439	1119510	0	0
44337832	1192710	0	0
44361522	19008572	2	3
44778219	40229134	2	3
45659676	1129625	0	0
44340473	1307863	0	0
45646620	1332419	2	3
45665512	1177480	0	0
45647981	1124300	0	0
45623707	1192710	0	0
45691609	723013	0	0
45783485	1549786	0	0
45651757	708298	0	0
45679772	1000560	0	0
45676376	1115008	0	0
45786798	1192710	0	0
45780244	1112807	0	0
45798054	1548195	0	0
46293735	1192710	0	0
46244229	1551099	0	0
46241587	975125	0	0
46242371	40232448	2	3
45791754	1125315	0	0
46308714	1125315	0	0
4168644	4174876	2	2
4022201	4237458	3	4
21503143	914335	2	2
21500120	1549786	7	7
36156890	19125062	2	3
36009704	133834	0	0
36150893	1545959	2	3
36500000	4218389	4	4
42803441	975125	0	0
44337836	1174888	0	0
44361351	43012036	2	3
44778069	46275916	2	3
45659504	1129625	0	0
44340476	975125	0	0
45634815	1332419	2	3
45665518	1177480	0	0
45648270	1115008	0	0
45623900	738818	0	0
45691615	914335	0	0
45783485	1595799	0	0
45651641	1107830	0	0
45679627	1124300	0	0
45676379	1539403	0	0
45786886	1192710	0	0
45780315	1112807	0	0
45797819	1112807	0	0
46293837	791967	0	0
46244147	1545958	0	0
46241706	1124957	0	0
46242223	1127433	2	3
45791756	1125315	0	0
46308692	1125315	0	0
4176946	80809	2	2
4022139	4108705	3	4
21503147	1154029	2	2
21500120	19054876	7	7
36156623	1127433	2	3
36151990	1153428	0	0
36156033	1332419	2	3
36211308	4152936	4	4
42803246	1713332	0	0
44337838	933724	0	0
44361309	19008572	2	3
44778070	46275916	2	3
45659464	1129625	0	0
44340039	1174888	0	0
45656594	40174880	2	3
45665846	1177480	0	0
45648225	1549786	0	0
45624029	1154029	0	0
45691722	757627	0	0
45783485	1521369	0	0
45651644	1713332	0	0
45679628	1713332	0	0
45676387	1307863	0	0
45786967	1551099	0	0
45780231	1112807	0	0
45797954	1713332	0	0
46293846	1124957	0	0
46244271	1309944	0	0
46241639	1309944	0	0
46242338	40228214	2	3
45791763	1125315	0	0
46308702	1125315	0	0
4177703	4027663	2	2
4022923	4149245	3	4
21500595	1177480	2	2
21500120	975125	7	7
36157205	40229134	2	3
36152190	1539403	0	0
36150969	19078461	2	3
36603345	4285898	4	4
42803405	1129625	0	0
44337847	1115008	0	0
44357482	40231925	2	3
44358143	43012036	2	3
45656523	1129625	0	0
44340369	738818	0	0
45653115	1545959	2	3
45663129	1177480	0	0
45648225	1589505	0	0
45625137	1309944	0	0
45691742	1115008	0	0
45783501	1149196	0	0
45651644	1759842	0	0
45679628	1759842	0	0
45676477	914335	0	0
45786975	1000560	0	0
45777738	1112807	0	0
45797903	1124300	0	0
46288767	1112807	0	0
46244293	1717327	0	0
46241625	723013	0	0
46242356	40229134	2	3
45791769	1125315	0	0
46312106	1125315	0	0
4058419	4323208	2	2
4004041	4336464	3	4
21500595	1124300	2	2
4274025	4299128	5	5
36156878	35605858	2	3
36151910	1119510	0	0
36155793	19078461	2	3
36211088	78272	4	4
42803087	1759842	0	0
44337684	1112807	0	0
44357494	19133905	2	3
44357923	19059056	2	3
45656353	1129625	0	0
44340543	1149380	0	0
45647197	1545959	2	3
45663242	1177480	0	0
45648232	1174888	0	0
45625180	1174888	0	0
45691658	1332418	0	0
45780995	1557272	0	0
45651646	1595799	0	0
45679630	1500211	0	0
45676298	1110410	0	0
45786900	1174888	0	0
45777778	1112807	0	0
45797980	738818	0	0
46288619	1738521	0	0
46244380	1738521	0	0
46241740	1192710	0	0
46239615	40232448	2	3
45789048	1125315	0	0
46312186	1125315	0	0
4090615	78272	2	2
193460	4059173	3	4
21500595	1129625	2	2
4274025	442116	5	6
36157062	1115171	2	3
36152267	1129625	0	0
36155906	19078461	2	3
36502199	80502	4	4
42803087	1713332	0	0
44338018	791967	0	0
44357502	40229134	2	3
44359132	42707627	2	3
45656463	1129625	0	0
44340512	1118084	0	0
45641598	1539411	2	3
45663021	1177480	0	0
45648273	738818	0	0
45625186	1332418	0	0
45691661	1174888	0	0
45780998	1000560	0	0
45651326	1174888	0	0
45679631	1149196	0	0
45672259	1738521	0	0
45786903	1717327	0	0
45706371	1112807	0	0
45798040	1343916	0	0
46288881	1549786	0	0
46244373	1192710	0	0
46241745	1118084	0	0
46239621	19059056	2	3
45788965	1125315	0	0
46312205	1125315	0	0
4042835	4283893	2	2
193460	4109685	3	4
21500604	1115008	2	2
4274025	439406	5	6
35507067	46275916	2	3
36152267	1112807	0	0
36151342	19078461	2	3
36211677	4084167	4	4
42803088	1112807	0	0
44337733	1759842	0	0
44357714	46275916	2	3
44359180	1115171	2	3
45656624	1129625	0	0
44340486	1115008	0	0
45659558	1539411	2	3
45663249	1177480	0	0
45647860	705944	0	0
45625245	1174888	0	0
45691663	1115008	0	0
45781031	1551099	0	0
45651327	1174888	0	0
45679639	791967	0	0
45672304	1332418	0	0
45786904	1115008	0	0
45706486	1112807	0	0
45797993	1545958	0	0
46288889	1310149	0	0
46244194	1153428	0	0
46241748	975125	0	0
46240237	40229134	2	3
45789003	1125315	0	0
46312350	1125315	0	0
4042835	4156265	2	2
1548195	40221415	3	4
21500604	1125315	2	2
4274025	4306014	5	6
35507212	1115171	2	3
36151910	738818	0	0
36154974	40228214	2	3
36516993	317576	4	4
42803145	1539403	0	0
44363691	1343916	0	0
44354569	40232448	2	3
44359185	43012036	2	3
45652995	1129625	0	0
44340494	920293	0	0
45665241	1539411	2	3
45663466	1177480	0	0
45648287	1322184	0	0
45625194	975125	0	0
45691435	1519936	0	0
45781032	738818	0	0
45651329	1124957	0	0
45679716	1589505	0	0
45671925	1551099	0	0
45786908	975125	0	0
45706443	1112807	0	0
45797824	1115008	0	0
46288461	1738521	0	0
46244258	1149196	0	0
46241691	1738521	0	0
45896227	1115171	2	3
45789006	1125315	0	0
46312287	1125315	0	0
4152154	4202451	2	2
73553	4149245	3	3
21500604	1124300	2	2
4274025	4156265	5	7
36212328	19128022	2	3
36151911	1177480	0	0
36155203	40228214	2	3
36211325	4156265	4	4
42803184	1125315	0	0
44363312	1115008	0	0
44350813	1551192	2	3
44358931	19008572	2	3
45652923	1129625	0	0
44340417	1115008	0	0
45653553	1539411	2	3
45660111	1177480	0	0
45648115	1308738	0	0
45625195	1545958	0	0
45691527	1308738	0	0
45781044	1192710	0	0
45651331	1107830	0	0
45679242	1000560	0	0
45671926	975125	0	0
45786433	1107830	0	0
45706604	1112807	0	0
45797998	1713332	0	0
46288372	1153428	0	0
46244199	1738521	0	0
46241674	1124957	0	0
45896231	19019273	2	3
45789057	1125315	0	0
46312430	1125315	0	0
4176801	4057420	2	2
77960	80809	3	3
21500653	1112807	2	2
4274025	4230399	7	10
35508397	19019273	2	3
36151911	1129625	0	0
36224185	19127904	2	3
36211325	4230399	4	4
42803112	1332418	0	0
44363669	1177480	0	0
44350612	1115171	2	3
44358396	40162522	2	3
45652937	1129625	0	0
44340502	1332418	0	0
45632431	19079524	1	1
45634196	1112807	0	0
45648192	1154029	0	0
45625198	1149196	0	0
45689757	1000560	0	0
45781051	738818	0	0
45651338	1501700	0	0
45679565	1551099	0	0
45672201	1000560	0	0
45786434	975125	0	0
45703245	1112807	0	0
45797998	1759842	0	0
46288866	1112807	0	0
46244202	1000560	0	0
46241766	705944	0	0
45896253	19126352	2	3
45788949	1125315	0	0
46311837	1125315	0	0
4172515	4107731	2	3
77960	4146173	3	3
21500653	1125315	2	2
4274025	40479768	7	9
35508775	19019273	2	3
36152105	1119510	0	0
36151177	1107882	2	3
36211315	40479768	4	4
42802260	1557272	0	0
44363708	1326303	0	0
44350419	40232448	2	3
44358420	1127433	2	3
45653178	1129625	0	0
44340611	1332418	0	0
45632271	19079524	1	1
45634084	1112807	0	0
45648254	1343916	0	0
45625201	1174888	0	0
45689701	1174888	0	0
45781052	1115008	0	0
45651341	1000560	0	0
45674500	1713332	0	0
45672202	967823	0	0
45786577	753626	0	0
45703095	1112807	0	0
45798005	1107830	0	0
46288867	1124300	0	0
46244203	1124957	0	0
46241764	1539403	0	0
45896240	40232448	2	3
45789144	1125315	0	0
46311838	1125315	0	0
4101219	4285898	2	3
432795	4094814	3	3
21500643	19003953	2	2
4274025	4144583	7	7
21603453	40229134	2	3
36152294	1539403	0	0
36155937	1107882	2	3
36211315	40479422	4	4
42802245	1307863	0	0
44363716	1361711	0	0
44350711	40232448	2	3
44358369	782047	2	3
45653352	1129625	0	0
44340636	19127890	0	0
45623345	19079524	1	1
45629132	1112807	0	0
45648257	933724	0	0
45625145	1521369	0	0
45689703	1124957	0	0
45781055	1124957	0	0
45651461	715997	0	0
45674623	740275	0	0
45671909	738818	0	0
45786579	1539403	0	0
45703099	1112807	0	0
45798007	1115008	0	0
46288816	1174888	0	0
46244347	757627	0	0
46242602	1174888	0	0
45896396	19008572	2	3
45789138	1125315	0	0
46311912	1125315	0	0
4115106	4285898	2	3
432795	381316	3	3
21001758	19133905	2	3
4274025	375671	6	10
36156644	40228214	2	3
36152297	1124300	0	0
36150763	1107882	2	3
36000000	4169137	4	4
42802303	1124300	0	0
44363717	933724	0	0
44350517	40236824	2	3
44358474	1127433	2	3
45653151	1129625	0	0
44340636	1515774	0	0
45665452	19079524	1	1
45628973	1112807	0	0
45648258	1115008	0	0
45625145	1595799	0	0
45689795	1107830	0	0
45781025	1307863	0	0
45651447	1310149	0	0
45674625	1174888	0	0
45672188	1124957	0	0
45786583	975125	0	0
45703219	1112807	0	0
45799744	738818	0	0
46288881	1589505	0	0
46244350	975125	0	0
46242611	1307863	0	0
45896342	1310034	2	3
45789032	1125315	0	0
46311997	1125315	0	0
4042835	40481087	2	3
432586	440086	3	3
21001758	19133873	2	3
4274025	4146173	6	8
35509025	1107882	2	3
36152299	738818	0	0
36156485	1107882	2	3
36211303	4299128	4	4
42802273	1307863	0	0
44363475	1124300	0	0
44350532	40232448	2	3
44358612	46275916	2	3
45653276	1129625	0	0
44340636	1549786	0	0
45626583	19079524	1	1
45629269	1112807	0	0
45648022	1548195	0	0
45625145	1549786	0	0
45689765	738818	0	0
45781143	1174888	0	0
45651449	791967	0	0
45674583	1589505	0	0
45672243	1107830	0	0
45785255	967823	0	0
45700010	1112807	0	0
45795188	967823	0	0
46288900	1115008	0	0
46239174	975125	0	0
46242578	1501700	0	0
45896607	920334	2	3
45789148	1125315	0	0
46311999	1125315	0	0
4027384	198809	2	6
432586	378419	3	3
21003223	40232448	2	3
4274025	433125	6	6
36156637	19078461	2	3
36152412	1549786	0	0
36207527	3000963	2	3
36211303	4296205	4	4
42802282	1153428	0	0
44363412	1112807	0	0
44350685	19076374	2	3
44358656	19073183	2	3
45653345	1129625	0	0
44340462	967823	0	0
45665375	19079524	1	1
45627888	1112807	0	0
45648026	1322184	0	0
45625215	738818	0	0
45689745	791967	0	0
45781013	1115008	0	0
45651462	738818	0	0
45674585	967823	0	0
45672311	791967	0	0
45785306	1738521	0	0
45700030	1112807	0	0
45795158	1713332	0	0
46288632	1192710	0	0
46239394	1713332	0	0
46242566	1153428	0	0
45896610	43012036	2	3
46301922	1125315	0	0
46308790	1125315	0	0
4028902	4037675	5	6
443883	4294548	3	3
21003185	46275916	2	3
4274025	4237458	6	9
36156620	19079524	2	3
36151913	1118084	0	0
36207527	3006906	2	3
36300000	4191853	4	4
42802332	1124300	0	0
44363417	920293	0	0
44350522	19133873	2	3
44358661	1115171	2	3
45653133	1129625	0	0
44340197	1174888	0	0
45626391	19079524	1	1
45627984	1112807	0	0
45648127	1332418	0	0
45625220	791967	0	0
45689749	19127890	0	0
45780980	1500211	0	0
45651463	1548195	0	0
45674691	19002770	0	0
45672199	1361711	0	0
45785340	1192710	0	0
45697125	1112807	0	0
45795151	967823	0	0
46288644	1115008	0	0
46239358	1713332	0	0
46241837	1118084	0	0
45893954	40236824	2	3
46301961	1125315	0	0
46308813	1125315	0	0
4172024	433644	5	6
200174	134438	3	3
21002670	46233710	2	3
4274025	4059173	6	9
36156671	19079524	2	3
36151923	1119510	0	0
36207527	3014576	2	3
36206173	3028833	5	5
42802309	723013	0	0
44363673	1112807	0	0
44350713	1115171	2	3
44351379	19133905	2	3
45653114	1129625	0	0
44340200	1713332	0	0
45647284	19079524	1	1
45626121	1112807	0	0
45644802	1102527	0	0
45625238	1000560	0	0
45689749	1589505	0	0
45780982	1174888	0	0
45651705	753626	0	0
45674706	1589505	0	0
45672327	1192710	0	0
45785309	1174888	0	0
45697043	1112807	0	0
45795189	1107830	0	0
46288648	1124300	0	0
46239372	1000560	0	0
46241850	1545958	0	0
45894024	1127433	2	3
46301965	1125315	0	0
46303622	1125315	0	0
4091532	81893	5	6
197917	198809	3	3
21002455	46275444	2	3
21500972	1149380	2	2
36157232	1545959	2	3
36151927	1177480	0	0
36207527	3009542	2	3
36206173	3020655	6	6
42802295	1154029	0	0
44363356	1124300	0	0
44350721	19073188	2	3
44351293	40229134	2	3
45653216	1129625	0	0
44340334	1118084	0	0
45626240	19079524	1	1
45626130	1112807	0	0
45644789	1192710	0	0
45625312	1738521	0	0
45689749	1549786	0	0
45780987	1107830	0	0
45652199	738818	0	0
45674711	1118084	0	0
45672263	1500211	0	0
45785283	1174888	0	0
45693900	1112807	0	0
45795194	738818	0	0
46288656	1115008	0	0
46239373	1557272	0	0
46241863	1107830	0	0
45894025	1127433	2	3
46301827	1125315	0	0
46303312	1125315	0	0
4091363	4112343	5	6
4021915	439777	3	3
21002421	46275444	2	3
21500972	1129625	2	2
36156867	19078461	2	3
36152361	975125	0	0
36150937	19078461	2	3
36206173	3007461	3	7
42802394	715997	0	0
44363507	1124300	0	0
44351071	40232448	2	3
44351356	40229134	2	3
45649975	1129625	0	0
44340602	708298	0	0
45623116	19079524	1	1
45626148	1112807	0	0
45644786	19127890	0	0
45625155	1149196	0	0
45689772	1551099	0	0
45780989	967823	0	0
45652200	1154343	0	0
45674714	1713332	0	0
45672432	1501700	0	0
45785283	1192710	0	0
45694055	1112807	0	0
45795323	1549786	0	0
46288825	1115008	0	0
46239435	1174888	0	0
46241838	1192710	0	0
45894026	1127433	2	3
46298967	1125315	0	0
46303279	1125315	0	0
4042836	378001	5	6
4021780	195588	3	3
21003454	40224132	2	3
21500972	975125	2	2
35509015	19078461	2	3
36152363	975125	0	0
36211065	4230399	2	3
36206173	3014576	3	7
42802406	1000560	0	0
44363762	1000560	0	0
44351079	19059056	2	3
44351429	40236824	2	3
45649991	1129625	0	0
44340605	1332418	0	0
45657041	19079524	1	1
45626375	1112807	0	0
45644786	1521369	0	0
45625202	1332418	0	0
45689841	1557272	0	0
45780990	1746114	0	0
45652301	1107830	0	0
45674714	1759842	0	0
45672051	1174888	0	0
45785284	1115008	0	0
45690966	1112807	0	0
45795323	19127890	0	0
46288830	1115008	0	0
46239578	1149196	0	0
46241887	19010482	0	0
45894027	1127433	2	3
46299548	1125315	0	0
46303442	1125315	0	0
4115259	258780	5	5
4022571	28060	3	3
21003454	1519937	2	3
4179713	4163971	2	2
36156949	40228214	2	3
36152365	1149196	0	0
36224164	42902245	2	3
36206173	3045716	3	7
42802410	791967	0	0
44363806	1149380	0	0
44348529	1127433	2	3
44351514	1551192	2	3
45646780	1129625	0	0
44340203	738818	0	0
45641661	19079524	1	1
45622762	1112807	0	0
45644786	1549786	0	0
45624124	967823	0	0
45689708	738818	0	0
45780990	1741122	0	0
45652256	1107830	0	0
45674835	1124300	0	0
45672052	1343916	0	0
45785359	1367571	0	0
45688086	1112807	0	0
45795323	1521369	0	0
46288842	1107830	0	0
46239457	1545958	0	0
46241871	1309944	0	0
45894028	1127433	2	3
46299549	1125315	0	0
46303452	1125315	0	0
4177703	81893	5	5
4020347	78272	3	3
21003454	40224805	2	3
21600985	1322184	2	2
36218510	40221415	2	3
36152368	975125	0	0
36151049	19123231	2	3
36206173	3026361	3	8
42802418	19127890	0	0
44363811	1177480	0	0
44348654	40236824	2	3
44351616	1127433	2	3
45647131	1129625	0	0
44340357	1153428	0	0
45632281	19079524	1	1
45623179	1112807	0	0
45644990	967823	0	0
45624125	1500211	0	0
45689659	1332418	0	0
45781015	1115008	0	0
45651978	1595799	0	0
45674957	1192710	0	0
45672271	1343916	0	0
45785299	1112807	0	0
45688088	1112807	0	0
45795109	1326303	0	0
46291628	975125	0	0
46239532	1124957	0	0
46241814	1322184	0	0
45894122	782047	2	3
46299384	1125315	0	0
46303719	1125315	0	0
4132647	4336464	5	5
444089	196456	3	3
21003454	44816277	2	3
21600985	1112807	2	2
35508889	40228214	2	3
36157452	933724	0	0
36224165	42902245	2	3
36502202	80180	4	4
42802418	1521369	0	0
44363813	1343916	0	0
44347072	40236824	2	3
44351559	35605482	2	3
45647137	1129625	0	0
44340608	1124300	0	0
45644543	19079524	1	1
45623103	1112807	0	0
45644852	791967	0	0
45624128	1308738	0	0
45689899	1305058	0	0
45781064	738818	0	0
45651978	1521369	0	0
45674958	1174888	0	0
45672331	975125	0	0
45785314	1326303	0	0
45688131	1112807	0	0
45795112	1310149	0	0
46291631	1192710	0	0
46239540	1332418	0	0
46241818	1738521	0	0
45894097	19133905	2	3
46299553	1125315	0	0
46303722	1125315	0	0
4028908	4024958	5	5
1176472	3023103	2	2
21002671	19008572	2	3
4187630	45766064	2	2
35509157	19079524	2	3
36157453	1129625	0	0
36151074	1545959	2	3
36502202	381316	5	5
42802418	1549786	0	0
44363817	738818	0	0
44346976	1551192	2	3
44351466	19133905	2	3
45646891	1129625	0	0
44340224	1107830	0	0
45667849	19079524	1	1
45621504	1112807	0	0
45644894	1307863	0	0
45624129	1729720	0	0
45689666	738818	0	0
45780450	1332418	0	0
45651978	1549786	0	0
45674953	715997	0	0
45672445	1149196	0	0
45785304	705944	0	0
45688190	1112807	0	0
45795197	1307863	0	0
46290991	1778162	0	0
46239458	791967	0	0
46241851	723013	0	0
45894097	19133873	2	3
46299178	1125315	0	0
46303114	1125315	0	0
4042835	4048171	5	5
1176472	3016723	2	2
21500645	42707627	2	3
21604793	836654	2	2
35509152	19078461	2	3
36157457	1118084	0	0
36155267	1545959	2	3
36502202	80809	5	5
42802384	1551099	0	0
44363817	1112807	0	0
42804388	1177480	0	0
44351775	43012036	2	3
45646710	1129625	0	0
44340450	715997	0	0
45663375	19079524	1	1
45667461	1112807	0	0
45644895	738818	0	0
45624137	1192710	0	0
45689678	1174888	0	0
45780454	967823	0	0
45652013	1713332	0	0
45674734	1361711	0	0
45672343	914335	0	0
45785323	791967	0	0
45688247	1112807	0	0
45795221	1500211	0	0
46291655	1112807	0	0
46239459	975125	0	0
46242004	1551099	0	0
45894062	19019273	2	3
46299396	1125315	0	0
46303115	1125315	0	0
4029205	4062501	5	5
444089	195588	2	2
21500599	19007333	2	3
4179873	80180	2	2
35506858	19078461	2	3
36157757	1192710	0	0
36150758	1551192	2	3
36502202	80502	5	5
42802362	1177480	0	0
44363831	738818	0	0
42804389	1177480	0	0
44351820	40236824	2	3
45647119	1129625	0	0
44340324	738818	0	0
45660084	46275916	1	1
45665265	1112807	0	0
45644896	1551099	0	0
45624149	1521369	0	0
45689680	1326303	0	0
45780692	1343916	0	0
45652013	1759842	0	0
45674737	1759842	0	0
45672281	1332418	0	0
45785354	1551099	0	0
45688313	1112807	0	0
45795199	914335	0	0
46291783	1545958	0	0
46239686	1000560	0	0
46241831	1548195	0	0
45894164	40236824	2	3
46299210	1125315	0	0
46303814	1125315	0	0
4029205	40478878	5	5
73553	4146173	2	2
21502881	19007333	2	3
4179873	317576	2	2
35508924	1332419	2	3
36157761	1119510	0	0
36151340	19019273	2	3
36502202	4310024	4	6
42802386	1500211	0	0
44363922	1177480	0	0
42804430	1551099	0	0
44351362	40163554	2	3
45647121	1129625	0	0
44340346	1551099	0	0
45660084	19079524	1	1
45665338	1112807	0	0
45644900	933724	0	0
45624149	1549786	0	0
45689684	975125	0	0
45778579	723013	0	0
45651914	1332418	0	0
45674737	1713332	0	0
45672353	1551099	0	0
45785317	1115008	0	0
45684697	1112807	0	0
45795200	933724	0	0
46291306	1153428	0	0
46239548	1115008	0	0
45897899	1115008	0	0
45801567	19019273	2	3
46298815	1125315	0	0
46303618	1125315	0	0
4029205	44805732	5	5
73553	4035415	2	2
21500203	19018935	2	3
21500851	1713671	2	2
36156536	1545959	2	3
36157761	1192710	0	0
36155808	19018935	2	3
36502202	40486433	6	6
42802527	1119510	0	0
44363998	1149380	0	0
42804205	1332418	0	0
44351869	40232448	2	3
45647128	1129625	0	0
44340356	1124300	0	0
45663287	19079524	1	1
45665038	1112807	0	0
45644902	967823	0	0
45624154	967823	0	0
45689871	738818	0	0
45778592	1713332	0	0
45651914	1545958	0	0
45674741	1115008	0	0
45672354	1545958	0	0
45785473	967823	0	0
45685021	1112807	0	0
45795352	1515774	0	0
46288949	1539403	0	0
46239638	791967	0	0
45897902	1738521	0	0
46240275	19078461	2	3
46298847	1125315	0	0
46303754	1125315	0	0
4086181	4043241	7	8
444090	4109685	2	2
21003205	40232448	2	3
21500027	1738521	2	2
35506817	1545959	2	3
36157524	1129625	0	0
36151362	42707627	2	3
36502202	317576	6	6
42802375	1124300	0	0
44363987	1545958	0	0
42804282	1738521	0	0
44343976	19019273	2	3
45647142	1129625	0	0
44340442	1545958	0	0
45663287	46275916	1	1
45665360	1112807	0	0
45644922	738818	0	0
45624143	1332418	0	0
45689685	914335	0	0
45778592	1759842	0	0
45652062	1515774	0	0
45674757	1124957	0	0
45672290	967823	0	0
45785581	1713332	0	0
45684713	1112807	0	0
45795352	1549786	0	0
46288920	1149196	0	0
46239639	1192710	0	0
45897903	1738521	0	0
45790827	1545959	2	3
46299007	1125315	0	0
46303779	1125315	0	0
4029205	4047491	7	8
77635	4113008	2	2
21002332	920300	2	3
4042678	4216130	2	2
36217210	35605482	2	3
36157313	1107830	0	0
36154962	40236446	2	3
36502202	4280726	6	6
42802441	975125	0	0
44363359	1149380	0	0
42804477	1500211	0	0
44343831	40228230	2	3
45647199	1129625	0	0
44340443	1149196	0	0
45641742	19079524	1	1
45662465	1112807	0	0
45644924	1000560	0	0
45624203	933724	0	0
45689692	975125	0	0
45778624	1149196	0	0
45652062	19127890	0	0
45674659	738818	0	0
45672097	975125	0	0
45785581	1759842	0	0
45684787	1112807	0	0
45795352	19127890	0	0
46288931	967823	0	0
46239554	1332418	0	0
45897978	1124957	0	0
46290560	19019273	2	3
46299511	1125315	0	0
46303320	1125315	0	0
4042140	40479768	7	10
433128	40480160	2	2
21002332	920334	2	3
4077953	4035793	2	2
36217216	1713671	2	3
36157511	1309944	0	0
36210656	3000963	2	3
36502202	4134304	7	10
42802529	1738521	0	0
44363360	1521369	0	0
42804421	1125315	0	0
44343895	40232448	2	3
45646987	1129625	0	0
44340581	1332418	0	0
45626544	19079524	1	1
45662892	1112807	0	0
45644931	1115008	0	0
45624523	975125	0	0
45689694	1115008	0	0
45778637	1738521	0	0
45652062	1549786	0	0
45674592	975125	0	0
45672458	1149196	0	0
45785584	975125	0	0
45682053	1112807	0	0
45795416	1332418	0	0
46288932	1124300	0	0
46239515	1713332	0	0
45897961	1107830	0	0
46244225	40163554	2	3
46299240	1125315	0	0
46303697	1125315	0	0
4042140	40479422	7	10
433128	4066995	2	2
21002475	40224132	2	3
4300244	4337138	2	2
36217216	19019273	2	3
36157347	1129625	0	0
36210656	3016723	2	3
36502202	40479768	6	10
42802514	933724	0	0
44363360	1549786	0	0
42804421	1124957	0	0
44343995	1594382	2	3
45645773	1129625	0	0
44340600	1332418	0	0
45659649	19079524	1	1
45662911	1112807	0	0
45644933	1118084	0	0
45624185	1549786	0	0
45689853	1115008	0	0
45778587	1539403	0	0
45652392	1115008	0	0
45674634	1307863	0	0
45672565	1326303	0	0
45785454	1521369	0	0
45682160	1112807	0	0
45795417	1192710	0	0
46288936	1557272	0	0
46239515	1759842	0	0
45897962	1174888	0	0
46243886	40163554	2	3
46299522	1125315	0	0
46303971	1125315	0	0
4042140	133834	7	9
443784	381316	2	2
21002475	40224805	2	3
21600972	1367571	2	2
36217214	19019979	2	3
36157353	1129625	0	0
36210656	3024561	2	3
36502202	40479422	6	10
42802532	1177480	0	0
44363365	1308738	0	0
42804422	1125315	0	0
44344029	19008572	2	3
45645946	1129625	0	0
44337263	1539403	0	0
45626114	19079524	1	1
45662936	1112807	0	0
45645012	738818	0	0
45624185	1515774	0	0
45689864	1549786	0	0
45778618	1343916	0	0
45652264	1149196	0	0
45674874	742185	0	0
45672389	1332418	0	0
45785586	1332418	0	0
45682015	1112807	0	0
45795419	1149196	0	0
46288935	705944	0	0
46239702	1149196	0	0
45897804	705944	0	0
45804361	40163554	2	3
46299251	1125315	0	0
46304015	1125315	0	0
4088727	4125906	1	1
197917	196456	2	2
21004035	19076374	2	3
21500098	1305058	2	2
36217214	19075001	2	3
36157355	1154029	0	0
36154987	1154615	2	3
36502202	78272	5	10
42802605	1589505	0	0
44363421	967823	0	0
42804422	1124957	0	0
44344074	46275916	2	3
45643877	1129625	0	0
44337290	1778162	0	0
45621446	19079524	1	1
45664352	1112807	0	0
45645022	1551099	0	0
45624191	1124957	0	0
45689864	19127890	0	0
45778595	1107830	0	0
45652307	1124300	0	0
45674648	1551099	0	0
45672402	1717327	0	0
45785482	1149196	0	0
45705081	1177480	0	0
45795500	1738521	0	0
46289108	1124300	0	0
46239324	1149196	0	0
45897805	1000560	0	0
46244386	1332419	2	3
46301569	1125315	0	0
46304024	1125315	0	0
4098879	4198190	1	1
78831	4059173	2	2
21001751	19073188	2	3
4042646	4145310	2	2
36217214	1107882	2	3
36157361	1119510	0	0
36155154	40232448	2	3
36502202	4296204	4	7
42802605	1549786	0	0
44364013	1539403	0	0
42804471	920293	0	0
44344240	40162522	2	3
45644004	1129625	0	0
44337399	1115008	0	0
45650401	19079524	1	1
45664561	1112807	0	0
45644936	1124957	0	0
45624142	1332418	0	0
45686619	975125	0	0
45778604	1149196	0	0
45652315	1115008	0	0
45674955	1192710	0	0
45672403	1322184	0	0
45785399	740275	0	0
45705294	1177480	0	0
45795242	1112807	0	0
46289280	1192710	0	0
46239325	1124957	0	0
45897993	1539403	0	0
46244129	40163554	2	3
46301578	1125315	0	0
46303914	1125315	0	0
4178452	4144583	1	1
75053	4142905	2	2
21002374	46233988	2	3
4042646	4238715	2	2
36217214	46233710	2	3
36157361	1129625	0	0
36154677	1127433	2	3
36502202	4155034	7	7
42902702	40169216	0	0
44364017	1332418	0	0
42804400	914335	0	0
44344172	19019273	2	3
45644217	1129625	0	0
44337339	1000560	0	0
45635418	19079524	1	1
45659803	1112807	0	0
45644869	1149196	0	0
45624156	1322184	0	0
45686785	1589505	0	0
45778605	920293	0	0
45651797	1343916	0	0
45675053	1589505	0	0
45672463	975125	0	0
45785403	1112807	0	0
45779987	1177480	0	0
45795431	1521369	0	0
46289008	1738521	0	0
46239326	1174888	0	0
45897883	1308738	0	0
45792063	46233710	2	3
46301646	1125315	0	0
46303918	1125315	0	0
4149795	4059978	1	1
75865	4116491	2	2
21002374	46233710	2	3
21601079	1595799	2	2
36217214	19019273	2	3
36157363	1174888	0	0
36155061	1115171	2	3
36502202	4048171	7	7
42804136	1118084	0	0
44363533	1124957	0	0
42804242	1326303	0	0
44344687	19008572	2	3
45644236	1129625	0	0
44337410	1124957	0	0
45635418	46275916	1	1
45657177	1112807	0	0
45644806	1149196	0	0
45624226	1308738	0	0
45686785	1549786	0	0
45778606	1124957	0	0
45651860	705944	0	0
45675055	1124957	0	0
45672466	1361711	0	0
45785589	1149196	0	0
45780104	1177480	0	0
45795433	1112807	0	0
46289316	1149196	0	0
46239579	1512674	0	0
45897887	967823	0	0
46242317	1332419	2	3
46301851	1125315	0	0
46300925	1125315	0	0
4151199	4237458	1	1
75128	4142905	2	2
21003421	46233710	2	3
21601079	1396131	2	2
36217214	1713671	2	3
36157364	1119510	0	0
36155215	19008572	2	3
36502202	4113008	7	7
42804188	1713332	0	0
44363991	1107830	0	0
42804245	1322184	0	0
44344425	19008572	2	3
45641127	1129625	0	0
44337411	1107830	0	0
45662917	19079524	1	1
45656730	1112807	0	0
45645027	1192710	0	0
45624198	1549786	0	0
45686546	1115008	0	0
45778612	1110410	0	0
45697737	1115008	0	0
45675056	740275	0	0
45672567	914335	0	0
45785412	782043	0	0
45780020	1177480	0	0
45795435	1174888	0	0
46289317	1124957	0	0
46239579	1549786	0	0
45897946	1713332	0	0
45796549	40163554	2	3
46301813	1125315	0	0
46300875	1125315	0	0
4151202	4142905	1	1
443583	81151	2	2
21003421	46233988	2	3
4034850	4012477	2	2
21602818	19073188	2	5
36157554	1149196	0	0
36155230	19018935	2	3
36502202	4230399	8	9
42804111	708298	0	0
44363994	1124300	0	0
42804303	1396131	0	0
44337523	40236824	2	3
45641165	1129625	0	0
44337319	1000560	0	0
45632171	19079524	1	1
45653407	1112807	0	0
45645097	920293	0	0
45624198	1521369	0	0
45686552	791967	0	0
45778613	738818	0	0
45697861	1332418	0	0
45675037	1539403	0	0
45672568	967823	0	0
45785370	1107830	0	0
45780054	1177480	0	0
45795441	1310149	0	0
46288974	1000560	0	0
46239580	1192710	0	0
45895744	1738521	0	0
45801453	1713671	2	3
46295832	1125315	0	0
46300876	1125315	0	0
4149519	4012477	1	1
193666	4230399	2	2
21001753	19074841	2	3
21500909	1343916	2	2
21602818	19133905	2	5
36157387	1000560	0	0
36155275	19008572	2	3
36502202	81151	5	9
42804168	1713332	0	0
44363511	1713332	0	0
42804356	1124300	0	0
44337556	1594382	2	3
45641299	1129625	0	0
44337348	1118084	0	0
45665408	19079524	1	1
45653826	1112807	0	0
45645099	1539403	0	0
45624165	1192710	0	0
45686555	1551099	0	0
45778719	1000560	0	0
45697862	1154343	0	0
45675001	1539403	0	0
45672569	975125	0	0
45785452	753626	0	0
45780113	1177480	0	0
45795285	1149196	0	0
46288940	1501700	0	0
46239674	1000560	0	0
45895786	1115008	0	0
45793188	19078461	2	3
46296075	1125315	0	0
46300885	1125315	0	0
4149530	4010253	1	1
195771	4144583	2	2
21001753	19074843	2	3
21500909	1738521	2	2
21602818	19133873	2	5
36157426	1115008	0	0
36156317	1551192	2	3
36502202	4149245	5	9
42804168	1759842	0	0
44363623	1307863	0	0
42804357	1124300	0	0
44337651	40236446	2	3
45641237	1129625	0	0
44337353	1115008	0	0
45665366	19079524	1	1
45653710	1112807	0	0
45645092	1115008	0	0
45637384	1125315	0	0
45686556	1746114	0	0
45778639	19002770	0	0
45700778	1738521	0	0
45674976	1174888	0	0
45672580	1545958	0	0
45785465	1305058	0	0
45706102	1177480	0	0
45795287	1115008	0	0
46288946	1322184	0	0
46239444	975125	0	0
45895790	1153428	0	0
45798757	19019273	2	3
46296104	1125315	0	0
46301811	1125315	0	0
4152129	4197460	1	1
195856	198809	2	2
21001769	46233988	2	3
4042673	4216130	2	2
21602818	19073183	2	5
36157430	1153428	0	0
36156552	19123231	2	3
36502202	4152936	7	9
42804154	1322184	0	0
44363624	738818	0	0
42804415	1729720	0	0
44337594	19008572	2	3
45641247	1129625	0	0
44337401	1310149	0	0
45647249	19079524	1	1
45650266	1112807	0	0
45645087	1332418	0	0
45637337	1125315	0	0
45686556	1741122	0	0
45778642	1174888	0	0
45700720	1000560	0	0
45674879	738818	0	0
45672469	1115008	0	0
45785573	1118084	0	0
45706173	1177480	0	0
45795292	1713332	0	0
46288976	1332418	0	0
46239447	1149380	0	0
45895747	1149380	0	0
45801461	40174880	2	3
46295741	1125315	0	0
46301663	1125315	0	0
4152932	4155034	1	1
4022173	4108705	2	2
21001769	46233710	2	3
21500094	742185	2	2
21602515	40221415	2	5
36157437	1129625	0	0
36223493	40221415	2	3
36502202	4059173	7	8
42804118	1177480	0	0
44363625	1738521	0	0
42804416	920293	0	0
44337586	1127433	2	3
45642972	1129625	0	0
44337354	1738521	0	0
45667570	19079524	1	1
45650389	1112807	0	0
45644888	1539403	0	0
45621844	1125315	0	0
45686602	1549786	0	0
45778764	1539403	0	0
45700722	791967	0	0
45674882	1124300	0	0
45672571	791967	0	0
45785677	967823	0	0
45706184	1177480	0	0
45795293	1115008	0	0
46288983	933724	0	0
46239755	1192710	0	0
45895757	19003953	0	0
46294669	46233710	2	3
46295934	1125315	0	0
46301628	1125315	0	0
4152932	4113008	1	1
1177480	19019979	2	3
21506167	19019273	2	3
4046698	4336464	2	2
21603445	19112599	2	5
36157412	1129625	0	0
36223494	40221415	2	3
36502202	4237458	6	8
42804122	1305058	0	0
44363789	1174888	0	0
42804325	1177480	0	0
44337569	19008572	2	3
45642973	1129625	0	0
44337413	723013	0	0
45623540	19079524	1	1
45650120	1112807	0	0
45645089	1713332	0	0
45621793	1125315	0	0
45686869	914335	0	0
45778673	1153428	0	0
45700723	1174888	0	0
45674884	1107830	0	0
45672363	1332418	0	0
45785425	1713332	0	0
45706463	1177480	0	0
45795300	1000560	0	0
46289101	1738521	0	0
46239757	1192710	0	0
45895849	1759842	0	0
46298522	19078461	2	3
46295984	1125315	0	0
46302071	1125315	0	0
4152960	4152936	1	1
1177480	19078461	2	3
21003404	1551192	2	3
21501012	1192710	2	2
35702113	4266809	3	8
36157529	1119510	0	0
36151026	1127433	2	3
36502202	40480160	6	8
42804227	1332418	0	0
44363582	975125	0	0
42804472	1177480	0	0
44337726	40232448	2	3
45638153	1129625	0	0
44337328	1539403	0	0
45623540	46275916	1	1
45650451	1112807	0	0
45645089	1759842	0	0
45621984	1125315	0	0
45686872	1738521	0	0
45778674	1778162	0	0
45700726	1738521	0	0
45675071	1149196	0	0
45672470	1149380	0	0
45785382	1174888	0	0
45706578	1177480	0	0
45795284	1309944	0	0
46289285	1332418	0	0
46239659	1500211	0	0
45896002	967823	0	0
45801848	19078461	2	3
46296028	1125315	0	0
46301279	1125315	0	0
4152960	4109685	1	1
1154343	1154615	2	3
21500206	19126352	2	3
4078460	4202451	2	2
35702113	30753	3	8
36157534	914335	0	0
36150872	1115171	2	3
36502202	4278672	6	8
42804137	1332418	0	0
44363583	1149196	0	0
42804450	1310149	0	0
45622216	40163554	2	3
45638045	1129625	0	0
44337330	701322	0	0
45650243	19079524	1	1
45650368	1112807	0	0
45645044	1192710	0	0
45620584	1125315	0	0
45686457	1717327	0	0
45778678	738818	0	0
45700730	1551099	0	0
45675074	1728416	0	0
45672219	791967	0	0
45785388	1154343	0	0
45706494	1177480	0	0
45795518	19010482	0	0
46289135	742185	0	0
46239725	1124300	0	0
45895794	975125	0	0
46295357	46275916	1	1
46296037	1125315	0	0
46301259	1125315	0	0
4132082	375671	1	1
1713332	19073188	2	3
21001746	1713671	2	3
21600962	1310149	2	2
21602796	920300	3	6
36157536	738818	0	0
36151307	1127433	2	3
36502202	4142905	6	8
42804096	1115008	0	0
44363551	975125	0	0
42804461	1713332	0	0
45622184	1545959	2	3
45638174	1129625	0	0
45620321	975125	0	0
45632212	19079524	1	1
45650630	1112807	0	0
45645106	738818	0	0
45620590	1125315	0	0
45686604	1548195	0	0
45778925	738818	0	0
45700735	1149196	0	0
45674666	1174888	0	0
45672585	1107830	0	0
45785392	1310149	0	0
45699715	1177480	0	0
45795541	1557272	0	0
46243596	19010482	0	0
46239758	1539403	0	0
45895825	1107830	0	0
46295531	19079524	1	1
46296051	1125315	0	0
46301336	1125315	0	0
4132546	4001336	1	1
1174888	40162522	2	3
21002434	46275444	2	3
4042642	4181917	2	2
21602796	19133905	3	6
36157536	1119510	0	0
36151320	46275444	2	3
36502202	4048695	5	8
42804190	1738521	0	0
44363553	1551099	0	0
42804461	1759842	0	0
44358682	40232448	2	3
45638165	1129625	0	0
45620324	1174888	0	0
45647145	19079524	1	1
45648872	1112807	0	0
45645172	914335	0	0
45620565	1125315	0	0
45686879	1322184	0	0
45778929	914335	0	0
45700659	1305058	0	0
45674668	1174888	0	0
45672485	1174888	0	0
45782957	1307863	0	0
45699721	1177480	0	0
45795542	975125	0	0
46243715	1332418	0	0
46239747	1110410	0	0
45895813	740275	0	0
46297566	19079524	1	1
46295996	1125315	0	0
46301192	1125315	0	0
4056125	4314290	1	1
1174888	19133768	2	3
21506158	19079524	2	3
21600961	1310149	2	2
21602796	920334	3	6
36157538	1112807	0	0
36151326	40229134	2	3
36502202	4066995	5	8
42804158	1115008	0	0
44363557	742185	0	0
42804469	1118084	0	0
45658451	1551192	2	3
45638382	1129625	0	0
45620190	1308738	0	0
45667591	19079524	1	1
45644274	1112807	0	0
45645287	920293	0	0
45620643	1125315	0	0
45686634	1118084	0	0
45778647	1000560	0	0
45648719	791967	0	0
45674769	1110410	0	0
45672488	1192710	0	0
45783342	723013	0	0
45699773	1177480	0	0
45795305	967823	0	0
46243553	1154029	0	0
46239731	1738521	0	0
45895826	1107830	0	0
46234524	46233710	1	1
46295963	1125315	0	0
46301200	1125315	0	0
4059308	4242997	1	1
1192710	19112599	2	3
21013496	1551192	2	3
21600961	1112807	2	2
21602796	19073183	3	6
36157581	1177480	0	0
36151215	40232448	2	3
36502202	133834	8	8
42804206	1545958	0	0
44363495	738818	0	0
42804424	1551099	0	0
45658680	40174880	2	3
45638383	1129625	0	0
45620271	1322184	0	0
45635204	19079524	1	1
45644372	1112807	0	0
45645211	1768849	0	0
45620785	1125315	0	0
45686650	1154343	0	0
45778723	967823	0	0
45648666	1154343	0	0
45675084	738818	0	0
45672588	1713332	0	0
45783411	1501700	0	0
45699731	1177480	0	0
45795617	1717327	0	0
46243718	1500211	0	0
46239732	1713332	0	0
45895857	914335	0	0
46234352	920334	1	1
46296238	1125315	0	0
46301319	1125315	0	0
4059978	44805732	1	1
1545958	1545959	2	3
21001745	19073183	2	3
21600961	1322184	2	2
21602796	1717327	3	3
36157472	1115008	0	0
36151242	40229134	2	3
36302170	4084167	5	8
42804141	1322184	0	0
44363836	920293	0	0
42804457	19002770	0	0
45658699	40229134	2	3
45637132	1129625	0	0
45620273	723013	0	0
45632317	19079524	1	1
45644297	1112807	0	0
45645059	708298	0	0
45620654	1125315	0	0
45686845	967823	0	0
45778724	1192710	0	0
45648725	1551099	0	0
45675086	1343916	0	0
45672378	1124300	0	0
45783321	1153428	0	0
45699749	1177480	0	0
45795620	1501700	0	0
46243624	1332418	0	0
46239736	1192710	0	0
45895838	1305058	0	0
46234411	46233988	1	1
46295328	1125315	0	0
46301325	1125315	0	0
4061650	4197460	1	1
1766397	1545959	2	3
21001745	19073188	2	3
21600961	1367571	2	2
21602796	1738521	3	3
36157541	1501700	0	0
36151106	19008572	2	3
36302170	4243062	5	7
42804194	1759842	0	0
44363964	1332418	0	0
42804480	1000560	0	0
45658709	19075601	2	3
45634945	1129625	0	0
45620379	1717327	0	0
45653412	46275916	1	1
45644469	1112807	0	0
45645176	1124300	0	0
45620658	1125315	0	0
45686847	933724	0	0
45778896	1332418	0	0
45648727	1501700	0	0
45675060	1307863	0	0
45672496	1343916	0	0
45783350	914335	0	0
45693717	1177480	0	0
45795638	1729720	0	0
46243625	1174888	0	0
45896022	967823	0	0
45895849	1713332	0	0
46296490	19079524	1	1
46295973	1125315	0	0
46301409	1125315	0	0
4063381	257012	1	1
1580772	1332419	2	3
21001739	19075001	2	3
4174389	4242997	2	2
21602796	1713332	3	3
36157685	1545958	0	0
36151155	1127433	2	3
36302170	134438	5	10
42804194	1713332	0	0
44363608	1192710	0	0
42804482	1177480	0	0
45658747	40232448	2	3
45634856	1129625	0	0
45620384	1192710	0	0
45656666	19079524	1	1
45641431	1112807	0	0
45645317	1501700	0	0
45620701	1125315	0	0
45686853	1551099	0	0
45778651	1174888	0	0
45648728	1115008	0	0
45675062	1102527	0	0
45672498	1713332	0	0
45783420	1112807	0	0
45693599	1177480	0	0
45795380	1307863	0	0
46243630	975125	0	0
45896023	1713332	0	0
45895839	975125	0	0
46316915	42902245	2	2
46296246	1125315	0	0
46301441	1125315	0	0
4042673	4163951	1	1
1768849	19074843	2	3
21001757	19074843	2	3
21500988	1343916	2	2
21602796	1746114	3	3
36157598	1549786	0	0
36211232	4142905	2	3
36302170	439777	5	10
42804196	1717327	0	0
44363608	1112807	0	0
42804283	1124300	0	0
45658796	40229134	2	3
44362714	1177480	0	0
45620170	738818	0	0
45667730	46275916	1	1
45641435	1112807	0	0
45645320	1153428	0	0
45620724	1125315	0	0
45686921	1738521	0	0
45778886	1539403	0	0
45648534	967823	0	0
45675026	1149196	0	0
45672592	1310149	0	0
45783448	1174888	0	0
45690724	1177480	0	0
45795382	1107830	0	0
46243511	1154029	0	0
45896089	1107830	0	0
45895830	1343916	0	0
45794269	40228214	2	3
46296152	1125315	0	0
46301329	1125315	0	0
4044368	4058899	1	1
1768849	19074841	2	3
21001757	19133905	2	3
136779	4278672	2	2
21602796	1768849	3	3
36157610	1332418	0	0
36155823	1545959	2	3
36302170	196456	5	11
42804237	1713332	0	0
44363910	1177480	0	0
42804288	1545958	0	0
45658798	1115171	2	3
44362717	1177480	0	0
45620173	1332418	0	0
45629534	46275916	1	1
45641458	1112807	0	0
45645222	1110410	0	0
45620723	1125315	0	0
45686864	920293	0	0
45778889	1115008	0	0
45648492	1501700	0	0
45674725	1115008	0	0
45672596	975125	0	0
45783450	1310149	0	0
45690696	1177480	0	0
45792547	1115008	0	0
46243562	1741122	0	0
45895937	1153428	0	0
45895910	1192710	0	0
46242059	40228214	2	3
46295581	1125315	0	0
46319235	1125315	0	0
4044900	4170947	1	1
1759842	1713671	2	3
21001757	19073188	2	3
21601625	1361711	2	2
21602796	1778162	3	3
36157473	1308738	0	0
36155724	40229134	2	3
36302170	4195803	4	4
42804237	1759842	0	0
44363914	975125	0	0
42804531	1177480	0	0
45658808	19059056	2	3
44361965	1177480	0	0
45620187	1174888	0	0
45629534	19079524	1	1
45641648	1112807	0	0
45645202	738818	0	0
45620746	1125315	0	0
45686718	967823	0	0
45778966	1174888	0	0
45648593	1174888	0	0
45675038	1149196	0	0
45672605	1738521	0	0
45783463	1115008	0	0
45690780	1177480	0	0
45792683	1115008	0	0
46243562	1746114	0	0
45895990	933724	0	0
45895929	1192710	0	0
45789345	19075601	2	3
46295682	1125315	0	0
46319449	1125315	0	0
4028919	4234705	1	1
1539403	1539411	2	3
21001757	19133873	2	3
21500879	975125	2	2
21602796	920293	3	3
36157475	1119510	0	0
36157928	1125315	0	0
36302170	4012477	4	7
42804295	1115008	0	0
44363770	701322	0	0
42804512	1501700	0	0
45659004	1127433	2	3
44362009	1177480	0	0
45620294	1192710	0	0
45649507	19079524	1	1
45641542	1112807	0	0
45645203	1589505	0	0
45620752	1125315	0	0
45686939	967823	0	0
45778966	1192710	0	0
45648595	967823	0	0
45674779	1396131	0	0
45672615	1107830	0	0
45783163	1307863	0	0
45690810	1177480	0	0
45792655	1343916	0	0
46243736	1115008	0	0
45896062	1713332	0	0
45895954	1332418	0	0
45793924	40228214	2	3
46295685	1125315	0	0
46319699	1125315	0	0
4028919	4230209	1	1
1557272	40173590	2	3
21001757	19073183	2	3
21500879	1738521	2	2
35502617	140673	3	3
36157475	738818	0	0
36158305	1125315	0	0
36302170	4144583	10	10
42804297	1332418	0	0
44363966	1124957	0	0
42804529	1000560	0	0
45658482	40174880	2	3
44362023	1177480	0	0
45620260	1110410	0	0
45659834	19079524	1	1
45641792	1112807	0	0
45645326	740275	0	0
45620710	1125315	0	0
45686940	1500211	0	0
45778834	1115008	0	0
45648603	1307863	0	0
45674780	1549786	0	0
45672227	715997	0	0
45783514	975125	0	0
45687426	1177480	0	0
45792593	1501700	0	0
46243739	933724	0	0
45896063	1521369	0	0
45895956	1778162	0	0
46241557	19078461	2	3
46295591	1125315	0	0
46319701	1125315	0	0
4183452	372328	1	1
1766561	1107882	2	3
21003656	46233988	2	3
21500925	975125	2	2
21603248	1154343	3	3
36157515	1119510	0	0
36158308	1125315	0	0
36302170	80180	6	8
42804340	1545958	0	0
44364016	1177480	0	0
42804491	1309944	0	0
45658853	19008572	2	3
45656208	1177480	0	0
45620429	1149196	0	0
45650146	19079524	1	1
45638297	1112807	0	0
45645378	1174888	0	0
45661584	1125315	0	0
45687000	1501700	0	0
45778690	1549786	0	0
45648735	1115008	0	0
45674780	19127890	0	0
45784027	1738521	0	0
45783369	1738521	0	0
45688581	1177480	0	0
45792719	1192710	0	0
46243610	1149196	0	0
45896064	1000560	0	0
45896019	1000560	0	0
45793690	40228214	2	3
46296402	1125315	0	0
46319453	1125315	0	0
4133611	381316	1	1
1580765	1107882	2	3
21003174	40229134	2	3
21500925	1361711	2	2
21603248	1137529	3	3
36157517	1119510	0	0
36158206	1125315	0	0
36302170	317576	6	12
42804299	1713332	0	0
44363982	975125	0	0
42804493	914335	0	0
45658739	1551192	2	3
45656274	1177480	0	0
45620437	967823	0	0
45638260	19079524	1	1
45638391	1112807	0	0
45645307	1174888	0	0
45661734	1125315	0	0
45686967	1115008	0	0
45778658	1713332	0	0
45648742	1738521	0	0
45674783	1154343	0	0
45784343	1000560	0	0
45783370	1738521	0	0
45684625	1177480	0	0
45792721	1174888	0	0
46243611	1112807	0	0
45896076	715997	0	0
45896108	1107830	0	0
45799002	40228214	2	3
46296413	1125315	0	0
46319461	1125315	0	0
4115576	196456	1	1
1766414	1107882	2	3
21003174	1107882	2	3
21500999	967823	2	2
21603248	1149380	3	3
36157520	1177480	0	0
36158207	1125315	0	0
36302170	4156265	8	11
42804270	1717327	0	0
44356737	1521369	0	0
42804495	1129625	0	0
45658923	19126352	2	3
45652440	1177480	0	0
45620442	1174888	0	0
45623557	46275916	1	1
45638402	1112807	0	0
45642135	1501700	0	0
45661519	1125315	0	0
45687002	738818	0	0
45778877	1361711	0	0
45648776	1768849	0	0
45674899	1589505	0	0
45784344	1589505	0	0
45783362	723013	0	0
45684735	1177480	0	0
45792495	1149196	0	0
46243614	1322184	0	0
45896107	975125	0	0
45896057	1309944	0	0
46298341	40228214	2	3
46296417	1125315	0	0
46319652	1125315	0	0
4091589	4012477	1	1
791967	19057271	2	3
21003174	1150837	2	3
21600033	975125	2	2
21603932	1115008	3	3
36157687	1115008	0	0
36157936	1125315	0	0
36302170	81151	8	13
42804254	1545958	0	0
44356737	1549786	0	0
42804496	1343916	0	0
45658893	19075601	2	3
45652524	1177480	0	0
45620553	1115008	0	0
45632147	46275916	1	1
45638486	1112807	0	0
45642139	1124957	0	0
45661744	1125315	0	0
45687005	1115008	0	0
45778692	1343916	0	0
45648579	1110410	0	0
45674900	1549786	0	0
45784351	1154343	0	0
45783058	1551099	0	0
45684591	1177480	0	0
45792584	1115008	0	0
46243616	975125	0	0
45896192	1551099	0	0
45895979	1367571	0	0
45788675	19079524	2	3
46295592	1125315	0	0
46319770	1125315	0	0
4029205	4170947	1	1
77960	4035415	2	3
21003174	19125062	2	3
21600003	975125	2	2
21603932	1118084	3	3
36157689	1149196	0	0
36158342	1125315	0	0
36302170	4142905	8	12
42804274	1713332	0	0
44356531	1713332	0	0
42804498	1361711	0	0
45658499	1127433	2	3
45652638	1177480	0	0
45620265	1110410	0	0
45634139	19079524	1	1
45638465	1112807	0	0
45642150	1551099	0	0
45661961	1125315	0	0
45687015	738818	0	0
45707538	1115008	0	0
45648684	1713332	0	0
45674900	1521369	0	0
45784353	738818	0	0
45783063	975125	0	0
45684594	1177480	0	0
45792614	1112807	0	0
46243522	1112807	0	0
45895887	1729720	0	0
45895984	1192710	0	0
45798931	19079524	2	3
46295602	1125315	0	0
46319771	1125315	0	0
4090616	78272	1	1
444089	4310024	2	3
21003174	43012036	2	3
21601119	1308738	2	2
21604181	19039298	3	3
36157628	1149380	0	0
36158371	1125315	0	0
36302170	4169137	8	9
42804280	1713332	0	0
44356531	1759842	0	0
42804501	914335	0	0
45658864	40232448	2	3
45652713	1177480	0	0
45620402	1124300	0	0
45628919	46275916	1	1
45638547	1112807	0	0
45643026	1174888	0	0
45661861	1125315	0	0
45686931	742185	0	0
45707178	1515774	0	0
45648746	1124300	0	0
45674900	1595799	0	0
45784256	1174888	0	0
45783518	1501700	0	0
45684810	1177480	0	0
45792667	1112807	0	0
46243525	933724	0	0
45895994	1115008	0	0
45895957	1149196	0	0
46241681	19078461	2	3
46291186	1125315	0	0
46322554	1125315	0	0
4132804	4323902	1	1
920293	920300	2	3
21003174	19112599	2	3
21604564	791967	2	2
21602002	1129625	3	3
36157630	1107830	0	0
36158338	1125315	0	0
36302170	438614	8	9
42804280	1759842	0	0
44356505	738818	0	0
42804250	1118084	0	0
45659013	43012036	2	3
45652802	1177480	0	0
45620403	1107830	0	0
45629144	46275916	1	1
45638627	1112807	0	0
45643040	723013	0	0
45661873	1125315	0	0
45686807	1308738	0	0
45707178	19127890	0	0
45648701	920293	0	0
45674912	1115008	0	0
45784260	1768849	0	0
45783522	1551099	0	0
45684762	1177480	0	0
45792595	1112807	0	0
46243645	1118084	0	0
45896058	975125	0	0
45803982	1153428	0	0
45795784	40228214	2	3
46291142	1125315	0	0
46322564	1125315	0	0
4168004	4168004	0	0
1766598	19073183	2	3
21001738	40229134	2	3
21604564	723013	2	2
21602515	19128009	3	3
36157635	1119510	0	0
36158436	1125315	0	0
36302170	4304110	8	9
42804222	1322184	0	0
44356540	1174888	0	0
42804251	1396131	0	0
44352123	19077344	2	3
45649708	1177480	0	0
45620545	1589505	0	0
45628096	19079524	1	1
45635399	1112807	0	0
45643041	1548195	0	0
45661877	1125315	0	0
45685658	1713332	0	0
45707178	1549786	0	0
45648750	1115008	0	0
45674914	1174888	0	0
45784262	738818	0	0
45783529	1551099	0	0
45684844	1177480	0	0
45792609	1124957	0	0
46243647	975125	0	0
45896148	1154343	0	0
45803985	1174888	0	0
46297972	19078461	2	3
46291149	1125315	0	0
46322567	1125315	0	0
4151422	4151422	0	0
77630	4146173	2	3
21001743	19073188	2	3
21601606	1361711	2	2
21603551	975125	3	3
36157635	1192710	0	0
36158375	1125315	0	0
36302170	4299128	8	8
42804150	920293	0	0
44356740	738818	0	0
42804252	1177480	0	0
44351940	40231925	2	3
45649845	1177480	0	0
45620545	1549786	0	0
45621561	19079524	1	1
45635314	1112807	0	0
45643042	1307863	0	0
45661521	1125315	0	0
45683553	1174888	0	0
45707369	757627	0	0
45648794	1115008	0	0
45675145	1548195	0	0
45784316	1000560	0	0
45783262	1332418	0	0
45684818	1177480	0	0
45792623	1521369	0	0
46243651	1153428	0	0
45896129	1118084	0	0
45804114	1549786	0	0
45788881	19078461	2	3
46291276	1125315	0	0
46322571	1125315	0	0
4152936	4152936	0	0
1519936	1519937	2	3
21001743	19129655	2	3
21604792	757627	2	2
21603551	1124300	3	3
36157715	1549786	0	0
36157824	1125315	0	0
36302170	140673	7	9
42804316	1124300	0	0
44356544	1545958	0	0
42804313	1115008	0	0
44352072	19078461	2	3
45649974	1177480	0	0
45620133	1778162	0	0
45663020	46275916	1	1
45635413	1112807	0	0
45643043	1174888	0	0
45661524	1125315	0	0
45683557	1149196	0	0
45707120	1102527	0	0
45648853	1174888	0	0
45671682	1729720	0	0
45784280	738818	0	0
46291160	1501700	0	0
45681386	1177480	0	0
45792623	1503184	0	0
46243724	1500211	0	0
45896133	1174888	0	0
45804114	1515774	0	0
45893803	19078461	2	3
46290893	1125315	0	0
46319913	1125315	0	0
4132546	4132546	0	0
1519936	43012433	2	3
21001743	1713671	2	3
4176944	40481087	2	2
21603551	914335	3	3
36157718	1500211	0	0
36158346	1125315	0	0
36302170	4051466	7	8
42804152	1177480	0	0
44356579	1768849	0	0
42804338	1545958	0	0
45652119	40232448	2	3
45646328	1177480	0	0
45620268	1738521	0	0
45656910	19079524	1	1
45635653	1112807	0	0
45643021	738818	0	0
45661878	1125315	0	0
45683559	1548195	0	0
45707517	1512674	0	0
45648948	1000560	0	0
45671686	975125	0	0
45784361	1115008	0	0
46291165	1149196	0	0
45681591	1177480	0	0
45792623	19127890	0	0
46243502	1549786	0	0
45896041	1310149	0	0
45804116	1343916	0	0
46297764	19078461	2	3
46290922	1125315	0	0
46320058	1125315	0	0
4144583	4144583	0	0
1153428	40223834	2	3
21001743	19073183	2	3
4122944	4252419	2	2
21603551	1343916	3	3
36157722	1119510	0	0
36158348	1125315	0	0
36302170	4109685	7	11
42804397	791967	0	0
44356668	1332418	0	0
42804442	1125315	0	0
45652120	40232448	2	3
45648942	1177480	0	0
45620362	1192710	0	0
45656679	46275916	1	1
45632296	1112807	0	0
45643116	1549786	0	0
45661881	1125315	0	0
45683568	708298	0	0
45707517	19127890	0	0
45648836	914335	0	0
45671729	1000560	0	0
45784250	1595799	0	0
46291170	1551099	0	0
45682625	1177480	0	0
45792623	1549786	0	0
46243502	19127890	0	0
45896044	1713332	0	0
45804242	1115008	0	0
45787767	19078461	2	3
46291152	1125315	0	0
46319953	1125315	0	0
4059173	4059173	0	0
192438	4285898	2	3
21001770	1150771	2	3
4122944	4024289	2	2
21603551	967823	3	3
36157735	1115008	0	0
36158445	1125315	0	0
36302170	30753	7	11
42804333	1332418	0	0
44356612	975125	0	0
42804339	1545958	0	0
45652026	40223768	2	3
45648795	1177480	0	0
45620556	1107830	0	0
45657031	19079524	1	1
45632288	1112807	0	0
45643116	1521369	0	0
45661535	1125315	0	0
45683561	1107830	0	0
45707517	1549786	0	0
45648782	1110410	0	0
45671731	753626	0	0
45784250	1521369	0	0
46291172	1115008	0	0
45681824	1177480	0	0
45792590	1174888	0	0
46243502	1515774	0	0
45896153	1124957	0	0
45804102	920293	0	0
45793933	19078461	2	3
46244757	1125315	0	0
46320014	1125315	0	0
4059978	4059978	0	0
1766450	1127433	2	3
21001770	19125062	2	3
4185916	4243062	2	2
35622751	4218408	1	1
36157741	1112807	0	0
36158447	1125315	0	0
36302170	4283893	7	11
42804223	1545958	0	0
44356624	738818	0	0
42804533	1326303	0	0
45652330	1115171	2	3
45646449	1177480	0	0
45620542	1107830	0	0
45646902	46275916	1	1
45632516	1112807	0	0
45643116	1595799	0	0
45662011	1125315	0	0
45683675	1551099	0	0
45707522	1149196	0	0
45648847	1000560	0	0
45671706	920293	0	0
45784250	1549786	0	0
46291177	1192710	0	0
45678490	1177480	0	0
45794547	1322184	0	0
46243623	708298	0	0
45896091	1115008	0	0
45804122	1192710	0	0
46289803	19078461	2	3
46244695	1125315	0	0
46320029	1125315	0	0
4062501	4062501	0	0
1766494	19126352	2	3
21001770	40228230	2	3
257007	4048171	2	2
36157208	19127904	1	2
36157901	1129625	0	0
36158457	1125315	0	0
36302170	380378	7	10
42804267	1310149	0	0
44356628	1177480	0	0
42804508	1343916	0	0
45652164	40232448	2	3
45646640	1177480	0	0
45620545	19127890	0	0
45647074	46275916	1	1
45632518	1112807	0	0
45642266	1310149	0	0
45661842	1125315	0	0
45683704	19127890	0	0
45707523	1501700	0	0
45648848	1115008	0	0
45671715	740275	0	0
45784151	1000560	0	0
46291826	933724	0	0
45672298	1177480	0	0
45794548	1112807	0	0
46243579	1107830	0	0
45896645	740275	0	0
45804136	1000560	0	0
46289987	19079524	2	3
46244971	1125315	0	0
46320039	1125315	0	0
4058899	4058899	0	0
1766609	920334	2	3
21001770	1107882	2	3
192353	198809	2	2
36157133	19128263	1	2
36157645	975125	0	0
36158495	1125315	0	0
36302170	4113008	7	10
42804352	1118084	0	0
44356604	1549786	0	0
42804510	1307863	0	0
45652359	1551192	2	3
45646685	1177480	0	0
45620492	1107830	0	0
45647430	19079524	1	1
45629292	1112807	0	0
45642194	1115008	0	0
45661895	1125315	0	0
45683704	1512674	0	0
45707524	738818	0	0
45648970	920293	0	0
45671732	1551099	0	0
45784369	975125	0	0
46291831	1192710	0	0
45784517	1177480	0	0
45794558	791967	0	0
46243769	1332418	0	0
45896743	1124300	0	0
45804245	1153428	0	0
45793681	40228214	2	3
46244634	1125315	0	0
46319997	1125315	0	0
4066995	4066995	0	0
1766595	19008572	2	3
21001770	43012036	2	3
4042660	44783196	2	2
36212271	19074679	1	2
36157646	1177480	0	0
36158496	1125315	0	0
36302170	378419	7	12
42902746	40169281	0	0
44356604	1521369	0	0
42804428	1551099	0	0
45652176	40169281	2	3
45646785	1177480	0	0
45620447	1713332	0	0
45644257	19079524	1	1
45629525	1112807	0	0
45642247	1153428	0	0
45661847	1125315	0	0
45683704	1549786	0	0
45707180	1322184	0	0
45648979	1115008	0	0
45671840	1713332	0	0
45784264	1367571	0	0
46291860	1192710	0	0
45784642	1177480	0	0
45794568	1124957	0	0
46243771	1310149	0	0
45896721	1107830	0	0
45804070	1115008	0	0
46241941	19078461	2	3
46244637	1125315	0	0
46320202	1125315	0	0
4047491	4047491	0	0
4022201	4146173	2	3
21001770	19112599	2	3
4186167	4237458	2	2
36009833	80809	0	1
36157696	1119510	0	0
36158215	1125315	0	0
36302170	4294548	7	13
42902244	42902245	0	0
44356604	19127890	0	0
42804429	1551099	0	0
45652229	40174880	2	3
45643250	1177480	0	0
45620137	975125	0	0
45641486	46275916	1	1
45629180	1112807	0	0
45642179	1149196	0	0
45661692	1125315	0	0
45683740	1115008	0	0
45707185	1309944	0	0
45648981	933724	0	0
45671840	1759842	0	0
45784268	1149196	0	0
46291349	1551099	0	0
45784853	1177480	0	0
45794539	1115008	0	0
46243814	1112807	0	0
45896722	967823	0	0
45803748	1115008	0	0
46297906	19079524	2	3
46244638	1125315	0	0
46313788	1125315	0	0
4169137	4169137	0	0
75909	40480160	2	4
21001750	19074841	2	3
4188027	37017711	2	2
21602823	19073183	0	3
36157699	1119510	0	0
36158417	1125315	0	0
36302170	4166224	9	13
42902245	42902245	0	0
44356605	1174888	0	0
42804522	1115008	0	0
44344444	19077344	2	3
45643577	1177480	0	0
45620149	1308738	0	0
45641651	46275916	1	1
45629610	1112807	0	0
45642180	1149380	0	0
45661777	1125315	0	0
45683746	1154029	0	0
45707580	1192710	0	0
45648944	1149196	0	0
45671813	1595799	0	0
45784310	1149196	0	0
46291353	1551099	0	0
45782692	1177480	0	0
45794437	715997	0	0
46243690	1738521	0	0
45896200	1322184	0	0
45804038	914335	0	0
45795874	19078461	2	3
46239908	1125315	0	0
46313563	1125315	0	0
442264	4149245	4	4
194526	4142905	2	4
21001750	46233710	2	3
4188027	433644	2	2
36202157	4278672	7	9
36157699	738818	0	0
36158477	1125315	0	0
36302170	375671	9	13
42903088	1154615	0	0
44356610	738818	0	0
42801720	1125315	0	0
44344273	46275916	2	3
45643671	1177480	0	0
45620151	1332418	0	0
45635453	46275916	1	1
45629596	1112807	0	0
45642185	738818	0	0
45661785	1125315	0	0
45683582	914335	0	0
45707376	740275	0	0
45648612	1153428	0	0
45671938	1124957	0	0
45784341	1551099	0	0
46291366	1728416	0	0
45782708	1177480	0	0
45794612	1118084	0	0
46243749	1713332	0	0
45804251	1153428	0	0
45804071	1322184	0	0
45788834	19078461	2	3
46240010	1125315	0	0
46313912	1125315	0	0
4103320	40481087	4	4
432795	4001336	4	7
21001750	19074843	2	3
4188027	4240902	2	2
36202157	4237458	8	9
36157564	1119510	0	0
36158530	1125315	0	0
36302170	378001	9	13
42806682	1112807	0	0
44356751	1115008	0	0
42801720	1174888	0	0
44344082	1115171	2	3
45643747	1177480	0	0
45620448	19039298	0	0
45632452	46275916	1	1
45626651	1112807	0	0
45642199	1305058	0	0
45661837	1125315	0	0
45683597	1124300	0	0
45707305	1115008	0	0
45648991	1124300	0	0
45671950	1367571	0	0
45786442	1307863	0	0
46291574	705944	0	0
45782796	1177480	0	0
45794615	1343916	0	0
46243695	1000560	0	0
45804257	975125	0	0
45804047	1174888	0	0
46241697	19078461	2	3
46239923	1125315	0	0
46313836	1125315	0	0
4040738	45769019	4	4
4020346	4146173	4	6
21001750	19133905	2	3
4188027	4219399	2	2
36203062	4134304	7	10
36157566	1149196	0	0
36154376	1125315	0	0
36302170	37017711	9	10
42806671	1177480	0	0
44356803	933724	0	0
42801724	705944	0	0
44344647	19059056	2	3
45643557	1177480	0	0
45620370	1500211	0	0
45632620	46275916	1	1
45626787	1112807	0	0
45642253	1124957	0	0
45661982	1125315	0	0
45683710	757627	0	0
45707311	1500211	0	0
45649126	1124300	0	0
45671738	1549786	0	0
45786359	1107830	0	0
46291594	1713332	0	0
45780220	1177480	0	0
45794603	914335	0	0
46243701	1192710	0	0
45804352	705944	0	0
45804051	1192710	0	0
46297506	40223768	2	3
46239931	1125315	0	0
46313719	1125315	0	0
4105895	4107731	4	4
4022201	4134304	4	6
21001750	19133873	2	3
4180154	45769019	2	2
36203062	78272	6	10
36157567	1124300	0	0
36154346	1125315	0	0
36516972	80809	3	3
42806667	1119510	0	0
44356804	1310149	0	0
42801642	933724	0	0
45646038	19075601	2	3
45645773	1177480	0	0
45620484	1332418	0	0
45629394	46275916	1	1
45626716	1112807	0	0
45642236	1107830	0	0
45661985	1125315	0	0
45683599	740275	0	0
45707385	1332418	0	0
45648622	705944	0	0
45671738	19127890	0	0
45786417	1000560	0	0
46291600	914335	0	0
45780474	1177480	0	0
45794610	1192710	0	0
46243902	1192710	0	0
45804336	1307863	0	0
45804054	1501700	0	0
45798907	19078461	2	3
46240106	1125315	0	0
46314050	1125315	0	0
4040722	40492359	4	4
73553	4134304	4	6
21001750	19073188	2	3
4077352	4163874	2	2
36203062	81151	6	9
36157568	1149196	0	0
36154583	1125315	0	0
36516972	80502	3	3
42806669	1149380	0	0
44356672	1192710	0	0
42801644	1000560	0	0
45646385	40236446	2	3
45640698	1177480	0	0
45620495	791967	0	0
45626592	46275916	1	1
45626672	1112807	0	0
45642240	1102527	0	0
45661901	1125315	0	0
45683600	1310149	0	0
45707387	1551099	0	0
45648629	1768849	0	0
45671738	1515774	0	0
45786456	1124957	0	0
46291615	1112807	0	0
45706533	1177480	0	0
45794734	757627	0	0
46243819	1551099	0	0
45804317	1738521	0	0
45804171	975125	0	0
46244518	19078461	2	3
46239873	1125315	0	0
46313849	1125315	0	0
4115390	321042	4	4
444112	4296204	4	6
21013536	46275444	2	3
4078068	4168004	2	2
36203062	375671	6	9
36157574	1119510	0	0
36154317	1125315	0	0
36516772	80502	3	3
42806728	1521369	0	0
44356673	1154029	0	0
42801684	1549786	0	0
45646293	19018935	2	3
45640890	1177480	0	0
45620505	1192710	0	0
45626704	19079524	1	1
45623298	1112807	0	0
45642209	1501700	0	0
45655525	1125315	0	0
45683747	738818	0	0
45707388	1107830	0	0
45649084	1174888	0	0
45671813	1308738	0	0
45786475	1192710	0	0
46291621	1778162	0	0
45706294	1177480	0	0
45794444	1548195	0	0
46243824	1000560	0	0
45804287	1310149	0	0
45803830	1545958	0	0
45788688	19078461	2	3
46239950	1125315	0	0
46314075	1125315	0	0
4042640	4323902	4	4
4028071	261325	4	6
21013536	1713671	2	3
4030886	4108705	2	2
36203062	378001	6	9
36157577	1119510	0	0
36154472	1125315	0	0
36516772	4035415	3	3
42806728	1595799	0	0
44356611	723013	0	0
42801684	1512674	0	0
45646408	40232448	2	3
45641042	1177480	0	0
45620509	1192710	0	0
45667963	46275916	1	1
45623357	1112807	0	0
45642272	1149380	0	0
45655569	1125315	0	0
45683640	1521369	0	0
45707195	1000560	0	0
45649152	967823	0	0
45671814	1343916	0	0
45786481	920293	0	0
46291793	1112807	0	0
45706419	1177480	0	0
45794446	1545958	0	0
46243825	1000560	0	0
45804319	1326303	0	0
45803924	791967	0	0
45793581	19079524	2	3
46240070	1125315	0	0
46314785	1125315	0	0
4180938	4163872	4	4
193460	81151	4	5
21001768	46233710	2	3
4122424	4202451	2	2
35702118	4285898	4	8
36157578	1119510	0	0
36154473	1125315	0	0
36703477	381316	3	3
42806728	1549786	0	0
44356692	975125	0	0
42801685	1119510	0	0
45645975	43012036	2	3
45640849	1177480	0	0
45620528	975125	0	0
45663454	40220386	1	1
45623567	1112807	0	0
45642216	1778162	0	0
45658264	1125315	0	0
45683640	1549786	0	0
45707383	1713332	0	0
45649134	1107830	0	0
45671976	1149380	0	0
45784394	1307863	0	0
46291751	1107830	0	0
45706459	1177480	0	0
45792779	738818	0	0
46243906	1738521	0	0
45804359	967823	0	0
45803926	1000560	0	0
45793553	19078461	2	3
46239968	1125315	0	0
46314535	1125315	0	0
4181063	4048171	4	4
193460	4230399	4	5
21001768	46233988	2	3
4098910	4117038	2	2
36203062	4059173	6	8
36157578	738818	0	0
36154476	1125315	0	0
36315348	4037675	3	3
42806735	1125315	0	0
44356758	1115008	0	0
42801729	1125315	0	0
45646196	19008572	2	3
45640800	1177480	0	0
44362084	1124300	0	0
45659674	46275916	1	1
45667662	1112807	0	0
45642330	738818	0	0
45658334	1125315	0	0
45683648	1154343	0	0
45707383	1759842	0	0
45649160	1501700	0	0
45671746	1343916	0	0
45784372	967823	0	0
46291762	1112807	0	0
45706621	1177480	0	0
45792734	1192710	0	0
46243780	1149196	0	0
45804361	1310149	0	0
45803935	1332418	0	0
46289942	19079524	2	3
46240130	1125315	0	0
46314544	1125315	0	0
4154739	4230399	4	4
444112	134438	4	5
21002349	920300	2	3
4099350	4116491	2	2
36203062	4278672	6	8
36157766	1129625	0	0
36154443	1125315	0	0
36602219	40480160	3	3
42806735	1174888	0	0
44356654	1512674	0	0
42801609	1177480	0	0
45643070	920334	2	3
45641176	1177480	0	0
44362250	975125	0	0
45649391	1125315	0	0
45667800	1112807	0	0
45642332	1332418	0	0
45658010	1125315	0	0
45683649	738818	0	0
45707497	708298	0	0
45649143	1307863	0	0
45671758	1149196	0	0
45784382	1778162	0	0
46291765	1115008	0	0
45706603	1177480	0	0
45792764	738818	0	0
46243783	705944	0	0
45804380	1174888	0	0
45804181	1521369	0	0
46241982	19078461	2	3
46240021	1125315	0	0
46314629	1125315	0	0
4154162	4001336	4	4
4028071	45769019	4	5
21002349	920334	2	3
4100621	4293740	2	2
36203062	4146173	6	8
36157643	1129625	0	0
36154444	1125315	0	0
40792670	3014576	3	3
42806680	1107830	0	0
44356710	738818	0	0
42801688	1153428	0	0
45643316	19019979	2	3
45641044	1177480	0	0
44362280	1713332	0	0
45649333	1125315	0	0
45667908	1112807	0	0
45642317	738818	0	0
45658341	1125315	0	0
45683788	1115008	0	0
45707503	1367571	0	0
45646162	1115008	0	0
45671954	1110410	0	0
45784392	1174888	0	0
46292019	1112807	0	0
45703045	1177480	0	0
45792770	1332418	0	0
46243786	1521369	0	0
45804379	1778162	0	0
45804181	1549786	0	0
45795852	19078461	2	3
46240119	1125315	0	0
46314569	1125315	0	0
4041285	4116491	4	4
4022201	81151	4	5
21001744	19073188	2	3
4101079	372328	2	2
36203062	40480160	8	8
36157643	1119510	0	0
36154389	1125315	0	0
36503296	4149245	3	4
42806756	19127890	0	0
44356717	967823	0	0
42801631	1738521	0	0
44357062	1125315	0	0
45641283	1177480	0	0
44362280	1759842	0	0
45649520	1125315	0	0
45667951	1112807	0	0
45642335	1305058	0	0
45655599	1125315	0	0
45683798	1549786	0	0
45707679	1115008	0	0
45646159	1110410	0	0
45671856	914335	0	0
45784457	738818	0	0
46291776	1107830	0	0
45703091	1177480	0	0
45792789	1343916	0	0
46243786	1549786	0	0
45804315	1149196	0	0
45804186	1332418	0	0
45794032	19078461	2	3
45896588	1125315	0	0
46314582	1125315	0	0
4042641	4078793	4	4
4022571	4112343	4	5
21001744	19073183	2	3
4100932	4035415	2	2
36203062	4237458	7	8
36157708	1332418	0	0
36154554	1125315	0	0
36516728	4237458	3	4
42806756	1589505	0	0
44356718	1112807	0	0
42801771	1000560	0	0
44357064	1125315	0	0
45641211	1177480	0	0
44362350	1343916	0	0
45649465	1125315	0	0
45667956	1112807	0	0
45642310	1759842	0	0
45655689	1125315	0	0
45683798	1589505	0	0
45707727	1326303	0	0
45645996	738818	0	0
45671897	1149196	0	0
45784440	1149380	0	0
46291452	1501700	0	0
45702971	1177480	0	0
45792746	715997	0	0
46243919	975125	0	0
45804388	1310149	0	0
45804022	1501700	0	0
45795857	19078461	2	3
45896592	1125315	0	0
46314674	1125315	0	0
4042641	4057420	4	4
444089	4166224	4	5
21002805	19019273	2	3
4309075	4047491	2	2
36203062	4048695	7	8
36157710	1112807	0	0
36154656	1125315	0	0
36503297	4146173	3	4
42806756	1549786	0	0
44356662	738818	0	0
42801766	1322184	0	0
44357176	1125315	0	0
45637584	1177480	0	0
44362353	1549786	0	0
45649441	1125315	0	0
45665456	1112807	0	0
45642310	1713332	0	0
45655700	1125315	0	0
45683798	19127890	0	0
45707665	1738521	0	0
45646235	1107830	0	0
45671994	1124300	0	0
45784442	1154029	0	0
46291458	975125	0	0
45699956	1177480	0	0
45792731	1539403	0	0
46243873	1149196	0	0
45796288	1115008	0	0
45804032	920293	0	0
45788461	19078461	2	3
45896485	1125315	0	0
46314994	1125315	0	0
4179141	40479768	4	4
4027553	260139	4	4
21002805	19078461	2	3
4309188	192671	2	2
36203062	4066995	7	8
36157616	1129625	0	0
36154647	1125315	0	0
36703500	44782520	3	4
42806758	1124300	0	0
44356654	1549786	0	0
42801706	708298	0	0
44357108	1125315	0	0
45637730	1177480	0	0
44362353	1521369	0	0
45649446	1125315	0	0
45665457	1112807	0	0
45642360	1545958	0	0
45655647	1125315	0	0
45683656	1729720	0	0
45707681	1110410	0	0
45646062	1149196	0	0
45672145	19127890	0	0
45784414	1000560	0	0
46291470	1124957	0	0
45700037	1177480	0	0
45792750	1332418	0	0
46241234	1118084	0	0
45796294	1557272	0	0
45804160	1310149	0	0
46301431	19078461	2	3
45896527	1125315	0	0
46315024	1125315	0	0
4179141	40479422	4	4
75053	4134304	4	4
21003410	1551192	2	3
21604214	40220386	2	3
36000000	4066995	7	8
36157620	1332418	0	0
36154652	1125315	0	0
36516781	4149245	3	4
42806761	1361711	0	0
44356731	715997	0	0
42801711	1521369	0	0
44357111	1125315	0	0
45637681	1177480	0	0
44362358	1361711	0	0
45649448	1125315	0	0
45665435	1112807	0	0
45642361	1107830	0	0
45655664	1125315	0	0
45683658	738818	0	0
45707683	1551099	0	0
45646331	1124300	0	0
45672145	1589505	0	0
45784488	1361711	0	0
46291693	1343916	0	0
45700120	1177480	0	0
45792881	1521369	0	0
46241235	1110410	0	0
45796389	1000560	0	0
45804168	1589505	0	0
46290232	19078461	2	3
45896438	1125315	0	0
46314723	1125315	0	0
4178367	4202451	4	4
4003568	40492359	4	4
21003153	1115171	2	3
35507611	1115171	2	3
35508496	1119510	0	0
36157793	1545958	0	0
36154728	1125315	0	0
36313967	40478878	3	4
42806763	1154343	0	0
44356847	933724	0	0
42801712	701322	0	0
44357116	1125315	0	0
45637690	1177480	0	0
44361983	1149196	0	0
45649449	1125315	0	0
45663232	1112807	0	0
45642391	1713332	0	0
45655760	1125315	0	0
45683698	740275	0	0
45707222	1192710	0	0
45646334	1310149	0	0
45672145	1549786	0	0
45784608	1307863	0	0
46291700	723013	0	0
45699922	1177480	0	0
45792881	1549786	0	0
46241478	1154029	0	0
45797153	1115008	0	0
45804168	1549786	0	0
45790789	40223768	2	3
45896503	1125315	0	0
46308793	1125315	0	0
4103662	4066995	4	4
432545	433125	4	4
21003153	1127078	2	3
35507491	40229134	2	3
35508496	1125315	0	0
36157771	1149196	0	0
36154731	1125315	0	0
36516781	81151	3	5
42806766	920293	0	0
44356930	1521369	0	0
42801767	1738521	0	0
44358910	1125315	0	0
45637948	1177480	0	0
44362219	1192710	0	0
45649492	1125315	0	0
45660069	1112807	0	0
45642391	1759842	0	0
45655980	1125315	0	0
45683699	19010482	0	0
45707225	1110410	0	0
45646339	1539403	0	0
45672146	1192710	0	0
45784435	1115008	0	0
46291978	1107830	0	0
45700073	1177480	0	0
45792882	738818	0	0
46241483	1115008	0	0
45797167	975125	0	0
45798784	975125	0	0
46298141	19078461	2	3
45896472	1125315	0	0
46308797	1125315	0	0
4178545	4283893	4	4
432545	28060	4	4
21003153	19078461	2	3
35507616	35605482	2	3
35508496	738818	0	0
36157711	1177480	0	0
36154732	1125315	0	0
36703500	381316	3	5
42806699	1153428	0	0
44357200	1115008	0	0
42801744	1118084	0	0
44358920	1125315	0	0
45637998	1177480	0	0
44361999	1545958	0	0
45631754	1125315	0	0
45649376	975125	0	0
45642399	1343916	0	0
45655818	1125315	0	0
45683700	1149380	0	0
45707490	1310149	0	0
45645683	1154343	0	0
45671871	1174888	0	0
45784490	1332418	0	0
46291906	1112807	0	0
45700395	1177480	0	0
45792890	1149380	0	0
46241279	1539403	0	0
45797298	1551099	0	0
45798791	1332418	0	0
46241902	19078461	2	3
45896473	1125315	0	0
46308801	1125315	0	0
4178545	372328	4	4
4022201	4059173	4	4
21003153	19059056	2	3
35507585	40162522	2	3
35508499	933724	0	0
36157939	975125	0	0
36154734	1125315	0	0
36516825	40480160	3	5
42806706	1000560	0	0
44357206	1308738	0	0
42801730	738818	0	0
44358718	1125315	0	0
45634502	1177480	0	0
44362085	1149196	0	0
45632050	1125315	0	0
45632175	975125	0	0
45638877	1717327	0	0
45655744	1125315	0	0
45683754	1118084	0	0
45707582	1115008	0	0
45645632	1115008	0	0
45672112	1343916	0	0
45784480	742185	0	0
46291909	791967	0	0
45700480	1177480	0	0
45792892	738818	0	0
46241441	1332418	0	0
45796532	1713332	0	0
45798792	1548195	0	0
46289970	19078461	2	3
45896681	1125315	0	0
46309180	1125315	0	0
4154161	4156265	4	4
4022201	40480160	4	4
21002350	19074843	2	3
35507492	1332419	2	3
35508502	791967	0	0
36157940	1738521	0	0
36154735	1125315	0	0
36500000	80180	3	5
42806748	1124300	0	0
44357270	1154343	0	0
42801655	1149380	0	0
44358751	1125315	0	0
45634800	1177480	0	0
44362088	1149380	0	0
45632149	1125315	0	0
45631974	975125	0	0
45638879	1308738	0	0
45655750	1125315	0	0
45683768	1729720	0	0
45707685	967823	0	0
45645618	1713332	0	0
45671903	1361711	0	0
45784482	723013	0	0
46291917	1738521	0	0
45697580	1177480	0	0
45792974	738818	0	0
46241407	1551099	0	0
45796501	1107830	0	0
45798882	1738521	0	0
46310895	19078461	2	3
45896682	1125315	0	0
46308948	1125315	0	0
4185115	4125906	4	4
4022201	40479768	4	4
21002350	920300	2	3
903386	45892894	2	3
35508456	738818	0	0
36157675	1119510	0	0
36154745	1125315	0	0
36300000	4163951	3	5
42806686	791967	0	0
44356722	1192710	0	0
42801735	1332418	0	0
44357302	1125315	0	0
45634738	1177480	0	0
44362094	1729720	0	0
45632086	1125315	0	0
45631874	975125	0	0
45639313	1521369	0	0
45655729	1125315	0	0
45683670	975125	0	0
45707598	1192710	0	0
45645804	1149196	0	0
45671907	1322184	0	0
45782311	1174888	0	0
46295773	1501700	0	0
45696908	1177480	0	0
45792979	1115008	0	0
46241315	1112807	0	0
45796512	975125	0	0
45798930	1174888	0	0
46310964	19078461	2	3
45896686	1125315	0	0
46308896	1125315	0	0
4071689	317576	4	4
4022201	4048695	4	4
21002350	920334	2	3
4044900	4058899	2	3
35508412	1174888	0	0
36157676	1549786	0	0
36154746	1125315	0	0
36500000	80502	3	6
42806842	975125	0	0
44356961	1107830	0	0
42801659	1177480	0	0
44357394	1125315	0	0
45634423	1177480	0	0
44362176	975125	0	0
45632160	1125315	0	0
45632227	975125	0	0
45639315	1551099	0	0
45655783	1125315	0	0
45683807	967823	0	0
45707599	1174888	0	0
45645708	1154343	0	0
45672030	738818	0	0
45782212	1539403	0	0
46295789	975125	0	0
45696917	1177480	0	0
45792980	1738521	0	0
46241458	1124300	0	0
45796549	1310149	0	0
45798931	967823	0	0
46316930	40223768	2	3
45896687	1125315	0	0
46308919	1125315	0	0
4071689	4310024	4	4
4022201	4278672	4	4
21002811	19078461	2	3
4180169	372328	2	3
35508412	1125315	0	0
36157676	19127890	0	0
36154748	1125315	0	0
36500000	80809	3	6
42806802	1000560	0	0
44356777	1713332	0	0
42801661	1192710	0	0
44357398	1125315	0	0
45634535	1177480	0	0
44362255	1332418	0	0
45632185	1125315	0	0
45634087	975125	0	0
45639222	1153428	0	0
45655943	1125315	0	0
45683773	1124957	0	0
45707318	1000560	0	0
45645610	1332418	0	0
45672038	1551099	0	0
45782316	1192710	0	0
46295795	1192710	0	0
45697075	1177480	0	0
45792741	1332418	0	0
46241464	1124957	0	0
45796669	1551099	0	0
45798673	1192710	0	0
46316862	19078461	2	3
45896554	1125315	0	0
46309286	1125315	0	0
4028071	4116491	4	4
4022201	40479422	4	4
21002811	1115171	2	3
4032251	4024289	2	3
35508268	1125315	0	0
36157676	1589505	0	0
36154751	1125315	0	0
36313966	439777	3	8
42806904	1548195	0	0
44356783	1545958	0	0
42801775	1557272	0	0
44357311	1125315	0	0
45634785	1177480	0	0
44362138	19010482	0	0
45632249	1125315	0	0
45634216	975125	0	0
45639135	738818	0	0
44348130	1125315	0	0
45683778	1741122	0	0
45707422	1192710	0	0
45645724	1310149	0	0
45672158	1154343	0	0
45782328	1000560	0	0
46244923	1149196	0	0
45697238	1177480	0	0
45792793	1717327	0	0
46241469	1149196	0	0
45796503	1115008	0	0
45798674	1115008	0	0
45799832	1332419	2	3
45896576	1125315	0	0
46309409	1125315	0	0
4103352	257012	4	4
4022201	4066995	4	4
21002491	1127433	2	3
4032251	4252419	2	3
35508506	975125	0	0
36157683	1112807	0	0
36154752	1125315	0	0
36516993	78272	3	8
42806777	1118084	0	0
44356764	1713332	0	0
42801778	1000560	0	0
44357345	1125315	0	0
45636982	1177480	0	0
44362457	1589505	0	0
45631989	1125315	0	0
45629075	975125	0	0
45639158	1174888	0	0
44348409	1125315	0	0
45683778	1746114	0	0
45707510	1000560	0	0
45645764	1124300	0	0
45671772	1192710	0	0
45782335	1729720	0	0
46244924	1322184	0	0
45696988	1177480	0	0
45792819	920293	0	0
46241473	1149196	0	0
45796479	19010482	0	0
45798682	1115008	0	0
45802454	1545959	2	3
45894735	1125315	0	0
46309131	1125315	0	0
4072499	4043071	4	4
4021667	4113008	4	4
21002491	19078461	2	3
1102527	40165015	2	3
35508507	1125315	0	0
36157684	1154343	0	0
36154564	1125315	0	0
36500000	4059173	3	9
42806754	1713332	0	0
44356971	1124300	0	0
42801781	1589505	0	0
44353627	1125315	0	0
45636795	1177480	0	0
44362461	975125	0	0
45631991	1125315	0	0
45629154	975125	0	0
45639229	1107830	0	0
44348200	1125315	0	0
45683783	1589505	0	0
45707406	1115008	0	0
45645792	1149196	0	0
45672071	1501700	0	0
45782422	1000560	0	0
46244927	1000560	0	0
45697303	1177480	0	0
45792903	1501700	0	0
46241326	1713332	0	0
45796553	1778162	0	0
45798560	1000560	0	0
45893732	1332419	2	3
45894624	1125315	0	0
46309307	1125315	0	0
4067285	4163971	4	4
4021667	4109685	4	4
21002491	19019273	2	3
21003024	19023398	2	3
35508413	791967	0	0
36157831	791967	0	0
36154573	1125315	0	0
36500000	4278672	3	9
42806811	1589505	0	0
44356697	1118084	0	0
42801781	19127890	0	0
44353941	1125315	0	0
45637317	1177480	0	0
44362463	1154029	0	0
45632004	1125315	0	0
45629215	975125	0	0
45639230	1548195	0	0
44348413	1125315	0	0
45683851	975125	0	0
45707415	1115008	0	0
45642677	1115008	0	0
45672077	1149380	0	0
45782221	1192710	0	0
46244928	1728416	0	0
45693938	1177480	0	0
45792908	1174888	0	0
46241328	1192710	0	0
45796482	967823	0	0
45798671	1174888	0	0
45790676	1332419	2	3
45894720	1125315	0	0
46309310	1125315	0	0
4043022	4163872	4	4
4021667	4155034	4	4
21002491	19059056	2	3
21003024	782047	2	3
35508415	1125315	0	0
36157833	1124300	0	0
36154812	1125315	0	0
36500000	4237458	3	9
42806870	19016749	0	0
44356703	975125	0	0
42801781	1549786	0	0
44353895	1125315	0	0
45631793	1177480	0	0
44362261	1124957	0	0
45632006	1125315	0	0
45628987	975125	0	0
45639272	967823	0	0
44348416	1125315	0	0
45683867	1501700	0	0
45707695	715997	0	0
45642688	967823	0	0
45672083	738818	0	0
45782357	975125	0	0
46275444	46275444	0	0
45694103	1177480	0	0
45792910	1112807	0	0
46241331	791967	0	0
45796490	1149196	0	0
45798781	1307863	0	0
46244441	1332419	2	3
45894340	1125315	0	0
46309318	1125315	0	0
4043022	4163951	4	4
433128	4084167	4	4
21002491	1115171	2	3
21013966	46233710	2	3
35508415	1174888	0	0
36157835	1124300	0	0
36152381	1125315	0	0
36500000	4142905	3	9
42806821	1118084	0	0
44356704	705944	0	0
42801810	1125315	0	0
44354225	1125315	0	0
45631797	1177480	0	0
44362262	967823	0	0
45632013	1125315	0	0
45629317	975125	0	0
45639308	1192710	0	0
44348267	1125315	0	0
45683873	1343916	0	0
45704433	967823	0	0
45642703	1713332	0	0
45672086	19127890	0	0
45782360	975125	0	0
45678097	19019273	2	3
45694183	1177480	0	0
45792798	1192710	0	0
46241344	19127890	0	0
45796679	1110410	0	0
45798474	1551099	0	0
45795866	1332419	2	3
45894511	1125315	0	0
46309342	1125315	0	0
4043022	4145310	4	4
4020346	4113008	4	4
21002808	1551192	2	3
21013966	46233988	2	3
35508458	1119510	0	0
36157837	1153428	0	0
36152179	1125315	0	0
36516972	78272	3	8
42806832	1115008	0	0
44356830	975125	0	0
42801810	1112807	0	0
44353844	1125315	0	0
45631778	1177480	0	0
44362186	1110410	0	0
45632016	1125315	0	0
45628274	975125	0	0
45639362	1107830	0	0
45651975	1125315	0	0
45683875	723013	0	0
45704631	1000560	0	0
45642703	1759842	0	0
45672086	1589505	0	0
45782368	1115008	0	0
45678079	40163554	2	3
45694153	1177480	0	0
45792799	1115008	0	0
46241344	1521369	0	0
45796694	975125	0	0
45798475	708298	0	0
46297938	19079524	2	3
45799644	1125315	0	0
46309344	1125315	0	0
4178818	133834	4	4
4020346	4155034	4	4
21002808	19019273	2	3
21003063	40232448	2	3
35508460	1119510	0	0
36157842	1112807	0	0
36152180	1125315	0	0
36516972	4066995	3	6
42806958	1177480	0	0
44356842	723013	0	0
42801810	1129625	0	0
44354144	1125315	0	0
45631902	1177480	0	0
44362194	791967	0	0
45632213	1125315	0	0
45626116	975125	0	0
45639335	1124957	0	0
45649324	1125315	0	0
45683891	1000560	0	0
45704635	1713332	0	0
45642758	757627	0	0
45672086	1549786	0	0
45782281	715997	0	0
45678352	35605482	2	3
45694038	1177480	0	0
45792811	1115008	0	0
46241344	1549786	0	0
45796727	1326303	0	0
45798481	1124300	0	0
45787572	1539411	2	3
45799648	1125315	0	0
46309461	1125315	0	0
4178818	198809	4	4
73553	81151	4	4
21002808	19019979	2	3
701322	45892894	2	3
35508461	1729720	0	0
36157715	1589505	0	0
36152328	1125315	0	0
36516972	4035415	3	6
42806972	1154343	0	0
44356994	1174888	0	0
42801785	1332418	0	0
44354145	1125315	0	0
45628705	1177480	0	0
44362213	791967	0	0
45632238	1125315	0	0
45626223	975125	0	0
45639260	1110410	0	0
45649327	1125315	0	0
45683859	19010482	0	0
45704578	1310149	0	0
45642770	19127890	0	0
45672088	1539403	0	0
45782464	1557272	0	0
45678243	40163554	2	3
45693852	1177480	0	0
45790027	1174888	0	0
46241347	1308738	0	0
45796809	1322184	0	0
45798592	1174888	0	0
46316298	19079524	1	1
45799932	1125315	0	0
46309183	1125315	0	0
4178818	4283893	4	4
432795	4296205	4	4
21002808	19059056	2	3
21500806	40163554	2	3
35508462	1177480	0	0
36157870	1115008	0	0
36152150	1125315	0	0
36516781	78272	2	6
42806973	1125315	0	0
44356998	1557272	0	0
42801816	1738521	0	0
44354235	1125315	0	0
45631175	1177480	0	0
44362216	1192710	0	0
45632240	1125315	0	0
45623110	975125	0	0
45639261	1192710	0	0
45649331	1125315	0	0
45683898	1107830	0	0
45704594	1309944	0	0
45642770	1549786	0	0
45671908	1107830	0	0
45782428	967823	0	0
45678393	40231925	2	3
45694135	1177480	0	0
45790027	1192710	0	0
46241348	1192710	0	0
45796547	1174888	0	0
45798889	975125	0	0
46311271	19079524	1	1
46317845	1125315	0	0
46309472	1125315	0	0
4178818	440448	4	4
432795	4299128	4	4
21002808	19078461	2	3
21002958	19129655	2	3
35508269	1112807	0	0
36157871	1119510	0	0
36152156	1125315	0	0
36503296	81151	2	6
42807077	1125315	0	0
44356768	1000560	0	0
42801819	920293	0	0
44354212	1125315	0	0
45631095	1177480	0	0
44362305	1361711	0	0
45634196	1125315	0	0
45623318	975125	0	0
45639002	1149196	0	0
45649348	1125315	0	0
45683901	1545958	0	0
45704595	19039298	0	0
45642829	1322184	0	0
45671780	1174888	0	0
45782374	1589505	0	0
45678235	40224805	2	3
45691035	1177480	0	0
45790036	1551099	0	0
46241489	1107830	0	0
45796601	1000560	0	0
45798894	975125	0	0
45876009	3009542	1	1
46318082	1125315	0	0
46309189	1125315	0	0
4027403	44805732	4	4
193460	4035415	4	4
21002808	1115171	2	3
21002912	1551192	2	3
35508270	1115008	0	0
36157772	1589505	0	0
36158271	1125315	0	0
36313967	4015189	2	6
42807077	1112807	0	0
44357095	1322184	0	0
42801821	1112807	0	0
44354249	1125315	0	0
45628936	1177480	0	0
44362307	701322	0	0
45634218	1125315	0	0
45621508	975125	0	0
45639364	1557272	0	0
45649408	1125315	0	0
45683844	1332418	0	0
45704761	1332418	0	0
45642812	1115008	0	0
45671784	975125	0	0
45782528	738818	0	0
45678242	1115171	2	3
45690983	1177480	0	0
45790037	19010482	0	0
46241372	1112807	0	0
45796664	1107830	0	0
45798898	1545958	0	0
45876009	3024731	1	1
46317603	1125315	0	0
46309192	1125315	0	0
4047779	378001	6	9
75909	4066995	4	4
21601119	964261	4	5
21002975	40243436	2	3
35508594	1125315	0	0
36157883	1177480	0	0
36158539	1125315	0	0
36503297	4149245	2	5
42807030	1125315	0	0
44357096	1713332	0	0
42801823	1154343	0	0
44354187	1125315	0	0
45626026	1177480	0	0
44362456	715997	0	0
45634228	1125315	0	0
45621768	975125	0	0
45639065	1192710	0	0
45649566	1125315	0	0
45683943	1149196	0	0
45704853	1539403	0	0
45642817	1115008	0	0
45671874	1149380	0	0
45782547	1326303	0	0
45678406	19059056	2	3
45690908	1177480	0	0
45790040	1115008	0	0
46241352	920293	0	0
45796634	1124300	0	0
45798597	1713332	0	0
45876009	3002385	1	1
46318162	1125315	0	0
46309366	1125315	0	0
4047779	313217	6	9
75909	4059173	4	4
21600279	46275916	4	5
21500523	19076374	2	3
35508596	738818	0	0
36157884	791967	0	0
36158612	1125315	0	0
36422731	1150771	2	3
42806854	1124957	0	0
44357006	1177480	0	0
42801993	1738521	0	0
44354196	1125315	0	0
45626097	1177480	0	0
44362333	738818	0	0
45629015	1125315	0	0
45621858	975125	0	0
45639070	1515774	0	0
45649574	1125315	0	0
45683939	1310149	0	0
45704445	1717327	0	0
45642859	1124957	0	0
45671874	1137529	0	0
45782551	1549786	0	0
45678341	1127433	2	3
45691155	1177480	0	0
45789986	975125	0	0
46241542	1000560	0	0
45796637	1548195	0	0
45798708	1343916	0	0
45876009	3010813	1	1
46317754	1125315	0	0
46303662	1125315	0	0
4047779	4230399	6	9
75909	4048695	4	4
21500562	45892894	4	5
35507421	19019273	2	3
35508602	1500211	0	0
36158055	1177480	0	0
36158602	1125315	0	0
36429173	1150837	2	3
42806854	1125315	0	0
44356885	1738521	0	0
42801959	1112807	0	0
44354207	1125315	0	0
45622696	1177480	0	0
44362457	1549786	0	0
45629132	1125315	0	0
45667289	975125	0	0
45639070	19127890	0	0
45649219	1125315	0	0
45683820	1000560	0	0
45704718	1539403	0	0
45642796	723013	0	0
45671878	1549786	0	0
45782551	19127890	0	0
45678428	40223834	2	3
45691312	1177480	0	0
45790129	1192710	0	0
46241432	1107830	0	0
45791253	967823	0	0
45799774	1343916	0	0
45876009	3026361	1	1
46318139	1125315	0	0
46303716	1125315	0	0
4047779	40479768	6	8
444089	198809	4	4
21500562	40223768	4	5
35507532	1107882	2	3
35508213	1129625	0	0
36157898	1107830	0	0
36158634	1125315	0	0
36427861	1551192	2	3
42806861	975125	0	0
44357009	1174888	0	0
42802001	1125315	0	0
44354279	1125315	0	0
45622673	1177480	0	0
44362559	1717327	0	0
45629136	1125315	0	0
45667425	975125	0	0
45639070	1549786	0	0
44343579	19128022	1	2
45683825	1115008	0	0
45704448	715997	0	0
45688706	1124957	0	0
45671878	1595799	0	0
45782562	1589505	0	0
45678428	40223821	2	3
45688151	1177480	0	0
45790130	975125	0	0
46241553	1118084	0	0
45791129	1501700	0	0
45799777	1549786	0	0
45876009	3007461	1	1
46317781	1125315	0	0
46303861	1125315	0	0
4047779	40479422	6	8
1361711	1361711	0	0
21500643	42707627	4	5
21002902	40173590	2	3
35508214	1119510	0	0
36158061	975125	0	0
36150709	1125315	0	0
36429128	46275444	2	3
42806942	1000560	0	0
44356875	723013	0	0
42802003	1118084	0	0
44352387	1125315	0	0
45622680	1177480	0	0
44362411	738818	0	0
45629197	1125315	0	0
45667450	975125	0	0
45639073	1548195	0	0
44343579	19128263	1	2
45683973	975125	0	0
45704551	1149196	0	0
45688471	1310149	0	0
45671878	1521369	0	0
45782565	738818	0	0
45678370	19008572	2	3
45688226	1177480	0	0
45790131	1192710	0	0
46241570	705944	0	0
45791119	1322184	0	0
45799777	1521369	0	0
45876009	3000963	1	1
46318249	1125315	0	0
46303865	1125315	0	0
4047779	133834	6	8
198809	198809	0	0
21600190	40243436	4	5
21003174	1150771	2	3
35508215	1125315	0	0
36158064	1112807	0	0
36150855	1125315	0	0
36426273	19057271	2	3
42806943	1000560	0	0
44357044	1107830	0	0
42802107	1551099	0	0
44352235	1125315	0	0
45622959	1177480	0	0
44362422	1174888	0	0
45629200	1125315	0	0
45667314	975125	0	0
45639080	1738521	0	0
44362457	19128009	1	2
45683975	1153428	0	0
45704643	705944	0	0
45688571	740275	0	0
45784050	1000560	0	0
45782505	1124300	0	0
45678418	40165015	2	3
45688379	1177480	0	0
45790048	1326303	0	0
46241451	1112807	0	0
45791221	1115008	0	0
45799809	1153428	0	0
45896736	1738521	0	0
46318096	1125315	0	0
46303929	1125315	0	0
4047779	196456	6	6
198199	198199	0	0
21500215	1332419	4	5
21003174	40232448	2	3
35508603	1738521	0	0
36157948	1177480	0	0
36150663	1125315	0	0
36427690	46275444	2	3
42806938	1738521	0	0
44357010	1778162	0	0
42802110	1177480	0	0
44352239	1125315	0	0
45622969	1177480	0	0
44362471	1308738	0	0
45629045	1125315	0	0
45662814	975125	0	0
45639083	1149196	0	0
45640662	46275916	1	1
45684071	19010482	0	0
45704816	1307863	0	0
45688660	1308738	0	0
45784051	1548195	0	0
45782509	708298	0	0
45674853	1127433	2	3
45684964	1177480	0	0
45790052	1112807	0	0
46241496	1107830	0	0
45791193	791967	0	0
45799709	1332418	0	0
45896739	1154343	0	0
46318168	1125315	0	0
46307067	1125315	0	0
4047779	441267	5	5
4010253	4010253	0	0
21500216	1310034	4	5
21013948	46233988	2	3
35508604	1119510	0	0
36158112	975125	0	0
36150844	1125315	0	0
36424954	1149380	0	0
42807080	742185	0	0
44357024	738818	0	0
42802110	1174888	0	0
44352352	1125315	0	0
45620878	1177480	0	0
44362496	1107830	0	0
45629161	1125315	0	0
45664648	975125	0	0
45639171	1595799	0	0
45637107	46275916	1	1
45683963	1549786	0	0
45704651	1307863	0	0
45691232	715997	0	0
45783789	723013	0	0
45782580	1192710	0	0
45674863	19059056	2	3
45685016	1177480	0	0
45790134	723013	0	0
46241512	1309944	0	0
45791073	1545958	0	0
45799850	1545958	0	0
45895584	1000560	0	0
46318210	1125315	0	0
46307005	1125315	0	0
4047779	192671	5	5
1595799	1595799	0	0
21500595	19019979	4	5
4042650	4252419	2	3
35508607	738818	0	0
36158115	1119510	0	0
36150845	1125315	0	0
36425092	757627	0	0
42807014	1125315	0	0
44356771	723013	0	0
42801966	1125315	0	0
44350269	1125315	0	0
45621125	1177480	0	0
44362584	738818	0	0
45629164	1125315	0	0
45656794	975125	0	0
45639171	1308738	0	0
45634639	46275916	1	1
45683963	1589505	0	0
45704825	1326303	0	0
45691234	1305058	0	0
45783885	1115008	0	0
45782649	1154029	0	0
45675210	1551192	2	3
45685101	1177480	0	0
45790056	708298	0	0
46241576	1112807	0	0
45791333	1557272	0	0
45799832	1332418	0	0
45895663	1322184	0	0
46318216	1125315	0	0
46306477	1125315	0	0
4047779	45769019	5	6
1594382	1594382	0	0
21500595	1115171	4	5
21501230	19079524	2	3
35508607	1119510	0	0
36158121	738818	0	0
36150935	1125315	0	0
36423756	1322184	0	0
42806951	1501700	0	0
44356955	1738521	0	0
42801935	1713332	0	0
44350257	1125315	0	0
45621386	1177480	0	0
44362594	1549786	0	0
45629205	1125315	0	0
45657205	975125	0	0
45639185	1110410	0	0
45628194	19127918	1	1
45680699	1589505	0	0
45704775	1174888	0	0
45691298	1000560	0	0
45783888	1124957	0	0
45782651	1589505	0	0
45675236	19008572	2	3
45685015	1177480	0	0
45790136	1539403	0	0
46241579	1595799	0	0
45791216	1322184	0	0
45799859	1124957	0	0
45895607	967823	0	0
46322544	1125315	0	0
46307073	1125315	0	0
4047779	4109685	5	6
1308738	1308738	0	0
21506173	40171902	4	4
1101544	40173590	2	3
35508611	1119510	0	0
36158121	1119510	0	0
36156431	1125315	0	0
36422341	1309944	0	0
42804384	1174888	0	0
44357132	1153428	0	0
42802079	1000560	0	0
44350342	1125315	0	0
45664833	1177480	0	0
44362478	1124300	0	0
45629192	1125315	0	0
45656890	975125	0	0
45639191	1174888	0	0
45620848	19074679	1	1
45680418	1149196	0	0
45704576	1115008	0	0
45691387	1107830	0	0
45783895	1729720	0	0
45782589	738818	0	0
45675005	19019273	2	3
45684995	1177480	0	0
45790138	1153428	0	0
46241650	1332418	0	0
45791156	1738521	0	0
45798973	1332418	0	0
45895573	1332418	0	0
46318325	1125315	0	0
46307077	1125315	0	0
4047779	4056621	5	6
1305058	1305058	0	0
21503082	914335	4	4
21002670	46233988	2	3
35508611	1125315	0	0
36157655	1177480	0	0
36156432	1125315	0	0
36422418	1713332	0	0
42804384	1125315	0	0
44350113	738818	0	0
42802081	975125	0	0
44350244	1125315	0	0
45664834	1177480	0	0
44362564	738818	0	0
45628973	1125315	0	0
45653776	975125	0	0
45639204	738818	0	0
45664228	19079524	1	1
45680762	1000560	0	0
45705097	1332418	0	0
45691389	933724	0	0
45783897	1309944	0	0
45782532	1551099	0	0
45675013	1127433	2	3
45685089	1177480	0	0
45789989	1545958	0	0
46241519	1322184	0	0
45791178	1192710	0	0
45798977	1501700	0	0
45895613	740275	0	0
45794374	1125315	0	0
46304054	1125315	0	0
4047779	4048171	5	9
967823	967823	0	0
21503082	967823	4	4
21002623	46275444	2	3
35508611	1192710	0	0
36158076	1119510	0	0
36155451	1125315	0	0
36422348	1332418	0	0
42804385	1125315	0	0
44350117	1112807	0	0
42801867	1124300	0	0
44350395	1125315	0	0
45664913	1177480	0	0
44362480	1713332	0	0
45628975	1125315	0	0
45653820	975125	0	0
45639339	1107830	0	0
45662205	19115351	1	1
45680872	723013	0	0
45704955	1149196	0	0
45691390	1551099	0	0
45784225	1746114	0	0
45782537	1551099	0	0
45675096	19018935	2	3
45685727	1177480	0	0
45790041	1545958	0	0
46241520	1112807	0	0
45791245	1174888	0	0
45799000	1115008	0	0
45895588	1308738	0	0
45794380	1125315	0	0
46304220	1125315	0	0
4047779	4146173	5	7
715997	715997	0	0
21503082	933724	4	4
21003027	46275916	2	3
35508625	738818	0	0
36158076	738818	0	0
36155565	1125315	0	0
36422432	1717327	0	0
42804385	1174888	0	0
44349758	1545958	0	0
42801873	1589505	0	0
44350336	1125315	0	0
45665083	1177480	0	0
44362366	1717327	0	0
45629092	1125315	0	0
45653637	975125	0	0
45638913	723013	0	0
45643657	19079524	1	1
45680741	1154029	0	0
45704878	1501700	0	0
45639745	1307863	0	0
45784225	1741122	0	0
45782544	1713332	0	0
45676423	1115171	2	3
45685885	1177480	0	0
45789916	1361711	0	0
46241600	1174888	0	0
45791249	1118084	0	0
45799056	1000560	0	0
45895639	738818	0	0
45794483	1125315	0	0
46304172	1125315	0	0
4047779	198809	5	7
723013	723013	0	0
21503082	920293	4	4
21003217	40232448	2	3
35508625	1125315	0	0
36158022	1124300	0	0
36155438	1125315	0	0
36503269	4142905	5	6
42804387	1125315	0	0
44349627	1332418	0	0
42801845	1149196	0	0
44350271	1125315	0	0
45665124	1177480	0	0
44362367	19127890	0	0
45629102	1125315	0	0
45653770	975125	0	0
45638979	1154343	0	0
45643372	19079524	1	1
45680526	1343916	0	0
45704882	1192710	0	0
45639634	1551099	0	0
45783954	791967	0	0
45782666	738818	0	0
45676429	40232448	2	3
45682152	1177480	0	0
45789905	1738521	0	0
46241603	975125	0	0
45791424	1551099	0	0
45799002	1149196	0	0
45895575	1149196	0	0
45794416	1125315	0	0
46304101	1125315	0	0
4047779	317576	5	7
723164	19115351	0	0
21500582	1177480	4	4
1101489	19007333	2	3
35508625	1119510	0	0
36158023	1119510	0	0
36155439	1125315	0	0
36516972	4059173	5	6
42804387	1174888	0	0
44349628	975125	0	0
42801873	1549786	0	0
44350249	1125315	0	0
45665057	1177480	0	0
44362367	1549786	0	0
45629049	1125315	0	0
45650232	975125	0	0
45638981	1332418	0	0
45634190	46275916	1	1
45680527	1713332	0	0
45704886	914335	0	0
45639919	1174888	0	0
45783958	1115008	0	0
45782383	1149196	0	0
45676376	1115171	2	3
45682269	1177480	0	0
45790150	1174888	0	0
46241604	1112807	0	0
45791320	1515774	0	0
45799037	920293	0	0
45895768	1343916	0	0
45794503	1125315	0	0
46304120	1125315	0	0
4047779	321042	5	7
260139	260139	0	0
21500582	1125315	4	4
21500819	19075601	2	3
35508555	1119510	0	0
36158023	1129625	0	0
36155440	1125315	0	0
36516772	4059173	5	6
42804421	40231925	2	3
44349635	1110410	0	0
42801877	975125	0	0
44350591	1125315	0	0
45665214	1177480	0	0
44362368	1738521	0	0
45629257	1125315	0	0
45650141	975125	0	0
45638983	1174888	0	0
45664746	46275916	1	1
45680529	1549786	0	0
45704888	19010482	0	0
45639695	1174888	0	0
45783905	1326303	0	0
45782238	1115008	0	0
45671925	1551192	2	3
45682332	1177480	0	0
45790155	1326303	0	0
46241606	1115008	0	0
45791320	1549786	0	0
45799041	1124300	0	0
45895725	1192710	0	0
45794399	1125315	0	0
46304187	1125315	0	0
4047779	4296204	5	7
261325	261325	0	0
21500541	1129625	4	4
21002901	40173590	2	3
35508555	1125315	0	0
36158029	1322184	0	0
36155398	1125315	0	0
36516772	4066995	5	6
42804242	19018935	2	3
44349801	791967	0	0
42801792	19127890	0	0
44350458	1125315	0	0
45665186	1177480	0	0
44362663	1149380	0	0
45629210	1125315	0	0
45650201	975125	0	0
45639355	1738521	0	0
45659077	46275916	1	1
45680529	1589505	0	0
45704562	1174888	0	0
45639670	1107830	0	0
45783971	1102527	0	0
45782419	975125	0	0
45671926	19008572	2	3
45682230	1177480	0	0
45790159	738818	0	0
46241673	1124957	0	0
45791202	1551099	0	0
45794629	740275	0	0
45895601	1332418	0	0
45794403	1125315	0	0
46304292	1125315	0	0
4047779	4059173	5	8
258780	258780	0	0
21500541	738818	4	4
1101553	40169216	2	3
35508630	1119510	0	0
36158176	1124300	0	0
36155400	1125315	0	0
36516772	4048695	5	6
42804303	19077344	2	3
44349803	1124300	0	0
42801792	1589505	0	0
44350698	1125315	0	0
45662584	1177480	0	0
44362534	19127890	0	0
45629268	1125315	0	0
45647289	975125	0	0
45639122	1557272	0	0
45643524	19079524	1	1
45680535	1154029	0	0
45704890	1154029	0	0
45639878	1154343	0	0
45783998	1115008	0	0
45782421	715997	0	0
45672097	19008572	2	3
45682237	1177480	0	0
45790160	738818	0	0
46241628	1322184	0	0
45791237	1521369	0	0
45794630	1778162	0	0
45895645	1124957	0	0
45794436	1125315	0	0
46304310	1125315	0	0
4047779	4278672	5	8
4012477	4012477	0	0
21500541	1125315	4	4
1101539	19019979	2	3
35508630	1125315	0	0
36157980	1557272	0	0
36155415	1125315	0	0
36516772	40479422	5	6
42804415	19133873	2	3
44349473	1361711	0	0
42801792	1549786	0	0
44350703	1125315	0	0
45662450	1177480	0	0
44362534	1549786	0	0
45629316	1125315	0	0
45647347	975125	0	0
45639241	1778162	0	0
45620907	46275916	1	1
45680356	967823	0	0
45704891	1192710	0	0
45639882	1738521	0	0
45784006	1110410	0	0
45782483	1192710	0	0
45672463	19008572	2	3
45678632	1177480	0	0
45789920	1102527	0	0
46238493	975125	0	0
45791360	791967	0	0
45793563	1153428	0	0
45895651	1107830	0	0
45794459	1125315	0	0
45794225	1107882	2	3
4047779	4048695	5	8
1307863	1307863	0	0
21500541	708298	4	4
1101539	1115171	2	3
35508513	1125315	0	0
36157982	1119510	0	0
36155443	1125315	0	0
36703500	378001	5	8
42804251	19077344	2	3
44349779	975125	0	0
42535580	42535580	0	0
44350492	1125315	0	0
45662410	1177480	0	0
44362534	1521369	0	0
45627888	1125315	0	0
45644457	975125	0	0
45639379	1717327	0	0
45637158	19079524	1	1
45680463	1107830	0	0
45704570	1174888	0	0
45639886	1548195	0	0
45783845	1545958	0	0
45782501	1539403	0	0
45672470	40169216	2	3
45678869	1177480	0	0
45790207	1322184	0	0
46238444	1545958	0	0
45791484	1521369	0	0
45793497	1110410	0	0
45895741	1107830	0	0
46312374	1125315	0	0
45799812	19078461	2	3
4047779	134438	4	6
1310034	1310034	0	0
21500541	791967	4	4
1101539	19019273	2	3
35508513	738818	0	0
36158165	1153428	0	0
36155353	1125315	0	0
36516972	4155034	5	5
42801688	40223834	2	3
44349781	1112807	0	0
42529093	3023103	1	1
44346388	1125315	0	0
45662692	1177480	0	0
44362669	1738521	0	0
45628275	1125315	0	0
45644446	975125	0	0
45639380	1500211	0	0
45664480	19079524	1	1
45680569	1149196	0	0
45704965	738818	0	0
45639997	1149196	0	0
45784300	1539403	0	0
45782490	791967	0	0
45672496	46275916	2	3
45678920	1177480	0	0
45789926	1174888	0	0
46238452	1741122	0	0
45791484	19127890	0	0
45793576	723013	0	0
45895742	791967	0	0
46312108	1125315	0	0
45802517	19078461	2	3
4047779	257012	4	7
1310149	1310149	0	0
21500648	1125315	4	4
1101539	19078461	2	3
35508513	1119510	0	0
36158236	1177480	0	0
36155356	1125315	0	0
36503290	40479422	5	5
42801655	40169216	2	3
44349794	738818	0	0
42529414	3051031	1	1
44346468	1125315	0	0
45662823	1177480	0	0
44362512	1115008	0	0
45628278	1125315	0	0
45641555	975125	0	0
45639252	1107830	0	0
45659018	19079524	1	1
45680658	1713332	0	0
45704893	1551099	0	0
45640009	1107830	0	0
45784000	975125	0	0
45782610	738818	0	0
45672592	40163554	2	3
45678952	1177480	0	0
45789810	738818	0	0
46238756	1112807	0	0
45791484	1549786	0	0
45793556	1310149	0	0
45895782	975125	0	0
46312304	1125315	0	0
45788704	1107882	2	3
4047779	4132546	4	7
1309944	1309944	0	0
21500648	1112807	4	4
1101498	1115171	2	3
35508515	1119510	0	0
36156508	738818	0	0
36155369	1125315	0	0
36503290	40479768	5	5
42801661	43012036	2	3
44349799	1153428	0	0
42529473	3049273	1	1
44346471	1125315	0	0
45662652	1177480	0	0
44362687	1589505	0	0
45626120	1125315	0	0
45641601	975125	0	0
45640143	1192710	0	0
45634139	46275916	1	1
45680658	1759842	0	0
45704655	1738521	0	0
45639846	708298	0	0
45784103	1115008	0	0
45782614	1551099	0	0
45784260	19074843	2	3
45706690	1129625	0	0
45789936	19127890	0	0
46238591	1367571	0	0
45791413	1713332	0	0
45793675	1332418	0	0
45895681	1557272	0	0
46312314	1125315	0	0
45795974	19078461	2	3
4047779	255848	4	7
975125	975125	0	0
21600959	1322184	4	4
1101498	19019273	2	3
35508564	1177480	0	0
36156508	1112807	0	0
36155370	1125315	0	0
36516993	4048171	5	5
42801819	920334	2	3
44349474	975125	0	0
42902167	42902245	1	1
44346140	1125315	0	0
45662563	1177480	0	0
44362687	1549786	0	0
45626196	1125315	0	0
45638248	975125	0	0
45640218	1343916	0	0
45662193	46275916	1	1
45680666	1367571	0	0
45704869	742185	0	0
45639892	1115008	0	0
45783928	1192710	0	0
45782623	1154343	0	0
45784262	40229134	2	3
45706866	1129625	0	0
45789936	1549786	0	0
46238543	1738521	0	0
45791413	1759842	0	0
45793612	1589505	0	0
45895685	1589505	0	0
46312241	1125315	0	0
46295431	1332419	2	3
4047779	28060	4	7
255848	255848	0	0
21600959	1595799	4	4
1101498	19019979	2	3
35508781	1125315	0	0
36156510	738818	0	0
36155371	1125315	0	0
36516993	4296204	4	5
42804111	19078924	2	3
44349475	1124957	0	0
42902242	42902245	1	1
44346648	1125315	0	0
45661232	1177480	0	0
44362791	1149196	0	0
45626200	1125315	0	0
45640224	975125	0	0
45640221	1738521	0	0
45662193	19079524	1	1
45680574	738818	0	0
45704870	738818	0	0
45639939	1539403	0	0
45783933	1154029	0	0
45782624	1000560	0	0
45784280	40229134	2	3
45705372	1129625	0	0
45790219	1112807	0	0
46238548	1149196	0	0
45791325	1149196	0	0
45793681	1149196	0	0
45895743	1713332	0	0
46312329	1125315	0	0
46244425	1107882	2	3
4047779	40481087	4	7
4024958	4024958	0	0
21503444	1125315	4	4
4030660	4242997	3	3
35508781	1119510	0	0
36156510	1119510	0	0
36155525	1125315	0	0
36302167	439777	4	5
42806182	43012036	2	3
44349646	1149196	0	0
42902243	42902245	1	1
44346749	1125315	0	0
45661538	1177480	0	0
44362482	967823	0	0
45626171	1125315	0	0
45638456	975125	0	0
45640219	1332418	0	0
45634034	19079524	1	1
45680575	1326303	0	0
45704798	1539403	0	0
45640035	1768849	0	0
45784063	1115008	0	0
45769019	45769019	0	0
45784341	1551192	2	3
45779955	1129625	0	0
45789814	1174888	0	0
46238826	1192710	0	0
45791166	1539403	0	0
45793779	1192710	0	0
45895743	1759842	0	0
46312444	1125315	0	0
45801884	1107882	2	3
4047779	80180	4	4
4015189	4015189	0	0
21503444	1595799	4	4
4133169	4330583	3	3
35508713	1125315	0	0
36156510	1112807	0	0
36155483	1125315	0	0
36516993	134438	4	4
42806129	1154615	2	3
44349483	1332418	0	0
42801873	19128009	2	2
44346575	1125315	0	0
45661457	1177480	0	0
44354914	975125	0	0
45626219	1125315	0	0
45638538	975125	0	0
45640176	1153428	0	0
45622385	19079524	1	1
45680579	738818	0	0
45704899	723013	0	0
45639727	738818	0	0
45784121	1713332	0	0
45702582	1192710	0	0
45784361	1115171	2	3
45779959	1129625	0	0
45790167	1501700	0	0
46238827	1192710	0	0
45791421	1192710	0	0
45793785	1557272	0	0
45801999	1738521	0	0
46312506	1125315	0	0
46241863	1107882	2	3
4047779	4051466	4	4
4166224	4166224	0	0
21503444	1308738	4	4
4133169	4117038	3	3
35508713	1119510	0	0
36156274	1107830	0	0
36155491	1125315	0	0
36703458	378419	4	4
42806260	19073188	2	3
44349975	1112807	0	0
42529086	3023103	2	2
44346533	1125315	0	0
45659352	1177480	0	0
44355002	740275	0	0
45626132	1125315	0	0
45635184	975125	0	0
45640244	1000560	0	0
45621246	19079524	1	1
45680868	1307863	0	0
45705006	1343916	0	0
45639827	705944	0	0
45784227	920293	0	0
45702588	19127890	0	0
45784480	19123231	2	3
45779870	1129625	0	0
45790175	1192710	0	0
46238830	1192710	0	0
45791423	933724	0	0
45793725	1759842	0	0
45801965	1102527	0	0
46312567	1125315	0	0
46297929	1107882	2	3
4047779	80809	4	5
4149245	4149245	0	0
21503444	1396131	4	4
4300244	4323902	3	3
35508273	1177480	0	0
36156512	1738521	0	0
36155507	1125315	0	0
36503290	4149245	4	4
42806262	19133905	2	3
44349977	1738521	0	0
42529086	3016723	2	2
44346764	1125315	0	0
45659395	1177480	0	0
44355007	1000560	0	0
45626137	1125315	0	0
45635608	975125	0	0
45635777	723013	0	0
45621246	46275916	1	1
45680779	1501700	0	0
45704970	738818	0	0
45640122	1713332	0	0
45784073	1309944	0	0
45702588	1512674	0	0
45784392	40162522	2	3
45780030	1129625	0	0
45790178	1124300	0	0
46238831	1192710	0	0
45791490	1738521	0	0
45793835	1309944	0	0
45801907	723013	0	0
46312600	1125315	0	0
46289431	1107882	2	3
4047779	80502	4	5
4180628	378001	6	8
21503444	967823	4	4
4176642	4246502	3	3
21602553	1521369	0	0
36154202	1174888	0	0
36155581	1125315	0	0
36302166	42535580	4	4
42806288	19018935	2	3
44349990	708298	0	0
42888893	196456	3	3
44346776	1125315	0	0
45659680	1177480	0	0
44355043	1124300	0	0
45626139	1125315	0	0
45632565	975125	0	0
45635780	1124300	0	0
45622175	19079524	1	1
45680427	1149196	0	0
45704971	1343916	0	0
45685910	740275	0	0
45784130	723013	0	0
45702588	1549786	0	0
45784457	40229134	2	3
45706104	1129625	0	0
45789990	1308738	0	0
46238565	1153428	0	0
45791435	1713332	0	0
45793832	1738521	0	0
45802021	705944	0	0
46312473	1125315	0	0
45790487	1332419	2	3
4047779	4116491	4	5
253549	4230399	6	7
21503444	1192710	4	4
141960	134438	3	3
21603992	1118084	0	0
36154202	1125315	0	0
36155637	1125315	0	0
36516728	4048695	4	4
42806345	40224805	2	3
44349993	1174888	0	0
42888894	4037675	5	5
44346782	1125315	0	0
45656432	1177480	0	0
44354751	1549786	0	0
45626262	1125315	0	0
45632627	975125	0	0
45635793	1115008	0	0
45628735	19079524	1	1
45680810	1115008	0	0
45704911	1322184	0	0
45685855	1149196	0	0
45784239	738818	0	0
45702570	1115008	0	0
45784435	1115171	2	3
45706356	1129625	0	0
45789992	738818	0	0
46238599	1332418	0	0
45791430	1713332	0	0
45793520	1153428	0	0
45802024	914335	0	0
46312829	1125315	0	0
45790668	40223768	2	3
4047779	40486433	4	8
4180628	4059173	6	7
21503146	753626	4	4
4034850	40478878	3	3
21604051	1124300	0	0
36154216	1177480	0	0
36155609	1125315	0	0
36516728	4059173	4	4
42806426	19133905	2	3
44349996	1515774	0	0
43530877	40479422	6	7
44346685	1125315	0	0
45656257	1177480	0	0
44354751	1589505	0	0
45626344	1125315	0	0
45632481	975125	0	0
45635794	1154343	0	0
45620864	19079524	1	1
45680816	975125	0	0
45705013	1124300	0	0
45685829	738818	0	0
45784240	1115008	0	0
45702633	1174888	0	0
45782211	40232448	2	3
45706296	1129625	0	0
45789995	1551099	0	0
46238603	19010482	0	0
45791430	1759842	0	0
45793637	967823	0	0
45802028	1149196	0	0
46312831	1125315	0	0
45801126	40223768	2	3
4047779	4149245	4	8
4101796	378001	6	6
21503146	1343916	4	4
4077953	4043071	3	3
21602848	1728416	0	0
36154234	1545958	0	0
36155749	1125315	0	0
36516728	4066995	4	4
42806320	40231925	2	3
44349996	1549786	0	0
40490903	4107731	5	5
44346617	1125315	0	0
45656611	1177480	0	0
44354755	914335	0	0
45626338	1125315	0	0
45632707	975125	0	0
45635850	1305058	0	0
45646249	19079524	1	1
45680821	1149196	0	0
45705018	738818	0	0
45685807	705944	0	0
45784234	1322184	0	0
45702644	1110410	0	0
45782335	19133873	2	3
45699742	1129625	0	0
45789996	1332418	0	0
46238604	1107830	0	0
45791438	967823	0	0
45793683	1124300	0	0
45802002	1153428	0	0
46306958	1125315	0	0
46242114	1107882	2	3
4047779	4294548	4	8
4086921	4324181	6	6
21503146	1154029	4	4
4172515	4035793	3	3
21602849	1728416	0	0
36154247	1000560	0	0
36102977	198199	1	3
36516728	4278672	4	4
42803988	40229134	2	3
44350007	1713332	0	0
43531052	4166224	5	6
44346665	1125315	0	0
45656538	1177480	0	0
44354711	1545958	0	0
45626305	1125315	0	0
45629387	975125	0	0
45635901	1310149	0	0
45643148	19079524	1	1
45680785	715997	0	0
45705026	791967	0	0
45685816	1310149	0	0
45784081	1107830	0	0
45702843	791967	0	0
45782221	43012036	2	3
45699917	1129625	0	0
45790022	1738521	0	0
46238667	1174888	0	0
45791564	1192710	0	0
45793640	1124300	0	0
45802013	1102527	0	0
46307109	1125315	0	0
45790359	40228214	2	3
4047779	260139	4	8
4086921	4163874	7	7
21503146	19039298	4	4
4300185	4337138	3	3
21602823	1713332	0	0
36154249	1125315	0	0
36110715	4112343	1	3
36516972	4146173	1	7
42804038	1551192	2	3
44349953	1000560	0	0
45655713	19079524	1	1
44346667	1125315	0	0
45656382	1177480	0	0
44355050	1115008	0	0
45626381	1125315	0	0
45629502	975125	0	0
45635907	738818	0	0
45628496	19079524	1	1
45680430	967823	0	0
45704912	791967	0	0
45685817	1551099	0	0
45784297	1322184	0	0
45702850	1107830	0	0
45782357	19008572	2	3
45699843	1129625	0	0
45790025	1501700	0	0
46238779	1107830	0	0
45791565	975125	0	0
45793690	1149196	0	0
45802018	1115008	0	0
46312038	1125315	0	0
45893834	19078461	2	3
4047779	440448	4	9
253549	78272	7	8
21503146	19002770	4	4
4042673	4057420	3	3
36009742	4102123	0	0
36154211	1177480	0	0
36110715	4294548	1	3
36228634	19045231	1	2
42803681	19018935	2	3
44350195	914335	0	0
45655713	46275916	1	1
44346713	1125315	0	0
45656647	1177480	0	0
44355079	1149196	0	0
45626312	1125315	0	0
45629503	975125	0	0
45636072	1153428	0	0
45625376	19079524	1	1
45680708	1305058	0	0
45704934	967823	0	0
45685876	740275	0	0
45783942	1149196	0	0
45702595	967823	0	0
45782368	1115171	2	3
45699851	1129625	0	0
45790118	19003953	0	0
46238782	723013	0	0
45791447	1717327	0	0
45793536	1738521	0	0
45802039	1115008	0	0
46312066	1125315	0	0
46242267	19075601	2	3
4047779	4112343	4	9
253549	4134304	7	8
21503146	708298	4	4
4185916	4047491	3	3
36009768	133834	0	0
36154250	1129625	0	0
36102977	4056621	3	3
36228635	19045231	1	2
42804049	40162522	2	3
44350196	1515774	0	0
45620644	19079524	1	1
44346715	1125315	0	0
45652927	1177480	0	0
44355017	1124300	0	0
45622799	1125315	0	0
45629585	975125	0	0
45636073	791967	0	0
45643249	19079524	1	1
45680553	1115008	0	0
45701268	738818	0	0
45685792	967823	0	0
45781904	723013	0	0
45702476	1000560	0	0
45782544	19073188	2	3
45693338	1129625	0	0
45790231	1154343	0	0
46238639	1501700	0	0
45791443	1149196	0	0
45793725	1713332	0	0
45801970	1367571	0	0
46307337	1125315	0	0
46291822	19078461	2	3
4047779	78272	4	10
255919	4048171	7	9
21503146	782043	4	4
4179871	45769019	3	3
36009735	134438	0	0
36154250	1125315	0	0
36110704	4048171	3	3
36230662	19074679	1	2
42804051	1551192	2	3
44350196	19127890	0	0
45655577	46275916	1	1
44346717	1125315	0	0
45653162	1177480	0	0
44355020	1124300	0	0
45622808	1125315	0	0
45631323	975125	0	0
45636004	1539403	0	0
45637536	19079524	1	1
45680713	1154343	0	0
45701270	1149380	0	0
45685959	1115008	0	0
45781883	1308738	0	0
45702608	1551099	0	0
45782509	19078924	2	3
45693460	1129625	0	0
45790095	1309944	0	0
46238651	967823	0	0
45791545	791967	0	0
45793618	1501700	0	0
45801909	1545958	0	0
46307154	1125315	0	0
45895785	19078461	2	3
4180628	317009	2	2
4028071	81893	8	9
21500223	1332418	4	4
21500594	19078461	5	6
36009691	439406	0	0
36154251	1326303	0	0
36110712	258780	3	3
36230663	19074679	1	2
42804058	19133905	2	3
44350196	1549786	0	0
45655577	19079524	1	1
44346518	1125315	0	0
45653416	1177480	0	0
44355081	715997	0	0
45622756	1125315	0	0
45631233	975125	0	0
45636101	1548195	0	0
45631399	19079524	1	1
45680729	1110410	0	0
45701144	1153428	0	0
45685941	1174888	0	0
45781941	1115008	0	0
45702744	1000560	0	0
45782537	1551192	2	3
45693726	1129625	0	0
45790087	1112807	0	0
46238615	1738521	0	0
45791500	1124957	0	0
45793630	975125	0	0
45802092	1000560	0	0
46307165	1125315	0	0
45804071	19075601	2	3
4180628	4066995	4	7
77960	40479422	5	5
21500223	1307863	4	4
21500594	19019273	5	6
36009700	317009	0	0
36154236	1545958	0	0
36110570	40481087	3	3
36230245	43012433	1	2
42805404	19073183	2	3
44349970	1177480	0	0
45655710	19079524	1	1
44346146	1125315	0	0
45653317	1177480	0	0
44355108	1149380	0	0
45622760	1125315	0	0
45626642	975125	0	0
45636101	1515774	0	0
44782620	4152936	4	4
45680731	1124957	0	0
45701163	791967	0	0
45685643	1713332	0	0
45781891	1154343	0	0
45702651	738818	0	0
45782238	1115171	2	3
45693728	1129625	0	0
45790003	1367571	0	0
46238619	705944	0	0
45791292	975125	0	0
45793641	1115008	0	0
45802049	975125	0	0
46307380	1125315	0	0
45893835	19078461	2	3
4180628	261325	4	7
77960	40479768	5	5
21506125	19074679	1	1
21500594	1115171	5	6
36211457	4296205	0	0
36154238	1129625	0	0
35702118	192671	3	3
36230246	43012433	1	2
42804107	1551192	2	3
44350162	1177480	0	0
45620721	19079524	1	1
44346830	1125315	0	0
45652950	1177480	0	0
44355109	1154343	0	0
45622910	1125315	0	0
45626727	975125	0	0
45636106	19010482	0	0
44782620	4035415	3	3
45680669	967823	0	0
45701272	738818	0	0
45685613	1174888	0	0
45781967	738818	0	0
45702652	738818	0	0
45782419	19008572	2	3
45693792	1129625	0	0
45790021	1124957	0	0
46238624	757627	0	0
46298711	1192710	0	0
45793642	1115008	0	0
45802050	1153428	0	0
46307219	1125315	0	0
45795943	19079524	2	3
4180628	4112343	4	8
432795	4218389	5	5
21003454	19127904	1	1
21500594	19019979	5	6
36211458	4299128	0	0
36154239	1129625	0	0
36212270	19074679	1	2
36232608	19132304	1	2
42801330	920300	2	3
44350168	1192710	0	0
45620545	19127918	1	1
44346820	1125315	0	0
45653452	1177480	0	0
44355113	1107830	0	0
45623138	1125315	0	0
45623534	975125	0	0
45636093	1326303	0	0
44782620	4059173	3	3
45680856	1124957	0	0
45701275	1154029	0	0
45686077	1000560	0	0
45781971	1110410	0	0
45702653	738818	0	0
45702528	40232448	2	3
45693797	1129625	0	0
45790106	1000560	0	0
46238750	1110410	0	0
46298597	1124300	0	0
45793650	1153428	0	0
45802065	1307863	0	0
46307226	1125315	0	0
45789181	40174880	2	3
4180628	78272	4	9
4021667	4230399	5	5
21003454	19132304	1	1
21503082	920334	6	7
36152830	1545958	0	0
36154240	1192710	0	0
36212774	40229134	1	2
36516728	80502	1	1
42801389	1551192	2	3
44350168	1112807	0	0
45620365	46275916	1	1
44346288	1125315	0	0
45649921	1177480	0	0
44355149	1548195	0	0
45623148	1125315	0	0
45623361	975125	0	0
45636126	1361711	0	0
44782620	4109685	3	3
45680672	1115008	0	0
45701250	1548195	0	0
45686080	1332418	0	0
45782117	19003953	0	0
45702691	1343916	0	0
45702589	1127433	2	3
45690632	1129625	0	0
45790188	738818	0	0
46238658	1149196	0	0
46298600	1000560	0	0
45793793	1000560	0	0
45801915	975125	0	0
46307235	1125315	0	0
45788721	19075601	2	3
1589505	19132304	2	3
4021667	4156265	5	5
21003454	19127918	1	1
21503082	920300	6	7
36152833	975125	0	0
36154240	1125315	0	0
36212775	40229134	1	2
36427424	1127433	2	3
43053690	4142905	2	3
44349485	1112807	0	0
45620543	46275916	1	1
44346299	1125315	0	0
45649621	1177480	0	0
44355154	1110410	0	0
45623153	1125315	0	0
45623569	975125	0	0
45636097	1174888	0	0
44782620	81151	3	4
45680674	1000560	0	0
45701129	1713332	0	0
45685619	738818	0	0
45781925	1118084	0	0
45702543	1174888	0	0
45702472	40232448	2	3
45690678	1129625	0	0
45787360	1149380	0	0
46238788	1738521	0	0
46298265	1539403	0	0
45793762	1539403	0	0
45802100	1501700	0	0
46307417	1125315	0	0
46295242	19075601	2	3
1500211	40224132	2	3
441840	4116491	6	8
21003454	19128065	1	1
21503082	40236824	6	7
36152772	1177480	0	0
36154241	1125315	0	0
36220586	40169281	1	2
36427424	40231925	2	3
43053690	40480160	2	3
44350206	1332418	0	0
44347714	40220386	1	1
44346790	1125315	0	0
45649758	1177480	0	0
44355164	705944	0	0
45622880	1125315	0	0
45667941	975125	0	0
45636223	1551099	0	0
44782620	40479768	5	5
45682498	1124957	0	0
45701208	1174888	0	0
45686089	1124300	0	0
45781929	967823	0	0
45702546	738818	0	0
45702608	1551192	2	3
45690659	1129625	0	0
45787360	1137529	0	0
46238818	975125	0	0
46298741	1343916	0	0
45793839	1149196	0	0
45802103	19039298	0	0
46307974	1125315	0	0
45893837	19078461	2	3
1500211	40224805	2	3
441840	4146173	6	10
21003454	19128009	1	1
21503146	19078924	6	7
36152895	1177480	0	0
36154241	1112807	0	0
36221037	19132304	1	2
36427424	40229134	2	3
42806227	1154615	2	3
44349882	1115008	0	0
44347911	19129144	1	1
44346792	1125315	0	0
45649962	1177480	0	0
44354976	738818	0	0
45623190	1125315	0	0
45665476	975125	0	0
45636145	1551099	0	0
44782620	40479422	5	5
45682455	1149196	0	0
45701214	1107830	0	0
45686174	740275	0	0
45782076	1549786	0	0
45702548	1192710	0	0
45702651	40229134	2	3
45690704	1129625	0	0
45787436	738818	0	0
46240079	1115008	0	0
46298529	1500211	0	0
45793657	708298	0	0
45801973	1107830	0	0
46307593	1125315	0	0
45801852	19078461	2	3
1361711	19126352	2	3
441840	4001336	6	10
21003454	19127922	1	1
21503146	782047	6	7
36153082	1125315	0	0
36154242	1119510	0	0
36221037	46221626	1	2
36427424	40162522	2	3
42806380	1115171	2	3
44349896	1124300	0	0
44347911	19127922	1	1
44346601	1125315	0	0
45651888	1177480	0	0
44355138	738818	0	0
45623090	1125315	0	0
45665711	975125	0	0
45644673	40228214	2	3
44783379	4301346	3	4
45682544	1713332	0	0
45701219	1713332	0	0
45686201	1153428	0	0
45782076	1518198	0	0
45702852	1174888	0	0
45702660	19019273	2	3
45690884	1129625	0	0
45787441	1112807	0	0
46240157	975125	0	0
46298416	1118084	0	0
45793798	1309944	0	0
45802056	1545958	0	0
46307545	1125315	0	0
45897887	19079524	2	3
1107830	1107882	2	3
441840	81151	6	11
21003454	19128263	1	1
21500582	40162522	6	7
36153148	975125	0	0
36154242	1125315	0	0
36223222	19123231	1	2
36427424	19133768	2	3
42801515	920334	2	3
44350088	738818	0	0
44347911	19133679	1	1
44346608	1125315	0	0
45646852	1177480	0	0
44355091	1322184	0	0
45623019	1125315	0	0
45665520	975125	0	0
45663443	40228214	2	3
45622194	19128009	3	4
45682560	1326303	0	0
45701219	1759842	0	0
45637423	1174888	0	0
45781946	1174888	0	0
45702853	1396131	0	0
45702941	40162522	2	3
45690955	1129625	0	0
45787441	1192710	0	0
46240158	1115008	0	0
46298601	1309944	0	0
45793799	1115008	0	0
45801919	738818	0	0
46307312	1125315	0	0
46297643	19079524	2	3
1107830	19125062	2	3
441840	258780	6	11
21003454	43012433	1	1
21500574	19019273	6	7
36153037	1112807	0	0
36154233	1545958	0	0
36223223	19123231	1	2
36427424	1127078	2	3
42806225	40236446	2	3
44349498	1149380	0	0
44348134	19074679	1	1
44348442	1125315	0	0
45646891	1177480	0	0
44354937	1107830	0	0
45623037	1125315	0	0
45665875	975125	0	0
45647507	19078461	2	3
45620913	19128022	3	4
45680883	1759842	0	0
45701221	791967	0	0
45637226	1149196	0	0
45781990	1738521	0	0
45702725	1343916	0	0
45702922	40163554	2	3
45687759	1129625	0	0
45787443	1112807	0	0
46240163	1000560	0	0
46298488	1174888	0	0
45793803	1738521	0	0
45801922	975125	0	0
46307523	1125315	0	0
46317471	19018935	2	3
701322	40222846	2	3
441840	4230399	6	11
21003454	40221415	1	1
21502709	40169216	9	10
36153265	975125	0	0
36154338	1738521	0	0
36223455	1551192	1	2
36422418	19073188	2	3
42806596	19019273	2	3
44350066	1192710	0	0
45661980	46275916	1	1
44348446	1125315	0	0
45647082	1177480	0	0
44354940	738818	0	0
45623103	1125315	0	0
45659836	975125	0	0
45648066	19078461	2	3
45664748	19127918	3	4
45680905	1154029	0	0
45701166	1539403	0	0
45637234	1115008	0	0
45781992	975125	0	0
45702696	1174888	0	0
45702755	40232448	2	3
45687734	1129625	0	0
45787475	738818	0	0
46240036	1000560	0	0
46298488	1192710	0	0
45793581	967823	0	0
45801976	1115008	0	0
46307204	1125315	0	0
46317726	40236824	2	3
1396131	19077344	2	3
441840	4296204	6	9
21003454	42902245	1	1
21502709	19112599	9	10
36153330	1125315	0	0
36154305	1125315	0	0
36221044	40236446	1	2
36422418	1713671	2	3
42806471	19019273	2	3
44350071	1192710	0	0
45661813	46275916	1	1
44348381	1125315	0	0
45647141	1177480	0	0
44354949	738818	0	0
45623232	1125315	0	0
45659982	975125	0	0
45651063	19078461	2	3
45662172	19127922	3	4
45680887	1738521	0	0
45701358	967823	0	0
45637237	920293	0	0
45782121	738818	0	0
45702558	1192710	0	0
45702902	19019273	2	3
45688505	1129625	0	0
45787477	1343916	0	0
45897591	1501700	0	0
46298494	1154343	0	0
45793819	1308738	0	0
45802093	723013	0	0
46307210	1125315	0	0
46319831	1551192	2	3
1115008	1115171	2	3
441840	4306014	6	7
21003454	19133679	1	1
21502709	40223821	9	10
36152839	1119510	0	0
36154366	1149196	0	0
36220458	19077572	1	2
36422348	1332419	2	3
42806134	19019273	2	3
44350077	1177480	0	0
45658006	40220386	1	1
44348382	1125315	0	0
45647179	1177480	0	0
44355051	738818	0	0
45625063	1125315	0	0
45660004	975125	0	0
45641956	19078461	2	3
44784102	195588	3	3
45677361	708298	0	0
45701361	1713332	0	0
45637300	1153428	0	0
45781948	1551099	0	0
45702659	1738521	0	0
45702908	1545959	2	3
45684544	1129625	0	0
45787244	1548195	0	0
45897693	1551099	0	0
46298723	1107830	0	0
45793761	1557272	0	0
45802059	1115008	0	0
46307802	1125315	0	0
46319409	19019273	2	3
1115008	19019273	2	3
441840	439406	6	7
21003454	19128022	1	1
21502709	40232448	9	10
36153428	1112807	0	0
36154259	1177480	0	0
36219948	19077344	1	2
36428377	1154615	2	3
42801396	1551192	2	3
44350095	1112807	0	0
45655823	1127433	1	1
44342672	1125315	0	0
45646890	1177480	0	0
44355180	1738521	0	0
45624908	1125315	0	0
45660142	975125	0	0
45624105	19078461	2	3
44783028	4146173	3	3
45677232	1501700	0	0
45701365	1192710	0	0
45637333	1308738	0	0
45782095	1549786	0	0
45702660	1115008	0	0
45696704	19018935	2	3
45684670	1129625	0	0
45787244	1589505	0	0
45897787	1149380	0	0
46298603	1361711	0	0
45793588	975125	0	0
45801984	1115008	0	0
46307804	1125315	0	0
45895578	1127433	2	3
708298	19078924	2	3
441840	4285898	5	12
21003454	19129144	1	1
21502709	1343916	7	7
36152839	1125315	0	0
36154261	1118084	0	0
36220457	19077572	1	2
36423716	1713671	2	3
42804080	19075001	2	3
44350097	920293	0	0
45649227	46275916	1	1
44342766	1125315	0	0
45644062	1177480	0	0
44355183	1107830	0	0
45625112	1125315	0	0
45659741	975125	0	0
45657582	19078461	2	3
44783378	4301346	3	3
45677354	1310149	0	0
45701379	1501700	0	0
45636684	1115008	0	0
45782095	19127890	0	0
45702790	1192710	0	0
45696779	40174880	2	3
45684672	1129625	0	0
45787256	738818	0	0
45897870	1192710	0	0
46298941	1551099	0	0
45793669	1174888	0	0
45802072	1153428	0	0
46307681	1125315	0	0
45895645	40231925	2	3
1580955	40223768	2	3
3049150	3036780	2	2
21003454	46221626	1	1
21502709	738818	7	7
36153096	1125315	0	0
36154284	1551099	0	0
36220587	40169216	1	2
36424953	40169281	2	3
42806332	1551192	2	3
44350127	738818	0	0
45661643	19079524	1	1
44342777	1125315	0	0
45643952	1177480	0	0
44354970	1545958	0	0
45625018	1125315	0	0
45649377	1192710	0	0
45644825	19078461	2	3
44782619	4230399	3	3
45677390	738818	0	0
45701230	1124300	0	0
45636693	1107830	0	0
45782095	1512674	0	0
45702941	1174888	0	0
45696780	19008572	2	3
45684588	1129625	0	0
45787257	1107830	0	0
45897873	1738521	0	0
46298902	933724	0	0
45788431	1738521	0	0
45802125	1118084	0	0
46307367	1125315	0	0
45895741	1107882	2	3
914335	40243436	2	3
3049150	3023430	2	2
21002475	19128009	1	1
21502709	1150770	7	7
36153096	1119510	0	0
36154293	1124957	0	0
36223225	1545959	1	2
36424953	40169216	2	3
42804295	19019273	2	3
44349832	933724	0	0
45649244	19079524	1	1
44342760	1125315	0	0
45644041	1177480	0	0
44355055	975125	0	0
45623280	1125315	0	0
45649348	1192710	0	0
45644383	19078461	2	3
44782503	4301346	3	3
45677492	1115008	0	0
45701292	1124957	0	0
45636777	1545958	0	0
45781919	1192710	0	0
45702954	1548195	0	0
45672469	19019273	2	3
45684612	1129625	0	0
45787373	1149196	0	0
45897686	1310149	0	0
46298586	1310149	0	0
45788233	1000560	0	0
45802252	1192710	0	0
46302204	1125315	0	0
45876029	3005136	2	3
1129625	40232448	2	3
3049209	3023430	2	2
21002475	42902245	1	1
21502709	1125443	7	7
36153335	1177480	0	0
36154294	1551099	0	0
36223224	1545959	1	2
36424954	40169216	2	3
42804522	19019273	2	3
44349839	1174888	0	0
44345811	46275916	1	1
44342762	1125315	0	0
45644121	1177480	0	0
45655591	708298	0	0
45621487	1125315	0	0
45649300	1192710	0	0
45639138	19078461	2	3
45651648	19127918	2	2
45677651	1124300	0	0
45701293	1107830	0	0
45636717	715997	0	0
45782045	1149380	0	0
45702958	1501700	0	0
45784027	46233710	2	3
45684601	1129625	0	0
45787380	967823	0	0
45897778	1713332	0	0
46298593	975125	0	0
45788547	975125	0	0
45802083	705944	0	0
46302376	1125315	0	0
45876029	3036780	2	3
1192710	43012036	2	3
3049209	3005136	2	2
21001669	1551192	2	3
21502709	1107830	7	7
36153336	1115008	0	0
36154295	1551099	0	0
36214108	19019979	1	2
36424954	40169281	2	3
42807080	19123231	2	3
44349852	1112807	0	0
44345863	46275916	1	1
44342788	1125315	0	0
45644145	1177480	0	0
45655496	1501700	0	0
45621511	1125315	0	0
45649453	1192710	0	0
45668005	19078461	2	3
45651648	19128009	2	2
45677657	914335	0	0
45701177	1713332	0	0
45636721	1501700	0	0
45782122	1322184	0	0
45702960	1501700	0	0
45680007	19078924	2	3
45681727	1129625	0	0
45787196	738818	0	0
45897716	1110410	0	0
46299300	1000560	0	0
45788186	975125	0	0
45802085	1124300	0	0
46302151	1125315	0	0
45876029	3023430	2	3
1713332	1713671	2	3
3049209	3036780	2	2
21002326	1713671	2	3
21502709	967823	7	7
36153337	1125315	0	0
36154288	1154343	0	0
36214108	19078461	1	2
36426127	40174880	2	3
42804313	19019273	2	3
44350009	1177480	0	0
43530876	4329847	1	1
44343084	1125315	0	0
45644192	1177480	0	0
45655537	975125	0	0
45629763	43012036	2	3
45632050	1192710	0	0
45629789	19078461	2	3
45624185	19128022	2	2
45677408	1307863	0	0
45701177	1759842	0	0
45636757	1738521	0	0
45782065	1174888	0	0
45702813	738818	0	0
45672259	46233988	2	3
45681844	1129625	0	0
45787197	1154343	0	0
45897837	1332418	0	0
46298946	1343916	0	0
45788553	705944	0	0
45802088	723013	0	0
46301861	1125315	0	0
45876033	3015632	2	3
1713332	19073183	2	3
3049219	3036780	2	2
21002731	46233988	2	3
21502709	1137529	7	7
36153337	1119510	0	0
36154304	1149196	0	0
36214107	19019979	1	2
36428442	1539411	2	3
42803971	1545959	2	3
44350190	1501700	0	0
44786912	3023103	1	1
44342925	1125315	0	0
45644096	1177480	0	0
45655137	1539403	0	0
45629739	19133905	2	3
45632255	1192710	0	0
45657322	19078461	2	3
45639424	19128022	2	2
45677428	1153428	0	0
45701181	1501700	0	0
45636758	1124300	0	0
45782071	1521369	0	0
45702920	1539403	0	0
45672259	46233710	2	3
45681790	1129625	0	0
45787269	738818	0	0
45897665	1192710	0	0
46298948	1551099	0	0
45788357	1738521	0	0
45802152	738818	0	0
46302300	1125315	0	0
45876033	3023103	2	3
1110410	35605858	2	3
3050400	3005136	2	2
21002731	46233710	2	3
21500120	1512674	7	7
36153338	1589505	0	0
36154402	791967	0	0
36214107	19078461	1	2
36422432	19129655	2	3
42804110	1545959	2	3
44350146	1177480	0	0
44786936	3051031	1	1
44342931	1125315	0	0
45644227	1177480	0	0
45655588	933724	0	0
45629739	19133873	2	3
45632125	1192710	0	0
45657391	19078461	2	3
45634966	40174880	2	3
45677496	1307863	0	0
45701184	1107830	0	0
45636773	1000560	0	0
45782099	1149196	0	0
45702922	1310149	0	0
45672298	19078461	2	3
45681973	1129625	0	0
45787533	1107830	0	0
45897781	1332418	0	0
46298769	1149196	0	0
45788401	1107830	0	0
45802062	1545958	0	0
46302389	1125315	0	0
45876033	3014576	2	3
1112807	19059056	2	3
3050400	3036780	2	2
21003385	1551192	2	3
21502620	19133873	7	8
36153339	1112807	0	0
36154341	1125315	0	0
36110229	433125	0	1
36426182	19132304	2	3
42804254	1545959	2	3
44350148	1112807	0	0
44816088	44816277	1	1
44343091	1125315	0	0
45641011	1177480	0	0
45655217	1149196	0	0
45629775	19019273	2	3
45631870	1192710	0	0
45635578	19078461	2	3
45635001	1115171	2	3
45677506	1000560	0	0
45703455	1501700	0	0
45636821	791967	0	0
45782056	1174888	0	0
45702931	967823	0	0
45699371	19075001	2	3
45681950	1129625	0	0
45787535	742185	0	0
45897864	1174888	0	0
46298783	1501700	0	0
45788312	1124957	0	0
45802165	1545958	0	0
46302395	1125315	0	0
45876033	3027970	2	3
1119510	40229134	2	3
3050400	3023430	2	2
21003393	1551192	2	3
21502620	19073188	7	8
36153600	1112807	0	0
36154342	933724	0	0
36110584	260139	0	1
36426182	46221626	2	3
42801993	46233988	2	3
44350150	1124957	0	0
44361161	40171902	1	1
44343011	1125315	0	0
45641148	1177480	0	0
45655144	1595799	0	0
45629915	19019273	2	3
45632002	1192710	0	0
45633031	19078461	2	3
45634986	19075601	2	3
45677446	1501700	0	0
45703461	1000560	0	0
45636826	723013	0	0
45782061	967823	0	0
45702756	967823	0	0
45696027	40228214	2	3
45678521	1129625	0	0
45787482	1149196	0	0
45897864	1192710	0	0
46299006	1545958	0	0
45788302	1154029	0	0
45802168	1154029	0	0
46302433	1125315	0	0
45802381	19078461	2	3
1125315	1127433	2	3
3050409	3005136	2	2
21001833	46233988	2	3
21503160	1129625	6	6
36153602	1129625	0	0
36154344	1129625	0	0
36102977	195588	1	1
36426182	43012754	2	3
42801993	46233710	2	3
44349678	1332418	0	0
44786889	3016723	2	2
44343292	1125315	0	0
45641210	1177480	0	0
45655144	1308738	0	0
45629770	19133768	2	3
45632233	1192710	0	0
45629766	19078461	2	3
45635004	19019273	2	3
45677434	1545958	0	0
45703632	1149196	0	0
45636865	723013	0	0
45781997	705944	0	0
45702763	1149380	0	0
45687750	40223768	2	3
45678545	1129625	0	0
45787541	967823	0	0
45897723	1107830	0	0
46298556	1729720	0	0
45788305	1107830	0	0
45802261	1551099	0	0
46302464	1125315	0	0
45801999	46233710	2	3
1125315	19133768	2	3
3050409	3036780	2	2
21001833	46233710	2	3
21503160	1119510	6	6
36153197	1192710	0	0
35604747	40224805	0	0
36110229	28060	1	1
36426182	1718412	2	3
42806938	46233710	2	3
44349866	1738521	0	0
43530807	4174876	2	2
44343098	1125315	0	0
45641165	1177480	0	0
45655146	1149380	0	0
45626918	40232448	2	3
45634228	1192710	0	0
45650927	19078461	2	3
45635042	40163554	2	3
45677532	1107830	0	0
45703721	1515774	0	0
45636787	738818	0	0
45782142	1174888	0	0
45702764	967823	0	0
45784382	19075001	2	3
45672619	1129625	0	0
45787542	1501700	0	0
45897732	1551099	0	0
46298561	967823	0	0
45788383	1713332	0	0
45802251	1501700	0	0
46302487	1125315	0	0
45802024	40243436	2	3
1125315	40231925	2	3
3050409	3023430	2	2
21001820	46233710	2	3
21503160	1115008	6	6
36153197	1112807	0	0
35605482	35605482	0	0
36110265	28060	1	1
36425092	19077572	2	3
42801381	40223768	2	3
44349871	1118084	0	0
44359965	19128009	2	2
44343190	1125315	0	0
45641267	1177480	0	0
45655266	1149196	0	0
45626921	19018935	2	3
45629320	1192710	0	0
45663871	19078461	2	3
45635286	40228214	2	3
45677417	1174888	0	0
45703721	1549786	0	0
45636958	1307863	0	0
45782108	1118084	0	0
45702902	1115008	0	0
45672227	40223768	2	3
45672421	1129625	0	0
45787278	1307863	0	0
45897738	1500211	0	0
46298876	1713332	0	0
45788392	1174888	0	0
45802213	738818	0	0
46306891	1125315	0	0
45802059	1115171	2	3
1125315	40229134	2	3
3050415	3023430	2	2
21001820	46233988	2	3
21503160	1177480	6	6
36153198	1112807	0	0
35605483	35605482	0	0
35702780	4027663	1	1
36423756	19075601	2	3
42801554	19075001	2	3
44350041	1545958	0	0
44338512	19128009	2	2
44343203	1125315	0	0
45642908	1177480	0	0
45655326	1557272	0	0
45626841	43012036	2	3
45628002	1192710	0	0
45653851	19078461	2	3
45635376	40232448	2	3
45677645	1107830	0	0
45703721	19127890	0	0
45636827	1124957	0	0
45782128	1778162	0	0
45702906	19127890	0	0
45684241	1107882	2	3
45673404	1129625	0	0
45787205	1515774	0	0
45897745	1548195	0	0
46298879	1115008	0	0
45788557	1713332	0	0
45802271	1549786	0	0
46306832	1125315	0	0
45802013	40165015	2	3
1125315	40162522	2	3
3050415	3005136	2	2
21002745	40228230	2	3
21503160	1112807	6	6
36153200	1129625	0	0
35605858	35605858	0	0
36110736	4116491	1	1
36422341	1310034	2	3
42806474	19073183	2	3
44342344	1177480	0	0
44338512	19127918	2	2
44343287	1125315	0	0
45641363	1177480	0	0
45655272	1124957	0	0
45628216	19076374	2	3
45628275	1192710	0	0
45642093	19078461	2	3
45635345	19078461	2	3
45677649	1521369	0	0
45703722	1154343	0	0
45636964	740275	0	0
45782129	1115008	0	0
45702906	1548195	0	0
45702242	1127433	2	3
45672720	1129625	0	0
45787275	1545958	0	0
45897719	1713332	0	0
46299032	1549786	0	0
45788557	1759842	0	0
45802271	1589505	0	0
46306841	1125315	0	0
45802018	1115171	2	3
1125315	1127078	2	3
3050415	3036780	2	2
21002745	1150771	2	3
21503160	738818	6	6
36153228	1129625	0	0
35605859	35605858	0	0
36110687	4294548	1	1
36424218	19076374	2	3
42806558	40223768	2	3
44342347	1332418	0	0
43530877	4329847	2	2
44343173	1125315	0	0
45641351	1177480	0	0
44347889	1118084	0	0
45627041	19078924	2	3
45626345	1192710	0	0
45626769	19078461	2	3
45629899	1115171	2	3
45677447	1149196	0	0
45703726	1515774	0	0
45636969	723013	0	0
45782232	1713332	0	0
45702906	19054876	0	0
45702242	19078461	2	3
45672856	1129625	0	0
45696796	1177480	0	0
45897833	1118084	0	0
46299032	1521369	0	0
45788439	1545958	0	0
45802335	738818	0	0
46306850	1125315	0	0
45801909	1545959	2	3
3039467	3023103	1	3
3050420	3023430	2	2
21002745	19112599	2	3
21503160	1125315	6	6
36153595	1153428	0	0
36002139	4048695	6	7
36110708	257012	1	1
36516993	4310024	2	4
42803048	19073183	2	3
44342203	975125	0	0
43530877	381316	2	2
44343216	1125315	0	0
45637902	1177480	0	0
44347843	933724	0	0
45627083	19075001	2	3
45622983	1192710	0	0
45641968	19078461	2	3
45629903	1127433	2	3
45677585	1539403	0	0
45703726	1549786	0	0
45637104	1332418	0	0
45782232	1759842	0	0
45702908	1545958	0	0
45696023	1127433	2	3
45672731	1129625	0	0
45696383	1177480	0	0
45897836	1539403	0	0
46299041	1192710	0	0
45788439	1332418	0	0
45802338	1115008	0	0
46306311	1125315	0	0
45802103	19023398	2	3
442013	4296204	2	2
3050420	3036780	2	2
21002745	40223821	2	3
21503160	1150836	6	6
36153433	1125315	0	0
35500000	4144583	5	7
36110708	40481087	1	1
36516728	40480160	2	4
42801337	1107882	2	3
44342466	1149380	0	0
44360439	19128022	1	2
44343020	1125315	0	0
45638017	1177480	0	0
44347856	791967	0	0
45623716	1115171	2	3
45621462	1192710	0	0
45660369	40174880	2	3
45630127	1115171	2	3
45677695	1174888	0	0
45701508	1107830	0	0
45637005	1115008	0	0
45782201	975125	0	0
45703039	967823	0	0
45696023	19078461	2	3
45672845	1129625	0	0
45696887	1177480	0	0
45897874	1192710	0	0
46299044	1545958	0	0
45788440	1192710	0	0
45799429	1115008	0	0
46306256	1125315	0	0
45801919	40229134	2	3
4008565	440086	2	2
3050420	3005136	2	2
21002745	1107882	2	3
21503160	1149196	6	6
36153436	1112807	0	0
21604180	19078924	4	7
36111049	4112343	1	1
36503288	4146173	2	8
42805289	40223768	2	3
44342468	1174888	0	0
44360439	19128263	1	2
44339412	1125315	0	0
45637941	1177480	0	0
44347860	1521369	0	0
45623924	40163554	2	3
45621738	1192710	0	0
45644478	1539411	2	3
45629868	1127433	2	3
45677700	738818	0	0
45701544	1149196	0	0
45637011	1107830	0	0
45782204	1551099	0	0
45702912	1192710	0	0
45705409	19079524	2	3
45784682	1129625	0	0
45696750	1177480	0	0
45897905	1713332	0	0
46299134	1713332	0	0
45788565	975125	0	0
45799185	1000560	0	0
46306776	1125315	0	0
45801976	1115171	2	3
4006969	4112343	2	2
3050426	3023430	2	2
21002745	40232448	2	3
21503160	40229134	8	9
36153436	1192710	0	0
21604180	836659	4	7
36111056	40481087	1	1
36503295	4035415	2	2
42806546	1107882	2	3
44342479	791967	0	0
44361043	19127904	1	2
44339602	1125315	0	0
45637827	1177480	0	0
44347860	1549786	0	0
45623943	40232448	2	3
45621530	1192710	0	0
45663839	19079524	2	3
45629994	19008572	2	3
45677709	1115008	0	0
45701551	1115008	0	0
45636894	1539403	0	0
45782460	1154029	0	0
45696720	1539403	0	0
45779864	19075601	2	3
45784550	1129625	0	0
45696831	1177480	0	0
45897896	1112807	0	0
46299219	1713332	0	0
45788188	1000560	0	0
45799499	1367571	0	0
46306899	1125315	0	0
45801984	1115171	2	3
4006969	260139	2	2
3050426	3005136	2	2
21002745	1150837	2	3
21502550	40243436	6	7
36153439	1125315	0	0
21603248	40169281	4	6
36313965	4181917	3	3
36603352	40480160	2	2
42806680	1107882	2	3
44342524	1539403	0	0
44337968	43012036	2	3
44339606	1125315	0	0
45638161	1177480	0	0
44347895	1192710	0	0
45623806	19075001	2	3
45621862	1192710	0	0
45623956	1332419	2	3
45630108	46275444	2	3
45677474	975125	0	0
45701555	708298	0	0
45682784	1551099	0	0
45782187	1174888	0	0
45696501	1174888	0	0
45690570	19078924	2	3
45784552	1129625	0	0
45696864	1177480	0	0
45897703	1112807	0	0
46299219	1759842	0	0
45788452	1000560	0	0
45799500	738818	0	0
46306810	1125315	0	0
45802088	19076374	2	3
4006969	4294548	2	2
3050426	3036780	2	2
21002745	40228214	2	3
21502550	926487	4	4
36153451	1112807	0	0
21602796	46275444	4	6
36313965	4151422	3	3
36302161	4163951	2	2
42804137	1332419	2	3
44342325	1367571	0	0
44338101	1115171	2	3
44339512	1125315	0	0
45638451	1177480	0	0
44347895	1174888	0	0
45623922	1127433	2	3
45667579	1192710	0	0
45630009	1539411	2	3
45630019	40232448	2	3
45677483	914335	0	0
45701464	1396131	0	0
45682768	1124300	0	0
45782274	920293	0	0
45696618	738818	0	0
45693326	40228214	2	3
45789333	920300	2	3
45802662	1177480	0	0
45897917	1500211	0	0
46298926	1124957	0	0
45788322	1107830	0	0
45799416	1595799	0	0
46302579	1125315	0	0
45802152	40229134	2	3
1580779	42902245	2	2
3050442	3023430	2	2
21002745	40223834	2	3
21502550	1129625	4	4
36153470	1107830	0	0
36202157	4296205	6	6
36313965	4246502	3	3
36300000	4234705	3	3
42803300	1539411	2	3
44342528	1332418	0	0
44338294	1127433	2	3
44339242	1125315	0	0
45634854	1177480	0	0
44347817	1343916	0	0
45623456	19078461	2	3
45667481	1192710	0	0
45654152	1332419	2	3
45630191	1545959	2	3
45677487	1539403	0	0
45701468	1124300	0	0
45682769	1361711	0	0
45782276	1154029	0	0
45696621	967823	0	0
45687540	1107882	2	3
45789447	19008572	2	3
45802674	1177480	0	0
45897844	1115008	0	0
46298760	933724	0	0
45788568	1115008	0	0
45799416	1521369	0	0
46299637	1125315	0	0
45802338	1115171	2	3
1586134	40766240	2	2
3050442	3005136	2	2
21002745	19125062	2	3
21502550	738818	4	4
36152782	1548195	0	0
36203062	4218389	6	6
36313965	4133840	3	3
36516993	381316	3	3
42804297	1332419	2	3
44342273	1110410	0	0
44338519	43012036	2	3
44339623	1125315	0	0
45634839	1177480	0	0
44347935	1332418	0	0
45623682	40231925	2	3
45665243	1192710	0	0
45666620	1539411	2	3
45630175	1551192	2	3
45677763	1174888	0	0
45701440	708298	0	0
45682773	738818	0	0
45782011	738818	0	0
45696628	1332418	0	0
45699584	1107882	2	3
45789481	1115171	2	3
45802886	1177480	0	0
45897846	1124957	0	0
46299474	1107830	0	0
45788314	723013	0	0
45799416	1549786	0	0
46299663	1125315	0	0
45799429	1115171	2	3
4023316	81151	2	2
3050442	3036780	2	2
21002745	43012036	2	3
21502549	19074843	8	9
36152846	1119510	0	0
36202155	78272	6	6
36303153	4195803	3	3
36502205	4035415	3	3
42801735	1332419	2	3
44342443	1124300	0	0
44338448	1127433	2	3
44339627	1125315	0	0
44361857	1112807	0	0
44347512	701322	0	0
45624088	1115171	2	3
45662923	1192710	0	0
45627492	19079524	1	1
45630406	40223821	2	3
45677766	967823	0	0
45701445	1738521	0	0
45682717	1124957	0	0
45782130	1501700	0	0
45696666	1310149	0	0
45690509	1107882	2	3
45789869	19073183	2	3
45802728	1177480	0	0
45897856	920293	0	0
46298649	1154343	0	0
45788610	1174888	0	0
45799509	1149196	0	0
46299676	1125315	0	0
45799307	19018935	2	3
3039467	3027970	2	2
3050445	3036780	2	2
21002328	920300	2	3
21502549	19133873	8	9
36152850	1112807	0	0
36002868	4066995	5	6
36303153	4163951	3	3
36503269	4035415	3	3
42801526	19075601	2	3
44342330	1729720	0	0
44338503	40231925	2	3
44339484	1125315	0	0
44362201	1112807	0	0
44347711	1115008	0	0
45624090	1127433	2	3
45662911	1192710	0	0
45639512	19079524	1	1
45627211	19077572	2	3
45677769	791967	0	0
45701501	1192710	0	0
45682812	1149196	0	0
45782308	1322184	0	0
45696673	975125	0	0
45679996	19073183	2	3
45786837	1115171	2	3
45802918	1177480	0	0
45897921	1332418	0	0
46298652	740275	0	0
45788593	1501700	0	0
45799305	708298	0	0
46299887	1125315	0	0
45799549	40236824	2	3
3039467	3006906	2	2
3050445	3023430	2	2
21002328	19075001	2	3
21502549	19073188	8	9
36152850	1192710	0	0
36002868	4048695	5	6
36503288	80180	3	3
36503269	80502	3	3
42804154	19075601	2	3
44342457	738818	0	0
44338394	1154615	2	3
44339558	1125315	0	0
44362167	1112807	0	0
44347712	1713332	0	0
45623894	1115171	2	3
45662915	1192710	0	0
45668991	19079524	1	1
45627230	19073183	2	3
45677773	1589505	0	0
45701504	1192710	0	0
45682721	1149196	0	0
45779563	1192710	0	0
45696676	1778162	0	0
45702850	1107882	2	3
45786500	1127433	2	3
45802870	1177480	0	0
45897952	1738521	0	0
46290359	1713332	0	0
45788598	1174888	0	0
45799306	1713332	0	0
46299800	1125315	0	0
45799363	19019273	2	3
3039467	3004501	2	2
3050445	3005136	2	2
21002328	920334	2	3
21502549	19075001	8	9
36152784	1738521	0	0
36203060	78272	5	6
36303152	4145310	3	3
36603314	4285898	3	3
42804222	19075601	2	3
44342458	1124300	0	0
44341152	40232448	2	3
44339349	1125315	0	0
44362029	1112807	0	0
44347712	1759842	0	0
45668034	1127433	2	3
45662961	1192710	0	0
45654720	19079524	1	1
45627104	19008572	2	3
45677773	1549786	0	0
45701668	1107830	0	0
45682818	1149196	0	0
45779585	1549786	0	0
45696680	1107830	0	0
45685660	1107882	2	3
45786663	19018935	2	3
45802979	1177480	0	0
45897959	19127890	0	0
46290568	933724	0	0
45788427	1308738	0	0
45799306	1759842	0	0
46299933	1125315	0	0
45799526	19075001	2	3
3039467	3024561	2	2
3050465	3023430	2	2
21002328	1713671	2	3
21502549	46233710	8	9
36152785	1177480	0	0
35802832	4048171	5	6
36303130	42535580	3	3
36503249	40480160	3	5
42804141	19075601	2	3
44342530	1118084	0	0
44341206	35605482	2	3
44339438	1125315	0	0
44362068	1112807	0	0
44347714	753626	0	0
45667880	46275444	2	3
45664441	1192710	0	0
45639657	19079524	1	1
45627229	1713671	2	3
45677775	920293	0	0
45701630	1153428	0	0
45682797	1717327	0	0
45779585	19127890	0	0
45696595	967823	0	0
45672585	1107882	2	3
45786511	40232448	2	3
45802883	1177480	0	0
45897959	1549786	0	0
46290583	1738521	0	0
45788428	975125	0	0
45799307	1326303	0	0
46299870	1125315	0	0
45796615	19008572	2	3
3039467	3013721	2	2
3050465	3005136	2	2
21001283	1107882	2	3
21502549	46233988	8	9
36152785	1129625	0	0
21602537	40221415	5	6
36702254	4132546	3	3
36300000	4052083	3	5
42801766	19075601	2	3
44342506	1137529	0	0
44341157	19008572	2	3
44341300	1125315	0	0
45656115	1112807	0	0
44347957	1192710	0	0
45667886	19078461	2	3
45659534	1192710	0	0
45663963	19079524	1	1
45627317	40163554	2	3
45677779	738818	0	0
45701591	1174888	0	0
45682977	738818	0	0
45779585	1589505	0	0
45696702	1154343	0	0
45672243	1107882	2	3
45786512	19059056	2	3
45802847	1177480	0	0
45897937	1501700	0	0
46290469	920293	0	0
45788531	1192710	0	0
45799449	738818	0	0
46299810	1125315	0	0
45796715	19008572	2	3
3039467	3016723	2	2
3050465	3036780	2	2
21001283	1150771	2	3
21502549	19074841	8	9
36153041	1125315	0	0
36206173	3019406	6	6
36703499	375671	3	3
36502205	4149245	3	6
42804245	19075601	2	3
44342506	1149380	0	0
44359725	40229134	2	3
44341429	1125315	0	0
45656026	1112807	0	0
44347672	1149380	0	0
45667903	40232448	2	3
45659701	1192710	0	0
45666484	19079524	1	1
45627107	40229134	2	3
45677790	1738521	0	0
45698107	738818	0	0
45682979	1115008	0	0
45779589	1174888	0	0
45696704	1326303	0	0
45786359	1107882	2	3
45786811	1115171	2	3
45800122	1177480	0	0
45895521	1307863	0	0
46290382	967823	0	0
45788675	967823	0	0
45799454	975125	0	0
46299820	1125315	0	0
45796987	19018935	2	3
3039467	3035995	2	2
3050951	3024561	2	2
21001283	19125062	2	3
21502549	1713671	8	9
36153370	1125315	0	0
35500000	140673	3	5
36313949	4024289	3	3
36516972	4048695	3	6
42803999	1539411	2	3
44342277	1112807	0	0
44359826	19008572	2	3
44341163	1125315	0	0
45656066	1112807	0	0
44347676	1149380	0	0
45667907	40232448	2	3
45660042	1192710	0	0
45666484	46275916	1	1
45627109	40229134	2	3
45677858	1332418	0	0
45697983	1361711	0	0
45682987	1545958	0	0
45779559	1305058	0	0
45696447	967823	0	0
45690421	1107882	2	3
45786648	1127433	2	3
45800279	1177480	0	0
45895503	1367571	0	0
46290385	1192710	0	0
45788630	1153428	0	0
45799460	1174888	0	0
46300021	1125315	0	0
45796848	40232448	2	3
3039467	3006923	2	2
3050951	3013682	2	2
21001283	40232448	2	3
21502549	46275444	8	9
36153370	1112807	0	0
35902135	198809	3	5
36313949	4252419	3	3
36313965	4202451	3	6
42806494	40223768	2	3
44342414	1343916	0	0
44359799	19008572	2	3
44339692	1125315	0	0
45656428	1112807	0	0
44347677	1149196	0	0
45670043	19079524	2	3
45656943	1192710	0	0
45666587	19079524	1	1
45627110	19059056	2	3
45677795	1549786	0	0
45698083	738818	0	0
45682875	1713332	0	0
45779520	967823	0	0
45696553	1548195	0	0
45695989	1107882	2	3
45786710	40229134	2	3
45800295	1177480	0	0
45895346	1149196	0	0
46290394	1539403	0	0
45788541	1551099	0	0
45799317	1102527	0	0
46300027	1125315	0	0
45796809	19075601	2	3
3039467	3020630	2	2
3050951	3013721	2	2
21001283	1150837	2	3
21502549	19129655	8	9
36153374	1112807	0	0
21602818	46275444	3	5
36313913	4024289	3	4
36503263	78272	3	7
42806190	40223768	2	3
44342420	1549786	0	0
44359834	40236824	2	3
44339699	1125315	0	0
45652690	1112807	0	0
44347720	738818	0	0
45670086	43012036	2	3
45657001	1192710	0	0
45627354	19079524	1	1
45627288	19075601	2	3
45677795	1519936	0	0
45698091	1107830	0	0
45682885	1153428	0	0
45779618	967823	0	0
45696554	920293	0	0
45674884	1107882	2	3
45786713	19077572	2	3
45802517	1177480	0	0
45895567	1361711	0	0
46290397	740275	0	0
45788683	1149196	0	0
45799318	1310149	0	0
46300085	1125315	0	0
45796884	19133905	2	3
3039467	3013682	2	2
3050951	3006923	2	2
21001283	43012036	2	3
21502549	1174888	6	6
36153492	1549786	0	0
36100000	4280726	5	5
36303140	439777	3	4
36502205	81151	3	7
42801609	19078461	2	3
44342430	1738521	0	0
44359623	19019273	2	3
44339771	1125315	0	0
45655177	1112807	0	0
44347728	19127890	0	0
45670351	19059056	2	3
45653557	1192710	0	0
45627835	19079524	1	1
45627377	1127433	2	3
45674156	1759842	0	0
45698368	1149196	0	0
45633681	1154029	0	0
45779638	1153428	0	0
45696779	1501700	0	0
45679971	1107882	2	3
45786922	40229134	2	3
45802247	1177480	0	0
45895570	1729720	0	0
46290507	1310149	0	0
45788399	1545958	0	0
45799321	975125	0	0
46300089	1125315	0	0
45796884	19133873	2	3
3048893	3005136	2	2
3050951	3006906	2	2
21001283	19112599	2	3
21502549	1728416	6	6
36153050	1107830	0	0
35702777	81893	5	5
36516728	4142905	3	4
36426641	19128065	3	4
42806595	19078461	2	3
44342442	1118084	0	0
44360136	1115171	2	3
43531392	4186930	3	4
45655355	1112807	0	0
44347911	1521369	0	0
45668175	1115171	2	3
45653560	1192710	0	0
45664124	19079524	1	1
45627357	1551192	2	3
45674156	1713332	0	0
45698315	1115008	0	0
45633427	1551099	0	0
45779641	1549786	0	0
45696780	975125	0	0
45778140	19079524	2	3
45786927	920334	2	3
45797571	1177480	0	0
45895463	1192710	0	0
46290476	1115008	0	0
45788499	1115008	0	0
45799506	1738521	0	0
46300236	1125315	0	0
45796897	40163554	2	3
3048893	3036780	2	2
3050951	3027970	2	2
21001283	40228214	2	3
21502549	1729720	6	6
36153051	1115008	0	0
35809406	81893	5	5
36516993	4149245	3	4
36602211	4285898	3	4
42806412	1332419	2	3
44342593	1149380	0	0
44360080	40232448	2	3
44784106	4230399	4	4
45652854	1112807	0	0
44347728	1589505	0	0
45668183	40162522	2	3
45653243	1192710	0	0
45633497	19079524	1	1
45627448	40163554	2	3
45674163	1595799	0	0
45698782	1308738	0	0
45633470	1545958	0	0
45779641	19127890	0	0
45682141	1112807	0	0
45703048	19078461	2	3
45786794	40229134	2	3
45797582	1177480	0	0
45895468	1515774	0	0
46290428	19003953	0	0
45788677	1307863	0	0
45799363	1115008	0	0
46300111	1125315	0	0
45797027	40229134	2	3
3048893	3023430	2	2
3050951	3004501	2	2
21001283	40223821	2	3
21502549	1717327	6	6
36153053	1177480	0	0
36002868	4048171	5	5
36303152	4163872	3	4
36427783	40221415	3	4
42801338	1332419	2	3
44342594	1332418	0	0
44360143	40229134	2	3
44784105	40479422	4	4
45649526	1112807	0	0
44347728	1549786	0	0
45668123	40220960	2	3
45653619	1192710	0	0
45633497	46275916	1	1
45627463	920300	2	3
45674163	1308738	0	0
45698094	1124300	0	0
45633715	1308738	0	0
45779641	1589505	0	0
45679963	1112807	0	0
45678583	40228214	2	3
45786964	40229134	2	3
45797842	1177480	0	0
45895468	1549786	0	0
46290393	1174888	0	0
45788648	742185	0	0
45799549	933724	0	0
46300148	1125315	0	0
45797028	1154615	2	3
3048907	3036780	2	2
3050951	3020630	2	2
21001283	40228230	2	3
21502549	1768849	6	6
36153054	1125315	0	0
36000000	37017711	5	5
36427091	19127922	3	4
36503263	4035415	3	4
42801344	1332419	2	3
44342571	1539403	0	0
44359883	40236824	2	3
43531071	4238715	3	4
45649747	1112807	0	0
44347938	967823	0	0
45668124	40223834	2	3
45650157	1192710	0	0
45666564	19079524	1	1
45627538	19019273	2	3
45674008	975125	0	0
45698096	738818	0	0
45633780	1107830	0	0
45779725	1501700	0	0
45677673	1112807	0	0
45696337	19075601	2	3
45786886	40229134	2	3
45797562	1177480	0	0
45895544	1107830	0	0
46290550	1115008	0	0
45788654	1717327	0	0
45799485	791967	0	0
46300169	1125315	0	0
45797143	43012036	2	3
3048907	3023430	2	2
3050951	3035995	2	2
21001283	40223834	2	3
21502549	1738521	6	6
36153054	1112807	0	0
36000000	4240902	5	5
36427091	19133679	3	4
36503263	4146173	3	4
42801785	1332419	2	3
44342551	1149196	0	0
44360280	40229134	2	3
43531071	4330583	3	7
45649846	1112807	0	0
44347867	1713332	0	0
45668126	40232448	2	3
45650245	1192710	0	0
45664399	19079524	1	1
45623708	19078461	2	3
45674170	1713332	0	0
45698406	1713332	0	0
45633874	1149380	0	0
45779644	1115008	0	0
45677915	1112807	0	0
45778010	1539411	2	3
45786904	1115171	2	3
45797677	1177480	0	0
45896700	1322184	0	0
46290593	1124300	0	0
45788657	1729720	0	0
45799550	1154029	0	0
46300340	1125315	0	0
46317548	19019273	2	3
3048907	3005136	2	2
3037839	3045716	2	2
21001804	19073188	2	3
21502549	1741122	6	6
36153055	1112807	0	0
36202157	4094814	5	5
36427091	42902245	3	4
40049748	19008572	1	1
42804512	40174880	2	3
44342619	1310149	0	0
44353309	40162522	2	3
43531071	4145310	3	3
45649672	1112807	0	0
44347869	1738521	0	0
45668130	920300	2	3
45647404	1192710	0	0
45630158	19079524	1	1
45623900	40229134	2	3
45674170	1759842	0	0
45698406	1759842	0	0
45633789	967823	0	0
45779649	738818	0	0
45677827	1112807	0	0
45679366	40228214	2	3
45786908	19008572	2	3
45794980	1177480	0	0
45896701	1713332	0	0
46290863	1713332	0	0
46298026	975125	0	0
45799521	1154029	0	0
46300245	1125315	0	0
46317571	19008572	2	3
3048915	3036780	2	2
3037839	3019550	2	2
21001804	19074841	2	3
21502549	1759842	6	6
36153057	1112807	0	0
36203066	375671	5	5
36427091	19128065	3	4
40654138	3049273	1	1
42801630	1545959	2	3
44342616	1115008	0	0
44353316	40236824	2	3
43531071	4186930	4	5
45649925	1112807	0	0
44347952	1549786	0	0
45668169	35605482	2	3
45644415	1192710	0	0
45627321	19079524	1	1
45623901	40232448	2	3
45674173	1343916	0	0
45698387	1367571	0	0
45633877	1551099	0	0
45779729	723013	0	0
45674699	1112807	0	0
45679945	1332419	2	3
45785340	43012036	2	3
45795096	1177480	0	0
45896717	1000560	0	0
46290873	1124300	0	0
46297506	715997	0	0
45799553	1115008	0	0
46300246	1125315	0	0
45794186	40162522	2	3
3048915	3023430	2	2
3037839	3023103	2	2
21001804	19129655	2	3
21502549	1778162	6	6
36153108	1125315	0	0
36203066	378001	5	5
36427091	19129144	3	4
37522151	4107731	1	1
42806550	1539411	2	3
44342569	705944	0	0
44353322	19057271	2	3
43531071	4117038	4	6
45649898	1112807	0	0
44348538	1107830	0	0
45668286	40236446	2	3
45644433	1192710	0	0
45639393	19079524	1	1
45625137	1310034	2	3
45674409	1107830	0	0
45698504	967823	0	0
45633788	740275	0	0
45779730	738818	0	0
45674540	1112807	0	0
45705820	1332419	2	3
45785284	1115171	2	3
45792524	1177480	0	0
45896718	1124957	0	0
46290649	1192710	0	0
46297680	1124957	0	0
45799530	1539403	0	0
46300184	1125315	0	0
45794187	1115171	2	3
3048915	3005136	2	2
3037839	3014576	2	2
21001804	19074843	2	3
21502549	933724	6	6
36153108	1112807	0	0
36203062	4299128	5	5
36426182	19127918	3	4
40171037	40169281	1	1
42538830	439777	3	4
44342132	1154029	0	0
44353142	19008572	2	3
43531060	195588	3	4
45649930	1112807	0	0
44348662	1153428	0	0
45668365	1127433	2	3
45644299	1192710	0	0
45627710	19079524	1	1
45625194	19008572	2	3
45674397	1595799	0	0
45698239	1124957	0	0
45633792	1149196	0	0
45779799	1738521	0	0
45674754	1112807	0	0
45696628	1332419	2	3
45785299	19059056	2	3
45789503	1177480	0	0
45896805	933724	0	0
46290718	708298	0	0
46297688	1192710	0	0
45799568	1107830	0	0
46300159	1125315	0	0
45794192	920334	2	3
3048927	3036780	2	2
3037839	3015632	2	2
21001804	19073183	2	3
21502553	40171902	6	6
36153117	1112807	0	0
36203062	4296205	5	5
36426182	19128009	3	4
36303177	4181917	1	1
42888897	4037675	4	4
44342600	1000560	0	0
44353345	19008572	2	3
43531056	4329847	5	6
45649104	1112807	0	0
44348539	1332418	0	0
45665936	40163554	2	3
45641444	1192710	0	0
45645411	19079524	1	1
45625195	1545959	2	3
45676233	1115008	0	0
45698314	1308738	0	0
45679857	1115008	0	0
45779628	1343916	0	0
45674654	1112807	0	0
45782464	40173590	2	3
45785314	19018935	2	3
45789761	1177480	0	0
45896724	975125	0	0
46290719	1124957	0	0
46297938	967823	0	0
45799526	1778162	0	0
46296119	1125315	0	0
45794021	19133905	2	3
1503242	19128065	2	2
3044023	3045716	2	2
21001804	19075001	2	3
21502553	1539411	7	8
36153376	1192710	0	0
36203090	4084167	5	5
36424660	40221415	3	4
37522248	4035793	1	1
37502338	4336464	5	5
44342606	1000560	0	0
44355677	19008572	2	3
43531056	317576	5	5
45646509	1112807	0	0
44348553	738818	0	0
45665794	40243436	2	3
45641594	1192710	0	0
45630490	19079524	1	1
45625268	1332419	2	3
45676244	975125	0	0
45698218	1332418	0	0
45679872	1305058	0	0
45779632	740275	0	0
45674788	1112807	0	0
45779914	1107882	2	3
45785317	1115171	2	3
45789764	1177480	0	0
45896732	1557272	0	0
46290887	1118084	0	0
46301490	1545958	0	0
45799528	1738521	0	0
46296125	1125315	0	0
45794021	19133873	2	3
437385	375671	2	2
3044023	3023103	2	2
21002327	920300	2	3
21502553	1545959	7	8
36153376	1112807	0	0
21603249	40169281	4	5
36424688	42902245	3	4
36316010	4133840	1	1
37502338	4337611	4	4
44342253	1768849	0	0
44355421	19008572	2	3
43531056	258780	5	5
45646569	1112807	0	0
44348555	1000560	0	0
45665614	40236824	2	3
45641693	1192710	0	0
45666213	19079524	1	1
45625202	1332419	2	3
45676257	1310149	0	0
45698326	1154029	0	0
45679588	738818	0	0
45779634	1551099	0	0
45674722	1112807	0	0
45677518	1107882	2	3
45785364	1127433	2	3
45789879	1177480	0	0
45896701	1759842	0	0
46290560	1115008	0	0
46301446	705944	0	0
45799532	1115008	0	0
46296348	1125315	0	0
45794144	40236824	2	3
3006343	3014576	2	2
3044023	3019550	2	2
21002327	19075001	2	3
21502553	1343916	5	5
36153638	1125315	0	0
21602496	19127904	4	5
36424688	19128263	3	4
36403239	140673	1	1
37502341	4117038	5	5
44342257	1149196	0	0
44355232	1551192	2	3
43531056	321042	5	5
45643477	1112807	0	0
44348726	1521369	0	0
45666059	40229134	2	3
45638247	1192710	0	0
45666680	19079524	1	1
45624203	40236824	2	3
45676260	738818	0	0
45698338	1551099	0	0
45679591	1515774	0	0
45779737	1115008	0	0
45671971	1112807	0	0
45672403	19075601	2	3
45785371	40232448	2	3
45789237	1177480	0	0
45679921	738818	0	0
46290756	1713332	0	0
46301453	1174888	0	0
45799613	1174888	0	0
46296113	1125315	0	0
45794796	40236446	2	3
3006343	3023103	2	2
3044023	3014576	2	2
21002327	920334	2	3
21502553	1361711	5	5
36153063	975125	0	0
21602537	40224805	4	5
36424688	19128009	3	4
36316422	4314290	1	1
37502341	4330583	5	5
44342258	1110410	0	0
44355306	1332419	2	3
43531056	255848	4	4
45643781	1112807	0	0
44348726	1549786	0	0
45666163	40232448	2	3
45640079	1192710	0	0
45666778	19079524	1	1
45624234	1127433	2	3
45676407	1149196	0	0
45698243	1124957	0	0
45679591	19127890	0	0
45779742	1174888	0	0
45671753	1112807	0	0
45676342	19078461	2	3
45785412	782047	2	3
45789223	1177480	0	0
45679086	738818	0	0
46290756	1759842	0	0
46301466	1307863	0	0
45799538	1589505	0	0
46318426	1125315	0	0
45794801	40229134	2	3
3006343	3019550	2	2
3044023	3015632	2	2
21002327	1713671	2	3
21502553	1332418	5	5
36153492	1515774	0	0
21602868	19075001	4	5
36424688	19127904	3	4
37303797	134438	1	1
42537893	4048695	3	3
44342401	1112807	0	0
44345678	19008572	2	3
43531056	260139	4	4
45643610	1112807	0	0
44348322	1115008	0	0
45666030	19059056	2	3
45638467	1192710	0	0
45627762	46275916	1	1
45624523	19008572	2	3
45676411	1000560	0	0
45698248	1512674	0	0
45679591	1549786	0	0
45779747	1115008	0	0
45672028	1112807	0	0
45784234	19075601	2	3
45785389	40229134	2	3
45787046	1177480	0	0
45786031	738818	0	0
46290772	1174888	0	0
46301542	1729720	0	0
45799538	1549786	0	0
46318427	1125315	0	0
45794276	19129655	2	3
3006343	3015632	2	2
3048501	3036780	2	2
21001801	19075001	2	3
21502553	1308738	5	5
36153137	975125	0	0
35502089	4144583	4	5
36424688	19127918	3	4
40773226	3010813	1	1
42537893	4066995	3	3
44342406	1713332	0	0
44345441	19008572	2	3
43531056	261325	3	5
45643635	1112807	0	0
44348735	975125	0	0
45666195	19126352	2	3
45634235	1192710	0	0
45627762	19079524	1	1
45624263	40163554	2	3
45674425	1115008	0	0
45698248	1548195	0	0
45630668	1713332	0	0
45779526	1124300	0	0
45783787	1112807	0	0
45782308	19075601	2	3
45785392	40163554	2	3
45787067	1177480	0	0
45786544	738818	0	0
46290779	1174888	0	0
46298196	1174888	0	0
45799540	1174888	0	0
46318429	1125315	0	0
45794311	19073188	2	3
3006343	3045716	2	2
3048501	3005136	2	2
21001801	19074841	2	3
21502553	1539403	5	5
36153138	975125	0	0
21602818	1713671	4	5
36424688	19128022	3	4
40589905	4084167	1	1
37502338	4337138	3	3
44342406	1759842	0	0
44345769	19129655	2	3
43531056	313217	6	7
45643512	1112807	0	0
44348741	920293	0	0
45666042	40223834	2	3
45632428	1192710	0	0
45630649	19079524	1	1
45624208	1127433	2	3
45674447	1308738	0	0
45698250	1192710	0	0
45630668	1759842	0	0
45779803	738818	0	0
45783953	1112807	0	0
45708184	19078461	2	3
45783410	40229134	2	3
45787356	1177480	0	0
45786383	738818	0	0
46290658	1551099	0	0
46298147	1192710	0	0
45799657	1149196	0	0
46318451	1125315	0	0
45794424	40236824	2	3
1595936	42902245	2	2
3048501	3023430	2	2
21001801	19074843	2	3
21502553	1307863	5	5
36153616	1177480	0	0
21603933	19019273	4	5
36424689	19128009	3	4
40765798	40766240	1	1
37502338	4078793	3	3
44342408	1713332	0	0
44348087	19008572	2	3
43531057	4329847	6	7
45645832	1112807	0	0
44348556	738818	0	0
45666109	1551192	2	3
45629465	1192710	0	0
45624724	19079524	1	1
45624381	40232448	2	3
45674451	920293	0	0
45698389	1738521	0	0
45630671	967823	0	0
45779590	1192710	0	0
45784179	1112807	0	0
45699386	19078461	2	3
45783449	40229134	2	3
45785653	1177480	0	0
45786122	738818	0	0
46290833	1192710	0	0
46298268	967823	0	0
45799665	1154343	0	0
46318452	1125315	0	0
45794477	1127433	2	3
4023584	44805732	2	2
3048567	3036780	2	2
21001801	19073188	2	3
21600001	914335	4	4
36153616	1119510	0	0
21603933	19078461	4	5
36424689	42902245	3	4
40170032	35605858	1	1
43054942	3016723	3	3
44342541	1115008	0	0
44345803	1127433	2	3
43531057	258780	6	6
45641083	1112807	0	0
44348618	1192710	0	0
45666260	40174880	2	3
45626737	1192710	0	0
45664228	46275916	1	1
45624244	19008572	2	3
45674485	1115008	0	0
45698460	1305058	0	0
45630769	738818	0	0
45779705	738818	0	0
45784193	1112807	0	0
45696511	19075601	2	3
45783450	40163554	2	3
45785571	1177480	0	0
46292667	738818	0	0
46290563	1307863	0	0
46298293	967823	0	0
45799670	1322184	0	0
46318454	1125315	0	0
45791453	40229134	2	3
1107885	1107882	1	1
3048567	3023430	2	2
21001801	1713671	2	3
21600001	1000560	4	4
36153773	1307863	0	0
35702738	4285898	4	10
36424689	19128263	3	4
40047095	19077572	1	1
43054942	3023103	3	3
44344654	1713332	0	0
44345817	40232448	2	3
43531057	321042	6	6
45641181	1112807	0	0
44348432	1729720	0	0
45666271	19019273	2	3
45623325	1192710	0	0
45630077	19079524	1	1
45668312	40223834	2	3
45674419	1343916	0	0
45698557	1729720	0	0
45630770	1713332	0	0
45779687	1309944	0	0
45784287	1112807	0	0
45784297	19075601	2	3
45783178	19078461	2	3
45785606	1177480	0	0
46292717	738818	0	0
46290834	1308738	0	0
46298158	1192710	0	0
45799624	920293	0	0
46318459	1125315	0	0
45791380	1107882	2	3
437312	192671	1	1
3048567	3005136	2	2
21001801	19129655	2	3
21600001	975125	4	4
36153775	1153428	0	0
35702738	30753	4	7
36424689	19127904	3	4
40050254	782047	1	1
43054942	3013682	3	3
44344662	1149380	0	0
44341148	19019273	2	3
43531057	317576	6	6
45640895	1112807	0	0
44348010	1308738	0	0
45663644	19008572	2	3
45623481	1192710	0	0
45668934	19079524	1	1
45668197	19078924	2	3
45674495	1149196	0	0
45698433	1124957	0	0
45630715	1738521	0	0
45779781	1107830	0	0
45781866	1112807	0	0
45779600	19075601	2	3
45783522	1551192	2	3
45785641	1177480	0	0
46293194	738818	0	0
46291041	1124957	0	0
46298184	1124300	0	0
45799577	1738521	0	0
46318574	1125315	0	0
45791709	40229134	2	3
1127642	40229134	1	1
3048584	3036780	2	2
21001801	19073183	2	3
21500010	1768849	2	2
36153793	1713332	0	0
35702738	198809	5	7
36424689	19127918	3	4
37521794	4337138	1	1
37500000	4186930	4	4
44344949	1759842	0	0
44338730	46275444	2	3
43531057	4142905	6	6
45637567	1112807	0	0
44348122	975125	0	0
45663711	1545959	2	3
45623535	1192710	0	0
45668934	46275916	1	1
45668365	19078461	2	3
45674472	738818	0	0
45698560	1713332	0	0
45630832	1149196	0	0
45779784	967823	0	0
45782123	1112807	0	0
45671907	19075601	2	3
46291172	1115171	2	3
45785860	1177480	0	0
46288417	738818	0	0
46291064	705944	0	0
46298341	1149196	0	0
45799484	1738521	0	0
46318516	1125315	0	0
45791597	40224805	2	3
1113309	19059056	1	1
3048584	3005136	2	2
21001801	46275444	2	3
21500010	1741122	2	2
36153812	1115008	0	0
35702738	81893	5	11
36424689	19128022	3	4
37521795	4337611	1	1
37500000	4078793	4	4
44344949	1713332	0	0
44338678	40232448	2	3
43531057	260139	5	5
45637963	1112807	0	0
44347976	1110410	0	0
45663420	40232448	2	3
45623363	1192710	0	0
45648514	19079524	1	1
45668373	40229134	2	3
45674560	757627	0	0
45698533	967823	0	0
45630838	920293	0	0
45779814	967823	0	0
45782019	1112807	0	0
45705923	19075601	2	3
46291621	19075001	2	3
45785645	1177480	0	0
46288691	738818	0	0
46290683	933724	0	0
46298457	715997	0	0
45799578	738818	0	0
46318772	1125315	0	0
45791697	40231925	2	3
4018956	78272	1	1
3048584	3023430	2	2
21001819	46233710	2	3
21500010	1778162	2	2
36153823	1119510	0	0
35702738	4112343	5	9
36503289	4310024	3	5
37521588	4117038	1	1
37500000	4295880	6	6
44344952	1548195	0	0
44338740	19133905	2	3
43531057	255848	5	5
45634742	1112807	0	0
44347982	1713332	0	0
45663855	46275444	2	3
45667842	1192710	0	0
45642647	19079524	1	1
45668294	19073183	2	3
45674566	19039298	0	0
45698688	1115008	0	0
45630840	1729720	0	0
45779821	975125	0	0
45779523	1112807	0	0
45782122	19075601	2	3
46291540	1107882	2	3
45785983	1177480	0	0
46288761	738818	0	0
46290695	1549786	0	0
46298345	1501700	0	0
45799636	975125	0	0
46318677	1125315	0	0
45791614	920334	2	3
1585385	40766240	1	1
3048604	3036780	2	2
21001819	19075001	2	3
21604565	723013	2	2
36153083	1125315	0	0
35702738	196456	5	6
36313913	4058899	3	5
36918918	440086	1	1
42806218	19127904	1	2
44342629	1118084	0	0
44339207	40162522	2	3
43531057	261325	4	6
45634726	1112807	0	0
44347990	1110410	0	0
45663550	19133768	2	3
45667909	1192710	0	0
45627408	46275916	1	1
45668399	1551192	2	3
45674569	1307863	0	0
45698374	1367571	0	0
45630610	1548195	0	0
45779599	975125	0	0
45779800	1112807	0	0
45782501	1539411	2	3
46291751	1107882	2	3
45785935	1177480	0	0
46243300	738818	0	0
46290695	1521369	0	0
46298377	1000560	0	0
45799589	1549786	0	0
46318880	1125315	0	0
45791659	19019273	2	3
1107886	19125062	1	1
3048604	3023430	2	2
21001819	46275444	2	3
21604565	19115351	2	2
36153736	1112807	0	0
35702738	28060	6	7
36313957	439777	3	5
36918919	440086	1	1
43053794	4285898	1	2
44342707	1729720	0	0
44360400	40236824	2	3
43531057	313217	7	8
45634548	1112807	0	0
44348052	1521369	0	0
45663584	46275916	2	3
45667815	1192710	0	0
45627408	19079524	1	1
45668439	19073183	2	3
45674572	1551099	0	0
45698694	723013	0	0
45630843	1115008	0	0
45779600	1322184	0	0
45779633	1112807	0	0
45672088	1539411	2	3
46291765	1115171	2	3
46292163	1177480	0	0
46243301	738818	0	0
46291070	791967	0	0
46298408	742185	0	0
45799589	19127890	0	0
46319028	1125315	0	0
45791667	19059056	2	3
435459	433125	1	1
3048604	3005136	2	2
21001819	46233988	2	3
21604565	791967	2	2
36153750	1129625	0	0
35802829	381316	6	6
36503290	81151	3	6
36919236	443279	1	1
43053691	4066995	1	2
44342743	967823	0	0
44347441	19133905	2	3
43531059	45769019	4	4
45631581	1112807	0	0
44348052	1595799	0	0
45660242	19008572	2	3
45667838	1192710	0	0
45636470	19079524	1	1
45668381	1107882	2	3
45674508	975125	0	0
45698573	1124957	0	0
45630860	1107830	0	0
45779832	1309944	0	0
45779918	1112807	0	0
45784300	1539411	2	3
46291452	40174880	2	3
46292144	1177480	0	0
46242546	738818	0	0
46291236	715997	0	0
46298543	1713332	0	0
45799589	1515774	0	0
46319029	1125315	0	0
45791583	46233710	2	3
438409	440086	1	1
3048875	3036780	2	2
21001819	1713671	2	3
21602882	19075001	2	2
36152955	1107830	0	0
35802829	372328	6	6
36300000	4133840	3	6
40793378	3021226	1	1
37502353	44783196	5	7
44342722	1153428	0	0
44343243	1115171	2	3
43531059	195588	4	5
45631846	1112807	0	0
44348052	1549786	0	0
45660383	1127433	2	3
45667193	1192710	0	0
45636470	46275916	1	1
45668427	43012036	2	3
45674462	1713332	0	0
45698440	1501700	0	0
45630862	740275	0	0
45779881	1000560	0	0
45708301	1112807	0	0
45678092	1539411	2	3
46291678	40229134	2	3
46292278	1177480	0	0
46241209	738818	0	0
46290845	1192710	0	0
46298543	1759842	0	0
45799592	1174888	0	0
46318656	1125315	0	0
45791754	1127433	2	3
4023584	4059978	1	1
3048875	3005136	2	2
21001819	19129655	2	3
21602882	1768849	2	2
36153562	975125	0	0
35802829	380378	6	6
36303152	4058899	3	6
40793379	3006451	1	1
37502353	4301346	6	7
44342686	975125	0	0
44342974	40162522	2	3
43531058	81893	7	8
45628594	1112807	0	0
44348062	1115008	0	0
45660384	40232448	2	3
45663358	1192710	0	0
45668769	19079524	1	1
45668524	19029476	2	3
45674513	1149196	0	0
45698710	1738521	0	0
45630991	708298	0	0
45779913	1332418	0	0
45708025	1112807	0	0
45675176	40228214	2	3
46291693	46275916	2	3
46243082	1177480	0	0
46241391	738818	0	0
46290631	1000560	0	0
46298305	1551099	0	0
45796838	1521369	0	0
46318776	1125315	0	0
45791781	782047	2	3
3040986	3051031	1	1
3048875	3023430	2	2
21001643	1545959	2	3
21604148	40173590	2	2
36153878	1125315	0	0
35802829	28060	6	7
36503289	4296204	3	6
40652640	3013721	1	1
37502353	4117038	4	8
44342652	1738521	0	0
44343100	19133873	2	3
43531058	4166224	5	6
45628623	1112807	0	0
44348134	740275	0	0
45660336	1115171	2	3
45659846	1192710	0	0
45651207	19079524	1	1
45668632	35605482	2	3
45674525	738818	0	0
45698445	1107830	0	0
45630872	1343916	0	0
45779658	914335	0	0
45777970	1112807	0	0
45782212	1539411	2	3
46291888	40232448	2	3
46242909	1177480	0	0
46238440	738818	0	0
46242048	933724	0	0
46298326	967823	0	0
45796659	740275	0	0
46312781	1125315	0	0
45788963	19076374	2	3
3041250	3023430	1	1
3048880	3036780	2	2
21001643	1539411	2	3
21604793	715997	2	2
36153879	1112807	0	0
35802829	4001336	6	8
36313965	4015189	3	6
40652709	3028833	1	1
37502353	4163971	4	9
44342669	738818	0	0
44343394	40223834	2	3
43531058	198809	5	5
45631100	1112807	0	0
44348106	740275	0	0
45660453	19078461	2	3
45659753	1192710	0	0
45668487	19079524	1	1
45668496	1115171	2	3
45671433	1738521	0	0
45698576	1174888	0	0
45630921	1539403	0	0
45779914	1107830	0	0
45778222	1112807	0	0
45784268	40228214	2	3
46291917	46233710	2	3
46243078	1177480	0	0
46238395	738818	0	0
46242213	1124957	0	0
46289697	1192710	0	0
45796610	1322184	0	0
46312391	1125315	0	0
45788965	40231925	2	3
3041250	3005136	1	1
3048880	3023430	2	2
21001630	1545959	2	3
21604793	40223774	2	2
36153883	1000560	0	0
35802829	40481087	6	8
36300000	4181917	3	7
40652745	3006906	1	1
37502353	4035793	3	5
44342691	1713332	0	0
44343492	40232448	2	3
43531058	4266809	4	4
45631104	1112807	0	0
44348111	738818	0	0
45660618	40169216	2	3
45649511	1332418	0	0
45658229	19079524	1	1
45668585	19073183	2	3
45671471	1174888	0	0
45698578	1115008	0	0
45631007	1500211	0	0
45779920	738818	0	0
45705856	1112807	0	0
45684274	40228230	2	3
46295789	19008572	2	3
46243207	1177480	0	0
45897579	738818	0	0
46242435	1332418	0	0
46290110	1000560	0	0
45796611	1000560	0	0
46312403	1125315	0	0
45789006	40229134	2	3
3041250	3036780	1	1
3048880	3005136	2	2
21506101	1125315	1	1
21604793	757627	2	2
36153751	1129625	0	0
35802829	4112343	6	9
36300000	4163872	3	8
40652760	3015632	1	1
37502336	44783196	4	6
44363955	1500211	0	0
44343501	1127433	2	3
43531058	196456	4	4
45628813	1112807	0	0
44348113	933724	0	0
45660760	19019273	2	3
45649279	967823	0	0
45658229	46275916	1	1
45668409	19008572	2	3
45671544	1501700	0	0
45698593	1192710	0	0
45631011	1149196	0	0
45779666	1000560	0	0
45705659	1112807	0	0
45684274	40228214	2	3
46244994	1127433	2	3
46243216	1177480	0	0
45897589	738818	0	0
46242462	715997	0	0
46290122	1115008	0	0
45796615	975125	0	0
46312688	1125315	0	0
45788935	40228214	2	3
3048893	3006734	1	1
3048238	3023430	2	2
21506109	1332418	1	1
21503965	19010482	2	2
36153752	1129625	0	0
35802829	4294548	6	9
36300000	4024958	3	8
40652796	3014576	1	1
40087471	40174880	1	1
44364018	1539403	0	0
44343468	43012036	2	3
43531058	4285898	3	7
45628870	1112807	0	0
44348095	1149380	0	0
45660422	40229134	2	3
45649286	1332418	0	0
45635144	19079524	1	1
45665857	40229134	2	3
45671642	1174888	0	0
45698599	1149380	0	0
45630823	914335	0	0
45779671	1149196	0	0
45706047	1112807	0	0
45706019	40228214	2	3
46244995	40232448	2	3
46240910	1177480	0	0
45897643	738818	0	0
46242142	1124957	0	0
46289857	1149196	0	0
45796715	975125	0	0
46312996	1125315	0	0
45788944	19023398	2	3
3048893	3001247	1	1
3048238	3005136	2	2
21506109	1307863	1	1
21503965	1305058	2	2
36153757	1125315	0	0
35802829	4048171	8	10
36300000	4015189	3	9
40652525	3006923	1	1
40083920	1539411	1	1
44364056	1177480	0	0
44343477	40162522	2	3
43531058	195588	3	5
45626109	1112807	0	0
44348139	1548195	0	0
45660553	40223768	2	3
45649519	1124300	0	0
45627273	46275916	1	1
45665861	43012036	2	3
45671648	1174888	0	0
45698605	1107830	0	0
45631013	1332418	0	0
45779769	1539403	0	0
45705798	1112807	0	0
45681312	40228214	2	3
46290991	19075001	2	3
46240937	1177480	0	0
45895374	738818	0	0
46242217	1124957	0	0
46289879	1717327	0	0
45796721	1174888	0	0
46312917	1125315	0	0
45788993	19129655	2	3
3048915	3001247	1	1
3048238	3036780	2	2
21506098	967823	1	1
21604798	701322	2	2
36154119	1125315	0	0
35802829	140673	5	5
36313965	4010253	2	6
40652534	3024561	1	1
43021226	134438	1	1
44364037	1545958	0	0
44339798	1115171	2	3
43531058	4310024	3	4
45622590	1112807	0	0
44348140	1174888	0	0
45660526	19008572	2	3
45649350	1124300	0	0
45627273	19079524	1	1
45667239	19079524	2	3
45671649	1717327	0	0
45698616	782043	0	0
45630908	967823	0	0
45779711	1741122	0	0
45703693	1112807	0	0
45672445	40228214	2	3
46291317	1115171	2	3
46241063	1177480	0	0
45894650	738818	0	0
46242414	1332418	0	0
46289417	1367571	0	0
45796721	1192710	0	0
46313177	1125315	0	0
45788985	1115171	2	3
3048915	3006734	1	1
3048257	3036780	2	2
21501246	19010482	1	1
21500296	967823	2	2
36153018	1589505	0	0
35802829	4029498	5	5
36313913	4145310	2	2
40652549	3035995	1	1
43055200	3051031	1	1
44364046	1521369	0	0
44339802	1127433	2	3
43531058	440448	6	6
45622675	1112807	0	0
44348243	1115008	0	0
45658426	19073183	2	3
45649406	1738521	0	0
45624023	19079524	1	1
45667365	40232448	2	3
45671486	914335	0	0
45698628	1192710	0	0
45630905	1539403	0	0
45779711	1746114	0	0
45703604	1112807	0	0
45784310	40228214	2	3
46242704	920334	2	3
46241094	1177480	0	0
45803429	738818	0	0
46242492	1548195	0	0
46289961	1149196	0	0
45796730	1124300	0	0
46312463	1125315	0	0
45788986	40232448	2	3
1115092	19019273	1	1
3048257	3023430	2	2
21502613	1125315	1	1
21604416	740275	2	2
36153018	19127890	0	0
35802829	4283893	5	7
36313949	4163872	2	2
40652575	3001247	1	1
43053692	4142905	1	1
44364046	1549786	0	0
44339986	1115171	2	3
43531061	81893	8	9
45622867	1112807	0	0
44348246	738818	0	0
45658426	19073188	2	3
45649292	1501700	0	0
45645390	19079524	1	1
45667335	19008572	2	3
45671550	1548195	0	0
45698633	1713332	0	0
45630924	1174888	0	0
45779836	1551099	0	0
45703866	1112807	0	0
45702599	19079524	2	3
46242641	40223834	2	3
46241095	1177480	0	0
45803357	738818	0	0
46242083	757627	0	0
46290144	1115008	0	0
45796662	1367571	0	0
46312466	1125315	0	0
46302087	43012036	2	3
1115170	1115171	1	1
3048257	3005136	2	2
21502613	1115008	1	1
21604635	708298	2	2
36153018	1549786	0	0
35802829	4156265	5	7
36313949	4058899	2	2
40652611	3045716	1	1
40064724	19019273	1	1
44364091	1149380	0	0
45620074	40228230	2	3
43531061	198809	6	6
45622971	1112807	0	0
44348247	1713332	0	0
45658398	40232448	2	3
45649304	1305058	0	0
45645390	46275916	1	1
45667273	40223768	2	3
45671582	1548195	0	0
45698789	1500211	0	0
45631066	1539403	0	0
45779837	975125	0	0
45702242	1112807	0	0
45699406	19078461	2	3
46242719	40232448	2	3
46238232	1177480	0	0
45803452	738818	0	0
46242374	715997	0	0
46290148	1367571	0	0
45796813	1741122	0	0
46312710	1125315	0	0
46301817	19077344	2	3
3005833	3000963	1	1
3048273	3036780	2	2
21502621	1759842	1	1
21505881	1557272	2	2
36153020	1129625	0	0
35802829	4132546	5	7
36304718	3045716	2	2
40652614	3020655	1	1
40064724	1115171	1	1
44364094	738818	0	0
45620337	19008572	2	3
43531061	4166224	6	7
45622747	1112807	0	0
44348213	1551099	0	0
45658401	44816277	2	3
45649467	1124300	0	0
45657708	19079524	1	1
45667466	19133768	2	3
45671584	1153428	0	0
45698341	1729720	0	0
45630738	1332418	0	0
45779851	1110410	0	0
45702392	1112807	0	0
45779814	19079524	2	3
46242680	40229134	2	3
46238242	1177480	0	0
45800897	738818	0	0
46242380	967823	0	0
46289870	1124300	0	0
45796813	1746114	0	0
46312942	1125315	0	0
46299553	40229134	2	3
3006343	3004501	1	1
3048273	3023430	2	2
21502537	1367571	1	1
21604147	1557272	2	2
36153023	1125315	0	0
35802829	4043241	9	10
36304718	3019550	2	2
40652870	3016723	1	1
40067083	19133873	1	1
44364252	1309944	0	0
45619848	19059056	2	3
43531061	196456	5	5
45621130	1112807	0	0
44348214	1174888	0	0
45657513	19075001	2	3
45649380	1000560	0	0
45651287	46275916	1	1
45667466	40162522	2	3
45671595	1545958	0	0
45698344	1110410	0	0
45631001	1115008	0	0
45779862	1713332	0	0
45702458	1112807	0	0
45684416	40228214	2	3
46242773	40229134	2	3
45897149	1177480	0	0
45800931	738818	0	0
46242381	1110410	0	0
46289399	1192710	0	0
45796860	1332418	0	0
46312958	1125315	0	0
46299563	19008572	2	3
3006343	3016723	1	1
3048273	3005136	2	2
21500563	715997	1	1
21604606	708298	2	2
36153023	1119510	0	0
35802829	4218389	4	5
36304718	3015632	2	2
40653596	3023103	1	1
40067083	19133905	1	1
44364318	1124300	0	0
45619912	19075601	2	3
43531061	4266809	5	5
45621943	1112807	0	0
44348247	1759842	0	0
45657595	19133768	2	3
45649479	19127890	0	0
45651287	19079524	1	1
45666362	40232448	2	3
45671552	1154343	0	0
45698865	1549786	0	0
45676640	1110410	0	0
45779864	1322184	0	0
45699494	1112807	0	0
45681302	40228214	2	3
46242883	19008572	2	3
45897365	1177480	0	0
45801090	738818	0	0
46242477	723013	0	0
46289403	933724	0	0
45796987	1326303	0	0
46312962	1125315	0	0
46298835	19133873	2	3
3006343	3013682	1	1
3051542	3024561	2	2
21500578	1125315	1	1
21602861	46275444	2	2
36153566	1107830	0	0
35802829	40486433	7	9
36304718	3023103	2	2
40653626	3020630	1	1
40064205	19078924	1	1
44364321	1307863	0	0
45620133	19075001	2	3
43531061	4285898	4	8
45621389	1112807	0	0
44341413	1307863	0	0
45657842	19008572	2	3
45649479	1512674	0	0
45654553	19079524	1	1
45663597	1124300	0	0
45671558	1115008	0	0
45698865	1589505	0	0
45676641	1713332	0	0
45779939	1332418	0	0
45699668	1112807	0	0
45681302	40228230	2	3
46242888	40162522	2	3
45897219	1177480	0	0
45801046	738818	0	0
46242350	1000560	0	0
46289407	1174888	0	0
45796780	1326303	0	0
46312697	1125315	0	0
46299245	1107882	2	3
3001019	3009201	1	1
3051542	3020630	2	2
21500578	1112807	1	1
21604200	19078219	2	2
36153533	1125315	0	0
35802829	4280726	7	9
36304718	3014576	2	2
40653646	3006734	1	1
42868771	3013682	1	1
44364356	1332418	0	0
45620047	19133768	2	3
43531061	195588	4	6
45621419	1112807	0	0
44341556	715997	0	0
45657683	1115171	2	3
45649479	1549786	0	0
45623803	19079524	1	1
45660110	1124957	0	0
45671562	1308738	0	0
45698756	1124957	0	0
45676644	1107830	0	0
45708116	1551099	0	0
45699674	1112807	0	0
45681630	40228214	2	3
46242962	1127433	2	3
45897335	1177480	0	0
45800777	738818	0	0
46239745	1110410	0	0
46290025	1192710	0	0
45796801	738818	0	0
46313043	1125315	0	0
46301505	40232448	2	3
3001019	3008598	1	1
3051542	3006906	2	2
21500586	1125315	1	1
21602868	1768849	2	2
36153533	1129625	0	0
35802829	378001	7	9
36304850	3014576	2	2
40654005	3026361	1	1
42870588	3010813	1	1
44364307	975125	0	0
44778130	19133905	2	3
43531061	4310024	4	5
45665080	1112807	0	0
44341563	1332418	0	0
45657688	19133905	2	3
45649480	1149196	0	0
45624204	46275916	1	1
45659906	1153428	0	0
45671631	975125	0	0
45698654	1326303	0	0
45676716	1713332	0	0
45708180	1124300	0	0
45696059	1112807	0	0
45779618	19079524	2	3
46242823	40231925	2	3
45897465	1177480	0	0
45801150	738818	0	0
46239601	1332418	0	0
46290042	1124957	0	0
45796802	914335	0	0
46313055	1125315	0	0
46301574	19073188	2	3
3001643	3000963	1	1
3051542	3013721	2	2
21500586	1112807	1	1
21602868	1778162	2	2
36153535	1125315	0	0
35802829	375671	7	9
36304850	3045716	2	2
40654026	3010813	1	1
42870592	3000963	1	1
44364081	1149380	0	0
44361327	1115171	2	3
43531061	440448	7	7
45664973	1112807	0	0
44341119	1738521	0	0
45657542	1551192	2	3
45649492	738818	0	0
45654578	19079524	1	1
45659660	715997	0	0
45671540	1124957	0	0
45698670	967823	0	0
45627802	1501700	0	0
45766064	45766064	0	0
45696226	1112807	0	0
45681643	40228214	2	3
46242831	40232448	2	3
45897363	1177480	0	0
45799770	738818	0	0
46239690	1124300	0	0
46290150	705944	0	0
45796803	715997	0	0
46313058	1125315	0	0
46301854	19078924	2	3
3001643	3009542	1	1
3051542	3004501	2	2
21500138	1500211	1	1
21502568	1713332	2	2
36153535	1129625	0	0
35802829	378419	7	8
36304850	3019550	2	2
40654106	3007461	1	1
42870592	3024731	1	1
44364083	920293	0	0
44361601	19133873	2	3
44362457	19127918	2	2
45665093	1112807	0	0
44341541	1545958	0	0
45657787	40231925	2	3
45649493	1367571	0	0
45645423	19079524	1	1
45659661	1153428	0	0
45673012	1549786	0	0
45698808	1192710	0	0
45627790	791967	0	0
45708224	1548195	0	0
45696183	1112807	0	0
45675071	40228214	2	3
46242985	19008572	2	3
45897378	1177480	0	0
45798069	738818	0	0
46239754	1738521	0	0
46290182	975125	0	0
45796850	1728416	0	0
46313186	1125315	0	0
46301985	42707627	2	3
4145627	196456	1	1
3051542	3027970	2	2
21500138	1548195	1	1
21502571	19129144	2	2
36153536	1125315	0	0
21602496	1519937	1	4
36304850	3023103	2	2
40653762	3019550	1	1
42870592	3002385	1	1
44364110	740275	0	0
44347014	40236446	2	3
44347728	19128009	2	2
45665187	1112807	0	0
44341569	1124300	0	0
45657790	1107882	2	3
45631754	1174888	0	0
45624739	19079524	1	1
45659665	738818	0	0
45673016	1549786	0	0
45698814	1115008	0	0
45628253	1000560	0	0
45708370	1000560	0	0
45696454	1112807	0	0
45779784	19079524	2	3
46242804	40229134	2	3
45895110	1177480	0	0
45798274	738818	0	0
46239526	1149196	0	0
46289920	1174888	0	0
45796734	1149196	0	0
46313127	1125315	0	0
46299709	19008572	2	3
1125448	19029476	1	1
3051542	3016723	2	2
21500140	1519936	1	1
21502571	1595799	2	2
36153536	1119510	0	0
21603458	43012036	1	4
36304850	3015632	2	2
40653836	3009201	1	1
42870592	3007461	1	1
44364134	1549786	0	0
44360994	19018935	2	3
44362687	19128009	2	2
45665020	1112807	0	0
44341570	1149196	0	0
45654379	19018935	2	3
45632048	705944	0	0
45627081	19079524	1	1
45660082	1322184	0	0
45673016	1589505	0	0
45698815	791967	0	0
45628238	1000560	0	0
45708371	1326303	0	0
45696322	1112807	0	0
45699679	40223768	2	3
46242971	19018935	2	3
45895225	1177480	0	0
45798261	738818	0	0
46239701	1539403	0	0
46290275	1551099	0	0
45796903	1500211	0	0
46313131	1125315	0	0
46295715	1115171	2	3
4087571	4295880	1	1
3051542	3035995	2	2
21500140	975125	1	1
21502571	19054876	2	2
36153544	1115008	0	0
21603458	19112599	1	4
36403211	40480160	2	2
40653838	3008598	1	1
42870592	3009542	1	1
44364140	1396131	0	0
44341513	19019273	2	3
44357905	19128009	2	2
45665192	1112807	0	0
44341453	1192710	0	0
45654387	40229134	2	3
45632089	1307863	0	0
45625216	46275916	1	1
45659917	738818	0	0
45673016	19127890	0	0
45698350	1778162	0	0
45628372	1154029	0	0
45708228	1545958	0	0
45693144	1112807	0	0
45675226	19078461	2	3
46242931	40163554	2	3
45894320	1177480	0	0
45798397	738818	0	0
46240251	1589505	0	0
46289942	967823	0	0
45796858	1332418	0	0
46312871	1125315	0	0
46295502	19059056	2	3
442013	4299128	1	1
3051542	3006923	2	2
21500144	1503184	1	1
21502571	19127890	2	2
36153546	1119510	0	0
21603503	19125062	1	4
36302180	4163872	2	2
40653900	3013682	1	1
42870592	3026361	1	1
44364155	933724	0	0
44347251	19019273	2	3
44351995	42902245	2	2
45662482	1112807	0	0
44341107	1107830	0	0
45654390	19075001	2	3
45632172	1738521	0	0
45625279	19079524	1	1
45659974	1551099	0	0
45673028	1115008	0	0
45698521	914335	0	0
45628375	1501700	0	0
45708232	975125	0	0
45693233	1112807	0	0
45687367	19078461	2	3
46243069	40162522	2	3
45894496	1177480	0	0
45798293	738818	0	0
46240262	1174888	0	0
46290237	1124957	0	0
45796981	1124957	0	0
46312877	1125315	0	0
46295421	19074843	2	3
442013	4296205	1	1
3049219	3023430	2	2
21500144	1589505	1	1
21502571	1503184	2	2
36153663	1125315	0	0
21603503	40223834	1	4
36302180	4052083	2	2
40171019	40169216	1	1
42868693	3016723	1	1
44364175	715997	0	0
44354453	19019273	2	3
44357871	40232448	2	3
45662586	1112807	0	0
44341325	1738521	0	0
45654313	40231925	2	3
45632166	1332418	0	0
45668479	46275916	1	1
45660113	1539403	0	0
45673029	1589505	0	0
45698357	1501700	0	0
45628290	1713332	0	0
45708203	1332418	0	0
45693259	1112807	0	0
45783935	19078461	2	3
46242744	1115171	2	3
45894498	1177480	0	0
45795690	738818	0	0
46240241	1343916	0	0
46290173	1549786	0	0
45796749	1551099	0	0
46312928	1125315	0	0
46295704	40232448	2	3
1127524	1127433	1	1
3049219	3005136	2	2
21500144	1548195	1	1
21502571	19127922	2	2
36153672	1129625	0	0
21603503	1107882	1	4
36303152	4010253	2	2
40173589	40173590	1	1
42868693	3013682	1	1
44364178	1107830	0	0
44339811	19019273	2	3
44357909	43012036	2	3
45662501	1112807	0	0
44341330	1115008	0	0
45654243	19077572	2	3
45631861	1124300	0	0
45667190	46275916	1	1
45660066	1115008	0	0
45673030	1501700	0	0
45698744	1149196	0	0
45628290	1759842	0	0
45708337	1115008	0	0
45694890	1112807	0	0
45674953	40223768	2	3
46240720	40229134	2	3
45894461	1177480	0	0
45796925	738818	0	0
45896226	1713332	0	0
46290249	1115008	0	0
45796750	1361711	0	0
46312934	1125315	0	0
46296103	19008572	2	3
1127524	40231925	1	1
3049225	3036780	2	2
21500144	1521369	1	1
21502571	1548195	2	2
36153674	1125315	0	0
21603503	1150837	1	4
36302175	4234705	2	2
37522265	4330583	1	1
42868693	3004501	1	1
44364061	1177480	0	0
44354542	19073183	2	3
44357990	1115171	2	3
45662359	1112807	0	0
44340665	1000560	0	0
45654447	40229134	2	3
45631862	1501700	0	0
45666441	46275916	1	1
45660075	1149196	0	0
45673037	1549786	0	0
45698747	1521369	0	0
45628394	738818	0	0
45778138	1595799	0	0
45693449	1112807	0	0
45690604	19078461	2	3
45799694	19078461	2	3
45803106	1177480	0	0
45792831	738818	0	0
45896226	1759842	0	0
46290212	1545958	0	0
45796818	1549786	0	0
46313223	1125315	0	0
46295984	1127433	2	3
1127524	40162522	1	1
3049225	3023430	2	2
21500144	1595799	1	1
21502571	1515774	2	2
36153689	1129625	0	0
21603503	40223821	1	4
36302175	4181917	2	2
40796088	3014599	3	3
42868769	3024561	1	1
44364071	1174888	0	0
44343548	19075001	2	3
44358114	1115171	2	3
45662513	1112807	0	0
44340668	1717327	0	0
45654506	19078924	2	3
45632191	1589505	0	0
45660798	46275916	1	1
45660135	1110410	0	0
45673037	1521369	0	0
45698747	1548195	0	0
45628408	1153428	0	0
45778138	1308738	0	0
45687677	1112807	0	0
45671741	19078461	2	3
46240081	19078461	2	3
45802969	1177480	0	0
45791978	738818	0	0
45896227	1115008	0	0
46290286	975125	0	0
45796818	1521369	0	0
46313074	1125315	0	0
46296244	35605482	2	3
4178367	4047491	4	5
3049225	3005136	2	2
21500144	19054876	1	1
21502571	1589505	2	2
36153696	1177480	0	0
21603503	1150771	1	4
36313965	4052083	2	2
36303160	4314290	3	3
42868769	3006906	1	1
44364076	1717327	0	0
44361299	19019273	2	3
44358275	40236824	2	3
45662603	1112807	0	0
44340670	1118084	0	0
45654507	19123231	2	3
45631871	1124957	0	0
45658052	46275916	1	1
45660137	1729720	0	0
45673147	1124957	0	0
45697636	1192710	0	0
45628503	1124300	0	0
45777946	967823	0	0
45687537	1112807	0	0
45671787	19078461	2	3
45778285	19078461	2	3
45803289	1177480	0	0
45790243	738818	0	0
45896231	1115008	0	0
46290105	1149196	0	0
45796996	1332418	0	0
46313079	1125315	0	0
46296247	19059056	2	3
4115390	4329847	4	5
3049228	3036780	2	2
21500134	19127890	1	1
21502571	1512674	2	2
36153697	1125315	0	0
21603491	40228214	1	4
36313965	4163951	2	2
36902285	443279	3	3
42868770	3000963	1	1
44364078	1310149	0	0
44343607	19075001	2	3
44358121	19019273	2	3
45662663	1112807	0	0
44340641	1174888	0	0
45654371	19008572	2	3
45631986	1741122	0	0
45654823	19115351	1	1
45660144	1154343	0	0
45673037	19127890	0	0
45697782	1551099	0	0
45628381	1000560	0	0
45778208	1539403	0	0
45687727	1112807	0	0
45782480	19078461	2	3
45694824	19078461	2	3
45803117	1177480	0	0
45790249	738818	0	0
45896257	1738521	0	0
46290321	1501700	0	0
45796907	1332418	0	0
46307535	1125315	0	0
46296184	1115171	2	3
4091532	4285898	4	5
3049228	3023430	2	2
21500134	1515774	1	1
21502571	19133679	2	2
36153762	1107830	0	0
21603491	40228230	1	4
36313965	4195803	2	2
40796119	3002385	3	3
42868771	3016723	1	1
44364212	753626	0	0
44343317	19019273	2	3
44354488	35605482	2	3
45662742	1112807	0	0
44340644	1500211	0	0
45651952	19078461	2	3
45631986	1746114	0	0
45648430	46275916	1	1
45660146	1738521	0	0
45673337	975125	0	0
45697551	791967	0	0
45627848	1107830	0	0
45777957	920293	0	0
45685506	1112807	0	0
45784470	19078461	2	3
45703547	19075001	2	3
45803327	1177480	0	0
45790606	738818	0	0
45896210	1322184	0	0
46290329	1192710	0	0
45796968	1153428	0	0
46307761	1125315	0	0
46295588	19133905	2	3
4172024	4169137	4	5
3049228	3005136	2	2
21500134	19054876	1	1
21502571	1521369	2	2
36153766	1119510	0	0
35502623	4144583	3	4
36214642	40236824	1	2
40796119	3024731	3	3
42709780	44783196	1	1
44364123	1713332	0	0
45619857	40223834	2	3
44354613	35605482	2	3
45662846	1112807	0	0
44340648	1308738	0	0
45652237	19018935	2	3
45631991	1174888	0	0
45648772	19079524	1	1
45660057	1174888	0	0
45673344	1738521	0	0
45697480	723013	0	0
45627841	1153428	0	0
45777937	715997	0	0
45684465	1112807	0	0
45782365	19078461	2	3
45675663	19075001	2	3
45800510	1177480	0	0
45787559	738818	0	0
45896218	1309944	0	0
46289678	1551099	0	0
45796877	1332418	0	0
46307504	1125315	0	0
46295703	19133905	2	3
4172024	442116	4	5
3049249	3036780	2	2
21500134	1548195	1	1
21502571	1549786	2	2
36153771	1112807	0	0
21602858	46275444	3	4
36215230	19023423	1	2
36703477	380378	3	3
42808846	19008572	2	3
44364191	1545958	0	0
45619857	40223821	2	3
44354674	40236824	2	3
45661458	1112807	0	0
44340652	1110410	0	0
45650892	19008572	2	3
45631992	1154029	0	0
45645191	19079524	1	1
45659761	1539403	0	0
45673369	1149196	0	0
45697556	1549786	0	0
45627845	1149196	0	0
45777950	1149196	0	0
45684580	1112807	0	0
45779888	19078461	2	3
45778209	46233710	2	3
45800495	1177480	0	0
45787829	738818	0	0
45896253	1361711	0	0
46290219	1332418	0	0
45796878	975125	0	0
46307863	1125315	0	0
46295703	19133873	2	3
4172024	4102123	4	5
3049249	3023430	2	2
21500144	1515774	1	1
21500270	1545958	2	2
36154120	1125315	0	0
21603446	40229134	3	4
36215361	40220960	1	2
36703534	4001336	3	3
42808448	1115171	2	3
44364302	1149196	0	0
44347070	1545959	2	3
44354413	40236824	2	3
45659703	1112807	0	0
44340671	19003953	0	0
45650982	40162522	2	3
45632003	1501700	0	0
45642595	46275916	1	1
45659860	1115008	0	0
45673417	1322184	0	0
45697599	723013	0	0
45627938	1741122	0	0
45778140	967823	0	0
45681443	1112807	0	0
45674985	19078461	2	3
45778209	46233988	2	3
45800591	1177480	0	0
45787871	738818	0	0
45896284	1539403	0	0
46291928	1501700	0	0
45797002	1000560	0	0
46307864	1125315	0	0
46291236	40223768	2	3
4172024	439406	4	5
3049249	3005136	2	2
21500134	1589505	1	1
21500270	1332418	2	2
36154122	1115008	0	0
21603255	40169281	3	4
36002880	80809	1	2
36702253	4218389	3	3
42809410	1115171	2	3
44364201	1177480	0	0
44357639	1545959	2	3
44354772	40229134	2	3
45656533	1112807	0	0
44340731	1115008	0	0
45650919	19074843	2	3
45632004	1174888	0	0
45642615	19115351	1	1
45659866	1115008	0	0
45673038	1000560	0	0
45697481	1153428	0	0
45627938	1746114	0	0
45778220	1539403	0	0
45681101	1112807	0	0
45672260	19078461	2	3
45789435	19075001	2	3
45800704	1177480	0	0
45786216	738818	0	0
45896285	740275	0	0
46291540	1107830	0	0
45796737	1343916	0	0
46307780	1125315	0	0
46244890	19078461	2	3
4172024	4306014	4	5
3049512	3036780	2	2
21500134	1500211	1	1
21500334	1112807	2	2
36153999	1125315	0	0
35802829	195588	4	4
36224525	46233988	1	2
40796134	3010813	3	3
42807861	1127433	2	3
44364207	1746114	0	0
44361502	1545959	2	3
44354773	920334	2	3
45656534	1112807	0	0
44340743	1110410	0	0
45651160	40228214	2	3
45632006	738818	0	0
45636329	19079524	1	1
45623144	19128009	3	4
45673312	1174888	0	0
45697489	1778162	0	0
45627850	1124300	0	0
45778223	1551099	0	0
45681198	1112807	0	0
45681329	1332419	2	3
45791746	19079524	2	3
45800842	1177480	0	0
45786231	738818	0	0
45896276	19002770	0	0
46291545	1115008	0	0
45797105	1107830	0	0
46307935	1125315	0	0
46239821	40232448	2	3
4172024	438614	4	5
3049512	3023430	2	2
21500134	1521369	1	1
21500334	1119510	2	2
36153713	1124957	0	0
21603550	967823	4	4
36224525	46233710	1	2
40779592	3001247	3	3
42808572	19008572	2	3
44364207	1741122	0	0
44353948	19019273	2	3
44354803	19008572	2	3
45656439	1112807	0	0
44340753	1738521	0	0
45648164	40236824	2	3
45632131	1149196	0	0
45636592	19127922	1	1
45667443	19128009	3	4
45673398	1521369	0	0
45697496	1717327	0	0
45627895	1501700	0	0
45778025	1551099	0	0
45681661	1112807	0	0
45693292	19078461	2	3
46242359	19078461	2	3
45797886	1177480	0	0
45786363	738818	0	0
45896365	1124300	0	0
46291547	1310149	0	0
45796884	1729720	0	0
46307943	1125315	0	0
46240115	40223834	2	3
4172024	4302207	4	5
3049512	3005136	2	2
21500134	1512674	1	1
21500334	1125315	2	2
36153998	1125315	0	0
21603550	1343916	4	4
36224758	40222846	1	2
40779592	3015076	3	3
42804716	19126352	2	3
44364236	791967	0	0
44350410	19075601	2	3
44354695	1713671	2	3
45656617	1112807	0	0
44340757	1310149	0	0
45648173	19077344	2	3
45632139	1102527	0	0
45636592	19133679	1	1
45657003	19127922	3	4
45673101	738818	0	0
45697500	1551099	0	0
45627932	1149196	0	0
45778000	1124957	0	0
45679409	1112807	0	0
45678167	19078461	2	3
45786949	1107882	2	3
45797650	1177480	0	0
46296945	738818	0	0
45896330	1521369	0	0
46292005	1738521	0	0
45797108	967823	0	0
46307446	1125315	0	0
46240057	40232448	2	3
4172024	4048169	4	5
3049537	3036780	2	2
21500134	40221415	1	1
21500334	1129625	2	2
36154201	1738521	0	0
21603550	914335	4	4
36214852	42707627	1	2
40779570	3004501	3	3
42805045	40231925	2	3
44364222	1149380	0	0
44354075	40223768	2	3
44354815	19008572	2	3
45653045	1112807	0	0
44340813	1115008	0	0
45648061	40236824	2	3
45632213	738818	0	0
45636592	19129144	1	1
45638509	19127918	3	4
45671670	1174888	0	0
45697785	1154029	0	0
45627935	1107830	0	0
45778001	1124300	0	0
45678159	1112807	0	0
45699600	19078461	2	3
46291098	1107882	2	3
45795235	1177480	0	0
46297120	738818	0	0
45896439	933724	0	0
46291656	1539403	0	0
45797109	1174888	0	0
46307714	1125315	0	0
45896411	40232448	2	3
4172024	4304110	4	5
3049537	3023430	2	2
21500134	1549786	1	1
21500334	738818	2	2
36153971	1119510	0	0
21603550	1124300	4	4
36221329	19045231	1	2
40796115	3027231	3	3
42802493	1154615	2	3
44364352	740275	0	0
44357564	19075001	2	3
44351039	46275444	2	3
45653202	1112807	0	0
44340758	1124300	0	0
45648270	1115171	2	3
45631875	1717327	0	0
45633559	46275916	1	1
45661465	40223768	2	3
45671664	1713332	0	0
45697316	1332418	0	0
45627976	920293	0	0
45778104	1728416	0	0
45678329	1112807	0	0
45782152	19078461	2	3
45784935	1545959	2	3
45795131	1177480	0	0
46297520	738818	0	0
45896482	1738521	0	0
46241841	1551099	0	0
45796739	1149196	0	0
46307718	1125315	0	0
45896413	1115171	2	3
4103320	4280726	4	5
3049537	3005136	2	2
21500144	19127890	1	1
21500330	1112807	2	2
36154129	1112807	0	0
21603550	975125	4	4
36221330	19045231	1	2
40776230	3028833	3	3
42802591	1551192	2	3
44364245	1192710	0	0
44346926	19073183	2	3
44351164	35605482	2	3
45649962	1112807	0	0
44340778	1729720	0	0
45647865	19059056	2	3
45632019	738818	0	0
45630317	46275916	1	1
45661437	19078461	2	3
45671700	1549786	0	0
45695221	1174888	0	0
45627958	1713332	0	0
45705875	1115008	0	0
45678406	1112807	0	0
45782279	19078461	2	3
45685263	1107882	2	3
45795254	1177480	0	0
46292863	738818	0	0
45896357	1332418	0	0
46241855	705944	0	0
45797015	1154029	0	0
46307620	1125315	0	0
45896554	40229134	2	3
4103320	40486433	4	5
3053269	3023430	2	2
21500144	1512674	1	1
21500334	1192710	2	2
36154129	1125315	0	0
35506542	4144583	4	4
36225993	964261	1	2
36314523	4024958	3	3
42802374	40231925	2	3
44364289	738818	0	0
44357586	1107882	2	3
44351102	19019273	2	3
45650037	1112807	0	0
44340820	1149380	0	0
45648290	1127433	2	3
45632146	1107830	0	0
45631162	19079524	1	1
45661715	40232448	2	3
45671700	1589505	0	0
45695188	1713332	0	0
45676354	1174888	0	0
45705876	1589505	0	0
45674863	1112807	0	0
45672495	19078461	2	3
45673042	1107882	2	3
45795270	1177480	0	0
46293304	738818	0	0
45896357	1545958	0	0
46241859	19127890	0	0
45796893	1149196	0	0
46307627	1125315	0	0
45896418	19019273	2	3
4027384	80809	4	5
3053269	3036780	2	2
21500144	1549786	1	1
21500334	1177480	2	2
36154004	1125315	0	0
21602514	19128009	4	4
36214806	43012036	1	2
40796098	3015632	3	3
42802775	1127433	2	3
44364337	975125	0	0
44357687	1545959	2	3
44351171	19008572	2	3
45646809	1112807	0	0
44340822	1332418	0	0
45648258	1115171	2	3
45632237	1549786	0	0
45627572	46275916	1	1
45661369	19079524	2	3
45671712	1000560	0	0
45695200	1000560	0	0
45676360	1713332	0	0
45705565	1192710	0	0
45675301	1112807	0	0
45699473	19078461	2	3
45694465	1107882	2	3
45795279	1177480	0	0
46296565	738818	0	0
45896268	1153428	0	0
46241859	1549786	0	0
45797016	1713332	0	0
46308128	1125315	0	0
45896419	40223834	2	3
4103183	313217	4	5
3053269	3005136	2	2
21500146	19128263	1	1
21500292	1129625	2	2
36154008	1192710	0	0
35502087	140673	4	4
36214806	19112599	1	2
37119628	45769019	3	3
42802869	46233710	2	3
44364338	1107830	0	0
44357409	1332419	2	3
44351174	19133905	2	3
45646925	1112807	0	0
44340981	738818	0	0
45648252	40232448	2	3
45632237	19127890	0	0
45624599	46275916	1	1
45661727	19073183	2	3
45670025	1778162	0	0
45695206	1149196	0	0
45676362	1738521	0	0
45705566	1149196	0	0
45672057	1112807	0	0
45706079	1127433	2	3
45786733	19075001	2	3
45795301	1177480	0	0
46296728	738818	0	0
45896332	1149196	0	0
46241859	1512674	0	0
45796915	1332418	0	0
46308228	1125315	0	0
45894525	19077572	2	3
4086181	4001336	4	6
3049843	3023430	2	2
21500146	42902245	1	1
21500292	1192710	2	2
36154123	1129625	0	0
21602537	19133679	4	4
36221413	19006318	1	2
36702242	4029498	3	3
42802982	1127433	2	3
44364358	1192710	0	0
44350810	19075601	2	3
44351174	19133873	2	3
45647039	1112807	0	0
44340769	738818	0	0
45648026	19075601	2	3
45632237	1515774	0	0
45624738	46275916	1	1
45661396	46275444	2	3
45670026	1124300	0	0
45695222	1115008	0	0
45676611	1153428	0	0
45705822	1539403	0	0
45672390	1112807	0	0
45706079	19078461	2	3
45800056	1107882	2	3
45792721	1177480	0	0
46288885	738818	0	0
45896396	975125	0	0
46241961	1124957	0	0
45797041	1000560	0	0
46308235	1125315	0	0
45894248	19133905	2	3
4148948	4336464	4	6
3049843	3005136	2	2
21500146	19128022	1	1
21500333	914335	2	2
36154008	1112807	0	0
21602537	19129144	4	4
36224759	40222846	1	2
40779561	3000963	3	3
44355667	40229134	2	3
44356888	1000560	0	0
44348480	19075601	2	3
44351151	19019273	2	3
45647075	1112807	0	0
44340936	1343916	0	0
45644900	40236824	2	3
45632240	1174888	0	0
45668804	46275916	1	1
45660228	19019273	2	3
45669995	1326303	0	0
45695190	1332418	0	0
45676613	1768849	0	0
45705926	1713332	0	0
45672483	1112807	0	0
45699470	19078461	2	3
45673059	1107882	2	3
45792791	1177480	0	0
46291649	738818	0	0
45896342	1309944	0	0
46241967	1332418	0	0
45797058	1521369	0	0
46308266	1125315	0	0
45894171	19133905	2	3
4028902	4010253	4	6
3049843	3036780	2	2
21500137	19127922	1	1
21500333	1192710	2	2
36154124	967823	0	0
21602537	19127922	4	4
36221043	40236446	1	2
40779561	3009542	3	3
44355669	19133905	2	3
44356890	1149380	0	0
44343593	19075601	2	3
44347269	19075001	2	3
45647206	1112807	0	0
44340937	1713332	0	0
45645092	1115171	2	3
45632245	1308738	0	0
45668850	19074679	1	1
45658296	19075601	2	3
45670043	967823	0	0
45695148	757627	0	0
45676638	1322184	0	0
45705932	1501700	0	0
45784360	1112807	0	0
45675089	19078461	2	3
45697261	1107882	2	3
45790070	1177480	0	0
46243599	738818	0	0
45896449	1361711	0	0
46242106	975125	0	0
45797088	1174888	0	0
46307695	1125315	0	0
45894228	40223834	2	3
4027384	440448	4	6
3049861	3036780	2	2
21500137	19133679	1	1
21500341	1119510	2	2
36154024	1177480	0	0
21604180	19002770	4	4
36221423	19133905	1	2
40776231	3013682	3	3
44355670	19008572	2	3
44356905	1149380	0	0
44343330	19075601	2	3
44347396	19133873	2	3
45647090	1112807	0	0
45634281	19078461	2	3
45645115	40232448	2	3
45633986	1738521	0	0
45666974	19079524	1	1
45658090	40223834	2	3
45670153	1326303	0	0
45695153	1308738	0	0
45676615	1107830	0	0
45705936	738818	0	0
45784335	1112807	0	0
45784198	19078461	2	3
45797347	1107882	2	3
45790078	1177480	0	0
46243487	738818	0	0
45896370	791967	0	0
46242017	1149196	0	0
45796897	1310149	0	0
46307917	1125315	0	0
45894355	1115171	2	3
4027384	255848	4	7
3049861	3005136	2	2
21500137	19129144	1	1
21500341	1129625	2	2
36154043	1154343	0	0
21604180	742185	4	4
36221423	19133873	1	2
40776231	3016723	3	3
44355505	40232448	2	3
44356911	1738521	0	0
44361656	19075601	2	3
44347398	19075001	2	3
45646136	1112807	0	0
45634705	42707627	2	3
45645076	19078461	2	3
45634094	1115008	0	0
45664408	46275916	1	1
45704092	40232448	2	3
45670173	1551099	0	0
45695155	1361711	0	0
45676180	1124300	0	0
45705651	1124300	0	0
45786468	1112807	0	0
45779546	19078461	2	3
45802331	1332419	2	3
45789700	1177480	0	0
46243586	738818	0	0
45896435	1153428	0	0
46242020	1115008	0	0
45797019	738818	0	0
46308117	1125315	0	0
45894519	19077572	2	3
4027384	40481087	4	7
3049861	3023430	2	2
21013457	19074679	1	1
21500341	738818	2	2
36154046	1119510	0	0
35802134	4027663	4	4
36221147	19078924	1	2
37119620	45769019	3	3
44355967	1551192	2	3
44357030	757627	0	0
44354434	19075601	2	3
44347528	40163554	2	3
45644096	1112807	0	0
45634760	1115171	2	3
45645287	920334	2	3
45634198	1149196	0	0
45634967	1125315	0	0
45704143	40224132	2	3
45670174	1361711	0	0
45695159	1153428	0	0
45676214	1343916	0	0
45705800	1124957	0	0
45784381	1112807	0	0
45784099	19078461	2	3
45700324	1107882	2	3
45790141	1177480	0	0
46243811	738818	0	0
45896410	1713332	0	0
46241913	1548195	0	0
45797027	738818	0	0
46307908	1125315	0	0
45799936	19078924	2	3
4027384	28060	4	7
3050719	3036780	2	2
21011215	1154615	1	1
21500341	1192710	2	2
36154046	1125315	0	0
35702115	4116491	2	2
36214580	35605858	1	2
40770375	3023103	3	3
44356088	19126352	2	3
44357088	967823	0	0
45620075	19075601	2	3
44347560	19008572	2	3
45644218	1112807	0	0
45634768	40232448	2	3
45645320	40223834	2	3
45628917	1501700	0	0
45635062	1125315	0	0
45703985	40162522	2	3
45670060	1124300	0	0
45695192	740275	0	0
45676249	1107830	0	0
45705593	1545958	0	0
45782329	1112807	0	0
45696172	19078461	2	3
46240219	1107882	2	3
45790233	1177480	0	0
46243772	738818	0	0
45896606	1549786	0	0
46241913	1521369	0	0
45797028	1154343	0	0
46308179	1125315	0	0
46318162	40229134	2	3
4027384	258780	4	9
3050719	3005136	2	2
19010482	19134077	1	1
21500341	1125315	2	2
36154046	738818	0	0
35702115	440448	2	2
36221422	19133873	1	2
40770375	3016723	3	3
42805286	44816277	2	3
44357143	1545958	0	0
44362608	19075601	2	3
44347460	1115171	2	3
45644141	1112807	0	0
45634736	19008572	2	3
45645320	40223821	2	3
45628940	1107830	0	0
45634959	1125315	0	0
45703956	19008572	2	3
45670072	1115008	0	0
45695128	1548195	0	0
45676187	791967	0	0
45705655	967823	0	0
45782434	1112807	0	0
45681427	19078461	2	3
45700222	1107882	2	3
45787440	1177480	0	0
46243838	738818	0	0
45896606	1521369	0	0
46242025	757627	0	0
45797143	1192710	0	0
46308427	1125315	0	0
46318106	40243436	2	3
441840	80809	3	7
3050719	3023430	2	2
21500575	1112807	1	1
21500330	1129625	2	2
36154047	1119510	0	0
36102976	28060	2	2
36221422	19133905	1	2
40770375	3013682	3	3
44348706	19077572	2	3
44357052	1729720	0	0
44361400	19075601	2	3
44347775	19018935	2	3
45641136	1112807	0	0
45634805	1115171	2	3
45645199	19008572	2	3
45628898	1310149	0	0
45635035	1125315	0	0
45704146	19008572	2	3
45670041	1521369	0	0
45695208	1124957	0	0
45676203	1174888	0	0
45705861	975125	0	0
45782595	1112807	0	0
45782074	19078461	2	3
45785370	1107882	2	3
45787451	1177480	0	0
46241412	738818	0	0
45896606	1595799	0	0
46242123	1149196	0	0
45797175	1153428	0	0
46308335	1125315	0	0
46318256	46233710	2	3
441840	196456	3	9
3050752	3005136	2	2
21502687	19074679	1	1
21500330	1125315	2	2
36154047	1125315	0	0
36002139	439406	2	2
36313966	4048171	7	12
37503868	4057420	3	3
44349131	1127433	2	3
44357145	933724	0	0
44347121	19075601	2	3
44343349	19073183	2	3
45643296	1112807	0	0
45634793	19008572	2	3
45645307	40162522	2	3
45628996	1713332	0	0
45634985	1125315	0	0
45703780	40229134	2	3
45670076	723013	0	0
45695210	1000560	0	0
45676272	1332418	0	0
45705820	1332418	0	0
45782489	1112807	0	0
45693407	1332419	2	3
45700254	19078461	2	3
45696803	1129625	0	0
46241313	738818	0	0
45896607	920293	0	0
46242238	1549786	0	0
46318051	738818	0	0
46302527	1125315	0	0
46322526	40223834	2	3
4027384	4280726	5	8
3050752	3036780	2	2
21502534	40171902	1	1
21500330	1192710	2	2
36153271	1119510	0	0
36002139	317009	2	2
36313966	4166224	7	11
37503868	4337611	3	3
44349113	19023398	2	3
44357147	1115008	0	0
45619935	1539411	2	3
44344789	19008572	2	3
45643805	1112807	0	0
45631466	40229134	2	3
45642139	40231925	2	3
45628996	1759842	0	0
45635093	1125315	0	0
45704033	1127433	2	3
45670218	1759842	0	0
45695178	1149196	0	0
45676277	1174888	0	0
45706058	1713332	0	0
45782619	1112807	0	0
45684543	1332419	2	3
45792139	1107882	2	3
45696823	1129625	0	0
46241529	738818	0	0
45896610	1192710	0	0
46242238	19127890	0	0
46317665	1149196	0	0
46302542	1125315	0	0
45794376	1115171	2	3
4027384	40486433	5	8
3050752	3023430	2	2
21500145	19128065	1	1
21500345	738818	2	2
36153271	738818	0	0
36002139	134438	2	2
36313966	378001	7	11
37521802	4057420	3	3
42802751	19019273	2	3
44357240	1107830	0	0
44347147	40228214	2	3
44344790	42707627	2	3
45641353	1112807	0	0
45631649	40232448	2	3
45643039	40232448	2	3
45629017	1310149	0	0
45635096	1125315	0	0
45703904	19018935	2	3
45670218	1713332	0	0
45695214	1124957	0	0
45673503	1149196	0	0
45706058	1759842	0	0
45782675	1112807	0	0
45784490	1332419	2	3
46291776	1107882	2	3
45802689	1129625	0	0
46238795	738818	0	0
45896392	1000560	0	0
46242242	1501700	0	0
46317548	1115008	0	0
46302645	1125315	0	0
45794483	40229134	2	3
4042641	4336464	5	8
3050759	3036780	2	2
21500145	19127918	1	1
21500345	1192710	2	2
36153271	1125315	0	0
36002139	133834	2	2
36313966	4240902	7	8
40779250	3027970	3	3
44355574	19019273	2	3
44357246	1110410	0	0
44343498	40228214	2	3
44344767	40232448	2	3
45638128	1112807	0	0
45631916	40163554	2	3
45643048	40223768	2	3
45628904	1107830	0	0
45635057	1125315	0	0
45651760	40236446	2	3
45670187	1118084	0	0
45695226	1115008	0	0
45673482	1501700	0	0
45705944	1305058	0	0
45702587	1112807	0	0
45696720	1539411	2	3
45688382	19078461	2	3
45802802	1129625	0	0
46238561	738818	0	0
45896523	975125	0	0
46242172	1115008	0	0
46317411	1115008	0	0
46302551	1125315	0	0
45794397	1115171	2	3
4086181	378001	5	7
3050759	3023430	2	2
21500145	19127904	1	1
21500345	1125315	2	2
36153280	1119510	0	0
36102977	4116491	2	2
36313966	37017711	7	8
40779250	3024561	3	3
42816558	40223834	2	3
44356818	1545958	0	0
44777976	40228214	2	3
44343732	1127433	2	3
45638145	1112807	0	0
45631782	40229134	2	3
45643065	40228230	2	3
45628905	1310149	0	0
45635203	1125315	0	0
45651757	19078924	2	3
45670300	1154343	0	0
45695403	1310149	0	0
45624510	1361711	0	0
45706019	1149196	0	0
45702592	1112807	0	0
45681555	1332419	2	3
45785088	1107882	2	3
45802886	1129625	0	0
46238809	738818	0	0
45896611	1192710	0	0
46242178	19003953	0	0
45793897	1000560	0	0
46302582	1125315	0	0
46312314	40162522	2	3
4027384	81893	5	7
3050759	3005136	2	2
19081471	19008572	1	1
21500345	1129625	2	2
36153941	1177480	0	0
36158993	42902245	2	2
36313966	441267	6	7
37522193	4295880	3	3
42802587	40163554	2	3
44357064	1174888	0	0
44362758	19078461	2	3
44343687	40232448	2	3
45638149	1112807	0	0
45628451	40223768	2	3
45643043	19133768	2	3
45628895	715997	0	0
45635381	1125315	0	0
45651522	40232448	2	3
45670111	1545958	0	0
45695375	1539403	0	0
45624732	1343916	0	0
45705905	1124957	0	0
45702643	1112807	0	0
45702561	1332419	2	3
45778049	1332419	2	3
45802696	1129625	0	0
45897657	738818	0	0
45896619	933724	0	0
46241946	1192710	0	0
45793890	1192710	0	0
46302654	1125315	0	0
46312110	1115171	2	3
4042140	80809	5	6
3052062	3036780	2	2
21013430	19074679	1	1
21500345	1119510	2	2
35603355	40243436	0	0
36159540	42902245	2	2
36313966	4302207	6	7
37522193	4197460	3	3
42802496	1545959	2	3
44357065	1177480	0	0
44339983	40228214	2	3
44343823	1594382	2	3
45638052	1112807	0	0
45628746	43012036	2	3
45643021	40229134	2	3
45629060	723013	0	0
45635118	1125315	0	0
45651641	1107882	2	3
45669908	1149196	0	0
45695498	1713332	0	0
45624733	1174888	0	0
45705539	1107830	0	0
45702739	1112807	0	0
45705655	19079524	2	3
46240704	1107882	2	3
45802950	1129625	0	0
45897927	738818	0	0
45893939	1713332	0	0
46242319	975125	0	0
45794004	1149196	0	0
46302576	1125315	0	0
46312329	40229134	2	3
4042140	441267	5	6
3052062	3023430	2	2
21002731	40221415	1	1
21500345	1112807	2	2
36153996	975125	0	0
36202158	4299128	2	2
36313966	4102123	6	7
40792365	3005136	3	3
42805042	46233988	2	3
44357175	19127890	0	0
44351056	40228214	2	3
44343723	40232448	2	3
45638229	1112807	0	0
45628711	35605482	2	3
45643065	40228214	2	3
45629116	1154343	0	0
45629903	1125315	0	0
45651329	40231925	2	3
45669912	1551099	0	0
45695502	1154343	0	0
45624853	914335	0	0
45705540	708298	0	0
45702661	1112807	0	0
45672363	1332419	2	3
45785677	19079524	2	3
45802910	1129625	0	0
45895542	738818	0	0
45893985	1307863	0	0
46242059	1149196	0	0
45794186	1174888	0	0
46303349	1125315	0	0
46312591	40223834	2	3
4042140	134438	5	7
3052062	3005136	2	2
21002731	19127904	1	1
21500356	1192710	2	2
36153963	1112807	0	0
36202158	4296204	2	2
36313966	4304110	6	7
37303809	4113008	3	3
42805042	46233710	2	3
44357175	1549786	0	0
44341455	19078461	2	3
44344038	40229134	2	3
45634855	1112807	0	0
45628625	40165015	2	3
45643121	40232448	2	3
45629141	1115008	0	0
45629962	1125315	0	0
45651341	35605482	2	3
45669985	740275	0	0
45695504	1000560	0	0
45624854	791967	0	0
45705785	1192710	0	0
45702913	1112807	0	0
45687617	1332419	2	3
46240545	19078461	2	3
45800100	1129625	0	0
45896731	738818	0	0
45893991	1713332	0	0
46242114	1107830	0	0
45794187	1115008	0	0
46302856	1125315	0	0
46312752	19133905	2	3
4042140	4116491	5	7
3051724	3036780	2	2
21002731	19127918	1	1
21500355	1174888	2	2
36153639	1177480	0	0
36202158	4296205	2	2
36313966	4169137	6	7
37303809	4155034	3	3
44348866	1539411	2	3
44357184	1112807	0	0
44361401	40223768	2	3
44344041	19008572	2	3
44361752	975125	0	0
45631132	19008572	2	3
45642194	19019273	2	3
45629084	1361711	0	0
45630143	1125315	0	0
45651447	40163554	2	3
45670143	1124957	0	0
45695285	1549786	0	0
45624956	738818	0	0
45705786	1361711	0	0
45696630	1112807	0	0
45672389	1332419	2	3
45786954	40173590	2	3
45800234	1129625	0	0
45679031	1177480	0	0
45893952	1501700	0	0
46242148	1174888	0	0
45794191	1332418	0	0
46302858	1125315	0	0
46306918	19059056	2	3
4042140	4149245	5	9
3051724	3023430	2	2
21002731	42902245	1	1
21500356	1174888	2	2
36153648	1589505	0	0
36198925	42902245	2	2
36313966	4266809	6	9
37303809	4109685	3	3
44355850	19078924	2	3
44357070	1177480	0	0
45619714	19078461	2	3
45643264	19077344	2	3
44361773	975125	0	0
45631023	1107882	2	3
45642185	40229134	2	3
45629045	738818	0	0
45629885	1125315	0	0
45651717	46233988	2	3
45783634	1557272	0	0
45695285	1589505	0	0
45624797	1174888	0	0
45705787	1192710	0	0
45679978	1177480	0	0
45687542	1332419	2	3
45685363	19078461	2	3
45800152	1129625	0	0
45679149	1177480	0	0
45893998	1000560	0	0
46241987	1332418	0	0
45794192	920293	0	0
46302678	1125315	0	0
46307032	40232448	2	3
4042140	321042	5	9
3051724	3005136	2	2
21002731	19128263	1	1
21500356	1119510	2	2
36153651	1119510	0	0
36152230	19128263	2	2
36313966	198199	6	9
37303809	4152936	3	3
42805188	19073183	2	3
44356828	975125	0	0
45619858	19078461	2	3
45643146	40232448	2	3
44361926	975125	0	0
45631066	1539411	2	3
45642253	40231925	2	3
45629159	967823	0	0
45629866	1125315	0	0
45652256	1107882	2	3
45783636	1728416	0	0
45695139	1154343	0	0
45624800	1149196	0	0
45706043	1551099	0	0
45678072	1177480	0	0
45672304	1332419	2	3
45792034	19078461	2	3
45802288	1129625	0	0
45785945	1177480	0	0
45894168	1548195	0	0
46242190	1124300	0	0
45794197	1149196	0	0
46302701	1125315	0	0
46307109	1127433	2	3
4042140	260139	5	9
3053021	3023430	2	2
21002731	19128009	1	1
21500358	1119510	2	2
36153651	1125315	0	0
36152230	19128022	2	2
36313966	81151	6	11
37303809	4296204	3	3
44355845	1107882	2	3
44356992	1110410	0	0
44346869	19078461	2	3
45643448	19073183	2	3
45655954	975125	0	0
45628783	1107882	2	3
45642240	40165015	2	3
45629161	738818	0	0
45629868	1125315	0	0
45652204	1107882	2	3
45783640	1000560	0	0
45695287	1149196	0	0
45624815	1115008	0	0
45705915	1713332	0	0
45677687	1177480	0	0
45702355	1545959	2	3
45777733	1332419	2	3
45797540	1129625	0	0
45786045	1177480	0	0
45893924	1551099	0	0
46242192	975125	0	0
45794021	1729720	0	0
46302816	1125315	0	0
46311831	40222846	2	3
4042140	40481087	5	9
3053021	3005136	2	2
21002731	19128022	1	1
21500358	1192710	2	2
36153654	1112807	0	0
36009773	4048171	2	2
36313966	258780	6	11
40776269	3024561	3	3
42819196	1107882	2	3
44357071	1309944	0	0
44340062	19078461	2	3
45643534	1551192	2	3
45655965	975125	0	0
45628936	19078461	2	3
45642310	1713671	2	3
45629120	791967	0	0
45629908	1125315	0	0
45652089	19008572	2	3
45783714	715997	0	0
45695265	1501700	0	0
45625043	1154343	0	0
45705915	1759842	0	0
45677682	1177480	0	0
45699690	1539411	2	3
45792268	19019273	2	3
45797437	1129625	0	0
45786674	1177480	0	0
45893954	933724	0	0
46242198	1149196	0	0
45794144	933724	0	0
46302743	1125315	0	0
46307380	1127433	2	3
4042140	4278672	5	9
3053021	3036780	2	2
21506042	1332418	3	3
21500358	1174888	2	2
36153654	1125315	0	0
35809406	4027663	2	2
36313966	40481087	6	10
40776269	3026361	3	3
42802474	1332419	2	3
44357122	1738521	0	0
45619741	19078461	2	3
45643190	19073188	2	3
45652632	975125	0	0
45628890	1332419	2	3
45639269	19008572	2	3
45629164	738818	0	0
45630083	1125315	0	0
45651843	40228214	2	3
45783732	791967	0	0
45695321	1124957	0	0
45624963	708298	0	0
45705923	1322184	0	0
45674527	1177480	0	0
45705822	1539411	2	3
45694307	40173590	2	3
45797446	1129625	0	0
46292423	1177480	0	0
45894007	1332418	0	0
46242151	1548195	0	0
45794236	723013	0	0
46302746	1125315	0	0
46307234	1115171	2	3
4042140	4048695	5	9
3052929	3023430	2	2
21506042	1307863	3	3
21500359	1119510	2	2
36153655	1177480	0	0
35708308	81893	2	2
36313966	4278672	6	10
40776269	3007461	3	3
44348628	19078461	2	3
44357287	975125	0	0
44361591	19078461	2	3
45643192	19008572	2	3
45652770	975125	0	0
45625844	1332419	2	3
45639315	1551192	2	3
45628924	1000560	0	0
45630099	1125315	0	0
45697851	40232448	2	3
45783768	738818	0	0
45695410	967823	0	0
45624831	1332418	0	0
45705893	1192710	0	0
45674985	1177480	0	0
45784834	1539411	2	3
45876038	3010813	2	3
45797858	1129625	0	0
46292508	1177480	0	0
45893969	1107830	0	0
46242310	1154029	0	0
45794154	1713332	0	0
46302777	1125315	0	0
46307194	1115171	2	3
4042140	317576	5	9
3052929	3005136	2	2
21500129	19127890	3	3
21500359	1192710	2	2
36153893	1119510	0	0
35702112	441267	2	2
36313966	4149245	6	10
37320089	134438	3	3
42802894	19078461	2	3
44357289	1713332	0	0
44357490	1545959	2	3
45640292	1545959	2	3
45652891	975125	0	0
45625849	19008572	2	3
45638981	1332419	2	3
45629000	1153428	0	0
45630062	1125315	0	0
45700722	19057271	2	3
45783772	1307863	0	0
45695416	738818	0	0
45670283	1153428	0	0
45705901	1396131	0	0
45674807	1177480	0	0
45779769	1539411	2	3
45876038	3000963	2	3
45797178	1129625	0	0
46293178	1177480	0	0
45894144	1713332	0	0
46242326	1154343	0	0
45794810	1548195	0	0
46303039	1125315	0	0
46307364	1115171	2	3
4042140	196456	5	8
3052929	3036780	2	2
21500129	19054876	3	3
21500359	1125315	2	2
36153899	1129625	0	0
35909435	196456	2	2
36313966	4142905	6	10
40779168	3026361	3	3
42805451	19075601	2	3
44357215	1149380	0	0
44346938	1332419	2	3
45640335	19019273	2	3
45652872	975125	0	0
45625921	40232448	2	3
45635777	19076374	2	3
45628958	1548195	0	0
45630023	1125315	0	0
45700715	40232448	2	3
45783723	1137529	0	0
45695255	1124957	0	0
45670324	1115008	0	0
45705838	1713332	0	0
45675164	1177480	0	0
45693599	19078461	2	3
45675678	1332419	2	3
45797312	1129625	0	0
46293245	1177480	0	0
45894144	1759842	0	0
46242328	1332418	0	0
45794546	1332418	0	0
46302903	1125315	0	0
46307969	19059056	2	3
4042140	255848	5	8
3052932	3036780	2	2
21500129	1521369	3	3
21500353	1125315	2	2
36153899	1125315	0	0
35809320	40480160	2	2
36313966	4001336	6	10
40779168	3010813	3	3
42817786	40228214	2	3
44357289	1759842	0	0
44339989	1545959	2	3
45640424	40232448	2	3
45649544	975125	0	0
45625951	40232448	2	3
45636072	40223834	2	3
45629245	1000560	0	0
45630027	1125315	0	0
45648728	1115171	2	3
45783723	1149380	0	0
45695234	967823	0	0
45670575	1115008	0	0
45705839	1115008	0	0
45675089	1177480	0	0
45702920	1539411	2	3
45685527	19078461	2	3
45797219	1129625	0	0
46293198	1177480	0	0
45893910	1307863	0	0
46242146	1729720	0	0
45794751	1500211	0	0
46303185	1125315	0	0
46307305	19077572	2	3
4042140	28060	5	8
3052932	3023430	2	2
21500129	1500211	3	3
21500353	1119510	2	2
36153915	1112807	0	0
35702767	192671	2	2
36313966	4116491	6	8
36919117	440086	3	3
44355873	40228214	2	3
44357290	1177480	0	0
44339966	1539411	2	3
45640415	1551192	2	3
45649550	975125	0	0
45625980	19019273	2	3
45635894	19008572	2	3
45629192	738818	0	0
45630029	1125315	0	0
45648735	1115171	2	3
45783825	738818	0	0
45695269	757627	0	0
45670333	1595799	0	0
45705843	19010482	0	0
45671786	1177480	0	0
45672760	1539411	2	3
45685855	40228214	2	3
45795027	1129625	0	0
46293381	1177480	0	0
45894122	782043	0	0
46242311	1149196	0	0
45794796	705944	0	0
46303295	1125315	0	0
46307215	35605482	2	3
4042140	381316	4	7
3052932	3005136	2	2
21500129	1549786	3	3
21505744	1125315	2	2
36153928	1153428	0	0
35702116	30753	2	2
36313966	4299128	6	6
36919117	378419	3	3
42804941	1332419	2	3
44358904	1322184	0	0
43534937	40174880	2	3
45640546	19008572	2	3
45649862	975125	0	0
45626058	1107882	2	3
45635907	40229134	2	3
45628961	1115008	0	0
45630167	1125315	0	0
45648776	19074843	2	3
45783830	1153428	0	0
45695235	1501700	0	0
45670333	1521369	0	0
45705844	19127890	0	0
45671977	1177480	0	0
45675037	1539411	2	3
46242587	1332419	2	3
45795075	1129625	0	0
46292965	1177480	0	0
45893972	1551099	0	0
46242315	1115008	0	0
45794801	738818	0	0
46303019	1125315	0	0
46307576	1115171	2	3
4042140	4310024	4	8
3052978	3036780	2	2
21500129	40221415	3	3
21505744	1119510	2	2
36153929	1396131	0	0
35702114	192671	2	2
36313966	4094814	5	5
40776264	3009201	3	3
42805156	1332419	2	3
44358905	19127890	0	0
44343426	1539411	2	3
45640381	19008572	2	3
45646554	975125	0	0
45625836	1115171	2	3
45636072	40223821	2	3
45629095	1118084	0	0
45630258	1125315	0	0
45648684	19073183	2	3
45783879	753626	0	0
45695239	1367571	0	0
45670333	1549786	0	0
45705844	1589505	0	0
45671846	1177480	0	0
45688165	1539411	2	3
45782876	19075601	2	3
45792320	1129625	0	0
46288227	1177480	0	0
45894097	1729720	0	0
46242200	1729720	0	0
45794858	715997	0	0
46302992	1125315	0	0
46307495	19077572	2	3
4042140	4283893	4	8
3052978	3023430	2	2
21500129	1589505	3	3
21505749	1192710	2	2
36153323	1119510	0	0
36110584	258780	2	2
36313966	440086	5	7
37521809	4323902	3	3
42805212	1332419	2	3
44358905	1589505	0	0
43530807	4219399	4	4
45640757	19133768	2	3
45640875	975125	0	0
45626070	1107882	2	3
45635911	40232448	2	3
45629097	967823	0	0
45630172	1125315	0	0
45648686	19008572	2	3
45783910	1000560	0	0
45695339	1110410	0	0
45670416	1539403	0	0
45705844	1549786	0	0
45671787	1177480	0	0
45706099	19128009	1	2
45780494	19075601	2	3
45792500	1129625	0	0
46288109	1177480	0	0
45894062	1115008	0	0
46242203	1192710	0	0
45794752	1149196	0	0
46303473	1125315	0	0
46302194	40236824	2	3
4042140	195588	4	9
3052978	3005136	2	2
21500129	1548195	3	3
21505749	1125315	2	2
36153328	1115008	0	0
36110736	198199	2	2
36313966	80502	5	7
37503861	44783196	3	3
42848776	42902245	2	2
44358905	1549786	0	0
43530807	433644	4	4
45640757	40162522	2	3
45640637	975125	0	0
45625839	19018935	2	3
45636223	1551192	2	3
45629106	1332418	0	0
45630176	1125315	0	0
45648750	19019273	2	3
45783746	1521369	0	0
45695340	1124300	0	0
45670474	1551099	0	0
45705972	1310149	0	0
45671741	1177480	0	0
45694152	19128263	1	2
45680928	19078461	2	3
45789536	1129625	0	0
46288399	1177480	0	0
45894155	975125	0	0
46242267	1322184	0	0
45794270	1545958	0	0
46303236	1125315	0	0
46301878	1551192	2	3
4042140	192671	4	6
3052983	3023430	2	2
21500129	1512674	3	3
21506108	1332418	2	2
36154131	1125315	0	0
36110736	4056621	2	2
36313966	140673	5	7
37503861	4301346	3	3
42870592	3010813	2	2
44358910	1192710	0	0
43530807	4240902	4	4
45640758	19075601	2	3
45637612	975125	0	0
45626031	19008572	2	3
45636009	19078924	2	3
45629208	1000560	0	0
45630335	1125315	0	0
45648612	40223834	2	3
45783748	705944	0	0
45695364	1545958	0	0
45670616	1149196	0	0
45705977	967823	0	0
45672260	1177480	0	0
45706783	975125	0	0
45799961	40223768	2	3
45789969	1129625	0	0
46288500	1177480	0	0
45894156	1551099	0	0
46242046	1000560	0	0
45794276	1717327	0	0
46300280	1125315	0	0
46302358	40236824	2	3
4042140	80502	4	6
3052983	3005136	2	2
21500594	1177480	3	3
21500007	1759842	2	2
36154131	1129625	0	0
36110704	40486433	2	2
36313966	4283893	5	9
37520918	4117038	3	3
42868693	3015632	2	2
44358912	1115008	0	0
43530807	37017711	4	4
45640771	40223834	2	3
45637891	975125	0	0
45626033	19133768	2	3
45635924	19133768	2	3
45629284	1124300	0	0
45630353	1125315	0	0
45648848	19019273	2	3
45783759	1713332	0	0
45695371	738818	0	0
45670618	1107830	0	0
45705980	1118084	0	0
45783899	1177480	0	0
45706626	1545958	0	0
46240742	19075601	2	3
45789797	1129625	0	0
46244856	1177480	0	0
45894163	1738521	0	0
45893597	1309944	0	0
45794305	1149196	0	0
46300293	1125315	0	0
46302361	920334	2	3
4042140	4329847	4	10
3052983	3036780	2	2
21500594	1115008	3	3
21500007	1746114	2	2
36154133	1125315	0	0
36110704	4280726	2	2
36313966	4310024	5	9
37520918	4330583	3	3
42868693	3014576	2	2
44358914	1717327	0	0
43530897	4139681	4	4
45640772	1551192	2	3
45634667	975125	0	0
45626083	1551192	2	3
45633007	19078924	2	3
45629261	723013	0	0
45630354	1125315	0	0
45648853	19133768	2	3
45783867	1115008	0	0
45695390	1549786	0	0
45670619	1107830	0	0
45705991	1149196	0	0
45783935	1177480	0	0
45706856	967823	0	0
46244924	19075601	2	3
45789964	1129625	0	0
46244705	1177480	0	0
45894164	933724	0	0
45893599	1713332	0	0
45794311	1713332	0	0
46300368	1125315	0	0
46302306	40232448	2	3
4029205	4015189	4	7
3016782	3020630	2	2
21502522	914335	3	3
21500007	1728416	2	2
36154134	1119510	0	0
36110708	4294548	2	2
36313966	4056621	5	9
37520918	4242997	3	3
42868693	3023103	2	2
44358820	1177480	0	0
43530897	4302207	4	4
45637475	40232448	2	3
45634736	975125	0	0
45622618	19078924	2	3
45632772	40232448	2	3
45629316	738818	0	0
45630184	1125315	0	0
45648612	40223821	2	3
45783871	1551099	0	0
45691995	1738521	0	0
45670632	1501700	0	0
45705992	975125	0	0
45784043	1177480	0	0
45706701	975125	0	0
46242610	19078461	2	3
45789087	1129625	0	0
46243418	1177480	0	0
45798573	1112807	0	0
45893599	1759842	0	0
45794333	1539403	0	0
46300301	1125315	0	0
46302027	46221626	2	3
4029205	4337138	4	6
3016782	3027970	2	2
21502522	920293	3	3
21500007	1713332	2	2
36154135	1129625	0	0
36110712	260139	2	2
36313966	4109685	5	9
40772935	3020630	3	3
42868693	3019550	2	2
44358948	19127890	0	0
43530897	438614	4	4
45637170	40243436	2	3
45634446	975125	0	0
45622649	43012036	2	3
45632949	19077344	2	3
45629341	1396131	0	0
45630424	1125315	0	0
45648795	19078461	2	3
45783873	975125	0	0
45691996	1738521	0	0
45670683	1107830	0	0
45705997	967823	0	0
45784099	1177480	0	0
45706703	1124957	0	0
45794961	19078461	2	3
45789156	1129625	0	0
46242301	1177480	0	0
45798472	1112807	0	0
45893629	1174888	0	0
45794349	1728416	0	0
46300306	1125315	0	0
46302126	40236824	2	3
4029205	44783196	4	6
1521405	19127922	2	2
21502522	933724	3	3
21500007	1741122	2	2
36154135	1125315	0	0
36110715	40481087	2	2
36313966	4113008	5	8
37320108	134438	2	3
42868693	3045716	2	2
44358948	1521369	0	0
43530897	442116	4	4
45637110	19075601	2	3
45634793	975125	0	0
45622845	40236824	2	3
45632989	40232448	2	3
45629393	1124957	0	0
45630389	1125315	0	0
45648629	19074843	2	3
45783853	705944	0	0
45692004	1367571	0	0
45670595	1713332	0	0
45706002	738818	0	0
45784057	1177480	0	0
45706858	1115008	0	0
46244871	1539411	2	3
45787036	1129625	0	0
46241146	1177480	0	0
45798442	1112807	0	0
45893698	791967	0	0
45794282	738818	0	0
46300387	1125315	0	0
46302387	40228230	2	3
4029205	4197460	5	6
1521405	19133679	2	2
21500136	1595799	3	3
21500007	1717327	2	2
36154139	1115008	0	0
36111056	4112343	2	2
36313966	372328	5	8
36422768	40243436	2	3
44349077	19128009	2	2
44358948	1549786	0	0
43530897	4102123	4	4
45637432	1115171	2	3
45631727	975125	0	0
45622390	1127433	2	3
45632996	40231925	2	3
45629272	1367571	0	0
45627087	1125315	0	0
45649131	43012036	2	3
45783796	933724	0	0
45692203	1308738	0	0
45670605	1149196	0	0
45703704	1500211	0	0
45784294	1177480	0	0
45706862	1521369	0	0
45679189	1539411	2	3
45787010	1129625	0	0
46241386	1177480	0	0
45798563	1112807	0	0
45893650	1149196	0	0
45794284	740275	0	0
46300313	1125315	0	0
46302389	40162522	2	3
4029205	4238715	5	6
1521405	19129144	2	2
21500136	19054876	3	3
21604792	701322	2	2
36154141	1125315	0	0
36152003	19074843	2	3
36313966	4155034	5	8
36422742	1545959	2	3
42802692	19128009	2	2
44358821	1713332	0	0
43530897	4048169	4	4
45637491	1551192	2	3
45628596	975125	0	0
45622406	40229134	2	3
45633991	40236446	2	3
45629273	1107830	0	0
45627185	1125315	0	0
45645996	40229134	2	3
45783803	738818	0	0
45692011	1115008	0	0
45670721	1110410	0	0
45703709	1000560	0	0
45782074	1177480	0	0
45706862	1548195	0	0
46243041	19075601	2	3
45787046	1129625	0	0
46238467	1177480	0	0
45793476	1112807	0	0
45893676	1307863	0	0
45794288	1124300	0	0
46300474	1125315	0	0
46302464	1127433	2	3
4029205	4057420	5	8
440921	4094814	2	2
21500136	1521369	3	3
21604182	19078219	2	2
36153616	1125315	0	0
36151288	19019273	2	3
36313966	195588	5	10
36903633	378419	2	3
42802692	19127918	2	2
44358821	1759842	0	0
43530897	4304110	4	4
45637517	920300	2	3
45628770	975125	0	0
45622661	19019273	2	3
45642076	19075001	2	3
45627958	1759842	0	0
45627186	1125315	0	0
45646107	19078461	2	3
45783977	1149196	0	0
45692013	1149380	0	0
45670644	1512674	0	0
45703742	1154343	0	0
45782065	1177480	0	0
45706769	1192710	0	0
45672905	19078461	2	3
45787133	1129625	0	0
46238468	1177480	0	0
45793295	1112807	0	0
45893732	1332418	0	0
45794424	933724	0	0
46300480	1125315	0	0
46306891	40162522	2	3
4029205	4108705	5	7
1332418	1332419	2	3
21500136	1500211	3	3
21604182	19039298	2	2
36154150	1713332	0	0
36151808	40236446	2	3
36313966	260139	5	10
37002286	195588	2	3
44358988	1539403	0	0
44358952	1107830	0	0
43530897	4169137	4	4
45639825	19077344	2	3
45631132	975125	0	0
45622723	40229134	2	3
45663382	19075001	2	3
45628071	933724	0	0
45627191	1125315	0	0
45646235	1107882	2	3
45783989	738818	0	0
45691785	1115008	0	0
45670644	1548195	0	0
45703743	920293	0	0
45782152	1177480	0	0
45705270	1124300	0	0
45789421	40223768	2	3
45787172	1129625	0	0
46238471	1177480	0	0
45793297	1112807	0	0
45893635	791967	0	0
45794337	1107830	0	0
46300511	1125315	0	0
46306809	19129655	2	3
4029205	4337611	5	7
1149380	40169216	2	3
21500136	19127922	3	3
21604182	19002770	2	2
36154183	1192710	0	0
36158967	1551192	2	3
36313966	261325	5	10
37303797	133834	1	3
44359115	1177480	0	0
44358904	1112807	0	0
43530897	4306014	4	4
45639997	40228214	2	3
45625849	975125	0	0
45622736	19019273	2	3
45641626	19073183	2	3
45628007	1115008	0	0
45627107	1125315	0	0
45645589	1127433	2	3
45781454	705944	0	0
45692066	1539403	0	0
45670348	914335	0	0
45703863	1124300	0	0
45782142	1177480	0	0
45705281	1548195	0	0
45794940	19075601	2	3
45787333	1129625	0	0
46238387	1177480	0	0
45793392	1112807	0	0
45893736	1548195	0	0
45794293	975125	0	0
46300735	1125315	0	0
46306854	40232448	2	3
4040390	4186930	5	6
1149380	40169281	2	3
21500136	1503184	3	3
21604182	782043	2	2
36154186	1129625	0	0
36102976	40481087	2	3
36313966	4329847	5	11
36241494	19029476	1	2
44359123	738818	0	0
44358956	1149196	0	0
43530897	439406	4	4
45634051	1127433	2	3
45626031	975125	0	0
45622817	19008572	2	3
45658547	19073183	2	3
45628123	967823	0	0
45627109	1125315	0	0
45645886	1127433	2	3
45781568	19039298	0	0
45692224	1192710	0	0
45670493	967823	0	0
45703873	791967	0	0
45782010	1177480	0	0
45705283	1110410	0	0
45682439	19078461	2	3
45785602	1129625	0	0
46238777	1177480	0	0
45793153	1112807	0	0
45893705	933724	0	0
45794428	1557272	0	0
46300636	1125315	0	0
46306311	1127433	2	3
4040390	4057420	5	5
1729720	19133873	2	3
21500136	1518198	3	3
21604182	19059528	2	2
36154187	1192710	0	0
36158865	19008572	2	3
36313966	133834	8	10
37502354	4216130	2	2
44359130	1129625	0	0
44359054	1107830	0	0
43530897	37017711	5	5
45634398	40231925	2	3
45622700	975125	0	0
45623045	19008572	2	3
45639241	19075001	2	3
45628277	1549786	0	0
45627366	1125315	0	0
45645607	43012036	2	3
45781597	920293	0	0
45692279	791967	0	0
45670458	1149196	0	0
45703755	1153428	0	0
45782187	1177480	0	0
45705214	1343916	0	0
45802538	40228214	2	3
45785856	1129625	0	0
45897430	1177480	0	0
45793252	1112807	0	0
45893700	1738521	0	0
45791569	1124300	0	0
46300807	1125315	0	0
46306256	40231925	2	3
4040390	4078793	5	5
1729720	19133905	2	3
21500136	19127890	3	3
21602099	1149380	2	2
36154189	791967	0	0
36158843	19125062	2	3
36313966	40479768	8	11
36703533	4066995	2	2
44358995	1129625	0	0
44358638	1177480	0	0
43530897	4219399	5	5
45634123	43012036	2	3
45622817	975125	0	0
45622957	1154615	2	3
45627162	19078461	2	3
45628278	738818	0	0
45627375	1125315	0	0
45642677	1115171	2	3
45781710	1548195	0	0
45692281	1309944	0	0
45670384	1343916	0	0
45702248	1124957	0	0
45779768	1177480	0	0
45705181	708298	0	0
45797367	40223768	2	3
45785611	1129625	0	0
45897433	1177480	0	0
45793258	1112807	0	0
45893713	1000560	0	0
45791453	738818	0	0
46300429	1125315	0	0
46306901	40163554	2	3
4040390	4058899	5	7
1149196	40228230	2	3
21500136	1515774	3	3
21502573	40224805	2	3
36154191	1125315	0	0
36158968	19125062	2	3
36313966	4134304	8	12
36703534	4132546	2	2
44358996	1192710	0	0
44359023	1738521	0	0
43530897	4240902	5	5
45634313	1127433	2	3
45623045	975125	0	0
45622973	19073183	2	3
45632666	40228214	2	3
45626200	738818	0	0
45627377	1125315	0	0
45642719	19008572	2	3
45781298	1115008	0	0
45692191	1000560	0	0
45670291	1557272	0	0
45702282	1107830	0	0
45779546	1177480	0	0
45705242	1115008	0	0
45786535	40228214	2	3
45785613	1129625	0	0
45897456	1177480	0	0
45794492	1112807	0	0
45893755	1713332	0	0
45791456	1174888	0	0
46300598	1125315	0	0
46306336	1551192	2	3
4040390	4336464	6	9
1149196	40228214	2	3
21500136	1589505	3	3
21502573	40224132	2	3
36154191	738818	0	0
36158796	40232448	2	3
36313966	317009	4	5
40770464	3024561	2	2
44358997	1129625	0	0
44359055	708298	0	0
43530897	433644	5	5
45634456	40232448	2	3
45622956	975125	0	0
45621021	1332419	2	3
45639252	1107882	2	3
45626151	723013	0	0
45627126	1125315	0	0
45642844	19008572	2	3
45781301	1115008	0	0
45692324	1595799	0	0
45670298	1713332	0	0
45702346	1310149	0	0
45779980	1177480	0	0
45705191	1192710	0	0
45685266	40228214	2	3
45785657	1129625	0	0
45897512	1177480	0	0
45787843	1112807	0	0
45893755	1759842	0	0
45791295	1124957	0	0
46300569	1125315	0	0
46299663	1127433	2	3
4040390	4117038	6	7
1137529	40169281	2	3
21500136	43012433	3	3
21502575	1519937	2	3
36154191	1119510	0	0
36158821	1115171	2	3
36313966	4027663	4	8
40770464	3000963	2	2
44358755	1115008	0	0
44358841	1177480	0	0
43530897	4174876	3	3
45634585	1127433	2	3
45623183	975125	0	0
45620878	19078461	2	3
45647353	1332419	2	3
45626153	1778162	0	0
45627150	1125315	0	0
45642817	19019273	2	3
45781305	1125443	0	0
45692185	1545958	0	0
45670359	1738521	0	0
45702352	1307863	0	0
45779888	1177480	0	0
45705200	791967	0	0
46240350	40228214	2	3
45785669	1129625	0	0
45897520	1177480	0	0
45787918	1112807	0	0
45893760	975125	0	0
45791380	1107830	0	0
46300826	1125315	0	0
46299676	1127433	2	3
4040390	4047491	6	7
740275	19074679	2	3
21500136	1519936	3	3
21503951	19023398	2	3
36154193	1119510	0	0
36158800	1551192	2	3
36313966	317576	4	10
40770464	3016723	2	2
44358891	920293	0	0
44359037	715997	0	0
43530807	4306014	3	3
45634430	19008572	2	3
45621126	975125	0	0
45621269	1115171	2	3
45647555	1107882	2	3
45626170	1310149	0	0
45627363	1125315	0	0
45642832	19008572	2	3
45781816	1174888	0	0
45692363	1174888	0	0
45670095	1501700	0	0
45702244	1154029	0	0
45779924	1177480	0	0
45705208	1174888	0	0
45703253	40174880	2	3
45785694	1129625	0	0
45897644	1177480	0	0
45788146	1112807	0	0
45893729	1174888	0	0
45791381	1149196	0	0
46300829	1125315	0	0
46299726	19077344	2	3
4040390	4242997	6	6
1738521	46233988	2	3
21500136	19133679	3	3
21503951	782047	2	3
36154193	1125315	0	0
36158804	40232448	2	3
36313966	4237458	4	10
36423637	19010482	0	0
44359113	1112807	0	0
44359057	1332418	0	0
43530807	442116	3	3
45634276	40231925	2	3
45621955	975125	0	0
45621126	19008572	2	3
45623977	19073183	2	3
45626132	1124957	0	0
45627539	1125315	0	0
45688685	19078461	2	3
45781817	933724	0	0
45692372	1361711	0	0
45670459	1110410	0	0
45702245	791967	0	0
45708041	1177480	0	0
45705259	1539403	0	0
45802567	19079524	2	3
45785955	1129625	0	0
45895395	1177480	0	0
45788055	1112807	0	0
45893768	1115008	0	0
45791370	1728416	0	0
46300852	1125315	0	0
46299777	19059056	2	3
4040390	40492359	6	6
926487	19045231	2	3
21500136	1548195	3	3
21002075	46275444	2	3
36153954	1177480	0	0
36159148	40232448	2	3
36313966	4066995	4	10
36463150	1119510	0	0
44359317	933724	0	0
44358736	1729720	0	0
43530807	4102123	3	3
45634526	40229134	2	3
45664836	975125	0	0
45621296	1115171	2	3
45635923	1107882	2	3
45626187	1361711	0	0
45623707	1125315	0	0
45688381	19079524	2	3
45781535	701322	0	0
45692284	1124957	0	0
45670433	1000560	0	0
45702321	975125	0	0
45708184	1177480	0	0
45705253	1307863	0	0
46243040	19079524	2	3
46296258	1129625	0	0
45895410	1177480	0	0
45788198	1112807	0	0
45893744	933724	0	0
45791509	740275	0	0
46300854	1125315	0	0
46291258	19079524	1	1
4040390	4170947	4	4
757627	19077572	2	3
21500136	1549786	3	3
21002077	46275444	2	3
36154199	1129625	0	0
36159229	40232448	2	3
36313966	40480160	4	10
36463158	1129625	0	0
44359320	1115008	0	0
44358751	738818	0	0
43530807	4302207	3	3
45634363	19018935	2	3
45665122	975125	0	0
45621307	40174880	2	3
45663649	1107882	2	3
45626189	1107830	0	0
45623896	1125315	0	0
45688471	40163554	2	3
45781289	1174888	0	0
45683734	1119510	0	0
45670367	967823	0	0
45702267	1124957	0	0
45708362	1177480	0	0
45705162	1149196	0	0
45697646	40228214	2	3
46296263	1129625	0	0
45895405	1177480	0	0
45788280	1112807	0	0
45893781	1738521	0	0
45791468	1124300	0	0
46300911	1125315	0	0
46270317	4237458	1	1
4040390	4181917	4	4
1322184	19075601	2	3
21500136	975125	3	3
21002068	46275444	2	3
36153617	1125315	0	0
36159130	40229134	2	3
36313966	4029498	4	7
36463158	1125315	0	0
44359077	1177480	0	0
44357299	1713332	0	0
43530807	4169137	3	3
45634621	40236824	2	3
45664946	975125	0	0
45621823	1107882	2	3
45628061	19078461	2	3
45626222	1115008	0	0
45623900	1125315	0	0
45691232	40223768	2	3
45781631	967823	0	0
45683834	1119510	0	0
45669036	1307863	0	0
45702354	920293	0	0
45778115	1177480	0	0
45780013	1174888	0	0
45799825	19078461	2	3
46292033	1129625	0	0
45895528	1177480	0	0
46293937	1112807	0	0
45893879	1717327	0	0
45791709	738818	0	0
46300916	1125315	0	0
45802374	19115351	1	1
4040390	4199276	4	4
738818	40229134	2	3
21500136	19129144	3	3
21002069	46275444	2	3
36153617	1112807	0	0
36159139	1115171	2	3
36313966	44782520	4	7
36463159	1154343	0	0
44359321	1129625	0	0
44357299	1759842	0	0
43530807	438614	3	3
45634689	42707627	2	3
45665194	975125	0	0
45622168	19073183	2	3
45637032	1107882	2	3
45626216	1102527	0	0
45625135	1125315	0	0
45639813	19008572	2	3
45781636	738818	0	0
45683770	1119510	0	0
45669039	1149380	0	0
45702326	1115008	0	0
45706079	1177480	0	0
45780017	1713332	0	0
45794876	40223768	2	3
46292089	1129625	0	0
45895245	1177480	0	0
46293893	1112807	0	0
45894165	1115008	0	0
45791684	1174888	0	0
46301016	1125315	0	0
46312099	19079524	1	1
4040390	44783196	4	7
1746114	46275444	2	3
21500136	1512674	3	3
21002072	46275444	2	3
36153619	1129625	0	0
35702120	4027663	2	3
36313966	4043241	3	12
36463290	1125315	0	0
44359068	1515774	0	0
44357364	1717327	0	0
43530807	439406	3	3
45631091	40229134	2	3
45665275	975125	0	0
45621732	40163554	2	3
45647822	1107882	2	3
45626347	723013	0	0
45625211	1125315	0	0
45639634	1551192	2	3
45781728	1308738	0	0
45683857	1119510	0	0
45669045	1107830	0	0
45702327	1501700	0	0
45705538	1177480	0	0
45779963	1000560	0	0
45896849	19078461	2	3
46292094	1129625	0	0
45803293	1177480	0	0
46294064	1112807	0	0
45893897	19003953	0	0
45791601	1124300	0	0
46301018	1125315	0	0
46300050	46275916	1	1
4040390	4337611	4	7
1124957	40231925	2	3
21500575	19059056	3	4
21604795	45892894	2	3
36153619	1125315	0	0
36159049	1115171	2	3
36313966	4084167	3	6
36463291	975125	0	0
44359068	1549786	0	0
44357400	1729720	0	0
43530807	4048169	3	3
45633826	1115171	2	3
45665284	975125	0	0
45664836	19008572	2	3
45654255	1107882	2	3
45626261	1728416	0	0
45625178	1125315	0	0
45639919	19133768	2	3
45781730	1149196	0	0
45683863	1119510	0	0
45669056	1539403	0	0
45702561	1332418	0	0
45705955	1177480	0	0
45779988	1501700	0	0
45797412	19078461	2	3
46292299	1129625	0	0
45803349	1177480	0	0
46294123	1112807	0	0
45893809	1549786	0	0
45791597	1500211	0	0
46301127	1125315	0	0
46318333	46275916	1	1
4040390	4108705	4	7
753626	40220386	2	3
21500140	1519937	3	4
21604799	45892894	2	3
36153620	1119510	0	0
36159054	43012036	2	3
36313966	80809	3	7
36463200	1738521	0	0
44359253	738818	0	0
44357327	1545958	0	0
43530807	4139681	3	3
45631426	19073183	2	3
45664959	975125	0	0
45664896	40232448	2	3
45642346	40228214	2	3
45626343	1738521	0	0
45625180	1125315	0	0
45639670	1107882	2	3
45781537	1343916	0	0
45683889	1119510	0	0
45669091	1501700	0	0
45702355	1545958	0	0
45705728	1177480	0	0
45780167	1115008	0	0
45794637	1539411	2	3
46292326	1129625	0	0
45803475	1177480	0	0
46294219	1112807	0	0
45893809	1515774	0	0
45791554	738818	0	0
46319195	1125315	0	0
46303090	1115171	2	3
4040390	4216130	4	7
742185	19123231	2	3
21500138	40224132	3	4
21602860	46275444	2	3
36153847	1125315	0	0
36159418	1127433	2	3
36313966	196456	3	9
36463216	1125315	0	0
44359257	1149380	0	0
44357324	1153428	0	0
43530807	4304110	3	3
45631395	19019273	2	3
45662166	975125	0	0
45665081	40174880	2	3
45657678	1107882	2	3
45626394	1149196	0	0
45625182	1125315	0	0
45639843	1127433	2	3
45781539	1501700	0	0
45683890	1119510	0	0
45669026	1310149	0	0
45702268	1153428	0	0
45706006	1177480	0	0
45779682	1332418	0	0
45679441	40223768	2	3
46292451	1129625	0	0
45800902	1177480	0	0
46294448	1112807	0	0
45893843	1115008	0	0
45791656	1110410	0	0
46319219	1125315	0	0
46303311	1115171	2	3
4040390	4323902	4	7
1326303	19018935	2	3
21500138	40224805	3	4
21003263	40236824	2	3
36154200	1112807	0	0
36159545	40236824	2	3
36313966	134438	3	8
36463297	1332418	0	0
37100000	4056621	6	7
44357464	975125	0	0
43531053	45769019	3	3
45631500	19059056	2	3
45662509	975125	0	0
45664940	40223834	2	3
45626977	1545959	2	3
45626328	1124957	0	0
45625245	1125315	0	0
45639892	1115171	2	3
45781737	1713332	0	0
45683897	1119510	0	0
45669051	1713332	0	0
45702270	1174888	0	0
45703694	1177480	0	0
45780060	1501700	0	0
45697166	40223768	2	3
46292394	1129625	0	0
45800677	1177480	0	0
46243852	1112807	0	0
45893904	715997	0	0
45791697	1124957	0	0
46319097	1125315	0	0
46303437	46233710	2	3
4040390	4238715	4	5
1741122	46275444	2	3
21500578	1127078	3	4
21604152	40173590	2	3
36154157	1118084	0	0
36159597	40162522	2	3
36313966	192671	2	7
36463337	1545958	0	0
42802224	19128009	2	2
44357467	1124300	0	0
43531052	196456	4	4
45631610	19073183	2	3
45662318	975125	0	0
45665226	1107882	2	3
45628073	40228214	2	3
45626330	1738521	0	0
45625248	1125315	0	0
45639827	40236446	2	3
45781545	1174888	0	0
45683933	1119510	0	0
45669051	1759842	0	0
45702390	920293	0	0
45703615	1177480	0	0
45779899	1539403	0	0
45700468	19078461	2	3
46292607	1129625	0	0
45798184	1177480	0	0
46243857	1112807	0	0
45893831	1115008	0	0
45791698	1741122	0	0
46319285	1125315	0	0
46303115	40162522	2	3
4040390	44805732	4	5
933724	40236824	2	3
21012458	836654	0	0
21503925	19019273	2	3
36153848	1129625	0	0
36203042	40480160	2	3
36302170	4163872	4	7
36463252	1115008	0	0
42802224	19127918	2	2
44357471	723013	0	0
43531052	4266809	4	4
45628570	40232448	2	3
45662677	975125	0	0
45664954	1127433	2	3
45639339	1107882	2	3
45626333	1115008	0	0
45625201	1125315	0	0
45640122	19073183	2	3
45781546	738818	0	0
45683971	1119510	0	0
45669053	1549786	0	0
45702299	1548195	0	0
45702307	1177480	0	0
45780127	782043	0	0
45679365	19078461	2	3
46287942	1129625	0	0
45798278	1177480	0	0
46244731	1112807	0	0
45801715	1154343	0	0
45791698	1746114	0	0
46319065	1125315	0	0
46303377	1115171	2	3
4040390	4202451	4	5
3050951	3019550	2	3
21506167	1177480	0	0
21005779	1551192	2	3
36153856	1112807	0	0
36151279	46275444	2	3
36302170	4163951	4	4
36463329	1545958	0	0
40490903	4199276	2	2
44353630	1112807	0	0
43530815	4152936	3	5
45628539	40232448	2	3
45662735	975125	0	0
45665197	1127433	2	3
45657576	1107882	2	3
45626461	753626	0	0
45625144	1125315	0	0
45685697	19008572	2	3
45781837	1115008	0	0
45683978	1119510	0	0
45669074	1521369	0	0
45702302	1149380	0	0
45702376	1177480	0	0
45779779	1174888	0	0
45786666	19078461	2	3
46287985	1129625	0	0
45798423	1177480	0	0
46244787	1112807	0	0
45801687	1738521	0	0
45791511	1107830	0	0
46319076	1125315	0	0
45801237	40229134	2	3
4040390	4330583	4	8
3050951	3023103	2	3
21506125	740275	0	0
21500363	1154615	2	3
36153868	1125315	0	0
36152284	40229134	2	3
36302170	4202451	5	8
36463307	1125315	0	0
40490903	4059978	2	2
44353633	1149380	0	0
43530815	4059173	3	5
45628351	1551192	2	3
45662921	975125	0	0
45665145	19133905	2	3
45629620	1107882	2	3
45626464	1149196	0	0
45625215	1125315	0	0
45685829	40229134	2	3
45781844	914335	0	0
45683962	1119510	0	0
45669074	19127890	0	0
45702359	1110410	0	0
45699386	1177480	0	0
45780076	1545958	0	0
45784880	40223768	2	3
46288115	1129625	0	0
45798315	1177480	0	0
46244823	1112807	0	0
45801736	1153428	0	0
45791614	920293	0	0
46319115	1125315	0	0
45801231	1539411	2	3
4040390	4301346	4	8
3050951	3014576	2	3
21506147	1119510	0	0
21500002	19133905	2	3
36153871	1112807	0	0
36152288	19125062	2	3
36302170	4043241	5	14
36463331	1545958	0	0
42807353	19128009	2	2
44354052	723013	0	0
43530815	4146173	3	5
45628540	43012036	2	3
45662421	975125	0	0
45665285	1551192	2	3
45668022	40223768	2	3
45626237	1149196	0	0
45625230	1125315	0	0
45685807	40236446	2	3
45781295	1153428	0	0
45684008	1119510	0	0
45669074	1549786	0	0
45702426	1307863	0	0
45699473	1177480	0	0
45780161	1738521	0	0
46242664	19078461	2	3
46243147	1129625	0	0
45795494	1177480	0	0
46243975	1112807	0	0
45801767	1115008	0	0
45791785	1548195	0	0
46318965	1125315	0	0
45801339	19008572	2	3
4040390	4198190	7	9
3051542	3019550	2	3
21506187	967823	0	0
21500002	19133873	2	3
36153872	1589505	0	0
36151398	40229134	2	3
36302170	4246502	5	5
36463127	1332418	0	0
42805822	19128263	2	2
44353833	1177480	0	0
43530815	4142905	3	5
45628472	1115171	2	3
45661363	975125	0	0
45665347	19057271	2	3
45657490	1107882	2	3
45626299	967823	0	0
45624137	1125315	0	0
45685826	40232448	2	3
45781297	1549786	0	0
45684018	1119510	0	0
45669100	1124957	0	0
45702411	1332418	0	0
45699470	1177480	0	0
45780185	1118084	0	0
46240370	19078461	2	3
46242905	1129625	0	0
45795603	1177480	0	0
46238904	1112807	0	0
45801883	1000560	0	0
45791785	1521369	0	0
46319128	1125315	0	0
45795710	1154615	2	3
4040390	4163971	7	7
3051542	3023103	2	3
21506156	1115008	0	0
21002094	19129655	2	3
36153873	1129625	0	0
36157102	1129625	0	0
36302170	4133840	5	5
36463144	1501700	0	0
42805822	19128022	2	2
44353926	1124300	0	0
43530815	4278672	3	5
45628357	1551192	2	3
45659331	975125	0	0
45662166	19008572	2	3
45659106	1545959	2	3
45626381	738818	0	0
45624158	1125315	0	0
45685941	19133768	2	3
45781297	19127890	0	0
45680457	1119510	0	0
45669103	1367571	0	0
45702494	1501700	0	0
45699600	1177480	0	0
45780191	1107830	0	0
45685426	19078461	2	3
46242913	1129625	0	0
45795653	1177480	0	0
46239010	1112807	0	0
45801884	1107830	0	0
45791820	1595799	0	0
46319377	1125315	0	0
45795766	19133905	2	3
4040390	4107731	7	7
3051542	3014576	2	3
21502881	1305058	0	0
21505734	19079524	2	3
36154048	1129625	0	0
36157102	1125315	0	0
36302170	4151422	5	5
36463232	1119510	0	0
42805741	920334	2	3
44353931	1124300	0	0
43530815	78272	3	7
45625169	40232448	2	3
45659385	975125	0	0
45662284	35605482	2	3
45639122	40173590	2	3
45626244	1149196	0	0
45624356	1125315	0	0
45685882	1107882	2	3
45781677	975125	0	0
45680574	1119510	0	0
45669104	967823	0	0
45702441	1501700	0	0
45696023	1177480	0	0
45780194	933724	0	0
46244854	40223768	2	3
46243182	1129625	0	0
45795598	1177480	0	0
46239019	1112807	0	0
45801820	791967	0	0
45791820	1521369	0	0
46319146	1125315	0	0
45795841	40229134	2	3
4040390	4275113	7	7
1518198	44816277	2	3
21502889	967823	0	0
21003153	19019273	2	3
36154057	975125	0	0
36157102	1119510	0	0
36302170	4134304	10	14
36463232	738818	0	0
42805695	40169281	2	3
44353932	701322	0	0
43530815	4218389	3	3
45625301	40232448	2	3
45659393	975125	0	0
45662314	19018935	2	3
45635757	1107882	2	3
45626247	740275	0	0
45624183	1125315	0	0
45686080	1332419	2	3
45781685	1367571	0	0
45680579	1119510	0	0
45669130	1713332	0	0
45702502	975125	0	0
45696282	1177480	0	0
45780175	1174888	0	0
45794846	19078461	2	3
46242998	1129625	0	0
45795602	1177480	0	0
46239020	1112807	0	0
45801824	1551099	0	0
45791820	1549786	0	0
46319150	1125315	0	0
45795915	1551192	2	3
4040390	4218408	3	3
1150770	1150771	2	3
21503138	1112807	0	0
21003110	42707627	2	3
36154062	1125315	0	0
36156878	1110410	0	0
36302170	40479422	10	13
36463232	1125315	0	0
42805830	40224805	2	3
44354029	1124300	0	0
43530815	4296204	3	3
45625378	40229134	2	3
45659578	975125	0	0
45662410	19078461	2	3
45648233	1332419	2	3
45622793	1124300	0	0
45624190	1125315	0	0
45686201	40223834	2	3
45781689	1174888	0	0
45680863	1119510	0	0
45669245	705944	0	0
45702518	1332418	0	0
45696172	1177480	0	0
45780176	1107830	0	0
45783151	19078461	2	3
46243009	1129625	0	0
45797238	1177480	0	0
46239143	1112807	0	0
45801830	1192710	0	0
45791675	1124300	0	0
46319153	1125315	0	0
45795809	19018935	2	3
4040390	4163951	3	3
1150836	1150837	2	3
21503089	914335	0	0
21500286	40232448	2	3
36154062	1119510	0	0
36156881	1501700	0	0
36302170	133834	10	12
36463234	1118084	0	0
42805713	40163554	2	3
44354030	738818	0	0
43530815	4113008	3	3
45625272	19133768	2	3
45656231	975125	0	0
45662921	19008572	2	3
45657659	1332419	2	3
45623131	1545958	0	0
45624234	1125315	0	0
45637226	40228214	2	3
45781691	1367571	0	0
45677276	1119510	0	0
45669122	1107830	0	0
45702521	1717327	0	0
45693141	1177480	0	0
45780177	19127890	0	0
45700169	19078461	2	3
46243013	1129625	0	0
45795713	1177480	0	0
46239144	1112807	0	0
45801641	1539403	0	0
45791659	1115008	0	0
46295535	1125315	0	0
45795872	40228230	2	3
4040390	4295880	3	4
1153428	40223821	2	3
21502874	967823	0	0
21003108	42707627	2	3
36154062	738818	0	0
36156906	1717327	0	0
36302170	4024958	6	7
36463361	1107830	0	0
42805905	43012433	2	3
44354055	1107830	0	0
43530815	4155034	3	3
45625471	1127433	2	3
45656370	975125	0	0
45662775	19133873	2	3
45623686	1107882	2	3
45623144	1589505	0	0
45624236	1125315	0	0
45637234	19019273	2	3
45781517	1305058	0	0
45677390	1119510	0	0
45669189	1115008	0	0
45702599	967823	0	0
45693271	1177480	0	0
45780177	1549786	0	0
45681046	19078461	2	3
46243061	1129625	0	0
45793032	1177480	0	0
45894728	1112807	0	0
45801810	1309944	0	0
45791670	1343916	0	0
46295193	1125315	0	0
45790459	1115171	2	3
4040390	4059978	3	4
442983	4048171	4	4
21503154	967823	0	0
21005679	19073188	2	3
36154064	1112807	0	0
36157036	1713332	0	0
36302170	4027663	6	10
36463080	1738521	0	0
42805911	1551192	2	3
44354063	1521369	0	0
43530815	4109685	3	4
45625689	19078924	2	3
45656160	975125	0	0
45662421	19008572	2	3
45652196	40228214	2	3
45623144	1549786	0	0
45624208	1125315	0	0
45636740	40232448	2	3
45781529	738818	0	0
45677427	1119510	0	0
45669305	1778162	0	0
45699391	1174888	0	0
45693292	1177480	0	0
45780183	1557272	0	0
45681139	19078461	2	3
46243128	1129625	0	0
45792837	1177480	0	0
45893582	1112807	0	0
45801793	967823	0	0
45791671	1174888	0	0
46295537	1125315	0	0
45790644	1115171	2	3
4040390	4010253	3	5
432661	4048171	4	4
21503156	967823	0	0
21003056	40232448	2	3
36154065	1112807	0	0
36157036	1759842	0	0
36302170	44782520	6	9
36463083	705944	0	0
42805922	19133905	2	3
44354063	1549786	0	0
43530815	4132546	3	4
45625691	1551192	2	3
45656677	975125	0	0
45662965	40228214	2	3
45626985	1332419	2	3
45623148	738818	0	0
45624278	1125315	0	0
45636821	19057271	2	3
45781534	1309944	0	0
45677498	1119510	0	0
45669191	1539403	0	0
45699296	914335	0	0
45694831	1177480	0	0
45780085	920293	0	0
45681256	19078461	2	3
46240914	1129625	0	0
45793358	1177480	0	0
45801702	1112807	0	0
45801795	1115008	0	0
45791736	701322	0	0
46295551	1125315	0	0
45790576	40229134	2	3
4040390	4337138	3	6
442628	40479422	4	4
21502750	1551099	0	0
21002587	19075001	2	3
36154065	1192710	0	0
36157061	1501700	0	0
36302170	4237458	6	12
36463274	1129625	0	0
42805922	19133873	2	3
44354033	1124957	0	0
43530815	40480160	5	5
45625658	40224805	2	3
45652905	975125	0	0
45662728	40232448	2	3
45665664	1107882	2	3
45622991	1551099	0	0
45624229	1125315	0	0
45682977	40229134	2	3
45781663	715997	0	0
45677700	1119510	0	0
45669237	1107830	0	0
45699297	975125	0	0
45690301	1177480	0	0
45780089	1192710	0	0
45786720	19078461	2	3
46240998	1129625	0	0
45793053	1177480	0	0
45796140	1112807	0	0
45801813	1309944	0	0
45791741	1174888	0	0
46295439	1125315	0	0
45790448	40229134	2	3
4040390	4035793	2	2
442628	40479768	4	4
21502750	975125	0	0
21003076	40229134	2	3
36154067	1112807	0	0
36157062	1115008	0	0
36302170	4066995	6	12
36463282	1115008	0	0
42806883	40236824	2	3
44353758	1149380	0	0
43530815	40479768	5	6
45625752	19008572	2	3
45653017	975125	0	0
45662830	40223768	2	3
45651101	19078461	2	3
45623153	1124957	0	0
45668348	1125315	0	0
45682979	19019273	2	3
45781669	1149196	0	0
45677779	1119510	0	0
45669311	1115008	0	0
45699323	738818	0	0
45690484	1177480	0	0
45780002	723013	0	0
45676022	19078461	2	3
46241000	1129625	0	0
45793188	1177480	0	0
45796255	1112807	0	0
45801854	1115008	0	0
45791792	1149196	0	0
46295308	1125315	0	0
45790701	40229134	2	3
4042140	4134304	7	11
374009	4043241	4	4
21503094	933724	0	0
21503953	19078924	2	3
36154067	1192710	0	0
36157201	1129625	0	0
36302170	321042	8	12
36463287	1332418	0	0
42807063	1551192	2	3
44354035	19127890	0	0
43530815	375671	5	6
45625843	1115171	2	3
45653304	975125	0	0
45661363	19008572	2	3
45633040	19078461	2	3
45623177	1713332	0	0
45668261	1125315	0	0
45682985	19008572	2	3
45781772	1367571	0	0
45676260	1119510	0	0
45669196	1521369	0	0
45699299	914335	0	0
45690328	1177480	0	0
45780098	1326303	0	0
45673126	19078461	2	3
46240888	1129625	0	0
45791917	1177480	0	0
45796197	1112807	0	0
45801855	791967	0	0
45791794	1174888	0	0
46295243	1125315	0	0
45790558	1115171	2	3
4042140	4230399	7	10
4000731	4337611	4	4
21503209	975125	0	0
21003040	19078924	2	3
36154069	1112807	0	0
36156637	1177480	0	0
36302170	4048695	8	12
36463190	1500211	0	0
42807004	35605482	2	3
44354035	1521369	0	0
43530815	40479422	5	6
45622120	19018935	2	3
45653305	975125	0	0
45661203	46275444	2	3
45638671	19075601	2	3
45623177	1759842	0	0
45668365	1125315	0	0
45682987	1545959	2	3
45781775	1308738	0	0
45674481	1119510	0	0
45669196	1595799	0	0
45699585	1332418	0	0
45690604	1177480	0	0
45780107	19010482	0	0
45675921	19078461	2	3
46240749	1129625	0	0
45790272	1177480	0	0
45796207	1112807	0	0
45801876	1174888	0	0
45791797	1713332	0	0
46295245	1125315	0	0
45790838	1551192	2	3
4042140	4144583	7	7
440029	40481087	4	4
21503162	1192710	0	0
21005678	19073183	2	3
36154069	1192710	0	0
36156720	1149196	0	0
36302170	4266809	8	11
36463192	1112807	0	0
42805465	1594382	2	3
44354035	1549786	0	0
43530815	378001	5	6
45622124	40162522	2	3
45653208	975125	0	0
45661289	19073183	2	3
45627061	40228214	2	3
45623180	1589505	0	0
45668370	1125315	0	0
45682829	40232448	2	3
45781801	1174888	0	0
45674471	1119510	0	0
45669196	1549786	0	0
45699690	1539403	0	0
45690589	1177480	0	0
45780116	1310149	0	0
46240618	19078461	2	3
46240897	1129625	0	0
45787312	1177480	0	0
45796263	1112807	0	0
45801877	723013	0	0
45791805	1115008	0	0
46295351	1125315	0	0
45790957	19008572	2	3
4042140	4155034	6	7
440921	4113008	4	4
21503162	738818	0	0
21005678	19073188	2	3
36154075	975125	0	0
36157233	1177480	0	0
36302170	255848	8	11
36463332	1177480	0	0
42804566	920334	2	3
44354039	975125	0	0
43530815	4230399	4	6
45622124	19133768	2	3
45653459	975125	0	0
45659331	19008572	2	3
45644539	40228214	2	3
45623180	1549786	0	0
45668373	1125315	0	0
45682885	40223834	2	3
45781780	967823	0	0
45674472	1119510	0	0
45669294	1717327	0	0
45699342	1192710	0	0
45687367	1177480	0	0
45780122	1367571	0	0
45694531	19078461	2	3
46240836	1129625	0	0
45787719	1177480	0	0
45796265	1112807	0	0
45802413	1501700	0	0
45791582	975125	0	0
46295637	1125315	0	0
45790812	1519937	2	3
4042140	4109685	6	8
440921	4155034	4	4
21500583	1174888	0	0
21505795	19075601	2	3
36154077	1177480	0	0
35506909	1177480	0	0
36302170	28060	8	11
36463334	1177480	0	0
42802009	40231925	2	3
44354199	1713332	0	0
43530815	81151	4	6
45622139	40232448	2	3
45649767	975125	0	0
45659382	40174880	2	3
45632849	19075601	2	3
45623180	19127890	0	0
45668404	1125315	0	0
45633683	19008572	2	3
45781807	1110410	0	0
45674436	1119510	0	0
45669266	1307863	0	0
45699371	1778162	0	0
45687570	1177480	0	0
45780134	1713332	0	0
46242839	19078461	2	3
45696476	40174880	2	3
45787520	1177480	0	0
45796180	1112807	0	0
45802417	975125	0	0
45791583	1738521	0	0
46244325	1125315	0	0
45790899	19075601	2	3
4042140	81893	6	12
440921	4218389	4	4
21500599	1305058	0	0
21003205	19112599	2	3
36154078	933724	0	0
35506909	1129625	0	0
36302170	198199	8	11
36427424	1125315	0	0
42801830	1154615	2	3
44354225	1112807	0	0
43530815	4156265	4	4
45622164	40229134	2	3
45646880	975125	0	0
45659438	1127433	2	3
45648287	19075601	2	3
45622887	1124957	0	0
45668451	1125315	0	0
45633470	1545959	2	3
45783497	1343916	0	0
45674525	1119510	0	0
45669278	1115008	0	0
45699439	740275	0	0
45687279	1177480	0	0
45780154	705944	0	0
45673063	19078461	2	3
45792495	40228214	2	3
45789039	1177480	0	0
45790739	1112807	0	0
45802525	1110410	0	0
45791648	1548195	0	0
46244334	1125315	0	0
45790687	40162522	2	3
4042140	313217	6	11
444187	4152936	4	4
21500613	1343916	0	0
21002836	1125315	0	0
36154087	1112807	0	0
35506912	1149196	0	0
36302170	40486433	8	13
36424953	1149380	0	0
42802236	40162522	2	3
44354015	1177480	0	0
43530815	4134304	4	7
45625098	40223834	2	3
45646935	975125	0	0
45659393	19008572	2	3
45650995	19075601	2	3
45622890	1551099	0	0
45668422	1125315	0	0
45633733	40232448	2	3
45783512	1549786	0	0
45671608	1119510	0	0
45669379	738818	0	0
45699584	1107830	0	0
45684297	1177480	0	0
45780153	920293	0	0
45797317	1539411	2	3
45802672	19079524	2	3
45789280	1177480	0	0
45791890	1112807	0	0
45802320	1124300	0	0
45791752	1551099	0	0
46244446	1125315	0	0
45790717	19008572	2	3
4042140	4166224	6	10
375415	378001	4	4
21500606	1124300	0	0
21002846	1115008	0	0
36154108	1174888	0	0
35507013	791967	0	0
36302170	440448	8	13
36422283	1347450	0	0
42807125	40231925	2	3
44354257	1110410	0	0
43530815	4066995	4	5
45622287	19008572	2	3
45646969	975125	0	0
45659504	40232448	2	3
45639364	40173590	2	3
45622992	1500211	0	0
45668692	1125315	0	0
45633769	19008572	2	3
45783512	19127890	0	0
45671599	1119510	0	0
45669316	1000560	0	0
45699384	705944	0	0
45685610	1177480	0	0
45779872	1192710	0	0
46240492	1332419	2	3
46242909	19078461	2	3
45787907	1177480	0	0
45792007	1112807	0	0
45802600	1551099	0	0
45791775	1124300	0	0
46244583	1125315	0	0
46297637	46275916	2	3
4042140	258780	6	10
375415	375671	4	4
21500607	1125315	0	0
21002836	1112807	0	0
36154108	1125315	0	0
35507014	1119510	0	0
36302170	258780	8	13
36422228	1557272	0	0
42807128	19018935	2	3
44354155	791967	0	0
43530815	4048695	4	5
45622309	1154615	2	3
45647198	975125	0	0
45659357	19018935	2	3
45656953	19078461	2	3
45622906	967823	0	0
45668458	1125315	0	0
45633877	1551192	2	3
45783596	738818	0	0
45671569	1119510	0	0
45669318	1332418	0	0
45699436	1192710	0	0
45684390	1177480	0	0
45779873	975125	0	0
45785207	1332419	2	3
45797555	40223768	2	3
45787900	1177480	0	0
46294636	1112807	0	0
45798963	967823	0	0
45791777	1343916	0	0
46244514	1125315	0	0
46297239	19008572	2	3
4042140	4059173	6	9
4000740	4057420	4	4
21500616	1343916	0	0
21002822	1115008	0	0
36154110	1125315	0	0
35507024	1119510	0	0
36302170	4302207	8	9
36422111	1112807	0	0
42807135	19023398	2	3
44354018	1124300	0	0
43530815	4237458	4	5
45622597	1115171	2	3
45643892	975125	0	0
45659545	42707627	2	3
45635594	19078461	2	3
45623189	1717327	0	0
45668452	1125315	0	0
45633905	43012036	2	3
45783601	1107830	0	0
45671575	1119510	0	0
45669144	1124957	0	0
45699534	975125	0	0
45684578	1177480	0	0
45779972	1174888	0	0
45777813	1545959	2	3
45795235	19078461	2	3
45786095	1177480	0	0
46294909	1112807	0	0
45799074	1124300	0	0
45791781	782043	0	0
46244337	1125315	0	0
46297349	40232448	2	3
4042140	4152936	6	9
4003043	4275113	4	4
21500176	1557272	0	0
21002827	975125	0	0
36154111	1129625	0	0
35507028	1177480	0	0
36302170	441267	8	9
36463335	1115008	0	0
42807238	19133905	2	3
44353987	1307863	0	0
43530815	4001336	4	5
45622600	1127433	2	3
45644135	975125	0	0
45659546	19123231	2	3
45658434	19078461	2	3
45622891	1115008	0	0
45668492	1125315	0	0
45630745	19078461	2	3
45783614	1589505	0	0
45671542	1119510	0	0
45669466	1107830	0	0
45699535	975125	0	0
45681427	1177480	0	0
45779978	1000560	0	0
45675852	40174880	2	3
45802847	19078461	2	3
46296887	1177480	0	0
46294937	1112807	0	0
45799088	1124957	0	0
45788950	1713332	0	0
46244313	1125315	0	0
46297449	40236824	2	3
4180628	4146173	4	6
134057	4310024	4	4
21500203	1326303	0	0
21002827	1124300	0	0
36154118	1112807	0	0
35506977	1307863	0	0
36302170	4139681	8	9
36463429	1107830	0	0
42808536	40229134	2	3
44354020	715997	0	0
43530877	4296204	4	4
45622444	1127433	2	3
45642928	975125	0	0
45659509	40162522	2	3
45651888	19078461	2	3
45622894	1738521	0	0
45668501	1125315	0	0
45630714	19078461	2	3
45783682	740275	0	0
45673015	1119510	0	0
45669326	1149196	0	0
45699536	738818	0	0
45681656	1177480	0	0
45780032	1115008	0	0
45697419	1539411	2	3
46292144	19078461	2	3
46297097	1177480	0	0
46244063	1112807	0	0
45799091	705944	0	0
45788984	1539403	0	0
46244562	1125315	0	0
46297846	43012036	2	3
4180628	4132546	4	6
372887	4001336	4	4
21500166	1501700	0	0
21002846	975125	0	0
36156282	1000560	0	0
35507090	914335	0	0
36302170	442116	8	9
36463446	1125315	0	0
42804694	40236824	2	3
44353902	1307863	0	0
43530877	4113008	4	4
45622493	1115171	2	3
45637822	975125	0	0
45659464	40232448	2	3
45633021	40228214	2	3
45623030	1501700	0	0
45668521	1125315	0	0
45630840	19133873	2	3
45781850	975125	0	0
45673035	1119510	0	0
45666721	715997	0	0
45699440	1307863	0	0
45681512	1177480	0	0
45780042	1124957	0	0
45802631	1545959	2	3
45794980	19078461	2	3
46293377	1177480	0	0
46244162	1112807	0	0
45799097	1107830	0	0
45789046	19127890	0	0
46244526	1125315	0	0
46297958	19008572	2	3
4180628	198809	4	6
4000738	4163971	4	4
21003406	19010482	0	0
21002846	1124300	0	0
36156240	920293	0	0
35506982	1129625	0	0
36302170	78272	8	14
36463446	1119510	0	0
42804666	19073183	2	3
44354004	1149196	0	0
43530877	4155034	4	4
45620730	19059056	2	3
45638329	975125	0	0
45659582	1551192	2	3
45632496	19078461	2	3
45623031	933724	0	0
45668782	1125315	0	0
45630843	1115171	2	3
45778816	967823	0	0
45673372	1119510	0	0
45666789	1307863	0	0
45699563	1124300	0	0
45681623	1177480	0	0
45780045	1153428	0	0
45778220	1539411	2	3
45895110	19078461	2	3
46293488	1177480	0	0
46239456	1112807	0	0
45799140	1153428	0	0
45789046	1549786	0	0
46244298	1125315	0	0
46297908	40232448	2	3
4180628	4266809	4	6
133468	4278672	4	4
21003405	19010482	0	0
21002844	975125	0	0
36156400	975125	0	0
35507064	1177480	0	0
36302170	4174876	7	8
36463446	1129625	0	0
42804652	35605482	2	3
44354021	1738521	0	0
43530877	4218389	4	4
45620837	40232448	2	3
45637122	975125	0	0
45659541	1332419	2	3
45654181	40228214	2	3
45622897	1512674	0	0
45668789	1125315	0	0
45630856	40232448	2	3
45779232	738818	0	0
45673101	1119510	0	0
45666753	1174888	0	0
45699449	1332418	0	0
45679750	1177480	0	0
45780048	967823	0	0
45792103	1539411	2	3
46292163	19078461	2	3
46296593	1177480	0	0
46239551	1112807	0	0
45799159	740275	0	0
45789048	1174888	0	0
46244322	1125315	0	0
46297923	40162522	2	3
4180628	4283893	4	5
133468	4113008	4	4
21003421	1738521	0	0
21002844	1124300	0	0
36156355	1154343	0	0
35507067	1343916	0	0
36302170	372328	7	10
36463443	705944	0	0
42804655	40243436	2	3
44354109	1521369	0	0
43530877	4109685	4	5
45620771	1115171	2	3
44361834	1192710	0	0
45659472	1551192	2	3
45642179	40228214	2	3
45622897	1549786	0	0
45668790	1125315	0	0
45630991	19078924	2	3
45779237	738818	0	0
45671669	1119510	0	0
45666884	791967	0	0
45699635	1192710	0	0
45679783	1177480	0	0
45780049	1713332	0	0
46240499	1539411	2	3
45795131	19078461	2	3
46288475	1177480	0	0
46239677	1112807	0	0
45799249	1192710	0	0
45788963	723013	0	0
46244323	1125315	0	0
46297994	19125062	2	3
4180628	381316	4	5
133468	4155034	4	4
21003410	1551099	0	0
21002852	1728416	0	0
36156356	920293	0	0
35507069	1119510	0	0
36302170	4155034	7	10
36463418	738818	0	0
42804657	1594382	2	3
44353851	1501700	0	0
43530877	4059173	4	6
45621229	40223834	2	3
44361851	1192710	0	0
45656231	19008572	2	3
45635745	19079524	2	3
45622994	723013	0	0
45665857	1125315	0	0
45630809	19008572	2	3
45779238	738818	0	0
45669950	1119510	0	0
45666806	1110410	0	0
45699553	1501700	0	0
45678167	1177480	0	0
45706914	1551099	0	0
45876037	3013682	2	5
46243078	19078461	2	3
46288827	1177480	0	0
46239649	1112807	0	0
45799252	1713332	0	0
45788965	1124957	0	0
46244569	1125315	0	0
46289301	40162522	2	3
4180628	4056621	4	5
376337	380378	4	4
21003410	975125	0	0
21002493	1521369	0	0
36156465	1305058	0	0
35507075	1545958	0	0
36302170	381316	7	10
36463418	1119510	0	0
42804658	46275916	2	3
44354117	1115008	0	0
43530877	4001336	4	6
45621229	40223821	2	3
44361919	1192710	0	0
45656370	19008572	2	3
45654327	40228214	2	3
45623090	738818	0	0
45665987	1125315	0	0
45631001	1115171	2	3
45779358	705944	0	0
45670157	1119510	0	0
45666939	1118084	0	0
45699638	1174888	0	0
45678100	1177480	0	0
45706931	791967	0	0
45876037	3023103	2	6
46243207	19078461	2	3
46288967	1177480	0	0
46239726	1112807	0	0
45799166	1124300	0	0
45789006	738818	0	0
46244388	1125315	0	0
46289148	19018935	2	3
4180628	80809	4	4
376208	317576	4	4
21004035	708298	0	0
21002493	1589505	0	0
36156306	1149380	0	0
35507211	975125	0	0
36302170	4056621	7	11
36463418	1125315	0	0
42804875	40162522	2	3
44354091	1322184	0	0
43530877	4278672	4	6
45621183	19059056	2	3
44362295	1192710	0	0
45656259	1545959	2	3
45644806	40228214	2	3
45623198	1713332	0	0
45666102	1125315	0	0
45630976	19073183	2	3
45779359	914335	0	0
45670168	1119510	0	0
45666839	1110410	0	0
45699570	1738521	0	0
45678517	1177480	0	0
45707019	1192710	0	0
45876037	3016723	2	5
45789888	40223768	2	3
46288964	1177480	0	0
46239611	1112807	0	0
45799257	1539403	0	0
45789040	1545958	0	0
46244586	1125315	0	0
46289325	40163554	2	3
4180628	441267	4	4
376208	4280726	4	4
21003446	1595799	0	0
21002508	1549786	0	0
36156311	1129625	0	0
35507212	1115008	0	0
36302170	195588	7	12
36463393	705944	0	0
42804843	1154615	2	3
44354092	1112807	0	0
43530877	4142905	4	6
45621186	1115171	2	3
45655842	1192710	0	0
45656463	40232448	2	3
45647857	1539411	2	3
45623001	1153428	0	0
45666335	1125315	0	0
45628258	19078461	2	3
45779365	1551099	0	0
45670013	1119510	0	0
45666962	708298	0	0
45699402	1367571	0	0
45678779	1177480	0	0
45707022	705944	0	0
45783005	19128263	1	2
45789563	1332419	2	3
46289094	1177480	0	0
45896134	1112807	0	0
45799115	1521369	0	0
45789057	1174888	0	0
46244591	1125315	0	0
46289786	19008572	2	3
4180628	321042	4	4
376208	40486433	4	4
21003446	1308738	0	0
21002491	1124300	0	0
36156312	1129625	0	0
35507213	738818	0	0
36302170	261325	7	12
36463454	1717327	0	0
42805134	19078461	2	3
44354234	1115008	0	0
43530877	4146173	4	6
45621215	19059056	2	3
45655911	1192710	0	0
45658376	19075001	2	3
45666166	40228214	2	3
45623007	1738521	0	0
45666347	1125315	0	0
45628233	40232448	2	3
45779369	740275	0	0
45669989	1119510	0	0
45667030	933724	0	0
45699645	1115008	0	0
45675271	1177480	0	0
45707026	975125	0	0
45797383	19129144	1	2
45800510	19078461	2	3
46243589	1177480	0	0
45896145	1112807	0	0
45799252	1759842	0	0
45789041	1738521	0	0
46244596	1125315	0	0
46289555	46275916	2	3
4180628	4029498	4	4
376208	134438	4	4
21003452	1595799	0	0
21002491	1177480	0	0
36156312	1125315	0	0
35507213	1125315	0	0
36302170	260139	7	12
36463424	1307863	0	0
42803247	19133905	2	3
44354096	1149196	0	0
43530877	4152936	4	6
45621015	40232448	2	3
45655959	1192710	0	0
45658417	40165015	2	3
45636350	19078461	2	3
45623016	1332418	0	0
45667264	1125315	0	0
45627955	40232448	2	3
45779121	1332418	0	0
45783735	1119510	0	0
45666813	967823	0	0
45699471	1107830	0	0
45675226	1177480	0	0
45707028	1174888	0	0
45797383	19127922	1	2
45802662	19078461	2	3
46243529	1177480	0	0
45896838	1112807	0	0
45799242	1124957	0	0
45789042	1548195	0	0
46244535	1125315	0	0
46289594	19008572	2	3
4180628	4035415	4	4
4094284	81151	3	6
21003452	1308738	0	0
21002493	1548195	0	0
36156441	1125315	0	0
35507213	1119510	0	0
36302170	4329847	7	13
36469904	1153428	0	0
42802386	40224805	2	3
44354207	1177480	0	0
43530877	78272	4	8
45664682	1115171	2	3
45656310	1192710	0	0
45658447	40162522	2	3
45641870	19079524	2	3
45623019	738818	0	0
45667371	1125315	0	0
45627958	1713671	2	3
45779040	1501700	0	0
45783768	1119510	0	0
45666924	1174888	0	0
45699647	1343916	0	0
45672440	1177480	0	0
45706978	705944	0	0
45797383	19133679	1	2
45789764	19078461	2	3
46243764	1177480	0	0
45896839	1112807	0	0
45799332	1551099	0	0
45788935	1149196	0	0
46244611	1125315	0	0
46289835	1115171	2	3
4180628	4116491	4	4
4042641	4216130	3	6
21003454	1500211	0	0
21002502	19127890	0	0
36156442	1713332	0	0
35507214	1125315	0	0
36302170	4112343	7	13
36469247	1738521	0	0
42802514	40236824	2	3
44353962	1149196	0	0
43530877	40480160	6	6
45664596	19019273	2	3
45656216	1192710	0	0
45656677	19008572	2	3
45651194	40228214	2	3
45623099	967823	0	0
45667466	1125315	0	0
45676203	40162522	2	3
45779044	1115008	0	0
45783825	1119510	0	0
45667114	1154343	0	0
45699655	19003953	0	0
45672351	1177480	0	0
45707131	975125	0	0
45797184	40223774	1	1
45792746	40223768	2	3
46243652	1177480	0	0
45804276	1112807	0	0
45799337	1124957	0	0
45788936	1367571	0	0
46244571	1125315	0	0
46241667	43012036	2	3
4180628	4043241	8	9
4136694	40479422	3	3
21003454	1503184	0	0
21002502	1515774	0	0
36156442	1759842	0	0
35507214	1119510	0	0
36302170	4285898	7	14
36463387	1119510	0	0
42807303	19078924	2	3
44353755	1557272	0	0
43530877	40479768	6	7
45664712	19133768	2	3
45654980	1192710	0	0
45652901	1594382	2	3
45647691	40228214	2	3
45623217	1149196	0	0
45666428	1125315	0	0
45676278	1127433	2	3
45779264	1153428	0	0
45783753	1119510	0	0
45666840	19010482	0	0
45699679	715997	0	0
45672286	1177480	0	0
45706894	791967	0	0
45792456	40171902	1	1
46292278	19078461	2	3
46243815	1177480	0	0
45804312	1112807	0	0
45799121	1332418	0	0
45788940	1332418	0	0
46244552	1125315	0	0
46241668	1127433	2	3
4180628	28060	5	6
4136694	40479768	3	3
21000705	1332418	0	0
21002502	1548195	0	0
36156546	1738521	0	0
35507222	1539403	0	0
36302170	4094814	7	7
36463460	1119510	0	0
42807058	40236446	2	3
44354251	1551099	0	0
43530877	4132546	3	5
45664819	19008572	2	3
45655043	1192710	0	0
45653058	1107882	2	3
45654009	19079524	2	3
45623219	1154029	0	0
45666476	1125315	0	0
45676280	40232448	2	3
45779301	1174888	0	0
45783989	1119510	0	0
45666895	1115008	0	0
45699680	967823	0	0
45672572	1177480	0	0
45706896	791967	0	0
46275875	46275444	1	1
45792593	40174880	2	3
46243839	1177480	0	0
45797286	1112807	0	0
45799357	1107830	0	0
45788944	19039298	0	0
46240381	1125315	0	0
46241669	43012036	2	3
4180628	40481087	5	6
4181583	4294548	3	3
21000705	1545958	0	0
21002502	1595799	0	0
36156317	1551099	0	0
35202051	4280726	5	9
36302170	4240902	9	10
36463463	1332418	0	0
42805341	19018935	2	3
44354189	1713332	0	0
43530877	4134304	5	8
45664753	1154615	2	3
45649535	1192710	0	0
45652919	19075601	2	3
45644284	19078461	2	3
45623225	1149196	0	0
45666477	1125315	0	0
45673503	40228214	2	3
45779318	1326303	0	0
45783990	1119510	0	0
45666983	1000560	0	0
45699476	975125	0	0
45672495	1177480	0	0
45706099	1589505	0	0
46275915	46275916	1	1
45797993	1545959	2	3
46243784	1177480	0	0
45796656	1112807	0	0
45799174	1738521	0	0
45788993	1717327	0	0
46239771	1125315	0	0
46241587	19008572	2	3
4180628	255848	5	6
4181583	4112343	3	3
19123231	19123231	0	0
21002502	19054876	0	0
36156375	1551099	0	0
35702113	81893	6	12
36302170	433644	9	10
36463397	1717327	0	0
42805647	19019273	2	3
44354193	1177480	0	0
43530877	375671	5	7
45664886	1551192	2	3
45649601	1192710	0	0
45652923	40232448	2	3
45638394	19078461	2	3
45623247	1115008	0	0
45663829	1125315	0	0
45624732	1594382	2	3
45779346	1124300	0	0
45783993	1119510	0	0
45666816	1548195	0	0
45699484	1115008	0	0
45672631	1177480	0	0
45706099	1549786	0	0
46276149	1594382	1	1
45792741	1332419	2	3
46241434	1177480	0	0
45791196	1112807	0	0
45799348	975125	0	0
45789107	1192710	0	0
46239772	1125315	0	0
46241703	1127433	2	3
4180628	4142905	5	7
4042330	4301346	3	5
19074841	19074841	0	0
21002502	1589505	0	0
36156248	914335	0	0
35802134	81893	7	7
36302170	4048171	9	14
36469615	1154343	0	0
42804952	19019273	2	3
44354196	738818	0	0
43530877	378001	5	7
45664803	40232448	2	3
45649659	1192710	0	0
45653425	40162522	2	3
45629263	19078461	2	3
45625102	1713332	0	0
45664522	1125315	0	0
45624956	40229134	2	3
45780620	1115008	0	0
45781563	1119510	0	0
45667047	920293	0	0
45699685	1149196	0	0
45784309	1177480	0	0
45706117	1307863	0	0
46287614	40243436	1	1
45800467	1332419	2	3
46241444	1177480	0	0
45791357	1112807	0	0
45799126	1192710	0	0
45789107	1174888	0	0
46241859	19127904	3	4
46241646	40229134	2	3
4180628	4001336	5	7
4042503	4146173	3	5
19075001	19075001	0	0
21002502	1521369	0	0
36156508	1119510	0	0
21604180	723013	4	4
36302170	313217	9	14
36469629	1115008	0	0
42802101	19019273	2	3
44353845	1551099	0	0
43530877	4230399	5	7
45664806	40232448	2	3
45649059	1192710	0	0
45653425	19133768	2	3
45665286	40174880	2	3
45625063	1174888	0	0
45664515	1125315	0	0
45624815	1115171	2	3
45780624	975125	0	0
45781818	1119510	0	0
45667121	1768849	0	0
45699601	1124957	0	0
45784198	1177480	0	0
45706149	975125	0	0
45885352	4237458	1	1
45803108	1332419	2	3
46241636	1177480	0	0
45791211	1112807	0	0
45799132	1115008	0	0
45789101	1308738	0	0
46244407	19133679	3	4
46241623	1127433	2	3
4180628	40480160	5	7
4185503	261325	3	5
19076733	19029476	0	0
21002502	1549786	0	0
35507691	1307863	0	0
21604180	19074679	4	7
36303153	4037675	7	7
36463384	1125315	0	0
42802384	1551192	2	3
44353963	1738521	0	0
43530877	81151	5	7
45664810	40232448	2	3
45646568	1192710	0	0
45652981	1115171	2	3
45653438	1332419	2	3
45625102	1759842	0	0
45663965	1125315	0	0
45624963	19078924	2	3
45780701	738818	0	0
45781636	1119510	0	0
45667058	1738521	0	0
45699610	1305058	0	0
45786453	1177480	0	0
45706198	1115008	0	0
45876187	46235214	1	1
46243208	1332419	2	3
46238786	1177480	0	0
45791560	1112807	0	0
45799271	1501700	0	0
45788894	1746114	0	0
45876060	3024561	3	4
46241748	19008572	2	3
4180628	4048171	5	8
4180627	4295880	3	5
19077344	19077344	0	0
21002502	1503184	0	0
35507694	1728416	0	0
21604180	45892894	6	7
36303153	4299128	7	7
36469821	1125315	0	0
42807064	19075001	2	3
44354098	1539403	0	0
43530877	4156265	5	5
45664878	19018935	2	3
45646605	1192710	0	0
45653305	19008572	2	3
45635562	19078461	2	3
45625074	708298	0	0
45664005	1125315	0	0
45624673	19078461	2	3
45780857	738818	0	0
45781735	1119510	0	0
45667078	1115008	0	0
45699659	1149196	0	0
45784434	1177480	0	0
45706158	1153428	0	0
45696885	19079524	1	1
45696783	1332419	2	3
46238667	1177480	0	0
45791425	1112807	0	0
45799275	1549786	0	0
45788894	1741122	0	0
45876060	3013682	3	3
46241765	40229134	2	3
4180628	4166224	5	8
4180627	4059978	3	5
19076374	19076374	0	0
21002505	1521369	0	0
35507962	1107830	0	0
36217216	19133679	3	4
36303153	4266809	7	10
36469839	1119510	0	0
42804841	19019273	2	3
44354102	1192710	0	0
43530877	4048695	5	6
45664881	1115171	2	3
45643697	1192710	0	0
45653315	1154615	2	3
45650241	19078461	2	3
45624899	1110410	0	0
45663962	1125315	0	0
45670282	19008572	2	3
45780706	1107830	0	0
45781546	1119510	0	0
45667111	723013	0	0
45699667	1332418	0	0
45784470	1177480	0	0
45706148	967823	0	0
46292632	19079524	1	1
45789819	1332419	2	3
46238574	1177480	0	0
46298473	1112807	0	0
45799275	1589505	0	0
45789091	1551099	0	0
45893809	19128263	2	2
46242602	40162522	2	3
4180628	258780	5	8
4180627	4145310	3	5
19077572	19077572	0	0
21002524	1305058	0	0
35508016	715997	0	0
36217216	19128263	3	4
36303153	4156265	7	10
36469839	1125315	0	0
42804690	1545959	2	3
44354170	933724	0	0
43530877	4237458	5	6
45664407	40223834	2	3
45643797	1192710	0	0
45653361	19133768	2	3
45638404	19078461	2	3
45625076	1332418	0	0
45663938	1125315	0	0
45670283	40223834	2	3
45780697	1501700	0	0
45781308	1119510	0	0
45667082	738818	0	0
45699667	1545958	0	0
45782311	1177480	0	0
45706239	1154029	0	0
45876221	21494966	1	1
45785831	40174880	2	3
46240081	1177480	0	0
46298476	1112807	0	0
45799275	19127890	0	0
45788888	1589505	0	0
45893809	19128022	2	2
46242612	40229134	2	3
4180628	81151	5	8
4042330	44783196	3	4
21001432	1545958	0	0
21002493	19127890	0	0
35507965	1545958	0	0
36217216	19127918	3	4
36303153	4142905	7	11
36470033	1125315	0	0
42806885	40163554	2	3
44354278	920293	0	0
43530877	4066995	5	6
45664342	19059056	2	3
45643485	1192710	0	0
45653216	40232448	2	3
45649183	1539411	2	3
45624908	738818	0	0
45664078	1125315	0	0
45670614	40232448	2	3
45780844	1738521	0	0
45781529	1119510	0	0
45667140	1124957	0	0
45699669	1595799	0	0
45782253	1177480	0	0
45706347	1137529	0	0
45876220	40758406	1	1
45790041	1545959	2	3
45897701	1177480	0	0
46298685	1112807	0	0
45799278	1154343	0	0
45789080	1367571	0	0
46239815	19133768	2	3
46241850	1545959	2	3
4180628	81893	5	10
4134423	4238715	3	4
21001432	1332418	0	0
21002493	1515774	0	0
35507917	1310149	0	0
36217216	19127904	3	4
36303153	4169137	7	8
36470033	1119510	0	0
42807218	1545959	2	3
44354075	715997	0	0
44338301	1129625	0	0
45662043	19008572	2	3
45643500	1192710	0	0
45653459	19008572	2	3
45623782	1332419	2	3
45625126	742185	0	0
45664028	1125315	0	0
45670575	19019273	2	3
45780732	1174888	0	0
45781532	1119510	0	0
45667134	738818	0	0
45699669	1308738	0	0
45782220	1177480	0	0
45706347	1149380	0	0
45876220	3051031	1	1
45795055	1545959	2	3
45897794	1177480	0	0
46298859	1112807	0	0
45799209	19127890	0	0
45788985	1115008	0	0
46239815	40162522	2	3
46242004	1551192	2	3
4180628	45769019	5	5
4042504	4243062	3	4
21001432	1307863	0	0
21002510	1548195	0	0
35508059	1107830	0	0
36217216	19133905	2	3
36303153	42535580	7	8
36470077	1119510	0	0
42807091	1545959	2	3
44351701	1149196	0	0
44338311	1738521	0	0
45662158	1332419	2	3
45643614	1192710	0	0
45649767	19008572	2	3
45667395	1332419	2	3
45625018	1124957	0	0
45663986	1125315	0	0
45670474	1551192	2	3
45780734	1000560	0	0
45783596	1119510	0	0
45780960	738818	0	0
45699597	1539403	0	0
45782365	1177480	0	0
45706166	1149380	0	0
46276153	19079524	1	1
46240951	1545959	2	3
45897728	1177480	0	0
46298765	1112807	0	0
45799209	1549786	0	0
45789022	1310149	0	0
46239897	1115171	2	3
46241824	40229134	2	3
4180628	196456	5	5
4171379	4056621	3	4
19074843	19074843	0	0
21002493	1512674	0	0
35508029	1000560	0	0
36217216	40228214	2	3
36303153	81151	7	12
36470077	1125315	0	0
42804547	1545959	2	3
44352276	1738521	0	0
44338317	1149196	0	0
45662136	19008572	2	3
45643550	1192710	0	0
45651991	1115171	2	3
45667726	1539411	2	3
45623321	1149380	0	0
45663949	1125315	0	0
45670624	19059056	2	3
45779428	1174888	0	0
45783599	1119510	0	0
45780713	1174888	0	0
45699696	1107830	0	0
45782527	1177480	0	0
45706172	975125	0	0
45876249	3005136	3	4
45792731	1539411	2	3
45895522	1177480	0	0
46298892	1112807	0	0
45799216	1149196	0	0
45789031	1717327	0	0
46239944	40229134	2	3
45897899	1115171	2	3
4180628	4027663	5	5
4095203	4146173	3	4
19075601	19075601	0	0
21002508	1589505	0	0
35507923	1115008	0	0
36217216	40173590	2	3
36303153	258780	7	12
36470101	1119510	0	0
42807317	19123231	2	3
44352310	1322184	0	0
44338318	1192710	0	0
45662148	19059056	2	3
45640779	1192710	0	0
45652006	1551192	2	3
45653582	1332419	2	3
45621408	1107830	0	0
45664159	1125315	0	0
45670616	40228214	2	3
45779408	1332418	0	0
45783567	1119510	0	0
45780939	1115008	0	0
45699688	1192710	0	0
45782279	1177480	0	0
45706301	1154343	0	0
45876249	40758406	3	4
45790136	1539411	2	3
45896578	1177480	0	0
46290396	1112807	0	0
45799219	1305058	0	0
45789035	1501700	0	0
46321915	44816277	2	3
45897902	46233988	2	3
4180628	4134304	6	9
4029498	380378	1	1
4266169	4329847	3	4
21002508	1521369	0	0
35508036	1125315	0	0
36217216	46233988	2	3
36303153	37017711	8	9
36470162	1153428	0	0
42804866	19019273	2	3
44352401	1177480	0	0
44338319	1557272	0	0
45662106	19078924	2	3
45640970	1192710	0	0
45650046	1115171	2	3
45666201	1332419	2	3
45621482	1501700	0	0
45663995	1125315	0	0
45670595	19073183	2	3
45779431	723013	0	0
45779232	1119510	0	0
45780638	1000560	0	0
45699689	1153428	0	0
45782480	1177480	0	0
45706175	1713332	0	0
45876249	40769189	3	4
45895468	19128263	1	2
45679765	1129625	0	0
46290501	1112807	0	0
45799283	1115008	0	0
45789073	967823	0	0
46322225	40229134	2	3
45897978	40231925	2	3
4180628	4285898	6	9
4134312	4149245	1	1
4304916	30753	3	4
21002508	1512674	0	0
35508039	1545958	0	0
36217216	19059056	2	3
36303153	4166224	8	12
36469276	1177480	0	0
42804860	19019273	2	3
44352403	1557272	0	0
44338326	1124300	0	0
45662034	1551192	2	3
45641079	1192710	0	0
45650083	1551192	2	3
45641539	1332419	2	3
45621506	914335	0	0
45664109	1125315	0	0
45670538	40228214	2	3
45779437	738818	0	0
45779238	1119510	0	0
45780640	1343916	0	0
45696115	738818	0	0
45782603	1177480	0	0
45706334	1501700	0	0
45876249	21494966	3	4
46240071	42902245	1	2
45679794	1129625	0	0
46290717	1112807	0	0
45799402	1307863	0	0
46301961	1192710	0	0
46322236	46275916	2	3
45898002	19078461	2	3
4180628	4278672	6	7
4134439	4132546	1	1
4304916	4310024	3	4
21002508	1500211	0	0
35508040	791967	0	0
36217216	1551192	2	3
36303153	4243062	6	6
36470268	1129625	0	0
42802139	19019273	2	3
44352386	1115008	0	0
44338327	1112807	0	0
45662305	40169281	2	3
45640939	1192710	0	0
45650153	19073183	2	3
45659736	1332419	2	3
45621461	1110410	0	0
45664130	1125315	0	0
45670700	19008572	2	3
45779482	1548195	0	0
45779364	1119510	0	0
45780643	1124957	0	0
45695988	1107830	0	0
45782608	1177480	0	0
45706338	791967	0	0
45876249	40769194	3	4
45885352	4278672	1	2
45679032	1129625	0	0
46291036	1112807	0	0
45793765	1343916	0	0
46301975	1102527	0	0
46322040	40174880	2	3
45895786	19019273	2	3
4180628	40479422	6	7
4095263	4094814	1	1
4274025	317576	3	8
21002499	1595799	0	0
35507984	1309944	0	0
36217216	836659	2	3
36303153	4218389	6	8
36470268	1125315	0	0
42801990	1107882	2	3
44352003	1124300	0	0
44338327	738818	0	0
45662541	40228214	2	3
45637632	1192710	0	0
45646757	1551192	2	3
45623099	19079524	2	3
45621505	1332418	0	0
45664181	1125315	0	0
45670493	19079524	2	3
45779549	1521369	0	0
45779288	1119510	0	0
45778102	1118084	0	0
45695989	1107830	0	0
45702806	1177480	0	0
45706340	975125	0	0
45681484	1125315	0	0
45885352	4059173	1	2
45678963	1129625	0	0
46242086	1112807	0	0
45793960	967823	0	0
46301789	1124300	0	0
46321930	40229134	2	3
45895757	42707627	2	3
4040400	4078793	4	4
4050747	4278672	1	1
4223595	4048171	3	3
21002499	1515774	0	0
35508051	1332418	0	0
36217216	45892894	2	3
36303153	372328	6	9
36470446	1115008	0	0
42804642	1332419	2	3
44352228	1124300	0	0
44338464	1129625	0	0
45659150	19008572	2	3
45637673	1192710	0	0
45646775	40223821	2	3
45629608	19079524	2	3
45621621	1521369	0	0
45664139	1125315	0	0
45670458	40228214	2	3
45779549	1549786	0	0
45779290	1119510	0	0
45778450	1115008	0	0
45696105	1539403	0	0
45703048	1177480	0	0
45706302	1124300	0	0
45681567	1125315	0	0
46292579	46275916	1	1
45678968	1129625	0	0
46242519	1112807	0	0
45793924	1149196	0	0
46301827	1192710	0	0
46322265	43012036	2	3
45895794	19008572	2	3
4040400	4202451	4	4
4085546	4134304	1	1
4309188	4027663	3	3
21002499	1549786	0	0
35508052	1551099	0	0
36217216	1545959	2	3
36303153	4113008	6	9
36474554	1149196	0	0
42804696	1332419	2	3
44350234	1153428	0	0
44338212	1713332	0	0
45658878	19073183	2	3
45637766	1192710	0	0
45646869	19077572	2	3
45665249	1332419	2	3
45621621	19127890	0	0
45664144	1125315	0	0
45669045	1107882	2	3
45779549	1595799	0	0
45779319	1119510	0	0
45778451	1115008	0	0
45696207	1000560	0	0
45696263	1177480	0	0
45706215	1149196	0	0
45681436	1125315	0	0
45885353	4237458	1	1
45679073	1129625	0	0
46239621	1112807	0	0
45793970	1548195	0	0
46301878	1551099	0	0
46322283	40232448	2	3
45895857	40243436	2	3
4040400	4323902	4	4
4052559	441267	1	1
4268628	4037675	3	3
21002499	1589505	0	0
35507704	1310149	0	0
36217216	19123231	2	3
36303153	4109685	6	10
36475982	1367571	0	0
42810048	19078461	2	3
44350318	19127890	0	0
44338357	1589505	0	0
45659313	19008572	2	3
45634802	1192710	0	0
45646880	19008572	2	3
45660113	1539411	2	3
45621621	1549786	0	0
45660773	1125315	0	0
45669070	1127433	2	3
45779556	1713332	0	0
45779140	1119510	0	0
45778350	1367571	0	0
45696218	738818	0	0
45696741	1177480	0	0
45706219	1000560	0	0
45681419	1125315	0	0
45788120	19127922	1	1
45679125	1129625	0	0
46240257	1112807	0	0
45793975	1545958	0	0
46302040	1153428	0	0
46316255	1115171	2	3
45895901	40232448	2	3
4040400	4186930	4	4
4053602	4152936	1	1
4224259	4048171	3	3
21002499	19127890	0	0
35507707	967823	0	0
36217216	19073183	2	3
36303153	30753	6	10
36469202	1119510	0	0
42804629	19075601	2	3
44350318	1589505	0	0
44338361	1343916	0	0
44351574	40163554	2	3
45634552	1192710	0	0
45646888	35605482	2	3
45650279	1545959	2	3
45621433	1309944	0	0
45660925	1125315	0	0
45669122	1107882	2	3
45779508	1124300	0	0
45780701	1119510	0	0
45778473	1115008	0	0
45696085	1307863	0	0
45679964	1129625	0	0
45706309	1110410	0	0
45681552	1125315	0	0
45788120	19133679	1	1
45785848	1129625	0	0
45896258	1112807	0	0
45793975	1332418	0	0
46301761	753626	0	0
46311263	19133873	2	3
45895861	40229134	2	3
4040400	4337611	4	4
4043197	4238715	1	1
4223759	40486433	3	3
21002510	1500211	0	0
35507708	914335	0	0
36217216	40163554	2	3
36303153	378419	6	11
36427520	1729720	0	0
42805416	19075601	2	3
44350318	1549786	0	0
44338278	1107830	0	0
44351485	1545959	2	3
45637315	1192710	0	0
45646826	40163554	2	3
45656864	1545959	2	3
45621525	791967	0	0
45660946	1125315	0	0
45669215	43012036	2	3
45779461	738818	0	0
45779437	1119510	0	0
45778475	705944	0	0
45696068	19003953	0	0
45680078	1129625	0	0
45706313	1149196	0	0
45681632	1125315	0	0
45788120	19129144	1	1
45785851	1129625	0	0
45896444	1112807	0	0
45793978	1305058	0	0
46301766	1000560	0	0
46311134	1551192	2	3
45895851	40232448	2	3
4043161	4202451	4	4
4040976	4043071	1	1
4223759	4280726	3	3
21002510	1512674	0	0
35507710	967823	0	0
21604343	1127433	1	4
36303153	4134304	9	13
36427514	1728416	0	0
42805871	19075601	2	3
44350321	1549786	0	0
44338280	738818	0	0
44778204	1545959	2	3
45631644	1192710	0	0
45646951	19112599	2	3
45656846	1545959	2	3
45621497	1115008	0	0
45660947	1125315	0	0
45669178	19008572	2	3
45779606	1174888	0	0
45779438	1119510	0	0
45778546	1115008	0	0
45696225	1192710	0	0
45677944	1129625	0	0
45706271	1549786	0	0
45681612	1125315	0	0
46296921	46275916	1	1
45786040	1129625	0	0
45896359	1112807	0	0
45793986	1589505	0	0
46302059	920293	0	0
46311338	1154615	2	3
45895956	19075001	2	3
4040396	4275113	4	4
4040551	4218408	1	1
4224260	40486433	3	3
21002508	1548195	0	0
35507846	933724	0	0
21604753	19123231	1	4
36303153	317009	5	6
36427581	1102527	0	0
42804762	19075601	2	3
44350313	715997	0	0
44338088	1501700	0	0
45634111	19019273	2	3
45631651	1192710	0	0
45647105	40173590	2	3
45629773	1539411	2	3
45621565	1307863	0	0
45660997	1125315	0	0
45669161	43012036	2	3
45779515	1110410	0	0
45779489	1119510	0	0
45778549	738818	0	0
45696132	1521369	0	0
45677894	1129625	0	0
45706271	19127890	0	0
45681560	1125315	0	0
46289049	19079524	1	1
45786543	1129625	0	0
45896343	1112807	0	0
45794104	1539403	0	0
46302087	1192710	0	0
46311579	19133905	2	3
45896116	40229134	2	3
4040396	42535580	4	4
4134294	198809	1	1
4224260	4280726	3	3
21002510	1521369	0	0
35507858	975125	0	0
21604753	40236446	1	4
36303153	4027663	5	9
36423637	19134077	1	1
42802204	19075601	2	3
44350333	1778162	0	0
44338101	1115008	0	0
45625474	40223834	2	3
45632199	1192710	0	0
45647039	19059056	2	3
45663799	1539411	2	3
45621639	1551099	0	0
45660777	1125315	0	0
45669294	19129655	2	3
45779516	1557272	0	0
45779461	1119510	0	0
45778396	1343916	0	0
45696134	1149380	0	0
45677904	1129625	0	0
45706271	1589505	0	0
45679754	1125315	0	0
46238603	19134077	1	1
45786676	1129625	0	0
45893989	1112807	0	0
45794128	914335	0	0
46302095	1149380	0	0
46322125	19008572	2	3
45896167	40229134	2	3
4040396	4242997	4	4
4181187	4283893	1	1
4299725	4057420	3	3
21002572	1746114	0	0
35507862	1192710	0	0
35506943	19127904	1	2
36303153	44782520	5	8
36303194	4052083	1	1
42805460	19075601	2	3
44350258	1110410	0	0
44338102	1174888	0	0
45625474	40223821	2	3
45631840	1192710	0	0
45646969	19008572	2	3
45629944	1539411	2	3
45621745	1305058	0	0
45660829	1125315	0	0
45669278	19019273	2	3
45707934	975125	0	0
45707949	1119510	0	0
45778410	1367571	0	0
45696140	723013	0	0
45679771	1129625	0	0
45706283	975125	0	0
45679577	1125315	0	0
45696872	46275916	1	1
45786134	1129625	0	0
45894001	1112807	0	0
45793706	1500211	0	0
46302099	967823	0	0
46317368	19018935	2	3
45895984	43012036	2	3
4040396	4330583	4	4
4134423	4199276	1	1
4304916	4027663	3	3
21002574	1746114	0	0
35507869	967823	0	0
36216814	40231925	1	2
36303153	40480160	5	11
36313965	4191853	1	1
42804460	1539411	2	3
44350347	1539403	0	0
44338375	1192710	0	0
45658652	40223834	2	3
45631758	1192710	0	0
45647087	40229134	2	3
45632642	19078461	2	3
45621755	1595799	0	0
45660489	1125315	0	0
45669379	40229134	2	3
45707941	1713332	0	0
45708243	1119510	0	0
45778537	1149196	0	0
45696255	1115008	0	0
45674626	1129625	0	0
45706291	1110410	0	0
45679782	1125315	0	0
45696715	19079524	1	1
45786199	1129625	0	0
45894023	1112807	0	0
45794067	1717327	0	0
46301814	1332418	0	0
46306560	19133905	2	3
45804242	1115171	2	3
4043022	4337138	4	4
4169307	4174876	1	1
4266169	317576	3	3
21002574	1717327	0	0
35508008	1124300	0	0
36216815	40231925	1	2
36303153	134438	4	9
36503252	80502	1	1
42803145	1539411	2	3
44350323	715997	0	0
44338530	975125	0	0
45658652	40223821	2	3
45628746	1192710	0	0
45647004	1127433	2	3
45636004	1539411	2	3
45621755	1549786	0	0
45660533	1125315	0	0
45669144	40231925	2	3
45707997	967823	0	0
45708187	1119510	0	0
45778539	1396131	0	0
45696256	738818	0	0
45674646	1129625	0	0
45706249	1192710	0	0
45678191	1125315	0	0
45876168	3006322	1	1
46292643	1129625	0	0
45798527	738818	0	0
45794081	1124957	0	0
46301815	1551099	0	0
46305976	19133873	2	3
45804102	920300	2	3
4043023	4323902	4	4
4138127	4163971	1	1
4266169	321042	3	3
21002591	1728416	0	0
35508013	1177480	0	0
36219307	1150837	1	2
36303153	4084167	4	7
36503269	80180	1	1
42807056	1539411	2	3
44350270	1713332	0	0
44338519	1192710	0	0
45628470	1551192	2	3
45628602	1192710	0	0
45646143	1154615	2	3
45654049	1539411	2	3
45621755	1521369	0	0
45660661	1125315	0	0
45669466	1107882	2	3
45707962	740275	0	0
45707913	1119510	0	0
45778464	1500211	0	0
45696280	1192710	0	0
45674807	1129625	0	0
45706482	1154343	0	0
45678085	1125315	0	0
46291552	19079524	1	1
46293076	1129625	0	0
45798492	738818	0	0
45794086	1343916	0	0
46301817	1396131	0	0
46306190	19133905	2	3
45804104	40229134	2	3
4043023	4337611	4	4
4180627	4198190	7	10
4326835	4012477	3	3
21002510	1549786	0	0
35508139	1332418	0	0
36219308	1150837	1	2
36303153	4202451	4	7
36227313	19079524	1	2
42805680	40223768	2	3
44350244	738818	0	0
44338475	1548195	0	0
45652124	1332419	2	3
45628725	1192710	0	0
45643939	19133768	2	3
45639142	1539411	2	3
45621651	723013	0	0
45660880	1125315	0	0
45669314	1127433	2	3
45707973	1308738	0	0
45708297	1119510	0	0
45778491	920293	0	0
45696285	1192710	0	0
45674602	1129625	0	0
45706190	975125	0	0
45678292	1125315	0	0
46288534	19079524	1	1
46293166	1129625	0	0
45798843	738818	0	0
45794092	1717327	0	0
46301818	791967	0	0
46306574	1115171	2	3
45804138	1127433	2	3
4048365	4314290	4	4
4180627	4163971	7	8
4326835	4314290	3	3
21002511	1500211	0	0
35508172	1119510	0	0
36219363	19057271	1	2
36300000	4314290	4	8
36224524	46233710	1	2
42807153	19078461	2	3
44350596	1153428	0	0
44338433	1332418	0	0
45634185	19019273	2	3
45626013	1192710	0	0
45643892	19008572	2	3
45644888	1539411	2	3
45621760	1713332	0	0
45660951	1125315	0	0
45666632	19008572	2	3
45707974	791967	0	0
45705360	1119510	0	0
45778492	1501700	0	0
45696290	975125	0	0
45674980	1129625	0	0
45706194	1332418	0	0
45678294	1125315	0	0
45679150	19079524	1	1
46292990	1129625	0	0
45793192	738818	0	0
45793809	1545958	0	0
46301792	1539403	0	0
46306243	19059056	2	3
45803748	1115171	2	3
4048365	4012477	4	4
4094284	78272	7	7
4239721	433644	1	1
21002591	1768849	0	0
35508177	1119510	0	0
36213180	1150771	1	2
36300000	196456	6	12
36224524	46233988	1	2
42870893	3021226	3	3
44350563	19127890	0	0
44338289	791967	0	0
45628632	19019273	2	3
45622843	1192710	0	0
45644067	19133768	2	3
45645099	1539411	2	3
45621770	1713332	0	0
45660962	1125315	0	0
45666783	1127433	2	3
45707980	1118084	0	0
45705449	1119510	0	0
45778493	701322	0	0
45696476	1501700	0	0
45674898	1129625	0	0
45706292	1115008	0	0
45678247	1125315	0	0
46297099	19079524	1	1
46288160	1129625	0	0
45793194	738818	0	0
45794107	1124300	0	0
46301793	1115008	0	0
46306246	19008572	2	3
45804212	40229134	2	3
4096864	195588	4	4
4134598	4198190	7	7
4239721	4219399	1	1
21002597	1713332	0	0
35508177	1125315	0	0
36102932	433125	1	2
36300000	4246502	6	6
36227221	40220386	1	2
43531052	81893	7	8
44350563	1589505	0	0
44338434	1129625	0	0
45631427	19019273	2	3
45622396	1192710	0	0
45644043	42707627	2	3
45666095	1539411	2	3
45621742	1149196	0	0
45657861	1125315	0	0
45666962	19078924	2	3
45707981	753626	0	0
45705452	1119510	0	0
45778510	1107830	0	0
45696337	1322184	0	0
45674777	1129625	0	0
45706293	1396131	0	0
45678255	1125315	0	0
46288565	19079524	1	1
46288313	1129625	0	0
45793441	738818	0	0
45793945	1551099	0	0
46301863	1107830	0	0
46306773	40232448	2	3
45876069	3016723	2	3
4096864	198809	4	4
4113008	4113008	0	0
4238715	4186930	1	1
21002591	1778162	0	0
35508177	738818	0	0
36102934	28060	1	2
36300000	4029498	7	10
36227104	40165015	1	2
42802175	19128022	1	2
44350563	1549786	0	0
44338436	791967	0	0
45634501	19019273	2	3
45622649	1192710	0	0
45643993	43012036	2	3
45635950	46275916	1	1
45621871	1595799	0	0
45657981	1125315	0	0
45667030	40236824	2	3
45708042	914335	0	0
45705486	1119510	0	0
45778513	738818	0	0
45696232	1343916	0	0
45671816	1129625	0	0
45706305	1124957	0	0
45678393	1125315	0	0
45876060	3016723	3	4
46288045	1129625	0	0
45793294	738818	0	0
45793956	1115008	0	0
46298753	967823	0	0
46317223	40162522	2	3
45876069	3000963	2	3
4182161	4283893	4	4
4052083	4052083	0	0
4239975	4329847	1	1
21002591	1741122	0	0
35508142	1551099	0	0
36102971	260139	1	2
36300000	317576	7	13
36227038	920334	1	2
42802175	19128263	1	2
44350354	19010482	0	0
44338094	1177480	0	0
44778223	46233710	2	3
45622863	1192710	0	0
45644004	40232448	2	3
45635950	19079524	1	1
45621871	1521369	0	0
45657871	1125315	0	0
45667040	1127433	2	3
45708050	1548195	0	0
45705434	1119510	0	0
45778522	1124300	0	0
45696152	967823	0	0
45671826	1129625	0	0
45700609	1738521	0	0
45678396	1125315	0	0
45876060	3000963	3	4
46288741	1129625	0	0
45787862	738818	0	0
45794257	1124957	0	0
46299547	1551099	0	0
46322347	43012036	2	3
45798674	1115171	2	3
4182161	4156265	4	4
4195803	4195803	0	0
4250749	37017711	1	1
21002591	1713332	0	0
35508143	933724	0	0
36212939	40243436	1	2
36300000	133834	11	13
36227051	46275444	1	2
42810281	1149380	0	0
44350378	1112807	0	0
44338256	1307863	0	0
45621218	40228214	2	3
45621954	1192710	0	0
45644010	1107882	2	3
45666004	46275916	1	1
45621871	1549786	0	0
45658103	1125315	0	0
45666895	19019273	2	3
45708050	1589505	0	0
45705692	1119510	0	0
45780676	1149196	0	0
45696158	738818	0	0
45671972	1129625	0	0
45700669	1367571	0	0
45678499	1125315	0	0
45876060	3006906	3	3
46288685	1129625	0	0
45787878	738818	0	0
45794225	1107830	0	0
46299549	738818	0	0
46322654	1545959	2	3
45798475	19078924	2	3
4083787	4296204	4	4
4197460	4197460	0	0
4250749	4240902	1	1
21002591	1746114	0	0
35508084	1125315	0	0
36219362	1107882	1	2
36300000	381316	8	11
36227036	920300	1	2
42808846	975125	0	0
44350292	1713332	0	0
44338525	1332418	0	0
45662257	19078924	2	3
45621426	1192710	0	0
45643983	19078924	2	3
45666004	19079524	1	1
45621872	967823	0	0
45658102	1125315	0	0
45666847	19008572	2	3
45708065	1551099	0	0
45705510	1119510	0	0
45780603	914335	0	0
45696160	1192710	0	0
45671974	1129625	0	0
45700671	1307863	0	0
45678336	1125315	0	0
45885353	4230399	3	3
46244802	1129625	0	0
45788240	738818	0	0
45794228	933724	0	0
46299489	1174888	0	0
46317908	1332419	2	3
45798592	40162522	2	3
4134148	4275113	4	4
21000705	1539403	0	0
4251030	4243062	1	1
21002591	1729720	0	0
35508091	1000560	0	0
36219362	19125062	1	2
36300000	4283893	8	12
36227037	920334	1	2
42809095	1112807	0	0
44350296	738818	0	0
44338496	791967	0	0
45631287	19078924	2	3
45664883	1192710	0	0
45644096	1127433	2	3
45632971	46275916	1	1
45621823	1107830	0	0
45658181	1125315	0	0
45666852	19078461	2	3
45708146	1115008	0	0
45705734	1119510	0	0
45780608	1717327	0	0
45696163	1309944	0	0
45671743	1129625	0	0
45700675	1153428	0	0
45678341	1125315	0	0
45876047	3000963	4	4
46244646	1129625	0	0
45788070	738818	0	0
45794269	1149196	0	0
46298973	1124957	0	0
46321770	19019273	2	3
45798704	1127433	2	3
4083964	40479422	4	4
21000706	1332418	0	0
4252853	4112343	1	1
21002597	1717327	0	0
35508066	1332418	0	0
36222255	19075601	1	2
36300000	195588	8	13
36227037	920300	1	2
42807371	1118084	0	0
44350658	1112807	0	0
44338553	1177480	0	0
44351784	40223768	2	3
45662701	1192710	0	0
45644096	19078461	2	3
45632971	19079524	1	1
45621848	715997	0	0
45658161	1125315	0	0
45666983	35605482	2	3
45707884	1149380	0	0
45702004	1119510	0	0
45780518	1107830	0	0
45696266	967823	0	0
45672108	1129625	0	0
45700676	1124300	0	0
45678425	1125315	0	0
45795361	19127918	3	4
46244656	1129625	0	0
45788093	738818	0	0
45794204	791967	0	0
46299371	933724	0	0
46322302	19019273	2	3
45799681	40232448	2	3
4083964	40479768	4	4
21000713	1551099	0	0
4218017	4043241	1	1
21001912	1551099	0	0
35508148	1177480	0	0
36219361	19125062	1	2
36300000	260139	8	13
36503271	80809	1	2
42807373	1309944	0	0
44350253	742185	0	0
44338529	1149196	0	0
44344513	40223768	2	3
45662660	1192710	0	0
45644075	920334	2	3
45644856	19079524	1	1
45621849	1149196	0	0
45658217	1125315	0	0
45667047	920334	2	3
45707884	1137529	0	0
45702010	1119510	0	0
45780521	738818	0	0
45696165	975125	0	0
45672120	1129625	0	0
45700679	1549786	0	0
45678357	1125315	0	0
45679525	975125	0	0
46243358	1129625	0	0
46294030	738818	0	0
45794220	1154029	0	0
46299383	1717327	0	0
46239758	1539411	2	3
45799850	1545959	2	3
4029698	4198190	4	4
21000716	1177480	0	0
4219484	443279	1	1
21001947	1729720	0	0
21604757	705944	0	0
36219361	1107882	1	2
36300000	4329847	8	14
36227567	1519937	1	2
42809371	1125315	0	0
44350395	738818	0	0
44338508	1177480	0	0
45652540	19075001	2	3
45662662	1192710	0	0
45644236	40232448	2	3
45667985	19079524	1	1
45621852	1713332	0	0
45658148	1125315	0	0
45667121	19074843	2	3
45707855	705944	0	0
45702089	1119510	0	0
45780523	738818	0	0
45696171	1521369	0	0
45671905	1129625	0	0
45700679	1595799	0	0
45678353	1125315	0	0
45679375	975125	0	0
46243379	1129625	0	0
46293543	738818	0	0
45788663	715997	0	0
46299553	738818	0	0
45788820	1545959	2	3
45799859	40231925	2	3
4181187	4048171	4	4
21000716	1118084	0	0
4221994	4187458	1	1
21001953	975125	0	0
21604320	1112807	0	0
36213167	19059056	1	2
36300000	4116491	9	11
36303194	4133840	1	2
42808448	1115008	0	0
44350470	1551099	0	0
44338499	1112807	0	0
45633948	40173590	2	3
45656557	1192710	0	0
45641287	1115171	2	3
45641752	19079524	1	1
45621926	1154029	0	0
45658157	1125315	0	0
45667057	43012036	2	3
45708135	1115008	0	0
45701822	1119510	0	0
45706970	1124300	0	0
45696171	1595799	0	0
45672026	1129625	0	0
45700679	1521369	0	0
45674853	1125315	0	0
45679720	1174888	0	0
46243545	1129625	0	0
46243663	738818	0	0
45788666	1729720	0	0
46299563	975125	0	0
46289656	1545959	2	3
45798977	40174880	2	3
4049222	40486433	4	4
21000736	967823	0	0
19099291	44816277	1	1
21001868	1154343	0	0
21602499	1589505	0	0
36216540	19074843	1	2
36300000	4278672	9	13
36313965	4012477	2	5
42816239	1119510	0	0
44350334	1551099	0	0
44338503	1124957	0	0
45634052	19073183	2	3
45656176	1192710	0	0
45641012	1127433	2	3
45633020	19079524	1	1
45621927	1548195	0	0
45657764	1125315	0	0
45667088	19008572	2	3
45708136	1107830	0	0
45701824	1119510	0	0
45706982	1549786	0	0
45696171	1549786	0	0
45672157	1129625	0	0
45700642	1107830	0	0
45674935	1125315	0	0
45679706	1154029	0	0
46240943	1129625	0	0
46243774	738818	0	0
45788667	1154343	0	0
46299154	1551099	0	0
45788399	1545959	2	3
45799000	19019273	2	3
4049222	4280726	4	4
21000295	1738521	0	0
19020937	19029476	1	1
21001950	1738521	0	0
21602504	1519936	0	0
36216540	19074841	1	2
36300000	4102123	9	10
36503263	80809	2	4
42811089	1125315	0	0
44350336	1112807	0	0
44338449	1192710	0	0
45620884	19073183	2	3
45658412	1192710	0	0
45641118	19019273	2	3
45645194	19079524	1	1
45621597	920293	0	0
45657903	1125315	0	0
45780939	1115171	2	3
45708233	1501700	0	0
45701846	1119510	0	0
45706982	1595799	0	0
45696275	1110410	0	0
45671774	1129625	0	0
45699701	1549786	0	0
45675293	1125315	0	0
45679464	1548195	0	0
46242166	1129625	0	0
46244772	738818	0	0
45788674	1149196	0	0
46298821	1549786	0	0
46298265	1539411	2	3
45799006	40229134	2	3
4172515	4043071	4	4
21000290	1759842	0	0
4322048	4275113	1	1
21001919	1154343	0	0
21601767	1307863	0	0
36213168	19059056	1	2
36300000	441267	9	10
36503263	80180	2	3
42809371	1119510	0	0
44350426	1149196	0	0
44338615	1557272	0	0
45628166	19078461	2	3
45653011	1192710	0	0
45641128	40228230	2	3
45644845	19079524	1	1
45621882	1124300	0	0
45657919	1125315	0	0
45778415	40232448	2	3
45708234	1149380	0	0
45701852	1119510	0	0
45706982	1521369	0	0
45696273	723013	0	0
45784048	1129625	0	0
45699701	19127890	0	0
45675211	1125315	0	0
45679850	1501700	0	0
46242170	1129625	0	0
46244777	738818	0	0
45789345	1322184	0	0
46298823	791967	0	0
45793762	1539411	2	3
45793556	40163554	2	3
4121042	4202451	4	4
21000285	1778162	0	0
4287321	4202451	1	1
21001853	1768849	0	0
35508129	1119510	0	0
35205190	4329847	1	1
36300000	4302207	9	10
36463290	1127433	2	3
42809410	1115008	0	0
44350428	1149380	0	0
44338620	1112807	0	0
45634652	19078461	2	3
45653531	1192710	0	0
45641295	40174880	2	3
45648154	19079524	1	1
45667477	1107830	0	0
45658323	1125315	0	0
45778416	40232448	2	3
45707897	1738521	0	0
45702189	1119510	0	0
45706985	967823	0	0
45696341	1153428	0	0
45784041	1129625	0	0
45699701	1589505	0	0
45675214	1125315	0	0
45679853	1107830	0	0
46242299	1129625	0	0
46244780	738818	0	0
45789181	1501700	0	0
46299390	1115008	0	0
45893695	1539411	2	3
45793672	40229134	2	3
4043346	4142905	4	4
21000292	1738521	0	0
19112768	19074679	1	1
21001936	1746114	0	0
35508129	1125315	0	0
35204969	313217	1	1
36300000	4139681	9	10
36463190	40224805	2	3
42811090	1149196	0	0
44350435	1332418	0	0
44338561	1332418	0	0
45664503	19078461	2	3
45653103	1192710	0	0
45642908	19078461	2	3
45635732	19079524	1	1
45667316	1501700	0	0
45658326	1125315	0	0
45778450	1115171	2	3
45708150	1000560	0	0
45702068	1119510	0	0
45707166	1589505	0	0
45696485	738818	0	0
45784174	1129625	0	0
45699755	1115008	0	0
45675229	1125315	0	0
45678987	1343916	0	0
46241199	1129625	0	0
46238984	738818	0	0
45789417	1738521	0	0
46299402	1521369	0	0
45801641	1539411	2	3
45793641	1115171	2	3
4043346	321042	4	4
21000291	1738521	0	0
4267297	198809	1	1
21001936	1717327	0	0
35508129	1192710	0	0
35205164	317576	1	1
36300000	378001	10	14
36422283	40220960	2	3
42820455	738818	0	0
44350440	975125	0	0
44338234	738818	0	0
44778004	40228214	2	3
45652988	1192710	0	0
45642973	40232448	2	3
45641859	19079524	1	1
45667317	738818	0	0
45658329	1125315	0	0
45778451	1115171	2	3
45708105	1309944	0	0
45702129	1119510	0	0
45707050	1539403	0	0
45696604	1307863	0	0
45784070	1129625	0	0
45699760	1738521	0	0
45675231	1125315	0	0
45678989	1521369	0	0
46241297	1129625	0	0
46239295	738818	0	0
45788701	1501700	0	0
46299402	1549786	0	0
45799257	1539411	2	3
45793642	1115171	2	3
4180170	40486433	4	4
21000683	1308738	0	0
4226263	28060	1	1
21001907	975125	0	0
35508074	1501700	0	0
35502641	140673	1	1
36300000	4048171	10	15
36463335	1115171	2	3
42820568	1125315	0	0
44350441	1501700	0	0
44338512	1549786	0	0
45662243	1107882	2	3
45647017	1192710	0	0
45642987	40228214	2	3
45660471	46275916	1	1
45667276	715997	0	0
45658305	1125315	0	0
45778362	40232448	2	3
45708243	738818	0	0
45702159	1119510	0	0
45779383	1125315	0	0
45696321	967823	0	0
45784086	1129625	0	0
45699762	1118084	0	0
45675013	1125315	0	0
45678989	1548195	0	0
46238500	1129625	0	0
45894584	738818	0	0
45788780	742185	0	0
46298804	975125	0	0
46241764	1539411	2	3
45793790	40232448	2	3
4180170	260139	4	4
21000701	1332418	0	0
19123230	19123231	1	1
21001907	1551099	0	0
35508076	1000560	0	0
35506777	140673	1	1
36503289	40486433	5	5
36469629	1115171	2	3
42816558	1153428	0	0
44350445	1112807	0	0
44338512	1589505	0	0
45640438	1107882	2	3
45646951	1192710	0	0
45641309	19019273	2	3
45660471	19079524	1	1
45667279	1343916	0	0
45654640	1125315	0	0
45778363	1127433	2	3
45708075	1326303	0	0
45702224	1119510	0	0
45779399	1125315	0	0
45696608	1107830	0	0
45781961	1129625	0	0
45699710	19003953	0	0
45675193	1125315	0	0
45679017	1102527	0	0
46238507	1129625	0	0
45894620	738818	0	0
45788757	1149196	0	0
46299595	1539403	0	0
46297472	19128009	1	2
45793853	40232448	2	3
4180170	4280726	4	4
21000701	1545958	0	0
19076574	19045231	1	1
21001924	1768849	0	0
35508264	1501700	0	0
35708603	28060	1	1
36503289	317576	5	5
36470446	1115171	2	3
42807861	1125315	0	0
44350472	1118084	0	0
44338237	1107830	0	0
45664715	1107882	2	3
45643853	1192710	0	0
45641387	19019273	2	3
45648060	19079524	1	1
45667484	1174888	0	0
45654657	1125315	0	0
45778473	19019273	2	3
45708093	1115008	0	0
45699250	1119510	0	0
45779290	1125315	0	0
45696610	1192710	0	0
45781985	1129625	0	0
45699785	1174888	0	0
45675266	1125315	0	0
45679025	791967	0	0
46238484	1129625	0	0
45894666	738818	0	0
45788721	1322184	0	0
46298835	1729720	0	0
45804114	19128263	1	2
45793804	40229134	2	3
4180170	4294548	4	4
21000300	1728416	0	0
4288463	4238715	1	1
21001924	1778162	0	0
35508265	1501700	0	0
36102960	440448	1	1
36503289	4280726	5	5
36427581	40165015	2	3
42810477	1112807	0	0
44350588	1153428	0	0
44338242	1112807	0	0
45625076	1332419	2	3
45643926	1192710	0	0
45641463	42707627	2	3
45663811	46275916	1	1
45667495	1549786	0	0
45654665	1125315	0	0
45778414	43012036	2	3
45708185	791967	0	0
45699192	1119510	0	0
45780628	1125315	0	0
45696348	1738521	0	0
45782075	1129625	0	0
45699789	1309944	0	0
45676427	1125315	0	0
45679040	1112807	0	0
46238335	1129625	0	0
45801595	738818	0	0
45788762	914335	0	0
46298838	1343916	0	0
45804114	19128022	1	2
45793588	19008572	2	3
4181192	4108705	4	4
21000297	1738521	0	0
4287856	4202832	1	1
21002159	1746114	0	0
35508266	1177480	0	0
36102966	372328	1	1
36503289	134438	5	5
36463252	19019273	2	3
42810664	1589505	0	0
44350590	1124300	0	0
44338242	1192710	0	0
45658978	1107882	2	3
45643928	1192710	0	0
45641310	1107882	2	3
45663811	19079524	1	1
45667495	1589505	0	0
45654667	1125315	0	0
45778539	19077344	2	3
45708308	1107830	0	0
45699305	1119510	0	0
45780629	1125315	0	0
45696350	1305058	0	0
45781902	1129625	0	0
45699896	1153428	0	0
45672204	1125315	0	0
45679055	1149380	0	0
46238339	1129625	0	0
45801566	738818	0	0
45788704	1107830	0	0
46299511	1174888	0	0
500000503	192671	1	1
45788208	40223768	2	3
4042141	372328	4	4
21000299	1728416	0	0
21001459	40171902	1	1
21002159	1717327	0	0
35508232	1149196	0	0
36102971	255848	1	1
36503289	40479422	5	7
36463282	19019273	2	3
42810830	1119510	0	0
44350591	1174888	0	0
44338421	1149196	0	0
45658694	1107882	2	3
45643993	1192710	0	0
45637822	19008572	2	3
45644647	19079524	1	1
45667389	1308738	0	0
45654292	1125315	0	0
45778464	40224132	2	3
45708194	975125	0	0
45699185	1119510	0	0
45780701	1125315	0	0
45696360	1153428	0	0
45781995	1129625	0	0
45699900	1332418	0	0
45671909	1125315	0	0
45679059	1112807	0	0
46238357	1129625	0	0
45795901	738818	0	0
45788720	1589505	0	0
46299245	1107830	0	0
500000901	321042	1	1
45788176	40229134	2	3
4134134	375671	4	4
21000299	1729720	0	0
21000953	19074679	1	1
21002247	975125	0	0
35508238	1738521	0	0
21603288	40169281	1	1
36503289	40479768	5	7
36475983	19078461	2	3
42810849	1125315	0	0
44350592	967823	0	0
44338428	1310149	0	0
45643073	1107882	2	3
45644015	1192710	0	0
45638095	19077344	2	3
45642134	19079524	1	1
45667281	1367571	0	0
45654299	1125315	0	0
45778491	920334	2	3
45708195	1174888	0	0
45699355	1119510	0	0
45780862	1125315	0	0
45696504	1153428	0	0
45781956	1129625	0	0
45699914	1149196	0	0
45672251	1125315	0	0
45679087	1310149	0	0
46238672	1129625	0	0
45796250	738818	0	0
45788691	1309944	0	0
46299217	1738521	0	0
500000902	321042	1	1
45788317	40232448	2	3
4134134	378001	4	4
21000313	975125	0	0
21001432	40171902	1	1
21002132	1746114	0	0
35508240	1545958	0	0
21604343	19133768	3	4
36503289	133834	7	7
36428428	40169281	2	3
42817873	1119510	0	0
44350410	1322184	0	0
44338430	1107830	0	0
45622019	19078461	2	3
45641216	1192710	0	0
45638075	1127433	2	3
45653873	19079524	1	1
45665340	1545958	0	0
45654587	1125315	0	0
45778510	1107882	2	3
45707902	791967	0	0
45699512	1119510	0	0
45780732	1125315	0	0
45696511	1322184	0	0
45781958	1129625	0	0
45699817	1174888	0	0
45672312	1125315	0	0
45679152	1192710	0	0
45897433	1129625	0	0
45796199	738818	0	0
45788748	1549786	0	0
46299522	738818	0	0
500000903	321042	1	1
45788568	1115171	2	3
4043160	4107731	4	4
21000301	1728416	0	0
21001432	1332419	2	3
21002166	975125	0	0
35508371	1332418	0	0
35204998	317576	3	4
36503289	381316	4	4
36468849	19078461	2	3
42817902	1119510	0	0
44350599	1149380	0	0
44338588	1557272	0	0
45645968	1332419	2	3
45641116	1192710	0	0
45638059	19073183	2	3
45660354	46275916	1	1
45665034	1501700	0	0
45654703	1125315	0	0
45778521	19059056	2	3
45707903	1332418	0	0
45699517	1119510	0	0
45779428	1125315	0	0
45696512	738818	0	0
45782211	1129625	0	0
45699821	1343916	0	0
45672051	1125315	0	0
45679167	1192710	0	0
45897447	1129625	0	0
45796179	738818	0	0
45788748	1521369	0	0
46299283	1115008	0	0
500001801	321042	1	1
45788570	40232448	2	3
4104157	45769019	4	4
21000315	975125	0	0
21001455	19059056	2	3
21002168	975125	0	0
35508372	1115008	0	0
36100000	257012	3	4
36503289	4149245	4	5
36422228	40173590	2	3
42816848	1149380	0	0
44350602	1177480	0	0
44338595	1129625	0	0
44358062	1332419	2	3
45641253	1192710	0	0
45638045	40232448	2	3
45660354	19079524	1	1
45665241	1539403	0	0
45654415	1125315	0	0
45780608	19129655	2	3
45708012	1343916	0	0
45699518	1119510	0	0
45779403	1125315	0	0
45696517	1713332	0	0
45779738	1129625	0	0
45699769	1115008	0	0
45672213	1125315	0	0
45679169	1107830	0	0
45897638	1129625	0	0
45791011	738818	0	0
45788727	1137529	0	0
46299462	1307863	0	0
500001801	313217	1	1
45788607	19059056	2	3
4134443	40479422	4	4
21000301	1738521	0	0
21001455	1539411	2	3
21002134	1746114	0	0
35508463	1125315	0	0
36152687	19133679	3	4
36503289	81151	4	8
36463361	1107882	2	3
42816865	1149196	0	0
44350577	1738521	0	0
44338545	1332418	0	0
45640219	1332419	2	3
45642982	1192710	0	0
45638171	1713671	2	3
45635671	19079524	1	1
45665305	1310149	0	0
45654431	1125315	0	0
45707153	1115171	2	3
45708247	740275	0	0
45695749	1119510	0	0
45779437	1125315	0	0
45696519	1154343	0	0
45779760	1129625	0	0
45699831	1154343	0	0
45672200	1125315	0	0
45679178	1112807	0	0
45897575	1129625	0	0
45791895	738818	0	0
45788727	1149380	0	0
46301558	1343916	0	0
46311637	46275916	1	1
45788598	40162522	2	3
4134443	40479768	4	4
21000314	975125	0	0
21001455	19075601	2	3
21002135	1741122	0	0
35508463	1129625	0	0
36206173	3000876	3	6
36503289	78272	4	9
36463429	1107882	2	3
42816957	1149380	0	0
44350385	1154029	0	0
44338546	1118084	0	0
45664318	1332419	2	3
45642970	1192710	0	0
45638169	1154615	2	3
45623802	46275916	1	1
45665313	1343916	0	0
45654432	1125315	0	0
45707254	1107882	2	3
45708078	1115008	0	0
45697704	1119510	0	0
45779443	1125315	0	0
45696650	975125	0	0
45779793	1129625	0	0
45699838	975125	0	0
45672563	1125315	0	0
45679069	19010482	0	0
45897711	1129625	0	0
45791855	738818	0	0
45788699	1115008	0	0
46301720	1000560	0	0
45801388	19074679	1	1
45788541	1551192	2	3
4176642	4035793	4	4
19131647	19132304	0	0
21001455	1545959	2	3
21002146	1741122	0	0
35508463	1119510	0	0
36206173	3015076	3	6
36503288	4113008	6	6
36423511	40228214	2	3
42818360	1125315	0	0
44350567	1149380	0	0
44338589	920293	0	0
45625594	19075601	2	3
45642919	1192710	0	0
45638380	19133873	2	3
45623802	19079524	1	1
45665409	1557272	0	0
45655442	1125315	0	0
45707256	19008572	2	3
45708161	1557272	0	0
45697654	1119510	0	0
45779489	1125315	0	0
45696651	1192710	0	0
45779879	1129625	0	0
45699869	1308738	0	0
45672587	1125315	0	0
45679029	975125	0	0
45895292	1129625	0	0
45791922	738818	0	0
45788782	975125	0	0
46301574	1713332	0	0
45795850	40171902	1	1
45788684	40229134	2	3
4130526	4144583	4	4
19054876	19054876	0	0
21000703	1539411	2	3
21001967	914335	0	0
35508503	1332418	0	0
35205038	257012	3	6
36503288	4155034	6	6
36423511	40228230	2	3
42818360	1129625	0	0
44350570	1177480	0	0
44338388	1129625	0	0
44344137	1539411	2	3
45641346	1192710	0	0
45638451	19078461	2	3
45653940	19079524	1	1
45665323	1738521	0	0
45655512	1125315	0	0
45707048	40232448	2	3
45707910	1557272	0	0
45697833	1119510	0	0
45779460	1125315	0	0
45696407	1149196	0	0
45708354	1129625	0	0
45699872	967823	0	0
45672485	1125315	0	0
45679127	1717327	0	0
45895349	1129625	0	0
45792039	738818	0	0
45788783	1738521	0	0
46301590	1192710	0	0
45876029	3014599	2	2
45788499	1115171	2	3
4116777	261325	4	4
19016749	19016749	0	0
21000703	1545959	2	3
21001973	975125	0	0
35508505	1713332	0	0
4180941	4186930	3	6
36503288	4059173	6	7
36422111	19059056	2	3
42818440	1119510	0	0
44350657	1177480	0	0
44338390	1112807	0	0
45658442	19078461	2	3
45641398	1192710	0	0
45637104	1332419	2	3
45624091	19079524	1	1
45665325	1738521	0	0
45654726	1125315	0	0
45707343	40174880	2	3
45707912	1107830	0	0
45696005	1119510	0	0
45779461	1125315	0	0
45696534	1149196	0	0
45708362	1129625	0	0
45699873	1549786	0	0
45672602	1125315	0	0
45785989	1332418	0	0
45895456	1129625	0	0
46294808	738818	0	0
45788824	1738521	0	0
46301854	708298	0	0
45876029	3001247	2	2
45788505	40232448	2	3
4116777	258780	4	4
4299128	4299128	0	0
21001447	19126352	2	3
21001982	1119510	0	0
35508469	1119510	0	0
4201745	4112343	3	7
36503288	4152936	6	8
36427514	19006318	2	3
42808572	975125	0	0
44350700	933724	0	0
44338393	1124957	0	0
45643345	19079524	2	3
45638137	1192710	0	0
45634866	1154615	2	3
45639301	19079524	1	1
45665286	1501700	0	0
45654762	1125315	0	0
45707427	40228214	2	3
45707913	738818	0	0
45693077	1119510	0	0
45779606	1125315	0	0
45696543	1545958	0	0
45708348	1129625	0	0
45699873	1512674	0	0
45672381	1125315	0	0
45785936	1000560	0	0
45895385	1129625	0	0
46244039	738818	0	0
45788835	1548195	0	0
46301786	1343916	0	0
45876029	3006734	2	2
45788657	19133905	2	3
4169466	4152936	4	4
21000706	1545958	0	0
21001447	19059056	2	3
21001960	1115008	0	0
35508473	1119510	0	0
35205038	4280726	3	7
36503288	40479768	6	9
36423453	19074843	2	3
42817353	1125315	0	0
44350492	1192710	0	0
44338605	1174888	0	0
45628639	1539411	2	3
45637957	1192710	0	0
45634875	40162522	2	3
45654063	19079524	1	1
45665292	1149196	0	0
45651367	1125315	0	0
45707566	1127433	2	3
45708291	1549786	0	0
45692915	1119510	0	0
45779607	1125315	0	0
45696544	1153428	0	0
45777958	1129625	0	0
45699873	19127890	0	0
45784301	1125315	0	0
45786010	1149196	0	0
45895480	1129625	0	0
46244043	738818	0	0
45788835	1521369	0	0
46301983	975125	0	0
45876029	3015076	2	2
45788657	19133873	2	3
4042478	4163971	4	4
21000706	1539403	0	0
21000705	1545959	2	3
21001960	1125315	0	0
35508475	1192710	0	0
36200000	4296205	3	7
36503288	40479422	6	9
36423453	19074841	2	3
42820815	1125315	0	0
44350605	1192710	0	0
44338394	1154343	0	0
44351772	1539411	2	3
45638077	1192710	0	0
45648942	19078461	2	3
45623831	46275916	1	1
45665348	1124300	0	0
45651113	1125315	0	0
45707444	40228214	2	3
45708276	1110410	0	0
45692738	1119510	0	0
45707963	1125315	0	0
45696686	738818	0	0
45705945	1129625	0	0
45699857	1501700	0	0
45784353	1125315	0	0
45786052	1149196	0	0
45895505	1129625	0	0
46244100	738818	0	0
45788839	1551099	0	0
46301984	1110410	0	0
45876029	3000876	2	2
46298026	19008572	2	3
4042142	40486433	4	4
21000756	967823	0	0
21001448	19059056	2	3
21601121	1308738	0	0
35508579	1729720	0	0
36102970	4112343	3	7
36503288	4149245	5	8
36423477	19075001	2	3
42820816	1125315	0	0
44350608	1112807	0	0
44338609	1149196	0	0
45662076	1539411	2	3
45638053	1192710	0	0
45662847	1539411	2	3
45623831	19079524	1	1
45665357	1539403	0	0
45651302	1125315	0	0
45706779	19073183	2	3
45708177	1124300	0	0
45692992	1119510	0	0
45708004	1125315	0	0
45696415	1110410	0	0
45705942	1129625	0	0
45699885	1361711	0	0
45784256	1125315	0	0
45786046	1548195	0	0
45895422	1129625	0	0
46244075	738818	0	0
45788840	967823	0	0
46301985	19003953	0	0
45876029	3021226	2	2
46301446	40236446	2	3
4042142	4280726	4	4
21000713	975125	0	0
21001448	19075601	2	3
21600234	19018935	0	3
35508581	1521369	0	0
36102154	40481087	3	7
36503288	4278672	5	7
36423476	19075001	2	3
42820884	1129625	0	0
44350812	1149196	0	0
44338406	1548195	0	0
45659255	19079524	2	3
45638262	1192710	0	0
45646883	19075601	2	3
45642105	46275916	1	1
45665387	1107830	0	0
45651153	1125315	0	0
45706510	40165015	2	3
45708291	1589505	0	0
45693189	1119510	0	0
45707953	1125315	0	0
45696433	1192710	0	0
45705769	1129625	0	0
45699889	1192710	0	0
45784262	1125315	0	0
45785995	967823	0	0
45895431	1129625	0	0
46244165	738818	0	0
45788846	1115008	0	0
46302504	1322184	0	0
45876029	3001488	2	2
46301453	40162522	2	3
4094284	4149245	4	4
21000815	1729720	0	0
21001448	40163554	2	3
21600270	1310034	0	3
35508581	1549786	0	0
36102149	40481087	3	7
36503288	4142905	5	7
36305121	3023103	2	2
42817581	1129625	0	0
44346397	1549786	0	0
44338531	1149196	0	0
45625619	40228214	2	3
44362813	1332418	0	0
45655315	1332419	2	3
45642105	19079524	1	1
45665398	1000560	0	0
45651292	1125315	0	0
45704401	1127433	2	3
45708096	19010482	0	0
45693104	1119510	0	0
45707847	1125315	0	0
45692966	738818	0	0
45705951	1129625	0	0
45699962	1149196	0	0
45784318	1125315	0	0
45785997	1112807	0	0
45895252	1129625	0	0
46244402	738818	0	0
45788909	975125	0	0
46301653	1595799	0	0
45876029	3027231	2	2
46301542	19133905	2	3
4136694	81151	4	4
21000716	1124300	0	0
21001770	1551192	2	3
21505741	40229134	5	6
35508262	1501700	0	0
36102149	28060	3	7
36503288	40480160	5	7
36305121	3016723	2	2
42817597	1125315	0	0
44346389	1124300	0	0
44338532	1177480	0	0
45625604	40228214	2	3
44361721	715997	0	0
45649757	19075601	2	3
45663658	19079524	1	1
45665401	1149196	0	0
45651390	1125315	0	0
45704255	1154615	2	3
45708099	1548195	0	0
45692862	1119510	0	0
45707896	1125315	0	0
45693253	914335	0	0
45706088	1129625	0	0
45700048	1549786	0	0
45784280	1125315	0	0
45785976	1107830	0	0
45895514	1129625	0	0
46239371	738818	0	0
45789017	1149196	0	0
46299620	1551099	0	0
45876029	3006451	2	2
46298158	43012036	2	3
4042483	4330583	4	4
21000716	1115008	0	0
21001770	40229134	2	3
21500543	40232448	5	6
35508316	1112807	0	0
36100000	433125	3	8
36503288	4230399	7	8
36503249	80502	2	2
42817688	1112807	0	0
44346369	1332418	0	0
44338534	738818	0	0
45643226	19078461	2	3
44361748	1539403	0	0
45640962	1539411	2	3
45659060	46275916	1	1
45665384	1549786	0	0
45651478	1125315	0	0
45704256	19078924	2	3
45708333	1107830	0	0
45693067	1119510	0	0
45708243	1125315	0	0
45693235	975125	0	0
45706006	1129625	0	0
45700060	1521369	0	0
45784334	1125315	0	0
45786027	1107830	0	0
45803345	1129625	0	0
46239679	738818	0	0
45788866	715997	0	0
46299709	975125	0	0
45876029	3012494	2	2
46289859	40229134	2	3
4197094	440448	4	4
21000824	975125	0	0
21001770	40228214	2	3
21500731	19079524	5	6
35508319	1125315	0	0
36100000	28060	3	8
36503288	4066995	4	7
36303200	4314290	2	2
42817786	1149196	0	0
44346586	1112807	0	0
44338537	1124300	0	0
44344260	40228214	2	3
44361859	1153428	0	0
45656042	19075601	2	3
45659060	19079524	1	1
45665384	19127890	0	0
45651608	1125315	0	0
45704364	40224805	2	3
45708110	19010482	0	0
45690014	1119510	0	0
45708076	1125315	0	0
45693239	1192710	0	0
45703700	1129625	0	0
45700147	933724	0	0
45784270	1125315	0	0
45785844	1153428	0	0
45803761	1129625	0	0
46239658	738818	0	0
45788820	1545958	0	0
46295319	1107830	0	0
45876032	3004501	2	2
46290144	1115171	2	3
4190185	81893	3	4
21000830	975125	0	0
21001770	40232448	2	3
21500731	19077344	5	6
35508319	1174888	0	0
36100000	198199	3	8
36503288	80502	4	4
36503252	40480160	2	2
42848776	1521369	0	0
44346626	1107830	0	0
44338624	1332418	0	0
45643352	40228230	2	3
44361833	1118084	0	0
45622544	40228214	2	3
45660381	19079524	1	1
45665384	1515774	0	0
45651653	1125315	0	0
45624172	715997	0	0
45705161	1501700	0	0
45689788	1119510	0	0
45708195	1125315	0	0
45693245	1110410	0	0
45703862	1129625	0	0
45693372	1521369	0	0
45786318	1125315	0	0
45786014	723013	0	0
45800979	1129625	0	0
45896136	738818	0	0
45788818	705944	0	0
46295715	1115008	0	0
46300061	19019273	2	3
46290150	40236446	2	3
4155793	4252419	3	4
21000803	1308738	0	0
21001770	1150837	2	3
21601077	964261	5	6
35508363	1129625	0	0
36200000	4059173	3	10
36702253	375671	8	10
36503287	4218389	2	2
42848776	1549786	0	0
44346613	1107830	0	0
44338636	914335	0	0
45643352	40228214	2	3
44361755	1310149	0	0
45628704	1332419	2	3
45632538	19079524	1	1
45665421	1308738	0	0
45651556	1125315	0	0
45624263	1310149	0	0
45705389	1124300	0	0
45690141	1119510	0	0
45708163	1125315	0	0
45693198	1124300	0	0
45702251	1129625	0	0
45693372	1549786	0	0
45786569	1125315	0	0
45786029	1124957	0	0
45799752	1129625	0	0
45896031	738818	0	0
45788879	1174888	0	0
46295492	1115008	0	0
46300002	19008572	2	3
46290275	1551192	2	3
4130851	4134304	3	4
21000803	1396131	0	0
21001770	40223821	2	3
21600127	40243436	5	6
35508364	1000560	0	0
36200000	4142905	3	10
36402193	4144583	8	8
36718119	381316	2	2
42808617	1125315	0	0
44346392	1107830	0	0
44338637	791967	0	0
45646145	19078461	2	3
44361890	1729720	0	0
45649974	19078461	2	3
45632591	46275916	1	1
45665422	1361711	0	0
45651270	1125315	0	0
45624276	723013	0	0
45705165	1124957	0	0
45690249	1119510	0	0
45707913	1125315	0	0
45693206	1115008	0	0
45702242	1129625	0	0
45693564	1153428	0	0
45786256	1125315	0	0
45786054	1713332	0	0
45798171	1129625	0	0
45895997	738818	0	0
46296837	1192710	0	0
46295756	723013	0	0
46300174	19019273	2	3
46290237	40231925	2	3
4134148	4117038	3	4
21000717	1551099	0	0
21001770	40223834	2	3
21503645	1177480	5	5
35508300	1192710	0	0
36102154	4112343	3	8
36516772	78272	7	8
36718119	380378	2	2
42808624	1129625	0	0
44346527	1545958	0	0
44341152	1129625	0	0
45640380	19078461	2	3
44361891	1343916	0	0
45621171	40228214	2	3
45636329	46275916	1	1
45665163	920293	0	0
45651442	1125315	0	0
45624236	1124957	0	0
45705360	738818	0	0
45690055	1119510	0	0
45708140	1125315	0	0
45692969	1332418	0	0
45702287	1129625	0	0
45693524	975125	0	0
45786454	1125315	0	0
45786054	1759842	0	0
45798173	1129625	0	0
45896807	738818	0	0
46296845	1551099	0	0
46295712	1118084	0	0
46300340	40229134	2	3
46290294	40232448	2	3
4162054	4197460	3	4
21000819	1551099	0	0
21000571	1551192	2	3
21503645	1125315	5	5
35508210	1738521	0	0
36102149	4116491	3	8
36503290	78272	7	7
40181754	40221415	2	2
42808624	1177480	0	0
44346531	933724	0	0
44341207	738818	0	0
44337454	1332419	2	3
44361896	1124300	0	0
45662642	19075601	2	3
45647677	19079524	1	1
45665430	1308738	0	0
45651561	1125315	0	0
45624244	975125	0	0
45705335	967823	0	0
45690178	1119510	0	0
45708322	1125315	0	0
45693131	1501700	0	0
45702373	1129625	0	0
45693477	1153428	0	0
45786459	1125315	0	0
45786056	967823	0	0
45798126	1129625	0	0
45804357	738818	0	0
46296758	1305058	0	0
46295687	975125	0	0
46300532	1154615	2	3
46290105	40228230	2	3
4044900	4047491	3	4
21000758	967823	0	0
21000049	46233988	2	3
21503645	19010482	5	5
35508267	1125315	0	0
36102149	4112343	3	8
36702253	381316	6	7
40057995	19127904	2	2
42821356	1153428	0	0
44346502	1115008	0	0
44341157	975125	0	0
45662341	19078461	2	3
44361897	1589505	0	0
45643483	19075601	2	3
45648191	19079524	1	1
45665249	1332418	0	0
45651689	1125315	0	0
45624391	1343916	0	0
45705453	914335	0	0
45690244	1119510	0	0
45708300	1125315	0	0
45693132	1115008	0	0
45702447	1129625	0	0
45693483	1149196	0	0
45786467	1125315	0	0
45786036	1174888	0	0
45795402	1129625	0	0
45796287	738818	0	0
46296761	1367571	0	0
46295949	1713332	0	0
46300323	19019273	2	3
46290212	1545959	2	3
4042140	317009	3	4
21000760	967823	0	0
21000049	46233710	2	3
21503645	1305058	5	5
35508302	1738521	0	0
36102149	4294548	3	8
36703458	4043241	6	6
37522376	4202451	2	2
42822200	1119510	0	0
44346754	1115008	0	0
44341158	1177480	0	0
45640340	19078461	2	3
44361900	1115008	0	0
45643562	40228214	2	3
45663669	19079524	1	1
45665371	738818	0	0
45651569	1125315	0	0
45624392	1192710	0	0
45705549	1149196	0	0
45690365	1119510	0	0
45705215	1125315	0	0
45693134	1115008	0	0
45702500	1129625	0	0
45693510	19003953	0	0
45786468	1125315	0	0
45786068	1309944	0	0
45795564	1129625	0	0
45797162	738818	0	0
46296705	914335	0	0
46295473	1717327	0	0
46296306	19075001	2	3
46292015	40232448	2	3
4180627	4218408	3	4
21000766	1125443	0	0
21001463	1332419	2	3
21503645	1118084	5	5
35508279	1125315	0	0
36100000	372328	3	3
36516728	4134304	6	6
37202317	255848	2	2
42822200	1125315	0	0
44346574	1738521	0	0
44359842	1129625	0	0
45622053	19078461	2	3
44361727	1149380	0	0
45637968	40228214	2	3
45629888	19079524	1	1
45667423	1107830	0	0
45648185	1125315	0	0
45668197	708298	0	0
45705553	1149196	0	0
45690192	1119510	0	0
45705206	1125315	0	0
45693226	914335	0	0
45702435	1129625	0	0
45693566	1308738	0	0
45784392	1125315	0	0
45786064	1192710	0	0
45796940	1129625	0	0
45796524	738818	0	0
46296548	1149196	0	0
46295421	1768849	0	0
46296315	40232448	2	3
46291545	1115171	2	3
4043161	44805732	3	4
21000874	1551099	0	0
21000591	1551192	2	3
21503645	1124957	5	5
35508279	1119510	0	0
36100000	255848	3	3
36426668	1305058	0	0
37202317	4283893	2	2
42821742	1125315	0	0
44346536	1729720	0	0
44359562	1124300	0	0
45640406	19078461	2	3
44361731	1551099	0	0
45656371	40228214	2	3
45629888	46275916	1	1
45667429	738818	0	0
45648304	1125315	0	0
45668312	1153428	0	0
45705384	1501700	0	0
45690194	1119510	0	0
45705165	1125315	0	0
45693229	1000560	0	0
45702436	1129625	0	0
45693574	1115008	0	0
45784457	1125315	0	0
45786065	1124300	0	0
45797069	1129625	0	0
45796535	738818	0	0
46295107	1326303	0	0
46295264	1310149	0	0
46318372	40243436	2	3
46292005	46233710	2	3
4043023	4216130	3	4
21000819	975125	0	0
21000538	1551192	2	3
21503645	1102527	5	5
35508280	1125315	0	0
36100000	195588	3	3
36422232	19059528	0	0
40782521	3010813	2	2
42819679	1177480	0	0
44346543	1729720	0	0
44359661	1177480	0	0
45643401	19078461	2	3
44361733	1149380	0	0
45655909	19079524	2	3
45652131	19079524	1	1
45667354	1115008	0	0
45649239	1125315	0	0
45668354	975125	0	0
45705385	1115008	0	0
45690378	1119510	0	0
45705360	1125315	0	0
45693291	1115008	0	0
45699422	1129625	0	0
45693577	1717327	0	0
45784466	1125315	0	0
45786067	1501700	0	0
45795713	1129625	0	0
45791405	738818	0	0
46295146	1557272	0	0
46296103	975125	0	0
46318402	40232448	2	3
46241955	40229134	2	3
4040396	4117038	3	4
21000806	1308738	0	0
21001459	1332419	2	3
21503645	1154029	5	5
35508280	1119510	0	0
36100000	440448	3	3
36428428	1137529	0	0
36703452	381316	2	2
42819004	1125315	0	0
44346778	1713332	0	0
44359606	1149380	0	0
45664799	19078461	2	3
44361742	967823	0	0
45659435	40228214	2	3
45658342	19079524	1	1
45667440	1500211	0	0
45649210	1125315	0	0
45668200	1124300	0	0
45705388	1149196	0	0
45686795	1119510	0	0
45705551	1125315	0	0
45694754	1115008	0	0
45699346	1129625	0	0
45693543	1192710	0	0
45784447	1125315	0	0
45786726	1149196	0	0
45795718	1129625	0	0
45791547	738818	0	0
46295039	1343916	0	0
46295728	1149196	0	0
46318807	40236824	2	3
46241956	19078461	2	3
4043025	4047491	3	4
21000806	1396131	0	0
21001456	19075601	2	3
21503645	1129625	5	5
35508280	738818	0	0
36100000	4283893	3	3
36428442	1539403	0	0
37203741	261325	2	2
42822308	1177480	0	0
44346142	1149196	0	0
44359608	791967	0	0
44358502	19078461	2	3
44361765	1149380	0	0
45622769	40228214	2	3
45658419	19079524	1	1
45667443	1589505	0	0
45648361	1125315	0	0
45668442	1361711	0	0
45705396	975125	0	0
45688409	1119510	0	0
45705554	1125315	0	0
45694627	1539403	0	0
45699488	1129625	0	0
45693587	1501700	0	0
45784450	1125315	0	0
45786369	1728416	0	0
45793005	1129625	0	0
46298495	738818	0	0
46295113	933724	0	0
46295933	1521369	0	0
46318452	40229134	2	3
46241965	40229134	2	3
4040400	4057420	3	4
21000804	1308738	0	0
21000010	19073188	2	3
21503645	1115008	5	5
35508285	1125315	0	0
35600000	4280726	3	3
36426127	1501700	0	0
37203741	4051466	2	2
42820242	1149196	0	0
44346548	1512674	0	0
44359716	975125	0	0
45634240	19078461	2	3
44361810	1310149	0	0
45640845	40228214	2	3
45660276	19079524	1	1
45667443	1549786	0	0
45648438	1125315	0	0
45668262	1192710	0	0
45705518	1107830	0	0
45688411	1119510	0	0
45705341	1125315	0	0
45694366	1759842	0	0
45699490	1129625	0	0
45693408	1149196	0	0
45784479	1125315	0	0
45786677	19010482	0	0
45792926	1129625	0	0
46298782	738818	0	0
46295116	1000560	0	0
46295934	1124957	0	0
46318767	19008572	2	3
46241968	40229134	2	3
4050571	40492359	3	3
21000806	1595799	0	0
21000010	19129655	2	3
21503160	1174888	6	6
35508285	1112807	0	0
35300000	441267	3	3
36424292	1129625	0	0
37203747	255848	2	2
42820392	1177480	0	0
44346548	19127890	0	0
44359724	1177480	0	0
45628354	19078461	2	3
44361767	1778162	0	0
45621245	1332419	2	3
45654690	19079524	1	1
45667275	738818	0	0
45648455	1125315	0	0
45668269	738818	0	0
45705350	1107830	0	0
45688696	1119510	0	0
45705329	1125315	0	0
45694366	1713332	0	0
45699594	1129625	0	0
45693326	1149196	0	0
45782313	1125315	0	0
45786539	1000560	0	0
45792839	1129625	0	0
46298939	738818	0	0
46295071	1107830	0	0
46296037	738818	0	0
46318699	19133905	2	3
46242016	40229134	2	3
4042478	4242997	3	3
21000860	1367571	0	0
21000010	19073183	2	3
21503160	914335	6	6
35508291	715997	0	0
21603282	40169281	3	3
36423716	1759842	0	0
37202312	261325	2	2
42819169	1149196	0	0
44346548	1549786	0	0
44359823	1332418	0	0
45622228	40223768	2	3
44361850	1149380	0	0
45662516	40228214	2	3
45632711	19079524	1	1
45667452	1361711	0	0
45648316	1125315	0	0
45668391	738818	0	0
45705354	1149196	0	0
45688697	1119510	0	0
45705421	1125315	0	0
45694369	1713332	0	0
45696019	1129625	0	0
45693417	933724	0	0
45782315	1125315	0	0
45786682	1192710	0	0
45792956	1129625	0	0
46290400	738818	0	0
46295173	1115008	0	0
46295667	1149196	0	0
46318725	40232448	2	3
46242020	19019273	2	3
4094683	4142905	3	3
21000825	975125	0	0
21001430	19059056	2	3
21503160	1107830	6	6
35509012	1153428	0	0
35205038	4051466	3	3
36426182	1589505	0	0
37203744	255848	2	2
42819196	1107830	0	0
44346685	738818	0	0
44359725	738818	0	0
45628522	19078461	2	3
44361877	1308738	0	0
45631930	19079524	2	3
45652012	19079524	1	1
45662805	1326303	0	0
45648513	1125315	0	0
45668370	1192710	0	0
45705166	723013	0	0
45688730	1119510	0	0
45705423	1125315	0	0
45694369	1759842	0	0
45696061	1129625	0	0
45693484	1343916	0	0
45782320	1125315	0	0
45786381	1000560	0	0
45793119	1129625	0	0
46290686	738818	0	0
46295073	1107830	0	0
46296244	1000560	0	0
46313165	1115171	2	3
46242024	40232448	2	3
4105886	4084167	3	3
21000830	1551099	0	0
21001454	19075601	2	3
21503160	1153428	6	6
35509015	1177480	0	0
35204998	321042	3	3
36155942	1115171	2	3
37003664	4116491	2	2
42820405	1125315	0	0
44346511	1124300	0	0
44359984	1112807	0	0
45658457	19078461	2	3
44361908	1000560	0	0
45621277	40228214	2	3
45632600	19079524	1	1
45662813	1310149	0	0
45648322	1125315	0	0
45668373	738818	0	0
45705343	1154343	0	0
45687103	1119510	0	0
45705430	1125315	0	0
45694372	975125	0	0
45696129	1129625	0	0
45693495	1149196	0	0
45782329	1125315	0	0
45786384	723013	0	0
45793215	1129625	0	0
46290743	738818	0	0
46295094	1107830	0	0
46295485	975125	0	0
46312531	19019273	2	3
46242178	42707627	2	3
4134184	4134304	3	3
21000873	975125	0	0
21000548	19007333	2	3
21503160	1192710	6	6
35508709	1125315	0	0
21602098	975125	3	3
36156096	19133905	2	3
37503938	44805732	2	2
42848796	1512674	0	0
44346617	738818	0	0
44360001	1192710	0	0
45631270	1545959	2	3
44361909	1118084	0	0
45631574	40228214	2	3
45626925	46275916	1	1
45662455	1539403	0	0
45648630	1125315	0	0
45668380	1326303	0	0
45705323	1154343	0	0
45687173	1119510	0	0
45705434	1125315	0	0
45694832	1759842	0	0
45696159	1129625	0	0
45693422	1343916	0	0
45782222	1125315	0	0
45786133	1112807	0	0
45792127	1129625	0	0
46291113	738818	0	0
46295178	1192710	0	0
46295417	1149196	0	0
46312823	19059056	2	3
46242319	19008572	2	3
4189544	4015189	3	3
21000825	1551099	0	0
21001775	40229134	2	3
21503146	19023398	6	7
35508390	1125315	0	0
36102971	258780	3	3
36156026	1127433	2	3
37503938	4186930	2	2
42848796	1549786	0	0
44346665	1112807	0	0
44359573	1343916	0	0
45659239	19078461	2	3
44361910	1000560	0	0
45649962	19078461	2	3
45638826	46275916	1	1
45662783	740275	0	0
45648631	1125315	0	0
45668559	1000560	0	0
45705327	1149196	0	0
45684127	1119510	0	0
45705746	1125315	0	0
45694832	1713332	0	0
45696495	1129625	0	0
45693427	1174888	0	0
45782524	1125315	0	0
45786139	19002770	0	0
45790323	1129625	0	0
46242354	738818	0	0
46295385	967823	0	0
46296250	1154029	0	0
46312942	40162522	2	3
46242234	40229134	2	3
4193169	4112343	3	3
19132304	19132304	0	0
21001775	43012036	2	3
21500541	40232448	6	7
35508454	1119510	0	0
21604389	740275	3	3
36156044	1127433	2	3
36703484	378419	2	2
42848815	1129625	0	0
44346667	1174888	0	0
44359575	1332418	0	0
45625399	40223768	2	3
44361816	1729720	0	0
45649995	19079524	2	3
45654133	19079524	1	1
45662788	1332418	0	0
45648643	1125315	0	0
45668294	1713332	0	0
45705331	1307863	0	0
45684174	1119510	0	0
45705568	1125315	0	0
45694945	1110410	0	0
45696323	1129625	0	0
45693468	1521369	0	0
45782502	1125315	0	0
45786140	1500211	0	0
45790707	1129625	0	0
46242356	738818	0	0
46295404	914335	0	0
46295682	1174888	0	0
46313096	1551192	2	3
46242182	40229134	2	3
4117301	4107731	3	3
19133679	19133679	0	0
21000544	19007333	2	3
21503444	19079524	6	7
35508211	1125315	0	0
21604069	19003953	3	3
36156140	19073183	2	3
37396230	4024289	2	2
42848815	1119510	0	0
44346668	1177480	0	0
44360007	1149380	0	0
45628629	19079524	2	3
44361883	705944	0	0
45640813	1539411	2	3
45639363	46275916	1	1
45662898	19127890	0	0
45648553	1125315	0	0
45668296	933724	0	0
45705333	1738521	0	0
45684213	1119510	0	0
45705510	1125315	0	0
45694393	1759842	0	0
45696329	1129625	0	0
45693601	1154029	0	0
45782528	1125315	0	0
45786143	19127890	0	0
45790531	1129625	0	0
46240237	738818	0	0
46295408	1115008	0	0
46296184	1115008	0	0
46313043	1127433	2	3
46242192	19008572	2	3
4116777	260139	3	3
21000230	1738521	0	0
21000038	1551192	2	3
21503444	19077344	6	7
35508376	1125315	0	0
21604181	753626	3	3
36156186	19073188	2	3
37396230	4252419	2	2
42848925	1129625	0	0
44346818	701322	0	0
44359577	1153428	0	0
45637509	1332419	2	3
44361963	1115008	0	0
45649610	40228214	2	3
45657708	46275916	1	1
45662898	1549786	0	0
45648714	1125315	0	0
45668398	1501700	0	0
45705414	1305058	0	0
45684217	1119510	0	0
45705734	1125315	0	0
45694859	920293	0	0
45696532	1129625	0	0
45693604	1768849	0	0
45782283	1125315	0	0
45786143	1549786	0	0
45790471	1129625	0	0
45798493	1177480	0	0
46295413	967823	0	0
46296193	1305058	0	0
46312733	40174880	2	3
46242198	40228214	2	3
4134174	4134304	3	3
21000260	1738521	0	0
21000009	46233710	2	3
21503645	19019979	7	8
35508483	1115008	0	0
21604181	19016749	3	3
36155991	46275916	2	3
37503922	4330583	2	2
42848925	1119510	0	0
44346595	705944	0	0
44359583	1549786	0	0
45621158	19079524	2	3
44361937	715997	0	0
45653416	19078461	2	3
45657233	46275916	1	1
45662831	1154343	0	0
45648658	1125315	0	0
45668446	1149196	0	0
45705305	1332418	0	0
45654991	1125315	0	0
45705664	1125315	0	0
45694864	1548195	0	0
45693232	1129625	0	0
45693743	1326303	0	0
45782565	1125315	0	0
45786143	1589505	0	0
45790607	1129625	0	0
45798460	1177480	0	0
46295277	1713332	0	0
46296195	975125	0	0
46313032	40163554	2	3
46242309	40229134	2	3
4050747	4134304	3	3
21000260	1746114	0	0
21000009	46233988	2	3
21503645	19133768	7	8
35508488	1125315	0	0
36217214	19127922	3	4
36156196	19126352	2	3
37503940	4117038	2	2
42848925	1125315	0	0
44346758	1124300	0	0
44359583	19127890	0	0
44351937	1332419	2	3
44361972	1738521	0	0
45637993	40223768	2	3
45657118	46275916	1	1
45662608	1768849	0	0
45645345	1125315	0	0
45668399	1551099	0	0
45705521	1322184	0	0
45655070	1125315	0	0
45702004	1125315	0	0
45694891	1107830	0	0
45693126	1129625	0	0
45693958	975125	0	0
45782567	1125315	0	0
45786176	1149196	0	0
45787676	1129625	0	0
45798614	1177480	0	0
46295193	1192710	0	0
46295588	1729720	0	0
46312929	40223834	2	3
46241988	40229134	2	3
4170143	40481087	3	3
21000259	1738521	0	0
21000584	40174880	2	3
21503645	40165015	7	8
35508488	1119510	0	0
36102149	198199	2	7
36156200	19078461	2	3
37202310	441267	2	2
42848992	1112807	0	0
44346760	1149380	0	0
44359583	1515774	0	0
45646193	1539411	2	3
44361928	1149196	0	0
45646756	40223768	2	3
45657438	46275916	1	1
45662913	1549786	0	0
45645145	1125315	0	0
45668448	1557272	0	0
45705622	1545958	0	0
45655109	1125315	0	0
45702005	1125315	0	0
45693313	738818	0	0
45693231	1129625	0	0
45693440	1310149	0	0
45782586	1125315	0	0
45786197	975125	0	0
45787624	1129625	0	0
45798553	1177480	0	0
46295198	933724	0	0
46296417	738818	0	0
46313079	40162522	2	3
46242325	19059056	2	3
4134134	4066995	3	3
21000249	1728416	0	0
21000578	40174880	2	3
21503645	19059056	7	8
35508488	738818	0	0
4041262	4330583	2	6
36156204	40232448	2	3
37202310	317009	2	2
42848992	1125315	0	0
44346802	1343916	0	0
44359693	1713332	0	0
45658886	1332419	2	3
44361996	723013	0	0
45664958	40223768	2	3
45644836	46275916	1	1
45662913	19127890	0	0
45645238	1125315	0	0
45668439	1713332	0	0
45705625	1107830	0	0
45654785	1125315	0	0
45701894	1125315	0	0
45693395	1153428	0	0
45693298	1129625	0	0
45693589	1551099	0	0
45782589	1125315	0	0
45786206	1713332	0	0
45787792	1129625	0	0
45798690	1177480	0	0
46295210	975125	0	0
46296441	1310149	0	0
46307734	40236824	2	3
46242146	19133873	2	3
4134134	4001336	3	3
21000250	1728416	0	0
21001385	1713671	2	3
21503645	40231925	7	8
35508489	1129625	0	0
36103041	40481087	2	6
36156604	1127433	2	3
37003657	195588	2	2
42848992	1129625	0	0
44346518	1112807	0	0
44360067	1549786	0	0
45624981	40223768	2	3
44361942	1738521	0	0
45641211	19078461	2	3
45641824	46275916	1	1
45662913	1512674	0	0
45645258	1125315	0	0
45668381	1107830	0	0
45705603	1153428	0	0
45655118	1125315	0	0
45702091	1125315	0	0
45693398	1124300	0	0
45690317	1129625	0	0
45693616	1192710	0	0
45782590	1125315	0	0
45786102	1545958	0	0
45789261	1129625	0	0
45793370	1177480	0	0
46295213	1000560	0	0
46295874	791967	0	0
46308216	19008572	2	3
46242257	1127078	2	3
4043174	4336464	3	3
21000251	1728416	0	0
21001385	19074841	2	3
21600001	35605482	5	7
21604256	1110410	0	0
36102144	28060	2	6
36156592	19073183	2	3
37108852	4174876	2	2
42849011	1119510	0	0
44346618	1713332	0	0
44360067	19127890	0	0
45652430	40174880	2	3
44362057	1332418	0	0
45659352	19078461	2	3
45641977	46275916	1	1
45662927	1115008	0	0
45645434	1125315	0	0
45668678	1115008	0	0
45705608	1149380	0	0
45655290	1125315	0	0
45702089	1125315	0	0
45693399	1192710	0	0
45690397	1129625	0	0
45693594	1149196	0	0
45782596	1125315	0	0
45786108	1124300	0	0
45789401	1129625	0	0
45793386	1177480	0	0
46295383	705944	0	0
46296431	19059528	0	0
46308228	40162522	2	3
46242200	19133905	2	3
4134439	375671	3	3
21000252	1728416	0	0
21000012	19129655	2	3
21600001	40243436	6	7
21604260	1124957	0	0
36102144	433125	2	6
36156612	1594382	2	3
40782562	3019550	2	2
42849011	1125315	0	0
44346829	738818	0	0
44360067	1512674	0	0
45662023	40174880	2	3
44362208	1545958	0	0
45646785	19078461	2	3
45638751	46275916	1	1
45662957	1307863	0	0
45645556	1125315	0	0
45668427	1192710	0	0
45705611	967823	0	0
45654961	1125315	0	0
45701822	1125315	0	0
45693402	1308738	0	0
45690341	1129625	0	0
45693801	1738521	0	0
45782543	1125315	0	0
45786177	791967	0	0
45787896	1129625	0	0
45793227	1177480	0	0
46295241	1545958	0	0
46295611	1549786	0	0
46308286	920300	2	3
46242288	40229134	2	3
4134439	378001	3	3
21000253	1728416	0	0
21001750	46233988	2	3
21600001	967823	4	4
21603929	1305058	0	0
4180941	4238715	2	5
36156602	19133905	2	3
40782472	3001247	2	2
42849011	1129625	0	0
44346282	1112807	0	0
44359826	975125	0	0
45625348	19078461	2	3
44362168	1115008	0	0
45659584	40223768	2	3
45638857	46275916	1	1
45662965	1149196	0	0
45645563	1125315	0	0
45668489	1332418	0	0
45705313	975125	0	0
45655198	1125315	0	0
45701824	1125315	0	0
45693301	975125	0	0
45690326	1129625	0	0
45693807	1107830	0	0
45782483	1125315	0	0
45786184	1174888	0	0
45786325	1129625	0	0
45793266	1177480	0	0
46295329	1107830	0	0
46295611	1595799	0	0
46307694	1115171	2	3
45893688	46233710	2	3
4161193	28060	3	3
21000254	1728416	0	0
21001750	19073183	2	3
21601237	1545958	4	4
21604049	1177480	0	0
21604390	19074679	2	5
35909452	198809	2	2
40782476	3000876	2	2
42822312	1125315	0	0
44346820	1124957	0	0
44359828	1107830	0	0
44778278	40174880	2	3
44362173	1589505	0	0
45643671	19078461	2	3
45638854	46275916	1	1
45662841	1717327	0	0
45645126	1125315	0	0
45668585	1713332	0	0
45705492	1548195	0	0
45700755	1125315	0	0
45702197	1125315	0	0
45693337	1738521	0	0
45690495	1129625	0	0
45693784	1149196	0	0
45782484	1125315	0	0
45786320	1589505	0	0
45786233	1129625	0	0
45794723	1177480	0	0
46295431	1332418	0	0
46295611	1521369	0	0
46308117	40162522	2	3
45893688	46233988	2	3
4161193	433125	3	3
21000255	1728416	0	0
21000242	46233710	2	3
21601237	1309944	4	4
21602820	1717327	0	0
21604752	19123231	2	5
35707601	4285898	2	2
40782579	3006923	2	2
42822431	1119510	0	0
44346821	1153428	0	0
44359796	1307863	0	0
45659110	1539411	2	3
44362173	1549786	0	0
45630830	1539411	2	3
45638961	46275916	1	1
45662969	1124957	0	0
45645463	1125315	0	0
45668458	738818	0	0
45705613	1309944	0	0
45700900	1125315	0	0
45701852	1125315	0	0
45693563	738818	0	0
45690556	1129625	0	0
45693812	708298	0	0
45782489	1125315	0	0
45786320	1549786	0	0
45786303	1129625	0	0
45794686	1177480	0	0
46295441	1551099	0	0
46295703	1729720	0	0
46308095	19019273	2	3
45893649	40232448	2	3
4180170	28060	3	3
21000256	1728416	0	0
21000923	19076374	2	3
21601237	46275916	6	7
21601856	1539403	0	0
21604752	40236446	2	5
36211103	4230399	2	2
40782935	3049273	2	2
42804716	1361711	0	0
44346822	1124300	0	0
44359799	975125	0	0
45652616	1545959	2	3
44362064	738818	0	0
44362635	1125315	0	0
45636880	46275916	1	1
45662934	967823	0	0
45645133	1125315	0	0
45668550	1545958	0	0
45705685	1332418	0	0
45701485	1125315	0	0
45702044	1125315	0	0
45693629	1367571	0	0
45690501	1129625	0	0
45693907	1149380	0	0
45782673	1125315	0	0
45786081	975125	0	0
45786413	1129625	0	0
45794816	1177480	0	0
46295623	975125	0	0
46291142	1192710	0	0
46308088	19077344	2	3
45893768	19019273	2	3
4180170	255848	3	3
21000257	1728416	0	0
21001773	40228214	2	3
21601237	40171902	5	5
21601860	1545958	0	0
36102149	260139	2	4
36211267	4146173	2	2
40782883	3008598	2	2
42805045	1125315	0	0
44346661	1149196	0	0
44360160	723013	0	0
45634819	1545959	2	3
44361945	967823	0	0
44362738	1125315	0	0
45637158	46275916	1	1
45662947	1322184	0	0
45645395	1125315	0	0
45668524	1125443	0	0
45705491	715997	0	0
45701604	1125315	0	0
45702068	1125315	0	0
45693357	975125	0	0
45690428	1129625	0	0
45693909	1738521	0	0
45782606	1125315	0	0
45786287	1115008	0	0
46296864	1129625	0	0
45787979	1177480	0	0
46295628	1500211	0	0
46291187	1107830	0	0
46308342	1115171	2	3
45893744	40236824	2	3
4180170	40481087	3	3
21000258	1728416	0	0
21001772	19112599	2	3
21600959	964261	6	7
21601423	1305058	0	0
4130851	4146173	2	4
36211224	375671	2	2
40760140	3000963	2	2
42805045	1124957	0	0
44346298	1177480	0	0
44359864	1713332	0	0
45628607	1539411	2	3
44362217	967823	0	0
44360434	1125315	0	0
45631025	46275916	1	1
45662708	1539403	0	0
45645403	1125315	0	0
45668614	1107830	0	0
45705543	1551099	0	0
45701640	1125315	0	0
45702129	1125315	0	0
45693500	1519936	0	0
45687158	1129625	0	0
45693664	1738521	0	0
45782607	1125315	0	0
46292407	701322	0	0
46296996	1129625	0	0
45787961	1177480	0	0
46295242	1322184	0	0
46290800	1595799	0	0
46302576	40231925	2	3
45893839	1127433	2	3
4180170	257012	3	3
19133768	19133768	0	0
21001772	43012036	2	3
21600959	1310149	4	4
35406426	372328	0	0
4130852	4152936	2	4
36211224	378001	2	2
40760141	3000963	2	2
42805052	1112807	0	0
44346404	1115008	0	0
44359864	1759842	0	0
44344196	1539411	2	3
45655900	1310149	0	0
44360523	1125315	0	0
45626851	19079524	1	1
45662830	715997	0	0
45645406	1125315	0	0
45668760	1153428	0	0
45705545	723013	0	0
45701621	1125315	0	0
45702139	1125315	0	0
45693507	1310149	0	0
45687393	1129625	0	0
45693833	1361711	0	0
45782618	1125315	0	0
46292483	1124957	0	0
46297029	1129625	0	0
45788113	1177480	0	0
46295247	1738521	0	0
46290800	1549786	0	0
46302816	40229134	2	3
45893952	40174880	2	3
4171379	4116491	3	3
19133873	19133873	0	0
21001745	1713671	2	3
21600959	1396131	4	4
35406429	372328	0	0
36213602	19128263	2	3
36211259	4149245	2	2
40480513	439777	2	2
42805054	1119510	0	0
44346797	1738521	0	0
44359987	1149380	0	0
45641020	1539411	2	3
45655903	1343916	0	0
44360481	1125315	0	0
45623761	46275916	1	1
45662850	738818	0	0
45645510	1125315	0	0
45668632	1000560	0	0
45705409	967823	0	0
45701749	1125315	0	0
45702159	1125315	0	0
45693407	1332418	0	0
45687570	1129625	0	0
45693920	1310149	0	0
45782675	1125315	0	0
46292486	1112807	0	0
46297035	1129625	0	0
46294316	1177480	0	0
46295163	1153428	0	0
46290800	1521369	0	0
46302823	1551192	2	3
45894165	19019273	2	3
4049890	4107731	3	3
19133905	19133905	0	0
21000967	19076374	2	3
21600959	1367571	4	4
21603619	975125	0	0
36213602	19128022	2	3
36211065	40480160	2	2
40181757	40221415	2	2
42805124	1119510	0	0
44346813	1153428	0	0
44359834	933724	0	0
45620869	1539411	2	3
45655868	1110410	0	0
44360482	1125315	0	0
45667600	19079524	1	1
45662856	1115008	0	0
45646221	1125315	0	0
45668634	1153428	0	0
45705505	791967	0	0
45701706	1125315	0	0
45702026	1125315	0	0
45690296	701322	0	0
45687376	1129625	0	0
45691568	1551099	0	0
45702582	1125315	0	0
46292490	1332418	0	0
46297077	1129625	0	0
46294206	1177480	0	0
46295356	975125	0	0
46290904	1153428	0	0
46302693	40232448	2	3
45893897	42707627	2	3
4042501	4230399	3	3
19134077	19134077	0	0
21001382	19133873	2	3
21600959	1112807	4	4
21603448	1129625	0	0
4130851	78272	2	3
36211065	4278672	2	2
40181781	40221415	2	2
42805040	1713332	0	0
44346606	975125	0	0
44359837	1129625	0	0
45621220	1539411	2	3
45655873	1738521	0	0
44360555	1125315	0	0
45667603	46275916	1	1
45662937	1332418	0	0
45642367	1125315	0	0
45668685	1501700	0	0
45705480	1332418	0	0
45701713	1125315	0	0
45699021	1125315	0	0
45690457	1118084	0	0
45687686	1129625	0	0
45691446	1124300	0	0
45702589	1125315	0	0
46292421	1115008	0	0
46297113	1129625	0	0
46294394	1177480	0	0
46295637	1192710	0	0
46290981	1738521	0	0
46302772	19008572	2	3
45893843	1115171	2	3
4181195	4301346	3	3
19019273	19019273	0	0
21000919	19076374	2	3
21600959	1308738	4	4
21602106	975125	0	0
36213604	19128009	2	3
36211065	4066995	2	2
40181783	40221415	2	2
42805040	1759842	0	0
44346722	967823	0	0
44359991	1713332	0	0
45665016	1539411	2	3
45655875	1361711	0	0
44360560	1125315	0	0
45667730	19079524	1	1
45662973	1549786	0	0
45642315	1125315	0	0
45668409	975125	0	0
45705575	708298	0	0
45701795	1125315	0	0
45699152	1125315	0	0
45690284	1124300	0	0
45687303	1129625	0	0
45691450	1713332	0	0
45702592	1125315	0	0
46292576	1112807	0	0
46297229	1129625	0	0
46294543	1177480	0	0
46244425	1107830	0	0
46244910	1713332	0	0
46303280	19078461	2	3
45893831	1115171	2	3
4043346	255848	3	3
4314290	4314290	0	0
21000526	19007333	2	3
21600959	967823	4	4
21602115	975125	0	0
36213603	19128009	2	3
36211065	4237458	2	2
40062921	19128065	2	2
42805042	1738521	0	0
44346723	1713332	0	0
44360014	1332418	0	0
45622574	1539411	2	3
45655792	1124957	0	0
44360569	1125315	0	0
45668214	46275916	1	1
45662973	1521369	0	0
45642357	1125315	0	0
45668493	1124300	0	0
45705510	738818	0	0
45701808	1125315	0	0
45699204	1125315	0	0
45690285	1548195	0	0
45687690	1129625	0	0
45691466	1589505	0	0
45702533	1125315	0	0
46292576	1192710	0	0
46297525	1129625	0	0
46243853	1177480	0	0
46244285	1539403	0	0
46244914	1000560	0	0
46303214	40236824	2	3
45801715	1154615	2	3
4043346	260139	3	3
4275113	4275113	0	0
21000565	19007333	2	3
21600959	19075601	4	7
35507306	1125315	0	0
21604086	42707627	2	3
36211065	4048695	2	2
36718317	375671	2	2
42805129	1713332	0	0
44346738	1115008	0	0
44359622	1177480	0	0
45649773	19079524	1	1
45655829	1153428	0	0
44360534	1125315	0	0
45665592	19079524	1	1
45662973	19127890	0	0
45642358	1125315	0	0
45668496	1115008	0	0
45705513	1107830	0	0
45701790	1125315	0	0
45699162	1125315	0	0
45690287	1149196	0	0
45685475	1129625	0	0
45691466	1549786	0	0
45702633	1125315	0	0
46292635	1332418	0	0
46297155	1129625	0	0
46243775	1177480	0	0
46244475	1548195	0	0
46244836	1115008	0	0
46300425	19008572	2	3
45801767	1115171	2	3
4082416	372328	3	3
4278672	4278672	0	0
21001427	19133873	2	3
21600959	40163554	4	7
35507359	1332418	0	0
36156691	46275916	2	3
36211065	4059173	2	2
36718157	4043241	2	2
42805129	1759842	0	0
44348184	1107830	0	0
44359623	1115008	0	0
45649773	46275916	1	1
45655909	967823	0	0
44360547	1125315	0	0
45665855	46275916	1	1
45662946	1000560	0	0
45642370	1125315	0	0
45668497	742185	0	0
45705581	1539403	0	0
45701930	1125315	0	0
45699219	1125315	0	0
45690305	738818	0	0
45684426	1129625	0	0
45690640	1192710	0	0
45702749	1125315	0	0
46292673	1595799	0	0
46293093	1129625	0	0
46244653	1177480	0	0
46244441	1332418	0	0
46244974	1332418	0	0
46300301	40162522	2	3
45801638	19059056	2	3
4040549	4323902	3	3
4029498	4029498	0	0
19003953	42707627	2	3
21502553	46275916	7	8
35507274	1153428	0	0
35506838	19133905	2	3
36211305	4152936	2	2
36718162	4043241	2	2
42804941	1332418	0	0
44348291	1551099	0	0
44359557	1713332	0	0
45625987	19079524	1	1
45655882	708298	0	0
44353470	1125315	0	0
45663505	19079524	1	1
45664641	1545958	0	0
45642454	1125315	0	0
45668587	1310149	0	0
45705708	975125	0	0
45701882	1125315	0	0
45699148	1125315	0	0
45690306	975125	0	0
45684515	1129625	0	0
45690667	1307863	0	0
45702604	1125315	0	0
46292673	1308738	0	0
46293456	1129625	0	0
46244875	1177480	0	0
46244331	1192710	0	0
46244625	1149196	0	0
46300807	1127433	2	3
45801824	1551192	2	3
4040549	4337611	3	3
4094814	4094814	0	0
21001379	19133905	2	3
21500327	40229134	7	8
35507349	1107830	0	0
35506841	19008572	2	3
36211305	4113008	2	2
36718526	380378	2	2
42805156	1332418	0	0
44348297	740275	0	0
44359557	1759842	0	0
45644127	46275916	1	1
45655847	1107830	0	0
44353456	1125315	0	0
45657615	46275916	1	1
45664634	19078219	0	0
45642627	1125315	0	0
45668452	738818	0	0
45705710	1501700	0	0
45701883	1125315	0	0
45699308	1125315	0	0
45690467	1713332	0	0
45684581	1129625	0	0
45690711	1174888	0	0
45702742	1125315	0	0
46292796	1545958	0	0
46239320	1308738	0	0
46244056	1177480	0	0
46244411	1192710	0	0
46244636	738818	0	0
46300429	40162522	2	3
45801809	1127433	2	3
4043028	44783196	3	3
4048695	4048695	0	0
21000033	19129655	2	3
21502620	19075001	7	8
35507412	1154343	0	0
35506941	40162522	2	3
36211305	4109685	2	2
37521054	4198190	2	3
42805010	1124300	0	0
44348302	1177480	0	0
44360136	1115008	0	0
45644127	19079524	1	1
45655915	1124957	0	0
44353460	1125315	0	0
45658004	19079524	1	1
45664553	1115008	0	0
45642749	1125315	0	0
45668415	1154029	0	0
45705759	975125	0	0
45701971	1125315	0	0
45699249	1125315	0	0
45690473	975125	0	0
45681241	1129625	0	0
45690641	1153428	0	0
45702708	1125315	0	0
46292821	1174888	0	0
46239069	1124300	0	0
46244032	1177480	0	0
46244411	1174888	0	0
46244637	1174888	0	0
46300436	920300	2	3
45801854	1115171	2	3
4101796	380378	3	3
4181917	4181917	0	0
21001759	19133905	2	3
21502620	46233710	7	8
35507377	1738521	0	0
35506987	1551192	2	3
36211305	4155034	2	2
37202317	257012	2	3
42805157	967823	0	0
44348307	1112807	0	0
44360071	1115008	0	0
45649553	46275916	1	1
45655947	738818	0	0
44353614	1125315	0	0
45654465	46275916	1	1
45664555	738818	0	0
45642558	1125315	0	0
45668416	1501700	0	0
45702004	738818	0	0
45701932	1125315	0	0
45699352	1125315	0	0
45690307	1192710	0	0
45678100	1129625	0	0
45690723	723013	0	0
45702573	1125315	0	0
46292550	1741122	0	0
46239220	1115008	0	0
46238947	1177480	0	0
46244420	1107830	0	0
46239831	705944	0	0
46300484	19075001	2	3
45802417	19008572	2	3
4162054	4295880	3	3
4174876	4174876	0	0
21001759	19133873	2	3
21502620	19133905	7	8
35507382	1129625	0	0
35506993	40224805	2	3
36211375	4132546	2	2
37202317	28060	2	3
42805167	920293	0	0
44348372	1000560	0	0
44360076	1137529	0	0
45649553	19079524	1	1
45656199	1595799	0	0
44353618	1125315	0	0
45651175	46275916	1	1
45664569	1000560	0	0
45642559	1125315	0	0
45665857	738818	0	0
45702005	1174888	0	0
45701939	1125315	0	0
45699358	1125315	0	0
45690570	708298	0	0
45678104	1129625	0	0
45690728	1361711	0	0
45702675	1125315	0	0
46292550	1746114	0	0
46239200	1521369	0	0
46238985	1177480	0	0
46244482	1192710	0	0
46240037	1545958	0	0
46300598	40229134	2	3
45802604	19078461	2	3
4129747	4117038	3	3
4139681	4139681	0	0
21001751	19073183	2	3
21502620	19074843	7	8
35507382	1125315	0	0
35507205	1115171	2	3
36211375	4156265	2	2
37503958	4337611	2	3
42805008	1110410	0	0
44348438	701322	0	0
44360076	1149380	0	0
44360243	1115171	2	3
45656199	1308738	0	0
44353572	1125315	0	0
45647634	46275916	1	1
45664650	740275	0	0
45642479	1125315	0	0
45665861	1192710	0	0
45702016	1000560	0	0
45698765	1125315	0	0
45699407	1125315	0	0
45690403	1738521	0	0
45678091	1129625	0	0
45690643	1118084	0	0
45702680	1125315	0	0
46292558	1154343	0	0
46239234	1192710	0	0
46239185	1177480	0	0
46244483	1549786	0	0
46240115	1153428	0	0
46300564	19059056	2	3
45799091	40236446	2	3
4095631	317576	3	3
4084167	4084167	0	0
21001752	40229134	2	3
21502620	19074841	7	8
35507318	1738521	0	0
36152544	40236446	2	3
36210656	3013682	2	2
36718588	44782520	2	3
42805009	1110410	0	0
44348443	1115008	0	0
44360080	1129625	0	0
44360303	19133905	2	3
45656121	967823	0	0
44353581	1125315	0	0
45645351	19079524	1	1
45663013	1149196	0	0
45642564	1125315	0	0
45665873	1153428	0	0
45701748	1501700	0	0
45698766	1125315	0	0
45699512	1125315	0	0
45690318	1192710	0	0
45678164	1129625	0	0
45690637	1595799	0	0
45702651	1125315	0	0
46292711	1112807	0	0
46239080	1149196	0	0
45894748	1177480	0	0
46244483	1521369	0	0
46239873	1192710	0	0
46300633	19019273	2	3
45799332	1551192	2	3
4095793	45769019	3	3
4051466	4051466	0	0
19002770	19023423	2	3
21502620	46233988	7	8
35507319	975125	0	0
36152880	40229134	2	3
36210656	3006906	2	2
36427520	19133905	2	3
42805134	1177480	0	0
44348358	738818	0	0
44360015	1501700	0	0
44360306	40229134	2	3
45656029	738818	0	0
44353488	1125315	0	0
45642429	46275916	1	1
45663078	1149196	0	0
45642632	1125315	0	0
45665856	1107830	0	0
45702177	1115008	0	0
45698488	1125315	0	0
45699518	1125315	0	0
45690409	1149196	0	0
45678265	1129625	0	0
45690674	1124957	0	0
45702652	1125315	0	0
46292712	791967	0	0
46239381	1557272	0	0
45894575	1177480	0	0
46244497	1115008	0	0
46239883	1713332	0	0
46300852	40231925	2	3
45799337	40231925	2	3
4180169	198199	3	3
4043241	4043241	0	0
4226263	4112343	2	3
21502620	1713671	7	8
35507320	975125	0	0
36152889	1115171	2	3
35702800	28060	2	2
36427520	19133873	2	3
42805011	1177480	0	0
44342670	1177480	0	0
44360148	1332418	0	0
44360270	40162522	2	3
45656206	1310149	0	0
44353419	1125315	0	0
45638881	46275916	1	1
45663102	1174888	0	0
45642496	1125315	0	0
45666278	1332418	0	0
45701911	1107830	0	0
45698733	1125315	0	0
45695931	1125315	0	0
45690340	1192710	0	0
45678321	1129625	0	0
45690688	975125	0	0
45702653	1125315	0	0
46292997	1102527	0	0
46239067	1118084	0	0
45894443	1177480	0	0
46244434	705944	0	0
46239956	1713332	0	0
46300766	46233988	2	3
45799354	40229134	2	3
4180169	134438	3	3
21000261	1778162	0	0
4288734	261325	2	2
21502620	19129655	7	8
35507321	1119510	0	0
36152462	1551192	2	3
36211391	4296204	2	2
36718338	4029498	2	3
42805014	1501700	0	0
44342675	1549786	0	0
44360154	791967	0	0
44353471	46275916	2	3
45656032	1326303	0	0
44353544	1125315	0	0
45639139	46275916	1	1
45663104	1310149	0	0
45642500	1125315	0	0
45666322	1124300	0	0
45702087	975125	0	0
45698741	1125315	0	0
45695812	1125315	0	0
45690342	1154029	0	0
45678696	1129625	0	0
45690689	1192710	0	0
45702543	1125315	0	0
46292739	1124300	0	0
46239409	19127890	0	0
45801504	1177480	0	0
46244318	1115008	0	0
46240059	1308738	0	0
46301018	40231925	2	3
45799348	19008572	2	3
4044887	44783196	3	3
21000284	1778162	0	0
4223595	40486433	2	2
21502620	46275444	7	8
35507417	1125315	0	0
36152703	19008572	2	3
35809320	4066995	2	2
36718338	44782520	2	3
42805017	1501700	0	0
44342675	1521369	0	0
44360218	1521369	0	0
44353614	1127433	2	3
45656051	723013	0	0
44353697	1125315	0	0
45635790	46275916	1	1
45663016	738818	0	0
45640051	1125315	0	0
45666282	1124957	0	0
45702099	975125	0	0
45698911	1125315	0	0
45695744	1125315	0	0
45690345	19010482	0	0
45678779	1129625	0	0
45690692	975125	0	0
45702546	1125315	0	0
46292744	708298	0	0
46239409	1549786	0	0
45801560	1177480	0	0
46244319	1741122	0	0
46240071	1549786	0	0
46301122	19018935	2	3
45799132	1115171	2	3
4190185	198809	3	3
21000244	1728416	0	0
4223595	4280726	2	2
21502620	19073183	7	8
35507531	1119510	0	0
36152576	40236824	2	3
36207527	3049273	2	2
37503992	4035793	2	4
42805102	1332418	0	0
44342952	1149196	0	0
44360218	1549786	0	0
44353576	19126352	2	3
45655968	1713332	0	0
44353664	1125315	0	0
45659022	1125315	0	0
45663131	1343916	0	0
45640058	1125315	0	0
45666330	1500211	0	0
45701833	1500211	0	0
45700538	1125315	0	0
45695745	1125315	0	0
45690321	1515774	0	0
45678353	1129625	0	0
45690647	1521369	0	0
45702548	1125315	0	0
46292647	1322184	0	0
46239409	1589505	0	0
45801616	1177480	0	0
46244319	1746114	0	0
46240071	1521369	0	0
46319065	1127433	2	3
45799283	1115171	2	3
4190185	28060	3	3
21000244	1713332	0	0
4223616	4084167	2	2
21500120	1548195	7	7
35204953	313217	0	0
36152579	40231925	2	3
36207527	3004501	2	2
37503992	4107731	2	6
42805111	1500211	0	0
44342648	1557272	0	0
44360143	738818	0	0
44353415	19008572	2	3
45655969	1115008	0	0
44353666	1125315	0	0
45659125	1125315	0	0
45663176	1501700	0	0
45639476	1125315	0	0
45666105	1107830	0	0
45702194	1107830	0	0
45700548	1125315	0	0
45695587	1125315	0	0
45690321	1549786	0	0
45675283	1129625	0	0
45690650	914335	0	0
45702852	1125315	0	0
46292653	1115008	0	0
46239156	1192710	0	0
45801463	1177480	0	0
46244438	1124957	0	0
46240118	1549786	0	0
46319428	1115171	2	3
45793702	40232448	2	3
4190185	440448	3	3
21000244	1738521	0	0
4224259	40486433	2	2
21500120	1501700	7	7
21605060	914335	0	0
36152908	1107882	2	3
36211091	4146173	2	2
37503992	4330583	2	9
42804928	1177480	0	0
44342766	738818	0	0
44359769	1177480	0	0
44353779	40163554	2	3
45656075	1149196	0	0
44353706	1125315	0	0
45659129	1125315	0	0
45663018	1713332	0	0
45639450	1125315	0	0
45666345	1124300	0	0
45702061	1326303	0	0
45700661	1125315	0	0
45695753	1125315	0	0
45690323	975125	0	0
45675214	1129625	0	0
45690658	1154029	0	0
45702790	1125315	0	0
46293004	1115008	0	0
46239158	1192710	0	0
45801377	1177480	0	0
46244572	1118084	0	0
46240020	1557272	0	0
46319154	19059056	2	3
45794081	40231925	2	3
4042503	4155034	3	3
21000244	1729720	0	0
4224259	4280726	2	2
21500120	1557272	7	7
21605129	967823	0	0
36152742	19125062	2	3
36211091	4134304	2	2
37503898	4108705	2	5
42805000	1124300	0	0
44342695	1738521	0	0
44359670	705944	0	0
44353519	40229134	2	3
45656339	1343916	0	0
44353881	1125315	0	0
45659288	1125315	0	0
45663018	1759842	0	0
45639452	1125315	0	0
45667208	708298	0	0
45701852	738818	0	0
45700524	1125315	0	0
45695843	1125315	0	0
45690325	1124300	0	0
45675193	1129625	0	0
45690664	791967	0	0
45702696	1125315	0	0
46292936	1174888	0	0
45894583	1521369	0	0
45801574	1177480	0	0
46244386	1332418	0	0
46240134	1738521	0	0
46319524	40163554	2	3
45794086	1594382	2	3
4042503	4278672	3	3
21000245	1738521	0	0
4288463	4186930	2	2
21502709	40229134	9	10
21604305	1112807	0	0
36153255	43012036	2	3
36211091	4230399	2	2
37202310	258780	2	5
42805069	1124300	0	0
44342731	1124957	0	0
44359812	975125	0	0
44353731	40163554	2	3
45656349	1551099	0	0
44353519	1125315	0	0
45659135	1125315	0	0
45663062	723013	0	0
45639505	1125315	0	0
45667194	1332418	0	0
45702113	1102527	0	0
45698943	1125315	0	0
45695784	1125315	0	0
45690329	1124957	0	0
45676429	1129625	0	0
45690762	1174888	0	0
45702558	1125315	0	0
46292946	1549786	0	0
45894583	1549786	0	0
45801431	1177480	0	0
46244500	1738521	0	0
46240118	1589505	0	0
46295416	19078461	2	3
45794092	19129655	2	3
4042503	4113008	3	3
21000245	1728416	0	0
4304916	192671	2	2
21002855	19076374	2	3
21603392	19029476	0	3
35708603	4112343	2	3
36211315	4296204	2	2
36703500	4066995	2	5
42805142	1125315	0	0
44342812	1107830	0	0
44359965	1589505	0	0
44353736	1115171	2	3
45656328	1149380	0	0
44353715	1125315	0	0
45659251	1125315	0	0
45663208	1713332	0	0
45639514	1125315	0	0
45667322	1115008	0	0
45702116	1107830	0	0
45698972	1125315	0	0
45697753	1125315	0	0
45690492	738818	0	0
45672365	1129625	0	0
45690766	1124300	0	0
45702941	1125315	0	0
46292946	1512674	0	0
45894586	1310149	0	0
45801557	1177480	0	0
46244407	1521369	0	0
46240119	738818	0	0
46301752	1332419	2	3
45793956	1115171	2	3
4169307	4240902	3	3
21000261	1738521	0	0
4287856	40492359	2	2
21002644	19008572	2	3
21604271	40165015	0	3
35509194	1127433	2	3
36208978	46235214	2	2
37202320	4280726	2	5
42805346	1738521	0	0
44342814	1107830	0	0
44359965	1549786	0	0
44346121	1115171	2	3
45656156	1545958	0	0
44353805	1125315	0	0
45659324	1125315	0	0
45663208	1759842	0	0
45639533	1125315	0	0
45667380	1548195	0	0
45702184	723013	0	0
45699017	1125315	0	0
45697537	1125315	0	0
45690497	1717327	0	0
45672616	1129625	0	0
45690757	967823	0	0
45702813	1125315	0	0
46293031	1115008	0	0
45894374	1124300	0	0
45801446	1177480	0	0
46244605	1192710	0	0
45896592	1192710	0	0
45894291	19073183	2	3
45794228	40236824	2	3
4169307	4219399	3	3
21000267	1738521	0	0
4287856	4275113	2	2
21002602	1713671	2	3
21602504	1519937	0	3
35509201	40163554	2	3
36208978	3011505	2	2
36718338	4132546	2	5
42805479	914335	0	0
44342753	1149380	0	0
44360145	975125	0	0
44346258	40229134	2	3
45656270	1115008	0	0
44353939	1125315	0	0
45659325	1125315	0	0
45663221	1149196	0	0
45639466	1125315	0	0
45667323	19059528	0	0
45702232	1332418	0	0
45698963	1125315	0	0
45697598	1125315	0	0
45690439	1551099	0	0
45786339	1129625	0	0
45690758	1110410	0	0
45702817	1125315	0	0
46292956	1548195	0	0
45894653	914335	0	0
45801712	1177480	0	0
46244606	933724	0	0
45896487	1115008	0	0
45797016	19073183	2	3
45794204	19057271	2	3
4169307	37017711	3	3
21000260	1778162	0	0
4287856	44805732	2	2
21002899	40173590	2	3
21604762	19123231	0	3
36156844	1115171	2	3
36208195	3000876	2	2
37503919	4163971	2	4
42805589	791967	0	0
44342720	708298	0	0
44360228	1112807	0	0
44346209	19133873	2	3
45656272	1589505	0	0
44346082	1125315	0	0
45659272	1125315	0	0
45659629	791967	0	0
45639506	1125315	0	0
45667332	1115008	0	0
45701838	1717327	0	0
45695465	1125315	0	0
45697764	1125315	0	0
45690444	1115008	0	0
45786569	1129625	0	0
45690828	1149196	0	0
45702818	1125315	0	0
46292956	1521369	0	0
45894438	1174888	0	0
45796169	1177480	0	0
46244610	1305058	0	0
45896497	738818	0	0
46302101	19075001	2	3
45788661	40232448	2	3
4169307	433644	3	3
21000282	1728416	0	0
21503268	975125	2	2
21002659	1551192	2	3
21604757	40236446	0	3
36157291	19059056	2	3
36208195	3021226	2	2
37202317	260139	2	4
42805654	701322	0	0
44342756	1322184	0	0
44360171	1154343	0	0
44346320	1115171	2	3
45656272	19127890	0	0
44346096	1125315	0	0
45656908	1125315	0	0
45659632	1115008	0	0
45639593	1125315	0	0
45667335	975125	0	0
45702187	1115008	0	0
45695474	1125315	0	0
45697547	1125315	0	0
45690446	1501700	0	0
45782288	1129625	0	0
45690729	1332418	0	0
45702801	1125315	0	0
46293181	1124957	0	0
45894621	1107830	0	0
45795979	1177480	0	0
46244458	1115008	0	0
45896527	1192710	0	0
46301863	1107882	2	3
45788666	19133905	2	3
4181187	4280726	3	3
21000261	1746114	0	0
21600191	914335	2	2
21002685	19007333	2	3
21601747	1332419	0	3
36157305	40222846	2	3
36208195	3001488	2	2
37002289	198199	2	4
42805515	1124300	0	0
44342837	1124957	0	0
44360174	738818	0	0
44346244	19008572	2	3
45656272	1549786	0	0
44345942	1125315	0	0
45656855	1125315	0	0
45659706	1149380	0	0
45639596	1125315	0	0
45667181	967823	0	0
45702032	975125	0	0
45695477	1125315	0	0
45697726	1125315	0	0
45690551	1367571	0	0
45702528	1129625	0	0
45690779	975125	0	0
45702784	1125315	0	0
46293190	1124300	0	0
45892894	45892894	0	0
45796347	1177480	0	0
46244459	1192710	0	0
45896582	1124300	0	0
45794197	40228214	2	3
45788667	1154615	2	3
4181187	4294548	3	3
21000268	1746114	0	0
21600191	40243436	2	2
21003018	1310034	2	3
21601860	1545959	0	3
36156990	40229134	2	3
36208195	3024731	2	2
36718338	381316	2	4
42805443	920293	0	0
44342845	1343916	0	0
44359919	738818	0	0
44346245	19008572	2	3
45656274	1174888	0	0
44346176	1125315	0	0
45657291	1125315	0	0
45659708	1000560	0	0
45639654	1125315	0	0
45667187	1308738	0	0
45702042	933724	0	0
45695556	1125315	0	0
45697704	1125315	0	0
45690555	1501700	0	0
45702748	1129625	0	0
45690709	1192710	0	0
45696498	1125315	0	0
46293211	975125	0	0
45892895	45892894	0	0
45790835	1177480	0	0
46244463	975125	0	0
45896668	1124300	0	0
46299967	40223768	2	3
45788699	19019273	2	3
4181187	40486433	3	3
21000265	1738521	0	0
21600280	1343916	2	2
21003025	42707627	2	3
21601856	1539411	0	3
36157031	40232448	2	3
36208195	3002385	2	2
37503924	4330583	1	6
42805446	1119510	0	0
44342758	19078219	0	0
44360176	1177480	0	0
44346424	19008572	2	3
45656405	738818	0	0
44346178	1125315	0	0
45657174	1125315	0	0
45659638	1539403	0	0
45639524	1125315	0	0
45667230	1551099	0	0
45702044	1174888	0	0
45695572	1125315	0	0
45697711	1125315	0	0
45690603	1115008	0	0
45702751	1129625	0	0
45690787	1110410	0	0
45696501	1125315	0	0
46293224	1545958	0	0
45893564	1332418	0	0
45790976	1177480	0	0
46240140	19127890	0	0
45896534	1551099	0	0
45791511	1107882	2	3
45788822	40229134	2	3
4134148	4186930	3	3
4170947	4170947	0	0
21600280	46275916	2	2
21003025	40243436	2	3
35202055	317576	2	3
36157171	1127433	2	3
36208195	3009542	2	2
37503919	4242997	1	3
42805451	1322184	0	0
44342760	1192710	0	0
44360185	1308738	0	0
44346634	1127433	2	3
45656037	1549786	0	0
44346190	1125315	0	0
45657489	1125315	0	0
45659698	1149196	0	0
45639567	1125315	0	0
45667342	1343916	0	0
45702070	975125	0	0
45695577	1125315	0	0
45697654	1125315	0	0
45690565	1310149	0	0
45702472	1129625	0	0
45690614	1545958	0	0
45696776	1125315	0	0
46293085	791967	0	0
45893609	1738521	0	0
45791858	1177480	0	0
46240140	1549786	0	0
45896573	1107830	0	0
46307156	1107882	2	3
45788869	40229134	2	3
4182161	372328	3	3
21000292	46233710	2	3
21500215	1332418	2	2
21003025	19078924	2	3
35402084	372328	2	3
36157188	40174880	2	3
36208195	3009201	2	2
37503958	4323902	1	3
42805421	1549786	0	0
44342858	1177480	0	0
44360187	1112807	0	0
44346268	40232448	2	3
45656311	1501700	0	0
44346195	1125315	0	0
45657260	1125315	0	0
45659656	1521369	0	0
45639585	1125315	0	0
45667466	1174888	0	0
45701956	1149196	0	0
45695678	1125315	0	0
45697601	1125315	0	0
45690502	1501700	0	0
45702742	1129625	0	0
45690616	1153428	0	0
45696705	1125315	0	0
46292752	1332418	0	0
45893562	1192710	0	0
45791972	1177480	0	0
46240140	1512674	0	0
45896553	19010482	0	0
46300331	1107882	2	3
45788818	40236446	2	3
4111522	4010253	3	3
21000244	19133905	2	3
21600269	1309944	2	2
21002627	19008572	2	3
21603448	40232448	2	3
36157466	19125062	2	3
36208195	3008598	2	2
37503893	4198190	1	4
42805327	1309944	0	0
44342785	1110410	0	0
44360187	1192710	0	0
44346386	19008572	2	3
45656214	1713332	0	0
44346153	1125315	0	0
45657491	1125315	0	0
45659658	1332418	0	0
45639677	1125315	0	0
45667237	1154029	0	0
45701958	1343916	0	0
45695761	1125315	0	0
45697603	1125315	0	0
45690504	1000560	0	0
45702573	1129625	0	0
45690621	975125	0	0
45696194	1125315	0	0
46293408	1000560	0	0
45893688	1738521	0	0
46295000	1177480	0	0
46240291	1557272	0	0
45896686	1192710	0	0
46318571	1107882	2	3
600000005	19115351	2	2
4096864	4266809	3	3
21000244	19075001	2	3
21600316	1361711	2	2
21002863	1115171	2	3
35507274	40223834	2	3
36157378	1127433	2	3
36208195	3014599	2	2
36718338	4066995	1	4
42805185	1149380	0	0
44342789	967823	0	0
44359925	1332418	0	0
44346388	1127433	2	3
45656037	1515774	0	0
44346329	1125315	0	0
45657386	1125315	0	0
45659541	1332418	0	0
45639644	1125315	0	0
45666356	791967	0	0
45702209	1115008	0	0
45695778	1125315	0	0
45697670	1125315	0	0
45690509	1107830	0	0
45702945	1129625	0	0
45690870	1000560	0	0
45696448	1125315	0	0
46293162	1000560	0	0
45893588	1149196	0	0
46244067	1177480	0	0
46240144	1557272	0	0
45896693	1110410	0	0
45799568	1107882	2	3
45876033	3013721	2	2
4096864	4310024	3	3
21000244	46233710	2	3
21500658	1308738	2	2
21002863	1127433	2	3
35204989	4329847	2	3
36157403	40232448	2	3
36208195	3007461	2	2
37503958	4337138	1	2
42805188	1713332	0	0
44342861	1738521	0	0
44359876	1129625	0	0
44338937	40162522	2	3
45652509	1110410	0	0
44346258	1125315	0	0
45657398	1125315	0	0
45659550	1332418	0	0
45639665	1125315	0	0
45666425	740275	0	0
45702129	738818	0	0
45694698	1125315	0	0
45695956	1125315	0	0
45690576	1000560	0	0
45702755	1129625	0	0
45690744	1500211	0	0
45765647	375671	3	3
46292752	1545958	0	0
45893695	1539403	0	0
46244086	1177480	0	0
46239763	1595799	0	0
45896413	1115008	0	0
46295319	1107882	2	3
45876033	3006923	2	2
4096864	196456	3	3
21000244	19073183	2	3
21500658	1125315	2	2
21002863	1127078	2	3
21603929	19007333	2	3
36152361	19008572	2	3
36208195	3012494	2	2
37203741	258780	1	2
42802479	1112807	0	0
44342875	1322184	0	0
44359876	1177480	0	0
44338996	19008572	2	3
45652384	1110410	0	0
44346204	1125315	0	0
45657407	1125315	0	0
45659736	1332418	0	0
45639623	1125315	0	0
45666426	920293	0	0
45702159	738818	0	0
45694701	1125315	0	0
45696023	1125315	0	0
45690596	1115008	0	0
45702758	1129625	0	0
45690805	1149196	0	0
45765647	378001	3	3
46292755	975125	0	0
45893616	967823	0	0
46244253	1177480	0	0
46239763	1521369	0	0
45896554	738818	0	0
45894748	19078461	2	3
45876033	3035995	2	2
4043176	4216130	3	3
21000290	1713671	2	3
21505743	1119510	2	2
21003153	1127433	2	3
35507349	1107882	2	3
36152363	19008572	2	3
36208195	3026361	2	2
36718586	4066995	1	2
42802493	1154343	0	0
44342876	1326303	0	0
44359883	933724	0	0
44339115	19008572	2	3
45652386	19127890	0	0
44346160	1125315	0	0
45657050	1125315	0	0
45659558	1539403	0	0
45639913	1125315	0	0
45666412	708298	0	0
45703560	1153428	0	0
45694383	1125315	0	0
45695934	1125315	0	0
45690421	1107830	0	0
45702765	1129625	0	0
45690879	1000560	0	0
45766714	133834	3	3
46293248	1124300	0	0
45801383	1115008	0	0
46244218	1177480	0	0
46239763	1549786	0	0
45896703	1154343	0	0
45896573	1107882	2	3
45876033	3007461	2	2
4029698	4163971	3	3
21000261	46233988	2	3
21505743	1174888	2	2
21003153	19019979	2	3
21604256	35605858	2	3
36157472	1115171	2	3
36208195	3001247	2	2
37503938	4275113	1	1
42802496	1545958	0	0
44342953	1307863	0	0
44359972	1124300	0	0
44339227	1127433	2	3
45652386	1549786	0	0
44346327	1125315	0	0
45657336	1125315	0	0
45659720	1326303	0	0
45639916	1125315	0	0
45666451	975125	0	0
45703562	1107830	0	0
45694709	1125315	0	0
45692762	1125315	0	0
45690515	1192710	0	0
45682541	1119510	0	0
45690817	1149196	0	0
45671738	19128263	3	4
46293228	1000560	0	0
45801501	1332418	0	0
46239183	1177480	0	0
46239764	708298	0	0
45896706	1717327	0	0
46317705	1107882	2	3
45876033	3004501	2	2
4040551	4202451	3	3
21000261	46233710	2	3
21500766	1308738	2	2
21003205	40229134	2	3
21603398	40162522	2	3
36157538	19059056	2	3
36208195	3006451	2	2
37503938	4238715	1	1
42802327	1713332	0	0
44342874	1192710	0	0
44359688	1738521	0	0
44339232	40231925	2	3
45652387	1309944	0	0
44346228	1125315	0	0
45657343	1125315	0	0
45659604	708298	0	0
45639804	1125315	0	0
45666452	1307863	0	0
45703805	967823	0	0
45694523	1125315	0	0
45693086	1125315	0	0
45690517	1124300	0	0
45682143	1119510	0	0
45690846	1154029	0	0
45687552	40221415	3	4
46292768	1192710	0	0
45801507	1746114	0	0
46239435	1177480	0	0
46239772	1192710	0	0
45896709	1307863	0	0
46300103	1107882	2	3
46240118	19127918	2	2
4180627	4035793	3	3
21000285	46233988	2	3
21500764	967823	2	2
21002683	1551192	2	3
21604260	40231925	2	3
36157754	1127433	2	3
36208195	3027231	2	2
37396227	4145310	1	1
42802327	1759842	0	0
44343079	1713332	0	0
44360083	1545958	0	0
44339236	1718412	2	3
45652708	920293	0	0
44346465	1125315	0	0
45655025	1125315	0	0
45659622	1107830	0	0
45636358	1125315	0	0
45666377	1149196	0	0
45703806	975125	0	0
45694711	1125315	0	0
45693087	1125315	0	0
45690544	920293	0	0
45680071	1119510	0	0
45690848	1154029	0	0
45702906	40221415	3	4
46293159	1115008	0	0
45801507	1741122	0	0
46239684	1177480	0	0
45787504	1112807	0	0
45896574	1174888	0	0
46312926	1107882	2	3
45788984	1539411	2	3
4156363	443279	3	3
21000265	46233988	2	3
21500216	1307863	2	2
21002846	19019273	2	3
21604344	40162522	2	3
36157735	1115171	2	3
36208195	3006734	2	2
37397180	439406	1	1
42802587	1310149	0	0
44342964	1192710	0	0
44360280	738818	0	0
44339427	40236824	2	3
45652625	1778162	0	0
44346486	1125315	0	0
45655376	1125315	0	0
45659553	1174888	0	0
45636361	1125315	0	0
45666380	738818	0	0
45699090	1332418	0	0
45692413	1125315	0	0
45693088	1125315	0	0
45691412	975125	0	0
45680011	1119510	0	0
45691064	1154343	0	0
45771096	440086	4	4
46292887	967823	0	0
45801508	920293	0	0
46239541	1177480	0	0
45787741	1112807	0	0
45896574	1192710	0	0
45797105	1107882	2	3
46307916	1539411	2	3
4172515	4197460	3	3
21000265	46233710	2	3
21500676	1396131	2	2
21002827	1115171	2	3
21604344	19133768	2	3
36157901	40232448	2	3
36208195	3015076	2	2
37397180	4048169	1	1
42802372	1125315	0	0
44342925	1112807	0	0
44360283	1129625	0	0
44339523	920334	2	3
45652739	1153428	0	0
44346634	1125315	0	0
45655479	1125315	0	0
45659681	1332418	0	0
45636300	1125315	0	0
45666382	1107830	0	0
45699022	1124957	0	0
45692427	1125315	0	0
45692794	1125315	0	0
45691435	1549786	0	0
45680077	1119510	0	0
45690999	1000560	0	0
46235681	3023103	2	2
46288140	723013	0	0
45801509	1551099	0	0
45895936	1177480	0	0
45801029	1112807	0	0
45896576	1174888	0	0
46300232	1107882	2	3
45799530	1539411	2	3
4029549	4301346	3	3
21000284	46233988	2	3
21500676	1595799	2	2
21002842	1551192	2	3
21603926	1305058	2	2
36157568	40228230	2	3
36208978	40766240	2	4
37003658	195588	1	1
42802567	1539403	0	0
44342930	1343916	0	0
44360297	1112807	0	0
44339097	19133905	2	3
45652741	1512674	0	0
44346267	1125315	0	0
45655458	1125315	0	0
45659557	1174888	0	0
45636313	1125315	0	0
45666386	1154029	0	0
45699124	975125	0	0
45692431	1125315	0	0
45692922	1125315	0	0
45691489	1192710	0	0
45677561	1119510	0	0
45691000	1361711	0	0
46235681	3016723	2	2
46287865	1153428	0	0
45801511	1322184	0	0
45895938	1177480	0	0
45801102	1112807	0	0
45896416	1343916	0	0
46318722	1332419	2	3
600000004	19074679	1	4
4030028	44783196	3	3
21000267	46233710	2	3
21500676	1308738	2	2
21002673	1551192	2	3
21603926	19007333	2	2
36157578	40229134	2	3
36208978	40758406	2	4
36903656	443279	2	2
42802543	1549786	0	0
44342939	1149380	0	0
44353103	975125	0	0
44360460	40236824	2	3
45652741	1549786	0	0
44346433	1125315	0	0
45655462	1125315	0	0
45659814	1107830	0	0
45636217	1125315	0	0
45666387	1107830	0	0
45699132	975125	0	0
45692729	1125315	0	0
45692930	1125315	0	0
45691491	1501700	0	0
45677878	1119510	0	0
45690885	1115008	0	0
45800486	19128009	2	2
46287866	1115008	0	0
45801400	1110410	0	0
45896077	1177480	0	0
45802589	1112807	0	0
45896418	1115008	0	0
45794428	40173590	2	3
46307291	42902245	1	2
4043023	4163872	3	3
21000245	46233988	2	3
21500803	1367571	2	2
21002682	19007333	2	3
35104341	4056621	2	2
36157621	1127433	2	3
36208978	40769189	2	4
36903604	378419	2	2
42802543	19127890	0	0
44342880	1192710	0	0
44353105	1118084	0	0
44360732	43012036	2	3
45652741	19127890	0	0
44346383	1125315	0	0
45655463	1125315	0	0
45659853	738818	0	0
45636460	1125315	0	0
45666413	1115008	0	0
45699051	1154029	0	0
45692975	1125315	0	0
45692938	1125315	0	0
45687249	975125	0	0
45677891	1119510	0	0
45690886	975125	0	0
45800486	19127918	2	2
46287999	1310149	0	0
45801754	1729720	0	0
45896146	1177480	0	0
45801418	1112807	0	0
45896419	1153428	0	0
46307150	19079524	2	3
46318515	19127904	1	2
4043023	4337138	3	3
21000245	46233710	2	3
21500803	1310149	2	2
21002682	1551192	2	3
21603445	1153428	2	2
36157939	19008572	2	3
36208978	40769194	2	4
36919120	378419	2	2
42802543	1515774	0	0
44342797	1308738	0	0
44353230	1738521	0	0
44360702	1551192	2	3
45652692	1332418	0	0
44338937	1125315	0	0
45655466	1125315	0	0
45659857	914335	0	0
45636436	1125315	0	0
45666414	975125	0	0
45699097	1115008	0	0
45692290	1192710	0	0
45692755	1125315	0	0
45687338	1713332	0	0
45678032	1119510	0	0
45690888	1000560	0	0
45885349	4146173	2	2
46288479	1738521	0	0
45801756	1307863	0	0
45895892	1177480	0	0
45795823	1112807	0	0
45896764	1000560	0	0
46307511	1332419	2	3
46321021	46275916	1	1
4043023	4163951	3	3
4181195	44783196	2	3
21600190	914335	2	2
21002663	1551192	2	3
21603445	1107830	2	2
36158076	40229134	2	3
36208978	40769179	2	4
40795922	3001488	2	2
42802554	914335	0	0
44342799	1154029	0	0
44352939	1738521	0	0
44360469	40232448	2	3
45652673	1307863	0	0
44338928	1125315	0	0
45655470	1125315	0	0
45659957	1174888	0	0
45636442	1125315	0	0
45666440	701322	0	0
45699214	1154029	0	0
45692297	1115008	0	0
45692765	1125315	0	0
45687338	1759842	0	0
45677835	1119510	0	0
45690889	1778162	0	0
45876166	3006322	2	2
46288494	1713332	0	0
45801459	1000560	0	0
45896133	1177480	0	0
45795855	1112807	0	0
45894627	933724	0	0
46319575	1332419	2	3
46321021	19079524	1	1
4040396	4186930	3	3
4134443	4149245	2	3
21503342	1125315	2	2
21002655	1551192	2	3
21603445	1149196	2	2
36158001	40222846	2	3
36208978	40769184	2	4
40795725	3000963	2	2
42802626	1000560	0	0
44342999	1310149	0	0
44353281	738818	0	0
44360790	40231925	2	3
45652454	1154029	0	0
44339138	1125315	0	0
45655423	1125315	0	0
45660079	1539403	0	0
45636445	1125315	0	0
45666455	1308738	0	0
45699216	920293	0	0
45692299	1174888	0	0
45692992	1125315	0	0
45687361	1308738	0	0
45677990	1119510	0	0
45691001	1149196	0	0
45803035	42902245	2	2
46288494	1759842	0	0
45801461	1501700	0	0
45896033	1177480	0	0
45790421	1112807	0	0
45894630	1332418	0	0
45794344	19075601	2	3
45796838	19127922	1	1
4043161	4199276	3	3
4041261	4238715	2	3
21500562	757627	2	2
21002894	46275444	2	3
21603445	1192710	2	2
36102149	257012	2	3
36208978	3006322	2	4
40795727	3009201	2	2
42802558	1154343	0	0
44343138	1124300	0	0
44353307	1115008	0	0
44360875	40232448	2	3
45652594	1713332	0	0
44338997	1125315	0	0
45653856	1125315	0	0
45659769	1174888	0	0
45636437	1125315	0	0
45666471	1107830	0	0
45699067	1717327	0	0
45692314	1343916	0	0
45693000	1125315	0	0
45687469	1501700	0	0
45679563	1119510	0	0
45690930	1367571	0	0
45795011	19128009	2	2
46288502	1124300	0	0
45801462	1174888	0	0
45896072	1177480	0	0
45790793	1112807	0	0
45894525	757627	0	0
45794752	40228214	2	3
45796838	19129144	1	1
4042150	4218408	3	3
4170143	4112343	2	4
21500562	715997	2	2
21002025	19073183	2	3
21603445	1129625	2	2
36156759	40236446	2	3
36208978	21494966	2	4
40795730	3013682	2	2
42802591	1551099	0	0
44343289	1192710	0	0
44353284	1149196	0	0
44360658	19008572	2	3
45652594	1759842	0	0
44339012	1125315	0	0
45653955	1125315	0	0
45659772	1307863	0	0
45636395	1125315	0	0
45666528	715997	0	0
45699143	975125	0	0
45692341	933724	0	0
45693073	1125315	0	0
45687275	1738521	0	0
45679568	1119510	0	0
45687314	1309944	0	0
45785737	19128009	2	2
46288013	1112807	0	0
45801364	1115008	0	0
45896101	1177480	0	0
45790503	1112807	0	0
45894719	723013	0	0
45802251	40174880	2	3
45796838	19133679	1	1
4042150	4202451	3	3
4170143	4294548	2	4
21600885	967823	2	2
21002025	19073188	2	3
21603445	1150770	2	2
36152735	42707627	2	3
36517140	81151	2	5
40652452	3006322	2	2
42802464	914335	0	0
44343305	975125	0	0
44353309	1174888	0	0
44361014	1127433	2	3
45652581	1174888	0	0
44339227	1125315	0	0
45653921	1125315	0	0
45659774	1361711	0	0
45636153	1125315	0	0
45663828	967823	0	0
45699146	1361711	0	0
45692346	1332418	0	0
45693033	1125315	0	0
45687394	723013	0	0
45679569	1119510	0	0
45687700	1308738	0	0
46240118	19128009	2	2
46287970	1153428	0	0
45801573	1149196	0	0
45896185	1177480	0	0
45790868	1112807	0	0
45894170	1738521	0	0
45895663	19075601	2	3
46315219	42902245	2	2
4040400	4295880	3	3
4171379	195588	2	5
21600248	1309944	2	2
21002642	1551192	2	3
35104366	4056621	2	2
35507109	40236446	2	3
36208195	3004501	2	5
37320143	133834	2	2
42802423	1177480	0	0
44343092	1177480	0	0
44353316	933724	0	0
44360629	40232448	2	3
45652583	1124300	0	0
44339232	1125315	0	0
45654100	1125315	0	0
45659777	1549786	0	0
45636340	1125315	0	0
45664454	975125	0	0
45699148	1174888	0	0
45691936	1149196	0	0
45693189	1125315	0	0
45687471	1729720	0	0
45674689	1119510	0	0
45687348	975125	0	0
45895008	19128009	2	2
46288169	1738521	0	0
45801472	1545958	0	0
45896702	1177480	0	0
45790814	1112807	0	0
45894248	1729720	0	0
46298976	19079524	1	1
44361178	40231925	2	3
4040400	4238715	3	3
4029565	4198190	2	2
21600279	1343916	2	2
21002642	19008572	2	3
21605042	1149380	2	2
36213601	19128263	2	3
36208195	3013682	2	5
36903593	440086	2	2
44359268	1738521	0	0
44343094	1738521	0	0
44353319	1192710	0	0
44361059	40169216	2	3
45652646	1595799	0	0
44339168	1125315	0	0
45654165	1125315	0	0
45659777	19127890	0	0
45636326	1125315	0	0
45664518	920293	0	0
45699151	1310149	0	0
45692062	1332418	0	0
45693192	1125315	0	0
45687472	1192710	0	0
45674631	1119510	0	0
45687350	791967	0	0
45895008	19127918	2	2
46288518	1112807	0	0
45801473	1174888	0	0
45896827	1177480	0	0
45790568	1112807	0	0
45894171	1729720	0	0
46307852	19079524	1	1
44361216	40162522	2	3
4040400	4337138	3	3
4134443	4035415	2	2
21503332	975125	2	2
21002630	19008572	2	3
21603891	19010482	2	2
36213601	19128022	2	3
36208195	3020630	2	5
37522193	4293740	2	2
44359322	1129625	0	0
44343098	738818	0	0
44353322	791967	0	0
44360632	40232448	2	3
45652647	1124957	0	0
44339121	1125315	0	0
45647365	1125315	0	0
45659777	1521369	0	0
45636529	1125315	0	0
45664533	975125	0	0
45699077	1539403	0	0
45692143	967823	0	0
45693104	1125315	0	0
45687478	975125	0	0
45674957	1119510	0	0
45687429	914335	0	0
45802937	42902245	2	2
46288531	1501700	0	0
45801478	740275	0	0
45896664	1177480	0	0
45790686	1112807	0	0
45894184	920293	0	0
46302627	19079524	1	1
45650533	40232448	2	3
4040400	40492359	5	5
4134439	4001336	2	2
21503409	1396131	2	2
21002630	1551192	2	3
21603891	1305058	2	2
36156981	1551192	2	3
36208195	3024561	2	5
40795740	3004501	2	2
44359323	1112807	0	0
44343203	1192710	0	0
44353141	1177480	0	0
44338212	19073183	2	3
45652648	1713332	0	0
44339345	1125315	0	0
45647481	1125315	0	0
45660019	1305058	0	0
45636469	1125315	0	0
45664603	975125	0	0
45699274	1110410	0	0
45692159	1332418	0	0
45692859	1125315	0	0
45687480	1713332	0	0
45674659	1119510	0	0
45687773	1310149	0	0
45787205	19128263	2	2
46288056	1112807	0	0
45801371	1000560	0	0
45896744	1177480	0	0
46297571	1112807	0	0
45894228	1153428	0	0
46313268	46275916	1	1
45650556	40174880	2	3
4043022	4242997	5	5
4134439	4066995	2	2
21500770	1308738	2	2
21002630	40228214	2	3
21604077	42707627	2	2
36157365	1551192	2	3
36208195	3016723	2	5
40775801	3016723	2	2
44359325	1124300	0	0
44343211	1118084	0	0
44353064	975125	0	0
44359791	43012036	2	3
45655047	1115008	0	0
44339125	1125315	0	0
45647482	1125315	0	0
45660044	1115008	0	0
45636614	1125315	0	0
45664618	975125	0	0
45699244	1778162	0	0
45692379	1149196	0	0
45692862	1125315	0	0
45687406	1396131	0	0
45674784	1119510	0	0
45687824	1174888	0	0
45696797	19057271	2	3
46288057	975125	0	0
45801453	1713332	0	0
45804330	1177480	0	0
46297954	1112807	0	0
45894188	1551099	0	0
46313268	19079524	1	1
46319484	1125315	0	0
4043022	4337611	5	5
4136573	4134304	2	2
21500752	967823	2	2
21002630	40228230	2	3
21604077	19003953	2	2
36157685	1545959	2	3
36208195	3035995	2	5
37320127	4296204	2	2
44359329	1192710	0	0
44343287	1112807	0	0
44353065	1115008	0	0
44345969	42707627	2	3
45655059	1115008	0	0
44339023	1125315	0	0
45647393	1125315	0	0
45659895	1124300	0	0
45636615	1125315	0	0
45664733	1000560	0	0
45699413	1521369	0	0
45694654	1149196	0	0
45693058	1125315	0	0
45687410	1738521	0	0
45674842	1119510	0	0
45687999	1149196	0	0
45696730	19008572	2	3
46288171	1112807	0	0
45801589	1551099	0	0
45797301	1177480	0	0
46297756	1112807	0	0
45894191	1717327	0	0
46321640	19079524	1	1
46319580	1125315	0	0
4040396	4163971	5	5
4135090	4134304	2	2
21600884	967823	2	2
21500093	19007333	6	7
21605009	1149380	2	2
4130852	4059173	2	3
36208195	3027970	2	5
37522151	4197460	2	2
44359330	1192710	0	0
44343288	708298	0	0
44353067	791967	0	0
44359670	40236446	2	3
45655170	738818	0	0
44339025	1125315	0	0
45647398	1125315	0	0
45659901	1501700	0	0
45636409	1125315	0	0
45664670	1115008	0	0
45699413	1549786	0	0
45694622	1192710	0	0
45693067	1125315	0	0
45687329	1192710	0	0
45674975	1119510	0	0
45688002	1124957	0	0
45696374	1115171	2	3
46288178	1326303	0	0
45801453	1759842	0	0
45796703	1177480	0	0
46297422	1112807	0	0
45894196	1115008	0	0
46303642	19079524	1	1
46319581	1125315	0	0
4093991	317576	5	5
4135097	4134304	2	2
21601078	1396131	2	2
21500936	19008572	6	7
21604254	1154029	2	2
4130852	4109685	2	3
36208195	3006906	2	5
37303797	4102123	2	2
44359332	1713332	0	0
44343173	738818	0	0
44353244	738818	0	0
44355568	19078461	2	3
45655171	1309944	0	0
44339580	1125315	0	0
45647399	1125315	0	0
45660048	1115008	0	0
45636943	1125315	0	0
45663979	1549786	0	0
45699413	19127890	0	0
45694689	1124957	0	0
45690014	1125315	0	0
45687523	1107830	0	0
45674879	1119510	0	0
45688006	1153428	0	0
45696823	40232448	2	3
46288548	791967	0	0
45801611	1521369	0	0
45796547	1177480	0	0
46297966	1112807	0	0
45894262	715997	0	0
46307301	46275916	1	1
46319445	1125315	0	0
4180627	4170947	5	5
4138286	4149245	2	2
21601078	1595799	2	2
21602681	40174880	6	7
21603395	1119510	2	2
35406420	372328	1	1
36208195	3013721	2	5
37521809	4337138	2	2
44359338	1112807	0	0
44343238	1177480	0	0
44353142	975125	0	0
44353682	19019273	2	3
45655352	1332418	0	0
44339588	1125315	0	0
45647459	1125315	0	0
45660081	1310149	0	0
45637054	1125315	0	0
45663979	1519936	0	0
45699416	1174888	0	0
45689038	1501700	0	0
45689840	1125315	0	0
45687562	738818	0	0
45674887	1119510	0	0
45687888	1713332	0	0
45696848	920300	2	3
46288600	1713332	0	0
45801611	1595799	0	0
45791201	1177480	0	0
46289024	1112807	0	0
45894267	1115008	0	0
46307301	19079524	1	1
46319159	1125315	0	0
4043023	4057420	5	5
4101212	30753	2	2
21600192	40243436	2	3
21604795	40223768	0	3
21601421	1305058	2	2
35402603	372328	1	1
36208195	3006923	2	5
37522270	4323208	2	2
44359019	1551099	0	0
44343073	1322184	0	0
44353072	1112807	0	0
44346248	19019273	2	3
45655327	1310149	0	0
45619683	1125315	0	0
45647412	1125315	0	0
45659799	1174888	0	0
45633183	1125315	0	0
45663952	1124300	0	0
45699510	1149196	0	0
45689142	1118084	0	0
45689786	1125315	0	0
45687676	1115008	0	0
45674891	1119510	0	0
45687888	1759842	0	0
45696666	40163554	2	3
46288607	1549786	0	0
45801611	1549786	0	0
45791142	1177480	0	0
46289157	1112807	0	0
45894268	1500211	0	0
46308433	19079524	1	1
46319385	1125315	0	0
4043023	4078793	5	5
4048512	78272	2	2
21505737	19059056	2	3
21602842	19133873	0	3
21601854	1539403	2	2
35104366	4280726	1	1
36211303	4142905	2	7
40652424	3049273	2	2
44359234	1107830	0	0
44343216	738818	0	0
44353073	1149380	0	0
44353588	19019273	2	3
45655301	1118084	0	0
44360451	1125315	0	0
45647552	1125315	0	0
45660052	1107830	0	0
45633188	1125315	0	0
45663959	975125	0	0
45699361	1539403	0	0
45689150	1310149	0	0
45689790	1125315	0	0
45687280	1192710	0	0
45674772	1119510	0	0
45687834	1501700	0	0
45696834	19019273	2	3
46288301	1112807	0	0
45801612	1154343	0	0
45791259	1177480	0	0
46289060	1112807	0	0
45894278	1551099	0	0
46319612	19079524	1	1
46319390	1125315	0	0
4180169	133834	5	5
4042641	4218408	2	2
21505756	19019273	2	3
21602886	19074843	0	3
35402602	372328	2	2
35104341	4280726	1	1
36208195	3000963	2	6
40652448	3049273	2	2
44359196	1729720	0	0
44343012	723013	0	0
44353258	738818	0	0
44348279	19019273	2	3
45655315	1332418	0	0
44360453	1125315	0	0
45647585	1125315	0	0
45660053	1310149	0	0
45633203	1125315	0	0
45663945	1124957	0	0
45699381	1326303	0	0
45689152	1000560	0	0
45689898	1125315	0	0
45687379	1713332	0	0
45675084	1119510	0	0
45687492	975125	0	0
45802696	40232448	2	3
46287974	1322184	0	0
45801554	1309944	0	0
45791154	1177480	0	0
46289210	1112807	0	0
45894395	1192710	0	0
46304864	19079524	1	1
46239815	1125315	0	0
4180170	4048171	5	5
4042641	4163951	2	2
21003656	46233710	2	3
21604566	19076374	0	3
21603671	1343916	2	2
21601767	40171902	1	1
36208195	3045716	2	6
40652431	3024561	2	2
44359173	1549786	0	0
44343015	1759842	0	0
44353265	1500211	0	0
44346646	19019273	2	3
45655181	1307863	0	0
44360509	1125315	0	0
45647806	1125315	0	0
45656656	1000560	0	0
45633487	1125315	0	0
45663984	1322184	0	0
45699524	1115008	0	0
45689307	914335	0	0
45689824	1125315	0	0
45687534	738818	0	0
45674729	1119510	0	0
45687505	1738521	0	0
45802861	40229134	2	3
46288200	1322184	0	0
45801567	1115008	0	0
45791529	1177480	0	0
46289375	1112807	0	0
45894285	1332418	0	0
46309292	19079524	1	1
46239885	1125315	0	0
4180170	258780	5	5
4030292	4116491	2	2
21004496	19129655	2	3
21600989	19075601	0	3
21602099	975125	2	2
35202472	4329847	1	2
36208195	3014576	2	6
40652431	3016723	2	2
44359173	1515774	0	0
44343015	1713332	0	0
44353267	715997	0	0
44338725	19019273	2	3
45655304	1154343	0	0
44360741	1125315	0	0
45647501	1125315	0	0
45656923	738818	0	0
45633646	1125315	0	0
45663985	1110410	0	0
45695868	1110410	0	0
45689299	1115008	0	0
45690123	1125315	0	0
45687536	1738521	0	0
45671750	1119510	0	0
45687663	975125	0	0
45803046	19008572	2	3
46288060	1124300	0	0
45801440	1149196	0	0
46299140	1177480	0	0
46289975	1112807	0	0
45894235	791967	0	0
46316590	19079524	1	1
46239998	1125315	0	0
4134149	4330583	5	5
4030031	4057420	2	2
21004497	19129655	2	3
21604799	40222846	0	3
21605125	967823	2	2
35202471	317576	1	2
36208195	3019550	2	6
40652431	3013682	2	2
44359200	1551099	0	0
44343020	738818	0	0
44353345	975125	0	0
44360630	19019273	2	3
45655332	1115008	0	0
44360896	1125315	0	0
45647811	1125315	0	0
45657176	1326303	0	0
45633396	1125315	0	0
45664017	705944	0	0
45695901	740275	0	0
45689233	1000560	0	0
45689812	1125315	0	0
45686065	1125315	0	0
45671789	1119510	0	0
45687672	1124957	0	0
45802977	19007333	2	3
46288185	1521369	0	0
45801442	920293	0	0
46298940	1177480	0	0
46241617	1112807	0	0
45894291	1713332	0	0
46304638	19079524	1	1
46239837	1125315	0	0
4130852	40479422	5	5
4181251	78272	2	2
21600303	46275916	2	3
21604417	19074679	0	3
21605058	914335	2	2
35200000	4051466	6	6
36208195	3023103	2	6
40652431	3008598	2	2
44359293	1501700	0	0
44342909	1738521	0	0
44353269	975125	0	0
44355443	19078461	2	3
45655183	1149196	0	0
44360673	1125315	0	0
45647766	1125315	0	0
45656724	19127890	0	0
45633398	1125315	0	0
45664023	1310149	0	0
45695812	1124957	0	0
45689162	738818	0	0
45689954	1125315	0	0
45685933	1125315	0	0
45671857	1119510	0	0
45687928	1332418	0	0
45803131	40174880	2	3
46288185	1549786	0	0
45801446	1174888	0	0
46299349	1177480	0	0
46241847	1112807	0	0
45894355	1115008	0	0
46307013	19079524	1	1
46239838	1125315	0	0
4181192	4107731	4	5
4181583	40481087	2	2
21004494	19129655	2	3
21604797	19077572	0	3
21601422	1305058	2	2
35200000	381316	6	6
36208195	3015632	2	6
40652431	3004501	2	2
44359294	1129625	0	0
44342911	1551099	0	0
44353271	1129625	0	0
44359784	19019273	2	3
45655281	1595799	0	0
44360682	1125315	0	0
45647945	1125315	0	0
45656724	1521369	0	0
45633332	1125315	0	0
45664028	1124957	0	0
45695743	1741122	0	0
45689171	1124957	0	0
45689958	1125315	0	0
45688478	1125315	0	0
45671999	1119510	0	0
45687929	1551099	0	0
45800140	40231925	2	3
46288335	1174888	0	0
45801520	967823	0	0
46292007	1177480	0	0
46241886	1112807	0	0
45894396	1118084	0	0
46307197	19079524	1	1
46239851	1125315	0	0
4180170	4112343	4	5
4138262	4107731	2	2
21004495	19129655	2	3
21604571	19057271	0	3
21605126	967823	2	2
35200000	4163874	6	6
35707763	4027663	2	5
40652431	3006906	2	2
44359011	738818	0	0
44342914	1551099	0	0
44353163	738818	0	0
44360717	40223834	2	3
45655281	1521369	0	0
44360845	1125315	0	0
45647739	1125315	0	0
45656724	1549786	0	0
45633342	1125315	0	0
45664085	1332418	0	0
45695743	1746114	0	0
45689237	1174888	0	0
45690030	1125315	0	0
45682728	1125315	0	0
45672135	1119510	0	0
45687948	1759842	0	0
45800027	40236446	2	3
46288348	1149196	0	0
45801651	1557272	0	0
46290582	1177480	0	0
46241821	1112807	0	0
45894365	1192710	0	0
46314824	19079524	1	1
46239860	1125315	0	0
4190185	4112343	4	5
4119403	4323902	2	2
21004491	19129655	2	3
21600965	40163554	0	3
21603923	19010482	2	2
35202051	441267	6	6
35707763	4166224	2	8
40652431	3000963	2	2
44359000	975125	0	0
44343164	1177480	0	0
44353167	975125	0	0
44339041	19123231	2	3
45655281	1549786	0	0
44360642	1125315	0	0
45648014	1125315	0	0
45656673	1548195	0	0
45633623	1125315	0	0
45664165	975125	0	0
45695745	1174888	0	0
45688968	1149196	0	0
45690140	1125315	0	0
45682847	1125315	0	0
45672030	1119510	0	0
45687948	1713332	0	0
45800036	40163554	2	3
46288360	1192710	0	0
45801652	1343916	0	0
46290662	1177480	0	0
46241830	1112807	0	0
45894361	1000560	0	0
46314532	19079524	1	1
46239861	1125315	0	0
4043346	4329847	4	5
4084434	4149245	2	2
21009232	46233710	2	3
21602660	40236824	0	3
21605059	914335	2	2
35202051	4310024	6	6
35707763	4310024	1	6
40652431	3023103	2	2
44359304	738818	0	0
44343405	1738521	0	0
44353171	1112807	0	0
44346154	40163554	2	3
45652769	791967	0	0
44360790	1125315	0	0
45647828	1125315	0	0
45656864	1545958	0	0
45633637	1125315	0	0
45664030	1124300	0	0
45695747	1728416	0	0
45689253	1124957	0	0
45690117	1125315	0	0
45682854	1125315	0	0
45672036	1119510	0	0
45687959	1192710	0	0
45800123	19078924	2	3
46288366	1124300	0	0
45801657	19127890	0	0
46290880	1177480	0	0
45895928	1112807	0	0
45894419	1149196	0	0
46301157	19079524	1	1
46239944	1125315	0	0
4162054	4108705	4	5
4086016	4230209	2	2
21004631	19129655	2	3
21604794	836659	0	3
21604304	1112807	2	2
21602359	19127918	6	6
35707763	4266809	1	6
40652431	3028833	2	2
44359306	738818	0	0
44343051	1177480	0	0
44353377	1129625	0	0
44339293	1545959	2	3
45652776	705944	0	0
44360849	1125315	0	0
45647835	1125315	0	0
45656695	738818	0	0
45633438	1125315	0	0
45664037	1367571	0	0
45695584	1000560	0	0
45689397	1501700	0	0
45690042	1125315	0	0
45682858	1125315	0	0
45672083	1119510	0	0
45687795	1000560	0	0
45800373	19019273	2	3
46288438	1548195	0	0
45801657	1549786	0	0
46290772	1177480	0	0
45803832	1112807	0	0
45894424	1192710	0	0
46312891	19079524	1	1
46321843	1125315	0	0
4101796	378419	4	5
4086016	4234705	2	2
21004632	19129655	2	3
21502567	914335	0	0
21604269	1154029	2	2
21602359	42902245	6	6
35707763	192671	1	4
40652431	3020630	2	2
44359314	1539403	0	0
44342915	1551099	0	0
44353292	1129625	0	0
44338953	1713671	2	3
45652824	1124957	0	0
44360606	1125315	0	0
45647932	1125315	0	0
45656839	1309944	0	0
45633650	1125315	0	0
45663995	1174888	0	0
45695593	1309944	0	0
45689073	1124957	0	0
45690055	1125315	0	0
45682866	1125315	0	0
45783997	1119510	0	0
45687865	791967	0	0
45800381	19133873	2	3
46288447	1548195	0	0
45801658	1154343	0	0
46242523	1177480	0	0
45798936	1112807	0	0
45894511	738818	0	0
46302263	19079524	1	1
46321960	1125315	0	0
4172024	4139681	4	5
4049972	441267	2	2
21004854	19129655	2	3
21502572	1589505	0	0
21604269	1102527	2	2
21602359	19133679	6	6
36211260	81151	1	3
40652433	3006906	2	2
44359352	1177480	0	0
44343061	1115008	0	0
44353293	19127890	0	0
44348284	19019273	2	3
45652852	1000560	0	0
44360987	1125315	0	0
45647934	1125315	0	0
45656681	1149196	0	0
45633548	1125315	0	0
45663998	1549786	0	0
45695757	1717327	0	0
45689470	1332418	0	0
45690178	1125315	0	0
45683022	1125315	0	0
45784113	1119510	0	0
45687908	914335	0	0
45800232	19019273	2	3
45897778	19073183	2	3
45801710	715997	0	0
46242359	1177480	0	0
45798710	1112807	0	0
45894303	1000560	0	0
46302263	46275916	1	1
46321962	1125315	0	0
4042503	4134304	4	5
4051932	4078793	2	2
21002574	19129655	2	3
21502572	1549786	0	0
21604255	1110410	2	2
21602359	19129144	6	6
36207527	40766240	1	3
40652433	3014576	2	2
44351888	1129625	0	0
44343062	1310149	0	0
44353293	1521369	0	0
44353307	19019273	2	3
45652929	738818	0	0
44360885	1125315	0	0
45644496	1125315	0	0
45656899	1174888	0	0
45633687	1125315	0	0
45663998	1521369	0	0
45695846	1501700	0	0
45689367	1124957	0	0
45689967	1125315	0	0
45683084	1125315	0	0
45784069	1119510	0	0
45687915	967823	0	0
45800235	40229134	2	3
45787779	1107882	2	3
45801679	1549786	0	0
46239452	1177480	0	0
45799017	1112807	0	0
45894519	757627	0	0
46303493	19079524	1	1
46322225	1125315	0	0
4043176	4336464	4	5
4050572	40492359	2	2
21001936	19129655	2	3
21502572	1595799	0	0
21601855	1539403	2	2
21602359	19128009	6	6
36207527	40769179	1	3
40652433	3035995	2	2
44352323	920293	0	0
44339271	1759842	0	0
44353293	1549786	0	0
44360570	19019273	2	3
45652856	1000560	0	0
44361077	1125315	0	0
45644533	1125315	0	0
45656933	1713332	0	0
45633697	1125315	0	0
45664112	791967	0	0
45695873	1124300	0	0
45689373	1549786	0	0
45690181	1125315	0	0
45682942	1125315	0	0
45784188	1119510	0	0
45687741	1192710	0	0
45800309	19008572	2	3
46241489	1107882	2	3
45801679	19127890	0	0
45896232	1177480	0	0
45793779	1112807	0	0
45894400	1000560	0	0
46300083	19079524	1	1
46321749	1125315	0	0
4182161	40481087	4	5
4051796	4330583	2	2
21503065	46275916	2	3
21502572	19127890	0	0
21601855	1545958	2	2
21602359	19128263	6	6
36207527	40769194	1	3
40652433	3045716	2	2
44352326	967823	0	0
44339276	1153428	0	0
44355558	1149196	0	0
44353230	46233710	2	3
45652863	740275	0	0
44360854	1125315	0	0
45644670	1125315	0	0
45656752	1154343	0	0
45633413	1125315	0	0
45664116	1768849	0	0
45697539	1124300	0	0
45689344	723013	0	0
45690237	1125315	0	0
45683008	1125315	0	0
45784238	1119510	0	0
45687744	1124957	0	0
45802307	40236446	2	3
45803462	1107882	2	3
45801528	1738521	0	0
45896201	1177480	0	0
45793658	1112807	0	0
45802371	1539403	0	0
45876002	3028833	1	1
46321750	1125315	0	0
4042140	80180	4	5
4045900	4170947	2	2
21003586	40243436	2	3
21502572	1521369	0	0
21604343	1125315	2	2
21602359	19127922	6	6
36207527	3006322	1	3
40652433	3006923	2	2
44352327	1124300	0	0
44339410	705944	0	0
44355423	1149380	0	0
44341385	1332419	2	3
45653032	1174888	0	0
44361014	1125315	0	0
45644687	1125315	0	0
45656753	1501700	0	0
45630373	1125315	0	0
45664172	1343916	0	0
45697704	738818	0	0
45689536	1153428	0	0
45690244	1125315	0	0
45683103	1125315	0	0
45784095	1119510	0	0
45687962	1713332	0	0
45797369	19019273	2	3
46241496	1107882	2	3
45801679	1512674	0	0
45893968	1177480	0	0
45793544	1112807	0	0
45802374	723013	0	0
45876002	3016723	1	1
46321761	1125315	0	0
4180169	198809	4	5
4193783	4314290	2	2
21505859	40236446	2	3
21502573	1500211	0	0
21603396	1119510	2	2
21602359	19128022	6	6
36207527	21494966	1	3
40652433	3015632	2	2
44352051	1112807	0	0
44339412	1192710	0	0
44355677	975125	0	0
44339417	1107882	2	3
45652895	1174888	0	0
44360828	1125315	0	0
45644700	1125315	0	0
45656757	1310149	0	0
45630496	1125315	0	0
45664045	1107830	0	0
45697713	1115008	0	0
45689485	1154343	0	0
45690361	1125315	0	0
45682752	1125315	0	0
45784289	1119510	0	0
45688627	1539403	0	0
45797461	19073188	2	3
45798067	19075001	2	3
45801669	1107830	0	0
45894068	1177480	0	0
45788470	1112807	0	0
45802375	1192710	0	0
45876002	3045716	1	1
46322189	1125315	0	0
4134598	4323902	4	5
4194763	4037675	2	2
21004571	40243436	2	3
21502574	1589505	0	0
21603931	19019273	6	7
21602796	19075001	5	6
36207527	40769189	1	3
40652433	3004501	2	2
44352057	1551099	0	0
44339416	1521369	0	0
44355687	1177480	0	0
44353503	1107882	2	3
45649595	1124957	0	0
44361039	1125315	0	0
45644560	1125315	0	0
45656762	1107830	0	0
45630509	1125315	0	0
45664181	1192710	0	0
45697654	738818	0	0
45689489	19010482	0	0
45690194	1125315	0	0
45682756	1125315	0	0
45781878	1119510	0	0
45688594	1115008	0	0
45797477	19075001	2	3
45895250	1107882	2	3
45801673	967823	0	0
45893946	1177480	0	0
45788316	1112807	0	0
45802376	1115008	0	0
46317796	1149196	0	0
46321925	1125315	0	0
4042140	4296204	5	8
4182007	80809	2	2
21002822	1115171	2	3
21502574	975125	0	0
21603931	42707627	6	7
21602796	1713671	5	6
36207527	40758406	1	3
40652433	3013721	2	2
44352196	1309944	0	0
44339416	1548195	0	0
44355556	1112807	0	0
44359771	1107882	2	3
45649529	1539403	0	0
43534659	1361711	1	1
45644561	1125315	0	0
45656846	1545958	0	0
45630017	1125315	0	0
45664155	1154029	0	0
45697322	1309944	0	0
45689542	723013	0	0
45690263	1125315	0	0
45683162	1125315	0	0
45781967	1119510	0	0
45688394	975125	0	0
45797531	1115171	2	3
45801157	1107882	2	3
45801674	1501700	0	0
45893841	1177480	0	0
45788480	1112807	0	0
45802130	1118084	0	0
46313399	701322	0	0
46321928	1125315	0	0
4042140	4001336	5	9
4042518	4010253	2	2
21503375	19008572	2	3
21502575	975125	0	0
21603931	40173590	6	7
21603444	40232448	5	6
36207527	40769184	1	3
40652433	3013682	2	2
44352199	1174888	0	0
44339505	1174888	0	0
44355715	1112807	0	0
44338659	1107882	2	3
45649534	1501700	0	0
45620188	19079524	1	1
45644576	1125315	0	0
45656933	1759842	0	0
45630447	1125315	0	0
45664187	1149196	0	0
45697659	1717327	0	0
45689546	1110410	0	0
45690272	1125315	0	0
45683336	1125315	0	0
45782078	1119510	0	0
45688482	1326303	0	0
45797544	40229134	2	3
45790241	19079524	2	3
45801675	1149196	0	0
45893953	1177480	0	0
45788448	1112807	0	0
45802448	1361711	0	0
46313320	1738521	0	0
46321930	1125315	0	0
4042140	4142905	5	9
4185207	4218389	2	2
21013458	40236446	2	3
21502575	1519936	0	0
21603931	19078461	6	7
35200000	321042	3	6
36217373	19129655	1	2
40652433	3019550	2	2
44352207	1738521	0	0
44339512	738818	0	0
44355421	975125	0	0
44360265	1107882	2	3
45649684	740275	0	0
45620254	46275916	1	1
45645870	1125315	0	0
45656945	914335	0	0
45630514	1125315	0	0
45664361	1539403	0	0
45697821	1153428	0	0
45689609	1308738	0	0
45690203	1125315	0	0
45683093	1125315	0	0
45781915	1119510	0	0
45688490	933724	0	0
45797547	1115171	2	3
45790262	1107882	2	3
45801676	1174888	0	0
45894123	1177480	0	0
45788607	1112807	0	0
45799653	1153428	0	0
46313365	1501700	0	0
46322157	1125315	0	0
4042140	4027663	5	7
4095850	4066995	2	2
21500561	40236446	2	3
21500286	1129625	0	0
21602359	43012433	6	7
21603444	19112599	3	6
36212546	19076374	1	2
40652433	3028833	2	2
44352336	1343916	0	0
44339476	1177480	0	0
44355232	1551099	0	0
44360842	19078461	2	3
45649626	708298	0	0
45620254	19079524	1	1
45646102	1125315	0	0
45656948	1149196	0	0
45630152	1125315	0	0
45664065	1759842	0	0
45697830	1115008	0	0
45689568	1115008	0	0
45690157	1125315	0	0
45682953	1125315	0	0
45782047	1119510	0	0
45688504	975125	0	0
45797550	19018935	2	3
46238604	1107882	2	3
45801699	1326303	0	0
45894149	1177480	0	0
45788410	1112807	0	0
45799865	1000560	0	0
46313441	1332418	0	0
46322486	1125315	0	0
4042140	78272	5	11
4095850	4048695	2	2
21001710	46275916	2	3
21500299	1343916	0	0
21602359	40224805	6	7
21603444	1150771	3	6
36211065	4142905	1	2
40652433	3009201	2	2
44352347	708298	0	0
44339611	1124957	0	0
44355247	1112807	0	0
44353707	1107882	2	3
45649746	1115008	0	0
45621677	19079524	1	1
45645929	1125315	0	0
45656949	1124300	0	0
45630215	1125315	0	0
45664065	1713332	0	0
45697605	1000560	0	0
45686233	1501700	0	0
45690159	1125315	0	0
45682954	1125315	0	0
45782050	1119510	0	0
45684561	1512674	0	0
45797538	19018935	2	3
45786027	1107882	2	3
45801704	1115008	0	0
45894673	1177480	0	0
45788621	1112807	0	0
45799828	1539403	0	0
46313457	1192710	0	0
46321995	1125315	0	0
4042140	4043241	8	11
4134595	4056621	2	2
21001967	40243436	2	3
21500286	738818	0	0
21602359	40224132	6	7
21603444	40228214	3	6
36224505	19029476	1	2
40652433	3024561	2	2
44355207	1322184	0	0
44339616	1308738	0	0
44355277	791967	0	0
44359828	1107882	2	3
45649709	1174888	0	0
45619836	19079524	1	1
45645933	1125315	0	0
45656951	791967	0	0
45630218	1125315	0	0
45664138	1332418	0	0
45697677	1549786	0	0
45686259	1110410	0	0
45686794	1125315	0	0
45682967	1125315	0	0
45782200	1119510	0	0
45684561	19127890	0	0
45797644	1154615	2	3
45895355	1107882	2	3
45801729	1124300	0	0
45798249	1129625	0	0
46301463	1112807	0	0
45799961	715997	0	0
46313277	1545958	0	0
46322062	1125315	0	0
4042140	372328	4	7
4185206	4066995	2	2
21004753	46275444	2	3
21500337	1174888	0	0
35202051	4283893	6	7
21603444	1150837	3	6
36218126	19075001	1	2
40652433	3019406	2	2
44355208	1129625	0	0
44339482	740275	0	0
44355296	1589505	0	0
44339049	1107882	2	3
45649610	1149196	0	0
45647246	19128009	2	2
45644728	1125315	0	0
45656868	1332418	0	0
45630323	1125315	0	0
45664236	1115008	0	0
45695935	1149196	0	0
45686262	1154343	0	0
45688736	1125315	0	0
45683370	1125315	0	0
45782011	1119510	0	0
45684561	1549786	0	0
45797458	40162522	2	3
45679221	1332419	2	3
45796005	1000560	0	0
45798529	1129625	0	0
46289697	1112807	0	0
45799936	708298	0	0
46313277	1332418	0	0
46322312	1125315	0	0
4042140	4066995	4	9
4185206	4048695	2	2
21004035	19078924	2	3
21500293	1129625	0	0
35202461	40481087	6	7
21603444	40228230	3	6
36211677	4066995	1	2
40652433	3001247	2	2
44355210	1343916	0	0
44339504	975125	0	0
44355240	738818	0	0
44360339	1107882	2	3
45649612	1124957	0	0
45649292	40174880	2	3
45644828	1125315	0	0
45657130	1000560	0	0
45631255	1125315	0	0
45660789	1332418	0	0
45695949	1326303	0	0
45686247	1343916	0	0
45688409	1125315	0	0
45683069	1125315	0	0
45779578	1119510	0	0
45684571	1107830	0	0
45797575	19129655	2	3
45792920	19079524	2	3
45796133	791967	0	0
45798601	1129625	0	0
46290057	1112807	0	0
45799942	738818	0	0
46313322	1112807	0	0
46322338	1125315	0	0
4042140	261325	4	9
4040539	4301346	2	2
21001876	40169216	2	3
21500294	1192710	0	0
35202461	28060	6	7
21602796	19133873	3	6
36223749	40163554	1	2
40652433	3023103	2	2
44355219	1778162	0	0
44339617	1177480	0	0
44355303	738818	0	0
44338430	1107882	2	3
45649821	1107830	0	0
45631756	19075601	2	3
45644837	1125315	0	0
45656876	1107830	0	0
45630959	1125315	0	0
45660791	975125	0	0
45695950	791967	0	0
45686246	1174888	0	0
45688411	1125315	0	0
45682925	1125315	0	0
45779649	1119510	0	0
45684673	1107830	0	0
45797727	40231925	2	3
45895544	1107882	2	3
45796006	1310149	0	0
45798334	1129625	0	0
46290313	1112807	0	0
600000004	740275	0	0
46313583	1595799	0	0
46322495	1125315	0	0
4042140	140673	4	6
4101796	4029498	2	2
21004841	1551192	2	3
21500320	1119510	0	0
35202461	255848	5	7
21602796	19074841	3	6
36223748	40163554	1	2
40652433	3008598	2	2
44355222	738818	0	0
44339623	738818	0	0
44355244	715997	0	0
44339167	1332419	2	3
45649879	742185	0	0
45631986	46275444	2	3
45644840	1125315	0	0
45657079	738818	0	0
45630531	1125315	0	0
45660740	975125	0	0
45695953	1521369	0	0
45686338	1343916	0	0
45688697	1125315	0	0
45679609	1125315	0	0
45779730	1119510	0	0
45684679	1000560	0	0
45797583	19008572	2	3
45795719	19075601	2	3
45796008	975125	0	0
45798582	1129625	0	0
46242240	1112807	0	0
600000005	723013	0	0
46313583	1549786	0	0
46322344	1125315	0	0
4042140	4218389	4	6
4040537	4295880	2	2
21002222	19129655	2	3
21500343	1129625	0	0
35202461	257012	4	7
21602796	19073188	3	6
36223456	1551192	1	2
40652433	3016723	2	2
44355431	1149380	0	0
44339632	1332418	0	0
44353383	1539403	0	0
44338561	1332419	2	3
45649635	742185	0	0
45631991	40162522	2	3
45644747	1125315	0	0
45656993	914335	0	0
45630542	1125315	0	0
45660747	738818	0	0
45695953	1549786	0	0
45686299	738818	0	0
45687043	1125315	0	0
45679827	1125315	0	0
45779736	1119510	0	0
45684767	1149196	0	0
45797584	1115171	2	3
45897905	19073188	2	3
45796009	1115008	0	0
45798719	1129625	0	0
46242325	1112807	0	0
600000005	791967	0	0
46313583	1521369	0	0
46322350	1125315	0	0
4042140	4051466	4	5
19102032	1519937	1	1
21002222	1713671	2	3
21500343	1119510	0	0
35205038	261325	4	7
21602796	19074843	3	6
36218152	40228230	1	2
40652433	3020655	2	2
44355458	1107830	0	0
44339646	1549786	0	0
44353447	738818	0	0
44345840	1332419	2	3
45649644	1115008	0	0
45632004	40162522	2	3
45644866	1125315	0	0
45656994	1115008	0	0
45630543	1125315	0	0
45660924	1149196	0	0
45696037	1107830	0	0
45686323	1595799	0	0
45687103	1125315	0	0
45682379	1125315	0	0
45779803	1119510	0	0
45684522	967823	0	0
45797587	1115171	2	3
45897905	19073183	2	3
45796012	1310149	0	0
45793285	1129625	0	0
46242027	1112807	0	0
46317571	975125	0	0
46313512	1107830	0	0
46316011	1125315	0	0
4042140	4280726	4	10
4311853	198199	1	1
21500785	19077344	2	3
21500343	738818	0	0
35200000	4310024	7	7
35202457	313217	4	6
36218125	19075001	1	2
40652433	3006734	2	2
44355406	738818	0	0
44339251	1545958	0	0
44353422	1112807	0	0
44360103	19075601	2	3
45649849	1501700	0	0
45632013	1127433	2	3
45641962	1125315	0	0
45656999	1501700	0	0
45630617	1125315	0	0
45660753	708298	0	0
45695966	975125	0	0
45686213	1521369	0	0
45687240	1125315	0	0
45682315	1125315	0	0
45779590	1119510	0	0
45684640	1501700	0	0
45797600	19077344	2	3
45787711	19078461	2	3
45796014	1521369	0	0
45793372	1129625	0	0
45893706	1112807	0	0
46318076	1307863	0	0
46313517	1192710	0	0
46316068	1125315	0	0
4042140	4285898	4	11
4235863	4066995	1	1
21004615	19129655	2	3
21500343	1192710	0	0
35200000	441267	7	7
35204989	313217	3	4
36224044	40232448	1	2
40652433	3020630	2	2
44355442	1153428	0	0
44339484	1174888	0	0
44345748	1343916	0	0
44362506	19078461	2	3
45649853	1595799	0	0
45632139	40165015	2	3
45641851	1125315	0	0
45657000	1107830	0	0
45630547	1125315	0	0
45660946	1192710	0	0
45696064	723013	0	0
45686213	1595799	0	0
45687116	1125315	0	0
45682736	42902245	1	2
45779705	1119510	0	0
45684647	1192710	0	0
45797851	40224805	2	3
46288566	1332419	2	3
45796224	975125	0	0
45793117	1129625	0	0
45893710	1112807	0	0
46318026	1551099	0	0
46313534	1124957	0	0
46316316	1125315	0	0
4117930	81893	9	10
4199590	4230399	1	1
21002475	19128263	1	1
21500324	1125443	0	0
35202456	321042	1	1
35202457	321042	3	4
36218398	19008572	1	2
36700000	4218389	4	4
44352441	1310149	0	0
44339445	1589505	0	0
44345322	1192710	0	0
44353747	19078461	2	3
45649888	1174888	0	0
45631874	19008572	2	3
45641816	1125315	0	0
45657002	1549786	0	0
45630553	1125315	0	0
45661023	1551099	0	0
45696076	1332418	0	0
45686213	1549786	0	0
45687120	1125315	0	0
45703952	40221415	3	4
45779782	1119510	0	0
45684648	1192710	0	0
45797699	19077344	2	3
46241441	1332419	2	3
45795943	967823	0	0
45793118	1129625	0	0
45893840	1112807	0	0
46318059	967823	0	0
46313695	701322	0	0
46316325	1125315	0	0
4156265	4156265	0	0
21000766	19029476	1	1
21002475	19128022	1	1
21500360	1119510	0	0
35202456	4324181	1	1
35204998	4329847	3	4
36224043	40232448	1	2
40772935	3035995	4	4
44352445	1738521	0	0
44339446	1548195	0	0
44345752	1129625	0	0
44345675	19079524	2	3
45649657	1549786	0	0
45632226	40232448	2	3
45621451	1125315	0	0
45657002	1521369	0	0
45630686	1125315	0	0
45661024	1115008	0	0
45696027	1149196	0	0
45686283	1501700	0	0
45687121	1125315	0	0
45700857	19127918	3	4
45779823	1119510	0	0
45684747	1174888	0	0
45794794	42707627	2	3
46243285	40173590	2	3
45796249	1343916	0	0
45793386	1129625	0	0
45893844	1112807	0	0
46318162	738818	0	0
46313469	1154029	0	0
46316379	1125315	0	0
4163872	4163872	0	0
19132303	19132304	1	1
21002475	19127918	1	1
21500360	1192710	0	0
35104382	4280726	1	1
21604255	40231925	3	4
36224173	40223768	1	2
40772935	3045716	4	4
44352466	920293	0	0
44339553	1112807	0	0
44345791	1112807	0	0
44355244	40223768	2	3
45649657	1589505	0	0
45632227	19008572	2	3
45621462	1125315	0	0
45657002	19127890	0	0
45630642	1125315	0	0
45660986	1110410	0	0
45695969	1738521	0	0
45686681	738818	0	0
45683950	1125315	0	0
45876033	3006906	2	2
45779533	1119510	0	0
45684798	1551099	0	0
45794853	19075601	2	3
45897781	1332419	2	3
45795992	914335	0	0
45794721	1129625	0	0
45893833	1112807	0	0
46318279	1154029	0	0
46313490	1124300	0	0
46316270	1125315	0	0
4163874	4163874	0	0
19133767	40162522	1	1
21002493	19127904	1	1
21500360	1125315	0	0
35104704	439777	1	1
21604255	35605858	3	4
36223969	40223768	1	2
40772935	3019550	4	4
44352516	1115008	0	0
44339558	738818	0	0
44345791	1177480	0	0
44360674	19075601	2	3
45649657	19127890	0	0
45634094	19019273	2	3
45621530	1125315	0	0
45657003	1521369	0	0
45630713	1125315	0	0
45660760	1115008	0	0
45695973	1361711	0	0
45686683	1149196	0	0
45684094	1125315	0	0
45876033	3000963	2	2
45779884	1119510	0	0
45684534	1332418	0	0
45797134	40231925	2	3
45895340	40223768	2	3
45796028	1115008	0	0
45794809	1129625	0	0
45801734	1112807	0	0
46318293	1124300	0	0
46313597	1112807	0	0
46310638	1125315	0	0
4146173	4146173	0	0
19133767	19133768	1	1
21002493	42902245	1	1
21013676	1000560	0	0
35104347	4280726	1	1
21604343	40229134	3	4
36218151	40228214	1	2
40772935	3004501	4	4
44352418	1738521	0	0
44339561	1112807	0	0
44345791	1129625	0	0
44339040	40228214	2	3
45649666	1308738	0	0
45634096	40232448	2	3
45621746	1125315	0	0
45657004	1549786	0	0
45630625	1125315	0	0
45660670	1343916	0	0
45696081	19039298	0	0
45686330	723013	0	0
45684127	1125315	0	0
45876033	3024561	2	2
45779920	1119510	0	0
45684751	1738521	0	0
45796916	40231925	2	3
45789298	40173590	2	3
45796031	967823	0	0
45794662	1129625	0	0
45801529	1112807	0	0
46317862	1521369	0	0
46313611	1124300	0	0
46311214	1125315	0	0
4134304	4134304	0	0
19133904	19133905	1	1
21002493	19128263	1	1
21013627	1551099	0	0
35508066	1332419	2	3
21604343	40162522	3	4
36218151	40228230	1	2
40772935	3015632	4	4
44352472	1129625	0	0
44339348	1332418	0	0
44345753	1545958	0	0
44338676	40228214	2	3
45649727	1107830	0	0
45634211	40232448	2	3
45621643	1125315	0	0
45657004	19127890	0	0
45627718	1125315	0	0
45660672	1192710	0	0
45692652	1149196	0	0
45686375	920293	0	0
45684180	1125315	0	0
45876033	3009201	2	2
45779838	1119510	0	0
45684653	1308738	0	0
45797184	40223768	2	3
46296446	19079524	2	3
45796238	1549786	0	0
45787864	1129625	0	0
45801638	1112807	0	0
46317862	1549786	0	0
46313547	975125	0	0
46310857	1125315	0	0
4116491	4116491	0	0
19133872	19133873	1	1
21002493	40221415	1	1
21013692	740275	0	0
35507962	1107882	2	3
21604343	40231925	3	4
36217723	1332419	1	2
40772935	3016723	4	4
44352551	1112807	0	0
44339361	1149380	0	0
44345725	1177480	0	0
44338973	40228214	2	3
45649735	1149196	0	0
45634216	19008572	2	3
45621537	1125315	0	0
45657004	1512674	0	0
45627722	1125315	0	0
45660675	1107830	0	0
45692940	1308738	0	0
45686376	1545958	0	0
45684201	1125315	0	0
45876033	3013682	2	2
45779932	1119510	0	0
45684756	1778162	0	0
45797188	40229134	2	3
45792981	1332419	2	3
45796238	1518198	0	0
45787886	1129625	0	0
45798990	1112807	0	0
46317866	975125	0	0
46313550	1112807	0	0
46311487	1125315	0	0
4117038	4117038	0	0
19083337	19045231	1	1
21002506	42902245	1	1
21002594	975125	0	0
35508059	1107882	2	3
21603396	40229134	3	4
36217722	1332419	1	2
40772935	3006906	4	4
44352434	1124300	0	0
44339437	1177480	0	0
44345675	967823	0	0
44338531	40228214	2	3
45649899	1548195	0	0
45628898	40163554	2	3
45621817	1125315	0	0
45656720	708298	0	0
45627731	1125315	0	0
45660661	1124957	0	0
45692915	738818	0	0
45686377	705944	0	0
45684020	1125315	0	0
45876033	3008598	2	2
45708117	1119510	0	0
45684800	1192710	0	0
45795013	40162522	2	3
46296765	1332419	2	3
45796259	715997	0	0
45788010	1129625	0	0
45799205	1112807	0	0
46318020	1118084	0	0
46313551	1539403	0	0
46311507	1125315	0	0
4107731	4107731	0	0
4312749	4198190	1	1
21002506	19128022	1	1
21002591	1717327	0	0
35507479	1107882	2	3
21603396	40162522	3	4
36207527	3051031	1	2
40772935	3006923	4	4
44352556	1713332	0	0
44339438	1174888	0	0
44345678	975125	0	0
44360319	19079524	2	3
45649901	708298	0	0
45629060	19076374	2	3
45621544	1125315	0	0
45657110	1174888	0	0
45627529	1125315	0	0
45660993	1115008	0	0
45692938	1174888	0	0
45686365	1192710	0	0
45684084	1125315	0	0
45876033	3016723	2	2
45705936	1119510	0	0
45684502	1153428	0	0
45794977	40231925	2	3
46288946	19075601	2	3
45796375	975125	0	0
45787983	1129625	0	0
45799360	1112807	0	0
46318139	738818	0	0
46313340	1307863	0	0
46310928	1125315	0	0
4108705	4108705	0	0
4313889	4010253	1	1
21002506	19128263	1	1
21002597	1778162	0	0
35508291	40223768	2	3
21601746	1332419	1	4
35909445	196456	1	1
40772935	3027970	4	4
44352606	19127890	0	0
44339439	723013	0	0
44345336	1332418	0	0
44353141	19078461	2	3
45649831	1153428	0	0
45629141	1115171	2	3
45667579	1125315	0	0
45657112	1396131	0	0
45627530	1125315	0	0
45661003	715997	0	0
45692940	1595799	0	0
45686401	1124957	0	0
45684213	1125315	0	0
45785087	19128009	2	2
45705852	1119510	0	0
45684614	1501700	0	0
45795075	40232448	2	3
46241519	19075601	2	3
45796262	1115008	0	0
45787960	1129625	0	0
45793881	1112807	0	0
46317775	914335	0	0
46313391	1112807	0	0
46310933	1125315	0	0
4109685	4109685	0	0
4054054	4146173	1	1
21002506	19127918	1	1
21002597	1759842	0	0
35508016	40223768	2	3
21604343	1127078	1	4
35909452	196456	1	1
40772948	3006451	4	4
44352606	1515774	0	0
44341206	1000560	0	0
44345337	708298	0	0
44359769	19078461	2	3
45649721	1153428	0	0
45629197	1127433	2	3
45667317	1125315	0	0
45657231	1115008	0	0
45627620	1125315	0	0
45660697	1115008	0	0
45693072	1322184	0	0
45686529	738818	0	0
45684217	1125315	0	0
45783005	19128022	2	2
45705785	1119510	0	0
45684850	1332418	0	0
45795048	19008572	2	3
46241257	19075601	2	3
45796055	1310149	0	0
45788037	1129625	0	0
45794098	1112807	0	0
46317781	738818	0	0
46313505	1713332	0	0
46310935	1125315	0	0
4048169	4048169	0	0
4196958	4163971	1	1
21003455	19127918	1	1
21002598	1728416	0	0
35507965	1545959	2	3
21603379	19029476	1	4
35707753	4166224	1	1
36900000	443279	4	4
44352606	1549786	0	0
44341481	1332418	0	0
44345436	1129625	0	0
44345725	19078461	2	3
45649931	1107830	0	0
45629214	1115171	2	3
45667481	1125315	0	0
45657271	738818	0	0
45627752	1125315	0	0
45660703	975125	0	0
45692818	933724	0	0
45686427	1192710	0	0
45684294	1125315	0	0
45777688	42902245	2	2
45705787	1119510	0	0
45684832	1521369	0	0
45795092	1115171	2	3
46243614	19075601	2	3
45796057	1115008	0	0
45787973	1129625	0	0
45794176	1112807	0	0
46317957	1154029	0	0
46313505	1759842	0	0
46310938	1125315	0	0
4048171	4048171	0	0
19081496	19078461	1	1
21506111	1332418	1	1
21002591	1738521	0	0
35509012	40223834	2	3
21602819	19073188	1	4
35707605	4285898	1	1
36400000	40480160	4	4
44352607	1124300	0	0
44341064	1545958	0	0
44345441	975125	0	0
44338553	19078461	2	3
45649940	1309944	0	0
45629192	40229134	2	3
45667484	1125315	0	0
45656889	1107830	0	0
45627699	1125315	0	0
45660704	1124300	0	0
45692702	1107830	0	0
45686429	1521369	0	0
45684029	1125315	0	0
46240251	19127918	2	2
45705893	1119510	0	0
45684837	1115008	0	0
45795095	19018935	2	3
45790519	1332419	2	3
45796058	1501700	0	0
45788203	1129625	0	0
45794121	1112807	0	0
46318249	1174888	0	0
46313655	1154343	0	0
46310942	1125315	0	0
4163951	4163951	0	0
4237320	4218408	1	1
21506123	967823	1	1
21002597	1728416	0	0
35507923	19019273	2	3
21602840	19133873	1	4
35707694	4266809	1	1
37520918	4163971	4	4
44352542	791967	0	0
44341017	1332418	0	0
44345632	1129625	0	0
44345832	19078461	2	3
45649695	1149196	0	0
45628961	19019273	2	3
45667487	1125315	0	0
45657044	1154029	0	0
45627702	1125315	0	0
45660989	1000560	0	0
45692632	975125	0	0
45686429	19127890	0	0
45684231	1125315	0	0
46240251	19128009	2	2
45705971	1119510	0	0
45684983	1322184	0	0
45792272	40236446	2	3
46288200	19075601	2	3
45796061	975125	0	0
45788283	1129625	0	0
45794055	1112807	0	0
46318014	1154343	0	0
46313621	1521369	0	0
46311085	1125315	0	0
4043071	4043071	0	0
4237321	4191853	1	1
21506140	1332418	1	1
21002587	1778162	0	0
35508372	19019273	2	3
21603057	920300	1	4
35707753	440448	1	1
37320089	4296204	4	4
44352523	1177480	0	0
44339679	1177480	0	0
44345793	1112807	0	0
44359823	1332419	2	3
45649698	1174888	0	0
45629092	1127433	2	3
45667405	1125315	0	0
45657047	1500211	0	0
45627771	1125315	0	0
45660951	1192710	0	0
45692774	1768849	0	0
45686429	1549786	0	0
45684317	1125315	0	0
45876038	3002385	2	2
45703751	1119510	0	0
45684986	1110410	0	0
45792274	920334	2	3
46243449	19075601	2	3
45796065	1332418	0	0
46294138	1129625	0	0
45794218	1112807	0	0
46318307	1332418	0	0
46313674	1343916	0	0
46311118	1125315	0	0
4191853	4191853	0	0
4237321	4078793	3	3
21506220	1115008	1	1
21002597	1768849	0	0
35508300	43012036	2	3
21603057	920334	1	4
36210621	3049273	1	1
36903632	378419	4	4
44352547	920293	0	0
44339762	1107830	0	0
44345794	933724	0	0
44360083	1545959	2	3
45649702	1595799	0	0
45628009	40232448	2	3
45667408	1125315	0	0
45657182	1110410	0	0
45627412	1125315	0	0
45660953	1501700	0	0
45692744	1309944	0	0
45686407	1192710	0	0
45684299	1125315	0	0
45876038	3009542	2	2
45702371	1119510	0	0
45684951	1307863	0	0
45792351	1115171	2	3
45897599	19075601	2	3
45796393	975125	0	0
46294143	1129625	0	0
45788733	1112807	0	0
46317705	1107830	0	0
46313936	975125	0	0
46311163	1125315	0	0
4112343	4112343	0	0
4237321	4062501	3	3
21506150	967823	1	1
21002601	1717327	0	0
35507862	43012036	2	3
21604269	40165015	1	4
36211076	40480160	1	1
36903632	440086	4	4
44352425	1309944	0	0
44339833	1124300	0	0
44345754	1129625	0	0
44353478	1332419	2	3
45649702	1308738	0	0
45626116	19008572	2	3
45665342	1125315	0	0
45657186	1549786	0	0
45627838	1125315	0	0
45660906	1759842	0	0
45692754	1115008	0	0
45686462	1110410	0	0
45684326	1125315	0	0
45876038	3026361	2	2
45702478	1119510	0	0
45684958	1738521	0	0
45792420	19077572	2	3
46292647	19075601	2	3
45796246	1545958	0	0
46293892	1129625	0	0
45789011	1112807	0	0
46318096	1192710	0	0
46313948	1557272	0	0
46311185	1125315	0	0
4027663	4027663	0	0
4042516	4170947	3	3
21503152	1129625	1	1
21002597	1741122	0	0
21602831	46275444	2	3
21601855	1539411	1	4
36211103	4059173	1	1
40792793	3009542	4	4
44352433	757627	0	0
44339692	1174888	0	0
44345766	975125	0	0
44345925	1332419	2	3
45649950	1107830	0	0
45626200	40229134	2	3
45665265	1125315	0	0
45657186	1521369	0	0
45627651	1125315	0	0
45660906	1713332	0	0
45692756	1115008	0	0
45686518	19127890	0	0
45684356	1125315	0	0
45876038	3024731	2	2
45702415	1119510	0	0
45684902	1149196	0	0
46244870	705944	0	0
46241636	19078461	2	3
45796189	1521369	0	0
46294057	1129625	0	0
46296760	1112807	0	0
46318106	914335	0	0
46313959	1124957	0	0
46311203	1125315	0	0
4163971	4163971	0	0
4275564	4336464	3	3
21503083	920293	1	1
21002600	1759842	0	0
21602754	40174880	2	3
21601855	1545959	1	4
36211136	4278672	1	1
40792793	3000963	4	4
44352595	740275	0	0
44339699	738818	0	0
44345769	1717327	0	0
44338624	1332419	2	3
45649978	1305058	0	0
45626130	19059056	2	3
45665405	1125315	0	0
45657097	1717327	0	0
45627680	1125315	0	0
45661041	738818	0	0
45693011	1307863	0	0
45686518	1589505	0	0
45684372	1125315	0	0
45876038	3007461	2	2
45699323	1119510	0	0
45684876	1501700	0	0
46244980	914335	0	0
45787865	19079524	2	3
45796189	19127890	0	0
46294239	1129625	0	0
46296893	1112807	0	0
46317720	1738521	0	0
46314014	1501700	0	0
46311094	1125315	0	0
4102123	4102123	0	0
4326426	4337138	3	3
21503144	914335	1	1
21002600	1746114	0	0
35507607	40223834	2	3
21602795	1741122	4	4
36211123	4048695	1	1
37502353	4293740	4	4
44352494	19127890	0	0
44339709	1361711	0	0
44348344	1501700	0	0
44353383	1539411	2	3
45646309	1115008	0	0
45626132	40231925	2	3
45665165	1125315	0	0
45656784	1124957	0	0
45627696	1125315	0	0
45660920	967823	0	0
45693014	1343916	0	0
45686518	1549786	0	0
45655185	46275916	1	1
45680892	40231925	2	3
45699342	1119510	0	0
45684730	1713332	0	0
46244990	708298	0	0
46243532	19075601	2	3
45796175	1174888	0	0
46293901	1129625	0	0
46295432	1112807	0	0
46317908	1332418	0	0
46314024	1549786	0	0
46311304	1125315	0	0
4186930	4186930	0	0
4195288	4202451	3	3
21503148	1154029	1	1
21002607	1746114	0	0
35507567	35605482	2	3
21602795	1778162	4	4
35708073	81893	1	1
37502353	4323208	4	4
44352494	1589505	0	0
44339729	1149380	0	0
44348248	1539403	0	0
44345954	1545959	2	3
45646251	920293	0	0
45626222	1115171	2	3
45665399	1125315	0	0
45653550	1124300	0	0
45624202	1125315	0	0
45661004	1149196	0	0
45692888	1332418	0	0
45686361	1174888	0	0
45701741	46275916	1	1
45680989	19077572	2	3
45699622	1119510	0	0
45684730	1759842	0	0
46291423	1521369	0	0
46241279	1539411	2	3
45796178	791967	0	0
46294209	1129625	0	0
46244575	1112807	0	0
46318195	1332418	0	0
46314024	19127890	0	0
46311239	1125315	0	0
4187458	4187458	0	0
4054054	40479422	3	3
21503149	1154029	1	1
21002600	1717327	0	0
35507572	1115171	2	3
21602795	1768849	4	4
35708038	81893	1	1
40792803	3010813	4	4
44352494	1549786	0	0
44339771	738818	0	0
44348087	975125	0	0
44345791	19078461	2	3
45646318	1115008	0	0
45626223	19008572	2	3
45665380	1125315	0	0
45653582	1332418	0	0
45624341	1125315	0	0
45661050	1713332	0	0
45692636	1545958	0	0
45686700	914335	0	0
45698370	19079524	1	1
45680995	19073183	2	3
45699623	1119510	0	0
45685030	1153428	0	0
46291423	1549786	0	0
46293132	40228214	2	3
45796271	933724	0	0
46294216	1129625	0	0
46244313	1112807	0	0
46318256	1738521	0	0
46314024	1589505	0	0
46311578	1125315	0	0
4155034	4155034	0	0
4054054	40479768	3	3
21503133	19003953	1	1
21002591	1759842	0	0
35507941	1154615	2	3
21602795	920293	4	4
35707843	30753	1	1
40792803	3026361	4	4
44352814	1177480	0	0
44339731	791967	0	0
44348037	738818	0	0
44345791	40232448	2	3
45646370	933724	0	0
45626210	40232448	2	3
45665162	1125315	0	0
45653375	1124957	0	0
45624608	1125315	0	0
45661051	723013	0	0
45692808	1539403	0	0
45686602	1521369	0	0
45695485	46275916	1	1
45681009	19019273	2	3
45699625	1119510	0	0
45685034	1738521	0	0
46291423	1595799	0	0
45803493	40228214	2	3
45796272	1115008	0	0
46294452	1129625	0	0
46244521	1112807	0	0
46318262	933724	0	0
46313969	1332418	0	0
46311594	1125315	0	0
4125906	4125906	0	0
4054054	81151	3	3
21502867	967823	1	1
21002607	1741122	0	0
35507482	19133905	2	3
21602795	1717327	4	4
36517129	4035415	1	1
40796128	3004501	4	4
44352503	1174888	0	0
44339667	1500211	0	0
44348284	1115008	0	0
44339374	1539411	2	3
45646375	1310149	0	0
45626345	43012036	2	3
45665242	1125315	0	0
45653463	1539403	0	0
45624616	1125315	0	0
45661053	975125	0	0
45692809	975125	0	0
45683170	738818	0	0
45695494	19127922	1	1
45681132	40228230	2	3
45699635	1119510	0	0
45681601	1149196	0	0
46291098	1107830	0	0
45786010	40228214	2	3
45796322	975125	0	0
46294579	1129625	0	0
46244547	1112807	0	0
46322396	975125	0	0
46314423	1192710	0	0
46305986	1125315	0	0
4041436	439777	4	6
4043197	4275113	3	3
21503152	738818	1	1
21002592	975125	0	0
35507780	1127433	2	3
21602795	1738521	4	4
36517132	4035415	1	1
37303790	134438	4	4
44352803	1545958	0	0
44339713	1149196	0	0
44348039	920293	0	0
44362717	19078461	2	3
45648856	1539403	0	0
45623153	40231925	2	3
45665368	1125315	0	0
45653411	1107830	0	0
45624620	1125315	0	0
45661076	975125	0	0
45692822	1149196	0	0
45683176	753626	0	0
45695494	19133679	1	1
45681098	920300	2	3
45699576	1119510	0	0
45681602	1174888	0	0
46291223	791967	0	0
45793032	19078461	2	3
45796189	1549786	0	0
46243884	1129625	0	0
45787640	738818	0	0
46322526	1153428	0	0
46313631	1332418	0	0
46322655	1125315	0	0
4179141	4134304	4	6
4184252	140673	3	3
21503197	975125	1	1
21002598	1778162	0	0
35508052	1551192	2	3
21602795	1713332	4	4
36211268	4149245	1	1
37303809	4156265	4	4
44352725	701322	0	0
44339719	1110410	0	0
44348190	1129625	0	0
44362814	19133873	2	3
45648993	1551099	0	0
45622890	1551192	2	3
45665371	1125315	0	0
45653432	1551099	0	0
45624413	1125315	0	0
45661089	1713332	0	0
45692827	705944	0	0
45683115	1738521	0	0
45695494	19129144	1	1
45681369	19059056	2	3
45699350	1119510	0	0
45681492	1557272	0	0
46291521	1174888	0	0
45785945	19078461	2	3
45796398	1713332	0	0
46243714	1129625	0	0
45787293	738818	0	0
46318366	1332418	0	0
46313739	1551099	0	0
46322091	1125315	0	0
4178545	4294548	4	6
4184252	4218389	3	3
21503197	1124300	1	1
21002602	1759842	0	0
35508143	40236824	2	3
21602795	1746114	4	4
36211224	4001336	1	1
37521802	4336464	4	4
44352705	1177480	0	0
44362941	1129625	0	0
44348420	1129625	0	0
44361890	19133905	2	3
45648999	1501700	0	0
45622891	1115171	2	3
45667429	1125315	0	0
45653438	1332418	0	0
45624448	1125315	0	0
45661044	1501700	0	0
45692983	740275	0	0
45683111	1343916	0	0
45695848	46275916	1	1
45675559	19019273	2	3
45699494	1119510	0	0
45682610	1551099	0	0
46291716	1728416	0	0
45787759	19079524	2	3
45796308	975125	0	0
46243936	1129625	0	0
45787777	738818	0	0
45794465	967823	0	0
46313763	1000560	0	0
46322095	1125315	0	0
4178818	4280726	4	6
4043671	4280726	3	3
21503152	1192710	1	1
21002602	1713332	0	0
35508084	1127433	2	3
21601907	1129625	4	4
36211402	4066995	1	1
40599742	4168004	4	4
44352453	738818	0	0
44363251	1129625	0	0
44348422	1107830	0	0
44361891	46275916	2	3
45649002	1326303	0	0
45623030	40174880	2	3
45667275	1125315	0	0
45653697	1107830	0	0
45624452	1125315	0	0
45660845	1110410	0	0
45692910	1521369	0	0
45683514	738818	0	0
45695601	19115351	1	1
45675988	19008572	2	3
45699672	1119510	0	0
45682613	1174888	0	0
46291102	1539403	0	0
46238671	40228214	2	3
45796385	1107830	0	0
46243943	1129625	0	0
45802515	738818	0	0
45794376	1115008	0	0
46313997	1107830	0	0
46322422	1125315	0	0
4178818	40486433	4	6
4043671	4294548	3	3
21503199	975125	1	1
21002597	1729720	0	0
35508091	35605482	2	3
21601907	1149380	4	4
35707759	4310024	1	1
40796010	3007461	4	4
44352727	1177480	0	0
44363368	1129625	0	0
44348315	1129625	0	0
44361900	19019273	2	3
45649175	1149196	0	0
45623247	1115171	2	3
45667308	1125315	0	0
45653674	1110410	0	0
45624453	1125315	0	0
45657969	1115008	0	0
45692910	1549786	0	0
45683129	705944	0	0
45692566	46275916	1	1
45675669	43012036	2	3
45696017	1119510	0	0
45682628	1549786	0	0
46291309	1545958	0	0
46238658	40228214	2	3
45796457	1361711	0	0
46243851	1129625	0	0
45801237	738818	0	0
45794483	738818	0	0
46313903	1310149	0	0
46322581	1125315	0	0
4180628	30753	4	6
4043671	40486433	3	3
21503205	1343916	1	1
21002621	1746114	0	0
35202055	4329847	2	3
21601907	975125	4	4
36211677	196456	1	1
40796010	3010813	4	4
44352639	738818	0	0
44363514	1129625	0	0
44348274	1129625	0	0
44361726	1127433	2	3
45649106	738818	0	0
45625063	40162522	2	3
45662787	1125315	0	0
45653678	1501700	0	0
45624457	1125315	0	0
45657978	1713332	0	0
45692992	738818	0	0
45683460	914335	0	0
45689277	46275916	1	1
45675902	19008572	2	3
45696115	1119510	0	0
45682628	1521369	0	0
46291317	1115008	0	0
45786056	19079524	2	3
45796468	1521369	0	0
46243854	1129625	0	0
45795841	738818	0	0
45794419	975125	0	0
46308405	1738521	0	0
46322608	1125315	0	0
4040391	4301346	4	6
4184974	4336464	3	3
21501229	967823	1	1
21002600	1778162	0	0
21602504	43012433	2	3
35202457	381316	4	4
36211088	4146173	1	1
37522205	4301346	4	4
44352753	1713332	0	0
44363159	1129625	0	0
44348277	708298	0	0
44361755	40163554	2	3
45649107	1107830	0	0
45625074	19078924	2	3
45662800	1125315	0	0
45653253	1115008	0	0
45624539	1125315	0	0
45657978	1759842	0	0
45693162	19127890	0	0
45683482	1713332	0	0
45689779	46275916	1	1
45676100	40231925	2	3
45696200	1119510	0	0
45682629	1174888	0	0
46291374	1112807	0	0
45786176	40228214	2	3
45796468	1549786	0	0
46244899	1129625	0	0
45790405	738818	0	0
45794503	1192710	0	0
46307885	1548195	0	0
46322611	1125315	0	0
4027403	4107731	4	6
4196016	4108705	3	3
21500615	1343916	1	1
21002617	1746114	0	0
35508579	19133905	2	3
35202457	4163874	4	4
36211091	4113008	1	1
36919120	4043241	4	4
44352756	1115008	0	0
44363592	1129625	0	0
44348279	1115008	0	0
44361767	19075001	2	3
45649187	791967	0	0
45624908	40229134	2	3
45662900	1125315	0	0
45653256	1549786	0	0
45624541	1125315	0	0
45657937	1107830	0	0
45693162	1512674	0	0
45683377	723013	0	0
45680864	46275916	1	1
45676101	1551192	2	3
45696218	1119510	0	0
45682632	975125	0	0
46291398	1000560	0	0
45895346	40228214	2	3
45796349	1115008	0	0
46244820	1129625	0	0
45790576	738818	0	0
45794393	920293	0	0
46308517	1713332	0	0
46316495	1125315	0	0
4027403	4275113	4	6
4198525	30753	3	3
21500155	1539403	1	1
21002615	1746114	0	0
35508262	40174880	2	3
21602359	933724	4	4
36211091	78272	1	1
36314523	4015189	4	4
44352761	1129625	0	0
44363595	1129625	0	0
44345805	1521369	0	0
44361851	43012036	2	3
45648857	1539403	0	0
45623318	19008572	2	3
45662923	1125315	0	0
45653256	1521369	0	0
45624867	1125315	0	0
45657993	1343916	0	0
45693162	1549786	0	0
45683246	1738521	0	0
45680904	46275916	1	1
45672791	40228214	2	3
45696221	1119510	0	0
45682673	1308738	0	0
46242704	920293	0	0
45787520	19078461	2	3
45796350	1192710	0	0
46244882	1129625	0	0
45790448	738818	0	0
45794396	1343916	0	0
46308568	1551099	0	0
46316744	1125315	0	0
4027403	4108705	4	6
4196708	380378	3	3
21500165	1501700	1	1
21002597	1746114	0	0
21603404	40229134	2	3
21602359	1521369	4	4
36207527	46235214	1	1
36903604	4043241	4	4
44352765	1308738	0	0
44363305	1129625	0	0
44345805	1549786	0	0
44361816	19133905	2	3
45649202	1361711	0	0
45623321	40169216	2	3
45662915	1125315	0	0
45653553	1539403	0	0
45624879	1125315	0	0
45657997	1149196	0	0
45693004	1551099	0	0
45683256	1310149	0	0
45676178	46275916	1	1
45672959	19019273	2	3
45696145	1119510	0	0
45682579	1174888	0	0
46242711	1343916	0	0
45895161	40223768	2	3
45796310	1174888	0	0
46243984	1129625	0	0
45790586	738818	0	0
45794397	1115008	0	0
46308194	1501700	0	0
46318008	1125315	0	0
4028071	321042	4	6
4185643	4237458	3	3
21500201	1326303	1	1
21002602	1746114	0	0
21602473	19127904	3	3
21602359	1589505	4	4
36207527	3011505	1	1
40796118	3008598	4	4
44352712	1713332	0	0
44358707	1129625	0	0
44345815	1110410	0	0
44361963	19019273	2	3
45648859	1326303	0	0
45621487	1127433	2	3
45662961	1125315	0	0
45653826	738818	0	0
45624985	1125315	0	0
45657950	1110410	0	0
45692896	1115008	0	0
45683257	1322184	0	0
45676210	19079524	1	1
45672914	19057271	2	3
45696256	1119510	0	0
45682585	1115008	0	0
46242675	1713332	0	0
46297179	1332419	2	3
45796311	1361711	0	0
46238900	1129625	0	0
45790701	738818	0	0
45794399	1174888	0	0
46308574	975125	0	0
46318012	1125315	0	0
4028071	317576	4	6
4182210	4043241	3	3
21506220	1124300	1	1
21002602	1778162	0	0
21602473	19128022	3	3
21602359	1549786	4	4
36211303	4156265	6	6
37522205	44783196	3	4
44352712	1759842	0	0
44356261	1129625	0	0
44345817	1129625	0	0
44361883	40236446	2	3
45646490	1149380	0	0
45621508	19008572	2	3
45662836	1125315	0	0
45653831	1124957	0	0
45624784	1125315	0	0
45658048	1192710	0	0
45692897	1149196	0	0
45683259	1124957	0	0
45671713	19079524	1	1
45673051	40229134	2	3
45696158	1119510	0	0
45682590	1154343	0	0
46242675	1759842	0	0
46238511	40223768	2	3
45796312	967823	0	0
46238903	1129625	0	0
45790860	738818	0	0
45794403	738818	0	0
46308577	1589505	0	0
46317192	1125315	0	0
4047779	4035415	4	6
4276675	4314290	3	3
21506220	1177480	1	1
21002615	1717327	0	0
21602473	42902245	3	3
21603931	1124300	4	4
36516993	133834	6	6
40254301	40221415	3	4
44352616	1149380	0	0
44356306	1129625	0	0
44345885	1177480	0	0
44362168	1115171	2	3
45646491	738818	0	0
45621738	43012036	2	3
45662969	1125315	0	0
45653490	1110410	0	0
45624789	1125315	0	0
45657716	1326303	0	0
45693033	738818	0	0
45683261	914335	0	0
45670219	19079524	1	1
45673222	1594382	2	3
45696485	1119510	0	0
45682622	1149196	0	0
46242684	723013	0	0
45801164	40223768	2	3
45796426	740275	0	0
46238965	1129625	0	0
46297191	738818	0	0
45794344	1322184	0	0
46308585	1738521	0	0
46317882	1125315	0	0
4047779	380378	4	6
4043671	4112343	3	4
21500620	19002770	1	1
21002615	1778162	0	0
21602473	19128263	3	3
21603931	19003953	4	4
36416692	4144583	6	6
37320108	4296204	3	4
44352618	740275	0	0
44349379	1129625	0	0
44345865	1000560	0	0
44362064	40229134	2	3
45646498	782043	0	0
45621849	40228230	2	3
45662617	1125315	0	0
45653652	1149196	0	0
45624536	1125315	0	0
45657718	1192710	0	0
45693034	975125	0	0
45683270	1000560	0	0
45783746	19127922	1	1
45673176	43012036	2	3
45696244	1119510	0	0
45682648	1115008	0	0
46242582	1738521	0	0
45897512	19078461	2	3
45796433	1521369	0	0
46238897	1129625	0	0
46297601	738818	0	0
45794459	1124957	0	0
46308732	1112807	0	0
46317631	1125315	0	0
4047779	4156265	4	6
4182536	4108705	3	4
21500620	19039298	1	1
21002601	1746114	0	0
21602473	19128009	3	3
36217214	19128065	3	4
36416680	4144583	6	6
37522270	4337138	3	4
44352619	1310149	0	0
44349610	1129625	0	0
44345839	1192710	0	0
45655829	40223834	2	3
45646499	920293	0	0
45665355	40232448	2	3
45662850	1125315	0	0
45653402	1545958	0	0
45624843	1125315	0	0
45657719	1124957	0	0
45693168	1322184	0	0
45683145	1192710	0	0
45783746	19129144	1	1
45673307	19078461	2	3
45696327	1119510	0	0
45681719	1149196	0	0
46242679	1746114	0	0
46243815	19078461	2	3
45796279	1000560	0	0
46238898	1129625	0	0
46297565	738818	0	0
45794491	1539403	0	0
46308738	1595799	0	0
46317660	1125315	0	0
4028071	4329847	4	7
4300157	4142905	3	4
21500620	782043	1	1
21002599	1717327	0	0
21602473	19127918	3	3
36217214	19128263	3	4
36211315	78272	6	6
36900000	378419	2	6
44352736	1717327	0	0
44349738	1129625	0	0
44345832	1177480	0	0
45655954	19008572	2	3
45646472	1713332	0	0
45667354	19019273	2	3
45662863	1125315	0	0
45653466	1738521	0	0
45668794	1125315	0	0
45658060	708298	0	0
45693046	1713332	0	0
45683147	1107830	0	0
45783746	19133679	1	1
45785005	43012036	2	3
45696610	1119510	0	0
45681678	1192710	0	0
46242679	1741122	0	0
45800902	19078461	2	3
45796434	708298	0	0
46238989	1129625	0	0
46289024	738818	0	0
46312365	1326303	0	0
46308739	975125	0	0
46317538	1125315	0	0
4180628	4294548	4	7
4300157	4237458	3	4
21002499	19127918	1	1
21002616	1746114	0	0
21601765	40171902	3	3
36217214	19127918	3	4
35802848	81893	6	6
36603422	81151	3	6
44352742	701322	0	0
44349708	1129625	0	0
44345840	1332418	0	0
45656051	19076374	2	3
45646528	738818	0	0
45667314	19008572	2	3
45662975	1125315	0	0
45653787	1149196	0	0
45668704	1125315	0	0
45658053	1521369	0	0
45693189	738818	0	0
45683477	1153428	0	0
45707981	40220386	1	1
45784872	19019273	2	3
45696423	1119510	0	0
45681679	19039298	0	0
46242769	1192710	0	0
46243529	19078461	2	3
45796305	1149196	0	0
46238990	1129625	0	0
46289221	738818	0	0
46312378	1124957	0	0
46308764	914335	0	0
46316790	1125315	0	0
4178545	4112343	4	7
4043371	4112343	3	4
21502653	933724	1	1
21002616	1717327	0	0
21602471	19054876	3	3
36217214	19127904	3	4
36517012	78272	6	6
37103722	195588	3	6
44352742	715997	0	0
44349660	1129625	0	0
44345870	920293	0	0
45655965	19008572	2	3
45646537	1515774	0	0
45662805	19018935	2	3
45664555	1125315	0	0
45653468	1713332	0	0
45668978	1125315	0	0
45658053	1595799	0	0
45693104	738818	0	0
45683237	1332418	0	0
45708007	46275916	1	1
45784861	43012036	2	3
45696433	1119510	0	0
45681705	1115008	0	0
46242771	975125	0	0
45798278	19078461	2	3
45796398	1759842	0	0
46238991	1129625	0	0
46289774	738818	0	0
46312108	1192710	0	0
46308782	705944	0	0
46316841	1125315	0	0
4027403	40492359	4	8
4040563	4198190	3	4
21002491	19128022	1	1
21002600	1713332	0	0
21602471	1589505	3	3
36217214	19129144	3	4
36517140	78272	6	6
36702247	4066995	3	6
44352744	1153428	0	0
44349861	1129625	0	0
44345871	1124300	0	0
45656032	19018935	2	3
45646537	1549786	0	0
45662461	40232448	2	3
45664560	1125315	0	0
45653668	1548195	0	0
45668551	1125315	0	0
45658053	1549786	0	0
45692859	1174888	0	0
45683539	1124300	0	0
45708317	19079524	1	1
45785016	40229134	2	3
45696438	1119510	0	0
45681708	1521369	0	0
46242652	1545958	0	0
46293377	19078461	2	3
45796399	1154029	0	0
46239014	1129625	0	0
46241646	738818	0	0
46312314	1174888	0	0
46308468	1118084	0	0
46316852	1125315	0	0
4027384	134438	4	4
4279903	4323902	3	4
21002491	19128263	1	1
21505734	967823	0	0
21602471	1521369	3	3
36217214	40221415	3	4
36502198	4134304	5	6
37320122	4296204	3	6
44352483	1115008	0	0
44341796	1129625	0	0
44345875	1129625	0	0
45656069	1127433	2	3
45646546	708298	0	0
45662608	19074843	2	3
45663001	1125315	0	0
45653812	1153428	0	0
45668944	1125315	0	0
45658081	738818	0	0
45693184	1332418	0	0
45683543	1738521	0	0
45705314	46275916	1	1
45785161	40229134	2	3
45692966	1119510	0	0
45681708	1595799	0	0
46242883	975125	0	0
46238387	19078461	2	3
45790722	1174888	0	0
46239234	1129625	0	0
46241725	738818	0	0
46312110	1115008	0	0
46308596	975125	0	0
46316940	1125315	0	0
4071948	4330583	4	4
19054876	40221415	3	4
21002491	19127918	1	1
21505776	1192710	0	0
21602471	1500211	3	3
36217214	40165015	2	3
36502196	4066995	5	6
36900000	440086	4	6
44352486	1192710	0	0
44341849	1129625	0	0
44345880	1110410	0	0
45656349	1551192	2	3
45646461	1107830	0	0
45664560	1127433	2	3
45663102	1125315	0	0
45653821	1551099	0	0
45668958	1125315	0	0
45658082	1149196	0	0
45693186	1539403	0	0
45683382	1539403	0	0
45705701	46275916	1	1
45785244	1115171	2	3
45694729	1119510	0	0
45681708	1549786	0	0
46242888	1174888	0	0
45795494	19078461	2	3
45790725	1192710	0	0
46239414	1129625	0	0
46241735	738818	0	0
46312129	975125	0	0
46308616	1741122	0	0
46311630	1125315	0	0
4047779	81151	4	9
4311041	4336464	3	4
21002491	42902245	1	1
21505823	1192710	0	0
21602471	1548195	3	3
36217214	19077572	2	3
36502199	4149245	5	6
37002287	198199	4	6
44352766	1539403	0	0
44342045	1129625	0	0
44345881	1124300	0	0
45656155	40232448	2	3
45646467	738818	0	0
45659632	19019273	2	3
45663016	1125315	0	0
45653836	1154343	0	0
45668963	1125315	0	0
45658164	1551099	0	0
45692980	975125	0	0
45683247	1153428	0	0
45702012	46275916	1	1
45784843	40229134	2	3
45693313	1119510	0	0
45681682	1154029	0	0
46242696	1107830	0	0
46243764	19078461	2	3
45790766	1549786	0	0
46239426	1129625	0	0
46241765	738818	0	0
46312131	1501700	0	0
46308616	1746114	0	0
46306374	1125315	0	0
4047779	4142905	4	8
4042504	44783196	3	5
21002491	19128009	1	1
21505819	1125315	0	0
21602471	1512674	3	3
36217214	920334	2	3
36211303	4109685	5	6
37002287	4056621	4	6
44352576	1124300	0	0
44341920	1129625	0	0
44345891	738818	0	0
45656270	1115171	2	3
45646633	708298	0	0
45659613	40232448	2	3
45663034	1125315	0	0
45653479	1310149	0	0
45668728	1125315	0	0
45657743	1778162	0	0
45693048	1124300	0	0
45683254	1149196	0	0
45699313	46275916	1	1
45785077	1545959	2	3
45693563	1119510	0	0
45681756	1738521	0	0
46242821	1778162	0	0
46293245	19078461	2	3
45790766	19127890	0	0
45894433	1129625	0	0
46242612	738818	0	0
46312329	738818	0	0
46308617	1192710	0	0
46306501	1125315	0	0
4047779	44782520	4	5
4042505	4278672	3	5
21601120	964261	3	4
21505820	1192710	0	0
21602471	1549786	3	3
36217214	40162522	2	3
36211303	4132546	4	6
36403239	439777	4	6
42802580	1729720	0	0
44341921	1129625	0	0
44345897	1118084	0	0
45656406	40232448	2	3
45646561	1107830	0	0
45659624	40232448	2	3
45663210	1125315	0	0
45653608	967823	0	0
45668880	1125315	0	0
45658140	1545958	0	0
45693053	1310149	0	0
45683385	1332418	0	0
45699329	46275916	1	1
45785202	19133768	2	3
45693498	1119510	0	0
45681757	1713332	0	0
46242823	1124957	0	0
45895395	19078461	2	3
45790766	1521369	0	0
45801503	1129625	0	0
46241811	738818	0	0
46312246	1000560	0	0
46308660	1174888	0	0
46306183	1125315	0	0
4067285	4198190	4	5
4042505	4048695	3	5
21502709	1154615	3	4
21505820	1112807	0	0
21602471	1519936	3	3
36217214	40228230	2	3
36516972	4237458	4	6
37200000	321042	6	6
42802779	1343916	0	0
44341869	1129625	0	0
44345912	1112807	0	0
45656409	40232448	2	3
45646571	1124300	0	0
45659814	19125062	2	3
45659569	1125315	0	0
45653711	1124957	0	0
45668882	1125315	0	0
45658066	1557272	0	0
45693064	1115008	0	0
45683497	705944	0	0
45692950	46275916	1	1
45784942	1115171	2	3
45690305	1119510	0	0
45681711	1308738	0	0
46242834	1112807	0	0
46292965	19078461	2	3
45790930	1115008	0	0
45801409	1129625	0	0
46241824	738818	0	0
46312444	1174888	0	0
46308670	1192710	0	0
46306186	1125315	0	0
4040392	4186930	4	5
4042505	40480160	3	5
21503530	19075601	3	4
21505821	1177480	0	0
21601387	1305058	3	3
36217214	1127078	2	3
36516972	4142905	4	6
37502354	4108705	6	6
42802781	1713332	0	0
44341876	1129625	0	0
44345914	1149380	0	0
45656216	43012036	2	3
45646644	933724	0	0
45659769	40162522	2	3
45659794	1125315	0	0
45653504	1154029	0	0
45666462	1125315	0	0
45658069	975125	0	0
45693065	19039298	0	0
45683492	1545958	0	0
45707153	1115008	0	0
45785068	19008572	2	3
45690402	1119510	0	0
45681724	1545958	0	0
46242872	1192710	0	0
45793053	19078461	2	3
45790931	1501700	0	0
45801482	1129625	0	0
45897971	738818	0	0
46312224	723013	0	0
46308673	1738521	0	0
46306073	1125315	0	0
4040391	44783196	4	5
4182165	4066995	3	5
21503530	19059056	3	4
21505821	1192710	0	0
21604685	701322	3	3
36217214	19007333	2	3
36600000	4285898	4	6
36702253	4029498	6	6
42802783	1124300	0	0
44342087	1129625	0	0
44345923	1137529	0	0
45652708	920334	2	3
45646647	1124300	0	0
45660048	1115171	2	3
45659628	1125315	0	0
45653713	1332418	0	0
45666516	1125315	0	0
45658070	1102527	0	0
45693193	715997	0	0
45683504	1115008	0	0
45707060	1367571	0	0
45786482	40229134	2	3
45690554	1119510	0	0
45681747	1557272	0	0
46242876	1124957	0	0
46243589	19078461	2	3
45790939	1107830	0	0
45801574	1129625	0	0
45895806	738818	0	0
46312322	791967	0	0
46308630	740275	0	0
46306516	1125315	0	0
4028071	4310024	4	5
4182165	4048695	3	5
21501229	19079524	3	4
21505823	1129625	0	0
21604685	715997	3	3
35802845	4285898	4	7
35707763	30753	3	6
40792793	3024731	6	6
42802795	723013	0	0
44342137	1129625	0	0
44345923	1149380	0	0
45652625	19075001	2	3
45646650	1361711	0	0
45659927	40232448	2	3
45659534	1125315	0	0
45653515	1557272	0	0
45666497	1125315	0	0
45657877	1000560	0	0
45689835	1149196	0	0
45685286	723013	0	0
45707032	1000560	0	0
45786594	19018935	2	3
45690609	1119510	0	0
45681732	1102527	0	0
46243040	967823	0	0
46238574	19078461	2	3
45790775	791967	0	0
45801695	1129625	0	0
45895861	738818	0	0
46312675	1332418	0	0
46308486	1149196	0	0
46306592	1125315	0	0
4155793	4047491	4	5
4215793	4275113	3	5
21500563	45892894	3	4
21505735	967823	0	0
21604685	705944	3	3
35800000	378419	9	10
36208978	3049273	3	7
40779591	3001488	6	6
42802796	1124300	0	0
44363811	1129625	0	0
44345954	1545958	0	0
45652664	1127433	2	3
45646576	1124957	0	0
45656695	40229134	2	3
45659490	1125315	0	0
45653629	1115008	0	0
45666487	1125315	0	0
45658230	1310149	0	0
45689837	1124957	0	0
45685403	1149196	0	0
45707286	1107830	0	0
45786250	40229134	2	3
45690343	1119510	0	0
45681700	1589505	0	0
46242794	1713332	0	0
46288274	1545959	2	3
45791009	975125	0	0
45801650	1129625	0	0
45896009	738818	0	0
46312581	701322	0	0
46308490	705944	0	0
46306298	1125315	0	0
4155793	42535580	4	5
4054054	4134304	3	5
21503474	19077344	3	4
21505915	1119510	0	0
21601853	1545958	3	3
35800000	28060	8	9
36211303	4001336	4	7
36703532	380378	6	6
42802582	1738521	0	0
44363929	1129625	0	0
44345958	1129625	0	0
45655047	1115171	2	3
45646579	782043	0	0
45656794	19008572	2	3
45659701	1125315	0	0
45653727	1124957	0	0
45666548	1125315	0	0
45658173	1728416	0	0
45690017	1717327	0	0
45685232	1124957	0	0
45707254	1107830	0	0
45782906	19019979	2	3
45690387	1119510	0	0
45681702	1107830	0	0
46242801	1738521	0	0
46238467	19078461	2	3
45790801	715997	0	0
45795962	1129625	0	0
45896116	738818	0	0
46312591	1153428	0	0
46308714	1192710	0	0
46306244	1125315	0	0
4178818	28060	4	5
4042516	4301346	3	7
21503133	42707627	3	4
21505915	1192710	0	0
21601853	1539403	3	3
35800000	4001336	8	10
36502199	4059173	7	7
40796132	3026361	6	6
42803038	1322184	0	0
44363573	1129625	0	0
44345959	1115008	0	0
45655059	1115171	2	3
45646678	1153428	0	0
45656899	19133768	2	3
45659553	1125315	0	0
45653733	1310149	0	0
45666595	1125315	0	0
45658183	975125	0	0
45690018	1115008	0	0
45685243	1174888	0	0
45707108	1124957	0	0
45783017	40229134	2	3
45690492	1119510	0	0
45681794	1115008	0	0
46242983	1778162	0	0
46293150	1545959	2	3
45790741	1307863	0	0
45796169	1129625	0	0
45896167	738818	0	0
46312423	1149196	0	0
46308702	1192710	0	0
46306991	1125315	0	0
4178818	81893	4	5
4042516	44783196	3	6
21500201	19018935	3	4
21505921	1125315	0	0
21603932	1177480	3	3
35800000	81893	8	8
36502199	4066995	7	7
40796132	3010813	6	6
42802638	1501700	0	0
44363634	1129625	0	0
44345940	1192710	0	0
45655170	40229134	2	3
45646694	967823	0	0
45656753	40174880	2	3
45659557	1125315	0	0
45653636	708298	0	0
45666670	1125315	0	0
45658153	1115008	0	0
45689833	1539403	0	0
45685245	1545958	0	0
45707049	1107830	0	0
45782891	40162522	2	3
45690559	1119510	0	0
45681820	1551099	0	0
46242985	975125	0	0
45897993	1539411	2	3
45790876	1738521	0	0
45796378	1129625	0	0
45804104	738818	0	0
46312752	1729720	0	0
46308641	1149196	0	0
46306993	1125315	0	0
4041285	4056621	4	5
4213101	4048695	4	6
21500746	19079524	3	4
21505922	1192710	0	0
21603932	1124300	3	3
35800000	380378	8	8
36502199	4048695	7	7
36702242	4001336	6	6
42802725	1115008	0	0
44363639	1129625	0	0
44345940	1112807	0	0
45655327	40163554	2	3
45646433	1107830	0	0
45656762	1107882	2	3
45659853	1125315	0	0
45653525	1154029	0	0
45666729	1125315	0	0
45657891	967823	0	0
45689785	1521369	0	0
45685488	1107830	0	0
45707343	1501700	0	0
45782999	40229134	2	3
45690578	1119510	0	0
45681834	1738521	0	0
46242971	1326303	0	0
45792947	1332419	2	3
45790806	1713332	0	0
45796257	1129625	0	0
45804212	738818	0	0
46312327	1332418	0	0
46308647	975125	0	0
46306468	1125315	0	0
4103352	4294548	4	5
4275431	4057420	4	6
21503152	40232448	3	4
21505922	1174888	0	0
21603444	1153428	3	3
35800000	372328	8	8
36502199	4278672	7	7
37320108	133834	4	5
42802728	975125	0	0
44363736	1129625	0	0
44345969	19003953	0	0
45655445	19008572	2	3
45646606	1174888	0	0
45656943	43012036	2	3
45659855	1125315	0	0
45653745	738818	0	0
45666756	1125315	0	0
45658316	975125	0	0
45689785	1549786	0	0
45685493	1501700	0	0
45707427	1149196	0	0
45782992	1115171	2	3
45690515	1119510	0	0
45681862	1192710	0	0
46243068	1332418	0	0
46243331	1332419	2	3
45790827	1545958	0	0
45796212	1129625	0	0
45804189	738818	0	0
46312831	1192710	0	0
46308682	1545958	0	0
46306739	1125315	0	0
4103662	4001336	4	5
4042516	4058899	4	6
21503152	43012036	3	4
21505930	1177480	0	0
21603444	1192710	3	3
35800000	381316	8	8
36502199	81151	5	7
37520918	4198190	4	5
42803074	1713332	0	0
44363768	1129625	0	0
44341262	1177480	0	0
45655180	40232448	2	3
45646610	1332418	0	0
45656868	1332419	2	3
45659957	1125315	0	0
45653755	1713332	0	0
45666712	1125315	0	0
45658322	1153428	0	0
45689785	19127890	0	0
45685484	1154343	0	0
45707349	1545958	0	0
45783194	40232448	2	3
45690534	1119510	0	0
45681866	1115008	0	0
46242924	1112807	0	0
46296933	1332419	2	3
45790828	1174888	0	0
45796268	1129625	0	0
45799006	738818	0	0
46312780	1118084	0	0
46312351	1501700	0	0
46306230	1125315	0	0
4043022	4216130	4	5
4042504	4301346	4	6
21503152	19112599	3	4
21505930	1308738	0	0
21603444	1150836	3	3
35800000	4294548	8	11
36502199	40480160	5	7
37521809	4336464	4	5
42803074	1759842	0	0
44363769	1129625	0	0
44341385	1332418	0	0
45655183	40228214	2	3
45646620	1332418	0	0
45657034	1127433	2	3
45659769	1125315	0	0
45653755	1759842	0	0
45666867	1125315	0	0
45657903	1174888	0	0
45689786	1174888	0	0
45685441	933724	0	0
45707444	1149196	0	0
45783111	40229134	2	3
45687472	1119510	0	0
45681880	1000560	0	0
46242929	1110410	0	0
45897921	1332419	2	3
45790942	1551099	0	0
45796467	1129625	0	0
45799038	738818	0	0
46306913	1343916	0	0
46312352	1361711	0	0
46306606	1125315	0	0
4027403	4197460	4	5
4299602	4198190	4	5
21503083	920300	3	4
21505970	1154343	0	0
21603444	738818	3	3
35800000	4112343	8	11
36211303	4146173	5	7
36313967	4024958	4	5
42802914	1124957	0	0
44363986	1129625	0	0
44341010	1545958	0	0
45652824	40231925	2	3
45646718	1343916	0	0
45657079	40229134	2	3
45659779	1125315	0	0
45653761	1545958	0	0
45666972	1125315	0	0
45657923	1595799	0	0
45689896	1124300	0	0
45685599	1308738	0	0
45706869	1115008	0	0
45783458	40162522	2	3
45687562	1119510	0	0
45678508	1149196	0	0
46242931	1310149	0	0
46241650	1332419	2	3
45790945	1551099	0	0
45796430	1129625	0	0
45793548	738818	0	0
46306919	1343916	0	0
46312354	1124300	0	0
46317223	1125315	0	0
4027403	4337138	4	5
4040561	4198190	4	5
21503083	920334	3	4
21505971	1137529	0	0
21602722	975125	3	3
35800000	4156265	7	9
36211303	4278672	5	7
36903633	4043241	4	5
42803062	1759842	0	0
44356506	1129625	0	0
44341221	1129625	0	0
45652840	1127433	2	3
45646726	757627	0	0
45656994	19019273	2	3
45660042	1125315	0	0
45650086	1501700	0	0
45664267	1125315	0	0
45657923	1308738	0	0
45690026	1367571	0	0
45685609	705944	0	0
45706504	967823	0	0
45783077	1115171	2	3
45687280	1119510	0	0
45678608	1361711	0	0
46243069	1174888	0	0
46238639	40174880	2	3
45790890	914335	0	0
45790773	1129625	0	0
45793672	738818	0	0
46306960	1118084	0	0
46312357	1361711	0	0
46317310	1125315	0	0
4042836	40486433	4	5
4042505	4142905	4	5
21500620	19023398	3	4
21505972	1549786	0	0
21604181	19059528	3	3
35800000	4283893	7	9
36211303	4152936	5	7
36703532	44782520	4	5
42803062	1713332	0	0
44356509	1129625	0	0
44341222	1192710	0	0
45649544	19008572	2	3
45646704	1149380	0	0
45657112	19077344	2	3
45659799	1125315	0	0
45650101	967823	0	0
45664393	1125315	0	0
45658329	1192710	0	0
45690021	1149196	0	0
45680106	1343916	0	0
45706779	1713332	0	0
45783141	40229134	2	3
45687534	1119510	0	0
45678623	920293	0	0
46243071	1118084	0	0
46243349	1332419	2	3
45790897	723013	0	0
45790893	1129625	0	0
45793804	738818	0	0
46307029	1343916	0	0
46312428	1112807	0	0
46317460	1125315	0	0
4042836	4280726	4	5
4197094	4285898	4	5
21500620	782047	3	4
21505972	1548195	0	0
21604181	19002770	3	3
35800000	4218389	6	7
36211303	4059173	5	7
37103722	4056621	4	5
42802734	1778162	0	0
44356718	1129625	0	0
44341183	1713332	0	0
45649747	19059056	2	3
45646688	1115008	0	0
45657205	19008572	2	3
45659935	1125315	0	0
45650314	738818	0	0
45664537	1125315	0	0
45654634	1332418	0	0
45689876	1174888	0	0
45680224	1308738	0	0
45706754	1539403	0	0
45783140	40232448	2	3
45687453	1119510	0	0
45678712	1118084	0	0
46243041	1322184	0	0
46238551	1332419	2	3
45790952	1115008	0	0
45792013	1129625	0	0
45793666	738818	0	0
46307106	1589505	0	0
46311947	1551099	0	0
45876037	3035995	3	5
4042836	4294548	4	5
4247371	4156265	4	5
21500165	40174880	3	4
21505972	1512674	0	0
21603512	1150771	0	3
35800000	4084167	6	7
36502197	4146173	6	7
37522191	4108705	3	5
42802869	1738521	0	0
44356720	1129625	0	0
44341183	1759842	0	0
45649746	19019273	2	3
45646735	1549786	0	0
45653552	1127433	2	3
45656923	1125315	0	0
45650381	1717327	0	0
45664414	1125315	0	0
45654641	1107830	0	0
45689895	1115008	0	0
45680168	1154343	0	0
45706806	1738521	0	0
45783206	19133905	2	3
45687649	1119510	0	0
45678489	967823	0	0
46242812	1115008	0	0
45897837	1332419	2	3
45791002	1549786	0	0
45791189	1129625	0	0
45788176	738818	0	0
46307108	1124300	0	0
46311958	1713332	0	0
600000010	40163554	3	4
4042836	378419	4	5
4042504	4047491	4	5
21506150	19079524	3	4
21505795	1322184	0	0
21604191	782047	0	3
35800000	4027663	5	5
36502199	40479422	6	7
36902280	378419	3	5
42802684	975125	0	0
44356729	1129625	0	0
44341340	1177480	0	0
45649649	40232448	2	3
45646735	1521369	0	0
45653776	19008572	2	3
45656672	1125315	0	0
45650383	1153428	0	0
45664309	1125315	0	0
45654535	920293	0	0
45690150	1332418	0	0
45680053	791967	0	0
45706880	791967	0	0
45783206	19133873	2	3
45687716	1119510	0	0
45678590	1110410	0	0
46242744	1115008	0	0
46243254	1332419	2	3
45791002	1515774	0	0
46294895	1129625	0	0
45788306	738818	0	0
46307058	1551099	0	0
46311906	1500211	0	0
600000007	40173590	3	4
4042836	4001336	4	5
4279903	4330583	4	4
21506220	19078461	3	4
21503939	975125	0	0
21604192	19023423	0	3
35800000	40480160	5	5
36502199	4237458	6	7
37320122	134438	2	5
42803013	1129625	0	0
44357012	1129625	0	0
44341241	1118084	0	0
45649950	1107882	2	3
45646768	1713332	0	0
45653253	19019273	2	3
45656693	1125315	0	0
45650337	708298	0	0
45664544	1125315	0	0
45654665	1124957	0	0
45689956	1361711	0	0
45680317	1738521	0	0
45706510	1102527	0	0
45783212	19019273	2	3
45687720	1119510	0	0
45678592	1110410	0	0
46242815	914335	0	0
45801097	1332419	2	3
45791002	19127890	0	0
46294906	1129625	0	0
45788684	738818	0	0
46307110	1124957	0	0
46308816	1118084	0	0
500000301	198809	4	4
4042836	4043241	6	7
4054054	78272	4	4
21506220	19019979	3	4
21503948	1107830	0	0
21604193	19023398	0	3
35800000	4066995	5	5
36502199	40479768	6	7
36702253	4066995	3	7
42803026	1545958	0	0
44357074	1129625	0	0
44338783	1521369	0	0
45649879	19123231	2	3
45646768	1759842	0	0
45653652	40228230	2	3
45656695	1125315	0	0
45650273	1149196	0	0
45778333	1125315	0	0
45654656	1107830	0	0
45689814	1713332	0	0
45680087	1149196	0	0
45706516	1551099	0	0
45780575	40232448	2	3
45687747	1119510	0	0
45678514	1107830	0	0
46242817	1124957	0	0
46238412	1545959	2	3
45791003	1361711	0	0
46294263	1129625	0	0
46289859	738818	0	0
46311831	701322	0	0
46308829	1738521	0	0
500000301	196456	3	3
4180628	378419	6	7
4297887	440448	4	4
21506220	19019273	3	4
21503948	1150836	0	0
21603513	1150837	0	3
21604180	1127433	4	7
36502199	4142905	6	7
36700000	4029498	3	7
44344770	1129625	0	0
44357130	1129625	0	0
44338783	1549786	0	0
45649821	1107882	2	3
45646772	1149196	0	0
45653783	40232448	2	3
45656899	1125315	0	0
45650274	1124957	0	0
45778053	1125315	0	0
45654295	1154343	0	0
45689939	1738521	0	0
45680128	738818	0	0
45706686	1539403	0	0
46244726	19008572	2	3
45684246	1119510	0	0
45678439	1192710	0	0
46243095	1112807	0	0
46241283	1545959	2	3
45791026	1149196	0	0
46296634	1129625	0	0
46289865	738818	0	0
46311833	975125	0	0
46308851	1305058	0	0
600000005	19057271	3	4
4178545	4048171	6	7
4215793	4337138	4	4
21506220	1115171	3	4
21503953	708298	0	0
21603525	40223834	0	3
21604180	19023423	4	7
36211303	4048695	6	7
37502353	4107731	3	7
44345074	1129625	0	0
44350112	1129625	0	0
44338667	1124957	0	0
45649635	19123231	2	3
45646756	715997	0	0
45653812	40223834	2	3
45656751	1125315	0	0
45650279	1545958	0	0
45778324	1125315	0	0
45654463	753626	0	0
45689960	1332418	0	0
45680129	1154343	0	0
45704257	1308738	0	0
46244684	19008572	2	3
45684379	1119510	0	0
45678444	1107830	0	0
46242782	1154343	0	0
46238444	1545959	2	3
45791029	1713332	0	0
46244109	1129625	0	0
46290333	738818	0	0
46312044	975125	0	0
46303398	933724	0	0
600000005	19076374	3	4
4028071	4166224	6	7
4300157	40480160	4	4
21500215	40171902	3	3
21503929	1124300	0	0
21603525	40223821	0	3
21604180	19123231	4	7
36211303	4066995	6	7
37303796	4296204	3	7
44344875	967823	0	0
44349757	1129625	0	0
44338725	1115008	0	0
45649849	40174880	2	3
45646775	1153428	0	0
45653820	19008572	2	3
45656710	1125315	0	0
45650138	738818	0	0
45778246	1125315	0	0
45654589	1124300	0	0
45689960	1545958	0	0
45680237	1551099	0	0
45704260	1501700	0	0
46244687	1127433	2	3
45681444	1119510	0	0
45678472	933724	0	0
46242783	1192710	0	0
46243554	1545959	2	3
45791029	1759842	0	0
46244224	1129625	0	0
46241955	738818	0	0
46312045	1305058	0	0
46303763	1192710	0	0
46307705	19075601	2	3
4029205	4024289	6	7
4300157	4278672	4	4
21500216	40171902	3	3
21503948	1153428	0	0
21602842	19133905	0	3
21604180	19057271	4	7
36211303	4237458	6	7
37320122	133834	4	7
44344880	1115008	0	0
44349976	1129625	0	0
44338668	1149380	0	0
45649862	19008572	2	3
45643442	1124300	0	0
45653821	1551192	2	3
45656770	1125315	0	0
45650413	1102527	0	0
45778101	1125315	0	0
45654591	1501700	0	0
45690132	967823	0	0
45680240	1361711	0	0
45704206	1000560	0	0
45778126	40229134	2	3
45681473	1119510	0	0
45678475	914335	0	0
46243102	705944	0	0
46288949	1539411	2	3
45792004	1124957	0	0
46244372	1129625	0	0
46241965	738818	0	0
46307150	967823	0	0
46303350	975125	0	0
46302465	19075601	2	3
4180628	375671	6	8
4300157	4066995	4	4
21506173	1332418	3	3
21503948	1150770	0	0
21603462	43012036	0	3
21604180	35605858	6	7
35707763	440448	3	8
36702239	4043241	7	7
44344946	1177480	0	0
44350005	1129625	0	0
44338670	1112807	0	0
45649735	40228230	2	3
45643447	1713332	0	0
45653836	1154615	2	3
45656947	1125315	0	0
45650112	1149196	0	0
45660965	1125315	0	0
45654700	1110410	0	0
45690140	1174888	0	0
45680090	738818	0	0
45704276	738818	0	0
45778079	19008572	2	3
45681294	1119510	0	0
45678570	1310149	0	0
46242790	757627	0	0
45895389	1539411	2	3
45791875	1589505	0	0
46239164	1129625	0	0
46241968	738818	0	0
46307156	1107830	0	0
46303309	1309944	0	0
46302504	19075601	2	3
4043018	4198190	6	8
4300157	40479422	4	4
21506173	1307863	3	3
21503951	19002770	0	0
21603462	19112599	0	3
4201745	81893	4	9
36402192	4144583	8	8
36702242	375671	7	7
44345101	1124300	0	0
44349943	1129625	0	0
44338702	1589505	0	0
45649931	1107882	2	3
45643447	1759842	0	0
45653479	40163554	2	3
45657034	1125315	0	0
45650418	1367571	0	0
45660978	1125315	0	0
45654703	1174888	0	0
45690114	723013	0	0
45680093	1115008	0	0
45704285	738818	0	0
46244647	1127433	2	3
45681104	1119510	0	0
45678574	1174888	0	0
46240492	1332418	0	0
46243470	1539411	2	3
45791877	1549786	0	0
46239339	1129625	0	0
46242016	738818	0	0
46307280	1713332	0	0
46303312	1112807	0	0
45799670	19075601	2	3
4047779	4134304	6	10
4043671	4048171	4	4
21503193	1713671	3	3
21503951	782043	0	0
21603514	19125062	0	3
4201745	440448	4	7
36400000	439777	6	8
36702242	378001	7	7
44345188	975125	0	0
44349950	1129625	0	0
44338702	1549786	0	0
45649721	40223834	2	3
45643581	1124300	0	0
45653629	19019273	2	3
45656717	1125315	0	0
45650345	1778162	0	0
45661832	1125315	0	0
45654603	1115008	0	0
45690119	708298	0	0
45680094	1124300	0	0
45704287	1124957	0	0
46244705	19078461	2	3
45681436	1119510	0	0
45678576	1746114	0	0
46240496	1545958	0	0
46243537	19128263	1	2
45791877	19127890	0	0
46239345	1129625	0	0
46242234	738818	0	0
46307337	1174888	0	0
46303268	1112807	0	0
45796610	19075601	2	3
4047779	4166224	6	9
4186164	4134304	4	4
21500154	1539403	3	3
21503951	19039298	0	0
21603514	1107882	0	3
4201745	4166224	4	7
36211303	375671	5	8
37302325	4048695	6	7
44344957	1713332	0	0
44350207	1129625	0	0
44338707	1149380	0	0
45649934	19073183	2	3
45643603	1545958	0	0
45653637	19008572	2	3
45657079	1125315	0	0
45650491	715997	0	0
45661649	1125315	0	0
45654718	1738521	0	0
45689964	1501700	0	0
45680295	738818	0	0
45704187	1124300	0	0
46244628	40163554	2	3
45681612	1119510	0	0
45678577	1343916	0	0
46240587	1332418	0	0
45885353	4059173	1	2
45791877	1512674	0	0
46239583	1129625	0	0
46242182	738818	0	0
46307338	791967	0	0
46303437	1738521	0	0
46300396	1545959	2	3
4047779	375671	6	9
4043346	258780	4	4
21501117	967823	3	3
21503955	1154029	0	0
21602823	19073188	0	3
4227253	81893	7	8
36211303	378001	5	8
36900000	4043241	4	8
44344797	1129625	0	0
44350130	1129625	0	0
44338712	1539403	0	0
45649777	1127433	2	3
45643605	1521369	0	0
45653745	40229134	2	3
45657001	1125315	0	0
45650497	1174888	0	0
45661377	1125315	0	0
45654411	1713332	0	0
45690041	1501700	0	0
45680380	1115008	0	0
45704326	723013	0	0
46240377	40232448	2	3
45681539	1119510	0	0
45678710	933724	0	0
46240591	975125	0	0
45885353	4278672	1	2
45791885	1115008	0	0
46239652	1129625	0	0
46242185	738818	0	0
46307166	1343916	0	0
46303440	1521369	0	0
46319141	19075601	2	3
4178818	4294548	6	6
4043346	317576	4	4
21500617	782043	3	3
21503956	1154029	0	0
21603497	40228214	0	3
4227253	4285898	6	7
36211303	81151	6	8
36702242	4043241	7	8
44344798	738818	0	0
44350146	1129625	0	0
44338887	967823	0	0
45646309	19019273	2	3
45643605	1549786	0	0
45650141	19008572	2	3
45657006	1125315	0	0
45650499	1713332	0	0
45661767	1125315	0	0
45654417	1310149	0	0
45689976	1307863	0	0
45680568	1549786	0	0
45704328	1501700	0	0
46240217	19059056	2	3
45681606	1119510	0	0
45678579	1192710	0	0
46240553	1118084	0	0
45803566	19127922	1	2
45791888	1367571	0	0
46239727	1129625	0	0
46242309	738818	0	0
46307411	738818	0	0
46303440	1549786	0	0
45894675	19078461	2	3
4178818	260139	6	6
4040559	4242997	4	4
21500617	19002770	3	3
21503947	1149196	0	0
21603497	40228230	0	3
35802131	4043241	10	11
36211303	4230399	6	8
37200000	313217	7	8
44345008	1129625	0	0
44364124	1129625	0	0
44338894	1110410	0	0
45646323	40232448	2	3
45643605	1595799	0	0
45650138	40229134	2	3
45657271	1125315	0	0
45650511	1515774	0	0
45661109	1125315	0	0
45654672	975125	0	0
45690062	1149196	0	0
45680568	1515774	0	0
45704212	1501700	0	0
46240307	43012036	2	3
45679754	1119510	0	0
45678684	1308738	0	0
46240669	1124300	0	0
45803566	19133679	1	2
45791854	1110410	0	0
46239615	1129625	0	0
46241988	738818	0	0
46307231	1332418	0	0
46303451	1738521	0	0
46300214	1539411	2	3
4043022	4163971	6	6
4042505	4059173	5	5
21500617	753626	3	3
21503932	1343916	0	0
35202455	313217	1	3
21502709	1150771	9	10
36211303	4134304	6	9
36700000	381316	3	8
44344773	1115008	0	0
44364188	1129625	0	0
44338649	1129625	0	0
45646327	40232448	2	3
45643448	1713332	0	0
45650349	40232448	2	3
45656850	1125315	0	0
45650511	1549786	0	0
45661146	1125315	0	0
45654673	975125	0	0
45690097	1107830	0	0
45680568	19127890	0	0
45704213	1107830	0	0
46240431	40236446	2	3
45679577	1119510	0	0
45678546	740275	0	0
46240670	1115008	0	0
45803566	19129144	1	2
45791898	1107830	0	0
46239735	1129625	0	0
46242288	738818	0	0
46307234	1115008	0	0
46303452	1174888	0	0
45796739	40228214	2	3
4043022	4078793	6	6
4300157	4230399	5	5
21500617	19039298	3	3
21504550	1124300	0	0
35202050	313217	2	4
21502709	1150837	9	10
36211303	78272	5	9
36700000	380378	3	8
44344986	1112807	0	0
44356898	1129625	0	0
44338766	914335	0	0
45646367	40232448	2	3
45643460	1149380	0	0
45650514	40236446	2	3
45653557	1125315	0	0
45650511	19127890	0	0
45661148	1125315	0	0
45654677	1149196	0	0
45690462	967823	0	0
45680180	1310149	0	0
45704290	738818	0	0
46240091	19059056	2	3
45678085	1119510	0	0
45678554	975125	0	0
46240568	1738521	0	0
45892893	45892894	1	1
45791931	1396131	0	0
45895940	1129625	0	0
45893603	738818	0	0
46307235	738818	0	0
46303097	1124957	0	0
46300839	1539411	2	3
4040392	4275113	6	6
4214956	4163874	5	5
21500617	1154029	3	3
21504027	1112807	0	0
21602496	43012433	3	4
21502709	1107882	9	10
35707763	4285898	3	9
37000000	195588	3	8
44345104	1112807	0	0
44356899	1129625	0	0
44338768	1308738	0	0
45646375	40163554	2	3
45643562	1149196	0	0
45650174	40163554	2	3
45653560	1125315	0	0
45650512	1713332	0	0
45661130	1125315	0	0
45654543	1154029	0	0
45690244	738818	0	0
45680407	1713332	0	0
45704226	738818	0	0
46240451	19133905	2	3
45678161	1119510	0	0
45678556	1154343	0	0
46240714	1124300	0	0
45796433	19129144	1	1
45791864	1549786	0	0
45895948	1129625	0	0
45799173	738818	0	0
46307236	738818	0	0
46303115	1174888	0	0
46319060	1539411	2	3
4103352	4048171	6	6
4247371	378419	5	6
21500617	708298	3	3
21504028	1125315	0	0
21604208	40220386	3	4
21502549	19133905	8	9
36426817	1110410	0	0
36303153	192671	3	8
44345106	1115008	0	0
44357137	1129625	0	0
44338899	1589505	0	0
45649002	19018935	2	3
45643251	1500211	0	0
45650187	40223834	2	3
45653552	1125315	0	0
45650512	1759842	0	0
45661186	1125315	0	0
45654547	1107830	0	0
45689982	933724	0	0
45680411	1557272	0	0
45704296	1174888	0	0
46240362	40229134	2	3
45678165	1119510	0	0
45678650	1149196	0	0
46240663	1112807	0	0
45796433	19127922	1	1
45791864	1595799	0	0
45895949	1129625	0	0
45799194	738818	0	0
46307241	1192710	0	0
46303722	1192710	0	0
46302788	40228214	2	3
4043017	4323902	6	6
4040559	4198190	5	6
21503134	1125315	3	3
21504552	1308738	0	0
21603396	19133768	3	4
21502549	19073183	8	9
36425574	975125	0	0
36300000	4012477	3	8
44345112	738818	0	0
44357056	1129625	0	0
44338730	1741122	0	0
45649107	1107882	2	3
45643565	1332418	0	0
45650356	19074679	2	3
45653224	1125315	0	0
45650514	705944	0	0
45661113	1125315	0	0
45654550	1717327	0	0
45689988	975125	0	0
45680392	1322184	0	0
45704297	1713332	0	0
46240374	40232448	2	3
45678292	1119510	0	0
45678776	1149196	0	0
46240742	1322184	0	0
45796433	19133679	1	1
45791864	1521369	0	0
45896137	1129625	0	0
45799354	738818	0	0
46307247	1343916	0	0
46303723	1310149	0	0
45799657	40228214	2	3
4043017	4337611	6	6
4042505	4134304	5	7
21503134	1112807	3	3
21500003	1717327	0	0
21602472	42902245	4	4
1717327	1717327	0	0
36500000	4134304	6	11
36703532	378419	7	8
44345009	738818	0	0
44356915	1129625	0	0
44338730	1746114	0	0
45646498	782047	2	3
45643668	1115008	0	0
45650630	19059056	2	3
45653385	1125315	0	0
45650397	1326303	0	0
45661453	1125315	0	0
45654552	1115008	0	0
45689994	1713332	0	0
45680468	1595799	0	0
45704297	1759842	0	0
46242385	1127433	2	3
45678294	1119510	0	0
45678660	1124300	0	0
46240743	1501700	0	0
45790741	40171902	1	1
45791871	1174888	0	0
45896184	1129625	0	0
45794130	738818	0	0
46307249	1741122	0	0
46303162	1153428	0	0
46312423	40228214	2	3
4028071	258780	6	6
4040551	4336464	5	7
21500205	1361711	3	3
21500002	1728416	0	0
21602472	19128022	4	4
1728416	1728416	0	0
36502199	4134304	5	9
37502353	4242997	7	8
44345010	1129625	0	0
44357111	1129625	0	0
44338899	1549786	0	0
45646472	19073183	2	3
45643708	1153428	0	0
45647250	1551192	2	3
45653782	1125315	0	0
45650429	1548195	0	0
45777849	1125315	0	0
45654710	914335	0	0
45689994	1759842	0	0
45680468	1549786	0	0
45704420	1174888	0	0
46242462	40223768	2	3
45678250	1119510	0	0
45678664	1545958	0	0
46240736	1124300	0	0
46294933	40220386	1	1
45792063	1738521	0	0
45896651	1129625	0	0
45794202	738818	0	0
46307174	1310149	0	0
46303378	1521369	0	0
46295417	40228214	2	3
4047779	4144583	6	6
4247371	4294548	5	7
21500164	1501700	3	3
21500003	1713332	0	0
21602472	19128009	4	4
4056621	4056621	0	0
36502199	78272	4	8
36702247	378001	6	9
44345022	1500211	0	0
44357119	1129625	0	0
44338676	1149196	0	0
45646568	43012036	2	3
45643779	1551099	0	0
45647302	19133768	2	3
45653823	1125315	0	0
45650174	1310149	0	0
45777823	1125315	0	0
45654714	975125	0	0
45690103	1154343	0	0
45680468	1521369	0	0
45704255	1154343	0	0
46242471	19059056	2	3
45678395	1119510	0	0
45678667	1124957	0	0
46240704	1107830	0	0
46299010	19079524	1	1
45792042	1717327	0	0
45896749	1129625	0	0
45788822	738818	0	0
46307194	1115008	0	0
46303382	1112807	0	0
46318351	40228214	2	3
4047779	4027663	6	6
4274025	313217	7	10
21500594	1124300	3	3
21500005	1746114	0	0
21602472	19127918	4	4
4057420	4057420	0	0
36502199	4230399	8	8
36703532	378001	7	9
44345024	1112807	0	0
44358638	1129625	0	0
44338678	1129625	0	0
45646561	1107882	2	3
45643816	1149196	0	0
45647266	40229134	2	3
45653831	1125315	0	0
45650552	1713332	0	0
45654754	1125315	0	0
45655509	1367571	0	0
45690064	1149196	0	0
45680471	1192710	0	0
45704256	708298	0	0
46240496	1545959	2	3
45678499	1119510	0	0
45678676	1308738	0	0
45681062	738818	0	0
46298553	19079524	1	1
45792068	975125	0	0
45804369	1129625	0	0
45788906	738818	0	0
46307291	1549786	0	0
46303134	1738521	0	0
45894262	40223768	2	3
4043018	4163971	6	6
4339410	4134304	7	7
21500594	1129625	3	3
21500002	1729720	0	0
21602472	19128263	4	4
4142905	4142905	0	0
36502197	4237458	6	8
36702253	378419	8	9
44345031	1308738	0	0
44358835	1129625	0	0
44338736	1174888	0	0
45646458	40232448	2	3
45643321	1332418	0	0
45647165	19077572	2	3
45653555	1125315	0	0
45650246	1110410	0	0
45654850	1125315	0	0
45655484	1545958	0	0
45690068	1713332	0	0
45680478	1153428	0	0
45704364	1500211	0	0
46240515	40232448	2	3
45678335	1119510	0	0
45678887	1322184	0	0
45675832	738818	0	0
46242477	19115351	1	1
45791043	1548195	0	0
45804343	1129625	0	0
45788869	738818	0	0
46307291	1521369	0	0
46303816	1112807	0	0
45799828	1539411	2	3
4043016	4107731	6	6
19057271	19057271	0	0
21500594	1118084	3	3
21500012	1778162	0	0
21603931	1118084	4	4
4145310	4145310	0	0
36424688	44816277	2	3
36702253	4001336	7	9
44345036	1129625	0	0
44357394	1129625	0	0
44338737	1501700	0	0
45646633	19078924	2	3
45643373	1154029	0	0
45649205	19073183	2	3
45653804	1125315	0	0
45641900	1125315	0	0
45654883	1125315	0	0
45655445	975125	0	0
45690068	1759842	0	0
45680185	1107830	0	0
45704474	1738521	0	0
46240516	40232448	2	3
45678357	1119510	0	0
45678875	1192710	0	0
45675909	738818	0	0
45896285	19074679	1	1
45791044	967823	0	0
45804382	1129625	0	0
46295245	738818	0	0
46307429	1309944	0	0
46303692	1308738	0	0
45802028	40228214	2	3
4042641	4108705	6	6
19059056	19059056	0	0
21500657	1125315	3	3
21500012	1768849	0	0
21603931	1115008	4	4
4202451	4202451	0	0
36424688	43012433	2	3
37200000	257012	3	9
44344935	742185	0	0
44353898	1129625	0	0
44338740	1729720	0	0
45646579	782047	2	3
45643737	1501700	0	0
45648859	19018935	2	3
45653833	1125315	0	0
45641905	1125315	0	0
45634985	1119510	0	0
45655028	1115008	0	0
45690078	1124957	0	0
45680484	1115008	0	0
45704475	1115008	0	0
45703170	40232448	2	3
45674935	1119510	0	0
45678879	1713332	0	0
45673051	738818	0	0
46299021	19079524	1	1
45791062	1107830	0	0
45804330	1129625	0	0
46295351	738818	0	0
46307432	1124300	0	0
46303818	1738521	0	0
45799300	19078461	2	3
4157607	44782520	1	1
4337138	4337138	0	0
21500657	1308738	3	3
21005673	1310149	0	0
21603931	1557272	4	4
4202832	4202832	0	0
36424689	44816277	2	3
36303153	196456	4	10
44344975	738818	0	0
44354151	1129625	0	0
44338900	1713332	0	0
45646688	19019273	2	3
45643723	1153428	0	0
45648822	40236446	2	3
45653619	1125315	0	0
45641912	1125315	0	0
45635093	1119510	0	0
45654729	791967	0	0
45690185	1551099	0	0
45680244	1539403	0	0
45704487	1545958	0	0
45703223	40174880	2	3
45674858	1119510	0	0
45678895	975125	0	0
45673228	738818	0	0
46299021	46275916	1	1
45791068	1322184	0	0
45796407	1129625	0	0
46244325	738818	0	0
46307364	1115008	0	0
46303736	1501700	0	0
45796734	40228214	2	3
4163273	4330583	1	1
4337611	4337611	0	0
21601077	1308738	3	3
21005678	1713332	0	0
21603931	1177480	4	4
21505925	1343916	0	0
36424689	43012433	2	3
36700000	378419	3	10
44344890	1129625	0	0
44354132	1129625	0	0
44338656	705944	0	0
45646704	40169216	2	3
45643730	1548195	0	0
45649023	40236824	2	3
45653720	1125315	0	0
45642072	1125315	0	0
45635057	1119510	0	0
45654747	1361711	0	0
45690253	1107830	0	0
45680258	738818	0	0
45704492	723013	0	0
45703230	1545959	2	3
45675293	1119510	0	0
45678825	723013	0	0
45784743	738818	0	0
46294371	19079524	1	1
45791082	967823	0	0
45797282	1129625	0	0
46244337	738818	0	0
46307973	920293	0	0
46303646	975125	0	0
45794004	40228214	2	3
4134145	44782520	1	1
4218389	4218389	0	0
21601077	1396131	3	3
21006763	1396131	0	0
35202051	4324181	4	4
21506022	914335	0	0
36427086	964261	2	3
36703532	4043241	9	10
44345051	1192710	0	0
44354235	1129625	0	0
44338659	1107830	0	0
45646775	40223834	2	3
45643783	1738521	0	0
45648872	19059056	2	3
45653628	1125315	0	0
45641919	1125315	0	0
45635151	1119510	0	0
45654764	1595799	0	0
45690110	1115008	0	0
45680497	1174888	0	0
45704503	738818	0	0
45703240	1551192	2	3
45675294	1119510	0	0
45678908	975125	0	0
45784855	738818	0	0
45875979	3011505	1	1
45791109	1000560	0	0
45796485	1129625	0	0
46244558	738818	0	0
46307361	1738521	0	0
46303683	1332418	0	0
46302691	19079524	2	3
4116976	4306014	1	1
4218408	4218408	0	0
21001775	738818	0	0
21006763	1308738	0	0
35202051	317009	4	4
21502734	1309944	0	0
36427078	19126352	2	3
36702247	4043241	8	10
44345037	1174888	0	0
44350314	1129625	0	0
44338859	1308738	0	0
45643464	40228214	2	3
45643784	1307863	0	0
45649175	40228214	2	3
45653630	1125315	0	0
45642038	1125315	0	0
45630110	1119510	0	0
45654867	1149196	0	0
45690111	967823	0	0
45680498	1174888	0	0
45704511	1149380	0	0
45703275	1154615	2	3
45674865	1119510	0	0
45678718	1149196	0	0
45784871	738818	0	0
45875977	40769184	1	1
45791099	1500211	0	0
45796595	1129625	0	0
46244596	738818	0	0
46307425	1713332	0	0
46303690	975125	0	0
46313224	40228214	2	3
4116976	4302207	1	1
21000890	1713332	0	0
21001775	967823	0	0
21008439	1551099	0	0
21605007	1149196	4	4
21502741	1738521	0	0
36427229	35605482	2	3
36700000	375671	3	11
44344916	1124300	0	0
44350245	1129625	0	0
44338860	1124300	0	0
45643565	1332419	2	3
45643483	1322184	0	0
45647309	1545959	2	3
45653745	1125315	0	0
45641755	1125315	0	0
45630143	1119510	0	0
45654870	1192710	0	0
45690257	1738521	0	0
45680501	1549786	0	0
45704512	1124957	0	0
45703348	40162522	2	3
45675211	1119510	0	0
45678826	1310149	0	0
45785016	738818	0	0
45875977	40769189	1	1
45791100	967823	0	0
45796656	1129625	0	0
45787711	1177480	0	0
46307425	1759842	0	0
46303692	1595799	0	0
46312074	1539411	2	3
4108467	4296204	1	1
21000890	1746114	0	0
21001775	1125315	0	0
21008461	738818	0	0
21605007	1129625	4	4
21502752	1548195	0	0
36416791	19078924	2	3
36700000	378001	6	11
44344917	1551099	0	0
44350491	1129625	0	0
44338865	1153428	0	0
45643723	40223834	2	3
45643375	1149196	0	0
45647406	1115171	2	3
45653767	1125315	0	0
45641955	1125315	0	0
45630099	1119510	0	0
45654815	967823	0	0
45690268	1501700	0	0
45680501	1521369	0	0
45704356	920293	0	0
45703491	40229134	2	3
45675258	1119510	0	0
45678926	1539403	0	0
45785161	738818	0	0
45875977	40769194	1	1
45791048	1738521	0	0
45791489	1129625	0	0
45787690	1177480	0	0
46307426	1361711	0	0
46303176	1332418	0	0
46307371	1539411	2	3
4189601	4010253	1	1
21000802	975125	0	0
21001775	1150836	0	0
21008225	1713332	0	0
21605007	738818	4	4
21502752	1512674	0	0
36427387	19045231	2	3
36702253	4043241	10	11
44345130	1192710	0	0
44350365	1129625	0	0
44338973	1149196	0	0
45643518	40232448	2	3
45643494	1149380	0	0
45644362	1115171	2	3
45650222	1125315	0	0
45642046	1125315	0	0
45630025	1119510	0	0
45654816	1343916	0	0
45690203	1174888	0	0
45680365	1115008	0	0
45704357	1307863	0	0
45703472	40229134	2	3
45674869	1119510	0	0
45672501	1778162	0	0
45784952	738818	0	0
45875977	40769179	1	1
45791104	1551099	0	0
46298674	1129625	0	0
45787591	1177480	0	0
46307590	1717327	0	0
46303878	1174888	0	0
45791792	40228214	2	3
4189847	4117038	1	1
21000803	1595799	0	0
21001791	975125	0	0
21008225	1759842	0	0
21605007	1154343	4	4
21503001	1129625	0	0
36226536	19127904	2	3
37502353	4336464	7	11
44345132	1110410	0	0
44346772	1129625	0	0
44339049	1107830	0	0
45646062	40228214	2	3
45643790	1115008	0	0
45644457	19008572	2	3
45650225	1125315	0	0
45642054	1125315	0	0
45630275	1119510	0	0
45654817	1501700	0	0
45690204	1124957	0	0
45680366	738818	0	0
45700959	967823	0	0
45703330	40165015	2	3
45675205	1119510	0	0
45672507	1548195	0	0
45784843	738818	0	0
45875977	40766240	1	1
45791096	1115008	0	0
46298689	1129625	0	0
45787767	1177480	0	0
46307593	738818	0	0
46303989	1551099	0	0
46318040	19078461	2	3
4164337	4285898	1	1
21000890	1759842	0	0
21001778	967823	0	0
21008226	1713332	0	0
21605007	1174888	4	4
21502752	1549786	0	0
36424575	1594382	2	3
37522270	4323902	2	6
44344922	1548195	0	0
44346776	1129625	0	0
44339050	738818	0	0
45640509	19077572	2	3
45643624	723013	0	0
45644289	40165015	2	3
45650314	1125315	0	0
45638735	1125315	0	0
45630167	1119510	0	0
45654823	723013	0	0
45690161	1309944	0	0
45680376	1589505	0	0
45700961	1115008	0	0
45700402	40229134	2	3
45675264	1119510	0	0
45672404	1149196	0	0
45785220	738818	0	0
45875996	3006734	1	1
46294692	1332418	0	0
46298517	1129625	0	0
45801234	1177480	0	0
46307598	975125	0	0
46304006	1589505	0	0
46302099	19079524	2	3
4159963	195588	1	1
21000890	1741122	0	0
21001797	1778162	0	0
21008226	1759842	0	0
21605007	1149380	4	4
21502759	1501700	0	0
36423360	19074679	2	3
37522270	4117038	2	6
44345338	1137529	0	0
44346593	1129625	0	0
44338953	1759842	0	0
45640779	43012036	2	3
45643406	1738521	0	0
45644510	19057271	2	3
45650165	1125315	0	0
45638726	1125315	0	0
45630258	1119510	0	0
45654824	975125	0	0
45686952	1308738	0	0
45680376	1549786	0	0
45700802	753626	0	0
45700114	1127433	2	3
45675266	1119510	0	0
45672620	19127890	0	0
45785228	738818	0	0
45875996	3000876	1	1
46294744	1343916	0	0
46298724	1129625	0	0
45795769	1177480	0	0
46307305	757627	0	0
46304015	1192710	0	0
46312664	19078461	2	3
4159963	198199	1	1
21000874	975125	0	0
21001797	1759842	0	0
21008236	1759842	0	0
21605007	1137529	4	4
21502747	1545958	0	0
36427076	920300	2	3
37522270	4057420	4	7
44345338	1149380	0	0
44346805	1129625	0	0
44339075	1129625	0	0
45640889	1713671	2	3
45643412	1124300	0	0
45644424	40224805	2	3
45650267	1125315	0	0
45638922	1125315	0	0
45630335	1119510	0	0
45651176	1115008	0	0
45686954	1551099	0	0
45680344	1174888	0	0
45700874	1107830	0	0
45700309	40232448	2	3
45671909	1119510	0	0
45672620	1549786	0	0
45785074	738818	0	0
45875996	3021226	1	1
46294749	1000560	0	0
46298991	1129625	0	0
45795857	1177480	0	0
46307307	975125	0	0
46303903	1118084	0	0
45794277	19078461	2	3
4080926	133834	1	1
21000873	1551099	0	0
21001797	1746114	0	0
21008236	1713332	0	0
21605007	1107830	4	4
21502747	1539403	0	0
36427076	920334	2	3
37522270	44783196	4	5
44345240	1192710	0	0
44346742	1129625	0	0
44338981	1549786	0	0
45640847	1713671	2	3
45643749	738818	0	0
45641444	43012036	2	3
45650274	1125315	0	0
45638923	1125315	0	0
45630354	1119510	0	0
45651199	1738521	0	0
45686724	1738521	0	0
45680367	1501700	0	0
45700885	1717327	0	0
45700502	40232448	2	3
45672327	1119510	0	0
45672626	1154343	0	0
45786482	738818	0	0
45875996	3001488	1	1
46294092	975125	0	0
46299011	1129625	0	0
45795974	1177480	0	0
46307201	1501700	0	0
46303388	1551099	0	0
46307480	19078461	2	3
4082382	4326177	1	1
21000907	1310149	0	0
21001796	1728416	0	0
21011415	1110410	0	0
21602359	1519936	4	4
21600317	1361711	0	0
36424251	19018935	2	3
37522270	4337611	4	5
44344925	1332418	0	0
44346288	1129625	0	0
44338981	1521369	0	0
45640868	782047	2	3
45643509	1717327	0	0
45641413	1127433	2	3
45650276	1125315	0	0
45638762	1125315	0	0
45627107	1119510	0	0
45651367	738818	0	0
45686797	1153428	0	0
45680368	1713332	0	0
45700981	967823	0	0
45700349	1154615	2	3
45672550	1119510	0	0
45672531	1310149	0	0
45786250	738818	0	0
45875996	3023430	1	1
46294093	1310149	0	0
46299224	1129625	0	0
45795874	1177480	0	0
46307203	1192710	0	0
46303389	1153428	0	0
46299723	19078461	2	3
4083499	4078793	1	1
21001351	1343916	0	0
21001775	1174888	0	0
21011420	1343916	0	0
21602359	1500211	4	4
21604214	753626	0	0
36302180	4133840	2	3
36700000	4043241	5	12
44344928	1124957	0	0
44346601	1129625	0	0
44338745	1124957	0	0
45640997	40231925	2	3
45643512	1124957	0	0
45641650	40232448	2	3
45650138	1125315	0	0
45638771	1125315	0	0
45627109	1119510	0	0
45651215	1115008	0	0
45686956	1332418	0	0
45680368	1759842	0	0
45700689	740275	0	0
45700257	19018935	2	3
45672276	1119510	0	0
45672540	920293	0	0
45782873	738818	0	0
45875996	3019406	1	1
46294096	1000560	0	0
46291664	1129625	0	0
45795954	1177480	0	0
46307203	1174888	0	0
46301035	1361711	0	0
46302164	19078461	2	3
4190759	4163872	1	1
21001355	975125	0	0
21001775	1107830	0	0
21011856	1713332	0	0
21602359	19054876	4	4
1713671	1713671	0	0
36225403	19128065	2	3
36700000	4001336	5	10
44345245	1115008	0	0
44348579	1129625	0	0
44338908	1112807	0	0
45640998	40223834	2	3
45643763	1549786	0	0
44340904	1115008	0	0
45650493	1125315	0	0
45638892	1125315	0	0
45627363	1119510	0	0
45651164	19010482	0	0
45686949	708298	0	0
45680373	738818	0	0
45701069	1149196	0	0
45896820	40162522	2	3
45672594	1119510	0	0
45672543	791967	0	0
45782822	738818	0	0
45875996	3015076	1	1
46294630	1361711	0	0
46291843	1129625	0	0
45795852	1177480	0	0
46307204	1174888	0	0
46301052	1107830	0	0
46307458	19078461	2	3
4191948	40492359	1	1
21001359	1124300	0	0
21001796	1717327	0	0
21002077	1746114	0	0
21602359	1548195	4	4
21502553	1332419	7	8
36225402	19128065	2	3
36400000	4144583	5	9
44345079	1738521	0	0
44348445	1129625	0	0
44338811	967823	0	0
45640998	40223821	2	3
45643763	19127890	0	0
44340908	933724	0	0
45650497	1125315	0	0
45638898	1125315	0	0
45627539	1119510	0	0
45651166	1310149	0	0
45688737	1746114	0	0
45680353	1192710	0	0
45701097	1124957	0	0
45896880	1127433	2	3
45784024	1119510	0	0
45673275	1124957	0	0
45783017	738818	0	0
45875996	3006451	1	1
46294889	975125	0	0
46291156	1129625	0	0
45796046	1177480	0	0
46307523	738818	0	0
46301062	933724	0	0
46307682	19078461	2	3
4161134	4202451	1	1
21001359	975125	0	0
21001775	1192710	0	0
21002077	1741122	0	0
21602359	1512674	4	4
21502553	19018935	7	8
36463297	1332419	2	3
37522270	4336464	5	9
44345340	1738521	0	0
44342776	1129625	0	0
44338815	920293	0	0
45640874	40232448	2	3
45643837	742185	0	0
44340939	1545958	0	0
45650500	1125315	0	0
45639089	1125315	0	0
45623707	1119510	0	0
45651149	1149196	0	0
45688737	1741122	0	0
45680630	1305058	0	0
45700945	1713332	0	0
45697106	19008572	2	3
45784342	1119510	0	0
45673276	1192710	0	0
45783033	738818	0	0
45875996	3005136	1	1
46294639	1149380	0	0
46290402	1129625	0	0
45790654	1177480	0	0
46307215	1000560	0	0
46301067	975125	0	0
45799483	19078461	2	3
4112341	4294548	1	1
21001379	1759842	0	0
21001775	1149196	0	0
21002084	975125	0	0
21601386	19010482	4	4
21502553	1310034	7	8
36424721	1519937	2	3
36702247	4001336	5	8
44345251	740275	0	0
44342721	1129625	0	0
44338849	1177480	0	0
45640976	19133905	2	3
45645839	701322	0	0
44340962	1361711	0	0
45650616	1125315	0	0
45639103	1125315	0	0
45623900	1119510	0	0
45651169	1000560	0	0
45688532	1367571	0	0
45680681	1501700	0	0
45701137	1332418	0	0
45697394	40229134	2	3
45784353	1119510	0	0
45673276	1174888	0	0
45783154	738818	0	0
45875996	3001247	1	1
46294639	1137529	0	0
46290514	1129625	0	0
46297242	1177480	0	0
46307576	1115008	0	0
46300923	1501700	0	0
45802061	19078461	2	3
4112341	4112343	1	1
21001381	1717327	0	0
21001688	1310149	0	0
21002052	1713332	0	0
21601386	1500211	4	4
21502553	19126352	7	8
36424721	43012433	2	3
37303796	133834	5	8
44345043	1177480	0	0
44342762	1129625	0	0
44338999	1000560	0	0
45640976	19133873	2	3
45640772	1551099	0	0
44340909	1124300	0	0
45650188	1125315	0	0
45635369	1125315	0	0
45625144	1119510	0	0
45651406	1107830	0	0
45688406	1149196	0	0
45680650	1149196	0	0
45700817	1310149	0	0
45697397	40229134	2	3
45784262	1119510	0	0
45673186	1154343	0	0
45782999	738818	0	0
45875996	3020655	1	1
46294644	1713332	0	0
46290430	1129625	0	0
46297764	1177480	0	0
46307587	1307863	0	0
46300925	1112807	0	0
46318480	19078461	2	3
4043174	4216130	1	1
21001382	1713332	0	0
21001686	1310149	0	0
21002094	1717327	0	0
21604208	753626	2	2
35702767	81893	6	8
36427297	40231925	2	3
37522270	4330583	5	8
44345043	1129625	0	0
44342792	1129625	0	0
44339004	1129625	0	0
45640987	40232448	2	3
45640527	1738521	0	0
44340945	701322	0	0
45650368	1125315	0	0
45635625	1125315	0	0
45625215	1119510	0	0
45651174	975125	0	0
45688409	738818	0	0
45680349	1557272	0	0
45700986	1124957	0	0
45697369	1127433	2	3
45784280	1119510	0	0
45673384	1124957	0	0
45783111	738818	0	0
45875996	3012494	1	1
46294644	1759842	0	0
46290698	1129625	0	0
46297972	1177480	0	0
46307802	1174888	0	0
46300773	1332418	0	0
46300307	40223768	2	3
4043029	4024289	1	1
21001378	1717327	0	0
21001686	1367571	0	0
21002088	975125	0	0
21602496	1512674	2	2
36200000	4084167	7	7
36424211	40229134	2	3
40776263	3026361	5	7
44345046	1589505	0	0
44343082	1129625	0	0
44339004	1177480	0	0
45640639	40236824	2	3
45640646	1153428	0	0
44340952	738818	0	0
45650262	1125315	0	0
45635627	1125315	0	0
45625230	1119510	0	0
45651359	1115008	0	0
45688517	1115008	0	0
45680633	1110410	0	0
45700952	1738521	0	0
45697509	19078461	2	3
45784253	1119510	0	0
45673386	723013	0	0
45783315	738818	0	0
45875996	3036780	1	1
46294648	1307863	0	0
46290757	1129625	0	0
46289803	1177480	0	0
46307443	1153428	0	0
46300542	1310149	0	0
45895602	19078461	2	3
4027255	317576	1	1
21001379	1717327	0	0
21001701	975125	0	0
21002068	1741122	0	0
21602496	1589505	2	2
21502709	1149196	7	7
36244042	44816277	2	3
40776263	3010813	5	7
44345157	1326303	0	0
44343019	1129625	0	0
44338817	1501700	0	0
45641180	1127433	2	3
45640750	753626	0	0
44340911	1115008	0	0
45647280	1125315	0	0
45635629	1125315	0	0
45624137	1119510	0	0
45651388	1310149	0	0
45688697	738818	0	0
45680636	791967	0	0
45701082	1107830	0	0
45697420	19008572	2	3
45784270	1119510	0	0
45673296	1192710	0	0
45783141	738818	0	0
45875996	3014599	1	1
46294656	1549786	0	0
46290948	1129625	0	0
46241557	1177480	0	0
46307489	933724	0	0
46300678	1112807	0	0
46296219	19078461	2	3
4178680	80180	1	1
21001357	1124300	0	0
21001738	1174888	0	0
21002068	1746114	0	0
21604255	1124957	2	2
21502709	1177480	7	7
36429708	40171902	1	1
36703532	4132546	5	7
44344993	1729720	0	0
44339492	1129625	0	0
44338826	740275	0	0
45641097	40232448	2	3
45640589	1149196	0	0
44340884	1305058	0	0
45647302	1125315	0	0
45637187	1125315	0	0
45624209	1119510	0	0
45651390	738818	0	0
45688729	1124300	0	0
45680643	1759842	0	0
45700989	1000560	0	0
45894727	19078461	2	3
45786454	1119510	0	0
45672666	1115008	0	0
45783205	738818	0	0
45875996	3027231	1	1
46294656	1512674	0	0
46290669	1129625	0	0
46241590	1177480	0	0
46307495	757627	0	0
46300875	1174888	0	0
46318469	19078461	2	3
4178431	4035415	1	1
21001380	1778162	0	0
21001707	967823	0	0
21002069	1741122	0	0
21602100	975125	2	2
21502709	1154343	7	7
36303102	4163951	1	1
36700000	44782520	5	7
44344994	1115008	0	0
44339550	1129625	0	0
44339057	1177480	0	0
45637612	19008572	2	3
45640889	1713332	0	0
44340688	1115008	0	0
45647266	1125315	0	0
45637034	1125315	0	0
45624183	1119510	0	0
45651391	1115008	0	0
45687059	967823	0	0
45680643	1713332	0	0
45701199	1308738	0	0
45894819	40228230	2	3
45786455	1119510	0	0
45672633	1192710	0	0
45783333	738818	0	0
45875980	3049273	1	1
46294657	975125	0	0
46290814	1129625	0	0
46241697	1177480	0	0
46307681	738818	0	0
46300878	1545958	0	0
46312420	19078461	2	3
4064927	4062501	1	1
21001379	1778162	0	0
21001738	1125315	0	0
21002069	1746114	0	0
21602478	42902245	2	2
21502552	19059056	6	7
36424218	19115351	1	1
36300000	4145310	5	7
44345089	1192710	0	0
44339353	1129625	0	0
44339198	1129625	0	0
45637646	40163554	2	3
45640889	1759842	0	0
44340841	1118084	0	0
45647160	1125315	0	0
45636837	1125315	0	0
45624165	1119510	0	0
45651398	1332418	0	0
45687084	1738521	0	0
45680685	1149196	0	0
45701203	1343916	0	0
45694415	19008572	2	3
45786459	1119510	0	0
45672647	1738521	0	0
45778126	738818	0	0
45876002	3019550	1	1
46294802	1154343	0	0
46290815	1129625	0	0
46241681	1177480	0	0
46302194	933724	0	0
46300888	1548195	0	0
46312534	19078461	2	3
4068155	313217	1	1
21001379	1728416	0	0
21001710	1343916	0	0
21002070	1741122	0	0
35202454	313217	2	2
21502552	40163554	6	7
36303181	4234705	1	1
40792793	3026361	5	7
44345089	1177480	0	0
44341422	1129625	0	0
44339201	1129625	0	0
45637766	43012036	2	3
45640509	757627	0	0
44340843	1192710	0	0
45647169	1125315	0	0
45636838	1125315	0	0
45624256	1119510	0	0
45651306	1396131	0	0
45687130	975125	0	0
45680690	1192710	0	0
45701001	1174888	0	0
45694447	1713671	2	3
45784371	1119510	0	0
45672667	1107830	0	0
46242632	738818	0	0
45876002	3013721	1	1
46294806	723013	0	0
46291084	1129625	0	0
45897976	1177480	0	0
46302311	1521369	0	0
46301070	1501700	0	0
46296392	19078461	2	3
4063381	4280726	1	1
21001378	1759842	0	0
21001738	1129625	0	0
21002071	1741122	0	0
21602752	1501700	2	2
21502552	19075601	6	7
36304718	3013682	1	1
36902280	4043241	5	7
44345092	1177480	0	0
44341300	1129625	0	0
44339207	1174888	0	0
45637892	19019273	2	3
45640709	1174888	0	0
44340844	1332418	0	0
45649009	1125315	0	0
45637150	1125315	0	0
45624392	1119510	0	0
45651612	920293	0	0
45687066	715997	0	0
45676886	1192710	0	0
45701165	967823	0	0
45694261	19018935	2	3
45784385	1119510	0	0
45672649	920293	0	0
46240248	738818	0	0
45876002	3015632	1	1
46296566	1129625	0	0
46291057	1129625	0	0
45898002	1177480	0	0
46302358	933724	0	0
46301618	1589505	0	0
46308120	19078461	2	3
4187067	317576	1	1
21001380	1759842	0	0
21001738	1192710	0	0
21002072	1746114	0	0
21602480	19128009	2	2
4093991	4296204	5	6
36304718	3024561	1	1
36402192	439777	5	7
44345088	1177480	0	0
44339773	1129625	0	0
44338920	1177480	0	0
45637904	1115171	2	3
45640992	740275	0	0
44340849	1115008	0	0
45649012	1125315	0	0
45636928	1125315	0	0
45668478	1119510	0	0
45651619	1549786	0	0
45687069	1149196	0	0
45676699	738818	0	0
45701353	740275	0	0
45694435	19059056	2	3
45784457	1119510	0	0
45672654	975125	0	0
46240362	738818	0	0
45876002	3006923	1	1
46296648	1129625	0	0
46291069	1129625	0	0
45897964	1177480	0	0
46302361	920293	0	0
46301678	1557272	0	0
46318225	19078461	2	3
4187096	4059173	1	1
21001382	1759842	0	0
21001688	1367571	0	0
21002072	1741122	0	0
21602480	19127918	2	2
4227253	4166224	5	6
36304718	3004501	1	1
37303814	4066995	5	6
44345006	1129625	0	0
44362940	1119510	0	0
44339067	1129625	0	0
45637909	40229134	2	3
45640813	1539403	0	0
44340985	1000560	0	0
45649016	1125315	0	0
45637220	1125315	0	0
45668269	1119510	0	0
45651619	19127890	0	0
45687097	740275	0	0
45676847	1149196	0	0
45701245	967823	0	0
45694602	19008572	2	3
45784409	1119510	0	0
45672656	1124957	0	0
45703272	738818	0	0
45876002	3027970	1	1
46293651	1129625	0	0
46290618	1129625	0	0
45895702	1177480	0	0
46302369	1124957	0	0
46301663	1174888	0	0
46319088	19078461	2	3
4180765	4252419	1	1
21000912	1728416	0	0
21013411	1768849	0	0
21002073	1741122	0	0
35202050	321042	2	2
4227253	313217	5	6
36304718	3016723	1	1
37303814	4048695	5	6
44338115	1177480	0	0
44363082	1119510	0	0
44360400	933724	0	0
45637992	19073183	2	3
45640718	1539403	0	0
44340922	738818	0	0
45647369	1125315	0	0
45637222	1125315	0	0
45668271	1119510	0	0
45651619	1512674	0	0
45687284	1343916	0	0
45677074	1548195	0	0
45701065	1107830	0	0
45694596	40163554	2	3
45784487	1119510	0	0
45672695	1717327	0	0
45703276	738818	0	0
45876002	3035995	1	1
46293589	1129625	0	0
46290628	1129625	0	0
45895780	1177480	0	0
46302471	1174888	0	0
46301702	1713332	0	0
45799501	19078461	2	3
4180765	4024289	1	1
21000912	1729720	0	0
21013411	1713332	0	0
21002074	1741122	0	0
35202050	4324181	2	2
4180938	4058899	4	6
36303158	4012477	1	1
36703532	381316	5	6
44338173	1326303	0	0
44362987	1119510	0	0
44360088	1112807	0	0
44343795	43012036	2	3
45640728	1307863	0	0
44340924	738818	0	0
45647408	1125315	0	0
45635940	1125315	0	0
45668276	1119510	0	0
45651648	1589505	0	0
45687137	1124957	0	0
45677087	1501700	0	0
45700857	1589505	0	0
45691336	40232448	2	3
45784433	1119510	0	0
45672698	1549786	0	0
45703491	738818	0	0
45876002	3023103	1	1
46293751	1129625	0	0
46242437	1129625	0	0
45895785	1177480	0	0
46302167	1332418	0	0
46301748	1326303	0	0
45796915	1332419	2	3
4115236	40481087	1	1
21000931	791967	0	0
21013430	740275	0	0
21002075	1741122	0	0
21604303	1125315	2	2
4213101	4066995	4	6
36304850	3006906	1	1
40792793	3010813	5	6
44338174	1307863	0	0
44362995	1119510	0	0
44360413	1174888	0	0
44340084	1115171	2	3
45640847	1713332	0	0
44340934	975125	0	0
45644240	1125315	0	0
45635834	1125315	0	0
45668239	1119510	0	0
45651648	1549786	0	0
45687104	1738521	0	0
45677007	1115008	0	0
45700857	1549786	0	0
45802647	40229134	2	3
45782313	1119510	0	0
45672702	1107830	0	0
45703472	738818	0	0
45876002	3004501	1	1
46293494	1129625	0	0
46242371	1129625	0	0
45895869	1177480	0	0
46301992	914335	0	0
46301750	1343916	0	0
46299644	19078461	2	3
4105866	81151	1	1
21000919	791967	0	0
21013433	1746114	0	0
21002075	1746114	0	0
21604303	1112807	2	2
4042505	4230399	6	6
36304850	3024561	1	1
36702242	378419	5	6
44338215	1738521	0	0
44363243	1119510	0	0
44360383	1129625	0	0
44340147	19018935	2	3
45640847	1759842	0	0
44340890	723013	0	0
45644309	1125315	0	0
45635762	1125315	0	0
45668387	1119510	0	0
45651653	738818	0	0
45687187	1768849	0	0
45677008	1124957	0	0
45700857	19127890	0	0
45802539	1115171	2	3
45782315	1119510	0	0
45672711	1124957	0	0
45700402	738818	0	0
45876002	3014576	1	1
46293811	1129625	0	0
46242522	1129625	0	0
45896011	1177480	0	0
46302115	1000560	0	0
46301847	1322184	0	0
46313035	19078461	2	3
4074815	81893	1	1
21000467	1548195	0	0
21013448	1539403	0	0
21002059	1112807	0	0
21603395	1174888	2	2
35802131	140673	6	6
36304850	3013682	1	1
36702253	44782520	5	6
44338226	1326303	0	0
44363466	1119510	0	0
44360391	933724	0	0
44340255	1127433	2	3
45640854	738818	0	0
44340891	1115008	0	0
45644147	1125315	0	0
45635768	1125315	0	0
45668391	1119510	0	0
45651555	1154343	0	0
45687235	975125	0	0
45677010	1124957	0	0
45700860	1149196	0	0
45876033	3020630	2	3
45782316	1119510	0	0
45672772	967823	0	0
45697394	738818	0	0
45876002	3013682	1	1
46293725	1129625	0	0
46242353	1129625	0	0
45804223	1177480	0	0
46302282	1107830	0	0
46301618	1549786	0	0
46307409	19078461	2	3
4074298	4238715	1	1
21000404	1551099	0	0
21013455	1124300	0	0
21002089	975125	0	0
21603366	1125443	2	2
21502549	1308738	6	6
36304850	3004501	1	1
36702247	380378	5	6
44338227	738818	0	0
44363381	1119510	0	0
44359771	1107830	0	0
44340370	19008572	2	3
45640856	1551099	0	0
45636975	1107830	0	0
45644273	1125315	0	0
45636064	1125315	0	0
45668370	1119510	0	0
45651493	1729720	0	0
45687237	1107830	0	0
45679392	715997	0	0
45700871	738818	0	0
45876033	3045716	2	3
45782502	1119510	0	0
45672641	967823	0	0
45697397	738818	0	0
45876002	3009201	1	1
46293952	1129625	0	0
46242548	1129625	0	0
45804216	1177480	0	0
46302017	1501700	0	0
46301752	1332418	0	0
46299662	19078461	2	3
4074298	4275113	1	1
21000423	975125	0	0
21013432	1717327	0	0
21002089	1551099	0	0
21603617	975125	2	2
21502549	1746114	6	6
36304850	3016723	1	1
37503887	4198190	5	6
44338229	1557272	0	0
44363179	1119510	0	0
44360037	1110410	0	0
44340374	19077572	2	3
45640862	1521369	0	0
45637302	738818	0	0
45644278	1125315	0	0
45632547	1125315	0	0
45668373	1119510	0	0
45651382	1729720	0	0
45687241	1154029	0	0
45679452	1154029	0	0
45700788	1305058	0	0
45876033	3019550	2	3
45782528	1119510	0	0
45672645	1192710	0	0
45894805	738818	0	0
45876002	3024561	1	1
46288772	1129625	0	0
46240264	1129625	0	0
45804047	1177480	0	0
46302311	1549786	0	0
46301939	723013	0	0
45791657	19078461	2	3
4085100	40481087	1	1
21000404	975125	0	0
21013432	1778162	0	0
21002084	1551099	0	0
21603638	1124300	2	2
21502549	1713332	6	6
36403211	80502	1	1
37522270	4242997	5	6
44338190	1549786	0	0
44363257	1119510	0	0
44360042	1305058	0	0
44339943	19133905	2	3
45640862	1549786	0	0
45637393	1124300	0	0
45644372	1125315	0	0
45632642	1125315	0	0
45668452	1119510	0	0
45651412	1192710	0	0
45687184	1778162	0	0
45679287	723013	0	0
45700792	1107830	0	0
45688459	40162522	2	3
45782565	1119510	0	0
45672686	1192710	0	0
45694981	738818	0	0
45876002	3020630	1	1
46289124	1129625	0	0
45896240	1129625	0	0
45803835	1177480	0	0
46302022	1521369	0	0
46301240	1000560	0	0
46318696	40174880	2	3
4043017	4035793	1	1
21000472	975125	0	0
21013431	791967	0	0
21002098	975125	0	0
21602723	975125	2	2
4227253	440448	6	6
36248814	40174880	1	2
40796010	3026361	5	5
44338190	19127890	0	0
44363258	1119510	0	0
44360233	1110410	0	0
44340486	19019273	2	3
45640866	1548195	0	0
45637365	1539403	0	0
45644327	1125315	0	0
45632826	1125315	0	0
45668789	1119510	0	0
45651414	975125	0	0
45687209	1322184	0	0
45679663	1154029	0	0
45700831	1110410	0	0
45800015	19078461	2	3
45782589	1119510	0	0
45672688	1738521	0	0
45694606	738818	0	0
45876002	3006906	1	1
46289277	1129625	0	0
45896457	1129625	0	0
45804083	1177480	0	0
46302027	1589505	0	0
46301246	1107830	0	0
46318938	1545959	2	3
4180248	4035793	1	1
21000472	1551099	0	0
21013458	705944	0	0
21502657	1118084	0	0
21602723	1551099	2	2
1713545	1713671	1	1
36248806	40174880	1	2
36300000	4195803	5	5
44338190	1512674	0	0
44363193	1119510	0	0
44359774	1548195	0	0
44340494	920334	2	3
45640868	782043	0	0
45637341	1154029	0	0
45644092	1125315	0	0
45632751	1125315	0	0
45668525	1119510	0	0
45651423	1343916	0	0
45687210	1729720	0	0
45679664	1107830	0	0
45700834	738818	0	0
45799993	43012036	2	3
45782590	1119510	0	0
45672791	1149196	0	0
45802647	738818	0	0
46233710	46233710	0	0
46243839	1129625	0	0
45896622	1129625	0	0
45804027	1177480	0	0
46302101	1778162	0	0
46301270	1729720	0	0
45894285	1332419	2	3
4105895	4293740	1	1
21000472	1305058	0	0
21013433	1759842	0	0
21602860	1741122	0	0
21604182	19016749	2	2
1717504	19129655	1	1
36225210	1539411	1	2
37302323	4156265	5	5
44338176	1501700	0	0
44363323	1119510	0	0
44360124	1118084	0	0
44340417	19019273	2	3
45640961	1343916	0	0
45625321	1332418	0	0
45644161	1125315	0	0
45632785	1125315	0	0
45665857	1119510	0	0
45651432	1717327	0	0
45687200	1107830	0	0
45679672	19127890	0	0
45697943	1115008	0	0
45800053	40229134	2	3
45782534	1119510	0	0
45672673	1501700	0	0
45688171	738818	0	0
46238179	1149196	0	0
46243754	1129625	0	0
45894114	1129625	0	0
45798907	1177480	0	0
46302249	1124300	0	0
46301275	1322184	0	0
46300426	1332419	2	3
4040398	4243062	1	1
21000471	1551099	0	0
21013433	920293	0	0
21003026	1154029	0	0
21603057	920293	2	2
4056622	4056621	1	1
36225209	1539411	1	2
40779591	3021226	5	5
44338265	1177480	0	0
44363302	1119510	0	0
44359780	975125	0	0
44340631	40232448	2	3
45640996	738818	0	0
45625323	975125	0	0
45644179	1125315	0	0
45632824	1125315	0	0
45667371	1119510	0	0
45651435	740275	0	0
45687296	1000560	0	0
45679672	1589505	0	0
45697876	1343916	0	0
45800082	19077572	2	3
45782665	1119510	0	0
45672719	1192710	0	0
45688436	738818	0	0
46235214	46235214	0	0
46243849	1129625	0	0
45894088	1129625	0	0
45799812	1177480	0	0
46302216	1713332	0	0
46301184	1308738	0	0
45796860	1332419	2	3
4043028	4252419	1	1
21000474	1149380	0	0
21013433	1768849	0	0
21003025	19003953	0	0
21601854	1545958	2	2
4092747	378419	1	1
36225662	35605482	1	2
40779591	3023430	5	5
44338124	1713332	0	0
44363596	1119510	0	0
44360423	975125	0	0
44340521	40232448	2	3
45640997	1124957	0	0
45622036	740275	0	0
45644342	1125315	0	0
45632922	1125315	0	0
45667225	1119510	0	0
45651682	1728416	0	0
45687203	1107830	0	0
45679672	1549786	0	0
45697920	1115008	0	0
45800084	1127433	2	3
45782235	1119510	0	0
45672723	1551099	0	0
45800016	738818	0	0
46221622	46221626	0	0
46241468	1129625	0	0
45798540	1119510	0	0
45793508	1177480	0	0
46302126	933724	0	0
46301395	1112807	0	0
46302167	1332419	2	3
4040396	4202451	1	1
21000431	1305058	0	0
21013475	1738521	0	0
21003025	753626	0	0
21601765	1307863	2	2
4092807	4012477	1	1
36246594	40173590	1	2
40779591	3036780	5	5
44338124	1759842	0	0
44356332	1119510	0	0
44360430	1500211	0	0
44340464	40232448	2	3
45640998	1153428	0	0
45621788	738818	0	0
45644089	1125315	0	0
45632789	1125315	0	0
45666380	1119510	0	0
45651690	1115008	0	0
45687248	1307863	0	0
45679675	1589505	0	0
45697921	738818	0	0
45800086	40229134	2	3
45782483	1119510	0	0
45672756	1713332	0	0
45800053	738818	0	0
46221626	46221626	0	0
46241444	1129625	0	0
45798380	1119510	0	0
45793553	1177480	0	0
46302387	1149196	0	0
46301401	975125	0	0
46318059	19079524	2	3
4179141	4035415	1	1
21000450	1500211	0	0
21013433	1778162	0	0
21003024	753626	0	0
21602472	1512674	2	2
4180938	4195803	1	1
36246593	40173590	1	2
40779591	3014599	5	5
44338125	1112807	0	0
44356425	1119510	0	0
44359784	1115008	0	0
44340596	40232448	2	3
45640845	1149196	0	0
45621835	1738521	0	0
45644209	1125315	0	0
45632932	1125315	0	0
45666476	1119510	0	0
45651779	1548195	0	0
45683955	1149380	0	0
45679675	19127890	0	0
45698037	723013	0	0
45800215	19075001	2	3
45782484	1119510	0	0
45672857	1539403	0	0
45800086	738818	0	0
46238178	1332418	0	0
46241635	1129625	0	0
45798659	1119510	0	0
45793687	1177480	0	0
46302389	1174888	0	0
46301354	1112807	0	0
45796907	1332419	2	3
4048365	4052083	1	1
21000471	975125	0	0
21013411	1759842	0	0
21003039	708298	0	0
21602472	1519936	2	2
4141657	4058899	1	1
36226749	40224805	1	2
36603422	40479768	5	5
44338134	1500211	0	0
44356412	1119510	0	0
44360319	967823	0	0
44337353	1115171	2	3
45640962	1539403	0	0
45621838	1310149	0	0
45644171	1125315	0	0
45632941	1125315	0	0
45666477	1119510	0	0
45651569	1192710	0	0
45683959	1309944	0	0
45679675	1549786	0	0
45698073	1549786	0	0
45800221	1115171	2	3
45782673	1119510	0	0
45672942	1545958	0	0
45799984	738818	0	0
46238182	1192710	0	0
46241578	1129625	0	0
45798616	1119510	0	0
45793786	1177480	0	0
46302395	738818	0	0
46301320	1551099	0	0
46240037	1545959	2	3
4043160	4199276	1	1
21000702	1539403	0	0
21013486	1129625	0	0
21003025	914335	0	0
21602472	1589505	2	2
4143250	4285898	1	1
36226749	40224132	1	2
36603422	40479422	5	5
44338135	1000560	0	0
44356416	1119510	0	0
44360359	1129625	0	0
44337330	40222846	2	3
45640877	967823	0	0
45621794	708298	0	0
45644428	1125315	0	0
45632869	1125315	0	0
45666521	1119510	0	0
45648176	1115008	0	0
45683912	1000560	0	0
45679503	1149196	0	0
45698073	1521369	0	0
45800282	1539411	2	3
45782610	1119510	0	0
45672734	1174888	0	0
45800095	738818	0	0
46238184	742185	0	0
46241598	1129625	0	0
45798360	1119510	0	0
45793643	1177480	0	0
46302225	1308738	0	0
46301303	1112807	0	0
45794333	1539411	2	3
4043160	4059978	1	1
21000702	1332418	0	0
21013433	1738521	0	0
21003079	1102527	0	0
21602514	1549786	2	2
4328798	4151422	1	1
36244815	44816277	1	2
37522193	4107731	5	5
44338269	1112807	0	0
44356489	1119510	0	0
44360360	1149380	0	0
44337332	40232448	2	3
45640878	1361711	0	0
45621806	1551099	0	0
45644433	1125315	0	0
45632844	1125315	0	0
45663821	1119510	0	0
45648178	1154029	0	0
45684122	1549786	0	0
45679511	740275	0	0
45697884	1174888	0	0
45800354	19008572	2	3
45782618	1119510	0	0
45672736	1115008	0	0
45685684	738818	0	0
45798316	1149196	0	0
46241610	1129625	0	0
45798759	1119510	0	0
45788461	1177480	0	0
46302229	1110410	0	0
46301364	1110410	0	0
46303440	42902245	2	2
4047779	4285898	7	10
21000640	1521369	0	0
21013489	1343916	0	0
21003056	1129625	0	0
21602514	1548195	2	2
4267432	439777	1	1
36246159	43012433	1	2
36702239	378419	5	5
44338194	1551099	0	0
44356574	1119510	0	0
44360240	1738521	0	0
45620321	19008572	2	3
45640976	1729720	0	0
45621807	1118084	0	0
45644303	1125315	0	0
45632771	1125315	0	0
45663971	1119510	0	0
45648183	1000560	0	0
45684122	19127890	0	0
45679426	1000560	0	0
45697989	1107830	0	0
45685900	1154615	2	3
45702533	1119510	0	0
45672771	723013	0	0
45685383	738818	0	0
45798528	1501700	0	0
46241526	1129625	0	0
45798556	1119510	0	0
45788459	1177480	0	0
46302233	1549786	0	0
46301506	1118084	0	0
46301618	19128009	2	2
4047779	4043241	7	10
21000640	1503184	0	0
21013490	1343916	0	0
21003063	1129625	0	0
35508581	42902245	2	2
4269879	4168004	1	1
36246160	43012433	1	2
37303790	4296204	5	5
44337774	1149380	0	0
44349208	1119510	0	0
44359788	1129625	0	0
45620271	19075601	2	3
45640989	19010482	0	0
45621720	19127890	0	0
45644396	1125315	0	0
45632856	1125315	0	0
45664078	1119510	0	0
45648185	1124957	0	0
45684123	1548195	0	0
45679434	1307863	0	0
45697990	1149380	0	0
45685508	40163554	2	3
45702716	1119510	0	0
45672979	1115008	0	0
45799949	738818	0	0
45798320	1738521	0	0
46238757	1129625	0	0
45798364	1119510	0	0
45788475	1177480	0	0
46302233	19127890	0	0
46301507	1713332	0	0
46301618	19127918	2	2
4029205	4198190	7	9
21000640	1595799	0	0
21002747	975125	0	0
21003063	1125315	0	0
21601766	1307863	2	2
4226399	313217	1	1
36227103	40165015	1	2
37320089	133834	5	5
44337943	1149380	0	0
44349172	1119510	0	0
44359791	1192710	0	0
45620187	19133768	2	3
45641070	1149196	0	0
45621720	1549786	0	0
45644515	1125315	0	0
45632857	1125315	0	0
45663997	1119510	0	0
45648187	1343916	0	0
45684124	975125	0	0
45677139	1115008	0	0
45697934	1551099	0	0
45685684	40229134	2	3
45702741	1119510	0	0
45672982	1124957	0	0
45799720	738818	0	0
45798325	1107830	0	0
46238819	1129625	0	0
45798365	1119510	0	0
45788573	1177480	0	0
46302233	1512674	0	0
46301418	975125	0	0
500002101	4296205	2	2
4180628	4230399	7	8
21000640	19127890	0	0
21002781	19010482	0	0
21003063	1177480	0	0
21601766	40171902	2	2
21505865	705944	1	1
36226711	782047	1	2
36703532	4029498	5	5
44337985	740275	0	0
44349408	1119510	0	0
44360243	1115008	0	0
45620137	19008572	2	3
45640630	967823	0	0
45620606	1124300	0	0
45641431	1125315	0	0
45632644	1125315	0	0
45664176	1119510	0	0
45648295	1154343	0	0
45684126	1551099	0	0
45677186	1115008	0	0
45698051	1153428	0	0
45685318	40223768	2	3
45702689	1119510	0	0
45672992	975125	0	0
45794918	738818	0	0
45798493	1174888	0	0
46240057	1129625	0	0
45793174	1119510	0	0
45788688	1177480	0	0
46302446	1738521	0	0
46301440	1539403	0	0
500002101	4299128	2	2
4178818	258780	7	7
21000669	1308738	0	0
21002783	1305058	0	0
21003027	791967	0	0
21602728	975125	2	2
21503005	738818	1	1
36248905	46221626	1	2
36702242	4132546	5	5
44337986	1129625	0	0
44349352	1119510	0	0
44359936	738818	0	0
45620448	19023398	2	3
45640635	1549786	0	0
45620578	1124957	0	0
45641530	1125315	0	0
45632958	1125315	0	0
45664043	1119510	0	0
45648296	1000560	0	0
45684127	738818	0	0
45677173	1000560	0	0
45698064	914335	0	0
45685319	1115171	2	3
45702651	1119510	0	0
45672793	1305058	0	0
45679119	738818	0	0
45798242	1557272	0	0
45897645	1129625	0	0
45793177	1119510	0	0
45788628	1177480	0	0
46302450	1551099	0	0
46301237	975125	0	0
46308809	19127918	2	2
4117930	258780	7	7
21000702	1545958	0	0
21002791	1759842	0	0
21003038	723013	0	0
21602728	1551099	2	2
21502749	1589505	1	1
36244985	19125062	1	2
36919117	4043241	5	5
44337991	1177480	0	0
44349601	1119510	0	0
44359938	738818	0	0
45620370	40224805	2	3
45640635	19127890	0	0
45620583	1115008	0	0
45641492	1125315	0	0
45630938	1125315	0	0
45664108	1119510	0	0
45648302	1149196	0	0
45684043	1545958	0	0
45677158	1713332	0	0
45697906	1154343	0	0
45685417	1127433	2	3
45702652	1119510	0	0
45672760	1539403	0	0
45679449	738818	0	0
45798453	975125	0	0
45897697	1129625	0	0
45793192	1119510	0	0
46301431	1177480	0	0
46302465	1322184	0	0
46301329	1174888	0	0
46308809	19128009	2	2
4117930	198809	7	7
19059528	19059528	0	0
21002791	1778162	0	0
21003079	1124957	0	0
21602753	40174880	2	2
21502749	975125	1	1
36248622	45892894	1	2
36902280	440086	5	5
44338199	1177480	0	0
44350015	1119510	0	0
44360303	1729720	0	0
45620373	40232448	2	3
45640635	1589505	0	0
45620566	1305058	0	0
45641460	1125315	0	0
45630941	1125315	0	0
45664139	1119510	0	0
45649185	1308738	0	0
45683987	1153428	0	0
45677158	1759842	0	0
45698017	1310149	0	0
45685261	19059056	2	3
45702546	1119510	0	0
45672828	1000560	0	0
45792061	738818	0	0
45798655	1154343	0	0
45897744	1129625	0	0
45793194	1119510	0	0
46301330	1177480	0	0
46306891	1174888	0	0
46301713	933724	0	0
46320092	42902245	2	2
4042150	4163971	7	7
19018935	19018935	0	0
21002792	1746114	0	0
21003079	1110410	0	0
21602753	1501700	2	2
4181060	4059978	1	1
36248623	45892894	1	2
37522270	4125906	5	5
44337968	1192710	0	0
44350046	1119510	0	0
44359942	1118084	0	0
44362250	19008572	2	3
45640639	933724	0	0
45620669	975125	0	0
45641589	1125315	0	0
45630948	1125315	0	0
45660747	1119510	0	0
45649228	1539403	0	0
45683993	1332418	0	0
45677188	738818	0	0
45698023	738818	0	0
45685383	40229134	2	3
45702939	1119510	0	0
45672842	1589505	0	0
45792181	738818	0	0
45798658	791967	0	0
45897835	1129625	0	0
45793200	1119510	0	0
46301452	1177480	0	0
46306685	1192710	0	0
46319618	1112807	0	0
46314764	19128009	2	2
4199402	255848	7	7
19019979	19019979	0	0
21002744	1129625	0	0
21003079	1112807	0	0
21603379	1125443	2	2
4181063	30753	1	1
36463118	19128263	1	2
40796128	3024561	5	5
44338202	1177480	0	0
44341801	1119510	0	0
44359949	1545958	0	0
44361983	40228230	2	3
45640645	1124957	0	0
45620693	975125	0	0
45641593	1125315	0	0
45629665	1125315	0	0
45660951	1119510	0	0
45649239	1192710	0	0
45684183	1548195	0	0
45677194	738818	0	0
45698035	1746114	0	0
45800043	40223834	2	3
45702818	1119510	0	0
45672849	1738521	0	0
45792210	738818	0	0
45798661	1154029	0	0
45897821	1129625	0	0
45793481	1119510	0	0
46301489	1177480	0	0
46306809	1717327	0	0
46319259	1501700	0	0
46315314	40223768	2	3
4048384	4168004	7	7
4302207	4302207	0	0
21002796	1746114	0	0
21003079	1177480	0	0
21603396	1174888	2	2
4181063	372328	1	1
36463118	19128022	1	2
40796128	3027970	5	5
44338151	1551099	0	0
44342122	1119510	0	0
44359961	1551099	0	0
44361999	1545959	2	3
45641086	1110410	0	0
45620654	1174888	0	0
45641594	1125315	0	0
45629649	1125315	0	0
45661041	1119510	0	0
45649225	1332418	0	0
45684201	1174888	0	0
45677199	1521369	0	0
45698035	1741122	0	0
45799872	19076374	2	3
45696618	1119510	0	0
45672850	975125	0	0
45792376	738818	0	0
45798667	1310149	0	0
45897915	1129625	0	0
45793434	1119510	0	0
46298141	1177480	0	0
46306322	914335	0	0
46319805	1539403	0	0
46320683	1107882	2	3
4043022	40492359	7	7
4280726	4280726	0	0
21002783	1551099	0	0
21003076	1125315	0	0
21601746	1332418	2	2
4181063	195588	1	1
36303164	4024958	1	4
37502353	4295880	5	5
44337995	1149196	0	0
44341834	1119510	0	0
44360103	1322184	0	0
44362094	19133905	2	3
45641020	1539403	0	0
45620805	1153428	0	0
45641413	1125315	0	0
45629683	1125315	0	0
45658081	1119510	0	0
45649270	1589505	0	0
45683906	19059528	0	0
45677199	19127890	0	0
45698036	1310149	0	0
45799741	1539411	2	3
45682541	1125315	0	0
45672860	1174888	0	0
45789384	738818	0	0
45798603	1501700	0	0
45897770	1129625	0	0
45793445	1119510	0	0
46298522	1177480	0	0
46306256	1124957	0	0
46319697	967823	0	0
46309206	1107882	2	3
4043025	4243062	2	3
4199402	4035415	6	7
21002775	975125	0	0
21003076	1112807	0	0
35200000	317576	3	7
4180941	4163951	1	1
36303164	4015189	1	5
37503887	4163971	5	5
44337996	1557272	0	0
44341805	1119510	0	0
44360306	738818	0	0
44362411	40229134	2	3
45640929	1548195	0	0
45620662	1738521	0	0
45641419	1125315	0	0
45629628	1125315	0	0
45658065	1119510	0	0
45649240	1115008	0	0
45684023	1153428	0	0
45677199	1549786	0	0
45697997	1174888	0	0
45797318	19133905	2	3
45680011	1125315	0	0
45672870	1713332	0	0
45789324	738818	0	0
45798606	1332418	0	0
45897842	1129625	0	0
45793294	1119510	0	0
46289708	1177480	0	0
46306776	1124957	0	0
46319701	1192710	0	0
46327429	1107882	2	3
4043161	4059978	2	3
4199402	4059173	6	7
21002744	1192710	0	0
21003076	1129625	0	0
35202051	313217	5	7
36217029	1713671	1	2
36500000	40480160	4	9
40772948	3015076	5	5
44338098	738818	0	0
44341889	1119510	0	0
44360111	1332418	0	0
44362305	19126352	2	3
45640935	738818	0	0
45620673	1746114	0	0
45641801	1125315	0	0
45629755	1125315	0	0
45658217	1119510	0	0
45649241	1107830	0	0
45684158	1107830	0	0
45677200	1326303	0	0
45698009	1759842	0	0
45797318	19133873	2	3
45680012	1125315	0	0
45672779	1192710	0	0
45786506	738818	0	0
45798330	975125	0	0
45897960	1129625	0	0
45793308	1119510	0	0
46290079	1177480	0	0
46306961	975125	0	0
46319456	1000560	0	0
46301052	1107882	2	3
4042836	4283893	2	3
4199402	381316	6	6
21002804	1746114	0	0
21003076	738818	0	0
21605007	40169281	5	7
36217124	19074843	1	2
36602234	81151	4	7
40772948	3006734	5	5
44362819	1177480	0	0
44341892	1119510	0	0
44360248	1310149	0	0
44362559	19129655	2	3
45641096	1713332	0	0
45620673	1741122	0	0
45641693	1125315	0	0
45629757	1125315	0	0
45658326	1119510	0	0
45648362	1115008	0	0
45684096	975125	0	0
45677295	1738521	0	0
45698009	1713332	0	0
45794821	40231925	2	3
45677545	1125315	0	0
45672770	740275	0	0
45786710	738818	0	0
45798608	1713332	0	0
45897929	1129625	0	0
45793469	1119510	0	0
46289947	1177480	0	0
46306901	1310149	0	0
46319461	1112807	0	0
46301246	1107882	2	3
4180169	195588	2	3
4199402	133834	6	6
21002805	19010482	0	0
21003076	1119510	0	0
21602471	19127904	5	7
36217124	19074841	1	2
36313913	4047491	4	5
40772948	3019406	5	5
44362849	1192710	0	0
44342040	1119510	0	0
44360261	1112807	0	0
44362422	40162522	2	3
45641188	1107830	0	0
45620731	1149196	0	0
45641694	1125315	0	0
45629762	1125315	0	0
45658329	1119510	0	0
45648325	1326303	0	0
45684098	19039298	0	0
45677321	1110410	0	0
45698124	1332418	0	0
45794907	1115171	2	3
45677555	1125315	0	0
45672751	1115008	0	0
45786920	738818	0	0
45798757	1115008	0	0
45895526	1129625	0	0
45794656	1119510	0	0
46290232	1177480	0	0
46306336	1551099	0	0
46319652	1124957	0	0
46313997	1107882	2	3
4108611	4329847	2	3
4199402	40479768	8	9
21002806	1115008	0	0
21003076	1192710	0	0
21602471	40221415	4	7
36217030	1713671	1	2
36303152	4024289	4	5
37109021	4174876	1	1
44362856	1177480	0	0
44341944	1119510	0	0
44360265	1107830	0	0
44362512	1115171	2	3
45641045	1713332	0	0
45620732	1115008	0	0
45641558	1125315	0	0
45629741	1125315	0	0
45654667	1119510	0	0
45648326	967823	0	0
45684099	1343916	0	0
45677302	1115008	0	0
45698127	1115008	0	0
45679272	19008572	2	3
45677561	1125315	0	0
45784493	975125	0	0
45786922	738818	0	0
45798631	1307863	0	0
45895497	1129625	0	0
45787859	1119510	0	0
46289970	1177480	0	0
46302613	1000560	0	0
46319656	1332418	0	0
46311899	1107882	2	3
4040397	4301346	2	3
4199402	198809	8	8
21002805	975125	0	0
21003076	1177480	0	0
21605007	1150771	4	7
36219949	19077344	1	2
36303152	4252419	4	5
36713504	4310024	1	1
44362858	1124300	0	0
44341934	1119510	0	0
44360270	1174888	0	0
44355164	40236446	2	3
45641045	1759842	0	0
45620718	1107830	0	0
45641641	1125315	0	0
45629653	1125315	0	0
45654668	1119510	0	0
45648338	1153428	0	0
45684101	1154343	0	0
45677306	1501700	0	0
45698133	967823	0	0
45679267	40232448	2	3
45677994	1125315	0	0
45784508	19127890	0	0
45786794	738818	0	0
45798852	1521369	0	0
45895552	1129625	0	0
45787862	1119510	0	0
46291822	1177480	0	0
46299726	1396131	0	0
46319659	967823	0	0
46305255	40174880	2	3
442264	4146173	2	3
4199402	4283893	5	7
21002806	1124300	0	0
21003027	708298	0	0
21605007	19112599	4	7
36217056	19073188	1	2
36303152	4243062	4	4
36713625	4146173	1	1
44362873	701322	0	0
44342072	1119510	0	0
44360328	1129625	0	0
44355202	1127433	2	3
45640822	738818	0	0
45620724	738818	0	0
45641545	1125315	0	0
45629705	1125315	0	0
45654614	1119510	0	0
45648438	1192710	0	0
45684206	975125	0	0
45677308	757627	0	0
45698135	1110410	0	0
45679651	40223834	2	3
45677617	1125315	0	0
45784508	1515774	0	0
45786964	738818	0	0
45798852	19127890	0	0
45895566	1129625	0	0
45787878	1119510	0	0
46241902	1177480	0	0
46299832	1539403	0	0
46319682	1738521	0	0
46313857	1107882	2	3
4040576	4117038	2	3
4199402	4156265	5	7
21002806	1177480	0	0
21003044	791967	0	0
21605007	40228230	4	7
36213600	44816277	1	2
36313959	4181917	4	4
36703483	378419	1	1
44362903	738818	0	0
44342073	1119510	0	0
44360339	1107830	0	0
45655537	19008572	2	3
45641106	1174888	0	0
45620850	975125	0	0
45641599	1125315	0	0
45629784	1125315	0	0
45654414	1119510	0	0
45648375	1115008	0	0
45684207	1174888	0	0
45677259	1153428	0	0
45697976	1500211	0	0
45679449	40229134	2	3
45678069	1125315	0	0
45784508	1549786	0	0
45786886	738818	0	0
45798852	1549786	0	0
45895465	1129625	0	0
45788007	1119510	0	0
46241956	1177480	0	0
46299800	738818	0	0
46319696	1738521	0	0
46314408	1332419	2	3
4043016	4059978	2	3
4199402	4132546	5	7
21002805	1112807	0	0
21003042	1154029	0	0
21605007	1107882	4	7
443357	81151	3	3
36313913	4202451	4	4
40798526	3024731	1	1
44362920	1124300	0	0
44342386	1119510	0	0
44360344	1174888	0	0
45655145	40232448	2	3
45637611	1501700	0	0
45620851	1713332	0	0
45641740	1125315	0	0
45629857	1125315	0	0
45655549	1119510	0	0
45648389	1107830	0	0
45684217	738818	0	0
45677190	1174888	0	0
45698149	1545958	0	0
45792058	1115171	2	3
45677894	1125315	0	0
45784521	967823	0	0
45786237	738818	0	0
45798574	1713332	0	0
45679534	1119510	0	0
45787965	1119510	0	0
46242015	1177480	0	0
46299905	1115008	0	0
46319744	1124300	0	0
46300773	1332419	2	3
4027880	81893	2	3
4199402	4296204	5	5
21002805	1551099	0	0
21003042	914335	0	0
21602359	40236824	4	7
4092876	198809	3	3
36502197	80502	5	5
40796605	3028833	1	1
44362923	1192710	0	0
44342351	1119510	0	0
44362697	1713332	0	0
44347517	1127433	2	3
45637575	1174888	0	0
45620851	1759842	0	0
45641613	1125315	0	0
45629793	1125315	0	0
45654762	1119510	0	0
45648522	1501700	0	0
45684293	1778162	0	0
45677220	1107830	0	0
45698182	1115008	0	0
45792062	19019273	2	3
45678015	1125315	0	0
45784529	1174888	0	0
45786427	738818	0	0
45798351	1539403	0	0
45679921	1119510	0	0
45788025	1119510	0	0
46241982	1177480	0	0
46299911	933724	0	0
46322413	1551099	0	0
46322513	19078461	2	3
4154739	4142905	2	3
4199402	134438	4	4
21002783	975125	0	0
21003042	791967	0	0
21602359	1519937	4	7
4092747	4043241	3	3
36313944	42535580	5	5
40796722	3006923	1	1
44362970	1129625	0	0
44342362	1119510	0	0
44362697	1759842	0	0
44347711	1115171	2	3
45637577	1124957	0	0
45620852	914335	0	0
45641618	1125315	0	0
45629800	1125315	0	0
45651367	1119510	0	0
45648529	1548195	0	0
45684237	1589505	0	0
45674056	1192710	0	0
45698282	1149380	0	0
45792249	40232448	2	3
45678032	1125315	0	0
45784585	1192710	0	0
45786575	738818	0	0
45798468	723013	0	0
45679465	1119510	0	0
45788049	1119510	0	0
46242021	1177480	0	0
46299941	975125	0	0
46322563	1000560	0	0
46319697	19079524	2	3
4154739	4237458	2	3
4199402	378419	7	8
21002793	1746114	0	0
21003079	1129625	0	0
35200000	313217	3	8
4144290	4163874	3	3
36602234	4149245	5	5
40796376	3016723	1	1
44362905	1501700	0	0
44342305	1119510	0	0
44362706	1177480	0	0
44347724	40232448	2	3
45637637	1326303	0	0
45620853	1778162	0	0
45641802	1125315	0	0
45630006	1125315	0	0
45651235	1119510	0	0
45648318	975125	0	0
45684238	1115008	0	0
45674078	1174888	0	0
45698282	1137529	0	0
45792395	19078461	2	3
45677835	1125315	0	0
45784542	1307863	0	0
45785578	738818	0	0
45798575	1501700	0	0
45679009	1119510	0	0
45788129	1119510	0	0
46241941	1177480	0	0
46299958	1000560	0	0
46327429	1107830	0	0
46301847	19075601	2	3
4162054	4293740	2	4
4199402	4230399	7	8
21002805	1177480	0	0
21003040	1154029	0	0
35802829	257012	6	8
4056681	4252419	3	3
36303152	4202451	5	5
40796407	3009201	1	1
44362821	1112807	0	0
44337832	1119510	0	0
44362707	1545958	0	0
44347922	40231925	2	3
45637716	1343916	0	0
45620855	1539403	0	0
45641524	1125315	0	0
45629770	1125315	0	0
45651352	1119510	0	0
45648471	967823	0	0
45684239	975125	0	0
45674081	914335	0	0
45698283	1717327	0	0
45792197	19008572	2	3
45677909	1125315	0	0
45784616	1322184	0	0
45785398	738818	0	0
45798584	1738521	0	0
45679086	1119510	0	0
45788134	1119510	0	0
46242429	1177480	0	0
46299870	1192710	0	0
46319864	1332418	0	0
46321014	1332419	2	3
4043017	4010253	2	4
4199402	313217	7	10
21002805	1115008	0	0
21003040	708298	0	0
35202051	257012	5	8
4056681	4024289	3	3
36502196	4048695	5	6
40796508	3006906	1	1
44363011	1124300	0	0
44337680	1119510	0	0
44362502	1759842	0	0
44348322	19019273	2	3
45637729	1154343	0	0
45620727	1545958	0	0
45641771	1125315	0	0
45626839	1125315	0	0
45651390	1119510	0	0
45648321	1107830	0	0
45684240	914335	0	0
45674103	1322184	0	0
45698076	1000560	0	0
45792182	19059056	2	3
45677970	1125315	0	0
45784546	1154343	0	0
45785531	738818	0	0
45798352	1115008	0	0
45678970	1119510	0	0
45788065	1119510	0	0
46242148	1177480	0	0
46299725	1309944	0	0
46320132	1738521	0	0
46306555	19075601	2	3
4179141	81151	2	4
4199402	378001	7	9
21002145	1741122	0	0
21003042	708298	0	0
21602359	40221415	5	8
4130852	81151	3	3
36303152	4047491	5	6
40780206	3020655	1	1
44363014	1115008	0	0
44363688	1119510	0	0
44362632	914335	0	0
44348432	19133873	2	3
45637646	1310149	0	0
45620676	1149196	0	0
45641805	1125315	0	0
45626920	1125315	0	0
45651608	1119510	0	0
45648630	738818	0	0
45684033	1738521	0	0
45673984	1738521	0	0
45698185	1107830	0	0
45792210	40229134	2	3
45677948	1125315	0	0
45784548	1153428	0	0
45785389	738818	0	0
45798720	1548195	0	0
45786031	1119510	0	0
45788240	1119510	0	0
46242196	1177480	0	0
46299745	1115008	0	0
46319954	1154029	0	0
45897073	1545959	2	3
4180169	30753	2	4
4199402	4280726	7	9
21002154	1741122	0	0
21003042	1110410	0	0
21603945	1124300	0	0
4057955	4024958	3	3
36602234	40479422	6	6
40780213	3000876	1	1
44363016	933724	0	0
44363354	1119510	0	0
44362501	1501700	0	0
44348243	1115171	2	3
45637647	1149196	0	0
45620727	1332418	0	0
45641786	1125315	0	0
45626922	1125315	0	0
45651653	1119510	0	0
45648556	1124300	0	0
45684311	708298	0	0
45673990	1192710	0	0
45698188	1153428	0	0
45792384	19023398	2	3
45679563	1125315	0	0
45784558	1551099	0	0
45783410	738818	0	0
45798725	1153428	0	0
45786544	1119510	0	0
45788070	1119510	0	0
46241928	1177480	0	0
46299820	1174888	0	0
46320157	1521369	0	0
45803875	1332419	2	3
4180169	4283893	2	5
4301351	4336464	5	9
21002154	1746114	0	0
21003026	1343916	0	0
21603453	738818	0	0
4201745	192671	3	3
36602234	40479768	6	6
40780242	3012494	1	1
44363019	1713332	0	0
44363812	1119510	0	0
44362502	1713332	0	0
44341330	19019273	2	3
45637598	1124300	0	0
45620728	1539403	0	0
45638373	1125315	0	0
45626702	1125315	0	0
45651667	1119510	0	0
45648644	1539403	0	0
45684287	1308738	0	0
45674247	1332418	0	0
45698211	1124300	0	0
45792391	1115171	2	3
45679622	1125315	0	0
45784679	1332418	0	0
45783326	738818	0	0
45798441	791967	0	0
45786561	1119510	0	0
45788093	1119510	0	0
45893691	1177480	0	0
46299822	1713332	0	0
46320161	1713332	0	0
46304338	1125315	0	0
4134423	4186930	2	5
4301351	4125906	5	5
21002222	1717327	0	0
21003069	1119510	0	0
21603462	1192710	0	0
4227253	30753	3	3
36502196	4278672	6	6
40780092	3024561	1	1
44362931	1115008	0	0
44363817	1119510	0	0
44362814	1729720	0	0
44340671	42707627	2	3
45637668	1308738	0	0
45620711	1343916	0	0
45638427	1125315	0	0
45626699	1125315	0	0
45651269	1119510	0	0
45648647	975125	0	0
45684129	1310149	0	0
45674068	1501700	0	0
45698215	738818	0	0
45676046	40228214	2	3
45674591	1125315	0	0
45784632	1713332	0	0
45783449	738818	0	0
45798561	1124957	0	0
45786368	1119510	0	0
46293850	1119510	0	0
45893765	1177480	0	0
46299822	1759842	0	0
46320161	1759842	0	0
46320119	1125315	0	0
4027384	257012	2	7
4301351	4330583	5	8
21002136	1741122	0	0
21003069	1115008	0	0
21603525	1153428	0	0
4227253	261325	3	3
36303152	42535580	6	6
40780881	3045716	1	1
44363041	1129625	0	0
44363831	1119510	0	0
44362506	1177480	0	0
44340778	19133873	2	3
45637642	1309944	0	0
45620856	1759842	0	0
45638212	1125315	0	0
45626971	1125315	0	0
45651681	1119510	0	0
45648714	1174888	0	0
45684131	1713332	0	0
45674218	1551099	0	0
45698119	1539403	0	0
45675957	1127433	2	3
45674605	1125315	0	0
45784692	1174888	0	0
45783368	738818	0	0
45798758	1110410	0	0
45786386	1119510	0	0
46294030	1119510	0	0
45893835	1177480	0	0
46299690	1124957	0	0
46319973	1551099	0	0
46320124	1125315	0	0
4038677	4310024	2	2
4301351	4242997	5	6
21002137	1741122	0	0
21003069	1177480	0	0
21603512	1150770	0	0
4141937	4337611	3	3
36500000	4155034	8	8
40782260	3036780	1	1
44362933	1545958	0	0
44363924	1119510	0	0
44362519	1000560	0	0
44340936	46275916	2	3
45637740	1332418	0	0
45620856	1713332	0	0
45638391	1125315	0	0
45626819	1125315	0	0
45651569	1119510	0	0
45648657	1307863	0	0
45684133	975125	0	0
45674219	1124300	0	0
45648931	1332418	0	0
45675972	1545959	2	3
45674625	1125315	0	0
45784706	1000560	0	0
45783516	738818	0	0
45798763	975125	0	0
45786383	1119510	0	0
46294130	1119510	0	0
45893803	1177480	0	0
46299691	1107830	0	0
46320199	1307863	0	0
46320183	1125315	0	0
4040560	4242997	2	2
4301351	4198190	6	8
21001840	1778162	0	0
21003069	1112807	0	0
21603288	1149380	0	0
36158237	1119510	0	0
36302170	4037675	8	8
40782474	3005136	1	1
44362958	1129625	0	0
44364003	1119510	0	0
44362523	1174888	0	0
44340937	19073183	2	3
45637844	967823	0	0
45661595	975125	0	0
45639955	1125315	0	0
45626801	1125315	0	0
45651570	1119510	0	0
45648575	1149196	0	0
45684283	1549786	0	0
45673742	1307863	0	0
45648933	1549786	0	0
45676078	43012036	2	3
45674689	1125315	0	0
45784798	1107830	0	0
46291583	738818	0	0
45798771	1728416	0	0
45786158	1119510	0	0
46293884	1119510	0	0
45893826	1177480	0	0
46299703	1149196	0	0
46320219	1153428	0	0
46320454	1125315	0	0
4040562	4198190	2	2
4301351	4057420	4	7
21001841	1778162	0	0
21003042	753626	0	0
21603266	1137529	0	0
36158237	738818	0	0
36302170	4035415	7	11
40654442	3028833	1	1
44363048	1310149	0	0
44363509	1119510	0	0
44362524	1107830	0	0
44340904	19019273	2	3
45637648	1124957	0	0
45661600	1728416	0	0
45640036	1125315	0	0
45626957	1125315	0	0
45651572	1119510	0	0
45648663	1153428	0	0
45684283	19127890	0	0
45673746	1192710	0	0
45648933	1521369	0	0
45676351	40174880	2	3
45674693	1125315	0	0
45784632	1759842	0	0
46291678	738818	0	0
45798824	1521369	0	0
45786160	1119510	0	0
46293543	1119510	0	0
45893837	1177480	0	0
46299785	1595799	0	0
46320222	1361711	0	0
46320363	1125315	0	0
4150819	4336464	2	2
4301351	4337611	4	5
21001839	1778162	0	0
21003079	1124300	0	0
21602517	1548195	0	0
36158241	1107830	0	0
36502196	4134304	8	8
40654504	3006906	1	1
44363019	1759842	0	0
44363577	1119510	0	0
44362607	1129625	0	0
44340849	1115171	2	3
45637651	1154343	0	0
45661603	967823	0	0
45638535	1125315	0	0
45626930	1125315	0	0
45648298	1119510	0	0
45645066	740275	0	0
45684356	738818	0	0
45673746	1174888	0	0
45648939	1308738	0	0
45789123	920300	2	3
45674699	1125315	0	0
45784622	1309944	0	0
46291715	738818	0	0
45798824	1548195	0	0
45786122	1119510	0	0
46294064	1119510	0	0
45893834	1177480	0	0
46299967	715997	0	0
46320233	1112807	0	0
46320366	1125315	0	0
4065001	4314290	2	2
4301351	44783196	4	5
21001840	1713332	0	0
21003099	791967	0	0
21602516	1549786	0	0
36158171	1515774	0	0
36602234	78272	8	8
40654685	3016723	1	1
44363126	738818	0	0
44363992	1119510	0	0
44362729	701322	0	0
44340891	1115171	2	3
45637862	1332418	0	0
45661732	1548195	0	0
45638466	1125315	0	0
45626931	1125315	0	0
45649239	1119510	0	0
45645385	1149196	0	0
45684358	1361711	0	0
45674221	19016749	0	0
45648769	1501700	0	0
45789379	40162522	2	3
45674538	1125315	0	0
45784787	1149196	0	0
46242680	738818	0	0
45798919	1713332	0	0
45786183	1119510	0	0
46294034	1119510	0	0
45801852	1177480	0	0
46300027	738818	0	0
46320130	1110410	0	0
46320488	1125315	0	0
4070456	4218408	2	2
4301351	4301346	4	5
21001842	1713332	0	0
21003069	1129625	0	0
21602540	1500211	0	0
36158171	19127890	0	0
36502196	4230399	7	7
40766216	3012494	1	1
44362978	723013	0	0
44363624	1119510	0	0
44362732	1124957	0	0
45637384	1127433	2	3
45637657	1307863	0	0
45661703	975125	0	0
45638467	1125315	0	0
45626853	1125315	0	0
45648438	1119510	0	0
45645329	1343916	0	0
45684361	1107830	0	0
45674086	1539403	0	0
45694959	1149196	0	0
45789390	40228214	2	3
45674541	1125315	0	0
45784634	1343916	0	0
46242773	738818	0	0
45798919	1759842	0	0
46292667	1119510	0	0
46294396	1119510	0	0
45801848	1177480	0	0
46300085	1174888	0	0
46320108	1154029	0	0
46320377	1125315	0	0
4063381	261325	2	2
4301351	4337138	3	4
21001840	1759842	0	0
21003081	1124957	0	0
21602102	975125	0	0
36158171	1549786	0	0
36402189	4144583	7	7
40766216	3006451	1	1
44363023	1307863	0	0
44363495	1119510	0	0
44362734	1332418	0	0
45637365	1539411	2	3
45637807	1501700	0	0
45661430	975125	0	0
45638528	1125315	0	0
45628031	1125315	0	0
45648630	1119510	0	0
45645269	1361711	0	0
45684368	1124957	0	0
45674000	1115008	0	0
45694825	1154343	0	0
45789324	40229134	2	3
45674957	1125315	0	0
45784596	1192710	0	0
46242804	738818	0	0
45798920	1107830	0	0
46292488	1119510	0	0
46294075	1119510	0	0
45802421	1177480	0	0
46300087	1551099	0	0
46320118	1124957	0	0
46320333	1125315	0	0
4187096	4230399	2	2
4244662	80180	2	2
21001840	1768849	0	0
21003081	1125315	0	0
21602136	1149380	0	0
36158174	1177480	0	0
36424251	1326303	0	0
40249018	19074679	1	1
44359235	1149380	0	0
44363609	1119510	0	0
44360439	1515774	0	0
45637355	40232448	2	3
45637741	1521369	0	0
45661708	723013	0	0
45638574	1125315	0	0
45628122	1125315	0	0
45648636	1119510	0	0
45645271	975125	0	0
45684252	1343916	0	0
45674226	738818	0	0
45695024	1000560	0	0
45777979	1367571	0	0
45674958	1125315	0	0
45784638	1107830	0	0
46242816	738818	0	0
45798921	1000560	0	0
46292575	1119510	0	0
46294475	1119510	0	0
45799139	1177480	0	0
46300089	1192710	0	0
46319905	1112807	0	0
46320592	1125315	0	0
4185284	4202451	2	2
4303053	4301346	2	2
21001846	1759842	0	0
21003081	1118084	0	0
35508516	1738521	0	0
36158175	975125	0	0
36423360	740275	0	0
40181758	40221415	1	1
44359242	920293	0	0
44356506	1119510	0	0
44360439	1549786	0	0
45621792	40232448	2	3
45637741	1549786	0	0
45661824	1545958	0	0
45638630	1125315	0	0
45628244	1125315	0	0
45645050	1119510	0	0
45645272	19127890	0	0
45684300	715997	0	0
45674228	738818	0	0
45694994	1521369	0	0
45777932	1192710	0	0
45674754	1125315	0	0
45784817	1154343	0	0
46240780	738818	0	0
45798558	1118084	0	0
46292797	1119510	0	0
46294153	1119510	0	0
45799072	1177480	0	0
46300095	1713332	0	0
46320147	1124957	0	0
46320551	1125315	0	0
4155030	4156265	2	2
4241075	4293740	2	2
21001839	1768849	0	0
21003053	791967	0	0
35508517	1713332	0	0
36157773	1177480	0	0
36416757	1154029	0	0
40181782	40221415	1	1
44359243	1129625	0	0
44356538	1119510	0	0
44360481	1129625	0	0
45621794	19078924	2	3
45637687	738818	0	0
45661433	1310149	0	0
45638604	1125315	0	0
45628210	1125315	0	0
45645434	1119510	0	0
45645272	1549786	0	0
45680883	1713332	0	0
45674229	920293	0	0
45694994	19127890	0	0
45777915	738818	0	0
45674640	1125315	0	0
45784665	1174888	0	0
46240720	738818	0	0
45798740	1322184	0	0
46293071	1119510	0	0
46294155	1119510	0	0
45799104	1177480	0	0
46300220	1153428	0	0
46320149	1000560	0	0
46320650	1125315	0	0
4115236	4294548	2	2
4327941	4043071	2	2
21001846	1713332	0	0
21003069	738818	0	0
35508518	1124300	0	0
36158124	1107830	0	0
36416791	708298	0	0
40181784	40221415	1	1
44359251	1115008	0	0
44356505	1119510	0	0
44360548	1545958	0	0
45620583	1115171	2	3
45637865	1110410	0	0
45661516	1192710	0	0
45638505	1125315	0	0
45628225	1125315	0	0
45645556	1119510	0	0
45645276	1107830	0	0
45680884	975125	0	0
45674230	1717327	0	0
45694994	1549786	0	0
45777943	1149196	0	0
45674646	1125315	0	0
45784912	967823	0	0
46272569	40492359	3	3
45798574	1759842	0	0
46292507	1119510	0	0
46294301	1119510	0	0
45799300	1177480	0	0
46300232	1107830	0	0
46320151	1149196	0	0
46320800	1125315	0	0
4125928	4108705	2	2
4307254	4230399	2	2
21001849	1759842	0	0
21003099	723013	0	0
35508618	1309944	0	0
36158073	1112807	0	0
36429708	1307863	0	0
40220385	40220386	1	1
44362605	1124957	0	0
44356740	1119510	0	0
44360440	975125	0	0
45620586	40232448	2	3
45637798	1124957	0	0
45661519	738818	0	0
45638582	1125315	0	0
45627062	1125315	0	0
45645463	1119510	0	0
45645048	1149196	0	0
45680886	1107830	0	0
45673981	1192710	0	0
45694562	1124300	0	0
45777903	738818	0	0
45674987	1125315	0	0
45784823	914335	0	0
46240186	19128022	3	4
45798687	1115008	0	0
46293009	1119510	0	0
46294485	1119510	0	0
45799432	1177480	0	0
46300235	914335	0	0
46313774	1112807	0	0
46320410	1125315	0	0
4074722	4107731	2	2
4283893	4294548	2	2
21001842	1759842	0	0
21003069	1192710	0	0
35508633	1545958	0	0
36157967	1129625	0	0
36427078	1361711	0	0
40165009	40165015	1	1
44362548	738818	0	0
44356741	1119510	0	0
44360557	1124957	0	0
45620570	19059056	2	3
45637767	1500211	0	0
45661944	1551099	0	0
45638628	1125315	0	0
45627079	1125315	0	0
45645134	1119510	0	0
45645145	1174888	0	0
45698764	1192710	0	0
45674114	1310149	0	0
45694964	1110410	0	0
45777876	1307863	0	0
45674784	1125315	0	0
45784834	1539403	0	0
45697433	19127904	3	4
45798774	1000560	0	0
46293047	1119510	0	0
46294488	1119510	0	0
45799410	1177480	0	0
46300061	1115008	0	0
46313774	1124957	0	0
46320411	1125315	0	0
4074298	4186930	2	2
4353828	317576	2	2
21001849	1778162	0	0
21003069	1125315	0	0
35508640	1129625	0	0
36157971	1118084	0	0
36427086	1308738	0	0
40102982	920334	1	1
44362653	1551099	0	0
44356624	1119510	0	0
44353463	1192710	0	0
45620732	1115171	2	3
45637781	1521369	0	0
45661947	914335	0	0
45638683	1125315	0	0
45623763	1125315	0	0
45645510	1119510	0	0
45645433	967823	0	0
45698733	1192710	0	0
45674232	1551099	0	0
45694596	1310149	0	0
45777879	1713332	0	0
45674786	1125315	0	0
45784715	1549786	0	0
45802402	19129144	3	4
45793176	1124957	0	0
46292657	1119510	0	0
46294214	1119510	0	0
45793933	1177480	0	0
46300103	1107830	0	0
46313780	1332418	0	0
46320434	1125315	0	0
4073634	4107731	2	2
4303802	438614	2	2
21001846	1778162	0	0
21003108	19003953	0	0
35508640	1115008	0	0
36157857	1177480	0	0
36427076	920293	0	0
40128143	40229134	1	1
44362656	914335	0	0
44356672	1119510	0	0
44353463	1174888	0	0
45620673	46275444	2	3
45637892	1115008	0	0
45661854	1713332	0	0
45635455	1125315	0	0
45623721	1125315	0	0
45645520	1119510	0	0
45645434	1192710	0	0
45698738	1192710	0	0
45673755	740275	0	0
45695049	1332418	0	0
45777880	1717327	0	0
45674955	1125315	0	0
45784715	1521369	0	0
45786850	19133679	3	4
45793269	975125	0	0
46292961	1119510	0	0
46294234	1119510	0	0
45794032	1177480	0	0
46300002	975125	0	0
46313807	1124300	0	0
46320867	1125315	0	0
4085100	4112343	2	2
4303802	442116	2	2
21001846	1717327	0	0
21003110	19003953	0	0
35508642	1119510	0	0
36157858	1112807	0	0
36424660	1548195	0	0
40061664	40165015	1	1
44362578	1332418	0	0
44356662	1119510	0	0
44353471	1343916	0	0
45620701	1127433	2	3
45637993	715997	0	0
45661746	975125	0	0
45635251	1125315	0	0
45623816	1125315	0	0
45642454	1119510	0	0
45645246	1521369	0	0
45695465	1192710	0	0
45673771	1501700	0	0
45694635	1539403	0	0
45778010	1539403	0	0
45674633	1125315	0	0
45784716	1153428	0	0
45876037	3014576	3	6
46240961	1129625	0	0
46293194	1119510	0	0
46294563	1119510	0	0
45789340	1177480	0	0
46300111	738818	0	0
46314344	1149196	0	0
46320662	1125315	0	0
4073287	4056621	2	2
4303802	4169137	2	2
21001850	1778162	0	0
21003079	1174888	0	0
35508648	1308738	0	0
36157865	920293	0	0
36463106	1149196	0	0
40021194	19074679	1	1
44362759	1000560	0	0
44356722	1119510	0	0
44353588	1115008	0	0
45620850	19008572	2	3
45637794	933724	0	0
45661856	967823	0	0
45635339	1125315	0	0
45623928	1125315	0	0
45642569	1119510	0	0
45645246	1595799	0	0
45692480	1192710	0	0
45673774	1174888	0	0
45695113	1361711	0	0
45707779	914335	0	0
45674970	1125315	0	0
45784722	1713332	0	0
45876037	3045716	3	6
46240753	1129625	0	0
46293210	1119510	0	0
46294439	1119510	0	0
45789397	1177480	0	0
46300112	723013	0	0
46314345	933724	0	0
46320918	1125315	0	0
4154162	4218389	2	2
4303802	4139681	2	2
21001850	1717327	0	0
21003081	1177480	0	0
35508890	1125315	0	0
36157972	967823	0	0
36463107	1713332	0	0
40021195	19074679	1	1
44362776	1713332	0	0
44356970	1119510	0	0
44353592	1124300	0	0
45661569	1115171	2	3
45637904	1115008	0	0
45661527	1500211	0	0
45635435	1125315	0	0
45623822	1125315	0	0
45642552	1119510	0	0
45645246	1549786	0	0
45692430	1192710	0	0
45674233	967823	0	0
45695124	1115008	0	0
45707835	1174888	0	0
45674976	1125315	0	0
45784722	1759842	0	0
45876037	3019550	3	6
46241094	1129625	0	0
46292768	1119510	0	0
46293974	1119510	0	0
45788790	1177480	0	0
46300130	1153428	0	0
46313808	1149196	0	0
46320631	1125315	0	0
4074287	4117038	2	2
19091065	19128009	2	2
21001849	1717327	0	0
21003081	1110410	0	0
35508891	1713332	0	0
36157976	1115008	0	0
36463112	1119510	0	0
37503938	4059978	1	1
44362616	914335	0	0
44356999	1119510	0	0
44353478	1332418	0	0
45662007	40236824	2	3
45637909	738818	0	0
45661569	1115008	0	0
45635402	1125315	0	0
45624068	1125315	0	0
45642559	1119510	0	0
45645258	1174888	0	0
45692729	1192710	0	0
45674234	1307863	0	0
45694799	967823	0	0
45707838	1521369	0	0
45674977	1125315	0	0
45784915	975125	0	0
45876037	3013721	3	5
46241033	1129625	0	0
46293333	1119510	0	0
46294453	1119510	0	0
45788784	1177480	0	0
46300145	933724	0	0
46313830	1192710	0	0
46320632	1125315	0	0
4186164	4278672	2	2
4242290	81151	2	2
21001860	1343916	0	0
21003082	1125315	0	0
35508586	1738521	0	0
36157977	1119510	0	0
36463118	1549786	0	0
37203741	441267	1	1
44362617	1521369	0	0
44357094	1119510	0	0
44353594	1153428	0	0
45661561	19019273	2	3
45637967	1545958	0	0
45661879	1124957	0	0
45635289	1125315	0	0
45624070	1125315	0	0
45642632	1119510	0	0
45645417	723013	0	0
45692519	1192710	0	0
45674274	1107830	0	0
45695104	738818	0	0
45707838	1595799	0	0
45674879	1125315	0	0
45784772	1174888	0	0
45876037	3015632	3	6
46240851	1129625	0	0
46293398	1119510	0	0
46294388	1119510	0	0
45788834	1177480	0	0
46300260	708298	0	0
46313837	19003953	0	0
46320879	1125315	0	0
4027880	4285898	2	2
4208786	80502	2	2
21600192	914335	0	0
21003081	1124300	0	0
35508397	1115008	0	0
36157977	738818	0	0
36463118	1515774	0	0
37203741	317009	1	1
44359387	1551099	0	0
44357046	1119510	0	0
44353432	1746114	0	0
45662002	19008572	2	3
45637968	1149196	0	0
45661884	1153428	0	0
45635247	1125315	0	0
45624074	1125315	0	0
45640051	1119510	0	0
45645556	738818	0	0
45692445	1192710	0	0
45674239	1551099	0	0
45695106	1500211	0	0
45707838	1549786	0	0
45674887	1125315	0	0
45784924	1310149	0	0
45876037	3006923	3	5
46238192	1129625	0	0
46292888	1119510	0	0
46243710	1119510	0	0
45788881	1177480	0	0
46300268	1153428	0	0
46313719	1174888	0	0
46315054	1125315	0	0
4027717	4238715	2	2
4207185	4294548	2	2
21600234	1326303	0	0
21003081	1154029	0	0
35508786	1539403	0	0
36157869	1149196	0	0
36427229	1000560	0	0
37203747	261325	1	1
44359393	791967	0	0
44357104	1119510	0	0
44353432	1741122	0	0
45661982	40231925	2	3
45638032	1713332	0	0
45661532	738818	0	0
45635449	1125315	0	0
45623843	1125315	0	0
45639476	1119510	0	0
45645239	1107830	0	0
45692604	1192710	0	0
45674310	967823	0	0
45695077	1149196	0	0
45707810	1000560	0	0
45674666	1125315	0	0
45784764	975125	0	0
45876037	3006906	3	5
46240207	1129625	0	0
46287955	1119510	0	0
46243663	1119510	0	0
46295416	1177480	0	0
46300401	1589505	0	0
46313731	1326303	0	0
46314285	1125315	0	0
4093991	4280726	4	5
4329725	4337138	2	2
21503162	1129625	0	0
21600493	1000560	0	0
35508399	1118084	0	0
36158001	701322	0	0
36427091	1521369	0	0
37003672	198199	1	1
44359421	742185	0	0
44357024	1119510	0	0
44353439	1500211	0	0
45664310	42707627	2	3
45638032	1759842	0	0
45661534	1107830	0	0
45635267	1125315	0	0
45623773	1125315	0	0
45639450	1119510	0	0
45645563	1174888	0	0
45692550	1192710	0	0
45674269	1153428	0	0
45695080	1738521	0	0
45707758	1118084	0	0
45674668	1125315	0	0
45784766	1174888	0	0
45876037	3024561	3	5
46238225	1129625	0	0
46288317	1119510	0	0
46243667	1119510	0	0
46244274	1177480	0	0
46300172	1713332	0	0
46314094	1112807	0	0
46313873	1125315	0	0
4093991	40486433	4	5
4251030	4047491	2	2
21503163	1149196	0	0
21501130	1759842	0	0
35508741	1500211	0	0
36158009	967823	0	0
36427297	1124957	0	0
37017419	4336464	1	1
44359364	1177480	0	0
44357191	1119510	0	0
44353548	1500211	0	0
45658205	19008572	2	3
45637992	1713332	0	0
45662007	933724	0	0
45635521	1125315	0	0
45623922	1125315	0	0
45639738	1119510	0	0
45645440	708298	0	0
45692703	1192710	0	0
45674258	1174888	0	0
45695054	1343916	0	0
45707778	1174888	0	0
45674768	1125315	0	0
45784734	1729720	0	0
45876037	3027970	3	5
45897256	1129625	0	0
46288476	1119510	0	0
46243864	1119510	0	0
46244430	1177480	0	0
46300174	1115008	0	0
46314095	1000560	0	0
46314894	1125315	0	0
4093991	134438	4	5
21001382	19133905	2	3
21503194	914335	0	0
21602842	1729720	0	0
35508745	1115008	0	0
21604344	1125315	0	0
36427387	926487	0	0
36718163	378419	1	1
44359444	1107830	0	0
44350113	1119510	0	0
44353551	1521369	0	0
45655882	19078924	2	3
45634686	1107830	0	0
45662008	1308738	0	0
45635533	1125315	0	0
45623682	1125315	0	0
45639524	1119510	0	0
45645125	1174888	0	0
45692669	1192710	0	0
45673639	1153428	0	0
45695085	1149196	0	0
45707801	1501700	0	0
45675084	1125315	0	0
45784934	1738521	0	0
45876037	3004501	3	5
45897185	1129625	0	0
46288477	1119510	0	0
46243891	1119510	0	0
46244518	1177480	0	0
46299853	1124300	0	0
46314122	1305058	0	0
46314896	1125315	0	0
4180627	4181917	4	5
21001034	19129655	2	3
21503163	1107830	0	0
21602831	1746114	0	0
35508755	1343916	0	0
36156768	1125315	0	0
36424688	1549786	0	0
36718526	4029498	1	1
44359432	1539403	0	0
44349644	1119510	0	0
44353648	1129625	0	0
45655669	19059056	2	3
45634690	933724	0	0
45661561	1115008	0	0
45635413	1125315	0	0
45624090	1125315	0	0
45639679	1119510	0	0
45645459	1310149	0	0
45692672	1192710	0	0
45674337	1154029	0	0
45694820	1000560	0	0
45707813	1548195	0	0
45675168	1125315	0	0
45782654	1307863	0	0
45876037	3020630	3	5
45897348	1129625	0	0
46288022	1119510	0	0
46243674	1119510	0	0
45787392	1129625	0	0
46300151	705944	0	0
46313838	1112807	0	0
46314899	1125315	0	0
4180627	4243062	4	5
21000108	19129655	2	3
21503163	1150836	0	0
21603256	1154343	0	0
35508762	1125315	0	0
36156772	1125315	0	0
36424689	1549786	0	0
40220958	40220960	1	1
44359368	1729720	0	0
44349782	1119510	0	0
44353651	1129625	0	0
45655802	19078924	2	3
45634657	1717327	0	0
45661690	1110410	0	0
45635595	1125315	0	0
45623792	1125315	0	0
45636361	1119510	0	0
45645550	1717327	0	0
45689587	1192710	0	0
45674345	1154029	0	0
45694924	1343916	0	0
45707824	967823	0	0
45674914	1125315	0	0
45782401	1367571	0	0
45876037	3000963	5	6
45897402	1129625	0	0
46288028	1119510	0	0
46243876	1119510	0	0
45787591	1129625	0	0
46300340	738818	0	0
46314028	1149196	0	0
46314901	1125315	0	0
4180627	4163872	4	5
21000061	19129655	2	3
21503163	1153428	0	0
21602886	1768849	0	0
35508762	1174888	0	0
36156776	1125315	0	0
36424721	1519936	0	0
40220959	40220960	1	1
44359374	1149380	0	0
44349794	1119510	0	0
44353613	1124300	0	0
45655782	40228230	2	3
45634662	914335	0	0
45661841	1124957	0	0
45635645	1125315	0	0
45623800	1125315	0	0
45636033	1119510	0	0
45645463	1192710	0	0
45689713	1192710	0	0
45674045	738818	0	0
45694931	1149196	0	0
45707879	1713332	0	0
45674925	1125315	0	0
45782341	1192710	0	0
45876049	3009201	2	2
45897499	1129625	0	0
46288298	1119510	0	0
46243774	1119510	0	0
45802229	1129625	0	0
46300344	1545958	0	0
46314355	920293	0	0
46314799	1125315	0	0
4042150	4238715	4	5
21000084	19133905	2	3
21503168	1125315	0	0
21003084	1124957	0	0
35508765	742185	0	0
36156780	1125315	0	0
36313965	4024958	5	5
40221144	44816277	1	1
44359428	1595799	0	0
44350157	1119510	0	0
44353573	1332418	0	0
44348254	40223834	2	3
45634676	1118084	0	0
45661842	1174888	0	0
45635655	1125315	0	0
45624095	1125315	0	0
45636217	1119510	0	0
45645575	1738521	0	0
45689729	1192710	0	0
45674049	1551099	0	0
45695066	738818	0	0
45707919	1107830	0	0
45674929	1125315	0	0
45782342	740275	0	0
45786320	19128009	2	2
45897411	1129625	0	0
46288310	1119510	0	0
46244772	1119510	0	0
45802333	1129625	0	0
46300532	1154343	0	0
46313916	1545958	0	0
46314803	1125315	0	0
4040400	44783196	4	5
21000090	19076374	2	3
21503168	1129625	0	0
21003084	1177480	0	0
35508769	1000560	0	0
36156387	1125315	0	0
36313965	4243062	5	5
40085778	1150837	1	1
44359460	1112807	0	0
44349942	1119510	0	0
44353576	1361711	0	0
44348405	19008572	2	3
45634705	19003953	0	0
45661844	967823	0	0
45635660	1125315	0	0
45624051	1125315	0	0
45636442	1119510	0	0
45645138	1310149	0	0
45689632	1192710	0	0
45674051	967823	0	0
45697584	740275	0	0
45707991	738818	0	0
45671838	1125315	0	0
45782356	1332418	0	0
45786320	19127918	2	2
45894943	1129625	0	0
46288311	1119510	0	0
46244777	1119510	0	0
45801318	1129625	0	0
46300246	1124957	0	0
46314137	1545958	0	0
46314808	1125315	0	0
4040400	4117038	4	5
21000084	19133873	2	3
21503172	1174888	0	0
21003079	914335	0	0
35508888	1118084	0	0
35506952	1125315	0	0
36313965	4314290	5	5
36718045	381316	1	1
44359375	1174888	0	0
44349952	1119510	0	0
44353682	1115008	0	0
44348409	40229134	2	3
45634747	1115008	0	0
45662002	975125	0	0
45635325	1125315	0	0
45624055	1125315	0	0
45636526	1119510	0	0
45645481	975125	0	0
45686615	1192710	0	0
45674052	738818	0	0
45645897	740275	0	0
45705089	1713332	0	0
45671942	1125315	0	0
45782438	1713332	0	0
46288185	42902245	2	2
45895190	1129625	0	0
46288259	1119510	0	0
46244780	1119510	0	0
45801312	1129625	0	0
46300182	791967	0	0
46314429	967823	0	0
46314811	1125315	0	0
4043025	4301346	3	5
4306074	4010253	2	3
21503178	1154343	0	0
21003084	914335	0	0
35508520	1548195	0	0
35506898	1125315	0	0
36313965	4163872	5	5
40181755	40221415	1	1
44359428	1521369	0	0
44350201	1119510	0	0
44353683	1000560	0	0
45651976	46275444	2	3
45634760	1115008	0	0
45661886	791967	0	0
45635552	1125315	0	0
45623888	1125315	0	0
45636436	1119510	0	0
45645485	1149196	0	0
45686647	1192710	0	0
45674182	1153428	0	0
45645979	1115008	0	0
45705089	1759842	0	0
45671842	1125315	0	0
45782438	1759842	0	0
46243537	19128022	2	2
45895014	1129625	0	0
46288360	1119510	0	0
46238901	1119510	0	0
45795919	1129625	0	0
46300183	975125	0	0
46314782	1124300	0	0
46314816	1125315	0	0
4180627	4252419	3	5
21000141	19133873	2	3
21503179	1149380	0	0
21003084	1174888	0	0
35508521	1119510	0	0
35506941	1125315	0	0
36313965	4252419	5	6
36718119	4029498	1	1
44359428	1549786	0	0
44349968	1119510	0	0
44353488	1112807	0	0
45649408	40162522	2	3
45634819	1545958	0	0
45661895	1174888	0	0
45632428	1125315	0	0
45623697	1125315	0	0
45636561	1119510	0	0
45645475	1124300	0	0
45686883	1192710	0	0
45674184	708298	0	0
45645801	1115008	0	0
45705045	1713332	0	0
45671828	1125315	0	0
45782439	1500211	0	0
45876069	3013682	2	2
45895211	1129625	0	0
46288417	1119510	0	0
46238902	1119510	0	0
45795798	1129625	0	0
46300184	738818	0	0
46313922	1551099	0	0
46314821	1125315	0	0
4043022	4238715	3	5
441840	372328	5	8
21503179	1137529	0	0
21003079	1192710	0	0
35508521	738818	0	0
35507131	1125315	0	0
36313965	4024289	5	6
40057961	40223768	1	1
44359448	1738521	0	0
44350164	1119510	0	0
44353708	1000560	0	0
45649962	1127433	2	3
45634442	1738521	0	0
45661692	1174888	0	0
45632324	1125315	0	0
45624113	1125315	0	0
45636152	1119510	0	0
45645554	1551099	0	0
45686964	1192710	0	0
45674193	1521369	0	0
45691751	1738521	0	0
45705045	1759842	0	0
45672107	1125315	0	0
45782522	1713332	0	0
45876069	3006906	2	2
45895150	1129625	0	0
46288434	1119510	0	0
46238903	1119510	0	0
45795945	1129625	0	0
46300323	1115008	0	0
46314390	975125	0	0
46315082	1125315	0	0
4180169	440448	3	5
441840	4152936	5	10
21503065	1343916	0	0
21003079	1115008	0	0
35508523	1129625	0	0
35507054	1125315	0	0
36313965	4058899	5	7
40105046	1713671	1	1
44359433	1149196	0	0
44349826	1119510	0	0
44353503	1107830	0	0
45649220	40174880	2	3
45634815	1332418	0	0
45661785	738818	0	0
45632287	1125315	0	0
45668028	1125315	0	0
45636340	1119510	0	0
45645510	738818	0	0
45687017	1192710	0	0
45674193	19127890	0	0
45691719	1124300	0	0
45705133	1149380	0	0
45671972	1125315	0	0
45783590	19003953	0	0
45895468	19128022	2	2
45895337	1129625	0	0
46288456	1119510	0	0
46238870	1119510	0	0
45795955	1129625	0	0
46295767	1110410	0	0
46314395	1149196	0	0
46314747	1125315	0	0
4093991	4310024	3	5
441840	4056621	5	9
21503281	975125	0	0
21003079	1125315	0	0
35508659	1549786	0	0
35507056	1125315	0	0
36313965	40478878	4	4
36718005	381316	0	0
44359853	1177480	0	0
44350088	1119510	0	0
44353414	1539403	0	0
44354696	1551192	2	3
45634737	1149196	0	0
45661837	1192710	0	0
45632296	1125315	0	0
45668034	1125315	0	0
45636644	1119510	0	0
45645522	738818	0	0
45686813	1192710	0	0
45674193	1549786	0	0
45691860	1149196	0	0
45704800	1310149	0	0
45671743	1125315	0	0
45783674	1107830	0	0
45679375	19008572	2	3
45894521	1129625	0	0
46288772	1119510	0	0
46238921	1119510	0	0
45790670	1129625	0	0
46295857	914335	0	0
46314785	1174888	0	0
46314192	1125315	0	0
4180628	134438	3	5
441840	4310024	5	9
21003454	1595799	0	0
21003090	1124957	0	0
35508659	1515774	0	0
35507061	1125315	0	0
36313965	4062501	4	4
40766240	40766240	0	0
44359982	1305058	0	0
44350124	1119510	0	0
44353415	975125	0	0
45655934	40223834	2	3
45634741	1310149	0	0
45661982	1124957	0	0
45632289	1125315	0	0
45667648	1125315	0	0
45636469	1119510	0	0
45645940	975125	0	0
45687034	1192710	0	0
45674194	738818	0	0
45691864	1310149	0	0
45704688	1107830	0	0
45671750	1125315	0	0
45783547	1149380	0	0
45679794	40232448	2	3
45894496	1129625	0	0
46288803	1119510	0	0
46238922	1119510	0	0
45790674	1129625	0	0
46296139	1501700	0	0
46314626	1713332	0	0
46314777	1125315	0	0
4162054	4107731	3	5
441840	4283893	5	9
21003454	19054876	0	0
21003091	1124957	0	0
35508668	1174888	0	0
35507141	1125315	0	0
36313965	4145310	4	4
40249018	740275	0	0
44359474	1177480	0	0
44350071	1119510	0	0
44353419	1192710	0	0
45655934	40223821	2	3
45634745	1309944	0	0
45661985	738818	0	0
45632293	1125315	0	0
45667988	1125315	0	0
45636675	1119510	0	0
45642530	1713332	0	0
45683693	1192710	0	0
45674346	1192710	0	0
45691891	1713332	0	0
45704693	1717327	0	0
45671753	1125315	0	0
45783548	1124300	0	0
45679032	40232448	2	3
45803008	1129625	0	0
46288691	1119510	0	0
46238923	1119510	0	0
45790587	1129625	0	0
46296306	1778162	0	0
46314408	1332418	0	0
46314940	1125315	0	0
4042150	4186930	3	6
441840	4174876	5	6
21003454	1521369	0	0
21003086	1102527	0	0
35508678	975125	0	0
35507174	1125315	0	0
36313965	4047491	6	7
40479768	40479768	0	0
44359430	19127890	0	0
44350075	1119510	0	0
44353535	1332418	0	0
44340911	19019273	2	3
45634805	1115008	0	0
45661908	1115008	0	0
45632335	1125315	0	0
45667991	1125315	0	0
45636605	1119510	0	0
45642346	1149196	0	0
45683889	1192710	0	0
45674318	1124957	0	0
45691891	1759842	0	0
45704694	1308738	0	0
45671790	1125315	0	0
45783579	1717327	0	0
45679055	40169216	2	3
45803279	1129625	0	0
46288694	1119510	0	0
46238895	1119510	0	0
45790762	1129625	0	0
46296318	1124300	0	0
46314555	1112807	0	0
46314959	1125315	0	0
4180169	257012	3	6
441840	440086	5	7
21003454	1589505	0	0
21003084	1154029	0	0
35508683	1729720	0	0
35507129	1125315	0	0
36303153	4048171	8	13
40479422	40479422	0	0
44359430	1589505	0	0
44350101	1119510	0	0
44353538	967823	0	0
44337399	19019273	2	3
45634420	1110410	0	0
45661928	1310149	0	0
45632337	1125315	0	0
45667978	1125315	0	0
45636940	1119510	0	0
45642501	1192710	0	0
45683893	1192710	0	0
45673724	738818	0	0
45691898	1309944	0	0
45704701	1332418	0	0
45671857	1125315	0	0
45783587	1322184	0	0
45678968	40232448	2	3
45803288	1129625	0	0
46288701	1119510	0	0
46238898	1119510	0	0
45790984	1129625	0	0
46296347	1149380	0	0
46314575	1112807	0	0
46314979	1125315	0	0
4199402	4278672	5	6
441840	140673	5	7
21003454	19127890	0	0
21003091	1174888	0	0
35508686	1741122	0	0
36152536	1125315	0	0
36303153	313217	8	13
40250232	967823	0	0
44359430	1549786	0	0
44350127	1119510	0	0
44353546	1361711	0	0
44348222	19123231	2	3
45634817	1500211	0	0
45661968	1309944	0	0
45632416	1125315	0	0
45667984	1125315	0	0
45637054	1119510	0	0
45642510	791967	0	0
45684008	1192710	0	0
45674358	1115008	0	0
45691543	1521369	0	0
45704928	757627	0	0
45672234	1125315	0	0
45783624	1124300	0	0
45679125	40232448	2	3
45803411	1129625	0	0
46288761	1119510	0	0
46238899	1119510	0	0
45790720	1129625	0	0
46296353	1000560	0	0
46314582	1192710	0	0
46314910	1125315	0	0
4172024	4240902	5	6
441840	4094814	5	5
21003454	1518198	0	0
21003090	1110410	0	0
35508686	1746114	0	0
36152491	1125315	0	0
36303153	375671	8	12
40480160	40480160	0	0
44359431	1129625	0	0
44349682	1119510	0	0
44353551	1549786	0	0
44340939	1545959	2	3
45634556	1154029	0	0
45661760	1778162	0	0
45632352	1125315	0	0
45667780	1125315	0	0
45633278	1119510	0	0
45642384	1149196	0	0
45684018	1192710	0	0
45673913	1192710	0	0
45691530	738818	0	0
45705050	1557272	0	0
45671871	1125315	0	0
45783644	1107830	0	0
45785844	40223834	2	3
45803080	1129625	0	0
46288716	1119510	0	0
46239042	1119510	0	0
46297406	1129625	0	0
46296468	967823	0	0
46314796	1738521	0	0
46314912	1125315	0	0
4172024	4219399	5	6
441840	4029498	4	7
21003454	1515774	0	0
21003091	1154029	0	0
35508697	1307863	0	0
36152494	1125315	0	0
36303153	4059173	8	11
40213198	40213198	0	0
44359381	1521369	0	0
44349669	1119510	0	0
44353645	1129625	0	0
44354886	1545959	2	3
45634680	1124300	0	0
45661761	975125	0	0
45632355	1125315	0	0
45667893	1125315	0	0
45633190	1119510	0	0
45642434	715997	0	0
45680862	1192710	0	0
45674299	1124300	0	0
45691577	1149196	0	0
45705059	1192710	0	0
45672137	1125315	0	0
45782678	1115008	0	0
45785976	1107882	2	3
45800485	1129625	0	0
46243296	1119510	0	0
46238992	1119510	0	0
46297345	1129625	0	0
600000007	1557272	0	0
46314456	1192710	0	0
46314919	1125315	0	0
4172024	37017711	5	6
441840	317576	4	10
21003454	1549786	0	0
21003084	1110410	0	0
35508405	1125315	0	0
36152598	1125315	0	0
36303153	81893	8	14
40213201	40213201	0	0
44359381	1549786	0	0
44342512	1119510	0	0
44353684	1589505	0	0
44351256	1545959	2	3
45634788	914335	0	0
45661899	975125	0	0
45632340	1125315	0	0
45668015	1125315	0	0
45633203	1119510	0	0
45642448	1713332	0	0
45680863	1192710	0	0
45674303	1192710	0	0
45691674	1738521	0	0
45707178	19128022	3	4
45672026	1125315	0	0
45782707	933724	0	0
45786067	40174880	2	3
45800583	1129625	0	0
46243339	1119510	0	0
46238993	1119510	0	0
46297349	1129625	0	0
600000010	1310149	0	0
46314512	705944	0	0
46314699	1125315	0	0
4042140	44782520	5	6
441840	4027663	4	8
21003454	1548195	0	0
21003091	1110410	0	0
35508406	791967	0	0
36152521	1125315	0	0
36303153	4219399	8	9
40213314	40213314	0	0
44359535	1124957	0	0
44342431	1119510	0	0
44353684	19127890	0	0
44341545	19078461	2	3
45634759	1153428	0	0
45664310	19003953	0	0
45632432	1125315	0	0
45670123	1125315	0	0
45633291	1119510	0	0
45642451	1124957	0	0
45677481	1192710	0	0
45673889	708298	0	0
45691642	967823	0	0
45781363	19128022	3	4
45672028	1125315	0	0
45782737	1713332	0	0
45786544	40229134	2	3
45800687	1129625	0	0
46243301	1119510	0	0
46239295	1119510	0	0
46297558	1129625	0	0
46318351	1149196	0	0
46314682	1545958	0	0
46314700	1125315	0	0
4040396	4198190	5	6
441840	317009	4	5
21003454	1519936	0	0
21003084	1102527	0	0
35508719	1119510	0	0
36152725	1125315	0	0
36303153	4240902	8	9
40213320	40213320	0	0
44359617	740275	0	0
44342586	1119510	0	0
44353684	1549786	0	0
45662011	1127433	2	3
45636801	1110410	0	0
45655524	1539403	0	0
45632702	1125315	0	0
45670276	1125315	0	0
45633317	1119510	0	0
45642452	1124957	0	0
45674157	1192710	0	0
45674017	914335	0	0
45691629	1332418	0	0
45671700	19128009	2	2
45672030	1125315	0	0
45782850	1124957	0	0
45786676	40232448	2	3
45800561	1129625	0	0
46243468	1119510	0	0
46239111	1119510	0	0
46297562	1129625	0	0
46318336	1326303	0	0
46313857	1107830	0	0
46317746	1125315	0	0
4093991	4048171	5	6
441840	37017711	7	8
21003454	1512674	0	0
21003118	975125	0	0
35508720	1124300	0	0
36152762	1125315	0	0
36303153	78272	7	13
40213154	40213154	0	0
44359619	967823	0	0
44342131	1119510	0	0
44353693	1124300	0	0
45662011	19078461	2	3
45636891	705944	0	0
45655567	1149196	0	0
45629211	1125315	0	0
45670001	1125315	0	0
45633438	1119510	0	0
45642597	975125	0	0
45676229	1192710	0	0
45674024	1738521	0	0
45691919	715997	0	0
45766058	4330583	2	2
45672157	1125315	0	0
45782765	967823	0	0
45786682	43012036	2	3
45800699	1129625	0	0
46243348	1119510	0	0
46239298	1119510	0	0
46297418	1129625	0	0
46318445	975125	0	0
46315008	715997	0	0
46317968	1125315	0	0
4117930	198199	4	6
441840	4240902	7	8
21003455	19127890	0	0
21003118	1149380	0	0
35508775	1115008	0	0
36152880	1125315	0	0
36303153	441267	7	8
40213160	40213160	0	0
44359523	1717327	0	0
44342264	1119510	0	0
44353747	1177480	0	0
44347456	1551192	2	3
45631645	1595799	0	0
45655576	1713332	0	0
45629297	1125315	0	0
45670049	1125315	0	0
45633557	1119510	0	0
45642627	1174888	0	0
45674467	1192710	0	0
45674026	1107830	0	0
45691753	1174888	0	0
45763613	81893	2	2
45671772	1125315	0	0
45782769	1192710	0	0
45786287	1115171	2	3
45800839	1129625	0	0
46240854	1119510	0	0
46239306	1119510	0	0
46297284	1129625	0	0
46318372	914335	0	0
46315014	967823	0	0
46317164	1125315	0	0
4043161	4107731	4	6
441840	4219399	7	8
21003511	1000560	0	0
21003090	1174888	0	0
35508907	1129625	0	0
36152577	1125315	0	0
36303153	438614	7	8
40213216	40213216	0	0
44359527	1129625	0	0
44344655	1119510	0	0
44353663	1192710	0	0
44358085	1545959	2	3
45631464	1549786	0	0
45658264	738818	0	0
45629300	1125315	0	0
45670288	1125315	0	0
45633687	1119510	0	0
45642602	723013	0	0
45674546	1192710	0	0
45671150	1000560	0	0
45691768	967823	0	0
45765647	4001336	2	2
45672171	1125315	0	0
45782732	1557272	0	0
46292550	46275444	2	3
45800744	1129625	0	0
46240858	1119510	0	0
46239205	1119510	0	0
46297908	1129625	0	0
46318376	914335	0	0
46314721	967823	0	0
46317359	1125315	0	0
4043022	4186930	4	6
441840	4166224	7	11
21003511	791967	0	0
21003153	1129625	0	0
35508908	1112807	0	0
36152579	1125315	0	0
36303153	4102123	7	8
40213227	40213227	0	0
44359624	1149196	0	0
44342631	1119510	0	0
44353663	1112807	0	0
45655751	1551192	2	3
45631464	19127890	0	0
45658006	753626	0	0
45629303	1125315	0	0
45670079	1125315	0	0
45630284	1119510	0	0
45642413	1515774	0	0
45671608	1192710	0	0
45671151	1551099	0	0
45691774	1322184	0	0
45690321	19128022	2	2
45671780	1125315	0	0
45782733	1115008	0	0
46293077	35605482	2	3
45797776	1129625	0	0
46242546	1119510	0	0
46239029	1119510	0	0
46297897	1129625	0	0
46318807	933724	0	0
46308893	1545958	0	0
46315285	1125315	0	0
4180169	81893	4	6
441840	378001	7	11
21003455	1549786	0	0
21604571	791967	0	0
35508910	1129625	0	0
36152661	1125315	0	0
36303153	4048169	7	8
40213230	40213230	0	0
44359475	1549786	0	0
44342639	1119510	0	0
44353666	738818	0	0
44362217	19079524	2	3
45631466	738818	0	0
45658205	975125	0	0
45629308	1125315	0	0
45670312	1125315	0	0
45630373	1119510	0	0
45642413	1549786	0	0
45671315	1192710	0	0
45671147	1713332	0	0
45691672	1115008	0	0
45690321	19128263	2	2
45671782	1125315	0	0
45782892	1124957	0	0
46292997	40165015	2	3
45798058	1129625	0	0
46242486	1119510	0	0
45894584	1119510	0	0
46298017	1129625	0	0
46318452	738818	0	0
46308797	1174888	0	0
46315304	1125315	0	0
4043023	4336464	4	6
441840	4059173	7	10
21003455	1589505	0	0
21604566	723013	0	0
35508913	1125315	0	0
36152607	1125315	0	0
36303153	4306014	7	8
40213251	40213251	0	0
44359475	19127890	0	0
44342649	1119510	0	0
44353677	1124300	0	0
45661928	40163554	2	3
45631647	1107830	0	0
45658021	1107830	0	0
45629510	1125315	0	0
45670265	1125315	0	0
45630013	1119510	0	0
45642423	1501700	0	0
45671575	1192710	0	0
45671336	967823	0	0
45691823	1548195	0	0
45675348	19127918	2	2
45671888	1125315	0	0
45782855	1174888	0	0
46292508	19078461	2	3
45797942	1129625	0	0
46242170	1119510	0	0
45894378	1119510	0	0
46297801	1129625	0	0
46318492	701322	0	0
46308841	975125	0	0
46315165	1125315	0	0
4047779	198199	4	6
4215793	4202832	2	2
21004032	1717327	0	0
21604643	708298	0	0
35508422	1307863	0	0
36152919	1125315	0	0
36303153	439406	7	8
40213180	40213180	0	0
44359475	1515774	0	0
44342656	1119510	0	0
44353678	1548195	0	0
45655796	40163554	2	3
45631578	1501700	0	0
45655599	738818	0	0
45629378	1125315	0	0
45670449	1125315	0	0
45630447	1119510	0	0
45642574	1738521	0	0
45671542	1192710	0	0
45671338	738818	0	0
45691838	933724	0	0
45675348	19128009	2	2
45784053	1125315	0	0
45782757	723013	0	0
46292653	1115171	2	3
45797900	1129625	0	0
46241209	1119510	0	0
45894620	1119510	0	0
46289063	1129625	0	0
46318571	1107830	0	0
46308843	1110410	0	0
46309493	1125315	0	0
4180628	4296204	4	6
4344497	4149245	2	2
21003438	1746114	0	0
21604417	740275	0	0
35508889	1149196	0	0
36152682	1125315	0	0
36303153	4304110	7	8
40220386	40220386	0	0
44359478	708298	0	0
44342669	1119510	0	0
44353779	1310149	0	0
45656022	19019273	2	3
45631579	1115008	0	0
45655621	967823	0	0
45629168	1125315	0	0
45670090	1125315	0	0
45630155	1119510	0	0
45642579	967823	0	0
45670157	1192710	0	0
45671213	1551099	0	0
45691959	1174888	0	0
45769811	375671	2	2
45783785	1125315	0	0
45782709	1551099	0	0
45784800	1129625	0	0
45797909	1129625	0	0
46241211	1119510	0	0
45894431	1119510	0	0
46289159	1129625	0	0
46318581	1124300	0	0
46309053	1501700	0	0
46309502	1125315	0	0
4043022	4057420	6	6
4316083	4296204	2	2
21003438	1778162	0	0
21604152	1557272	0	0
35508826	1118084	0	0
36153080	1125315	0	0
36303153	4230399	7	12
40220389	40220386	0	0
44359490	1741122	0	0
44364094	1119510	0	0
44353726	1545958	0	0
44355050	19019273	2	3
45631698	967823	0	0
45655679	1549786	0	0
45629169	1125315	0	0
45668116	1125315	0	0
45630959	1119510	0	0
45642580	1149196	0	0
45781818	1192710	0	0
45671184	1308738	0	0
45691648	1759842	0	0
45769811	378001	2	2
45783888	1125315	0	0
45782710	1326303	0	0
45784565	1129625	0	0
45795226	1129625	0	0
46241119	1119510	0	0
45893585	1119510	0	0
46289175	1129625	0	0
46318515	1512674	0	0
46308809	1549786	0	0
46309593	1125315	0	0
4043161	4216130	6	6
4216752	4197460	2	2
21003514	914335	0	0
21500804	1367571	0	0
35508534	1125315	0	0
36152812	1125315	0	0
36303153	440448	7	12
40165015	40165015	0	0
44359490	1746114	0	0
44364279	1119510	0	0
44353515	1112807	0	0
45661908	19019273	2	3
45631660	1545958	0	0
45655679	19127890	0	0
45629461	1125315	0	0
45668153	1125315	0	0
45631262	1119510	0	0
45642615	723013	0	0
45781777	1192710	0	0
45671162	723013	0	0
45691648	1713332	0	0
45679970	19008572	2	3
45783890	1125315	0	0
45782780	19127890	0	0
45784788	1129625	0	0
45795528	1129625	0	0
46241137	1119510	0	0
45893556	1119510	0	0
46289364	1129625	0	0
46318515	1549786	0	0
46308809	1589505	0	0
46309605	1125315	0	0
4043161	4108705	6	6
4322244	4125906	2	2
21003515	791967	0	0
21500819	1322184	0	0
35508536	1738521	0	0
36152648	1125315	0	0
36303153	40481087	7	11
37522318	4336464	0	0
44359501	1177480	0	0
44364289	1119510	0	0
44353706	1112807	0	0
44340813	19019273	2	3
45631700	1124300	0	0
45655630	1332418	0	0
45629549	1125315	0	0
45668183	1125315	0	0
45630553	1119510	0	0
45642517	1149196	0	0
45781801	1192710	0	0
45671164	1308738	0	0
45692015	1000560	0	0
45680023	40236824	2	3
45783903	1125315	0	0
45782780	1589505	0	0
45784819	1129625	0	0
45795378	1129625	0	0
46241376	1119510	0	0
45801384	1119510	0	0
46289508	1129625	0	0
46318521	1307863	0	0
46308967	1361711	0	0
46309607	1125315	0	0
4043023	40492359	6	6
19127891	19128263	2	2
21004035	723013	0	0
21500806	1310149	0	0
35508441	1149380	0	0
36153081	1125315	0	0
36303153	4278672	7	11
37522325	4216130	0	0
44359502	1153428	0	0
44364364	1119510	0	0
44353707	1107830	0	0
45620553	19019273	2	3
45631596	1124300	0	0
45655688	1154029	0	0
45629233	1125315	0	0
45668131	1125315	0	0
45627520	1119510	0	0
45642624	1332418	0	0
45783599	1192710	0	0
45671003	1343916	0	0
45692022	1549786	0	0
45680003	19018935	2	3
45783908	1125315	0	0
45782780	1549786	0	0
45782403	1129625	0	0
45794644	1129625	0	0
46241282	1119510	0	0
45801481	1119510	0	0
46289463	1129625	0	0
46318523	975125	0	0
46309076	975125	0	0
46310079	1125315	0	0
4040400	4330583	5	6
19127891	19128022	2	2
21004201	1717327	0	0
21500851	1759842	0	0
35508813	1177480	0	0
35509188	1125315	0	0
36303153	4146173	7	11
36718157	378419	0	0
44359506	1548195	0	0
44357062	1119510	0	0
44353881	1192710	0	0
45655496	40174880	2	3
45631706	1361711	0	0
45655694	975125	0	0
45629500	1125315	0	0
45668320	1125315	0	0
45627782	1119510	0	0
45642523	1154029	0	0
45779489	1192710	0	0
45671078	715997	0	0
45692022	1589505	0	0
45680013	19018935	2	3
45784172	1125315	0	0
45782771	1124957	0	0
45782662	1129625	0	0
45794537	1129625	0	0
46241391	1119510	0	0
45801617	1119510	0	0
46289789	1129625	0	0
46318405	1738521	0	0
46309028	715997	0	0
46309701	1125315	0	0
4040400	4163971	6	6
19127891	19128065	2	2
21004202	1717327	0	0
21500824	1112807	0	0
35508861	1000560	0	0
35509189	1125315	0	0
36303153	4001336	7	11
36718530	4029498	0	0
44359507	1521369	0	0
44357173	1119510	0	0
44353882	1129625	0	0
45655137	1539411	2	3
45631574	1149196	0	0
45655796	1310149	0	0
45629265	1125315	0	0
45668324	1125315	0	0
45627784	1119510	0	0
45642489	1154343	0	0
45707949	1192710	0	0
45671085	1115008	0	0
45692022	19127890	0	0
45677545	40231925	2	3
45784173	1125315	0	0
45782969	1149196	0	0
45780544	1129625	0	0
45794617	1129625	0	0
46238440	1119510	0	0
45801752	1119510	0	0
46289757	1129625	0	0
46318406	975125	0	0
46309018	1000560	0	0
46309548	1125315	0	0
4040400	4108705	6	6
19127891	19127904	2	2
21003656	1738521	0	0
21500845	1308738	0	0
35508863	701322	0	0
35509194	1125315	0	0
36303153	198199	7	10
40213260	40213260	0	0
44359508	1124300	0	0
44357258	1119510	0	0
44353519	738818	0	0
45621900	40223768	2	3
45631813	1124957	0	0
45655851	723013	0	0
45629266	1125315	0	0
45668325	1125315	0	0
45627718	1119510	0	0
45642491	1310149	0	0
45707950	1192710	0	0
45671253	1115008	0	0
45691690	738818	0	0
45677944	40232448	2	3
45784113	1125315	0	0
45782863	1192710	0	0
45780555	1129625	0	0
45794445	1129625	0	0
46238327	1119510	0	0
45801392	1119510	0	0
46289713	1129625	0	0
46318418	1153428	0	0
46308902	1107830	0	0
46309828	1125315	0	0
4040400	4301346	4	6
4302532	4202451	2	2
21004223	1713332	0	0
21500903	975125	0	0
35508541	1119510	0	0
36157065	1125315	0	0
36303153	28060	7	10
40213281	40213281	0	0
44359586	1545958	0	0
44358910	1119510	0	0
44353727	1118084	0	0
44352291	40223768	2	3
45631913	791967	0	0
45655857	1549786	0	0
45629375	1125315	0	0
45668339	1125315	0	0
45627722	1119510	0	0
45642628	1149196	0	0
45708187	1192710	0	0
45671106	1310149	0	0
45691695	1115008	0	0
45677837	1154615	2	3
45784159	1125315	0	0
45780747	975125	0	0
45706600	1129625	0	0
45792782	1129625	0	0
46238392	1119510	0	0
45801609	1119510	0	0
46289604	1129625	0	0
46318696	1501700	0	0
46308908	740275	0	0
46309842	1125315	0	0
4040400	4216130	3	6
4301352	4323902	2	2
21002330	1746114	0	0
21500875	967823	0	0
35508879	1125315	0	0
36157223	1125315	0	0
36303153	4296204	7	10
40213296	40213296	0	0
44359733	1153428	0	0
44358718	1119510	0	0
44353716	1110410	0	0
45636974	19078461	2	3
45631916	1310149	0	0
45655857	19127890	0	0
45629474	1125315	0	0
45668159	1125315	0	0
45627530	1119510	0	0
45642558	1192710	0	0
45708299	1192710	0	0
45671108	19010482	0	0
45691696	1310149	0	0
45677904	40232448	2	3
45783929	1125315	0	0
45780749	791967	0	0
45706733	1129625	0	0
45792791	1129625	0	0
46238395	1119510	0	0
45801595	1119510	0	0
46289847	1129625	0	0
46318767	975125	0	0
46309082	1595799	0	0
46309867	1125315	0	0
4093991	40479768	6	7
4301352	4337611	2	2
21002335	1741122	0	0
21500874	967823	0	0
35508879	1119510	0	0
36156815	1125315	0	0
36303153	4116491	7	9
40213299	40213299	0	0
44359652	1129625	0	0
44358751	1119510	0	0
44353728	1129625	0	0
44355081	40223768	2	3
45631924	1500211	0	0
45655857	1589505	0	0
45629475	1125315	0	0
45668106	1125315	0	0
45627585	1119510	0	0
45642559	738818	0	0
45705334	1192710	0	0
45671189	1309944	0	0
45692039	738818	0	0
45678052	920334	2	3
45784083	1125315	0	0
45780754	1153428	0	0
45706635	1129625	0	0
45792858	1129625	0	0
46238502	1119510	0	0
45801566	1119510	0	0
46289895	1129625	0	0
46318699	1729720	0	0
46309082	1521369	0	0
46309895	1125315	0	0
4093991	133834	6	7
4339410	4035415	2	2
21002328	1713332	0	0
21500894	975125	0	0
35508814	1129625	0	0
36156821	1125315	0	0
36303153	4296205	7	7
40220960	40220960	0	0
44359545	1149380	0	0
44357336	1119510	0	0
44353492	920293	0	0
44357981	19075001	2	3
45631709	1174888	0	0
45655606	1115008	0	0
45629482	1125315	0	0
45665790	1125315	0	0
45627702	1119510	0	0
45642725	1149196	0	0
45702017	1192710	0	0
45671119	1738521	0	0
45691840	1124957	0	0
45677970	1127433	2	3
45781947	1125315	0	0
45780779	1000560	0	0
45706832	1129625	0	0
45792774	1129625	0	0
46238344	1119510	0	0
45801581	1119510	0	0
46241638	1129625	0	0
46318662	1713332	0	0
46309082	1549786	0	0
46309910	1125315	0	0
4093991	40479422	6	7
4339410	80502	2	2
21002346	1759842	0	0
21500853	975125	0	0
35508815	705944	0	0
36156977	1125315	0	0
36303153	4094814	6	6
40213306	40213306	0	0
44359467	1501700	0	0
44357311	1119510	0	0
44353812	1177480	0	0
44357999	40223768	2	3
45631718	1149196	0	0
45655658	975125	0	0
45629492	1125315	0	0
45665594	1125315	0	0
45627412	1119510	0	0
45642479	1174888	0	0
45702068	1192710	0	0
45671222	740275	0	0
45692046	1124957	0	0
45679772	35605482	2	3
45781878	1125315	0	0
45780781	1729720	0	0
45706835	1129625	0	0
45787332	1129625	0	0
46238349	1119510	0	0
45795901	1119510	0	0
46241716	1129625	0	0
46318722	1332418	0	0
46309105	1332418	0	0
46310078	1125315	0	0
4043022	4275113	5	7
4198525	4027663	2	2
21002330	1759842	0	0
21500932	975125	0	0
35508817	1119510	0	0
36156754	1125315	0	0
36303153	4051466	6	7
40221414	40221415	0	0
44359743	1177480	0	0
44353921	1119510	0	0
44353816	1112807	0	0
44340145	40223768	2	3
45631830	967823	0	0
45655672	975125	0	0
45629495	1125315	0	0
45665810	1125315	0	0
45627414	1119510	0	0
45642564	1174888	0	0
45702133	1192710	0	0
45671292	1115008	0	0
45691801	757627	0	0
45679639	19057271	2	3
45781939	1125315	0	0
45780847	1115008	0	0
45706841	1129625	0	0
45787279	1129625	0	0
46238695	1119510	0	0
45795961	1119510	0	0
46241741	1129625	0	0
46318529	1115008	0	0
46309286	1112807	0	0
46309543	1125315	0	0
4043022	4117038	4	7
4200516	381316	2	2
21002329	1717327	0	0
21500876	1124300	0	0
35508824	1549786	0	0
36156825	1125315	0	0
36303153	4174876	6	7
40221415	40221415	0	0
44359657	1000560	0	0
44354030	1119510	0	0
44353816	1192710	0	0
45655576	19073183	2	3
45631817	1501700	0	0
45655977	1124300	0	0
45629402	1125315	0	0
45666059	1125315	0	0
45624608	1119510	0	0
45642629	975125	0	0
45699021	1192710	0	0
45671135	1192710	0	0
45691777	738818	0	0
45679245	40223768	2	3
45781967	1125315	0	0
45780632	1115008	0	0
46240377	1129625	0	0
45787280	1129625	0	0
46238727	1119510	0	0
45796160	1119510	0	0
46241742	1129625	0	0
46318841	1124300	0	0
46308958	791967	0	0
46309556	1125315	0	0
4043022	4198190	6	7
4301471	195588	2	2
21002347	1746114	0	0
21500926	975125	0	0
35508824	1515774	0	0
36156990	1125315	0	0
36303153	4024289	6	7
40231925	40231925	0	0
44359764	1192710	0	0
44353844	1119510	0	0
44353827	1713332	0	0
44362515	19078461	2	3
45631925	1500211	0	0
45655618	1000560	0	0
45629584	1125315	0	0
45665915	1125315	0	0
45624468	1119510	0	0
45642632	1192710	0	0
45699518	1192710	0	0
45671138	1192710	0	0
45691979	1124300	0	0
45674626	40232448	2	3
45781926	1125315	0	0
45780786	1149380	0	0
45702776	1129625	0	0
45696301	1119510	0	0
45897495	1119510	0	0
45795965	1119510	0	0
46241682	1129625	0	0
46318670	1738521	0	0
46309209	715997	0	0
46309968	1125315	0	0
4180169	260139	3	7
4261497	42535580	2	2
21002338	1746114	0	0
21002855	1125315	0	0
35508824	19127890	0	0
36157006	1125315	0	0
36303153	440086	6	8
36718530	380378	0	1
44359765	1545958	0	0
44354249	1119510	0	0
44353788	1192710	0	0
45620447	19073183	2	3
45631930	967823	0	0
45655751	1551099	0	0
45631236	1125315	0	0
45666075	1125315	0	0
45624628	1119510	0	0
45642637	1153428	0	0
45695753	1192710	0	0
45671144	933724	0	0
45692071	1326303	0	0
45674538	1127433	2	3
45781912	1125315	0	0
45780889	1000560	0	0
45702869	1129625	0	0
45696812	1119510	0	0
45897513	1119510	0	0
45796250	1119510	0	0
46242515	1129625	0	0
46318981	1308738	0	0
46309230	1595799	0	0
46309746	1125315	0	0
4199402	4048695	5	7
4201402	81893	2	2
21002338	1741122	0	0
21002855	723013	0	0
35508918	1153428	0	0
36157160	1125315	0	0
36303153	140673	6	8
37202316	4280726	3	9
44359767	1124300	0	0
44354196	1119510	0	0
44353788	1112807	0	0
45625321	1332419	2	3
45631877	1539403	0	0
45655802	708298	0	0
45626452	1125315	0	0
45665828	1125315	0	0
45624651	1119510	0	0
45642496	1174888	0	0
45697750	1192710	0	0
45671261	723013	0	0
45691990	1149196	0	0
45674958	19133768	2	3
45781915	1125315	0	0
45780895	1174888	0	0
45703037	1129625	0	0
45696818	1119510	0	0
45897518	1119510	0	0
45795913	1119510	0	0
46241888	1129625	0	0
46318986	967823	0	0
46309230	1549786	0	0
46309562	1125315	0	0
4159949	4336464	5	7
4197094	4266809	2	2
21002332	1759842	0	0
21002855	1112807	0	0
35508924	1332418	0	0
36157171	1125315	0	0
36303153	4155034	6	9
37202316	261325	3	9
44359699	1129625	0	0
44354102	1119510	0	0
44353731	1310149	0	0
44348694	19078461	2	3
45631879	1174888	0	0
45655863	967823	0	0
45626453	1125315	0	0
45666049	1125315	0	0
45624413	1119510	0	0
45640051	738818	0	0
45692862	1192710	0	0
45671365	1738521	0	0
45691993	1717327	0	0
45674741	1115171	2	3
45781917	1125315	0	0
45780952	705944	0	0
45703074	1129625	0	0
45696874	1119510	0	0
45897589	1119510	0	0
45796114	1119510	0	0
46241894	1129625	0	0
46318586	1738521	0	0
46309230	1521369	0	0
46309974	1125315	0	0
4117930	317576	5	7
4342752	81893	2	2
21002349	920293	0	0
21002855	791967	0	0
35509016	1124957	0	0
36157308	1125315	0	0
36303153	380378	6	9
37202316	257012	3	8
44359700	738818	0	0
44354279	1119510	0	0
44353736	1115008	0	0
45620556	1107882	2	3
45631781	738818	0	0
45655757	1343916	0	0
45626634	1125315	0	0
45666221	1125315	0	0
45624448	1119510	0	0
45640054	1361711	0	0
45693067	1192710	0	0
45671366	1500211	0	0
45691805	738818	0	0
45674640	1127433	2	3
45782080	1125315	0	0
45780200	1149196	0	0
45703938	1129625	0	0
45696717	1119510	0	0
45897776	1119510	0	0
45796199	1119510	0	0
45897795	1129625	0	0
46318746	1000560	0	0
46309231	1149196	0	0
46309994	1125315	0	0
4117930	4142905	4	7
4200851	258780	2	2
21002434	1717327	0	0
21002856	1125315	0	0
35508887	708298	0	0
36157344	1125315	0	0
36303153	4310024	6	10
37200000	258780	3	11
44359705	1115008	0	0
44352402	1119510	0	0
44353830	1177480	0	0
44344712	1107882	2	3
45631782	738818	0	0
45655760	1174888	0	0
45626637	1125315	0	0
45666254	1125315	0	0
45624415	1119510	0	0
45639421	1174888	0	0
45690014	1192710	0	0
45671516	1124300	0	0
45691808	1501700	0	0
45675001	1539411	2	3
45781946	1125315	0	0
45780250	1149196	0	0
45703129	1129625	0	0
45696794	1119510	0	0
45895436	1119510	0	0
45796097	1119510	0	0
45895810	1129625	0	0
46318851	1124300	0	0
46309137	975125	0	0
46309572	1125315	0	0
4117930	195588	4	7
4344040	4146173	2	2
21002436	1746114	0	0
21002858	1728416	0	0
35509019	1129625	0	0
36157488	1125315	0	0
36303153	4035415	6	10
37200000	261325	3	10
44359708	1129625	0	0
44352235	1119510	0	0
44353791	1149380	0	0
44347685	1107882	2	3
45632152	738818	0	0
45655761	975125	0	0
45626737	1125315	0	0
45665730	1125315	0	0
45624767	1119510	0	0
45639461	967823	0	0
45689788	1192710	0	0
45671518	1149196	0	0
45691811	933724	0	0
45674879	40229134	2	3
45781995	1125315	0	0
45780285	1107830	0	0
45703170	1129625	0	0
45802680	1119510	0	0
45895348	1119510	0	0
45796101	1119510	0	0
45895901	1129625	0	0
46318727	1308738	0	0
46309152	1729720	0	0
46309931	1125315	0	0
4180169	40486433	4	7
4320791	40486433	2	2
21002491	1125315	0	0
21002881	1746114	0	0
35508981	1115008	0	0
36157468	1125315	0	0
36303153	4283893	6	10
37200000	4280726	3	10
44355985	1595799	0	0
44350288	1119510	0	0
44353792	1551099	0	0
44355183	1107882	2	3
45632153	1549786	0	0
45655981	1307863	0	0
45626537	1125315	0	0
45666175	1125315	0	0
45624563	1119510	0	0
45639477	1310149	0	0
45690123	1192710	0	0
45671289	1153428	0	0
45688791	1107830	0	0
45674666	19133768	2	3
45782124	1125315	0	0
45780262	1174888	0	0
45699987	1129625	0	0
45802895	1119510	0	0
45895374	1119510	0	0
45796179	1119510	0	0
45895851	1129625	0	0
46318729	967823	0	0
46309112	1112807	0	0
46309937	1125315	0	0
4180169	4294548	4	7
4320791	4280726	2	2
21002491	1595799	0	0
21002846	1112807	0	0
35508871	1177480	0	0
36157377	1125315	0	0
36303153	4132546	6	10
37200000	260139	3	10
44355985	1521369	0	0
44350343	1119510	0	0
44353913	1177480	0	0
44337411	1107882	2	3
45632153	1595799	0	0
45655986	1149196	0	0
45626784	1125315	0	0
45666177	1125315	0	0
45624863	1119510	0	0
45639489	1149196	0	0
45690178	1192710	0	0
45671510	791967	0	0
45688763	914335	0	0
45674777	40232448	2	3
45782023	1125315	0	0
45780289	933724	0	0
45700251	1129625	0	0
45802774	1119510	0	0
45895297	1119510	0	0
45796274	1119510	0	0
45896083	1129625	0	0
46318894	1308738	0	0
46309120	1000560	0	0
46310156	1125315	0	0
4180169	4280726	4	7
4278510	4197460	2	2
21002491	19054876	0	0
21002865	1125315	0	0
35508837	1125315	0	0
36157378	1125315	0	0
36303153	4056621	6	10
37200000	255848	3	9
44355985	1549786	0	0
44350244	1119510	0	0
44353621	1332418	0	0
44343872	1107882	2	3
45632153	1521369	0	0
45655821	914335	0	0
45626605	1125315	0	0
45663610	1125315	0	0
45624867	1119510	0	0
45639491	1149196	0	0
45690085	1192710	0	0
45671588	1149196	0	0
45688853	791967	0	0
45674783	1154615	2	3
45781958	1125315	0	0
45780291	708298	0	0
45697773	1129625	0	0
45802778	1119510	0	0
45895443	1119510	0	0
45796437	1119510	0	0
45804140	1129625	0	0
46318901	1738521	0	0
46309122	1500211	0	0
46310159	1125315	0	0
4181322	4336464	4	7
21000912	19133905	2	3
21002425	1746114	0	0
21002880	1759842	0	0
35508839	1000560	0	0
36151910	1125315	0	0
36303153	261325	6	11
37200000	28060	3	9
44355989	1129625	0	0
44350452	1119510	0	0
44353939	738818	0	0
44347777	1107882	2	3
45631900	1000560	0	0
45655750	738818	0	0
45626619	1125315	0	0
45663616	1125315	0	0
45624878	1119510	0	0
45639496	1545958	0	0
45688408	1192710	0	0
45671592	1539403	0	0
45688833	967823	0	0
45674912	1115171	2	3
45781960	1125315	0	0
45780234	967823	0	0
45696901	1129625	0	0
45802861	1119510	0	0
45895266	1119510	0	0
45790725	1119510	0	0
45804223	1129625	0	0
46319000	975125	0	0
46309165	1545958	0	0
46309769	1125315	0	0
4180628	40479768	6	7
21000912	19133873	2	3
21002436	1717327	0	0
21002880	1778162	0	0
35508735	1557272	0	0
36152267	1125315	0	0
36303153	4152936	6	11
37200000	4283893	3	8
44355625	1551099	0	0
44350395	1119510	0	0
44353916	914335	0	0
44341489	19078461	2	3
45631756	1322184	0	0
45655934	1153428	0	0
45626665	1125315	0	0
45663618	1125315	0	0
45624879	1119510	0	0
45639401	1192710	0	0
45688730	1192710	0	0
45671277	1717327	0	0
45688793	1539403	0	0
45671682	19133905	2	3
45782056	1125315	0	0
45780235	1000560	0	0
45697018	1129625	0	0
45802730	1119510	0	0
45894650	1119510	0	0
45790730	1119510	0	0
45804248	1129625	0	0
46319189	1192710	0	0
46309182	1551099	0	0
46309781	1125315	0	0
4163873	4181917	2	2
21000907	40163554	2	3
21002374	1738521	0	0
21002842	1551099	0	0
35508982	1738521	0	0
36151921	1125315	0	0
36303153	4294548	6	12
37200000	441267	3	7
44355628	975125	0	0
44350249	1119510	0	0
44345925	1332418	0	0
45620492	1107882	2	3
45632036	1149196	0	0
45655722	1124957	0	0
45626777	1125315	0	0
45663628	1125315	0	0
45624592	1119510	0	0
45639424	1515774	0	0
45687091	1192710	0	0
45671278	1310149	0	0
45688812	1115008	0	0
45671686	19008572	2	3
45782141	1125315	0	0
45780238	742185	0	0
45697037	1129625	0	0
45802913	1119510	0	0
45803298	1119510	0	0
45791011	1119510	0	0
45803916	1129625	0	0
46318646	1308738	0	0
46309108	1539403	0	0
46310059	1125315	0	0
4134134	4132546	2	2
21000931	19078924	2	3
21002421	1746114	0	0
21002845	1112807	0	0
35508845	1125315	0	0
36151923	1125315	0	0
36303153	4285898	6	13
37000000	198199	3	7
44356061	1112807	0	0
44350690	1119510	0	0
44346081	1107830	0	0
45651818	19078461	2	3
45632037	1310149	0	0
45655726	1549786	0	0
45626716	1125315	0	0
45663652	1125315	0	0
45624784	1119510	0	0
45639424	1549786	0	0
45684213	1192710	0	0
45671279	1192710	0	0
45688834	1713332	0	0
45671838	1127433	2	3
45782006	1125315	0	0
45780242	1307863	0	0
45697231	1129625	0	0
45802921	1119510	0	0
45803342	1119510	0	0
45790779	1119510	0	0
45803853	1129625	0	0
46318776	1192710	0	0
46309206	1107830	0	0
46310007	1125315	0	0
4188066	4314290	2	2
21000931	19076374	2	3
21002422	1746114	0	0
21002863	1115008	0	0
35508845	1174888	0	0
36157756	1125315	0	0
36303153	40479768	9	12
37600000	317576	3	7
44356062	1759842	0	0
44350492	1119510	0	0
44346067	1112807	0	0
45649268	19078461	2	3
45632118	1549786	0	0
45655726	1595799	0	0
45626835	1125315	0	0
45663655	1125315	0	0
45624536	1119510	0	0
45639426	1551099	0	0
45654965	1112807	0	0
45671237	1589505	0	0
45688834	1759842	0	0
45671942	1127433	2	3
45782008	1125315	0	0
45780253	975125	0	0
45693847	1129625	0	0
45803052	1119510	0	0
45803429	1119510	0	0
45790824	1119510	0	0
45798788	1129625	0	0
46312454	975125	0	0
46309382	914335	0	0
46304466	1125315	0	0
4179922	439777	2	2
21001380	1713671	2	3
21002332	920293	0	0
21002863	1125315	0	0
35508846	1119510	0	0
36157761	1125315	0	0
36303153	4144583	9	9
37202317	4112343	3	6
44356111	1129625	0	0
44350605	1119510	0	0
44346002	1115008	0	0
44344813	40228214	2	3
45632118	19127890	0	0
45655726	1521369	0	0
45626979	1125315	0	0
45663735	1125315	0	0
45624913	1119510	0	0
45639431	1310149	0	0
45700759	1112807	0	0
45671410	1174888	0	0
45688874	1174888	0	0
45671977	19019979	2	3
45782208	1125315	0	0
45780266	1124957	0	0
45694167	1129625	0	0
45802993	1119510	0	0
45803357	1119510	0	0
45790975	1119510	0	0
45798924	1129625	0	0
46312926	1107830	0	0
46309387	1192710	0	0
46304428	1125315	0	0
4180175	4301346	2	2
21000830	1551192	2	3
21002350	1768849	0	0
21003153	738818	0	0
35508846	1125315	0	0
36157763	1125315	0	0
36303153	4145310	5	5
37202317	4294548	3	6
44356062	1713332	0	0
44346468	1119510	0	0
44346008	1551099	0	0
45661826	19078461	2	3
45632103	1174888	0	0
45655780	740275	0	0
45626868	1125315	0	0
45663761	1125315	0	0
45668463	1119510	0	0
45639432	19078219	0	0
45701538	1112807	0	0
45671444	738818	0	0
45688816	19127890	0	0
45672108	40232448	2	3
45782011	1125315	0	0
45780202	975125	0	0
45693859	1129625	0	0
45800135	1119510	0	0
45803452	1119510	0	0
45791037	1119510	0	0
45799681	1129625	0	0
46312406	1713332	0	0
46309450	967823	0	0
46304430	1125315	0	0
4180170	4283893	2	2
21000474	19008572	2	3
21002410	1746114	0	0
21003153	1115008	0	0
35508949	1125315	0	0
36157347	1125315	0	0
36303153	80180	5	7
36703500	4132546	3	6
44356063	1192710	0	0
44346648	1119510	0	0
44346099	791967	0	0
44341563	1332419	2	3
45632105	967823	0	0
45655782	1149196	0	0
45626887	1125315	0	0
45663772	1125315	0	0
45668794	1119510	0	0
45639433	1308738	0	0
45701565	1112807	0	0
45669875	1539403	0	0
45688816	1512674	0	0
45672071	40174880	2	3
45782189	1125315	0	0
45780272	1174888	0	0
45694038	1129625	0	0
45800137	1119510	0	0
45803505	1119510	0	0
45791887	1119510	0	0
45799845	1129625	0	0
46312525	975125	0	0
46309359	1107830	0	0
46304445	1125315	0	0
4193318	4112343	2	2
21000474	1551192	2	3
21001738	1149196	0	0
21003174	1119510	0	0
35506856	1713332	0	0
36157361	1125315	0	0
36303153	4029498	5	8
36718338	4001336	3	6
44355637	715997	0	0
44346749	1119510	0	0
44346102	1112807	0	0
44348218	1332419	2	3
45631740	1343916	0	0
45655737	1192710	0	0
45623286	1125315	0	0
45663701	1125315	0	0
45668704	1119510	0	0
45639446	1310149	0	0
45701613	1112807	0	0
45669813	1107830	0	0
45688816	1549786	0	0
45671784	19008572	2	3
45779575	1125315	0	0
45780334	1107830	0	0
45694187	1129625	0	0
45799916	1119510	0	0
45803481	1119510	0	0
45791895	1119510	0	0
45799045	1129625	0	0
46312544	1307863	0	0
46309360	920293	0	0
46304477	1125315	0	0
4193169	40481087	2	2
21001379	19073188	2	3
21001738	738818	0	0
21003174	1149196	0	0
35506797	140673	0	0
36157363	1125315	0	0
36303153	317576	5	11
37200000	317009	3	5
44355881	1310149	0	0
44346533	1119510	0	0
44346115	701322	0	0
44350812	40228214	2	3
45631746	1332418	0	0
45655889	1124300	0	0
45623294	1125315	0	0
45663323	1125315	0	0
45668718	1119510	0	0
45639450	738818	0	0
45701742	1112807	0	0
45669729	1501700	0	0
45688859	1332418	0	0
45671874	40169281	2	3
45779589	1125315	0	0
45780275	1115008	0	0
45694010	1129625	0	0
45800114	1119510	0	0
45803495	1119510	0	0
45791922	1119510	0	0
45793489	1129625	0	0
46313165	1115008	0	0
46309393	1000560	0	0
46304629	1125315	0	0
4189544	4024958	2	2
21001379	19133873	2	3
21001739	1778162	0	0
21003174	1153428	0	0
35506858	1177480	0	0
36157364	1125315	0	0
36303153	257012	5	11
37202310	261325	3	5
44355781	1112807	0	0
44346537	1119510	0	0
44346117	1153428	0	0
44351287	19075601	2	3
45628761	1738521	0	0
45656022	1115008	0	0
45623295	1125315	0	0
45663324	1125315	0	0
45668873	1119510	0	0
45639463	1110410	0	0
45701643	1112807	0	0
45669826	1192710	0	0
45688863	738818	0	0
45783885	1115171	2	3
45779698	1125315	0	0
45780307	1192710	0	0
45694012	1129625	0	0
45800026	1119510	0	0
45800751	1119510	0	0
45792039	1119510	0	0
45793517	1129625	0	0
46312690	791967	0	0
46309366	1124957	0	0
46304639	1125315	0	0
4130851	4113008	2	2
21001379	19073183	2	3
21001692	1310149	0	0
21003205	1119510	0	0
35506815	1129625	0	0
36157427	1125315	0	0
36303153	4237458	5	11
37002287	4116491	3	5
44355646	1738521	0	0
44346539	1119510	0	0
44346015	1501700	0	0
44355091	19075601	2	3
45628442	1332418	0	0
44348222	742185	0	0
45623338	1125315	0	0
45663416	1125315	0	0
45668876	1119510	0	0
45639590	1149196	0	0
45701762	1112807	0	0
45669831	1738521	0	0
45689001	1343916	0	0
45783895	19133873	2	3
45779523	1125315	0	0
45780357	1521369	0	0
45694403	1129625	0	0
45800120	1119510	0	0
45800652	1119510	0	0
45791078	1119510	0	0
45793687	1129625	0	0
46313177	1192710	0	0
46303394	1343916	0	0
46304668	1125315	0	0
4130851	4278672	2	2
21000408	1551192	2	3
21001738	1119510	0	0
21003156	1125315	0	0
35506918	1119510	0	0
36157437	1125315	0	0
36303153	4280726	5	12
37502347	4117038	3	5
44355884	1149380	0	0
44346763	1119510	0	0
44346121	1115008	0	0
44343706	19075601	2	3
45628704	1332418	0	0
44348124	1124957	0	0
45623373	1125315	0	0
45663889	1125315	0	0
45668895	1119510	0	0
45639606	1501700	0	0
45698513	1112807	0	0
45669833	1717327	0	0
45689018	1107830	0	0
45783958	1115171	2	3
45779649	1125315	0	0
45780230	1326303	0	0
45691047	1129625	0	0
45800256	1119510	0	0
45800897	1119510	0	0
46294580	1119510	0	0
45793626	1129625	0	0
46312531	1115008	0	0
46303521	1332418	0	0
46305172	1125315	0	0
4190185	30753	2	2
21001378	19075001	2	3
21001744	1713332	0	0
21003156	1112807	0	0
35506918	738818	0	0
36157410	1125315	0	0
36303153	439777	4	9
37202320	40486433	3	5
44355810	1129625	0	0
44346764	1119510	0	0
44346167	791967	0	0
45655863	19079524	2	3
45628450	1107830	0	0
44348253	705944	0	0
45623479	1125315	0	0
45663894	1125315	0	0
45668954	1119510	0	0
45639598	1000560	0	0
45698681	1112807	0	0
45669847	1361711	0	0
45688911	1153428	0	0
45783905	19018935	2	3
45779730	1125315	0	0
45780400	19003953	0	0
45691025	1129625	0	0
45800262	1119510	0	0
45800931	1119510	0	0
46294808	1119510	0	0
45793790	1129625	0	0
46312853	1738521	0	0
46303861	1174888	0	0
46305184	1125315	0	0
4093228	4149245	2	2
21001378	1713671	2	3
21001741	1778162	0	0
21003153	1119510	0	0
35506817	1545958	0	0
36157412	1125315	0	0
36303153	80809	4	8
37202317	40481087	3	5
44355813	1308738	0	0
44346782	1119510	0	0
44346176	1129625	0	0
44351368	19078461	2	3
45628451	715997	0	0
44348254	1153428	0	0
45623363	1125315	0	0
45663897	1125315	0	0
45668923	1119510	0	0
45639601	740275	0	0
45699028	1112807	0	0
45669852	1192710	0	0
45688978	1107830	0	0
45783998	1115171	2	3
45779800	1125315	0	0
45780277	1174888	0	0
45688631	1129625	0	0
45800382	1119510	0	0
45801014	1119510	0	0
46294175	1119510	0	0
45793853	1129625	0	0
46312866	1548195	0	0
46303865	1124957	0	0
46304500	1125315	0	0
4134148	4238715	2	2
21001378	19073188	2	3
21001738	1150836	0	0
21003174	1150770	0	0
35506865	1119510	0	0
36157529	1125315	0	0
36303153	40478878	4	5
37003663	198199	3	5
44355912	967823	0	0
44346685	1119510	0	0
44346178	1174888	0	0
44347812	1539411	2	3
45628750	1307863	0	0
44348259	1548195	0	0
45623420	1125315	0	0
45663428	1125315	0	0
45668963	1119510	0	0
45639533	1174888	0	0
45694390	1112807	0	0
45669853	1308738	0	0
45688982	1501700	0	0
45783928	43012036	2	3
45779409	1125315	0	0
45780404	1501700	0	0
45688060	1129625	0	0
45800235	1119510	0	0
45800799	1119510	0	0
46295008	1119510	0	0
45793815	1129625	0	0
46312942	1174888	0	0
46303928	933724	0	0
46304945	1125315	0	0
4043160	44805732	2	2
21000873	1551192	2	3
21001738	1107830	0	0
21003156	1129625	0	0
35506865	1125315	0	0
36157536	1125315	0	0
36303153	4246502	4	4
37003663	195588	3	6
44355992	1174888	0	0
44346617	1119510	0	0
44346179	1177480	0	0
44347450	19078461	2	3
45628600	738818	0	0
44348218	1332418	0	0
45623422	1125315	0	0
45663439	1125315	0	0
45668728	1119510	0	0
45639534	1192710	0	0
45692481	1112807	0	0
45669864	1549786	0	0
45689026	1549786	0	0
45784000	19008572	2	3
45779633	1125315	0	0
45780550	1551099	0	0
45688065	1129625	0	0
45800067	1119510	0	0
45800781	1119510	0	0
46295010	1119510	0	0
45788375	1129625	0	0
46312958	1174888	0	0
46303930	1000560	0	0
46304511	1125315	0	0
4048375	4330583	2	2
21000436	1551192	2	3
21001740	1778162	0	0
21003156	738818	0	0
35506874	705944	0	0
36157475	1125315	0	0
36303153	4151422	4	4
36718338	380378	3	4
44355917	1112807	0	0
44346713	1119510	0	0
44346190	1129625	0	0
45620855	1539411	2	3
45628708	1124300	0	0
44348191	933724	0	0
45623625	1125315	0	0
45663442	1125315	0	0
45668749	1119510	0	0
45639542	1741122	0	0
45692490	1112807	0	0
45669874	19127890	0	0
45689026	19127890	0	0
45784063	1115171	2	3
45779742	1125315	0	0
45780421	1361711	0	0
45688093	1129625	0	0
45802225	1119510	0	0
45800937	1119510	0	0
46294957	1119510	0	0
45788353	1129625	0	0
46313096	1551099	0	0
46303936	1000560	0	0
46304680	1125315	0	0
4093991	81151	4	8
21000890	46275444	2	3
21001743	1713332	0	0
21003156	1192710	0	0
35506926	1177480	0	0
36157754	1125315	0	0
36303153	4133840	4	4
36718588	381316	3	4
44355920	1118084	0	0
44346146	1119510	0	0
44346200	1332418	0	0
45661844	19079524	2	3
45628711	1000560	0	0
44348405	975125	0	0
45623645	1125315	0	0
45663844	1125315	0	0
45668880	1119510	0	0
45639612	1192710	0	0
45692716	1112807	0	0
45669874	1589505	0	0
45689026	1515774	0	0
45784174	40232448	2	3
45779803	1125315	0	0
45777763	1729720	0	0
45684964	1129625	0	0
45802436	1119510	0	0
45801090	1119510	0	0
46294430	1119510	0	0
45788543	1129625	0	0
46313042	1717327	0	0
46303937	1107830	0	0
46304929	1125315	0	0
4040400	4336464	5	8
21000890	1713671	2	3
21001750	1713332	0	0
21003205	1174888	0	0
21605050	1149380	0	0
36157499	1125315	0	0
36303153	4015189	3	7
36718588	4066995	3	4
44356127	1557272	0	0
44346829	1119510	0	0
44346153	738818	0	0
45649228	1539411	2	3
45628684	1549786	0	0
44348194	1110410	0	0
45667568	1125315	0	0
45663550	1125315	0	0
45668882	1119510	0	0
45639628	975125	0	0
45689599	1112807	0	0
45669874	1549786	0	0
45686027	723013	0	0
45784240	1115171	2	3
45779590	1125315	0	0
45777810	1589505	0	0
45684937	1129625	0	0
45802437	1119510	0	0
45801046	1119510	0	0
46294677	1119510	0	0
45788615	1129625	0	0
46313104	1154029	0	0
46306441	933724	0	0
46304936	1125315	0	0
4043022	4330583	4	8
21000874	1551192	2	3
21001749	1717327	0	0
21003205	1112807	0	0
21604191	782043	0	0
36157741	1125315	0	0
36303153	4010253	3	7
36703500	4029498	3	4
44356001	1110410	0	0
44346830	1119510	0	0
44346344	1129625	0	0
45620429	40228230	2	3
45628684	1515774	0	0
44348409	738818	0	0
45667655	1125315	0	0
45663746	1125315	0	0
45670354	1119510	0	0
45639594	1728416	0	0
45689802	1112807	0	0
45669673	715997	0	0
45686038	1110410	0	0
45783942	40228230	2	3
45779705	1125315	0	0
45777707	1308738	0	0
45685137	1129625	0	0
45802278	1119510	0	0
45800774	1119510	0	0
46294767	1119510	0	0
45788317	1129625	0	0
46313107	1124300	0	0
46306448	1738521	0	0
46321017	1125315	0	0
4043161	4336464	6	8
21000404	1551192	2	3
21001766	1174888	0	0
21003205	1192710	0	0
21604192	19002770	0	0
36157637	1125315	0	0
36303153	4012477	3	6
36718119	378419	3	4
44355844	1149196	0	0
44346839	1119510	0	0
44346258	738818	0	0
45620429	40228214	2	3
45628625	1102527	0	0
44348200	738818	0	0
45667573	1125315	0	0
45663449	1125315	0	0
45666595	1119510	0	0
45639651	1174888	0	0
45689731	1112807	0	0
45669780	1326303	0	0
45686042	1102527	0	0
45782075	40232448	2	3
45779692	1125315	0	0
45777709	1549786	0	0
45684790	1129625	0	0
45800422	1119510	0	0
45800777	1119510	0	0
46244039	1119510	0	0
45788349	1129625	0	0
46313194	1115008	0	0
46306951	967823	0	0
46321559	1125315	0	0
4180169	4112343	4	8
21000702	1545959	2	3
21001745	1713332	0	0
21002036	1713332	0	0
21604193	19039298	0	0
36157699	1125315	0	0
36303153	4052083	3	3
37202316	317009	3	4
44355921	1343916	0	0
44346288	1119510	0	0
44346525	1305058	0	0
45620676	40228214	2	3
45631131	1501700	0	0
44348265	1545958	0	0
45667842	1125315	0	0
45660205	1125315	0	0
45666729	1119510	0	0
45639652	1174888	0	0
45689783	1112807	0	0
45669787	1322184	0	0
45686047	1332418	0	0
45782076	44816277	2	3
45779760	1125315	0	0
45777709	19127890	0	0
45685094	1129625	0	0
45797326	1119510	0	0
45801039	1119510	0	0
46244043	1119510	0	0
45788570	1129625	0	0
46313140	708298	0	0
46307069	1307863	0	0
46320827	1125315	0	0
4180169	258780	4	8
21000702	1539411	2	3
21001743	1759842	0	0
21002025	1713332	0	0
21603497	1149196	0	0
36157564	1125315	0	0
36300000	192671	5	10
37003663	4116491	3	4
44355922	1124957	0	0
44346410	1119510	0	0
44346204	1192710	0	0
44354798	40228214	2	3
45631136	1521369	0	0
45651975	1192710	0	0
45667800	1125315	0	0
45660219	1125315	0	0
45666731	1119510	0	0
45639527	1149196	0	0
45689852	1112807	0	0
45670405	705944	0	0
45686050	1549786	0	0
45782117	42707627	2	3
45779812	1125315	0	0
45777709	1589505	0	0
45685552	1129625	0	0
45797525	1119510	0	0
45801083	1119510	0	0
46244100	1119510	0	0
45788505	1129625	0	0
46313144	975125	0	0
46304046	715997	0	0
46321184	1125315	0	0
4047779	378419	5	8
21000375	1551192	2	3
21001757	1768849	0	0
21500864	1343916	0	0
21603513	1150836	0	0
36157574	1125315	0	0
36300000	4058899	5	10
36703483	4043241	3	3
44355933	975125	0	0
44346299	1119510	0	0
44346154	1310149	0	0
44354639	40228214	2	3
45631136	1595799	0	0
45651976	1741122	0	0
45667936	1125315	0	0
45660371	1125315	0	0
45666864	1119510	0	0
45639528	975125	0	0
45686624	1112807	0	0
45670409	715997	0	0
45686050	19127890	0	0
45781948	1551192	2	3
45779823	1125315	0	0
45777720	1115008	0	0
45685840	1129625	0	0
45797544	1119510	0	0
45800888	1119510	0	0
46244101	1119510	0	0
45788678	1129625	0	0
46313147	1149196	0	0
46304049	975125	0	0
46321191	1125315	0	0
4180628	440448	5	8
21000471	1551192	2	3
21001738	1112807	0	0
21500927	975125	0	0
21603514	1107830	0	0
36157578	1125315	0	0
36300000	4010253	4	9
40782473	3000876	3	3
44356036	1112807	0	0
44346790	1119510	0	0
44346209	1729720	0	0
44347162	40228214	2	3
45631136	1549786	0	0
45651976	1746114	0	0
45667738	1125315	0	0
45660383	1125315	0	0
45664075	1119510	0	0
45639475	740275	0	0
45686631	1112807	0	0
45670610	723013	0	0
45686050	1521369	0	0
45781919	43012036	2	3
45779766	1125315	0	0
45777725	967823	0	0
45682152	1129625	0	0
45797577	1119510	0	0
45800993	1119510	0	0
46244075	1119510	0	0
45788655	1129625	0	0
46312628	1343916	0	0
46304050	1153428	0	0
46321331	1125315	0	0
4117930	4285898	4	9
21000472	19007333	2	3
21001743	1717327	0	0
21500889	975125	0	0
21602800	1738521	0	0
36157766	1125315	0	0
36300000	4024289	6	9
40772883	3001488	3	3
44356177	1177480	0	0
44346792	1119510	0	0
44346243	1124957	0	0
44347162	40228230	2	3
45630830	1539403	0	0
45652231	1102527	0	0
45667742	1125315	0	0
45660340	1125315	0	0
45664390	1119510	0	0
45639569	1332418	0	0
45686846	1112807	0	0
45670583	914335	0	0
45686143	967823	0	0
45779563	43012036	2	3
45779792	1125315	0	0
45777640	920293	0	0
45682155	1129625	0	0
45797735	1119510	0	0
45801150	1119510	0	0
46244165	1119510	0	0
45788661	1129625	0	0
46313259	1115008	0	0
46304215	1174888	0	0
46321451	1125315	0	0
4093991	78272	4	9
21000472	1551192	2	3
21001749	1713332	0	0
21500892	975125	0	0
21602016	1129625	0	0
36157643	1125315	0	0
36300000	4252419	6	9
40772617	3008598	3	3
44356081	1124300	0	0
44348446	1119510	0	0
44346160	1129625	0	0
44347677	40228214	2	3
45631094	1107830	0	0
45651820	1115008	0	0
45667743	1125315	0	0
45660334	1125315	0	0
45664393	1119510	0	0
45639589	1149380	0	0
45686941	1112807	0	0
45670278	1545958	0	0
45685623	1154343	0	0
45779589	40162522	2	3
45779884	1125315	0	0
45777656	1115008	0	0
45682381	1129625	0	0
45797845	1119510	0	0
45799770	1119510	0	0
46244175	1119510	0	0
46297507	1129625	0	0
46312733	1501700	0	0
46304229	975125	0	0
46321080	1125315	0	0
4042140	4237458	3	9
4301351	4323902	2	6
21001749	1759842	0	0
21500973	975125	0	0
35508949	1177480	0	0
36157710	1125315	0	0
36300000	134438	6	11
37203740	260139	3	3
44356118	1110410	0	0
44348382	1119510	0	0
44346320	1115008	0	0
44347677	40228230	2	3
45631102	1153428	0	0
45651821	1738521	0	0
45667837	1125315	0	0
45660392	1125315	0	0
45664309	1119510	0	0
45639589	1137529	0	0
45686815	1112807	0	0
45669942	1107830	0	0
45685987	1396131	0	0
45779644	1115171	2	3
45779660	1125315	0	0
45777796	975125	0	0
45682349	1129625	0	0
45797599	1119510	0	0
45799716	1119510	0	0
46244232	1119510	0	0
46297934	1129625	0	0
46312630	914335	0	0
46304117	1551099	0	0
46321354	1125315	0	0
4042140	380378	4	7
4301351	4117038	2	6
21001750	1728416	0	0
21500954	1129625	0	0
35508985	1119510	0	0
36157616	1125315	0	0
36300000	80809	6	10
37003668	198199	3	3
44356119	1545958	0	0
44342766	1119510	0	0
44346326	975125	0	0
44354620	40223768	2	3
45630976	1713332	0	0
45649324	1174888	0	0
45667838	1125315	0	0
45660504	1125315	0	0
45778196	1119510	0	0
45639672	1154029	0	0
45686809	1112807	0	0
45669927	1192710	0	0
45686104	1500211	0	0
45779737	1115171	2	3
45779602	1125315	0	0
45777797	723013	0	0
45682191	1129625	0	0
45797698	1119510	0	0
45798088	1119510	0	0
46244286	1119510	0	0
46298219	1129625	0	0
46312683	975125	0	0
46304072	975125	0	0
46321224	1125315	0	0
4042140	257012	4	9
4301351	4163971	2	7
21001757	1729720	0	0
21501001	967823	0	0
35508985	738818	0	0
36157621	1125315	0	0
36300000	40478878	6	7
36718163	4043241	3	3
44356122	1501700	0	0
44342777	1119510	0	0
44346327	1129625	0	0
45655524	1539411	2	3
45631023	1107830	0	0
45649327	1174888	0	0
45667546	1125315	0	0
45660505	1125315	0	0
45661833	1119510	0	0
45639676	914335	0	0
45683577	1112807	0	0
45669901	1000560	0	0
45686169	1305058	0	0
45779742	40162522	2	3
45779920	1125315	0	0
45777804	1124300	0	0
45682369	1129625	0	0
45797861	1119510	0	0
45798185	1119510	0	0
46244289	1119510	0	0
46298169	1129625	0	0
46312841	705944	0	0
46304080	1153428	0	0
46321203	1125315	0	0
4042140	30753	4	8
4171379	198199	2	4
21001746	1713332	0	0
21003205	1129625	0	0
35508990	1129625	0	0
36158064	1125315	0	0
36300000	44782520	7	10
37003664	4056621	3	3
44356182	1343916	0	0
44342760	1119510	0	0
44346302	1149196	0	0
44347738	40228214	2	3
45631220	1149380	0	0
45649408	1174888	0	0
45668017	1125315	0	0
45660506	1125315	0	0
45661649	1119510	0	0
45639542	1746114	0	0
45683720	1112807	0	0
45669976	1192710	0	0
45686172	1115008	0	0
45779747	1115171	2	3
45779923	1125315	0	0
45777790	1192710	0	0
45682124	1129625	0	0
45794855	1119510	0	0
45798069	1119510	0	0
46244373	1119510	0	0
46298237	1129625	0	0
46312878	1000560	0	0
46304087	1322184	0	0
46321473	1125315	0	0
4042140	4132546	4	8
4309188	30753	2	4
21001746	1759842	0	0
21003217	1129625	0	0
35508992	1738521	0	0
36158115	1125315	0	0
36300000	4047491	7	10
37003664	198199	3	3
44356186	1309944	0	0
44342788	1119510	0	0
44346309	1112807	0	0
44362456	40223768	2	3
45628783	1107830	0	0
45649411	757627	0	0
45667163	1125315	0	0
45660359	1125315	0	0
45661673	1119510	0	0
45639680	1107830	0	0
45683888	1112807	0	0
45669903	1124300	0	0
45685762	1000560	0	0
45779803	40229134	2	3
45708118	1125315	0	0
45777791	1154343	0	0
45678881	1129625	0	0
45797135	1119510	0	0
45798261	1119510	0	0
46244384	1119510	0	0
46298178	1129625	0	0
46313032	1310149	0	0
46304307	1308738	0	0
46320954	1125315	0	0
4042140	4035415	4	8
4301347	4301346	1	1
21001753	1768849	0	0
21002884	1746114	0	0
35508994	791967	0	0
36158076	1125315	0	0
36300000	4027663	7	11
40779671	3026361	3	3
44356190	738818	0	0
44342874	1119510	0	0
44346313	1124957	0	0
44354923	19078461	2	3
45628822	1124957	0	0
45649556	975125	0	0
45667219	1125315	0	0
45660347	1125315	0	0
45661767	1119510	0	0
45639660	715997	0	0
45683932	1112807	0	0
45670023	1501700	0	0
45685768	1713332	0	0
45779837	19008572	2	3
45708354	1125315	0	0
45777634	1124300	0	0
45678862	1129625	0	0
45797188	1119510	0	0
45798397	1119510	0	0
46244402	1119510	0	0
46298339	1129625	0	0
46312649	967823	0	0
46304608	1545958	0	0
46320967	1125315	0	0
4042140	81151	5	10
4301347	44783196	1	1
21001757	1713332	0	0
21002894	1717327	0	0
35508935	1153428	0	0
36158023	1125315	0	0
36300000	317009	7	8
37503950	4043071	3	3
44356207	1129625	0	0
44342964	1119510	0	0
44346244	975125	0	0
44362563	19078461	2	3
45628825	1778162	0	0
45649574	738818	0	0
45667193	1125315	0	0
45660416	1125315	0	0
45661320	1119510	0	0
45639856	1124300	0	0
45684007	1112807	0	0
45781234	791967	0	0
45685769	738818	0	0
45708337	19019273	2	3
45708207	1125315	0	0
45777741	975125	0	0
45678746	1129625	0	0
45797190	1119510	0	0
45798508	1119510	0	0
46239161	1119510	0	0
46298382	1129625	0	0
46313034	1343916	0	0
46304281	1549786	0	0
46321582	1125315	0	0
4042140	4294548	5	10
4214956	45766064	1	1
21001758	1728416	0	0
21002894	1741122	0	0
35509025	1107830	0	0
36157982	1125315	0	0
36300000	4237458	7	13
40782921	3019406	3	3
44356224	1322184	0	0
44343084	1119510	0	0
44346245	975125	0	0
44348023	19078461	2	3
45628781	1738521	0	0
45649264	975125	0	0
45667249	1125315	0	0
45660422	1125315	0	0
45777849	1119510	0	0
45639549	1361711	0	0
45680558	1112807	0	0
45781326	1000560	0	0
45685971	1110410	0	0
45777957	920334	2	3
45708348	1125315	0	0
45777746	1192710	0	0
45706689	1119510	0	0
45795027	1119510	0	0
45795393	1119510	0	0
46239175	1119510	0	0
46298545	1129625	0	0
46312795	1115008	0	0
46304281	19127890	0	0
46321585	1125315	0	0
4042140	440448	5	10
19057704	19128263	1	1
21001751	1717327	0	0
21002894	1778162	0	0
35508873	1124300	0	0
36158237	1125315	0	0
36300000	198809	7	13
37019273	195588	3	3
44356245	701322	0	0
44342796	1119510	0	0
44346479	975125	0	0
45661755	19078461	2	3
45628788	1124300	0	0
45649216	1713332	0	0
45665454	1125315	0	0
45660431	1125315	0	0
45777823	1119510	0	0
45639551	1308738	0	0
45680671	1112807	0	0
45781278	738818	0	0
45685779	1174888	0	0
45777970	19059056	2	3
45777918	1125315	0	0
45777704	1521369	0	0
45706693	1119510	0	0
45795053	1119510	0	0
45795561	1119510	0	0
46239371	1119510	0	0
46298300	1129625	0	0
46312812	1309944	0	0
46304197	975125	0	0
46321588	1125315	0	0
4042140	40480160	5	9
19057704	19128022	1	1
21001757	1759842	0	0
21002894	1746114	0	0
35508874	1551099	0	0
36158073	1125315	0	0
36300000	257012	7	13
40797982	3004501	3	3
44356246	1153428	0	0
44343134	1119510	0	0
44346221	1539403	0	0
44354919	19078461	2	3
45628795	1307863	0	0
45649220	1501700	0	0
45665581	1125315	0	0
45660438	1125315	0	0
45654850	1119510	0	0
45639913	1174888	0	0
45682260	1112807	0	0
45781281	723013	0	0
45686206	1539403	0	0
45705861	19008572	2	3
45778205	1125315	0	0
45777704	19127890	0	0
45705287	1119510	0	0
45795089	1119510	0	0
45795570	1119510	0	0
46239433	1119510	0	0
46289703	1129625	0	0
46312928	1192710	0	0
46304287	791967	0	0
46321590	1125315	0	0
4042140	4146173	5	9
4337138	4337611	1	1
21001744	1759842	0	0
21002902	1557272	0	0
35508877	1125315	0	0
36157977	1125315	0	0
36300000	4280726	7	14
37202310	4051466	3	3
44356040	19127890	0	0
44343004	1119510	0	0
44346229	1129625	0	0
44362331	19078461	2	3
45628841	1501700	0	0
45649222	1307863	0	0
45665677	1125315	0	0
45660475	1125315	0	0
45635051	1177480	0	0
45639559	1343916	0	0
45677489	1112807	0	0
45781273	1124957	0	0
45686142	1501700	0	0
45705769	40232448	2	3
45778139	1125315	0	0
45777704	1549786	0	0
45705238	1119510	0	0
45795149	1119510	0	0
45795579	1119510	0	0
46239533	1119510	0	0
46290057	1129625	0	0
46312929	1153428	0	0
46304302	1000560	0	0
46321595	1125315	0	0
4042140	198809	5	9
4340361	4166224	1	1
21001769	1738521	0	0
21002885	1746114	0	0
35508945	1125315	0	0
36103041	198199	6	6
36300000	80180	7	9
40772892	3049273	3	3
44356040	1589505	0	0
44343011	1119510	0	0
44346261	1549786	0	0
44357763	19078461	2	3
45628890	1332418	0	0
44337912	1177480	0	0
45665682	1125315	0	0
45660571	1125315	0	0
45635028	1177480	0	0
45639804	1192710	0	0
45677484	1112807	0	0
45781385	1713332	0	0
45686180	1115008	0	0
45706088	40232448	2	3
45777960	1125315	0	0
45777751	1154343	0	0
45705267	1119510	0	0
45795057	1119510	0	0
45795546	1119510	0	0
46239547	1119510	0	0
46290270	1129625	0	0
46312931	1717327	0	0
46304356	1343916	0	0
46321614	1125315	0	0
4042140	4266809	5	8
4261784	81893	1	1
21001769	1713332	0	0
21002895	1557272	0	0
35508945	1119510	0	0
36102970	433125	6	6
36300000	40479768	11	14
37202312	255848	3	3
44356040	1549786	0	0
44343098	1119510	0	0
44346261	19127890	0	0
44358074	19078461	2	3
45625735	1149196	0	0
44778256	1177480	0	0
45665603	1125315	0	0
45660487	1125315	0	0
45635017	1177480	0	0
45636477	1115008	0	0
45677784	1112807	0	0
45781123	1545958	0	0
45686181	738818	0	0
45706043	1551192	2	3
45777941	1125315	0	0
45777779	1548195	0	0
45780010	1119510	0	0
45792279	1119510	0	0
45795592	1119510	0	0
46239639	1119510	0	0
46290245	1129625	0	0
46313223	738818	0	0
46304314	1000560	0	0
46321619	1125315	0	0
4042140	198199	5	8
4217966	4047491	1	1
21001745	1759842	0	0
21002912	1551099	0	0
35508948	975125	0	0
36102970	28060	6	6
36300000	4218389	8	10
36718588	4029498	3	3
44356047	1149380	0	0
44343173	1119510	0	0
44346261	1515774	0	0
44340037	19078461	2	3
45625844	1332418	0	0
44778258	1177480	0	0
45665737	1125315	0	0
45660616	1125315	0	0
45634991	1177480	0	0
45636299	1107830	0	0
45677864	1112807	0	0
45781335	1343916	0	0
45686155	1000560	0	0
45705901	19077344	2	3
45778031	1125315	0	0
45706372	1503184	0	0
45779967	1119510	0	0
45792360	1119510	0	0
45795646	1119510	0	0
46239560	1119510	0	0
46290294	1129625	0	0
46313224	1149196	0	0
46320092	1521369	0	0
46321657	1125315	0	0
4042140	4156265	5	8
4201402	440448	1	1
21001772	1107830	0	0
21002900	1589505	0	0
35508952	1125315	0	0
36100000	4048171	6	6
36300000	140673	8	10
40779558	3005136	3	3
44356050	1129625	0	0
44343216	1119510	0	0
44346262	1177480	0	0
44340639	19078461	2	3
45625857	1174888	0	0
44778237	1177480	0	0
45665617	1125315	0	0
45660733	1125315	0	0
45635282	1177480	0	0
45636300	1124957	0	0
45674282	1112807	0	0
45781368	1174888	0	0
45685939	967823	0	0
45705992	19008572	2	3
45778000	1125315	0	0
45706372	19127890	0	0
45779679	1119510	0	0
45792364	1119510	0	0
45795649	1119510	0	0
46239580	1119510	0	0
46289670	1129625	0	0
46313079	1174888	0	0
46320092	1549786	0	0
46321664	1125315	0	0
4042140	45769019	6	8
4201540	4108705	1	1
21001770	1149196	0	0
21002900	1500211	0	0
35508960	1119510	0	0
35802131	4156265	6	8
36300000	440086	8	10
37503959	4337138	3	3
44356143	738818	0	0
44343020	1119510	0	0
44346463	1192710	0	0
45655888	19078461	2	3
45625941	1738521	0	0
44358319	1177480	0	0
45665633	1125315	0	0
45660641	1125315	0	0
45635382	1177480	0	0
45636302	1149380	0	0
45676225	1112807	0	0
45781375	967823	0	0
45686006	1110410	0	0
45703694	19078461	2	3
45778003	1125315	0	0
45706372	1521369	0	0
45780195	1119510	0	0
45792427	1119510	0	0
45795690	1119510	0	0
46239679	1119510	0	0
46292015	1129625	0	0
46313084	740275	0	0
46320254	1118084	0	0
46315312	1125315	0	0
4042140	4113008	6	7
19086049	19126352	1	1
21001744	1717327	0	0
21002975	914335	0	0
35508962	1119510	0	0
36102154	4116491	6	8
36300000	80502	8	10
36718119	4132546	3	3
44356057	1124957	0	0
44339274	1119510	0	0
44346463	1112807	0	0
44351125	19078461	2	3
45625563	1115008	0	0
44358502	1177480	0	0
45663134	1125315	0	0
45658565	1125315	0	0
45635345	1177480	0	0
45636366	975125	0	0
45674422	1112807	0	0
45781100	1149196	0	0
45686016	1153428	0	0
45703575	40228214	2	3
45705648	1125315	0	0
45706542	791967	0	0
45780063	1119510	0	0
45792429	1119510	0	0
45796925	1119510	0	0
46239757	1119510	0	0
46242013	1129625	0	0
46307371	1539403	0	0
46320257	1112807	0	0
46315366	1125315	0	0
4042140	378419	6	9
19084040	19077344	1	1
21506158	967823	0	0
21003001	1500211	0	0
35508962	738818	0	0
35202461	4048171	6	9
36300000	4056621	8	12
40782530	3005136	4	4
44356166	1738521	0	0
44339412	1119510	0	0
44346248	1115008	0	0
44354810	19078461	2	3
45625512	1738521	0	0
44358598	1177480	0	0
45663231	1125315	0	0
45658566	1125315	0	0
45629993	1177480	0	0
45636030	1551099	0	0
45674554	1112807	0	0
45781127	1332418	0	0
45685752	1322184	0	0
45703873	19057271	2	3
45705587	1125315	0	0
45706587	1149196	0	0
45780118	1119510	0	0
45792631	1119510	0	0
45796937	1119510	0	0
46239588	1119510	0	0
46242024	1129625	0	0
46307535	1192710	0	0
46320341	1713332	0	0
46315373	1125315	0	0
4180627	4275113	6	8
19084980	19077572	1	1
21506206	1332418	0	0
21002898	1548195	0	0
35508967	1713332	0	0
36200000	40479422	6	11
36300000	4132546	8	12
37503959	4323902	4	4
44356158	1124300	0	0
44339606	1119510	0	0
44346465	738818	0	0
44358137	1332419	2	3
45625868	1332418	0	0
44358610	1177480	0	0
45663232	1125315	0	0
45658374	1125315	0	0
45630039	1177480	0	0
45636630	1115008	0	0
45671545	1112807	0	0
45781128	1124300	0	0
45685753	1713332	0	0
45702268	40223834	2	3
45705852	1125315	0	0
45706420	1551099	0	0
45779971	1119510	0	0
45792161	1119510	0	0
45797227	1119510	0	0
46239658	1119510	0	0
46242233	1129625	0	0
46307850	1124957	0	0
46320341	1759842	0	0
46315624	1125315	0	0
4180627	4242997	6	7
19085458	836659	1	1
21506167	1115008	0	0
21002900	1521369	0	0
35508967	1759842	0	0
36102149	433125	7	7
4141937	4323902	3	3
37503959	4337611	4	4
44356162	738818	0	0
44339512	1119510	0	0
44346361	1501700	0	0
44354574	1332419	2	3
45625912	1115008	0	0
44351368	1177480	0	0
45663283	1125315	0	0
45650247	1713332	0	0
45630133	1177480	0	0
45636522	1309944	0	0
45671533	1112807	0	0
45781161	740275	0	0
45686162	1149380	0	0
45702354	920334	2	3
45705856	1125315	0	0
45706422	1500211	0	0
45779977	1119510	0	0
45792447	1119510	0	0
45797247	1119510	0	0
46239728	1119510	0	0
46241918	1129625	0	0
46307863	738818	0	0
46320270	1118084	0	0
46315628	1125315	0	0
4180627	44783196	3	8
19061283	19128009	1	1
21500621	753626	0	0
21002900	1549786	0	0
35508968	1129625	0	0
36102154	28060	7	7
4181063	198809	3	3
36718119	4001336	4	4
44352659	1129625	0	0
44339623	1119510	0	0
44346056	1149380	0	0
44340600	1332419	2	3
45625915	757627	0	0
44351445	1177480	0	0
45663284	1125315	0	0
45650552	1759842	0	0
45630168	1177480	0	0
45636217	738818	0	0
45669905	1112807	0	0
45781165	1124957	0	0
45685930	1308738	0	0
45702326	1115171	2	3
45705532	1125315	0	0
45706427	1174888	0	0
45780038	1119510	0	0
45792152	1119510	0	0
45797249	1119510	0	0
46239730	1119510	0	0
46241923	1129625	0	0
46307511	1332418	0	0
46320251	1124300	0	0
46315663	1125315	0	0
4180627	4058899	3	8
19019339	19129144	1	1
21500645	19003953	0	0
21002900	1512674	0	0
35508969	1112807	0	0
36102154	433125	7	7
4181063	4280726	3	3
36718588	380378	4	4
44352661	1729720	0	0
44339627	1119510	0	0
44346059	1713332	0	0
44340822	1332419	2	3
45626006	1713332	0	0
44351412	1177480	0	0
45663180	1125315	0	0
45650449	1149380	0	0
45630260	1177480	0	0
45636449	1307863	0	0
45783881	1112807	0	0
45781250	738818	0	0
45685933	738818	0	0
45702346	40163554	2	3
45706069	1125315	0	0
45706442	1310149	0	0
45780039	1119510	0	0
45792630	1119510	0	0
45792873	1119510	0	0
46239733	1119510	0	0
46242042	1129625	0	0
46307864	738818	0	0
46320377	1174888	0	0
46315667	1125315	0	0
4180627	4186930	5	7
19019339	19127922	1	1
21013503	1361711	0	0
21002899	1557272	0	0
35508972	1310149	0	0
36102154	198199	7	7
4181063	81893	3	3
37522376	4108705	4	4
44352794	1177480	0	0
44339443	1119510	0	0
44346424	975125	0	0
44347935	1332419	2	3
45625952	1000560	0	0
44344324	1177480	0	0
45663184	1125315	0	0
45650452	1107830	0	0
45629950	1177480	0	0
45636450	1107830	0	0
45783795	1112807	0	0
45781251	1545958	0	0
45686125	1367571	0	0
45702436	40232448	2	3
45705945	1125315	0	0
45706450	1115008	0	0
45780041	1119510	0	0
45792172	1119510	0	0
45793013	1119510	0	0
45895917	1119510	0	0
46242002	1129625	0	0
46307935	1192710	0	0
46320570	1112807	0	0
46315902	1125315	0	0
4180627	4330583	5	9
19019339	19133679	1	1
21013503	975125	0	0
21003024	19039298	0	0
35508974	1129625	0	0
35802131	375671	8	10
4180941	44805732	3	3
37203758	4051466	4	4
44352838	933724	0	0
44339554	1119510	0	0
44346490	738818	0	0
44354711	1545959	2	3
45625742	738818	0	0
44337373	1177480	0	0
45663275	1125315	0	0
45650255	740275	0	0
45627213	1177480	0	0
45636460	1174888	0	0
45783798	1112807	0	0
45781251	1332418	0	0
45686133	1124300	0	0
45702502	19008572	2	3
45705809	1125315	0	0
45706412	1149196	0	0
45706900	1119510	0	0
45792514	1119510	0	0
45792825	1119510	0	0
45896106	1119510	0	0
45893540	1129625	0	0
46307945	1149196	0	0
46320579	701322	0	0
46315577	1125315	0	0
4180627	4047491	5	8
19019340	19128065	1	1
21013496	1551099	0	0
21003024	782043	0	0
35508978	1154343	0	0
35802131	378419	8	9
4180941	4163971	3	3
37503943	4117038	4	4
44352844	1115008	0	0
44339558	1119510	0	0
44346498	1551099	0	0
44340954	19078461	2	3
45625743	1110410	0	0
44337305	1177480	0	0
45663276	1125315	0	0
45650187	1153428	0	0
45627162	1177480	0	0
45636464	1307863	0	0
45783992	1112807	0	0
45781353	738818	0	0
45688610	1305058	0	0
45702435	40232448	2	3
45706047	1125315	0	0
45706598	1153428	0	0
45707015	1119510	0	0
45792651	1119510	0	0
45792831	1119510	0	0
45895878	1119510	0	0
45893649	1129625	0	0
46307705	1322184	0	0
46320580	1738521	0	0
46315968	1125315	0	0
4180627	4108705	5	8
4344027	4149245	1	1
21013536	1717327	0	0
21003003	1501700	0	0
35509042	19127890	0	0
35300000	4043241	8	8
4042505	4066995	3	5
37003680	195588	4	4
44352845	1124300	0	0
44339349	1119510	0	0
44346267	738818	0	0
44340226	1539411	2	3
45625969	1738521	0	0
44337772	1177480	0	0
45663347	1125315	0	0
45650356	740275	0	0
45627419	1177480	0	0
45636423	1149196	0	0
45781721	1112807	0	0
45781363	19127890	0	0
45688615	701322	0	0
45702480	1127433	2	3
45705785	1125315	0	0
45706537	791967	0	0
45707019	1119510	0	0
45789500	1119510	0	0
45793089	1119510	0	0
45896170	1119510	0	0
45893753	1129625	0	0
46307946	1153428	0	0
46320592	1192710	0	0
46315217	1125315	0	0
4180627	4117038	5	8
4344271	81151	1	1
21013536	1759842	0	0
21003024	1154029	0	0
35509042	1589505	0	0
36202157	40480160	9	9
4201944	4010253	3	5
37502348	4043071	4	4
44352684	1545958	0	0
44341300	1119510	0	0
44346249	723013	0	0
44337636	1738521	0	0
45625971	19127890	0	0
44337513	1177480	0	0
45663349	1125315	0	0
45650362	1107830	0	0
45627260	1177480	0	0
45636436	738818	0	0
45779232	1112807	0	0
45781363	1515774	0	0
45688621	1124957	0	0
45699381	19018935	2	3
45706079	1125315	0	0
45706491	1322184	0	0
45706100	1119510	0	0
45789558	1119510	0	0
45793128	1119510	0	0
45896136	1119510	0	0
45893826	1129625	0	0
46307995	1501700	0	0
46320764	1738521	0	0
46315935	1125315	0	0
4180627	4337611	5	8
4318404	255848	1	1
21013536	1713332	0	0
21003027	1102527	0	0
35509042	1549786	0	0
36217214	42902245	3	4
4201745	4310024	3	5
40782937	3027231	4	4
44352858	1192710	0	0
44341432	1119510	0	0
44346268	1129625	0	0
44337849	1501700	0	0
45625971	1589505	0	0
45622053	1177480	0	0
45663405	1125315	0	0
45650521	1501700	0	0
45627160	1177480	0	0
45636445	1174888	0	0
45779235	1112807	0	0
45781363	1549786	0	0
45688574	967823	0	0
45699534	19008572	2	3
45706083	1125315	0	0
45706452	1107830	0	0
45706221	1119510	0	0
45789727	1119510	0	0
45793049	1119510	0	0
45896031	1119510	0	0
45893832	1129625	0	0
46307714	1192710	0	0
46320379	920293	0	0
46316136	1125315	0	0
4180627	4323902	5	8
4321844	4117038	1	1
21002805	1124300	0	0
21003027	1110410	0	0
35509043	1177480	0	0
36217214	19128022	3	4
4201745	198809	3	5
40782937	3015076	4	4
44352685	1149196	0	0
44339676	1119510	0	0
44346059	1759842	0	0
44337601	1192710	0	0
45625971	1549786	0	0
45622019	1177480	0	0
45663076	1125315	0	0
45650636	738818	0	0
45623708	1177480	0	0
45636587	1305058	0	0
45778828	1112807	0	0
45781476	914335	0	0
45688529	1539403	0	0
45699384	40236446	2	3
45705893	1125315	0	0
45706454	705944	0	0
45706223	1119510	0	0
45789743	1119510	0	0
45793167	1119510	0	0
45895997	1119510	0	0
45801808	1129625	0	0
46307726	738818	0	0
46320595	1548195	0	0
46316026	1125315	0	0
4180627	4238715	4	6
4301352	4337138	1	1
21002805	1305058	0	0
21002900	1548195	0	0
35509056	1125315	0	0
36217214	19133768	2	3
4201745	4266809	3	5
40782937	3006734	4	4
44352810	1548195	0	0
44339831	1119510	0	0
44346375	1124957	0	0
44337637	1307863	0	0
45625870	1515774	0	0
45622090	1177480	0	0
45663518	1125315	0	0
45650718	1107830	0	0
45625223	1177480	0	0
45636508	1149196	0	0
45779265	1112807	0	0
45781219	791967	0	0
45688668	708298	0	0
45699645	19019273	2	3
45705851	1125315	0	0
45706456	1110410	0	0
45706165	1119510	0	0
45789746	1119510	0	0
45793324	1119510	0	0
45896099	1119510	0	0
45802461	1129625	0	0
46307734	933724	0	0
46320595	19054876	0	0
46315566	1125315	0	0
4180627	4010253	4	6
19057161	19128009	1	1
21002804	1778162	0	0
21003024	19002770	0	0
35509059	1125315	0	0
36217214	40223834	2	3
4201745	30753	3	5
37202317	40486433	4	4
44352966	1115008	0	0
44339699	1119510	0	0
44346253	1332418	0	0
44337873	738818	0	0
45625870	19127890	0	0
45658541	1177480	0	0
45663373	1125315	0	0
45647015	1110410	0	0
45625348	1177480	0	0
45636588	1107830	0	0
45779268	1112807	0	0
45781478	1738521	0	0
45682728	1174888	0	0
45699471	1107882	2	3
45705971	1125315	0	0
45706459	1192710	0	0
45706359	1119510	0	0
45789633	1119510	0	0
45793411	1119510	0	0
45896807	1119510	0	0
45799071	1129625	0	0
46307610	1549786	0	0
46320541	1307863	0	0
46315842	1125315	0	0
4180627	44805732	4	6
19057161	19127918	1	1
21002805	1118084	0	0
21002955	975125	0	0
35509062	19127890	0	0
36217214	1150837	2	3
4093991	4149245	4	5
37202317	4280726	4	4
44352971	1149196	0	0
44339771	1119510	0	0
44346386	975125	0	0
44338023	1713332	0	0
45625870	1549786	0	0
45658457	1177480	0	0
45663194	1125315	0	0
45646895	1717327	0	0
45625152	1177480	0	0
45636218	1000560	0	0
45779277	1112807	0	0
45781226	1501700	0	0
45682736	1521369	0	0
45699655	42707627	2	3
45705998	1125315	0	0
45706462	1174888	0	0
45706176	1119510	0	0
45789650	1119510	0	0
45791942	1119510	0	0
45804357	1119510	0	0
45799083	1129625	0	0
46307610	1521369	0	0
46320843	1149380	0	0
46315873	1125315	0	0
4180627	4301346	4	9
4233623	40478878	1	1
21003153	1125315	0	0
21002900	1557272	0	0
35509062	1515774	0	0
36217214	19018935	2	3
4113999	4285898	4	5
37203740	261325	4	4
44352927	1713332	0	0
44339772	1119510	0	0
44346061	1177480	0	0
44338026	1149196	0	0
45625881	1174888	0	0
45658869	1177480	0	0
45663660	1125315	0	0
45647246	1549786	0	0
45624518	1177480	0	0
45636638	1107830	0	0
45779287	1112807	0	0
45781230	1713332	0	0
45682868	1124957	0	0
45699659	40228230	2	3
45703861	1125315	0	0
45706552	1539403	0	0
45706255	1119510	0	0
45789768	1119510	0	0
45791978	1119510	0	0
45796287	1119510	0	0
45799164	1129625	0	0
46307612	1149196	0	0
46320861	1557272	0	0
46315886	1125315	0	0
4180627	4337138	4	7
4216752	4107731	1	1
21003156	1177480	0	0
21002901	1557272	0	0
35509062	1549786	0	0
36217214	40236446	2	3
4041261	4117038	4	5
37203740	258780	4	4
44352668	1149196	0	0
44362962	1125315	0	0
44346646	1115008	0	0
44337906	1149380	0	0
45625885	738818	0	0
45658442	1177480	0	0
45663727	1125315	0	0
45647246	1589505	0	0
45624141	1177480	0	0
45636438	1548195	0	0
45780702	1112807	0	0
45781230	1759842	0	0
45682870	1500211	0	0
45699688	43012036	2	3
45702248	1125315	0	0
45706646	1154343	0	0
45706265	1119510	0	0
45789836	1119510	0	0
45791849	1119510	0	0
45797162	1119510	0	0
45799134	1129625	0	0
46307626	967823	0	0
46320406	1124957	0	0
46316038	1125315	0	0
4180627	4057420	4	7
21000640	19127918	1	1
21003156	1115008	0	0
21003017	753626	0	0
35509068	1112807	0	0
36217214	1127433	2	3
4042505	4237458	4	5
37202310	260139	4	4
44352823	1129625	0	0
44362940	1125315	0	0
44338834	1124957	0	0
44337919	1174888	0	0
45625888	1124300	0	0
45658991	1177480	0	0
45663661	1125315	0	0
45647258	1332418	0	0
45624277	1177480	0	0
45636592	1521369	0	0
45779422	1112807	0	0
45781311	1124957	0	0
45682736	1549786	0	0
45695988	1107882	2	3
45702251	1125315	0	0
45706668	1115008	0	0
45706559	1119510	0	0
45789681	1119510	0	0
45790255	1119510	0	0
45796530	1119510	0	0
45793980	1129625	0	0
46307916	1539403	0	0
46320683	1107830	0	0
46315997	1125315	0	0
4180627	4216130	4	8
21000640	19128009	1	1
21003157	1125315	0	0
21003025	708298	0	0
35509145	1548195	0	0
36217214	19045231	2	3
4054559	4336464	4	5
36703484	4043241	4	4
44352826	738818	0	0
44362914	1125315	0	0
44338972	1124300	0	0
44778144	920293	0	0
45626019	1153428	0	0
45659047	1177480	0	0
45663158	1125315	0	0
45647261	1107830	0	0
45668393	1177480	0	0
45636153	1192710	0	0
45779455	1112807	0	0
45781389	1115008	0	0
45683056	19127890	0	0
45696207	35605482	2	3
45702256	1125315	0	0
45706721	1154343	0	0
45706561	1119510	0	0
45789965	1119510	0	0
45790279	1119510	0	0
45796535	1119510	0	0
45793702	1129625	0	0
46308144	1110410	0	0
46320687	1501700	0	0
46316009	1125315	0	0
4237321	4323902	2	2
4339410	4059173	5	5
21003174	738818	0	0
21002958	1717327	0	0
35509107	1125315	0	0
36217214	1115171	2	3
4180938	4252419	4	5
40779591	3020655	4	4
44352674	723013	0	0
44362995	1125315	0	0
44339041	742185	0	0
44778204	1545958	0	0
45626049	1000560	0	0
44352072	1177480	0	0
45663459	1125315	0	0
45647250	1551099	0	0
45668561	1177480	0	0
45636340	738818	0	0
45708069	1112807	0	0
45781391	1361711	0	0
45683056	1549786	0	0
45696095	1127433	2	3
45702242	1125315	0	0
45706724	1153428	0	0
45706404	1119510	0	0
45789165	1119510	0	0
45790243	1119510	0	0
45796630	1119510	0	0
45794091	1129625	0	0
46308021	1713332	0	0
46320698	1332418	0	0
46309612	1125315	0	0
4237321	4246502	2	2
4339410	4048695	5	5
21003174	1125315	0	0
21002958	1728416	0	0
35509107	1112807	0	0
36217214	920300	2	3
4180938	4024289	4	5
40782473	3021226	4	4
44352675	1332418	0	0
44363106	1125315	0	0
44338937	1174888	0	0
44778157	1153428	0	0
45625980	1115008	0	0
45652400	1177480	0	0
45659665	1125315	0	0
45646896	1107830	0	0
45668837	1177480	0	0
45636347	967823	0	0
45708076	1112807	0	0
45781312	1000560	0	0
45683056	1521369	0	0
45696068	42707627	2	3
45702287	1125315	0	0
45706725	1539403	0	0
45706249	1119510	0	0
45789239	1119510	0	0
45790249	1119510	0	0
45796693	1119510	0	0
45794247	1129625	0	0
46308216	975125	0	0
46320786	1738521	0	0
46309617	1125315	0	0
4237320	4326177	2	2
4339410	4278672	5	5
21003174	1129625	0	0
21002959	1728416	0	0
35509044	933724	0	0
36217214	19112599	2	3
4227253	4329847	4	5
37522284	4337611	4	4
44352769	1112807	0	0
44363100	1125315	0	0
44338938	1548195	0	0
44778165	1153428	0	0
45625827	1149196	0	0
45652431	1177480	0	0
45659917	1125315	0	0
45647263	1115008	0	0
45666138	1177480	0	0
45636325	1501700	0	0
45705329	1112807	0	0
45781625	738818	0	0
45682838	1107830	0	0
45696225	43012036	2	3
45702291	1125315	0	0
45706682	1149196	0	0
45706192	1119510	0	0
45787097	1119510	0	0
45790443	1119510	0	0
45796671	1119510	0	0
45794125	1129625	0	0
46308228	1174888	0	0
46320718	1112807	0	0
46309622	1125315	0	0
4275564	4057420	2	2
4339410	4066995	5	5
21003153	1177480	0	0
21003017	708298	0	0
35509047	1177480	0	0
36217214	40231925	2	3
4141937	4336464	5	5
37016775	4066995	4	4
44352774	967823	0	0
44363103	1125315	0	0
44338948	1129625	0	0
44778004	1149196	0	0
45626058	1107830	0	0
45652734	1177480	0	0
45659845	1125315	0	0
45647066	1551099	0	0
45666319	1177480	0	0
45636594	1322184	0	0
45705433	1112807	0	0
45781581	1332418	0	0
45683001	914335	0	0
45696255	1115171	2	3
45702270	1125315	0	0
45706729	914335	0	0
45700619	1119510	0	0
45787098	1119510	0	0
45790538	1119510	0	0
45791177	1119510	0	0
45794266	1129625	0	0
46308266	1192710	0	0
46320913	967823	0	0
46309811	1125315	0	0
4043371	440448	2	2
4339468	40486433	5	5
21003174	1150836	0	0
21003017	1102527	0	0
35509092	19127890	0	0
36217214	43012036	2	3
4201944	4037675	5	5
37016775	4048695	4	4
44352779	1717327	0	0
44363243	1125315	0	0
44338952	1124300	0	0
44778214	1589505	0	0
45625836	1115008	0	0
44344404	1177480	0	0
45659846	1125315	0	0
45647302	1174888	0	0
45666281	1177480	0	0
45636530	791967	0	0
45702051	1112807	0	0
45781700	1107830	0	0
45682991	1149196	0	0
45696290	19008572	2	3
45702305	1125315	0	0
45706637	1551099	0	0
45699774	1119510	0	0
45786990	1119510	0	0
45790414	1119510	0	0
45791178	1119510	0	0
45789340	1129625	0	0
46308286	920293	0	0
46320411	1192710	0	0
46311849	1125315	0	0
4043371	28060	2	2
4339468	4280726	5	5
21003185	1343916	0	0
21003017	791967	0	0
35509092	1549786	0	0
36217214	19077344	2	3
21502620	1759842	5	5
36702247	44782520	4	5
44352790	1589505	0	0
44363026	1125315	0	0
44338953	1713332	0	0
44782520	44782520	0	0
45626070	1107830	0	0
45646279	1177480	0	0
45660009	1125315	0	0
45647306	1107830	0	0
45665984	1177480	0	0
45636486	1308738	0	0
45703808	1112807	0	0
45781324	1125315	0	0
45683098	1115008	0	0
45696165	19008572	2	3
45702342	1125315	0	0
45706714	1307863	0	0
45699895	1119510	0	0
45786993	1119510	0	0
45790606	1119510	0	0
45791247	1119510	0	0
45789348	1129625	0	0
46307698	723013	0	0
46320596	791967	0	0
46311903	1125315	0	0
4317258	134438	2	2
4279903	4163971	5	5
21003153	1192710	0	0
21003018	1309944	0	0
35509092	1515774	0	0
36217214	40174880	2	3
4130852	40479768	5	5
37202317	258780	4	5
44352780	1539403	0	0
44363109	1125315	0	0
44339030	1118084	0	0
44778201	723013	0	0
45625676	738818	0	0
45646145	1177480	0	0
45660057	1125315	0	0
45647266	738818	0	0
45666401	1177480	0	0
45636494	1115008	0	0
45699261	1112807	0	0
45781383	1125315	0	0
45683100	1729720	0	0
45696341	40223834	2	3
45702371	1125315	0	0
45706738	967823	0	0
45699781	1119510	0	0
45787050	1119510	0	0
45790610	1119510	0	0
45791148	1119510	0	0
45788700	1129625	0	0
46308167	1308738	0	0
46320600	1545958	0	0
46312002	1125315	0	0
4215793	4059978	2	2
4200516	378001	5	5
21003174	1192710	0	0
21003027	1343916	0	0
35509113	1153428	0	0
36217214	1539411	2	3
4141833	4048171	5	5
37003663	4056621	4	5
44353090	1177480	0	0
44363394	1125315	0	0
44339039	1343916	0	0
44778271	1124957	0	0
45625839	1326303	0	0
44340998	1177480	0	0
45660155	1125315	0	0
45647267	1322184	0	0
45664617	1177480	0	0
45636469	738818	0	0
45699308	1112807	0	0
45781179	1125315	0	0
45683021	1551099	0	0
45696485	40229134	2	3
45702447	1125315	0	0
45706830	1107830	0	0
45699818	1119510	0	0
45787027	1119510	0	0
45787664	1119510	0	0
45791234	1119510	0	0
45788754	1129625	0	0
46307694	1115008	0	0
46320304	1308738	0	0
46312011	1125315	0	0
4237017	40478878	2	2
4200516	375671	5	5
21003263	933724	0	0
21003027	914335	0	0
35509114	1177480	0	0
36217216	19019979	2	3
4227253	198809	5	5
37202316	4051466	4	5
44353184	1115008	0	0
44363464	1125315	0	0
44339040	1149196	0	0
44778276	975125	0	0
45626033	1174888	0	0
44341078	1177480	0	0
45659868	1125315	0	0
45647165	757627	0	0
45664517	1177480	0	0
45636653	1154029	0	0
45695931	1112807	0	0
45781368	1125315	0	0
45683104	967823	0	0
45696487	1127433	2	3
45702520	1125315	0	0
45706616	1307863	0	0
45699970	1119510	0	0
45787166	1119510	0	0
45787722	1119510	0	0
45791239	1119510	0	0
45788904	1129625	0	0
46308287	1000560	0	0
46320911	1738521	0	0
46311993	1125315	0	0
4053826	4296204	2	2
4318379	4048171	5	5
21003174	1107830	0	0
21003025	1102527	0	0
35509201	1310149	0	0
36217216	19077572	2	3
4227253	195588	5	5
37503959	4057420	4	5
44353202	1129625	0	0
44363466	1125315	0	0
44339111	1738521	0	0
44778278	1501700	0	0
45626077	1713332	0	0
45643316	1177480	0	0
45649418	1119510	0	0
45647287	1539403	0	0
45663977	1177480	0	0
45636674	1149196	0	0
45697545	1112807	0	0
45781371	1125315	0	0
45683177	1149196	0	0
45696323	40232448	2	3
45702480	1125315	0	0
45706617	1192710	0	0
45699889	1119510	0	0
45787167	1119510	0	0
45787829	1119510	0	0
45791240	1119510	0	0
45788905	1129625	0	0
46308117	1174888	0	0
46320625	1717327	0	0
46310339	1125315	0	0
4032251	4163872	2	2
4215793	4337611	5	5
21003153	1112807	0	0
21003025	1154029	0	0
35509202	1119510	0	0
36217216	40165015	2	3
21502553	1326303	5	5
37002287	195588	4	7
44353215	1192710	0	0
44363467	1125315	0	0
44339129	705944	0	0
44778060	1149196	0	0
45626078	1153428	0	0
45643399	1177480	0	0
45649385	1119510	0	0
45647169	1174888	0	0
45664021	1177480	0	0
45636655	1115008	0	0
45697598	1112807	0	0
45781159	1125315	0	0
45683276	914335	0	0
45696519	1154615	2	3
45702415	1125315	0	0
45706620	1308738	0	0
45693482	1119510	0	0
45787188	1119510	0	0
45787871	1119510	0	0
45791355	1119510	0	0
45789012	1129625	0	0
46308170	1308738	0	0
46320999	1118084	0	0
46310341	1125315	0	0
4043197	4186930	2	2
4326426	4163971	5	5
21002808	1177480	0	0
21003025	1110410	0	0
35509119	1119510	0	0
36217216	19075001	2	3
4101219	81893	3	4
37202316	4112343	4	10
44353107	1115008	0	0
44363053	1125315	0	0
44338990	1332418	0	0
44778219	738818	0	0
45626083	1551099	0	0
45643391	1177480	0	0
45649307	1119510	0	0
45647307	1322184	0	0
45660666	1177480	0	0
45636680	753626	0	0
45697601	1112807	0	0
45781250	1125315	0	0
45683213	1521369	0	0
45696543	1545959	2	3
45699389	1125315	0	0
45706799	1124957	0	0
45693532	1119510	0	0
45787349	1119510	0	0
45786216	1119510	0	0
45791407	1119510	0	0
45788807	1129625	0	0
46308289	1551099	0	0
46321109	1124300	0	0
46310242	1125315	0	0
4194895	4062501	2	2
4197094	81893	5	6
21002808	1115008	0	0
21003025	791967	0	0
35509119	738818	0	0
36217216	19074841	2	3
4041261	4186930	3	4
37202316	40486433	4	9
44353137	1713332	0	0
44363224	1125315	0	0
44339140	1107830	0	0
44778223	1738521	0	0
45625779	1501700	0	0
45643401	1177480	0	0
45649300	1119510	0	0
45648822	705944	0	0
45660857	1177480	0	0
45636572	1115008	0	0
45697831	1112807	0	0
45781353	1125315	0	0
45683213	1549786	0	0
45693259	19059056	2	3
45699391	1125315	0	0
45706834	1107830	0	0
45693494	1119510	0	0
45787325	1119510	0	0
45786231	1119510	0	0
45791330	1119510	0	0
46296901	1129625	0	0
46308291	1192710	0	0
46320803	715997	0	0
46310263	1125315	0	0
4112731	4285898	2	2
4212577	4280726	5	6
21002808	1124300	0	0
21003063	791967	0	0
35509119	1125315	0	0
36217216	40236824	2	3
4144078	4198190	3	4
37202316	4294548	4	9
44353137	1759842	0	0
44363368	1125315	0	0
44338996	975125	0	0
44778202	1551099	0	0
45625896	1124300	0	0
45643226	1177480	0	0
45649492	1119510	0	0
45649205	1713332	0	0
45660928	1177480	0	0
45636678	1551099	0	0
45696025	1112807	0	0
45781571	1125315	0	0
45683213	19127890	0	0
45693131	40174880	2	3
45699323	1125315	0	0
45706845	1192710	0	0
45693476	1119510	0	0
45785604	1119510	0	0
45786363	1119510	0	0
45791277	1119510	0	0
46296704	1129625	0	0
46308059	705944	0	0
46321263	1551099	0	0
46310305	1125315	0	0
4045839	4336464	2	2
4212577	40486433	5	6
21002808	1551099	0	0
21003063	1115008	0	0
35509073	1119510	0	0
36217216	19073188	2	3
21505865	40236446	3	4
37202316	255848	4	8
44353113	1107830	0	0
44363514	1125315	0	0
44339167	1332418	0	0
44778069	1343916	0	0
45625911	1149196	0	0
45640340	1177480	0	0
45632050	1119510	0	0
45649073	705944	0	0
45660940	1177480	0	0
45636595	1343916	0	0
45692923	1112807	0	0
45781311	1125315	0	0
45683088	1124300	0	0
45693226	40243436	2	3
45699368	1125315	0	0
45706847	1545958	0	0
45693608	1119510	0	0
45785682	1119510	0	0
46297008	1119510	0	0
45791547	1119510	0	0
46296709	1129625	0	0
46308095	1115008	0	0
46320882	1112807	0	0
46310309	1125315	0	0
4043349	4035415	2	2
4304916	440448	5	6
21002808	1112807	0	0
21003018	1307863	0	0
35509076	1119510	0	0
36217216	1150837	2	3
4130852	4230399	3	4
36702247	375671	4	9
44352867	1112807	0	0
44363516	1125315	0	0
44339217	1124300	0	0
44778070	1343916	0	0
45626102	1343916	0	0
45640406	1177480	0	0
45641423	19079524	2	3
45649017	967823	0	0
45661006	1177480	0	0
45636600	1501700	0	0
45692993	1112807	0	0
45781625	1125315	0	0
45683281	1501700	0	0
45693231	40232448	2	3
45699586	1125315	0	0
46240175	1174888	0	0
45693616	1119510	0	0
45785508	1119510	0	0
46297012	1119510	0	0
45791282	1119510	0	0
46295026	1129625	0	0
46308079	1545958	0	0
46320805	1153428	0	0
46310372	1125315	0	0
4043671	40481087	2	2
4309188	4166224	5	6
21002808	975125	0	0
21002602	1717327	0	0
35509076	1125315	0	0
36217216	40236446	2	3
4180941	40492359	3	4
40480457	439777	4	7
44352869	975125	0	0
44363193	1125315	0	0
44339115	975125	0	0
44778230	1738521	0	0
45622643	1738521	0	0
45640411	1177480	0	0
45644392	19078924	2	3
45649023	933724	0	0
45657755	1177480	0	0
45636603	1551099	0	0
45693097	1112807	0	0
45781580	1125315	0	0
45683287	1307863	0	0
45693291	19019273	2	3
45699342	1125315	0	0
45702766	740275	0	0
45693905	1119510	0	0
45785569	1119510	0	0
46297021	1119510	0	0
45791452	1119510	0	0
46295153	1129625	0	0
46307996	1115008	0	0
46320816	1332418	0	0
46310430	1125315	0	0
4043671	28060	2	2
4322976	4043071	5	6
21002808	1118084	0	0
21002603	1746114	0	0
35509076	738818	0	0
36217216	19018935	2	3
4181193	4301346	4	4
37203758	4112343	5	9
44353158	975125	0	0
44363448	1125315	0	0
44339015	1149380	0	0
44778257	1149196	0	0
45622574	1539403	0	0
45640447	1177480	0	0
45631095	19078461	2	3
45649048	1149196	0	0
45658165	1177480	0	0
45636610	1154029	0	0
45693106	1112807	0	0
45781643	1125315	0	0
45682943	1778162	0	0
45694754	19019273	2	3
45699429	1125315	0	0
45703088	1124957	0	0
45693919	1119510	0	0
45785523	1119510	0	0
46296937	1119510	0	0
46298711	1119510	0	0
46295390	1129625	0	0
46308105	1551099	0	0
46314874	967823	0	0
46310506	1125315	0	0
4043671	257012	2	2
4322976	40478878	5	6
21002811	1112807	0	0
21002603	1717327	0	0
35509157	967823	0	0
36217216	40231925	2	3
4181193	44783196	4	4
37203758	261325	5	8
44353008	1177480	0	0
44363323	1125315	0	0
44339220	1118084	0	0
44783196	44783196	0	0
45622577	1308738	0	0
45640445	1177480	0	0
45663397	40223768	2	3
45649183	1539403	0	0
45654658	1177480	0	0
45636629	1107830	0	0
45693066	1112807	0	0
45781649	1125315	0	0
45683321	1307863	0	0
45694859	920334	2	3
45699436	1125315	0	0
45703090	1551099	0	0
45690640	1119510	0	0
45785644	1119510	0	0
46296945	1119510	0	0
46298417	1119510	0	0
46295215	1129625	0	0
46308426	1124300	0	0
46313868	1332418	0	0
46310490	1125315	0	0
4212887	4146173	2	2
4274025	80502	5	6
21002811	1115008	0	0
21002618	1746114	0	0
35509096	1129625	0	0
36217216	40162522	2	3
4141937	4057420	4	4
37203758	40486433	5	8
44352722	723013	0	0
44363589	1125315	0	0
44339224	1149380	0	0
44358139	1549786	0	0
45622618	708298	0	0
45640454	1177480	0	0
45665854	1107882	2	3
45647309	1545958	0	0
45638905	1119510	0	0
45636409	1124957	0	0
45689790	1112807	0	0
45781449	1125315	0	0
45683323	1107830	0	0
45693313	40229134	2	3
45699623	1125315	0	0
45703028	1308738	0	0
45690768	1119510	0	0
45785674	1119510	0	0
46297072	1119510	0	0
46298429	1119510	0	0
46295574	1129625	0	0
46308367	1308738	0	0
46313873	1174888	0	0
46310414	1125315	0	0
4195601	4186930	2	2
4274025	438614	5	6
21002811	1177480	0	0
21002682	1305058	0	0
35509101	1119510	0	0
36217216	43012036	2	3
4201745	196456	4	4
36718588	375671	5	7
44352901	1545958	0	0
44363592	1125315	0	0
44339232	1124957	0	0
44357924	1000560	0	0
45622630	1548195	0	0
45640380	1177480	0	0
45659604	19078924	2	3
45647406	1115008	0	0
45639204	1119510	0	0
45636554	975125	0	0
45690030	1112807	0	0
45781594	1125315	0	0
45683328	1153428	0	0
45693298	40232448	2	3
45699443	1125315	0	0
45702996	1557272	0	0
45690819	1119510	0	0
45785779	1119510	0	0
46297077	1119510	0	0
46298689	1119510	0	0
46295308	1129625	0	0
46308088	1396131	0	0
46313876	1149196	0	0
46310653	1125315	0	0
4196708	4029498	2	2
4274025	4048169	5	6
21002810	1124300	0	0
21002682	975125	0	0
35509103	1112807	0	0
36217216	1127433	2	3
4201745	4027663	4	4
36718588	378001	5	7
44352908	1149380	0	0
44363594	1125315	0	0
44339236	1589505	0	0
44357932	1548195	0	0
45622631	1107830	0	0
45637199	1177480	0	0
45629454	40174880	2	3
45647408	738818	0	0
45639298	1119510	0	0
45636555	1149196	0	0
45690085	1112807	0	0
45779008	1125315	0	0
45683336	1124957	0	0
45693399	43012036	2	3
45699635	1125315	0	0
45800012	1119510	0	0
45687424	1119510	0	0
45785985	1119510	0	0
46297120	1119510	0	0
46298495	1119510	0	0
46295252	1129625	0	0
46308335	1124957	0	0
46314292	967823	0	0
46310656	1125315	0	0
4196732	196456	2	2
4304916	4285898	5	7
21002814	1177480	0	0
21002683	975125	0	0
35509172	1129625	0	0
36217216	19077344	2	3
4180938	4243062	4	4
36718595	4001336	5	7
44353179	1500211	0	0
44363662	1125315	0	0
44339237	708298	0	0
44358062	1332418	0	0
45622566	19127890	0	0
45637207	1177480	0	0
45626153	19075001	2	3
45644283	1110410	0	0
45635859	1119510	0	0
45637054	738818	0	0
45690200	1112807	0	0
45778663	1125315	0	0
45682946	1154343	0	0
45693301	19008572	2	3
45699461	1125315	0	0
45800016	1119510	0	0
45687758	1119510	0	0
46296467	1119510	0	0
46297226	1119510	0	0
46298576	1119510	0	0
46244334	1129625	0	0
46308342	1115008	0	0
46314896	1174888	0	0
46310671	1125315	0	0
19081738	19128263	2	2
4274025	4149245	5	9
21002814	1115008	0	0
21002686	1149380	0	0
35509156	1149380	0	0
36217216	40232448	2	3
4093991	381316	4	4
37503996	4336464	5	7
44353015	701322	0	0
44358779	1125315	0	0
44339305	975125	0	0
44358219	1595799	0	0
45622566	1549786	0	0
45637490	1177480	0	0
45667423	1107882	2	3
45644342	738818	0	0
45636050	1119510	0	0
45636950	1539403	0	0
45686905	1112807	0	0
45779015	1125315	0	0
45682997	1115008	0	0
45693337	46233988	2	3
45699403	1125315	0	0
45800053	1119510	0	0
45687702	1119510	0	0
46292313	1119510	0	0
45894600	1119510	0	0
46298643	1119510	0	0
46244419	1129625	0	0
46308350	1332418	0	0
46314897	1501700	0	0
46310596	1125315	0	0
19081738	19128022	2	2
4274025	40486433	5	9
21002814	1124300	0	0
21002683	1551099	0	0
35509175	1125315	0	0
36217216	19045231	2	3
4112892	4107731	4	4
37100000	198199	5	7
44352915	1115008	0	0
44358686	1125315	0	0
44339333	1149380	0	0
44358219	1521369	0	0
45622566	1512674	0	0
45639979	1177480	0	0
45663511	1107882	2	3
45644343	1343916	0	0
45635868	1119510	0	0
45637421	791967	0	0
45688698	1112807	0	0
45778781	1125315	0	0
45682905	1107830	0	0
45693337	46233710	2	3
45699490	1125315	0	0
45800086	1119510	0	0
45687714	1119510	0	0
46292515	1119510	0	0
45803024	1119510	0	0
46298782	1119510	0	0
46244312	1129625	0	0
46302551	738818	0	0
46314901	1192710	0	0
46310532	1125315	0	0
4297887	4310024	2	2
4274025	440448	5	10
21002411	1746114	0	0
21002677	1149380	0	0
35509167	975125	0	0
36217216	1539411	2	3
4042645	4057420	4	4
40783000	3049273	5	6
44353188	1115008	0	0
44358484	1125315	0	0
44339335	723013	0	0
44358219	1549786	0	0
45622544	1149196	0	0
45640112	1177480	0	0
45662751	19078461	2	3
45644358	19010482	0	0
45635810	1119510	0	0
45633278	1192710	0	0
45687177	1112807	0	0
45779081	1125315	0	0
45683220	967823	0	0
45693500	1519937	2	3
45699497	1125315	0	0
45799984	1119510	0	0
45687630	1119510	0	0
46292319	1119510	0	0
45802962	1119510	0	0
46298992	1119510	0	0
46244562	1129625	0	0
46302661	1115008	0	0
46313884	1322184	0	0
46304812	1125315	0	0
4235428	4057420	2	2
4322976	4197460	5	7
21002450	1759842	0	0
21002685	19010482	0	0
35509150	1112807	0	0
36217216	1115171	2	3
4042645	4078793	4	4
37604009	313217	5	6
44353190	738818	0	0
44358489	1125315	0	0
44339345	1129625	0	0
44358972	1192710	0	0
45622845	933724	0	0
45634240	1177480	0	0
45663453	40228214	2	3
45644362	1115008	0	0
45635907	1119510	0	0
45633178	1501700	0	0
45687318	1112807	0	0
45779061	1125315	0	0
45683064	1778162	0	0
45690307	43012036	2	3
45699601	1125315	0	0
45799827	1119510	0	0
45687876	1119510	0	0
46292123	1119510	0	0
45803387	1119510	0	0
46299029	1119510	0	0
46244529	1129625	0	0
46302576	1124957	0	0
46314803	1174888	0	0
46304879	1125315	0	0
4043371	81893	2	3
4322976	4216130	5	9
21002452	1746114	0	0
21002685	1305058	0	0
35509152	1177480	0	0
36217216	19128009	3	4
21604180	740275	4	4
36718588	378419	5	6
44352836	1548195	0	0
44356252	1125315	0	0
44339427	933724	0	0
44359132	19003953	0	0
45622395	738818	0	0
45634590	1177480	0	0
45665387	1107882	2	3
45644324	1551099	0	0
45636078	1119510	0	0
45633279	1545958	0	0
45683952	1112807	0	0
45778708	1125315	0	0
45683297	1741122	0	0
45690317	40232448	2	3
45696115	1125315	0	0
45800092	1119510	0	0
45687920	1119510	0	0
46292380	1119510	0	0
45803392	1119510	0	0
46299040	1119510	0	0
46244322	1129625	0	0
46302795	1107830	0	0
46314747	1174888	0	0
46304885	1125315	0	0
21000815	19133905	2	3
4199402	4329847	6	9
21002453	1759842	0	0
21002627	1149380	0	0
35509182	1125315	0	0
36217216	19128065	3	4
4141833	4280726	4	4
37604032	313217	5	6
44353093	1000560	0	0
44356332	1125315	0	0
44339181	1738521	0	0
44359043	723013	0	0
45622406	738818	0	0
45634281	1177480	0	0
45629131	1107882	2	3
45644310	1332418	0	0
45636015	1119510	0	0
45633288	1728416	0	0
45684084	1112807	0	0
45779195	1125315	0	0
45683297	1746114	0	0
45690340	43012036	2	3
45695996	1125315	0	0
45800189	1119510	0	0
45687895	1119510	0	0
46292301	1119510	0	0
45803400	1119510	0	0
46298628	1119510	0	0
46244440	1129625	0	0
46302814	1521369	0	0
46314193	1308738	0	0
46305431	1125315	0	0
21000815	19133873	2	3
4199402	4112343	6	9
21002454	1759842	0	0
21002623	1741122	0	0
36156645	1112807	0	0
36217216	42902245	3	4
4141833	40486433	4	4
37602360	4329847	5	6
44353198	1177480	0	0
44356256	1125315	0	0
44339258	1129625	0	0
44359047	1332418	0	0
45622410	1713332	0	0
45634652	1177480	0	0
45650491	40223768	2	3
45644092	1174888	0	0
45636017	1119510	0	0
45633327	791967	0	0
45654955	1177480	0	0
45779208	1125315	0	0
45683419	723013	0	0
45690544	920334	2	3
45696011	1125315	0	0
45799910	1119510	0	0
45687504	1119510	0	0
46292223	1119510	0	0
45803410	1119510	0	0
46299295	1119510	0	0
46244535	1129625	0	0
46302963	1149196	0	0
46314764	1549786	0	0
46305003	1125315	0	0
4042516	4295880	2	3
4322976	4337611	6	9
21002445	1746114	0	0
21002623	1746114	0	0
36156671	967823	0	0
36217216	19129144	3	4
4100932	40479768	4	4
37602360	4310024	5	6
44353216	1149196	0	0
44356441	1125315	0	0
44339125	1192710	0	0
44358978	738818	0	0
45622410	1759842	0	0
45634468	1177480	0	0
45641384	1107882	2	3
45644286	1154343	0	0
45636274	1119510	0	0
45633203	738818	0	0
45654899	1177480	0	0
45778984	1125315	0	0
45683430	1549786	0	0
45691410	1127433	2	3
45696090	1125315	0	0
45800095	1119510	0	0
45688013	1119510	0	0
46292477	1119510	0	0
45803384	1119510	0	0
46298923	1119510	0	0
45787646	1119510	0	0
46302845	1738521	0	0
46314755	1310149	0	0
46305445	1125315	0	0
21000260	46233988	2	3
4304916	81893	6	8
21002445	1759842	0	0
21002627	975125	0	0
36156675	1713332	0	0
35809386	4285898	3	6
4057955	4015189	4	4
36718595	380378	5	5
44353219	975125	0	0
44356449	1125315	0	0
44339331	1177480	0	0
44359179	738818	0	0
45622414	1521369	0	0
45631362	1177480	0	0
45649286	1332419	2	3
45644188	1367571	0	0
45636200	1119510	0	0
45633487	1192710	0	0
45654841	1177480	0	0
45778986	1125315	0	0
45683200	1595799	0	0
45687203	1107882	2	3
45696095	1125315	0	0
45685906	1119510	0	0
45687959	1119510	0	0
46292470	1119510	0	0
45803079	1119510	0	0
46298939	1119510	0	0
45787229	1119510	0	0
46303139	1118084	0	0
46314698	1551099	0	0
46305016	1125315	0	0
21000260	46233710	2	3
4199402	4146173	6	8
21002455	1759842	0	0
21002630	1149380	0	0
36156679	1343916	0	0
35700000	198809	7	9
4203551	4108705	4	4
37602360	321042	5	5
44353221	1310149	0	0
44356344	1125315	0	0
44339332	723013	0	0
44359180	1115008	0	0
45622416	738818	0	0
45633937	1177480	0	0
45650718	1107882	2	3
45644476	967823	0	0
45636185	1119510	0	0
45633646	1174888	0	0
45655110	1177480	0	0
45778786	1125315	0	0
45683200	1308738	0	0
45687249	19008572	2	3
45696218	1125315	0	0
45685684	1119510	0	0
45687902	1119510	0	0
46292451	1119510	0	0
45803235	1119510	0	0
46299065	1119510	0	0
45787633	1119510	0	0
46302853	975125	0	0
46314700	1192710	0	0
46305571	1125315	0	0
21000259	46233988	2	3
4199402	257012	6	8
21002455	1741122	0	0
21002630	1149196	0	0
36156660	1539403	0	0
35700000	196456	7	8
4227253	321042	4	4
37602360	4163874	5	5
44353222	1112807	0	0
44356306	1125315	0	0
44339417	1107830	0	0
44359185	1192710	0	0
45622274	1124300	0	0
45631557	1177480	0	0
45647261	1107882	2	3
45644335	967823	0	0
45636021	1119510	0	0
45633574	1551099	0	0
45655113	1177480	0	0
45779157	1125315	0	0
45683430	1512674	0	0
45687394	19076374	2	3
45696061	1125315	0	0
45685323	1119510	0	0
45687906	1119510	0	0
46287882	1119510	0	0
45803330	1119510	0	0
46290400	1119510	0	0
45787640	1119510	0	0
46302701	1174888	0	0
46314704	1112807	0	0
46305574	1125315	0	0
21000803	19077344	2	3
4199402	4149245	6	8
21002455	1746114	0	0
21600965	1310149	0	0
36156662	1309944	0	0
35700000	441267	3	3
4227253	4266809	4	4
37604009	4310024	5	5
44353039	738818	0	0
44356389	1125315	0	0
44339153	1124300	0	0
44358862	1149196	0	0
45622303	1153428	0	0
45628133	1177480	0	0
45626189	1107882	2	3
45644198	1332418	0	0
45632944	1119510	0	0
45633529	1759842	0	0
45655238	1177480	0	0
45779229	1125315	0	0
45683466	1332418	0	0
45687406	19077344	2	3
45696226	1125315	0	0
45685359	1119510	0	0
45687963	1119510	0	0
46287975	1119510	0	0
45800456	1119510	0	0
46290369	1119510	0	0
45787741	1119510	0	0
46302707	1551099	0	0
46314710	1124300	0	0
46305330	1125315	0	0
21000299	19133905	2	3
4199402	321042	6	8
21002491	1112807	0	0
21600036	975125	0	0
36156666	1361711	0	0
35700000	4116491	3	3
4227253	4310024	4	4
37602356	381316	5	5
44349052	1129625	0	0
44356456	1125315	0	0
44339160	933724	0	0
44358354	1548195	0	0
45622309	1154343	0	0
45628522	1177480	0	0
45634244	19078461	2	3
45644202	1501700	0	0
45632997	1119510	0	0
45633529	1713332	0	0
45655222	1177480	0	0
45779400	1125315	0	0
45683164	1107830	0	0
45687676	1115171	2	3
45696179	1125315	0	0
45685378	1119510	0	0
45684648	1119510	0	0
46287987	1119510	0	0
45800430	1119510	0	0
46290404	1119510	0	0
45787519	1119510	0	0
46302712	791967	0	0
46314715	1149196	0	0
46305332	1125315	0	0
21000299	19133873	2	3
4212577	4048171	6	7
21002491	1115008	0	0
21500949	1129625	0	0
36156654	1000560	0	0
35700000	440448	3	11
4227253	255848	4	4
37602356	321042	5	5
44349057	975125	0	0
44356425	1125315	0	0
44339523	920293	0	0
44358359	1307863	0	0
45622358	1512674	0	0
45628188	1177480	0	0
45626850	1107882	2	3
45644289	1102527	0	0
45633002	1119510	0	0
45633385	1174888	0	0
45700760	1177480	0	0
45779393	1125315	0	0
45679895	1124300	0	0
45687677	19059056	2	3
45696129	1125315	0	0
45685383	1119510	0	0
45684736	1119510	0	0
46243137	1119510	0	0
45800485	1119510	0	0
46290385	1119510	0	0
45787490	1119510	0	0
46302814	1549786	0	0
46314856	1149196	0	0
46305211	1125315	0	0
21000292	46233988	2	3
4274025	4219399	6	7
21002491	1118084	0	0
21501230	967823	0	0
36156659	967823	0	0
35700000	30753	3	9
4227253	196456	4	4
40782662	3010813	5	5
44349058	723013	0	0
44356489	1125315	0	0
44339526	1332418	0	0
44358364	738818	0	0
45622358	19127890	0	0
45628354	1177480	0	0
45623747	19078461	2	3
45644423	1539403	0	0
45633974	1119510	0	0
45633388	1115008	0	0
45701541	1177480	0	0
45779395	1125315	0	0
45679880	1501700	0	0
45687598	1115171	2	3
45696256	1125315	0	0
45799949	1119510	0	0
45684607	1119510	0	0
46243140	1119510	0	0
45800473	1119510	0	0
46290474	1119510	0	0
45787613	1119510	0	0
46302816	738818	0	0
46317595	1778162	0	0
46305217	1125315	0	0
21000230	46233710	2	3
4274025	321042	6	8
21002412	1746114	0	0
21500050	1308738	0	0
36156669	791967	0	0
35700000	4027663	3	8
4181063	133834	4	4
40782662	3026361	5	5
44348777	791967	0	0
44356574	1125315	0	0
44339023	738818	0	0
44358327	738818	0	0
45622358	1549786	0	0
45628343	1177480	0	0
45646896	1107882	2	3
45644506	914335	0	0
45633953	1119510	0	0
45633395	791967	0	0
45701641	1177480	0	0
45779337	1125315	0	0
45679882	1124957	0	0
45687551	40163554	2	3
45696190	1125315	0	0
45800006	1119510	0	0
45684803	1119510	0	0
46242899	1119510	0	0
45800579	1119510	0	0
46290527	1119510	0	0
45787616	1119510	0	0
46302823	1551099	0	0
46317740	1551099	0	0
46307146	1125315	0	0
21000230	46233988	2	3
4274025	4152936	6	8
21002475	1515774	0	0
21500095	742185	0	0
36156791	1125315	0	0
35700000	81893	3	13
36200000	40479768	6	11
40772935	3009201	5	5
44348887	914335	0	0
44356647	1125315	0	0
44341844	1125315	0	0
44358532	1110410	0	0
45622359	1110410	0	0
45628703	1177480	0	0
45626519	1332419	2	3
45644510	791967	0	0
45634008	1119510	0	0
45633396	738818	0	0
45701794	1177480	0	0
45779181	1125315	0	0
45679885	1124957	0	0
45687576	19078924	2	3
45696280	1125315	0	0
45800041	1119510	0	0
45684990	1119510	0	0
46242917	1119510	0	0
45800635	1119510	0	0
46290529	1119510	0	0
45787777	1119510	0	0
46302682	1713332	0	0
46317753	920293	0	0
46306699	1125315	0	0
21000291	46233710	2	3
4339468	4048171	6	6
21002475	19127890	0	0
21500108	1500211	0	0
36156795	1551099	0	0
35700000	192671	3	7
36200000	381316	6	6
37302322	134438	5	5
44348890	1149196	0	0
44356560	1125315	0	0
44341889	1125315	0	0
44358535	1124300	0	0
45622249	975125	0	0
45628642	1177480	0	0
45662947	19075601	2	3
45644469	1124957	0	0
45634033	1119510	0	0
45633401	1713332	0	0
45701779	1177480	0	0
45779373	1125315	0	0
45679602	1501700	0	0
45687224	19008572	2	3
45696285	1125315	0	0
45799719	1119510	0	0
45684726	1119510	0	0
46243230	1119510	0	0
45800545	1119510	0	0
46290602	1119510	0	0
45801201	1119510	0	0
46302691	967823	0	0
46317667	1118084	0	0
46306700	1125315	0	0
21000291	46233988	2	3
4339410	4230399	6	6
21002475	1595799	0	0
21013948	1738521	0	0
36156797	1149196	0	0
35700000	4112343	5	11
36200000	4329847	6	6
37203758	441267	5	5
44348903	1713332	0	0
44349172	1125315	0	0
44342040	1125315	0	0
44358515	1118084	0	0
45622326	19127890	0	0
45625365	1177480	0	0
45650526	19078461	2	3
45644447	1326303	0	0
45659136	1129625	0	0
45633401	1759842	0	0
45701769	1177480	0	0
45779374	1125315	0	0
45679927	1115008	0	0
45691641	1129625	0	0
45696292	1125315	0	0
45799720	1119510	0	0
45684727	1119510	0	0
46243181	1119510	0	0
45800718	1119510	0	0
46290875	1119510	0	0
45802364	1119510	0	0
46302928	1551099	0	0
46317813	1738521	0	0
46306550	1125315	0	0
21000285	46233710	2	3
4199402	4116491	6	6
21002491	1515774	0	0
21002644	975125	0	0
36156800	1119510	0	0
35700000	4285898	4	12
36200000	4094814	6	6
40786239	3001488	5	5
44348904	1192710	0	0
44349407	1125315	0	0
44341998	1125315	0	0
44358931	975125	0	0
45622326	1549786	0	0
45625294	1177480	0	0
45650307	19075601	2	3
45644539	1149196	0	0
45659251	1129625	0	0
45633339	1308738	0	0
45701866	1177480	0	0
45779375	1125315	0	0
45679928	1110410	0	0
45691634	1129625	0	0
45696234	1125315	0	0
45682525	1119510	0	0
45681281	1119510	0	0
46243067	1119510	0	0
45800720	1119510	0	0
46291019	1119510	0	0
45802515	1119510	0	0
46302772	975125	0	0
46317359	1192710	0	0
46321686	1125315	0	0
21000295	46233988	2	3
4279903	4198190	6	6
21002475	1589505	0	0
21002630	1551099	0	0
36156518	1125315	0	0
35700000	4166224	4	11
36200000	81151	4	11
37602356	4310024	6	6
44349114	723013	0	0
44349357	1125315	0	0
44342052	1125315	0	0
44358936	1713332	0	0
45622281	1501700	0	0
45625647	1177480	0	0
45641708	1107882	2	3
45644449	1343916	0	0
45657275	1129625	0	0
45633341	975125	0	0
45701973	1177480	0	0
45779376	1125315	0	0
45679818	1738521	0	0
45691763	1129625	0	0
45696158	1125315	0	0
45682286	1119510	0	0
45682671	1119510	0	0
46243220	1119510	0	0
45800607	1119510	0	0
46290686	1119510	0	0
45802230	1119510	0	0
46302777	1192710	0	0
46315091	1545958	0	0
46321817	1125315	0	0
21000295	46233710	2	3
4300157	78272	6	6
21002491	1589505	0	0
21002642	975125	0	0
36156764	1713332	0	0
35700000	28060	4	9
36200000	4132546	4	9
37600000	321042	6	6
44349077	1589505	0	0
44349352	1125315	0	0
44341921	1125315	0	0
44358440	1107830	0	0
45622429	1154029	0	0
45625635	1177480	0	0
45638661	40228214	2	3
45644424	1500211	0	0
45657290	1129625	0	0
45633494	1521369	0	0
45701855	1177480	0	0
45779392	1125315	0	0
45679945	1332418	0	0
45691819	1129625	0	0
45696159	1125315	0	0
45794884	1119510	0	0
45681849	1119510	0	0
46243212	1119510	0	0
45800500	1119510	0	0
46290743	1119510	0	0
45802594	1119510	0	0
46302782	1154029	0	0
46315316	1310149	0	0
46321698	1125315	0	0
21000297	46233710	2	3
4213310	4043241	6	6
21002350	920293	0	0
21002630	975125	0	0
36156765	1149196	0	0
35700000	4310024	4	9
36200000	4156265	4	9
37600000	4163874	6	6
44349077	1549786	0	0
44349447	1125315	0	0
44342230	1125315	0	0
44358396	1174888	0	0
45622507	738818	0	0
45625748	1177480	0	0
45644544	40228214	2	3
45644544	1149196	0	0
45657024	1129625	0	0
45633211	1107830	0	0
45698881	1177480	0	0
45779166	1125315	0	0
45679835	1115008	0	0
45691859	1129625	0	0
45696160	1125315	0	0
45794946	1119510	0	0
45681941	1119510	0	0
46243122	1119510	0	0
45800711	1119510	0	0
46291113	1119510	0	0
45801237	1119510	0	0
46302788	1149196	0	0
46315100	975125	0	0
46321723	1125315	0	0
21000297	46233988	2	3
4215217	4149245	3	3
21002475	1521369	0	0
21002642	1149380	0	0
36156777	1000560	0	0
35700000	4266809	4	9
36200000	4149245	4	5
40783186	3008598	6	6
44348968	1174888	0	0
44349610	1125315	0	0
44341941	1125315	0	0
44358400	753626	0	0
45622508	975125	0	0
45624965	1177480	0	0
45665409	40173590	2	3
45644392	708298	0	0
45657050	1129625	0	0
45633348	975125	0	0
45698895	1177480	0	0
45779396	1125315	0	0
45682297	1738521	0	0
45691848	1129625	0	0
45696274	1125315	0	0
45794911	1119510	0	0
45681735	1119510	0	0
46243126	1119510	0	0
45800818	1119510	0	0
46290845	1119510	0	0
45801285	1119510	0	0
46302973	975125	0	0
46315120	1118084	0	0
46321727	1125315	0	0
21000301	46233710	2	3
4320791	4048171	3	3
21002475	1500211	0	0
21002655	1551099	0	0
36156778	1129625	0	0
35802131	378001	8	10
36200000	4048695	4	10
36425574	19008572	2	3
44348972	1149380	0	0
44349376	1125315	0	0
44342110	1125315	0	0
44358402	1124300	0	0
45622371	975125	0	0
45622533	1177480	0	0
45621852	19073188	2	3
45644396	738818	0	0
45657055	1129625	0	0
45633353	1548195	0	0
45698676	1177480	0	0
45779397	1125315	0	0
45682300	1361711	0	0
45688819	1129625	0	0
45696482	1125315	0	0
45794918	1119510	0	0
45681862	1119510	0	0
46244713	1119510	0	0
45800537	1119510	0	0
46242437	1119510	0	0
45801227	1119510	0	0
46303060	1595799	0	0
46315192	1154029	0	0
46321831	1125315	0	0
21000301	46233988	2	3
4276572	439777	3	3
21002475	1503184	0	0
21002644	1149380	0	0
36156533	1129625	0	0
35802131	4112343	7	10
36200000	4299128	3	7
36502202	4218389	3	3
44348974	1192710	0	0
44349749	1125315	0	0
44341873	1125315	0	0
44358416	1124300	0	0
45622432	1174888	0	0
45622432	1177480	0	0
45621852	19073183	2	3
45644617	1000560	0	0
45657336	1129625	0	0
45633246	1343916	0	0
45698861	1177480	0	0
45779398	1125315	0	0
45682301	1154343	0	0
45688825	1129625	0	0
45696485	1125315	0	0
45679135	1119510	0	0
45678530	1119510	0	0
46244721	1119510	0	0
45800614	1119510	0	0
46242354	1119510	0	0
45801274	1119510	0	0
46303060	1308738	0	0
46315357	1149380	0	0
46321792	1125315	0	0
21000290	46233710	2	3
4195979	4324181	3	3
21002475	1549786	0	0
21002642	1551099	0	0
36156534	1115008	0	0
35802131	4294548	7	10
36200000	4296204	3	8
36302183	4314290	3	3
44348984	1192710	0	0
44349601	1125315	0	0
44341876	1125315	0	0
44358529	1192710	0	0
45622597	1115008	0	0
45622477	1177480	0	0
45660082	19075601	2	3
45644662	967823	0	0
45655371	1129625	0	0
45633612	791967	0	0
45698828	1177480	0	0
45779401	1125315	0	0
45682315	1174888	0	0
45688772	1129625	0	0
45696487	1125315	0	0
45679342	1119510	0	0
45678889	1119510	0	0
46240867	1119510	0	0
45797763	1119510	0	0
46242356	1119510	0	0
45801279	1119510	0	0
46303016	1738521	0	0
46315360	967823	0	0
46316294	1125315	0	0
21000290	46233988	2	3
4200516	4132546	3	3
21002421	1741122	0	0
21002655	975125	0	0
36156790	1149196	0	0
35802131	257012	7	9
36200000	375671	3	11
36313913	4243062	3	3
44348985	1713332	0	0
44349557	1125315	0	0
44341934	1125315	0	0
44358441	1738521	0	0
45622434	1589505	0	0
45620829	1177480	0	0
45623627	19075601	2	3
45644667	1308738	0	0
45655474	1129625	0	0
45633310	1192710	0	0
45698953	1177480	0	0
45779402	1125315	0	0
45682393	1551099	0	0
45688849	1129625	0	0
45696244	1125315	0	0
45679248	1119510	0	0
45678875	1119510	0	0
46240870	1119510	0	0
45797876	1119510	0	0
46242517	1119510	0	0
45801352	1119510	0	0
46303295	738818	0	0
46315362	1112807	0	0
46316047	1125315	0	0
21000825	1551192	2	3
4215685	4323208	3	3
21002487	1548195	0	0
21002658	975125	0	0
36156920	1125315	0	0
35802131	40481087	7	9
36200000	4237458	3	10
36313913	4163872	3	3
44348471	1107830	0	0
44349875	1125315	0	0
44342213	1125315	0	0
44358369	782043	0	0
45622438	1713332	0	0
45621212	1177480	0	0
45629310	19075601	2	3
45644537	1548195	0	0
45655466	1129625	0	0
45633626	1548195	0	0
45699005	1177480	0	0
45777897	1125315	0	0
45682133	1107830	0	0
45688867	1129625	0	0
45696251	1125315	0	0
45679449	1119510	0	0
45678899	1119510	0	0
46240751	1119510	0	0
45797880	1119510	0	0
46242245	1119510	0	0
45795739	1119510	0	0
46303074	723013	0	0
46315362	1192710	0	0
46316404	1125315	0	0
21000717	1551192	2	3
4200532	4116491	3	3
21002491	1521369	0	0
21002663	1551099	0	0
36156920	1119510	0	0
35802131	4001336	7	9
35702118	30753	4	5
36402186	40480160	3	3
44349060	1124957	0	0
44350015	1125315	0	0
44342090	1125315	0	0
44358318	1124300	0	0
45622375	1000560	0	0
45621069	1177480	0	0
45647267	19075601	2	3
45641434	1149380	0	0
45653998	1129625	0	0
45633360	1545958	0	0
45699106	1177480	0	0
45778009	1125315	0	0
45661548	1112807	0	0
45686179	1129625	0	0
45696322	1125315	0	0
45792052	1119510	0	0
45673188	1119510	0	0
46240754	1119510	0	0
45797800	1119510	0	0
46239753	1119510	0	0
45795841	1119510	0	0
46303214	933724	0	0
46315161	1589505	0	0
46316605	1125315	0	0
21000705	1539411	2	3
4339468	372328	3	3
21002487	1512674	0	0
21002663	975125	0	0
36156921	1119510	0	0
35802131	28060	7	8
35702118	4266809	4	5
36400000	140673	3	3
44348640	967823	0	0
44350046	1125315	0	0
44342093	1125315	0	0
44358569	742185	0	0
45622452	975125	0	0
45664799	1177480	0	0
45640112	19078461	2	3
45641366	1154029	0	0
45647365	1129625	0	0
45633362	967823	0	0
45695724	1177480	0	0
45777932	1125315	0	0
45661613	1112807	0	0
45686055	1129625	0	0
45696327	1125315	0	0
45792059	1119510	0	0
45673296	1119510	0	0
46240949	1119510	0	0
45797931	1119510	0	0
46239628	1119510	0	0
45795785	1119510	0	0
46303526	1332418	0	0
46315176	975125	0	0
46316693	1125315	0	0
21000819	1551192	2	3
4339468	4283893	3	3
21002487	1500211	0	0
21002673	1551099	0	0
36156921	1192710	0	0
35802131	372328	7	7
35702118	4310024	4	5
36400000	80502	3	3
44348641	1713332	0	0
44341760	1125315	0	0
44342073	1125315	0	0
44358668	1124300	0	0
45622485	967823	0	0
45664830	1177480	0	0
45647307	19075601	2	3
45641370	1717327	0	0
45647399	1129625	0	0
45633437	1124300	0	0
45695719	1177480	0	0
45777915	1125315	0	0
45660174	1112807	0	0
45686159	1129625	0	0
45696333	1125315	0	0
45792061	1119510	0	0
45673297	1119510	0	0
46240954	1119510	0	0
45797717	1119510	0	0
46240102	1119510	0	0
45795761	1119510	0	0
46303534	1549786	0	0
46315178	1112807	0	0
46316546	1125315	0	0
21000701	1539411	2	3
4302076	4202451	3	3
21002487	1549786	0	0
21002673	975125	0	0
36156867	1177480	0	0
35802131	381316	7	7
35702118	4166224	5	7
36302170	4191853	3	3
44348645	1545958	0	0
44341801	1125315	0	0
44342086	1125315	0	0
44358470	1307863	0	0
45622493	1115008	0	0
45664775	1177480	0	0
45660111	19078461	2	3
45641463	19003953	0	0
45647547	1129625	0	0
45633647	1000560	0	0
45695789	1177480	0	0
45777903	1125315	0	0
45704017	1112807	0	0
45688620	1129625	0	0
45696609	1125315	0	0
45792199	1119510	0	0
45672726	1119510	0	0
46241090	1119510	0	0
45797946	1119510	0	0
46240271	1119510	0	0
45795808	1119510	0	0
46303534	1521369	0	0
46315346	967823	0	0
46316378	1125315	0	0
21000713	1551192	2	3
4317258	4296204	3	3
21002487	1521369	0	0
21600973	1367571	0	0
36156863	1124300	0	0
35802131	380378	7	7
35702118	440448	6	7
36517012	4149245	3	3
44349083	933724	0	0
44342122	1125315	0	0
44342305	1125315	0	0
44358586	1115008	0	0
45620913	1515774	0	0
45664503	1177480	0	0
45665357	1539411	2	3
45641481	1713332	0	0
45647613	1129625	0	0
45633505	1557272	0	0
45692382	1177480	0	0
45777873	1125315	0	0
45703792	1112807	0	0
45688547	1129625	0	0
45696610	1125315	0	0
45792181	1119510	0	0
45672670	1119510	0	0
46240624	1119510	0	0
45797962	1119510	0	0
46240274	1119510	0	0
45795949	1119510	0	0
46303534	1595799	0	0
46315311	1545958	0	0
46316182	1125315	0	0
21000706	1545959	2	3
4198525	28060	3	3
21002491	19127890	0	0
21600989	1322184	0	0
36156887	1129625	0	0
35802131	4048171	6	11
35702118	81893	7	9
36517140	4149245	3	3
44349037	1149380	0	0
44341805	1125315	0	0
44342317	1125315	0	0
44358601	738818	0	0
45620913	19127890	0	0
45664494	1177480	0	0
45621505	1332419	2	3
45641527	1149196	0	0
45647887	1129625	0	0
45633402	1713332	0	0
45692512	1177480	0	0
45707835	1125315	0	0
45651724	1112807	0	0
45682844	1129625	0	0
45696351	1125315	0	0
45792210	1119510	0	0
45672690	1119510	0	0
46240641	1119510	0	0
45797980	1119510	0	0
46240288	1119510	0	0
45795851	1119510	0	0
46302984	1153428	0	0
46309480	1112807	0	0
46316188	1125315	0	0
21000706	1539411	2	3
4198525	4310024	3	3
21002481	1500211	0	0
21600991	1112807	0	0
36156887	1125315	0	0
35802131	4283893	6	8
36000000	433644	5	5
36313275	439777	3	3
44349041	1129625	0	0
44342127	1125315	0	0
44337836	1125315	0	0
44358609	1154343	0	0
45620913	1549786	0	0
45662328	1177480	0	0
45621811	19078461	2	3
45641531	1149196	0	0
45648040	1129625	0	0
45633403	1501700	0	0
45692400	1177480	0	0
45707807	1125315	0	0
45651755	1112807	0	0
45683085	1129625	0	0
45696651	1125315	0	0
45792376	1119510	0	0
45672640	1119510	0	0
46240043	1119510	0	0
45797991	1119510	0	0
46240237	1119510	0	0
45795813	1119510	0	0
46302992	1124957	0	0
46309493	1192710	0	0
46316191	1125315	0	0
21000716	19019273	2	3
4344497	4296204	3	3
21002433	1746114	0	0
21502622	1759842	0	0
36156888	1112807	0	0
35802131	4132546	6	8
36000000	4219399	5	5
36206173	3009542	3	5
44349049	1000560	0	0
44341839	1125315	0	0
44363316	1125315	0	0
44358478	1713332	0	0
45620869	1539403	0	0
45662341	1177480	0	0
45665555	40228214	2	3
45641563	1153428	0	0
45644533	1129625	0	0
45633404	1000560	0	0
45692532	1177480	0	0
45707761	1125315	0	0
45651450	1112807	0	0
45683103	1129625	0	0
45696616	1125315	0	0
45675985	1119510	0	0
45672718	1119510	0	0
46238277	1119510	0	0
45798009	1119510	0	0
45896211	1119510	0	0
45795876	1119510	0	0
46302914	742185	0	0
46309593	1112807	0	0
46304087	19075601	2	3
21000716	19078461	2	3
4215793	44805732	3	3
21002434	1741122	0	0
21502683	723013	0	0
36156888	1125315	0	0
35802131	4029498	6	6
36000000	40486433	4	6
36416670	439777	3	5
44349070	1112807	0	0
44345231	1501700	0	0
44363354	1125315	0	0
44358621	933724	0	0
45620807	1124300	0	0
45662412	1177480	0	0
45653787	40228214	2	3
45641446	1124300	0	0
45644700	1129625	0	0
45633522	19010482	0	0
45692567	1177480	0	0
45707778	1125315	0	0
45651712	1112807	0	0
45682752	1129625	0	0
45696408	1125315	0	0
45676035	1119510	0	0
45672719	1119510	0	0
46238361	1119510	0	0
45799744	1119510	0	0
45896304	1119510	0	0
45796000	1119510	0	0
46302916	967823	0	0
46309531	791967	0	0
46304684	19075601	2	3
21000716	19019979	2	3
4200532	40481087	3	4
21002434	1746114	0	0
21500450	1713332	0	0
36156866	1149196	0	0
35802131	4285898	5	5
36000000	4280726	3	6
36502196	40480160	3	6
44349118	19127890	0	0
44345068	1729720	0	0
44363468	1125315	0	0
44358612	1343916	0	0
45620859	1713332	0	0
45662537	1177480	0	0
45667529	40228214	2	3
45641539	1332418	0	0
45644762	1129625	0	0
45633554	1149196	0	0
45692618	1177480	0	0
45707877	1125315	0	0
45651701	1112807	0	0
45683090	1129625	0	0
45696695	1125315	0	0
45676440	1119510	0	0
45784507	1119510	0	0
45897247	1119510	0	0
45795194	1119510	0	0
45896400	1119510	0	0
45790405	1119510	0	0
46303456	1110410	0	0
46309533	1589505	0	0
46310004	19075601	2	3
21000716	1115171	2	3
4260918	4048695	3	4
21002491	1548195	0	0
21500523	723013	0	0
36156949	1149196	0	0
35802131	195588	5	5
36000000	4048171	5	7
36502202	4146173	3	9
44349118	1515774	0	0
44345171	1149196	0	0
44363480	1125315	0	0
44358613	914335	0	0
45620884	1713332	0	0
45659296	1177480	0	0
45663078	40228214	2	3
45641581	1539403	0	0
45644840	1129625	0	0
45633557	738818	0	0
45689416	1177480	0	0
45707862	1125315	0	0
45697847	1112807	0	0
45683356	1129625	0	0
45696423	1125315	0	0
45789127	1119510	0	0
45784515	1119510	0	0
45897254	1119510	0	0
45795355	1119510	0	0
45896436	1119510	0	0
45790527	1119510	0	0
46300425	975125	0	0
46310079	1192710	0	0
46301275	19075601	2	3
4274025	134438	2	7
4260918	4066995	3	4
21002670	1738521	0	0
21602660	933724	0	0
36156536	1545958	0	0
36151533	19133905	2	3
36000000	4048695	7	8
36500000	4066995	3	9
44349118	1549786	0	0
44345177	1149380	0	0
44363831	1125315	0	0
44358656	1713332	0	0
45620833	1154343	0	0
45659218	1177480	0	0
45663013	40228214	2	3
45641384	1107830	0	0
45644867	1129625	0	0
45633687	1192710	0	0
45691545	1177480	0	0
45707921	1125315	0	0
45648504	1112807	0	0
45682916	1129625	0	0
45696430	1125315	0	0
45789128	1119510	0	0
45784520	1119510	0	0
45897145	1119510	0	0
45795631	1119510	0	0
45896611	1119510	0	0
45790647	1119510	0	0
46300250	1000560	0	0
46309296	1551099	0	0
46304570	19075601	2	3
4274025	4084167	2	5
4197094	4166224	3	4
21002677	975125	0	0
21601626	1361711	0	0
36156924	1539403	0	0
36151533	19133873	2	3
36202157	4152936	4	9
36302170	4010253	3	8
44349122	1192710	0	0
44345154	1000560	0	0
44363530	1125315	0	0
44358661	1115008	0	0
45620917	1738521	0	0
45659239	1177480	0	0
45663013	40228230	2	3
45641386	1149196	0	0
45641814	1129625	0	0
45633688	1149196	0	0
45691551	1177480	0	0
45707867	1125315	0	0
45648816	1112807	0	0
45683474	1129625	0	0
45692966	1125315	0	0
45789384	1119510	0	0
45784600	1119510	0	0
45897179	1119510	0	0
45795304	1119510	0	0
45894133	1119510	0	0
45790576	1119510	0	0
46300331	1107830	0	0
46309540	1738521	0	0
46310187	19075601	2	3
4274025	4043241	2	11
19127890	40221415	3	4
21002686	975125	0	0
35507532	1107830	0	0
36156697	1000560	0	0
36151502	40231925	2	3
36202157	4001336	4	9
36516993	81151	3	7
44349125	1118084	0	0
44345179	723013	0	0
44363577	1125315	0	0
44351379	1729720	0	0
45620924	1396131	0	0
44341741	1177480	0	0
45657184	19078461	2	3
45641387	1115008	0	0
45641911	1129625	0	0
45633658	967823	0	0
45686733	1177480	0	0
45707991	1125315	0	0
45648790	1112807	0	0
45679812	1129625	0	0
45693144	1125315	0	0
45789324	1119510	0	0
45784585	1119510	0	0
45897416	1119510	0	0
45795378	1119510	0	0
45894087	1119510	0	0
45790478	1119510	0	0
46300252	967823	0	0
46309660	1332418	0	0
46305964	19075601	2	3
4043346	261325	2	4
4339468	4294548	3	5
21002659	1551099	0	0
35507270	1125315	0	0
36156700	967823	0	0
36151488	1127433	2	3
36202157	4146173	4	9
36206173	3001488	3	8
44349128	1177480	0	0
44345423	738818	0	0
44363579	1125315	0	0
44351293	738818	0	0
45620925	967823	0	0
44358074	1177480	0	0
45659698	40228214	2	3
45641516	1115008	0	0
45638611	1129625	0	0
45633666	1192710	0	0
45686865	1177480	0	0
45704945	1125315	0	0
45648919	1112807	0	0
45660102	1119510	0	0
45693232	1125315	0	0
45789330	1119510	0	0
45784536	1119510	0	0
45897217	1119510	0	0
45792549	1119510	0	0
45894089	1119510	0	0
45790479	1119510	0	0
46300379	1192710	0	0
46309847	1149196	0	0
46313884	19075601	2	3
4043679	4134304	2	4
4339410	40480160	3	5
21002671	975125	0	0
35507270	1119510	0	0
36156701	1107830	0	0
36151411	1115171	2	3
36202157	4142905	4	9
36206173	3010813	3	8
44348797	1124957	0	0
44345292	1521369	0	0
44363992	1125315	0	0
44351356	738818	0	0
45621021	1332418	0	0
44357763	1177480	0	0
45638517	19079524	2	3
45641498	1124300	0	0
45638617	1129625	0	0
45633672	791967	0	0
45686915	1177480	0	0
45704947	1125315	0	0
45649154	1112807	0	0
45661667	1119510	0	0
45693239	1125315	0	0
45789512	1119510	0	0
45784708	1119510	0	0
45897306	1119510	0	0
45792719	1119510	0	0
45798492	1125315	0	0
45790448	1119510	0	0
46300301	1174888	0	0
46309793	1112807	0	0
46315974	19075601	2	3
4042503	78272	2	4
4200532	4294548	3	5
21002671	1149380	0	0
35507402	1551099	0	0
36156705	1149380	0	0
36151545	40223834	2	3
36202157	378001	5	10
36206173	3015632	3	7
44348801	1115008	0	0
44345365	1332418	0	0
44363616	1125315	0	0
44351338	1545958	0	0
45621024	967823	0	0
44357767	1177480	0	0
45632131	40228214	2	3
45641409	1367571	0	0
45638690	1129625	0	0
45633411	1545958	0	0
45683575	1177480	0	0
45705040	1125315	0	0
45646016	1112807	0	0
45660175	1119510	0	0
45693126	1125315	0	0
45786491	1119510	0	0
45784629	1119510	0	0
45897355	1119510	0	0
45792666	1119510	0	0
45798333	1125315	0	0
45790485	1119510	0	0
46300307	715997	0	0
46309793	1192710	0	0
46309761	1539411	2	3
4032251	4058899	2	4
4200532	4112343	3	5
21002682	1551099	0	0
35507406	1738521	0	0
36156889	1115008	0	0
36151550	920334	2	3
36202157	4048695	5	9
36206173	3024731	3	7
44349087	1124300	0	0
44345376	1124957	0	0
44363624	1125315	0	0
44351505	1137529	0	0
45621027	1124300	0	0
44357970	1177480	0	0
45623393	19079524	2	3
45641419	738818	0	0
45638794	1129625	0	0
45633752	1124957	0	0
45683655	1177480	0	0
45705096	1125315	0	0
45645620	1112807	0	0
45658302	1119510	0	0
45694838	1125315	0	0
45786835	1119510	0	0
45784696	1119510	0	0
45894946	1119510	0	0
45792588	1119510	0	0
45798334	1125315	0	0
45790586	1119510	0	0
46300426	1332418	0	0
46309897	1549786	0	0
46310959	19078461	2	3
4199402	4237458	2	4
4339468	4112343	3	6
21002491	1549786	0	0
35507500	1153428	0	0
36156890	1107830	0	0
36199695	1115171	2	3
36202157	4066995	3	9
36206173	3021226	3	7
44349099	1310149	0	0
44345377	1112807	0	0
44363639	1125315	0	0
44351505	1149380	0	0
45620983	1137529	0	0
44354810	1177480	0	0
45665401	40228214	2	3
45641637	1115008	0	0
45638923	1129625	0	0
45630399	1326303	0	0
45683738	1177480	0	0
45704677	1125315	0	0
45645744	1112807	0	0
45658285	1119510	0	0
45694841	1125315	0	0
45786658	1119510	0	0
45784799	1119510	0	0
45894939	1119510	0	0
45794463	1119510	0	0
45798531	1125315	0	0
45790590	1119510	0	0
46300387	1192710	0	0
46309897	1589505	0	0
46313551	1539411	2	3
4042504	4024289	2	4
4309188	440448	3	6
21002493	1595799	0	0
35507502	1129625	0	0
36156892	1713332	0	0
36151788	40232448	2	3
36202157	4132546	3	8
36206173	3000963	3	7
44352006	1177480	0	0
44345380	1129625	0	0
44363644	1125315	0	0
44351371	1589505	0	0
45620983	1149380	0	0
44354823	1177480	0	0
45656948	40228214	2	3
45641840	1545958	0	0
45638894	1129625	0	0
45630280	1149196	0	0
45683821	1177480	0	0
45705131	1125315	0	0
45642879	1112807	0	0
45658297	1119510	0	0
45693313	1125315	0	0
45786757	1119510	0	0
45784909	1119510	0	0
45894966	1119510	0	0
45794524	1119510	0	0
45798616	1125315	0	0
45790601	1119510	0	0
46300394	1551099	0	0
46309898	1149196	0	0
45803847	19078461	2	3
4042504	4252419	2	4
4215793	40492359	3	7
21002493	19054876	0	0
35507506	1112807	0	0
36156870	1118084	0	0
36152000	46275444	2	3
36202157	4059173	7	9
36206173	3008598	3	7
44352013	738818	0	0
44345383	1129625	0	0
44363789	1125315	0	0
44351269	738818	0	0
45620984	1192710	0	0
44354919	1177480	0	0
45667911	40228214	2	3
45641694	1174888	0	0
45635369	1129625	0	0
45629960	1343916	0	0
45680703	1177480	0	0
45705099	1125315	0	0
45639921	1112807	0	0
45658088	1119510	0	0
45693319	1125315	0	0
45786506	1119510	0	0
45784596	1119510	0	0
45895043	1119510	0	0
45792779	1119510	0	0
45798634	1125315	0	0
45790701	1119510	0	0
46300313	738818	0	0
46309541	1713332	0	0
45803796	19075601	2	3
4052083	4133840	1	1
4302537	4285898	3	9
21002499	1521369	0	0
35507514	1174888	0	0
36156625	1501700	0	0
36152110	19129655	2	3
36211303	40479422	7	8
36206173	3002385	3	7
44351917	1124300	0	0
44345384	1192710	0	0
44363495	1125315	0	0
44351429	933724	0	0
45620986	1192710	0	0
44354923	1177480	0	0
45663319	19079524	2	3
45641566	19127890	0	0
45635376	1129625	0	0
45630373	1192710	0	0
45680783	1177480	0	0
45705149	1125315	0	0
45685878	1112807	0	0
45658166	1119510	0	0
45693557	1125315	0	0
45786515	1119510	0	0
45784655	1119510	0	0
45895036	1119510	0	0
45792764	1119510	0	0
45798577	1125315	0	0
45790511	1119510	0	0
46300474	738818	0	0
46309704	1501700	0	0
46320913	19079524	2	3
4054058	4134304	1	1
4274025	4280726	3	9
21002505	1500211	0	0
35507516	1112807	0	0
36157202	1107830	0	0
36152112	19078461	2	3
36211303	40479768	7	8
36206173	3036780	3	7
44351536	742185	0	0
44345655	1149196	0	0
44363736	1125315	0	0
44351386	1154343	0	0
45620990	1713332	0	0
44351045	1177480	0	0
45665846	19078461	2	3
45641566	1549786	0	0
45635590	1129625	0	0
45630378	967823	0	0
45680773	1177480	0	0
45704689	1125315	0	0
45636698	1112807	0	0
45658168	1119510	0	0
45693563	1125315	0	0
45786934	1119510	0	0
45784765	1119510	0	0
45895143	1119510	0	0
45792882	1119510	0	0
45798582	1125315	0	0
45790514	1119510	0	0
46300478	1124300	0	0
46309716	933724	0	0
46304533	19079524	2	3
4043371	30753	1	1
4274025	198809	3	8
21002506	1595799	0	0
35507517	1307863	0	0
36157204	967823	0	0
36152087	40220386	2	3
36211123	4066995	0	1
36206173	3006923	3	6
44352081	1112807	0	0
44345529	1501700	0	0
44363609	1125315	0	0
44351399	1759842	0	0
45620995	967823	0	0
44350991	1177480	0	0
45665292	40228214	2	3
45641571	1153428	0	0
45637220	1129625	0	0
45630505	1501700	0	0
45680590	1177480	0	0
45705068	1125315	0	0
45636738	1112807	0	0
45704007	1119510	0	0
45690278	1125315	0	0
45786952	1119510	0	0
45784768	1119510	0	0
45895239	1119510	0	0
45792974	1119510	0	0
45798353	1125315	0	0
45790851	1119510	0	0
46300480	1192710	0	0
46309754	1545958	0	0
46311973	40228214	2	3
4043671	4283893	1	1
4302537	4112343	4	8
21002506	1589505	0	0
35507611	1115008	0	0
36157241	1124300	0	0
36152129	1115171	2	3
36211089	81151	0	2
36206173	3016723	3	6
44352091	1738521	0	0
44345530	1112807	0	0
44363768	1125315	0	0
44351399	1713332	0	0
45621153	738818	0	0
44350861	1177480	0	0
45626134	19078461	2	3
45641598	1539403	0	0
45636882	1129625	0	0
45630509	1174888	0	0
45680576	1177480	0	0
45705059	1125315	0	0
45636849	1112807	0	0
45704081	1119510	0	0
45690305	1125315	0	0
45786870	1119510	0	0
45784993	1119510	0	0
45895324	1119510	0	0
45789985	1119510	0	0
45798354	1125315	0	0
45790860	1119510	0	0
46300396	1545958	0	0
46309878	1118084	0	0
46310977	1539411	2	3
4194895	4246502	1	1
4326426	4330583	4	7
21002506	1515774	0	0
35507542	723013	0	0
36157205	1125315	0	0
36152138	19133873	2	3
35900000	198809	3	6
36206173	3013721	3	6
44352099	1118084	0	0
44345536	1149380	0	0
44356505	1125315	0	0
44351403	975125	0	0
45620835	1154029	0	0
44351125	1177480	0	0
45628895	40223768	2	3
45641708	1107830	0	0
45635709	1129625	0	0
45630306	740275	0	0
45680793	1177480	0	0
45633045	1119510	0	0
45636825	1112807	0	0
45703919	1119510	0	0
45690464	1125315	0	0
45786710	1119510	0	0
45784998	1119510	0	0
45895116	1119510	0	0
45790129	1119510	0	0
45798609	1125315	0	0
45790991	1119510	0	0
46300494	1778162	0	0
46309522	1545958	0	0
46305728	19078461	2	3
4195601	4238715	1	1
4274025	4310024	4	8
21002506	19127890	0	0
35507491	1125315	0	0
36157205	1119510	0	0
36002140	80809	2	3
36002139	4048171	4	6
36206173	3024561	3	6
44352150	1713332	0	0
44345717	1174888	0	0
44356538	1125315	0	0
44351561	1192710	0	0
45621050	1124300	0	0
44352409	1177480	0	0
45644426	19078461	2	3
45641545	738818	0	0
45635714	1129625	0	0
45630311	975125	0	0
45680869	1177480	0	0
45633048	1119510	0	0
45636850	1112807	0	0
45703977	1119510	0	0
45690475	1125315	0	0
45786920	1119510	0	0
45784999	1119510	0	0
45895170	1119510	0	0
45789901	1119510	0	0
45798442	1125315	0	0
46297464	1119510	0	0
46300500	1174888	0	0
46309527	1310149	0	0
46314715	40228214	2	3
4182210	378419	1	1
4274025	4329847	4	9
21002506	1521369	0	0
21003027	19078924	2	3
36157205	738818	0	0
35708136	4285898	2	3
35702120	81893	4	6
36206173	3009201	3	6
44351751	1174888	0	0
44345577	1129625	0	0
44356506	1125315	0	0
44351485	1545958	0	0
45620771	1115008	0	0
44352249	1177480	0	0
45632388	19079524	2	3
45641756	705944	0	0
45635768	1129625	0	0
45630012	1115008	0	0
45680558	1177480	0	0
45633070	1119510	0	0
45636770	1112807	0	0
45703780	1119510	0	0
45690554	1125315	0	0
45786922	1119510	0	0
45784647	1119510	0	0
45895333	1119510	0	0
45790142	1119510	0	0
45798563	1125315	0	0
46297721	1119510	0	0
46300429	1174888	0	0
46309685	975125	0	0
46311577	40228214	2	3
19131646	19132304	1	1
4274025	260139	4	9
21002506	1549786	0	0
21500003	19129655	2	3
36157208	1549786	0	0
36158638	19123231	2	3
36203042	4134304	4	6
36206173	3013682	3	6
44351697	705944	0	0
44345592	1129625	0	0
44356540	1125315	0	0
44351514	1551099	0	0
45620930	1115008	0	0
44351262	1177480	0	0
45626441	19078461	2	3
45641657	1738521	0	0
45636064	1129625	0	0
45630428	715997	0	0
45682564	1177480	0	0
45633141	1119510	0	0
45636966	1112807	0	0
45703903	1119510	0	0
45690397	1125315	0	0
45786844	1119510	0	0
45782403	1119510	0	0
45894407	1119510	0	0
45790159	1119510	0	0
45798555	1125315	0	0
46297955	1119510	0	0
46300436	920293	0	0
46309971	967823	0	0
45650761	40228214	2	3
19103127	19128022	1	1
4274025	4112343	4	10
21002501	1521369	0	0
21500003	19073183	2	3
36157242	1149196	0	0
36158295	1545959	2	3
35802133	4084167	5	6
36206173	3005136	3	6
44352265	1521369	0	0
44345297	1322184	0	0
44356667	1125315	0	0
44351487	1305058	0	0
45620842	1154029	0	0
44347148	1177480	0	0
45650156	19078461	2	3
45641550	19003953	0	0
45632667	1129625	0	0
45630429	1305058	0	0
45677662	1177480	0	0
45633144	1119510	0	0
45636971	1112807	0	0
45651693	1119510	0	0
45690387	1125315	0	0
45786794	1119510	0	0
45782408	1119510	0	0
45797544	738818	0	0
45790160	1119510	0	0
45798556	1125315	0	0
46297749	1119510	0	0
46300661	1305058	0	0
46309750	1310149	0	0
46320151	40228214	2	3
19103127	19128263	1	1
4274025	440086	4	6
21002501	1500211	0	0
21500003	19073188	2	3
36156969	1107830	0	0
36152204	19075001	2	3
36102970	198199	6	6
36206173	3035995	3	6
44349156	1361711	0	0
44345271	791967	0	0
44356620	1125315	0	0
44351522	1124300	0	0
45620893	1778162	0	0
44347450	1177480	0	0
45659660	40223768	2	3
45641553	1137529	0	0
45632801	1129625	0	0
45630447	738818	0	0
45677509	1177480	0	0
45633073	1119510	0	0
45633770	1112807	0	0
45651320	1119510	0	0
45690326	1125315	0	0
45786797	1119510	0	0
45782658	1119510	0	0
45797545	1000560	0	0
45789927	1119510	0	0
45793176	1125315	0	0
46297417	1119510	0	0
46300454	1551099	0	0
46309911	1118084	0	0
46314429	19079524	2	3
19103181	19023423	1	1
4302537	198809	4	6
21002493	1549786	0	0
21003038	19076374	2	3
36156939	1177480	0	0
36154384	19019273	2	3
36102898	4116491	6	6
36206173	3020630	3	6
44349254	975125	0	0
44345273	1115008	0	0
44356605	1125315	0	0
44351492	1713332	0	0
45620777	1501700	0	0
44347759	1177480	0	0
45667276	40223768	2	3
45641553	1149380	0	0
45632871	1129625	0	0
45630442	1713332	0	0
45677425	1177480	0	0
45676458	1119510	0	0
45633797	1112807	0	0
45651340	1119510	0	0
45690329	1125315	0	0
45786964	1119510	0	0
45782350	1119510	0	0
45797546	705944	0	0
45789810	1119510	0	0
45793267	1125315	0	0
46297354	1119510	0	0
46300214	1539403	0	0
46309557	701322	0	0
45675329	40228230	2	3
4027405	4301346	2	2
4302537	30753	4	6
21001768	1738521	0	0
21008439	1551192	2	3
36156622	920293	0	0
36150715	42707627	2	3
36103041	28060	6	6
36502198	4048695	3	4
44349255	1110410	0	0
44345277	1326303	0	0
44356610	1125315	0	0
44351497	1154343	0	0
45621205	1174888	0	0
44343619	1177480	0	0
45659823	19078461	2	3
45641556	1154343	0	0
45632844	1129625	0	0
45630152	1174888	0	0
45677695	1177480	0	0
45676733	1119510	0	0
45679586	1112807	0	0
45651444	1119510	0	0
45690492	1125315	0	0
45786886	1119510	0	0
45783667	1119510	0	0
45797547	1115008	0	0
45789909	1119510	0	0
45793277	1125315	0	0
46297649	1119510	0	0
46300484	1778162	0	0
46309582	1107830	0	0
45675329	40228214	2	3
4027405	44783196	2	2
4304916	4166224	4	6
21001769	1759842	0	0
21500012	19074841	2	3
36156623	1125315	0	0
36154509	42707627	2	3
36103041	433125	6	6
36502198	40480160	3	4
44349259	1177480	0	0
44345288	1501700	0	0
44356754	1125315	0	0
44351647	1124957	0	0
45620847	1000560	0	0
44343958	1177480	0	0
45665512	19078461	2	3
45641610	1149196	0	0
45632653	1129625	0	0
45630220	1326303	0	0
45677705	1177480	0	0
45676802	1119510	0	0
45630657	1112807	0	0
45652199	1119510	0	0
45690495	1125315	0	0
45786976	1119510	0	0
45783654	1119510	0	0
45797550	1326303	0	0
45790175	1119510	0	0
45793285	1125315	0	0
46297601	1119510	0	0
46300598	738818	0	0
46310153	1738521	0	0
45803895	40228214	2	3
4178367	4145310	2	2
4309188	4112343	4	6
21001770	1174888	0	0
21500012	19074843	2	3
36156871	1125315	0	0
36158041	46275444	2	3
36202155	4134304	5	7
36313913	4252419	3	4
44349183	1177480	0	0
44345497	1326303	0	0
44356672	1125315	0	0
44351371	1549786	0	0
45620848	740275	0	0
44340478	1177480	0	0
45632017	19078461	2	3
45641613	738818	0	0
45631083	1129625	0	0
45630262	1713332	0	0
45676231	1177480	0	0
45676915	1119510	0	0
45630961	1112807	0	0
45652016	1119510	0	0
45690556	1125315	0	0
45786237	1119510	0	0
45782749	1119510	0	0
45797438	1192710	0	0
45789992	1119510	0	0
45793109	1125315	0	0
46297973	1119510	0	0
46300689	740275	0	0
46309937	1112807	0	0
45896983	40228214	2	3
4155793	4145310	2	2
4339410	4142905	4	5
21001770	1192710	0	0
21500012	19075001	2	3
36157105	1115008	0	0
36158049	40162522	2	3
36202157	4218389	3	7
36424236	40221415	3	4
44349222	1738521	0	0
44345310	967823	0	0
44356707	1125315	0	0
44351453	1332418	0	0
45621199	791967	0	0
44340037	1177480	0	0
45647392	19078461	2	3
45641618	1174888	0	0
45629755	1129625	0	0
45630485	1501700	0	0
45676251	1177480	0	0
45676925	1119510	0	0
45627804	1112807	0	0
45652072	1119510	0	0
45690578	1125315	0	0
45786279	1119510	0	0
45782738	1119510	0	0
45797508	1589505	0	0
45790011	1119510	0	0
45793110	1125315	0	0
46297565	1119510	0	0
46300691	1149196	0	0
46309938	1738521	0	0
46309450	19079524	2	3
4042517	4295880	2	2
4339410	4237458	4	5
21601086	1396131	0	0
21002607	46275444	2	3
36157114	1125315	0	0
36157788	40229134	2	3
36202157	4113008	3	7
36424390	19127904	3	4
44349231	1112807	0	0
44345401	1177480	0	0
44356718	1125315	0	0
44351464	1738521	0	0
45621229	1153428	0	0
44340556	1177480	0	0
45623640	19078461	2	3
45641768	1310149	0	0
45629776	1129625	0	0
45630406	1153428	0	0
45671526	1177480	0	0
45676805	1119510	0	0
45627856	1112807	0	0
45651809	1119510	0	0
45690428	1125315	0	0
45786427	1119510	0	0
45782894	1119510	0	0
45797517	1713332	0	0
45790188	1119510	0	0
45793192	1125315	0	0
46297782	1119510	0	0
46301032	1738521	0	0
46310093	1154029	0	0
45803889	19079524	2	3
4181063	28060	2	2
4198525	4112343	4	5
21601080	1396131	0	0
21503947	40228230	2	3
36157114	1129625	0	0
36158197	19125062	2	3
36202157	4155034	4	7
36217216	40221415	3	4
44349278	1124300	0	0
44345408	1192710	0	0
44356662	1125315	0	0
44351788	701322	0	0
45621072	1713332	0	0
44340457	1177480	0	0
45659784	19078461	2	3
45641770	1551099	0	0
45629793	1129625	0	0
45631155	914335	0	0
45671490	1177480	0	0
45676788	1119510	0	0
45676165	1112807	0	0
45651815	1119510	0	0
45690511	1125315	0	0
45786575	1119510	0	0
45782775	1119510	0	0
45797538	1326303	0	0
45787436	1119510	0	0
45793194	1125315	0	0
46289024	1119510	0	0
46300823	1192710	0	0
46310094	1000560	0	0
45675419	40228214	2	3
4042837	140673	2	2
4266169	313217	4	5
21601081	1595799	0	0
21503947	40228214	2	3
36157117	1119510	0	0
36158342	1127433	2	3
36102970	4116491	5	7
40652446	3007461	2	2
44349161	1192710	0	0
44345519	738818	0	0
44356722	1125315	0	0
44351772	1539403	0	0
45621079	1118084	0	0
45620548	1177480	0	0
45634073	19078461	2	3
45641772	19010482	0	0
45626918	1129625	0	0
45631353	1713332	0	0
45671579	1177480	0	0
45676791	1119510	0	0
45670624	1112807	0	0
45697849	1119510	0	0
45691410	1125315	0	0
45785271	1119510	0	0
45782863	1119510	0	0
45797625	1000560	0	0
45787439	1119510	0	0
45793403	1125315	0	0
46289062	1119510	0	0
46300824	1501700	0	0
46310158	1192710	0	0
45650751	40228214	2	3
4042837	4218389	2	2
4322976	4058899	4	9
21502620	1174888	5	5
21013658	40223768	2	3
36157117	738818	0	0
36158293	43012036	2	3
36002139	4066995	6	7
40652446	3026361	2	2
44349166	1551099	0	0
44345523	1177480	0	0
44356776	1125315	0	0
44351466	1729720	0	0
45621083	1107830	0	0
45620462	1177480	0	0
45641544	19078461	2	3
45641782	1115008	0	0
45626949	1129625	0	0
45631250	715997	0	0
45673017	1177480	0	0
45676897	1119510	0	0
45670383	1112807	0	0
45697860	1119510	0	0
45691411	1125315	0	0
45785360	1119510	0	0
45780761	1119510	0	0
45797631	1110410	0	0
45787475	1119510	0	0
45793372	1125315	0	0
46289221	1119510	0	0
46300826	1174888	0	0
46310159	1124957	0	0
46315346	19079524	2	3
441840	78272	6	12
4322976	44783196	4	9
21500617	782047	5	6
21602823	1713671	2	3
36157117	1125315	0	0
36158294	1115171	2	3
36211303	40480160	7	7
40652446	3010813	2	2
44349169	1149196	0	0
44345477	1115008	0	0
44356970	1125315	0	0
44351559	1000560	0	0
45621086	1192710	0	0
45620562	1177480	0	0
45650181	19078461	2	3
45641783	967823	0	0
45626853	1129625	0	0
45631255	1124957	0	0
45673098	1177480	0	0
45676898	1119510	0	0
45669402	1112807	0	0
45700651	1119510	0	0
45687252	1125315	0	0
45785578	1119510	0	0
45780236	1119510	0	0
45797643	1115008	0	0
45787256	1119510	0	0
45793476	1125315	0	0
46289463	1119510	0	0
46300828	1000560	0	0
46310013	1545958	0	0
46316985	40223768	2	3
441840	4139681	6	7
4322976	4117038	4	9
21500617	19023398	5	6
21003042	19078924	2	3
36157133	1515774	0	0
36158331	19008572	2	3
36202157	381316	5	5
40779250	3020630	2	2
44349281	1112807	0	0
44345480	1738521	0	0
44356994	1125315	0	0
44351657	791967	0	0
45621089	1192710	0	0
45620356	1177480	0	0
45632519	19078461	2	3
45641786	738818	0	0
45628122	1129625	0	0
45631257	933724	0	0
45673312	1177480	0	0
45676901	1119510	0	0
45666963	1112807	0	0
45700658	1119510	0	0
45687254	1125315	0	0
45785398	1119510	0	0
45780328	1119510	0	0
45797644	1154343	0	0
45787263	1119510	0	0
45793480	1125315	0	0
46289536	1119510	0	0
46300860	1174888	0	0
46310045	1308738	0	0
46309028	40223768	2	3
441840	438614	6	7
4322976	4015189	4	8
21500164	40174880	5	6
21002036	19073183	2	3
36157133	1549786	0	0
36158436	1127433	2	3
36202157	4329847	5	5
37503868	4078793	2	2
44349289	1129625	0	0
44345483	738818	0	0
44356999	1125315	0	0
44351794	738818	0	0
45621186	1115008	0	0
44362331	1177480	0	0
45659971	19078461	2	3
45638373	1124957	0	0
45627079	1129625	0	0
45631261	975125	0	0
45671689	1177480	0	0
45676974	1119510	0	0
45666986	1112807	0	0
45648496	1119510	0	0
45687393	1125315	0	0
45785531	1119510	0	0
45780306	1119510	0	0
45797457	1308738	0	0
45787196	1119510	0	0
45793434	1125315	0	0
46289814	1119510	0	0
46300869	1332418	0	0
46309761	1539403	0	0
46309209	40223768	2	3
441840	4304110	6	7
376208	4296204	4	5
21500617	19078924	5	6
21002036	19073188	2	3
36157140	1149380	0	0
36158441	19008572	2	3
35809212	4048171	5	5
37503868	4337138	2	2
44349296	933724	0	0
44345484	1177480	0	0
44357009	1125315	0	0
44351800	1759842	0	0
45621197	738818	0	0
44362563	1177480	0	0
45663242	19078461	2	3
45638385	914335	0	0
45623928	1129625	0	0
45631069	1154029	0	0
45671665	1177480	0	0
45676958	1119510	0	0
45778455	1112807	0	0
45648785	1119510	0	0
45687472	1125315	0	0
45785683	1119510	0	0
45777762	1119510	0	0
45797458	1174888	0	0
45787269	1119510	0	0
45793439	1125315	0	0
46289559	1119510	0	0
46300839	1539403	0	0
46309781	1124957	0	0
45896529	40223768	2	3
441840	4169137	6	7
133468	4109685	4	5
21500205	19126352	5	6
21003084	40165015	2	3
36156944	1107830	0	0
36158218	1115171	2	3
36002141	4048171	5	5
40039807	19128022	2	2
44349244	1112807	0	0
44345776	1112807	0	0
44356854	1125315	0	0
44351800	1713332	0	0
45621198	1192710	0	0
44362515	1177480	0	0
45629431	19078461	2	3
45638216	1501700	0	0
45623822	1129625	0	0
45631073	1545958	0	0
45670042	1177480	0	0
45676941	1119510	0	0
45778443	1112807	0	0
45648787	1119510	0	0
45687556	1125315	0	0
45785389	1119510	0	0
45777723	1119510	0	0
45797685	740275	0	0
45787450	1119510	0	0
45793441	1125315	0	0
46289738	1119510	0	0
46301115	975125	0	0
46310167	1124957	0	0
46304867	19078461	2	3
441840	40486433	6	11
133468	4059173	4	5
21506173	1332419	5	6
21503948	40223821	2	3
36156947	1129625	0	0
36158520	40236824	2	3
36110015	4294548	5	5
40039807	19128263	2	2
44349413	1549786	0	0
44345783	1713332	0	0
44357104	1125315	0	0
44351803	1000560	0	0
45621158	967823	0	0
44362769	1177480	0	0
45623329	19078461	2	3
45640073	1115008	0	0
45623943	1129625	0	0
45631264	740275	0	0
45783754	1177480	0	0
45673431	1119510	0	0
45778417	1112807	0	0
45648849	1119510	0	0
45687507	1125315	0	0
45785391	1119510	0	0
45777726	1119510	0	0
45797575	1717327	0	0
45696301	1125315	0	0
45793294	1125315	0	0
46241559	1119510	0	0
46300894	1551099	0	0
46310204	791967	0	0
45675646	19078461	2	3
441840	4266809	6	9
376106	378419	4	5
21503224	1343916	0	0
21503948	1150771	2	3
36156947	1125315	0	0
36154376	40162522	2	3
36202155	40479768	5	5
40040565	19128009	2	2
44349389	1107830	0	0
44345789	1177480	0	0
44357024	1125315	0	0
44351961	1310149	0	0
45620953	967823	0	0
44354964	1177480	0	0
45623365	19078461	2	3
45639950	1000560	0	0
45623919	1129625	0	0
45630531	1174888	0	0
45783725	1177480	0	0
45673437	1119510	0	0
45778534	1112807	0	0
45648985	1119510	0	0
45687562	1125315	0	0
45783410	1119510	0	0
45777653	1119510	0	0
45797555	715997	0	0
45696381	1125315	0	0
45793301	1125315	0	0
46241705	1119510	0	0
46300631	701322	0	0
46310205	1361711	0	0
46320803	40223768	2	3
441840	4156265	6	9
440921	4109685	4	5
21503244	975125	0	0
21503948	1150837	2	3
36156948	1125315	0	0
36154716	40232448	2	3
36002139	40486433	3	5
36703530	4218389	2	2
44349417	1129625	0	0
44345410	1332418	0	0
44357049	1125315	0	0
44351658	738818	0	0
45620967	1343916	0	0
44355013	1177480	0	0
45626342	19078461	2	3
45638517	967823	0	0
45667989	1129625	0	0
45630532	1174888	0	0
45783995	1177480	0	0
45673676	1119510	0	0
45778511	1112807	0	0
45648846	1119510	0	0
45687571	1125315	0	0
45783351	1119510	0	0
45777803	1119510	0	0
45797519	1107830	0	0
45696384	1125315	0	0
45793308	1125315	0	0
46241646	1119510	0	0
46300852	1124957	0	0
46310115	791967	0	0
46320593	19078461	2	3
441840	198199	6	9
440921	4132546	4	5
21503264	1343916	0	0
21503948	19125062	2	3
36157080	1000560	0	0
36154612	40232448	2	3
36203042	4278672	3	3
40776205	3049273	2	2
44349317	1115008	0	0
44345416	1177480	0	0
44357187	1125315	0	0
44351715	1107830	0	0
45620968	1500211	0	0
44355052	1177480	0	0
45650384	19078461	2	3
45638461	705944	0	0
45667903	1129625	0	0
45630532	1192710	0	0
45781757	1177480	0	0
45673845	1119510	0	0
45778521	1112807	0	0
45645959	1119510	0	0
45687280	1125315	0	0
45783326	1119510	0	0
45777746	1119510	0	0
45797520	1310149	0	0
45696390	1125315	0	0
45793120	1125315	0	0
46241723	1119510	0	0
46300632	1124300	0	0
46310003	1549786	0	0
46320472	19078461	2	3
441840	4048695	6	10
4002365	4336464	4	5
21503264	1119510	0	0
21503948	1107882	2	3
36157100	1343916	0	0
36154486	19076374	2	3
36203042	4237458	3	3
40776222	3005136	2	2
44349263	914335	0	0
44345503	1129625	0	0
44357084	1125315	0	0
44351411	1154029	0	0
45621163	975125	0	0
44354943	1177480	0	0
45623258	19078461	2	3
45638495	1759842	0	0
45667905	1129625	0	0
45630593	1124300	0	0
45781709	1177480	0	0
45673846	1119510	0	0
45780461	1112807	0	0
45645996	1119510	0	0
45687385	1125315	0	0
45783447	1119510	0	0
45777748	1119510	0	0
45797461	1713332	0	0
45696812	1125315	0	0
45793395	1125315	0	0
46241735	1119510	0	0
46300633	1115008	0	0
46310003	19127890	0	0
46304246	19078461	2	3
441840	40481087	6	10
432250	40481087	4	5
21505737	1112807	0	0
21503948	40223834	2	3
36157101	1548195	0	0
36154837	46275916	2	3
36203042	4066995	3	3
40779107	3021226	2	2
44349187	1741122	0	0
44345697	1595799	0	0
44357130	1125315	0	0
44351417	723013	0	0
45664715	1107830	0	0
45655143	1177480	0	0
45632127	19078461	2	3
45638495	1713332	0	0
45668087	1129625	0	0
45630553	1192710	0	0
45781381	1177480	0	0
45673739	1119510	0	0
45707208	1112807	0	0
45646338	1119510	0	0
45687534	1125315	0	0
45783449	1119510	0	0
45706497	1119510	0	0
45797618	1107830	0	0
45696818	1125315	0	0
45793046	1125315	0	0
46241765	1119510	0	0
46300937	1305058	0	0
46310003	1512674	0	0
46313571	19078461	2	3
441840	4142905	6	10
4021667	4152936	4	6
21505764	1192710	0	0
21013672	1310034	2	3
35702738	4310024	2	7
36154654	40232448	2	3
35708303	81893	3	3
40779360	3015076	2	2
44349190	975125	0	0
44345697	1521369	0	0
44350109	1125315	0	0
44351625	1551099	0	0
45664682	1115008	0	0
45655483	1177480	0	0
45632296	1127433	2	3
45638468	1717327	0	0
45668178	1129625	0	0
45630557	1307863	0	0
45781847	1177480	0	0
45673282	1119510	0	0
45704259	1112807	0	0
45645655	1119510	0	0
45687681	1125315	0	0
45783368	1119510	0	0
45706672	1119510	0	0
45797724	1149196	0	0
45696882	1125315	0	0
45793258	1125315	0	0
46242612	1119510	0	0
46300948	738818	0	0
46310117	933724	0	0
46320712	19078461	2	3
441840	4299128	6	6
376106	378001	4	6
21505755	1124300	0	0
21002089	1551192	2	3
36202157	4230399	4	10
36154657	40232448	2	3
35702111	4266809	3	3
40779159	3007461	2	2
44349311	1149196	0	0
44345697	1549786	0	0
44349629	1125315	0	0
44351579	1548195	0	0
45664720	1107830	0	0
44347716	1177480	0	0
45632296	19078461	2	3
45638568	1551099	0	0
45668126	1129625	0	0
45630699	920293	0	0
45781836	1177480	0	0
45673003	1119510	0	0
45700800	1112807	0	0
45645710	1119510	0	0
45687600	1125315	0	0
45783516	1119510	0	0
45706845	1119510	0	0
45797727	1124957	0	0
45696761	1125315	0	0
45794579	1125315	0	0
46242615	1119510	0	0
46300966	1539403	0	0
46310120	1149196	0	0
46303823	19078461	2	3
441840	4296205	6	6
376106	375671	4	6
21505756	1115008	0	0
21003118	19008572	2	3
36202157	4134304	4	11
36155000	1551192	2	3
36102976	4280726	3	3
37503873	4197460	2	2
44349276	1177480	0	0
44345600	1124300	0	0
44349766	1125315	0	0
44351585	1332418	0	0
45664596	1115008	0	0
44348628	1177480	0	0
45623642	19078461	2	3
45638527	1738521	0	0
45665792	1129625	0	0
45630704	967823	0	0
45779139	1177480	0	0
45673414	1119510	0	0
45701046	1112807	0	0
45646024	1119510	0	0
45687467	1125315	0	0
45783517	1119510	0	0
45703089	1119510	0	0
45797728	1154343	0	0
45696614	1125315	0	0
45794656	1125315	0	0
46242571	1119510	0	0
46300971	933724	0	0
46310004	1322184	0	0
46313436	19078461	2	3
441840	4035415	5	9
376337	4001336	4	6
21505765	1192710	0	0
21002591	19133905	2	3
36203062	4152936	4	8
36155014	1551192	2	3
36102976	40486433	3	3
37119654	45769019	2	2
44349377	1000560	0	0
44345710	1129625	0	0
44349644	1125315	0	0
44351775	1192710	0	0
45664598	1174888	0	0
44348023	1177480	0	0
45644511	19078461	2	3
45638573	738818	0	0
45665803	1129625	0	0
45630713	1124957	0	0
45779272	1177480	0	0
45670764	1119510	0	0
45701055	1112807	0	0
45642704	1119510	0	0
45687541	1125315	0	0
45783055	1119510	0	0
45703772	1119510	0	0
45797579	1112807	0	0
45696615	1125315	0	0
45794660	1125315	0	0
46241811	1119510	0	0
46300977	1332418	0	0
46310171	1153428	0	0
46314534	19078461	2	3
441840	4109685	5	9
432250	4116491	4	6
21505765	1129625	0	0
21002591	19073183	2	3
35205038	4112343	4	8
36152419	1551192	2	3
36102976	260139	3	3
40795754	3027970	2	2
44349299	1177480	0	0
44345712	920293	0	0
44349776	1125315	0	0
44351634	1738521	0	0
45664727	1107830	0	0
44348162	1177480	0	0
44347457	1129625	0	0
45638544	1124957	0	0
45665952	1129625	0	0
45630765	967823	0	0
45779301	1177480	0	0
45670843	1119510	0	0
45700783	1112807	0	0
45642650	1119510	0	0
45687649	1125315	0	0
45783176	1119510	0	0
45703182	1119510	0	0
45797407	723013	0	0
45802689	1125315	0	0
45787859	1125315	0	0
46241824	1119510	0	0
46300979	1115008	0	0
46304448	975125	0	0
46304098	19078461	2	3
441840	4132546	5	9
440921	4142905	4	6
21505718	19010482	0	0
21002591	19133873	2	3
36100000	40481087	4	8
36152327	19008572	2	3
35809207	40486433	3	3
40795688	3027231	2	2
44345193	1557272	0	0
44345715	1129625	0	0
44349782	1125315	0	0
44351564	1192710	0	0
45664722	1149196	0	0
44348123	1177480	0	0
44347661	1129625	0	0
45638635	1310149	0	0
45665594	1129625	0	0
45630774	1326303	0	0
45780731	1177480	0	0
45670767	1119510	0	0
45697877	1112807	0	0
45688716	1119510	0	0
45687747	1125315	0	0
45783531	1119510	0	0
45703184	1119510	0	0
45797847	1738521	0	0
45802705	1125315	0	0
45787862	1125315	0	0
46241792	1119510	0	0
46300766	1738521	0	0
46304466	1192710	0	0
46305546	19078461	2	3
441840	381316	5	8
440921	4278672	4	6
21505783	1539403	0	0
21002600	19073188	2	3
36100000	4294548	4	9
36152328	40229134	2	3
35809207	4280726	3	3
40795689	3014599	2	2
44345263	1124300	0	0
44345603	1112807	0	0
44349794	1125315	0	0
44351574	1310149	0	0
45664708	1115008	0	0
44341489	1177480	0	0
44347783	1129625	0	0
45638501	791967	0	0
45665753	1129625	0	0
45630775	1174888	0	0
45779472	1177480	0	0
45670817	1119510	0	0
45697926	1112807	0	0
45688662	1119510	0	0
45687304	1125315	0	0
46291860	1119510	0	0
45703278	1119510	0	0
45797409	1000560	0	0
45802895	1125315	0	0
45787878	1125315	0	0
46241832	1119510	0	0
46301009	1000560	0	0
46304357	1118084	0	0
46313800	19078461	2	3
441840	4113008	5	8
440921	4152936	4	6
21505770	738818	0	0
21002600	1713671	2	3
36100000	4112343	4	9
36152156	40229134	2	3
36002886	4280726	3	3
40795690	3012494	2	2
44345389	1149380	0	0
44345609	1589505	0	0
44349475	1125315	0	0
44351635	967823	0	0
45664712	1174888	0	0
44340679	1177480	0	0
44343566	1129625	0	0
45638583	1545958	0	0
45666163	1129625	0	0
45630631	1332418	0	0
45708091	1177480	0	0
45670793	1119510	0	0
45698050	1112807	0	0
45639811	1119510	0	0
45684258	1125315	0	0
46291572	1119510	0	0
45700128	1119510	0	0
45797730	1124300	0	0
45802802	1125315	0	0
45787918	1125315	0	0
45895806	1119510	0	0
46300917	1153428	0	0
46304437	1149380	0	0
46308815	19078461	2	3
441840	378419	5	10
440921	4146173	4	6
21505732	967823	0	0
21002600	19073183	2	3
36100000	4116491	4	9
35702116	81893	2	3
36002886	40486433	3	3
40779224	3028833	2	2
44345398	1557272	0	0
44345802	967823	0	0
44349814	1125315	0	0
44351577	1115008	0	0
45664725	1124300	0	0
44340639	1177480	0	0
44344767	1129625	0	0
45638591	1367571	0	0
45666177	1129625	0	0
45630635	1548195	0	0
45708066	1177480	0	0
45671090	1119510	0	0
45694765	1112807	0	0
45639727	1119510	0	0
45684246	1125315	0	0
46291583	1119510	0	0
45699984	1119510	0	0
45797732	1367571	0	0
45802771	1125315	0	0
45787886	1125315	0	0
45895861	1119510	0	0
46301018	1124957	0	0
46304619	975125	0	0
46320445	19078461	2	3
441840	195588	5	10
133468	4152936	4	6
21505845	1545958	0	0
21013671	19018935	2	3
36203062	4109685	4	7
36158559	19008572	2	3
36202155	4146173	3	3
40792413	3023103	2	2
44345399	1129625	0	0
44345667	1738521	0	0
44350157	1125315	0	0
44351820	933724	0	0
45667150	1124300	0	0
44340954	1177480	0	0
44343724	1129625	0	0
45638509	1549786	0	0
45663735	1129625	0	0
45630638	1738521	0	0
45708124	1177480	0	0
45670880	1119510	0	0
45691855	1112807	0	0
45685829	1119510	0	0
45685478	1125315	0	0
46291590	1119510	0	0
45700199	1119510	0	0
45797583	975125	0	0
45802774	1125315	0	0
45788010	1125315	0	0
45895910	1119510	0	0
46301122	1326303	0	0
46304398	1307863	0	0
46304070	19078461	2	3
441840	4294548	5	11
133468	4146173	4	6
21505845	1539403	0	0
21002084	1551192	2	3
36102149	4056621	4	7
36158768	19008572	2	3
36000000	81893	3	3
40181756	40221415	2	2
44345506	1153428	0	0
44345668	1713332	0	0
44349942	1125315	0	0
44351725	1501700	0	0
45667273	715997	0	0
45637339	1177480	0	0
44343687	1129625	0	0
45638509	19127890	0	0
45663502	1129625	0	0
45630624	1107830	0	0
45708265	1177480	0	0
45670885	1119510	0	0
45688956	1112807	0	0
45685798	1119510	0	0
45685506	1125315	0	0
46291493	1119510	0	0
45697777	1119510	0	0
45797584	1115008	0	0
45802778	1125315	0	0
45787903	1125315	0	0
45896004	1119510	0	0
46319215	1115008	0	0
46304653	723013	0	0
46313300	19078461	2	3
441840	4112343	5	11
440921	375671	4	7
21505859	705944	0	0
21002598	19075001	2	3
35205038	260139	4	7
36150807	46275444	2	3
36000000	317009	3	3
40244551	1551192	2	3
44345356	914335	0	0
44345613	1149196	0	0
44349993	1125315	0	0
44351738	1512674	0	0
45667415	738818	0	0
45625204	1177480	0	0
44343723	1129625	0	0
45638509	1589505	0	0
45663420	1129625	0	0
45630710	1768849	0	0
45708329	1177480	0	0
45670959	1119510	0	0
45686068	1112807	0	0
45685797	1119510	0	0
45684446	1125315	0	0
46291678	1119510	0	0
45696895	1119510	0	0
45797587	1115008	0	0
45802861	1125315	0	0
45787988	1125315	0	0
45896009	1119510	0	0
46319226	1521369	0	0
46304664	1102527	0	0
46304328	19078461	2	3
441840	40479768	8	11
440921	378001	4	7
21505958	1738521	0	0
21002597	46275444	2	3
35205038	40486433	4	7
36150855	40229134	2	3
36002139	438614	3	3
40244542	1115171	2	3
44345447	1361711	0	0
44345614	1545958	0	0
44349943	1125315	0	0
44351826	914335	0	0
45667420	1149196	0	0
45625317	1177480	0	0
44344016	1129625	0	0
45638513	1326303	0	0
45663552	1129625	0	0
45630651	723013	0	0
45705338	1177480	0	0
45671154	1119510	0	0
45686128	1112807	0	0
45685619	1119510	0	0
45684420	1125315	0	0
46291965	1119510	0	0
45696939	1119510	0	0
45797849	1713332	0	0
45802730	1125315	0	0
45787960	1125315	0	0
45895929	1119510	0	0
46319097	738818	0	0
46304739	1308738	0	0
46316571	19078461	2	3
441840	4134304	8	12
440921	78272	4	8
21505960	738818	0	0
21002597	1713671	2	3
35205038	4294548	4	7
36150928	1115171	2	3
36002139	4051466	3	3
40244494	40236824	2	3
44345453	1129625	0	0
44345738	1738521	0	0
44349950	1125315	0	0
44351830	1174888	0	0
45667672	1192710	0	0
45620594	1177480	0	0
44344216	1129625	0	0
45638555	967823	0	0
45663759	1129625	0	0
45630739	1124957	0	0
45705570	1177480	0	0
45669584	1119510	0	0
45682868	1112807	0	0
45636696	1119510	0	0
45684382	1125315	0	0
46291923	1119510	0	0
45697123	1119510	0	0
45797500	1115008	0	0
45802744	1125315	0	0
45788024	1125315	0	0
45896116	1119510	0	0
46319289	723013	0	0
46304376	1118084	0	0
46301068	19078461	2	3
441840	80180	4	6
135930	78272	4	9
21505963	1738521	0	0
21002052	19073188	2	3
36202157	4296204	4	7
36151098	1332419	2	3
36002139	4169137	3	3
40244527	40220386	2	3
44345455	1112807	0	0
44345546	1738521	0	0
44350164	1125315	0	0
44351834	1589505	0	0
45664781	975125	0	0
45620803	1177480	0	0
44340504	1129625	0	0
45638843	723013	0	0
45663579	1129625	0	0
45627515	1000560	0	0
45701954	1177480	0	0
45669521	1119510	0	0
45683106	1112807	0	0
45636699	1119510	0	0
45684379	1125315	0	0
46295785	1119510	0	0
45696933	1119510	0	0
45797596	1154343	0	0
45802841	1125315	0	0
45788037	1125315	0	0
45896118	1119510	0	0
46319284	1115008	0	0
46304378	1112807	0	0
46315409	19078461	2	3
441840	198809	4	10
440921	4134304	5	8
21505784	1332418	0	0
21002052	19073183	2	3
35205038	255848	4	6
36155328	40232448	2	3
36002139	4102123	3	3
40244529	1115171	2	3
44345457	1000560	0	0
44345548	1192710	0	0
44350171	1125315	0	0
44351913	1713332	0	0
45664805	1332418	0	0
45661826	1177480	0	0
44340464	1129625	0	0
45638637	1110410	0	0
45660384	1129625	0	0
45627780	1549786	0	0
45702098	1177480	0	0
45669669	1119510	0	0
45683290	1112807	0	0
45636741	1119510	0	0
45684397	1125315	0	0
46295795	1119510	0	0
45696892	1119510	0	0
45797600	1396131	0	0
45803044	1125315	0	0
45788130	1125315	0	0
45896167	1119510	0	0
46319060	1539403	0	0
46304754	1545958	0	0
46301149	19078461	2	3
441840	257012	4	10
4000610	81893	5	7
21505784	1545958	0	0
21003069	19078461	2	3
36102970	40481087	4	6
36155525	40231925	2	3
36002139	442116	3	3
40244685	40232448	2	3
44345264	1326303	0	0
44345551	738818	0	0
44349883	1125315	0	0
44352163	1332418	0	0
45664819	975125	0	0
45661869	1177480	0	0
44340542	1129625	0	0
45638624	1310149	0	0
45660505	1129625	0	0
45627780	1521369	0	0
45702242	1177480	0	0
45669480	1119510	0	0
45682955	1112807	0	0
45636831	1119510	0	0
45684389	1125315	0	0
46291522	1119510	0	0
45696936	1119510	0	0
45797684	1124300	0	0
45803052	1125315	0	0
45788148	1125315	0	0
45804104	1119510	0	0
46319068	1308738	0	0
46304533	967823	0	0
46314902	19078461	2	3
441840	44782520	4	7
440921	81151	5	7
21505757	701322	0	0
21003069	40229134	2	3
35702767	4166224	4	6
36155339	19133873	2	3
36200000	134438	3	3
40244644	1127433	2	3
44345055	1102527	0	0
44345563	1746114	0	0
44350088	1125315	0	0
44351784	715997	0	0
45664822	1174888	0	0
45662011	1177480	0	0
44340481	1129625	0	0
45638626	1332418	0	0
45660462	1129625	0	0
45627780	19127890	0	0
45702155	1177480	0	0
45669500	1119510	0	0
45679898	1112807	0	0
45636835	1119510	0	0
45684515	1125315	0	0
46291711	1119510	0	0
45697056	1119510	0	0
45797851	1500211	0	0
45803055	1125315	0	0
45788134	1125315	0	0
45804105	1119510	0	0
46319075	1307863	0	0
46304973	1717327	0	0
46310390	19078461	2	3
441840	4043241	3	12
376337	378001	5	7
21505770	1129625	0	0
21003069	1127433	2	3
36203062	4155034	4	6
36155660	35605482	2	3
36154849	1177480	0	0
40244623	1127433	2	3
44345358	967823	0	0
44345563	1741122	0	0
44350207	1125315	0	0
44351787	1589505	0	0
45664795	738818	0	0
45661755	1177480	0	0
44340032	1129625	0	0
45635347	1154343	0	0
45658374	1129625	0	0
45627781	1305058	0	0
45702220	1177480	0	0
45669505	1119510	0	0
45679827	1112807	0	0
45636961	1119510	0	0
45684588	1125315	0	0
46291715	1119510	0	0
45696984	1119510	0	0
45797699	1396131	0	0
45802762	1125315	0	0
45788065	1125315	0	0
45804122	1119510	0	0
46319079	975125	0	0
46304982	1154029	0	0
46309630	19078461	2	3
441840	4084167	3	6
376337	375671	5	7
21001773	1107830	0	0
21003069	19059056	2	3
36203062	4113008	4	6
36155495	40163554	2	3
36154981	1112807	0	0
40244700	1551192	2	3
44345312	1759842	0	0
44345569	1124957	0	0
44350089	1125315	0	0
44351937	1332418	0	0
45664798	1305058	0	0
45658272	1177480	0	0
44340631	1129625	0	0
45635348	705944	0	0
45658398	1129625	0	0
45627569	1589505	0	0
45699093	1177480	0	0
45669772	1119510	0	0
45658285	1192710	0	0
45637004	1119510	0	0
45684475	1125315	0	0
46291717	1119510	0	0
45697041	1119510	0	0
45797852	1149196	0	0
45800132	1125315	0	0
45787972	1125315	0	0
45804123	1119510	0	0
46318797	1332418	0	0
46304684	1322184	0	0
46309819	19078461	2	3
441840	439777	3	8
4000610	4285898	5	6
21001775	1119510	0	0
21003069	19019273	2	3
35702124	4112343	4	5
36155637	1127433	2	3
36154984	1149380	0	0
40244679	40232448	2	3
44345312	1713332	0	0
44341543	1000560	0	0
44350124	1125315	0	0
44351973	1124300	0	0
45664748	19127890	0	0
45655888	1177480	0	0
44340521	1129625	0	0
45635251	738818	0	0
45657620	1129625	0	0
45627569	1549786	0	0
45699264	1177480	0	0
45780878	1119510	0	0
45703633	1192710	0	0
45682695	1119510	0	0
45681345	1125315	0	0
46291310	1119510	0	0
45697081	1119510	0	0
45797856	723013	0	0
45800137	1125315	0	0
45788219	1125315	0	0
45804042	1119510	0	0
46319428	1115008	0	0
46304961	1192710	0	0
46304046	40223768	2	3
444089	4285898	5	6
440921	4048695	5	6
21001775	1343916	0	0
21003069	1115171	2	3
21602543	40221415	4	5
36155476	40236824	2	3
36154987	1154343	0	0
40244680	1127433	2	3
44345095	1124300	0	0
44341545	1177480	0	0
44349973	1125315	0	0
44351362	1310149	0	0
45664748	1589505	0	0
45655759	1177480	0	0
44340532	1129625	0	0
45635254	1107830	0	0
45657848	1129625	0	0
45627300	1149196	0	0
45699243	1177480	0	0
45780824	1119510	0	0
45704007	1192710	0	0
45682773	1119510	0	0
45681444	1125315	0	0
46291399	1119510	0	0
45697302	1119510	0	0
45797857	1112807	0	0
45800140	1125315	0	0
45788226	1125315	0	0
45803750	1119510	0	0
46319115	1174888	0	0
46304968	975125	0	0
45803595	40223768	2	3
444089	81893	6	7
440921	4066995	5	6
21001773	1129625	0	0
21003069	19019979	2	3
36102149	258780	4	5
36155609	40231925	2	3
36154864	1713332	0	0
40244879	40162522	2	3
44345098	1149380	0	0
44341263	1741122	0	0
44350071	1125315	0	0
44351976	975125	0	0
45664748	1549786	0	0
45655918	1177480	0	0
44340556	1129625	0	0
45635260	1115008	0	0
45657958	1129625	0	0
45627713	1124300	0	0
45699360	1177480	0	0
45781032	1119510	0	0
45704045	1192710	0	0
45682977	1119510	0	0
45681454	1125315	0	0
46291411	1119510	0	0
45693880	1119510	0	0
45797861	738818	0	0
45800102	1125315	0	0
45788087	1125315	0	0
45804212	1119510	0	0
46318938	1545958	0	0
46304764	1112807	0	0
45675324	19078461	2	3
4028071	4285898	7	8
133468	4134304	5	6
21001773	738818	0	0
21003069	1127078	2	3
36009717	4066995	4	5
36157793	1545959	2	3
36154864	1759842	0	0
40244753	1115171	2	3
44345100	1759842	0	0
44341263	1746114	0	0
44350075	1125315	0	0
44351738	1549786	0	0
45664753	1154343	0	0
45651865	1177480	0	0
44340196	1129625	0	0
45635261	1107830	0	0
45654108	1129625	0	0
45627718	738818	0	0
45699406	1177480	0	0
45781048	1119510	0	0
45651470	1192710	0	0
45633682	1119510	0	0
45681473	1125315	0	0
46242680	1119510	0	0
45693897	1119510	0	0
45797920	1115008	0	0
45800114	1125315	0	0
45788240	1125315	0	0
45804200	1119510	0	0
46319141	1322184	0	0
46304776	1326303	0	0
46309370	19078461	2	3
432795	40479422	7	8
133468	81151	5	6
21001494	1551099	0	0
21003079	19078461	2	3
36009717	4048695	4	5
36159029	46233710	2	3
36155201	1153428	0	0
40244754	1115171	2	3
44345100	1713332	0	0
44341282	1713332	0	0
44350127	1125315	0	0
44352016	1124300	0	0
45664874	1107830	0	0
45649268	1177480	0	0
44340219	1129625	0	0
45635439	1343916	0	0
45654203	1129625	0	0
45627303	1192710	0	0
45695845	1177480	0	0
45781051	1119510	0	0
45651444	1192710	0	0
45633465	1119510	0	0
45681583	1125315	0	0
46242767	1119510	0	0
45693955	1119510	0	0
45797927	920293	0	0
45800365	1125315	0	0
45788246	1125315	0	0
45803922	1119510	0	0
46319121	1332418	0	0
46304778	1118084	0	0
46317375	19078461	2	3
432795	40479768	7	8
133468	4230399	5	6
21001057	1129625	0	0
21003079	1127078	2	3
35205038	4283893	4	5
36151501	40223768	2	3
36155154	1129625	0	0
36702238	381316	2	3
40250213	1112807	0	0
44341282	1759842	0	0
44349839	1125315	0	0
44352024	1332418	0	0
45664758	975125	0	0
44778148	1112807	0	0
44340223	1129625	0	0
45635185	1501700	0	0
45654305	1129625	0	0
45627308	1110410	0	0
45695923	1177480	0	0
45781145	1119510	0	0
45648593	1192710	0	0
45633756	1119510	0	0
45681103	1125315	0	0
46242769	1119510	0	0
45694083	1119510	0	0
45794788	1589505	0	0
45800120	1125315	0	0
45788070	1125315	0	0
45803931	1119510	0	0
46319365	738818	0	0
46304570	1322184	0	0
45650766	19078461	2	3
432795	81151	6	8
376337	378419	5	6
21001070	1129625	0	0
21003079	1127433	2	3
21602537	40224132	4	5
36159364	19075001	2	3
36155161	1112807	0	0
36702245	378419	2	3
40250213	1129625	0	0
44341400	1129625	0	0
44350186	1125315	0	0
44344054	1192710	0	0
45664961	1154029	0	0
44778075	1112807	0	0
44340596	1129625	0	0
45635561	1539403	0	0
45654142	1129625	0	0
45627309	1717327	0	0
45697705	1177480	0	0
45781064	1119510	0	0
45648785	1192710	0	0
45633757	1119510	0	0
45681198	1125315	0	0
46242773	1119510	0	0
45694085	1119510	0	0
45794790	1367571	0	0
45800379	1125315	0	0
45788093	1125315	0	0
45798790	1119510	0	0
46319373	1000560	0	0
46304786	1000560	0	0
45650673	19078461	2	3
432795	4230399	6	8
376208	40479768	5	6
21001099	723013	0	0
21003079	19133768	2	3
36202155	4230399	4	5
36158536	40223768	2	3
36154908	1545958	0	0
40250232	19079524	2	3
40250215	1177480	0	0
44341492	1129625	0	0
44349588	1125315	0	0
44343781	1539403	0	0
45664968	1192710	0	0
44357830	1112807	0	0
44337284	1129625	0	0
45635286	1149196	0	0
45654518	1129625	0	0
45627529	1174888	0	0
45695958	1177480	0	0
45780857	1119510	0	0
45649131	1192710	0	0
45633887	1119510	0	0
45681502	1125315	0	0
46242856	1119510	0	0
45693770	1119510	0	0
45794794	19003953	0	0
45800251	1125315	0	0
45788159	1125315	0	0
45798928	1119510	0	0
46319146	1192710	0	0
46305276	1549786	0	0
500003101	380378	1	1
432795	4134304	6	9
376208	40479422	5	6
21001099	791967	0	0
21003079	40162522	2	3
21604182	40220386	4	5
36157962	1107882	2	3
36154931	1112807	0	0
40244611	40228214	2	3
40250216	1367571	0	0
44344543	1177480	0	0
44350150	1125315	0	0
44343787	1713332	0	0
45664998	791967	0	0
44357923	1112807	0	0
44337459	1129625	0	0
45635506	1326303	0	0
45654241	1129625	0	0
45627530	738818	0	0
45693082	1177480	0	0
45778549	1119510	0	0
45645607	1192710	0	0
45633908	1119510	0	0
46275426	46275444	1	1
46242860	1119510	0	0
45694158	1119510	0	0
45794853	1322184	0	0
45800255	1125315	0	0
45788162	1125315	0	0
45798944	1119510	0	0
46319150	738818	0	0
46305189	1192710	0	0
500002401	313217	1	1
255919	378001	6	8
4000738	4198190	5	5
21001092	740275	0	0
21003079	1115171	2	3
35802832	4280726	4	5
36155696	40223768	2	3
36154931	1192710	0	0
40244594	19078461	2	3
40249001	1119510	0	0
44344360	740275	0	0
44349669	1125315	0	0
44343787	1759842	0	0
45665071	738818	0	0
44358214	1112807	0	0
44337465	1129625	0	0
45635248	1149196	0	0
45652244	1129625	0	0
45627610	19127890	0	0
45692804	1177480	0	0
45778557	1119510	0	0
45642704	1192710	0	0
45679700	1119510	0	0
46275443	46275444	1	1
46242804	1119510	0	0
45694041	1119510	0	0
45794855	738818	0	0
45800074	1125315	0	0
45788286	1125315	0	0
45798482	1119510	0	0
46319575	1332418	0	0
46304706	1551099	0	0
46316337	19079524	1	1
444112	133834	6	7
372887	375671	5	5
21001054	1129625	0	0
21003079	19059056	2	3
35802832	40486433	4	5
36156563	1107882	2	3
36154949	1107830	0	0
40244689	19078461	2	3
40249024	1308738	0	0
44344363	975125	0	0
44350044	1125315	0	0
44343804	738818	0	0
45664317	1115008	0	0
44358220	1112807	0	0
44337332	1129625	0	0
45635508	1149196	0	0
45651034	1129625	0	0
45627610	1512674	0	0
45692936	1177480	0	0
45778560	1119510	0	0
45642811	1192710	0	0
45679588	1119510	0	0
45680892	1125315	0	0
46242816	1119510	0	0
45694131	1119510	0	0
45797005	1728416	0	0
45800382	1125315	0	0
45788359	1125315	0	0
45799006	1119510	0	0
46319622	1738521	0	0
46304937	1124300	0	0
46316716	46275916	1	1
432795	4048695	6	7
372887	378001	5	5
21001107	740275	0	0
21003079	19019979	2	3
35900000	196456	4	5
36152353	40223768	2	3
36155025	1112807	0	0
40244733	19078461	2	3
40249028	1137529	0	0
44344370	1174888	0	0
44342478	1125315	0	0
44343987	1501700	0	0
45664407	1153428	0	0
44358627	1112807	0	0
45620277	1129625	0	0
45635449	1174888	0	0
45650994	1129625	0	0
45627610	1549786	0	0
45693201	1177480	0	0
45778613	1119510	0	0
45642650	1192710	0	0
45630780	1119510	0	0
45681148	1125315	0	0
46242783	1119510	0	0
45694015	1119510	0	0
45797146	1549786	0	0
45800235	1125315	0	0
46294030	1125315	0	0
45798959	1119510	0	0
46319625	1149196	0	0
46305276	1589505	0	0
46310566	46275916	1	1
432795	4066995	6	7
440921	4156265	5	5
21001102	740275	0	0
21003079	19019273	2	3
21604180	836654	4	4
36212328	19128065	2	3
36155027	1177480	0	0
40244765	19078461	2	3
40249028	1149380	0	0
44344374	1129625	0	0
44342457	1125315	0	0
44343989	1713332	0	0
45664422	1107830	0	0
44344054	1112807	0	0
45620169	1129625	0	0
45635269	1501700	0	0
45651217	1129625	0	0
45627616	1000560	0	0
45693183	1177480	0	0
45778720	1119510	0	0
45688662	1192710	0	0
45630769	1119510	0	0
45681003	1125315	0	0
46240483	1119510	0	0
45693983	1119510	0	0
45797146	19127890	0	0
45800065	1125315	0	0
46294130	1125315	0	0
45799030	1119510	0	0
46319637	1728416	0	0
46305279	975125	0	0
46322392	40171902	1	1
432795	4237458	6	7
4000610	440448	5	5
21001116	1112807	0	0
21003079	40231925	2	3
36203055	378001	4	4
36212328	19127904	2	3
36155113	933724	0	0
40244766	19078461	2	3
40250176	19127890	0	0
44344308	1110410	0	0
44342277	1125315	0	0
44343831	1149196	0	0
45664322	1124957	0	0
44344202	1112807	0	0
45620007	1129625	0	0
45635425	1545958	0	0
45647997	1129625	0	0
45627620	1192710	0	0
45693254	1177480	0	0
45778678	1119510	0	0
45685800	1192710	0	0
45630978	1119510	0	0
45681124	1125315	0	0
46240609	1119510	0	0
45691200	1119510	0	0
45797146	1589505	0	0
45800066	1125315	0	0
46294131	1125315	0	0
45799038	1119510	0	0
46319639	740275	0	0
46304801	1154343	0	0
46321623	46275916	1	1
193460	40479768	6	6
432545	4116491	5	5
21001181	1124300	0	0
21602868	19074843	2	5
36009725	4048171	4	4
36212328	19127918	2	3
36155105	1343916	0	0
40244748	19078461	2	3
40250176	1548195	0	0
44344639	1738521	0	0
44342422	1125315	0	0
44344107	1713332	0	0
45664329	1174888	0	0
45640267	1112807	0	0
45620373	1129625	0	0
45635426	738818	0	0
45647918	1129625	0	0
45627629	791967	0	0
45689837	1177480	0	0
45778925	1119510	0	0
45685820	1192710	0	0
45628171	1119510	0	0
45680966	1125315	0	0
46240780	1119510	0	0
45691204	1119510	0	0
45797123	1112807	0	0
45800067	1125315	0	0
46293875	1125315	0	0
45793531	1119510	0	0
46319519	1107830	0	0
46321014	1332418	0	0
46309302	19079524	1	1
193460	40479422	6	6
255919	380378	5	5
21001116	1124300	0	0
21602868	19074841	2	5
35902135	196456	4	4
36212328	19128263	2	3
36155107	1129625	0	0
40244595	19078461	2	3
40250176	19054876	0	0
44344562	1112807	0	0
44342423	1125315	0	0
44343842	1589505	0	0
45664331	975125	0	0
44358649	1112807	0	0
44362221	1129625	0	0
45635633	1107830	0	0
45648133	1129625	0	0
45627635	1124957	0	0
45690050	1177480	0	0
45707447	1119510	0	0
45685758	1192710	0	0
45628403	1119510	0	0
45680974	1125315	0	0
46240698	1119510	0	0
45691150	1119510	0	0
45797124	1115008	0	0
45800291	1125315	0	0
46293771	1125315	0	0
45793548	1119510	0	0
46319524	1310149	0	0
46321017	1192710	0	0
45675474	19079524	1	1
432795	4156265	6	6
375239	4043241	5	5
21001116	1115008	0	0
21604792	40222846	2	5
35202461	4051466	4	4
36212328	40221415	2	3
36155174	1713332	0	0
40244591	19078461	2	3
40250176	1589505	0	0
44344564	1129625	0	0
44342431	1125315	0	0
44343842	19127890	0	0
45664346	1361711	0	0
45658808	1112807	0	0
44362130	1129625	0	0
45635362	1332418	0	0
45648209	1129625	0	0
45627639	1107830	0	0
45690052	1177480	0	0
45707524	1119510	0	0
45636696	1192710	0	0
45627842	1119510	0	0
45681014	1125315	0	0
46240720	1119510	0	0
45691206	1119510	0	0
45797127	1112807	0	0
45800152	1125315	0	0
46293779	1125315	0	0
45793569	1119510	0	0
46319169	1192710	0	0
46321409	1192710	0	0
44360760	1112807	0	0
432795	375671	5	8
4004038	40492359	5	5
21001119	705944	0	0
21604792	836659	2	5
21602566	19128065	4	4
36151169	40228214	2	3
36155242	791967	0	0
40244593	19078461	2	3
40250176	1549786	0	0
44344317	1177480	0	0
44342338	1125315	0	0
44343842	1549786	0	0
45664495	1137529	0	0
45658470	1112807	0	0
44362270	1129625	0	0
45635306	1149196	0	0
45648212	1129625	0	0
45627642	975125	0	0
45690226	1177480	0	0
45707141	1119510	0	0
45636831	1192710	0	0
45676586	1119510	0	0
45681062	1125315	0	0
45681150	1129625	0	0
45691093	1119510	0	0
45797128	1112807	0	0
45800154	1125315	0	0
46294147	1125315	0	0
45793504	1119510	0	0
46319142	1738521	0	0
46321556	1154029	0	0
44361178	1124957	0	0
432795	78272	5	9
432250	198199	5	5
21001190	975125	0	0
21604606	19078924	2	5
35802832	4285898	4	4
36152424	1107882	2	3
36155174	1759842	0	0
40244725	19078461	2	3
40250177	975125	0	0
44344446	1177480	0	0
44342518	1125315	0	0
44343913	1326303	0	0
45649824	19079524	1	1
45658577	1112807	0	0
44362288	1129625	0	0
45635514	1110410	0	0
45648223	1129625	0	0
45627699	1174888	0	0
45690195	1177480	0	0
45707222	1119510	0	0
45636962	1192710	0	0
45676170	1119510	0	0
45681142	1125315	0	0
45681002	1129625	0	0
45690993	1119510	0	0
45797134	1124957	0	0
45800297	1125315	0	0
46293884	1125315	0	0
45793575	1119510	0	0
46319538	1192710	0	0
46320884	1154343	0	0
44361180	1149196	0	0
255919	4001336	5	7
432250	433125	5	5
21001156	914335	0	0
21603366	19029476	2	5
36203060	40479768	4	4
36155343	1107882	2	3
36155188	1738521	0	0
40248956	1551192	2	3
40254301	19054876	0	0
44344700	1515774	0	0
44342501	1125315	0	0
44343919	1107830	0	0
45641038	19079524	1	1
45658737	1112807	0	0
44362672	1129625	0	0
45635533	738818	0	0
45648156	1129625	0	0
45627325	1713332	0	0
45690270	1177480	0	0
45707598	1119510	0	0
45633465	1192710	0	0
45676204	1119510	0	0
45681269	1125315	0	0
45680972	1129625	0	0
45691366	1119510	0	0
45796916	1124957	0	0
45802216	1125315	0	0
46293966	1125315	0	0
45793672	1119510	0	0
46239789	1000560	0	0
46321562	914335	0	0
44361066	914335	0	0
432795	4278672	5	7
432250	28060	5	5
21000630	1551099	0	0
21604182	19023398	2	5
4300185	4337611	4	4
36158660	1107882	2	3
36155244	1326303	0	0
37522270	4163971	2	7
40478878	40478878	0	0
44344700	19127890	0	0
44344610	1125315	0	0
44343995	1343916	0	0
45640904	19079524	1	1
45658622	1112807	0	0
44362692	1129625	0	0
45635565	1149196	0	0
45648252	1129625	0	0
45627325	1759842	0	0
45686801	1177480	0	0
45704749	1119510	0	0
45633756	1192710	0	0
45673472	1119510	0	0
45681221	1125315	0	0
45680977	1129625	0	0
45691013	1119510	0	0
45796920	1539403	0	0
45802291	1125315	0	0
46293543	1125315	0	0
45793604	1119510	0	0
46239804	1000560	0	0
46321198	1000560	0	0
44361226	975125	0	0
432795	4152936	5	7
133468	4035415	5	5
21000643	1515774	0	0
21604182	782047	2	5
4100932	40479422	4	4
36158556	1107882	2	3
36155256	1713332	0	0
37502354	4336464	2	8
40248957	1137529	0	0
44344700	1549786	0	0
44344612	1125315	0	0
44343996	1332418	0	0
45625798	19079524	1	1
45658947	1112807	0	0
44355092	1129625	0	0
45635566	791967	0	0
45644847	1129625	0	0
45627344	1192710	0	0
45688691	1177480	0	0
45704727	1119510	0	0
45633757	1192710	0	0
45624956	1119510	0	0
45681214	1125315	0	0
45681175	1129625	0	0
45691165	1119510	0	0
45796823	1154343	0	0
45802292	1125315	0	0
46293892	1125315	0	0
45793779	1119510	0	0
46239759	1149380	0	0
46321116	1124300	0	0
44361228	1119510	0	0
432795	4059173	5	7
376208	4048171	5	5
21000630	975125	0	0
21600492	35605482	2	4
4160875	78272	4	4
36151836	1107882	2	3
36155150	1115008	0	0
36703532	4066995	2	6
40232448	40232448	0	0
44344701	1129625	0	0
44344856	1125315	0	0
44343861	975125	0	0
45621254	46275916	1	1
45652160	1112807	0	0
44355015	1129625	0	0
45635595	1174888	0	0
45644904	1129625	0	0
45627702	738818	0	0
45688700	1177480	0	0
45704824	1119510	0	0
45633742	1192710	0	0
45625027	1119510	0	0
45681229	1125315	0	0
45681073	1129625	0	0
45691171	1119510	0	0
45797137	1545958	0	0
45802436	1125315	0	0
46293895	1125315	0	0
45793624	1119510	0	0
46239815	1174888	0	0
46321313	1107830	0	0
44361187	1115008	0	0
4022201	78272	5	6
4003043	40492359	6	6
21000637	1551099	0	0
21602882	19074843	1	4
4123446	4107731	4	4
36158458	1107882	2	3
36155257	1129625	0	0
36702251	380378	2	5
40174880	40174880	0	0
44344451	723013	0	0
44342656	1125315	0	0
44344164	1124957	0	0
45621254	19079524	1	1
45652288	1112807	0	0
45655145	1129625	0	0
45635599	1115008	0	0
45644912	1129625	0	0
45627708	975125	0	0
45684084	1177480	0	0
45704882	1119510	0	0
45633905	1192710	0	0
45670612	1119510	0	0
45675691	1125315	0	0
45681338	1129625	0	0
45688107	1119510	0	0
45797179	740275	0	0
45802278	1125315	0	0
46294050	1125315	0	0
45793854	1119510	0	0
46239894	705944	0	0
46321343	791967	0	0
44361096	933724	0	0
432795	4109685	5	6
442628	78272	6	6
21000635	975125	0	0
21602882	19074841	1	4
4042678	4336464	3	4
36151439	1107882	2	3
36154907	1107830	0	0
36702254	375671	2	5
37302323	4296204	4	8
44344459	1192710	0	0
44342669	1125315	0	0
44344122	738818	0	0
45638155	19079524	1	1
44344469	1112807	0	0
45655156	1129625	0	0
45635650	1738521	0	0
45644868	1129625	0	0
45627765	708298	0	0
45684207	1177480	0	0
45704564	1119510	0	0
45630605	1192710	0	0
45670470	1119510	0	0
45675695	1125315	0	0
45676065	1129625	0	0
45688140	1119510	0	0
45797184	715997	0	0
45800399	1125315	0	0
46294239	1125315	0	0
45793632	1119510	0	0
46239897	1115008	0	0
46321348	1738521	0	0
44361361	1112807	0	0
4020346	4134304	5	6
135930	4059173	6	7
21000643	1548195	0	0
21604793	19077572	1	4
4038678	4285898	3	4
36212329	19128263	2	3
36154695	1307863	0	0
36702251	4029498	2	4
37202316	4283893	4	7
44344603	1519936	0	0
44364064	1125315	0	0
44343808	914335	0	0
45625904	19079524	1	1
44344618	1112807	0	0
45655159	1129625	0	0
45635652	1309944	0	0
45644966	1129625	0	0
45627776	1107830	0	0
45684165	1177480	0	0
45704891	1119510	0	0
45627842	1192710	0	0
45670621	1119510	0	0
45675832	1125315	0	0
45672885	1129625	0	0
45688227	1119510	0	0
45797188	738818	0	0
45797323	1125315	0	0
46294396	1125315	0	0
45793804	1119510	0	0
46240006	1551099	0	0
46321353	1309944	0	0
44361362	1192710	0	0
4022201	4230399	5	5
376106	4043241	6	7
21000643	1512674	0	0
21604416	19074679	1	4
4180169	80809	3	4
36212329	40221415	2	3
36154782	1112807	0	0
36703523	4029498	1	3
36702247	4132546	4	7
44344603	1549786	0	0
44364071	1125315	0	0
44344029	975125	0	0
45622659	19079524	1	1
44344630	1112807	0	0
45655321	1129625	0	0
45635658	1124300	0	0
45644892	1129625	0	0
45627470	1549786	0	0
45684220	1177480	0	0
45704965	1119510	0	0
45676586	1192710	0	0
45670718	1119510	0	0
45675754	1125315	0	0
45672894	1129625	0	0
45688208	1119510	0	0
45797190	738818	0	0
45797326	1125315	0	0
46294075	1125315	0	0
45793691	1119510	0	0
46239838	738818	0	0
46321354	1192710	0	0
44361362	1119510	0	0
432795	4155034	5	5
440921	40479422	6	7
21000643	1589505	0	0
21604798	40222846	1	4
4078521	44783196	3	4
36212329	19128065	2	3
36154785	1332418	0	0
36703523	380378	1	4
36703500	4001336	4	7
44341613	1154029	0	0
44364196	1125315	0	0
44344030	1124957	0	0
45665003	19079524	1	1
44344647	1112807	0	0
44347846	1129625	0	0
45635324	1501700	0	0
45645115	1129625	0	0
45627470	19127890	0	0
45684135	1177480	0	0
45704870	1119510	0	0
45676204	1192710	0	0
45670525	1119510	0	0
45675636	1125315	0	0
45673250	1129625	0	0
45688334	1119510	0	0
45797197	1149380	0	0
45797424	1125315	0	0
46294471	1125315	0	0
45788176	1119510	0	0
46239846	1746114	0	0
46321499	1521369	0	0
44361213	975125	0	0
432795	4296204	5	5
255919	4280726	6	8
21000643	1549786	0	0
21602840	19133905	1	4
4032251	4047491	3	4
36212329	19128022	2	3
36154786	1332418	0	0
36703534	375671	1	4
37203758	257012	4	7
44341602	738818	0	0
44364210	1125315	0	0
44344246	723013	0	0
45638235	19079524	1	1
44341082	1112807	0	0
44347724	1129625	0	0
45635534	1310149	0	0
45643039	1129625	0	0
45627470	1589505	0	0
45684368	1177480	0	0
45704970	1119510	0	0
45625039	1192710	0	0
45670429	1119510	0	0
45675643	1125315	0	0
45673255	1129625	0	0
45688431	1119510	0	0
45794963	975125	0	0
45797425	1125315	0	0
46294118	1125315	0	0
45788463	1119510	0	0
46239846	1741122	0	0
46321499	1595799	0	0
44361216	1174888	0	0
4027553	258780	5	5
376208	133834	6	6
21000633	975125	0	0
21604635	19078924	1	4
4309188	28060	3	4
36212329	19127918	2	3
36155061	1115008	0	0
40240628	19112599	1	1
36718338	378001	4	7
44341622	1129625	0	0
44364192	1125315	0	0
44344126	1124957	0	0
45652828	19079524	1	1
45643157	1112807	0	0
44348329	1129625	0	0
45632309	1107830	0	0
45643121	1129625	0	0
45627473	1310149	0	0
45684172	1177480	0	0
45705018	1119510	0	0
45670102	1192710	0	0
45669011	1119510	0	0
45675909	1125315	0	0
45785114	1129625	0	0
45684961	1119510	0	0
45794966	1192710	0	0
45797540	1125315	0	0
46294201	1125315	0	0
45788517	1119510	0	0
46239854	705944	0	0
46321499	1549786	0	0
44360744	1192710	0	0
432586	4043241	5	5
376337	4043241	7	8
21000637	975125	0	0
21602819	19073183	1	4
4045900	4058899	3	4
36212329	19127904	2	3
36155203	1149196	0	0
40090536	836659	1	1
36718338	375671	4	7
44341626	1177480	0	0
44364227	1125315	0	0
44344001	975125	0	0
45664938	19079524	1	1
45643103	1112807	0	0
44348091	1129625	0	0
45632312	1115008	0	0
45642229	1129625	0	0
45627417	967823	0	0
45680940	1177480	0	0
45701268	1119510	0	0
45670470	1192710	0	0
45669057	1119510	0	0
45675763	1125315	0	0
45785009	1129625	0	0
45684981	1119510	0	0
45794995	1149196	0	0
45797568	1125315	0	0
46294153	1125315	0	0
45788444	1119510	0	0
46239860	1174888	0	0
46321373	933724	0	0
44360744	1112807	0	0
255919	372328	5	5
133468	40479422	7	7
21000633	1551099	0	0
21604565	19057271	1	4
4042650	44783196	2	4
36152038	1332419	2	3
36154952	1759842	0	0
40000858	19057271	1	1
36702247	4029498	4	5
44341633	1746114	0	0
44364166	1125315	0	0
44344074	1343916	0	0
45637564	19079524	1	1
45643319	1112807	0	0
44347979	1129625	0	0
45632313	967823	0	0
45642323	1129625	0	0
45627806	975125	0	0
45654944	1129625	0	0
45701272	1119510	0	0
45670621	1192710	0	0
45669076	1119510	0	0
45675849	1125315	0	0
45785020	1129625	0	0
45685059	1119510	0	0
45794999	1149380	0	0
45797544	1125315	0	0
46294155	1125315	0	0
45788453	1119510	0	0
46239813	1746114	0	0
46321084	1112807	0	0
44360744	1119510	0	0
432545	4294548	5	5
133468	40479768	7	7
21000640	1515774	0	0
21604565	19076374	1	4
141253	140673	1	1
36151270	40228214	2	3
36154952	1713332	0	0
40001198	43012754	1	1
37503891	4198190	4	5
44341633	1741122	0	0
44364274	1125315	0	0
44344007	1149380	0	0
45638239	46275916	1	1
45643388	1112807	0	0
44348107	1129625	0	0
45632319	1308738	0	0
45639212	1129625	0	0
45627807	1192710	0	0
45654831	1129625	0	0
45701365	1119510	0	0
45670718	1192710	0	0
45669035	1119510	0	0
45676064	1125315	0	0
45785038	1129625	0	0
45685155	1119510	0	0
45795003	1112807	0	0
45797552	1125315	0	0
46294301	1125315	0	0
45788426	1119510	0	0
46239813	1741122	0	0
46321483	1000560	0	0
44360747	1115008	0	0
4022923	40479768	5	5
1766600	1125315	0	0
21000640	1549786	0	0
21502572	19128009	1	1
257007	40486433	1	1
36158036	40228214	2	3
36155072	1107830	0	0
40773752	3002385	1	1
40779561	3010813	4	5
44341618	1545958	0	0
44364248	1125315	0	0
44344260	1149196	0	0
45638239	19079524	1	1
45643427	1112807	0	0
44348066	1129625	0	0
45632321	933724	0	0
45635878	1129625	0	0
45627813	1110410	0	0
45655294	1129625	0	0
45701401	1119510	0	0
45669057	1192710	0	0
45669106	1119510	0	0
45675899	1125315	0	0
45785251	1129625	0	0
45685064	1119510	0	0
45794981	1501700	0	0
45797437	1125315	0	0
46294384	1125315	0	0
45788524	1119510	0	0
46239944	738818	0	0
46320949	723013	0	0
44361237	967823	0	0
4022923	40479422	5	5
1766606	975125	0	0
21000640	1548195	0	0
21502574	19132304	1	1
257007	4280726	1	1
36150842	19075601	2	3
36155213	1124957	0	0
40773762	3001488	1	1
36702245	4043241	4	5
44341645	1107830	0	0
44364289	1125315	0	0
44344137	1539403	0	0
45646771	19079524	1	1
45643208	1112807	0	0
44341028	1129625	0	0
45632324	738818	0	0
45635908	1129625	0	0
45627680	738818	0	0
45701739	1129625	0	0
45701179	1119510	0	0
45669215	1192710	0	0
45669156	1119510	0	0
45676100	1125315	0	0
45784962	1129625	0	0
45684944	1119510	0	0
45794988	1110410	0	0
45797628	1125315	0	0
46294485	1125315	0	0
45788531	1119510	0	0
46321908	967823	0	0
46321621	975125	0	0
44361247	738818	0	0
3001247	3001247	0	0
1766553	1308738	0	0
21000640	1589505	0	0
21502574	46221626	1	1
257011	4112343	1	1
36152183	19075601	2	3
36155215	975125	0	0
40774001	3019550	1	1
36718338	378419	4	6
44341606	1549786	0	0
44364358	1125315	0	0
44344070	738818	0	0
45637663	19079524	1	1
45642997	1112807	0	0
44341536	1129625	0	0
45632325	1118084	0	0
45635911	1129625	0	0
45627793	1768849	0	0
45701808	1129625	0	0
45703452	1119510	0	0
45669168	1192710	0	0
45669289	1119510	0	0
45676104	1125315	0	0
45784968	1129625	0	0
45685077	1119510	0	0
45795013	1174888	0	0
45797458	1125315	0	0
46294488	1125315	0	0
45788684	1119510	0	0
46321915	1549786	0	0
46321085	1713332	0	0
44361247	1119510	0	0
3010813	3010813	0	0
255919	4043241	8	9
21000641	1521369	0	0
21502554	1713332	1	1
257011	4294548	1	1
36159247	19075601	2	3
36154962	705944	0	0
40776870	3019406	1	1
36702247	381316	4	6
44341606	19127890	0	0
44364364	1125315	0	0
44344182	1124300	0	0
45643845	19079524	1	1
45640470	1112807	0	0
44340698	1129625	0	0
45632448	1738521	0	0
45636139	1129625	0	0
45624310	1549786	0	0
45701930	1129625	0	0
45703456	1119510	0	0
45669158	1192710	0	0
45669309	1119510	0	0
45676014	1125315	0	0
45784972	1129625	0	0
45685049	1119510	0	0
45794976	1107830	0	0
45797576	1125315	0	0
46294219	1125315	0	0
46298169	1119510	0	0
46321915	1518198	0	0
46321572	701322	0	0
44361249	738818	0	0
3023103	3023103	0	0
441840	4237458	4	10
21000641	1548195	0	0
21500290	1107830	1	1
192353	196456	1	1
36155552	1539411	2	3
36154801	1153428	0	0
40776533	3027970	1	1
37522357	4336464	4	6
44341606	1515774	0	0
44356899	1125315	0	0
44344290	1308738	0	0
45637571	19079524	1	1
45640460	1112807	0	0
44340705	1129625	0	0
45632301	1124300	0	0
45636268	1129625	0	0
45624310	1521369	0	0
45698765	1129625	0	0
45701553	1119510	0	0
45669161	1192710	0	0
45669310	1119510	0	0
45676016	1125315	0	0
45786249	1129625	0	0
45685083	1119510	0	0
45794977	1124957	0	0
45797577	1125315	0	0
46294234	1125315	0	0
46298250	1119510	0	0
46322425	1124300	0	0
46321577	1124957	0	0
44361249	1119510	0	0
3002385	3002385	0	0
441840	40480160	4	10
21000101	1759842	0	0
21500290	1150836	1	1
4174520	4066995	1	1
36155578	1539411	2	3
36155227	1110410	0	0
40776614	3004501	1	1
40779561	3026361	4	6
44341723	1501700	0	0
44356912	1125315	0	0
44344239	705944	0	0
45643889	19079524	1	1
45640611	1112807	0	0
44340732	1129625	0	0
45632397	791967	0	0
45635932	1129625	0	0
45624345	1192710	0	0
45698766	1129625	0	0
45698107	1119510	0	0
45669267	1192710	0	0
45669379	1119510	0	0
45676137	1125315	0	0
45782871	1129625	0	0
45685084	1119510	0	0
45795026	1115008	0	0
45797727	1125315	0	0
46294563	1125315	0	0
46298369	1119510	0	0
46321898	1595799	0	0
46321085	1759842	0	0
44361256	1177480	0	0
3009201	3009201	0	0
441840	4066995	4	10
21000101	1746114	0	0
21500311	967823	1	1
4174520	4048695	1	1
36158440	40228214	2	3
36155230	1326303	0	0
40776958	3009542	1	1
36718588	4001336	4	6
44341685	1124957	0	0
44356915	1125315	0	0
44344240	1174888	0	0
45656318	19079524	1	1
45640545	1112807	0	0
44340752	1129625	0	0
45632295	1768849	0	0
45636353	1129625	0	0
45624674	1115008	0	0
45698828	1129625	0	0
45698083	1119510	0	0
45666833	1192710	0	0
45666748	1119510	0	0
45672885	1125315	0	0
45782923	1129625	0	0
45685140	1119510	0	0
45795052	1309944	0	0
45797738	1125315	0	0
46294684	1125315	0	0
46298347	1119510	0	0
46321905	1192710	0	0
46321626	1595799	0	0
45650307	1322184	0	0
3009542	3009542	0	0
441840	4144583	8	8
21000110	1717327	0	0
21500332	1129625	1	1
4042655	4047491	1	1
36158543	40228214	2	3
36155231	1305058	0	0
40777013	3035995	1	1
37202320	4048171	4	6
44341646	967823	0	0
44364083	920300	2	3
44344172	1115008	0	0
45634797	19079524	1	1
45637553	1112807	0	0
44340713	1129625	0	0
45632388	967823	0	0
45632989	1129625	0	0
45624294	1717327	0	0
45704475	19019273	2	3
45698096	1119510	0	0
45667057	1192710	0	0
45666749	1119510	0	0
45672878	1125315	0	0
45783018	1129625	0	0
45685887	1119510	0	0
45795054	740275	0	0
45797845	1125315	0	0
46294619	1125315	0	0
46298545	1119510	0	0
46321960	738818	0	0
46321637	1112807	0	0
45650720	1154029	0	0
80180	80180	0	0
441840	4218389	5	7
21000120	1728416	0	0
21500332	738818	1	1
4035228	4015189	1	1
36158744	40228214	2	3
36155267	1545958	0	0
40243435	40243436	1	1
37000000	4116491	4	6
44341697	738818	0	0
44364140	19077344	2	3
44344173	738818	0	0
45634635	19079524	1	1
45637265	1112807	0	0
44340921	1129625	0	0
45632454	1501700	0	0
45632659	1129625	0	0
45624490	1759842	0	0
45704487	1545959	2	3
45698427	1119510	0	0
45667051	1192710	0	0
45666872	1119510	0	0
45672970	1125315	0	0
45782988	1129625	0	0
45685524	1119510	0	0
45795034	1174888	0	0
45797501	1125315	0	0
46294388	1125315	0	0
46298297	1119510	0	0
46322225	738818	0	0
46321206	1741122	0	0
45650526	1177480	0	0
78272	78272	0	0
441840	4155034	5	8
21000122	1728416	0	0
21500332	1153428	1	1
4035987	4112343	1	1
36158466	40228214	2	3
36155275	975125	0	0
40093132	40163554	1	1
37202320	4112343	4	6
44341657	1729720	0	0
44364192	1127433	2	3
44344521	701322	0	0
45644032	19079524	1	1
45637515	1112807	0	0
45637404	1129625	0	0
45632466	1110410	0	0
45632918	1129625	0	0
45624490	1713332	0	0
45704497	19008572	2	3
45698546	1119510	0	0
45778453	1192710	0	0
45667006	1119510	0	0
45672972	1125315	0	0
45782844	1129625	0	0
45681890	1119510	0	0
45795011	1549786	0	0
45797861	1125315	0	0
46243884	1125315	0	0
46298300	1119510	0	0
46321766	1521369	0	0
46321206	1746114	0	0
45650532	723013	0	0
81151	81151	0	0
441840	380378	5	8
21000123	1728416	0	0
21500332	1192710	1	1
4037143	4037675	1	1
36159504	40228214	2	3
36154974	1149196	0	0
40002751	40231925	1	1
37200000	4112343	4	11
44341770	1177480	0	0
44364245	43012036	2	3
44344093	791967	0	0
45640680	19079524	1	1
45639822	1112807	0	0
45637355	1129625	0	0
45632435	1741122	0	0
45632772	1129625	0	0
45624608	738818	0	0
45704512	40231925	2	3
45698593	1119510	0	0
45778454	1192710	0	0
45667008	1119510	0	0
45672961	1125315	0	0
45783194	1129625	0	0
45681895	1119510	0	0
45795007	1154029	0	0
45797925	1125315	0	0
46243827	1125315	0	0
46298312	1119510	0	0
46321766	1595799	0	0
46321219	1545958	0	0
45650533	1129625	0	0
80502	80502	0	0
441840	30753	5	9
21000083	1713332	0	0
21500338	1192710	1	1
4133715	378001	1	1
36159055	40228214	2	3
36155286	1501700	0	0
40002706	40162522	1	1
37200000	4294548	4	10
44341779	1595799	0	0
44364337	19008572	2	3
44344687	975125	0	0
45653290	19079524	1	1
45639943	1112807	0	0
45625204	1129625	0	0
45632435	1746114	0	0
45659277	1177480	0	0
45624609	723013	0	0
45701024	19008572	2	3
45698643	1119510	0	0
45778434	1192710	0	0
45667027	1119510	0	0
45673051	1125315	0	0
45783112	1129625	0	0
45681986	1119510	0	0
45795009	1361711	0	0
45794791	1125315	0	0
46243858	1125315	0	0
46289695	1119510	0	0
46321766	1549786	0	0
46320732	1118084	0	0
45650292	1154343	0	0
1545958	1545958	0	0
441840	4051466	5	6
21000116	1728416	0	0
21500338	1174888	1	1
4133843	4015189	1	1
36151885	19078461	2	3
36154803	1112807	0	0
40002706	19133768	1	1
37200000	40486433	4	10
44341779	1521369	0	0
44357052	19133873	2	3
44343931	1343916	0	0
45656205	19079524	1	1
45639945	1112807	0	0
45625348	1129625	0	0
45632506	1124957	0	0
45657322	1177480	0	0
45624466	1500211	0	0
45700945	19073183	2	3
45697636	1119510	0	0
45778436	1192710	0	0
45666848	1119510	0	0
45672904	1125315	0	0
45783459	1129625	0	0
45682030	1119510	0	0
45795055	1545958	0	0
45794855	1125315	0	0
46243663	1125315	0	0
46289859	1119510	0	0
46321860	1551099	0	0
46320749	791967	0	0
45650313	975125	0	0
1519936	1519936	0	0
441840	261325	5	10
21000101	1717327	0	0
21500318	1119510	1	1
4143839	4197460	1	1
36159142	19078461	2	3
36154806	738818	0	0
37119655	45769019	1	1
37200000	40481087	4	9
44341779	1549786	0	0
44357240	1107882	2	3
44344376	1149380	0	0
45652296	19079524	1	1
45639949	1112807	0	0
45621792	1129625	0	0
45632522	708298	0	0
45657357	1177480	0	0
45624406	1713332	0	0
45700817	40163554	2	3
45697794	1119510	0	0
45778432	1192710	0	0
45666978	1119510	0	0
45673228	1125315	0	0
45783078	1129625	0	0
45682054	1119510	0	0
45795165	1107830	0	0
45797123	1125315	0	0
46243860	1125315	0	0
46289865	1119510	0	0
46321770	1115008	0	0
46320752	1713332	0	0
45650645	1551099	0	0
1519937	1519937	0	0
441840	440448	6	11
21000101	1778162	0	0
21500332	1107830	1	1
4185932	4329847	1	1
36158852	19078461	2	3
36155130	1112807	0	0
40793588	3014576	1	1
37200000	4051466	4	6
44341783	1129625	0	0
44358736	19133905	2	3
44344513	715997	0	0
45665279	19079524	1	1
45639993	1112807	0	0
45621808	1129625	0	0
45632408	738818	0	0
45657290	1177480	0	0
45624621	1589505	0	0
45701012	19008572	2	3
45695167	1119510	0	0
45778414	1192710	0	0
45666817	1119510	0	0
45673229	1125315	0	0
45783079	1129625	0	0
45682067	1119510	0	0
45795048	975125	0	0
45797127	1125315	0	0
46243670	1125315	0	0
46290025	1119510	0	0
46322021	791967	0	0
46321283	1551099	0	0
45650708	1177480	0	0
1548195	1548195	0	0
441840	4048169	6	7
21000148	1717327	0	0
21500332	1150836	1	1
4188027	4139681	1	1
36158201	19078461	2	3
36155136	1129625	0	0
40791672	3020630	1	1
36700000	4132546	4	9
44341860	1177480	0	0
44357302	1127433	2	3
44343934	738818	0	0
45628832	19079524	1	1
45634397	1112807	0	0
45621810	1129625	0	0
45632335	1174888	0	0
45657025	1177480	0	0
45624629	1551099	0	0
45701334	1127433	2	3
45695277	1119510	0	0
45707008	1192710	0	0
45667051	1119510	0	0
45672966	1125315	0	0
45783140	1129625	0	0
45682092	1119510	0	0
45795018	1000560	0	0
45797128	1125315	0	0
46243864	1125315	0	0
46290333	1119510	0	0
46322022	920293	0	0
46321482	1112807	0	0
45650714	1124300	0	0
1713332	1713332	0	0
441840	4302207	6	7
21000102	1746114	0	0
21500339	1129625	1	1
4188027	438614	1	1
36158425	19078461	2	3
36155138	1129625	0	0
40779933	3026361	1	1
36700000	4066995	4	8
44341819	1310149	0	0
44357364	19129655	2	3
44344205	967823	0	0
45638081	19079524	1	1
45634481	1112807	0	0
45620586	1129625	0	0
45632416	1174888	0	0
45656953	1177480	0	0
45624636	1124300	0	0
45700792	1107882	2	3
45695283	1119510	0	0
45707069	1192710	0	0
45667124	1119510	0	0
45673250	1125315	0	0
45783204	1129625	0	0
45682108	1119510	0	0
45795143	1110410	0	0
45797134	1125315	0	0
46243891	1125315	0	0
46289941	1119510	0	0
46322236	1343916	0	0
46320970	1738521	0	0
45650480	1119510	0	0
1154029	1154029	0	0
441840	4102123	6	7
21000102	1759842	0	0
21500328	1112807	1	1
4188027	442116	1	1
36158710	19078461	2	3
36155140	738818	0	0
40653085	3004501	1	1
37522270	4301346	4	5
44341825	967823	0	0
44357398	1127433	2	3
44344208	1310149	0	0
45665029	19079524	1	1
45634280	1112807	0	0
45620590	1129625	0	0
45632355	738818	0	0
45657391	1177480	0	0
45624650	1549786	0	0
45697934	1551192	2	3
45695331	1119510	0	0
45707097	1192710	0	0
45667082	1119510	0	0
45673255	1125315	0	0
45783435	1129625	0	0
45682210	1119510	0	0
45795085	1118084	0	0
45797218	1125315	0	0
46243675	1125315	0	0
46289411	1119510	0	0
46322479	1192710	0	0
46320992	1112807	0	0
45650489	1177480	0	0
1154615	1154615	0	0
441840	375671	7	11
21000116	1738521	0	0
21500339	1174888	1	1
4188027	4169137	1	1
36159638	19078461	2	3
36156473	1129625	0	0
40653240	3019406	1	1
37503887	4242997	4	4
44341957	920293	0	0
44357400	19133873	2	3
44344320	1124300	0	0
44361937	40223774	1	1
45634714	1112807	0	0
45620565	1129625	0	0
45632566	19078219	0	0
45656958	1177480	0	0
45624650	1521369	0	0
45698072	19008572	2	3
45695416	1119510	0	0
45704175	1192710	0	0
45667134	1119510	0	0
45673164	1125315	0	0
45783258	1129625	0	0
45682000	1119510	0	0
45795208	1107830	0	0
45796916	1125315	0	0
46243682	1125315	0	0
46290247	1119510	0	0
46322189	738818	0	0
46321590	1112807	0	0
45650655	1192710	0	0
195588	195588	0	0
441840	433125	7	7
21000268	1738521	0	0
21500328	1125315	1	1
4179823	4156265	1	1
36151743	1332419	2	3
36156562	1713332	0	0
40654863	3004501	1	1
37503887	4330583	4	4
44341963	1129625	0	0
44352386	1115171	2	3
44344323	1551099	0	0
45656203	46275916	1	1
45631421	1112807	0	0
45620658	1129625	0	0
45632570	1154343	0	0
45653851	1177480	0	0
45624650	19127890	0	0
45697884	19133768	2	3
45695384	1119510	0	0
45700900	1192710	0	0
45780960	1119510	0	0
45673177	1125315	0	0
45780575	1129625	0	0
45682177	1119510	0	0
45795209	738818	0	0
45797219	1125315	0	0
46243774	1125315	0	0
46290255	1119510	0	0
46322040	1501700	0	0
46321619	1112807	0	0
45650755	723013	0	0
1766384	920293	0	0
441840	45769019	7	9
21000280	1728416	0	0
21500332	1149196	1	1
4077069	4163874	1	1
36154514	1332419	2	3
36156384	1307863	0	0
40654905	3000963	1	1
37503887	4117038	4	4
44341728	1310149	0	0
44350342	1127433	2	3
44344343	701322	0	0
45652604	46275916	1	1
45631436	1112807	0	0
45620752	1129625	0	0
45632624	1332418	0	0
45647363	1177480	0	0
45624664	1738521	0	0
45698019	40232448	2	3
45695341	1119510	0	0
45701064	1192710	0	0
45778452	1119510	0	0
45673108	1125315	0	0
45780495	1129625	0	0
45682415	1119510	0	0
45795071	715997	0	0
45797220	1125315	0	0
46243851	1125315	0	0
46290176	1119510	0	0
46321930	738818	0	0
46321645	1112807	0	0
45650581	1124300	0	0
1766389	1343916	0	0
4322976	4337138	5	8
21000267	1746114	0	0
21500328	1115008	1	1
4077352	4324181	1	1
36159190	1332419	2	3
36156485	1107830	0	0
40655325	3023103	1	1
40773177	3004501	4	4
44341735	1539403	0	0
44350244	40229134	2	3
44344444	1396131	0	0
45652848	19079524	1	1
45631500	1112807	0	0
45661584	1129625	0	0
45632571	1322184	0	0
45647507	1177480	0	0
45624412	1115008	0	0
45698123	1127433	2	3
45695352	1119510	0	0
45701422	1192710	0	0
45778454	1119510	0	0
45786723	1125315	0	0
45777659	1129625	0	0
45678912	1119510	0	0
45795092	1115008	0	0
45797188	1125315	0	0
46243852	1125315	0	0
46289669	1119510	0	0
46322139	738818	0	0
46321664	1174888	0	0
45650582	1549786	0	0
1766448	1107830	0	0
4322976	4301346	5	10
21000259	1728416	0	0
21500339	1192710	1	1
4078460	4163951	1	1
36152436	1539411	2	3
36156491	1107830	0	0
40655374	3020630	1	1
40796128	3028833	4	4
44341736	1729720	0	0
44350491	40232448	2	3
44344425	975125	0	0
45649606	46275916	1	1
45628581	1112807	0	0
45661697	1129625	0	0
45632572	1154343	0	0
45647426	1177480	0	0
45624413	1192710	0	0
45697977	1127433	2	3
45695429	1119510	0	0
45700784	1192710	0	0
45778169	1119510	0	0
45784873	1125315	0	0
45778228	1129625	0	0
45678751	1119510	0	0
45795095	1326303	0	0
45797190	1125315	0	0
46243854	1125315	0	0
46291800	1119510	0	0
46322148	1154343	0	0
46315335	1000560	0	0
45650582	1512674	0	0
1766449	975125	0	0
4322976	4243062	5	7
21000284	1738521	0	0
21500344	738818	1	1
4031049	4181917	1	1
36217210	19079524	2	3
36156498	1192710	0	0
40654162	3006322	1	1
40796128	3020630	4	4
44341739	1332418	0	0
44350658	19059056	2	3
44344263	723013	0	0
45646731	46275916	1	1
45628312	1112807	0	0
45661758	1129625	0	0
45632439	1307863	0	0
45647466	1177480	0	0
45624446	975125	0	0
45698282	40169281	2	3
45695536	1119510	0	0
45698022	1192710	0	0
45778433	1119510	0	0
45784875	1125315	0	0
46242719	1129625	0	0
45706782	1125315	0	0
45795153	1778162	0	0
45795013	1125315	0	0
46244772	1125315	0	0
46241932	1119510	0	0
46322157	738818	0	0
46315314	715997	0	0
45650766	1177480	0	0
1766450	1125315	0	0
4322976	4163872	5	7
21000196	1738521	0	0
21500328	1192710	1	1
4032251	4145310	1	1
36217210	40224132	2	3
36156498	1112807	0	0
40655518	3008598	1	1
40796128	3010813	4	4
44359118	1119510	0	0
44350805	1107882	2	3
44337439	1149380	0	0
45643829	46275916	1	1
45628514	1112807	0	0
45658278	1129625	0	0
45632344	723013	0	0
45647547	1177480	0	0
45624448	738818	0	0
45697989	1107882	2	3
45695371	1119510	0	0
45698131	1192710	0	0
45778435	1119510	0	0
45784878	1125315	0	0
46242721	1129625	0	0
45706749	1125315	0	0
45795155	1322184	0	0
45795014	1125315	0	0
46244777	1125315	0	0
46241955	1119510	0	0
46322161	1124300	0	0
46315378	1112807	0	0
45650597	975125	0	0
1766460	1129625	0	0
4322976	4234705	5	5
21000213	1738521	0	0
21500344	1119510	1	1
19100279	19006318	1	1
36217207	19023423	2	3
36156499	1129625	0	0
40655590	3013682	1	1
40796128	3026361	4	4
44359123	1119510	0	0
44350253	19123231	2	3
44337443	1153428	0	0
45646059	19079524	1	1
45625349	1112807	0	0
45658341	1129625	0	0
45632374	791967	0	0
45647682	1177480	0	0
45624666	975125	0	0
45698269	19078461	2	3
45695524	1119510	0	0
45697971	1192710	0	0
45778436	1119510	0	0
45784743	1125315	0	0
46240309	1129625	0	0
45706695	1125315	0	0
45792393	1112807	0	0
45794977	1125315	0	0
46244780	1125315	0	0
46241958	1119510	0	0
46322255	1551099	0	0
46315456	1124957	0	0
45650768	1129625	0	0
1766469	753626	0	0
4322976	4133840	5	5
21000218	1738521	0	0
21500328	1177480	1	1
4122944	4163872	1	1
36217207	19029476	2	3
36156499	1177480	0	0
40656757	3049273	1	1
40796128	3000963	4	4
44358995	1119510	0	0
44350334	1551192	2	3
44337380	19127890	0	0
45637860	46275916	1	1
45625352	1112807	0	0
45655592	1129625	0	0
45632607	967823	0	0
45648066	1177480	0	0
45624676	1728416	0	0
45695021	19008572	2	3
45695303	1119510	0	0
45694787	1192710	0	0
45778438	1119510	0	0
45784777	1125315	0	0
46240434	1129625	0	0
45706769	1125315	0	0
45792272	705944	0	0
45795027	1125315	0	0
46244787	1125315	0	0
46241965	1119510	0	0
46322485	1124300	0	0
46315458	1000560	0	0
45650556	1501700	0	0
1766488	967823	0	0
4322976	4151422	5	5
21000216	1738521	0	0
21500344	1129625	1	1
4122944	4058899	1	1
36217207	40169281	2	3
36156594	1124300	0	0
40654273	3024561	1	1
37502354	4202451	4	4
44358996	1119510	0	0
44350365	40232448	2	3
44337293	1174888	0	0
45636925	46275916	1	1
45625314	1112807	0	0
45655689	1129625	0	0
45632474	757627	0	0
45644383	1177480	0	0
45624579	1107830	0	0
45695040	19008572	2	3
45692000	1119510	0	0
45694802	1192710	0	0
45778440	1119510	0	0
45784869	1125315	0	0
46240183	1129625	0	0
45705240	1125315	0	0
45792274	920293	0	0
45795034	1125315	0	0
46244884	1125315	0	0
46241968	1119510	0	0
46322486	1192710	0	0
46315470	1326303	0	0
45650665	1738521	0	0
1766393	1125315	0	0
4322976	4181917	5	6
19125062	19125062	0	0
21500344	1192710	1	1
4100474	4057420	1	1
36217207	40169216	2	3
36156319	1738521	0	0
40250192	1119510	1	1
40776264	3008598	4	4
44358888	1119510	0	0
44350700	40236824	2	3
44337380	1549786	0	0
45631831	46275916	1	1
45625316	1112807	0	0
45655655	1129625	0	0
45632482	1308738	0	0
45644597	1177480	0	0
45624767	738818	0	0
45694802	43012036	2	3
45692097	1119510	0	0
45694915	1192710	0	0
45778458	1119510	0	0
45784871	1125315	0	0
46240364	1129625	0	0
45705189	1125315	0	0
45792394	975125	0	0
45795038	1125315	0	0
46243957	1125315	0	0
46242014	1119510	0	0
46322493	1551099	0	0
46315474	791967	0	0
45650731	705944	0	0
1766503	1112807	0	0
4322976	4062501	4	6
19126352	19126352	0	0
21500324	19029476	1	1
4076875	4301346	1	1
36217207	1154615	2	3
36156563	1107830	0	0
40250176	40221415	1	1
36702242	380378	4	4
44359253	1119510	0	0
44350703	1127433	2	3
44337296	1557272	0	0
45628451	40223774	1	1
45625348	1112807	0	0
45655818	1129625	0	0
45632489	19039298	0	0
45645915	1177480	0	0
45624561	1000560	0	0
45694804	40232448	2	3
45692077	1119510	0	0
45645802	1192710	0	0
45778460	1119510	0	0
45785016	1125315	0	0
46240374	1129625	0	0
45705191	1125315	0	0
45792220	1738521	0	0
45795084	1125315	0	0
46243959	1125315	0	0
46242016	1119510	0	0
46322204	1149196	0	0
46315621	1500211	0	0
45650751	1149196	0	0
1766492	1129625	0	0
4322976	4145310	4	6
19127893	19127904	0	0
21500348	1129625	1	1
4079526	44783196	1	1
36217207	782047	2	3
35909442	198809	0	0
40174875	40174880	1	1
36702242	381316	4	4
44359329	1119510	0	0
44346404	1115171	2	3
44337297	1595799	0	0
45631106	46275916	1	1
45625276	1112807	0	0
45655744	1129625	0	0
45632444	914335	0	0
45644768	1177480	0	0
45624765	1332418	0	0
45645801	19019273	2	3
45692102	1119510	0	0
45691677	1192710	0	0
45778355	1119510	0	0
45785024	1125315	0	0
46242092	1129625	0	0
45705193	1125315	0	0
45792099	1107830	0	0
45795209	1125315	0	0
46244051	1125315	0	0
46241905	1119510	0	0
46322265	1192710	0	0
46315628	1174888	0	0
45650833	1778162	0	0
1766494	1361711	0	0
4322976	4295880	4	6
19127904	19127904	0	0
21500348	1192710	1	1
4078442	4057420	1	1
36217216	40223821	2	3
35707594	4285898	0	0
40100593	19023398	1	1
40779591	3000876	4	4
44359330	1119510	0	0
44346471	1127433	2	3
44337297	1521369	0	0
45628845	46275916	1	1
45625392	1112807	0	0
45649331	1129625	0	0
45658343	1125315	0	0
45641888	1177480	0	0
45624860	1149196	0	0
45691577	40228214	2	3
45692218	1119510	0	0
45691682	1192710	0	0
45778357	1119510	0	0
45785026	1125315	0	0
46240515	1129625	0	0
45705199	1125315	0	0
45792221	967823	0	0
45792252	1125315	0	0
46244054	1125315	0	0
46241912	1119510	0	0
46322273	1713332	0	0
46315655	1112807	0	0
45650834	1129625	0	0
1766405	1115008	0	0
4322976	4195803	4	4
19129144	19129144	0	0
21500350	1192710	1	1
1101553	40169281	1	1
36217216	46233710	2	3
36151049	742185	0	0
40098676	19029476	1	1
37503868	4336464	4	4
44359156	1119510	0	0
44346392	1107882	2	3
44337297	1549786	0	0
45628879	46275916	1	1
45625806	1112807	0	0
44337690	1119510	0	0
45658404	1125315	0	0
45641632	1177480	0	0
45624864	1124300	0	0
45691677	43012036	2	3
45692089	1119510	0	0
45688936	1192710	0	0
45778431	1119510	0	0
45785036	1125315	0	0
46240516	1129625	0	0
45705208	1125315	0	0
45792187	1192710	0	0
45792279	1125315	0	0
46244005	1125315	0	0
46242112	1119510	0	0
46322287	1115008	0	0
46315660	1551099	0	0
45650736	1129625	0	0
1766414	1107830	0	0
4322976	4187458	4	4
19096779	19074841	0	0
21500351	1125315	1	1
4045900	4047491	4	5
36217216	1107882	2	3
36151054	1129625	0	0
40098677	19029476	1	1
40792746	3049273	4	4
44359165	1119510	0	0
44346502	19019273	2	3
44337372	1118084	0	0
45625997	46275916	1	1
45622117	1112807	0	0
44337601	1119510	0	0
45657580	1125315	0	0
45641992	1177480	0	0
45624867	1192710	0	0
45691641	40232448	2	3
45692138	1119510	0	0
45688942	1192710	0	0
45778432	1119510	0	0
45785038	1125315	0	0
45703292	1129625	0	0
45705370	1125315	0	0
45792187	1174888	0	0
45792355	1125315	0	0
46238900	1125315	0	0
46242174	1119510	0	0
46322302	1115008	0	0
46315668	1501700	0	0
45650467	1129625	0	0
1766566	1192710	0	0
4322976	4012477	4	7
19078219	19078219	0	0
21500352	1129625	1	1
4030660	4198190	4	5
36217216	19075601	2	3
36150849	1112807	0	0
40054982	19023423	1	1
37302323	4155034	4	4
44359166	1119510	0	0
44346536	19133905	2	3
44337454	1332418	0	0
45622638	46275916	1	1
45622060	1112807	0	0
44337883	1119510	0	0
45657558	1125315	0	0
45641968	1177480	0	0
45624875	1137529	0	0
45691672	1115171	2	3
45694622	1119510	0	0
45686044	1192710	0	0
45778389	1119510	0	0
45785043	1125315	0	0
45703139	1129625	0	0
45705267	1125315	0	0
45792351	1115008	0	0
45792300	1125315	0	0
46238901	1125315	0	0
46241946	1119510	0	0
46322495	738818	0	0
46315670	1713332	0	0
45650847	1119510	0	0
1766566	1125315	0	0
4322976	44805732	4	7
19078924	19078924	0	0
21500352	1125315	1	1
4180627	4199276	4	5
36217216	19074843	2	3
36150758	1551099	0	0
40056535	19077344	1	1
40779557	3019406	4	4
44359294	1119510	0	0
44346543	19133873	2	3
44337418	1124300	0	0
45623042	40171902	1	1
45624968	1112807	0	0
44337884	1119510	0	0
45657595	1125315	0	0
45641956	1177480	0	0
45624875	1149380	0	0
45691819	40232448	2	3
45689281	1119510	0	0
45685918	1192710	0	0
45778468	1119510	0	0
45784882	1125315	0	0
45703145	1129625	0	0
45780013	1125315	0	0
45792353	1310149	0	0
45792480	1125315	0	0
46238902	1125315	0	0
46242076	1119510	0	0
46322501	975125	0	0
46315570	1174888	0	0
45650739	975125	0	0
1768849	1768849	0	0
4322976	4163971	4	9
19039298	19039298	0	0
21500354	1174888	1	1
4038678	81893	4	5
36217216	40228230	2	3
36150850	1177480	0	0
40056894	40223834	1	1
36703477	4132546	4	4
44359001	1119510	0	0
44346742	40232448	2	3
44337423	1545958	0	0
45621935	19079524	1	1
45624943	1112807	0	0
44778040	1119510	0	0
45657848	1125315	0	0
45638796	1177480	0	0
45624879	738818	0	0
45691919	40223768	2	3
45689320	1119510	0	0
45688291	1192710	0	0
45778513	1119510	0	0
45784937	1125315	0	0
45703579	1129625	0	0
45779848	1125315	0	0
45792222	1738521	0	0
45792364	1125315	0	0
46238903	1125315	0	0
46242234	1119510	0	0
46322502	1738521	0	0
46315915	740275	0	0
45650740	1501700	0	0
1766609	920293	0	0
4322976	4252419	4	8
19008572	19008572	0	0
21505745	1174888	1	1
4096864	4166224	4	5
36217216	40223834	2	3
36150906	1107830	0	0
40056894	40223821	1	1
36703534	378001	4	4
44359304	1119510	0	0
44346821	40223834	2	3
44337812	1713332	0	0
45622039	19079524	1	1
45624954	1112807	0	0
44778254	1119510	0	0
45657775	1125315	0	0
45638806	1177480	0	0
45624760	1322184	0	0
45691887	19008572	2	3
45689162	1119510	0	0
45682858	1192710	0	0
45780610	1119510	0	0
45785161	1125315	0	0
45703530	1129625	0	0
45780010	1125315	0	0
45792232	1115008	0	0
45792331	1125315	0	0
46238863	1125315	0	0
46242182	1119510	0	0
46322344	1124957	0	0
46315355	1153428	0	0
45650749	1112807	0	0
1766555	1549786	0	0
4322976	4202451	4	8
4323902	4323902	0	0
21505750	1192710	1	1
4180627	4163951	3	5
36217216	19133768	2	3
36150915	738818	0	0
40041368	1519937	1	1
40776225	3014599	4	4
44359306	1119510	0	0
44346298	19078461	2	3
44337784	1174888	0	0
45621429	19079524	1	1
45622261	1112807	0	0
44778219	1119510	0	0
45657780	1125315	0	0
45638887	1177480	0	0
45624364	975125	0	0
45691695	1115171	2	3
45689178	1119510	0	0
45683216	1192710	0	0
45780509	1119510	0	0
45784901	1125315	0	0
45703533	1129625	0	0
45779772	1125315	0	0
45792358	1307863	0	0
45792427	1125315	0	0
46238870	1125315	0	0
46242185	1119510	0	0
46322347	1192710	0	0
46315543	1595799	0	0
45650761	1149196	0	0
1766555	1512674	0	0
4322976	4024289	4	8
4324181	4324181	0	0
21505750	1174888	1	1
4180627	4024289	3	5
36217206	44816277	2	3
36150990	740275	0	0
40010254	1150771	1	1
36702254	4001336	4	4
44359083	1119510	0	0
44346606	19008572	2	3
44338021	1192710	0	0
45665169	19079524	1	1
45622306	1112807	0	0
44358972	1119510	0	0
45657787	1125315	0	0
45639096	1177480	0	0
45624808	967823	0	0
45692046	40231925	2	3
45689215	1119510	0	0
45682925	1192710	0	0
45780521	1119510	0	0
45785134	1125315	0	0
45703264	1129625	0	0
45779927	1125315	0	0
45792451	1713332	0	0
45792161	1125315	0	0
46238919	1125315	0	0
46242309	1119510	0	0
46315798	1124300	0	0
46315543	1308738	0	0
45650853	975125	0	0
1766557	1713332	0	0
4322976	4323902	3	9
4323208	4323208	0	0
21505751	1119510	1	1
21600961	19075601	2	5
36217214	46233988	2	3
36150992	1192710	0	0
40009472	19073183	1	1
37202317	4048171	5	5
44352315	1119510	0	0
44346738	19019273	2	3
44337822	1107830	0	0
45665149	46275916	1	1
45622369	1112807	0	0
44358976	1119510	0	0
45657822	1125315	0	0
45639104	1177480	0	0
45624984	1149196	0	0
45692071	19018935	2	3
45689357	1119510	0	0
45704142	975125	0	0
45780523	1119510	0	0
45784952	1125315	0	0
45703267	1129625	0	0
45780126	1125315	0	0
45792479	1343916	0	0
45792527	1125315	0	0
46238920	1125315	0	0
46241988	1119510	0	0
46316069	914335	0	0
46315790	1000560	0	0
45650798	1539403	0	0
1766557	1759842	0	0
4322976	4275113	3	9
4230209	4230209	0	0
21505751	1192710	1	1
21600961	40163554	2	5
36217214	1551192	2	3
36150997	1137529	0	0
40099132	19123231	1	1
37002291	195588	5	5
44352053	1119510	0	0
44348579	40232448	2	3
44337999	1000560	0	0
45665258	19079524	1	1
45622460	1112807	0	0
44359058	1119510	0	0
45657627	1125315	0	0
45638786	1177480	0	0
45624991	1192710	0	0
45688819	40232448	2	3
45689535	1119510	0	0
45704146	975125	0	0
45707069	1119510	0	0
45784843	1125315	0	0
45700398	1129625	0	0
45779779	1125315	0	0
45792237	1102527	0	0
45792447	1125315	0	0
46238921	1125315	0	0
46242288	1119510	0	0
46316220	1000560	0	0
46315791	1713332	0	0
45650858	1119510	0	0
1766561	1107830	0	0
4322976	4057420	3	9
4230399	4230399	0	0
21505753	1119510	1	1
21604564	19076374	2	5
36217214	836659	2	3
36150997	1149380	0	0
36703451	381316	1	1
40779561	3002385	5	5
44355213	1119510	0	0
44348291	1551192	2	3
44338186	1124957	0	0
45662162	19079524	1	1
45622384	1112807	0	0
44358846	1119510	0	0
45654048	1125315	0	0
45638869	1177480	0	0
45624423	742185	0	0
45688791	1107882	2	3
45689056	1119510	0	0
45703956	975125	0	0
45707138	1119510	0	0
45785080	1125315	0	0
45700301	1129625	0	0
45780053	1125315	0	0
45792240	1153428	0	0
45792450	1125315	0	0
46238922	1125315	0	0
46242000	1119510	0	0
46316242	1361711	0	0
46315928	975125	0	0
45650673	1177480	0	0
1766420	1124300	0	0
4322976	4078793	3	8
21001547	1309944	0	0
21505753	1192710	1	1
21604564	19057271	2	5
36217214	19059056	2	3
36150998	1177480	0	0
40000823	1107882	1	1
40779561	3024731	5	5
44355222	1119510	0	0
44342766	40229134	2	3
44338011	1307863	0	0
45659396	40220386	1	1
45620730	1112807	0	0
44358978	1119510	0	0
45654116	1125315	0	0
45635578	1177480	0	0
45624715	1367571	0	0
45688763	40243436	2	3
45689529	1119510	0	0
45703782	975125	0	0
45707329	1119510	0	0
45785202	1125315	0	0
45700309	1129625	0	0
45780077	1125315	0	0
45792359	1124300	0	0
45792536	1125315	0	0
46238923	1125315	0	0
46242003	1119510	0	0
46316255	1115008	0	0
46315949	1521369	0	0
45650675	1177480	0	0
1766424	1125315	0	0
4322976	4010253	3	8
21001554	1343916	0	0
21505753	1125315	1	1
21604792	19077572	2	5
36217214	45892894	2	3
36150958	1307863	0	0
40009799	19129655	1	1
40779561	3007461	5	5
44355406	1119510	0	0
44342721	40232448	2	3
44337533	1521369	0	0
45658342	46275916	1	1
45621026	1112807	0	0
44359179	1119510	0	0
45654202	1125315	0	0
45635594	1177480	0	0
45624598	1367571	0	0
45688812	19019273	2	3
45686258	1119510	0	0
45652318	975125	0	0
45707097	1119510	0	0
45785220	1125315	0	0
45700481	1129625	0	0
45780195	1125315	0	0
45792364	738818	0	0
45792630	1125315	0	0
46238968	1125315	0	0
45893701	1119510	0	0
46316304	1115008	0	0
46316017	1153428	0	0
45650807	975125	0	0
1766424	1119510	0	0
4322976	4238715	3	7
21001554	1309944	0	0
21505758	1125315	1	1
21604792	40223768	2	5
36217214	19073188	2	3
36151009	1192710	0	0
40173379	40232448	1	1
37003663	45769019	5	5
44352442	1119510	0	0
44343079	19073183	2	3
44337533	1549786	0	0
45656627	46275916	1	1
45621183	1112807	0	0
44358364	1119510	0	0
45654203	1125315	0	0
45635713	1177480	0	0
45624375	1192710	0	0
45688883	19008572	2	3
45686299	1119510	0	0
45652089	975125	0	0
45707250	1119510	0	0
45784968	1125315	0	0
45700502	1129625	0	0
45780175	1125315	0	0
45792368	1110410	0	0
45792152	1125315	0	0
46238970	1125315	0	0
45893753	1119510	0	0
46316312	1308738	0	0
46316020	1124300	0	0
45650809	1308738	0	0
1766426	1192710	0	0
4322976	4059978	3	6
21001538	1307863	0	0
21505914	1119510	1	1
4037672	42535580	5	5
36217214	19074841	2	3
36151015	1149196	0	0
40097012	964261	1	1
37600000	4324181	5	5
44352561	1119510	0	0
44342880	43012036	2	3
44337534	1192710	0	0
45656703	19079524	1	1
45621215	1112807	0	0
44358336	1119510	0	0
45654387	1125315	0	0
45635719	1177480	0	0
45624779	1310149	0	0
45688942	43012036	2	3
45686681	1119510	0	0
45700708	975125	0	0
45707356	1119510	0	0
45784972	1125315	0	0
45700345	1129625	0	0
45780026	1125315	0	0
45792456	1307863	0	0
45792415	1125315	0	0
46238887	1125315	0	0
45801735	1119510	0	0
46316316	1192710	0	0
46316095	1713332	0	0
45650812	1129625	0	0
1768657	1361711	0	0
4322976	4199276	3	6
21001557	1343916	0	0
21505914	1192710	1	1
4162282	260139	5	5
36217214	19123231	2	3
36151021	1115008	0	0
40249028	40169281	1	1
37202319	321042	5	5
44352564	1119510	0	0
44343305	19008572	2	3
44337523	933724	0	0
45652834	46275916	1	1
45664755	1112807	0	0
44358314	1119510	0	0
45654310	1125315	0	0
45632642	1177480	0	0
45624504	791967	0	0
45689095	19008572	2	3
45686409	1119510	0	0
45700711	975125	0	0
45704277	1119510	0	0
45784973	1125315	0	0
45700267	1129625	0	0
45780057	1125315	0	0
45792336	1112807	0	0
45792500	1125315	0	0
46238893	1125315	0	0
45801830	1119510	0	0
46316333	1551099	0	0
46316095	1759842	0	0
45650812	1119510	0	0
1766397	1545958	0	0
4322976	4326177	3	4
21001630	1545958	0	0
21505920	1125315	1	1
4162282	4294548	5	5
36217214	1545959	2	3
36150866	1115008	0	0
40173617	40173590	1	1
37202319	317576	5	5
44352592	1119510	0	0
44342909	46233988	2	3
44337530	920293	0	0
45647074	19079524	1	1
45664342	1112807	0	0
44358327	1119510	0	0
45654313	1125315	0	0
45632801	1177480	0	0
45624536	738818	0	0
45686027	19076374	2	3
45686374	1119510	0	0
45648686	975125	0	0
45704279	1119510	0	0
45784978	1125315	0	0
45896879	1129625	0	0
45780063	1125315	0	0
45792338	1545958	0	0
45792697	1125315	0	0
46238895	1125315	0	0
45801796	1119510	0	0
46316449	975125	0	0
46315916	975125	0	0
45650590	1177480	0	0
1766593	1125315	0	0
4322976	4246502	3	5
21001555	1309944	0	0
21505758	1119510	1	1
4162282	4280726	5	5
36102976	4112343	2	4
36151028	933724	0	0
40009507	19073188	1	1
36703477	4001336	5	5
44352453	1119510	0	0
44343061	1115171	2	3
44337582	1549786	0	0
45644196	46275916	1	1
45662020	1112807	0	0
44358565	1119510	0	0
45654315	1125315	0	0
45632871	1177480	0	0
45624537	1512674	0	0
45686042	40165015	2	3
45686390	1119510	0	0
45648928	975125	0	0
45704285	1119510	0	0
45785099	1125315	0	0
45697214	1129625	0	0
45780069	1125315	0	0
45792427	738818	0	0
45792651	1125315	0	0
46238896	1125315	0	0
45802420	1119510	0	0
46316155	1551099	0	0
46315796	1738521	0	0
45650605	1501700	0	0
1778162	1778162	0	0
4322976	4202832	3	5
21001565	1343916	0	0
21505758	738818	1	1
4042645	40492359	5	5
36102976	4294548	2	4
36150851	1107830	0	0
40095878	19075601	1	1
36718119	375671	5	5
44352476	1119510	0	0
44339602	1127433	2	3
44337556	1343916	0	0
45641218	46275916	1	1
45662037	1112807	0	0
44358433	1119510	0	0
45654317	1125315	0	0
45631083	1177480	0	0
45624537	1549786	0	0
45685747	19074843	2	3
45686391	1119510	0	0
45645581	975125	0	0
45704331	1119510	0	0
45785225	1125315	0	0
45694285	1129625	0	0
45780118	1125315	0	0
45792429	1192710	0	0
45789494	1125315	0	0
46238897	1125315	0	0
45799083	1119510	0	0
46311140	1000560	0	0
46315974	1322184	0	0
45650823	1192710	0	0
1766595	975125	0	0
4322976	4024958	6	7
21001565	914335	0	0
21505758	1192710	1	1
4042645	4336464	5	5
36202155	4066995	2	4
36151059	1154343	0	0
40009896	19059056	1	1
36718119	378001	5	5
44352478	1119510	0	0
44339504	19008572	2	3
44337576	1545958	0	0
45638321	46275916	1	1
45662148	1112807	0	0
44358520	1119510	0	0
45654139	1125315	0	0
45629698	1177480	0	0
45624537	19127890	0	0
45686159	40232448	2	3
45686396	1119510	0	0
45645692	975125	0	0
45704337	1119510	0	0
45785227	1125315	0	0
45694244	1129625	0	0
45780155	1125315	0	0
45792315	723013	0	0
45789625	1125315	0	0
46238898	1125315	0	0
45798993	1119510	0	0
46311143	1361711	0	0
46316134	1112807	0	0
45650606	1119510	0	0
1766598	1713332	0	0
4322976	4336464	6	11
21001578	1326303	0	0
21505758	1112807	1	1
4038335	4330583	5	5
36202155	4237458	2	4
36150872	1115008	0	0
40005746	1127433	1	1
37202316	4048171	5	10
44352486	1119510	0	0
44339484	40162522	2	3
44337577	1589505	0	0
45638316	46275916	1	1
45662069	1112807	0	0
44358529	1119510	0	0
45654146	1125315	0	0
45629766	1177480	0	0
45624748	1310149	0	0
45685918	43012036	2	3
45686529	1119510	0	0
45642698	975125	0	0
45704290	1119510	0	0
45785228	1125315	0	0
45694446	1129625	0	0
45779971	1125315	0	0
45792420	757627	0	0
45789727	1125315	0	0
46238899	1125315	0	0
45799095	1119510	0	0
46310913	1738521	0	0
46316152	1551099	0	0
45650613	1119510	0	0
1154343	1154343	0	0
4322976	4108705	6	9
21001627	1112807	0	0
21503969	1174888	1	1
4175951	4168004	5	5
36202155	4059173	2	4
36151038	1177480	0	0
40005746	1127078	1	1
37202316	258780	5	10
44352570	1119510	0	0
44339438	40162522	2	3
44337577	1549786	0	0
44351456	46275916	1	1
45662544	1112807	0	0
44358572	1119510	0	0
45654447	1125315	0	0
45629789	1177480	0	0
45624843	1174888	0	0
45688613	19008572	2	3
45686427	1119510	0	0
45642719	975125	0	0
45704226	1119510	0	0
45785234	1125315	0	0
45691336	1129625	0	0
45780030	1125315	0	0
45792161	738818	0	0
45789746	1125315	0	0
46239039	1125315	0	0
45799098	1119510	0	0
46310804	967823	0	0
46315219	1549786	0	0
45650703	975125	0	0
1174888	1174888	0	0
4322976	4047491	6	9
21000643	1500211	0	0
21503969	1177480	1	1
4179873	378419	5	5
36110570	4294548	2	4
36151040	967823	0	0
40008978	1332419	1	1
37202316	260139	5	9
42803016	1119510	0	0
44341064	1545959	2	3
44337649	740275	0	0
44351637	46275916	1	1
45662546	1112807	0	0
44358669	1119510	0	0
45654518	1125315	0	0
45627021	1177480	0	0
45624847	975125	0	0
45682838	1107882	2	3
45686580	1119510	0	0
45642844	975125	0	0
45704227	1119510	0	0
45785169	1125315	0	0
45691300	1129625	0	0
45780038	1125315	0	0
45792526	1361711	0	0
45789828	1125315	0	0
46239042	1125315	0	0
45799124	1119510	0	0
46310808	1174888	0	0
46315219	1521369	0	0
45650599	1177480	0	0
1580765	1107830	0	0
4322976	42535580	6	9
21000653	1500211	0	0
21504026	1125315	1	1
4180169	28060	3	6
36202155	4142905	2	4
36151067	1129625	0	0
40095247	1545959	1	1
37202316	40481087	5	8
44344936	1119510	0	0
44339713	40228230	2	3
44337651	705944	0	0
44784095	4295880	1	1
45659069	1112807	0	0
44358601	1119510	0	0
45654240	1125315	0	0
45626769	1177480	0	0
45668534	1154343	0	0
45682943	19075001	2	3
45683170	1119510	0	0
45642832	975125	0	0
45704294	1119510	0	0
45786482	1125315	0	0
45802644	1129625	0	0
45780041	1125315	0	0
45792561	1154029	0	0
45789847	1125315	0	0
46238988	1125315	0	0
45799173	1119510	0	0
46310808	1192710	0	0
46316021	975125	0	0
45650600	1154343	0	0
1580887	1332418	0	0
4322976	4330583	6	10
21000694	1308738	0	0
21504026	1112807	1	1
4180169	255848	3	6
36110570	4112343	2	4
36150893	1545958	0	0
40054158	19019979	1	1
37202316	28060	5	8
44344798	1119510	0	0
44363312	19019273	2	3
44337657	975125	0	0
45658665	19074679	1	1
44358058	1112807	0	0
44358604	1119510	0	0
45654241	1125315	0	0
45628061	1177480	0	0
45668915	1149380	0	0
45683098	1115171	2	3
45683175	1119510	0	0
45639813	975125	0	0
45704298	1119510	0	0
45786243	1125315	0	0
45802328	1129625	0	0
45780047	1125315	0	0
45792443	967823	0	0
45789650	1125315	0	0
46238989	1125315	0	0
45799194	1119510	0	0
46311222	1595799	0	0
46315550	1153428	0	0
45650699	1174888	0	0
1580772	1332418	0	0
4322976	4314290	7	7
21000701	1539403	0	0
21503962	926487	1	1
4180169	40481087	3	6
36002139	4280726	2	5
36150763	1107830	0	0
40054158	19078461	1	1
37203758	260139	5	8
44344984	1119510	0	0
44349659	1713671	2	3
44337594	975125	0	0
44362721	1125315	0	0
44357764	1112807	0	0
44351293	1119510	0	0
45654064	1125315	0	0
45628287	1177480	0	0
45668910	1115008	0	0
45683100	19133905	2	3
45683514	1119510	0	0
45640120	975125	0	0
45704248	1119510	0	0
45786250	1125315	0	0
45802578	1129625	0	0
45707015	1125315	0	0
45792444	1115008	0	0
45789769	1125315	0	0
46238990	1125315	0	0
45799354	1119510	0	0
46311222	1521369	0	0
46315421	1713332	0	0
45650699	1177480	0	0
1557272	1557272	0	0
4322976	4242997	7	8
21000643	1521369	0	0
21493848	3051031	1	1
4180627	4202451	3	6
36103041	4112343	2	7
36151072	1110410	0	0
40244551	1551099	0	0
37203758	4294548	5	8
44345112	1119510	0	0
44346527	1545959	2	3
44337733	1713332	0	0
44362725	1125315	0	0
44357866	1112807	0	0
44351356	1119510	0	0
45654282	1125315	0	0
45627064	1177480	0	0
45668469	1309944	0	0
45683290	19059056	2	3
45683145	1119510	0	0
45685697	975125	0	0
45704371	1119510	0	0
45782871	1125315	0	0
45802571	1129625	0	0
45707019	1125315	0	0
45792534	1332418	0	0
45789670	1125315	0	0
46238991	1125315	0	0
45799355	1119510	0	0
46311222	1549786	0	0
46315421	1759842	0	0
45650700	1119510	0	0
1580753	1125315	0	0
4322976	4198190	8	11
21000643	19127890	0	0
21500015	1741122	1	1
255919	4283893	4	6
36111047	4112343	2	6
36151189	1539403	0	0
40244557	1119510	0	0
37000000	4056621	5	7
44345009	1119510	0	0
44362983	19019273	2	3
44337624	1589505	0	0
44361802	1125315	0	0
44357911	1112807	0	0
44351269	1119510	0	0
45654628	1125315	0	0
45623936	1177480	0	0
45668709	1137529	0	0
45683328	40223834	2	3
45683253	1119510	0	0
45636695	975125	0	0
45704503	1119510	0	0
45782873	1125315	0	0
45688461	1129625	0	0
45707023	1125315	0	0
45792537	1115008	0	0
45789717	1125315	0	0
46238992	1125315	0	0
45799208	1119510	0	0
46310821	1501700	0	0
46315438	1551099	0	0
45650677	1124300	0	0
1580779	1549786	0	0
4344497	78272	7	7
21000643	1595799	0	0
21502659	1124300	1	1
4042677	4336464	4	6
36102970	4294548	3	7
36151199	1129625	0	0
40244557	1125315	0	0
37203758	255848	5	7
44345027	1119510	0	0
44356885	46233710	2	3
44337624	1549786	0	0
44361857	1125315	0	0
44358104	1112807	0	0
44351401	1119510	0	0
45654189	1125315	0	0
45623456	1177480	0	0
45668709	1149380	0	0
45682997	19019273	2	3
45685595	1119510	0	0
45636723	975125	0	0
45700801	1119510	0	0
45782822	1125315	0	0
45800013	1129625	0	0
45707028	1125315	0	0
45792538	1738521	0	0
45789788	1125315	0	0
46238993	1125315	0	0
45799213	1119510	0	0
46310857	1192710	0	0
46315442	1738521	0	0
45650682	1129625	0	0
1580865	1332418	0	0
4244662	4230399	6	7
21000643	19054876	0	0
21502659	1177480	1	1
4185503	4329847	5	6
36103041	4116491	5	7
36151199	1177480	0	0
40244557	1129625	0	0
37202319	4329847	5	6
44344975	1119510	0	0
44343068	19078461	2	3
44337703	1124300	0	0
44361726	1125315	0	0
44354846	1112807	0	0
44351433	1119510	0	0
45652032	1125315	0	0
45624049	1177480	0	0
45668715	1192710	0	0
45682955	19059056	2	3
45680265	1119510	0	0
45682985	975125	0	0
45700947	1119510	0	0
45782826	1125315	0	0
45800087	1129625	0	0
45706125	1125315	0	0
45792628	791967	0	0
45789836	1125315	0	0
46239295	1125315	0	0
45799405	1119510	0	0
46310872	1501700	0	0
46315842	1112807	0	0
45650772	1551099	0	0
1580866	1332418	0	0
4212577	133834	6	6
21000683	1396131	0	0
21602866	46275444	1	1
4180627	42535580	5	6
36103041	4294548	4	7
36151201	1112807	0	0
40244542	1115008	0	0
37203758	4283893	5	6
44345130	1119510	0	0
44358788	19075601	2	3
44337714	723013	0	0
44361809	1125315	0	0
44351013	1112807	0	0
44351459	1119510	0	0
45652040	1125315	0	0
45623955	1177480	0	0
45668470	1107830	0	0
45683064	19075001	2	3
45680128	1119510	0	0
45633683	975125	0	0
45700775	1119510	0	0
45783011	1125315	0	0
45800208	1129625	0	0
45706100	1125315	0	0
45792503	1115008	0	0
45789840	1125315	0	0
46239125	1125315	0	0
45793962	1119510	0	0
46310880	933724	0	0
46315843	1110410	0	0
45650773	1326303	0	0
1580809	1129625	0	0
4305027	81151	4	5
19128263	19128263	0	0
21500342	1119510	1	1
4086181	378419	5	6
36202157	4109685	4	8
36151207	1112807	0	0
40244587	1125315	0	0
37202316	441267	5	6
44338171	1119510	0	0
44339286	1539411	2	3
44337721	1309944	0	0
44361919	1125315	0	0
44351994	1112807	0	0
44351552	1119510	0	0
45651912	1125315	0	0
45624105	1177480	0	0
45668474	1589505	0	0
45682916	40232448	2	3
45680324	1119510	0	0
45633722	975125	0	0
45701080	1119510	0	0
45783017	1125315	0	0
45685850	1129625	0	0
45706221	1125315	0	0
45792507	975125	0	0
45789681	1125315	0	0
46239310	1125315	0	0
45793965	1119510	0	0
46311263	1729720	0	0
46315754	1326303	0	0
45675348	1589505	0	0
1580755	791967	0	0
4221994	4037675	4	4
19127917	19127918	0	0
21505970	1154615	1	1
138239	4109685	5	6
36202157	4156265	3	8
36151165	1515774	0	0
40244591	1177480	0	0
37503959	4336464	5	6
44338227	1119510	0	0
44356731	40223768	2	3
44337569	975125	0	0
44362021	1125315	0	0
44347543	1112807	0	0
44351794	1119510	0	0
45651895	1125315	0	0
45623877	1177480	0	0
45668858	1551099	0	0
45683356	40232448	2	3
45680090	1119510	0	0
45633769	975125	0	0
45700922	1119510	0	0
45783018	1125315	0	0
45685694	1129625	0	0
45706146	1125315	0	0
45792513	1107830	0	0
45789821	1125315	0	0
46239316	1125315	0	0
45793967	1119510	0	0
46310937	742185	0	0
46315598	1310149	0	0
45675371	1332418	0	0
1580756	1367571	0	0
4300157	4048695	4	4
19127918	19127918	0	0
21604566	19115351	1	1
255919	40481087	5	7
36202157	78272	3	11
36151165	1549786	0	0
40243436	40243436	0	0
36718119	4043241	5	6
44338133	1119510	0	0
44350323	40223768	2	3
44337573	1361711	0	0
44362207	1125315	0	0
44347360	1112807	0	0
44351658	1119510	0	0
45651906	1125315	0	0
45668005	1177480	0	0
45668875	1000560	0	0
45679880	40174880	2	3
45680295	1119510	0	0
45633933	975125	0	0
45701056	1119510	0	0
45783033	1125315	0	0
45685868	1129625	0	0
45706165	1125315	0	0
45792172	1192710	0	0
45789893	1125315	0	0
46239298	1125315	0	0
45793984	1119510	0	0
46311134	1551099	0	0
46315602	975125	0	0
45675380	1115008	0	0
1580762	1177480	0	0
4300157	4059173	4	4
19127921	19127922	0	0
21604795	40223774	1	1
4086181	375671	5	7
36202157	81151	3	10
36151170	1778162	0	0
40244494	933724	0	0
37202319	313217	6	7
44338098	1119510	0	0
44356764	19073183	2	3
44337632	1118084	0	0
44362171	1125315	0	0
44343880	1112807	0	0
44351564	1119510	0	0
45652125	1125315	0	0
45667896	1177480	0	0
45668842	1149196	0	0
45679602	40174880	2	3
45680306	1119510	0	0
45630809	975125	0	0
45701347	1119510	0	0
45783154	1125315	0	0
45685299	1129625	0	0
45706174	1125315	0	0
45792175	933724	0	0
45789969	1125315	0	0
46239302	1125315	0	0
45793777	1119510	0	0
46311179	975125	0	0
46315986	1738521	0	0
45675449	914335	0	0
1580850	1713332	0	0
4300157	40479768	4	4
19127921	19133679	0	0
21504611	40171902	1	1
135930	40480160	4	7
36202157	40479422	5	10
36151177	1107830	0	0
40244509	705944	0	0
36702253	4132546	6	8
44362849	1119510	0	0
44364338	1107882	2	3
44337722	1500211	0	0
44362062	1125315	0	0
45620278	1112807	0	0
44351822	1119510	0	0
45652244	1125315	0	0
45668008	1177480	0	0
45668888	1153428	0	0
45679927	19019273	2	3
45680326	1119510	0	0
45630918	975125	0	0
45701064	1119510	0	0
45783157	1125315	0	0
45799837	1129625	0	0
45706176	1125315	0	0
45792690	1112807	0	0
45789695	1125315	0	0
46239303	1125315	0	0
45794038	1119510	0	0
46311368	975125	0	0
46315999	1112807	0	0
45675309	1307863	0	0
1580773	967823	0	0
4223759	4048171	4	4
19127921	19129144	0	0
21010499	40171902	1	1
4309188	81893	3	8
36200000	4113008	4	8
36151296	1153428	0	0
40244527	753626	0	0
36702247	378419	6	8
44362864	1119510	0	0
44339251	1545959	2	3
44337592	920293	0	0
44362064	1125315	0	0
45620238	1112807	0	0
44351825	1119510	0	0
45652245	1125315	0	0
45668365	1177480	0	0
45668889	920293	0	0
45682301	1154615	2	3
45680471	1119510	0	0
45627868	975125	0	0
45700871	1119510	0	0
45782891	1125315	0	0
45797351	1129625	0	0
45706265	1125315	0	0
45792695	1746114	0	0
45789166	1125315	0	0
46239209	1125315	0	0
45794048	1119510	0	0
46311375	975125	0	0
46310172	1153428	0	0
45675329	1149196	0	0
1580890	920293	0	0
4224260	4048171	4	4
19127922	19127922	0	0
21504609	1332418	1	1
4047779	4280726	4	8
36200000	4218389	4	8
36151300	1153428	0	0
40244529	1115008	0	0
36718338	4043241	6	8
44362865	1119510	0	0
44346613	1107882	2	3
45622170	1501700	0	0
44362068	1125315	0	0
45620557	1112807	0	0
44343804	1119510	0	0
45650982	1125315	0	0
45665914	1177480	0	0
45668894	975125	0	0
45682308	19008572	2	3
45680475	1119510	0	0
45676363	975125	0	0
45700784	1119510	0	0
45782999	1125315	0	0
45797431	1129625	0	0
45706323	1125315	0	0
45792695	1741122	0	0
45789167	1125315	0	0
46239012	1125315	0	0
45794130	1119510	0	0
46311338	1154343	0	0
46310187	1322184	0	0
45675392	1396131	0	0
1580850	1759842	0	0
4309188	4310024	4	4
19128008	19128009	0	0
21013671	40171902	1	1
255919	4294548	5	8
36200000	40480160	4	10
36150941	1332418	0	0
40244531	1125315	0	0
37502353	4057420	6	9
44362903	1119510	0	0
44363289	1107882	2	3
45622043	19127890	0	0
45655989	1125315	0	0
45620497	1112807	0	0
44343889	1119510	0	0
45650889	1125315	0	0
45665918	1177480	0	0
45668843	1713332	0	0
45682315	19133768	2	3
45680627	1119510	0	0
45676255	975125	0	0
45700834	1119510	0	0
45783066	1125315	0	0
45682402	1129625	0	0
45706559	1125315	0	0
45792651	738818	0	0
45789170	1125315	0	0
46239013	1125315	0	0
45793882	1119510	0	0
46311297	1332418	0	0
46310132	975125	0	0
45675358	1177480	0	0
1580932	1112807	0	0
4303236	4336464	4	4
19128009	19128009	0	0
21013692	19074679	1	1
4180169	4048171	5	8
36200000	4146173	4	10
36150942	1129625	0	0
40244535	1154029	0	0
37002287	45769019	6	6
44362820	1119510	0	0
44363093	1107882	2	3
45622043	1589505	0	0
45655996	1125315	0	0
44362325	1112807	0	0
44344163	1119510	0	0
45650931	1125315	0	0
45665762	1177480	0	0
45668845	1115008	0	0
45682405	19078461	2	3
45680373	1119510	0	0
45670282	975125	0	0
45697940	1119510	0	0
45783130	1125315	0	0
45794835	1129625	0	0
45706561	1125315	0	0
45792652	1115008	0	0
45789229	1125315	0	0
46239014	1125315	0	0
45794035	1119510	0	0
46311308	1124300	0	0
46309612	1124957	0	0
45675330	1112807	0	0
1580935	1501700	0	0
4227253	317576	4	4
19128021	19128263	0	0
21501117	1759842	3	3
21604180	40223774	5	5
36200000	78272	4	12
36150943	1177480	0	0
40244608	1548195	0	0
37600000	313217	7	8
44362932	1119510	0	0
44356961	1107882	2	3
45622043	1549786	0	0
45655792	1125315	0	0
44362188	1112807	0	0
44344011	1119510	0	0
45650954	1125315	0	0
45666013	1177480	0	0
45668946	1307863	0	0
45682430	19079524	2	3
45680353	1119510	0	0
45670716	975125	0	0
45697921	1119510	0	0
45783131	1125315	0	0
45794909	1129625	0	0
45706192	1125315	0	0
45792458	1115008	0	0
45789260	1125315	0	0
46239019	1125315	0	0
45794106	1119510	0	0
46311239	1124957	0	0
46309613	975125	0	0
45675331	1545958	0	0
1177480	1177480	0	0
4305027	4109685	4	4
19128021	19128022	0	0
21502584	19074679	3	3
21604180	19115351	5	5
36200000	4278672	3	10
36151179	1129625	0	0
40244593	1177480	0	0
36718588	4043241	7	8
44363126	1119510	0	0
44348184	1107882	2	3
45622228	715997	0	0
45655832	1125315	0	0
44362475	1112807	0	0
44344122	1119510	0	0
45650894	1125315	0	0
45666247	1177480	0	0
45668554	1149196	0	0
45706925	19078461	2	3
45680634	1119510	0	0
45670481	975125	0	0
45698022	1119510	0	0
45783110	1125315	0	0
45679334	1129625	0	0
45706197	1125315	0	0
45792676	1149196	0	0
45787032	1125315	0	0
46239020	1125315	0	0
45794108	1119510	0	0
46311579	1729720	0	0
46309616	1000560	0	0
45675332	1119510	0	0
1192710	1192710	0	0
4305027	4059173	4	4
19128022	19128022	0	0
21500001	1759842	3	3
35202457	4310024	5	5
36200000	4066995	3	10
36151187	1545958	0	0
40244611	1149196	0	0
36703500	4043241	7	9
44362548	1119510	0	0
44349397	19078461	2	3
45621903	1110410	0	0
45655844	1125315	0	0
44362665	1112807	0	0
44344070	1119510	0	0
45651124	1125315	0	0
45663767	1177480	0	0
45668557	1192710	0	0
45670484	19078461	2	3
45680690	1119510	0	0
45670697	975125	0	0
45698023	1119510	0	0
45783111	1125315	0	0
45679267	1129625	0	0
45706305	1125315	0	0
45792467	1326303	0	0
45786988	1125315	0	0
46239026	1125315	0	0
45793946	1119510	0	0
46311590	1107830	0	0
46309617	1112807	0	0
45675333	1115008	0	0
791967	791967	0	0
4326426	4337611	4	4
19128050	19128065	0	0
21500001	1741122	3	3
35305792	4144583	5	5
36200000	4155034	5	8
36151334	1177480	0	0
40244682	1112807	0	0
37502353	4198190	8	10
44362770	1119510	0	0
44354055	1107882	2	3
45622021	1738521	0	0
45655911	1125315	0	0
44362381	1112807	0	0
44344388	1119510	0	0
45651131	1125315	0	0
45663502	1177480	0	0
45668645	1778162	0	0
45624800	40228214	2	3
45680694	1119510	0	0
45670700	975125	0	0
45697994	1119510	0	0
45783315	1125315	0	0
45679186	1129625	0	0
45700701	1125315	0	0
45789500	1192710	0	0
45787098	1125315	0	0
46239028	1125315	0	0
45794200	1119510	0	0
46311594	738818	0	0
46309618	1153428	0	0
45675339	791967	0	0
920293	920293	0	0
4304358	4181917	4	4
19128065	19128065	0	0
21500001	1713332	3	3
35302074	378419	5	5
36111047	4116491	4	6
36151340	1115008	0	0
40244683	1112807	0	0
36702253	380378	7	7
44362767	1119510	0	0
44341340	19078461	2	3
45622028	1149196	0	0
45656029	1125315	0	0
44354903	1112807	0	0
44344140	1119510	0	0
45651102	1125315	0	0
45663446	1177480	0	0
45668652	1115008	0	0
45691579	19079524	2	3
45676701	1119510	0	0
45670361	975125	0	0
45698008	1119510	0	0
45783230	1125315	0	0
45679282	1129625	0	0
45700634	1125315	0	0
45789525	1545958	0	0
45786990	1125315	0	0
46239029	1125315	0	0
45794202	1119510	0	0
46306988	1738521	0	0
46309622	1174888	0	0
45675463	1192710	0	0
433125	433125	0	0
4240345	4010253	4	4
19127890	19127890	0	0
21500001	1746114	3	3
35306088	4043241	5	5
36111047	4294548	3	6
36150886	1115008	0	0
40244685	1129625	0	0
36702253	378001	8	10
44362782	1119510	0	0
44352310	19075601	2	3
45622002	1539403	0	0
45656064	1125315	0	0
44355049	1112807	0	0
44344145	1119510	0	0
45651067	1125315	0	0
45663871	1177480	0	0
45668658	740275	0	0
45706950	19078461	2	3
45679455	1119510	0	0
45669178	975125	0	0
45698170	1119510	0	0
45783034	1125315	0	0
45792259	1129625	0	0
45700628	1125315	0	0
45789590	1551099	0	0
45787039	1125315	0	0
46239234	1125315	0	0
45794265	1119510	0	0
46305633	723013	0	0
46309821	1112807	0	0
45675345	1551099	0	0
433644	433644	0	0
4240345	4037675	4	4
21505985	1112807	0	0
21500001	1729720	3	3
35204998	313217	4	5
36110538	4116491	4	6
36150947	1112807	0	0
40244686	1125315	0	0
37203758	40481087	6	7
44362620	1119510	0	0
44350206	1332419	2	3
45621905	1149196	0	0
45656066	1125315	0	0
44355015	1112807	0	0
44343934	1119510	0	0
45651109	1125315	0	0
45660236	1177480	0	0
45668661	1551099	0	0
45630832	40228214	2	3
45677145	1119510	0	0
45669185	975125	0	0
45698189	1119510	0	0
45783458	1125315	0	0
45792249	1129625	0	0
45699774	1125315	0	0
45789563	1332418	0	0
45787052	1125315	0	0
46239270	1125315	0	0
45794219	1119510	0	0
46305589	1149196	0	0
46310029	701322	0	0
45675347	967823	0	0
313217	313217	0	0
4304110	4304110	0	0
21505985	1125315	0	0
21500001	1728416	3	3
21603891	19007333	4	5
36110538	4112343	3	6
36150778	1000560	0	0
40244644	1125315	0	0
37200000	4329847	6	7
44362621	1119510	0	0
44364302	40228214	2	3
45622214	738818	0	0
45656069	1125315	0	0
45655325	1112807	0	0
44344326	1119510	0	0
45647850	1125315	0	0
45660357	1177480	0	0
45668667	1343916	0	0
45685752	19075601	2	3
45677188	1119510	0	0
45666632	975125	0	0
45698205	1119510	0	0
45783141	1125315	0	0
45792480	1129625	0	0
45699781	1125315	0	0
45789627	1112807	0	0
45787132	1125315	0	0
46239413	1125315	0	0
45789336	1119510	0	0
46305694	1305058	0	0
46310038	1192710	0	0
45675399	1129625	0	0
1545959	1545959	0	0
21000967	708298	0	0
21505988	1332418	0	0
21500001	1717327	3	3
21603445	40229134	4	5
36110538	4294548	3	6
36151315	933724	0	0
40244678	1129625	0	0
37200000	317576	6	6
44359397	1119510	0	0
44356668	1332419	2	3
45622089	975125	0	0
45656195	1125315	0	0
44348065	1112807	0	0
44344418	1119510	0	0
45647918	1125315	0	0
45660451	1177480	0	0
45668850	740275	0	0
45658330	19079524	2	3
45677194	1119510	0	0
45666847	975125	0	0
45698214	1119510	0	0
45783081	1125315	0	0
45792098	1129625	0	0
45699783	1125315	0	0
45789628	1367571	0	0
45787133	1125315	0	0
46239414	1125315	0	0
45789341	1119510	0	0
46305986	1174888	0	0
46310041	1112807	0	0
45675348	1549786	0	0
443279	443279	0	0
21000967	723013	0	0
21505901	1125315	0	0
21503967	1174888	3	3
21603445	40232448	4	5
36103041	4056621	4	6
36151348	1129625	0	0
40244678	1125315	0	0
37200000	4048171	5	11
44359451	1119510	0	0
44349678	1332419	2	3
45622216	1310149	0	0
45656405	1125315	0	0
44341412	1112807	0	0
44337475	1119510	0	0
45647927	1125315	0	0
45660453	1177480	0	0
45668732	1738521	0	0
45630905	1539411	2	3
45677209	1119510	0	0
45667001	975125	0	0
45695087	1119510	0	0
45782945	1125315	0	0
45676149	1129625	0	0
45699785	1125315	0	0
45789532	1154343	0	0
45787136	1125315	0	0
46239143	1125315	0	0
45789358	1119510	0	0
46322654	1545958	0	0
46311973	1149196	0	0
45675321	1107830	0	0
375671	375671	0	0
21000967	791967	0	0
21506025	914335	0	0
21503967	1102527	3	3
21604254	35605858	4	5
36102970	4056621	4	6
36151354	1149380	0	0
40244623	1125315	0	0
37503992	4242997	6	7
44359630	1119510	0	0
44364123	19073183	2	3
45622177	1192710	0	0
45655921	1125315	0	0
44341364	1112807	0	0
44338021	1119510	0	0
45648042	1125315	0	0
45660583	1177480	0	0
45668733	1154343	0	0
45686206	1539411	2	3
45677336	1119510	0	0
45667088	975125	0	0
45694787	1119510	0	0
45783143	1125315	0	0
45791951	1129625	0	0
45699912	1125315	0	0
45789610	1000560	0	0
45787104	1125315	0	0
46239145	1125315	0	0
45788750	1119510	0	0
46322659	791967	0	0
46311989	1501700	0	0
45675364	1549786	0	0
4001336	4001336	0	0
21000970	723013	0	0
21506026	914335	0	0
21503967	1177480	3	3
21604254	40231925	4	5
35702767	440448	5	6
36151342	1177480	0	0
40244595	1177480	0	0
37503992	4163971	3	8
44359547	1119510	0	0
44364123	19073188	2	3
45622184	1545958	0	0
45656305	1125315	0	0
44340942	1112807	0	0
44337612	1119510	0	0
45648044	1125315	0	0
45660594	1177480	0	0
45668735	1149196	0	0
45694635	1539411	2	3
45677299	1119510	0	0
45780958	975125	0	0
45695104	1119510	0	0
45783205	1125315	0	0
45789490	1129625	0	0
45699817	1125315	0	0
45789620	1112807	0	0
45787086	1125315	0	0
46239146	1125315	0	0
45788732	1119510	0	0
46322081	1501700	0	0
46311899	1107830	0	0
45675364	19127890	0	0
1766573	1307863	0	0
21000247	1728416	0	0
21506003	1177480	0	0
21503967	1124957	3	3
21603395	40162522	4	5
36202157	4299128	6	6
36151074	1545958	0	0
40244716	1153428	0	0
37503992	4293740	3	3
44359512	1119510	0	0
44339476	19078461	2	3
45622194	1589505	0	0
45656307	1125315	0	0
44341040	1112807	0	0
44337526	1119510	0	0
45648133	1125315	0	0
45660411	1177480	0	0
45668736	1149196	0	0
45630908	19079524	2	3
45677249	1119510	0	0
45706948	975125	0	0
45694915	1119510	0	0
45783425	1125315	0	0
45786511	1129625	0	0
45699818	1125315	0	0
45789622	1729720	0	0
45787139	1125315	0	0
46239156	1125315	0	0
45788822	1119510	0	0
46322692	791967	0	0
46311888	1548195	0	0
45675364	1512674	0	0
1766432	1119510	0	0
21000244	1778162	0	0
21506003	1129625	0	0
21500363	1343916	3	3
21603395	19133768	4	5
36102898	4294548	6	6
36151320	1746114	0	0
40244700	1551099	0	0
37503992	4301346	5	6
44359761	1119510	0	0
44342875	19075601	2	3
45622194	1549786	0	0
45656310	1125315	0	0
44340954	1112807	0	0
44337655	1119510	0	0
45647969	1125315	0	0
45660643	1177480	0	0
45668747	1309944	0	0
45701069	40228214	2	3
45674056	1119510	0	0
45706984	975125	0	0
45695066	1119510	0	0
45783435	1125315	0	0
45786431	1129625	0	0
45699734	1125315	0	0
45789724	1322184	0	0
45787215	1125315	0	0
46239158	1125315	0	0
45788906	1119510	0	0
46322111	1310149	0	0
46312075	701322	0	0
45675470	1778162	0	0
1766436	1343916	0	0
21000290	1738521	0	0
21506003	1115008	0	0
21500363	40169281	3	3
21603395	40229134	4	5
35802131	4218389	5	6
36151320	1741122	0	0
40244684	1125315	0	0
37503992	4337138	4	5
44359700	1119510	0	0
44357095	19075601	2	3
44358795	1545958	0	0
45656215	1125315	0	0
45621793	1112807	0	0
44337713	1119510	0	0
45648148	1125315	0	0
45658434	1177480	0	0
45668748	742185	0	0
45683466	1332419	2	3
45674226	1119510	0	0
45707256	975125	0	0
45645802	1119510	0	0
45783439	1125315	0	0
45785259	1129625	0	0
45699843	1125315	0	0
45789738	1102527	0	0
45787166	1125315	0	0
46239426	1125315	0	0
45788911	1119510	0	0
46322119	1332418	0	0
46312002	1124957	0	0
45675564	1741122	0	0
1759842	1759842	0	0
21000290	1713332	0	0
21506037	1308738	0	0
21502569	1551099	3	3
21604254	40165015	2	5
35802841	4084167	4	5
36151321	1129625	0	0
40244679	1129625	0	0
37500000	4108705	4	8
44355619	1119510	0	0
44356247	1539411	2	3
44358545	1124300	0	0
45652626	1125315	0	0
45620570	1112807	0	0
44337719	1119510	0	0
45648224	1125315	0	0
45658352	1177480	0	0
45668821	1107830	0	0
45645804	40228214	2	3
45673981	1119510	0	0
45707104	975125	0	0
45691530	1119510	0	0
45783258	1125315	0	0
45785436	1129625	0	0
45699853	1125315	0	0
45789631	1112807	0	0
45787167	1125315	0	0
46239160	1125315	0	0
45788929	1119510	0	0
46322125	975125	0	0
46312074	1539403	0	0
45675564	1746114	0	0
1343916	1343916	0	0
21000289	1738521	0	0
21506081	1501700	0	0
21502569	975125	3	3
21603445	40223821	2	5
36110015	4116491	5	5
36151322	914335	0	0
40244680	1125315	0	0
37500000	4337611	4	8
44356063	1119510	0	0
44353962	40228214	2	3
44358650	1589505	0	0
45652690	1125315	0	0
45661699	1112807	0	0
45622045	1119510	0	0
45648232	1125315	0	0
45657582	1177480	0	0
45668831	1154343	0	0
45636945	19078461	2	3
45673779	1119510	0	0
45707109	975125	0	0
45691682	1119510	0	0
45783207	1125315	0	0
45785371	1129625	0	0
45700059	1125315	0	0
45789828	1174888	0	0
45787172	1125315	0	0
46239159	1125315	0	0
45789016	1119510	0	0
46322127	1149196	0	0
46312015	791967	0	0
45675416	1112807	0	0
1000560	1000560	0	0
21000285	1738521	0	0
21506064	1192710	0	0
21502571	19128263	3	3
21603445	40223834	2	5
36111047	433125	5	5
36151326	738818	0	0
40244681	1125315	0	0
37500000	4035793	4	6
44355795	1119510	0	0
44349402	19075601	2	3
44358650	1549786	0	0
45652664	1125315	0	0
45661564	1112807	0	0
45622214	1119510	0	0
45648272	1125315	0	0
45657655	1177480	0	0
45668880	1192710	0	0
45695049	1332419	2	3
45674362	1119510	0	0
45707088	975125	0	0
45691967	1119510	0	0
45783304	1125315	0	0
45785535	1129625	0	0
45700061	1125315	0	0
45789830	967823	0	0
45787333	1125315	0	0
45894584	1125315	0	0
45788868	1119510	0	0
46322581	1174888	0	0
46312021	1501700	0	0
45675497	1192710	0	0
782047	782047	0	0
21000267	1778162	0	0
21505823	1125315	0	0
21502571	19128022	3	3
21603445	19125062	2	5
36111047	198199	5	5
36151083	1107830	0	0
40244648	1124300	0	0
37500000	4197460	4	6
44355653	1119510	0	0
44358904	19075601	2	3
44358654	1713332	0	0
45652667	1125315	0	0
45662009	1112807	0	0
45658585	1119510	0	0
45648273	1125315	0	0
45657943	1177480	0	0
45668880	738818	0	0
45694959	40228214	2	3
45674370	1119510	0	0
45707099	975125	0	0
45691969	1119510	0	0
45783306	1125315	0	0
45785424	1129625	0	0
45693369	1125315	0	0
45789763	1729720	0	0
45787335	1125315	0	0
45894376	1125315	0	0
45788869	1119510	0	0
46322586	1738521	0	0
46312035	975125	0	0
45675502	975125	0	0
441267	441267	0	0
21000289	1728416	0	0
21505824	1125315	0	0
21502571	19128009	3	3
21603445	1150771	2	5
36111047	28060	5	5
36151085	1177480	0	0
40244725	1177480	0	0
37500000	4337138	3	7
44355945	1119510	0	0
44354091	19075601	2	3
44358676	1124957	0	0
45652749	1125315	0	0
45662011	1112807	0	0
45658699	1119510	0	0
45648286	1125315	0	0
45654222	1177480	0	0
45668884	1192710	0	0
45701165	19079524	2	3
45674045	1119510	0	0
45706511	975125	0	0
45691884	1119510	0	0
45783333	1125315	0	0
45785378	1129625	0	0
45693380	1125315	0	0
45789634	1174888	0	0
45787325	1125315	0	0
45894378	1125315	0	0
46296637	1119510	0	0
46322608	738818	0	0
46312263	975125	0	0
45675524	1177480	0	0
80809	80809	0	0
21000289	1778162	0	0
21505824	1119510	0	0
21502571	40221415	3	3
21603445	1150837	2	5
36111047	40481087	4	5
36151209	1000560	0	0
40244594	1177480	0	0
37500000	4330583	3	11
44356190	1119510	0	0
44342756	19075601	2	3
44358767	1717327	0	0
45652751	1125315	0	0
45661915	1112807	0	0
45658796	1119510	0	0
45648156	1125315	0	0
45654332	1177480	0	0
45668952	1305058	0	0
45670605	40228214	2	3
45674052	1119510	0	0
45704274	975125	0	0
45692039	1119510	0	0
45782953	1125315	0	0
45785386	1129625	0	0
45693523	1125315	0	0
45789635	1153428	0	0
45787415	1125315	0	0
45894620	1125315	0	0
46296499	1119510	0	0
46316495	738818	0	0
46312267	1153428	0	0
45675324	1177480	0	0
133834	133834	0	0
21000050	1738521	0	0
21505836	1125315	0	0
21502571	42902245	3	3
21603445	40228230	2	5
36111047	4056621	3	5
36151215	1129625	0	0
40244747	1125315	0	0
37500000	4198190	3	11
44356221	1119510	0	0
44339437	19078461	2	3
44358768	1545958	0	0
45652444	1125315	0	0
45661921	1112807	0	0
45658469	1119510	0	0
45648290	1125315	0	0
45654276	1177480	0	0
45670389	1501700	0	0
45642829	19075601	2	3
45674194	1119510	0	0
45704306	975125	0	0
45691805	1119510	0	0
45780566	1125315	0	0
45783421	1129625	0	0
45693338	1125315	0	0
45789650	738818	0	0
45787194	1125315	0	0
45894661	1125315	0	0
46295018	1119510	0	0
46316509	1332418	0	0
46310341	1174888	0	0
45675434	1738521	0	0
81893	81893	0	0
21000051	1728416	0	0
21505836	1119510	0	0
21502571	19128065	3	3
21603445	1107882	2	5
36110538	4056621	3	5
36151220	1107830	0	0
40244878	791967	0	0
37500000	4323902	3	9
44356044	1119510	0	0
44346843	19078461	2	3
45658524	791967	0	0
45652568	1125315	0	0
45658259	1112807	0	0
45658656	1119510	0	0
45648092	1125315	0	0
45654403	1177480	0	0
45670397	1124300	0	0
45688833	19079524	2	3
45673724	1119510	0	0
45704467	975125	0	0
45688807	1119510	0	0
45780553	1125315	0	0
45783330	1129625	0	0
45693340	1125315	0	0
45789651	933724	0	0
45785502	1125315	0	0
45894431	1125315	0	0
46295088	1119510	0	0
46316510	1310149	0	0
46310251	1154343	0	0
45675525	1307863	0	0
3014576	3014576	0	0
21000051	1717327	0	0
21505839	1125315	0	0
21502571	19127904	3	3
21603445	43012036	2	5
36110538	40481087	4	5
36151222	738818	0	0
40772948	3012494	5	5
37500000	4216130	3	3
44356009	1119510	0	0
44364013	1539411	2	3
45658529	1110410	0	0
45652581	1125315	0	0
45655669	1112807	0	0
45658474	1119510	0	0
45644789	1125315	0	0
45654440	1177480	0	0
45666456	1557272	0	0
45645792	40228214	2	3
45673913	1119510	0	0
45704497	975125	0	0
45688792	1119510	0	0
45780445	1125315	0	0
45783467	1129625	0	0
45693532	1125315	0	0
45789656	975125	0	0
45785602	1125315	0	0
45894436	1125315	0	0
46295196	1119510	0	0
46316513	1149196	0	0
46310263	1174888	0	0
45675532	1153428	0	0
3014599	3014599	0	0
21000051	1738521	0	0
21505840	1125315	0	0
21502571	19127918	3	3
21603041	920334	2	5
36110538	198199	5	5
36151232	1177480	0	0
40772948	3000876	5	5
37500000	4238715	3	3
44356021	1119510	0	0
44349572	40228214	2	3
45658649	1759842	0	0
45652639	1125315	0	0
45655766	1112807	0	0
45658592	1119510	0	0
45644783	1125315	0	0
45654355	1177480	0	0
45666541	1149196	0	0
45700959	19079524	2	3
45674303	1119510	0	0
45701024	975125	0	0
45688927	1119510	0	0
45780659	1125315	0	0
45783523	1129625	0	0
45693571	1125315	0	0
45789647	1778162	0	0
45785603	1125315	0	0
45894438	1125315	0	0
46295537	1119510	0	0
46317368	1326303	0	0
46310309	1174888	0	0
45675646	1177480	0	0
3026361	3026361	0	0
21000052	1738521	0	0
21505843	1112807	0	0
21500269	1308738	3	3
35202457	4329847	3	5
36110538	433125	5	5
36151236	1332418	0	0
40772948	3020655	5	5
37500000	4043071	5	7
44356143	1119510	0	0
44349646	40228214	2	3
45658649	1713332	0	0
45655036	1125315	0	0
45655735	1112807	0	0
45658610	1119510	0	0
45644997	1125315	0	0
45654457	1177480	0	0
45666516	1174888	0	0
45695077	40228214	2	3
45671338	1119510	0	0
45701012	975125	0	0
45689009	1119510	0	0
46244963	1125315	0	0
46291453	1129625	0	0
45693539	1125315	0	0
45789665	1107830	0	0
45785604	1125315	0	0
45894666	1125315	0	0
46295439	1119510	0	0
46317204	1738521	0	0
46310321	1310149	0	0
45675419	1149196	0	0
3027231	3027231	0	0
21000052	1717327	0	0
21505803	1125315	0	0
21604146	1557272	3	3
35202457	317576	3	5
36110538	28060	5	5
36151242	738818	0	0
40772948	3005136	5	5
37500000	4202451	5	5
44356162	1119510	0	0
44346142	40228214	2	3
45658652	1153428	0	0
45655041	1125315	0	0
44348267	1112807	0	0
45658951	1119510	0	0
45644847	1125315	0	0
45654487	1177480	0	0
45666494	1149196	0	0
45633789	19079524	2	3
45671165	1119510	0	0
45698072	975125	0	0
45688980	1119510	0	0
46244687	1125315	0	0
46291709	1129625	0	0
45693543	1125315	0	0
45789666	1107830	0	0
45785682	1125315	0	0
45894728	1125315	0	0
46295624	1119510	0	0
46318002	1149196	0	0
46310447	1746114	0	0
45675476	1124300	0	0
3015632	3015632	0	0
21000052	1728416	0	0
21505804	1112807	0	0
21500284	1153428	3	3
35300000	378419	6	6
35802133	4066995	4	4
36151246	1177480	0	0
40772948	3001247	5	5
37500000	4323208	5	5
44352659	1119510	0	0
44350426	40228214	2	3
45658396	1124957	0	0
45655043	1125315	0	0
44778042	1129625	0	0
45652416	1119510	0	0
45644788	1125315	0	0
45654519	1177480	0	0
45666486	1332418	0	0
45648609	19078461	2	3
45671167	1119510	0	0
45695040	975125	0	0
45689129	1119510	0	0
46244949	1125315	0	0
46291780	1129625	0	0
45693494	1125315	0	0
45789670	1174888	0	0
45785508	1125315	0	0
45893552	1125315	0	0
46295243	1119510	0	0
46317189	975125	0	0
46310447	1741122	0	0
45675482	1177480	0	0
3019406	3019406	0	0
21000054	1728416	0	0
21505805	1112807	0	0
21500284	1129625	3	3
35302548	4144583	6	6
35702118	4027663	4	4
36151249	1115008	0	0
40772948	3027231	5	5
37500000	4057420	5	10
44352665	1119510	0	0
44346661	40228214	2	3
45658451	1551099	0	0
45655057	1125315	0	0
44778286	1129625	0	0
45652468	1119510	0	0
45644895	1125315	0	0
45651952	1177480	0	0
45666544	1557272	0	0
45778449	19078461	2	3
45671242	1119510	0	0
45695021	975125	0	0
45688959	1119510	0	0
45777674	1125315	0	0
46291888	1129625	0	0
45693427	1125315	0	0
45789782	1326303	0	0
45785745	1125315	0	0
45893544	1125315	0	0
46295245	1119510	0	0
46317192	1174888	0	0
46310430	1192710	0	0
45675508	1110410	0	0
3027970	3027970	0	0
21000054	1717327	0	0
21505807	1125315	0	0
21500284	1149196	3	3
35302568	4043241	6	6
36110015	433125	4	4
36151251	914335	0	0
40779555	3049273	5	5
42888892	134438	2	2
44353334	1119510	0	0
44363054	40228214	2	3
45658544	791967	0	0
45655170	1125315	0	0
44778240	1129625	0	0
45652480	1119510	0	0
45644912	1125315	0	0
45651890	1177480	0	0
45666556	1174888	0	0
45685974	19078461	2	3
45671350	1119510	0	0
45695096	975125	0	0
45685763	1119510	0	0
45777770	1125315	0	0
46295775	1129625	0	0
45693733	1125315	0	0
45789673	1501700	0	0
45785569	1125315	0	0
45893547	1125315	0	0
46295351	1119510	0	0
46317882	1174888	0	0
46310433	1000560	0	0
45675445	1119510	0	0
3004501	3004501	0	0
21000053	1728416	0	0
21505808	1115008	0	0
21500284	1150770	3	3
21602359	19128065	6	6
36110015	28060	4	4
36151359	1589505	0	0
37503862	4301346	5	5
43021227	4084167	2	2
44352858	1119510	0	0
44354096	40228214	2	3
45658680	1501700	0	0
45655260	1125315	0	0
44359143	1129625	0	0
45652343	1119510	0	0
45644922	1125315	0	0
45651034	1177480	0	0
45666556	1192710	0	0
45688664	19078461	2	3
45671356	1119510	0	0
45691870	975125	0	0
45685769	1119510	0	0
45777774	1125315	0	0
46244995	1129625	0	0
45693716	1125315	0	0
45789706	1307863	0	0
45785523	1125315	0	0
45893582	1125315	0	0
46295637	1119510	0	0
46317932	967823	0	0
46310383	1549786	0	0
45675445	1192710	0	0
3011505	3011505	0	0
21000057	1738521	0	0
21505808	1177480	0	0
21500284	738818	3	3
21602751	40174880	5	6
36150696	19127922	3	4
36151362	19003953	0	0
37503862	44783196	5	5
43053691	4048695	2	2
44352826	1119510	0	0
44350313	40223768	2	3
45658694	1107830	0	0
45655346	1125315	0	0
44358860	1129625	0	0
45652123	1119510	0	0
45645012	1125315	0	0
45650927	1177480	0	0
45666579	1551099	0	0
45682819	19078461	2	3
45671279	1119510	0	0
45691887	975125	0	0
45686181	1119510	0	0
45778228	1125315	0	0
46242645	1129625	0	0
45693608	1125315	0	0
45789720	1713332	0	0
45785856	1125315	0	0
45893556	1125315	0	0
46244353	1119510	0	0
46317623	1501700	0	0
46310383	19127890	0	0
45675484	1119510	0	0
3016723	3016723	0	0
21000058	1728416	0	0
21505809	1125315	0	0
21500284	1150836	3	3
21604069	42707627	5	6
36157979	1153428	0	0
36150969	1177480	0	0
40792792	3005136	5	5
42804267	40163554	2	3
44352868	1119510	0	0
44350602	19078461	2	3
45658665	740275	0	0
45652854	1125315	0	0
44358570	1129625	0	0
45652544	1119510	0	0
45645014	1125315	0	0
45651063	1177480	0	0
45666517	1326303	0	0
45633767	19078461	2	3
45671228	1119510	0	0
45692009	975125	0	0
45686191	1119510	0	0
45778232	1125315	0	0
46242724	1129625	0	0
45693616	1125315	0	0
45789786	967823	0	0
45785628	1125315	0	0
45893562	1125315	0	0
46244325	1119510	0	0
46317635	1115008	0	0
46310387	1112807	0	0
45675484	738818	0	0
3006734	3006734	0	0
21000056	1738521	0	0
21505811	1125315	0	0
21500284	1192710	3	3
21603890	19007333	5	6
36158036	1149196	0	0
36151106	975125	0	0
40228214	40228214	0	0
42806735	40162522	2	3
44352878	1119510	0	0
44364016	19078461	2	3
45658699	738818	0	0
45652855	1125315	0	0
44358518	1129625	0	0
45652726	1119510	0	0
45644884	1125315	0	0
45651101	1177480	0	0
45666599	1115008	0	0
45683024	19078461	2	3
45671444	1119510	0	0
45688883	975125	0	0
45685933	1119510	0	0
45778069	1125315	0	0
46242759	1129625	0	0
45693588	1125315	0	0
45789834	1713332	0	0
45785608	1125315	0	0
45801384	1125315	0	0
46244331	1119510	0	0
46317653	1326303	0	0
46310354	740275	0	0
45675430	1322184	0	0
3028833	3028833	0	0
21000056	1728416	0	0
21505812	1125315	0	0
21505746	1112807	3	3
21604253	35605858	5	6
36158153	1000560	0	0
36151258	1177480	0	0
40223768	40223768	0	0
42806972	1154615	2	3
44352879	1119510	0	0
44342390	19078461	2	3
45658702	740275	0	0
45652781	1125315	0	0
44351493	1129625	0	0
45652222	1119510	0	0
45644966	1125315	0	0
45651225	1177480	0	0
45666602	1501700	0	0
45682734	19078461	2	3
45669852	1119510	0	0
45688855	975125	0	0
45688607	1119510	0	0
45778126	1125315	0	0
46242651	1129625	0	0
45693599	1125315	0	0
45789834	1759842	0	0
45785639	1125315	0	0
45801411	1125315	0	0
46244446	1119510	0	0
46317662	1713332	0	0
46310326	1192710	0	0
45675431	1115008	0	0
3007461	3007461	0	0
21000063	1728416	0	0
21505812	1119510	0	0
21505746	1125315	3	3
21604685	45892894	5	6
36158154	1112807	0	0
36151116	1115008	0	0
43012432	43012433	0	0
42806854	40231925	2	3
44352720	1119510	0	0
44354015	19078461	2	3
45658709	1322184	0	0
45652782	1125315	0	0
44351625	1129625	0	0
45652371	1119510	0	0
45645027	1125315	0	0
45647953	1177480	0	0
45666646	1174888	0	0
45627856	19078461	2	3
45670281	1119510	0	0
45689095	975125	0	0
45688478	1119510	0	0
45777829	1125315	0	0
46242853	1129625	0	0
45693680	1125315	0	0
45789682	975125	0	0
45785644	1125315	0	0
45801401	1125315	0	0
46244337	1119510	0	0
46317311	1153428	0	0
46310448	1112807	0	0
45675617	1129625	0	0
3012494	3012494	0	0
21000064	1728416	0	0
21505812	1192710	0	0
21505746	1129625	3	3
35204998	381316	3	3
36158162	1112807	0	0
36151121	1107830	0	0
43012433	43012433	0	0
42806951	40174880	2	3
44352907	1119510	0	0
44356404	19078461	2	3
45658796	738818	0	0
45652824	1125315	0	0
44351550	1129625	0	0
45652286	1119510	0	0
45644967	1125315	0	0
45648067	1177480	0	0
45666650	1713332	0	0
45627856	1127433	2	3
45669927	1119510	0	0
45686184	975125	0	0
45682858	1119510	0	0
46244647	1125315	0	0
46242728	1129625	0	0
45693905	1125315	0	0
45789819	1332418	0	0
45785668	1125315	0	0
45801406	1125315	0	0
46244338	1119510	0	0
46317901	1308738	0	0
46310503	1112807	0	0
45675619	1119510	0	0
3019550	3019550	0	0
21000059	1717327	0	0
21505813	1119510	0	0
21505746	738818	3	3
35204998	4163874	3	3
36158186	1112807	0	0
36151260	1129625	0	0
43012695	43012433	0	0
42804387	40162522	2	3
44353190	1119510	0	0
44363104	19078461	2	3
45658798	1115008	0	0
45652838	1125315	0	0
44351477	1129625	0	0
45652487	1119510	0	0
45644972	1125315	0	0
45648072	1177480	0	0
45666650	1759842	0	0
45778418	19078461	2	3
45781324	1119510	0	0
45688608	975125	0	0
45683031	1119510	0	0
46244731	1125315	0	0
46242831	1129625	0	0
45693792	1125315	0	0
45789888	715997	0	0
45785703	1125315	0	0
45801752	1125315	0	0
46244506	1119510	0	0
46317323	975125	0	0
46310512	1551099	0	0
45675619	1192710	0	0
1549786	1549786	0	0
21000065	1728416	0	0
21505813	1129625	0	0
21505746	1119510	3	3
35202457	4324181	3	3
36158132	1539403	0	0
36150988	1177480	0	0
43012696	43012433	0	0
42804430	1551192	2	3
44353228	1119510	0	0
44357290	19078461	2	3
45659051	1307863	0	0
45652840	1125315	0	0
44351570	1129625	0	0
45652376	1119510	0	0
45645030	1125315	0	0
45647999	1177480	0	0
45666626	967823	0	0
45670673	19078461	2	3
45781383	1119510	0	0
45688613	975125	0	0
45683045	1119510	0	0
46244699	1125315	0	0
46242792	1129625	0	0
45693794	1125315	0	0
45789795	1110410	0	0
45785692	1125315	0	0
45801389	1125315	0	0
46244596	1119510	0	0
46317538	1192710	0	0
46310418	1112807	0	0
45675515	1361711	0	0
1551192	1551192	0	0
21000066	1728416	0	0
21505813	738818	0	0
21505746	1192710	3	3
35202461	317009	3	3
36158080	1129625	0	0
36150890	1000560	0	0
43012754	43012754	0	0
42804477	40224805	2	3
44348904	1119510	0	0
44358632	19078461	2	3
45658656	738818	0	0
45652929	1125315	0	0
44351670	1129625	0	0
45652439	1119510	0	0
45645044	1125315	0	0
45647971	1177480	0	0
45666653	1326303	0	0
45707083	19078461	2	3
45781250	1119510	0	0
45688616	975125	0	0
45683084	1119510	0	0
46244668	1125315	0	0
46243032	1129625	0	0
45693686	1125315	0	0
45789962	1192710	0	0
45785754	1125315	0	0
45801456	1125315	0	0
46244478	1119510	0	0
46317545	1343916	0	0
46310610	791967	0	0
45675604	1500211	0	0
1551099	1551099	0	0
21000059	1738521	0	0
21505813	1192710	0	0
21500045	1308738	3	3
21602796	1729720	3	3
36157779	738818	0	0
36150892	1332418	0	0
42805668	1000560	0	0
37203769	260139	1	2
44348974	1119510	0	0
44364056	19078461	2	3
45658657	1500211	0	0
45652812	1125315	0	0
44351903	1129625	0	0
44344268	1119510	0	0
45645101	1125315	0	0
45648223	1177480	0	0
45666595	1192710	0	0
45707345	19078461	2	3
45781353	1119510	0	0
45683060	975125	0	0
45682942	1119510	0	0
46242632	1125315	0	0
46242981	1129625	0	0
45693919	1125315	0	0
45789979	1149380	0	0
45785779	1125315	0	0
45801462	1125315	0	0
45787207	1125315	0	0
46318071	1124957	0	0
46310665	1149196	0	0
45675516	1501700	0	0
1551195	19089061	0	0
21000075	1738521	0	0
21505813	1125315	0	0
21604685	836654	3	3
21602796	1741122	3	3
36157783	1129625	0	0
36151266	1177480	0	0
42805863	701322	0	0
37604005	4329847	1	2
44348984	1119510	0	0
44358898	19078461	2	3
45658479	1174888	0	0
45652885	1125315	0	0
44351822	1129625	0	0
44344272	1119510	0	0
45645106	1125315	0	0
45648237	1177480	0	0
45666729	1192710	0	0
45694930	19078461	2	3
45781625	1119510	0	0
45683190	975125	0	0
45682967	1119510	0	0
46242604	1125315	0	0
46243034	1129625	0	0
45691447	1125315	0	0
45789979	1137529	0	0
45785783	1125315	0	0
45801451	1125315	0	0
45787651	1125315	0	0
46316821	1149196	0	0
46310573	1332418	0	0
45675544	1119510	0	0
1347450	1347450	0	0
21000082	1778162	0	0
21505814	738818	0	0
21604181	782043	3	3
21602796	1728416	3	3
36158082	738818	0	0
36151390	975125	0	0
42805765	723013	0	0
37604005	317576	1	2
44349085	1119510	0	0
44363236	40223768	2	3
45658482	1501700	0	0
45653032	1125315	0	0
44351869	1129625	0	0
44344574	1119510	0	0
45645312	1125315	0	0
45647858	1177480	0	0
45666620	1539403	0	0
45636724	19078461	2	3
45781651	1119510	0	0
45682951	975125	0	0
45683216	1119510	0	0
46242663	1125315	0	0
46242928	1129625	0	0
45691506	1125315	0	0
45789216	740275	0	0
45785979	1125315	0	0
45801512	1125315	0	0
45787229	1125315	0	0
46316838	1149380	0	0
46310596	1192710	0	0
45675558	1539403	0	0
1501700	1501700	0	0
21000109	1717327	0	0
21505814	1192710	0	0
21604181	1154029	3	3
35402588	372328	3	3
36158041	1746114	0	0
36150976	791967	0	0
42805766	1713332	0	0
37604031	381316	1	2
44349122	1119510	0	0
44357065	19078461	2	3
45658606	1545958	0	0
45652849	1125315	0	0
44343895	1129625	0	0
44344578	1119510	0	0
45645202	1125315	0	0
45647827	1177480	0	0
45666772	1738521	0	0
45679806	19078461	2	3
45781215	1119510	0	0
45682308	975125	0	0
45682913	1119510	0	0
46242640	1125315	0	0
46242779	1129625	0	0
45691419	1125315	0	0
45789151	1326303	0	0
45785985	1125315	0	0
45801432	1125315	0	0
45787633	1125315	0	0
46316906	1307863	0	0
46310752	975125	0	0
45675702	1119510	0	0
1503184	1503184	0	0
21000060	1728416	0	0
21505814	1119510	0	0
21604181	19078219	3	3
21605008	1149380	3	3
36158041	1741122	0	0
36211097	4059173	0	0
42805770	1548195	0	0
37521562	44805732	1	1
44349106	1119510	0	0
44346668	19078461	2	3
45658984	1118084	0	0
45652895	1125315	0	0
44344011	1129625	0	0
44344588	1119510	0	0
45645367	1125315	0	0
45644825	1177480	0	0
45666853	1308738	0	0
45630929	19078461	2	3
45779081	1119510	0	0
45660194	1177480	0	0
45683311	1119510	0	0
46240248	1125315	0	0
46242818	1129625	0	0
45690640	1125315	0	0
45789160	1115008	0	0
46296258	1125315	0	0
45801609	1125315	0	0
45787640	1125315	0	0
46316930	715997	0	0
46310522	1309944	0	0
45675708	1192710	0	0
1101352	1361711	0	0
19089061	19089061	0	0
21505814	1112807	0	0
21603365	1119510	3	3
21603444	1149196	3	3
36158049	1174888	0	0
36211127	4142905	0	0
42805612	1129625	0	0
37521571	4186930	1	1
44352013	1119510	0	0
44339679	19078461	2	3
45658987	1332418	0	0
45649459	1125315	0	0
44344003	1129625	0	0
44344528	1119510	0	0
45645378	1125315	0	0
45645024	1177480	0	0
45666857	975125	0	0
45686135	19078461	2	3
45779061	1119510	0	0
45660260	1177480	0	0
45682925	1119510	0	0
46240422	1125315	0	0
46241023	1129625	0	0
45690674	1125315	0	0
45789090	1107830	0	0
46296263	1125315	0	0
45801563	1125315	0	0
45787460	1125315	0	0
46316960	1118084	0	0
46310533	914335	0	0
45675715	1112807	0	0
1101380	1124300	0	0
19029476	19029476	0	0
21505816	738818	0	0
21602098	1149380	3	3
21603444	1129625	3	3
36158196	1177480	0	0
36211129	4237458	0	0
42805709	1124300	0	0
37521572	4186930	1	1
44351934	1119510	0	0
44357070	19078461	2	3
45658853	975125	0	0
45649460	1125315	0	0
44344251	1129625	0	0
44344593	1119510	0	0
45645307	1125315	0	0
45644893	1177480	0	0
45666788	1545958	0	0
45689092	19078461	2	3
45779195	1119510	0	0
45658313	1177480	0	0
45683108	1119510	0	0
46240423	1125315	0	0
46240521	1129625	0	0
45690687	1125315	0	0
45789167	1174888	0	0
46296267	1125315	0	0
45801595	1125315	0	0
45787293	1125315	0	0
46316915	1521369	0	0
46310534	920293	0	0
45675723	738818	0	0
1101382	1124300	0	0
4293740	4293740	0	0
21505816	1119510	0	0
21500290	40223821	3	4
21603444	1107830	3	3
36158278	1177480	0	0
36211130	4278672	0	0
42805711	1115008	0	0
40139614	19126352	1	1
44352083	1119510	0	0
44342133	19078461	2	3
45658886	1332418	0	0
45649594	1125315	0	0
44344688	1129625	0	0
45646265	1119510	0	0
45642139	1125315	0	0
45645028	1177480	0	0
45666859	1310149	0	0
45695019	19078461	2	3
45779208	1119510	0	0
45703855	1177480	0	0
45682929	1119510	0	0
46240218	1125315	0	0
46240604	1129625	0	0
45690762	1125315	0	0
45789248	1154343	0	0
46296277	1125315	0	0
45801565	1125315	0	0
45787601	1125315	0	0
46316915	1549786	0	0
46305288	1332418	0	0
45675548	1119510	0	0
1101382	1115008	0	0
4242997	4242997	0	0
21505816	1125315	0	0
21500290	40223834	3	4
21603444	1150770	3	3
36157986	1738521	0	0
36155831	705944	0	0
42805713	1310149	0	0
40141358	1310034	1	1
44351755	1119510	0	0
44339617	19078461	2	3
45658576	975125	0	0
45649535	1125315	0	0
44344420	1129625	0	0
45646270	1119510	0	0
45642095	1125315	0	0
45645113	1177480	0	0
45666870	1149196	0	0
45778420	19078461	2	3
45779108	1119510	0	0
45703984	1177480	0	0
45679884	1119510	0	0
46240427	1125315	0	0
46240581	1129625	0	0
45690768	1125315	0	0
45789253	933724	0	0
46296068	1125315	0	0
45801566	1125315	0	0
45787613	1125315	0	0
46316963	1551099	0	0
46304812	1112807	0	0
45675589	1129625	0	0
1101329	1124957	0	0
4243062	4243062	0	0
21505816	1192710	0	0
21500290	1107882	3	4
35507258	1539411	2	3
36157987	1177480	0	0
36155788	791967	0	0
42805925	1548195	0	0
40141899	40224132	1	1
44349303	1119510	0	0
44350009	19078461	2	3
45658739	1551099	0	0
45649692	1125315	0	0
44337436	1129625	0	0
45646343	1119510	0	0
45643026	1125315	0	0
45645076	1177480	0	0
45666733	1118084	0	0
45778421	19078461	2	3
45778885	1119510	0	0
45703930	1177480	0	0
45679609	1119510	0	0
46240331	1125315	0	0
45681150	1177480	0	0
45690760	1125315	0	0
45786982	1000560	0	0
46296287	1125315	0	0
45801437	1125315	0	0
45787616	1125315	0	0
46316953	1000560	0	0
46304836	1332418	0	0
45675631	705944	0	0
1101405	1551099	0	0
21001016	1112807	0	0
21505816	1129625	0	0
21604798	45892894	3	4
35507329	19019273	2	3
36157788	738818	0	0
36155724	738818	0	0
42805927	1332418	0	0
40136913	19125062	1	1
44349316	1119510	0	0
44343073	19075601	2	3
45658774	1174888	0	0
45649600	1125315	0	0
44337772	1129625	0	0
44341191	1119510	0	0
45643031	1125315	0	0
45642093	1177480	0	0
45666971	1501700	0	0
45778419	19078461	2	3
45778798	1119510	0	0
45651791	1177480	0	0
45682132	1119510	0	0
46240434	1125315	0	0
45680928	1177480	0	0
45690709	1125315	0	0
45786985	975125	0	0
46296304	1125315	0	0
45801439	1125315	0	0
45787774	1125315	0	0
46316904	1124300	0	0
46305052	967823	0	0
45675826	1112807	0	0
1101405	975125	0	0
21001016	1125315	0	0
21505819	738818	0	0
21604793	45892894	3	4
35507285	35605482	2	3
36157789	1129625	0	0
36155728	1112807	0	0
42805937	1124300	0	0
40142703	1154615	1	1
44345257	1119510	0	0
44342571	1539411	2	3
45658777	1545958	0	0
45649601	1125315	0	0
44337614	1129625	0	0
44341141	1119510	0	0
45643043	1125315	0	0
45642168	1177480	0	0
45664071	1343916	0	0
45778497	19078461	2	3
45779392	1119510	0	0
45651319	1177480	0	0
45682134	1119510	0	0
46240083	1125315	0	0
45681046	1177480	0	0
45690711	1125315	0	0
45787032	1112807	0	0
46296467	1125315	0	0
45801583	1125315	0	0
45787777	1125315	0	0
46311462	1322184	0	0
46305053	701322	0	0
45675775	1119510	0	0
1101410	1548195	0	0
21001017	1112807	0	0
21505819	1192710	0	0
21604181	782047	3	6
35507290	1127433	2	3
36158092	1115008	0	0
36155797	723013	0	0
42819910	1129625	0	0
40023991	19112599	1	1
44345505	1119510	0	0
44357327	1545959	2	3
45658777	1332418	0	0
45649709	1125315	0	0
44337513	1129625	0	0
45643530	1119510	0	0
45643021	1125315	0	0
45639158	1177480	0	0
45664074	1717327	0	0
45698153	19078461	2	3
45779393	1119510	0	0
45651640	1177480	0	0
45660102	1125315	0	0
46240184	1125315	0	0
45680879	1177480	0	0
45690624	1125315	0	0
45787058	1124300	0	0
46292108	1125315	0	0
45801598	1125315	0	0
45801029	1125315	0	0
46311480	1713332	0	0
46305167	1738521	0	0
45675750	1551099	0	0
782043	782043	0	0
21001018	708298	0	0
21505883	1557272	0	0
21604181	19023423	3	6
35507259	19008572	2	3
36158289	1124300	0	0
36155806	1539403	0	0
42819961	1107830	0	0
40023993	43012036	1	1
44345461	1119510	0	0
44364017	1332419	2	3
45658922	1545958	0	0
45649612	1125315	0	0
44337563	1129625	0	0
45643211	1119510	0	0
45642171	1125315	0	0
45639138	1177480	0	0
45664253	1309944	0	0
45651791	19078461	2	3
45779179	1119510	0	0
45652257	1177480	0	0
45661474	1125315	0	0
46240187	1125315	0	0
45681262	1177480	0	0
45690749	1125315	0	0
45786988	1112807	0	0
46292312	1125315	0	0
45801676	1125315	0	0
45801201	1125315	0	0
46311604	1149196	0	0
46304998	1367571	0	0
45896983	1149196	0	0
836654	836654	0	0
21001378	1713332	0	0
19045231	19045231	0	0
21604685	19123231	3	6
35507354	40229134	2	3
36158243	1112807	0	0
36155807	1192710	0	0
42820011	1119510	0	0
40024030	19074841	1	1
44345472	1119510	0	0
44356282	40223768	2	3
45658922	1332418	0	0
45649615	1125315	0	0
44337726	1129625	0	0
45643095	1119510	0	0
45642228	1125315	0	0
45639275	1177480	0	0
45664259	1343916	0	0
45688653	19078461	2	3
45779395	1119510	0	0
45651859	1177480	0	0
45661551	1125315	0	0
46240362	1125315	0	0
45681139	1177480	0	0
45690740	1125315	0	0
45787098	738818	0	0
46292515	1125315	0	0
45801694	1125315	0	0
45801033	1125315	0	0
46311630	738818	0	0
46305014	791967	0	0
45896932	757627	0	0
836659	836659	0	0
21001368	975125	0	0
21500546	1129625	0	0
21500120	40174880	9	10
21604643	19078924	0	3
36158245	1112807	0	0
36155808	1326303	0	0
42820011	738818	0	0
37203772	4283893	1	1
44345229	1119510	0	0
44356818	1545959	2	3
45658923	1361711	0	0
45649783	1125315	0	0
45622007	1129625	0	0
45643002	1119510	0	0
45642185	1125315	0	0
45638969	1177480	0	0
45664273	1548195	0	0
45698116	19078461	2	3
45707639	1119510	0	0
45651808	1177480	0	0
45661665	1125315	0	0
46240369	1125315	0	0
45681223	1177480	0	0
45690819	1125315	0	0
45787102	1310149	0	0
46292319	1125315	0	0
45801695	1125315	0	0
45802515	1125315	0	0
46306165	1367571	0	0
46305084	975125	0	0
45896935	1110410	0	0
378001	378001	0	0
21001379	1729720	0	0
21500546	738818	0	0
21502709	43012036	9	10
21603058	920300	0	3
36158197	1107830	0	0
36155793	1177480	0	0
42805972	975125	0	0
37203767	28060	1	1
44345230	1119510	0	0
44354207	19078461	2	3
45658888	1551099	0	0
45649755	1125315	0	0
45621917	1129625	0	0
45640398	1119510	0	0
45642229	1125315	0	0
45639071	1177480	0	0
45664273	1521369	0	0
45682897	19078461	2	3
45707642	1119510	0	0
45651818	1177480	0	0
45661667	1125315	0	0
46242346	1125315	0	0
45681256	1177480	0	0
45691071	1125315	0	0
45787078	975125	0	0
46292168	1125315	0	0
45801702	1125315	0	0
45802586	1125315	0	0
46306560	1729720	0	0
46305088	975125	0	0
45897040	1589505	0	0
380378	380378	0	0
21001385	1759842	0	0
21500547	1125315	0	0
21502709	46275916	9	10
21603058	920334	0	3
36157928	738818	0	0
36155931	1307863	0	0
42805985	1539403	0	0
37203769	255848	1	1
44345423	1119510	0	0
43534908	1000560	0	0
45658893	1322184	0	0
45649638	1125315	0	0
45622215	1129625	0	0
45640350	1119510	0	0
45642253	1125315	0	0
45638983	1177480	0	0
45664194	1149380	0	0
45685946	19078461	2	3
45777915	1119510	0	0
45700648	1177480	0	0
45661612	1125315	0	0
46242385	1125315	0	0
45675921	1177480	0	0
45687424	1125315	0	0
45787082	975125	0	0
46292123	1125315	0	0
45795901	1125315	0	0
45802590	1125315	0	0
46305976	1729720	0	0
46305097	1112807	0	0
45896897	1119510	0	0
378419	378419	0	0
21001369	975125	0	0
21500547	1129625	0	0
21502709	40228230	9	10
35200000	4329847	3	7
36157797	1310149	0	0
36155941	738818	0	0
42806027	1332418	0	0
37019238	195588	1	1
44345384	1119510	0	0
43534629	967823	0	0
45658903	1310149	0	0
45649645	1125315	0	0
45622190	1129625	0	0
45640480	1119510	0	0
45642330	1125315	0	0
45639124	1177480	0	0
45664194	1137529	0	0
45630738	1332419	2	3
45777877	1119510	0	0
45648724	1177480	0	0
45661642	1125315	0	0
46242096	1125315	0	0
45676061	1177480	0	0
45687691	1125315	0	0
45786991	1551099	0	0
46292182	1125315	0	0
45796124	1125315	0	0
45802594	1125315	0	0
46306501	1192710	0	0
46305102	1332418	0	0
45896952	1738521	0	0
381316	381316	0	0
21001385	1713332	0	0
21500564	836654	0	0
21602886	19074841	0	3
35302072	4144583	7	7
36158291	1177480	0	0
36155906	1177480	0	0
42805950	1115008	0	0
40783242	3013682	1	1
44345576	1119510	0	0
43534632	967823	0	0
45658495	975125	0	0
45649647	1125315	0	0
44358682	1129625	0	0
45640476	1119510	0	0
45642317	1125315	0	0
45640146	1177480	0	0
45664275	1332418	0	0
45660194	19078461	2	3
45707807	1119510	0	0
45648824	1177480	0	0
45660188	1125315	0	0
46242162	1125315	0	0
45676105	1177480	0	0
45687758	1125315	0	0
45786993	1192710	0	0
46292089	1125315	0	0
45796140	1125315	0	0
45801237	1125315	0	0
46306189	1322184	0	0
46305437	914335	0	0
45897052	1119510	0	0
196456	196456	0	0
21001385	1778162	0	0
4326177	4326177	0	0
21502584	19123231	7	8
35302074	4043241	7	7
36158201	1177480	0	0
36156016	738818	0	0
42806074	1124957	0	0
40783474	3008598	1	1
44345407	1119510	0	0
43534633	967823	0	0
45658504	1118084	0	0
45649865	1125315	0	0
45658432	1129625	0	0
45640500	1119510	0	0
45642290	1125315	0	0
45636350	1177480	0	0
45664191	708298	0	0
45701166	1539411	2	3
45707803	1119510	0	0
45648707	1177480	0	0
45658285	1125315	0	0
46242404	1125315	0	0
45676022	1177480	0	0
45687759	1125315	0	0
45786997	1149196	0	0
46292281	1125315	0	0
45795962	1125315	0	0
45801418	1125315	0	0
46306190	1729720	0	0
46305438	1551099	0	0
45897054	1129625	0	0
1539411	1539411	0	0
21001379	1713332	0	0
21011857	1759842	0	0
21502584	19076374	7	8
21602795	19075001	6	7
36158206	738818	0	0
36156091	975125	0	0
42806091	1000560	0	0
40483563	4323208	1	1
44345519	1119510	0	0
43534634	967823	0	0
45658627	1717327	0	0
45649867	1125315	0	0
45658747	1129625	0	0
45640610	1119510	0	0
45639129	1125315	0	0
45633031	1177480	0	0
45664360	1738521	0	0
45669056	1539411	2	3
45707991	1119510	0	0
45648609	1177480	0	0
45658304	1125315	0	0
46240468	1125315	0	0
45672905	1177480	0	0
45687699	1125315	0	0
45787001	1000560	0	0
46292299	1125315	0	0
45795965	1125315	0	0
45801224	1125315	0	0
46306411	1738521	0	0
46305446	1192710	0	0
45897055	1332418	0	0
1549914	19127918	2	2
21001370	975125	0	0
21011857	1717327	0	0
21502584	40232448	7	8
21602795	19073188	4	7
36158324	1124957	0	0
36155942	1115008	0	0
42806201	791967	0	0
40486433	4048171	1	1
44345478	1119510	0	0
43534642	1539403	0	0
45658630	705944	0	0
45649888	1125315	0	0
45658838	1129625	0	0
45640518	1119510	0	0
45639135	1125315	0	0
45659129	1112807	0	0
45664200	791967	0	0
45631013	1332419	2	3
45704677	1119510	0	0
45648943	1177480	0	0
45657929	1125315	0	0
46240469	1125315	0	0
45673063	1177480	0	0
45687353	1125315	0	0
45787004	975125	0	0
46292301	1125315	0	0
45796250	1125315	0	0
45801229	1125315	0	0
46306574	1115008	0	0
46305446	1174888	0	0
45897064	933724	0	0
1549914	42902245	2	2
21001371	975125	0	0
21011858	1717327	0	0
21502584	40236446	7	8
21602795	19074841	4	7
36158326	1589505	0	0
36155837	791967	0	0
42806145	1177480	0	0
40223818	40223821	1	1
44345483	1119510	0	0
43534660	1361711	0	0
45658805	1551099	0	0
45649650	1125315	0	0
45658843	1129625	0	0
45640559	1119510	0	0
45639271	1125315	0	0
45659133	1112807	0	0
45664202	1307863	0	0
45686142	40174880	2	3
45705131	1119510	0	0
45649130	1177480	0	0
45658168	1125315	0	0
46240478	1125315	0	0
45673126	1177480	0	0
45687354	1125315	0	0
45787006	1124300	0	0
46292223	1125315	0	0
45796255	1125315	0	0
45801312	1125315	0	0
46306644	723013	0	0
46305022	933724	0	0
45897067	1177480	0	0
1549914	19128009	2	2
21001372	975125	0	0
21012149	1396131	0	0
21503650	42707627	7	8
21602795	19133873	4	7
36158292	1501700	0	0
36155861	1124300	0	0
42806013	1738521	0	0
40223828	40223834	1	1
44345710	1119510	0	0
43534674	975125	0	0
45659106	1545958	0	0
45649616	1125315	0	0
45658954	1129625	0	0
45637537	1119510	0	0
45639317	1125315	0	0
45657214	1112807	0	0
45664375	1713332	0	0
45685939	19079524	2	3
45704685	1119510	0	0
45646107	1177480	0	0
45703840	1125315	0	0
46240491	1125315	0	0
45673211	1177480	0	0
45687824	1125315	0	0
45787016	740275	0	0
46292477	1125315	0	0
45796218	1125315	0	0
45801329	1125315	0	0
46306516	738818	0	0
46305255	1501700	0	0
45897099	1124957	0	0
1549916	19127904	2	2
21001380	1713332	0	0
21012151	1396131	0	0
21503645	40162522	7	8
21602795	920300	4	7
36158339	740275	0	0
36155876	1112807	0	0
42806100	1343916	0	0
40222857	45892894	1	1
44345606	1119510	0	0
43534879	1154029	0	0
45659109	1124300	0	0
45649898	1125315	0	0
45658864	1129625	0	0
45637191	1119510	0	0
45639325	1125315	0	0
45653899	1112807	0	0
45664280	1115008	0	0
45704418	1127433	2	3
45704696	1119510	0	0
45645747	1177480	0	0
45704006	1125315	0	0
46240558	1125315	0	0
45673307	1177480	0	0
45687630	1125315	0	0
45787039	1192710	0	0
46292470	1125315	0	0
45795975	1125315	0	0
45801333	1125315	0	0
46306246	975125	0	0
46305519	1595799	0	0
45897103	1174888	0	0
1549916	42902245	2	2
21001425	1551099	0	0
21012484	1548195	0	0
21503645	1127433	7	8
35302077	441267	2	2
36158293	1192710	0	0
36155877	1000560	0	0
42806064	1119510	0	0
40222845	40222846	1	1
44345737	1119510	0	0
43534723	1521369	0	0
45659033	1107830	0	0
45649698	1125315	0	0
45658824	1129625	0	0
45637179	1119510	0	0
45639261	1125315	0	0
45647574	1112807	0	0
45664393	738818	0	0
45698149	1545959	2	3
45705059	1119510	0	0
45645625	1177480	0	0
45704007	1125315	0	0
45703292	1125315	0	0
45786671	1177480	0	0
45688002	1125315	0	0
45787059	975125	0	0
46292503	1125315	0	0
45796199	1125315	0	0
45801352	1125315	0	0
46306989	1107830	0	0
46305525	1192710	0	0
45897103	1192710	0	0
4001217	4326177	2	2
21001425	1112807	0	0
21011857	1713332	0	0
21503645	19007333	7	8
21604792	715997	2	2
36158294	1115008	0	0
36155776	1177480	0	0
42805999	1545958	0	0
40144037	40169216	1	1
44345551	1119510	0	0
43534937	1501700	0	0
45658868	1343916	0	0
45649775	1125315	0	0
45652119	1129625	0	0
45637480	1119510	0	0
45639296	1125315	0	0
45644499	1112807	0	0
45664381	1343916	0	0
45706686	1539411	2	3
45633049	1129625	0	0
45645803	1177480	0	0
45704081	1125315	0	0
45703135	1125315	0	0
45785009	1177480	0	0
45687876	1125315	0	0
45787061	1112807	0	0
46292451	1125315	0	0
45796204	1125315	0	0
45795709	1125315	0	0
46306468	738818	0	0
46305525	1174888	0	0
45897172	1153428	0	0
376106	4029498	2	2
21001022	705944	0	0
21011858	1713332	0	0
21503645	19019273	7	8
21604792	836654	2	2
36158295	1545958	0	0
36155916	723013	0	0
42806088	1124300	0	0
40069736	19045231	1	1
44341272	1119510	0	0
43534941	1308738	0	0
45659013	1192710	0	0
45649777	1125315	0	0
45652120	1129625	0	0
45637560	1119510	0	0
45639065	1125315	0	0
45644251	1112807	0	0
45664383	1149380	0	0
45706754	1539411	2	3
45633130	1129625	0	0
45642714	1177480	0	0
45703985	1125315	0	0
45703139	1125315	0	0
45785136	1177480	0	0
45687895	1125315	0	0
45787062	1332418	0	0
46292394	1125315	0	0
45796174	1125315	0	0
45795732	1125315	0	0
46306596	1149196	0	0
46305313	1153428	0	0
45896922	1129625	0	0
1549918	42902245	2	2
21001028	740275	0	0
21011858	1759842	0	0
21503645	19078461	7	8
21604254	1102527	2	2
36158331	975125	0	0
36156017	1124300	0	0
42806090	1713332	0	0
40065329	19007333	1	1
44344459	1119510	0	0
45619689	1192710	0	0
45658871	1124957	0	0
45649059	1125315	0	0
45652321	1129625	0	0
45637412	1119510	0	0
45639191	1125315	0	0
45644687	1112807	0	0
45664470	1000560	0	0
45781123	1545959	2	3
45633230	1129625	0	0
45642757	1177480	0	0
45703926	1125315	0	0
45703232	1125315	0	0
45784943	1177480	0	0
45687653	1125315	0	0
45787067	1174888	0	0
46292520	1125315	0	0
45796175	1125315	0	0
45795768	1125315	0	0
46306230	738818	0	0
46305526	1149196	0	0
45896985	1115008	0	0
1549918	19128263	2	2
21001034	1717327	0	0
21012458	715997	0	0
21503645	1127078	7	8
21604254	1124957	2	2
36158332	1521369	0	0
36156019	1118084	0	0
42806014	19127890	0	0
40069853	40236824	1	1
44344462	1119510	0	0
45619695	1177480	0	0
45658826	1124957	0	0
45648796	1125315	0	0
45652326	1129625	0	0
45640107	1119510	0	0
45639204	1125315	0	0
45644715	1112807	0	0
45664465	1713332	0	0
45680244	1539411	2	3
45676456	1129625	0	0
45642800	1177480	0	0
45704135	1125315	0	0
45703385	1125315	0	0
45784981	1177480	0	0
45687504	1125315	0	0
45787057	1149196	0	0
46292607	1125315	0	0
45796179	1125315	0	0
45795823	1125315	0	0
46306646	933724	0	0
46305476	1149196	0	0
45896860	1307863	0	0
1549918	19128022	2	2
21000141	19133905	2	3
21012458	757627	0	0
21503645	1115171	7	8
21604254	1110410	2	2
36158332	1549786	0	0
36155945	1124300	0	0
42806014	1512674	0	0
40069975	920300	1	1
44341602	1119510	0	0
45619703	1115008	0	0
44352123	1396131	0	0
45649055	1125315	0	0
45652149	1129625	0	0
45639982	1119510	0	0
45639212	1125315	0	0
45641850	1112807	0	0
45664465	1759842	0	0
45671592	1539411	2	3
45676745	1129625	0	0
45642901	1177480	0	0
45703977	1125315	0	0
45703530	1125315	0	0
45782906	1177480	0	0
45687602	1125315	0	0
45787029	1153428	0	0
46287882	1125315	0	0
45796323	1125315	0	0
45795793	1125315	0	0
46306668	1548195	0	0
46305481	1713332	0	0
45896962	1107830	0	0
4003382	4323902	2	2
21001038	19129655	2	3
21012484	1521369	0	0
21500238	1307863	0	0
21604070	19003953	2	2
36158333	1589505	0	0
36156094	1177480	0	0
42806014	1549786	0	0
40066578	40236446	1	1
44341697	1119510	0	0
45619705	1112807	0	0
44351940	1124957	0	0
45649106	1125315	0	0
45652159	1129625	0	0
45634180	1119510	0	0
45639215	1125315	0	0
45641999	1112807	0	0
45664466	1589505	0	0
45677019	1539411	2	3
45676977	1129625	0	0
45688685	1177480	0	0
45703780	1125315	0	0
45703533	1125315	0	0
45783113	1177480	0	0
45687899	1125315	0	0
45787160	933724	0	0
46287907	1125315	0	0
45796325	1125315	0	0
45795858	1125315	0	0
46317223	1174888	0	0
46305489	1112807	0	0
45896965	1112807	0	0
372887	381316	2	2
21000105	19129655	2	3
21012460	757627	0	0
21500238	1332418	0	0
21604035	1124300	2	2
36158333	19127890	0	0
36155847	1115008	0	0
42803541	1713332	0	0
40073531	1551192	1	1
44341767	1119510	0	0
45619706	1174888	0	0
44351944	1308738	0	0
45649117	1125315	0	0
45652164	1129625	0	0
45634181	1119510	0	0
45638990	1125315	0	0
45641830	1112807	0	0
45664466	1548195	0	0
45778764	1539411	2	3
45677067	1129625	0	0
45688664	1177480	0	0
45704033	1125315	0	0
45703264	1125315	0	0
45783125	1177480	0	0
45687902	1125315	0	0
45787153	1549786	0	0
46288115	1125315	0	0
45796191	1125315	0	0
45795839	1125315	0	0
46317297	1115008	0	0
46305330	1192710	0	0
45897049	1332418	0	0
372887	380378	2	2
21000109	19129655	2	3
4283893	4283893	0	0
21500285	1192710	0	0
21604035	1177480	2	2
36158333	1549786	0	0
36155937	1107830	0	0
42803514	1545958	0	0
37503995	4216130	1	1
44341815	1119510	0	0
45621960	967823	0	0
44351945	1310149	0	0
45646491	1125315	0	0
45652339	1129625	0	0
45634040	1119510	0	0
45638996	1125315	0	0
45641955	1112807	0	0
45664479	1154343	0	0
45695375	1539411	2	3
45676540	1129625	0	0
45691385	1177480	0	0
45704053	1125315	0	0
45703267	1125315	0	0
45783139	1177480	0	0
45687906	1125315	0	0
45787153	1589505	0	0
46287987	1125315	0	0
45796469	1125315	0	0
45795841	1125315	0	0
46317460	1192710	0	0
46305346	1000560	0	0
45896969	1119510	0	0
378161	372328	2	2
21000101	19129655	2	3
21000474	1551099	0	0
21503745	1125315	0	0
21603813	1500211	2	2
36158458	1107830	0	0
36156174	920293	0	0
42803452	1125315	0	0
40021695	40228214	1	1
44341816	1119510	0	0
45621558	1595799	0	0
44351852	1000560	0	0
45646477	1125315	0	0
45652619	1129625	0	0
45634117	1119510	0	0
45639298	1125315	0	0
45638950	1112807	0	0
45664282	975125	0	0
45669875	1539411	2	3
45673585	1129625	0	0
45639851	1177480	0	0
45704054	1125315	0	0
45703272	1125315	0	0
45783151	1177480	0	0
45687914	1125315	0	0
45787124	1107830	0	0
46243137	1125315	0	0
45796350	1125315	0	0
45795919	1125315	0	0
45895592	1112807	0	0
46305211	1112807	0	0
45896988	1309944	0	0
375415	4156265	2	2
21000259	46233710	2	3
21000482	1551099	0	0
21503753	967823	0	0
21603041	920293	2	2
36158433	1177480	0	0
36156177	1713332	0	0
42803610	1124300	0	0
40021695	40228230	1	1
44341956	1119510	0	0
45621558	1308738	0	0
44352071	975125	0	0
45646569	1125315	0	0
45652290	1129625	0	0
45634121	1119510	0	0
45640143	1125315	0	0
45638759	1112807	0	0
45664283	1501700	0	0
45707706	19079524	1	1
45673703	1129625	0	0
45685946	1177480	0	0
45703903	1125315	0	0
45703276	1125315	0	0
45778285	1177480	0	0
45687734	1125315	0	0
45787211	1112807	0	0
46243106	1125315	0	0
45796354	1125315	0	0
45795843	1125315	0	0
45895577	1112807	0	0
46305234	975125	0	0
45896972	1177480	0	0
375415	4132546	2	2
21000094	19129655	2	3
21000474	975125	0	0
21503925	1177480	0	0
35102442	439777	2	2
36158371	738818	0	0
36156178	1129625	0	0
42803577	1557272	0	0
40223725	42707627	1	1
44341737	1119510	0	0
45621580	933724	0	0
44352218	1110410	0	0
45646690	1125315	0	0
44344574	1129625	0	0
45634153	1119510	0	0
45640212	1125315	0	0
45639021	1112807	0	0
45664286	975125	0	0
45680453	19079524	1	1
45673518	1129625	0	0
45685974	1177480	0	0
45703906	1125315	0	0
45703348	1125315	0	0
45777840	1177480	0	0
45687738	1125315	0	0
45787213	1713332	0	0
46243140	1125315	0	0
45796310	1125315	0	0
45795972	1125315	0	0
45895767	1112807	0	0
46305246	975125	0	0
45896986	1307863	0	0
4002905	440448	2	2
21000086	19129655	2	3
21000478	1551099	0	0
21503646	1125315	0	0
35205038	317009	2	2
36158375	1192710	0	0
36155953	1000560	0	0
42803508	1545958	0	0
37604042	192671	1	1
42707627	42707627	0	0
45621551	1124957	0	0
45652419	740275	0	0
45646430	1125315	0	0
44344344	1129625	0	0
45634399	1119510	0	0
45635859	1125315	0	0
45638899	1112807	0	0
45664224	967823	0	0
45692252	19079524	1	1
45673842	1129625	0	0
45685980	1177480	0	0
45703907	1125315	0	0
45703541	1125315	0	0
45777891	1177480	0	0
45687741	1125315	0	0
45787219	1115008	0	0
46243147	1125315	0	0
45790958	1125315	0	0
45795761	1125315	0	0
45895653	1112807	0	0
46305497	1149196	0	0
45896987	723013	0	0
4002905	4166224	2	2
21001033	19129655	2	3
21000478	1305058	0	0
21503925	1115008	0	0
35104382	4056621	2	2
36158383	1112807	0	0
36155954	1713332	0	0
42803511	1545958	0	0
40069735	19045231	1	1
44359123	1125315	0	0
45621665	967823	0	0
45652616	1545958	0	0
45646606	1125315	0	0
45646264	1129625	0	0
45634506	1119510	0	0
45635811	1125315	0	0
45635784	1112807	0	0
45664318	1332418	0	0
45689139	19079524	1	1
45673820	1129625	0	0
45636724	1177480	0	0
45651470	1125315	0	0
45703550	1125315	0	0
46242610	1177480	0	0
45687744	1125315	0	0
45787166	738818	0	0
46242867	1125315	0	0
45790725	1125315	0	0
45795808	1125315	0	0
45802109	1112807	0	0
46305514	975125	0	0
45896957	1332418	0	0
4002046	4336464	2	2
21000060	19129655	2	3
21000480	1551099	0	0
21503664	1112807	0	0
35104347	4056621	2	2
36158106	1107830	0	0
36155923	1129625	0	0
42803460	1125315	0	0
40223461	43012036	1	1
44359130	1125315	0	0
45621666	1129625	0	0
45652025	1124300	0	0
45646684	1125315	0	0
45646265	1129625	0	0
45634336	1119510	0	0
45636050	1125315	0	0
45632673	1112807	0	0
45664302	1713332	0	0
45633086	19079524	1	1
45670807	1129625	0	0
45636824	1177480	0	0
45651747	1125315	0	0
45703491	1125315	0	0
46242664	1177480	0	0
45688505	1125315	0	0
45787184	933724	0	0
46242905	1125315	0	0
45790660	1125315	0	0
45795949	1125315	0	0
45802143	1112807	0	0
46305154	1153428	0	0
45896959	1129625	0	0
321887	317576	2	2
21000483	1551192	2	3
21000478	975125	0	0
21503664	1125315	0	0
21601745	1332418	2	2
36158109	1177480	0	0
36155928	1545958	0	0
42803589	1545958	0	0
40126735	40222846	1	1
44358995	1125315	0	0
45621697	738818	0	0
45652026	715997	0	0
45646727	1125315	0	0
45646344	1129625	0	0
45634241	1119510	0	0
45635868	1125315	0	0
45632555	1112807	0	0
45664309	738818	0	0
45707875	19079524	1	1
45670771	1129625	0	0
45636945	1177480	0	0
45651598	1125315	0	0
45703472	1125315	0	0
46240337	1177480	0	0
45684778	1125315	0	0
45787185	920293	0	0
46242907	1125315	0	0
45790739	1125315	0	0
45795951	1125315	0	0
45802233	1112807	0	0
46305352	1332418	0	0
45896998	1129625	0	0
444129	4134304	2	2
21000092	19129655	2	3
4097962	4152936	2	2
21503664	1124957	0	0
21604182	1154029	2	2
36157821	1177480	0	0
36156067	1177480	0	0
42803691	1000560	0	0
40020957	19075001	1	1
44358888	1125315	0	0
45621976	1102527	0	0
45652028	1153428	0	0
45646585	1125315	0	0
45646408	1129625	0	0
45634261	1119510	0	0
45635873	1125315	0	0
45632933	1112807	0	0
45664538	1717327	0	0
45707697	19079524	1	1
45671053	1129625	0	0
45682819	1177480	0	0
45651642	1125315	0	0
45703329	1125315	0	0
46240398	1177480	0	0
45684672	1125315	0	0
45787145	1192710	0	0
46242913	1125315	0	0
45791011	1125315	0	0
45795806	1125315	0	0
45802270	1112807	0	0
46305362	715997	0	0
45897004	1174888	0	0
4000609	30753	2	2
21000267	46233988	2	3
4139262	4010253	2	2
21503664	1177480	0	0
35406308	372328	2	2
36157824	738818	0	0
36156096	1729720	0	0
42803693	1129625	0	0
40483561	4125906	1	1
44359064	1125315	0	0
45621900	715997	0	0
45652204	1107830	0	0
45646733	1125315	0	0
45646068	1129625	0	0
45634314	1119510	0	0
45635902	1125315	0	0
45632870	1112807	0	0
45664544	1192710	0	0
45683509	19079524	1	1
45671054	1129625	0	0
45682832	1177480	0	0
45651320	1125315	0	0
45700402	1125315	0	0
46240284	1177480	0	0
45684677	1125315	0	0
45787145	1174888	0	0
46242917	1125315	0	0
45790779	1125315	0	0
45795876	1125315	0	0
45799301	1112807	0	0
46305362	701322	0	0
45897004	1192710	0	0
4000609	4310024	2	2
21000486	19007333	2	3
4048543	4336464	2	2
21503647	1129625	0	0
35104353	4056621	2	2
36158346	1129625	0	0
36155882	738818	0	0
42803555	1177480	0	0
40024032	19074843	1	1
44359259	1125315	0	0
45621968	1149196	0	0
45652330	1115008	0	0
45646767	1125315	0	0
45646075	1129625	0	0
45634429	1119510	0	0
45635907	1125315	0	0
45632856	1112807	0	0
45778310	975125	0	0
45669375	19079524	1	1
45670744	1129625	0	0
45682879	1177480	0	0
45651326	1125315	0	0
45700114	1125315	0	0
46240275	1177480	0	0
45684517	1125315	0	0
45787243	1539403	0	0
46243016	1125315	0	0
45791022	1125315	0	0
45795877	1125315	0	0
45796783	1112807	0	0
46305363	1729720	0	0
45897132	1177480	0	0
4002367	4337138	2	2
21000148	46233988	2	3
4040549	4337138	2	2
21503647	1112807	0	0
21603819	1500211	2	2
36158348	738818	0	0
36155954	1759842	0	0
42803592	1119510	0	0
40144020	40169281	1	1
44359260	1125315	0	0
45619714	1177480	0	0
45652426	1551099	0	0
45643478	1125315	0	0
45646197	1129625	0	0
45634526	1119510	0	0
45636097	1125315	0	0
45629649	1112807	0	0
45778187	1308738	0	0
45671176	19079524	1	1
45670909	1129625	0	0
45633462	1177480	0	0
45651327	1125315	0	0
45700345	1125315	0	0
46240370	1177480	0	0
45684642	1125315	0	0
45787355	1115008	0	0
46243181	1125315	0	0
45790828	1125315	0	0
45795966	1125315	0	0
45796985	1112807	0	0
46305387	1367571	0	0
45896991	1107830	0	0
374009	378419	2	2
21000148	19129655	2	3
4134294	4112343	2	2
21494966	21494966	0	0
35102397	4280726	2	2
36158362	1361711	0	0
36156054	1713332	0	0
42803517	1713332	0	0
40072606	19006318	1	1
44359262	1125315	0	0
45619741	1177480	0	0
45652427	1308738	0	0
45643706	1125315	0	0
45643144	1129625	0	0
45634620	1119510	0	0
45636135	1125315	0	0
45629651	1112807	0	0
45778049	1332418	0	0
45707565	19079524	1	1
45670973	1129625	0	0
45633590	1177480	0	0
45651329	1125315	0	0
45700465	1125315	0	0
45703413	1177480	0	0
45684648	1125315	0	0
45787325	738818	0	0
46243182	1125315	0	0
45790975	1125315	0	0
45795884	1125315	0	0
45796881	1112807	0	0
46307021	740275	0	0
45897073	1545958	0	0
442564	4152936	2	2
21000289	46233988	2	3
4134294	4294548	2	2
21004920	1717327	0	0
21008595	1545959	2	3
36158437	19127890	0	0
36156054	1759842	0	0
42803517	1759842	0	0
40783186	3004501	4	4
44359278	1125315	0	0
45619796	1112807	0	0
45652468	1192710	0	0
45643479	1125315	0	0
45643399	1129625	0	0
45634377	1119510	0	0
45636139	1125315	0	0
45628031	1112807	0	0
45778150	1124300	0	0
45707312	19079524	1	1
45670984	1129625	0	0
45633776	1177480	0	0
45651451	1125315	0	0
45700507	1125315	0	0
45703471	1177480	0	0
45684741	1125315	0	0
45787356	1174888	0	0
46242996	1125315	0	0
45790954	1125315	0	0
45795930	1125315	0	0
45797024	1112807	0	0
46307147	1112807	0	0
45897151	1107830	0	0
321588	321042	2	2
21000085	19133873	2	3
4134294	260139	2	2
21004864	914335	0	0
21008595	1539411	2	3
36158437	1549786	0	0
36155930	1589505	0	0
42803653	1124957	0	0
40783186	3006906	4	4
44359323	1125315	0	0
45619797	1129625	0	0
45652108	1124957	0	0
45643781	1125315	0	0
45643107	1129625	0	0
45634389	1119510	0	0
45636251	1125315	0	0
45628244	1112807	0	0
45778191	1107830	0	0
45680358	46275916	1	1
45669360	1129625	0	0
45633767	1177480	0	0
45651453	1125315	0	0
45896820	1125315	0	0
45703477	1177480	0	0
45684747	1125315	0	0
45787416	1115008	0	0
46242999	1125315	0	0
45792002	1125315	0	0
45796043	1125315	0	0
46317557	1112807	0	0
46306700	1174888	0	0
45897152	1129625	0	0
374377	44782520	2	2
21000085	19133905	2	3
4181187	257012	2	2
21004929	1717327	0	0
21008593	1545959	2	3
36158440	1149196	0	0
36155930	19127890	0	0
42803431	1738521	0	0
40783186	3024561	4	4
44359329	1125315	0	0
45619797	1177480	0	0
45652216	705944	0	0
45643721	1125315	0	0
45643146	1129625	0	0
45634716	1119510	0	0
45636011	1125315	0	0
45628225	1112807	0	0
45778378	740275	0	0
45680358	19079524	1	1
45669486	1129625	0	0
45679697	1177480	0	0
45652199	1125315	0	0
45896847	1125315	0	0
45700404	1177480	0	0
45684749	1125315	0	0
45787222	1332418	0	0
46242967	1125315	0	0
45791887	1125315	0	0
45795937	1125315	0	0
45794184	1112807	0	0
46306536	1521369	0	0
45897155	1307863	0	0
4000610	4027663	2	2
21000116	46233710	2	3
4181187	40481087	2	2
21005289	1501700	0	0
21008593	1539411	2	3
36158466	1149196	0	0
36155930	1549786	0	0
42803513	1149196	0	0
40783186	3013721	4	4
44359330	1125315	0	0
45619800	975125	0	0
45652161	1124957	0	0
45643485	1125315	0	0
45643441	1129625	0	0
45631284	1119510	0	0
45636015	1125315	0	0
45627077	1112807	0	0
45778053	1124957	0	0
45680465	19079524	1	1
45780799	1129625	0	0
45679806	1177480	0	0
45652061	1125315	0	0
45896879	1125315	0	0
45700468	1177480	0	0
45684607	1125315	0	0
45785498	1308738	0	0
46243067	1125315	0	0
45791895	1125315	0	0
45796051	1125315	0	0
45794006	1112807	0	0
46306543	715997	0	0
45896939	933724	0	0
4001565	4337611	2	2
21000116	46233988	2	3
4088217	4107731	2	2
21004841	1551099	0	0
21601195	967823	2	2
36158441	975125	0	0
36156188	1000560	0	0
42803638	1545958	0	0
40783186	3015632	4	4
44359097	1125315	0	0
45619790	1149196	0	0
45652344	1000560	0	0
45643500	1125315	0	0
45643176	1129625	0	0
45631091	1119510	0	0
45636264	1125315	0	0
45623926	1112807	0	0
45778242	1738521	0	0
45704577	19079524	1	1
45781078	1129625	0	0
45630745	1177480	0	0
45652030	1125315	0	0
45896880	1125315	0	0
45700169	1177480	0	0
45684487	1125315	0	0
45785502	1124957	0	0
46243009	1125315	0	0
45791964	1125315	0	0
45790670	1125315	0	0
45794243	1112807	0	0
46306716	1589505	0	0
45896940	1000560	0	0
4001535	4275113	2	2
21000075	46233988	2	3
4169307	438614	2	2
21004841	975125	0	0
21601240	1326303	2	2
36158445	738818	0	0
36156215	914335	0	0
42803632	1118084	0	0
40783186	3006923	4	4
44359156	1125315	0	0
45619749	1177480	0	0
45652351	967823	0	0
45643690	1125315	0	0
45640393	1129625	0	0
45631295	1119510	0	0
45636017	1125315	0	0
45624078	1112807	0	0
45778251	1501700	0	0
45669996	46275916	1	1
45778670	1129625	0	0
45630790	1177480	0	0
45652065	1125315	0	0
45896882	1125315	0	0
45700254	1177480	0	0
45684509	1125315	0	0
45785504	1107830	0	0
46243013	1125315	0	0
45792008	1125315	0	0
45790674	1125315	0	0
45794272	1112807	0	0
46306555	1322184	0	0
45897090	1118084	0	0
4001377	4163971	2	2
21000075	46233710	2	3
4169307	4302207	2	2
21004864	1110410	0	0
21491100	3023103	2	2
36158455	1129625	0	0
36155989	1545958	0	0
42803730	1713332	0	0
40783186	3027970	4	4
44359165	1125315	0	0
45619776	723013	0	0
45652430	1501700	0	0
45643422	1125315	0	0
45640424	1129625	0	0
45631309	1119510	0	0
45636268	1125315	0	0
45623954	1112807	0	0
45778326	967823	0	0
45669996	19079524	1	1
45778894	1129625	0	0
45630714	1177480	0	0
45652072	1125315	0	0
45896883	1125315	0	0
45896849	1177480	0	0
45684834	1125315	0	0
45785682	738818	0	0
46243220	1125315	0	0
45792013	1125315	0	0
45790355	1125315	0	0
45791465	1112807	0	0
46321710	1551099	0	0
45897013	1177480	0	0
133835	133834	2	2
21001380	19075001	2	3
4169307	4306014	2	2
21004865	1361711	0	0
21491100	3016723	2	2
36158495	1129625	0	0
36156033	1332418	0	0
42803732	1501700	0	0
40783186	3035995	4	4
44359166	1125315	0	0
45619735	1501700	0	0
45652359	1551099	0	0
45643749	1125315	0	0
45640442	1129625	0	0
45631316	1119510	0	0
45636276	1125315	0	0
45623798	1112807	0	0
45778402	1332418	0	0
45673937	19079524	1	1
45778657	1129625	0	0
45630819	1177480	0	0
45651815	1125315	0	0
45896889	1125315	0	0
45697455	1177480	0	0
45684724	1125315	0	0
45785647	914335	0	0
46243224	1125315	0	0
45791865	1125315	0	0
45790405	1125315	0	0
45791386	1112807	0	0
46321779	1124300	0	0
45897016	19002770	0	0
81902	4056621	2	2
21001425	1551192	2	3
4169307	442116	2	2
21005429	1153428	0	0
21601179	967823	2	2
36158513	1177480	0	0
35707989	440448	0	0
42803733	1326303	0	0
40783186	3028833	4	4
44359294	1125315	0	0
45619750	1112807	0	0
45652608	791967	0	0
45643761	1125315	0	0
45637464	1129625	0	0
45633921	1119510	0	0
45636229	1125315	0	0
45623866	1112807	0	0
45778101	1192710	0	0
45673910	19079524	1	1
45778753	1129625	0	0
45630826	1177480	0	0
45697849	1125315	0	0
45896855	1125315	0	0
45697509	1177480	0	0
45684990	1125315	0	0
45785726	1322184	0	0
46243160	1125315	0	0
45791871	1125315	0	0
45790527	1125315	0	0
45791589	1112807	0	0
46321768	723013	0	0
45897018	975125	0	0
81902	198199	2	2
21001054	40232448	2	3
4169307	439406	2	2
21005429	738818	0	0
21600492	1000560	2	2
36158513	1192710	0	0
35708083	30753	0	0
42803752	1501700	0	0
40786257	3010813	4	4
44358892	1125315	0	0
45619754	1305058	0	0
45652176	1149380	0	0
45643647	1125315	0	0
45637475	1129625	0	0
45633925	1119510	0	0
45635855	1125315	0	0
45623697	1112807	0	0
45660966	1107830	0	0
45689103	19079524	1	1
45778870	1129625	0	0
45630816	1177480	0	0
45700643	1125315	0	0
45896891	1125315	0	0
45894727	1177480	0	0
45684821	1125315	0	0
45785727	1112807	0	0
46243167	1125315	0	0
45792039	1125315	0	0
45790463	1125315	0	0
45791667	1112807	0	0
46321736	1326303	0	0
45897084	1332418	0	0
3026023	3014576	2	2
21000050	46233710	2	3
4169307	4169137	2	2
21005679	1713332	0	0
21601153	967823	2	2
36158215	738818	0	0
35708044	81893	0	0
42803857	1000560	0	0
40789534	3009201	4	4
44359011	1125315	0	0
45619719	708298	0	0
45652124	1332418	0	0
45645980	1125315	0	0
45637100	1129625	0	0
45633901	1119510	0	0
45636175	1125315	0	0
45667997	1112807	0	0
45660967	1713332	0	0
45698509	19079524	1	1
45707540	1129625	0	0
45630929	1177480	0	0
45700723	1125315	0	0
45896894	1125315	0	0
45894790	1177480	0	0
45684924	1125315	0	0
45785732	1549786	0	0
46243173	1125315	0	0
45791978	1125315	0	0
45790638	1125315	0	0
45788893	1112807	0	0
46321959	1107830	0	0
45897174	1112807	0	0
3026023	3019550	2	2
21000050	46233988	2	3
4169307	4304110	2	2
21005680	1713332	0	0
21490931	3014576	2	2
36158218	1115008	0	0
35707858	192671	0	0
42803596	723013	0	0
40772935	3024561	4	4
44359304	1125315	0	0
45619756	1539403	0	0
45652176	1137529	0	0
45640699	1125315	0	0
45637550	1129625	0	0
45633842	1119510	0	0
45636162	1125315	0	0
45670351	1112807	0	0
45660973	1343916	0	0
45633125	46275916	1	1
45707177	1129625	0	0
45631065	1177480	0	0
45648717	1125315	0	0
45896861	1125315	0	0
45694674	1177480	0	0
45684726	1125315	0	0
45785732	19127890	0	0
46243052	1125315	0	0
45791078	1125315	0	0
45790647	1125315	0	0
45789112	1112807	0	0
46321783	1738521	0	0
45897176	1307863	0	0
3026023	3023103	2	2
21000485	19007333	2	3
4169307	4048169	2	2
21005429	1107830	0	0
21490931	3009542	2	2
36158221	1107830	0	0
35707864	192671	0	0
42803662	740275	0	0
36718595	4029498	4	4
44359306	1125315	0	0
45619759	1177480	0	0
45652540	1778162	0	0
45640709	1125315	0	0
45637558	1129625	0	0
45633844	1119510	0	0
45635924	1125315	0	0
45668324	1112807	0	0
45661706	19127890	0	0
45673325	19079524	1	1
45707438	1129625	0	0
45631099	1177480	0	0
45648731	1125315	0	0
45697346	1125315	0	0
45694824	1177480	0	0
45684727	1125315	0	0
45785732	1515774	0	0
46243122	1125315	0	0
45791085	1125315	0	0
45790652	1125315	0	0
46301922	1112807	0	0
46321788	1310149	0	0
45897160	1154029	0	0
3026023	3015632	2	2
21000110	19129655	2	3
4169307	4102123	2	2
21005429	1129625	0	0
21490931	3006322	2	2
36158400	1107830	0	0
36211270	4218389	0	0
42803605	920293	0	0
40786267	3010813	4	4
44359093	1125315	0	0
45619857	1153428	0	0
45652541	753626	0	0
45640726	1125315	0	0
45637160	1129625	0	0
45631382	1119510	0	0
45635932	1125315	0	0
45668365	1112807	0	0
45661706	1549786	0	0
45704630	46275916	1	1
45707310	1129625	0	0
45676393	1177480	0	0
45648496	1125315	0	0
45697116	1125315	0	0
45694749	1177480	0	0
45681602	1125315	0	0
45785737	1549786	0	0
46243125	1125315	0	0
45791189	1125315	0	0
45790576	1125315	0	0
46299178	1112807	0	0
46315732	1124957	0	0
45897161	1343916	0	0
3026023	3045716	2	2
21001028	19123231	2	3
4169307	4139681	2	2
21005418	1149380	0	0
21490931	3006906	2	2
36158410	1107830	0	0
36211215	375671	0	0
42803809	1154343	0	0
40786267	3026361	4	4
44351888	1125315	0	0
45619858	1177480	0	0
45652683	1107830	0	0
45640970	1125315	0	0
45637188	1129625	0	0
45631424	1119510	0	0
45635938	1125315	0	0
45665752	1112807	0	0
45661706	1512674	0	0
45698673	46275916	1	1
45707682	1129625	0	0
45628258	1177480	0	0
45648504	1125315	0	0
45697120	1125315	0	0
45694194	1177480	0	0
45681373	1125315	0	0
45785739	705944	0	0
46243126	1125315	0	0
46294624	1125315	0	0
45790422	1125315	0	0
46299586	1112807	0	0
46316385	1539403	0	0
45897164	1738521	0	0
3022035	3014576	2	2
21001028	40236446	2	3
4040400	4218408	2	2
21005429	1149196	0	0
21505608	1361711	2	2
36158417	1192710	0	0
36211224	4132546	0	0
42803609	1551099	0	0
40782957	3026361	4	4
44352027	1125315	0	0
45619935	1539403	0	0
45652610	1729720	0	0
45641039	1125315	0	0
45639940	1129625	0	0
45628143	1119510	0	0
45636021	1125315	0	0
45666030	1112807	0	0
45661707	920293	0	0
45697227	19079524	1	1
45707489	1129625	0	0
45628166	1177480	0	0
45648779	1125315	0	0
45697223	1125315	0	0
45694221	1177480	0	0
45681385	1125315	0	0
45785562	1539403	0	0
46243128	1125315	0	0
46294894	1125315	0	0
45790661	1125315	0	0
46299596	1112807	0	0
46316467	1501700	0	0
45897267	1551099	0	0
3022035	3023103	2	2
21000054	19129655	2	3
4083964	4296204	2	2
21005429	1192710	0	0
21500419	914335	2	2
36157956	1521369	0	0
36211455	4296204	0	0
42803698	1308738	0	0
40782957	3007461	4	4
44352051	1125315	0	0
45619808	914335	0	0
45652613	1107830	0	0
45641060	1125315	0	0
45634207	1129625	0	0
45628146	1119510	0	0
45632981	1125315	0	0
45666135	1112807	0	0
45661646	1361711	0	0
45695126	19079524	1	1
45707585	1129625	0	0
45627856	1177480	0	0
45648853	1125315	0	0
45697436	1125315	0	0
45694531	1177480	0	0
45682613	1125315	0	0
45785552	967823	0	0
46244644	1125315	0	0
46294399	1125315	0	0
45790448	1125315	0	0
46301613	1112807	0	0
46316280	1738521	0	0
45897271	1129625	0	0
3022035	3019550	2	2
21000059	19129655	2	3
4181192	4295880	2	2
21006489	1112807	0	0
21602882	1778162	2	2
36157958	1149380	0	0
36156071	1112807	0	0
42803821	1501700	0	0
40782957	3024561	4	4
44352053	1125315	0	0
44364329	1112807	0	0
45652369	1713332	0	0
45640957	1125315	0	0
45634332	1129625	0	0
45628558	1119510	0	0
45632663	1125315	0	0
45663628	1112807	0	0
45661649	738818	0	0
45689489	19134077	1	1
45707425	1129625	0	0
45627942	1177480	0	0
45648752	1125315	0	0
45697393	1125315	0	0
45694470	1177480	0	0
45682629	1125315	0	0
45785569	738818	0	0
46244713	1125315	0	0
46294636	1125315	0	0
45790485	1125315	0	0
46295502	1112807	0	0
46316373	1521369	0	0
45897273	715997	0	0
3022035	3015632	2	2
21000059	46233988	2	3
4029698	4330583	2	2
21005418	975125	0	0
21500375	40169281	2	2
36157962	1107830	0	0
36156051	1000560	0	0
42803819	1548195	0	0
37622411	4310024	4	4
44352199	1125315	0	0
44361443	1129625	0	0
45652229	1501700	0	0
45640996	1125315	0	0
45634126	1129625	0	0
45628577	1119510	0	0
45632996	1125315	0	0
45663701	1112807	0	0
45661341	1539403	0	0
45686464	46275916	1	1
45707419	1129625	0	0
45676212	1177480	0	0
45648754	1125315	0	0
45697394	1125315	0	0
45694235	1177480	0	0
45682579	1125315	0	0
45785519	975125	0	0
46244717	1125315	0	0
46294831	1125315	0	0
45790486	1125315	0	0
46295717	1112807	0	0
46316373	1548195	0	0
45897237	1589505	0	0
3022035	3045716	2	2
21000059	46233710	2	3
4029698	4242997	2	2
21005429	1150836	0	0
21503963	1125315	2	2
36158469	705944	0	0
36156107	1551099	0	0
42803932	1000560	0	0
37602360	4324181	4	4
44355217	1125315	0	0
44360994	1326303	0	0
45652728	914335	0	0
45640997	1125315	0	0
45634507	1129625	0	0
45628181	1119510	0	0
45633987	1125315	0	0
45663340	1112807	0	0
45661656	1124957	0	0
45686674	46275916	1	1
45704626	1129625	0	0
45624508	1177480	0	0
45648785	1125315	0	0
45697397	1125315	0	0
45694313	1177480	0	0
45682601	1125315	0	0
45785619	1519936	0	0
46244718	1125315	0	0
46294921	1125315	0	0
45790742	1125315	0	0
46296022	1112807	0	0
46315829	1112807	0	0
45897198	1332418	0	0
378125	4043241	2	2
21000057	46233988	2	3
4042150	4199276	2	2
21005672	1310149	0	0
21503963	1112807	2	2
36158471	1000560	0	0
36156108	1332418	0	0
42803705	975125	0	0
40772922	3005136	4	4
44355222	1125315	0	0
44361401	715997	0	0
45652275	1713332	0	0
45640888	1125315	0	0
45634456	1129625	0	0
45628512	1119510	0	0
45633974	1125315	0	0
45660205	1112807	0	0
45661439	1332418	0	0
45686687	19079524	1	1
45704872	1129625	0	0
45624673	1177480	0	0
45648787	1125315	0	0
45697450	1125315	0	0
45691302	1177480	0	0
45681714	1125315	0	0
45785570	1551099	0	0
46240819	1125315	0	0
46294925	1125315	0	0
45790586	1125315	0	0
46295328	1112807	0	0
46315837	1102527	0	0
45897295	1174888	0	0
377091	380378	2	2
21000057	46233710	2	3
4096864	81893	6	7
21005779	1551099	0	0
21503963	1129625	2	2
36158473	975125	0	0
36156135	1000560	0	0
42803846	1154343	0	0
37604009	321042	4	4
44355461	1125315	0	0
44360997	1124957	0	0
45652278	1153428	0	0
45640935	1125315	0	0
45634588	1129625	0	0
45628491	1119510	0	0
45634062	1125315	0	0
45660375	1112807	0	0
45661767	1192710	0	0
45680193	46275916	1	1
45704966	1129625	0	0
45624797	1177480	0	0
45648972	1125315	0	0
45697262	1125315	0	0
45802604	1177480	0	0
45681806	1125315	0	0
45785608	1112807	0	0
46241080	1125315	0	0
46294808	1125315	0	0
45790701	1125315	0	0
46296247	1112807	0	0
46316047	1174888	0	0
45897340	1119510	0	0
378419	4043241	2	2
21001022	40236446	2	3
4182161	4048171	6	7
21006489	1545958	0	0
21500437	914335	2	2
36158475	1548195	0	0
36156137	1551099	0	0
42803571	1551099	0	0
37604009	381316	4	4
44355406	1125315	0	0
44360940	1192710	0	0
45652486	1149196	0	0
45641180	1125315	0	0
45634590	1129625	0	0
45628355	1119510	0	0
45633957	1125315	0	0
45660472	1112807	0	0
45661775	1501700	0	0
45679694	46275916	1	1
45705028	1129625	0	0
45624816	1177480	0	0
45648624	1125315	0	0
45697355	1125315	0	0
45802541	1177480	0	0
45681727	1125315	0	0
45785615	1539403	0	0
46240867	1125315	0	0
46294937	1125315	0	0
45790860	1125315	0	0
46296152	1112807	0	0
46316398	975125	0	0
45897342	1326303	0	0
321588	4329847	2	3
21001057	40232448	2	3
4185503	313217	6	7
21006489	1539403	0	0
21505647	738818	2	2
36158478	1149196	0	0
36156140	1713332	0	0
42803983	1551099	0	0
40785842	3026361	4	4
44355464	1125315	0	0
44361446	1129625	0	0
45652487	1192710	0	0
45640939	1125315	0	0
45631209	1129625	0	0
45625450	1119510	0	0
45633993	1125315	0	0
45654226	1112807	0	0
45661490	1717327	0	0
45671187	46275916	1	1
45701121	1129625	0	0
45625003	1177480	0	0
45649084	1125315	0	0
45697365	1125315	0	0
45802406	1177480	0	0
45681842	1125315	0	0
45785915	757627	0	0
46240868	1125315	0	0
46294175	1125315	0	0
45790868	1125315	0	0
46244695	1112807	0	0
46316407	1545958	0	0
45894756	1129625	0	0
1766436	46275916	2	3
21000083	19074841	2	3
4043182	4198190	6	7
21601161	967823	0	0
21505647	1129625	2	2
36158501	1124957	0	0
36156121	920293	0	0
42803716	1548195	0	0
40783188	3027970	4	4
44352442	1125315	0	0
44361450	1177480	0	0
45652488	1549786	0	0
45641106	1125315	0	0
45631312	1129625	0	0
45625378	1119510	0	0
45634033	1125315	0	0
45654148	1112807	0	0
45661502	1343916	0	0
45671222	19074679	1	1
45701253	1129625	0	0
45670673	1177480	0	0
45649088	1125315	0	0
45697369	1125315	0	0
45688452	1177480	0	0
45681729	1125315	0	0
45785660	1746114	0	0
46240999	1125315	0	0
46294362	1125315	0	0
45790916	1125315	0	0
46244638	1112807	0	0
46316440	1326303	0	0
45894763	1177480	0	0
78831	81151	2	3
21000083	19075001	2	3
4040400	4198190	6	7
21601180	967823	0	0
21500489	933724	2	2
36158484	1118084	0	0
36155890	975125	0	0
42803572	1000560	0	0
40783188	3024561	4	4
44352420	1125315	0	0
44361450	1174888	0	0
45652488	19127890	0	0
45641010	1125315	0	0
45631557	1129625	0	0
45625497	1119510	0	0
45659022	1119510	0	0
45654501	1112807	0	0
45661503	914335	0	0
45670516	46275916	1	1
45701209	1129625	0	0
45670523	1177480	0	0
45649094	1125315	0	0
45697421	1125315	0	0
45688466	1177480	0	0
45681780	1125315	0	0
45785660	1741122	0	0
46240870	1125315	0	0
46294957	1125315	0	0
45790956	1125315	0	0
46244640	1112807	0	0
46316427	933724	0	0
45894791	1177480	0	0
1347450	40220960	2	3
21000083	19133905	2	3
4101796	4043241	6	7
21502623	1713332	0	0
21503968	1125315	2	2
36158485	1124300	0	0
36155893	791967	0	0
42803968	705944	0	0
40782937	3012494	4	4
44352551	1125315	0	0
44361452	933724	0	0
45652291	1110410	0	0
45637567	1125315	0	0
45628561	1129625	0	0
45625290	1119510	0	0
45659125	1119510	0	0
45654482	1112807	0	0
45661806	1332418	0	0
45707864	46275916	1	1
45703450	1129625	0	0
45670537	1177480	0	0
45649154	1125315	0	0
45697521	1125315	0	0
45688382	1177480	0	0
45681790	1125315	0	0
45785861	1115008	0	0
46240882	1125315	0	0
46294430	1125315	0	0
45790571	1125315	0	0
46240008	1112807	0	0
46316444	1000560	0	0
45894834	920293	0	0
1101352	19126352	2	3
21000083	19073188	2	3
4042140	375671	6	10
21502628	1728416	0	0
21503968	1112807	2	2
36158490	1115008	0	0
36155894	723013	0	0
42803945	1000560	0	0
40782937	3001247	4	4
44352602	1125315	0	0
44361403	1115008	0	0
44344272	738818	0	0
45637614	1125315	0	0
45628570	1129625	0	0
45625707	1119510	0	0
45659288	1119510	0	0
45651899	1112807	0	0
45661146	1124957	0	0
45707882	46275916	1	1
45703403	1129625	0	0
45670484	1177480	0	0
45645959	1125315	0	0
45894486	1125315	0	0
45800015	1177480	0	0
45681927	1125315	0	0
45785796	1149196	0	0
46240888	1125315	0	0
46294972	1125315	0	0
45790927	1125315	0	0
46240070	1112807	0	0
46316635	1112807	0	0
45894799	19010482	0	0
782043	782047	2	3
21000083	19133873	2	3
4083964	78272	6	6
21502630	1741122	0	0
21500296	1343916	2	2
36158504	1308738	0	0
36156161	1129625	0	0
42803984	1545958	0	0
37604032	321042	4	4
44352592	1125315	0	0
44361462	975125	0	0
44344273	1343916	0	0
45637575	1125315	0	0
45628633	1129625	0	0
45625640	1119510	0	0
45659135	1119510	0	0
45650925	1112807	0	0
45661154	1107830	0	0
45708020	19079524	1	1
45701656	1129625	0	0
45670365	1177480	0	0
45645996	1125315	0	0
45894709	1125315	0	0
45799986	1177480	0	0
45681939	1125315	0	0
45785929	1713332	0	0
46240749	1125315	0	0
46294677	1125315	0	0
45790786	1125315	0	0
45896708	1112807	0	0
46316656	1149196	0	0
45894567	738818	0	0
836654	836659	2	3
21000083	19129655	2	3
4300157	4134304	6	6
21502656	933724	0	0
21601160	967823	2	2
36158516	1177480	0	0
36156186	1713332	0	0
42803718	1501700	0	0
37604032	4163874	4	4
44352599	1125315	0	0
44361374	1112807	0	0
44344589	1307863	0	0
45637577	1125315	0	0
45628539	1129625	0	0
45625601	1119510	0	0
45659252	1119510	0	0
45651057	1112807	0	0
45661130	1174888	0	0
45633075	1125315	0	0
45698316	1129625	0	0
45669303	1177480	0	0
45646172	1125315	0	0
45694981	1125315	0	0
45799793	1177480	0	0
45681941	1125315	0	0
45785929	1759842	0	0
46240836	1125315	0	0
46294680	1125315	0	0
45790687	1125315	0	0
45896575	1112807	0	0
46316700	1713332	0	0
45894571	1112807	0	0
4002905	4285898	2	3
21000480	1551192	2	3
4101796	375671	6	6
21500371	1149380	0	0
21492840	21494966	2	2
36158520	933724	0	0
36155991	1343916	0	0
42803670	1713332	0	0
40481352	4058899	4	4
44352503	1125315	0	0
44361376	738818	0	0
44344528	738818	0	0
45662059	1310149	0	0
45628480	1129625	0	0
45625603	1119510	0	0
45659178	1119510	0	0
45650906	1112807	0	0
45661181	723013	0	0
45633070	1125315	0	0
45698446	1129625	0	0
45669262	1177480	0	0
45646338	1125315	0	0
45694872	1125315	0	0
45799825	1177480	0	0
45681735	1125315	0	0
45785932	1717327	0	0
46240960	1125315	0	0
46294767	1125315	0	0
45790990	1125315	0	0
45896561	1112807	0	0
46316712	1112807	0	0
45894840	19003953	0	0
1766606	19008572	2	3
21001385	19129655	2	3
4043350	4168004	6	6
21500409	1177480	0	0
35102033	439777	2	2
36158527	1332418	0	0
36155992	1110410	0	0
42803915	1713332	0	0
40481352	4047491	4	4
44352806	1125315	0	0
44360942	1149380	0	0
44344529	933724	0	0
45662024	1107830	0	0
45628307	1129625	0	0
45625751	1119510	0	0
45659325	1119510	0	0
45651091	1112807	0	0
45661183	1361711	0	0
45633064	1125315	0	0
45698448	1129625	0	0
45669314	1177480	0	0
45645677	1125315	0	0
45694190	1125315	0	0
45800191	1177480	0	0
45681860	1125315	0	0
45785667	1000560	0	0
46240961	1125315	0	0
46296634	1125315	0	0
45790995	1125315	0	0
46317431	1112807	0	0
46316346	1112807	0	0
45894843	1500211	0	0
1551099	1551192	2	3
21001385	19073188	2	3
4042150	4330583	6	6
21013795	1110410	0	0
21500416	967823	2	2
36158533	1177480	0	0
36155995	920293	0	0
42803915	1759842	0	0
37203779	317576	4	4
44352453	1125315	0	0
44361193	1115008	0	0
44344539	967823	0	0
45662023	1501700	0	0
45628728	1129625	0	0
45622067	1119510	0	0
45659327	1119510	0	0
45650998	1112807	0	0
45661163	1115008	0	0
45633122	1125315	0	0
45698456	1129625	0	0
45666882	1177480	0	0
45645587	1125315	0	0
45694285	1125315	0	0
45685678	1177480	0	0
45681973	1125315	0	0
45785913	1115008	0	0
46240949	1125315	0	0
46244043	1125315	0	0
46297464	1125315	0	0
46317768	1112807	0	0
46316346	1192710	0	0
45894846	1129625	0	0
376106	381316	2	3
21001385	19133905	2	3
4042150	4242997	6	6
21013786	1728416	0	0
21500259	1343916	2	2
36154376	1174888	0	0
36156001	738818	0	0
42802880	1119510	0	0
37203779	321042	4	4
44352639	1125315	0	0
44361366	1551099	0	0
44344148	1124300	0	0
45662154	1332418	0	0
45625169	1129625	0	0
45622128	1119510	0	0
45656835	1119510	0	0
45647758	1112807	0	0
45661217	1124300	0	0
45633090	1125315	0	0
45698689	1129625	0	0
45666924	1177480	0	0
45645589	1125315	0	0
45694195	1125315	0	0
45685296	1177480	0	0
45678453	1125315	0	0
45785676	1107830	0	0
46241059	1125315	0	0
46244045	1125315	0	0
46297721	1125315	0	0
45794380	1112807	0	0
46316543	1713332	0	0
45894849	1119510	0	0
376106	4066995	2	3
21001385	19074843	2	3
4134598	4163971	6	6
21013767	914335	0	0
21500270	1539403	2	2
36154347	1129625	0	0
36156226	1177480	0	0
42802880	738818	0	0
37302323	4113008	4	4
44352478	1125315	0	0
44361372	1174888	0	0
44344082	1115008	0	0
45662157	19127890	0	0
45625301	1129625	0	0
45622164	1119510	0	0
45657237	1119510	0	0
45648044	1112807	0	0
45661219	1192710	0	0
45633148	1125315	0	0
45698693	1129625	0	0
45667106	1177480	0	0
45645655	1125315	0	0
45694303	1125315	0	0
45685350	1177480	0	0
45678574	1125315	0	0
45785716	740275	0	0
46240953	1125315	0	0
46244046	1125315	0	0
46297640	1125315	0	0
45794436	1112807	0	0
46316543	1759842	0	0
45894851	1119510	0	0
1766448	1107882	2	3
21001385	19073183	2	3
4042150	4323902	5	6
21013768	914335	0	0
21500270	1112807	2	2
36154367	1000560	0	0
36156227	1154029	0	0
42802880	1125315	0	0
37302323	4109685	4	4
44352630	1125315	0	0
44361547	1124957	0	0
44344086	1153428	0	0
45662157	1512674	0	0
45625419	1129625	0	0
45622319	1119510	0	0
45657291	1119510	0	0
45647969	1112807	0	0
45661155	708298	0	0
45633151	1125315	0	0
45698571	1129625	0	0
45778449	1177480	0	0
45645886	1125315	0	0
45694230	1125315	0	0
45685528	1177480	0	0
45678796	1125315	0	0
45785747	1112807	0	0
46241090	1125315	0	0
46244048	1125315	0	0
46297191	1125315	0	0
46306918	1112807	0	0
46316545	791967	0	0
45894852	1551099	0	0
376337	44782520	2	3
21001385	19075001	2	3
4096864	4285898	5	6
21013805	1308738	0	0
21503472	967823	2	2
36154512	1177480	0	0
36156228	1118084	0	0
42803046	1119510	0	0
37302323	4152936	4	4
42802984	1125315	0	0
44361548	1129625	0	0
44344673	1738521	0	0
45662157	1549786	0	0
45625728	1129625	0	0
45622507	1119510	0	0
45657115	1119510	0	0
45647865	1112807	0	0
45661116	1343916	0	0
45676759	1125315	0	0
45698260	1129625	0	0
45639424	19128263	1	2
45645710	1125315	0	0
45694342	1125315	0	0
45685255	1177480	0	0
45678730	1125315	0	0
45785772	1192710	0	0
46241067	1125315	0	0
46244078	1125315	0	0
46297754	1125315	0	0
46307055	1112807	0	0
46316729	757627	0	0
45894853	1192710	0	0
1778162	19075001	2	3
21000056	46233710	2	3
4182161	4294548	5	6
21013911	723013	0	0
21600491	1000560	2	2
36154514	1332418	0	0
36156193	1738521	0	0
42802814	1332418	0	0
37019275	45769019	4	4
42802731	1125315	0	0
44361584	1118084	0	0
44344590	1545958	0	0
45662158	1332418	0	0
45625472	1129625	0	0
45622377	1119510	0	0
45657174	1119510	0	0
45644778	1112807	0	0
45661119	1154029	0	0
45676449	1125315	0	0
45698592	1129625	0	0
45627251	19128022	3	4
45645611	1125315	0	0
45694349	1125315	0	0
45685426	1177480	0	0
45678667	1125315	0	0
45785776	975125	0	0
46241069	1125315	0	0
46244092	1125315	0	0
46297417	1125315	0	0
46307064	1112807	0	0
46316216	1332418	0	0
45894888	1119510	0	0
1101498	19078461	2	3
21000056	46233988	2	3
4182161	4280726	5	6
21013820	1124957	0	0
21500355	1119510	2	2
36154245	1112807	0	0
36156195	1129625	0	0
42802819	1125315	0	0
37203784	40486433	4	4
42802914	1125315	0	0
44361671	1107830	0	0
44344679	920293	0	0
45662112	1000560	0	0
45625549	1129625	0	0
45620938	1119510	0	0
45657260	1119510	0	0
45644995	1112807	0	0
45661175	1115008	0	0
45676458	1125315	0	0
45698607	1129625	0	0
45633494	19133679	3	4
45645745	1125315	0	0
45694479	1125315	0	0
45685527	1177480	0	0
45678875	1125315	0	0
45785777	920293	0	0
46241098	1125315	0	0
46244100	1125315	0	0
46297345	1125315	0	0
46307236	1112807	0	0
46316192	1738521	0	0
45894645	1119510	0	0
1000560	35605482	2	3
21000082	19133873	2	3
4182161	40486433	5	6
21013795	1124957	0	0
21601167	967823	2	2
36154332	1112807	0	0
36156196	1361711	0	0
42802819	1124957	0	0
37203784	4280726	4	4
42802868	1125315	0	0
44361702	738818	0	0
44344683	1545958	0	0
45662136	975125	0	0
45625807	1129625	0	0
45621030	1119510	0	0
45657491	1119510	0	0
45644884	1112807	0	0
45661221	1332418	0	0
45676826	1125315	0	0
45698799	1129625	0	0
45708291	19128009	2	2
45645723	1125315	0	0
45694485	1125315	0	0
45799694	1177480	0	0
45678899	1125315	0	0
45785779	738818	0	0
46240622	1125315	0	0
46244101	1125315	0	0
46297562	1125315	0	0
46307969	1112807	0	0
46316555	1107830	0	0
45894646	1192710	0	0
1549786	44816277	2	3
21000082	19073183	2	3
4043346	313217	5	6
21013820	1174888	0	0
21601194	967823	2	2
36154378	1738521	0	0
36156197	1738521	0	0
42802827	1149196	0	0
40786239	3023430	4	4
44344956	1125315	0	0
44361116	1713332	0	0
44344593	1192710	0	0
45662205	723013	0	0
45625633	1129625	0	0
45621153	1119510	0	0
45657398	1119510	0	0
45645032	1112807	0	0
45661317	1539403	0	0
45676633	1125315	0	0
45697311	1129625	0	0
45708291	19127918	2	2
45645815	1125315	0	0
45694613	1125315	0	0
45797331	1177480	0	0
45678828	1125315	0	0
45785867	1112807	0	0
46240732	1125315	0	0
46244104	1125315	0	0
46297421	1125315	0	0
46302160	1112807	0	0
46310551	1174888	0	0
45894825	1129625	0	0
1549786	43012433	2	3
21000082	19075001	2	3
4042516	4047491	5	6
21013820	1154029	0	0
21504520	19132304	2	2
36154290	1738521	0	0
36156200	1177480	0	0
42802829	1129625	0	0
37220016	4048171	4	4
44344798	1125315	0	0
44360952	1713332	0	0
44344600	723013	0	0
45662071	1110410	0	0
45625748	1129625	0	0
45621046	1119510	0	0
45657401	1119510	0	0
45645114	1112807	0	0
45661460	1738521	0	0
45676802	1125315	0	0
45695171	1129625	0	0
45683963	19128009	2	2
45645695	1125315	0	0
45694458	1125315	0	0
45797412	1177480	0	0
45678830	1125315	0	0
45785881	1115008	0	0
46240641	1125315	0	0
46244114	1125315	0	0
46297649	1125315	0	0
46302018	1112807	0	0
46310616	1501700	0	0
45894830	1129625	0	0
1101405	1551192	2	3
21000082	19073188	2	3
4030654	4198190	5	7
21013820	1110410	0	0
21504520	46221626	2	2
36154317	1124957	0	0
36156201	1129625	0	0
42802829	1125315	0	0
37203771	40481087	4	4
44344986	1125315	0	0
44361554	1177480	0	0
44344477	1149380	0	0
45662076	1539403	0	0
45622139	1129625	0	0
45620770	1119510	0	0
45655376	1119510	0	0
45645057	1112807	0	0
45661359	1548195	0	0
45676550	1125315	0	0
45695421	1129625	0	0
45683963	19127918	2	2
45645702	1125315	0	0
45694425	1125315	0	0
45797378	1177480	0	0
45672509	1125315	0	0
45785713	1549786	0	0
46240625	1125315	0	0
46244064	1125315	0	0
46297656	1125315	0	0
46302451	1112807	0	0
46310726	1309944	0	0
45894608	1107830	0	0
1343916	1594382	2	3
21000082	19074841	2	3
4042140	4112343	5	10
21013911	791967	0	0
21505615	1343916	2	2
36154609	1713332	0	0
36156203	1112807	0	0
42802921	1107830	0	0
37502338	4057420	4	4
44345104	1125315	0	0
44361381	1177480	0	0
44344479	1118084	0	0
45662106	708298	0	0
45622146	1129625	0	0
45621086	1119510	0	0
45655462	1119510	0	0
45645298	1112807	0	0
45661365	1115008	0	0
45676495	1125315	0	0
45691793	1129625	0	0
45677773	19128009	2	2
45645786	1125315	0	0
45694606	1125315	0	0
45797384	1177480	0	0
45672421	1125315	0	0
45785713	1595799	0	0
46240634	1125315	0	0
46244021	1125315	0	0
46297658	1125315	0	0
46306580	1112807	0	0
46310794	975125	0	0
45894895	1177480	0	0
1343916	46275916	2	3
21000082	19133905	2	3
4042140	40486433	5	10
21013911	708298	0	0
21505600	975125	2	2
36154609	1759842	0	0
36156204	1129625	0	0
42802985	1129625	0	0
37203772	4048171	4	4
44345112	1125315	0	0
44361587	1557272	0	0
44344711	1332418	0	0
45662014	1174888	0	0
45622297	1129625	0	0
45621197	1119510	0	0
45655423	1119510	0	0
45642290	1112807	0	0
45661279	1153428	0	0
45676925	1125315	0	0
45692129	1129625	0	0
45694364	19128009	2	2
45645770	1125315	0	0
45694687	1125315	0	0
45682439	1177480	0	0
45672544	1125315	0	0
45785713	1521369	0	0
46240845	1125315	0	0
46244075	1125315	0	0
46297663	1125315	0	0
46306841	1112807	0	0
46310799	1124957	0	0
45894616	1124957	0	0
376208	4310024	2	4
21000478	1551192	2	3
4180627	4336464	5	10
21013864	1112807	0	0
21505600	1589505	2	2
36154715	1129625	0	0
36156206	738818	0	0
42802986	1129625	0	0
37203772	258780	4	4
44345010	1125315	0	0
44361591	1177480	0	0
44344196	1539403	0	0
45662172	1521369	0	0
45622466	1129625	0	0
45621159	1119510	0	0
45653955	1119510	0	0
45639079	1112807	0	0
45661327	914335	0	0
45676926	1125315	0	0
45692322	1129625	0	0
45683640	42902245	2	2
45645825	1125315	0	0
45802384	1125315	0	0
45682405	1177480	0	0
45673187	1125315	0	0
45785890	1115008	0	0
46238191	1125315	0	0
46244140	1125315	0	0
46297284	1125315	0	0
46299777	1112807	0	0
46310846	975125	0	0
45894695	1129625	0	0
376106	4132546	2	4
21000478	19007333	2	3
4180627	4078793	5	7
21013849	1322184	0	0
21505697	705944	2	2
36154716	1129625	0	0
36156083	1305058	0	0
42802987	1112807	0	0
37521809	4057420	4	4
44345019	1125315	0	0
44360959	715997	0	0
44344696	1107830	0	0
45662268	1738521	0	0
45620867	1129625	0	0
45664704	1119510	0	0
45647482	1119510	0	0
45640149	1112807	0	0
45661403	1153428	0	0
45676805	1125315	0	0
45692175	1129625	0	0
45779549	42902245	2	2
45642679	1125315	0	0
45802513	1125315	0	0
45682505	1177480	0	0
45673188	1125315	0	0
45785985	738818	0	0
46240043	1125315	0	0
46244164	1125315	0	0
46297601	1125315	0	0
46300041	1112807	0	0
46310838	19010482	0	0
45894750	1738521	0	0
440029	4112343	2	5
21000482	19007333	2	3
4134598	4242997	5	5
21013966	1738521	0	0
21500485	914335	2	2
36154509	19003953	0	0
36156168	1713332	0	0
42802989	1112807	0	0
40789541	3036780	4	4
44345024	1125315	0	0
44361423	715997	0	0
44344645	1539403	0	0
45662269	738818	0	0
45620829	1129625	0	0
45664714	1119510	0	0
45647393	1119510	0	0
45635869	1112807	0	0
45777830	1124300	0	0
45676969	1125315	0	0
45692264	1129625	0	0
45695953	19128009	2	2
45642704	1125315	0	0
45802498	1125315	0	0
45794846	1177480	0	0
45673384	1125315	0	0
45785964	1124300	0	0
46240207	1125315	0	0
46244165	1125315	0	0
46297973	1125315	0	0
46300144	1112807	0	0
46310854	1332418	0	0
45894753	1192710	0	0
442628	81151	2	5
21000482	1551192	2	3
4134598	4330583	5	5
21013919	1738521	0	0
21500485	933724	2	2
36154511	1713332	0	0
36156168	1759842	0	0
42802990	1192710	0	0
40760929	3019550	4	4
44344975	1125315	0	0
44361435	1501700	0	0
45646038	1322184	0	0
45662203	715997	0	0
45620837	1129625	0	0
45667171	1119510	0	0
45647398	1119510	0	0
45636011	1112807	0	0
45777849	738818	0	0
45676788	1125315	0	0
45692058	1129625	0	0
45654911	40163554	2	3
45642755	1125315	0	0
45802647	1125315	0	0
45794823	1177480	0	0
45673296	1125315	0	0
45785989	1545958	0	0
46240045	1125315	0	0
46244171	1125315	0	0
46297565	1125315	0	0
46318763	1112807	0	0
46305661	723013	0	0
45894772	1343916	0	0
376208	78272	3	8
21000052	46233988	2	3
4182161	257012	5	5
21601198	967823	0	0
21500460	926487	2	2
36154593	920293	0	0
36156434	1000560	0	0
42802992	1119510	0	0
40782918	3001488	4	4
44345051	1125315	0	0
44361679	1115008	0	0
45646189	1310149	0	0
45662331	1308738	0	0
45620772	1129625	0	0
45667415	1119510	0	0
45647552	1119510	0	0
45656818	975125	0	0
45777823	738818	0	0
45676901	1125315	0	0
45692142	1129625	0	0
45654867	40228214	2	3
45642856	1125315	0	0
45802571	1125315	0	0
45794961	1177480	0	0
45673297	1125315	0	0
45785724	1738521	0	0
46238277	1125315	0	0
46244175	1125315	0	0
46297829	1125315	0	0
46318978	1112807	0	0
46305667	1112807	0	0
45894740	1310149	0	0
376208	81151	3	7
21000052	19129655	2	3
4096864	440448	5	5
21504555	1518198	0	0
21505685	1129625	2	2
36154596	1713332	0	0
36156437	1129625	0	0
42802993	1112807	0	0
37203779	4329847	4	5
44345052	1125315	0	0
44361115	1545958	0	0
45646354	1332418	0	0
45662338	1343916	0	0
45620904	1129625	0	0
45664779	1119510	0	0
45647680	1119510	0	0
45657030	975125	0	0
45654732	1308738	0	0
45676974	1125315	0	0
45694662	1129625	0	0
45654831	40232448	2	3
45642870	1125315	0	0
45688436	1125315	0	0
45679480	1177480	0	0
45673404	1125315	0	0
45785831	1501700	0	0
46238379	1125315	0	0
46244228	1125315	0	0
46297923	1125315	0	0
46318918	1112807	0	0
46305729	975125	0	0
45894741	1129625	0	0
440921	4001336	3	6
21000052	46233710	2	3
4040400	4275113	5	5
21504555	1549786	0	0
21505685	1119510	2	2
36154596	1759842	0	0
36156438	1177480	0	0
42802998	1396131	0	0
37102305	4116491	4	5
44345037	1125315	0	0
44361656	1322184	0	0
45646385	705944	0	0
45662034	1551099	0	0
45621193	1129625	0	0
45664815	1119510	0	0
45647566	1119510	0	0
45657121	975125	0	0
45654756	1551099	0	0
45676953	1125315	0	0
45689151	1129625	0	0
45655016	1115171	2	3
45642904	1125315	0	0
45688459	1125315	0	0
45679344	1177480	0	0
45672726	1125315	0	0
45785829	975125	0	0
46238423	1125315	0	0
46244232	1125315	0	0
46298083	1125315	0	0
46319189	1112807	0	0
46305734	933724	0	0
45894743	1119510	0	0
432250	4112343	3	6
21000051	19129655	2	3
4040400	4242997	5	5
21504516	1125315	0	0
21505685	738818	2	2
36154597	1343916	0	0
36156606	1343916	0	0
42803003	1125315	0	0
36718595	4066995	4	5
44345130	1125315	0	0
44361681	1124300	0	0
45646047	1545958	0	0
45662051	933724	0	0
45620962	1129625	0	0
45664795	1119510	0	0
45647945	1119510	0	0
45657404	975125	0	0
45654774	723013	0	0
45676958	1125315	0	0
45689157	1129625	0	0
45655109	40229134	2	3
45688468	1125315	0	0
45688525	1125315	0	0
45679350	1177480	0	0
45672670	1125315	0	0
45785835	1153428	0	0
46238430	1125315	0	0
46244234	1125315	0	0
46297998	1125315	0	0
46312823	1112807	0	0
46305739	1305058	0	0
45894744	1713332	0	0
432250	4294548	3	6
21000051	46233988	2	3
4086921	4323208	5	5
21504604	1738521	0	0
21505685	1192710	2	2
36154603	1000560	0	0
36156609	708298	0	0
42802922	920293	0	0
36718595	381316	4	5
44345240	1125315	0	0
44361692	1153428	0	0
45646293	1326303	0	0
45662052	738818	0	0
45621015	1129625	0	0
45664796	1119510	0	0
45647738	1119510	0	0
45657218	975125	0	0
45654776	1149196	0	0
45676508	1125315	0	0
45689107	1129625	0	0
45654785	40229134	2	3
45688662	1125315	0	0
45688528	1125315	0	0
45679365	1177480	0	0
45672690	1125315	0	0
46296486	1729720	0	0
46238328	1125315	0	0
46244286	1125315	0	0
46297782	1125315	0	0
46312707	1112807	0	0
46305740	1154343	0	0
45894868	1119510	0	0
376106	4001336	3	5
21000051	46233710	2	3
4049222	4048171	5	5
21504524	975125	0	0
21505685	1174888	2	2
36154605	1343916	0	0
36156610	708298	0	0
42802927	1713332	0	0
37203764	441267	4	5
44345000	1125315	0	0
44361392	1124300	0	0
45645895	1307863	0	0
45662054	1717327	0	0
45664594	1129625	0	0
45664800	1119510	0	0
45647835	1119510	0	0
45657461	975125	0	0
45654889	1310149	0	0
45676977	1125315	0	0
45689210	1129625	0	0
45655250	1539411	2	3
45691237	1125315	0	0
45799878	1125315	0	0
45792034	1177480	0	0
45672713	1125315	0	0
46296489	1149380	0	0
46238280	1125315	0	0
46244289	1125315	0	0
46289301	1125315	0	0
46312650	1112807	0	0
46305742	1332418	0	0
45894814	715997	0	0
432250	4056621	3	5
4322976	4218408	2	5
4040551	4216130	5	5
21504611	1307863	0	0
21505679	1119510	2	2
36154612	1129625	0	0
36156580	1332418	0	0
42803007	1551099	0	0
37604009	4329847	4	5
44338171	1125315	0	0
44361399	1115008	0	0
45645966	1551099	0	0
45662304	19127890	0	0
45664675	1129625	0	0
45664832	1119510	0	0
45644561	1119510	0	0
45654095	975125	0	0
45654891	1310149	0	0
45676941	1125315	0	0
45689213	1129625	0	0
45655294	40232448	2	3
45691309	1125315	0	0
45800012	1125315	0	0
45792395	1177480	0	0
45672645	1125315	0	0
46296268	1551099	0	0
46238361	1125315	0	0
46244216	1125315	0	0
46289062	1125315	0	0
46307982	1112807	0	0
46305600	1000560	0	0
45894819	1149196	0	0
376337	4132546	3	5
4322976	4170947	2	6
4040551	4108705	5	5
21505616	1343916	0	0
21505679	1129625	2	2
36154592	1124300	0	0
36156583	1326303	0	0
40492359	40492359	0	0
37604032	4329847	4	5
44338227	1125315	0	0
44361661	1589505	0	0
45645968	1332418	0	0
45662304	1549786	0	0
45667417	1129625	0	0
45665071	1119510	0	0
45645870	1119510	0	0
45654055	975125	0	0
45654849	975125	0	0
45677021	1125315	0	0
45689448	1129625	0	0
45700976	1551192	2	3
45691388	1125315	0	0
45800016	1125315	0	0
45676144	1177480	0	0
45672719	1125315	0	0
46296273	1112807	0	0
46238368	1125315	0	0
46244371	1125315	0	0
46289159	1125315	0	0
46307453	1112807	0	0
46305617	1118084	0	0
45896562	1174888	0	0
133468	78272	3	5
4322976	4163951	2	6
4185503	4142905	5	5
21505633	1112807	0	0
21505679	738818	2	2
36154359	1154343	0	0
36156612	1343916	0	0
40224805	40224805	0	0
37604032	4310024	4	5
44338125	1125315	0	0
44361661	19127890	0	0
45646397	1124300	0	0
45662305	1137529	0	0
45664803	1129625	0	0
45662147	1119510	0	0
45646102	1119510	0	0
45654169	975125	0	0
45654884	1551099	0	0
45677117	1125315	0	0
45689351	1129625	0	0
45701613	19059056	2	3
45639811	1125315	0	0
45799990	1125315	0	0
45676150	1177480	0	0
45672721	1125315	0	0
46296356	1713332	0	0
45897397	1125315	0	0
46244290	1125315	0	0
46289221	1125315	0	0
46308325	1112807	0	0
46305775	1124957	0	0
45896566	1129625	0	0
440921	4299128	3	3
4344497	81151	2	6
4083964	81151	5	5
21505601	1549786	0	0
21505679	1192710	2	2
36154616	1738521	0	0
36156644	1149196	0	0
40229134	40229134	0	0
37219970	313217	4	5
44338098	1125315	0	0
44361661	1549786	0	0
45646404	1110410	0	0
45662305	1149380	0	0
45664806	1129625	0	0
45662269	1119510	0	0
45645929	1119510	0	0
45647443	975125	0	0
45624185	19128263	1	2
45673431	1125315	0	0
45689522	1129625	0	0
45701544	40228214	2	3
45639812	1125315	0	0
45800053	1125315	0	0
45676342	1177480	0	0
45672734	1125315	0	0
46296225	1102527	0	0
45897024	1125315	0	0
46244193	1125315	0	0
46289256	1125315	0	0
46302542	1112807	0	0
46305816	1124300	0	0
45896653	1310149	0	0
197331	195588	3	3
4283893	40481087	1	1
4041261	4275113	5	5
21505601	1519936	0	0
21505679	1174888	2	2
36154618	1112807	0	0
36156600	1713332	0	0
40228230	40228230	0	0
37622411	313217	4	5
44362848	1125315	0	0
44360966	1129625	0	0
45646413	975125	0	0
45662043	975125	0	0
45664810	1129625	0	0
45662052	1119510	0	0
45645933	1119510	0	0
45647554	975125	0	0
45663998	42902245	1	2
45673587	1125315	0	0
45686268	1129625	0	0
45701815	19008572	2	3
45639919	1125315	0	0
45800084	1125315	0	0
45789283	1177480	0	0
45672982	1125315	0	0
46296363	1115008	0	0
45897254	1125315	0	0
46244373	1125315	0	0
46289463	1125315	0	0
46302623	1112807	0	0
46305831	791967	0	0
45896421	782043	0	0
444208	258780	3	3
4283893	257012	1	1
4095203	4149245	5	5
21505634	1125315	0	0
21604390	740275	2	2
36154618	1192710	0	0
36156600	1759842	0	0
37219829	261325	0	0
37602360	317576	4	6
44362849	1125315	0	0
44361674	1713332	0	0
45645970	1174888	0	0
45662208	1115008	0	0
45664345	1129625	0	0
45662344	1119510	0	0
45644728	1119510	0	0
45647689	975125	0	0
45636250	1124300	0	0
45673472	1125315	0	0
45686296	1129625	0	0
45701712	19078924	2	3
45639927	1125315	0	0
45800086	1125315	0	0
45789380	1177480	0	0
45672821	1125315	0	0
46296302	1713332	0	0
45897276	1125315	0	0
46244305	1125315	0	0
46289813	1125315	0	0
46302866	1112807	0	0
46305944	1112807	0	0
45896517	1129625	0	0
4000610	4266809	3	3
4279139	4142905	1	1
4094284	40479422	5	5
21505634	1112807	0	0
21603616	975125	2	2
36154620	1551099	0	0
36156602	1729720	0	0
40758406	40758406	0	0
37502336	4301346	4	6
44362903	1125315	0	0
44361400	1322184	0	0
45645974	967823	0	0
45662210	738818	0	0
45664492	1129625	0	0
45658813	1119510	0	0
45644837	1119510	0	0
45647580	975125	0	0
45636009	708298	0	0
45673538	1125315	0	0
45686290	1129625	0	0
45701914	19133873	2	3
45639695	1125315	0	0
45800087	1125315	0	0
45789220	1177480	0	0
45672847	1125315	0	0
46296302	1759842	0	0
45897147	1125315	0	0
46244402	1125315	0	0
46289814	1125315	0	0
46302603	1112807	0	0
46306118	914335	0	0
45896765	1177480	0	0
4000610	4310024	3	3
19066170	42902245	1	1
4094284	40479768	5	5
21505689	1192710	0	0
21603616	1124300	2	2
36154668	1115008	0	0
36156682	1153428	0	0
40769179	40769179	0	0
37219945	255848	4	6
44362923	1125315	0	0
44361285	1149196	0	0
45646359	967823	0	0
45662211	1326303	0	0
45662098	1129625	0	0
45658830	1119510	0	0
45644747	1119510	0	0
45647931	975125	0	0
45636265	1149196	0	0
45673551	1125315	0	0
45686567	1129625	0	0
45701882	1127433	2	3
45639874	1125315	0	0
45799984	1125315	0	0
45789510	1177480	0	0
45672946	1125315	0	0
46296228	1322184	0	0
45897277	1125315	0	0
46244203	1125315	0	0
46289975	1125315	0	0
46303144	1112807	0	0
46306129	1308738	0	0
45896766	1119510	0	0
4000610	30753	3	3
19081494	19019979	1	1
4136694	78272	5	5
21505689	1174888	0	0
21601239	1326303	2	2
36154380	1112807	0	0
36158858	738818	0	0
37622518	192671	1	1
36718595	4132546	4	6
44362970	1125315	0	0
44361522	975125	0	0
45646125	1154029	0	0
45662236	1154343	0	0
45662012	1129625	0	0
45659146	1119510	0	0
45642000	1119510	0	0
45644672	975125	0	0
45636634	723013	0	0
45673616	1125315	0	0
45686578	1129625	0	0
45701996	19008572	2	3
45639708	1125315	0	0
45800208	1125315	0	0
45789444	1177480	0	0
45672948	1125315	0	0
46296466	975125	0	0
45897298	1125315	0	0
46239383	1125315	0	0
46289757	1125315	0	0
46300379	1112807	0	0
46305964	1322184	0	0
45896768	1521369	0	0
77358	4113008	3	3
4354249	4329847	1	1
4042142	4048171	5	5
21505690	1119510	0	0
21500540	19074679	2	2
36154383	1713332	0	0
36158860	1129625	0	0
37622515	192671	1	1
37102305	198199	4	6
44362971	1125315	0	0
44361296	1129625	0	0
45646128	1310149	0	0
45662243	1107830	0	0
45662222	1129625	0	0
45659083	1119510	0	0
45642014	1119510	0	0
45644710	975125	0	0
45636636	1192710	0	0
45673693	1125315	0	0
45686684	1129625	0	0
45701964	19008572	2	3
45639716	1125315	0	0
45800184	1125315	0	0
45789570	1177480	0	0
45672860	1125315	0	0
46292025	1501700	0	0
45897299	1125315	0	0
46239396	1125315	0	0
46289713	1125315	0	0
46300648	1112807	0	0
46305967	1112807	0	0
45896769	1177480	0	0
432661	40486433	3	3
4353741	4078793	1	1
4297090	4052083	2	2
21505690	1192710	0	0
21604685	40223774	4	4
36154441	1153428	0	0
36158865	975125	0	0
37219942	261325	1	1
37203764	28060	4	7
44362932	1125315	0	0
44361299	1115008	0	0
45645975	1192710	0	0
45662436	1738521	0	0
45662537	1129625	0	0
45659165	1119510	0	0
45641905	1119510	0	0
45644738	975125	0	0
45636523	715997	0	0
45673797	1125315	0	0
45686513	1129625	0	0
45698853	40228214	2	3
45640008	1125315	0	0
45799910	1125315	0	0
45786720	1177480	0	0
45672779	1125315	0	0
46292037	1551099	0	0
45897179	1125315	0	0
46239398	1125315	0	0
46289720	1125315	0	0
46300564	1112807	0	0
46305970	1367571	0	0
45896771	1000560	0	0
432661	4280726	3	3
4303684	42535580	1	1
4297090	4163951	2	2
21500462	926487	0	0
21601744	40171902	4	4
36154711	1000560	0	0
36158868	1149380	0	0
37219939	4280726	1	1
37203764	40481087	4	7
44363041	1125315	0	0
44361476	738818	0	0
45645977	708298	0	0
45662411	1549786	0	0
44341855	1129625	0	0
45659193	1119510	0	0
45641755	1119510	0	0
45641867	975125	0	0
45635923	1107830	0	0
45673676	1125315	0	0
45686472	1129625	0	0
45698480	19078924	2	3
45640097	1125315	0	0
45800095	1125315	0	0
45786666	1177480	0	0
45784497	1125315	0	0
46292109	1000560	0	0
45897416	1125315	0	0
46239474	1125315	0	0
46289680	1125315	0	0
46300829	1112807	0	0
46305972	1717327	0	0
45896772	1112807	0	0
4002367	4337611	3	3
4291025	80809	1	1
4297090	4195803	2	2
21500464	926487	0	0
35100000	4280726	4	4
36154472	1129625	0	0
36158964	1129625	0	0
37219939	257012	1	1
37102305	195588	4	7
44363042	1125315	0	0
44360975	1129625	0	0
45646076	1551099	0	0
45662411	1515774	0	0
44358058	1129625	0	0
45659194	1119510	0	0
45638795	1119510	0	0
45641749	975125	0	0
45635924	1174888	0	0
45673846	1125315	0	0
45683519	1129625	0	0
45698484	19125062	2	3
45639843	1125315	0	0
45800353	1125315	0	0
45786915	1177480	0	0
45784507	1125315	0	0
46292147	1501700	0	0
45897186	1125315	0	0
46239371	1125315	0	0
46289738	1125315	0	0
46300837	1112807	0	0
46305989	1500211	0	0
45896763	1713332	0	0
4003565	4057420	3	3
4293027	4293740	1	1
4297887	30753	2	2
21500438	914335	0	0
21601386	1305058	4	4
36154473	1129625	0	0
36158762	1112807	0	0
37220048	28060	1	1
37219945	4048171	4	8
44363126	1125315	0	0
44361639	1521369	0	0
45646196	975125	0	0
45662411	19127890	0	0
44358059	1129625	0	0
45659195	1119510	0	0
45638757	1119510	0	0
45642087	975125	0	0
45635930	1501700	0	0
45673848	1125315	0	0
45683446	1129625	0	0
45698681	19059056	2	3
45639817	1125315	0	0
45800357	1125315	0	0
45789086	1177480	0	0
45784509	1125315	0	0
46292312	1112807	0	0
45897306	1125315	0	0
46239433	1125315	0	0
46289774	1125315	0	0
46300752	1112807	0	0
46305848	967823	0	0
45896529	715997	0	0
4002404	40492359	3	3
4242997	4163971	1	1
4297887	4266809	2	2
21500424	914335	0	0
21602795	1729720	4	4
36154476	1129625	0	0
36158763	1112807	0	0
40789986	3000963	1	1
37219945	258780	4	8
44359229	1125315	0	0
44361639	1548195	0	0
45646149	1545958	0	0
45662541	1149196	0	0
44357761	1129625	0	0
44341974	1119510	0	0
45638762	1119510	0	0
45638938	975125	0	0
45635934	914335	0	0
45673877	1125315	0	0
45683452	1129625	0	0
45700526	40243436	2	3
45639727	1125315	0	0
45800326	1125315	0	0
45785269	1177480	0	0
45784585	1125315	0	0
46292319	738818	0	0
45897355	1125315	0	0
46239498	1125315	0	0
46289895	1125315	0	0
46301012	1112807	0	0
46306011	19127890	0	0
45896593	1307863	0	0
442628	4149245	3	3
4206587	4107731	1	1
4208786	4035415	2	2
21500478	1177480	0	0
21602795	1728416	4	4
36154477	933724	0	0
36158843	1107830	0	0
40790076	3014599	1	1
37203764	260139	4	8
44359239	1125315	0	0
44361340	1000560	0	0
44341052	1124300	0	0
45662150	1713332	0	0
44357871	1129625	0	0
44357596	1119510	0	0
45638898	1119510	0	0
45638951	975125	0	0
45636017	738818	0	0
45670764	1125315	0	0
45683454	1129625	0	0
45698972	1127433	2	3
45685869	1125315	0	0
45685684	1125315	0	0
45785493	1177480	0	0
45784529	1125315	0	0
46292324	1738521	0	0
45897424	1125315	0	0
46239485	1125315	0	0
46241665	1125315	0	0
46300762	1112807	0	0
46306011	1549786	0	0
45896656	1124957	0	0
442983	40486433	3	3
4295259	4117038	1	1
4324765	4149245	2	2
21500487	933724	0	0
21500263	1332418	4	4
36154481	967823	0	0
36158849	1112807	0	0
40790090	3006734	1	1
37203758	4280726	4	8
44359243	1125315	0	0
44361351	1192710	0	0
44341057	933724	0	0
45662150	1759842	0	0
44358096	1129625	0	0
44357717	1119510	0	0
45638809	1119510	0	0
45639056	975125	0	0
45636172	1154343	0	0
45670807	1125315	0	0
45683485	1129625	0	0
45699041	19019273	2	3
45685786	1125315	0	0
45685694	1125315	0	0
45783536	1177480	0	0
45784579	1125315	0	0
46292065	1545958	0	0
45897393	1125315	0	0
46239513	1125315	0	0
46241668	1125315	0	0
46319337	1112807	0	0
46306026	1112807	0	0
45896787	1149196	0	0
442983	4280726	3	3
4295112	4107731	1	1
4211641	4163872	2	2
21500497	975125	0	0
35402079	372328	4	4
36154482	975125	0	0
36158852	1177480	0	0
40786570	3007461	1	1
37203764	4048171	4	9
44362548	1125315	0	0
44361354	1149380	0	0
44341000	1153428	0	0
45662249	1149196	0	0
44358051	1129625	0	0
44357992	1119510	0	0
45635469	1119510	0	0
45635761	975125	0	0
45632983	1549786	0	0
45670843	1125315	0	0
45685497	1129625	0	0
45698963	1127433	2	3
45685829	1125315	0	0
45685301	1125315	0	0
45783357	1177480	0	0
45784800	1125315	0	0
46292069	975125	0	0
45897394	1125315	0	0
46239637	1125315	0	0
46241638	1125315	0	0
46319154	1112807	0	0
46306052	1343916	0	0
45896790	1112807	0	0
375239	378419	3	3
4297085	4010253	1	1
4271450	4112343	2	2
21500501	1548195	0	0
21500491	1548195	4	4
36154398	1545958	0	0
36158935	738818	0	0
40786848	3015076	1	1
37203764	258780	4	9
44362654	1125315	0	0
44360980	738818	0	0
44341003	933724	0	0
45662257	708298	0	0
44358132	1129625	0	0
44358075	1119510	0	0
45635627	1119510	0	0
45632754	975125	0	0
45632983	1589505	0	0
45670817	1125315	0	0
45680301	1129625	0	0
45695458	40223834	2	3
45685800	1125315	0	0
45685305	1125315	0	0
45783178	1177480	0	0
45784909	1125315	0	0
46292079	1112807	0	0
45897375	1125315	0	0
46239643	1125315	0	0
46241716	1125315	0	0
46239899	1112807	0	0
46305857	1551099	0	0
45896792	933724	0	0
444132	40479422	3	3
4287856	4059978	1	1
4271450	4294548	2	2
21500457	1000560	0	0
21500491	975125	4	4
36154486	723013	0	0
36158938	975125	0	0
40786854	3023430	1	1
37100000	45769019	4	7
44362621	1125315	0	0
44361308	1177480	0	0
44341006	1713332	0	0
45662262	975125	0	0
44354688	1129625	0	0
44358234	1119510	0	0
45635679	1119510	0	0
45632769	975125	0	0
45632658	1124300	0	0
45670792	1125315	0	0
45680179	1129625	0	0
45695644	1332419	2	3
45685820	1125315	0	0
45685257	1125315	0	0
46291054	1177480	0	0
45784596	1125315	0	0
46292098	1332418	0	0
45894914	1125315	0	0
46239559	1125315	0	0
46241617	1125315	0	0
46239852	1112807	0	0
46306346	1124957	0	0
45896530	1112807	0	0
444132	40479768	3	3
4344497	4310024	1	1
4309075	4058899	2	2
21500512	933724	0	0
35102039	4056621	4	4
36154383	1759842	0	0
36158953	1177480	0	0
40786881	3001247	1	1
36424211	1119510	0	0
44359396	1125315	0	0
44361309	975125	0	0
44341006	1759842	0	0
45659014	1115008	0	0
44354602	1129625	0	0
44358044	1119510	0	0
45637137	1119510	0	0
45631085	975125	0	0
45632912	967823	0	0
45670851	1125315	0	0
45680327	1129625	0	0
45695613	40232448	2	3
45685797	1125315	0	0
45685417	1125315	0	0
46290930	1177480	0	0
45784640	1125315	0	0
46292122	1326303	0	0
45894918	1125315	0	0
46239560	1125315	0	0
46241661	1125315	0	0
46322479	1112807	0	0
46306354	1521369	0	0
45896597	1119510	0	0
444211	4152936	3	3
21001028	19074679	1	1
4208699	4012477	2	2
21500523	791967	0	0
35302568	378419	4	4
36154384	1115008	0	0
36158977	1107830	0	0
40786887	3027231	1	1
37521562	4059978	0	0
44359397	1125315	0	0
44361483	1149380	0	0
44341059	1589505	0	0
45658830	738818	0	0
44354740	1129625	0	0
44358112	1119510	0	0
45632445	1153428	0	0
45629680	975125	0	0
45633007	708298	0	0
45670801	1125315	0	0
45680243	1129625	0	0
45695619	1332419	2	3
45685838	1125315	0	0
45685378	1125315	0	0
46291369	1177480	0	0
45784665	1125315	0	0
46292123	1192710	0	0
45894988	1125315	0	0
46239561	1125315	0	0
46241559	1125315	0	0
46316225	1112807	0	0
46306354	1549786	0	0
45896639	1119510	0	0
195002	81893	3	3
4244662	4035415	3	3
19125488	19128263	2	2
21500516	967823	0	0
21503764	1125315	4	4
36154443	1129625	0	0
36158827	1115008	0	0
40787003	3013721	1	1
37521571	4275113	0	0
44359458	1125315	0	0
44361498	1000560	0	0
44341059	1549786	0	0
45658831	1124300	0	0
44354996	1129625	0	0
44358269	1119510	0	0
45632719	967823	0	0
45629656	975125	0	0
45632949	1396131	0	0
45670953	1125315	0	0
45680391	1129625	0	0
45695758	19075001	2	3
45685941	1125315	0	0
45685381	1125315	0	0
46242718	1177480	0	0
45784829	1125315	0	0
46292081	1557272	0	0
45894953	1125315	0	0
46239325	1125315	0	0
46241618	1125315	0	0
46316239	1112807	0	0
46306459	1124300	0	0
45894903	1129625	0	0
375415	4001336	3	3
4244662	80809	3	3
19125488	19128022	2	2
21011856	1759842	0	0
21503764	738818	4	4
36154630	914335	0	0
36158967	1551099	0	0
40770371	3013682	1	1
37521571	4238715	0	0
44359375	1125315	0	0
44361130	1112807	0	0
44341059	19127890	0	0
45659150	975125	0	0
44351191	1129625	0	0
44358293	1119510	0	0
45632723	1124300	0	0
45629625	975125	0	0
45633036	1115008	0	0
45670744	1125315	0	0
45680469	1129625	0	0
45695849	19078924	2	3
45686034	1125315	0	0
45685383	1125315	0	0
46242839	1177480	0	0
45784727	1125315	0	0
46292369	1192710	0	0
45895038	1125315	0	0
46239328	1125315	0	0
46241623	1125315	0	0
46310943	1112807	0	0
46322440	975125	0	0
45894954	715997	0	0
134057	321042	3	3
4244662	80502	3	3
19127891	40221415	2	2
21011856	1717327	0	0
21503764	1119510	4	4
36154387	1177480	0	0
36158968	1107830	0	0
40770372	3016723	1	1
37521572	4238715	0	0
44359451	1125315	0	0
44361644	1308738	0	0
44341253	933724	0	0
45659261	1500211	0	0
44351026	1129625	0	0
44358298	1119510	0	0
45629214	1115008	0	0
45626953	975125	0	0
45632996	1124957	0	0
45670880	1125315	0	0
45680612	1129625	0	0
45695678	40162522	2	3
45685613	1125315	0	0
45799942	1125315	0	0
46243032	1177480	0	0
45784729	1125315	0	0
46292371	1501700	0	0
45895042	1125315	0	0
46239337	1125315	0	0
46241699	1125315	0	0
46311201	1112807	0	0
46322444	975125	0	0
45803787	1307863	0	0
4000731	4337138	3	3
4300244	4337611	3	3
19127891	19127918	2	2
21011482	19010482	0	0
21503764	1129625	4	4
36154506	914335	0	0
36158986	1129625	0	0
40758558	3007461	1	1
40481087	40481087	0	0
44359454	1125315	0	0
44361646	975125	0	0
44341197	1149380	0	0
45659078	1174888	0	0
44350967	1129625	0	0
44354644	1119510	0	0
45629291	1153428	0	0
45628022	975125	0	0
45632998	791967	0	0
45670973	1125315	0	0
45680625	1129625	0	0
45694393	1713671	2	3
45685619	1125315	0	0
45799949	1125315	0	0
46242734	1177480	0	0
45784772	1125315	0	0
46292382	1102527	0	0
45895014	1125315	0	0
46239580	1125315	0	0
46241703	1125315	0	0
46322616	1112807	0	0
46322453	1551099	0	0
45803593	1307863	0	0
376337	4029498	3	3
4266188	4142905	3	3
4311387	45769019	2	2
21008466	1124300	0	0
21503764	1192710	4	4
36154836	1332418	0	0
36158677	1192710	0	0
40758558	3009542	1	1
37521035	4198190	0	0
42801354	1125315	0	0
44361648	1322184	0	0
44341405	1110410	0	0
45658878	1713332	0	0
44352257	1129625	0	0
44354648	1119510	0	0
45629292	1124957	0	0
45627067	975125	0	0
45633968	1545958	0	0
45671058	1125315	0	0
45680689	1129625	0	0
45692427	40229134	2	3
45637361	1125315	0	0
45800006	1125315	0	0
46242802	1177480	0	0
45784929	1125315	0	0
46292135	1112807	0	0
45895188	1125315	0	0
46239581	1125315	0	0
46241706	1125315	0	0
46316529	1112807	0	0
46322392	1307863	0	0
45803624	1119510	0	0
376106	380378	3	3
4241075	4197460	3	3
4248028	313217	2	2
21008595	1539403	0	0
21505615	46275916	4	5
36154710	1149196	0	0
36159084	1129625	0	0
40758558	3024731	1	1
37017711	37017711	0	0
42801354	1174888	0	0
44357442	1129625	0	0
44341071	1124300	0	0
45658970	1717327	0	0
44351879	1129625	0	0
44354767	1119510	0	0
45629303	1174888	0	0
45623726	975125	0	0
45633980	1308738	0	0
45670981	1125315	0	0
45677133	1129625	0	0
45692431	40229134	2	3
45637423	1125315	0	0
45799963	1125315	0	0
46240572	1177480	0	0
45784755	1125315	0	0
46292257	705944	0	0
45895190	1125315	0	0
46239677	1125315	0	0
46241641	1125315	0	0
46318008	1112807	0	0
46322460	967823	0	0
45803625	1119510	0	0
376208	381316	3	3
4241075	4295880	3	3
4248097	443279	2	2
21008593	1539403	0	0
21505697	40236446	4	5
36154837	1343916	0	0
36159089	1548195	0	0
40758558	3010813	1	1
40486433	40486433	0	0
42801439	19127890	0	0
44357426	705944	0	0
44341035	738818	0	0
45659083	738818	0	0
44351811	1129625	0	0
44354772	1119510	0	0
45629377	1115008	0	0
45624050	975125	0	0
45634062	1124957	0	0
45670984	1125315	0	0
45679285	1129625	0	0
45692403	1107882	2	3
45637426	1125315	0	0
45799965	1125315	0	0
46240545	1177480	0	0
45784766	1125315	0	0
46292333	1112807	0	0
45894972	1125315	0	0
46239679	1125315	0	0
46241646	1125315	0	0
46316794	1112807	0	0
46322673	1124957	0	0
45803625	738818	0	0
4000738	4323902	3	3
4243478	4336464	3	3
4231941	40479422	2	2
21008595	1332418	0	0
21500098	19007333	4	5
36154838	19127890	0	0
36158776	1192710	0	0
40758558	3026361	1	1
40223821	40223821	0	0
42801439	1515774	0	0
44357427	791967	0	0
44341140	1545958	0	0
45659091	1192710	0	0
44352368	1129625	0	0
44354723	1119510	0	0
45629442	1326303	0	0
45623801	975125	0	0
45634027	1713332	0	0
45670986	1125315	0	0
45679679	1129625	0	0
45692728	42707627	2	3
45637299	1125315	0	0
45799970	1125315	0	0
46240618	1177480	0	0
45784993	1125315	0	0
46292285	1713332	0	0
45895043	1125315	0	0
46239588	1125315	0	0
46241723	1125315	0	0
46316932	1112807	0	0
46322676	1154343	0	0
45803628	914335	0	0
4000738	4330583	3	3
4306073	4337138	3	3
4231941	40479768	2	2
21008593	1545958	0	0
21500437	40243436	4	5
36154838	1521369	0	0
36158901	1129625	0	0
40758558	3000963	1	1
40223834	40223834	0	0
42801439	1549786	0	0
44357433	933724	0	0
44341148	1115008	0	0
45659110	1539403	0	0
44351252	1129625	0	0
44354623	1119510	0	0
45629169	1174888	0	0
45623885	975125	0	0
45634027	1759842	0	0
45669393	1125315	0	0
45677235	1129625	0	0
45692463	1107882	2	3
45636751	1125315	0	0
45800040	1125315	0	0
46240791	1177480	0	0
45784998	1125315	0	0
46292337	1124300	0	0
45895015	1125315	0	0
46239652	1125315	0	0
46241725	1125315	0	0
46317047	1112807	0	0
46322516	1738521	0	0
45803730	1000560	0	0
4000738	4242997	3	3
4329725	4337611	3	3
21505897	1125315	2	2
21008593	1332418	0	0
21505608	19126352	4	5
36154838	1549786	0	0
36158684	1177480	0	0
40757363	3023103	1	1
40223771	40223774	0	0
42801426	1738521	0	0
44357409	1332418	0	0
45643344	715997	0	0
45658736	1539403	0	0
44351288	1129625	0	0
44354993	1119510	0	0
45629450	1000560	0	0
45668037	975125	0	0
45634130	914335	0	0
45669369	1125315	0	0
45677279	1129625	0	0
45692501	19018935	2	3
45636855	1125315	0	0
45799720	1125315	0	0
46240722	1177480	0	0
45785002	1125315	0	0
46292342	1174888	0	0
45895030	1125315	0	0
46239658	1125315	0	0
46241735	1125315	0	0
46306371	1112807	0	0
46316954	1307863	0	0
45803818	1107830	0	0
376208	4149245	3	4
4329725	4323902	3	3
21500562	836654	2	2
21008820	1738521	0	0
21500270	19059056	4	5
36154724	1000560	0	0
36158903	1129625	0	0
40757363	3013721	1	1
40223774	40223774	0	0
42801344	1332418	0	0
44357384	1149196	0	0
45643100	1500211	0	0
45658978	1107830	0	0
44347504	1129625	0	0
44350811	1119510	0	0
45629310	1322184	0	0
45667994	975125	0	0
45633991	705944	0	0
45669554	1125315	0	0
45674099	1129625	0	0
45692613	1154615	2	3
45636782	1125315	0	0
45799687	1125315	0	0
45681014	1174888	0	0
45784647	1125315	0	0
46292344	1124300	0	0
45895109	1125315	0	0
46239722	1125315	0	0
46241739	1125315	0	0
46306372	1112807	0	0
46317102	1118084	0	0
45803820	1129625	0	0
134057	4329847	3	4
4252534	4116491	3	3
21500562	701322	2	2
21008595	1545958	0	0
21500259	46275916	4	5
36154549	1124300	0	0
36158804	1129625	0	0
40757363	3024561	1	1
40222846	40222846	0	0
42801387	1107830	0	0
44357482	1124957	0	0
45643300	1759842	0	0
45659120	1332418	0	0
44347430	1129625	0	0
44351194	1119510	0	0
45629454	1501700	0	0
45670243	975125	0	0
45634008	1192710	0	0
45669433	1125315	0	0
45673934	1129625	0	0
45692591	19019273	2	3
45636831	1125315	0	0
45797344	1125315	0	0
45681016	1548195	0	0
45782652	1125315	0	0
46292356	1107830	0	0
45895126	1125315	0	0
46239753	1125315	0	0
46241740	1125315	0	0
46306428	1112807	0	0
46317103	1545958	0	0
45803821	738818	0	0
376337	381316	3	4
4207186	40481087	3	3
21001487	19129655	2	3
21010168	1305058	0	0
21503963	19059056	4	5
36154645	1153428	0	0
36158812	1545958	0	0
40757363	3014576	1	1
40224132	40224132	0	0
42801388	1332418	0	0
44357483	1149380	0	0
45643300	1713332	0	0
45658979	1124957	0	0
44347402	1129625	0	0
44350873	1119510	0	0
45629459	1551099	0	0
45665829	975125	0	0
45647429	19127904	3	4
45669436	1125315	0	0
45674263	1129625	0	0
45692672	19112599	2	3
45636765	1125315	0	0
45797350	1125315	0	0
45681165	1713332	0	0
45782402	1125315	0	0
46292216	1192710	0	0
45895069	1125315	0	0
46239712	1125315	0	0
46241682	1125315	0	0
46306243	1112807	0	0
46317120	1551099	0	0
45803821	1119510	0	0
376337	4066995	3	4
4295343	4168004	3	3
21001488	19129655	2	3
21011074	1367571	0	0
21600490	35605482	4	6
36154652	1129625	0	0
36159012	1367571	0	0
40757363	3013682	1	1
40783186	3020630	3	3
42801389	1551099	0	0
44357447	1738521	0	0
45643065	1149196	0	0
45658981	1192710	0	0
44347383	1129625	0	0
44350875	1119510	0	0
45629602	1545958	0	0
45665885	975125	0	0
45644636	19127918	3	4
45669635	1125315	0	0
45673635	1129625	0	0
45692681	1127433	2	3
45636835	1125315	0	0
45797352	1125315	0	0
45681009	1115008	0	0
45782403	1125315	0	0
46292223	1192710	0	0
45895072	1125315	0	0
46239695	1125315	0	0
46241683	1125315	0	0
46306758	1112807	0	0
46317132	1539403	0	0
45803619	1000560	0	0
4002905	81893	3	4
4303802	4240902	3	3
21001486	19129655	2	3
21009299	1738521	0	0
21601237	1539411	4	7
36154654	1129625	0	0
36158785	1521369	0	0
40757363	3004501	1	1
40783186	3016723	3	3
42801392	1124300	0	0
44357518	1149196	0	0
45643352	1149196	0	0
45658982	975125	0	0
44347561	1129625	0	0
44351817	1119510	0	0
45629603	914335	0	0
45666205	975125	0	0
45651017	19128065	3	4
45669539	1125315	0	0
45673717	1129625	0	0
45692682	19076374	2	3
45636961	1125315	0	0
45797339	1125315	0	0
45681165	1759842	0	0
45782408	1125315	0	0
46292235	1112807	0	0
45895214	1125315	0	0
46239733	1125315	0	0
46241750	1125315	0	0
45895616	1177480	0	0
46317273	1557272	0	0
45803793	1177480	0	0
321588	313217	3	4
4303802	433644	3	3
21001762	1551192	2	3
21010499	1307863	0	0
21601237	1332419	4	7
36154728	1129625	0	0
36158787	1129625	0	0
40757363	3006906	1	1
40782937	3006451	3	3
42801396	1551099	0	0
44357571	701322	0	0
45643070	920293	0	0
45659165	1192710	0	0
45647175	1343916	0	0
44352370	1119510	0	0
45629546	1589505	0	0
45666180	975125	0	0
45648172	40221415	3	4
45669521	1125315	0	0
45674349	1129625	0	0
45692844	40223768	2	3
45636968	1125315	0	0
45797393	1125315	0	0
45681011	1110410	0	0
45782662	1125315	0	0
46292239	1149196	0	0
45895143	1125315	0	0
46239736	1125315	0	0
46241708	1125315	0	0
45895637	1177480	0	0
46316985	715997	0	0
45803796	1322184	0	0
135930	4035415	3	4
4303802	37017711	3	3
21001163	1551192	2	3
21010583	1595799	0	0
21600493	35605482	1	3
36154729	1557272	0	0
36158993	1521369	0	0
40757363	3016723	1	1
40785816	3026361	3	3
42801498	967823	0	0
44357493	1149380	0	0
45643310	1107830	0	0
45659193	738818	0	0
45646993	738818	0	0
44351257	1119510	0	0
45629546	1549786	0	0
45663644	975125	0	0
45639313	19127922	3	4
45669604	1125315	0	0
45673927	1129625	0	0
45692803	19126352	2	3
45636971	1125315	0	0
45682355	1125315	0	0
45680892	1124957	0	0
45782350	1125315	0	0
46292477	738818	0	0
45895218	1125315	0	0
45895935	1125315	0	0
46241696	1125315	0	0
45895602	1177480	0	0
46317141	933724	0	0
45803895	1149196	0	0
372887	378419	3	4
4303802	4219399	3	3
19039298	19023398	2	3
21002098	1551099	0	0
21601240	19018935	1	4
36154730	1107830	0	0
36158993	1549786	0	0
40757363	3035995	1	1
40785816	3010813	3	3
42801405	920293	0	0
44357494	1729720	0	0
45643264	1396131	0	0
45659195	1192710	0	0
45647087	738818	0	0
44351288	1119510	0	0
45629563	1000560	0	0
45663668	975125	0	0
45695285	19128009	2	2
45669480	1125315	0	0
45671127	1129625	0	0
45691516	19008572	2	3
45636869	1125315	0	0
45682418	1125315	0	0
45680896	1000560	0	0
45782513	1125315	0	0
46292244	1738521	0	0
45895221	1125315	0	0
45896157	1125315	0	0
46241713	1125315	0	0
45895627	1177480	0	0
46317144	1124957	0	0
45803683	1119510	0	0
255919	4218389	3	4
4207184	4294548	3	3
21505843	19059056	2	3
21002247	1551099	0	0
21500367	1154615	1	2
36154731	1192710	0	0
36159109	1149196	0	0
40757363	3020630	1	1
37503996	4202451	3	3
42806550	1539403	0	0
44357549	738818	0	0
45643071	1332418	0	0
45659283	933724	0	0
45647095	914335	0	0
44347310	1119510	0	0
45629566	708298	0	0
45663435	975125	0	0
45695285	19127918	2	2
45669486	1125315	0	0
45671362	1129625	0	0
45691722	19077572	2	3
45637004	1125315	0	0
45682515	1125315	0	0
45680897	967823	0	0
45782638	1125315	0	0
46292404	1396131	0	0
45895222	1125315	0	0
45896166	1125315	0	0
46241765	1125315	0	0
45895652	1177480	0	0
46317435	1112807	0	0
45803685	967823	0	0
1549786	19127904	3	4
4304916	4266809	3	4
21505816	40229134	2	3
21002238	1551099	0	0
21500260	1343916	1	1
36154734	1192710	0	0
36159114	738818	0	0
40757363	3019550	1	1
40783188	3000963	3	3
42806459	1149380	0	0
44357486	1192710	0	0
45643345	967823	0	0
45659298	701322	0	0
45647219	1367571	0	0
44347485	1119510	0	0
45629131	1107830	0	0
45663867	975125	0	0
45680376	19127918	2	2
45669697	1125315	0	0
45671367	1129625	0	0
45691742	1115171	2	3
45636872	1125315	0	0
45682506	1125315	0	0
45680925	1501700	0	0
45783593	1125315	0	0
46292469	1000560	0	0
45895165	1125315	0	0
45895884	1125315	0	0
46242515	1125315	0	0
45802381	1177480	0	0
46317438	920293	0	0
45803688	1322184	0	0
1549786	19128263	3	4
4302537	192671	3	4
4322976	4191853	2	3
21002151	1717327	0	0
21503530	1322184	1	1
36154842	1549786	0	0
36159115	1521369	0	0
40757364	3004501	1	1
40783188	3020630	3	3
42806327	975125	0	0
44357575	708298	0	0
45643073	1107830	0	0
45659313	975125	0	0
45647223	1309944	0	0
44347741	1119510	0	0
45629233	1174888	0	0
45663914	975125	0	0
45680376	19128009	2	2
45669630	1125315	0	0
45671368	1129625	0	0
45691435	43012433	2	3
45682789	1125315	0	0
45794889	1125315	0	0
45680927	1112807	0	0
45783586	1125315	0	0
46292437	933724	0	0
45895239	1125315	0	0
45896054	1125315	0	0
46242601	1125315	0	0
45801957	1177480	0	0
46317150	715997	0	0
45803594	1119510	0	0
1549786	19128009	3	4
4296373	4336464	3	4
21011857	1713671	2	3
21002151	1741122	0	0
21503530	1112807	1	1
36154657	1129625	0	0
36158923	1177480	0	0
40757364	3013721	1	1
40783188	3004501	3	3
42806463	1149380	0	0
44357490	1545958	0	0
45643075	975125	0	0
45659255	967823	0	0
45647008	1149196	0	0
44347657	1119510	0	0
45629470	1124957	0	0
45660242	975125	0	0
45698865	19128009	2	2
45669500	1125315	0	0
45671504	1129625	0	0
45691663	1115171	2	3
45682794	1125315	0	0
45794833	1125315	0	0
45680933	1112807	0	0
45783561	1125315	0	0
46292438	1589505	0	0
45895333	1125315	0	0
45896134	1125315	0	0
46242602	1125315	0	0
45801972	1177480	0	0
46311341	975125	0	0
45803595	715997	0	0
1549786	19128022	3	4
4206591	4285898	3	4
21000216	46233710	2	3
21002152	1741122	0	0
21503884	708298	1	1
36154743	1118084	0	0
36159096	1738521	0	0
40757364	3024561	1	1
40783188	3028833	3	3
42806471	1115008	0	0
44357502	738818	0	0
45643383	1738521	0	0
44341857	723013	0	0
45645890	1713332	0	0
44347529	1119510	0	0
45629471	1539403	0	0
45660526	975125	0	0
45676997	19128009	2	2
45669600	1125315	0	0
45671509	1129625	0	0
45689697	40232448	2	3
45682688	1125315	0	0
45794820	1125315	0	0
45680915	1332418	0	0
45782749	1125315	0	0
46292390	701322	0	0
45895337	1125315	0	0
45896136	1125315	0	0
46242575	1125315	0	0
45802061	1177480	0	0
46310828	1713332	0	0
45803552	1119510	0	0
1549786	19127918	3	4
4244662	4146173	3	5
21000216	46233988	2	3
21002222	1759842	0	0
21503765	1192710	1	1
36154745	1192710	0	0
36158796	1129625	0	0
40757364	3013682	1	1
40786225	3035995	3	3
42806556	975125	0	0
44357453	1177480	0	0
45643393	1738521	0	0
44341974	738818	0	0
45646143	1154343	0	0
44347545	1119510	0	0
45629560	933724	0	0
45657462	975125	0	0
45676997	19127918	2	2
45669772	1125315	0	0
45671440	1129625	0	0
45689703	40231925	2	3
45682771	1125315	0	0
45794821	1125315	0	0
45680989	757627	0	0
45782727	1125315	0	0
46292694	1124300	0	0
45895300	1125315	0	0
45896137	1125315	0	0
46242612	1125315	0	0
45799312	1177480	0	0
46310829	19127890	0	0
45803862	1124300	0	0
1549786	42902245	3	4
4244662	4066995	3	6
21500546	40232448	2	3
21002222	1713332	0	0
21503765	1125315	1	1
36154748	1192710	0	0
36159115	1549786	0	0
40757364	3023103	1	1
40786225	3006923	3	3
42806474	1713332	0	0
44357562	1129625	0	0
45643594	1154343	0	0
44357954	1332418	0	0
45645894	1174888	0	0
44347623	1119510	0	0
45629505	933724	0	0
45657468	975125	0	0
45689373	19128009	2	2
45780646	1125315	0	0
45669801	1129625	0	0
45689708	40229134	2	3
45682773	1125315	0	0
45794879	1125315	0	0
45681054	1115008	0	0
45782851	1125315	0	0
46293077	1000560	0	0
45894474	1125315	0	0
45896031	1125315	0	0
46242613	1125315	0	0
45799501	1177480	0	0
46310829	1549786	0	0
45803829	1118084	0	0
1344056	46275916	1	1
4244662	4048695	3	6
21001557	46275916	2	3
21002138	1741122	0	0
21503884	753626	1	1
36154532	914335	0	0
36159247	1322184	0	0
40757364	3019550	1	1
37018424	4296204	3	3
42806558	715997	0	0
44357563	1124300	0	0
45643236	738818	0	0
44357893	1361711	0	0
45645856	1361711	0	0
44347625	1119510	0	0
45629572	1115008	0	0
45658393	975125	0	0
45633070	40229134	2	3
45780787	1125315	0	0
45669727	1129625	0	0
45689680	19018935	2	3
45682709	1125315	0	0
45794913	1125315	0	0
45680995	1713332	0	0
45782855	1125315	0	0
46275916	46275916	0	0
45894477	1125315	0	0
45896040	1125315	0	0
46242615	1125315	0	0
45799529	1177480	0	0
46310970	933724	0	0
45803556	1129625	0	0
1344056	1594382	1	1
4244662	78272	3	8
21000289	46233710	2	3
21002113	1713332	0	0
21494873	3051031	1	1
36155000	1551099	0	0
36158800	1551099	0	0
40757364	3020630	1	1
40481384	42535580	3	3
42806223	1713332	0	0
44357564	1778162	0	0
45643357	920293	0	0
44357905	1549786	0	0
45645862	1107830	0	0
44347215	1119510	0	0
45629361	740275	0	0
45657842	975125	0	0
45633130	40232448	2	3
45780816	1125315	0	0
45669824	1129625	0	0
45689876	19133768	2	3
45682977	1125315	0	0
45794918	1125315	0	0
45680997	1501700	0	0
45782771	1125315	0	0
46275919	46275916	0	0
45894407	1125315	0	0
45895997	1125315	0	0
46242567	1125315	0	0
45799483	1177480	0	0
46310971	715997	0	0
45803602	1174888	0	0
1768881	19074843	1	1
4274025	255848	5	8
21011858	1713671	2	3
21002113	1759842	0	0
21494880	3051031	1	1
36155010	1713332	0	0
36158819	1153428	0	0
40757364	3006906	1	1
40785842	3007461	3	3
42806332	1551099	0	0
44357678	1129625	0	0
45643359	1124957	0	0
44358057	1118084	0	0
45645864	1124300	0	0
44347782	1119510	0	0
45629366	1000560	0	0
45657963	975125	0	0
45633173	19019273	2	3
45780824	1125315	0	0
45670504	1129625	0	0
45689876	40162522	2	3
45682826	1125315	0	0
45794959	1125315	0	0
45681000	920293	0	0
45782775	1125315	0	0
46287943	1549786	0	0
45894414	1125315	0	0
45896143	1125315	0	0
46241847	1125315	0	0
45796707	1177480	0	0
46311639	975125	0	0
45803720	1112807	0	0
1551099	19089061	1	1
4274025	4132546	5	8
21001565	40243436	2	3
21002113	1741122	0	0
21492982	3051031	1	1
36155014	1551099	0	0
36158821	1115008	0	0
40757364	3006923	1	1
40785842	3010813	3	3
42806223	1759842	0	0
44357505	1124300	0	0
45643526	1153428	0	0
44357760	738818	0	0
45646137	1149196	0	0
44343351	1119510	0	0
45629474	1174888	0	0
45654111	975125	0	0
45633230	40232448	2	3
45780832	1125315	0	0
45781093	1129625	0	0
45689853	1115171	2	3
45682890	1125315	0	0
45794942	1125315	0	0
45681003	1112807	0	0
45782863	1125315	0	0
46287943	1521369	0	0
45894536	1125315	0	0
45896199	1125315	0	0
46241864	1125315	0	0
45796845	1177480	0	0
46311784	1729720	0	0
45803724	914335	0	0
1778228	19075001	1	1
4201745	4285898	5	8
21001565	46275916	2	3
21002113	1717327	0	0
21490759	3006322	1	1
36154752	1192710	0	0
36158822	1551099	0	0
40757364	3035995	1	1
40786227	3006906	3	3
42806482	967823	0	0
44357687	1545958	0	0
45643527	1154029	0	0
44357793	1115008	0	0
45643848	1308738	0	0
44343552	1119510	0	0
45629475	738818	0	0
45654112	975125	0	0
45676454	1551192	2	3
45780914	1125315	0	0
45781244	1129625	0	0
45686556	46275444	2	3
45633682	1125315	0	0
45679135	1125315	0	0
45681118	1112807	0	0
45780758	1125315	0	0
46287949	1738521	0	0
45894597	1125315	0	0
45896153	1125315	0	0
46241838	1125315	0	0
45797055	1177480	0	0
46311785	933724	0	0
45803804	1326303	0	0
381591	381316	1	1
4244662	4134304	5	8
21000083	19073183	2	3
21002102	1717327	0	0
21490760	3009542	1	1
36154564	1129625	0	0
36158826	1545958	0	0
40757364	3016723	1	1
37604032	4324181	3	3
42806487	1000560	0	0
44357584	1521369	0	0
45643530	738818	0	0
44357765	1310149	0	0
45643860	1174888	0	0
44343553	1119510	0	0
45629486	1137529	0	0
45654368	975125	0	0
45676462	1332419	2	3
45783372	1125315	0	0
45781248	1129625	0	0
45686853	1551192	2	3
45633465	1125315	0	0
45679382	1125315	0	0
45681039	1367571	0	0
45780777	1125315	0	0
46287875	975125	0	0
45894600	1125315	0	0
45896824	1125315	0	0
46241889	1125315	0	0
45794141	1177480	0	0
46311246	1000560	0	0
45803805	1192710	0	0
372887	4029498	1	1
4302537	4166224	5	8
21000268	46233988	2	3
21002102	1738521	0	0
21490760	3014576	1	1
36110253	28060	0	0
36158998	1713332	0	0
40761511	3000963	1	1
40792670	3023103	3	3
42806593	1153428	0	0
44357584	1549786	0	0
45643533	1174888	0	0
44357769	1501700	0	0
45643888	1124300	0	0
44343724	1119510	0	0
45629490	967823	0	0
45654371	975125	0	0
45676637	19008572	2	3
45783389	1125315	0	0
45781472	1129625	0	0
45686731	40232448	2	3
45633756	1125315	0	0
45679388	1125315	0	0
45681168	1307863	0	0
45780895	1125315	0	0
46287882	738818	0	0
45894391	1125315	0	0
45896649	1125315	0	0
46241806	1125315	0	0
45794239	1177480	0	0
46311253	1589505	0	0
45803806	914335	0	0
444208	257012	1	1
4302537	440448	5	8
21000268	46233710	2	3
21002113	1746114	0	0
21490760	3006906	1	1
36152376	1149196	0	0
36159003	738818	0	0
40761547	3016723	1	1
40792670	3045716	3	3
42806225	705944	0	0
44357584	19127890	0	0
45643534	1551099	0	0
44357907	1332418	0	0
45643921	1110410	0	0
44344038	1119510	0	0
45629412	1310149	0	0
45650892	975125	0	0
45676638	19075601	2	3
45783294	1125315	0	0
45781483	1129625	0	0
45687015	40229134	2	3
45633757	1125315	0	0
45679254	1125315	0	0
45680946	1557272	0	0
45780262	1125315	0	0
46287911	1738521	0	0
45894580	1125315	0	0
45896839	1125315	0	0
46241810	1125315	0	0
45794761	1177480	0	0
46311645	1738521	0	0
45803603	1124957	0	0
373087	4066995	1	1
4302537	81893	5	10
21000218	46233988	2	3
21002122	1741122	0	0
21494954	21494966	1	1
36152382	1129625	0	0
36158913	1124300	0	0
40485073	40479768	1	1
40792670	3019550	3	3
42806227	1154343	0	0
44357702	738818	0	0
45643464	1149196	0	0
44357909	1192710	0	0
45643930	1738521	0	0
44344049	1119510	0	0
45629417	1154343	0	0
45648064	975125	0	0
45676767	920334	2	3
45783296	1125315	0	0
45781590	1129625	0	0
45686896	1127433	2	3
45633761	1125315	0	0
45679445	1125315	0	0
45680952	1717327	0	0
45780266	1125315	0	0
46287913	975125	0	0
45894581	1125315	0	0
45896807	1125315	0	0
46241811	1125315	0	0
45794770	1177480	0	0
46311577	1149196	0	0
45803866	738818	0	0
4000610	192671	1	1
4274025	380378	5	7
21001483	19129655	2	3
21002122	1717327	0	0
21491255	3007461	1	1
36152419	1551099	0	0
36159024	1149196	0	0
40485074	40479422	1	1
37019385	195588	3	3
42806638	1307863	0	0
44357703	738818	0	0
45643536	1192710	0	0
44357910	738818	0	0
45643966	1551099	0	0
44344095	1119510	0	0
45629418	1501700	0	0
45645199	975125	0	0
45676927	19008572	2	3
45780969	1125315	0	0
45781594	1129625	0	0
45686813	43012036	2	3
45633762	1125315	0	0
45679648	1125315	0	0
45680954	1738521	0	0
45780328	1125315	0	0
46287927	791967	0	0
45803100	1125315	0	0
45804357	1125315	0	0
46241817	1125315	0	0
45794707	1177480	0	0
46311576	1118084	0	0
45803866	1119510	0	0
4000609	4027663	1	1
4274025	4035415	5	7
21001555	1310034	2	3
21002123	1759842	0	0
21491255	3013721	1	1
36152316	1153428	0	0
36159025	1129625	0	0
40223765	45892894	1	1
40482705	4198190	3	3
42806406	1115008	0	0
44357704	1177480	0	0
45643537	1548195	0	0
44357990	1115008	0	0
45643969	1174888	0	0
44340083	1119510	0	0
45629608	967823	0	0
45642101	975125	0	0
45676958	40229134	2	3
45781032	1125315	0	0
45779225	1129625	0	0
45685609	40236446	2	3
45633821	1125315	0	0
45679121	1125315	0	0
45680955	920293	0	0
45780224	1125315	0	0
46288077	1332418	0	0
46288783	1361711	0	0
45804301	1125315	0	0
46241824	1125315	0	0
45794830	1177480	0	0
46310977	1539403	0	0
45803867	19127890	0	0
4000735	4295880	1	1
4297090	4058899	5	7
21001630	1539411	2	3
21002155	1741122	0	0
21491255	3006923	1	1
36152177	1308738	0	0
36159144	1149380	0	0
40223765	40223768	1	1
40482662	81151	3	3
42806412	1332418	0	0
44357714	1343916	0	0
45640278	1149380	0	0
44357992	738818	0	0
45643971	1738521	0	0
44340439	1119510	0	0
45631270	1545958	0	0
45642258	975125	0	0
45676961	40163554	2	3
45781045	1125315	0	0
45779181	1129625	0	0
45683568	19078924	2	3
45633742	1125315	0	0
45679280	1125315	0	0
45680956	1717327	0	0
45780302	1125315	0	0
46288086	1713332	0	0
46288566	1332418	0	0
45804369	1125315	0	0
46241792	1125315	0	0
45794277	1177480	0	0
46311527	1149380	0	0
45803867	1515774	0	0
4000882	4323902	1	1
4247371	40486433	5	7
21000148	46233710	2	3
21002122	1759842	0	0
21502626	1728416	1	1
36152179	738818	0	0
36159148	1129625	0	0
40224804	40224805	1	1
37203772	260139	3	3
42806595	1177480	0	0
44357529	738818	0	0
45640280	975125	0	0
44357960	1713332	0	0
45643946	738818	0	0
44340387	1119510	0	0
45630933	1153428	0	0
45639269	975125	0	0
45676512	19008572	2	3
45781051	1125315	0	0
45778914	1129625	0	0
45683710	19077572	2	3
45633795	1125315	0	0
45679449	1125315	0	0
45681264	723013	0	0
45780306	1125315	0	0
46288127	1332418	0	0
46288684	1174888	0	0
45804343	1125315	0	0
45897977	1125315	0	0
45794281	1177480	0	0
46311663	967823	0	0
45803867	1549786	0	0
4001336	375671	1	1
4247371	4280726	5	7
21001070	40232448	2	3
21002122	1746114	0	0
21500354	1119510	1	1
36152183	1322184	0	0
36158926	1107830	0	0
40224808	40224132	1	1
37203772	40486433	3	3
42806648	1149196	0	0
44357512	1129625	0	0
45642992	1501700	0	0
44357960	1759842	0	0
45643949	933724	0	0
44340466	1119510	0	0
45631108	1124300	0	0
45635778	975125	0	0
45673493	1551192	2	3
45781103	1125315	0	0
45779165	1129625	0	0
45683747	40229134	2	3
45633904	1125315	0	0
45792049	1125315	0	0
45681132	1149196	0	0
45780307	1125315	0	0
46287987	738818	0	0
46288567	1310149	0	0
45804380	1125315	0	0
45897978	1125315	0	0
45791684	1177480	0	0
46311738	1153428	0	0
45803768	1154029	0	0
4001336	378001	1	1
4322976	4293740	5	7
21001554	1310034	2	3
21002116	914335	0	0
21500290	1153428	1	1
36152204	1778162	0	0
36158929	738818	0	0
40230706	40229134	1	1
37203772	4280726	3	3
42806652	701322	0	0
44357538	1192710	0	0
45643095	738818	0	0
44357963	1153428	0	0
45643939	1174888	0	0
44340369	1119510	0	0
45631321	1154343	0	0
45636069	975125	0	0
45673610	1115171	2	3
45781143	1125315	0	0
45779168	1129625	0	0
45683600	40163554	2	3
45679868	1125315	0	0
45792059	1125315	0	0
45681059	723013	0	0
45780310	1125315	0	0
46287991	701322	0	0
46288688	1115008	0	0
45804382	1125315	0	0
45897971	1125315	0	0
45791699	1177480	0	0
46311417	1343916	0	0
45803844	1521369	0	0
4001565	4337138	1	1
4247371	4001336	5	6
21001554	46275916	2	3
21002125	1746114	0	0
21500290	1149196	1	1
36152338	1153428	0	0
36159065	1149196	0	0
40228218	40228230	1	1
37203769	258780	3	3
42806516	920293	0	0
44357539	1112807	0	0
45643178	1713332	0	0
44358090	1154343	0	0
45643890	1551099	0	0
44340637	1119510	0	0
45631232	791967	0	0
45635894	975125	0	0
45673628	1551192	2	3
45781145	1125315	0	0
45779175	1129625	0	0
45683670	19008572	2	3
45679863	1125315	0	0
45792061	1125315	0	0
45681211	1124300	0	0
45780342	1125315	0	0
46288088	1112807	0	0
46288571	1738521	0	0
45804312	1125315	0	0
45897962	1125315	0	0
45791657	1177480	0	0
46311821	975125	0	0
45803844	1549786	0	0
4001377	4242997	1	1
4297887	81893	5	6
21000244	46233988	2	3
21002123	1717327	0	0
21500290	1150770	1	1
36152343	1115008	0	0
36159070	1177480	0	0
40033902	19018935	1	1
40782821	3023430	3	3
42806529	19127890	0	0
44357542	1713332	0	0
45643179	19002770	0	0
44358093	1551099	0	0
45643891	1124957	0	0
44340196	1119510	0	0
45631247	1713332	0	0
45636206	975125	0	0
45673854	19008572	2	3
45781146	1125315	0	0
45707628	1129625	0	0
45683778	46275444	2	3
45679789	1125315	0	0
45792181	1125315	0	0
45681268	19127890	0	0
45780475	1125315	0	0
46288099	1112807	0	0
46288583	1343916	0	0
45796287	1125315	0	0
45897949	1125315	0	0
45791835	1177480	0	0
46311454	975125	0	0
45803845	1119510	0	0
374364	372328	1	1
4297090	4252419	5	6
21001099	19076374	2	3
21002124	1741122	0	0
21500375	1137529	1	1
36152420	1124300	0	0
36159071	1129625	0	0
40035909	19076374	1	1
37203758	317009	3	3
42806529	1589505	0	0
44357544	1177480	0	0
45643190	1713332	0	0
44358098	1713332	0	0
45644039	1738521	0	0
44340203	1119510	0	0
45631247	1759842	0	0
45633999	975125	0	0
45673831	1551192	2	3
45780982	1125315	0	0
45707651	1129625	0	0
45683783	19132304	2	3
45679588	1125315	0	0
45792089	1125315	0	0
45681268	1549786	0	0
45780277	1125315	0	0
46288101	1174888	0	0
46288216	1307863	0	0
45796417	1125315	0	0
45895695	1125315	0	0
45791741	1177480	0	0
46319021	1713332	0	0
45803847	1177480	0	0
79116	4146173	1	1
4297090	4024289	5	6
21001099	19078924	2	3
21002124	1746114	0	0
21500375	1149380	1	1
36152327	975125	0	0
36159074	1192710	0	0
37622403	317576	1	1
36776613	380378	3	3
42806529	1549786	0	0
44357629	1112807	0	0
45642960	1154029	0	0
44357981	1778162	0	0
45644051	1501700	0	0
44340204	1119510	0	0
45626546	1305058	0	0
45659022	738818	0	0
45673515	40222846	2	3
45781082	1125315	0	0
45707818	1129625	0	0
45683898	1107882	2	3
45630714	1125315	0	0
45792093	1125315	0	0
45681269	1174888	0	0
45780448	1125315	0	0
46288101	1192710	0	0
46288274	1545958	0	0
45796423	1125315	0	0
45895778	1125315	0	0
45788967	1177480	0	0
46319419	1192710	0	0
45803667	1119510	0	0
134222	4278672	1	1
4326426	4198190	5	6
21000284	46233710	2	3
21002124	1759842	0	0
21500375	1154343	1	1
36152328	738818	0	0
36158914	1112807	0	0
37520737	4078793	1	1
37202320	28060	3	4
42806530	723013	0	0
44357639	1545958	0	0
45643002	738818	0	0
44358075	738818	0	0
45643929	715997	0	0
44340316	1119510	0	0
45626351	914335	0	0
45658910	1308738	0	0
45673842	40232448	2	3
45781063	1125315	0	0
45707862	1129625	0	0
45683825	19019273	2	3
45630656	1125315	0	0
45792096	1125315	0	0
45681332	723013	0	0
45780233	1125315	0	0
46243025	1738521	0	0
46288458	1307863	0	0
45797158	1125315	0	0
45895791	1125315	0	0
45788972	1177480	0	0
46319424	701322	0	0
45803673	738818	0	0
134222	4155034	1	1
4293902	4198190	5	6
21506081	40174880	2	3
21002124	1717327	0	0
21500423	914335	1	1
36152422	1713332	0	0
36158917	1177480	0	0
37520740	4337138	1	1
37521016	4198190	3	4
42806509	914335	0	0
44357641	715997	0	0
45643192	975125	0	0
44358081	967823	0	0
45643954	1107830	0	0
44337327	1119510	0	0
45626525	1305058	0	0
45659024	1000560	0	0
45673848	1127433	2	3
45781064	1125315	0	0
45707921	1129625	0	0
45683973	19008572	2	3
45630780	1125315	0	0
45792098	1125315	0	0
45681336	1548195	0	0
45777762	1125315	0	0
46243139	1149196	0	0
46288721	715997	0	0
45797162	1125315	0	0
45895806	1125315	0	0
45788976	1177480	0	0
46319397	1124300	0	0
45803673	1119510	0	0
81902	4116491	1	1
4293032	4198190	5	6
21001773	40228230	2	3
21002140	1741122	0	0
21504554	1518198	1	1
36152422	1759842	0	0
36159298	1129625	0	0
37520797	4197460	1	1
37600000	192671	3	4
42806538	1154029	0	0
44357650	1112807	0	0
45640292	1545958	0	0
44358082	1192710	0	0
45644067	1174888	0	0
44337329	1119510	0	0
45626504	708298	0	0
45659125	738818	0	0
45673851	40174880	2	3
45780856	1125315	0	0
45705040	1129625	0	0
45684060	40232448	2	3
45630769	1125315	0	0
45792206	1125315	0	0
45681145	1107830	0	0
45777723	1125315	0	0
46243140	738818	0	0
46244617	1000560	0	0
45797286	1125315	0	0
45895773	1125315	0	0
46302164	1177480	0	0
46319804	914335	0	0
45803875	1332418	0	0
3026023	3027970	1	1
4244662	4059173	5	6
21001460	19126352	2	3
21002141	1741122	0	0
21504554	1549786	1	1
36152447	1149196	0	0
36159251	1107830	0	0
37219804	261325	1	1
36718595	44782520	3	4
42806539	791967	0	0
44357770	1129625	0	0
45640379	1501700	0	0
44358085	1545958	0	0
45644117	1000560	0	0
45620165	1119510	0	0
45626507	1115008	0	0
45659132	1307863	0	0
45673954	19019273	2	3
45780857	1125315	0	0
45705125	1129625	0	0
45680553	19019273	2	3
45630978	1125315	0	0
45792210	1125315	0	0
45681248	1112807	0	0
45777726	1125315	0	0
46243201	1112807	0	0
46244744	1118084	0	0
45797173	1125315	0	0
45895861	1125315	0	0
46299236	1177480	0	0
46319733	1149380	0	0
45803954	1112807	0	0
3026023	3006906	1	1
4244662	4278672	5	6
21001125	1551192	2	3
21002139	1741122	0	0
21504600	1332418	1	1
36152038	1332418	0	0
36159229	1129625	0	0
37219822	255848	1	1
37203764	4051466	3	4
42806604	1110410	0	0
44357771	1107830	0	0
45640390	723013	0	0
44357731	1361711	0	0
45644043	19003953	0	0
45620181	1119510	0	0
45626495	1738521	0	0
45659221	1115008	0	0
45673962	1115171	2	3
45778549	1125315	0	0
45705099	1129625	0	0
45680713	1154615	2	3
45630605	1125315	0	0
45675985	1125315	0	0
45681251	1595799	0	0
45777649	1125315	0	0
46243205	19010482	0	0
46244657	1124957	0	0
45797266	1125315	0	0
45895910	1125315	0	0
46299489	1177480	0	0
46319831	1551099	0	0
45803960	1149196	0	0
3026023	3004501	1	1
4244662	40479768	5	6
21000198	46233988	2	3
21002129	1717327	0	0
21504600	1545958	1	1
36152424	1107830	0	0
36159197	1177480	0	0
37219832	255848	1	1
37019275	4056621	3	4
42806644	1713332	0	0
44357598	1738521	0	0
45640391	1174888	0	0
44358234	738818	0	0
45644028	1305058	0	0
45620294	1119510	0	0
45626730	1500211	0	0
45659288	738818	0	0
45673884	19008572	2	3
45778557	1125315	0	0
45704925	1129625	0	0
45680671	19059056	2	3
45630904	1125315	0	0
45676035	1125315	0	0
45681219	1545958	0	0
45777653	1125315	0	0
46243190	1332418	0	0
46243249	1717327	0	0
45796485	1125315	0	0
45895965	1125315	0	0
46298825	1177480	0	0
46319832	967823	0	0
45803961	1129625	0	0
3026023	3024561	1	1
4244662	40479422	5	6
21000196	46233710	2	3
21002145	1746114	0	0
21504600	1112807	1	1
36152150	1112807	0	0
36159200	1521369	0	0
40789845	3015632	1	1
37604032	381316	3	4
42806313	1545958	0	0
44357778	1124300	0	0
45640400	1521369	0	0
44358237	1174888	0	0
45643996	920293	0	0
45620243	1119510	0	0
45626516	1153428	0	0
45659173	1501700	0	0
45673807	1115171	2	3
45778558	1125315	0	0
45705068	1129625	0	0
45680674	35605482	2	3
45630803	1125315	0	0
45675877	1125315	0	0
45681229	1174888	0	0
45777632	1125315	0	0
46242898	1154343	0	0
46243270	1738521	0	0
45796535	1125315	0	0
45896009	1125315	0	0
46299418	1177480	0	0
46319706	967823	0	0
45803961	1177480	0	0
3026023	3013721	1	1
4302537	28060	5	6
21001475	40163554	2	3
21505640	967823	0	0
21504600	1539403	1	1
36152150	1129625	0	0
36159200	1548195	0	0
40789893	3023103	1	1
37604032	317576	3	5
42806380	1115008	0	0
44357602	1149196	0	0
45640400	19127890	0	0
44357999	715997	0	0
45644010	1107830	0	0
45620357	1119510	0	0
45626789	1343916	0	0
45659263	914335	0	0
45673869	40223834	2	3
45778559	1125315	0	0
45633040	1177480	0	0
45677361	19078924	2	3
45630999	1125315	0	0
45675882	1125315	0	0
45681082	1107830	0	0
45777805	1125315	0	0
46242900	1746114	0	0
46243272	1174888	0	0
45796629	1125315	0	0
45895929	1125315	0	0
46299213	1177480	0	0
46317471	1326303	0	0
45803962	975125	0	0
3026023	3035995	1	1
4274025	4304110	5	6
21001763	1551192	2	3
21505686	1174888	0	0
21503966	1118084	1	1
36152156	738818	0	0
36159130	738818	0	0
40765634	40769189	1	1
36718588	4132546	3	5
42806603	1153428	0	0
44357788	1118084	0	0
45640400	1549786	0	0
44358041	1154343	0	0
45644017	1154029	0	0
45620153	1119510	0	0
45626503	1149196	0	0
45656821	914335	0	0
45672997	1107882	2	3
45778560	1125315	0	0
45633042	1177480	0	0
45677428	40223834	2	3
45676714	1125315	0	0
45675957	1125315	0	0
45681096	914335	0	0
45777738	1125315	0	0
46242900	1741122	0	0
46243274	1153428	0	0
45796630	1125315	0	0
45896078	1125315	0	0
46302176	1177480	0	0
46317472	1595799	0	0
45803971	1119510	0	0
3026023	3016723	1	1
4274025	4102123	5	6
21001456	19059056	2	3
21505687	1119510	0	0
21504520	1589505	1	1
36110716	195588	0	0
36159132	1107830	0	0
40765634	40769184	1	1
40481841	439777	3	5
42806391	740275	0	0
44357753	1501700	0	0
45640329	19002770	0	0
44358143	1192710	0	0
45644100	723013	0	0
45620474	1119510	0	0
45626538	1729720	0	0
45656824	19127890	0	0
45673319	19078461	2	3
45778666	1125315	0	0
45633146	1177480	0	0
45677509	19078461	2	3
45628373	1125315	0	0
45676149	1125315	0	0
45681098	920293	0	0
45777750	1125315	0	0
46242907	1192710	0	0
46243254	1332418	0	0
45796705	1125315	0	0
45896114	1125315	0	0
46295320	1177480	0	0
46317199	967823	0	0
45803876	1332418	0	0
3026023	3006923	1	1
4274025	4302207	5	6
21001547	1310034	2	3
21505688	1174888	0	0
21504520	975125	1	1
36158141	1177480	0	0
36159040	708298	0	0
40765634	40769179	1	1
37203771	4112343	3	5
42806494	715997	0	0
44357663	701322	0	0
45640335	1115008	0	0
44358155	1713332	0	0
45643983	708298	0	0
44362303	1119510	0	0
45626610	1343916	0	0
45656824	1589505	0	0
45670810	19008572	2	3
45778613	1125315	0	0
45676402	1177480	0	0
45677713	40232448	2	3
45628293	1125315	0	0
45676440	1125315	0	0
45681260	920293	0	0
45777703	1125315	0	0
46242910	1153428	0	0
46243310	1118084	0	0
45796474	1125315	0	0
45896116	1125315	0	0
46296219	1177480	0	0
46317726	933724	0	0
45803880	1119510	0	0
3026023	3020630	1	1
4300157	81151	5	5
21001462	19075601	2	3
21505695	742185	0	0
21504525	975125	1	1
36158254	1713332	0	0
36159239	1000560	0	0
40765634	40769194	1	1
37203771	4294548	3	5
42806596	1115008	0	0
44357773	1332418	0	0
45640364	975125	0	0
44358158	1713332	0	0
45644108	1124300	0	0
44362219	1119510	0	0
45626613	967823	0	0
45656824	1549786	0	0
45670775	1713671	2	3
45778642	1125315	0	0
45676634	1177480	0	0
45677474	19008572	2	3
45628068	1125315	0	0
45676442	1125315	0	0
45681348	1332418	0	0
45706531	1125315	0	0
46242917	738818	0	0
46243296	1192710	0	0
45796476	1125315	0	0
45896118	1125315	0	0
46296392	1177480	0	0
46317869	1778162	0	0
45803881	1119510	0	0
3026023	3013682	1	1
4241075	4107731	5	5
21001462	19059056	2	3
21603673	1343916	0	0
21505601	43012433	1	1
36158254	1759842	0	0
36159139	1115008	0	0
40758528	3004501	1	1
37600000	381316	3	6
42820136	1125315	0	0
44357586	1107830	0	0
45640356	1361711	0	0
44358112	1192710	0	0
45644109	967823	0	0
44362100	1119510	0	0
45626619	738818	0	0
45657147	967823	0	0
45670799	1115171	2	3
45778572	1125315	0	0
45676760	1177480	0	0
45677769	19057271	2	3
45627856	1125315	0	0
45676478	1125315	0	0
45681350	1310149	0	0
45706582	1125315	0	0
46243015	1545958	0	0
46243360	1154029	0	0
45796477	1125315	0	0
45896167	1125315	0	0
46291266	1177480	0	0
46317525	1124300	0	0
45804092	1119510	0	0
3026863	3013721	1	1
4212577	4296204	5	5
21000116	19133905	2	3
21009232	1738521	0	0
21503969	1112807	1	1
36158265	1738521	0	0
36159142	1177480	0	0
40758251	3024561	1	1
37203764	4283893	3	6
42820136	1119510	0	0
44357835	1713332	0	0
45640431	1738521	0	0
44358114	1115008	0	0
45644075	920293	0	0
44362221	1119510	0	0
45626519	1332418	0	0
45657349	1713332	0	0
45671015	1115171	2	3
45778678	1125315	0	0
45676762	1177480	0	0
45677795	43012433	2	3
45627974	1125315	0	0
45676482	1125315	0	0
45681369	1112807	0	0
45706375	1125315	0	0
46243080	1124957	0	0
46243381	1174888	0	0
45796570	1125315	0	0
45803984	1125315	0	0
46244890	1177480	0	0
46317527	1551099	0	0
45804096	1119510	0	0
3026863	3024561	1	1
4306074	4337611	5	5
21000116	19133873	2	3
21010583	1308738	0	0
21503969	1102527	1	1
36158271	1124957	0	0
36159275	1521369	0	0
40771521	3024561	1	1
37600000	4329847	3	7
42801466	705944	0	0
44357841	738818	0	0
45640754	1124300	0	0
44358262	1118084	0	0
45641287	1115008	0	0
44361992	1119510	0	0
45626579	1713332	0	0
45657350	740275	0	0
45671017	40223834	2	3
45778925	1125315	0	0
45677126	1177480	0	0
45677796	19075001	2	3
45628043	1125315	0	0
45789127	1125315	0	0
45675559	1115008	0	0
45706427	1125315	0	0
46243184	1500211	0	0
46243459	1115008	0	0
45796556	1125315	0	0
45803985	1125315	0	0
46244689	1177480	0	0
46317901	1595799	0	0
45803889	967823	0	0
3026863	3035995	1	1
4306074	4323902	5	5
21001477	40163554	2	3
21011215	1154343	0	0
21503969	1125315	1	1
36158425	1177480	0	0
36159275	19127890	0	0
40771521	3016723	1	1
37203764	255848	3	7
42801365	1548195	0	0
44354079	1713332	0	0
45640591	1000560	0	0
44357746	1192710	0	0
45641290	1309944	0	0
44362396	1119510	0	0
45626467	1501700	0	0
45657234	1153428	0	0
45670909	40232448	2	3
45778934	1125315	0	0
45673938	1177480	0	0
45674409	1107882	2	3
45627864	1125315	0	0
45789128	1125315	0	0
45675678	1332418	0	0
45706497	1125315	0	0
46242999	738818	0	0
46243460	1154029	0	0
45796691	1125315	0	0
45803916	1125315	0	0
46239871	1177480	0	0
46317593	715997	0	0
45803973	1118084	0	0
3026863	3006923	1	1
4322976	4230209	5	5
21012458	19077572	2	3
21009234	1741122	0	0
21503969	1124957	1	1
36158427	1107830	0	0
36159275	1549786	0	0
40771521	3000963	1	1
37203764	4294548	3	8
42801479	1174888	0	0
44354079	1759842	0	0
45640592	1551099	0	0
44358001	1539403	0	0
45641220	791967	0	0
44362411	1119510	0	0
45626485	1000560	0	0
45657154	1149196	0	0
45671058	40231925	2	3
45778651	1125315	0	0
45673138	1177480	0	0
45676233	1115171	2	3
45627866	1125315	0	0
45789379	1125315	0	0
45675690	1154029	0	0
45706458	1125315	0	0
46243001	1778162	0	0
46243318	1746114	0	0
45796693	1125315	0	0
45803778	1125315	0	0
46239932	1177480	0	0
46313331	1115008	0	0
45803974	975125	0	0
3022035	3013682	1	1
4344497	40479422	5	5
21012458	836659	2	3
21009234	1759842	0	0
21505667	1119510	1	1
36158430	1177480	0	0
36159276	1595799	0	0
40771562	3009201	1	1
37203764	40486433	3	8
42801479	1125315	0	0
44354174	1149196	0	0
45640596	1102527	0	0
44358013	1326303	0	0
45641118	1115008	0	0
44362333	1119510	0	0
45626556	1759842	0	0
45657356	1746114	0	0
45671037	40165015	2	3
45778894	1125315	0	0
45673319	1177480	0	0
45676257	40163554	2	3
45676354	1125315	0	0
45789384	1125315	0	0
45675691	1112807	0	0
45706462	1125315	0	0
46243002	1192710	0	0
46243318	1741122	0	0
45796537	1125315	0	0
45804104	1125315	0	0
45896586	1177480	0	0
46313501	1115008	0	0
45803975	1713332	0	0
3022035	3006906	1	1
4344497	40479768	5	5
21001116	1115171	2	3
21011074	1322184	0	0
21505667	1125315	1	1
36158535	1153428	0	0
36159276	1549786	0	0
40760919	3013682	1	1
37203764	4112343	3	9
42801338	1332418	0	0
44353948	1115008	0	0
45640492	1738521	0	0
44358266	1174888	0	0
45641128	1149196	0	0
44362493	1119510	0	0
45626756	1107830	0	0
45657356	1741122	0	0
45669554	1127433	2	3
45778967	1125315	0	0
45673258	1177480	0	0
45674425	1115171	2	3
45676586	1125315	0	0
45789324	1125315	0	0
45675754	1124957	0	0
45706642	1125315	0	0
46243067	738818	0	0
46243398	1332418	0	0
45796725	1125315	0	0
45804138	1125315	0	0
45896474	1177480	0	0
46314215	1115008	0	0
45803976	920293	0	0
3022035	3004501	1	1
4208786	4048695	5	5
21012460	45892894	2	3
21602884	1778162	0	0
21500418	967823	1	1
36158536	715997	0	0
36159276	1521369	0	0
36426524	40224132	2	3
37300000	4296204	5	9
42801339	1000560	0	0
44354162	1124300	0	0
45640415	1551099	0	0
44358269	738818	0	0
45641137	738818	0	0
44362584	1119510	0	0
45626850	1107830	0	0
45657017	967823	0	0
45669427	19023398	2	3
45778975	1125315	0	0
45670791	1177480	0	0
45674472	40229134	2	3
45676163	1125315	0	0
45792114	1125315	0	0
45675758	1310149	0	0
45706539	1125315	0	0
46243242	975125	0	0
46243591	740275	0	0
45796663	1125315	0	0
45804190	1125315	0	0
45894675	1177480	0	0
46313945	1115008	0	0
45803979	1129625	0	0
3022035	3016723	1	1
4208786	4066995	5	5
21012460	40223768	2	3
21604180	1127078	4	7
21500442	914335	1	1
36158543	1149196	0	0
36159281	1149380	0	0
36426524	40224805	2	3
37100000	195588	5	8
42801508	1115008	0	0
44354167	1539403	0	0
45640444	1738521	0	0
44358272	1307863	0	0
45641140	1551099	0	0
44362564	1119510	0	0
45626571	723013	0	0
45657278	1500211	0	0
45669531	40163554	2	3
45778657	1125315	0	0
45670884	1177480	0	0
45674546	43012036	2	3
45676193	1125315	0	0
45792243	1125315	0	0
45675844	1112807	0	0
45706732	1125315	0	0
46243243	1107830	0	0
46243261	1000560	0	0
45796654	1125315	0	0
45804042	1125315	0	0
46318304	1177480	0	0
46313902	1115008	0	0
45803998	1343916	0	0
3003823	3006906	1	1
4208786	4059173	5	5
21012460	19077572	2	3
21604180	19077572	4	7
21500486	914335	1	1
36158537	1124957	0	0
36159190	1332418	0	0
36468760	40228214	2	3
37203779	313217	5	6
42801448	705944	0	0
44355253	1124300	0	0
45640450	1153428	0	0
44358179	1118084	0	0
45641209	1589505	0	0
44362369	1119510	0	0
45626556	1713332	0	0
45657287	1310149	0	0
45669640	19008572	2	3
45707447	1125315	0	0
45670842	1177480	0	0
45674566	19023398	2	3
45676203	1125315	0	0
45792070	1125315	0	0
45675852	1501700	0	0
45706726	1125315	0	0
46243006	1500211	0	0
46243285	1557272	0	0
45796656	1125315	0	0
45803941	1125315	0	0
46317962	1177480	0	0
46308049	1115008	0	0
45804009	1129625	0	0
3027995	3045716	1	1
4208786	4278672	5	5
21000701	1545959	2	3
21604180	40165015	4	7
21500496	975125	1	1
36158611	1177480	0	0
36159345	1129625	0	0
36426272	1107882	2	3
37502350	4057420	5	6
42801545	1548195	0	0
44355282	1177480	0	0
45640456	1124300	0	0
44358189	933724	0	0
45641194	1343916	0	0
44355065	1119510	0	0
45626655	1551099	0	0
45657117	1118084	0	0
45669510	40163554	2	3
45707457	1125315	0	0
45671044	1177480	0	0
45674572	1551192	2	3
45676204	1125315	0	0
45789453	1125315	0	0
45675853	1107830	0	0
45706733	1125315	0	0
46243152	740275	0	0
46243286	1112807	0	0
45791169	1125315	0	0
45804212	1125315	0	0
46318225	1177480	0	0
46308317	1115008	0	0
44360761	1125315	0	0
3027995	3019550	1	1
4208786	40479768	5	5
21000633	1551192	2	3
21502709	1150836	7	7
21500522	723013	1	1
36158581	715997	0	0
36159350	1713332	0	0
36426272	19125062	2	3
37100000	4116491	5	6
42801399	1713332	0	0
44355346	1177480	0	0
45640464	1343916	0	0
44358194	705944	0	0
45641162	1738521	0	0
44354966	1119510	0	0
45626659	1332418	0	0
45657431	1192710	0	0
45669256	1127433	2	3
45707177	1125315	0	0
45671053	1177480	0	0
45671471	40162522	2	3
45676277	1125315	0	0
45789465	1125315	0	0
45675643	1124957	0	0
45706685	1125315	0	0
46243220	738818	0	0
46243366	1332418	0	0
45791177	1125315	0	0
45804051	1125315	0	0
46318040	1177480	0	0
46308663	1115008	0	0
44361178	1125315	0	0
3027995	3015632	1	1
4208786	40479422	5	5
21001494	1551192	2	3
21502709	914335	7	7
21500490	933724	1	1
36158558	1112807	0	0
36159350	1759842	0	0
36313967	4012477	2	3
37102305	45769019	5	6
42801399	1759842	0	0
44355311	1129625	0	0
45640438	1107830	0	0
44358275	933724	0	0
45641157	1110410	0	0
44355078	1119510	0	0
45626664	1713332	0	0
45657388	723013	0	0
45669686	46275916	2	3
45707438	1125315	0	0
45671034	1177480	0	0
45671649	19129655	2	3
45676278	1125315	0	0
45786835	1125315	0	0
45675854	1000560	0	0
45706635	1125315	0	0
46243162	1124300	0	0
46243369	1192710	0	0
45791178	1125315	0	0
45803855	1125315	0	0
46312120	1177480	0	0
46311994	1115008	0	0
44361225	1125315	0	0
3027995	3023103	1	1
4326426	4057420	5	5
21000637	1551192	2	3
21502709	1119510	7	7
21500468	926487	1	1
36158559	975125	0	0
36159293	1129625	0	0
36422418	19073183	2	3
37102305	4056621	5	6
42801510	1305058	0	0
44355311	1177480	0	0
45640610	738818	0	0
44358017	791967	0	0
45641295	1501700	0	0
44355018	1119510	0	0
45626777	1174888	0	0
45657485	1000560	0	0
45669603	19018935	2	3
45707521	1125315	0	0
45669470	1177480	0	0
45671490	19019979	2	3
45673478	1125315	0	0
45786658	1125315	0	0
45675833	723013	0	0
45706794	1125315	0	0
46243168	1107830	0	0
46243372	705944	0	0
45791245	1125315	0	0
45804180	1125315	0	0
46312415	1177480	0	0
46303166	1115008	0	0
44361184	1125315	0	0
3027995	3014576	1	1
4297090	4243062	5	5
21001485	19129655	2	3
21502709	1149380	7	7
21505694	742185	1	1
36158568	1177480	0	0
36159049	1115008	0	0
36426554	40222846	2	3
37502341	4242997	5	5
42801513	1125315	0	0
44355316	914335	0	0
45640739	1332418	0	0
44357809	1115008	0	0
45641300	738818	0	0
44354835	1119510	0	0
45626761	933724	0	0
45657268	708298	0	0
45780905	40169216	2	3
45707524	1125315	0	0
45669533	1177480	0	0
45671555	40232448	2	3
45624733	1125315	0	0
45786500	1125315	0	0
45675988	975125	0	0
45706799	1125315	0	0
46243049	1192710	0	0
46243374	1713332	0	0
45791247	1125315	0	0
45804082	1125315	0	0
46312420	1177480	0	0
46303090	1115008	0	0
44361093	1125315	0	0
3004588	3020630	1	1
4297090	4024958	5	5
21001485	19073183	2	3
21502709	1174888	7	7
21505694	705944	1	1
36158652	1112807	0	0
36159054	1192710	0	0
36426554	45892894	2	3
40783186	3009201	5	5
42801515	920293	0	0
44355321	1110410	0	0
45640546	975125	0	0
44358121	1115008	0	0
45641235	1110410	0	0
44354841	1119510	0	0
45626911	1149196	0	0
45657364	1307863	0	0
45780812	19018935	2	3
45707561	1125315	0	0
45669579	1177480	0	0
45671558	1115171	2	3
45624812	1125315	0	0
45786506	1125315	0	0
45675997	715997	0	0
45706845	1125315	0	0
46243056	19003953	0	0
46243349	1332418	0	0
45791331	1125315	0	0
45798787	1125315	0	0
46307458	1177480	0	0
46303311	1115008	0	0
44361362	1125315	0	0
3004588	3027970	1	1
4297090	4163872	5	5
21001485	19073188	2	3
21502709	1153428	7	7
21505698	1174888	1	1
36158612	1129625	0	0
36159244	1177480	0	0
36516781	80809	2	3
37300000	4152936	5	5
42801547	1119510	0	0
44355443	1177480	0	0
45640516	1124957	0	0
44358137	1332418	0	0
45641240	1595799	0	0
44354976	1119510	0	0
45626542	1000560	0	0
45657164	1000560	0	0
45780816	40162522	2	3
45707580	1125315	0	0
45669563	1177480	0	0
45671540	40231925	2	3
45624956	1125315	0	0
45786618	1125315	0	0
45675999	1149196	0	0
46240175	1125315	0	0
46243117	1124300	0	0
46243331	1332418	0	0
45791148	1125315	0	0
45798788	1125315	0	0
46307558	1177480	0	0
46303377	1115008	0	0
44361214	1125315	0	0
3028564	3035995	1	1
4297090	4314290	5	5
21000630	1551192	2	3
21502709	1192710	7	7
21505699	1192710	1	1
36158613	1129625	0	0
36159212	1129625	0	0
36516781	4146173	2	3
40487842	4058899	5	5
42801526	1322184	0	0
44355445	1332418	0	0
45640381	975125	0	0
44358255	1174888	0	0
45641244	738818	0	0
44355089	1119510	0	0
45626688	1305058	0	0
45657124	1115008	0	0
45780914	40162522	2	3
45707141	1125315	0	0
45669583	1177480	0	0
45673029	19132304	2	3
45625027	1125315	0	0
45786939	1125315	0	0
45675836	740275	0	0
45703088	1125315	0	0
46243119	1107830	0	0
46243415	1112807	0	0
45791240	1125315	0	0
45798928	1125315	0	0
46307409	1177480	0	0
46301740	1115008	0	0
44361216	1125315	0	0
3029702	3006906	1	1
4297090	4145310	4	4
21001472	1539411	2	3
21502709	1129625	7	7
21505699	1119510	1	1
36158601	1192710	0	0
36159216	933724	0	0
36516781	4035415	2	3
40487842	4047491	5	5
42801528	1343916	0	0
44355448	1129625	0	0
45640518	1192710	0	0
44358117	1539403	0	0
45642982	1174888	0	0
44355138	1119510	0	0
45623286	738818	0	0
45657168	1154343	0	0
45783534	19008572	2	3
45707486	1125315	0	0
45669759	1177480	0	0
45673147	40231925	2	3
45625033	1125315	0	0
45786740	1125315	0	0
45675663	1778162	0	0
45703089	1125315	0	0
46243122	738818	0	0
46243354	1153428	0	0
45791355	1125315	0	0
45798930	1125315	0	0
46307682	1177480	0	0
46301394	1115008	0	0
44360930	1125315	0	0
3025200	3024561	1	1
4297090	4062501	4	4
21001472	1545959	2	3
21500120	1539403	7	7
21500367	1137529	1	1
36158602	738818	0	0
36159356	1343916	0	0
36474269	1332419	2	3
40789534	3008598	5	5
42801477	1557272	0	0
44355306	1332418	0	0
45640559	1192710	0	0
44357828	1115008	0	0
45642987	1149196	0	0
44354940	1119510	0	0
45623294	738818	0	0
45657490	1107830	0	0
45783181	40236824	2	3
45707222	1125315	0	0
45669613	1177480	0	0
45673211	19078461	2	3
45625039	1125315	0	0
45786648	1125315	0	0
45675669	1192710	0	0
45702778	1125315	0	0
46243126	1192710	0	0
46243449	1322184	0	0
45791211	1125315	0	0
45798950	1125315	0	0
46302453	1177480	0	0
46319563	1115008	0	0
46310771	1125315	0	0
3025200	3023103	1	1
4297090	40478878	4	4
21001578	19018935	2	3
21500120	1521369	7	7
21500367	1154343	1	1
36158639	1192710	0	0
36159426	1177480	0	0
36424040	964261	2	3
37203784	4048171	5	5
42801322	1545958	0	0
44355269	1129625	0	0
45640619	1174888	0	0
44354673	1118084	0	0
45642911	1107830	0	0
44354945	1119510	0	0
45623295	738818	0	0
45657448	1118084	0	0
45781052	1115171	2	3
45707243	1125315	0	0
45780810	1177480	0	0
45670025	19075001	2	3
45670319	1125315	0	0
45786749	1125315	0	0
45676094	1115008	0	0
45703030	1125315	0	0
46243208	1332418	0	0
46243322	1713332	0	0
45791492	1125315	0	0
45798589	1125315	0	0
46302373	1177480	0	0
46319472	1115008	0	0
46310784	1125315	0	0
3025200	3020630	1	1
4326426	4323902	4	4
4297090	4012477	2	5
21500120	19127890	7	7
21503649	1112807	1	1
36158556	1107830	0	0
36159055	1149196	0	0
36424575	46275916	2	3
37503997	4108705	5	5
42801380	1124300	0	0
44355368	791967	0	0
45640757	1174888	0	0
44354488	1000560	0	0
45642932	1738521	0	0
44354949	1119510	0	0
45623296	1343916	0	0
45657293	967823	0	0
45781143	40162522	2	3
45707598	1125315	0	0
45780908	1177480	0	0
45669942	1107882	2	3
45670470	1125315	0	0
45786710	1125315	0	0
45675913	1124300	0	0
45702999	1125315	0	0
46244644	1192710	0	0
46243345	1112807	0	0
45791277	1125315	0	0
45798482	1125315	0	0
46299662	1177480	0	0
46313560	1115008	0	0
46310799	1125315	0	0
3025200	3006906	1	1
4326426	4242997	4	4
4297090	4010253	2	6
21500263	1539411	6	7
21503649	1125315	1	1
36158753	1177480	0	0
36159364	1778162	0	0
36516825	4035415	2	2
42888893	4084167	6	6
42801381	715997	0	0
44355377	1129625	0	0
45640758	1322184	0	0
44354613	1000560	0	0
45642936	1713332	0	0
44354952	1119510	0	0
45623312	1174888	0	0
45657491	738818	0	0
45781013	1115171	2	3
45707599	1125315	0	0
45780966	1177480	0	0
45670173	1551192	2	3
45670621	1125315	0	0
45786920	1125315	0	0
45675954	740275	0	0
45703074	1125315	0	0
46244710	1112807	0	0
46243428	1307863	0	0
45791564	1125315	0	0
45798479	1125315	0	0
46299723	1177480	0	0
46314257	1115008	0	0
46310690	1125315	0	0
3025200	3014576	1	1
4297887	198809	4	4
4322976	4125906	2	7
21500263	1545959	6	7
21503649	1129625	1	1
36158758	1154343	0	0
36159471	1107830	0	0
36516825	80502	2	2
37502341	4163971	6	6
42803048	1713332	0	0
44355377	1177480	0	0
45640771	1153428	0	0
44354617	1738521	0	0
45643048	715997	0	0
44355051	1119510	0	0
45623313	1501700	0	0
45656971	1548195	0	0
45780987	19125062	2	3
45707509	1125315	0	0
45781241	1177480	0	0
45670076	19076374	2	3
45670520	1125315	0	0
45786922	1125315	0	0
45676059	1307863	0	0
45702979	1125315	0	0
46240900	1149196	0	0
46243472	1000560	0	0
45791547	1125315	0	0
45798592	1125315	0	0
46299644	1177480	0	0
46309080	1115008	0	0
46310717	1125315	0	0
3025200	3019550	1	1
4306073	4337611	4	4
4274025	80809	2	6
21503764	40229134	6	7
21505668	1119510	1	1
36158704	1107830	0	0
36159161	1738521	0	0
40039778	42902245	2	2
37602356	313217	6	7
42803050	1112807	0	0
44355380	1124957	0	0
45637368	1367571	0	0
44354413	933724	0	0
45643079	1343916	0	0
44355181	1119510	0	0
45623324	1115008	0	0
45657307	1713332	0	0
45781015	1115171	2	3
45707462	1125315	0	0
45781078	1177480	0	0
45670111	1545959	2	3
45670636	1125315	0	0
45786844	1125315	0	0
45675887	1500211	0	0
45703693	1125315	0	0
46241088	1118084	0	0
46243532	1322184	0	0
45791452	1125315	0	0
45798593	1125315	0	0
46300053	1177480	0	0
46309107	1115008	0	0
46305675	1125315	0	0
3025200	3013721	1	1
4306073	4323902	4	4
21001107	19074679	1	1
21601386	19007333	6	7
21505668	1174888	1	1
36158648	1129625	0	0
36159162	1129625	0	0
36703477	4029498	2	2
37602360	313217	6	7
42803053	1713332	0	0
44355384	1192710	0	0
45637497	1124300	0	0
44354639	1149196	0	0
45643080	1124957	0	0
44355198	1119510	0	0
45623484	1343916	0	0
45657314	1713332	0	0
45781064	40229134	2	3
45707418	1125315	0	0
45778617	1177480	0	0
45669908	40228214	2	3
45670429	1125315	0	0
45786931	1125315	0	0
45675850	1107830	0	0
45703772	1125315	0	0
46240800	1500211	0	0
46243537	1515774	0	0
45791500	1125315	0	0
45798595	1125315	0	0
46300137	1177480	0	0
46309408	1115008	0	0
46305736	1125315	0	0
3025200	3004501	1	1
4207186	4112343	4	4
21001138	19074679	1	1
21495748	3024731	4	4
21603458	1192710	2	2
36158744	1149196	0	0
36159164	1154029	0	0
36303153	4191853	2	2
37600000	4310024	6	7
42803053	1759842	0	0
44355360	1129625	0	0
45637081	1539403	0	0
44354762	1713332	0	0
45643807	1154343	0	0
44347769	1119510	0	0
45623628	1115008	0	0
45657380	1149196	0	0
45780697	40174880	2	3
45704437	1125315	0	0
45778634	1177480	0	0
45783716	40232448	2	3
45669011	1125315	0	0
45786776	1125315	0	0
45675899	1112807	0	0
45703650	1125315	0	0
46240802	1738521	0	0
46243537	1549786	0	0
46298538	1125315	0	0
45798598	1125315	0	0
46296124	1177480	0	0
46308974	1115008	0	0
46305738	1125315	0	0
3025200	3035995	1	1
4201745	28060	4	5
19125489	19128263	1	1
21495748	3002385	4	4
21603503	1150836	2	2
36158634	1129625	0	0
36159171	1307863	0	0
36475223	42902245	2	2
37302325	4066995	6	7
42803175	1545958	0	0
44355464	1192710	0	0
45637537	738818	0	0
44354762	1759842	0	0
45641310	1107830	0	0
44347846	1119510	0	0
45623546	1000560	0	0
45657386	1192710	0	0
45780857	40229134	2	3
45704727	1125315	0	0
45778670	1177480	0	0
45783768	40229134	2	3
45669119	1125315	0	0
45786875	1125315	0	0
45675930	975125	0	0
45703715	1125315	0	0
46240869	1112807	0	0
46243538	975125	0	0
46298711	1125315	0	0
45798704	1125315	0	0
46318469	1177480	0	0
46309379	1115008	0	0
46305749	1125315	0	0
3025200	3016723	1	1
4208786	4149245	4	5
19125489	19128022	1	1
21604180	715997	4	4
21603503	1150770	2	2
36158664	1548195	0	0
36159177	1332418	0	0
36314293	4314290	2	2
37203758	28060	6	7
42803386	1115008	0	0
44354286	1192710	0	0
45637466	1115008	0	0
44354674	933724	0	0
45641309	1115008	0	0
44347857	1119510	0	0
45623393	967823	0	0
45657056	1000560	0	0
45778549	40229134	2	3
45704827	1125315	0	0
45778596	1177480	0	0
45783723	40169281	2	3
45669057	1125315	0	0
45786714	1125315	0	0
45675790	791967	0	0
45703717	1125315	0	0
46240728	1112807	0	0
46243541	975125	0	0
46298716	1125315	0	0
45799845	1125315	0	0
46318480	1177480	0	0
46303718	1115008	0	0
46305606	1125315	0	0
3025200	3013682	1	1
4300244	4336464	4	5
19039300	19023398	1	1
21604180	791967	4	4
21603503	1153428	2	2
36158765	1177480	0	0
36159369	1129625	0	0
36516972	80180	2	2
37203758	4048171	6	9
42801553	1309944	0	0
44354296	1112807	0	0
45637474	1115008	0	0
44354767	738818	0	0
45641346	1174888	0	0
44347820	1119510	0	0
45623527	1501700	0	0
45657459	1310149	0	0
45778613	40229134	2	3
45704842	1125315	0	0
45779055	1177480	0	0
45783759	19073183	2	3
45669070	1125315	0	0
45786851	1125315	0	0
45676100	1124957	0	0
45703096	1125315	0	0
46240823	1332418	0	0
46243470	1539403	0	0
46298417	1125315	0	0
45799859	1125315	0	0
46318712	1177480	0	0
46303846	1115008	0	0
46305763	1125315	0	0
1551198	1551192	1	1
4302537	4027663	4	5
4323715	4108705	1	1
21604180	1102527	4	4
21603503	1107830	2	2
36158768	975125	0	0
36159375	1149196	0	0
40772935	3008598	6	6
37203758	258780	6	9
42801563	914335	0	0
44354352	1326303	0	0
45637505	791967	0	0
44354769	1124957	0	0
45641423	967823	0	0
44347826	1119510	0	0
45623351	1124300	0	0
45657061	1115008	0	0
45778642	40162522	2	3
45704843	1125315	0	0
45707419	1177480	0	0
45783867	1115171	2	3
45669076	1125315	0	0
45786787	1125315	0	0
45675902	975125	0	0
45703165	1125315	0	0
46240870	738818	0	0
46243554	1545958	0	0
46298689	1125315	0	0
45799005	1125315	0	0
46318988	1177480	0	0
46304123	1115008	0	0
46305813	1125315	0	0
1127530	19133768	1	1
4302537	196456	4	5
4323193	78272	1	1
21604180	708298	4	4
21602819	1746114	2	2
36158638	742185	0	0
36159383	1129625	0	0
36516825	4230399	6	6
36718595	375671	6	8
42801601	1125315	0	0
44354351	1177480	0	0
45637170	914335	0	0
44354772	738818	0	0
45641389	1310149	0	0
44347526	1119510	0	0
45623459	1738521	0	0
45657073	1115008	0	0
45778673	40223834	2	3
45704775	1125315	0	0
45704740	1177480	0	0
45783873	19008572	2	3
45669156	1125315	0	0
45786878	1125315	0	0
45676004	791967	0	0
45703182	1125315	0	0
46240883	1308738	0	0
46243555	1551099	0	0
46298722	1125315	0	0
45799006	1125315	0	0
46312664	1177480	0	0
46320565	1115008	0	0
46306110	1125315	0	0
792033	19057271	1	1
4244662	4237458	4	6
4308656	4301346	1	1
21602681	1551099	4	4
21602819	1713332	2	2
36158585	1118084	0	0
36159389	1107830	0	0
37502353	4043071	6	6
36718595	378001	6	8
42801581	1119510	0	0
44354299	1177480	0	0
45637172	1115008	0	0
44354773	920293	0	0
45641335	1343916	0	0
44347678	1119510	0	0
45623735	933724	0	0
45657216	740275	0	0
45778678	40229134	2	3
45704960	1125315	0	0
45704736	1177480	0	0
45783989	40229134	2	3
45669023	1125315	0	0
45786794	1125315	0	0
45676101	1551099	0	0
45703192	1125315	0	0
46240832	705944	0	0
46243476	1192710	0	0
46298859	1125315	0	0
45799017	1125315	0	0
46312547	1177480	0	0
46320378	1115008	0	0
46305944	1125315	0	0
793135	46221626	1	1
4244662	4142905	4	6
4306169	4102123	1	1
21602681	975125	4	4
21603491	1149196	2	2
36158590	1112807	0	0
36159529	1124957	0	0
36903632	4043241	6	6
36718595	378419	6	7
42801554	1778162	0	0
44354355	1129625	0	0
45637509	1332418	0	0
44354774	1124300	0	0
45637942	1124300	0	0
44347720	1119510	0	0
45623418	1107830	0	0
45657340	1545958	0	0
45778889	19019273	2	3
45704882	1125315	0	0
45704787	1177480	0	0
45781626	19078461	2	3
45669309	1125315	0	0
45786798	1125315	0	0
45675800	975125	0	0
45703278	1125315	0	0
46240935	1713332	0	0
46240856	967823	0	0
46298643	1125315	0	0
45799030	1125315	0	0
46312534	1177480	0	0
46320661	1115008	0	0
46305962	1125315	0	0
793136	46221626	1	1
4244662	4149245	4	6
4272162	4266809	1	1
21602681	1501700	4	4
21602515	1549786	2	2
36158660	1107830	0	0
36159540	1521369	0	0
36303153	4163872	6	6
36718595	4043241	8	9
42801569	1177480	0	0
44354359	1112807	0	0
45637539	1501700	0	0
44354797	1548195	0	0
45637944	1539403	0	0
44347722	1119510	0	0
45623438	1343916	0	0
45655363	1000560	0	0
45778975	1127433	2	3
45704562	1125315	0	0
45704975	1177480	0	0
45781568	19023398	2	3
45669293	1125315	0	0
45786964	1125315	0	0
45675872	1154029	0	0
45703221	1125315	0	0
46240935	1759842	0	0
46241051	19003953	0	0
46298782	1125315	0	0
45799038	1125315	0	0
46313054	1177480	0	0
46321276	1115008	0	0
46306113	1125315	0	0
782046	782047	1	1
4244662	40480160	4	6
4272488	81893	1	1
21500263	1539403	4	4
21602515	1548195	2	2
36158710	1177480	0	0
36159540	1595799	0	0
36303153	4314290	6	6
37503992	4057420	5	8
42801636	19127890	0	0
44354363	1545958	0	0
45637559	791967	0	0
44354542	1713332	0	0
45638092	933724	0	0
44347864	1119510	0	0
45623576	1501700	0	0
45655473	1124957	0	0
45707349	1545959	2	3
45704563	1125315	0	0
45704937	1177480	0	0
45781455	40232448	2	3
45669256	1125315	0	0
45786886	1125315	0	0
45675960	975125	0	0
45700124	1125315	0	0
46240970	1713332	0	0
46242539	1112807	0	0
46298988	1125315	0	0
45793548	1125315	0	0
46312851	1177480	0	0
46320638	1115008	0	0
46305901	1125315	0	0
444130	4109685	1	1
4302537	4266809	4	6
4247120	4027663	1	1
21500263	1308738	4	4
21603446	1129625	2	2
36158685	1112807	0	0
36159540	1549786	0	0
40772948	3036780	6	6
37503992	4043071	5	5
42801636	1515774	0	0
44354373	1177480	0	0
45637110	1322184	0	0
44354620	715997	0	0
45638095	1396131	0	0
44348587	1119510	0	0
45623627	1322184	0	0
45655373	967823	0	0
45707538	1115171	2	3
45704891	1125315	0	0
45701209	1177480	0	0
45781301	1115171	2	3
45669314	1125315	0	0
45786893	1125315	0	0
45675962	1192710	0	0
45700107	1125315	0	0
46240970	1759842	0	0
46242541	1551099	0	0
46298991	1125315	0	0
45793504	1125315	0	0
46313035	1177480	0	0
46314305	1115008	0	0
46305902	1125315	0	0
444129	78272	1	1
4302537	4310024	4	6
21505898	1125315	1	1
21500263	1545958	4	4
21603446	40232448	2	2
36158873	1115008	0	0
36159312	1129625	0	0
40772948	3021226	6	6
37503992	4337611	5	6
42801636	1549786	0	0
44354319	975125	0	0
45637192	1154029	0	0
44354574	1332418	0	0
45638109	1713332	0	0
44348553	1119510	0	0
45623562	1551099	0	0
45655449	1515774	0	0
45707120	40165015	2	3
45704569	1125315	0	0
45703453	1177480	0	0
45781305	19029476	2	3
45669379	1125315	0	0
45786896	1125315	0	0
45675966	1124300	0	0
45699932	1125315	0	0
46240949	738818	0	0
46242544	1102527	0	0
46298573	1125315	0	0
45793507	1125315	0	0
46307791	1177480	0	0
46317384	1115008	0	0
46305843	1125315	0	0
444191	4156265	1	1
4244662	81151	4	7
21506024	914335	1	1
21503967	40231925	5	6
21603446	738818	2	2
36158712	1107830	0	0
36159543	1129625	0	0
40772948	3023430	6	6
37503992	4125906	6	6
42801630	1545958	0	0
44354334	1112807	0	0
45637198	1343916	0	0
44354681	723013	0	0
45638109	1759842	0	0
44348328	1119510	0	0
45623645	1124957	0	0
45655347	1124300	0	0
45707582	19019273	2	3
45704570	1125315	0	0
45703693	1177480	0	0
45781814	40232448	2	3
45669144	1125315	0	0
45786900	1125315	0	0
45676104	1112807	0	0
45699935	1125315	0	0
46241053	1154029	0	0
46242167	1124300	0	0
46298873	1125315	0	0
45793575	1125315	0	0
46307955	1177480	0	0
46315287	1115008	0	0
46305974	1125315	0	0
377091	4029498	1	1
21001472	1539403	0	0
21505882	1557272	1	1
21002493	19128009	1	1
21603255	1154343	2	2
36158717	1713332	0	0
36159363	738818	0	0
40772948	3014599	6	6
37503992	4336464	6	10
42801613	1124300	0	0
44354395	1332418	0	0
45637381	1551099	0	0
44354798	1149196	0	0
45638120	1174888	0	0
44348556	1119510	0	0
45623652	1107830	0	0
45655449	1548195	0	0
45707305	1115171	2	3
45704965	1125315	0	0
45703408	1177480	0	0
45781816	40162522	2	3
45666630	1125315	0	0
45789112	1125315	0	0
45676011	1361711	0	0
45700246	1125315	0	0
46240904	791967	0	0
46242289	1107830	0	0
46298892	1125315	0	0
45793672	1125315	0	0
46308120	1177480	0	0
46315159	1115008	0	0
46306018	1125315	0	0
4003535	4330583	1	1
21001475	1310149	0	0
21500563	701322	1	1
21001922	1154615	1	1
21603255	1137529	2	2
36158717	1759842	0	0
36159504	1149196	0	0
37303790	133834	6	6
37503992	4197460	3	4
42801726	1124300	0	0
44354374	19127890	0	0
45637480	738818	0	0
44354799	1149380	0	0
45637970	738818	0	0
44347965	1119510	0	0
45623653	1595799	0	0
45655458	1174888	0	0
45707311	40224805	2	3
45704968	1125315	0	0
45701478	1177480	0	0
45781817	40236824	2	3
45666753	1125315	0	0
45786233	1125315	0	0
45676014	1192710	0	0
45700251	1125315	0	0
46240907	1153428	0	0
46242294	975125	0	0
46299220	1125315	0	0
45793613	1125315	0	0
46307480	1177480	0	0
46315331	1115008	0	0
46306021	1125315	0	0
1768904	19074841	1	1
21001483	1728416	0	0
21500563	757627	1	1
21013543	40171902	1	1
21602798	1738521	2	2
36158726	1124300	0	0
36159507	1305058	0	0
36703477	378001	6	6
37503992	4117038	3	7
42803389	1545958	0	0
44354374	1549786	0	0
45637481	1107830	0	0
44354803	975125	0	0
45638059	1713332	0	0
44348002	1119510	0	0
45623653	1521369	0	0
45655463	1124957	0	0
45707387	1551192	2	3
45704870	1125315	0	0
45698267	1177480	0	0
45781721	19059056	2	3
45666783	1125315	0	0
45786237	1125315	0	0
45676157	1361711	0	0
45700077	1125315	0	0
46240951	1545958	0	0
46242497	1738521	0	0
46298937	1125315	0	0
45793604	1125315	0	0
46307607	1177480	0	0
46309687	1115008	0	0
46306026	1125315	0	0
201337	195588	1	1
21001463	1307863	0	0
21500548	1125315	1	1
257012	257012	0	0
21602119	1149380	2	2
36158877	1000560	0	0
36159545	933724	0	0
36703477	375671	6	6
37503992	4323902	3	7
42803305	1149380	0	0
44354397	1129625	0	0
45637200	1000560	0	0
44354722	1124300	0	0
45638039	1124957	0	0
44348105	1119510	0	0
45623653	1549786	0	0
45655406	1124957	0	0
45707727	19018935	2	3
45704970	1125315	0	0
45698405	1177480	0	0
45781545	40162522	2	3
45666872	1125315	0	0
45786278	1125315	0	0
45676134	1738521	0	0
45700081	1125315	0	0
46241062	933724	0	0
46242365	1118084	0	0
46298939	1125315	0	0
45793783	1125315	0	0
46308065	1177480	0	0
46309738	1115008	0	0
46306028	1125315	0	0
4008090	4043241	1	1
21001472	1545958	0	0
21500548	1129625	1	1
192671	192671	0	0
21602496	1519936	2	2
36158735	1115008	0	0
36159475	1177480	0	0
40792793	3002385	6	6
37503992	4323208	3	3
42803226	1548195	0	0
44354423	1149196	0	0
45637319	1154343	0	0
44354723	738818	0	0
45638042	738818	0	0
44348111	1119510	0	0
45623782	1332418	0	0
45655397	742185	0	0
45707679	1115171	2	3
45705018	1125315	0	0
45698269	1177480	0	0
45781298	1115171	2	3
45666936	1125315	0	0
45786438	1125315	0	0
45676016	1192710	0	0
45700199	1125315	0	0
46241090	738818	0	0
46242368	975125	0	0
46298656	1125315	0	0
45793517	1125315	0	0
46302648	1177480	0	0
46310106	1115008	0	0
46306037	1125315	0	0
1305130	19007333	1	1
21001483	1717327	0	0
21500578	1129625	1	1
1101498	1177480	0	0
21602840	1728416	2	2
36158879	1153428	0	0
36159492	1129625	0	0
40792793	3007461	6	6
37503992	4198190	7	9
42803308	1124300	0	0
44354519	1759842	0	0
45637545	19010482	0	0
44354848	1717327	0	0
45638050	1551099	0	0
44348246	1119510	0	0
45623716	1115008	0	0
45653912	1192710	0	0
45707683	1551192	2	3
45705028	1125315	0	0
45698329	1177480	0	0
45781311	40231925	2	3
45666963	1125315	0	0
45786431	1125315	0	0
45676114	914335	0	0
45700205	1125315	0	0
46241068	1112807	0	0
46242450	1112807	0	0
46291665	1125315	0	0
45793624	1125315	0	0
46302873	1177480	0	0
46304344	1115008	0	0
46305856	1125315	0	0
708336	19078924	1	1
21001486	1728416	0	0
21500563	836654	1	1
1101482	1361711	0	0
21602840	1729720	2	2
36158881	1149196	0	0
36159500	1129625	0	0
36703477	4043241	6	7
37503992	4295880	4	4
42803467	1729720	0	0
44354519	1713332	0	0
45637561	715997	0	0
44354684	1310149	0	0
45638055	1501700	0	0
44340728	1119510	0	0
45667698	1110410	0	0
45653862	1118084	0	0
45707585	40232448	2	3
45705030	1125315	0	0
45698234	1177480	0	0
45781677	19008572	2	3
45667027	1125315	0	0
45786575	1125315	0	0
45675865	967823	0	0
45697612	1125315	0	0
45792444	1115171	2	3
46241131	1000560	0	0
46291669	1125315	0	0
45793626	1125315	0	0
46302759	1177480	0	0
46304840	1115008	0	0
46322295	1125315	0	0
723162	19076374	1	1
21001486	1717327	0	0
4324765	4035415	1	1
1101498	1115008	0	0
35506542	140673	2	2
36158760	723013	0	0
36159502	1107830	0	0
36516772	4230399	6	7
37503992	4108705	4	6
42803448	740275	0	0
44354436	738818	0	0
45637562	738818	0	0
44354695	1713332	0	0
45638173	1000560	0	0
44340744	1119510	0	0
45667684	1115008	0	0
45653865	920293	0	0
45707732	19008572	2	3
45701268	1125315	0	0
45698690	1177480	0	0
45781689	40162522	2	3
45667040	1125315	0	0
45785309	1125315	0	0
45672883	1107830	0	0
45697613	1125315	0	0
45792537	1115171	2	3
46241208	1149196	0	0
46291843	1125315	0	0
45793539	1125315	0	0
46303078	1177480	0	0
46305115	1115008	0	0
46322299	1125315	0	0
201891	4310024	1	1
21001487	1728416	0	0
19124099	19127904	1	1
1101539	1177480	0	0
21602538	40224805	2	2
36158722	1149196	0	0
36159508	1177480	0	0
36303153	4252419	6	7
37503992	44783196	4	6
42803400	1125315	0	0
44354431	1343916	0	0
45637261	1107830	0	0
44354695	1759842	0	0
45638234	1332418	0	0
44340798	1119510	0	0
45667716	1115008	0	0
45653926	1107830	0	0
45707422	43012036	2	3
45701272	1125315	0	0
45698518	1177480	0	0
45783596	40229134	2	3
45666943	1125315	0	0
45785345	1125315	0	0
45672887	1118084	0	0
45697773	1125315	0	0
45792683	19019273	2	3
46241216	1713332	0	0
46290400	1125315	0	0
45793849	1125315	0	0
46303025	1177480	0	0
46304686	1115008	0	0
46322450	1125315	0	0
201618	4266809	1	1
21001488	1717327	0	0
21000640	19128263	1	1
1101489	1305058	0	0
21602538	40224132	2	2
36110722	198199	0	0
36159429	19127890	0	0
36516972	4230399	6	7
37500000	44805732	4	4
42803339	1124300	0	0
44354467	1548195	0	0
45637267	975125	0	0
44354886	1545958	0	0
45638177	1115008	0	0
44340981	1119510	0	0
45667395	1332418	0	0
45653939	1149196	0	0
45704590	19078461	2	3
45701121	1125315	0	0
45698607	1177480	0	0
45783601	1107882	2	3
45666903	1125315	0	0
45785271	1125315	0	0
45672908	1154343	0	0
45697777	1125315	0	0
45792652	1115171	2	3
46241154	1115008	0	0
46290402	1125315	0	0
45793804	1125315	0	0
46300500	1177480	0	0
46321547	1115008	0	0
46322625	1125315	0	0
201909	45769019	1	1
21001456	1112807	0	0
21000640	42902245	1	1
1101498	1118084	0	0
21602538	1500211	2	2
36110689	257012	0	0
36159429	1521369	0	0
37522270	4198190	6	8
37500000	4117038	4	9
42803487	1545958	0	0
44354426	715997	0	0
45637268	975125	0	0
44354900	1309944	0	0
45638169	1154343	0	0
44340833	1119510	0	0
45667726	1539403	0	0
45653913	1738521	0	0
45704635	19073188	2	3
45701208	1125315	0	0
45695240	1177480	0	0
45781902	40232448	2	3
45666848	1125315	0	0
45785273	1125315	0	0
45672893	1118084	0	0
45696895	1125315	0	0
45792458	1115171	2	3
46241119	1192710	0	0
46290385	1125315	0	0
45793741	1125315	0	0
46319070	1177480	0	0
46320825	1115008	0	0
46322626	1125315	0	0
320136	317009	1	1
21001493	1728416	0	0
21000640	19128022	1	1
1101553	1137529	0	0
21602485	19127904	2	2
36110708	4283893	0	0
36159429	1549786	0	0
36303153	4058899	6	8
37500000	4163971	4	10
42803548	975125	0	0
44354851	1545958	0	0
45637430	914335	0	0
44354873	740275	0	0
45638171	1713332	0	0
44340769	1119510	0	0
45667843	705944	0	0
45653904	1305058	0	0
45704595	19023398	2	3
45701169	1125315	0	0
45695276	1177480	0	0
45779235	19059056	2	3
45666986	1125315	0	0
45785360	1125315	0	0
45672959	1115008	0	0
45696977	1125315	0	0
45789622	19133905	2	3
46241122	1137529	0	0
46290396	1125315	0	0
45793815	1125315	0	0
46319088	1177480	0	0
46321315	1115008	0	0
46322627	1125315	0	0
256451	260139	1	1
21001456	1322184	0	0
4297706	4186930	1	1
1101553	1149380	0	0
21602104	975125	2	2
36110597	255848	0	0
36159556	1549786	0	0
36303153	80502	6	8
37500000	4107731	4	8
42803841	1124957	0	0
44354365	1000560	0	0
45637432	1115008	0	0
44354696	1551099	0	0
45638171	1759842	0	0
44340952	1119510	0	0
45667400	1367571	0	0
45653953	1713332	0	0
45704596	40232448	2	3
45701360	1125315	0	0
45695338	1177480	0	0
45779358	40236446	2	3
45666826	1125315	0	0
45785302	1125315	0	0
45673120	1107830	0	0
45696912	1125315	0	0
45789763	19133905	2	3
46241122	1149380	0	0
46290474	1125315	0	0
45793691	1125315	0	0
46239787	1177480	0	0
46321101	1115008	0	0
46322080	1125315	0	0
320136	257012	2	5
21001485	1717327	0	0
19127892	19127918	1	1
1101492	1367571	0	0
21602543	19054876	2	2
36150676	1124300	0	0
36159556	1512674	0	0
36703532	4001336	6	8
37500000	4336464	3	12
42803737	1124300	0	0
44354449	708298	0	0
45637291	1149196	0	0
44354993	1192710	0	0
45638183	738818	0	0
44340843	1119510	0	0
45667793	967823	0	0
45653941	1154343	0	0
45704440	19059056	2	3
45701383	1125315	0	0
45692092	1177480	0	0
45779376	1127433	2	3
45667045	1125315	0	0
45785351	1125315	0	0
45672935	1713332	0	0
45697123	1125315	0	0
45789763	19133873	2	3
46241124	1149196	0	0
46290527	1125315	0	0
45793586	1125315	0	0
46239946	1177480	0	0
46321625	1115008	0	0
46322678	1125315	0	0
320136	258780	4	7
21001477	1310149	0	0
19127892	19127904	1	1
1101539	1115008	0	0
21603283	1149380	2	2
36150681	1115008	0	0
36159559	1129625	0	0
36303153	4329847	6	12
37500000	4242997	3	9
42803340	1129625	0	0
44354450	1129625	0	0
45637309	1307863	0	0
44354637	1310149	0	0
45638251	1549786	0	0
44340854	1119510	0	0
45667806	1115008	0	0
45653975	1308738	0	0
45704445	19129655	2	3
45701292	1125315	0	0
45691793	1177480	0	0
45779377	1127433	2	3
45667051	1125315	0	0
45785352	1125315	0	0
45672936	757627	0	0
45696926	1125315	0	0
45789635	40223834	2	3
46241216	1759842	0	0
46290393	1125315	0	0
45788351	1125315	0	0
46321769	1177480	0	0
46320733	1115008	0	0
46317129	1125315	0	0
320136	4048171	4	7
21001477	1367571	0	0
19127892	19128065	1	1
1101544	1557272	0	0
21603933	1118084	2	2
36150693	1107830	0	0
36159559	1177480	0	0
36303153	195588	6	11
37500000	4059978	3	3
42803341	1729720	0	0
44354452	1129625	0	0
45637310	1713332	0	0
44354817	1118084	0	0
45638251	1595799	0	0
44341042	1119510	0	0
45667911	1149196	0	0
45654019	1124300	0	0
45704448	40223768	2	3
45701404	1125315	0	0
45692274	1177480	0	0
45779318	19018935	2	3
45666956	1125315	0	0
45785293	1125315	0	0
45672914	791967	0	0
45697016	1125315	0	0
45789651	40236824	2	3
46241218	1332418	0	0
46290602	1125315	0	0
45788375	1125315	0	0
46322234	1177480	0	0
46321305	1115008	0	0
46317105	1125315	0	0
320136	255848	4	5
21001028	742185	0	0
19127892	19128263	1	1
1101530	914335	0	0
21603933	1115008	2	2
36150696	1521369	0	0
36159320	738818	0	0
36303153	260139	6	11
37500000	4275113	3	3
42803318	1129625	0	0
44354452	1112807	0	0
45637491	1551099	0	0
44354994	1539403	0	0
45638251	1521369	0	0
44340914	1119510	0	0
45667922	914335	0	0
45654127	1153428	0	0
45704643	40236446	2	3
45701175	1125315	0	0
45692265	1177480	0	0
45780518	1107882	2	3
45666909	1125315	0	0
45785369	1125315	0	0
45672930	1112807	0	0
45696892	1125315	0	0
45789782	19018935	2	3
46241224	1713332	0	0
46290711	1125315	0	0
45788353	1125315	0	0
46321937	1177480	0	0
46315344	1115008	0	0
46317147	1125315	0	0
320136	40481087	4	5
21001028	705944	0	0
19127892	40221415	1	1
1101498	1124300	0	0
21603933	1177480	2	2
36150698	1149380	0	0
36159576	933724	0	0
36516972	4278672	4	6
37500000	4125906	8	8
42803457	1545958	0	0
44354453	1115008	0	0
45637516	1154029	0	0
44354795	1738521	0	0
45638342	1149196	0	0
44340922	1119510	0	0
45667933	1501700	0	0
45654088	1545958	0	0
45704819	19008572	2	3
45703452	1125315	0	0
45691799	1177480	0	0
45780620	19019273	2	3
45667003	1125315	0	0
45785364	1125315	0	0
45673042	1107830	0	0
45697057	1125315	0	0
45789682	19008572	2	3
46241224	1759842	0	0
46290875	1125315	0	0
45788474	1125315	0	0
46322341	1177480	0	0
46315635	1115008	0	0
46311272	1125315	0	0
320136	28060	4	5
21001038	1717327	0	0
19127892	19128022	1	1
1102527	1102527	0	0
21602818	1728416	2	2
36150699	1124300	0	0
36159462	1177480	0	0
36516972	40480160	4	6
37500000	4293740	5	5
42803420	975125	0	0
44354573	1332418	0	0
45637517	920293	0	0
44355069	1115008	0	0
45638305	1124957	0	0
44340924	1119510	0	0
45667936	1124957	0	0
45653980	1000560	0	0
45704878	40174880	2	3
45703459	1125315	0	0
45692243	1177480	0	0
45780701	40229134	2	3
45667124	1125315	0	0
45785578	1125315	0	0
45673043	975125	0	0
45696980	1125315	0	0
45789962	43012036	2	3
46241307	1115008	0	0
46290448	1125315	0	0
45788176	1125315	0	0
46316381	1177480	0	0
46315547	1115008	0	0
46311332	1125315	0	0
138239	78272	4	6
21001034	1728416	0	0
4297090	4191853	1	1
903356	19010482	0	0
21602818	1741122	2	2
36150807	1746114	0	0
36159029	1738521	0	0
36516972	81151	4	7
37500000	4301346	5	8
42803334	1125315	0	0
44354434	1322184	0	0
45637519	1153428	0	0
44354739	933724	0	0
45638380	1729720	0	0
44340894	1119510	0	0
45667609	1153428	0	0
45653984	1309944	0	0
45704970	40229134	2	3
45701456	1125315	0	0
45692305	1177480	0	0
45780706	1107882	2	3
45666998	1125315	0	0
45785398	1125315	0	0
45673220	1501700	0	0
45697002	1125315	0	0
45789151	19018935	2	3
46241138	1149196	0	0
46290779	1125315	0	0
45788463	1125315	0	0
46310721	1177480	0	0
46315875	1115008	0	0
46311661	1125315	0	0
138239	4278672	4	5
21001033	1778162	0	0
21001462	40171902	1	1
903327	1124300	0	0
21602818	1746114	2	2
36150807	1741122	0	0
36159031	1153428	0	0
36516972	4149245	4	7
37500000	44783196	5	8
42803528	1125315	0	0
44354568	1308738	0	0
45637521	1549786	0	0
44354815	975125	0	0
45638443	1551099	0	0
45636976	1119510	0	0
45667617	1154029	0	0
45654009	967823	0	0
45704911	19075601	2	3
45701553	1125315	0	0
45689246	1177480	0	0
45779431	19076374	2	3
45667082	1125315	0	0
45785462	1125315	0	0
45673222	1343916	0	0
45697041	1125315	0	0
45789160	1115171	2	3
46241142	1192710	0	0
46290980	1125315	0	0
45788315	1125315	0	0
46311229	1177480	0	0
46310234	1115008	0	0
46311623	1125315	0	0
138239	40479422	7	8
21001033	1717327	0	0
21001102	19074679	1	1
903386	701322	0	0
21602818	1729720	2	2
36150715	19003953	0	0
36159034	1154029	0	0
36516781	4134304	4	7
40039762	19128009	2	2
40162522	40162522	0	0
44354569	1129625	0	0
45639941	1107830	0	0
44354819	1174888	0	0
45638302	1361711	0	0
45637302	1119510	0	0
45667738	738818	0	0
45654098	1307863	0	0
45705026	19057271	2	3
45701501	1125315	0	0
45689213	1177480	0	0
45779437	40229134	2	3
45667134	1125315	0	0
45785531	1125315	0	0
45673230	1557272	0	0
45697043	1125315	0	0
45789091	1551192	2	3
46241194	1501700	0	0
46290669	1125315	0	0
45788517	1125315	0	0
46310964	1177480	0	0
46312082	1115008	0	0
46311517	1125315	0	0
138239	40479768	7	8
21001035	1778162	0	0
21000643	19128009	1	1
903386	715997	0	0
21602818	1713332	2	2
36150810	1129625	0	0
36159037	1310149	0	0
36516772	81151	4	7
40039762	19127918	2	2
40163554	40163554	0	0
44354662	1326303	0	0
45639831	1149196	0	0
44354830	1713332	0	0
45638445	1124300	0	0
45637397	1119510	0	0
45667751	723013	0	0
45654025	1768849	0	0
45701272	40229134	2	3
45701654	1125315	0	0
45686242	1177480	0	0
45779461	40229134	2	3
45780960	1125315	0	0
45785410	1125315	0	0
45673233	914335	0	0
45697232	1125315	0	0
45787078	19008572	2	3
46241296	1332418	0	0
46290833	1125315	0	0
45788392	1125315	0	0
46310951	1177480	0	0
46310328	1115008	0	0
46311759	1125315	0	0
138239	4146173	5	7
21001035	1728416	0	0
21000643	19127918	1	1
4035415	4035415	0	0
21602818	1717327	2	2
36150855	738818	0	0
36159459	1177480	0	0
36516772	40480160	4	6
37521341	4242997	2	2
37521377	4330583	0	0
44350813	1551099	0	0
45639821	1310149	0	0
44351199	1343916	0	0
45637227	705944	0	0
45637399	1119510	0	0
45667825	1153428	0	0
45654049	1539403	0	0
45701221	19057271	2	3
45701591	1125315	0	0
45686327	1177480	0	0
45707934	19008572	2	3
45780713	1125315	0	0
45785424	1125315	0	0
45672966	1174888	0	0
45697081	1125315	0	0
45787082	19008572	2	3
46241305	1343916	0	0
46291019	1125315	0	0
45788480	1125315	0	0
46305728	1177480	0	0
46305073	1115008	0	0
46311668	1125315	0	0
138239	4149245	5	7
21001035	1717327	0	0
21000643	19128263	1	1
4035793	4035793	0	0
21602858	1741122	2	2
36150860	1129625	0	0
36159460	1153428	0	0
36516772	4142905	4	6
37521694	4043071	2	2
37521342	4242997	0	0
44350612	1115008	0	0
45639825	1396131	0	0
44350878	1548195	0	0
45637125	1717327	0	0
45620724	1119510	0	0
45667402	1307863	0	0
45654027	1309944	0	0
45701383	1127433	2	3
45701592	1125315	0	0
45686248	1177480	0	0
45707950	43012036	2	3
45780643	1125315	0	0
45785495	1125315	0	0
45673176	1192710	0	0
45697302	1125315	0	0
45786991	1551192	2	3
46241248	1112807	0	0
46291036	1125315	0	0
45788440	1125315	0	0
46322513	1177480	0	0
46305089	1115008	0	0
46311822	1125315	0	0
138239	4152936	5	7
21001036	1778162	0	0
21000643	42902245	1	1
4037675	4037675	0	0
21603445	738818	2	2
36150840	701322	0	0
36159585	738818	0	0
36516772	4237458	4	6
37522351	4202451	2	2
43053690	4230399	3	4
44350711	1129625	0	0
45640107	738818	0	0
44351039	1746114	0	0
45637128	738818	0	0
45620746	1119510	0	0
45667760	1717327	0	0
45647311	715997	0	0
45701175	1127433	2	3
45698107	1125315	0	0
45686216	1177480	0	0
45708146	1115171	2	3
45780645	1125315	0	0
45785382	1125315	0	0
45673059	1107830	0	0
45693880	1125315	0	0
45787016	19074679	2	3
46241250	1545958	0	0
46291057	1125315	0	0
45788610	1125315	0	0
46316862	1177480	0	0
46306722	1115008	0	0
46311423	1125315	0	0
138239	4113008	5	5
21001099	708298	0	0
21000643	40221415	1	1
4133840	4133840	0	0
21603445	1150836	2	2
36150825	1551099	0	0
36159588	1713332	0	0
36703500	380378	4	5
40039151	42902245	2	2
43053690	4237458	3	3
44350839	1129625	0	0
45640207	967823	0	0
44351039	1741122	0	0
45634858	1549786	0	0
45661432	1119510	0	0
45667543	1124957	0	0
45647440	1310149	0	0
45703444	42707627	2	3
45698378	1125315	0	0
45686334	1177480	0	0
45707884	40169281	2	3
45778367	1125315	0	0
45785386	1125315	0	0
45673305	1112807	0	0
45693897	1125315	0	0
45787219	1115171	2	3
46241283	1545958	0	0
46291069	1125315	0	0
45788598	1125315	0	0
46306460	1177480	0	0
46310732	1115008	0	0
46311435	1125315	0	0
138239	4035415	5	6
21000082	1728416	0	0
4322976	4035793	4	5
4199276	4199276	0	0
21603249	1154343	2	2
36150828	1149196	0	0
36159597	1174888	0	0
36516961	4048695	4	5
42889648	4001336	2	2
43053690	4059173	3	3
44350579	1177480	0	0
45640184	715997	0	0
44351164	1000560	0	0
45634910	19010482	0	0
45661516	1119510	0	0
45667527	1124300	0	0
45647320	1545958	0	0
45703461	35605482	2	3
45698239	1125315	0	0
45686448	1177480	0	0
45708135	1115171	2	3
45778158	1125315	0	0
45785389	1125315	0	0
45673305	1192710	0	0
45693900	1125315	0	0
45787184	40236824	2	3
46241163	757627	0	0
46290686	1125315	0	0
45788410	1125315	0	0
46306382	1177480	0	0
46306343	1115008	0	0
46311440	1125315	0	0
138239	4059173	5	6
21000078	1728416	0	0
4279903	4242997	4	4
4078793	4078793	0	0
21603249	1137529	2	2
36150920	1107830	0	0
36159599	1115008	0	0
36516961	4066995	4	5
42803400	1127433	2	3
43053690	4048695	3	3
44350419	1129625	0	0
45639982	738818	0	0
44351101	1000560	0	0
45634840	1174888	0	0
45661519	1119510	0	0
45667529	1149196	0	0
45647321	1332418	0	0
45703693	1127433	2	3
45698229	1125315	0	0
45683113	1177480	0	0
45708244	40232448	2	3
45778159	1125315	0	0
45785391	1125315	0	0
45786759	1557272	0	0
45693954	1125315	0	0
45785569	40229134	2	3
46241229	1112807	0	0
46290687	1125315	0	0
45788531	1125315	0	0
46306405	1177480	0	0
46322629	1115008	0	0
46319609	1125315	0	0
135930	80809	4	4
21000108	1717327	0	0
4322976	4052083	4	4
21503371	19008572	3	4
21603282	1149380	2	2
36150730	1149196	0	0
36159613	1149196	0	0
36516825	4237458	4	5
42803341	19133905	2	3
43053690	4066995	3	3
44350399	1307863	0	0
45639984	1551099	0	0
44351102	1115008	0	0
45634858	1589505	0	0
45661744	1119510	0	0
45667727	1118084	0	0
45647353	1332418	0	0
45701464	19077344	2	3
45698446	1125315	0	0
45683318	1177480	0	0
45708075	19018935	2	3
45778165	1125315	0	0
45785559	1125315	0	0
45786663	1326303	0	0
45693955	1125315	0	0
45785619	1519937	2	3
46241252	1153428	0	0
46290694	1125315	0	0
45788413	1125315	0	0
45895652	1129625	0	0
46317054	1115008	0	0
46319645	1125315	0	0
135930	4278672	4	7
21000085	1729720	0	0
4302532	4108705	4	4
21500762	967823	3	3
21602797	1738521	2	2
36150801	1107830	0	0
36159614	738818	0	0
36516825	4142905	4	5
42803318	40232448	2	3
43053690	4278672	3	3
44350403	791967	0	0
45640081	1308738	0	0
44351103	1149380	0	0
45634858	19127890	0	0
45661961	1119510	0	0
45667728	1124300	0	0
45647429	1512674	0	0
45701675	42707627	2	3
45698243	1125315	0	0
45683530	1177480	0	0
45708194	19008572	2	3
45778456	1125315	0	0
45783407	1125315	0	0
45786642	1713332	0	0
45694083	1125315	0	0
45785657	40232448	2	3
46241394	705944	0	0
46290618	1125315	0	0
45788415	1125315	0	0
45895667	1129625	0	0
46317289	1115008	0	0
46319419	1125315	0	0
135930	4066995	4	7
21000060	1717327	0	0
4339468	28060	4	4
21600857	967823	3	3
21602484	19128263	2	2
36150803	1307863	0	0
36159618	1177480	0	0
36516772	4146173	4	5
37521122	4108705	2	3
43021226	4084167	3	3
44350683	738818	0	0
45634179	1396131	0	0
44350992	1124957	0	0
45634926	1310149	0	0
45661877	1119510	0	0
45667861	738818	0	0
45647429	1549786	0	0
45698315	1115171	2	3
45698250	1125315	0	0
45683241	1177480	0	0
45708093	19019273	2	3
45778255	1125315	0	0
45783410	1125315	0	0
45786624	1501700	0	0
45694084	1125315	0	0
45785754	1127433	2	3
46241399	1112807	0	0
46290743	1125315	0	0
45788684	1125315	0	0
45895686	1129625	0	0
46311408	1115008	0	0
46319719	1125315	0	0
135930	4048695	4	7
21000080	1728416	0	0
4339468	40481087	4	4
21601077	1595799	3	3
35507491	1119510	0	0
36150844	1129625	0	0
36151162	1112807	0	0
36703477	378419	4	5
37103727	45769019	2	3
43021227	4174876	3	3
44350407	1310149	0	0
45634181	738818	0	0
44350862	1308738	0	0
45634860	1551099	0	0
45661878	1119510	0	0
45667215	1307863	0	0
45647429	19127890	0	0
45698416	19008572	2	3
45698390	1125315	0	0
45683383	1177480	0	0
45705388	40228214	2	3
45778452	1125315	0	0
45783042	1125315	0	0
45786670	1367571	0	0
45694085	1125315	0	0
45785772	43012036	2	3
46241271	967823	0	0
46291113	1125315	0	0
45788682	1125315	0	0
45802609	1129625	0	0
46311519	1115008	0	0
46319318	1125315	0	0
135930	4149245	4	7
21000086	1728416	0	0
4339468	257012	4	4
21505741	1125315	3	3
35507616	1000560	0	0
36150844	1112807	0	0
36151163	1177480	0	0
36503296	40479422	4	5
42805810	19123231	2	3
43053690	4134304	5	5
44350511	1310149	0	0
45634036	1548195	0	0
44351169	1124300	0	0
45634866	1154343	0	0
45661532	1119510	0	0
45667221	933724	0	0
45647409	1124300	0	0
45698119	1539411	2	3
45698393	1125315	0	0
45685244	1177480	0	0
45705350	1107882	2	3
45778453	1125315	0	0
45783326	1125315	0	0
45784872	1115008	0	0
45693847	1125315	0	0
45785777	920300	2	3
46241257	1322184	0	0
46290845	1125315	0	0
45788639	1125315	0	0
45801954	1129625	0	0
46319409	1115008	0	0
46319544	1125315	0	0
135930	4146173	4	6
21000086	1717327	0	0
4212577	134438	4	4
21505741	1129625	3	3
35507618	1713332	0	0
36150845	1174888	0	0
36151126	1124300	0	0
36503296	40479768	4	5
42806153	1545959	2	3
43021226	4174876	4	4
44350517	933724	0	0
45634182	1343916	0	0
44351171	975125	0	0
45634875	1174888	0	0
45661535	1119510	0	0
45667192	1367571	0	0
45647424	1549786	0	0
45698243	40231925	2	3
45698427	1125315	0	0
45685363	1177480	0	0
45705162	40228214	2	3
45778454	1125315	0	0
45783332	1125315	0	0
45784877	1738521	0	0
45694167	1125315	0	0
45785890	1115171	2	3
46238413	1332418	0	0
46242433	1125315	0	0
45788644	1125315	0	0
45801951	1129625	0	0
46313300	1177480	0	0
46319821	1125315	0	0
135930	81151	4	8
21000088	1728416	0	0
4317258	133834	4	4
21505741	738818	3	3
35507621	1125315	0	0
36150847	1112807	0	0
36151129	1149196	0	0
36516781	40479768	4	5
42803460	1127433	2	3
43021226	439406	5	5
44350520	1129625	0	0
45634185	1115008	0	0
44351174	1729720	0	0
45634879	933724	0	0
45661764	1119510	0	0
45667249	738818	0	0
45647424	19127890	0	0
45698557	19133905	2	3
45698234	1125315	0	0
45680229	1177480	0	0
45705334	43012036	2	3
45778433	1125315	0	0
45783447	1125315	0	0
45785005	1192710	0	0
45694168	1125315	0	0
45785985	40229134	2	3
46238413	1545958	0	0
46242410	1125315	0	0
45788655	1125315	0	0
45802045	1129625	0	0
46313436	1177480	0	0
46319705	1125315	0	0
135930	4237458	5	7
21000089	1728416	0	0
4200532	4056621	4	4
21505741	1119510	3	3
35507621	1174888	0	0
36151098	1332418	0	0
36151136	1307863	0	0
36516781	40479422	4	5
42803691	35605482	2	3
43021226	4306014	5	5
44350532	1129625	0	0
45634052	1713332	0	0
44351182	1545958	0	0
45622566	19127904	3	4
45661983	1119510	0	0
45667252	1307863	0	0
45647462	1115008	0	0
45698694	19076374	2	3
45698689	1125315	0	0
45680268	1177480	0	0
45705553	40228214	2	3
45778434	1125315	0	0
45783448	1125315	0	0
45784861	1192710	0	0
45876249	3010813	3	4
46296486	19133905	2	3
46238443	1738521	0	0
46242049	1125315	0	0
46298029	1125315	0	0
45802122	1129625	0	0
46313610	1177480	0	0
46316999	1125315	0	0
135930	4142905	5	7
21000082	1729720	0	0
4200532	198199	4	4
21505741	1192710	3	3
35507613	1125315	0	0
36151057	1177480	0	0
36151138	1717327	0	0
36603422	4149245	4	4
42803733	19018935	2	3
43021226	442116	5	5
44350541	738818	0	0
45634111	1115008	0	0
44351127	1738521	0	0
44782620	4149245	2	4
45661985	1119510	0	0
45667239	967823	0	0
45647469	1521369	0	0
45698338	1551192	2	3
45698571	1125315	0	0
45680086	1177480	0	0
45705384	40174880	2	3
45778435	1125315	0	0
45783449	1125315	0	0
45784869	1174888	0	0
45876249	3023430	3	4
46296486	19133873	2	3
46238496	705944	0	0
46242437	1125315	0	0
46297686	1125315	0	0
45802075	1129625	0	0
46313568	1177480	0	0
46317253	1125315	0	0
135930	40479422	6	7
21000104	1759842	0	0
4200516	4001336	4	4
21600127	914335	3	3
35507441	1119510	0	0
36150876	1153428	0	0
36151145	1738521	0	0
40772935	3014576	4	4
42803752	40174880	2	3
43021226	438614	5	5
44350685	723013	0	0
45634491	1521369	0	0
44350884	975125	0	0
45654264	19127918	2	2
45661979	1119510	0	0
45665489	967823	0	0
45647469	1549786	0	0
45698264	19008572	2	3
45698544	1125315	0	0
45680441	1177480	0	0
45705396	19008572	2	3
45778436	1125315	0	0
45783467	1125315	0	0
45784750	1549786	0	0
45876249	40766240	3	4
46296468	19079524	2	3
46238527	1112807	0	0
46242372	1125315	0	0
46297688	1125315	0	0
45802179	1129625	0	0
46307999	1177480	0	0
46317519	1125315	0	0
135930	40479768	6	7
21000104	1746114	0	0
4200533	4294548	4	4
21500543	1125315	3	3
35507448	1521369	0	0
36151048	1738521	0	0
36151148	975125	0	0
40772935	3013721	4	4
42803609	1551192	2	3
43021226	40486433	5	5
44350529	1112807	0	0
45634491	1549786	0	0
44350885	1124300	0	0
45654264	19128009	2	2
45658264	1119510	0	0
45665499	1124957	0	0
45647511	1717327	0	0
45698341	19133905	2	3
45698462	1125315	0	0
45680311	1177480	0	0
45705518	1107882	2	3
45778437	1125315	0	0
45783368	1125315	0	0
45785018	967823	0	0
45876249	3036780	3	4
46292108	1127433	2	3
46238531	1332418	0	0
46242439	1125315	0	0
46301453	1125315	0	0
45802188	1129625	0	0
46308406	1177480	0	0
46317182	1125315	0	0
135930	4134304	6	9
21000108	1728416	0	0
4318379	4280726	4	4
21500543	708298	3	3
35507452	1738521	0	0
36151031	1177480	0	0
36151151	914335	0	0
40772935	3028833	4	4
42803571	1551192	2	3
43021226	4280726	5	5
44350831	1118084	0	0
45634491	19127890	0	0
44350954	1118084	0	0
45648225	19128009	2	2
45658254	1119510	0	0
45665434	1310149	0	0
45647550	1154343	0	0
45698616	782047	2	3
45698546	1125315	0	0
45680179	1177480	0	0
45705603	40223821	2	3
45778438	1125315	0	0
45783516	1125315	0	0
45785024	1192710	0	0
45876249	40769184	3	4
46292319	40229134	2	3
46238412	1545958	0	0
46242456	1125315	0	0
46301532	1125315	0	0
45802156	1129625	0	0
46308460	1177480	0	0
46317268	1125315	0	0
135930	4230399	7	8
21000108	1746114	0	0
4318379	40486433	4	4
21500543	791967	3	3
35507453	1119510	0	0
36151169	1149196	0	0
36151288	1115008	0	0
40772935	3023103	4	4
42803984	1545959	2	3
43021226	4102123	5	5
44350634	19127890	0	0
45634149	1174888	0	0
44350956	19127890	0	0
45660620	19128009	2	2
45658105	1119510	0	0
45665530	1149196	0	0
45647555	1107830	0	0
45698628	43012036	2	3
45698709	1125315	0	0
45680243	1177480	0	0
45705603	40223834	2	3
45778439	1125315	0	0
45783531	1125315	0	0
45785128	1713332	0	0
45876249	40769179	3	4
46292324	46233710	2	3
46238319	1713332	0	0
46242457	1125315	0	0
46298196	1125315	0	0
45802248	1129625	0	0
46308678	1177480	0	0
46317269	1125315	0	0
444089	440448	5	5
21000082	1713332	0	0
4309188	4266809	4	4
21500731	1192710	3	3
35507461	975125	0	0
36150927	1129625	0	0
36151289	1124957	0	0
40772935	3013682	4	4
42802990	43012036	2	3
43021226	4169137	5	5
44350634	1515774	0	0
45634143	1118084	0	0
44350956	1515774	0	0
45657550	42902245	2	2
45655599	1119510	0	0
45665531	1107830	0	0
45647485	1549786	0	0
45698341	19133873	2	3
45698576	1125315	0	0
45680397	1177480	0	0
45705483	40232448	2	3
45778440	1125315	0	0
46291167	1125315	0	0
45784935	1545958	0	0
45876249	3007461	3	3
46292069	19008572	2	3
46238319	1759842	0	0
46242051	1125315	0	0
46298206	1125315	0	0
45802232	1129625	0	0
46312181	1177480	0	0
500002101	4296204	3	3
73553	78272	2	5
21000082	1768849	0	0
4171379	45769019	4	4
21500731	1308738	3	3
35507466	1119510	0	0
36150928	1115008	0	0
36151292	1192710	0	0
36516825	4066995	5	5
42802998	19077344	2	3
43021226	4304110	5	5
44350634	1549786	0	0
45634396	1521369	0	0
44350956	1549786	0	0
45659221	19019273	2	3
45655685	1119510	0	0
45665508	1115008	0	0
45647485	19127890	0	0
45698799	40232448	2	3
45698592	1125315	0	0
45680498	1177480	0	0
45705466	40232448	2	3
45778443	1125315	0	0
46291177	1125315	0	0
45785045	975125	0	0
45876249	3015076	3	3
46292122	19018935	2	3
46238535	1309944	0	0
46242140	1125315	0	0
46298219	1125315	0	0
45799462	1129625	0	0
46312201	1177480	0	0
46310013	1545959	2	3
443883	198809	2	3
21000090	1728416	0	0
4214956	4324181	4	4
21500731	967823	3	3
35507466	738818	0	0
36150842	1322184	0	0
36151270	1149196	0	0
36516825	4059173	5	5
42805711	19019273	2	3
43021226	4048169	5	5
44350530	1713332	0	0
45634398	1124957	0	0
44350969	723013	0	0
45659173	40174880	2	3
45655693	1119510	0	0
45665536	1539403	0	0
45647485	1521369	0	0
45698654	19018935	2	3
45698596	1125315	0	0
45680615	1177480	0	0
45705540	19078924	2	3
45778457	1125315	0	0
46291860	1125315	0	0
45785049	1713332	0	0
45876249	3014599	3	3
46292371	40174880	2	3
46238610	1332418	0	0
46242142	1125315	0	0
46298130	1125315	0	0
45799551	1129625	0	0
46312436	1177480	0	0
46316216	1332419	2	3
440921	40479768	6	7
21000061	1728416	0	0
4213310	378419	4	4
21500731	1595799	3	3
35507475	914335	0	0
36150898	1343916	0	0
36151279	1741122	0	0
36516825	4278672	5	5
37522278	4107731	2	3
43021226	4302207	5	5
44350648	1129625	0	0
45634399	738818	0	0
44350971	1124957	0	0
45657202	40232448	2	3
45655700	1119510	0	0
45665445	1501700	0	0
45647491	1500211	0	0
45698667	19008572	2	3
45698364	1125315	0	0
45676675	1177480	0	0
45705505	19057271	2	3
45778458	1125315	0	0
46291572	1125315	0	0
45785050	1000560	0	0
45876249	3006734	3	3
46292216	43012036	2	3
46238399	1309944	0	0
46242223	1125315	0	0
46298169	1125315	0	0
45799490	1129625	0	0
46308815	1177480	0	0
46305102	1332419	2	3
75909	4134304	6	6
21000104	1778162	0	0
4195979	4163874	4	4
21500731	1396131	3	3
35507578	1000560	0	0
36150933	705944	0	0
36151279	1746114	0	0
36516825	4048695	5	5
42803511	1545959	2	3
43021226	4139681	5	5
44350650	1112807	0	0
45634187	1107830	0	0
44351029	1309944	0	0
45657349	19073183	2	3
45655702	1119510	0	0
45665604	1549786	0	0
45647577	1154343	0	0
45698814	1115171	2	3
45698855	1125315	0	0
45677035	1177480	0	0
45705575	19078924	2	3
45778460	1125315	0	0
46291583	1125315	0	0
45784880	715997	0	0
45876249	3002385	3	3
46292404	19077344	2	3
46238344	1192710	0	0
46242086	1125315	0	0
46298237	1125315	0	0
45799529	1129625	0	0
46303280	1177480	0	0
45675371	1332419	2	3
440921	40480160	6	6
21000105	1746114	0	0
4199402	40486433	7	9
4187630	4163874	6	6
35507585	1125315	0	0
36150936	1738521	0	0
36152157	1000560	0	0
36516728	4230399	5	5
42803589	1545959	2	3
43021226	433644	6	6
44350522	1729720	0	0
45634123	1192710	0	0
44351150	1713332	0	0
45657234	40223834	2	3
45655708	1119510	0	0
45665604	19127890	0	0
45647498	1501700	0	0
45697480	19076374	2	3
45697794	1125315	0	0
45679691	1177480	0	0
45705710	40174880	2	3
45778403	1125315	0	0
46291795	1125315	0	0
45784883	1521369	0	0
45876249	3008598	3	3
46292437	40236824	2	3
46238551	1332418	0	0
46242354	1125315	0	0
46298147	1125315	0	0
45799441	1129625	0	0
46303795	1177480	0	0
45650798	1539411	2	3
372887	4043241	5	6
21000105	1717327	0	0
4199402	260139	7	7
4162282	258780	6	6
35507585	1174888	0	0
36150937	1177480	0	0
36152438	1112807	0	0
36702254	378001	5	5
42805950	19019273	2	3
43021226	37017711	6	6
44350523	1192710	0	0
45634127	1332418	0	0
44351150	1759842	0	0
45657154	40228230	2	3
45655767	1119510	0	0
45665688	1501700	0	0
45647691	1149196	0	0
45697481	40223834	2	3
45697788	1125315	0	0
45679692	1177480	0	0
45705566	40228214	2	3
45778368	1125315	0	0
46292019	1125315	0	0
45785145	1112807	0	0
45876249	3009542	3	3
46287913	19008572	2	3
46238577	1112807	0	0
46242491	1125315	0	0
46298339	1125315	0	0
45799536	1129625	0	0
46303682	1177480	0	0
46319805	1539411	2	3
440921	4237458	5	6
21000083	1729720	0	0
4199402	4048171	8	10
4030781	4330583	6	6
35507491	738818	0	0
36156419	1000560	0	0
36152161	1549786	0	0
36516772	40479768	5	6
42802921	1107882	2	3
43021226	4048171	6	6
44350523	1112807	0	0
45634336	738818	0	0
44351151	1115008	0	0
45657268	19078924	2	3
45655750	1119510	0	0
45665639	1107830	0	0
45647558	1124957	0	0
45697495	19008572	2	3
45695167	1125315	0	0
45679552	1177480	0	0
45702004	40229134	2	3
45778354	1125315	0	0
46291478	1125315	0	0
45785214	1501700	0	0
45876249	3027231	3	3
46242790	19077572	2	3
46238608	1548195	0	0
46242499	1125315	0	0
46298358	1125315	0	0
45799638	1129625	0	0
46303655	1177480	0	0
46309108	1539411	2	3
440921	4230399	5	7
21000061	1717327	0	0
4199402	40479422	8	9
138239	4134304	6	7
35507421	1115008	0	0
36156552	742185	0	0
36152162	1129625	0	0
36516772	4278672	5	6
42819961	1107882	2	3
43021226	4240902	6	6
44350845	933724	0	0
45634241	738818	0	0
44351159	1717327	0	0
45657030	19008572	2	3
45655729	1119510	0	0
45665851	1110410	0	0
45647585	1192710	0	0
45697500	1551192	2	3
45695221	1125315	0	0
45677191	1177480	0	0
45702017	43012036	2	3
45778355	1125315	0	0
46291493	1125315	0	0
45784901	1124957	0	0
45876249	3026361	3	3
46243140	40229134	2	3
46238409	1112807	0	0
46242547	1125315	0	0
46298361	1125315	0	0
45799600	1129625	0	0
46303823	1177480	0	0
46320157	19127922	1	2
77960	4134304	5	7
21000090	723013	0	0
4336464	4336464	0	0
138239	4230399	6	7
35507623	975125	0	0
36156641	1343916	0	0
36152436	1539403	0	0
36516772	4149245	5	6
42806145	19078461	2	3
43021226	4219399	6	6
44350652	740275	0	0
45634300	975125	0	0
44352247	1326303	0	0
45657287	40163554	2	3
45655938	1119510	0	0
45665581	1174888	0	0
45647568	1717327	0	0
45695148	19077572	2	3
45695169	1125315	0	0
45677211	1177480	0	0
45702177	1115171	2	3
45778356	1125315	0	0
46291678	1125315	0	0
45785244	1115008	0	0
45876249	3051031	3	3
46243067	40229134	2	3
46238671	1149196	0	0
46242517	1125315	0	0
46298382	1125315	0	0
45796661	1129625	0	0
46301068	1177480	0	0
46320157	19129144	1	2
75909	4230399	5	5
21000092	1746114	0	0
4301346	4301346	0	0
138239	81151	6	7
21604795	715997	0	0
36156429	708298	0	0
36152168	1149196	0	0
36703500	378419	5	7
42803276	19075601	2	3
43021227	37017711	5	5
44350713	1115008	0	0
45634302	1589505	0	0
44352254	1713332	0	0
45657388	19076374	2	3
44348409	1119510	0	0
45665710	1322184	0	0
45647701	1110410	0	0
45695155	19126352	2	3
45695171	1125315	0	0
45677284	1177480	0	0
45701914	19133905	2	3
45778357	1125315	0	0
46291947	1125315	0	0
45784836	933724	0	0
45876249	3009201	3	3
46243015	1545959	2	3
46238635	1115008	0	0
46242356	1125315	0	0
46298545	1125315	0	0
45796848	1129625	0	0
46301735	1177480	0	0
46320157	19133679	1	2
3050940	3000963	5	5
21000093	1778162	0	0
4216130	4216130	0	0
4199402	45769019	6	7
21604797	757627	0	0
36156454	1177480	0	0
36152284	738818	0	0
36503296	78272	5	7
42805927	1332419	2	3
43021227	4240902	5	5
44350902	738818	0	0
45634302	1549786	0	0
44352359	1118084	0	0
45657121	19008572	2	3
44348200	1119510	0	0
45665601	1367571	0	0
45647698	1154343	0	0
45695158	19008572	2	3
45695208	1125315	0	0
45674273	1177480	0	0
45702099	19008572	2	3
45778363	1125315	0	0
46291702	1125315	0	0
45785245	1343916	0	0
45876249	3021226	3	3
46243056	42707627	2	3
46238418	1137529	0	0
46242548	1125315	0	0
46298297	1125315	0	0
45796854	1129625	0	0
46301149	1177480	0	0
46320595	40221415	1	2
440142	313217	4	5
21000092	1717327	0	0
4198190	4198190	0	0
4199402	28060	6	7
21604794	836654	0	0
36156642	1545958	0	0
36152286	1177480	0	0
36703500	375671	5	8
42803513	40228214	2	3
43021227	4219399	5	5
44350904	1149196	0	0
45634501	1115008	0	0
44352365	1310149	0	0
45657164	35605482	2	3
44348413	1119510	0	0
45665523	1551099	0	0
45647800	1115008	0	0
45695222	19019273	2	3
45695209	1125315	0	0
45673635	1177480	0	0
45702194	1107882	2	3
45778364	1125315	0	0
46295775	1125315	0	0
45785248	1549786	0	0
45876249	3001247	3	3
46243119	1107882	2	3
46238511	715997	0	0
46242549	1125315	0	0
46298335	1125315	0	0
45797100	1129625	0	0
46313571	1177480	0	0
46315949	19129144	1	2
140190	4066995	4	5
21000092	1778162	0	0
21000302	1728416	0	0
4199402	40481087	6	8
21604799	701322	0	0
36156433	1713332	0	0
36152288	1107830	0	0
36516972	4134304	5	8
42803555	19078461	2	3
43021227	433644	5	5
44350546	738818	0	0
45634346	1115008	0	0
44351817	738818	0	0
45657124	19019273	2	3
44348416	1119510	0	0
45665736	1000560	0	0
45647708	1192710	0	0
45695224	19008572	2	3
45695282	1125315	0	0
45674287	1177480	0	0
45702113	40165015	2	3
45778461	1125315	0	0
46295785	1125315	0	0
45785248	19127890	0	0
45876249	3006451	3	3
46240800	40224805	2	3
46238695	1192710	0	0
46239602	1125315	0	0
46289695	1125315	0	0
45796889	1129625	0	0
46313809	1177480	0	0
46315949	19127922	1	2
140190	4048695	4	5
21000130	1728416	0	0
21000303	1728416	0	0
4199402	317576	6	8
21500972	19008572	4	5
36155334	1545958	0	0
36152291	1177480	0	0
36516972	40479422	5	8
42805999	1545959	2	3
43021227	4048171	5	5
44350557	1112807	0	0
45634311	791967	0	0
44351995	1549786	0	0
45657307	19073188	2	3
45651975	1119510	0	0
45665525	967823	0	0
45647810	1759842	0	0
45695200	35605482	2	3
45695503	1125315	0	0
45671104	1177480	0	0
45702187	19019273	2	3
45778423	1125315	0	0
46295795	1125315	0	0
45785135	914335	0	0
45876249	3000876	3	3
46240949	40229134	2	3
46238703	1149380	0	0
46239606	1125315	0	0
46289859	1125315	0	0
45797056	1129625	0	0
46313800	1177480	0	0
46315949	19133679	1	2
4000610	4166224	4	5
21000062	1728416	0	0
21000304	1728416	0	0
4180627	40492359	6	8
21500803	40163554	4	5
36155339	1729720	0	0
36152388	1149380	0	0
36516972	40479768	5	8
37502344	4242997	2	4
43021227	4048169	4	4
44350717	1110410	0	0
45634574	705944	0	0
44351995	1521369	0	0
45657061	1115171	2	3
45652232	1119510	0	0
45665555	1149196	0	0
45647814	1729720	0	0
45695226	1115171	2	3
45695283	1125315	0	0
45670916	1177480	0	0
45702044	40162522	2	3
45778424	1125315	0	0
46244852	1125315	0	0
45784839	1124957	0	0
45876249	3001488	3	3
46241100	40236446	2	3
46238489	1112807	0	0
46239737	1125315	0	0
46289864	1125315	0	0
45797176	1129625	0	0
46314534	1177480	0	0
45650604	46275916	1	1
134057	313217	4	5
21000084	1728416	0	0
21000305	1728416	0	0
4309188	4285898	6	7
21500027	46233710	4	5
36155447	1589505	0	0
36152405	1551099	0	0
36516972	4152936	5	7
40236438	40236446	1	1
43021227	4169137	4	4
44350721	1713332	0	0
45634450	975125	0	0
44352000	920293	0	0
45657340	1545959	2	3
45649333	1119510	0	0
45665720	715997	0	0
45647765	1729720	0	0
45695403	40163554	2	3
45695321	1125315	0	0
45671121	1177480	0	0
45703562	1107882	2	3
45778425	1125315	0	0
46244864	1125315	0	0
45784840	1149196	0	0
45876249	3012494	3	3
46240917	40236446	2	3
46238386	1501700	0	0
46239721	1125315	0	0
46289865	1125315	0	0
45794135	1129625	0	0
46314792	1177480	0	0
45650855	46275916	1	1
3050940	3014576	4	5
21000140	1728416	0	0
21000306	1728416	0	0
255919	375671	6	8
21500027	46233988	4	5
36155565	738818	0	0
36152406	1551099	0	0
36516972	4109685	5	6
40163553	40163554	1	1
43021227	4304110	4	4
44350726	738818	0	0
45634454	1307863	0	0
44352002	1545958	0	0
45657461	19008572	2	3
45649574	1119510	0	0
45665630	1746114	0	0
45647810	1713332	0	0
45695421	40232448	2	3
45695416	1125315	0	0
45671258	1177480	0	0
45699132	19008572	2	3
45778426	1125315	0	0
46244994	1125315	0	0
45784841	967823	0	0
45876249	3024731	3	3
46240988	19133905	2	3
46238479	1112807	0	0
46239628	1125315	0	0
46290025	1125315	0	0
45794147	1129625	0	0
46315053	1177480	0	0
46300762	19059056	2	3
3050940	3019550	4	5
21000084	1729720	0	0
21000375	975125	0	0
4176642	4043071	5	5
21501038	1125315	4	4
36155568	1154343	0	0
36151398	738818	0	0
36703532	375671	7	9
37521369	4330583	1	1
43021227	4302207	4	4
44350745	1589505	0	0
45634579	1549786	0	0
44352155	1515774	0	0
45657462	19008572	2	3
44337690	1125315	0	0
45665630	1741122	0	0
45647945	738818	0	0
45695269	19077572	2	3
45695384	1125315	0	0
45671127	1177480	0	0
45699097	1115171	2	3
45778429	1125315	0	0
46244989	1125315	0	0
45784955	1192710	0	0
45876249	3049273	3	3
46240641	40229134	2	3
46238726	1521369	0	0
46239631	1125315	0	0
46290167	1125315	0	0
45794759	1129625	0	0
46308878	1177480	0	0
46301062	40236824	2	3
3050940	3015632	4	5
21000094	1759842	0	0
21000408	1551099	0	0
4176642	4181917	5	5
21502709	40169281	4	4
36155578	1539403	0	0
36151496	738818	0	0
40772948	3001488	7	7
37521136	4108705	1	1
43021227	4280726	4	4
44350750	1729720	0	0
45634579	1589505	0	0
44352155	19127890	0	0
45655371	40232448	2	3
44337601	1125315	0	0
45665632	1110410	0	0
45647738	738818	0	0
45695433	40223768	2	3
45695423	1125315	0	0
45671301	1177480	0	0
45699162	1127433	2	3
45778430	1125315	0	0
46290990	1125315	0	0
45784890	1738521	0	0
45876249	3013721	3	6
46240851	40232448	2	3
46238726	1549786	0	0
46240262	1125315	0	0
46290333	1125315	0	0
45794330	1129625	0	0
46308965	1177480	0	0
46301067	19008572	2	3
3050940	3045716	4	5
21000094	1717327	0	0
21000375	1551099	0	0
4176642	4202451	5	5
21500044	1308738	4	4
36155437	1129625	0	0
36151432	975125	0	0
36403239	4144583	7	7
37521342	4163971	1	1
43021227	439406	4	4
44350941	1192710	0	0
45634638	1192710	0	0
45637632	1125315	0	0
45655266	40228214	2	3
44337873	1125315	0	0
45665854	1107830	0	0
45647746	740275	0	0
45691785	1115171	2	3
45695371	1125315	0	0
45671369	1177480	0	0
45699067	19129655	2	3
45778431	1125315	0	0
46291522	1125315	0	0
45785137	1192710	0	0
45876249	3013682	3	6
46240075	19059056	2	3
46238727	1192710	0	0
46240273	1125315	0	0
46290133	1125315	0	0
45794332	1129625	0	0
46309031	1177480	0	0
46300878	1545959	2	3
133468	4149245	4	6
21000141	1729720	0	0
21000436	1551099	0	0
141960	133834	5	5
21500837	1713671	4	4
36155438	738818	0	0
36151602	1129625	0	0
36403241	4144583	7	7
37521353	4242997	1	1
43021227	4102123	4	4
44350854	1332418	0	0
45634641	1000560	0	0
45637596	1125315	0	0
45655474	40232448	2	3
44778195	1125315	0	0
45665841	1713332	0	0
45647793	1738521	0	0
45692274	19078461	2	3
45695444	1125315	0	0
45671089	1177480	0	0
45699148	19133768	2	3
45778432	1125315	0	0
46291715	1125315	0	0
45785077	1545958	0	0
45876249	3006923	3	6
46240073	19077572	2	3
46238728	1153428	0	0
46240237	1125315	0	0
46289941	1125315	0	0
45791837	1129625	0	0
46309205	1177480	0	0
46301663	40162522	2	3
440921	4059173	4	6
21000096	1746114	0	0
21506108	1307863	2	2
255919	381316	5	5
21500093	1305058	4	4
36155439	738818	0	0
36151439	1107830	0	0
36516781	80180	1	2
43012692	43012433	1	1
43021227	438614	4	4
44350916	967823	0	0
45634687	1154343	0	0
45637640	1125315	0	0
45654127	40223834	2	3
44778271	1125315	0	0
45665657	1102527	0	0
45647835	738818	0	0
45692185	1545959	2	3
45695374	1125315	0	0
45671303	1177480	0	0
45699244	19075001	2	3
45778323	1125315	0	0
46242754	1125315	0	0
45785084	1192710	0	0
45876249	3024561	3	6
46240165	19133905	2	3
46238735	1107830	0	0
46240242	1125315	0	0
46289407	1125315	0	0
45788986	1129625	0	0
46309370	1177480	0	0
46301740	1115171	2	3
3039757	3000963	4	4
21000113	1728416	0	0
21506110	1332418	2	2
4187630	4324181	5	5
21500093	742185	4	4
36155440	738818	0	0
36151603	1149196	0	0
37502353	4125906	7	7
43012693	43012433	1	1
43021227	4139681	4	4
44350927	1124300	0	0
45634430	975125	0	0
45637684	1125315	0	0
45653980	35605482	2	3
44778153	1125315	0	0
45665664	1107830	0	0
45647820	1332418	0	0
45692372	19126352	2	3
45695303	1125315	0	0
45671409	1177480	0	0
45699352	1127433	2	3
45778524	1125315	0	0
46242680	1125315	0	0
45785087	1549786	0	0
45876249	3020630	3	6
46240165	19133873	2	3
45897488	1326303	0	0
45896245	1125315	0	0
46290026	1125315	0	0
45789148	1129625	0	0
46303855	1177480	0	0
46301200	40229134	2	3
440921	4296204	4	4
21000114	1728416	0	0
21500121	1551099	2	2
4185503	317576	5	5
21500936	1124300	4	4
36155328	1129625	0	0
36151501	715997	0	0
37000000	45769019	7	7
43012694	43012433	1	1
43021227	4306014	4	4
44351060	1545958	0	0
45634433	1107830	0	0
45637673	1125315	0	0
45654025	19074843	2	3
44778240	1125315	0	0
45663141	1551099	0	0
45647822	1107830	0	0
45692297	1115171	2	3
45692129	1125315	0	0
45671440	1177480	0	0
45699524	1115171	2	3
45778540	1125315	0	0
46242683	1125315	0	0
45785087	1589505	0	0
45876249	3016723	3	6
46238284	40228230	2	3
45897456	1174888	0	0
45896211	1125315	0	0
46290196	1125315	0	0
46302141	1129625	0	0
46307065	1177480	0	0
46301270	19133873	2	3
73553	40479422	4	4
21000083	1778162	0	0
21500121	975125	2	2
4185503	258780	5	5
21500936	1129625	4	4
36155415	738818	0	0
36151502	1124957	0	0
36303153	378001	8	12
43012697	43012433	1	1
43021227	442116	4	4
44351070	1118084	0	0
45634517	1501700	0	0
45637847	1125315	0	0
45654169	19008572	2	3
44778219	1125315	0	0
45663227	723013	0	0
45647842	1124300	0	0
45692142	40232448	2	3
45692218	1125315	0	0
45669802	1177480	0	0
45695932	40232448	2	3
45778535	1125315	0	0
46242767	1125315	0	0
45785088	1107830	0	0
45876249	3027970	3	6
46238272	1115171	2	3
45897495	1192710	0	0
45896316	1125315	0	0
46290270	1125315	0	0
46301986	1129625	0	0
46304070	1177480	0	0
46301401	19008572	2	3
73553	40479768	4	4
21000110	1746114	0	0
21500101	1500211	2	2
4185503	321042	5	5
21500936	1738521	4	4
36155401	1118084	0	0
36151645	1112807	0	0
36303153	133834	9	11
43012753	43012754	1	1
43021227	40486433	4	4
44351071	1129625	0	0
45634276	1124957	0	0
45637687	1125315	0	0
45647443	19008572	2	3
44357930	1125315	0	0
45663231	738818	0	0
45644496	1174888	0	0
45692379	40228230	2	3
45692089	1125315	0	0
45669786	1177480	0	0
45778418	1177480	0	0
45778465	1125315	0	0
46242769	1125315	0	0
45784852	742185	0	0
45876249	3006906	3	6
46238428	19008572	2	3
45897557	705944	0	0
45896304	1125315	0	0
46290271	1125315	0	0
46301816	1129625	0	0
46304328	1177480	0	0
46301507	19073183	2	3
3050940	3006906	4	4
21000110	1759842	0	0
21500144	19128022	2	2
138239	4155034	5	5
21500936	1149380	4	4
36155599	1551099	0	0
36151519	1589505	0	0
36303153	4302207	7	8
42889344	4102123	1	1
43531054	195588	2	2
44351072	1500211	0	0
45634415	967823	0	0
45637809	1125315	0	0
45647426	19078461	2	3
44357939	1125315	0	0
45663302	1738521	0	0
45644478	1539403	0	0
45694831	19078461	2	3
45692348	1125315	0	0
45669919	1177480	0	0
45778421	1177480	0	0
45778466	1125315	0	0
46242773	1125315	0	0
45785197	1153428	0	0
45876249	3004501	3	6
46238246	19133905	2	3
45897544	1713332	0	0
45896361	1125315	0	0
46290237	1125315	0	0
46298967	1129625	0	0
46304246	1177480	0	0
46301418	19008572	2	3
3050940	3020630	4	4
21000115	1728416	0	0
21500144	19128009	2	2
4030654	4163971	5	5
21500936	1396131	4	4
36155356	738818	0	0
36151525	1501700	0	0
36303153	4149245	7	11
42889648	4132546	1	1
44784105	4109685	2	2
44351079	1112807	0	0
45634526	738818	0	0
45637909	1125315	0	0
45647462	1115171	2	3
44358972	1125315	0	0
45663314	1515774	0	0
45644673	1149196	0	0
45689107	40232448	2	3
45692363	1125315	0	0
45781124	1177480	0	0
45778420	1177480	0	0
45778467	1125315	0	0
46242853	1125315	0	0
45785202	1174888	0	0
45876249	3035995	3	6
45897265	19059056	2	3
45897559	1521369	0	0
45896278	1125315	0	0
46290247	1125315	0	0
46298805	1129625	0	0
46304098	1177480	0	0
46319235	40229134	2	3
3050940	3013721	4	4
21000085	1728416	0	0
21500144	42902245	2	2
4179873	4043241	7	7
21500936	975125	4	4
36155369	738818	0	0
36151445	1149380	0	0
36314535	4015189	0	0
42889655	4218389	1	1
44784105	81151	2	2
44351064	975125	0	0
45634363	1326303	0	0
45637700	1125315	0	0
45647550	1154615	2	3
44358976	1125315	0	0
45663314	19127890	0	0
45644596	1115008	0	0
45689299	19019273	2	3
45692366	1125315	0	0
45781365	1177480	0	0
45778497	1177480	0	0
45778468	1125315	0	0
46242688	1125315	0	0
45785207	1332418	0	0
45876249	3023103	3	7
45897218	19133905	2	3
45897559	1549786	0	0
45896339	1125315	0	0
46290283	1125315	0	0
46301505	1129625	0	0
46320445	1177480	0	0
46319259	40174880	2	3
3050940	3027970	4	4
21000083	1717327	0	0
21500144	19128263	2	2
21500408	1177480	3	3
21500936	1343916	4	4
36155525	1124957	0	0
36151449	738818	0	0
36316010	4052083	0	0
40080661	42707627	1	1
44359428	42902245	2	2
44350796	1129625	0	0
45634369	1149196	0	0
45637702	1125315	0	0
45647554	19008572	2	3
44359058	1125315	0	0
45663314	1549786	0	0
45644551	1545958	0	0
45689162	40229134	2	3
45692284	1125315	0	0
45781314	1177480	0	0
45778419	1177480	0	0
45778265	1125315	0	0
46242888	1125315	0	0
45784942	1115008	0	0
45876249	3014576	3	7
45897348	40232448	2	3
45897578	1545958	0	0
45896400	1125315	0	0
46290255	1125315	0	0
46301646	1129625	0	0
46320472	1177480	0	0
46319652	40231925	2	3
3050940	3004501	4	4
21000099	1746114	0	0
21500144	19128065	2	2
21500408	967823	3	3
21500936	1192710	4	4
36155386	1107830	0	0
36151454	1192710	0	0
36316018	4133840	0	0
40228550	40231925	1	1
44359381	42902245	2	2
44350805	1107830	0	0
45634621	933724	0	0
45637952	1125315	0	0
45647613	40232448	2	3
44359136	1125315	0	0
45663317	1107830	0	0
45644524	920293	0	0
45689397	40174880	2	3
45692299	1125315	0	0
45781655	1177480	0	0
45780671	1177480	0	0
45778365	1125315	0	0
46242962	1125315	0	0
45785223	1326303	0	0
45876249	3015632	3	7
45897191	19008572	2	3
45897628	1154343	0	0
45896537	1125315	0	0
46290258	1125315	0	0
46301851	1129625	0	0
46320593	1177480	0	0
46320058	40229134	2	3
3050940	3035995	4	4
21000100	1778162	0	0
21500144	19127918	2	2
21503967	1110410	3	3
21500936	967823	4	4
36155343	1107830	0	0
36151542	1177480	0	0
36314511	4024958	0	0
40080069	19079524	1	1
44352265	19129144	2	2
44351056	1149196	0	0
45634622	1738521	0	0
45634669	1125315	0	0
45647689	19008572	2	3
44358851	1125315	0	0
45663390	1557272	0	0
45644636	1589505	0	0
45689398	19008572	2	3
45692264	1125315	0	0
45781626	1177480	0	0
45706950	1177480	0	0
45778366	1125315	0	0
46242724	1125315	0	0
45784971	1713332	0	0
45876249	3019550	3	7
45897424	1127433	2	3
45897517	1192710	0	0
45896436	1125315	0	0
46290329	1125315	0	0
46299623	1129625	0	0
46320712	1177480	0	0
46320438	40232448	2	3
3050940	3006923	4	4
21000103	1746114	0	0
21500144	19127904	2	2
21503967	1112807	3	3
21501117	19079524	5	6
36155377	723013	0	0
36151533	1729720	0	0
36316088	4163872	0	0
43012036	43012036	0	0
44352265	19127922	2	2
44351058	1129625	0	0
45634626	1551099	0	0
45634726	1125315	0	0
45647698	1154615	2	3
44358978	1125315	0	0
45663187	1367571	0	0
45644636	19127890	0	0
45689073	40231925	2	3
45692055	1125315	0	0
45778905	1177480	0	0
45706925	1177480	0	0
45778487	1125315	0	0
46242823	1125315	0	0
45784983	791967	0	0
45876249	3045716	3	7
45897411	40232448	2	3
45897634	967823	0	0
45896457	1125315	0	0
46291542	1125315	0	0
46295704	1129625	0	0
46321012	1177480	0	0
46319953	1127433	2	3
3050940	3024561	4	4
21000083	1768849	0	0
21500144	40221415	2	2
21503967	1125315	3	3
21604253	40231925	5	6
36155552	1539403	0	0
36151608	1177480	0	0
36315243	4234705	0	0
42806018	791967	0	0
44352265	19133679	2	2
44350810	1322184	0	0
45634628	1551099	0	0
45634730	1125315	0	0
45647800	1115171	2	3
44359179	1125315	0	0
45663307	1000560	0	0
45644636	1549786	0	0
45689367	40231925	2	3
45692058	1125315	0	0
45779106	1177480	0	0
45706967	1177480	0	0
45778511	1125315	0	0
46242872	1125315	0	0
45785100	1332418	0	0
45876249	3000963	3	7
45895004	45892894	2	3
45897746	1332418	0	0
45896459	1125315	0	0
46291544	1125315	0	0
46295706	1129625	0	0
46314902	1177480	0	0
46320233	19059056	2	3
443783	258780	4	4
21000110	1778162	0	0
4274025	439777	2	2
21503967	1154029	3	3
21500001	19073188	5	6
36155660	1000560	0	0
36151699	967823	0	0
40769184	40769184	0	0
42806042	1713332	0	0
44358755	1115171	2	3
44351185	1177480	0	0
45634386	1174888	0	0
45634552	1125315	0	0
45647766	1127433	2	3
44358336	1125315	0	0
45663298	1309944	0	0
45644386	914335	0	0
45689568	1115171	2	3
45692138	1125315	0	0
45779188	1177480	0	0
45706968	1177480	0	0
45780612	1125315	0	0
46242804	1125315	0	0
45785106	967823	0	0
45885344	80502	4	4
45894948	19132304	2	3
45897641	975125	0	0
45896468	1125315	0	0
46291800	1125315	0	0
46296032	1129625	0	0
46314194	1177480	0	0
46313830	43012036	2	3
75909	4278672	4	4
21000169	975125	0	0
21500130	1515774	2	2
21500454	738818	3	3
21500001	19129655	5	6
36155663	1177480	0	0
36151411	1115008	0	0
40769189	40769189	0	0
42806048	723013	0	0
44358891	920334	2	3
44348371	1129625	0	0
45634711	738818	0	0
45634754	1125315	0	0
45648040	40232448	2	3
44358327	1125315	0	0
45663319	967823	0	0
45644560	1192710	0	0
45686296	40232448	2	3
45694662	1125315	0	0
45779128	1177480	0	0
45707140	1177480	0	0
45780461	1125315	0	0
46242975	1125315	0	0
45785058	1112807	0	0
45885344	4035415	4	4
45895189	42707627	2	3
45897647	19002770	0	0
45896622	1125315	0	0
46241845	1125315	0	0
46295669	1129625	0	0
46317375	1177480	0	0
46313837	42707627	2	3
75865	195588	4	4
21000083	1728416	0	0
21500130	19054876	2	2
21500454	1129625	3	3
21500001	19133905	5	6
36155491	738818	0	0
36151413	19127890	0	0
40769194	40769194	0	0
42806106	1177480	0	0
44359196	19133905	2	3
44348510	1713332	0	0
45634714	1124957	0	0
45637094	1125315	0	0
45647931	19008572	2	3
44358529	1125315	0	0
45663321	1551099	0	0
45645909	1118084	0	0
45686301	1127433	2	3
45694621	1125315	0	0
45777982	1177480	0	0
45707156	1177480	0	0
45780523	1125315	0	0
46242738	1125315	0	0
45785237	975125	0	0
45885344	4134304	8	9
45894960	40236824	2	3
45897807	1118084	0	0
45893839	1125315	0	0
46241955	1125315	0	0
46295324	1129625	0	0
46315157	1177480	0	0
46313731	19018935	2	3
31821	4144583	4	4
21000148	1738521	0	0
21500130	1548195	2	2
21500454	1000560	3	3
21500001	19073183	5	6
36155495	1310149	0	0
36151413	1549786	0	0
40169216	40169216	0	0
42806078	701322	0	0
44359200	1551192	2	3
44348510	1759842	0	0
45634689	19003953	0	0
45637162	1125315	0	0
45644499	19059056	2	3
44358531	1125315	0	0
45663407	1124300	0	0
45646108	1539403	0	0
45686228	1127433	2	3
45694622	1125315	0	0
45707831	1177480	0	0
45707215	1177480	0	0
45706951	1125315	0	0
46242923	1125315	0	0
45785239	1153428	0	0
45885344	78272	8	9
45894973	40236824	2	3
45897772	1174888	0	0
45893930	1125315	0	0
46241958	1125315	0	0
46295693	1129625	0	0
46304516	1177480	0	0
46314075	40229134	2	3
9201	9201	0	0
21000174	975125	0	0
21500130	1589505	2	2
21500363	1154343	3	3
21500001	19133873	5	6
36155496	1545958	0	0
36151637	1192710	0	0
40169281	40169281	0	0
42806081	967823	0	0
44352057	1551192	2	3
44348520	1308738	0	0
45634289	1124300	0	0
45637120	1125315	0	0
45644596	19019273	2	3
44358428	1125315	0	0
45663453	1149196	0	0
45645868	1500211	0	0
45686283	40174880	2	3
45689281	1125315	0	0
45707821	1177480	0	0
45707293	1177480	0	0
45707069	1125315	0	0
46242925	1125315	0	0
45785240	1332418	0	0
45885344	4230399	7	8
45895069	40231925	2	3
45897595	1713332	0	0
45893943	1125315	0	0
46241961	1125315	0	0
46295996	1129625	0	0
46304867	1177480	0	0
46314785	40162522	2	3
9202	9202	0	0
21000116	1729720	0	0
21500130	1500211	2	2
21500363	1149380	3	3
21500001	1713671	5	6
36155497	914335	0	0
36151424	738818	0	0
37521795	4337138	0	0
42806174	1308738	0	0
44352336	46275916	2	3
44348480	1322184	0	0
45634394	1000560	0	0
45637311	1125315	0	0
45644672	19008572	2	3
44358433	1125315	0	0
45663397	715997	0	0
45646112	1124300	0	0
45686375	920334	2	3
45689291	1125315	0	0
45704686	1177480	0	0
45707144	1177480	0	0
45707138	1125315	0	0
46242927	1125315	0	0
45785068	975125	0	0
45885344	4146173	5	6
45895211	40232448	2	3
45897597	1107830	0	0
45893838	1125315	0	0
46241965	1125315	0	0
46296181	1129625	0	0
46321539	1177480	0	0
46314456	43012036	2	3
9203	9203	0	0
19006318	19006318	0	0
21500130	19127890	2	2
21500363	1137529	3	3
21500001	46275444	5	6
36155499	1154343	0	0
36151739	914335	0	0
37521796	4323902	0	0
42806179	1177480	0	0
44355208	40232448	2	3
44348419	1124300	0	0
45631207	1149196	0	0
45637312	1125315	0	0
45646138	19075601	2	3
44358396	1125315	0	0
45663398	1153428	0	0
45646138	1322184	0	0
45686437	19008572	2	3
45689040	1125315	0	0
45704930	1177480	0	0
45707083	1177480	0	0
45707080	1125315	0	0
46243039	1125315	0	0
45786594	1326303	0	0
45885344	81151	5	8
45895197	43012036	2	3
45897642	1717327	0	0
45894024	1125315	0	0
46241968	1125315	0	0
46295649	1129625	0	0
46321127	1177480	0	0
46314512	40236446	2	3
1512674	1512674	0	0
19007333	19007333	0	0
21500130	1512674	2	2
35102039	4280726	3	3
21604146	40173590	5	6
36155501	1309944	0	0
36151743	1332418	0	0
40173590	40173590	0	0
42806182	1192710	0	0
44355210	46275916	2	3
44348694	1177480	0	0
45631288	1309944	0	0
45631644	1125315	0	0
45646096	1551192	2	3
44358419	1125315	0	0
45663405	738818	0	0
45646096	1551099	0	0
45686407	43012036	2	3
45689046	1125315	0	0
45633148	1112807	0	0
45707106	1177480	0	0
45707289	1125315	0	0
46242934	1125315	0	0
45786243	1192710	0	0
45885344	40480160	5	7
45895325	1332419	2	3
45897620	1153428	0	0
45894025	1125315	0	0
46242013	1125315	0	0
46295888	1129625	0	0
46315409	1177480	0	0
46315024	40229134	2	3
1515774	1515774	0	0
4330583	4330583	0	0
21500130	1521369	2	2
21505691	1557272	3	3
21503967	40165015	5	6
36155581	738818	0	0
36151744	1177480	0	0
40171902	40171902	0	0
42806183	1343916	0	0
44355384	43012036	2	3
44348654	933724	0	0
45631287	708298	0	0
45631618	1125315	0	0
45646149	1545959	2	3
44358420	1125315	0	0
45663406	1115008	0	0
45646099	1107830	0	0
45686361	40162522	2	3
45689049	1125315	0	0
45676446	1112807	0	0
45707345	1177480	0	0
45707111	1125315	0	0
46243069	1125315	0	0
45786252	1112807	0	0
45885344	4237458	5	7
45894313	40174880	2	3
45897599	1322184	0	0
45894026	1125315	0	0
46242014	1125315	0	0
46295925	1129625	0	0
46316170	1177480	0	0
46308841	19008572	2	3
1322184	1322184	0	0
4306014	4306014	0	0
21500130	1549786	2	2
21601136	967823	3	3
21503967	19133768	5	6
36155582	1713332	0	0
36151638	1177480	0	0
36424575	1343916	0	0
42806188	1549786	0	0
44352516	1115171	2	3
44348532	1110410	0	0
45631027	1192710	0	0
45631466	1125315	0	0
45644757	19019273	2	3
44358448	1125315	0	0
45663511	1107830	0	0
45646102	738818	0	0
45686472	40232448	2	3
45689145	1125315	0	0
45676986	1112807	0	0
45707152	1177480	0	0
45707329	1125315	0	0
46242745	1125315	0	0
45782803	1548195	0	0
45885344	4142905	5	7
45894536	1127433	2	3
45897601	1107830	0	0
45894027	1125315	0	0
46242016	1125315	0	0
46291186	1129625	0	0
46310220	1177480	0	0
46308974	19019273	2	3
1326303	1326303	0	0
4294548	4294548	0	0
21500130	40221415	2	2
21604792	40223774	3	3
21500284	19112599	5	6
36155654	1174888	0	0
36151545	1153428	0	0
36516824	80180	0	0
42806253	19127890	0	0
44352547	920334	2	3
44346843	1177480	0	0
45631343	1107830	0	0
45631487	1125315	0	0
45644762	40232448	2	3
44358570	1125315	0	0
45663413	920293	0	0
45646155	1501700	0	0
45683177	40228214	2	3
45689157	1125315	0	0
45676633	1112807	0	0
45704590	1177480	0	0
45707097	1125315	0	0
46242816	1125315	0	0
45782803	1521369	0	0
45885344	4149245	6	7
45894580	40231925	2	3
45895389	1539403	0	0
45894028	1125315	0	0
46241912	1125315	0	0
46291149	1129625	0	0
46309630	1177480	0	0
46309107	19019273	2	3
1127078	1127078	0	0
4295880	4295880	0	0
21501218	967823	2	2
21601238	1361711	3	3
21500284	19125062	5	6
36155735	1118084	0	0
36151550	920293	0	0
36474579	1501700	0	0
42806253	1549786	0	0
44352425	1310034	2	3
44346851	1192710	0	0
45631344	914335	0	0
45631651	1125315	0	0
45644732	40236446	2	3
44358572	1125315	0	0
45663522	1118084	0	0
45646157	1343916	0	0
45683482	19073183	2	3
45689317	1125315	0	0
45677119	1112807	0	0
45700851	1177480	0	0
45707566	1125315	0	0
46243045	1125315	0	0
45782804	1124957	0	0
45885344	4066995	6	7
45802828	19077572	2	3
45895325	1332418	0	0
45894030	1125315	0	0
46242240	1125315	0	0
46244757	1129625	0	0
46309819	1177480	0	0
46309408	19019273	2	3
1127433	1127433	0	0
4296204	4296204	0	0
4248801	28060	2	2
21601238	1326303	3	3
21500284	43012036	5	6
36155462	738818	0	0
36151584	1129625	0	0
36468794	967823	0	0
42806222	1548195	0	0
44352503	40162522	2	3
44346866	723013	0	0
45631091	738818	0	0
45631813	1125315	0	0
45644868	40232448	2	3
44358474	1125315	0	0
45663523	1107830	0	0
45645923	914335	0	0
45683543	46233710	2	3
45689320	1125315	0	0
45673704	1112807	0	0
45700940	1177480	0	0
45707356	1125315	0	0
46242783	1125315	0	0
45782810	1112807	0	0
45885344	4278672	6	7
45803250	19008572	2	3
45895161	715997	0	0
45894109	1125315	0	0
46242271	1125315	0	0
46244968	1129625	0	0
46310443	1177480	0	0
46309122	40224805	2	3
920300	920300	0	0
4296205	4296205	0	0
4248801	433125	2	2
21601238	1309944	3	3
21500284	40232448	5	6
36155476	933724	0	0
36151610	1521369	0	0
36469239	1129625	0	0
42806129	1154343	0	0
44352453	40229134	2	3
44346874	723013	0	0
45631300	1110410	0	0
45631709	1125315	0	0
45641677	19019273	2	3
44358627	1125315	0	0
45663525	19127890	0	0
45645929	1192710	0	0
45683543	46233988	2	3
45689162	1125315	0	0
45673801	1112807	0	0
45700774	1177480	0	0
45706870	1125315	0	0
46242818	1125315	0	0
45782812	975125	0	0
45885344	40479768	6	7
45803373	40228214	2	3
45895435	1112807	0	0
45894114	1125315	0	0
46242072	1125315	0	0
46244635	1129625	0	0
46310390	1177480	0	0
46309333	40232448	2	3
920334	920334	0	0
4252419	4252419	0	0
21600651	975125	2	2
21601238	1343916	3	3
21500284	40228214	5	6
36155606	1548195	0	0
36151706	791967	0	0
36469239	1125315	0	0
42806130	1367571	0	0
44352756	1115171	2	3
44346891	1307863	0	0
45631313	1154343	0	0
45631933	1125315	0	0
45641749	19008572	2	3
44351293	1125315	0	0
45663525	1589505	0	0
45646193	1539403	0	0
45683485	40232448	2	3
45689237	1125315	0	0
45673944	1112807	0	0
45701188	1177480	0	0
45706821	1125315	0	0
46243020	1125315	0	0
45782874	1307863	0	0
45885344	4059173	6	7
45803260	19077344	2	3
45895287	1713332	0	0
45894135	1125315	0	0
46241946	1125315	0	0
46240116	1129625	0	0
46310440	1177480	0	0
46309371	40232448	2	3
740275	740275	0	0
4238715	4238715	0	0
21600652	975125	2	2
21602751	1501700	3	3
21500284	40223821	5	6
36155747	1177480	0	0
36151610	1549786	0	0
36468760	1149196	0	0
42806140	1149196	0	0
44352761	40232448	2	3
44346869	1177480	0	0
45633736	723013	0	0
45631879	1125315	0	0
45641684	19057271	2	3
44351356	1125315	0	0
45663150	1149380	0	0
45644757	1115008	0	0
45666469	40232448	2	3
45689215	1125315	0	0
45673134	1112807	0	0
45701197	1177480	0	0
45704175	1125315	0	0
46242787	1125315	0	0
45782918	1310149	0	0
45885344	40479422	6	7
45803411	40232448	2	3
45895289	1115008	0	0
45875954	21494966	3	3
46241950	1125315	0	0
45896674	1129625	0	0
46310537	1177480	0	0
46309379	1115171	2	3
742185	742185	0	0
4237458	4237458	0	0
21502709	19029476	2	2
21604253	1125315	3	3
21500284	1107882	5	6
36155664	1717327	0	0
36151860	1107830	0	0
36300000	4240902	10	11
42806257	1149380	0	0
44352619	40163554	2	3
44346854	757627	0	0
45633889	1000560	0	0
45631781	1125315	0	0
45641900	19133768	2	3
44351369	1125315	0	0
45663153	1738521	0	0
45644760	1124957	0	0
45666412	19078924	2	3
45689389	1125315	0	0
45670766	1112807	0	0
45701022	1177480	0	0
45704202	1125315	0	0
46243103	1125315	0	0
45782920	1551099	0	0
45885344	4048695	6	7
45800456	40229134	2	3
45895270	967823	0	0
45791237	19127922	3	4
46242062	1125315	0	0
45896411	1129625	0	0
46305492	1177480	0	0
46309473	40232448	2	3
757627	757627	0	0
4219399	4219399	0	0
21500595	1115008	2	2
21604253	1154029	3	3
21500284	40223834	5	6
36155620	1129625	0	0
36151864	1112807	0	0
36300000	4304110	9	10
42806260	1713332	0	0
44352742	45892894	2	3
44346856	753626	0	0
45633891	1548195	0	0
45631782	1125315	0	0
45641911	40232448	2	3
44351269	1125315	0	0
45663525	1549786	0	0
45644728	738818	0	0
45666413	1115171	2	3
45689073	1125315	0	0
45670910	1112807	0	0
45698116	1177480	0	0
45704205	1125315	0	0
46240480	1125315	0	0
45782922	1149196	0	0
45885349	78272	5	5
45800427	19075001	2	3
45895326	1000560	0	0
46238184	19123231	2	3
46242234	1125315	0	0
45896472	1129625	0	0
46304723	1177480	0	0
46309366	40231925	2	3
738818	738818	0	0
21001427	1729720	0	0
21500139	1549786	2	2
21604253	1110410	3	3
21500284	1150771	5	6
36155671	1551099	0	0
36151730	1309944	0	0
36300000	258780	9	14
42806134	1115008	0	0
44352483	1115171	2	3
44346876	1154343	0	0
45633823	1174888	0	0
45632199	1125315	0	0
45642022	1310034	2	3
44351214	1125315	0	0
45663373	738818	0	0
45644732	705944	0	0
45664441	43012036	2	3
45689449	1125315	0	0
45669420	1112807	0	0
45698153	1177480	0	0
45704276	1125315	0	0
46240521	1125315	0	0
45782827	967823	0	0
45885349	4134304	4	6
45800479	1115171	2	3
45895372	1192710	0	0
45798249	40232448	2	3
46242182	1125315	0	0
45896473	1129625	0	0
46305546	1177480	0	0
46303718	1115171	2	3
439406	439406	0	0
21001385	1768849	0	0
21500139	43012433	2	2
21604253	1112807	3	3
21500284	40228230	5	6
36155675	1112807	0	0
36151683	738818	0	0
36300000	4051466	8	9
42806146	1125315	0	0
42802580	19133905	2	3
44346947	1192710	0	0
45633826	1115008	0	0
45632200	1125315	0	0
45642072	40162522	2	3
44351493	1125315	0	0
45663194	738818	0	0
45644766	1124300	0	0
45664454	19008572	2	3
45689367	1125315	0	0
45669630	1112807	0	0
45695046	1177480	0	0
45704279	1125315	0	0
46240589	1125315	0	0
45783005	1549786	0	0
45885349	40479422	4	4
45800564	19073183	2	3
45895372	1112807	0	0
45798453	19008572	2	3
46242185	1125315	0	0
45896683	1129625	0	0
46306530	1177480	0	0
46303846	1115171	2	3
439777	439777	0	0
21001430	1551099	0	0
21500139	1519936	2	2
35102398	4056621	3	3
21500284	1150837	5	6
36155766	791967	0	0
36151754	1000560	0	0
36300000	372328	8	11
42806153	1545958	0	0
42802580	19133873	2	3
44346911	1549786	0	0
45633842	1192710	0	0
45632152	1125315	0	0
45642074	19018935	2	3
44351433	1125315	0	0
45663243	1110410	0	0
45644837	738818	0	0
45664522	1127433	2	3
45689535	1125315	0	0
45780723	1112807	0	0
45694639	1177480	0	0
45704285	1125315	0	0
46240559	1125315	0	0
45783005	1515774	0	0
45885349	40479768	4	4
45800525	1127433	2	3
45895363	1500211	0	0
45798667	40163554	2	3
46242309	1125315	0	0
45896687	1129625	0	0
46316470	1177480	0	0
46303861	40162522	2	3
440086	440086	0	0
21001382	1728416	0	0
21500141	975125	2	2
35102397	4056621	3	3
21500363	40169216	5	6
36155772	1115008	0	0
36151779	1192710	0	0
36300000	4113008	8	11
42806144	1548195	0	0
42802731	1127433	2	3
44346911	1512674	0	0
45633939	967823	0	0
45631898	1125315	0	0
45638829	19077344	2	3
44351375	1125315	0	0
45663258	1738521	0	0
45644721	1738521	0	0
45664603	19008572	2	3
45689354	1125315	0	0
45781071	1112807	0	0
45694930	1177480	0	0
45704264	1125315	0	0
46240561	1125315	0	0
45783025	1149196	0	0
45885349	81151	4	4
45800505	40224805	2	3
45895368	1102527	0	0
45798601	40232448	2	3
46241988	1125315	0	0
45894255	1129625	0	0
46316283	1177480	0	0
46303937	1107882	2	3
440448	440448	0	0
21001382	1717327	0	0
21500141	1589505	2	2
35102035	439777	3	3
21502569	1551192	5	6
36155696	715997	0	0
36151693	1309944	0	0
36300000	261325	8	13
42806287	1738521	0	0
42802914	40231925	2	3
44346916	738818	0	0
45633940	1308738	0	0
45631840	1125315	0	0
45638938	19008572	2	3
44351461	1125315	0	0
45663664	967823	0	0
45644866	1174888	0	0
45663979	43012433	2	3
45689615	1125315	0	0
45781072	1112807	0	0
45695019	1177480	0	0
45704186	1125315	0	0
46240556	1125315	0	0
45783027	1332418	0	0
45885352	4230399	3	3
45800599	19077572	2	3
45895476	1124300	0	0
45798603	40174880	2	3
46242312	1125315	0	0
45894357	1129625	0	0
46315978	1177480	0	0
46306441	40236824	2	3
317009	317009	0	0
21001382	1729720	0	0
21500074	933724	2	2
35102392	4056621	3	3
21502620	1738521	5	5
36155609	1124957	0	0
36151883	1112807	0	0
36300000	4066995	7	13
42806217	1309944	0	0
44344956	1127433	2	3
44346991	1549786	0	0
45633948	1557272	0	0
45631515	1125315	0	0
45639056	19008572	2	3
44351616	1125315	0	0
45663155	715997	0	0
45641673	933724	0	0
45663984	19075601	2	3
45689442	1125315	0	0
45781023	1112807	0	0
45695057	1177480	0	0
45704207	1125315	0	0
46240756	1125315	0	0
45783031	1149196	0	0
45885352	4134304	4	4
45800729	40236824	2	3
45895293	1112807	0	0
45798330	19008572	2	3
46242027	1125315	0	0
45799607	1129625	0	0
46316571	1177480	0	0
46306951	19079524	2	3
317576	317576	0	0
21001384	1713332	0	0
21003349	40243436	2	3
21503587	1192710	3	3
21500327	1119510	5	5
36155749	1192710	0	0
36151867	1738521	0	0
36300000	40480160	7	13
42806231	1332418	0	0
44345188	19008572	2	3
44346938	1332418	0	0
45631375	1548195	0	0
45632103	1125315	0	0
45639084	40174880	2	3
44351550	1125315	0	0
45663158	1174888	0	0
45641808	1549786	0	0
45664023	40163554	2	3
45689056	1125315	0	0
45781146	1112807	0	0
45695055	1177480	0	0
45704331	1125315	0	0
46240780	1125315	0	0
45782876	1322184	0	0
45885353	4134304	4	4
45800845	1713671	2	3
45895352	914335	0	0
45798573	19059056	2	3
46242257	1125315	0	0
46318278	1129625	0	0
46310551	1177480	0	0
46304229	19008572	2	3
321042	321042	0	0
21001384	1759842	0	0
21003251	40236824	2	3
35102391	4056621	3	3
21500327	1112807	5	5
36155617	1124300	0	0
36151852	738818	0	0
36300000	4043241	6	15
42806262	1729720	0	0
44345008	40232448	2	3
44347024	738818	0	0
45631378	975125	0	0
45628600	1125315	0	0
45635487	40163554	2	3
44351552	1125315	0	0
45663454	753626	0	0
45641808	1589505	0	0
45663949	1127433	2	3
45689569	1125315	0	0
45780597	1112807	0	0
45697647	1177480	0	0
45704337	1125315	0	0
46240777	1125315	0	0
45783065	967823	0	0
45894456	19128022	3	4
45800847	19133873	2	3
45895355	1107830	0	0
45798352	1115171	2	3
46242041	1125315	0	0
46318132	1129625	0	0
46310959	1177480	0	0
46304123	1115171	2	3
372328	372328	0	0
21001384	975125	0	0
21502622	46275444	2	3
35102395	4056621	3	3
21500327	1129625	5	5
36155697	1124300	0	0
36151858	1177480	0	0
36300000	4202451	6	9
42806234	975125	0	0
44345112	40229134	2	3
44347036	1129625	0	0
45631489	740275	0	0
45628602	1125315	0	0
45635590	40232448	2	3
44351794	1125315	0	0
45663459	738818	0	0
45641809	967823	0	0
45664165	19008572	2	3
45689576	1125315	0	0
45780854	1112807	0	0
45691644	1177480	0	0
45704290	1125315	0	0
46240782	1125315	0	0
45782840	914335	0	0
45792623	19128065	3	4
45797647	40162522	2	3
45895249	975125	0	0
45798763	19008572	2	3
46242203	1125315	0	0
46318251	1129625	0	0
46310712	1177480	0	0
46320565	1115171	2	3
134438	134438	0	0
21001390	975125	0	0
21500589	19133768	2	3
21604685	757627	3	3
21500327	738818	5	5
36155823	1545958	0	0
36151996	1115008	0	0
36303196	4163872	1	1
42806288	1326303	0	0
44345000	1127433	2	3
44347038	1192710	0	0
45631494	1110410	0	0
45628500	1125315	0	0
45635694	1713671	2	3
44351957	1125315	0	0
45663470	1521369	0	0
45641884	914335	0	0
45664116	19074841	2	3
45686256	1125315	0	0
45780856	1112807	0	0
45691983	1177480	0	0
45704227	1125315	0	0
46240790	1125315	0	0
45782833	1738521	0	0
45696797	791967	0	0
45797814	1545959	2	3
45895425	1149380	0	0
45798687	1115171	2	3
46242287	1125315	0	0
46318325	1129625	0	0
46310895	1177480	0	0
46320570	19059056	2	3
140673	140673	0	0
21001402	975125	0	0
21500589	40162522	2	3
21604685	742185	3	3
21500327	1174888	5	5
36157779	1119510	0	0
36152000	1746114	0	0
40236820	40236824	1	1
42806289	1332418	0	0
44338226	19018935	2	3
44346925	1149196	0	0
45631426	1713332	0	0
45628725	1125315	0	0
45636934	19126352	2	3
44351658	1125315	0	0
45663470	1595799	0	0
45641870	967823	0	0
45660789	1332419	2	3
45686258	1125315	0	0
45778553	1112807	0	0
45691403	1177480	0	0
45704296	1125315	0	0
46240544	1125315	0	0
45782891	1174888	0	0
45696730	975125	0	0
45797900	40232448	2	3
45895406	1174888	0	0
45793271	19008572	2	3
46242288	1125315	0	0
46312318	1129625	0	0
46306043	1177480	0	0
46320434	40229134	2	3
28060	28060	0	0
21001414	1778162	0	0
21002773	19129655	2	3
21603890	1305058	3	3
21500327	914335	5	5
36157782	1119510	0	0
36152000	1741122	0	0
36516779	80809	1	1
42806281	1309944	0	0
44338098	40229134	2	3
44346926	1713332	0	0
45631427	1115008	0	0
45631104	1125315	0	0
45635709	40232448	2	3
44351630	1125315	0	0
45663470	1549786	0	0
45641841	1153428	0	0
45660753	19078924	2	3
45686246	1125315	0	0
45778555	1112807	0	0
45688854	1177480	0	0
45704401	1125315	0	0
46240684	1125315	0	0
45782983	1000560	0	0
45696301	1192710	0	0
45795158	19073188	2	3
45895486	1332418	0	0
45793288	1115171	2	3
45893620	1125315	0	0
46312440	1129625	0	0
46317008	1177480	0	0
46320600	1545959	2	3
30753	30753	0	0
21000923	791967	0	0
21003348	40243436	2	3
21603890	19010482	3	3
21500327	1177480	5	5
36158052	1119510	0	0
36198920	1129625	0	0
36302170	4059173	9	12
42806345	1500211	0	0
44362931	1115171	2	3
44347041	1778162	0	0
45631508	1154029	0	0
45631105	1125315	0	0
45636056	19019273	2	3
44351564	1125315	0	0
45663595	1149196	0	0
45641875	1307863	0	0
45661023	1551192	2	3
45686299	1125315	0	0
45778556	1112807	0	0
45688831	1177480	0	0
45704420	1125315	0	0
46240720	1125315	0	0
45782843	1153428	0	0
45696374	1115008	0	0
45795109	19018935	2	3
45895250	1107830	0	0
45793109	1127433	2	3
45893595	1125315	0	0
46312771	1129625	0	0
46317106	1177480	0	0
46320911	46233710	2	3
3045716	3045716	0	0
21000923	723013	0	0
21001827	46275444	2	3
35102047	439777	3	3
21500327	1115008	5	5
36158082	1119510	0	0
36159647	1115008	0	0
36302170	4310024	7	11
42806421	791967	0	0
44359239	1127433	2	3
44347042	1112807	0	0
45631395	1115008	0	0
45628858	1125315	0	0
45632558	1115171	2	3
44351904	1125315	0	0
45637028	1119510	0	0
45641845	791967	0	0
45660672	43012036	2	3
45686301	1125315	0	0
45778667	1112807	0	0
45688940	1177480	0	0
45704525	1125315	0	0
45680974	1119510	0	0
45782992	1115008	0	0
45696564	1500211	0	0
45795112	40163554	2	3
45895487	975125	0	0
45793110	1127433	2	3
45893628	1125315	0	0
46306954	1129625	0	0
46319806	1177480	0	0
46320661	1115171	2	3
3049273	3049273	0	0
21000931	723013	0	0
21012458	40223768	2	3
21603812	1500211	3	3
21502553	1309944	5	5
36157788	1119510	0	0
36159652	914335	0	0
36302170	80502	7	9
42806426	1729720	0	0
44359387	1551192	2	3
44347048	1129625	0	0
45631441	1738521	0	0
45628812	1125315	0	0
45632751	1127433	2	3
44351591	1125315	0	0
45636837	1119510	0	0
45641677	1115008	0	0
45660631	40232448	2	3
45686250	1125315	0	0
45779130	1112807	0	0
45689081	1177480	0	0
45704248	1125315	0	0
45681062	1119510	0	0
45782994	920293	0	0
45696574	1759842	0	0
45795500	46233710	2	3
45895443	1192710	0	0
45793192	40229134	2	3
45893579	1125315	0	0
46307032	1129625	0	0
46317237	1177480	0	0
46320918	40229134	2	3
3051031	3051031	0	0
21000919	723013	0	0
21001427	19133905	2	3
21602722	1551099	3	3
21502553	1545958	5	5
36157910	1119510	0	0
36159653	1129625	0	0
36302170	4314290	7	7
42806433	1115008	0	0
44359368	19133873	2	3
44347070	1545958	0	0
45631544	1174888	0	0
45628912	1125315	0	0
45632824	19133768	2	3
44351822	1125315	0	0
45636838	1119510	0	0
45641684	791967	0	0
45660993	19019273	2	3
45686220	1125315	0	0
45778650	1112807	0	0
45689092	1177480	0	0
45704373	1125315	0	0
45681221	1119510	0	0
45783244	1112807	0	0
45696574	1713332	0	0
45795433	19059056	2	3
45895444	1713332	0	0
45793194	40229134	2	3
45893629	1125315	0	0
46307053	1129625	0	0
46313410	738818	0	0
46321276	1115171	2	3
3001488	3001488	0	0
21000931	708298	0	0
21000196	46233988	2	3
21601744	1332418	3	3
21502553	914335	5	5
36157914	1119510	0	0
36159655	1149196	0	0
36302170	4296205	8	8
42806190	715997	0	0
44359375	40162522	2	3
44347072	933724	0	0
45631544	1192710	0	0
45625857	1125315	0	0
45632811	46233710	2	3
44351830	1125315	0	0
45637150	1119510	0	0
45641687	1110410	0	0
45661024	19019273	2	3
45686228	1125315	0	0
45778892	1112807	0	0
45686109	1177480	0	0
45704418	1125315	0	0
45675832	1119510	0	0
45783072	1549786	0	0
45696383	1174888	0	0
45795435	40162522	2	3
45895515	1112807	0	0
45793370	19078461	2	3
45893602	1125315	0	0
46312066	1129625	0	0
46308558	738818	0	0
46320638	1115171	2	3
3013682	3013682	0	0
21000953	740275	0	0
21001627	19059056	2	3
21601744	1307863	3	3
21502584	1124300	5	5
36157928	1119510	0	0
36159626	1521369	0	0
36302170	4116491	8	10
42806251	701322	0	0
44359984	19059056	2	3
44347172	1549786	0	0
45631501	1110410	0	0
45625946	1125315	0	0
45632769	19008572	2	3
44352111	1125315	0	0
45635940	1119510	0	0
45641888	1124957	0	0
45660989	35605482	2	3
45686681	1125315	0	0
45707373	1112807	0	0
45685748	1177480	0	0
45704503	1125315	0	0
45675925	1119510	0	0
45783072	19127890	0	0
45696384	1192710	0	0
45795293	1115171	2	3
45895444	1759842	0	0
45793480	40231925	2	3
45893696	1125315	0	0
46307219	1129625	0	0
46308297	738818	0	0
46315054	40229134	2	3
3013721	3013721	0	0
21000012	1717327	0	0
21502524	920300	2	3
35306088	378419	3	3
21502584	1129625	5	5
36157802	1119510	0	0
36159626	1549786	0	0
36302170	4296204	8	11
42806357	1548195	0	0
44359527	1125315	0	0
44347172	19127890	0	0
45631453	975125	0	0
45625742	1125315	0	0
45632870	19059056	2	3
44351967	1125315	0	0
45635960	1119510	0	0
45641625	1154343	0	0
45660697	19019273	2	3
45686410	1125315	0	0
45707561	1112807	0	0
45686202	1177480	0	0
45704512	1125315	0	0
45675907	1119510	0	0
45783073	1713332	0	0
45696812	738818	0	0
45795638	19133905	2	3
45895448	1153428	0	0
45793295	19059056	2	3
45893701	1125315	0	0
46307273	1129625	0	0
46308570	738818	0	0
46313873	40162522	2	3
3015076	3015076	0	0
21000013	1728416	0	0
21502524	920334	2	3
21500284	1107830	3	3
21502584	723013	5	5
36158206	1119510	0	0
36159638	1177480	0	0
36302170	4149245	8	12
42806305	1307863	0	0
44359547	1125315	0	0
44347172	1512674	0	0
45631610	1713332	0	0
45625881	1125315	0	0
45632644	40162522	2	3
44351733	1125315	0	0
45632547	1119510	0	0
45641626	1713332	0	0
45661050	19073183	2	3
45686374	1125315	0	0
45707486	1112807	0	0
45686135	1177480	0	0
45704513	1125315	0	0
45675909	1119510	0	0
45783073	1759842	0	0
45696813	975125	0	0
45795638	19133873	2	3
45895340	715997	0	0
45793297	19059056	2	3
45893706	1125315	0	0
46307965	1129625	0	0
46308311	738818	0	0
46314896	40162522	2	3
3021226	3021226	0	0
21000010	1717327	0	0
21001685	40163554	2	3
21600490	1000560	3	3
21502584	738818	5	5
36158323	1119510	0	0
36198896	1129625	0	0
36302170	4278672	8	12
42806546	1107830	0	0
44359700	1125315	0	0
44346957	1177480	0	0
45628148	1192710	0	0
45625885	1125315	0	0
45632804	19019273	2	3
44344098	1125315	0	0
45632789	1119510	0	0
45641894	1307863	0	0
45661053	19008572	2	3
45686401	1125315	0	0
45704607	1112807	0	0
45688653	1177480	0	0
45700800	1125315	0	0
45675910	1119510	0	0
45782837	1192710	0	0
45696818	1192710	0	0
45795382	1107882	2	3
45894537	1174888	0	0
45793305	19057271	2	3
45893753	1125315	0	0
46307354	1129625	0	0
46308692	738818	0	0
46314803	40162522	2	3
3023430	3023430	0	0
21000011	1717327	0	0
21000198	46233710	2	3
21505600	46221626	3	3
21502584	791967	5	5
36158371	1119510	0	0
36198902	1129625	0	0
36302170	40481087	8	12
42806350	1125315	0	0
44359708	1125315	0	0
44347000	1124957	0	0
45628162	1332418	0	0
45625526	1125315	0	0
45631085	19008572	2	3
44344057	1125315	0	0
45632931	1119510	0	0
45641895	791967	0	0
45661076	19008572	2	3
45686529	1125315	0	0
45704440	1112807	0	0
45683024	1177480	0	0
45700909	1125315	0	0
45676095	1119510	0	0
45783095	1112807	0	0
45696820	1548195	0	0
45792584	1115171	2	3
45803236	1192710	0	0
45793460	19076374	2	3
45893729	1125315	0	0
46307312	1129625	0	0
46312350	738818	0	0
46314940	40229134	2	3
3006906	3006906	0	0
21000009	1738521	0	0
21000224	46233988	2	3
21505600	19132304	3	3
21502659	19019273	3	4
36158375	1119510	0	0
36198903	1129625	0	0
36302170	4001336	8	12
42806218	1512674	0	0
44355619	1125315	0	0
44346863	1549786	0	0
45628554	1717327	0	0
45625829	1125315	0	0
45629651	19059056	2	3
44343785	1125315	0	0
45632932	1119510	0	0
45641964	1154343	0	0
45657969	19019273	2	3
45686427	1125315	0	0
45704822	1112807	0	0
45683037	1177480	0	0
45701042	1125315	0	0
45676064	1119510	0	0
45783098	1746114	0	0
45696820	1589505	0	0
45794537	40232448	2	3
45803332	1192710	0	0
45794807	1115171	2	3
45893745	1125315	0	0
46307210	1129625	0	0
46311838	738818	0	0
46314755	40163554	2	3
3006923	3006923	0	0
21000033	1717327	0	0
21000224	46233710	2	3
21505696	705944	3	3
21502621	46275444	3	4
36157824	1119510	0	0
36198925	1521369	0	0
36302170	4230399	8	13
42806218	1549786	0	0
44355521	1125315	0	0
44347011	1361711	0	0
45628573	1115008	0	0
45625835	1125315	0	0
45629720	19133905	2	3
44343804	1125315	0	0
45632941	1119510	0	0
45641967	1548195	0	0
45657996	19059056	2	3
45686684	1125315	0	0
45704672	1112807	0	0
45683085	1177480	0	0
45700803	1125315	0	0
45676014	1119510	0	0
45783098	1741122	0	0
45696824	1107830	0	0
45794734	19077572	2	3
45803198	975125	0	0
45794685	1115171	2	3
45893771	1125315	0	0
46307464	1129625	0	0
46308813	738818	0	0
46314698	1551192	2	3
3024561	3024561	0	0
21000010	1713332	0	0
21002677	19008572	2	3
21603365	1125443	3	3
21502621	1713671	3	4
36158348	1119510	0	0
36198925	1549786	0	0
36302170	4102123	8	9
42806350	1112807	0	0
44356063	1125315	0	0
44347014	705944	0	0
45628590	967823	0	0
45626033	1125315	0	0
45629662	40165015	2	3
44343889	1125315	0	0
45632843	1119510	0	0
45641823	1115008	0	0
45657716	19018935	2	3
45686594	1125315	0	0
45704788	1112807	0	0
45682734	1177480	0	0
45700947	1125315	0	0
45676016	1119510	0	0
45783102	1192710	0	0
45696848	920293	0	0
45792774	40232448	2	3
45803368	19127890	0	0
45787990	1115171	2	3
45893772	1125315	0	0
46307668	1129625	0	0
46303814	738818	0	0
46314856	40228214	2	3
3024731	3024731	0	0
21000049	1738521	0	0
21000218	46233710	2	3
21603365	1174888	3	3
21600960	40163554	3	6
36158445	1119510	0	0
36198927	19127890	0	0
36302170	439406	8	9
42806276	1549786	0	0
44355795	1125315	0	0
44347019	1154343	0	0
45628524	1124300	0	0
45626072	1125315	0	0
45629671	40224805	2	3
44344011	1125315	0	0
45632869	1119510	0	0
45642005	1110410	0	0
45658060	19078924	2	3
45686361	1125315	0	0
45704905	1112807	0	0
45682897	1177480	0	0
45700814	1125315	0	0
45675866	1119510	0	0
45783199	1149380	0	0
45696854	1153428	0	0
45792882	40229134	2	3
45803368	1549786	0	0
45787950	40236824	2	3
45893785	1125315	0	0
46302106	1129625	0	0
46303918	738818	0	0
46317595	19075001	2	3
1729720	1729720	0	0
21000038	1551099	0	0
21001655	40163554	2	3
21500260	46275916	3	4
21600960	19075601	3	6
36158457	1119510	0	0
36198837	1192710	0	0
36302170	4280726	6	13
42806319	1124957	0	0
44355653	1125315	0	0
44347121	1322184	0	0
45628632	1115008	0	0
45626073	1125315	0	0
45629750	1545959	2	3
44344113	1125315	0	0
45632956	1119510	0	0
45641900	1174888	0	0
45657876	40232448	2	3
45683170	1125315	0	0
45704660	1112807	0	0
45661628	1129625	0	0
45700985	1125315	0	0
45672972	1119510	0	0
45783230	1174888	0	0
45696307	1154029	0	0
45792979	1115171	2	3
45803337	1118084	0	0
45788005	43012036	2	3
45893740	1125315	0	0
46302151	1129625	0	0
46300876	738818	0	0
46317746	40229134	2	3
1746114	1746114	0	0
21000242	1728416	0	0
21001824	46275444	2	3
21500290	40228230	3	4
21604253	40165015	3	6
36158215	1119510	0	0
36198839	1512674	0	0
36302170	4029498	6	9
42806392	1545958	0	0
44355810	1125315	0	0
44347124	1738521	0	0
45628508	1192710	0	0
45625906	1125315	0	0
45629757	40162522	2	3
44344121	1125315	0	0
45632958	1119510	0	0
45641908	914335	0	0
45658070	40165015	2	3
45683175	1125315	0	0
45705027	1112807	0	0
45661715	1129625	0	0
45700925	1125315	0	0
45672928	1119510	0	0
45783034	1174888	0	0
45696665	967823	0	0
45792798	43012036	2	3
45803341	967823	0	0
45788038	19077572	2	3
45893741	1125315	0	0
46302107	1129625	0	0
46300885	738818	0	0
46317753	920334	2	3
1741122	1741122	0	0
21000243	1738521	0	0
21003394	1551192	2	3
21500290	19125062	3	4
21500885	975125	3	3
36157952	1119510	0	0
36198839	1549786	0	0
36302170	317009	6	7
42806320	1124957	0	0
44355992	1125315	0	0
44347198	701322	0	0
45628179	1759842	0	0
45626109	1125315	0	0
45629759	40163554	2	3
44343930	1125315	0	0
45630938	1119510	0	0
45642071	1343916	0	0
45658153	19019273	2	3
45683514	1125315	0	0
45701271	1112807	0	0
45704092	1129625	0	0
45701008	1125315	0	0
45673051	1119510	0	0
45783458	1174888	0	0
45696874	738818	0	0
45792799	1115171	2	3
45803427	1332418	0	0
45788040	19076374	2	3
45893836	1125315	0	0
46302306	1129625	0	0
46301915	738818	0	0
46317384	1115171	2	3
1718412	1718412	0	0
21000268	1778162	0	0
21011491	19076374	2	3
21500290	40228214	3	4
21600960	1322184	3	3
36154244	1119510	0	0
36198840	1129625	0	0
36302170	80809	5	9
42806320	1125315	0	0
44356016	1125315	0	0
44347092	738818	0	0
45628179	1713332	0	0
45626091	1125315	0	0
45641759	40232448	2	3
44344252	1125315	0	0
45630940	1119510	0	0
45642022	1309944	0	0
45657743	19075001	2	3
45683350	1125315	0	0
45701404	1112807	0	0
45704053	1129625	0	0
45701001	1125315	0	0
45673228	1119510	0	0
45783077	1115008	0	0
45696882	1174888	0	0
45790056	19078924	2	3
45803428	1115008	0	0
45788146	19059056	2	3
45893751	1125315	0	0
46306854	1129625	0	0
46301200	738818	0	0
46317932	19079524	2	3
1718994	1718412	0	0
19023398	19023398	0	0
21002686	19008572	2	3
21500290	1150771	3	4
21600960	1112807	3	3
36154380	1119510	0	0
36198843	1129625	0	0
36302170	4252419	5	8
42806356	1177480	0	0
44356172	1125315	0	0
44347251	1115008	0	0
45628184	1361711	0	0
45622578	1125315	0	0
45641694	40162522	2	3
44344070	1125315	0	0
45630941	1119510	0	0
45642110	1549786	0	0
45658316	19008572	2	3
45683517	1125315	0	0
45703659	1112807	0	0
45651522	1129625	0	0
45701334	1125315	0	0
45673229	1119510	0	0
45783206	1729720	0	0
45696709	1154343	0	0
45790155	19018935	2	3
45803269	1361711	0	0
45788219	40231925	2	3
45893842	1125315	0	0
46306863	1129625	0	0
46301325	738818	0	0
46315287	1115171	2	3
1738521	1738521	0	0
19023423	19023423	0	0
21003226	40232448	2	3
21500290	1150837	3	4
21600960	1367571	3	3
36154473	1119510	0	0
36199695	1115008	0	0
36302170	4024289	5	8
42806447	1713332	0	0
44355922	1125315	0	0
44347179	1149380	0	0
45628351	1551099	0	0
45622841	1125315	0	0
45641571	40223834	2	3
44344240	1125315	0	0
45629618	1119510	0	0
45642110	1512674	0	0
45654519	19078461	2	3
45683519	1125315	0	0
45701475	1112807	0	0
45651451	1129625	0	0
45701346	1125315	0	0
45673164	1119510	0	0
45783425	1192710	0	0
45696710	967823	0	0
45790160	40229134	2	3
45803349	1192710	0	0
45788226	40162522	2	3
45893885	1125315	0	0
46306967	1129625	0	0
46319235	738818	0	0
46315316	40163554	2	3
1521369	1521369	0	0
4329847	4329847	0	0
21001662	19059056	2	3
21504554	44816277	3	4
21600960	1310149	3	3
36154389	1119510	0	0
36199705	1107830	0	0
36302170	4058899	4	9
42803986	1154343	0	0
44355945	1125315	0	0
44346976	1551099	0	0
45628540	1192710	0	0
45622843	1125315	0	0
45641550	42707627	2	3
44344173	1125315	0	0
45629621	1119510	0	0
45642110	19127890	0	0
45654535	920334	2	3
45683259	1125315	0	0
45701654	1112807	0	0
45651709	1129625	0	0
45701131	1125315	0	0
45784878	1119510	0	0
45783439	1112807	0	0
45696834	1115008	0	0
45789920	40165015	2	3
45803458	1595799	0	0
45788241	1115171	2	3
45893832	1125315	0	0
46306993	1129625	0	0
46320058	738818	0	0
46315344	19019273	2	3
1518198	1518198	0	0
4285898	4285898	0	0
21001665	19007333	2	3
21504609	1332419	3	4
21601605	1361711	3	3
36154728	1119510	0	0
36198927	1515774	0	0
36302170	192671	4	9
42803988	1125315	0	0
44356190	1125315	0	0
44346978	1112807	0	0
45628668	1174888	0	0
45622387	1125315	0	0
45641553	40169281	2	3
44344145	1125315	0	0
45629628	1119510	0	0
45642116	1713332	0	0
45654665	40231925	2	3
45683266	1125315	0	0
45701655	1112807	0	0
45652254	1129625	0	0
45700858	1125315	0	0
45784743	1119510	0	0
45783300	1112807	0	0
45696783	1332418	0	0
45789923	1127433	2	3
45803458	1308738	0	0
45788273	1115171	2	3
45801529	1125315	0	0
46299908	1129625	0	0
46314075	738818	0	0
46315331	1115171	2	3
1539403	1539403	0	0
4240902	4240902	0	0
21003387	46275916	2	3
35100000	439777	3	4
21600002	975125	3	3
36154731	1119510	0	0
36198927	1549786	0	0
37604043	192671	2	2
42803988	1119510	0	0
44356044	1125315	0	0
44347295	1107830	0	0
45628470	1551099	0	0
45622390	1125315	0	0
45641666	40232448	2	3
44343934	1125315	0	0
45629762	1119510	0	0
45642076	1778162	0	0
45654656	1107882	2	3
45683145	1125315	0	0
45701592	1112807	0	0
45652101	1129625	0	0
45700871	1125315	0	0
45784777	1119510	0	0
45783302	1308738	0	0
45696861	740275	0	0
45789810	40229134	2	3
45803468	1112807	0	0
45788070	40229134	2	3
45801760	1125315	0	0
46299933	1129625	0	0
46315024	738818	0	0
46309704	40174880	2	3
1332418	1332418	0	0
4234705	4234705	0	0
21003387	40232448	2	3
21503969	19133768	3	4
21501050	1125315	3	3
36154735	1119510	0	0
36198936	1129625	0	0
40143224	19127904	2	2
42803988	738818	0	0
44356050	1125315	0	0
44347147	1149196	0	0
45628471	975125	0	0
45622396	1125315	0	0
45641782	19019273	2	3
44344428	1125315	0	0
45629741	1119510	0	0
45642072	1174888	0	0
45654672	19008572	2	3
45683547	1125315	0	0
45698234	1112807	0	0
45697738	1129625	0	0
45700872	1125315	0	0
45784855	1119510	0	0
45783305	1000560	0	0
45696864	1192710	0	0
45789814	40162522	2	3
45803523	1149380	0	0
45788324	19019273	2	3
45801546	1125315	0	0
46299875	1129625	0	0
46308793	738818	0	0
46309527	40163554	2	3
1150837	1150837	0	0
21001770	975125	0	0
21000227	46233988	2	3
21503969	40231925	3	4
21604253	1102527	3	3
36154745	1119510	0	0
36198857	1129625	0	0
40143224	19127918	2	2
42803989	1713332	0	0
44356009	1125315	0	0
44347299	1551099	0	0
45628316	1154343	0	0
45622406	1125315	0	0
45641725	40232448	2	3
44337335	1125315	0	0
45629857	1119510	0	0
45642074	1326303	0	0
45654552	1115171	2	3
45683405	1125315	0	0
45698566	1112807	0	0
45697851	1129625	0	0
45700873	1125315	0	0
45784867	1119510	0	0
45783212	1115008	0	0
45696866	791967	0	0
45789992	40229134	2	3
45803527	1310149	0	0
45788254	19073183	2	3
45801547	1125315	0	0
46299687	1129625	0	0
46308948	738818	0	0
46309738	19019273	2	3
1149380	1149380	0	0
21001770	1107830	0	0
21000227	46233710	2	3
21503969	40162522	3	4
21604253	1124957	3	3
36154746	1119510	0	0
36198941	738818	0	0
40143224	40221415	2	2
42803989	1759842	0	0
44356021	1125315	0	0
44347247	1124300	0	0
45628468	1332418	0	0
45622415	1125315	0	0
45638309	40232448	2	3
44337293	1125315	0	0
45629712	1119510	0	0
45642027	1539403	0	0
45655435	40232448	2	3
45683253	1125315	0	0
45698709	1112807	0	0
45700721	1129625	0	0
45700783	1125315	0	0
45784871	1119510	0	0
45780485	933724	0	0
45696867	723013	0	0
45789995	1551192	2	3
45803462	1107830	0	0
46293988	40163554	2	3
45801835	1125315	0	0
46300044	1129625	0	0
46308896	738818	0	0
46309912	40232448	2	3
1149196	1149196	0	0
21001750	1729720	0	0
21003377	19112599	2	3
21504600	19059056	3	4
21501034	914335	3	3
36154748	1119510	0	0
36198943	19127890	0	0
40143224	19128022	2	2
42804015	920293	0	0
44356129	1125315	0	0
44347249	1129625	0	0
45628516	975125	0	0
45622416	1125315	0	0
45638248	19008572	2	3
44337314	1125315	0	0
45626702	1119510	0	0
45642029	1713332	0	0
45655567	40228214	2	3
45685232	1125315	0	0
45695312	1112807	0	0
45700710	1129625	0	0
45700784	1125315	0	0
45785016	1119510	0	0
45780571	1112807	0	0
45802672	967823	0	0
45790118	42707627	2	3
45803507	1115008	0	0
46293933	1115171	2	3
45801891	1125315	0	0
46300195	1129625	0	0
46309307	738818	0	0
46309938	46233710	2	3
1137529	1137529	0	0
21001750	1717327	0	0
21003377	43012036	2	3
21503884	19078924	3	4
21500897	975125	3	3
36154751	1119510	0	0
36198943	1589505	0	0
40143224	19128263	2	2
42803920	1361711	0	0
44356143	1125315	0	0
44347441	1729720	0	0
45628629	967823	0	0
45622546	1125315	0	0
45640184	40223768	2	3
44337421	1125315	0	0
45626699	1119510	0	0
45642157	1501700	0	0
45654870	43012036	2	3
45685243	1125315	0	0
45695278	1112807	0	0
45700715	1129625	0	0
45700828	1125315	0	0
45785024	1119510	0	0
45780429	1000560	0	0
45802697	1124300	0	0
45790188	40229134	2	3
45803509	1124957	0	0
46293662	1551192	2	3
45801724	1125315	0	0
46300404	1129625	0	0
46307005	738818	0	0
46310159	40231925	2	3
1153428	1153428	0	0
21001758	1729720	0	0
21001119	40236446	2	3
21505694	19123231	3	4
21500897	1343916	3	3
36154564	1119510	0	0
36198943	1549786	0	0
40143224	19128065	2	2
42803671	1000560	0	0
44356160	1125315	0	0
44347448	1149196	0	0
45628472	1115008	0	0
45622723	1125315	0	0
45640244	35605482	2	3
44337784	1125315	0	0
45628024	1119510	0	0
45641926	1728416	0	0
45654815	19079524	2	3
45685519	1125315	0	0
45695501	1112807	0	0
45648781	1129625	0	0
45700834	1125315	0	0
45785125	1119510	0	0
45780494	1322184	0	0
45802664	1000560	0	0
45787360	40169281	2	3
45803537	1308738	0	0
46293780	1115171	2	3
45801808	1125315	0	0
46296124	1129625	0	0
46320362	738818	0	0
46310117	40236824	2	3
1150770	1150770	0	0
21001745	1717327	0	0
21009234	46275444	2	3
21505694	40236446	3	4
21500897	1738521	3	3
36154812	1119510	0	0
36198946	1192710	0	0
37203772	28060	2	2
42804005	1125315	0	0
44356162	1125315	0	0
44347057	1112807	0	0
45628477	1307863	0	0
45622726	1125315	0	0
45640073	1115171	2	3
44338021	1125315	0	0
45628210	1119510	0	0
45641939	1310149	0	0
45654824	19008572	2	3
45685567	1125315	0	0
45695326	1112807	0	0
45648929	1129625	0	0
45697940	1125315	0	0
45785127	1119510	0	0
45780496	1149196	0	0
45802720	1549786	0	0
45787256	40229134	2	3
45803515	1149196	0	0
46294059	43012036	2	3
45801809	1125315	0	0
46296315	1129625	0	0
46320454	738818	0	0
46304344	19019273	2	3
1150771	1150771	0	0
21001750	1768849	0	0
21002333	19073188	2	3
21500522	19076374	3	4
21500897	1119510	3	3
36152179	1119510	0	0
36198947	1129625	0	0
36718599	4066995	2	2
42804036	1551099	0	0
44352657	1125315	0	0
44347062	1129625	0	0
45628491	738818	0	0
45622667	1125315	0	0
45638461	40236446	2	3
44337614	1125315	0	0
45623749	1119510	0	0
45641755	1192710	0	0
45651176	1115171	2	3
45680082	1125315	0	0
45691997	1112807	0	0
45649083	1129625	0	0
45697921	1125315	0	0
45785160	1119510	0	0
45780652	1112807	0	0
45802720	19127890	0	0
45787416	1115171	2	3
45803493	1149196	0	0
46294474	19133873	2	3
45801875	1125315	0	0
46318402	1129625	0	0
46320366	738818	0	0
46304653	19076374	2	3
1150836	1150836	0	0
21001750	1738521	0	0
21002333	19073183	2	3
21604253	1127078	3	6
21604564	19115351	3	3
36152180	1119510	0	0
36198968	1589505	0	0
40072443	19127922	2	2
42804037	1000560	0	0
44352659	1125315	0	0
44347203	1332418	0	0
45628607	1539403	0	0
45622743	1125315	0	0
45638468	19129655	2	3
44337534	1125315	0	0
45624070	1119510	0	0
45642040	1124957	0	0
45651215	1115171	2	3
45680272	1125315	0	0
45692063	1112807	0	0
45649086	1129625	0	0
45697884	1125315	0	0
45785161	1119510	0	0
45780667	1153428	0	0
45802720	1521369	0	0
45803242	19019273	2	3
45803574	1367571	0	0
46243663	40229134	2	3
45801876	1125315	0	0
46318709	1129625	0	0
46320410	738818	0	0
46304664	40165015	2	3
926487	926487	0	0
21001770	1551099	0	0
21003376	46275916	2	3
21604253	1127433	3	6
21500937	975125	3	3
36152299	1119510	0	0
36198968	1549786	0	0
40072443	19133679	2	2
42804038	1551099	0	0
44352665	1125315	0	0
44347233	1112807	0	0
45628300	1110410	0	0
45622855	1125315	0	0
45638568	1551192	2	3
44337655	1125315	0	0
45624072	1119510	0	0
45642054	1174888	0	0
45651166	40163554	2	3
45680056	1125315	0	0
45692344	1112807	0	0
45649130	1129625	0	0
45697901	1125315	0	0
45784952	1119510	0	0
45780669	1521369	0	0
45802792	1521369	0	0
45785861	19019273	2	3
45803577	975125	0	0
46243860	1127433	2	3
45802418	1125315	0	0
46318617	1129625	0	0
46320434	738818	0	0
46304703	40232448	2	3
926488	19045231	0	0
21001770	1129625	0	0
21003376	40232448	2	3
21604685	40222846	3	6
21500837	1759842	3	3
36152328	1119510	0	0
36199670	1107830	0	0
40072443	19129144	2	2
42804039	1551099	0	0
44353334	1125315	0	0
44346991	1589505	0	0
45628302	1107830	0	0
45622863	1125315	0	0
45638475	40232448	2	3
44337586	1125315	0	0
45624074	1119510	0	0
45638661	1149196	0	0
45651359	1115171	2	3
45680324	1125315	0	0
45694661	1112807	0	0
45645587	1129625	0	0
45698022	1125315	0	0
45784843	1119510	0	0
45780669	1549786	0	0
45802792	1548195	0	0
45787533	1107882	2	3
45803538	791967	0	0
46243809	19008572	2	3
45802521	1125315	0	0
46318725	1129625	0	0
46320671	738818	0	0
46305172	40229134	2	3
933724	933724	0	0
21001770	1153428	0	0
21000219	46233988	2	3
21604685	836659	3	6
21500837	975125	3	3
36152425	1119510	0	0
36151808	705944	0	0
40483287	198199	2	2
42803675	1713332	0	0
44352823	1125315	0	0
44343221	738818	0	0
45628194	1549786	0	0
45622950	1125315	0	0
45638513	19018935	2	3
45622047	1125315	0	0
45623843	1119510	0	0
45638609	1153428	0	0
45651406	1107882	2	3
45680090	1125315	0	0
45694621	1112807	0	0
45645745	1129625	0	0
45698023	1125315	0	0
45785137	1119510	0	0
45780386	1343916	0	0
45802796	1589505	0	0
46292244	46233710	2	3
45803605	1326303	0	0
46244772	40229134	2	3
45802532	1125315	0	0
46319029	1129625	0	0
46320918	738818	0	0
46304840	1115171	2	3
753626	753626	0	0
21001770	1125315	0	0
21000219	46233710	2	3
21604685	40236446	3	6
21500837	1124300	3	3
36152156	1119510	0	0
36151796	19127890	0	0
37521794	4323902	2	2
42803922	1551099	0	0
44352826	1125315	0	0
44343227	1738521	0	0
45628194	19127890	0	0
45622553	1125315	0	0
45638843	19076374	2	3
45622031	1125315	0	0
45623671	1119510	0	0
45638671	1322184	0	0
45651493	19133873	2	3
45680295	1125315	0	0
45689145	1112807	0	0
45642679	1129625	0	0
45697994	1125315	0	0
45785078	1119510	0	0
46244952	1332418	0	0
45802671	1153428	0	0
45894962	19078924	2	3
45803606	1729720	0	0
46244780	40229134	2	3
45802469	1125315	0	0
46319038	1129625	0	0
46315054	738818	0	0
46304968	19008572	2	3
1332419	1332419	0	0
21001770	1150836	0	0
21003153	40229134	2	3
21601744	1332419	3	6
21500837	967823	3	3
36158570	1119510	0	0
36151796	1549786	0	0
37521794	4337611	2	2
42804022	1125315	0	0
44352769	1125315	0	0
44343068	1177480	0	0
45628194	1589505	0	0
45622557	1125315	0	0
45638624	40163554	2	3
45621917	1125315	0	0
45623792	1119510	0	0
45638610	1192710	0	0
45651382	19133905	2	3
45680301	1125315	0	0
45689185	1112807	0	0
45642689	1129625	0	0
45697997	1125315	0	0
45785220	1119510	0	0
46244955	1112807	0	0
45802710	1738521	0	0
45785995	19079524	2	3
45803610	1307863	0	0
46244899	40232448	2	3
45799052	1125315	0	0
46312996	1129625	0	0
46314899	738818	0	0
46304973	19129655	2	3
4168666	4043241	4	4
21001770	1150770	0	0
21000235	46233988	2	3
21601238	1310034	3	6
21500837	1308738	3	3
36158653	1119510	0	0
36151796	1512674	0	0
37521353	4163971	2	2
42804022	1124957	0	0
44353037	1125315	0	0
44343312	791967	0	0
45628639	1539403	0	0
45622867	1125315	0	0
45635392	19073183	2	3
45622214	1125315	0	0
45623800	1119510	0	0
45638726	738818	0	0
45651388	40163554	2	3
45680560	1125315	0	0
45689366	1112807	0	0
45642702	1129625	0	0
45698008	1125315	0	0
45784959	1119510	0	0
46244771	715997	0	0
45802807	715997	0	0
46240791	19078461	2	3
45803615	1192710	0	0
46244882	40232448	2	3
45798986	1125315	0	0
46312710	1129625	0	0
46314821	738818	0	0
46304776	19018935	2	3
4133611	375671	4	4
21001775	1112807	0	0
21000235	46233710	2	3
21601238	19018935	3	6
21500837	19010482	3	3
36158620	1119510	0	0
36151801	1713332	0	0
37203774	40481087	2	2
42803851	1713332	0	0
44353209	1125315	0	0
44343315	1115008	0	0
45628317	1501700	0	0
45622744	1125315	0	0
45635251	40229134	2	3
45622177	1125315	0	0
45624095	1119510	0	0
45638781	791967	0	0
45651414	19008572	2	3
45680379	1125315	0	0
45686256	1112807	0	0
45642709	1129625	0	0
45698123	1125315	0	0
45785090	1119510	0	0
46244854	715997	0	0
45802753	1112807	0	0
45792099	1107882	2	3
45803583	975125	0	0
46244052	1115171	2	3
45799108	1125315	0	0
46312697	1129625	0	0
46314940	738818	0	0
46305115	1115171	2	3
4133611	378001	4	4
21001775	1177480	0	0
21002299	920300	2	3
21603365	19029476	3	6
21500837	914335	3	3
36158602	1119510	0	0
36151803	738818	0	0
36776613	4029498	2	2
42803851	1759842	0	0
44352868	1125315	0	0
44343317	1115008	0	0
45628439	1307863	0	0
45622937	1125315	0	0
45635260	1115171	2	3
44358676	1125315	0	0
45624055	1119510	0	0
45638782	1115008	0	0
45651690	19019273	2	3
45680327	1125315	0	0
45686286	1112807	0	0
45642813	1129625	0	0
45697972	1125315	0	0
45785092	1119510	0	0
46244935	1154343	0	0
45802891	1322184	0	0
45800064	40174880	2	3
45803559	1551099	0	0
46244005	40162522	2	3
45798990	1125315	0	0
46313039	1129625	0	0
46314979	738818	0	0
46305189	43012036	2	3
4115574	198809	4	4
21001775	1115008	0	0
21002299	920334	2	3
21600491	35605482	3	5
21500837	1343916	3	3
36158705	1119510	0	0
36151827	1115008	0	0
40785765	3006734	2	2
42803852	1125315	0	0
44353153	1125315	0	0
44343282	1307863	0	0
45628357	1551099	0	0
45622742	1125315	0	0
45635439	46275916	2	3
45658557	1125315	0	0
45624056	1119510	0	0
45638882	1728416	0	0
45651717	46233710	2	3
45680391	1125315	0	0
45686382	1112807	0	0
45642870	1129625	0	0
45697977	1125315	0	0
45785093	1119510	0	0
46244726	975125	0	0
45802769	975125	0	0
45795071	40223768	2	3
45803566	1521369	0	0
46243993	1115171	2	3
45799221	1125315	0	0
46313058	1129625	0	0
46314910	738818	0	0
46305279	19008572	2	3
4154161	81151	4	4
21001759	1729720	0	0
21500176	40173590	2	3
35400000	372328	3	5
21500837	1738521	3	3
36158708	1119510	0	0
36152003	1768849	0	0
40785766	3023430	2	2
42803855	1759842	0	0
44352878	1125315	0	0
44343426	1539403	0	0
45625268	1332418	0	0
45622974	1125315	0	0
45635408	40232448	2	3
45658396	1125315	0	0
45623998	1119510	0	0
45638885	1589505	0	0
45648185	40231925	2	3
45680404	1125315	0	0
45686399	1112807	0	0
45642878	1129625	0	0
45698171	1125315	0	0
45785099	1119510	0	0
46244683	1149196	0	0
45803035	1521369	0	0
45795397	40228214	2	3
45803647	967823	0	0
46240097	19008572	2	3
45799246	1125315	0	0
46313118	1129625	0	0
46317746	738818	0	0
46304801	1154615	2	3
4177094	42535580	4	4
21001772	738818	0	0
21003375	40232448	2	3
21601239	19018935	2	5
21500943	975125	3	3
36158872	1119510	0	0
36152004	1192710	0	0
40785850	3006906	2	2
42803855	1713332	0	0
44352879	1125315	0	0
44343241	1713332	0	0
45625190	1361711	0	0
45622774	1125315	0	0
45635185	40174880	2	3
45658432	1125315	0	0
45623692	1119510	0	0
45638829	1396131	0	0
45648308	19078461	2	3
45680469	1125315	0	0
45686582	1112807	0	0
45691237	1129625	0	0
45698205	1125315	0	0
45785228	1119510	0	0
46244684	975125	0	0
45803035	1549786	0	0
45789647	19075001	2	3
45803632	1551099	0	0
46238918	1107882	2	3
45799337	1125315	0	0
46313127	1129625	0	0
46317164	738818	0	0
46304686	19019273	2	3
4028876	258780	4	4
21001751	1713332	0	0
21002321	19129655	2	3
21503664	40231925	2	3
21600962	40163554	1	4
36150703	1119510	0	0
36151666	1177480	0	0
40785861	3013721	2	2
42804076	1124300	0	0
44352881	1125315	0	0
44343243	1115008	0	0
45625474	1153428	0	0
45622776	1125315	0	0
45635506	19018935	2	3
45658452	1125315	0	0
45667988	1119510	0	0
45638838	1154029	0	0
45648209	40232448	2	3
45680471	1125315	0	0
45683517	1112807	0	0
45639704	1129625	0	0
45698214	1125315	0	0
45785175	1119510	0	0
46244943	1153428	0	0
45803039	1153428	0	0
45789720	19073183	2	3
45803584	1539403	0	0
46238968	1127433	2	3
45799339	1125315	0	0
46312877	1129625	0	0
46309502	738818	0	0
46321409	43012036	2	3
4042677	4216130	4	4
21001775	1129625	0	0
21002321	19073188	2	3
21502623	1713671	2	3
21604793	836659	1	4
36150708	1119510	0	0
36151666	1129625	0	0
40785869	3014576	2	2
42803926	1759842	0	0
44352894	1125315	0	0
44343172	1545958	0	0
45625260	1343916	0	0
45623166	1125315	0	0
45635508	40228230	2	3
45658585	1125315	0	0
45667991	1119510	0	0
45638943	1149196	0	0
45649231	19059056	2	3
45680475	1125315	0	0
45683405	1112807	0	0
45685826	1129625	0	0
45698215	1125315	0	0
45786482	1119510	0	0
45777781	1713332	0	0
45802744	1192710	0	0
46296356	19073183	2	3
45803699	1000560	0	0
46238965	40232448	2	3
45799173	1125315	0	0
46307761	1129625	0	0
46309910	738818	0	0
46320884	1154615	2	3
4043670	4323208	4	4
21001752	1125315	0	0
21002321	19073183	2	3
21504555	44816277	2	3
21600985	19075601	1	4
36150740	1119510	0	0
36151669	1738521	0	0
37602361	192671	2	3
42803681	1326303	0	0
44352720	1125315	0	0
44342974	1174888	0	0
45625370	1521369	0	0
45621237	1125315	0	0
45635314	19059056	2	3
45658698	1125315	0	0
45667780	1119510	0	0
45639028	1124957	0	0
45649241	1107882	2	3
45680258	1125315	0	0
45683244	1112807	0	0
45636740	1129625	0	0
45648770	1125315	0	0
45786243	1119510	0	0
45777781	1759842	0	0
45802773	738818	0	0
45797517	19073183	2	3
45800750	19127890	0	0
46238980	1115171	2	3
45799353	1125315	0	0
46307740	1129625	0	0
46309572	738818	0	0
46321637	19059056	2	3
4027384	198199	4	4
21001752	1119510	0	0
21000217	46233988	2	3
21500512	40236824	2	3
21500893	975125	1	1
36150855	1119510	0	0
36151714	1153428	0	0
37203764	317009	2	3
42803926	1713332	0	0
44352907	1125315	0	0
44342996	723013	0	0
45625370	1595799	0	0
45621112	1125315	0	0
45635599	1115171	2	3
45658699	1125315	0	0
45670049	1119510	0	0
45639036	1738521	0	0
45648325	19018935	2	3
45680497	1125315	0	0
45680051	1112807	0	0
45636835	1129625	0	0
45694826	1125315	0	0
45786250	1119510	0	0
45777784	1000560	0	0
45802776	1501700	0	0
45792111	19079524	2	3
45800750	1589505	0	0
46238981	43012036	2	3
45799354	1125315	0	0
46307504	1129625	0	0
46304428	738818	0	0
46321206	46275444	2	3
4042673	40492359	4	4
21001773	1192710	0	0
21000217	46233710	2	3
21005679	19073183	2	3
21500928	975125	1	1
36150834	1119510	0	0
36151722	1177480	0	0
37203772	40481087	2	3
42803684	1713332	0	0
44353181	1125315	0	0
44343377	1759842	0	0
45625370	1549786	0	0
45621129	1125315	0	0
45635324	40174880	2	3
45658700	1125315	0	0
45670079	1119510	0	0
45638898	1192710	0	0
45648455	1127433	2	3
45680612	1125315	0	0
45680173	1112807	0	0
45636991	1129625	0	0
45694552	1125315	0	0
45782873	1119510	0	0
45777732	1305058	0	0
45802783	975125	0	0
45785504	1107882	2	3
45800893	1192710	0	0
46239068	19019273	2	3
45799355	1125315	0	0
46307620	1129625	0	0
46304430	738818	0	0
46321589	40232448	2	3
4115259	260139	4	4
21001752	1192710	0	0
21011482	1551192	2	3
21500438	40243436	2	3
21500931	975125	1	1
36150663	1119510	0	0
36151828	1129625	0	0
37203774	4112343	2	3
42803856	1000560	0	0
44353126	1125315	0	0
44343377	1713332	0	0
45625171	1154343	0	0
45621288	1125315	0	0
45632321	40236824	2	3
45658796	1125315	0	0
45670312	1119510	0	0
45638971	1738521	0	0
45648379	19059056	2	3
45680625	1125315	0	0
45680379	1112807	0	0
45682789	1129625	0	0
45694553	1125315	0	0
45782822	1119510	0	0
45777665	1332418	0	0
45802787	1112807	0	0
45894991	1107882	2	3
45800833	1112807	0	0
46238998	19008572	2	3
45799350	1125315	0	0
46307917	1129625	0	0
46304633	738818	0	0
46321645	19059056	2	3
4091213	195588	4	4
21001773	1150836	0	0
21012460	40222846	2	3
21505616	46275916	2	3
21500919	1738521	1	1
36156431	1119510	0	0
36151830	1501700	0	0
40484533	439777	2	3
42803971	1545958	0	0
44353190	1125315	0	0
44343359	1174888	0	0
45625299	1308738	0	0
45622017	1125315	0	0
45632295	19074843	2	3
45659004	1125315	0	0
45670090	1119510	0	0
45638777	1307863	0	0
45648318	19008572	2	3
45680513	1125315	0	0
45680513	1112807	0	0
45682806	1129625	0	0
45694812	1125315	0	0
45782826	1119510	0	0
45777733	1332418	0	0
45802860	1000560	0	0
45795153	19075001	2	3
45800836	1589505	0	0
46239002	920300	2	3
45799126	1125315	0	0
46308365	1129625	0	0
46304672	738818	0	0
46315335	35605482	2	3
4044022	4301346	4	4
21001752	738818	0	0
21001425	19059056	2	3
21002124	46275444	2	3
21500891	975125	1	1
36155451	1119510	0	0
36151955	1177480	0	0
37019275	4116491	2	3
42803974	1713332	0	0
44353228	1125315	0	0
44343100	1729720	0	0
45625445	1729720	0	0
45621831	1125315	0	0
45632522	19078924	2	3
45658469	1125315	0	0
45668071	1119510	0	0
45639059	1759842	0	0
45648510	40232448	2	3
45680344	1125315	0	0
45680648	1112807	0	0
45682988	1129625	0	0
45694787	1125315	0	0
45783017	1119510	0	0
45777670	1545958	0	0
45802861	738818	0	0
45789090	1107882	2	3
45800960	1174888	0	0
46239101	19008572	2	3
45799213	1125315	0	0
46308397	1129625	0	0
46305172	738818	0	0
46315470	19018935	2	3
4103320	28060	4	4
21001752	1129625	0	0
21003205	43012036	2	3
21602884	19075001	2	3
21500856	914335	1	1
36155565	1119510	0	0
36151960	1112807	0	0
37302323	133834	2	9
42803684	1759842	0	0
44348757	1125315	0	0
44343071	1129625	0	0
45625406	791967	0	0
45621782	1125315	0	0
45632355	40229134	2	3
45658656	1125315	0	0
45668117	1119510	0	0
45639059	1713332	0	0
45648630	40229134	2	3
45680373	1125315	0	0
45677128	1112807	0	0
45682829	1129625	0	0
45695104	1125315	0	0
45783022	1119510	0	0
45777670	1332418	0	0
45802730	738818	0	0
45798005	1107882	2	3
45800854	1501700	0	0
46239220	1115171	2	3
45799220	1125315	0	0
46308380	1129625	0	0
46304936	738818	0	0
46315968	40229134	2	3
4103320	257012	4	4
21001762	1551099	0	0
21002690	19008572	2	3
21011856	1713671	2	3
21500951	1124300	1	1
36155438	1119510	0	0
36151966	1112807	0	0
37203764	4280726	2	8
42804080	1778162	0	0
44348782	1125315	0	0
44343072	1112807	0	0
45625378	738818	0	0
45622001	1125315	0	0
45632571	19075601	2	3
45658838	1125315	0	0
45668118	1119510	0	0
45639037	791967	0	0
45648575	40228214	2	3
45680644	1125315	0	0
45677129	1112807	0	0
45682832	1129625	0	0
45694822	1125315	0	0
45783033	1119510	0	0
45777734	1545958	0	0
45802869	791967	0	0
45789666	1107882	2	3
45800674	1149196	0	0
45894575	19078461	2	3
45799400	1125315	0	0
46302850	1129625	0	0
46321331	738818	0	0
46315547	1115171	2	3
4115390	317576	4	4
21001770	1119510	0	0
21001191	1551192	2	3
21500285	19112599	2	3
21500953	1129625	1	1
36155439	1119510	0	0
36151884	1738521	0	0
37203764	261325	2	8
42804084	1125315	0	0
44348904	1125315	0	0
44343265	1154343	0	0
45625483	1149196	0	0
45621315	1125315	0	0
45632627	19008572	2	3
45658843	1125315	0	0
45668145	1119510	0	0
45639142	1539403	0	0
45645048	40228214	2	3
45680689	1125315	0	0
45677008	1112807	0	0
45633686	1129625	0	0
45694915	1125315	0	0
45783154	1119510	0	0
45777688	1549786	0	0
45802908	1154343	0	0
45894495	1107882	2	3
45800919	1746114	0	0
45894661	1127433	2	3
45793996	1125315	0	0
46302693	1129625	0	0
46321595	738818	0	0
46315566	1127433	2	3
4086181	380378	4	4
21001445	1361711	0	0
21001379	19075001	2	3
21500285	43012036	2	3
21500995	1396131	1	1
36155440	1119510	0	0
36151786	1177480	0	0
37203764	257012	2	7
42804049	1125315	0	0
44348968	1125315	0	0
44343272	1129625	0	0
45625340	1192710	0	0
45621318	1125315	0	0
45632518	19059056	2	3
45658479	1125315	0	0
45668211	1119510	0	0
45639084	1501700	0	0
45645269	19126352	2	3
45680690	1125315	0	0
45679674	1112807	0	0
45633761	1129625	0	0
45694921	1125315	0	0
45782999	1119510	0	0
45777688	1521369	0	0
45802918	1174888	0	0
45797674	1107882	2	3
45800919	1741122	0	0
45894438	40162522	2	3
45793771	1125315	0	0
46302759	1129625	0	0
46315373	738818	0	0
46315754	19018935	2	3
4168644	4219399	4	4
21001447	1361711	0	0
21000228	46233710	2	3
21505695	19123231	2	3
21501009	967823	1	1
36155400	1119510	0	0
36151788	1129625	0	0
37602356	317576	2	6
42804049	1174888	0	0
44348974	1125315	0	0
44343157	1551099	0	0
45625492	920293	0	0
45621447	1125315	0	0
45632365	40232448	2	3
45658610	1125315	0	0
45668143	1119510	0	0
45638997	740275	0	0
45645280	40232448	2	3
45680694	1125315	0	0
45679431	1112807	0	0
45633733	1129625	0	0
45695066	1125315	0	0
45783130	1119510	0	0
45777696	1174888	0	0
45802922	1332418	0	0
45785796	40228214	2	3
45800921	1738521	0	0
45893691	19078461	2	3
45794130	1125315	0	0
46302946	1129625	0	0
46315968	738818	0	0
46315875	19019273	2	3
4168644	4240902	4	4
21001447	1112807	0	0
21000228	46233988	2	3
21005672	40163554	2	3
21501052	1125315	1	1
36155415	1119510	0	0
36151929	1192710	0	0
37602356	4329847	2	6
42804051	1551099	0	0
44349060	1125315	0	0
44343391	19127890	0	0
45625288	1154029	0	0
45664835	1125315	0	0
45632474	19077572	2	3
45658792	1125315	0	0
45668339	1119510	0	0
45638998	1149196	0	0
45645440	19078924	2	3
45676886	1125315	0	0
45677170	1112807	0	0
45630896	1129625	0	0
45697585	1125315	0	0
45783131	1119510	0	0
45777696	1192710	0	0
45802877	1500211	0	0
46292356	1107882	2	3
45800952	1332418	0	0
45801383	1115171	2	3
45793882	1125315	0	0
46302977	1129625	0	0
46311900	738818	0	0
46310132	19008572	2	3
4168644	433644	4	4
21001435	1361711	0	0
21000244	19133873	2	3
21005673	40163554	2	3
21500940	975125	1	1
36155443	1119510	0	0
36151616	1107830	0	0
37602360	381316	2	5
42804052	1551099	0	0
44349019	1125315	0	0
44343391	1549786	0	0
45625290	1192710	0	0
45664972	1125315	0	0
45632489	19023398	2	3
45658753	1125315	0	0
45665962	1119510	0	0
45638816	1717327	0	0
45645485	40228230	2	3
45677014	1125315	0	0
45677401	1112807	0	0
45630856	1129625	0	0
45645903	1125315	0	0
45783196	1119510	0	0
45777698	757627	0	0
45803046	975125	0	0
45797618	1107882	2	3
45800664	1738521	0	0
45801409	40232448	2	3
45793709	1125315	0	0
46302979	1129625	0	0
46311849	738818	0	0
46309613	19008572	2	3
4168644	37017711	4	4
21001447	1367571	0	0
21000244	19073188	2	3
21505633	19059056	2	3
21500962	1124300	1	1
36155353	1119510	0	0
36151885	1177480	0	0
37019275	195588	2	5
42804058	1729720	0	0
44349082	1125315	0	0
44343394	1153428	0	0
45625293	1174888	0	0
45664906	1125315	0	0
45629291	40223834	2	3
45658770	1125315	0	0
45666059	1119510	0	0
45638825	723013	0	0
45645554	1551192	2	3
45676699	1125315	0	0
45677269	1112807	0	0
45630826	1129625	0	0
45691604	1125315	0	0
45783111	1119510	0	0
45777769	1307863	0	0
45803049	1551099	0	0
45787257	1107882	2	3
45800787	975125	0	0
45801482	40232448	2	3
45794081	1125315	0	0
46303186	1129625	0	0
46310653	738818	0	0
46310234	19019273	2	3
4091363	28060	4	4
21000538	1551099	0	0
21000242	46233988	2	3
21013864	19059056	2	3
21502659	1129625	1	1
36155356	1119510	0	0
36151974	1129625	0	0
37604009	317576	2	5
42803995	975125	0	0
44349085	1125315	0	0
44343370	1149196	0	0
45625272	1174888	0	0
45664927	1125315	0	0
45629377	1115171	2	3
45658774	1125315	0	0
45665665	1119510	0	0
45638863	708298	0	0
45645940	19008572	2	3
45677128	1125315	0	0
45674250	1112807	0	0
45630907	1129625	0	0
45691897	1125315	0	0
45783314	1119510	0	0
45777770	1112807	0	0
45803051	1154343	0	0
45792513	1107882	2	3
45801015	1713332	0	0
45801754	19133905	2	3
45794091	1125315	0	0
46303294	1129625	0	0
46310656	738818	0	0
46311849	40229134	2	3
4091532	440448	4	4
21000539	1548195	0	0
21002691	19008572	2	3
21013911	19076374	2	3
21502659	1115008	1	1
36155369	1119510	0	0
36151985	1309944	0	0
37203772	4112343	2	4
42803999	1539403	0	0
44349041	1125315	0	0
44343490	1177480	0	0
45625382	1154029	0	0
45664934	1125315	0	0
45629442	19018935	2	3
45658671	1125315	0	0
45666049	1119510	0	0
45635670	1115008	0	0
45642530	19073188	2	3
45676862	1125315	0	0
45674376	1112807	0	0
45630999	1129625	0	0
45691529	1125315	0	0
45783315	1119510	0	0
45778232	1192710	0	0
45803052	738818	0	0
45789665	1107882	2	3
45801016	1115008	0	0
45801589	1551192	2	3
45793926	1125315	0	0
46303457	1129625	0	0
46310770	738818	0	0
46310321	40163554	2	3
4168335	4230399	4	4
21000537	1549786	0	0
21001385	19133873	2	3
21013911	19078924	2	3
21502659	1308738	1	1
36155389	1119510	0	0
36152110	1717327	0	0
37203772	4294548	2	4
42804001	1124300	0	0
44349122	1125315	0	0
44343330	1322184	0	0
45625409	1000560	0	0
45664883	1125315	0	0
45629169	19133768	2	3
45658945	1125315	0	0
45665887	1119510	0	0
45635421	723013	0	0
45642448	19073183	2	3
45677133	1125315	0	0
45674032	1112807	0	0
45631000	1129625	0	0
45691530	1125315	0	0
45783141	1119510	0	0
45778234	1112807	0	0
45803053	914335	0	0
46238436	40173590	2	3
45801176	1746114	0	0
45801612	1154615	2	3
45794199	1125315	0	0
46300450	1129625	0	0
46304885	738818	0	0
46310443	19078461	2	3
4168335	4156265	4	4
21000534	1500211	0	0
21001834	19074841	2	3
21500371	40169216	2	3
21502621	1717327	1	1
36155483	1119510	0	0
36151936	1551099	0	0
37019275	198199	2	4
42804023	1177480	0	0
44348797	1125315	0	0
44343534	1124957	0	0
45625388	1154029	0	0
45665097	1125315	0	0
45629169	40162522	2	3
45658499	1125315	0	0
45666221	1119510	0	0
45635623	1713332	0	0
45642627	40162522	2	3
45679502	1125315	0	0
45671009	1112807	0	0
45676304	1129625	0	0
45691666	1125315	0	0
45783081	1119510	0	0
45778058	1738521	0	0
45802762	1112807	0	0
45800400	1107882	2	3
45801176	1741122	0	0
45801566	40229134	2	3
45794247	1125315	0	0
46300566	1129625	0	0
46305082	738818	0	0
46310326	43012036	2	3
4090614	4048171	4	4
21000544	1305058	0	0
21000223	46233988	2	3
21002122	46275444	2	3
21502621	1713332	1	1
36155491	1119510	0	0
36152085	738818	0	0
37503995	4336464	1	5
42804024	1551099	0	0
44349106	1125315	0	0
44343411	1129625	0	0
45625538	1539403	0	0
45665187	1125315	0	0
45629387	19008572	2	3
45658947	1125315	0	0
45666175	1119510	0	0
45635623	1759842	0	0
45642602	19076374	2	3
45679472	1125315	0	0
45671385	1112807	0	0
45628233	1129625	0	0
45691682	1125315	0	0
45782946	1119510	0	0
45778069	1174888	0	0
45802989	1174888	0	0
46292423	19078461	2	3
45800782	975125	0	0
45801442	920334	2	3
45794251	1125315	0	0
46301117	1129625	0	0
46305571	738818	0	0
46310328	1115171	2	3
4028387	134438	4	4
21000538	1548195	0	0
21000223	46233710	2	3
21005680	19073188	2	3
21502621	1746114	1	1
36155507	1119510	0	0
36152112	1177480	0	0
37203772	257012	1	2
42804072	1713332	0	0
44351751	1125315	0	0
44343342	791967	0	0
45625719	1539403	0	0
45665020	1125315	0	0
45629179	40232448	2	3
45658954	1125315	0	0
45663761	1119510	0	0
45635627	1192710	0	0
45642585	40232448	2	3
45677185	1125315	0	0
45671389	1112807	0	0
45628288	1129625	0	0
45691920	1125315	0	0
45783143	1119510	0	0
45778121	967823	0	0
45802977	1305058	0	0
46292098	1332419	2	3
45800968	1192710	0	0
45801699	19018935	2	3
45794121	1125315	0	0
46319483	1129625	0	0
46305574	738818	0	0
46310447	46275444	2	3
4042835	4280726	4	4
21000548	1305058	0	0
21000213	46233988	2	3
21005680	19073183	2	3
21502621	1741122	1	1
36155581	1119510	0	0
36152087	753626	0	0
40244879	1125315	0	0
42804073	1713332	0	0
44351755	1125315	0	0
44343435	740275	0	0
45625816	1521369	0	0
45665025	1125315	0	0
45629567	40232448	2	3
45658959	1125315	0	0
45663772	1119510	0	0
45635577	1124300	0	0
45642580	40228230	2	3
45677144	1125315	0	0
45669459	1112807	0	0
45627864	1129625	0	0
45691965	1125315	0	0
45783205	1119510	0	0
45778122	975125	0	0
45802979	1174888	0	0
45800530	1332419	2	3
45801070	1728416	0	0
45801704	1115171	2	3
45794125	1125315	0	0
46319580	1129625	0	0
46305332	738818	0	0
46310512	1551192	2	3
4042835	40486433	4	4
21000565	1305058	0	0
21000213	46233710	2	3
21009232	46233988	2	3
21500479	975125	1	1
36155462	1119510	0	0
36151674	1115008	0	0
40244879	1174888	0	0
42804075	1361711	0	0
44349157	1125315	0	0
44343476	1177480	0	0
45625816	19127890	0	0
45665108	1125315	0	0
45629572	1115171	2	3
45659108	1125315	0	0
45663710	1119510	0	0
45635582	1192710	0	0
45642491	40163554	2	3
45677235	1125315	0	0
45669924	1112807	0	0
45627955	1129625	0	0
45691967	1125315	0	0
45783207	1119510	0	0
45778040	1332418	0	0
45802817	1713332	0	0
45802823	40173590	2	3
45800765	791967	0	0
45801710	40223768	2	3
45794198	1125315	0	0
46319624	1129625	0	0
46321817	738818	0	0
46310656	40229134	2	3
4028908	40478878	4	4
21000594	1539403	0	0
21000243	46233988	2	3
21010168	19007333	2	3
21500522	791967	1	1
36155749	1119510	0	0
36151951	1000560	0	0
40244689	1177480	0	0
42804026	1539403	0	0
44349161	1125315	0	0
44343492	1129625	0	0
45625816	1503184	0	0
45665229	1125315	0	0
45629366	35605482	2	3
45659035	1125315	0	0
45663323	1119510	0	0
45635487	1310149	0	0
45642529	19078461	2	3
45677188	1125315	0	0
45781369	1112807	0	0
45628043	1129625	0	0
45691969	1125315	0	0
45783333	1119510	0	0
45778079	975125	0	0
45802881	1115008	0	0
45800081	19075601	2	3
45800969	1557272	0	0
45795901	40229134	2	3
45794055	1125315	0	0
46319008	1129625	0	0
46321718	738818	0	0
46310665	40228214	2	3
4029205	4181917	4	4
21000571	975125	0	0
21000243	46233710	2	3
21013948	46233710	2	3
21602471	42902245	5	5
36158162	1125315	0	0
36151716	1118084	0	0
40244687	1112807	0	0
42804027	1124300	0	0
44349303	1125315	0	0
44343498	1149196	0	0
45625817	1717327	0	0
45665135	1125315	0	0
45629375	1127433	2	3
45658867	1125315	0	0
45663418	1119510	0	0
45635489	1332418	0	0
45642559	40229134	2	3
45677194	1125315	0	0
45781315	1112807	0	0
45676181	1129625	0	0
45692114	1125315	0	0
45780535	1119510	0	0
45777977	920293	0	0
45802996	1115008	0	0
45802247	19078461	2	3
45800980	975125	0	0
45796012	40163554	2	3
45794266	1125315	0	0
46239821	1129625	0	0
46316605	738818	0	0
46304879	1127433	2	3
4029205	4133840	4	4
21000583	1501700	0	0
21001654	19075601	2	3
21009299	46233710	2	3
21602471	19127922	5	5
36157779	1125315	0	0
36151767	740275	0	0
40244744	1177480	0	0
42805238	1119510	0	0
44349184	1125315	0	0
44343422	738818	0	0
45625570	1308738	0	0
45664954	1125315	0	0
45631323	19008572	2	3
45658826	1125315	0	0
45663441	1119510	0	0
45635494	1110410	0	0
45642629	19008572	2	3
45677304	1125315	0	0
45781444	1112807	0	0
45676163	1129625	0	0
45691753	1125315	0	0
45780654	1119510	0	0
45778145	1112807	0	0
45802999	753626	0	0
45800600	1332419	2	3
45801095	1124300	0	0
45796250	40229134	2	3
45789343	1125315	0	0
46239938	1129625	0	0
46316693	738818	0	0
46305073	19019273	2	3
4029205	4218408	4	4
21000571	1551099	0	0
21013408	1551192	2	3
21009299	46233988	2	3
21602471	19128065	5	5
36157782	1125315	0	0
36151770	1129625	0	0
40244745	1361711	0	0
42805392	1557272	0	0
44349416	1125315	0	0
44343425	1112807	0	0
45625636	1305058	0	0
45665197	1125315	0	0
45631233	19008572	2	3
44351940	1125315	0	0
45663449	1119510	0	0
45635585	1589505	0	0
45642800	19078461	2	3
45677190	1125315	0	0
45781449	1112807	0	0
45676195	1129625	0	0
45691763	1125315	0	0
45780668	1119510	0	0
45778209	1738521	0	0
45803131	1501700	0	0
45803210	1332419	2	3
45801097	1332418	0	0
45796238	44816277	2	3
45789378	1125315	0	0
46321748	1129625	0	0
46316191	738818	0	0
46305126	40232448	2	3
4029205	4151422	4	4
21000591	975125	0	0
21000199	46233988	2	3
21002247	1551192	2	3
21602471	19128022	5	5
36158080	1125315	0	0
36151774	1149380	0	0
40244727	1307863	0	0
42805404	1713332	0	0
44345204	1125315	0	0
44343506	1129625	0	0
45625277	1192710	0	0
45665198	1125315	0	0
45630935	19057271	2	3
45652425	1125315	0	0
45660371	1119510	0	0
45635694	1713332	0	0
45639416	19059056	2	3
45677221	1125315	0	0
45779010	1112807	0	0
45676280	1129625	0	0
45691959	1125315	0	0
46244949	1119510	0	0
45778210	914335	0	0
45800132	1174888	0	0
46288127	1332419	2	3
45800945	1713332	0	0
45796375	19008572	2	3
45789358	1125315	0	0
46321761	1129625	0	0
46310690	738818	0	0
46305089	19019273	2	3
4029205	4246502	4	4
21000591	1551099	0	0
21000199	46233710	2	3
21005418	19008572	2	3
21602471	19127918	5	5
36158082	1125315	0	0
36152010	1545958	0	0
40244733	1177480	0	0
42805379	975125	0	0
44345229	1125315	0	0
44343607	1778162	0	0
45625551	1115008	0	0
45665139	1125315	0	0
45626507	19019273	2	3
45652320	1125315	0	0
45660325	1119510	0	0
45635694	1759842	0	0
45639489	40228214	2	3
45674057	1125315	0	0
45778664	1112807	0	0
45624918	1129625	0	0
45692023	1125315	0	0
46244761	1119510	0	0
45778213	1124957	0	0
45800140	1124957	0	0
46238242	19078461	2	3
45801055	975125	0	0
45796197	19059056	2	3
45789348	1125315	0	0
46321928	1129625	0	0
46305843	738818	0	0
46305514	19008572	2	3
1589505	19128009	3	4
19129655	19129655	0	0
21013433	19074843	2	3
21005289	40174880	2	3
21602471	19128009	5	5
36158049	1125315	0	0
36151834	738818	0	0
40244705	1713332	0	0
42805493	1115008	0	0
44345230	1125315	0	0
44343548	1778162	0	0
45625689	708298	0	0
45665142	1125315	0	0
45626605	1127433	2	3
45652321	1125315	0	0
45660392	1119510	0	0
45637026	967823	0	0
45639496	1545959	2	3
45674078	1125315	0	0
45778782	1112807	0	0
45624824	1129625	0	0
45691683	1125315	0	0
45777664	1119510	0	0
45777871	1713332	0	0
45800145	1309944	0	0
45794858	40223768	2	3
45801071	1738521	0	0
45796057	1115171	2	3
45788770	1125315	0	0
46322141	1129625	0	0
46306028	738818	0	0
46305362	45892894	2	3
1589505	19127918	3	4
19112599	19112599	0	0
21013433	19074841	2	3
21002102	19129655	2	3
21602471	19128263	5	5
36158052	1125315	0	0
36151836	1107830	0	0
40244748	1177480	0	0
42805411	1124300	0	0
44345173	1125315	0	0
44343468	1192710	0	0
45625691	1551099	0	0
45665236	1125315	0	0
45626538	19133905	2	3
45652468	1125315	0	0
45660493	1119510	0	0
45637027	1154029	0	0
45639426	1551192	2	3
45673630	1125315	0	0
45778708	1112807	0	0
45624812	1129625	0	0
45691859	1125315	0	0
45777674	1119510	0	0
45777871	1759842	0	0
45799914	1154343	0	0
45789525	1545959	2	3
45801157	1107830	0	0
45796061	19008572	2	3
45788707	1125315	0	0
46321995	1129625	0	0
46305856	738818	0	0
46305363	19133905	2	3
1588689	19127904	3	4
19115351	19115351	0	0
21002692	19008572	2	3
21002102	46233988	2	3
21602471	19133679	5	5
36158195	1125315	0	0
36152227	1107830	0	0
40244749	1125315	0	0
42804098	1177480	0	0
44345319	1125315	0	0
44343512	1310149	0	0
45625693	1501700	0	0
45665240	1125315	0	0
45626503	40228230	2	3
45652477	1125315	0	0
45660359	1119510	0	0
45637032	1107830	0	0
45639430	19059056	2	3
45673743	1125315	0	0
45778786	1112807	0	0
45670319	1129625	0	0
45691852	1125315	0	0
45778232	1119510	0	0
45777841	975125	0	0
45800102	738818	0	0
45894419	40228214	2	3
45801205	1115008	0	0
45796262	1115171	2	3
45788718	1125315	0	0
46322259	1129625	0	0
46322299	738818	0	0
46321817	40229134	2	3
1512674	19127904	3	4
19073188	19073188	0	0
21000220	46233988	2	3
21002102	46233710	2	3
21602471	19129144	5	5
36157989	1125315	0	0
36152250	1713332	0	0
40244750	1192710	0	0
42804110	1545958	0	0
44345417	1125315	0	0
44343515	1192710	0	0
45625295	1309944	0	0
45665212	1125315	0	0
45626582	40232448	2	3
45652480	1125315	0	0
45660422	1119510	0	0
45637034	1174888	0	0
45639401	43012036	2	3
45674226	1125315	0	0
45779067	1112807	0	0
45670614	1129625	0	0
45692046	1125315	0	0
45778126	1119510	0	0
45777848	740275	0	0
45800104	975125	0	0
45799951	1539411	2	3
45801212	1124957	0	0
45796175	40162522	2	3
45788822	1125315	0	0
46322276	1129625	0	0
46322617	738818	0	0
46315738	40232448	2	3
4023577	81151	3	4
19073183	19073183	0	0
21000220	46233710	2	3
21013849	19075601	2	3
35202051	4163874	5	5
36157788	1125315	0	0
36152250	1759842	0	0
40244750	1125315	0	0
42804107	1551099	0	0
44345423	1125315	0	0
44343543	967823	0	0
45625594	1322184	0	0
45665176	1125315	0	0
45623294	40229134	2	3
45652145	1125315	0	0
45660475	1119510	0	0
45636837	738818	0	0
45639612	43012036	2	3
45674228	1125315	0	0
45779068	1112807	0	0
45670636	1129625	0	0
45691805	1125315	0	0
45777886	1119510	0	0
45777813	1545958	0	0
45800112	1343916	0	0
45794491	1539411	2	3
45801073	1367571	0	0
45796180	19059056	2	3
45788767	1125315	0	0
46322283	1129625	0	0
46322626	738818	0	0
46316300	40232448	2	3
3039466	3045716	3	4
19074679	19074679	0	0
21001816	1713671	2	3
21013919	46233710	2	3
35202051	4051466	5	5
36158242	1125315	0	0
36152353	715997	0	0
40244832	1119510	0	0
42801327	1759842	0	0
44345375	1125315	0	0
44343477	1174888	0	0
45625643	19127890	0	0
45665177	1125315	0	0
45623295	40229134	2	3
45652149	1125315	0	0
45660616	1119510	0	0
45637222	1174888	0	0
45639589	40169281	2	3
45673981	1125315	0	0
45779383	1112807	0	0
45669303	1129625	0	0
45691812	1125315	0	0
46242632	1119510	0	0
46244619	1545958	0	0
45800120	738818	0	0
45794547	19075601	2	3
45801074	1310149	0	0
45796308	19008572	2	3
45788827	1125315	0	0
46322287	1129625	0	0
46311423	738818	0	0
46316368	40232448	2	3
3039466	3019550	3	4
19074694	19074679	0	0
21002694	19112599	2	3
21013919	46233988	2	3
35202051	381316	5	5
36158245	1125315	0	0
36152356	1589505	0	0
40244832	1125315	0	0
42801327	1713332	0	0
44345654	1125315	0	0
44343526	1129625	0	0
45625643	1589505	0	0
45662478	1125315	0	0
45623338	1127433	2	3
45652219	1125315	0	0
45660586	1119510	0	0
45637152	1551099	0	0
45639542	46275444	2	3
45674115	1125315	0	0
45779073	1112807	0	0
45669285	1129625	0	0
45688796	1125315	0	0
46242579	1119510	0	0
46244649	1115008	0	0
45800027	705944	0	0
45790207	19075601	2	3
45801158	1501700	0	0
45796457	19126352	2	3
45788925	1125315	0	0
46322062	1129625	0	0
46311435	738818	0	0
46316407	1545959	2	3
3039466	3014576	3	4
19002770	19002770	0	0
21002694	40232448	2	3
21002098	1551192	2	3
35502617	4144583	5	5
36157914	1125315	0	0
36152356	19127890	0	0
40244833	1112807	0	0
42801330	920293	0	0
44345717	1125315	0	0
44343527	738818	0	0
45625643	1549786	0	0
45662493	1125315	0	0
45623324	1115171	2	3
45652123	1125315	0	0
45657482	1119510	0	0
45636934	1361711	0	0
45639759	40232448	2	3
45673756	1125315	0	0
45707614	1112807	0	0
45666786	1129625	0	0
45688825	1125315	0	0
46242656	1119510	0	0
46244628	1310149	0	0
45800266	1192710	0	0
46240722	19078461	2	3
45801164	715997	0	0
45796349	1115171	2	3
45788904	1125315	0	0
46322326	1129625	0	0
46319821	738818	0	0
46316440	19018935	2	3
3039466	3015632	3	4
19003953	19003953	0	0
21002694	43012036	2	3
21002113	1713671	2	3
35200000	317009	5	5
35802131	40486433	5	10
36152356	1549786	0	0
40244834	1549786	0	0
42801337	1107830	0	0
44345284	1125315	0	0
44343528	975125	0	0
45625650	967823	0	0
45662685	1125315	0	0
45623374	40232448	2	3
45652343	1125315	0	0
45658566	1119510	0	0
45636936	1174888	0	0
45639549	19126352	2	3
45673774	1125315	0	0
45707626	1112807	0	0
45666956	1129625	0	0
45688820	1125315	0	0
46240248	1119510	0	0
46244629	975125	0	0
45800271	914335	0	0
45802891	19075601	2	3
45800883	1551099	0	0
45796310	40162522	2	3
45788905	1125315	0	0
46322338	1129625	0	0
46317591	1129625	0	0
46316729	19077572	2	3
1503184	19128065	3	4
4310024	4310024	0	0
21001288	46233988	2	3
21002113	46275444	2	3
21602752	40174880	4	5
35802131	4280726	5	10
36152080	1129625	0	0
40244751	1112807	0	0
40760920	3016723	1	1
44345298	1125315	0	0
44343593	1322184	0	0
45625658	1500211	0	0
45662503	1125315	0	0
45623628	1115171	2	3
45652554	1125315	0	0
45657589	1119510	0	0
45636936	1192710	0	0
45636477	1115171	2	3
45673779	1125315	0	0
45777897	1112807	0	0
45667003	1129625	0	0
45688772	1125315	0	0
46240351	1119510	0	0
46244673	1738521	0	0
45800279	1174888	0	0
45795155	19075601	2	3
45800884	1332418	0	0
45796430	40232448	2	3
45788906	1125315	0	0
46322356	1129625	0	0
46313418	1129625	0	0
46310794	19008572	2	3
4022924	4109685	3	3
4266809	4266809	0	0
21001288	46233710	2	3
21011074	19059056	2	3
35202051	321042	4	5
35809132	4218389	3	4
36152082	1192710	0	0
40244752	1119510	0	0
40771966	3051031	1	1
44345299	1125315	0	0
44339797	1308738	0	0
45625665	1110410	0	0
45662732	1125315	0	0
45623534	19008572	2	3
45652619	1125315	0	0
45657775	1119510	0	0
45635733	1545958	0	0
45636630	1115171	2	3
45674258	1125315	0	0
45707833	1112807	0	0
45780645	1129625	0	0
45688849	1125315	0	0
46240362	1119510	0	0
46244678	715997	0	0
45800282	1539403	0	0
46296228	19075601	2	3
45800887	975125	0	0
45796434	19078924	2	3
45788929	1125315	0	0
46322359	1129625	0	0
46313270	1129625	0	0
46310690	40229134	2	3
4023317	4152936	3	3
21001448	1310149	0	0
21013411	19073183	2	3
21011074	19075601	2	3
21602472	43012433	4	5
35809132	4043241	8	9
36152418	1129625	0	0
40244752	1125315	0	0
40765349	3000963	1	1
44345519	1125315	0	0
44339798	1115008	0	0
45625602	1154343	0	0
45662514	1125315	0	0
45623361	19008572	2	3
45652726	1125315	0	0
45657822	1119510	0	0
45635940	738818	0	0
45636217	40229134	2	3
45674360	1125315	0	0
45707822	1112807	0	0
45778159	1129625	0	0
45688865	1125315	0	0
46242346	1119510	0	0
46242587	1332418	0	0
45800036	1310149	0	0
45803025	19075601	2	3
45801045	1115008	0	0
45790930	1115171	2	3
45788978	1125315	0	0
46316175	1129625	0	0
46313423	1129625	0	0
46310799	40231925	2	3
4003387	4336464	3	3
21001454	1322184	0	0
21013411	19129655	2	3
21005429	40228214	2	3
21604303	40162522	4	5
35809132	4156265	4	6
36152049	1177480	0	0
40244753	1115008	0	0
40763504	3023103	1	1
44345483	1125315	0	0
44339801	1149380	0	0
45625604	1149196	0	0
45662713	1125315	0	0
45623735	40236824	2	3
45652487	1125315	0	0
45657527	1119510	0	0
45635746	1343916	0	0
45636523	40223768	2	3
45674388	1125315	0	0
45705142	1112807	0	0
45778415	1129625	0	0
45688867	1125315	0	0
46240468	1119510	0	0
46242588	1728416	0	0
45800123	708298	0	0
46240937	19078461	2	3
45800986	1149196	0	0
45790931	40174880	2	3
45788868	1125315	0	0
46316300	1129625	0	0
46313482	1129625	0	0
46310732	1115171	2	3
4086921	45766064	3	3
21001448	1539403	0	0
21013411	1713671	2	3
21005429	40223821	2	3
21604303	40231925	4	5
35809132	4283893	4	6
36152094	933724	0	0
40244754	1115008	0	0
40033943	40232448	1	1
44345686	1125315	0	0
44339849	1129625	0	0
45625801	1107830	0	0
45662727	1125315	0	0
45623743	40232448	2	3
45652187	1125315	0	0
45657627	1119510	0	0
45635753	1110410	0	0
45636485	40232448	2	3
45674338	1125315	0	0
45705064	1112807	0	0
45778416	1129625	0	0
45688936	1125315	0	0
45703288	1119510	0	0
46242615	1192710	0	0
45800249	1332418	0	0
45802371	1539411	2	3
45801178	1332418	0	0
45790732	1332419	2	3
45788869	1125315	0	0
46316325	1129625	0	0
46313379	1129625	0	0
46305962	1127433	2	3
4023577	4059173	3	3
21001448	1322184	0	0
21001378	19073183	2	3
21005429	40223834	2	3
21604303	40229134	4	5
35809132	4132546	4	6
36152099	1129625	0	0
40244755	1125315	0	0
40032939	46233988	1	1
44345710	1125315	0	0
44339905	1545958	0	0
45625619	1149196	0	0
45662612	1125315	0	0
45623562	1551192	2	3
45652712	1125315	0	0
45657948	1119510	0	0
45635757	1107830	0	0
45636655	1115171	2	3
45674045	1125315	0	0
45633082	975125	0	0
45778403	1129625	0	0
45688937	1125315	0	0
45703520	1119510	0	0
46242590	1115008	0	0
45800373	1115008	0	0
45897211	19075601	2	3
45801183	1115008	0	0
45790806	19073183	2	3
45788879	1125315	0	0
46310876	1129625	0	0
46313544	1129625	0	0
46305972	19129655	2	3
4024000	4116491	3	3
21001455	1539403	0	0
21000221	46233988	2	3
21005429	40228230	2	3
21604303	19133768	4	5
35809132	4029498	4	4
36152046	1551099	0	0
40244755	1119510	0	0
40032939	46233710	1	1
44345606	1125315	0	0
44339989	1545958	0	0
45625620	701322	0	0
45662433	1125315	0	0
45623645	40231925	2	3
44344272	1125315	0	0
45654048	1119510	0	0
45635745	967823	0	0
45636678	1551192	2	3
45674052	1125315	0	0
45676636	975125	0	0
45778368	1129625	0	0
45689129	1125315	0	0
45703272	1119510	0	0
46242618	1309944	0	0
45800377	1738521	0	0
45789724	19075601	2	3
45801148	1521369	0	0
45790952	1115171	2	3
46296837	1125315	0	0
46311047	1129625	0	0
46314224	1129625	0	0
46305989	40224805	2	3
432795	4329847	3	3
21001455	1112807	0	0
21000221	46233710	2	3
21006489	19059056	2	3
21601854	1545959	2	5
35809132	140673	4	4
36152228	975125	0	0
40244756	1125315	0	0
40227524	40229134	1	1
44345673	1125315	0	0
44339854	1000560	0	0
45625673	1000560	0	0
45662887	1125315	0	0
45667684	1115171	2	3
44344397	1125315	0	0
45654387	1119510	0	0
45635762	1174888	0	0
45636603	1551192	2	3
45674181	1125315	0	0
45676637	975125	0	0
45778362	1129625	0	0
45686068	1125315	0	0
45703276	1119510	0	0
46242591	1551099	0	0
45800081	1322184	0	0
45897363	19078461	2	3
45801148	1548195	0	0
45791003	19126352	2	3
46296854	1125315	0	0
46311487	1129625	0	0
46313766	1129625	0	0
46305856	40229134	2	3
4003389	4275113	3	3
21001459	1307863	0	0
21002238	1551192	2	3
21006489	1539411	2	3
21601854	1539411	2	5
35809132	4112343	5	8
36152129	1115008	0	0
40244756	1119510	0	0
40225999	40228214	1	1
44345548	1125315	0	0
44339906	738818	0	0
45625752	975125	0	0
45662530	1125315	0	0
45667825	40223834	2	3
44344574	1125315	0	0
45654447	1119510	0	0
45636056	1115008	0	0
45636629	1107882	2	3
45674194	1125315	0	0
45676927	975125	0	0
45778422	1129625	0	0
45686044	1125315	0	0
45703491	1119510	0	0
46242619	1332418	0	0
45800381	1729720	0	0
45795151	19079524	2	3
45801152	1115008	0	0
45791917	19078461	2	3
46296760	1125315	0	0
46311507	1129625	0	0
46313983	1129625	0	0
46305857	1551192	2	3
4022923	4035415	3	3
21001448	1112807	0	0
21001626	40163554	2	3
21006489	1545959	2	3
21604303	1127078	2	5
35809132	4294548	5	8
36152138	1729720	0	0
40244839	1149196	0	0
40758307	40758406	1	1
44345551	1125315	0	0
44339931	1521369	0	0
45625753	1107830	0	0
45661222	1125315	0	0
45667941	19008572	2	3
44344528	1125315	0	0
45654064	1119510	0	0
45636057	967823	0	0
45637054	40229134	2	3
45674346	1125315	0	0
45676511	975125	0	0
45778426	1129625	0	0
45685779	1125315	0	0
45703472	1119510	0	0
46242663	1192710	0	0
45800232	1115008	0	0
45789830	19079524	2	3
45801153	1310149	0	0
45791931	19077344	2	3
46296893	1125315	0	0
46311203	1129625	0	0
46313896	1129625	0	0
46322440	19008572	2	3
4023316	78272	3	3
21001459	1332418	0	0
21001626	19075601	2	3
21008820	46233988	2	3
21604303	1127433	2	5
35809132	4001336	5	7
36152237	1177480	0	0
40244845	1551099	0	0
37219801	258780	0	1
44341272	1125315	0	0
44339811	1115008	0	0
45625754	1124957	0	0
45661355	1125315	0	0
45667817	40232448	2	3
44344469	1125315	0	0
45652032	1119510	0	0
45636062	1343916	0	0
45637317	19078461	2	3
45673717	1125315	0	0
45676512	975125	0	0
45778429	1129625	0	0
45686179	1125315	0	0
45700402	1119510	0	0
46242641	1153428	0	0
45800235	738818	0	0
45785615	1539411	2	3
45799698	1713332	0	0
45792042	19129655	2	3
46296704	1125315	0	0
46311238	1129625	0	0
46308410	1129625	0	0
46322081	40174880	2	3
3039466	3024561	3	3
21001459	1545958	0	0
21001626	19059056	2	3
21008820	46233710	2	3
21601745	1332419	2	5
35809132	40481087	5	7
36152056	715997	0	0
40244851	1119510	0	0
37203783	4280726	1	2
44341399	1125315	0	0
44339885	738818	0	0
45625372	1124300	0	0
45661211	1125315	0	0
45665583	40232448	2	3
44344618	1125315	0	0
45650962	1119510	0	0
45635962	705944	0	0
45633287	19078461	2	3
45673724	1125315	0	0
45673586	975125	0	0
45778430	1129625	0	0
45686181	1125315	0	0
45700466	1119510	0	0
46240423	1112807	0	0
45800238	1115008	0	0
45797898	19079524	2	3
45799700	1174888	0	0
45791099	40224805	2	3
46296709	1125315	0	0
46311596	1129625	0	0
46308540	1129625	0	0
46322629	19019273	2	3
3039466	3006906	3	3
21001456	1361711	0	0
21001430	1551192	2	3
21503925	19078461	2	3
21603445	40228214	2	5
35809132	257012	5	7
36152230	1515774	0	0
40244851	738818	0	0
37219945	317009	1	2
44341400	1125315	0	0
44339888	1149380	0	0
45625811	1778162	0	0
45659363	1125315	0	0
45665710	19075601	2	3
44344485	1125315	0	0
45651131	1119510	0	0
45635786	1548195	0	0
45633343	40232448	2	3
45673913	1125315	0	0
45673597	975125	0	0
45778465	1129625	0	0
45686055	1125315	0	0
45700470	1119510	0	0
46240251	1549786	0	0
45800242	1000560	0	0
45794995	40228214	2	3
45799766	791967	0	0
45791104	1551192	2	3
46296499	1125315	0	0
46305840	1129625	0	0
46308724	1129625	0	0
46317289	1115171	2	3
3039466	3020630	3	3
21001455	1545958	0	0
21000222	46233988	2	3
21503925	19019979	2	3
21603041	920300	2	5
35809132	28060	5	6
36152230	1549786	0	0
40244851	1125315	0	0
40760930	3023103	1	2
44341493	1125315	0	0
44339893	920293	0	0
45625865	1110410	0	0
45659340	1125315	0	0
45665520	19008572	2	3
44344225	1125315	0	0
45651102	1119510	0	0
45632666	1149196	0	0
45633246	46275916	2	3
45673927	1125315	0	0
45673854	975125	0	0
45778466	1129625	0	0
45697545	19059056	2	3
45700473	1119510	0	0
46240217	1112807	0	0
45800064	1501700	0	0
45792676	40228214	2	3
45799771	1115008	0	0
45791096	1115171	2	3
46296546	1125315	0	0
46305720	1129625	0	0
46308672	1129625	0	0
46317297	1115171	2	3
3039466	3013721	3	3
21001456	1367571	0	0
21000222	46233710	2	3
21503925	1115171	2	3
21604182	19023423	2	5
35809132	372328	5	5
36152065	1112807	0	0
40244854	1177480	0	0
37203783	40486433	2	2
44344541	1125315	0	0
44339912	1177480	0	0
45625842	1000560	0	0
45659676	1125315	0	0
45665523	1551192	2	3
44344411	1125315	0	0
45651068	1119510	0	0
45632539	742185	0	0
45633360	1545959	2	3
45674293	1125315	0	0
45673884	975125	0	0
45778467	1129625	0	0
45697713	19019273	2	3
45896843	1119510	0	0
46240378	723013	0	0
45800065	1174888	0	0
45787057	40228214	2	3
45799751	1174888	0	0
46294744	46275916	2	3
46296550	1125315	0	0
46322611	1129625	0	0
46308485	1129625	0	0
46311596	40232448	2	3
3039466	3027970	3	3
21001462	1112807	0	0
21013390	1310034	2	3
4174389	4163971	3	3
21602472	1519937	2	5
35809132	380378	5	5
36151888	1177480	0	0
40244868	933724	0	0
37219939	261325	2	2
44344370	1125315	0	0
44340010	1551099	0	0
45625843	1115008	0	0
45659381	1125315	0	0
45665875	19008572	2	3
45646265	1125315	0	0
45651110	1119510	0	0
45632543	1124300	0	0
45633411	1545959	2	3
45674301	1125315	0	0
45673156	975125	0	0
45778366	1129625	0	0
45697654	40229134	2	3
45896882	1119510	0	0
46240339	1539403	0	0
45800067	738818	0	0
46243139	40228214	2	3
45799756	1107830	0	0
46294889	19008572	2	3
46295178	1125315	0	0
46316744	1129625	0	0
46308639	1129625	0	0
46311341	19008572	2	3
3039466	3004501	3	3
21001462	1361711	0	0
21001603	1551192	2	3
4086181	4029498	3	3
35200000	4324181	3	5
35809132	381316	5	5
36152257	19010482	0	0
40244766	1177480	0	0
37219785	260139	2	2
44344375	1125315	0	0
44339993	1112807	0	0
45625399	715997	0	0
45659438	1125315	0	0
45665720	40223768	2	3
45646353	1125315	0	0
45647988	1119510	0	0
45632547	738818	0	0
45630399	19018935	2	3
45674303	1125315	0	0
45670810	975125	0	0
45706967	1129625	0	0
45697659	19129655	2	3
45896889	1119510	0	0
46240350	1149196	0	0
45800193	1118084	0	0
45897423	40228214	2	3
45799741	1539403	0	0
46294639	40169281	2	3
46295184	1125315	0	0
46317660	1129625	0	0
46312205	1129625	0	0
46311408	19019273	2	3
3039466	3006923	3	3
21001460	1361711	0	0
21001823	19074843	2	3
4036803	4037675	3	3
35202051	317576	4	6
35809132	4048171	7	9
36152259	1124300	0	0
40244693	1129625	0	0
37019308	198199	2	2
44344552	1125315	0	0
44339995	1545958	0	0
45622204	1713332	0	0
45659388	1125315	0	0
45665630	46275444	2	3
45646054	1125315	0	0
45647918	1119510	0	0
45632558	1115008	0	0
45630311	19008572	2	3
45674029	1125315	0	0
45669411	975125	0	0
45707000	1129625	0	0
45697328	40232448	2	3
45896863	1119510	0	0
46240219	1107830	0	0
45800198	1112807	0	0
45803314	40228214	2	3
45799803	1107830	0	0
46294808	40229134	2	3
46295127	1125315	0	0
46316903	1129625	0	0
46312287	1129625	0	0
46311784	19133905	2	3
3039466	3035995	3	3
21001463	1332418	0	0
21002658	1551192	2	3
4038678	440448	3	3
35202051	4329847	4	6
35809132	375671	6	8
36152075	1154343	0	0
40244694	1125315	0	0
40789322	3019406	2	2
44344459	1125315	0	0
44340003	1153428	0	0
45622116	1713332	0	0
45659509	1125315	0	0
45665657	40165015	2	3
45645967	1125315	0	0
45647824	1119510	0	0
45632789	738818	0	0
45630442	19073183	2	3
45674032	1125315	0	0
45669640	975125	0	0
45707125	1129625	0	0
45695966	19008572	2	3
45697161	1119510	0	0
46240307	1192710	0	0
45800395	1759842	0	0
45798014	40228214	2	3
45799805	1738521	0	0
46244044	1115171	2	3
46295278	1125315	0	0
46306067	1129625	0	0
46311912	1129625	0	0
46311785	40236824	2	3
1580876	19008572	2	3
21001463	1545958	0	0
21500577	1127433	2	3
4038678	4166224	3	3
21602472	19127904	4	6
35809132	40486433	6	8
36151891	1589505	0	0
40244768	1112807	0	0
40789329	3020655	2	2
44344463	1125315	0	0
44340018	1129625	0	0
45622116	1759842	0	0
45659542	1125315	0	0
45663141	1551192	2	3
45645970	1125315	0	0
45648240	1119510	0	0
45632790	1738521	0	0
45630220	19018935	2	3
45671338	1125315	0	0
45669601	975125	0	0
45707144	1129625	0	0
45696081	19023398	2	3
45697310	1119510	0	0
46240313	1112807	0	0
45800297	1174888	0	0
45894579	1332419	2	3
45798063	1539403	0	0
46244100	40229134	2	3
46296945	1125315	0	0
46306490	1129625	0	0
46311997	1129625	0	0
46311297	1332419	2	3
3039466	3016723	2	3
21001455	1332418	0	0
21500577	1127078	2	3
4100932	4149245	3	3
21601853	1539411	3	6
35809132	4280726	6	8
36151891	19127890	0	0
40244768	1192710	0	0
40789356	3002385	2	2
44341602	1125315	0	0
44340005	1129625	0	0
45622120	1326303	0	0
45659703	1125315	0	0
45663231	40229134	2	3
45646068	1125315	0	0
45648273	1119510	0	0
45632760	1124300	0	0
45630406	40223834	2	3
45671167	1125315	0	0
45783534	975125	0	0
45707048	1129625	0	0
45693072	19075601	2	3
45697116	1119510	0	0
46240320	1112807	0	0
45800298	1192710	0	0
45797895	40228214	2	3
45798114	1124300	0	0
46244111	19077572	2	3
46297072	1125315	0	0
46306497	1129625	0	0
46311999	1129625	0	0
46311519	1115171	2	3
3039466	3013682	2	3
21001472	1332418	0	0
21013409	1551192	2	3
4099350	4056621	3	3
21601853	1545959	3	6
35809132	378001	6	8
36151891	1549786	0	0
40244696	1154343	0	0
40789179	3009542	2	2
44341592	1125315	0	0
44340168	920293	0	0
45622067	1192710	0	0
45659474	1125315	0	0
45663390	40173590	2	3
45646075	1125315	0	0
45648248	1119510	0	0
45632786	1551099	0	0
45631099	19078461	2	3
45671009	1125315	0	0
45781068	975125	0	0
45707325	1129625	0	0
45692632	19008572	2	3
45697120	1119510	0	0
46240332	1192710	0	0
45800298	1112807	0	0
46293004	1115171	2	3
45798065	1174888	0	0
46244159	19018935	2	3
46297077	1125315	0	0
46306186	1129625	0	0
46303476	1129625	0	0
46311423	40229134	2	3
3039467	3014576	2	3
21001455	1322184	0	0
21001149	1551192	2	3
4099350	198199	3	3
21604685	19077572	3	6
35809132	378419	6	7
36151899	791967	0	0
40244697	1125315	0	0
40789180	3015632	2	2
44341709	1125315	0	0
44339983	1149196	0	0
45622224	933724	0	0
45656518	1125315	0	0
45663321	1551192	2	3
45646197	1125315	0	0
45648099	1119510	0	0
45632787	1149196	0	0
45631353	19073183	2	3
45671068	1125315	0	0
45707732	975125	0	0
45706826	1129625	0	0
45692754	1115171	2	3
45697436	1119510	0	0
46240430	1539403	0	0
45800309	975125	0	0
46292744	19078924	2	3
45798067	1778162	0	0
46244165	40229134	2	3
46297078	1125315	0	0
46306073	1129625	0	0
46303621	1129625	0	0
46306543	40223768	2	3
3039467	3019550	2	3
21001487	1717327	0	0
21500564	19077572	2	3
4038490	45769019	3	3
21604685	40223768	3	6
35702113	28060	7	8
36152208	1112807	0	0
40244758	1125315	0	0
40789182	3024731	2	2
44341676	1125315	0	0
44339986	1115008	0	0
45622072	1124300	0	0
45656316	1125315	0	0
45663398	40223834	2	3
45646198	1125315	0	0
45648105	1119510	0	0
45632823	1000560	0	0
45631343	1107882	2	3
45671125	1125315	0	0
45704819	975125	0	0
45704262	1129625	0	0
45693014	46275916	2	3
45697122	1119510	0	0
46240431	705944	0	0
45800311	1367571	0	0
46293031	19019273	2	3
45798152	1713332	0	0
46244402	40229134	2	3
46297079	1125315	0	0
46306244	1129625	0	0
46303675	1129625	0	0
46317199	19079524	2	3
3039467	3015632	2	3
21000578	1501700	0	0
21500564	836659	2	3
4186701	4275113	3	3
21603444	19125062	3	6
35702113	196456	6	7
36152215	1112807	0	0
40244734	1713332	0	0
40789190	3035995	2	2
44341685	1125315	0	0
44339868	1129625	0	0
45622124	1174888	0	0
45656523	1125315	0	0
45663413	920334	2	3
45646203	1125315	0	0
45644783	1119510	0	0
45632824	1174888	0	0
45630774	19018935	2	3
45671190	1125315	0	0
45704572	975125	0	0
45704331	1129625	0	0
45692818	40236824	2	3
45697394	1119510	0	0
46240399	1192710	0	0
45802597	1332418	0	0
46293420	1127433	2	3
45798090	967823	0	0
46244203	40231925	2	3
46297226	1125315	0	0
46306464	1129625	0	0
46303779	1129625	0	0
46301330	19078461	2	3
3039467	3045716	2	3
21000584	1501700	0	0
21500564	40223768	2	3
4160875	81151	3	3
21603444	1107882	3	6
35702113	198809	6	8
36152217	967823	0	0
40244698	1154343	0	0
37520740	4337611	2	2
44341696	1125315	0	0
44339871	738818	0	0
45622078	1107830	0	0
45656561	1125315	0	0
45663194	40229134	2	3
44340955	1125315	0	0
45644895	1119510	0	0
45632811	1738521	0	0
45630631	1332419	2	3
45671356	1125315	0	0
45704889	975125	0	0
45704362	1129625	0	0
45692809	19008572	2	3
45697397	1119510	0	0
46240401	1112807	0	0
45802412	1149196	0	0
46293159	19019273	2	3
45798104	975125	0	0
46244347	19077572	2	3
46297331	1125315	0	0
46306737	1129625	0	0
46303917	1129625	0	0
46310971	40223768	2	3
1501700	40174880	2	3
21000587	1501700	0	0
21500583	40165015	2	3
4162282	4283893	3	3
21603444	43012036	3	6
35702113	4112343	6	10
36151987	1129625	0	0
40244769	1000560	0	0
40789095	3036780	2	2
44341697	1125315	0	0
44339876	738818	0	0
45622134	708298	0	0
45656353	1125315	0	0
45663258	46233988	2	3
44341251	1125315	0	0
45644922	1119510	0	0
45632928	1124957	0	0
45630624	1107882	2	3
45671367	1125315	0	0
45701370	975125	0	0
45704373	1129625	0	0
45692827	40236446	2	3
45697188	1119510	0	0
46240409	1343916	0	0
45802300	1124957	0	0
46288013	19059056	2	3
45798154	1107830	0	0
46244350	19008572	2	3
46297520	1125315	0	0
46306773	1129625	0	0
46300536	1129625	0	0
45650836	1127433	2	3
1589505	43012754	2	3
21000588	1501700	0	0
21001806	19129655	2	3
4176642	4062501	4	4
21603444	40223834	3	6
35702113	4285898	5	11
36009776	4280726	0	0
40244759	1125315	0	0
40789527	3045716	2	2
44341783	1125315	0	0
44340178	1177480	0	0
45622163	975125	0	0
45656469	1125315	0	0
45663258	46233710	2	3
44341257	1125315	0	0
45645012	1119510	0	0
45632763	1192710	0	0
45630714	1127433	2	3
45671192	1125315	0	0
45701378	975125	0	0
45704596	1129625	0	0
45692828	40232448	2	3
45697355	1119510	0	0
46240083	1112807	0	0
45802350	1154029	0	0
46287970	40223834	2	3
45798127	975125	0	0
45693861	1125315	0	0
46297525	1125315	0	0
45896740	1119510	0	0
46301385	1129625	0	0
45650807	19008572	2	3
4013074	439777	1	1
21000703	1545958	0	0
21001661	1551192	2	3
4176642	4197460	4	4
21603444	40223821	3	6
35702113	4027663	4	7
35708322	4027663	0	0
40244760	1125315	0	0
40758424	3027970	2	2
44341815	1125315	0	0
44339966	1539403	0	0
45622164	738818	0	0
45656474	1125315	0	0
45663595	40228214	2	3
44341191	1125315	0	0
45645027	1119510	0	0
45632798	1000560	0	0
45630710	19074843	2	3
45671279	1125315	0	0
45701391	975125	0	0
45700686	1129625	0	0
45692992	40229134	2	3
45697357	1119510	0	0
46240084	1361711	0	0
45802291	1174888	0	0
46288178	19018935	2	3
45798078	1124957	0	0
45694045	1125315	0	0
46297368	1125315	0	0
45801994	1119510	0	0
46319699	1129625	0	0
45650703	19008572	2	3
1309307	964261	1	1
21000703	1539403	0	0
21002325	920334	2	3
4030660	4163971	4	4
21602471	1519937	3	6
35702113	4310024	3	8
35708276	4027663	0	0
40244760	1112807	0	0
40758424	3020630	2	2
44341816	1125315	0	0
44340185	1110410	0	0
45622055	791967	0	0
45656600	1125315	0	0
45659906	40223834	2	3
45643288	1125315	0	0
45645101	1119510	0	0
45632737	1778162	0	0
45627765	19078924	2	3
45671228	1125315	0	0
45698416	975125	0	0
45700909	1129625	0	0
45693004	1551192	2	3
45697521	1119510	0	0
46240091	1112807	0	0
45802426	1778162	0	0
46287974	19075601	2	3
45798407	1115008	0	0
45694104	1125315	0	0
46297155	1125315	0	0
45801951	1119510	0	0
46319761	1129625	0	0
45675392	19077344	2	3
1309994	1310034	1	1
21000703	1332418	0	0
21002325	920300	2	3
141960	4296204	4	4
21604389	19074679	3	6
35702113	440448	3	10
36154755	1119510	0	0
40244762	1129625	0	0
40763890	40766240	2	2
44341963	1125315	0	0
44340158	1000560	0	0
45624999	1738521	0	0
45656603	1125315	0	0
45659906	40223821	2	3
45643157	1125315	0	0
45645106	1119510	0	0
45633021	1149196	0	0
45627616	35605482	2	3
45671410	1125315	0	0
45698255	975125	0	0
45701052	1129625	0	0
45693104	40229134	2	3
45694980	1119510	0	0
46240446	19010482	0	0
45802435	1112807	0	0
46288688	1115171	2	3
45798074	1110410	0	0
45693747	1125315	0	0
46293433	1125315	0	0
45801941	1119510	0	0
46319770	1129625	0	0
45675399	40232448	2	3
437779	28060	1	1
21001475	1367571	0	0
21013403	1551192	2	3
4042646	4330583	4	4
21602514	40221415	3	6
35702113	4166224	3	10
36154756	1119510	0	0
40244762	1125315	0	0
40760930	3019550	2	2
44341907	1125315	0	0
44340133	975125	0	0
45624834	1545958	0	0
45656176	1125315	0	0
45659661	40223834	2	3
45643144	1125315	0	0
45645202	1119510	0	0
45633030	1115008	0	0
45627642	19008572	2	3
45671444	1125315	0	0
45698264	975125	0	0
45700803	1129625	0	0
45693278	40232448	2	3
45694981	1119510	0	0
46240449	1115008	0	0
45802222	1322184	0	0
46288761	40229134	2	3
45798076	1738521	0	0
45694158	1125315	0	0
46292863	1125315	0	0
45802046	1119510	0	0
46319869	1129625	0	0
45675358	19078461	2	3
437409	4132546	1	1
21001462	1322184	0	0
21002743	40223834	2	3
4300244	4057420	4	4
21604181	19023398	3	6
35702113	192671	3	6
36154686	1119510	0	0
40244764	1177480	0	0
40760892	3000963	2	2
44359507	19127922	3	4
44340062	1177480	0	0
45624970	1192710	0	0
45656573	1125315	0	0
45659665	40229134	2	3
45643317	1125315	0	0
45645381	1119510	0	0
45632831	1367571	0	0
45627588	40232448	2	3
45669801	1125315	0	0
45698707	975125	0	0
45701346	1129625	0	0
45693053	40163554	2	3
45694293	1119510	0	0
46240451	1729720	0	0
45802307	705944	0	0
46288721	40223768	2	3
45798159	1174888	0	0
45693876	1125315	0	0
46293056	1125315	0	0
45802052	1119510	0	0
46319997	1129625	0	0
45675497	43012036	2	3
253506	255848	1	1
21001485	1713332	0	0
21002743	40228230	2	3
4034850	4024958	4	4
35502087	4144583	6	6
35707763	4112343	4	8
36154806	1119510	0	0
40248974	1125315	0	0
37220041	28060	2	2
44784105	40479768	4	4
44340259	1124300	0	0
45624971	1107830	0	0
45658360	1125315	0	0
45659982	19008572	2	3
45643379	1125315	0	0
45642095	1119510	0	0
45632866	914335	0	0
45627699	40162522	2	3
45669747	1125315	0	0
45698667	975125	0	0
45701131	1129625	0	0
45693064	19019273	2	3
45694314	1119510	0	0
46240457	1549786	0	0
45797369	1115008	0	0
46244771	40223768	2	3
45798130	975125	0	0
45693980	1125315	0	0
46293239	1125315	0	0
45801919	1119510	0	0
46320119	1129625	0	0
45675502	19008572	2	3
255573	261325	1	1
21001462	1307863	0	0
21002743	1107882	2	3
4185503	260139	4	4
21603444	40229134	5	6
35707763	198809	4	6
36156498	1119510	0	0
40250182	1332418	0	0
40763503	3016723	2	2
44784105	4152936	3	3
44339957	1310149	0	0
45625007	914335	0	0
45658363	1125315	0	0
45659991	40232448	2	3
45643441	1125315	0	0
45643031	1119510	0	0
45632869	738818	0	0
45627344	43012036	2	3
45669810	1125315	0	0
45698349	975125	0	0
45700858	1129625	0	0
45693065	19023398	2	3
45694342	1119510	0	0
46240457	1589505	0	0
45797465	19127890	0	0
46244856	19078461	2	3
45798252	1717327	0	0
45694010	1125315	0	0
46293093	1125315	0	0
45802173	1119510	0	0
46320154	1129625	0	0
45675532	40223834	2	3
255841	258780	1	1
21001463	1361711	0	0
21002743	1150837	2	3
4185503	255848	4	4
21602471	40224132	5	6
35707763	81893	4	10
36151054	1119510	0	0
40250185	1589505	0	0
40763503	3023103	2	2
43531056	4142905	5	5
44340194	1549786	0	0
45625091	1149196	0	0
45658412	1125315	0	0
45660004	19008572	2	3
45643236	1125315	0	0
45643021	1119510	0	0
45632804	1115008	0	0
45627708	19008572	2	3
45669824	1125315	0	0
45697594	975125	0	0
45697901	1129625	0	0
45690018	1115171	2	3
45694425	1119510	0	0
46240461	1118084	0	0
45797323	1112807	0	0
46243301	40229134	2	3
45798254	1309944	0	0
45694012	1125315	0	0
46293127	1125315	0	0
45802086	1119510	0	0
46313809	1129625	0	0
45675430	19075601	2	3
4015311	4024958	1	1
21001772	1119510	0	0
21002743	40228214	2	3
4030654	4242997	4	4
21602471	43012433	5	6
35707763	196456	4	5
36150930	1119510	0	0
40250193	1119510	0	0
40763503	3013682	2	2
43531052	4285898	6	7
44340194	1521369	0	0
45625096	738818	0	0
45658447	1125315	0	0
45660137	19133905	2	3
45643361	1125315	0	0
45642171	1119510	0	0
45632849	1322184	0	0
45627776	1107882	2	3
45669830	1125315	0	0
45697495	975125	0	0
45698019	1129625	0	0
45689963	40232448	2	3
45694606	1119510	0	0
46240186	1515774	0	0
45797326	738818	0	0
46243381	40162522	2	3
45798262	1000560	0	0
45694015	1125315	0	0
46293304	1125315	0	0
45802152	1119510	0	0
46313836	1129625	0	0
45675715	19059056	2	3
4166904	4146173	1	1
21001772	1129625	0	0
21002743	1150771	2	3
4042673	4336464	4	4
21602471	40224805	5	6
35707763	28060	5	6
36150907	1119510	0	0
40250199	1332418	0	0
40789120	3026361	2	2
43531052	440448	6	6
44340285	1192710	0	0
45625098	1153428	0	0
45656637	1125315	0	0
45660158	40228214	2	3
45643530	1125315	0	0
45642249	1119510	0	0
45632644	1174888	0	0
45627806	19008572	2	3
45669841	1125315	0	0
45697573	975125	0	0
45698141	1129625	0	0
45689982	40236824	2	3
45691133	1119510	0	0
46240186	19127890	0	0
45797328	1307863	0	0
46243318	46275444	2	3
45798263	1112807	0	0
45694017	1125315	0	0
46296448	1125315	0	0
45802089	1119510	0	0
46313734	1129625	0	0
45896932	19077572	2	3
4148204	260139	1	1
21001772	1149196	0	0
21002743	19125062	2	3
4133838	4230209	4	4
21603932	19078461	5	6
35800000	378001	9	11
36150915	1119510	0	0
40244765	1177480	0	0
40791227	3024561	2	2
43531052	198809	5	5
44340288	1738521	0	0
45624935	975125	0	0
45656678	1125315	0	0
45659860	19019273	2	3
45643427	1125315	0	0
45642185	1119510	0	0
45632885	1738521	0	0
45627793	19074843	2	3
45669743	1125315	0	0
45695147	975125	0	0
45698171	1129625	0	0
45689988	19008572	2	3
45691140	1119510	0	0
46240186	1549786	0	0
45797424	1174888	0	0
46243545	40232448	2	3
45798195	1307863	0	0
45694896	1125315	0	0
46296565	1125315	0	0
45802211	1119510	0	0
46314050	1129625	0	0
45897040	46221626	2	3
4148909	4181917	1	1
21001763	1551099	0	0
21002743	40223821	2	3
4133838	4234705	4	4
21603932	19019273	5	6
35800000	40481087	8	10
36150995	1119510	0	0
40244790	1177480	0	0
40770373	3013682	2	2
43531052	4310024	3	4
44340305	1107830	0	0
45624953	967823	0	0
45656617	1125315	0	0
45659884	1107882	2	3
45643430	1125315	0	0
45642330	1119510	0	0
45632889	738818	0	0
45624674	1115171	2	3
45669852	1125315	0	0
45695158	975125	0	0
45648770	1129625	0	0
45690077	40232448	2	3
45802384	1119510	0	0
46240188	1309944	0	0
45797425	1112807	0	0
46243369	43012036	2	3
45798420	1115008	0	0
45694907	1125315	0	0
46296584	1125315	0	0
45802213	1119510	0	0
46314628	1129625	0	0
45897099	40231925	2	3
723013	19115351	1	1
21001772	1192710	0	0
21001666	1551192	2	3
255919	140673	4	4
21603398	19133768	2	3
35800000	4048171	7	12
36151014	1119510	0	0
40248956	1551099	0	0
40770373	3023103	2	2
43531052	195588	3	3
44340426	1713332	0	0
45624981	715997	0	0
45656629	1125315	0	0
45667806	19019273	2	3
45643533	1125315	0	0
45642317	1119510	0	0
45630935	791967	0	0
45624613	40232448	2	3
45669781	1125315	0	0
45695224	975125	0	0
45694826	1129625	0	0
45690263	1127433	2	3
45802387	1119510	0	0
46242562	914335	0	0
45797568	1174888	0	0
46243354	40223834	2	3
45798424	1713332	0	0
45690891	1125315	0	0
46296803	1125315	0	0
45802343	1119510	0	0
46314629	1129625	0	0
45896985	1115171	2	3
715997	40223774	1	1
21001772	1150836	0	0
21001669	19007333	2	3
4042664	4330583	4	4
35508266	19078461	2	3
35800000	4029498	7	7
36151312	1119510	0	0
40244795	920293	0	0
40770373	3016723	2	2
43531053	195588	3	3
44340426	1759842	0	0
45622287	975125	0	0
45653066	1125315	0	0
45635534	40163554	2	3
45643469	1125315	0	0
45642299	1119510	0	0
45630948	1192710	0	0
45624406	19073188	2	3
45670578	1125315	0	0
45695268	975125	0	0
45694553	1129625	0	0
45690268	40174880	2	3
45802647	1119510	0	0
46242249	1713332	0	0
45797465	1549786	0	0
46243322	19073183	2	3
45798517	933724	0	0
45690900	1125315	0	0
46296600	1125315	0	0
45802335	1119510	0	0
46309371	1129625	0	0
45896998	40232448	2	3
1307863	40171902	1	1
21001766	1119510	0	0
21000643	19128022	1	1
444220	4230399	4	4
35507392	40228214	2	3
35800000	140673	7	7
36151316	1119510	0	0
40244803	1119510	0	0
40760921	3013682	2	2
44364134	19128009	2	2
44340405	1149196	0	0
45622275	1738521	0	0
45653161	1125315	0	0
45647263	19019273	2	3
45643536	1125315	0	0
45642325	1119510	0	0
45631202	1192710	0	0
45624412	1115171	2	3
45670592	1125315	0	0
45695296	975125	0	0
45694967	1129625	0	0
45688737	46275444	2	3
45802565	1119510	0	0
46242338	1149196	0	0
45797477	1778162	0	0
46243538	19008572	2	3
45798519	1551099	0	0
45691200	1125315	0	0
46296608	1125315	0	0
45799184	1119510	0	0
46309288	1129625	0	0
45897152	40232448	2	3
4022922	4230399	5	6
21001770	1177480	0	0
21000643	19127904	1	1
4078521	4301346	4	4
35507497	40228214	2	3
35800000	195588	6	6
36151326	1119510	0	0
40244808	1521369	0	0
40760921	3016723	2	2
44341806	19128263	2	2
44340274	701322	0	0
45622292	1310149	0	0
45653011	1125315	0	0
45635633	1107882	2	3
45643095	1125315	0	0
45639327	1119510	0	0
45629664	740275	0	0
45624453	1127433	2	3
45669926	1125315	0	0
45692182	975125	0	0
45694769	1129625	0	0
45688517	1115171	2	3
45802570	1119510	0	0
46242090	1332418	0	0
45797478	1149196	0	0
46243555	1551192	2	3
45798368	791967	0	0
45691204	1125315	0	0
46296728	1125315	0	0
45799500	1119510	0	0
46309305	1129625	0	0
45897018	19008572	2	3
4022922	81151	5	6
21001770	1112807	0	0
21001092	19074679	1	1
4162282	257012	4	4
35508232	40228214	2	3
36200000	4001336	5	10
36151222	1119510	0	0
40244808	19127890	0	0
37502347	4275113	2	2
44341806	19128022	2	2
44340226	1539403	0	0
45622296	1746114	0	0
45653016	1125315	0	0
45633986	46233710	2	3
45643223	1125315	0	0
45639135	1119510	0	0
45629665	1192710	0	0
45624666	19008572	2	3
45669976	1125315	0	0
45689278	975125	0	0
45694804	1129625	0	0
45688697	40229134	2	3
45688171	1119510	0	0
46242090	1545958	0	0
45797531	1115008	0	0
46243476	43012036	2	3
45798290	1107830	0	0
45691079	1125315	0	0
46296661	1125315	0	0
45799621	1119510	0	0
46309310	1129625	0	0
45897273	40223768	2	3
4023995	313217	5	6
21001770	738818	0	0
21001463	40171902	1	1
4162282	255848	4	4
35507733	19075601	2	3
36200000	4134304	5	12
36151225	1119510	0	0
40244808	1549786	0	0
37502347	4059978	2	2
44784105	4059173	2	2
44337795	1118084	0	0
45622296	1741122	0	0
45653021	1125315	0	0
45629566	19078924	2	3
45643152	1125315	0	0
45638932	1119510	0	0
45629720	1729720	0	0
45624685	40232448	2	3
45781318	1125315	0	0
45689398	975125	0	0
45695057	1129625	0	0
45687091	43012036	2	3
45688436	1119510	0	0
46242317	1332418	0	0
45797488	967823	0	0
46241051	42707627	2	3
45798410	1548195	0	0
45691150	1125315	0	0
46296748	1125315	0	0
45799392	1119510	0	0
46309318	1129625	0	0
45897026	1115171	2	3
255919	28060	5	6
21001773	1149196	0	0
21500574	1124300	4	4
4162282	40481087	4	4
35508371	1332419	2	3
36200000	378001	6	11
36151242	1119510	0	0
40250213	1192710	0	0
37502347	4238715	2	2
44364046	42902245	2	2
44337799	1549786	0	0
45622336	1539403	0	0
45653175	1125315	0	0
45625102	1713671	2	3
45643002	1125315	0	0
45639271	1119510	0	0
45629662	1102527	0	0
45624875	40169281	2	3
45781319	1125315	0	0
45686238	975125	0	0
45691897	1129625	0	0
45687104	46233988	2	3
45799882	1119510	0	0
46242387	1112807	0	0
45797497	1332418	0	0
46242544	40165015	2	3
45798412	1115008	0	0
45691206	1125315	0	0
46296507	1125315	0	0
45799449	1119510	0	0
46309173	1129625	0	0
45897342	19018935	2	3
4180628	313217	5	6
4179141	4146173	2	2
21500574	1118084	4	4
21505770	1119510	0	0
21503967	40162522	5	6
36203060	40479422	4	4
36151386	1119510	0	0
21502552	1112807	4	4
40765628	40769189	2	2
44339646	19128009	2	2
44337799	1521369	0	0
44339264	1124957	0	0
45652937	1125315	0	0
45622421	1713332	0	0
45640391	1125315	0	0
45632061	1119510	0	0
45629773	1539403	0	0
45654298	1177480	0	0
45624364	19008572	2	3
45686394	975125	0	0
45781198	933724	0	0
45687104	46233710	2	3
45687749	19008572	2	3
46242471	1112807	0	0
45703024	1728416	0	0
46242546	40229134	2	3
45798499	1000560	0	0
46297520	1119510	0	0
45691093	1125315	0	0
46293532	1125315	0	0
45799320	1119510	0	0
46309333	1129625	0	0
45897346	1107882	2	3
253549	4048695	5	6
4179141	4149245	2	2
21500574	1177480	4	4
21505770	1192710	0	0
21500363	46275916	5	6
35902851	198809	4	4
36155724	1119510	0	0
21502552	1367571	4	4
40765628	40769179	2	2
44362889	40223834	2	3
44337803	933724	0	0
44339286	1539403	0	0
45652938	1125315	0	0
45622707	791967	0	0
45640297	1125315	0	0
45632149	1119510	0	0
45629693	1521369	0	0
45655401	1177480	0	0
45624375	43012036	2	3
45686437	975125	0	0
45781644	1717327	0	0
45687187	19074843	2	3
45687303	40232448	2	3
46242526	1115008	0	0
45702872	920293	0	0
46242294	19008572	2	3
45798500	1310149	0	0
46292863	1119510	0	0
45691287	1125315	0	0
46293704	1125315	0	0
45799552	1119510	0	0
46309473	1129625	0	0
45894646	43012036	2	3
253549	4149245	5	6
4154161	4296205	2	2
21500574	1305058	4	4
21505771	1174888	0	0
21505691	40173590	5	6
35802133	40480160	4	4
36155807	1119510	0	0
21502552	1310149	4	4
40765628	40769184	2	2
44362900	1154615	2	3
44337807	1115008	0	0
44339423	1738521	0	0
45653079	1125315	0	0
45622708	1343916	0	0
45640350	1125315	0	0
45632086	1119510	0	0
45629693	19127890	0	0
45654761	1177480	0	0
45624843	40162522	2	3
45686512	975125	0	0
45781652	1124300	0	0
45687237	1107882	2	3
45687230	1115171	2	3
46242529	1738521	0	0
45702874	1307863	0	0
46242368	19008572	2	3
45798510	1124300	0	0
46293239	1119510	0	0
45691366	1125315	0	0
46293589	1125315	0	0
45799671	1119510	0	0
46309362	1129625	0	0
45894753	43012036	2	3
253549	4278672	5	6
4154161	4299128	2	2
21500574	1112807	4	4
21505771	1129625	0	0
21505696	40236446	5	6
36002886	4048171	4	4
36155941	1119510	0	0
21502552	1322184	4	4
40765628	40769194	2	2
44363088	19059056	2	3
44337888	1000560	0	0
44339288	705944	0	0
45653127	1125315	0	0
45622661	1115008	0	0
45640480	1125315	0	0
45632160	1119510	0	0
45629693	1549786	0	0
45654876	1177480	0	0
45668913	40232448	2	3
45685530	975125	0	0
45781436	967823	0	0
45687171	40232448	2	3
45687690	40232448	2	3
46242531	757627	0	0
45702879	967823	0	0
46241199	40232448	2	3
45798292	967823	0	0
46293425	1119510	0	0
45691370	1125315	0	0
46293606	1125315	0	0
45799659	1119510	0	0
46303833	1129625	0	0
45894768	1127433	2	3
253549	40479768	5	6
4154161	4001336	2	2
21500574	19010482	4	4
21505771	1192710	0	0
21601238	46275916	5	6
36002141	4280726	4	4
36156016	1119510	0	0
4180941	4125906	4	4
37520653	44783196	2	2
44362914	40231925	2	3
44337890	1343916	0	0
44339290	975125	0	0
45653151	1125315	0	0
45622723	738818	0	0
45640534	1125315	0	0
45631865	1119510	0	0
45629671	1500211	0	0
45654802	1177480	0	0
45668842	40228230	2	3
45680343	975125	0	0
45781446	1115008	0	0
45687184	19075001	2	3
45687839	19077572	2	3
46240468	1192710	0	0
45702968	920293	0	0
46241250	1545959	2	3
45798300	1729720	0	0
46293304	1119510	0	0
45691344	1125315	0	0
46293610	1125315	0	0
45799578	1119510	0	0
46303855	1129625	0	0
45896749	40232448	2	3
253549	4066995	5	6
4027255	4329847	2	2
21500574	1129625	4	4
21505775	1174888	0	0
21604253	40229134	5	6
36002141	40486433	4	4
36155943	1119510	0	0
21502550	1000560	4	4
37219942	255848	2	2
44362916	1115171	2	3
44337891	1539403	0	0
44339090	1149380	0	0
45653423	1125315	0	0
45622950	738818	0	0
45640523	1125315	0	0
45632192	1119510	0	0
45629677	740275	0	0
45651402	1177480	0	0
45668889	920334	2	3
45676890	975125	0	0
45781202	967823	0	0
45687209	19075601	2	3
45684256	19019273	2	3
46240499	1539403	0	0
45702980	1729720	0	0
46241163	19077572	2	3
45798302	1112807	0	0
46293457	1119510	0	0
45690976	1125315	0	0
46293746	1125315	0	0
45796709	1119510	0	0
46303929	1129625	0	0
45896653	40163554	2	3
253549	40479422	5	6
4105895	4295880	2	2
21500574	1115008	4	4
21505776	1119510	0	0
21604253	19133768	5	6
36002868	40486433	4	4
36155882	1119510	0	0
21502550	975125	4	4
37622482	317576	2	2
44363103	40162522	2	3
44338028	1112807	0	0
44339293	1545958	0	0
45653425	1125315	0	0
45622557	1174888	0	0
45640442	1125315	0	0
45632006	1119510	0	0
45629620	1107830	0	0
45651651	1177480	0	0
45668843	19073183	2	3
45677086	975125	0	0
45781591	933724	0	0
45687210	19133905	2	3
45684374	40163554	2	3
46240710	1545958	0	0
45702986	1551099	0	0
46238234	1332419	2	3
45798424	1759842	0	0
46296565	1119510	0	0
45688744	1125315	0	0
46293751	1125315	0	0
45796843	1119510	0	0
46307067	1129625	0	0
45896421	782047	2	3
253549	4059173	5	6
4105895	4197460	2	2
21500574	1125315	4	4
21505819	1129625	0	0
21604253	40162522	5	6
36002139	433644	4	4
36156211	1119510	0	0
21502550	914335	4	4
40228299	42902245	2	2
44363026	40162522	2	3
44338031	1129625	0	0
44339580	1129625	0	0
45653531	1125315	0	0
45622736	1115008	0	0
45640538	1125315	0	0
45632012	1119510	0	0
45629628	738818	0	0
45651272	1177480	0	0
45668645	19075001	2	3
45677281	975125	0	0
45781215	738818	0	0
45687210	19133873	2	3
45684300	40223768	2	3
46240710	1332418	0	0
45703055	1332418	0	0
46238508	1127433	2	3
45798523	1107830	0	0
46296644	1119510	0	0
45688020	1125315	0	0
46293520	1125315	0	0
45796991	1119510	0	0
46306400	1129625	0	0
45896517	40232448	2	3
4024567	40481087	5	6
4043026	4047491	2	2
21502510	1713332	4	4
21503326	1149380	0	0
21603365	40229134	5	6
36002139	4240902	4	4
36156028	1119510	0	0
21502550	967823	4	4
37520731	4057420	2	2
44363228	19019273	2	3
44338035	1738521	0	0
44339386	1115008	0	0
45653103	1125315	0	0
45622868	1153428	0	0
45640610	1125315	0	0
45632213	1119510	0	0
45629757	1174888	0	0
45648308	1177480	0	0
45668661	1551192	2	3
45673977	975125	0	0
45778663	1124957	0	0
45684124	19008572	2	3
45684311	19078924	2	3
45703202	1112807	0	0
45703816	1548195	0	0
46238531	1332419	2	3
45798228	975125	0	0
46296803	1119510	0	0
45688115	1125315	0	0
46293811	1125315	0	0
45796801	1119510	0	0
46307077	1129625	0	0
45896772	19059056	2	3
4024567	28060	5	6
4178818	372328	2	2
21502510	1768849	4	4
21503373	1129625	0	0
21603365	40162522	5	6
35204998	4310024	4	4
36156029	1119510	0	0
21502550	1177480	4	4
37622481	381316	2	2
44363251	40232448	2	3
44338045	1192710	0	0
44339459	1177480	0	0
45652984	1125315	0	0
45622869	1102527	0	0
45640512	1125315	0	0
45632024	1119510	0	0
45629759	1310149	0	0
45648403	1177480	0	0
45668880	40229134	2	3
45673935	975125	0	0
45778878	967823	0	0
45684158	1107882	2	3
45684269	19077344	2	3
45703250	1124957	0	0
45703946	1107830	0	0
46238339	40232448	2	3
45795455	1153428	0	0
46296600	1119510	0	0
45688064	1125315	0	0
46293725	1125315	0	0
45797104	1119510	0	0
46304172	1129625	0	0
45896792	40236824	2	3
4028076	4048171	5	6
4178818	134438	2	2
21502510	1759842	4	4
21503373	975125	0	0
21603365	19133768	5	6
35205038	441267	4	4
36156132	1119510	0	0
36217216	19127922	3	4
40037552	40221415	2	2
44363252	1115171	2	3
45619727	738818	0	0
44339459	1174888	0	0
45653285	1125315	0	0
45622812	1728416	0	0
45640513	1125315	0	0
45634086	1119510	0	0
45629763	1192710	0	0
45648412	1177480	0	0
45668952	19007333	2	3
45674014	975125	0	0
45779076	967823	0	0
45684098	19023398	2	3
45685586	19075601	2	3
45703223	1501700	0	0
45703575	1149196	0	0
46238409	19059056	2	3
45795361	1589505	0	0
46296728	1119510	0	0
45688107	1125315	0	0
46293530	1125315	0	0
45796891	1119510	0	0
46304183	1129625	0	0
45803821	40229134	2	3
4162282	4112343	5	6
4178818	198199	2	2
21502510	1741122	4	4
21503365	975125	0	0
21496206	3049273	4	5
36203067	4156265	4	4
36156001	1119510	0	0
36217216	19128022	3	4
40758298	40758406	2	2
44363143	1154615	2	3
45619794	1310149	0	0
44339460	1129625	0	0
45653300	1125315	0	0
45622822	1713332	0	0
45640518	1125315	0	0
45634228	1119510	0	0
45629739	1729720	0	0
45645154	1177480	0	0
45670291	40173590	2	3
45673895	975125	0	0
45779085	1545958	0	0
45684206	19008572	2	3
45685467	43012036	2	3
45703180	1118084	0	0
45703771	1310149	0	0
46238635	19019273	2	3
45795361	19127890	0	0
46296660	1119510	0	0
45688088	1125315	0	0
46293952	1125315	0	0
45797038	1119510	0	0
46304101	1129625	0	0
45803602	40162522	2	3
432795	4132546	4	6
4178818	195588	2	2
21502510	1746114	4	4
21503366	975125	0	0
21604147	40173590	4	5
36000000	438614	4	4
36156195	1119510	0	0
36600000	4280726	4	4
37520664	4301346	2	2
44363181	1115171	2	3
45619795	1129625	0	0
44339461	1521369	0	0
45653326	1125315	0	0
45622822	1759842	0	0
45640559	1125315	0	0
45628849	1119510	0	0
45629741	738818	0	0
45645256	1177480	0	0
45670398	19078461	2	3
45673896	975125	0	0
45779195	1192710	0	0
45684239	19008572	2	3
45685478	1127433	2	3
45703206	705944	0	0
45703772	1192710	0	0
46238672	40232448	2	3
45795361	1549786	0	0
46296661	1119510	0	0
45688093	1125315	0	0
46293846	1125315	0	0
45797042	1119510	0	0
46320438	1129625	0	0
45803804	19018935	2	3
4024567	255848	4	6
4108616	4010253	2	2
21502510	1729720	4	4
21503367	975125	0	0
21604792	45892894	4	5
36000000	4139681	4	4
36156198	1119510	0	0
36600000	40480160	4	4
40789542	3006451	2	2
44363159	40232448	2	3
45619955	1112807	0	0
44339461	1549786	0	0
45653095	1125315	0	0
45622830	1332418	0	0
45640619	1125315	0	0
45629045	1119510	0	0
45629749	1759842	0	0
45645125	1177480	0	0
45666599	1115171	2	3
45673906	975125	0	0
45779197	1124957	0	0
45684129	40163554	2	3
45685704	1713671	2	3
45703362	1501700	0	0
45704070	1308738	0	0
46238754	1127433	2	3
45795364	1112807	0	0
46296517	1119510	0	0
45688133	1125315	0	0
46288728	1125315	0	0
45797083	1119510	0	0
46320124	1129625	0	0
45803866	40229134	2	3
4180628	4310024	4	6
4158691	4186930	2	2
21502510	1717327	4	4
21503344	1125315	0	0
21503965	19007333	4	5
36203066	4066995	4	4
36156206	1119510	0	0
36600000	4056621	5	5
40765347	3000963	2	2
44363193	40229134	2	3
45619826	1129625	0	0
44339463	1548195	0	0
45653361	1125315	0	0
45622746	1309944	0	0
45640756	1125315	0	0
45629161	1119510	0	0
45629749	1713332	0	0
45645460	1177480	0	0
45666857	19008572	2	3
45671370	975125	0	0
45779106	1174888	0	0
45684372	1127433	2	3
45685708	19133905	2	3
45703296	1738521	0	0
45703651	1728416	0	0
46238703	40169216	2	3
45795399	933724	0	0
46293572	1119510	0	0
45688140	1125315	0	0
46288617	1125315	0	0
45797027	1119510	0	0
46320460	1129625	0	0
45803673	40229134	2	3
255919	4156265	4	6
4042836	4029498	2	2
21502510	1174888	4	4
21503326	975125	0	0
21604070	42707627	4	5
36203066	40479768	4	4
36156435	1119510	0	0
36600000	81151	5	8
37520651	4301346	2	2
44363591	19133905	2	3
45619873	738818	0	0
44339268	1154029	0	0
45653133	1125315	0	0
45623042	1307863	0	0
45640757	1125315	0	0
45629164	1119510	0	0
45629750	1545958	0	0
45642529	1177480	0	0
45664254	40232448	2	3
45671246	975125	0	0
45779108	1192710	0	0
45680884	19008572	2	3
45685708	19133873	2	3
45703141	1307863	0	0
45703653	1308738	0	0
45897488	19018935	2	3
45795404	1738521	0	0
46293746	1119510	0	0
45688125	1125315	0	0
46288885	1125315	0	0
46318051	1119510	0	0
46320692	1129625	0	0
45803962	19008572	2	3
255919	4132546	4	6
4043161	4218408	2	2
21502510	1778162	4	4
21503375	975125	0	0
21500007	1713671	4	5
36203066	4048695	4	4
36158854	1119510	0	0
36600000	4149245	6	6
37520651	44783196	2	2
44358586	19019273	2	3
45620074	1149196	0	0
44339271	1713332	0	0
45653136	1125315	0	0
45622957	1154343	0	0
45637439	1125315	0	0
45629192	1119510	0	0
45629886	1713332	0	0
45642372	1177480	0	0
45664479	1154615	2	3
45670706	975125	0	0
45778879	1107830	0	0
45683993	1332419	2	3
45684391	40228230	2	3
45703253	1501700	0	0
45704079	1361711	0	0
45897557	40236446	2	3
45795407	1174888	0	0
46293811	1119510	0	0
45688174	1125315	0	0
46288816	1125315	0	0
46318054	1119510	0	0
46320631	1129625	0	0
45894840	42707627	2	3
4022922	4152936	4	6
4043161	4295880	2	2
21502510	1728416	4	4
21503351	1396131	0	0
21500007	46275444	4	5
36203066	40479422	4	4
36158858	1119510	0	0
36600000	40479768	7	7
37522278	4035793	3	3
44358687	40236824	2	3
45619980	1177480	0	0
44339588	1129625	0	0
45653442	1125315	0	0
45622973	1713332	0	0
45637502	1125315	0	0
45629096	1119510	0	0
45629886	1759842	0	0
45642405	1177480	0	0
45664280	1115171	2	3
45781372	975125	0	0
45778948	1149196	0	0
45680558	1127433	2	3
45684580	19059056	2	3
45703224	1309944	0	0
45703717	1124957	0	0
45897639	1127433	2	3
45795397	1149196	0	0
46293530	1119510	0	0
45688208	1125315	0	0
46288632	1125315	0	0
46317552	1119510	0	0
46321388	1129625	0	0
45896869	1107882	2	3
4022922	4149245	4	6
4043022	4202451	2	2
21500582	1174888	4	4
21500206	1361711	0	0
21500010	19074843	4	5
36203066	4001336	4	4
36158935	1119510	0	0
36600000	40479422	7	7
37522278	4197460	3	3
44356475	1115171	2	3
45620028	1177480	0	0
44339374	1539403	0	0
45653114	1125315	0	0
45623071	1115008	0	0
45637537	1125315	0	0
45629102	1119510	0	0
45629835	1713332	0	0
45642550	1177480	0	0
45664309	40229134	2	3
45781186	975125	0	0
45778957	1153428	0	0
45680558	19078461	2	3
45684581	40232448	2	3
45703422	791967	0	0
45703122	1545958	0	0
45897589	40229134	2	3
45795572	1332418	0	0
46288728	1119510	0	0
45688321	1125315	0	0
46291556	1125315	0	0
45793890	1119510	0	0
46320810	1129625	0	0
45650773	19018935	2	3
253549	40480160	4	6
4048365	4133840	2	2
21500582	1124957	4	4
21500544	708298	0	0
21500010	19075001	4	5
36102149	40486433	4	4
36158971	1119510	0	0
36600000	78272	9	9
37622481	317576	3	3
44356269	19008572	2	3
45620337	975125	0	0
44339097	1729720	0	0
45653299	1125315	0	0
45623058	1309944	0	0
45637160	1125315	0	0
45629257	1119510	0	0
45629846	1192710	0	0
45642477	1177480	0	0
45664548	40232448	2	3
45779017	975125	0	0
45778960	1124300	0	0
45783587	19075601	2	3
45684574	1115171	2	3
45703425	1124300	0	0
45703124	1551099	0	0
45897597	1107882	2	3
45795574	1112807	0	0
46288885	1119510	0	0
45688203	1125315	0	0
46291649	1125315	0	0
45794190	1119510	0	0
46314285	1129625	0	0
45675631	40236446	2	3
253549	4237458	4	6
4040396	4238715	2	2
21500582	1102527	4	4
21500544	791967	0	0
21500010	19074841	4	5
36102149	4280726	4	4
36158677	1119510	0	0
36300000	42535580	5	10
37622481	4310024	3	3
44356464	1115171	2	3
45620106	1738521	0	0
44816277	44816277	0	0
45649962	1125315	0	0
45623061	1124300	0	0
45637480	1125315	0	0
45629316	1119510	0	0
45629809	1124300	0	0
45642658	1177480	0	0
45778402	1332419	2	3
45779154	975125	0	0
45779161	1501700	0	0
45693193	40223768	2	3
45681447	1154615	2	3
45703230	1545958	0	0
45703127	1551099	0	0
45897642	19129655	2	3
45795577	933724	0	0
46288852	1119510	0	0
45688205	1125315	0	0
46291655	1125315	0	0
45794024	1119510	0	0
46314894	1129625	0	0
45894852	1551192	2	3
253549	4142905	4	6
4180941	4199276	2	2
21500582	1154029	4	4
21500561	705944	0	0
21500341	40229134	4	5
36203062	381316	4	4
36159085	1119510	0	0
36300000	4037675	6	9
40786258	3049273	3	3
44356471	19059056	2	3
45620075	1322184	0	0
44816279	44816277	0	0
45649985	1125315	0	0
45623062	1308738	0	0
45637483	1125315	0	0
45629271	1119510	0	0
45629775	1115008	0	0
45642797	1177480	0	0
45661668	1115171	2	3
45779184	975125	0	0
45779163	1174888	0	0
45671526	19078461	2	3
45681284	1115171	2	3
45703240	1551099	0	0
45703147	782043	0	0
45897711	40232448	2	3
45795464	1717327	0	0
46288649	1119510	0	0
45688244	1125315	0	0
46289487	1125315	0	0
45794153	1119510	0	0
46314173	1129625	0	0
45675431	19019273	2	3
4028071	198809	6	6
4040400	4163951	2	2
21500582	1110410	4	4
21500553	1192710	0	0
21500327	1107830	5	5
36203062	4329847	4	4
36158776	1119510	0	0
36300000	4243062	6	8
37622411	381316	3	3
44349379	40232448	2	3
45620201	975125	0	0
44805732	44805732	0	0
45649976	1125315	0	0
45622778	967823	0	0
45637322	1125315	0	0
45628278	1119510	0	0
45629933	1308738	0	0
45640254	1177480	0	0
45661775	40174880	2	3
45778791	975125	0	0
45778790	1501700	0	0
45692448	1332419	2	3
45681521	1115171	2	3
45703382	1112807	0	0
45703242	19127890	0	0
45895289	19019273	2	3
45795485	1000560	0	0
46291629	1119510	0	0
45688355	1125315	0	0
46289317	1125315	0	0
45794772	1119510	0	0
46314192	1129625	0	0
45675333	19019273	2	3
436670	4144583	6	6
4047779	261325	5	8
21500582	1112807	4	4
21003515	1000560	0	0
21500327	1192710	5	5
36203062	4094814	4	4
36159114	1119510	0	0
36300000	4151422	6	6
37622411	321042	3	3
44349357	40231925	2	3
45619965	1309944	0	0
45619686	791967	0	0
45649620	1125315	0	0
45622781	1124957	0	0
45637327	1125315	0	0
45626200	1119510	0	0
45629853	1367571	0	0
45640168	1177480	0	0
45661806	1332419	2	3
45708016	975125	0	0
45779250	738818	0	0
45692702	1107882	2	3
45681317	19008572	2	3
45703521	701322	0	0
45703242	1589505	0	0
45895456	40232448	2	3
45795593	914335	0	0
46291649	1119510	0	0
45688305	1125315	0	0
46288982	1125315	0	0
45794801	1119510	0	0
46314835	1129625	0	0
45650772	1551192	2	3
4162282	4048171	6	6
4047779	4001336	5	8
21500120	40221415	4	4
21004249	738818	0	0
21500327	1153428	5	5
36206173	3049273	4	4
36159122	1119510	0	0
36300000	4062501	7	7
37522284	4337138	3	3
44349417	40232448	2	3
45619876	1129625	0	0
44360447	723013	0	0
45649871	1125315	0	0
45622782	1115008	0	0
45637560	1125315	0	0
45626428	1119510	0	0
45629822	967823	0	0
45640258	1177480	0	0
45661146	40231925	2	3
45707992	975125	0	0
45779189	1174888	0	0
45676251	19078461	2	3
45681560	1127433	2	3
45703255	1310149	0	0
45703242	1549786	0	0
45895368	40165015	2	3
45795661	1124300	0	0
46289097	1119510	0	0
45688431	1125315	0	0
46243494	1125315	0	0
45794313	1119510	0	0
46314690	1129625	0	0
45894821	1107882	2	3
4024567	257012	3	6
4047779	4066995	5	8
4247371	380378	4	4
21004249	1192710	0	0
21500327	1125315	5	5
36203066	4230399	3	3
36159003	1119510	0	0
36300000	40479422	11	14
37520731	4336464	3	3
44349463	19008572	2	3
45619845	1112807	0	0
44360453	738818	0	0
45649957	1125315	0	0
45623119	740275	0	0
45637562	1125315	0	0
45626262	1119510	0	0
45629785	1124957	0	0
45639646	1177480	0	0
45661155	19078924	2	3
45705094	975125	0	0
45779340	1192710	0	0
45673417	19075601	2	3
45679754	40229134	2	3
45703265	975125	0	0
45703164	1149380	0	0
45895480	40232448	2	3
45795666	1549786	0	0
46288982	1119510	0	0
45688375	1125315	0	0
46243597	1125315	0	0
45794282	1119510	0	0
46317745	1129625	0	0
45650645	1551192	2	3
4102111	4285898	3	6
4047779	4237458	5	8
4247371	372328	4	4
21004249	1115008	0	0
21500327	1150836	5	5
36203066	4134304	3	3
36159147	1119510	0	0
36300000	4174876	8	9
37302323	4102123	3	3
44349451	19057271	2	3
45619848	1112807	0	0
44360457	1713332	0	0
45651886	1125315	0	0
45622769	1149196	0	0
45637265	1125315	0	0
45626302	1119510	0	0
45629787	791967	0	0
45639651	1177480	0	0
45661365	19019273	2	3
45633081	1548195	0	0
45779341	1713332	0	0
45680569	40228214	2	3
45679777	19008572	2	3
45703275	1154343	0	0
45703386	967823	0	0
45895385	40232448	2	3
45795666	19127890	0	0
46243599	1119510	0	0
45688169	1125315	0	0
46243598	1125315	0	0
45791453	1119510	0	0
46317093	1129625	0	0
45894954	40223768	2	3
320136	4280726	2	6
4047779	40480160	5	8
4247371	381316	4	4
21004387	1112807	0	0
21500327	1149196	5	5
36203066	4146173	3	3
36158929	1119510	0	0
36300000	4035415	8	12
37521809	4337611	3	3
44349429	1115171	2	3
45619850	1589505	0	0
44360457	1759842	0	0
45652002	1125315	0	0
45623160	1124957	0	0
45637269	1125315	0	0
45626305	1119510	0	0
45629788	701322	0	0
45639652	1177480	0	0
45777849	40229134	2	3
45633084	1124957	0	0
45779178	1110410	0	0
45680773	19078461	2	3
45679759	19057271	2	3
45703586	791967	0	0
45703192	1174888	0	0
45895249	19008572	2	3
45795666	1521369	0	0
46243487	1119510	0	0
45685006	1125315	0	0
46243599	1125315	0	0
45791709	1119510	0	0
46315097	1129625	0	0
45897164	46233988	2	3
4024567	4280726	3	7
4047779	4152936	5	7
21500093	1500211	4	4
21004232	1713332	0	0
35100000	4056621	5	5
36203066	4132546	3	3
36158915	1119510	0	0
36300000	4109685	8	12
37502347	4186930	3	3
44349749	40231925	2	3
45619910	1192710	0	0
44360460	933724	0	0
45651938	1125315	0	0
45623169	1154029	0	0
45637270	1125315	0	0
45626381	1119510	0	0
45629918	1728416	0	0
45639526	1177480	0	0
45777823	40229134	2	3
45633061	1149196	0	0
45779374	1192710	0	0
45677425	19078461	2	3
45697811	19019273	2	3
45703348	1174888	0	0
45703278	1192710	0	0
45895505	40232448	2	3
45795678	1539403	0	0
46243721	1119510	0	0
45684923	1125315	0	0
46243487	1125315	0	0
45791405	1119510	0	0
46315304	1129625	0	0
45897164	46233710	2	3
432795	40480160	7	7
4047779	4266809	5	7
21500136	19128065	4	4
21004249	1174888	0	0
21503650	1125315	5	5
35702124	28060	3	3
36159235	1119510	0	0
36300000	4112343	8	14
37502347	44805732	3	3
44349751	19133905	2	3
45619912	1322184	0	0
44360561	1154029	0	0
45650045	1125315	0	0
45621245	1332418	0	0
45637412	1125315	0	0
45626439	1119510	0	0
45629944	1539403	0	0
45636642	1177480	0	0
45654802	19078461	2	3
45633070	738818	0	0
45779125	19010482	0	0
45705521	19075601	2	3
45696898	920334	2	3
45703547	1778162	0	0
45703282	1107830	0	0
45895487	19008572	2	3
45795597	19010482	0	0
46243638	1119510	0	0
45684981	1125315	0	0
46243625	1125315	0	0
45791685	1119510	0	0
46309601	1129625	0	0
45803688	19075601	2	3
4022922	40479422	6	7
4047779	258780	5	9
21500136	19127918	4	4
21004387	975125	0	0
21503650	19003953	5	5
36002869	433644	3	3
36159082	1119510	0	0
36300000	321042	9	13
40490903	44805732	3	3
44349557	40162522	2	3
45619920	1112807	0	0
44360632	1129625	0	0
45646739	1125315	0	0
45621277	1149196	0	0
45639940	1125315	0	0
45626313	1119510	0	0
45629719	914335	0	0
45636974	1177480	0	0
45654849	19008572	2	3
45633136	1110410	0	0
45778924	791967	0	0
45686956	1332419	2	3
45697017	19133905	2	3
45703630	1107830	0	0
45703108	1729720	0	0
45894537	40162522	2	3
45795684	1548195	0	0
46243512	1119510	0	0
45685105	1125315	0	0
46243638	1125315	0	0
45791554	1119510	0	0
46309862	1129625	0	0
45894790	19078461	2	3
4022922	40479768	6	7
4047779	81893	5	11
21500136	19132304	4	4
21003586	914335	0	0
21503650	1112807	5	5
36002869	4219399	3	3
36159130	1119510	0	0
36300000	28060	9	12
40763497	3013682	3	3
44349660	40232448	2	3
45620001	1107830	0	0
44360651	967823	0	0
45646744	1125315	0	0
45621235	914335	0	0
45640208	1125315	0	0
45623148	1119510	0	0
45629800	1192710	0	0
45637250	1177480	0	0
45654793	40232448	2	3
45633142	738818	0	0
45779075	791967	0	0
45686879	19075601	2	3
45697018	40232448	2	3
45703505	914335	0	0
45703118	1000560	0	0
45803236	43012036	2	3
45795686	1153428	0	0
46243504	1119510	0	0
45685064	1125315	0	0
46243640	1125315	0	0
45791692	1119510	0	0
46309746	1129625	0	0
45894814	40223768	2	3
4024567	261325	4	7
4185115	4336464	5	8
21500136	19127904	4	4
21004249	1119510	0	0
21502584	708298	5	5
36002869	4240902	3	3
36159273	1119510	0	0
36300000	255848	9	12
40763497	3023103	3	3
44349861	40232448	2	3
45619886	738818	0	0
44360691	1332418	0	0
45646745	1125315	0	0
45621218	1149196	0	0
45640029	1125315	0	0
45622983	1119510	0	0
45629804	914335	0	0
45633285	1177480	0	0
45645239	1107882	2	3
45633115	1107830	0	0
45778989	1000560	0	0
45695657	19075601	2	3
45697308	1115171	2	3
45703301	1107830	0	0
45699801	1310149	0	0
45803421	1127433	2	3
45795689	1115008	0	0
46243655	1119510	0	0
45684713	1125315	0	0
46243642	1125315	0	0
45791837	1119510	0	0
46309912	1129625	0	0
45894819	40228214	2	3
4024567	260139	4	7
4180627	4107731	5	8
21500136	19128009	4	4
21004249	1177480	0	0
21502584	1125315	5	5
36002869	37017711	3	3
36159044	1119510	0	0
36300000	198199	9	12
40763497	3016723	3	3
44350046	40229134	2	3
45620126	791967	0	0
44360570	1115008	0	0
45646598	1125315	0	0
45621256	1778162	0	0
45639982	1125315	0	0
45623090	1119510	0	0
45629987	1149380	0	0
45633287	1177480	0	0
45655484	1545959	2	3
45633122	1174888	0	0
45707620	1589505	0	0
45693168	19075601	2	3
45693945	19008572	2	3
45703310	1149196	0	0
45700035	19002770	0	0
45803357	40229134	2	3
45795694	1549786	0	0
46243586	1119510	0	0
45685077	1125315	0	0
46243732	1125315	0	0
45791786	1119510	0	0
46304703	1129625	0	0
45894608	1107882	2	3
4024567	4294548	4	7
4180628	4237458	5	7
21500136	42902245	4	4
21004249	1112807	0	0
21502584	1115008	5	5
36203067	4109685	3	3
36159343	1119510	0	0
36300000	440448	9	14
37219970	317576	3	3
44341796	40232448	2	3
45619838	1177480	0	0
44360575	791967	0	0
45646879	1125315	0	0
45621259	1309944	0	0
45639945	1125315	0	0
45623011	1119510	0	0
45629988	1153428	0	0
45633223	1177480	0	0
45639569	1332419	2	3
45633128	1000560	0	0
45707624	1118084	0	0
45692638	1332419	2	3
45693946	40174880	2	3
45703314	1107830	0	0
45699813	1332418	0	0
45876069	3024561	2	3
45795694	1521369	0	0
46243811	1119510	0	0
45685083	1125315	0	0
46243611	1125315	0	0
45791585	1119510	0	0
46304704	1129625	0	0
45803818	1107882	2	3
4024567	40486433	4	7
4178818	4048171	5	7
21500136	19128263	4	4
21004386	1551099	0	0
21502584	740275	5	5
36203067	4152936	3	3
36159212	1119510	0	0
36300000	442116	9	10
37219970	321042	3	3
44342122	40229134	2	3
45620032	1149196	0	0
44360714	705944	0	0
45647035	1125315	0	0
45621171	1149196	0	0
45640084	1125315	0	0
45623013	1119510	0	0
45629990	1110410	0	0
45633451	1177480	0	0
45630227	1107882	2	3
45633088	1192710	0	0
45707629	1153428	0	0
45680940	19078461	2	3
45693954	40231925	2	3
45703326	1717327	0	0
45700048	1589505	0	0
45803527	40163554	2	3
45796826	1149196	0	0
46243772	1119510	0	0
45685110	1125315	0	0
46243523	1125315	0	0
45791826	1119510	0	0
46304945	1129625	0	0
45675321	1107882	2	3
4180628	40486433	4	7
4178818	4112343	5	7
21500136	40221415	4	4
21004571	914335	0	0
21502584	1119510	5	5
36203067	4296204	3	3
36159363	1119510	0	0
36300000	4169137	9	10
40760929	3013682	3	3
44341873	40162522	2	3
45620216	975125	0	0
44360717	1153428	0	0
45646844	1125315	0	0
45620973	1717327	0	0
45634207	1125315	0	0
45623019	1119510	0	0
45629770	1174888	0	0
45633621	1177480	0	0
45631207	40228214	2	3
45633162	1713332	0	0
45707637	1149196	0	0
45673098	19078461	2	3
45694085	40229134	2	3
45703330	1102527	0	0
45700119	1000560	0	0
45803507	1115171	2	3
45796936	1115008	0	0
46243838	1119510	0	0
45685137	1125315	0	0
46243649	1125315	0	0
45791730	1119510	0	0
46304763	1129625	0	0
45896962	1107882	2	3
4180628	260139	4	7
4043022	4336464	5	7
21500136	19128022	4	4
21004572	975125	0	0
21502584	705944	5	5
36203067	4113008	3	3
36159480	1119510	0	0
36300000	78272	9	15
40760929	3016723	3	3
44342020	1713671	2	3
45620042	1129625	0	0
44360720	1129625	0	0
45646848	1125315	0	0
45620974	723013	0	0
45634181	1125315	0	0
45623249	1119510	0	0
45626917	1310149	0	0
45633308	1177480	0	0
45636950	1539411	2	3
45633149	1521369	0	0
45707638	1343916	0	0
45692382	19078461	2	3
45693743	19018935	2	3
45703442	1107830	0	0
45700125	914335	0	0
45803606	19133873	2	3
45797138	1521369	0	0
46243752	1119510	0	0
45685140	1125315	0	0
46243504	1125315	0	0
45791750	1119510	0	0
46305277	1129625	0	0
45896991	1107882	2	3
4180628	4048695	4	7
4178545	4280726	5	6
21500136	46221626	4	4
21004493	1717327	0	0
21502584	742185	5	5
36203067	4155034	3	3
36159482	1119510	0	0
36300000	433125	10	10
36902266	440086	3	3
44342224	19008572	2	3
45620045	1112807	0	0
44360732	1192710	0	0
45646952	1125315	0	0
45621281	1110410	0	0
45634040	1125315	0	0
45624908	1119510	0	0
45626921	1326303	0	0
45633654	1177480	0	0
45633505	40173590	2	3
45633270	1548195	0	0
45707639	1192710	0	0
45680427	40228214	2	3
45694034	19019273	2	3
45703444	19003953	0	0
45699985	1102527	0	0
45803615	43012036	2	3
45797138	1549786	0	0
46243701	1119510	0	0
45685013	1125315	0	0
46243582	1125315	0	0
45791756	1119510	0	0
46321155	1129625	0	0
46317593	40223768	2	3
253549	81151	4	7
4178545	40486433	5	6
21500175	1557272	4	4
21004249	1149196	0	0
21502584	926487	5	5
36002139	4139681	3	3
36159488	1119510	0	0
36300000	45769019	10	12
37521609	4117038	3	3
44342093	40231925	2	3
45620047	1174888	0	0
44360741	1112807	0	0
45647137	1125315	0	0
45621241	1548195	0	0
45634051	1125315	0	0
45625112	1119510	0	0
45626702	738818	0	0
45633750	1177480	0	0
45666544	40173590	2	3
45633270	1512674	0	0
45707648	1545958	0	0
45692652	40228214	2	3
45694161	19008572	2	3
45703477	1174888	0	0
45700103	1149196	0	0
45803632	1551192	2	3
45796938	1107830	0	0
46243799	1119510	0	0
45685114	1125315	0	0
46243586	1125315	0	0
45791763	1119510	0	0
46321167	1129625	0	0
46313270	40232448	2	3
4012185	4336464	4	7
4180938	4047491	5	6
4229909	4048171	4	4
21004233	1713332	0	0
21503645	1174888	5	5
35802841	40480160	3	3
36159489	1119510	0	0
36300000	4219399	10	11
40789542	3012494	3	3
44342077	46221626	2	3
45620054	738818	0	0
44360896	1129625	0	0
45647245	1125315	0	0
45621269	1115008	0	0
45634149	1125315	0	0
45621629	1119510	0	0
45626985	1332418	0	0
45633698	1177480	0	0
45639680	1107882	2	3
45633173	1115008	0	0
45777908	1000560	0	0
45695718	40228214	2	3
45694016	19133873	2	3
45700219	1192710	0	0
45700239	1310149	0	0
45800836	19132304	2	3
45796947	967823	0	0
46241412	1119510	0	0
45684867	1125315	0	0
46243811	1125315	0	0
45791769	1119510	0	0
46320829	1129625	0	0
46313423	40232448	2	3
432795	4146173	5	7
4180938	42535580	5	6
4299725	4336464	4	4
21004346	1738521	0	0
21503645	1124300	5	5
35802841	4066995	3	3
36159500	1119510	0	0
36300000	313217	10	15
40789542	3006734	3	3
44342163	1551192	2	3
45620057	1177480	0	0
44360697	738818	0	0
45647075	1125315	0	0
45621138	1124300	0	0
45634154	1125315	0	0
45621530	1119510	0	0
45627026	1149196	0	0
45630288	1177480	0	0
45627223	1107882	2	3
45676449	1192710	0	0
45777924	1307863	0	0
45655222	19078461	2	3
45694028	35605482	2	3
45700369	1343916	0	0
45700111	975125	0	0
45801016	1115171	2	3
45796949	1738521	0	0
46241242	1119510	0	0
45685209	1125315	0	0
46243744	1125315	0	0
45789003	1119510	0	0
46321173	1129625	0	0
46313534	40231925	2	3
432795	4142905	5	7
4103662	375671	5	6
4306074	4337138	4	4
21004249	1129625	0	0
21503645	1110410	5	5
36203090	40480160	3	3
36159320	1119510	0	0
36303153	433125	8	8
37521341	4163971	3	3
44342253	19074843	2	3
45620060	1112807	0	0
44360672	1112807	0	0
45647080	1125315	0	0
45621142	1713332	0	0
45634398	1125315	0	0
45621664	1119510	0	0
45626699	1192710	0	0
45630474	1177480	0	0
45654781	19078461	2	3
45676781	1107830	0	0
45777862	1124300	0	0
45779408	1332419	2	3
45694896	40231925	2	3
45700401	1307863	0	0
45699933	1501700	0	0
45801074	40163554	2	3
45796952	1115008	0	0
46241313	1119510	0	0
45685840	1125315	0	0
46243766	1125315	0	0
45789006	1119510	0	0
46321184	1129625	0	0
46313331	1115171	2	3
4180628	133834	5	7
4103662	378001	5	6
4247120	81893	4	4
21004346	1728416	0	0
21503645	1112807	5	5
36203060	4146173	3	3
36159327	1119510	0	0
36303153	45769019	8	10
37220016	40486433	3	3
44342375	19073183	2	3
45620064	1177480	0	0
44360673	1192710	0	0
45647114	1125315	0	0
45621220	1539403	0	0
45634399	1125315	0	0
45621862	1119510	0	0
45626841	1192710	0	0
45630402	1177480	0	0
45648127	1332419	2	3
45676395	1110410	0	0
45777864	1343916	0	0
45690064	40228214	2	3
45690950	19018935	2	3
45700445	1549786	0	0
45699935	1192710	0	0
45800887	19008572	2	3
45797073	1738521	0	0
46241474	1119510	0	0
45685887	1125315	0	0
46243772	1125315	0	0
45789053	1119510	0	0
46321194	1129625	0	0
46313501	1115171	2	3
4180628	4149245	5	7
4115390	313217	5	6
21505881	40173590	4	5
21004496	1717327	0	0
21502620	1778162	5	5
36000000	439406	3	3
36159582	1119510	0	0
36303153	433644	8	9
37220016	4280726	3	3
44337822	1107882	2	3
45620064	1129625	0	0
44360674	1322184	0	0
45647142	1125315	0	0
45621296	1115008	0	0
45634506	1125315	0	0
45667317	1119510	0	0
45626968	1154029	0	0
45630691	1177480	0	0
45642624	1332419	2	3
45676401	933724	0	0
45692516	1125315	0	0
45781730	40228230	2	3
45690951	19008572	2	3
45700445	19127890	0	0
45699936	715997	0	0
45801183	19019273	2	3
45795701	1000560	0	0
46241335	1119510	0	0
45681890	1125315	0	0
46243834	1125315	0	0
45788941	1119510	0	0
46321080	1129625	0	0
46313544	40232448	2	3
4024567	258780	5	8
4103320	4048171	5	6
21500121	1551192	4	5
21004497	1717327	0	0
21502620	1728416	5	5
36000000	133834	3	3
36159585	1119510	0	0
36303153	40486433	7	12
37502339	4197460	3	3
44337826	40223834	2	3
45620111	1177480	0	0
44360699	1539403	0	0
45647152	1125315	0	0
45621267	1343916	0	0
45634507	1125315	0	0
45667491	1119510	0	0
45626819	1174888	0	0
45630758	1177480	0	0
45649225	1332419	2	3
45676454	1551099	0	0
45692519	1125315	0	0
45781730	40228214	2	3
45691060	40174880	2	3
45700445	1589505	0	0
45700153	967823	0	0
45799770	40229134	2	3
45795711	1118084	0	0
46241339	1119510	0	0
45682155	1125315	0	0
46243685	1125315	0	0
45789144	1119510	0	0
46320954	1129625	0	0
46314215	1115171	2	3
4024567	4048171	5	8
4027403	4337611	5	6
21501218	19079524	4	5
21001849	1713332	0	0
21502620	1746114	5	5
35902851	196456	3	3
36159614	1119510	0	0
36303153	4139681	7	8
37219785	258780	3	3
44337838	40236824	2	3
45619894	1115008	0	0
44360702	1551099	0	0
45646987	1125315	0	0
45621304	1000560	0	0
45634336	1125315	0	0
45665342	1119510	0	0
45626977	1545958	0	0
45627635	1177480	0	0
45660666	19078461	2	3
45676458	738818	0	0
45692604	1125315	0	0
45692386	1539411	2	3
45691039	1310034	2	3
45700447	1124300	0	0
45700159	1308738	0	0
45799771	1115171	2	3
45795719	1322184	0	0
46241351	1119510	0	0
45681967	1125315	0	0
46243838	1125315	0	0
45789138	1119510	0	0
46320967	1129625	0	0
46313945	1115171	2	3
432795	378001	5	8
4040392	4117038	5	6
4208786	4237458	4	5
21001857	1137529	0	0
21502620	1713332	5	5
21602567	19128065	3	3
36151143	1119510	0	0
36303153	442116	7	8
37219785	261325	3	3
44337847	1115171	2	3
45619896	791967	0	0
44360703	920293	0	0
45646993	1125315	0	0
45621307	1501700	0	0
45634241	1125315	0	0
45665165	1119510	0	0
45626962	1551099	0	0
45627655	1177480	0	0
45636594	19075601	2	3
45676845	1310149	0	0
45692390	1125315	0	0
45683943	40228214	2	3
45691206	40229134	2	3
45700305	914335	0	0
45699994	1713332	0	0
45799709	1332419	2	3
45792994	1174888	0	0
46241517	1119510	0	0
45682026	1125315	0	0
46243752	1125315	0	0
46301961	1119510	0	0
46321582	1129625	0	0
46313959	40231925	2	3
4024567	4112343	4	8
4042836	375671	5	6
4208786	4142905	4	5
21001857	1149380	0	0
21502620	1729720	5	5
36211375	4001336	3	3
36151146	1119510	0	0
36303153	4047491	7	8
40789541	3020655	3	3
44337684	19059056	2	3
45620092	1129625	0	0
44360857	1177480	0	0
45646994	1125315	0	0
45622168	1713332	0	0
45634341	1125315	0	0
45665306	1119510	0	0
45626939	1107830	0	0
45627686	1177480	0	0
45661221	1332419	2	3
45676981	1539403	0	0
45692655	1125315	0	0
45781780	19079524	2	3
45691188	1539411	2	3
45700324	1107830	0	0
45700004	723013	0	0
45799751	40162522	2	3
45792995	1738521	0	0
46241574	1119510	0	0
45682053	1125315	0	0
46243701	1125315	0	0
46301965	1119510	0	0
46321585	1129625	0	0
46313902	19019273	2	3
4028071	440448	7	7
4042836	4048171	5	6
4297887	4112343	4	5
21001842	1768849	0	0
21502620	1741122	5	5
21602627	933724	3	3
36151292	1119510	0	0
36303153	4048695	7	11
40786244	3009201	3	3
44363316	1127433	2	3
45620105	1137529	0	0
44360842	1177480	0	0
45647087	1125315	0	0
45621922	1361711	0	0
45634313	1125315	0	0
45665399	1119510	0	0
45627008	1549786	0	0
45624460	1177480	0	0
45668446	40228214	2	3
45676990	1310149	0	0
45692550	1125315	0	0
45682455	40228214	2	3
45691028	40163554	2	3
45700222	1107830	0	0
45700005	967823	0	0
45798171	40232448	2	3
45793001	1729720	0	0
46241655	1119510	0	0
45682060	1125315	0	0
46243817	1125315	0	0
46301827	1119510	0	0
46321588	1129625	0	0
46308405	46233710	2	3
4028071	313217	5	8
4154161	78272	5	5
4297887	4285898	4	5
21001860	975125	0	0
21502620	1768849	5	5
35902136	196456	3	3
36152440	1119510	0	0
36303153	321042	7	11
42889666	4066995	3	3
44363708	19018935	2	3
44777976	1149196	0	0
44360875	1129625	0	0
45647004	1125315	0	0
45621947	740275	0	0
45634471	1125315	0	0
45665380	1119510	0	0
45627008	1521369	0	0
45624488	1177480	0	0
45636508	40228214	2	3
45676994	1174888	0	0
45692615	1125315	0	0
45674495	40228214	2	3
45691129	19008572	2	3
45700374	1589505	0	0
45700104	1539403	0	0
45798407	1115171	2	3
45792981	1332418	0	0
46241556	1119510	0	0
45682067	1125315	0	0
46243902	1125315	0	0
46301801	1119510	0	0
46321589	1129625	0	0
46308049	1115171	2	3
255919	257012	5	7
4179141	78272	5	5
4247371	4132546	4	5
21001866	1551099	0	0
21502620	933724	5	5
36203042	4059173	3	3
36152277	1119510	0	0
36303153	255848	7	10
42889666	4048695	3	3
44363717	40236824	2	3
44777982	1738521	0	0
44360656	1118084	0	0
45647211	1125315	0	0
45621948	1124957	0	0
45634638	1125315	0	0
45665242	1119510	0	0
45627016	1310149	0	0
45624639	1177480	0	0
45624156	19075601	2	3
45676997	1549786	0	0
45692705	1125315	0	0
45783977	40228214	2	3
45688115	40162522	2	3
45700374	1549786	0	0
45700084	1115008	0	0
45798069	40229134	2	3
45792920	967823	0	0
46241613	1119510	0	0
45682092	1125315	0	0
46243779	1125315	0	0
46301887	1119510	0	0
46315694	1129625	0	0
46308517	19073183	2	3
255919	4112343	5	8
4154162	378001	5	5
21500562	19077572	4	5
21001849	1768849	0	0
21502620	1717327	5	5
36203042	4048695	3	3
36152284	1119510	0	0
36303153	381316	6	9
40786225	3013721	3	3
44363412	19059056	2	3
44777990	1124957	0	0
44360490	1177480	0	0
45647230	1125315	0	0
45621954	1174888	0	0
45634585	1125315	0	0
45665247	1119510	0	0
45628023	1501700	0	0
45624530	1177480	0	0
45666805	19078461	2	3
45676997	1589505	0	0
45692546	1125315	0	0
45680669	19079524	2	3
45688115	19133768	2	3
45700380	708298	0	0
45699926	967823	0	0
45798130	19008572	2	3
45792921	1713332	0	0
46241529	1119510	0	0
45682108	1125315	0	0
46243791	1125315	0	0
46302174	1119510	0	0
46316026	1129625	0	0
46308568	1551192	2	3
255919	40486433	6	8
4154162	375671	5	5
21500562	40222846	4	5
21001866	975125	0	0
21604489	19115351	4	4
35702767	4027663	3	3
36152287	1119510	0	0
36303153	4112343	6	12
37503997	4202451	3	3
44363417	920300	2	3
44777995	1124300	0	0
44360469	1129625	0	0
45647237	1125315	0	0
45622048	753626	0	0
45634276	1125315	0	0
45667429	1119510	0	0
45628030	914335	0	0
45624807	1177480	0	0
45624760	19075601	2	3
45676542	1343916	0	0
45692669	1125315	0	0
45677662	19078461	2	3
45688065	40232448	2	3
45700458	19010482	0	0
45700236	1713332	0	0
45798261	40229134	2	3
45792853	1115008	0	0
46238795	1119510	0	0
45682118	1125315	0	0
46243799	1125315	0	0
46302046	1119510	0	0
46315963	1129625	0	0
46308194	40174880	2	3
255919	378419	6	7
4180938	4202451	5	5
21500562	836659	4	5
21001878	1137529	0	0
21604489	723013	3	3
21602551	19127922	3	3
36152397	1119510	0	0
36303153	40479422	9	12
37521376	4330583	3	3
44363530	1127433	2	3
44777996	1112807	0	0
44360646	1000560	0	0
45645894	1125315	0	0
45621321	1118084	0	0
45634526	1125315	0	0
45667275	1119510	0	0
45628073	1149196	0	0
45624995	1177480	0	0
45666721	40223768	2	3
45676722	1548195	0	0
45692681	1125315	0	0
45692822	40228214	2	3
45688151	19078461	2	3
45700229	1112807	0	0
45700088	1501700	0	0
45798397	40229134	2	3
45793134	1115008	0	0
46238546	1119510	0	0
45682277	1125315	0	0
46243804	1125315	0	0
46302141	1119510	0	0
46315964	1129625	0	0
46308311	40229134	2	3
1107882	1107882	0	0
4040559	4163971	5	5
21500595	19078461	4	5
21001878	1149380	0	0
21604489	791967	3	3
21602551	19133679	3	3
36151398	1119510	0	0
36303153	4062501	5	5
42889648	378001	3	3
44363573	40232448	2	3
44777998	1124300	0	0
44360790	1124957	0	0
45645860	1125315	0	0
45621417	1549786	0	0
45634372	1125315	0	0
45662909	1119510	0	0
45628210	738818	0	0
45624998	1177480	0	0
45657997	40228214	2	3
45676462	1332418	0	0
45692694	1125315	0	0
45655014	40228214	2	3
45688323	920334	2	3
45700463	1361711	0	0
45700350	1308738	0	0
45798290	1107882	2	3
45793137	1174888	0	0
46238828	1119510	0	0
45682343	1125315	0	0
46243921	1125315	0	0
46299549	1119510	0	0
46315749	1129625	0	0
46308616	46275444	2	3
1580874	1000560	0	0
4154739	4134304	5	5
21500595	19019273	4	5
21001848	1713332	0	0
21604489	708298	3	3
21602551	19129144	3	3
36151458	1119510	0	0
36303153	4024958	5	6
42889648	375671	3	3
44363624	40229134	2	3
44778029	1177480	0	0
44360818	1305058	0	0
45643853	1125315	0	0
45621417	1521369	0	0
45634619	1125315	0	0
45662915	1119510	0	0
45628214	1557272	0	0
45624742	1177480	0	0
45645385	40228214	2	3
45676767	920293	0	0
45692709	1125315	0	0
45705338	19078461	2	3
45688333	1115171	2	3
45700498	1112807	0	0
45700207	1307863	0	0
45798412	19019273	2	3
45793137	1192710	0	0
46238829	1119510	0	0
45682460	1125315	0	0
46243922	1125315	0	0
46299384	1119510	0	0
46316038	1129625	0	0
46308692	40229134	2	3
1580858	1332418	0	0
4180627	4037675	5	5
4326426	4117038	4	5
21001848	1778162	0	0
21604489	19057271	3	6
21604034	1124300	3	3
36151496	1119510	0	0
36303153	4066995	5	11
37203783	4048171	3	3
44363553	1551192	2	3
44778007	933724	0	0
44360658	975125	0	0
45643855	1125315	0	0
45621342	1115008	0	0
45634620	1125315	0	0
45662966	1119510	0	0
45628216	723013	0	0
45668945	1177480	0	0
45666870	40228214	2	3
45676918	715997	0	0
45692716	1125315	0	0
45705491	40223768	2	3
45688194	19008572	2	3
45700327	1149196	0	0
45700363	1115008	0	0
45798300	19133905	2	3
45793140	967823	0	0
46238830	1119510	0	0
45682220	1125315	0	0
46241412	1125315	0	0
46299553	1119510	0	0
46315997	1129625	0	0
46308647	19008572	2	3
1580860	1115008	0	0
4042641	40492359	5	5
4322976	4186930	4	8
21001848	1717327	0	0
21604489	19076374	3	6
21604034	1177480	3	3
36151472	1119510	0	0
36303153	198809	5	11
37219939	258780	3	3
44363982	19008572	2	3
44778120	1129625	0	0
44360604	1112807	0	0
45643860	1125315	0	0
45621611	1124300	0	0
45634377	1125315	0	0
45662706	1119510	0	0
45628217	1549786	0	0
45668878	1177480	0	0
45666138	19078461	2	3
45676804	791967	0	0
45692620	1125315	0	0
45781381	19078461	2	3
45688355	19133768	2	3
45700335	1107830	0	0
45700355	967823	0	0
45798300	19133873	2	3
45793106	1174888	0	0
46238831	1119510	0	0
45682000	1125315	0	0
46241481	1125315	0	0
46299396	1119510	0	0
46312011	1129625	0	0
46312357	19126352	2	3
1580939	1501700	0	0
4041285	45769019	5	5
4322976	4107731	4	9
21001874	1551099	0	0
21604489	19078924	3	6
36203055	4001336	3	3
36151424	1119510	0	0
36303153	4043241	4	13
40789521	3036780	3	3
44356620	1127433	2	3
44778130	1729720	0	0
44360606	738818	0	0
45643926	1125315	0	0
45621732	1310149	0	0
45634386	1125315	0	0
45662850	1119510	0	0
45628217	1521369	0	0
45670398	1177480	0	0
45635087	40228214	2	3
45676491	1728416	0	0
45692701	1125315	0	0
45783714	40223768	2	3
45685164	1115171	2	3
45700337	19010482	0	0
45700489	1192710	0	0
45798424	1713671	2	3
45792866	1326303	0	0
46238561	1119510	0	0
45682369	1125315	0	0
46241313	1125315	0	0
46299205	1119510	0	0
46310305	1129625	0	0
46303166	1115171	2	3
1580942	1367571	0	0
4047779	4113008	5	5
4322976	40492359	4	10
21001882	1551099	0	0
21605007	1192710	4	4
36002872	4048171	3	3
36151748	1119510	0	0
36303153	4181917	4	5
40760921	3019550	3	3
44356751	19019273	2	3
44778131	1118084	0	0
44360620	1713332	0	0
45643866	1125315	0	0
45621426	1174888	0	0
45634607	1125315	0	0
45662863	1119510	0	0
45628217	1595799	0	0
45666565	1177480	0	0
45683497	40236446	2	3
45676916	1713332	0	0
45689581	1125315	0	0
45680785	40223768	2	3
45685064	40229134	2	3
45700342	1112807	0	0
45700286	1501700	0	0
45795455	40223834	2	3
45792867	1153428	0	0
46238760	1119510	0	0
45682176	1125315	0	0
46241315	1125315	0	0
46299240	1119510	0	0
46310372	1129625	0	0
45650532	19115351	1	1
1580779	1595799	0	0
4047779	4155034	5	5
4274025	4294548	4	9
21001879	1551099	0	0
21605007	1125443	4	4
36009725	4280726	3	3
36151750	1119510	0	0
36313966	198809	4	10
37203786	28060	2	3
44357096	19073183	2	3
44778030	1501700	0	0
44361161	1307863	0	0
45643928	1125315	0	0
45621323	1551099	0	0
45631284	1125315	0	0
45662974	1119510	0	0
45628224	1110410	0	0
45666596	1177480	0	0
45683504	19019273	2	3
45676805	738818	0	0
45689587	1125315	0	0
45705305	1332419	2	3
45685013	19133768	2	3
45700349	1154343	0	0
45700433	1308738	0	0
45795572	1332419	2	3
45793069	1112807	0	0
46238761	1119510	0	0
45682182	1125315	0	0
46241462	1125315	0	0
46299243	1119510	0	0
46310490	1129625	0	0
45897273	40223774	1	1
1580779	1521369	0	0
4178545	28060	5	5
4274025	378419	4	9
21001876	1149380	0	0
21605007	1119510	4	4
36009725	40486433	3	3
36151546	1119510	0	0
36313966	80180	4	6
37220048	4112343	2	3
44357010	19075001	2	3
44361607	1713332	0	0
44360885	738818	0	0
45643876	1125315	0	0
45621326	1521369	0	0
45631359	1125315	0	0
45664639	1119510	0	0
45628064	967823	0	0
45666552	1177480	0	0
45685493	40174880	2	3
45676818	1738521	0	0
45689123	1125315	0	0
45686733	19078461	2	3
45685222	19077572	2	3
45700467	1115008	0	0
45697843	1149196	0	0
45795416	1332419	2	3
45793077	1112807	0	0
46238809	1119510	0	0
45678634	1125315	0	0
46241474	1125315	0	0
46299247	1119510	0	0
46305306	1129625	0	0
46308205	46275916	1	1
1580876	975125	0	0
4178545	40481087	5	5
4274025	381316	4	7
21001871	1551099	0	0
21605007	1150770	4	4
36009869	4048171	3	3
36151591	1119510	0	0
36313966	4296204	6	9
40760921	3023103	2	3
44349779	19008572	2	3
44361327	1115008	0	0
44360890	791967	0	0
45643931	1125315	0	0
45621326	1549786	0	0
45631027	1125315	0	0
45664555	1119510	0	0
45627061	1149196	0	0
45666646	1177480	0	0
45685497	40232448	2	3
45676897	1192710	0	0
45689423	1125315	0	0
45683821	19078461	2	3
45685507	19077572	2	3
45700069	1118084	0	0
45697677	1521369	0	0
45795689	1115171	2	3
45792844	1717327	0	0
46239916	1119510	0	0
45678912	1125315	0	0
46241321	1125315	0	0
46299522	1119510	0	0
46305126	1129625	0	0
46303372	46275916	1	1
1580880	1115008	0	0
4178545	257012	5	5
4274025	195588	4	8
21001848	1768849	0	0
21605007	1150836	4	4
35902853	198809	3	3
36151592	1119510	0	0
36313966	4230399	6	11
37219945	4051466	2	3
44349794	40229134	2	3
44361611	1343916	0	0
44361077	738818	0	0
45643969	1125315	0	0
45621326	1595799	0	0
45631091	1125315	0	0
45664655	1119510	0	0
45627038	1154343	0	0
45666852	1177480	0	0
45680237	1551192	2	3
45676501	1124300	0	0
45691470	1125315	0	0
45692618	19078461	2	3
45685780	19078924	2	3
45700506	1124300	0	0
45697611	1549786	0	0
45796925	40229134	2	3
45792947	1332418	0	0
45897657	1119510	0	0
45678743	1125315	0	0
46241433	1125315	0	0
46299251	1119510	0	0
46305466	1129625	0	0
46309096	46275916	1	1
1580962	1149196	0	0
4103352	40486433	5	5
4274025	30753	4	8
21001900	1110410	0	0
21605007	1153428	4	4
35909435	198809	3	3
36151683	1119510	0	0
36313966	440448	6	11
36902269	378419	1	3
44349474	19008572	2	3
44361613	1310149	0	0
44361015	1149196	0	0
45643946	1125315	0	0
45621381	1154343	0	0
45631295	1125315	0	0
45664436	1119510	0	0
45627041	708298	0	0
45666805	1177480	0	0
45680090	40229134	2	3
45676880	1149196	0	0
45691621	1125315	0	0
45684135	19078461	2	3
45685718	920334	2	3
45700507	1192710	0	0
45697611	1589505	0	0
45796936	1115171	2	3
45792958	1124300	0	0
45897755	1119510	0	0
45678744	1125315	0	0
46241363	1125315	0	0
46301578	1119510	0	0
46305490	1129625	0	0
46307114	19079524	1	1
1580964	1129625	0	0
4103352	4280726	5	5
4247371	257012	4	6
21001853	1713332	0	0
21605007	1150837	4	7
36202157	4149245	3	4
36151779	1119510	0	0
36313966	4306014	6	7
37502350	4337138	2	4
44349475	40231925	2	3
44361622	738818	0	0
44360828	738818	0	0
45643939	1125315	0	0
45664835	738818	0	0
45631316	1125315	0	0
45663016	1119510	0	0
45627063	1115008	0	0
45664263	1177480	0	0
45680295	40229134	2	3
45676688	1713332	0	0
45691489	1125315	0	0
45686801	19078461	2	3
45685725	19008572	2	3
45700170	1367571	0	0
45697611	19127890	0	0
45797137	1545959	2	3
45793163	1153428	0	0
45897839	1119510	0	0
45678746	1125315	0	0
46241339	1125315	0	0
46301581	1119510	0	0
46306699	1129625	0	0
44361246	1125315	0	0
1580906	1539403	0	0
4043017	4337138	5	5
4247371	40481087	4	6
21001888	1738521	0	0
21605007	19029476	4	7
36000000	80809	3	4
36151852	1119510	0	0
36313966	4048169	6	7
42888893	40480160	4	4
44349976	40232448	2	3
44361601	1729720	0	0
44360833	1112807	0	0
45643891	1125315	0	0
45664898	723013	0	0
45633925	1125315	0	0
45659787	1119510	0	0
45627045	791967	0	0
45664204	1177480	0	0
45680380	1115171	2	3
45676688	1759842	0	0
45691606	1125315	0	0
45654841	19078461	2	3
45685731	40174880	2	3
45700257	1326303	0	0
45697809	1124300	0	0
45792994	40162522	2	3
45793166	1174888	0	0
45897866	1119510	0	0
45699779	46275916	1	1
46241341	1125315	0	0
46295371	1119510	0	0
46321686	1129625	0	0
44361247	1125315	0	0
1580916	1367571	0	0
4043018	4242997	5	5
4326426	4336464	4	6
21001890	1728416	0	0
21605007	19125062	4	7
35702761	4285898	3	4
36198912	1119510	0	0
36313966	4296205	6	6
37522278	4043071	4	4
44350088	40229134	2	3
44361502	1545958	0	0
44360629	1129625	0	0
45643912	1125315	0	0
45664909	1107830	0	0
45633899	1125315	0	0
45659599	1119510	0	0
45627083	1778162	0	0
45664534	1177480	0	0
45680407	19073188	2	3
45676769	791967	0	0
45691610	1125315	0	0
45686865	19078461	2	3
45685733	1551192	2	3
45700422	1112807	0	0
45697811	1115008	0	0
45792995	46233710	2	3
45793068	1110410	0	0
45897734	1119510	0	0
45688630	46275916	1	1
46241348	1125315	0	0
46295741	1119510	0	0
46321698	1129625	0	0
44361249	1125315	0	0
1580813	1361711	0	0
4180628	380378	5	5
4297090	4202451	3	6
21001891	1728416	0	0
21605007	43012036	4	7
35702778	81893	3	4
36198916	1119510	0	0
36313966	433125	7	7
37103722	4116491	3	4
44350077	19078461	2	3
44361508	1713332	0	0
44360630	1115008	0	0
45644067	1125315	0	0
45664878	1326303	0	0
45633823	1125315	0	0
45659534	1119510	0	0
45627071	1501700	0	0
45660971	1177480	0	0
45680392	19075601	2	3
45677048	1153428	0	0
45691613	1125315	0	0
45783725	19078461	2	3
45682153	1332419	2	3
45896815	1549786	0	0
45697774	967823	0	0
45793001	19133905	2	3
45793061	1149196	0	0
45897821	1119510	0	0
45694031	46275916	1	1
46241404	1125315	0	0
46296037	1119510	0	0
46321871	1129625	0	0
45650724	1125315	0	0
1580821	1154343	0	0
4180628	4144583	5	5
4297090	4015189	3	6
21001920	1154343	0	0
21605007	40223834	4	7
36203056	4142905	3	4
36159654	1119510	0	0
36313966	433644	7	8
42888893	4066995	3	4
44349839	40162522	2	3
44361627	1124300	0	0
44361039	1174888	0	0
45644070	1125315	0	0
45664934	738818	0	0
45633901	1125315	0	0
45659490	1119510	0	0
45627072	1149196	0	0
45661437	1177480	0	0
45680484	1115171	2	3
45676953	1174888	0	0
45691661	1125315	0	0
45701779	19078461	2	3
45682101	19008572	2	3
45896815	1521369	0	0
45697682	1713332	0	0
45793005	40232448	2	3
45793063	1741122	0	0
45897918	1119510	0	0
45706039	19079524	1	1
46241359	1125315	0	0
46296052	1119510	0	0
46315738	1129625	0	0
45650541	1125315	0	0
1580827	914335	0	0
4028071	260139	5	5
4208786	81151	3	6
21001922	1137529	0	0
21605007	40223821	4	7
35702767	4310024	3	4
36198892	1119510	0	0
36313966	4219399	7	8
37219970	4329847	3	4
44350150	40231925	2	3
44362743	1521369	0	0
44361041	1521369	0	0
45643915	1125315	0	0
45665008	1154029	0	0
45633842	1125315	0	0
45659493	1119510	0	0
45627055	1153428	0	0
45661644	1177480	0	0
45680497	19133768	2	3
45676954	1124300	0	0
45691624	1125315	0	0
45680590	19078461	2	3
45682106	1545959	2	3
45896820	1174888	0	0
45697798	1124300	0	0
45792852	1127433	2	3
45793063	1746114	0	0
45897764	1119510	0	0
45700603	19079524	1	1
46241446	1125315	0	0
46296246	1119510	0	0
46316286	1129625	0	0
45650281	1125315	0	0
1580830	1124300	0	0
4028071	196456	5	5
4274025	44782520	3	6
21001922	1154343	0	0
21605007	40228214	4	7
35702767	4266809	3	4
36198843	1119510	0	0
36313966	313217	7	12
37220041	4112343	3	4
44342506	40169281	2	3
44362751	1177480	0	0
44361041	1595799	0	0
45644046	1125315	0	0
45665081	1501700	0	0
45633844	1125315	0	0
45659701	1119510	0	0
45623810	1548195	0	0
45661370	1177480	0	0
45680365	1115171	2	3
45676955	1149196	0	0
45689713	1125315	0	0
45684220	19078461	2	3
45682036	19008572	2	3
45896821	1343916	0	0
45696898	920293	0	0
45792853	1115171	2	3
45793065	1713332	0	0
45897853	1119510	0	0
45684832	19127922	1	1
46241547	1125315	0	0
46295685	1119510	0	0
46316357	1129625	0	0
45650836	1125315	0	0
1580838	967823	0	0
4178818	40481087	5	5
4274025	257012	3	8
21001903	1551099	0	0
21605007	40229134	6	7
35702767	30753	3	4
36198941	1119510	0	0
35800000	375671	9	11
37521144	4108705	3	4
44342408	19073183	2	3
44362755	791967	0	0
44361041	1549786	0	0
45644015	1125315	0	0
45665083	1124957	0	0
45633946	1125315	0	0
45659853	1119510	0	0
45623818	1545958	0	0
45661176	1177480	0	0
45680356	19079524	2	3
45676958	738818	0	0
45689719	1125315	0	0
45698685	40174880	2	3
45682118	1127433	2	3
45896900	1713332	0	0
45696939	1192710	0	0
45793134	1115171	2	3
45793065	1759842	0	0
45897958	1119510	0	0
45684832	19133679	1	1
46241548	1125315	0	0
46295602	1119510	0	0
46316368	1129625	0	0
45650733	1125315	0	0
1580844	1332418	0	0
4178818	255848	5	5
4247371	4283893	3	5
21001877	1154343	0	0
21605007	40162522	6	7
21602819	1713671	3	4
36198946	1119510	0	0
35800000	257012	8	10
37102306	45769019	3	4
44342414	46275916	2	3
44362758	1177480	0	0
44361043	1512674	0	0
45644096	1125315	0	0
45664881	1115008	0	0
45631382	1125315	0	0
45659935	1119510	0	0
45623924	1310149	0	0
45661267	1177480	0	0
45680685	40228230	2	3
45676961	1310149	0	0
45689702	1125315	0	0
45686915	19078461	2	3
45682277	1127433	2	3
45896869	1107830	0	0
45696961	1367571	0	0
45792839	40232448	2	3
45793081	975125	0	0
45897960	1119510	0	0
45684832	19129144	1	1
46241495	1125315	0	0
46296425	1119510	0	0
46316062	1129625	0	0
45650736	1125315	0	0
1580847	1332418	0	0
4178818	257012	5	5
4208786	40480160	3	5
21001883	1728416	0	0
21605007	40232448	6	7
21602819	46275444	3	4
36198983	1119510	0	0
35800000	4132546	7	9
40760929	3023103	3	4
44342518	1127433	2	3
44362793	1177480	0	0
44361043	1549786	0	0
45644225	1125315	0	0
45664886	1551099	0	0
45631424	1125315	0	0
45656923	1119510	0	0
45623690	740275	0	0
45661278	1177480	0	0
45677086	19008572	2	3
45676964	1124957	0	0
45689703	1125315	0	0
45690050	19078461	2	3
45682251	19073183	2	3
45896851	1118084	0	0
45696942	1713332	0	0
45793203	40223768	2	3
45793209	1107830	0	0
45897990	1119510	0	0
45681820	19089061	1	1
46241517	1125315	0	0
46291237	1119510	0	0
46316660	1129625	0	0
45650467	1125315	0	0
1580955	715997	0	0
4043022	42535580	5	5
4269838	4108705	3	5
21001935	967823	0	0
21605007	19133768	6	7
21602627	40236824	3	6
36151812	1119510	0	0
35800000	40486433	6	11
37522308	4336464	3	4
44342551	40228230	2	3
44362796	1112807	0	0
44361044	933724	0	0
45644232	1125315	0	0
45664940	1153428	0	0
45631505	1125315	0	0
45656693	1119510	0	0
45623945	1115008	0	0
45654781	1177480	0	0
45677007	19019273	2	3
45676965	1501700	0	0
45689797	1125315	0	0
45701855	19078461	2	3
45682198	19019273	2	3
45896908	1112807	0	0
45696912	1192710	0	0
45792956	40232448	2	3
45793241	1549786	0	0
45897932	1119510	0	0
45672770	19074679	1	1
46241450	1125315	0	0
46291135	1119510	0	0
46316182	1129625	0	0
45650764	1125315	0	0
1588689	1512674	0	0
4043022	4323902	5	5
21500563	40223768	3	4
21001900	914335	0	0
21604180	40236446	4	7
36203062	4296204	3	6
36151819	1119510	0	0
35800000	4280726	6	11
37219945	441267	3	4
44342541	19019273	2	3
44362799	1129625	0	0
44361048	1129625	0	0
45641216	1125315	0	0
45664849	1717327	0	0
45631662	1125315	0	0
45656695	1119510	0	0
45624068	1174888	0	0
45634974	1129625	0	0
45679392	40223768	2	3
45677019	1539403	0	0
45689765	1125315	0	0
45699093	19078461	2	3
45682465	19018935	2	3
45697106	975125	0	0
45696962	791967	0	0
45793163	40223834	2	3
45793223	1713332	0	0
45895500	1119510	0	0
45772679	4304110	1	1
46241571	1125315	0	0
46291136	1119510	0	0
46316188	1129625	0	0
45650812	1125315	0	0
1589505	1589505	0	0
4274025	80180	3	5
21500563	836659	3	4
21001909	1551099	0	0
21604180	782047	4	7
35702738	4027663	3	6
36151803	1119510	0	0
35800000	4285898	6	9
37622411	317576	3	4
44342707	19133873	2	3
44362608	1322184	0	0
44361059	1149380	0	0
45640901	1125315	0	0
45665090	705944	0	0
45631665	1125315	0	0
45656700	1119510	0	0
45624072	1192710	0	0
45634895	1129625	0	0
45677173	35605482	2	3
45676941	738818	0	0
45689731	1125315	0	0
45680703	19078461	2	3
45678937	19125062	2	3
45697088	1149196	0	0
45696989	1154343	0	0
45793166	40162522	2	3
45793223	1759842	0	0
45895463	1119510	0	0
45703785	19079524	1	1
46241574	1125315	0	0
46291137	1119510	0	0
46310688	1129625	0	0
45650823	1125315	0	0
1367571	1367571	0	0
4274025	4066995	3	9
21500563	40222846	3	4
21001853	1759842	0	0
21604180	40222846	4	7
36100000	260139	3	5
36151719	1119510	0	0
35800000	4043241	11	12
37622411	4329847	3	4
43531392	4238715	2	3
45619689	1119510	0	0
44360755	1192710	0	0
45641227	1125315	0	0
45665092	1310149	0	0
45631384	1125315	0	0
45656710	1119510	0	0
45623806	1778162	0	0
45635051	1129625	0	0
45677144	1127433	2	3
45677094	19010482	0	0
45689842	1125315	0	0
45692532	19078461	2	3
45678867	43012036	2	3
45697096	1149380	0	0
45697008	1154029	0	0
45793215	40232448	2	3
45793241	1521369	0	0
45895536	1119510	0	0
45697864	46275916	1	1
46241453	1125315	0	0
46291142	1119510	0	0
46305655	1129625	0	0
45650683	1125315	0	0
1110410	1110410	0	0
4274025	40480160	3	9
21500563	19077572	3	4
21001875	1551099	0	0
21604180	40231925	6	7
36203062	4142905	3	8
36151828	1119510	0	0
36427861	1551099	0	0
37520685	44783196	4	4
44784217	313217	2	3
45619693	1119510	0	0
44361016	1124300	0	0
45641012	1125315	0	0
45665097	1124957	0	0
45631434	1125315	0	0
45657079	1119510	0	0
45623843	738818	0	0
45635203	1129625	0	0
45677200	19018935	2	3
45676979	1309944	0	0
45689750	1125315	0	0
45671665	19078461	2	3
45678920	19078461	2	3
45697213	1595799	0	0
45696934	1361711	0	0
45793341	1107882	2	3
45793341	1107830	0	0
45895542	1119510	0	0
45697465	46275916	1	1
46241613	1125315	0	0
46290922	1119510	0	0
46305736	1129625	0	0
45675332	1125315	0	0
1107830	1107830	0	0
4274025	4027663	3	7
4297887	4166224	3	4
21001882	975125	0	0
21604180	19133768	6	7
36206173	3023430	3	7
36151944	1119510	0	0
36427938	753626	0	0
37520685	4301346	4	4
44359490	46275444	2	3
45621961	1119510	0	0
44361018	1738521	0	0
45641116	1125315	0	0
45665016	1539403	0	0
45631403	1125315	0	0
45657228	1119510	0	0
45623773	1174888	0	0
45630137	1129625	0	0
45674081	40243436	2	3
45676708	1557272	0	0
45689708	1125315	0	0
45670042	19078461	2	3
45678949	1519937	2	3
45697208	740275	0	0
45696944	1557272	0	0
45793186	19059056	2	3
45792919	791967	0	0
45896696	1119510	0	0
45691219	46275916	1	1
46241616	1125315	0	0
46291152	1119510	0	0
46305749	1129625	0	0
45675600	1125315	0	0
1129625	1129625	0	0
4274025	4283893	4	7
19127890	19128022	3	4
21001924	1713332	0	0
21604180	705944	4	4
36206173	3019550	3	7
36151659	1119510	0	0
36426679	705944	0	0
37502350	4323902	2	5
44359501	19078461	2	3
45621608	1119510	0	0
44361021	19127890	0	0
45640912	1125315	0	0
45665107	1153428	0	0
45631550	1125315	0	0
45657271	1119510	0	0
45623916	1551099	0	0
45630142	1129625	0	0
45674099	40232448	2	3
45677062	791967	0	0
45690003	1125315	0	0
45708265	19078461	2	3
45679370	35605482	2	3
45697109	1107830	0	0
45696949	975125	0	0
45792081	1127433	2	3
45793328	1548195	0	0
45896731	1119510	0	0
45688055	46275916	1	1
46241597	1125315	0	0
46291201	1119510	0	0
46305791	1129625	0	0
45675484	1125315	0	0
964261	964261	0	0
4274025	4056621	4	7
19127890	19128263	3	4
21001947	1728416	0	0
21604180	1154029	4	4
36206173	3023103	3	7
36152085	1119510	0	0
36426867	1115008	0	0
37219945	4283893	2	5
44359502	40223834	2	3
45621671	1119510	0	0
44361021	1589505	0	0
45641017	1125315	0	0
45664861	1343916	0	0
45628426	1125315	0	0
45653557	1119510	0	0
45623956	1332418	0	0
45630078	1129625	0	0
45674218	1551192	2	3
45677116	1595799	0	0
45689920	1125315	0	0
45702220	19078461	2	3
45702986	1551192	2	3
45697118	1343916	0	0
45696919	1551099	0	0
45791978	40229134	2	3
45793411	1192710	0	0
45679532	1125315	0	0
45681900	46275916	1	1
46241600	1125315	0	0
46244837	1119510	0	0
46306021	1129625	0	0
45675445	1125315	0	0
701322	701322	0	0
4274025	261325	4	9
19127890	19128065	3	4
21001947	1738521	0	0
21604180	1112807	4	4
36206173	3014599	3	7
36151769	1119510	0	0
36424218	723013	0	0
37521375	4330583	5	5
44359764	43012036	2	3
45621977	1119510	0	0
44361021	1549786	0	0
45641132	1125315	0	0
45665059	19010482	0	0
45628140	1125315	0	0
45653560	1119510	0	0
45623977	1713332	0	0
45630019	1129625	0	0
45674000	19019273	2	3
45676534	914335	0	0
45690010	1125315	0	0
45698861	19078461	2	3
45685734	19019273	2	3
45697350	1149196	0	0
45696921	1153428	0	0
45791963	19078924	2	3
45793186	1112807	0	0
45679720	1125315	0	0
45682158	46275916	1	1
46241604	1125315	0	0
46244971	1119510	0	0
46306043	1129625	0	0
45675617	1125315	0	0
705944	705944	0	0
4274025	4285898	4	11
19127890	19127918	3	4
21001924	1746114	0	0
21604180	1110410	4	4
36206173	3004501	3	6
36151834	1119510	0	0
36424226	1124300	0	0
37502350	4337611	3	5
44359705	1115171	2	3
45619802	1119510	0	0
44341366	1551099	0	0
45641134	1125315	0	0
45665112	1124300	0	0
45628146	1125315	0	0
45653429	1119510	0	0
45623680	1153428	0	0
45629950	1129625	0	0
45674114	40163554	2	3
45676535	1551099	0	0
45689678	1125315	0	0
45779139	19078461	2	3
45691089	19019273	2	3
45697220	1361711	0	0
45696926	1192710	0	0
45790256	1127433	2	3
45793334	1112807	0	0
45679463	1125315	0	0
45697095	46275916	1	1
46241673	1125315	0	0
46239873	1119510	0	0
46322078	1129625	0	0
45675624	1125315	0	0
708298	708298	0	0
4274025	4029498	4	6
19127890	19127904	3	4
21001879	975125	0	0
21604180	19016749	4	4
36206173	3027231	3	6
36152244	1119510	0	0
36424236	19054876	0	0
37203786	4112343	3	5
44355625	1551192	2	3
45619818	1119510	0	0
44341455	1177480	0	0
45641137	1125315	0	0
45665216	1713332	0	0
45628148	1125315	0	0
45653224	1119510	0	0
45623682	1124957	0	0
45630389	1129625	0	0
45673771	40174880	2	3
45677117	1174888	0	0
45689876	1125315	0	0
45690195	19078461	2	3
45682043	19078924	2	3
45697223	1174888	0	0
45697017	1729720	0	0
45790707	40232448	2	3
45792132	1112807	0	0
45679471	1125315	0	0
45672407	46275916	1	1
46241526	1125315	0	0
46239963	1119510	0	0
46322290	1129625	0	0
45675708	1125315	0	0
438614	438614	0	0
4274025	372328	4	6
4208786	4146173	3	4
21001880	1728416	0	0
21602795	920334	4	7
36206173	3006906	3	6
36152252	1119510	0	0
36424373	1738521	0	0
36902269	4043241	3	5
44356160	1127433	2	3
45619806	1119510	0	0
44341337	1112807	0	0
45641145	1125315	0	0
45665218	1110410	0	0
45628536	1125315	0	0
45653650	1119510	0	0
45623686	1107830	0	0
45627143	1129625	0	0
45673934	40232448	2	3
45673493	1551099	0	0
45689935	1125315	0	0
45781836	19078461	2	3
45694148	19078924	2	3
45697425	914335	0	0
45696976	1149380	0	0
45790364	35605482	2	3
45792079	1367571	0	0
45679009	1125315	0	0
45706243	46275916	1	1
46241529	1125315	0	0
46240119	1119510	0	0
46322627	1129625	0	0
45675723	1125315	0	0
3020630	3020630	0	0
4274025	4218389	4	6
21500578	1127433	3	4
21600886	967823	0	0
21602795	19074843	4	7
36206173	3006734	3	6
36152253	1119510	0	0
36425373	1367571	0	0
37502344	4163971	3	5
44352661	19133873	2	3
44361376	1119510	0	0
44341459	1149380	0	0
45641253	1125315	0	0
45665226	1107830	0	0
45628668	1125315	0	0
45653700	1119510	0	0
45623966	1115008	0	0
45627185	1129625	0	0
45674263	40232448	2	3
45673485	1118084	0	0
45689686	1125315	0	0
45693201	19078461	2	3
45684751	46233988	2	3
45697430	1310149	0	0
45696892	1192710	0	0
45790335	19008572	2	3
45791842	1112807	0	0
45678963	1125315	0	0
45687774	19079524	1	1
46238757	1125315	0	0
46240122	1119510	0	0
46322080	1129625	0	0
45675589	1125315	0	0
3020655	3020655	0	0
4274025	4174876	4	5
4209223	4285898	3	3
21600270	1309944	0	0
21602795	19073183	4	7
36206173	3012494	3	6
36152417	1119510	0	0
36424390	1512674	0	0
37219945	40481087	3	6
44352838	40236824	2	3
44361542	1119510	0	0
44341460	1153428	0	0
45641299	1125315	0	0
45665131	1500211	0	0
45628512	1125315	0	0
45653686	1119510	0	0
45623969	967823	0	0
45627314	1129625	0	0
45674269	40223834	2	3
45673431	738818	0	0
45689632	1125315	0	0
45781663	40223768	2	3
45684751	46233710	2	3
45697433	1549786	0	0
45696894	1343916	0	0
45790307	1127433	2	3
45791943	1124300	0	0
45679086	1125315	0	0
45703204	19079524	1	1
46238758	1125315	0	0
45896629	1119510	0	0
46317129	1129625	0	0
45896982	1125315	0	0
3036780	3036780	0	0
4274025	140673	4	5
4300157	4146173	3	3
21600303	1343916	0	0
21602795	19133905	4	7
36206173	3027970	3	6
36152093	1119510	0	0
36416551	80502	0	0
37219945	28060	3	6
44352844	1115171	2	3
44361669	1119510	0	0
44341510	1589505	0	0
45641300	1125315	0	0
45664958	715997	0	0
45628305	1125315	0	0
45653243	1119510	0	0
45623980	967823	0	0
45627215	1129625	0	0
45674269	40223821	2	3
45673433	1717327	0	0
45689866	1125315	0	0
45690150	1332419	2	3
45705161	40174880	2	3
45697433	19127890	0	0
45697022	715997	0	0
45790539	1115171	2	3
45791952	1367571	0	0
45679152	1125315	0	0
45682685	19079524	1	1
46238459	1125315	0	0
45896592	1119510	0	0
46317147	1129625	0	0
45897039	1125315	0	0
3035995	3035995	0	0
4274025	317009	4	4
21600600	975125	3	3
21503381	1124300	0	0
21602795	46275444	5	7
36206173	3001247	3	6
36152238	1119510	0	0
36311902	4163951	0	0
37502342	4108705	3	6
44352826	40229134	2	3
44361702	1119510	0	0
44341510	1549786	0	0
45641260	1125315	0	0
45665145	1729720	0	0
45628307	1125315	0	0
45653823	1119510	0	0
45624062	1521369	0	0
45627543	1129625	0	0
45674358	1115171	2	3
45673605	1551099	0	0
45686767	1125315	0	0
45692888	1332419	2	3
45697682	19073183	2	3
45697433	1512674	0	0
45697026	1110410	0	0
45790606	40229134	2	3
45791963	708298	0	0
45679166	1125315	0	0
45678766	19079524	1	1
46238795	1125315	0	0
45896485	1119510	0	0
46317296	1129625	0	0
45896953	1125315	0	0
1112807	1112807	0	0
4274025	4094814	4	4
4212076	4230399	3	3
21503428	967823	0	0
21602795	1713671	6	7
36206173	3006451	3	5
36152068	1119510	0	0
36222374	40223834	1	2
37303796	134438	3	6
44353215	43012036	2	3
44360954	1119510	0	0
44341510	19127890	0	0
45641244	1125315	0	0
45665240	738818	0	0
45628355	1125315	0	0
45653826	1119510	0	0
45624062	1549786	0	0
45623901	1129625	0	0
45674049	1551192	2	3
45673519	1307863	0	0
45686780	1125315	0	0
45699090	1332419	2	3
45697682	19073188	2	3
45697436	1192710	0	0
45696999	933724	0	0
45787560	40231925	2	3
45791986	1361711	0	0
45679167	1125315	0	0
45682620	19079524	1	1
46238796	1125315	0	0
45896497	1119510	0	0
46311273	1129625	0	0
45897050	1125315	0	0
1115171	1115171	0	0
4274025	4139681	5	6
4324765	40479422	3	3
21503515	1308738	0	0
35200000	4112343	7	11
36217214	19128009	3	4
36152171	1119510	0	0
36222374	40223821	1	2
37302322	4296204	6	6
44352869	19008572	2	3
44361677	1119510	0	0
44341513	1115008	0	0
45642972	1125315	0	0
45665285	1551099	0	0
45628631	1125315	0	0
45653703	1119510	0	0
45624062	1595799	0	0
45625214	1129625	0	0
45674184	19078924	2	3
45673522	1310149	0	0
45686455	1125315	0	0
45705480	1332419	2	3
45703693	19078461	2	3
45697439	1107830	0	0
45697005	1107830	0	0
45787569	40165015	2	3
45790262	1107830	0	0
45678970	1125315	0	0
45703025	19079524	1	1
46238546	1125315	0	0
45896679	1119510	0	0
46311614	1129625	0	0
45897054	1125315	0	0
1115008	1115008	0	0
4274025	4169137	5	6
4324765	40479768	3	3
21500772	1308738	0	0
35200000	258780	8	11
36217214	19133679	3	4
36152214	1119510	0	0
36226418	19023398	1	2
37219945	257012	2	6
44353015	40222846	2	3
44361107	1119510	0	0
44341540	1129625	0	0
45642913	1125315	0	0
45665347	791967	0	0
45628728	1125315	0	0
45653745	1119510	0	0
45624063	1738521	0	0
45625248	1129625	0	0
45674349	40232448	2	3
45673527	1343916	0	0
45686866	1125315	0	0
45671544	40174880	2	3
45700363	19019273	2	3
45697440	1153428	0	0
45697077	1000560	0	0
45787668	1551192	2	3
45790241	967823	0	0
45679026	1125315	0	0
45690718	19079524	1	1
46238567	1125315	0	0
45896682	1119510	0	0
46311348	1129625	0	0
45897099	1125315	0	0
1119510	1119510	0	0
4274025	4001336	5	9
4229909	4280726	3	3
21500753	967823	0	0
35200000	4048171	8	11
36216998	1127078	1	2
36151987	1119510	0	0
36226326	19007333	1	2
37502350	4336464	6	7
44352915	1115171	2	3
44361270	1119510	0	0
44341549	1124300	0	0
45642931	1125315	0	0
45665256	1115008	0	0
45625164	1125315	0	0
45653767	1119510	0	0
45624088	1115008	0	0
45624217	1129625	0	0
45673889	19078924	2	3
45673530	1759842	0	0
45686677	1125315	0	0
45684043	1545959	2	3
45779682	1332419	2	3
45697120	1192710	0	0
45697033	1332418	0	0
45787625	40223834	2	3
45790265	1551099	0	0
45679129	1125315	0	0
45690718	46275916	1	1
46238826	1125315	0	0
45896686	1119510	0	0
46311827	1129625	0	0
45896922	1125315	0	0
1118084	1118084	0	0
4274025	4142905	5	9
4229909	40486433	3	3
21500754	967823	0	0
35200000	261325	7	10
36216998	1127433	1	2
36155101	1125315	0	0
36226327	19007333	1	2
37302322	133834	7	7
44349135	40231925	2	3
44361277	1119510	0	0
44338318	1119510	0	0
45643080	1125315	0	0
45662516	1149196	0	0
45625348	1125315	0	0
45650225	1119510	0	0
45623800	738818	0	0
45624355	1129625	0	0
45673896	19008572	2	3
45673530	1713332	0	0
45686615	1125315	0	0
45654931	1545959	2	3
45687962	19073183	2	3
45697261	1107830	0	0
45697048	1154343	0	0
45787629	40162522	2	3
45790369	1124300	0	0
45786006	1125315	0	0
45678625	46275916	1	1
46238828	1125315	0	0
45896554	1119510	0	0
46319315	1129625	0	0
45896969	1125315	0	0
1124957	1124957	0	0
4274025	40481087	5	8
21500543	738818	3	3
21500755	967823	0	0
35200000	40486433	7	10
36217055	19073188	1	2
36155158	1125315	0	0
36225011	19126352	1	2
37302323	134438	2	7
44349060	40231925	2	3
44361283	1119510	0	0
44338327	1119510	0	0
45642921	1125315	0	0
45662524	738818	0	0
45625329	1125315	0	0
45650165	1119510	0	0
45624096	1110410	0	0
45624381	1129625	0	0
45671085	1115171	2	3
45673531	1154029	0	0
45686624	1125315	0	0
45677434	1545959	2	3
45696942	19073183	2	3
45697396	967823	0	0
45697049	975125	0	0
45789173	19077572	2	3
45790280	1521369	0	0
45785847	1125315	0	0
45693774	46275916	1	1
46238829	1125315	0	0
45896510	1119510	0	0
46319734	1129625	0	0
45897000	1125315	0	0
4024289	4024289	0	0
4274025	28060	5	8
21500543	1129625	3	3
21500781	1308738	0	0
35200000	4294548	7	10
36217055	19073183	1	2
36154754	1125315	0	0
36215488	19019273	1	2
37502345	4330583	2	7
44348801	19019273	2	3
44361690	1119510	0	0
44338462	1119510	0	0
45643799	1125315	0	0
45662642	1322184	0	0
45625378	1125315	0	0
45650138	1119510	0	0
45623601	1192710	0	0
45624288	1129625	0	0
45671253	1115171	2	3
45673447	1149196	0	0
45686647	1125315	0	0
45694627	1539411	2	3
46240144	40173590	2	3
45697403	1307863	0	0
45697130	1501700	0	0
45789305	40231925	2	3
45790280	1549786	0	0
45785848	1125315	0	0
45693774	19079524	1	1
46238830	1125315	0	0
45894365	1119510	0	0
46313410	1119510	0	0
45897002	1125315	0	0
3005136	3005136	0	0
4274025	81151	5	10
4247371	4029498	3	3
21500782	1125315	0	0
35200000	260139	7	10
36216999	1127433	1	2
36154755	1125315	0	0
36215488	1115171	1	2
37502341	4198190	2	7
44351751	40162522	2	3
44360968	1119510	0	0
44338280	1119510	0	0
45641319	1125315	0	0
45662384	1305058	0	0
45625285	1125315	0	0
45650385	1119510	0	0
45623867	1521369	0	0
45624229	1129625	0	0
45671106	40163554	2	3
45673535	1521369	0	0
45686661	1125315	0	0
45681408	19079524	1	1
45684534	1332419	2	3
45697265	1000560	0	0
45697065	1149196	0	0
45789310	1115171	2	3
45790364	1000560	0	0
45786031	1125315	0	0
45673399	19079524	1	1
46238831	1125315	0	0
45894424	1119510	0	0
46313307	1119510	0	0
45897005	1125315	0	0
3006322	3006322	0	0
4274025	258780	5	10
4297887	28060	3	3
21500785	1595799	0	0
35200000	4280726	6	10
36216999	1127078	1	2
36154756	1125315	0	0
36222613	46275916	1	2
37219945	4294548	2	7
44349254	19008572	2	3
44361476	1119510	0	0
44338521	1119510	0	0
45641362	1125315	0	0
45662482	1124957	0	0
45625290	1125315	0	0
45650547	1119510	0	0
45623867	1549786	0	0
45668238	1129625	0	0
45671190	1127433	2	3
45673535	1549786	0	0
45686738	1125315	0	0
45678261	19079524	1	1
45693754	19073183	2	3
45697166	715997	0	0
45697232	1174888	0	0
45787825	1115171	2	3
45790366	1551099	0	0
45786036	1125315	0	0
45684685	19079524	1	1
46238561	1125315	0	0
45894511	1119510	0	0
46313437	1119510	0	0
45897136	1125315	0	0
3006451	3006451	0	0
4274025	4051466	5	5
4297887	196456	3	3
21500785	1396131	0	0
35200000	4283893	7	8
36217056	19073183	1	2
36154677	1125315	0	0
36222613	1594382	1	2
37219945	4280726	2	7
44349296	40236824	2	3
44361347	1119510	0	0
44338482	1119510	0	0
45641374	1125315	0	0
45662488	1107830	0	0
45625293	1125315	0	0
45650245	1119510	0	0
45623868	967823	0	0
45668422	1129625	0	0
45671144	40236824	2	3
45673538	738818	0	0
45686846	1125315	0	0
45675288	19079524	1	1
45672870	19073183	2	3
45697285	1308738	0	0
45697238	1174888	0	0
45787845	43012433	2	3
45790335	975125	0	0
45786543	1125315	0	0
45706694	19079524	1	1
46238640	1125315	0	0
45799942	1119510	0	0
46313457	1119510	0	0
45897083	1125315	0	0
3000876	3000876	0	0
4274025	4296205	5	5
4297090	4181917	3	3
21500785	1308738	0	0
35200000	257012	6	9
36216121	40162522	1	2
36154684	1125315	0	0
36215489	19019273	1	2
37219945	261325	3	7
44349317	1115171	2	3
44361306	1119510	0	0
44338484	1119510	0	0
45638136	1125315	0	0
45662581	967823	0	0
45625272	1125315	0	0
45650450	1119510	0	0
45623984	1308738	0	0
45668633	1129625	0	0
45671504	40232448	2	3
45673546	1713332	0	0
45686985	1125315	0	0
45678149	46275916	1	1
45699994	19073183	2	3
45697408	1154343	0	0
45697304	975125	0	0
45787871	40229134	2	3
45790291	1112807	0	0
45786544	1125315	0	0
45682084	19079524	1	1
46238617	1125315	0	0
46317845	1119510	0	0
46314235	1119510	0	0
45897086	1125315	0	0
3000963	3000963	0	0
4274025	78272	5	11
4297090	4151422	3	3
21500767	1308738	0	0
35200000	40481087	8	9
36216121	19133768	1	2
36154678	1125315	0	0
36215489	1115171	1	2
37219945	260139	3	7
44345055	40165015	2	3
44360980	1119510	0	0
44338252	1119510	0	0
45638137	1125315	0	0
45662586	1124957	0	0
45625419	1125315	0	0
45647280	1119510	0	0
45623993	1778162	0	0
45668782	1129625	0	0
45671289	40223834	2	3
45673546	1759842	0	0
45686883	1125315	0	0
45678149	19079524	1	1
45687603	40228214	2	3
45697414	1174888	0	0
45697307	1107830	0	0
45786307	40228214	2	3
45790303	1713332	0	0
45786549	1125315	0	0
45678943	19079524	1	1
46238759	1125315	0	0
46318078	1119510	0	0
46314236	1119510	0	0
45897270	1125315	0	0
3008598	3008598	0	0
4274025	4116491	5	7
4297090	4246502	3	3
21500734	1595799	0	0
35200000	28060	8	9
36216122	40162522	1	2
36155047	1125315	0	0
36222254	19075601	1	2
37219945	40486433	3	7
44345231	40174880	2	3
44360985	1119510	0	0
44338619	1119510	0	0
45638120	1125315	0	0
45662592	1110410	0	0
45625728	1125315	0	0
45647266	1119510	0	0
45624055	738818	0	0
45666343	1129625	0	0
45671510	19057271	2	3
45673555	1713332	0	0
45686821	1125315	0	0
45696278	19079524	1	1
45678514	1107882	2	3
45697419	1539403	0	0
45697308	1115008	0	0
45786325	40232448	2	3
45790397	1115008	0	0
45786561	1125315	0	0
45706889	19079524	1	1
46238760	1125315	0	0
46318082	1119510	0	0
46314016	1119510	0	0
45897111	1125315	0	0
1396131	1396131	0	0
4274025	198199	5	7
4297090	4133840	3	3
21500740	1192710	0	0
35200000	255848	7	9
36216122	19133768	1	2
36155128	1125315	0	0
36215522	1154615	1	2
37219945	4112343	2	8
44345154	35605482	2	3
44361480	1119510	0	0
44338234	1119510	0	0
45638151	1125315	0	0
45662282	740275	0	0
45625471	1125315	0	0
45649009	1119510	0	0
45623894	1115008	0	0
45667365	1129625	0	0
45671278	40163554	2	3
45673559	1310149	0	0
45686822	1125315	0	0
45702424	46275916	1	1
45681601	40228214	2	3
45697355	1192710	0	0
45693938	1174888	0	0
45786216	40229134	2	3
45790308	1717327	0	0
45786383	1125315	0	0
45678429	19079524	1	1
46238761	1125315	0	0
46317603	1119510	0	0
46314423	1119510	0	0
45897113	1125315	0	0
1500211	1500211	0	0
4274025	4166224	7	10
21502522	920300	5	6
21500721	1595799	0	0
35202051	28060	7	8
36218152	40228214	1	2
36154806	1125315	0	0
36416551	40480160	1	1
37103722	198199	3	5
44345157	19018935	2	3
44361153	1119510	0	0
44338392	1119510	0	0
45638075	1125315	0	0
45662284	1000560	0	0
45625640	1125315	0	0
45649042	1119510	0	0
45623595	1309944	0	0
45667341	1129625	0	0
45669810	1127433	2	3
45673564	1110410	0	0
45686964	1125315	0	0
45702424	19079524	1	1
45684756	19075001	2	3
45697367	1149196	0	0
45693945	975125	0	0
45786231	40229134	2	3
45790310	920293	0	0
45786134	1125315	0	0
45700672	19079524	1	1
46238809	1125315	0	0
46317825	1119510	0	0
46313627	1119510	0	0
45897292	1125315	0	0
1124300	1124300	0	0
4274025	4134304	7	11
21502522	920334	5	6
21500786	1595799	0	0
35202051	40481087	7	8
36216027	19018935	1	2
36155130	1125315	0	0
36313907	4010253	1	1
37103722	45769019	4	5
44345423	40229134	2	3
44357434	1119510	0	0
44338547	1119510	0	0
45637970	1125315	0	0
45662450	1174888	0	0
45625616	1125315	0	0
45649182	1119510	0	0
45623698	1000560	0	0
45666469	1129625	0	0
45669729	40174880	2	3
45673610	1115008	0	0
45687002	1125315	0	0
45706041	19079524	1	1
45681794	19019273	2	3
45697375	1149380	0	0
45693946	1501700	0	0
45786301	40162522	2	3
45790440	1112807	0	0
45786210	1125315	0	0
45700177	19079524	1	1
46238825	1125315	0	0
46318162	1119510	0	0
46308506	1119510	0	0
45894710	1125315	0	0
1125443	1125443	0	0
4274025	133834	7	9
21500136	40224132	5	6
21500786	1308738	0	0
35202051	255848	6	8
36216028	19018935	1	2
36155136	1125315	0	0
36427861	19089061	1	1
37502353	4337611	6	7
44345380	40232448	2	3
44357408	1119510	0	0
44338534	1119510	0	0
45638057	1125315	0	0
45662497	1115008	0	0
45625603	1125315	0	0
45647404	1119510	0	0
45624112	1308738	0	0
45666362	1129625	0	0
45669826	43012036	2	3
45673533	1000560	0	0
45687015	1125315	0	0
45706041	46275916	1	1
45705081	19078461	2	3
45697646	1149196	0	0
45693879	1343916	0	0
45786313	40231925	2	3
45790539	1115008	0	0
45786122	1125315	0	0
45700112	19079524	1	1
46240078	1125315	0	0
46317860	1119510	0	0
46307889	1119510	0	0
45894756	1125315	0	0
1125315	1125315	0	0
4274025	196456	7	7
21500136	44816277	5	6
21500786	1396131	0	0
35202051	4294548	6	9
36203047	4066995	1	2
36156449	1125315	0	0
36302172	4012477	2	2
37502353	4323902	4	8
44345717	40162522	2	3
44357385	1119510	0	0
44338630	1119510	0	0
45638042	1125315	0	0
45662287	1738521	0	0
45625805	1125315	0	0
45647408	1119510	0	0
45667867	738818	0	0
45664515	1129625	0	0
45669787	19075601	2	3
45673570	1548195	0	0
45687017	1125315	0	0
45678066	19079524	1	1
45681702	1107882	2	3
45697252	1110410	0	0
45693952	1124957	0	0
45786362	40222846	2	3
45790386	705944	0	0
45786166	1125315	0	0
45687815	19079524	1	1
46239916	1125315	0	0
46318139	1119510	0	0
46308409	1119510	0	0
45894760	1125315	0	0
914335	914335	0	0
4274025	4048171	6	10
21500136	1519937	5	6
21500701	1308738	0	0
35202051	40486433	6	9
36002872	4280726	1	2
36151054	1125315	0	0
36402186	80502	2	2
37502353	4197460	4	5
44345497	19018935	2	3
44357502	1119510	0	0
44341207	1119510	0	0
45638165	1125315	0	0
45662401	705944	0	0
45625676	1125315	0	0
45644213	1119510	0	0
45668022	715997	0	0
45663965	1129625	0	0
45670409	40223768	2	3
45673598	1501700	0	0
45686896	1125315	0	0
45702623	19079524	1	1
45672673	40174880	2	3
45697258	1367571	0	0
45693887	757627	0	0
46296886	1115171	2	3
45790668	715997	0	0
45786168	1125315	0	0
45687815	46275916	1	1
46240179	1125315	0	0
46317781	1119510	0	0
46308533	1119510	0	0
45894764	1125315	0	0
442116	442116	0	0
4274025	378001	6	10
21500136	40224805	5	6
21500710	1308738	0	0
35202051	260139	6	9
36153492	19128263	1	2
36150849	1125315	0	0
36312757	42535580	2	2
37502353	4330583	3	10
44345277	19018935	2	3
44357702	1119510	0	0
44359814	1119510	0	0
45638183	1125315	0	0
45662358	1124957	0	0
45625633	1125315	0	0
45644278	1119510	0	0
45667645	1549786	0	0
45664159	1129625	0	0
45670278	1545959	2	3
45673671	1738521	0	0
45686802	1125315	0	0
45702623	46275916	1	1
45783644	1107882	2	3
45697353	1107830	0	0
45693954	1124957	0	0
46296996	40232448	2	3
45790410	1326303	0	0
45786173	1125315	0	0
45706502	19079524	1	1
45897691	1125315	0	0
46318096	1119510	0	0
46308558	1119510	0	0
45894765	1125315	0	0
260131	260139	2	2
4274025	4266809	6	8
4246502	4246502	0	0
21500712	1396131	0	0
35202051	261325	6	9
36216955	1310034	1	2
36150930	1125315	0	0
36313276	439777	2	2
37502353	4337138	5	6
44345298	1127433	2	3
44357703	1119510	0	0
44359850	1119510	0	0
45638382	1125315	0	0
45662554	1154343	0	0
45625751	1125315	0	0
45644342	1119510	0	0
45667645	19127890	0	0
45664163	1129625	0	0
45781244	40232448	2	3
45673674	1332418	0	0
45686809	1125315	0	0
45672266	19079524	1	1
45688177	1107882	2	3
45697508	1501700	0	0
45693671	1137529	0	0
46296817	1107882	2	3
45793271	975125	0	0
45786184	1125315	0	0
45693724	19079524	1	1
45897697	1125315	0	0
46318168	1119510	0	0
46308297	1119510	0	0
45894594	1125315	0	0
256451	258780	2	2
4274025	45769019	6	7
21001192	975125	0	0
21500714	1308738	0	0
35202051	4048171	7	10
35902852	198809	1	2
36150907	1125315	0	0
36402192	140673	2	2
37502353	4108705	5	7
44345312	1713671	2	3
44357529	1119510	0	0
44359725	1119510	0	0
45638262	1125315	0	0
45662314	1326303	0	0
45625758	1125315	0	0
45644345	1119510	0	0
45667645	1589505	0	0
45664002	1129625	0	0
45781372	19008572	2	3
45673621	740275	0	0
45687034	1125315	0	0
45674815	19079524	1	1
45780285	1107882	2	3
45697566	1501700	0	0
45693671	1149380	0	0
46296924	19075001	2	3
45793288	1115008	0	0
45786296	1125315	0	0
45681957	46275916	1	1
45897870	1125315	0	0
46318193	1119510	0	0
46308570	1119510	0	0
45894846	1125315	0	0
4013842	439777	2	2
4274025	433644	6	7
21001125	1551099	0	0
21500721	1308738	0	0
35202051	258780	7	10
35702751	81893	1	2
36150913	1125315	0	0
36502198	4059173	2	4
37300000	4156265	6	6
44345519	40229134	2	3
44357649	1119510	0	0
44359730	1119510	0	0
45638270	1125315	0	0
45662691	1107830	0	0
45625723	1125315	0	0
45644201	1119510	0	0
45667975	914335	0	0
45664109	1129625	0	0
45781226	40174880	2	3
45673622	1124957	0	0
45687035	1125315	0	0
45680024	46275916	1	1
45706834	1107882	2	3
45697288	1000560	0	0
45694083	1192710	0	0
46297079	1127078	2	3
45793113	1107830	0	0
46292667	1125315	0	0
45681957	19079524	1	1
45897657	1125315	0	0
45794483	1119510	0	0
46308311	1119510	0	0
45894859	1125315	0	0
4016263	4134304	2	2
4274025	4240902	6	7
21001125	975125	0	0
21500727	1308738	0	0
35202051	4112343	6	10
21602517	40221415	1	4
36150992	1125315	0	0
36502198	4066995	2	4
37300000	4066995	7	8
44345483	40229134	2	3
44357760	1119510	0	0
44360001	1119510	0	0
45637128	1125315	0	0
45662701	1174888	0	0
45622067	1125315	0	0
45644433	1119510	0	0
45667991	1192710	0	0
45664094	1129625	0	0
45781389	1115171	2	3
45673628	1551099	0	0
45683553	1125315	0	0
45680024	19079524	1	1
45672667	1107882	2	3
45697420	975125	0	0
45693978	1343916	0	0
46293236	19075001	2	3
45793406	791967	0	0
46292737	1125315	0	0
45681721	19079524	1	1
45897665	1125315	0	0
45794403	1119510	0	0
46308750	1119510	0	0
45894888	1125315	0	0
437409	4001336	2	2
4274025	4109685	6	7
21001259	975125	0	0
21013536	1746114	0	0
21602359	19127904	6	8
21602657	40236824	1	4
36150961	1125315	0	0
36502198	4278672	2	4
37300000	4048695	7	8
44345503	40232448	2	3
44357875	1119510	0	0
44359837	1119510	0	0
45637132	1125315	0	0
45662321	1332418	0	0
45622124	1125315	0	0
45644462	1119510	0	0
45667996	967823	0	0
45660997	1129625	0	0
45781625	40229134	2	3
45673629	914335	0	0
45683577	1125315	0	0
45693311	19079524	1	1
46240339	1539411	2	3
45894782	1115008	0	0
45694056	1174888	0	0
46293113	40163554	2	3
45793203	715997	0	0
46292640	1125315	0	0
45681721	46275916	1	1
45897866	1125315	0	0
45794520	1119510	0	0
46308617	1119510	0	0
45894826	1125315	0	0
4015311	4015189	2	2
4274025	37017711	6	7
21001163	1551099	0	0
21013536	1741122	0	0
35202461	258780	6	9
36203055	375671	1	4
36151014	1125315	0	0
36502198	4142905	2	4
37300000	134438	3	8
44341263	46275444	2	3
44357881	1119510	0	0
44360070	1119510	0	0
45634945	1125315	0	0
45662601	1107830	0	0
45622146	1125315	0	0
45644299	1119510	0	0
45668002	1343916	0	0
45660631	1129625	0	0
45781700	1107882	2	3
45673711	914335	0	0
45683708	1125315	0	0
45702280	19079524	1	1
45703946	1107882	2	3
45894875	920293	0	0
45694056	1192710	0	0
46293426	19059056	2	3
45793480	1124957	0	0
46292643	1125315	0	0
45693626	19079524	1	1
45897734	1125315	0	0
46312374	1119510	0	0
46308473	1119510	0	0
45894683	1125315	0	0
4028074	78272	2	2
4274025	81893	6	12
21001267	967823	0	0
21013610	1305058	0	0
35202461	4112343	5	9
36203048	4142905	1	1
36151026	1125315	0	0
36502198	4237458	2	4
37300000	133834	3	10
44341399	1127433	2	3
44357884	1119510	0	0
44360078	1119510	0	0
45634892	1125315	0	0
45662514	738818	0	0
45622164	1125315	0	0
45644396	1119510	0	0
45668004	1110410	0	0
45660886	1129625	0	0
45781590	40232448	2	3
45673879	1367571	0	0
45683709	1125315	0	0
45696317	19079524	1	1
45782356	1332419	2	3
45894821	1107830	0	0
45694062	1153428	0	0
46293290	1551192	2	3
45793439	1192710	0	0
46292672	1125315	0	0
45688159	19079524	1	1
45897821	1125315	0	0
46312108	1119510	0	0
46308669	1119510	0	0
45894755	1125315	0	0
4024567	317009	2	2
4274025	441267	6	6
21001195	975125	0	0
21013645	1308738	0	0
35202461	4280726	4	8
36211378	4218389	1	1
36150766	1125315	0	0
36502199	80180	2	4
37300000	4109685	5	5
44344370	40162522	2	3
44357802	1119510	0	0
44360143	1119510	0	0
45634884	1125315	0	0
45662738	1717327	0	0
45625096	1125315	0	0
45641530	1119510	0	0
45667978	1174888	0	0
45657981	1129625	0	0
45781591	40236824	2	3
45673676	1192710	0	0
45683747	1125315	0	0
45679984	46275916	1	1
45681492	40173590	2	3
45694683	791967	0	0
45694078	1332418	0	0
46293314	1115171	2	3
45793298	1149196	0	0
46292797	1125315	0	0
45672689	46275916	1	1
45897910	1125315	0	0
46312109	1119510	0	0
46308670	1119510	0	0
45894695	1125315	0	0
254068	4283893	2	2
4274025	4113008	6	6
21001138	740275	0	0
21013627	1307863	0	0
35202461	4294548	5	8
36009740	438614	1	1
36151304	1125315	0	0
36302173	4015189	2	6
37300000	4155034	5	5
44344374	40232448	2	3
44353848	1119510	0	0
44359741	1119510	0	0
45634875	1125315	0	0
45662634	1308738	0	0
45624835	1125315	0	0
45641582	1119510	0	0
45667654	1332418	0	0
45657876	1129625	0	0
45778663	40231925	2	3
45673831	1551099	0	0
45683591	1125315	0	0
45679984	19079524	1	1
45688422	40173590	2	3
45694551	1124957	0	0
45694088	1110410	0	0
46296565	40229134	2	3
45793305	791967	0	0
46292821	1125315	0	0
45672689	19079524	1	1
45897874	1125315	0	0
46312329	1119510	0	0
46308714	1119510	0	0
45894699	1125315	0	0
1589542	19127918	2	2
4274025	4155034	6	6
21001258	975125	0	0
21013671	1307863	0	0
35202461	261325	5	8
36009740	4139681	1	1
36151307	1125315	0	0
36517012	81151	2	5
37300000	4113008	5	5
44344603	43012433	2	3
44354163	1119510	0	0
44360174	1119510	0	0
44362725	1119510	0	0
45662772	1551099	0	0
45624954	1125315	0	0
45641419	1119510	0	0
45667731	1713332	0	0
45657881	1129625	0	0
45779017	19008572	2	3
45673651	1557272	0	0
45683602	1125315	0	0
45680158	19079524	1	1
45780450	1332419	2	3
45694447	1759842	0	0
45693673	1361711	0	0
46296805	1115171	2	3
45793389	1154343	0	0
46293071	1125315	0	0
45696932	46275916	1	1
45897915	1125315	0	0
46312520	1119510	0	0
46308692	1119510	0	0
45894711	1125315	0	0
1589542	19128009	2	2
4274025	4278672	6	9
21001205	1343916	0	0
21013671	1326303	0	0
35202461	40486433	5	8
36009740	442116	1	1
36151316	1125315	0	0
36502199	80809	2	5
37300000	4102123	4	4
44341622	40232448	2	3
44355319	1119510	0	0
44359919	1119510	0	0
44361829	1119510	0	0
45662773	19059528	0	0
45622261	1125315	0	0
45641606	1119510	0	0
45667869	1759842	0	0
45658155	1129625	0	0
45778790	40174880	2	3
45673807	1115008	0	0
45683653	1125315	0	0
45675099	46275916	1	1
45703039	19079524	2	3
45694447	1713332	0	0
45693675	1307863	0	0
46296717	19008572	2	3
45793390	1322184	0	0
46292711	1125315	0	0
45696932	19079524	1	1
45897770	1125315	0	0
46312770	1119510	0	0
46312106	1119510	0	0
45894832	1125315	0	0
4010109	4301346	2	2
4274025	4048695	6	9
21001219	914335	0	0
21013658	715997	0	0
35202461	260139	5	8
36009740	4169137	1	1
36151348	1125315	0	0
36302173	4024958	2	5
42805599	1515774	0	0
44341633	46275444	2	3
44355351	1119510	0	0
44360187	1119510	0	0
44361756	1119510	0	0
45662526	1124957	0	0
45622330	1125315	0	0
45641613	1119510	0	0
45667869	1713332	0	0
45658157	1129625	0	0
45779340	43012036	2	3
45673515	701322	0	0
45683714	1125315	0	0
45675099	19079524	1	1
45784616	19075601	2	3
45694453	1110410	0	0
45693757	1115008	0	0
46293520	40162522	2	3
45793375	1124300	0	0
46293009	1125315	0	0
45685128	19079524	1	1
45897846	1125315	0	0
46312661	1119510	0	0
46312152	1119510	0	0
45894768	1125315	0	0
4010109	44783196	2	2
4029205	4293740	4	6
21001228	1124300	0	0
21013543	1307863	0	0
35300000	4144583	8	8
36002872	133834	1	1
36151326	1125315	0	0
36517149	4146173	2	3
42805599	19127890	0	0
44341685	40231925	2	3
44355355	1119510	0	0
44359970	1119510	0	0
44361834	1119510	0	0
45662719	1501700	0	0
45622305	1125315	0	0
45641664	1119510	0	0
45667880	1746114	0	0
45654640	1129625	0	0
45779341	19073183	2	3
45673846	738818	0	0
45683693	1125315	0	0
45699571	46275916	1	1
45678887	19075601	2	3
45694215	1107830	0	0
45693765	1361711	0	0
46293837	19057271	2	3
45793044	1501700	0	0
46292928	1125315	0	0
45690923	19079524	1	1
45897850	1125315	0	0
46312830	1119510	0	0
46312350	1119510	0	0
45894743	1125315	0	0
4028071	198199	3	5
4029205	4202451	4	7
21001149	1551099	0	0
21013671	1309944	0	0
21602754	1501700	0	0
36002869	134438	1	1
36151222	1125315	0	0
36502196	80502	2	3
42805599	1549786	0	0
44341657	19133905	2	3
44355464	1119510	0	0
44360280	1119510	0	0
44361769	1119510	0	0
45662726	1310149	0	0
45622373	1125315	0	0
45641786	1119510	0	0
45667880	1741122	0	0
45654564	1129625	0	0
45779375	1127433	2	3
45673851	1501700	0	0
45683658	1125315	0	0
45699571	19079524	1	1
45706491	19075601	2	3
45694216	975125	0	0
45693850	1153428	0	0
46288885	40229134	2	3
45793308	1192710	0	0
46293047	1125315	0	0
45699839	19079524	1	1
45897852	1125315	0	0
46312831	1119510	0	0
46311838	1119510	0	0
45894817	1125315	0	0
4020346	78272	3	5
4029205	4186930	4	7
21001116	1125315	0	0
21013672	1309944	0	0
21603392	1125443	0	0
36009700	4051466	1	1
36151242	1125315	0	0
36603316	4285898	2	3
42805680	715997	0	0
44341957	920334	2	3
44354286	1119510	0	0
44359901	1119510	0	0
44361966	1119510	0	0
45662775	1729720	0	0
45622558	1125315	0	0
45638247	1119510	0	0
45668007	1738521	0	0
45654657	1129625	0	0
45779165	40232448	2	3
45673954	1115008	0	0
45683734	1125315	0	0
45672521	19079524	1	1
45779671	40228214	2	3
45694194	1174888	0	0
45693766	1149196	0	0
46288900	1115171	2	3
45793310	1115008	0	0
46293048	1125315	0	0
45699964	19079524	1	1
45897960	1125315	0	0
46307057	1119510	0	0
46311915	1119510	0	0
45894818	1125315	0	0
4086181	4132546	3	5
4029205	4295880	4	5
21001248	975125	0	0
21013658	757627	0	0
21603641	1124300	0	0
35702735	441267	1	1
36151102	1125315	0	0
36225034	19127922	2	3
42805555	1177480	0	0
44341736	19133873	2	3
44354369	1119510	0	0
44353281	1119510	0	0
44362295	1119510	0	0
45662629	1124300	0	0
45622318	1125315	0	0
45640079	1119510	0	0
45668011	1308738	0	0
45654658	1129625	0	0
45707637	40228230	2	3
45673958	1149196	0	0
45683770	1125315	0	0
45705632	19079524	1	1
45705259	1539411	2	3
45694303	1174888	0	0
45693856	1332418	0	0
46288644	1115171	2	3
45793228	914335	0	0
46292659	1125315	0	0
45688215	19079524	1	1
45897988	1125315	0	0
46307154	1119510	0	0
46303613	1119510	0	0
45896562	1125315	0	0
4028076	40486433	4	5
4029205	4059978	4	4
21001191	1551099	0	0
21004615	1717327	0	0
21602837	1717327	0	0
36211374	4156265	1	1
36151386	1125315	0	0
36225034	19133679	2	3
42805785	1115008	0	0
44363048	40163554	2	3
44354436	1119510	0	0
44353319	1119510	0	0
44362064	1119510	0	0
45662847	1539403	0	0
45622319	1125315	0	0
45640200	1119510	0	0
45668012	914335	0	0
45654289	1129625	0	0
45707638	1594382	2	3
45673962	1115008	0	0
45683773	1125315	0	0
45706039	46275916	1	1
45684983	19075601	2	3
45694196	1738521	0	0
45693857	1307863	0	0
46288656	1115171	2	3
45793231	1741122	0	0
46292961	1125315	0	0
45688196	46275916	1	1
45897990	1125315	0	0
46307226	1119510	0	0
46303622	1119510	0	0
45896568	1125315	0	0
4028076	4280726	4	5
4029205	4202832	4	4
21001191	914335	0	0
21004494	1717327	0	0
21602735	1551099	0	0
36203073	4296204	1	1
36151155	1125315	0	0
36225034	19129144	2	3
42805788	914335	0	0
42802638	40174880	2	3
44354432	1119510	0	0
44353326	1119510	0	0
45655996	1119510	0	0
45662776	1000560	0	0
45622502	1125315	0	0
45638467	1119510	0	0
45670122	1154029	0	0
45654299	1129625	0	0
45707648	1545959	2	3
45673867	1000560	0	0
45683876	1125315	0	0
45678331	19079524	1	1
45784853	19078461	2	3
45694221	1174888	0	0
45693861	1174888	0	0
46288830	19019273	2	3
45793236	1107830	0	0
46293181	1125315	0	0
45688196	19079524	1	1
45897927	1125315	0	0
46307411	1119510	0	0
46303279	1119510	0	0
45896766	1125315	0	0
201618	81893	4	5
4029205	4145310	5	5
21001191	975125	0	0
21004495	1717327	0	0
21602737	975125	0	0
36203073	4296205	1	1
36155724	1125315	0	0
36225033	19133679	2	3
42805789	740275	0	0
44345264	19018935	2	3
44354461	1119510	0	0
44353244	1119510	0	0
45655832	1119510	0	0
45661406	723013	0	0
45622507	1125315	0	0
45638571	1119510	0	0
45670123	738818	0	0
45654611	1129625	0	0
45777937	40223768	2	3
45673869	1153428	0	0
45683888	1125315	0	0
45690208	19079524	1	1
45681591	19078461	2	3
45694296	1154343	0	0
45694050	1149196	0	0
46291631	43012036	2	3
45793460	723013	0	0
46293194	1125315	0	0
45700038	19079524	1	1
45897929	1125315	0	0
46307235	1119510	0	0
46303580	1119510	0	0
45896774	1125315	0	0
253549	4146173	4	5
4029205	4275113	5	7
21001252	975125	0	0
21004491	1717327	0	0
21604762	742185	0	0
36203073	4299128	1	1
36155726	1125315	0	0
36225033	19127922	2	3
42805650	723013	0	0
44344880	19019273	2	3
44350683	1119510	0	0
44353258	1119510	0	0
45656102	1119510	0	0
45661203	1746114	0	0
45622458	1125315	0	0
45638505	1119510	0	0
45670267	791967	0	0
45655435	1129625	0	0
45707818	40232448	2	3
45673824	1115008	0	0
45683889	1125315	0	0
45690208	46275916	1	1
45693408	40228214	2	3
45694307	1557272	0	0
45694151	1778162	0	0
46291649	40229134	2	3
45793455	1557272	0	0
46293210	1125315	0	0
45690864	19079524	1	1
45897708	1125315	0	0
46307236	1119510	0	0
46303722	1119510	0	0
45896530	1125315	0	0
4024567	4283893	4	5
4029205	4107731	5	7
21001283	1125315	0	0
21004199	1738521	0	0
21604206	19016749	0	0
35602665	4280726	1	1
36155807	1125315	0	0
36225033	19129144	2	3
42805739	920293	0	0
44353184	19019273	2	3
44350513	1119510	0	0
44353163	1119510	0	0
45656103	1119510	0	0
45661203	1741122	0	0
45622600	1125315	0	0
45635235	1119510	0	0
45670000	740275	0	0
45651234	1129625	0	0
45704945	1127433	2	3
45673942	1107830	0	0
45683879	1125315	0	0
45674837	46275916	1	1
45779899	1539411	2	3
45694227	1308738	0	0
45694152	1549786	0	0
46288935	40236446	2	3
45793345	1308738	0	0
46293420	1125315	0	0
45684781	46275916	1	1
45895341	1125315	0	0
46307241	1119510	0	0
46303676	1119510	0	0
45894897	1125315	0	0
4180628	317576	4	5
4029205	4301346	5	6
21001283	1129625	0	0
21004249	1125315	0	0
35507492	1332418	0	0
35909419	198809	1	1
36155836	1125315	0	0
36427938	40220386	2	3
42805741	920293	0	0
44355219	19075001	2	3
44350541	1119510	0	0
44355240	1119510	0	0
45655911	1119510	0	0
45661206	19127890	0	0
45622444	1125315	0	0
45635251	1119510	0	0
45670001	1174888	0	0
45651216	1129625	0	0
45705125	40232448	2	3
45674073	1149196	0	0
45683890	1125315	0	0
45674837	19079524	1	1
45685108	1539411	2	3
45694315	1112807	0	0
45694152	1515774	0	0
46289317	40231925	2	3
45793158	967823	0	0
46293166	1125315	0	0
45684781	19079524	1	1
45895500	1125315	0	0
46307267	1119510	0	0
46303559	1119510	0	0
45894903	1125315	0	0
4180628	4329847	4	5
4029205	40492359	5	9
21001283	1177480	0	0
21004249	1150836	0	0
35507625	1192710	0	0
35702748	440448	1	1
36155941	1125315	0	0
36426867	1115171	2	3
42805745	1713332	0	0
42802725	19019273	2	3
44350546	1119510	0	0
44355303	1119510	0	0
45656027	1119510	0	0
45661206	1515774	0	0
45622376	1125315	0	0
45635407	1119510	0	0
45670005	1192710	0	0
45651478	1129625	0	0
45704800	40163554	2	3
45670538	1149196	0	0
45683971	1125315	0	0
45691417	19079524	1	1
45690931	1539411	2	3
45694328	705944	0	0
45694098	1149196	0	0
46289069	1332419	2	3
45793349	1149196	0	0
46293232	1125315	0	0
45706602	19079524	1	1
45895502	1125315	0	0
46307593	1119510	0	0
46303789	1119510	0	0
45803591	1125315	0	0
4028071	4056621	4	5
4029205	4336464	6	10
21001283	1192710	0	0
21004249	1107830	0	0
35507625	1112807	0	0
35702743	192671	1	1
36155900	1125315	0	0
36426867	19019273	2	3
42805745	1759842	0	0
44363014	19019273	2	3
44350726	1119510	0	0
44355328	1119510	0	0
45656029	1119510	0	0
45661206	1549786	0	0
45620712	1125315	0	0
45635267	1119510	0	0
45670055	1107830	0	0
45651665	1129625	0	0
45704928	19077572	2	3
45670549	1000560	0	0
45683978	1125315	0	0
45696262	46275916	1	1
45706148	19079524	2	3
45694348	740275	0	0
45694155	1000560	0	0
46243630	19008572	2	3
45793259	1361711	0	0
46292844	1125315	0	0
45699929	19079524	1	1
45895463	1125315	0	0
46307545	1119510	0	0
46303619	1119510	0	0
45803625	1125315	0	0
4023995	317576	4	5
4029205	4037675	6	7
21001385	1717327	0	0
21011303	1361711	0	0
35507392	1149196	0	0
35702744	192671	1	1
36156016	1125315	0	0
36426668	19007333	2	3
42805695	1137529	0	0
44353107	19019273	2	3
44350941	1119510	0	0
44353447	1119510	0	0
45656405	1119510	0	0
45661284	1549786	0	0
45620828	1125315	0	0
45635359	1119510	0	0
45670012	1154343	0	0
45651561	1129625	0	0
45691799	19078461	2	3
45670656	1717327	0	0
45684000	1125315	0	0
45696755	19079524	1	1
45678759	1539411	2	3
45694349	1174888	0	0
45694161	975125	0	0
46243732	1127433	2	3
45793260	705944	0	0
46293398	1125315	0	0
45875957	3051031	2	2
45895542	1125315	0	0
46307312	1119510	0	0
46303755	1119510	0	0
45803821	1125315	0	0
4023995	4329847	4	5
4029205	4314290	6	6
21001430	975125	0	0
21011419	1154029	0	0
35507497	1149196	0	0
35702754	30753	1	1
36155838	1125315	0	0
36426679	40236446	2	3
42805695	1149380	0	0
44359019	1551192	2	3
44350919	1119510	0	0
44353409	1119510	0	0
45656411	1119510	0	0
45661284	19127890	0	0
45620938	1125315	0	0
45635533	1119510	0	0
45670079	1192710	0	0
45648510	1129625	0	0
45703632	40228214	2	3
45673280	967823	0	0
45684012	1125315	0	0
45687698	46275916	1	1
45682201	19079524	2	3
45694352	1154343	0	0
45694041	1192710	0	0
46243736	1115171	2	3
45793355	1549786	0	0
46287953	1125315	0	0
46239754	46233988	2	3
45896804	1125315	0	0
46307210	1119510	0	0
46303320	1119510	0	0
45803897	1125315	0	0
4022922	4035415	4	5
4029205	4243062	6	6
21001385	1729720	0	0
21011419	1110410	0	0
35507600	740275	0	0
35702775	4027663	1	1
36155943	1125315	0	0
36424292	40232448	2	3
42805699	1177480	0	0
44362653	1551192	2	3
44350925	1119510	0	0
44345742	1119510	0	0
45652628	1119510	0	0
45661284	1589505	0	0
45620984	1125315	0	0
45635645	1119510	0	0
45670081	1149196	0	0
45648427	1129625	0	0
45778879	1107882	2	3
45672997	1107830	0	0
45684018	1125315	0	0
45682476	19079524	1	1
45688319	40228214	2	3
45694261	1326303	0	0
45693752	1310149	0	0
46243586	40229134	2	3
45793355	19127890	0	0
46287955	1125315	0	0
46239754	46233710	2	3
45896728	1125315	0	0
46307632	1119510	0	0
46303697	1119510	0	0
45803899	1125315	0	0
4022922	4059173	4	5
4029205	4125906	6	6
21001430	1112807	0	0
21011415	1154029	0	0
35507614	740275	0	0
35604745	40224805	1	1
36155780	1125315	0	0
36424373	46233710	2	3
42805889	1738521	0	0
44341618	1545959	2	3
44350766	1119510	0	0
44345437	1119510	0	0
45652667	1119510	0	0
45661287	1548195	0	0
45620986	1125315	0	0
45635660	1119510	0	0
45670086	1192710	0	0
45645280	1129625	0	0
45670805	1107882	2	3
45673080	1115008	0	0
45680702	1125315	0	0
45677741	46275916	1	1
45685146	40228214	2	3
45694445	1310149	0	0
45693754	1713332	0	0
46243772	40229134	2	3
45793355	1515774	0	0
46288160	1125315	0	0
45894621	1107882	2	3
45875969	3004501	2	2
46307681	1119510	0	0
46303685	1119510	0	0
45803900	1125315	0	0
4022922	4109685	4	5
4029205	4195803	3	3
21001427	1728416	0	0
21004631	1728416	0	0
35507601	1713332	0	0
35605480	35605482	1	1
36155882	1125315	0	0
36424373	46233988	2	3
42805793	1713332	0	0
44359421	19123231	2	3
44346851	1119510	0	0
44348085	1119510	0	0
45652446	1119510	0	0
45661289	1713332	0	0
45621153	1125315	0	0
45634235	1119510	0	0
45670312	1192710	0	0
45645345	1129625	0	0
45676781	1107882	2	3
45673081	1307863	0	0
45680750	1125315	0	0
45679775	46275916	1	1
45684902	40228214	2	3
45694465	1107830	0	0
45694133	1308738	0	0
46241313	40229134	2	3
45793361	1549786	0	0
46288022	1125315	0	0
45796664	1107882	2	3
45875971	3049273	2	2
46302151	1119510	0	0
46304024	1119510	0	0
45803684	1125315	0	0
4027553	261325	2	5
4029205	4187458	3	3
21001283	738818	0	0
21004631	1717327	0	0
35507603	1153428	0	0
36002868	133834	1	1
36156211	1125315	0	0
36244035	19125062	2	3
42805793	1759842	0	0
44356246	40223834	2	3
44346947	1119510	0	0
44348037	1119510	0	0
45652639	1119510	0	0
45661542	1367571	0	0
45621046	1125315	0	0
45632284	1119510	0	0
45670314	1501700	0	0
45645452	1129625	0	0
45701293	1107882	2	3
45673003	738818	0	0
45680457	1125315	0	0
45708101	46275916	1	1
45706587	40228214	2	3
45694466	1112807	0	0
45694136	1124957	0	0
46241331	19057271	2	3
45793361	19127890	0	0
46287961	1125315	0	0
46240291	40173590	2	3
45791320	19128022	2	2
46302156	1119510	0	0
46303918	1119510	0	0
45803594	1125315	0	0
254068	4112343	2	5
4029205	4199276	3	3
21001283	1149196	0	0
21004620	1551099	0	0
35507671	740275	0	0
36002868	317009	1	1
36156217	1125315	0	0
36426817	35605858	2	3
42805810	742185	0	0
44356246	40223821	2	3
44346913	1119510	0	0
44345853	1119510	0	0
45655036	1119510	0	0
45659462	1110410	0	0
45620772	1125315	0	0
45632324	1119510	0	0
45670263	1713332	0	0
45645406	1129625	0	0
45778595	1107882	2	3
45673410	1728416	0	0
45680668	1125315	0	0
45763613	4285898	1	1
45693483	40228214	2	3
45694479	1112807	0	0
45694141	914335	0	0
46241352	920334	2	3
45793361	1521369	0	0
46288045	1125315	0	0
46244860	40223768	2	3
45791320	19128263	2	2
46302005	1119510	0	0
46303494	1119510	0	0
45803552	1125315	0	0
4034850	4015189	2	5
4029205	4163951	3	3
21000198	1738521	0	0
21004633	1717327	0	0
35507673	1115008	0	0
35604830	35605858	1	1
36156026	1125315	0	0
36217214	40232448	2	3
42805814	1124957	0	0
44352901	1545959	2	3
44346916	1119510	0	0
44345839	1119510	0	0
45655043	1119510	0	0
45659342	1539403	0	0
45620770	1125315	0	0
45632508	1119510	0	0
45670450	920293	0	0
45642367	1129625	0	0
45671147	19073183	2	3
45673131	740275	0	0
45680574	1125315	0	0
45763653	4230399	1	1
45693784	40228214	2	3
45694485	1112807	0	0
45694144	1367571	0	0
46241520	19059056	2	3
45793364	975125	0	0
46288056	1125315	0	0
45790835	19078461	2	3
45875968	3000963	2	3
46301868	1119510	0	0
46300876	1119510	0	0
45803602	1125315	0	0
4162282	40486433	5	5
4029205	4012477	3	6
21000199	1738521	0	0
21004633	1778162	0	0
35507607	1153428	0	0
36203051	134438	1	1
36156044	1125315	0	0
36425676	19019979	2	3
42805822	1515774	0	0
44351536	19123231	2	3
44347116	1119510	0	0
44345891	1119510	0	0
45655170	1119510	0	0
45659420	701322	0	0
45621202	1125315	0	0
45632355	1119510	0	0
45670452	1154343	0	0
45642409	1129625	0	0
45674274	1107882	2	3
45673136	1521369	0	0
45680436	1125315	0	0
45766333	4294548	1	1
45678776	40228214	2	3
45694489	1512674	0	0
45694148	708298	0	0
46241600	40162522	2	3
45793365	1149196	0	0
46288298	1125315	0	0
45896108	1107882	2	3
45875968	40766240	2	3
46302300	1119510	0	0
46300885	1119510	0	0
45803805	1125315	0	0
435244	440086	5	5
4029205	4010253	3	7
21000220	1738521	0	0
21004634	1728416	0	0
35507610	933724	0	0
36102149	4048171	5	5
36156027	1125315	0	0
36425676	19078461	2	3
42805544	1713332	0	0
44348645	1545959	2	3
44347038	1119510	0	0
44345921	1119510	0	0
45655334	1119510	0	0
45659376	1343916	0	0
45621205	1125315	0	0
45632612	1119510	0	0
45668067	1717327	0	0
45642439	1129625	0	0
45679291	1332419	2	3
45673004	1713332	0	0
45680710	1125315	0	0
45765647	4132546	1	1
45690828	40228214	2	3
45694613	1174888	0	0
45693862	1738521	0	0
46241603	19008572	2	3
45794637	1539403	0	0
46288301	1125315	0	0
45790801	40223768	2	3
45875968	40769179	2	3
46302395	1119510	0	0
46301079	1119510	0	0
45803866	1125315	0	0
437515	4144583	5	5
4029205	4323902	3	7
21000221	1738521	0	0
21004634	1778162	0	0
35507733	1322184	0	0
36100000	40486433	5	5
36156001	1125315	0	0
36217216	1127078	2	3
42805544	1759842	0	0
44345477	19019273	2	3
44347009	1119510	0	0
44345933	1119510	0	0
45655346	1119510	0	0
45659381	738818	0	0
45620904	1125315	0	0
45629465	1119510	0	0
45668116	1174888	0	0
45642585	1129625	0	0
45701137	1332419	2	3
45673004	1759842	0	0
45680721	1125315	0	0
45766714	134438	1	1
45699914	40228214	2	3
45694489	1549786	0	0
45693863	1557272	0	0
46241606	1115171	2	3
45794860	740275	0	0
46288311	1125315	0	0
45796553	19075001	2	3
45875968	40769194	2	3
46302257	1119510	0	0
46301694	1119510	0	0
45803845	1125315	0	0
432795	4113008	5	5
4029205	4163971	3	8
21000219	1738521	0	0
21004634	1717327	0	0
35507373	1125315	0	0
36102898	28060	5	5
36156195	1125315	0	0
36217216	19007333	2	3
42805549	1738521	0	0
44349312	1107882	2	3
44347024	1119510	0	0
44341222	1119510	0	0
45652778	1119510	0	0
45659435	1149196	0	0
45621089	1125315	0	0
45629168	1119510	0	0
45668153	1174888	0	0
45642578	1129625	0	0
45707879	19073183	2	3
45673087	1557272	0	0
45680722	1125315	0	0
45705650	46275916	1	1
45682622	40228214	2	3
45694435	1112807	0	0
45694016	1729720	0	0
46241628	19075601	2	3
45794730	705944	0	0
46288259	1125315	0	0
46244872	40223768	2	3
45875968	40769189	2	3
46302427	1119510	0	0
46301915	1119510	0	0
45803673	1125315	0	0
4101796	4001336	5	5
4029205	42535580	7	8
21000224	1738521	0	0
21004632	1728416	0	0
35507561	791967	0	0
36102898	433125	5	5
36156198	1125315	0	0
36300000	4310024	8	12
42805830	1500211	0	0
44341860	19078461	2	3
44347092	1119510	0	0
44338687	1119510	0	0
45652781	1119510	0	0
45659444	723013	0	0
45621193	1125315	0	0
45629605	1119510	0	0
45668155	967823	0	0
45642749	1129625	0	0
45669314	19078461	2	3
45673129	1000560	0	0
45680732	1125315	0	0
45703996	19079524	1	1
45693766	40228214	2	3
45694280	715997	0	0
45694017	1174888	0	0
46241673	40231925	2	3
45794807	1115008	0	0
46288203	1125315	0	0
46299474	1107882	2	3
45875968	40769184	2	3
46306832	1119510	0	0
46301336	1119510	0	0
45803678	1125315	0	0
4028071	4266809	5	5
4029205	4078793	2	2
21000222	1738521	0	0
21004632	1717327	0	0
35507567	1000560	0	0
35202461	441267	5	5
36156199	1125315	0	0
36300000	4152936	8	13
42805551	1551099	0	0
42803038	19075601	2	3
44347184	1119510	0	0
44338675	1119510	0	0
45652929	1119510	0	0
45659514	1713332	0	0
45621197	1125315	0	0
45629237	1119510	0	0
45668169	1000560	0	0
45640168	1129625	0	0
45698445	1107882	2	3
45670722	723013	0	0
45680558	1125315	0	0
45702426	40171902	1	1
45691001	40228214	2	3
45694602	975125	0	0
45693864	791967	0	0
46238795	40229134	2	3
45794658	1153428	0	0
46288335	1125315	0	0
45896062	19073183	2	3
46289275	46275916	1	1
46306867	1119510	0	0
46301192	1119510	0	0
45803954	1125315	0	0
4028071	255848	5	5
4029205	4191853	2	2
21000223	1738521	0	0
21004633	1728416	0	0
35507568	914335	0	0
36202155	81151	5	5
36156201	1125315	0	0
36300000	4285898	8	15
42805822	1549786	0	0
44352347	19078924	2	3
44347248	1119510	0	0
44338682	1119510	0	0
45652812	1119510	0	0
45659382	1501700	0	0
45621159	1125315	0	0
45629573	1119510	0	0
45668175	1115008	0	0
45639452	1129625	0	0
45633115	1107882	2	3
45700521	1129625	0	0
45680743	1125315	0	0
45699186	46275916	1	1
45706412	40228214	2	3
45694506	1551099	0	0
45694028	1000560	0	0
46238561	40229134	2	3
45794661	1110410	0	0
46288360	1125315	0	0
45791435	19073183	2	3
46301326	19079524	1	1
46306971	1119510	0	0
46301200	1119510	0	0
45803880	1125315	0	0
200174	133834	5	5
4199402	81893	10	11
21000217	1738521	0	0
21004635	1728416	0	0
35507572	1115008	0	0
36202155	40479422	5	5
36156202	1125315	0	0
36300000	4094814	8	8
42805824	1738521	0	0
44344696	1107882	2	3
44343221	1119510	0	0
44338741	1119510	0	0
45652765	1119510	0	0
45659386	1307863	0	0
45664674	1125315	0	0
45629475	1119510	0	0
45668190	1118084	0	0
45639593	1129625	0	0
45677220	1107882	2	3
45698987	1129625	0	0
45680862	1125315	0	0
45699528	46275916	1	1
45706856	19079524	2	3
45691242	1149196	0	0
45693990	967823	0	0
46238782	19076374	2	3
45794685	1115008	0	0
46288417	1125315	0	0
45787996	19073183	2	3
46301391	46275916	1	1
46299800	1119510	0	0
46301319	1119510	0	0
45803979	1125315	0	0
4024000	195588	5	5
4199402	4218389	4	5
21000242	1738521	0	0
21004635	1746114	0	0
35507374	1129625	0	0
35202461	4283893	5	6
36156203	1125315	0	0
36300000	4142905	9	13
42805577	1125315	0	0
44359234	1107882	2	3
44343229	1119510	0	0
44338882	1119510	0	0
45649459	1119510	0	0
45659396	753626	0	0
45664678	1125315	0	0
45629495	1119510	0	0
45668086	1501700	0	0
45639759	1129625	0	0
45686376	1545959	2	3
45698973	1129625	0	0
45680863	1125315	0	0
45696085	40171902	1	1
45691285	40228214	2	3
45691244	1112807	0	0
45693985	1110410	0	0
46238624	19077572	2	3
45794688	975125	0	0
46288443	1125315	0	0
45796532	19073183	2	3
46301478	46275916	1	1
46299907	1119510	0	0
46301309	1119510	0	0
45675364	19127904	3	4
4023995	4310024	5	5
4199402	4043241	9	10
21000247	1738521	0	0
21004635	1741122	0	0
35507734	1115008	0	0
35205038	28060	5	6
36156435	1125315	0	0
36300000	4001336	9	13
42805894	708298	0	0
44359444	1107882	2	3
44343285	1119510	0	0
44339050	1119510	0	0
45649535	1119510	0	0
45659354	1310149	0	0
45664598	1125315	0	0
45629409	1119510	0	0
45668088	1521369	0	0
45636313	1129625	0	0
45704576	19019273	2	3
45699005	1129625	0	0
45680888	1125315	0	0
45694630	19079524	1	1
45706215	40228214	2	3
45691329	1307863	0	0
45694112	1149196	0	0
46238818	19008572	2	3
45787926	1728416	0	0
46288456	1125315	0	0
45798316	40228214	2	3
46322460	19079524	2	3
46299926	1119510	0	0
46301405	1119510	0	0
45896768	19129144	3	4
254068	4048171	5	5
4199402	440448	9	9
21000227	1738521	0	0
21004635	1778162	0	0
35507736	1759842	0	0
35205038	40481087	5	6
36156437	1125315	0	0
36300000	4048695	9	13
42805895	1310149	0	0
44341645	1107882	2	3
44343113	1119510	0	0
44338806	1119510	0	0
45649601	1119510	0	0
45659357	1326303	0	0
45664712	1125315	0	0
45626510	1119510	0	0
45668183	1174888	0	0
45636509	1129625	0	0
45778896	1332419	2	3
45695514	1129625	0	0
45677405	1125315	0	0
45693724	46275916	1	1
45777725	19079524	2	3
45691322	1149196	0	0
45694034	1115008	0	0
46238825	1127433	2	3
45787930	975125	0	0
46288772	1125315	0	0
45795984	40223768	2	3
46321959	1107882	2	3
46299938	1119510	0	0
46301325	1119510	0	0
441840	313217	7	12
4199402	195588	5	8
21000235	1738521	0	0
21004635	1717327	0	0
35507736	1713332	0	0
36100000	258780	5	6
36156604	1125315	0	0
36300000	4146173	9	13
42805871	1322184	0	0
44362578	1332419	2	3
44343417	1119510	0	0
44339063	1119510	0	0
45649615	1119510	0	0
45659459	1308738	0	0
45664714	1125315	0	0
45626737	1119510	0	0
45668123	1347450	0	0
45636395	1129625	0	0
45680650	40228214	2	3
45695572	1129625	0	0
45677390	1125315	0	0
45691425	19079524	1	1
45690805	40228214	2	3
45691131	1112807	0	0
45694118	967823	0	0
46240079	1115171	2	3
45787943	1000560	0	0
46288803	1125315	0	0
45796385	1107882	2	3
46306989	1107882	2	3
46299870	1119510	0	0
46301409	1119510	0	0
441840	4048171	7	12
4199402	4142905	5	8
21000228	1738521	0	0
21004737	1308738	0	0
35507640	1125315	0	0
21604181	40220386	5	6
36158860	1125315	0	0
36300000	40481087	9	13
42805647	1115008	0	0
44356127	40173590	2	3
44343422	1119510	0	0
44339070	1119510	0	0
45649886	1119510	0	0
45659545	19003953	0	0
45667415	1125315	0	0
45626619	1119510	0	0
45668124	1153428	0	0
45636485	1129625	0	0
45692346	1332419	2	3
45695613	1129625	0	0
45677427	1125315	0	0
45687440	19079524	1	1
45694112	40228214	2	3
45691133	1192710	0	0
45694122	1307863	0	0
45897645	40232448	2	3
45787944	1738521	0	0
46288684	1125315	0	0
45893969	1107882	2	3
46311462	19075601	2	3
46300027	1119510	0	0
46301441	1119510	0	0
441840	81893	7	13
4199402	4285898	5	10
21502534	1307863	0	0
21004854	1717327	0	0
35507684	1713332	0	0
36102154	4056621	5	7
36158838	1125315	0	0
36300000	4149245	9	13
42805904	1177480	0	0
42802893	19078461	2	3
44343423	1119510	0	0
44360409	1119510	0	0
45649715	1119510	0	0
45659546	742185	0	0
45664745	1125315	0	0
45626540	1119510	0	0
45668130	920293	0	0
45636493	1129625	0	0
45683385	1332419	2	3
45695766	1129625	0	0
45677499	1125315	0	0
45681611	19079524	1	1
45678916	19079524	2	3
45691303	1112807	0	0
45694896	1124957	0	0
45897657	40229134	2	3
45787990	1115008	0	0
46288691	1125315	0	0
46293919	40222846	2	3
46321769	19078461	2	3
46300089	1119510	0	0
46301712	1119510	0	0
441840	433644	7	8
4199402	4066995	5	7
21502524	920293	0	0
21004855	975125	0	0
35507684	1759842	0	0
36203062	4156265	5	7
36158849	1125315	0	0
36300000	81151	9	14
42805905	1549786	0	0
44345193	40173590	2	3
44343465	1119510	0	0
44360396	1119510	0	0
45649941	1119510	0	0
45659547	1738521	0	0
45664822	1125315	0	0
45626979	1119510	0	0
45668319	1308738	0	0
45637250	1129625	0	0
45705050	40173590	2	3
45695833	1129625	0	0
45677323	1125315	0	0
45681515	46275916	1	1
45678489	19079524	2	3
45691305	1154029	0	0
45694415	975125	0	0
45897686	40163554	2	3
45787996	1713332	0	0
46288701	1125315	0	0
46244034	1107882	2	3
46310951	19078461	2	3
46300226	1119510	0	0
46319235	1119510	0	0
441840	441267	6	7
4199402	198199	5	7
21501259	967823	0	0
21004856	1728416	0	0
35507941	1154343	0	0
36203062	4132546	5	7
36158935	1125315	0	0
36300000	4230399	9	14
42805905	1519936	0	0
44355207	19075601	2	3
44343514	1119510	0	0
44360060	1119510	0	0
45649001	1119510	0	0
45659509	1174888	0	0
45664795	1125315	0	0
45623286	1119510	0	0
45668321	920293	0	0
45633536	1129625	0	0
45695190	1332419	2	3
45694511	1129625	0	0
45677541	1125315	0	0
45678625	19079524	1	1
45672772	19079524	2	3
45691324	740275	0	0
45690931	1539403	0	0
45897732	1551192	2	3
45787950	933724	0	0
46288761	1125315	0	0
45790939	1107882	2	3
46321908	19079524	2	3
46300040	1119510	0	0
46319770	1119510	0	0
441840	442116	6	7
4199402	78272	5	7
19010482	19010482	0	0
21004756	975125	0	0
35507576	1124300	0	0
35702767	4285898	5	7
36158677	1125315	0	0
36300000	40486433	9	14
42805794	715997	0	0
44352163	1332419	2	3
44343527	1119510	0	0
44360349	1119510	0	0
45649106	1119510	0	0
45659513	1310149	0	0
45664870	1125315	0	0
45623294	1119510	0	0
45668325	1124957	0	0
45633398	1129625	0	0
45676708	40173590	2	3
45692411	1129625	0	0
45677417	1125315	0	0
45678943	46275916	1	1
45697022	40223768	2	3
45802509	791967	0	0
45690939	975125	0	0
45897738	40224132	2	3
45787982	975125	0	0
46288716	1125315	0	0
46244219	1107882	2	3
46322127	40228214	2	3
46299996	1119510	0	0
46319771	1119510	0	0
441840	28060	6	9
4199402	140673	5	5
19010530	19134077	0	0
21004758	1595799	0	0
35507577	1501700	0	0
36102144	4294548	5	7
36159085	1125315	0	0
36300000	4296204	9	12
42805797	1125315	0	0
44345297	19075601	2	3
44343648	1119510	0	0
44360239	1119510	0	0
45646491	1119510	0	0
45659582	1551099	0	0
45664759	1125315	0	0
45623295	1119510	0	0
45668326	1307863	0	0
45633343	1129625	0	0
45707385	1332419	2	3
45692425	1129625	0	0
45677422	1125315	0	0
45678141	19127922	1	1
45682237	19078461	2	3
45802487	1545958	0	0
45690941	1717327	0	0
45897744	40232448	2	3
45788011	1149196	0	0
46244800	1125315	0	0
45801712	19078461	2	3
46321937	19078461	2	3
46300111	1119510	0	0
46322571	1119510	0	0
441840	255848	6	9
4199402	4029498	5	5
21003349	914335	0	0
21004758	1396131	0	0
35507642	975125	0	0
36102144	4116491	5	7
36159086	1125315	0	0
36300000	439406	9	10
42805800	19127890	0	0
44356224	19075601	2	3
44339818	1119510	0	0
44359936	1119510	0	0
45646528	1119510	0	0
45659529	1539403	0	0
45664968	1125315	0	0
45623513	1119510	0	0
45668286	705944	0	0
45633637	1129625	0	0
45698218	1332419	2	3
45692734	1129625	0	0
45677453	1125315	0	0
45678141	19133679	1	1
45678632	19078461	2	3
45802488	1153428	0	0
45690950	1326303	0	0
45897836	1539411	2	3
45787962	967823	0	0
46244804	1125315	0	0
45896089	1107882	2	3
46306460	19078461	2	3
46300113	1119510	0	0
46319844	1119510	0	0
441840	4149245	6	10
4199402	4166224	8	9
21003376	1129625	0	0
21004753	1746114	0	0
35507644	1129625	0	0
35802134	4285898	5	8
36159092	1125315	0	0
36300000	4306014	9	10
42805800	1589505	0	0
44345802	19079524	2	3
44339793	1119510	0	0
44359938	1119510	0	0
45646467	1119510	0	0
45659584	715997	0	0
45664879	1125315	0	0
45623520	1119510	0	0
45668106	1192710	0	0
45633440	1129625	0	0
45680418	40228214	2	3
45692390	1129625	0	0
45677593	1125315	0	0
45678141	19129144	1	1
45690780	19078461	2	3
45802323	1521369	0	0
45690951	975125	0	0
45897703	19059056	2	3
45788002	1124300	0	0
46244751	1125315	0	0
46242523	19078461	2	3
46316821	40228214	2	3
46300104	1119510	0	0
46319857	1119510	0	0
441840	4278672	6	10
4199402	258780	8	8
21003376	1343916	0	0
21004753	1741122	0	0
35507650	1129625	0	0
35205038	258780	5	8
36158776	1125315	0	0
36300000	4048169	9	10
42805800	1549786	0	0
44344946	19078461	2	3
44339906	1119510	0	0
44360306	1119510	0	0
45646646	1119510	0	0
45659472	1551099	0	0
45665068	1125315	0	0
45623363	1119510	0	0
45668108	1307863	0	0
45633544	1129625	0	0
45676402	19078461	2	3
45692615	1129625	0	0
45677700	1125315	0	0
45676347	19079524	1	1
45696917	19078461	2	3
45802323	1595799	0	0
45691054	1192710	0	0
45897917	40224805	2	3
45788024	1174888	0	0
46244656	1125315	0	0
45788113	19078461	2	3
46311229	19078461	2	3
46300340	1119510	0	0
46319936	1119510	0	0
441840	321042	6	10
4199402	372328	6	6
21003375	1129625	0	0
21004852	975125	0	0
35507651	1125315	0	0
35205038	4048171	5	8
36158903	1125315	0	0
36300000	4296205	9	9
42805553	1713332	0	0
44338265	19078461	2	3
44339885	1119510	0	0
44360262	1119510	0	0
45646605	1119510	0	0
45659473	1738521	0	0
45665071	1125315	0	0
45623630	1119510	0	0
45668161	738818	0	0
45633750	1129625	0	0
45698405	19078461	2	3
45692567	1129625	0	0
45677712	1125315	0	0
45769811	4001336	1	1
45690696	19078461	2	3
45802323	1549786	0	0
45691060	1501700	0	0
45897856	920300	2	3
45788026	1149196	0	0
46244657	1125315	0	0
46243963	40173590	2	3
45787463	1115171	2	3
46300245	1119510	0	0
46320058	1119510	0	0
441840	80502	5	7
4199402	4113008	6	6
21003385	1551099	0	0
21002821	1125315	0	0
35507652	1125315	0	0
36102154	4294548	5	8
36159114	1125315	0	0
36300000	4059173	10	13
42805520	967823	0	0
44345655	40228214	2	3
44339871	1119510	0	0
44362727	1119510	0	0
45646727	1119510	0	0
45656518	1174888	0	0
45664622	1125315	0	0
45623636	1119510	0	0
45668113	1548195	0	0
45630496	1129625	0	0
45683318	19078461	2	3
45692670	1129625	0	0
45677763	1125315	0	0
45702780	19079524	1	1
45780020	19078461	2	3
45802620	1549786	0	0
45691003	1713332	0	0
45897961	1107882	2	3
45788005	1192710	0	0
46243272	1125315	0	0
45801651	40173590	2	3
45787504	19059056	2	3
46300159	1119510	0	0
46319976	1119510	0	0
441840	260139	5	10
4199402	4155034	6	6
21003223	1129625	0	0
21002811	1124300	0	0
35507653	1125315	0	0
36100000	4056621	5	8
36158924	1125315	0	0
36300000	81893	10	16
42805911	1551099	0	0
44352766	1539411	2	3
44339876	1119510	0	0
44362800	1119510	0	0
45646585	1119510	0	0
45656316	738818	0	0
45664321	1125315	0	0
45667703	1119510	0	0
45665999	1332418	0	0
45630507	1129625	0	0
45669527	19075601	2	3
45692694	1129625	0	0
45677779	1125315	0	0
45702671	46275916	1	1
45694183	19078461	2	3
45802620	1521369	0	0
45691003	1759842	0	0
45895497	40232448	2	3
45788006	791967	0	0
46243284	1125315	0	0
45793455	40173590	2	3
45787509	782047	2	3
46296475	1119510	0	0
46320009	1119510	0	0
441840	4329847	5	11
4199402	380378	6	6
21003205	738818	0	0
21002812	975125	0	0
35507653	1119510	0	0
36203062	4001336	5	8
36159122	1125315	0	0
36300000	433644	10	11
42805922	1729720	0	0
44352685	40228214	2	3
44340117	1119510	0	0
44360555	1119510	0	0
45643811	1119510	0	0
45656536	1124957	0	0
45664329	1125315	0	0
45667842	1119510	0	0
45666000	1107830	0	0
45630323	1129625	0	0
45698518	19078461	2	3
45692709	1129625	0	0
45677781	1125315	0	0
45702668	46275916	1	1
45699715	19078461	2	3
45802631	1545958	0	0
45690898	1000560	0	0
45895570	19133873	2	3
45788038	757627	0	0
46243296	1125315	0	0
45798606	1332419	2	3
45787683	19074841	2	3
46296065	1119510	0	0
46320014	1119510	0	0
441840	133834	8	10
4199402	4109685	6	7
21003371	1000560	0	0
21002827	1115008	0	0
35507658	715997	0	0
36202157	40479768	5	10
36159003	1125315	0	0
36500000	381316	6	6
42805632	1557272	0	0
44359433	40228214	2	3
44340125	1119510	0	0
44360534	1119510	0	0
45643324	1119510	0	0
45656220	1361711	0	0
45662086	1125315	0	0
45667913	1119510	0	0
45665936	1310149	0	0
45630328	1129625	0	0
45674103	19075601	2	3
45692701	1129625	0	0
45677926	1125315	0	0
45696828	19079524	1	1
45706173	19078461	2	3
45802498	1124957	0	0
45690863	1107830	0	0
45895573	1332419	2	3
45788128	975125	0	0
46243301	1125315	0	0
46239381	40173590	2	3
45787739	19008572	2	3
46296348	1119510	0	0
46320029	1119510	0	0
441840	40479422	8	11
4199402	4056621	6	7
21003226	1129625	0	0
21002827	1551099	0	0
35507596	1174888	0	0
36203062	4230399	5	9
36158929	1125315	0	0
36500000	4310024	5	7
42805717	1119510	0	0
44345358	19079524	2	3
44340256	1119510	0	0
44360541	1119510	0	0
45643739	1119510	0	0
45656228	1343916	0	0
45662037	1125315	0	0
45667738	1119510	0	0
45665773	1309944	0	0
45630547	1129625	0	0
45779128	19078461	2	3
45689589	1129625	0	0
45677845	1125315	0	0
45692832	46275916	1	1
45780104	19078461	2	3
45802654	920293	0	0
45691080	1738521	0	0
45896724	19008572	2	3
45788040	723013	0	0
46243364	1125315	0	0
46294692	1332419	2	3
45787492	19019273	2	3
46318427	1119510	0	0
46319883	1119510	0	0
441840	4280726	4	11
4199402	4310024	6	7
21003246	914335	0	0
21002822	1125315	0	0
35507596	1125315	0	0
36203062	40479768	5	9
36159294	1125315	0	0
36500000	4280726	7	7
42805718	1149380	0	0
44359115	19078461	2	3
44340285	1119510	0	0
44353470	1119510	0	0
45643485	1119510	0	0
45656434	1149196	0	0
45662147	1125315	0	0
45667750	1119510	0	0
45665774	1717327	0	0
45630756	1129625	0	0
45707180	19075601	2	3
45689596	1129625	0	0
45677857	1125315	0	0
45692855	46275916	1	1
45706463	19078461	2	3
45802331	1332418	0	0
45691036	1713332	0	0
45896728	1127433	2	3
45788041	1149196	0	0
46243381	1125315	0	0
45801501	1332419	2	3
45801113	46233710	2	3
46318429	1119510	0	0
46313781	1119510	0	0
441840	134438	3	8
4199402	4294548	6	9
21003205	1125315	0	0
21002822	1112807	0	0
35507661	1112807	0	0
36203062	40479422	5	9
36159298	1125315	0	0
36500000	40486433	7	7
42805720	1307863	0	0
44352523	19078461	2	3
44338045	1119510	0	0
44353456	1119510	0	0
45643341	1119510	0	0
45656508	1367571	0	0
45662069	1125315	0	0
45667837	1119510	0	0
45665794	914335	0	0
45630575	1129625	0	0
45683257	19075601	2	3
45689275	1129625	0	0
45677791	1125315	0	0
45692887	46275916	1	1
45684735	19078461	2	3
45802567	967823	0	0
45691036	1759842	0	0
45896701	1713671	2	3
45788063	791967	0	0
46243370	1125315	0	0
46242380	19079524	2	3
45801205	1115171	2	3
46318452	1119510	0	0
46313826	1119510	0	0
441840	192671	2	7
4199402	4001336	6	8
21003220	1000560	0	0
21002811	1118084	0	0
35507479	1107830	0	0
36200000	4230399	5	11
36159235	1125315	0	0
36500000	317576	7	7
42902788	1310034	0	0
44353090	19078461	2	3
44338048	1119510	0	0
44353460	1119510	0	0
45643500	1119510	0	0
45656509	1309944	0	0
45662101	1125315	0	0
45667596	1119510	0	0
45665804	742185	0	0
45630582	1129625	0	0
45676407	40228214	2	3
45691624	1129625	0	0
45674401	1125315	0	0
45690025	46275916	1	1
45691035	19078461	2	3
45802585	1738521	0	0
45691039	1309944	0	0
45799698	19073183	2	3
45787972	1124957	0	0
46243332	1125315	0	0
45896077	19078461	2	3
45802355	19076374	2	3
46318454	1119510	0	0
46313798	1119510	0	0
1125443	19029476	2	3
4199402	4152936	6	8
21003250	1124300	0	0
21002827	1118084	0	0
35507482	1729720	0	0
36200000	4109685	5	9
36159130	1125315	0	0
36500000	134438	7	7
42902852	40224132	0	0
44359077	19078461	2	3
45619873	1119510	0	0
44353430	1119510	0	0
45643614	1119510	0	0
45656510	19127890	0	0
45662014	1125315	0	0
45668017	1119510	0	0
45665614	933724	0	0
45627588	1129625	0	0
45778723	19079524	2	3
45689697	1129625	0	0
45674005	1125315	0	0
45690088	46275916	1	1
45684614	40174880	2	3
45802389	1153428	0	0
45691089	1115008	0	0
46242289	1107882	2	3
45788104	1545958	0	0
46243320	1125315	0	0
45791529	19078461	2	3
45802515	40229134	2	3
46318574	1119510	0	0
46313687	1119510	0	0
920293	920334	2	3
4199402	261325	6	8
21003251	933724	0	0
21002839	1551099	0	0
35507485	1125315	0	0
36200000	4152936	5	10
36159131	1125315	0	0
36500000	40479768	6	11
42806840	1738521	0	0
44345088	19078461	2	3
45619849	1119510	0	0
44353649	1119510	0	0
45643631	1119510	0	0
45656510	1549786	0	0
45662173	1125315	0	0
45667861	1119510	0	0
45665615	967823	0	0
45627686	1129625	0	0
45780900	40228214	2	3
45689676	1129625	0	0
45674157	1125315	0	0
45688740	19079524	1	1
45700037	19078461	2	3
45802538	1149196	0	0
45691102	753626	0	0
45801071	46233710	2	3
45788051	1309944	0	0
46243416	1125315	0	0
45791216	19075601	2	3
45802406	19078461	2	3
46318534	1119510	0	0
46313725	1119510	0	0
4042650	4024289	2	3
4199402	81151	7	8
21003348	914335	0	0
21002813	975125	0	0
35507485	738818	0	0
21604344	1127078	0	3
36159343	1125315	0	0
36500000	40479422	6	11
42806978	1124957	0	0
44359352	19078461	2	3
45619886	1119510	0	0
44353419	1119510	0	0
45640743	1119510	0	0
45656450	1768849	0	0
45662269	1125315	0	0
45667249	1119510	0	0
45665904	1154343	0	0
45624613	1129625	0	0
45707824	19079524	2	3
45686779	1129625	0	0
45674282	1125315	0	0
45688519	19079524	1	1
45699731	19078461	2	3
45802402	1521369	0	0
45691188	1539403	0	0
45786045	19078461	2	3
45788219	1124957	0	0
46243468	1125315	0	0
45791068	19075601	2	3
45802939	1125315	0	0
46318677	1119510	0	0
46314041	1119510	0	0
4024656	4108705	2	3
4199402	4134304	7	8
21003119	1129625	0	0
21002844	1115008	0	0
35507485	1119510	0	0
21604344	1127433	0	3
36159293	1125315	0	0
36500000	78272	5	11
42806983	1129625	0	0
44362856	19078461	2	3
45620127	1119510	0	0
44353544	1119510	0	0
45640970	1119510	0	0
45656586	1149196	0	0
45662337	1125315	0	0
45665590	1119510	0	0
45665820	1149196	0	0
45624620	1129625	0	0
45676847	40228214	2	3
45686455	1129625	0	0
45674408	1125315	0	0
45683758	19079524	1	1
45684591	19078461	2	3
45802539	1115008	0	0
45690982	1110410	0	0
45798523	1107882	2	3
45788226	1174888	0	0
46243345	1125315	0	0
45798740	19075601	2	3
45802949	1125315	0	0
46318889	1119510	0	0
46314360	1119510	0	0
4165549	4198190	2	3
4199402	196456	7	7
21002691	1149380	0	0
21002844	1112807	0	0
35507641	1713332	0	0
35205189	4329847	0	0
36159212	1125315	0	0
36500000	4296204	5	8
42807194	1738521	0	0
44345523	19078461	2	3
45620213	1119510	0	0
44353666	1119510	0	0
45640729	1119510	0	0
45656371	1149196	0	0
45662050	1125315	0	0
45665680	1119510	0	0
45666022	1124300	0	0
45624451	1129625	0	0
45780810	19078461	2	3
45686693	1129625	0	0
45676229	1125315	0	0
45671438	19079524	1	1
45706494	19078461	2	3
45802540	914335	0	0
45690909	975125	0	0
46240804	1557272	0	0
45788262	1501700	0	0
46243348	1125315	0	0
46293961	19075601	2	3
45803213	1125315	0	0
46319028	1119510	0	0
46314363	1119510	0	0
201618	4166224	2	3
4199402	4266809	7	7
21002690	975125	0	0
21002845	975125	0	0
35507757	1000560	0	0
35204966	321042	0	0
36159404	1125315	0	0
36500000	4048171	8	8
42807022	705944	0	0
44362819	19078461	2	3
45620054	1119510	0	0
44353881	1119510	0	0
45640996	1119510	0	0
45656562	1332418	0	0
45662052	1125315	0	0
45665633	1119510	0	0
45666201	1332418	0	0
45624685	1129625	0	0
45685403	40228214	2	3
45686731	1129625	0	0
45676260	1125315	0	0
45688731	19079524	1	1
45685015	19078461	2	3
45802574	791967	0	0
45691285	1149196	0	0
46240805	1549786	0	0
45788239	1107830	0	0
46243419	1125315	0	0
45793390	19075601	2	3
45802957	1125315	0	0
46319097	1119510	0	0
46313849	1119510	0	0
1310149	40163554	2	3
4199402	375671	7	9
21002692	1149380	0	0
21002744	43012036	2	3
35507885	1759842	0	0
35204966	4324181	0	0
36159418	1125315	0	0
36500000	4113008	8	8
42806883	933724	0	0
44356177	19078461	2	3
45620067	1119510	0	0
44353519	1119510	0	0
45640984	1119510	0	0
45656259	1545958	0	0
45662210	1125315	0	0
45663134	1119510	0	0
45666053	1501700	0	0
45668467	1129625	0	0
45674073	40228214	2	3
45686985	1129625	0	0
45674414	1125315	0	0
45699218	19079524	1	1
45699721	19078461	2	3
45802632	1154343	0	0
45691259	1149196	0	0
46240805	1521369	0	0
45788241	1115008	0	0
46243479	1125315	0	0
45801511	19075601	2	3
45803069	1125315	0	0
46318776	1119510	0	0
46314068	1119510	0	0
1309944	1310034	2	3
4117930	313217	6	9
21002691	975125	0	0
21002744	19112599	2	3
35507885	1713332	0	0
35205160	317576	0	0
36159162	1125315	0	0
36500000	4152936	8	10
42807280	1738521	0	0
44345484	19078461	2	3
44361622	1119510	0	0
44353815	1119510	0	0
45641072	1119510	0	0
45656261	1115008	0	0
45662544	1125315	0	0
45663231	1119510	0	0
45666057	1713332	0	0
45668913	1129625	0	0
45686448	19078461	2	3
45687035	1129625	0	0
45674472	1125315	0	0
45702227	46275916	1	1
45780474	19078461	2	3
45802570	1192710	0	0
45691020	1115008	0	0
46240805	19127890	0	0
45788242	1549786	0	0
46243481	1125315	0	0
45791119	19075601	2	3
45803205	1125315	0	0
46313174	1119510	0	0
46314075	1119510	0	0
705944	40236446	2	3
4117930	4266809	6	6
21002322	1741122	0	0
21002744	40232448	2	3
35507888	1154343	0	0
21604086	19003953	0	0
36159174	1125315	0	0
36500000	4230399	5	10
42806991	1549786	0	0
44345401	19078461	2	3
44341469	1125315	0	0
44353939	1119510	0	0
45640935	1119510	0	0
45656593	1000560	0	0
45662260	1125315	0	0
45663184	1119510	0	0
45666059	738818	0	0
45668957	1129625	0	0
45695178	40228214	2	3
45683560	1129625	0	0
45674547	1125315	0	0
45702227	19079524	1	1
45782796	19078461	2	3
45688448	1501700	0	0
45691027	1551099	0	0
46240917	705944	0	0
45788272	1548195	0	0
46240852	1125315	0	0
46243684	19075601	2	3
45803313	1125315	0	0
46313177	1119510	0	0
46314372	1119510	0	0
1589505	1718412	2	3
4117930	255848	6	6
21002299	920293	0	0
21505757	40222846	2	3
35507890	1119510	0	0
21603967	1177480	0	0
36159369	1125315	0	0
36500000	4149245	4	10
42806991	1512674	0	0
44338115	19078461	2	3
45619689	1125315	0	0
44346021	1119510	0	0
45641047	1119510	0	0
45656467	1551099	0	0
45658830	1125315	0	0
45663347	1119510	0	0
45666064	1778162	0	0
45666636	1129625	0	0
45778587	1539411	2	3
45683708	1129625	0	0
45674432	1125315	0	0
45695379	19079524	1	1
45699922	19078461	2	3
45688456	933724	0	0
45691028	1310149	0	0
46241039	1000560	0	0
45788273	1115008	0	0
46240858	1125315	0	0
46238966	19075601	2	3
45803288	1125315	0	0
46312710	1119510	0	0
46314264	1119510	0	0
1589505	46221626	2	3
4117930	260139	6	6
21002321	1717327	0	0
21013432	19129655	2	3
35507873	1112807	0	0
21603968	1115008	0	0
36159543	1125315	0	0
36500000	4146173	4	10
42807242	1177480	0	0
44352684	1545959	2	3
45619706	1125315	0	0
44346190	1119510	0	0
45640939	1119510	0	0
45656472	1332418	0	0
45659078	1125315	0	0
45663358	1119510	0	0
45665665	738818	0	0
45666712	1129625	0	0
45676880	40228214	2	3
45683801	1129625	0	0
45674507	1125315	0	0
45689807	19079524	1	1
45780113	19078461	2	3
45688457	1112807	0	0
45691030	920293	0	0
46241025	1192710	0	0
45788254	1713332	0	0
46241050	1125315	0	0
45896210	19075601	2	3
45803390	1125315	0	0
46312960	1119510	0	0
46314535	1119510	0	0
723013	19076374	2	3
4117930	196456	6	6
21002321	1713332	0	0
21004223	19073188	2	3
35507820	1332418	0	0
21603980	1177480	0	0
36159363	1125315	0	0
36500000	81151	4	10
42807303	708298	0	0
44348791	1539411	2	3
45621554	1125315	0	0
44346195	1119510	0	0
45640822	1119510	0	0
45656042	1322184	0	0
45658967	1125315	0	0
45663405	1119510	0	0
45665668	1154029	0	0
45664247	1129625	0	0
45676880	40228230	2	3
45683781	1129625	0	0
45674436	1125315	0	0
45692707	19079524	1	1
45685101	19078461	2	3
45688459	1174888	0	0
45691343	1343916	0	0
46240975	1738521	0	0
45788159	1192710	0	0
46242537	1125315	0	0
46296697	40228214	2	3
45803392	1125315	0	0
46312697	1119510	0	0
46314592	1119510	0	0
715997	40223768	2	3
4117930	4056621	5	6
21002325	920293	0	0
21004223	19073183	2	3
35507901	1125315	0	0
21603312	1154343	0	0
36159488	1125315	0	0
36500000	4109685	8	9
42807306	1548195	0	0
44341723	40174880	2	3
45621608	1125315	0	0
44346153	1119510	0	0
45637669	1119510	0	0
45656615	1738521	0	0
45659083	1125315	0	0
45663373	1119510	0	0
45665925	1110410	0	0
45664254	1129625	0	0
45633061	40228214	2	3
45683850	1129625	0	0
45674525	1125315	0	0
45686763	19079524	1	1
45694103	19078461	2	3
45688282	1500211	0	0
45691355	1332418	0	0
46240985	1000560	0	0
45788201	1343916	0	0
46242546	1125315	0	0
45896200	19075601	2	3
45803400	1125315	0	0
46312605	1119510	0	0
46314551	1119510	0	0
715997	45892894	2	3
4117930	4310024	5	6
21002325	1717327	0	0
21004232	19073188	2	3
35507967	1551099	0	0
36156685	723013	0	0
36159489	1125315	0	0
36500000	4048695	4	9
42806922	1125315	0	0
44352675	1332419	2	3
45621610	1125315	0	0
44346258	1119510	0	0
45637847	1119510	0	0
45656594	1501700	0	0
45659085	1125315	0	0
45663194	1119510	0	0
45666109	1551099	0	0
45664263	1129625	0	0
45778886	1539411	2	3
45684060	1129625	0	0
45671471	1125315	0	0
45670075	19079524	1	1
45702971	19078461	2	3
45688542	1713332	0	0
45691316	1307863	0	0
46240988	1729720	0	0
45788324	1115008	0	0
46242486	1125315	0	0
46242374	40223768	2	3
45803130	1125315	0	0
46313148	1119510	0	0
46314567	1119510	0	0
1305058	19007333	2	3
4117930	45769019	5	6
21002325	1746114	0	0
21004232	19073183	2	3
35507968	967823	0	0
36156591	1501700	0	0
36159500	1125315	0	0
36500000	4035415	4	9
42806879	1125315	0	0
44352780	1539411	2	3
45621666	1125315	0	0
44346160	1119510	0	0
45637687	1119510	0	0
45656378	967823	0	0
45659091	1125315	0	0
45663456	1119510	0	0
45666038	1149196	0	0
45664269	1129625	0	0
45688968	40228214	2	3
45680702	1129625	0	0
45671604	1125315	0	0
45671618	19079524	1	1
45690729	1332419	2	3
45688640	975125	0	0
45691167	723013	0	0
46241100	705944	0	0
45788330	1500211	0	0
46242163	1125315	0	0
46244832	40228214	2	3
45803384	1125315	0	0
46313150	1119510	0	0
46314582	1119510	0	0
1308738	964261	2	3
4117930	4329847	5	8
21002227	926487	0	0
21004635	46275444	2	3
35507780	1125315	0	0
36156592	1713332	0	0
36159320	1125315	0	0
36500000	133834	9	9
42806879	1174888	0	0
44359432	1539411	2	3
45621696	1125315	0	0
44346310	1119510	0	0
45637889	1119510	0	0
45656543	1124957	0	0
45659118	1125315	0	0
45663459	1119510	0	0
45666095	1539403	0	0
45664368	1129625	0	0
45781100	40228214	2	3
45680750	1129625	0	0
45671642	1125315	0	0
45701784	46275916	1	1
45699900	1332419	2	3
45688528	1192710	0	0
45691384	1149196	0	0
46241110	1124957	0	0
45788116	1539403	0	0
46242166	1125315	0	0
45875959	40758406	2	3
45803326	1125315	0	0
46312928	1119510	0	0
46314674	1119510	0	0
975125	19008572	2	3
4117930	4116491	5	5
21001798	1746114	0	0
21004635	19129655	2	3
21604271	1102527	0	0
36156691	1343916	0	0
36159572	1125315	0	0
36313966	4280726	4	11
42807110	701322	0	0
44786893	3013682	1	1
45621717	1125315	0	0
44346228	1119510	0	0
45637909	1119510	0	0
45656241	1713332	0	0
45658979	1125315	0	0
45663596	1119510	0	0
45666190	1551099	0	0
45664548	1129625	0	0
45779076	19079524	2	3
45680763	1129625	0	0
45671647	1125315	0	0
45692911	19079524	1	1
45678678	1332419	2	3
45800047	1000560	0	0
45691129	975125	0	0
46241111	975125	0	0
45788082	1713332	0	0
46242170	1125315	0	0
45804315	40228214	2	3
45803075	1125315	0	0
46312932	1119510	0	0
46314686	1119510	0	0
967823	19079524	2	3
4117930	261325	5	7
21001801	1717327	0	0
21004233	19073183	2	3
21604272	1154029	0	0
36156692	1343916	0	0
36159584	1125315	0	0
36313966	257012	4	10
42807159	1125315	0	0
44786911	3016723	1	1
45619802	1125315	0	0
44346465	1119510	0	0
45637700	1119510	0	0
45656243	1343916	0	0
45658981	1125315	0	0
45659665	1119510	0	0
45666195	1361711	0	0
45661113	1129625	0	0
45695206	40228214	2	3
45680721	1129625	0	0
45671648	1125315	0	0
45695666	19079524	1	1
45703055	1332419	2	3
45799993	1192710	0	0
45691181	1107830	0	0
46240641	738818	0	0
45788081	1367571	0	0
46242490	1125315	0	0
45801573	40228214	2	3
45803079	1125315	0	0
46313223	1119510	0	0
46314340	1119510	0	0
4042646	4186930	3	3
4117930	321042	5	7
21001796	1759842	0	0
21004233	19073188	2	3
21603404	1119510	0	0
36156784	1119510	0	0
36159152	1125315	0	0
36313966	40479422	8	11
42807159	1124957	0	0
44359617	19074679	1	1
45619744	1125315	0	0
44346267	1119510	0	0
45634696	1119510	0	0
45656245	1343916	0	0
45659193	1125315	0	0
45659917	1119510	0	0
45666166	1149196	0	0
45661114	1129625	0	0
45778624	40228214	2	3
45680743	1129625	0	0
45671599	1125315	0	0
45708101	19079524	1	1
45684876	40174880	2	3
45799791	1149196	0	0
45691174	1192710	0	0
46240642	1107830	0	0
45788231	1332418	0	0
46242494	1125315	0	0
45787962	19079524	2	3
45800456	1125315	0	0
46313074	1119510	0	0
46315024	1119510	0	0
201618	440448	3	3
4117930	4166224	7	8
21001801	1713332	0	0
21601121	964261	2	3
21603398	1174888	0	0
36156787	1118084	0	0
36159585	1125315	0	0
36313966	4144583	8	8
42807198	1309944	0	0
44353136	46275916	1	1
45619820	1125315	0	0
44346383	1119510	0	0
45634669	1119510	0	0
45658433	723013	0	0
45659316	1125315	0	0
45659845	1119510	0	0
45666042	1153428	0	0
45661323	1129625	0	0
45698368	40228214	2	3
45677360	1129625	0	0
45671575	1125315	0	0
45677461	19079524	1	1
45876002	3008598	1	1
45800082	757627	0	0
45688744	1124957	0	0
46238197	1549786	0	0
45788363	1149196	0	0
46242362	1125315	0	0
46239324	40228214	2	3
45800485	1125315	0	0
46313236	1119510	0	0
46308793	1119510	0	0
254068	40481087	3	3
4117930	440448	8	8
21001801	1768849	0	0
21004633	19129655	2	3
21601747	1332418	0	0
36156768	1129625	0	0
36159597	1125315	0	0
36313966	4218389	5	7
42807203	1738521	0	0
44345292	19127922	1	1
44360997	1125315	0	0
44346644	1119510	0	0
45634673	1119510	0	0
45658355	1332418	0	0
44341743	1125315	0	0
45659846	1119510	0	0
45666199	1521369	0	0
45661278	1129625	0	0
45707695	40223768	2	3
45677404	1129625	0	0
45671629	1125315	0	0
45699186	19079524	1	1
45697275	19079524	1	1
45800056	1107830	0	0
45688381	967823	0	0
46238197	19127890	0	0
45788365	1124957	0	0
46241203	1125315	0	0
46238882	40228214	2	3
45800470	1125315	0	0
46307767	1119510	0	0
46308992	1119510	0	0
254068	28060	3	3
4042150	4198190	8	8
21001802	1713332	0	0
21002491	19019979	2	3
35507961	1551099	0	0
36156772	1119510	0	0
36159614	1125315	0	0
36313966	4051466	5	6
42807011	1595799	0	0
44345292	19133679	1	1
44360998	1125315	0	0
44339012	1119510	0	0
45634802	1119510	0	0
45658363	738818	0	0
44357596	1125315	0	0
45659868	1119510	0	0
45666049	1192710	0	0
45654793	1129625	0	0
45704551	40228214	2	3
45677607	1129625	0	0
45671540	1125315	0	0
45701653	46275916	1	1
45675904	19079524	1	1
45800090	1343916	0	0
45688020	1124957	0	0
46233988	46233988	0	0
45788082	1759842	0	0
46241209	1125315	0	0
45896664	19078461	2	3
45800518	1125315	0	0
46307833	1119510	0	0
46309421	1119510	0	0
254068	257012	3	3
1332450	1332419	1	1
21001801	1741122	0	0
21002491	1127078	2	3
35507929	740275	0	0
36156780	1119510	0	0
36159615	1125315	0	0
36313966	4174876	5	6
42807011	1521369	0	0
44345292	19129144	1	1
44360940	1125315	0	0
44339235	1119510	0	0
45634808	1119510	0	0
45658367	1343916	0	0
44357916	1125315	0	0
45649369	1129625	0	0
45665760	914335	0	0
45635062	1112807	0	0
45669478	40223768	2	3
45677326	1129625	0	0
45673015	1125315	0	0
45701653	19079524	1	1
45675920	19079524	1	1
45800200	975125	0	0
45688068	1000560	0	0
46240075	1112807	0	0
45788084	1595799	0	0
46241297	1125315	0	0
45896332	40228214	2	3
45800525	1125315	0	0
46307504	1119510	0	0
46308948	1119510	0	0
4024567	4051466	3	3
1322187	19075601	1	1
21001801	1759842	0	0
21004493	19129655	2	3
35507934	967823	0	0
36156619	1307863	0	0
36151146	1125315	0	0
36313966	30753	5	9
42807011	1549786	0	0
44362889	1153428	0	0
44361446	1125315	0	0
44339121	1119510	0	0
45634419	1119510	0	0
45658413	914335	0	0
44357894	1125315	0	0
45649441	1129625	0	0
45665762	1174888	0	0
45635103	1112807	0	0
45698744	40228214	2	3
45677533	1129625	0	0
45673147	1125315	0	0
45686755	19079524	1	1
45672963	19079524	1	1
45800202	1107830	0	0
45688115	1174888	0	0
46240076	1549786	0	0
45788084	1521369	0	0
46241248	1125315	0	0
46239578	40228214	2	3
45800492	1125315	0	0
46307508	1119510	0	0
46308896	1119510	0	0
4101796	381316	3	3
1539465	1539411	1	1
21001801	1746114	0	0
21002154	46275444	2	3
35507935	967823	0	0
36156620	967823	0	0
36151289	1125315	0	0
36313966	4035415	5	9
42807012	738818	0	0
44362962	1112807	0	0
44361373	1125315	0	0
44339125	1119510	0	0
45634552	1119510	0	0
45658376	1778162	0	0
44358058	1125315	0	0
45631774	1129625	0	0
45665887	738818	0	0
45635056	1112807	0	0
45676918	40223768	2	3
45677713	1129625	0	0
45673354	1125315	0	0
45692894	19079524	1	1
45675848	19079524	1	1
45800204	1149196	0	0
45688040	1545958	0	0
46240076	1512674	0	0
45788084	1549786	0	0
46241375	1125315	0	0
46239080	40228214	2	3
45800635	1125315	0	0
46307863	1119510	0	0
46309229	1119510	0	0
4011630	4029498	3	3
753630	40220386	1	1
21001801	1778162	0	0
21001950	46233710	2	3
35507976	1738521	0	0
36156298	1119510	0	0
36151282	1125315	0	0
36313966	4132546	5	9
42807063	1551099	0	0
44363068	1177480	0	0
44361372	1125315	0	0
44339023	1119510	0	0
45636907	1119510	0	0
45658417	1102527	0	0
44357717	1125315	0	0
45632049	1129625	0	0
45666257	1713332	0	0
45635085	1112807	0	0
45781241	19078461	2	3
45677480	1129625	0	0
45673318	1125315	0	0
45699045	19079524	1	1
45681043	19079524	1	1
45800213	975125	0	0
45688044	1332418	0	0
46239971	1107830	0	0
45788208	715997	0	0
46241282	1125315	0	0
46294109	40228214	2	3
45800638	1125315	0	0
46307864	1119510	0	0
46309119	1119510	0	0
4028074	4134304	3	3
1137537	40169281	1	1
21001804	1778162	0	0
21001950	46233988	2	3
35507978	1177480	0	0
36156232	1000560	0	0
36152163	1125315	0	0
36313966	380378	5	8
42807064	1778162	0	0
44362900	1154343	0	0
44361542	1125315	0	0
44339025	1119510	0	0
45637120	1119510	0	0
45658426	1713332	0	0
44357760	1125315	0	0
45632016	1129625	0	0
45666257	1759842	0	0
45635164	1112807	0	0
45683530	19078461	2	3
45677781	1129625	0	0
45673266	1125315	0	0
45680848	46275916	1	1
45676089	19079524	1	1
45800215	1778162	0	0
45688160	1322184	0	0
46240073	757627	0	0
45788337	1713332	0	0
46241229	1125315	0	0
45791253	19079524	2	3
45800561	1125315	0	0
46307935	1119510	0	0
46309334	1119510	0	0
252662	260139	3	3
1000599	35605482	1	1
21001802	1759842	0	0
21001692	40163554	2	3
35507590	1177480	0	0
36156398	975125	0	0
36152284	1125315	0	0
36313966	381316	5	8
42807176	1115008	0	0
44363088	1112807	0	0
44361547	1125315	0	0
44339263	1119510	0	0
45631644	1119510	0	0
45658447	1174888	0	0
44357910	1125315	0	0
45632226	1129625	0	0
45666260	1501700	0	0
45635137	1112807	0	0
45669673	40223768	2	3
45674401	1129625	0	0
45673101	1125315	0	0
45680848	19079524	1	1
45694310	19079524	1	1
45800221	1115008	0	0
45688126	1124957	0	0
46239987	1112807	0	0
45788337	1759842	0	0
46241269	1125315	0	0
46294544	40228214	2	3
45800531	1125315	0	0
46307718	1119510	0	0
46309256	1119510	0	0
201820	4144583	3	3
25297	4112343	1	1
21001802	1717327	0	0
21004386	1551192	2	3
35508001	1125315	0	0
35506945	1322184	0	0
36152391	1125315	0	0
36313966	378419	5	10
42806885	1310149	0	0
44363093	1107830	0	0
44361662	1125315	0	0
44339580	1119510	0	0
45631618	1119510	0	0
45656650	1551099	0	0
44357992	1125315	0	0
45634096	1129625	0	0
45666271	1115008	0	0
45635390	1112807	0	0
45677126	19078461	2	3
45674284	1129625	0	0
45671670	1125315	0	0
45701931	19079524	1	1
45703277	46275916	1	1
45800174	708298	0	0
45688165	1539403	0	0
46239987	1124957	0	0
46293988	1310149	0	0
46241272	1125315	0	0
46238179	40228214	2	3
45800694	1125315	0	0
46307726	1119510	0	0
46309183	1119510	0	0
260131	261325	3	3
1127495	1127078	1	1
21001804	1768849	0	0
21004634	19129655	2	3
35508049	715997	0	0
35506947	1589505	0	0
36151398	1125315	0	0
36313966	4152936	5	10
42807275	1545958	0	0
44362983	1115008	0	0
44361702	1125315	0	0
44339454	1119510	0	0
45631466	1119510	0	0
45656640	1115008	0	0
44357863	1125315	0	0
45634211	1129625	0	0
45665725	967823	0	0
45629980	1112807	0	0
45779055	19078461	2	3
45674394	1129625	0	0
45671663	1125315	0	0
45701931	46275916	1	1
45703277	19079524	1	1
45800188	1548195	0	0
45688319	1149196	0	0
46239990	1192710	0	0
46294014	975125	0	0
46241391	1125315	0	0
45893588	40228214	2	3
45800545	1125315	0	0
46308217	1119510	0	0
46309434	1119510	0	0
260131	258780	3	3
920335	920300	1	1
21001806	1717327	0	0
21001874	1551192	2	3
35102374	439777	2	2
35506824	1119510	0	0
36151458	1125315	0	0
36313966	4294548	5	11
42807276	1512674	0	0
44362914	1124957	0	0
44361579	1125315	0	0
44339588	1119510	0	0
45631651	1119510	0	0
45656632	1124300	0	0
44358095	1125315	0	0
45628972	1129625	0	0
45666089	791967	0	0
45630166	1112807	0	0
45677191	19078461	2	3
45674404	1129625	0	0
45669946	1125315	0	0
45702201	19079524	1	1
45697526	19079524	1	1
45799908	975125	0	0
45688321	1174888	0	0
46240041	1332418	0	0
46294020	1326303	0	0
46238440	1125315	0	0
45894123	19078461	2	3
45800720	1125315	0	0
46308266	1119510	0	0
46309472	1119510	0	0
437409	375671	3	3
440059	4280726	1	1
21001804	1713332	0	0
21001909	1551192	2	3
35102391	4280726	2	2
35506829	705944	0	0
36151496	1125315	0	0
36313966	4112343	5	11
42807276	19127890	0	0
44362916	1115008	0	0
44361677	1125315	0	0
44360451	1119510	0	0
45631806	1119510	0	0
45652901	1343916	0	0
44357874	1125315	0	0
45629049	1129625	0	0
45666244	715997	0	0
45627110	1112807	0	0
45695240	19078461	2	3
45674547	1129625	0	0
45669956	1125315	0	0
45674516	19079524	1	1
45700439	19079524	1	1
45800063	1112807	0	0
45688323	920293	0	0
46240047	967823	0	0
46293927	1738521	0	0
46238327	1125315	0	0
45796482	19079524	2	3
45800735	1125315	0	0
46308280	1119510	0	0
46309192	1119510	0	0
437409	378001	3	3
317009	4051466	1	1
21001804	1717327	0	0
21001912	1551192	2	3
35104392	4056621	2	2
35506818	1119510	0	0
36151602	1125315	0	0
36313966	4285898	5	12
42807276	1549786	0	0
44362919	1305058	0	0
44361269	1125315	0	0
44360453	1119510	0	0
45631782	1119510	0	0
45652908	1501700	0	0
44357975	1125315	0	0
45629050	1129625	0	0
45666168	1717327	0	0
45627511	1112807	0	0
45695276	19078461	2	3
45674529	1129625	0	0
45669979	1125315	0	0
45674413	46275916	1	1
45694233	19079524	1	1
45800354	975125	0	0
45688333	1115008	0	0
46240128	1000560	0	0
46293933	1115008	0	0
46238395	1125315	0	0
45893841	19078461	2	3
45800507	1125315	0	0
46307917	1119510	0	0
46309394	1119510	0	0
4013518	439777	3	3
318443	317576	1	1
21001806	1778162	0	0
21001903	1551192	2	3
21604186	782043	2	2
35506822	1501700	0	0
36151472	1125315	0	0
36313966	40486433	6	11
42807047	1549786	0	0
44362995	738818	0	0
44361277	1125315	0	0
44360582	1119510	0	0
45631736	1119510	0	0
45653050	1118084	0	0
44358075	1125315	0	0
45627886	1129625	0	0
45666250	1000560	0	0
45624044	1112807	0	0
45778634	19078461	2	3
45674578	1129625	0	0
45669983	1125315	0	0
45674413	19079524	1	1
45703381	19079524	1	1
45800359	1521369	0	0
45688194	975125	0	0
46240165	1729720	0	0
46293662	1551099	0	0
46238397	1125315	0	0
46239526	40228214	2	3
45800593	1125315	0	0
46308291	1119510	0	0
46309396	1119510	0	0
4148091	440086	3	3
256440	4283893	1	1
21001808	1746114	0	0
21001850	19075001	2	3
21604186	19039298	2	2
35506959	1119510	0	0
36151502	1125315	0	0
36313966	4156265	6	9
42807047	19127890	0	0
44363103	1174888	0	0
44360965	1125315	0	0
44360509	1119510	0	0
45632199	1119510	0	0
45653053	967823	0	0
44358082	1125315	0	0
45628009	1129625	0	0
45666254	1174888	0	0
45624136	1112807	0	0
45778617	19078461	2	3
45671555	1129625	0	0
45670155	1125315	0	0
45680835	19079524	1	1
45681060	19079524	1	1
45800359	19127890	0	0
45688203	1192710	0	0
46238234	1332418	0	0
46294131	1174888	0	0
46238502	1125315	0	0
46298769	40228214	2	3
45800699	1125315	0	0
46308179	1119510	0	0
46303659	1119510	0	0
4087571	4107731	3	3
140708	4066995	1	1
21001809	1746114	0	0
21001841	19075001	2	3
21604186	19002770	2	2
35506963	1177480	0	0
36151488	1125315	0	0
36313966	255848	6	9
42807047	1512674	0	0
44363243	738818	0	0
44361476	1125315	0	0
44360896	1119510	0	0
45632200	1119510	0	0
45653058	1107830	0	0
44358028	1125315	0	0
45626119	1129625	0	0
45666175	738818	0	0
45624186	1112807	0	0
45698267	19078461	2	3
45673346	1129625	0	0
45670157	1125315	0	0
45655021	46275916	1	1
45681060	46275916	1	1
45800359	1549786	0	0
45688205	1174888	0	0
46238238	1115008	0	0
46293776	975125	0	0
46238507	1125315	0	0
45791026	40228214	2	3
45800711	1125315	0	0
46308438	1119510	0	0
46306393	1119510	0	0
253549	80502	3	3
24818	4218389	1	1
21001806	1759842	0	0
21001741	19075001	2	3
35102392	4280726	2	2
35506838	1729720	0	0
36151454	1125315	0	0
36313966	28060	6	9
42807051	705944	0	0
44363026	1174888	0	0
44361304	1125315	0	0
44360697	1119510	0	0
45632152	1119510	0	0
45653040	791967	0	0
44358234	1125315	0	0
45626139	1129625	0	0
45666183	1000560	0	0
45624190	1112807	0	0
45669563	19078461	2	3
45669916	1129625	0	0
45670013	1125315	0	0
45655021	19079524	1	1
45673095	19079524	1	1
45800326	1174888	0	0
45688240	1343916	0	0
46238244	1107830	0	0
46293779	1192710	0	0
46238508	1125315	0	0
46291786	19079524	1	1
45800808	1125315	0	0
46308427	1119510	0	0
46307005	1119510	0	0
253549	4035415	3	3
31610	30753	1	1
21001809	1778162	0	0
21001860	46275916	2	3
35102395	4280726	2	2
35506841	975125	0	0
36151646	1125315	0	0
36313966	4048695	6	10
42806895	1343916	0	0
44363029	1149380	0	0
44361347	1125315	0	0
44360673	1119510	0	0
45628600	1119510	0	0
45652832	1310149	0	0
44358237	1125315	0	0
45626205	1129625	0	0
45663605	1107830	0	0
45624247	1112807	0	0
45780908	19078461	2	3
45783716	1129625	0	0
45669916	1125315	0	0
45684194	19079524	1	1
45703626	19079524	1	1
45800128	723013	0	0
45688244	1174888	0	0
46238216	1713332	0	0
46293780	1115008	0	0
46238532	1125315	0	0
46289784	19079524	1	1
45800814	1125315	0	0
46308413	1119510	0	0
46306477	1119510	0	0
4012176	4125906	3	3
73571	40480160	1	1
21001626	1112807	0	0
21013627	1551192	2	3
35102398	4280726	2	2
35506842	705944	0	0
36151607	1125315	0	0
36313966	321042	6	10
42807263	933724	0	0
44363031	740275	0	0
44361306	1125315	0	0
44360606	1119510	0	0
45628602	1119510	0	0
45652919	1322184	0	0
44358150	1125315	0	0
45626210	1129625	0	0
45663619	1149196	0	0
45668261	1112807	0	0
45633146	19078461	2	3
45783762	1129625	0	0
45783735	1125315	0	0
45686880	19079524	1	1
45691342	19079524	1	1
45685677	1305058	0	0
45688355	1174888	0	0
46238216	1759842	0	0
46293961	1322184	0	0
46238310	1125315	0	0
46295154	46275916	1	1
45800818	1125315	0	0
46308425	1119510	0	0
46307118	1119510	0	0
4012185	4057420	3	3
73553	80180	1	1
21001630	1332418	0	0
21503326	19008572	2	3
21603821	1500211	0	0
35506843	1177480	0	0
36151424	1125315	0	0
36313966	4146173	6	10
42807269	1548195	0	0
44363228	1115008	0	0
44360980	1125315	0	0
44360885	1119510	0	0
45631044	1119510	0	0
45653016	1174888	0	0
44358161	1125315	0	0
45626418	1129625	0	0
45663636	967823	0	0
45668403	1112807	0	0
45683241	19078461	2	3
45783757	1129625	0	0
45783768	1125315	0	0
45706099	19127918	2	2
45673113	19079524	1	1
45685900	1154343	0	0
45688358	1548195	0	0
46238284	1149196	0	0
46293537	1539403	0	0
46238318	1125315	0	0
46295154	19079524	1	1
45800839	1125315	0	0
46302645	1119510	0	0
46307073	1119510	0	0
4012907	4301346	3	3
75909	80502	1	1
21001654	1322184	0	0
21013411	19074843	2	3
21603058	920293	0	0
35507048	1332418	0	0
36151748	1125315	0	0
36313966	438614	6	7
42807153	1177480	0	0
44363461	1307863	0	0
44361312	1125315	0	0
44361077	1119510	0	0
45628856	1119510	0	0
45653021	738818	0	0
44357746	1125315	0	0
45626141	1129625	0	0
45663643	1332418	0	0
45668436	1112807	0	0
45671301	19078461	2	3
45783849	1129625	0	0
45783701	1125315	0	0
45784715	42902245	2	2
45694597	19079524	1	1
45685845	1367571	0	0
45688422	1557272	0	0
46238272	1115008	0	0
46294059	1192710	0	0
46238320	1125315	0	0
46289245	19079524	1	1
45800643	1125315	0	0
46302551	1119510	0	0
46306624	1119510	0	0
4012907	44783196	3	3
3049150	3006734	1	1
21001589	1361711	0	0
21013411	19073188	2	3
35104074	439777	0	0
35506845	1500211	0	0
36151750	1125315	0	0
36313966	442116	6	7
42807298	701322	0	0
44363246	1112807	0	0
44361494	1125315	0	0
44361169	1119510	0	0
45625742	1119510	0	0
45653171	1124957	0	0
44358266	1125315	0	0
45626327	1129625	0	0
45663649	1107830	0	0
45668594	1112807	0	0
45778596	19078461	2	3
45783794	1129625	0	0
45783825	1125315	0	0
45700048	19128009	2	2
45676122	46275916	1	1
45685852	967823	0	0
45688431	1192710	0	0
46238418	1149380	0	0
46294064	1192710	0	0
46238344	1125315	0	0
45787205	1549786	0	0
45800744	1125315	0	0
46302578	1119510	0	0
46304054	1119510	0	0
4042646	4117038	3	4
3049209	3001247	1	1
21001630	1539403	0	0
21001960	1127433	2	3
21603924	19010482	0	0
35506848	1589505	0	0
36151546	1125315	0	0
36313966	439406	6	7
42807301	1115008	0	0
44363054	1149196	0	0
44361139	1125315	0	0
44361172	1119510	0	0
45626013	1119510	0	0
45652938	1174888	0	0
44358269	1125315	0	0
45626366	1129625	0	0
45663655	1174888	0	0
45666018	1112807	0	0
45707831	19078461	2	3
45783808	1129625	0	0
45783836	1125315	0	0
45700048	19127918	2	2
45679447	19079524	1	1
45685518	914335	0	0
45688177	1107830	0	0
46238428	975125	0	0
46294032	701322	0	0
46238346	1125315	0	0
45787225	1102527	0	0
45797841	1125315	0	0
46302816	1119510	0	0
46304220	1119510	0	0
201618	4285898	3	4
3049209	3006734	1	1
21001626	1322184	0	0
21001960	1127078	2	3
35507285	1000560	0	0
35506942	1177480	0	0
36151551	1125315	0	0
36313966	4139681	6	7
42806968	1153428	0	0
44363104	1177480	0	0
44357373	1125315	0	0
44360828	1119510	0	0
45625883	1119510	0	0
45653120	1110410	0	0
44358187	1125315	0	0
45622799	1129625	0	0
45663382	1778162	0	0
45664612	1112807	0	0
45686327	19078461	2	3
45781455	1129625	0	0
45783881	1125315	0	0
45694152	19128022	2	2
45682130	46275916	1	1
45685302	914335	0	0
45688266	1361711	0	0
46238430	1174888	0	0
46294050	1192710	0	0
46238405	1125315	0	0
45787207	1124957	0	0
45797774	1125315	0	0
46302979	1119510	0	0
46304131	1119510	0	0
1595799	42902245	3	4
3049219	3001247	1	1
21001622	1112807	0	0
21001960	1115171	2	3
35507288	1119510	0	0
35506943	1549786	0	0
36151585	1125315	0	0
36313966	78272	6	12
42806969	1177480	0	0
44363060	1118084	0	0
44357434	1125315	0	0
44338294	1125315	0	0
45625885	1119510	0	0
45653079	738818	0	0
44358193	1125315	0	0
45622808	1129625	0	0
45663768	1000560	0	0
45663945	1112807	0	0
45704930	19078461	2	3
45781709	1129625	0	0
45783753	1125315	0	0
45706783	19008572	2	3
45675824	19079524	1	1
45685305	1174888	0	0
45688180	1332418	0	0
46238433	1713332	0	0
46294109	1149196	0	0
46238352	1125315	0	0
45787228	1521369	0	0
45797647	1125315	0	0
46303295	1119510	0	0
46304261	1119510	0	0
4020346	4278672	3	4
3050400	3006734	1	1
21001626	1310149	0	0
21002145	46275444	2	3
35507258	1539403	0	0
35506943	1512674	0	0
36151592	1125315	0	0
36313966	375671	7	11
42807004	1000560	0	0
44363212	967823	0	0
44357475	1125315	0	0
44338318	1125315	0	0
45625835	1119510	0	0
45653115	1545958	0	0
44358293	1125315	0	0
45622760	1129625	0	0
45663772	1192710	0	0
45664029	1112807	0	0
45671089	19078461	2	3
45781814	1129625	0	0
45783795	1125315	0	0
45706701	19008572	2	3
45697095	19079524	1	1
45685314	1110410	0	0
45688184	1551099	0	0
46238433	1759842	0	0
46294185	1149196	0	0
46238754	1125315	0	0
45787228	1595799	0	0
45797763	1125315	0	0
46303298	1119510	0	0
46304232	1119510	0	0
3039466	3023103	2	4
3050400	3001247	1	1
21001643	1545958	0	0
21013658	19077572	2	3
35507259	975125	0	0
35507041	1332418	0	0
36151724	1125315	0	0
36313966	4059173	7	10
42807342	1177480	0	0
44363141	967823	0	0
44357482	1125315	0	0
44338280	1125315	0	0
45625676	1119510	0	0
45653152	1308738	0	0
44358132	1125315	0	0
45622880	1129625	0	0
45663787	1192710	0	0
45664143	1112807	0	0
45704736	19078461	2	3
45781729	1129625	0	0
45783808	1125315	0	0
45706858	1115171	2	3
45688255	19079524	1	1
45685318	715997	0	0
45685055	1343916	0	0
46238435	1192710	0	0
46294190	1548195	0	0
46238706	1125315	0	0
45787228	1549786	0	0
45797915	1125315	0	0
46303236	1119510	0	0
46304120	1119510	0	0
254068	4294548	2	4
3050409	3006734	1	1
21001662	1112807	0	0
21001947	19133905	2	3
35507253	1125315	0	0
35506892	1149196	0	0
36151683	1125315	0	0
36313966	81893	7	13
42807215	701322	0	0
44363143	1154343	0	0
44357440	1125315	0	0
44338102	1125315	0	0
45626072	1119510	0	0
45653423	738818	0	0
44358255	1125315	0	0
45621512	1129625	0	0
45663742	1717327	0	0
45661030	1112807	0	0
45671104	19078461	2	3
45781767	1129625	0	0
45783989	1125315	0	0
45705181	19078924	2	3
45703534	46275916	1	1
45685319	1115008	0	0
45685007	1545958	0	0
46238436	1557272	0	0
46293795	1551099	0	0
46238477	1125315	0	0
45787548	967823	0	0
45797714	1125315	0	0
46300280	1119510	0	0
46304155	1119510	0	0
3039459	3000963	4	4
3050409	3001247	1	1
21001655	1310149	0	0
21001947	46233988	2	3
35507256	1119510	0	0
35506898	1129625	0	0
36151850	1125315	0	0
36313966	45769019	7	9
42807216	19127890	0	0
44363147	1500211	0	0
44357486	1125315	0	0
44338375	1125315	0	0
45625773	1119510	0	0
45653425	1174888	0	0
44358118	1125315	0	0
45621857	1129625	0	0
45663700	791967	0	0
45657996	1112807	0	0
45778905	19078461	2	3
45783504	1129625	0	0
45783990	1125315	0	0
45705240	1127433	2	3
45703482	46275916	1	1
45685321	1112807	0	0
45685058	1149196	0	0
46238332	1107830	0	0
46293899	1501700	0	0
46238755	1125315	0	0
45787463	1115008	0	0
45797888	1125315	0	0
46300291	1119510	0	0
46304292	1119510	0	0
4162282	28060	4	4
3050415	3006734	1	1
21001665	1305058	0	0
21001947	19133873	2	3
35507250	1119510	0	0
35506941	1174888	0	0
36198916	1125315	0	0
36302170	81893	9	15
42807216	1549786	0	0
44363149	1551099	0	0
44357555	1125315	0	0
44338482	1125315	0	0
45622841	1119510	0	0
45653530	1154343	0	0
44354504	1125315	0	0
45667278	1129625	0	0
45663706	1110410	0	0
45658147	1112807	0	0
45676634	19078461	2	3
45783568	1129625	0	0
45783993	1125315	0	0
45780010	40229134	2	3
45700298	19079524	1	1
45685351	1746114	0	0
45685062	1310149	0	0
46238333	1557272	0	0
46294114	1332418	0	0
46238491	1125315	0	0
45787710	1549786	0	0
45798025	1125315	0	0
46300293	1119510	0	0
46320081	1119510	0	0
4042640	4337611	4	4
3050415	3001247	1	1
21001669	1305058	0	0
21001947	46233710	2	3
35507250	1125315	0	0
35506904	1149380	0	0
36159654	1125315	0	0
36302170	433125	9	9
42807283	1768849	0	0
44363252	1115008	0	0
44357502	1125315	0	0
44338484	1125315	0	0
45622406	1119510	0	0
45653572	967823	0	0
44354647	1125315	0	0
45667405	1129625	0	0
45663708	1110410	0	0
45657894	1112807	0	0
45669919	19078461	2	3
45779245	1129625	0	0
45781562	1125315	0	0
45780167	19019273	2	3
45700458	19134077	1	1
45685351	1741122	0	0
45685105	1192710	0	0
46238305	1332418	0	0
46294507	742185	0	0
45897432	1125315	0	0
45787710	1515774	0	0
45797704	1125315	0	0
46300386	1119510	0	0
46320362	1119510	0	0
4020347	4134304	4	4
3050420	3006734	1	1
21001653	1367571	0	0
21002821	1127433	2	3
35507250	738818	0	0
35507131	1174888	0	0
36198892	1125315	0	0
36302170	45769019	9	11
42807339	1539403	0	0
44363284	1154343	0	0
44357678	1125315	0	0
44338434	1125315	0	0
45622415	1119510	0	0
45652981	1115008	0	0
44354518	1125315	0	0
45665035	1129625	0	0
45663711	1545958	0	0
45654661	1112807	0	0
45777982	19078461	2	3
45779287	1129625	0	0
45781308	1125315	0	0
45780175	19133768	2	3
45694952	19079524	1	1
45685360	1501700	0	0
45685108	1539403	0	0
46238307	967823	0	0
46294727	1149196	0	0
45897494	1125315	0	0
45787710	19127890	0	0
45797875	1125315	0	0
46300313	1119510	0	0
46320454	1119510	0	0
435742	4116491	4	4
3050426	3001247	1	1
21001661	1551099	0	0
21002821	1127078	2	3
35507290	1125315	0	0
35507108	1119510	0	0
36198837	1125315	0	0
36302170	4219399	9	10
42807340	1000560	0	0
44363337	1149380	0	0
44357702	1125315	0	0
44338503	1125315	0	0
45622416	1119510	0	0
45653357	1595799	0	0
44354528	1125315	0	0
45665355	1129625	0	0
45663799	1539403	0	0
45654597	1112807	0	0
45676760	19078461	2	3
45779291	1129625	0	0
45781816	1125315	0	0
45780175	40162522	2	3
45688443	46275916	1	1
45685257	1124957	0	0
45685164	1115008	0	0
46238261	1124300	0	0
46294474	1729720	0	0
45897459	1125315	0	0
45787509	782043	0	0
45797876	1125315	0	0
46300474	1119510	0	0
46320459	1119510	0	0
252662	258780	4	4
3050442	3006734	1	1
21001685	1310149	0	0
21001740	19075001	2	3
35507329	1115008	0	0
35506992	1177480	0	0
36198843	1125315	0	0
36302170	4048169	8	9
42804458	1545958	0	0
44363345	1308738	0	0
44357703	1125315	0	0
44338448	1125315	0	0
45622547	1119510	0	0
45653315	1154343	0	0
44354767	1125315	0	0
45667358	1129625	0	0
45663804	1396131	0	0
45654431	1112807	0	0
45669470	19078461	2	3
45780629	1129625	0	0
45781818	1125315	0	0
45780060	40174880	2	3
45685246	46275916	1	1
45685420	1343916	0	0
45685063	740275	0	0
46238363	1107830	0	0
46294149	1118084	0	0
45897495	1125315	0	0
45787779	1107830	0	0
45797796	1125315	0	0
46300545	1119510	0	0
46320366	1119510	0	0
252662	261325	4	4
3050442	3001247	1	1
21001643	1332418	0	0
21004199	46233988	2	3
35507294	791967	0	0
35506993	1500211	0	0
36198946	1125315	0	0
36302170	4306014	8	9
42804459	1545958	0	0
44363517	1124300	0	0
44357709	1125315	0	0
44338234	1125315	0	0
45622723	1119510	0	0
45653322	914335	0	0
44354772	1125315	0	0
45667455	1129625	0	0
45663805	1118084	0	0
45655516	1112807	0	0
45781314	19078461	2	3
45780862	1129625	0	0
45781289	1125315	0	0
45780127	782047	2	3
45682319	46275916	1	1
45685421	1124957	0	0
45685066	1551099	0	0
46238368	1124957	0	0
46294372	1192710	0	0
45897504	1125315	0	0
45787586	1153428	0	0
45797803	1125315	0	0
46300517	1119510	0	0
46320274	1119510	0	0
4024000	4056621	4	4
3050445	3001247	1	1
21001643	1539403	0	0
21004199	46233710	2	3
35507354	738818	0	0
35506987	1551099	0	0
36151821	1125315	0	0
36302170	4146173	8	12
42804484	1177480	0	0
44363175	975125	0	0
44357529	1125315	0	0
44338388	1125315	0	0
45622726	1119510	0	0
45653346	920293	0	0
44354723	1125315	0	0
45662461	1129625	0	0
45663428	1192710	0	0
45651483	1112807	0	0
45674273	19078461	2	3
45779454	1129625	0	0
45781611	1125315	0	0
45780194	40236824	2	3
45676299	19079524	1	1
45685504	708298	0	0
45684716	914335	0	0
46238246	1729720	0	0
46294375	1589505	0	0
45897518	1125315	0	0
45787572	1539403	0	0
45797931	1125315	0	0
46300626	1119510	0	0
46320333	1119510	0	0
4024000	198199	4	4
3050445	3006734	1	1
21001603	1551099	0	0
21001875	1551192	2	3
35507354	1119510	0	0
35506988	1548195	0	0
36151803	1125315	0	0
36302170	42535580	7	9
42804460	1539403	0	0
44363177	1000560	0	0
44357532	1125315	0	0
44338605	1125315	0	0
45622950	1119510	0	0
45653347	1738521	0	0
44354683	1125315	0	0
45662900	1129625	0	0
45663438	1124957	0	0
45651603	1112807	0	0
45671078	40223768	2	3
45779460	1129625	0	0
45781636	1125315	0	0
45780098	19018935	2	3
46272790	4024289	1	1
45685289	1102527	0	0
45684944	1192710	0	0
45897248	1361711	0	0
46293919	701322	0	0
45897572	1125315	0	0
45787683	1768849	0	0
45797717	1125315	0	0
46300735	1119510	0	0
46320592	1119510	0	0
4011630	380378	4	4
3050465	3006734	1	1
21001654	1367571	0	0
21001775	40232448	2	3
35507354	1125315	0	0
35506991	1129625	0	0
36152004	1125315	0	0
36302170	4218389	7	9
42805324	1728416	0	0
44363389	1112807	0	0
44357538	1125315	0	0
44338404	1125315	0	0
45622553	1119510	0	0
45653348	1124300	0	0
44354807	1125315	0	0
45664740	1129625	0	0
45663443	1149196	0	0
45651252	1112807	0	0
45633042	19078461	2	3
45708244	1129625	0	0
45781722	1125315	0	0
45780057	1127433	2	3
46272790	4252419	1	1
45685261	1112807	0	0
45685168	1149196	0	0
45897250	1149196	0	0
46294494	1778162	0	0
45897638	1125315	0	0
45787739	975125	0	0
45798061	1125315	0	0
46300598	1119510	0	0
46320650	1119510	0	0
4101796	4132546	4	4
3050465	3001247	1	1
21001288	1738521	0	0
21001775	19112599	2	3
35507330	1112807	0	0
35507109	705944	0	0
36151929	1125315	0	0
36302170	440086	7	9
42805457	1149380	0	0
44363181	1115008	0	0
44357628	1125315	0	0
44338547	1125315	0	0
45622824	1119510	0	0
45653089	1713332	0	0
44354898	1125315	0	0
45664552	1129625	0	0
45663898	1000560	0	0
45651347	1112807	0	0
45698234	19078461	2	3
45708325	1129625	0	0
45781542	1125315	0	0
45779781	1107882	2	3
45687679	738818	0	0
45685263	1107830	0	0
45685109	920293	0	0
45897265	1112807	0	0
46294596	1738521	0	0
45897639	1125315	0	0
45787740	975125	0	0
45797819	1125315	0	0
46300992	1119510	0	0
46320722	1119510	0	0
4042646	4275113	4	4
3037839	3024561	1	1
21001283	1150770	0	0
21013610	19007333	2	3
35507314	791967	0	0
35506996	920293	0	0
36151659	1125315	0	0
36302170	4132546	7	11
42805460	1322184	0	0
44363163	914335	0	0
44357629	1125315	0	0
44338534	1125315	0	0
45621237	1119510	0	0
45653089	1759842	0	0
44354623	1125315	0	0
45664434	1129625	0	0
45663855	1741122	0	0
45648294	1112807	0	0
45705097	1332419	2	3
45708328	1129625	0	0
45781290	1125315	0	0
45780153	920334	2	3
45687447	967823	0	0
45685266	1149196	0	0
45685110	1174888	0	0
45897293	1153428	0	0
46293973	1589505	0	0
45897589	1125315	0	0
45787741	1192710	0	0
45797946	1125315	0	0
46300916	1119510	0	0
46320410	1119510	0	0
4180628	192671	4	4
3037839	3013682	1	1
21001283	1112807	0	0
21002775	1551192	2	3
35507315	738818	0	0
35506998	1177480	0	0
36151872	1125315	0	0
36302170	4152936	7	12
42805465	1343916	0	0
44363287	1308738	0	0
44357649	1125315	0	0
44338630	1125315	0	0
45621112	1119510	0	0
45653090	1149196	0	0
44354993	1125315	0	0
45663001	1129625	0	0
45663855	1746114	0	0
45649208	1112807	0	0
45669399	1332419	2	3
45705551	1129625	0	0
45781545	1125315	0	0
45780154	40236446	2	3
45687451	1149196	0	0
45685269	1124957	0	0
45685222	757627	0	0
45897139	1124300	0	0
46293973	19127890	0	0
45897772	1125315	0	0
45787749	1000560	0	0
45797980	1125315	0	0
46300996	1119510	0	0
46320411	1119510	0	0
4180628	80502	4	4
3037839	3006906	1	1
21001283	1107830	0	0
21002775	19007333	2	3
35507315	1119510	0	0
35506998	1129625	0	0
36151981	1125315	0	0
36302170	40480160	6	12
42805658	1112807	0	0
44363258	1192710	0	0
44357650	1125315	0	0
44338638	1125315	0	0
45621260	1119510	0	0
45653357	1308738	0	0
44355011	1125315	0	0
45663037	1129625	0	0
45663858	1501700	0	0
45649231	1112807	0	0
45674247	1332419	2	3
45705399	1129625	0	0
45781546	1125315	0	0
45707022	40236446	2	3
45687460	1728416	0	0
45685425	1153428	0	0
45685084	1192710	0	0
45897147	1124957	0	0
46293973	1549786	0	0
45897643	1125315	0	0
45787700	1551099	0	0
45797991	1125315	0	0
46301002	1119510	0	0
46320434	1119510	0	0
4024567	441267	4	4
3037839	3004501	1	1
21001283	1153428	0	0
21002836	1127078	2	3
35507315	1125315	0	0
35506999	1177480	0	0
36152085	1125315	0	0
36302170	257012	6	12
42805416	1322184	0	0
44363260	1107830	0	0
44357587	1125315	0	0
44341207	1125315	0	0
45622001	1119510	0	0
45653361	1174888	0	0
44355036	1125315	0	0
45659791	1129625	0	0
45663868	1305058	0	0
45648379	1112807	0	0
45673674	1332419	2	3
45705321	1129625	0	0
45781842	1125315	0	0
45707026	19008572	2	3
45687598	1115008	0	0
45799951	1539403	0	0
45685132	967823	0	0
45897369	1361711	0	0
46294501	1713332	0	0
45897575	1125315	0	0
45787701	1305058	0	0
45797992	1125315	0	0
46301003	1119510	0	0
46320867	1119510	0	0
4017459	4198190	4	4
3037839	3016723	1	1
21001284	975125	0	0
21002836	1127433	2	3
35507266	1545958	0	0
35507034	1545958	0	0
36151764	1125315	0	0
36302170	198809	6	12
42805468	705944	0	0
44363186	1149380	0	0
44357957	1125315	0	0
44359814	1125315	0	0
45621315	1119510	0	0
45653542	1124300	0	0
44355078	1125315	0	0
45659613	1129625	0	0
45663546	1548195	0	0
45642445	1112807	0	0
45704761	1332419	2	3
45705423	1129625	0	0
45781689	1125315	0	0
45707125	40232448	2	3
45687600	1174888	0	0
45800009	791967	0	0
45685146	1149196	0	0
45897372	1124957	0	0
46294501	1759842	0	0
45897621	1125315	0	0
45787702	1124300	0	0
45797995	1125315	0	0
46301127	1119510	0	0
46320662	1119510	0	0
255919	4029498	4	4
3044031	3016723	1	1
21001352	975125	0	0
21001871	1551192	2	3
35507336	975125	0	0
35507056	1112807	0	0
36151769	1125315	0	0
36302170	4047491	6	9
42805341	1326303	0	0
44363193	738818	0	0
44357884	1125315	0	0
44359725	1125315	0	0
45664835	1119510	0	0
45653439	1332418	0	0
44354740	1125315	0	0
45659624	1129625	0	0
45663550	1174888	0	0
45642672	1112807	0	0
45692062	1332419	2	3
45705483	1129625	0	0
45781398	1125315	0	0
45706894	19057271	2	3
45687540	1107830	0	0
45800043	1153428	0	0
45684788	1521369	0	0
45897026	1115008	0	0
46294443	1124300	0	0
45897604	1125315	0	0
45787763	1713332	0	0
45797905	1125315	0	0
46319195	1119510	0	0
46320671	1119510	0	0
200174	4296204	4	4
3044460	3016723	1	1
21001299	975125	0	0
21001853	19074841	2	3
35507303	1129625	0	0
35507059	1153428	0	0
36151770	1125315	0	0
36302170	4062501	6	6
42805342	1125315	0	0
44363434	1738521	0	0
44357755	1125315	0	0
44359730	1125315	0	0
45664934	1119510	0	0
45653129	914335	0	0
44354741	1125315	0	0
45659927	1129625	0	0
45663924	1124957	0	0
45642566	1112807	0	0
45669593	40223768	2	3
45705466	1129625	0	0
45781529	1125315	0	0
45706149	19008572	2	3
45687551	1310149	0	0
45799872	723013	0	0
45684788	19127890	0	0
45897106	1112807	0	0
46294458	1153428	0	0
45895374	1125315	0	0
45787608	1713332	0	0
45799744	1125315	0	0
46319219	1119510	0	0
46320918	1119510	0	0
4023995	381316	4	4
3048501	3006734	1	1
21001373	975125	0	0
21001853	1713671	2	3
35507304	1119510	0	0
35507148	1129625	0	0
36152244	1125315	0	0
36302170	40479768	10	13
42804547	1545958	0	0
44363395	1112807	0	0
44357832	1125315	0	0
44359837	1125315	0	0
45664883	1119510	0	0
45653136	1174888	0	0
44354819	1125315	0	0
45656672	1129625	0	0
45663839	967823	0	0
45639416	1112807	0	0
45699361	1539411	2	3
45705498	1129625	0	0
45781532	1125315	0	0
45706198	1115171	2	3
45687552	19127890	0	0
45799788	1548195	0	0
45684788	1549786	0	0
45897221	1118084	0	0
46294686	975125	0	0
45895244	1125315	0	0
45787608	1759842	0	0
45795194	1125315	0	0
46319102	1119510	0	0
46321392	1119510	0	0
4023995	321042	4	4
3048501	3001247	1	1
21001374	975125	0	0
21004620	1551192	2	3
35306246	441267	0	0
35507136	1177480	0	0
36152252	1125315	0	0
36302170	4181917	5	6
42804543	1551099	0	0
44363197	1713332	0	0
44353848	1125315	0	0
44360143	1125315	0	0
45664845	1119510	0	0
45653294	967823	0	0
44351191	1125315	0	0
45656947	1129625	0	0
45663688	1124300	0	0
45639420	1112807	0	0
45669691	1539411	2	3
45705572	1129625	0	0
45781658	1125315	0	0
45706158	40223834	2	3
45687552	1548195	0	0
45799702	1154029	0	0
45684880	975125	0	0
45897211	1322184	0	0
46294619	1192710	0	0
45895422	1125315	0	0
45787611	1309944	0	0
45795335	1125315	0	0
46319481	1119510	0	0
46321395	1119510	0	0
254068	40486433	4	4
3048567	3006734	1	1
21001283	975125	0	0
21001688	40163554	2	3
21604793	40223768	1	4
35507105	1112807	0	0
36152080	1125315	0	0
36302170	40478878	5	6
42804576	1738521	0	0
44363197	1759842	0	0
44355300	1125315	0	0
44359967	1125315	0	0
45665189	1119510	0	0
45652952	1713332	0	0
44351194	1125315	0	0
45657006	1129625	0	0
45663449	738818	0	0
45639430	1112807	0	0
45684084	19078461	2	3
45705664	1129625	0	0
45781777	1125315	0	0
45706174	1127433	2	3
45687603	1149196	0	0
45799722	1738521	0	0
45685013	1174888	0	0
45897213	1738521	0	0
46293977	1153428	0	0
45895431	1125315	0	0
45787305	1332418	0	0
45795355	1125315	0	0
46319365	1119510	0	0
46315054	1119510	0	0
254068	4280726	4	4
3048567	3001247	1	1
21001283	1150836	0	0
21001839	19075001	2	3
21604186	19023398	1	4
35507106	1177480	0	0
36152418	1125315	0	0
36302170	4015189	4	8
42804757	1177480	0	0
44363203	1149380	0	0
44355448	1125315	0	0
44359675	1125315	0	0
45665135	1119510	0	0
45652956	1326303	0	0
44350870	1125315	0	0
45657202	1129625	0	0
45663450	967823	0	0
45639514	1112807	0	0
45692808	1539411	2	3
45701894	1129625	0	0
45783596	1125315	0	0
45706175	19073188	2	3
45687552	19054876	0	0
45799733	1551099	0	0
45685112	740275	0	0
45897218	1729720	0	0
46294720	1115008	0	0
45895252	1125315	0	0
45787492	1115008	0	0
45795435	1125315	0	0
46319146	1119510	0	0
46313872	1119510	0	0
4029205	4117038	3	7
3048584	3006734	1	1
21001378	1778162	0	0
21001839	19074841	2	3
21604186	782047	1	4
35507226	1548195	0	0
36152093	1125315	0	0
36302170	4145310	4	6
42804771	1177480	0	0
44363208	1107830	0	0
44355336	1125315	0	0
44359741	1125315	0	0
45665236	1119510	0	0
45653197	967823	0	0
44350873	1125315	0	0
45653687	1129625	0	0
45663558	1738521	0	0
45639534	1112807	0	0
45689833	1539411	2	3
45702067	1129625	0	0
45783778	1125315	0	0
45706292	19019273	2	3
45687639	1551099	0	0
45799680	1717327	0	0
45685113	1717327	0	0
45897305	791967	0	0
46294388	1192710	0	0
45895514	1125315	0	0
45800997	1361711	0	0
45795516	1125315	0	0
46319150	1119510	0	0
46314894	1119510	0	0
4047779	381316	3	6
3048584	3001247	1	1
21001349	914335	0	0
21001840	19074841	2	3
21604186	19023423	1	4
35507227	1129625	0	0
36152099	1125315	0	0
36302170	4052083	4	4
42804551	740275	0	0
44363289	1107830	0	0
44355269	1125315	0	0
44360174	1125315	0	0
45665172	1119510	0	0
45649934	1713332	0	0
44350875	1125315	0	0
45653783	1129625	0	0
45663576	1551099	0	0
45639654	1112807	0	0
45673398	19129144	3	4
45702139	1129625	0	0
45779237	1125315	0	0
45706293	19077344	2	3
45687640	1107830	0	0
45799687	1174888	0	0
45685116	920293	0	0
45897335	1174888	0	0
46294522	1118084	0	0
45895515	1125315	0	0
45801189	1548195	0	0
45795372	1125315	0	0
46319449	1119510	0	0
46314899	1119510	0	0
4047779	4283893	3	6
3048591	3024561	1	1
21001319	19010482	0	0
21001840	19075001	2	3
35104392	4280726	1	1
35507151	1177480	0	0
36152068	1125315	0	0
36502203	4149245	5	5
42804594	1539403	0	0
44363445	1307863	0	0
44355272	1125315	0	0
44359919	1125315	0	0
45665282	1119510	0	0
45649990	723013	0	0
44351168	1125315	0	0
45653804	1129625	0	0
45663584	1343916	0	0
45639665	1112807	0	0
45654931	1545958	0	0
45702022	1129625	0	0
45779238	1125315	0	0
45699710	42707627	2	3
45687541	1174888	0	0
45797317	1539403	0	0
45685125	1118084	0	0
45897339	1738521	0	0
46294525	967823	0	0
45895517	1125315	0	0
45801191	1118084	0	0
45795528	1125315	0	0
46319167	1119510	0	0
46314901	1119510	0	0
4047779	30753	3	7
3048591	3020630	1	1
21001358	975125	0	0
21001840	1713671	2	3
35104353	4280726	1	1
35507154	1149196	0	0
36152171	1125315	0	0
36502203	78272	8	8
42804597	1124300	0	0
44363271	1738521	0	0
44355380	1125315	0	0
44359970	1125315	0	0
45662294	1119510	0	0
45649994	967823	0	0
44351013	1125315	0	0
45650225	1129625	0	0
45663814	1115008	0	0
45639687	1112807	0	0
45654908	1124300	0	0
45699219	1129625	0	0
45779377	1125315	0	0
45699774	40229134	2	3
45687608	967823	0	0
45797339	1192710	0	0
45685127	967823	0	0
45897346	1107830	0	0
46294534	1118084	0	0
45894537	1125315	0	0
45801195	1551099	0	0
45795448	1125315	0	0
46319390	1119510	0	0
46314811	1119510	0	0
4047779	4310024	3	7
3048604	3001247	1	1
21600654	975125	0	0
21001882	1551192	2	3
35302583	441267	1	1
35507080	1515774	0	0
36151987	1125315	0	0
36502203	40479768	6	6
42804579	1177480	0	0
44363273	1124957	0	0
44355360	1125315	0	0
44360280	1125315	0	0
45662505	1119510	0	0
45649995	967823	0	0
44351016	1125315	0	0
45650349	1129625	0	0
45660285	1153428	0	0
45639623	1112807	0	0
45654909	1110410	0	0
45695932	1129625	0	0
45627300	40228214	2	3
45699742	40232448	2	3
45687645	1746114	0	0
45797367	715997	0	0
45685098	1192710	0	0
45897306	738818	0	0
46294539	1549786	0	0
45894562	1125315	0	0
45801200	1501700	0	0
45795304	1125315	0	0
46319490	1119510	0	0
46314821	1119510	0	0
4047779	195588	3	7
3048604	3006734	1	1
21506099	967823	0	0
21002839	1551192	2	3
35102367	439777	1	1
35507080	1549786	0	0
35809207	4048171	4	4
36502203	40479422	6	6
42804583	1177480	0	0
44363563	1713332	0	0
44355364	1125315	0	0
44360283	1125315	0	0
45662654	1119510	0	0
45649905	1549786	0	0
44351130	1125315	0	0
45650364	1129625	0	0
45660296	1738521	0	0
45639760	1112807	0	0
45654911	1310149	0	0
45695587	1129625	0	0
45642434	40223768	2	3
45699769	19019273	2	3
45687645	1741122	0	0
45797377	1738521	0	0
45685196	933724	0	0
45897315	1112807	0	0
46294539	1595799	0	0
45803193	1125315	0	0
45801104	1149196	0	0
45795378	1125315	0	0
46319538	1119510	0	0
46315082	1119510	0	0
4047779	4329847	3	8
3048875	3006734	1	1
21506100	967823	0	0
21002597	19075001	2	3
35104186	439777	1	1
35507125	1112807	0	0
36002868	4280726	4	4
36502203	81151	4	7
42804566	920293	0	0
44363323	738818	0	0
44354286	1125315	0	0
44359901	1125315	0	0
45662669	1119510	0	0
45649905	19127890	0	0
44351138	1125315	0	0
45649031	1129625	0	0
45660302	1343916	0	0
45639552	1112807	0	0
45655072	920293	0	0
45695881	1129625	0	0
45630203	40228214	2	3
45700147	40236824	2	3
45687649	738818	0	0
45797347	1107830	0	0
45685210	1153428	0	0
45897323	1107830	0	0
46294539	1521369	0	0
45803199	1125315	0	0
45801203	723013	0	0
45792717	1125315	0	0
46240001	1119510	0	0
46314767	1119510	0	0
4027384	4112343	3	9
3048875	3001247	1	1
21506102	1125315	0	0
21002597	19133905	2	3
21601237	1326303	4	4
35507127	920293	0	0
35708294	81893	4	4
36602217	4285898	5	5
42804592	1124300	0	0
44363292	1305058	0	0
44354355	1125315	0	0
44353309	1125315	0	0
45662514	1119510	0	0
45649905	1515774	0	0
44350883	1125315	0	0
45647369	1129625	0	0
45660306	1153428	0	0
45639916	1112807	0	0
45655014	1149196	0	0
45697328	1129625	0	0
45639590	40228214	2	3
45693380	1127433	2	3
45687576	708298	0	0
45797318	1729720	0	0
45685216	791967	0	0
45897355	1192710	0	0
46243886	1310149	0	0
45803421	1125315	0	0
45801113	1738521	0	0
45792719	1125315	0	0
46239885	1119510	0	0
46314940	1119510	0	0
4027384	260139	3	8
3048880	3001247	1	1
21506104	1125315	0	0
21002597	19074841	2	3
21601237	1343916	4	4
35507158	1115008	0	0
36102976	258780	4	4
36503288	80809	4	4
42804620	914335	0	0
44363301	1149380	0	0
44354432	1125315	0	0
44353319	1125315	0	0
45662727	1119510	0	0
45649757	1322184	0	0
44351146	1125315	0	0
45644273	1129625	0	0
45660282	1153428	0	0
45636585	1112807	0	0
45655016	1115008	0	0
45697871	1129625	0	0
45661370	19078461	2	3
45693510	42707627	2	3
45687578	975125	0	0
45797383	1521369	0	0
45685553	1738521	0	0
45897190	1149196	0	0
46243569	1309944	0	0
45803342	1125315	0	0
45801115	1332418	0	0
45792590	1125315	0	0
46239837	1119510	0	0
46314979	1119510	0	0
4027384	4294548	3	8
3048880	3006734	1	1
21506104	1192710	0	0
21002597	19133873	2	3
21601237	1539403	4	4
35507168	1149380	0	0
36102976	4048171	4	4
36503288	78272	4	9
42804629	1322184	0	0
44363302	738818	0	0
44354554	1125315	0	0
44353326	1125315	0	0
45662530	1119510	0	0
45649997	19127890	0	0
44350960	1125315	0	0
45644281	1129625	0	0
45660253	1343916	0	0
45633283	1112807	0	0
45655002	791967	0	0
45695999	1129625	0	0
45666494	40228214	2	3
45693574	1115171	2	3
45687779	1738521	0	0
45797385	1332418	0	0
45685554	1501700	0	0
45897191	975125	0	0
46243828	19010482	0	0
45803429	1125315	0	0
45801126	715997	0	0
45792591	1125315	0	0
46239838	1119510	0	0
46314919	1119510	0	0
4040392	4330583	3	7
3045262	3016723	1	1
21501247	19010482	0	0
21001686	40163554	2	3
21601237	1307863	4	4
35507174	1119510	0	0
35809212	40486433	4	4
36503288	4134304	6	9
42804630	1115008	0	0
44363230	1539403	0	0
44354452	1125315	0	0
44353337	1125315	0	0
45661222	1119510	0	0
45649997	1549786	0	0
44350971	1125315	0	0
45644410	1129625	0	0
45660391	1768849	0	0
45633386	1112807	0	0
45655008	1153428	0	0
45696067	1129625	0	0
45625155	40228214	2	3
45693726	40232448	2	3
45687594	1713332	0	0
45797387	975125	0	0
45685557	1343916	0	0
45897235	753626	0	0
46243571	1154343	0	0
45803270	1125315	0	0
45801137	1153428	0	0
45794548	1125315	0	0
46239944	1119510	0	0
46314908	1119510	0	0
4180628	4280726	3	7
3048238	3006734	1	1
21502520	1174888	0	0
21001848	19074841	2	3
21601237	1332418	4	4
35507129	1119510	0	0
35809212	4280726	4	4
36503288	81151	5	8
42804581	1000560	0	0
44363236	715997	0	0
44354666	1125315	0	0
44353244	1125315	0	0
45661216	1119510	0	0
45649967	1713332	0	0
44351028	1125315	0	0
45644377	1129625	0	0
45660310	1308738	0	0
45633557	1112807	0	0
45655109	738818	0	0
45692794	1129625	0	0
45661004	40228214	2	3
45693604	19074843	2	3
45687696	1107830	0	0
45797393	1192710	0	0
45685507	757627	0	0
45897118	967823	0	0
46243874	1332418	0	0
45803357	1125315	0	0
45802442	967823	0	0
45794568	1125315	0	0
46321960	1119510	0	0
46314910	1119510	0	0
4028071	4142905	3	6
3048257	3006734	1	1
21502622	1746114	0	0
21001848	19075001	2	3
21601237	1361711	4	4
35507129	1129625	0	0
35809320	4084167	4	4
36503288	4109685	6	7
42804696	1332418	0	0
44363591	1729720	0	0
42802374	1125315	0	0
44353258	1125315	0	0
45659381	1119510	0	0
45649971	1557272	0	0
44351149	1125315	0	0
45644210	1129625	0	0
45660336	1115008	0	0
45633692	1112807	0	0
45655184	1521369	0	0
45692820	1129625	0	0
45668554	40228214	2	3
45693958	19008572	2	3
45687609	1107830	0	0
45797395	1521369	0	0
45685780	708298	0	0
45897423	1149196	0	0
46243932	975125	0	0
45803367	1125315	0	0
45802355	723013	0	0
45794525	1125315	0	0
46321962	1119510	0	0
46314699	1119510	0	0
4028071	195588	3	6
3050489	3049273	1	1
21502622	1741122	0	0
21001848	19073188	2	3
21601237	1545959	4	7
35507244	1124300	0	0
36002139	4219399	4	4
36503288	4237458	5	7
42804690	1545958	0	0
44363303	791967	0	0
42802374	1124957	0	0
44353351	1125315	0	0
45659388	1119510	0	0
45651843	1149196	0	0
44352377	1125315	0	0
45644171	1129625	0	0
45660340	1192710	0	0
45633667	1112807	0	0
45655009	1332418	0	0
45692765	1129625	0	0
45636423	40228214	2	3
45693608	40229134	2	3
45687224	975125	0	0
45682416	723013	0	0
45685718	920293	0	0
45897356	1118084	0	0
46243933	1361711	0	0
45803455	1125315	0	0
45802447	1367571	0	0
45794610	1125315	0	0
46322225	1119510	0	0
46314700	1119510	0	0
4041285	195588	3	6
3049225	3006734	1	1
21502623	1759842	0	0
21001848	19073183	2	3
21601237	1310034	4	7
35507193	1149196	0	0
36002139	37017711	4	4
36503288	4035415	4	7
42804614	1713332	0	0
44363306	1343916	0	0
42802650	1728416	0	0
44353163	1125315	0	0
45659648	1119510	0	0
45651855	1548195	0	0
44352253	1125315	0	0
45644164	1129625	0	0
45660392	1192710	0	0
45630286	1112807	0	0
45654784	1115008	0	0
45692828	1129625	0	0
45636555	40228214	2	3
45693812	19078924	2	3
45687542	1332418	0	0
45682524	1149196	0	0
45685723	967823	0	0
45897332	1192710	0	0
46243861	1728416	0	0
45803471	1125315	0	0
45802454	1545958	0	0
45792779	1125315	0	0
46321749	1119510	0	0
46317746	1119510	0	0
4103320	4112343	3	6
3049225	3001247	1	1
21502623	1717327	0	0
21001796	19073188	2	3
21601237	19018935	4	7
35507196	1332418	0	0
36000000	4051466	4	4
36503288	4048695	4	7
42804677	1118084	0	0
44363329	1192710	0	0
42802751	1115008	0	0
44355240	1125315	0	0
45659526	1119510	0	0
45651985	1149196	0	0
44352260	1125315	0	0
45641492	1129625	0	0
45660393	1154029	0	0
45630470	1112807	0	0
45654785	738818	0	0
45692995	1129625	0	0
45642725	40228214	2	3
45693905	40229134	2	3
45687726	967823	0	0
45682442	1112807	0	0
45685725	975125	0	0
45897285	1521369	0	0
46243670	1174888	0	0
45803481	1125315	0	0
45802367	1551099	0	0
45792735	1125315	0	0
46322180	1119510	0	0
46317806	1119510	0	0
4028908	4015189	3	6
3049228	3006734	1	1
21502687	740275	0	0
21001796	19073183	2	3
21604180	19076374	4	7
35507198	19078219	0	0
36000000	4102123	4	4
36502202	4035415	5	8
42804554	19127890	0	0
44363569	1545958	0	0
42802714	1713332	0	0
44355303	1125315	0	0
45659403	1119510	0	0
45651991	1115008	0	0
44352362	1125315	0	0
45641561	1129625	0	0
45660359	738818	0	0
45630476	1112807	0	0
45655120	1549786	0	0
45693183	1129625	0	0
45639461	19079524	2	3
45693887	19077572	2	3
45687728	1717327	0	0
45682317	1149196	0	0
45685731	1501700	0	0
45897285	1595799	0	0
46243809	975125	0	0
45803485	1125315	0	0
45802228	975125	0	0
45792764	1125315	0	0
46322189	1119510	0	0
46317359	1119510	0	0
4042140	4029498	3	6
3049249	3001247	1	1
21500564	757627	0	0
21004346	46233710	2	3
21604180	40223768	4	7
35507201	1154029	0	0
36000000	442116	4	4
36502202	134438	6	6
42804554	1515774	0	0
44363663	1124300	0	0
42802714	1759842	0	0
44353447	1125315	0	0
45659511	1119510	0	0
45652002	738818	0	0
44352364	1125315	0	0
45641459	1129625	0	0
45660369	1501700	0	0
45631254	1112807	0	0
45655120	19127890	0	0
45693278	1129625	0	0
45661003	40223768	2	3
45691568	1551192	2	3
45687788	1192710	0	0
45682446	1102527	0	0
45685733	1551099	0	0
45897285	1549786	0	0
46243949	1192710	0	0
45803690	1125315	0	0
45802590	1174888	0	0
45792765	1125315	0	0
46322190	1119510	0	0
46315093	1119510	0	0
4027384	4283893	3	6
3049249	3006734	1	1
21500564	715997	0	0
21004346	46233988	2	3
21604180	19023398	4	7
35507204	1119510	0	0
36200000	196456	4	4
36502202	4109685	7	8
42804554	1549786	0	0
44358781	1000560	0	0
42802692	1589505	0	0
44345742	1125315	0	0
45659677	1119510	0	0
45652006	1551099	0	0
44351881	1125315	0	0
45641589	1129625	0	0
45660603	1115008	0	0
45630714	1112807	0	0
45655012	1124957	0	0
45689958	1129625	0	0
45658165	19078461	2	3
45690723	19076374	2	3
45687792	1539403	0	0
45682286	1192710	0	0
45685734	1115008	0	0
45897374	1112807	0	0
46243893	1102527	0	0
45803695	1125315	0	0
45801233	742185	0	0
45792882	1125315	0	0
46322050	1119510	0	0
46315315	1119510	0	0
4180628	257012	3	6
3045783	3019550	1	1
21500577	1125315	0	0
21001849	19075001	2	3
21604180	40220386	6	7
35507205	1115008	0	0
36203042	4230399	3	4
36503249	4237458	4	5
42804756	1738521	0	0
44358786	1310149	0	0
42802692	1549786	0	0
44345322	1125315	0	0
45656316	1119510	0	0
45650015	1501700	0	0
44351817	1125315	0	0
45641412	1129625	0	0
45660771	791967	0	0
45630763	1112807	0	0
45655089	1307863	0	0
45689963	1129625	0	0
45624172	40223768	2	3
45690632	40232448	2	3
45687613	1738521	0	0
45682288	1124300	0	0
45685747	1768849	0	0
45894922	1000560	0	0
46243675	1174888	0	0
45800751	1125315	0	0
45801262	1107830	0	0
45792858	1125315	0	0
46322479	1119510	0	0
46309502	1119510	0	0
4180628	195588	3	6
3045783	3023103	1	1
21500583	1154029	0	0
21001849	19074841	2	3
21604180	40162522	6	7
35506890	1713332	0	0
35702109	4285898	3	4
36503249	4048695	4	5
42804674	1177480	0	0
44358788	1322184	0	0
42802693	975125	0	0
44345437	1125315	0	0
45656557	1119510	0	0
45650039	1343916	0	0
44352370	1125315	0	0
45641650	1129625	0	0
45660463	1118084	0	0
45630653	1112807	0	0
45655285	1000560	0	0
45690049	1129625	0	0
45666528	40223768	2	3
45690692	19008572	2	3
45687617	1332418	0	0
45682295	1124957	0	0
45685882	1107830	0	0
45894914	1124957	0	0
46243678	1309944	0	0
45800893	1125315	0	0
45801236	1521369	0	0
45792970	1125315	0	0
46321925	1119510	0	0
46310079	1119510	0	0
4178367	4058899	3	5
3049512	3001247	1	1
21500583	1124957	0	0
21001849	19073188	2	3
21604180	40229134	6	7
21604201	1154029	0	0
36202155	4048695	3	4
36503249	4066995	4	5
42804707	1125315	0	0
44358898	1177480	0	0
42802704	1000560	0	0
44345791	1125315	0	0
45656561	1119510	0	0
45650046	1115008	0	0
44351257	1125315	0	0
45641759	1129625	0	0
45660617	1738521	0	0
45627571	1112807	0	0
45655093	1110410	0	0
45690077	1129625	0	0
45624530	19078461	2	3
45690616	40223834	2	3
45687749	975125	0	0
45682510	1124957	0	0
45685508	1310149	0	0
45894984	1118084	0	0
46243684	1322184	0	0
45800897	1125315	0	0
45801236	1549786	0	0
45792974	1125315	0	0
46321930	1119510	0	0
46309867	1119510	0	0
4041285	198199	3	5
3049512	3006734	1	1
21500580	1129625	0	0
21001849	1713671	2	3
21604180	19078219	4	4
21604202	19059528	0	0
36202155	40480160	3	4
36503249	4142905	4	5
42804708	1361711	0	0
44358577	1713332	0	0
42802830	1125315	0	0
44345639	1125315	0	0
45656603	1119510	0	0
45650083	1551099	0	0
44351252	1125315	0	0
45641666	1129625	0	0
45660618	1149380	0	0
45627525	1112807	0	0
45655098	975125	0	0
45687072	1129625	0	0
45666552	19078461	2	3
45690744	40224805	2	3
45687750	715997	0	0
45682514	1192710	0	0
45685562	1154029	0	0
45894987	1115008	0	0
46244779	1124957	0	0
45800658	1125315	0	0
45801236	1595799	0	0
45792977	1125315	0	0
46322139	1119510	0	0
46309874	1119510	0	0
4168335	4152936	3	5
3049558	3051031	1	1
21500580	1112807	0	0
21001849	19073183	2	3
21604180	753626	4	4
21604203	19078219	0	0
36151891	19127918	3	4
36503249	4059173	5	5
42804709	1713332	0	0
44358580	920293	0	0
42802857	791967	0	0
44348037	1125315	0	0
45656176	1119510	0	0
45650067	738818	0	0
44351288	1125315	0	0
45641725	1129625	0	0
45660620	1549786	0	0
45627634	1112807	0	0
45655290	1174888	0	0
45687133	1129625	0	0
45648403	19078461	2	3
45690884	40232448	2	3
45687230	1115008	0	0
45682398	1107830	0	0
45681881	1124300	0	0
45895004	715997	0	0
46244789	1000560	0	0
45800673	1125315	0	0
45801239	1549786	0	0
45792863	1125315	0	0
46322157	1119510	0	0
46309895	1119510	0	0
4103320	4294548	3	5
3053269	3001247	1	1
21500580	1125315	0	0
21001842	19074841	2	3
21604180	757627	4	4
36156236	1119510	0	0
36102976	4283893	1	1
36503249	4278672	5	5
42802009	1125315	0	0
44358584	1110410	0	0
42802768	701322	0	0
44348190	1125315	0	0
45658363	1119510	0	0
45650153	1713332	0	0
44347310	1125315	0	0
45638309	1129625	0	0
45660403	1367571	0	0
45627409	1112807	0	0
45655191	1343916	0	0
45687043	1129625	0	0
45668561	19078461	2	3
45690955	40232448	2	3
45687231	1713332	0	0
45682400	1343916	0	0
45681887	1149196	0	0
45895004	701322	0	0
46244893	1521369	0	0
45800864	1125315	0	0
45801239	19127890	0	0
45792792	1125315	0	0
46322481	1119510	0	0
46309899	1119510	0	0
4115259	261325	3	5
3053269	3006734	1	1
21500590	1112807	0	0
21001842	1713671	2	3
21604180	782043	4	4
36156287	1322184	0	0
35909441	198809	1	1
36503249	4134304	7	7
42802009	1124957	0	0
44358687	933724	0	0
42802770	1112807	0	0
44348420	1125315	0	0
45653066	1119510	0	0
45646739	738818	0	0
44347496	1125315	0	0
45638212	1129625	0	0
45660422	738818	0	0
45624346	1112807	0	0
45655293	1778162	0	0
45687289	1129625	0	0
45660857	19078461	2	3
45691000	19126352	2	3
45687850	1310149	0	0
45682430	967823	0	0
45681883	1110410	0	0
45894931	1112807	0	0
46244893	1549786	0	0
45800931	1125315	0	0
45801239	1589505	0	0
45792908	1125315	0	0
46322486	1119510	0	0
46309910	1119510	0	0
4027384	30753	3	5
3049843	3006734	1	1
21500590	1125315	0	0
21001879	1551192	2	3
21604180	19059528	4	4
36152470	1118084	0	0
36002886	81893	1	1
36503249	4230399	6	6
42801754	1000560	0	0
44358494	1501700	0	0
42802677	975125	0	0
44345803	1125315	0	0
45653011	1119510	0	0
45646740	1548195	0	0
44347485	1125315	0	0
45638466	1129625	0	0
45660434	1713332	0	0
45624452	1112807	0	0
45655250	1539403	0	0
45687099	1129625	0	0
45642550	19078461	2	3
45690885	19019273	2	3
45687839	757627	0	0
45794842	740275	0	0
45682153	1332418	0	0
45894933	1137529	0	0
46244859	914335	0	0
45801002	1125315	0	0
45801248	967823	0	0
45790129	1125315	0	0
46322065	1119510	0	0
46309556	1119510	0	0
4028387	4296204	3	5
3049861	3006734	1	1
21500591	1102527	0	0
21001907	1551192	2	3
21604180	1124957	4	4
36152553	723013	0	0
36002868	439406	1	1
36503269	4230399	7	7
42801853	701322	0	0
44358698	1149380	0	0
42802983	1125315	0	0
44345853	1125315	0	0
45653021	1119510	0	0
45646757	1551099	0	0
44347741	1125315	0	0
45638528	1129625	0	0
45660475	738818	0	0
45624792	1112807	0	0
45655032	1717327	0	0
45687240	1129625	0	0
45627213	19078461	2	3
45687696	1107882	2	3
45687304	1124957	0	0
45794843	740275	0	0
45682101	975125	0	0
45894935	1551099	0	0
46244860	715997	0	0
45801116	1125315	0	0
45801388	740275	0	0
45790131	1125315	0	0
46322495	1119510	0	0
46309543	1119510	0	0
4155793	4058899	3	5
3050719	3006734	1	1
21500591	1125315	0	0
21002783	1551192	2	3
21604180	701322	4	4
36152493	1192710	0	0
36009773	40486433	1	1
36503269	4134304	8	8
42801859	1589505	0	0
44358630	1521369	0	0
42802929	1589505	0	0
44345839	1125315	0	0
45653079	1119510	0	0
45646590	1149196	0	0
44347402	1125315	0	0
45638542	1129625	0	0
45660572	1713332	0	0
45624793	1112807	0	0
45655253	1115008	0	0
45687171	1129625	0	0
45661006	19078461	2	3
45687663	19008572	2	3
45684374	1310149	0	0
45794845	1192710	0	0
45681984	1149196	0	0
45894948	1589505	0	0
46244826	791967	0	0
45800968	1125315	0	0
45801229	1192710	0	0
45790052	1125315	0	0
46322509	1119510	0	0
46309958	1119510	0	0
4178683	4057420	3	5
3050752	3006734	1	1
21500592	1125315	0	0
21002783	19007333	2	3
21604180	19039298	4	4
36152498	975125	0	0
36009773	4280726	1	1
36503269	4048695	6	6
42801859	19127890	0	0
44358630	1549786	0	0
42802942	1332418	0	0
44345875	1125315	0	0
45653127	1119510	0	0
45646591	1115008	0	0
44347657	1125315	0	0
45638475	1129625	0	0
45660572	1759842	0	0
45668711	1112807	0	0
45700760	1174888	0	0
45687116	1129625	0	0
45630402	19078461	2	3
45687744	40231925	2	3
45684256	1115008	0	0
45794710	1545958	0	0
45682028	1110410	0	0
45895007	1000560	0	0
46244832	1149196	0	0
45800958	1125315	0	0
45801231	1539403	0	0
45789900	1125315	0	0
46316081	1119510	0	0
46309562	1119510	0	0
4180628	198199	3	5
3050752	3001247	1	1
21500592	1112807	0	0
21002811	19059056	2	3
21604180	1125315	4	4
36152480	1515774	0	0
36009799	80809	1	1
36503269	4066995	6	6
42801859	1549786	0	0
44358829	1713332	0	0
42802775	1125315	0	0
44345879	1125315	0	0
45653531	1119510	0	0
45646595	1115008	0	0
44347529	1125315	0	0
45638582	1129625	0	0
45660610	1343916	0	0
45668543	1112807	0	0
45700766	1124300	0	0
45684116	1129625	0	0
45627260	19078461	2	3
45688594	19019273	2	3
45684241	1107830	0	0
45794926	1332418	0	0
45682036	975125	0	0
45895008	1549786	0	0
46244871	1539403	0	0
45800979	1125315	0	0
45801335	1713332	0	0
45790150	1125315	0	0
46316224	1119510	0	0
46309974	1119510	0	0
4047779	372328	3	5
3052062	3006734	1	1
21500587	1125315	0	0
21002811	19019979	2	3
21602819	1717327	2	2
36152480	1549786	0	0
35708294	4027663	1	1
36503269	4278672	6	6
42801861	1149380	0	0
44358632	1177480	0	0
42802777	1124300	0	0
44345891	1125315	0	0
45653103	1119510	0	0
45646781	1548195	0	0
44347545	1125315	0	0
45635401	1129625	0	0
45660728	1501700	0	0
45668840	1112807	0	0
45700892	975125	0	0
45684084	1129625	0	0
45630428	40223768	2	3
45688490	40236824	2	3
45684343	1551099	0	0
45794928	1153428	0	0
45682039	1332418	0	0
45894966	1192710	0	0
46244872	715997	0	0
45800770	1125315	0	0
45801310	1307863	0	0
45790160	1125315	0	0
46316311	1119510	0	0
46309572	1119510	0	0
4047779	4218389	3	5
3052062	3001247	1	1
21500587	1112807	0	0
21002811	19019273	2	3
36002869	438614	2	2
36152554	1107830	0	0
36102976	257012	1	2
36503269	4059173	6	6
42801824	1305058	0	0
44358716	1149380	0	0
42802894	1177480	0	0
44345862	1125315	0	0
45653104	1119510	0	0
45646782	1000560	0	0
44347661	1125315	0	0
45635408	1129625	0	0
45660682	1110410	0	0
45668979	1112807	0	0
45700976	1551099	0	0
45684165	1129625	0	0
45624765	1332419	2	3
45684642	1127433	2	3
45684269	1396131	0	0
45794850	1149196	0	0
45681971	1115008	0	0
45894969	1124300	0	0
46243956	715997	0	0
45801046	1125315	0	0
45801291	1501700	0	0
45789923	1125315	0	0
46316316	1119510	0	0
46309574	1119510	0	0
4047779	4029498	3	5
3051724	3001247	1	1
21500588	1125315	0	0
21002846	1115171	2	3
36002869	4139681	2	2
36152482	1759842	0	0
36221037	43012754	1	2
36503269	4237458	5	6
42801866	1125315	0	0
44356307	1738521	0	0
42802799	1307863	0	0
44345958	1125315	0	0
45653278	1119510	0	0
45646744	738818	0	0
44347691	1125315	0	0
45635247	1129625	0	0
45660553	715997	0	0
45668958	1112807	0	0
45701485	1124957	0	0
45684231	1129625	0	0
45660928	19078461	2	3
45684612	40232448	2	3
45684270	1549786	0	0
45794821	1124957	0	0
45682043	708298	0	0
45895039	967823	0	0
46243963	1557272	0	0
45800875	1125315	0	0
45801339	975125	0	0
45789810	1125315	0	0
46316270	1119510	0	0
46309931	1119510	0	0
4027403	4293740	3	5
3051724	3006734	1	1
21500588	1112807	0	0
21002844	1115171	2	3
36002869	4169137	2	2
36152482	1713332	0	0
36221037	1718412	1	2
36503269	40480160	4	6
42801900	1192710	0	0
44356321	933724	0	0
42802893	1177480	0	0
44345933	1125315	0	0
45652988	1119510	0	0
45646745	738818	0	0
44347206	1125315	0	0
45635300	1129625	0	0
45660528	791967	0	0
45668921	1112807	0	0
45701540	1000560	0	0
45684317	1129625	0	0
45633308	19078461	2	3
45684798	1551192	2	3
45684274	1149196	0	0
45794876	715997	0	0
45682099	1557272	0	0
45895189	19003953	0	0
46243974	1149196	0	0
45801212	1125315	0	0
45801379	1107830	0	0
45789814	1125315	0	0
46311135	1119510	0	0
46309457	1119510	0	0
4042641	4202451	3	4
3050153	3014599	1	1
21500589	1174888	0	0
21002844	19019273	2	3
36002869	442116	2	2
36152485	1129625	0	0
36214470	1150771	1	2
36516993	40479422	5	6
42801900	1174888	0	0
44356256	1112807	0	0
42802870	920293	0	0
44345938	1125315	0	0
45653325	1119510	0	0
45646795	1361711	0	0
44347212	1125315	0	0
45635572	1129625	0	0
45660529	1154343	0	0
45668557	1112807	0	0
45701610	1307863	0	0
45684281	1129625	0	0
45668878	19078461	2	3
45684840	19059056	2	3
45685586	1322184	0	0
45794874	1738521	0	0
45681917	1713332	0	0
45894960	933724	0	0
46244051	1174888	0	0
45800777	1125315	0	0
45795764	1124300	0	0
45790175	1125315	0	0
46311214	1119510	0	0
46310155	1119510	0	0
4043016	44805732	3	4
3050153	3012494	1	1
21500589	1177480	0	0
21004249	19112599	2	3
36002869	4102123	2	2
36152488	1124300	0	0
36214805	19112599	1	2
36516993	40479768	5	6
42801904	1713332	0	0
44356247	1539403	0	0
42802658	1332418	0	0
44346034	1125315	0	0
45653339	1119510	0	0
45646869	757627	0	0
44347215	1125315	0	0
45632323	1129625	0	0
45660734	1149196	0	0
45668805	1112807	0	0
45701815	975125	0	0
45684354	1129625	0	0
45634991	19078461	2	3
45684726	40229134	2	3
45685450	1713332	0	0
45794714	1124957	0	0
45682092	1192710	0	0
45894962	708298	0	0
46244052	1115008	0	0
45801039	1125315	0	0
45795708	975125	0	0
45789992	1125315	0	0
46310857	1119510	0	0
46310156	1119510	0	0
4103352	40481087	3	4
3050153	3001488	1	1
21500589	1125315	0	0
21004249	40229134	2	3
36203066	4218389	2	2
36152586	19127890	0	0
36214807	43012036	1	2
36516993	40486433	4	4
42801904	1759842	0	0
44356282	715997	0	0
42802660	1154343	0	0
44341228	1125315	0	0
45653095	1119510	0	0
45646870	1154343	0	0
44347360	1125315	0	0
45632394	1129625	0	0
45660646	1778162	0	0
45668884	1112807	0	0
45701712	708298	0	0
45654798	1119510	0	0
45666596	19078461	2	3
45685030	40223834	2	3
45685450	1759842	0	0
45794880	1501700	0	0
45682116	1551099	0	0
45895008	1589505	0	0
46243978	1545958	0	0
45800888	1125315	0	0
45795710	1154343	0	0
45790092	1125315	0	0
46310861	1119510	0	0
46310158	1119510	0	0
4027384	195588	3	4
3050153	3006451	1	1
21500589	1112807	0	0
21004249	43012036	2	3
36203066	78272	2	2
36152586	1515774	0	0
36159556	19127904	1	2
36516993	4280726	4	4
42801908	1124300	0	0
44356341	1177480	0	0
42802944	1177480	0	0
44341182	1125315	0	0
45653442	1119510	0	0
45646879	1174888	0	0
44347922	1125315	0	0
45632287	1129625	0	0
45660788	1759842	0	0
45666511	1112807	0	0
45701734	1124957	0	0
45654855	1119510	0	0
45664517	19078461	2	3
45682585	1115171	2	3
45685467	1192710	0	0
45794907	1115008	0	0
45682272	1154343	0	0
45894972	1112807	0	0
46244005	1174888	0	0
45801087	1125315	0	0
45795801	1107830	0	0
45790085	1125315	0	0
46310933	1119510	0	0
46309769	1119510	0	0
4027384	372328	3	4
3050153	3021226	1	1
21500583	1110410	0	0
21001846	19073188	2	3
36203066	4113008	2	2
36152586	1549786	0	0
36222375	40223821	1	2
36313965	42535580	6	7
42801912	1738521	0	0
44356441	1174888	0	0
42802904	1551099	0	0
44341322	1125315	0	0
45653458	1119510	0	0
45646883	1322184	0	0
44347620	1125315	0	0
45632432	1129625	0	0
45660788	1713332	0	0
45666495	1112807	0	0
45701675	19003953	0	0
45654738	1119510	0	0
45624460	19078461	2	3
45682625	19078461	2	3
45685577	1124300	0	0
45794913	1192710	0	0
45682106	1545958	0	0
45894973	933724	0	0
46244034	1107830	0	0
45800993	1125315	0	0
45795765	19002770	0	0
45790086	1125315	0	0
46310935	1119510	0	0
46310059	1119510	0	0
4115259	255848	3	4
3050153	3000876	1	1
21500583	1102527	0	0
21001846	19075001	2	3
36203090	196456	2	2
36152455	1307863	0	0
36222375	40223834	1	2
36313965	4037675	6	6
42801979	1154343	0	0
44356442	1549786	0	0
42802905	715997	0	0
44338715	1125315	0	0
45649770	1119510	0	0
45646905	1501700	0	0
44343625	1125315	0	0
45632365	1129625	0	0
45657464	1759842	0	0
45666502	1112807	0	0
45701676	1713332	0	0
45655079	1119510	0	0
45664021	19078461	2	3
45681678	43012036	2	3
45685579	1000560	0	0
45794634	1326303	0	0
45682250	1149196	0	0
45894991	1107830	0	0
46244055	1545958	0	0
45801150	1125315	0	0
45795766	1729720	0	0
45790011	1125315	0	0
46310938	1119510	0	0
46310062	1119510	0	0
4103183	4329847	3	4
3050153	3027231	1	1
21500143	1500211	0	0
21001846	19129655	2	3
21604036	1177480	2	2
36152558	1192710	0	0
36221667	836659	1	2
36503263	4134304	5	8
42801830	1154343	0	0
44356442	1595799	0	0
42803034	1124300	0	0
44338722	1125315	0	0
45652002	1119510	0	0
45646888	1000560	0	0
44344842	1125315	0	0
45632442	1129625	0	0
45657464	1713332	0	0
45666444	1112807	0	0
45701677	975125	0	0
45655104	1119510	0	0
45642658	19078461	2	3
45681679	19023398	2	3
45685700	740275	0	0
45794779	1309944	0	0
45682251	1713332	0	0
45895026	1717327	0	0
46244181	1332418	0	0
45799700	1125315	0	0
45795778	1110410	0	0
45790188	1125315	0	0
46310942	1119510	0	0
46310007	1119510	0	0
4086181	381316	3	4
3050153	3015076	1	1
21500143	1548195	0	0
21001846	19073183	2	3
21604036	1124300	2	2
36152544	705944	0	0
36221668	836659	1	2
36503263	40479422	5	6
42801841	1154029	0	0
44356442	1521369	0	0
42802678	723013	0	0
44338649	1125315	0	0
45651938	1119510	0	0
45646826	1310149	0	0
44344725	1125315	0	0
45629297	1129625	0	0
45657465	1107830	0	0
45666520	1112807	0	0
45701797	1107830	0	0
45655109	1119510	0	0
45633223	19078461	2	3
45681939	1127433	2	3
45685704	1713332	0	0
45794940	1322184	0	0
45682382	1548195	0	0
45895036	1192710	0	0
46243988	1307863	0	0
45799770	1125315	0	0
45795822	1307863	0	0
45792021	1125315	0	0
46311163	1119510	0	0
46304428	1119510	0	0
4086181	4066995	3	4
3052929	3006734	1	1
21500146	1589505	0	0
21001846	1713671	2	3
36002868	4051466	2	2
36152550	1738521	0	0
36214641	40236824	1	2
36503263	40479768	5	6
42802142	1545958	0	0
44356444	920293	0	0
42802977	1115008	0	0
44338729	1125315	0	0
45650025	1119510	0	0
45646827	1551099	0	0
44344749	1125315	0	0
45629300	1129625	0	0
45657467	1124300	0	0
45666682	1112807	0	0
45701820	1713332	0	0
45654785	1119510	0	0
45664534	19078461	2	3
45681820	1551192	2	3
45685704	1759842	0	0
45679221	1332418	0	0
45682198	1115008	0	0
45894982	791967	0	0
46243993	1115008	0	0
45799751	1125315	0	0
45795784	1149196	0	0
45792078	1125315	0	0
46311185	1119510	0	0
46304430	1119510	0	0
4091532	4166224	3	4
3052929	3001247	1	1
21500147	1521369	0	0
21001924	19074841	2	3
36203060	4218389	2	2
36152552	1177480	0	0
1738521	46233710	2	3
36503263	4149245	4	5
42802036	1153428	0	0
44356450	1107830	0	0
42802978	1500211	0	0
44338772	1125315	0	0
45646673	1119510	0	0
45646841	1110410	0	0
44343724	1125315	0	0
45629510	1129625	0	0
45657480	1000560	0	0
45666706	1112807	0	0
45701793	723013	0	0
45655118	1119510	0	0
45624808	19079524	2	3
45681866	19019273	2	3
45685660	1107830	0	0
45679326	1107830	0	0
45682201	967823	0	0
45895107	975125	0	0
46244008	19010482	0	0
45799752	1125315	0	0
45795794	1174888	0	0
45787435	1125315	0	0
46311304	1119510	0	0
46304526	1119510	0	0
4181063	4112343	3	4
3052932	3001247	1	1
21500147	933724	0	0
21001924	19075001	2	3
21602657	933724	2	2
36152528	1549786	0	0
36213587	19127918	2	3
36503263	81151	4	6
42802175	1515774	0	0
44356452	1713332	0	0
42802982	1125315	0	0
44338682	1125315	0	0
45646739	1119510	0	0
45646924	1361711	0	0
44343732	1125315	0	0
45629378	1129625	0	0
45658564	1115008	0	0
45666858	1112807	0	0
45701935	1713332	0	0
45655201	1119510	0	0
45666788	1545959	2	3
45678570	40163554	2	3
45685708	1729720	0	0
45679383	1545958	0	0
45682324	975125	0	0
45895109	1174888	0	0
46240097	975125	0	0
45798065	1125315	0	0
45795794	1192710	0	0
45787436	1125315	0	0
46311594	1119510	0	0
46304410	1119510	0	0
4172024	4174876	3	4
3052932	3006734	1	1
21500147	1500211	0	0
21001924	19074843	2	3
36002874	80809	2	2
36152529	1713332	0	0
36213587	19128009	2	3
36502196	4059173	6	6
42802175	1549786	0	0
44356452	1759842	0	0
42802474	1332418	0	0
44338791	1125315	0	0
45646744	1119510	0	0
45646926	1728416	0	0
44343715	1125315	0	0
45629179	1129625	0	0
45658565	1192710	0	0
45664414	1112807	0	0
45701914	1729720	0	0
45700759	1119510	0	0
45635088	1332419	2	3
45678574	40162522	2	3
45685539	1343916	0	0
45678980	1112807	0	0
45682465	1326303	0	0
45895062	1332418	0	0
46238902	1192710	0	0
45798085	1125315	0	0
45795861	1000560	0	0
45787438	1125315	0	0
46322095	1119510	0	0
46304633	1119510	0	0
4103662	4132546	3	4
3052978	3001247	1	1
21500131	1548195	0	0
21001924	19073183	2	3
35702741	30753	2	2
36152532	1177480	0	0
36158196	19078461	2	3
36502196	4142905	5	6
42802224	1549786	0	0
44356343	1332418	0	0
42802578	1539403	0	0
44338732	1125315	0	0
45646848	1119510	0	0
45646954	1738521	0	0
44343956	1125315	0	0
45629601	1129625	0	0
45658547	1713332	0	0
45664304	1112807	0	0
45701772	1548195	0	0
45700839	1119510	0	0
45636777	1545959	2	3
45678696	40232448	2	3
45684429	1149196	0	0
45679272	975125	0	0
45681995	1107830	0	0
45895015	1112807	0	0
46238931	1332418	0	0
45798111	1125315	0	0
45795839	1174888	0	0
45787439	1125315	0	0
46322418	1119510	0	0
46304668	1119510	0	0
4176642	4107731	3	4
3052978	3006734	1	1
21500145	19127890	0	0
21001924	19073188	2	3
36211677	40480160	2	2
36152532	1174888	0	0
35507075	1545959	2	3
36502196	4237458	5	6
42801990	1107830	0	0
44356344	738818	0	0
44355398	1129625	0	0
44338736	1125315	0	0
45646952	1119510	0	0
45647105	1557272	0	0
44344038	1125315	0	0
45629549	1129625	0	0
45658344	1110410	0	0
45660965	1112807	0	0
45701874	1124957	0	0
45701611	1119510	0	0
45668550	1545959	2	3
45678554	19008572	2	3
45684394	967823	0	0
45679274	1115008	0	0
45682218	1501700	0	0
45895051	1713332	0	0
46238882	1149196	0	0
45798145	1125315	0	0
45795915	1551099	0	0
45787370	1125315	0	0
46322611	1119510	0	0
46304905	1119510	0	0
4178367	4024289	3	4
3052983	3006734	1	1
21500145	1589505	0	0
21013671	1310034	2	3
36203047	4048695	2	2
36152622	1549786	0	0
35506822	40174880	2	3
36502205	78272	6	8
42802063	1125315	0	0
44356293	1521369	0	0
44355398	1125315	0	0
44339050	1125315	0	0
45646862	1119510	0	0
45647133	1153428	0	0
44344046	1125315	0	0
45629567	1129625	0	0
45658346	967823	0	0
45661676	1112807	0	0
45701886	1713332	0	0
45701626	1119510	0	0
45664361	1539411	2	3
45678556	1154615	2	3
45684379	738818	0	0
45679225	1107830	0	0
45682230	1174888	0	0
45895052	791967	0	0
46238918	1107830	0	0
45798185	1125315	0	0
45795921	791967	0	0
45787475	1125315	0	0
46316495	1119510	0	0
46304911	1119510	0	0
4178367	4252419	3	4
3052983	3001247	1	1
21500145	1595799	0	0
21001866	1551192	2	3
36002141	81893	2	2
36152627	1153428	0	0
36217212	19126352	2	3
36502197	4142905	6	8
42802073	1125315	0	0
44356293	1549786	0	0
44355568	1177480	0	0
44339075	1125315	0	0
45646993	1119510	0	0
45647135	1717327	0	0
44344016	1125315	0	0
45629364	1129625	0	0
45658351	1521369	0	0
45661656	1112807	0	0
45701886	1759842	0	0
45701706	1119510	0	0
45633279	1545959	2	3
45678667	40231925	2	3
45684380	1154343	0	0
45679231	1112807	0	0
45682231	1501700	0	0
45895067	1112807	0	0
46238966	1322184	0	0
45798069	1125315	0	0
45795922	1000560	0	0
45787256	1125315	0	0
46316522	1119510	0	0
46305172	1119510	0	0
4042835	4294548	3	4
3053021	3006734	1	1
21500145	1521369	0	0
21002827	19019273	2	3
36203055	4132546	2	2
36152629	975125	0	0
1728416	19006318	2	3
36503289	4048171	6	6
42802073	1174888	0	0
44356358	1551099	0	0
44355524	1521369	0	0
44338908	1125315	0	0
45646994	1119510	0	0
45647138	1501700	0	0
44344223	1125315	0	0
45629483	1129625	0	0
45658401	1549786	0	0
45654775	1112807	0	0
45701967	1154343	0	0
45701795	1119510	0	0
45630921	1539411	2	3
45678908	19008572	2	3
45684472	1500211	0	0
45679145	1112807	0	0
45682364	975125	0	0
45895069	1124957	0	0
46238893	1192710	0	0
45798276	1125315	0	0
45795799	1361711	0	0
45787417	1125315	0	0
46317367	1119510	0	0
46305184	1119510	0	0
4040392	4238715	3	4
3053021	3001247	1	1
21500145	1503184	0	0
21002827	1551192	2	3
36002872	40486433	2	2
36152632	1149196	0	0
36157948	19078461	2	3
36502205	40479422	5	6
42801938	1177480	0	0
44356473	1124300	0	0
44355524	1549786	0	0
44338806	1125315	0	0
45647087	1119510	0	0
45647139	19010482	0	0
44340088	1125315	0	0
45629492	1129625	0	0
45658401	1518198	0	0
45654895	1112807	0	0
45701971	738818	0	0
45701764	1119510	0	0
45636894	1539411	2	3
45672404	40228230	2	3
45684397	1192710	0	0
45679342	1192710	0	0
45682377	975125	0	0
45895055	967823	0	0
46239033	1539403	0	0
45798159	1125315	0	0
45795866	1332418	0	0
45787196	1125315	0	0
46318012	1119510	0	0
46304500	1119510	0	0
4040721	4010253	3	4
3013094	3013721	1	1
21500145	1515774	0	0
21013433	46233710	2	3
21602553	19127922	2	2
36152633	1149196	0	0
21603968	19019273	2	3
36502205	40479768	5	6
42802151	1545958	0	0
44356475	1115008	0	0
44355574	1115008	0	0
44338798	1125315	0	0
45646109	1119510	0	0
45646709	1548195	0	0
44340093	1125315	0	0
45629414	1129625	0	0
45658386	1115008	0	0
45654883	1112807	0	0
45701974	1738521	0	0
45701806	1119510	0	0
45688793	1539411	2	3
45673384	40231925	2	3
45684406	19127890	0	0
45679348	1107830	0	0
45682010	1110410	0	0
45895133	1112807	0	0
46238980	1115008	0	0
45798261	1125315	0	0
45795982	1154343	0	0
45787483	1125315	0	0
46317538	1119510	0	0
46304961	1119510	0	0
4155793	4024289	3	4
3013094	3024561	1	1
21500145	1549786	0	0
21013433	19129655	2	3
21602553	19133679	2	2
36152626	1322184	0	0
35506892	40228214	2	3
36603422	78272	7	7
42802154	914335	0	0
44356269	975125	0	0
44355592	1549786	0	0
44338903	1125315	0	0
45645860	1119510	0	0
45647114	1174888	0	0
44340439	1125315	0	0
45631097	1129625	0	0
45657513	1778162	0	0
45634911	1149196	0	0
45701996	975125	0	0
45701921	1119510	0	0
45648856	1539411	2	3
45672723	1551192	2	3
45684406	1549786	0	0
45679352	1112807	0	0
45682014	1149380	0	0
45895212	1361711	0	0
46238981	1192710	0	0
45798397	1125315	0	0
45795809	1326303	0	0
45787280	1125315	0	0
46316840	1119510	0	0
46305194	1119510	0	0
4180628	44782520	3	4
3013094	3035995	1	1
21500145	1512674	0	0
21013433	920334	2	3
21602553	19129144	2	2
36152655	975125	0	0
36152237	19078461	2	3
36516772	4134304	7	8
42802156	1125315	0	0
44356350	975125	0	0
44355592	1521369	0	0
44339201	1125315	0	0
45643853	1119510	0	0
45647147	1713332	0	0
44340504	1125315	0	0
45626534	1129625	0	0
45657550	1549786	0	0
45634844	920293	0	0
45701998	1149380	0	0
45701971	1119510	0	0
45648644	1539411	2	3
45672649	920334	2	3
45684391	1149196	0	0
45679189	1539403	0	0
45678933	1115008	0	0
45895121	701322	0	0
46239068	1115008	0	0
45798508	1125315	0	0
45795850	1307863	0	0
45875962	21494966	2	2
46316841	1119510	0	0
46304936	1119510	0	0
4180628	372328	3	4
3013094	3006923	1	1
21500146	19127890	0	0
21013433	1713671	2	3
36153492	19128022	2	2
36152601	1119510	0	0
36152697	1107882	2	3
36516825	4134304	7	7
42802209	723013	0	0
44356463	975125	0	0
44355593	1119510	0	0
44339207	1125315	0	0
45643926	1119510	0	0
45647141	1174888	0	0
44340387	1125315	0	0
45626537	1129625	0	0
45657550	1521369	0	0
45634966	1501700	0	0
45701998	1137529	0	0
45698488	1119510	0	0
45651698	46275916	1	1
45672731	40232448	2	3
45684453	1326303	0	0
45679207	1305058	0	0
45678937	1107830	0	0
45895087	1361711	0	0
46239043	1332418	0	0
45798302	1125315	0	0
45795871	1307863	0	0
46244893	42902245	2	2
46311484	1119510	0	0
46320891	1119510	0	0
4042836	4132546	3	4
3013094	3020630	1	1
21500146	1521369	0	0
21013433	46233988	2	3
21602537	1500211	2	2
36152730	1741122	0	0
36157005	1107882	2	3
36503266	4134304	4	6
42802220	975125	0	0
44356464	1115008	0	0
44355501	1125315	0	0
44339063	1125315	0	0
45643928	1119510	0	0
45646861	715997	0	0
44340039	1125315	0	0
45626771	1129625	0	0
45657563	1326303	0	0
45634972	1713332	0	0
45701938	1124300	0	0
45698821	1119510	0	0
45651698	19079524	1	1
45672758	19059056	2	3
45684455	1309944	0	0
45679245	715997	0	0
45678759	1539403	0	0
45895197	1192710	0	0
46239035	975125	0	0
45795364	1125315	0	0
45795872	1149196	0	0
46243956	40223768	2	3
46311630	1119510	0	0
46321160	1119510	0	0
4042836	257012	3	4
1718400	19132304	1	1
21500146	1595799	0	0
21013433	920300	2	3
21602551	1521369	2	2
36152730	1746114	0	0
36156854	1107882	2	3
36502205	4146173	4	5
42802181	1154343	0	0
44356404	1177480	0	0
44355596	1539403	0	0
44339070	1125315	0	0
45643946	1119510	0	0
45646981	1154343	0	0
44339948	1125315	0	0
45626661	1129625	0	0
45657521	1539403	0	0
45634972	1759842	0	0
45701964	975125	0	0
45700548	1119510	0	0
45704402	19079524	1	1
45672856	40232448	2	3
45684473	1501700	0	0
45679252	1307863	0	0
45678760	975125	0	0
45895235	1549786	0	0
46239042	1192710	0	0
45795402	1125315	0	0
45795984	715997	0	0
46238947	19078461	2	3
46306376	1119510	0	0
46321559	1119510	0	0
4042836	40481087	3	4
1718400	1718412	1	1
21500146	1515774	0	0
21013433	19075001	2	3
36211382	4066995	2	2
36152567	1124300	0	0
21603266	40169281	2	3
36475214	1119510	0	0
42802077	1000560	0	0
44356483	1115008	0	0
44355600	1154343	0	0
44360302	1125315	0	0
45644070	1119510	0	0
45647197	1545958	0	0
44340369	1125315	0	0
45626582	1129625	0	0
45657576	1107830	0	0
45635064	1149196	0	0
45698817	1343916	0	0
45698943	1119510	0	0
45648780	46275916	1	1
45672982	40231925	2	3
45684407	1501700	0	0
45679182	1154343	0	0
45678883	19127890	0	0
45895235	1515774	0	0
46239002	920293	0	0
45795407	1125315	0	0
45795814	791967	0	0
45798614	19078461	2	3
46306501	1119510	0	0
46321191	1119510	0	0
4047779	140673	3	4
1718400	46221626	1	1
21500146	1549786	0	0
21002591	46233710	2	3
36211382	4048695	2	2
36152589	1149196	0	0
36152939	40228214	2	3
36475223	1521369	0	0
42802228	1124300	0	0
44356416	738818	0	0
44355531	1125315	0	0
44360316	1125315	0	0
45643992	1119510	0	0
44352155	1549786	0	0
44340032	1125315	0	0
45626687	1129625	0	0
45657659	1332418	0	0
45634941	1149196	0	0
45698853	1149196	0	0
45699029	1119510	0	0
45648780	19079524	1	1
45672845	40232448	2	3
45684416	1149196	0	0
45679441	715997	0	0
45678883	1549786	0	0
45895241	1343916	0	0
46238993	1192710	0	0
45795411	1125315	0	0
45795882	1551099	0	0
45787961	19078461	2	3
46306218	1119510	0	0
46321308	1119510	0	0
4027403	4295880	3	4
1718402	46221626	1	1
21500137	1521369	0	0
21002591	19074841	2	3
36009740	37017711	2	2
36152760	1149196	0	0
35506945	19075601	2	3
36475223	1549786	0	0
42802224	1589505	0	0
44356491	1332418	0	0
44355531	1119510	0	0
44360413	1125315	0	0
45644015	1119510	0	0
44352291	715997	0	0
44340637	1125315	0	0
45626868	1129625	0	0
45657666	1521369	0	0
45635001	1115008	0	0
45698863	1305058	0	0
45699043	1119510	0	0
45695031	19079524	1	1
45672850	19008572	2	3
45684440	1713332	0	0
45679445	1112807	0	0
45678634	1174888	0	0
45895324	738818	0	0
46238998	975125	0	0
45795570	1125315	0	0
45795892	975125	0	0
46239183	19078461	2	3
46306516	1119510	0	0
46321331	1119510	0	0
4028902	4151422	3	3
1718403	19132304	1	1
21012460	715997	0	0
21002591	19129655	2	3
36009740	433644	2	2
36152762	1119510	0	0
21502734	1310034	2	3
36475351	1149196	0	0
42802043	1177480	0	0
44356471	1112807	0	0
44355657	1119510	0	0
44360049	1125315	0	0
45641216	1119510	0	0
44352370	738818	0	0
44340196	1125315	0	0
45626904	1129625	0	0
45657666	1548195	0	0
45635035	1192710	0	0
45698880	791967	0	0
45698933	1119510	0	0
45642831	19079524	1	1
45672771	19076374	2	3
45684543	1332418	0	0
45679448	1154029	0	0
45678678	1332418	0	0
45895173	740275	0	0
46239292	975125	0	0
45795669	1125315	0	0
45796122	1000560	0	0
45798690	19078461	2	3
46306244	1119510	0	0
46321354	1119510	0	0
4040394	4108705	3	3
1718405	1718412	1	1
21013408	1551099	0	0
21002591	46275444	2	3
36009740	4240902	2	2
36152735	19003953	0	0
36156287	19075601	2	3
36475417	1119510	0	0
42802139	1115008	0	0
44356494	1177480	0	0
44355657	1125315	0	0
44360209	1125315	0	0
45640901	1119510	0	0
44352373	1521369	0	0
44340197	1125315	0	0
45623310	1129625	0	0
45657595	1174888	0	0
45635150	975125	0	0
45698884	1124300	0	0
45695474	1119510	0	0
45636743	46275916	1	1
45784682	40232448	2	3
45684574	1115008	0	0
45679492	1746114	0	0
45678867	1192710	0	0
45895091	1713332	0	0
46239056	1107830	0	0
45795547	1125315	0	0
45796043	1124957	0	0
45788231	1332419	2	3
46306468	1119510	0	0
46321108	1119510	0	0
4032257	42535580	3	3
1718411	1718412	1	1
21012460	701322	0	0
21002591	46233988	2	3
36009740	4219399	2	2
36152736	1177480	0	0
36152376	40228214	2	3
36475856	1119510	0	0
42802120	1551099	0	0
44356584	1149380	0	0
44355659	1551099	0	0
44360349	1125315	0	0
45640912	1119510	0	0
44352373	1549786	0	0
44340203	1125315	0	0
45623370	1129625	0	0
45657678	1107830	0	0
45635151	738818	0	0
45698480	708298	0	0
45695556	1119510	0	0
45636743	19079524	1	1
45784550	40232448	2	3
45684576	1539403	0	0
45679492	1741122	0	0
45678868	791967	0	0
45895091	1759842	0	0
46239187	1115008	0	0
45795658	1125315	0	0
45795932	967823	0	0
45896146	19078461	2	3
46306739	1119510	0	0
46320954	1119510	0	0
4176644	372328	3	3
1718993	1718412	1	1
21013408	19010482	0	0
21002591	19075001	2	3
36009869	4280726	2	2
36152880	1119510	0	0
36157655	19078461	2	3
36474269	1332418	0	0
42802048	975125	0	0
44356588	1112807	0	0
44355663	1361711	0	0
44360239	1125315	0	0
45641116	1119510	0	0
44352373	1595799	0	0
44340204	1125315	0	0
45623373	1129625	0	0
45657838	1000560	0	0
45635343	1149196	0	0
45698712	1738521	0	0
45695778	1119510	0	0
45645758	19079524	1	1
45784558	1551192	2	3
45681442	1115008	0	0
45679501	1343916	0	0
45678647	1539403	0	0
45895097	1149196	0	0
46239009	1713332	0	0
45795690	1125315	0	0
45795900	1124957	0	0
46299418	19078461	2	3
46306230	1119510	0	0
46321588	1119510	0	0
4176944	4294548	3	3
1545961	1545959	1	1
21013411	1717327	0	0
21002591	1713671	2	3
36009869	40486433	2	2
36152880	738818	0	0
36213586	19128009	2	3
36474281	1119510	0	0
42802051	1125315	0	0
44356590	1713332	0	0
44355664	1119510	0	0
44359936	1125315	0	0
45641130	1119510	0	0
44351211	1149196	0	0
44340324	1125315	0	0
45623374	1129625	0	0
45657683	1115008	0	0
45634992	1307863	0	0
45698723	1124957	0	0
45694383	1119510	0	0
45688814	19079524	1	1
45784788	40232448	2	3
45681447	1154343	0	0
45679651	1153428	0	0
45678916	967823	0	0
45895099	975125	0	0
46239093	1713332	0	0
45796925	1125315	0	0
45796049	791967	0	0
46298940	19078461	2	3
46306577	1119510	0	0
46321595	1119510	0	0
4148703	4330583	3	3
1326409	19018935	1	1
21013409	1551099	0	0
21002591	19074843	2	3
35702732	4266809	2	2
36152889	1115008	0	0
36213586	19127918	2	3
36473642	1548195	0	0
42802053	1149380	0	0
44356590	1759842	0	0
44355667	1125315	0	0
44359938	1125315	0	0
45641137	1119510	0	0
44351230	1149196	0	0
44337465	1125315	0	0
45623529	1129625	0	0
45657688	1729720	0	0
45634994	967823	0	0
45698484	1107830	0	0
45694701	1119510	0	0
45694997	19079524	1	1
45784665	40162522	2	3
45681454	1192710	0	0
45679291	1332418	0	0
45678851	1768849	0	0
45895151	967823	0	0
46239093	1759842	0	0
45796935	1125315	0	0
45790672	967823	0	0
46290880	19078461	2	3
46317158	1119510	0	0
46321457	1119510	0	0
4063381	258780	3	3
1150866	1150837	1	1
21013418	1305058	0	0
21002591	19073188	2	3
36203068	4066995	2	2
36152570	1149196	0	0
36152626	19075601	2	3
36473662	1119510	0	0
42802125	1307863	0	0
44356578	723013	0	0
44355667	1119510	0	0
44360306	1125315	0	0
45641139	1119510	0	0
44351280	1332418	0	0
44337366	1125315	0	0
45623743	1129625	0	0
45657677	19127890	0	0
45634984	1115008	0	0
45698488	738818	0	0
45692438	1119510	0	0
45627846	19079524	1	1
45784924	40163554	2	3
45681458	1521369	0	0
45792050	1149196	0	0
45678735	1549786	0	0
45895186	967823	0	0
46239101	975125	0	0
45796937	1125315	0	0
45790355	1192710	0	0
46239452	19078461	2	3
46317299	1119510	0	0
46315373	1119510	0	0
4042822	4330583	3	3
1150808	1150771	1	1
21013411	1778162	0	0
21002805	1551192	2	3
35902852	196456	2	2
36152462	1551099	0	0
36213592	42902245	2	3
36473711	1149196	0	0
42802231	975125	0	0
44356629	1174888	0	0
44355667	738818	0	0
44360262	1125315	0	0
45641253	1119510	0	0
44351323	1521369	0	0
45620324	1125315	0	0
45623422	1129625	0	0
45657677	1549786	0	0
45634985	738818	0	0
45698887	1545958	0	0
45692414	1119510	0	0
45688943	19079524	1	1
45784764	19008572	2	3
45681458	1595799	0	0
45792058	1115008	0	0
45678735	1589505	0	0
45895330	1149196	0	0
46239102	1118084	0	0
45797231	1125315	0	0
45790359	1149196	0	0
45801560	19078461	2	3
45896740	1125315	0	0
46315661	1119510	0	0
4028970	258780	3	3
764205	4056621	1	1
21013403	1551099	0	0
21002805	1115171	2	3
35902853	196456	2	2
36152463	1115008	0	0
36213593	42902245	2	3
36473773	1177480	0	0
42802236	1125315	0	0
44356631	1738521	0	0
44355669	1729720	0	0
44360270	1125315	0	0
45641300	1119510	0	0
44351323	19127890	0	0
45620277	1125315	0	0
45623452	1129625	0	0
45657542	1551099	0	0
45634986	1322184	0	0
45698675	1343916	0	0
45692427	1119510	0	0
45704399	19079524	1	1
45784734	19133905	2	3
45681458	1549786	0	0
45792103	1539403	0	0
45678854	967823	0	0
45894334	1309944	0	0
46239110	975125	0	0
45797233	1125315	0	0
45790459	1115008	0	0
46244086	19078461	2	3
45895704	1125315	0	0
46315667	1119510	0	0
4040560	4163971	3	3
443723	439777	1	1
21013390	1309944	0	0
21002805	19007333	2	3
35909418	198809	2	2
36152703	975125	0	0
36152633	40228214	2	3
36473817	1309944	0	0
42802236	1174888	0	0
44349193	1738521	0	0
44355670	975125	0	0
44360344	1125315	0	0
45641362	1119510	0	0
44351323	1549786	0	0
45620165	1125315	0	0
45623407	1129625	0	0
45657652	1310149	0	0
45635068	1000560	0	0
45698736	1549786	0	0
45692430	1119510	0	0
45666914	19079524	1	1
45784734	19133873	2	3
45681329	1332418	0	0
45792031	1713332	0	0
45678739	1521369	0	0
45894492	19010482	0	0
46239318	1149196	0	0
45796943	1125315	0	0
45790676	1332418	0	0
46244253	19078461	2	3
45895587	1125315	0	0
46315968	1119510	0	0
4027717	4186930	3	3
440320	4116491	1	1
21013433	1713332	0	0
21002805	19019979	2	3
35702777	4027663	2	2
36152576	933724	0	0
36156842	40228214	2	3
36473881	1125315	0	0
42802237	740275	0	0
44349312	1107830	0	0
44355671	1124300	0	0
44360346	1125315	0	0
45641374	1119510	0	0
44351256	1545958	0	0
45620187	1125315	0	0
45667907	1129625	0	0
45657775	738818	0	0
45635004	1115008	0	0
45698736	19127890	0	0
45692729	1119510	0	0
45676465	19079524	1	1
45782439	40224805	2	3
45681464	1551099	0	0
45792031	1759842	0	0
45678739	19127890	0	0
45894477	1174888	0	0
45790468	1545958	0	0
45792994	1125315	0	0
45790519	1332418	0	0
45793266	19078461	2	3
45895639	1125315	0	0
46315780	1119510	0	0
4133611	4001336	3	3
3050951	3016723	1	2
21013433	1717327	0	0
21002805	19059056	2	3
35508412	40162522	2	3
36152577	1119510	0	0
36157771	40228214	2	3
36473965	1124300	0	0
42801926	1149380	0	0
44349328	1192710	0	0
44355570	1125315	0	0
44362727	1125315	0	0
45641398	1119510	0	0
44351342	1717327	0	0
45620384	1125315	0	0
45667935	1129625	0	0
45657786	1107830	0	0
45634977	723013	0	0
45698736	1589505	0	0
45692519	1119510	0	0
45695037	19079524	1	1
45783590	42707627	2	3
45681472	1192710	0	0
45792258	1548195	0	0
45678739	1549786	0	0
45894313	1501700	0	0
45790474	740275	0	0
45793009	1125315	0	0
45790522	1115008	0	0
45801557	19078461	2	3
45895642	1125315	0	0
46316029	1119510	0	0
4028876	260139	3	3
3051542	3013682	1	2
21013457	740275	0	0
21600248	1310034	2	5
35508270	1115171	2	3
36152579	1124957	0	0
36152760	40228214	2	3
36474109	1125315	0	0
42801928	920293	0	0
44349328	1174888	0	0
44355723	1174888	0	0
44362523	1125315	0	0
45638137	1119510	0	0
44351287	1322184	0	0
45620441	1125315	0	0
45667613	1129625	0	0
45657787	1124957	0	0
45635092	1332418	0	0
45698685	1501700	0	0
45692431	1119510	0	0
45645661	19079524	1	1
45783579	19129655	2	3
45681473	738818	0	0
45792266	705944	0	0
45678742	1149196	0	0
45894408	1153428	0	0
45790613	1332418	0	0
45793017	1125315	0	0
45790525	1115008	0	0
46243775	19078461	2	3
45895578	1125315	0	0
46315592	1119510	0	0
4063579	4062501	3	3
1718406	1718412	1	2
21003385	975125	0	0
21600269	1310034	1	4
35508602	40224805	2	3
36152581	1107830	0	0
36152874	40228214	2	3
36468849	1177480	0	0
42802184	1545958	0	0
44349214	1149196	0	0
44355729	1713332	0	0
44362704	1125315	0	0
45638015	1119510	0	0
44351350	1713332	0	0
45620442	1125315	0	0
45667742	1129625	0	0
45657813	1110410	0	0
45635093	738818	0	0
45698687	1110410	0	0
45692491	1119510	0	0
45683153	19079524	1	1
45782678	1115171	2	3
45681583	1124957	0	0
45792062	1115008	0	0
45678744	1124957	0	0
45894412	1332418	0	0
45790418	1112807	0	0
45792825	1125315	0	0
45790638	1192710	0	0
46243853	19078461	2	3
45895626	1125315	0	0
46316009	1119510	0	0
4032377	4230209	3	3
320136	4112343	3	7
21003387	1129625	0	0
21503165	1119510	1	1
35508625	40229134	2	3
36152638	1589505	0	0
35507154	40228214	2	3
36475983	1177480	0	0
42801992	1548195	0	0
44349397	1177480	0	0
44355729	1759842	0	0
44350839	1125315	0	0
45637957	1119510	0	0
44351354	723013	0	0
45620550	1125315	0	0
45667743	1129625	0	0
45657822	1192710	0	0
45635042	1310149	0	0
45698911	1174888	0	0
45692604	1119510	0	0
45691704	19079524	1	1
45782969	40228230	2	3
45681197	1778162	0	0
45792251	1000560	0	0
45678949	1519936	0	0
45894413	1110410	0	0
45787596	705944	0	0
45792831	1125315	0	0
45790644	1115008	0	0
46294316	19078461	2	3
45895645	1125315	0	0
46310178	1119510	0	0
4032377	4234705	3	3
320136	261325	3	6
21003387	1343916	0	0
21503165	1125315	1	1
35508513	40229134	2	3
36152939	1149196	0	0
36152946	19078461	2	3
36476757	1149380	0	0
42802094	1521369	0	0
44349525	1307863	0	0
44355692	1110410	0	0
44350683	1125315	0	0
45637939	1119510	0	0
44351377	791967	0	0
45620362	1125315	0	0
45667817	1129625	0	0
45657522	1713332	0	0
45635057	1192710	0	0
45700518	1307863	0	0
45692550	1119510	0	0
45660118	19079524	1	1
45782855	40162522	2	3
45681284	1115008	0	0
45792338	1332418	0	0
45679366	1149196	0	0
45894495	1107830	0	0
45787766	1738521	0	0
45792756	1125315	0	0
45790661	1174888	0	0
45893946	19078461	2	3
45895664	1125315	0	0
46309811	1119510	0	0
4154739	4059173	3	3
320136	4294548	3	6
21003377	1192710	0	0
21503166	1119510	1	1
36203042	4142905	2	3
36152946	1177480	0	0
36157581	19078461	2	3
36476385	1129625	0	0
42802204	1322184	0	0
44349530	1521369	0	0
44355845	1107830	0	0
44350535	1125315	0	0
45638106	1119510	0	0
44347267	1545958	0	0
45620357	1125315	0	0
45665454	1129625	0	0
45657637	1124957	0	0
45635161	1500211	0	0
45700586	19127890	0	0
45692583	1119510	0	0
45704463	46275916	1	1
45782710	19018935	2	3
45681291	975125	0	0
45792197	975125	0	0
45679370	1000560	0	0
45894454	1149196	0	0
45787402	1307863	0	0
45793089	1125315	0	0
45790486	1174888	0	0
46294543	19078461	2	3
45895679	1125315	0	0
46310038	1119510	0	0
4154739	4048695	3	3
320136	40486433	3	6
21003377	1129625	0	0
21503166	1112807	1	1
35702718	4285898	2	3
36152607	1119510	0	0
35506942	19078461	2	3
36476385	1125315	0	0
42802101	1115008	0	0
44349530	1549786	0	0
44355542	1118084	0	0
44350541	1125315	0	0
45638151	1119510	0	0
44347473	791967	0	0
45620509	1125315	0	0
45665573	1129625	0	0
45657944	1501700	0	0
45635087	1149196	0	0
45700586	1549786	0	0
45692620	1119510	0	0
45704463	19079524	1	1
45782771	40231925	2	3
45681293	1326303	0	0
45792182	1112807	0	0
45705238	738818	0	0
45894456	19127890	0	0
45787426	1112807	0	0
45792852	1125315	0	0
45790487	1332418	0	0
46239541	19078461	2	3
45895686	1125315	0	0
46311900	1119510	0	0
4154739	4278672	3	3
320136	260139	3	6
21003402	19010482	0	0
21503166	1125315	1	1
36203060	4149245	2	3
36152611	738818	0	0
36157711	19078461	2	3
36476510	1125315	0	0
42802192	1119510	0	0
44349337	1545958	0	0
44355549	1112807	0	0
44350529	1125315	0	0
45638077	1119510	0	0
44347239	1545958	0	0
44362219	1125315	0	0
45665583	1129625	0	0
45657790	1107830	0	0
45635088	1332418	0	0
45700589	975125	0	0
45689619	1119510	0	0
45707121	19079524	1	1
45780544	40232448	2	3
45681298	975125	0	0
45792089	1174888	0	0
45705267	738818	0	0
45894456	1515774	0	0
45787432	1539403	0	0
45792931	1125315	0	0
45790618	1738521	0	0
45790976	19078461	2	3
45802504	1125315	0	0
46311849	1119510	0	0
4154739	4066995	3	3
77960	81151	3	5
21003378	975125	0	0
21503166	1129625	1	1
36152833	19008572	2	3
36152611	1119510	0	0
36157610	1332419	2	3
36476549	1119510	0	0
42802168	1738521	0	0
44349402	1322184	0	0
44355615	1308738	0	0
44350825	1125315	0	0
45637970	1119510	0	0
44347269	1778162	0	0
44362100	1125315	0	0
45665709	1129625	0	0
45654046	740275	0	0
45635381	1174888	0	0
45700526	914335	0	0
45689593	1119510	0	0
45645945	19079524	1	1
45780781	19133905	2	3
45681302	1149196	0	0
45792093	1124957	0	0
45780010	738818	0	0
45894456	1549786	0	0
45787408	1112807	0	0
45792935	1125315	0	0
45790492	1000560	0	0
45801472	1545959	2	3
45801989	1125315	0	0
46312027	1119510	0	0
4154739	40480160	3	3
3050940	3023103	3	5
21003400	19010482	0	0
21503166	738818	1	1
36153433	1127433	2	3
36152872	1119510	0	0
35507048	1332419	2	3
36476549	1125315	0	0
42807218	1545958	0	0
44349334	1713332	0	0
44355617	1177480	0	0
44350638	1125315	0	0
45638057	1119510	0	0
44347162	1149196	0	0
44362104	1125315	0	0
45663134	1129625	0	0
45654048	738818	0	0
45635382	1174888	0	0
45700615	1713332	0	0
45691569	1119510	0	0
45667161	19079524	1	1
45780632	19019273	2	3
45681502	1174888	0	0
45792096	1174888	0	0
45780053	738818	0	0
45894461	1174888	0	0
45787560	1124957	0	0
45793095	1125315	0	0
45790593	1549786	0	0
45796246	1545959	2	3
45801993	1125315	0	0
46310242	1119510	0	0
4103661	4066995	3	3
372887	4132546	3	3
21003404	19010482	0	0
21503166	1192710	1	1
36153336	1115171	2	3
36152923	1112807	0	0
1717327	19129655	2	3
36476622	1154343	0	0
42807040	1177480	0	0
44349354	723013	0	0
44355400	1177480	0	0
44350546	1125315	0	0
45638042	1119510	0	0
44347592	1153428	0	0
44362091	1125315	0	0
45663283	1129625	0	0
45654116	1174888	0	0
45635118	1192710	0	0
45700615	1759842	0	0
45691574	1119510	0	0
45704452	19079524	1	1
45780895	40162522	2	3
45681468	967823	0	0
45792097	1192710	0	0
45780138	738818	0	0
45894579	1332418	0	0
45787567	1112807	0	0
45793106	1125315	0	0
45790593	19127890	0	0
45790979	1332419	2	3
45801994	1125315	0	0
46310392	1119510	0	0
4042640	4337138	3	3
440142	317576	3	3
21003404	1551099	0	0
21503197	19010482	1	1
36153439	1127433	2	3
36152748	1124300	0	0
35507034	1545959	2	3
36427690	1746114	0	0
42807040	1174888	0	0
44349343	1124300	0	0
44355505	1129625	0	0
44350557	1125315	0	0
45638183	1119510	0	0
44347487	1551099	0	0
44362221	1125315	0	0
45663275	1129625	0	0
45654117	1107830	0	0
45635119	1308738	0	0
45700547	1149380	0	0
45689702	1119510	0	0
45669246	19079524	1	1
45780952	40236446	2	3
45681566	1124957	0	0
45792097	1112807	0	0
45706100	738818	0	0
45894580	1124957	0	0
45787568	1124300	0	0
45792840	1125315	0	0
45790593	1589505	0	0
46239457	1545959	2	3
45801954	1125315	0	0
46310506	1119510	0	0
4115574	196456	3	3
440142	321042	3	3
21003322	975125	0	0
21503064	1343916	1	1
36153041	1127433	2	3
36152898	975125	0	0
21502741	46233988	2	3
36426272	1107830	0	0
42807038	1551099	0	0
44349410	1539403	0	0
44355509	1112807	0	0
44350726	1125315	0	0
45638255	1119510	0	0
44347475	701322	0	0
44362323	1125315	0	0
45663349	1129625	0	0
45654120	1149196	0	0
45635392	1713332	0	0
45700549	1549786	0	0
45689765	1119510	0	0
45669387	19079524	1	1
45780291	19078924	2	3
45681436	738818	0	0
45792135	1124300	0	0
45706221	738818	0	0
45803000	1361711	0	0
45787569	1102527	0	0
45793104	1125315	0	0
45790596	705944	0	0
46243874	1332419	2	3
45801964	1125315	0	0
46310453	1119510	0	0
4040395	4010253	3	3
75053	4230399	3	3
21003393	975125	0	0
21503220	1308738	1	1
36153051	1115171	2	3
36153184	1177480	0	0
21502741	46233710	2	3
36426273	791967	0	0
42807056	1539403	0	0
44349357	1124957	0	0
44355717	1129625	0	0
44350941	1125315	0	0
45638436	1119510	0	0
44347481	1367571	0	0
44362326	1125315	0	0
45663665	1129625	0	0
45654195	1551099	0	0
45629889	1115008	0	0
45700549	1521369	0	0
45689708	1119510	0	0
45666873	19079524	1	1
45780266	40231925	2	3
45681440	1367571	0	0
45792136	1343916	0	0
45706165	738818	0	0
45803011	914335	0	0
45787660	1713332	0	0
45792869	1125315	0	0
45790599	1343916	0	0
46239540	1332419	2	3
45801951	1125315	0	0
46310414	1119510	0	0
4027553	255848	3	3
256440	4294548	3	3
21003394	1551099	0	0
21503258	1343916	1	1
36153083	1127433	2	3
36152665	1177480	0	0
21502759	40174880	2	3
36422742	1545958	0	0
42807058	705944	0	0
44349413	1515774	0	0
44355850	708298	0	0
44350925	1125315	0	0
45638270	1119510	0	0
44347272	1367571	0	0
44362330	1125315	0	0
45659991	1129625	0	0
45654199	1307863	0	0
45629897	1124300	0	0
45700549	1595799	0	0
45689871	1119510	0	0
45648486	46275916	1	1
45780202	19008572	2	3
45681312	1149196	0	0
45792139	1107830	0	0
45706176	738818	0	0
45802848	791967	0	0
45787660	1759842	0	0
45792957	1125315	0	0
45790732	1332418	0	0
46239043	1332419	2	3
45802164	1125315	0	0
46310653	1119510	0	0
4180938	4145310	3	3
443419	4156265	3	3
21003393	1551099	0	0
21503258	1119510	1	1
36153137	19008572	2	3
36152673	1124300	0	0
4180941	4275113	2	3
36422768	914335	0	0
42807091	1545958	0	0
44349512	1149380	0	0
44355864	1129625	0	0
44351058	1125315	0	0
45638279	1119510	0	0
44347603	1124300	0	0
44362261	1125315	0	0
45660009	1129625	0	0
45654202	1124957	0	0
45629899	1115008	0	0
45700573	1110410	0	0
45689686	1119510	0	0
45648515	19079524	1	1
45780328	40229134	2	3
45681419	1192710	0	0
45792268	1115008	0	0
45706265	738818	0	0
45803133	1000560	0	0
45787668	1551099	0	0
45793166	1125315	0	0
45790757	1367571	0	0
45788116	1539411	2	3
45801937	1125315	0	0
46310656	1119510	0	0
4088217	4293740	3	3
75865	4056621	3	3
21011418	1110410	0	0
21505763	914335	1	1
36153775	40223834	2	3
36153245	914335	0	0
21502750	1551192	2	3
36422731	1150770	0	0
42807125	1125315	0	0
44349514	1713332	0	0
44355864	1125315	0	0
44348371	1125315	0	0
45637128	1119510	0	0
44347498	1713332	0	0
44362199	1125315	0	0
45649367	1177480	0	0
45654211	1551099	0	0
45629900	1124957	0	0
45700574	1713332	0	0
45689632	1119510	0	0
45648540	46275916	1	1
45780275	19019273	2	3
45681422	1107830	0	0
45792270	1549786	0	0
45699774	738818	0	0
45803149	975125	0	0
45787525	967823	0	0
45793119	1125315	0	0
45790763	1500211	0	0
46290394	1539411	2	3
45801953	1125315	0	0
46310671	1119510	0	0
4088217	4197460	3	3
75865	198199	3	3
21011418	1154029	0	0
21505763	1192710	1	1
36153812	1115171	2	3
36152677	1589505	0	0
21603967	19078461	2	3
36314177	4012477	0	0
42807125	1124957	0	0
44349454	1118084	0	0
44355753	1125315	0	0
44348529	1125315	0	0
45634859	1119510	0	0
44347639	1305058	0	0
44362216	1125315	0	0
45649468	1177480	0	0
45654181	1149196	0	0
45629905	1326303	0	0
45700661	1124957	0	0
45689854	1119510	0	0
45645614	46275916	1	1
45780230	19018935	2	3
45681521	1115008	0	0
45792270	19127890	0	0
45699781	738818	0	0
45802823	1557272	0	0
45787669	1174888	0	0
45793067	1125315	0	0
45790845	1124300	0	0
45791073	1545959	2	3
45802040	1125315	0	0
46310569	1119510	0	0
4042645	4216130	3	3
134057	381316	3	3
21011412	1110410	0	0
21505957	1738521	1	1
36153544	1115171	2	3
36152798	1112807	0	0
21604344	40229134	2	3
36315060	4181917	0	0
42807128	1326303	0	0
44349463	975125	0	0
44355753	1119510	0	0
44348655	1125315	0	0
44362725	1129625	0	0
44347652	1332418	0	0
44362333	1125315	0	0
45632049	1177480	0	0
45654156	1548195	0	0
45629882	1595799	0	0
45698936	1322184	0	0
45689866	1119510	0	0
45642876	46275916	1	1
45780400	42707627	2	3
45681317	975125	0	0
45792270	1589505	0	0
45699818	738818	0	0
45803025	1322184	0	0
45787674	975125	0	0
45793080	1125315	0	0
45790854	1326303	0	0
46243978	1545959	2	3
45802045	1125315	0	0
46310596	1119510	0	0
4042673	4078793	3	3
443883	260139	3	3
21009234	1746114	0	0
21505772	1112807	1	1
36153672	40232448	2	3
36152639	1512674	0	0
21604344	40231925	2	3
40236824	40236824	0	0
42807317	742185	0	0
44349467	1308738	0	0
44355852	1545958	0	0
44346851	1125315	0	0
44361848	1129625	0	0
44347654	1115008	0	0
44362334	1125315	0	0
45632058	1177480	0	0
45654264	1589505	0	0
45629864	1110410	0	0
45698941	1501700	0	0
45686543	1119510	0	0
45642840	46275916	1	1
45777763	19133905	2	3
45681574	1107830	0	0
45792340	1000560	0	0
45693523	738818	0	0
45803093	1501700	0	0
45787676	1115008	0	0
45793218	1125315	0	0
45790548	1521369	0	0
46244285	1539411	2	3
45802046	1125315	0	0
46310755	1119510	0	0
4176967	4058899	3	3
443883	4112343	3	3
21011412	1154029	0	0
21505772	1125315	1	1
36154122	1115171	2	3
36152682	1119510	0	0
21502747	1545959	2	3
40236446	40236446	0	0
42807135	19039298	0	0
44349368	1118084	0	0
44355853	1125315	0	0
44346930	1125315	0	0
44361951	1129625	0	0
44347283	791967	0	0
44362411	1125315	0	0
45632127	1177480	0	0
45654264	1549786	0	0
45630009	1539403	0	0
45698943	738818	0	0
45686780	1119510	0	0
45685611	46275916	1	1
45777763	19133873	2	3
45681643	1149196	0	0
45792202	975125	0	0
45693494	738818	0	0
45802828	757627	0	0
45787625	1153428	0	0
45793220	1125315	0	0
45790557	1551099	0	0
46239701	1539411	2	3
45802105	1125315	0	0
46310770	1119510	0	0
4176967	4047491	3	3
440921	4296205	3	3
21011074	1112807	0	0
21505772	1129625	1	1
36154123	40232448	2	3
36152639	1549786	0	0
21502747	1539411	2	3
36429173	1150836	0	0
42807139	1728416	0	0
44349447	1174888	0	0
44355853	1124957	0	0
44346880	1125315	0	0
44362206	1129625	0	0
44347440	1738521	0	0
44362422	1125315	0	0
45632208	1177480	0	0
45654379	1326303	0	0
45630112	1551099	0	0
45698920	1115008	0	0
45686450	1119510	0	0
45685964	46275916	1	1
45777720	19019273	2	3
45681594	1539403	0	0
45792212	975125	0	0
45693608	738818	0	0
45802931	1551099	0	0
45787629	1174888	0	0
45793324	1125315	0	0
45790558	1115008	0	0
46239033	1539411	2	3
45802108	1125315	0	0
46310532	1119510	0	0
4115260	255848	3	3
75047	4134304	3	3
21011104	1367571	0	0
21505758	1177480	1	1
36153271	40229134	2	3
36152716	1177480	0	0
36217206	19008572	2	3
36429128	1741122	0	0
42807229	1115008	0	0
44349451	791967	0	0
44355869	1119510	0	0
44346947	1125315	0	0
44362171	1129625	0	0
44347738	1149196	0	0
44362475	1125315	0	0
45632017	1177480	0	0
45654387	738818	0	0
45630115	1589505	0	0
45698988	1549786	0	0
45686866	1119510	0	0
45636779	46275916	1	1
45777726	40229134	2	3
45681555	1332418	0	0
45792376	1112807	0	0
45693905	738818	0	0
45802937	1521369	0	0
45787722	1192710	0	0
45793027	1125315	0	0
45790564	967823	0	0
45804168	19127918	2	2
45802111	1125315	0	0
46304885	1119510	0	0
4154162	4132546	3	3
3050951	3045716	3	3
21011189	967823	0	0
21505772	1192710	1	1
36153996	19008572	2	3
36152874	1149196	0	0
36217210	19078924	2	3
36427783	1548195	0	0
42807236	19127890	0	0
44349608	1717327	0	0
44355956	1125315	0	0
44346916	1125315	0	0
45655998	1129625	0	0
44347742	1124300	0	0
44362564	1125315	0	0
45634073	1177480	0	0
45654310	738818	0	0
45630119	1124957	0	0
45698988	1512674	0	0
45686615	1119510	0	0
45633559	19079524	1	1
45777656	1115171	2	3
45681580	1149196	0	0
45792377	1153428	0	0
45690768	738818	0	0
45802937	1549786	0	0
45787723	1137529	0	0
45793334	1125315	0	0
45790979	1332418	0	0
45804168	19128009	2	2
45801919	1125315	0	0
46305431	1119510	0	0
4154162	4156265	3	3
3050951	3015632	3	3
21011191	967823	0	0
21505758	1129625	1	1
36153929	19077344	2	3
36153080	1112807	0	0
36217210	40224805	2	3
36426554	701322	0	0
42807236	1515774	0	0
44349429	1115008	0	0
44355873	1149196	0	0
44347048	1125315	0	0
45656327	1129625	0	0
44347451	1713332	0	0
44362450	1125315	0	0
45633949	1177480	0	0
45654311	1124957	0	0
45630127	1115008	0	0
45698988	19127890	0	0
45686738	1119510	0	0
45633766	46275916	1	1
45777796	19008572	2	3
45681630	1149196	0	0
45792384	19039298	0	0
45690819	738818	0	0
45802943	1512674	0	0
45787724	1174888	0	0
45792132	1125315	0	0
45790838	1551099	0	0
45787205	19128022	2	2
45802122	1125315	0	0
46305003	1119510	0	0
4103320	4283893	3	3
3033521	3000963	3	3
21011482	1551099	0	0
21503358	1343916	1	1
36153328	1115171	2	3
36152640	1107830	0	0
36217210	40220960	2	3
36426524	1500211	0	0
42807236	1549786	0	0
44349618	1549786	0	0
44355967	1551099	0	0
44347071	1125315	0	0
45656155	1129625	0	0
44347451	1759842	0	0
44362668	1125315	0	0
45634226	1177480	0	0
45654327	1149196	0	0
45630133	1174888	0	0
45699041	1115008	0	0
45686720	1119510	0	0
45633851	19079524	1	1
45777790	43012036	2	3
45681636	1332418	0	0
45792391	1115008	0	0
45687758	738818	0	0
45802943	19127890	0	0
45787735	1548195	0	0
45792081	1125315	0	0
45790957	975125	0	0
46296901	40232448	2	3
45801982	1125315	0	0
46305008	1119510	0	0
4181063	258780	3	3
3051542	3045716	3	3
21011491	723013	0	0
21503364	975125	1	1
36153330	1127433	2	3
36152646	1115008	0	0
36217210	46275916	2	3
36424040	1308738	0	0
42807238	1729720	0	0
44349619	975125	0	0
44355972	1129625	0	0
44347175	1125315	0	0
45656406	1129625	0	0
44347396	1729720	0	0
44362684	1125315	0	0
45634244	1177480	0	0
45654271	1545958	0	0
45630139	1521369	0	0
45698933	738818	0	0
45686883	1119510	0	0
45633871	46275916	1	1
45706422	40224805	2	3
45681612	738818	0	0
45675985	1192710	0	0
45687895	738818	0	0
45802943	1549786	0	0
45787759	967823	0	0
45790256	1125315	0	0
45790812	1519936	0	0
46296702	19073183	2	3
45802117	1125315	0	0
46305445	1119510	0	0
4181063	40486433	3	3
3051542	3015632	3	3
21011655	975125	0	0
21503371	1129625	1	1
36154133	1127433	2	3
36152908	1107830	0	0
36217220	40229134	2	3
36425676	1177480	0	0
42807286	1501700	0	0
44349621	1118084	0	0
44356088	1361711	0	0
44347009	1125315	0	0
45656409	1129625	0	0
44347398	1778162	0	0
44362440	1125315	0	0
45629263	1177480	0	0
45654313	1124957	0	0
45629882	1308738	0	0
45699008	1307863	0	0
45686964	1119510	0	0
45628268	46275916	1	1
45706450	19019273	2	3
45679754	738818	0	0
45675884	1124300	0	0
45687504	738818	0	0
45802945	1110410	0	0
45787791	975125	0	0
45790372	1125315	0	0
45790899	1322184	0	0
46295026	40232448	2	3
45802252	1125315	0	0
46305016	1119510	0	0
4103183	317576	3	3
443784	317576	3	3
21002690	1149380	0	0
21503371	975125	1	1
36154189	19057271	2	3
36152742	1107830	0	0
36217220	19112599	2	3
36426641	1503184	0	0
42807288	1125315	0	0
44349572	1149196	0	0
44356105	738818	0	0
44347022	1125315	0	0
45652522	1129625	0	0
44347399	1115008	0	0
44362487	1125315	0	0
45629070	1177480	0	0
45654402	1308738	0	0
45630251	1501700	0	0
45699111	1501700	0	0
45687002	1119510	0	0
45628658	19079524	1	1
45706462	19133768	2	3
45679777	975125	0	0
45676046	1149196	0	0
45684607	738818	0	0
45803101	723013	0	0
45787801	1149196	0	0
45790704	1125315	0	0
45790902	1124300	0	0
46295107	19018935	2	3
45802086	1125315	0	0
46305571	1119510	0	0
4103183	321042	3	3
443784	4310024	3	3
21002731	1521369	0	0
21503445	1125315	1	1
36154199	40232448	2	3
36152743	1153428	0	0
36217220	40222846	2	3
36423453	1768849	0	0
42807330	1000560	0	0
44349574	1000560	0	0
44356105	1125315	0	0
44347024	1125315	0	0
45652751	1129625	0	0
44347456	1551099	0	0
45661796	1125315	0	0
45627994	1177480	0	0
45654150	914335	0	0
45629866	1174888	0	0
45695458	1153428	0	0
45687015	1119510	0	0
45628409	19079524	1	1
45706462	40162522	2	3
45679759	791967	0	0
45675972	1545958	0	0
45684726	738818	0	0
45803102	1112807	0	0
45789173	757627	0	0
45790361	1125315	0	0
45790907	1713332	0	0
46295113	40236824	2	3
45802152	1125315	0	0
46305574	1119510	0	0
4103662	381316	3	3
320136	441267	3	3
21002731	1548195	0	0
21500540	740275	1	1
36154057	19008572	2	3
36152687	1521369	0	0
36217220	19074679	2	3
36423483	1118084	0	0
42807384	1177480	0	0
44349734	1361711	0	0
44356105	1119510	0	0
44347092	1125315	0	0
45655054	1129625	0	0
44347528	1310149	0	0
44355092	1125315	0	0
45626134	1177480	0	0
45654152	1332418	0	0
45629994	975125	0	0
45695466	1115008	0	0
45687017	1119510	0	0
45627877	46275916	1	1
45706668	1115171	2	3
45679416	1107830	0	0
45675973	975125	0	0
45681281	738818	0	0
45803108	1332418	0	0
45789335	1309944	0	0
45790299	1125315	0	0
45790572	1154029	0	0
46295173	19019273	2	3
45802156	1125315	0	0
46305330	1119510	0	0
4178367	4163872	3	3
443783	4056621	3	3
21002731	975125	0	0
21503445	1308738	1	1
36154110	1127433	2	3
36152810	1177480	0	0
36217214	19078461	2	3
36423477	1778162	0	0
42807390	1124300	0	0
44349373	1332418	0	0
44355862	1557272	0	0
44347111	1125315	0	0
45655180	1129625	0	0
44347529	1192710	0	0
44354966	1125315	0	0
45626327	1177480	0	0
45654243	757627	0	0
45630079	1149196	0	0
45695472	1551099	0	0
45687034	1119510	0	0
45676210	46275916	1	1
45706826	40232448	2	3
45679424	1110410	0	0
45676047	1115008	0	0
45681927	738818	0	0
45803218	1343916	0	0
45789286	1501700	0	0
45790347	1125315	0	0
45790626	1589505	0	0
46295153	40232448	2	3
45802089	1125315	0	0
46305332	1119510	0	0
4178367	4243062	3	3
443783	261325	3	3
21002731	1595799	0	0
21503592	967823	1	1
36154111	40232448	2	3
36152812	1119510	0	0
36217214	19125062	2	3
36423476	1778162	0	0
42807382	723013	0	0
44349749	1124957	0	0
42805192	1177480	0	0
44347297	1125315	0	0
45655314	1129625	0	0
44347560	975125	0	0
44354713	1125315	0	0
45626328	1177480	0	0
45654252	1115008	0	0
45630082	975125	0	0
45695474	738818	0	0
45683632	1119510	0	0
45625025	46275916	1	1
45706799	40231925	2	3
45678190	1521369	0	0
45676051	1115008	0	0
45681941	738818	0	0
45803059	1112807	0	0
45789298	1557272	0	0
45790243	1125315	0	0
45790626	1549786	0	0
46295408	1115171	2	3
45802127	1125315	0	0
46305506	1119510	0	0
4043686	4047491	3	3
444089	4266809	3	3
21002731	19054876	0	0
21503467	1595799	1	1
36156311	40232448	2	3
36152812	738818	0	0
36217214	40229134	2	3
36428377	1154343	0	0
42807366	1124300	0	0
44349751	1729720	0	0
42805196	701322	0	0
44347298	1125315	0	0
45652791	1129625	0	0
44347567	1713332	0	0
44355015	1125315	0	0
45626337	1177480	0	0
45654390	1778162	0	0
45630083	1124957	0	0
45695511	1308738	0	0
45683709	1119510	0	0
45625060	19079524	1	1
45706835	40232448	2	3
45678190	1548195	0	0
45676078	1192710	0	0
45681735	738818	0	0
45803242	1115008	0	0
45789305	1124957	0	0
45790291	1125315	0	0
45790786	1174888	0	0
46295213	35605482	2	3
45802248	1125315	0	0
46305360	1119510	0	0
4168644	438614	3	3
135930	80180	3	3
21002731	1589505	0	0
21503474	1595799	1	1
36156375	1551192	2	3
36152823	933724	0	0
4181063	260139	2	2
36423511	1149196	0	0
42809676	1177480	0	0
44349753	1153428	0	0
42805204	1738521	0	0
44347449	1125315	0	0
45652760	1129625	0	0
44347567	1759842	0	0
44355226	1125315	0	0
45626282	1177480	0	0
45654320	791967	0	0
45630099	1192710	0	0
45695644	1332418	0	0
45683747	1119510	0	0
45670485	19079524	1	1
45702765	40232448	2	3
45678191	738818	0	0
45676142	933724	0	0
45681944	738818	0	0
45803249	791967	0	0
45789307	1174888	0	0
45790307	1125315	0	0
45790789	715997	0	0
46295628	40224805	2	3
45802233	1125315	0	0
46305384	1119510	0	0
4168644	4306014	3	3
1521369	19127922	3	4
21002731	1549786	0	0
21503474	1396131	1	1
36154202	40162522	2	3
36152647	791967	0	0
4181063	255848	2	2
36502197	40480160	6	8
42807353	1549786	0	0
44349603	1112807	0	0
42805283	1713332	0	0
44347057	1125315	0	0
45652849	1129625	0	0
44347460	1115008	0	0
44355138	1125315	0	0
45626342	1177480	0	0
45654499	1717327	0	0
45630108	1741122	0	0
45695627	1153428	0	0
45683693	1119510	0	0
45670722	19115351	1	1
45703088	40231925	2	3
45678151	1501700	0	0
45676148	1115008	0	0
45673297	738818	0	0
45803250	975125	0	0
45789406	1717327	0	0
45790440	1125315	0	0
45790683	1557272	0	0
46295252	40232448	2	3
45802213	1125315	0	0
46306723	1119510	0	0
4168644	439406	3	3
1521369	42902245	3	4
21002731	1738521	0	0
21503474	1308738	1	1
36154247	35605482	2	3
36152648	1129625	0	0
4181063	80809	2	2
36502197	4066995	7	8
42810048	1177480	0	0
44349653	1396131	0	0
42805286	1549786	0	0
44343221	1125315	0	0
45649681	1129625	0	0
44347545	738818	0	0
44354940	1125315	0	0
45626366	1177480	0	0
45654447	738818	0	0
45630108	1746114	0	0
45695487	1307863	0	0
45683658	1119510	0	0
45669222	46275916	1	1
45703089	40229134	2	3
45678124	1717327	0	0
45676344	1310149	0	0
45784507	738818	0	0
45803205	1124957	0	0
45789411	1000560	0	0
45790532	1125315	0	0
45790685	1124957	0	0
46244325	40229134	2	3
45802343	1125315	0	0
46306979	1119510	0	0
4168644	4102123	3	3
1521369	19133679	3	4
21002731	1515774	0	0
21503478	967823	1	1
36154251	19018935	2	3
36152654	1539403	0	0
4181063	440448	2	2
36502197	4048695	7	8
42808536	1125315	0	0
44349654	1738521	0	0
42805286	1518198	0	0
44343229	1125315	0	0
45649649	1129625	0	0
44347871	1713332	0	0
44354945	1125315	0	0
45622801	1177480	0	0
45654392	1154343	0	0
45630227	1107830	0	0
45695657	1322184	0	0
45670732	1713332	0	0
45669201	46275916	1	1
45702869	40232448	2	3
45678092	1539403	0	0
45676483	920293	0	0
45784993	738818	0	0
45803311	1124957	0	0
45789310	1115008	0	0
45790535	1125315	0	0
45790687	1174888	0	0
46244337	40229134	2	3
45802335	1125315	0	0
46321684	1119510	0	0
4168644	4048169	3	3
1521369	19129144	3	4
21002731	19127890	0	0
21503584	1192710	1	1
36154294	1551192	2	3
36152688	1124300	0	0
4181063	134438	2	2
36502197	4059173	7	8
42808536	738818	0	0
44349659	1713332	0	0
42805212	1332418	0	0
44342974	1125315	0	0
45649830	1129625	0	0
44347775	1326303	0	0
44354949	1125315	0	0
45623224	1177480	0	0
45654506	708298	0	0
45630043	1310149	0	0
45695494	1521369	0	0
45670732	1759842	0	0
45666866	46275916	1	1
45702980	19133905	2	3
45678097	1115008	0	0
45676570	1361711	0	0
45782435	738818	0	0
45803313	1112807	0	0
45789312	914335	0	0
45790538	1125315	0	0
45790990	1174888	0	0
46244419	40232448	2	3
45799184	1125315	0	0
46321817	1119510	0	0
4168644	4304110	3	3
1521369	19128065	3	4
21002692	975125	0	0
21503469	1192710	1	1
36154284	1551192	2	3
36152689	1119510	0	0
4181060	44805732	2	2
36502197	40479422	7	8
42808536	1119510	0	0
44349557	1174888	0	0
42805213	1115008	0	0
44342977	1125315	0	0
45646323	1129625	0	0
44347777	1107830	0	0
44355051	1125315	0	0
45624897	1177480	0	0
45654507	742185	0	0
45630061	1154343	0	0
45695635	967823	0	0
45670883	1738521	0	0
45666974	46275916	1	1
45702980	19133873	2	3
45678081	791967	0	0
45676351	1501700	0	0
45782749	738818	0	0
45803314	1149196	0	0
45789315	967823	0	0
45790545	1125315	0	0
45790717	975125	0	0
46244497	1115171	2	3
45799390	1125315	0	0
46321718	1119510	0	0
4168644	4169137	3	3
135930	80502	3	4
21002694	1129625	0	0
21500744	967823	1	1
36154341	1127433	2	3
36152697	1107830	0	0
21603283	40169281	2	2
36502197	40479768	7	8
42810317	1125315	0	0
44349659	1759842	0	0
42805274	1125315	0	0
44343361	1125315	0	0
45646327	1129625	0	0
44347625	1192710	0	0
44355181	1125315	0	0
45624905	1177480	0	0
45654515	1000560	0	0
45630018	1149196	0	0
45695272	1713332	0	0
45670843	1192710	0	0
45666951	46275916	1	1
45703938	40232448	2	3
45678364	1115008	0	0
45789118	1545958	0	0
45782775	738818	0	0
45802968	967823	0	0
45787825	1115008	0	0
45790414	1125315	0	0
46297546	1115008	0	0
46244434	40236446	2	3
45799492	1125315	0	0
46321723	1119510	0	0
4168644	4302207	3	3
440142	4329847	3	4
21002745	1149196	0	0
21500709	1396131	1	1
35902849	198809	2	3
36153255	1192710	0	0
36102149	255848	2	2
36502197	4278672	7	8
42807391	1343916	0	0
44349562	1118084	0	0
42805289	715997	0	0
44343362	1125315	0	0
45646367	1129625	0	0
44347778	791967	0	0
44355202	1125315	0	0
45625103	1177480	0	0
45654255	1107830	0	0
45629915	1115008	0	0
45695433	715997	0	0
45670829	1149196	0	0
45707347	19079524	1	1
45703771	40163554	2	3
45678492	1551099	0	0
45789120	1310149	0	0
45780328	738818	0	0
45803210	1332418	0	0
45787826	1149380	0	0
45790418	1125315	0	0
46297692	1154029	0	0
46244596	40229134	2	3
45799621	1125315	0	0
46321792	1119510	0	0
4168644	4139681	3	3
320136	4283893	3	4
21002694	1192710	0	0
21500709	1308738	1	1
36203066	4156265	2	3
35529060	1177480	0	0
36102149	440448	2	2
36502197	4149245	7	8
42810072	1119510	0	0
44349700	933724	0	0
42805291	723013	0	0
44343071	1125315	0	0
45649109	1129625	0	0
44347576	1557272	0	0
45655494	1125315	0	0
45623258	1177480	0	0
45654455	1539403	0	0
45630027	1192710	0	0
45695517	1500211	0	0
45670836	920293	0	0
45704229	46275916	1	1
45704079	19126352	2	3
45678494	1778162	0	0
45789123	920293	0	0
45780306	738818	0	0
45803290	975125	0	0
45787827	1112807	0	0
45790606	1125315	0	0
46297699	1153428	0	0
46244606	40236824	2	3
45799392	1125315	0	0
46316468	1119510	0	0
4168644	442116	3	3
1515774	19128263	3	4
21002743	1150836	0	0
21500720	1595799	1	1
36152830	1545959	2	3
35529067	19127890	0	0
36102149	372328	2	2
36502197	4134304	9	10
42810072	1125315	0	0
44349664	742185	0	0
42805183	1124300	0	0
44343113	1125315	0	0
45646545	1129625	0	0
44347792	740275	0	0
44347846	1125315	0	0
45621404	1177480	0	0
45654080	1308738	0	0
45630191	1545958	0	0
45695578	1539403	0	0
45670767	738818	0	0
45704332	46275916	1	1
45703717	40231925	2	3
45678428	1153428	0	0
45789127	1192710	0	0
45777762	738818	0	0
45803119	1112807	0	0
45787908	1115008	0	0
45790501	1125315	0	0
46297716	1153428	0	0
46244458	19019273	2	3
45799449	1125315	0	0
46316410	1119510	0	0
4043016	4199276	3	3
1515774	19128022	3	4
21002745	1129625	0	0
21500720	1308738	1	1
36156274	1107882	2	3
35529067	1515774	0	0
36102149	4283893	2	2
36502197	78272	9	10
42810275	1112807	0	0
44349856	1115008	0	0
42805184	1332418	0	0
44343161	1125315	0	0
45646477	1129625	0	0
44347802	1115008	0	0
44347517	1125315	0	0
45621523	1177480	0	0
45654474	1110410	0	0
45629982	914335	0	0
45695645	1738521	0	0
45670775	1713332	0	0
45704538	46275916	1	1
45703129	40232448	2	3
45678131	1154343	0	0
45789130	1124300	0	0
45777726	738818	0	0
45803400	738818	0	0
45787845	1549786	0	0
45787597	1125315	0	0
46297721	1192710	0	0
46244459	43012036	2	3
45799456	1125315	0	0
46316404	1119510	0	0
4155793	4163872	3	3
134057	317576	3	4
21002731	1512674	0	0
21503179	40169281	1	1
36217219	1519937	2	3
35529067	1549786	0	0
36102149	195588	2	2
36502197	81151	6	9
42804734	1000560	0	0
44349859	1713332	0	0
42805220	1177480	0	0
44343407	1125315	0	0
45646458	1129625	0	0
44347214	1521369	0	0
44347826	1125315	0	0
45621766	1177480	0	0
45654456	1332418	0	0
45630276	1307863	0	0
45695441	1326303	0	0
45670775	1759842	0	0
45700802	40220386	1	1
45703108	19133905	2	3
45678141	1521369	0	0
45789390	1149196	0	0
45777748	738818	0	0
45803373	1149196	0	0
45787845	1519936	0	0
45787560	1125315	0	0
46297472	1549786	0	0
46244547	19059056	2	3
45799460	1125315	0	0
46316429	1119510	0	0
4155793	4243062	3	3
31057	4112343	3	4
21002745	1107830	0	0
21001868	1154615	1	1
36217219	43012754	2	3
35509184	1110410	0	0
21604753	705944	2	2
36502197	4230399	8	9
42804735	1738521	0	0
44349761	1326303	0	0
42805301	1118084	0	0
44343411	1125315	0	0
45646733	1129625	0	0
44347812	1539403	0	0
44347526	1125315	0	0
45621811	1177480	0	0
45654486	1110410	0	0
45630258	738818	0	0
45695619	1332418	0	0
45670821	1738521	0	0
45700982	46275916	1	1
45703147	782047	2	3
45678142	19127890	0	0
45789379	1174888	0	0
45703089	738818	0	0
45803260	1396131	0	0
45787875	1000560	0	0
45787669	1125315	0	0
46297637	1343916	0	0
45893781	46233710	2	3
45799319	1125315	0	0
46316605	1119510	0	0
4071689	381316	3	3
75909	4237458	3	4
21002745	1150836	0	0
21002499	19128263	1	1
36217219	1718412	2	3
35509188	1119510	0	0
21604753	742185	2	2
36208978	3004501	3	3
42804736	1125315	0	0
44350045	1124957	0	0
42805306	967823	0	0
44343422	1125315	0	0
45646767	1129625	0	0
44347363	1500211	0	0
44347717	1125315	0	0
45665266	1177480	0	0
45654494	1107830	0	0
45630259	19010482	0	0
45695816	1738521	0	0
45671092	1361711	0	0
45700887	46275916	1	1
45703165	1127433	2	3
45678142	1549786	0	0
45789319	1107830	0	0
45699984	738818	0	0
45803326	1124957	0	0
45787865	967823	0	0
45787629	1125315	0	0
46297576	914335	0	0
45789280	19078461	2	3
45799320	1125315	0	0
46316693	1119510	0	0
4168335	4109685	3	3
3050940	3016723	3	4
21002694	975125	0	0
21002499	42902245	1	1
36217219	19132304	2	3
36157065	1119510	0	0
4041268	4010253	2	2
36211303	381316	3	3
42804736	1174888	0	0
44350046	738818	0	0
42805293	1124300	0	0
44343423	1125315	0	0
45643458	1129625	0	0
44347781	1149380	0	0
44347720	1125315	0	0
45665370	1177480	0	0
45654086	791967	0	0
45630172	738818	0	0
45695849	708298	0	0
45670797	1738521	0	0
45694971	46275916	1	1
45703192	19133768	2	3
45678176	1149196	0	0
45789333	920293	0	0
45700199	738818	0	0
45803331	1124957	0	0
45788118	1149196	0	0
45787722	1125315	0	0
46297744	1124957	0	0
45802222	19075601	2	3
45799466	1125315	0	0
46316546	1119510	0	0
4168335	4155034	3	3
3050940	3013682	3	4
21002745	1192710	0	0
21002499	19128022	1	1
36217219	46221626	2	3
36157237	1129625	0	0
21603991	1118084	2	2
36211303	4329847	3	3
42804737	723013	0	0
44341980	1107830	0	0
42805295	1310149	0	0
44343501	1125315	0	0
45643700	1129625	0	0
44347922	1124957	0	0
44347722	1125315	0	0
45667455	1177480	0	0
45654369	1548195	0	0
45630175	1551099	0	0
45695670	1305058	0	0
45670799	1115008	0	0
45694999	46275916	1	1
45703192	40162522	2	3
45678182	1154029	0	0
45791746	967823	0	0
45700282	738818	0	0
45800456	738818	0	0
45788120	1521369	0	0
45787724	1125315	0	0
46297754	1174888	0	0
45802426	19075001	2	3
45799559	1125315	0	0
46316191	1119510	0	0
4168335	4113008	3	3
1512675	19127904	2	2
21002694	738818	0	0
21001920	1154615	1	1
36217219	43012433	2	3
36156633	1343916	0	0
19109535	40221415	2	2
36211303	4094814	3	3
42804709	1759842	0	0
44341760	1112807	0	0
42805281	1118084	0	0
44343515	1125315	0	0
45643577	1129625	0	0
44347931	1118084	0	0
44347913	1125315	0	0
45662801	1177480	0	0
45652033	920293	0	0
45630181	1124957	0	0
45695678	1174888	0	0
45670853	1512674	0	0
45688947	46275916	1	1
45703108	19133873	2	3
45678284	1717327	0	0
45791748	1000560	0	0
45696895	738818	0	0
45800463	1713332	0	0
45786307	1149196	0	0
45787726	1125315	0	0
46297643	967823	0	0
45793657	19078924	2	3
45799613	1125315	0	0
46310788	1119510	0	0
4090615	4149245	3	3
443783	44782520	2	2
21002708	1124300	0	0
21001857	40169281	1	1
36203090	4066995	2	3
36156634	1177480	0	0
35624868	4156265	2	2
36211325	4155034	3	3
42804811	1713332	0	0
44341765	1177480	0	0
42805361	1149380	0	0
44343477	1125315	0	0
45643690	1129625	0	0
44347685	1107830	0	0
44347957	1125315	0	0
45662751	1177480	0	0
45652042	1501700	0	0
45630183	1521369	0	0
45695727	1367571	0	0
45670853	19127890	0	0
45686174	19074679	1	1
45703118	35605482	2	3
45678292	1192710	0	0
45792111	967823	0	0
45693880	738818	0	0
45800463	1759842	0	0
45786329	708298	0	0
45787733	1125315	0	0
46297239	975125	0	0
45794630	19075001	2	3
45799540	1125315	0	0
46310690	1119510	0	0
4168166	4336464	3	3
443783	257012	2	2
21002745	738818	0	0
21001878	40169281	1	1
36153566	1107882	2	3
36157208	1512674	0	0
4112892	4295880	2	2
36211325	4109685	3	3
42804811	1759842	0	0
44341801	738818	0	0
44348936	701322	0	0
44343479	1125315	0	0
45643518	1129625	0	0
44347686	1154343	0	0
44348450	1125315	0	0
45664428	1177480	0	0
45652187	738818	0	0
45630354	1192710	0	0
45695718	1149196	0	0
45670853	1549786	0	0
45682386	19079524	1	1
45700111	19008572	2	3
45678294	738818	0	0
45792112	1112807	0	0
45693897	738818	0	0
45800400	1107830	0	0
45786223	1500211	0	0
45787792	1125315	0	0
46297427	975125	0	0
45788663	40223768	2	3
45799671	1125315	0	0
46305763	1119510	0	0
4180653	4181917	3	3
443783	4280726	2	2
21002745	1150770	0	0
21503379	1192710	1	1
36152955	1107882	2	3
36157258	1515774	0	0
35602099	4280726	2	2
36211325	4113008	3	3
42804666	1713332	0	0
44341803	1118084	0	0
44348944	1759842	0	0
44343484	1125315	0	0
45643761	1129625	0	0
44343618	1501700	0	0
44348553	1125315	0	0
45659659	1177480	0	0
45652193	914335	0	0
45630359	1310149	0	0
45695683	1149196	0	0
45670805	1107830	0	0
45659884	1107830	0	0
45700004	19076374	2	3
45678243	1310149	0	0
45792073	1154029	0	0
45693955	738818	0	0
45800412	967823	0	0
45786337	1548195	0	0
45787796	1125315	0	0
46297449	933724	0	0
46298457	40223768	2	3
45799578	1125315	0	0
46305830	1119510	0	0
4090614	40486433	3	3
31821	140673	2	2
21002745	1153428	0	0
21002491	40221415	1	1
36153762	1107882	2	3
36157258	19127890	0	0
4268896	44783196	2	2
35809117	195588	3	3
42804622	1000560	0	0
44342121	1000560	0	0
44348706	757627	0	0
44343527	1125315	0	0
45640699	1129625	0	0
44343349	1713332	0	0
44348556	1125315	0	0
45659619	1177480	0	0
45651962	1521369	0	0
45630365	1192710	0	0
45695758	1778162	0	0
45671015	1115008	0	0
45660029	1548195	0	0
45700084	1115171	2	3
45678264	1713332	0	0
45792076	1112807	0	0
45694085	738818	0	0
45800427	1778162	0	0
45786399	1000560	0	0
45787820	1125315	0	0
46297663	1174888	0	0
45788866	40223768	2	3
45799638	1125315	0	0
46305896	1119510	0	0
4090614	4280726	3	3
320136	4051466	2	2
21002775	1305058	0	0
21001919	1154615	1	1
36154366	40228214	2	3
36157258	1549786	0	0
36102932	28060	2	2
36211091	40479422	3	3
42804694	933724	0	0
44342122	738818	0	0
44348707	1521369	0	0
44339802	1125315	0	0
45640726	1129625	0	0
44343358	1124300	0	0
44348562	1125315	0	0
45659971	1177480	0	0
45651962	1595799	0	0
45630183	1549786	0	0
45695497	1124300	0	0
45670742	1192710	0	0
45660102	738818	0	0
45700236	19073183	2	3
45678247	1174888	0	0
45792070	1124957	0	0
45694158	738818	0	0
45800483	1107830	0	0
45786301	1174888	0	0
45789299	1125315	0	0
46297607	1115008	0	0
46244274	19078461	2	3
45799592	1125315	0	0
46305901	1119510	0	0
4154161	4155034	3	3
1521406	19128065	2	2
21002773	1746114	0	0
21013627	40171902	1	1
36218509	40221415	2	3
36157261	19127890	0	0
21604200	19059528	2	2
36211091	40479768	3	3
42804679	1713332	0	0
44341805	1192710	0	0
44348707	1549786	0	0
44339847	1125315	0	0
45641039	1129625	0	0
44343552	738818	0	0
44348001	1125315	0	0
45659823	1177480	0	0
45651962	1549786	0	0
45630203	1149196	0	0
45695687	920293	0	0
45670863	19002770	0	0
45661337	1717327	0	0
45700286	40174880	2	3
45678250	1192710	0	0
45789421	715997	0	0
45694015	738818	0	0
45800458	1326303	0	0
45786313	1124957	0	0
45789278	1125315	0	0
46297622	1153428	0	0
46295329	1107882	2	3
45799600	1125315	0	0
46306119	1119510	0	0
4154161	4152936	3	3
321588	317576	2	2
21002773	1717327	0	0
21002502	40221415	1	1
35508273	19078461	2	3
36157261	1549786	0	0
21604200	1154029	2	2
36211088	40479422	3	3
42804695	1545958	0	0
44341806	1549786	0	0
44348711	1125315	0	0
44339906	1125315	0	0
45640849	1129625	0	0
44343564	1118084	0	0
44348002	1125315	0	0
45659946	1177480	0	0
45652052	1500211	0	0
45630401	1551099	0	0
45695596	1149196	0	0
45671099	914335	0	0
45661465	715997	0	0
45682143	1192710	0	0
45678389	1110410	0	0
45789435	1778162	0	0
45691206	738818	0	0
45800437	1713332	0	0
45786362	701322	0	0
45789305	1125315	0	0
46298058	1738521	0	0
45788322	1107882	2	3
45796811	1125315	0	0
46305843	1119510	0	0
4154161	378001	3	3
440059	4056621	2	2
21002743	1149196	0	0
21002502	19128009	1	1
36154304	40228214	2	3
36156741	1589505	0	0
21604200	19016749	2	2
36211088	40479768	3	3
42804815	1125315	0	0
44341806	1515774	0	0
44348713	723013	0	0
44339775	1125315	0	0
45640852	1129625	0	0
44343579	1515774	0	0
44348105	1125315	0	0
45659784	1177480	0	0
45651968	1000560	0	0
45629956	1545958	0	0
45695601	723013	0	0
45671017	1153428	0	0
45661620	1367571	0	0
45679989	1107830	0	0
45678393	1124957	0	0
45789447	975125	0	0
45691093	738818	0	0
45800437	1759842	0	0
45786414	1307863	0	0
45789307	1125315	0	0
46297832	1192710	0	0
45788305	1107882	2	3
45796665	1125315	0	0
46306138	1119510	0	0
4154161	4113008	3	3
75053	4059173	2	2
21002743	1107830	0	0
21002502	42902245	1	1
36153639	19078461	2	3
36156821	1119510	0	0
21603940	1124300	2	2
36211088	81151	3	3
42804952	1115008	0	0
44341848	914335	0	0
44348494	1545958	0	0
44339754	1125315	0	0
45640874	1129625	0	0
44343579	1549786	0	0
44348111	1125315	0	0
45660049	1177480	0	0
45652196	1149196	0	0
45630392	1115008	0	0
45695602	1149196	0	0
45671020	1589505	0	0
45661298	701322	0	0
45680007	708298	0	0
45678210	967823	0	0
45789453	1174888	0	0
45691366	738818	0	0
45800472	708298	0	0
46296817	1107830	0	0
45789401	1125315	0	0
46297846	1192710	0	0
46295071	1107882	2	3
45796710	1125315	0	0
46306214	1119510	0	0
4154161	4109685	3	3
75053	4048695	2	2
21002743	1153428	0	0
21002502	19128065	1	1
36153941	19078461	2	3
36156750	1124300	0	0
4130851	4155034	2	2
36000000	134438	3	3
42804667	1545958	0	0
44341883	1154343	0	0
44349143	1119510	0	0
44339810	1125315	0	0
45640987	1129625	0	0
44344787	1501700	0	0
44348066	1125315	0	0
45656904	1177480	0	0
45652125	1124957	0	0
45627086	1539403	0	0
45695605	791967	0	0
45670917	967823	0	0
45661547	967823	0	0
45679946	1107830	0	0
45678235	1500211	0	0
45789465	1174888	0	0
45688741	738818	0	0
45800476	1112807	0	0
46296958	1153428	0	0
45787829	1125315	0	0
46297958	975125	0	0
45895826	1107882	2	3
45796868	1125315	0	0
46306028	1119510	0	0
4154161	375671	3	3
75053	4066995	2	2
21002743	1150770	0	0
21002502	19128263	1	1
36153655	19078461	2	3
36156751	1107830	0	0
21603311	1154343	2	2
35802848	4027663	3	3
42804642	1332418	0	0
44341889	738818	0	0
44349143	738818	0	0
44339885	1125315	0	0
45641071	1129625	0	0
44344789	975125	0	0
44348140	1125315	0	0
45657008	1177480	0	0
45652237	1326303	0	0
45627211	757627	0	0
45695698	1154343	0	0
45671036	967823	0	0
45661551	1174888	0	0
45679953	1343916	0	0
45678238	742185	0	0
45789472	1738521	0	0
45688107	738818	0	0
45800479	1115008	0	0
46296886	1115008	0	0
45787871	1125315	0	0
46297967	1332418	0	0
45801335	19073183	2	3
45796991	1125315	0	0
46305856	1119510	0	0
4154161	4296204	3	3
75053	4278672	2	2
21002744	738818	0	0
21002502	19128022	1	1
36153954	19078461	2	3
36156741	1549786	0	0
35204998	4324181	2	2
36211305	4156265	3	3
42804643	975125	0	0
44341892	1192710	0	0
44349151	975125	0	0
44339887	1125315	0	0
45640933	1129625	0	0
44344790	19003953	0	0
44348246	1125315	0	0
45657110	1177480	0	0
45652245	1174888	0	0
45627230	1713332	0	0
45695821	933724	0	0
45670958	1107830	0	0
45661659	1332418	0	0
45679967	1107830	0	0
45678240	1332418	0	0
45789477	1549786	0	0
45688169	738818	0	0
45800564	1713332	0	0
46296767	1174888	0	0
45787910	1125315	0	0
46297862	705944	0	0
45801262	1107882	2	3
45796801	1125315	0	0
46322299	1119510	0	0
4103352	4156265	3	3
75053	4237458	2	2
21002775	1551099	0	0
21002502	19127918	1	1
36153616	19078461	2	3
36157070	1000560	0	0
21604148	1557272	2	2
36207528	3013682	3	3
42804681	1000560	0	0
44341766	1118084	0	0
44348822	1119510	0	0
44339993	1125315	0	0
45641097	1129625	0	0
44344910	740275	0	0
44348214	1125315	0	0
45657184	1177480	0	0
45650895	920293	0	0
45627104	975125	0	0
45695827	1110410	0	0
45671058	1124957	0	0
45661668	1115008	0	0
45679970	975125	0	0
45678242	1115008	0	0
45789477	1515774	0	0
45685059	738818	0	0
45800513	1115008	0	0
46296997	1118084	0	0
45786083	1125315	0	0
46297906	967823	0	0
46239358	19073183	2	3
45796849	1125315	0	0
46322450	1119510	0	0
4103352	4283893	3	3
75053	40480160	2	2
21002326	1713332	0	0
21002502	19132304	1	1
36217220	920300	2	3
36157209	1539403	0	0
35204989	321042	2	2
36207528	3006906	3	3
42804644	1124957	0	0
44341864	1521369	0	0
44348572	1548195	0	0
44339975	1125315	0	0
45641283	1129625	0	0
44344823	1548195	0	0
44341580	1125315	0	0
45653082	1177480	0	0
45650901	1548195	0	0
45627229	1713332	0	0
45695832	1713332	0	0
45671061	1110410	0	0
45661369	967823	0	0
45679971	1107830	0	0
45678314	1154029	0	0
45789479	975125	0	0
45685064	738818	0	0
45800486	1589505	0	0
46297025	1112807	0	0
45786216	1125315	0	0
46297923	1174888	0	0
46239371	40229134	2	3
45796854	1125315	0	0
46322617	1119510	0	0
4043019	4181917	3	3
73553	80809	2	2
21002326	1759842	0	0
21500746	967823	1	1
36217210	1594382	2	3
36156759	705944	0	0
35204989	317576	2	2
36211136	4134304	3	3
42804644	1125315	0	0
44341865	933724	0	0
44348593	1125315	0	0
44340018	1125315	0	0
45641010	1129625	0	0
44344824	1746114	0	0
44340704	1125315	0	0
45653381	1177480	0	0
45650918	1545958	0	0
45627229	1759842	0	0
45695860	1110410	0	0
45670978	1332418	0	0
45661727	1713332	0	0
45680040	1551099	0	0
45678227	1310149	0	0
45789481	1115008	0	0
45681986	738818	0	0
45800443	1153428	0	0
46296924	1778162	0	0
45786231	1125315	0	0
46297929	1107830	0	0
46239459	19008572	2	3
45796975	1125315	0	0
46322618	1119510	0	0
4028908	4012477	3	3
443419	4155034	2	2
21002658	1551099	0	0
21002493	19128022	1	1
36217210	19006318	2	3
36156754	1119510	0	0
4141937	4337138	2	2
35809321	4084167	3	3
42804806	1174888	0	0
44342040	738818	0	0
44348867	1177480	0	0
44340173	1125315	0	0
45637730	1129625	0	0
44344824	1741122	0	0
44340654	1125315	0	0
45653648	1177480	0	0
45650981	1107830	0	0
45627239	975125	0	0
45695903	1153428	0	0
45671037	1102527	0	0
45661394	1124957	0	0
45680041	1367571	0	0
45678220	1545958	0	0
45789459	1549786	0	0
45682067	738818	0	0
45800527	967823	0	0
46296929	1112807	0	0
45786401	1125315	0	0
46297990	975125	0	0
46239548	1115171	2	3
45796981	1125315	0	0
46322626	1119510	0	0
4042835	257012	3	3
443419	4152936	2	2
21002327	1759842	0	0
21001812	1746114	0	0
36217210	964261	2	3
36156825	1124957	0	0
4092881	195588	2	2
36211089	78272	3	3
42804806	1125315	0	0
44341896	1332418	0	0
44348332	1149196	0	0
44339868	1125315	0	0
45637690	1129625	0	0
44344712	1107830	0	0
44340657	1125315	0	0
45653506	1177480	0	0
45650982	1174888	0	0
45627241	1107830	0	0
45695904	791967	0	0
45669691	1539403	0	0
45661396	1741122	0	0
45680283	1305058	0	0
45678220	1332418	0	0
45789428	1548195	0	0
45682000	738818	0	0
45800486	1549786	0	0
46297109	1000560	0	0
45786408	1125315	0	0
46297994	1107830	0	0
46239551	19059056	2	3
45796985	1125315	0	0
46316970	1119510	0	0
4072499	4035793	3	3
443419	4109685	2	2
21002327	1713332	0	0
21001816	1713332	0	0
36217210	1310034	2	3
36157232	1545958	0	0
4056681	4163872	2	2
35809215	4285898	3	3
42804915	1713332	0	0
44342043	933724	0	0
44348931	1125315	0	0
44339871	1125315	0	0
45637872	1129625	0	0
44344750	1310149	0	0
44340673	1125315	0	0
45650156	1177480	0	0
45650986	1115008	0	0
45627186	1192710	0	0
45694387	1149196	0	0
45669350	920293	0	0
45661396	1746114	0	0
45680023	933724	0	0
45678499	738818	0	0
45789492	1000560	0	0
45678912	738818	0	0
45800490	19010482	0	0
46296938	1112807	0	0
45786301	1125315	0	0
46297489	1307863	0	0
46239325	40231925	2	3
45796872	1125315	0	0
46311332	1119510	0	0
4177089	4125906	3	3
443419	4113008	2	2
21002328	1746114	0	0
21001819	1741122	0	0
36217210	19076374	2	3
36157210	1119510	0	0
4056681	4058899	2	2
36211258	40479422	3	3
42804915	1759842	0	0
44342153	1177480	0	0
44348933	1119510	0	0
44339876	1125315	0	0
45637780	1129625	0	0
44344813	1149196	0	0
44340744	1125315	0	0
45650241	1177480	0	0
45651017	1521369	0	0
45627192	1115008	0	0
45694709	1174888	0	0
45669365	740275	0	0
45660228	1115008	0	0
45679996	1713332	0	0
45678426	1149196	0	0
45789608	1000560	0	0
45678923	738818	0	0
45800620	1501700	0	0
46296939	1153428	0	0
45786313	1125315	0	0
46297398	1192710	0	0
46239658	40229134	2	3
45796967	1125315	0	0
46311410	1119510	0	0
4178818	80809	3	3
31057	28060	2	2
21002327	920293	0	0
21001819	1713332	0	0
36217210	40220386	2	3
36157269	1521369	0	0
4042505	80502	2	2
36211258	40479768	3	3
42804916	1717327	0	0
44341922	1149196	0	0
44348933	1125315	0	0
44340117	1125315	0	0
45637910	1129625	0	0
44343706	1322184	0	0
44340823	1125315	0	0
45650329	1177480	0	0
45651017	19127890	0	0
45627243	1713332	0	0
45694393	1713332	0	0
45669369	1192710	0	0
45660158	1149196	0	0
45680070	1551099	0	0
45678506	1149380	0	0
45789849	1310149	0	0
45706755	1112807	0	0
45800633	967823	0	0
46296933	1332418	0	0
45786363	1125315	0	0
46297765	753626	0	0
46239659	40224805	2	3
45796738	1125315	0	0
46311625	1119510	0	0
4178818	30753	3	3
257907	255848	2	2
21002327	1746114	0	0
21001816	1759842	0	0
36217214	1332419	2	3
36157269	1549786	0	0
4092876	196456	2	2
36502199	4146173	4	5
42804646	1124957	0	0
44342233	1548195	0	0
44348791	1539403	0	0
44340255	1125315	0	0
45637694	1129625	0	0
44343713	1759842	0	0
44340954	1125315	0	0
45650384	1177480	0	0
45651017	1549786	0	0
45627198	1738521	0	0
45694364	1549786	0	0
45669407	1118084	0	0
45660192	1137529	0	0
45680072	1343916	0	0
45678583	1149196	0	0
45789852	1115008	0	0
45705278	1112807	0	0
45800467	1332418	0	0
46297090	933724	0	0
46296767	1125315	0	0
46297799	1192710	0	0
46239611	19059056	2	3
45796879	1125315	0	0
46311814	1119510	0	0
4042836	381316	3	3
1515777	19128022	2	2
21002327	1778162	0	0
21001824	1746114	0	0
36217214	40223768	2	3
36157281	1119510	0	0
4181187	372328	2	2
36502199	4035415	4	5
42804883	1713332	0	0
44341942	933724	0	0
44348676	1125315	0	0
44340285	1125315	0	0
45637702	1129625	0	0
44343713	1713332	0	0
44340798	1125315	0	0
45650542	1177480	0	0
45651017	1503184	0	0
45627276	1521369	0	0
45694523	1124957	0	0
45669336	1107830	0	0
45660192	1149380	0	0
45679957	1361711	0	0
45678335	738818	0	0
45789856	975125	0	0
45705234	1112807	0	0
45800600	1332418	0	0
46297179	1332418	0	0
46296986	1125315	0	0
46289296	1322184	0	0
46239735	40232448	2	3
45797104	1125315	0	0
46311822	1119510	0	0
4042836	380378	3	3
1515777	19128263	2	2
21002328	920293	0	0
21001824	1741122	0	0
36217214	19075601	2	3
36156842	1149196	0	0
4144290	4324181	2	2
36502198	4230399	4	5
42804668	1124300	0	0
44342113	1000560	0	0
44348677	1125315	0	0
44340076	1125315	0	0
45634691	1129625	0	0
44343734	1124957	0	0
44340981	1125315	0	0
45650181	1177480	0	0
45650931	1124957	0	0
45627276	1549786	0	0
45694712	1154029	0	0
45669439	1308738	0	0
45658289	967823	0	0
45680010	1124300	0	0
45678336	1192710	0	0
45789863	1367571	0	0
45779998	1112807	0	0
45800602	1545958	0	0
46296966	1115008	0	0
46297008	1125315	0	0
46289301	1174888	0	0
45895940	40232448	2	3
45797038	1125315	0	0
46311423	1119510	0	0
4042836	4156265	3	3
256440	257012	2	2
21002328	1759842	0	0
21001833	1738521	0	0
36217214	19074843	2	3
36156844	1115008	0	0
4113552	4166224	2	2
36211071	4134304	3	5
42804669	1713332	0	0
44342020	1713332	0	0
44348677	1129625	0	0
44338028	1125315	0	0
45634679	1129625	0	0
44343823	1343916	0	0
44340832	1125315	0	0
45650204	1177480	0	0
45650991	967823	0	0
45627276	19127890	0	0
45692456	1118084	0	0
45669427	19039298	0	0
45658296	1322184	0	0
45680117	1308738	0	0
45678337	975125	0	0
45789869	1713332	0	0
45780180	1112807	0	0
45800534	1112807	0	0
46296967	1110410	0	0
46297021	1125315	0	0
46289140	1305058	0	0
45896157	1127433	2	3
45797208	1125315	0	0
46311435	1119510	0	0
4042836	372328	3	3
256440	40481087	2	2
21002337	1746114	0	0
21001813	1746114	0	0
36217216	19133873	2	3
36156981	1551099	0	0
4113552	440448	2	2
36211088	4134304	3	5
42804647	1149380	0	0
44341873	1174888	0	0
44348689	1154029	0	0
44338056	1125315	0	0
45634768	1129625	0	0
44343815	975125	0	0
44340769	1125315	0	0
45647257	1177480	0	0
45650906	1124957	0	0
45627236	1149196	0	0
45692463	1107830	0	0
45669527	1322184	0	0
45658330	967823	0	0
45680119	1396131	0	0
45678338	1115008	0	0
45789541	1551099	0	0
45780120	1112807	0	0
45800495	1174888	0	0
46297323	1110410	0	0
46297025	1125315	0	0
46289148	1326303	0	0
45896192	1551192	2	3
45797088	1125315	0	0
46311440	1119510	0	0
4047779	317009	3	3
135526	4066995	2	2
21002329	1746114	0	0
21001819	1759842	0	0
36217216	1150771	2	3
36156854	1107830	0	0
4201944	4151422	2	2
36211325	4152936	3	5
42804762	1322184	0	0
44341874	1107830	0	0
44348691	1153428	0	0
45619720	1125315	0	0
45634564	1129625	0	0
44343938	1110410	0	0
44340770	1125315	0	0
45647171	1177480	0	0
45650995	1322184	0	0
45627317	1310149	0	0
45692480	1174888	0	0
45669453	1115008	0	0
45658090	1153428	0	0
45680122	1738521	0	0
45678345	967823	0	0
45789456	1153428	0	0
45706122	1112807	0	0
45800505	1500211	0	0
46297331	1112807	0	0
46297054	1125315	0	0
46289166	914335	0	0
45895887	19133905	2	3
45797216	1125315	0	0
46319609	1119510	0	0
4180628	4051466	3	3
136779	4155034	2	2
21002333	1713332	0	0
21001827	1746114	0	0
36217216	920334	2	3
36156984	1177480	0	0
21600315	1361711	2	2
36211258	78272	5	5
42804923	1177480	0	0
44342154	1115008	0	0
44348871	1129625	0	0
45619727	1125315	0	0
45634754	1129625	0	0
44343872	1107830	0	0
44340952	1125315	0	0
45649032	1177480	0	0
45650919	1768849	0	0
45627107	738818	0	0
45692481	1124957	0	0
45669575	1124957	0	0
45658026	1717327	0	0
45680164	1500211	0	0
45678370	975125	0	0
45789459	1521369	0	0
45706197	1112807	0	0
45800509	1501700	0	0
46297522	975125	0	0
46296937	1125315	0	0
46289191	705944	0	0
45895994	1115171	2	3
45797024	1125315	0	0
46319394	1119510	0	0
4180628	140673	3	3
77960	80180	2	2
21002328	1778162	0	0
21001827	1741122	0	0
36217216	1332419	2	3
36157143	1539403	0	0
35204952	313217	2	2
36516972	4113008	5	5
42804652	1000560	0	0
44342163	1551099	0	0
44348872	1149380	0	0
45619778	1125315	0	0
45634780	1129625	0	0
44343947	1149196	0	0
44340843	1125315	0	0
45647340	1177480	0	0
45650923	1000560	0	0
45627109	738818	0	0
45692427	738818	0	0
45669399	1332418	0	0
45658093	791967	0	0
45680003	1326303	0	0
45678371	1192710	0	0
45789569	1112807	0	0
45706217	1112807	0	0
45800595	1307863	0	0
46297139	975125	0	0
46296938	1125315	0	0
46289209	791967	0	0
45896058	19008572	2	3
45797027	1125315	0	0
46319719	1119510	0	0
4180628	80180	3	3
76611	4146173	2	2
21002335	1746114	0	0
21001834	1768849	0	0
36217216	40223768	2	3
36157291	1112807	0	0
21604752	742185	2	2
36211315	81151	5	5
42804655	914335	0	0
44342286	1539403	0	0
44348999	705944	0	0
45619826	1125315	0	0
45637312	1129625	0	0
44343772	1308738	0	0
44341042	1125315	0	0
45647346	1177480	0	0
45650917	1110410	0	0
45627112	738818	0	0
45692431	738818	0	0
45669531	1310149	0	0
45658168	738818	0	0
45680013	1326303	0	0
45678418	1102527	0	0
45786488	1000560	0	0
45706570	1112807	0	0
45800599	757627	0	0
46297129	1115008	0	0
46294816	1115008	0	0
46289213	1115008	0	0
45896040	1127433	2	3
46318051	1125315	0	0
46319821	1119510	0	0
4029205	4326177	3	3
3048927	3023430	2	2
21002336	1741122	0	0
21001819	1778162	0	0
36217216	19125062	2	3
36157295	1129625	0	0
21604752	705944	2	2
36502197	4035415	5	5
42804657	1343916	0	0
44342020	1759842	0	0
44349001	1124957	0	0
45619873	1125315	0	0
45631471	1129625	0	0
44343677	920293	0	0
44340914	1125315	0	0
45647392	1177480	0	0
45651130	1713332	0	0
45627115	1521369	0	0
45692403	1107830	0	0
45669643	1000560	0	0
45658238	1310149	0	0
45680147	1738521	0	0
45678697	975125	0	0
45786533	1589505	0	0
45706250	1112807	0	0
45800702	967823	0	0
46292890	933724	0	0
46294933	753626	0	0
46289480	1149196	0	0
45896041	40163554	2	3
46318054	1125315	0	0
46317507	1119510	0	0
4029205	4052083	3	3
3048927	3005136	2	2
21002336	1746114	0	0
21001820	1738521	0	0
36217216	19078461	2	3
36157295	1177480	0	0
21603933	1124300	2	2
36211303	4113008	5	5
42804658	1343916	0	0
44342119	1153428	0	0
44349004	701322	0	0
45619837	1125315	0	0
45631649	1129625	0	0
44344038	738818	0	0
44340921	1125315	0	0
45644272	1177480	0	0
45651130	1759842	0	0
45627287	1501700	0	0
45692728	19003953	0	0
45669539	1174888	0	0
45658240	1000560	0	0
45680080	1551099	0	0
45678352	1000560	0	0
45786527	1738521	0	0
45700640	1112807	0	0
45800704	1192710	0	0
46293438	1501700	0	0
46294807	1107830	0	0
46289222	1000560	0	0
45895997	40229134	2	3
46317552	1125315	0	0
46317509	1119510	0	0
4027403	4186930	3	3
3049150	3005136	2	2
21002337	1741122	0	0
21001819	1717327	0	0
36202155	4278672	2	4
36157305	701322	0	0
21603302	1154343	2	2
36211303	4218389	5	5
42804763	914335	0	0
44342023	1112807	0	0
44349131	1125315	0	0
45619910	1125315	0	0
45628700	1129625	0	0
44344041	975125	0	0
44340922	1125315	0	0
45644281	1177480	0	0
45651190	791967	0	0
45627288	1322184	0	0
45692409	1545958	0	0
45669583	1174888	0	0
45658243	1595799	0	0
45677616	1310149	0	0
45675117	975125	0	0
45786837	1115008	0	0
45699886	1112807	0	0
45800537	738818	0	0
46293236	1778162	0	0
46294548	1501700	0	0
46289606	1738521	0	0
45896184	40232448	2	3
45793893	1125315	0	0
46317521	1119510	0	0
4027403	4059978	3	3
1759843	1713671	1	1
21002344	1759842	0	0
21001819	1738521	0	0
35902136	198809	2	4
36156990	1119510	0	0
21604182	753626	2	2
36211303	4296204	5	5
42804661	1343916	0	0
44341926	1713332	0	0
44349133	1129625	0	0
45619914	1125315	0	0
45631040	1129625	0	0
44344048	1307863	0	0
44340924	1125315	0	0
45644284	1177480	0	0
45651194	1149196	0	0
45627118	1551099	0	0
45692448	1332418	0	0
45669644	1124300	0	0
45658246	1149380	0	0
45677727	975125	0	0
45675121	1310149	0	0
45786733	1778162	0	0
45693571	1112807	0	0
45800808	1192710	0	0
46292916	1192710	0	0
46294364	1000560	0	0
46289264	1367571	0	0
45804352	40236446	2	3
45793887	1125315	0	0
46317268	1119510	0	0
4027403	4202832	3	3
1713545	19073183	1	1
21001804	1728416	0	0
21001823	1768849	0	0
36203060	81151	2	5
36156990	738818	0	0
36152480	19128022	2	2
36211303	4155034	5	5
42804866	1115008	0	0
44341926	1759842	0	0
44348940	708298	0	0
45620003	1125315	0	0
45628858	1129625	0	0
44343793	1110410	0	0
44340888	1125315	0	0
45644373	1177480	0	0
45651373	738818	0	0
45627122	1110410	0	0
45692520	1124957	0	0
45669510	1310149	0	0
45658118	1000560	0	0
45677545	1124957	0	0
45675176	1149196	0	0
45786509	1713332	0	0
45693607	1112807	0	0
45800818	1192710	0	0
46292918	1112807	0	0
46294281	1549786	0	0
46289271	920293	0	0
45804319	19018935	2	3
45793911	1125315	0	0
46317591	1125315	0	0
4067285	4242997	3	3
1713547	19073188	1	1
21001819	1746114	0	0
21001669	1551099	0	0
35702738	192671	2	5
36156861	1119510	0	0
36152480	19128263	2	2
36300000	375671	10	14
42804854	920293	0	0
44341928	708298	0	0
44348952	1548195	0	0
45619886	1125315	0	0
45628885	1129625	0	0
44343795	1192710	0	0
44340894	1125315	0	0
45644426	1177480	0	0
45651374	1124957	0	0
45627364	1501700	0	0
45692485	1154343	0	0
45669684	1501700	0	0
45704016	1713332	0	0
45677740	920293	0	0
45675157	738818	0	0
45786509	1759842	0	0
45693706	1112807	0	0
45800616	1115008	0	0
46293110	1501700	0	0
46294281	1521369	0	0
46289620	1332418	0	0
45804388	40163554	2	3
45794001	1125315	0	0
46313409	1125315	0	0
4067285	4117038	3	3
1154459	1154615	1	1
21000483	1551099	0	0
21001666	1551099	0	0
21602628	40236824	2	5
36156861	738818	0	0
21603966	19019273	2	2
36300000	4166224	10	14
42804986	1310149	0	0
44342104	1149196	0	0
44348942	738818	0	0
45620213	1125315	0	0
45625796	1129625	0	0
44343858	1307863	0	0
45637302	1125315	0	0
45644178	1177480	0	0
45651093	1539403	0	0
45627366	1124957	0	0
45692496	1107830	0	0
45669686	1343916	0	0
45704016	1759842	0	0
45677560	1110410	0	0
45675158	1548195	0	0
45786535	1149196	0	0
45691503	1112807	0	0
45800530	1332418	0	0
46293113	1310149	0	0
46294411	1305058	0	0
46289637	920293	0	0
45797167	19008572	2	3
45794186	1125315	0	0
46313410	1125315	0	0
4067285	4330583	3	3
4020466	4336464	1	1
21000482	1305058	0	0
21001796	1713332	0	0
36202157	375671	2	10
36156999	1153428	0	0
21603966	19078461	2	2
36300000	37017711	10	11
42804995	1177480	0	0
44342214	705944	0	0
44348942	1119510	0	0
45620250	1125315	0	0
45625921	1129625	0	0
44344162	1557272	0	0
45638161	19078461	2	3
45644511	1177480	0	0
45651280	1501700	0	0
45627369	1343916	0	0
45692501	1326303	0	0
45669521	738818	0	0
45704085	1738521	0	0
45677561	738818	0	0
45674849	1332418	0	0
45786725	1154343	0	0
45691447	1112807	0	0
45800843	967823	0	0
46293132	1149196	0	0
46294430	1192710	0	0
46289524	967823	0	0
45796694	19008572	2	3
45794190	1125315	0	0
46313418	1125315	0	0
4042140	4056621	6	8
3023227	3000963	1	1
21000485	1305058	0	0
21500574	19019979	6	7
35702738	440448	2	9
36157005	1107830	0	0
21603966	1115008	2	2
36300000	438614	9	10
42804998	1551099	0	0
44342224	975125	0	0
44348942	1125315	0	0
45620047	1125315	0	0
45625951	1129625	0	0
44343923	1738521	0	0
45640890	19078461	2	3
45644663	1177480	0	0
45651107	1713332	0	0
45627383	1738521	0	0
45692386	1539403	0	0
45669525	701322	0	0
45703842	1332418	0	0
45677563	1154029	0	0
45674852	975125	0	0
45786719	1309944	0	0
45690734	1112807	0	0
45800844	1124300	0	0
46293426	1112807	0	0
46294544	1149196	0	0
46289069	1332418	0	0
45796727	19018935	2	3
45794024	1125315	0	0
46313308	1125315	0	0
4042140	4048171	6	11
3002665	3006906	1	1
21000486	1305058	0	0
21500574	1115171	6	7
35702738	4166224	2	9
36157017	1589505	0	0
21603966	1177480	2	2
36300000	4156265	9	12
42804870	1713332	0	0
44342058	1124957	0	0
44348944	1713332	0	0
45620054	1125315	0	0
45625819	1129625	0	0
44344158	740275	0	0
45656538	19078461	2	3
45641544	1177480	0	0
45651160	1149196	0	0
45627388	1124300	0	0
45692514	1149380	0	0
45669603	1326303	0	0
45703636	1153428	0	0
45677518	1107830	0	0
45675272	1124300	0	0
45786664	1107830	0	0
45690740	1112807	0	0
45800845	1713332	0	0
46293136	1112807	0	0
46294667	1551099	0	0
46289786	975125	0	0
45796669	1551192	2	3
45794009	1125315	0	0
46313437	1125315	0	0
4042140	378001	6	10
3003169	3004501	1	1
21000482	975125	0	0
21500574	19007333	6	7
35702738	4266809	2	7
36157024	1153428	0	0
4180941	4202832	2	2
36300000	4266809	9	12
42805064	1149380	0	0
44342093	1124957	0	0
44348914	1738521	0	0
45620060	1125315	0	0
45625983	1129625	0	0
44344095	1192710	0	0
45631797	19078461	2	3
45641640	1177480	0	0
45647867	1738521	0	0
45627264	1343916	0	0
45692638	1332418	0	0
45669604	1174888	0	0
45703788	1118084	0	0
45677938	914335	0	0
45674935	738818	0	0
45786512	1112807	0	0
45687691	1112807	0	0
45800845	1759842	0	0
46293127	1174888	0	0
46294669	1738521	0	0
46289325	1310149	0	0
45791202	1551192	2	3
45794158	1125315	0	0
46313457	1125315	0	0
4029205	4330583	6	9
77162	81151	1	1
21000495	1305058	0	0
21500574	19078461	6	7
21602484	19128022	2	2
36157031	1129625	0	0
4180941	4010253	2	2
36300000	4299128	9	9
42804840	1129625	0	0
44342094	1595799	0	0
44348962	1129625	0	0
45620067	1125315	0	0
45622578	1129625	0	0
44343976	1115008	0	0
45656647	19078461	2	3
45638404	1177480	0	0
45647713	1589505	0	0
45627268	1154029	0	0
45692547	1124300	0	0
45669662	1153428	0	0
45704143	1500211	0	0
45677995	1154343	0	0
45674945	1545958	0	0
45786618	1174888	0	0
45687351	1112807	0	0
45800729	933724	0	0
46293432	1124957	0	0
46294670	1549786	0	0
46289787	1738521	0	0
45791405	40229134	2	3
45794824	1125315	0	0
46313517	1125315	0	0
4029205	4242997	6	7
77162	4059173	1	1
21000526	1305058	0	0
21500574	1127078	6	7
21602516	19128009	2	2
36157147	967823	0	0
4180941	4057420	2	2
36300000	4155034	8	11
42804979	1713332	0	0
44342094	1549786	0	0
44348962	1125315	0	0
45620092	1125315	0	0
45622841	1129625	0	0
44340081	1367571	0	0
45647179	19078461	2	3
45638394	1177480	0	0
45647899	1310149	0	0
45627269	1332418	0	0
45692554	1124957	0	0
45669607	1192710	0	0
45703982	1107830	0	0
45677520	1115008	0	0
45674856	914335	0	0
45786805	1545958	0	0
45687632	1112807	0	0
45800847	1729720	0	0
46293150	1545958	0	0
46294670	1521369	0	0
46289800	1124300	0	0
45791489	40232448	2	3
45794772	1125315	0	0
46313534	1125315	0	0
4029205	4252419	6	7
80004	4113008	1	1
19078461	19078461	0	0
21500175	40173590	6	7
21602568	19128065	2	2
36157156	1589505	0	0
4180941	4059978	2	2
36300000	380378	8	11
42804979	1759842	0	0
44342094	1521369	0	0
44348601	1759842	0	0
45620161	1125315	0	0
45622546	1129625	0	0
44340084	1115008	0	0
45641070	40228214	2	3
45640202	1177480	0	0
45647640	1000560	0	0
45627395	1778162	0	0
45692612	19010482	0	0
45669790	1548195	0	0
45703985	1174888	0	0
45677634	723013	0	0
45674858	738818	0	0
45786737	1551099	0	0
45687989	1112807	0	0
45800749	1332418	0	0
46293283	1713332	0	0
46294677	1192710	0	0
46289555	1343916	0	0
45791424	1551192	2	3
45794452	1125315	0	0
46313542	1125315	0	0
4029205	4058899	6	8
80502	40480160	1	1
19079524	19079524	0	0
21500582	19133768	6	7
21602537	1521369	2	2
36157169	967823	0	0
36217214	1150771	2	3
36300000	30753	8	12
42804980	1778162	0	0
44342096	1548195	0	0
44348923	1343916	0	0
44778120	1125315	0	0
45622651	1129625	0	0
44340091	1149196	0	0
45662823	19078461	2	3
45635211	1177480	0	0
45647643	791967	0	0
45627423	1551099	0	0
45692613	1154343	0	0
45669793	19010482	0	0
45703952	19127890	0	0
45678069	1192710	0	0
45675289	1192710	0	0
45786830	1112807	0	0
45687489	1112807	0	0
45800750	1549786	0	0
46293283	1759842	0	0
46294842	1115008	0	0
46289814	1192710	0	0
45791547	40229134	2	3
45794801	1125315	0	0
46313474	1125315	0	0
4027384	4048171	6	9
1519940	43012433	1	1
4297090	42535580	6	7
21500582	40165015	6	7
21602537	19054876	2	2
36157188	1501700	0	0
36217214	19133873	2	3
36300000	378419	8	13
42804875	1125315	0	0
44342073	738818	0	0
44348859	1154343	0	0
44361324	1125315	0	0
45622673	1129625	0	0
44340096	705944	0	0
45641011	19078461	2	3
45635562	1177480	0	0
45647904	1343916	0	0
45627486	1310149	0	0
45692591	1115008	0	0
45669478	715997	0	0
45703952	19054876	0	0
45677669	1305058	0	0
45675293	1192710	0	0
45786941	1332418	0	0
45687938	1112807	0	0
45797674	1107830	0	0
46293290	1551099	0	0
46296702	1713332	0	0
46289823	1118084	0	0
45791292	19008572	2	3
45794330	1125315	0	0
46313482	1125315	0	0
4027384	133834	6	6
443883	4084167	1	1
4297090	4047491	6	7
21500582	40231925	6	7
35508659	19128263	2	2
36157308	1119510	0	0
36217214	40173590	2	3
36300000	4294548	8	14
42804875	1174888	0	0
44342074	1539403	0	0
44348860	1125315	0	0
44361622	1125315	0	0
45622858	1129625	0	0
44340104	1107830	0	0
45646640	19078461	2	3
45635401	1177480	0	0
45647870	791967	0	0
45627487	1332418	0	0
45692673	975125	0	0
45669480	738818	0	0
45703952	1548195	0	0
45677998	1545958	0	0
45675210	1551099	0	0
45786811	1115008	0	0
45687940	1112807	0	0
45797836	701322	0	0
46293312	914335	0	0
46296765	1332418	0	0
46289582	1549786	0	0
46298473	19059056	2	3
45794332	1125315	0	0
46313376	1125315	0	0
4028387	133834	6	6
740348	19074679	1	1
4322976	4037675	6	8
21502510	19074843	6	7
35508659	19128022	2	2
36157194	1119510	0	0
36217214	40236824	2	3
36300000	4144583	11	11
42804971	1124300	0	0
44342077	1589505	0	0
44348866	1539403	0	0
44363023	40171902	1	1
45622776	1129625	0	0
44340145	715997	0	0
45631793	19078461	2	3
45632296	1177480	0	0
45647989	1192710	0	0
45627357	1551099	0	0
45692675	1729720	0	0
45669488	1548195	0	0
45703919	738818	0	0
45677871	1501700	0	0
45675211	738818	0	0
45786815	791967	0	0
45687903	1112807	0	0
45797647	1174888	0	0
46293314	1115008	0	0
46296879	708298	0	0
46289582	19127890	0	0
46298674	40232448	2	3
45794317	1125315	0	0
46313379	1125315	0	0
4029205	4024958	6	6
192956	198809	1	1
4274025	4296204	6	8
21502510	19133905	6	7
35502639	140673	2	2
36199678	1119510	0	0
36217214	19074679	2	3
36300000	4134304	11	15
42804972	1713332	0	0
44342102	1589505	0	0
44349113	19039298	0	0
44337665	19115351	1	1
45621312	1129625	0	0
44340147	1326303	0	0
45622696	19078461	2	3
45632310	1177480	0	0
45647916	1192710	0	0
45627512	1332418	0	0
45692682	723013	0	0
45669488	1512674	0	0
45703972	1501700	0	0
45677885	1154343	0	0
45675113	975125	0	0
45786949	1107830	0	0
45687974	1112807	0	0
45797763	1192710	0	0
46293264	1539403	0	0
46244044	1115008	0	0
46289987	967823	0	0
46298902	40236824	2	3
45794282	1125315	0	0
46313626	1125315	0	0
4029205	4163872	6	6
195632	4149245	1	1
21500574	1127433	6	7
21502510	19073183	6	7
21602003	1129625	2	2
36157310	723013	0	0
36217214	40222846	2	3
36300000	4084167	6	9
42804841	1115008	0	0
44342102	1549786	0	0
44349135	1124957	0	0
44784217	321042	1	1
45621288	1129625	0	0
44339937	1539403	0	0
45641363	19078461	2	3
45632323	1177480	0	0
45648001	723013	0	0
45627431	1361711	0	0
45692697	1124300	0	0
45669591	1107830	0	0
45704155	1124300	0	0
45678011	1124300	0	0
45675228	975125	0	0
45786740	1112807	0	0
45684749	1112807	0	0
45797651	1124957	0	0
46296446	967823	0	0
46244116	1149196	0	0
46289643	1000560	0	0
46298586	40163554	2	3
45794477	1125315	0	0
46313959	1125315	0	0
4032251	4243062	2	2
4001868	4301346	1	1
21500574	19059056	6	7
21502510	19129655	6	7
21602004	1129625	2	2
36157329	1738521	0	0
36217214	19073183	2	3
36300000	439777	5	11
42804843	1154343	0	0
44342243	1177480	0	0
44349135	1125315	0	0
44361661	19127918	3	4
45622017	1129625	0	0
44340505	19127890	0	0
45656208	19078461	2	3
45632402	1177480	0	0
45647907	1115008	0	0
45627223	1107830	0	0
45692624	1154029	0	0
45669497	1551099	0	0
45704113	1738521	0	0
45678014	975125	0	0
45675248	1713332	0	0
45786741	1000560	0	0
45684499	1112807	0	0
45797912	1332418	0	0
46296584	1124957	0	0
46244111	757627	0	0
46289656	1545958	0	0
46298724	40232448	2	3
45791453	1125315	0	0
46314016	1125315	0	0
4149795	44805732	2	2
1175452	3020630	1	1
4274025	192671	6	6
21502510	19133873	6	7
21603672	1343916	2	2
36157344	1112807	0	0
36217214	19133905	2	3
36208978	3014576	3	4
42804845	920293	0	0
44342295	1149196	0	0
44348601	1713332	0	0
44339931	19133679	3	4
45621996	1129625	0	0
44340505	1549786	0	0
45649708	19078461	2	3
45632496	1177480	0	0
45648050	1551099	0	0
45627447	1548195	0	0
45692775	1115008	0	0
45669500	1192710	0	0
45704120	1310149	0	0
45678015	1174888	0	0
45675254	19059528	0	0
45786631	1548195	0	0
45684840	1112807	0	0
45797777	1149196	0	0
46296697	1149196	0	0
46244207	1332418	0	0
46289721	1154343	0	0
46298556	19133873	2	3
45791456	1125315	0	0
46314423	1125315	0	0
4132546	375671	2	2
1175606	3023103	1	1
4208786	4230399	6	6
21502510	19073188	6	7
36157133	19128022	2	2
36157488	1119510	0	0
36217214	40163554	2	3
36208978	3000963	3	4
42804973	1738521	0	0
44342175	1107830	0	0
42802094	19133679	1	1
43531071	4275113	5	6
45621365	1129625	0	0
44340506	920293	0	0
45649845	19078461	2	3
45632561	1177480	0	0
45648056	1107830	0	0
45627448	1310149	0	0
45692719	1521369	0	0
45669593	715997	0	0
45704099	1115008	0	0
45678046	1149196	0	0
45675255	1310149	0	0
45786704	1309944	0	0
45682578	1112807	0	0
45797781	1000560	0	0
46296805	1115008	0	0
46244121	1500211	0	0
46289771	1124300	0	0
46298556	19133905	2	3
45791726	1125315	0	0
46313896	1125315	0	0
4132546	378001	2	2
1176181	3020630	1	1
4297090	4037675	6	6
21502510	1713671	6	7
21602628	933724	2	2
36157488	738818	0	0
36217214	40228214	2	3
36208978	3006906	3	4
42804975	1177480	0	0
44342375	1713332	0	0
42802094	19127922	1	1
43531072	4330583	4	6
45664896	1129625	0	0
44340510	1107830	0	0
44362009	19078461	2	3
45632519	1177480	0	0
45648057	19127890	0	0
45627251	1549786	0	0
45692719	19127890	0	0
45669765	1118084	0	0
45703780	738818	0	0
45677796	1778162	0	0
45675257	1115008	0	0
45786954	1557272	0	0
45682644	1112807	0	0
45797661	967823	0	0
46296717	975125	0	0
46244081	791967	0	0
46289594	975125	0	0
46299041	43012036	2	3
45791728	1125315	0	0
46308388	1125315	0	0
4103192	4329847	2	2
1175900	3008598	1	1
4247371	4048171	6	8
21502510	19075001	6	7
21602540	40224805	2	3
36157420	1107830	0	0
36217214	40223821	2	3
36208978	3009542	3	4
42804976	1310149	0	0
44342024	1557272	0	0
42802094	19129144	1	1
43531072	4117038	4	4
45664927	1129625	0	0
44340511	914335	0	0
45643929	40223768	2	3
45629431	1177480	0	0
45648057	1549786	0	0
45627251	1515774	0	0
45692719	1549786	0	0
45669772	1192710	0	0
45704031	1174888	0	0
45677816	1557272	0	0
45675236	975125	0	0
45786871	1589505	0	0
45681685	1112807	0	0
45797714	1174888	0	0
46296661	1192710	0	0
46244082	1110410	0	0
46289431	1107830	0	0
46299224	40232448	2	3
45791386	1125315	0	0
46308506	1125315	0	0
4063579	4246502	2	2
433524	4166224	1	1
4247371	375671	6	7
21502510	46275444	6	7
21602540	40224132	2	3
36157466	1107830	0	0
36217210	19129655	2	3
36207528	3016723	3	4
42805028	1153428	0	0
44342028	1149380	0	0
44786889	3023103	2	2
44786889	3013682	2	2
45664931	1129625	0	0
44340251	1713332	0	0
45637941	19078461	2	3
45629385	1177480	0	0
45648059	914335	0	0
45627251	19127890	0	0
45692723	1308738	0	0
45780877	791967	0	0
45703896	1308738	0	0
45677909	1192710	0	0
45674866	1107830	0	0
45786713	757627	0	0
45678512	1112807	0	0
45797715	1112807	0	0
46296810	1124957	0	0
46244021	1174888	0	0
46289744	1115008	0	0
46298939	40229134	2	3
45791405	1125315	0	0
46308533	1125315	0	0
4047120	440086	2	2
433524	440448	1	1
4247371	378001	6	7
21502510	19074841	6	7
35508755	1594382	2	3
36157468	1129625	0	0
36217210	46275444	2	3
36207528	3000963	3	4
42805032	19010482	0	0
44342034	1746114	0	0
45619703	1115171	2	3
44783379	4058899	2	2
45665096	1129625	0	0
44340251	1759842	0	0
45659395	19078461	2	3
45626640	1177480	0	0
45648077	1332418	0	0
45627296	1310149	0	0
45692844	715997	0	0
45780900	1149196	0	0
45703899	1000560	0	0
45677923	1308738	0	0
45675005	1115008	0	0
45786818	1738521	0	0
45672758	1112807	0	0
45797887	967823	0	0
46296815	1153428	0	0
46244085	1154343	0	0
46289750	1343916	0	0
46298760	40236824	2	3
45791709	1125315	0	0
46308529	1125315	0	0
4028876	255848	2	2
434621	80809	1	1
4274025	40479422	7	9
21500148	1539403	6	6
35508769	35605482	2	3
36157468	1119510	0	0
36217210	35605858	2	3
36207528	3024561	3	4
42804860	1115008	0	0
44342034	1741122	0	0
45619706	40162522	2	3
44782549	4066995	2	2
45665117	1129625	0	0
44340497	1548195	0	0
45646861	40223768	2	3
45626441	1177480	0	0
45647923	967823	0	0
45627454	1102527	0	0
45692699	1713332	0	0
45780718	723013	0	0
45704064	1361711	0	0
45677742	975125	0	0
45675051	1343916	0	0
45786919	1112807	0	0
45672761	1112807	0	0
45797895	1149196	0	0
46293557	1500211	0	0
46244129	1310149	0	0
46289926	1713332	0	0
46291664	40232448	2	3
45791685	1125315	0	0
46308558	1125315	0	0
4028902	4187458	2	2
257907	261325	1	1
21502709	1125315	7	7
21502709	40223834	9	10
35508683	19133873	2	3
36157365	1551099	0	0
36217210	42707627	2	3
35702800	4112343	3	4
42805061	1343916	0	0
44342133	1177480	0	0
45621976	40165015	2	3
44782549	4048695	2	2
45665055	1129625	0	0
44340236	1713332	0	0
45656382	19078461	2	3
45626728	1177480	0	0
45648081	1367571	0	0
45627461	1713332	0	0
45692803	1361711	0	0
45780797	1361711	0	0
45703904	1326303	0	0
45677823	1192710	0	0
45675126	1778162	0	0
45786927	920293	0	0
45784497	1112807	0	0
45797868	1539403	0	0
46293639	1738521	0	0
46244219	1107830	0	0
46289926	1759842	0	0
46290507	40163554	2	3
45791550	1125315	0	0
46308297	1125315	0	0
4028970	260139	2	2
260123	4294548	1	1
4208786	4134304	7	7
21502709	40228214	9	10
35508683	19133905	2	3
36157368	920293	0	0
36217210	19057271	2	3
36211258	81151	4	4
42803300	1539403	0	0
44342189	1713332	0	0
45619795	40232448	2	3
44337624	19128009	2	2
45665108	1129625	0	0
44340370	975125	0	0
45646890	19078461	2	3
45623312	1177480	0	0
45648148	1192710	0	0
45627461	1759842	0	0
45689272	1551099	0	0
45780905	1149380	0	0
45703906	1174888	0	0
45677837	1154343	0	0
45675096	1326303	0	0
45786769	967823	0	0
45784539	1112807	0	0
45797876	738818	0	0
46293679	701322	0	0
46244209	1332418	0	0
46289880	1308738	0	0
46290476	1115171	2	3
45791554	1125315	0	0
46308570	1125315	0	0
4168666	378419	2	2
1766555	19127904	1	2
4208786	78272	7	7
21502709	19125062	9	10
35508686	46275444	2	3
36157369	1115008	0	0
36217210	40243436	2	3
36211260	78272	4	4
42803276	1322184	0	0
44342390	1177480	0	0
44360997	40231925	2	3
44337624	19127918	2	2
45665142	1129625	0	0
44340371	1124300	0	0
45653162	19078461	2	3
45623365	1177480	0	0
45647857	1539403	0	0
45627462	975125	0	0
45689532	1738521	0	0
45780812	1326303	0	0
45703907	1174888	0	0
45677838	1717327	0	0
45675200	1308738	0	0
45786772	914335	0	0
45784618	1112807	0	0
45797881	1115008	0	0
46293606	1174888	0	0
46244225	1310149	0	0
46289835	1115008	0	0
46290428	42707627	2	3
45791697	1125315	0	0
46308311	1125315	0	0
4042645	4163951	2	2
77960	78272	3	6
21601120	1308738	2	2
21502709	1112807	7	7
35508981	1115171	2	3
36157373	1154343	0	0
36217216	40174880	2	3
36517140	40479422	4	4
42803279	1119510	0	0
44342182	1112807	0	0
44361403	1115171	2	3
44337577	19128009	2	2
45665176	1129625	0	0
44340373	1110410	0	0
45662563	19078461	2	3
45623329	1177480	0	0
45648164	933724	0	0
45627463	920293	0	0
45689422	1501700	0	0
45780816	1174888	0	0
45706791	715997	0	0
45677754	975125	0	0
45675266	738818	0	0
45786931	1192710	0	0
45784829	1112807	0	0
45798014	1149196	0	0
46293610	1174888	0	0
46244140	1124957	0	0
46289836	1343916	0	0
46290698	40232448	2	3
45791837	1125315	0	0
46308750	1125315	0	0
4059308	4163971	2	2
4002031	4336464	3	6
21500624	723013	2	2
21502709	1115008	7	7
35508845	40162522	2	3
36157376	1119510	0	0
36208978	3051031	2	3
36517140	40479768	4	4
42803287	975125	0	0
44342305	1192710	0	0
44361462	19008572	2	3
45637521	19128009	2	2
45662295	1129625	0	0
44340374	757627	0	0
45637681	19078461	2	3
45623747	1177480	0	0
45647825	1361711	0	0
45627538	1115008	0	0
45691616	1124300	0	0
45780835	1153428	0	0
45651760	705944	0	0
45677962	1153428	0	0
45676416	1192710	0	0
45786875	1174888	0	0
45784831	1112807	0	0
45797788	1124957	0	0
46293614	1115008	0	0
46244145	914335	0	0
46289839	1326303	0	0
46290863	19073188	2	3
45791786	1125315	0	0
46308612	1125315	0	0
4132552	4112343	2	2
74726	4134304	3	5
21500624	740275	2	2
4247371	4043241	7	8
35502093	140673	2	3
36157376	738818	0	0
36208195	3005136	2	3
36517012	40479422	4	4
42803295	1124300	0	0
44342007	1124300	0	0
44361374	19059056	2	3
45656037	19128022	1	2
45662697	1129625	0	0
44340379	705944	0	0
45641351	19078461	2	3
45623640	1177480	0	0
45648233	1332418	0	0
45627539	738818	0	0
45691511	1738521	0	0
45780914	1174888	0	0
45651472	1310149	0	0
45678050	1501700	0	0
45676338	975125	0	0
45786850	1521369	0	0
45782402	1112807	0	0
45797814	1545958	0	0
46293719	1713332	0	0
46244146	791967	0	0
46289842	975125	0	0
46290718	19078924	2	3
45791671	1125315	0	0
46308617	1125315	0	0
4132552	198809	2	2
193460	4152936	3	5
21500624	19074679	2	2
21500120	40173590	9	10
35506609	4144583	2	3
36157379	1115008	0	0
36208195	3036780	2	3
36517012	40479768	4	4
42803298	1545958	0	0
44342532	1332418	0	0
44361193	1115171	2	3
45656037	19128263	1	2
45662728	1129625	0	0
44340382	1107830	0	0
45652927	19078461	2	3
45623642	1177480	0	0
45648172	19054876	0	0
45627547	19010482	0	0
45691477	1778162	0	0
45783268	1717327	0	0
45651717	1738521	0	0
45678052	920293	0	0
45676423	1115008	0	0
45786851	1174888	0	0
45783586	1112807	0	0
45797973	1310149	0	0
46293520	1174888	0	0
46244159	1326303	0	0
46289902	1192710	0	0
46290779	40162522	2	3
45791831	1125315	0	0
46308473	1125315	0	0
4044889	4047491	2	2
193460	4149245	3	5
21500612	1343916	2	2
21500120	1551192	9	10
35508948	19008572	2	3
36157397	975125	0	0
36208195	3010813	2	3
36302172	4314290	4	4
42803299	1326303	0	0
44342316	1501700	0	0
44361547	40231925	2	3
44337577	19127918	1	2
45662433	1129625	0	0
44340537	975125	0	0
45640630	19079524	2	3
45623349	1177480	0	0
45648172	1548195	0	0
45627468	1738521	0	0
45691488	1551099	0	0
45783372	1192710	0	0
45651722	1154343	0	0
45677967	1107830	0	0
45676430	1307863	0	0
45786856	1154343	0	0
45782727	1112807	0	0
45797931	738818	0	0
46293809	1153428	0	0
46244161	1154029	0	0
46241667	1192710	0	0
46290814	40232448	2	3
45791729	1125315	0	0
46308660	1125315	0	0
4115260	261325	2	2
77960	4149245	3	4
21500215	1307863	2	2
21500120	1589505	7	7
35509044	40236824	2	3
36157403	1129625	0	0
36208195	3023430	2	3
36517149	4149245	4	4
42803432	1309944	0	0
44337665	723013	0	0
44361702	40229134	2	3
44778030	40174880	2	3
45662887	1129625	0	0
44340540	1000560	0	0
45637740	1332419	2	3
45667537	1177480	0	0
45648172	19127890	0	0
45627555	1310149	0	0
45691566	1501700	0	0
45783389	1174888	0	0
45651762	1521369	0	0
45678079	1310149	0	0
45676293	1000560	0	0
45786787	1124957	0	0
45782769	1112807	0	0
45797717	738818	0	0
46293730	1501700	0	0
46244249	1728416	0	0
46241669	1192710	0	0
46290815	40232448	2	3
45791730	1125315	0	0
46308670	1125315	0	0
4133611	4132546	2	2
75909	4142905	3	4
21503193	1759842	2	2
21500120	1500211	7	7
35509076	40229134	2	3
36157404	1119510	0	0
36217207	19023398	2	3
36211375	378001	4	4
42803435	1124300	0	0
44337826	1153428	0	0
44361679	1115171	2	3
44778286	40232448	2	3
45661355	1129625	0	0
44339943	1729720	0	0
45638234	1332419	2	3
45667886	1177480	0	0
45648173	1396131	0	0
45627560	1154343	0	0
45691579	967823	0	0
45783181	933724	0	0
45651783	1332418	0	0
45679563	738818	0	0
45676367	715997	0	0
45786959	1548195	0	0
45780850	1112807	0	0
45797898	967823	0	0
46293827	742185	0	0
46244149	1000560	0	0
46241637	914335	0	0
46290683	40236824	2	3
45791794	1125315	0	0
46308672	1125315	0	0
4027369	4310024	2	2
4022449	4146173	3	4
21503193	1343916	2	2
21500120	933724	7	7
35509096	40232448	2	3
36157337	1149196	0	0
36217209	43012433	2	3
36211375	375671	4	4
42803247	1729720	0	0
44337827	1149380	0	0
44361399	1115171	2	3
44778271	40231925	2	3
45659340	1129625	0	0
44340472	1110410	0	0
45637862	1332419	2	3
45667202	1177480	0	0
45648061	933724	0	0
45627569	19127890	0	0
45691516	975125	0	0
45783272	791967	0	0
45651691	1332418	0	0
45679713	1521369	0	0
45676370	1124957	0	0
45786960	1713332	0	0
45780948	1112807	0	0
45798044	1153428	0	0
46293735	1174888	0	0
46244228	1192710	0	0
46241568	1309944	0	0
46291113	40229134	2	3
45791795	1125315	0	0
46308674	1125315	0	0
4091532	4266809	2	2
4022201	4142905	3	4
21500216	1309944	2	2
21500120	1551099	7	7
36156889	1115171	2	3
36157448	1129625	0	0
36155989	1545959	2	3
36211065	4134304	4	4
42803439	1119510	0	0
44337832	1192710	0	0
44361522	19008572	2	3
44778219	40229134	2	3
45659676	1129625	0	0
44340473	1307863	0	0
45646620	1332419	2	3
45665512	1177480	0	0
45647981	1124300	0	0
45623707	1192710	0	0
45691609	723013	0	0
45783485	1549786	0	0
45651757	708298	0	0
45679772	1000560	0	0
45676376	1115008	0	0
45786798	1192710	0	0
45780244	1112807	0	0
45798054	1548195	0	0
46293735	1192710	0	0
46244229	1551099	0	0
46241587	975125	0	0
46242371	40232448	2	3
45791754	1125315	0	0
46308714	1125315	0	0
4168644	4174876	2	2
4022201	4237458	3	4
21503143	914335	2	2
21500120	1549786	7	7
36156890	19125062	2	3
36009704	133834	0	0
36150893	1545959	2	3
36500000	4218389	4	4
42803441	975125	0	0
44337836	1174888	0	0
44361351	43012036	2	3
44778069	46275916	2	3
45659504	1129625	0	0
44340476	975125	0	0
45634815	1332419	2	3
45665518	1177480	0	0
45648270	1115008	0	0
45623900	738818	0	0
45691615	914335	0	0
45783485	1595799	0	0
45651641	1107830	0	0
45679627	1124300	0	0
45676379	1539403	0	0
45786886	1192710	0	0
45780315	1112807	0	0
45797819	1112807	0	0
46293837	791967	0	0
46244147	1545958	0	0
46241706	1124957	0	0
46242223	1127433	2	3
45791756	1125315	0	0
46308692	1125315	0	0
4176946	80809	2	2
4022139	4108705	3	4
21503147	1154029	2	2
21500120	19054876	7	7
36156623	1127433	2	3
36151990	1153428	0	0
36156033	1332419	2	3
36211308	4152936	4	4
42803246	1713332	0	0
44337838	933724	0	0
44361309	19008572	2	3
44778070	46275916	2	3
45659464	1129625	0	0
44340039	1174888	0	0
45656594	40174880	2	3
45665846	1177480	0	0
45648225	1549786	0	0
45624029	1154029	0	0
45691722	757627	0	0
45783485	1521369	0	0
45651644	1713332	0	0
45679628	1713332	0	0
45676387	1307863	0	0
45786967	1551099	0	0
45780231	1112807	0	0
45797954	1713332	0	0
46293846	1124957	0	0
46244271	1309944	0	0
46241639	1309944	0	0
46242338	40228214	2	3
45791763	1125315	0	0
46308702	1125315	0	0
4177703	4027663	2	2
4022923	4149245	3	4
21500595	1177480	2	2
21500120	975125	7	7
36157205	40229134	2	3
36152190	1539403	0	0
36150969	19078461	2	3
36603345	4285898	4	4
42803405	1129625	0	0
44337847	1115008	0	0
44357482	40231925	2	3
44358143	43012036	2	3
45656523	1129625	0	0
44340369	738818	0	0
45653115	1545959	2	3
45663129	1177480	0	0
45648225	1589505	0	0
45625137	1309944	0	0
45691742	1115008	0	0
45783501	1149196	0	0
45651644	1759842	0	0
45679628	1759842	0	0
45676477	914335	0	0
45786975	1000560	0	0
45777738	1112807	0	0
45797903	1124300	0	0
46288767	1112807	0	0
46244293	1717327	0	0
46241625	723013	0	0
46242356	40229134	2	3
45791769	1125315	0	0
46312106	1125315	0	0
4058419	4323208	2	2
4004041	4336464	3	4
21500595	1124300	2	2
4274025	4299128	5	5
36156878	35605858	2	3
36151910	1119510	0	0
36155793	19078461	2	3
36211088	78272	4	4
42803087	1759842	0	0
44337684	1112807	0	0
44357494	19133905	2	3
44357923	19059056	2	3
45656353	1129625	0	0
44340543	1149380	0	0
45647197	1545959	2	3
45663242	1177480	0	0
45648232	1174888	0	0
45625180	1174888	0	0
45691658	1332418	0	0
45780995	1557272	0	0
45651646	1595799	0	0
45679630	1500211	0	0
45676298	1110410	0	0
45786900	1174888	0	0
45777778	1112807	0	0
45797980	738818	0	0
46288619	1738521	0	0
46244380	1738521	0	0
46241740	1192710	0	0
46239615	40232448	2	3
45789048	1125315	0	0
46312186	1125315	0	0
4090615	78272	2	2
193460	4059173	3	4
21500595	1129625	2	2
4274025	442116	5	6
36157062	1115171	2	3
36152267	1129625	0	0
36155906	19078461	2	3
36502199	80502	4	4
42803087	1713332	0	0
44338018	791967	0	0
44357502	40229134	2	3
44359132	42707627	2	3
45656463	1129625	0	0
44340512	1118084	0	0
45641598	1539411	2	3
45663021	1177480	0	0
45648273	738818	0	0
45625186	1332418	0	0
45691661	1174888	0	0
45780998	1000560	0	0
45651326	1174888	0	0
45679631	1149196	0	0
45672259	1738521	0	0
45786903	1717327	0	0
45706371	1112807	0	0
45798040	1343916	0	0
46288881	1549786	0	0
46244373	1192710	0	0
46241745	1118084	0	0
46239621	19059056	2	3
45788965	1125315	0	0
46312205	1125315	0	0
4042835	4283893	2	2
193460	4109685	3	4
21500604	1115008	2	2
4274025	439406	5	6
35507067	46275916	2	3
36152267	1112807	0	0
36151342	19078461	2	3
36211677	4084167	4	4
42803088	1112807	0	0
44337733	1759842	0	0
44357714	46275916	2	3
44359180	1115171	2	3
45656624	1129625	0	0
44340486	1115008	0	0
45659558	1539411	2	3
45663249	1177480	0	0
45647860	705944	0	0
45625245	1174888	0	0
45691663	1115008	0	0
45781031	1551099	0	0
45651327	1174888	0	0
45679639	791967	0	0
45672304	1332418	0	0
45786904	1115008	0	0
45706486	1112807	0	0
45797993	1545958	0	0
46288889	1310149	0	0
46244194	1153428	0	0
46241748	975125	0	0
46240237	40229134	2	3
45789003	1125315	0	0
46312350	1125315	0	0
4042835	4156265	2	2
1548195	40221415	3	4
21500604	1125315	2	2
4274025	4306014	5	6
35507212	1115171	2	3
36151910	738818	0	0
36154974	40228214	2	3
36516993	317576	4	4
42803145	1539403	0	0
44363691	1343916	0	0
44354569	40232448	2	3
44359185	43012036	2	3
45652995	1129625	0	0
44340494	920293	0	0
45665241	1539411	2	3
45663466	1177480	0	0
45648287	1322184	0	0
45625194	975125	0	0
45691435	1519936	0	0
45781032	738818	0	0
45651329	1124957	0	0
45679716	1589505	0	0
45671925	1551099	0	0
45786908	975125	0	0
45706443	1112807	0	0
45797824	1115008	0	0
46288461	1738521	0	0
46244258	1149196	0	0
46241691	1738521	0	0
45896227	1115171	2	3
45789006	1125315	0	0
46312287	1125315	0	0
4152154	4202451	2	2
73553	4149245	3	3
21500604	1124300	2	2
4274025	4156265	5	7
36212328	19128022	2	3
36151911	1177480	0	0
36155203	40228214	2	3
36211325	4156265	4	4
42803184	1125315	0	0
44363312	1115008	0	0
44350813	1551192	2	3
44358931	19008572	2	3
45652923	1129625	0	0
44340417	1115008	0	0
45653553	1539411	2	3
45660111	1177480	0	0
45648115	1308738	0	0
45625195	1545958	0	0
45691527	1308738	0	0
45781044	1192710	0	0
45651331	1107830	0	0
45679242	1000560	0	0
45671926	975125	0	0
45786433	1107830	0	0
45706604	1112807	0	0
45797998	1713332	0	0
46288372	1153428	0	0
46244199	1738521	0	0
46241674	1124957	0	0
45896231	19019273	2	3
45789057	1125315	0	0
46312430	1125315	0	0
4176801	4057420	2	2
77960	80809	3	3
21500653	1112807	2	2
4274025	4230399	7	10
35508397	19019273	2	3
36151911	1129625	0	0
36224185	19127904	2	3
36211325	4230399	4	4
42803112	1332418	0	0
44363669	1177480	0	0
44350612	1115171	2	3
44358396	40162522	2	3
45652937	1129625	0	0
44340502	1332418	0	0
45632431	19079524	1	1
45634196	1112807	0	0
45648192	1154029	0	0
45625198	1149196	0	0
45689757	1000560	0	0
45781051	738818	0	0
45651338	1501700	0	0
45679565	1551099	0	0
45672201	1000560	0	0
45786434	975125	0	0
45703245	1112807	0	0
45797998	1759842	0	0
46288866	1112807	0	0
46244202	1000560	0	0
46241766	705944	0	0
45896253	19126352	2	3
45788949	1125315	0	0
46311837	1125315	0	0
4172515	4107731	2	3
77960	4146173	3	3
21500653	1125315	2	2
4274025	40479768	7	9
35508775	19019273	2	3
36152105	1119510	0	0
36151177	1107882	2	3
36211315	40479768	4	4
42802260	1557272	0	0
44363708	1326303	0	0
44350419	40232448	2	3
44358420	1127433	2	3
45653178	1129625	0	0
44340611	1332418	0	0
45632271	19079524	1	1
45634084	1112807	0	0
45648254	1343916	0	0
45625201	1174888	0	0
45689701	1174888	0	0
45781052	1115008	0	0
45651341	1000560	0	0
45674500	1713332	0	0
45672202	967823	0	0
45786577	753626	0	0
45703095	1112807	0	0
45798005	1107830	0	0
46288867	1124300	0	0
46244203	1124957	0	0
46241764	1539403	0	0
45896240	40232448	2	3
45789144	1125315	0	0
46311838	1125315	0	0
4101219	4285898	2	3
432795	4094814	3	3
21500643	19003953	2	2
4274025	4144583	7	7
21603453	40229134	2	3
36152294	1539403	0	0
36155937	1107882	2	3
36211315	40479422	4	4
42802245	1307863	0	0
44363716	1361711	0	0
44350711	40232448	2	3
44358369	782047	2	3
45653352	1129625	0	0
44340636	19127890	0	0
45623345	19079524	1	1
45629132	1112807	0	0
45648257	933724	0	0
45625145	1521369	0	0
45689703	1124957	0	0
45781055	1124957	0	0
45651461	715997	0	0
45674623	740275	0	0
45671909	738818	0	0
45786579	1539403	0	0
45703099	1112807	0	0
45798007	1115008	0	0
46288816	1174888	0	0
46244347	757627	0	0
46242602	1174888	0	0
45896396	19008572	2	3
45789138	1125315	0	0
46311912	1125315	0	0
4115106	4285898	2	3
432795	381316	3	3
21001758	19133905	2	3
4274025	375671	6	10
36156644	40228214	2	3
36152297	1124300	0	0
36150763	1107882	2	3
36000000	4169137	4	4
42802303	1124300	0	0
44363717	933724	0	0
44350517	40236824	2	3
44358474	1127433	2	3
45653151	1129625	0	0
44340636	1515774	0	0
45665452	19079524	1	1
45628973	1112807	0	0
45648258	1115008	0	0
45625145	1595799	0	0
45689795	1107830	0	0
45781025	1307863	0	0
45651447	1310149	0	0
45674625	1174888	0	0
45672188	1124957	0	0
45786583	975125	0	0
45703219	1112807	0	0
45799744	738818	0	0
46288881	1589505	0	0
46244350	975125	0	0
46242611	1307863	0	0
45896342	1310034	2	3
45789032	1125315	0	0
46311997	1125315	0	0
4042835	40481087	2	3
432586	440086	3	3
21001758	19133873	2	3
4274025	4146173	6	8
35509025	1107882	2	3
36152299	738818	0	0
36156485	1107882	2	3
36211303	4299128	4	4
42802273	1307863	0	0
44363475	1124300	0	0
44350532	40232448	2	3
44358612	46275916	2	3
45653276	1129625	0	0
44340636	1549786	0	0
45626583	19079524	1	1
45629269	1112807	0	0
45648022	1548195	0	0
45625145	1549786	0	0
45689765	738818	0	0
45781143	1174888	0	0
45651449	791967	0	0
45674583	1589505	0	0
45672243	1107830	0	0
45785255	967823	0	0
45700010	1112807	0	0
45795188	967823	0	0
46288900	1115008	0	0
46239174	975125	0	0
46242578	1501700	0	0
45896607	920334	2	3
45789148	1125315	0	0
46311999	1125315	0	0
4027384	198809	2	6
432586	378419	3	3
21003223	40232448	2	3
4274025	433125	6	6
36156637	19078461	2	3
36152412	1549786	0	0
36207527	3000963	2	3
36211303	4296205	4	4
42802282	1153428	0	0
44363412	1112807	0	0
44350685	19076374	2	3
44358656	19073183	2	3
45653345	1129625	0	0
44340462	967823	0	0
45665375	19079524	1	1
45627888	1112807	0	0
45648026	1322184	0	0
45625215	738818	0	0
45689745	791967	0	0
45781013	1115008	0	0
45651462	738818	0	0
45674585	967823	0	0
45672311	791967	0	0
45785306	1738521	0	0
45700030	1112807	0	0
45795158	1713332	0	0
46288632	1192710	0	0
46239394	1713332	0	0
46242566	1153428	0	0
45896610	43012036	2	3
46301922	1125315	0	0
46308790	1125315	0	0
4028902	4037675	5	6
443883	4294548	3	3
21003185	46275916	2	3
4274025	4237458	6	9
36156620	19079524	2	3
36151913	1118084	0	0
36207527	3006906	2	3
36300000	4191853	4	4
42802332	1124300	0	0
44363417	920293	0	0
44350522	19133873	2	3
44358661	1115171	2	3
45653133	1129625	0	0
44340197	1174888	0	0
45626391	19079524	1	1
45627984	1112807	0	0
45648127	1332418	0	0
45625220	791967	0	0
45689749	19127890	0	0
45780980	1500211	0	0
45651463	1548195	0	0
45674691	19002770	0	0
45672199	1361711	0	0
45785340	1192710	0	0
45697125	1112807	0	0
45795151	967823	0	0
46288644	1115008	0	0
46239358	1713332	0	0
46241837	1118084	0	0
45893954	40236824	2	3
46301961	1125315	0	0
46308813	1125315	0	0
4172024	433644	5	6
200174	134438	3	3
21002670	46233710	2	3
4274025	4059173	6	9
36156671	19079524	2	3
36151923	1119510	0	0
36207527	3014576	2	3
36206173	3028833	5	5
42802309	723013	0	0
44363673	1112807	0	0
44350713	1115171	2	3
44351379	19133905	2	3
45653114	1129625	0	0
44340200	1713332	0	0
45647284	19079524	1	1
45626121	1112807	0	0
45644802	1102527	0	0
45625238	1000560	0	0
45689749	1589505	0	0
45780982	1174888	0	0
45651705	753626	0	0
45674706	1589505	0	0
45672327	1192710	0	0
45785309	1174888	0	0
45697043	1112807	0	0
45795189	1107830	0	0
46288648	1124300	0	0
46239372	1000560	0	0
46241850	1545958	0	0
45894024	1127433	2	3
46301965	1125315	0	0
46303622	1125315	0	0
4091532	81893	5	6
197917	198809	3	3
21002455	46275444	2	3
21500972	1149380	2	2
36157232	1545959	2	3
36151927	1177480	0	0
36207527	3009542	2	3
36206173	3020655	6	6
42802295	1154029	0	0
44363356	1124300	0	0
44350721	19073188	2	3
44351293	40229134	2	3
45653216	1129625	0	0
44340334	1118084	0	0
45626240	19079524	1	1
45626130	1112807	0	0
45644789	1192710	0	0
45625312	1738521	0	0
45689749	1549786	0	0
45780987	1107830	0	0
45652199	738818	0	0
45674711	1118084	0	0
45672263	1500211	0	0
45785283	1174888	0	0
45693900	1112807	0	0
45795194	738818	0	0
46288656	1115008	0	0
46239373	1557272	0	0
46241863	1107830	0	0
45894025	1127433	2	3
46301827	1125315	0	0
46303312	1125315	0	0
4091363	4112343	5	6
4021915	439777	3	3
21002421	46275444	2	3
21500972	1129625	2	2
36156867	19078461	2	3
36152361	975125	0	0
36150937	19078461	2	3
36206173	3007461	3	7
42802394	715997	0	0
44363507	1124300	0	0
44351071	40232448	2	3
44351356	40229134	2	3
45649975	1129625	0	0
44340602	708298	0	0
45623116	19079524	1	1
45626148	1112807	0	0
45644786	19127890	0	0
45625155	1149196	0	0
45689772	1551099	0	0
45780989	967823	0	0
45652200	1154343	0	0
45674714	1713332	0	0
45672432	1501700	0	0
45785283	1192710	0	0
45694055	1112807	0	0
45795323	1549786	0	0
46288825	1115008	0	0
46239435	1174888	0	0
46241838	1192710	0	0
45894026	1127433	2	3
46298967	1125315	0	0
46303279	1125315	0	0
4042836	378001	5	6
4021780	195588	3	3
21003454	40224132	2	3
21500972	975125	2	2
35509015	19078461	2	3
36152363	975125	0	0
36211065	4230399	2	3
36206173	3014576	3	7
42802406	1000560	0	0
44363762	1000560	0	0
44351079	19059056	2	3
44351429	40236824	2	3
45649991	1129625	0	0
44340605	1332418	0	0
45657041	19079524	1	1
45626375	1112807	0	0
45644786	1521369	0	0
45625202	1332418	0	0
45689841	1557272	0	0
45780990	1746114	0	0
45652301	1107830	0	0
45674714	1759842	0	0
45672051	1174888	0	0
45785284	1115008	0	0
45690966	1112807	0	0
45795323	19127890	0	0
46288830	1115008	0	0
46239578	1149196	0	0
46241887	19010482	0	0
45894027	1127433	2	3
46299548	1125315	0	0
46303442	1125315	0	0
4115259	258780	5	5
4022571	28060	3	3
21003454	1519937	2	3
4179713	4163971	2	2
36156949	40228214	2	3
36152365	1149196	0	0
36224164	42902245	2	3
36206173	3045716	3	7
42802410	791967	0	0
44363806	1149380	0	0
44348529	1127433	2	3
44351514	1551192	2	3
45646780	1129625	0	0
44340203	738818	0	0
45641661	19079524	1	1
45622762	1112807	0	0
45644786	1549786	0	0
45624124	967823	0	0
45689708	738818	0	0
45780990	1741122	0	0
45652256	1107830	0	0
45674835	1124300	0	0
45672052	1343916	0	0
45785359	1367571	0	0
45688086	1112807	0	0
45795323	1521369	0	0
46288842	1107830	0	0
46239457	1545958	0	0
46241871	1309944	0	0
45894028	1127433	2	3
46299549	1125315	0	0
46303452	1125315	0	0
4177703	81893	5	5
4020347	78272	3	3
21003454	40224805	2	3
21600985	1322184	2	2
36218510	40221415	2	3
36152368	975125	0	0
36151049	19123231	2	3
36206173	3026361	3	8
42802418	19127890	0	0
44363811	1177480	0	0
44348654	40236824	2	3
44351616	1127433	2	3
45647131	1129625	0	0
44340357	1153428	0	0
45632281	19079524	1	1
45623179	1112807	0	0
45644990	967823	0	0
45624125	1500211	0	0
45689659	1332418	0	0
45781015	1115008	0	0
45651978	1595799	0	0
45674957	1192710	0	0
45672271	1343916	0	0
45785299	1112807	0	0
45688088	1112807	0	0
45795109	1326303	0	0
46291628	975125	0	0
46239532	1124957	0	0
46241814	1322184	0	0
45894122	782047	2	3
46299384	1125315	0	0
46303719	1125315	0	0
4132647	4336464	5	5
444089	196456	3	3
21003454	44816277	2	3
21600985	1112807	2	2
35508889	40228214	2	3
36157452	933724	0	0
36224165	42902245	2	3
36502202	80180	4	4
42802418	1521369	0	0
44363813	1343916	0	0
44347072	40236824	2	3
44351559	35605482	2	3
45647137	1129625	0	0
44340608	1124300	0	0
45644543	19079524	1	1
45623103	1112807	0	0
45644852	791967	0	0
45624128	1308738	0	0
45689899	1305058	0	0
45781064	738818	0	0
45651978	1521369	0	0
45674958	1174888	0	0
45672331	975125	0	0
45785314	1326303	0	0
45688131	1112807	0	0
45795112	1310149	0	0
46291631	1192710	0	0
46239540	1332418	0	0
46241818	1738521	0	0
45894097	19133905	2	3
46299553	1125315	0	0
46303722	1125315	0	0
4028908	4024958	5	5
1176472	3023103	2	2
21002671	19008572	2	3
4187630	45766064	2	2
35509157	19079524	2	3
36157453	1129625	0	0
36151074	1545959	2	3
36502202	381316	5	5
42802418	1549786	0	0
44363817	738818	0	0
44346976	1551192	2	3
44351466	19133905	2	3
45646891	1129625	0	0
44340224	1107830	0	0
45667849	19079524	1	1
45621504	1112807	0	0
45644894	1307863	0	0
45624129	1729720	0	0
45689666	738818	0	0
45780450	1332418	0	0
45651978	1549786	0	0
45674953	715997	0	0
45672445	1149196	0	0
45785304	705944	0	0
45688190	1112807	0	0
45795197	1307863	0	0
46290991	1778162	0	0
46239458	791967	0	0
46241851	723013	0	0
45894097	19133873	2	3
46299178	1125315	0	0
46303114	1125315	0	0
4042835	4048171	5	5
1176472	3016723	2	2
21500645	42707627	2	3
21604793	836654	2	2
35509152	19078461	2	3
36157457	1118084	0	0
36155267	1545959	2	3
36502202	80809	5	5
42802384	1551099	0	0
44363817	1112807	0	0
42804388	1177480	0	0
44351775	43012036	2	3
45646710	1129625	0	0
44340450	715997	0	0
45663375	19079524	1	1
45667461	1112807	0	0
45644895	738818	0	0
45624137	1192710	0	0
45689678	1174888	0	0
45780454	967823	0	0
45652013	1713332	0	0
45674734	1361711	0	0
45672343	914335	0	0
45785323	791967	0	0
45688247	1112807	0	0
45795221	1500211	0	0
46291655	1112807	0	0
46239459	975125	0	0
46242004	1551099	0	0
45894062	19019273	2	3
46299396	1125315	0	0
46303115	1125315	0	0
4029205	4062501	5	5
444089	195588	2	2
21500599	19007333	2	3
4179873	80180	2	2
35506858	19078461	2	3
36157757	1192710	0	0
36150758	1551192	2	3
36502202	80502	5	5
42802362	1177480	0	0
44363831	738818	0	0
42804389	1177480	0	0
44351820	40236824	2	3
45647119	1129625	0	0
44340324	738818	0	0
45660084	46275916	1	1
45665265	1112807	0	0
45644896	1551099	0	0
45624149	1521369	0	0
45689680	1326303	0	0
45780692	1343916	0	0
45652013	1759842	0	0
45674737	1759842	0	0
45672281	1332418	0	0
45785354	1551099	0	0
45688313	1112807	0	0
45795199	914335	0	0
46291783	1545958	0	0
46239686	1000560	0	0
46241831	1548195	0	0
45894164	40236824	2	3
46299210	1125315	0	0
46303814	1125315	0	0
4029205	40478878	5	5
73553	4146173	2	2
21502881	19007333	2	3
4179873	317576	2	2
35508924	1332419	2	3
36157761	1119510	0	0
36151340	19019273	2	3
36502202	4310024	4	6
42802386	1500211	0	0
44363922	1177480	0	0
42804430	1551099	0	0
44351362	40163554	2	3
45647121	1129625	0	0
44340346	1551099	0	0
45660084	19079524	1	1
45665338	1112807	0	0
45644900	933724	0	0
45624149	1549786	0	0
45689684	975125	0	0
45778579	723013	0	0
45651914	1332418	0	0
45674737	1713332	0	0
45672353	1551099	0	0
45785317	1115008	0	0
45684697	1112807	0	0
45795200	933724	0	0
46291306	1153428	0	0
46239548	1115008	0	0
45897899	1115008	0	0
45801567	19019273	2	3
46298815	1125315	0	0
46303618	1125315	0	0
4029205	44805732	5	5
73553	4035415	2	2
21500203	19018935	2	3
21500851	1713671	2	2
36156536	1545959	2	3
36157761	1192710	0	0
36155808	19018935	2	3
36502202	40486433	6	6
42802527	1119510	0	0
44363998	1149380	0	0
42804205	1332418	0	0
44351869	40232448	2	3
45647128	1129625	0	0
44340356	1124300	0	0
45663287	19079524	1	1
45665038	1112807	0	0
45644902	967823	0	0
45624154	967823	0	0
45689871	738818	0	0
45778592	1713332	0	0
45651914	1545958	0	0
45674741	1115008	0	0
45672354	1545958	0	0
45785473	967823	0	0
45685021	1112807	0	0
45795352	1515774	0	0
46288949	1539403	0	0
46239638	791967	0	0
45897902	1738521	0	0
46240275	19078461	2	3
46298847	1125315	0	0
46303754	1125315	0	0
4086181	4043241	7	8
444090	4109685	2	2
21003205	40232448	2	3
21500027	1738521	2	2
35506817	1545959	2	3
36157524	1129625	0	0
36151362	42707627	2	3
36502202	317576	6	6
42802375	1124300	0	0
44363987	1545958	0	0
42804282	1738521	0	0
44343976	19019273	2	3
45647142	1129625	0	0
44340442	1545958	0	0
45663287	46275916	1	1
45665360	1112807	0	0
45644922	738818	0	0
45624143	1332418	0	0
45689685	914335	0	0
45778592	1759842	0	0
45652062	1515774	0	0
45674757	1124957	0	0
45672290	967823	0	0
45785581	1713332	0	0
45684713	1112807	0	0
45795352	1549786	0	0
46288920	1149196	0	0
46239639	1192710	0	0
45897903	1738521	0	0
45790827	1545959	2	3
46299007	1125315	0	0
46303779	1125315	0	0
4029205	4047491	7	8
77635	4113008	2	2
21002332	920300	2	3
4042678	4216130	2	2
36217210	35605482	2	3
36157313	1107830	0	0
36154962	40236446	2	3
36502202	4280726	6	6
42802441	975125	0	0
44363359	1149380	0	0
42804477	1500211	0	0
44343831	40228230	2	3
45647199	1129625	0	0
44340443	1149196	0	0
45641742	19079524	1	1
45662465	1112807	0	0
45644924	1000560	0	0
45624203	933724	0	0
45689692	975125	0	0
45778624	1149196	0	0
45652062	19127890	0	0
45674659	738818	0	0
45672097	975125	0	0
45785581	1759842	0	0
45684787	1112807	0	0
45795352	19127890	0	0
46288931	967823	0	0
46239554	1332418	0	0
45897978	1124957	0	0
46290560	19019273	2	3
46299511	1125315	0	0
46303320	1125315	0	0
4042140	40479768	7	10
433128	40480160	2	2
21002332	920334	2	3
4077953	4035793	2	2
36217216	1713671	2	3
36157511	1309944	0	0
36210656	3000963	2	3
36502202	4134304	7	10
42802529	1738521	0	0
44363360	1521369	0	0
42804421	1125315	0	0
44343895	40232448	2	3
45646987	1129625	0	0
44340581	1332418	0	0
45626544	19079524	1	1
45662892	1112807	0	0
45644931	1115008	0	0
45624523	975125	0	0
45689694	1115008	0	0
45778637	1738521	0	0
45652062	1549786	0	0
45674592	975125	0	0
45672458	1149196	0	0
45785584	975125	0	0
45682053	1112807	0	0
45795416	1332418	0	0
46288932	1124300	0	0
46239515	1713332	0	0
45897961	1107830	0	0
46244225	40163554	2	3
46299240	1125315	0	0
46303697	1125315	0	0
4042140	40479422	7	10
433128	4066995	2	2
21002475	40224132	2	3
4300244	4337138	2	2
36217216	19019273	2	3
36157347	1129625	0	0
36210656	3016723	2	3
36502202	40479768	6	10
42802514	933724	0	0
44363360	1549786	0	0
42804421	1124957	0	0
44343995	1594382	2	3
45645773	1129625	0	0
44340600	1332418	0	0
45659649	19079524	1	1
45662911	1112807	0	0
45644933	1118084	0	0
45624185	1549786	0	0
45689853	1115008	0	0
45778587	1539403	0	0
45652392	1115008	0	0
45674634	1307863	0	0
45672565	1326303	0	0
45785454	1521369	0	0
45682160	1112807	0	0
45795417	1192710	0	0
46288936	1557272	0	0
46239515	1759842	0	0
45897962	1174888	0	0
46243886	40163554	2	3
46299522	1125315	0	0
46303971	1125315	0	0
4042140	133834	7	9
443784	381316	2	2
21002475	40224805	2	3
21600972	1367571	2	2
36217214	19019979	2	3
36157353	1129625	0	0
36210656	3024561	2	3
36502202	40479422	6	10
42802532	1177480	0	0
44363365	1308738	0	0
42804422	1125315	0	0
44344029	19008572	2	3
45645946	1129625	0	0
44337263	1539403	0	0
45626114	19079524	1	1
45662936	1112807	0	0
45645012	738818	0	0
45624185	1515774	0	0
45689864	1549786	0	0
45778618	1343916	0	0
45652264	1149196	0	0
45674874	742185	0	0
45672389	1332418	0	0
45785586	1332418	0	0
45682015	1112807	0	0
45795419	1149196	0	0
46288935	705944	0	0
46239702	1149196	0	0
45897804	705944	0	0
45804361	40163554	2	3
46299251	1125315	0	0
46304015	1125315	0	0
4088727	4125906	1	1
197917	196456	2	2
21004035	19076374	2	3
21500098	1305058	2	2
36217214	19075001	2	3
36157355	1154029	0	0
36154987	1154615	2	3
36502202	78272	5	10
42802605	1589505	0	0
44363421	967823	0	0
42804422	1124957	0	0
44344074	46275916	2	3
45643877	1129625	0	0
44337290	1778162	0	0
45621446	19079524	1	1
45664352	1112807	0	0
45645022	1551099	0	0
45624191	1124957	0	0
45689864	19127890	0	0
45778595	1107830	0	0
45652307	1124300	0	0
45674648	1551099	0	0
45672402	1717327	0	0
45785482	1149196	0	0
45705081	1177480	0	0
45795500	1738521	0	0
46289108	1124300	0	0
46239324	1149196	0	0
45897805	1000560	0	0
46244386	1332419	2	3
46301569	1125315	0	0
46304024	1125315	0	0
4098879	4198190	1	1
78831	4059173	2	2
21001751	19073188	2	3
4042646	4145310	2	2
36217214	1107882	2	3
36157361	1119510	0	0
36155154	40232448	2	3
36502202	4296204	4	7
42802605	1549786	0	0
44364013	1539403	0	0
42804471	920293	0	0
44344240	40162522	2	3
45644004	1129625	0	0
44337399	1115008	0	0
45650401	19079524	1	1
45664561	1112807	0	0
45644936	1124957	0	0
45624142	1332418	0	0
45686619	975125	0	0
45778604	1149196	0	0
45652315	1115008	0	0
45674955	1192710	0	0
45672403	1322184	0	0
45785399	740275	0	0
45705294	1177480	0	0
45795242	1112807	0	0
46289280	1192710	0	0
46239325	1124957	0	0
45897993	1539403	0	0
46244129	40163554	2	3
46301578	1125315	0	0
46303914	1125315	0	0
4178452	4144583	1	1
75053	4142905	2	2
21002374	46233988	2	3
4042646	4238715	2	2
36217214	46233710	2	3
36157361	1129625	0	0
36154677	1127433	2	3
36502202	4155034	7	7
42902702	40169216	0	0
44364017	1332418	0	0
42804400	914335	0	0
44344172	19019273	2	3
45644217	1129625	0	0
44337339	1000560	0	0
45635418	19079524	1	1
45659803	1112807	0	0
45644869	1149196	0	0
45624156	1322184	0	0
45686785	1589505	0	0
45778605	920293	0	0
45651797	1343916	0	0
45675053	1589505	0	0
45672463	975125	0	0
45785403	1112807	0	0
45779987	1177480	0	0
45795431	1521369	0	0
46289008	1738521	0	0
46239326	1174888	0	0
45897883	1308738	0	0
45792063	46233710	2	3
46301646	1125315	0	0
46303918	1125315	0	0
4149795	4059978	1	1
75865	4116491	2	2
21002374	46233710	2	3
21601079	1595799	2	2
36217214	19019273	2	3
36157363	1174888	0	0
36155061	1115171	2	3
36502202	4048171	7	7
42804136	1118084	0	0
44363533	1124957	0	0
42804242	1326303	0	0
44344687	19008572	2	3
45644236	1129625	0	0
44337410	1124957	0	0
45635418	46275916	1	1
45657177	1112807	0	0
45644806	1149196	0	0
45624226	1308738	0	0
45686785	1549786	0	0
45778606	1124957	0	0
45651860	705944	0	0
45675055	1124957	0	0
45672466	1361711	0	0
45785589	1149196	0	0
45780104	1177480	0	0
45795433	1112807	0	0
46289316	1149196	0	0
46239579	1512674	0	0
45897887	967823	0	0
46242317	1332419	2	3
46301851	1125315	0	0
46300925	1125315	0	0
4151199	4237458	1	1
75128	4142905	2	2
21003421	46233710	2	3
21601079	1396131	2	2
36217214	1713671	2	3
36157364	1119510	0	0
36155215	19008572	2	3
36502202	4113008	7	7
42804188	1713332	0	0
44363991	1107830	0	0
42804245	1322184	0	0
44344425	19008572	2	3
45641127	1129625	0	0
44337411	1107830	0	0
45662917	19079524	1	1
45656730	1112807	0	0
45645027	1192710	0	0
45624198	1549786	0	0
45686546	1115008	0	0
45778612	1110410	0	0
45697737	1115008	0	0
45675056	740275	0	0
45672567	914335	0	0
45785412	782043	0	0
45780020	1177480	0	0
45795435	1174888	0	0
46289317	1124957	0	0
46239579	1549786	0	0
45897946	1713332	0	0
45796549	40163554	2	3
46301813	1125315	0	0
46300875	1125315	0	0
4151202	4142905	1	1
443583	81151	2	2
21003421	46233988	2	3
4034850	4012477	2	2
21602818	19073188	2	5
36157554	1149196	0	0
36155230	19018935	2	3
36502202	4230399	8	9
42804111	708298	0	0
44363994	1124300	0	0
42804303	1396131	0	0
44337523	40236824	2	3
45641165	1129625	0	0
44337319	1000560	0	0
45632171	19079524	1	1
45653407	1112807	0	0
45645097	920293	0	0
45624198	1521369	0	0
45686552	791967	0	0
45778613	738818	0	0
45697861	1332418	0	0
45675037	1539403	0	0
45672568	967823	0	0
45785370	1107830	0	0
45780054	1177480	0	0
45795441	1310149	0	0
46288974	1000560	0	0
46239580	1192710	0	0
45895744	1738521	0	0
45801453	1713671	2	3
46295832	1125315	0	0
46300876	1125315	0	0
4149519	4012477	1	1
193666	4230399	2	2
21001753	19074841	2	3
21500909	1343916	2	2
21602818	19133905	2	5
36157387	1000560	0	0
36155275	19008572	2	3
36502202	81151	5	9
42804168	1713332	0	0
44363511	1713332	0	0
42804356	1124300	0	0
44337556	1594382	2	3
45641299	1129625	0	0
44337348	1118084	0	0
45665408	19079524	1	1
45653826	1112807	0	0
45645099	1539403	0	0
45624165	1192710	0	0
45686555	1551099	0	0
45778719	1000560	0	0
45697862	1154343	0	0
45675001	1539403	0	0
45672569	975125	0	0
45785452	753626	0	0
45780113	1177480	0	0
45795285	1149196	0	0
46288940	1501700	0	0
46239674	1000560	0	0
45895786	1115008	0	0
45793188	19078461	2	3
46296075	1125315	0	0
46300885	1125315	0	0
4149530	4010253	1	1
195771	4144583	2	2
21001753	19074843	2	3
21500909	1738521	2	2
21602818	19133873	2	5
36157426	1115008	0	0
36156317	1551192	2	3
36502202	4149245	5	9
42804168	1759842	0	0
44363623	1307863	0	0
42804357	1124300	0	0
44337651	40236446	2	3
45641237	1129625	0	0
44337353	1115008	0	0
45665366	19079524	1	1
45653710	1112807	0	0
45645092	1115008	0	0
45637384	1125315	0	0
45686556	1746114	0	0
45778639	19002770	0	0
45700778	1738521	0	0
45674976	1174888	0	0
45672580	1545958	0	0
45785465	1305058	0	0
45706102	1177480	0	0
45795287	1115008	0	0
46288946	1322184	0	0
46239444	975125	0	0
45895790	1153428	0	0
45798757	19019273	2	3
46296104	1125315	0	0
46301811	1125315	0	0
4152129	4197460	1	1
195856	198809	2	2
21001769	46233988	2	3
4042673	4216130	2	2
21602818	19073183	2	5
36157430	1153428	0	0
36156552	19123231	2	3
36502202	4152936	7	9
42804154	1322184	0	0
44363624	738818	0	0
42804415	1729720	0	0
44337594	19008572	2	3
45641247	1129625	0	0
44337401	1310149	0	0
45647249	19079524	1	1
45650266	1112807	0	0
45645087	1332418	0	0
45637337	1125315	0	0
45686556	1741122	0	0
45778642	1174888	0	0
45700720	1000560	0	0
45674879	738818	0	0
45672469	1115008	0	0
45785573	1118084	0	0
45706173	1177480	0	0
45795292	1713332	0	0
46288976	1332418	0	0
46239447	1149380	0	0
45895747	1149380	0	0
45801461	40174880	2	3
46295741	1125315	0	0
46301663	1125315	0	0
4152932	4155034	1	1
4022173	4108705	2	2
21001769	46233710	2	3
21500094	742185	2	2
21602515	40221415	2	5
36157437	1129625	0	0
36223493	40221415	2	3
36502202	4059173	7	8
42804118	1177480	0	0
44363625	1738521	0	0
42804416	920293	0	0
44337586	1127433	2	3
45642972	1129625	0	0
44337354	1738521	0	0
45667570	19079524	1	1
45650389	1112807	0	0
45644888	1539403	0	0
45621844	1125315	0	0
45686602	1549786	0	0
45778764	1539403	0	0
45700722	791967	0	0
45674882	1124300	0	0
45672571	791967	0	0
45785677	967823	0	0
45706184	1177480	0	0
45795293	1115008	0	0
46288983	933724	0	0
46239755	1192710	0	0
45895757	19003953	0	0
46294669	46233710	2	3
46295934	1125315	0	0
46301628	1125315	0	0
4152932	4113008	1	1
1177480	19019979	2	3
21506167	19019273	2	3
4046698	4336464	2	2
21603445	19112599	2	5
36157412	1129625	0	0
36223494	40221415	2	3
36502202	4237458	6	8
42804122	1305058	0	0
44363789	1174888	0	0
42804325	1177480	0	0
44337569	19008572	2	3
45642973	1129625	0	0
44337413	723013	0	0
45623540	19079524	1	1
45650120	1112807	0	0
45645089	1713332	0	0
45621793	1125315	0	0
45686869	914335	0	0
45778673	1153428	0	0
45700723	1174888	0	0
45674884	1107830	0	0
45672363	1332418	0	0
45785425	1713332	0	0
45706463	1177480	0	0
45795300	1000560	0	0
46289101	1738521	0	0
46239757	1192710	0	0
45895849	1759842	0	0
46298522	19078461	2	3
46295984	1125315	0	0
46302071	1125315	0	0
4152960	4152936	1	1
1177480	19078461	2	3
21003404	1551192	2	3
21501012	1192710	2	2
35702113	4266809	3	8
36157529	1119510	0	0
36151026	1127433	2	3
36502202	40480160	6	8
42804227	1332418	0	0
44363582	975125	0	0
42804472	1177480	0	0
44337726	40232448	2	3
45638153	1129625	0	0
44337328	1539403	0	0
45623540	46275916	1	1
45650451	1112807	0	0
45645089	1759842	0	0
45621984	1125315	0	0
45686872	1738521	0	0
45778674	1778162	0	0
45700726	1738521	0	0
45675071	1149196	0	0
45672470	1149380	0	0
45785382	1174888	0	0
45706578	1177480	0	0
45795284	1309944	0	0
46289285	1332418	0	0
46239659	1500211	0	0
45896002	967823	0	0
45801848	19078461	2	3
46296028	1125315	0	0
46301279	1125315	0	0
4152960	4109685	1	1
1154343	1154615	2	3
21500206	19126352	2	3
4078460	4202451	2	2
35702113	30753	3	8
36157534	914335	0	0
36150872	1115171	2	3
36502202	4278672	6	8
42804137	1332418	0	0
44363583	1149196	0	0
42804450	1310149	0	0
45622216	40163554	2	3
45638045	1129625	0	0
44337330	701322	0	0
45650243	19079524	1	1
45650368	1112807	0	0
45645044	1192710	0	0
45620584	1125315	0	0
45686457	1717327	0	0
45778678	738818	0	0
45700730	1551099	0	0
45675074	1728416	0	0
45672219	791967	0	0
45785388	1154343	0	0
45706494	1177480	0	0
45795518	19010482	0	0
46289135	742185	0	0
46239725	1124300	0	0
45895794	975125	0	0
46295357	46275916	1	1
46296037	1125315	0	0
46301259	1125315	0	0
4132082	375671	1	1
1713332	19073188	2	3
21001746	1713671	2	3
21600962	1310149	2	2
21602796	920300	3	6
36157536	738818	0	0
36151307	1127433	2	3
36502202	4142905	6	8
42804096	1115008	0	0
44363551	975125	0	0
42804461	1713332	0	0
45622184	1545959	2	3
45638174	1129625	0	0
45620321	975125	0	0
45632212	19079524	1	1
45650630	1112807	0	0
45645106	738818	0	0
45620590	1125315	0	0
45686604	1548195	0	0
45778925	738818	0	0
45700735	1149196	0	0
45674666	1174888	0	0
45672585	1107830	0	0
45785392	1310149	0	0
45699715	1177480	0	0
45795541	1557272	0	0
46243596	19010482	0	0
46239758	1539403	0	0
45895825	1107830	0	0
46295531	19079524	1	1
46296051	1125315	0	0
46301336	1125315	0	0
4132546	4001336	1	1
1174888	40162522	2	3
21002434	46275444	2	3
4042642	4181917	2	2
21602796	19133905	3	6
36157536	1119510	0	0
36151320	46275444	2	3
36502202	4048695	5	8
42804190	1738521	0	0
44363553	1551099	0	0
42804461	1759842	0	0
44358682	40232448	2	3
45638165	1129625	0	0
45620324	1174888	0	0
45647145	19079524	1	1
45648872	1112807	0	0
45645172	914335	0	0
45620565	1125315	0	0
45686879	1322184	0	0
45778929	914335	0	0
45700659	1305058	0	0
45674668	1174888	0	0
45672485	1174888	0	0
45782957	1307863	0	0
45699721	1177480	0	0
45795542	975125	0	0
46243715	1332418	0	0
46239747	1110410	0	0
45895813	740275	0	0
46297566	19079524	1	1
46295996	1125315	0	0
46301192	1125315	0	0
4056125	4314290	1	1
1174888	19133768	2	3
21506158	19079524	2	3
21600961	1310149	2	2
21602796	920334	3	6
36157538	1112807	0	0
36151326	40229134	2	3
36502202	4066995	5	8
42804158	1115008	0	0
44363557	742185	0	0
42804469	1118084	0	0
45658451	1551192	2	3
45638382	1129625	0	0
45620190	1308738	0	0
45667591	19079524	1	1
45644274	1112807	0	0
45645287	920293	0	0
45620643	1125315	0	0
45686634	1118084	0	0
45778647	1000560	0	0
45648719	791967	0	0
45674769	1110410	0	0
45672488	1192710	0	0
45783342	723013	0	0
45699773	1177480	0	0
45795305	967823	0	0
46243553	1154029	0	0
46239731	1738521	0	0
45895826	1107830	0	0
46234524	46233710	1	1
46295963	1125315	0	0
46301200	1125315	0	0
4059308	4242997	1	1
1192710	19112599	2	3
21013496	1551192	2	3
21600961	1112807	2	2
21602796	19073183	3	6
36157581	1177480	0	0
36151215	40232448	2	3
36502202	133834	8	8
42804206	1545958	0	0
44363495	738818	0	0
42804424	1551099	0	0
45658680	40174880	2	3
45638383	1129625	0	0
45620271	1322184	0	0
45635204	19079524	1	1
45644372	1112807	0	0
45645211	1768849	0	0
45620785	1125315	0	0
45686650	1154343	0	0
45778723	967823	0	0
45648666	1154343	0	0
45675084	738818	0	0
45672588	1713332	0	0
45783411	1501700	0	0
45699731	1177480	0	0
45795617	1717327	0	0
46243718	1500211	0	0
46239732	1713332	0	0
45895857	914335	0	0
46234352	920334	1	1
46296238	1125315	0	0
46301319	1125315	0	0
4059978	44805732	1	1
1545958	1545959	2	3
21001745	19073183	2	3
21600961	1322184	2	2
21602796	1717327	3	3
36157472	1115008	0	0
36151242	40229134	2	3
36302170	4084167	5	8
42804141	1322184	0	0
44363836	920293	0	0
42804457	19002770	0	0
45658699	40229134	2	3
45637132	1129625	0	0
45620273	723013	0	0
45632317	19079524	1	1
45644297	1112807	0	0
45645059	708298	0	0
45620654	1125315	0	0
45686845	967823	0	0
45778724	1192710	0	0
45648725	1551099	0	0
45675086	1343916	0	0
45672378	1124300	0	0
45783321	1153428	0	0
45699749	1177480	0	0
45795620	1501700	0	0
46243624	1332418	0	0
46239736	1192710	0	0
45895838	1305058	0	0
46234411	46233988	1	1
46295328	1125315	0	0
46301325	1125315	0	0
4061650	4197460	1	1
1766397	1545959	2	3
21001745	19073188	2	3
21600961	1367571	2	2
21602796	1738521	3	3
36157541	1501700	0	0
36151106	19008572	2	3
36302170	4243062	5	7
42804194	1759842	0	0
44363964	1332418	0	0
42804480	1000560	0	0
45658709	19075601	2	3
45634945	1129625	0	0
45620379	1717327	0	0
45653412	46275916	1	1
45644469	1112807	0	0
45645176	1124300	0	0
45620658	1125315	0	0
45686847	933724	0	0
45778896	1332418	0	0
45648727	1501700	0	0
45675060	1307863	0	0
45672496	1343916	0	0
45783350	914335	0	0
45693717	1177480	0	0
45795638	1729720	0	0
46243625	1174888	0	0
45896022	967823	0	0
45895849	1713332	0	0
46296490	19079524	1	1
46295973	1125315	0	0
46301409	1125315	0	0
4063381	257012	1	1
1580772	1332419	2	3
21001739	19075001	2	3
4174389	4242997	2	2
21602796	1713332	3	3
36157685	1545958	0	0
36151155	1127433	2	3
36302170	134438	5	10
42804194	1713332	0	0
44363608	1192710	0	0
42804482	1177480	0	0
45658747	40232448	2	3
45634856	1129625	0	0
45620384	1192710	0	0
45656666	19079524	1	1
45641431	1112807	0	0
45645317	1501700	0	0
45620701	1125315	0	0
45686853	1551099	0	0
45778651	1174888	0	0
45648728	1115008	0	0
45675062	1102527	0	0
45672498	1713332	0	0
45783420	1112807	0	0
45693599	1177480	0	0
45795380	1307863	0	0
46243630	975125	0	0
45896023	1713332	0	0
45895839	975125	0	0
46316915	42902245	2	2
46296246	1125315	0	0
46301441	1125315	0	0
4042673	4163951	1	1
1768849	19074843	2	3
21001757	19074843	2	3
21500988	1343916	2	2
21602796	1746114	3	3
36157598	1549786	0	0
36211232	4142905	2	3
36302170	439777	5	10
42804196	1717327	0	0
44363608	1112807	0	0
42804283	1124300	0	0
45658796	40229134	2	3
44362714	1177480	0	0
45620170	738818	0	0
45667730	46275916	1	1
45641435	1112807	0	0
45645320	1153428	0	0
45620724	1125315	0	0
45686921	1738521	0	0
45778886	1539403	0	0
45648534	967823	0	0
45675026	1149196	0	0
45672592	1310149	0	0
45783448	1174888	0	0
45690724	1177480	0	0
45795382	1107830	0	0
46243511	1154029	0	0
45896089	1107830	0	0
45895830	1343916	0	0
45794269	40228214	2	3
46296152	1125315	0	0
46301329	1125315	0	0
4044368	4058899	1	1
1768849	19074841	2	3
21001757	19133905	2	3
136779	4278672	2	2
21602796	1768849	3	3
36157610	1332418	0	0
36155823	1545959	2	3
36302170	196456	5	11
42804237	1713332	0	0
44363910	1177480	0	0
42804288	1545958	0	0
45658798	1115171	2	3
44362717	1177480	0	0
45620173	1332418	0	0
45629534	46275916	1	1
45641458	1112807	0	0
45645222	1110410	0	0
45620723	1125315	0	0
45686864	920293	0	0
45778889	1115008	0	0
45648492	1501700	0	0
45674725	1115008	0	0
45672596	975125	0	0
45783450	1310149	0	0
45690696	1177480	0	0
45792547	1115008	0	0
46243562	1741122	0	0
45895937	1153428	0	0
45895910	1192710	0	0
46242059	40228214	2	3
46295581	1125315	0	0
46319235	1125315	0	0
4044900	4170947	1	1
1759842	1713671	2	3
21001757	19073188	2	3
21601625	1361711	2	2
21602796	1778162	3	3
36157473	1308738	0	0
36155724	40229134	2	3
36302170	4195803	4	4
42804237	1759842	0	0
44363914	975125	0	0
42804531	1177480	0	0
45658808	19059056	2	3
44361965	1177480	0	0
45620187	1174888	0	0
45629534	19079524	1	1
45641648	1112807	0	0
45645202	738818	0	0
45620746	1125315	0	0
45686718	967823	0	0
45778966	1174888	0	0
45648593	1174888	0	0
45675038	1149196	0	0
45672605	1738521	0	0
45783463	1115008	0	0
45690780	1177480	0	0
45792683	1115008	0	0
46243562	1746114	0	0
45895990	933724	0	0
45895929	1192710	0	0
45789345	19075601	2	3
46295682	1125315	0	0
46319449	1125315	0	0
4028919	4234705	1	1
1539403	1539411	2	3
21001757	19133873	2	3
21500879	975125	2	2
21602796	920293	3	3
36157475	1119510	0	0
36157928	1125315	0	0
36302170	4012477	4	7
42804295	1115008	0	0
44363770	701322	0	0
42804512	1501700	0	0
45659004	1127433	2	3
44362009	1177480	0	0
45620294	1192710	0	0
45649507	19079524	1	1
45641542	1112807	0	0
45645203	1589505	0	0
45620752	1125315	0	0
45686939	967823	0	0
45778966	1192710	0	0
45648595	967823	0	0
45674779	1396131	0	0
45672615	1107830	0	0
45783163	1307863	0	0
45690810	1177480	0	0
45792655	1343916	0	0
46243736	1115008	0	0
45896062	1713332	0	0
45895954	1332418	0	0
45793924	40228214	2	3
46295685	1125315	0	0
46319699	1125315	0	0
4028919	4230209	1	1
1557272	40173590	2	3
21001757	19073183	2	3
21500879	1738521	2	2
35502617	140673	3	3
36157475	738818	0	0
36158305	1125315	0	0
36302170	4144583	10	10
42804297	1332418	0	0
44363966	1124957	0	0
42804529	1000560	0	0
45658482	40174880	2	3
44362023	1177480	0	0
45620260	1110410	0	0
45659834	19079524	1	1
45641792	1112807	0	0
45645326	740275	0	0
45620710	1125315	0	0
45686940	1500211	0	0
45778834	1115008	0	0
45648603	1307863	0	0
45674780	1549786	0	0
45672227	715997	0	0
45783514	975125	0	0
45687426	1177480	0	0
45792593	1501700	0	0
46243739	933724	0	0
45896063	1521369	0	0
45895956	1778162	0	0
46241557	19078461	2	3
46295591	1125315	0	0
46319701	1125315	0	0
4183452	372328	1	1
1766561	1107882	2	3
21003656	46233988	2	3
21500925	975125	2	2
21603248	1154343	3	3
36157515	1119510	0	0
36158308	1125315	0	0
36302170	80180	6	8
42804340	1545958	0	0
44364016	1177480	0	0
42804491	1309944	0	0
45658853	19008572	2	3
45656208	1177480	0	0
45620429	1149196	0	0
45650146	19079524	1	1
45638297	1112807	0	0
45645378	1174888	0	0
45661584	1125315	0	0
45687000	1501700	0	0
45778690	1549786	0	0
45648735	1115008	0	0
45674780	19127890	0	0
45784027	1738521	0	0
45783369	1738521	0	0
45688581	1177480	0	0
45792719	1192710	0	0
46243610	1149196	0	0
45896064	1000560	0	0
45896019	1000560	0	0
45793690	40228214	2	3
46296402	1125315	0	0
46319453	1125315	0	0
4133611	381316	1	1
1580765	1107882	2	3
21003174	40229134	2	3
21500925	1361711	2	2
21603248	1137529	3	3
36157517	1119510	0	0
36158206	1125315	0	0
36302170	317576	6	12
42804299	1713332	0	0
44363982	975125	0	0
42804493	914335	0	0
45658739	1551192	2	3
45656274	1177480	0	0
45620437	967823	0	0
45638260	19079524	1	1
45638391	1112807	0	0
45645307	1174888	0	0
45661734	1125315	0	0
45686967	1115008	0	0
45778658	1713332	0	0
45648742	1738521	0	0
45674783	1154343	0	0
45784343	1000560	0	0
45783370	1738521	0	0
45684625	1177480	0	0
45792721	1174888	0	0
46243611	1112807	0	0
45896076	715997	0	0
45896108	1107830	0	0
45799002	40228214	2	3
46296413	1125315	0	0
46319461	1125315	0	0
4115576	196456	1	1
1766414	1107882	2	3
21003174	1107882	2	3
21500999	967823	2	2
21603248	1149380	3	3
36157520	1177480	0	0
36158207	1125315	0	0
36302170	4156265	8	11
42804270	1717327	0	0
44356737	1521369	0	0
42804495	1129625	0	0
45658923	19126352	2	3
45652440	1177480	0	0
45620442	1174888	0	0
45623557	46275916	1	1
45638402	1112807	0	0
45642135	1501700	0	0
45661519	1125315	0	0
45687002	738818	0	0
45778877	1361711	0	0
45648776	1768849	0	0
45674899	1589505	0	0
45784344	1589505	0	0
45783362	723013	0	0
45684735	1177480	0	0
45792495	1149196	0	0
46243614	1322184	0	0
45896107	975125	0	0
45896057	1309944	0	0
46298341	40228214	2	3
46296417	1125315	0	0
46319652	1125315	0	0
4091589	4012477	1	1
791967	19057271	2	3
21003174	1150837	2	3
21600033	975125	2	2
21603932	1115008	3	3
36157687	1115008	0	0
36157936	1125315	0	0
36302170	81151	8	13
42804254	1545958	0	0
44356737	1549786	0	0
42804496	1343916	0	0
45658893	19075601	2	3
45652524	1177480	0	0
45620553	1115008	0	0
45632147	46275916	1	1
45638486	1112807	0	0
45642139	1124957	0	0
45661744	1125315	0	0
45687005	1115008	0	0
45778692	1343916	0	0
45648579	1110410	0	0
45674900	1549786	0	0
45784351	1154343	0	0
45783058	1551099	0	0
45684591	1177480	0	0
45792584	1115008	0	0
46243616	975125	0	0
45896192	1551099	0	0
45895979	1367571	0	0
45788675	19079524	2	3
46295592	1125315	0	0
46319770	1125315	0	0
4029205	4170947	1	1
77960	4035415	2	3
21003174	19125062	2	3
21600003	975125	2	2
21603932	1118084	3	3
36157689	1149196	0	0
36158342	1125315	0	0
36302170	4142905	8	12
42804274	1713332	0	0
44356531	1713332	0	0
42804498	1361711	0	0
45658499	1127433	2	3
45652638	1177480	0	0
45620265	1110410	0	0
45634139	19079524	1	1
45638465	1112807	0	0
45642150	1551099	0	0
45661961	1125315	0	0
45687015	738818	0	0
45707538	1115008	0	0
45648684	1713332	0	0
45674900	1521369	0	0
45784353	738818	0	0
45783063	975125	0	0
45684594	1177480	0	0
45792614	1112807	0	0
46243522	1112807	0	0
45895887	1729720	0	0
45895984	1192710	0	0
45798931	19079524	2	3
46295602	1125315	0	0
46319771	1125315	0	0
4090616	78272	1	1
444089	4310024	2	3
21003174	43012036	2	3
21601119	1308738	2	2
21604181	19039298	3	3
36157628	1149380	0	0
36158371	1125315	0	0
36302170	4169137	8	9
42804280	1713332	0	0
44356531	1759842	0	0
42804501	914335	0	0
45658864	40232448	2	3
45652713	1177480	0	0
45620402	1124300	0	0
45628919	46275916	1	1
45638547	1112807	0	0
45643026	1174888	0	0
45661861	1125315	0	0
45686931	742185	0	0
45707178	1515774	0	0
45648746	1124300	0	0
45674900	1595799	0	0
45784256	1174888	0	0
45783518	1501700	0	0
45684810	1177480	0	0
45792667	1112807	0	0
46243525	933724	0	0
45895994	1115008	0	0
45895957	1149196	0	0
46241681	19078461	2	3
46291186	1125315	0	0
46322554	1125315	0	0
4132804	4323902	1	1
920293	920300	2	3
21003174	19112599	2	3
21604564	791967	2	2
21602002	1129625	3	3
36157630	1107830	0	0
36158338	1125315	0	0
36302170	438614	8	9
42804280	1759842	0	0
44356505	738818	0	0
42804250	1118084	0	0
45659013	43012036	2	3
45652802	1177480	0	0
45620403	1107830	0	0
45629144	46275916	1	1
45638627	1112807	0	0
45643040	723013	0	0
45661873	1125315	0	0
45686807	1308738	0	0
45707178	19127890	0	0
45648701	920293	0	0
45674912	1115008	0	0
45784260	1768849	0	0
45783522	1551099	0	0
45684762	1177480	0	0
45792595	1112807	0	0
46243645	1118084	0	0
45896058	975125	0	0
45803982	1153428	0	0
45795784	40228214	2	3
46291142	1125315	0	0
46322564	1125315	0	0
4168004	4168004	0	0
1766598	19073183	2	3
21001738	40229134	2	3
21604564	723013	2	2
21602515	19128009	3	3
36157635	1119510	0	0
36158436	1125315	0	0
36302170	4304110	8	9
42804222	1322184	0	0
44356540	1174888	0	0
42804251	1396131	0	0
44352123	19077344	2	3
45649708	1177480	0	0
45620545	1589505	0	0
45628096	19079524	1	1
45635399	1112807	0	0
45643041	1548195	0	0
45661877	1125315	0	0
45685658	1713332	0	0
45707178	1549786	0	0
45648750	1115008	0	0
45674914	1174888	0	0
45784262	738818	0	0
45783529	1551099	0	0
45684844	1177480	0	0
45792609	1124957	0	0
46243647	975125	0	0
45896148	1154343	0	0
45803985	1174888	0	0
46297972	19078461	2	3
46291149	1125315	0	0
46322567	1125315	0	0
4151422	4151422	0	0
77630	4146173	2	3
21001743	19073188	2	3
21601606	1361711	2	2
21603551	975125	3	3
36157635	1192710	0	0
36158375	1125315	0	0
36302170	4299128	8	8
42804150	920293	0	0
44356740	738818	0	0
42804252	1177480	0	0
44351940	40231925	2	3
45649845	1177480	0	0
45620545	1549786	0	0
45621561	19079524	1	1
45635314	1112807	0	0
45643042	1307863	0	0
45661521	1125315	0	0
45683553	1174888	0	0
45707369	757627	0	0
45648794	1115008	0	0
45675145	1548195	0	0
45784316	1000560	0	0
45783262	1332418	0	0
45684818	1177480	0	0
45792623	1521369	0	0
46243651	1153428	0	0
45896129	1118084	0	0
45804114	1549786	0	0
45788881	19078461	2	3
46291276	1125315	0	0
46322571	1125315	0	0
4152936	4152936	0	0
1519936	1519937	2	3
21001743	19129655	2	3
21604792	757627	2	2
21603551	1124300	3	3
36157715	1549786	0	0
36157824	1125315	0	0
36302170	140673	7	9
42804316	1124300	0	0
44356544	1545958	0	0
42804313	1115008	0	0
44352072	19078461	2	3
45649974	1177480	0	0
45620133	1778162	0	0
45663020	46275916	1	1
45635413	1112807	0	0
45643043	1174888	0	0
45661524	1125315	0	0
45683557	1149196	0	0
45707120	1102527	0	0
45648853	1174888	0	0
45671682	1729720	0	0
45784280	738818	0	0
46291160	1501700	0	0
45681386	1177480	0	0
45792623	1503184	0	0
46243724	1500211	0	0
45896133	1174888	0	0
45804114	1515774	0	0
45893803	19078461	2	3
46290893	1125315	0	0
46319913	1125315	0	0
4132546	4132546	0	0
1519936	43012433	2	3
21001743	1713671	2	3
4176944	40481087	2	2
21603551	914335	3	3
36157718	1500211	0	0
36158346	1125315	0	0
36302170	4051466	7	8
42804152	1177480	0	0
44356579	1768849	0	0
42804338	1545958	0	0
45652119	40232448	2	3
45646328	1177480	0	0
45620268	1738521	0	0
45656910	19079524	1	1
45635653	1112807	0	0
45643021	738818	0	0
45661878	1125315	0	0
45683559	1548195	0	0
45707517	1512674	0	0
45648948	1000560	0	0
45671686	975125	0	0
45784361	1115008	0	0
46291165	1149196	0	0
45681591	1177480	0	0
45792623	19127890	0	0
46243502	1549786	0	0
45896041	1310149	0	0
45804116	1343916	0	0
46297764	19078461	2	3
46290922	1125315	0	0
46320058	1125315	0	0
4144583	4144583	0	0
1153428	40223834	2	3
21001743	19073183	2	3
4122944	4252419	2	2
21603551	1343916	3	3
36157722	1119510	0	0
36158348	1125315	0	0
36302170	4109685	7	11
42804397	791967	0	0
44356668	1332418	0	0
42804442	1125315	0	0
45652120	40232448	2	3
45648942	1177480	0	0
45620362	1192710	0	0
45656679	46275916	1	1
45632296	1112807	0	0
45643116	1549786	0	0
45661881	1125315	0	0
45683568	708298	0	0
45707517	19127890	0	0
45648836	914335	0	0
45671729	1000560	0	0
45784250	1595799	0	0
46291170	1551099	0	0
45682625	1177480	0	0
45792623	1549786	0	0
46243502	19127890	0	0
45896044	1713332	0	0
45804242	1115008	0	0
45787767	19078461	2	3
46291152	1125315	0	0
46319953	1125315	0	0
4059173	4059173	0	0
192438	4285898	2	3
21001770	1150771	2	3
4122944	4024289	2	2
21603551	967823	3	3
36157735	1115008	0	0
36158445	1125315	0	0
36302170	30753	7	11
42804333	1332418	0	0
44356612	975125	0	0
42804339	1545958	0	0
45652026	40223768	2	3
45648795	1177480	0	0
45620556	1107830	0	0
45657031	19079524	1	1
45632288	1112807	0	0
45643116	1521369	0	0
45661535	1125315	0	0
45683561	1107830	0	0
45707517	1549786	0	0
45648782	1110410	0	0
45671731	753626	0	0
45784250	1521369	0	0
46291172	1115008	0	0
45681824	1177480	0	0
45792590	1174888	0	0
46243502	1515774	0	0
45896153	1124957	0	0
45804102	920293	0	0
45793933	19078461	2	3
46244757	1125315	0	0
46320014	1125315	0	0
4059978	4059978	0	0
1766450	1127433	2	3
21001770	19125062	2	3
4185916	4243062	2	2
35622751	4218408	1	1
36157741	1112807	0	0
36158447	1125315	0	0
36302170	4283893	7	11
42804223	1545958	0	0
44356624	738818	0	0
42804533	1326303	0	0
45652330	1115171	2	3
45646449	1177480	0	0
45620542	1107830	0	0
45646902	46275916	1	1
45632516	1112807	0	0
45643116	1595799	0	0
45662011	1125315	0	0
45683675	1551099	0	0
45707522	1149196	0	0
45648847	1000560	0	0
45671706	920293	0	0
45784250	1549786	0	0
46291177	1192710	0	0
45678490	1177480	0	0
45794547	1322184	0	0
46243623	708298	0	0
45896091	1115008	0	0
45804122	1192710	0	0
46289803	19078461	2	3
46244695	1125315	0	0
46320029	1125315	0	0
4062501	4062501	0	0
1766494	19126352	2	3
21001770	40228230	2	3
257007	4048171	2	2
36157208	19127904	1	2
36157901	1129625	0	0
36158457	1125315	0	0
36302170	380378	7	10
42804267	1310149	0	0
44356628	1177480	0	0
42804508	1343916	0	0
45652164	40232448	2	3
45646640	1177480	0	0
45620545	19127890	0	0
45647074	46275916	1	1
45632518	1112807	0	0
45642266	1310149	0	0
45661842	1125315	0	0
45683704	19127890	0	0
45707523	1501700	0	0
45648848	1115008	0	0
45671715	740275	0	0
45784151	1000560	0	0
46291826	933724	0	0
45672298	1177480	0	0
45794548	1112807	0	0
46243579	1107830	0	0
45896645	740275	0	0
45804136	1000560	0	0
46289987	19079524	2	3
46244971	1125315	0	0
46320039	1125315	0	0
4058899	4058899	0	0
1766609	920334	2	3
21001770	1107882	2	3
192353	198809	2	2
36157133	19128263	1	2
36157645	975125	0	0
36158495	1125315	0	0
36302170	4113008	7	10
42804352	1118084	0	0
44356604	1549786	0	0
42804510	1307863	0	0
45652359	1551192	2	3
45646685	1177480	0	0
45620492	1107830	0	0
45647430	19079524	1	1
45629292	1112807	0	0
45642194	1115008	0	0
45661895	1125315	0	0
45683704	1512674	0	0
45707524	738818	0	0
45648970	920293	0	0
45671732	1551099	0	0
45784369	975125	0	0
46291831	1192710	0	0
45784517	1177480	0	0
45794558	791967	0	0
46243769	1332418	0	0
45896743	1124300	0	0
45804245	1153428	0	0
45793681	40228214	2	3
46244634	1125315	0	0
46319997	1125315	0	0
4066995	4066995	0	0
1766595	19008572	2	3
21001770	43012036	2	3
4042660	44783196	2	2
36212271	19074679	1	2
36157646	1177480	0	0
36158496	1125315	0	0
36302170	378419	7	12
42902746	40169281	0	0
44356604	1521369	0	0
42804428	1551099	0	0
45652176	40169281	2	3
45646785	1177480	0	0
45620447	1713332	0	0
45644257	19079524	1	1
45629525	1112807	0	0
45642247	1153428	0	0
45661847	1125315	0	0
45683704	1549786	0	0
45707180	1322184	0	0
45648979	1115008	0	0
45671840	1713332	0	0
45784264	1367571	0	0
46291860	1192710	0	0
45784642	1177480	0	0
45794568	1124957	0	0
46243771	1310149	0	0
45896721	1107830	0	0
45804070	1115008	0	0
46241941	19078461	2	3
46244637	1125315	0	0
46320202	1125315	0	0
4047491	4047491	0	0
4022201	4146173	2	3
21001770	19112599	2	3
4186167	4237458	2	2
36009833	80809	0	1
36157696	1119510	0	0
36158215	1125315	0	0
36302170	4294548	7	13
42902244	42902245	0	0
44356604	19127890	0	0
42804429	1551099	0	0
45652229	40174880	2	3
45643250	1177480	0	0
45620137	975125	0	0
45641486	46275916	1	1
45629180	1112807	0	0
45642179	1149196	0	0
45661692	1125315	0	0
45683740	1115008	0	0
45707185	1309944	0	0
45648981	933724	0	0
45671840	1759842	0	0
45784268	1149196	0	0
46291349	1551099	0	0
45784853	1177480	0	0
45794539	1115008	0	0
46243814	1112807	0	0
45896722	967823	0	0
45803748	1115008	0	0
46297906	19079524	2	3
46244638	1125315	0	0
46313788	1125315	0	0
4169137	4169137	0	0
75909	40480160	2	4
21001750	19074841	2	3
4188027	37017711	2	2
21602823	19073183	0	3
36157699	1119510	0	0
36158417	1125315	0	0
36302170	4166224	9	13
42902245	42902245	0	0
44356605	1174888	0	0
42804522	1115008	0	0
44344444	19077344	2	3
45643577	1177480	0	0
45620149	1308738	0	0
45641651	46275916	1	1
45629610	1112807	0	0
45642180	1149380	0	0
45661777	1125315	0	0
45683746	1154029	0	0
45707580	1192710	0	0
45648944	1149196	0	0
45671813	1595799	0	0
45784310	1149196	0	0
46291353	1551099	0	0
45782692	1177480	0	0
45794437	715997	0	0
46243690	1738521	0	0
45896200	1322184	0	0
45804038	914335	0	0
45795874	19078461	2	3
46239908	1125315	0	0
46313563	1125315	0	0
442264	4149245	4	4
194526	4142905	2	4
21001750	46233710	2	3
4188027	433644	2	2
36202157	4278672	7	9
36157699	738818	0	0
36158477	1125315	0	0
36302170	375671	9	13
42903088	1154615	0	0
44356610	738818	0	0
42801720	1125315	0	0
44344273	46275916	2	3
45643671	1177480	0	0
45620151	1332418	0	0
45635453	46275916	1	1
45629596	1112807	0	0
45642185	738818	0	0
45661785	1125315	0	0
45683582	914335	0	0
45707376	740275	0	0
45648612	1153428	0	0
45671938	1124957	0	0
45784341	1551099	0	0
46291366	1728416	0	0
45782708	1177480	0	0
45794612	1118084	0	0
46243749	1713332	0	0
45804251	1153428	0	0
45804071	1322184	0	0
45788834	19078461	2	3
46240010	1125315	0	0
46313912	1125315	0	0
4103320	40481087	4	4
432795	4001336	4	7
21001750	19074843	2	3
4188027	4240902	2	2
36202157	4237458	8	9
36157564	1119510	0	0
36158530	1125315	0	0
36302170	378001	9	13
42806682	1112807	0	0
44356751	1115008	0	0
42801720	1174888	0	0
44344082	1115171	2	3
45643747	1177480	0	0
45620448	19039298	0	0
45632452	46275916	1	1
45626651	1112807	0	0
45642199	1305058	0	0
45661837	1125315	0	0
45683597	1124300	0	0
45707305	1115008	0	0
45648991	1124300	0	0
45671950	1367571	0	0
45786442	1307863	0	0
46291574	705944	0	0
45782796	1177480	0	0
45794615	1343916	0	0
46243695	1000560	0	0
45804257	975125	0	0
45804047	1174888	0	0
46241697	19078461	2	3
46239923	1125315	0	0
46313836	1125315	0	0
4040738	45769019	4	4
4020346	4146173	4	6
21001750	19133905	2	3
4188027	4219399	2	2
36203062	4134304	7	10
36157566	1149196	0	0
36154376	1125315	0	0
36302170	37017711	9	10
42806671	1177480	0	0
44356803	933724	0	0
42801724	705944	0	0
44344647	19059056	2	3
45643557	1177480	0	0
45620370	1500211	0	0
45632620	46275916	1	1
45626787	1112807	0	0
45642253	1124957	0	0
45661982	1125315	0	0
45683710	757627	0	0
45707311	1500211	0	0
45649126	1124300	0	0
45671738	1549786	0	0
45786359	1107830	0	0
46291594	1713332	0	0
45780220	1177480	0	0
45794603	914335	0	0
46243701	1192710	0	0
45804352	705944	0	0
45804051	1192710	0	0
46297506	40223768	2	3
46239931	1125315	0	0
46313719	1125315	0	0
4105895	4107731	4	4
4022201	4134304	4	6
21001750	19133873	2	3
4180154	45769019	2	2
36203062	78272	6	10
36157567	1124300	0	0
36154346	1125315	0	0
36516972	80809	3	3
42806667	1119510	0	0
44356804	1310149	0	0
42801642	933724	0	0
45646038	19075601	2	3
45645773	1177480	0	0
45620484	1332418	0	0
45629394	46275916	1	1
45626716	1112807	0	0
45642236	1107830	0	0
45661985	1125315	0	0
45683599	740275	0	0
45707385	1332418	0	0
45648622	705944	0	0
45671738	19127890	0	0
45786417	1000560	0	0
46291600	914335	0	0
45780474	1177480	0	0
45794610	1192710	0	0
46243902	1192710	0	0
45804336	1307863	0	0
45804054	1501700	0	0
45798907	19078461	2	3
46240106	1125315	0	0
46314050	1125315	0	0
4040722	40492359	4	4
73553	4134304	4	6
21001750	19073188	2	3
4077352	4163874	2	2
36203062	81151	6	9
36157568	1149196	0	0
36154583	1125315	0	0
36516972	80502	3	3
42806669	1149380	0	0
44356672	1192710	0	0
42801644	1000560	0	0
45646385	40236446	2	3
45640698	1177480	0	0
45620495	791967	0	0
45626592	46275916	1	1
45626672	1112807	0	0
45642240	1102527	0	0
45661901	1125315	0	0
45683600	1310149	0	0
45707387	1551099	0	0
45648629	1768849	0	0
45671738	1515774	0	0
45786456	1124957	0	0
46291615	1112807	0	0
45706533	1177480	0	0
45794734	757627	0	0
46243819	1551099	0	0
45804317	1738521	0	0
45804171	975125	0	0
46244518	19078461	2	3
46239873	1125315	0	0
46313849	1125315	0	0
4115390	321042	4	4
444112	4296204	4	6
21013536	46275444	2	3
4078068	4168004	2	2
36203062	375671	6	9
36157574	1119510	0	0
36154317	1125315	0	0
36516772	80502	3	3
42806728	1521369	0	0
44356673	1154029	0	0
42801684	1549786	0	0
45646293	19018935	2	3
45640890	1177480	0	0
45620505	1192710	0	0
45626704	19079524	1	1
45623298	1112807	0	0
45642209	1501700	0	0
45655525	1125315	0	0
45683747	738818	0	0
45707388	1107830	0	0
45649084	1174888	0	0
45671813	1308738	0	0
45786475	1192710	0	0
46291621	1778162	0	0
45706294	1177480	0	0
45794444	1548195	0	0
46243824	1000560	0	0
45804287	1310149	0	0
45803830	1545958	0	0
45788688	19078461	2	3
46239950	1125315	0	0
46314075	1125315	0	0
4042640	4323902	4	4
4028071	261325	4	6
21013536	1713671	2	3
4030886	4108705	2	2
36203062	378001	6	9
36157577	1119510	0	0
36154472	1125315	0	0
36516772	4035415	3	3
42806728	1595799	0	0
44356611	723013	0	0
42801684	1512674	0	0
45646408	40232448	2	3
45641042	1177480	0	0
45620509	1192710	0	0
45667963	46275916	1	1
45623357	1112807	0	0
45642272	1149380	0	0
45655569	1125315	0	0
45683640	1521369	0	0
45707195	1000560	0	0
45649152	967823	0	0
45671814	1343916	0	0
45786481	920293	0	0
46291793	1112807	0	0
45706419	1177480	0	0
45794446	1545958	0	0
46243825	1000560	0	0
45804319	1326303	0	0
45803924	791967	0	0
45793581	19079524	2	3
46240070	1125315	0	0
46314785	1125315	0	0
4180938	4163872	4	4
193460	81151	4	5
21001768	46233710	2	3
4122424	4202451	2	2
35702118	4285898	4	8
36157578	1119510	0	0
36154473	1125315	0	0
36703477	381316	3	3
42806728	1549786	0	0
44356692	975125	0	0
42801685	1119510	0	0
45645975	43012036	2	3
45640849	1177480	0	0
45620528	975125	0	0
45663454	40220386	1	1
45623567	1112807	0	0
45642216	1778162	0	0
45658264	1125315	0	0
45683640	1549786	0	0
45707383	1713332	0	0
45649134	1107830	0	0
45671976	1149380	0	0
45784394	1307863	0	0
46291751	1107830	0	0
45706459	1177480	0	0
45792779	738818	0	0
46243906	1738521	0	0
45804359	967823	0	0
45803926	1000560	0	0
45793553	19078461	2	3
46239968	1125315	0	0
46314535	1125315	0	0
4181063	4048171	4	4
193460	4230399	4	5
21001768	46233988	2	3
4098910	4117038	2	2
36203062	4059173	6	8
36157578	738818	0	0
36154476	1125315	0	0
36315348	4037675	3	3
42806735	1125315	0	0
44356758	1115008	0	0
42801729	1125315	0	0
45646196	19008572	2	3
45640800	1177480	0	0
44362084	1124300	0	0
45659674	46275916	1	1
45667662	1112807	0	0
45642330	738818	0	0
45658334	1125315	0	0
45683648	1154343	0	0
45707383	1759842	0	0
45649160	1501700	0	0
45671746	1343916	0	0
45784372	967823	0	0
46291762	1112807	0	0
45706621	1177480	0	0
45792734	1192710	0	0
46243780	1149196	0	0
45804361	1310149	0	0
45803935	1332418	0	0
46289942	19079524	2	3
46240130	1125315	0	0
46314544	1125315	0	0
4154739	4230399	4	4
444112	134438	4	5
21002349	920300	2	3
4099350	4116491	2	2
36203062	4278672	6	8
36157766	1129625	0	0
36154443	1125315	0	0
36602219	40480160	3	3
42806735	1174888	0	0
44356654	1512674	0	0
42801609	1177480	0	0
45643070	920334	2	3
45641176	1177480	0	0
44362250	975125	0	0
45649391	1125315	0	0
45667800	1112807	0	0
45642332	1332418	0	0
45658010	1125315	0	0
45683649	738818	0	0
45707497	708298	0	0
45649143	1307863	0	0
45671758	1149196	0	0
45784382	1778162	0	0
46291765	1115008	0	0
45706603	1177480	0	0
45792764	738818	0	0
46243783	705944	0	0
45804380	1174888	0	0
45804181	1521369	0	0
46241982	19078461	2	3
46240021	1125315	0	0
46314629	1125315	0	0
4154162	4001336	4	4
4028071	45769019	4	5
21002349	920334	2	3
4100621	4293740	2	2
36203062	4146173	6	8
36157643	1129625	0	0
36154444	1125315	0	0
40792670	3014576	3	3
42806680	1107830	0	0
44356710	738818	0	0
42801688	1153428	0	0
45643316	19019979	2	3
45641044	1177480	0	0
44362280	1713332	0	0
45649333	1125315	0	0
45667908	1112807	0	0
45642317	738818	0	0
45658341	1125315	0	0
45683788	1115008	0	0
45707503	1367571	0	0
45646162	1115008	0	0
45671954	1110410	0	0
45784392	1174888	0	0
46292019	1112807	0	0
45703045	1177480	0	0
45792770	1332418	0	0
46243786	1521369	0	0
45804379	1778162	0	0
45804181	1549786	0	0
45795852	19078461	2	3
46240119	1125315	0	0
46314569	1125315	0	0
4041285	4116491	4	4
4022201	81151	4	5
21001744	19073188	2	3
4101079	372328	2	2
36203062	40480160	8	8
36157643	1119510	0	0
36154389	1125315	0	0
36503296	4149245	3	4
42806756	19127890	0	0
44356717	967823	0	0
42801631	1738521	0	0
44357062	1125315	0	0
45641283	1177480	0	0
44362280	1759842	0	0
45649520	1125315	0	0
45667951	1112807	0	0
45642335	1305058	0	0
45655599	1125315	0	0
45683798	1549786	0	0
45707679	1115008	0	0
45646159	1110410	0	0
45671856	914335	0	0
45784457	738818	0	0
46291776	1107830	0	0
45703091	1177480	0	0
45792789	1343916	0	0
46243786	1549786	0	0
45804315	1149196	0	0
45804186	1332418	0	0
45794032	19078461	2	3
45896588	1125315	0	0
46314582	1125315	0	0
4042641	4078793	4	4
4022571	4112343	4	5
21001744	19073183	2	3
4100932	4035415	2	2
36203062	4237458	7	8
36157708	1332418	0	0
36154554	1125315	0	0
36516728	4237458	3	4
42806756	1589505	0	0
44356718	1112807	0	0
42801771	1000560	0	0
44357064	1125315	0	0
45641211	1177480	0	0
44362350	1343916	0	0
45649465	1125315	0	0
45667956	1112807	0	0
45642310	1759842	0	0
45655689	1125315	0	0
45683798	1589505	0	0
45707727	1326303	0	0
45645996	738818	0	0
45671897	1149196	0	0
45784440	1149380	0	0
46291452	1501700	0	0
45702971	1177480	0	0
45792746	715997	0	0
46243919	975125	0	0
45804388	1310149	0	0
45804022	1501700	0	0
45795857	19078461	2	3
45896592	1125315	0	0
46314674	1125315	0	0
4042641	4057420	4	4
444089	4166224	4	5
21002805	19019273	2	3
4309075	4047491	2	2
36203062	4048695	7	8
36157710	1112807	0	0
36154656	1125315	0	0
36503297	4146173	3	4
42806756	1549786	0	0
44356662	738818	0	0
42801766	1322184	0	0
44357176	1125315	0	0
45637584	1177480	0	0
44362353	1549786	0	0
45649441	1125315	0	0
45665456	1112807	0	0
45642310	1713332	0	0
45655700	1125315	0	0
45683798	19127890	0	0
45707665	1738521	0	0
45646235	1107830	0	0
45671994	1124300	0	0
45784442	1154029	0	0
46291458	975125	0	0
45699956	1177480	0	0
45792731	1539403	0	0
46243873	1149196	0	0
45796288	1115008	0	0
45804032	920293	0	0
45788461	19078461	2	3
45896485	1125315	0	0
46314994	1125315	0	0
4179141	40479768	4	4
4027553	260139	4	4
21002805	19078461	2	3
4309188	192671	2	2
36203062	4066995	7	8
36157616	1129625	0	0
36154647	1125315	0	0
36703500	44782520	3	4
42806758	1124300	0	0
44356654	1549786	0	0
42801706	708298	0	0
44357108	1125315	0	0
45637730	1177480	0	0
44362353	1521369	0	0
45649446	1125315	0	0
45665457	1112807	0	0
45642360	1545958	0	0
45655647	1125315	0	0
45683656	1729720	0	0
45707681	1110410	0	0
45646062	1149196	0	0
45672145	19127890	0	0
45784414	1000560	0	0
46291470	1124957	0	0
45700037	1177480	0	0
45792750	1332418	0	0
46241234	1118084	0	0
45796294	1557272	0	0
45804160	1310149	0	0
46301431	19078461	2	3
45896527	1125315	0	0
46315024	1125315	0	0
4179141	40479422	4	4
75053	4134304	4	4
21003410	1551192	2	3
21604214	40220386	2	3
36000000	4066995	7	8
36157620	1332418	0	0
36154652	1125315	0	0
36516781	4149245	3	4
42806761	1361711	0	0
44356731	715997	0	0
42801711	1521369	0	0
44357111	1125315	0	0
45637681	1177480	0	0
44362358	1361711	0	0
45649448	1125315	0	0
45665435	1112807	0	0
45642361	1107830	0	0
45655664	1125315	0	0
45683658	738818	0	0
45707683	1551099	0	0
45646331	1124300	0	0
45672145	1589505	0	0
45784488	1361711	0	0
46291693	1343916	0	0
45700120	1177480	0	0
45792881	1521369	0	0
46241235	1110410	0	0
45796389	1000560	0	0
45804168	1589505	0	0
46290232	19078461	2	3
45896438	1125315	0	0
46314723	1125315	0	0
4178367	4202451	4	4
4003568	40492359	4	4
21003153	1115171	2	3
35507611	1115171	2	3
35508496	1119510	0	0
36157793	1545958	0	0
36154728	1125315	0	0
36313967	40478878	3	4
42806763	1154343	0	0
44356847	933724	0	0
42801712	701322	0	0
44357116	1125315	0	0
45637690	1177480	0	0
44361983	1149196	0	0
45649449	1125315	0	0
45663232	1112807	0	0
45642391	1713332	0	0
45655760	1125315	0	0
45683698	740275	0	0
45707222	1192710	0	0
45646334	1310149	0	0
45672145	1549786	0	0
45784608	1307863	0	0
46291700	723013	0	0
45699922	1177480	0	0
45792881	1549786	0	0
46241478	1154029	0	0
45797153	1115008	0	0
45804168	1549786	0	0
45790789	40223768	2	3
45896503	1125315	0	0
46308793	1125315	0	0
4103662	4066995	4	4
432545	433125	4	4
21003153	1127078	2	3
35507491	40229134	2	3
35508496	1125315	0	0
36157771	1149196	0	0
36154731	1125315	0	0
36516781	81151	3	5
42806766	920293	0	0
44356930	1521369	0	0
42801767	1738521	0	0
44358910	1125315	0	0
45637948	1177480	0	0
44362219	1192710	0	0
45649492	1125315	0	0
45660069	1112807	0	0
45642391	1759842	0	0
45655980	1125315	0	0
45683699	19010482	0	0
45707225	1110410	0	0
45646339	1539403	0	0
45672146	1192710	0	0
45784435	1115008	0	0
46291978	1107830	0	0
45700073	1177480	0	0
45792882	738818	0	0
46241483	1115008	0	0
45797167	975125	0	0
45798784	975125	0	0
46298141	19078461	2	3
45896472	1125315	0	0
46308797	1125315	0	0
4178545	4283893	4	4
432545	28060	4	4
21003153	19078461	2	3
35507616	35605482	2	3
35508496	738818	0	0
36157711	1177480	0	0
36154732	1125315	0	0
36703500	381316	3	5
42806699	1153428	0	0
44357200	1115008	0	0
42801744	1118084	0	0
44358920	1125315	0	0
45637998	1177480	0	0
44361999	1545958	0	0
45631754	1125315	0	0
45649376	975125	0	0
45642399	1343916	0	0
45655818	1125315	0	0
45683700	1149380	0	0
45707490	1310149	0	0
45645683	1154343	0	0
45671871	1174888	0	0
45784490	1332418	0	0
46291906	1112807	0	0
45700395	1177480	0	0
45792890	1149380	0	0
46241279	1539403	0	0
45797298	1551099	0	0
45798791	1332418	0	0
46241902	19078461	2	3
45896473	1125315	0	0
46308801	1125315	0	0
4178545	372328	4	4
4022201	4059173	4	4
21003153	19059056	2	3
35507585	40162522	2	3
35508499	933724	0	0
36157939	975125	0	0
36154734	1125315	0	0
36516825	40480160	3	5
42806706	1000560	0	0
44357206	1308738	0	0
42801730	738818	0	0
44358718	1125315	0	0
45634502	1177480	0	0
44362085	1149196	0	0
45632050	1125315	0	0
45632175	975125	0	0
45638877	1717327	0	0
45655744	1125315	0	0
45683754	1118084	0	0
45707582	1115008	0	0
45645632	1115008	0	0
45672112	1343916	0	0
45784480	742185	0	0
46291909	791967	0	0
45700480	1177480	0	0
45792892	738818	0	0
46241441	1332418	0	0
45796532	1713332	0	0
45798792	1548195	0	0
46289970	19078461	2	3
45896681	1125315	0	0
46309180	1125315	0	0
4154161	4156265	4	4
4022201	40480160	4	4
21002350	19074843	2	3
35507492	1332419	2	3
35508502	791967	0	0
36157940	1738521	0	0
36154735	1125315	0	0
36500000	80180	3	5
42806748	1124300	0	0
44357270	1154343	0	0
42801655	1149380	0	0
44358751	1125315	0	0
45634800	1177480	0	0
44362088	1149380	0	0
45632149	1125315	0	0
45631974	975125	0	0
45638879	1308738	0	0
45655750	1125315	0	0
45683768	1729720	0	0
45707685	967823	0	0
45645618	1713332	0	0
45671903	1361711	0	0
45784482	723013	0	0
46291917	1738521	0	0
45697580	1177480	0	0
45792974	738818	0	0
46241407	1551099	0	0
45796501	1107830	0	0
45798882	1738521	0	0
46310895	19078461	2	3
45896682	1125315	0	0
46308948	1125315	0	0
4185115	4125906	4	4
4022201	40479768	4	4
21002350	920300	2	3
903386	45892894	2	3
35508456	738818	0	0
36157675	1119510	0	0
36154745	1125315	0	0
36300000	4163951	3	5
42806686	791967	0	0
44356722	1192710	0	0
42801735	1332418	0	0
44357302	1125315	0	0
45634738	1177480	0	0
44362094	1729720	0	0
45632086	1125315	0	0
45631874	975125	0	0
45639313	1521369	0	0
45655729	1125315	0	0
45683670	975125	0	0
45707598	1192710	0	0
45645804	1149196	0	0
45671907	1322184	0	0
45782311	1174888	0	0
46295773	1501700	0	0
45696908	1177480	0	0
45792979	1115008	0	0
46241315	1112807	0	0
45796512	975125	0	0
45798930	1174888	0	0
46310964	19078461	2	3
45896686	1125315	0	0
46308896	1125315	0	0
4071689	317576	4	4
4022201	4048695	4	4
21002350	920334	2	3
4044900	4058899	2	3
35508412	1174888	0	0
36157676	1549786	0	0
36154746	1125315	0	0
36500000	80502	3	6
42806842	975125	0	0
44356961	1107830	0	0
42801659	1177480	0	0
44357394	1125315	0	0
45634423	1177480	0	0
44362176	975125	0	0
45632160	1125315	0	0
45632227	975125	0	0
45639315	1551099	0	0
45655783	1125315	0	0
45683807	967823	0	0
45707599	1174888	0	0
45645708	1154343	0	0
45672030	738818	0	0
45782212	1539403	0	0
46295789	975125	0	0
45696917	1177480	0	0
45792980	1738521	0	0
46241458	1124300	0	0
45796549	1310149	0	0
45798931	967823	0	0
46316930	40223768	2	3
45896687	1125315	0	0
46308919	1125315	0	0
4071689	4310024	4	4
4022201	4278672	4	4
21002811	19078461	2	3
4180169	372328	2	3
35508412	1125315	0	0
36157676	19127890	0	0
36154748	1125315	0	0
36500000	80809	3	6
42806802	1000560	0	0
44356777	1713332	0	0
42801661	1192710	0	0
44357398	1125315	0	0
45634535	1177480	0	0
44362255	1332418	0	0
45632185	1125315	0	0
45634087	975125	0	0
45639222	1153428	0	0
45655943	1125315	0	0
45683773	1124957	0	0
45707318	1000560	0	0
45645610	1332418	0	0
45672038	1551099	0	0
45782316	1192710	0	0
46295795	1192710	0	0
45697075	1177480	0	0
45792741	1332418	0	0
46241464	1124957	0	0
45796669	1551099	0	0
45798673	1192710	0	0
46316862	19078461	2	3
45896554	1125315	0	0
46309286	1125315	0	0
4028071	4116491	4	4
4022201	40479422	4	4
21002811	1115171	2	3
4032251	4024289	2	3
35508268	1125315	0	0
36157676	1589505	0	0
36154751	1125315	0	0
36313966	439777	3	8
42806904	1548195	0	0
44356783	1545958	0	0
42801775	1557272	0	0
44357311	1125315	0	0
45634785	1177480	0	0
44362138	19010482	0	0
45632249	1125315	0	0
45634216	975125	0	0
45639135	738818	0	0
44348130	1125315	0	0
45683778	1741122	0	0
45707422	1192710	0	0
45645724	1310149	0	0
45672158	1154343	0	0
45782328	1000560	0	0
46244923	1149196	0	0
45697238	1177480	0	0
45792793	1717327	0	0
46241469	1149196	0	0
45796503	1115008	0	0
45798674	1115008	0	0
45799832	1332419	2	3
45896576	1125315	0	0
46309409	1125315	0	0
4103352	257012	4	4
4022201	4066995	4	4
21002491	1127433	2	3
4032251	4252419	2	3
35508506	975125	0	0
36157683	1112807	0	0
36154752	1125315	0	0
36516993	78272	3	8
42806777	1118084	0	0
44356764	1713332	0	0
42801778	1000560	0	0
44357345	1125315	0	0
45636982	1177480	0	0
44362457	1589505	0	0
45631989	1125315	0	0
45629075	975125	0	0
45639158	1174888	0	0
44348409	1125315	0	0
45683778	1746114	0	0
45707510	1000560	0	0
45645764	1124300	0	0
45671772	1192710	0	0
45782335	1729720	0	0
46244924	1322184	0	0
45696988	1177480	0	0
45792819	920293	0	0
46241473	1149196	0	0
45796479	19010482	0	0
45798682	1115008	0	0
45802454	1545959	2	3
45894735	1125315	0	0
46309131	1125315	0	0
4072499	4043071	4	4
4021667	4113008	4	4
21002491	19078461	2	3
1102527	40165015	2	3
35508507	1125315	0	0
36157684	1154343	0	0
36154564	1125315	0	0
36500000	4059173	3	9
42806754	1713332	0	0
44356971	1124300	0	0
42801781	1589505	0	0
44353627	1125315	0	0
45636795	1177480	0	0
44362461	975125	0	0
45631991	1125315	0	0
45629154	975125	0	0
45639229	1107830	0	0
44348200	1125315	0	0
45683783	1589505	0	0
45707406	1115008	0	0
45645792	1149196	0	0
45672071	1501700	0	0
45782422	1000560	0	0
46244927	1000560	0	0
45697303	1177480	0	0
45792903	1501700	0	0
46241326	1713332	0	0
45796553	1778162	0	0
45798560	1000560	0	0
45893732	1332419	2	3
45894624	1125315	0	0
46309307	1125315	0	0
4067285	4163971	4	4
4021667	4109685	4	4
21002491	19019273	2	3
21003024	19023398	2	3
35508413	791967	0	0
36157831	791967	0	0
36154573	1125315	0	0
36500000	4278672	3	9
42806811	1589505	0	0
44356697	1118084	0	0
42801781	19127890	0	0
44353941	1125315	0	0
45637317	1177480	0	0
44362463	1154029	0	0
45632004	1125315	0	0
45629215	975125	0	0
45639230	1548195	0	0
44348413	1125315	0	0
45683851	975125	0	0
45707415	1115008	0	0
45642677	1115008	0	0
45672077	1149380	0	0
45782221	1192710	0	0
46244928	1728416	0	0
45693938	1177480	0	0
45792908	1174888	0	0
46241328	1192710	0	0
45796482	967823	0	0
45798671	1174888	0	0
45790676	1332419	2	3
45894720	1125315	0	0
46309310	1125315	0	0
4043022	4163872	4	4
4021667	4155034	4	4
21002491	19059056	2	3
21003024	782047	2	3
35508415	1125315	0	0
36157833	1124300	0	0
36154812	1125315	0	0
36500000	4237458	3	9
42806870	19016749	0	0
44356703	975125	0	0
42801781	1549786	0	0
44353895	1125315	0	0
45631793	1177480	0	0
44362261	1124957	0	0
45632006	1125315	0	0
45628987	975125	0	0
45639272	967823	0	0
44348416	1125315	0	0
45683867	1501700	0	0
45707695	715997	0	0
45642688	967823	0	0
45672083	738818	0	0
45782357	975125	0	0
46275444	46275444	0	0
45694103	1177480	0	0
45792910	1112807	0	0
46241331	791967	0	0
45796490	1149196	0	0
45798781	1307863	0	0
46244441	1332419	2	3
45894340	1125315	0	0
46309318	1125315	0	0
4043022	4163951	4	4
433128	4084167	4	4
21002491	1115171	2	3
21013966	46233710	2	3
35508415	1174888	0	0
36157835	1124300	0	0
36152381	1125315	0	0
36500000	4142905	3	9
42806821	1118084	0	0
44356704	705944	0	0
42801810	1125315	0	0
44354225	1125315	0	0
45631797	1177480	0	0
44362262	967823	0	0
45632013	1125315	0	0
45629317	975125	0	0
45639308	1192710	0	0
44348267	1125315	0	0
45683873	1343916	0	0
45704433	967823	0	0
45642703	1713332	0	0
45672086	19127890	0	0
45782360	975125	0	0
45678097	19019273	2	3
45694183	1177480	0	0
45792798	1192710	0	0
46241344	19127890	0	0
45796679	1110410	0	0
45798474	1551099	0	0
45795866	1332419	2	3
45894511	1125315	0	0
46309342	1125315	0	0
4043022	4145310	4	4
4020346	4113008	4	4
21002808	1551192	2	3
21013966	46233988	2	3
35508458	1119510	0	0
36157837	1153428	0	0
36152179	1125315	0	0
36516972	78272	3	8
42806832	1115008	0	0
44356830	975125	0	0
42801810	1112807	0	0
44353844	1125315	0	0
45631778	1177480	0	0
44362186	1110410	0	0
45632016	1125315	0	0
45628274	975125	0	0
45639362	1107830	0	0
45651975	1125315	0	0
45683875	723013	0	0
45704631	1000560	0	0
45642703	1759842	0	0
45672086	1589505	0	0
45782368	1115008	0	0
45678079	40163554	2	3
45694153	1177480	0	0
45792799	1115008	0	0
46241344	1521369	0	0
45796694	975125	0	0
45798475	708298	0	0
46297938	19079524	2	3
45799644	1125315	0	0
46309344	1125315	0	0
4178818	133834	4	4
4020346	4155034	4	4
21002808	19019273	2	3
21003063	40232448	2	3
35508460	1119510	0	0
36157842	1112807	0	0
36152180	1125315	0	0
36516972	4066995	3	6
42806958	1177480	0	0
44356842	723013	0	0
42801810	1129625	0	0
44354144	1125315	0	0
45631902	1177480	0	0
44362194	791967	0	0
45632213	1125315	0	0
45626116	975125	0	0
45639335	1124957	0	0
45649324	1125315	0	0
45683891	1000560	0	0
45704635	1713332	0	0
45642758	757627	0	0
45672086	1549786	0	0
45782281	715997	0	0
45678352	35605482	2	3
45694038	1177480	0	0
45792811	1115008	0	0
46241344	1549786	0	0
45796727	1326303	0	0
45798481	1124300	0	0
45787572	1539411	2	3
45799648	1125315	0	0
46309461	1125315	0	0
4178818	198809	4	4
73553	81151	4	4
21002808	19019979	2	3
701322	45892894	2	3
35508461	1729720	0	0
36157715	1589505	0	0
36152328	1125315	0	0
36516972	4035415	3	6
42806972	1154343	0	0
44356994	1174888	0	0
42801785	1332418	0	0
44354145	1125315	0	0
45628705	1177480	0	0
44362213	791967	0	0
45632238	1125315	0	0
45626223	975125	0	0
45639260	1110410	0	0
45649327	1125315	0	0
45683859	19010482	0	0
45704578	1310149	0	0
45642770	19127890	0	0
45672088	1539403	0	0
45782464	1557272	0	0
45678243	40163554	2	3
45693852	1177480	0	0
45790027	1174888	0	0
46241347	1308738	0	0
45796809	1322184	0	0
45798592	1174888	0	0
46316298	19079524	1	1
45799932	1125315	0	0
46309183	1125315	0	0
4178818	4283893	4	4
432795	4296205	4	4
21002808	19059056	2	3
21500806	40163554	2	3
35508462	1177480	0	0
36157870	1115008	0	0
36152150	1125315	0	0
36516781	78272	2	6
42806973	1125315	0	0
44356998	1557272	0	0
42801816	1738521	0	0
44354235	1125315	0	0
45631175	1177480	0	0
44362216	1192710	0	0
45632240	1125315	0	0
45623110	975125	0	0
45639261	1192710	0	0
45649331	1125315	0	0
45683898	1107830	0	0
45704594	1309944	0	0
45642770	1549786	0	0
45671908	1107830	0	0
45782428	967823	0	0
45678393	40231925	2	3
45694135	1177480	0	0
45790027	1192710	0	0
46241348	1192710	0	0
45796547	1174888	0	0
45798889	975125	0	0
46311271	19079524	1	1
46317845	1125315	0	0
46309472	1125315	0	0
4178818	440448	4	4
432795	4299128	4	4
21002808	19078461	2	3
21002958	19129655	2	3
35508269	1112807	0	0
36157871	1119510	0	0
36152156	1125315	0	0
36503296	81151	2	6
42807077	1125315	0	0
44356768	1000560	0	0
42801819	920293	0	0
44354212	1125315	0	0
45631095	1177480	0	0
44362305	1361711	0	0
45634196	1125315	0	0
45623318	975125	0	0
45639002	1149196	0	0
45649348	1125315	0	0
45683901	1545958	0	0
45704595	19039298	0	0
45642829	1322184	0	0
45671780	1174888	0	0
45782374	1589505	0	0
45678235	40224805	2	3
45691035	1177480	0	0
45790036	1551099	0	0
46241489	1107830	0	0
45796601	1000560	0	0
45798894	975125	0	0
45876009	3009542	1	1
46318082	1125315	0	0
46309189	1125315	0	0
4027403	44805732	4	4
193460	4035415	4	4
21002808	1115171	2	3
21002912	1551192	2	3
35508270	1115008	0	0
36157772	1589505	0	0
36158271	1125315	0	0
36313967	4015189	2	6
42807077	1112807	0	0
44357095	1322184	0	0
42801821	1112807	0	0
44354249	1125315	0	0
45628936	1177480	0	0
44362307	701322	0	0
45634218	1125315	0	0
45621508	975125	0	0
45639364	1557272	0	0
45649408	1125315	0	0
45683844	1332418	0	0
45704761	1332418	0	0
45642812	1115008	0	0
45671784	975125	0	0
45782528	738818	0	0
45678242	1115171	2	3
45690983	1177480	0	0
45790037	19010482	0	0
46241372	1112807	0	0
45796664	1107830	0	0
45798898	1545958	0	0
45876009	3024731	1	1
46317603	1125315	0	0
46309192	1125315	0	0
4047779	378001	6	9
75909	4066995	4	4
21601119	964261	4	5
21002975	40243436	2	3
35508594	1125315	0	0
36157883	1177480	0	0
36158539	1125315	0	0
36503297	4149245	2	5
42807030	1125315	0	0
44357096	1713332	0	0
42801823	1154343	0	0
44354187	1125315	0	0
45626026	1177480	0	0
44362456	715997	0	0
45634228	1125315	0	0
45621768	975125	0	0
45639065	1192710	0	0
45649566	1125315	0	0
45683943	1149196	0	0
45704853	1539403	0	0
45642817	1115008	0	0
45671874	1149380	0	0
45782547	1326303	0	0
45678406	19059056	2	3
45690908	1177480	0	0
45790040	1115008	0	0
46241352	920293	0	0
45796634	1124300	0	0
45798597	1713332	0	0
45876009	3002385	1	1
46318162	1125315	0	0
46309366	1125315	0	0
4047779	313217	6	9
75909	4059173	4	4
21600279	46275916	4	5
21500523	19076374	2	3
35508596	738818	0	0
36157884	791967	0	0
36158612	1125315	0	0
36422731	1150771	2	3
42806854	1124957	0	0
44357006	1177480	0	0
42801993	1738521	0	0
44354196	1125315	0	0
45626097	1177480	0	0
44362333	738818	0	0
45629015	1125315	0	0
45621858	975125	0	0
45639070	1515774	0	0
45649574	1125315	0	0
45683939	1310149	0	0
45704445	1717327	0	0
45642859	1124957	0	0
45671874	1137529	0	0
45782551	1549786	0	0
45678341	1127433	2	3
45691155	1177480	0	0
45789986	975125	0	0
46241542	1000560	0	0
45796637	1548195	0	0
45798708	1343916	0	0
45876009	3010813	1	1
46317754	1125315	0	0
46303662	1125315	0	0
4047779	4230399	6	9
75909	4048695	4	4
21500562	45892894	4	5
35507421	19019273	2	3
35508602	1500211	0	0
36158055	1177480	0	0
36158602	1125315	0	0
36429173	1150837	2	3
42806854	1125315	0	0
44356885	1738521	0	0
42801959	1112807	0	0
44354207	1125315	0	0
45622696	1177480	0	0
44362457	1549786	0	0
45629132	1125315	0	0
45667289	975125	0	0
45639070	19127890	0	0
45649219	1125315	0	0
45683820	1000560	0	0
45704718	1539403	0	0
45642796	723013	0	0
45671878	1549786	0	0
45782551	19127890	0	0
45678428	40223834	2	3
45691312	1177480	0	0
45790129	1192710	0	0
46241432	1107830	0	0
45791253	967823	0	0
45799774	1343916	0	0
45876009	3026361	1	1
46318139	1125315	0	0
46303716	1125315	0	0
4047779	40479768	6	8
444089	198809	4	4
21500562	40223768	4	5
35507532	1107882	2	3
35508213	1129625	0	0
36157898	1107830	0	0
36158634	1125315	0	0
36427861	1551192	2	3
42806861	975125	0	0
44357009	1174888	0	0
42802001	1125315	0	0
44354279	1125315	0	0
45622673	1177480	0	0
44362559	1717327	0	0
45629136	1125315	0	0
45667425	975125	0	0
45639070	1549786	0	0
44343579	19128022	1	2
45683825	1115008	0	0
45704448	715997	0	0
45688706	1124957	0	0
45671878	1595799	0	0
45782562	1589505	0	0
45678428	40223821	2	3
45688151	1177480	0	0
45790130	975125	0	0
46241553	1118084	0	0
45791129	1501700	0	0
45799777	1549786	0	0
45876009	3007461	1	1
46317781	1125315	0	0
46303861	1125315	0	0
4047779	40479422	6	8
1361711	1361711	0	0
21500643	42707627	4	5
21002902	40173590	2	3
35508214	1119510	0	0
36158061	975125	0	0
36150709	1125315	0	0
36429128	46275444	2	3
42806942	1000560	0	0
44356875	723013	0	0
42802003	1118084	0	0
44352387	1125315	0	0
45622680	1177480	0	0
44362411	738818	0	0
45629197	1125315	0	0
45667450	975125	0	0
45639073	1548195	0	0
44343579	19128263	1	2
45683973	975125	0	0
45704551	1149196	0	0
45688471	1310149	0	0
45671878	1521369	0	0
45782565	738818	0	0
45678370	19008572	2	3
45688226	1177480	0	0
45790131	1192710	0	0
46241570	705944	0	0
45791119	1322184	0	0
45799777	1521369	0	0
45876009	3000963	1	1
46318249	1125315	0	0
46303865	1125315	0	0
4047779	133834	6	8
198809	198809	0	0
21600190	40243436	4	5
21003174	1150771	2	3
35508215	1125315	0	0
36158064	1112807	0	0
36150855	1125315	0	0
36426273	19057271	2	3
42806943	1000560	0	0
44357044	1107830	0	0
42802107	1551099	0	0
44352235	1125315	0	0
45622959	1177480	0	0
44362422	1174888	0	0
45629200	1125315	0	0
45667314	975125	0	0
45639080	1738521	0	0
44362457	19128009	1	2
45683975	1153428	0	0
45704643	705944	0	0
45688571	740275	0	0
45784050	1000560	0	0
45782505	1124300	0	0
45678418	40165015	2	3
45688379	1177480	0	0
45790048	1326303	0	0
46241451	1112807	0	0
45791221	1115008	0	0
45799809	1153428	0	0
45896736	1738521	0	0
46318096	1125315	0	0
46303929	1125315	0	0
4047779	196456	6	6
198199	198199	0	0
21500215	1332419	4	5
21003174	40232448	2	3
35508603	1738521	0	0
36157948	1177480	0	0
36150663	1125315	0	0
36427690	46275444	2	3
42806938	1738521	0	0
44357010	1778162	0	0
42802110	1177480	0	0
44352239	1125315	0	0
45622969	1177480	0	0
44362471	1308738	0	0
45629045	1125315	0	0
45662814	975125	0	0
45639083	1149196	0	0
45640662	46275916	1	1
45684071	19010482	0	0
45704816	1307863	0	0
45688660	1308738	0	0
45784051	1548195	0	0
45782509	708298	0	0
45674853	1127433	2	3
45684964	1177480	0	0
45790052	1112807	0	0
46241496	1107830	0	0
45791193	791967	0	0
45799709	1332418	0	0
45896739	1154343	0	0
46318168	1125315	0	0
46307067	1125315	0	0
4047779	441267	5	5
4010253	4010253	0	0
21500216	1310034	4	5
21013948	46233988	2	3
35508604	1119510	0	0
36158112	975125	0	0
36150844	1125315	0	0
36424954	1149380	0	0
42807080	742185	0	0
44357024	738818	0	0
42802110	1174888	0	0
44352352	1125315	0	0
45620878	1177480	0	0
44362496	1107830	0	0
45629161	1125315	0	0
45664648	975125	0	0
45639171	1595799	0	0
45637107	46275916	1	1
45683963	1549786	0	0
45704651	1307863	0	0
45691232	715997	0	0
45783789	723013	0	0
45782580	1192710	0	0
45674863	19059056	2	3
45685016	1177480	0	0
45790134	723013	0	0
46241512	1309944	0	0
45791073	1545958	0	0
45799850	1545958	0	0
45895584	1000560	0	0
46318210	1125315	0	0
46307005	1125315	0	0
4047779	192671	5	5
1595799	1595799	0	0
21500595	19019979	4	5
4042650	4252419	2	3
35508607	738818	0	0
36158115	1119510	0	0
36150845	1125315	0	0
36425092	757627	0	0
42807014	1125315	0	0
44356771	723013	0	0
42801966	1125315	0	0
44350269	1125315	0	0
45621125	1177480	0	0
44362584	738818	0	0
45629164	1125315	0	0
45656794	975125	0	0
45639171	1308738	0	0
45634639	46275916	1	1
45683963	1589505	0	0
45704825	1326303	0	0
45691234	1305058	0	0
45783885	1115008	0	0
45782649	1154029	0	0
45675210	1551192	2	3
45685101	1177480	0	0
45790056	708298	0	0
46241576	1112807	0	0
45791333	1557272	0	0
45799832	1332418	0	0
45895663	1322184	0	0
46318216	1125315	0	0
46306477	1125315	0	0
4047779	45769019	5	6
1594382	1594382	0	0
21500595	1115171	4	5
21501230	19079524	2	3
35508607	1119510	0	0
36158121	738818	0	0
36150935	1125315	0	0
36423756	1322184	0	0
42806951	1501700	0	0
44356955	1738521	0	0
42801935	1713332	0	0
44350257	1125315	0	0
45621386	1177480	0	0
44362594	1549786	0	0
45629205	1125315	0	0
45657205	975125	0	0
45639185	1110410	0	0
45628194	19127918	1	1
45680699	1589505	0	0
45704775	1174888	0	0
45691298	1000560	0	0
45783888	1124957	0	0
45782651	1589505	0	0
45675236	19008572	2	3
45685015	1177480	0	0
45790136	1539403	0	0
46241579	1595799	0	0
45791216	1322184	0	0
45799859	1124957	0	0
45895607	967823	0	0
46322544	1125315	0	0
46307073	1125315	0	0
4047779	4109685	5	6
1308738	1308738	0	0
21506173	40171902	4	4
1101544	40173590	2	3
35508611	1119510	0	0
36158121	1119510	0	0
36156431	1125315	0	0
36422341	1309944	0	0
42804384	1174888	0	0
44357132	1153428	0	0
42802079	1000560	0	0
44350342	1125315	0	0
45664833	1177480	0	0
44362478	1124300	0	0
45629192	1125315	0	0
45656890	975125	0	0
45639191	1174888	0	0
45620848	19074679	1	1
45680418	1149196	0	0
45704576	1115008	0	0
45691387	1107830	0	0
45783895	1729720	0	0
45782589	738818	0	0
45675005	19019273	2	3
45684995	1177480	0	0
45790138	1153428	0	0
46241650	1332418	0	0
45791156	1738521	0	0
45798973	1332418	0	0
45895573	1332418	0	0
46318325	1125315	0	0
46307077	1125315	0	0
4047779	4056621	5	6
1305058	1305058	0	0
21503082	914335	4	4
21002670	46233988	2	3
35508611	1125315	0	0
36157655	1177480	0	0
36156432	1125315	0	0
36422418	1713332	0	0
42804384	1125315	0	0
44350113	738818	0	0
42802081	975125	0	0
44350244	1125315	0	0
45664834	1177480	0	0
44362564	738818	0	0
45628973	1125315	0	0
45653776	975125	0	0
45639204	738818	0	0
45664228	19079524	1	1
45680762	1000560	0	0
45705097	1332418	0	0
45691389	933724	0	0
45783897	1309944	0	0
45782532	1551099	0	0
45675013	1127433	2	3
45685089	1177480	0	0
45789989	1545958	0	0
46241519	1322184	0	0
45791178	1192710	0	0
45798977	1501700	0	0
45895613	740275	0	0
45794374	1125315	0	0
46304054	1125315	0	0
4047779	4048171	5	9
967823	967823	0	0
21503082	967823	4	4
21002623	46275444	2	3
35508611	1192710	0	0
36158076	1119510	0	0
36155451	1125315	0	0
36422348	1332418	0	0
42804385	1125315	0	0
44350117	1112807	0	0
42801867	1124300	0	0
44350395	1125315	0	0
45664913	1177480	0	0
44362480	1713332	0	0
45628975	1125315	0	0
45653820	975125	0	0
45639339	1107830	0	0
45662205	19115351	1	1
45680872	723013	0	0
45704955	1149196	0	0
45691390	1551099	0	0
45784225	1746114	0	0
45782537	1551099	0	0
45675096	19018935	2	3
45685727	1177480	0	0
45790041	1545958	0	0
46241520	1112807	0	0
45791245	1174888	0	0
45799000	1115008	0	0
45895588	1308738	0	0
45794380	1125315	0	0
46304220	1125315	0	0
4047779	4146173	5	7
715997	715997	0	0
21503082	933724	4	4
21003027	46275916	2	3
35508625	738818	0	0
36158076	738818	0	0
36155565	1125315	0	0
36422432	1717327	0	0
42804385	1174888	0	0
44349758	1545958	0	0
42801873	1589505	0	0
44350336	1125315	0	0
45665083	1177480	0	0
44362366	1717327	0	0
45629092	1125315	0	0
45653637	975125	0	0
45638913	723013	0	0
45643657	19079524	1	1
45680741	1154029	0	0
45704878	1501700	0	0
45639745	1307863	0	0
45784225	1741122	0	0
45782544	1713332	0	0
45676423	1115171	2	3
45685885	1177480	0	0
45789916	1361711	0	0
46241600	1174888	0	0
45791249	1118084	0	0
45799056	1000560	0	0
45895639	738818	0	0
45794483	1125315	0	0
46304172	1125315	0	0
4047779	198809	5	7
723013	723013	0	0
21503082	920293	4	4
21003217	40232448	2	3
35508625	1125315	0	0
36158022	1124300	0	0
36155438	1125315	0	0
36503269	4142905	5	6
42804387	1125315	0	0
44349627	1332418	0	0
42801845	1149196	0	0
44350271	1125315	0	0
45665124	1177480	0	0
44362367	19127890	0	0
45629102	1125315	0	0
45653770	975125	0	0
45638979	1154343	0	0
45643372	19079524	1	1
45680526	1343916	0	0
45704882	1192710	0	0
45639634	1551099	0	0
45783954	791967	0	0
45782666	738818	0	0
45676429	40232448	2	3
45682152	1177480	0	0
45789905	1738521	0	0
46241603	975125	0	0
45791424	1551099	0	0
45799002	1149196	0	0
45895575	1149196	0	0
45794416	1125315	0	0
46304101	1125315	0	0
4047779	317576	5	7
723164	19115351	0	0
21500582	1177480	4	4
1101489	19007333	2	3
35508625	1119510	0	0
36158023	1119510	0	0
36155439	1125315	0	0
36516972	4059173	5	6
42804387	1174888	0	0
44349628	975125	0	0
42801873	1549786	0	0
44350249	1125315	0	0
45665057	1177480	0	0
44362367	1549786	0	0
45629049	1125315	0	0
45650232	975125	0	0
45638981	1332418	0	0
45634190	46275916	1	1
45680527	1713332	0	0
45704886	914335	0	0
45639919	1174888	0	0
45783958	1115008	0	0
45782383	1149196	0	0
45676376	1115171	2	3
45682269	1177480	0	0
45790150	1174888	0	0
46241604	1112807	0	0
45791320	1515774	0	0
45799037	920293	0	0
45895768	1343916	0	0
45794503	1125315	0	0
46304120	1125315	0	0
4047779	321042	5	7
260139	260139	0	0
21500582	1125315	4	4
21500819	19075601	2	3
35508555	1119510	0	0
36158023	1129625	0	0
36155440	1125315	0	0
36516772	4059173	5	6
42804421	40231925	2	3
44349635	1110410	0	0
42801877	975125	0	0
44350591	1125315	0	0
45665214	1177480	0	0
44362368	1738521	0	0
45629257	1125315	0	0
45650141	975125	0	0
45638983	1174888	0	0
45664746	46275916	1	1
45680529	1549786	0	0
45704888	19010482	0	0
45639695	1174888	0	0
45783905	1326303	0	0
45782238	1115008	0	0
45671925	1551192	2	3
45682332	1177480	0	0
45790155	1326303	0	0
46241606	1115008	0	0
45791320	1549786	0	0
45799041	1124300	0	0
45895725	1192710	0	0
45794399	1125315	0	0
46304187	1125315	0	0
4047779	4296204	5	7
261325	261325	0	0
21500541	1129625	4	4
21002901	40173590	2	3
35508555	1125315	0	0
36158029	1322184	0	0
36155398	1125315	0	0
36516772	4066995	5	6
42804242	19018935	2	3
44349801	791967	0	0
42801792	19127890	0	0
44350458	1125315	0	0
45665186	1177480	0	0
44362663	1149380	0	0
45629210	1125315	0	0
45650201	975125	0	0
45639355	1738521	0	0
45659077	46275916	1	1
45680529	1589505	0	0
45704562	1174888	0	0
45639670	1107830	0	0
45783971	1102527	0	0
45782419	975125	0	0
45671926	19008572	2	3
45682230	1177480	0	0
45790159	738818	0	0
46241673	1124957	0	0
45791202	1551099	0	0
45794629	740275	0	0
45895601	1332418	0	0
45794403	1125315	0	0
46304292	1125315	0	0
4047779	4059173	5	8
258780	258780	0	0
21500541	738818	4	4
1101553	40169216	2	3
35508630	1119510	0	0
36158176	1124300	0	0
36155400	1125315	0	0
36516772	4048695	5	6
42804303	19077344	2	3
44349803	1124300	0	0
42801792	1589505	0	0
44350698	1125315	0	0
45662584	1177480	0	0
44362534	19127890	0	0
45629268	1125315	0	0
45647289	975125	0	0
45639122	1557272	0	0
45643524	19079524	1	1
45680535	1154029	0	0
45704890	1154029	0	0
45639878	1154343	0	0
45783998	1115008	0	0
45782421	715997	0	0
45672097	19008572	2	3
45682237	1177480	0	0
45790160	738818	0	0
46241628	1322184	0	0
45791237	1521369	0	0
45794630	1778162	0	0
45895645	1124957	0	0
45794436	1125315	0	0
46304310	1125315	0	0
4047779	4278672	5	8
4012477	4012477	0	0
21500541	1125315	4	4
1101539	19019979	2	3
35508630	1125315	0	0
36157980	1557272	0	0
36155415	1125315	0	0
36516772	40479422	5	6
42804415	19133873	2	3
44349473	1361711	0	0
42801792	1549786	0	0
44350703	1125315	0	0
45662450	1177480	0	0
44362534	1549786	0	0
45629316	1125315	0	0
45647347	975125	0	0
45639241	1778162	0	0
45620907	46275916	1	1
45680356	967823	0	0
45704891	1192710	0	0
45639882	1738521	0	0
45784006	1110410	0	0
45782483	1192710	0	0
45672463	19008572	2	3
45678632	1177480	0	0
45789920	1102527	0	0
46238493	975125	0	0
45791360	791967	0	0
45793563	1153428	0	0
45895651	1107830	0	0
45794459	1125315	0	0
45794225	1107882	2	3
4047779	4048695	5	8
1307863	1307863	0	0
21500541	708298	4	4
1101539	1115171	2	3
35508513	1125315	0	0
36157982	1119510	0	0
36155443	1125315	0	0
36703500	378001	5	8
42804251	19077344	2	3
44349779	975125	0	0
42535580	42535580	0	0
44350492	1125315	0	0
45662410	1177480	0	0
44362534	1521369	0	0
45627888	1125315	0	0
45644457	975125	0	0
45639379	1717327	0	0
45637158	19079524	1	1
45680463	1107830	0	0
45704570	1174888	0	0
45639886	1548195	0	0
45783845	1545958	0	0
45782501	1539403	0	0
45672470	40169216	2	3
45678869	1177480	0	0
45790207	1322184	0	0
46238444	1545958	0	0
45791484	1521369	0	0
45793497	1110410	0	0
45895741	1107830	0	0
46312374	1125315	0	0
45799812	19078461	2	3
4047779	134438	4	6
1310034	1310034	0	0
21500541	791967	4	4
1101539	19019273	2	3
35508513	738818	0	0
36158165	1153428	0	0
36155353	1125315	0	0
36516972	4155034	5	5
42801688	40223834	2	3
44349781	1112807	0	0
42529093	3023103	1	1
44346388	1125315	0	0
45662692	1177480	0	0
44362669	1738521	0	0
45628275	1125315	0	0
45644446	975125	0	0
45639380	1500211	0	0
45664480	19079524	1	1
45680569	1149196	0	0
45704965	738818	0	0
45639997	1149196	0	0
45784300	1539403	0	0
45782490	791967	0	0
45672496	46275916	2	3
45678920	1177480	0	0
45789926	1174888	0	0
46238452	1741122	0	0
45791484	19127890	0	0
45793576	723013	0	0
45895742	791967	0	0
46312108	1125315	0	0
45802517	19078461	2	3
4047779	257012	4	7
1310149	1310149	0	0
21500648	1125315	4	4
1101539	19078461	2	3
35508513	1119510	0	0
36158236	1177480	0	0
36155356	1125315	0	0
36503290	40479422	5	5
42801655	40169216	2	3
44349794	738818	0	0
42529414	3051031	1	1
44346468	1125315	0	0
45662823	1177480	0	0
44362512	1115008	0	0
45628278	1125315	0	0
45641555	975125	0	0
45639252	1107830	0	0
45659018	19079524	1	1
45680658	1713332	0	0
45704893	1551099	0	0
45640009	1107830	0	0
45784000	975125	0	0
45782610	738818	0	0
45672592	40163554	2	3
45678952	1177480	0	0
45789810	738818	0	0
46238756	1112807	0	0
45791484	1549786	0	0
45793556	1310149	0	0
45895782	975125	0	0
46312304	1125315	0	0
45788704	1107882	2	3
4047779	4132546	4	7
1309944	1309944	0	0
21500648	1112807	4	4
1101498	1115171	2	3
35508515	1119510	0	0
36156508	738818	0	0
36155369	1125315	0	0
36503290	40479768	5	5
42801661	43012036	2	3
44349799	1153428	0	0
42529473	3049273	1	1
44346471	1125315	0	0
45662652	1177480	0	0
44362687	1589505	0	0
45626120	1125315	0	0
45641601	975125	0	0
45640143	1192710	0	0
45634139	46275916	1	1
45680658	1759842	0	0
45704655	1738521	0	0
45639846	708298	0	0
45784103	1115008	0	0
45782614	1551099	0	0
45784260	19074843	2	3
45706690	1129625	0	0
45789936	19127890	0	0
46238591	1367571	0	0
45791413	1713332	0	0
45793675	1332418	0	0
45895681	1557272	0	0
46312314	1125315	0	0
45795974	19078461	2	3
4047779	255848	4	7
975125	975125	0	0
21600959	1322184	4	4
1101498	19019273	2	3
35508564	1177480	0	0
36156508	1112807	0	0
36155370	1125315	0	0
36516993	4048171	5	5
42801819	920334	2	3
44349474	975125	0	0
42902167	42902245	1	1
44346140	1125315	0	0
45662563	1177480	0	0
44362687	1549786	0	0
45626196	1125315	0	0
45638248	975125	0	0
45640218	1343916	0	0
45662193	46275916	1	1
45680666	1367571	0	0
45704869	742185	0	0
45639892	1115008	0	0
45783928	1192710	0	0
45782623	1154343	0	0
45784262	40229134	2	3
45706866	1129625	0	0
45789936	1549786	0	0
46238543	1738521	0	0
45791413	1759842	0	0
45793612	1589505	0	0
45895685	1589505	0	0
46312241	1125315	0	0
46295431	1332419	2	3
4047779	28060	4	7
255848	255848	0	0
21600959	1595799	4	4
1101498	19019979	2	3
35508781	1125315	0	0
36156510	738818	0	0
36155371	1125315	0	0
36516993	4296204	4	5
42804111	19078924	2	3
44349475	1124957	0	0
42902242	42902245	1	1
44346648	1125315	0	0
45661232	1177480	0	0
44362791	1149196	0	0
45626200	1125315	0	0
45640224	975125	0	0
45640221	1738521	0	0
45662193	19079524	1	1
45680574	738818	0	0
45704870	738818	0	0
45639939	1539403	0	0
45783933	1154029	0	0
45782624	1000560	0	0
45784280	40229134	2	3
45705372	1129625	0	0
45790219	1112807	0	0
46238548	1149196	0	0
45791325	1149196	0	0
45793681	1149196	0	0
45895743	1713332	0	0
46312329	1125315	0	0
46244425	1107882	2	3
4047779	40481087	4	7
4024958	4024958	0	0
21503444	1125315	4	4
4030660	4242997	3	3
35508781	1119510	0	0
36156510	1119510	0	0
36155525	1125315	0	0
36302167	439777	4	5
42806182	43012036	2	3
44349646	1149196	0	0
42902243	42902245	1	1
44346749	1125315	0	0
45661538	1177480	0	0
44362482	967823	0	0
45626171	1125315	0	0
45638456	975125	0	0
45640219	1332418	0	0
45634034	19079524	1	1
45680575	1326303	0	0
45704798	1539403	0	0
45640035	1768849	0	0
45784063	1115008	0	0
45769019	45769019	0	0
45784341	1551192	2	3
45779955	1129625	0	0
45789814	1174888	0	0
46238826	1192710	0	0
45791166	1539403	0	0
45793779	1192710	0	0
45895743	1759842	0	0
46312444	1125315	0	0
45801884	1107882	2	3
4047779	80180	4	4
4015189	4015189	0	0
21503444	1595799	4	4
4133169	4330583	3	3
35508713	1125315	0	0
36156510	1112807	0	0
36155483	1125315	0	0
36516993	134438	4	4
42806129	1154615	2	3
44349483	1332418	0	0
42801873	19128009	2	2
44346575	1125315	0	0
45661457	1177480	0	0
44354914	975125	0	0
45626219	1125315	0	0
45638538	975125	0	0
45640176	1153428	0	0
45622385	19079524	1	1
45680579	738818	0	0
45704899	723013	0	0
45639727	738818	0	0
45784121	1713332	0	0
45702582	1192710	0	0
45784361	1115171	2	3
45779959	1129625	0	0
45790167	1501700	0	0
46238827	1192710	0	0
45791421	1192710	0	0
45793785	1557272	0	0
45801999	1738521	0	0
46312506	1125315	0	0
46241863	1107882	2	3
4047779	4051466	4	4
4166224	4166224	0	0
21503444	1308738	4	4
4133169	4117038	3	3
35508713	1119510	0	0
36156274	1107830	0	0
36155491	1125315	0	0
36703458	378419	4	4
42806260	19073188	2	3
44349975	1112807	0	0
42529086	3023103	2	2
44346533	1125315	0	0
45659352	1177480	0	0
44355002	740275	0	0
45626132	1125315	0	0
45635184	975125	0	0
45640244	1000560	0	0
45621246	19079524	1	1
45680868	1307863	0	0
45705006	1343916	0	0
45639827	705944	0	0
45784227	920293	0	0
45702588	19127890	0	0
45784480	19123231	2	3
45779870	1129625	0	0
45790175	1192710	0	0
46238830	1192710	0	0
45791423	933724	0	0
45793725	1759842	0	0
45801965	1102527	0	0
46312567	1125315	0	0
46297929	1107882	2	3
4047779	80809	4	5
4149245	4149245	0	0
21503444	1396131	4	4
4300244	4323902	3	3
35508273	1177480	0	0
36156512	1738521	0	0
36155507	1125315	0	0
36503290	4149245	4	4
42806262	19133905	2	3
44349977	1738521	0	0
42529086	3016723	2	2
44346764	1125315	0	0
45659395	1177480	0	0
44355007	1000560	0	0
45626137	1125315	0	0
45635608	975125	0	0
45635777	723013	0	0
45621246	46275916	1	1
45680779	1501700	0	0
45704970	738818	0	0
45640122	1713332	0	0
45784073	1309944	0	0
45702588	1512674	0	0
45784392	40162522	2	3
45780030	1129625	0	0
45790178	1124300	0	0
46238831	1192710	0	0
45791490	1738521	0	0
45793835	1309944	0	0
45801907	723013	0	0
46312600	1125315	0	0
46289431	1107882	2	3
4047779	80502	4	5
4180628	378001	6	8
21503444	967823	4	4
4176642	4246502	3	3
21602553	1521369	0	0
36154202	1174888	0	0
36155581	1125315	0	0
36302166	42535580	4	4
42806288	19018935	2	3
44349990	708298	0	0
42888893	196456	3	3
44346776	1125315	0	0
45659680	1177480	0	0
44355043	1124300	0	0
45626139	1125315	0	0
45632565	975125	0	0
45635780	1124300	0	0
45622175	19079524	1	1
45680427	1149196	0	0
45704971	1343916	0	0
45685910	740275	0	0
45784130	723013	0	0
45702588	1549786	0	0
45784457	40229134	2	3
45706104	1129625	0	0
45789990	1308738	0	0
46238565	1153428	0	0
45791435	1713332	0	0
45793832	1738521	0	0
45802021	705944	0	0
46312473	1125315	0	0
45790487	1332419	2	3
4047779	4116491	4	5
253549	4230399	6	7
21503444	1192710	4	4
141960	134438	3	3
21603992	1118084	0	0
36154202	1125315	0	0
36155637	1125315	0	0
36516728	4048695	4	4
42806345	40224805	2	3
44349993	1174888	0	0
42888894	4037675	5	5
44346782	1125315	0	0
45656432	1177480	0	0
44354751	1549786	0	0
45626262	1125315	0	0
45632627	975125	0	0
45635793	1115008	0	0
45628735	19079524	1	1
45680810	1115008	0	0
45704911	1322184	0	0
45685855	1149196	0	0
45784239	738818	0	0
45702570	1115008	0	0
45784435	1115171	2	3
45706356	1129625	0	0
45789992	738818	0	0
46238599	1332418	0	0
45791430	1713332	0	0
45793520	1153428	0	0
45802024	914335	0	0
46312829	1125315	0	0
45790668	40223768	2	3
4047779	40486433	4	8
4180628	4059173	6	7
21503146	753626	4	4
4034850	40478878	3	3
21604051	1124300	0	0
36154216	1177480	0	0
36155609	1125315	0	0
36516728	4059173	4	4
42806426	19133905	2	3
44349996	1515774	0	0
43530877	40479422	6	7
44346685	1125315	0	0
45656257	1177480	0	0
44354751	1589505	0	0
45626344	1125315	0	0
45632481	975125	0	0
45635794	1154343	0	0
45620864	19079524	1	1
45680816	975125	0	0
45705013	1124300	0	0
45685829	738818	0	0
45784240	1115008	0	0
45702633	1174888	0	0
45782211	40232448	2	3
45706296	1129625	0	0
45789995	1551099	0	0
46238603	19010482	0	0
45791430	1759842	0	0
45793637	967823	0	0
45802028	1149196	0	0
46312831	1125315	0	0
45801126	40223768	2	3
4047779	4149245	4	8
4101796	378001	6	6
21503146	1343916	4	4
4077953	4043071	3	3
21602848	1728416	0	0
36154234	1545958	0	0
36155749	1125315	0	0
36516728	4066995	4	4
42806320	40231925	2	3
44349996	1549786	0	0
40490903	4107731	5	5
44346617	1125315	0	0
45656611	1177480	0	0
44354755	914335	0	0
45626338	1125315	0	0
45632707	975125	0	0
45635850	1305058	0	0
45646249	19079524	1	1
45680821	1149196	0	0
45705018	738818	0	0
45685807	705944	0	0
45784234	1322184	0	0
45702644	1110410	0	0
45782335	19133873	2	3
45699742	1129625	0	0
45789996	1332418	0	0
46238604	1107830	0	0
45791438	967823	0	0
45793683	1124300	0	0
45802002	1153428	0	0
46306958	1125315	0	0
46242114	1107882	2	3
4047779	4294548	4	8
4086921	4324181	6	6
21503146	1154029	4	4
4172515	4035793	3	3
21602849	1728416	0	0
36154247	1000560	0	0
36102977	198199	1	3
36516728	4278672	4	4
42803988	40229134	2	3
44350007	1713332	0	0
43531052	4166224	5	6
44346665	1125315	0	0
45656538	1177480	0	0
44354711	1545958	0	0
45626305	1125315	0	0
45629387	975125	0	0
45635901	1310149	0	0
45643148	19079524	1	1
45680785	715997	0	0
45705026	791967	0	0
45685816	1310149	0	0
45784081	1107830	0	0
45702843	791967	0	0
45782221	43012036	2	3
45699917	1129625	0	0
45790022	1738521	0	0
46238667	1174888	0	0
45791564	1192710	0	0
45793640	1124300	0	0
45802013	1102527	0	0
46307109	1125315	0	0
45790359	40228214	2	3
4047779	260139	4	8
4086921	4163874	7	7
21503146	19039298	4	4
4300185	4337138	3	3
21602823	1713332	0	0
36154249	1125315	0	0
36110715	4112343	1	3
36516972	4146173	1	7
42804038	1551192	2	3
44349953	1000560	0	0
45655713	19079524	1	1
44346667	1125315	0	0
45656382	1177480	0	0
44355050	1115008	0	0
45626381	1125315	0	0
45629502	975125	0	0
45635907	738818	0	0
45628496	19079524	1	1
45680430	967823	0	0
45704912	791967	0	0
45685817	1551099	0	0
45784297	1322184	0	0
45702850	1107830	0	0
45782357	19008572	2	3
45699843	1129625	0	0
45790025	1501700	0	0
46238779	1107830	0	0
45791565	975125	0	0
45793690	1149196	0	0
45802018	1115008	0	0
46312038	1125315	0	0
45893834	19078461	2	3
4047779	440448	4	9
253549	78272	7	8
21503146	19002770	4	4
4042673	4057420	3	3
36009742	4102123	0	0
36154211	1177480	0	0
36110715	4294548	1	3
36228634	19045231	1	2
42803681	19018935	2	3
44350195	914335	0	0
45655713	46275916	1	1
44346713	1125315	0	0
45656647	1177480	0	0
44355079	1149196	0	0
45626312	1125315	0	0
45629503	975125	0	0
45636072	1153428	0	0
45625376	19079524	1	1
45680708	1305058	0	0
45704934	967823	0	0
45685876	740275	0	0
45783942	1149196	0	0
45702595	967823	0	0
45782368	1115171	2	3
45699851	1129625	0	0
45790118	19003953	0	0
46238782	723013	0	0
45791447	1717327	0	0
45793536	1738521	0	0
45802039	1115008	0	0
46312066	1125315	0	0
46242267	19075601	2	3
4047779	4112343	4	9
253549	4134304	7	8
21503146	708298	4	4
4185916	4047491	3	3
36009768	133834	0	0
36154250	1129625	0	0
36102977	4056621	3	3
36228635	19045231	1	2
42804049	40162522	2	3
44350196	1515774	0	0
45620644	19079524	1	1
44346715	1125315	0	0
45652927	1177480	0	0
44355017	1124300	0	0
45622799	1125315	0	0
45629585	975125	0	0
45636073	791967	0	0
45643249	19079524	1	1
45680553	1115008	0	0
45701268	738818	0	0
45685792	967823	0	0
45781904	723013	0	0
45702476	1000560	0	0
45782544	19073188	2	3
45693338	1129625	0	0
45790231	1154343	0	0
46238639	1501700	0	0
45791443	1149196	0	0
45793725	1713332	0	0
45801970	1367571	0	0
46307337	1125315	0	0
46291822	19078461	2	3
4047779	78272	4	10
255919	4048171	7	9
21503146	782043	4	4
4179871	45769019	3	3
36009735	134438	0	0
36154250	1125315	0	0
36110704	4048171	3	3
36230662	19074679	1	2
42804051	1551192	2	3
44350196	19127890	0	0
45655577	46275916	1	1
44346717	1125315	0	0
45653162	1177480	0	0
44355020	1124300	0	0
45622808	1125315	0	0
45631323	975125	0	0
45636004	1539403	0	0
45637536	19079524	1	1
45680713	1154343	0	0
45701270	1149380	0	0
45685959	1115008	0	0
45781883	1308738	0	0
45702608	1551099	0	0
45782509	19078924	2	3
45693460	1129625	0	0
45790095	1309944	0	0
46238651	967823	0	0
45791545	791967	0	0
45793618	1501700	0	0
45801909	1545958	0	0
46307154	1125315	0	0
45895785	19078461	2	3
4180628	317009	2	2
4028071	81893	8	9
21500223	1332418	4	4
21500594	19078461	5	6
36009691	439406	0	0
36154251	1326303	0	0
36110712	258780	3	3
36230663	19074679	1	2
42804058	19133905	2	3
44350196	1549786	0	0
45655577	19079524	1	1
44346518	1125315	0	0
45653416	1177480	0	0
44355081	715997	0	0
45622756	1125315	0	0
45631233	975125	0	0
45636101	1548195	0	0
45631399	19079524	1	1
45680729	1110410	0	0
45701144	1153428	0	0
45685941	1174888	0	0
45781941	1115008	0	0
45702744	1000560	0	0
45782537	1551192	2	3
45693726	1129625	0	0
45790087	1112807	0	0
46238615	1738521	0	0
45791500	1124957	0	0
45793630	975125	0	0
45802092	1000560	0	0
46307165	1125315	0	0
45804071	19075601	2	3
4180628	4066995	4	7
77960	40479422	5	5
21500223	1307863	4	4
21500594	19019273	5	6
36009700	317009	0	0
36154236	1545958	0	0
36110570	40481087	3	3
36230245	43012433	1	2
42805404	19073183	2	3
44349970	1177480	0	0
45655710	19079524	1	1
44346146	1125315	0	0
45653317	1177480	0	0
44355108	1149380	0	0
45622760	1125315	0	0
45626642	975125	0	0
45636101	1515774	0	0
44782620	4152936	4	4
45680731	1124957	0	0
45701163	791967	0	0
45685643	1713332	0	0
45781891	1154343	0	0
45702651	738818	0	0
45782238	1115171	2	3
45693728	1129625	0	0
45790003	1367571	0	0
46238619	705944	0	0
45791292	975125	0	0
45793641	1115008	0	0
45802049	975125	0	0
46307380	1125315	0	0
45893835	19078461	2	3
4180628	261325	4	7
77960	40479768	5	5
21506125	19074679	1	1
21500594	1115171	5	6
36211457	4296205	0	0
36154238	1129625	0	0
35702118	192671	3	3
36230246	43012433	1	2
42804107	1551192	2	3
44350162	1177480	0	0
45620721	19079524	1	1
44346830	1125315	0	0
45652950	1177480	0	0
44355109	1154343	0	0
45622910	1125315	0	0
45626727	975125	0	0
45636106	19010482	0	0
44782620	4035415	3	3
45680669	967823	0	0
45701272	738818	0	0
45685613	1174888	0	0
45781967	738818	0	0
45702652	738818	0	0
45782419	19008572	2	3
45693792	1129625	0	0
45790021	1124957	0	0
46238624	757627	0	0
46298711	1192710	0	0
45793642	1115008	0	0
45802050	1153428	0	0
46307219	1125315	0	0
45795943	19079524	2	3
4180628	4112343	4	8
432795	4218389	5	5
21003454	19127904	1	1
21500594	19019979	5	6
36211458	4299128	0	0
36154239	1129625	0	0
36212270	19074679	1	2
36232608	19132304	1	2
42801330	920300	2	3
44350168	1192710	0	0
45620545	19127918	1	1
44346820	1125315	0	0
45653452	1177480	0	0
44355113	1107830	0	0
45623138	1125315	0	0
45623534	975125	0	0
45636093	1326303	0	0
44782620	4059173	3	3
45680856	1124957	0	0
45701275	1154029	0	0
45686077	1000560	0	0
45781971	1110410	0	0
45702653	738818	0	0
45702528	40232448	2	3
45693797	1129625	0	0
45790106	1000560	0	0
46238750	1110410	0	0
46298597	1124300	0	0
45793650	1153428	0	0
45802065	1307863	0	0
46307226	1125315	0	0
45789181	40174880	2	3
4180628	78272	4	9
4021667	4230399	5	5
21003454	19132304	1	1
21503082	920334	6	7
36152830	1545958	0	0
36154240	1192710	0	0
36212774	40229134	1	2
36516728	80502	1	1
42801389	1551192	2	3
44350168	1112807	0	0
45620365	46275916	1	1
44346288	1125315	0	0
45649921	1177480	0	0
44355149	1548195	0	0
45623148	1125315	0	0
45623361	975125	0	0
45636126	1361711	0	0
44782620	4109685	3	3
45680672	1115008	0	0
45701250	1548195	0	0
45686080	1332418	0	0
45782117	19003953	0	0
45702691	1343916	0	0
45702589	1127433	2	3
45690632	1129625	0	0
45790188	738818	0	0
46238658	1149196	0	0
46298600	1000560	0	0
45793793	1000560	0	0
45801915	975125	0	0
46307235	1125315	0	0
45788721	19075601	2	3
1589505	19132304	2	3
4021667	4156265	5	5
21003454	19127918	1	1
21503082	920300	6	7
36152833	975125	0	0
36154240	1125315	0	0
36212775	40229134	1	2
36427424	1127433	2	3
43053690	4142905	2	3
44349485	1112807	0	0
45620543	46275916	1	1
44346299	1125315	0	0
45649621	1177480	0	0
44355154	1110410	0	0
45623153	1125315	0	0
45623569	975125	0	0
45636097	1174888	0	0
44782620	81151	3	4
45680674	1000560	0	0
45701129	1713332	0	0
45685619	738818	0	0
45781925	1118084	0	0
45702543	1174888	0	0
45702472	40232448	2	3
45690678	1129625	0	0
45787360	1149380	0	0
46238788	1738521	0	0
46298265	1539403	0	0
45793762	1539403	0	0
45802100	1501700	0	0
46307417	1125315	0	0
46295242	19075601	2	3
1500211	40224132	2	3
441840	4116491	6	8
21003454	19128065	1	1
21503082	40236824	6	7
36152772	1177480	0	0
36154241	1125315	0	0
36220586	40169281	1	2
36427424	40231925	2	3
43053690	40480160	2	3
44350206	1332418	0	0
44347714	40220386	1	1
44346790	1125315	0	0
45649758	1177480	0	0
44355164	705944	0	0
45622880	1125315	0	0
45667941	975125	0	0
45636223	1551099	0	0
44782620	40479768	5	5
45682498	1124957	0	0
45701208	1174888	0	0
45686089	1124300	0	0
45781929	967823	0	0
45702546	738818	0	0
45702608	1551192	2	3
45690659	1129625	0	0
45787360	1137529	0	0
46238818	975125	0	0
46298741	1343916	0	0
45793839	1149196	0	0
45802103	19039298	0	0
46307974	1125315	0	0
45893837	19078461	2	3
1500211	40224805	2	3
441840	4146173	6	10
21003454	19128009	1	1
21503146	19078924	6	7
36152895	1177480	0	0
36154241	1112807	0	0
36221037	19132304	1	2
36427424	40229134	2	3
42806227	1154615	2	3
44349882	1115008	0	0
44347911	19129144	1	1
44346792	1125315	0	0
45649962	1177480	0	0
44354976	738818	0	0
45623190	1125315	0	0
45665476	975125	0	0
45636145	1551099	0	0
44782620	40479422	5	5
45682455	1149196	0	0
45701214	1107830	0	0
45686174	740275	0	0
45782076	1549786	0	0
45702548	1192710	0	0
45702651	40229134	2	3
45690704	1129625	0	0
45787436	738818	0	0
46240079	1115008	0	0
46298529	1500211	0	0
45793657	708298	0	0
45801973	1107830	0	0
46307593	1125315	0	0
45801852	19078461	2	3
1361711	19126352	2	3
441840	4001336	6	10
21003454	19127922	1	1
21503146	782047	6	7
36153082	1125315	0	0
36154242	1119510	0	0
36221037	46221626	1	2
36427424	40162522	2	3
42806380	1115171	2	3
44349896	1124300	0	0
44347911	19127922	1	1
44346601	1125315	0	0
45651888	1177480	0	0
44355138	738818	0	0
45623090	1125315	0	0
45665711	975125	0	0
45644673	40228214	2	3
44783379	4301346	3	4
45682544	1713332	0	0
45701219	1713332	0	0
45686201	1153428	0	0
45782076	1518198	0	0
45702852	1174888	0	0
45702660	19019273	2	3
45690884	1129625	0	0
45787441	1112807	0	0
46240157	975125	0	0
46298416	1118084	0	0
45793798	1309944	0	0
45802056	1545958	0	0
46307545	1125315	0	0
45897887	19079524	2	3
1107830	1107882	2	3
441840	81151	6	11
21003454	19128263	1	1
21500582	40162522	6	7
36153148	975125	0	0
36154242	1125315	0	0
36223222	19123231	1	2
36427424	19133768	2	3
42801515	920334	2	3
44350088	738818	0	0
44347911	19133679	1	1
44346608	1125315	0	0
45646852	1177480	0	0
44355091	1322184	0	0
45623019	1125315	0	0
45665520	975125	0	0
45663443	40228214	2	3
45622194	19128009	3	4
45682560	1326303	0	0
45701219	1759842	0	0
45637423	1174888	0	0
45781946	1174888	0	0
45702853	1396131	0	0
45702941	40162522	2	3
45690955	1129625	0	0
45787441	1192710	0	0
46240158	1115008	0	0
46298601	1309944	0	0
45793799	1115008	0	0
45801919	738818	0	0
46307312	1125315	0	0
46297643	19079524	2	3
1107830	19125062	2	3
441840	258780	6	11
21003454	43012433	1	1
21500574	19019273	6	7
36153037	1112807	0	0
36154233	1545958	0	0
36223223	19123231	1	2
36427424	1127078	2	3
42806225	40236446	2	3
44349498	1149380	0	0
44348134	19074679	1	1
44348442	1125315	0	0
45646891	1177480	0	0
44354937	1107830	0	0
45623037	1125315	0	0
45665875	975125	0	0
45647507	19078461	2	3
45620913	19128022	3	4
45680883	1759842	0	0
45701221	791967	0	0
45637226	1149196	0	0
45781990	1738521	0	0
45702725	1343916	0	0
45702922	40163554	2	3
45687759	1129625	0	0
45787443	1112807	0	0
46240163	1000560	0	0
46298488	1174888	0	0
45793803	1738521	0	0
45801922	975125	0	0
46307523	1125315	0	0
46317471	19018935	2	3
701322	40222846	2	3
441840	4230399	6	11
21003454	40221415	1	1
21502709	40169216	9	10
36153265	975125	0	0
36154338	1738521	0	0
36223455	1551192	1	2
36422418	19073188	2	3
42806596	19019273	2	3
44350066	1192710	0	0
45661980	46275916	1	1
44348446	1125315	0	0
45647082	1177480	0	0
44354940	738818	0	0
45623103	1125315	0	0
45659836	975125	0	0
45648066	19078461	2	3
45664748	19127918	3	4
45680905	1154029	0	0
45701166	1539403	0	0
45637234	1115008	0	0
45781992	975125	0	0
45702696	1174888	0	0
45702755	40232448	2	3
45687734	1129625	0	0
45787475	738818	0	0
46240036	1000560	0	0
46298488	1192710	0	0
45793581	967823	0	0
45801976	1115008	0	0
46307204	1125315	0	0
46317726	40236824	2	3
1396131	19077344	2	3
441840	4296204	6	9
21003454	42902245	1	1
21502709	19112599	9	10
36153330	1125315	0	0
36154305	1125315	0	0
36221044	40236446	1	2
36422418	1713671	2	3
42806471	19019273	2	3
44350071	1192710	0	0
45661813	46275916	1	1
44348381	1125315	0	0
45647141	1177480	0	0
44354949	738818	0	0
45623232	1125315	0	0
45659982	975125	0	0
45651063	19078461	2	3
45662172	19127922	3	4
45680887	1738521	0	0
45701358	967823	0	0
45637237	920293	0	0
45782121	738818	0	0
45702558	1192710	0	0
45702902	19019273	2	3
45688505	1129625	0	0
45787477	1343916	0	0
45897591	1501700	0	0
46298494	1154343	0	0
45793819	1308738	0	0
45802093	723013	0	0
46307210	1125315	0	0
46319831	1551192	2	3
1115008	1115171	2	3
441840	4306014	6	7
21003454	19133679	1	1
21502709	40223821	9	10
36152839	1119510	0	0
36154366	1149196	0	0
36220458	19077572	1	2
36422348	1332419	2	3
42806134	19019273	2	3
44350077	1177480	0	0
45658006	40220386	1	1
44348382	1125315	0	0
45647179	1177480	0	0
44355051	738818	0	0
45625063	1125315	0	0
45660004	975125	0	0
45641956	19078461	2	3
44784102	195588	3	3
45677361	708298	0	0
45701361	1713332	0	0
45637300	1153428	0	0
45781948	1551099	0	0
45702659	1738521	0	0
45702908	1545959	2	3
45684544	1129625	0	0
45787244	1548195	0	0
45897693	1551099	0	0
46298723	1107830	0	0
45793761	1557272	0	0
45802059	1115008	0	0
46307802	1125315	0	0
46319409	19019273	2	3
1115008	19019273	2	3
441840	439406	6	7
21003454	19128022	1	1
21502709	40232448	9	10
36153428	1112807	0	0
36154259	1177480	0	0
36219948	19077344	1	2
36428377	1154615	2	3
42801396	1551192	2	3
44350095	1112807	0	0
45655823	1127433	1	1
44342672	1125315	0	0
45646890	1177480	0	0
44355180	1738521	0	0
45624908	1125315	0	0
45660142	975125	0	0
45624105	19078461	2	3
44783028	4146173	3	3
45677232	1501700	0	0
45701365	1192710	0	0
45637333	1308738	0	0
45782095	1549786	0	0
45702660	1115008	0	0
45696704	19018935	2	3
45684670	1129625	0	0
45787244	1589505	0	0
45897787	1149380	0	0
46298603	1361711	0	0
45793588	975125	0	0
45801984	1115008	0	0
46307804	1125315	0	0
45895578	1127433	2	3
708298	19078924	2	3
441840	4285898	5	12
21003454	19129144	1	1
21502709	1343916	7	7
36152839	1125315	0	0
36154261	1118084	0	0
36220457	19077572	1	2
36423716	1713671	2	3
42804080	19075001	2	3
44350097	920293	0	0
45649227	46275916	1	1
44342766	1125315	0	0
45644062	1177480	0	0
44355183	1107830	0	0
45625112	1125315	0	0
45659741	975125	0	0
45657582	19078461	2	3
44783378	4301346	3	3
45677354	1310149	0	0
45701379	1501700	0	0
45636684	1115008	0	0
45782095	19127890	0	0
45702790	1192710	0	0
45696779	40174880	2	3
45684672	1129625	0	0
45787256	738818	0	0
45897870	1192710	0	0
46298941	1551099	0	0
45793669	1174888	0	0
45802072	1153428	0	0
46307681	1125315	0	0
45895645	40231925	2	3
1580955	40223768	2	3
3049150	3036780	2	2
21003454	46221626	1	1
21502709	738818	7	7
36153096	1125315	0	0
36154284	1551099	0	0
36220587	40169216	1	2
36424953	40169281	2	3
42806332	1551192	2	3
44350127	738818	0	0
45661643	19079524	1	1
44342777	1125315	0	0
45643952	1177480	0	0
44354970	1545958	0	0
45625018	1125315	0	0
45649377	1192710	0	0
45644825	19078461	2	3
44782619	4230399	3	3
45677390	738818	0	0
45701230	1124300	0	0
45636693	1107830	0	0
45782095	1512674	0	0
45702941	1174888	0	0
45696780	19008572	2	3
45684588	1129625	0	0
45787257	1107830	0	0
45897873	1738521	0	0
46298902	933724	0	0
45788431	1738521	0	0
45802125	1118084	0	0
46307367	1125315	0	0
45895741	1107882	2	3
914335	40243436	2	3
3049150	3023430	2	2
21002475	19128009	1	1
21502709	1150770	7	7
36153096	1119510	0	0
36154293	1124957	0	0
36223225	1545959	1	2
36424953	40169216	2	3
42804295	19019273	2	3
44349832	933724	0	0
45649244	19079524	1	1
44342760	1125315	0	0
45644041	1177480	0	0
44355055	975125	0	0
45623280	1125315	0	0
45649348	1192710	0	0
45644383	19078461	2	3
44782503	4301346	3	3
45677492	1115008	0	0
45701292	1124957	0	0
45636777	1545958	0	0
45781919	1192710	0	0
45702954	1548195	0	0
45672469	19019273	2	3
45684612	1129625	0	0
45787373	1149196	0	0
45897686	1310149	0	0
46298586	1310149	0	0
45788233	1000560	0	0
45802252	1192710	0	0
46302204	1125315	0	0
45876029	3005136	2	3
1129625	40232448	2	3
3049209	3023430	2	2
21002475	42902245	1	1
21502709	1125443	7	7
36153335	1177480	0	0
36154294	1551099	0	0
36223224	1545959	1	2
36424954	40169216	2	3
42804522	19019273	2	3
44349839	1174888	0	0
44345811	46275916	1	1
44342762	1125315	0	0
45644121	1177480	0	0
45655591	708298	0	0
45621487	1125315	0	0
45649300	1192710	0	0
45639138	19078461	2	3
45651648	19127918	2	2
45677651	1124300	0	0
45701293	1107830	0	0
45636717	715997	0	0
45782045	1149380	0	0
45702958	1501700	0	0
45784027	46233710	2	3
45684601	1129625	0	0
45787380	967823	0	0
45897778	1713332	0	0
46298593	975125	0	0
45788547	975125	0	0
45802083	705944	0	0
46302376	1125315	0	0
45876029	3036780	2	3
1192710	43012036	2	3
3049209	3005136	2	2
21001669	1551192	2	3
21502709	1107830	7	7
36153336	1115008	0	0
36154295	1551099	0	0
36214108	19019979	1	2
36424954	40169281	2	3
42807080	19123231	2	3
44349852	1112807	0	0
44345863	46275916	1	1
44342788	1125315	0	0
45644145	1177480	0	0
45655496	1501700	0	0
45621511	1125315	0	0
45649453	1192710	0	0
45668005	19078461	2	3
45651648	19128009	2	2
45677657	914335	0	0
45701177	1713332	0	0
45636721	1501700	0	0
45782122	1322184	0	0
45702960	1501700	0	0
45680007	19078924	2	3
45681727	1129625	0	0
45787196	738818	0	0
45897716	1110410	0	0
46299300	1000560	0	0
45788186	975125	0	0
45802085	1124300	0	0
46302151	1125315	0	0
45876029	3023430	2	3
1713332	1713671	2	3
3049209	3036780	2	2
21002326	1713671	2	3
21502709	967823	7	7
36153337	1125315	0	0
36154288	1154343	0	0
36214108	19078461	1	2
36426127	40174880	2	3
42804313	19019273	2	3
44350009	1177480	0	0
43530876	4329847	1	1
44343084	1125315	0	0
45644192	1177480	0	0
45655537	975125	0	0
45629763	43012036	2	3
45632050	1192710	0	0
45629789	19078461	2	3
45624185	19128022	2	2
45677408	1307863	0	0
45701177	1759842	0	0
45636757	1738521	0	0
45782065	1174888	0	0
45702813	738818	0	0
45672259	46233988	2	3
45681844	1129625	0	0
45787197	1154343	0	0
45897837	1332418	0	0
46298946	1343916	0	0
45788553	705944	0	0
45802088	723013	0	0
46301861	1125315	0	0
45876033	3015632	2	3
1713332	19073183	2	3
3049219	3036780	2	2
21002731	46233988	2	3
21502709	1137529	7	7
36153337	1119510	0	0
36154304	1149196	0	0
36214107	19019979	1	2
36428442	1539411	2	3
42803971	1545959	2	3
44350190	1501700	0	0
44786912	3023103	1	1
44342925	1125315	0	0
45644096	1177480	0	0
45655137	1539403	0	0
45629739	19133905	2	3
45632255	1192710	0	0
45657322	19078461	2	3
45639424	19128022	2	2
45677428	1153428	0	0
45701181	1501700	0	0
45636758	1124300	0	0
45782071	1521369	0	0
45702920	1539403	0	0
45672259	46233710	2	3
45681790	1129625	0	0
45787269	738818	0	0
45897665	1192710	0	0
46298948	1551099	0	0
45788357	1738521	0	0
45802152	738818	0	0
46302300	1125315	0	0
45876033	3023103	2	3
1110410	35605858	2	3
3050400	3005136	2	2
21002731	46233710	2	3
21500120	1512674	7	7
36153338	1589505	0	0
36154402	791967	0	0
36214107	19078461	1	2
36422432	19129655	2	3
42804110	1545959	2	3
44350146	1177480	0	0
44786936	3051031	1	1
44342931	1125315	0	0
45644227	1177480	0	0
45655588	933724	0	0
45629739	19133873	2	3
45632125	1192710	0	0
45657391	19078461	2	3
45634966	40174880	2	3
45677496	1307863	0	0
45701184	1107830	0	0
45636773	1000560	0	0
45782099	1149196	0	0
45702922	1310149	0	0
45672298	19078461	2	3
45681973	1129625	0	0
45787533	1107830	0	0
45897781	1332418	0	0
46298769	1149196	0	0
45788401	1107830	0	0
45802062	1545958	0	0
46302389	1125315	0	0
45876033	3014576	2	3
1112807	19059056	2	3
3050400	3036780	2	2
21003385	1551192	2	3
21502620	19133873	7	8
36153339	1112807	0	0
36154341	1125315	0	0
36110229	433125	0	1
36426182	19132304	2	3
42804254	1545959	2	3
44350148	1112807	0	0
44816088	44816277	1	1
44343091	1125315	0	0
45641011	1177480	0	0
45655217	1149196	0	0
45629775	19019273	2	3
45631870	1192710	0	0
45635578	19078461	2	3
45635001	1115171	2	3
45677506	1000560	0	0
45703455	1501700	0	0
45636821	791967	0	0
45782056	1174888	0	0
45702931	967823	0	0
45699371	19075001	2	3
45681950	1129625	0	0
45787535	742185	0	0
45897864	1174888	0	0
46298783	1501700	0	0
45788312	1124957	0	0
45802165	1545958	0	0
46302395	1125315	0	0
45876033	3027970	2	3
1119510	40229134	2	3
3050400	3023430	2	2
21003393	1551192	2	3
21502620	19073188	7	8
36153600	1112807	0	0
36154342	933724	0	0
36110584	260139	0	1
36426182	46221626	2	3
42801993	46233988	2	3
44350150	1124957	0	0
44361161	40171902	1	1
44343011	1125315	0	0
45641148	1177480	0	0
45655144	1595799	0	0
45629915	19019273	2	3
45632002	1192710	0	0
45633031	19078461	2	3
45634986	19075601	2	3
45677446	1501700	0	0
45703461	1000560	0	0
45636826	723013	0	0
45782061	967823	0	0
45702756	967823	0	0
45696027	40228214	2	3
45678521	1129625	0	0
45787482	1149196	0	0
45897864	1192710	0	0
46299006	1545958	0	0
45788302	1154029	0	0
45802168	1154029	0	0
46302433	1125315	0	0
45802381	19078461	2	3
1125315	1127433	2	3
3050409	3005136	2	2
21001833	46233988	2	3
21503160	1129625	6	6
36153602	1129625	0	0
36154344	1129625	0	0
36102977	195588	1	1
36426182	43012754	2	3
42801993	46233710	2	3
44349678	1332418	0	0
44786889	3016723	2	2
44343292	1125315	0	0
45641210	1177480	0	0
45655144	1308738	0	0
45629770	19133768	2	3
45632233	1192710	0	0
45629766	19078461	2	3
45635004	19019273	2	3
45677434	1545958	0	0
45703632	1149196	0	0
45636865	723013	0	0
45781997	705944	0	0
45702763	1149380	0	0
45687750	40223768	2	3
45678545	1129625	0	0
45787541	967823	0	0
45897723	1107830	0	0
46298556	1729720	0	0
45788305	1107830	0	0
45802261	1551099	0	0
46302464	1125315	0	0
45801999	46233710	2	3
1125315	19133768	2	3
3050409	3036780	2	2
21001833	46233710	2	3
21503160	1119510	6	6
36153197	1192710	0	0
35604747	40224805	0	0
36110229	28060	1	1
36426182	1718412	2	3
42806938	46233710	2	3
44349866	1738521	0	0
43530807	4174876	2	2
44343098	1125315	0	0
45641165	1177480	0	0
45655146	1149380	0	0
45626918	40232448	2	3
45634228	1192710	0	0
45650927	19078461	2	3
45635042	40163554	2	3
45677532	1107830	0	0
45703721	1515774	0	0
45636787	738818	0	0
45782142	1174888	0	0
45702764	967823	0	0
45784382	19075001	2	3
45672619	1129625	0	0
45787542	1501700	0	0
45897732	1551099	0	0
46298561	967823	0	0
45788383	1713332	0	0
45802251	1501700	0	0
46302487	1125315	0	0
45802024	40243436	2	3
1125315	40231925	2	3
3050409	3023430	2	2
21001820	46233710	2	3
21503160	1115008	6	6
36153197	1112807	0	0
35605482	35605482	0	0
36110265	28060	1	1
36425092	19077572	2	3
42801381	40223768	2	3
44349871	1118084	0	0
44359965	19128009	2	2
44343190	1125315	0	0
45641267	1177480	0	0
45655266	1149196	0	0
45626921	19018935	2	3
45629320	1192710	0	0
45663871	19078461	2	3
45635286	40228214	2	3
45677417	1174888	0	0
45703721	1549786	0	0
45636958	1307863	0	0
45782108	1118084	0	0
45702902	1115008	0	0
45672227	40223768	2	3
45672421	1129625	0	0
45787278	1307863	0	0
45897738	1500211	0	0
46298876	1713332	0	0
45788392	1174888	0	0
45802213	738818	0	0
46306891	1125315	0	0
45802059	1115171	2	3
1125315	40229134	2	3
3050415	3023430	2	2
21001820	46233988	2	3
21503160	1177480	6	6
36153198	1112807	0	0
35605483	35605482	0	0
35702780	4027663	1	1
36423756	19075601	2	3
42801554	19075001	2	3
44350041	1545958	0	0
44338512	19128009	2	2
44343203	1125315	0	0
45642908	1177480	0	0
45655326	1557272	0	0
45626841	43012036	2	3
45628002	1192710	0	0
45653851	19078461	2	3
45635376	40232448	2	3
45677645	1107830	0	0
45703721	19127890	0	0
45636827	1124957	0	0
45782128	1778162	0	0
45702906	19127890	0	0
45684241	1107882	2	3
45673404	1129625	0	0
45787205	1515774	0	0
45897745	1548195	0	0
46298879	1115008	0	0
45788557	1713332	0	0
45802271	1549786	0	0
46306832	1125315	0	0
45802013	40165015	2	3
1125315	40162522	2	3
3050415	3005136	2	2
21002745	40228230	2	3
21503160	1112807	6	6
36153200	1129625	0	0
35605858	35605858	0	0
36110736	4116491	1	1
36422341	1310034	2	3
42806474	19073183	2	3
44342344	1177480	0	0
44338512	19127918	2	2
44343287	1125315	0	0
45641363	1177480	0	0
45655272	1124957	0	0
45628216	19076374	2	3
45628275	1192710	0	0
45642093	19078461	2	3
45635345	19078461	2	3
45677649	1521369	0	0
45703722	1154343	0	0
45636964	740275	0	0
45782129	1115008	0	0
45702906	1548195	0	0
45702242	1127433	2	3
45672720	1129625	0	0
45787275	1545958	0	0
45897719	1713332	0	0
46299032	1549786	0	0
45788557	1759842	0	0
45802271	1589505	0	0
46306841	1125315	0	0
45802018	1115171	2	3
1125315	1127078	2	3
3050415	3036780	2	2
21002745	1150771	2	3
21503160	738818	6	6
36153228	1129625	0	0
35605859	35605858	0	0
36110687	4294548	1	1
36424218	19076374	2	3
42806558	40223768	2	3
44342347	1332418	0	0
43530877	4329847	2	2
44343173	1125315	0	0
45641351	1177480	0	0
44347889	1118084	0	0
45627041	19078924	2	3
45626345	1192710	0	0
45626769	19078461	2	3
45629899	1115171	2	3
45677447	1149196	0	0
45703726	1515774	0	0
45636969	723013	0	0
45782232	1713332	0	0
45702906	19054876	0	0
45702242	19078461	2	3
45672856	1129625	0	0
45696796	1177480	0	0
45897833	1118084	0	0
46299032	1521369	0	0
45788439	1545958	0	0
45802335	738818	0	0
46306850	1125315	0	0
45801909	1545959	2	3
3039467	3023103	1	3
3050420	3023430	2	2
21002745	19112599	2	3
21503160	1125315	6	6
36153595	1153428	0	0
36002139	4048695	6	7
36110708	257012	1	1
36516993	4310024	2	4
42803048	19073183	2	3
44342203	975125	0	0
43530877	381316	2	2
44343216	1125315	0	0
45637902	1177480	0	0
44347843	933724	0	0
45627083	19075001	2	3
45622983	1192710	0	0
45641968	19078461	2	3
45629903	1127433	2	3
45677585	1539403	0	0
45703726	1549786	0	0
45637104	1332418	0	0
45782232	1759842	0	0
45702908	1545958	0	0
45696023	1127433	2	3
45672731	1129625	0	0
45696383	1177480	0	0
45897836	1539403	0	0
46299041	1192710	0	0
45788439	1332418	0	0
45802338	1115008	0	0
46306311	1125315	0	0
45802103	19023398	2	3
442013	4296204	2	2
3050420	3036780	2	2
21002745	40223821	2	3
21503160	1150836	6	6
36153433	1125315	0	0
35500000	4144583	5	7
36110708	40481087	1	1
36516728	40480160	2	4
42801337	1107882	2	3
44342466	1149380	0	0
44360439	19128022	1	2
44343020	1125315	0	0
45638017	1177480	0	0
44347856	791967	0	0
45623716	1115171	2	3
45621462	1192710	0	0
45660369	40174880	2	3
45630127	1115171	2	3
45677695	1174888	0	0
45701508	1107830	0	0
45637005	1115008	0	0
45782201	975125	0	0
45703039	967823	0	0
45696023	19078461	2	3
45672845	1129625	0	0
45696887	1177480	0	0
45897874	1192710	0	0
46299044	1545958	0	0
45788440	1192710	0	0
45799429	1115008	0	0
46306256	1125315	0	0
45801919	40229134	2	3
4008565	440086	2	2
3050420	3005136	2	2
21002745	1107882	2	3
21503160	1149196	6	6
36153436	1112807	0	0
21604180	19078924	4	7
36111049	4112343	1	1
36503288	4146173	2	8
42805289	40223768	2	3
44342468	1174888	0	0
44360439	19128263	1	2
44339412	1125315	0	0
45637941	1177480	0	0
44347860	1521369	0	0
45623924	40163554	2	3
45621738	1192710	0	0
45644478	1539411	2	3
45629868	1127433	2	3
45677700	738818	0	0
45701544	1149196	0	0
45637011	1107830	0	0
45782204	1551099	0	0
45702912	1192710	0	0
45705409	19079524	2	3
45784682	1129625	0	0
45696750	1177480	0	0
45897905	1713332	0	0
46299134	1713332	0	0
45788565	975125	0	0
45799185	1000560	0	0
46306776	1125315	0	0
45801976	1115171	2	3
4006969	4112343	2	2
3050426	3023430	2	2
21002745	40232448	2	3
21503160	40229134	8	9
36153436	1192710	0	0
21604180	836659	4	7
36111056	40481087	1	1
36503295	4035415	2	2
42806546	1107882	2	3
44342479	791967	0	0
44361043	19127904	1	2
44339602	1125315	0	0
45637827	1177480	0	0
44347860	1549786	0	0
45623943	40232448	2	3
45621530	1192710	0	0
45663839	19079524	2	3
45629994	19008572	2	3
45677709	1115008	0	0
45701551	1115008	0	0
45636894	1539403	0	0
45782460	1154029	0	0
45696720	1539403	0	0
45779864	19075601	2	3
45784550	1129625	0	0
45696831	1177480	0	0
45897896	1112807	0	0
46299219	1713332	0	0
45788188	1000560	0	0
45799499	1367571	0	0
46306899	1125315	0	0
45801984	1115171	2	3
4006969	260139	2	2
3050426	3005136	2	2
21002745	1150837	2	3
21502550	40243436	6	7
36153439	1125315	0	0
21603248	40169281	4	6
36313965	4181917	3	3
36603352	40480160	2	2
42806680	1107882	2	3
44342524	1539403	0	0
44337968	43012036	2	3
44339606	1125315	0	0
45638161	1177480	0	0
44347895	1192710	0	0
45623806	19075001	2	3
45621862	1192710	0	0
45623956	1332419	2	3
45630108	46275444	2	3
45677474	975125	0	0
45701555	708298	0	0
45682784	1551099	0	0
45782187	1174888	0	0
45696501	1174888	0	0
45690570	19078924	2	3
45784552	1129625	0	0
45696864	1177480	0	0
45897703	1112807	0	0
46299219	1759842	0	0
45788452	1000560	0	0
45799500	738818	0	0
46306810	1125315	0	0
45802088	19076374	2	3
4006969	4294548	2	2
3050426	3036780	2	2
21002745	40228214	2	3
21502550	926487	4	4
36153451	1112807	0	0
21602796	46275444	4	6
36313965	4151422	3	3
36302161	4163951	2	2
42804137	1332419	2	3
44342325	1367571	0	0
44338101	1115171	2	3
44339512	1125315	0	0
45638451	1177480	0	0
44347895	1174888	0	0
45623922	1127433	2	3
45667579	1192710	0	0
45630009	1539411	2	3
45630019	40232448	2	3
45677483	914335	0	0
45701464	1396131	0	0
45682768	1124300	0	0
45782274	920293	0	0
45696618	738818	0	0
45693326	40228214	2	3
45789333	920300	2	3
45802662	1177480	0	0
45897917	1500211	0	0
46298926	1124957	0	0
45788322	1107830	0	0
45799416	1595799	0	0
46302579	1125315	0	0
45802152	40229134	2	3
1580779	42902245	2	2
3050442	3023430	2	2
21002745	40223834	2	3
21502550	1129625	4	4
36153470	1107830	0	0
36202157	4296205	6	6
36313965	4246502	3	3
36300000	4234705	3	3
42803300	1539411	2	3
44342528	1332418	0	0
44338294	1127433	2	3
44339242	1125315	0	0
45634854	1177480	0	0
44347817	1343916	0	0
45623456	19078461	2	3
45667481	1192710	0	0
45654152	1332419	2	3
45630191	1545959	2	3
45677487	1539403	0	0
45701468	1124300	0	0
45682769	1361711	0	0
45782276	1154029	0	0
45696621	967823	0	0
45687540	1107882	2	3
45789447	19008572	2	3
45802674	1177480	0	0
45897844	1115008	0	0
46298760	933724	0	0
45788568	1115008	0	0
45799416	1521369	0	0
46299637	1125315	0	0
45802338	1115171	2	3
1586134	40766240	2	2
3050442	3005136	2	2
21002745	19125062	2	3
21502550	738818	4	4
36152782	1548195	0	0
36203062	4218389	6	6
36313965	4133840	3	3
36516993	381316	3	3
42804297	1332419	2	3
44342273	1110410	0	0
44338519	43012036	2	3
44339623	1125315	0	0
45634839	1177480	0	0
44347935	1332418	0	0
45623682	40231925	2	3
45665243	1192710	0	0
45666620	1539411	2	3
45630175	1551192	2	3
45677763	1174888	0	0
45701440	708298	0	0
45682773	738818	0	0
45782011	738818	0	0
45696628	1332418	0	0
45699584	1107882	2	3
45789481	1115171	2	3
45802886	1177480	0	0
45897846	1124957	0	0
46299474	1107830	0	0
45788314	723013	0	0
45799416	1549786	0	0
46299663	1125315	0	0
45799429	1115171	2	3
4023316	81151	2	2
3050442	3036780	2	2
21002745	43012036	2	3
21502549	19074843	8	9
36152846	1119510	0	0
36202155	78272	6	6
36303153	4195803	3	3
36502205	4035415	3	3
42801735	1332419	2	3
44342443	1124300	0	0
44338448	1127433	2	3
44339627	1125315	0	0
44361857	1112807	0	0
44347512	701322	0	0
45624088	1115171	2	3
45662923	1192710	0	0
45627492	19079524	1	1
45630406	40223821	2	3
45677766	967823	0	0
45701445	1738521	0	0
45682717	1124957	0	0
45782130	1501700	0	0
45696666	1310149	0	0
45690509	1107882	2	3
45789869	19073183	2	3
45802728	1177480	0	0
45897856	920293	0	0
46298649	1154343	0	0
45788610	1174888	0	0
45799509	1149196	0	0
46299676	1125315	0	0
45799307	19018935	2	3
3039467	3027970	2	2
3050445	3036780	2	2
21002328	920300	2	3
21502549	19133873	8	9
36152850	1112807	0	0
36002868	4066995	5	6
36303153	4163951	3	3
36503269	4035415	3	3
42801526	19075601	2	3
44342330	1729720	0	0
44338503	40231925	2	3
44339484	1125315	0	0
44362201	1112807	0	0
44347711	1115008	0	0
45624090	1127433	2	3
45662911	1192710	0	0
45639512	19079524	1	1
45627211	19077572	2	3
45677769	791967	0	0
45701501	1192710	0	0
45682812	1149196	0	0
45782308	1322184	0	0
45696673	975125	0	0
45679996	19073183	2	3
45786837	1115171	2	3
45802918	1177480	0	0
45897921	1332418	0	0
46298652	740275	0	0
45788593	1501700	0	0
45799305	708298	0	0
46299887	1125315	0	0
45799549	40236824	2	3
3039467	3006906	2	2
3050445	3023430	2	2
21002328	19075001	2	3
21502549	19073188	8	9
36152850	1192710	0	0
36002868	4048695	5	6
36503288	80180	3	3
36503269	80502	3	3
42804154	19075601	2	3
44342457	738818	0	0
44338394	1154615	2	3
44339558	1125315	0	0
44362167	1112807	0	0
44347712	1713332	0	0
45623894	1115171	2	3
45662915	1192710	0	0
45668991	19079524	1	1
45627230	19073183	2	3
45677773	1589505	0	0
45701504	1192710	0	0
45682721	1149196	0	0
45779563	1192710	0	0
45696676	1778162	0	0
45702850	1107882	2	3
45786500	1127433	2	3
45802870	1177480	0	0
45897952	1738521	0	0
46290359	1713332	0	0
45788598	1174888	0	0
45799306	1713332	0	0
46299800	1125315	0	0
45799363	19019273	2	3
3039467	3004501	2	2
3050445	3005136	2	2
21002328	920334	2	3
21502549	19075001	8	9
36152784	1738521	0	0
36203060	78272	5	6
36303152	4145310	3	3
36603314	4285898	3	3
42804222	19075601	2	3
44342458	1124300	0	0
44341152	40232448	2	3
44339349	1125315	0	0
44362029	1112807	0	0
44347712	1759842	0	0
45668034	1127433	2	3
45662961	1192710	0	0
45654720	19079524	1	1
45627104	19008572	2	3
45677773	1549786	0	0
45701668	1107830	0	0
45682818	1149196	0	0
45779585	1549786	0	0
45696680	1107830	0	0
45685660	1107882	2	3
45786663	19018935	2	3
45802979	1177480	0	0
45897959	19127890	0	0
46290568	933724	0	0
45788427	1308738	0	0
45799306	1759842	0	0
46299933	1125315	0	0
45799526	19075001	2	3
3039467	3024561	2	2
3050465	3023430	2	2
21002328	1713671	2	3
21502549	46233710	8	9
36152785	1177480	0	0
35802832	4048171	5	6
36303130	42535580	3	3
36503249	40480160	3	5
42804141	19075601	2	3
44342530	1118084	0	0
44341206	35605482	2	3
44339438	1125315	0	0
44362068	1112807	0	0
44347714	753626	0	0
45667880	46275444	2	3
45664441	1192710	0	0
45639657	19079524	1	1
45627229	1713671	2	3
45677775	920293	0	0
45701630	1153428	0	0
45682797	1717327	0	0
45779585	19127890	0	0
45696595	967823	0	0
45672585	1107882	2	3
45786511	40232448	2	3
45802883	1177480	0	0
45897959	1549786	0	0
46290583	1738521	0	0
45788428	975125	0	0
45799307	1326303	0	0
46299870	1125315	0	0
45796615	19008572	2	3
3039467	3013721	2	2
3050465	3005136	2	2
21001283	1107882	2	3
21502549	46233988	8	9
36152785	1129625	0	0
21602537	40221415	5	6
36702254	4132546	3	3
36300000	4052083	3	5
42801766	19075601	2	3
44342506	1137529	0	0
44341157	19008572	2	3
44341300	1125315	0	0
45656115	1112807	0	0
44347957	1192710	0	0
45667886	19078461	2	3
45659534	1192710	0	0
45663963	19079524	1	1
45627317	40163554	2	3
45677779	738818	0	0
45701591	1174888	0	0
45682977	738818	0	0
45779585	1589505	0	0
45696702	1154343	0	0
45672243	1107882	2	3
45786512	19059056	2	3
45802847	1177480	0	0
45897937	1501700	0	0
46290469	920293	0	0
45788531	1192710	0	0
45799449	738818	0	0
46299810	1125315	0	0
45796715	19008572	2	3
3039467	3016723	2	2
3050465	3036780	2	2
21001283	1150771	2	3
21502549	19074841	8	9
36153041	1125315	0	0
36206173	3019406	6	6
36703499	375671	3	3
36502205	4149245	3	6
42804245	19075601	2	3
44342506	1149380	0	0
44359725	40229134	2	3
44341429	1125315	0	0
45656026	1112807	0	0
44347672	1149380	0	0
45667903	40232448	2	3
45659701	1192710	0	0
45666484	19079524	1	1
45627107	40229134	2	3
45677790	1738521	0	0
45698107	738818	0	0
45682979	1115008	0	0
45779589	1174888	0	0
45696704	1326303	0	0
45786359	1107882	2	3
45786811	1115171	2	3
45800122	1177480	0	0
45895521	1307863	0	0
46290382	967823	0	0
45788675	967823	0	0
45799454	975125	0	0
46299820	1125315	0	0
45796987	19018935	2	3
3039467	3035995	2	2
3050951	3024561	2	2
21001283	19125062	2	3
21502549	1713671	8	9
36153370	1125315	0	0
35500000	140673	3	5
36313949	4024289	3	3
36516972	4048695	3	6
42803999	1539411	2	3
44342277	1112807	0	0
44359826	19008572	2	3
44341163	1125315	0	0
45656066	1112807	0	0
44347676	1149380	0	0
45667907	40232448	2	3
45660042	1192710	0	0
45666484	46275916	1	1
45627109	40229134	2	3
45677858	1332418	0	0
45697983	1361711	0	0
45682987	1545958	0	0
45779559	1305058	0	0
45696447	967823	0	0
45690421	1107882	2	3
45786648	1127433	2	3
45800279	1177480	0	0
45895503	1367571	0	0
46290385	1192710	0	0
45788630	1153428	0	0
45799460	1174888	0	0
46300021	1125315	0	0
45796848	40232448	2	3
3039467	3006923	2	2
3050951	3013682	2	2
21001283	40232448	2	3
21502549	46275444	8	9
36153370	1112807	0	0
35902135	198809	3	5
36313949	4252419	3	3
36313965	4202451	3	6
42806494	40223768	2	3
44342414	1343916	0	0
44359799	19008572	2	3
44339692	1125315	0	0
45656428	1112807	0	0
44347677	1149196	0	0
45670043	19079524	2	3
45656943	1192710	0	0
45666587	19079524	1	1
45627110	19059056	2	3
45677795	1549786	0	0
45698083	738818	0	0
45682875	1713332	0	0
45779520	967823	0	0
45696553	1548195	0	0
45695989	1107882	2	3
45786710	40229134	2	3
45800295	1177480	0	0
45895346	1149196	0	0
46290394	1539403	0	0
45788541	1551099	0	0
45799317	1102527	0	0
46300027	1125315	0	0
45796809	19075601	2	3
3039467	3020630	2	2
3050951	3013721	2	2
21001283	1150837	2	3
21502549	19129655	8	9
36153374	1112807	0	0
21602818	46275444	3	5
36313913	4024289	3	4
36503263	78272	3	7
42806190	40223768	2	3
44342420	1549786	0	0
44359834	40236824	2	3
44339699	1125315	0	0
45652690	1112807	0	0
44347720	738818	0	0
45670086	43012036	2	3
45657001	1192710	0	0
45627354	19079524	1	1
45627288	19075601	2	3
45677795	1519936	0	0
45698091	1107830	0	0
45682885	1153428	0	0
45779618	967823	0	0
45696554	920293	0	0
45674884	1107882	2	3
45786713	19077572	2	3
45802517	1177480	0	0
45895567	1361711	0	0
46290397	740275	0	0
45788683	1149196	0	0
45799318	1310149	0	0
46300085	1125315	0	0
45796884	19133905	2	3
3039467	3013682	2	2
3050951	3006923	2	2
21001283	43012036	2	3
21502549	1174888	6	6
36153492	1549786	0	0
36100000	4280726	5	5
36303140	439777	3	4
36502205	81151	3	7
42801609	19078461	2	3
44342430	1738521	0	0
44359623	19019273	2	3
44339771	1125315	0	0
45655177	1112807	0	0
44347728	19127890	0	0
45670351	19059056	2	3
45653557	1192710	0	0
45627835	19079524	1	1
45627377	1127433	2	3
45674156	1759842	0	0
45698368	1149196	0	0
45633681	1154029	0	0
45779638	1153428	0	0
45696779	1501700	0	0
45679971	1107882	2	3
45786922	40229134	2	3
45802247	1177480	0	0
45895570	1729720	0	0
46290507	1310149	0	0
45788399	1545958	0	0
45799321	975125	0	0
46300089	1125315	0	0
45796884	19133873	2	3
3048893	3005136	2	2
3050951	3006906	2	2
21001283	19112599	2	3
21502549	1728416	6	6
36153050	1107830	0	0
35702777	81893	5	5
36516728	4142905	3	4
36426641	19128065	3	4
42806595	19078461	2	3
44342442	1118084	0	0
44360136	1115171	2	3
43531392	4186930	3	4
45655355	1112807	0	0
44347911	1521369	0	0
45668175	1115171	2	3
45653560	1192710	0	0
45664124	19079524	1	1
45627357	1551192	2	3
45674156	1713332	0	0
45698315	1115008	0	0
45633427	1551099	0	0
45779641	1549786	0	0
45696780	975125	0	0
45778140	19079524	2	3
45786927	920334	2	3
45797571	1177480	0	0
45895463	1192710	0	0
46290476	1115008	0	0
45788499	1115008	0	0
45799506	1738521	0	0
46300236	1125315	0	0
45796897	40163554	2	3
3048893	3036780	2	2
3050951	3027970	2	2
21001283	40228214	2	3
21502549	1729720	6	6
36153051	1115008	0	0
35809406	81893	5	5
36516993	4149245	3	4
36602211	4285898	3	4
42806412	1332419	2	3
44342593	1149380	0	0
44360080	40232448	2	3
44784106	4230399	4	4
45652854	1112807	0	0
44347728	1589505	0	0
45668183	40162522	2	3
45653243	1192710	0	0
45633497	19079524	1	1
45627448	40163554	2	3
45674163	1595799	0	0
45698782	1308738	0	0
45633470	1545958	0	0
45779641	19127890	0	0
45682141	1112807	0	0
45703048	19078461	2	3
45786794	40229134	2	3
45797582	1177480	0	0
45895468	1515774	0	0
46290428	19003953	0	0
45788677	1307863	0	0
45799363	1115008	0	0
46300111	1125315	0	0
45797027	40229134	2	3
3048893	3023430	2	2
3050951	3004501	2	2
21001283	40223821	2	3
21502549	1717327	6	6
36153053	1177480	0	0
36002868	4048171	5	5
36303152	4163872	3	4
36427783	40221415	3	4
42801338	1332419	2	3
44342594	1332418	0	0
44360143	40229134	2	3
44784105	40479422	4	4
45649526	1112807	0	0
44347728	1549786	0	0
45668123	40220960	2	3
45653619	1192710	0	0
45633497	46275916	1	1
45627463	920300	2	3
45674163	1308738	0	0
45698094	1124300	0	0
45633715	1308738	0	0
45779641	1589505	0	0
45679963	1112807	0	0
45678583	40228214	2	3
45786964	40229134	2	3
45797842	1177480	0	0
45895468	1549786	0	0
46290393	1174888	0	0
45788648	742185	0	0
45799549	933724	0	0
46300148	1125315	0	0
45797028	1154615	2	3
3048907	3036780	2	2
3050951	3020630	2	2
21001283	40228230	2	3
21502549	1768849	6	6
36153054	1125315	0	0
36000000	37017711	5	5
36427091	19127922	3	4
36503263	4035415	3	4
42801344	1332419	2	3
44342571	1539403	0	0
44359883	40236824	2	3
43531071	4238715	3	4
45649747	1112807	0	0
44347938	967823	0	0
45668124	40223834	2	3
45650157	1192710	0	0
45666564	19079524	1	1
45627538	19019273	2	3
45674008	975125	0	0
45698096	738818	0	0
45633780	1107830	0	0
45779725	1501700	0	0
45677673	1112807	0	0
45696337	19075601	2	3
45786886	40229134	2	3
45797562	1177480	0	0
45895544	1107830	0	0
46290550	1115008	0	0
45788654	1717327	0	0
45799485	791967	0	0
46300169	1125315	0	0
45797143	43012036	2	3
3048907	3023430	2	2
3050951	3035995	2	2
21001283	40223834	2	3
21502549	1738521	6	6
36153054	1112807	0	0
36000000	4240902	5	5
36427091	19133679	3	4
36503263	4146173	3	4
42801785	1332419	2	3
44342551	1149196	0	0
44360280	40229134	2	3
43531071	4330583	3	7
45649846	1112807	0	0
44347867	1713332	0	0
45668126	40232448	2	3
45650245	1192710	0	0
45664399	19079524	1	1
45623708	19078461	2	3
45674170	1713332	0	0
45698406	1713332	0	0
45633874	1149380	0	0
45779644	1115008	0	0
45677915	1112807	0	0
45778010	1539411	2	3
45786904	1115171	2	3
45797677	1177480	0	0
45896700	1322184	0	0
46290593	1124300	0	0
45788657	1729720	0	0
45799550	1154029	0	0
46300340	1125315	0	0
46317548	19019273	2	3
3048907	3005136	2	2
3037839	3045716	2	2
21001804	19073188	2	3
21502549	1741122	6	6
36153055	1112807	0	0
36202157	4094814	5	5
36427091	42902245	3	4
40049748	19008572	1	1
42804512	40174880	2	3
44342619	1310149	0	0
44353309	40162522	2	3
43531071	4145310	3	3
45649672	1112807	0	0
44347869	1738521	0	0
45668130	920300	2	3
45647404	1192710	0	0
45630158	19079524	1	1
45623900	40229134	2	3
45674170	1759842	0	0
45698406	1759842	0	0
45633789	967823	0	0
45779649	738818	0	0
45677827	1112807	0	0
45679366	40228214	2	3
45786908	19008572	2	3
45794980	1177480	0	0
45896701	1713332	0	0
46290863	1713332	0	0
46298026	975125	0	0
45799521	1154029	0	0
46300245	1125315	0	0
46317571	19008572	2	3
3048915	3036780	2	2
3037839	3019550	2	2
21001804	19074841	2	3
21502549	1759842	6	6
36153057	1112807	0	0
36203066	375671	5	5
36427091	19128065	3	4
40654138	3049273	1	1
42801630	1545959	2	3
44342616	1115008	0	0
44353316	40236824	2	3
43531071	4186930	4	5
45649925	1112807	0	0
44347952	1549786	0	0
45668169	35605482	2	3
45644415	1192710	0	0
45627321	19079524	1	1
45623901	40232448	2	3
45674173	1343916	0	0
45698387	1367571	0	0
45633877	1551099	0	0
45779729	723013	0	0
45674699	1112807	0	0
45679945	1332419	2	3
45785340	43012036	2	3
45795096	1177480	0	0
45896717	1000560	0	0
46290873	1124300	0	0
46297506	715997	0	0
45799553	1115008	0	0
46300246	1125315	0	0
45794186	40162522	2	3
3048915	3023430	2	2
3037839	3023103	2	2
21001804	19129655	2	3
21502549	1778162	6	6
36153108	1125315	0	0
36203066	378001	5	5
36427091	19129144	3	4
37522151	4107731	1	1
42806550	1539411	2	3
44342569	705944	0	0
44353322	19057271	2	3
43531071	4117038	4	6
45649898	1112807	0	0
44348538	1107830	0	0
45668286	40236446	2	3
45644433	1192710	0	0
45639393	19079524	1	1
45625137	1310034	2	3
45674409	1107830	0	0
45698504	967823	0	0
45633788	740275	0	0
45779730	738818	0	0
45674540	1112807	0	0
45705820	1332419	2	3
45785284	1115171	2	3
45792524	1177480	0	0
45896718	1124957	0	0
46290649	1192710	0	0
46297680	1124957	0	0
45799530	1539403	0	0
46300184	1125315	0	0
45794187	1115171	2	3
3048915	3005136	2	2
3037839	3014576	2	2
21001804	19074843	2	3
21502549	933724	6	6
36153108	1112807	0	0
36203062	4299128	5	5
36426182	19127918	3	4
40171037	40169281	1	1
42538830	439777	3	4
44342132	1154029	0	0
44353142	19008572	2	3
43531060	195588	3	4
45649930	1112807	0	0
44348662	1153428	0	0
45668365	1127433	2	3
45644299	1192710	0	0
45627710	19079524	1	1
45625194	19008572	2	3
45674397	1595799	0	0
45698239	1124957	0	0
45633792	1149196	0	0
45779799	1738521	0	0
45674754	1112807	0	0
45696628	1332419	2	3
45785299	19059056	2	3
45789503	1177480	0	0
45896805	933724	0	0
46290718	708298	0	0
46297688	1192710	0	0
45799568	1107830	0	0
46300159	1125315	0	0
45794192	920334	2	3
3048927	3036780	2	2
3037839	3015632	2	2
21001804	19073183	2	3
21502553	40171902	6	6
36153117	1112807	0	0
36203062	4296205	5	5
36426182	19128009	3	4
36303177	4181917	1	1
42888897	4037675	4	4
44342600	1000560	0	0
44353345	19008572	2	3
43531056	4329847	5	6
45649104	1112807	0	0
44348539	1332418	0	0
45665936	40163554	2	3
45641444	1192710	0	0
45645411	19079524	1	1
45625195	1545959	2	3
45676233	1115008	0	0
45698314	1308738	0	0
45679857	1115008	0	0
45779628	1343916	0	0
45674654	1112807	0	0
45782464	40173590	2	3
45785314	19018935	2	3
45789761	1177480	0	0
45896724	975125	0	0
46290719	1124957	0	0
46297938	967823	0	0
45799526	1778162	0	0
46296119	1125315	0	0
45794021	19133905	2	3
1503242	19128065	2	2
3044023	3045716	2	2
21001804	19075001	2	3
21502553	1539411	7	8
36153376	1192710	0	0
36203090	4084167	5	5
36424660	40221415	3	4
37522248	4035793	1	1
37502338	4336464	5	5
44342606	1000560	0	0
44355677	19008572	2	3
43531056	317576	5	5
45646509	1112807	0	0
44348553	738818	0	0
45665794	40243436	2	3
45641594	1192710	0	0
45630490	19079524	1	1
45625268	1332419	2	3
45676244	975125	0	0
45698218	1332418	0	0
45679872	1305058	0	0
45779632	740275	0	0
45674788	1112807	0	0
45779914	1107882	2	3
45785317	1115171	2	3
45789764	1177480	0	0
45896732	1557272	0	0
46290887	1118084	0	0
46301490	1545958	0	0
45799528	1738521	0	0
46296125	1125315	0	0
45794021	19133873	2	3
437385	375671	2	2
3044023	3023103	2	2
21002327	920300	2	3
21502553	1545959	7	8
36153376	1112807	0	0
21603249	40169281	4	5
36424688	42902245	3	4
36316010	4133840	1	1
37502338	4337611	4	4
44342253	1768849	0	0
44355421	19008572	2	3
43531056	258780	5	5
45646569	1112807	0	0
44348555	1000560	0	0
45665614	40236824	2	3
45641693	1192710	0	0
45666213	19079524	1	1
45625202	1332419	2	3
45676257	1310149	0	0
45698326	1154029	0	0
45679588	738818	0	0
45779634	1551099	0	0
45674722	1112807	0	0
45677518	1107882	2	3
45785364	1127433	2	3
45789879	1177480	0	0
45896701	1759842	0	0
46290560	1115008	0	0
46301446	705944	0	0
45799532	1115008	0	0
46296348	1125315	0	0
45794144	40236824	2	3
3006343	3014576	2	2
3044023	3019550	2	2
21002327	19075001	2	3
21502553	1343916	5	5
36153638	1125315	0	0
21602496	19127904	4	5
36424688	19128263	3	4
36403239	140673	1	1
37502341	4117038	5	5
44342257	1149196	0	0
44355232	1551192	2	3
43531056	321042	5	5
45643477	1112807	0	0
44348726	1521369	0	0
45666059	40229134	2	3
45638247	1192710	0	0
45666680	19079524	1	1
45624203	40236824	2	3
45676260	738818	0	0
45698338	1551099	0	0
45679591	1515774	0	0
45779737	1115008	0	0
45671971	1112807	0	0
45672403	19075601	2	3
45785371	40232448	2	3
45789237	1177480	0	0
45679921	738818	0	0
46290756	1713332	0	0
46301453	1174888	0	0
45799613	1174888	0	0
46296113	1125315	0	0
45794796	40236446	2	3
3006343	3023103	2	2
3044023	3014576	2	2
21002327	920334	2	3
21502553	1361711	5	5
36153063	975125	0	0
21602537	40224805	4	5
36424688	19128009	3	4
36316422	4314290	1	1
37502341	4330583	5	5
44342258	1110410	0	0
44355306	1332419	2	3
43531056	255848	4	4
45643781	1112807	0	0
44348726	1549786	0	0
45666163	40232448	2	3
45640079	1192710	0	0
45666778	19079524	1	1
45624234	1127433	2	3
45676407	1149196	0	0
45698243	1124957	0	0
45679591	19127890	0	0
45779742	1174888	0	0
45671753	1112807	0	0
45676342	19078461	2	3
45785412	782047	2	3
45789223	1177480	0	0
45679086	738818	0	0
46290756	1759842	0	0
46301466	1307863	0	0
45799538	1589505	0	0
46318426	1125315	0	0
45794801	40229134	2	3
3006343	3019550	2	2
3044023	3015632	2	2
21002327	1713671	2	3
21502553	1332418	5	5
36153492	1515774	0	0
21602868	19075001	4	5
36424688	19127904	3	4
37303797	134438	1	1
42537893	4048695	3	3
44342401	1112807	0	0
44345678	19008572	2	3
43531056	260139	4	4
45643610	1112807	0	0
44348322	1115008	0	0
45666030	19059056	2	3
45638467	1192710	0	0
45627762	46275916	1	1
45624523	19008572	2	3
45676411	1000560	0	0
45698248	1512674	0	0
45679591	1549786	0	0
45779747	1115008	0	0
45672028	1112807	0	0
45784234	19075601	2	3
45785389	40229134	2	3
45787046	1177480	0	0
45786031	738818	0	0
46290772	1174888	0	0
46301542	1729720	0	0
45799538	1549786	0	0
46318427	1125315	0	0
45794276	19129655	2	3
3006343	3015632	2	2
3048501	3036780	2	2
21001801	19075001	2	3
21502553	1308738	5	5
36153137	975125	0	0
35502089	4144583	4	5
36424688	19127918	3	4
40773226	3010813	1	1
42537893	4066995	3	3
44342406	1713332	0	0
44345441	19008572	2	3
43531056	261325	3	5
45643635	1112807	0	0
44348735	975125	0	0
45666195	19126352	2	3
45634235	1192710	0	0
45627762	19079524	1	1
45624263	40163554	2	3
45674425	1115008	0	0
45698248	1548195	0	0
45630668	1713332	0	0
45779526	1124300	0	0
45783787	1112807	0	0
45782308	19075601	2	3
45785392	40163554	2	3
45787067	1177480	0	0
45786544	738818	0	0
46290779	1174888	0	0
46298196	1174888	0	0
45799540	1174888	0	0
46318429	1125315	0	0
45794311	19073188	2	3
3006343	3045716	2	2
3048501	3005136	2	2
21001801	19074841	2	3
21502553	1539403	5	5
36153138	975125	0	0
21602818	1713671	4	5
36424688	19128022	3	4
40589905	4084167	1	1
37502338	4337138	3	3
44342406	1759842	0	0
44345769	19129655	2	3
43531056	313217	6	7
45643512	1112807	0	0
44348741	920293	0	0
45666042	40223834	2	3
45632428	1192710	0	0
45630649	19079524	1	1
45624208	1127433	2	3
45674447	1308738	0	0
45698250	1192710	0	0
45630668	1759842	0	0
45779803	738818	0	0
45783953	1112807	0	0
45708184	19078461	2	3
45783410	40229134	2	3
45787356	1177480	0	0
45786383	738818	0	0
46290658	1551099	0	0
46298147	1192710	0	0
45799657	1149196	0	0
46318451	1125315	0	0
45794424	40236824	2	3
1595936	42902245	2	2
3048501	3023430	2	2
21001801	19074843	2	3
21502553	1307863	5	5
36153616	1177480	0	0
21603933	19019273	4	5
36424689	19128009	3	4
40765798	40766240	1	1
37502338	4078793	3	3
44342408	1713332	0	0
44348087	19008572	2	3
43531057	4329847	6	7
45645832	1112807	0	0
44348556	738818	0	0
45666109	1551192	2	3
45629465	1192710	0	0
45624724	19079524	1	1
45624381	40232448	2	3
45674451	920293	0	0
45698389	1738521	0	0
45630671	967823	0	0
45779590	1192710	0	0
45784179	1112807	0	0
45699386	19078461	2	3
45783449	40229134	2	3
45785653	1177480	0	0
45786122	738818	0	0
46290833	1192710	0	0
46298268	967823	0	0
45799665	1154343	0	0
46318452	1125315	0	0
45794477	1127433	2	3
4023584	44805732	2	2
3048567	3036780	2	2
21001801	19073188	2	3
21600001	914335	4	4
36153616	1119510	0	0
21603933	19078461	4	5
36424689	42902245	3	4
40170032	35605858	1	1
43054942	3016723	3	3
44342541	1115008	0	0
44345803	1127433	2	3
43531057	258780	6	6
45641083	1112807	0	0
44348618	1192710	0	0
45666260	40174880	2	3
45626737	1192710	0	0
45664228	46275916	1	1
45624244	19008572	2	3
45674485	1115008	0	0
45698460	1305058	0	0
45630769	738818	0	0
45779705	738818	0	0
45784193	1112807	0	0
45696511	19075601	2	3
45783450	40163554	2	3
45785571	1177480	0	0
46292667	738818	0	0
46290563	1307863	0	0
46298293	967823	0	0
45799670	1322184	0	0
46318454	1125315	0	0
45791453	40229134	2	3
1107885	1107882	1	1
3048567	3023430	2	2
21001801	1713671	2	3
21600001	1000560	4	4
36153773	1307863	0	0
35702738	4285898	4	10
36424689	19128263	3	4
40047095	19077572	1	1
43054942	3023103	3	3
44344654	1713332	0	0
44345817	40232448	2	3
43531057	321042	6	6
45641181	1112807	0	0
44348432	1729720	0	0
45666271	19019273	2	3
45623325	1192710	0	0
45630077	19079524	1	1
45668312	40223834	2	3
45674419	1343916	0	0
45698557	1729720	0	0
45630770	1713332	0	0
45779687	1309944	0	0
45784287	1112807	0	0
45784297	19075601	2	3
45783178	19078461	2	3
45785606	1177480	0	0
46292717	738818	0	0
46290834	1308738	0	0
46298158	1192710	0	0
45799624	920293	0	0
46318459	1125315	0	0
45791380	1107882	2	3
437312	192671	1	1
3048567	3005136	2	2
21001801	19129655	2	3
21600001	975125	4	4
36153775	1153428	0	0
35702738	30753	4	7
36424689	19127904	3	4
40050254	782047	1	1
43054942	3013682	3	3
44344662	1149380	0	0
44341148	19019273	2	3
43531057	317576	6	6
45640895	1112807	0	0
44348010	1308738	0	0
45663644	19008572	2	3
45623481	1192710	0	0
45668934	19079524	1	1
45668197	19078924	2	3
45674495	1149196	0	0
45698433	1124957	0	0
45630715	1738521	0	0
45779781	1107830	0	0
45781866	1112807	0	0
45779600	19075601	2	3
45783522	1551192	2	3
45785641	1177480	0	0
46293194	738818	0	0
46291041	1124957	0	0
46298184	1124300	0	0
45799577	1738521	0	0
46318574	1125315	0	0
45791709	40229134	2	3
1127642	40229134	1	1
3048584	3036780	2	2
21001801	19073183	2	3
21500010	1768849	2	2
36153793	1713332	0	0
35702738	198809	5	7
36424689	19127918	3	4
37521794	4337138	1	1
37500000	4186930	4	4
44344949	1759842	0	0
44338730	46275444	2	3
43531057	4142905	6	6
45637567	1112807	0	0
44348122	975125	0	0
45663711	1545959	2	3
45623535	1192710	0	0
45668934	46275916	1	1
45668365	19078461	2	3
45674472	738818	0	0
45698560	1713332	0	0
45630832	1149196	0	0
45779784	967823	0	0
45782123	1112807	0	0
45671907	19075601	2	3
46291172	1115171	2	3
45785860	1177480	0	0
46288417	738818	0	0
46291064	705944	0	0
46298341	1149196	0	0
45799484	1738521	0	0
46318516	1125315	0	0
45791597	40224805	2	3
1113309	19059056	1	1
3048584	3005136	2	2
21001801	46275444	2	3
21500010	1741122	2	2
36153812	1115008	0	0
35702738	81893	5	11
36424689	19128022	3	4
37521795	4337611	1	1
37500000	4078793	4	4
44344949	1713332	0	0
44338678	40232448	2	3
43531057	260139	5	5
45637963	1112807	0	0
44347976	1110410	0	0
45663420	40232448	2	3
45623363	1192710	0	0
45648514	19079524	1	1
45668373	40229134	2	3
45674560	757627	0	0
45698533	967823	0	0
45630838	920293	0	0
45779814	967823	0	0
45782019	1112807	0	0
45705923	19075601	2	3
46291621	19075001	2	3
45785645	1177480	0	0
46288691	738818	0	0
46290683	933724	0	0
46298457	715997	0	0
45799578	738818	0	0
46318772	1125315	0	0
45791697	40231925	2	3
4018956	78272	1	1
3048584	3023430	2	2
21001819	46233710	2	3
21500010	1778162	2	2
36153823	1119510	0	0
35702738	4112343	5	9
36503289	4310024	3	5
37521588	4117038	1	1
37500000	4295880	6	6
44344952	1548195	0	0
44338740	19133905	2	3
43531057	255848	5	5
45634742	1112807	0	0
44347982	1713332	0	0
45663855	46275444	2	3
45667842	1192710	0	0
45642647	19079524	1	1
45668294	19073183	2	3
45674566	19039298	0	0
45698688	1115008	0	0
45630840	1729720	0	0
45779821	975125	0	0
45779523	1112807	0	0
45782122	19075601	2	3
46291540	1107882	2	3
45785983	1177480	0	0
46288761	738818	0	0
46290695	1549786	0	0
46298345	1501700	0	0
45799636	975125	0	0
46318677	1125315	0	0
45791614	920334	2	3
1585385	40766240	1	1
3048604	3036780	2	2
21001819	19075001	2	3
21604565	723013	2	2
36153083	1125315	0	0
35702738	196456	5	6
36313913	4058899	3	5
36918918	440086	1	1
42806218	19127904	1	2
44342629	1118084	0	0
44339207	40162522	2	3
43531057	261325	4	6
45634726	1112807	0	0
44347990	1110410	0	0
45663550	19133768	2	3
45667909	1192710	0	0
45627408	46275916	1	1
45668399	1551192	2	3
45674569	1307863	0	0
45698374	1367571	0	0
45630610	1548195	0	0
45779599	975125	0	0
45779800	1112807	0	0
45782501	1539411	2	3
46291751	1107882	2	3
45785935	1177480	0	0
46243300	738818	0	0
46290695	1521369	0	0
46298377	1000560	0	0
45799589	1549786	0	0
46318880	1125315	0	0
45791659	19019273	2	3
1107886	19125062	1	1
3048604	3023430	2	2
21001819	46275444	2	3
21604565	19115351	2	2
36153736	1112807	0	0
35702738	28060	6	7
36313957	439777	3	5
36918919	440086	1	1
43053794	4285898	1	2
44342707	1729720	0	0
44360400	40236824	2	3
43531057	313217	7	8
45634548	1112807	0	0
44348052	1521369	0	0
45663584	46275916	2	3
45667815	1192710	0	0
45627408	19079524	1	1
45668439	19073183	2	3
45674572	1551099	0	0
45698694	723013	0	0
45630843	1115008	0	0
45779600	1322184	0	0
45779633	1112807	0	0
45672088	1539411	2	3
46291765	1115171	2	3
46292163	1177480	0	0
46243301	738818	0	0
46291070	791967	0	0
46298408	742185	0	0
45799589	19127890	0	0
46319028	1125315	0	0
45791667	19059056	2	3
435459	433125	1	1
3048604	3005136	2	2
21001819	46233988	2	3
21604565	791967	2	2
36153750	1129625	0	0
35802829	381316	6	6
36503290	81151	3	6
36919236	443279	1	1
43053691	4066995	1	2
44342743	967823	0	0
44347441	19133905	2	3
43531059	45769019	4	4
45631581	1112807	0	0
44348052	1595799	0	0
45660242	19008572	2	3
45667838	1192710	0	0
45636470	19079524	1	1
45668381	1107882	2	3
45674508	975125	0	0
45698573	1124957	0	0
45630860	1107830	0	0
45779832	1309944	0	0
45779918	1112807	0	0
45784300	1539411	2	3
46291452	40174880	2	3
46292144	1177480	0	0
46242546	738818	0	0
46291236	715997	0	0
46298543	1713332	0	0
45799589	1515774	0	0
46319029	1125315	0	0
45791583	46233710	2	3
438409	440086	1	1
3048875	3036780	2	2
21001819	1713671	2	3
21602882	19075001	2	2
36152955	1107830	0	0
35802829	372328	6	6
36300000	4133840	3	6
40793378	3021226	1	1
37502353	44783196	5	7
44342722	1153428	0	0
44343243	1115171	2	3
43531059	195588	4	5
45631846	1112807	0	0
44348052	1549786	0	0
45660383	1127433	2	3
45667193	1192710	0	0
45636470	46275916	1	1
45668427	43012036	2	3
45674462	1713332	0	0
45698440	1501700	0	0
45630862	740275	0	0
45779881	1000560	0	0
45708301	1112807	0	0
45678092	1539411	2	3
46291678	40229134	2	3
46292278	1177480	0	0
46241209	738818	0	0
46290845	1192710	0	0
46298543	1759842	0	0
45799592	1174888	0	0
46318656	1125315	0	0
45791754	1127433	2	3
4023584	4059978	1	1
3048875	3005136	2	2
21001819	19129655	2	3
21602882	1768849	2	2
36153562	975125	0	0
35802829	380378	6	6
36303152	4058899	3	6
40793379	3006451	1	1
37502353	4301346	6	7
44342686	975125	0	0
44342974	40162522	2	3
43531058	81893	7	8
45628594	1112807	0	0
44348062	1115008	0	0
45660384	40232448	2	3
45663358	1192710	0	0
45668769	19079524	1	1
45668524	19029476	2	3
45674513	1149196	0	0
45698710	1738521	0	0
45630991	708298	0	0
45779913	1332418	0	0
45708025	1112807	0	0
45675176	40228214	2	3
46291693	46275916	2	3
46243082	1177480	0	0
46241391	738818	0	0
46290631	1000560	0	0
46298305	1551099	0	0
45796838	1521369	0	0
46318776	1125315	0	0
45791781	782047	2	3
3040986	3051031	1	1
3048875	3023430	2	2
21001643	1545959	2	3
21604148	40173590	2	2
36153878	1125315	0	0
35802829	28060	6	7
36503289	4296204	3	6
40652640	3013721	1	1
37502353	4117038	4	8
44342652	1738521	0	0
44343100	19133873	2	3
43531058	4166224	5	6
45628623	1112807	0	0
44348134	740275	0	0
45660336	1115171	2	3
45659846	1192710	0	0
45651207	19079524	1	1
45668632	35605482	2	3
45674525	738818	0	0
45698445	1107830	0	0
45630872	1343916	0	0
45779658	914335	0	0
45777970	1112807	0	0
45782212	1539411	2	3
46291888	40232448	2	3
46242909	1177480	0	0
46238440	738818	0	0
46242048	933724	0	0
46298326	967823	0	0
45796659	740275	0	0
46312781	1125315	0	0
45788963	19076374	2	3
3041250	3023430	1	1
3048880	3036780	2	2
21001643	1539411	2	3
21604793	715997	2	2
36153879	1112807	0	0
35802829	4001336	6	8
36313965	4015189	3	6
40652709	3028833	1	1
37502353	4163971	4	9
44342669	738818	0	0
44343394	40223834	2	3
43531058	198809	5	5
45631100	1112807	0	0
44348106	740275	0	0
45660453	19078461	2	3
45659753	1192710	0	0
45668487	19079524	1	1
45668496	1115171	2	3
45671433	1738521	0	0
45698576	1174888	0	0
45630921	1539403	0	0
45779914	1107830	0	0
45778222	1112807	0	0
45784268	40228214	2	3
46291917	46233710	2	3
46243078	1177480	0	0
46238395	738818	0	0
46242213	1124957	0	0
46289697	1192710	0	0
45796610	1322184	0	0
46312391	1125315	0	0
45788965	40231925	2	3
3041250	3005136	1	1
3048880	3023430	2	2
21001630	1545959	2	3
21604793	40223774	2	2
36153883	1000560	0	0
35802829	40481087	6	8
36300000	4181917	3	7
40652745	3006906	1	1
37502353	4035793	3	5
44342691	1713332	0	0
44343492	40232448	2	3
43531058	4266809	4	4
45631104	1112807	0	0
44348111	738818	0	0
45660618	40169216	2	3
45649511	1332418	0	0
45658229	19079524	1	1
45668585	19073183	2	3
45671471	1174888	0	0
45698578	1115008	0	0
45631007	1500211	0	0
45779920	738818	0	0
45705856	1112807	0	0
45684274	40228230	2	3
46295789	19008572	2	3
46243207	1177480	0	0
45897579	738818	0	0
46242435	1332418	0	0
46290110	1000560	0	0
45796611	1000560	0	0
46312403	1125315	0	0
45789006	40229134	2	3
3041250	3036780	1	1
3048880	3005136	2	2
21506101	1125315	1	1
21604793	757627	2	2
36153751	1129625	0	0
35802829	4112343	6	9
36300000	4163872	3	8
40652760	3015632	1	1
37502336	44783196	4	6
44363955	1500211	0	0
44343501	1127433	2	3
43531058	196456	4	4
45628813	1112807	0	0
44348113	933724	0	0
45660760	19019273	2	3
45649279	967823	0	0
45658229	46275916	1	1
45668409	19008572	2	3
45671544	1501700	0	0
45698593	1192710	0	0
45631011	1149196	0	0
45779666	1000560	0	0
45705659	1112807	0	0
45684274	40228214	2	3
46244994	1127433	2	3
46243216	1177480	0	0
45897589	738818	0	0
46242462	715997	0	0
46290122	1115008	0	0
45796615	975125	0	0
46312688	1125315	0	0
45788935	40228214	2	3
3048893	3006734	1	1
3048238	3023430	2	2
21506109	1332418	1	1
21503965	19010482	2	2
36153752	1129625	0	0
35802829	4294548	6	9
36300000	4024958	3	8
40652796	3014576	1	1
40087471	40174880	1	1
44364018	1539403	0	0
44343468	43012036	2	3
43531058	4285898	3	7
45628870	1112807	0	0
44348095	1149380	0	0
45660422	40229134	2	3
45649286	1332418	0	0
45635144	19079524	1	1
45665857	40229134	2	3
45671642	1174888	0	0
45698599	1149380	0	0
45630823	914335	0	0
45779671	1149196	0	0
45706047	1112807	0	0
45706019	40228214	2	3
46244995	40232448	2	3
46240910	1177480	0	0
45897643	738818	0	0
46242142	1124957	0	0
46289857	1149196	0	0
45796715	975125	0	0
46312996	1125315	0	0
45788944	19023398	2	3
3048893	3001247	1	1
3048238	3005136	2	2
21506109	1307863	1	1
21503965	1305058	2	2
36153757	1125315	0	0
35802829	4048171	8	10
36300000	4015189	3	9
40652525	3006923	1	1
40083920	1539411	1	1
44364056	1177480	0	0
44343477	40162522	2	3
43531058	195588	3	5
45626109	1112807	0	0
44348139	1548195	0	0
45660553	40223768	2	3
45649519	1124300	0	0
45627273	46275916	1	1
45665861	43012036	2	3
45671648	1174888	0	0
45698605	1107830	0	0
45631013	1332418	0	0
45779769	1539403	0	0
45705798	1112807	0	0
45681312	40228214	2	3
46290991	19075001	2	3
46240937	1177480	0	0
45895374	738818	0	0
46242217	1124957	0	0
46289879	1717327	0	0
45796721	1174888	0	0
46312917	1125315	0	0
45788993	19129655	2	3
3048915	3001247	1	1
3048238	3036780	2	2
21506098	967823	1	1
21604798	701322	2	2
36154119	1125315	0	0
35802829	140673	5	5
36313965	4010253	2	6
40652534	3024561	1	1
43021226	134438	1	1
44364037	1545958	0	0
44339798	1115171	2	3
43531058	4310024	3	4
45622590	1112807	0	0
44348140	1174888	0	0
45660526	19008572	2	3
45649350	1124300	0	0
45627273	19079524	1	1
45667239	19079524	2	3
45671649	1717327	0	0
45698616	782043	0	0
45630908	967823	0	0
45779711	1741122	0	0
45703693	1112807	0	0
45672445	40228214	2	3
46291317	1115171	2	3
46241063	1177480	0	0
45894650	738818	0	0
46242414	1332418	0	0
46289417	1367571	0	0
45796721	1192710	0	0
46313177	1125315	0	0
45788985	1115171	2	3
3048915	3006734	1	1
3048257	3036780	2	2
21501246	19010482	1	1
21500296	967823	2	2
36153018	1589505	0	0
35802829	4029498	5	5
36313913	4145310	2	2
40652549	3035995	1	1
43055200	3051031	1	1
44364046	1521369	0	0
44339802	1127433	2	3
43531058	440448	6	6
45622675	1112807	0	0
44348243	1115008	0	0
45658426	19073183	2	3
45649406	1738521	0	0
45624023	19079524	1	1
45667365	40232448	2	3
45671486	914335	0	0
45698628	1192710	0	0
45630905	1539403	0	0
45779711	1746114	0	0
45703604	1112807	0	0
45784310	40228214	2	3
46242704	920334	2	3
46241094	1177480	0	0
45803429	738818	0	0
46242492	1548195	0	0
46289961	1149196	0	0
45796730	1124300	0	0
46312463	1125315	0	0
45788986	40232448	2	3
1115092	19019273	1	1
3048257	3023430	2	2
21502613	1125315	1	1
21604416	740275	2	2
36153018	19127890	0	0
35802829	4283893	5	7
36313949	4163872	2	2
40652575	3001247	1	1
43053692	4142905	1	1
44364046	1549786	0	0
44339986	1115171	2	3
43531061	81893	8	9
45622867	1112807	0	0
44348246	738818	0	0
45658426	19073188	2	3
45649292	1501700	0	0
45645390	19079524	1	1
45667335	19008572	2	3
45671550	1548195	0	0
45698633	1713332	0	0
45630924	1174888	0	0
45779836	1551099	0	0
45703866	1112807	0	0
45702599	19079524	2	3
46242641	40223834	2	3
46241095	1177480	0	0
45803357	738818	0	0
46242083	757627	0	0
46290144	1115008	0	0
45796662	1367571	0	0
46312466	1125315	0	0
46302087	43012036	2	3
1115170	1115171	1	1
3048257	3005136	2	2
21502613	1115008	1	1
21604635	708298	2	2
36153018	1549786	0	0
35802829	4156265	5	7
36313949	4058899	2	2
40652611	3045716	1	1
40064724	19019273	1	1
44364091	1149380	0	0
45620074	40228230	2	3
43531061	198809	6	6
45622971	1112807	0	0
44348247	1713332	0	0
45658398	40232448	2	3
45649304	1305058	0	0
45645390	46275916	1	1
45667273	40223768	2	3
45671582	1548195	0	0
45698789	1500211	0	0
45631066	1539403	0	0
45779837	975125	0	0
45702242	1112807	0	0
45699406	19078461	2	3
46242719	40232448	2	3
46238232	1177480	0	0
45803452	738818	0	0
46242374	715997	0	0
46290148	1367571	0	0
45796813	1741122	0	0
46312710	1125315	0	0
46301817	19077344	2	3
3005833	3000963	1	1
3048273	3036780	2	2
21502621	1759842	1	1
21505881	1557272	2	2
36153020	1129625	0	0
35802829	4132546	5	7
36304718	3045716	2	2
40652614	3020655	1	1
40064724	1115171	1	1
44364094	738818	0	0
45620337	19008572	2	3
43531061	4166224	6	7
45622747	1112807	0	0
44348213	1551099	0	0
45658401	44816277	2	3
45649467	1124300	0	0
45657708	19079524	1	1
45667466	19133768	2	3
45671584	1153428	0	0
45698341	1729720	0	0
45630738	1332418	0	0
45779851	1110410	0	0
45702392	1112807	0	0
45779814	19079524	2	3
46242680	40229134	2	3
46238242	1177480	0	0
45800897	738818	0	0
46242380	967823	0	0
46289870	1124300	0	0
45796813	1746114	0	0
46312942	1125315	0	0
46299553	40229134	2	3
3006343	3004501	1	1
3048273	3023430	2	2
21502537	1367571	1	1
21604147	1557272	2	2
36153023	1125315	0	0
35802829	4043241	9	10
36304718	3019550	2	2
40652870	3016723	1	1
40067083	19133873	1	1
44364252	1309944	0	0
45619848	19059056	2	3
43531061	196456	5	5
45621130	1112807	0	0
44348214	1174888	0	0
45657513	19075001	2	3
45649380	1000560	0	0
45651287	46275916	1	1
45667466	40162522	2	3
45671595	1545958	0	0
45698344	1110410	0	0
45631001	1115008	0	0
45779862	1713332	0	0
45702458	1112807	0	0
45684416	40228214	2	3
46242773	40229134	2	3
45897149	1177480	0	0
45800931	738818	0	0
46242381	1110410	0	0
46289399	1192710	0	0
45796860	1332418	0	0
46312958	1125315	0	0
46299563	19008572	2	3
3006343	3016723	1	1
3048273	3005136	2	2
21500563	715997	1	1
21604606	708298	2	2
36153023	1119510	0	0
35802829	4218389	4	5
36304718	3015632	2	2
40653596	3023103	1	1
40067083	19133905	1	1
44364318	1124300	0	0
45619912	19075601	2	3
43531061	4266809	5	5
45621943	1112807	0	0
44348247	1759842	0	0
45657595	19133768	2	3
45649479	19127890	0	0
45651287	19079524	1	1
45666362	40232448	2	3
45671552	1154343	0	0
45698865	1549786	0	0
45676640	1110410	0	0
45779864	1322184	0	0
45699494	1112807	0	0
45681302	40228214	2	3
46242883	19008572	2	3
45897365	1177480	0	0
45801090	738818	0	0
46242477	723013	0	0
46289403	933724	0	0
45796987	1326303	0	0
46312962	1125315	0	0
46298835	19133873	2	3
3006343	3013682	1	1
3051542	3024561	2	2
21500578	1125315	1	1
21602861	46275444	2	2
36153566	1107830	0	0
35802829	40486433	7	9
36304718	3023103	2	2
40653626	3020630	1	1
40064205	19078924	1	1
44364321	1307863	0	0
45620133	19075001	2	3
43531061	4285898	4	8
45621389	1112807	0	0
44341413	1307863	0	0
45657842	19008572	2	3
45649479	1512674	0	0
45654553	19079524	1	1
45663597	1124300	0	0
45671558	1115008	0	0
45698865	1589505	0	0
45676641	1713332	0	0
45779939	1332418	0	0
45699668	1112807	0	0
45681302	40228230	2	3
46242888	40162522	2	3
45897219	1177480	0	0
45801046	738818	0	0
46242350	1000560	0	0
46289407	1174888	0	0
45796780	1326303	0	0
46312697	1125315	0	0
46299245	1107882	2	3
3001019	3009201	1	1
3051542	3020630	2	2
21500578	1112807	1	1
21604200	19078219	2	2
36153533	1125315	0	0
35802829	4280726	7	9
36304718	3014576	2	2
40653646	3006734	1	1
42868771	3013682	1	1
44364356	1332418	0	0
45620047	19133768	2	3
43531061	195588	4	6
45621419	1112807	0	0
44341556	715997	0	0
45657683	1115171	2	3
45649479	1549786	0	0
45623803	19079524	1	1
45660110	1124957	0	0
45671562	1308738	0	0
45698756	1124957	0	0
45676644	1107830	0	0
45708116	1551099	0	0
45699674	1112807	0	0
45681630	40228214	2	3
46242962	1127433	2	3
45897335	1177480	0	0
45800777	738818	0	0
46239745	1110410	0	0
46290025	1192710	0	0
45796801	738818	0	0
46313043	1125315	0	0
46301505	40232448	2	3
3001019	3008598	1	1
3051542	3006906	2	2
21500586	1125315	1	1
21602868	1768849	2	2
36153533	1129625	0	0
35802829	378001	7	9
36304850	3014576	2	2
40654005	3026361	1	1
42870588	3010813	1	1
44364307	975125	0	0
44778130	19133905	2	3
43531061	4310024	4	5
45665080	1112807	0	0
44341563	1332418	0	0
45657688	19133905	2	3
45649480	1149196	0	0
45624204	46275916	1	1
45659906	1153428	0	0
45671631	975125	0	0
45698654	1326303	0	0
45676716	1713332	0	0
45708180	1124300	0	0
45696059	1112807	0	0
45779618	19079524	2	3
46242823	40231925	2	3
45897465	1177480	0	0
45801150	738818	0	0
46239601	1332418	0	0
46290042	1124957	0	0
45796802	914335	0	0
46313055	1125315	0	0
46301574	19073188	2	3
3001643	3000963	1	1
3051542	3013721	2	2
21500586	1112807	1	1
21602868	1778162	2	2
36153535	1125315	0	0
35802829	375671	7	9
36304850	3045716	2	2
40654026	3010813	1	1
42870592	3000963	1	1
44364081	1149380	0	0
44361327	1115171	2	3
43531061	440448	7	7
45664973	1112807	0	0
44341119	1738521	0	0
45657542	1551192	2	3
45649492	738818	0	0
45654578	19079524	1	1
45659660	715997	0	0
45671540	1124957	0	0
45698670	967823	0	0
45627802	1501700	0	0
45766064	45766064	0	0
45696226	1112807	0	0
45681643	40228214	2	3
46242831	40232448	2	3
45897363	1177480	0	0
45799770	738818	0	0
46239690	1124300	0	0
46290150	705944	0	0
45796803	715997	0	0
46313058	1125315	0	0
46301854	19078924	2	3
3001643	3009542	1	1
3051542	3004501	2	2
21500138	1500211	1	1
21502568	1713332	2	2
36153535	1129625	0	0
35802829	378419	7	8
36304850	3019550	2	2
40654106	3007461	1	1
42870592	3024731	1	1
44364083	920293	0	0
44361601	19133873	2	3
44362457	19127918	2	2
45665093	1112807	0	0
44341541	1545958	0	0
45657787	40231925	2	3
45649493	1367571	0	0
45645423	19079524	1	1
45659661	1153428	0	0
45673012	1549786	0	0
45698808	1192710	0	0
45627790	791967	0	0
45708224	1548195	0	0
45696183	1112807	0	0
45675071	40228214	2	3
46242985	19008572	2	3
45897378	1177480	0	0
45798069	738818	0	0
46239754	1738521	0	0
46290182	975125	0	0
45796850	1728416	0	0
46313186	1125315	0	0
46301985	42707627	2	3
4145627	196456	1	1
3051542	3027970	2	2
21500138	1548195	1	1
21502571	19129144	2	2
36153536	1125315	0	0
21602496	1519937	1	4
36304850	3023103	2	2
40653762	3019550	1	1
42870592	3002385	1	1
44364110	740275	0	0
44347014	40236446	2	3
44347728	19128009	2	2
45665187	1112807	0	0
44341569	1124300	0	0
45657790	1107882	2	3
45631754	1174888	0	0
45624739	19079524	1	1
45659665	738818	0	0
45673016	1549786	0	0
45698814	1115008	0	0
45628253	1000560	0	0
45708370	1000560	0	0
45696454	1112807	0	0
45779784	19079524	2	3
46242804	40229134	2	3
45895110	1177480	0	0
45798274	738818	0	0
46239526	1149196	0	0
46289920	1174888	0	0
45796734	1149196	0	0
46313127	1125315	0	0
46299709	19008572	2	3
1125448	19029476	1	1
3051542	3016723	2	2
21500140	1519936	1	1
21502571	1595799	2	2
36153536	1119510	0	0
21603458	43012036	1	4
36304850	3015632	2	2
40653836	3009201	1	1
42870592	3007461	1	1
44364134	1549786	0	0
44360994	19018935	2	3
44362687	19128009	2	2
45665020	1112807	0	0
44341570	1149196	0	0
45654379	19018935	2	3
45632048	705944	0	0
45627081	19079524	1	1
45660082	1322184	0	0
45673016	1589505	0	0
45698815	791967	0	0
45628238	1000560	0	0
45708371	1326303	0	0
45696322	1112807	0	0
45699679	40223768	2	3
46242971	19018935	2	3
45895225	1177480	0	0
45798261	738818	0	0
46239701	1539403	0	0
46290275	1551099	0	0
45796903	1500211	0	0
46313131	1125315	0	0
46295715	1115171	2	3
4087571	4295880	1	1
3051542	3035995	2	2
21500140	975125	1	1
21502571	19054876	2	2
36153544	1115008	0	0
21603458	19112599	1	4
36403211	40480160	2	2
40653838	3008598	1	1
42870592	3009542	1	1
44364140	1396131	0	0
44341513	19019273	2	3
44357905	19128009	2	2
45665192	1112807	0	0
44341453	1192710	0	0
45654387	40229134	2	3
45632089	1307863	0	0
45625216	46275916	1	1
45659917	738818	0	0
45673016	19127890	0	0
45698350	1778162	0	0
45628372	1154029	0	0
45708228	1545958	0	0
45693144	1112807	0	0
45675226	19078461	2	3
46242931	40163554	2	3
45894320	1177480	0	0
45798397	738818	0	0
46240251	1589505	0	0
46289942	967823	0	0
45796858	1332418	0	0
46312871	1125315	0	0
46295502	19059056	2	3
442013	4299128	1	1
3051542	3006923	2	2
21500144	1503184	1	1
21502571	19127890	2	2
36153546	1119510	0	0
21603503	19125062	1	4
36302180	4163872	2	2
40653900	3013682	1	1
42870592	3026361	1	1
44364155	933724	0	0
44347251	19019273	2	3
44351995	42902245	2	2
45662482	1112807	0	0
44341107	1107830	0	0
45654390	19075001	2	3
45632172	1738521	0	0
45625279	19079524	1	1
45659974	1551099	0	0
45673028	1115008	0	0
45698521	914335	0	0
45628375	1501700	0	0
45708232	975125	0	0
45693233	1112807	0	0
45687367	19078461	2	3
46243069	40162522	2	3
45894496	1177480	0	0
45798293	738818	0	0
46240262	1174888	0	0
46290237	1124957	0	0
45796981	1124957	0	0
46312877	1125315	0	0
46295421	19074843	2	3
442013	4296205	1	1
3049219	3023430	2	2
21500144	1589505	1	1
21502571	1503184	2	2
36153663	1125315	0	0
21603503	40223834	1	4
36302180	4052083	2	2
40171019	40169216	1	1
42868693	3016723	1	1
44364175	715997	0	0
44354453	19019273	2	3
44357871	40232448	2	3
45662586	1112807	0	0
44341325	1738521	0	0
45654313	40231925	2	3
45632166	1332418	0	0
45668479	46275916	1	1
45660113	1539403	0	0
45673029	1589505	0	0
45698357	1501700	0	0
45628290	1713332	0	0
45708203	1332418	0	0
45693259	1112807	0	0
45783935	19078461	2	3
46242744	1115171	2	3
45894498	1177480	0	0
45795690	738818	0	0
46240241	1343916	0	0
46290173	1549786	0	0
45796749	1551099	0	0
46312928	1125315	0	0
46295704	40232448	2	3
1127524	1127433	1	1
3049219	3005136	2	2
21500144	1548195	1	1
21502571	19127922	2	2
36153672	1129625	0	0
21603503	1107882	1	4
36303152	4010253	2	2
40173589	40173590	1	1
42868693	3013682	1	1
44364178	1107830	0	0
44339811	19019273	2	3
44357909	43012036	2	3
45662501	1112807	0	0
44341330	1115008	0	0
45654243	19077572	2	3
45631861	1124300	0	0
45667190	46275916	1	1
45660066	1115008	0	0
45673030	1501700	0	0
45698744	1149196	0	0
45628290	1759842	0	0
45708337	1115008	0	0
45694890	1112807	0	0
45674953	40223768	2	3
46240720	40229134	2	3
45894461	1177480	0	0
45796925	738818	0	0
45896226	1713332	0	0
46290249	1115008	0	0
45796750	1361711	0	0
46312934	1125315	0	0
46296103	19008572	2	3
1127524	40231925	1	1
3049225	3036780	2	2
21500144	1521369	1	1
21502571	1548195	2	2
36153674	1125315	0	0
21603503	1150837	1	4
36302175	4234705	2	2
37522265	4330583	1	1
42868693	3004501	1	1
44364061	1177480	0	0
44354542	19073183	2	3
44357990	1115171	2	3
45662359	1112807	0	0
44340665	1000560	0	0
45654447	40229134	2	3
45631862	1501700	0	0
45666441	46275916	1	1
45660075	1149196	0	0
45673037	1549786	0	0
45698747	1521369	0	0
45628394	738818	0	0
45778138	1595799	0	0
45693449	1112807	0	0
45690604	19078461	2	3
45799694	19078461	2	3
45803106	1177480	0	0
45792831	738818	0	0
45896226	1759842	0	0
46290212	1545958	0	0
45796818	1549786	0	0
46313223	1125315	0	0
46295984	1127433	2	3
1127524	40162522	1	1
3049225	3023430	2	2
21500144	1595799	1	1
21502571	1515774	2	2
36153689	1129625	0	0
21603503	40223821	1	4
36302175	4181917	2	2
40796088	3014599	3	3
42868769	3024561	1	1
44364071	1174888	0	0
44343548	19075001	2	3
44358114	1115171	2	3
45662513	1112807	0	0
44340668	1717327	0	0
45654506	19078924	2	3
45632191	1589505	0	0
45660798	46275916	1	1
45660135	1110410	0	0
45673037	1521369	0	0
45698747	1548195	0	0
45628408	1153428	0	0
45778138	1308738	0	0
45687677	1112807	0	0
45671741	19078461	2	3
46240081	19078461	2	3
45802969	1177480	0	0
45791978	738818	0	0
45896227	1115008	0	0
46290286	975125	0	0
45796818	1521369	0	0
46313074	1125315	0	0
46296244	35605482	2	3
4178367	4047491	4	5
3049225	3005136	2	2
21500144	19054876	1	1
21502571	1589505	2	2
36153696	1177480	0	0
21603503	1150771	1	4
36313965	4052083	2	2
36303160	4314290	3	3
42868769	3006906	1	1
44364076	1717327	0	0
44361299	19019273	2	3
44358275	40236824	2	3
45662603	1112807	0	0
44340670	1118084	0	0
45654507	19123231	2	3
45631871	1124957	0	0
45658052	46275916	1	1
45660137	1729720	0	0
45673147	1124957	0	0
45697636	1192710	0	0
45628503	1124300	0	0
45777946	967823	0	0
45687537	1112807	0	0
45671787	19078461	2	3
45778285	19078461	2	3
45803289	1177480	0	0
45790243	738818	0	0
45896231	1115008	0	0
46290105	1149196	0	0
45796996	1332418	0	0
46313079	1125315	0	0
46296247	19059056	2	3
4115390	4329847	4	5
3049228	3036780	2	2
21500134	19127890	1	1
21502571	1512674	2	2
36153697	1125315	0	0
21603491	40228214	1	4
36313965	4163951	2	2
36902285	443279	3	3
42868770	3000963	1	1
44364078	1310149	0	0
44343607	19075001	2	3
44358121	19019273	2	3
45662663	1112807	0	0
44340641	1174888	0	0
45654371	19008572	2	3
45631986	1741122	0	0
45654823	19115351	1	1
45660144	1154343	0	0
45673037	19127890	0	0
45697782	1551099	0	0
45628381	1000560	0	0
45778208	1539403	0	0
45687727	1112807	0	0
45782480	19078461	2	3
45694824	19078461	2	3
45803117	1177480	0	0
45790249	738818	0	0
45896257	1738521	0	0
46290321	1501700	0	0
45796907	1332418	0	0
46307535	1125315	0	0
46296184	1115171	2	3
4091532	4285898	4	5
3049228	3023430	2	2
21500134	1515774	1	1
21502571	19133679	2	2
36153762	1107830	0	0
21603491	40228230	1	4
36313965	4195803	2	2
40796119	3002385	3	3
42868771	3016723	1	1
44364212	753626	0	0
44343317	19019273	2	3
44354488	35605482	2	3
45662742	1112807	0	0
44340644	1500211	0	0
45651952	19078461	2	3
45631986	1746114	0	0
45648430	46275916	1	1
45660146	1738521	0	0
45673337	975125	0	0
45697551	791967	0	0
45627848	1107830	0	0
45777957	920293	0	0
45685506	1112807	0	0
45784470	19078461	2	3
45703547	19075001	2	3
45803327	1177480	0	0
45790606	738818	0	0
45896210	1322184	0	0
46290329	1192710	0	0
45796968	1153428	0	0
46307761	1125315	0	0
46295588	19133905	2	3
4172024	4169137	4	5
3049228	3005136	2	2
21500134	19054876	1	1
21502571	1521369	2	2
36153766	1119510	0	0
35502623	4144583	3	4
36214642	40236824	1	2
40796119	3024731	3	3
42709780	44783196	1	1
44364123	1713332	0	0
45619857	40223834	2	3
44354613	35605482	2	3
45662846	1112807	0	0
44340648	1308738	0	0
45652237	19018935	2	3
45631991	1174888	0	0
45648772	19079524	1	1
45660057	1174888	0	0
45673344	1738521	0	0
45697480	723013	0	0
45627841	1153428	0	0
45777937	715997	0	0
45684465	1112807	0	0
45782365	19078461	2	3
45675663	19075001	2	3
45800510	1177480	0	0
45787559	738818	0	0
45896218	1309944	0	0
46289678	1551099	0	0
45796877	1332418	0	0
46307504	1125315	0	0
46295703	19133905	2	3
4172024	442116	4	5
3049249	3036780	2	2
21500134	1548195	1	1
21502571	1549786	2	2
36153771	1112807	0	0
21602858	46275444	3	4
36215230	19023423	1	2
36703477	380378	3	3
42808846	19008572	2	3
44364191	1545958	0	0
45619857	40223821	2	3
44354674	40236824	2	3
45661458	1112807	0	0
44340652	1110410	0	0
45650892	19008572	2	3
45631992	1154029	0	0
45645191	19079524	1	1
45659761	1539403	0	0
45673369	1149196	0	0
45697556	1549786	0	0
45627845	1149196	0	0
45777950	1149196	0	0
45684580	1112807	0	0
45779888	19078461	2	3
45778209	46233710	2	3
45800495	1177480	0	0
45787829	738818	0	0
45896253	1361711	0	0
46290219	1332418	0	0
45796878	975125	0	0
46307863	1125315	0	0
46295703	19133873	2	3
4172024	4102123	4	5
3049249	3023430	2	2
21500144	1515774	1	1
21500270	1545958	2	2
36154120	1125315	0	0
21603446	40229134	3	4
36215361	40220960	1	2
36703534	4001336	3	3
42808448	1115171	2	3
44364302	1149196	0	0
44347070	1545959	2	3
44354413	40236824	2	3
45659703	1112807	0	0
44340671	19003953	0	0
45650982	40162522	2	3
45632003	1501700	0	0
45642595	46275916	1	1
45659860	1115008	0	0
45673417	1322184	0	0
45697599	723013	0	0
45627938	1741122	0	0
45778140	967823	0	0
45681443	1112807	0	0
45674985	19078461	2	3
45778209	46233988	2	3
45800591	1177480	0	0
45787871	738818	0	0
45896284	1539403	0	0
46291928	1501700	0	0
45797002	1000560	0	0
46307864	1125315	0	0
46291236	40223768	2	3
4172024	439406	4	5
3049249	3005136	2	2
21500134	1589505	1	1
21500270	1332418	2	2
36154122	1115008	0	0
21603255	40169281	3	4
36002880	80809	1	2
36702253	4218389	3	3
42809410	1115171	2	3
44364201	1177480	0	0
44357639	1545959	2	3
44354772	40229134	2	3
45656533	1112807	0	0
44340731	1115008	0	0
45650919	19074843	2	3
45632004	1174888	0	0
45642615	19115351	1	1
45659866	1115008	0	0
45673038	1000560	0	0
45697481	1153428	0	0
45627938	1746114	0	0
45778220	1539403	0	0
45681101	1112807	0	0
45672260	19078461	2	3
45789435	19075001	2	3
45800704	1177480	0	0
45786216	738818	0	0
45896285	740275	0	0
46291540	1107830	0	0
45796737	1343916	0	0
46307780	1125315	0	0
46244890	19078461	2	3
4172024	4306014	4	5
3049512	3036780	2	2
21500134	1500211	1	1
21500334	1112807	2	2
36153999	1125315	0	0
35802829	195588	4	4
36224525	46233988	1	2
40796134	3010813	3	3
42807861	1127433	2	3
44364207	1746114	0	0
44361502	1545959	2	3
44354773	920334	2	3
45656534	1112807	0	0
44340743	1110410	0	0
45651160	40228214	2	3
45632006	738818	0	0
45636329	19079524	1	1
45623144	19128009	3	4
45673312	1174888	0	0
45697489	1778162	0	0
45627850	1124300	0	0
45778223	1551099	0	0
45681198	1112807	0	0
45681329	1332419	2	3
45791746	19079524	2	3
45800842	1177480	0	0
45786231	738818	0	0
45896276	19002770	0	0
46291545	1115008	0	0
45797105	1107830	0	0
46307935	1125315	0	0
46239821	40232448	2	3
4172024	438614	4	5
3049512	3023430	2	2
21500134	1521369	1	1
21500334	1119510	2	2
36153713	1124957	0	0
21603550	967823	4	4
36224525	46233710	1	2
40779592	3001247	3	3
42808572	19008572	2	3
44364207	1741122	0	0
44353948	19019273	2	3
44354803	19008572	2	3
45656439	1112807	0	0
44340753	1738521	0	0
45648164	40236824	2	3
45632131	1149196	0	0
45636592	19127922	1	1
45667443	19128009	3	4
45673398	1521369	0	0
45697496	1717327	0	0
45627895	1501700	0	0
45778025	1551099	0	0
45681661	1112807	0	0
45693292	19078461	2	3
46242359	19078461	2	3
45797886	1177480	0	0
45786363	738818	0	0
45896365	1124300	0	0
46291547	1310149	0	0
45796884	1729720	0	0
46307943	1125315	0	0
46240115	40223834	2	3
4172024	4302207	4	5
3049512	3005136	2	2
21500134	1512674	1	1
21500334	1125315	2	2
36153998	1125315	0	0
21603550	1343916	4	4
36224758	40222846	1	2
40779592	3015076	3	3
42804716	19126352	2	3
44364236	791967	0	0
44350410	19075601	2	3
44354695	1713671	2	3
45656617	1112807	0	0
44340757	1310149	0	0
45648173	19077344	2	3
45632139	1102527	0	0
45636592	19133679	1	1
45657003	19127922	3	4
45673101	738818	0	0
45697500	1551099	0	0
45627932	1149196	0	0
45778000	1124957	0	0
45679409	1112807	0	0
45678167	19078461	2	3
45786949	1107882	2	3
45797650	1177480	0	0
46296945	738818	0	0
45896330	1521369	0	0
46292005	1738521	0	0
45797108	967823	0	0
46307446	1125315	0	0
46240057	40232448	2	3
4172024	4048169	4	5
3049537	3036780	2	2
21500134	40221415	1	1
21500334	1129625	2	2
36154201	1738521	0	0
21603550	914335	4	4
36214852	42707627	1	2
40779570	3004501	3	3
42805045	40231925	2	3
44364222	1149380	0	0
44354075	40223768	2	3
44354815	19008572	2	3
45653045	1112807	0	0
44340813	1115008	0	0
45648061	40236824	2	3
45632213	738818	0	0
45636592	19129144	1	1
45638509	19127918	3	4
45671670	1174888	0	0
45697785	1154029	0	0
45627935	1107830	0	0
45778001	1124300	0	0
45678159	1112807	0	0
45699600	19078461	2	3
46291098	1107882	2	3
45795235	1177480	0	0
46297120	738818	0	0
45896439	933724	0	0
46291656	1539403	0	0
45797109	1174888	0	0
46307714	1125315	0	0
45896411	40232448	2	3
4172024	4304110	4	5
3049537	3023430	2	2
21500134	1549786	1	1
21500334	738818	2	2
36153971	1119510	0	0
21603550	1124300	4	4
36221329	19045231	1	2
40796115	3027231	3	3
42802493	1154615	2	3
44364352	740275	0	0
44357564	19075001	2	3
44351039	46275444	2	3
45653202	1112807	0	0
44340758	1124300	0	0
45648270	1115171	2	3
45631875	1717327	0	0
45633559	46275916	1	1
45661465	40223768	2	3
45671664	1713332	0	0
45697316	1332418	0	0
45627976	920293	0	0
45778104	1728416	0	0
45678329	1112807	0	0
45782152	19078461	2	3
45784935	1545959	2	3
45795131	1177480	0	0
46297520	738818	0	0
45896482	1738521	0	0
46241841	1551099	0	0
45796739	1149196	0	0
46307718	1125315	0	0
45896413	1115171	2	3
4103320	4280726	4	5
3049537	3005136	2	2
21500144	19127890	1	1
21500330	1112807	2	2
36154129	1112807	0	0
21603550	975125	4	4
36221330	19045231	1	2
40776230	3028833	3	3
42802591	1551192	2	3
44364245	1192710	0	0
44346926	19073183	2	3
44351164	35605482	2	3
45649962	1112807	0	0
44340778	1729720	0	0
45647865	19059056	2	3
45632019	738818	0	0
45630317	46275916	1	1
45661437	19078461	2	3
45671700	1549786	0	0
45695221	1174888	0	0
45627958	1713332	0	0
45705875	1115008	0	0
45678406	1112807	0	0
45782279	19078461	2	3
45685263	1107882	2	3
45795254	1177480	0	0
46292863	738818	0	0
45896357	1332418	0	0
46241855	705944	0	0
45797015	1154029	0	0
46307620	1125315	0	0
45896554	40229134	2	3
4103320	40486433	4	5
3053269	3023430	2	2
21500144	1512674	1	1
21500334	1192710	2	2
36154129	1125315	0	0
35506542	4144583	4	4
36225993	964261	1	2
36314523	4024958	3	3
42802374	40231925	2	3
44364289	738818	0	0
44357586	1107882	2	3
44351102	19019273	2	3
45650037	1112807	0	0
44340820	1149380	0	0
45648290	1127433	2	3
45632146	1107830	0	0
45631162	19079524	1	1
45661715	40232448	2	3
45671700	1589505	0	0
45695188	1713332	0	0
45676354	1174888	0	0
45705876	1589505	0	0
45674863	1112807	0	0
45672495	19078461	2	3
45673042	1107882	2	3
45795270	1177480	0	0
46293304	738818	0	0
45896357	1545958	0	0
46241859	19127890	0	0
45796893	1149196	0	0
46307627	1125315	0	0
45896418	19019273	2	3
4027384	80809	4	5
3053269	3036780	2	2
21500144	1549786	1	1
21500334	1177480	2	2
36154004	1125315	0	0
21602514	19128009	4	4
36214806	43012036	1	2
40796098	3015632	3	3
42802775	1127433	2	3
44364337	975125	0	0
44357687	1545959	2	3
44351171	19008572	2	3
45646809	1112807	0	0
44340822	1332418	0	0
45648258	1115171	2	3
45632237	1549786	0	0
45627572	46275916	1	1
45661369	19079524	2	3
45671712	1000560	0	0
45695200	1000560	0	0
45676360	1713332	0	0
45705565	1192710	0	0
45675301	1112807	0	0
45699473	19078461	2	3
45694465	1107882	2	3
45795279	1177480	0	0
46296565	738818	0	0
45896268	1153428	0	0
46241859	1549786	0	0
45797016	1713332	0	0
46308128	1125315	0	0
45896419	40223834	2	3
4103183	313217	4	5
3053269	3005136	2	2
21500146	19128263	1	1
21500292	1129625	2	2
36154008	1192710	0	0
35502087	140673	4	4
36214806	19112599	1	2
37119628	45769019	3	3
42802869	46233710	2	3
44364338	1107830	0	0
44357409	1332419	2	3
44351174	19133905	2	3
45646925	1112807	0	0
44340981	738818	0	0
45648252	40232448	2	3
45632237	19127890	0	0
45624599	46275916	1	1
45661727	19073183	2	3
45670025	1778162	0	0
45695206	1149196	0	0
45676362	1738521	0	0
45705566	1149196	0	0
45672057	1112807	0	0
45706079	1127433	2	3
45786733	19075001	2	3
45795301	1177480	0	0
46296728	738818	0	0
45896332	1149196	0	0
46241859	1512674	0	0
45796915	1332418	0	0
46308228	1125315	0	0
45894525	19077572	2	3
4086181	4001336	4	6
3049843	3023430	2	2
21500146	42902245	1	1
21500292	1192710	2	2
36154123	1129625	0	0
21602537	19133679	4	4
36221413	19006318	1	2
36702242	4029498	3	3
42802982	1127433	2	3
44364358	1192710	0	0
44350810	19075601	2	3
44351174	19133873	2	3
45647039	1112807	0	0
44340769	738818	0	0
45648026	19075601	2	3
45632237	1515774	0	0
45624738	46275916	1	1
45661396	46275444	2	3
45670026	1124300	0	0
45695222	1115008	0	0
45676611	1153428	0	0
45705822	1539403	0	0
45672390	1112807	0	0
45706079	19078461	2	3
45800056	1107882	2	3
45792721	1177480	0	0
46288885	738818	0	0
45896396	975125	0	0
46241961	1124957	0	0
45797041	1000560	0	0
46308235	1125315	0	0
45894248	19133905	2	3
4148948	4336464	4	6
3049843	3005136	2	2
21500146	19128022	1	1
21500333	914335	2	2
36154008	1112807	0	0
21602537	19129144	4	4
36224759	40222846	1	2
40779561	3000963	3	3
44355667	40229134	2	3
44356888	1000560	0	0
44348480	19075601	2	3
44351151	19019273	2	3
45647075	1112807	0	0
44340936	1343916	0	0
45644900	40236824	2	3
45632240	1174888	0	0
45668804	46275916	1	1
45660228	19019273	2	3
45669995	1326303	0	0
45695190	1332418	0	0
45676613	1768849	0	0
45705926	1713332	0	0
45672483	1112807	0	0
45699470	19078461	2	3
45673059	1107882	2	3
45792791	1177480	0	0
46291649	738818	0	0
45896342	1309944	0	0
46241967	1332418	0	0
45797058	1521369	0	0
46308266	1125315	0	0
45894171	19133905	2	3
4028902	4010253	4	6
3049843	3036780	2	2
21500137	19127922	1	1
21500333	1192710	2	2
36154124	967823	0	0
21602537	19127922	4	4
36221043	40236446	1	2
40779561	3009542	3	3
44355669	19133905	2	3
44356890	1149380	0	0
44343593	19075601	2	3
44347269	19075001	2	3
45647206	1112807	0	0
44340937	1713332	0	0
45645092	1115171	2	3
45632245	1308738	0	0
45668850	19074679	1	1
45658296	19075601	2	3
45670043	967823	0	0
45695148	757627	0	0
45676638	1322184	0	0
45705932	1501700	0	0
45784360	1112807	0	0
45675089	19078461	2	3
45697261	1107882	2	3
45790070	1177480	0	0
46243599	738818	0	0
45896449	1361711	0	0
46242106	975125	0	0
45797088	1174888	0	0
46307695	1125315	0	0
45894228	40223834	2	3
4027384	440448	4	6
3049861	3036780	2	2
21500137	19133679	1	1
21500341	1119510	2	2
36154024	1177480	0	0
21604180	19002770	4	4
36221423	19133905	1	2
40776231	3013682	3	3
44355670	19008572	2	3
44356905	1149380	0	0
44343330	19075601	2	3
44347396	19133873	2	3
45647090	1112807	0	0
45634281	19078461	2	3
45645115	40232448	2	3
45633986	1738521	0	0
45666974	19079524	1	1
45658090	40223834	2	3
45670153	1326303	0	0
45695153	1308738	0	0
45676615	1107830	0	0
45705936	738818	0	0
45784335	1112807	0	0
45784198	19078461	2	3
45797347	1107882	2	3
45790078	1177480	0	0
46243487	738818	0	0
45896370	791967	0	0
46242017	1149196	0	0
45796897	1310149	0	0
46307917	1125315	0	0
45894355	1115171	2	3
4027384	255848	4	7
3049861	3005136	2	2
21500137	19129144	1	1
21500341	1129625	2	2
36154043	1154343	0	0
21604180	742185	4	4
36221423	19133873	1	2
40776231	3016723	3	3
44355505	40232448	2	3
44356911	1738521	0	0
44361656	19075601	2	3
44347398	19075001	2	3
45646136	1112807	0	0
45634705	42707627	2	3
45645076	19078461	2	3
45634094	1115008	0	0
45664408	46275916	1	1
45704092	40232448	2	3
45670173	1551099	0	0
45695155	1361711	0	0
45676180	1124300	0	0
45705651	1124300	0	0
45786468	1112807	0	0
45779546	19078461	2	3
45802331	1332419	2	3
45789700	1177480	0	0
46243586	738818	0	0
45896435	1153428	0	0
46242020	1115008	0	0
45797019	738818	0	0
46308117	1125315	0	0
45894519	19077572	2	3
4027384	40481087	4	7
3049861	3023430	2	2
21013457	19074679	1	1
21500341	738818	2	2
36154046	1119510	0	0
35802134	4027663	4	4
36221147	19078924	1	2
37119620	45769019	3	3
44355967	1551192	2	3
44357030	757627	0	0
44354434	19075601	2	3
44347528	40163554	2	3
45644096	1112807	0	0
45634760	1115171	2	3
45645287	920334	2	3
45634198	1149196	0	0
45634967	1125315	0	0
45704143	40224132	2	3
45670174	1361711	0	0
45695159	1153428	0	0
45676214	1343916	0	0
45705800	1124957	0	0
45784381	1112807	0	0
45784099	19078461	2	3
45700324	1107882	2	3
45790141	1177480	0	0
46243811	738818	0	0
45896410	1713332	0	0
46241913	1548195	0	0
45797027	738818	0	0
46307908	1125315	0	0
45799936	19078924	2	3
4027384	28060	4	7
3050719	3036780	2	2
21011215	1154615	1	1
21500341	1192710	2	2
36154046	1125315	0	0
35702115	4116491	2	2
36214580	35605858	1	2
40770375	3023103	3	3
44356088	19126352	2	3
44357088	967823	0	0
45620075	19075601	2	3
44347560	19008572	2	3
45644218	1112807	0	0
45634768	40232448	2	3
45645320	40223834	2	3
45628917	1501700	0	0
45635062	1125315	0	0
45703985	40162522	2	3
45670060	1124300	0	0
45695192	740275	0	0
45676249	1107830	0	0
45705593	1545958	0	0
45782329	1112807	0	0
45696172	19078461	2	3
46240219	1107882	2	3
45790233	1177480	0	0
46243772	738818	0	0
45896606	1549786	0	0
46241913	1521369	0	0
45797028	1154343	0	0
46308179	1125315	0	0
46318162	40229134	2	3
4027384	258780	4	9
3050719	3005136	2	2
19010482	19134077	1	1
21500341	1125315	2	2
36154046	738818	0	0
35702115	440448	2	2
36221422	19133873	1	2
40770375	3016723	3	3
42805286	44816277	2	3
44357143	1545958	0	0
44362608	19075601	2	3
44347460	1115171	2	3
45644141	1112807	0	0
45634736	19008572	2	3
45645320	40223821	2	3
45628940	1107830	0	0
45634959	1125315	0	0
45703956	19008572	2	3
45670072	1115008	0	0
45695128	1548195	0	0
45676187	791967	0	0
45705655	967823	0	0
45782434	1112807	0	0
45681427	19078461	2	3
45700222	1107882	2	3
45787440	1177480	0	0
46243838	738818	0	0
45896606	1521369	0	0
46242025	757627	0	0
45797143	1192710	0	0
46308427	1125315	0	0
46318106	40243436	2	3
441840	80809	3	7
3050719	3023430	2	2
21500575	1112807	1	1
21500330	1129625	2	2
36154047	1119510	0	0
36102976	28060	2	2
36221422	19133905	1	2
40770375	3013682	3	3
44348706	19077572	2	3
44357052	1729720	0	0
44361400	19075601	2	3
44347775	19018935	2	3
45641136	1112807	0	0
45634805	1115171	2	3
45645199	19008572	2	3
45628898	1310149	0	0
45635035	1125315	0	0
45704146	19008572	2	3
45670041	1521369	0	0
45695208	1124957	0	0
45676203	1174888	0	0
45705861	975125	0	0
45782595	1112807	0	0
45782074	19078461	2	3
45785370	1107882	2	3
45787451	1177480	0	0
46241412	738818	0	0
45896606	1595799	0	0
46242123	1149196	0	0
45797175	1153428	0	0
46308335	1125315	0	0
46318256	46233710	2	3
441840	196456	3	9
3050752	3005136	2	2
21502687	19074679	1	1
21500330	1125315	2	2
36154047	1125315	0	0
36002139	439406	2	2
36313966	4048171	7	12
37503868	4057420	3	3
44349131	1127433	2	3
44357145	933724	0	0
44347121	19075601	2	3
44343349	19073183	2	3
45643296	1112807	0	0
45634793	19008572	2	3
45645307	40162522	2	3
45628996	1713332	0	0
45634985	1125315	0	0
45703780	40229134	2	3
45670076	723013	0	0
45695210	1000560	0	0
45676272	1332418	0	0
45705820	1332418	0	0
45782489	1112807	0	0
45693407	1332419	2	3
45700254	19078461	2	3
45696803	1129625	0	0
46241313	738818	0	0
45896607	920293	0	0
46242238	1549786	0	0
46318051	738818	0	0
46302527	1125315	0	0
46322526	40223834	2	3
4027384	4280726	5	8
3050752	3036780	2	2
21502534	40171902	1	1
21500330	1192710	2	2
36153271	1119510	0	0
36002139	317009	2	2
36313966	4166224	7	11
37503868	4337611	3	3
44349113	19023398	2	3
44357147	1115008	0	0
45619935	1539411	2	3
44344789	19008572	2	3
45643805	1112807	0	0
45631466	40229134	2	3
45642139	40231925	2	3
45628996	1759842	0	0
45635093	1125315	0	0
45704033	1127433	2	3
45670218	1759842	0	0
45695178	1149196	0	0
45676277	1174888	0	0
45706058	1713332	0	0
45782619	1112807	0	0
45684543	1332419	2	3
45792139	1107882	2	3
45696823	1129625	0	0
46241529	738818	0	0
45896610	1192710	0	0
46242238	19127890	0	0
46317665	1149196	0	0
46302542	1125315	0	0
45794376	1115171	2	3
4027384	40486433	5	8
3050752	3023430	2	2
21500145	19128065	1	1
21500345	738818	2	2
36153271	738818	0	0
36002139	134438	2	2
36313966	378001	7	11
37521802	4057420	3	3
42802751	19019273	2	3
44357240	1107830	0	0
44347147	40228214	2	3
44344790	42707627	2	3
45641353	1112807	0	0
45631649	40232448	2	3
45643039	40232448	2	3
45629017	1310149	0	0
45635096	1125315	0	0
45703904	19018935	2	3
45670218	1713332	0	0
45695214	1124957	0	0
45673503	1149196	0	0
45706058	1759842	0	0
45782675	1112807	0	0
45784490	1332419	2	3
46291776	1107882	2	3
45802689	1129625	0	0
46238795	738818	0	0
45896392	1000560	0	0
46242242	1501700	0	0
46317548	1115008	0	0
46302645	1125315	0	0
45794483	40229134	2	3
4042641	4336464	5	8
3050759	3036780	2	2
21500145	19127918	1	1
21500345	1192710	2	2
36153271	1125315	0	0
36002139	133834	2	2
36313966	4240902	7	8
40779250	3027970	3	3
44355574	19019273	2	3
44357246	1110410	0	0
44343498	40228214	2	3
44344767	40232448	2	3
45638128	1112807	0	0
45631916	40163554	2	3
45643048	40223768	2	3
45628904	1107830	0	0
45635057	1125315	0	0
45651760	40236446	2	3
45670187	1118084	0	0
45695226	1115008	0	0
45673482	1501700	0	0
45705944	1305058	0	0
45702587	1112807	0	0
45696720	1539411	2	3
45688382	19078461	2	3
45802802	1129625	0	0
46238561	738818	0	0
45896523	975125	0	0
46242172	1115008	0	0
46317411	1115008	0	0
46302551	1125315	0	0
45794397	1115171	2	3
4086181	378001	5	7
3050759	3023430	2	2
21500145	19127904	1	1
21500345	1125315	2	2
36153280	1119510	0	0
36102977	4116491	2	2
36313966	37017711	7	8
40779250	3024561	3	3
42816558	40223834	2	3
44356818	1545958	0	0
44777976	40228214	2	3
44343732	1127433	2	3
45638145	1112807	0	0
45631782	40229134	2	3
45643065	40228230	2	3
45628905	1310149	0	0
45635203	1125315	0	0
45651757	19078924	2	3
45670300	1154343	0	0
45695403	1310149	0	0
45624510	1361711	0	0
45706019	1149196	0	0
45702592	1112807	0	0
45681555	1332419	2	3
45785088	1107882	2	3
45802886	1129625	0	0
46238809	738818	0	0
45896611	1192710	0	0
46242178	19003953	0	0
45793897	1000560	0	0
46302582	1125315	0	0
46312314	40162522	2	3
4027384	81893	5	7
3050759	3005136	2	2
19081471	19008572	1	1
21500345	1129625	2	2
36153941	1177480	0	0
36158993	42902245	2	2
36313966	441267	6	7
37522193	4295880	3	3
42802587	40163554	2	3
44357064	1174888	0	0
44362758	19078461	2	3
44343687	40232448	2	3
45638149	1112807	0	0
45628451	40223768	2	3
45643043	19133768	2	3
45628895	715997	0	0
45635381	1125315	0	0
45651522	40232448	2	3
45670111	1545958	0	0
45695375	1539403	0	0
45624732	1343916	0	0
45705905	1124957	0	0
45702643	1112807	0	0
45702561	1332419	2	3
45778049	1332419	2	3
45802696	1129625	0	0
45897657	738818	0	0
45896619	933724	0	0
46241946	1192710	0	0
45793890	1192710	0	0
46302654	1125315	0	0
46312110	1115171	2	3
4042140	80809	5	6
3052062	3036780	2	2
21013430	19074679	1	1
21500345	1119510	2	2
35603355	40243436	0	0
36159540	42902245	2	2
36313966	4302207	6	7
37522193	4197460	3	3
42802496	1545959	2	3
44357065	1177480	0	0
44339983	40228214	2	3
44343823	1594382	2	3
45638052	1112807	0	0
45628746	43012036	2	3
45643021	40229134	2	3
45629060	723013	0	0
45635118	1125315	0	0
45651641	1107882	2	3
45669908	1149196	0	0
45695498	1713332	0	0
45624733	1174888	0	0
45705539	1107830	0	0
45702739	1112807	0	0
45705655	19079524	2	3
46240704	1107882	2	3
45802950	1129625	0	0
45897927	738818	0	0
45893939	1713332	0	0
46242319	975125	0	0
45794004	1149196	0	0
46302576	1125315	0	0
46312329	40229134	2	3
4042140	441267	5	6
3052062	3023430	2	2
21002731	40221415	1	1
21500345	1112807	2	2
36153996	975125	0	0
36202158	4299128	2	2
36313966	4102123	6	7
40792365	3005136	3	3
42805042	46233988	2	3
44357175	19127890	0	0
44351056	40228214	2	3
44343723	40232448	2	3
45638229	1112807	0	0
45628711	35605482	2	3
45643065	40228214	2	3
45629116	1154343	0	0
45629903	1125315	0	0
45651329	40231925	2	3
45669912	1551099	0	0
45695502	1154343	0	0
45624853	914335	0	0
45705540	708298	0	0
45702661	1112807	0	0
45672363	1332419	2	3
45785677	19079524	2	3
45802910	1129625	0	0
45895542	738818	0	0
45893985	1307863	0	0
46242059	1149196	0	0
45794186	1174888	0	0
46303349	1125315	0	0
46312591	40223834	2	3
4042140	134438	5	7
3052062	3005136	2	2
21002731	19127904	1	1
21500356	1192710	2	2
36153963	1112807	0	0
36202158	4296204	2	2
36313966	4304110	6	7
37303809	4113008	3	3
42805042	46233710	2	3
44357175	1549786	0	0
44341455	19078461	2	3
44344038	40229134	2	3
45634855	1112807	0	0
45628625	40165015	2	3
45643121	40232448	2	3
45629141	1115008	0	0
45629962	1125315	0	0
45651341	35605482	2	3
45669985	740275	0	0
45695504	1000560	0	0
45624854	791967	0	0
45705785	1192710	0	0
45702913	1112807	0	0
45687617	1332419	2	3
46240545	19078461	2	3
45800100	1129625	0	0
45896731	738818	0	0
45893991	1713332	0	0
46242114	1107830	0	0
45794187	1115008	0	0
46302856	1125315	0	0
46312752	19133905	2	3
4042140	4116491	5	7
3051724	3036780	2	2
21002731	19127918	1	1
21500355	1174888	2	2
36153639	1177480	0	0
36202158	4296205	2	2
36313966	4169137	6	7
37303809	4155034	3	3
44348866	1539411	2	3
44357184	1112807	0	0
44361401	40223768	2	3
44344041	19008572	2	3
44361752	975125	0	0
45631132	19008572	2	3
45642194	19019273	2	3
45629084	1361711	0	0
45630143	1125315	0	0
45651447	40163554	2	3
45670143	1124957	0	0
45695285	1549786	0	0
45624956	738818	0	0
45705786	1361711	0	0
45696630	1112807	0	0
45672389	1332419	2	3
45786954	40173590	2	3
45800234	1129625	0	0
45679031	1177480	0	0
45893952	1501700	0	0
46242148	1174888	0	0
45794191	1332418	0	0
46302858	1125315	0	0
46306918	19059056	2	3
4042140	4149245	5	9
3051724	3023430	2	2
21002731	42902245	1	1
21500356	1174888	2	2
36153648	1589505	0	0
36198925	42902245	2	2
36313966	4266809	6	9
37303809	4109685	3	3
44355850	19078924	2	3
44357070	1177480	0	0
45619714	19078461	2	3
45643264	19077344	2	3
44361773	975125	0	0
45631023	1107882	2	3
45642185	40229134	2	3
45629045	738818	0	0
45629885	1125315	0	0
45651717	46233988	2	3
45783634	1557272	0	0
45695285	1589505	0	0
45624797	1174888	0	0
45705787	1192710	0	0
45679978	1177480	0	0
45687542	1332419	2	3
45685363	19078461	2	3
45800152	1129625	0	0
45679149	1177480	0	0
45893998	1000560	0	0
46241987	1332418	0	0
45794192	920293	0	0
46302678	1125315	0	0
46307032	40232448	2	3
4042140	321042	5	9
3051724	3005136	2	2
21002731	19128263	1	1
21500356	1119510	2	2
36153651	1119510	0	0
36152230	19128263	2	2
36313966	198199	6	9
37303809	4152936	3	3
42805188	19073183	2	3
44356828	975125	0	0
45619858	19078461	2	3
45643146	40232448	2	3
44361926	975125	0	0
45631066	1539411	2	3
45642253	40231925	2	3
45629159	967823	0	0
45629866	1125315	0	0
45652256	1107882	2	3
45783636	1728416	0	0
45695139	1154343	0	0
45624800	1149196	0	0
45706043	1551099	0	0
45678072	1177480	0	0
45672304	1332419	2	3
45792034	19078461	2	3
45802288	1129625	0	0
45785945	1177480	0	0
45894168	1548195	0	0
46242190	1124300	0	0
45794197	1149196	0	0
46302701	1125315	0	0
46307109	1127433	2	3
4042140	260139	5	9
3053021	3023430	2	2
21002731	19128009	1	1
21500358	1119510	2	2
36153651	1125315	0	0
36152230	19128022	2	2
36313966	81151	6	11
37303809	4296204	3	3
44355845	1107882	2	3
44356992	1110410	0	0
44346869	19078461	2	3
45643448	19073183	2	3
45655954	975125	0	0
45628783	1107882	2	3
45642240	40165015	2	3
45629161	738818	0	0
45629868	1125315	0	0
45652204	1107882	2	3
45783640	1000560	0	0
45695287	1149196	0	0
45624815	1115008	0	0
45705915	1713332	0	0
45677687	1177480	0	0
45702355	1545959	2	3
45777733	1332419	2	3
45797540	1129625	0	0
45786045	1177480	0	0
45893924	1551099	0	0
46242192	975125	0	0
45794021	1729720	0	0
46302816	1125315	0	0
46311831	40222846	2	3
4042140	40481087	5	9
3053021	3005136	2	2
21002731	19128022	1	1
21500358	1192710	2	2
36153654	1112807	0	0
36009773	4048171	2	2
36313966	258780	6	11
40776269	3024561	3	3
42819196	1107882	2	3
44357071	1309944	0	0
44340062	19078461	2	3
45643534	1551192	2	3
45655965	975125	0	0
45628936	19078461	2	3
45642310	1713671	2	3
45629120	791967	0	0
45629908	1125315	0	0
45652089	19008572	2	3
45783714	715997	0	0
45695265	1501700	0	0
45625043	1154343	0	0
45705915	1759842	0	0
45677682	1177480	0	0
45699690	1539411	2	3
45792268	19019273	2	3
45797437	1129625	0	0
45786674	1177480	0	0
45893954	933724	0	0
46242198	1149196	0	0
45794144	933724	0	0
46302743	1125315	0	0
46307380	1127433	2	3
4042140	4278672	5	9
3053021	3036780	2	2
21506042	1332418	3	3
21500358	1174888	2	2
36153654	1125315	0	0
35809406	4027663	2	2
36313966	40481087	6	10
40776269	3026361	3	3
42802474	1332419	2	3
44357122	1738521	0	0
45619741	19078461	2	3
45643190	19073188	2	3
45652632	975125	0	0
45628890	1332419	2	3
45639269	19008572	2	3
45629164	738818	0	0
45630083	1125315	0	0
45651843	40228214	2	3
45783732	791967	0	0
45695321	1124957	0	0
45624963	708298	0	0
45705923	1322184	0	0
45674527	1177480	0	0
45705822	1539411	2	3
45694307	40173590	2	3
45797446	1129625	0	0
46292423	1177480	0	0
45894007	1332418	0	0
46242151	1548195	0	0
45794236	723013	0	0
46302746	1125315	0	0
46307234	1115171	2	3
4042140	4048695	5	9
3052929	3023430	2	2
21506042	1307863	3	3
21500359	1119510	2	2
36153655	1177480	0	0
35708308	81893	2	2
36313966	4278672	6	10
40776269	3007461	3	3
44348628	19078461	2	3
44357287	975125	0	0
44361591	19078461	2	3
45643192	19008572	2	3
45652770	975125	0	0
45625844	1332419	2	3
45639315	1551192	2	3
45628924	1000560	0	0
45630099	1125315	0	0
45697851	40232448	2	3
45783768	738818	0	0
45695410	967823	0	0
45624831	1332418	0	0
45705893	1192710	0	0
45674985	1177480	0	0
45784834	1539411	2	3
45876038	3010813	2	3
45797858	1129625	0	0
46292508	1177480	0	0
45893969	1107830	0	0
46242310	1154029	0	0
45794154	1713332	0	0
46302777	1125315	0	0
46307194	1115171	2	3
4042140	317576	5	9
3052929	3005136	2	2
21500129	19127890	3	3
21500359	1192710	2	2
36153893	1119510	0	0
35702112	441267	2	2
36313966	4149245	6	10
37320089	134438	3	3
42802894	19078461	2	3
44357289	1713332	0	0
44357490	1545959	2	3
45640292	1545959	2	3
45652891	975125	0	0
45625849	19008572	2	3
45638981	1332419	2	3
45629000	1153428	0	0
45630062	1125315	0	0
45700722	19057271	2	3
45783772	1307863	0	0
45695416	738818	0	0
45670283	1153428	0	0
45705901	1396131	0	0
45674807	1177480	0	0
45779769	1539411	2	3
45876038	3000963	2	3
45797178	1129625	0	0
46293178	1177480	0	0
45894144	1713332	0	0
46242326	1154343	0	0
45794810	1548195	0	0
46303039	1125315	0	0
46307364	1115171	2	3
4042140	196456	5	8
3052929	3036780	2	2
21500129	19054876	3	3
21500359	1125315	2	2
36153899	1129625	0	0
35909435	196456	2	2
36313966	4142905	6	10
40779168	3026361	3	3
42805451	19075601	2	3
44357215	1149380	0	0
44346938	1332419	2	3
45640335	19019273	2	3
45652872	975125	0	0
45625921	40232448	2	3
45635777	19076374	2	3
45628958	1548195	0	0
45630023	1125315	0	0
45700715	40232448	2	3
45783723	1137529	0	0
45695255	1124957	0	0
45670324	1115008	0	0
45705838	1713332	0	0
45675164	1177480	0	0
45693599	19078461	2	3
45675678	1332419	2	3
45797312	1129625	0	0
46293245	1177480	0	0
45894144	1759842	0	0
46242328	1332418	0	0
45794546	1332418	0	0
46302903	1125315	0	0
46307969	19059056	2	3
4042140	255848	5	8
3052932	3036780	2	2
21500129	1521369	3	3
21500353	1125315	2	2
36153899	1125315	0	0
35809320	40480160	2	2
36313966	4001336	6	10
40779168	3010813	3	3
42817786	40228214	2	3
44357289	1759842	0	0
44339989	1545959	2	3
45640424	40232448	2	3
45649544	975125	0	0
45625951	40232448	2	3
45636072	40223834	2	3
45629245	1000560	0	0
45630027	1125315	0	0
45648728	1115171	2	3
45783723	1149380	0	0
45695234	967823	0	0
45670575	1115008	0	0
45705839	1115008	0	0
45675089	1177480	0	0
45702920	1539411	2	3
45685527	19078461	2	3
45797219	1129625	0	0
46293198	1177480	0	0
45893910	1307863	0	0
46242146	1729720	0	0
45794751	1500211	0	0
46303185	1125315	0	0
46307305	19077572	2	3
4042140	28060	5	8
3052932	3023430	2	2
21500129	1500211	3	3
21500353	1119510	2	2
36153915	1112807	0	0
35702767	192671	2	2
36313966	4116491	6	8
36919117	440086	3	3
44355873	40228214	2	3
44357290	1177480	0	0
44339966	1539411	2	3
45640415	1551192	2	3
45649550	975125	0	0
45625980	19019273	2	3
45635894	19008572	2	3
45629192	738818	0	0
45630029	1125315	0	0
45648735	1115171	2	3
45783825	738818	0	0
45695269	757627	0	0
45670333	1595799	0	0
45705843	19010482	0	0
45671786	1177480	0	0
45672760	1539411	2	3
45685855	40228214	2	3
45795027	1129625	0	0
46293381	1177480	0	0
45894122	782043	0	0
46242311	1149196	0	0
45794796	705944	0	0
46303295	1125315	0	0
46307215	35605482	2	3
4042140	381316	4	7
3052932	3005136	2	2
21500129	1549786	3	3
21505744	1125315	2	2
36153928	1153428	0	0
35702116	30753	2	2
36313966	4299128	6	6
36919117	378419	3	3
42804941	1332419	2	3
44358904	1322184	0	0
43534937	40174880	2	3
45640546	19008572	2	3
45649862	975125	0	0
45626058	1107882	2	3
45635907	40229134	2	3
45628961	1115008	0	0
45630167	1125315	0	0
45648776	19074843	2	3
45783830	1153428	0	0
45695235	1501700	0	0
45670333	1521369	0	0
45705844	19127890	0	0
45671977	1177480	0	0
45675037	1539411	2	3
46242587	1332419	2	3
45795075	1129625	0	0
46292965	1177480	0	0
45893972	1551099	0	0
46242315	1115008	0	0
45794801	738818	0	0
46303019	1125315	0	0
46307576	1115171	2	3
4042140	4310024	4	8
3052978	3036780	2	2
21500129	40221415	3	3
21505744	1119510	2	2
36153929	1396131	0	0
35702114	192671	2	2
36313966	4094814	5	5
40776264	3009201	3	3
42805156	1332419	2	3
44358905	19127890	0	0
44343426	1539411	2	3
45640381	19008572	2	3
45646554	975125	0	0
45625836	1115171	2	3
45636072	40223821	2	3
45629095	1118084	0	0
45630258	1125315	0	0
45648684	19073183	2	3
45783879	753626	0	0
45695239	1367571	0	0
45670333	1549786	0	0
45705844	1589505	0	0
45671846	1177480	0	0
45688165	1539411	2	3
45782876	19075601	2	3
45792320	1129625	0	0
46288227	1177480	0	0
45894097	1729720	0	0
46242200	1729720	0	0
45794858	715997	0	0
46302992	1125315	0	0
46307495	19077572	2	3
4042140	4283893	4	8
3052978	3023430	2	2
21500129	1589505	3	3
21505749	1192710	2	2
36153323	1119510	0	0
36110584	258780	2	2
36313966	440086	5	7
37521809	4323902	3	3
42805212	1332419	2	3
44358905	1589505	0	0
43530807	4219399	4	4
45640757	19133768	2	3
45640875	975125	0	0
45626070	1107882	2	3
45635911	40232448	2	3
45629097	967823	0	0
45630172	1125315	0	0
45648686	19008572	2	3
45783910	1000560	0	0
45695339	1110410	0	0
45670416	1539403	0	0
45705844	1549786	0	0
45671787	1177480	0	0
45706099	19128009	1	2
45780494	19075601	2	3
45792500	1129625	0	0
46288109	1177480	0	0
45894062	1115008	0	0
46242203	1192710	0	0
45794752	1149196	0	0
46303473	1125315	0	0
46302194	40236824	2	3
4042140	195588	4	9
3052978	3005136	2	2
21500129	1548195	3	3
21505749	1125315	2	2
36153328	1115008	0	0
36110736	198199	2	2
36313966	80502	5	7
37503861	44783196	3	3
42848776	42902245	2	2
44358905	1549786	0	0
43530807	433644	4	4
45640757	40162522	2	3
45640637	975125	0	0
45625839	19018935	2	3
45636223	1551192	2	3
45629106	1332418	0	0
45630176	1125315	0	0
45648750	19019273	2	3
45783746	1521369	0	0
45695340	1124300	0	0
45670474	1551099	0	0
45705972	1310149	0	0
45671741	1177480	0	0
45694152	19128263	1	2
45680928	19078461	2	3
45789536	1129625	0	0
46288399	1177480	0	0
45894155	975125	0	0
46242267	1322184	0	0
45794270	1545958	0	0
46303236	1125315	0	0
46301878	1551192	2	3
4042140	192671	4	6
3052983	3023430	2	2
21500129	1512674	3	3
21506108	1332418	2	2
36154131	1125315	0	0
36110736	4056621	2	2
36313966	140673	5	7
37503861	4301346	3	3
42870592	3010813	2	2
44358910	1192710	0	0
43530807	4240902	4	4
45640758	19075601	2	3
45637612	975125	0	0
45626031	19008572	2	3
45636009	19078924	2	3
45629208	1000560	0	0
45630335	1125315	0	0
45648612	40223834	2	3
45783748	705944	0	0
45695364	1545958	0	0
45670616	1149196	0	0
45705977	967823	0	0
45672260	1177480	0	0
45706783	975125	0	0
45799961	40223768	2	3
45789969	1129625	0	0
46288500	1177480	0	0
45894156	1551099	0	0
46242046	1000560	0	0
45794276	1717327	0	0
46300280	1125315	0	0
46302358	40236824	2	3
4042140	80502	4	6
3052983	3005136	2	2
21500594	1177480	3	3
21500007	1759842	2	2
36154131	1129625	0	0
36110704	40486433	2	2
36313966	4283893	5	9
37520918	4117038	3	3
42868693	3015632	2	2
44358912	1115008	0	0
43530807	37017711	4	4
45640771	40223834	2	3
45637891	975125	0	0
45626033	19133768	2	3
45635924	19133768	2	3
45629284	1124300	0	0
45630353	1125315	0	0
45648848	19019273	2	3
45783759	1713332	0	0
45695371	738818	0	0
45670618	1107830	0	0
45705980	1118084	0	0
45783899	1177480	0	0
45706626	1545958	0	0
46240742	19075601	2	3
45789797	1129625	0	0
46244856	1177480	0	0
45894163	1738521	0	0
45893597	1309944	0	0
45794305	1149196	0	0
46300293	1125315	0	0
46302361	920334	2	3
4042140	4329847	4	10
3052983	3036780	2	2
21500594	1115008	3	3
21500007	1746114	2	2
36154133	1125315	0	0
36110704	4280726	2	2
36313966	4310024	5	9
37520918	4330583	3	3
42868693	3014576	2	2
44358914	1717327	0	0
43530897	4139681	4	4
45640772	1551192	2	3
45634667	975125	0	0
45626083	1551192	2	3
45633007	19078924	2	3
45629261	723013	0	0
45630354	1125315	0	0
45648853	19133768	2	3
45783867	1115008	0	0
45695390	1549786	0	0
45670619	1107830	0	0
45705991	1149196	0	0
45783935	1177480	0	0
45706856	967823	0	0
46244924	19075601	2	3
45789964	1129625	0	0
46244705	1177480	0	0
45894164	933724	0	0
45893599	1713332	0	0
45794311	1713332	0	0
46300368	1125315	0	0
46302306	40232448	2	3
4029205	4015189	4	7
3016782	3020630	2	2
21502522	914335	3	3
21500007	1728416	2	2
36154134	1119510	0	0
36110708	4294548	2	2
36313966	4056621	5	9
37520918	4242997	3	3
42868693	3023103	2	2
44358820	1177480	0	0
43530897	4302207	4	4
45637475	40232448	2	3
45634736	975125	0	0
45622618	19078924	2	3
45632772	40232448	2	3
45629316	738818	0	0
45630184	1125315	0	0
45648612	40223821	2	3
45783871	1551099	0	0
45691995	1738521	0	0
45670632	1501700	0	0
45705992	975125	0	0
45784043	1177480	0	0
45706701	975125	0	0
46242610	19078461	2	3
45789087	1129625	0	0
46243418	1177480	0	0
45798573	1112807	0	0
45893599	1759842	0	0
45794333	1539403	0	0
46300301	1125315	0	0
46302027	46221626	2	3
4029205	4337138	4	6
3016782	3027970	2	2
21502522	920293	3	3
21500007	1713332	2	2
36154135	1129625	0	0
36110712	260139	2	2
36313966	4109685	5	9
40772935	3020630	3	3
42868693	3019550	2	2
44358948	19127890	0	0
43530897	438614	4	4
45637170	40243436	2	3
45634446	975125	0	0
45622649	43012036	2	3
45632949	19077344	2	3
45629341	1396131	0	0
45630424	1125315	0	0
45648795	19078461	2	3
45783873	975125	0	0
45691996	1738521	0	0
45670683	1107830	0	0
45705997	967823	0	0
45784099	1177480	0	0
45706703	1124957	0	0
45794961	19078461	2	3
45789156	1129625	0	0
46242301	1177480	0	0
45798472	1112807	0	0
45893629	1174888	0	0
45794349	1728416	0	0
46300306	1125315	0	0
46302126	40236824	2	3
4029205	44783196	4	6
1521405	19127922	2	2
21502522	933724	3	3
21500007	1741122	2	2
36154135	1125315	0	0
36110715	40481087	2	2
36313966	4113008	5	8
37320108	134438	2	3
42868693	3045716	2	2
44358948	1521369	0	0
43530897	442116	4	4
45637110	19075601	2	3
45634793	975125	0	0
45622845	40236824	2	3
45632989	40232448	2	3
45629393	1124957	0	0
45630389	1125315	0	0
45648629	19074843	2	3
45783853	705944	0	0
45692004	1367571	0	0
45670595	1713332	0	0
45706002	738818	0	0
45784057	1177480	0	0
45706858	1115008	0	0
46244871	1539411	2	3
45787036	1129625	0	0
46241146	1177480	0	0
45798442	1112807	0	0
45893698	791967	0	0
45794282	738818	0	0
46300387	1125315	0	0
46302387	40228230	2	3
4029205	4197460	5	6
1521405	19133679	2	2
21500136	1595799	3	3
21500007	1717327	2	2
36154139	1115008	0	0
36111056	4112343	2	2
36313966	372328	5	8
36422768	40243436	2	3
44349077	19128009	2	2
44358948	1549786	0	0
43530897	4102123	4	4
45637432	1115171	2	3
45631727	975125	0	0
45622390	1127433	2	3
45632996	40231925	2	3
45629272	1367571	0	0
45627087	1125315	0	0
45649131	43012036	2	3
45783796	933724	0	0
45692203	1308738	0	0
45670605	1149196	0	0
45703704	1500211	0	0
45784294	1177480	0	0
45706862	1521369	0	0
45679189	1539411	2	3
45787010	1129625	0	0
46241386	1177480	0	0
45798563	1112807	0	0
45893650	1149196	0	0
45794284	740275	0	0
46300313	1125315	0	0
46302389	40162522	2	3
4029205	4238715	5	6
1521405	19129144	2	2
21500136	19054876	3	3
21604792	701322	2	2
36154141	1125315	0	0
36152003	19074843	2	3
36313966	4155034	5	8
36422742	1545959	2	3
42802692	19128009	2	2
44358821	1713332	0	0
43530897	4048169	4	4
45637491	1551192	2	3
45628596	975125	0	0
45622406	40229134	2	3
45633991	40236446	2	3
45629273	1107830	0	0
45627185	1125315	0	0
45645996	40229134	2	3
45783803	738818	0	0
45692011	1115008	0	0
45670721	1110410	0	0
45703709	1000560	0	0
45782074	1177480	0	0
45706862	1548195	0	0
46243041	19075601	2	3
45787046	1129625	0	0
46238467	1177480	0	0
45793476	1112807	0	0
45893676	1307863	0	0
45794288	1124300	0	0
46300474	1125315	0	0
46302464	1127433	2	3
4029205	4057420	5	8
440921	4094814	2	2
21500136	1521369	3	3
21604182	19078219	2	2
36153616	1125315	0	0
36151288	19019273	2	3
36313966	195588	5	10
36903633	378419	2	3
42802692	19127918	2	2
44358821	1759842	0	0
43530897	4304110	4	4
45637517	920300	2	3
45628770	975125	0	0
45622661	19019273	2	3
45642076	19075001	2	3
45627958	1759842	0	0
45627186	1125315	0	0
45646107	19078461	2	3
45783977	1149196	0	0
45692013	1149380	0	0
45670644	1512674	0	0
45703742	1154343	0	0
45782065	1177480	0	0
45706769	1192710	0	0
45672905	19078461	2	3
45787133	1129625	0	0
46238468	1177480	0	0
45793295	1112807	0	0
45893732	1332418	0	0
45794424	933724	0	0
46300480	1125315	0	0
46306891	40162522	2	3
4029205	4108705	5	7
1332418	1332419	2	3
21500136	1500211	3	3
21604182	19039298	2	2
36154150	1713332	0	0
36151808	40236446	2	3
36313966	260139	5	10
37002286	195588	2	3
44358988	1539403	0	0
44358952	1107830	0	0
43530897	4169137	4	4
45639825	19077344	2	3
45631132	975125	0	0
45622723	40229134	2	3
45663382	19075001	2	3
45628071	933724	0	0
45627191	1125315	0	0
45646235	1107882	2	3
45783989	738818	0	0
45691785	1115008	0	0
45670644	1548195	0	0
45703743	920293	0	0
45782152	1177480	0	0
45705270	1124300	0	0
45789421	40223768	2	3
45787172	1129625	0	0
46238471	1177480	0	0
45793297	1112807	0	0
45893635	791967	0	0
45794337	1107830	0	0
46300511	1125315	0	0
46306809	19129655	2	3
4029205	4337611	5	7
1149380	40169216	2	3
21500136	19127922	3	3
21604182	19002770	2	2
36154183	1192710	0	0
36158967	1551192	2	3
36313966	261325	5	10
37303797	133834	1	3
44359115	1177480	0	0
44358904	1112807	0	0
43530897	4306014	4	4
45639997	40228214	2	3
45625849	975125	0	0
45622736	19019273	2	3
45641626	19073183	2	3
45628007	1115008	0	0
45627107	1125315	0	0
45645589	1127433	2	3
45781454	705944	0	0
45692066	1539403	0	0
45670348	914335	0	0
45703863	1124300	0	0
45782142	1177480	0	0
45705281	1548195	0	0
45794940	19075601	2	3
45787333	1129625	0	0
46238387	1177480	0	0
45793392	1112807	0	0
45893736	1548195	0	0
45794293	975125	0	0
46300735	1125315	0	0
46306854	40232448	2	3
4040390	4186930	5	6
1149380	40169281	2	3
21500136	1503184	3	3
21604182	782043	2	2
36154186	1129625	0	0
36102976	40481087	2	3
36313966	4329847	5	11
36241494	19029476	1	2
44359123	738818	0	0
44358956	1149196	0	0
43530897	439406	4	4
45634051	1127433	2	3
45626031	975125	0	0
45622817	19008572	2	3
45658547	19073183	2	3
45628123	967823	0	0
45627109	1125315	0	0
45645886	1127433	2	3
45781568	19039298	0	0
45692224	1192710	0	0
45670493	967823	0	0
45703873	791967	0	0
45782010	1177480	0	0
45705283	1110410	0	0
45682439	19078461	2	3
45785602	1129625	0	0
46238777	1177480	0	0
45793153	1112807	0	0
45893705	933724	0	0
45794428	1557272	0	0
46300636	1125315	0	0
46306311	1127433	2	3
4040390	4057420	5	5
1729720	19133873	2	3
21500136	1518198	3	3
21604182	19059528	2	2
36154187	1192710	0	0
36158865	19008572	2	3
36313966	133834	8	10
37502354	4216130	2	2
44359130	1129625	0	0
44359054	1107830	0	0
43530897	37017711	5	5
45634398	40231925	2	3
45622700	975125	0	0
45623045	19008572	2	3
45639241	19075001	2	3
45628277	1549786	0	0
45627366	1125315	0	0
45645607	43012036	2	3
45781597	920293	0	0
45692279	791967	0	0
45670458	1149196	0	0
45703755	1153428	0	0
45782187	1177480	0	0
45705214	1343916	0	0
45802538	40228214	2	3
45785856	1129625	0	0
45897430	1177480	0	0
45793252	1112807	0	0
45893700	1738521	0	0
45791569	1124300	0	0
46300807	1125315	0	0
46306256	40231925	2	3
4040390	4078793	5	5
1729720	19133905	2	3
21500136	19127890	3	3
21602099	1149380	2	2
36154189	791967	0	0
36158843	19125062	2	3
36313966	40479768	8	11
36703533	4066995	2	2
44358995	1129625	0	0
44358638	1177480	0	0
43530897	4219399	5	5
45634123	43012036	2	3
45622817	975125	0	0
45622957	1154615	2	3
45627162	19078461	2	3
45628278	738818	0	0
45627375	1125315	0	0
45642677	1115171	2	3
45781710	1548195	0	0
45692281	1309944	0	0
45670384	1343916	0	0
45702248	1124957	0	0
45779768	1177480	0	0
45705181	708298	0	0
45797367	40223768	2	3
45785611	1129625	0	0
45897433	1177480	0	0
45793258	1112807	0	0
45893713	1000560	0	0
45791453	738818	0	0
46300429	1125315	0	0
46306901	40163554	2	3
4040390	4058899	5	7
1149196	40228230	2	3
21500136	1515774	3	3
21502573	40224805	2	3
36154191	1125315	0	0
36158968	19125062	2	3
36313966	4134304	8	12
36703534	4132546	2	2
44358996	1192710	0	0
44359023	1738521	0	0
43530897	4240902	5	5
45634313	1127433	2	3
45623045	975125	0	0
45622973	19073183	2	3
45632666	40228214	2	3
45626200	738818	0	0
45627377	1125315	0	0
45642719	19008572	2	3
45781298	1115008	0	0
45692191	1000560	0	0
45670291	1557272	0	0
45702282	1107830	0	0
45779546	1177480	0	0
45705242	1115008	0	0
45786535	40228214	2	3
45785613	1129625	0	0
45897456	1177480	0	0
45794492	1112807	0	0
45893755	1713332	0	0
45791456	1174888	0	0
46300598	1125315	0	0
46306336	1551192	2	3
4040390	4336464	6	9
1149196	40228214	2	3
21500136	1589505	3	3
21502573	40224132	2	3
36154191	738818	0	0
36158796	40232448	2	3
36313966	317009	4	5
40770464	3024561	2	2
44358997	1129625	0	0
44359055	708298	0	0
43530897	433644	5	5
45634456	40232448	2	3
45622956	975125	0	0
45621021	1332419	2	3
45639252	1107882	2	3
45626151	723013	0	0
45627126	1125315	0	0
45642844	19008572	2	3
45781301	1115008	0	0
45692324	1595799	0	0
45670298	1713332	0	0
45702346	1310149	0	0
45779980	1177480	0	0
45705191	1192710	0	0
45685266	40228214	2	3
45785657	1129625	0	0
45897512	1177480	0	0
45787843	1112807	0	0
45893755	1759842	0	0
45791295	1124957	0	0
46300569	1125315	0	0
46299663	1127433	2	3
4040390	4117038	6	7
1137529	40169281	2	3
21500136	43012433	3	3
21502575	1519937	2	3
36154191	1119510	0	0
36158821	1115171	2	3
36313966	4027663	4	8
40770464	3000963	2	2
44358755	1115008	0	0
44358841	1177480	0	0
43530897	4174876	3	3
45634585	1127433	2	3
45623183	975125	0	0
45620878	19078461	2	3
45647353	1332419	2	3
45626153	1778162	0	0
45627150	1125315	0	0
45642817	19019273	2	3
45781305	1125443	0	0
45692185	1545958	0	0
45670359	1738521	0	0
45702352	1307863	0	0
45779888	1177480	0	0
45705200	791967	0	0
46240350	40228214	2	3
45785669	1129625	0	0
45897520	1177480	0	0
45787918	1112807	0	0
45893760	975125	0	0
45791380	1107830	0	0
46300826	1125315	0	0
46299676	1127433	2	3
4040390	4047491	6	7
740275	19074679	2	3
21500136	1519936	3	3
21503951	19023398	2	3
36154193	1119510	0	0
36158800	1551192	2	3
36313966	317576	4	10
40770464	3016723	2	2
44358891	920293	0	0
44359037	715997	0	0
43530807	4306014	3	3
45634430	19008572	2	3
45621126	975125	0	0
45621269	1115171	2	3
45647555	1107882	2	3
45626170	1310149	0	0
45627363	1125315	0	0
45642832	19008572	2	3
45781816	1174888	0	0
45692363	1174888	0	0
45670095	1501700	0	0
45702244	1154029	0	0
45779924	1177480	0	0
45705208	1174888	0	0
45703253	40174880	2	3
45785694	1129625	0	0
45897644	1177480	0	0
45788146	1112807	0	0
45893729	1174888	0	0
45791381	1149196	0	0
46300829	1125315	0	0
46299726	19077344	2	3
4040390	4242997	6	6
1738521	46233988	2	3
21500136	19133679	3	3
21503951	782047	2	3
36154193	1125315	0	0
36158804	40232448	2	3
36313966	4237458	4	10
36423637	19010482	0	0
44359113	1112807	0	0
44359057	1332418	0	0
43530807	442116	3	3
45634276	40231925	2	3
45621955	975125	0	0
45621126	19008572	2	3
45623977	19073183	2	3
45626132	1124957	0	0
45627539	1125315	0	0
45688685	19078461	2	3
45781817	933724	0	0
45692372	1361711	0	0
45670459	1110410	0	0
45702245	791967	0	0
45708041	1177480	0	0
45705259	1539403	0	0
45802567	19079524	2	3
45785955	1129625	0	0
45895395	1177480	0	0
45788055	1112807	0	0
45893768	1115008	0	0
45791370	1728416	0	0
46300852	1125315	0	0
46299777	19059056	2	3
4040390	40492359	6	6
926487	19045231	2	3
21500136	1548195	3	3
21002075	46275444	2	3
36153954	1177480	0	0
36159148	40232448	2	3
36313966	4066995	4	10
36463150	1119510	0	0
44359317	933724	0	0
44358736	1729720	0	0
43530807	4102123	3	3
45634526	40229134	2	3
45664836	975125	0	0
45621296	1115171	2	3
45635923	1107882	2	3
45626187	1361711	0	0
45623707	1125315	0	0
45688381	19079524	2	3
45781535	701322	0	0
45692284	1124957	0	0
45670433	1000560	0	0
45702321	975125	0	0
45708184	1177480	0	0
45705253	1307863	0	0
46243040	19079524	2	3
46296258	1129625	0	0
45895410	1177480	0	0
45788198	1112807	0	0
45893744	933724	0	0
45791509	740275	0	0
46300854	1125315	0	0
46291258	19079524	1	1
4040390	4170947	4	4
757627	19077572	2	3
21500136	1549786	3	3
21002077	46275444	2	3
36154199	1129625	0	0
36159229	40232448	2	3
36313966	40480160	4	10
36463158	1129625	0	0
44359320	1115008	0	0
44358751	738818	0	0
43530807	4302207	3	3
45634363	19018935	2	3
45665122	975125	0	0
45621307	40174880	2	3
45663649	1107882	2	3
45626189	1107830	0	0
45623896	1125315	0	0
45688471	40163554	2	3
45781289	1174888	0	0
45683734	1119510	0	0
45670367	967823	0	0
45702267	1124957	0	0
45708362	1177480	0	0
45705162	1149196	0	0
45697646	40228214	2	3
46296263	1129625	0	0
45895405	1177480	0	0
45788280	1112807	0	0
45893781	1738521	0	0
45791468	1124300	0	0
46300911	1125315	0	0
46270317	4237458	1	1
4040390	4181917	4	4
1322184	19075601	2	3
21500136	975125	3	3
21002068	46275444	2	3
36153617	1125315	0	0
36159130	40229134	2	3
36313966	4029498	4	7
36463158	1125315	0	0
44359077	1177480	0	0
44357299	1713332	0	0
43530807	4169137	3	3
45634621	40236824	2	3
45664946	975125	0	0
45621823	1107882	2	3
45628061	19078461	2	3
45626222	1115008	0	0
45623900	1125315	0	0
45691232	40223768	2	3
45781631	967823	0	0
45683834	1119510	0	0
45669036	1307863	0	0
45702354	920293	0	0
45778115	1177480	0	0
45780013	1174888	0	0
45799825	19078461	2	3
46292033	1129625	0	0
45895528	1177480	0	0
46293937	1112807	0	0
45893879	1717327	0	0
45791709	738818	0	0
46300916	1125315	0	0
45802374	19115351	1	1
4040390	4199276	4	4
738818	40229134	2	3
21500136	19129144	3	3
21002069	46275444	2	3
36153617	1112807	0	0
36159139	1115171	2	3
36313966	44782520	4	7
36463159	1154343	0	0
44359321	1129625	0	0
44357299	1759842	0	0
43530807	438614	3	3
45634689	42707627	2	3
45665194	975125	0	0
45622168	19073183	2	3
45637032	1107882	2	3
45626216	1102527	0	0
45625135	1125315	0	0
45639813	19008572	2	3
45781636	738818	0	0
45683770	1119510	0	0
45669039	1149380	0	0
45702326	1115008	0	0
45706079	1177480	0	0
45780017	1713332	0	0
45794876	40223768	2	3
46292089	1129625	0	0
45895245	1177480	0	0
46293893	1112807	0	0
45894165	1115008	0	0
45791684	1174888	0	0
46301016	1125315	0	0
46312099	19079524	1	1
4040390	44783196	4	7
1746114	46275444	2	3
21500136	1512674	3	3
21002072	46275444	2	3
36153619	1129625	0	0
35702120	4027663	2	3
36313966	4043241	3	12
36463290	1125315	0	0
44359068	1515774	0	0
44357364	1717327	0	0
43530807	439406	3	3
45631091	40229134	2	3
45665275	975125	0	0
45621732	40163554	2	3
45647822	1107882	2	3
45626347	723013	0	0
45625211	1125315	0	0
45639634	1551192	2	3
45781728	1308738	0	0
45683857	1119510	0	0
45669045	1107830	0	0
45702327	1501700	0	0
45705538	1177480	0	0
45779963	1000560	0	0
45896849	19078461	2	3
46292094	1129625	0	0
45803293	1177480	0	0
46294064	1112807	0	0
45893897	19003953	0	0
45791601	1124300	0	0
46301018	1125315	0	0
46300050	46275916	1	1
4040390	4337611	4	7
1124957	40231925	2	3
21500575	19059056	3	4
21604795	45892894	2	3
36153619	1125315	0	0
36159049	1115171	2	3
36313966	4084167	3	6
36463291	975125	0	0
44359068	1549786	0	0
44357400	1729720	0	0
43530807	4048169	3	3
45633826	1115171	2	3
45665284	975125	0	0
45664836	19008572	2	3
45654255	1107882	2	3
45626261	1728416	0	0
45625178	1125315	0	0
45639919	19133768	2	3
45781730	1149196	0	0
45683863	1119510	0	0
45669056	1539403	0	0
45702561	1332418	0	0
45705955	1177480	0	0
45779988	1501700	0	0
45797412	19078461	2	3
46292299	1129625	0	0
45803349	1177480	0	0
46294123	1112807	0	0
45893809	1549786	0	0
45791597	1500211	0	0
46301127	1125315	0	0
46318333	46275916	1	1
4040390	4108705	4	7
753626	40220386	2	3
21500140	1519937	3	4
21604799	45892894	2	3
36153620	1119510	0	0
36159054	43012036	2	3
36313966	80809	3	7
36463200	1738521	0	0
44359253	738818	0	0
44357327	1545958	0	0
43530807	4139681	3	3
45631426	19073183	2	3
45664959	975125	0	0
45664896	40232448	2	3
45642346	40228214	2	3
45626343	1738521	0	0
45625180	1125315	0	0
45639670	1107882	2	3
45781537	1343916	0	0
45683889	1119510	0	0
45669091	1501700	0	0
45702355	1545958	0	0
45705728	1177480	0	0
45780167	1115008	0	0
45794637	1539411	2	3
46292326	1129625	0	0
45803475	1177480	0	0
46294219	1112807	0	0
45893809	1515774	0	0
45791554	738818	0	0
46319195	1125315	0	0
46303090	1115171	2	3
4040390	4216130	4	7
742185	19123231	2	3
21500138	40224132	3	4
21602860	46275444	2	3
36153847	1125315	0	0
36159418	1127433	2	3
36313966	196456	3	9
36463216	1125315	0	0
44359257	1149380	0	0
44357324	1153428	0	0
43530807	4304110	3	3
45631395	19019273	2	3
45662166	975125	0	0
45665081	40174880	2	3
45657678	1107882	2	3
45626394	1149196	0	0
45625182	1125315	0	0
45639843	1127433	2	3
45781539	1501700	0	0
45683890	1119510	0	0
45669026	1310149	0	0
45702268	1153428	0	0
45706006	1177480	0	0
45779682	1332418	0	0
45679441	40223768	2	3
46292451	1129625	0	0
45800902	1177480	0	0
46294448	1112807	0	0
45893843	1115008	0	0
45791656	1110410	0	0
46319219	1125315	0	0
46303311	1115171	2	3
4040390	4323902	4	7
1326303	19018935	2	3
21500138	40224805	3	4
21003263	40236824	2	3
36154200	1112807	0	0
36159545	40236824	2	3
36313966	134438	3	8
36463297	1332418	0	0
37100000	4056621	6	7
44357464	975125	0	0
43531053	45769019	3	3
45631500	19059056	2	3
45662509	975125	0	0
45664940	40223834	2	3
45626977	1545959	2	3
45626328	1124957	0	0
45625245	1125315	0	0
45639892	1115171	2	3
45781737	1713332	0	0
45683897	1119510	0	0
45669051	1713332	0	0
45702270	1174888	0	0
45703694	1177480	0	0
45780060	1501700	0	0
45697166	40223768	2	3
46292394	1129625	0	0
45800677	1177480	0	0
46243852	1112807	0	0
45893904	715997	0	0
45791697	1124957	0	0
46319097	1125315	0	0
46303437	46233710	2	3
4040390	4238715	4	5
1741122	46275444	2	3
21500578	1127078	3	4
21604152	40173590	2	3
36154157	1118084	0	0
36159597	40162522	2	3
36313966	192671	2	7
36463337	1545958	0	0
42802224	19128009	2	2
44357467	1124300	0	0
43531052	196456	4	4
45631610	19073183	2	3
45662318	975125	0	0
45665226	1107882	2	3
45628073	40228214	2	3
45626330	1738521	0	0
45625248	1125315	0	0
45639827	40236446	2	3
45781545	1174888	0	0
45683933	1119510	0	0
45669051	1759842	0	0
45702390	920293	0	0
45703615	1177480	0	0
45779899	1539403	0	0
45700468	19078461	2	3
46292607	1129625	0	0
45798184	1177480	0	0
46243857	1112807	0	0
45893831	1115008	0	0
45791698	1741122	0	0
46319285	1125315	0	0
46303115	40162522	2	3
4040390	44805732	4	5
933724	40236824	2	3
21012458	836654	0	0
21503925	19019273	2	3
36153848	1129625	0	0
36203042	40480160	2	3
36302170	4163872	4	7
36463252	1115008	0	0
42802224	19127918	2	2
44357471	723013	0	0
43531052	4266809	4	4
45628570	40232448	2	3
45662677	975125	0	0
45664954	1127433	2	3
45639339	1107882	2	3
45626333	1115008	0	0
45625201	1125315	0	0
45640122	19073183	2	3
45781546	738818	0	0
45683971	1119510	0	0
45669053	1549786	0	0
45702299	1548195	0	0
45702307	1177480	0	0
45780127	782043	0	0
45679365	19078461	2	3
46287942	1129625	0	0
45798278	1177480	0	0
46244731	1112807	0	0
45801715	1154343	0	0
45791698	1746114	0	0
46319065	1125315	0	0
46303377	1115171	2	3
4040390	4202451	4	5
3050951	3019550	2	3
21506167	1177480	0	0
21005779	1551192	2	3
36153856	1112807	0	0
36151279	46275444	2	3
36302170	4163951	4	4
36463329	1545958	0	0
40490903	4199276	2	2
44353630	1112807	0	0
43530815	4152936	3	5
45628539	40232448	2	3
45662735	975125	0	0
45665197	1127433	2	3
45657576	1107882	2	3
45626461	753626	0	0
45625144	1125315	0	0
45685697	19008572	2	3
45781837	1115008	0	0
45683978	1119510	0	0
45669074	1521369	0	0
45702302	1149380	0	0
45702376	1177480	0	0
45779779	1174888	0	0
45786666	19078461	2	3
46287985	1129625	0	0
45798423	1177480	0	0
46244787	1112807	0	0
45801687	1738521	0	0
45791511	1107830	0	0
46319076	1125315	0	0
45801237	40229134	2	3
4040390	4330583	4	8
3050951	3023103	2	3
21506125	740275	0	0
21500363	1154615	2	3
36153868	1125315	0	0
36152284	40229134	2	3
36302170	4202451	5	8
36463307	1125315	0	0
40490903	4059978	2	2
44353633	1149380	0	0
43530815	4059173	3	5
45628351	1551192	2	3
45662921	975125	0	0
45665145	19133905	2	3
45629620	1107882	2	3
45626464	1149196	0	0
45625215	1125315	0	0
45685829	40229134	2	3
45781844	914335	0	0
45683962	1119510	0	0
45669074	19127890	0	0
45702359	1110410	0	0
45699386	1177480	0	0
45780076	1545958	0	0
45784880	40223768	2	3
46288115	1129625	0	0
45798315	1177480	0	0
46244823	1112807	0	0
45801736	1153428	0	0
45791614	920293	0	0
46319115	1125315	0	0
45801231	1539411	2	3
4040390	4301346	4	8
3050951	3014576	2	3
21506147	1119510	0	0
21500002	19133905	2	3
36153871	1112807	0	0
36152288	19125062	2	3
36302170	4043241	5	14
36463331	1545958	0	0
42807353	19128009	2	2
44354052	723013	0	0
43530815	4146173	3	5
45628540	43012036	2	3
45662421	975125	0	0
45665285	1551192	2	3
45668022	40223768	2	3
45626237	1149196	0	0
45625230	1125315	0	0
45685807	40236446	2	3
45781295	1153428	0	0
45684008	1119510	0	0
45669074	1549786	0	0
45702426	1307863	0	0
45699473	1177480	0	0
45780161	1738521	0	0
46242664	19078461	2	3
46243147	1129625	0	0
45795494	1177480	0	0
46243975	1112807	0	0
45801767	1115008	0	0
45791785	1548195	0	0
46318965	1125315	0	0
45801339	19008572	2	3
4040390	4198190	7	9
3051542	3019550	2	3
21506187	967823	0	0
21500002	19133873	2	3
36153872	1589505	0	0
36151398	40229134	2	3
36302170	4246502	5	5
36463127	1332418	0	0
42805822	19128263	2	2
44353833	1177480	0	0
43530815	4142905	3	5
45628472	1115171	2	3
45661363	975125	0	0
45665347	19057271	2	3
45657490	1107882	2	3
45626299	967823	0	0
45624137	1125315	0	0
45685826	40232448	2	3
45781297	1549786	0	0
45684018	1119510	0	0
45669100	1124957	0	0
45702411	1332418	0	0
45699470	1177480	0	0
45780185	1118084	0	0
46240370	19078461	2	3
46242905	1129625	0	0
45795603	1177480	0	0
46238904	1112807	0	0
45801883	1000560	0	0
45791785	1521369	0	0
46319128	1125315	0	0
45795710	1154615	2	3
4040390	4163971	7	7
3051542	3023103	2	3
21506156	1115008	0	0
21002094	19129655	2	3
36153873	1129625	0	0
36157102	1129625	0	0
36302170	4133840	5	5
36463144	1501700	0	0
42805822	19128022	2	2
44353926	1124300	0	0
43530815	4278672	3	5
45628357	1551192	2	3
45659331	975125	0	0
45662166	19008572	2	3
45659106	1545959	2	3
45626381	738818	0	0
45624158	1125315	0	0
45685941	19133768	2	3
45781297	19127890	0	0
45680457	1119510	0	0
45669103	1367571	0	0
45702494	1501700	0	0
45699600	1177480	0	0
45780191	1107830	0	0
45685426	19078461	2	3
46242913	1129625	0	0
45795653	1177480	0	0
46239010	1112807	0	0
45801884	1107830	0	0
45791820	1595799	0	0
46319377	1125315	0	0
45795766	19133905	2	3
4040390	4107731	7	7
3051542	3014576	2	3
21502881	1305058	0	0
21505734	19079524	2	3
36154048	1129625	0	0
36157102	1125315	0	0
36302170	4151422	5	5
36463232	1119510	0	0
42805741	920334	2	3
44353931	1124300	0	0
43530815	78272	3	7
45625169	40232448	2	3
45659385	975125	0	0
45662284	35605482	2	3
45639122	40173590	2	3
45626244	1149196	0	0
45624356	1125315	0	0
45685882	1107882	2	3
45781677	975125	0	0
45680574	1119510	0	0
45669104	967823	0	0
45702441	1501700	0	0
45696023	1177480	0	0
45780194	933724	0	0
46244854	40223768	2	3
46243182	1129625	0	0
45795598	1177480	0	0
46239019	1112807	0	0
45801820	791967	0	0
45791820	1521369	0	0
46319146	1125315	0	0
45795841	40229134	2	3
4040390	4275113	7	7
1518198	44816277	2	3
21502889	967823	0	0
21003153	19019273	2	3
36154057	975125	0	0
36157102	1119510	0	0
36302170	4134304	10	14
36463232	738818	0	0
42805695	40169281	2	3
44353932	701322	0	0
43530815	4218389	3	3
45625301	40232448	2	3
45659393	975125	0	0
45662314	19018935	2	3
45635757	1107882	2	3
45626247	740275	0	0
45624183	1125315	0	0
45686080	1332419	2	3
45781685	1367571	0	0
45680579	1119510	0	0
45669130	1713332	0	0
45702502	975125	0	0
45696282	1177480	0	0
45780175	1174888	0	0
45794846	19078461	2	3
46242998	1129625	0	0
45795602	1177480	0	0
46239020	1112807	0	0
45801824	1551099	0	0
45791820	1549786	0	0
46319150	1125315	0	0
45795915	1551192	2	3
4040390	4218408	3	3
1150770	1150771	2	3
21503138	1112807	0	0
21003110	42707627	2	3
36154062	1125315	0	0
36156878	1110410	0	0
36302170	40479422	10	13
36463232	1125315	0	0
42805830	40224805	2	3
44354029	1124300	0	0
43530815	4296204	3	3
45625378	40229134	2	3
45659578	975125	0	0
45662410	19078461	2	3
45648233	1332419	2	3
45622793	1124300	0	0
45624190	1125315	0	0
45686201	40223834	2	3
45781689	1174888	0	0
45680863	1119510	0	0
45669245	705944	0	0
45702518	1332418	0	0
45696172	1177480	0	0
45780176	1107830	0	0
45783151	19078461	2	3
46243009	1129625	0	0
45797238	1177480	0	0
46239143	1112807	0	0
45801830	1192710	0	0
45791675	1124300	0	0
46319153	1125315	0	0
45795809	19018935	2	3
4040390	4163951	3	3
1150836	1150837	2	3
21503089	914335	0	0
21500286	40232448	2	3
36154062	1119510	0	0
36156881	1501700	0	0
36302170	133834	10	12
36463234	1118084	0	0
42805713	40163554	2	3
44354030	738818	0	0
43530815	4113008	3	3
45625272	19133768	2	3
45656231	975125	0	0
45662921	19008572	2	3
45657659	1332419	2	3
45623131	1545958	0	0
45624234	1125315	0	0
45637226	40228214	2	3
45781691	1367571	0	0
45677276	1119510	0	0
45669122	1107830	0	0
45702521	1717327	0	0
45693141	1177480	0	0
45780177	19127890	0	0
45700169	19078461	2	3
46243013	1129625	0	0
45795713	1177480	0	0
46239144	1112807	0	0
45801641	1539403	0	0
45791659	1115008	0	0
46295535	1125315	0	0
45795872	40228230	2	3
4040390	4295880	3	4
1153428	40223821	2	3
21502874	967823	0	0
21003108	42707627	2	3
36154062	738818	0	0
36156906	1717327	0	0
36302170	4024958	6	7
36463361	1107830	0	0
42805905	43012433	2	3
44354055	1107830	0	0
43530815	4155034	3	3
45625471	1127433	2	3
45656370	975125	0	0
45662775	19133873	2	3
45623686	1107882	2	3
45623144	1589505	0	0
45624236	1125315	0	0
45637234	19019273	2	3
45781517	1305058	0	0
45677390	1119510	0	0
45669189	1115008	0	0
45702599	967823	0	0
45693271	1177480	0	0
45780177	1549786	0	0
45681046	19078461	2	3
46243061	1129625	0	0
45793032	1177480	0	0
45894728	1112807	0	0
45801810	1309944	0	0
45791670	1343916	0	0
46295193	1125315	0	0
45790459	1115171	2	3
4040390	4059978	3	4
442983	4048171	4	4
21503154	967823	0	0
21005679	19073188	2	3
36154064	1112807	0	0
36157036	1713332	0	0
36302170	4027663	6	10
36463080	1738521	0	0
42805911	1551192	2	3
44354063	1521369	0	0
43530815	4109685	3	4
45625689	19078924	2	3
45656160	975125	0	0
45662421	19008572	2	3
45652196	40228214	2	3
45623144	1549786	0	0
45624208	1125315	0	0
45636740	40232448	2	3
45781529	738818	0	0
45677427	1119510	0	0
45669305	1778162	0	0
45699391	1174888	0	0
45693292	1177480	0	0
45780183	1557272	0	0
45681139	19078461	2	3
46243128	1129625	0	0
45792837	1177480	0	0
45893582	1112807	0	0
45801793	967823	0	0
45791671	1174888	0	0
46295537	1125315	0	0
45790644	1115171	2	3
4040390	4010253	3	5
432661	4048171	4	4
21503156	967823	0	0
21003056	40232448	2	3
36154065	1112807	0	0
36157036	1759842	0	0
36302170	44782520	6	9
36463083	705944	0	0
42805922	19133905	2	3
44354063	1549786	0	0
43530815	4132546	3	4
45625691	1551192	2	3
45656677	975125	0	0
45662965	40228214	2	3
45626985	1332419	2	3
45623148	738818	0	0
45624278	1125315	0	0
45636821	19057271	2	3
45781534	1309944	0	0
45677498	1119510	0	0
45669191	1539403	0	0
45699296	914335	0	0
45694831	1177480	0	0
45780085	920293	0	0
45681256	19078461	2	3
46240914	1129625	0	0
45793358	1177480	0	0
45801702	1112807	0	0
45801795	1115008	0	0
45791736	701322	0	0
46295551	1125315	0	0
45790576	40229134	2	3
4040390	4337138	3	6
442628	40479422	4	4
21502750	1551099	0	0
21002587	19075001	2	3
36154065	1192710	0	0
36157061	1501700	0	0
36302170	4237458	6	12
36463274	1129625	0	0
42805922	19133873	2	3
44354033	1124957	0	0
43530815	40480160	5	5
45625658	40224805	2	3
45652905	975125	0	0
45662728	40232448	2	3
45665664	1107882	2	3
45622991	1551099	0	0
45624229	1125315	0	0
45682977	40229134	2	3
45781663	715997	0	0
45677700	1119510	0	0
45669237	1107830	0	0
45699297	975125	0	0
45690301	1177480	0	0
45780089	1192710	0	0
45786720	19078461	2	3
46240998	1129625	0	0
45793053	1177480	0	0
45796140	1112807	0	0
45801813	1309944	0	0
45791741	1174888	0	0
46295439	1125315	0	0
45790448	40229134	2	3
4040390	4035793	2	2
442628	40479768	4	4
21502750	975125	0	0
21003076	40229134	2	3
36154067	1112807	0	0
36157062	1115008	0	0
36302170	4066995	6	12
36463282	1115008	0	0
42806883	40236824	2	3
44353758	1149380	0	0
43530815	40479768	5	6
45625752	19008572	2	3
45653017	975125	0	0
45662830	40223768	2	3
45651101	19078461	2	3
45623153	1124957	0	0
45668348	1125315	0	0
45682979	19019273	2	3
45781669	1149196	0	0
45677779	1119510	0	0
45669311	1115008	0	0
45699323	738818	0	0
45690484	1177480	0	0
45780002	723013	0	0
45676022	19078461	2	3
46241000	1129625	0	0
45793188	1177480	0	0
45796255	1112807	0	0
45801854	1115008	0	0
45791792	1149196	0	0
46295308	1125315	0	0
45790701	40229134	2	3
4042140	4134304	7	11
374009	4043241	4	4
21503094	933724	0	0
21503953	19078924	2	3
36154067	1192710	0	0
36157201	1129625	0	0
36302170	321042	8	12
36463287	1332418	0	0
42807063	1551192	2	3
44354035	19127890	0	0
43530815	375671	5	6
45625843	1115171	2	3
45653304	975125	0	0
45661363	19008572	2	3
45633040	19078461	2	3
45623177	1713332	0	0
45668261	1125315	0	0
45682985	19008572	2	3
45781772	1367571	0	0
45676260	1119510	0	0
45669196	1521369	0	0
45699299	914335	0	0
45690328	1177480	0	0
45780098	1326303	0	0
45673126	19078461	2	3
46240888	1129625	0	0
45791917	1177480	0	0
45796197	1112807	0	0
45801855	791967	0	0
45791794	1174888	0	0
46295243	1125315	0	0
45790558	1115171	2	3
4042140	4230399	7	10
4000731	4337611	4	4
21503209	975125	0	0
21003040	19078924	2	3
36154069	1112807	0	0
36156637	1177480	0	0
36302170	4048695	8	12
36463190	1500211	0	0
42807004	35605482	2	3
44354035	1521369	0	0
43530815	40479422	5	6
45622120	19018935	2	3
45653305	975125	0	0
45661203	46275444	2	3
45638671	19075601	2	3
45623177	1759842	0	0
45668365	1125315	0	0
45682987	1545959	2	3
45781775	1308738	0	0
45674481	1119510	0	0
45669196	1595799	0	0
45699585	1332418	0	0
45690604	1177480	0	0
45780107	19010482	0	0
45675921	19078461	2	3
46240749	1129625	0	0
45790272	1177480	0	0
45796207	1112807	0	0
45801876	1174888	0	0
45791797	1713332	0	0
46295245	1125315	0	0
45790838	1551192	2	3
4042140	4144583	7	7
440029	40481087	4	4
21503162	1192710	0	0
21005678	19073183	2	3
36154069	1192710	0	0
36156720	1149196	0	0
36302170	4266809	8	11
36463192	1112807	0	0
42805465	1594382	2	3
44354035	1549786	0	0
43530815	378001	5	6
45622124	40162522	2	3
45653208	975125	0	0
45661289	19073183	2	3
45627061	40228214	2	3
45623180	1589505	0	0
45668370	1125315	0	0
45682829	40232448	2	3
45781801	1174888	0	0
45674471	1119510	0	0
45669196	1549786	0	0
45699690	1539403	0	0
45690589	1177480	0	0
45780116	1310149	0	0
46240618	19078461	2	3
46240897	1129625	0	0
45787312	1177480	0	0
45796263	1112807	0	0
45801877	723013	0	0
45791805	1115008	0	0
46295351	1125315	0	0
45790957	19008572	2	3
4042140	4155034	6	7
440921	4113008	4	4
21503162	738818	0	0
21005678	19073188	2	3
36154075	975125	0	0
36157233	1177480	0	0
36302170	255848	8	11
36463332	1177480	0	0
42804566	920334	2	3
44354039	975125	0	0
43530815	4230399	4	6
45622124	19133768	2	3
45653459	975125	0	0
45659331	19008572	2	3
45644539	40228214	2	3
45623180	1549786	0	0
45668373	1125315	0	0
45682885	40223834	2	3
45781780	967823	0	0
45674472	1119510	0	0
45669294	1717327	0	0
45699342	1192710	0	0
45687367	1177480	0	0
45780122	1367571	0	0
45694531	19078461	2	3
46240836	1129625	0	0
45787719	1177480	0	0
45796265	1112807	0	0
45802413	1501700	0	0
45791582	975125	0	0
46295637	1125315	0	0
45790812	1519937	2	3
4042140	4109685	6	8
440921	4155034	4	4
21500583	1174888	0	0
21505795	19075601	2	3
36154077	1177480	0	0
35506909	1177480	0	0
36302170	28060	8	11
36463334	1177480	0	0
42802009	40231925	2	3
44354199	1713332	0	0
43530815	81151	4	6
45622139	40232448	2	3
45649767	975125	0	0
45659382	40174880	2	3
45632849	19075601	2	3
45623180	19127890	0	0
45668404	1125315	0	0
45633683	19008572	2	3
45781807	1110410	0	0
45674436	1119510	0	0
45669266	1307863	0	0
45699371	1778162	0	0
45687570	1177480	0	0
45780134	1713332	0	0
46242839	19078461	2	3
45696476	40174880	2	3
45787520	1177480	0	0
45796180	1112807	0	0
45802417	975125	0	0
45791583	1738521	0	0
46244325	1125315	0	0
45790899	19075601	2	3
4042140	81893	6	12
440921	4218389	4	4
21500599	1305058	0	0
21003205	19112599	2	3
36154078	933724	0	0
35506909	1129625	0	0
36302170	198199	8	11
36427424	1125315	0	0
42801830	1154615	2	3
44354225	1112807	0	0
43530815	4156265	4	4
45622164	40229134	2	3
45646880	975125	0	0
45659438	1127433	2	3
45648287	19075601	2	3
45622887	1124957	0	0
45668451	1125315	0	0
45633470	1545959	2	3
45783497	1343916	0	0
45674525	1119510	0	0
45669278	1115008	0	0
45699439	740275	0	0
45687279	1177480	0	0
45780154	705944	0	0
45673063	19078461	2	3
45792495	40228214	2	3
45789039	1177480	0	0
45790739	1112807	0	0
45802525	1110410	0	0
45791648	1548195	0	0
46244334	1125315	0	0
45790687	40162522	2	3
4042140	313217	6	11
444187	4152936	4	4
21500613	1343916	0	0
21002836	1125315	0	0
36154087	1112807	0	0
35506912	1149196	0	0
36302170	40486433	8	13
36424953	1149380	0	0
42802236	40162522	2	3
44354015	1177480	0	0
43530815	4134304	4	7
45625098	40223834	2	3
45646935	975125	0	0
45659393	19008572	2	3
45650995	19075601	2	3
45622890	1551099	0	0
45668422	1125315	0	0
45633733	40232448	2	3
45783512	1549786	0	0
45671608	1119510	0	0
45669379	738818	0	0
45699584	1107830	0	0
45684297	1177480	0	0
45780153	920293	0	0
45797317	1539411	2	3
45802672	19079524	2	3
45789280	1177480	0	0
45791890	1112807	0	0
45802320	1124300	0	0
45791752	1551099	0	0
46244446	1125315	0	0
45790717	19008572	2	3
4042140	4166224	6	10
375415	378001	4	4
21500606	1124300	0	0
21002846	1115008	0	0
36154108	1174888	0	0
35507013	791967	0	0
36302170	440448	8	13
36422283	1347450	0	0
42807125	40231925	2	3
44354257	1110410	0	0
43530815	4066995	4	5
45622287	19008572	2	3
45646969	975125	0	0
45659504	40232448	2	3
45639364	40173590	2	3
45622992	1500211	0	0
45668692	1125315	0	0
45633769	19008572	2	3
45783512	19127890	0	0
45671599	1119510	0	0
45669316	1000560	0	0
45699384	705944	0	0
45685610	1177480	0	0
45779872	1192710	0	0
46240492	1332419	2	3
46242909	19078461	2	3
45787907	1177480	0	0
45792007	1112807	0	0
45802600	1551099	0	0
45791775	1124300	0	0
46244583	1125315	0	0
46297637	46275916	2	3
4042140	258780	6	10
375415	375671	4	4
21500607	1125315	0	0
21002836	1112807	0	0
36154108	1125315	0	0
35507014	1119510	0	0
36302170	258780	8	13
36422228	1557272	0	0
42807128	19018935	2	3
44354155	791967	0	0
43530815	4048695	4	5
45622309	1154615	2	3
45647198	975125	0	0
45659357	19018935	2	3
45656953	19078461	2	3
45622906	967823	0	0
45668458	1125315	0	0
45633877	1551192	2	3
45783596	738818	0	0
45671569	1119510	0	0
45669318	1332418	0	0
45699436	1192710	0	0
45684390	1177480	0	0
45779873	975125	0	0
45785207	1332419	2	3
45797555	40223768	2	3
45787900	1177480	0	0
46294636	1112807	0	0
45798963	967823	0	0
45791777	1343916	0	0
46244514	1125315	0	0
46297239	19008572	2	3
4042140	4059173	6	9
4000740	4057420	4	4
21500616	1343916	0	0
21002822	1115008	0	0
36154110	1125315	0	0
35507024	1119510	0	0
36302170	4302207	8	9
36422111	1112807	0	0
42807135	19023398	2	3
44354018	1124300	0	0
43530815	4237458	4	5
45622597	1115171	2	3
45643892	975125	0	0
45659545	42707627	2	3
45635594	19078461	2	3
45623189	1717327	0	0
45668452	1125315	0	0
45633905	43012036	2	3
45783601	1107830	0	0
45671575	1119510	0	0
45669144	1124957	0	0
45699534	975125	0	0
45684578	1177480	0	0
45779972	1174888	0	0
45777813	1545959	2	3
45795235	19078461	2	3
45786095	1177480	0	0
46294909	1112807	0	0
45799074	1124300	0	0
45791781	782043	0	0
46244337	1125315	0	0
46297349	40232448	2	3
4042140	4152936	6	9
4003043	4275113	4	4
21500176	1557272	0	0
21002827	975125	0	0
36154111	1129625	0	0
35507028	1177480	0	0
36302170	441267	8	9
36463335	1115008	0	0
42807238	19133905	2	3
44353987	1307863	0	0
43530815	4001336	4	5
45622600	1127433	2	3
45644135	975125	0	0
45659546	19123231	2	3
45658434	19078461	2	3
45622891	1115008	0	0
45668492	1125315	0	0
45630745	19078461	2	3
45783614	1589505	0	0
45671542	1119510	0	0
45669466	1107830	0	0
45699535	975125	0	0
45681427	1177480	0	0
45779978	1000560	0	0
45675852	40174880	2	3
45802847	19078461	2	3
46296887	1177480	0	0
46294937	1112807	0	0
45799088	1124957	0	0
45788950	1713332	0	0
46244313	1125315	0	0
46297449	40236824	2	3
4180628	4146173	4	6
134057	4310024	4	4
21500203	1326303	0	0
21002827	1124300	0	0
36154118	1112807	0	0
35506977	1307863	0	0
36302170	4139681	8	9
36463429	1107830	0	0
42808536	40229134	2	3
44354020	715997	0	0
43530877	4296204	4	4
45622444	1127433	2	3
45642928	975125	0	0
45659509	40162522	2	3
45651888	19078461	2	3
45622894	1738521	0	0
45668501	1125315	0	0
45630714	19078461	2	3
45783682	740275	0	0
45673015	1119510	0	0
45669326	1149196	0	0
45699536	738818	0	0
45681656	1177480	0	0
45780032	1115008	0	0
45697419	1539411	2	3
46292144	19078461	2	3
46297097	1177480	0	0
46244063	1112807	0	0
45799091	705944	0	0
45788984	1539403	0	0
46244562	1125315	0	0
46297846	43012036	2	3
4180628	4132546	4	6
372887	4001336	4	4
21500166	1501700	0	0
21002846	975125	0	0
36156282	1000560	0	0
35507090	914335	0	0
36302170	442116	8	9
36463446	1125315	0	0
42804694	40236824	2	3
44353902	1307863	0	0
43530877	4113008	4	4
45622493	1115171	2	3
45637822	975125	0	0
45659464	40232448	2	3
45633021	40228214	2	3
45623030	1501700	0	0
45668521	1125315	0	0
45630840	19133873	2	3
45781850	975125	0	0
45673035	1119510	0	0
45666721	715997	0	0
45699440	1307863	0	0
45681512	1177480	0	0
45780042	1124957	0	0
45802631	1545959	2	3
45794980	19078461	2	3
46293377	1177480	0	0
46244162	1112807	0	0
45799097	1107830	0	0
45789046	19127890	0	0
46244526	1125315	0	0
46297958	19008572	2	3
4180628	198809	4	6
4000738	4163971	4	4
21003406	19010482	0	0
21002846	1124300	0	0
36156240	920293	0	0
35506982	1129625	0	0
36302170	78272	8	14
36463446	1119510	0	0
42804666	19073183	2	3
44354004	1149196	0	0
43530877	4155034	4	4
45620730	19059056	2	3
45638329	975125	0	0
45659582	1551192	2	3
45632496	19078461	2	3
45623031	933724	0	0
45668782	1125315	0	0
45630843	1115171	2	3
45778816	967823	0	0
45673372	1119510	0	0
45666789	1307863	0	0
45699563	1124300	0	0
45681623	1177480	0	0
45780045	1153428	0	0
45778220	1539411	2	3
45895110	19078461	2	3
46293488	1177480	0	0
46239456	1112807	0	0
45799140	1153428	0	0
45789046	1549786	0	0
46244298	1125315	0	0
46297908	40232448	2	3
4180628	4266809	4	6
133468	4278672	4	4
21003405	19010482	0	0
21002844	975125	0	0
36156400	975125	0	0
35507064	1177480	0	0
36302170	4174876	7	8
36463446	1129625	0	0
42804652	35605482	2	3
44354021	1738521	0	0
43530877	4218389	4	4
45620837	40232448	2	3
45637122	975125	0	0
45659541	1332419	2	3
45654181	40228214	2	3
45622897	1512674	0	0
45668789	1125315	0	0
45630856	40232448	2	3
45779232	738818	0	0
45673101	1119510	0	0
45666753	1174888	0	0
45699449	1332418	0	0
45679750	1177480	0	0
45780048	967823	0	0
45792103	1539411	2	3
46292163	19078461	2	3
46296593	1177480	0	0
46239551	1112807	0	0
45799159	740275	0	0
45789048	1174888	0	0
46244322	1125315	0	0
46297923	40162522	2	3
4180628	4283893	4	5
133468	4113008	4	4
21003421	1738521	0	0
21002844	1124300	0	0
36156355	1154343	0	0
35507067	1343916	0	0
36302170	372328	7	10
36463443	705944	0	0
42804655	40243436	2	3
44354109	1521369	0	0
43530877	4109685	4	5
45620771	1115171	2	3
44361834	1192710	0	0
45659472	1551192	2	3
45642179	40228214	2	3
45622897	1549786	0	0
45668790	1125315	0	0
45630991	19078924	2	3
45779237	738818	0	0
45671669	1119510	0	0
45666884	791967	0	0
45699635	1192710	0	0
45679783	1177480	0	0
45780049	1713332	0	0
46240499	1539411	2	3
45795131	19078461	2	3
46288475	1177480	0	0
46239677	1112807	0	0
45799249	1192710	0	0
45788963	723013	0	0
46244323	1125315	0	0
46297994	19125062	2	3
4180628	381316	4	5
133468	4155034	4	4
21003410	1551099	0	0
21002852	1728416	0	0
36156356	920293	0	0
35507069	1119510	0	0
36302170	4155034	7	10
36463418	738818	0	0
42804657	1594382	2	3
44353851	1501700	0	0
43530877	4059173	4	6
45621229	40223834	2	3
44361851	1192710	0	0
45656231	19008572	2	3
45635745	19079524	2	3
45622994	723013	0	0
45665857	1125315	0	0
45630809	19008572	2	3
45779238	738818	0	0
45669950	1119510	0	0
45666806	1110410	0	0
45699553	1501700	0	0
45678167	1177480	0	0
45706914	1551099	0	0
45876037	3013682	2	5
46243078	19078461	2	3
46288827	1177480	0	0
46239649	1112807	0	0
45799252	1713332	0	0
45788965	1124957	0	0
46244569	1125315	0	0
46289301	40162522	2	3
4180628	4056621	4	5
376337	380378	4	4
21003410	975125	0	0
21002493	1521369	0	0
36156465	1305058	0	0
35507075	1545958	0	0
36302170	381316	7	10
36463418	1119510	0	0
42804658	46275916	2	3
44354117	1115008	0	0
43530877	4001336	4	6
45621229	40223821	2	3
44361919	1192710	0	0
45656370	19008572	2	3
45654327	40228214	2	3
45623090	738818	0	0
45665987	1125315	0	0
45631001	1115171	2	3
45779358	705944	0	0
45670157	1119510	0	0
45666939	1118084	0	0
45699638	1174888	0	0
45678100	1177480	0	0
45706931	791967	0	0
45876037	3023103	2	6
46243207	19078461	2	3
46288967	1177480	0	0
46239726	1112807	0	0
45799166	1124300	0	0
45789006	738818	0	0
46244388	1125315	0	0
46289148	19018935	2	3
4180628	80809	4	4
376208	317576	4	4
21004035	708298	0	0
21002493	1589505	0	0
36156306	1149380	0	0
35507211	975125	0	0
36302170	4056621	7	11
36463418	1125315	0	0
42804875	40162522	2	3
44354091	1322184	0	0
43530877	4278672	4	6
45621183	19059056	2	3
44362295	1192710	0	0
45656259	1545959	2	3
45644806	40228214	2	3
45623198	1713332	0	0
45666102	1125315	0	0
45630976	19073183	2	3
45779359	914335	0	0
45670168	1119510	0	0
45666839	1110410	0	0
45699570	1738521	0	0
45678517	1177480	0	0
45707019	1192710	0	0
45876037	3016723	2	5
45789888	40223768	2	3
46288964	1177480	0	0
46239611	1112807	0	0
45799257	1539403	0	0
45789040	1545958	0	0
46244586	1125315	0	0
46289325	40163554	2	3
4180628	441267	4	4
376208	4280726	4	4
21003446	1595799	0	0
21002508	1549786	0	0
36156311	1129625	0	0
35507212	1115008	0	0
36302170	195588	7	12
36463393	705944	0	0
42804843	1154615	2	3
44354092	1112807	0	0
43530877	4142905	4	6
45621186	1115171	2	3
45655842	1192710	0	0
45656463	40232448	2	3
45647857	1539411	2	3
45623001	1153428	0	0
45666335	1125315	0	0
45628258	19078461	2	3
45779365	1551099	0	0
45670013	1119510	0	0
45666962	708298	0	0
45699402	1367571	0	0
45678779	1177480	0	0
45707022	705944	0	0
45783005	19128263	1	2
45789563	1332419	2	3
46289094	1177480	0	0
45896134	1112807	0	0
45799115	1521369	0	0
45789057	1174888	0	0
46244591	1125315	0	0
46289786	19008572	2	3
4180628	321042	4	4
376208	40486433	4	4
21003446	1308738	0	0
21002491	1124300	0	0
36156312	1129625	0	0
35507213	738818	0	0
36302170	261325	7	12
36463454	1717327	0	0
42805134	19078461	2	3
44354234	1115008	0	0
43530877	4146173	4	6
45621215	19059056	2	3
45655911	1192710	0	0
45658376	19075001	2	3
45666166	40228214	2	3
45623007	1738521	0	0
45666347	1125315	0	0
45628233	40232448	2	3
45779369	740275	0	0
45669989	1119510	0	0
45667030	933724	0	0
45699645	1115008	0	0
45675271	1177480	0	0
45707026	975125	0	0
45797383	19129144	1	2
45800510	19078461	2	3
46243589	1177480	0	0
45896145	1112807	0	0
45799252	1759842	0	0
45789041	1738521	0	0
46244596	1125315	0	0
46289555	46275916	2	3
4180628	4029498	4	4
376208	134438	4	4
21003452	1595799	0	0
21002491	1177480	0	0
36156312	1125315	0	0
35507213	1125315	0	0
36302170	260139	7	12
36463424	1307863	0	0
42803247	19133905	2	3
44354096	1149196	0	0
43530877	4152936	4	6
45621015	40232448	2	3
45655959	1192710	0	0
45658417	40165015	2	3
45636350	19078461	2	3
45623016	1332418	0	0
45667264	1125315	0	0
45627955	40232448	2	3
45779121	1332418	0	0
45783735	1119510	0	0
45666813	967823	0	0
45699471	1107830	0	0
45675226	1177480	0	0
45707028	1174888	0	0
45797383	19127922	1	2
45802662	19078461	2	3
46243529	1177480	0	0
45896838	1112807	0	0
45799242	1124957	0	0
45789042	1548195	0	0
46244535	1125315	0	0
46289594	19008572	2	3
4180628	4035415	4	4
4094284	81151	3	6
21003452	1308738	0	0
21002493	1548195	0	0
36156441	1125315	0	0
35507213	1119510	0	0
36302170	4329847	7	13
36469904	1153428	0	0
42802386	40224805	2	3
44354207	1177480	0	0
43530877	78272	4	8
45664682	1115171	2	3
45656310	1192710	0	0
45658447	40162522	2	3
45641870	19079524	2	3
45623019	738818	0	0
45667371	1125315	0	0
45627958	1713671	2	3
45779040	1501700	0	0
45783768	1119510	0	0
45666924	1174888	0	0
45699647	1343916	0	0
45672440	1177480	0	0
45706978	705944	0	0
45797383	19133679	1	2
45789764	19078461	2	3
46243764	1177480	0	0
45896839	1112807	0	0
45799332	1551099	0	0
45788935	1149196	0	0
46244611	1125315	0	0
46289835	1115171	2	3
4180628	4116491	4	4
4042641	4216130	3	6
21003454	1500211	0	0
21002502	19127890	0	0
36156442	1713332	0	0
35507214	1125315	0	0
36302170	4112343	7	13
36469247	1738521	0	0
42802514	40236824	2	3
44353962	1149196	0	0
43530877	40480160	6	6
45664596	19019273	2	3
45656216	1192710	0	0
45656677	19008572	2	3
45651194	40228214	2	3
45623099	967823	0	0
45667466	1125315	0	0
45676203	40162522	2	3
45779044	1115008	0	0
45783825	1119510	0	0
45667114	1154343	0	0
45699655	19003953	0	0
45672351	1177480	0	0
45707131	975125	0	0
45797184	40223774	1	1
45792746	40223768	2	3
46243652	1177480	0	0
45804276	1112807	0	0
45799337	1124957	0	0
45788936	1367571	0	0
46244571	1125315	0	0
46241667	43012036	2	3
4180628	4043241	8	9
4136694	40479422	3	3
21003454	1503184	0	0
21002502	1515774	0	0
36156442	1759842	0	0
35507214	1119510	0	0
36302170	4285898	7	14
36463387	1119510	0	0
42807303	19078924	2	3
44353755	1557272	0	0
43530877	40479768	6	7
45664712	19133768	2	3
45654980	1192710	0	0
45652901	1594382	2	3
45647691	40228214	2	3
45623217	1149196	0	0
45666428	1125315	0	0
45676278	1127433	2	3
45779264	1153428	0	0
45783753	1119510	0	0
45666840	19010482	0	0
45699679	715997	0	0
45672286	1177480	0	0
45706894	791967	0	0
45792456	40171902	1	1
46292278	19078461	2	3
46243815	1177480	0	0
45804312	1112807	0	0
45799121	1332418	0	0
45788940	1332418	0	0
46244552	1125315	0	0
46241668	1127433	2	3
4180628	28060	5	6
4136694	40479768	3	3
21000705	1332418	0	0
21002502	1548195	0	0
36156546	1738521	0	0
35507222	1539403	0	0
36302170	4094814	7	7
36463460	1119510	0	0
42807058	40236446	2	3
44354251	1551099	0	0
43530877	4132546	3	5
45664819	19008572	2	3
45655043	1192710	0	0
45653058	1107882	2	3
45654009	19079524	2	3
45623219	1154029	0	0
45666476	1125315	0	0
45676280	40232448	2	3
45779301	1174888	0	0
45783989	1119510	0	0
45666895	1115008	0	0
45699680	967823	0	0
45672572	1177480	0	0
45706896	791967	0	0
46275875	46275444	1	1
45792593	40174880	2	3
46243839	1177480	0	0
45797286	1112807	0	0
45799357	1107830	0	0
45788944	19039298	0	0
46240381	1125315	0	0
46241669	43012036	2	3
4180628	40481087	5	6
4181583	4294548	3	3
21000705	1545958	0	0
21002502	1595799	0	0
36156317	1551099	0	0
35202051	4280726	5	9
36302170	4240902	9	10
36463463	1332418	0	0
42805341	19018935	2	3
44354189	1713332	0	0
43530877	4134304	5	8
45664753	1154615	2	3
45649535	1192710	0	0
45652919	19075601	2	3
45644284	19078461	2	3
45623225	1149196	0	0
45666477	1125315	0	0
45673503	40228214	2	3
45779318	1326303	0	0
45783990	1119510	0	0
45666983	1000560	0	0
45699476	975125	0	0
45672495	1177480	0	0
45706099	1589505	0	0
46275915	46275916	1	1
45797993	1545959	2	3
46243784	1177480	0	0
45796656	1112807	0	0
45799174	1738521	0	0
45788993	1717327	0	0
46239771	1125315	0	0
46241587	19008572	2	3
4180628	255848	5	6
4181583	4112343	3	3
19123231	19123231	0	0
21002502	19054876	0	0
36156375	1551099	0	0
35702113	81893	6	12
36302170	433644	9	10
36463397	1717327	0	0
42805647	19019273	2	3
44354193	1177480	0	0
43530877	375671	5	7
45664886	1551192	2	3
45649601	1192710	0	0
45652923	40232448	2	3
45638394	19078461	2	3
45623247	1115008	0	0
45663829	1125315	0	0
45624732	1594382	2	3
45779346	1124300	0	0
45783993	1119510	0	0
45666816	1548195	0	0
45699484	1115008	0	0
45672631	1177480	0	0
45706099	1549786	0	0
46276149	1594382	1	1
45792741	1332419	2	3
46241434	1177480	0	0
45791196	1112807	0	0
45799348	975125	0	0
45789107	1192710	0	0
46239772	1125315	0	0
46241703	1127433	2	3
4180628	4142905	5	7
4042330	4301346	3	5
19074841	19074841	0	0
21002502	1589505	0	0
36156248	914335	0	0
35802134	81893	7	7
36302170	4048171	9	14
36469615	1154343	0	0
42804952	19019273	2	3
44354196	738818	0	0
43530877	378001	5	7
45664803	40232448	2	3
45649659	1192710	0	0
45653425	40162522	2	3
45629263	19078461	2	3
45625102	1713332	0	0
45664522	1125315	0	0
45624956	40229134	2	3
45780620	1115008	0	0
45781563	1119510	0	0
45667047	920293	0	0
45699685	1149196	0	0
45784309	1177480	0	0
45706117	1307863	0	0
46287614	40243436	1	1
45800467	1332419	2	3
46241444	1177480	0	0
45791357	1112807	0	0
45799126	1192710	0	0
45789107	1174888	0	0
46241859	19127904	3	4
46241646	40229134	2	3
4180628	4001336	5	7
4042503	4146173	3	5
19075001	19075001	0	0
21002502	1521369	0	0
36156508	1119510	0	0
21604180	723013	4	4
36302170	313217	9	14
36469629	1115008	0	0
42802101	19019273	2	3
44353845	1551099	0	0
43530877	4230399	5	7
45664806	40232448	2	3
45649059	1192710	0	0
45653425	19133768	2	3
45665286	40174880	2	3
45625063	1174888	0	0
45664515	1125315	0	0
45624815	1115171	2	3
45780624	975125	0	0
45781818	1119510	0	0
45667121	1768849	0	0
45699601	1124957	0	0
45784198	1177480	0	0
45706149	975125	0	0
45885352	4237458	1	1
45803108	1332419	2	3
46241636	1177480	0	0
45791211	1112807	0	0
45799132	1115008	0	0
45789101	1308738	0	0
46244407	19133679	3	4
46241623	1127433	2	3
4180628	40480160	5	7
4185503	261325	3	5
19076733	19029476	0	0
21002502	1549786	0	0
35507691	1307863	0	0
21604180	19074679	4	7
36303153	4037675	7	7
36463384	1125315	0	0
42802384	1551192	2	3
44353963	1738521	0	0
43530877	81151	5	7
45664810	40232448	2	3
45646568	1192710	0	0
45652981	1115171	2	3
45653438	1332419	2	3
45625102	1759842	0	0
45663965	1125315	0	0
45624963	19078924	2	3
45780701	738818	0	0
45781636	1119510	0	0
45667058	1738521	0	0
45699610	1305058	0	0
45786453	1177480	0	0
45706198	1115008	0	0
45876187	46235214	1	1
46243208	1332419	2	3
46238786	1177480	0	0
45791560	1112807	0	0
45799271	1501700	0	0
45788894	1746114	0	0
45876060	3024561	3	4
46241748	19008572	2	3
4180628	4048171	5	8
4180627	4295880	3	5
19077344	19077344	0	0
21002502	1503184	0	0
35507694	1728416	0	0
21604180	45892894	6	7
36303153	4299128	7	7
36469821	1125315	0	0
42807064	19075001	2	3
44354098	1539403	0	0
43530877	4156265	5	5
45664878	19018935	2	3
45646605	1192710	0	0
45653305	19008572	2	3
45635562	19078461	2	3
45625074	708298	0	0
45664005	1125315	0	0
45624673	19078461	2	3
45780857	738818	0	0
45781735	1119510	0	0
45667078	1115008	0	0
45699659	1149196	0	0
45784434	1177480	0	0
45706158	1153428	0	0
45696885	19079524	1	1
45696783	1332419	2	3
46238667	1177480	0	0
45791425	1112807	0	0
45799275	1549786	0	0
45788894	1741122	0	0
45876060	3013682	3	3
46241765	40229134	2	3
4180628	4166224	5	8
4180627	4059978	3	5
19076374	19076374	0	0
21002505	1521369	0	0
35507962	1107830	0	0
36217216	19133679	3	4
36303153	4266809	7	10
36469839	1119510	0	0
42804841	19019273	2	3
44354102	1192710	0	0
43530877	4048695	5	6
45664881	1115171	2	3
45643697	1192710	0	0
45653315	1154615	2	3
45650241	19078461	2	3
45624899	1110410	0	0
45663962	1125315	0	0
45670282	19008572	2	3
45780706	1107830	0	0
45781546	1119510	0	0
45667111	723013	0	0
45699667	1332418	0	0
45784470	1177480	0	0
45706148	967823	0	0
46292632	19079524	1	1
45789819	1332419	2	3
46238574	1177480	0	0
46298473	1112807	0	0
45799275	1589505	0	0
45789091	1551099	0	0
45893809	19128263	2	2
46242602	40162522	2	3
4180628	258780	5	8
4180627	4145310	3	5
19077572	19077572	0	0
21002524	1305058	0	0
35508016	715997	0	0
36217216	19128263	3	4
36303153	4156265	7	10
36469839	1125315	0	0
42804690	1545959	2	3
44354170	933724	0	0
43530877	4237458	5	6
45664407	40223834	2	3
45643797	1192710	0	0
45653361	19133768	2	3
45638404	19078461	2	3
45625076	1332418	0	0
45663938	1125315	0	0
45670283	40223834	2	3
45780697	1501700	0	0
45781308	1119510	0	0
45667082	738818	0	0
45699667	1545958	0	0
45782311	1177480	0	0
45706239	1154029	0	0
45876221	21494966	1	1
45785831	40174880	2	3
46240081	1177480	0	0
46298476	1112807	0	0
45799275	19127890	0	0
45788888	1589505	0	0
45893809	19128022	2	2
46242612	40229134	2	3
4180628	81151	5	8
4042330	44783196	3	4
21001432	1545958	0	0
21002493	19127890	0	0
35507965	1545958	0	0
36217216	19127918	3	4
36303153	4142905	7	11
36470033	1125315	0	0
42806885	40163554	2	3
44354278	920293	0	0
43530877	4066995	5	6
45664342	19059056	2	3
45643485	1192710	0	0
45653216	40232448	2	3
45649183	1539411	2	3
45624908	738818	0	0
45664078	1125315	0	0
45670614	40232448	2	3
45780844	1738521	0	0
45781529	1119510	0	0
45667140	1124957	0	0
45699669	1595799	0	0
45782253	1177480	0	0
45706347	1137529	0	0
45876220	40758406	1	1
45790041	1545959	2	3
45897701	1177480	0	0
46298685	1112807	0	0
45799278	1154343	0	0
45789080	1367571	0	0
46239815	19133768	2	3
46241850	1545959	2	3
4180628	81893	5	10
4134423	4238715	3	4
21001432	1332418	0	0
21002493	1515774	0	0
35507917	1310149	0	0
36217216	19127904	3	4
36303153	4169137	7	8
36470033	1119510	0	0
42807218	1545959	2	3
44354075	715997	0	0
44338301	1129625	0	0
45662043	19008572	2	3
45643500	1192710	0	0
45653459	19008572	2	3
45623782	1332419	2	3
45625126	742185	0	0
45664028	1125315	0	0
45670575	19019273	2	3
45780732	1174888	0	0
45781532	1119510	0	0
45667134	738818	0	0
45699669	1308738	0	0
45782220	1177480	0	0
45706347	1149380	0	0
45876220	3051031	1	1
45795055	1545959	2	3
45897794	1177480	0	0
46298859	1112807	0	0
45799209	19127890	0	0
45788985	1115008	0	0
46239815	40162522	2	3
46242004	1551192	2	3
4180628	45769019	5	5
4042504	4243062	3	4
21001432	1307863	0	0
21002510	1548195	0	0
35508059	1107830	0	0
36217216	19133905	2	3
36303153	42535580	7	8
36470077	1119510	0	0
42807091	1545959	2	3
44351701	1149196	0	0
44338311	1738521	0	0
45662158	1332419	2	3
45643614	1192710	0	0
45649767	19008572	2	3
45667395	1332419	2	3
45625018	1124957	0	0
45663986	1125315	0	0
45670474	1551192	2	3
45780734	1000560	0	0
45783596	1119510	0	0
45780960	738818	0	0
45699597	1539403	0	0
45782365	1177480	0	0
45706166	1149380	0	0
46276153	19079524	1	1
46240951	1545959	2	3
45897728	1177480	0	0
46298765	1112807	0	0
45799209	1549786	0	0
45789022	1310149	0	0
46239897	1115171	2	3
46241824	40229134	2	3
4180628	196456	5	5
4171379	4056621	3	4
19074843	19074843	0	0
21002493	1512674	0	0
35508029	1000560	0	0
36217216	40228214	2	3
36303153	81151	7	12
36470077	1125315	0	0
42804547	1545959	2	3
44352276	1738521	0	0
44338317	1149196	0	0
45662136	19008572	2	3
45643550	1192710	0	0
45651991	1115171	2	3
45667726	1539411	2	3
45623321	1149380	0	0
45663949	1125315	0	0
45670624	19059056	2	3
45779428	1174888	0	0
45783599	1119510	0	0
45780713	1174888	0	0
45699696	1107830	0	0
45782527	1177480	0	0
45706172	975125	0	0
45876249	3005136	3	4
45792731	1539411	2	3
45895522	1177480	0	0
46298892	1112807	0	0
45799216	1149196	0	0
45789031	1717327	0	0
46239944	40229134	2	3
45897899	1115171	2	3
4180628	4027663	5	5
4095203	4146173	3	4
19075601	19075601	0	0
21002508	1589505	0	0
35507923	1115008	0	0
36217216	40173590	2	3
36303153	258780	7	12
36470101	1119510	0	0
42807317	19123231	2	3
44352310	1322184	0	0
44338318	1192710	0	0
45662148	19059056	2	3
45640779	1192710	0	0
45652006	1551192	2	3
45653582	1332419	2	3
45621408	1107830	0	0
45664159	1125315	0	0
45670616	40228214	2	3
45779408	1332418	0	0
45783567	1119510	0	0
45780939	1115008	0	0
45699688	1192710	0	0
45782279	1177480	0	0
45706301	1154343	0	0
45876249	40758406	3	4
45790136	1539411	2	3
45896578	1177480	0	0
46290396	1112807	0	0
45799219	1305058	0	0
45789035	1501700	0	0
46321915	44816277	2	3
45897902	46233988	2	3
4180628	4134304	6	9
4029498	380378	1	1
4266169	4329847	3	4
21002508	1521369	0	0
35508036	1125315	0	0
36217216	46233988	2	3
36303153	37017711	8	9
36470162	1153428	0	0
42804866	19019273	2	3
44352401	1177480	0	0
44338319	1557272	0	0
45662106	19078924	2	3
45640970	1192710	0	0
45650046	1115171	2	3
45666201	1332419	2	3
45621482	1501700	0	0
45663995	1125315	0	0
45670595	19073183	2	3
45779431	723013	0	0
45779232	1119510	0	0
45780638	1000560	0	0
45699689	1153428	0	0
45782480	1177480	0	0
45706175	1713332	0	0
45876249	40769189	3	4
45895468	19128263	1	2
45679765	1129625	0	0
46290501	1112807	0	0
45799283	1115008	0	0
45789073	967823	0	0
46322225	40229134	2	3
45897978	40231925	2	3
4180628	4285898	6	9
4134312	4149245	1	1
4304916	30753	3	4
21002508	1512674	0	0
35508039	1545958	0	0
36217216	19059056	2	3
36303153	4166224	8	12
36469276	1177480	0	0
42804860	19019273	2	3
44352403	1557272	0	0
44338326	1124300	0	0
45662034	1551192	2	3
45641079	1192710	0	0
45650083	1551192	2	3
45641539	1332419	2	3
45621506	914335	0	0
45664109	1125315	0	0
45670538	40228214	2	3
45779437	738818	0	0
45779238	1119510	0	0
45780640	1343916	0	0
45696115	738818	0	0
45782603	1177480	0	0
45706334	1501700	0	0
45876249	21494966	3	4
46240071	42902245	1	2
45679794	1129625	0	0
46290717	1112807	0	0
45799402	1307863	0	0
46301961	1192710	0	0
46322236	46275916	2	3
45898002	19078461	2	3
4180628	4278672	6	7
4134439	4132546	1	1
4304916	4310024	3	4
21002508	1500211	0	0
35508040	791967	0	0
36217216	1551192	2	3
36303153	4243062	6	6
36470268	1129625	0	0
42802139	19019273	2	3
44352386	1115008	0	0
44338327	1112807	0	0
45662305	40169281	2	3
45640939	1192710	0	0
45650153	19073183	2	3
45659736	1332419	2	3
45621461	1110410	0	0
45664130	1125315	0	0
45670700	19008572	2	3
45779482	1548195	0	0
45779364	1119510	0	0
45780643	1124957	0	0
45695988	1107830	0	0
45782608	1177480	0	0
45706338	791967	0	0
45876249	40769194	3	4
45885352	4278672	1	2
45679032	1129625	0	0
46291036	1112807	0	0
45793765	1343916	0	0
46301975	1102527	0	0
46322040	40174880	2	3
45895786	19019273	2	3
4180628	40479422	6	7
4095263	4094814	1	1
4274025	317576	3	8
21002499	1595799	0	0
35507984	1309944	0	0
36217216	836659	2	3
36303153	4218389	6	8
36470268	1125315	0	0
42801990	1107882	2	3
44352003	1124300	0	0
44338327	738818	0	0
45662541	40228214	2	3
45637632	1192710	0	0
45646757	1551192	2	3
45623099	19079524	2	3
45621505	1332418	0	0
45664181	1125315	0	0
45670493	19079524	2	3
45779549	1521369	0	0
45779288	1119510	0	0
45778102	1118084	0	0
45695989	1107830	0	0
45702806	1177480	0	0
45706340	975125	0	0
45681484	1125315	0	0
45885352	4059173	1	2
45678963	1129625	0	0
46242086	1112807	0	0
45793960	967823	0	0
46301789	1124300	0	0
46321930	40229134	2	3
45895757	42707627	2	3
4040400	4078793	4	4
4050747	4278672	1	1
4223595	4048171	3	3
21002499	1515774	0	0
35508051	1332418	0	0
36217216	45892894	2	3
36303153	372328	6	9
36470446	1115008	0	0
42804642	1332419	2	3
44352228	1124300	0	0
44338464	1129625	0	0
45659150	19008572	2	3
45637673	1192710	0	0
45646775	40223821	2	3
45629608	19079524	2	3
45621621	1521369	0	0
45664139	1125315	0	0
45670458	40228214	2	3
45779549	1549786	0	0
45779290	1119510	0	0
45778450	1115008	0	0
45696105	1539403	0	0
45703048	1177480	0	0
45706302	1124300	0	0
45681567	1125315	0	0
46292579	46275916	1	1
45678968	1129625	0	0
46242519	1112807	0	0
45793924	1149196	0	0
46301827	1192710	0	0
46322265	43012036	2	3
45895794	19008572	2	3
4040400	4202451	4	4
4085546	4134304	1	1
4309188	4027663	3	3
21002499	1549786	0	0
35508052	1551099	0	0
36217216	1545959	2	3
36303153	4113008	6	9
36474554	1149196	0	0
42804696	1332419	2	3
44350234	1153428	0	0
44338212	1713332	0	0
45658878	19073183	2	3
45637766	1192710	0	0
45646869	19077572	2	3
45665249	1332419	2	3
45621621	19127890	0	0
45664144	1125315	0	0
45669045	1107882	2	3
45779549	1595799	0	0
45779319	1119510	0	0
45778451	1115008	0	0
45696207	1000560	0	0
45696263	1177480	0	0
45706215	1149196	0	0
45681436	1125315	0	0
45885353	4237458	1	1
45679073	1129625	0	0
46239621	1112807	0	0
45793970	1548195	0	0
46301878	1551099	0	0
46322283	40232448	2	3
45895857	40243436	2	3
4040400	4323902	4	4
4052559	441267	1	1
4268628	4037675	3	3
21002499	1589505	0	0
35507704	1310149	0	0
36217216	19123231	2	3
36303153	4109685	6	10
36475982	1367571	0	0
42810048	19078461	2	3
44350318	19127890	0	0
44338357	1589505	0	0
45659313	19008572	2	3
45634802	1192710	0	0
45646880	19008572	2	3
45660113	1539411	2	3
45621621	1549786	0	0
45660773	1125315	0	0
45669070	1127433	2	3
45779556	1713332	0	0
45779140	1119510	0	0
45778350	1367571	0	0
45696218	738818	0	0
45696741	1177480	0	0
45706219	1000560	0	0
45681419	1125315	0	0
45788120	19127922	1	1
45679125	1129625	0	0
46240257	1112807	0	0
45793975	1545958	0	0
46302040	1153428	0	0
46316255	1115171	2	3
45895901	40232448	2	3
4040400	4186930	4	4
4053602	4152936	1	1
4224259	4048171	3	3
21002499	19127890	0	0
35507707	967823	0	0
36217216	19073183	2	3
36303153	30753	6	10
36469202	1119510	0	0
42804629	19075601	2	3
44350318	1589505	0	0
44338361	1343916	0	0
44351574	40163554	2	3
45634552	1192710	0	0
45646888	35605482	2	3
45650279	1545959	2	3
45621433	1309944	0	0
45660925	1125315	0	0
45669122	1107882	2	3
45779508	1124300	0	0
45780701	1119510	0	0
45778473	1115008	0	0
45696085	1307863	0	0
45679964	1129625	0	0
45706309	1110410	0	0
45681552	1125315	0	0
45788120	19133679	1	1
45785848	1129625	0	0
45896258	1112807	0	0
45793975	1332418	0	0
46301761	753626	0	0
46311263	19133873	2	3
45895861	40229134	2	3
4040400	4337611	4	4
4043197	4238715	1	1
4223759	40486433	3	3
21002510	1500211	0	0
35507708	914335	0	0
36217216	40163554	2	3
36303153	378419	6	11
36427520	1729720	0	0
42805416	19075601	2	3
44350318	1549786	0	0
44338278	1107830	0	0
44351485	1545959	2	3
45637315	1192710	0	0
45646826	40163554	2	3
45656864	1545959	2	3
45621525	791967	0	0
45660946	1125315	0	0
45669215	43012036	2	3
45779461	738818	0	0
45779437	1119510	0	0
45778475	705944	0	0
45696068	19003953	0	0
45680078	1129625	0	0
45706313	1149196	0	0
45681632	1125315	0	0
45788120	19129144	1	1
45785851	1129625	0	0
45896444	1112807	0	0
45793978	1305058	0	0
46301766	1000560	0	0
46311134	1551192	2	3
45895851	40232448	2	3
4043161	4202451	4	4
4040976	4043071	1	1
4223759	4280726	3	3
21002510	1512674	0	0
35507710	967823	0	0
21604343	1127433	1	4
36303153	4134304	9	13
36427514	1728416	0	0
42805871	19075601	2	3
44350321	1549786	0	0
44338280	738818	0	0
44778204	1545959	2	3
45631644	1192710	0	0
45646951	19112599	2	3
45656846	1545959	2	3
45621497	1115008	0	0
45660947	1125315	0	0
45669178	19008572	2	3
45779606	1174888	0	0
45779438	1119510	0	0
45778546	1115008	0	0
45696225	1192710	0	0
45677944	1129625	0	0
45706271	1549786	0	0
45681612	1125315	0	0
46296921	46275916	1	1
45786040	1129625	0	0
45896359	1112807	0	0
45793986	1589505	0	0
46302059	920293	0	0
46311338	1154615	2	3
45895956	19075001	2	3
4040396	4275113	4	4
4040551	4218408	1	1
4224260	40486433	3	3
21002508	1548195	0	0
35507846	933724	0	0
21604753	19123231	1	4
36303153	317009	5	6
36427581	1102527	0	0
42804762	19075601	2	3
44350313	715997	0	0
44338088	1501700	0	0
45634111	19019273	2	3
45631651	1192710	0	0
45647105	40173590	2	3
45629773	1539411	2	3
45621565	1307863	0	0
45660997	1125315	0	0
45669161	43012036	2	3
45779515	1110410	0	0
45779489	1119510	0	0
45778549	738818	0	0
45696132	1521369	0	0
45677894	1129625	0	0
45706271	19127890	0	0
45681560	1125315	0	0
46289049	19079524	1	1
45786543	1129625	0	0
45896343	1112807	0	0
45794104	1539403	0	0
46302087	1192710	0	0
46311579	19133905	2	3
45896116	40229134	2	3
4040396	42535580	4	4
4134294	198809	1	1
4224260	4280726	3	3
21002510	1521369	0	0
35507858	975125	0	0
21604753	40236446	1	4
36303153	4027663	5	9
36423637	19134077	1	1
42802204	19075601	2	3
44350333	1778162	0	0
44338101	1115008	0	0
45625474	40223834	2	3
45632199	1192710	0	0
45647039	19059056	2	3
45663799	1539411	2	3
45621639	1551099	0	0
45660777	1125315	0	0
45669294	19129655	2	3
45779516	1557272	0	0
45779461	1119510	0	0
45778396	1343916	0	0
45696134	1149380	0	0
45677904	1129625	0	0
45706271	1589505	0	0
45679754	1125315	0	0
46238603	19134077	1	1
45786676	1129625	0	0
45893989	1112807	0	0
45794128	914335	0	0
46302095	1149380	0	0
46322125	19008572	2	3
45896167	40229134	2	3
4040396	4242997	4	4
4181187	4283893	1	1
4299725	4057420	3	3
21002572	1746114	0	0
35507862	1192710	0	0
35506943	19127904	1	2
36303153	44782520	5	8
36303194	4052083	1	1
42805460	19075601	2	3
44350258	1110410	0	0
44338102	1174888	0	0
45625474	40223821	2	3
45631840	1192710	0	0
45646969	19008572	2	3
45629944	1539411	2	3
45621745	1305058	0	0
45660829	1125315	0	0
45669278	19019273	2	3
45707934	975125	0	0
45707949	1119510	0	0
45778410	1367571	0	0
45696140	723013	0	0
45679771	1129625	0	0
45706283	975125	0	0
45679577	1125315	0	0
45696872	46275916	1	1
45786134	1129625	0	0
45894001	1112807	0	0
45793706	1500211	0	0
46302099	967823	0	0
46317368	19018935	2	3
45895984	43012036	2	3
4040396	4330583	4	4
4134423	4199276	1	1
4304916	4027663	3	3
21002574	1746114	0	0
35507869	967823	0	0
36216814	40231925	1	2
36303153	40480160	5	11
36313965	4191853	1	1
42804460	1539411	2	3
44350347	1539403	0	0
44338375	1192710	0	0
45658652	40223834	2	3
45631758	1192710	0	0
45647087	40229134	2	3
45632642	19078461	2	3
45621755	1595799	0	0
45660489	1125315	0	0
45669379	40229134	2	3
45707941	1713332	0	0
45708243	1119510	0	0
45778537	1149196	0	0
45696255	1115008	0	0
45674626	1129625	0	0
45706291	1110410	0	0
45679782	1125315	0	0
45696715	19079524	1	1
45786199	1129625	0	0
45894023	1112807	0	0
45794067	1717327	0	0
46301814	1332418	0	0
46306560	19133905	2	3
45804242	1115171	2	3
4043022	4337138	4	4
4169307	4174876	1	1
4266169	317576	3	3
21002574	1717327	0	0
35508008	1124300	0	0
36216815	40231925	1	2
36303153	134438	4	9
36503252	80502	1	1
42803145	1539411	2	3
44350323	715997	0	0
44338530	975125	0	0
45658652	40223821	2	3
45628746	1192710	0	0
45647004	1127433	2	3
45636004	1539411	2	3
45621755	1549786	0	0
45660533	1125315	0	0
45669144	40231925	2	3
45707997	967823	0	0
45708187	1119510	0	0
45778539	1396131	0	0
45696256	738818	0	0
45674646	1129625	0	0
45706249	1192710	0	0
45678191	1125315	0	0
45876168	3006322	1	1
46292643	1129625	0	0
45798527	738818	0	0
45794081	1124957	0	0
46301815	1551099	0	0
46305976	19133873	2	3
45804102	920300	2	3
4043023	4323902	4	4
4138127	4163971	1	1
4266169	321042	3	3
21002591	1728416	0	0
35508013	1177480	0	0
36219307	1150837	1	2
36303153	4084167	4	7
36503269	80180	1	1
42807056	1539411	2	3
44350270	1713332	0	0
44338519	1192710	0	0
45628470	1551192	2	3
45628602	1192710	0	0
45646143	1154615	2	3
45654049	1539411	2	3
45621755	1521369	0	0
45660661	1125315	0	0
45669466	1107882	2	3
45707962	740275	0	0
45707913	1119510	0	0
45778464	1500211	0	0
45696280	1192710	0	0
45674807	1129625	0	0
45706482	1154343	0	0
45678085	1125315	0	0
46291552	19079524	1	1
46293076	1129625	0	0
45798492	738818	0	0
45794086	1343916	0	0
46301817	1396131	0	0
46306190	19133905	2	3
45804104	40229134	2	3
4043023	4337611	4	4
4180627	4198190	7	10
4326835	4012477	3	3
21002510	1549786	0	0
35508139	1332418	0	0
36219308	1150837	1	2
36303153	4202451	4	7
36227313	19079524	1	2
42805680	40223768	2	3
44350244	738818	0	0
44338475	1548195	0	0
45652124	1332419	2	3
45628725	1192710	0	0
45643939	19133768	2	3
45639142	1539411	2	3
45621651	723013	0	0
45660880	1125315	0	0
45669314	1127433	2	3
45707973	1308738	0	0
45708297	1119510	0	0
45778491	920293	0	0
45696285	1192710	0	0
45674602	1129625	0	0
45706190	975125	0	0
45678292	1125315	0	0
46288534	19079524	1	1
46293166	1129625	0	0
45798843	738818	0	0
45794092	1717327	0	0
46301818	791967	0	0
46306574	1115171	2	3
45804138	1127433	2	3
4048365	4314290	4	4
4180627	4163971	7	8
4326835	4314290	3	3
21002511	1500211	0	0
35508172	1119510	0	0
36219363	19057271	1	2
36300000	4314290	4	8
36224524	46233710	1	2
42807153	19078461	2	3
44350596	1153428	0	0
44338433	1332418	0	0
45634185	19019273	2	3
45626013	1192710	0	0
45643892	19008572	2	3
45644888	1539411	2	3
45621760	1713332	0	0
45660951	1125315	0	0
45666632	19008572	2	3
45707974	791967	0	0
45705360	1119510	0	0
45778492	1501700	0	0
45696290	975125	0	0
45674980	1129625	0	0
45706194	1332418	0	0
45678294	1125315	0	0
45679150	19079524	1	1
46292990	1129625	0	0
45793192	738818	0	0
45793809	1545958	0	0
46301792	1539403	0	0
46306243	19059056	2	3
45803748	1115171	2	3
4048365	4012477	4	4
4094284	78272	7	7
4239721	433644	1	1
21002591	1768849	0	0
35508177	1119510	0	0
36213180	1150771	1	2
36300000	196456	6	12
36224524	46233988	1	2
42870893	3021226	3	3
44350563	19127890	0	0
44338289	791967	0	0
45628632	19019273	2	3
45622843	1192710	0	0
45644067	19133768	2	3
45645099	1539411	2	3
45621770	1713332	0	0
45660962	1125315	0	0
45666783	1127433	2	3
45707980	1118084	0	0
45705449	1119510	0	0
45778493	701322	0	0
45696476	1501700	0	0
45674898	1129625	0	0
45706292	1115008	0	0
45678247	1125315	0	0
46297099	19079524	1	1
46288160	1129625	0	0
45793194	738818	0	0
45794107	1124300	0	0
46301793	1115008	0	0
46306246	19008572	2	3
45804212	40229134	2	3
4096864	195588	4	4
4134598	4198190	7	7
4239721	4219399	1	1
21002597	1713332	0	0
35508177	1125315	0	0
36102932	433125	1	2
36300000	4246502	6	6
36227221	40220386	1	2
43531052	81893	7	8
44350563	1589505	0	0
44338434	1129625	0	0
45631427	19019273	2	3
45622396	1192710	0	0
45644043	42707627	2	3
45666095	1539411	2	3
45621742	1149196	0	0
45657861	1125315	0	0
45666962	19078924	2	3
45707981	753626	0	0
45705452	1119510	0	0
45778510	1107830	0	0
45696337	1322184	0	0
45674777	1129625	0	0
45706293	1396131	0	0
45678255	1125315	0	0
46288565	19079524	1	1
46288313	1129625	0	0
45793441	738818	0	0
45793945	1551099	0	0
46301863	1107830	0	0
46306773	40232448	2	3
45876069	3016723	2	3
4096864	198809	4	4
4113008	4113008	0	0
4238715	4186930	1	1
21002591	1778162	0	0
35508177	738818	0	0
36102934	28060	1	2
36300000	4029498	7	10
36227104	40165015	1	2
42802175	19128022	1	2
44350563	1549786	0	0
44338436	791967	0	0
45634501	19019273	2	3
45622649	1192710	0	0
45643993	43012036	2	3
45635950	46275916	1	1
45621871	1595799	0	0
45657981	1125315	0	0
45667030	40236824	2	3
45708042	914335	0	0
45705486	1119510	0	0
45778513	738818	0	0
45696232	1343916	0	0
45671816	1129625	0	0
45706305	1124957	0	0
45678393	1125315	0	0
45876060	3016723	3	4
46288045	1129625	0	0
45793294	738818	0	0
45793956	1115008	0	0
46298753	967823	0	0
46317223	40162522	2	3
45876069	3000963	2	3
4182161	4283893	4	4
4052083	4052083	0	0
4239975	4329847	1	1
21002591	1741122	0	0
35508142	1551099	0	0
36102971	260139	1	2
36300000	317576	7	13
36227038	920334	1	2
42802175	19128263	1	2
44350354	19010482	0	0
44338094	1177480	0	0
44778223	46233710	2	3
45622863	1192710	0	0
45644004	40232448	2	3
45635950	19079524	1	1
45621871	1521369	0	0
45657871	1125315	0	0
45667040	1127433	2	3
45708050	1548195	0	0
45705434	1119510	0	0
45778522	1124300	0	0
45696152	967823	0	0
45671826	1129625	0	0
45700609	1738521	0	0
45678396	1125315	0	0
45876060	3000963	3	4
46288741	1129625	0	0
45787862	738818	0	0
45794257	1124957	0	0
46299547	1551099	0	0
46322347	43012036	2	3
45798674	1115171	2	3
4182161	4156265	4	4
4195803	4195803	0	0
4250749	37017711	1	1
21002591	1713332	0	0
35508143	933724	0	0
36212939	40243436	1	2
36300000	133834	11	13
36227051	46275444	1	2
42810281	1149380	0	0
44350378	1112807	0	0
44338256	1307863	0	0
45621218	40228214	2	3
45621954	1192710	0	0
45644010	1107882	2	3
45666004	46275916	1	1
45621871	1549786	0	0
45658103	1125315	0	0
45666895	19019273	2	3
45708050	1589505	0	0
45705692	1119510	0	0
45780676	1149196	0	0
45696158	738818	0	0
45671972	1129625	0	0
45700669	1367571	0	0
45678499	1125315	0	0
45876060	3006906	3	3
46288685	1129625	0	0
45787878	738818	0	0
45794225	1107830	0	0
46299549	738818	0	0
46322654	1545959	2	3
45798475	19078924	2	3
4083787	4296204	4	4
4197460	4197460	0	0
4250749	4240902	1	1
21002591	1746114	0	0
35508084	1125315	0	0
36219362	1107882	1	2
36300000	381316	8	11
36227036	920300	1	2
42808846	975125	0	0
44350292	1713332	0	0
44338525	1332418	0	0
45662257	19078924	2	3
45621426	1192710	0	0
45643983	19078924	2	3
45666004	19079524	1	1
45621872	967823	0	0
45658102	1125315	0	0
45666847	19008572	2	3
45708065	1551099	0	0
45705510	1119510	0	0
45780603	914335	0	0
45696160	1192710	0	0
45671974	1129625	0	0
45700671	1307863	0	0
45678336	1125315	0	0
45885353	4230399	3	3
46244802	1129625	0	0
45788240	738818	0	0
45794228	933724	0	0
46299489	1174888	0	0
46317908	1332419	2	3
45798592	40162522	2	3
4134148	4275113	4	4
21000705	1539403	0	0
4251030	4243062	1	1
21002591	1729720	0	0
35508091	1000560	0	0
36219362	19125062	1	2
36300000	4283893	8	12
36227037	920334	1	2
42809095	1112807	0	0
44350296	738818	0	0
44338496	791967	0	0
45631287	19078924	2	3
45664883	1192710	0	0
45644096	1127433	2	3
45632971	46275916	1	1
45621823	1107830	0	0
45658181	1125315	0	0
45666852	19078461	2	3
45708146	1115008	0	0
45705734	1119510	0	0
45780608	1717327	0	0
45696163	1309944	0	0
45671743	1129625	0	0
45700675	1153428	0	0
45678341	1125315	0	0
45876047	3000963	4	4
46244646	1129625	0	0
45788070	738818	0	0
45794269	1149196	0	0
46298973	1124957	0	0
46321770	19019273	2	3
45798704	1127433	2	3
4083964	40479422	4	4
21000706	1332418	0	0
4252853	4112343	1	1
21002597	1717327	0	0
35508066	1332418	0	0
36222255	19075601	1	2
36300000	195588	8	13
36227037	920300	1	2
42807371	1118084	0	0
44350658	1112807	0	0
44338553	1177480	0	0
44351784	40223768	2	3
45662701	1192710	0	0
45644096	19078461	2	3
45632971	19079524	1	1
45621848	715997	0	0
45658161	1125315	0	0
45666983	35605482	2	3
45707884	1149380	0	0
45702004	1119510	0	0
45780518	1107830	0	0
45696266	967823	0	0
45672108	1129625	0	0
45700676	1124300	0	0
45678425	1125315	0	0
45795361	19127918	3	4
46244656	1129625	0	0
45788093	738818	0	0
45794204	791967	0	0
46299371	933724	0	0
46322302	19019273	2	3
45799681	40232448	2	3
4083964	40479768	4	4
21000713	1551099	0	0
4218017	4043241	1	1
21001912	1551099	0	0
35508148	1177480	0	0
36219361	19125062	1	2
36300000	260139	8	13
36503271	80809	1	2
42807373	1309944	0	0
44350253	742185	0	0
44338529	1149196	0	0
44344513	40223768	2	3
45662660	1192710	0	0
45644075	920334	2	3
45644856	19079524	1	1
45621849	1149196	0	0
45658217	1125315	0	0
45667047	920334	2	3
45707884	1137529	0	0
45702010	1119510	0	0
45780521	738818	0	0
45696165	975125	0	0
45672120	1129625	0	0
45700679	1549786	0	0
45678357	1125315	0	0
45679525	975125	0	0
46243358	1129625	0	0
46294030	738818	0	0
45794220	1154029	0	0
46299383	1717327	0	0
46239758	1539411	2	3
45799850	1545959	2	3
4029698	4198190	4	4
21000716	1177480	0	0
4219484	443279	1	1
21001947	1729720	0	0
21604757	705944	0	0
36219361	1107882	1	2
36300000	4329847	8	14
36227567	1519937	1	2
42809371	1125315	0	0
44350395	738818	0	0
44338508	1177480	0	0
45652540	19075001	2	3
45662662	1192710	0	0
45644236	40232448	2	3
45667985	19079524	1	1
45621852	1713332	0	0
45658148	1125315	0	0
45667121	19074843	2	3
45707855	705944	0	0
45702089	1119510	0	0
45780523	738818	0	0
45696171	1521369	0	0
45671905	1129625	0	0
45700679	1595799	0	0
45678353	1125315	0	0
45679375	975125	0	0
46243379	1129625	0	0
46293543	738818	0	0
45788663	715997	0	0
46299553	738818	0	0
45788820	1545959	2	3
45799859	40231925	2	3
4181187	4048171	4	4
21000716	1118084	0	0
4221994	4187458	1	1
21001953	975125	0	0
21604320	1112807	0	0
36213167	19059056	1	2
36300000	4116491	9	11
36303194	4133840	1	2
42808448	1115008	0	0
44350470	1551099	0	0
44338499	1112807	0	0
45633948	40173590	2	3
45656557	1192710	0	0
45641287	1115171	2	3
45641752	19079524	1	1
45621926	1154029	0	0
45658157	1125315	0	0
45667057	43012036	2	3
45708135	1115008	0	0
45701822	1119510	0	0
45706970	1124300	0	0
45696171	1595799	0	0
45672026	1129625	0	0
45700679	1521369	0	0
45674853	1125315	0	0
45679720	1174888	0	0
46243545	1129625	0	0
46243663	738818	0	0
45788666	1729720	0	0
46299563	975125	0	0
46289656	1545959	2	3
45798977	40174880	2	3
4049222	40486433	4	4
21000736	967823	0	0
19099291	44816277	1	1
21001868	1154343	0	0
21602499	1589505	0	0
36216540	19074843	1	2
36300000	4278672	9	13
36313965	4012477	2	5
42816239	1119510	0	0
44350334	1551099	0	0
44338503	1124957	0	0
45634052	19073183	2	3
45656176	1192710	0	0
45641012	1127433	2	3
45633020	19079524	1	1
45621927	1548195	0	0
45657764	1125315	0	0
45667088	19008572	2	3
45708136	1107830	0	0
45701824	1119510	0	0
45706982	1549786	0	0
45696171	1549786	0	0
45672157	1129625	0	0
45700642	1107830	0	0
45674935	1125315	0	0
45679706	1154029	0	0
46240943	1129625	0	0
46243774	738818	0	0
45788667	1154343	0	0
46299154	1551099	0	0
45788399	1545959	2	3
45799000	19019273	2	3
4049222	4280726	4	4
21000295	1738521	0	0
19020937	19029476	1	1
21001950	1738521	0	0
21602504	1519936	0	0
36216540	19074841	1	2
36300000	4102123	9	10
36503263	80809	2	4
42811089	1125315	0	0
44350336	1112807	0	0
44338449	1192710	0	0
45620884	19073183	2	3
45658412	1192710	0	0
45641118	19019273	2	3
45645194	19079524	1	1
45621597	920293	0	0
45657903	1125315	0	0
45780939	1115171	2	3
45708233	1501700	0	0
45701846	1119510	0	0
45706982	1595799	0	0
45696275	1110410	0	0
45671774	1129625	0	0
45699701	1549786	0	0
45675293	1125315	0	0
45679464	1548195	0	0
46242166	1129625	0	0
46244772	738818	0	0
45788674	1149196	0	0
46298821	1549786	0	0
46298265	1539411	2	3
45799006	40229134	2	3
4172515	4043071	4	4
21000290	1759842	0	0
4322048	4275113	1	1
21001919	1154343	0	0
21601767	1307863	0	0
36213168	19059056	1	2
36300000	441267	9	10
36503263	80180	2	3
42809371	1119510	0	0
44350426	1149196	0	0
44338615	1557272	0	0
45628166	19078461	2	3
45653011	1192710	0	0
45641128	40228230	2	3
45644845	19079524	1	1
45621882	1124300	0	0
45657919	1125315	0	0
45778415	40232448	2	3
45708234	1149380	0	0
45701852	1119510	0	0
45706982	1521369	0	0
45696273	723013	0	0
45784048	1129625	0	0
45699701	19127890	0	0
45675211	1125315	0	0
45679850	1501700	0	0
46242170	1129625	0	0
46244777	738818	0	0
45789345	1322184	0	0
46298823	791967	0	0
45793762	1539411	2	3
45793556	40163554	2	3
4121042	4202451	4	4
21000285	1778162	0	0
4287321	4202451	1	1
21001853	1768849	0	0
35508129	1119510	0	0
35205190	4329847	1	1
36300000	4302207	9	10
36463290	1127433	2	3
42809410	1115008	0	0
44350428	1149380	0	0
44338620	1112807	0	0
45634652	19078461	2	3
45653531	1192710	0	0
45641295	40174880	2	3
45648154	19079524	1	1
45667477	1107830	0	0
45658323	1125315	0	0
45778416	40232448	2	3
45707897	1738521	0	0
45702189	1119510	0	0
45706985	967823	0	0
45696341	1153428	0	0
45784041	1129625	0	0
45699701	1589505	0	0
45675214	1125315	0	0
45679853	1107830	0	0
46242299	1129625	0	0
46244780	738818	0	0
45789181	1501700	0	0
46299390	1115008	0	0
45893695	1539411	2	3
45793672	40229134	2	3
4043346	4142905	4	4
21000292	1738521	0	0
19112768	19074679	1	1
21001936	1746114	0	0
35508129	1125315	0	0
35204969	313217	1	1
36300000	4139681	9	10
36463190	40224805	2	3
42811090	1149196	0	0
44350435	1332418	0	0
44338561	1332418	0	0
45664503	19078461	2	3
45653103	1192710	0	0
45642908	19078461	2	3
45635732	19079524	1	1
45667316	1501700	0	0
45658326	1125315	0	0
45778450	1115171	2	3
45708150	1000560	0	0
45702068	1119510	0	0
45707166	1589505	0	0
45696485	738818	0	0
45784174	1129625	0	0
45699755	1115008	0	0
45675229	1125315	0	0
45678987	1343916	0	0
46241199	1129625	0	0
46238984	738818	0	0
45789417	1738521	0	0
46299402	1521369	0	0
45801641	1539411	2	3
45793641	1115171	2	3
4043346	321042	4	4
21000291	1738521	0	0
4267297	198809	1	1
21001936	1717327	0	0
35508129	1192710	0	0
35205164	317576	1	1
36300000	378001	10	14
36422283	40220960	2	3
42820455	738818	0	0
44350440	975125	0	0
44338234	738818	0	0
44778004	40228214	2	3
45652988	1192710	0	0
45642973	40232448	2	3
45641859	19079524	1	1
45667317	738818	0	0
45658329	1125315	0	0
45778451	1115171	2	3
45708105	1309944	0	0
45702129	1119510	0	0
45707050	1539403	0	0
45696604	1307863	0	0
45784070	1129625	0	0
45699760	1738521	0	0
45675231	1125315	0	0
45678989	1521369	0	0
46241297	1129625	0	0
46239295	738818	0	0
45788701	1501700	0	0
46299402	1549786	0	0
45799257	1539411	2	3
45793642	1115171	2	3
4180170	40486433	4	4
21000683	1308738	0	0
4226263	28060	1	1
21001907	975125	0	0
35508074	1501700	0	0
35502641	140673	1	1
36300000	4048171	10	15
36463335	1115171	2	3
42820568	1125315	0	0
44350441	1501700	0	0
44338512	1549786	0	0
45662243	1107882	2	3
45647017	1192710	0	0
45642987	40228214	2	3
45660471	46275916	1	1
45667276	715997	0	0
45658305	1125315	0	0
45778362	40232448	2	3
45708243	738818	0	0
45702159	1119510	0	0
45779383	1125315	0	0
45696321	967823	0	0
45784086	1129625	0	0
45699762	1118084	0	0
45675013	1125315	0	0
45678989	1548195	0	0
46238500	1129625	0	0
45894584	738818	0	0
45788780	742185	0	0
46298804	975125	0	0
46241764	1539411	2	3
45793790	40232448	2	3
4180170	260139	4	4
21000701	1332418	0	0
19123230	19123231	1	1
21001907	1551099	0	0
35508076	1000560	0	0
35506777	140673	1	1
36503289	40486433	5	5
36469629	1115171	2	3
42816558	1153428	0	0
44350445	1112807	0	0
44338512	1589505	0	0
45640438	1107882	2	3
45646951	1192710	0	0
45641309	19019273	2	3
45660471	19079524	1	1
45667279	1343916	0	0
45654640	1125315	0	0
45778363	1127433	2	3
45708075	1326303	0	0
45702224	1119510	0	0
45779399	1125315	0	0
45696608	1107830	0	0
45781961	1129625	0	0
45699710	19003953	0	0
45675193	1125315	0	0
45679017	1102527	0	0
46238507	1129625	0	0
45894620	738818	0	0
45788757	1149196	0	0
46299595	1539403	0	0
46297472	19128009	1	2
45793853	40232448	2	3
4180170	4280726	4	4
21000701	1545958	0	0
19076574	19045231	1	1
21001924	1768849	0	0
35508264	1501700	0	0
35708603	28060	1	1
36503289	317576	5	5
36470446	1115171	2	3
42807861	1125315	0	0
44350472	1118084	0	0
44338237	1107830	0	0
45664715	1107882	2	3
45643853	1192710	0	0
45641387	19019273	2	3
45648060	19079524	1	1
45667484	1174888	0	0
45654657	1125315	0	0
45778473	19019273	2	3
45708093	1115008	0	0
45699250	1119510	0	0
45779290	1125315	0	0
45696610	1192710	0	0
45781985	1129625	0	0
45699785	1174888	0	0
45675266	1125315	0	0
45679025	791967	0	0
46238484	1129625	0	0
45894666	738818	0	0
45788721	1322184	0	0
46298835	1729720	0	0
45804114	19128263	1	2
45793804	40229134	2	3
4180170	4294548	4	4
21000300	1728416	0	0
4288463	4238715	1	1
21001924	1778162	0	0
35508265	1501700	0	0
36102960	440448	1	1
36503289	4280726	5	5
36427581	40165015	2	3
42810477	1112807	0	0
44350588	1153428	0	0
44338242	1112807	0	0
45625076	1332419	2	3
45643926	1192710	0	0
45641463	42707627	2	3
45663811	46275916	1	1
45667495	1549786	0	0
45654665	1125315	0	0
45778414	43012036	2	3
45708185	791967	0	0
45699192	1119510	0	0
45780628	1125315	0	0
45696348	1738521	0	0
45782075	1129625	0	0
45699789	1309944	0	0
45676427	1125315	0	0
45679040	1112807	0	0
46238335	1129625	0	0
45801595	738818	0	0
45788762	914335	0	0
46298838	1343916	0	0
45804114	19128022	1	2
45793588	19008572	2	3
4181192	4108705	4	4
21000297	1738521	0	0
4287856	4202832	1	1
21002159	1746114	0	0
35508266	1177480	0	0
36102966	372328	1	1
36503289	134438	5	5
36463252	19019273	2	3
42810664	1589505	0	0
44350590	1124300	0	0
44338242	1192710	0	0
45658978	1107882	2	3
45643928	1192710	0	0
45641310	1107882	2	3
45663811	19079524	1	1
45667495	1589505	0	0
45654667	1125315	0	0
45778539	19077344	2	3
45708308	1107830	0	0
45699305	1119510	0	0
45780629	1125315	0	0
45696350	1305058	0	0
45781902	1129625	0	0
45699896	1153428	0	0
45672204	1125315	0	0
45679055	1149380	0	0
46238339	1129625	0	0
45801566	738818	0	0
45788704	1107830	0	0
46299511	1174888	0	0
500000503	192671	1	1
45788208	40223768	2	3
4042141	372328	4	4
21000299	1728416	0	0
21001459	40171902	1	1
21002159	1717327	0	0
35508232	1149196	0	0
36102971	255848	1	1
36503289	40479422	5	7
36463282	19019273	2	3
42810830	1119510	0	0
44350591	1174888	0	0
44338421	1149196	0	0
45658694	1107882	2	3
45643993	1192710	0	0
45637822	19008572	2	3
45644647	19079524	1	1
45667389	1308738	0	0
45654292	1125315	0	0
45778464	40224132	2	3
45708194	975125	0	0
45699185	1119510	0	0
45780701	1125315	0	0
45696360	1153428	0	0
45781995	1129625	0	0
45699900	1332418	0	0
45671909	1125315	0	0
45679059	1112807	0	0
46238357	1129625	0	0
45795901	738818	0	0
45788720	1589505	0	0
46299245	1107830	0	0
500000901	321042	1	1
45788176	40229134	2	3
4134134	375671	4	4
21000299	1729720	0	0
21000953	19074679	1	1
21002247	975125	0	0
35508238	1738521	0	0
21603288	40169281	1	1
36503289	40479768	5	7
36475983	19078461	2	3
42810849	1125315	0	0
44350592	967823	0	0
44338428	1310149	0	0
45643073	1107882	2	3
45644015	1192710	0	0
45638095	19077344	2	3
45642134	19079524	1	1
45667281	1367571	0	0
45654299	1125315	0	0
45778491	920334	2	3
45708195	1174888	0	0
45699355	1119510	0	0
45780862	1125315	0	0
45696504	1153428	0	0
45781956	1129625	0	0
45699914	1149196	0	0
45672251	1125315	0	0
45679087	1310149	0	0
46238672	1129625	0	0
45796250	738818	0	0
45788691	1309944	0	0
46299217	1738521	0	0
500000902	321042	1	1
45788317	40232448	2	3
4134134	378001	4	4
21000313	975125	0	0
21001432	40171902	1	1
21002132	1746114	0	0
35508240	1545958	0	0
21604343	19133768	3	4
36503289	133834	7	7
36428428	40169281	2	3
42817873	1119510	0	0
44350410	1322184	0	0
44338430	1107830	0	0
45622019	19078461	2	3
45641216	1192710	0	0
45638075	1127433	2	3
45653873	19079524	1	1
45665340	1545958	0	0
45654587	1125315	0	0
45778510	1107882	2	3
45707902	791967	0	0
45699512	1119510	0	0
45780732	1125315	0	0
45696511	1322184	0	0
45781958	1129625	0	0
45699817	1174888	0	0
45672312	1125315	0	0
45679152	1192710	0	0
45897433	1129625	0	0
45796199	738818	0	0
45788748	1549786	0	0
46299522	738818	0	0
500000903	321042	1	1
45788568	1115171	2	3
4043160	4107731	4	4
21000301	1728416	0	0
21001432	1332419	2	3
21002166	975125	0	0
35508371	1332418	0	0
35204998	317576	3	4
36503289	381316	4	4
36468849	19078461	2	3
42817902	1119510	0	0
44350599	1149380	0	0
44338588	1557272	0	0
45645968	1332419	2	3
45641116	1192710	0	0
45638059	19073183	2	3
45660354	46275916	1	1
45665034	1501700	0	0
45654703	1125315	0	0
45778521	19059056	2	3
45707903	1332418	0	0
45699517	1119510	0	0
45779428	1125315	0	0
45696512	738818	0	0
45782211	1129625	0	0
45699821	1343916	0	0
45672051	1125315	0	0
45679167	1192710	0	0
45897447	1129625	0	0
45796179	738818	0	0
45788748	1521369	0	0
46299283	1115008	0	0
500001801	321042	1	1
45788570	40232448	2	3
4104157	45769019	4	4
21000315	975125	0	0
21001455	19059056	2	3
21002168	975125	0	0
35508372	1115008	0	0
36100000	257012	3	4
36503289	4149245	4	5
36422228	40173590	2	3
42816848	1149380	0	0
44350602	1177480	0	0
44338595	1129625	0	0
44358062	1332419	2	3
45641253	1192710	0	0
45638045	40232448	2	3
45660354	19079524	1	1
45665241	1539403	0	0
45654415	1125315	0	0
45780608	19129655	2	3
45708012	1343916	0	0
45699518	1119510	0	0
45779403	1125315	0	0
45696517	1713332	0	0
45779738	1129625	0	0
45699769	1115008	0	0
45672213	1125315	0	0
45679169	1107830	0	0
45897638	1129625	0	0
45791011	738818	0	0
45788727	1137529	0	0
46299462	1307863	0	0
500001801	313217	1	1
45788607	19059056	2	3
4134443	40479422	4	4
21000301	1738521	0	0
21001455	1539411	2	3
21002134	1746114	0	0
35508463	1125315	0	0
36152687	19133679	3	4
36503289	81151	4	8
36463361	1107882	2	3
42816865	1149196	0	0
44350577	1738521	0	0
44338545	1332418	0	0
45640219	1332419	2	3
45642982	1192710	0	0
45638171	1713671	2	3
45635671	19079524	1	1
45665305	1310149	0	0
45654431	1125315	0	0
45707153	1115171	2	3
45708247	740275	0	0
45695749	1119510	0	0
45779437	1125315	0	0
45696519	1154343	0	0
45779760	1129625	0	0
45699831	1154343	0	0
45672200	1125315	0	0
45679178	1112807	0	0
45897575	1129625	0	0
45791895	738818	0	0
45788727	1149380	0	0
46301558	1343916	0	0
46311637	46275916	1	1
45788598	40162522	2	3
4134443	40479768	4	4
21000314	975125	0	0
21001455	19075601	2	3
21002135	1741122	0	0
35508463	1129625	0	0
36206173	3000876	3	6
36503289	78272	4	9
36463429	1107882	2	3
42816957	1149380	0	0
44350385	1154029	0	0
44338546	1118084	0	0
45664318	1332419	2	3
45642970	1192710	0	0
45638169	1154615	2	3
45623802	46275916	1	1
45665313	1343916	0	0
45654432	1125315	0	0
45707254	1107882	2	3
45708078	1115008	0	0
45697704	1119510	0	0
45779443	1125315	0	0
45696650	975125	0	0
45779793	1129625	0	0
45699838	975125	0	0
45672563	1125315	0	0
45679069	19010482	0	0
45897711	1129625	0	0
45791855	738818	0	0
45788699	1115008	0	0
46301720	1000560	0	0
45801388	19074679	1	1
45788541	1551192	2	3
4176642	4035793	4	4
19131647	19132304	0	0
21001455	1545959	2	3
21002146	1741122	0	0
35508463	1119510	0	0
36206173	3015076	3	6
36503288	4113008	6	6
36423511	40228214	2	3
42818360	1125315	0	0
44350567	1149380	0	0
44338589	920293	0	0
45625594	19075601	2	3
45642919	1192710	0	0
45638380	19133873	2	3
45623802	19079524	1	1
45665409	1557272	0	0
45655442	1125315	0	0
45707256	19008572	2	3
45708161	1557272	0	0
45697654	1119510	0	0
45779489	1125315	0	0
45696651	1192710	0	0
45779879	1129625	0	0
45699869	1308738	0	0
45672587	1125315	0	0
45679029	975125	0	0
45895292	1129625	0	0
45791922	738818	0	0
45788782	975125	0	0
46301574	1713332	0	0
45795850	40171902	1	1
45788684	40229134	2	3
4130526	4144583	4	4
19054876	19054876	0	0
21000703	1539411	2	3
21001967	914335	0	0
35508503	1332418	0	0
35205038	257012	3	6
36503288	4155034	6	6
36423511	40228230	2	3
42818360	1129625	0	0
44350570	1177480	0	0
44338388	1129625	0	0
44344137	1539411	2	3
45641346	1192710	0	0
45638451	19078461	2	3
45653940	19079524	1	1
45665323	1738521	0	0
45655512	1125315	0	0
45707048	40232448	2	3
45707910	1557272	0	0
45697833	1119510	0	0
45779460	1125315	0	0
45696407	1149196	0	0
45708354	1129625	0	0
45699872	967823	0	0
45672485	1125315	0	0
45679127	1717327	0	0
45895349	1129625	0	0
45792039	738818	0	0
45788783	1738521	0	0
46301590	1192710	0	0
45876029	3014599	2	2
45788499	1115171	2	3
4116777	261325	4	4
19016749	19016749	0	0
21000703	1545959	2	3
21001973	975125	0	0
35508505	1713332	0	0
4180941	4186930	3	6
36503288	4059173	6	7
36422111	19059056	2	3
42818440	1119510	0	0
44350657	1177480	0	0
44338390	1112807	0	0
45658442	19078461	2	3
45641398	1192710	0	0
45637104	1332419	2	3
45624091	19079524	1	1
45665325	1738521	0	0
45654726	1125315	0	0
45707343	40174880	2	3
45707912	1107830	0	0
45696005	1119510	0	0
45779461	1125315	0	0
45696534	1149196	0	0
45708362	1129625	0	0
45699873	1549786	0	0
45672602	1125315	0	0
45785989	1332418	0	0
45895456	1129625	0	0
46294808	738818	0	0
45788824	1738521	0	0
46301854	708298	0	0
45876029	3001247	2	2
45788505	40232448	2	3
4116777	258780	4	4
4299128	4299128	0	0
21001447	19126352	2	3
21001982	1119510	0	0
35508469	1119510	0	0
4201745	4112343	3	7
36503288	4152936	6	8
36427514	19006318	2	3
42808572	975125	0	0
44350700	933724	0	0
44338393	1124957	0	0
45643345	19079524	2	3
45638137	1192710	0	0
45634866	1154615	2	3
45639301	19079524	1	1
45665286	1501700	0	0
45654762	1125315	0	0
45707427	40228214	2	3
45707913	738818	0	0
45693077	1119510	0	0
45779606	1125315	0	0
45696543	1545958	0	0
45708348	1129625	0	0
45699873	1512674	0	0
45672381	1125315	0	0
45785936	1000560	0	0
45895385	1129625	0	0
46244039	738818	0	0
45788835	1548195	0	0
46301786	1343916	0	0
45876029	3006734	2	2
45788657	19133905	2	3
4169466	4152936	4	4
21000706	1545958	0	0
21001447	19059056	2	3
21001960	1115008	0	0
35508473	1119510	0	0
35205038	4280726	3	7
36503288	40479768	6	9
36423453	19074843	2	3
42817353	1125315	0	0
44350492	1192710	0	0
44338605	1174888	0	0
45628639	1539411	2	3
45637957	1192710	0	0
45634875	40162522	2	3
45654063	19079524	1	1
45665292	1149196	0	0
45651367	1125315	0	0
45707566	1127433	2	3
45708291	1549786	0	0
45692915	1119510	0	0
45779607	1125315	0	0
45696544	1153428	0	0
45777958	1129625	0	0
45699873	19127890	0	0
45784301	1125315	0	0
45786010	1149196	0	0
45895480	1129625	0	0
46244043	738818	0	0
45788835	1521369	0	0
46301983	975125	0	0
45876029	3015076	2	2
45788657	19133873	2	3
4042478	4163971	4	4
21000706	1539403	0	0
21000705	1545959	2	3
21001960	1125315	0	0
35508475	1192710	0	0
36200000	4296205	3	7
36503288	40479422	6	9
36423453	19074841	2	3
42820815	1125315	0	0
44350605	1192710	0	0
44338394	1154343	0	0
44351772	1539411	2	3
45638077	1192710	0	0
45648942	19078461	2	3
45623831	46275916	1	1
45665348	1124300	0	0
45651113	1125315	0	0
45707444	40228214	2	3
45708276	1110410	0	0
45692738	1119510	0	0
45707963	1125315	0	0
45696686	738818	0	0
45705945	1129625	0	0
45699857	1501700	0	0
45784353	1125315	0	0
45786052	1149196	0	0
45895505	1129625	0	0
46244100	738818	0	0
45788839	1551099	0	0
46301984	1110410	0	0
45876029	3000876	2	2
46298026	19008572	2	3
4042142	40486433	4	4
21000756	967823	0	0
21001448	19059056	2	3
21601121	1308738	0	0
35508579	1729720	0	0
36102970	4112343	3	7
36503288	4149245	5	8
36423477	19075001	2	3
42820816	1125315	0	0
44350608	1112807	0	0
44338609	1149196	0	0
45662076	1539411	2	3
45638053	1192710	0	0
45662847	1539411	2	3
45623831	19079524	1	1
45665357	1539403	0	0
45651302	1125315	0	0
45706779	19073183	2	3
45708177	1124300	0	0
45692992	1119510	0	0
45708004	1125315	0	0
45696415	1110410	0	0
45705942	1129625	0	0
45699885	1361711	0	0
45784256	1125315	0	0
45786046	1548195	0	0
45895422	1129625	0	0
46244075	738818	0	0
45788840	967823	0	0
46301985	19003953	0	0
45876029	3021226	2	2
46301446	40236446	2	3
4042142	4280726	4	4
21000713	975125	0	0
21001448	19075601	2	3
21600234	19018935	0	3
35508581	1521369	0	0
36102154	40481087	3	7
36503288	4278672	5	7
36423476	19075001	2	3
42820884	1129625	0	0
44350812	1149196	0	0
44338406	1548195	0	0
45659255	19079524	2	3
45638262	1192710	0	0
45646883	19075601	2	3
45642105	46275916	1	1
45665387	1107830	0	0
45651153	1125315	0	0
45706510	40165015	2	3
45708291	1589505	0	0
45693189	1119510	0	0
45707953	1125315	0	0
45696433	1192710	0	0
45705769	1129625	0	0
45699889	1192710	0	0
45784262	1125315	0	0
45785995	967823	0	0
45895431	1129625	0	0
46244165	738818	0	0
45788846	1115008	0	0
46302504	1322184	0	0
45876029	3001488	2	2
46301453	40162522	2	3
4094284	4149245	4	4
21000815	1729720	0	0
21001448	40163554	2	3
21600270	1310034	0	3
35508581	1549786	0	0
36102149	40481087	3	7
36503288	4142905	5	7
36305121	3023103	2	2
42817581	1129625	0	0
44346397	1549786	0	0
44338531	1149196	0	0
45625619	40228214	2	3
44362813	1332418	0	0
45655315	1332419	2	3
45642105	19079524	1	1
45665398	1000560	0	0
45651292	1125315	0	0
45704401	1127433	2	3
45708096	19010482	0	0
45693104	1119510	0	0
45707847	1125315	0	0
45692966	738818	0	0
45705951	1129625	0	0
45699962	1149196	0	0
45784318	1125315	0	0
45785997	1112807	0	0
45895252	1129625	0	0
46244402	738818	0	0
45788909	975125	0	0
46301653	1595799	0	0
45876029	3027231	2	2
46301542	19133905	2	3
4136694	81151	4	4
21000716	1124300	0	0
21001770	1551192	2	3
21505741	40229134	5	6
35508262	1501700	0	0
36102149	28060	3	7
36503288	40480160	5	7
36305121	3016723	2	2
42817597	1125315	0	0
44346389	1124300	0	0
44338532	1177480	0	0
45625604	40228214	2	3
44361721	715997	0	0
45649757	19075601	2	3
45663658	19079524	1	1
45665401	1149196	0	0
45651390	1125315	0	0
45704255	1154615	2	3
45708099	1548195	0	0
45692862	1119510	0	0
45707896	1125315	0	0
45693253	914335	0	0
45706088	1129625	0	0
45700048	1549786	0	0
45784280	1125315	0	0
45785976	1107830	0	0
45895514	1129625	0	0
46239371	738818	0	0
45789017	1149196	0	0
46299620	1551099	0	0
45876029	3006451	2	2
46298158	43012036	2	3
4042483	4330583	4	4
21000716	1115008	0	0
21001770	40229134	2	3
21500543	40232448	5	6
35508316	1112807	0	0
36100000	433125	3	8
36503288	4230399	7	8
36503249	80502	2	2
42817688	1112807	0	0
44346369	1332418	0	0
44338534	738818	0	0
45643226	19078461	2	3
44361748	1539403	0	0
45640962	1539411	2	3
45659060	46275916	1	1
45665384	1549786	0	0
45651478	1125315	0	0
45704256	19078924	2	3
45708333	1107830	0	0
45693067	1119510	0	0
45708243	1125315	0	0
45693235	975125	0	0
45706006	1129625	0	0
45700060	1521369	0	0
45784334	1125315	0	0
45786027	1107830	0	0
45803345	1129625	0	0
46239679	738818	0	0
45788866	715997	0	0
46299709	975125	0	0
45876029	3012494	2	2
46289859	40229134	2	3
4197094	440448	4	4
21000824	975125	0	0
21001770	40228214	2	3
21500731	19079524	5	6
35508319	1125315	0	0
36100000	28060	3	8
36503288	4066995	4	7
36303200	4314290	2	2
42817786	1149196	0	0
44346586	1112807	0	0
44338537	1124300	0	0
44344260	40228214	2	3
44361859	1153428	0	0
45656042	19075601	2	3
45659060	19079524	1	1
45665384	19127890	0	0
45651608	1125315	0	0
45704364	40224805	2	3
45708110	19010482	0	0
45690014	1119510	0	0
45708076	1125315	0	0
45693239	1192710	0	0
45703700	1129625	0	0
45700147	933724	0	0
45784270	1125315	0	0
45785844	1153428	0	0
45803761	1129625	0	0
46239658	738818	0	0
45788820	1545958	0	0
46295319	1107830	0	0
45876032	3004501	2	2
46290144	1115171	2	3
4190185	81893	3	4
21000830	975125	0	0
21001770	40232448	2	3
21500731	19077344	5	6
35508319	1174888	0	0
36100000	198199	3	8
36503288	80502	4	4
36503252	40480160	2	2
42848776	1521369	0	0
44346626	1107830	0	0
44338624	1332418	0	0
45643352	40228230	2	3
44361833	1118084	0	0
45622544	40228214	2	3
45660381	19079524	1	1
45665384	1515774	0	0
45651653	1125315	0	0
45624172	715997	0	0
45705161	1501700	0	0
45689788	1119510	0	0
45708195	1125315	0	0
45693245	1110410	0	0
45703862	1129625	0	0
45693372	1521369	0	0
45786318	1125315	0	0
45786014	723013	0	0
45800979	1129625	0	0
45896136	738818	0	0
45788818	705944	0	0
46295715	1115008	0	0
46300061	19019273	2	3
46290150	40236446	2	3
4155793	4252419	3	4
21000803	1308738	0	0
21001770	1150837	2	3
21601077	964261	5	6
35508363	1129625	0	0
36200000	4059173	3	10
36702253	375671	8	10
36503287	4218389	2	2
42848776	1549786	0	0
44346613	1107830	0	0
44338636	914335	0	0
45643352	40228214	2	3
44361755	1310149	0	0
45628704	1332419	2	3
45632538	19079524	1	1
45665421	1308738	0	0
45651556	1125315	0	0
45624263	1310149	0	0
45705389	1124300	0	0
45690141	1119510	0	0
45708163	1125315	0	0
45693198	1124300	0	0
45702251	1129625	0	0
45693372	1549786	0	0
45786569	1125315	0	0
45786029	1124957	0	0
45799752	1129625	0	0
45896031	738818	0	0
45788879	1174888	0	0
46295492	1115008	0	0
46300002	19008572	2	3
46290275	1551192	2	3
4130851	4134304	3	4
21000803	1396131	0	0
21001770	40223821	2	3
21600127	40243436	5	6
35508364	1000560	0	0
36200000	4142905	3	10
36402193	4144583	8	8
36718119	381316	2	2
42808617	1125315	0	0
44346392	1107830	0	0
44338637	791967	0	0
45646145	19078461	2	3
44361890	1729720	0	0
45649974	19078461	2	3
45632591	46275916	1	1
45665422	1361711	0	0
45651270	1125315	0	0
45624276	723013	0	0
45705165	1124957	0	0
45690249	1119510	0	0
45707913	1125315	0	0
45693206	1115008	0	0
45702242	1129625	0	0
45693564	1153428	0	0
45786256	1125315	0	0
45786054	1713332	0	0
45798171	1129625	0	0
45895997	738818	0	0
46296837	1192710	0	0
46295756	723013	0	0
46300174	19019273	2	3
46290237	40231925	2	3
4134148	4117038	3	4
21000717	1551099	0	0
21001770	40223834	2	3
21503645	1177480	5	5
35508300	1192710	0	0
36102154	4112343	3	8
36516772	78272	7	8
36718119	380378	2	2
42808624	1129625	0	0
44346527	1545958	0	0
44341152	1129625	0	0
45640380	19078461	2	3
44361891	1343916	0	0
45621171	40228214	2	3
45636329	46275916	1	1
45665163	920293	0	0
45651442	1125315	0	0
45624236	1124957	0	0
45705360	738818	0	0
45690055	1119510	0	0
45708140	1125315	0	0
45692969	1332418	0	0
45702287	1129625	0	0
45693524	975125	0	0
45786454	1125315	0	0
45786054	1759842	0	0
45798173	1129625	0	0
45896807	738818	0	0
46296845	1551099	0	0
46295712	1118084	0	0
46300340	40229134	2	3
46290294	40232448	2	3
4162054	4197460	3	4
21000819	1551099	0	0
21000571	1551192	2	3
21503645	1125315	5	5
35508210	1738521	0	0
36102149	4116491	3	8
36503290	78272	7	7
40181754	40221415	2	2
42808624	1177480	0	0
44346531	933724	0	0
44341207	738818	0	0
44337454	1332419	2	3
44361896	1124300	0	0
45662642	19075601	2	3
45647677	19079524	1	1
45665430	1308738	0	0
45651561	1125315	0	0
45624244	975125	0	0
45705335	967823	0	0
45690178	1119510	0	0
45708322	1125315	0	0
45693131	1501700	0	0
45702373	1129625	0	0
45693477	1153428	0	0
45786459	1125315	0	0
45786056	967823	0	0
45798126	1129625	0	0
45804357	738818	0	0
46296758	1305058	0	0
46295687	975125	0	0
46300532	1154615	2	3
46290105	40228230	2	3
4044900	4047491	3	4
21000758	967823	0	0
21000049	46233988	2	3
21503645	19010482	5	5
35508267	1125315	0	0
36102149	4112343	3	8
36702253	381316	6	7
40057995	19127904	2	2
42821356	1153428	0	0
44346502	1115008	0	0
44341157	975125	0	0
45662341	19078461	2	3
44361897	1589505	0	0
45643483	19075601	2	3
45648191	19079524	1	1
45665249	1332418	0	0
45651689	1125315	0	0
45624391	1343916	0	0
45705453	914335	0	0
45690244	1119510	0	0
45708300	1125315	0	0
45693132	1115008	0	0
45702447	1129625	0	0
45693483	1149196	0	0
45786467	1125315	0	0
45786036	1174888	0	0
45795402	1129625	0	0
45796287	738818	0	0
46296761	1367571	0	0
46295949	1713332	0	0
46300323	19019273	2	3
46290212	1545959	2	3
4042140	317009	3	4
21000760	967823	0	0
21000049	46233710	2	3
21503645	1305058	5	5
35508302	1738521	0	0
36102149	4294548	3	8
36703458	4043241	6	6
37522376	4202451	2	2
42822200	1119510	0	0
44346754	1115008	0	0
44341158	1177480	0	0
45640340	19078461	2	3
44361900	1115008	0	0
45643562	40228214	2	3
45663669	19079524	1	1
45665371	738818	0	0
45651569	1125315	0	0
45624392	1192710	0	0
45705549	1149196	0	0
45690365	1119510	0	0
45705215	1125315	0	0
45693134	1115008	0	0
45702500	1129625	0	0
45693510	19003953	0	0
45786468	1125315	0	0
45786068	1309944	0	0
45795564	1129625	0	0
45797162	738818	0	0
46296705	914335	0	0
46295473	1717327	0	0
46296306	19075001	2	3
46292015	40232448	2	3
4180627	4218408	3	4
21000766	1125443	0	0
21001463	1332419	2	3
21503645	1118084	5	5
35508279	1125315	0	0
36100000	372328	3	3
36516728	4134304	6	6
37202317	255848	2	2
42822200	1125315	0	0
44346574	1738521	0	0
44359842	1129625	0	0
45622053	19078461	2	3
44361727	1149380	0	0
45637968	40228214	2	3
45629888	19079524	1	1
45667423	1107830	0	0
45648185	1125315	0	0
45668197	708298	0	0
45705553	1149196	0	0
45690192	1119510	0	0
45705206	1125315	0	0
45693226	914335	0	0
45702435	1129625	0	0
45693566	1308738	0	0
45784392	1125315	0	0
45786064	1192710	0	0
45796940	1129625	0	0
45796524	738818	0	0
46296548	1149196	0	0
46295421	1768849	0	0
46296315	40232448	2	3
46291545	1115171	2	3
4043161	44805732	3	4
21000874	1551099	0	0
21000591	1551192	2	3
21503645	1124957	5	5
35508279	1119510	0	0
36100000	255848	3	3
36426668	1305058	0	0
37202317	4283893	2	2
42821742	1125315	0	0
44346536	1729720	0	0
44359562	1124300	0	0
45640406	19078461	2	3
44361731	1551099	0	0
45656371	40228214	2	3
45629888	46275916	1	1
45667429	738818	0	0
45648304	1125315	0	0
45668312	1153428	0	0
45705384	1501700	0	0
45690194	1119510	0	0
45705165	1125315	0	0
45693229	1000560	0	0
45702436	1129625	0	0
45693574	1115008	0	0
45784457	1125315	0	0
45786065	1124300	0	0
45797069	1129625	0	0
45796535	738818	0	0
46295107	1326303	0	0
46295264	1310149	0	0
46318372	40243436	2	3
46292005	46233710	2	3
4043023	4216130	3	4
21000819	975125	0	0
21000538	1551192	2	3
21503645	1102527	5	5
35508280	1125315	0	0
36100000	195588	3	3
36422232	19059528	0	0
40782521	3010813	2	2
42819679	1177480	0	0
44346543	1729720	0	0
44359661	1177480	0	0
45643401	19078461	2	3
44361733	1149380	0	0
45655909	19079524	2	3
45652131	19079524	1	1
45667354	1115008	0	0
45649239	1125315	0	0
45668354	975125	0	0
45705385	1115008	0	0
45690378	1119510	0	0
45705360	1125315	0	0
45693291	1115008	0	0
45699422	1129625	0	0
45693577	1717327	0	0
45784466	1125315	0	0
45786067	1501700	0	0
45795713	1129625	0	0
45791405	738818	0	0
46295146	1557272	0	0
46296103	975125	0	0
46318402	40232448	2	3
46241955	40229134	2	3
4040396	4117038	3	4
21000806	1308738	0	0
21001459	1332419	2	3
21503645	1154029	5	5
35508280	1119510	0	0
36100000	440448	3	3
36428428	1137529	0	0
36703452	381316	2	2
42819004	1125315	0	0
44346778	1713332	0	0
44359606	1149380	0	0
45664799	19078461	2	3
44361742	967823	0	0
45659435	40228214	2	3
45658342	19079524	1	1
45667440	1500211	0	0
45649210	1125315	0	0
45668200	1124300	0	0
45705388	1149196	0	0
45686795	1119510	0	0
45705551	1125315	0	0
45694754	1115008	0	0
45699346	1129625	0	0
45693543	1192710	0	0
45784447	1125315	0	0
45786726	1149196	0	0
45795718	1129625	0	0
45791547	738818	0	0
46295039	1343916	0	0
46295728	1149196	0	0
46318807	40236824	2	3
46241956	19078461	2	3
4043025	4047491	3	4
21000806	1396131	0	0
21001456	19075601	2	3
21503645	1129625	5	5
35508280	738818	0	0
36100000	4283893	3	3
36428442	1539403	0	0
37203741	261325	2	2
42822308	1177480	0	0
44346142	1149196	0	0
44359608	791967	0	0
44358502	19078461	2	3
44361765	1149380	0	0
45622769	40228214	2	3
45658419	19079524	1	1
45667443	1589505	0	0
45648361	1125315	0	0
45668442	1361711	0	0
45705396	975125	0	0
45688409	1119510	0	0
45705554	1125315	0	0
45694627	1539403	0	0
45699488	1129625	0	0
45693587	1501700	0	0
45784450	1125315	0	0
45786369	1728416	0	0
45793005	1129625	0	0
46298495	738818	0	0
46295113	933724	0	0
46295933	1521369	0	0
46318452	40229134	2	3
46241965	40229134	2	3
4040400	4057420	3	4
21000804	1308738	0	0
21000010	19073188	2	3
21503645	1115008	5	5
35508285	1125315	0	0
35600000	4280726	3	3
36426127	1501700	0	0
37203741	4051466	2	2
42820242	1149196	0	0
44346548	1512674	0	0
44359716	975125	0	0
45634240	19078461	2	3
44361810	1310149	0	0
45640845	40228214	2	3
45660276	19079524	1	1
45667443	1549786	0	0
45648438	1125315	0	0
45668262	1192710	0	0
45705518	1107830	0	0
45688411	1119510	0	0
45705341	1125315	0	0
45694366	1759842	0	0
45699490	1129625	0	0
45693408	1149196	0	0
45784479	1125315	0	0
45786677	19010482	0	0
45792926	1129625	0	0
46298782	738818	0	0
46295116	1000560	0	0
46295934	1124957	0	0
46318767	19008572	2	3
46241968	40229134	2	3
4050571	40492359	3	3
21000806	1595799	0	0
21000010	19129655	2	3
21503160	1174888	6	6
35508285	1112807	0	0
35300000	441267	3	3
36424292	1129625	0	0
37203747	255848	2	2
42820392	1177480	0	0
44346548	19127890	0	0
44359724	1177480	0	0
45628354	19078461	2	3
44361767	1778162	0	0
45621245	1332419	2	3
45654690	19079524	1	1
45667275	738818	0	0
45648455	1125315	0	0
45668269	738818	0	0
45705350	1107830	0	0
45688696	1119510	0	0
45705329	1125315	0	0
45694366	1713332	0	0
45699594	1129625	0	0
45693326	1149196	0	0
45782313	1125315	0	0
45786539	1000560	0	0
45792839	1129625	0	0
46298939	738818	0	0
46295071	1107830	0	0
46296037	738818	0	0
46318699	19133905	2	3
46242016	40229134	2	3
4042478	4242997	3	3
21000860	1367571	0	0
21000010	19073183	2	3
21503160	914335	6	6
35508291	715997	0	0
21603282	40169281	3	3
36423716	1759842	0	0
37202312	261325	2	2
42819169	1149196	0	0
44346548	1549786	0	0
44359823	1332418	0	0
45622228	40223768	2	3
44361850	1149380	0	0
45662516	40228214	2	3
45632711	19079524	1	1
45667452	1361711	0	0
45648316	1125315	0	0
45668391	738818	0	0
45705354	1149196	0	0
45688697	1119510	0	0
45705421	1125315	0	0
45694369	1713332	0	0
45696019	1129625	0	0
45693417	933724	0	0
45782315	1125315	0	0
45786682	1192710	0	0
45792956	1129625	0	0
46290400	738818	0	0
46295173	1115008	0	0
46295667	1149196	0	0
46318725	40232448	2	3
46242020	19019273	2	3
4094683	4142905	3	3
21000825	975125	0	0
21001430	19059056	2	3
21503160	1107830	6	6
35509012	1153428	0	0
35205038	4051466	3	3
36426182	1589505	0	0
37203744	255848	2	2
42819196	1107830	0	0
44346685	738818	0	0
44359725	738818	0	0
45628522	19078461	2	3
44361877	1308738	0	0
45631930	19079524	2	3
45652012	19079524	1	1
45662805	1326303	0	0
45648513	1125315	0	0
45668370	1192710	0	0
45705166	723013	0	0
45688730	1119510	0	0
45705423	1125315	0	0
45694369	1759842	0	0
45696061	1129625	0	0
45693484	1343916	0	0
45782320	1125315	0	0
45786381	1000560	0	0
45793119	1129625	0	0
46290686	738818	0	0
46295073	1107830	0	0
46296244	1000560	0	0
46313165	1115171	2	3
46242024	40232448	2	3
4105886	4084167	3	3
21000830	1551099	0	0
21001454	19075601	2	3
21503160	1153428	6	6
35509015	1177480	0	0
35204998	321042	3	3
36155942	1115171	2	3
37003664	4116491	2	2
42820405	1125315	0	0
44346511	1124300	0	0
44359984	1112807	0	0
45658457	19078461	2	3
44361908	1000560	0	0
45621277	40228214	2	3
45632600	19079524	1	1
45662813	1310149	0	0
45648322	1125315	0	0
45668373	738818	0	0
45705343	1154343	0	0
45687103	1119510	0	0
45705430	1125315	0	0
45694372	975125	0	0
45696129	1129625	0	0
45693495	1149196	0	0
45782329	1125315	0	0
45786384	723013	0	0
45793215	1129625	0	0
46290743	738818	0	0
46295094	1107830	0	0
46295485	975125	0	0
46312531	19019273	2	3
46242178	42707627	2	3
4134184	4134304	3	3
21000873	975125	0	0
21000548	19007333	2	3
21503160	1192710	6	6
35508709	1125315	0	0
21602098	975125	3	3
36156096	19133905	2	3
37503938	44805732	2	2
42848796	1512674	0	0
44346617	738818	0	0
44360001	1192710	0	0
45631270	1545959	2	3
44361909	1118084	0	0
45631574	40228214	2	3
45626925	46275916	1	1
45662455	1539403	0	0
45648630	1125315	0	0
45668380	1326303	0	0
45705323	1154343	0	0
45687173	1119510	0	0
45705434	1125315	0	0
45694832	1759842	0	0
45696159	1129625	0	0
45693422	1343916	0	0
45782222	1125315	0	0
45786133	1112807	0	0
45792127	1129625	0	0
46291113	738818	0	0
46295178	1192710	0	0
46295417	1149196	0	0
46312823	19059056	2	3
46242319	19008572	2	3
4189544	4015189	3	3
21000825	1551099	0	0
21001775	40229134	2	3
21503146	19023398	6	7
35508390	1125315	0	0
36102971	258780	3	3
36156026	1127433	2	3
37503938	4186930	2	2
42848796	1549786	0	0
44346665	1112807	0	0
44359573	1343916	0	0
45659239	19078461	2	3
44361910	1000560	0	0
45649962	19078461	2	3
45638826	46275916	1	1
45662783	740275	0	0
45648631	1125315	0	0
45668559	1000560	0	0
45705327	1149196	0	0
45684127	1119510	0	0
45705746	1125315	0	0
45694832	1713332	0	0
45696495	1129625	0	0
45693427	1174888	0	0
45782524	1125315	0	0
45786139	19002770	0	0
45790323	1129625	0	0
46242354	738818	0	0
46295385	967823	0	0
46296250	1154029	0	0
46312942	40162522	2	3
46242234	40229134	2	3
4193169	4112343	3	3
19132304	19132304	0	0
21001775	43012036	2	3
21500541	40232448	6	7
35508454	1119510	0	0
21604389	740275	3	3
36156044	1127433	2	3
36703484	378419	2	2
42848815	1129625	0	0
44346667	1174888	0	0
44359575	1332418	0	0
45625399	40223768	2	3
44361816	1729720	0	0
45649995	19079524	2	3
45654133	19079524	1	1
45662788	1332418	0	0
45648643	1125315	0	0
45668294	1713332	0	0
45705331	1307863	0	0
45684174	1119510	0	0
45705568	1125315	0	0
45694945	1110410	0	0
45696323	1129625	0	0
45693468	1521369	0	0
45782502	1125315	0	0
45786140	1500211	0	0
45790707	1129625	0	0
46242356	738818	0	0
46295404	914335	0	0
46295682	1174888	0	0
46313096	1551192	2	3
46242182	40229134	2	3
4117301	4107731	3	3
19133679	19133679	0	0
21000544	19007333	2	3
21503444	19079524	6	7
35508211	1125315	0	0
21604069	19003953	3	3
36156140	19073183	2	3
37396230	4024289	2	2
42848815	1119510	0	0
44346668	1177480	0	0
44360007	1149380	0	0
45628629	19079524	2	3
44361883	705944	0	0
45640813	1539411	2	3
45639363	46275916	1	1
45662898	19127890	0	0
45648553	1125315	0	0
45668296	933724	0	0
45705333	1738521	0	0
45684213	1119510	0	0
45705510	1125315	0	0
45694393	1759842	0	0
45696329	1129625	0	0
45693601	1154029	0	0
45782528	1125315	0	0
45786143	19127890	0	0
45790531	1129625	0	0
46240237	738818	0	0
46295408	1115008	0	0
46296184	1115008	0	0
46313043	1127433	2	3
46242192	19008572	2	3
4116777	260139	3	3
21000230	1738521	0	0
21000038	1551192	2	3
21503444	19077344	6	7
35508376	1125315	0	0
21604181	753626	3	3
36156186	19073188	2	3
37396230	4252419	2	2
42848925	1129625	0	0
44346818	701322	0	0
44359577	1153428	0	0
45637509	1332419	2	3
44361963	1115008	0	0
45649610	40228214	2	3
45657708	46275916	1	1
45662898	1549786	0	0
45648714	1125315	0	0
45668398	1501700	0	0
45705414	1305058	0	0
45684217	1119510	0	0
45705734	1125315	0	0
45694859	920293	0	0
45696532	1129625	0	0
45693604	1768849	0	0
45782283	1125315	0	0
45786143	1549786	0	0
45790471	1129625	0	0
45798493	1177480	0	0
46295413	967823	0	0
46296193	1305058	0	0
46312733	40174880	2	3
46242198	40228214	2	3
4134174	4134304	3	3
21000260	1738521	0	0
21000009	46233710	2	3
21503645	19019979	7	8
35508483	1115008	0	0
21604181	19016749	3	3
36155991	46275916	2	3
37503922	4330583	2	2
42848925	1119510	0	0
44346595	705944	0	0
44359583	1549786	0	0
45621158	19079524	2	3
44361937	715997	0	0
45653416	19078461	2	3
45657233	46275916	1	1
45662831	1154343	0	0
45648658	1125315	0	0
45668446	1149196	0	0
45705305	1332418	0	0
45654991	1125315	0	0
45705664	1125315	0	0
45694864	1548195	0	0
45693232	1129625	0	0
45693743	1326303	0	0
45782565	1125315	0	0
45786143	1589505	0	0
45790607	1129625	0	0
45798460	1177480	0	0
46295277	1713332	0	0
46296195	975125	0	0
46313032	40163554	2	3
46242309	40229134	2	3
4050747	4134304	3	3
21000260	1746114	0	0
21000009	46233988	2	3
21503645	19133768	7	8
35508488	1125315	0	0
36217214	19127922	3	4
36156196	19126352	2	3
37503940	4117038	2	2
42848925	1125315	0	0
44346758	1124300	0	0
44359583	19127890	0	0
44351937	1332419	2	3
44361972	1738521	0	0
45637993	40223768	2	3
45657118	46275916	1	1
45662608	1768849	0	0
45645345	1125315	0	0
45668399	1551099	0	0
45705521	1322184	0	0
45655070	1125315	0	0
45702004	1125315	0	0
45694891	1107830	0	0
45693126	1129625	0	0
45693958	975125	0	0
45782567	1125315	0	0
45786176	1149196	0	0
45787676	1129625	0	0
45798614	1177480	0	0
46295193	1192710	0	0
46295588	1729720	0	0
46312929	40223834	2	3
46241988	40229134	2	3
4170143	40481087	3	3
21000259	1738521	0	0
21000584	40174880	2	3
21503645	40165015	7	8
35508488	1119510	0	0
36102149	198199	2	7
36156200	19078461	2	3
37202310	441267	2	2
42848992	1112807	0	0
44346760	1149380	0	0
44359583	1515774	0	0
45646193	1539411	2	3
44361928	1149196	0	0
45646756	40223768	2	3
45657438	46275916	1	1
45662913	1549786	0	0
45645145	1125315	0	0
45668448	1557272	0	0
45705622	1545958	0	0
45655109	1125315	0	0
45702005	1125315	0	0
45693313	738818	0	0
45693231	1129625	0	0
45693440	1310149	0	0
45782586	1125315	0	0
45786197	975125	0	0
45787624	1129625	0	0
45798553	1177480	0	0
46295198	933724	0	0
46296417	738818	0	0
46313079	40162522	2	3
46242325	19059056	2	3
4134134	4066995	3	3
21000249	1728416	0	0
21000578	40174880	2	3
21503645	19059056	7	8
35508488	738818	0	0
4041262	4330583	2	6
36156204	40232448	2	3
37202310	317009	2	2
42848992	1125315	0	0
44346802	1343916	0	0
44359693	1713332	0	0
45658886	1332419	2	3
44361996	723013	0	0
45664958	40223768	2	3
45644836	46275916	1	1
45662913	19127890	0	0
45645238	1125315	0	0
45668439	1713332	0	0
45705625	1107830	0	0
45654785	1125315	0	0
45701894	1125315	0	0
45693395	1153428	0	0
45693298	1129625	0	0
45693589	1551099	0	0
45782589	1125315	0	0
45786206	1713332	0	0
45787792	1129625	0	0
45798690	1177480	0	0
46295210	975125	0	0
46296441	1310149	0	0
46307734	40236824	2	3
46242146	19133873	2	3
4134134	4001336	3	3
21000250	1728416	0	0
21001385	1713671	2	3
21503645	40231925	7	8
35508489	1129625	0	0
36103041	40481087	2	6
36156604	1127433	2	3
37003657	195588	2	2
42848992	1129625	0	0
44346518	1112807	0	0
44360067	1549786	0	0
45624981	40223768	2	3
44361942	1738521	0	0
45641211	19078461	2	3
45641824	46275916	1	1
45662913	1512674	0	0
45645258	1125315	0	0
45668381	1107830	0	0
45705603	1153428	0	0
45655118	1125315	0	0
45702091	1125315	0	0
45693398	1124300	0	0
45690317	1129625	0	0
45693616	1192710	0	0
45782590	1125315	0	0
45786102	1545958	0	0
45789261	1129625	0	0
45793370	1177480	0	0
46295213	1000560	0	0
46295874	791967	0	0
46308216	19008572	2	3
46242257	1127078	2	3
4043174	4336464	3	3
21000251	1728416	0	0
21001385	19074841	2	3
21600001	35605482	5	7
21604256	1110410	0	0
36102144	28060	2	6
36156592	19073183	2	3
37108852	4174876	2	2
42849011	1119510	0	0
44346618	1713332	0	0
44360067	19127890	0	0
45652430	40174880	2	3
44362057	1332418	0	0
45659352	19078461	2	3
45641977	46275916	1	1
45662927	1115008	0	0
45645434	1125315	0	0
45668678	1115008	0	0
45705608	1149380	0	0
45655290	1125315	0	0
45702089	1125315	0	0
45693399	1192710	0	0
45690397	1129625	0	0
45693594	1149196	0	0
45782596	1125315	0	0
45786108	1124300	0	0
45789401	1129625	0	0
45793386	1177480	0	0
46295383	705944	0	0
46296431	19059528	0	0
46308228	40162522	2	3
46242200	19133905	2	3
4134439	375671	3	3
21000252	1728416	0	0
21000012	19129655	2	3
21600001	40243436	6	7
21604260	1124957	0	0
36102144	433125	2	6
36156612	1594382	2	3
40782562	3019550	2	2
42849011	1125315	0	0
44346829	738818	0	0
44360067	1512674	0	0
45662023	40174880	2	3
44362208	1545958	0	0
45646785	19078461	2	3
45638751	46275916	1	1
45662957	1307863	0	0
45645556	1125315	0	0
45668427	1192710	0	0
45705611	967823	0	0
45654961	1125315	0	0
45701822	1125315	0	0
45693402	1308738	0	0
45690341	1129625	0	0
45693801	1738521	0	0
45782543	1125315	0	0
45786177	791967	0	0
45787896	1129625	0	0
45793227	1177480	0	0
46295241	1545958	0	0
46295611	1549786	0	0
46308286	920300	2	3
46242288	40229134	2	3
4134439	378001	3	3
21000253	1728416	0	0
21001750	46233988	2	3
21600001	967823	4	4
21603929	1305058	0	0
4180941	4238715	2	5
36156602	19133905	2	3
40782472	3001247	2	2
42849011	1129625	0	0
44346282	1112807	0	0
44359826	975125	0	0
45625348	19078461	2	3
44362168	1115008	0	0
45659584	40223768	2	3
45638857	46275916	1	1
45662965	1149196	0	0
45645563	1125315	0	0
45668489	1332418	0	0
45705313	975125	0	0
45655198	1125315	0	0
45701824	1125315	0	0
45693301	975125	0	0
45690326	1129625	0	0
45693807	1107830	0	0
45782483	1125315	0	0
45786184	1174888	0	0
45786325	1129625	0	0
45793266	1177480	0	0
46295329	1107830	0	0
46295611	1595799	0	0
46307694	1115171	2	3
45893688	46233710	2	3
4161193	28060	3	3
21000254	1728416	0	0
21001750	19073183	2	3
21601237	1545958	4	4
21604049	1177480	0	0
21604390	19074679	2	5
35909452	198809	2	2
40782476	3000876	2	2
42822312	1125315	0	0
44346820	1124957	0	0
44359828	1107830	0	0
44778278	40174880	2	3
44362173	1589505	0	0
45643671	19078461	2	3
45638854	46275916	1	1
45662841	1717327	0	0
45645126	1125315	0	0
45668585	1713332	0	0
45705492	1548195	0	0
45700755	1125315	0	0
45702197	1125315	0	0
45693337	1738521	0	0
45690495	1129625	0	0
45693784	1149196	0	0
45782484	1125315	0	0
45786320	1589505	0	0
45786233	1129625	0	0
45794723	1177480	0	0
46295431	1332418	0	0
46295611	1521369	0	0
46308117	40162522	2	3
45893688	46233988	2	3
4161193	433125	3	3
21000255	1728416	0	0
21000242	46233710	2	3
21601237	1309944	4	4
21602820	1717327	0	0
21604752	19123231	2	5
35707601	4285898	2	2
40782579	3006923	2	2
42822431	1119510	0	0
44346821	1153428	0	0
44359796	1307863	0	0
45659110	1539411	2	3
44362173	1549786	0	0
45630830	1539411	2	3
45638961	46275916	1	1
45662969	1124957	0	0
45645463	1125315	0	0
45668458	738818	0	0
45705613	1309944	0	0
45700900	1125315	0	0
45701852	1125315	0	0
45693563	738818	0	0
45690556	1129625	0	0
45693812	708298	0	0
45782489	1125315	0	0
45786320	1549786	0	0
45786303	1129625	0	0
45794686	1177480	0	0
46295441	1551099	0	0
46295703	1729720	0	0
46308095	19019273	2	3
45893649	40232448	2	3
4180170	28060	3	3
21000256	1728416	0	0
21000923	19076374	2	3
21601237	46275916	6	7
21601856	1539403	0	0
21604752	40236446	2	5
36211103	4230399	2	2
40782935	3049273	2	2
42804716	1361711	0	0
44346822	1124300	0	0
44359799	975125	0	0
45652616	1545959	2	3
44362064	738818	0	0
44362635	1125315	0	0
45636880	46275916	1	1
45662934	967823	0	0
45645133	1125315	0	0
45668550	1545958	0	0
45705685	1332418	0	0
45701485	1125315	0	0
45702044	1125315	0	0
45693629	1367571	0	0
45690501	1129625	0	0
45693907	1149380	0	0
45782673	1125315	0	0
45786081	975125	0	0
45786413	1129625	0	0
45794816	1177480	0	0
46295623	975125	0	0
46291142	1192710	0	0
46308088	19077344	2	3
45893768	19019273	2	3
4180170	255848	3	3
21000257	1728416	0	0
21001773	40228214	2	3
21601237	40171902	5	5
21601860	1545958	0	0
36102149	260139	2	4
36211267	4146173	2	2
40782883	3008598	2	2
42805045	1125315	0	0
44346661	1149196	0	0
44360160	723013	0	0
45634819	1545959	2	3
44361945	967823	0	0
44362738	1125315	0	0
45637158	46275916	1	1
45662947	1322184	0	0
45645395	1125315	0	0
45668524	1125443	0	0
45705491	715997	0	0
45701604	1125315	0	0
45702068	1125315	0	0
45693357	975125	0	0
45690428	1129625	0	0
45693909	1738521	0	0
45782606	1125315	0	0
45786287	1115008	0	0
46296864	1129625	0	0
45787979	1177480	0	0
46295628	1500211	0	0
46291187	1107830	0	0
46308342	1115171	2	3
45893744	40236824	2	3
4180170	40481087	3	3
21000258	1728416	0	0
21001772	19112599	2	3
21600959	964261	6	7
21601423	1305058	0	0
4130851	4146173	2	4
36211224	375671	2	2
40760140	3000963	2	2
42805045	1124957	0	0
44346298	1177480	0	0
44359864	1713332	0	0
45628607	1539411	2	3
44362217	967823	0	0
44360434	1125315	0	0
45631025	46275916	1	1
45662708	1539403	0	0
45645403	1125315	0	0
45668614	1107830	0	0
45705543	1551099	0	0
45701640	1125315	0	0
45702129	1125315	0	0
45693500	1519936	0	0
45687158	1129625	0	0
45693664	1738521	0	0
45782607	1125315	0	0
46292407	701322	0	0
46296996	1129625	0	0
45787961	1177480	0	0
46295242	1322184	0	0
46290800	1595799	0	0
46302576	40231925	2	3
45893839	1127433	2	3
4180170	257012	3	3
19133768	19133768	0	0
21001772	43012036	2	3
21600959	1310149	4	4
35406426	372328	0	0
4130852	4152936	2	4
36211224	378001	2	2
40760141	3000963	2	2
42805052	1112807	0	0
44346404	1115008	0	0
44359864	1759842	0	0
44344196	1539411	2	3
45655900	1310149	0	0
44360523	1125315	0	0
45626851	19079524	1	1
45662830	715997	0	0
45645406	1125315	0	0
45668760	1153428	0	0
45705545	723013	0	0
45701621	1125315	0	0
45702139	1125315	0	0
45693507	1310149	0	0
45687393	1129625	0	0
45693833	1361711	0	0
45782618	1125315	0	0
46292483	1124957	0	0
46297029	1129625	0	0
45788113	1177480	0	0
46295247	1738521	0	0
46290800	1549786	0	0
46302816	40229134	2	3
45893952	40174880	2	3
4171379	4116491	3	3
19133873	19133873	0	0
21001745	1713671	2	3
21600959	1396131	4	4
35406429	372328	0	0
36213602	19128263	2	3
36211259	4149245	2	2
40480513	439777	2	2
42805054	1119510	0	0
44346797	1738521	0	0
44359987	1149380	0	0
45641020	1539411	2	3
45655903	1343916	0	0
44360481	1125315	0	0
45623761	46275916	1	1
45662850	738818	0	0
45645510	1125315	0	0
45668632	1000560	0	0
45705409	967823	0	0
45701749	1125315	0	0
45702159	1125315	0	0
45693407	1332418	0	0
45687570	1129625	0	0
45693920	1310149	0	0
45782675	1125315	0	0
46292486	1112807	0	0
46297035	1129625	0	0
46294316	1177480	0	0
46295163	1153428	0	0
46290800	1521369	0	0
46302823	1551192	2	3
45894165	19019273	2	3
4049890	4107731	3	3
19133905	19133905	0	0
21000967	19076374	2	3
21600959	1367571	4	4
21603619	975125	0	0
36213602	19128022	2	3
36211065	40480160	2	2
40181757	40221415	2	2
42805124	1119510	0	0
44346813	1153428	0	0
44359834	933724	0	0
45620869	1539411	2	3
45655868	1110410	0	0
44360482	1125315	0	0
45667600	19079524	1	1
45662856	1115008	0	0
45646221	1125315	0	0
45668634	1153428	0	0
45705505	791967	0	0
45701706	1125315	0	0
45702026	1125315	0	0
45690296	701322	0	0
45687376	1129625	0	0
45691568	1551099	0	0
45702582	1125315	0	0
46292490	1332418	0	0
46297077	1129625	0	0
46294206	1177480	0	0
46295356	975125	0	0
46290904	1153428	0	0
46302693	40232448	2	3
45893897	42707627	2	3
4042501	4230399	3	3
19134077	19134077	0	0
21001382	19133873	2	3
21600959	1112807	4	4
21603448	1129625	0	0
4130851	78272	2	3
36211065	4278672	2	2
40181781	40221415	2	2
42805040	1713332	0	0
44346606	975125	0	0
44359837	1129625	0	0
45621220	1539411	2	3
45655873	1738521	0	0
44360555	1125315	0	0
45667603	46275916	1	1
45662937	1332418	0	0
45642367	1125315	0	0
45668685	1501700	0	0
45705480	1332418	0	0
45701713	1125315	0	0
45699021	1125315	0	0
45690457	1118084	0	0
45687686	1129625	0	0
45691446	1124300	0	0
45702589	1125315	0	0
46292421	1115008	0	0
46297113	1129625	0	0
46294394	1177480	0	0
46295637	1192710	0	0
46290981	1738521	0	0
46302772	19008572	2	3
45893843	1115171	2	3
4181195	4301346	3	3
19019273	19019273	0	0
21000919	19076374	2	3
21600959	1308738	4	4
21602106	975125	0	0
36213604	19128009	2	3
36211065	4066995	2	2
40181783	40221415	2	2
42805040	1759842	0	0
44346722	967823	0	0
44359991	1713332	0	0
45665016	1539411	2	3
45655875	1361711	0	0
44360560	1125315	0	0
45667730	19079524	1	1
45662973	1549786	0	0
45642315	1125315	0	0
45668409	975125	0	0
45705575	708298	0	0
45701795	1125315	0	0
45699152	1125315	0	0
45690284	1124300	0	0
45687303	1129625	0	0
45691450	1713332	0	0
45702592	1125315	0	0
46292576	1112807	0	0
46297229	1129625	0	0
46294543	1177480	0	0
46244425	1107830	0	0
46244910	1713332	0	0
46303280	19078461	2	3
45893831	1115171	2	3
4043346	255848	3	3
4314290	4314290	0	0
21000526	19007333	2	3
21600959	967823	4	4
21602115	975125	0	0
36213603	19128009	2	3
36211065	4237458	2	2
40062921	19128065	2	2
42805042	1738521	0	0
44346723	1713332	0	0
44360014	1332418	0	0
45622574	1539411	2	3
45655792	1124957	0	0
44360569	1125315	0	0
45668214	46275916	1	1
45662973	1521369	0	0
45642357	1125315	0	0
45668493	1124300	0	0
45705510	738818	0	0
45701808	1125315	0	0
45699204	1125315	0	0
45690285	1548195	0	0
45687690	1129625	0	0
45691466	1589505	0	0
45702533	1125315	0	0
46292576	1192710	0	0
46297525	1129625	0	0
46243853	1177480	0	0
46244285	1539403	0	0
46244914	1000560	0	0
46303214	40236824	2	3
45801715	1154615	2	3
4043346	260139	3	3
4275113	4275113	0	0
21000565	19007333	2	3
21600959	19075601	4	7
35507306	1125315	0	0
21604086	42707627	2	3
36211065	4048695	2	2
36718317	375671	2	2
42805129	1713332	0	0
44346738	1115008	0	0
44359622	1177480	0	0
45649773	19079524	1	1
45655829	1153428	0	0
44360534	1125315	0	0
45665592	19079524	1	1
45662973	19127890	0	0
45642358	1125315	0	0
45668496	1115008	0	0
45705513	1107830	0	0
45701790	1125315	0	0
45699162	1125315	0	0
45690287	1149196	0	0
45685475	1129625	0	0
45691466	1549786	0	0
45702633	1125315	0	0
46292635	1332418	0	0
46297155	1129625	0	0
46243775	1177480	0	0
46244475	1548195	0	0
46244836	1115008	0	0
46300425	19008572	2	3
45801767	1115171	2	3
4082416	372328	3	3
4278672	4278672	0	0
21001427	19133873	2	3
21600959	40163554	4	7
35507359	1332418	0	0
36156691	46275916	2	3
36211065	4059173	2	2
36718157	4043241	2	2
42805129	1759842	0	0
44348184	1107830	0	0
44359623	1115008	0	0
45649773	46275916	1	1
45655909	967823	0	0
44360547	1125315	0	0
45665855	46275916	1	1
45662946	1000560	0	0
45642370	1125315	0	0
45668497	742185	0	0
45705581	1539403	0	0
45701930	1125315	0	0
45699219	1125315	0	0
45690305	738818	0	0
45684426	1129625	0	0
45690640	1192710	0	0
45702749	1125315	0	0
46292673	1595799	0	0
46293093	1129625	0	0
46244653	1177480	0	0
46244441	1332418	0	0
46244974	1332418	0	0
46300301	40162522	2	3
45801638	19059056	2	3
4040549	4323902	3	3
4029498	4029498	0	0
19003953	42707627	2	3
21502553	46275916	7	8
35507274	1153428	0	0
35506838	19133905	2	3
36211305	4152936	2	2
36718162	4043241	2	2
42804941	1332418	0	0
44348291	1551099	0	0
44359557	1713332	0	0
45625987	19079524	1	1
45655882	708298	0	0
44353470	1125315	0	0
45663505	19079524	1	1
45664641	1545958	0	0
45642454	1125315	0	0
45668587	1310149	0	0
45705708	975125	0	0
45701882	1125315	0	0
45699148	1125315	0	0
45690306	975125	0	0
45684515	1129625	0	0
45690667	1307863	0	0
45702604	1125315	0	0
46292673	1308738	0	0
46293456	1129625	0	0
46244875	1177480	0	0
46244331	1192710	0	0
46244625	1149196	0	0
46300807	1127433	2	3
45801824	1551192	2	3
4040549	4337611	3	3
4094814	4094814	0	0
21001379	19133905	2	3
21500327	40229134	7	8
35507349	1107830	0	0
35506841	19008572	2	3
36211305	4113008	2	2
36718526	380378	2	2
42805156	1332418	0	0
44348297	740275	0	0
44359557	1759842	0	0
45644127	46275916	1	1
45655847	1107830	0	0
44353456	1125315	0	0
45657615	46275916	1	1
45664634	19078219	0	0
45642627	1125315	0	0
45668452	738818	0	0
45705710	1501700	0	0
45701883	1125315	0	0
45699308	1125315	0	0
45690467	1713332	0	0
45684581	1129625	0	0
45690711	1174888	0	0
45702742	1125315	0	0
46292796	1545958	0	0
46239320	1308738	0	0
46244056	1177480	0	0
46244411	1192710	0	0
46244636	738818	0	0
46300429	40162522	2	3
45801809	1127433	2	3
4043028	44783196	3	3
4048695	4048695	0	0
21000033	19129655	2	3
21502620	19075001	7	8
35507412	1154343	0	0
35506941	40162522	2	3
36211305	4109685	2	2
37521054	4198190	2	3
42805010	1124300	0	0
44348302	1177480	0	0
44360136	1115008	0	0
45644127	19079524	1	1
45655915	1124957	0	0
44353460	1125315	0	0
45658004	19079524	1	1
45664553	1115008	0	0
45642749	1125315	0	0
45668415	1154029	0	0
45705759	975125	0	0
45701971	1125315	0	0
45699249	1125315	0	0
45690473	975125	0	0
45681241	1129625	0	0
45690641	1153428	0	0
45702708	1125315	0	0
46292821	1174888	0	0
46239069	1124300	0	0
46244032	1177480	0	0
46244411	1174888	0	0
46244637	1174888	0	0
46300436	920300	2	3
45801854	1115171	2	3
4101796	380378	3	3
4181917	4181917	0	0
21001759	19133905	2	3
21502620	46233710	7	8
35507377	1738521	0	0
35506987	1551192	2	3
36211305	4155034	2	2
37202317	257012	2	3
42805157	967823	0	0
44348307	1112807	0	0
44360071	1115008	0	0
45649553	46275916	1	1
45655947	738818	0	0
44353614	1125315	0	0
45654465	46275916	1	1
45664555	738818	0	0
45642558	1125315	0	0
45668416	1501700	0	0
45702004	738818	0	0
45701932	1125315	0	0
45699352	1125315	0	0
45690307	1192710	0	0
45678100	1129625	0	0
45690723	723013	0	0
45702573	1125315	0	0
46292550	1741122	0	0
46239220	1115008	0	0
46238947	1177480	0	0
46244420	1107830	0	0
46239831	705944	0	0
46300484	19075001	2	3
45802417	19008572	2	3
4162054	4295880	3	3
4174876	4174876	0	0
21001759	19133873	2	3
21502620	19133905	7	8
35507382	1129625	0	0
35506993	40224805	2	3
36211375	4132546	2	2
37202317	28060	2	3
42805167	920293	0	0
44348372	1000560	0	0
44360076	1137529	0	0
45649553	19079524	1	1
45656199	1595799	0	0
44353618	1125315	0	0
45651175	46275916	1	1
45664569	1000560	0	0
45642559	1125315	0	0
45665857	738818	0	0
45702005	1174888	0	0
45701939	1125315	0	0
45699358	1125315	0	0
45690570	708298	0	0
45678104	1129625	0	0
45690728	1361711	0	0
45702675	1125315	0	0
46292550	1746114	0	0
46239200	1521369	0	0
46238985	1177480	0	0
46244482	1192710	0	0
46240037	1545958	0	0
46300598	40229134	2	3
45802604	19078461	2	3
4129747	4117038	3	3
4139681	4139681	0	0
21001751	19073183	2	3
21502620	19074843	7	8
35507382	1125315	0	0
35507205	1115171	2	3
36211375	4156265	2	2
37503958	4337611	2	3
42805008	1110410	0	0
44348438	701322	0	0
44360076	1149380	0	0
44360243	1115171	2	3
45656199	1308738	0	0
44353572	1125315	0	0
45647634	46275916	1	1
45664650	740275	0	0
45642479	1125315	0	0
45665861	1192710	0	0
45702016	1000560	0	0
45698765	1125315	0	0
45699407	1125315	0	0
45690403	1738521	0	0
45678091	1129625	0	0
45690643	1118084	0	0
45702680	1125315	0	0
46292558	1154343	0	0
46239234	1192710	0	0
46239185	1177480	0	0
46244483	1549786	0	0
46240115	1153428	0	0
46300564	19059056	2	3
45799091	40236446	2	3
4095631	317576	3	3
4084167	4084167	0	0
21001752	40229134	2	3
21502620	19074841	7	8
35507318	1738521	0	0
36152544	40236446	2	3
36210656	3013682	2	2
36718588	44782520	2	3
42805009	1110410	0	0
44348443	1115008	0	0
44360080	1129625	0	0
44360303	19133905	2	3
45656121	967823	0	0
44353581	1125315	0	0
45645351	19079524	1	1
45663013	1149196	0	0
45642564	1125315	0	0
45665873	1153428	0	0
45701748	1501700	0	0
45698766	1125315	0	0
45699512	1125315	0	0
45690318	1192710	0	0
45678164	1129625	0	0
45690637	1595799	0	0
45702651	1125315	0	0
46292711	1112807	0	0
46239080	1149196	0	0
45894748	1177480	0	0
46244483	1521369	0	0
46239873	1192710	0	0
46300633	19019273	2	3
45799332	1551192	2	3
4095793	45769019	3	3
4051466	4051466	0	0
19002770	19023423	2	3
21502620	46233988	7	8
35507319	975125	0	0
36152880	40229134	2	3
36210656	3006906	2	2
36427520	19133905	2	3
42805134	1177480	0	0
44348358	738818	0	0
44360015	1501700	0	0
44360306	40229134	2	3
45656029	738818	0	0
44353488	1125315	0	0
45642429	46275916	1	1
45663078	1149196	0	0
45642632	1125315	0	0
45665856	1107830	0	0
45702177	1115008	0	0
45698488	1125315	0	0
45699518	1125315	0	0
45690409	1149196	0	0
45678265	1129625	0	0
45690674	1124957	0	0
45702652	1125315	0	0
46292712	791967	0	0
46239381	1557272	0	0
45894575	1177480	0	0
46244497	1115008	0	0
46239883	1713332	0	0
46300852	40231925	2	3
45799337	40231925	2	3
4180169	198199	3	3
4043241	4043241	0	0
4226263	4112343	2	3
21502620	1713671	7	8
35507320	975125	0	0
36152889	1115171	2	3
35702800	28060	2	2
36427520	19133873	2	3
42805011	1177480	0	0
44342670	1177480	0	0
44360148	1332418	0	0
44360270	40162522	2	3
45656206	1310149	0	0
44353419	1125315	0	0
45638881	46275916	1	1
45663102	1174888	0	0
45642496	1125315	0	0
45666278	1332418	0	0
45701911	1107830	0	0
45698733	1125315	0	0
45695931	1125315	0	0
45690340	1192710	0	0
45678321	1129625	0	0
45690688	975125	0	0
45702653	1125315	0	0
46292997	1102527	0	0
46239067	1118084	0	0
45894443	1177480	0	0
46244434	705944	0	0
46239956	1713332	0	0
46300766	46233988	2	3
45799354	40229134	2	3
4180169	134438	3	3
21000261	1778162	0	0
4288734	261325	2	2
21502620	19129655	7	8
35507321	1119510	0	0
36152462	1551192	2	3
36211391	4296204	2	2
36718338	4029498	2	3
42805014	1501700	0	0
44342675	1549786	0	0
44360154	791967	0	0
44353471	46275916	2	3
45656032	1326303	0	0
44353544	1125315	0	0
45639139	46275916	1	1
45663104	1310149	0	0
45642500	1125315	0	0
45666322	1124300	0	0
45702087	975125	0	0
45698741	1125315	0	0
45695812	1125315	0	0
45690342	1154029	0	0
45678696	1129625	0	0
45690689	1192710	0	0
45702543	1125315	0	0
46292739	1124300	0	0
46239409	19127890	0	0
45801504	1177480	0	0
46244318	1115008	0	0
46240059	1308738	0	0
46301018	40231925	2	3
45799348	19008572	2	3
4044887	44783196	3	3
21000284	1778162	0	0
4223595	40486433	2	2
21502620	46275444	7	8
35507417	1125315	0	0
36152703	19008572	2	3
35809320	4066995	2	2
36718338	44782520	2	3
42805017	1501700	0	0
44342675	1521369	0	0
44360218	1521369	0	0
44353614	1127433	2	3
45656051	723013	0	0
44353697	1125315	0	0
45635790	46275916	1	1
45663016	738818	0	0
45640051	1125315	0	0
45666282	1124957	0	0
45702099	975125	0	0
45698911	1125315	0	0
45695744	1125315	0	0
45690345	19010482	0	0
45678779	1129625	0	0
45690692	975125	0	0
45702546	1125315	0	0
46292744	708298	0	0
46239409	1549786	0	0
45801560	1177480	0	0
46244319	1741122	0	0
46240071	1549786	0	0
46301122	19018935	2	3
45799132	1115171	2	3
4190185	198809	3	3
21000244	1728416	0	0
4223595	4280726	2	2
21502620	19073183	7	8
35507531	1119510	0	0
36152576	40236824	2	3
36207527	3049273	2	2
37503992	4035793	2	4
42805102	1332418	0	0
44342952	1149196	0	0
44360218	1549786	0	0
44353576	19126352	2	3
45655968	1713332	0	0
44353664	1125315	0	0
45659022	1125315	0	0
45663131	1343916	0	0
45640058	1125315	0	0
45666330	1500211	0	0
45701833	1500211	0	0
45700538	1125315	0	0
45695745	1125315	0	0
45690321	1515774	0	0
45678353	1129625	0	0
45690647	1521369	0	0
45702548	1125315	0	0
46292647	1322184	0	0
46239409	1589505	0	0
45801616	1177480	0	0
46244319	1746114	0	0
46240071	1521369	0	0
46319065	1127433	2	3
45799283	1115171	2	3
4190185	28060	3	3
21000244	1713332	0	0
4223616	4084167	2	2
21500120	1548195	7	7
35204953	313217	0	0
36152579	40231925	2	3
36207527	3004501	2	2
37503992	4107731	2	6
42805111	1500211	0	0
44342648	1557272	0	0
44360143	738818	0	0
44353415	19008572	2	3
45655969	1115008	0	0
44353666	1125315	0	0
45659125	1125315	0	0
45663176	1501700	0	0
45639476	1125315	0	0
45666105	1107830	0	0
45702194	1107830	0	0
45700548	1125315	0	0
45695587	1125315	0	0
45690321	1549786	0	0
45675283	1129625	0	0
45690650	914335	0	0
45702852	1125315	0	0
46292653	1115008	0	0
46239156	1192710	0	0
45801463	1177480	0	0
46244438	1124957	0	0
46240118	1549786	0	0
46319428	1115171	2	3
45793702	40232448	2	3
4190185	440448	3	3
21000244	1738521	0	0
4224259	40486433	2	2
21500120	1501700	7	7
21605060	914335	0	0
36152908	1107882	2	3
36211091	4146173	2	2
37503992	4330583	2	9
42804928	1177480	0	0
44342766	738818	0	0
44359769	1177480	0	0
44353779	40163554	2	3
45656075	1149196	0	0
44353706	1125315	0	0
45659129	1125315	0	0
45663018	1713332	0	0
45639450	1125315	0	0
45666345	1124300	0	0
45702061	1326303	0	0
45700661	1125315	0	0
45695753	1125315	0	0
45690323	975125	0	0
45675214	1129625	0	0
45690658	1154029	0	0
45702790	1125315	0	0
46293004	1115008	0	0
46239158	1192710	0	0
45801377	1177480	0	0
46244572	1118084	0	0
46240020	1557272	0	0
46319154	19059056	2	3
45794081	40231925	2	3
4042503	4155034	3	3
21000244	1729720	0	0
4224259	4280726	2	2
21500120	1557272	7	7
21605129	967823	0	0
36152742	19125062	2	3
36211091	4134304	2	2
37503898	4108705	2	5
42805000	1124300	0	0
44342695	1738521	0	0
44359670	705944	0	0
44353519	40229134	2	3
45656339	1343916	0	0
44353881	1125315	0	0
45659288	1125315	0	0
45663018	1759842	0	0
45639452	1125315	0	0
45667208	708298	0	0
45701852	738818	0	0
45700524	1125315	0	0
45695843	1125315	0	0
45690325	1124300	0	0
45675193	1129625	0	0
45690664	791967	0	0
45702696	1125315	0	0
46292936	1174888	0	0
45894583	1521369	0	0
45801574	1177480	0	0
46244386	1332418	0	0
46240134	1738521	0	0
46319524	40163554	2	3
45794086	1594382	2	3
4042503	4278672	3	3
21000245	1738521	0	0
4288463	4186930	2	2
21502709	40229134	9	10
21604305	1112807	0	0
36153255	43012036	2	3
36211091	4230399	2	2
37202310	258780	2	5
42805069	1124300	0	0
44342731	1124957	0	0
44359812	975125	0	0
44353731	40163554	2	3
45656349	1551099	0	0
44353519	1125315	0	0
45659135	1125315	0	0
45663062	723013	0	0
45639505	1125315	0	0
45667194	1332418	0	0
45702113	1102527	0	0
45698943	1125315	0	0
45695784	1125315	0	0
45690329	1124957	0	0
45676429	1129625	0	0
45690762	1174888	0	0
45702558	1125315	0	0
46292946	1549786	0	0
45894583	1549786	0	0
45801431	1177480	0	0
46244500	1738521	0	0
46240118	1589505	0	0
46295416	19078461	2	3
45794092	19129655	2	3
4042503	4113008	3	3
21000245	1728416	0	0
4304916	192671	2	2
21002855	19076374	2	3
21603392	19029476	0	3
35708603	4112343	2	3
36211315	4296204	2	2
36703500	4066995	2	5
42805142	1125315	0	0
44342812	1107830	0	0
44359965	1589505	0	0
44353736	1115171	2	3
45656328	1149380	0	0
44353715	1125315	0	0
45659251	1125315	0	0
45663208	1713332	0	0
45639514	1125315	0	0
45667322	1115008	0	0
45702116	1107830	0	0
45698972	1125315	0	0
45697753	1125315	0	0
45690492	738818	0	0
45672365	1129625	0	0
45690766	1124300	0	0
45702941	1125315	0	0
46292946	1512674	0	0
45894586	1310149	0	0
45801557	1177480	0	0
46244407	1521369	0	0
46240119	738818	0	0
46301752	1332419	2	3
45793956	1115171	2	3
4169307	4240902	3	3
21000261	1738521	0	0
4287856	40492359	2	2
21002644	19008572	2	3
21604271	40165015	0	3
35509194	1127433	2	3
36208978	46235214	2	2
37202320	4280726	2	5
42805346	1738521	0	0
44342814	1107830	0	0
44359965	1549786	0	0
44346121	1115171	2	3
45656156	1545958	0	0
44353805	1125315	0	0
45659324	1125315	0	0
45663208	1759842	0	0
45639533	1125315	0	0
45667380	1548195	0	0
45702184	723013	0	0
45699017	1125315	0	0
45697537	1125315	0	0
45690497	1717327	0	0
45672616	1129625	0	0
45690757	967823	0	0
45702813	1125315	0	0
46293031	1115008	0	0
45894374	1124300	0	0
45801446	1177480	0	0
46244605	1192710	0	0
45896592	1192710	0	0
45894291	19073183	2	3
45794228	40236824	2	3
4169307	4219399	3	3
21000267	1738521	0	0
4287856	4275113	2	2
21002602	1713671	2	3
21602504	1519937	0	3
35509201	40163554	2	3
36208978	3011505	2	2
36718338	4132546	2	5
42805479	914335	0	0
44342753	1149380	0	0
44360145	975125	0	0
44346258	40229134	2	3
45656270	1115008	0	0
44353939	1125315	0	0
45659325	1125315	0	0
45663221	1149196	0	0
45639466	1125315	0	0
45667323	19059528	0	0
45702232	1332418	0	0
45698963	1125315	0	0
45697598	1125315	0	0
45690439	1551099	0	0
45786339	1129625	0	0
45690758	1110410	0	0
45702817	1125315	0	0
46292956	1548195	0	0
45894653	914335	0	0
45801712	1177480	0	0
46244606	933724	0	0
45896487	1115008	0	0
45797016	19073183	2	3
45794204	19057271	2	3
4169307	37017711	3	3
21000260	1778162	0	0
4287856	44805732	2	2
21002899	40173590	2	3
21604762	19123231	0	3
36156844	1115171	2	3
36208195	3000876	2	2
37503919	4163971	2	4
42805589	791967	0	0
44342720	708298	0	0
44360228	1112807	0	0
44346209	19133873	2	3
45656272	1589505	0	0
44346082	1125315	0	0
45659272	1125315	0	0
45659629	791967	0	0
45639506	1125315	0	0
45667332	1115008	0	0
45701838	1717327	0	0
45695465	1125315	0	0
45697764	1125315	0	0
45690444	1115008	0	0
45786569	1129625	0	0
45690828	1149196	0	0
45702818	1125315	0	0
46292956	1521369	0	0
45894438	1174888	0	0
45796169	1177480	0	0
46244610	1305058	0	0
45896497	738818	0	0
46302101	19075001	2	3
45788661	40232448	2	3
4169307	433644	3	3
21000282	1728416	0	0
21503268	975125	2	2
21002659	1551192	2	3
21604757	40236446	0	3
36157291	19059056	2	3
36208195	3021226	2	2
37202317	260139	2	4
42805654	701322	0	0
44342756	1322184	0	0
44360171	1154343	0	0
44346320	1115171	2	3
45656272	19127890	0	0
44346096	1125315	0	0
45656908	1125315	0	0
45659632	1115008	0	0
45639593	1125315	0	0
45667335	975125	0	0
45702187	1115008	0	0
45695474	1125315	0	0
45697547	1125315	0	0
45690446	1501700	0	0
45782288	1129625	0	0
45690729	1332418	0	0
45702801	1125315	0	0
46293181	1124957	0	0
45894621	1107830	0	0
45795979	1177480	0	0
46244458	1115008	0	0
45896527	1192710	0	0
46301863	1107882	2	3
45788666	19133905	2	3
4181187	4280726	3	3
21000261	1746114	0	0
21600191	914335	2	2
21002685	19007333	2	3
21601747	1332419	0	3
36157305	40222846	2	3
36208195	3001488	2	2
37002289	198199	2	4
42805515	1124300	0	0
44342837	1124957	0	0
44360174	738818	0	0
44346244	19008572	2	3
45656272	1549786	0	0
44345942	1125315	0	0
45656855	1125315	0	0
45659706	1149380	0	0
45639596	1125315	0	0
45667181	967823	0	0
45702032	975125	0	0
45695477	1125315	0	0
45697726	1125315	0	0
45690551	1367571	0	0
45702528	1129625	0	0
45690779	975125	0	0
45702784	1125315	0	0
46293190	1124300	0	0
45892894	45892894	0	0
45796347	1177480	0	0
46244459	1192710	0	0
45896582	1124300	0	0
45794197	40228214	2	3
45788667	1154615	2	3
4181187	4294548	3	3
21000268	1746114	0	0
21600191	40243436	2	2
21003018	1310034	2	3
21601860	1545959	0	3
36156990	40229134	2	3
36208195	3024731	2	2
36718338	381316	2	4
42805443	920293	0	0
44342845	1343916	0	0
44359919	738818	0	0
44346245	19008572	2	3
45656274	1174888	0	0
44346176	1125315	0	0
45657291	1125315	0	0
45659708	1000560	0	0
45639654	1125315	0	0
45667187	1308738	0	0
45702042	933724	0	0
45695556	1125315	0	0
45697704	1125315	0	0
45690555	1501700	0	0
45702748	1129625	0	0
45690709	1192710	0	0
45696498	1125315	0	0
46293211	975125	0	0
45892895	45892894	0	0
45790835	1177480	0	0
46244463	975125	0	0
45896668	1124300	0	0
46299967	40223768	2	3
45788699	19019273	2	3
4181187	40486433	3	3
21000265	1738521	0	0
21600280	1343916	2	2
21003025	42707627	2	3
21601856	1539411	0	3
36157031	40232448	2	3
36208195	3002385	2	2
37503924	4330583	1	6
42805446	1119510	0	0
44342758	19078219	0	0
44360176	1177480	0	0
44346424	19008572	2	3
45656405	738818	0	0
44346178	1125315	0	0
45657174	1125315	0	0
45659638	1539403	0	0
45639524	1125315	0	0
45667230	1551099	0	0
45702044	1174888	0	0
45695572	1125315	0	0
45697711	1125315	0	0
45690603	1115008	0	0
45702751	1129625	0	0
45690787	1110410	0	0
45696501	1125315	0	0
46293224	1545958	0	0
45893564	1332418	0	0
45790976	1177480	0	0
46240140	19127890	0	0
45896534	1551099	0	0
45791511	1107882	2	3
45788822	40229134	2	3
4134148	4186930	3	3
4170947	4170947	0	0
21600280	46275916	2	2
21003025	40243436	2	3
35202055	317576	2	3
36157171	1127433	2	3
36208195	3009542	2	2
37503919	4242997	1	3
42805451	1322184	0	0
44342760	1192710	0	0
44360185	1308738	0	0
44346634	1127433	2	3
45656037	1549786	0	0
44346190	1125315	0	0
45657489	1125315	0	0
45659698	1149196	0	0
45639567	1125315	0	0
45667342	1343916	0	0
45702070	975125	0	0
45695577	1125315	0	0
45697654	1125315	0	0
45690565	1310149	0	0
45702472	1129625	0	0
45690614	1545958	0	0
45696776	1125315	0	0
46293085	791967	0	0
45893609	1738521	0	0
45791858	1177480	0	0
46240140	1549786	0	0
45896573	1107830	0	0
46307156	1107882	2	3
45788869	40229134	2	3
4182161	372328	3	3
21000292	46233710	2	3
21500215	1332418	2	2
21003025	19078924	2	3
35402084	372328	2	3
36157188	40174880	2	3
36208195	3009201	2	2
37503958	4323902	1	3
42805421	1549786	0	0
44342858	1177480	0	0
44360187	1112807	0	0
44346268	40232448	2	3
45656311	1501700	0	0
44346195	1125315	0	0
45657260	1125315	0	0
45659656	1521369	0	0
45639585	1125315	0	0
45667466	1174888	0	0
45701956	1149196	0	0
45695678	1125315	0	0
45697601	1125315	0	0
45690502	1501700	0	0
45702742	1129625	0	0
45690616	1153428	0	0
45696705	1125315	0	0
46292752	1332418	0	0
45893562	1192710	0	0
45791972	1177480	0	0
46240140	1512674	0	0
45896553	19010482	0	0
46300331	1107882	2	3
45788818	40236446	2	3
4111522	4010253	3	3
21000244	19133905	2	3
21600269	1309944	2	2
21002627	19008572	2	3
21603448	40232448	2	3
36157466	19125062	2	3
36208195	3008598	2	2
37503893	4198190	1	4
42805327	1309944	0	0
44342785	1110410	0	0
44360187	1192710	0	0
44346386	19008572	2	3
45656214	1713332	0	0
44346153	1125315	0	0
45657491	1125315	0	0
45659658	1332418	0	0
45639677	1125315	0	0
45667237	1154029	0	0
45701958	1343916	0	0
45695761	1125315	0	0
45697603	1125315	0	0
45690504	1000560	0	0
45702573	1129625	0	0
45690621	975125	0	0
45696194	1125315	0	0
46293408	1000560	0	0
45893688	1738521	0	0
46295000	1177480	0	0
46240291	1557272	0	0
45896686	1192710	0	0
46318571	1107882	2	3
600000005	19115351	2	2
4096864	4266809	3	3
21000244	19075001	2	3
21600316	1361711	2	2
21002863	1115171	2	3
35507274	40223834	2	3
36157378	1127433	2	3
36208195	3014599	2	2
36718338	4066995	1	4
42805185	1149380	0	0
44342789	967823	0	0
44359925	1332418	0	0
44346388	1127433	2	3
45656037	1515774	0	0
44346329	1125315	0	0
45657386	1125315	0	0
45659541	1332418	0	0
45639644	1125315	0	0
45666356	791967	0	0
45702209	1115008	0	0
45695778	1125315	0	0
45697670	1125315	0	0
45690509	1107830	0	0
45702945	1129625	0	0
45690870	1000560	0	0
45696448	1125315	0	0
46293162	1000560	0	0
45893588	1149196	0	0
46244067	1177480	0	0
46240144	1557272	0	0
45896693	1110410	0	0
45799568	1107882	2	3
45876033	3013721	2	2
4096864	4310024	3	3
21000244	46233710	2	3
21500658	1308738	2	2
21002863	1127433	2	3
35204989	4329847	2	3
36157403	40232448	2	3
36208195	3007461	2	2
37503958	4337138	1	2
42805188	1713332	0	0
44342861	1738521	0	0
44359876	1129625	0	0
44338937	40162522	2	3
45652509	1110410	0	0
44346258	1125315	0	0
45657398	1125315	0	0
45659550	1332418	0	0
45639665	1125315	0	0
45666425	740275	0	0
45702129	738818	0	0
45694698	1125315	0	0
45695956	1125315	0	0
45690576	1000560	0	0
45702755	1129625	0	0
45690744	1500211	0	0
45765647	375671	3	3
46292752	1545958	0	0
45893695	1539403	0	0
46244086	1177480	0	0
46239763	1595799	0	0
45896413	1115008	0	0
46295319	1107882	2	3
45876033	3006923	2	2
4096864	196456	3	3
21000244	19073183	2	3
21500658	1125315	2	2
21002863	1127078	2	3
21603929	19007333	2	3
36152361	19008572	2	3
36208195	3012494	2	2
37203741	258780	1	2
42802479	1112807	0	0
44342875	1322184	0	0
44359876	1177480	0	0
44338996	19008572	2	3
45652384	1110410	0	0
44346204	1125315	0	0
45657407	1125315	0	0
45659736	1332418	0	0
45639623	1125315	0	0
45666426	920293	0	0
45702159	738818	0	0
45694701	1125315	0	0
45696023	1125315	0	0
45690596	1115008	0	0
45702758	1129625	0	0
45690805	1149196	0	0
45765647	378001	3	3
46292755	975125	0	0
45893616	967823	0	0
46244253	1177480	0	0
46239763	1521369	0	0
45896554	738818	0	0
45894748	19078461	2	3
45876033	3035995	2	2
4043176	4216130	3	3
21000290	1713671	2	3
21505743	1119510	2	2
21003153	1127433	2	3
35507349	1107882	2	3
36152363	19008572	2	3
36208195	3026361	2	2
36718586	4066995	1	2
42802493	1154343	0	0
44342876	1326303	0	0
44359883	933724	0	0
44339115	19008572	2	3
45652386	19127890	0	0
44346160	1125315	0	0
45657050	1125315	0	0
45659558	1539403	0	0
45639913	1125315	0	0
45666412	708298	0	0
45703560	1153428	0	0
45694383	1125315	0	0
45695934	1125315	0	0
45690421	1107830	0	0
45702765	1129625	0	0
45690879	1000560	0	0
45766714	133834	3	3
46293248	1124300	0	0
45801383	1115008	0	0
46244218	1177480	0	0
46239763	1549786	0	0
45896703	1154343	0	0
45896573	1107882	2	3
45876033	3007461	2	2
4029698	4163971	3	3
21000261	46233988	2	3
21505743	1174888	2	2
21003153	19019979	2	3
21604256	35605858	2	3
36157472	1115171	2	3
36208195	3001247	2	2
37503938	4275113	1	1
42802496	1545958	0	0
44342953	1307863	0	0
44359972	1124300	0	0
44339227	1127433	2	3
45652386	1549786	0	0
44346327	1125315	0	0
45657336	1125315	0	0
45659720	1326303	0	0
45639916	1125315	0	0
45666451	975125	0	0
45703562	1107830	0	0
45694709	1125315	0	0
45692762	1125315	0	0
45690515	1192710	0	0
45682541	1119510	0	0
45690817	1149196	0	0
45671738	19128263	3	4
46293228	1000560	0	0
45801501	1332418	0	0
46239183	1177480	0	0
46239764	708298	0	0
45896706	1717327	0	0
46317705	1107882	2	3
45876033	3004501	2	2
4040551	4202451	3	3
21000261	46233710	2	3
21500766	1308738	2	2
21003205	40229134	2	3
21603398	40162522	2	3
36157538	19059056	2	3
36208195	3006451	2	2
37503938	4238715	1	1
42802327	1713332	0	0
44342874	1192710	0	0
44359688	1738521	0	0
44339232	40231925	2	3
45652387	1309944	0	0
44346228	1125315	0	0
45657343	1125315	0	0
45659604	708298	0	0
45639804	1125315	0	0
45666452	1307863	0	0
45703805	967823	0	0
45694523	1125315	0	0
45693086	1125315	0	0
45690517	1124300	0	0
45682143	1119510	0	0
45690846	1154029	0	0
45687552	40221415	3	4
46292768	1192710	0	0
45801507	1746114	0	0
46239435	1177480	0	0
46239772	1192710	0	0
45896709	1307863	0	0
46300103	1107882	2	3
46240118	19127918	2	2
4180627	4035793	3	3
21000285	46233988	2	3
21500764	967823	2	2
21002683	1551192	2	3
21604260	40231925	2	3
36157754	1127433	2	3
36208195	3027231	2	2
37396227	4145310	1	1
42802327	1759842	0	0
44343079	1713332	0	0
44360083	1545958	0	0
44339236	1718412	2	3
45652708	920293	0	0
44346465	1125315	0	0
45655025	1125315	0	0
45659622	1107830	0	0
45636358	1125315	0	0
45666377	1149196	0	0
45703806	975125	0	0
45694711	1125315	0	0
45693087	1125315	0	0
45690544	920293	0	0
45680071	1119510	0	0
45690848	1154029	0	0
45702906	40221415	3	4
46293159	1115008	0	0
45801507	1741122	0	0
46239684	1177480	0	0
45787504	1112807	0	0
45896574	1174888	0	0
46312926	1107882	2	3
45788984	1539411	2	3
4156363	443279	3	3
21000265	46233988	2	3
21500216	1307863	2	2
21002846	19019273	2	3
21604344	40162522	2	3
36157735	1115171	2	3
36208195	3006734	2	2
37397180	439406	1	1
42802587	1310149	0	0
44342964	1192710	0	0
44360280	738818	0	0
44339427	40236824	2	3
45652625	1778162	0	0
44346486	1125315	0	0
45655376	1125315	0	0
45659553	1174888	0	0
45636361	1125315	0	0
45666380	738818	0	0
45699090	1332418	0	0
45692413	1125315	0	0
45693088	1125315	0	0
45691412	975125	0	0
45680011	1119510	0	0
45691064	1154343	0	0
45771096	440086	4	4
46292887	967823	0	0
45801508	920293	0	0
46239541	1177480	0	0
45787741	1112807	0	0
45896574	1192710	0	0
45797105	1107882	2	3
46307916	1539411	2	3
4172515	4197460	3	3
21000265	46233710	2	3
21500676	1396131	2	2
21002827	1115171	2	3
21604344	19133768	2	3
36157901	40232448	2	3
36208195	3015076	2	2
37397180	4048169	1	1
42802372	1125315	0	0
44342925	1112807	0	0
44360283	1129625	0	0
44339523	920334	2	3
45652739	1153428	0	0
44346634	1125315	0	0
45655479	1125315	0	0
45659681	1332418	0	0
45636300	1125315	0	0
45666382	1107830	0	0
45699022	1124957	0	0
45692427	1125315	0	0
45692794	1125315	0	0
45691435	1549786	0	0
45680077	1119510	0	0
45690999	1000560	0	0
46235681	3023103	2	2
46288140	723013	0	0
45801509	1551099	0	0
45895936	1177480	0	0
45801029	1112807	0	0
45896576	1174888	0	0
46300232	1107882	2	3
45799530	1539411	2	3
4029549	4301346	3	3
21000284	46233988	2	3
21500676	1595799	2	2
21002842	1551192	2	3
21603926	1305058	2	2
36157568	40228230	2	3
36208978	40766240	2	4
37003658	195588	1	1
42802567	1539403	0	0
44342930	1343916	0	0
44360297	1112807	0	0
44339097	19133905	2	3
45652741	1512674	0	0
44346267	1125315	0	0
45655458	1125315	0	0
45659557	1174888	0	0
45636313	1125315	0	0
45666386	1154029	0	0
45699124	975125	0	0
45692431	1125315	0	0
45692922	1125315	0	0
45691489	1192710	0	0
45677561	1119510	0	0
45691000	1361711	0	0
46235681	3016723	2	2
46287865	1153428	0	0
45801511	1322184	0	0
45895938	1177480	0	0
45801102	1112807	0	0
45896416	1343916	0	0
46318722	1332419	2	3
600000004	19074679	1	4
4030028	44783196	3	3
21000267	46233710	2	3
21500676	1308738	2	2
21002673	1551192	2	3
21603926	19007333	2	2
36157578	40229134	2	3
36208978	40758406	2	4
36903656	443279	2	2
42802543	1549786	0	0
44342939	1149380	0	0
44353103	975125	0	0
44360460	40236824	2	3
45652741	1549786	0	0
44346433	1125315	0	0
45655462	1125315	0	0
45659814	1107830	0	0
45636217	1125315	0	0
45666387	1107830	0	0
45699132	975125	0	0
45692729	1125315	0	0
45692930	1125315	0	0
45691491	1501700	0	0
45677878	1119510	0	0
45690885	1115008	0	0
45800486	19128009	2	2
46287866	1115008	0	0
45801400	1110410	0	0
45896077	1177480	0	0
45802589	1112807	0	0
45896418	1115008	0	0
45794428	40173590	2	3
46307291	42902245	1	2
4043023	4163872	3	3
21000245	46233988	2	3
21500803	1367571	2	2
21002682	19007333	2	3
35104341	4056621	2	2
36157621	1127433	2	3
36208978	40769189	2	4
36903604	378419	2	2
42802543	19127890	0	0
44342880	1192710	0	0
44353105	1118084	0	0
44360732	43012036	2	3
45652741	19127890	0	0
44346383	1125315	0	0
45655463	1125315	0	0
45659853	738818	0	0
45636460	1125315	0	0
45666413	1115008	0	0
45699051	1154029	0	0
45692975	1125315	0	0
45692938	1125315	0	0
45687249	975125	0	0
45677891	1119510	0	0
45690886	975125	0	0
45800486	19127918	2	2
46287999	1310149	0	0
45801754	1729720	0	0
45896146	1177480	0	0
45801418	1112807	0	0
45896419	1153428	0	0
46307150	19079524	2	3
46318515	19127904	1	2
4043023	4337138	3	3
21000245	46233710	2	3
21500803	1310149	2	2
21002682	1551192	2	3
21603445	1153428	2	2
36157939	19008572	2	3
36208978	40769194	2	4
36919120	378419	2	2
42802543	1515774	0	0
44342797	1308738	0	0
44353230	1738521	0	0
44360702	1551192	2	3
45652692	1332418	0	0
44338937	1125315	0	0
45655466	1125315	0	0
45659857	914335	0	0
45636436	1125315	0	0
45666414	975125	0	0
45699097	1115008	0	0
45692290	1192710	0	0
45692755	1125315	0	0
45687338	1713332	0	0
45678032	1119510	0	0
45690888	1000560	0	0
45885349	4146173	2	2
46288479	1738521	0	0
45801756	1307863	0	0
45895892	1177480	0	0
45795823	1112807	0	0
45896764	1000560	0	0
46307511	1332419	2	3
46321021	46275916	1	1
4043023	4163951	3	3
4181195	44783196	2	3
21600190	914335	2	2
21002663	1551192	2	3
21603445	1107830	2	2
36158076	40229134	2	3
36208978	40769179	2	4
40795922	3001488	2	2
42802554	914335	0	0
44342799	1154029	0	0
44352939	1738521	0	0
44360469	40232448	2	3
45652673	1307863	0	0
44338928	1125315	0	0
45655470	1125315	0	0
45659957	1174888	0	0
45636442	1125315	0	0
45666440	701322	0	0
45699214	1154029	0	0
45692297	1115008	0	0
45692765	1125315	0	0
45687338	1759842	0	0
45677835	1119510	0	0
45690889	1778162	0	0
45876166	3006322	2	2
46288494	1713332	0	0
45801459	1000560	0	0
45896133	1177480	0	0
45795855	1112807	0	0
45894627	933724	0	0
46319575	1332419	2	3
46321021	19079524	1	1
4040396	4186930	3	3
4134443	4149245	2	3
21503342	1125315	2	2
21002655	1551192	2	3
21603445	1149196	2	2
36158001	40222846	2	3
36208978	40769184	2	4
40795725	3000963	2	2
42802626	1000560	0	0
44342999	1310149	0	0
44353281	738818	0	0
44360790	40231925	2	3
45652454	1154029	0	0
44339138	1125315	0	0
45655423	1125315	0	0
45660079	1539403	0	0
45636445	1125315	0	0
45666455	1308738	0	0
45699216	920293	0	0
45692299	1174888	0	0
45692992	1125315	0	0
45687361	1308738	0	0
45677990	1119510	0	0
45691001	1149196	0	0
45803035	42902245	2	2
46288494	1759842	0	0
45801461	1501700	0	0
45896033	1177480	0	0
45790421	1112807	0	0
45894630	1332418	0	0
45794344	19075601	2	3
45796838	19127922	1	1
4043161	4199276	3	3
4041261	4238715	2	3
21500562	757627	2	2
21002894	46275444	2	3
21603445	1192710	2	2
36102149	257012	2	3
36208978	3006322	2	4
40795727	3009201	2	2
42802558	1154343	0	0
44343138	1124300	0	0
44353307	1115008	0	0
44360875	40232448	2	3
45652594	1713332	0	0
44338997	1125315	0	0
45653856	1125315	0	0
45659769	1174888	0	0
45636437	1125315	0	0
45666471	1107830	0	0
45699067	1717327	0	0
45692314	1343916	0	0
45693000	1125315	0	0
45687469	1501700	0	0
45679563	1119510	0	0
45690930	1367571	0	0
45795011	19128009	2	2
46288502	1124300	0	0
45801462	1174888	0	0
45896072	1177480	0	0
45790793	1112807	0	0
45894525	757627	0	0
45794752	40228214	2	3
45796838	19129144	1	1
4042150	4218408	3	3
4170143	4112343	2	4
21500562	715997	2	2
21002025	19073183	2	3
21603445	1129625	2	2
36156759	40236446	2	3
36208978	21494966	2	4
40795730	3013682	2	2
42802591	1551099	0	0
44343289	1192710	0	0
44353284	1149196	0	0
44360658	19008572	2	3
45652594	1759842	0	0
44339012	1125315	0	0
45653955	1125315	0	0
45659772	1307863	0	0
45636395	1125315	0	0
45666528	715997	0	0
45699143	975125	0	0
45692341	933724	0	0
45693073	1125315	0	0
45687275	1738521	0	0
45679568	1119510	0	0
45687314	1309944	0	0
45785737	19128009	2	2
46288013	1112807	0	0
45801364	1115008	0	0
45896101	1177480	0	0
45790503	1112807	0	0
45894719	723013	0	0
45802251	40174880	2	3
45796838	19133679	1	1
4042150	4202451	3	3
4170143	4294548	2	4
21600885	967823	2	2
21002025	19073188	2	3
21603445	1150770	2	2
36152735	42707627	2	3
36517140	81151	2	5
40652452	3006322	2	2
42802464	914335	0	0
44343305	975125	0	0
44353309	1174888	0	0
44361014	1127433	2	3
45652581	1174888	0	0
44339227	1125315	0	0
45653921	1125315	0	0
45659774	1361711	0	0
45636153	1125315	0	0
45663828	967823	0	0
45699146	1361711	0	0
45692346	1332418	0	0
45693033	1125315	0	0
45687394	723013	0	0
45679569	1119510	0	0
45687700	1308738	0	0
46240118	19128009	2	2
46287970	1153428	0	0
45801573	1149196	0	0
45896185	1177480	0	0
45790868	1112807	0	0
45894170	1738521	0	0
45895663	19075601	2	3
46315219	42902245	2	2
4040400	4295880	3	3
4171379	195588	2	5
21600248	1309944	2	2
21002642	1551192	2	3
35104366	4056621	2	2
35507109	40236446	2	3
36208195	3004501	2	5
37320143	133834	2	2
42802423	1177480	0	0
44343092	1177480	0	0
44353316	933724	0	0
44360629	40232448	2	3
45652583	1124300	0	0
44339232	1125315	0	0
45654100	1125315	0	0
45659777	1549786	0	0
45636340	1125315	0	0
45664454	975125	0	0
45699148	1174888	0	0
45691936	1149196	0	0
45693189	1125315	0	0
45687471	1729720	0	0
45674689	1119510	0	0
45687348	975125	0	0
45895008	19128009	2	2
46288169	1738521	0	0
45801472	1545958	0	0
45896702	1177480	0	0
45790814	1112807	0	0
45894248	1729720	0	0
46298976	19079524	1	1
44361178	40231925	2	3
4040400	4238715	3	3
4029565	4198190	2	2
21600279	1343916	2	2
21002642	19008572	2	3
21605042	1149380	2	2
36213601	19128263	2	3
36208195	3013682	2	5
36903593	440086	2	2
44359268	1738521	0	0
44343094	1738521	0	0
44353319	1192710	0	0
44361059	40169216	2	3
45652646	1595799	0	0
44339168	1125315	0	0
45654165	1125315	0	0
45659777	19127890	0	0
45636326	1125315	0	0
45664518	920293	0	0
45699151	1310149	0	0
45692062	1332418	0	0
45693192	1125315	0	0
45687472	1192710	0	0
45674631	1119510	0	0
45687350	791967	0	0
45895008	19127918	2	2
46288518	1112807	0	0
45801473	1174888	0	0
45896827	1177480	0	0
45790568	1112807	0	0
45894171	1729720	0	0
46307852	19079524	1	1
44361216	40162522	2	3
4040400	4337138	3	3
4134443	4035415	2	2
21503332	975125	2	2
21002630	19008572	2	3
21603891	19010482	2	2
36213601	19128022	2	3
36208195	3020630	2	5
37522193	4293740	2	2
44359322	1129625	0	0
44343098	738818	0	0
44353322	791967	0	0
44360632	40232448	2	3
45652647	1124957	0	0
44339121	1125315	0	0
45647365	1125315	0	0
45659777	1521369	0	0
45636529	1125315	0	0
45664533	975125	0	0
45699077	1539403	0	0
45692143	967823	0	0
45693104	1125315	0	0
45687478	975125	0	0
45674957	1119510	0	0
45687429	914335	0	0
45802937	42902245	2	2
46288531	1501700	0	0
45801478	740275	0	0
45896664	1177480	0	0
45790686	1112807	0	0
45894184	920293	0	0
46302627	19079524	1	1
45650533	40232448	2	3
4040400	40492359	5	5
4134439	4001336	2	2
21503409	1396131	2	2
21002630	1551192	2	3
21603891	1305058	2	2
36156981	1551192	2	3
36208195	3024561	2	5
40795740	3004501	2	2
44359323	1112807	0	0
44343203	1192710	0	0
44353141	1177480	0	0
44338212	19073183	2	3
45652648	1713332	0	0
44339345	1125315	0	0
45647481	1125315	0	0
45660019	1305058	0	0
45636469	1125315	0	0
45664603	975125	0	0
45699274	1110410	0	0
45692159	1332418	0	0
45692859	1125315	0	0
45687480	1713332	0	0
45674659	1119510	0	0
45687773	1310149	0	0
45787205	19128263	2	2
46288056	1112807	0	0
45801371	1000560	0	0
45896744	1177480	0	0
46297571	1112807	0	0
45894228	1153428	0	0
46313268	46275916	1	1
45650556	40174880	2	3
4043022	4242997	5	5
4134439	4066995	2	2
21500770	1308738	2	2
21002630	40228214	2	3
21604077	42707627	2	2
36157365	1551192	2	3
36208195	3016723	2	5
40775801	3016723	2	2
44359325	1124300	0	0
44343211	1118084	0	0
44353064	975125	0	0
44359791	43012036	2	3
45655047	1115008	0	0
44339125	1125315	0	0
45647482	1125315	0	0
45660044	1115008	0	0
45636614	1125315	0	0
45664618	975125	0	0
45699244	1778162	0	0
45692379	1149196	0	0
45692862	1125315	0	0
45687406	1396131	0	0
45674784	1119510	0	0
45687824	1174888	0	0
45696797	19057271	2	3
46288057	975125	0	0
45801453	1713332	0	0
45804330	1177480	0	0
46297954	1112807	0	0
45894188	1551099	0	0
46313268	19079524	1	1
46319484	1125315	0	0
4043022	4337611	5	5
4136573	4134304	2	2
21500752	967823	2	2
21002630	40228230	2	3
21604077	19003953	2	2
36157685	1545959	2	3
36208195	3035995	2	5
37320127	4296204	2	2
44359329	1192710	0	0
44343287	1112807	0	0
44353065	1115008	0	0
44345969	42707627	2	3
45655059	1115008	0	0
44339023	1125315	0	0
45647393	1125315	0	0
45659895	1124300	0	0
45636615	1125315	0	0
45664733	1000560	0	0
45699413	1521369	0	0
45694654	1149196	0	0
45693058	1125315	0	0
45687410	1738521	0	0
45674842	1119510	0	0
45687999	1149196	0	0
45696730	19008572	2	3
46288171	1112807	0	0
45801589	1551099	0	0
45797301	1177480	0	0
46297756	1112807	0	0
45894191	1717327	0	0
46321640	19079524	1	1
46319580	1125315	0	0
4040396	4163971	5	5
4135090	4134304	2	2
21600884	967823	2	2
21500093	19007333	6	7
21605009	1149380	2	2
4130852	4059173	2	3
36208195	3027970	2	5
37522151	4197460	2	2
44359330	1192710	0	0
44343288	708298	0	0
44353067	791967	0	0
44359670	40236446	2	3
45655170	738818	0	0
44339025	1125315	0	0
45647398	1125315	0	0
45659901	1501700	0	0
45636409	1125315	0	0
45664670	1115008	0	0
45699413	1549786	0	0
45694622	1192710	0	0
45693067	1125315	0	0
45687329	1192710	0	0
45674975	1119510	0	0
45688002	1124957	0	0
45696374	1115171	2	3
46288178	1326303	0	0
45801453	1759842	0	0
45796703	1177480	0	0
46297422	1112807	0	0
45894196	1115008	0	0
46303642	19079524	1	1
46319581	1125315	0	0
4093991	317576	5	5
4135097	4134304	2	2
21601078	1396131	2	2
21500936	19008572	6	7
21604254	1154029	2	2
4130852	4109685	2	3
36208195	3006906	2	5
37303797	4102123	2	2
44359332	1713332	0	0
44343173	738818	0	0
44353244	738818	0	0
44355568	19078461	2	3
45655171	1309944	0	0
44339580	1125315	0	0
45647399	1125315	0	0
45660048	1115008	0	0
45636943	1125315	0	0
45663979	1549786	0	0
45699413	19127890	0	0
45694689	1124957	0	0
45690014	1125315	0	0
45687523	1107830	0	0
45674879	1119510	0	0
45688006	1153428	0	0
45696823	40232448	2	3
46288548	791967	0	0
45801611	1521369	0	0
45796547	1177480	0	0
46297966	1112807	0	0
45894262	715997	0	0
46307301	46275916	1	1
46319445	1125315	0	0
4180627	4170947	5	5
4138286	4149245	2	2
21601078	1595799	2	2
21602681	40174880	6	7
21603395	1119510	2	2
35406420	372328	1	1
36208195	3013721	2	5
37521809	4337138	2	2
44359338	1112807	0	0
44343238	1177480	0	0
44353142	975125	0	0
44353682	19019273	2	3
45655352	1332418	0	0
44339588	1125315	0	0
45647459	1125315	0	0
45660081	1310149	0	0
45637054	1125315	0	0
45663979	1519936	0	0
45699416	1174888	0	0
45689038	1501700	0	0
45689840	1125315	0	0
45687562	738818	0	0
45674887	1119510	0	0
45687888	1713332	0	0
45696848	920300	2	3
46288600	1713332	0	0
45801611	1595799	0	0
45791201	1177480	0	0
46289024	1112807	0	0
45894267	1115008	0	0
46307301	19079524	1	1
46319159	1125315	0	0
4043023	4057420	5	5
4101212	30753	2	2
21600192	40243436	2	3
21604795	40223768	0	3
21601421	1305058	2	2
35402603	372328	1	1
36208195	3006923	2	5
37522270	4323208	2	2
44359019	1551099	0	0
44343073	1322184	0	0
44353072	1112807	0	0
44346248	19019273	2	3
45655327	1310149	0	0
45619683	1125315	0	0
45647412	1125315	0	0
45659799	1174888	0	0
45633183	1125315	0	0
45663952	1124300	0	0
45699510	1149196	0	0
45689142	1118084	0	0
45689786	1125315	0	0
45687676	1115008	0	0
45674891	1119510	0	0
45687888	1759842	0	0
45696666	40163554	2	3
46288607	1549786	0	0
45801611	1549786	0	0
45791142	1177480	0	0
46289157	1112807	0	0
45894268	1500211	0	0
46308433	19079524	1	1
46319385	1125315	0	0
4043023	4078793	5	5
4048512	78272	2	2
21505737	19059056	2	3
21602842	19133873	0	3
21601854	1539403	2	2
35104366	4280726	1	1
36211303	4142905	2	7
40652424	3049273	2	2
44359234	1107830	0	0
44343216	738818	0	0
44353073	1149380	0	0
44353588	19019273	2	3
45655301	1118084	0	0
44360451	1125315	0	0
45647552	1125315	0	0
45660052	1107830	0	0
45633188	1125315	0	0
45663959	975125	0	0
45699361	1539403	0	0
45689150	1310149	0	0
45689790	1125315	0	0
45687280	1192710	0	0
45674772	1119510	0	0
45687834	1501700	0	0
45696834	19019273	2	3
46288301	1112807	0	0
45801612	1154343	0	0
45791259	1177480	0	0
46289060	1112807	0	0
45894278	1551099	0	0
46319612	19079524	1	1
46319390	1125315	0	0
4180169	133834	5	5
4042641	4218408	2	2
21505756	19019273	2	3
21602886	19074843	0	3
35402602	372328	2	2
35104341	4280726	1	1
36208195	3000963	2	6
40652448	3049273	2	2
44359196	1729720	0	0
44343012	723013	0	0
44353258	738818	0	0
44348279	19019273	2	3
45655315	1332418	0	0
44360453	1125315	0	0
45647585	1125315	0	0
45660053	1310149	0	0
45633203	1125315	0	0
45663945	1124957	0	0
45699381	1326303	0	0
45689152	1000560	0	0
45689898	1125315	0	0
45687379	1713332	0	0
45675084	1119510	0	0
45687492	975125	0	0
45802696	40232448	2	3
46287974	1322184	0	0
45801554	1309944	0	0
45791154	1177480	0	0
46289210	1112807	0	0
45894395	1192710	0	0
46304864	19079524	1	1
46239815	1125315	0	0
4180170	4048171	5	5
4042641	4163951	2	2
21003656	46233710	2	3
21604566	19076374	0	3
21603671	1343916	2	2
21601767	40171902	1	1
36208195	3045716	2	6
40652431	3024561	2	2
44359173	1549786	0	0
44343015	1759842	0	0
44353265	1500211	0	0
44346646	19019273	2	3
45655181	1307863	0	0
44360509	1125315	0	0
45647806	1125315	0	0
45656656	1000560	0	0
45633487	1125315	0	0
45663984	1322184	0	0
45699524	1115008	0	0
45689307	914335	0	0
45689824	1125315	0	0
45687534	738818	0	0
45674729	1119510	0	0
45687505	1738521	0	0
45802861	40229134	2	3
46288200	1322184	0	0
45801567	1115008	0	0
45791529	1177480	0	0
46289375	1112807	0	0
45894285	1332418	0	0
46309292	19079524	1	1
46239885	1125315	0	0
4180170	258780	5	5
4030292	4116491	2	2
21004496	19129655	2	3
21600989	19075601	0	3
21602099	975125	2	2
35202472	4329847	1	2
36208195	3014576	2	6
40652431	3016723	2	2
44359173	1515774	0	0
44343015	1713332	0	0
44353267	715997	0	0
44338725	19019273	2	3
45655304	1154343	0	0
44360741	1125315	0	0
45647501	1125315	0	0
45656923	738818	0	0
45633646	1125315	0	0
45663985	1110410	0	0
45695868	1110410	0	0
45689299	1115008	0	0
45690123	1125315	0	0
45687536	1738521	0	0
45671750	1119510	0	0
45687663	975125	0	0
45803046	19008572	2	3
46288060	1124300	0	0
45801440	1149196	0	0
46299140	1177480	0	0
46289975	1112807	0	0
45894235	791967	0	0
46316590	19079524	1	1
46239998	1125315	0	0
4134149	4330583	5	5
4030031	4057420	2	2
21004497	19129655	2	3
21604799	40222846	0	3
21605125	967823	2	2
35202471	317576	1	2
36208195	3019550	2	6
40652431	3013682	2	2
44359200	1551099	0	0
44343020	738818	0	0
44353345	975125	0	0
44360630	19019273	2	3
45655332	1115008	0	0
44360896	1125315	0	0
45647811	1125315	0	0
45657176	1326303	0	0
45633396	1125315	0	0
45664017	705944	0	0
45695901	740275	0	0
45689233	1000560	0	0
45689812	1125315	0	0
45686065	1125315	0	0
45671789	1119510	0	0
45687672	1124957	0	0
45802977	19007333	2	3
46288185	1521369	0	0
45801442	920293	0	0
46298940	1177480	0	0
46241617	1112807	0	0
45894291	1713332	0	0
46304638	19079524	1	1
46239837	1125315	0	0
4130852	40479422	5	5
4181251	78272	2	2
21600303	46275916	2	3
21604417	19074679	0	3
21605058	914335	2	2
35200000	4051466	6	6
36208195	3023103	2	6
40652431	3008598	2	2
44359293	1501700	0	0
44342909	1738521	0	0
44353269	975125	0	0
44355443	19078461	2	3
45655183	1149196	0	0
44360673	1125315	0	0
45647766	1125315	0	0
45656724	19127890	0	0
45633398	1125315	0	0
45664023	1310149	0	0
45695812	1124957	0	0
45689162	738818	0	0
45689954	1125315	0	0
45685933	1125315	0	0
45671857	1119510	0	0
45687928	1332418	0	0
45803131	40174880	2	3
46288185	1549786	0	0
45801446	1174888	0	0
46299349	1177480	0	0
46241847	1112807	0	0
45894355	1115008	0	0
46307013	19079524	1	1
46239838	1125315	0	0
4181192	4107731	4	5
4181583	40481087	2	2
21004494	19129655	2	3
21604797	19077572	0	3
21601422	1305058	2	2
35200000	381316	6	6
36208195	3015632	2	6
40652431	3004501	2	2
44359294	1129625	0	0
44342911	1551099	0	0
44353271	1129625	0	0
44359784	19019273	2	3
45655281	1595799	0	0
44360682	1125315	0	0
45647945	1125315	0	0
45656724	1521369	0	0
45633332	1125315	0	0
45664028	1124957	0	0
45695743	1741122	0	0
45689171	1124957	0	0
45689958	1125315	0	0
45688478	1125315	0	0
45671999	1119510	0	0
45687929	1551099	0	0
45800140	40231925	2	3
46288335	1174888	0	0
45801520	967823	0	0
46292007	1177480	0	0
46241886	1112807	0	0
45894396	1118084	0	0
46307197	19079524	1	1
46239851	1125315	0	0
4180170	4112343	4	5
4138262	4107731	2	2
21004495	19129655	2	3
21604571	19057271	0	3
21605126	967823	2	2
35200000	4163874	6	6
35707763	4027663	2	5
40652431	3006906	2	2
44359011	738818	0	0
44342914	1551099	0	0
44353163	738818	0	0
44360717	40223834	2	3
45655281	1521369	0	0
44360845	1125315	0	0
45647739	1125315	0	0
45656724	1549786	0	0
45633342	1125315	0	0
45664085	1332418	0	0
45695743	1746114	0	0
45689237	1174888	0	0
45690030	1125315	0	0
45682728	1125315	0	0
45672135	1119510	0	0
45687948	1759842	0	0
45800027	40236446	2	3
46288348	1149196	0	0
45801651	1557272	0	0
46290582	1177480	0	0
46241821	1112807	0	0
45894365	1192710	0	0
46314824	19079524	1	1
46239860	1125315	0	0
4190185	4112343	4	5
4119403	4323902	2	2
21004491	19129655	2	3
21600965	40163554	0	3
21603923	19010482	2	2
35202051	441267	6	6
35707763	4166224	2	8
40652431	3000963	2	2
44359000	975125	0	0
44343164	1177480	0	0
44353167	975125	0	0
44339041	19123231	2	3
45655281	1549786	0	0
44360642	1125315	0	0
45648014	1125315	0	0
45656673	1548195	0	0
45633623	1125315	0	0
45664165	975125	0	0
45695745	1174888	0	0
45688968	1149196	0	0
45690140	1125315	0	0
45682847	1125315	0	0
45672030	1119510	0	0
45687948	1713332	0	0
45800036	40163554	2	3
46288360	1192710	0	0
45801652	1343916	0	0
46290662	1177480	0	0
46241830	1112807	0	0
45894361	1000560	0	0
46314532	19079524	1	1
46239861	1125315	0	0
4043346	4329847	4	5
4084434	4149245	2	2
21009232	46233710	2	3
21602660	40236824	0	3
21605059	914335	2	2
35202051	4310024	6	6
35707763	4310024	1	6
40652431	3023103	2	2
44359304	738818	0	0
44343405	1738521	0	0
44353171	1112807	0	0
44346154	40163554	2	3
45652769	791967	0	0
44360790	1125315	0	0
45647828	1125315	0	0
45656864	1545958	0	0
45633637	1125315	0	0
45664030	1124300	0	0
45695747	1728416	0	0
45689253	1124957	0	0
45690117	1125315	0	0
45682854	1125315	0	0
45672036	1119510	0	0
45687959	1192710	0	0
45800123	19078924	2	3
46288366	1124300	0	0
45801657	19127890	0	0
46290880	1177480	0	0
45895928	1112807	0	0
45894419	1149196	0	0
46301157	19079524	1	1
46239944	1125315	0	0
4162054	4108705	4	5
4086016	4230209	2	2
21004631	19129655	2	3
21604794	836659	0	3
21604304	1112807	2	2
21602359	19127918	6	6
35707763	4266809	1	6
40652431	3028833	2	2
44359306	738818	0	0
44343051	1177480	0	0
44353377	1129625	0	0
44339293	1545959	2	3
45652776	705944	0	0
44360849	1125315	0	0
45647835	1125315	0	0
45656695	738818	0	0
45633438	1125315	0	0
45664037	1367571	0	0
45695584	1000560	0	0
45689397	1501700	0	0
45690042	1125315	0	0
45682858	1125315	0	0
45672083	1119510	0	0
45687795	1000560	0	0
45800373	19019273	2	3
46288438	1548195	0	0
45801657	1549786	0	0
46290772	1177480	0	0
45803832	1112807	0	0
45894424	1192710	0	0
46312891	19079524	1	1
46321843	1125315	0	0
4101796	378419	4	5
4086016	4234705	2	2
21004632	19129655	2	3
21502567	914335	0	0
21604269	1154029	2	2
21602359	42902245	6	6
35707763	192671	1	4
40652431	3020630	2	2
44359314	1539403	0	0
44342915	1551099	0	0
44353292	1129625	0	0
44338953	1713671	2	3
45652824	1124957	0	0
44360606	1125315	0	0
45647932	1125315	0	0
45656839	1309944	0	0
45633650	1125315	0	0
45663995	1174888	0	0
45695593	1309944	0	0
45689073	1124957	0	0
45690055	1125315	0	0
45682866	1125315	0	0
45783997	1119510	0	0
45687865	791967	0	0
45800381	19133873	2	3
46288447	1548195	0	0
45801658	1154343	0	0
46242523	1177480	0	0
45798936	1112807	0	0
45894511	738818	0	0
46302263	19079524	1	1
46321960	1125315	0	0
4172024	4139681	4	5
4049972	441267	2	2
21004854	19129655	2	3
21502572	1589505	0	0
21604269	1102527	2	2
21602359	19133679	6	6
36211260	81151	1	3
40652433	3006906	2	2
44359352	1177480	0	0
44343061	1115008	0	0
44353293	19127890	0	0
44348284	19019273	2	3
45652852	1000560	0	0
44360987	1125315	0	0
45647934	1125315	0	0
45656681	1149196	0	0
45633548	1125315	0	0
45663998	1549786	0	0
45695757	1717327	0	0
45689470	1332418	0	0
45690178	1125315	0	0
45683022	1125315	0	0
45784113	1119510	0	0
45687908	914335	0	0
45800232	19019273	2	3
45897778	19073183	2	3
45801710	715997	0	0
46242359	1177480	0	0
45798710	1112807	0	0
45894303	1000560	0	0
46302263	46275916	1	1
46321962	1125315	0	0
4042503	4134304	4	5
4051932	4078793	2	2
21002574	19129655	2	3
21502572	1549786	0	0
21604255	1110410	2	2
21602359	19129144	6	6
36207527	40766240	1	3
40652433	3014576	2	2
44351888	1129625	0	0
44343062	1310149	0	0
44353293	1521369	0	0
44353307	19019273	2	3
45652929	738818	0	0
44360885	1125315	0	0
45644496	1125315	0	0
45656899	1174888	0	0
45633687	1125315	0	0
45663998	1521369	0	0
45695846	1501700	0	0
45689367	1124957	0	0
45689967	1125315	0	0
45683084	1125315	0	0
45784069	1119510	0	0
45687915	967823	0	0
45800235	40229134	2	3
45787779	1107882	2	3
45801679	1549786	0	0
46239452	1177480	0	0
45799017	1112807	0	0
45894519	757627	0	0
46303493	19079524	1	1
46322225	1125315	0	0
4043176	4336464	4	5
4050572	40492359	2	2
21001936	19129655	2	3
21502572	1595799	0	0
21601855	1539403	2	2
21602359	19128009	6	6
36207527	40769179	1	3
40652433	3035995	2	2
44352323	920293	0	0
44339271	1759842	0	0
44353293	1549786	0	0
44360570	19019273	2	3
45652856	1000560	0	0
44361077	1125315	0	0
45644533	1125315	0	0
45656933	1713332	0	0
45633697	1125315	0	0
45664112	791967	0	0
45695873	1124300	0	0
45689373	1549786	0	0
45690181	1125315	0	0
45682942	1125315	0	0
45784188	1119510	0	0
45687741	1192710	0	0
45800309	19008572	2	3
46241489	1107882	2	3
45801679	19127890	0	0
45896232	1177480	0	0
45793779	1112807	0	0
45894400	1000560	0	0
46300083	19079524	1	1
46321749	1125315	0	0
4182161	40481087	4	5
4051796	4330583	2	2
21503065	46275916	2	3
21502572	19127890	0	0
21601855	1545958	2	2
21602359	19128263	6	6
36207527	40769194	1	3
40652433	3045716	2	2
44352326	967823	0	0
44339276	1153428	0	0
44355558	1149196	0	0
44353230	46233710	2	3
45652863	740275	0	0
44360854	1125315	0	0
45644670	1125315	0	0
45656752	1154343	0	0
45633413	1125315	0	0
45664116	1768849	0	0
45697539	1124300	0	0
45689344	723013	0	0
45690237	1125315	0	0
45683008	1125315	0	0
45784238	1119510	0	0
45687744	1124957	0	0
45802307	40236446	2	3
45803462	1107882	2	3
45801528	1738521	0	0
45896201	1177480	0	0
45793658	1112807	0	0
45802371	1539403	0	0
45876002	3028833	1	1
46321750	1125315	0	0
4042140	80180	4	5
4045900	4170947	2	2
21003586	40243436	2	3
21502572	1521369	0	0
21604343	1125315	2	2
21602359	19127922	6	6
36207527	3006322	1	3
40652433	3006923	2	2
44352327	1124300	0	0
44339410	705944	0	0
44355423	1149380	0	0
44341385	1332419	2	3
45653032	1174888	0	0
44361014	1125315	0	0
45644687	1125315	0	0
45656753	1501700	0	0
45630373	1125315	0	0
45664172	1343916	0	0
45697704	738818	0	0
45689536	1153428	0	0
45690244	1125315	0	0
45683103	1125315	0	0
45784095	1119510	0	0
45687962	1713332	0	0
45797369	19019273	2	3
46241496	1107882	2	3
45801679	1512674	0	0
45893968	1177480	0	0
45793544	1112807	0	0
45802374	723013	0	0
45876002	3016723	1	1
46321761	1125315	0	0
4180169	198809	4	5
4193783	4314290	2	2
21505859	40236446	2	3
21502573	1500211	0	0
21603396	1119510	2	2
21602359	19128022	6	6
36207527	21494966	1	3
40652433	3015632	2	2
44352051	1112807	0	0
44339412	1192710	0	0
44355677	975125	0	0
44339417	1107882	2	3
45652895	1174888	0	0
44360828	1125315	0	0
45644700	1125315	0	0
45656757	1310149	0	0
45630496	1125315	0	0
45664045	1107830	0	0
45697713	1115008	0	0
45689485	1154343	0	0
45690361	1125315	0	0
45682752	1125315	0	0
45784289	1119510	0	0
45688627	1539403	0	0
45797461	19073188	2	3
45798067	19075001	2	3
45801669	1107830	0	0
45894068	1177480	0	0
45788470	1112807	0	0
45802375	1192710	0	0
45876002	3045716	1	1
46322189	1125315	0	0
4134598	4323902	4	5
4194763	4037675	2	2
21004571	40243436	2	3
21502574	1589505	0	0
21603931	19019273	6	7
21602796	19075001	5	6
36207527	40769189	1	3
40652433	3004501	2	2
44352057	1551099	0	0
44339416	1521369	0	0
44355687	1177480	0	0
44353503	1107882	2	3
45649595	1124957	0	0
44361039	1125315	0	0
45644560	1125315	0	0
45656762	1107830	0	0
45630509	1125315	0	0
45664181	1192710	0	0
45697654	738818	0	0
45689489	19010482	0	0
45690194	1125315	0	0
45682756	1125315	0	0
45781878	1119510	0	0
45688594	1115008	0	0
45797477	19075001	2	3
45895250	1107882	2	3
45801673	967823	0	0
45893946	1177480	0	0
45788316	1112807	0	0
45802376	1115008	0	0
46317796	1149196	0	0
46321925	1125315	0	0
4042140	4296204	5	8
4182007	80809	2	2
21002822	1115171	2	3
21502574	975125	0	0
21603931	42707627	6	7
21602796	1713671	5	6
36207527	40758406	1	3
40652433	3013721	2	2
44352196	1309944	0	0
44339416	1548195	0	0
44355556	1112807	0	0
44359771	1107882	2	3
45649529	1539403	0	0
43534659	1361711	1	1
45644561	1125315	0	0
45656846	1545958	0	0
45630017	1125315	0	0
45664155	1154029	0	0
45697322	1309944	0	0
45689542	723013	0	0
45690263	1125315	0	0
45683162	1125315	0	0
45781967	1119510	0	0
45688394	975125	0	0
45797531	1115171	2	3
45801157	1107882	2	3
45801674	1501700	0	0
45893841	1177480	0	0
45788480	1112807	0	0
45802130	1118084	0	0
46313399	701322	0	0
46321928	1125315	0	0
4042140	4001336	5	9
4042518	4010253	2	2
21503375	19008572	2	3
21502575	975125	0	0
21603931	40173590	6	7
21603444	40232448	5	6
36207527	40769184	1	3
40652433	3013682	2	2
44352199	1174888	0	0
44339505	1174888	0	0
44355715	1112807	0	0
44338659	1107882	2	3
45649534	1501700	0	0
45620188	19079524	1	1
45644576	1125315	0	0
45656933	1759842	0	0
45630447	1125315	0	0
45664187	1149196	0	0
45697659	1717327	0	0
45689546	1110410	0	0
45690272	1125315	0	0
45683336	1125315	0	0
45782078	1119510	0	0
45688482	1326303	0	0
45797544	40229134	2	3
45790241	19079524	2	3
45801675	1149196	0	0
45893953	1177480	0	0
45788448	1112807	0	0
45802448	1361711	0	0
46313320	1738521	0	0
46321930	1125315	0	0
4042140	4142905	5	9
4185207	4218389	2	2
21013458	40236446	2	3
21502575	1519936	0	0
21603931	19078461	6	7
35200000	321042	3	6
36217373	19129655	1	2
40652433	3019550	2	2
44352207	1738521	0	0
44339512	738818	0	0
44355421	975125	0	0
44360265	1107882	2	3
45649684	740275	0	0
45620254	46275916	1	1
45645870	1125315	0	0
45656945	914335	0	0
45630514	1125315	0	0
45664361	1539403	0	0
45697821	1153428	0	0
45689609	1308738	0	0
45690203	1125315	0	0
45683093	1125315	0	0
45781915	1119510	0	0
45688490	933724	0	0
45797547	1115171	2	3
45790262	1107882	2	3
45801676	1174888	0	0
45894123	1177480	0	0
45788607	1112807	0	0
45799653	1153428	0	0
46313365	1501700	0	0
46322157	1125315	0	0
4042140	4027663	5	7
4095850	4066995	2	2
21500561	40236446	2	3
21500286	1129625	0	0
21602359	43012433	6	7
21603444	19112599	3	6
36212546	19076374	1	2
40652433	3028833	2	2
44352336	1343916	0	0
44339476	1177480	0	0
44355232	1551099	0	0
44360842	19078461	2	3
45649626	708298	0	0
45620254	19079524	1	1
45646102	1125315	0	0
45656948	1149196	0	0
45630152	1125315	0	0
45664065	1759842	0	0
45697830	1115008	0	0
45689568	1115008	0	0
45690157	1125315	0	0
45682953	1125315	0	0
45782047	1119510	0	0
45688504	975125	0	0
45797550	19018935	2	3
46238604	1107882	2	3
45801699	1326303	0	0
45894149	1177480	0	0
45788410	1112807	0	0
45799865	1000560	0	0
46313441	1332418	0	0
46322486	1125315	0	0
4042140	78272	5	11
4095850	4048695	2	2
21001710	46275916	2	3
21500299	1343916	0	0
21602359	40224805	6	7
21603444	1150771	3	6
36211065	4142905	1	2
40652433	3009201	2	2
44352347	708298	0	0
44339611	1124957	0	0
44355247	1112807	0	0
44353707	1107882	2	3
45649746	1115008	0	0
45621677	19079524	1	1
45645929	1125315	0	0
45656949	1124300	0	0
45630215	1125315	0	0
45664065	1713332	0	0
45697605	1000560	0	0
45686233	1501700	0	0
45690159	1125315	0	0
45682954	1125315	0	0
45782050	1119510	0	0
45684561	1512674	0	0
45797538	19018935	2	3
45786027	1107882	2	3
45801704	1115008	0	0
45894673	1177480	0	0
45788621	1112807	0	0
45799828	1539403	0	0
46313457	1192710	0	0
46321995	1125315	0	0
4042140	4043241	8	11
4134595	4056621	2	2
21001967	40243436	2	3
21500286	738818	0	0
21602359	40224132	6	7
21603444	40228214	3	6
36224505	19029476	1	2
40652433	3024561	2	2
44355207	1322184	0	0
44339616	1308738	0	0
44355277	791967	0	0
44359828	1107882	2	3
45649709	1174888	0	0
45619836	19079524	1	1
45645933	1125315	0	0
45656951	791967	0	0
45630218	1125315	0	0
45664138	1332418	0	0
45697677	1549786	0	0
45686259	1110410	0	0
45686794	1125315	0	0
45682967	1125315	0	0
45782200	1119510	0	0
45684561	19127890	0	0
45797644	1154615	2	3
45895355	1107882	2	3
45801729	1124300	0	0
45798249	1129625	0	0
46301463	1112807	0	0
45799961	715997	0	0
46313277	1545958	0	0
46322062	1125315	0	0
4042140	372328	4	7
4185206	4066995	2	2
21004753	46275444	2	3
21500337	1174888	0	0
35202051	4283893	6	7
21603444	1150837	3	6
36218126	19075001	1	2
40652433	3019406	2	2
44355208	1129625	0	0
44339482	740275	0	0
44355296	1589505	0	0
44339049	1107882	2	3
45649610	1149196	0	0
45647246	19128009	2	2
45644728	1125315	0	0
45656868	1332418	0	0
45630323	1125315	0	0
45664236	1115008	0	0
45695935	1149196	0	0
45686262	1154343	0	0
45688736	1125315	0	0
45683370	1125315	0	0
45782011	1119510	0	0
45684561	1549786	0	0
45797458	40162522	2	3
45679221	1332419	2	3
45796005	1000560	0	0
45798529	1129625	0	0
46289697	1112807	0	0
45799936	708298	0	0
46313277	1332418	0	0
46322312	1125315	0	0
4042140	4066995	4	9
4185206	4048695	2	2
21004035	19078924	2	3
21500293	1129625	0	0
35202461	40481087	6	7
21603444	40228230	3	6
36211677	4066995	1	2
40652433	3001247	2	2
44355210	1343916	0	0
44339504	975125	0	0
44355240	738818	0	0
44360339	1107882	2	3
45649612	1124957	0	0
45649292	40174880	2	3
45644828	1125315	0	0
45657130	1000560	0	0
45631255	1125315	0	0
45660789	1332418	0	0
45695949	1326303	0	0
45686247	1343916	0	0
45688409	1125315	0	0
45683069	1125315	0	0
45779578	1119510	0	0
45684571	1107830	0	0
45797575	19129655	2	3
45792920	19079524	2	3
45796133	791967	0	0
45798601	1129625	0	0
46290057	1112807	0	0
45799942	738818	0	0
46313322	1112807	0	0
46322338	1125315	0	0
4042140	261325	4	9
4040539	4301346	2	2
21001876	40169216	2	3
21500294	1192710	0	0
35202461	28060	6	7
21602796	19133873	3	6
36223749	40163554	1	2
40652433	3023103	2	2
44355219	1778162	0	0
44339617	1177480	0	0
44355303	738818	0	0
44338430	1107882	2	3
45649821	1107830	0	0
45631756	19075601	2	3
45644837	1125315	0	0
45656876	1107830	0	0
45630959	1125315	0	0
45660791	975125	0	0
45695950	791967	0	0
45686246	1174888	0	0
45688411	1125315	0	0
45682925	1125315	0	0
45779649	1119510	0	0
45684673	1107830	0	0
45797727	40231925	2	3
45895544	1107882	2	3
45796006	1310149	0	0
45798334	1129625	0	0
46290313	1112807	0	0
600000004	740275	0	0
46313583	1595799	0	0
46322495	1125315	0	0
4042140	140673	4	6
4101796	4029498	2	2
21004841	1551192	2	3
21500320	1119510	0	0
35202461	255848	5	7
21602796	19074841	3	6
36223748	40163554	1	2
40652433	3008598	2	2
44355222	738818	0	0
44339623	738818	0	0
44355244	715997	0	0
44339167	1332419	2	3
45649879	742185	0	0
45631986	46275444	2	3
45644840	1125315	0	0
45657079	738818	0	0
45630531	1125315	0	0
45660740	975125	0	0
45695953	1521369	0	0
45686338	1343916	0	0
45688697	1125315	0	0
45679609	1125315	0	0
45779730	1119510	0	0
45684679	1000560	0	0
45797583	19008572	2	3
45795719	19075601	2	3
45796008	975125	0	0
45798582	1129625	0	0
46242240	1112807	0	0
600000005	723013	0	0
46313583	1549786	0	0
46322344	1125315	0	0
4042140	4218389	4	6
4040537	4295880	2	2
21002222	19129655	2	3
21500343	1129625	0	0
35202461	257012	4	7
21602796	19073188	3	6
36223456	1551192	1	2
40652433	3016723	2	2
44355431	1149380	0	0
44339632	1332418	0	0
44353383	1539403	0	0
44338561	1332419	2	3
45649635	742185	0	0
45631991	40162522	2	3
45644747	1125315	0	0
45656993	914335	0	0
45630542	1125315	0	0
45660747	738818	0	0
45695953	1549786	0	0
45686299	738818	0	0
45687043	1125315	0	0
45679827	1125315	0	0
45779736	1119510	0	0
45684767	1149196	0	0
45797584	1115171	2	3
45897905	19073188	2	3
45796009	1115008	0	0
45798719	1129625	0	0
46242325	1112807	0	0
600000005	791967	0	0
46313583	1521369	0	0
46322350	1125315	0	0
4042140	4051466	4	5
19102032	1519937	1	1
21002222	1713671	2	3
21500343	1119510	0	0
35205038	261325	4	7
21602796	19074843	3	6
36218152	40228230	1	2
40652433	3020655	2	2
44355458	1107830	0	0
44339646	1549786	0	0
44353447	738818	0	0
44345840	1332419	2	3
45649644	1115008	0	0
45632004	40162522	2	3
45644866	1125315	0	0
45656994	1115008	0	0
45630543	1125315	0	0
45660924	1149196	0	0
45696037	1107830	0	0
45686323	1595799	0	0
45687103	1125315	0	0
45682379	1125315	0	0
45779803	1119510	0	0
45684522	967823	0	0
45797587	1115171	2	3
45897905	19073183	2	3
45796012	1310149	0	0
45793285	1129625	0	0
46242027	1112807	0	0
46317571	975125	0	0
46313512	1107830	0	0
46316011	1125315	0	0
4042140	4280726	4	10
4311853	198199	1	1
21500785	19077344	2	3
21500343	738818	0	0
35200000	4310024	7	7
35202457	313217	4	6
36218125	19075001	1	2
40652433	3006734	2	2
44355406	738818	0	0
44339251	1545958	0	0
44353422	1112807	0	0
44360103	19075601	2	3
45649849	1501700	0	0
45632013	1127433	2	3
45641962	1125315	0	0
45656999	1501700	0	0
45630617	1125315	0	0
45660753	708298	0	0
45695966	975125	0	0
45686213	1521369	0	0
45687240	1125315	0	0
45682315	1125315	0	0
45779590	1119510	0	0
45684640	1501700	0	0
45797600	19077344	2	3
45787711	19078461	2	3
45796014	1521369	0	0
45793372	1129625	0	0
45893706	1112807	0	0
46318076	1307863	0	0
46313517	1192710	0	0
46316068	1125315	0	0
4042140	4285898	4	11
4235863	4066995	1	1
21004615	19129655	2	3
21500343	1192710	0	0
35200000	441267	7	7
35204989	313217	3	4
36224044	40232448	1	2
40652433	3020630	2	2
44355442	1153428	0	0
44339484	1174888	0	0
44345748	1343916	0	0
44362506	19078461	2	3
45649853	1595799	0	0
45632139	40165015	2	3
45641851	1125315	0	0
45657000	1107830	0	0
45630547	1125315	0	0
45660946	1192710	0	0
45696064	723013	0	0
45686213	1595799	0	0
45687116	1125315	0	0
45682736	42902245	1	2
45779705	1119510	0	0
45684647	1192710	0	0
45797851	40224805	2	3
46288566	1332419	2	3
45796224	975125	0	0
45793117	1129625	0	0
45893710	1112807	0	0
46318026	1551099	0	0
46313534	1124957	0	0
46316316	1125315	0	0
4117930	81893	9	10
4199590	4230399	1	1
21002475	19128263	1	1
21500324	1125443	0	0
35202456	321042	1	1
35202457	321042	3	4
36218398	19008572	1	2
36700000	4218389	4	4
44352441	1310149	0	0
44339445	1589505	0	0
44345322	1192710	0	0
44353747	19078461	2	3
45649888	1174888	0	0
45631874	19008572	2	3
45641816	1125315	0	0
45657002	1549786	0	0
45630553	1125315	0	0
45661023	1551099	0	0
45696076	1332418	0	0
45686213	1549786	0	0
45687120	1125315	0	0
45703952	40221415	3	4
45779782	1119510	0	0
45684648	1192710	0	0
45797699	19077344	2	3
46241441	1332419	2	3
45795943	967823	0	0
45793118	1129625	0	0
45893840	1112807	0	0
46318059	967823	0	0
46313695	701322	0	0
46316325	1125315	0	0
4156265	4156265	0	0
21000766	19029476	1	1
21002475	19128022	1	1
21500360	1119510	0	0
35202456	4324181	1	1
35204998	4329847	3	4
36224043	40232448	1	2
40772935	3035995	4	4
44352445	1738521	0	0
44339446	1548195	0	0
44345752	1129625	0	0
44345675	19079524	2	3
45649657	1549786	0	0
45632226	40232448	2	3
45621451	1125315	0	0
45657002	1521369	0	0
45630686	1125315	0	0
45661024	1115008	0	0
45696027	1149196	0	0
45686283	1501700	0	0
45687121	1125315	0	0
45700857	19127918	3	4
45779823	1119510	0	0
45684747	1174888	0	0
45794794	42707627	2	3
46243285	40173590	2	3
45796249	1343916	0	0
45793386	1129625	0	0
45893844	1112807	0	0
46318162	738818	0	0
46313469	1154029	0	0
46316379	1125315	0	0
4163872	4163872	0	0
19132303	19132304	1	1
21002475	19127918	1	1
21500360	1192710	0	0
35104382	4280726	1	1
21604255	40231925	3	4
36224173	40223768	1	2
40772935	3045716	4	4
44352466	920293	0	0
44339553	1112807	0	0
44345791	1112807	0	0
44355244	40223768	2	3
45649657	1589505	0	0
45632227	19008572	2	3
45621462	1125315	0	0
45657002	19127890	0	0
45630642	1125315	0	0
45660986	1110410	0	0
45695969	1738521	0	0
45686681	738818	0	0
45683950	1125315	0	0
45876033	3006906	2	2
45779533	1119510	0	0
45684798	1551099	0	0
45794853	19075601	2	3
45897781	1332419	2	3
45795992	914335	0	0
45794721	1129625	0	0
45893833	1112807	0	0
46318279	1154029	0	0
46313490	1124300	0	0
46316270	1125315	0	0
4163874	4163874	0	0
19133767	40162522	1	1
21002493	19127904	1	1
21500360	1125315	0	0
35104704	439777	1	1
21604255	35605858	3	4
36223969	40223768	1	2
40772935	3019550	4	4
44352516	1115008	0	0
44339558	738818	0	0
44345791	1177480	0	0
44360674	19075601	2	3
45649657	19127890	0	0
45634094	19019273	2	3
45621530	1125315	0	0
45657003	1521369	0	0
45630713	1125315	0	0
45660760	1115008	0	0
45695973	1361711	0	0
45686683	1149196	0	0
45684094	1125315	0	0
45876033	3000963	2	2
45779884	1119510	0	0
45684534	1332418	0	0
45797134	40231925	2	3
45895340	40223768	2	3
45796028	1115008	0	0
45794809	1129625	0	0
45801734	1112807	0	0
46318293	1124300	0	0
46313597	1112807	0	0
46310638	1125315	0	0
4146173	4146173	0	0
19133767	19133768	1	1
21002493	42902245	1	1
21013676	1000560	0	0
35104347	4280726	1	1
21604343	40229134	3	4
36218151	40228214	1	2
40772935	3004501	4	4
44352418	1738521	0	0
44339561	1112807	0	0
44345791	1129625	0	0
44339040	40228214	2	3
45649666	1308738	0	0
45634096	40232448	2	3
45621746	1125315	0	0
45657004	1549786	0	0
45630625	1125315	0	0
45660670	1343916	0	0
45696081	19039298	0	0
45686330	723013	0	0
45684127	1125315	0	0
45876033	3024561	2	2
45779920	1119510	0	0
45684751	1738521	0	0
45796916	40231925	2	3
45789298	40173590	2	3
45796031	967823	0	0
45794662	1129625	0	0
45801529	1112807	0	0
46317862	1521369	0	0
46313611	1124300	0	0
46311214	1125315	0	0
4134304	4134304	0	0
19133904	19133905	1	1
21002493	19128263	1	1
21013627	1551099	0	0
35508066	1332419	2	3
21604343	40162522	3	4
36218151	40228230	1	2
40772935	3015632	4	4
44352472	1129625	0	0
44339348	1332418	0	0
44345753	1545958	0	0
44338676	40228214	2	3
45649727	1107830	0	0
45634211	40232448	2	3
45621643	1125315	0	0
45657004	19127890	0	0
45627718	1125315	0	0
45660672	1192710	0	0
45692652	1149196	0	0
45686375	920293	0	0
45684180	1125315	0	0
45876033	3009201	2	2
45779838	1119510	0	0
45684653	1308738	0	0
45797184	40223768	2	3
46296446	19079524	2	3
45796238	1549786	0	0
45787864	1129625	0	0
45801638	1112807	0	0
46317862	1549786	0	0
46313547	975125	0	0
46310857	1125315	0	0
4116491	4116491	0	0
19133872	19133873	1	1
21002493	40221415	1	1
21013692	740275	0	0
35507962	1107882	2	3
21604343	40231925	3	4
36217723	1332419	1	2
40772935	3016723	4	4
44352551	1112807	0	0
44339361	1149380	0	0
44345725	1177480	0	0
44338973	40228214	2	3
45649735	1149196	0	0
45634216	19008572	2	3
45621537	1125315	0	0
45657004	1512674	0	0
45627722	1125315	0	0
45660675	1107830	0	0
45692940	1308738	0	0
45686376	1545958	0	0
45684201	1125315	0	0
45876033	3013682	2	2
45779932	1119510	0	0
45684756	1778162	0	0
45797188	40229134	2	3
45792981	1332419	2	3
45796238	1518198	0	0
45787886	1129625	0	0
45798990	1112807	0	0
46317866	975125	0	0
46313550	1112807	0	0
46311487	1125315	0	0
4117038	4117038	0	0
19083337	19045231	1	1
21002506	42902245	1	1
21002594	975125	0	0
35508059	1107882	2	3
21603396	40229134	3	4
36217722	1332419	1	2
40772935	3006906	4	4
44352434	1124300	0	0
44339437	1177480	0	0
44345675	967823	0	0
44338531	40228214	2	3
45649899	1548195	0	0
45628898	40163554	2	3
45621817	1125315	0	0
45656720	708298	0	0
45627731	1125315	0	0
45660661	1124957	0	0
45692915	738818	0	0
45686377	705944	0	0
45684020	1125315	0	0
45876033	3008598	2	2
45708117	1119510	0	0
45684800	1192710	0	0
45795013	40162522	2	3
46296765	1332419	2	3
45796259	715997	0	0
45788010	1129625	0	0
45799205	1112807	0	0
46318020	1118084	0	0
46313551	1539403	0	0
46311507	1125315	0	0
4107731	4107731	0	0
4312749	4198190	1	1
21002506	19128022	1	1
21002591	1717327	0	0
35507479	1107882	2	3
21603396	40162522	3	4
36207527	3051031	1	2
40772935	3006923	4	4
44352556	1713332	0	0
44339438	1174888	0	0
44345678	975125	0	0
44360319	19079524	2	3
45649901	708298	0	0
45629060	19076374	2	3
45621544	1125315	0	0
45657110	1174888	0	0
45627529	1125315	0	0
45660993	1115008	0	0
45692938	1174888	0	0
45686365	1192710	0	0
45684084	1125315	0	0
45876033	3016723	2	2
45705936	1119510	0	0
45684502	1153428	0	0
45794977	40231925	2	3
46288946	19075601	2	3
45796375	975125	0	0
45787983	1129625	0	0
45799360	1112807	0	0
46318139	738818	0	0
46313340	1307863	0	0
46310928	1125315	0	0
4108705	4108705	0	0
4313889	4010253	1	1
21002506	19128263	1	1
21002597	1778162	0	0
35508291	40223768	2	3
21601746	1332419	1	4
35909445	196456	1	1
40772935	3027970	4	4
44352606	19127890	0	0
44339439	723013	0	0
44345336	1332418	0	0
44353141	19078461	2	3
45649831	1153428	0	0
45629141	1115171	2	3
45667579	1125315	0	0
45657112	1396131	0	0
45627530	1125315	0	0
45661003	715997	0	0
45692940	1595799	0	0
45686401	1124957	0	0
45684213	1125315	0	0
45785087	19128009	2	2
45705852	1119510	0	0
45684614	1501700	0	0
45795075	40232448	2	3
46241519	19075601	2	3
45796262	1115008	0	0
45787960	1129625	0	0
45793881	1112807	0	0
46317775	914335	0	0
46313391	1112807	0	0
46310933	1125315	0	0
4109685	4109685	0	0
4054054	4146173	1	1
21002506	19127918	1	1
21002597	1759842	0	0
35508016	40223768	2	3
21604343	1127078	1	4
35909452	196456	1	1
40772948	3006451	4	4
44352606	1515774	0	0
44341206	1000560	0	0
44345337	708298	0	0
44359769	19078461	2	3
45649721	1153428	0	0
45629197	1127433	2	3
45667317	1125315	0	0
45657231	1115008	0	0
45627620	1125315	0	0
45660697	1115008	0	0
45693072	1322184	0	0
45686529	738818	0	0
45684217	1125315	0	0
45783005	19128022	2	2
45705785	1119510	0	0
45684850	1332418	0	0
45795048	19008572	2	3
46241257	19075601	2	3
45796055	1310149	0	0
45788037	1129625	0	0
45794098	1112807	0	0
46317781	738818	0	0
46313505	1713332	0	0
46310935	1125315	0	0
4048169	4048169	0	0
4196958	4163971	1	1
21003455	19127918	1	1
21002598	1728416	0	0
35507965	1545959	2	3
21603379	19029476	1	4
35707753	4166224	1	1
36900000	443279	4	4
44352606	1549786	0	0
44341481	1332418	0	0
44345436	1129625	0	0
44345725	19078461	2	3
45649931	1107830	0	0
45629214	1115171	2	3
45667481	1125315	0	0
45657271	738818	0	0
45627752	1125315	0	0
45660703	975125	0	0
45692818	933724	0	0
45686427	1192710	0	0
45684294	1125315	0	0
45777688	42902245	2	2
45705787	1119510	0	0
45684832	1521369	0	0
45795092	1115171	2	3
46243614	19075601	2	3
45796057	1115008	0	0
45787973	1129625	0	0
45794176	1112807	0	0
46317957	1154029	0	0
46313505	1759842	0	0
46310938	1125315	0	0
4048171	4048171	0	0
19081496	19078461	1	1
21506111	1332418	1	1
21002591	1738521	0	0
35509012	40223834	2	3
21602819	19073188	1	4
35707605	4285898	1	1
36400000	40480160	4	4
44352607	1124300	0	0
44341064	1545958	0	0
44345441	975125	0	0
44338553	19078461	2	3
45649940	1309944	0	0
45629192	40229134	2	3
45667484	1125315	0	0
45656889	1107830	0	0
45627699	1125315	0	0
45660704	1124300	0	0
45692702	1107830	0	0
45686429	1521369	0	0
45684029	1125315	0	0
46240251	19127918	2	2
45705893	1119510	0	0
45684837	1115008	0	0
45795095	19018935	2	3
45790519	1332419	2	3
45796058	1501700	0	0
45788203	1129625	0	0
45794121	1112807	0	0
46318249	1174888	0	0
46313655	1154343	0	0
46310942	1125315	0	0
4163951	4163951	0	0
4237320	4218408	1	1
21506123	967823	1	1
21002597	1728416	0	0
35507923	19019273	2	3
21602840	19133873	1	4
35707694	4266809	1	1
37520918	4163971	4	4
44352542	791967	0	0
44341017	1332418	0	0
44345632	1129625	0	0
44345832	19078461	2	3
45649695	1149196	0	0
45628961	19019273	2	3
45667487	1125315	0	0
45657044	1154029	0	0
45627702	1125315	0	0
45660989	1000560	0	0
45692632	975125	0	0
45686429	19127890	0	0
45684231	1125315	0	0
46240251	19128009	2	2
45705971	1119510	0	0
45684983	1322184	0	0
45792272	40236446	2	3
46288200	19075601	2	3
45796061	975125	0	0
45788283	1129625	0	0
45794055	1112807	0	0
46318014	1154343	0	0
46313621	1521369	0	0
46311085	1125315	0	0
4043071	4043071	0	0
4237321	4191853	1	1
21506140	1332418	1	1
21002587	1778162	0	0
35508372	19019273	2	3
21603057	920300	1	4
35707753	440448	1	1
37320089	4296204	4	4
44352523	1177480	0	0
44339679	1177480	0	0
44345793	1112807	0	0
44359823	1332419	2	3
45649698	1174888	0	0
45629092	1127433	2	3
45667405	1125315	0	0
45657047	1500211	0	0
45627771	1125315	0	0
45660951	1192710	0	0
45692774	1768849	0	0
45686429	1549786	0	0
45684317	1125315	0	0
45876038	3002385	2	2
45703751	1119510	0	0
45684986	1110410	0	0
45792274	920334	2	3
46243449	19075601	2	3
45796065	1332418	0	0
46294138	1129625	0	0
45794218	1112807	0	0
46318307	1332418	0	0
46313674	1343916	0	0
46311118	1125315	0	0
4191853	4191853	0	0
4237321	4078793	3	3
21506220	1115008	1	1
21002597	1768849	0	0
35508300	43012036	2	3
21603057	920334	1	4
36210621	3049273	1	1
36903632	378419	4	4
44352547	920293	0	0
44339762	1107830	0	0
44345794	933724	0	0
44360083	1545959	2	3
45649702	1595799	0	0
45628009	40232448	2	3
45667408	1125315	0	0
45657182	1110410	0	0
45627412	1125315	0	0
45660953	1501700	0	0
45692744	1309944	0	0
45686407	1192710	0	0
45684299	1125315	0	0
45876038	3009542	2	2
45702371	1119510	0	0
45684951	1307863	0	0
45792351	1115171	2	3
45897599	19075601	2	3
45796393	975125	0	0
46294143	1129625	0	0
45788733	1112807	0	0
46317705	1107830	0	0
46313936	975125	0	0
46311163	1125315	0	0
4112343	4112343	0	0
4237321	4062501	3	3
21506150	967823	1	1
21002601	1717327	0	0
35507862	43012036	2	3
21604269	40165015	1	4
36211076	40480160	1	1
36903632	440086	4	4
44352425	1309944	0	0
44339833	1124300	0	0
44345754	1129625	0	0
44353478	1332419	2	3
45649702	1308738	0	0
45626116	19008572	2	3
45665342	1125315	0	0
45657186	1549786	0	0
45627838	1125315	0	0
45660906	1759842	0	0
45692754	1115008	0	0
45686462	1110410	0	0
45684326	1125315	0	0
45876038	3026361	2	2
45702478	1119510	0	0
45684958	1738521	0	0
45792420	19077572	2	3
46292647	19075601	2	3
45796246	1545958	0	0
46293892	1129625	0	0
45789011	1112807	0	0
46318096	1192710	0	0
46313948	1557272	0	0
46311185	1125315	0	0
4027663	4027663	0	0
4042516	4170947	3	3
21503152	1129625	1	1
21002597	1741122	0	0
21602831	46275444	2	3
21601855	1539411	1	4
36211103	4059173	1	1
40792793	3009542	4	4
44352433	757627	0	0
44339692	1174888	0	0
44345766	975125	0	0
44345925	1332419	2	3
45649950	1107830	0	0
45626200	40229134	2	3
45665265	1125315	0	0
45657186	1521369	0	0
45627651	1125315	0	0
45660906	1713332	0	0
45692756	1115008	0	0
45686518	19127890	0	0
45684356	1125315	0	0
45876038	3024731	2	2
45702415	1119510	0	0
45684902	1149196	0	0
46244870	705944	0	0
46241636	19078461	2	3
45796189	1521369	0	0
46294057	1129625	0	0
46296760	1112807	0	0
46318106	914335	0	0
46313959	1124957	0	0
46311203	1125315	0	0
4163971	4163971	0	0
4275564	4336464	3	3
21503083	920293	1	1
21002600	1759842	0	0
21602754	40174880	2	3
21601855	1545959	1	4
36211136	4278672	1	1
40792793	3000963	4	4
44352595	740275	0	0
44339699	738818	0	0
44345769	1717327	0	0
44338624	1332419	2	3
45649978	1305058	0	0
45626130	19059056	2	3
45665405	1125315	0	0
45657097	1717327	0	0
45627680	1125315	0	0
45661041	738818	0	0
45693011	1307863	0	0
45686518	1589505	0	0
45684372	1125315	0	0
45876038	3007461	2	2
45699323	1119510	0	0
45684876	1501700	0	0
46244980	914335	0	0
45787865	19079524	2	3
45796189	19127890	0	0
46294239	1129625	0	0
46296893	1112807	0	0
46317720	1738521	0	0
46314014	1501700	0	0
46311094	1125315	0	0
4102123	4102123	0	0
4326426	4337138	3	3
21503144	914335	1	1
21002600	1746114	0	0
35507607	40223834	2	3
21602795	1741122	4	4
36211123	4048695	1	1
37502353	4293740	4	4
44352494	19127890	0	0
44339709	1361711	0	0
44348344	1501700	0	0
44353383	1539411	2	3
45646309	1115008	0	0
45626132	40231925	2	3
45665165	1125315	0	0
45656784	1124957	0	0
45627696	1125315	0	0
45660920	967823	0	0
45693014	1343916	0	0
45686518	1549786	0	0
45655185	46275916	1	1
45680892	40231925	2	3
45699342	1119510	0	0
45684730	1713332	0	0
46244990	708298	0	0
46243532	19075601	2	3
45796175	1174888	0	0
46293901	1129625	0	0
46295432	1112807	0	0
46317908	1332418	0	0
46314024	1549786	0	0
46311304	1125315	0	0
4186930	4186930	0	0
4195288	4202451	3	3
21503148	1154029	1	1
21002607	1746114	0	0
35507567	35605482	2	3
21602795	1778162	4	4
35708073	81893	1	1
37502353	4323208	4	4
44352494	1589505	0	0
44339729	1149380	0	0
44348248	1539403	0	0
44345954	1545959	2	3
45646251	920293	0	0
45626222	1115171	2	3
45665399	1125315	0	0
45653550	1124300	0	0
45624202	1125315	0	0
45661004	1149196	0	0
45692888	1332418	0	0
45686361	1174888	0	0
45701741	46275916	1	1
45680989	19077572	2	3
45699622	1119510	0	0
45684730	1759842	0	0
46291423	1521369	0	0
46241279	1539411	2	3
45796178	791967	0	0
46294209	1129625	0	0
46244575	1112807	0	0
46318195	1332418	0	0
46314024	19127890	0	0
46311239	1125315	0	0
4187458	4187458	0	0
4054054	40479422	3	3
21503149	1154029	1	1
21002600	1717327	0	0
35507572	1115171	2	3
21602795	1768849	4	4
35708038	81893	1	1
40792803	3010813	4	4
44352494	1549786	0	0
44339771	738818	0	0
44348087	975125	0	0
44345791	19078461	2	3
45646318	1115008	0	0
45626223	19008572	2	3
45665380	1125315	0	0
45653582	1332418	0	0
45624341	1125315	0	0
45661050	1713332	0	0
45692636	1545958	0	0
45686700	914335	0	0
45698370	19079524	1	1
45680995	19073183	2	3
45699623	1119510	0	0
45685030	1153428	0	0
46291423	1549786	0	0
46293132	40228214	2	3
45796271	933724	0	0
46294216	1129625	0	0
46244313	1112807	0	0
46318256	1738521	0	0
46314024	1589505	0	0
46311578	1125315	0	0
4155034	4155034	0	0
4054054	40479768	3	3
21503133	19003953	1	1
21002591	1759842	0	0
35507941	1154615	2	3
21602795	920293	4	4
35707843	30753	1	1
40792803	3026361	4	4
44352814	1177480	0	0
44339731	791967	0	0
44348037	738818	0	0
44345791	40232448	2	3
45646370	933724	0	0
45626210	40232448	2	3
45665162	1125315	0	0
45653375	1124957	0	0
45624608	1125315	0	0
45661051	723013	0	0
45692808	1539403	0	0
45686602	1521369	0	0
45695485	46275916	1	1
45681009	19019273	2	3
45699625	1119510	0	0
45685034	1738521	0	0
46291423	1595799	0	0
45803493	40228214	2	3
45796272	1115008	0	0
46294452	1129625	0	0
46244521	1112807	0	0
46318262	933724	0	0
46313969	1332418	0	0
46311594	1125315	0	0
4125906	4125906	0	0
4054054	81151	3	3
21502867	967823	1	1
21002607	1741122	0	0
35507482	19133905	2	3
21602795	1717327	4	4
36517129	4035415	1	1
40796128	3004501	4	4
44352503	1174888	0	0
44339667	1500211	0	0
44348284	1115008	0	0
44339374	1539411	2	3
45646375	1310149	0	0
45626345	43012036	2	3
45665242	1125315	0	0
45653463	1539403	0	0
45624616	1125315	0	0
45661053	975125	0	0
45692809	975125	0	0
45683170	738818	0	0
45695494	19127922	1	1
45681132	40228230	2	3
45699635	1119510	0	0
45681601	1149196	0	0
46291098	1107830	0	0
45786010	40228214	2	3
45796322	975125	0	0
46294579	1129625	0	0
46244547	1112807	0	0
46322396	975125	0	0
46314423	1192710	0	0
46305986	1125315	0	0
4041436	439777	4	6
4043197	4275113	3	3
21503152	738818	1	1
21002592	975125	0	0
35507780	1127433	2	3
21602795	1738521	4	4
36517132	4035415	1	1
37303790	134438	4	4
44352803	1545958	0	0
44339713	1149196	0	0
44348039	920293	0	0
44362717	19078461	2	3
45648856	1539403	0	0
45623153	40231925	2	3
45665368	1125315	0	0
45653411	1107830	0	0
45624620	1125315	0	0
45661076	975125	0	0
45692822	1149196	0	0
45683176	753626	0	0
45695494	19133679	1	1
45681098	920300	2	3
45699576	1119510	0	0
45681602	1174888	0	0
46291223	791967	0	0
45793032	19078461	2	3
45796189	1549786	0	0
46243884	1129625	0	0
45787640	738818	0	0
46322526	1153428	0	0
46313631	1332418	0	0
46322655	1125315	0	0
4179141	4134304	4	6
4184252	140673	3	3
21503197	975125	1	1
21002598	1778162	0	0
35508052	1551192	2	3
21602795	1713332	4	4
36211268	4149245	1	1
37303809	4156265	4	4
44352725	701322	0	0
44339719	1110410	0	0
44348190	1129625	0	0
44362814	19133873	2	3
45648993	1551099	0	0
45622890	1551192	2	3
45665371	1125315	0	0
45653432	1551099	0	0
45624413	1125315	0	0
45661089	1713332	0	0
45692827	705944	0	0
45683115	1738521	0	0
45695494	19129144	1	1
45681369	19059056	2	3
45699350	1119510	0	0
45681492	1557272	0	0
46291521	1174888	0	0
45785945	19078461	2	3
45796398	1713332	0	0
46243714	1129625	0	0
45787293	738818	0	0
46318366	1332418	0	0
46313739	1551099	0	0
46322091	1125315	0	0
4178545	4294548	4	6
4184252	4218389	3	3
21503197	1124300	1	1
21002602	1759842	0	0
35508143	40236824	2	3
21602795	1746114	4	4
36211224	4001336	1	1
37521802	4336464	4	4
44352705	1177480	0	0
44362941	1129625	0	0
44348420	1129625	0	0
44361890	19133905	2	3
45648999	1501700	0	0
45622891	1115171	2	3
45667429	1125315	0	0
45653438	1332418	0	0
45624448	1125315	0	0
45661044	1501700	0	0
45692983	740275	0	0
45683111	1343916	0	0
45695848	46275916	1	1
45675559	19019273	2	3
45699494	1119510	0	0
45682610	1551099	0	0
46291716	1728416	0	0
45787759	19079524	2	3
45796308	975125	0	0
46243936	1129625	0	0
45787777	738818	0	0
45794465	967823	0	0
46313763	1000560	0	0
46322095	1125315	0	0
4178818	4280726	4	6
4043671	4280726	3	3
21503152	1192710	1	1
21002602	1713332	0	0
35508084	1127433	2	3
21601907	1129625	4	4
36211402	4066995	1	1
40599742	4168004	4	4
44352453	738818	0	0
44363251	1129625	0	0
44348422	1107830	0	0
44361891	46275916	2	3
45649002	1326303	0	0
45623030	40174880	2	3
45667275	1125315	0	0
45653697	1107830	0	0
45624452	1125315	0	0
45660845	1110410	0	0
45692910	1521369	0	0
45683514	738818	0	0
45695601	19115351	1	1
45675988	19008572	2	3
45699672	1119510	0	0
45682613	1174888	0	0
46291102	1539403	0	0
46238671	40228214	2	3
45796385	1107830	0	0
46243943	1129625	0	0
45802515	738818	0	0
45794376	1115008	0	0
46313997	1107830	0	0
46322422	1125315	0	0
4178818	40486433	4	6
4043671	4294548	3	3
21503199	975125	1	1
21002597	1729720	0	0
35508091	35605482	2	3
21601907	1149380	4	4
35707759	4310024	1	1
40796010	3007461	4	4
44352727	1177480	0	0
44363368	1129625	0	0
44348315	1129625	0	0
44361900	19019273	2	3
45649175	1149196	0	0
45623247	1115171	2	3
45667308	1125315	0	0
45653674	1110410	0	0
45624453	1125315	0	0
45657969	1115008	0	0
45692910	1549786	0	0
45683129	705944	0	0
45692566	46275916	1	1
45675669	43012036	2	3
45696017	1119510	0	0
45682628	1549786	0	0
46291309	1545958	0	0
46238658	40228214	2	3
45796457	1361711	0	0
46243851	1129625	0	0
45801237	738818	0	0
45794483	738818	0	0
46313903	1310149	0	0
46322581	1125315	0	0
4180628	30753	4	6
4043671	40486433	3	3
21503205	1343916	1	1
21002621	1746114	0	0
35202055	4329847	2	3
21601907	975125	4	4
36211677	196456	1	1
40796010	3010813	4	4
44352639	738818	0	0
44363514	1129625	0	0
44348274	1129625	0	0
44361726	1127433	2	3
45649106	738818	0	0
45625063	40162522	2	3
45662787	1125315	0	0
45653678	1501700	0	0
45624457	1125315	0	0
45657978	1713332	0	0
45692992	738818	0	0
45683460	914335	0	0
45689277	46275916	1	1
45675902	19008572	2	3
45696115	1119510	0	0
45682628	1521369	0	0
46291317	1115008	0	0
45786056	19079524	2	3
45796468	1521369	0	0
46243854	1129625	0	0
45795841	738818	0	0
45794419	975125	0	0
46308405	1738521	0	0
46322608	1125315	0	0
4040391	4301346	4	6
4184974	4336464	3	3
21501229	967823	1	1
21002600	1778162	0	0
21602504	43012433	2	3
35202457	381316	4	4
36211088	4146173	1	1
37522205	4301346	4	4
44352753	1713332	0	0
44363159	1129625	0	0
44348277	708298	0	0
44361755	40163554	2	3
45649107	1107830	0	0
45625074	19078924	2	3
45662800	1125315	0	0
45653253	1115008	0	0
45624539	1125315	0	0
45657978	1759842	0	0
45693162	19127890	0	0
45683482	1713332	0	0
45689779	46275916	1	1
45676100	40231925	2	3
45696200	1119510	0	0
45682629	1174888	0	0
46291374	1112807	0	0
45786176	40228214	2	3
45796468	1549786	0	0
46244899	1129625	0	0
45790405	738818	0	0
45794503	1192710	0	0
46307885	1548195	0	0
46322611	1125315	0	0
4027403	4107731	4	6
4196016	4108705	3	3
21500615	1343916	1	1
21002617	1746114	0	0
35508579	19133905	2	3
35202457	4163874	4	4
36211091	4113008	1	1
36919120	4043241	4	4
44352756	1115008	0	0
44363592	1129625	0	0
44348279	1115008	0	0
44361767	19075001	2	3
45649187	791967	0	0
45624908	40229134	2	3
45662900	1125315	0	0
45653256	1549786	0	0
45624541	1125315	0	0
45657937	1107830	0	0
45693162	1512674	0	0
45683377	723013	0	0
45680864	46275916	1	1
45676101	1551192	2	3
45696218	1119510	0	0
45682632	975125	0	0
46291398	1000560	0	0
45895346	40228214	2	3
45796349	1115008	0	0
46244820	1129625	0	0
45790576	738818	0	0
45794393	920293	0	0
46308517	1713332	0	0
46316495	1125315	0	0
4027403	4275113	4	6
4198525	30753	3	3
21500155	1539403	1	1
21002615	1746114	0	0
35508262	40174880	2	3
21602359	933724	4	4
36211091	78272	1	1
36314523	4015189	4	4
44352761	1129625	0	0
44363595	1129625	0	0
44345805	1521369	0	0
44361851	43012036	2	3
45648857	1539403	0	0
45623318	19008572	2	3
45662923	1125315	0	0
45653256	1521369	0	0
45624867	1125315	0	0
45657993	1343916	0	0
45693162	1549786	0	0
45683246	1738521	0	0
45680904	46275916	1	1
45672791	40228214	2	3
45696221	1119510	0	0
45682673	1308738	0	0
46242704	920293	0	0
45787520	19078461	2	3
45796350	1192710	0	0
46244882	1129625	0	0
45790448	738818	0	0
45794396	1343916	0	0
46308568	1551099	0	0
46316744	1125315	0	0
4027403	4108705	4	6
4196708	380378	3	3
21500165	1501700	1	1
21002597	1746114	0	0
21603404	40229134	2	3
21602359	1521369	4	4
36207527	46235214	1	1
36903604	4043241	4	4
44352765	1308738	0	0
44363305	1129625	0	0
44345805	1549786	0	0
44361816	19133905	2	3
45649202	1361711	0	0
45623321	40169216	2	3
45662915	1125315	0	0
45653553	1539403	0	0
45624879	1125315	0	0
45657997	1149196	0	0
45693004	1551099	0	0
45683256	1310149	0	0
45676178	46275916	1	1
45672959	19019273	2	3
45696145	1119510	0	0
45682579	1174888	0	0
46242711	1343916	0	0
45895161	40223768	2	3
45796310	1174888	0	0
46243984	1129625	0	0
45790586	738818	0	0
45794397	1115008	0	0
46308194	1501700	0	0
46318008	1125315	0	0
4028071	321042	4	6
4185643	4237458	3	3
21500201	1326303	1	1
21002602	1746114	0	0
21602473	19127904	3	3
21602359	1589505	4	4
36207527	3011505	1	1
40796118	3008598	4	4
44352712	1713332	0	0
44358707	1129625	0	0
44345815	1110410	0	0
44361963	19019273	2	3
45648859	1326303	0	0
45621487	1127433	2	3
45662961	1125315	0	0
45653826	738818	0	0
45624985	1125315	0	0
45657950	1110410	0	0
45692896	1115008	0	0
45683257	1322184	0	0
45676210	19079524	1	1
45672914	19057271	2	3
45696256	1119510	0	0
45682585	1115008	0	0
46242675	1713332	0	0
46297179	1332419	2	3
45796311	1361711	0	0
46238900	1129625	0	0
45790701	738818	0	0
45794399	1174888	0	0
46308574	975125	0	0
46318012	1125315	0	0
4028071	317576	4	6
4182210	4043241	3	3
21506220	1124300	1	1
21002602	1778162	0	0
21602473	19128022	3	3
21602359	1549786	4	4
36211303	4156265	6	6
37522205	44783196	3	4
44352712	1759842	0	0
44356261	1129625	0	0
44345817	1129625	0	0
44361883	40236446	2	3
45646490	1149380	0	0
45621508	19008572	2	3
45662836	1125315	0	0
45653831	1124957	0	0
45624784	1125315	0	0
45658048	1192710	0	0
45692897	1149196	0	0
45683259	1124957	0	0
45671713	19079524	1	1
45673051	40229134	2	3
45696158	1119510	0	0
45682590	1154343	0	0
46242675	1759842	0	0
46238511	40223768	2	3
45796312	967823	0	0
46238903	1129625	0	0
45790860	738818	0	0
45794403	738818	0	0
46308577	1589505	0	0
46317192	1125315	0	0
4047779	4035415	4	6
4276675	4314290	3	3
21506220	1177480	1	1
21002615	1717327	0	0
21602473	42902245	3	3
21603931	1124300	4	4
36516993	133834	6	6
40254301	40221415	3	4
44352616	1149380	0	0
44356306	1129625	0	0
44345885	1177480	0	0
44362168	1115171	2	3
45646491	738818	0	0
45621738	43012036	2	3
45662969	1125315	0	0
45653490	1110410	0	0
45624789	1125315	0	0
45657716	1326303	0	0
45693033	738818	0	0
45683261	914335	0	0
45670219	19079524	1	1
45673222	1594382	2	3
45696485	1119510	0	0
45682622	1149196	0	0
46242684	723013	0	0
45801164	40223768	2	3
45796426	740275	0	0
46238965	1129625	0	0
46297191	738818	0	0
45794344	1322184	0	0
46308585	1738521	0	0
46317882	1125315	0	0
4047779	380378	4	6
4043671	4112343	3	4
21500620	19002770	1	1
21002615	1778162	0	0
21602473	19128263	3	3
21603931	19003953	4	4
36416692	4144583	6	6
37320108	4296204	3	4
44352618	740275	0	0
44349379	1129625	0	0
44345865	1000560	0	0
44362064	40229134	2	3
45646498	782043	0	0
45621849	40228230	2	3
45662617	1125315	0	0
45653652	1149196	0	0
45624536	1125315	0	0
45657718	1192710	0	0
45693034	975125	0	0
45683270	1000560	0	0
45783746	19127922	1	1
45673176	43012036	2	3
45696244	1119510	0	0
45682648	1115008	0	0
46242582	1738521	0	0
45897512	19078461	2	3
45796433	1521369	0	0
46238897	1129625	0	0
46297601	738818	0	0
45794459	1124957	0	0
46308732	1112807	0	0
46317631	1125315	0	0
4047779	4156265	4	6
4182536	4108705	3	4
21500620	19039298	1	1
21002601	1746114	0	0
21602473	19128009	3	3
36217214	19128065	3	4
36416680	4144583	6	6
37522270	4337138	3	4
44352619	1310149	0	0
44349610	1129625	0	0
44345839	1192710	0	0
45655829	40223834	2	3
45646499	920293	0	0
45665355	40232448	2	3
45662850	1125315	0	0
45653402	1545958	0	0
45624843	1125315	0	0
45657719	1124957	0	0
45693168	1322184	0	0
45683145	1192710	0	0
45783746	19129144	1	1
45673307	19078461	2	3
45696327	1119510	0	0
45681719	1149196	0	0
46242679	1746114	0	0
46243815	19078461	2	3
45796279	1000560	0	0
46238898	1129625	0	0
46297565	738818	0	0
45794491	1539403	0	0
46308738	1595799	0	0
46317660	1125315	0	0
4028071	4329847	4	7
4300157	4142905	3	4
21500620	782043	1	1
21002599	1717327	0	0
21602473	19127918	3	3
36217214	19128263	3	4
36211315	78272	6	6
36900000	378419	2	6
44352736	1717327	0	0
44349738	1129625	0	0
44345832	1177480	0	0
45655954	19008572	2	3
45646472	1713332	0	0
45667354	19019273	2	3
45662863	1125315	0	0
45653466	1738521	0	0
45668794	1125315	0	0
45658060	708298	0	0
45693046	1713332	0	0
45683147	1107830	0	0
45783746	19133679	1	1
45785005	43012036	2	3
45696610	1119510	0	0
45681678	1192710	0	0
46242679	1741122	0	0
45800902	19078461	2	3
45796434	708298	0	0
46238989	1129625	0	0
46289024	738818	0	0
46312365	1326303	0	0
46308739	975125	0	0
46317538	1125315	0	0
4180628	4294548	4	7
4300157	4237458	3	4
21002499	19127918	1	1
21002616	1746114	0	0
21601765	40171902	3	3
36217214	19127918	3	4
35802848	81893	6	6
36603422	81151	3	6
44352742	701322	0	0
44349708	1129625	0	0
44345840	1332418	0	0
45656051	19076374	2	3
45646528	738818	0	0
45667314	19008572	2	3
45662975	1125315	0	0
45653787	1149196	0	0
45668704	1125315	0	0
45658053	1521369	0	0
45693189	738818	0	0
45683477	1153428	0	0
45707981	40220386	1	1
45784872	19019273	2	3
45696423	1119510	0	0
45681679	19039298	0	0
46242769	1192710	0	0
46243529	19078461	2	3
45796305	1149196	0	0
46238990	1129625	0	0
46289221	738818	0	0
46312378	1124957	0	0
46308764	914335	0	0
46316790	1125315	0	0
4178545	4112343	4	7
4043371	4112343	3	4
21502653	933724	1	1
21002616	1717327	0	0
21602471	19054876	3	3
36217214	19127904	3	4
36517012	78272	6	6
37103722	195588	3	6
44352742	715997	0	0
44349660	1129625	0	0
44345870	920293	0	0
45655965	19008572	2	3
45646537	1515774	0	0
45662805	19018935	2	3
45664555	1125315	0	0
45653468	1713332	0	0
45668978	1125315	0	0
45658053	1595799	0	0
45693104	738818	0	0
45683237	1332418	0	0
45708007	46275916	1	1
45784861	43012036	2	3
45696433	1119510	0	0
45681705	1115008	0	0
46242771	975125	0	0
45798278	19078461	2	3
45796398	1759842	0	0
46238991	1129625	0	0
46289774	738818	0	0
46312108	1192710	0	0
46308782	705944	0	0
46316841	1125315	0	0
4027403	40492359	4	8
4040563	4198190	3	4
21002491	19128022	1	1
21002600	1713332	0	0
21602471	1589505	3	3
36217214	19129144	3	4
36517140	78272	6	6
36702247	4066995	3	6
44352744	1153428	0	0
44349861	1129625	0	0
44345871	1124300	0	0
45656032	19018935	2	3
45646537	1549786	0	0
45662461	40232448	2	3
45664560	1125315	0	0
45653668	1548195	0	0
45668551	1125315	0	0
45658053	1549786	0	0
45692859	1174888	0	0
45683539	1124300	0	0
45708317	19079524	1	1
45785016	40229134	2	3
45696438	1119510	0	0
45681708	1521369	0	0
46242652	1545958	0	0
46293377	19078461	2	3
45796399	1154029	0	0
46239014	1129625	0	0
46241646	738818	0	0
46312314	1174888	0	0
46308468	1118084	0	0
46316852	1125315	0	0
4027384	134438	4	4
4279903	4323902	3	4
21002491	19128263	1	1
21505734	967823	0	0
21602471	1521369	3	3
36217214	40221415	3	4
36502198	4134304	5	6
37320122	4296204	3	6
44352483	1115008	0	0
44341796	1129625	0	0
44345875	1129625	0	0
45656069	1127433	2	3
45646546	708298	0	0
45662608	19074843	2	3
45663001	1125315	0	0
45653812	1153428	0	0
45668944	1125315	0	0
45658081	738818	0	0
45693184	1332418	0	0
45683543	1738521	0	0
45705314	46275916	1	1
45785161	40229134	2	3
45692966	1119510	0	0
45681708	1595799	0	0
46242883	975125	0	0
46238387	19078461	2	3
45790722	1174888	0	0
46239234	1129625	0	0
46241725	738818	0	0
46312110	1115008	0	0
46308596	975125	0	0
46316940	1125315	0	0
4071948	4330583	4	4
19054876	40221415	3	4
21002491	19127918	1	1
21505776	1192710	0	0
21602471	1500211	3	3
36217214	40165015	2	3
36502196	4066995	5	6
36900000	440086	4	6
44352486	1192710	0	0
44341849	1129625	0	0
44345880	1110410	0	0
45656349	1551192	2	3
45646461	1107830	0	0
45664560	1127433	2	3
45663102	1125315	0	0
45653821	1551099	0	0
45668958	1125315	0	0
45658082	1149196	0	0
45693186	1539403	0	0
45683382	1539403	0	0
45705701	46275916	1	1
45785244	1115171	2	3
45694729	1119510	0	0
45681708	1549786	0	0
46242888	1174888	0	0
45795494	19078461	2	3
45790725	1192710	0	0
46239414	1129625	0	0
46241735	738818	0	0
46312129	975125	0	0
46308616	1741122	0	0
46311630	1125315	0	0
4047779	81151	4	9
4311041	4336464	3	4
21002491	42902245	1	1
21505823	1192710	0	0
21602471	1548195	3	3
36217214	19077572	2	3
36502199	4149245	5	6
37002287	198199	4	6
44352766	1539403	0	0
44342045	1129625	0	0
44345881	1124300	0	0
45656155	40232448	2	3
45646467	738818	0	0
45659632	19019273	2	3
45663016	1125315	0	0
45653836	1154343	0	0
45668963	1125315	0	0
45658164	1551099	0	0
45692980	975125	0	0
45683247	1153428	0	0
45702012	46275916	1	1
45784843	40229134	2	3
45693313	1119510	0	0
45681682	1154029	0	0
46242696	1107830	0	0
46243764	19078461	2	3
45790766	1549786	0	0
46239426	1129625	0	0
46241765	738818	0	0
46312131	1501700	0	0
46308616	1746114	0	0
46306374	1125315	0	0
4047779	4142905	4	8
4042504	44783196	3	5
21002491	19128009	1	1
21505819	1125315	0	0
21602471	1512674	3	3
36217214	920334	2	3
36211303	4109685	5	6
37002287	4056621	4	6
44352576	1124300	0	0
44341920	1129625	0	0
44345891	738818	0	0
45656270	1115171	2	3
45646633	708298	0	0
45659613	40232448	2	3
45663034	1125315	0	0
45653479	1310149	0	0
45668728	1125315	0	0
45657743	1778162	0	0
45693048	1124300	0	0
45683254	1149196	0	0
45699313	46275916	1	1
45785077	1545959	2	3
45693563	1119510	0	0
45681756	1738521	0	0
46242821	1778162	0	0
46293245	19078461	2	3
45790766	19127890	0	0
45894433	1129625	0	0
46242612	738818	0	0
46312329	738818	0	0
46308617	1192710	0	0
46306501	1125315	0	0
4047779	44782520	4	5
4042505	4278672	3	5
21601120	964261	3	4
21505820	1192710	0	0
21602471	1549786	3	3
36217214	40162522	2	3
36211303	4132546	4	6
36403239	439777	4	6
42802580	1729720	0	0
44341921	1129625	0	0
44345897	1118084	0	0
45656406	40232448	2	3
45646561	1107830	0	0
45659624	40232448	2	3
45663210	1125315	0	0
45653608	967823	0	0
45668880	1125315	0	0
45658140	1545958	0	0
45693053	1310149	0	0
45683385	1332418	0	0
45699329	46275916	1	1
45785202	19133768	2	3
45693498	1119510	0	0
45681757	1713332	0	0
46242823	1124957	0	0
45895395	19078461	2	3
45790766	1521369	0	0
45801503	1129625	0	0
46241811	738818	0	0
46312246	1000560	0	0
46308660	1174888	0	0
46306183	1125315	0	0
4067285	4198190	4	5
4042505	4048695	3	5
21502709	1154615	3	4
21505820	1112807	0	0
21602471	1519936	3	3
36217214	40228230	2	3
36516972	4237458	4	6
37200000	321042	6	6
42802779	1343916	0	0
44341869	1129625	0	0
44345912	1112807	0	0
45656409	40232448	2	3
45646571	1124300	0	0
45659814	19125062	2	3
45659569	1125315	0	0
45653711	1124957	0	0
45668882	1125315	0	0
45658066	1557272	0	0
45693064	1115008	0	0
45683497	705944	0	0
45692950	46275916	1	1
45784942	1115171	2	3
45690305	1119510	0	0
45681711	1308738	0	0
46242834	1112807	0	0
46292965	19078461	2	3
45790930	1115008	0	0
45801409	1129625	0	0
46241824	738818	0	0
46312444	1174888	0	0
46308670	1192710	0	0
46306186	1125315	0	0
4040392	4186930	4	5
4042505	40480160	3	5
21503530	19075601	3	4
21505821	1177480	0	0
21601387	1305058	3	3
36217214	1127078	2	3
36516972	4142905	4	6
37502354	4108705	6	6
42802781	1713332	0	0
44341876	1129625	0	0
44345914	1149380	0	0
45656216	43012036	2	3
45646644	933724	0	0
45659769	40162522	2	3
45659794	1125315	0	0
45653504	1154029	0	0
45666462	1125315	0	0
45658069	975125	0	0
45693065	19039298	0	0
45683492	1545958	0	0
45707153	1115008	0	0
45785068	19008572	2	3
45690402	1119510	0	0
45681724	1545958	0	0
46242872	1192710	0	0
45793053	19078461	2	3
45790931	1501700	0	0
45801482	1129625	0	0
45897971	738818	0	0
46312224	723013	0	0
46308673	1738521	0	0
46306073	1125315	0	0
4040391	44783196	4	5
4182165	4066995	3	5
21503530	19059056	3	4
21505821	1192710	0	0
21604685	701322	3	3
36217214	19007333	2	3
36600000	4285898	4	6
36702253	4029498	6	6
42802783	1124300	0	0
44342087	1129625	0	0
44345923	1137529	0	0
45652708	920334	2	3
45646647	1124300	0	0
45660048	1115171	2	3
45659628	1125315	0	0
45653713	1332418	0	0
45666516	1125315	0	0
45658070	1102527	0	0
45693193	715997	0	0
45683504	1115008	0	0
45707060	1367571	0	0
45786482	40229134	2	3
45690554	1119510	0	0
45681747	1557272	0	0
46242876	1124957	0	0
46243589	19078461	2	3
45790939	1107830	0	0
45801574	1129625	0	0
45895806	738818	0	0
46312322	791967	0	0
46308630	740275	0	0
46306516	1125315	0	0
4028071	4310024	4	5
4182165	4048695	3	5
21501229	19079524	3	4
21505823	1129625	0	0
21604685	715997	3	3
35802845	4285898	4	7
35707763	30753	3	6
40792793	3024731	6	6
42802795	723013	0	0
44342137	1129625	0	0
44345923	1149380	0	0
45652625	19075001	2	3
45646650	1361711	0	0
45659927	40232448	2	3
45659534	1125315	0	0
45653515	1557272	0	0
45666497	1125315	0	0
45657877	1000560	0	0
45689835	1149196	0	0
45685286	723013	0	0
45707032	1000560	0	0
45786594	19018935	2	3
45690609	1119510	0	0
45681732	1102527	0	0
46243040	967823	0	0
46238574	19078461	2	3
45790775	791967	0	0
45801695	1129625	0	0
45895861	738818	0	0
46312675	1332418	0	0
46308486	1149196	0	0
46306592	1125315	0	0
4155793	4047491	4	5
4215793	4275113	3	5
21500563	45892894	3	4
21505735	967823	0	0
21604685	705944	3	3
35800000	378419	9	10
36208978	3049273	3	7
40779591	3001488	6	6
42802796	1124300	0	0
44363811	1129625	0	0
44345954	1545958	0	0
45652664	1127433	2	3
45646576	1124957	0	0
45656695	40229134	2	3
45659490	1125315	0	0
45653629	1115008	0	0
45666487	1125315	0	0
45658230	1310149	0	0
45689837	1124957	0	0
45685403	1149196	0	0
45707286	1107830	0	0
45786250	40229134	2	3
45690343	1119510	0	0
45681700	1589505	0	0
46242794	1713332	0	0
46288274	1545959	2	3
45791009	975125	0	0
45801650	1129625	0	0
45896009	738818	0	0
46312581	701322	0	0
46308490	705944	0	0
46306298	1125315	0	0
4155793	42535580	4	5
4054054	4134304	3	5
21503474	19077344	3	4
21505915	1119510	0	0
21601853	1545958	3	3
35800000	28060	8	9
36211303	4001336	4	7
36703532	380378	6	6
42802582	1738521	0	0
44363929	1129625	0	0
44345958	1129625	0	0
45655047	1115171	2	3
45646579	782043	0	0
45656794	19008572	2	3
45659701	1125315	0	0
45653727	1124957	0	0
45666548	1125315	0	0
45658173	1728416	0	0
45690017	1717327	0	0
45685232	1124957	0	0
45707254	1107830	0	0
45782906	19019979	2	3
45690387	1119510	0	0
45681702	1107830	0	0
46242801	1738521	0	0
46238467	19078461	2	3
45790801	715997	0	0
45795962	1129625	0	0
45896116	738818	0	0
46312591	1153428	0	0
46308714	1192710	0	0
46306244	1125315	0	0
4178818	28060	4	5
4042516	4301346	3	7
21503133	42707627	3	4
21505915	1192710	0	0
21601853	1539403	3	3
35800000	4001336	8	10
36502199	4059173	7	7
40796132	3026361	6	6
42803038	1322184	0	0
44363573	1129625	0	0
44345959	1115008	0	0
45655059	1115171	2	3
45646678	1153428	0	0
45656899	19133768	2	3
45659553	1125315	0	0
45653733	1310149	0	0
45666595	1125315	0	0
45658183	975125	0	0
45690018	1115008	0	0
45685243	1174888	0	0
45707108	1124957	0	0
45783017	40229134	2	3
45690492	1119510	0	0
45681794	1115008	0	0
46242983	1778162	0	0
46293150	1545959	2	3
45790741	1307863	0	0
45796169	1129625	0	0
45896167	738818	0	0
46312423	1149196	0	0
46308702	1192710	0	0
46306991	1125315	0	0
4178818	81893	4	5
4042516	44783196	3	6
21500201	19018935	3	4
21505921	1125315	0	0
21603932	1177480	3	3
35800000	81893	8	8
36502199	4066995	7	7
40796132	3010813	6	6
42802638	1501700	0	0
44363634	1129625	0	0
44345940	1192710	0	0
45655170	40229134	2	3
45646694	967823	0	0
45656753	40174880	2	3
45659557	1125315	0	0
45653636	708298	0	0
45666670	1125315	0	0
45658153	1115008	0	0
45689833	1539403	0	0
45685245	1545958	0	0
45707049	1107830	0	0
45782891	40162522	2	3
45690559	1119510	0	0
45681820	1551099	0	0
46242985	975125	0	0
45897993	1539411	2	3
45790876	1738521	0	0
45796378	1129625	0	0
45804104	738818	0	0
46312752	1729720	0	0
46308641	1149196	0	0
46306993	1125315	0	0
4041285	4056621	4	5
4213101	4048695	4	6
21500746	19079524	3	4
21505922	1192710	0	0
21603932	1124300	3	3
35800000	380378	8	8
36502199	4048695	7	7
36702242	4001336	6	6
42802725	1115008	0	0
44363639	1129625	0	0
44345940	1112807	0	0
45655327	40163554	2	3
45646433	1107830	0	0
45656762	1107882	2	3
45659853	1125315	0	0
45653525	1154029	0	0
45666729	1125315	0	0
45657891	967823	0	0
45689785	1521369	0	0
45685488	1107830	0	0
45707343	1501700	0	0
45782999	40229134	2	3
45690578	1119510	0	0
45681834	1738521	0	0
46242971	1326303	0	0
45792947	1332419	2	3
45790806	1713332	0	0
45796257	1129625	0	0
45804212	738818	0	0
46312327	1332418	0	0
46308647	975125	0	0
46306468	1125315	0	0
4103352	4294548	4	5
4275431	4057420	4	6
21503152	40232448	3	4
21505922	1174888	0	0
21603444	1153428	3	3
35800000	372328	8	8
36502199	4278672	7	7
37320108	133834	4	5
42802728	975125	0	0
44363736	1129625	0	0
44345969	19003953	0	0
45655445	19008572	2	3
45646606	1174888	0	0
45656943	43012036	2	3
45659855	1125315	0	0
45653745	738818	0	0
45666756	1125315	0	0
45658316	975125	0	0
45689785	1549786	0	0
45685493	1501700	0	0
45707427	1149196	0	0
45782992	1115171	2	3
45690515	1119510	0	0
45681862	1192710	0	0
46243068	1332418	0	0
46243331	1332419	2	3
45790827	1545958	0	0
45796212	1129625	0	0
45804189	738818	0	0
46312831	1192710	0	0
46308682	1545958	0	0
46306739	1125315	0	0
4103662	4001336	4	5
4042516	4058899	4	6
21503152	43012036	3	4
21505930	1177480	0	0
21603444	1192710	3	3
35800000	381316	8	8
36502199	81151	5	7
37520918	4198190	4	5
42803074	1713332	0	0
44363768	1129625	0	0
44341262	1177480	0	0
45655180	40232448	2	3
45646610	1332418	0	0
45656868	1332419	2	3
45659957	1125315	0	0
45653755	1713332	0	0
45666712	1125315	0	0
45658322	1153428	0	0
45689785	19127890	0	0
45685484	1154343	0	0
45707349	1545958	0	0
45783194	40232448	2	3
45690534	1119510	0	0
45681866	1115008	0	0
46242924	1112807	0	0
46296933	1332419	2	3
45790828	1174888	0	0
45796268	1129625	0	0
45799006	738818	0	0
46312780	1118084	0	0
46312351	1501700	0	0
46306230	1125315	0	0
4043022	4216130	4	5
4042504	4301346	4	6
21503152	19112599	3	4
21505930	1308738	0	0
21603444	1150836	3	3
35800000	4294548	8	11
36502199	40480160	5	7
37521809	4336464	4	5
42803074	1759842	0	0
44363769	1129625	0	0
44341385	1332418	0	0
45655183	40228214	2	3
45646620	1332418	0	0
45657034	1127433	2	3
45659769	1125315	0	0
45653755	1759842	0	0
45666867	1125315	0	0
45657903	1174888	0	0
45689786	1174888	0	0
45685441	933724	0	0
45707444	1149196	0	0
45783111	40229134	2	3
45687472	1119510	0	0
45681880	1000560	0	0
46242929	1110410	0	0
45897921	1332419	2	3
45790942	1551099	0	0
45796467	1129625	0	0
45799038	738818	0	0
46306913	1343916	0	0
46312352	1361711	0	0
46306606	1125315	0	0
4027403	4197460	4	5
4299602	4198190	4	5
21503083	920300	3	4
21505970	1154343	0	0
21603444	738818	3	3
35800000	4112343	8	11
36211303	4146173	5	7
36313967	4024958	4	5
42802914	1124957	0	0
44363986	1129625	0	0
44341010	1545958	0	0
45652824	40231925	2	3
45646718	1343916	0	0
45657079	40229134	2	3
45659779	1125315	0	0
45653761	1545958	0	0
45666972	1125315	0	0
45657923	1595799	0	0
45689896	1124300	0	0
45685599	1308738	0	0
45706869	1115008	0	0
45783458	40162522	2	3
45687562	1119510	0	0
45678508	1149196	0	0
46242931	1310149	0	0
46241650	1332419	2	3
45790945	1551099	0	0
45796430	1129625	0	0
45793548	738818	0	0
46306919	1343916	0	0
46312354	1124300	0	0
46317223	1125315	0	0
4027403	4337138	4	5
4040561	4198190	4	5
21503083	920334	3	4
21505971	1137529	0	0
21602722	975125	3	3
35800000	4156265	7	9
36211303	4278672	5	7
36903633	4043241	4	5
42803062	1759842	0	0
44356506	1129625	0	0
44341221	1129625	0	0
45652840	1127433	2	3
45646726	757627	0	0
45656994	19019273	2	3
45660042	1125315	0	0
45650086	1501700	0	0
45664267	1125315	0	0
45657923	1308738	0	0
45690026	1367571	0	0
45685609	705944	0	0
45706504	967823	0	0
45783077	1115171	2	3
45687280	1119510	0	0
45678608	1361711	0	0
46243069	1174888	0	0
46238639	40174880	2	3
45790890	914335	0	0
45790773	1129625	0	0
45793672	738818	0	0
46306960	1118084	0	0
46312357	1361711	0	0
46317310	1125315	0	0
4042836	40486433	4	5
4042505	4142905	4	5
21500620	19023398	3	4
21505972	1549786	0	0
21604181	19059528	3	3
35800000	4283893	7	9
36211303	4152936	5	7
36703532	44782520	4	5
42803062	1713332	0	0
44356509	1129625	0	0
44341222	1192710	0	0
45649544	19008572	2	3
45646704	1149380	0	0
45657112	19077344	2	3
45659799	1125315	0	0
45650101	967823	0	0
45664393	1125315	0	0
45658329	1192710	0	0
45690021	1149196	0	0
45680106	1343916	0	0
45706779	1713332	0	0
45783141	40229134	2	3
45687534	1119510	0	0
45678623	920293	0	0
46243071	1118084	0	0
46243349	1332419	2	3
45790897	723013	0	0
45790893	1129625	0	0
45793804	738818	0	0
46307029	1343916	0	0
46312428	1112807	0	0
46317460	1125315	0	0
4042836	4280726	4	5
4197094	4285898	4	5
21500620	782047	3	4
21505972	1548195	0	0
21604181	19002770	3	3
35800000	4218389	6	7
36211303	4059173	5	7
37103722	4056621	4	5
42802734	1778162	0	0
44356718	1129625	0	0
44341183	1713332	0	0
45649747	19059056	2	3
45646688	1115008	0	0
45657205	19008572	2	3
45659935	1125315	0	0
45650314	738818	0	0
45664537	1125315	0	0
45654634	1332418	0	0
45689876	1174888	0	0
45680224	1308738	0	0
45706754	1539403	0	0
45783140	40232448	2	3
45687453	1119510	0	0
45678712	1118084	0	0
46243041	1322184	0	0
46238551	1332419	2	3
45790952	1115008	0	0
45792013	1129625	0	0
45793666	738818	0	0
46307106	1589505	0	0
46311947	1551099	0	0
45876037	3035995	3	5
4042836	4294548	4	5
4247371	4156265	4	5
21500165	40174880	3	4
21505972	1512674	0	0
21603512	1150771	0	3
35800000	4084167	6	7
36502197	4146173	6	7
37522191	4108705	3	5
42802869	1738521	0	0
44356720	1129625	0	0
44341183	1759842	0	0
45649746	19019273	2	3
45646735	1549786	0	0
45653552	1127433	2	3
45656923	1125315	0	0
45650381	1717327	0	0
45664414	1125315	0	0
45654641	1107830	0	0
45689895	1115008	0	0
45680168	1154343	0	0
45706806	1738521	0	0
45783206	19133905	2	3
45687649	1119510	0	0
45678489	967823	0	0
46242812	1115008	0	0
45897837	1332419	2	3
45791002	1549786	0	0
45791189	1129625	0	0
45788176	738818	0	0
46307108	1124300	0	0
46311958	1713332	0	0
600000010	40163554	3	4
4042836	378419	4	5
4042504	4047491	4	5
21506150	19079524	3	4
21505795	1322184	0	0
21604191	782047	0	3
35800000	4027663	5	5
36502199	40479422	6	7
36902280	378419	3	5
42802684	975125	0	0
44356729	1129625	0	0
44341340	1177480	0	0
45649649	40232448	2	3
45646735	1521369	0	0
45653776	19008572	2	3
45656672	1125315	0	0
45650383	1153428	0	0
45664309	1125315	0	0
45654535	920293	0	0
45690150	1332418	0	0
45680053	791967	0	0
45706880	791967	0	0
45783206	19133873	2	3
45687716	1119510	0	0
45678590	1110410	0	0
46242744	1115008	0	0
46243254	1332419	2	3
45791002	1515774	0	0
46294895	1129625	0	0
45788306	738818	0	0
46307058	1551099	0	0
46311906	1500211	0	0
600000007	40173590	3	4
4042836	4001336	4	5
4279903	4330583	4	4
21506220	19078461	3	4
21503939	975125	0	0
21604192	19023423	0	3
35800000	40480160	5	5
36502199	4237458	6	7
37320122	134438	2	5
42803013	1129625	0	0
44357012	1129625	0	0
44341241	1118084	0	0
45649950	1107882	2	3
45646768	1713332	0	0
45653253	19019273	2	3
45656693	1125315	0	0
45650337	708298	0	0
45664544	1125315	0	0
45654665	1124957	0	0
45689956	1361711	0	0
45680317	1738521	0	0
45706510	1102527	0	0
45783212	19019273	2	3
45687720	1119510	0	0
45678592	1110410	0	0
46242815	914335	0	0
45801097	1332419	2	3
45791002	19127890	0	0
46294906	1129625	0	0
45788684	738818	0	0
46307110	1124957	0	0
46308816	1118084	0	0
500000301	198809	4	4
4042836	4043241	6	7
4054054	78272	4	4
21506220	19019979	3	4
21503948	1107830	0	0
21604193	19023398	0	3
35800000	4066995	5	5
36502199	40479768	6	7
36702253	4066995	3	7
42803026	1545958	0	0
44357074	1129625	0	0
44338783	1521369	0	0
45649879	19123231	2	3
45646768	1759842	0	0
45653652	40228230	2	3
45656695	1125315	0	0
45650273	1149196	0	0
45778333	1125315	0	0
45654656	1107830	0	0
45689814	1713332	0	0
45680087	1149196	0	0
45706516	1551099	0	0
45780575	40232448	2	3
45687747	1119510	0	0
45678514	1107830	0	0
46242817	1124957	0	0
46238412	1545959	2	3
45791003	1361711	0	0
46294263	1129625	0	0
46289859	738818	0	0
46311831	701322	0	0
46308829	1738521	0	0
500000301	196456	3	3
4180628	378419	6	7
4297887	440448	4	4
21506220	19019273	3	4
21503948	1150836	0	0
21603513	1150837	0	3
21604180	1127433	4	7
36502199	4142905	6	7
36700000	4029498	3	7
44344770	1129625	0	0
44357130	1129625	0	0
44338783	1549786	0	0
45649821	1107882	2	3
45646772	1149196	0	0
45653783	40232448	2	3
45656899	1125315	0	0
45650274	1124957	0	0
45778053	1125315	0	0
45654295	1154343	0	0
45689939	1738521	0	0
45680128	738818	0	0
45706686	1539403	0	0
46244726	19008572	2	3
45684246	1119510	0	0
45678439	1192710	0	0
46243095	1112807	0	0
46241283	1545959	2	3
45791026	1149196	0	0
46296634	1129625	0	0
46289865	738818	0	0
46311833	975125	0	0
46308851	1305058	0	0
600000005	19057271	3	4
4178545	4048171	6	7
4215793	4337138	4	4
21506220	1115171	3	4
21503953	708298	0	0
21603525	40223834	0	3
21604180	19023423	4	7
36211303	4048695	6	7
37502353	4107731	3	7
44345074	1129625	0	0
44350112	1129625	0	0
44338667	1124957	0	0
45649635	19123231	2	3
45646756	715997	0	0
45653812	40223834	2	3
45656751	1125315	0	0
45650279	1545958	0	0
45778324	1125315	0	0
45654463	753626	0	0
45689960	1332418	0	0
45680129	1154343	0	0
45704257	1308738	0	0
46244684	19008572	2	3
45684379	1119510	0	0
45678444	1107830	0	0
46242782	1154343	0	0
46238444	1545959	2	3
45791029	1713332	0	0
46244109	1129625	0	0
46290333	738818	0	0
46312044	975125	0	0
46303398	933724	0	0
600000005	19076374	3	4
4028071	4166224	6	7
4300157	40480160	4	4
21500215	40171902	3	3
21503929	1124300	0	0
21603525	40223821	0	3
21604180	19123231	4	7
36211303	4066995	6	7
37303796	4296204	3	7
44344875	967823	0	0
44349757	1129625	0	0
44338725	1115008	0	0
45649849	40174880	2	3
45646775	1153428	0	0
45653820	19008572	2	3
45656710	1125315	0	0
45650138	738818	0	0
45778246	1125315	0	0
45654589	1124300	0	0
45689960	1545958	0	0
45680237	1551099	0	0
45704260	1501700	0	0
46244687	1127433	2	3
45681444	1119510	0	0
45678472	933724	0	0
46242783	1192710	0	0
46243554	1545959	2	3
45791029	1759842	0	0
46244224	1129625	0	0
46241955	738818	0	0
46312045	1305058	0	0
46303763	1192710	0	0
46307705	19075601	2	3
4029205	4024289	6	7
4300157	4278672	4	4
21500216	40171902	3	3
21503948	1153428	0	0
21602842	19133905	0	3
21604180	19057271	4	7
36211303	4237458	6	7
37320122	133834	4	7
44344880	1115008	0	0
44349976	1129625	0	0
44338668	1149380	0	0
45649862	19008572	2	3
45643442	1124300	0	0
45653821	1551192	2	3
45656770	1125315	0	0
45650413	1102527	0	0
45778101	1125315	0	0
45654591	1501700	0	0
45690132	967823	0	0
45680240	1361711	0	0
45704206	1000560	0	0
45778126	40229134	2	3
45681473	1119510	0	0
45678475	914335	0	0
46243102	705944	0	0
46288949	1539411	2	3
45792004	1124957	0	0
46244372	1129625	0	0
46241965	738818	0	0
46307150	967823	0	0
46303350	975125	0	0
46302465	19075601	2	3
4180628	375671	6	8
4300157	4066995	4	4
21506173	1332418	3	3
21503948	1150770	0	0
21603462	43012036	0	3
21604180	35605858	6	7
35707763	440448	3	8
36702239	4043241	7	7
44344946	1177480	0	0
44350005	1129625	0	0
44338670	1112807	0	0
45649735	40228230	2	3
45643447	1713332	0	0
45653836	1154615	2	3
45656947	1125315	0	0
45650112	1149196	0	0
45660965	1125315	0	0
45654700	1110410	0	0
45690140	1174888	0	0
45680090	738818	0	0
45704276	738818	0	0
45778079	19008572	2	3
45681294	1119510	0	0
45678570	1310149	0	0
46242790	757627	0	0
45895389	1539411	2	3
45791875	1589505	0	0
46239164	1129625	0	0
46241968	738818	0	0
46307156	1107830	0	0
46303309	1309944	0	0
46302504	19075601	2	3
4043018	4198190	6	8
4300157	40479422	4	4
21506173	1307863	3	3
21503951	19002770	0	0
21603462	19112599	0	3
4201745	81893	4	9
36402192	4144583	8	8
36702242	375671	7	7
44345101	1124300	0	0
44349943	1129625	0	0
44338702	1589505	0	0
45649931	1107882	2	3
45643447	1759842	0	0
45653479	40163554	2	3
45657034	1125315	0	0
45650418	1367571	0	0
45660978	1125315	0	0
45654703	1174888	0	0
45690114	723013	0	0
45680093	1115008	0	0
45704285	738818	0	0
46244647	1127433	2	3
45681104	1119510	0	0
45678574	1174888	0	0
46240492	1332418	0	0
46243470	1539411	2	3
45791877	1549786	0	0
46239339	1129625	0	0
46242016	738818	0	0
46307280	1713332	0	0
46303312	1112807	0	0
45799670	19075601	2	3
4047779	4134304	6	10
4043671	4048171	4	4
21503193	1713671	3	3
21503951	782043	0	0
21603514	19125062	0	3
4201745	440448	4	7
36400000	439777	6	8
36702242	378001	7	7
44345188	975125	0	0
44349950	1129625	0	0
44338702	1549786	0	0
45649721	40223834	2	3
45643581	1124300	0	0
45653629	19019273	2	3
45656717	1125315	0	0
45650345	1778162	0	0
45661832	1125315	0	0
45654603	1115008	0	0
45690119	708298	0	0
45680094	1124300	0	0
45704287	1124957	0	0
46244705	19078461	2	3
45681436	1119510	0	0
45678576	1746114	0	0
46240496	1545958	0	0
46243537	19128263	1	2
45791877	19127890	0	0
46239345	1129625	0	0
46242234	738818	0	0
46307337	1174888	0	0
46303268	1112807	0	0
45796610	19075601	2	3
4047779	4166224	6	9
4186164	4134304	4	4
21500154	1539403	3	3
21503951	19039298	0	0
21603514	1107882	0	3
4201745	4166224	4	7
36211303	375671	5	8
37302325	4048695	6	7
44344957	1713332	0	0
44350207	1129625	0	0
44338707	1149380	0	0
45649934	19073183	2	3
45643603	1545958	0	0
45653637	19008572	2	3
45657079	1125315	0	0
45650491	715997	0	0
45661649	1125315	0	0
45654718	1738521	0	0
45689964	1501700	0	0
45680295	738818	0	0
45704187	1124300	0	0
46244628	40163554	2	3
45681612	1119510	0	0
45678577	1343916	0	0
46240587	1332418	0	0
45885353	4059173	1	2
45791877	1512674	0	0
46239583	1129625	0	0
46242182	738818	0	0
46307338	791967	0	0
46303437	1738521	0	0
46300396	1545959	2	3
4047779	375671	6	9
4043346	258780	4	4
21501117	967823	3	3
21503955	1154029	0	0
21602823	19073188	0	3
4227253	81893	7	8
36211303	378001	5	8
36900000	4043241	4	8
44344797	1129625	0	0
44350130	1129625	0	0
44338712	1539403	0	0
45649777	1127433	2	3
45643605	1521369	0	0
45653745	40229134	2	3
45657001	1125315	0	0
45650497	1174888	0	0
45661377	1125315	0	0
45654411	1713332	0	0
45690041	1501700	0	0
45680380	1115008	0	0
45704326	723013	0	0
46240377	40232448	2	3
45681539	1119510	0	0
45678710	933724	0	0
46240591	975125	0	0
45885353	4278672	1	2
45791885	1115008	0	0
46239652	1129625	0	0
46242185	738818	0	0
46307166	1343916	0	0
46303440	1521369	0	0
46319141	19075601	2	3
4178818	4294548	6	6
4043346	317576	4	4
21500617	782043	3	3
21503956	1154029	0	0
21603497	40228214	0	3
4227253	4285898	6	7
36211303	81151	6	8
36702242	4043241	7	8
44344798	738818	0	0
44350146	1129625	0	0
44338887	967823	0	0
45646309	19019273	2	3
45643605	1549786	0	0
45650141	19008572	2	3
45657006	1125315	0	0
45650499	1713332	0	0
45661767	1125315	0	0
45654417	1310149	0	0
45689976	1307863	0	0
45680568	1549786	0	0
45704328	1501700	0	0
46240217	19059056	2	3
45681606	1119510	0	0
45678579	1192710	0	0
46240553	1118084	0	0
45803566	19127922	1	2
45791888	1367571	0	0
46239727	1129625	0	0
46242309	738818	0	0
46307411	738818	0	0
46303440	1549786	0	0
45894675	19078461	2	3
4178818	260139	6	6
4040559	4242997	4	4
21500617	19002770	3	3
21503947	1149196	0	0
21603497	40228230	0	3
35802131	4043241	10	11
36211303	4230399	6	8
37200000	313217	7	8
44345008	1129625	0	0
44364124	1129625	0	0
44338894	1110410	0	0
45646323	40232448	2	3
45643605	1595799	0	0
45650138	40229134	2	3
45657271	1125315	0	0
45650511	1515774	0	0
45661109	1125315	0	0
45654672	975125	0	0
45690062	1149196	0	0
45680568	1515774	0	0
45704212	1501700	0	0
46240307	43012036	2	3
45679754	1119510	0	0
45678684	1308738	0	0
46240669	1124300	0	0
45803566	19133679	1	2
45791854	1110410	0	0
46239615	1129625	0	0
46241988	738818	0	0
46307231	1332418	0	0
46303451	1738521	0	0
46300214	1539411	2	3
4043022	4163971	6	6
4042505	4059173	5	5
21500617	753626	3	3
21503932	1343916	0	0
35202455	313217	1	3
21502709	1150771	9	10
36211303	4134304	6	9
36700000	381316	3	8
44344773	1115008	0	0
44364188	1129625	0	0
44338649	1129625	0	0
45646327	40232448	2	3
45643448	1713332	0	0
45650349	40232448	2	3
45656850	1125315	0	0
45650511	1549786	0	0
45661146	1125315	0	0
45654673	975125	0	0
45690097	1107830	0	0
45680568	19127890	0	0
45704213	1107830	0	0
46240431	40236446	2	3
45679577	1119510	0	0
45678546	740275	0	0
46240670	1115008	0	0
45803566	19129144	1	2
45791898	1107830	0	0
46239735	1129625	0	0
46242288	738818	0	0
46307234	1115008	0	0
46303452	1174888	0	0
45796739	40228214	2	3
4043022	4078793	6	6
4300157	4230399	5	5
21500617	19039298	3	3
21504550	1124300	0	0
35202050	313217	2	4
21502709	1150837	9	10
36211303	78272	5	9
36700000	380378	3	8
44344986	1112807	0	0
44356898	1129625	0	0
44338766	914335	0	0
45646367	40232448	2	3
45643460	1149380	0	0
45650514	40236446	2	3
45653557	1125315	0	0
45650511	19127890	0	0
45661148	1125315	0	0
45654677	1149196	0	0
45690462	967823	0	0
45680180	1310149	0	0
45704290	738818	0	0
46240091	19059056	2	3
45678085	1119510	0	0
45678554	975125	0	0
46240568	1738521	0	0
45892893	45892894	1	1
45791931	1396131	0	0
45895940	1129625	0	0
45893603	738818	0	0
46307235	738818	0	0
46303097	1124957	0	0
46300839	1539411	2	3
4040392	4275113	6	6
4214956	4163874	5	5
21500617	1154029	3	3
21504027	1112807	0	0
21602496	43012433	3	4
21502709	1107882	9	10
35707763	4285898	3	9
37000000	195588	3	8
44345104	1112807	0	0
44356899	1129625	0	0
44338768	1308738	0	0
45646375	40163554	2	3
45643562	1149196	0	0
45650174	40163554	2	3
45653560	1125315	0	0
45650512	1713332	0	0
45661130	1125315	0	0
45654543	1154029	0	0
45690244	738818	0	0
45680407	1713332	0	0
45704226	738818	0	0
46240451	19133905	2	3
45678161	1119510	0	0
45678556	1154343	0	0
46240714	1124300	0	0
45796433	19129144	1	1
45791864	1549786	0	0
45895948	1129625	0	0
45799173	738818	0	0
46307236	738818	0	0
46303115	1174888	0	0
46319060	1539411	2	3
4103352	4048171	6	6
4247371	378419	5	6
21500617	708298	3	3
21504028	1125315	0	0
21604208	40220386	3	4
21502549	19133905	8	9
36426817	1110410	0	0
36303153	192671	3	8
44345106	1115008	0	0
44357137	1129625	0	0
44338899	1589505	0	0
45649002	19018935	2	3
45643251	1500211	0	0
45650187	40223834	2	3
45653552	1125315	0	0
45650512	1759842	0	0
45661186	1125315	0	0
45654547	1107830	0	0
45689982	933724	0	0
45680411	1557272	0	0
45704296	1174888	0	0
46240362	40229134	2	3
45678165	1119510	0	0
45678650	1149196	0	0
46240663	1112807	0	0
45796433	19127922	1	1
45791864	1595799	0	0
45895949	1129625	0	0
45799194	738818	0	0
46307241	1192710	0	0
46303722	1192710	0	0
46302788	40228214	2	3
4043017	4323902	6	6
4040559	4198190	5	6
21503134	1125315	3	3
21504552	1308738	0	0
21603396	19133768	3	4
21502549	19073183	8	9
36425574	975125	0	0
36300000	4012477	3	8
44345112	738818	0	0
44357056	1129625	0	0
44338730	1741122	0	0
45649107	1107882	2	3
45643565	1332418	0	0
45650356	19074679	2	3
45653224	1125315	0	0
45650514	705944	0	0
45661113	1125315	0	0
45654550	1717327	0	0
45689988	975125	0	0
45680392	1322184	0	0
45704297	1713332	0	0
46240374	40232448	2	3
45678292	1119510	0	0
45678776	1149196	0	0
46240742	1322184	0	0
45796433	19133679	1	1
45791864	1521369	0	0
45896137	1129625	0	0
45799354	738818	0	0
46307247	1343916	0	0
46303723	1310149	0	0
45799657	40228214	2	3
4043017	4337611	6	6
4042505	4134304	5	7
21503134	1112807	3	3
21500003	1717327	0	0
21602472	42902245	4	4
1717327	1717327	0	0
36500000	4134304	6	11
36703532	378419	7	8
44345009	738818	0	0
44356915	1129625	0	0
44338730	1746114	0	0
45646498	782047	2	3
45643668	1115008	0	0
45650630	19059056	2	3
45653385	1125315	0	0
45650397	1326303	0	0
45661453	1125315	0	0
45654552	1115008	0	0
45689994	1713332	0	0
45680468	1595799	0	0
45704297	1759842	0	0
46242385	1127433	2	3
45678294	1119510	0	0
45678660	1124300	0	0
46240743	1501700	0	0
45790741	40171902	1	1
45791871	1174888	0	0
45896184	1129625	0	0
45794130	738818	0	0
46307249	1741122	0	0
46303162	1153428	0	0
46312423	40228214	2	3
4028071	258780	6	6
4040551	4336464	5	7
21500205	1361711	3	3
21500002	1728416	0	0
21602472	19128022	4	4
1728416	1728416	0	0
36502199	4134304	5	9
37502353	4242997	7	8
44345010	1129625	0	0
44357111	1129625	0	0
44338899	1549786	0	0
45646472	19073183	2	3
45643708	1153428	0	0
45647250	1551192	2	3
45653782	1125315	0	0
45650429	1548195	0	0
45777849	1125315	0	0
45654710	914335	0	0
45689994	1759842	0	0
45680468	1549786	0	0
45704420	1174888	0	0
46242462	40223768	2	3
45678250	1119510	0	0
45678664	1545958	0	0
46240736	1124300	0	0
46294933	40220386	1	1
45792063	1738521	0	0
45896651	1129625	0	0
45794202	738818	0	0
46307174	1310149	0	0
46303378	1521369	0	0
46295417	40228214	2	3
4047779	4144583	6	6
4247371	4294548	5	7
21500164	1501700	3	3
21500003	1713332	0	0
21602472	19128009	4	4
4056621	4056621	0	0
36502199	78272	4	8
36702247	378001	6	9
44345022	1500211	0	0
44357119	1129625	0	0
44338676	1149196	0	0
45646568	43012036	2	3
45643779	1551099	0	0
45647302	19133768	2	3
45653823	1125315	0	0
45650174	1310149	0	0
45777823	1125315	0	0
45654714	975125	0	0
45690103	1154343	0	0
45680468	1521369	0	0
45704255	1154343	0	0
46242471	19059056	2	3
45678395	1119510	0	0
45678667	1124957	0	0
46240704	1107830	0	0
46299010	19079524	1	1
45792042	1717327	0	0
45896749	1129625	0	0
45788822	738818	0	0
46307194	1115008	0	0
46303382	1112807	0	0
46318351	40228214	2	3
4047779	4027663	6	6
4274025	313217	7	10
21500594	1124300	3	3
21500005	1746114	0	0
21602472	19127918	4	4
4057420	4057420	0	0
36502199	4230399	8	8
36703532	378001	7	9
44345024	1112807	0	0
44358638	1129625	0	0
44338678	1129625	0	0
45646561	1107882	2	3
45643816	1149196	0	0
45647266	40229134	2	3
45653831	1125315	0	0
45650552	1713332	0	0
45654754	1125315	0	0
45655509	1367571	0	0
45690064	1149196	0	0
45680471	1192710	0	0
45704256	708298	0	0
46240496	1545959	2	3
45678499	1119510	0	0
45678676	1308738	0	0
45681062	738818	0	0
46298553	19079524	1	1
45792068	975125	0	0
45804369	1129625	0	0
45788906	738818	0	0
46307291	1549786	0	0
46303134	1738521	0	0
45894262	40223768	2	3
4043018	4163971	6	6
4339410	4134304	7	7
21500594	1129625	3	3
21500002	1729720	0	0
21602472	19128263	4	4
4142905	4142905	0	0
36502197	4237458	6	8
36702253	378419	8	9
44345031	1308738	0	0
44358835	1129625	0	0
44338736	1174888	0	0
45646458	40232448	2	3
45643321	1332418	0	0
45647165	19077572	2	3
45653555	1125315	0	0
45650246	1110410	0	0
45654850	1125315	0	0
45655484	1545958	0	0
45690068	1713332	0	0
45680478	1153428	0	0
45704364	1500211	0	0
46240515	40232448	2	3
45678335	1119510	0	0
45678887	1322184	0	0
45675832	738818	0	0
46242477	19115351	1	1
45791043	1548195	0	0
45804343	1129625	0	0
45788869	738818	0	0
46307291	1521369	0	0
46303816	1112807	0	0
45799828	1539411	2	3
4043016	4107731	6	6
19057271	19057271	0	0
21500594	1118084	3	3
21500012	1778162	0	0
21603931	1118084	4	4
4145310	4145310	0	0
36424688	44816277	2	3
36702253	4001336	7	9
44345036	1129625	0	0
44357394	1129625	0	0
44338737	1501700	0	0
45646633	19078924	2	3
45643373	1154029	0	0
45649205	19073183	2	3
45653804	1125315	0	0
45641900	1125315	0	0
45654883	1125315	0	0
45655445	975125	0	0
45690068	1759842	0	0
45680185	1107830	0	0
45704474	1738521	0	0
46240516	40232448	2	3
45678357	1119510	0	0
45678875	1192710	0	0
45675909	738818	0	0
45896285	19074679	1	1
45791044	967823	0	0
45804382	1129625	0	0
46295245	738818	0	0
46307429	1309944	0	0
46303692	1308738	0	0
45802028	40228214	2	3
4042641	4108705	6	6
19059056	19059056	0	0
21500657	1125315	3	3
21500012	1768849	0	0
21603931	1115008	4	4
4202451	4202451	0	0
36424688	43012433	2	3
37200000	257012	3	9
44344935	742185	0	0
44353898	1129625	0	0
44338740	1729720	0	0
45646579	782047	2	3
45643737	1501700	0	0
45648859	19018935	2	3
45653833	1125315	0	0
45641905	1125315	0	0
45634985	1119510	0	0
45655028	1115008	0	0
45690078	1124957	0	0
45680484	1115008	0	0
45704475	1115008	0	0
45703170	40232448	2	3
45674935	1119510	0	0
45678879	1713332	0	0
45673051	738818	0	0
46299021	19079524	1	1
45791062	1107830	0	0
45804330	1129625	0	0
46295351	738818	0	0
46307432	1124300	0	0
46303818	1738521	0	0
45799300	19078461	2	3
4157607	44782520	1	1
4337138	4337138	0	0
21500657	1308738	3	3
21005673	1310149	0	0
21603931	1557272	4	4
4202832	4202832	0	0
36424689	44816277	2	3
36303153	196456	4	10
44344975	738818	0	0
44354151	1129625	0	0
44338900	1713332	0	0
45646688	19019273	2	3
45643723	1153428	0	0
45648822	40236446	2	3
45653619	1125315	0	0
45641912	1125315	0	0
45635093	1119510	0	0
45654729	791967	0	0
45690185	1551099	0	0
45680244	1539403	0	0
45704487	1545958	0	0
45703223	40174880	2	3
45674858	1119510	0	0
45678895	975125	0	0
45673228	738818	0	0
46299021	46275916	1	1
45791068	1322184	0	0
45796407	1129625	0	0
46244325	738818	0	0
46307364	1115008	0	0
46303736	1501700	0	0
45796734	40228214	2	3
4163273	4330583	1	1
4337611	4337611	0	0
21601077	1308738	3	3
21005678	1713332	0	0
21603931	1177480	4	4
21505925	1343916	0	0
36424689	43012433	2	3
36700000	378419	3	10
44344890	1129625	0	0
44354132	1129625	0	0
44338656	705944	0	0
45646704	40169216	2	3
45643730	1548195	0	0
45649023	40236824	2	3
45653720	1125315	0	0
45642072	1125315	0	0
45635057	1119510	0	0
45654747	1361711	0	0
45690253	1107830	0	0
45680258	738818	0	0
45704492	723013	0	0
45703230	1545959	2	3
45675293	1119510	0	0
45678825	723013	0	0
45784743	738818	0	0
46294371	19079524	1	1
45791082	967823	0	0
45797282	1129625	0	0
46244337	738818	0	0
46307973	920293	0	0
46303646	975125	0	0
45794004	40228214	2	3
4134145	44782520	1	1
4218389	4218389	0	0
21601077	1396131	3	3
21006763	1396131	0	0
35202051	4324181	4	4
21506022	914335	0	0
36427086	964261	2	3
36703532	4043241	9	10
44345051	1192710	0	0
44354235	1129625	0	0
44338659	1107830	0	0
45646775	40223834	2	3
45643783	1738521	0	0
45648872	19059056	2	3
45653628	1125315	0	0
45641919	1125315	0	0
45635151	1119510	0	0
45654764	1595799	0	0
45690110	1115008	0	0
45680497	1174888	0	0
45704503	738818	0	0
45703240	1551192	2	3
45675294	1119510	0	0
45678908	975125	0	0
45784855	738818	0	0
45875979	3011505	1	1
45791109	1000560	0	0
45796485	1129625	0	0
46244558	738818	0	0
46307361	1738521	0	0
46303683	1332418	0	0
46302691	19079524	2	3
4116976	4306014	1	1
4218408	4218408	0	0
21001775	738818	0	0
21006763	1308738	0	0
35202051	317009	4	4
21502734	1309944	0	0
36427078	19126352	2	3
36702247	4043241	8	10
44345037	1174888	0	0
44350314	1129625	0	0
44338859	1308738	0	0
45643464	40228214	2	3
45643784	1307863	0	0
45649175	40228214	2	3
45653630	1125315	0	0
45642038	1125315	0	0
45630110	1119510	0	0
45654867	1149196	0	0
45690111	967823	0	0
45680498	1174888	0	0
45704511	1149380	0	0
45703275	1154615	2	3
45674865	1119510	0	0
45678718	1149196	0	0
45784871	738818	0	0
45875977	40769184	1	1
45791099	1500211	0	0
45796595	1129625	0	0
46244596	738818	0	0
46307425	1713332	0	0
46303690	975125	0	0
46313224	40228214	2	3
4116976	4302207	1	1
21000890	1713332	0	0
21001775	967823	0	0
21008439	1551099	0	0
21605007	1149196	4	4
21502741	1738521	0	0
36427229	35605482	2	3
36700000	375671	3	11
44344916	1124300	0	0
44350245	1129625	0	0
44338860	1124300	0	0
45643565	1332419	2	3
45643483	1322184	0	0
45647309	1545959	2	3
45653745	1125315	0	0
45641755	1125315	0	0
45630143	1119510	0	0
45654870	1192710	0	0
45690257	1738521	0	0
45680501	1549786	0	0
45704512	1124957	0	0
45703348	40162522	2	3
45675211	1119510	0	0
45678826	1310149	0	0
45785016	738818	0	0
45875977	40769189	1	1
45791100	967823	0	0
45796656	1129625	0	0
45787711	1177480	0	0
46307425	1759842	0	0
46303692	1595799	0	0
46312074	1539411	2	3
4108467	4296204	1	1
21000890	1746114	0	0
21001775	1125315	0	0
21008461	738818	0	0
21605007	1129625	4	4
21502752	1548195	0	0
36416791	19078924	2	3
36700000	378001	6	11
44344917	1551099	0	0
44350491	1129625	0	0
44338865	1153428	0	0
45643723	40223834	2	3
45643375	1149196	0	0
45647406	1115171	2	3
45653767	1125315	0	0
45641955	1125315	0	0
45630099	1119510	0	0
45654815	967823	0	0
45690268	1501700	0	0
45680501	1521369	0	0
45704356	920293	0	0
45703491	40229134	2	3
45675258	1119510	0	0
45678926	1539403	0	0
45785161	738818	0	0
45875977	40769194	1	1
45791048	1738521	0	0
45791489	1129625	0	0
45787690	1177480	0	0
46307426	1361711	0	0
46303176	1332418	0	0
46307371	1539411	2	3
4189601	4010253	1	1
21000802	975125	0	0
21001775	1150836	0	0
21008225	1713332	0	0
21605007	738818	4	4
21502752	1512674	0	0
36427387	19045231	2	3
36702253	4043241	10	11
44345130	1192710	0	0
44350365	1129625	0	0
44338973	1149196	0	0
45643518	40232448	2	3
45643494	1149380	0	0
45644362	1115171	2	3
45650222	1125315	0	0
45642046	1125315	0	0
45630025	1119510	0	0
45654816	1343916	0	0
45690203	1174888	0	0
45680365	1115008	0	0
45704357	1307863	0	0
45703472	40229134	2	3
45674869	1119510	0	0
45672501	1778162	0	0
45784952	738818	0	0
45875977	40769179	1	1
45791104	1551099	0	0
46298674	1129625	0	0
45787591	1177480	0	0
46307590	1717327	0	0
46303878	1174888	0	0
45791792	40228214	2	3
4189847	4117038	1	1
21000803	1595799	0	0
21001791	975125	0	0
21008225	1759842	0	0
21605007	1154343	4	4
21503001	1129625	0	0
36226536	19127904	2	3
37502353	4336464	7	11
44345132	1110410	0	0
44346772	1129625	0	0
44339049	1107830	0	0
45646062	40228214	2	3
45643790	1115008	0	0
45644457	19008572	2	3
45650225	1125315	0	0
45642054	1125315	0	0
45630275	1119510	0	0
45654817	1501700	0	0
45690204	1124957	0	0
45680366	738818	0	0
45700959	967823	0	0
45703330	40165015	2	3
45675205	1119510	0	0
45672507	1548195	0	0
45784843	738818	0	0
45875977	40766240	1	1
45791096	1115008	0	0
46298689	1129625	0	0
45787767	1177480	0	0
46307593	738818	0	0
46303989	1551099	0	0
46318040	19078461	2	3
4164337	4285898	1	1
21000890	1759842	0	0
21001778	967823	0	0
21008226	1713332	0	0
21605007	1174888	4	4
21502752	1549786	0	0
36424575	1594382	2	3
37522270	4323902	2	6
44344922	1548195	0	0
44346776	1129625	0	0
44339050	738818	0	0
45640509	19077572	2	3
45643624	723013	0	0
45644289	40165015	2	3
45650314	1125315	0	0
45638735	1125315	0	0
45630167	1119510	0	0
45654823	723013	0	0
45690161	1309944	0	0
45680376	1589505	0	0
45700961	1115008	0	0
45700402	40229134	2	3
45675264	1119510	0	0
45672404	1149196	0	0
45785220	738818	0	0
45875996	3006734	1	1
46294692	1332418	0	0
46298517	1129625	0	0
45801234	1177480	0	0
46307598	975125	0	0
46304006	1589505	0	0
46302099	19079524	2	3
4159963	195588	1	1
21000890	1741122	0	0
21001797	1778162	0	0
21008226	1759842	0	0
21605007	1149380	4	4
21502759	1501700	0	0
36423360	19074679	2	3
37522270	4117038	2	6
44345338	1137529	0	0
44346593	1129625	0	0
44338953	1759842	0	0
45640779	43012036	2	3
45643406	1738521	0	0
45644510	19057271	2	3
45650165	1125315	0	0
45638726	1125315	0	0
45630258	1119510	0	0
45654824	975125	0	0
45686952	1308738	0	0
45680376	1549786	0	0
45700802	753626	0	0
45700114	1127433	2	3
45675266	1119510	0	0
45672620	19127890	0	0
45785228	738818	0	0
45875996	3000876	1	1
46294744	1343916	0	0
46298724	1129625	0	0
45795769	1177480	0	0
46307305	757627	0	0
46304015	1192710	0	0
46312664	19078461	2	3
4159963	198199	1	1
21000874	975125	0	0
21001797	1759842	0	0
21008236	1759842	0	0
21605007	1137529	4	4
21502747	1545958	0	0
36427076	920300	2	3
37522270	4057420	4	7
44345338	1149380	0	0
44346805	1129625	0	0
44339075	1129625	0	0
45640889	1713671	2	3
45643412	1124300	0	0
45644424	40224805	2	3
45650267	1125315	0	0
45638922	1125315	0	0
45630335	1119510	0	0
45651176	1115008	0	0
45686954	1551099	0	0
45680344	1174888	0	0
45700874	1107830	0	0
45700309	40232448	2	3
45671909	1119510	0	0
45672620	1549786	0	0
45785074	738818	0	0
45875996	3021226	1	1
46294749	1000560	0	0
46298991	1129625	0	0
45795857	1177480	0	0
46307307	975125	0	0
46303903	1118084	0	0
45794277	19078461	2	3
4080926	133834	1	1
21000873	1551099	0	0
21001797	1746114	0	0
21008236	1713332	0	0
21605007	1107830	4	4
21502747	1539403	0	0
36427076	920334	2	3
37522270	44783196	4	5
44345240	1192710	0	0
44346742	1129625	0	0
44338981	1549786	0	0
45640847	1713671	2	3
45643749	738818	0	0
45641444	43012036	2	3
45650274	1125315	0	0
45638923	1125315	0	0
45630354	1119510	0	0
45651199	1738521	0	0
45686724	1738521	0	0
45680367	1501700	0	0
45700885	1717327	0	0
45700502	40232448	2	3
45672327	1119510	0	0
45672626	1154343	0	0
45786482	738818	0	0
45875996	3001488	1	1
46294092	975125	0	0
46299011	1129625	0	0
45795974	1177480	0	0
46307201	1501700	0	0
46303388	1551099	0	0
46307480	19078461	2	3
4082382	4326177	1	1
21000907	1310149	0	0
21001796	1728416	0	0
21011415	1110410	0	0
21602359	1519936	4	4
21600317	1361711	0	0
36424251	19018935	2	3
37522270	4337611	4	5
44344925	1332418	0	0
44346288	1129625	0	0
44338981	1521369	0	0
45640868	782047	2	3
45643509	1717327	0	0
45641413	1127433	2	3
45650276	1125315	0	0
45638762	1125315	0	0
45627107	1119510	0	0
45651367	738818	0	0
45686797	1153428	0	0
45680368	1713332	0	0
45700981	967823	0	0
45700349	1154615	2	3
45672550	1119510	0	0
45672531	1310149	0	0
45786250	738818	0	0
45875996	3023430	1	1
46294093	1310149	0	0
46299224	1129625	0	0
45795874	1177480	0	0
46307203	1192710	0	0
46303389	1153428	0	0
46299723	19078461	2	3
4083499	4078793	1	1
21001351	1343916	0	0
21001775	1174888	0	0
21011420	1343916	0	0
21602359	1500211	4	4
21604214	753626	0	0
36302180	4133840	2	3
36700000	4043241	5	12
44344928	1124957	0	0
44346601	1129625	0	0
44338745	1124957	0	0
45640997	40231925	2	3
45643512	1124957	0	0
45641650	40232448	2	3
45650138	1125315	0	0
45638771	1125315	0	0
45627109	1119510	0	0
45651215	1115008	0	0
45686956	1332418	0	0
45680368	1759842	0	0
45700689	740275	0	0
45700257	19018935	2	3
45672276	1119510	0	0
45672540	920293	0	0
45782873	738818	0	0
45875996	3019406	1	1
46294096	1000560	0	0
46291664	1129625	0	0
45795954	1177480	0	0
46307203	1174888	0	0
46301035	1361711	0	0
46302164	19078461	2	3
4190759	4163872	1	1
21001355	975125	0	0
21001775	1107830	0	0
21011856	1713332	0	0
21602359	19054876	4	4
1713671	1713671	0	0
36225403	19128065	2	3
36700000	4001336	5	10
44345245	1115008	0	0
44348579	1129625	0	0
44338908	1112807	0	0
45640998	40223834	2	3
45643763	1549786	0	0
44340904	1115008	0	0
45650493	1125315	0	0
45638892	1125315	0	0
45627363	1119510	0	0
45651164	19010482	0	0
45686949	708298	0	0
45680373	738818	0	0
45701069	1149196	0	0
45896820	40162522	2	3
45672594	1119510	0	0
45672543	791967	0	0
45782822	738818	0	0
45875996	3015076	1	1
46294630	1361711	0	0
46291843	1129625	0	0
45795852	1177480	0	0
46307204	1174888	0	0
46301052	1107830	0	0
46307458	19078461	2	3
4191948	40492359	1	1
21001359	1124300	0	0
21001796	1717327	0	0
21002077	1746114	0	0
21602359	1548195	4	4
21502553	1332419	7	8
36225402	19128065	2	3
36400000	4144583	5	9
44345079	1738521	0	0
44348445	1129625	0	0
44338811	967823	0	0
45640998	40223821	2	3
45643763	19127890	0	0
44340908	933724	0	0
45650497	1125315	0	0
45638898	1125315	0	0
45627539	1119510	0	0
45651166	1310149	0	0
45688737	1746114	0	0
45680353	1192710	0	0
45701097	1124957	0	0
45896880	1127433	2	3
45784024	1119510	0	0
45673275	1124957	0	0
45783017	738818	0	0
45875996	3006451	1	1
46294889	975125	0	0
46291156	1129625	0	0
45796046	1177480	0	0
46307523	738818	0	0
46301062	933724	0	0
46307682	19078461	2	3
4161134	4202451	1	1
21001359	975125	0	0
21001775	1192710	0	0
21002077	1741122	0	0
21602359	1512674	4	4
21502553	19018935	7	8
36463297	1332419	2	3
37522270	4336464	5	9
44345340	1738521	0	0
44342776	1129625	0	0
44338815	920293	0	0
45640874	40232448	2	3
45643837	742185	0	0
44340939	1545958	0	0
45650500	1125315	0	0
45639089	1125315	0	0
45623707	1119510	0	0
45651149	1149196	0	0
45688737	1741122	0	0
45680630	1305058	0	0
45700945	1713332	0	0
45697106	19008572	2	3
45784342	1119510	0	0
45673276	1192710	0	0
45783033	738818	0	0
45875996	3005136	1	1
46294639	1149380	0	0
46290402	1129625	0	0
45790654	1177480	0	0
46307215	1000560	0	0
46301067	975125	0	0
45799483	19078461	2	3
4112341	4294548	1	1
21001379	1759842	0	0
21001775	1149196	0	0
21002084	975125	0	0
21601386	19010482	4	4
21502553	1310034	7	8
36424721	1519937	2	3
36702247	4001336	5	8
44345251	740275	0	0
44342721	1129625	0	0
44338849	1177480	0	0
45640976	19133905	2	3
45645839	701322	0	0
44340962	1361711	0	0
45650616	1125315	0	0
45639103	1125315	0	0
45623900	1119510	0	0
45651169	1000560	0	0
45688532	1367571	0	0
45680681	1501700	0	0
45701137	1332418	0	0
45697394	40229134	2	3
45784353	1119510	0	0
45673276	1174888	0	0
45783154	738818	0	0
45875996	3001247	1	1
46294639	1137529	0	0
46290514	1129625	0	0
46297242	1177480	0	0
46307576	1115008	0	0
46300923	1501700	0	0
45802061	19078461	2	3
4112341	4112343	1	1
21001381	1717327	0	0
21001688	1310149	0	0
21002052	1713332	0	0
21601386	1500211	4	4
21502553	19126352	7	8
36424721	43012433	2	3
37303796	133834	5	8
44345043	1177480	0	0
44342762	1129625	0	0
44338999	1000560	0	0
45640976	19133873	2	3
45640772	1551099	0	0
44340909	1124300	0	0
45650188	1125315	0	0
45635369	1125315	0	0
45625144	1119510	0	0
45651406	1107830	0	0
45688406	1149196	0	0
45680650	1149196	0	0
45700817	1310149	0	0
45697397	40229134	2	3
45784262	1119510	0	0
45673186	1154343	0	0
45782999	738818	0	0
45875996	3020655	1	1
46294644	1713332	0	0
46290430	1129625	0	0
46297764	1177480	0	0
46307587	1307863	0	0
46300925	1112807	0	0
46318480	19078461	2	3
4043174	4216130	1	1
21001382	1713332	0	0
21001686	1310149	0	0
21002094	1717327	0	0
21604208	753626	2	2
35702767	81893	6	8
36427297	40231925	2	3
37522270	4330583	5	8
44345043	1129625	0	0
44342792	1129625	0	0
44339004	1129625	0	0
45640987	40232448	2	3
45640527	1738521	0	0
44340945	701322	0	0
45650368	1125315	0	0
45635625	1125315	0	0
45625215	1119510	0	0
45651174	975125	0	0
45688409	738818	0	0
45680349	1557272	0	0
45700986	1124957	0	0
45697369	1127433	2	3
45784280	1119510	0	0
45673384	1124957	0	0
45783111	738818	0	0
45875996	3012494	1	1
46294644	1759842	0	0
46290698	1129625	0	0
46297972	1177480	0	0
46307802	1174888	0	0
46300773	1332418	0	0
46300307	40223768	2	3
4043029	4024289	1	1
21001378	1717327	0	0
21001686	1367571	0	0
21002088	975125	0	0
21602496	1512674	2	2
36200000	4084167	7	7
36424211	40229134	2	3
40776263	3026361	5	7
44345046	1589505	0	0
44343082	1129625	0	0
44339004	1177480	0	0
45640639	40236824	2	3
45640646	1153428	0	0
44340952	738818	0	0
45650262	1125315	0	0
45635627	1125315	0	0
45625230	1119510	0	0
45651359	1115008	0	0
45688517	1115008	0	0
45680633	1110410	0	0
45700952	1738521	0	0
45697509	19078461	2	3
45784253	1119510	0	0
45673386	723013	0	0
45783315	738818	0	0
45875996	3036780	1	1
46294648	1307863	0	0
46290757	1129625	0	0
46289803	1177480	0	0
46307443	1153428	0	0
46300542	1310149	0	0
45895602	19078461	2	3
4027255	317576	1	1
21001379	1717327	0	0
21001701	975125	0	0
21002068	1741122	0	0
21602496	1589505	2	2
21502709	1149196	7	7
36244042	44816277	2	3
40776263	3010813	5	7
44345157	1326303	0	0
44343019	1129625	0	0
44338817	1501700	0	0
45641180	1127433	2	3
45640750	753626	0	0
44340911	1115008	0	0
45647280	1125315	0	0
45635629	1125315	0	0
45624137	1119510	0	0
45651388	1310149	0	0
45688697	738818	0	0
45680636	791967	0	0
45701082	1107830	0	0
45697420	19008572	2	3
45784270	1119510	0	0
45673296	1192710	0	0
45783141	738818	0	0
45875996	3014599	1	1
46294656	1549786	0	0
46290948	1129625	0	0
46241557	1177480	0	0
46307489	933724	0	0
46300678	1112807	0	0
46296219	19078461	2	3
4178680	80180	1	1
21001357	1124300	0	0
21001738	1174888	0	0
21002068	1746114	0	0
21604255	1124957	2	2
21502709	1177480	7	7
36429708	40171902	1	1
36703532	4132546	5	7
44344993	1729720	0	0
44339492	1129625	0	0
44338826	740275	0	0
45641097	40232448	2	3
45640589	1149196	0	0
44340884	1305058	0	0
45647302	1125315	0	0
45637187	1125315	0	0
45624209	1119510	0	0
45651390	738818	0	0
45688729	1124300	0	0
45680643	1759842	0	0
45700989	1000560	0	0
45894727	19078461	2	3
45786454	1119510	0	0
45672666	1115008	0	0
45783205	738818	0	0
45875996	3027231	1	1
46294656	1512674	0	0
46290669	1129625	0	0
46241590	1177480	0	0
46307495	757627	0	0
46300875	1174888	0	0
46318469	19078461	2	3
4178431	4035415	1	1
21001380	1778162	0	0
21001707	967823	0	0
21002069	1741122	0	0
21602100	975125	2	2
21502709	1154343	7	7
36303102	4163951	1	1
36700000	44782520	5	7
44344994	1115008	0	0
44339550	1129625	0	0
44339057	1177480	0	0
45637612	19008572	2	3
45640889	1713332	0	0
44340688	1115008	0	0
45647266	1125315	0	0
45637034	1125315	0	0
45624183	1119510	0	0
45651391	1115008	0	0
45687059	967823	0	0
45680643	1713332	0	0
45701199	1308738	0	0
45894819	40228230	2	3
45786455	1119510	0	0
45672633	1192710	0	0
45783333	738818	0	0
45875980	3049273	1	1
46294657	975125	0	0
46290814	1129625	0	0
46241697	1177480	0	0
46307681	738818	0	0
46300878	1545958	0	0
46312420	19078461	2	3
4064927	4062501	1	1
21001379	1778162	0	0
21001738	1125315	0	0
21002069	1746114	0	0
21602478	42902245	2	2
21502552	19059056	6	7
36424218	19115351	1	1
36300000	4145310	5	7
44345089	1192710	0	0
44339353	1129625	0	0
44339198	1129625	0	0
45637646	40163554	2	3
45640889	1759842	0	0
44340841	1118084	0	0
45647160	1125315	0	0
45636837	1125315	0	0
45624165	1119510	0	0
45651398	1332418	0	0
45687084	1738521	0	0
45680685	1149196	0	0
45701203	1343916	0	0
45694415	19008572	2	3
45786459	1119510	0	0
45672647	1738521	0	0
45778126	738818	0	0
45876002	3019550	1	1
46294802	1154343	0	0
46290815	1129625	0	0
46241681	1177480	0	0
46302194	933724	0	0
46300888	1548195	0	0
46312534	19078461	2	3
4068155	313217	1	1
21001379	1728416	0	0
21001710	1343916	0	0
21002070	1741122	0	0
35202454	313217	2	2
21502552	40163554	6	7
36303181	4234705	1	1
40792793	3026361	5	7
44345089	1177480	0	0
44341422	1129625	0	0
44339201	1129625	0	0
45637766	43012036	2	3
45640509	757627	0	0
44340843	1192710	0	0
45647169	1125315	0	0
45636838	1125315	0	0
45624256	1119510	0	0
45651306	1396131	0	0
45687130	975125	0	0
45680690	1192710	0	0
45701001	1174888	0	0
45694447	1713671	2	3
45784371	1119510	0	0
45672667	1107830	0	0
46242632	738818	0	0
45876002	3013721	1	1
46294806	723013	0	0
46291084	1129625	0	0
45897976	1177480	0	0
46302311	1521369	0	0
46301070	1501700	0	0
46296392	19078461	2	3
4063381	4280726	1	1
21001378	1759842	0	0
21001738	1129625	0	0
21002071	1741122	0	0
21602752	1501700	2	2
21502552	19075601	6	7
36304718	3013682	1	1
36902280	4043241	5	7
44345092	1177480	0	0
44341300	1129625	0	0
44339207	1174888	0	0
45637892	19019273	2	3
45640709	1174888	0	0
44340844	1332418	0	0
45649009	1125315	0	0
45637150	1125315	0	0
45624392	1119510	0	0
45651612	920293	0	0
45687066	715997	0	0
45676886	1192710	0	0
45701165	967823	0	0
45694261	19018935	2	3
45784385	1119510	0	0
45672649	920293	0	0
46240248	738818	0	0
45876002	3015632	1	1
46296566	1129625	0	0
46291057	1129625	0	0
45898002	1177480	0	0
46302358	933724	0	0
46301618	1589505	0	0
46308120	19078461	2	3
4187067	317576	1	1
21001380	1759842	0	0
21001738	1192710	0	0
21002072	1746114	0	0
21602480	19128009	2	2
4093991	4296204	5	6
36304718	3024561	1	1
36402192	439777	5	7
44345088	1177480	0	0
44339773	1129625	0	0
44338920	1177480	0	0
45637904	1115171	2	3
45640992	740275	0	0
44340849	1115008	0	0
45649012	1125315	0	0
45636928	1125315	0	0
45668478	1119510	0	0
45651619	1549786	0	0
45687069	1149196	0	0
45676699	738818	0	0
45701353	740275	0	0
45694435	19059056	2	3
45784457	1119510	0	0
45672654	975125	0	0
46240362	738818	0	0
45876002	3006923	1	1
46296648	1129625	0	0
46291069	1129625	0	0
45897964	1177480	0	0
46302361	920293	0	0
46301678	1557272	0	0
46318225	19078461	2	3
4187096	4059173	1	1
21001382	1759842	0	0
21001688	1367571	0	0
21002072	1741122	0	0
21602480	19127918	2	2
4227253	4166224	5	6
36304718	3004501	1	1
37303814	4066995	5	6
44345006	1129625	0	0
44362940	1119510	0	0
44339067	1129625	0	0
45637909	40229134	2	3
45640813	1539403	0	0
44340985	1000560	0	0
45649016	1125315	0	0
45637220	1125315	0	0
45668269	1119510	0	0
45651619	19127890	0	0
45687097	740275	0	0
45676847	1149196	0	0
45701245	967823	0	0
45694602	19008572	2	3
45784409	1119510	0	0
45672656	1124957	0	0
45703272	738818	0	0
45876002	3027970	1	1
46293651	1129625	0	0
46290618	1129625	0	0
45895702	1177480	0	0
46302369	1124957	0	0
46301663	1174888	0	0
46319088	19078461	2	3
4180765	4252419	1	1
21000912	1728416	0	0
21013411	1768849	0	0
21002073	1741122	0	0
35202050	321042	2	2
4227253	313217	5	6
36304718	3016723	1	1
37303814	4048695	5	6
44338115	1177480	0	0
44363082	1119510	0	0
44360400	933724	0	0
45637992	19073183	2	3
45640718	1539403	0	0
44340922	738818	0	0
45647369	1125315	0	0
45637222	1125315	0	0
45668271	1119510	0	0
45651619	1512674	0	0
45687284	1343916	0	0
45677074	1548195	0	0
45701065	1107830	0	0
45694596	40163554	2	3
45784487	1119510	0	0
45672695	1717327	0	0
45703276	738818	0	0
45876002	3035995	1	1
46293589	1129625	0	0
46290628	1129625	0	0
45895780	1177480	0	0
46302471	1174888	0	0
46301702	1713332	0	0
45799501	19078461	2	3
4180765	4024289	1	1
21000912	1729720	0	0
21013411	1713332	0	0
21002074	1741122	0	0
35202050	4324181	2	2
4180938	4058899	4	6
36303158	4012477	1	1
36703532	381316	5	6
44338173	1326303	0	0
44362987	1119510	0	0
44360088	1112807	0	0
44343795	43012036	2	3
45640728	1307863	0	0
44340924	738818	0	0
45647408	1125315	0	0
45635940	1125315	0	0
45668276	1119510	0	0
45651648	1589505	0	0
45687137	1124957	0	0
45677087	1501700	0	0
45700857	1589505	0	0
45691336	40232448	2	3
45784433	1119510	0	0
45672698	1549786	0	0
45703491	738818	0	0
45876002	3023103	1	1
46293751	1129625	0	0
46242437	1129625	0	0
45895785	1177480	0	0
46302167	1332418	0	0
46301748	1326303	0	0
45796915	1332419	2	3
4115236	40481087	1	1
21000931	791967	0	0
21013430	740275	0	0
21002075	1741122	0	0
21604303	1125315	2	2
4213101	4066995	4	6
36304850	3006906	1	1
40792793	3010813	5	6
44338174	1307863	0	0
44362995	1119510	0	0
44360413	1174888	0	0
44340084	1115171	2	3
45640847	1713332	0	0
44340934	975125	0	0
45644240	1125315	0	0
45635834	1125315	0	0
45668239	1119510	0	0
45651648	1549786	0	0
45687104	1738521	0	0
45677007	1115008	0	0
45700857	1549786	0	0
45802647	40229134	2	3
45782313	1119510	0	0
45672702	1107830	0	0
45703472	738818	0	0
45876002	3004501	1	1
46293494	1129625	0	0
46242371	1129625	0	0
45895869	1177480	0	0
46301992	914335	0	0
46301750	1343916	0	0
46299644	19078461	2	3
4105866	81151	1	1
21000919	791967	0	0
21013433	1746114	0	0
21002075	1746114	0	0
21604303	1112807	2	2
4042505	4230399	6	6
36304850	3024561	1	1
36702242	378419	5	6
44338215	1738521	0	0
44363243	1119510	0	0
44360383	1129625	0	0
44340147	19018935	2	3
45640847	1759842	0	0
44340890	723013	0	0
45644309	1125315	0	0
45635762	1125315	0	0
45668387	1119510	0	0
45651653	738818	0	0
45687187	1768849	0	0
45677008	1124957	0	0
45700857	19127890	0	0
45802539	1115171	2	3
45782315	1119510	0	0
45672711	1124957	0	0
45700402	738818	0	0
45876002	3014576	1	1
46293811	1129625	0	0
46242522	1129625	0	0
45896011	1177480	0	0
46302115	1000560	0	0
46301847	1322184	0	0
46313035	19078461	2	3
4074815	81893	1	1
21000467	1548195	0	0
21013448	1539403	0	0
21002059	1112807	0	0
21603395	1174888	2	2
35802131	140673	6	6
36304850	3013682	1	1
36702253	44782520	5	6
44338226	1326303	0	0
44363466	1119510	0	0
44360391	933724	0	0
44340255	1127433	2	3
45640854	738818	0	0
44340891	1115008	0	0
45644147	1125315	0	0
45635768	1125315	0	0
45668391	1119510	0	0
45651555	1154343	0	0
45687235	975125	0	0
45677010	1124957	0	0
45700860	1149196	0	0
45876033	3020630	2	3
45782316	1119510	0	0
45672772	967823	0	0
45697394	738818	0	0
45876002	3013682	1	1
46293725	1129625	0	0
46242353	1129625	0	0
45804223	1177480	0	0
46302282	1107830	0	0
46301618	1549786	0	0
46307409	19078461	2	3
4074298	4238715	1	1
21000404	1551099	0	0
21013455	1124300	0	0
21002089	975125	0	0
21603366	1125443	2	2
21502549	1308738	6	6
36304850	3004501	1	1
36702247	380378	5	6
44338227	738818	0	0
44363381	1119510	0	0
44359771	1107830	0	0
44340370	19008572	2	3
45640856	1551099	0	0
45636975	1107830	0	0
45644273	1125315	0	0
45636064	1125315	0	0
45668370	1119510	0	0
45651493	1729720	0	0
45687237	1107830	0	0
45679392	715997	0	0
45700871	738818	0	0
45876033	3045716	2	3
45782502	1119510	0	0
45672641	967823	0	0
45697397	738818	0	0
45876002	3009201	1	1
46293952	1129625	0	0
46242548	1129625	0	0
45804216	1177480	0	0
46302017	1501700	0	0
46301752	1332418	0	0
46299662	19078461	2	3
4074298	4275113	1	1
21000423	975125	0	0
21013432	1717327	0	0
21002089	1551099	0	0
21603617	975125	2	2
21502549	1746114	6	6
36304850	3016723	1	1
37503887	4198190	5	6
44338229	1557272	0	0
44363179	1119510	0	0
44360037	1110410	0	0
44340374	19077572	2	3
45640862	1521369	0	0
45637302	738818	0	0
45644278	1125315	0	0
45632547	1125315	0	0
45668373	1119510	0	0
45651382	1729720	0	0
45687241	1154029	0	0
45679452	1154029	0	0
45700788	1305058	0	0
45876033	3019550	2	3
45782528	1119510	0	0
45672645	1192710	0	0
45894805	738818	0	0
45876002	3024561	1	1
46288772	1129625	0	0
46240264	1129625	0	0
45804047	1177480	0	0
46302311	1549786	0	0
46301939	723013	0	0
45791657	19078461	2	3
4085100	40481087	1	1
21000404	975125	0	0
21013432	1778162	0	0
21002084	1551099	0	0
21603638	1124300	2	2
21502549	1713332	6	6
36403211	80502	1	1
37522270	4242997	5	6
44338190	1549786	0	0
44363257	1119510	0	0
44360042	1305058	0	0
44339943	19133905	2	3
45640862	1549786	0	0
45637393	1124300	0	0
45644372	1125315	0	0
45632642	1125315	0	0
45668452	1119510	0	0
45651412	1192710	0	0
45687184	1778162	0	0
45679287	723013	0	0
45700792	1107830	0	0
45688459	40162522	2	3
45782565	1119510	0	0
45672686	1192710	0	0
45694981	738818	0	0
45876002	3020630	1	1
46289124	1129625	0	0
45896240	1129625	0	0
45803835	1177480	0	0
46302022	1521369	0	0
46301240	1000560	0	0
46318696	40174880	2	3
4043017	4035793	1	1
21000472	975125	0	0
21013431	791967	0	0
21002098	975125	0	0
21602723	975125	2	2
4227253	440448	6	6
36248814	40174880	1	2
40796010	3026361	5	5
44338190	19127890	0	0
44363258	1119510	0	0
44360233	1110410	0	0
44340486	19019273	2	3
45640866	1548195	0	0
45637365	1539403	0	0
45644327	1125315	0	0
45632826	1125315	0	0
45668789	1119510	0	0
45651414	975125	0	0
45687209	1322184	0	0
45679663	1154029	0	0
45700831	1110410	0	0
45800015	19078461	2	3
45782589	1119510	0	0
45672688	1738521	0	0
45694606	738818	0	0
45876002	3006906	1	1
46289277	1129625	0	0
45896457	1129625	0	0
45804083	1177480	0	0
46302027	1589505	0	0
46301246	1107830	0	0
46318938	1545959	2	3
4180248	4035793	1	1
21000472	1551099	0	0
21013458	705944	0	0
21502657	1118084	0	0
21602723	1551099	2	2
1713545	1713671	1	1
36248806	40174880	1	2
36300000	4195803	5	5
44338190	1512674	0	0
44363193	1119510	0	0
44359774	1548195	0	0
44340494	920334	2	3
45640868	782043	0	0
45637341	1154029	0	0
45644092	1125315	0	0
45632751	1125315	0	0
45668525	1119510	0	0
45651423	1343916	0	0
45687210	1729720	0	0
45679664	1107830	0	0
45700834	738818	0	0
45799993	43012036	2	3
45782590	1119510	0	0
45672791	1149196	0	0
45802647	738818	0	0
46233710	46233710	0	0
46243839	1129625	0	0
45896622	1129625	0	0
45804027	1177480	0	0
46302101	1778162	0	0
46301270	1729720	0	0
45894285	1332419	2	3
4105895	4293740	1	1
21000472	1305058	0	0
21013433	1759842	0	0
21602860	1741122	0	0
21604182	19016749	2	2
1717504	19129655	1	1
36225210	1539411	1	2
37302323	4156265	5	5
44338176	1501700	0	0
44363323	1119510	0	0
44360124	1118084	0	0
44340417	19019273	2	3
45640961	1343916	0	0
45625321	1332418	0	0
45644161	1125315	0	0
45632785	1125315	0	0
45665857	1119510	0	0
45651432	1717327	0	0
45687200	1107830	0	0
45679672	19127890	0	0
45697943	1115008	0	0
45800053	40229134	2	3
45782534	1119510	0	0
45672673	1501700	0	0
45688171	738818	0	0
46238179	1149196	0	0
46243754	1129625	0	0
45894114	1129625	0	0
45798907	1177480	0	0
46302249	1124300	0	0
46301275	1322184	0	0
46300426	1332419	2	3
4040398	4243062	1	1
21000471	1551099	0	0
21013433	920293	0	0
21003026	1154029	0	0
21603057	920293	2	2
4056622	4056621	1	1
36225209	1539411	1	2
40779591	3021226	5	5
44338265	1177480	0	0
44363302	1119510	0	0
44359780	975125	0	0
44340631	40232448	2	3
45640996	738818	0	0
45625323	975125	0	0
45644179	1125315	0	0
45632824	1125315	0	0
45667371	1119510	0	0
45651435	740275	0	0
45687296	1000560	0	0
45679672	1589505	0	0
45697876	1343916	0	0
45800082	19077572	2	3
45782665	1119510	0	0
45672719	1192710	0	0
45688436	738818	0	0
46235214	46235214	0	0
46243849	1129625	0	0
45894088	1129625	0	0
45799812	1177480	0	0
46302216	1713332	0	0
46301184	1308738	0	0
45796860	1332419	2	3
4043028	4252419	1	1
21000474	1149380	0	0
21013433	1768849	0	0
21003025	19003953	0	0
21601854	1545958	2	2
4092747	378419	1	1
36225662	35605482	1	2
40779591	3023430	5	5
44338124	1713332	0	0
44363596	1119510	0	0
44360423	975125	0	0
44340521	40232448	2	3
45640997	1124957	0	0
45622036	740275	0	0
45644342	1125315	0	0
45632922	1125315	0	0
45667225	1119510	0	0
45651682	1728416	0	0
45687203	1107830	0	0
45679672	1549786	0	0
45697920	1115008	0	0
45800084	1127433	2	3
45782235	1119510	0	0
45672723	1551099	0	0
45800016	738818	0	0
46221622	46221626	0	0
46241468	1129625	0	0
45798540	1119510	0	0
45793508	1177480	0	0
46302126	933724	0	0
46301395	1112807	0	0
46302167	1332419	2	3
4040396	4202451	1	1
21000431	1305058	0	0
21013475	1738521	0	0
21003025	753626	0	0
21601765	1307863	2	2
4092807	4012477	1	1
36246594	40173590	1	2
40779591	3036780	5	5
44338124	1759842	0	0
44356332	1119510	0	0
44360430	1500211	0	0
44340464	40232448	2	3
45640998	1153428	0	0
45621788	738818	0	0
45644089	1125315	0	0
45632789	1125315	0	0
45666380	1119510	0	0
45651690	1115008	0	0
45687248	1307863	0	0
45679675	1589505	0	0
45697921	738818	0	0
45800086	40229134	2	3
45782483	1119510	0	0
45672756	1713332	0	0
45800053	738818	0	0
46221626	46221626	0	0
46241444	1129625	0	0
45798380	1119510	0	0
45793553	1177480	0	0
46302387	1149196	0	0
46301401	975125	0	0
46318059	19079524	2	3
4179141	4035415	1	1
21000450	1500211	0	0
21013433	1778162	0	0
21003024	753626	0	0
21602472	1512674	2	2
4180938	4195803	1	1
36246593	40173590	1	2
40779591	3014599	5	5
44338125	1112807	0	0
44356425	1119510	0	0
44359784	1115008	0	0
44340596	40232448	2	3
45640845	1149196	0	0
45621835	1738521	0	0
45644209	1125315	0	0
45632932	1125315	0	0
45666476	1119510	0	0
45651779	1548195	0	0
45683955	1149380	0	0
45679675	19127890	0	0
45698037	723013	0	0
45800215	19075001	2	3
45782484	1119510	0	0
45672857	1539403	0	0
45800086	738818	0	0
46238178	1332418	0	0
46241635	1129625	0	0
45798659	1119510	0	0
45793687	1177480	0	0
46302389	1174888	0	0
46301354	1112807	0	0
45796907	1332419	2	3
4048365	4052083	1	1
21000471	975125	0	0
21013411	1759842	0	0
21003039	708298	0	0
21602472	1519936	2	2
4141657	4058899	1	1
36226749	40224805	1	2
36603422	40479768	5	5
44338134	1500211	0	0
44356412	1119510	0	0
44360319	967823	0	0
44337353	1115171	2	3
45640962	1539403	0	0
45621838	1310149	0	0
45644171	1125315	0	0
45632941	1125315	0	0
45666477	1119510	0	0
45651569	1192710	0	0
45683959	1309944	0	0
45679675	1549786	0	0
45698073	1549786	0	0
45800221	1115171	2	3
45782673	1119510	0	0
45672942	1545958	0	0
45799984	738818	0	0
46238182	1192710	0	0
46241578	1129625	0	0
45798616	1119510	0	0
45793786	1177480	0	0
46302395	738818	0	0
46301320	1551099	0	0
46240037	1545959	2	3
4043160	4199276	1	1
21000702	1539403	0	0
21013486	1129625	0	0
21003025	914335	0	0
21602472	1589505	2	2
4143250	4285898	1	1
36226749	40224132	1	2
36603422	40479422	5	5
44338135	1000560	0	0
44356416	1119510	0	0
44360359	1129625	0	0
44337330	40222846	2	3
45640877	967823	0	0
45621794	708298	0	0
45644428	1125315	0	0
45632869	1125315	0	0
45666521	1119510	0	0
45648176	1115008	0	0
45683912	1000560	0	0
45679503	1149196	0	0
45698073	1521369	0	0
45800282	1539411	2	3
45782610	1119510	0	0
45672734	1174888	0	0
45800095	738818	0	0
46238184	742185	0	0
46241598	1129625	0	0
45798360	1119510	0	0
45793643	1177480	0	0
46302225	1308738	0	0
46301303	1112807	0	0
45794333	1539411	2	3
4043160	4059978	1	1
21000702	1332418	0	0
21013433	1738521	0	0
21003079	1102527	0	0
21602514	1549786	2	2
4328798	4151422	1	1
36244815	44816277	1	2
37522193	4107731	5	5
44338269	1112807	0	0
44356489	1119510	0	0
44360360	1149380	0	0
44337332	40232448	2	3
45640878	1361711	0	0
45621806	1551099	0	0
45644433	1125315	0	0
45632844	1125315	0	0
45663821	1119510	0	0
45648178	1154029	0	0
45684122	1549786	0	0
45679511	740275	0	0
45697884	1174888	0	0
45800354	19008572	2	3
45782618	1119510	0	0
45672736	1115008	0	0
45685684	738818	0	0
45798316	1149196	0	0
46241610	1129625	0	0
45798759	1119510	0	0
45788461	1177480	0	0
46302229	1110410	0	0
46301364	1110410	0	0
46303440	42902245	2	2
4047779	4285898	7	10
21000640	1521369	0	0
21013489	1343916	0	0
21003056	1129625	0	0
21602514	1548195	2	2
4267432	439777	1	1
36246159	43012433	1	2
36702239	378419	5	5
44338194	1551099	0	0
44356574	1119510	0	0
44360240	1738521	0	0
45620321	19008572	2	3
45640976	1729720	0	0
45621807	1118084	0	0
45644303	1125315	0	0
45632771	1125315	0	0
45663971	1119510	0	0
45648183	1000560	0	0
45684122	19127890	0	0
45679426	1000560	0	0
45697989	1107830	0	0
45685900	1154615	2	3
45702533	1119510	0	0
45672771	723013	0	0
45685383	738818	0	0
45798528	1501700	0	0
46241526	1129625	0	0
45798556	1119510	0	0
45788459	1177480	0	0
46302233	1549786	0	0
46301506	1118084	0	0
46301618	19128009	2	2
4047779	4043241	7	10
21000640	1503184	0	0
21013490	1343916	0	0
21003063	1129625	0	0
35508581	42902245	2	2
4269879	4168004	1	1
36246160	43012433	1	2
37303790	4296204	5	5
44337774	1149380	0	0
44349208	1119510	0	0
44359788	1129625	0	0
45620271	19075601	2	3
45640989	19010482	0	0
45621720	19127890	0	0
45644396	1125315	0	0
45632856	1125315	0	0
45664078	1119510	0	0
45648185	1124957	0	0
45684123	1548195	0	0
45679434	1307863	0	0
45697990	1149380	0	0
45685508	40163554	2	3
45702716	1119510	0	0
45672979	1115008	0	0
45799949	738818	0	0
45798320	1738521	0	0
46238757	1129625	0	0
45798364	1119510	0	0
45788475	1177480	0	0
46302233	19127890	0	0
46301507	1713332	0	0
46301618	19127918	2	2
4029205	4198190	7	9
21000640	1595799	0	0
21002747	975125	0	0
21003063	1125315	0	0
21601766	1307863	2	2
4226399	313217	1	1
36227103	40165015	1	2
37320089	133834	5	5
44337943	1149380	0	0
44349172	1119510	0	0
44359791	1192710	0	0
45620187	19133768	2	3
45641070	1149196	0	0
45621720	1549786	0	0
45644515	1125315	0	0
45632857	1125315	0	0
45663997	1119510	0	0
45648187	1343916	0	0
45684124	975125	0	0
45677139	1115008	0	0
45697934	1551099	0	0
45685684	40229134	2	3
45702741	1119510	0	0
45672982	1124957	0	0
45799720	738818	0	0
45798325	1107830	0	0
46238819	1129625	0	0
45798365	1119510	0	0
45788573	1177480	0	0
46302233	1512674	0	0
46301418	975125	0	0
500002101	4296205	2	2
4180628	4230399	7	8
21000640	19127890	0	0
21002781	19010482	0	0
21003063	1177480	0	0
21601766	40171902	2	2
21505865	705944	1	1
36226711	782047	1	2
36703532	4029498	5	5
44337985	740275	0	0
44349408	1119510	0	0
44360243	1115008	0	0
45620137	19008572	2	3
45640630	967823	0	0
45620606	1124300	0	0
45641431	1125315	0	0
45632644	1125315	0	0
45664176	1119510	0	0
45648295	1154343	0	0
45684126	1551099	0	0
45677186	1115008	0	0
45698051	1153428	0	0
45685318	40223768	2	3
45702689	1119510	0	0
45672992	975125	0	0
45794918	738818	0	0
45798493	1174888	0	0
46240057	1129625	0	0
45793174	1119510	0	0
45788688	1177480	0	0
46302446	1738521	0	0
46301440	1539403	0	0
500002101	4299128	2	2
4178818	258780	7	7
21000669	1308738	0	0
21002783	1305058	0	0
21003027	791967	0	0
21602728	975125	2	2
21503005	738818	1	1
36248905	46221626	1	2
36702242	4132546	5	5
44337986	1129625	0	0
44349352	1119510	0	0
44359936	738818	0	0
45620448	19023398	2	3
45640635	1549786	0	0
45620578	1124957	0	0
45641530	1125315	0	0
45632958	1125315	0	0
45664043	1119510	0	0
45648296	1000560	0	0
45684127	738818	0	0
45677173	1000560	0	0
45698064	914335	0	0
45685319	1115171	2	3
45702651	1119510	0	0
45672793	1305058	0	0
45679119	738818	0	0
45798242	1557272	0	0
45897645	1129625	0	0
45793177	1119510	0	0
45788628	1177480	0	0
46302450	1551099	0	0
46301237	975125	0	0
46308809	19127918	2	2
4117930	258780	7	7
21000702	1545958	0	0
21002791	1759842	0	0
21003038	723013	0	0
21602728	1551099	2	2
21502749	1589505	1	1
36244985	19125062	1	2
36919117	4043241	5	5
44337991	1177480	0	0
44349601	1119510	0	0
44359938	738818	0	0
45620370	40224805	2	3
45640635	19127890	0	0
45620583	1115008	0	0
45641492	1125315	0	0
45630938	1125315	0	0
45664108	1119510	0	0
45648302	1149196	0	0
45684043	1545958	0	0
45677158	1713332	0	0
45697906	1154343	0	0
45685417	1127433	2	3
45702652	1119510	0	0
45672760	1539403	0	0
45679449	738818	0	0
45798453	975125	0	0
45897697	1129625	0	0
45793192	1119510	0	0
46301431	1177480	0	0
46302465	1322184	0	0
46301329	1174888	0	0
46308809	19128009	2	2
4117930	198809	7	7
19059528	19059528	0	0
21002791	1778162	0	0
21003079	1124957	0	0
21602753	40174880	2	2
21502749	975125	1	1
36248622	45892894	1	2
36902280	440086	5	5
44338199	1177480	0	0
44350015	1119510	0	0
44360303	1729720	0	0
45620373	40232448	2	3
45640635	1589505	0	0
45620566	1305058	0	0
45641460	1125315	0	0
45630941	1125315	0	0
45664139	1119510	0	0
45649185	1308738	0	0
45683987	1153428	0	0
45677158	1759842	0	0
45698017	1310149	0	0
45685261	19059056	2	3
45702546	1119510	0	0
45672828	1000560	0	0
45792061	738818	0	0
45798655	1154343	0	0
45897744	1129625	0	0
45793194	1119510	0	0
46301330	1177480	0	0
46306891	1174888	0	0
46301713	933724	0	0
46320092	42902245	2	2
4042150	4163971	7	7
19018935	19018935	0	0
21002792	1746114	0	0
21003079	1110410	0	0
21602753	1501700	2	2
4181060	4059978	1	1
36248623	45892894	1	2
37522270	4125906	5	5
44337968	1192710	0	0
44350046	1119510	0	0
44359942	1118084	0	0
44362250	19008572	2	3
45640639	933724	0	0
45620669	975125	0	0
45641589	1125315	0	0
45630948	1125315	0	0
45660747	1119510	0	0
45649228	1539403	0	0
45683993	1332418	0	0
45677188	738818	0	0
45698023	738818	0	0
45685383	40229134	2	3
45702939	1119510	0	0
45672842	1589505	0	0
45792181	738818	0	0
45798658	791967	0	0
45897835	1129625	0	0
45793200	1119510	0	0
46301452	1177480	0	0
46306685	1192710	0	0
46319618	1112807	0	0
46314764	19128009	2	2
4199402	255848	7	7
19019979	19019979	0	0
21002744	1129625	0	0
21003079	1112807	0	0
21603379	1125443	2	2
4181063	30753	1	1
36463118	19128263	1	2
40796128	3024561	5	5
44338202	1177480	0	0
44341801	1119510	0	0
44359949	1545958	0	0
44361983	40228230	2	3
45640645	1124957	0	0
45620693	975125	0	0
45641593	1125315	0	0
45629665	1125315	0	0
45660951	1119510	0	0
45649239	1192710	0	0
45684183	1548195	0	0
45677194	738818	0	0
45698035	1746114	0	0
45800043	40223834	2	3
45702818	1119510	0	0
45672849	1738521	0	0
45792210	738818	0	0
45798661	1154029	0	0
45897821	1129625	0	0
45793481	1119510	0	0
46301489	1177480	0	0
46306809	1717327	0	0
46319259	1501700	0	0
46315314	40223768	2	3
4048384	4168004	7	7
4302207	4302207	0	0
21002796	1746114	0	0
21003079	1177480	0	0
21603396	1174888	2	2
4181063	372328	1	1
36463118	19128022	1	2
40796128	3027970	5	5
44338151	1551099	0	0
44342122	1119510	0	0
44359961	1551099	0	0
44361999	1545959	2	3
45641086	1110410	0	0
45620654	1174888	0	0
45641594	1125315	0	0
45629649	1125315	0	0
45661041	1119510	0	0
45649225	1332418	0	0
45684201	1174888	0	0
45677199	1521369	0	0
45698035	1741122	0	0
45799872	19076374	2	3
45696618	1119510	0	0
45672850	975125	0	0
45792376	738818	0	0
45798667	1310149	0	0
45897915	1129625	0	0
45793434	1119510	0	0
46298141	1177480	0	0
46306322	914335	0	0
46319805	1539403	0	0
46320683	1107882	2	3
4043022	40492359	7	7
4280726	4280726	0	0
21002783	1551099	0	0
21003076	1125315	0	0
21601746	1332418	2	2
4181063	195588	1	1
36303164	4024958	1	4
37502353	4295880	5	5
44337995	1149196	0	0
44341834	1119510	0	0
44360103	1322184	0	0
44362094	19133905	2	3
45641020	1539403	0	0
45620805	1153428	0	0
45641413	1125315	0	0
45629683	1125315	0	0
45658081	1119510	0	0
45649270	1589505	0	0
45683906	19059528	0	0
45677199	19127890	0	0
45698036	1310149	0	0
45799741	1539411	2	3
45682541	1125315	0	0
45672860	1174888	0	0
45789384	738818	0	0
45798603	1501700	0	0
45897770	1129625	0	0
45793445	1119510	0	0
46298522	1177480	0	0
46306256	1124957	0	0
46319697	967823	0	0
46309206	1107882	2	3
4043025	4243062	2	3
4199402	4035415	6	7
21002775	975125	0	0
21003076	1112807	0	0
35200000	317576	3	7
4180941	4163951	1	1
36303164	4015189	1	5
37503887	4163971	5	5
44337996	1557272	0	0
44341805	1119510	0	0
44360306	738818	0	0
44362411	40229134	2	3
45640929	1548195	0	0
45620662	1738521	0	0
45641419	1125315	0	0
45629628	1125315	0	0
45658065	1119510	0	0
45649240	1115008	0	0
45684023	1153428	0	0
45677199	1549786	0	0
45697997	1174888	0	0
45797318	19133905	2	3
45680011	1125315	0	0
45672870	1713332	0	0
45789324	738818	0	0
45798606	1332418	0	0
45897842	1129625	0	0
45793294	1119510	0	0
46289708	1177480	0	0
46306776	1124957	0	0
46319701	1192710	0	0
46327429	1107882	2	3
4043161	4059978	2	3
4199402	4059173	6	7
21002744	1192710	0	0
21003076	1129625	0	0
35202051	313217	5	7
36217029	1713671	1	2
36500000	40480160	4	9
40772948	3015076	5	5
44338098	738818	0	0
44341889	1119510	0	0
44360111	1332418	0	0
44362305	19126352	2	3
45640935	738818	0	0
45620673	1746114	0	0
45641801	1125315	0	0
45629755	1125315	0	0
45658217	1119510	0	0
45649241	1107830	0	0
45684158	1107830	0	0
45677200	1326303	0	0
45698009	1759842	0	0
45797318	19133873	2	3
45680012	1125315	0	0
45672779	1192710	0	0
45786506	738818	0	0
45798330	975125	0	0
45897960	1129625	0	0
45793308	1119510	0	0
46290079	1177480	0	0
46306961	975125	0	0
46319456	1000560	0	0
46301052	1107882	2	3
4042836	4283893	2	3
4199402	381316	6	6
21002804	1746114	0	0
21003076	738818	0	0
21605007	40169281	5	7
36217124	19074843	1	2
36602234	81151	4	7
40772948	3006734	5	5
44362819	1177480	0	0
44341892	1119510	0	0
44360248	1310149	0	0
44362559	19129655	2	3
45641096	1713332	0	0
45620673	1741122	0	0
45641693	1125315	0	0
45629757	1125315	0	0
45658326	1119510	0	0
45648362	1115008	0	0
45684096	975125	0	0
45677295	1738521	0	0
45698009	1713332	0	0
45794821	40231925	2	3
45677545	1125315	0	0
45672770	740275	0	0
45786710	738818	0	0
45798608	1713332	0	0
45897929	1129625	0	0
45793469	1119510	0	0
46289947	1177480	0	0
46306901	1310149	0	0
46319461	1112807	0	0
46301246	1107882	2	3
4180169	195588	2	3
4199402	133834	6	6
21002805	19010482	0	0
21003076	1119510	0	0
21602471	19127904	5	7
36217124	19074841	1	2
36313913	4047491	4	5
40772948	3019406	5	5
44362849	1192710	0	0
44342040	1119510	0	0
44360261	1112807	0	0
44362422	40162522	2	3
45641188	1107830	0	0
45620731	1149196	0	0
45641694	1125315	0	0
45629762	1125315	0	0
45658329	1119510	0	0
45648325	1326303	0	0
45684098	19039298	0	0
45677321	1110410	0	0
45698124	1332418	0	0
45794907	1115171	2	3
45677555	1125315	0	0
45672751	1115008	0	0
45786920	738818	0	0
45798757	1115008	0	0
45895526	1129625	0	0
45794656	1119510	0	0
46290232	1177480	0	0
46306336	1551099	0	0
46319652	1124957	0	0
46313997	1107882	2	3
4108611	4329847	2	3
4199402	40479768	8	9
21002806	1115008	0	0
21003076	1192710	0	0
21602471	40221415	4	7
36217030	1713671	1	2
36303152	4024289	4	5
37109021	4174876	1	1
44362856	1177480	0	0
44341944	1119510	0	0
44360265	1107830	0	0
44362512	1115171	2	3
45641045	1713332	0	0
45620732	1115008	0	0
45641558	1125315	0	0
45629741	1125315	0	0
45654667	1119510	0	0
45648326	967823	0	0
45684099	1343916	0	0
45677302	1115008	0	0
45698127	1115008	0	0
45679272	19008572	2	3
45677561	1125315	0	0
45784493	975125	0	0
45786922	738818	0	0
45798631	1307863	0	0
45895497	1129625	0	0
45787859	1119510	0	0
46289970	1177480	0	0
46302613	1000560	0	0
46319656	1332418	0	0
46311899	1107882	2	3
4040397	4301346	2	3
4199402	198809	8	8
21002805	975125	0	0
21003076	1177480	0	0
21605007	1150771	4	7
36219949	19077344	1	2
36303152	4252419	4	5
36713504	4310024	1	1
44362858	1124300	0	0
44341934	1119510	0	0
44360270	1174888	0	0
44355164	40236446	2	3
45641045	1759842	0	0
45620718	1107830	0	0
45641641	1125315	0	0
45629653	1125315	0	0
45654668	1119510	0	0
45648338	1153428	0	0
45684101	1154343	0	0
45677306	1501700	0	0
45698133	967823	0	0
45679267	40232448	2	3
45677994	1125315	0	0
45784508	19127890	0	0
45786794	738818	0	0
45798852	1521369	0	0
45895552	1129625	0	0
45787862	1119510	0	0
46291822	1177480	0	0
46299726	1396131	0	0
46319659	967823	0	0
46305255	40174880	2	3
442264	4146173	2	3
4199402	4283893	5	7
21002806	1124300	0	0
21003027	708298	0	0
21605007	19112599	4	7
36217056	19073188	1	2
36303152	4243062	4	4
36713625	4146173	1	1
44362873	701322	0	0
44342072	1119510	0	0
44360328	1129625	0	0
44355202	1127433	2	3
45640822	738818	0	0
45620724	738818	0	0
45641545	1125315	0	0
45629705	1125315	0	0
45654614	1119510	0	0
45648438	1192710	0	0
45684206	975125	0	0
45677308	757627	0	0
45698135	1110410	0	0
45679651	40223834	2	3
45677617	1125315	0	0
45784508	1515774	0	0
45786964	738818	0	0
45798852	19127890	0	0
45895566	1129625	0	0
45787878	1119510	0	0
46241902	1177480	0	0
46299832	1539403	0	0
46319682	1738521	0	0
46313857	1107882	2	3
4040576	4117038	2	3
4199402	4156265	5	7
21002806	1177480	0	0
21003044	791967	0	0
21605007	40228230	4	7
36213600	44816277	1	2
36313959	4181917	4	4
36703483	378419	1	1
44362903	738818	0	0
44342073	1119510	0	0
44360339	1107830	0	0
45655537	19008572	2	3
45641106	1174888	0	0
45620850	975125	0	0
45641599	1125315	0	0
45629784	1125315	0	0
45654414	1119510	0	0
45648375	1115008	0	0
45684207	1174888	0	0
45677259	1153428	0	0
45697976	1500211	0	0
45679449	40229134	2	3
45678069	1125315	0	0
45784508	1549786	0	0
45786886	738818	0	0
45798852	1549786	0	0
45895465	1129625	0	0
45788007	1119510	0	0
46241956	1177480	0	0
46299800	738818	0	0
46319696	1738521	0	0
46314408	1332419	2	3
4043016	4059978	2	3
4199402	4132546	5	7
21002805	1112807	0	0
21003042	1154029	0	0
21605007	1107882	4	7
443357	81151	3	3
36313913	4202451	4	4
40798526	3024731	1	1
44362920	1124300	0	0
44342386	1119510	0	0
44360344	1174888	0	0
45655145	40232448	2	3
45637611	1501700	0	0
45620851	1713332	0	0
45641740	1125315	0	0
45629857	1125315	0	0
45655549	1119510	0	0
45648389	1107830	0	0
45684217	738818	0	0
45677190	1174888	0	0
45698149	1545958	0	0
45792058	1115171	2	3
45677894	1125315	0	0
45784521	967823	0	0
45786237	738818	0	0
45798574	1713332	0	0
45679534	1119510	0	0
45787965	1119510	0	0
46242015	1177480	0	0
46299905	1115008	0	0
46319744	1124300	0	0
46300773	1332419	2	3
4027880	81893	2	3
4199402	4296204	5	5
21002805	1551099	0	0
21003042	914335	0	0
21602359	40236824	4	7
4092876	198809	3	3
36502197	80502	5	5
40796605	3028833	1	1
44362923	1192710	0	0
44342351	1119510	0	0
44362697	1713332	0	0
44347517	1127433	2	3
45637575	1174888	0	0
45620851	1759842	0	0
45641613	1125315	0	0
45629793	1125315	0	0
45654762	1119510	0	0
45648522	1501700	0	0
45684293	1778162	0	0
45677220	1107830	0	0
45698182	1115008	0	0
45792062	19019273	2	3
45678015	1125315	0	0
45784529	1174888	0	0
45786427	738818	0	0
45798351	1539403	0	0
45679921	1119510	0	0
45788025	1119510	0	0
46241982	1177480	0	0
46299911	933724	0	0
46322413	1551099	0	0
46322513	19078461	2	3
4154739	4142905	2	3
4199402	134438	4	4
21002783	975125	0	0
21003042	791967	0	0
21602359	1519937	4	7
4092747	4043241	3	3
36313944	42535580	5	5
40796722	3006923	1	1
44362970	1129625	0	0
44342362	1119510	0	0
44362697	1759842	0	0
44347711	1115171	2	3
45637577	1124957	0	0
45620852	914335	0	0
45641618	1125315	0	0
45629800	1125315	0	0
45651367	1119510	0	0
45648529	1548195	0	0
45684237	1589505	0	0
45674056	1192710	0	0
45698282	1149380	0	0
45792249	40232448	2	3
45678032	1125315	0	0
45784585	1192710	0	0
45786575	738818	0	0
45798468	723013	0	0
45679465	1119510	0	0
45788049	1119510	0	0
46242021	1177480	0	0
46299941	975125	0	0
46322563	1000560	0	0
46319697	19079524	2	3
4154739	4237458	2	3
4199402	378419	7	8
21002793	1746114	0	0
21003079	1129625	0	0
35200000	313217	3	8
4144290	4163874	3	3
36602234	4149245	5	5
40796376	3016723	1	1
44362905	1501700	0	0
44342305	1119510	0	0
44362706	1177480	0	0
44347724	40232448	2	3
45637637	1326303	0	0
45620853	1778162	0	0
45641802	1125315	0	0
45630006	1125315	0	0
45651235	1119510	0	0
45648318	975125	0	0
45684238	1115008	0	0
45674078	1174888	0	0
45698282	1137529	0	0
45792395	19078461	2	3
45677835	1125315	0	0
45784542	1307863	0	0
45785578	738818	0	0
45798575	1501700	0	0
45679009	1119510	0	0
45788129	1119510	0	0
46241941	1177480	0	0
46299958	1000560	0	0
46327429	1107830	0	0
46301847	19075601	2	3
4162054	4293740	2	4
4199402	4230399	7	8
21002805	1177480	0	0
21003040	1154029	0	0
35802829	257012	6	8
4056681	4252419	3	3
36303152	4202451	5	5
40796407	3009201	1	1
44362821	1112807	0	0
44337832	1119510	0	0
44362707	1545958	0	0
44347922	40231925	2	3
45637716	1343916	0	0
45620855	1539403	0	0
45641524	1125315	0	0
45629770	1125315	0	0
45651352	1119510	0	0
45648471	967823	0	0
45684239	975125	0	0
45674081	914335	0	0
45698283	1717327	0	0
45792197	19008572	2	3
45677909	1125315	0	0
45784616	1322184	0	0
45785398	738818	0	0
45798584	1738521	0	0
45679086	1119510	0	0
45788134	1119510	0	0
46242429	1177480	0	0
46299870	1192710	0	0
46319864	1332418	0	0
46321014	1332419	2	3
4043017	4010253	2	4
4199402	313217	7	10
21002805	1115008	0	0
21003040	708298	0	0
35202051	257012	5	8
4056681	4024289	3	3
36502196	4048695	5	6
40796508	3006906	1	1
44363011	1124300	0	0
44337680	1119510	0	0
44362502	1759842	0	0
44348322	19019273	2	3
45637729	1154343	0	0
45620727	1545958	0	0
45641771	1125315	0	0
45626839	1125315	0	0
45651390	1119510	0	0
45648321	1107830	0	0
45684240	914335	0	0
45674103	1322184	0	0
45698076	1000560	0	0
45792182	19059056	2	3
45677970	1125315	0	0
45784546	1154343	0	0
45785531	738818	0	0
45798352	1115008	0	0
45678970	1119510	0	0
45788065	1119510	0	0
46242148	1177480	0	0
46299725	1309944	0	0
46320132	1738521	0	0
46306555	19075601	2	3
4179141	81151	2	4
4199402	378001	7	9
21002145	1741122	0	0
21003042	708298	0	0
21602359	40221415	5	8
4130852	81151	3	3
36303152	4047491	5	6
40780206	3020655	1	1
44363014	1115008	0	0
44363688	1119510	0	0
44362632	914335	0	0
44348432	19133873	2	3
45637646	1310149	0	0
45620676	1149196	0	0
45641805	1125315	0	0
45626920	1125315	0	0
45651608	1119510	0	0
45648630	738818	0	0
45684033	1738521	0	0
45673984	1738521	0	0
45698185	1107830	0	0
45792210	40229134	2	3
45677948	1125315	0	0
45784548	1153428	0	0
45785389	738818	0	0
45798720	1548195	0	0
45786031	1119510	0	0
45788240	1119510	0	0
46242196	1177480	0	0
46299745	1115008	0	0
46319954	1154029	0	0
45897073	1545959	2	3
4180169	30753	2	4
4199402	4280726	7	9
21002154	1741122	0	0
21003042	1110410	0	0
21603945	1124300	0	0
4057955	4024958	3	3
36602234	40479422	6	6
40780213	3000876	1	1
44363016	933724	0	0
44363354	1119510	0	0
44362501	1501700	0	0
44348243	1115171	2	3
45637647	1149196	0	0
45620727	1332418	0	0
45641786	1125315	0	0
45626922	1125315	0	0
45651653	1119510	0	0
45648556	1124300	0	0
45684311	708298	0	0
45673990	1192710	0	0
45698188	1153428	0	0
45792384	19023398	2	3
45679563	1125315	0	0
45784558	1551099	0	0
45783410	738818	0	0
45798725	1153428	0	0
45786544	1119510	0	0
45788070	1119510	0	0
46241928	1177480	0	0
46299820	1174888	0	0
46320157	1521369	0	0
45803875	1332419	2	3
4180169	4283893	2	5
4301351	4336464	5	9
21002154	1746114	0	0
21003026	1343916	0	0
21603453	738818	0	0
4201745	192671	3	3
36602234	40479768	6	6
40780242	3012494	1	1
44363019	1713332	0	0
44363812	1119510	0	0
44362502	1713332	0	0
44341330	19019273	2	3
45637598	1124300	0	0
45620728	1539403	0	0
45638373	1125315	0	0
45626702	1125315	0	0
45651667	1119510	0	0
45648644	1539403	0	0
45684287	1308738	0	0
45674247	1332418	0	0
45698211	1124300	0	0
45792391	1115171	2	3
45679622	1125315	0	0
45784679	1332418	0	0
45783326	738818	0	0
45798441	791967	0	0
45786561	1119510	0	0
45788093	1119510	0	0
45893691	1177480	0	0
46299822	1713332	0	0
46320161	1713332	0	0
46304338	1125315	0	0
4134423	4186930	2	5
4301351	4125906	5	5
21002222	1717327	0	0
21003069	1119510	0	0
21603462	1192710	0	0
4227253	30753	3	3
36502196	4278672	6	6
40780092	3024561	1	1
44362931	1115008	0	0
44363817	1119510	0	0
44362814	1729720	0	0
44340671	42707627	2	3
45637668	1308738	0	0
45620711	1343916	0	0
45638427	1125315	0	0
45626699	1125315	0	0
45651269	1119510	0	0
45648647	975125	0	0
45684129	1310149	0	0
45674068	1501700	0	0
45698215	738818	0	0
45676046	40228214	2	3
45674591	1125315	0	0
45784632	1713332	0	0
45783449	738818	0	0
45798561	1124957	0	0
45786368	1119510	0	0
46293850	1119510	0	0
45893765	1177480	0	0
46299822	1759842	0	0
46320161	1759842	0	0
46320119	1125315	0	0
4027384	257012	2	7
4301351	4330583	5	8
21002136	1741122	0	0
21003069	1115008	0	0
21603525	1153428	0	0
4227253	261325	3	3
36303152	42535580	6	6
40780881	3045716	1	1
44363041	1129625	0	0
44363831	1119510	0	0
44362506	1177480	0	0
44340778	19133873	2	3
45637642	1309944	0	0
45620856	1759842	0	0
45638212	1125315	0	0
45626971	1125315	0	0
45651681	1119510	0	0
45648714	1174888	0	0
45684131	1713332	0	0
45674218	1551099	0	0
45698119	1539403	0	0
45675957	1127433	2	3
45674605	1125315	0	0
45784692	1174888	0	0
45783368	738818	0	0
45798758	1110410	0	0
45786386	1119510	0	0
46294030	1119510	0	0
45893835	1177480	0	0
46299690	1124957	0	0
46319973	1551099	0	0
46320124	1125315	0	0
4038677	4310024	2	2
4301351	4242997	5	6
21002137	1741122	0	0
21003069	1177480	0	0
21603512	1150770	0	0
4141937	4337611	3	3
36500000	4155034	8	8
40782260	3036780	1	1
44362933	1545958	0	0
44363924	1119510	0	0
44362519	1000560	0	0
44340936	46275916	2	3
45637740	1332418	0	0
45620856	1713332	0	0
45638391	1125315	0	0
45626819	1125315	0	0
45651569	1119510	0	0
45648657	1307863	0	0
45684133	975125	0	0
45674219	1124300	0	0
45648931	1332418	0	0
45675972	1545959	2	3
45674625	1125315	0	0
45784706	1000560	0	0
45783516	738818	0	0
45798763	975125	0	0
45786383	1119510	0	0
46294130	1119510	0	0
45893803	1177480	0	0
46299691	1107830	0	0
46320199	1307863	0	0
46320183	1125315	0	0
4040560	4242997	2	2
4301351	4198190	6	8
21001840	1778162	0	0
21003069	1112807	0	0
21603288	1149380	0	0
36158237	1119510	0	0
36302170	4037675	8	8
40782474	3005136	1	1
44362958	1129625	0	0
44364003	1119510	0	0
44362523	1174888	0	0
44340937	19073183	2	3
45637844	967823	0	0
45661595	975125	0	0
45639955	1125315	0	0
45626801	1125315	0	0
45651570	1119510	0	0
45648575	1149196	0	0
45684283	1549786	0	0
45673742	1307863	0	0
45648933	1549786	0	0
45676078	43012036	2	3
45674689	1125315	0	0
45784798	1107830	0	0
46291583	738818	0	0
45798771	1728416	0	0
45786158	1119510	0	0
46293884	1119510	0	0
45893826	1177480	0	0
46299703	1149196	0	0
46320219	1153428	0	0
46320454	1125315	0	0
4040562	4198190	2	2
4301351	4057420	4	7
21001841	1778162	0	0
21003042	753626	0	0
21603266	1137529	0	0
36158237	738818	0	0
36302170	4035415	7	11
40654442	3028833	1	1
44363048	1310149	0	0
44363509	1119510	0	0
44362524	1107830	0	0
44340904	19019273	2	3
45637648	1124957	0	0
45661600	1728416	0	0
45640036	1125315	0	0
45626957	1125315	0	0
45651572	1119510	0	0
45648663	1153428	0	0
45684283	19127890	0	0
45673746	1192710	0	0
45648933	1521369	0	0
45676351	40174880	2	3
45674693	1125315	0	0
45784632	1759842	0	0
46291678	738818	0	0
45798824	1521369	0	0
45786160	1119510	0	0
46293543	1119510	0	0
45893837	1177480	0	0
46299785	1595799	0	0
46320222	1361711	0	0
46320363	1125315	0	0
4150819	4336464	2	2
4301351	4337611	4	5
21001839	1778162	0	0
21003079	1124300	0	0
21602517	1548195	0	0
36158241	1107830	0	0
36502196	4134304	8	8
40654504	3006906	1	1
44363019	1759842	0	0
44363577	1119510	0	0
44362607	1129625	0	0
44340849	1115171	2	3
45637651	1154343	0	0
45661603	967823	0	0
45638535	1125315	0	0
45626930	1125315	0	0
45648298	1119510	0	0
45645066	740275	0	0
45684356	738818	0	0
45673746	1174888	0	0
45648939	1308738	0	0
45789123	920300	2	3
45674699	1125315	0	0
45784622	1309944	0	0
46291715	738818	0	0
45798824	1548195	0	0
45786122	1119510	0	0
46294064	1119510	0	0
45893834	1177480	0	0
46299967	715997	0	0
46320233	1112807	0	0
46320366	1125315	0	0
4065001	4314290	2	2
4301351	44783196	4	5
21001840	1713332	0	0
21003099	791967	0	0
21602516	1549786	0	0
36158171	1515774	0	0
36602234	78272	8	8
40654685	3016723	1	1
44363126	738818	0	0
44363992	1119510	0	0
44362729	701322	0	0
44340891	1115171	2	3
45637862	1332418	0	0
45661732	1548195	0	0
45638466	1125315	0	0
45626931	1125315	0	0
45649239	1119510	0	0
45645385	1149196	0	0
45684358	1361711	0	0
45674221	19016749	0	0
45648769	1501700	0	0
45789379	40162522	2	3
45674538	1125315	0	0
45784787	1149196	0	0
46242680	738818	0	0
45798919	1713332	0	0
45786183	1119510	0	0
46294034	1119510	0	0
45801852	1177480	0	0
46300027	738818	0	0
46320130	1110410	0	0
46320488	1125315	0	0
4070456	4218408	2	2
4301351	4301346	4	5
21001842	1713332	0	0
21003069	1129625	0	0
21602540	1500211	0	0
36158171	19127890	0	0
36502196	4230399	7	7
40766216	3012494	1	1
44362978	723013	0	0
44363624	1119510	0	0
44362732	1124957	0	0
45637384	1127433	2	3
45637657	1307863	0	0
45661703	975125	0	0
45638467	1125315	0	0
45626853	1125315	0	0
45648438	1119510	0	0
45645329	1343916	0	0
45684361	1107830	0	0
45674086	1539403	0	0
45694959	1149196	0	0
45789390	40228214	2	3
45674541	1125315	0	0
45784634	1343916	0	0
46242773	738818	0	0
45798919	1759842	0	0
46292667	1119510	0	0
46294396	1119510	0	0
45801848	1177480	0	0
46300085	1174888	0	0
46320108	1154029	0	0
46320377	1125315	0	0
4063381	261325	2	2
4301351	4337138	3	4
21001840	1759842	0	0
21003081	1124957	0	0
21602102	975125	0	0
36158171	1549786	0	0
36402189	4144583	7	7
40766216	3006451	1	1
44363023	1307863	0	0
44363495	1119510	0	0
44362734	1332418	0	0
45637365	1539411	2	3
45637807	1501700	0	0
45661430	975125	0	0
45638528	1125315	0	0
45628031	1125315	0	0
45648630	1119510	0	0
45645269	1361711	0	0
45684368	1124957	0	0
45674000	1115008	0	0
45694825	1154343	0	0
45789324	40229134	2	3
45674957	1125315	0	0
45784596	1192710	0	0
46242804	738818	0	0
45798920	1107830	0	0
46292488	1119510	0	0
46294075	1119510	0	0
45802421	1177480	0	0
46300087	1551099	0	0
46320118	1124957	0	0
46320333	1125315	0	0
4187096	4230399	2	2
4244662	80180	2	2
21001840	1768849	0	0
21003081	1125315	0	0
21602136	1149380	0	0
36158174	1177480	0	0
36424251	1326303	0	0
40249018	19074679	1	1
44359235	1149380	0	0
44363609	1119510	0	0
44360439	1515774	0	0
45637355	40232448	2	3
45637741	1521369	0	0
45661708	723013	0	0
45638574	1125315	0	0
45628122	1125315	0	0
45648636	1119510	0	0
45645271	975125	0	0
45684252	1343916	0	0
45674226	738818	0	0
45695024	1000560	0	0
45777979	1367571	0	0
45674958	1125315	0	0
45784638	1107830	0	0
46242816	738818	0	0
45798921	1000560	0	0
46292575	1119510	0	0
46294475	1119510	0	0
45799139	1177480	0	0
46300089	1192710	0	0
46319905	1112807	0	0
46320592	1125315	0	0
4185284	4202451	2	2
4303053	4301346	2	2
21001846	1759842	0	0
21003081	1118084	0	0
35508516	1738521	0	0
36158175	975125	0	0
36423360	740275	0	0
40181758	40221415	1	1
44359242	920293	0	0
44356506	1119510	0	0
44360439	1549786	0	0
45621792	40232448	2	3
45637741	1549786	0	0
45661824	1545958	0	0
45638630	1125315	0	0
45628244	1125315	0	0
45645050	1119510	0	0
45645272	19127890	0	0
45684300	715997	0	0
45674228	738818	0	0
45694994	1521369	0	0
45777932	1192710	0	0
45674754	1125315	0	0
45784817	1154343	0	0
46240780	738818	0	0
45798558	1118084	0	0
46292797	1119510	0	0
46294153	1119510	0	0
45799072	1177480	0	0
46300095	1713332	0	0
46320147	1124957	0	0
46320551	1125315	0	0
4155030	4156265	2	2
4241075	4293740	2	2
21001839	1768849	0	0
21003053	791967	0	0
35508517	1713332	0	0
36157773	1177480	0	0
36416757	1154029	0	0
40181782	40221415	1	1
44359243	1129625	0	0
44356538	1119510	0	0
44360481	1129625	0	0
45621794	19078924	2	3
45637687	738818	0	0
45661433	1310149	0	0
45638604	1125315	0	0
45628210	1125315	0	0
45645434	1119510	0	0
45645272	1549786	0	0
45680883	1713332	0	0
45674229	920293	0	0
45694994	19127890	0	0
45777915	738818	0	0
45674640	1125315	0	0
45784665	1174888	0	0
46240720	738818	0	0
45798740	1322184	0	0
46293071	1119510	0	0
46294155	1119510	0	0
45799104	1177480	0	0
46300220	1153428	0	0
46320149	1000560	0	0
46320650	1125315	0	0
4115236	4294548	2	2
4327941	4043071	2	2
21001846	1713332	0	0
21003069	738818	0	0
35508518	1124300	0	0
36158124	1107830	0	0
36416791	708298	0	0
40181784	40221415	1	1
44359251	1115008	0	0
44356505	1119510	0	0
44360548	1545958	0	0
45620583	1115171	2	3
45637865	1110410	0	0
45661516	1192710	0	0
45638505	1125315	0	0
45628225	1125315	0	0
45645556	1119510	0	0
45645276	1107830	0	0
45680884	975125	0	0
45674230	1717327	0	0
45694994	1549786	0	0
45777943	1149196	0	0
45674646	1125315	0	0
45784912	967823	0	0
46272569	40492359	3	3
45798574	1759842	0	0
46292507	1119510	0	0
46294301	1119510	0	0
45799300	1177480	0	0
46300232	1107830	0	0
46320151	1149196	0	0
46320800	1125315	0	0
4125928	4108705	2	2
4307254	4230399	2	2
21001849	1759842	0	0
21003099	723013	0	0
35508618	1309944	0	0
36158073	1112807	0	0
36429708	1307863	0	0
40220385	40220386	1	1
44362605	1124957	0	0
44356740	1119510	0	0
44360440	975125	0	0
45620586	40232448	2	3
45637798	1124957	0	0
45661519	738818	0	0
45638582	1125315	0	0
45627062	1125315	0	0
45645463	1119510	0	0
45645048	1149196	0	0
45680886	1107830	0	0
45673981	1192710	0	0
45694562	1124300	0	0
45777903	738818	0	0
45674987	1125315	0	0
45784823	914335	0	0
46240186	19128022	3	4
45798687	1115008	0	0
46293009	1119510	0	0
46294485	1119510	0	0
45799432	1177480	0	0
46300235	914335	0	0
46313774	1112807	0	0
46320410	1125315	0	0
4074722	4107731	2	2
4283893	4294548	2	2
21001842	1759842	0	0
21003069	1192710	0	0
35508633	1545958	0	0
36157967	1129625	0	0
36427078	1361711	0	0
40165009	40165015	1	1
44362548	738818	0	0
44356741	1119510	0	0
44360557	1124957	0	0
45620570	19059056	2	3
45637767	1500211	0	0
45661944	1551099	0	0
45638628	1125315	0	0
45627079	1125315	0	0
45645134	1119510	0	0
45645145	1174888	0	0
45698764	1192710	0	0
45674114	1310149	0	0
45694964	1110410	0	0
45777876	1307863	0	0
45674784	1125315	0	0
45784834	1539403	0	0
45697433	19127904	3	4
45798774	1000560	0	0
46293047	1119510	0	0
46294488	1119510	0	0
45799410	1177480	0	0
46300061	1115008	0	0
46313774	1124957	0	0
46320411	1125315	0	0
4074298	4186930	2	2
4353828	317576	2	2
21001849	1778162	0	0
21003069	1125315	0	0
35508640	1129625	0	0
36157971	1118084	0	0
36427086	1308738	0	0
40102982	920334	1	1
44362653	1551099	0	0
44356624	1119510	0	0
44353463	1192710	0	0
45620732	1115171	2	3
45637781	1521369	0	0
45661947	914335	0	0
45638683	1125315	0	0
45623763	1125315	0	0
45645510	1119510	0	0
45645433	967823	0	0
45698733	1192710	0	0
45674232	1551099	0	0
45694596	1310149	0	0
45777879	1713332	0	0
45674786	1125315	0	0
45784715	1549786	0	0
45802402	19129144	3	4
45793176	1124957	0	0
46292657	1119510	0	0
46294214	1119510	0	0
45793933	1177480	0	0
46300103	1107830	0	0
46313780	1332418	0	0
46320434	1125315	0	0
4073634	4107731	2	2
4303802	438614	2	2
21001846	1778162	0	0
21003108	19003953	0	0
35508640	1115008	0	0
36157857	1177480	0	0
36427076	920293	0	0
40128143	40229134	1	1
44362656	914335	0	0
44356672	1119510	0	0
44353463	1174888	0	0
45620673	46275444	2	3
45637892	1115008	0	0
45661854	1713332	0	0
45635455	1125315	0	0
45623721	1125315	0	0
45645520	1119510	0	0
45645434	1192710	0	0
45698738	1192710	0	0
45673755	740275	0	0
45695049	1332418	0	0
45777880	1717327	0	0
45674955	1125315	0	0
45784715	1521369	0	0
45786850	19133679	3	4
45793269	975125	0	0
46292961	1119510	0	0
46294234	1119510	0	0
45794032	1177480	0	0
46300002	975125	0	0
46313807	1124300	0	0
46320867	1125315	0	0
4085100	4112343	2	2
4303802	442116	2	2
21001846	1717327	0	0
21003110	19003953	0	0
35508642	1119510	0	0
36157858	1112807	0	0
36424660	1548195	0	0
40061664	40165015	1	1
44362578	1332418	0	0
44356662	1119510	0	0
44353471	1343916	0	0
45620701	1127433	2	3
45637993	715997	0	0
45661746	975125	0	0
45635251	1125315	0	0
45623816	1125315	0	0
45642454	1119510	0	0
45645246	1521369	0	0
45695465	1192710	0	0
45673771	1501700	0	0
45694635	1539403	0	0
45778010	1539403	0	0
45674633	1125315	0	0
45784716	1153428	0	0
45876037	3014576	3	6
46240961	1129625	0	0
46293194	1119510	0	0
46294563	1119510	0	0
45789340	1177480	0	0
46300111	738818	0	0
46314344	1149196	0	0
46320662	1125315	0	0
4073287	4056621	2	2
4303802	4169137	2	2
21001850	1778162	0	0
21003079	1174888	0	0
35508648	1308738	0	0
36157865	920293	0	0
36463106	1149196	0	0
40021194	19074679	1	1
44362759	1000560	0	0
44356722	1119510	0	0
44353588	1115008	0	0
45620850	19008572	2	3
45637794	933724	0	0
45661856	967823	0	0
45635339	1125315	0	0
45623928	1125315	0	0
45642569	1119510	0	0
45645246	1595799	0	0
45692480	1192710	0	0
45673774	1174888	0	0
45695113	1361711	0	0
45707779	914335	0	0
45674970	1125315	0	0
45784722	1713332	0	0
45876037	3045716	3	6
46240753	1129625	0	0
46293210	1119510	0	0
46294439	1119510	0	0
45789397	1177480	0	0
46300112	723013	0	0
46314345	933724	0	0
46320918	1125315	0	0
4154162	4218389	2	2
4303802	4139681	2	2
21001850	1717327	0	0
21003081	1177480	0	0
35508890	1125315	0	0
36157972	967823	0	0
36463107	1713332	0	0
40021195	19074679	1	1
44362776	1713332	0	0
44356970	1119510	0	0
44353592	1124300	0	0
45661569	1115171	2	3
45637904	1115008	0	0
45661527	1500211	0	0
45635435	1125315	0	0
45623822	1125315	0	0
45642552	1119510	0	0
45645246	1549786	0	0
45692430	1192710	0	0
45674233	967823	0	0
45695124	1115008	0	0
45707835	1174888	0	0
45674976	1125315	0	0
45784722	1759842	0	0
45876037	3019550	3	6
46241094	1129625	0	0
46292768	1119510	0	0
46293974	1119510	0	0
45788790	1177480	0	0
46300130	1153428	0	0
46313808	1149196	0	0
46320631	1125315	0	0
4074287	4117038	2	2
19091065	19128009	2	2
21001849	1717327	0	0
21003081	1110410	0	0
35508891	1713332	0	0
36157976	1115008	0	0
36463112	1119510	0	0
37503938	4059978	1	1
44362616	914335	0	0
44356999	1119510	0	0
44353478	1332418	0	0
45662007	40236824	2	3
45637909	738818	0	0
45661569	1115008	0	0
45635402	1125315	0	0
45624068	1125315	0	0
45642559	1119510	0	0
45645258	1174888	0	0
45692729	1192710	0	0
45674234	1307863	0	0
45694799	967823	0	0
45707838	1521369	0	0
45674977	1125315	0	0
45784915	975125	0	0
45876037	3013721	3	5
46241033	1129625	0	0
46293333	1119510	0	0
46294453	1119510	0	0
45788784	1177480	0	0
46300145	933724	0	0
46313830	1192710	0	0
46320632	1125315	0	0
4186164	4278672	2	2
4242290	81151	2	2
21001860	1343916	0	0
21003082	1125315	0	0
35508586	1738521	0	0
36157977	1119510	0	0
36463118	1549786	0	0
37203741	441267	1	1
44362617	1521369	0	0
44357094	1119510	0	0
44353594	1153428	0	0
45661561	19019273	2	3
45637967	1545958	0	0
45661879	1124957	0	0
45635289	1125315	0	0
45624070	1125315	0	0
45642632	1119510	0	0
45645417	723013	0	0
45692519	1192710	0	0
45674274	1107830	0	0
45695104	738818	0	0
45707838	1595799	0	0
45674879	1125315	0	0
45784772	1174888	0	0
45876037	3015632	3	6
46240851	1129625	0	0
46293398	1119510	0	0
46294388	1119510	0	0
45788834	1177480	0	0
46300260	708298	0	0
46313837	19003953	0	0
46320879	1125315	0	0
4027880	4285898	2	2
4208786	80502	2	2
21600192	914335	0	0
21003081	1124300	0	0
35508397	1115008	0	0
36157977	738818	0	0
36463118	1515774	0	0
37203741	317009	1	1
44359387	1551099	0	0
44357046	1119510	0	0
44353432	1746114	0	0
45662002	19008572	2	3
45637968	1149196	0	0
45661884	1153428	0	0
45635247	1125315	0	0
45624074	1125315	0	0
45640051	1119510	0	0
45645556	738818	0	0
45692445	1192710	0	0
45674239	1551099	0	0
45695106	1500211	0	0
45707838	1549786	0	0
45674887	1125315	0	0
45784924	1310149	0	0
45876037	3006923	3	5
46238192	1129625	0	0
46292888	1119510	0	0
46243710	1119510	0	0
45788881	1177480	0	0
46300268	1153428	0	0
46313719	1174888	0	0
46315054	1125315	0	0
4027717	4238715	2	2
4207185	4294548	2	2
21600234	1326303	0	0
21003081	1154029	0	0
35508786	1539403	0	0
36157869	1149196	0	0
36427229	1000560	0	0
37203747	261325	1	1
44359393	791967	0	0
44357104	1119510	0	0
44353432	1741122	0	0
45661982	40231925	2	3
45638032	1713332	0	0
45661532	738818	0	0
45635449	1125315	0	0
45623843	1125315	0	0
45639476	1119510	0	0
45645239	1107830	0	0
45692604	1192710	0	0
45674310	967823	0	0
45695077	1149196	0	0
45707810	1000560	0	0
45674666	1125315	0	0
45784764	975125	0	0
45876037	3006906	3	5
46240207	1129625	0	0
46287955	1119510	0	0
46243663	1119510	0	0
46295416	1177480	0	0
46300401	1589505	0	0
46313731	1326303	0	0
46314285	1125315	0	0
4093991	4280726	4	5
4329725	4337138	2	2
21503162	1129625	0	0
21600493	1000560	0	0
35508399	1118084	0	0
36158001	701322	0	0
36427091	1521369	0	0
37003672	198199	1	1
44359421	742185	0	0
44357024	1119510	0	0
44353439	1500211	0	0
45664310	42707627	2	3
45638032	1759842	0	0
45661534	1107830	0	0
45635267	1125315	0	0
45623773	1125315	0	0
45639450	1119510	0	0
45645563	1174888	0	0
45692550	1192710	0	0
45674269	1153428	0	0
45695080	1738521	0	0
45707758	1118084	0	0
45674668	1125315	0	0
45784766	1174888	0	0
45876037	3024561	3	5
46238225	1129625	0	0
46288317	1119510	0	0
46243667	1119510	0	0
46244274	1177480	0	0
46300172	1713332	0	0
46314094	1112807	0	0
46313873	1125315	0	0
4093991	40486433	4	5
4251030	4047491	2	2
21503163	1149196	0	0
21501130	1759842	0	0
35508741	1500211	0	0
36158009	967823	0	0
36427297	1124957	0	0
37017419	4336464	1	1
44359364	1177480	0	0
44357191	1119510	0	0
44353548	1500211	0	0
45658205	19008572	2	3
45637992	1713332	0	0
45662007	933724	0	0
45635521	1125315	0	0
45623922	1125315	0	0
45639738	1119510	0	0
45645440	708298	0	0
45692703	1192710	0	0
45674258	1174888	0	0
45695054	1343916	0	0
45707778	1174888	0	0
45674768	1125315	0	0
45784734	1729720	0	0
45876037	3027970	3	5
45897256	1129625	0	0
46288476	1119510	0	0
46243864	1119510	0	0
46244430	1177480	0	0
46300174	1115008	0	0
46314095	1000560	0	0
46314894	1125315	0	0
4093991	134438	4	5
21001382	19133905	2	3
21503194	914335	0	0
21602842	1729720	0	0
35508745	1115008	0	0
21604344	1125315	0	0
36427387	926487	0	0
36718163	378419	1	1
44359444	1107830	0	0
44350113	1119510	0	0
44353551	1521369	0	0
45655882	19078924	2	3
45634686	1107830	0	0
45662008	1308738	0	0
45635533	1125315	0	0
45623682	1125315	0	0
45639524	1119510	0	0
45645125	1174888	0	0
45692669	1192710	0	0
45673639	1153428	0	0
45695085	1149196	0	0
45707801	1501700	0	0
45675084	1125315	0	0
45784934	1738521	0	0
45876037	3004501	3	5
45897185	1129625	0	0
46288477	1119510	0	0
46243891	1119510	0	0
46244518	1177480	0	0
46299853	1124300	0	0
46314122	1305058	0	0
46314896	1125315	0	0
4180627	4181917	4	5
21001034	19129655	2	3
21503163	1107830	0	0
21602831	1746114	0	0
35508755	1343916	0	0
36156768	1125315	0	0
36424688	1549786	0	0
36718526	4029498	1	1
44359432	1539403	0	0
44349644	1119510	0	0
44353648	1129625	0	0
45655669	19059056	2	3
45634690	933724	0	0
45661561	1115008	0	0
45635413	1125315	0	0
45624090	1125315	0	0
45639679	1119510	0	0
45645459	1310149	0	0
45692672	1192710	0	0
45674337	1154029	0	0
45694820	1000560	0	0
45707813	1548195	0	0
45675168	1125315	0	0
45782654	1307863	0	0
45876037	3020630	3	5
45897348	1129625	0	0
46288022	1119510	0	0
46243674	1119510	0	0
45787392	1129625	0	0
46300151	705944	0	0
46313838	1112807	0	0
46314899	1125315	0	0
4180627	4243062	4	5
21000108	19129655	2	3
21503163	1150836	0	0
21603256	1154343	0	0
35508762	1125315	0	0
36156772	1125315	0	0
36424689	1549786	0	0
40220958	40220960	1	1
44359368	1729720	0	0
44349782	1119510	0	0
44353651	1129625	0	0
45655802	19078924	2	3
45634657	1717327	0	0
45661690	1110410	0	0
45635595	1125315	0	0
45623792	1125315	0	0
45636361	1119510	0	0
45645550	1717327	0	0
45689587	1192710	0	0
45674345	1154029	0	0
45694924	1343916	0	0
45707824	967823	0	0
45674914	1125315	0	0
45782401	1367571	0	0
45876037	3000963	5	6
45897402	1129625	0	0
46288028	1119510	0	0
46243876	1119510	0	0
45787591	1129625	0	0
46300340	738818	0	0
46314028	1149196	0	0
46314901	1125315	0	0
4180627	4163872	4	5
21000061	19129655	2	3
21503163	1153428	0	0
21602886	1768849	0	0
35508762	1174888	0	0
36156776	1125315	0	0
36424721	1519936	0	0
40220959	40220960	1	1
44359374	1149380	0	0
44349794	1119510	0	0
44353613	1124300	0	0
45655782	40228230	2	3
45634662	914335	0	0
45661841	1124957	0	0
45635645	1125315	0	0
45623800	1125315	0	0
45636033	1119510	0	0
45645463	1192710	0	0
45689713	1192710	0	0
45674045	738818	0	0
45694931	1149196	0	0
45707879	1713332	0	0
45674925	1125315	0	0
45782341	1192710	0	0
45876049	3009201	2	2
45897499	1129625	0	0
46288298	1119510	0	0
46243774	1119510	0	0
45802229	1129625	0	0
46300344	1545958	0	0
46314355	920293	0	0
46314799	1125315	0	0
4042150	4238715	4	5
21000084	19133905	2	3
21503168	1125315	0	0
21003084	1124957	0	0
35508765	742185	0	0
36156780	1125315	0	0
36313965	4024958	5	5
40221144	44816277	1	1
44359428	1595799	0	0
44350157	1119510	0	0
44353573	1332418	0	0
44348254	40223834	2	3
45634676	1118084	0	0
45661842	1174888	0	0
45635655	1125315	0	0
45624095	1125315	0	0
45636217	1119510	0	0
45645575	1738521	0	0
45689729	1192710	0	0
45674049	1551099	0	0
45695066	738818	0	0
45707919	1107830	0	0
45674929	1125315	0	0
45782342	740275	0	0
45786320	19128009	2	2
45897411	1129625	0	0
46288310	1119510	0	0
46244772	1119510	0	0
45802333	1129625	0	0
46300532	1154343	0	0
46313916	1545958	0	0
46314803	1125315	0	0
4040400	44783196	4	5
21000090	19076374	2	3
21503168	1129625	0	0
21003084	1177480	0	0
35508769	1000560	0	0
36156387	1125315	0	0
36313965	4243062	5	5
40085778	1150837	1	1
44359460	1112807	0	0
44349942	1119510	0	0
44353576	1361711	0	0
44348405	19008572	2	3
45634705	19003953	0	0
45661844	967823	0	0
45635660	1125315	0	0
45624051	1125315	0	0
45636442	1119510	0	0
45645138	1310149	0	0
45689632	1192710	0	0
45674051	967823	0	0
45697584	740275	0	0
45707991	738818	0	0
45671838	1125315	0	0
45782356	1332418	0	0
45786320	19127918	2	2
45894943	1129625	0	0
46288311	1119510	0	0
46244777	1119510	0	0
45801318	1129625	0	0
46300246	1124957	0	0
46314137	1545958	0	0
46314808	1125315	0	0
4040400	4117038	4	5
21000084	19133873	2	3
21503172	1174888	0	0
21003079	914335	0	0
35508888	1118084	0	0
35506952	1125315	0	0
36313965	4314290	5	5
36718045	381316	1	1
44359375	1174888	0	0
44349952	1119510	0	0
44353682	1115008	0	0
44348409	40229134	2	3
45634747	1115008	0	0
45662002	975125	0	0
45635325	1125315	0	0
45624055	1125315	0	0
45636526	1119510	0	0
45645481	975125	0	0
45686615	1192710	0	0
45674052	738818	0	0
45645897	740275	0	0
45705089	1713332	0	0
45671942	1125315	0	0
45782438	1713332	0	0
46288185	42902245	2	2
45895190	1129625	0	0
46288259	1119510	0	0
46244780	1119510	0	0
45801312	1129625	0	0
46300182	791967	0	0
46314429	967823	0	0
46314811	1125315	0	0
4043025	4301346	3	5
4306074	4010253	2	3
21503178	1154343	0	0
21003084	914335	0	0
35508520	1548195	0	0
35506898	1125315	0	0
36313965	4163872	5	5
40181755	40221415	1	1
44359428	1521369	0	0
44350201	1119510	0	0
44353683	1000560	0	0
45651976	46275444	2	3
45634760	1115008	0	0
45661886	791967	0	0
45635552	1125315	0	0
45623888	1125315	0	0
45636436	1119510	0	0
45645485	1149196	0	0
45686647	1192710	0	0
45674182	1153428	0	0
45645979	1115008	0	0
45705089	1759842	0	0
45671842	1125315	0	0
45782438	1759842	0	0
46243537	19128022	2	2
45895014	1129625	0	0
46288360	1119510	0	0
46238901	1119510	0	0
45795919	1129625	0	0
46300183	975125	0	0
46314782	1124300	0	0
46314816	1125315	0	0
4180627	4252419	3	5
21000141	19133873	2	3
21503179	1149380	0	0
21003084	1174888	0	0
35508521	1119510	0	0
35506941	1125315	0	0
36313965	4252419	5	6
36718119	4029498	1	1
44359428	1549786	0	0
44349968	1119510	0	0
44353488	1112807	0	0
45649408	40162522	2	3
45634819	1545958	0	0
45661895	1174888	0	0
45632428	1125315	0	0
45623697	1125315	0	0
45636561	1119510	0	0
45645475	1124300	0	0
45686883	1192710	0	0
45674184	708298	0	0
45645801	1115008	0	0
45705045	1713332	0	0
45671828	1125315	0	0
45782439	1500211	0	0
45876069	3013682	2	2
45895211	1129625	0	0
46288417	1119510	0	0
46238902	1119510	0	0
45795798	1129625	0	0
46300184	738818	0	0
46313922	1551099	0	0
46314821	1125315	0	0
4043022	4238715	3	5
441840	372328	5	8
21503179	1137529	0	0
21003079	1192710	0	0
35508521	738818	0	0
35507131	1125315	0	0
36313965	4024289	5	6
40057961	40223768	1	1
44359448	1738521	0	0
44350164	1119510	0	0
44353708	1000560	0	0
45649962	1127433	2	3
45634442	1738521	0	0
45661692	1174888	0	0
45632324	1125315	0	0
45624113	1125315	0	0
45636152	1119510	0	0
45645554	1551099	0	0
45686964	1192710	0	0
45674193	1521369	0	0
45691751	1738521	0	0
45705045	1759842	0	0
45672107	1125315	0	0
45782522	1713332	0	0
45876069	3006906	2	2
45895150	1129625	0	0
46288434	1119510	0	0
46238903	1119510	0	0
45795945	1129625	0	0
46300323	1115008	0	0
46314390	975125	0	0
46315082	1125315	0	0
4180169	440448	3	5
441840	4152936	5	10
21503065	1343916	0	0
21003079	1115008	0	0
35508523	1129625	0	0
35507054	1125315	0	0
36313965	4058899	5	7
40105046	1713671	1	1
44359433	1149196	0	0
44349826	1119510	0	0
44353503	1107830	0	0
45649220	40174880	2	3
45634815	1332418	0	0
45661785	738818	0	0
45632287	1125315	0	0
45668028	1125315	0	0
45636340	1119510	0	0
45645510	738818	0	0
45687017	1192710	0	0
45674193	19127890	0	0
45691719	1124300	0	0
45705133	1149380	0	0
45671972	1125315	0	0
45783590	19003953	0	0
45895468	19128022	2	2
45895337	1129625	0	0
46288456	1119510	0	0
46238870	1119510	0	0
45795955	1129625	0	0
46295767	1110410	0	0
46314395	1149196	0	0
46314747	1125315	0	0
4093991	4310024	3	5
441840	4056621	5	9
21503281	975125	0	0
21003079	1125315	0	0
35508659	1549786	0	0
35507056	1125315	0	0
36313965	40478878	4	4
36718005	381316	0	0
44359853	1177480	0	0
44350088	1119510	0	0
44353414	1539403	0	0
44354696	1551192	2	3
45634737	1149196	0	0
45661837	1192710	0	0
45632296	1125315	0	0
45668034	1125315	0	0
45636644	1119510	0	0
45645522	738818	0	0
45686813	1192710	0	0
45674193	1549786	0	0
45691860	1149196	0	0
45704800	1310149	0	0
45671743	1125315	0	0
45783674	1107830	0	0
45679375	19008572	2	3
45894521	1129625	0	0
46288772	1119510	0	0
46238921	1119510	0	0
45790670	1129625	0	0
46295857	914335	0	0
46314785	1174888	0	0
46314192	1125315	0	0
4180628	134438	3	5
441840	4310024	5	9
21003454	1595799	0	0
21003090	1124957	0	0
35508659	1515774	0	0
35507061	1125315	0	0
36313965	4062501	4	4
40766240	40766240	0	0
44359982	1305058	0	0
44350124	1119510	0	0
44353415	975125	0	0
45655934	40223834	2	3
45634741	1310149	0	0
45661982	1124957	0	0
45632289	1125315	0	0
45667648	1125315	0	0
45636469	1119510	0	0
45645940	975125	0	0
45687034	1192710	0	0
45674194	738818	0	0
45691864	1310149	0	0
45704688	1107830	0	0
45671750	1125315	0	0
45783547	1149380	0	0
45679794	40232448	2	3
45894496	1129625	0	0
46288803	1119510	0	0
46238922	1119510	0	0
45790674	1129625	0	0
46296139	1501700	0	0
46314626	1713332	0	0
46314777	1125315	0	0
4162054	4107731	3	5
441840	4283893	5	9
21003454	19054876	0	0
21003091	1124957	0	0
35508668	1174888	0	0
35507141	1125315	0	0
36313965	4145310	4	4
40249018	740275	0	0
44359474	1177480	0	0
44350071	1119510	0	0
44353419	1192710	0	0
45655934	40223821	2	3
45634745	1309944	0	0
45661985	738818	0	0
45632293	1125315	0	0
45667988	1125315	0	0
45636675	1119510	0	0
45642530	1713332	0	0
45683693	1192710	0	0
45674346	1192710	0	0
45691891	1713332	0	0
45704693	1717327	0	0
45671753	1125315	0	0
45783548	1124300	0	0
45679032	40232448	2	3
45803008	1129625	0	0
46288691	1119510	0	0
46238923	1119510	0	0
45790587	1129625	0	0
46296306	1778162	0	0
46314408	1332418	0	0
46314940	1125315	0	0
4042150	4186930	3	6
441840	4174876	5	6
21003454	1521369	0	0
21003086	1102527	0	0
35508678	975125	0	0
35507174	1125315	0	0
36313965	4047491	6	7
40479768	40479768	0	0
44359430	19127890	0	0
44350075	1119510	0	0
44353535	1332418	0	0
44340911	19019273	2	3
45634805	1115008	0	0
45661908	1115008	0	0
45632335	1125315	0	0
45667991	1125315	0	0
45636605	1119510	0	0
45642346	1149196	0	0
45683889	1192710	0	0
45674318	1124957	0	0
45691891	1759842	0	0
45704694	1308738	0	0
45671790	1125315	0	0
45783579	1717327	0	0
45679055	40169216	2	3
45803279	1129625	0	0
46288694	1119510	0	0
46238895	1119510	0	0
45790762	1129625	0	0
46296318	1124300	0	0
46314555	1112807	0	0
46314959	1125315	0	0
4180169	257012	3	6
441840	440086	5	7
21003454	1589505	0	0
21003084	1154029	0	0
35508683	1729720	0	0
35507129	1125315	0	0
36303153	4048171	8	13
40479422	40479422	0	0
44359430	1589505	0	0
44350101	1119510	0	0
44353538	967823	0	0
44337399	19019273	2	3
45634420	1110410	0	0
45661928	1310149	0	0
45632337	1125315	0	0
45667978	1125315	0	0
45636940	1119510	0	0
45642501	1192710	0	0
45683893	1192710	0	0
45673724	738818	0	0
45691898	1309944	0	0
45704701	1332418	0	0
45671857	1125315	0	0
45783587	1322184	0	0
45678968	40232448	2	3
45803288	1129625	0	0
46288701	1119510	0	0
46238898	1119510	0	0
45790984	1129625	0	0
46296347	1149380	0	0
46314575	1112807	0	0
46314979	1125315	0	0
4199402	4278672	5	6
441840	140673	5	7
21003454	19127890	0	0
21003091	1174888	0	0
35508686	1741122	0	0
36152536	1125315	0	0
36303153	313217	8	13
40250232	967823	0	0
44359430	1549786	0	0
44350127	1119510	0	0
44353546	1361711	0	0
44348222	19123231	2	3
45634817	1500211	0	0
45661968	1309944	0	0
45632416	1125315	0	0
45667984	1125315	0	0
45637054	1119510	0	0
45642510	791967	0	0
45684008	1192710	0	0
45674358	1115008	0	0
45691543	1521369	0	0
45704928	757627	0	0
45672234	1125315	0	0
45783624	1124300	0	0
45679125	40232448	2	3
45803411	1129625	0	0
46288761	1119510	0	0
46238899	1119510	0	0
45790720	1129625	0	0
46296353	1000560	0	0
46314582	1192710	0	0
46314910	1125315	0	0
4172024	4240902	5	6
441840	4094814	5	5
21003454	1518198	0	0
21003090	1110410	0	0
35508686	1746114	0	0
36152491	1125315	0	0
36303153	375671	8	12
40480160	40480160	0	0
44359431	1129625	0	0
44349682	1119510	0	0
44353551	1549786	0	0
44340939	1545959	2	3
45634556	1154029	0	0
45661760	1778162	0	0
45632352	1125315	0	0
45667780	1125315	0	0
45633278	1119510	0	0
45642384	1149196	0	0
45684018	1192710	0	0
45673913	1192710	0	0
45691530	738818	0	0
45705050	1557272	0	0
45671871	1125315	0	0
45783644	1107830	0	0
45785844	40223834	2	3
45803080	1129625	0	0
46288716	1119510	0	0
46239042	1119510	0	0
46297406	1129625	0	0
46296468	967823	0	0
46314796	1738521	0	0
46314912	1125315	0	0
4172024	4219399	5	6
441840	4029498	4	7
21003454	1515774	0	0
21003091	1154029	0	0
35508697	1307863	0	0
36152494	1125315	0	0
36303153	4059173	8	11
40213198	40213198	0	0
44359381	1521369	0	0
44349669	1119510	0	0
44353645	1129625	0	0
44354886	1545959	2	3
45634680	1124300	0	0
45661761	975125	0	0
45632355	1125315	0	0
45667893	1125315	0	0
45633190	1119510	0	0
45642434	715997	0	0
45680862	1192710	0	0
45674299	1124300	0	0
45691577	1149196	0	0
45705059	1192710	0	0
45672137	1125315	0	0
45782678	1115008	0	0
45785976	1107882	2	3
45800485	1129625	0	0
46243296	1119510	0	0
46238992	1119510	0	0
46297345	1129625	0	0
600000007	1557272	0	0
46314456	1192710	0	0
46314919	1125315	0	0
4172024	37017711	5	6
441840	317576	4	10
21003454	1549786	0	0
21003084	1110410	0	0
35508405	1125315	0	0
36152598	1125315	0	0
36303153	81893	8	14
40213201	40213201	0	0
44359381	1549786	0	0
44342512	1119510	0	0
44353684	1589505	0	0
44351256	1545959	2	3
45634788	914335	0	0
45661899	975125	0	0
45632340	1125315	0	0
45668015	1125315	0	0
45633203	1119510	0	0
45642448	1713332	0	0
45680863	1192710	0	0
45674303	1192710	0	0
45691674	1738521	0	0
45707178	19128022	3	4
45672026	1125315	0	0
45782707	933724	0	0
45786067	40174880	2	3
45800583	1129625	0	0
46243339	1119510	0	0
46238993	1119510	0	0
46297349	1129625	0	0
600000010	1310149	0	0
46314512	705944	0	0
46314699	1125315	0	0
4042140	44782520	5	6
441840	4027663	4	8
21003454	1548195	0	0
21003091	1110410	0	0
35508406	791967	0	0
36152521	1125315	0	0
36303153	4219399	8	9
40213314	40213314	0	0
44359535	1124957	0	0
44342431	1119510	0	0
44353684	19127890	0	0
44341545	19078461	2	3
45634759	1153428	0	0
45664310	19003953	0	0
45632432	1125315	0	0
45670123	1125315	0	0
45633291	1119510	0	0
45642451	1124957	0	0
45677481	1192710	0	0
45673889	708298	0	0
45691642	967823	0	0
45781363	19128022	3	4
45672028	1125315	0	0
45782737	1713332	0	0
45786544	40229134	2	3
45800687	1129625	0	0
46243301	1119510	0	0
46239295	1119510	0	0
46297558	1129625	0	0
46318351	1149196	0	0
46314682	1545958	0	0
46314700	1125315	0	0
4040396	4198190	5	6
441840	317009	4	5
21003454	1519936	0	0
21003084	1102527	0	0
35508719	1119510	0	0
36152725	1125315	0	0
36303153	4240902	8	9
40213320	40213320	0	0
44359617	740275	0	0
44342586	1119510	0	0
44353684	1549786	0	0
45662011	1127433	2	3
45636801	1110410	0	0
45655524	1539403	0	0
45632702	1125315	0	0
45670276	1125315	0	0
45633317	1119510	0	0
45642452	1124957	0	0
45674157	1192710	0	0
45674017	914335	0	0
45691629	1332418	0	0
45671700	19128009	2	2
45672030	1125315	0	0
45782850	1124957	0	0
45786676	40232448	2	3
45800561	1129625	0	0
46243468	1119510	0	0
46239111	1119510	0	0
46297562	1129625	0	0
46318336	1326303	0	0
46313857	1107830	0	0
46317746	1125315	0	0
4093991	4048171	5	6
441840	37017711	7	8
21003454	1512674	0	0
21003118	975125	0	0
35508720	1124300	0	0
36152762	1125315	0	0
36303153	78272	7	13
40213154	40213154	0	0
44359619	967823	0	0
44342131	1119510	0	0
44353693	1124300	0	0
45662011	19078461	2	3
45636891	705944	0	0
45655567	1149196	0	0
45629211	1125315	0	0
45670001	1125315	0	0
45633438	1119510	0	0
45642597	975125	0	0
45676229	1192710	0	0
45674024	1738521	0	0
45691919	715997	0	0
45766058	4330583	2	2
45672157	1125315	0	0
45782765	967823	0	0
45786682	43012036	2	3
45800699	1129625	0	0
46243348	1119510	0	0
46239298	1119510	0	0
46297418	1129625	0	0
46318445	975125	0	0
46315008	715997	0	0
46317968	1125315	0	0
4117930	198199	4	6
441840	4240902	7	8
21003455	19127890	0	0
21003118	1149380	0	0
35508775	1115008	0	0
36152880	1125315	0	0
36303153	441267	7	8
40213160	40213160	0	0
44359523	1717327	0	0
44342264	1119510	0	0
44353747	1177480	0	0
44347456	1551192	2	3
45631645	1595799	0	0
45655576	1713332	0	0
45629297	1125315	0	0
45670049	1125315	0	0
45633557	1119510	0	0
45642627	1174888	0	0
45674467	1192710	0	0
45674026	1107830	0	0
45691753	1174888	0	0
45763613	81893	2	2
45671772	1125315	0	0
45782769	1192710	0	0
45786287	1115171	2	3
45800839	1129625	0	0
46240854	1119510	0	0
46239306	1119510	0	0
46297284	1129625	0	0
46318372	914335	0	0
46315014	967823	0	0
46317164	1125315	0	0
4043161	4107731	4	6
441840	4219399	7	8
21003511	1000560	0	0
21003090	1174888	0	0
35508907	1129625	0	0
36152577	1125315	0	0
36303153	438614	7	8
40213216	40213216	0	0
44359527	1129625	0	0
44344655	1119510	0	0
44353663	1192710	0	0
44358085	1545959	2	3
45631464	1549786	0	0
45658264	738818	0	0
45629300	1125315	0	0
45670288	1125315	0	0
45633687	1119510	0	0
45642602	723013	0	0
45674546	1192710	0	0
45671150	1000560	0	0
45691768	967823	0	0
45765647	4001336	2	2
45672171	1125315	0	0
45782732	1557272	0	0
46292550	46275444	2	3
45800744	1129625	0	0
46240858	1119510	0	0
46239205	1119510	0	0
46297908	1129625	0	0
46318376	914335	0	0
46314721	967823	0	0
46317359	1125315	0	0
4043022	4186930	4	6
441840	4166224	7	11
21003511	791967	0	0
21003153	1129625	0	0
35508908	1112807	0	0
36152579	1125315	0	0
36303153	4102123	7	8
40213227	40213227	0	0
44359624	1149196	0	0
44342631	1119510	0	0
44353663	1112807	0	0
45655751	1551192	2	3
45631464	19127890	0	0
45658006	753626	0	0
45629303	1125315	0	0
45670079	1125315	0	0
45630284	1119510	0	0
45642413	1515774	0	0
45671608	1192710	0	0
45671151	1551099	0	0
45691774	1322184	0	0
45690321	19128022	2	2
45671780	1125315	0	0
45782733	1115008	0	0
46293077	35605482	2	3
45797776	1129625	0	0
46242546	1119510	0	0
46239029	1119510	0	0
46297897	1129625	0	0
46318807	933724	0	0
46308893	1545958	0	0
46315285	1125315	0	0
4180169	81893	4	6
441840	378001	7	11
21003455	1549786	0	0
21604571	791967	0	0
35508910	1129625	0	0
36152661	1125315	0	0
36303153	4048169	7	8
40213230	40213230	0	0
44359475	1549786	0	0
44342639	1119510	0	0
44353666	738818	0	0
44362217	19079524	2	3
45631466	738818	0	0
45658205	975125	0	0
45629308	1125315	0	0
45670312	1125315	0	0
45630373	1119510	0	0
45642413	1549786	0	0
45671315	1192710	0	0
45671147	1713332	0	0
45691672	1115008	0	0
45690321	19128263	2	2
45671782	1125315	0	0
45782892	1124957	0	0
46292997	40165015	2	3
45798058	1129625	0	0
46242486	1119510	0	0
45894584	1119510	0	0
46298017	1129625	0	0
46318452	738818	0	0
46308797	1174888	0	0
46315304	1125315	0	0
4043023	4336464	4	6
441840	4059173	7	10
21003455	1589505	0	0
21604566	723013	0	0
35508913	1125315	0	0
36152607	1125315	0	0
36303153	4306014	7	8
40213251	40213251	0	0
44359475	19127890	0	0
44342649	1119510	0	0
44353677	1124300	0	0
45661928	40163554	2	3
45631647	1107830	0	0
45658021	1107830	0	0
45629510	1125315	0	0
45670265	1125315	0	0
45630013	1119510	0	0
45642423	1501700	0	0
45671575	1192710	0	0
45671336	967823	0	0
45691823	1548195	0	0
45675348	19127918	2	2
45671888	1125315	0	0
45782855	1174888	0	0
46292508	19078461	2	3
45797942	1129625	0	0
46242170	1119510	0	0
45894378	1119510	0	0
46297801	1129625	0	0
46318492	701322	0	0
46308841	975125	0	0
46315165	1125315	0	0
4047779	198199	4	6
4215793	4202832	2	2
21004032	1717327	0	0
21604643	708298	0	0
35508422	1307863	0	0
36152919	1125315	0	0
36303153	439406	7	8
40213180	40213180	0	0
44359475	1515774	0	0
44342656	1119510	0	0
44353678	1548195	0	0
45655796	40163554	2	3
45631578	1501700	0	0
45655599	738818	0	0
45629378	1125315	0	0
45670449	1125315	0	0
45630447	1119510	0	0
45642574	1738521	0	0
45671542	1192710	0	0
45671338	738818	0	0
45691838	933724	0	0
45675348	19128009	2	2
45784053	1125315	0	0
45782757	723013	0	0
46292653	1115171	2	3
45797900	1129625	0	0
46241209	1119510	0	0
45894620	1119510	0	0
46289063	1129625	0	0
46318571	1107830	0	0
46308843	1110410	0	0
46309493	1125315	0	0
4180628	4296204	4	6
4344497	4149245	2	2
21003438	1746114	0	0
21604417	740275	0	0
35508889	1149196	0	0
36152682	1125315	0	0
36303153	4304110	7	8
40220386	40220386	0	0
44359478	708298	0	0
44342669	1119510	0	0
44353779	1310149	0	0
45656022	19019273	2	3
45631579	1115008	0	0
45655621	967823	0	0
45629168	1125315	0	0
45670090	1125315	0	0
45630155	1119510	0	0
45642579	967823	0	0
45670157	1192710	0	0
45671213	1551099	0	0
45691959	1174888	0	0
45769811	375671	2	2
45783785	1125315	0	0
45782709	1551099	0	0
45784800	1129625	0	0
45797909	1129625	0	0
46241211	1119510	0	0
45894431	1119510	0	0
46289159	1129625	0	0
46318581	1124300	0	0
46309053	1501700	0	0
46309502	1125315	0	0
4043022	4057420	6	6
4316083	4296204	2	2
21003438	1778162	0	0
21604152	1557272	0	0
35508826	1118084	0	0
36153080	1125315	0	0
36303153	4230399	7	12
40220389	40220386	0	0
44359490	1741122	0	0
44364094	1119510	0	0
44353726	1545958	0	0
44355050	19019273	2	3
45631698	967823	0	0
45655679	1549786	0	0
45629169	1125315	0	0
45668116	1125315	0	0
45630959	1119510	0	0
45642580	1149196	0	0
45781818	1192710	0	0
45671184	1308738	0	0
45691648	1759842	0	0
45769811	378001	2	2
45783888	1125315	0	0
45782710	1326303	0	0
45784565	1129625	0	0
45795226	1129625	0	0
46241119	1119510	0	0
45893585	1119510	0	0
46289175	1129625	0	0
46318515	1512674	0	0
46308809	1549786	0	0
46309593	1125315	0	0
4043161	4216130	6	6
4216752	4197460	2	2
21003514	914335	0	0
21500804	1367571	0	0
35508534	1125315	0	0
36152812	1125315	0	0
36303153	440448	7	12
40165015	40165015	0	0
44359490	1746114	0	0
44364279	1119510	0	0
44353515	1112807	0	0
45661908	19019273	2	3
45631660	1545958	0	0
45655679	19127890	0	0
45629461	1125315	0	0
45668153	1125315	0	0
45631262	1119510	0	0
45642615	723013	0	0
45781777	1192710	0	0
45671162	723013	0	0
45691648	1713332	0	0
45679970	19008572	2	3
45783890	1125315	0	0
45782780	19127890	0	0
45784788	1129625	0	0
45795528	1129625	0	0
46241137	1119510	0	0
45893556	1119510	0	0
46289364	1129625	0	0
46318515	1549786	0	0
46308809	1589505	0	0
46309605	1125315	0	0
4043161	4108705	6	6
4322244	4125906	2	2
21003515	791967	0	0
21500819	1322184	0	0
35508536	1738521	0	0
36152648	1125315	0	0
36303153	40481087	7	11
37522318	4336464	0	0
44359501	1177480	0	0
44364289	1119510	0	0
44353706	1112807	0	0
44340813	19019273	2	3
45631700	1124300	0	0
45655630	1332418	0	0
45629549	1125315	0	0
45668183	1125315	0	0
45630553	1119510	0	0
45642517	1149196	0	0
45781801	1192710	0	0
45671164	1308738	0	0
45692015	1000560	0	0
45680023	40236824	2	3
45783903	1125315	0	0
45782780	1589505	0	0
45784819	1129625	0	0
45795378	1129625	0	0
46241376	1119510	0	0
45801384	1119510	0	0
46289508	1129625	0	0
46318521	1307863	0	0
46308967	1361711	0	0
46309607	1125315	0	0
4043023	40492359	6	6
19127891	19128263	2	2
21004035	723013	0	0
21500806	1310149	0	0
35508441	1149380	0	0
36153081	1125315	0	0
36303153	4278672	7	11
37522325	4216130	0	0
44359502	1153428	0	0
44364364	1119510	0	0
44353707	1107830	0	0
45620553	19019273	2	3
45631596	1124300	0	0
45655688	1154029	0	0
45629233	1125315	0	0
45668131	1125315	0	0
45627520	1119510	0	0
45642624	1332418	0	0
45783599	1192710	0	0
45671003	1343916	0	0
45692022	1549786	0	0
45680003	19018935	2	3
45783908	1125315	0	0
45782780	1549786	0	0
45782403	1129625	0	0
45794644	1129625	0	0
46241282	1119510	0	0
45801481	1119510	0	0
46289463	1129625	0	0
46318523	975125	0	0
46309076	975125	0	0
46310079	1125315	0	0
4040400	4330583	5	6
19127891	19128022	2	2
21004201	1717327	0	0
21500851	1759842	0	0
35508813	1177480	0	0
35509188	1125315	0	0
36303153	4146173	7	11
36718157	378419	0	0
44359506	1548195	0	0
44357062	1119510	0	0
44353881	1192710	0	0
45655496	40174880	2	3
45631706	1361711	0	0
45655694	975125	0	0
45629500	1125315	0	0
45668320	1125315	0	0
45627782	1119510	0	0
45642523	1154029	0	0
45779489	1192710	0	0
45671078	715997	0	0
45692022	1589505	0	0
45680013	19018935	2	3
45784172	1125315	0	0
45782771	1124957	0	0
45782662	1129625	0	0
45794537	1129625	0	0
46241391	1119510	0	0
45801617	1119510	0	0
46289789	1129625	0	0
46318405	1738521	0	0
46309028	715997	0	0
46309701	1125315	0	0
4040400	4163971	6	6
19127891	19128065	2	2
21004202	1717327	0	0
21500824	1112807	0	0
35508861	1000560	0	0
35509189	1125315	0	0
36303153	4001336	7	11
36718530	4029498	0	0
44359507	1521369	0	0
44357173	1119510	0	0
44353882	1129625	0	0
45655137	1539411	2	3
45631574	1149196	0	0
45655796	1310149	0	0
45629265	1125315	0	0
45668324	1125315	0	0
45627784	1119510	0	0
45642489	1154343	0	0
45707949	1192710	0	0
45671085	1115008	0	0
45692022	19127890	0	0
45677545	40231925	2	3
45784173	1125315	0	0
45782969	1149196	0	0
45780544	1129625	0	0
45794617	1129625	0	0
46238440	1119510	0	0
45801752	1119510	0	0
46289757	1129625	0	0
46318406	975125	0	0
46309018	1000560	0	0
46309548	1125315	0	0
4040400	4108705	6	6
19127891	19127904	2	2
21003656	1738521	0	0
21500845	1308738	0	0
35508863	701322	0	0
35509194	1125315	0	0
36303153	198199	7	10
40213260	40213260	0	0
44359508	1124300	0	0
44357258	1119510	0	0
44353519	738818	0	0
45621900	40223768	2	3
45631813	1124957	0	0
45655851	723013	0	0
45629266	1125315	0	0
45668325	1125315	0	0
45627718	1119510	0	0
45642491	1310149	0	0
45707950	1192710	0	0
45671253	1115008	0	0
45691690	738818	0	0
45677944	40232448	2	3
45784113	1125315	0	0
45782863	1192710	0	0
45780555	1129625	0	0
45794445	1129625	0	0
46238327	1119510	0	0
45801392	1119510	0	0
46289713	1129625	0	0
46318418	1153428	0	0
46308902	1107830	0	0
46309828	1125315	0	0
4040400	4301346	4	6
4302532	4202451	2	2
21004223	1713332	0	0
21500903	975125	0	0
35508541	1119510	0	0
36157065	1125315	0	0
36303153	28060	7	10
40213281	40213281	0	0
44359586	1545958	0	0
44358910	1119510	0	0
44353727	1118084	0	0
44352291	40223768	2	3
45631913	791967	0	0
45655857	1549786	0	0
45629375	1125315	0	0
45668339	1125315	0	0
45627722	1119510	0	0
45642628	1149196	0	0
45708187	1192710	0	0
45671106	1310149	0	0
45691695	1115008	0	0
45677837	1154615	2	3
45784159	1125315	0	0
45780747	975125	0	0
45706600	1129625	0	0
45792782	1129625	0	0
46238392	1119510	0	0
45801609	1119510	0	0
46289604	1129625	0	0
46318696	1501700	0	0
46308908	740275	0	0
46309842	1125315	0	0
4040400	4216130	3	6
4301352	4323902	2	2
21002330	1746114	0	0
21500875	967823	0	0
35508879	1125315	0	0
36157223	1125315	0	0
36303153	4296204	7	10
40213296	40213296	0	0
44359733	1153428	0	0
44358718	1119510	0	0
44353716	1110410	0	0
45636974	19078461	2	3
45631916	1310149	0	0
45655857	19127890	0	0
45629474	1125315	0	0
45668159	1125315	0	0
45627530	1119510	0	0
45642558	1192710	0	0
45708299	1192710	0	0
45671108	19010482	0	0
45691696	1310149	0	0
45677904	40232448	2	3
45783929	1125315	0	0
45780749	791967	0	0
45706733	1129625	0	0
45792791	1129625	0	0
46238395	1119510	0	0
45801595	1119510	0	0
46289847	1129625	0	0
46318767	975125	0	0
46309082	1595799	0	0
46309867	1125315	0	0
4093991	40479768	6	7
4301352	4337611	2	2
21002335	1741122	0	0
21500874	967823	0	0
35508879	1119510	0	0
36156815	1125315	0	0
36303153	4116491	7	9
40213299	40213299	0	0
44359652	1129625	0	0
44358751	1119510	0	0
44353728	1129625	0	0
44355081	40223768	2	3
45631924	1500211	0	0
45655857	1589505	0	0
45629475	1125315	0	0
45668106	1125315	0	0
45627585	1119510	0	0
45642559	738818	0	0
45705334	1192710	0	0
45671189	1309944	0	0
45692039	738818	0	0
45678052	920334	2	3
45784083	1125315	0	0
45780754	1153428	0	0
45706635	1129625	0	0
45792858	1129625	0	0
46238502	1119510	0	0
45801566	1119510	0	0
46289895	1129625	0	0
46318699	1729720	0	0
46309082	1521369	0	0
46309895	1125315	0	0
4093991	133834	6	7
4339410	4035415	2	2
21002328	1713332	0	0
21500894	975125	0	0
35508814	1129625	0	0
36156821	1125315	0	0
36303153	4296205	7	7
40220960	40220960	0	0
44359545	1149380	0	0
44357336	1119510	0	0
44353492	920293	0	0
44357981	19075001	2	3
45631709	1174888	0	0
45655606	1115008	0	0
45629482	1125315	0	0
45665790	1125315	0	0
45627702	1119510	0	0
45642725	1149196	0	0
45702017	1192710	0	0
45671119	1738521	0	0
45691840	1124957	0	0
45677970	1127433	2	3
45781947	1125315	0	0
45780779	1000560	0	0
45706832	1129625	0	0
45792774	1129625	0	0
46238344	1119510	0	0
45801581	1119510	0	0
46241638	1129625	0	0
46318662	1713332	0	0
46309082	1549786	0	0
46309910	1125315	0	0
4093991	40479422	6	7
4339410	80502	2	2
21002346	1759842	0	0
21500853	975125	0	0
35508815	705944	0	0
36156977	1125315	0	0
36303153	4094814	6	6
40213306	40213306	0	0
44359467	1501700	0	0
44357311	1119510	0	0
44353812	1177480	0	0
44357999	40223768	2	3
45631718	1149196	0	0
45655658	975125	0	0
45629492	1125315	0	0
45665594	1125315	0	0
45627412	1119510	0	0
45642479	1174888	0	0
45702068	1192710	0	0
45671222	740275	0	0
45692046	1124957	0	0
45679772	35605482	2	3
45781878	1125315	0	0
45780781	1729720	0	0
45706835	1129625	0	0
45787332	1129625	0	0
46238349	1119510	0	0
45795901	1119510	0	0
46241716	1129625	0	0
46318722	1332418	0	0
46309105	1332418	0	0
46310078	1125315	0	0
4043022	4275113	5	7
4198525	4027663	2	2
21002330	1759842	0	0
21500932	975125	0	0
35508817	1119510	0	0
36156754	1125315	0	0
36303153	4051466	6	7
40221414	40221415	0	0
44359743	1177480	0	0
44353921	1119510	0	0
44353816	1112807	0	0
44340145	40223768	2	3
45631830	967823	0	0
45655672	975125	0	0
45629495	1125315	0	0
45665810	1125315	0	0
45627414	1119510	0	0
45642564	1174888	0	0
45702133	1192710	0	0
45671292	1115008	0	0
45691801	757627	0	0
45679639	19057271	2	3
45781939	1125315	0	0
45780847	1115008	0	0
45706841	1129625	0	0
45787279	1129625	0	0
46238695	1119510	0	0
45795961	1119510	0	0
46241741	1129625	0	0
46318529	1115008	0	0
46309286	1112807	0	0
46309543	1125315	0	0
4043022	4117038	4	7
4200516	381316	2	2
21002329	1717327	0	0
21500876	1124300	0	0
35508824	1549786	0	0
36156825	1125315	0	0
36303153	4174876	6	7
40221415	40221415	0	0
44359657	1000560	0	0
44354030	1119510	0	0
44353816	1192710	0	0
45655576	19073183	2	3
45631817	1501700	0	0
45655977	1124300	0	0
45629402	1125315	0	0
45666059	1125315	0	0
45624608	1119510	0	0
45642629	975125	0	0
45699021	1192710	0	0
45671135	1192710	0	0
45691777	738818	0	0
45679245	40223768	2	3
45781967	1125315	0	0
45780632	1115008	0	0
46240377	1129625	0	0
45787280	1129625	0	0
46238727	1119510	0	0
45796160	1119510	0	0
46241742	1129625	0	0
46318841	1124300	0	0
46308958	791967	0	0
46309556	1125315	0	0
4043022	4198190	6	7
4301471	195588	2	2
21002347	1746114	0	0
21500926	975125	0	0
35508824	1515774	0	0
36156990	1125315	0	0
36303153	4024289	6	7
40231925	40231925	0	0
44359764	1192710	0	0
44353844	1119510	0	0
44353827	1713332	0	0
44362515	19078461	2	3
45631925	1500211	0	0
45655618	1000560	0	0
45629584	1125315	0	0
45665915	1125315	0	0
45624468	1119510	0	0
45642632	1192710	0	0
45699518	1192710	0	0
45671138	1192710	0	0
45691979	1124300	0	0
45674626	40232448	2	3
45781926	1125315	0	0
45780786	1149380	0	0
45702776	1129625	0	0
45696301	1119510	0	0
45897495	1119510	0	0
45795965	1119510	0	0
46241682	1129625	0	0
46318670	1738521	0	0
46309209	715997	0	0
46309968	1125315	0	0
4180169	260139	3	7
4261497	42535580	2	2
21002338	1746114	0	0
21002855	1125315	0	0
35508824	19127890	0	0
36157006	1125315	0	0
36303153	440086	6	8
36718530	380378	0	1
44359765	1545958	0	0
44354249	1119510	0	0
44353788	1192710	0	0
45620447	19073183	2	3
45631930	967823	0	0
45655751	1551099	0	0
45631236	1125315	0	0
45666075	1125315	0	0
45624628	1119510	0	0
45642637	1153428	0	0
45695753	1192710	0	0
45671144	933724	0	0
45692071	1326303	0	0
45674538	1127433	2	3
45781912	1125315	0	0
45780889	1000560	0	0
45702869	1129625	0	0
45696812	1119510	0	0
45897513	1119510	0	0
45796250	1119510	0	0
46242515	1129625	0	0
46318981	1308738	0	0
46309230	1595799	0	0
46309746	1125315	0	0
4199402	4048695	5	7
4201402	81893	2	2
21002338	1741122	0	0
21002855	723013	0	0
35508918	1153428	0	0
36157160	1125315	0	0
36303153	140673	6	8
37202316	4280726	3	9
44359767	1124300	0	0
44354196	1119510	0	0
44353788	1112807	0	0
45625321	1332419	2	3
45631877	1539403	0	0
45655802	708298	0	0
45626452	1125315	0	0
45665828	1125315	0	0
45624651	1119510	0	0
45642496	1174888	0	0
45697750	1192710	0	0
45671261	723013	0	0
45691990	1149196	0	0
45674958	19133768	2	3
45781915	1125315	0	0
45780895	1174888	0	0
45703037	1129625	0	0
45696818	1119510	0	0
45897518	1119510	0	0
45795913	1119510	0	0
46241888	1129625	0	0
46318986	967823	0	0
46309230	1549786	0	0
46309562	1125315	0	0
4159949	4336464	5	7
4197094	4266809	2	2
21002332	1759842	0	0
21002855	1112807	0	0
35508924	1332418	0	0
36157171	1125315	0	0
36303153	4155034	6	9
37202316	261325	3	9
44359699	1129625	0	0
44354102	1119510	0	0
44353731	1310149	0	0
44348694	19078461	2	3
45631879	1174888	0	0
45655863	967823	0	0
45626453	1125315	0	0
45666049	1125315	0	0
45624413	1119510	0	0
45640051	738818	0	0
45692862	1192710	0	0
45671365	1738521	0	0
45691993	1717327	0	0
45674741	1115171	2	3
45781917	1125315	0	0
45780952	705944	0	0
45703074	1129625	0	0
45696874	1119510	0	0
45897589	1119510	0	0
45796114	1119510	0	0
46241894	1129625	0	0
46318586	1738521	0	0
46309230	1521369	0	0
46309974	1125315	0	0
4117930	317576	5	7
4342752	81893	2	2
21002349	920293	0	0
21002855	791967	0	0
35509016	1124957	0	0
36157308	1125315	0	0
36303153	380378	6	9
37202316	257012	3	8
44359700	738818	0	0
44354279	1119510	0	0
44353736	1115008	0	0
45620556	1107882	2	3
45631781	738818	0	0
45655757	1343916	0	0
45626634	1125315	0	0
45666221	1125315	0	0
45624448	1119510	0	0
45640054	1361711	0	0
45693067	1192710	0	0
45671366	1500211	0	0
45691805	738818	0	0
45674640	1127433	2	3
45782080	1125315	0	0
45780200	1149196	0	0
45703938	1129625	0	0
45696717	1119510	0	0
45897776	1119510	0	0
45796199	1119510	0	0
45897795	1129625	0	0
46318746	1000560	0	0
46309231	1149196	0	0
46309994	1125315	0	0
4117930	4142905	4	7
4200851	258780	2	2
21002434	1717327	0	0
21002856	1125315	0	0
35508887	708298	0	0
36157344	1125315	0	0
36303153	4310024	6	10
37200000	258780	3	11
44359705	1115008	0	0
44352402	1119510	0	0
44353830	1177480	0	0
44344712	1107882	2	3
45631782	738818	0	0
45655760	1174888	0	0
45626637	1125315	0	0
45666254	1125315	0	0
45624415	1119510	0	0
45639421	1174888	0	0
45690014	1192710	0	0
45671516	1124300	0	0
45691808	1501700	0	0
45675001	1539411	2	3
45781946	1125315	0	0
45780250	1149196	0	0
45703129	1129625	0	0
45696794	1119510	0	0
45895436	1119510	0	0
45796097	1119510	0	0
45895810	1129625	0	0
46318851	1124300	0	0
46309137	975125	0	0
46309572	1125315	0	0
4117930	195588	4	7
4344040	4146173	2	2
21002436	1746114	0	0
21002858	1728416	0	0
35509019	1129625	0	0
36157488	1125315	0	0
36303153	4035415	6	10
37200000	261325	3	10
44359708	1129625	0	0
44352235	1119510	0	0
44353791	1149380	0	0
44347685	1107882	2	3
45632152	738818	0	0
45655761	975125	0	0
45626737	1125315	0	0
45665730	1125315	0	0
45624767	1119510	0	0
45639461	967823	0	0
45689788	1192710	0	0
45671518	1149196	0	0
45691811	933724	0	0
45674879	40229134	2	3
45781995	1125315	0	0
45780285	1107830	0	0
45703170	1129625	0	0
45802680	1119510	0	0
45895348	1119510	0	0
45796101	1119510	0	0
45895901	1129625	0	0
46318727	1308738	0	0
46309152	1729720	0	0
46309931	1125315	0	0
4180169	40486433	4	7
4320791	40486433	2	2
21002491	1125315	0	0
21002881	1746114	0	0
35508981	1115008	0	0
36157468	1125315	0	0
36303153	4283893	6	10
37200000	4280726	3	10
44355985	1595799	0	0
44350288	1119510	0	0
44353792	1551099	0	0
44355183	1107882	2	3
45632153	1549786	0	0
45655981	1307863	0	0
45626537	1125315	0	0
45666175	1125315	0	0
45624563	1119510	0	0
45639477	1310149	0	0
45690123	1192710	0	0
45671289	1153428	0	0
45688791	1107830	0	0
45674666	19133768	2	3
45782124	1125315	0	0
45780262	1174888	0	0
45699987	1129625	0	0
45802895	1119510	0	0
45895374	1119510	0	0
45796179	1119510	0	0
45895851	1129625	0	0
46318729	967823	0	0
46309112	1112807	0	0
46309937	1125315	0	0
4180169	4294548	4	7
4320791	4280726	2	2
21002491	1595799	0	0
21002846	1112807	0	0
35508871	1177480	0	0
36157377	1125315	0	0
36303153	4132546	6	10
37200000	260139	3	10
44355985	1521369	0	0
44350343	1119510	0	0
44353913	1177480	0	0
44337411	1107882	2	3
45632153	1595799	0	0
45655986	1149196	0	0
45626784	1125315	0	0
45666177	1125315	0	0
45624863	1119510	0	0
45639489	1149196	0	0
45690178	1192710	0	0
45671510	791967	0	0
45688763	914335	0	0
45674777	40232448	2	3
45782023	1125315	0	0
45780289	933724	0	0
45700251	1129625	0	0
45802774	1119510	0	0
45895297	1119510	0	0
45796274	1119510	0	0
45896083	1129625	0	0
46318894	1308738	0	0
46309120	1000560	0	0
46310156	1125315	0	0
4180169	4280726	4	7
4278510	4197460	2	2
21002491	19054876	0	0
21002865	1125315	0	0
35508837	1125315	0	0
36157378	1125315	0	0
36303153	4056621	6	10
37200000	255848	3	9
44355985	1549786	0	0
44350244	1119510	0	0
44353621	1332418	0	0
44343872	1107882	2	3
45632153	1521369	0	0
45655821	914335	0	0
45626605	1125315	0	0
45663610	1125315	0	0
45624867	1119510	0	0
45639491	1149196	0	0
45690085	1192710	0	0
45671588	1149196	0	0
45688853	791967	0	0
45674783	1154615	2	3
45781958	1125315	0	0
45780291	708298	0	0
45697773	1129625	0	0
45802778	1119510	0	0
45895443	1119510	0	0
45796437	1119510	0	0
45804140	1129625	0	0
46318901	1738521	0	0
46309122	1500211	0	0
46310159	1125315	0	0
4181322	4336464	4	7
21000912	19133905	2	3
21002425	1746114	0	0
21002880	1759842	0	0
35508839	1000560	0	0
36151910	1125315	0	0
36303153	261325	6	11
37200000	28060	3	9
44355989	1129625	0	0
44350452	1119510	0	0
44353939	738818	0	0
44347777	1107882	2	3
45631900	1000560	0	0
45655750	738818	0	0
45626619	1125315	0	0
45663616	1125315	0	0
45624878	1119510	0	0
45639496	1545958	0	0
45688408	1192710	0	0
45671592	1539403	0	0
45688833	967823	0	0
45674912	1115171	2	3
45781960	1125315	0	0
45780234	967823	0	0
45696901	1129625	0	0
45802861	1119510	0	0
45895266	1119510	0	0
45790725	1119510	0	0
45804223	1129625	0	0
46319000	975125	0	0
46309165	1545958	0	0
46309769	1125315	0	0
4180628	40479768	6	7
21000912	19133873	2	3
21002436	1717327	0	0
21002880	1778162	0	0
35508735	1557272	0	0
36152267	1125315	0	0
36303153	4152936	6	11
37200000	4283893	3	8
44355625	1551099	0	0
44350395	1119510	0	0
44353916	914335	0	0
44341489	19078461	2	3
45631756	1322184	0	0
45655934	1153428	0	0
45626665	1125315	0	0
45663618	1125315	0	0
45624879	1119510	0	0
45639401	1192710	0	0
45688730	1192710	0	0
45671277	1717327	0	0
45688793	1539403	0	0
45671682	19133905	2	3
45782056	1125315	0	0
45780235	1000560	0	0
45697018	1129625	0	0
45802730	1119510	0	0
45894650	1119510	0	0
45790730	1119510	0	0
45804248	1129625	0	0
46319189	1192710	0	0
46309182	1551099	0	0
46309781	1125315	0	0
4163873	4181917	2	2
21000907	40163554	2	3
21002374	1738521	0	0
21002842	1551099	0	0
35508982	1738521	0	0
36151921	1125315	0	0
36303153	4294548	6	12
37200000	441267	3	7
44355628	975125	0	0
44350249	1119510	0	0
44345925	1332418	0	0
45620492	1107882	2	3
45632036	1149196	0	0
45655722	1124957	0	0
45626777	1125315	0	0
45663628	1125315	0	0
45624592	1119510	0	0
45639424	1515774	0	0
45687091	1192710	0	0
45671278	1310149	0	0
45688812	1115008	0	0
45671686	19008572	2	3
45782141	1125315	0	0
45780238	742185	0	0
45697037	1129625	0	0
45802913	1119510	0	0
45803298	1119510	0	0
45791011	1119510	0	0
45803916	1129625	0	0
46318646	1308738	0	0
46309108	1539403	0	0
46310059	1125315	0	0
4134134	4132546	2	2
21000931	19078924	2	3
21002421	1746114	0	0
21002845	1112807	0	0
35508845	1125315	0	0
36151923	1125315	0	0
36303153	4285898	6	13
37000000	198199	3	7
44356061	1112807	0	0
44350690	1119510	0	0
44346081	1107830	0	0
45651818	19078461	2	3
45632037	1310149	0	0
45655726	1549786	0	0
45626716	1125315	0	0
45663652	1125315	0	0
45624784	1119510	0	0
45639424	1549786	0	0
45684213	1192710	0	0
45671279	1192710	0	0
45688834	1713332	0	0
45671838	1127433	2	3
45782006	1125315	0	0
45780242	1307863	0	0
45697231	1129625	0	0
45802921	1119510	0	0
45803342	1119510	0	0
45790779	1119510	0	0
45803853	1129625	0	0
46318776	1192710	0	0
46309206	1107830	0	0
46310007	1125315	0	0
4188066	4314290	2	2
21000931	19076374	2	3
21002422	1746114	0	0
21002863	1115008	0	0
35508845	1174888	0	0
36157756	1125315	0	0
36303153	40479768	9	12
37600000	317576	3	7
44356062	1759842	0	0
44350492	1119510	0	0
44346067	1112807	0	0
45649268	19078461	2	3
45632118	1549786	0	0
45655726	1595799	0	0
45626835	1125315	0	0
45663655	1125315	0	0
45624536	1119510	0	0
45639426	1551099	0	0
45654965	1112807	0	0
45671237	1589505	0	0
45688834	1759842	0	0
45671942	1127433	2	3
45782008	1125315	0	0
45780253	975125	0	0
45693847	1129625	0	0
45803052	1119510	0	0
45803429	1119510	0	0
45790824	1119510	0	0
45798788	1129625	0	0
46312454	975125	0	0
46309382	914335	0	0
46304466	1125315	0	0
4179922	439777	2	2
21001380	1713671	2	3
21002332	920293	0	0
21002863	1125315	0	0
35508846	1119510	0	0
36157761	1125315	0	0
36303153	4144583	9	9
37202317	4112343	3	6
44356111	1129625	0	0
44350605	1119510	0	0
44346002	1115008	0	0
44344813	40228214	2	3
45632118	19127890	0	0
45655726	1521369	0	0
45626979	1125315	0	0
45663735	1125315	0	0
45624913	1119510	0	0
45639431	1310149	0	0
45700759	1112807	0	0
45671410	1174888	0	0
45688874	1174888	0	0
45671977	19019979	2	3
45782208	1125315	0	0
45780266	1124957	0	0
45694167	1129625	0	0
45802993	1119510	0	0
45803357	1119510	0	0
45790975	1119510	0	0
45798924	1129625	0	0
46312926	1107830	0	0
46309387	1192710	0	0
46304428	1125315	0	0
4180175	4301346	2	2
21000830	1551192	2	3
21002350	1768849	0	0
21003153	738818	0	0
35508846	1125315	0	0
36157763	1125315	0	0
36303153	4145310	5	5
37202317	4294548	3	6
44356062	1713332	0	0
44346468	1119510	0	0
44346008	1551099	0	0
45661826	19078461	2	3
45632103	1174888	0	0
45655780	740275	0	0
45626868	1125315	0	0
45663761	1125315	0	0
45668463	1119510	0	0
45639432	19078219	0	0
45701538	1112807	0	0
45671444	738818	0	0
45688816	19127890	0	0
45672108	40232448	2	3
45782011	1125315	0	0
45780202	975125	0	0
45693859	1129625	0	0
45800135	1119510	0	0
45803452	1119510	0	0
45791037	1119510	0	0
45799681	1129625	0	0
46312406	1713332	0	0
46309450	967823	0	0
46304430	1125315	0	0
4180170	4283893	2	2
21000474	19008572	2	3
21002410	1746114	0	0
21003153	1115008	0	0
35508949	1125315	0	0
36157347	1125315	0	0
36303153	80180	5	7
36703500	4132546	3	6
44356063	1192710	0	0
44346648	1119510	0	0
44346099	791967	0	0
44341563	1332419	2	3
45632105	967823	0	0
45655782	1149196	0	0
45626887	1125315	0	0
45663772	1125315	0	0
45668794	1119510	0	0
45639433	1308738	0	0
45701565	1112807	0	0
45669875	1539403	0	0
45688816	1512674	0	0
45672071	40174880	2	3
45782189	1125315	0	0
45780272	1174888	0	0
45694038	1129625	0	0
45800137	1119510	0	0
45803505	1119510	0	0
45791887	1119510	0	0
45799845	1129625	0	0
46312525	975125	0	0
46309359	1107830	0	0
46304445	1125315	0	0
4193318	4112343	2	2
21000474	1551192	2	3
21001738	1149196	0	0
21003174	1119510	0	0
35506856	1713332	0	0
36157361	1125315	0	0
36303153	4029498	5	8
36718338	4001336	3	6
44355637	715997	0	0
44346749	1119510	0	0
44346102	1112807	0	0
44348218	1332419	2	3
45631740	1343916	0	0
45655737	1192710	0	0
45623286	1125315	0	0
45663701	1125315	0	0
45668704	1119510	0	0
45639446	1310149	0	0
45701613	1112807	0	0
45669813	1107830	0	0
45688816	1549786	0	0
45671784	19008572	2	3
45779575	1125315	0	0
45780334	1107830	0	0
45694187	1129625	0	0
45799916	1119510	0	0
45803481	1119510	0	0
45791895	1119510	0	0
45799045	1129625	0	0
46312544	1307863	0	0
46309360	920293	0	0
46304477	1125315	0	0
4193169	40481087	2	2
21001379	19073188	2	3
21001738	738818	0	0
21003174	1149196	0	0
35506797	140673	0	0
36157363	1125315	0	0
36303153	317576	5	11
37200000	317009	3	5
44355881	1310149	0	0
44346533	1119510	0	0
44346115	701322	0	0
44350812	40228214	2	3
45631746	1332418	0	0
45655889	1124300	0	0
45623294	1125315	0	0
45663323	1125315	0	0
45668718	1119510	0	0
45639450	738818	0	0
45701742	1112807	0	0
45669729	1501700	0	0
45688859	1332418	0	0
45671874	40169281	2	3
45779589	1125315	0	0
45780275	1115008	0	0
45694010	1129625	0	0
45800114	1119510	0	0
45803495	1119510	0	0
45791922	1119510	0	0
45793489	1129625	0	0
46313165	1115008	0	0
46309393	1000560	0	0
46304629	1125315	0	0
4189544	4024958	2	2
21001379	19133873	2	3
21001739	1778162	0	0
21003174	1153428	0	0
35506858	1177480	0	0
36157364	1125315	0	0
36303153	257012	5	11
37202310	261325	3	5
44355781	1112807	0	0
44346537	1119510	0	0
44346117	1153428	0	0
44351287	19075601	2	3
45628761	1738521	0	0
45656022	1115008	0	0
45623295	1125315	0	0
45663324	1125315	0	0
45668873	1119510	0	0
45639463	1110410	0	0
45701643	1112807	0	0
45669826	1192710	0	0
45688863	738818	0	0
45783885	1115171	2	3
45779698	1125315	0	0
45780307	1192710	0	0
45694012	1129625	0	0
45800026	1119510	0	0
45800751	1119510	0	0
45792039	1119510	0	0
45793517	1129625	0	0
46312690	791967	0	0
46309366	1124957	0	0
46304639	1125315	0	0
4130851	4113008	2	2
21001379	19073183	2	3
21001692	1310149	0	0
21003205	1119510	0	0
35506815	1129625	0	0
36157427	1125315	0	0
36303153	4237458	5	11
37002287	4116491	3	5
44355646	1738521	0	0
44346539	1119510	0	0
44346015	1501700	0	0
44355091	19075601	2	3
45628442	1332418	0	0
44348222	742185	0	0
45623338	1125315	0	0
45663416	1125315	0	0
45668876	1119510	0	0
45639590	1149196	0	0
45701762	1112807	0	0
45669831	1738521	0	0
45689001	1343916	0	0
45783895	19133873	2	3
45779523	1125315	0	0
45780357	1521369	0	0
45694403	1129625	0	0
45800120	1119510	0	0
45800652	1119510	0	0
45791078	1119510	0	0
45793687	1129625	0	0
46313177	1192710	0	0
46303394	1343916	0	0
46304668	1125315	0	0
4130851	4278672	2	2
21000408	1551192	2	3
21001738	1119510	0	0
21003156	1125315	0	0
35506918	1119510	0	0
36157437	1125315	0	0
36303153	4280726	5	12
37502347	4117038	3	5
44355884	1149380	0	0
44346763	1119510	0	0
44346121	1115008	0	0
44343706	19075601	2	3
45628704	1332418	0	0
44348124	1124957	0	0
45623373	1125315	0	0
45663889	1125315	0	0
45668895	1119510	0	0
45639606	1501700	0	0
45698513	1112807	0	0
45669833	1717327	0	0
45689018	1107830	0	0
45783958	1115171	2	3
45779649	1125315	0	0
45780230	1326303	0	0
45691047	1129625	0	0
45800256	1119510	0	0
45800897	1119510	0	0
46294580	1119510	0	0
45793626	1129625	0	0
46312531	1115008	0	0
46303521	1332418	0	0
46305172	1125315	0	0
4190185	30753	2	2
21001378	19075001	2	3
21001744	1713332	0	0
21003156	1112807	0	0
35506918	738818	0	0
36157410	1125315	0	0
36303153	439777	4	9
37202320	40486433	3	5
44355810	1129625	0	0
44346764	1119510	0	0
44346167	791967	0	0
45655863	19079524	2	3
45628450	1107830	0	0
44348253	705944	0	0
45623479	1125315	0	0
45663894	1125315	0	0
45668954	1119510	0	0
45639598	1000560	0	0
45698681	1112807	0	0
45669847	1361711	0	0
45688911	1153428	0	0
45783905	19018935	2	3
45779730	1125315	0	0
45780400	19003953	0	0
45691025	1129625	0	0
45800262	1119510	0	0
45800931	1119510	0	0
46294808	1119510	0	0
45793790	1129625	0	0
46312853	1738521	0	0
46303861	1174888	0	0
46305184	1125315	0	0
4093228	4149245	2	2
21001378	1713671	2	3
21001741	1778162	0	0
21003153	1119510	0	0
35506817	1545958	0	0
36157412	1125315	0	0
36303153	80809	4	8
37202317	40481087	3	5
44355813	1308738	0	0
44346782	1119510	0	0
44346176	1129625	0	0
44351368	19078461	2	3
45628451	715997	0	0
44348254	1153428	0	0
45623363	1125315	0	0
45663897	1125315	0	0
45668923	1119510	0	0
45639601	740275	0	0
45699028	1112807	0	0
45669852	1192710	0	0
45688978	1107830	0	0
45783998	1115171	2	3
45779800	1125315	0	0
45780277	1174888	0	0
45688631	1129625	0	0
45800382	1119510	0	0
45801014	1119510	0	0
46294175	1119510	0	0
45793853	1129625	0	0
46312866	1548195	0	0
46303865	1124957	0	0
46304500	1125315	0	0
4134148	4238715	2	2
21001378	19073188	2	3
21001738	1150836	0	0
21003174	1150770	0	0
35506865	1119510	0	0
36157529	1125315	0	0
36303153	40478878	4	5
37003663	198199	3	5
44355912	967823	0	0
44346685	1119510	0	0
44346178	1174888	0	0
44347812	1539411	2	3
45628750	1307863	0	0
44348259	1548195	0	0
45623420	1125315	0	0
45663428	1125315	0	0
45668963	1119510	0	0
45639533	1174888	0	0
45694390	1112807	0	0
45669853	1308738	0	0
45688982	1501700	0	0
45783928	43012036	2	3
45779409	1125315	0	0
45780404	1501700	0	0
45688060	1129625	0	0
45800235	1119510	0	0
45800799	1119510	0	0
46295008	1119510	0	0
45793815	1129625	0	0
46312942	1174888	0	0
46303928	933724	0	0
46304945	1125315	0	0
4043160	44805732	2	2
21000873	1551192	2	3
21001738	1107830	0	0
21003156	1129625	0	0
35506865	1125315	0	0
36157536	1125315	0	0
36303153	4246502	4	4
37003663	195588	3	6
44355992	1174888	0	0
44346617	1119510	0	0
44346179	1177480	0	0
44347450	19078461	2	3
45628600	738818	0	0
44348218	1332418	0	0
45623422	1125315	0	0
45663439	1125315	0	0
45668728	1119510	0	0
45639534	1192710	0	0
45692481	1112807	0	0
45669864	1549786	0	0
45689026	1549786	0	0
45784000	19008572	2	3
45779633	1125315	0	0
45780550	1551099	0	0
45688065	1129625	0	0
45800067	1119510	0	0
45800781	1119510	0	0
46295010	1119510	0	0
45788375	1129625	0	0
46312958	1174888	0	0
46303930	1000560	0	0
46304511	1125315	0	0
4048375	4330583	2	2
21000436	1551192	2	3
21001740	1778162	0	0
21003156	738818	0	0
35506874	705944	0	0
36157475	1125315	0	0
36303153	4151422	4	4
36718338	380378	3	4
44355917	1112807	0	0
44346713	1119510	0	0
44346190	1129625	0	0
45620855	1539411	2	3
45628708	1124300	0	0
44348191	933724	0	0
45623625	1125315	0	0
45663442	1125315	0	0
45668749	1119510	0	0
45639542	1741122	0	0
45692490	1112807	0	0
45669874	19127890	0	0
45689026	19127890	0	0
45784063	1115171	2	3
45779742	1125315	0	0
45780421	1361711	0	0
45688093	1129625	0	0
45802225	1119510	0	0
45800937	1119510	0	0
46294957	1119510	0	0
45788353	1129625	0	0
46313096	1551099	0	0
46303936	1000560	0	0
46304680	1125315	0	0
4093991	81151	4	8
21000890	46275444	2	3
21001743	1713332	0	0
21003156	1192710	0	0
35506926	1177480	0	0
36157754	1125315	0	0
36303153	4133840	4	4
36718588	381316	3	4
44355920	1118084	0	0
44346146	1119510	0	0
44346200	1332418	0	0
45661844	19079524	2	3
45628711	1000560	0	0
44348405	975125	0	0
45623645	1125315	0	0
45663844	1125315	0	0
45668880	1119510	0	0
45639612	1192710	0	0
45692716	1112807	0	0
45669874	1589505	0	0
45689026	1515774	0	0
45784174	40232448	2	3
45779803	1125315	0	0
45777763	1729720	0	0
45684964	1129625	0	0
45802436	1119510	0	0
45801090	1119510	0	0
46294430	1119510	0	0
45788543	1129625	0	0
46313042	1717327	0	0
46303937	1107830	0	0
46304929	1125315	0	0
4040400	4336464	5	8
21000890	1713671	2	3
21001750	1713332	0	0
21003205	1174888	0	0
21605050	1149380	0	0
36157499	1125315	0	0
36303153	4015189	3	7
36718588	4066995	3	4
44356127	1557272	0	0
44346829	1119510	0	0
44346153	738818	0	0
45649228	1539411	2	3
45628684	1549786	0	0
44348194	1110410	0	0
45667568	1125315	0	0
45663550	1125315	0	0
45668882	1119510	0	0
45639628	975125	0	0
45689599	1112807	0	0
45669874	1549786	0	0
45686027	723013	0	0
45784240	1115171	2	3
45779590	1125315	0	0
45777810	1589505	0	0
45684937	1129625	0	0
45802437	1119510	0	0
45801046	1119510	0	0
46294677	1119510	0	0
45788615	1129625	0	0
46313104	1154029	0	0
46306441	933724	0	0
46304936	1125315	0	0
4043022	4330583	4	8
21000874	1551192	2	3
21001749	1717327	0	0
21003205	1112807	0	0
21604191	782043	0	0
36157741	1125315	0	0
36303153	4010253	3	7
36703500	4029498	3	4
44356001	1110410	0	0
44346830	1119510	0	0
44346344	1129625	0	0
45620429	40228230	2	3
45628684	1515774	0	0
44348409	738818	0	0
45667655	1125315	0	0
45663746	1125315	0	0
45670354	1119510	0	0
45639594	1728416	0	0
45689802	1112807	0	0
45669673	715997	0	0
45686038	1110410	0	0
45783942	40228230	2	3
45779705	1125315	0	0
45777707	1308738	0	0
45685137	1129625	0	0
45802278	1119510	0	0
45800774	1119510	0	0
46294767	1119510	0	0
45788317	1129625	0	0
46313107	1124300	0	0
46306448	1738521	0	0
46321017	1125315	0	0
4043161	4336464	6	8
21000404	1551192	2	3
21001766	1174888	0	0
21003205	1192710	0	0
21604192	19002770	0	0
36157637	1125315	0	0
36303153	4012477	3	6
36718119	378419	3	4
44355844	1149196	0	0
44346839	1119510	0	0
44346258	738818	0	0
45620429	40228214	2	3
45628625	1102527	0	0
44348200	738818	0	0
45667573	1125315	0	0
45663449	1125315	0	0
45666595	1119510	0	0
45639651	1174888	0	0
45689731	1112807	0	0
45669780	1326303	0	0
45686042	1102527	0	0
45782075	40232448	2	3
45779692	1125315	0	0
45777709	1549786	0	0
45684790	1129625	0	0
45800422	1119510	0	0
45800777	1119510	0	0
46244039	1119510	0	0
45788349	1129625	0	0
46313194	1115008	0	0
46306951	967823	0	0
46321559	1125315	0	0
4180169	4112343	4	8
21000702	1545959	2	3
21001745	1713332	0	0
21002036	1713332	0	0
21604193	19039298	0	0
36157699	1125315	0	0
36303153	4052083	3	3
37202316	317009	3	4
44355921	1343916	0	0
44346288	1119510	0	0
44346525	1305058	0	0
45620676	40228214	2	3
45631131	1501700	0	0
44348265	1545958	0	0
45667842	1125315	0	0
45660205	1125315	0	0
45666729	1119510	0	0
45639652	1174888	0	0
45689783	1112807	0	0
45669787	1322184	0	0
45686047	1332418	0	0
45782076	44816277	2	3
45779760	1125315	0	0
45777709	19127890	0	0
45685094	1129625	0	0
45797326	1119510	0	0
45801039	1119510	0	0
46244043	1119510	0	0
45788570	1129625	0	0
46313140	708298	0	0
46307069	1307863	0	0
46320827	1125315	0	0
4180169	258780	4	8
21000702	1539411	2	3
21001743	1759842	0	0
21002025	1713332	0	0
21603497	1149196	0	0
36157564	1125315	0	0
36300000	192671	5	10
37003663	4116491	3	4
44355922	1124957	0	0
44346410	1119510	0	0
44346204	1192710	0	0
44354798	40228214	2	3
45631136	1521369	0	0
45651975	1192710	0	0
45667800	1125315	0	0
45660219	1125315	0	0
45666731	1119510	0	0
45639527	1149196	0	0
45689852	1112807	0	0
45670405	705944	0	0
45686050	1549786	0	0
45782117	42707627	2	3
45779812	1125315	0	0
45777709	1589505	0	0
45685552	1129625	0	0
45797525	1119510	0	0
45801083	1119510	0	0
46244100	1119510	0	0
45788505	1129625	0	0
46313144	975125	0	0
46304046	715997	0	0
46321184	1125315	0	0
4047779	378419	5	8
21000375	1551192	2	3
21001757	1768849	0	0
21500864	1343916	0	0
21603513	1150836	0	0
36157574	1125315	0	0
36300000	4058899	5	10
36703483	4043241	3	3
44355933	975125	0	0
44346299	1119510	0	0
44346154	1310149	0	0
44354639	40228214	2	3
45631136	1595799	0	0
45651976	1741122	0	0
45667936	1125315	0	0
45660371	1125315	0	0
45666864	1119510	0	0
45639528	975125	0	0
45686624	1112807	0	0
45670409	715997	0	0
45686050	19127890	0	0
45781948	1551192	2	3
45779823	1125315	0	0
45777720	1115008	0	0
45685840	1129625	0	0
45797544	1119510	0	0
45800888	1119510	0	0
46244101	1119510	0	0
45788678	1129625	0	0
46313147	1149196	0	0
46304049	975125	0	0
46321191	1125315	0	0
4180628	440448	5	8
21000471	1551192	2	3
21001738	1112807	0	0
21500927	975125	0	0
21603514	1107830	0	0
36157578	1125315	0	0
36300000	4010253	4	9
40782473	3000876	3	3
44356036	1112807	0	0
44346790	1119510	0	0
44346209	1729720	0	0
44347162	40228214	2	3
45631136	1549786	0	0
45651976	1746114	0	0
45667738	1125315	0	0
45660383	1125315	0	0
45664075	1119510	0	0
45639475	740275	0	0
45686631	1112807	0	0
45670610	723013	0	0
45686050	1521369	0	0
45781919	43012036	2	3
45779766	1125315	0	0
45777725	967823	0	0
45682152	1129625	0	0
45797577	1119510	0	0
45800993	1119510	0	0
46244075	1119510	0	0
45788655	1129625	0	0
46312628	1343916	0	0
46304050	1153428	0	0
46321331	1125315	0	0
4117930	4285898	4	9
21000472	19007333	2	3
21001743	1717327	0	0
21500889	975125	0	0
21602800	1738521	0	0
36157766	1125315	0	0
36300000	4024289	6	9
40772883	3001488	3	3
44356177	1177480	0	0
44346792	1119510	0	0
44346243	1124957	0	0
44347162	40228230	2	3
45630830	1539403	0	0
45652231	1102527	0	0
45667742	1125315	0	0
45660340	1125315	0	0
45664390	1119510	0	0
45639569	1332418	0	0
45686846	1112807	0	0
45670583	914335	0	0
45686143	967823	0	0
45779563	43012036	2	3
45779792	1125315	0	0
45777640	920293	0	0
45682155	1129625	0	0
45797735	1119510	0	0
45801150	1119510	0	0
46244165	1119510	0	0
45788661	1129625	0	0
46313259	1115008	0	0
46304215	1174888	0	0
46321451	1125315	0	0
4093991	78272	4	9
21000472	1551192	2	3
21001749	1713332	0	0
21500892	975125	0	0
21602016	1129625	0	0
36157643	1125315	0	0
36300000	4252419	6	9
40772617	3008598	3	3
44356081	1124300	0	0
44348446	1119510	0	0
44346160	1129625	0	0
44347677	40228214	2	3
45631094	1107830	0	0
45651820	1115008	0	0
45667743	1125315	0	0
45660334	1125315	0	0
45664393	1119510	0	0
45639589	1149380	0	0
45686941	1112807	0	0
45670278	1545958	0	0
45685623	1154343	0	0
45779589	40162522	2	3
45779884	1125315	0	0
45777656	1115008	0	0
45682381	1129625	0	0
45797845	1119510	0	0
45799770	1119510	0	0
46244175	1119510	0	0
46297507	1129625	0	0
46312733	1501700	0	0
46304229	975125	0	0
46321080	1125315	0	0
4042140	4237458	3	9
4301351	4323902	2	6
21001749	1759842	0	0
21500973	975125	0	0
35508949	1177480	0	0
36157710	1125315	0	0
36300000	134438	6	11
37203740	260139	3	3
44356118	1110410	0	0
44348382	1119510	0	0
44346320	1115008	0	0
44347677	40228230	2	3
45631102	1153428	0	0
45651821	1738521	0	0
45667837	1125315	0	0
45660392	1125315	0	0
45664309	1119510	0	0
45639589	1137529	0	0
45686815	1112807	0	0
45669942	1107830	0	0
45685987	1396131	0	0
45779644	1115171	2	3
45779660	1125315	0	0
45777796	975125	0	0
45682349	1129625	0	0
45797599	1119510	0	0
45799716	1119510	0	0
46244232	1119510	0	0
46297934	1129625	0	0
46312630	914335	0	0
46304117	1551099	0	0
46321354	1125315	0	0
4042140	380378	4	7
4301351	4117038	2	6
21001750	1728416	0	0
21500954	1129625	0	0
35508985	1119510	0	0
36157616	1125315	0	0
36300000	80809	6	10
37003668	198199	3	3
44356119	1545958	0	0
44342766	1119510	0	0
44346326	975125	0	0
44354620	40223768	2	3
45630976	1713332	0	0
45649324	1174888	0	0
45667838	1125315	0	0
45660504	1125315	0	0
45778196	1119510	0	0
45639672	1154029	0	0
45686809	1112807	0	0
45669927	1192710	0	0
45686104	1500211	0	0
45779737	1115171	2	3
45779602	1125315	0	0
45777797	723013	0	0
45682191	1129625	0	0
45797698	1119510	0	0
45798088	1119510	0	0
46244286	1119510	0	0
46298219	1129625	0	0
46312683	975125	0	0
46304072	975125	0	0
46321224	1125315	0	0
4042140	257012	4	9
4301351	4163971	2	7
21001757	1729720	0	0
21501001	967823	0	0
35508985	738818	0	0
36157621	1125315	0	0
36300000	40478878	6	7
36718163	4043241	3	3
44356122	1501700	0	0
44342777	1119510	0	0
44346327	1129625	0	0
45655524	1539411	2	3
45631023	1107830	0	0
45649327	1174888	0	0
45667546	1125315	0	0
45660505	1125315	0	0
45661833	1119510	0	0
45639676	914335	0	0
45683577	1112807	0	0
45669901	1000560	0	0
45686169	1305058	0	0
45779742	40162522	2	3
45779920	1125315	0	0
45777804	1124300	0	0
45682369	1129625	0	0
45797861	1119510	0	0
45798185	1119510	0	0
46244289	1119510	0	0
46298169	1129625	0	0
46312841	705944	0	0
46304080	1153428	0	0
46321203	1125315	0	0
4042140	30753	4	8
4171379	198199	2	4
21001746	1713332	0	0
21003205	1129625	0	0
35508990	1129625	0	0
36158064	1125315	0	0
36300000	44782520	7	10
37003664	4056621	3	3
44356182	1343916	0	0
44342760	1119510	0	0
44346302	1149196	0	0
44347738	40228214	2	3
45631220	1149380	0	0
45649408	1174888	0	0
45668017	1125315	0	0
45660506	1125315	0	0
45661649	1119510	0	0
45639542	1746114	0	0
45683720	1112807	0	0
45669976	1192710	0	0
45686172	1115008	0	0
45779747	1115171	2	3
45779923	1125315	0	0
45777790	1192710	0	0
45682124	1129625	0	0
45794855	1119510	0	0
45798069	1119510	0	0
46244373	1119510	0	0
46298237	1129625	0	0
46312878	1000560	0	0
46304087	1322184	0	0
46321473	1125315	0	0
4042140	4132546	4	8
4309188	30753	2	4
21001746	1759842	0	0
21003217	1129625	0	0
35508992	1738521	0	0
36158115	1125315	0	0
36300000	4047491	7	10
37003664	198199	3	3
44356186	1309944	0	0
44342788	1119510	0	0
44346309	1112807	0	0
44362456	40223768	2	3
45628783	1107830	0	0
45649411	757627	0	0
45667163	1125315	0	0
45660359	1125315	0	0
45661673	1119510	0	0
45639680	1107830	0	0
45683888	1112807	0	0
45669903	1124300	0	0
45685762	1000560	0	0
45779803	40229134	2	3
45708118	1125315	0	0
45777791	1154343	0	0
45678881	1129625	0	0
45797135	1119510	0	0
45798261	1119510	0	0
46244384	1119510	0	0
46298178	1129625	0	0
46313032	1310149	0	0
46304307	1308738	0	0
46320954	1125315	0	0
4042140	4035415	4	8
4301347	4301346	1	1
21001753	1768849	0	0
21002884	1746114	0	0
35508994	791967	0	0
36158076	1125315	0	0
36300000	4027663	7	11
40779671	3026361	3	3
44356190	738818	0	0
44342874	1119510	0	0
44346313	1124957	0	0
44354923	19078461	2	3
45628822	1124957	0	0
45649556	975125	0	0
45667219	1125315	0	0
45660347	1125315	0	0
45661767	1119510	0	0
45639660	715997	0	0
45683932	1112807	0	0
45670023	1501700	0	0
45685768	1713332	0	0
45779837	19008572	2	3
45708354	1125315	0	0
45777634	1124300	0	0
45678862	1129625	0	0
45797188	1119510	0	0
45798397	1119510	0	0
46244402	1119510	0	0
46298339	1129625	0	0
46312649	967823	0	0
46304608	1545958	0	0
46320967	1125315	0	0
4042140	81151	5	10
4301347	44783196	1	1
21001757	1713332	0	0
21002894	1717327	0	0
35508935	1153428	0	0
36158023	1125315	0	0
36300000	317009	7	8
37503950	4043071	3	3
44356207	1129625	0	0
44342964	1119510	0	0
44346244	975125	0	0
44362563	19078461	2	3
45628825	1778162	0	0
45649574	738818	0	0
45667193	1125315	0	0
45660416	1125315	0	0
45661320	1119510	0	0
45639856	1124300	0	0
45684007	1112807	0	0
45781234	791967	0	0
45685769	738818	0	0
45708337	19019273	2	3
45708207	1125315	0	0
45777741	975125	0	0
45678746	1129625	0	0
45797190	1119510	0	0
45798508	1119510	0	0
46239161	1119510	0	0
46298382	1129625	0	0
46313034	1343916	0	0
46304281	1549786	0	0
46321582	1125315	0	0
4042140	4294548	5	10
4214956	45766064	1	1
21001758	1728416	0	0
21002894	1741122	0	0
35509025	1107830	0	0
36157982	1125315	0	0
36300000	4237458	7	13
40782921	3019406	3	3
44356224	1322184	0	0
44343084	1119510	0	0
44346245	975125	0	0
44348023	19078461	2	3
45628781	1738521	0	0
45649264	975125	0	0
45667249	1125315	0	0
45660422	1125315	0	0
45777849	1119510	0	0
45639549	1361711	0	0
45680558	1112807	0	0
45781326	1000560	0	0
45685971	1110410	0	0
45777957	920334	2	3
45708348	1125315	0	0
45777746	1192710	0	0
45706689	1119510	0	0
45795027	1119510	0	0
45795393	1119510	0	0
46239175	1119510	0	0
46298545	1129625	0	0
46312795	1115008	0	0
46304281	19127890	0	0
46321585	1125315	0	0
4042140	440448	5	10
19057704	19128263	1	1
21001751	1717327	0	0
21002894	1778162	0	0
35508873	1124300	0	0
36158237	1125315	0	0
36300000	198809	7	13
37019273	195588	3	3
44356245	701322	0	0
44342796	1119510	0	0
44346479	975125	0	0
45661755	19078461	2	3
45628788	1124300	0	0
45649216	1713332	0	0
45665454	1125315	0	0
45660431	1125315	0	0
45777823	1119510	0	0
45639551	1308738	0	0
45680671	1112807	0	0
45781278	738818	0	0
45685779	1174888	0	0
45777970	19059056	2	3
45777918	1125315	0	0
45777704	1521369	0	0
45706693	1119510	0	0
45795053	1119510	0	0
45795561	1119510	0	0
46239371	1119510	0	0
46298300	1129625	0	0
46312812	1309944	0	0
46304197	975125	0	0
46321588	1125315	0	0
4042140	40480160	5	9
19057704	19128022	1	1
21001757	1759842	0	0
21002894	1746114	0	0
35508874	1551099	0	0
36158073	1125315	0	0
36300000	257012	7	13
40797982	3004501	3	3
44356246	1153428	0	0
44343134	1119510	0	0
44346221	1539403	0	0
44354919	19078461	2	3
45628795	1307863	0	0
45649220	1501700	0	0
45665581	1125315	0	0
45660438	1125315	0	0
45654850	1119510	0	0
45639913	1174888	0	0
45682260	1112807	0	0
45781281	723013	0	0
45686206	1539403	0	0
45705861	19008572	2	3
45778205	1125315	0	0
45777704	19127890	0	0
45705287	1119510	0	0
45795089	1119510	0	0
45795570	1119510	0	0
46239433	1119510	0	0
46289703	1129625	0	0
46312928	1192710	0	0
46304287	791967	0	0
46321590	1125315	0	0
4042140	4146173	5	9
4337138	4337611	1	1
21001744	1759842	0	0
21002902	1557272	0	0
35508877	1125315	0	0
36157977	1125315	0	0
36300000	4280726	7	14
37202310	4051466	3	3
44356040	19127890	0	0
44343004	1119510	0	0
44346229	1129625	0	0
44362331	19078461	2	3
45628841	1501700	0	0
45649222	1307863	0	0
45665677	1125315	0	0
45660475	1125315	0	0
45635051	1177480	0	0
45639559	1343916	0	0
45677489	1112807	0	0
45781273	1124957	0	0
45686142	1501700	0	0
45705769	40232448	2	3
45778139	1125315	0	0
45777704	1549786	0	0
45705238	1119510	0	0
45795149	1119510	0	0
45795579	1119510	0	0
46239533	1119510	0	0
46290057	1129625	0	0
46312929	1153428	0	0
46304302	1000560	0	0
46321595	1125315	0	0
4042140	198809	5	9
4340361	4166224	1	1
21001769	1738521	0	0
21002885	1746114	0	0
35508945	1125315	0	0
36103041	198199	6	6
36300000	80180	7	9
40772892	3049273	3	3
44356040	1589505	0	0
44343011	1119510	0	0
44346261	1549786	0	0
44357763	19078461	2	3
45628890	1332418	0	0
44337912	1177480	0	0
45665682	1125315	0	0
45660571	1125315	0	0
45635028	1177480	0	0
45639804	1192710	0	0
45677484	1112807	0	0
45781385	1713332	0	0
45686180	1115008	0	0
45706088	40232448	2	3
45777960	1125315	0	0
45777751	1154343	0	0
45705267	1119510	0	0
45795057	1119510	0	0
45795546	1119510	0	0
46239547	1119510	0	0
46290270	1129625	0	0
46312931	1717327	0	0
46304356	1343916	0	0
46321614	1125315	0	0
4042140	4266809	5	8
4261784	81893	1	1
21001769	1713332	0	0
21002895	1557272	0	0
35508945	1119510	0	0
36102970	433125	6	6
36300000	40479768	11	14
37202312	255848	3	3
44356040	1549786	0	0
44343098	1119510	0	0
44346261	19127890	0	0
44358074	19078461	2	3
45625735	1149196	0	0
44778256	1177480	0	0
45665603	1125315	0	0
45660487	1125315	0	0
45635017	1177480	0	0
45636477	1115008	0	0
45677784	1112807	0	0
45781123	1545958	0	0
45686181	738818	0	0
45706043	1551192	2	3
45777941	1125315	0	0
45777779	1548195	0	0
45780010	1119510	0	0
45792279	1119510	0	0
45795592	1119510	0	0
46239639	1119510	0	0
46290245	1129625	0	0
46313223	738818	0	0
46304314	1000560	0	0
46321619	1125315	0	0
4042140	198199	5	8
4217966	4047491	1	1
21001745	1759842	0	0
21002912	1551099	0	0
35508948	975125	0	0
36102970	28060	6	6
36300000	4218389	8	10
36718588	4029498	3	3
44356047	1149380	0	0
44343173	1119510	0	0
44346261	1515774	0	0
44340037	19078461	2	3
45625844	1332418	0	0
44778258	1177480	0	0
45665737	1125315	0	0
45660616	1125315	0	0
45634991	1177480	0	0
45636299	1107830	0	0
45677864	1112807	0	0
45781335	1343916	0	0
45686155	1000560	0	0
45705901	19077344	2	3
45778031	1125315	0	0
45706372	1503184	0	0
45779967	1119510	0	0
45792360	1119510	0	0
45795646	1119510	0	0
46239560	1119510	0	0
46290294	1129625	0	0
46313224	1149196	0	0
46320092	1521369	0	0
46321657	1125315	0	0
4042140	4156265	5	8
4201402	440448	1	1
21001772	1107830	0	0
21002900	1589505	0	0
35508952	1125315	0	0
36100000	4048171	6	6
36300000	140673	8	10
40779558	3005136	3	3
44356050	1129625	0	0
44343216	1119510	0	0
44346262	1177480	0	0
44340639	19078461	2	3
45625857	1174888	0	0
44778237	1177480	0	0
45665617	1125315	0	0
45660733	1125315	0	0
45635282	1177480	0	0
45636300	1124957	0	0
45674282	1112807	0	0
45781368	1174888	0	0
45685939	967823	0	0
45705992	19008572	2	3
45778000	1125315	0	0
45706372	19127890	0	0
45779679	1119510	0	0
45792364	1119510	0	0
45795649	1119510	0	0
46239580	1119510	0	0
46289670	1129625	0	0
46313079	1174888	0	0
46320092	1549786	0	0
46321664	1125315	0	0
4042140	45769019	6	8
4201540	4108705	1	1
21001770	1149196	0	0
21002900	1500211	0	0
35508960	1119510	0	0
35802131	4156265	6	8
36300000	440086	8	10
37503959	4337138	3	3
44356143	738818	0	0
44343020	1119510	0	0
44346463	1192710	0	0
45655888	19078461	2	3
45625941	1738521	0	0
44358319	1177480	0	0
45665633	1125315	0	0
45660641	1125315	0	0
45635382	1177480	0	0
45636302	1149380	0	0
45676225	1112807	0	0
45781375	967823	0	0
45686006	1110410	0	0
45703694	19078461	2	3
45778003	1125315	0	0
45706372	1521369	0	0
45780195	1119510	0	0
45792427	1119510	0	0
45795690	1119510	0	0
46239679	1119510	0	0
46292015	1129625	0	0
46313084	740275	0	0
46320254	1118084	0	0
46315312	1125315	0	0
4042140	4113008	6	7
19086049	19126352	1	1
21001744	1717327	0	0
21002975	914335	0	0
35508962	1119510	0	0
36102154	4116491	6	8
36300000	80502	8	10
36718119	4132546	3	3
44356057	1124957	0	0
44339274	1119510	0	0
44346463	1112807	0	0
44351125	19078461	2	3
45625563	1115008	0	0
44358502	1177480	0	0
45663134	1125315	0	0
45658565	1125315	0	0
45635345	1177480	0	0
45636366	975125	0	0
45674422	1112807	0	0
45781100	1149196	0	0
45686016	1153428	0	0
45703575	40228214	2	3
45705648	1125315	0	0
45706542	791967	0	0
45780063	1119510	0	0
45792429	1119510	0	0
45796925	1119510	0	0
46239757	1119510	0	0
46242013	1129625	0	0
46307371	1539403	0	0
46320257	1112807	0	0
46315366	1125315	0	0
4042140	378419	6	9
19084040	19077344	1	1
21506158	967823	0	0
21003001	1500211	0	0
35508962	738818	0	0
35202461	4048171	6	9
36300000	4056621	8	12
40782530	3005136	4	4
44356166	1738521	0	0
44339412	1119510	0	0
44346248	1115008	0	0
44354810	19078461	2	3
45625512	1738521	0	0
44358598	1177480	0	0
45663231	1125315	0	0
45658566	1125315	0	0
45629993	1177480	0	0
45636030	1551099	0	0
45674554	1112807	0	0
45781127	1332418	0	0
45685752	1322184	0	0
45703873	19057271	2	3
45705587	1125315	0	0
45706587	1149196	0	0
45780118	1119510	0	0
45792631	1119510	0	0
45796937	1119510	0	0
46239588	1119510	0	0
46242024	1129625	0	0
46307535	1192710	0	0
46320341	1713332	0	0
46315373	1125315	0	0
4180627	4275113	6	8
19084980	19077572	1	1
21506206	1332418	0	0
21002898	1548195	0	0
35508967	1713332	0	0
36200000	40479422	6	11
36300000	4132546	8	12
37503959	4323902	4	4
44356158	1124300	0	0
44339606	1119510	0	0
44346465	738818	0	0
44358137	1332419	2	3
45625868	1332418	0	0
44358610	1177480	0	0
45663232	1125315	0	0
45658374	1125315	0	0
45630039	1177480	0	0
45636630	1115008	0	0
45671545	1112807	0	0
45781128	1124300	0	0
45685753	1713332	0	0
45702268	40223834	2	3
45705852	1125315	0	0
45706420	1551099	0	0
45779971	1119510	0	0
45792161	1119510	0	0
45797227	1119510	0	0
46239658	1119510	0	0
46242233	1129625	0	0
46307850	1124957	0	0
46320341	1759842	0	0
46315624	1125315	0	0
4180627	4242997	6	7
19085458	836659	1	1
21506167	1115008	0	0
21002900	1521369	0	0
35508967	1759842	0	0
36102149	433125	7	7
4141937	4323902	3	3
37503959	4337611	4	4
44356162	738818	0	0
44339512	1119510	0	0
44346361	1501700	0	0
44354574	1332419	2	3
45625912	1115008	0	0
44351368	1177480	0	0
45663283	1125315	0	0
45650247	1713332	0	0
45630133	1177480	0	0
45636522	1309944	0	0
45671533	1112807	0	0
45781161	740275	0	0
45686162	1149380	0	0
45702354	920334	2	3
45705856	1125315	0	0
45706422	1500211	0	0
45779977	1119510	0	0
45792447	1119510	0	0
45797247	1119510	0	0
46239728	1119510	0	0
46241918	1129625	0	0
46307863	738818	0	0
46320270	1118084	0	0
46315628	1125315	0	0
4180627	44783196	3	8
19061283	19128009	1	1
21500621	753626	0	0
21002900	1549786	0	0
35508968	1129625	0	0
36102154	28060	7	7
4181063	198809	3	3
36718119	4001336	4	4
44352659	1129625	0	0
44339623	1119510	0	0
44346056	1149380	0	0
44340600	1332419	2	3
45625915	757627	0	0
44351445	1177480	0	0
45663284	1125315	0	0
45650552	1759842	0	0
45630168	1177480	0	0
45636217	738818	0	0
45669905	1112807	0	0
45781165	1124957	0	0
45685930	1308738	0	0
45702326	1115171	2	3
45705532	1125315	0	0
45706427	1174888	0	0
45780038	1119510	0	0
45792152	1119510	0	0
45797249	1119510	0	0
46239730	1119510	0	0
46241923	1129625	0	0
46307511	1332418	0	0
46320251	1124300	0	0
46315663	1125315	0	0
4180627	4058899	3	8
19019339	19129144	1	1
21500645	19003953	0	0
21002900	1512674	0	0
35508969	1112807	0	0
36102154	433125	7	7
4181063	4280726	3	3
36718588	380378	4	4
44352661	1729720	0	0
44339627	1119510	0	0
44346059	1713332	0	0
44340822	1332419	2	3
45626006	1713332	0	0
44351412	1177480	0	0
45663180	1125315	0	0
45650449	1149380	0	0
45630260	1177480	0	0
45636449	1307863	0	0
45783881	1112807	0	0
45781250	738818	0	0
45685933	738818	0	0
45702346	40163554	2	3
45706069	1125315	0	0
45706442	1310149	0	0
45780039	1119510	0	0
45792630	1119510	0	0
45792873	1119510	0	0
46239733	1119510	0	0
46242042	1129625	0	0
46307864	738818	0	0
46320377	1174888	0	0
46315667	1125315	0	0
4180627	4186930	5	7
19019339	19127922	1	1
21013503	1361711	0	0
21002899	1557272	0	0
35508972	1310149	0	0
36102154	198199	7	7
4181063	81893	3	3
37522376	4108705	4	4
44352794	1177480	0	0
44339443	1119510	0	0
44346424	975125	0	0
44347935	1332419	2	3
45625952	1000560	0	0
44344324	1177480	0	0
45663184	1125315	0	0
45650452	1107830	0	0
45629950	1177480	0	0
45636450	1107830	0	0
45783795	1112807	0	0
45781251	1545958	0	0
45686125	1367571	0	0
45702436	40232448	2	3
45705945	1125315	0	0
45706450	1115008	0	0
45780041	1119510	0	0
45792172	1119510	0	0
45793013	1119510	0	0
45895917	1119510	0	0
46242002	1129625	0	0
46307935	1192710	0	0
46320570	1112807	0	0
46315902	1125315	0	0
4180627	4330583	5	9
19019339	19133679	1	1
21013503	975125	0	0
21003024	19039298	0	0
35508974	1129625	0	0
35802131	375671	8	10
4180941	44805732	3	3
37203758	4051466	4	4
44352838	933724	0	0
44339554	1119510	0	0
44346490	738818	0	0
44354711	1545959	2	3
45625742	738818	0	0
44337373	1177480	0	0
45663275	1125315	0	0
45650255	740275	0	0
45627213	1177480	0	0
45636460	1174888	0	0
45783798	1112807	0	0
45781251	1332418	0	0
45686133	1124300	0	0
45702502	19008572	2	3
45705809	1125315	0	0
45706412	1149196	0	0
45706900	1119510	0	0
45792514	1119510	0	0
45792825	1119510	0	0
45896106	1119510	0	0
45893540	1129625	0	0
46307945	1149196	0	0
46320579	701322	0	0
46315577	1125315	0	0
4180627	4047491	5	8
19019340	19128065	1	1
21013496	1551099	0	0
21003024	782043	0	0
35508978	1154343	0	0
35802131	378419	8	9
4180941	4163971	3	3
37503943	4117038	4	4
44352844	1115008	0	0
44339558	1119510	0	0
44346498	1551099	0	0
44340954	19078461	2	3
45625743	1110410	0	0
44337305	1177480	0	0
45663276	1125315	0	0
45650187	1153428	0	0
45627162	1177480	0	0
45636464	1307863	0	0
45783992	1112807	0	0
45781353	738818	0	0
45688610	1305058	0	0
45702435	40232448	2	3
45706047	1125315	0	0
45706598	1153428	0	0
45707015	1119510	0	0
45792651	1119510	0	0
45792831	1119510	0	0
45895878	1119510	0	0
45893649	1129625	0	0
46307705	1322184	0	0
46320580	1738521	0	0
46315968	1125315	0	0
4180627	4108705	5	8
4344027	4149245	1	1
21013536	1717327	0	0
21003003	1501700	0	0
35509042	19127890	0	0
35300000	4043241	8	8
4042505	4066995	3	5
37003680	195588	4	4
44352845	1124300	0	0
44339349	1119510	0	0
44346267	738818	0	0
44340226	1539411	2	3
45625969	1738521	0	0
44337772	1177480	0	0
45663347	1125315	0	0
45650356	740275	0	0
45627419	1177480	0	0
45636423	1149196	0	0
45781721	1112807	0	0
45781363	19127890	0	0
45688615	701322	0	0
45702480	1127433	2	3
45705785	1125315	0	0
45706537	791967	0	0
45707019	1119510	0	0
45789500	1119510	0	0
45793089	1119510	0	0
45896170	1119510	0	0
45893753	1129625	0	0
46307946	1153428	0	0
46320592	1192710	0	0
46315217	1125315	0	0
4180627	4117038	5	8
4344271	81151	1	1
21013536	1759842	0	0
21003024	1154029	0	0
35509042	1589505	0	0
36202157	40480160	9	9
4201944	4010253	3	5
37502348	4043071	4	4
44352684	1545958	0	0
44341300	1119510	0	0
44346249	723013	0	0
44337636	1738521	0	0
45625971	19127890	0	0
44337513	1177480	0	0
45663349	1125315	0	0
45650362	1107830	0	0
45627260	1177480	0	0
45636436	738818	0	0
45779232	1112807	0	0
45781363	1515774	0	0
45688621	1124957	0	0
45699381	19018935	2	3
45706079	1125315	0	0
45706491	1322184	0	0
45706100	1119510	0	0
45789558	1119510	0	0
45793128	1119510	0	0
45896136	1119510	0	0
45893826	1129625	0	0
46307995	1501700	0	0
46320764	1738521	0	0
46315935	1125315	0	0
4180627	4337611	5	8
4318404	255848	1	1
21013536	1713332	0	0
21003027	1102527	0	0
35509042	1549786	0	0
36217214	42902245	3	4
4201745	4310024	3	5
40782937	3027231	4	4
44352858	1192710	0	0
44341432	1119510	0	0
44346268	1129625	0	0
44337849	1501700	0	0
45625971	1589505	0	0
45622053	1177480	0	0
45663405	1125315	0	0
45650521	1501700	0	0
45627160	1177480	0	0
45636445	1174888	0	0
45779235	1112807	0	0
45781363	1549786	0	0
45688574	967823	0	0
45699534	19008572	2	3
45706083	1125315	0	0
45706452	1107830	0	0
45706221	1119510	0	0
45789727	1119510	0	0
45793049	1119510	0	0
45896031	1119510	0	0
45893832	1129625	0	0
46307714	1192710	0	0
46320379	920293	0	0
46316136	1125315	0	0
4180627	4323902	5	8
4321844	4117038	1	1
21002805	1124300	0	0
21003027	1110410	0	0
35509043	1177480	0	0
36217214	19128022	3	4
4201745	198809	3	5
40782937	3015076	4	4
44352685	1149196	0	0
44339676	1119510	0	0
44346059	1759842	0	0
44337601	1192710	0	0
45625971	1549786	0	0
45622019	1177480	0	0
45663076	1125315	0	0
45650636	738818	0	0
45623708	1177480	0	0
45636587	1305058	0	0
45778828	1112807	0	0
45781476	914335	0	0
45688529	1539403	0	0
45699384	40236446	2	3
45705893	1125315	0	0
45706454	705944	0	0
45706223	1119510	0	0
45789743	1119510	0	0
45793167	1119510	0	0
45895997	1119510	0	0
45801808	1129625	0	0
46307726	738818	0	0
46320595	1548195	0	0
46316026	1125315	0	0
4180627	4238715	4	6
4301352	4337138	1	1
21002805	1305058	0	0
21002900	1548195	0	0
35509056	1125315	0	0
36217214	19133768	2	3
4201745	4266809	3	5
40782937	3006734	4	4
44352810	1548195	0	0
44339831	1119510	0	0
44346375	1124957	0	0
44337637	1307863	0	0
45625870	1515774	0	0
45622090	1177480	0	0
45663518	1125315	0	0
45650718	1107830	0	0
45625223	1177480	0	0
45636508	1149196	0	0
45779265	1112807	0	0
45781219	791967	0	0
45688668	708298	0	0
45699645	19019273	2	3
45705851	1125315	0	0
45706456	1110410	0	0
45706165	1119510	0	0
45789746	1119510	0	0
45793324	1119510	0	0
45896099	1119510	0	0
45802461	1129625	0	0
46307734	933724	0	0
46320595	19054876	0	0
46315566	1125315	0	0
4180627	4010253	4	6
19057161	19128009	1	1
21002804	1778162	0	0
21003024	19002770	0	0
35509059	1125315	0	0
36217214	40223834	2	3
4201745	30753	3	5
37202317	40486433	4	4
44352966	1115008	0	0
44339699	1119510	0	0
44346253	1332418	0	0
44337873	738818	0	0
45625870	19127890	0	0
45658541	1177480	0	0
45663373	1125315	0	0
45647015	1110410	0	0
45625348	1177480	0	0
45636588	1107830	0	0
45779268	1112807	0	0
45781478	1738521	0	0
45682728	1174888	0	0
45699471	1107882	2	3
45705971	1125315	0	0
45706459	1192710	0	0
45706359	1119510	0	0
45789633	1119510	0	0
45793411	1119510	0	0
45896807	1119510	0	0
45799071	1129625	0	0
46307610	1549786	0	0
46320541	1307863	0	0
46315842	1125315	0	0
4180627	44805732	4	6
19057161	19127918	1	1
21002805	1118084	0	0
21002955	975125	0	0
35509062	19127890	0	0
36217214	1150837	2	3
4093991	4149245	4	5
37202317	4280726	4	4
44352971	1149196	0	0
44339771	1119510	0	0
44346386	975125	0	0
44338023	1713332	0	0
45625870	1549786	0	0
45658457	1177480	0	0
45663194	1125315	0	0
45646895	1717327	0	0
45625152	1177480	0	0
45636218	1000560	0	0
45779277	1112807	0	0
45781226	1501700	0	0
45682736	1521369	0	0
45699655	42707627	2	3
45705998	1125315	0	0
45706462	1174888	0	0
45706176	1119510	0	0
45789650	1119510	0	0
45791942	1119510	0	0
45804357	1119510	0	0
45799083	1129625	0	0
46307610	1521369	0	0
46320843	1149380	0	0
46315873	1125315	0	0
4180627	4301346	4	9
4233623	40478878	1	1
21003153	1125315	0	0
21002900	1557272	0	0
35509062	1515774	0	0
36217214	19018935	2	3
4113999	4285898	4	5
37203740	261325	4	4
44352927	1713332	0	0
44339772	1119510	0	0
44346061	1177480	0	0
44338026	1149196	0	0
45625881	1174888	0	0
45658869	1177480	0	0
45663660	1125315	0	0
45647246	1549786	0	0
45624518	1177480	0	0
45636638	1107830	0	0
45779287	1112807	0	0
45781230	1713332	0	0
45682868	1124957	0	0
45699659	40228230	2	3
45703861	1125315	0	0
45706552	1539403	0	0
45706255	1119510	0	0
45789768	1119510	0	0
45791978	1119510	0	0
45796287	1119510	0	0
45799164	1129625	0	0
46307612	1149196	0	0
46320861	1557272	0	0
46315886	1125315	0	0
4180627	4337138	4	7
4216752	4107731	1	1
21003156	1177480	0	0
21002901	1557272	0	0
35509062	1549786	0	0
36217214	40236446	2	3
4041261	4117038	4	5
37203740	258780	4	4
44352668	1149196	0	0
44362962	1125315	0	0
44346646	1115008	0	0
44337906	1149380	0	0
45625885	738818	0	0
45658442	1177480	0	0
45663727	1125315	0	0
45647246	1589505	0	0
45624141	1177480	0	0
45636438	1548195	0	0
45780702	1112807	0	0
45781230	1759842	0	0
45682870	1500211	0	0
45699688	43012036	2	3
45702248	1125315	0	0
45706646	1154343	0	0
45706265	1119510	0	0
45789836	1119510	0	0
45791849	1119510	0	0
45797162	1119510	0	0
45799134	1129625	0	0
46307626	967823	0	0
46320406	1124957	0	0
46316038	1125315	0	0
4180627	4057420	4	7
21000640	19127918	1	1
21003156	1115008	0	0
21003017	753626	0	0
35509068	1112807	0	0
36217214	1127433	2	3
4042505	4237458	4	5
37202310	260139	4	4
44352823	1129625	0	0
44362940	1125315	0	0
44338834	1124957	0	0
44337919	1174888	0	0
45625888	1124300	0	0
45658991	1177480	0	0
45663661	1125315	0	0
45647258	1332418	0	0
45624277	1177480	0	0
45636592	1521369	0	0
45779422	1112807	0	0
45781311	1124957	0	0
45682736	1549786	0	0
45695988	1107882	2	3
45702251	1125315	0	0
45706668	1115008	0	0
45706559	1119510	0	0
45789681	1119510	0	0
45790255	1119510	0	0
45796530	1119510	0	0
45793980	1129625	0	0
46307916	1539403	0	0
46320683	1107830	0	0
46315997	1125315	0	0
4180627	4216130	4	8
21000640	19128009	1	1
21003157	1125315	0	0
21003025	708298	0	0
35509145	1548195	0	0
36217214	19045231	2	3
4054559	4336464	4	5
36703484	4043241	4	4
44352826	738818	0	0
44362914	1125315	0	0
44338972	1124300	0	0
44778144	920293	0	0
45626019	1153428	0	0
45659047	1177480	0	0
45663158	1125315	0	0
45647261	1107830	0	0
45668393	1177480	0	0
45636153	1192710	0	0
45779455	1112807	0	0
45781389	1115008	0	0
45683056	19127890	0	0
45696207	35605482	2	3
45702256	1125315	0	0
45706721	1154343	0	0
45706561	1119510	0	0
45789965	1119510	0	0
45790279	1119510	0	0
45796535	1119510	0	0
45793702	1129625	0	0
46308144	1110410	0	0
46320687	1501700	0	0
46316009	1125315	0	0
4237321	4323902	2	2
4339410	4059173	5	5
21003174	738818	0	0
21002958	1717327	0	0
35509107	1125315	0	0
36217214	1115171	2	3
4180938	4252419	4	5
40779591	3020655	4	4
44352674	723013	0	0
44362995	1125315	0	0
44339041	742185	0	0
44778204	1545958	0	0
45626049	1000560	0	0
44352072	1177480	0	0
45663459	1125315	0	0
45647250	1551099	0	0
45668561	1177480	0	0
45636340	738818	0	0
45708069	1112807	0	0
45781391	1361711	0	0
45683056	1549786	0	0
45696095	1127433	2	3
45702242	1125315	0	0
45706724	1153428	0	0
45706404	1119510	0	0
45789165	1119510	0	0
45790243	1119510	0	0
45796630	1119510	0	0
45794091	1129625	0	0
46308021	1713332	0	0
46320698	1332418	0	0
46309612	1125315	0	0
4237321	4246502	2	2
4339410	4048695	5	5
21003174	1125315	0	0
21002958	1728416	0	0
35509107	1112807	0	0
36217214	920300	2	3
4180938	4024289	4	5
40782473	3021226	4	4
44352675	1332418	0	0
44363106	1125315	0	0
44338937	1174888	0	0
44778157	1153428	0	0
45625980	1115008	0	0
45652400	1177480	0	0
45659665	1125315	0	0
45646896	1107830	0	0
45668837	1177480	0	0
45636347	967823	0	0
45708076	1112807	0	0
45781312	1000560	0	0
45683056	1521369	0	0
45696068	42707627	2	3
45702287	1125315	0	0
45706725	1539403	0	0
45706249	1119510	0	0
45789239	1119510	0	0
45790249	1119510	0	0
45796693	1119510	0	0
45794247	1129625	0	0
46308216	975125	0	0
46320786	1738521	0	0
46309617	1125315	0	0
4237320	4326177	2	2
4339410	4278672	5	5
21003174	1129625	0	0
21002959	1728416	0	0
35509044	933724	0	0
36217214	19112599	2	3
4227253	4329847	4	5
37522284	4337611	4	4
44352769	1112807	0	0
44363100	1125315	0	0
44338938	1548195	0	0
44778165	1153428	0	0
45625827	1149196	0	0
45652431	1177480	0	0
45659917	1125315	0	0
45647263	1115008	0	0
45666138	1177480	0	0
45636325	1501700	0	0
45705329	1112807	0	0
45781625	738818	0	0
45682838	1107830	0	0
45696225	43012036	2	3
45702291	1125315	0	0
45706682	1149196	0	0
45706192	1119510	0	0
45787097	1119510	0	0
45790443	1119510	0	0
45796671	1119510	0	0
45794125	1129625	0	0
46308228	1174888	0	0
46320718	1112807	0	0
46309622	1125315	0	0
4275564	4057420	2	2
4339410	4066995	5	5
21003153	1177480	0	0
21003017	708298	0	0
35509047	1177480	0	0
36217214	40231925	2	3
4141937	4336464	5	5
37016775	4066995	4	4
44352774	967823	0	0
44363103	1125315	0	0
44338948	1129625	0	0
44778004	1149196	0	0
45626058	1107830	0	0
45652734	1177480	0	0
45659845	1125315	0	0
45647066	1551099	0	0
45666319	1177480	0	0
45636594	1322184	0	0
45705433	1112807	0	0
45781581	1332418	0	0
45683001	914335	0	0
45696255	1115171	2	3
45702270	1125315	0	0
45706729	914335	0	0
45700619	1119510	0	0
45787098	1119510	0	0
45790538	1119510	0	0
45791177	1119510	0	0
45794266	1129625	0	0
46308266	1192710	0	0
46320913	967823	0	0
46309811	1125315	0	0
4043371	440448	2	2
4339468	40486433	5	5
21003174	1150836	0	0
21003017	1102527	0	0
35509092	19127890	0	0
36217214	43012036	2	3
4201944	4037675	5	5
37016775	4048695	4	4
44352779	1717327	0	0
44363243	1125315	0	0
44338952	1124300	0	0
44778214	1589505	0	0
45625836	1115008	0	0
44344404	1177480	0	0
45659846	1125315	0	0
45647302	1174888	0	0
45666281	1177480	0	0
45636530	791967	0	0
45702051	1112807	0	0
45781700	1107830	0	0
45682991	1149196	0	0
45696290	19008572	2	3
45702305	1125315	0	0
45706637	1551099	0	0
45699774	1119510	0	0
45786990	1119510	0	0
45790414	1119510	0	0
45791178	1119510	0	0
45789340	1129625	0	0
46308286	920293	0	0
46320411	1192710	0	0
46311849	1125315	0	0
4043371	28060	2	2
4339468	4280726	5	5
21003185	1343916	0	0
21003017	791967	0	0
35509092	1549786	0	0
36217214	19077344	2	3
21502620	1759842	5	5
36702247	44782520	4	5
44352790	1589505	0	0
44363026	1125315	0	0
44338953	1713332	0	0
44782520	44782520	0	0
45626070	1107830	0	0
45646279	1177480	0	0
45660009	1125315	0	0
45647306	1107830	0	0
45665984	1177480	0	0
45636486	1308738	0	0
45703808	1112807	0	0
45781324	1125315	0	0
45683098	1115008	0	0
45696165	19008572	2	3
45702342	1125315	0	0
45706714	1307863	0	0
45699895	1119510	0	0
45786993	1119510	0	0
45790606	1119510	0	0
45791247	1119510	0	0
45789348	1129625	0	0
46307698	723013	0	0
46320596	791967	0	0
46311903	1125315	0	0
4317258	134438	2	2
4279903	4163971	5	5
21003153	1192710	0	0
21003018	1309944	0	0
35509092	1515774	0	0
36217214	40174880	2	3
4130852	40479768	5	5
37202317	258780	4	5
44352780	1539403	0	0
44363109	1125315	0	0
44339030	1118084	0	0
44778201	723013	0	0
45625676	738818	0	0
45646145	1177480	0	0
45660057	1125315	0	0
45647266	738818	0	0
45666401	1177480	0	0
45636494	1115008	0	0
45699261	1112807	0	0
45781383	1125315	0	0
45683100	1729720	0	0
45696341	40223834	2	3
45702371	1125315	0	0
45706738	967823	0	0
45699781	1119510	0	0
45787050	1119510	0	0
45790610	1119510	0	0
45791148	1119510	0	0
45788700	1129625	0	0
46308167	1308738	0	0
46320600	1545958	0	0
46312002	1125315	0	0
4215793	4059978	2	2
4200516	378001	5	5
21003174	1192710	0	0
21003027	1343916	0	0
35509113	1153428	0	0
36217214	1539411	2	3
4141833	4048171	5	5
37003663	4056621	4	5
44353090	1177480	0	0
44363394	1125315	0	0
44339039	1343916	0	0
44778271	1124957	0	0
45625839	1326303	0	0
44340998	1177480	0	0
45660155	1125315	0	0
45647267	1322184	0	0
45664617	1177480	0	0
45636469	738818	0	0
45699308	1112807	0	0
45781179	1125315	0	0
45683021	1551099	0	0
45696485	40229134	2	3
45702447	1125315	0	0
45706830	1107830	0	0
45699818	1119510	0	0
45787027	1119510	0	0
45787664	1119510	0	0
45791234	1119510	0	0
45788754	1129625	0	0
46307694	1115008	0	0
46320304	1308738	0	0
46312011	1125315	0	0
4237017	40478878	2	2
4200516	375671	5	5
21003263	933724	0	0
21003027	914335	0	0
35509114	1177480	0	0
36217216	19019979	2	3
4227253	198809	5	5
37202316	4051466	4	5
44353184	1115008	0	0
44363464	1125315	0	0
44339040	1149196	0	0
44778276	975125	0	0
45626033	1174888	0	0
44341078	1177480	0	0
45659868	1125315	0	0
45647165	757627	0	0
45664517	1177480	0	0
45636653	1154029	0	0
45695931	1112807	0	0
45781368	1125315	0	0
45683104	967823	0	0
45696487	1127433	2	3
45702520	1125315	0	0
45706616	1307863	0	0
45699970	1119510	0	0
45787166	1119510	0	0
45787722	1119510	0	0
45791239	1119510	0	0
45788904	1129625	0	0
46308287	1000560	0	0
46320911	1738521	0	0
46311993	1125315	0	0
4053826	4296204	2	2
4318379	4048171	5	5
21003174	1107830	0	0
21003025	1102527	0	0
35509201	1310149	0	0
36217216	19077572	2	3
4227253	195588	5	5
37503959	4057420	4	5
44353202	1129625	0	0
44363466	1125315	0	0
44339111	1738521	0	0
44778278	1501700	0	0
45626077	1713332	0	0
45643316	1177480	0	0
45649418	1119510	0	0
45647287	1539403	0	0
45663977	1177480	0	0
45636674	1149196	0	0
45697545	1112807	0	0
45781371	1125315	0	0
45683177	1149196	0	0
45696323	40232448	2	3
45702480	1125315	0	0
45706617	1192710	0	0
45699889	1119510	0	0
45787167	1119510	0	0
45787829	1119510	0	0
45791240	1119510	0	0
45788905	1129625	0	0
46308117	1174888	0	0
46320625	1717327	0	0
46310339	1125315	0	0
4032251	4163872	2	2
4215793	4337611	5	5
21003153	1112807	0	0
21003025	1154029	0	0
35509202	1119510	0	0
36217216	40165015	2	3
21502553	1326303	5	5
37002287	195588	4	7
44353215	1192710	0	0
44363467	1125315	0	0
44339129	705944	0	0
44778060	1149196	0	0
45626078	1153428	0	0
45643399	1177480	0	0
45649385	1119510	0	0
45647169	1174888	0	0
45664021	1177480	0	0
45636655	1115008	0	0
45697598	1112807	0	0
45781159	1125315	0	0
45683276	914335	0	0
45696519	1154615	2	3
45702415	1125315	0	0
45706620	1308738	0	0
45693482	1119510	0	0
45787188	1119510	0	0
45787871	1119510	0	0
45791355	1119510	0	0
45789012	1129625	0	0
46308170	1308738	0	0
46320999	1118084	0	0
46310341	1125315	0	0
4043197	4186930	2	2
4326426	4163971	5	5
21002808	1177480	0	0
21003025	1110410	0	0
35509119	1119510	0	0
36217216	19075001	2	3
4101219	81893	3	4
37202316	4112343	4	10
44353107	1115008	0	0
44363053	1125315	0	0
44338990	1332418	0	0
44778219	738818	0	0
45626083	1551099	0	0
45643391	1177480	0	0
45649307	1119510	0	0
45647307	1322184	0	0
45660666	1177480	0	0
45636680	753626	0	0
45697601	1112807	0	0
45781250	1125315	0	0
45683213	1521369	0	0
45696543	1545959	2	3
45699389	1125315	0	0
45706799	1124957	0	0
45693532	1119510	0	0
45787349	1119510	0	0
45786216	1119510	0	0
45791407	1119510	0	0
45788807	1129625	0	0
46308289	1551099	0	0
46321109	1124300	0	0
46310242	1125315	0	0
4194895	4062501	2	2
4197094	81893	5	6
21002808	1115008	0	0
21003025	791967	0	0
35509119	738818	0	0
36217216	19074841	2	3
4041261	4186930	3	4
37202316	40486433	4	9
44353137	1713332	0	0
44363224	1125315	0	0
44339140	1107830	0	0
44778223	1738521	0	0
45625779	1501700	0	0
45643401	1177480	0	0
45649300	1119510	0	0
45648822	705944	0	0
45660857	1177480	0	0
45636572	1115008	0	0
45697831	1112807	0	0
45781353	1125315	0	0
45683213	1549786	0	0
45693259	19059056	2	3
45699391	1125315	0	0
45706834	1107830	0	0
45693494	1119510	0	0
45787325	1119510	0	0
45786231	1119510	0	0
45791330	1119510	0	0
46296901	1129625	0	0
46308291	1192710	0	0
46320803	715997	0	0
46310263	1125315	0	0
4112731	4285898	2	2
4212577	4280726	5	6
21002808	1124300	0	0
21003063	791967	0	0
35509119	1125315	0	0
36217216	40236824	2	3
4144078	4198190	3	4
37202316	4294548	4	9
44353137	1759842	0	0
44363368	1125315	0	0
44338996	975125	0	0
44778202	1551099	0	0
45625896	1124300	0	0
45643226	1177480	0	0
45649492	1119510	0	0
45649205	1713332	0	0
45660928	1177480	0	0
45636678	1551099	0	0
45696025	1112807	0	0
45781571	1125315	0	0
45683213	19127890	0	0
45693131	40174880	2	3
45699323	1125315	0	0
45706845	1192710	0	0
45693476	1119510	0	0
45785604	1119510	0	0
45786363	1119510	0	0
45791277	1119510	0	0
46296704	1129625	0	0
46308059	705944	0	0
46321263	1551099	0	0
46310305	1125315	0	0
4045839	4336464	2	2
4212577	40486433	5	6
21002808	1551099	0	0
21003063	1115008	0	0
35509073	1119510	0	0
36217216	19073188	2	3
21505865	40236446	3	4
37202316	255848	4	8
44353113	1107830	0	0
44363514	1125315	0	0
44339167	1332418	0	0
44778069	1343916	0	0
45625911	1149196	0	0
45640340	1177480	0	0
45632050	1119510	0	0
45649073	705944	0	0
45660940	1177480	0	0
45636595	1343916	0	0
45692923	1112807	0	0
45781311	1125315	0	0
45683088	1124300	0	0
45693226	40243436	2	3
45699368	1125315	0	0
45706847	1545958	0	0
45693608	1119510	0	0
45785682	1119510	0	0
46297008	1119510	0	0
45791547	1119510	0	0
46296709	1129625	0	0
46308095	1115008	0	0
46320882	1112807	0	0
46310309	1125315	0	0
4043349	4035415	2	2
4304916	440448	5	6
21002808	1112807	0	0
21003018	1307863	0	0
35509076	1119510	0	0
36217216	1150837	2	3
4130852	4230399	3	4
36702247	375671	4	9
44352867	1112807	0	0
44363516	1125315	0	0
44339217	1124300	0	0
44778070	1343916	0	0
45626102	1343916	0	0
45640406	1177480	0	0
45641423	19079524	2	3
45649017	967823	0	0
45661006	1177480	0	0
45636600	1501700	0	0
45692993	1112807	0	0
45781625	1125315	0	0
45683281	1501700	0	0
45693231	40232448	2	3
45699586	1125315	0	0
46240175	1174888	0	0
45693616	1119510	0	0
45785508	1119510	0	0
46297012	1119510	0	0
45791282	1119510	0	0
46295026	1129625	0	0
46308079	1545958	0	0
46320805	1153428	0	0
46310372	1125315	0	0
4043671	40481087	2	2
4309188	4166224	5	6
21002808	975125	0	0
21002602	1717327	0	0
35509076	1125315	0	0
36217216	40236446	2	3
4180941	40492359	3	4
40480457	439777	4	7
44352869	975125	0	0
44363193	1125315	0	0
44339115	975125	0	0
44778230	1738521	0	0
45622643	1738521	0	0
45640411	1177480	0	0
45644392	19078924	2	3
45649023	933724	0	0
45657755	1177480	0	0
45636603	1551099	0	0
45693097	1112807	0	0
45781580	1125315	0	0
45683287	1307863	0	0
45693291	19019273	2	3
45699342	1125315	0	0
45702766	740275	0	0
45693905	1119510	0	0
45785569	1119510	0	0
46297021	1119510	0	0
45791452	1119510	0	0
46295153	1129625	0	0
46307996	1115008	0	0
46320816	1332418	0	0
46310430	1125315	0	0
4043671	28060	2	2
4322976	4043071	5	6
21002808	1118084	0	0
21002603	1746114	0	0
35509076	738818	0	0
36217216	19018935	2	3
4181193	4301346	4	4
37203758	4112343	5	9
44353158	975125	0	0
44363448	1125315	0	0
44339015	1149380	0	0
44778257	1149196	0	0
45622574	1539403	0	0
45640447	1177480	0	0
45631095	19078461	2	3
45649048	1149196	0	0
45658165	1177480	0	0
45636610	1154029	0	0
45693106	1112807	0	0
45781643	1125315	0	0
45682943	1778162	0	0
45694754	19019273	2	3
45699429	1125315	0	0
45703088	1124957	0	0
45693919	1119510	0	0
45785523	1119510	0	0
46296937	1119510	0	0
46298711	1119510	0	0
46295390	1129625	0	0
46308105	1551099	0	0
46314874	967823	0	0
46310506	1125315	0	0
4043671	257012	2	2
4322976	40478878	5	6
21002811	1112807	0	0
21002603	1717327	0	0
35509157	967823	0	0
36217216	40231925	2	3
4181193	44783196	4	4
37203758	261325	5	8
44353008	1177480	0	0
44363323	1125315	0	0
44339220	1118084	0	0
44783196	44783196	0	0
45622577	1308738	0	0
45640445	1177480	0	0
45663397	40223768	2	3
45649183	1539403	0	0
45654658	1177480	0	0
45636629	1107830	0	0
45693066	1112807	0	0
45781649	1125315	0	0
45683321	1307863	0	0
45694859	920334	2	3
45699436	1125315	0	0
45703090	1551099	0	0
45690640	1119510	0	0
45785644	1119510	0	0
46296945	1119510	0	0
46298417	1119510	0	0
46295215	1129625	0	0
46308426	1124300	0	0
46313868	1332418	0	0
46310490	1125315	0	0
4212887	4146173	2	2
4274025	80502	5	6
21002811	1115008	0	0
21002618	1746114	0	0
35509096	1129625	0	0
36217216	40162522	2	3
4141937	4057420	4	4
37203758	40486433	5	8
44352722	723013	0	0
44363589	1125315	0	0
44339224	1149380	0	0
44358139	1549786	0	0
45622618	708298	0	0
45640454	1177480	0	0
45665854	1107882	2	3
45647309	1545958	0	0
45638905	1119510	0	0
45636409	1124957	0	0
45689790	1112807	0	0
45781449	1125315	0	0
45683323	1107830	0	0
45693313	40229134	2	3
45699623	1125315	0	0
45703028	1308738	0	0
45690768	1119510	0	0
45785674	1119510	0	0
46297072	1119510	0	0
46298429	1119510	0	0
46295574	1129625	0	0
46308367	1308738	0	0
46313873	1174888	0	0
46310414	1125315	0	0
4195601	4186930	2	2
4274025	438614	5	6
21002811	1177480	0	0
21002682	1305058	0	0
35509101	1119510	0	0
36217216	43012036	2	3
4201745	196456	4	4
36718588	375671	5	7
44352901	1545958	0	0
44363592	1125315	0	0
44339232	1124957	0	0
44357924	1000560	0	0
45622630	1548195	0	0
45640380	1177480	0	0
45659604	19078924	2	3
45647406	1115008	0	0
45639204	1119510	0	0
45636554	975125	0	0
45690030	1112807	0	0
45781594	1125315	0	0
45683328	1153428	0	0
45693298	40232448	2	3
45699443	1125315	0	0
45702996	1557272	0	0
45690819	1119510	0	0
45785779	1119510	0	0
46297077	1119510	0	0
46298689	1119510	0	0
46295308	1129625	0	0
46308088	1396131	0	0
46313876	1149196	0	0
46310653	1125315	0	0
4196708	4029498	2	2
4274025	4048169	5	6
21002810	1124300	0	0
21002682	975125	0	0
35509103	1112807	0	0
36217216	1127433	2	3
4201745	4027663	4	4
36718588	378001	5	7
44352908	1149380	0	0
44363594	1125315	0	0
44339236	1589505	0	0
44357932	1548195	0	0
45622631	1107830	0	0
45637199	1177480	0	0
45629454	40174880	2	3
45647408	738818	0	0
45639298	1119510	0	0
45636555	1149196	0	0
45690085	1112807	0	0
45779008	1125315	0	0
45683336	1124957	0	0
45693399	43012036	2	3
45699635	1125315	0	0
45800012	1119510	0	0
45687424	1119510	0	0
45785985	1119510	0	0
46297120	1119510	0	0
46298495	1119510	0	0
46295252	1129625	0	0
46308335	1124957	0	0
46314292	967823	0	0
46310656	1125315	0	0
4196732	196456	2	2
4304916	4285898	5	7
21002814	1177480	0	0
21002683	975125	0	0
35509172	1129625	0	0
36217216	19077344	2	3
4180938	4243062	4	4
36718595	4001336	5	7
44353179	1500211	0	0
44363662	1125315	0	0
44339237	708298	0	0
44358062	1332418	0	0
45622566	19127890	0	0
45637207	1177480	0	0
45626153	19075001	2	3
45644283	1110410	0	0
45635859	1119510	0	0
45637054	738818	0	0
45690200	1112807	0	0
45778663	1125315	0	0
45682946	1154343	0	0
45693301	19008572	2	3
45699461	1125315	0	0
45800016	1119510	0	0
45687758	1119510	0	0
46296467	1119510	0	0
46297226	1119510	0	0
46298576	1119510	0	0
46244334	1129625	0	0
46308342	1115008	0	0
46314896	1174888	0	0
46310671	1125315	0	0
19081738	19128263	2	2
4274025	4149245	5	9
21002814	1115008	0	0
21002686	1149380	0	0
35509156	1149380	0	0
36217216	40232448	2	3
4093991	381316	4	4
37503996	4336464	5	7
44353015	701322	0	0
44358779	1125315	0	0
44339305	975125	0	0
44358219	1595799	0	0
45622566	1549786	0	0
45637490	1177480	0	0
45667423	1107882	2	3
45644342	738818	0	0
45636050	1119510	0	0
45636950	1539403	0	0
45686905	1112807	0	0
45779015	1125315	0	0
45682997	1115008	0	0
45693337	46233988	2	3
45699403	1125315	0	0
45800053	1119510	0	0
45687702	1119510	0	0
46292313	1119510	0	0
45894600	1119510	0	0
46298643	1119510	0	0
46244419	1129625	0	0
46308350	1332418	0	0
46314897	1501700	0	0
46310596	1125315	0	0
19081738	19128022	2	2
4274025	40486433	5	9
21002814	1124300	0	0
21002683	1551099	0	0
35509175	1125315	0	0
36217216	19045231	2	3
4112892	4107731	4	4
37100000	198199	5	7
44352915	1115008	0	0
44358686	1125315	0	0
44339333	1149380	0	0
44358219	1521369	0	0
45622566	1512674	0	0
45639979	1177480	0	0
45663511	1107882	2	3
45644343	1343916	0	0
45635868	1119510	0	0
45637421	791967	0	0
45688698	1112807	0	0
45778781	1125315	0	0
45682905	1107830	0	0
45693337	46233710	2	3
45699490	1125315	0	0
45800086	1119510	0	0
45687714	1119510	0	0
46292515	1119510	0	0
45803024	1119510	0	0
46298782	1119510	0	0
46244312	1129625	0	0
46302551	738818	0	0
46314901	1192710	0	0
46310532	1125315	0	0
4297887	4310024	2	2
4274025	440448	5	10
21002411	1746114	0	0
21002677	1149380	0	0
35509167	975125	0	0
36217216	1539411	2	3
4042645	4057420	4	4
40783000	3049273	5	6
44353188	1115008	0	0
44358484	1125315	0	0
44339335	723013	0	0
44358219	1549786	0	0
45622544	1149196	0	0
45640112	1177480	0	0
45662751	19078461	2	3
45644358	19010482	0	0
45635810	1119510	0	0
45633278	1192710	0	0
45687177	1112807	0	0
45779081	1125315	0	0
45683220	967823	0	0
45693500	1519937	2	3
45699497	1125315	0	0
45799984	1119510	0	0
45687630	1119510	0	0
46292319	1119510	0	0
45802962	1119510	0	0
46298992	1119510	0	0
46244562	1129625	0	0
46302661	1115008	0	0
46313884	1322184	0	0
46304812	1125315	0	0
4235428	4057420	2	2
4322976	4197460	5	7
21002450	1759842	0	0
21002685	19010482	0	0
35509150	1112807	0	0
36217216	1115171	2	3
4042645	4078793	4	4
37604009	313217	5	6
44353190	738818	0	0
44358489	1125315	0	0
44339345	1129625	0	0
44358972	1192710	0	0
45622845	933724	0	0
45634240	1177480	0	0
45663453	40228214	2	3
45644362	1115008	0	0
45635907	1119510	0	0
45633178	1501700	0	0
45687318	1112807	0	0
45779061	1125315	0	0
45683064	1778162	0	0
45690307	43012036	2	3
45699601	1125315	0	0
45799827	1119510	0	0
45687876	1119510	0	0
46292123	1119510	0	0
45803387	1119510	0	0
46299029	1119510	0	0
46244529	1129625	0	0
46302576	1124957	0	0
46314803	1174888	0	0
46304879	1125315	0	0
4043371	81893	2	3
4322976	4216130	5	9
21002452	1746114	0	0
21002685	1305058	0	0
35509152	1177480	0	0
36217216	19128009	3	4
21604180	740275	4	4
36718588	378419	5	6
44352836	1548195	0	0
44356252	1125315	0	0
44339427	933724	0	0
44359132	19003953	0	0
45622395	738818	0	0
45634590	1177480	0	0
45665387	1107882	2	3
45644324	1551099	0	0
45636078	1119510	0	0
45633279	1545958	0	0
45683952	1112807	0	0
45778708	1125315	0	0
45683297	1741122	0	0
45690317	40232448	2	3
45696115	1125315	0	0
45800092	1119510	0	0
45687920	1119510	0	0
46292380	1119510	0	0
45803392	1119510	0	0
46299040	1119510	0	0
46244322	1129625	0	0
46302795	1107830	0	0
46314747	1174888	0	0
46304885	1125315	0	0
21000815	19133905	2	3
4199402	4329847	6	9
21002453	1759842	0	0
21002627	1149380	0	0
35509182	1125315	0	0
36217216	19128065	3	4
4141833	4280726	4	4
37604032	313217	5	6
44353093	1000560	0	0
44356332	1125315	0	0
44339181	1738521	0	0
44359043	723013	0	0
45622406	738818	0	0
45634281	1177480	0	0
45629131	1107882	2	3
45644310	1332418	0	0
45636015	1119510	0	0
45633288	1728416	0	0
45684084	1112807	0	0
45779195	1125315	0	0
45683297	1746114	0	0
45690340	43012036	2	3
45695996	1125315	0	0
45800189	1119510	0	0
45687895	1119510	0	0
46292301	1119510	0	0
45803400	1119510	0	0
46298628	1119510	0	0
46244440	1129625	0	0
46302814	1521369	0	0
46314193	1308738	0	0
46305431	1125315	0	0
21000815	19133873	2	3
4199402	4112343	6	9
21002454	1759842	0	0
21002623	1741122	0	0
36156645	1112807	0	0
36217216	42902245	3	4
4141833	40486433	4	4
37602360	4329847	5	6
44353198	1177480	0	0
44356256	1125315	0	0
44339258	1129625	0	0
44359047	1332418	0	0
45622410	1713332	0	0
45634652	1177480	0	0
45650491	40223768	2	3
45644092	1174888	0	0
45636017	1119510	0	0
45633327	791967	0	0
45654955	1177480	0	0
45779208	1125315	0	0
45683419	723013	0	0
45690544	920334	2	3
45696011	1125315	0	0
45799910	1119510	0	0
45687504	1119510	0	0
46292223	1119510	0	0
45803410	1119510	0	0
46299295	1119510	0	0
46244535	1129625	0	0
46302963	1149196	0	0
46314764	1549786	0	0
46305003	1125315	0	0
4042516	4295880	2	3
4322976	4337611	6	9
21002445	1746114	0	0
21002623	1746114	0	0
36156671	967823	0	0
36217216	19129144	3	4
4100932	40479768	4	4
37602360	4310024	5	6
44353216	1149196	0	0
44356441	1125315	0	0
44339125	1192710	0	0
44358978	738818	0	0
45622410	1759842	0	0
45634468	1177480	0	0
45641384	1107882	2	3
45644286	1154343	0	0
45636274	1119510	0	0
45633203	738818	0	0
45654899	1177480	0	0
45778984	1125315	0	0
45683430	1549786	0	0
45691410	1127433	2	3
45696090	1125315	0	0
45800095	1119510	0	0
45688013	1119510	0	0
46292477	1119510	0	0
45803384	1119510	0	0
46298923	1119510	0	0
45787646	1119510	0	0
46302845	1738521	0	0
46314755	1310149	0	0
46305445	1125315	0	0
21000260	46233988	2	3
4304916	81893	6	8
21002445	1759842	0	0
21002627	975125	0	0
36156675	1713332	0	0
35809386	4285898	3	6
4057955	4015189	4	4
36718595	380378	5	5
44353219	975125	0	0
44356449	1125315	0	0
44339331	1177480	0	0
44359179	738818	0	0
45622414	1521369	0	0
45631362	1177480	0	0
45649286	1332419	2	3
45644188	1367571	0	0
45636200	1119510	0	0
45633487	1192710	0	0
45654841	1177480	0	0
45778986	1125315	0	0
45683200	1595799	0	0
45687203	1107882	2	3
45696095	1125315	0	0
45685906	1119510	0	0
45687959	1119510	0	0
46292470	1119510	0	0
45803079	1119510	0	0
46298939	1119510	0	0
45787229	1119510	0	0
46303139	1118084	0	0
46314698	1551099	0	0
46305016	1125315	0	0
21000260	46233710	2	3
4199402	4146173	6	8
21002455	1759842	0	0
21002630	1149380	0	0
36156679	1343916	0	0
35700000	198809	7	9
4203551	4108705	4	4
37602360	321042	5	5
44353221	1310149	0	0
44356344	1125315	0	0
44339332	723013	0	0
44359180	1115008	0	0
45622416	738818	0	0
45633937	1177480	0	0
45650718	1107882	2	3
45644476	967823	0	0
45636185	1119510	0	0
45633646	1174888	0	0
45655110	1177480	0	0
45778786	1125315	0	0
45683200	1308738	0	0
45687249	19008572	2	3
45696218	1125315	0	0
45685684	1119510	0	0
45687902	1119510	0	0
46292451	1119510	0	0
45803235	1119510	0	0
46299065	1119510	0	0
45787633	1119510	0	0
46302853	975125	0	0
46314700	1192710	0	0
46305571	1125315	0	0
21000259	46233988	2	3
4199402	257012	6	8
21002455	1741122	0	0
21002630	1149196	0	0
36156660	1539403	0	0
35700000	196456	7	8
4227253	321042	4	4
37602360	4163874	5	5
44353222	1112807	0	0
44356306	1125315	0	0
44339417	1107830	0	0
44359185	1192710	0	0
45622274	1124300	0	0
45631557	1177480	0	0
45647261	1107882	2	3
45644335	967823	0	0
45636021	1119510	0	0
45633574	1551099	0	0
45655113	1177480	0	0
45779157	1125315	0	0
45683430	1512674	0	0
45687394	19076374	2	3
45696061	1125315	0	0
45685323	1119510	0	0
45687906	1119510	0	0
46287882	1119510	0	0
45803330	1119510	0	0
46290400	1119510	0	0
45787640	1119510	0	0
46302701	1174888	0	0
46314704	1112807	0	0
46305574	1125315	0	0
21000803	19077344	2	3
4199402	4149245	6	8
21002455	1746114	0	0
21600965	1310149	0	0
36156662	1309944	0	0
35700000	441267	3	3
4227253	4266809	4	4
37604009	4310024	5	5
44353039	738818	0	0
44356389	1125315	0	0
44339153	1124300	0	0
44358862	1149196	0	0
45622303	1153428	0	0
45628133	1177480	0	0
45626189	1107882	2	3
45644198	1332418	0	0
45632944	1119510	0	0
45633529	1759842	0	0
45655238	1177480	0	0
45779229	1125315	0	0
45683466	1332418	0	0
45687406	19077344	2	3
45696226	1125315	0	0
45685359	1119510	0	0
45687963	1119510	0	0
46287975	1119510	0	0
45800456	1119510	0	0
46290369	1119510	0	0
45787741	1119510	0	0
46302707	1551099	0	0
46314710	1124300	0	0
46305330	1125315	0	0
21000299	19133905	2	3
4199402	321042	6	8
21002491	1112807	0	0
21600036	975125	0	0
36156666	1361711	0	0
35700000	4116491	3	3
4227253	4310024	4	4
37602356	381316	5	5
44349052	1129625	0	0
44356456	1125315	0	0
44339160	933724	0	0
44358354	1548195	0	0
45622309	1154343	0	0
45628522	1177480	0	0
45634244	19078461	2	3
45644202	1501700	0	0
45632997	1119510	0	0
45633529	1713332	0	0
45655222	1177480	0	0
45779400	1125315	0	0
45683164	1107830	0	0
45687676	1115171	2	3
45696179	1125315	0	0
45685378	1119510	0	0
45684648	1119510	0	0
46287987	1119510	0	0
45800430	1119510	0	0
46290404	1119510	0	0
45787519	1119510	0	0
46302712	791967	0	0
46314715	1149196	0	0
46305332	1125315	0	0
21000299	19133873	2	3
4212577	4048171	6	7
21002491	1115008	0	0
21500949	1129625	0	0
36156654	1000560	0	0
35700000	440448	3	11
4227253	255848	4	4
37602356	321042	5	5
44349057	975125	0	0
44356425	1125315	0	0
44339523	920293	0	0
44358359	1307863	0	0
45622358	1512674	0	0
45628188	1177480	0	0
45626850	1107882	2	3
45644289	1102527	0	0
45633002	1119510	0	0
45633385	1174888	0	0
45700760	1177480	0	0
45779393	1125315	0	0
45679895	1124300	0	0
45687677	19059056	2	3
45696129	1125315	0	0
45685383	1119510	0	0
45684736	1119510	0	0
46243137	1119510	0	0
45800485	1119510	0	0
46290385	1119510	0	0
45787490	1119510	0	0
46302814	1549786	0	0
46314856	1149196	0	0
46305211	1125315	0	0
21000292	46233988	2	3
4274025	4219399	6	7
21002491	1118084	0	0
21501230	967823	0	0
36156659	967823	0	0
35700000	30753	3	9
4227253	196456	4	4
40782662	3010813	5	5
44349058	723013	0	0
44356489	1125315	0	0
44339526	1332418	0	0
44358364	738818	0	0
45622358	19127890	0	0
45628354	1177480	0	0
45623747	19078461	2	3
45644423	1539403	0	0
45633974	1119510	0	0
45633388	1115008	0	0
45701541	1177480	0	0
45779395	1125315	0	0
45679880	1501700	0	0
45687598	1115171	2	3
45696256	1125315	0	0
45799949	1119510	0	0
45684607	1119510	0	0
46243140	1119510	0	0
45800473	1119510	0	0
46290474	1119510	0	0
45787613	1119510	0	0
46302816	738818	0	0
46317595	1778162	0	0
46305217	1125315	0	0
21000230	46233710	2	3
4274025	321042	6	8
21002412	1746114	0	0
21500050	1308738	0	0
36156669	791967	0	0
35700000	4027663	3	8
4181063	133834	4	4
40782662	3026361	5	5
44348777	791967	0	0
44356574	1125315	0	0
44339023	738818	0	0
44358327	738818	0	0
45622358	1549786	0	0
45628343	1177480	0	0
45646896	1107882	2	3
45644506	914335	0	0
45633953	1119510	0	0
45633395	791967	0	0
45701641	1177480	0	0
45779337	1125315	0	0
45679882	1124957	0	0
45687551	40163554	2	3
45696190	1125315	0	0
45800006	1119510	0	0
45684803	1119510	0	0
46242899	1119510	0	0
45800579	1119510	0	0
46290527	1119510	0	0
45787616	1119510	0	0
46302823	1551099	0	0
46317740	1551099	0	0
46307146	1125315	0	0
21000230	46233988	2	3
4274025	4152936	6	8
21002475	1515774	0	0
21500095	742185	0	0
36156791	1125315	0	0
35700000	81893	3	13
36200000	40479768	6	11
40772935	3009201	5	5
44348887	914335	0	0
44356647	1125315	0	0
44341844	1125315	0	0
44358532	1110410	0	0
45622359	1110410	0	0
45628703	1177480	0	0
45626519	1332419	2	3
45644510	791967	0	0
45634008	1119510	0	0
45633396	738818	0	0
45701794	1177480	0	0
45779181	1125315	0	0
45679885	1124957	0	0
45687576	19078924	2	3
45696280	1125315	0	0
45800041	1119510	0	0
45684990	1119510	0	0
46242917	1119510	0	0
45800635	1119510	0	0
46290529	1119510	0	0
45787777	1119510	0	0
46302682	1713332	0	0
46317753	920293	0	0
46306699	1125315	0	0
21000291	46233710	2	3
4339468	4048171	6	6
21002475	19127890	0	0
21500108	1500211	0	0
36156795	1551099	0	0
35700000	192671	3	7
36200000	381316	6	6
37302322	134438	5	5
44348890	1149196	0	0
44356560	1125315	0	0
44341889	1125315	0	0
44358535	1124300	0	0
45622249	975125	0	0
45628642	1177480	0	0
45662947	19075601	2	3
45644469	1124957	0	0
45634033	1119510	0	0
45633401	1713332	0	0
45701779	1177480	0	0
45779373	1125315	0	0
45679602	1501700	0	0
45687224	19008572	2	3
45696285	1125315	0	0
45799719	1119510	0	0
45684726	1119510	0	0
46243230	1119510	0	0
45800545	1119510	0	0
46290602	1119510	0	0
45801201	1119510	0	0
46302691	967823	0	0
46317667	1118084	0	0
46306700	1125315	0	0
21000291	46233988	2	3
4339410	4230399	6	6
21002475	1595799	0	0
21013948	1738521	0	0
36156797	1149196	0	0
35700000	4112343	5	11
36200000	4329847	6	6
37203758	441267	5	5
44348903	1713332	0	0
44349172	1125315	0	0
44342040	1125315	0	0
44358515	1118084	0	0
45622326	19127890	0	0
45625365	1177480	0	0
45650526	19078461	2	3
45644447	1326303	0	0
45659136	1129625	0	0
45633401	1759842	0	0
45701769	1177480	0	0
45779374	1125315	0	0
45679927	1115008	0	0
45691641	1129625	0	0
45696292	1125315	0	0
45799720	1119510	0	0
45684727	1119510	0	0
46243181	1119510	0	0
45800718	1119510	0	0
46290875	1119510	0	0
45802364	1119510	0	0
46302928	1551099	0	0
46317813	1738521	0	0
46306550	1125315	0	0
21000285	46233710	2	3
4199402	4116491	6	6
21002491	1515774	0	0
21002644	975125	0	0
36156800	1119510	0	0
35700000	4285898	4	12
36200000	4094814	6	6
40786239	3001488	5	5
44348904	1192710	0	0
44349407	1125315	0	0
44341998	1125315	0	0
44358931	975125	0	0
45622326	1549786	0	0
45625294	1177480	0	0
45650307	19075601	2	3
45644539	1149196	0	0
45659251	1129625	0	0
45633339	1308738	0	0
45701866	1177480	0	0
45779375	1125315	0	0
45679928	1110410	0	0
45691634	1129625	0	0
45696234	1125315	0	0
45682525	1119510	0	0
45681281	1119510	0	0
46243067	1119510	0	0
45800720	1119510	0	0
46291019	1119510	0	0
45802515	1119510	0	0
46302772	975125	0	0
46317359	1192710	0	0
46321686	1125315	0	0
21000295	46233988	2	3
4279903	4198190	6	6
21002475	1589505	0	0
21002630	1551099	0	0
36156518	1125315	0	0
35700000	4166224	4	11
36200000	81151	4	11
37602356	4310024	6	6
44349114	723013	0	0
44349357	1125315	0	0
44342052	1125315	0	0
44358936	1713332	0	0
45622281	1501700	0	0
45625647	1177480	0	0
45641708	1107882	2	3
45644449	1343916	0	0
45657275	1129625	0	0
45633341	975125	0	0
45701973	1177480	0	0
45779376	1125315	0	0
45679818	1738521	0	0
45691763	1129625	0	0
45696158	1125315	0	0
45682286	1119510	0	0
45682671	1119510	0	0
46243220	1119510	0	0
45800607	1119510	0	0
46290686	1119510	0	0
45802230	1119510	0	0
46302777	1192710	0	0
46315091	1545958	0	0
46321817	1125315	0	0
21000295	46233710	2	3
4300157	78272	6	6
21002491	1589505	0	0
21002642	975125	0	0
36156764	1713332	0	0
35700000	28060	4	9
36200000	4132546	4	9
37600000	321042	6	6
44349077	1589505	0	0
44349352	1125315	0	0
44341921	1125315	0	0
44358440	1107830	0	0
45622429	1154029	0	0
45625635	1177480	0	0
45638661	40228214	2	3
45644424	1500211	0	0
45657290	1129625	0	0
45633494	1521369	0	0
45701855	1177480	0	0
45779392	1125315	0	0
45679945	1332418	0	0
45691819	1129625	0	0
45696159	1125315	0	0
45794884	1119510	0	0
45681849	1119510	0	0
46243212	1119510	0	0
45800500	1119510	0	0
46290743	1119510	0	0
45802594	1119510	0	0
46302782	1154029	0	0
46315316	1310149	0	0
46321698	1125315	0	0
21000297	46233710	2	3
4213310	4043241	6	6
21002350	920293	0	0
21002630	975125	0	0
36156765	1149196	0	0
35700000	4310024	4	9
36200000	4156265	4	9
37600000	4163874	6	6
44349077	1549786	0	0
44349447	1125315	0	0
44342230	1125315	0	0
44358396	1174888	0	0
45622507	738818	0	0
45625748	1177480	0	0
45644544	40228214	2	3
45644544	1149196	0	0
45657024	1129625	0	0
45633211	1107830	0	0
45698881	1177480	0	0
45779166	1125315	0	0
45679835	1115008	0	0
45691859	1129625	0	0
45696160	1125315	0	0
45794946	1119510	0	0
45681941	1119510	0	0
46243122	1119510	0	0
45800711	1119510	0	0
46291113	1119510	0	0
45801237	1119510	0	0
46302788	1149196	0	0
46315100	975125	0	0
46321723	1125315	0	0
21000297	46233988	2	3
4215217	4149245	3	3
21002475	1521369	0	0
21002642	1149380	0	0
36156777	1000560	0	0
35700000	4266809	4	9
36200000	4149245	4	5
40783186	3008598	6	6
44348968	1174888	0	0
44349610	1125315	0	0
44341941	1125315	0	0
44358400	753626	0	0
45622508	975125	0	0
45624965	1177480	0	0
45665409	40173590	2	3
45644392	708298	0	0
45657050	1129625	0	0
45633348	975125	0	0
45698895	1177480	0	0
45779396	1125315	0	0
45682297	1738521	0	0
45691848	1129625	0	0
45696274	1125315	0	0
45794911	1119510	0	0
45681735	1119510	0	0
46243126	1119510	0	0
45800818	1119510	0	0
46290845	1119510	0	0
45801285	1119510	0	0
46302973	975125	0	0
46315120	1118084	0	0
46321727	1125315	0	0
21000301	46233710	2	3
4320791	4048171	3	3
21002475	1500211	0	0
21002655	1551099	0	0
36156778	1129625	0	0
35802131	378001	8	10
36200000	4048695	4	10
36425574	19008572	2	3
44348972	1149380	0	0
44349376	1125315	0	0
44342110	1125315	0	0
44358402	1124300	0	0
45622371	975125	0	0
45622533	1177480	0	0
45621852	19073188	2	3
45644396	738818	0	0
45657055	1129625	0	0
45633353	1548195	0	0
45698676	1177480	0	0
45779397	1125315	0	0
45682300	1361711	0	0
45688819	1129625	0	0
45696482	1125315	0	0
45794918	1119510	0	0
45681862	1119510	0	0
46244713	1119510	0	0
45800537	1119510	0	0
46242437	1119510	0	0
45801227	1119510	0	0
46303060	1595799	0	0
46315192	1154029	0	0
46321831	1125315	0	0
21000301	46233988	2	3
4276572	439777	3	3
21002475	1503184	0	0
21002644	1149380	0	0
36156533	1129625	0	0
35802131	4112343	7	10
36200000	4299128	3	7
36502202	4218389	3	3
44348974	1192710	0	0
44349749	1125315	0	0
44341873	1125315	0	0
44358416	1124300	0	0
45622432	1174888	0	0
45622432	1177480	0	0
45621852	19073183	2	3
45644617	1000560	0	0
45657336	1129625	0	0
45633246	1343916	0	0
45698861	1177480	0	0
45779398	1125315	0	0
45682301	1154343	0	0
45688825	1129625	0	0
45696485	1125315	0	0
45679135	1119510	0	0
45678530	1119510	0	0
46244721	1119510	0	0
45800614	1119510	0	0
46242354	1119510	0	0
45801274	1119510	0	0
46303060	1308738	0	0
46315357	1149380	0	0
46321792	1125315	0	0
21000290	46233710	2	3
4195979	4324181	3	3
21002475	1549786	0	0
21002642	1551099	0	0
36156534	1115008	0	0
35802131	4294548	7	10
36200000	4296204	3	8
36302183	4314290	3	3
44348984	1192710	0	0
44349601	1125315	0	0
44341876	1125315	0	0
44358529	1192710	0	0
45622597	1115008	0	0
45622477	1177480	0	0
45660082	19075601	2	3
45644662	967823	0	0
45655371	1129625	0	0
45633612	791967	0	0
45698828	1177480	0	0
45779401	1125315	0	0
45682315	1174888	0	0
45688772	1129625	0	0
45696487	1125315	0	0
45679342	1119510	0	0
45678889	1119510	0	0
46240867	1119510	0	0
45797763	1119510	0	0
46242356	1119510	0	0
45801279	1119510	0	0
46303016	1738521	0	0
46315360	967823	0	0
46316294	1125315	0	0
21000290	46233988	2	3
4200516	4132546	3	3
21002421	1741122	0	0
21002655	975125	0	0
36156790	1149196	0	0
35802131	257012	7	9
36200000	375671	3	11
36313913	4243062	3	3
44348985	1713332	0	0
44349557	1125315	0	0
44341934	1125315	0	0
44358441	1738521	0	0
45622434	1589505	0	0
45620829	1177480	0	0
45623627	19075601	2	3
45644667	1308738	0	0
45655474	1129625	0	0
45633310	1192710	0	0
45698953	1177480	0	0
45779402	1125315	0	0
45682393	1551099	0	0
45688849	1129625	0	0
45696244	1125315	0	0
45679248	1119510	0	0
45678875	1119510	0	0
46240870	1119510	0	0
45797876	1119510	0	0
46242517	1119510	0	0
45801352	1119510	0	0
46303295	738818	0	0
46315362	1112807	0	0
46316047	1125315	0	0
21000825	1551192	2	3
4215685	4323208	3	3
21002487	1548195	0	0
21002658	975125	0	0
36156920	1125315	0	0
35802131	40481087	7	9
36200000	4237458	3	10
36313913	4163872	3	3
44348471	1107830	0	0
44349875	1125315	0	0
44342213	1125315	0	0
44358369	782043	0	0
45622438	1713332	0	0
45621212	1177480	0	0
45629310	19075601	2	3
45644537	1548195	0	0
45655466	1129625	0	0
45633626	1548195	0	0
45699005	1177480	0	0
45777897	1125315	0	0
45682133	1107830	0	0
45688867	1129625	0	0
45696251	1125315	0	0
45679449	1119510	0	0
45678899	1119510	0	0
46240751	1119510	0	0
45797880	1119510	0	0
46242245	1119510	0	0
45795739	1119510	0	0
46303074	723013	0	0
46315362	1192710	0	0
46316404	1125315	0	0
21000717	1551192	2	3
4200532	4116491	3	3
21002491	1521369	0	0
21002663	1551099	0	0
36156920	1119510	0	0
35802131	4001336	7	9
35702118	30753	4	5
36402186	40480160	3	3
44349060	1124957	0	0
44350015	1125315	0	0
44342090	1125315	0	0
44358318	1124300	0	0
45622375	1000560	0	0
45621069	1177480	0	0
45647267	19075601	2	3
45641434	1149380	0	0
45653998	1129625	0	0
45633360	1545958	0	0
45699106	1177480	0	0
45778009	1125315	0	0
45661548	1112807	0	0
45686179	1129625	0	0
45696322	1125315	0	0
45792052	1119510	0	0
45673188	1119510	0	0
46240754	1119510	0	0
45797800	1119510	0	0
46239753	1119510	0	0
45795841	1119510	0	0
46303214	933724	0	0
46315161	1589505	0	0
46316605	1125315	0	0
21000705	1539411	2	3
4339468	372328	3	3
21002487	1512674	0	0
21002663	975125	0	0
36156921	1119510	0	0
35802131	28060	7	8
35702118	4266809	4	5
36400000	140673	3	3
44348640	967823	0	0
44350046	1125315	0	0
44342093	1125315	0	0
44358569	742185	0	0
45622452	975125	0	0
45664799	1177480	0	0
45640112	19078461	2	3
45641366	1154029	0	0
45647365	1129625	0	0
45633362	967823	0	0
45695724	1177480	0	0
45777932	1125315	0	0
45661613	1112807	0	0
45686055	1129625	0	0
45696327	1125315	0	0
45792059	1119510	0	0
45673296	1119510	0	0
46240949	1119510	0	0
45797931	1119510	0	0
46239628	1119510	0	0
45795785	1119510	0	0
46303526	1332418	0	0
46315176	975125	0	0
46316693	1125315	0	0
21000819	1551192	2	3
4339468	4283893	3	3
21002487	1500211	0	0
21002673	1551099	0	0
36156921	1192710	0	0
35802131	372328	7	7
35702118	4310024	4	5
36400000	80502	3	3
44348641	1713332	0	0
44341760	1125315	0	0
44342073	1125315	0	0
44358668	1124300	0	0
45622485	967823	0	0
45664830	1177480	0	0
45647307	19075601	2	3
45641370	1717327	0	0
45647399	1129625	0	0
45633437	1124300	0	0
45695719	1177480	0	0
45777915	1125315	0	0
45660174	1112807	0	0
45686159	1129625	0	0
45696333	1125315	0	0
45792061	1119510	0	0
45673297	1119510	0	0
46240954	1119510	0	0
45797717	1119510	0	0
46240102	1119510	0	0
45795761	1119510	0	0
46303534	1549786	0	0
46315178	1112807	0	0
46316546	1125315	0	0
21000701	1539411	2	3
4302076	4202451	3	3
21002487	1549786	0	0
21002673	975125	0	0
36156867	1177480	0	0
35802131	381316	7	7
35702118	4166224	5	7
36302170	4191853	3	3
44348645	1545958	0	0
44341801	1125315	0	0
44342086	1125315	0	0
44358470	1307863	0	0
45622493	1115008	0	0
45664775	1177480	0	0
45660111	19078461	2	3
45641463	19003953	0	0
45647547	1129625	0	0
45633647	1000560	0	0
45695789	1177480	0	0
45777903	1125315	0	0
45704017	1112807	0	0
45688620	1129625	0	0
45696609	1125315	0	0
45792199	1119510	0	0
45672726	1119510	0	0
46241090	1119510	0	0
45797946	1119510	0	0
46240271	1119510	0	0
45795808	1119510	0	0
46303534	1521369	0	0
46315346	967823	0	0
46316378	1125315	0	0
21000713	1551192	2	3
4317258	4296204	3	3
21002487	1521369	0	0
21600973	1367571	0	0
36156863	1124300	0	0
35802131	380378	7	7
35702118	440448	6	7
36517012	4149245	3	3
44349083	933724	0	0
44342122	1125315	0	0
44342305	1125315	0	0
44358586	1115008	0	0
45620913	1515774	0	0
45664503	1177480	0	0
45665357	1539411	2	3
45641481	1713332	0	0
45647613	1129625	0	0
45633505	1557272	0	0
45692382	1177480	0	0
45777873	1125315	0	0
45703792	1112807	0	0
45688547	1129625	0	0
45696610	1125315	0	0
45792181	1119510	0	0
45672670	1119510	0	0
46240624	1119510	0	0
45797962	1119510	0	0
46240274	1119510	0	0
45795949	1119510	0	0
46303534	1595799	0	0
46315311	1545958	0	0
46316182	1125315	0	0
21000706	1545959	2	3
4198525	28060	3	3
21002491	19127890	0	0
21600989	1322184	0	0
36156887	1129625	0	0
35802131	4048171	6	11
35702118	81893	7	9
36517140	4149245	3	3
44349037	1149380	0	0
44341805	1125315	0	0
44342317	1125315	0	0
44358601	738818	0	0
45620913	19127890	0	0
45664494	1177480	0	0
45621505	1332419	2	3
45641527	1149196	0	0
45647887	1129625	0	0
45633402	1713332	0	0
45692512	1177480	0	0
45707835	1125315	0	0
45651724	1112807	0	0
45682844	1129625	0	0
45696351	1125315	0	0
45792210	1119510	0	0
45672690	1119510	0	0
46240641	1119510	0	0
45797980	1119510	0	0
46240288	1119510	0	0
45795851	1119510	0	0
46302984	1153428	0	0
46309480	1112807	0	0
46316188	1125315	0	0
21000706	1539411	2	3
4198525	4310024	3	3
21002481	1500211	0	0
21600991	1112807	0	0
36156887	1125315	0	0
35802131	4283893	6	8
36000000	433644	5	5
36313275	439777	3	3
44349041	1129625	0	0
44342127	1125315	0	0
44337836	1125315	0	0
44358609	1154343	0	0
45620913	1549786	0	0
45662328	1177480	0	0
45621811	19078461	2	3
45641531	1149196	0	0
45648040	1129625	0	0
45633403	1501700	0	0
45692400	1177480	0	0
45707807	1125315	0	0
45651755	1112807	0	0
45683085	1129625	0	0
45696651	1125315	0	0
45792376	1119510	0	0
45672640	1119510	0	0
46240043	1119510	0	0
45797991	1119510	0	0
46240237	1119510	0	0
45795813	1119510	0	0
46302992	1124957	0	0
46309493	1192710	0	0
46316191	1125315	0	0
21000716	19019273	2	3
4344497	4296204	3	3
21002433	1746114	0	0
21502622	1759842	0	0
36156888	1112807	0	0
35802131	4132546	6	8
36000000	4219399	5	5
36206173	3009542	3	5
44349049	1000560	0	0
44341839	1125315	0	0
44363316	1125315	0	0
44358478	1713332	0	0
45620869	1539403	0	0
45662341	1177480	0	0
45665555	40228214	2	3
45641563	1153428	0	0
45644533	1129625	0	0
45633404	1000560	0	0
45692532	1177480	0	0
45707761	1125315	0	0
45651450	1112807	0	0
45683103	1129625	0	0
45696616	1125315	0	0
45675985	1119510	0	0
45672718	1119510	0	0
46238277	1119510	0	0
45798009	1119510	0	0
45896211	1119510	0	0
45795876	1119510	0	0
46302914	742185	0	0
46309593	1112807	0	0
46304087	19075601	2	3
21000716	19078461	2	3
4215793	44805732	3	3
21002434	1741122	0	0
21502683	723013	0	0
36156888	1125315	0	0
35802131	4029498	6	6
36000000	40486433	4	6
36416670	439777	3	5
44349070	1112807	0	0
44345231	1501700	0	0
44363354	1125315	0	0
44358621	933724	0	0
45620807	1124300	0	0
45662412	1177480	0	0
45653787	40228214	2	3
45641446	1124300	0	0
45644700	1129625	0	0
45633522	19010482	0	0
45692567	1177480	0	0
45707778	1125315	0	0
45651712	1112807	0	0
45682752	1129625	0	0
45696408	1125315	0	0
45676035	1119510	0	0
45672719	1119510	0	0
46238361	1119510	0	0
45799744	1119510	0	0
45896304	1119510	0	0
45796000	1119510	0	0
46302916	967823	0	0
46309531	791967	0	0
46304684	19075601	2	3
21000716	19019979	2	3
4200532	40481087	3	4
21002434	1746114	0	0
21500450	1713332	0	0
36156866	1149196	0	0
35802131	4285898	5	5
36000000	4280726	3	6
36502196	40480160	3	6
44349118	19127890	0	0
44345068	1729720	0	0
44363468	1125315	0	0
44358612	1343916	0	0
45620859	1713332	0	0
45662537	1177480	0	0
45667529	40228214	2	3
45641539	1332418	0	0
45644762	1129625	0	0
45633554	1149196	0	0
45692618	1177480	0	0
45707877	1125315	0	0
45651701	1112807	0	0
45683090	1129625	0	0
45696695	1125315	0	0
45676440	1119510	0	0
45784507	1119510	0	0
45897247	1119510	0	0
45795194	1119510	0	0
45896400	1119510	0	0
45790405	1119510	0	0
46303456	1110410	0	0
46309533	1589505	0	0
46310004	19075601	2	3
21000716	1115171	2	3
4260918	4048695	3	4
21002491	1548195	0	0
21500523	723013	0	0
36156949	1149196	0	0
35802131	195588	5	5
36000000	4048171	5	7
36502202	4146173	3	9
44349118	1515774	0	0
44345171	1149196	0	0
44363480	1125315	0	0
44358613	914335	0	0
45620884	1713332	0	0
45659296	1177480	0	0
45663078	40228214	2	3
45641581	1539403	0	0
45644840	1129625	0	0
45633557	738818	0	0
45689416	1177480	0	0
45707862	1125315	0	0
45697847	1112807	0	0
45683356	1129625	0	0
45696423	1125315	0	0
45789127	1119510	0	0
45784515	1119510	0	0
45897254	1119510	0	0
45795355	1119510	0	0
45896436	1119510	0	0
45790527	1119510	0	0
46300425	975125	0	0
46310079	1192710	0	0
46301275	19075601	2	3
4274025	134438	2	7
4260918	4066995	3	4
21002670	1738521	0	0
21602660	933724	0	0
36156536	1545958	0	0
36151533	19133905	2	3
36000000	4048695	7	8
36500000	4066995	3	9
44349118	1549786	0	0
44345177	1149380	0	0
44363831	1125315	0	0
44358656	1713332	0	0
45620833	1154343	0	0
45659218	1177480	0	0
45663013	40228214	2	3
45641384	1107830	0	0
45644867	1129625	0	0
45633687	1192710	0	0
45691545	1177480	0	0
45707921	1125315	0	0
45648504	1112807	0	0
45682916	1129625	0	0
45696430	1125315	0	0
45789128	1119510	0	0
45784520	1119510	0	0
45897145	1119510	0	0
45795631	1119510	0	0
45896611	1119510	0	0
45790647	1119510	0	0
46300250	1000560	0	0
46309296	1551099	0	0
46304570	19075601	2	3
4274025	4084167	2	5
4197094	4166224	3	4
21002677	975125	0	0
21601626	1361711	0	0
36156924	1539403	0	0
36151533	19133873	2	3
36202157	4152936	4	9
36302170	4010253	3	8
44349122	1192710	0	0
44345154	1000560	0	0
44363530	1125315	0	0
44358661	1115008	0	0
45620917	1738521	0	0
45659239	1177480	0	0
45663013	40228230	2	3
45641386	1149196	0	0
45641814	1129625	0	0
45633688	1149196	0	0
45691551	1177480	0	0
45707867	1125315	0	0
45648816	1112807	0	0
45683474	1129625	0	0
45692966	1125315	0	0
45789384	1119510	0	0
45784600	1119510	0	0
45897179	1119510	0	0
45795304	1119510	0	0
45894133	1119510	0	0
45790576	1119510	0	0
46300331	1107830	0	0
46309540	1738521	0	0
46310187	19075601	2	3
4274025	4043241	2	11
19127890	40221415	3	4
21002686	975125	0	0
35507532	1107830	0	0
36156697	1000560	0	0
36151502	40231925	2	3
36202157	4001336	4	9
36516993	81151	3	7
44349125	1118084	0	0
44345179	723013	0	0
44363577	1125315	0	0
44351379	1729720	0	0
45620924	1396131	0	0
44341741	1177480	0	0
45657184	19078461	2	3
45641387	1115008	0	0
45641911	1129625	0	0
45633658	967823	0	0
45686733	1177480	0	0
45707991	1125315	0	0
45648790	1112807	0	0
45679812	1129625	0	0
45693144	1125315	0	0
45789324	1119510	0	0
45784585	1119510	0	0
45897416	1119510	0	0
45795378	1119510	0	0
45894087	1119510	0	0
45790478	1119510	0	0
46300252	967823	0	0
46309660	1332418	0	0
46305964	19075601	2	3
4043346	261325	2	4
4339468	4294548	3	5
21002659	1551099	0	0
35507270	1125315	0	0
36156700	967823	0	0
36151488	1127433	2	3
36202157	4146173	4	9
36206173	3001488	3	8
44349128	1177480	0	0
44345423	738818	0	0
44363579	1125315	0	0
44351293	738818	0	0
45620925	967823	0	0
44358074	1177480	0	0
45659698	40228214	2	3
45641516	1115008	0	0
45638611	1129625	0	0
45633666	1192710	0	0
45686865	1177480	0	0
45704945	1125315	0	0
45648919	1112807	0	0
45660102	1119510	0	0
45693232	1125315	0	0
45789330	1119510	0	0
45784536	1119510	0	0
45897217	1119510	0	0
45792549	1119510	0	0
45894089	1119510	0	0
45790479	1119510	0	0
46300379	1192710	0	0
46309847	1149196	0	0
46313884	19075601	2	3
4043679	4134304	2	4
4339410	40480160	3	5
21002671	975125	0	0
35507270	1119510	0	0
36156701	1107830	0	0
36151411	1115171	2	3
36202157	4142905	4	9
36206173	3010813	3	8
44348797	1124957	0	0
44345292	1521369	0	0
44363992	1125315	0	0
44351356	738818	0	0
45621021	1332418	0	0
44357763	1177480	0	0
45638517	19079524	2	3
45641498	1124300	0	0
45638617	1129625	0	0
45633672	791967	0	0
45686915	1177480	0	0
45704947	1125315	0	0
45649154	1112807	0	0
45661667	1119510	0	0
45693239	1125315	0	0
45789512	1119510	0	0
45784708	1119510	0	0
45897306	1119510	0	0
45792719	1119510	0	0
45798492	1125315	0	0
45790448	1119510	0	0
46300301	1174888	0	0
46309793	1112807	0	0
46315974	19075601	2	3
4042503	78272	2	4
4200532	4294548	3	5
21002671	1149380	0	0
35507402	1551099	0	0
36156705	1149380	0	0
36151545	40223834	2	3
36202157	378001	5	10
36206173	3015632	3	7
44348801	1115008	0	0
44345365	1332418	0	0
44363616	1125315	0	0
44351338	1545958	0	0
45621024	967823	0	0
44357767	1177480	0	0
45632131	40228214	2	3
45641409	1367571	0	0
45638690	1129625	0	0
45633411	1545958	0	0
45683575	1177480	0	0
45705040	1125315	0	0
45646016	1112807	0	0
45660175	1119510	0	0
45693126	1125315	0	0
45786491	1119510	0	0
45784629	1119510	0	0
45897355	1119510	0	0
45792666	1119510	0	0
45798333	1125315	0	0
45790485	1119510	0	0
46300307	715997	0	0
46309793	1192710	0	0
46309761	1539411	2	3
4032251	4058899	2	4
4200532	4112343	3	5
21002682	1551099	0	0
35507406	1738521	0	0
36156889	1115008	0	0
36151550	920334	2	3
36202157	4048695	5	9
36206173	3024731	3	7
44349087	1124300	0	0
44345376	1124957	0	0
44363624	1125315	0	0
44351505	1137529	0	0
45621027	1124300	0	0
44357970	1177480	0	0
45623393	19079524	2	3
45641419	738818	0	0
45638794	1129625	0	0
45633752	1124957	0	0
45683655	1177480	0	0
45705096	1125315	0	0
45645620	1112807	0	0
45658302	1119510	0	0
45694838	1125315	0	0
45786835	1119510	0	0
45784696	1119510	0	0
45894946	1119510	0	0
45792588	1119510	0	0
45798334	1125315	0	0
45790586	1119510	0	0
46300426	1332418	0	0
46309897	1549786	0	0
46310959	19078461	2	3
4199402	4237458	2	4
4339468	4112343	3	6
21002491	1549786	0	0
35507500	1153428	0	0
36156890	1107830	0	0
36199695	1115171	2	3
36202157	4066995	3	9
36206173	3021226	3	7
44349099	1310149	0	0
44345377	1112807	0	0
44363639	1125315	0	0
44351505	1149380	0	0
45620983	1137529	0	0
44354810	1177480	0	0
45665401	40228214	2	3
45641637	1115008	0	0
45638923	1129625	0	0
45630399	1326303	0	0
45683738	1177480	0	0
45704677	1125315	0	0
45645744	1112807	0	0
45658285	1119510	0	0
45694841	1125315	0	0
45786658	1119510	0	0
45784799	1119510	0	0
45894939	1119510	0	0
45794463	1119510	0	0
45798531	1125315	0	0
45790590	1119510	0	0
46300387	1192710	0	0
46309897	1589505	0	0
46313551	1539411	2	3
4042504	4024289	2	4
4309188	440448	3	6
21002493	1595799	0	0
35507502	1129625	0	0
36156892	1713332	0	0
36151788	40232448	2	3
36202157	4132546	3	8
36206173	3000963	3	7
44352006	1177480	0	0
44345380	1129625	0	0
44363644	1125315	0	0
44351371	1589505	0	0
45620983	1149380	0	0
44354823	1177480	0	0
45656948	40228214	2	3
45641840	1545958	0	0
45638894	1129625	0	0
45630280	1149196	0	0
45683821	1177480	0	0
45705131	1125315	0	0
45642879	1112807	0	0
45658297	1119510	0	0
45693313	1125315	0	0
45786757	1119510	0	0
45784909	1119510	0	0
45894966	1119510	0	0
45794524	1119510	0	0
45798616	1125315	0	0
45790601	1119510	0	0
46300394	1551099	0	0
46309898	1149196	0	0
45803847	19078461	2	3
4042504	4252419	2	4
4215793	40492359	3	7
21002493	19054876	0	0
35507506	1112807	0	0
36156870	1118084	0	0
36152000	46275444	2	3
36202157	4059173	7	9
36206173	3008598	3	7
44352013	738818	0	0
44345383	1129625	0	0
44363789	1125315	0	0
44351269	738818	0	0
45620984	1192710	0	0
44354919	1177480	0	0
45667911	40228214	2	3
45641694	1174888	0	0
45635369	1129625	0	0
45629960	1343916	0	0
45680703	1177480	0	0
45705099	1125315	0	0
45639921	1112807	0	0
45658088	1119510	0	0
45693319	1125315	0	0
45786506	1119510	0	0
45784596	1119510	0	0
45895043	1119510	0	0
45792779	1119510	0	0
45798634	1125315	0	0
45790701	1119510	0	0
46300313	738818	0	0
46309541	1713332	0	0
45803796	19075601	2	3
4052083	4133840	1	1
4302537	4285898	3	9
21002499	1521369	0	0
35507514	1174888	0	0
36156625	1501700	0	0
36152110	19129655	2	3
36211303	40479422	7	8
36206173	3002385	3	7
44351917	1124300	0	0
44345384	1192710	0	0
44363495	1125315	0	0
44351429	933724	0	0
45620986	1192710	0	0
44354923	1177480	0	0
45663319	19079524	2	3
45641566	19127890	0	0
45635376	1129625	0	0
45630373	1192710	0	0
45680783	1177480	0	0
45705149	1125315	0	0
45685878	1112807	0	0
45658166	1119510	0	0
45693557	1125315	0	0
45786515	1119510	0	0
45784655	1119510	0	0
45895036	1119510	0	0
45792764	1119510	0	0
45798577	1125315	0	0
45790511	1119510	0	0
46300474	738818	0	0
46309704	1501700	0	0
46320913	19079524	2	3
4054058	4134304	1	1
4274025	4280726	3	9
21002505	1500211	0	0
35507516	1112807	0	0
36157202	1107830	0	0
36152112	19078461	2	3
36211303	40479768	7	8
36206173	3036780	3	7
44351536	742185	0	0
44345655	1149196	0	0
44363736	1125315	0	0
44351386	1154343	0	0
45620990	1713332	0	0
44351045	1177480	0	0
45665846	19078461	2	3
45641566	1549786	0	0
45635590	1129625	0	0
45630378	967823	0	0
45680773	1177480	0	0
45704689	1125315	0	0
45636698	1112807	0	0
45658168	1119510	0	0
45693563	1125315	0	0
45786934	1119510	0	0
45784765	1119510	0	0
45895143	1119510	0	0
45792882	1119510	0	0
45798582	1125315	0	0
45790514	1119510	0	0
46300478	1124300	0	0
46309716	933724	0	0
46304533	19079524	2	3
4043371	30753	1	1
4274025	198809	3	8
21002506	1595799	0	0
35507517	1307863	0	0
36157204	967823	0	0
36152087	40220386	2	3
36211123	4066995	0	1
36206173	3006923	3	6
44352081	1112807	0	0
44345529	1501700	0	0
44363609	1125315	0	0
44351399	1759842	0	0
45620995	967823	0	0
44350991	1177480	0	0
45665292	40228214	2	3
45641571	1153428	0	0
45637220	1129625	0	0
45630505	1501700	0	0
45680590	1177480	0	0
45705068	1125315	0	0
45636738	1112807	0	0
45704007	1119510	0	0
45690278	1125315	0	0
45786952	1119510	0	0
45784768	1119510	0	0
45895239	1119510	0	0
45792974	1119510	0	0
45798353	1125315	0	0
45790851	1119510	0	0
46300480	1192710	0	0
46309754	1545958	0	0
46311973	40228214	2	3
4043671	4283893	1	1
4302537	4112343	4	8
21002506	1589505	0	0
35507611	1115008	0	0
36157241	1124300	0	0
36152129	1115171	2	3
36211089	81151	0	2
36206173	3016723	3	6
44352091	1738521	0	0
44345530	1112807	0	0
44363768	1125315	0	0
44351399	1713332	0	0
45621153	738818	0	0
44350861	1177480	0	0
45626134	19078461	2	3
45641598	1539403	0	0
45636882	1129625	0	0
45630509	1174888	0	0
45680576	1177480	0	0
45705059	1125315	0	0
45636849	1112807	0	0
45704081	1119510	0	0
45690305	1125315	0	0
45786870	1119510	0	0
45784993	1119510	0	0
45895324	1119510	0	0
45789985	1119510	0	0
45798354	1125315	0	0
45790860	1119510	0	0
46300396	1545958	0	0
46309878	1118084	0	0
46310977	1539411	2	3
4194895	4246502	1	1
4326426	4330583	4	7
21002506	1515774	0	0
35507542	723013	0	0
36157205	1125315	0	0
36152138	19133873	2	3
35900000	198809	3	6
36206173	3013721	3	6
44352099	1118084	0	0
44345536	1149380	0	0
44356505	1125315	0	0
44351403	975125	0	0
45620835	1154029	0	0
44351125	1177480	0	0
45628895	40223768	2	3
45641708	1107830	0	0
45635709	1129625	0	0
45630306	740275	0	0
45680793	1177480	0	0
45633045	1119510	0	0
45636825	1112807	0	0
45703919	1119510	0	0
45690464	1125315	0	0
45786710	1119510	0	0
45784998	1119510	0	0
45895116	1119510	0	0
45790129	1119510	0	0
45798609	1125315	0	0
45790991	1119510	0	0
46300494	1778162	0	0
46309522	1545958	0	0
46305728	19078461	2	3
4195601	4238715	1	1
4274025	4310024	4	8
21002506	19127890	0	0
35507491	1125315	0	0
36157205	1119510	0	0
36002140	80809	2	3
36002139	4048171	4	6
36206173	3024561	3	6
44352150	1713332	0	0
44345717	1174888	0	0
44356538	1125315	0	0
44351561	1192710	0	0
45621050	1124300	0	0
44352409	1177480	0	0
45644426	19078461	2	3
45641545	738818	0	0
45635714	1129625	0	0
45630311	975125	0	0
45680869	1177480	0	0
45633048	1119510	0	0
45636850	1112807	0	0
45703977	1119510	0	0
45690475	1125315	0	0
45786920	1119510	0	0
45784999	1119510	0	0
45895170	1119510	0	0
45789901	1119510	0	0
45798442	1125315	0	0
46297464	1119510	0	0
46300500	1174888	0	0
46309527	1310149	0	0
46314715	40228214	2	3
4182210	378419	1	1
4274025	4329847	4	9
21002506	1521369	0	0
21003027	19078924	2	3
36157205	738818	0	0
35708136	4285898	2	3
35702120	81893	4	6
36206173	3009201	3	6
44351751	1174888	0	0
44345577	1129625	0	0
44356506	1125315	0	0
44351485	1545958	0	0
45620771	1115008	0	0
44352249	1177480	0	0
45632388	19079524	2	3
45641756	705944	0	0
45635768	1129625	0	0
45630012	1115008	0	0
45680558	1177480	0	0
45633070	1119510	0	0
45636770	1112807	0	0
45703780	1119510	0	0
45690554	1125315	0	0
45786922	1119510	0	0
45784647	1119510	0	0
45895333	1119510	0	0
45790142	1119510	0	0
45798563	1125315	0	0
46297721	1119510	0	0
46300429	1174888	0	0
46309685	975125	0	0
46311577	40228214	2	3
19131646	19132304	1	1
4274025	260139	4	9
21002506	1549786	0	0
21500003	19129655	2	3
36157208	1549786	0	0
36158638	19123231	2	3
36203042	4134304	4	6
36206173	3013682	3	6
44351697	705944	0	0
44345592	1129625	0	0
44356540	1125315	0	0
44351514	1551099	0	0
45620930	1115008	0	0
44351262	1177480	0	0
45626441	19078461	2	3
45641657	1738521	0	0
45636064	1129625	0	0
45630428	715997	0	0
45682564	1177480	0	0
45633141	1119510	0	0
45636966	1112807	0	0
45703903	1119510	0	0
45690397	1125315	0	0
45786844	1119510	0	0
45782403	1119510	0	0
45894407	1119510	0	0
45790159	1119510	0	0
45798555	1125315	0	0
46297955	1119510	0	0
46300436	920293	0	0
46309971	967823	0	0
45650761	40228214	2	3
19103127	19128022	1	1
4274025	4112343	4	10
21002501	1521369	0	0
21500003	19073183	2	3
36157242	1149196	0	0
36158295	1545959	2	3
35802133	4084167	5	6
36206173	3005136	3	6
44352265	1521369	0	0
44345297	1322184	0	0
44356667	1125315	0	0
44351487	1305058	0	0
45620842	1154029	0	0
44347148	1177480	0	0
45650156	19078461	2	3
45641550	19003953	0	0
45632667	1129625	0	0
45630429	1305058	0	0
45677662	1177480	0	0
45633144	1119510	0	0
45636971	1112807	0	0
45651693	1119510	0	0
45690387	1125315	0	0
45786794	1119510	0	0
45782408	1119510	0	0
45797544	738818	0	0
45790160	1119510	0	0
45798556	1125315	0	0
46297749	1119510	0	0
46300661	1305058	0	0
46309750	1310149	0	0
46320151	40228214	2	3
19103127	19128263	1	1
4274025	440086	4	6
21002501	1500211	0	0
21500003	19073188	2	3
36156969	1107830	0	0
36152204	19075001	2	3
36102970	198199	6	6
36206173	3035995	3	6
44349156	1361711	0	0
44345271	791967	0	0
44356620	1125315	0	0
44351522	1124300	0	0
45620893	1778162	0	0
44347450	1177480	0	0
45659660	40223768	2	3
45641553	1137529	0	0
45632801	1129625	0	0
45630447	738818	0	0
45677509	1177480	0	0
45633073	1119510	0	0
45633770	1112807	0	0
45651320	1119510	0	0
45690326	1125315	0	0
45786797	1119510	0	0
45782658	1119510	0	0
45797545	1000560	0	0
45789927	1119510	0	0
45793176	1125315	0	0
46297417	1119510	0	0
46300454	1551099	0	0
46309911	1118084	0	0
46314429	19079524	2	3
19103181	19023423	1	1
4302537	198809	4	6
21002493	1549786	0	0
21003038	19076374	2	3
36156939	1177480	0	0
36154384	19019273	2	3
36102898	4116491	6	6
36206173	3020630	3	6
44349254	975125	0	0
44345273	1115008	0	0
44356605	1125315	0	0
44351492	1713332	0	0
45620777	1501700	0	0
44347759	1177480	0	0
45667276	40223768	2	3
45641553	1149380	0	0
45632871	1129625	0	0
45630442	1713332	0	0
45677425	1177480	0	0
45676458	1119510	0	0
45633797	1112807	0	0
45651340	1119510	0	0
45690329	1125315	0	0
45786964	1119510	0	0
45782350	1119510	0	0
45797546	705944	0	0
45789810	1119510	0	0
45793267	1125315	0	0
46297354	1119510	0	0
46300214	1539403	0	0
46309557	701322	0	0
45675329	40228230	2	3
4027405	4301346	2	2
4302537	30753	4	6
21001768	1738521	0	0
21008439	1551192	2	3
36156622	920293	0	0
36150715	42707627	2	3
36103041	28060	6	6
36502198	4048695	3	4
44349255	1110410	0	0
44345277	1326303	0	0
44356610	1125315	0	0
44351497	1154343	0	0
45621205	1174888	0	0
44343619	1177480	0	0
45659823	19078461	2	3
45641556	1154343	0	0
45632844	1129625	0	0
45630152	1174888	0	0
45677695	1177480	0	0
45676733	1119510	0	0
45679586	1112807	0	0
45651444	1119510	0	0
45690492	1125315	0	0
45786886	1119510	0	0
45783667	1119510	0	0
45797547	1115008	0	0
45789909	1119510	0	0
45793277	1125315	0	0
46297649	1119510	0	0
46300484	1778162	0	0
46309582	1107830	0	0
45675329	40228214	2	3
4027405	44783196	2	2
4304916	4166224	4	6
21001769	1759842	0	0
21500012	19074841	2	3
36156623	1125315	0	0
36154509	42707627	2	3
36103041	433125	6	6
36502198	40480160	3	4
44349259	1177480	0	0
44345288	1501700	0	0
44356754	1125315	0	0
44351647	1124957	0	0
45620847	1000560	0	0
44343958	1177480	0	0
45665512	19078461	2	3
45641610	1149196	0	0
45632653	1129625	0	0
45630220	1326303	0	0
45677705	1177480	0	0
45676802	1119510	0	0
45630657	1112807	0	0
45652199	1119510	0	0
45690495	1125315	0	0
45786976	1119510	0	0
45783654	1119510	0	0
45797550	1326303	0	0
45790175	1119510	0	0
45793285	1125315	0	0
46297601	1119510	0	0
46300598	738818	0	0
46310153	1738521	0	0
45803895	40228214	2	3
4178367	4145310	2	2
4309188	4112343	4	6
21001770	1174888	0	0
21500012	19074843	2	3
36156871	1125315	0	0
36158041	46275444	2	3
36202155	4134304	5	7
36313913	4252419	3	4
44349183	1177480	0	0
44345497	1326303	0	0
44356672	1125315	0	0
44351371	1549786	0	0
45620848	740275	0	0
44340478	1177480	0	0
45632017	19078461	2	3
45641613	738818	0	0
45631083	1129625	0	0
45630262	1713332	0	0
45676231	1177480	0	0
45676915	1119510	0	0
45630961	1112807	0	0
45652016	1119510	0	0
45690556	1125315	0	0
45786237	1119510	0	0
45782749	1119510	0	0
45797438	1192710	0	0
45789992	1119510	0	0
45793109	1125315	0	0
46297973	1119510	0	0
46300689	740275	0	0
46309937	1112807	0	0
45896983	40228214	2	3
4155793	4145310	2	2
4339410	4142905	4	5
21001770	1192710	0	0
21500012	19075001	2	3
36157105	1115008	0	0
36158049	40162522	2	3
36202157	4218389	3	7
36424236	40221415	3	4
44349222	1738521	0	0
44345310	967823	0	0
44356707	1125315	0	0
44351453	1332418	0	0
45621199	791967	0	0
44340037	1177480	0	0
45647392	19078461	2	3
45641618	1174888	0	0
45629755	1129625	0	0
45630485	1501700	0	0
45676251	1177480	0	0
45676925	1119510	0	0
45627804	1112807	0	0
45652072	1119510	0	0
45690578	1125315	0	0
45786279	1119510	0	0
45782738	1119510	0	0
45797508	1589505	0	0
45790011	1119510	0	0
45793110	1125315	0	0
46297565	1119510	0	0
46300691	1149196	0	0
46309938	1738521	0	0
46309450	19079524	2	3
4042517	4295880	2	2
4339410	4237458	4	5
21601086	1396131	0	0
21002607	46275444	2	3
36157114	1125315	0	0
36157788	40229134	2	3
36202157	4113008	3	7
36424390	19127904	3	4
44349231	1112807	0	0
44345401	1177480	0	0
44356718	1125315	0	0
44351464	1738521	0	0
45621229	1153428	0	0
44340556	1177480	0	0
45623640	19078461	2	3
45641768	1310149	0	0
45629776	1129625	0	0
45630406	1153428	0	0
45671526	1177480	0	0
45676805	1119510	0	0
45627856	1112807	0	0
45651809	1119510	0	0
45690428	1125315	0	0
45786427	1119510	0	0
45782894	1119510	0	0
45797517	1713332	0	0
45790188	1119510	0	0
45793192	1125315	0	0
46297782	1119510	0	0
46301032	1738521	0	0
46310093	1154029	0	0
45803889	19079524	2	3
4181063	28060	2	2
4198525	4112343	4	5
21601080	1396131	0	0
21503947	40228230	2	3
36157114	1129625	0	0
36158197	19125062	2	3
36202157	4155034	4	7
36217216	40221415	3	4
44349278	1124300	0	0
44345408	1192710	0	0
44356662	1125315	0	0
44351788	701322	0	0
45621072	1713332	0	0
44340457	1177480	0	0
45659784	19078461	2	3
45641770	1551099	0	0
45629793	1129625	0	0
45631155	914335	0	0
45671490	1177480	0	0
45676788	1119510	0	0
45676165	1112807	0	0
45651815	1119510	0	0
45690511	1125315	0	0
45786575	1119510	0	0
45782775	1119510	0	0
45797538	1326303	0	0
45787436	1119510	0	0
45793194	1125315	0	0
46289024	1119510	0	0
46300823	1192710	0	0
46310094	1000560	0	0
45675419	40228214	2	3
4042837	140673	2	2
4266169	313217	4	5
21601081	1595799	0	0
21503947	40228214	2	3
36157117	1119510	0	0
36158342	1127433	2	3
36102970	4116491	5	7
40652446	3007461	2	2
44349161	1192710	0	0
44345519	738818	0	0
44356722	1125315	0	0
44351772	1539403	0	0
45621079	1118084	0	0
45620548	1177480	0	0
45634073	19078461	2	3
45641772	19010482	0	0
45626918	1129625	0	0
45631353	1713332	0	0
45671579	1177480	0	0
45676791	1119510	0	0
45670624	1112807	0	0
45697849	1119510	0	0
45691410	1125315	0	0
45785271	1119510	0	0
45782863	1119510	0	0
45797625	1000560	0	0
45787439	1119510	0	0
45793403	1125315	0	0
46289062	1119510	0	0
46300824	1501700	0	0
46310158	1192710	0	0
45650751	40228214	2	3
4042837	4218389	2	2
4322976	4058899	4	9
21502620	1174888	5	5
21013658	40223768	2	3
36157117	738818	0	0
36158293	43012036	2	3
36002139	4066995	6	7
40652446	3026361	2	2
44349166	1551099	0	0
44345523	1177480	0	0
44356776	1125315	0	0
44351466	1729720	0	0
45621083	1107830	0	0
45620462	1177480	0	0
45641544	19078461	2	3
45641782	1115008	0	0
45626949	1129625	0	0
45631250	715997	0	0
45673017	1177480	0	0
45676897	1119510	0	0
45670383	1112807	0	0
45697860	1119510	0	0
45691411	1125315	0	0
45785360	1119510	0	0
45780761	1119510	0	0
45797631	1110410	0	0
45787475	1119510	0	0
45793372	1125315	0	0
46289221	1119510	0	0
46300826	1174888	0	0
46310159	1124957	0	0
46315346	19079524	2	3
441840	78272	6	12
4322976	44783196	4	9
21500617	782047	5	6
21602823	1713671	2	3
36157117	1125315	0	0
36158294	1115171	2	3
36211303	40480160	7	7
40652446	3010813	2	2
44349169	1149196	0	0
44345477	1115008	0	0
44356970	1125315	0	0
44351559	1000560	0	0
45621086	1192710	0	0
45620562	1177480	0	0
45650181	19078461	2	3
45641783	967823	0	0
45626853	1129625	0	0
45631255	1124957	0	0
45673098	1177480	0	0
45676898	1119510	0	0
45669402	1112807	0	0
45700651	1119510	0	0
45687252	1125315	0	0
45785578	1119510	0	0
45780236	1119510	0	0
45797643	1115008	0	0
45787256	1119510	0	0
45793476	1125315	0	0
46289463	1119510	0	0
46300828	1000560	0	0
46310013	1545958	0	0
46316985	40223768	2	3
441840	4139681	6	7
4322976	4117038	4	9
21500617	19023398	5	6
21003042	19078924	2	3
36157133	1515774	0	0
36158331	19008572	2	3
36202157	381316	5	5
40779250	3020630	2	2
44349281	1112807	0	0
44345480	1738521	0	0
44356994	1125315	0	0
44351657	791967	0	0
45621089	1192710	0	0
45620356	1177480	0	0
45632519	19078461	2	3
45641786	738818	0	0
45628122	1129625	0	0
45631257	933724	0	0
45673312	1177480	0	0
45676901	1119510	0	0
45666963	1112807	0	0
45700658	1119510	0	0
45687254	1125315	0	0
45785398	1119510	0	0
45780328	1119510	0	0
45797644	1154343	0	0
45787263	1119510	0	0
45793480	1125315	0	0
46289536	1119510	0	0
46300860	1174888	0	0
46310045	1308738	0	0
46309028	40223768	2	3
441840	438614	6	7
4322976	4015189	4	8
21500164	40174880	5	6
21002036	19073183	2	3
36157133	1549786	0	0
36158436	1127433	2	3
36202157	4329847	5	5
37503868	4078793	2	2
44349289	1129625	0	0
44345483	738818	0	0
44356999	1125315	0	0
44351794	738818	0	0
45621186	1115008	0	0
44362331	1177480	0	0
45659971	19078461	2	3
45638373	1124957	0	0
45627079	1129625	0	0
45631261	975125	0	0
45671689	1177480	0	0
45676974	1119510	0	0
45666986	1112807	0	0
45648496	1119510	0	0
45687393	1125315	0	0
45785531	1119510	0	0
45780306	1119510	0	0
45797457	1308738	0	0
45787196	1119510	0	0
45793434	1125315	0	0
46289814	1119510	0	0
46300869	1332418	0	0
46309761	1539403	0	0
46309209	40223768	2	3
441840	4304110	6	7
376208	4296204	4	5
21500617	19078924	5	6
21002036	19073188	2	3
36157140	1149380	0	0
36158441	19008572	2	3
35809212	4048171	5	5
37503868	4337138	2	2
44349296	933724	0	0
44345484	1177480	0	0
44357009	1125315	0	0
44351800	1759842	0	0
45621197	738818	0	0
44362563	1177480	0	0
45663242	19078461	2	3
45638385	914335	0	0
45623928	1129625	0	0
45631069	1154029	0	0
45671665	1177480	0	0
45676958	1119510	0	0
45778455	1112807	0	0
45648785	1119510	0	0
45687472	1125315	0	0
45785683	1119510	0	0
45777762	1119510	0	0
45797458	1174888	0	0
45787269	1119510	0	0
45793439	1125315	0	0
46289559	1119510	0	0
46300839	1539403	0	0
46309781	1124957	0	0
45896529	40223768	2	3
441840	4169137	6	7
133468	4109685	4	5
21500205	19126352	5	6
21003084	40165015	2	3
36156944	1107830	0	0
36158218	1115171	2	3
36002141	4048171	5	5
40039807	19128022	2	2
44349244	1112807	0	0
44345776	1112807	0	0
44356854	1125315	0	0
44351800	1713332	0	0
45621198	1192710	0	0
44362515	1177480	0	0
45629431	19078461	2	3
45638216	1501700	0	0
45623822	1129625	0	0
45631073	1545958	0	0
45670042	1177480	0	0
45676941	1119510	0	0
45778443	1112807	0	0
45648787	1119510	0	0
45687556	1125315	0	0
45785389	1119510	0	0
45777723	1119510	0	0
45797685	740275	0	0
45787450	1119510	0	0
45793441	1125315	0	0
46289738	1119510	0	0
46301115	975125	0	0
46310167	1124957	0	0
46304867	19078461	2	3
441840	40486433	6	11
133468	4059173	4	5
21506173	1332419	5	6
21503948	40223821	2	3
36156947	1129625	0	0
36158520	40236824	2	3
36110015	4294548	5	5
40039807	19128263	2	2
44349413	1549786	0	0
44345783	1713332	0	0
44357104	1125315	0	0
44351803	1000560	0	0
45621158	967823	0	0
44362769	1177480	0	0
45623329	19078461	2	3
45640073	1115008	0	0
45623943	1129625	0	0
45631264	740275	0	0
45783754	1177480	0	0
45673431	1119510	0	0
45778417	1112807	0	0
45648849	1119510	0	0
45687507	1125315	0	0
45785391	1119510	0	0
45777726	1119510	0	0
45797575	1717327	0	0
45696301	1125315	0	0
45793294	1125315	0	0
46241559	1119510	0	0
46300894	1551099	0	0
46310204	791967	0	0
45675646	19078461	2	3
441840	4266809	6	9
376106	378419	4	5
21503224	1343916	0	0
21503948	1150771	2	3
36156947	1125315	0	0
36154376	40162522	2	3
36202155	40479768	5	5
40040565	19128009	2	2
44349389	1107830	0	0
44345789	1177480	0	0
44357024	1125315	0	0
44351961	1310149	0	0
45620953	967823	0	0
44354964	1177480	0	0
45623365	19078461	2	3
45639950	1000560	0	0
45623919	1129625	0	0
45630531	1174888	0	0
45783725	1177480	0	0
45673437	1119510	0	0
45778534	1112807	0	0
45648985	1119510	0	0
45687562	1125315	0	0
45783410	1119510	0	0
45777653	1119510	0	0
45797555	715997	0	0
45696381	1125315	0	0
45793301	1125315	0	0
46241705	1119510	0	0
46300631	701322	0	0
46310205	1361711	0	0
46320803	40223768	2	3
441840	4156265	6	9
440921	4109685	4	5
21503244	975125	0	0
21503948	1150837	2	3
36156948	1125315	0	0
36154716	40232448	2	3
36002139	40486433	3	5
36703530	4218389	2	2
44349417	1129625	0	0
44345410	1332418	0	0
44357049	1125315	0	0
44351658	738818	0	0
45620967	1343916	0	0
44355013	1177480	0	0
45626342	19078461	2	3
45638517	967823	0	0
45667989	1129625	0	0
45630532	1174888	0	0
45783995	1177480	0	0
45673676	1119510	0	0
45778511	1112807	0	0
45648846	1119510	0	0
45687571	1125315	0	0
45783351	1119510	0	0
45777803	1119510	0	0
45797519	1107830	0	0
45696384	1125315	0	0
45793308	1125315	0	0
46241646	1119510	0	0
46300852	1124957	0	0
46310115	791967	0	0
46320593	19078461	2	3
441840	198199	6	9
440921	4132546	4	5
21503264	1343916	0	0
21503948	19125062	2	3
36157080	1000560	0	0
36154612	40232448	2	3
36203042	4278672	3	3
40776205	3049273	2	2
44349317	1115008	0	0
44345416	1177480	0	0
44357187	1125315	0	0
44351715	1107830	0	0
45620968	1500211	0	0
44355052	1177480	0	0
45650384	19078461	2	3
45638461	705944	0	0
45667903	1129625	0	0
45630532	1192710	0	0
45781757	1177480	0	0
45673845	1119510	0	0
45778521	1112807	0	0
45645959	1119510	0	0
45687280	1125315	0	0
45783326	1119510	0	0
45777746	1119510	0	0
45797520	1310149	0	0
45696390	1125315	0	0
45793120	1125315	0	0
46241723	1119510	0	0
46300632	1124300	0	0
46310003	1549786	0	0
46320472	19078461	2	3
441840	4048695	6	10
4002365	4336464	4	5
21503264	1119510	0	0
21503948	1107882	2	3
36157100	1343916	0	0
36154486	19076374	2	3
36203042	4237458	3	3
40776222	3005136	2	2
44349263	914335	0	0
44345503	1129625	0	0
44357084	1125315	0	0
44351411	1154029	0	0
45621163	975125	0	0
44354943	1177480	0	0
45623258	19078461	2	3
45638495	1759842	0	0
45667905	1129625	0	0
45630593	1124300	0	0
45781709	1177480	0	0
45673846	1119510	0	0
45780461	1112807	0	0
45645996	1119510	0	0
45687385	1125315	0	0
45783447	1119510	0	0
45777748	1119510	0	0
45797461	1713332	0	0
45696812	1125315	0	0
45793395	1125315	0	0
46241735	1119510	0	0
46300633	1115008	0	0
46310003	19127890	0	0
46304246	19078461	2	3
441840	40481087	6	10
432250	40481087	4	5
21505737	1112807	0	0
21503948	40223834	2	3
36157101	1548195	0	0
36154837	46275916	2	3
36203042	4066995	3	3
40779107	3021226	2	2
44349187	1741122	0	0
44345697	1595799	0	0
44357130	1125315	0	0
44351417	723013	0	0
45664715	1107830	0	0
45655143	1177480	0	0
45632127	19078461	2	3
45638495	1713332	0	0
45668087	1129625	0	0
45630553	1192710	0	0
45781381	1177480	0	0
45673739	1119510	0	0
45707208	1112807	0	0
45646338	1119510	0	0
45687534	1125315	0	0
45783449	1119510	0	0
45706497	1119510	0	0
45797618	1107830	0	0
45696818	1125315	0	0
45793046	1125315	0	0
46241765	1119510	0	0
46300937	1305058	0	0
46310003	1512674	0	0
46313571	19078461	2	3
441840	4142905	6	10
4021667	4152936	4	6
21505764	1192710	0	0
21013672	1310034	2	3
35702738	4310024	2	7
36154654	40232448	2	3
35708303	81893	3	3
40779360	3015076	2	2
44349190	975125	0	0
44345697	1521369	0	0
44350109	1125315	0	0
44351625	1551099	0	0
45664682	1115008	0	0
45655483	1177480	0	0
45632296	1127433	2	3
45638468	1717327	0	0
45668178	1129625	0	0
45630557	1307863	0	0
45781847	1177480	0	0
45673282	1119510	0	0
45704259	1112807	0	0
45645655	1119510	0	0
45687681	1125315	0	0
45783368	1119510	0	0
45706672	1119510	0	0
45797724	1149196	0	0
45696882	1125315	0	0
45793258	1125315	0	0
46242612	1119510	0	0
46300948	738818	0	0
46310117	933724	0	0
46320712	19078461	2	3
441840	4299128	6	6
376106	378001	4	6
21505755	1124300	0	0
21002089	1551192	2	3
36202157	4230399	4	10
36154657	40232448	2	3
35702111	4266809	3	3
40779159	3007461	2	2
44349311	1149196	0	0
44345697	1549786	0	0
44349629	1125315	0	0
44351579	1548195	0	0
45664720	1107830	0	0
44347716	1177480	0	0
45632296	19078461	2	3
45638568	1551099	0	0
45668126	1129625	0	0
45630699	920293	0	0
45781836	1177480	0	0
45673003	1119510	0	0
45700800	1112807	0	0
45645710	1119510	0	0
45687600	1125315	0	0
45783516	1119510	0	0
45706845	1119510	0	0
45797727	1124957	0	0
45696761	1125315	0	0
45794579	1125315	0	0
46242615	1119510	0	0
46300966	1539403	0	0
46310120	1149196	0	0
46303823	19078461	2	3
441840	4296205	6	6
376106	375671	4	6
21505756	1115008	0	0
21003118	19008572	2	3
36202157	4134304	4	11
36155000	1551192	2	3
36102976	4280726	3	3
37503873	4197460	2	2
44349276	1177480	0	0
44345600	1124300	0	0
44349766	1125315	0	0
44351585	1332418	0	0
45664596	1115008	0	0
44348628	1177480	0	0
45623642	19078461	2	3
45638527	1738521	0	0
45665792	1129625	0	0
45630704	967823	0	0
45779139	1177480	0	0
45673414	1119510	0	0
45701046	1112807	0	0
45646024	1119510	0	0
45687467	1125315	0	0
45783517	1119510	0	0
45703089	1119510	0	0
45797728	1154343	0	0
45696614	1125315	0	0
45794656	1125315	0	0
46242571	1119510	0	0
46300971	933724	0	0
46310004	1322184	0	0
46313436	19078461	2	3
441840	4035415	5	9
376337	4001336	4	6
21505765	1192710	0	0
21002591	19133905	2	3
36203062	4152936	4	8
36155014	1551192	2	3
36102976	40486433	3	3
37119654	45769019	2	2
44349377	1000560	0	0
44345710	1129625	0	0
44349644	1125315	0	0
44351775	1192710	0	0
45664598	1174888	0	0
44348023	1177480	0	0
45644511	19078461	2	3
45638573	738818	0	0
45665803	1129625	0	0
45630713	1124957	0	0
45779272	1177480	0	0
45670764	1119510	0	0
45701055	1112807	0	0
45642704	1119510	0	0
45687541	1125315	0	0
45783055	1119510	0	0
45703772	1119510	0	0
45797579	1112807	0	0
45696615	1125315	0	0
45794660	1125315	0	0
46241811	1119510	0	0
46300977	1332418	0	0
46310171	1153428	0	0
46314534	19078461	2	3
441840	4109685	5	9
432250	4116491	4	6
21505765	1129625	0	0
21002591	19073183	2	3
35205038	4112343	4	8
36152419	1551192	2	3
36102976	260139	3	3
40795754	3027970	2	2
44349299	1177480	0	0
44345712	920293	0	0
44349776	1125315	0	0
44351634	1738521	0	0
45664727	1107830	0	0
44348162	1177480	0	0
44347457	1129625	0	0
45638544	1124957	0	0
45665952	1129625	0	0
45630765	967823	0	0
45779301	1177480	0	0
45670843	1119510	0	0
45700783	1112807	0	0
45642650	1119510	0	0
45687649	1125315	0	0
45783176	1119510	0	0
45703182	1119510	0	0
45797407	723013	0	0
45802689	1125315	0	0
45787859	1125315	0	0
46241824	1119510	0	0
46300979	1115008	0	0
46304448	975125	0	0
46304098	19078461	2	3
441840	4132546	5	9
440921	4142905	4	6
21505718	19010482	0	0
21002591	19133873	2	3
36100000	40481087	4	8
36152327	19008572	2	3
35809207	40486433	3	3
40795688	3027231	2	2
44345193	1557272	0	0
44345715	1129625	0	0
44349782	1125315	0	0
44351564	1192710	0	0
45664722	1149196	0	0
44348123	1177480	0	0
44347661	1129625	0	0
45638635	1310149	0	0
45665594	1129625	0	0
45630774	1326303	0	0
45780731	1177480	0	0
45670767	1119510	0	0
45697877	1112807	0	0
45688716	1119510	0	0
45687747	1125315	0	0
45783531	1119510	0	0
45703184	1119510	0	0
45797847	1738521	0	0
45802705	1125315	0	0
45787862	1125315	0	0
46241792	1119510	0	0
46300766	1738521	0	0
46304466	1192710	0	0
46305546	19078461	2	3
441840	381316	5	8
440921	4278672	4	6
21505783	1539403	0	0
21002600	19073188	2	3
36100000	4294548	4	9
36152328	40229134	2	3
35809207	4280726	3	3
40795689	3014599	2	2
44345263	1124300	0	0
44345603	1112807	0	0
44349794	1125315	0	0
44351574	1310149	0	0
45664708	1115008	0	0
44341489	1177480	0	0
44347783	1129625	0	0
45638501	791967	0	0
45665753	1129625	0	0
45630775	1174888	0	0
45779472	1177480	0	0
45670817	1119510	0	0
45697926	1112807	0	0
45688662	1119510	0	0
45687304	1125315	0	0
46291860	1119510	0	0
45703278	1119510	0	0
45797409	1000560	0	0
45802895	1125315	0	0
45787878	1125315	0	0
46241832	1119510	0	0
46301009	1000560	0	0
46304357	1118084	0	0
46313800	19078461	2	3
441840	4113008	5	8
440921	4152936	4	6
21505770	738818	0	0
21002600	1713671	2	3
36100000	4112343	4	9
36152156	40229134	2	3
36002886	4280726	3	3
40795690	3012494	2	2
44345389	1149380	0	0
44345609	1589505	0	0
44349475	1125315	0	0
44351635	967823	0	0
45664712	1174888	0	0
44340679	1177480	0	0
44343566	1129625	0	0
45638583	1545958	0	0
45666163	1129625	0	0
45630631	1332418	0	0
45708091	1177480	0	0
45670793	1119510	0	0
45698050	1112807	0	0
45639811	1119510	0	0
45684258	1125315	0	0
46291572	1119510	0	0
45700128	1119510	0	0
45797730	1124300	0	0
45802802	1125315	0	0
45787918	1125315	0	0
45895806	1119510	0	0
46300917	1153428	0	0
46304437	1149380	0	0
46308815	19078461	2	3
441840	378419	5	10
440921	4146173	4	6
21505732	967823	0	0
21002600	19073183	2	3
36100000	4116491	4	9
35702116	81893	2	3
36002886	40486433	3	3
40779224	3028833	2	2
44345398	1557272	0	0
44345802	967823	0	0
44349814	1125315	0	0
44351577	1115008	0	0
45664725	1124300	0	0
44340639	1177480	0	0
44344767	1129625	0	0
45638591	1367571	0	0
45666177	1129625	0	0
45630635	1548195	0	0
45708066	1177480	0	0
45671090	1119510	0	0
45694765	1112807	0	0
45639727	1119510	0	0
45684246	1125315	0	0
46291583	1119510	0	0
45699984	1119510	0	0
45797732	1367571	0	0
45802771	1125315	0	0
45787886	1125315	0	0
45895861	1119510	0	0
46301018	1124957	0	0
46304619	975125	0	0
46320445	19078461	2	3
441840	195588	5	10
133468	4152936	4	6
21505845	1545958	0	0
21013671	19018935	2	3
36203062	4109685	4	7
36158559	19008572	2	3
36202155	4146173	3	3
40792413	3023103	2	2
44345399	1129625	0	0
44345667	1738521	0	0
44350157	1125315	0	0
44351820	933724	0	0
45667150	1124300	0	0
44340954	1177480	0	0
44343724	1129625	0	0
45638509	1549786	0	0
45663735	1129625	0	0
45630638	1738521	0	0
45708124	1177480	0	0
45670880	1119510	0	0
45691855	1112807	0	0
45685829	1119510	0	0
45685478	1125315	0	0
46291590	1119510	0	0
45700199	1119510	0	0
45797583	975125	0	0
45802774	1125315	0	0
45788010	1125315	0	0
45895910	1119510	0	0
46301122	1326303	0	0
46304398	1307863	0	0
46304070	19078461	2	3
441840	4294548	5	11
133468	4146173	4	6
21505845	1539403	0	0
21002084	1551192	2	3
36102149	4056621	4	7
36158768	19008572	2	3
36000000	81893	3	3
40181756	40221415	2	2
44345506	1153428	0	0
44345668	1713332	0	0
44349942	1125315	0	0
44351725	1501700	0	0
45667273	715997	0	0
45637339	1177480	0	0
44343687	1129625	0	0
45638509	19127890	0	0
45663502	1129625	0	0
45630624	1107830	0	0
45708265	1177480	0	0
45670885	1119510	0	0
45688956	1112807	0	0
45685798	1119510	0	0
45685506	1125315	0	0
46291493	1119510	0	0
45697777	1119510	0	0
45797584	1115008	0	0
45802778	1125315	0	0
45787903	1125315	0	0
45896004	1119510	0	0
46319215	1115008	0	0
46304653	723013	0	0
46313300	19078461	2	3
441840	4112343	5	11
440921	375671	4	7
21505859	705944	0	0
21002598	19075001	2	3
35205038	260139	4	7
36150807	46275444	2	3
36000000	317009	3	3
40244551	1551192	2	3
44345356	914335	0	0
44345613	1149196	0	0
44349993	1125315	0	0
44351738	1512674	0	0
45667415	738818	0	0
45625204	1177480	0	0
44343723	1129625	0	0
45638509	1589505	0	0
45663420	1129625	0	0
45630710	1768849	0	0
45708329	1177480	0	0
45670959	1119510	0	0
45686068	1112807	0	0
45685797	1119510	0	0
45684446	1125315	0	0
46291678	1119510	0	0
45696895	1119510	0	0
45797587	1115008	0	0
45802861	1125315	0	0
45787988	1125315	0	0
45896009	1119510	0	0
46319226	1521369	0	0
46304664	1102527	0	0
46304328	19078461	2	3
441840	40479768	8	11
440921	378001	4	7
21505958	1738521	0	0
21002597	46275444	2	3
35205038	40486433	4	7
36150855	40229134	2	3
36002139	438614	3	3
40244542	1115171	2	3
44345447	1361711	0	0
44345614	1545958	0	0
44349943	1125315	0	0
44351826	914335	0	0
45667420	1149196	0	0
45625317	1177480	0	0
44344016	1129625	0	0
45638513	1326303	0	0
45663552	1129625	0	0
45630651	723013	0	0
45705338	1177480	0	0
45671154	1119510	0	0
45686128	1112807	0	0
45685619	1119510	0	0
45684420	1125315	0	0
46291965	1119510	0	0
45696939	1119510	0	0
45797849	1713332	0	0
45802730	1125315	0	0
45787960	1125315	0	0
45895929	1119510	0	0
46319097	738818	0	0
46304739	1308738	0	0
46316571	19078461	2	3
441840	4134304	8	12
440921	78272	4	8
21505960	738818	0	0
21002597	1713671	2	3
35205038	4294548	4	7
36150928	1115171	2	3
36002139	4051466	3	3
40244494	40236824	2	3
44345453	1129625	0	0
44345738	1738521	0	0
44349950	1125315	0	0
44351830	1174888	0	0
45667672	1192710	0	0
45620594	1177480	0	0
44344216	1129625	0	0
45638555	967823	0	0
45663759	1129625	0	0
45630739	1124957	0	0
45705570	1177480	0	0
45669584	1119510	0	0
45682868	1112807	0	0
45636696	1119510	0	0
45684382	1125315	0	0
46291923	1119510	0	0
45697123	1119510	0	0
45797500	1115008	0	0
45802744	1125315	0	0
45788024	1125315	0	0
45896116	1119510	0	0
46319289	723013	0	0
46304376	1118084	0	0
46301068	19078461	2	3
441840	80180	4	6
135930	78272	4	9
21505963	1738521	0	0
21002052	19073188	2	3
36202157	4296204	4	7
36151098	1332419	2	3
36002139	4169137	3	3
40244527	40220386	2	3
44345455	1112807	0	0
44345546	1738521	0	0
44350164	1125315	0	0
44351834	1589505	0	0
45664781	975125	0	0
45620803	1177480	0	0
44340504	1129625	0	0
45638843	723013	0	0
45663579	1129625	0	0
45627515	1000560	0	0
45701954	1177480	0	0
45669521	1119510	0	0
45683106	1112807	0	0
45636699	1119510	0	0
45684379	1125315	0	0
46295785	1119510	0	0
45696933	1119510	0	0
45797596	1154343	0	0
45802841	1125315	0	0
45788037	1125315	0	0
45896118	1119510	0	0
46319284	1115008	0	0
46304378	1112807	0	0
46315409	19078461	2	3
441840	198809	4	10
440921	4134304	5	8
21505784	1332418	0	0
21002052	19073183	2	3
35205038	255848	4	6
36155328	40232448	2	3
36002139	4102123	3	3
40244529	1115171	2	3
44345457	1000560	0	0
44345548	1192710	0	0
44350171	1125315	0	0
44351913	1713332	0	0
45664805	1332418	0	0
45661826	1177480	0	0
44340464	1129625	0	0
45638637	1110410	0	0
45660384	1129625	0	0
45627780	1549786	0	0
45702098	1177480	0	0
45669669	1119510	0	0
45683290	1112807	0	0
45636741	1119510	0	0
45684397	1125315	0	0
46295795	1119510	0	0
45696892	1119510	0	0
45797600	1396131	0	0
45803044	1125315	0	0
45788130	1125315	0	0
45896167	1119510	0	0
46319060	1539403	0	0
46304754	1545958	0	0
46301149	19078461	2	3
441840	257012	4	10
4000610	81893	5	7
21505784	1545958	0	0
21003069	19078461	2	3
36102970	40481087	4	6
36155525	40231925	2	3
36002139	442116	3	3
40244685	40232448	2	3
44345264	1326303	0	0
44345551	738818	0	0
44349883	1125315	0	0
44352163	1332418	0	0
45664819	975125	0	0
45661869	1177480	0	0
44340542	1129625	0	0
45638624	1310149	0	0
45660505	1129625	0	0
45627780	1521369	0	0
45702242	1177480	0	0
45669480	1119510	0	0
45682955	1112807	0	0
45636831	1119510	0	0
45684389	1125315	0	0
46291522	1119510	0	0
45696936	1119510	0	0
45797684	1124300	0	0
45803052	1125315	0	0
45788148	1125315	0	0
45804104	1119510	0	0
46319068	1308738	0	0
46304533	967823	0	0
46314902	19078461	2	3
441840	44782520	4	7
440921	81151	5	7
21505757	701322	0	0
21003069	40229134	2	3
35702767	4166224	4	6
36155339	19133873	2	3
36200000	134438	3	3
40244644	1127433	2	3
44345055	1102527	0	0
44345563	1746114	0	0
44350088	1125315	0	0
44351784	715997	0	0
45664822	1174888	0	0
45662011	1177480	0	0
44340481	1129625	0	0
45638626	1332418	0	0
45660462	1129625	0	0
45627780	19127890	0	0
45702155	1177480	0	0
45669500	1119510	0	0
45679898	1112807	0	0
45636835	1119510	0	0
45684515	1125315	0	0
46291711	1119510	0	0
45697056	1119510	0	0
45797851	1500211	0	0
45803055	1125315	0	0
45788134	1125315	0	0
45804105	1119510	0	0
46319075	1307863	0	0
46304973	1717327	0	0
46310390	19078461	2	3
441840	4043241	3	12
376337	378001	5	7
21505770	1129625	0	0
21003069	1127433	2	3
36203062	4155034	4	6
36155660	35605482	2	3
36154849	1177480	0	0
40244623	1127433	2	3
44345358	967823	0	0
44345563	1741122	0	0
44350207	1125315	0	0
44351787	1589505	0	0
45664795	738818	0	0
45661755	1177480	0	0
44340032	1129625	0	0
45635347	1154343	0	0
45658374	1129625	0	0
45627781	1305058	0	0
45702220	1177480	0	0
45669505	1119510	0	0
45679827	1112807	0	0
45636961	1119510	0	0
45684588	1125315	0	0
46291715	1119510	0	0
45696984	1119510	0	0
45797699	1396131	0	0
45802762	1125315	0	0
45788065	1125315	0	0
45804122	1119510	0	0
46319079	975125	0	0
46304982	1154029	0	0
46309630	19078461	2	3
441840	4084167	3	6
376337	375671	5	7
21001773	1107830	0	0
21003069	19059056	2	3
36203062	4113008	4	6
36155495	40163554	2	3
36154981	1112807	0	0
40244700	1551192	2	3
44345312	1759842	0	0
44345569	1124957	0	0
44350089	1125315	0	0
44351937	1332418	0	0
45664798	1305058	0	0
45658272	1177480	0	0
44340631	1129625	0	0
45635348	705944	0	0
45658398	1129625	0	0
45627569	1589505	0	0
45699093	1177480	0	0
45669772	1119510	0	0
45658285	1192710	0	0
45637004	1119510	0	0
45684475	1125315	0	0
46291717	1119510	0	0
45697041	1119510	0	0
45797852	1149196	0	0
45800132	1125315	0	0
45787972	1125315	0	0
45804123	1119510	0	0
46318797	1332418	0	0
46304684	1322184	0	0
46309819	19078461	2	3
441840	439777	3	8
4000610	4285898	5	6
21001775	1119510	0	0
21003069	19019273	2	3
35702124	4112343	4	5
36155637	1127433	2	3
36154984	1149380	0	0
40244679	40232448	2	3
44345312	1713332	0	0
44341543	1000560	0	0
44350124	1125315	0	0
44351973	1124300	0	0
45664748	19127890	0	0
45655888	1177480	0	0
44340521	1129625	0	0
45635251	738818	0	0
45657620	1129625	0	0
45627569	1549786	0	0
45699264	1177480	0	0
45780878	1119510	0	0
45703633	1192710	0	0
45682695	1119510	0	0
45681345	1125315	0	0
46291310	1119510	0	0
45697081	1119510	0	0
45797856	723013	0	0
45800137	1125315	0	0
45788219	1125315	0	0
45804042	1119510	0	0
46319428	1115008	0	0
46304961	1192710	0	0
46304046	40223768	2	3
444089	4285898	5	6
440921	4048695	5	6
21001775	1343916	0	0
21003069	1115171	2	3
21602543	40221415	4	5
36155476	40236824	2	3
36154987	1154343	0	0
40244680	1127433	2	3
44345095	1124300	0	0
44341545	1177480	0	0
44349973	1125315	0	0
44351362	1310149	0	0
45664748	1589505	0	0
45655759	1177480	0	0
44340532	1129625	0	0
45635254	1107830	0	0
45657848	1129625	0	0
45627300	1149196	0	0
45699243	1177480	0	0
45780824	1119510	0	0
45704007	1192710	0	0
45682773	1119510	0	0
45681444	1125315	0	0
46291399	1119510	0	0
45697302	1119510	0	0
45797857	1112807	0	0
45800140	1125315	0	0
45788226	1125315	0	0
45803750	1119510	0	0
46319115	1174888	0	0
46304968	975125	0	0
45803595	40223768	2	3
444089	81893	6	7
440921	4066995	5	6
21001773	1129625	0	0
21003069	19019979	2	3
36102149	258780	4	5
36155609	40231925	2	3
36154864	1713332	0	0
40244879	40162522	2	3
44345098	1149380	0	0
44341263	1741122	0	0
44350071	1125315	0	0
44351976	975125	0	0
45664748	1549786	0	0
45655918	1177480	0	0
44340556	1129625	0	0
45635260	1115008	0	0
45657958	1129625	0	0
45627713	1124300	0	0
45699360	1177480	0	0
45781032	1119510	0	0
45704045	1192710	0	0
45682977	1119510	0	0
45681454	1125315	0	0
46291411	1119510	0	0
45693880	1119510	0	0
45797861	738818	0	0
45800102	1125315	0	0
45788087	1125315	0	0
45804212	1119510	0	0
46318938	1545958	0	0
46304764	1112807	0	0
45675324	19078461	2	3
4028071	4285898	7	8
133468	4134304	5	6
21001773	738818	0	0
21003069	1127078	2	3
36009717	4066995	4	5
36157793	1545959	2	3
36154864	1759842	0	0
40244753	1115171	2	3
44345100	1759842	0	0
44341263	1746114	0	0
44350075	1125315	0	0
44351738	1549786	0	0
45664753	1154343	0	0
45651865	1177480	0	0
44340196	1129625	0	0
45635261	1107830	0	0
45654108	1129625	0	0
45627718	738818	0	0
45699406	1177480	0	0
45781048	1119510	0	0
45651470	1192710	0	0
45633682	1119510	0	0
45681473	1125315	0	0
46242680	1119510	0	0
45693897	1119510	0	0
45797920	1115008	0	0
45800114	1125315	0	0
45788240	1125315	0	0
45804200	1119510	0	0
46319141	1322184	0	0
46304776	1326303	0	0
46309370	19078461	2	3
432795	40479422	7	8
133468	81151	5	6
21001494	1551099	0	0
21003079	19078461	2	3
36009717	4048695	4	5
36159029	46233710	2	3
36155201	1153428	0	0
40244754	1115171	2	3
44345100	1713332	0	0
44341282	1713332	0	0
44350127	1125315	0	0
44352016	1124300	0	0
45664874	1107830	0	0
45649268	1177480	0	0
44340219	1129625	0	0
45635439	1343916	0	0
45654203	1129625	0	0
45627303	1192710	0	0
45695845	1177480	0	0
45781051	1119510	0	0
45651444	1192710	0	0
45633465	1119510	0	0
45681583	1125315	0	0
46242767	1119510	0	0
45693955	1119510	0	0
45797927	920293	0	0
45800365	1125315	0	0
45788246	1125315	0	0
45803922	1119510	0	0
46319121	1332418	0	0
46304778	1118084	0	0
46317375	19078461	2	3
432795	40479768	7	8
133468	4230399	5	6
21001057	1129625	0	0
21003079	1127078	2	3
35205038	4283893	4	5
36151501	40223768	2	3
36155154	1129625	0	0
36702238	381316	2	3
40250213	1112807	0	0
44341282	1759842	0	0
44349839	1125315	0	0
44352024	1332418	0	0
45664758	975125	0	0
44778148	1112807	0	0
44340223	1129625	0	0
45635185	1501700	0	0
45654305	1129625	0	0
45627308	1110410	0	0
45695923	1177480	0	0
45781145	1119510	0	0
45648593	1192710	0	0
45633756	1119510	0	0
45681103	1125315	0	0
46242769	1119510	0	0
45694083	1119510	0	0
45794788	1589505	0	0
45800120	1125315	0	0
45788070	1125315	0	0
45803931	1119510	0	0
46319365	738818	0	0
46304570	1322184	0	0
45650766	19078461	2	3
432795	81151	6	8
376337	378419	5	6
21001070	1129625	0	0
21003079	1127433	2	3
21602537	40224132	4	5
36159364	19075001	2	3
36155161	1112807	0	0
36702245	378419	2	3
40250213	1129625	0	0
44341400	1129625	0	0
44350186	1125315	0	0
44344054	1192710	0	0
45664961	1154029	0	0
44778075	1112807	0	0
44340596	1129625	0	0
45635561	1539403	0	0
45654142	1129625	0	0
45627309	1717327	0	0
45697705	1177480	0	0
45781064	1119510	0	0
45648785	1192710	0	0
45633757	1119510	0	0
45681198	1125315	0	0
46242773	1119510	0	0
45694085	1119510	0	0
45794790	1367571	0	0
45800379	1125315	0	0
45788093	1125315	0	0
45798790	1119510	0	0
46319373	1000560	0	0
46304786	1000560	0	0
45650673	19078461	2	3
432795	4230399	6	8
376208	40479768	5	6
21001099	723013	0	0
21003079	19133768	2	3
36202155	4230399	4	5
36158536	40223768	2	3
36154908	1545958	0	0
40250232	19079524	2	3
40250215	1177480	0	0
44341492	1129625	0	0
44349588	1125315	0	0
44343781	1539403	0	0
45664968	1192710	0	0
44357830	1112807	0	0
44337284	1129625	0	0
45635286	1149196	0	0
45654518	1129625	0	0
45627529	1174888	0	0
45695958	1177480	0	0
45780857	1119510	0	0
45649131	1192710	0	0
45633887	1119510	0	0
45681502	1125315	0	0
46242856	1119510	0	0
45693770	1119510	0	0
45794794	19003953	0	0
45800251	1125315	0	0
45788159	1125315	0	0
45798928	1119510	0	0
46319146	1192710	0	0
46305276	1549786	0	0
500003101	380378	1	1
432795	4134304	6	9
376208	40479422	5	6
21001099	791967	0	0
21003079	40162522	2	3
21604182	40220386	4	5
36157962	1107882	2	3
36154931	1112807	0	0
40244611	40228214	2	3
40250216	1367571	0	0
44344543	1177480	0	0
44350150	1125315	0	0
44343787	1713332	0	0
45664998	791967	0	0
44357923	1112807	0	0
44337459	1129625	0	0
45635506	1326303	0	0
45654241	1129625	0	0
45627530	738818	0	0
45693082	1177480	0	0
45778549	1119510	0	0
45645607	1192710	0	0
45633908	1119510	0	0
46275426	46275444	1	1
46242860	1119510	0	0
45694158	1119510	0	0
45794853	1322184	0	0
45800255	1125315	0	0
45788162	1125315	0	0
45798944	1119510	0	0
46319150	738818	0	0
46305189	1192710	0	0
500002401	313217	1	1
255919	378001	6	8
4000738	4198190	5	5
21001092	740275	0	0
21003079	1115171	2	3
35802832	4280726	4	5
36155696	40223768	2	3
36154931	1192710	0	0
40244594	19078461	2	3
40249001	1119510	0	0
44344360	740275	0	0
44349669	1125315	0	0
44343787	1759842	0	0
45665071	738818	0	0
44358214	1112807	0	0
44337465	1129625	0	0
45635248	1149196	0	0
45652244	1129625	0	0
45627610	19127890	0	0
45692804	1177480	0	0
45778557	1119510	0	0
45642704	1192710	0	0
45679700	1119510	0	0
46275443	46275444	1	1
46242804	1119510	0	0
45694041	1119510	0	0
45794855	738818	0	0
45800074	1125315	0	0
45788286	1125315	0	0
45798482	1119510	0	0
46319575	1332418	0	0
46304706	1551099	0	0
46316337	19079524	1	1
444112	133834	6	7
372887	375671	5	5
21001054	1129625	0	0
21003079	19059056	2	3
35802832	40486433	4	5
36156563	1107882	2	3
36154949	1107830	0	0
40244689	19078461	2	3
40249024	1308738	0	0
44344363	975125	0	0
44350044	1125315	0	0
44343804	738818	0	0
45664317	1115008	0	0
44358220	1112807	0	0
44337332	1129625	0	0
45635508	1149196	0	0
45651034	1129625	0	0
45627610	1512674	0	0
45692936	1177480	0	0
45778560	1119510	0	0
45642811	1192710	0	0
45679588	1119510	0	0
45680892	1125315	0	0
46242816	1119510	0	0
45694131	1119510	0	0
45797005	1728416	0	0
45800382	1125315	0	0
45788359	1125315	0	0
45799006	1119510	0	0
46319622	1738521	0	0
46304937	1124300	0	0
46316716	46275916	1	1
432795	4048695	6	7
372887	378001	5	5
21001107	740275	0	0
21003079	19019979	2	3
35900000	196456	4	5
36152353	40223768	2	3
36155025	1112807	0	0
40244733	19078461	2	3
40249028	1137529	0	0
44344370	1174888	0	0
44342478	1125315	0	0
44343987	1501700	0	0
45664407	1153428	0	0
44358627	1112807	0	0
45620277	1129625	0	0
45635449	1174888	0	0
45650994	1129625	0	0
45627610	1549786	0	0
45693201	1177480	0	0
45778613	1119510	0	0
45642650	1192710	0	0
45630780	1119510	0	0
45681148	1125315	0	0
46242783	1119510	0	0
45694015	1119510	0	0
45797146	1549786	0	0
45800235	1125315	0	0
46294030	1125315	0	0
45798959	1119510	0	0
46319625	1149196	0	0
46305276	1589505	0	0
46310566	46275916	1	1
432795	4066995	6	7
440921	4156265	5	5
21001102	740275	0	0
21003079	19019273	2	3
21604180	836654	4	4
36212328	19128065	2	3
36155027	1177480	0	0
40244765	19078461	2	3
40249028	1149380	0	0
44344374	1129625	0	0
44342457	1125315	0	0
44343989	1713332	0	0
45664422	1107830	0	0
44344054	1112807	0	0
45620169	1129625	0	0
45635269	1501700	0	0
45651217	1129625	0	0
45627616	1000560	0	0
45693183	1177480	0	0
45778720	1119510	0	0
45688662	1192710	0	0
45630769	1119510	0	0
45681003	1125315	0	0
46240483	1119510	0	0
45693983	1119510	0	0
45797146	19127890	0	0
45800065	1125315	0	0
46294130	1125315	0	0
45799030	1119510	0	0
46319637	1728416	0	0
46305279	975125	0	0
46322392	40171902	1	1
432795	4237458	6	7
4000610	440448	5	5
21001116	1112807	0	0
21003079	40231925	2	3
36203055	378001	4	4
36212328	19127904	2	3
36155113	933724	0	0
40244766	19078461	2	3
40250176	19127890	0	0
44344308	1110410	0	0
44342277	1125315	0	0
44343831	1149196	0	0
45664322	1124957	0	0
44344202	1112807	0	0
45620007	1129625	0	0
45635425	1545958	0	0
45647997	1129625	0	0
45627620	1192710	0	0
45693254	1177480	0	0
45778678	1119510	0	0
45685800	1192710	0	0
45630978	1119510	0	0
45681124	1125315	0	0
46240609	1119510	0	0
45691200	1119510	0	0
45797146	1589505	0	0
45800066	1125315	0	0
46294131	1125315	0	0
45799038	1119510	0	0
46319639	740275	0	0
46304801	1154343	0	0
46321623	46275916	1	1
193460	40479768	6	6
432545	4116491	5	5
21001181	1124300	0	0
21602868	19074843	2	5
36009725	4048171	4	4
36212328	19127918	2	3
36155105	1343916	0	0
40244748	19078461	2	3
40250176	1548195	0	0
44344639	1738521	0	0
44342422	1125315	0	0
44344107	1713332	0	0
45664329	1174888	0	0
45640267	1112807	0	0
45620373	1129625	0	0
45635426	738818	0	0
45647918	1129625	0	0
45627629	791967	0	0
45689837	1177480	0	0
45778925	1119510	0	0
45685820	1192710	0	0
45628171	1119510	0	0
45680966	1125315	0	0
46240780	1119510	0	0
45691204	1119510	0	0
45797123	1112807	0	0
45800067	1125315	0	0
46293875	1125315	0	0
45793531	1119510	0	0
46319519	1107830	0	0
46321014	1332418	0	0
46309302	19079524	1	1
193460	40479422	6	6
255919	380378	5	5
21001116	1124300	0	0
21602868	19074841	2	5
35902135	196456	4	4
36212328	19128263	2	3
36155107	1129625	0	0
40244595	19078461	2	3
40250176	19054876	0	0
44344562	1112807	0	0
44342423	1125315	0	0
44343842	1589505	0	0
45664331	975125	0	0
44358649	1112807	0	0
44362221	1129625	0	0
45635633	1107830	0	0
45648133	1129625	0	0
45627635	1124957	0	0
45690050	1177480	0	0
45707447	1119510	0	0
45685758	1192710	0	0
45628403	1119510	0	0
45680974	1125315	0	0
46240698	1119510	0	0
45691150	1119510	0	0
45797124	1115008	0	0
45800291	1125315	0	0
46293771	1125315	0	0
45793548	1119510	0	0
46319524	1310149	0	0
46321017	1192710	0	0
45675474	19079524	1	1
432795	4156265	6	6
375239	4043241	5	5
21001116	1115008	0	0
21604792	40222846	2	5
35202461	4051466	4	4
36212328	40221415	2	3
36155174	1713332	0	0
40244591	19078461	2	3
40250176	1589505	0	0
44344564	1129625	0	0
44342431	1125315	0	0
44343842	19127890	0	0
45664346	1361711	0	0
45658808	1112807	0	0
44362130	1129625	0	0
45635362	1332418	0	0
45648209	1129625	0	0
45627639	1107830	0	0
45690052	1177480	0	0
45707524	1119510	0	0
45636696	1192710	0	0
45627842	1119510	0	0
45681014	1125315	0	0
46240720	1119510	0	0
45691206	1119510	0	0
45797127	1112807	0	0
45800152	1125315	0	0
46293779	1125315	0	0
45793569	1119510	0	0
46319169	1192710	0	0
46321409	1192710	0	0
44360760	1112807	0	0
432795	375671	5	8
4004038	40492359	5	5
21001119	705944	0	0
21604792	836659	2	5
21602566	19128065	4	4
36151169	40228214	2	3
36155242	791967	0	0
40244593	19078461	2	3
40250176	1549786	0	0
44344317	1177480	0	0
44342338	1125315	0	0
44343842	1549786	0	0
45664495	1137529	0	0
45658470	1112807	0	0
44362270	1129625	0	0
45635306	1149196	0	0
45648212	1129625	0	0
45627642	975125	0	0
45690226	1177480	0	0
45707141	1119510	0	0
45636831	1192710	0	0
45676586	1119510	0	0
45681062	1125315	0	0
45681150	1129625	0	0
45691093	1119510	0	0
45797128	1112807	0	0
45800154	1125315	0	0
46294147	1125315	0	0
45793504	1119510	0	0
46319142	1738521	0	0
46321556	1154029	0	0
44361178	1124957	0	0
432795	78272	5	9
432250	198199	5	5
21001190	975125	0	0
21604606	19078924	2	5
35802832	4285898	4	4
36152424	1107882	2	3
36155174	1759842	0	0
40244725	19078461	2	3
40250177	975125	0	0
44344446	1177480	0	0
44342518	1125315	0	0
44343913	1326303	0	0
45649824	19079524	1	1
45658577	1112807	0	0
44362288	1129625	0	0
45635514	1110410	0	0
45648223	1129625	0	0
45627699	1174888	0	0
45690195	1177480	0	0
45707222	1119510	0	0
45636962	1192710	0	0
45676170	1119510	0	0
45681142	1125315	0	0
45681002	1129625	0	0
45690993	1119510	0	0
45797134	1124957	0	0
45800297	1125315	0	0
46293884	1125315	0	0
45793575	1119510	0	0
46319538	1192710	0	0
46320884	1154343	0	0
44361180	1149196	0	0
255919	4001336	5	7
432250	433125	5	5
21001156	914335	0	0
21603366	19029476	2	5
36203060	40479768	4	4
36155343	1107882	2	3
36155188	1738521	0	0
40248956	1551192	2	3
40254301	19054876	0	0
44344700	1515774	0	0
44342501	1125315	0	0
44343919	1107830	0	0
45641038	19079524	1	1
45658737	1112807	0	0
44362672	1129625	0	0
45635533	738818	0	0
45648156	1129625	0	0
45627325	1713332	0	0
45690270	1177480	0	0
45707598	1119510	0	0
45633465	1192710	0	0
45676204	1119510	0	0
45681269	1125315	0	0
45680972	1129625	0	0
45691366	1119510	0	0
45796916	1124957	0	0
45802216	1125315	0	0
46293966	1125315	0	0
45793672	1119510	0	0
46239789	1000560	0	0
46321562	914335	0	0
44361066	914335	0	0
432795	4278672	5	7
432250	28060	5	5
21000630	1551099	0	0
21604182	19023398	2	5
4300185	4337611	4	4
36158660	1107882	2	3
36155244	1326303	0	0
37522270	4163971	2	7
40478878	40478878	0	0
44344700	19127890	0	0
44344610	1125315	0	0
44343995	1343916	0	0
45640904	19079524	1	1
45658622	1112807	0	0
44362692	1129625	0	0
45635565	1149196	0	0
45648252	1129625	0	0
45627325	1759842	0	0
45686801	1177480	0	0
45704749	1119510	0	0
45633756	1192710	0	0
45673472	1119510	0	0
45681221	1125315	0	0
45680977	1129625	0	0
45691013	1119510	0	0
45796920	1539403	0	0
45802291	1125315	0	0
46293543	1125315	0	0
45793604	1119510	0	0
46239804	1000560	0	0
46321198	1000560	0	0
44361226	975125	0	0
432795	4152936	5	7
133468	4035415	5	5
21000643	1515774	0	0
21604182	782047	2	5
4100932	40479422	4	4
36158556	1107882	2	3
36155256	1713332	0	0
37502354	4336464	2	8
40248957	1137529	0	0
44344700	1549786	0	0
44344612	1125315	0	0
44343996	1332418	0	0
45625798	19079524	1	1
45658947	1112807	0	0
44355092	1129625	0	0
45635566	791967	0	0
45644847	1129625	0	0
45627344	1192710	0	0
45688691	1177480	0	0
45704727	1119510	0	0
45633757	1192710	0	0
45624956	1119510	0	0
45681214	1125315	0	0
45681175	1129625	0	0
45691165	1119510	0	0
45796823	1154343	0	0
45802292	1125315	0	0
46293892	1125315	0	0
45793779	1119510	0	0
46239759	1149380	0	0
46321116	1124300	0	0
44361228	1119510	0	0
432795	4059173	5	7
376208	4048171	5	5
21000630	975125	0	0
21600492	35605482	2	4
4160875	78272	4	4
36151836	1107882	2	3
36155150	1115008	0	0
36703532	4066995	2	6
40232448	40232448	0	0
44344701	1129625	0	0
44344856	1125315	0	0
44343861	975125	0	0
45621254	46275916	1	1
45652160	1112807	0	0
44355015	1129625	0	0
45635595	1174888	0	0
45644904	1129625	0	0
45627702	738818	0	0
45688700	1177480	0	0
45704824	1119510	0	0
45633742	1192710	0	0
45625027	1119510	0	0
45681229	1125315	0	0
45681073	1129625	0	0
45691171	1119510	0	0
45797137	1545958	0	0
45802436	1125315	0	0
46293895	1125315	0	0
45793624	1119510	0	0
46239815	1174888	0	0
46321313	1107830	0	0
44361187	1115008	0	0
4022201	78272	5	6
4003043	40492359	6	6
21000637	1551099	0	0
21602882	19074843	1	4
4123446	4107731	4	4
36158458	1107882	2	3
36155257	1129625	0	0
36702251	380378	2	5
40174880	40174880	0	0
44344451	723013	0	0
44342656	1125315	0	0
44344164	1124957	0	0
45621254	19079524	1	1
45652288	1112807	0	0
45655145	1129625	0	0
45635599	1115008	0	0
45644912	1129625	0	0
45627708	975125	0	0
45684084	1177480	0	0
45704882	1119510	0	0
45633905	1192710	0	0
45670612	1119510	0	0
45675691	1125315	0	0
45681338	1129625	0	0
45688107	1119510	0	0
45797179	740275	0	0
45802278	1125315	0	0
46294050	1125315	0	0
45793854	1119510	0	0
46239894	705944	0	0
46321343	791967	0	0
44361096	933724	0	0
432795	4109685	5	6
442628	78272	6	6
21000635	975125	0	0
21602882	19074841	1	4
4042678	4336464	3	4
36151439	1107882	2	3
36154907	1107830	0	0
36702254	375671	2	5
37302323	4296204	4	8
44344459	1192710	0	0
44342669	1125315	0	0
44344122	738818	0	0
45638155	19079524	1	1
44344469	1112807	0	0
45655156	1129625	0	0
45635650	1738521	0	0
45644868	1129625	0	0
45627765	708298	0	0
45684207	1177480	0	0
45704564	1119510	0	0
45630605	1192710	0	0
45670470	1119510	0	0
45675695	1125315	0	0
45676065	1129625	0	0
45688140	1119510	0	0
45797184	715997	0	0
45800399	1125315	0	0
46294239	1125315	0	0
45793632	1119510	0	0
46239897	1115008	0	0
46321348	1738521	0	0
44361361	1112807	0	0
4020346	4134304	5	6
135930	4059173	6	7
21000643	1548195	0	0
21604793	19077572	1	4
4038678	4285898	3	4
36212329	19128263	2	3
36154695	1307863	0	0
36702251	4029498	2	4
37202316	4283893	4	7
44344603	1519936	0	0
44364064	1125315	0	0
44343808	914335	0	0
45625904	19079524	1	1
44344618	1112807	0	0
45655159	1129625	0	0
45635652	1309944	0	0
45644966	1129625	0	0
45627776	1107830	0	0
45684165	1177480	0	0
45704891	1119510	0	0
45627842	1192710	0	0
45670621	1119510	0	0
45675832	1125315	0	0
45672885	1129625	0	0
45688227	1119510	0	0
45797188	738818	0	0
45797323	1125315	0	0
46294396	1125315	0	0
45793804	1119510	0	0
46240006	1551099	0	0
46321353	1309944	0	0
44361362	1192710	0	0
4022201	4230399	5	5
376106	4043241	6	7
21000643	1512674	0	0
21604416	19074679	1	4
4180169	80809	3	4
36212329	40221415	2	3
36154782	1112807	0	0
36703523	4029498	1	3
36702247	4132546	4	7
44344603	1549786	0	0
44364071	1125315	0	0
44344029	975125	0	0
45622659	19079524	1	1
44344630	1112807	0	0
45655321	1129625	0	0
45635658	1124300	0	0
45644892	1129625	0	0
45627470	1549786	0	0
45684220	1177480	0	0
45704965	1119510	0	0
45676586	1192710	0	0
45670718	1119510	0	0
45675754	1125315	0	0
45672894	1129625	0	0
45688208	1119510	0	0
45797190	738818	0	0
45797326	1125315	0	0
46294075	1125315	0	0
45793691	1119510	0	0
46239838	738818	0	0
46321354	1192710	0	0
44361362	1119510	0	0
432795	4155034	5	5
440921	40479422	6	7
21000643	1589505	0	0
21604798	40222846	1	4
4078521	44783196	3	4
36212329	19128065	2	3
36154785	1332418	0	0
36703523	380378	1	4
36703500	4001336	4	7
44341613	1154029	0	0
44364196	1125315	0	0
44344030	1124957	0	0
45665003	19079524	1	1
44344647	1112807	0	0
44347846	1129625	0	0
45635324	1501700	0	0
45645115	1129625	0	0
45627470	19127890	0	0
45684135	1177480	0	0
45704870	1119510	0	0
45676204	1192710	0	0
45670525	1119510	0	0
45675636	1125315	0	0
45673250	1129625	0	0
45688334	1119510	0	0
45797197	1149380	0	0
45797424	1125315	0	0
46294471	1125315	0	0
45788176	1119510	0	0
46239846	1746114	0	0
46321499	1521369	0	0
44361213	975125	0	0
432795	4296204	5	5
255919	4280726	6	8
21000643	1549786	0	0
21602840	19133905	1	4
4032251	4047491	3	4
36212329	19128022	2	3
36154786	1332418	0	0
36703534	375671	1	4
37203758	257012	4	7
44341602	738818	0	0
44364210	1125315	0	0
44344246	723013	0	0
45638235	19079524	1	1
44341082	1112807	0	0
44347724	1129625	0	0
45635534	1310149	0	0
45643039	1129625	0	0
45627470	1589505	0	0
45684368	1177480	0	0
45704970	1119510	0	0
45625039	1192710	0	0
45670429	1119510	0	0
45675643	1125315	0	0
45673255	1129625	0	0
45688431	1119510	0	0
45794963	975125	0	0
45797425	1125315	0	0
46294118	1125315	0	0
45788463	1119510	0	0
46239846	1741122	0	0
46321499	1595799	0	0
44361216	1174888	0	0
4027553	258780	5	5
376208	133834	6	6
21000633	975125	0	0
21604635	19078924	1	4
4309188	28060	3	4
36212329	19127918	2	3
36155061	1115008	0	0
40240628	19112599	1	1
36718338	378001	4	7
44341622	1129625	0	0
44364192	1125315	0	0
44344126	1124957	0	0
45652828	19079524	1	1
45643157	1112807	0	0
44348329	1129625	0	0
45632309	1107830	0	0
45643121	1129625	0	0
45627473	1310149	0	0
45684172	1177480	0	0
45705018	1119510	0	0
45670102	1192710	0	0
45669011	1119510	0	0
45675909	1125315	0	0
45785114	1129625	0	0
45684961	1119510	0	0
45794966	1192710	0	0
45797540	1125315	0	0
46294201	1125315	0	0
45788517	1119510	0	0
46239854	705944	0	0
46321499	1549786	0	0
44360744	1192710	0	0
432586	4043241	5	5
376337	4043241	7	8
21000637	975125	0	0
21602819	19073183	1	4
4045900	4058899	3	4
36212329	19127904	2	3
36155203	1149196	0	0
40090536	836659	1	1
36718338	375671	4	7
44341626	1177480	0	0
44364227	1125315	0	0
44344001	975125	0	0
45664938	19079524	1	1
45643103	1112807	0	0
44348091	1129625	0	0
45632312	1115008	0	0
45642229	1129625	0	0
45627417	967823	0	0
45680940	1177480	0	0
45701268	1119510	0	0
45670470	1192710	0	0
45669057	1119510	0	0
45675763	1125315	0	0
45785009	1129625	0	0
45684981	1119510	0	0
45794995	1149196	0	0
45797568	1125315	0	0
46294153	1125315	0	0
45788444	1119510	0	0
46239860	1174888	0	0
46321373	933724	0	0
44360744	1112807	0	0
255919	372328	5	5
133468	40479422	7	7
21000633	1551099	0	0
21604565	19057271	1	4
4042650	44783196	2	4
36152038	1332419	2	3
36154952	1759842	0	0
40000858	19057271	1	1
36702247	4029498	4	5
44341633	1746114	0	0
44364166	1125315	0	0
44344074	1343916	0	0
45637564	19079524	1	1
45643319	1112807	0	0
44347979	1129625	0	0
45632313	967823	0	0
45642323	1129625	0	0
45627806	975125	0	0
45654944	1129625	0	0
45701272	1119510	0	0
45670621	1192710	0	0
45669076	1119510	0	0
45675849	1125315	0	0
45785020	1129625	0	0
45685059	1119510	0	0
45794999	1149380	0	0
45797544	1125315	0	0
46294155	1125315	0	0
45788453	1119510	0	0
46239813	1746114	0	0
46321084	1112807	0	0
44360744	1119510	0	0
432545	4294548	5	5
133468	40479768	7	7
21000640	1515774	0	0
21604565	19076374	1	4
141253	140673	1	1
36151270	40228214	2	3
36154952	1713332	0	0
40001198	43012754	1	1
37503891	4198190	4	5
44341633	1741122	0	0
44364274	1125315	0	0
44344007	1149380	0	0
45638239	46275916	1	1
45643388	1112807	0	0
44348107	1129625	0	0
45632319	1308738	0	0
45639212	1129625	0	0
45627807	1192710	0	0
45654831	1129625	0	0
45701365	1119510	0	0
45670718	1192710	0	0
45669035	1119510	0	0
45676064	1125315	0	0
45785038	1129625	0	0
45685155	1119510	0	0
45795003	1112807	0	0
45797552	1125315	0	0
46294301	1125315	0	0
45788426	1119510	0	0
46239813	1741122	0	0
46321483	1000560	0	0
44360747	1115008	0	0
4022923	40479768	5	5
1766600	1125315	0	0
21000640	1549786	0	0
21502572	19128009	1	1
257007	40486433	1	1
36158036	40228214	2	3
36155072	1107830	0	0
40773752	3002385	1	1
40779561	3010813	4	5
44341618	1545958	0	0
44364248	1125315	0	0
44344260	1149196	0	0
45638239	19079524	1	1
45643427	1112807	0	0
44348066	1129625	0	0
45632321	933724	0	0
45635878	1129625	0	0
45627813	1110410	0	0
45655294	1129625	0	0
45701401	1119510	0	0
45669057	1192710	0	0
45669106	1119510	0	0
45675899	1125315	0	0
45785251	1129625	0	0
45685064	1119510	0	0
45794981	1501700	0	0
45797437	1125315	0	0
46294384	1125315	0	0
45788524	1119510	0	0
46239944	738818	0	0
46320949	723013	0	0
44361237	967823	0	0
4022923	40479422	5	5
1766606	975125	0	0
21000640	1548195	0	0
21502574	19132304	1	1
257007	4280726	1	1
36150842	19075601	2	3
36155213	1124957	0	0
40773762	3001488	1	1
36702245	4043241	4	5
44341645	1107830	0	0
44364289	1125315	0	0
44344137	1539403	0	0
45646771	19079524	1	1
45643208	1112807	0	0
44341028	1129625	0	0
45632324	738818	0	0
45635908	1129625	0	0
45627680	738818	0	0
45701739	1129625	0	0
45701179	1119510	0	0
45669215	1192710	0	0
45669156	1119510	0	0
45676100	1125315	0	0
45784962	1129625	0	0
45684944	1119510	0	0
45794988	1110410	0	0
45797628	1125315	0	0
46294485	1125315	0	0
45788531	1119510	0	0
46321908	967823	0	0
46321621	975125	0	0
44361247	738818	0	0
3001247	3001247	0	0
1766553	1308738	0	0
21000640	1589505	0	0
21502574	46221626	1	1
257011	4112343	1	1
36152183	19075601	2	3
36155215	975125	0	0
40774001	3019550	1	1
36718338	378419	4	6
44341606	1549786	0	0
44364358	1125315	0	0
44344070	738818	0	0
45637663	19079524	1	1
45642997	1112807	0	0
44341536	1129625	0	0
45632325	1118084	0	0
45635911	1129625	0	0
45627793	1768849	0	0
45701808	1129625	0	0
45703452	1119510	0	0
45669168	1192710	0	0
45669289	1119510	0	0
45676104	1125315	0	0
45784968	1129625	0	0
45685077	1119510	0	0
45795013	1174888	0	0
45797458	1125315	0	0
46294488	1125315	0	0
45788684	1119510	0	0
46321915	1549786	0	0
46321085	1713332	0	0
44361247	1119510	0	0
3010813	3010813	0	0
255919	4043241	8	9
21000641	1521369	0	0
21502554	1713332	1	1
257011	4294548	1	1
36159247	19075601	2	3
36154962	705944	0	0
40776870	3019406	1	1
36702247	381316	4	6
44341606	19127890	0	0
44364364	1125315	0	0
44344182	1124300	0	0
45643845	19079524	1	1
45640470	1112807	0	0
44340698	1129625	0	0
45632448	1738521	0	0
45636139	1129625	0	0
45624310	1549786	0	0
45701930	1129625	0	0
45703456	1119510	0	0
45669158	1192710	0	0
45669309	1119510	0	0
45676014	1125315	0	0
45784972	1129625	0	0
45685049	1119510	0	0
45794976	1107830	0	0
45797576	1125315	0	0
46294219	1125315	0	0
46298169	1119510	0	0
46321915	1518198	0	0
46321572	701322	0	0
44361249	738818	0	0
3023103	3023103	0	0
441840	4237458	4	10
21000641	1548195	0	0
21500290	1107830	1	1
192353	196456	1	1
36155552	1539411	2	3
36154801	1153428	0	0
40776533	3027970	1	1
37522357	4336464	4	6
44341606	1515774	0	0
44356899	1125315	0	0
44344290	1308738	0	0
45637571	19079524	1	1
45640460	1112807	0	0
44340705	1129625	0	0
45632301	1124300	0	0
45636268	1129625	0	0
45624310	1521369	0	0
45698765	1129625	0	0
45701553	1119510	0	0
45669161	1192710	0	0
45669310	1119510	0	0
45676016	1125315	0	0
45786249	1129625	0	0
45685083	1119510	0	0
45794977	1124957	0	0
45797577	1125315	0	0
46294234	1125315	0	0
46298250	1119510	0	0
46322425	1124300	0	0
46321577	1124957	0	0
44361249	1119510	0	0
3002385	3002385	0	0
441840	40480160	4	10
21000101	1759842	0	0
21500290	1150836	1	1
4174520	4066995	1	1
36155578	1539411	2	3
36155227	1110410	0	0
40776614	3004501	1	1
40779561	3026361	4	6
44341723	1501700	0	0
44356912	1125315	0	0
44344239	705944	0	0
45643889	19079524	1	1
45640611	1112807	0	0
44340732	1129625	0	0
45632397	791967	0	0
45635932	1129625	0	0
45624345	1192710	0	0
45698766	1129625	0	0
45698107	1119510	0	0
45669267	1192710	0	0
45669379	1119510	0	0
45676137	1125315	0	0
45782871	1129625	0	0
45685084	1119510	0	0
45795026	1115008	0	0
45797727	1125315	0	0
46294563	1125315	0	0
46298369	1119510	0	0
46321898	1595799	0	0
46321085	1759842	0	0
44361256	1177480	0	0
3009201	3009201	0	0
441840	4066995	4	10
21000101	1746114	0	0
21500311	967823	1	1
4174520	4048695	1	1
36158440	40228214	2	3
36155230	1326303	0	0
40776958	3009542	1	1
36718588	4001336	4	6
44341685	1124957	0	0
44356915	1125315	0	0
44344240	1174888	0	0
45656318	19079524	1	1
45640545	1112807	0	0
44340752	1129625	0	0
45632295	1768849	0	0
45636353	1129625	0	0
45624674	1115008	0	0
45698828	1129625	0	0
45698083	1119510	0	0
45666833	1192710	0	0
45666748	1119510	0	0
45672885	1125315	0	0
45782923	1129625	0	0
45685140	1119510	0	0
45795052	1309944	0	0
45797738	1125315	0	0
46294684	1125315	0	0
46298347	1119510	0	0
46321905	1192710	0	0
46321626	1595799	0	0
45650307	1322184	0	0
3009542	3009542	0	0
441840	4144583	8	8
21000110	1717327	0	0
21500332	1129625	1	1
4042655	4047491	1	1
36158543	40228214	2	3
36155231	1305058	0	0
40777013	3035995	1	1
37202320	4048171	4	6
44341646	967823	0	0
44364083	920300	2	3
44344172	1115008	0	0
45634797	19079524	1	1
45637553	1112807	0	0
44340713	1129625	0	0
45632388	967823	0	0
45632989	1129625	0	0
45624294	1717327	0	0
45704475	19019273	2	3
45698096	1119510	0	0
45667057	1192710	0	0
45666749	1119510	0	0
45672878	1125315	0	0
45783018	1129625	0	0
45685887	1119510	0	0
45795054	740275	0	0
45797845	1125315	0	0
46294619	1125315	0	0
46298545	1119510	0	0
46321960	738818	0	0
46321637	1112807	0	0
45650720	1154029	0	0
80180	80180	0	0
441840	4218389	5	7
21000120	1728416	0	0
21500332	738818	1	1
4035228	4015189	1	1
36158744	40228214	2	3
36155267	1545958	0	0
40243435	40243436	1	1
37000000	4116491	4	6
44341697	738818	0	0
44364140	19077344	2	3
44344173	738818	0	0
45634635	19079524	1	1
45637265	1112807	0	0
44340921	1129625	0	0
45632454	1501700	0	0
45632659	1129625	0	0
45624490	1759842	0	0
45704487	1545959	2	3
45698427	1119510	0	0
45667051	1192710	0	0
45666872	1119510	0	0
45672970	1125315	0	0
45782988	1129625	0	0
45685524	1119510	0	0
45795034	1174888	0	0
45797501	1125315	0	0
46294388	1125315	0	0
46298297	1119510	0	0
46322225	738818	0	0
46321206	1741122	0	0
45650526	1177480	0	0
78272	78272	0	0
441840	4155034	5	8
21000122	1728416	0	0
21500332	1153428	1	1
4035987	4112343	1	1
36158466	40228214	2	3
36155275	975125	0	0
40093132	40163554	1	1
37202320	4112343	4	6
44341657	1729720	0	0
44364192	1127433	2	3
44344521	701322	0	0
45644032	19079524	1	1
45637515	1112807	0	0
45637404	1129625	0	0
45632466	1110410	0	0
45632918	1129625	0	0
45624490	1713332	0	0
45704497	19008572	2	3
45698546	1119510	0	0
45778453	1192710	0	0
45667006	1119510	0	0
45672972	1125315	0	0
45782844	1129625	0	0
45681890	1119510	0	0
45795011	1549786	0	0
45797861	1125315	0	0
46243884	1125315	0	0
46298300	1119510	0	0
46321766	1521369	0	0
46321206	1746114	0	0
45650532	723013	0	0
81151	81151	0	0
441840	380378	5	8
21000123	1728416	0	0
21500332	1192710	1	1
4037143	4037675	1	1
36159504	40228214	2	3
36154974	1149196	0	0
40002751	40231925	1	1
37200000	4112343	4	11
44341770	1177480	0	0
44364245	43012036	2	3
44344093	791967	0	0
45640680	19079524	1	1
45639822	1112807	0	0
45637355	1129625	0	0
45632435	1741122	0	0
45632772	1129625	0	0
45624608	738818	0	0
45704512	40231925	2	3
45698593	1119510	0	0
45778454	1192710	0	0
45667008	1119510	0	0
45672961	1125315	0	0
45783194	1129625	0	0
45681895	1119510	0	0
45795007	1154029	0	0
45797925	1125315	0	0
46243827	1125315	0	0
46298312	1119510	0	0
46321766	1595799	0	0
46321219	1545958	0	0
45650533	1129625	0	0
80502	80502	0	0
441840	30753	5	9
21000083	1713332	0	0
21500338	1192710	1	1
4133715	378001	1	1
36159055	40228214	2	3
36155286	1501700	0	0
40002706	40162522	1	1
37200000	4294548	4	10
44341779	1595799	0	0
44364337	19008572	2	3
44344687	975125	0	0
45653290	19079524	1	1
45639943	1112807	0	0
45625204	1129625	0	0
45632435	1746114	0	0
45659277	1177480	0	0
45624609	723013	0	0
45701024	19008572	2	3
45698643	1119510	0	0
45778434	1192710	0	0
45667027	1119510	0	0
45673051	1125315	0	0
45783112	1129625	0	0
45681986	1119510	0	0
45795009	1361711	0	0
45794791	1125315	0	0
46243858	1125315	0	0
46289695	1119510	0	0
46321766	1549786	0	0
46320732	1118084	0	0
45650292	1154343	0	0
1545958	1545958	0	0
441840	4051466	5	6
21000116	1728416	0	0
21500338	1174888	1	1
4133843	4015189	1	1
36151885	19078461	2	3
36154803	1112807	0	0
40002706	19133768	1	1
37200000	40486433	4	10
44341779	1521369	0	0
44357052	19133873	2	3
44343931	1343916	0	0
45656205	19079524	1	1
45639945	1112807	0	0
45625348	1129625	0	0
45632506	1124957	0	0
45657322	1177480	0	0
45624466	1500211	0	0
45700945	19073183	2	3
45697636	1119510	0	0
45778436	1192710	0	0
45666848	1119510	0	0
45672904	1125315	0	0
45783459	1129625	0	0
45682030	1119510	0	0
45795055	1545958	0	0
45794855	1125315	0	0
46243663	1125315	0	0
46289859	1119510	0	0
46321860	1551099	0	0
46320749	791967	0	0
45650313	975125	0	0
1519936	1519936	0	0
441840	261325	5	10
21000101	1717327	0	0
21500318	1119510	1	1
4143839	4197460	1	1
36159142	19078461	2	3
36154806	738818	0	0
37119655	45769019	1	1
37200000	40481087	4	9
44341779	1549786	0	0
44357240	1107882	2	3
44344376	1149380	0	0
45652296	19079524	1	1
45639949	1112807	0	0
45621792	1129625	0	0
45632522	708298	0	0
45657357	1177480	0	0
45624406	1713332	0	0
45700817	40163554	2	3
45697794	1119510	0	0
45778432	1192710	0	0
45666978	1119510	0	0
45673228	1125315	0	0
45783078	1129625	0	0
45682054	1119510	0	0
45795165	1107830	0	0
45797123	1125315	0	0
46243860	1125315	0	0
46289865	1119510	0	0
46321770	1115008	0	0
46320752	1713332	0	0
45650645	1551099	0	0
1519937	1519937	0	0
441840	440448	6	11
21000101	1778162	0	0
21500332	1107830	1	1
4185932	4329847	1	1
36158852	19078461	2	3
36155130	1112807	0	0
40793588	3014576	1	1
37200000	4051466	4	6
44341783	1129625	0	0
44358736	19133905	2	3
44344513	715997	0	0
45665279	19079524	1	1
45639993	1112807	0	0
45621808	1129625	0	0
45632408	738818	0	0
45657290	1177480	0	0
45624621	1589505	0	0
45701012	19008572	2	3
45695167	1119510	0	0
45778414	1192710	0	0
45666817	1119510	0	0
45673229	1125315	0	0
45783079	1129625	0	0
45682067	1119510	0	0
45795048	975125	0	0
45797127	1125315	0	0
46243670	1125315	0	0
46290025	1119510	0	0
46322021	791967	0	0
46321283	1551099	0	0
45650708	1177480	0	0
1548195	1548195	0	0
441840	4048169	6	7
21000148	1717327	0	0
21500332	1150836	1	1
4188027	4139681	1	1
36158201	19078461	2	3
36155136	1129625	0	0
40791672	3020630	1	1
36700000	4132546	4	9
44341860	1177480	0	0
44357302	1127433	2	3
44343934	738818	0	0
45628832	19079524	1	1
45634397	1112807	0	0
45621810	1129625	0	0
45632335	1174888	0	0
45657025	1177480	0	0
45624629	1551099	0	0
45701334	1127433	2	3
45695277	1119510	0	0
45707008	1192710	0	0
45667051	1119510	0	0
45672966	1125315	0	0
45783140	1129625	0	0
45682092	1119510	0	0
45795018	1000560	0	0
45797128	1125315	0	0
46243864	1125315	0	0
46290333	1119510	0	0
46322022	920293	0	0
46321482	1112807	0	0
45650714	1124300	0	0
1713332	1713332	0	0
441840	4302207	6	7
21000102	1746114	0	0
21500339	1129625	1	1
4188027	438614	1	1
36158425	19078461	2	3
36155138	1129625	0	0
40779933	3026361	1	1
36700000	4066995	4	8
44341819	1310149	0	0
44357364	19129655	2	3
44344205	967823	0	0
45638081	19079524	1	1
45634481	1112807	0	0
45620586	1129625	0	0
45632416	1174888	0	0
45656953	1177480	0	0
45624636	1124300	0	0
45700792	1107882	2	3
45695283	1119510	0	0
45707069	1192710	0	0
45667124	1119510	0	0
45673250	1125315	0	0
45783204	1129625	0	0
45682108	1119510	0	0
45795143	1110410	0	0
45797134	1125315	0	0
46243891	1125315	0	0
46289941	1119510	0	0
46322236	1343916	0	0
46320970	1738521	0	0
45650480	1119510	0	0
1154029	1154029	0	0
441840	4102123	6	7
21000102	1759842	0	0
21500328	1112807	1	1
4188027	442116	1	1
36158710	19078461	2	3
36155140	738818	0	0
40653085	3004501	1	1
37522270	4301346	4	5
44341825	967823	0	0
44357398	1127433	2	3
44344208	1310149	0	0
45665029	19079524	1	1
45634280	1112807	0	0
45620590	1129625	0	0
45632355	738818	0	0
45657391	1177480	0	0
45624650	1549786	0	0
45697934	1551192	2	3
45695331	1119510	0	0
45707097	1192710	0	0
45667082	1119510	0	0
45673255	1125315	0	0
45783435	1129625	0	0
45682210	1119510	0	0
45795085	1118084	0	0
45797218	1125315	0	0
46243675	1125315	0	0
46289411	1119510	0	0
46322479	1192710	0	0
46320992	1112807	0	0
45650489	1177480	0	0
1154615	1154615	0	0
441840	375671	7	11
21000116	1738521	0	0
21500339	1174888	1	1
4188027	4169137	1	1
36159638	19078461	2	3
36156473	1129625	0	0
40653240	3019406	1	1
37503887	4242997	4	4
44341957	920293	0	0
44357400	19133873	2	3
44344320	1124300	0	0
44361937	40223774	1	1
45634714	1112807	0	0
45620565	1129625	0	0
45632566	19078219	0	0
45656958	1177480	0	0
45624650	1521369	0	0
45698072	19008572	2	3
45695416	1119510	0	0
45704175	1192710	0	0
45667134	1119510	0	0
45673164	1125315	0	0
45783258	1129625	0	0
45682000	1119510	0	0
45795208	1107830	0	0
45796916	1125315	0	0
46243682	1125315	0	0
46290247	1119510	0	0
46322189	738818	0	0
46321590	1112807	0	0
45650655	1192710	0	0
195588	195588	0	0
441840	433125	7	7
21000268	1738521	0	0
21500328	1125315	1	1
4179823	4156265	1	1
36151743	1332419	2	3
36156562	1713332	0	0
40654863	3004501	1	1
37503887	4330583	4	4
44341963	1129625	0	0
44352386	1115171	2	3
44344323	1551099	0	0
45656203	46275916	1	1
45631421	1112807	0	0
45620658	1129625	0	0
45632570	1154343	0	0
45653851	1177480	0	0
45624650	19127890	0	0
45697884	19133768	2	3
45695384	1119510	0	0
45700900	1192710	0	0
45780960	1119510	0	0
45673177	1125315	0	0
45780575	1129625	0	0
45682177	1119510	0	0
45795209	738818	0	0
45797219	1125315	0	0
46243774	1125315	0	0
46290255	1119510	0	0
46322040	1501700	0	0
46321619	1112807	0	0
45650755	723013	0	0
1766384	920293	0	0
441840	45769019	7	9
21000280	1728416	0	0
21500332	1149196	1	1
4077069	4163874	1	1
36154514	1332419	2	3
36156384	1307863	0	0
40654905	3000963	1	1
37503887	4117038	4	4
44341728	1310149	0	0
44350342	1127433	2	3
44344343	701322	0	0
45652604	46275916	1	1
45631436	1112807	0	0
45620752	1129625	0	0
45632624	1332418	0	0
45647363	1177480	0	0
45624664	1738521	0	0
45698019	40232448	2	3
45695341	1119510	0	0
45701064	1192710	0	0
45778452	1119510	0	0
45673108	1125315	0	0
45780495	1129625	0	0
45682415	1119510	0	0
45795071	715997	0	0
45797220	1125315	0	0
46243851	1125315	0	0
46290176	1119510	0	0
46321930	738818	0	0
46321645	1112807	0	0
45650581	1124300	0	0
1766389	1343916	0	0
4322976	4337138	5	8
21000267	1746114	0	0
21500328	1115008	1	1
4077352	4324181	1	1
36159190	1332419	2	3
36156485	1107830	0	0
40655325	3023103	1	1
40773177	3004501	4	4
44341735	1539403	0	0
44350244	40229134	2	3
44344444	1396131	0	0
45652848	19079524	1	1
45631500	1112807	0	0
45661584	1129625	0	0
45632571	1322184	0	0
45647507	1177480	0	0
45624412	1115008	0	0
45698123	1127433	2	3
45695352	1119510	0	0
45701422	1192710	0	0
45778454	1119510	0	0
45786723	1125315	0	0
45777659	1129625	0	0
45678912	1119510	0	0
45795092	1115008	0	0
45797188	1125315	0	0
46243852	1125315	0	0
46289669	1119510	0	0
46322139	738818	0	0
46321664	1174888	0	0
45650582	1549786	0	0
1766448	1107830	0	0
4322976	4301346	5	10
21000259	1728416	0	0
21500339	1192710	1	1
4078460	4163951	1	1
36152436	1539411	2	3
36156491	1107830	0	0
40655374	3020630	1	1
40796128	3028833	4	4
44341736	1729720	0	0
44350491	40232448	2	3
44344425	975125	0	0
45649606	46275916	1	1
45628581	1112807	0	0
45661697	1129625	0	0
45632572	1154343	0	0
45647426	1177480	0	0
45624413	1192710	0	0
45697977	1127433	2	3
45695429	1119510	0	0
45700784	1192710	0	0
45778169	1119510	0	0
45784873	1125315	0	0
45778228	1129625	0	0
45678751	1119510	0	0
45795095	1326303	0	0
45797190	1125315	0	0
46243854	1125315	0	0
46291800	1119510	0	0
46322148	1154343	0	0
46315335	1000560	0	0
45650582	1512674	0	0
1766449	975125	0	0
4322976	4243062	5	7
21000284	1738521	0	0
21500344	738818	1	1
4031049	4181917	1	1
36217210	19079524	2	3
36156498	1192710	0	0
40654162	3006322	1	1
40796128	3020630	4	4
44341739	1332418	0	0
44350658	19059056	2	3
44344263	723013	0	0
45646731	46275916	1	1
45628312	1112807	0	0
45661758	1129625	0	0
45632439	1307863	0	0
45647466	1177480	0	0
45624446	975125	0	0
45698282	40169281	2	3
45695536	1119510	0	0
45698022	1192710	0	0
45778433	1119510	0	0
45784875	1125315	0	0
46242719	1129625	0	0
45706782	1125315	0	0
45795153	1778162	0	0
45795013	1125315	0	0
46244772	1125315	0	0
46241932	1119510	0	0
46322157	738818	0	0
46315314	715997	0	0
45650766	1177480	0	0
1766450	1125315	0	0
4322976	4163872	5	7
21000196	1738521	0	0
21500328	1192710	1	1
4032251	4145310	1	1
36217210	40224132	2	3
36156498	1112807	0	0
40655518	3008598	1	1
40796128	3010813	4	4
44359118	1119510	0	0
44350805	1107882	2	3
44337439	1149380	0	0
45643829	46275916	1	1
45628514	1112807	0	0
45658278	1129625	0	0
45632344	723013	0	0
45647547	1177480	0	0
45624448	738818	0	0
45697989	1107882	2	3
45695371	1119510	0	0
45698131	1192710	0	0
45778435	1119510	0	0
45784878	1125315	0	0
46242721	1129625	0	0
45706749	1125315	0	0
45795155	1322184	0	0
45795014	1125315	0	0
46244777	1125315	0	0
46241955	1119510	0	0
46322161	1124300	0	0
46315378	1112807	0	0
45650597	975125	0	0
1766460	1129625	0	0
4322976	4234705	5	5
21000213	1738521	0	0
21500344	1119510	1	1
19100279	19006318	1	1
36217207	19023423	2	3
36156499	1129625	0	0
40655590	3013682	1	1
40796128	3026361	4	4
44359123	1119510	0	0
44350253	19123231	2	3
44337443	1153428	0	0
45646059	19079524	1	1
45625349	1112807	0	0
45658341	1129625	0	0
45632374	791967	0	0
45647682	1177480	0	0
45624666	975125	0	0
45698269	19078461	2	3
45695524	1119510	0	0
45697971	1192710	0	0
45778436	1119510	0	0
45784743	1125315	0	0
46240309	1129625	0	0
45706695	1125315	0	0
45792393	1112807	0	0
45794977	1125315	0	0
46244780	1125315	0	0
46241958	1119510	0	0
46322255	1551099	0	0
46315456	1124957	0	0
45650768	1129625	0	0
1766469	753626	0	0
4322976	4133840	5	5
21000218	1738521	0	0
21500328	1177480	1	1
4122944	4163872	1	1
36217207	19029476	2	3
36156499	1177480	0	0
40656757	3049273	1	1
40796128	3000963	4	4
44358995	1119510	0	0
44350334	1551192	2	3
44337380	19127890	0	0
45637860	46275916	1	1
45625352	1112807	0	0
45655592	1129625	0	0
45632607	967823	0	0
45648066	1177480	0	0
45624676	1728416	0	0
45695021	19008572	2	3
45695303	1119510	0	0
45694787	1192710	0	0
45778438	1119510	0	0
45784777	1125315	0	0
46240434	1129625	0	0
45706769	1125315	0	0
45792272	705944	0	0
45795027	1125315	0	0
46244787	1125315	0	0
46241965	1119510	0	0
46322485	1124300	0	0
46315458	1000560	0	0
45650556	1501700	0	0
1766488	967823	0	0
4322976	4151422	5	5
21000216	1738521	0	0
21500344	1129625	1	1
4122944	4058899	1	1
36217207	40169281	2	3
36156594	1124300	0	0
40654273	3024561	1	1
37502354	4202451	4	4
44358996	1119510	0	0
44350365	40232448	2	3
44337293	1174888	0	0
45636925	46275916	1	1
45625314	1112807	0	0
45655689	1129625	0	0
45632474	757627	0	0
45644383	1177480	0	0
45624579	1107830	0	0
45695040	19008572	2	3
45692000	1119510	0	0
45694802	1192710	0	0
45778440	1119510	0	0
45784869	1125315	0	0
46240183	1129625	0	0
45705240	1125315	0	0
45792274	920293	0	0
45795034	1125315	0	0
46244884	1125315	0	0
46241968	1119510	0	0
46322486	1192710	0	0
46315470	1326303	0	0
45650665	1738521	0	0
1766393	1125315	0	0
4322976	4181917	5	6
19125062	19125062	0	0
21500344	1192710	1	1
4100474	4057420	1	1
36217207	40169216	2	3
36156319	1738521	0	0
40250192	1119510	1	1
40776264	3008598	4	4
44358888	1119510	0	0
44350700	40236824	2	3
44337380	1549786	0	0
45631831	46275916	1	1
45625316	1112807	0	0
45655655	1129625	0	0
45632482	1308738	0	0
45644597	1177480	0	0
45624767	738818	0	0
45694802	43012036	2	3
45692097	1119510	0	0
45694915	1192710	0	0
45778458	1119510	0	0
45784871	1125315	0	0
46240364	1129625	0	0
45705189	1125315	0	0
45792394	975125	0	0
45795038	1125315	0	0
46243957	1125315	0	0
46242014	1119510	0	0
46322493	1551099	0	0
46315474	791967	0	0
45650731	705944	0	0
1766503	1112807	0	0
4322976	4062501	4	6
19126352	19126352	0	0
21500324	19029476	1	1
4076875	4301346	1	1
36217207	1154615	2	3
36156563	1107830	0	0
40250176	40221415	1	1
36702242	380378	4	4
44359253	1119510	0	0
44350703	1127433	2	3
44337296	1557272	0	0
45628451	40223774	1	1
45625348	1112807	0	0
45655818	1129625	0	0
45632489	19039298	0	0
45645915	1177480	0	0
45624561	1000560	0	0
45694804	40232448	2	3
45692077	1119510	0	0
45645802	1192710	0	0
45778460	1119510	0	0
45785016	1125315	0	0
46240374	1129625	0	0
45705191	1125315	0	0
45792220	1738521	0	0
45795084	1125315	0	0
46243959	1125315	0	0
46242016	1119510	0	0
46322204	1149196	0	0
46315621	1500211	0	0
45650751	1149196	0	0
1766492	1129625	0	0
4322976	4145310	4	6
19127893	19127904	0	0
21500348	1129625	1	1
4079526	44783196	1	1
36217207	782047	2	3
35909442	198809	0	0
40174875	40174880	1	1
36702242	381316	4	4
44359329	1119510	0	0
44346404	1115171	2	3
44337297	1595799	0	0
45631106	46275916	1	1
45625276	1112807	0	0
45655744	1129625	0	0
45632444	914335	0	0
45644768	1177480	0	0
45624765	1332418	0	0
45645801	19019273	2	3
45692102	1119510	0	0
45691677	1192710	0	0
45778355	1119510	0	0
45785024	1125315	0	0
46242092	1129625	0	0
45705193	1125315	0	0
45792099	1107830	0	0
45795209	1125315	0	0
46244051	1125315	0	0
46241905	1119510	0	0
46322265	1192710	0	0
46315628	1174888	0	0
45650833	1778162	0	0
1766494	1361711	0	0
4322976	4295880	4	6
19127904	19127904	0	0
21500348	1192710	1	1
4078442	4057420	1	1
36217216	40223821	2	3
35707594	4285898	0	0
40100593	19023398	1	1
40779591	3000876	4	4
44359330	1119510	0	0
44346471	1127433	2	3
44337297	1521369	0	0
45628845	46275916	1	1
45625392	1112807	0	0
45649331	1129625	0	0
45658343	1125315	0	0
45641888	1177480	0	0
45624860	1149196	0	0
45691577	40228214	2	3
45692218	1119510	0	0
45691682	1192710	0	0
45778357	1119510	0	0
45785026	1125315	0	0
46240515	1129625	0	0
45705199	1125315	0	0
45792221	967823	0	0
45792252	1125315	0	0
46244054	1125315	0	0
46241912	1119510	0	0
46322273	1713332	0	0
46315655	1112807	0	0
45650834	1129625	0	0
1766405	1115008	0	0
4322976	4195803	4	4
19129144	19129144	0	0
21500350	1192710	1	1
1101553	40169281	1	1
36217216	46233710	2	3
36151049	742185	0	0
40098676	19029476	1	1
37503868	4336464	4	4
44359156	1119510	0	0
44346392	1107882	2	3
44337297	1549786	0	0
45628879	46275916	1	1
45625806	1112807	0	0
44337690	1119510	0	0
45658404	1125315	0	0
45641632	1177480	0	0
45624864	1124300	0	0
45691677	43012036	2	3
45692089	1119510	0	0
45688936	1192710	0	0
45778431	1119510	0	0
45785036	1125315	0	0
46240516	1129625	0	0
45705208	1125315	0	0
45792187	1192710	0	0
45792279	1125315	0	0
46244005	1125315	0	0
46242112	1119510	0	0
46322287	1115008	0	0
46315660	1551099	0	0
45650736	1129625	0	0
1766414	1107830	0	0
4322976	4187458	4	4
19096779	19074841	0	0
21500351	1125315	1	1
4045900	4047491	4	5
36217216	1107882	2	3
36151054	1129625	0	0
40098677	19029476	1	1
40792746	3049273	4	4
44359165	1119510	0	0
44346502	19019273	2	3
44337372	1118084	0	0
45625997	46275916	1	1
45622117	1112807	0	0
44337601	1119510	0	0
45657580	1125315	0	0
45641992	1177480	0	0
45624867	1192710	0	0
45691641	40232448	2	3
45692138	1119510	0	0
45688942	1192710	0	0
45778432	1119510	0	0
45785038	1125315	0	0
45703292	1129625	0	0
45705370	1125315	0	0
45792187	1174888	0	0
45792355	1125315	0	0
46238900	1125315	0	0
46242174	1119510	0	0
46322302	1115008	0	0
46315668	1501700	0	0
45650467	1129625	0	0
1766566	1192710	0	0
4322976	4012477	4	7
19078219	19078219	0	0
21500352	1129625	1	1
4030660	4198190	4	5
36217216	19075601	2	3
36150849	1112807	0	0
40054982	19023423	1	1
37302323	4155034	4	4
44359166	1119510	0	0
44346536	19133905	2	3
44337454	1332418	0	0
45622638	46275916	1	1
45622060	1112807	0	0
44337883	1119510	0	0
45657558	1125315	0	0
45641968	1177480	0	0
45624875	1137529	0	0
45691672	1115171	2	3
45694622	1119510	0	0
45686044	1192710	0	0
45778389	1119510	0	0
45785043	1125315	0	0
45703139	1129625	0	0
45705267	1125315	0	0
45792351	1115008	0	0
45792300	1125315	0	0
46238901	1125315	0	0
46241946	1119510	0	0
46322495	738818	0	0
46315670	1713332	0	0
45650847	1119510	0	0
1766566	1125315	0	0
4322976	44805732	4	7
19078924	19078924	0	0
21500352	1125315	1	1
4180627	4199276	4	5
36217216	19074843	2	3
36150758	1551099	0	0
40056535	19077344	1	1
40779557	3019406	4	4
44359294	1119510	0	0
44346543	19133873	2	3
44337418	1124300	0	0
45623042	40171902	1	1
45624968	1112807	0	0
44337884	1119510	0	0
45657595	1125315	0	0
45641956	1177480	0	0
45624875	1149380	0	0
45691819	40232448	2	3
45689281	1119510	0	0
45685918	1192710	0	0
45778468	1119510	0	0
45784882	1125315	0	0
45703145	1129625	0	0
45780013	1125315	0	0
45792353	1310149	0	0
45792480	1125315	0	0
46238902	1125315	0	0
46242076	1119510	0	0
46322501	975125	0	0
46315570	1174888	0	0
45650739	975125	0	0
1768849	1768849	0	0
4322976	4163971	4	9
19039298	19039298	0	0
21500354	1174888	1	1
4038678	81893	4	5
36217216	40228230	2	3
36150850	1177480	0	0
40056894	40223834	1	1
36703477	4132546	4	4
44359001	1119510	0	0
44346742	40232448	2	3
44337423	1545958	0	0
45621935	19079524	1	1
45624943	1112807	0	0
44778040	1119510	0	0
45657848	1125315	0	0
45638796	1177480	0	0
45624879	738818	0	0
45691919	40223768	2	3
45689320	1119510	0	0
45688291	1192710	0	0
45778513	1119510	0	0
45784937	1125315	0	0
45703579	1129625	0	0
45779848	1125315	0	0
45792222	1738521	0	0
45792364	1125315	0	0
46238903	1125315	0	0
46242234	1119510	0	0
46322502	1738521	0	0
46315915	740275	0	0
45650740	1501700	0	0
1766609	920293	0	0
4322976	4252419	4	8
19008572	19008572	0	0
21505745	1174888	1	1
4096864	4166224	4	5
36217216	40223834	2	3
36150906	1107830	0	0
40056894	40223821	1	1
36703534	378001	4	4
44359304	1119510	0	0
44346821	40223834	2	3
44337812	1713332	0	0
45622039	19079524	1	1
45624954	1112807	0	0
44778254	1119510	0	0
45657775	1125315	0	0
45638806	1177480	0	0
45624760	1322184	0	0
45691887	19008572	2	3
45689162	1119510	0	0
45682858	1192710	0	0
45780610	1119510	0	0
45785161	1125315	0	0
45703530	1129625	0	0
45780010	1125315	0	0
45792232	1115008	0	0
45792331	1125315	0	0
46238863	1125315	0	0
46242182	1119510	0	0
46322344	1124957	0	0
46315355	1153428	0	0
45650749	1112807	0	0
1766555	1549786	0	0
4322976	4202451	4	8
4323902	4323902	0	0
21505750	1192710	1	1
4180627	4163951	3	5
36217216	19133768	2	3
36150915	738818	0	0
40041368	1519937	1	1
40776225	3014599	4	4
44359306	1119510	0	0
44346298	19078461	2	3
44337784	1174888	0	0
45621429	19079524	1	1
45622261	1112807	0	0
44778219	1119510	0	0
45657780	1125315	0	0
45638887	1177480	0	0
45624364	975125	0	0
45691695	1115171	2	3
45689178	1119510	0	0
45683216	1192710	0	0
45780509	1119510	0	0
45784901	1125315	0	0
45703533	1129625	0	0
45779772	1125315	0	0
45792358	1307863	0	0
45792427	1125315	0	0
46238870	1125315	0	0
46242185	1119510	0	0
46322347	1192710	0	0
46315543	1595799	0	0
45650761	1149196	0	0
1766555	1512674	0	0
4322976	4024289	4	8
4324181	4324181	0	0
21505750	1174888	1	1
4180627	4024289	3	5
36217206	44816277	2	3
36150990	740275	0	0
40010254	1150771	1	1
36702254	4001336	4	4
44359083	1119510	0	0
44346606	19008572	2	3
44338021	1192710	0	0
45665169	19079524	1	1
45622306	1112807	0	0
44358972	1119510	0	0
45657787	1125315	0	0
45639096	1177480	0	0
45624808	967823	0	0
45692046	40231925	2	3
45689215	1119510	0	0
45682925	1192710	0	0
45780521	1119510	0	0
45785134	1125315	0	0
45703264	1129625	0	0
45779927	1125315	0	0
45792451	1713332	0	0
45792161	1125315	0	0
46238919	1125315	0	0
46242309	1119510	0	0
46315798	1124300	0	0
46315543	1308738	0	0
45650853	975125	0	0
1766557	1713332	0	0
4322976	4323902	3	9
4323208	4323208	0	0
21505751	1119510	1	1
21600961	19075601	2	5
36217214	46233988	2	3
36150992	1192710	0	0
40009472	19073183	1	1
37202317	4048171	5	5
44352315	1119510	0	0
44346738	19019273	2	3
44337822	1107830	0	0
45665149	46275916	1	1
45622369	1112807	0	0
44358976	1119510	0	0
45657822	1125315	0	0
45639104	1177480	0	0
45624984	1149196	0	0
45692071	19018935	2	3
45689357	1119510	0	0
45704142	975125	0	0
45780523	1119510	0	0
45784952	1125315	0	0
45703267	1129625	0	0
45780126	1125315	0	0
45792479	1343916	0	0
45792527	1125315	0	0
46238920	1125315	0	0
46241988	1119510	0	0
46316069	914335	0	0
46315790	1000560	0	0
45650798	1539403	0	0
1766557	1759842	0	0
4322976	4275113	3	9
4230209	4230209	0	0
21505751	1192710	1	1
21600961	40163554	2	5
36217214	1551192	2	3
36150997	1137529	0	0
40099132	19123231	1	1
37002291	195588	5	5
44352053	1119510	0	0
44348579	40232448	2	3
44337999	1000560	0	0
45665258	19079524	1	1
45622460	1112807	0	0
44359058	1119510	0	0
45657627	1125315	0	0
45638786	1177480	0	0
45624991	1192710	0	0
45688819	40232448	2	3
45689535	1119510	0	0
45704146	975125	0	0
45707069	1119510	0	0
45784843	1125315	0	0
45700398	1129625	0	0
45779779	1125315	0	0
45792237	1102527	0	0
45792447	1125315	0	0
46238921	1125315	0	0
46242288	1119510	0	0
46316220	1000560	0	0
46315791	1713332	0	0
45650858	1119510	0	0
1766561	1107830	0	0
4322976	4057420	3	9
4230399	4230399	0	0
21505753	1119510	1	1
21604564	19076374	2	5
36217214	836659	2	3
36150997	1149380	0	0
36703451	381316	1	1
40779561	3002385	5	5
44355213	1119510	0	0
44348291	1551192	2	3
44338186	1124957	0	0
45662162	19079524	1	1
45622384	1112807	0	0
44358846	1119510	0	0
45654048	1125315	0	0
45638869	1177480	0	0
45624423	742185	0	0
45688791	1107882	2	3
45689056	1119510	0	0
45703956	975125	0	0
45707138	1119510	0	0
45785080	1125315	0	0
45700301	1129625	0	0
45780053	1125315	0	0
45792240	1153428	0	0
45792450	1125315	0	0
46238922	1125315	0	0
46242000	1119510	0	0
46316242	1361711	0	0
46315928	975125	0	0
45650673	1177480	0	0
1766420	1124300	0	0
4322976	4078793	3	8
21001547	1309944	0	0
21505753	1192710	1	1
21604564	19057271	2	5
36217214	19059056	2	3
36150998	1177480	0	0
40000823	1107882	1	1
40779561	3024731	5	5
44355222	1119510	0	0
44342766	40229134	2	3
44338011	1307863	0	0
45659396	40220386	1	1
45620730	1112807	0	0
44358978	1119510	0	0
45654116	1125315	0	0
45635578	1177480	0	0
45624715	1367571	0	0
45688763	40243436	2	3
45689529	1119510	0	0
45703782	975125	0	0
45707329	1119510	0	0
45785202	1125315	0	0
45700309	1129625	0	0
45780077	1125315	0	0
45792359	1124300	0	0
45792536	1125315	0	0
46238923	1125315	0	0
46242003	1119510	0	0
46316255	1115008	0	0
46315949	1521369	0	0
45650675	1177480	0	0
1766424	1125315	0	0
4322976	4010253	3	8
21001554	1343916	0	0
21505753	1125315	1	1
21604792	19077572	2	5
36217214	45892894	2	3
36150958	1307863	0	0
40009799	19129655	1	1
40779561	3007461	5	5
44355406	1119510	0	0
44342721	40232448	2	3
44337533	1521369	0	0
45658342	46275916	1	1
45621026	1112807	0	0
44359179	1119510	0	0
45654202	1125315	0	0
45635594	1177480	0	0
45624598	1367571	0	0
45688812	19019273	2	3
45686258	1119510	0	0
45652318	975125	0	0
45707097	1119510	0	0
45785220	1125315	0	0
45700481	1129625	0	0
45780195	1125315	0	0
45792364	738818	0	0
45792630	1125315	0	0
46238968	1125315	0	0
45893701	1119510	0	0
46316304	1115008	0	0
46316017	1153428	0	0
45650807	975125	0	0
1766424	1119510	0	0
4322976	4238715	3	7
21001554	1309944	0	0
21505758	1125315	1	1
21604792	40223768	2	5
36217214	19073188	2	3
36151009	1192710	0	0
40173379	40232448	1	1
37003663	45769019	5	5
44352442	1119510	0	0
44343079	19073183	2	3
44337533	1549786	0	0
45656627	46275916	1	1
45621183	1112807	0	0
44358364	1119510	0	0
45654203	1125315	0	0
45635713	1177480	0	0
45624375	1192710	0	0
45688883	19008572	2	3
45686299	1119510	0	0
45652089	975125	0	0
45707250	1119510	0	0
45784968	1125315	0	0
45700502	1129625	0	0
45780175	1125315	0	0
45792368	1110410	0	0
45792152	1125315	0	0
46238970	1125315	0	0
45893753	1119510	0	0
46316312	1308738	0	0
46316020	1124300	0	0
45650809	1308738	0	0
1766426	1192710	0	0
4322976	4059978	3	6
21001538	1307863	0	0
21505914	1119510	1	1
4037672	42535580	5	5
36217214	19074841	2	3
36151015	1149196	0	0
40097012	964261	1	1
37600000	4324181	5	5
44352561	1119510	0	0
44342880	43012036	2	3
44337534	1192710	0	0
45656703	19079524	1	1
45621215	1112807	0	0
44358336	1119510	0	0
45654387	1125315	0	0
45635719	1177480	0	0
45624779	1310149	0	0
45688942	43012036	2	3
45686681	1119510	0	0
45700708	975125	0	0
45707356	1119510	0	0
45784972	1125315	0	0
45700345	1129625	0	0
45780026	1125315	0	0
45792456	1307863	0	0
45792415	1125315	0	0
46238887	1125315	0	0
45801735	1119510	0	0
46316316	1192710	0	0
46316095	1713332	0	0
45650812	1129625	0	0
1768657	1361711	0	0
4322976	4199276	3	6
21001557	1343916	0	0
21505914	1192710	1	1
4162282	260139	5	5
36217214	19123231	2	3
36151021	1115008	0	0
40249028	40169281	1	1
37202319	321042	5	5
44352564	1119510	0	0
44343305	19008572	2	3
44337523	933724	0	0
45652834	46275916	1	1
45664755	1112807	0	0
44358314	1119510	0	0
45654310	1125315	0	0
45632642	1177480	0	0
45624504	791967	0	0
45689095	19008572	2	3
45686409	1119510	0	0
45700711	975125	0	0
45704277	1119510	0	0
45784973	1125315	0	0
45700267	1129625	0	0
45780057	1125315	0	0
45792336	1112807	0	0
45792500	1125315	0	0
46238893	1125315	0	0
45801830	1119510	0	0
46316333	1551099	0	0
46316095	1759842	0	0
45650812	1119510	0	0
1766397	1545958	0	0
4322976	4326177	3	4
21001630	1545958	0	0
21505920	1125315	1	1
4162282	4294548	5	5
36217214	1545959	2	3
36150866	1115008	0	0
40173617	40173590	1	1
37202319	317576	5	5
44352592	1119510	0	0
44342909	46233988	2	3
44337530	920293	0	0
45647074	19079524	1	1
45664342	1112807	0	0
44358327	1119510	0	0
45654313	1125315	0	0
45632801	1177480	0	0
45624536	738818	0	0
45686027	19076374	2	3
45686374	1119510	0	0
45648686	975125	0	0
45704279	1119510	0	0
45784978	1125315	0	0
45896879	1129625	0	0
45780063	1125315	0	0
45792338	1545958	0	0
45792697	1125315	0	0
46238895	1125315	0	0
45801796	1119510	0	0
46316449	975125	0	0
46315916	975125	0	0
45650590	1177480	0	0
1766593	1125315	0	0
4322976	4246502	3	5
21001555	1309944	0	0
21505758	1119510	1	1
4162282	4280726	5	5
36102976	4112343	2	4
36151028	933724	0	0
40009507	19073188	1	1
36703477	4001336	5	5
44352453	1119510	0	0
44343061	1115171	2	3
44337582	1549786	0	0
45644196	46275916	1	1
45662020	1112807	0	0
44358565	1119510	0	0
45654315	1125315	0	0
45632871	1177480	0	0
45624537	1512674	0	0
45686042	40165015	2	3
45686390	1119510	0	0
45648928	975125	0	0
45704285	1119510	0	0
45785099	1125315	0	0
45697214	1129625	0	0
45780069	1125315	0	0
45792427	738818	0	0
45792651	1125315	0	0
46238896	1125315	0	0
45802420	1119510	0	0
46316155	1551099	0	0
46315796	1738521	0	0
45650605	1501700	0	0
1778162	1778162	0	0
4322976	4202832	3	5
21001565	1343916	0	0
21505758	738818	1	1
4042645	40492359	5	5
36102976	4294548	2	4
36150851	1107830	0	0
40095878	19075601	1	1
36718119	375671	5	5
44352476	1119510	0	0
44339602	1127433	2	3
44337556	1343916	0	0
45641218	46275916	1	1
45662037	1112807	0	0
44358433	1119510	0	0
45654317	1125315	0	0
45631083	1177480	0	0
45624537	1549786	0	0
45685747	19074843	2	3
45686391	1119510	0	0
45645581	975125	0	0
45704331	1119510	0	0
45785225	1125315	0	0
45694285	1129625	0	0
45780118	1125315	0	0
45792429	1192710	0	0
45789494	1125315	0	0
46238897	1125315	0	0
45799083	1119510	0	0
46311140	1000560	0	0
46315974	1322184	0	0
45650823	1192710	0	0
1766595	975125	0	0
4322976	4024958	6	7
21001565	914335	0	0
21505758	1192710	1	1
4042645	4336464	5	5
36202155	4066995	2	4
36151059	1154343	0	0
40009896	19059056	1	1
36718119	378001	5	5
44352478	1119510	0	0
44339504	19008572	2	3
44337576	1545958	0	0
45638321	46275916	1	1
45662148	1112807	0	0
44358520	1119510	0	0
45654139	1125315	0	0
45629698	1177480	0	0
45624537	19127890	0	0
45686159	40232448	2	3
45686396	1119510	0	0
45645692	975125	0	0
45704337	1119510	0	0
45785227	1125315	0	0
45694244	1129625	0	0
45780155	1125315	0	0
45792315	723013	0	0
45789625	1125315	0	0
46238898	1125315	0	0
45798993	1119510	0	0
46311143	1361711	0	0
46316134	1112807	0	0
45650606	1119510	0	0
1766598	1713332	0	0
4322976	4336464	6	11
21001578	1326303	0	0
21505758	1112807	1	1
4038335	4330583	5	5
36202155	4237458	2	4
36150872	1115008	0	0
40005746	1127433	1	1
37202316	4048171	5	10
44352486	1119510	0	0
44339484	40162522	2	3
44337577	1589505	0	0
45638316	46275916	1	1
45662069	1112807	0	0
44358529	1119510	0	0
45654146	1125315	0	0
45629766	1177480	0	0
45624748	1310149	0	0
45685918	43012036	2	3
45686529	1119510	0	0
45642698	975125	0	0
45704290	1119510	0	0
45785228	1125315	0	0
45694446	1129625	0	0
45779971	1125315	0	0
45792420	757627	0	0
45789727	1125315	0	0
46238899	1125315	0	0
45799095	1119510	0	0
46310913	1738521	0	0
46316152	1551099	0	0
45650613	1119510	0	0
1154343	1154343	0	0
4322976	4108705	6	9
21001627	1112807	0	0
21503969	1174888	1	1
4175951	4168004	5	5
36202155	4059173	2	4
36151038	1177480	0	0
40005746	1127078	1	1
37202316	258780	5	10
44352570	1119510	0	0
44339438	40162522	2	3
44337577	1549786	0	0
44351456	46275916	1	1
45662544	1112807	0	0
44358572	1119510	0	0
45654447	1125315	0	0
45629789	1177480	0	0
45624843	1174888	0	0
45688613	19008572	2	3
45686427	1119510	0	0
45642719	975125	0	0
45704226	1119510	0	0
45785234	1125315	0	0
45691336	1129625	0	0
45780030	1125315	0	0
45792161	738818	0	0
45789746	1125315	0	0
46239039	1125315	0	0
45799098	1119510	0	0
46310804	967823	0	0
46315219	1549786	0	0
45650703	975125	0	0
1174888	1174888	0	0
4322976	4047491	6	9
21000643	1500211	0	0
21503969	1177480	1	1
4179873	378419	5	5
36110570	4294548	2	4
36151040	967823	0	0
40008978	1332419	1	1
37202316	260139	5	9
42803016	1119510	0	0
44341064	1545959	2	3
44337649	740275	0	0
44351637	46275916	1	1
45662546	1112807	0	0
44358669	1119510	0	0
45654518	1125315	0	0
45627021	1177480	0	0
45624847	975125	0	0
45682838	1107882	2	3
45686580	1119510	0	0
45642844	975125	0	0
45704227	1119510	0	0
45785169	1125315	0	0
45691300	1129625	0	0
45780038	1125315	0	0
45792526	1361711	0	0
45789828	1125315	0	0
46239042	1125315	0	0
45799124	1119510	0	0
46310808	1174888	0	0
46315219	1521369	0	0
45650599	1177480	0	0
1580765	1107830	0	0
4322976	42535580	6	9
21000653	1500211	0	0
21504026	1125315	1	1
4180169	28060	3	6
36202155	4142905	2	4
36151067	1129625	0	0
40095247	1545959	1	1
37202316	40481087	5	8
44344936	1119510	0	0
44339713	40228230	2	3
44337651	705944	0	0
44784095	4295880	1	1
45659069	1112807	0	0
44358601	1119510	0	0
45654240	1125315	0	0
45626769	1177480	0	0
45668534	1154343	0	0
45682943	19075001	2	3
45683170	1119510	0	0
45642832	975125	0	0
45704294	1119510	0	0
45786482	1125315	0	0
45802644	1129625	0	0
45780041	1125315	0	0
45792561	1154029	0	0
45789847	1125315	0	0
46238988	1125315	0	0
45799173	1119510	0	0
46310808	1192710	0	0
46316021	975125	0	0
45650600	1154343	0	0
1580887	1332418	0	0
4322976	4330583	6	10
21000694	1308738	0	0
21504026	1112807	1	1
4180169	255848	3	6
36110570	4112343	2	4
36150893	1545958	0	0
40054158	19019979	1	1
37202316	28060	5	8
44344798	1119510	0	0
44363312	19019273	2	3
44337657	975125	0	0
45658665	19074679	1	1
44358058	1112807	0	0
44358604	1119510	0	0
45654241	1125315	0	0
45628061	1177480	0	0
45668915	1149380	0	0
45683098	1115171	2	3
45683175	1119510	0	0
45639813	975125	0	0
45704298	1119510	0	0
45786243	1125315	0	0
45802328	1129625	0	0
45780047	1125315	0	0
45792443	967823	0	0
45789650	1125315	0	0
46238989	1125315	0	0
45799194	1119510	0	0
46311222	1595799	0	0
46315550	1153428	0	0
45650699	1174888	0	0
1580772	1332418	0	0
4322976	4314290	7	7
21000701	1539403	0	0
21503962	926487	1	1
4180169	40481087	3	6
36002139	4280726	2	5
36150763	1107830	0	0
40054158	19078461	1	1
37203758	260139	5	8
44344984	1119510	0	0
44349659	1713671	2	3
44337594	975125	0	0
44362721	1125315	0	0
44357764	1112807	0	0
44351293	1119510	0	0
45654064	1125315	0	0
45628287	1177480	0	0
45668910	1115008	0	0
45683100	19133905	2	3
45683514	1119510	0	0
45640120	975125	0	0
45704248	1119510	0	0
45786250	1125315	0	0
45802578	1129625	0	0
45707015	1125315	0	0
45792444	1115008	0	0
45789769	1125315	0	0
46238990	1125315	0	0
45799354	1119510	0	0
46311222	1521369	0	0
46315421	1713332	0	0
45650699	1177480	0	0
1557272	1557272	0	0
4322976	4242997	7	8
21000643	1521369	0	0
21493848	3051031	1	1
4180627	4202451	3	6
36103041	4112343	2	7
36151072	1110410	0	0
40244551	1551099	0	0
37203758	4294548	5	8
44345112	1119510	0	0
44346527	1545959	2	3
44337733	1713332	0	0
44362725	1125315	0	0
44357866	1112807	0	0
44351356	1119510	0	0
45654282	1125315	0	0
45627064	1177480	0	0
45668469	1309944	0	0
45683290	19059056	2	3
45683145	1119510	0	0
45685697	975125	0	0
45704371	1119510	0	0
45782871	1125315	0	0
45802571	1129625	0	0
45707019	1125315	0	0
45792534	1332418	0	0
45789670	1125315	0	0
46238991	1125315	0	0
45799355	1119510	0	0
46311222	1549786	0	0
46315421	1759842	0	0
45650700	1119510	0	0
1580753	1125315	0	0
4322976	4198190	8	11
21000643	19127890	0	0
21500015	1741122	1	1
255919	4283893	4	6
36111047	4112343	2	6
36151189	1539403	0	0
40244557	1119510	0	0
37000000	4056621	5	7
44345009	1119510	0	0
44362983	19019273	2	3
44337624	1589505	0	0
44361802	1125315	0	0
44357911	1112807	0	0
44351269	1119510	0	0
45654628	1125315	0	0
45623936	1177480	0	0
45668709	1137529	0	0
45683328	40223834	2	3
45683253	1119510	0	0
45636695	975125	0	0
45704503	1119510	0	0
45782873	1125315	0	0
45688461	1129625	0	0
45707023	1125315	0	0
45792537	1115008	0	0
45789717	1125315	0	0
46238992	1125315	0	0
45799208	1119510	0	0
46310821	1501700	0	0
46315438	1551099	0	0
45650677	1124300	0	0
1580779	1549786	0	0
4344497	78272	7	7
21000643	1595799	0	0
21502659	1124300	1	1
4042677	4336464	4	6
36102970	4294548	3	7
36151199	1129625	0	0
40244557	1125315	0	0
37203758	255848	5	7
44345027	1119510	0	0
44356885	46233710	2	3
44337624	1549786	0	0
44361857	1125315	0	0
44358104	1112807	0	0
44351401	1119510	0	0
45654189	1125315	0	0
45623456	1177480	0	0
45668709	1149380	0	0
45682997	19019273	2	3
45685595	1119510	0	0
45636723	975125	0	0
45700801	1119510	0	0
45782822	1125315	0	0
45800013	1129625	0	0
45707028	1125315	0	0
45792538	1738521	0	0
45789788	1125315	0	0
46238993	1125315	0	0
45799213	1119510	0	0
46310857	1192710	0	0
46315442	1738521	0	0
45650682	1129625	0	0
1580865	1332418	0	0
4244662	4230399	6	7
21000643	19054876	0	0
21502659	1177480	1	1
4185503	4329847	5	6
36103041	4116491	5	7
36151199	1177480	0	0
40244557	1129625	0	0
37202319	4329847	5	6
44344975	1119510	0	0
44343068	19078461	2	3
44337703	1124300	0	0
44361726	1125315	0	0
44354846	1112807	0	0
44351433	1119510	0	0
45652032	1125315	0	0
45624049	1177480	0	0
45668715	1192710	0	0
45682955	19059056	2	3
45680265	1119510	0	0
45682985	975125	0	0
45700947	1119510	0	0
45782826	1125315	0	0
45800087	1129625	0	0
45706125	1125315	0	0
45792628	791967	0	0
45789836	1125315	0	0
46239295	1125315	0	0
45799405	1119510	0	0
46310872	1501700	0	0
46315842	1112807	0	0
45650772	1551099	0	0
1580866	1332418	0	0
4212577	133834	6	6
21000683	1396131	0	0
21602866	46275444	1	1
4180627	42535580	5	6
36103041	4294548	4	7
36151201	1112807	0	0
40244542	1115008	0	0
37203758	4283893	5	6
44345130	1119510	0	0
44358788	19075601	2	3
44337714	723013	0	0
44361809	1125315	0	0
44351013	1112807	0	0
44351459	1119510	0	0
45652040	1125315	0	0
45623955	1177480	0	0
45668470	1107830	0	0
45683064	19075001	2	3
45680128	1119510	0	0
45633683	975125	0	0
45700775	1119510	0	0
45783011	1125315	0	0
45800208	1129625	0	0
45706100	1125315	0	0
45792503	1115008	0	0
45789840	1125315	0	0
46239125	1125315	0	0
45793962	1119510	0	0
46310880	933724	0	0
46315843	1110410	0	0
45650773	1326303	0	0
1580809	1129625	0	0
4305027	81151	4	5
19128263	19128263	0	0
21500342	1119510	1	1
4086181	378419	5	6
36202157	4109685	4	8
36151207	1112807	0	0
40244587	1125315	0	0
37202316	441267	5	6
44338171	1119510	0	0
44339286	1539411	2	3
44337721	1309944	0	0
44361919	1125315	0	0
44351994	1112807	0	0
44351552	1119510	0	0
45651912	1125315	0	0
45624105	1177480	0	0
45668474	1589505	0	0
45682916	40232448	2	3
45680324	1119510	0	0
45633722	975125	0	0
45701080	1119510	0	0
45783017	1125315	0	0
45685850	1129625	0	0
45706221	1125315	0	0
45792507	975125	0	0
45789681	1125315	0	0
46239310	1125315	0	0
45793965	1119510	0	0
46311263	1729720	0	0
46315754	1326303	0	0
45675348	1589505	0	0
1580755	791967	0	0
4221994	4037675	4	4
19127917	19127918	0	0
21505970	1154615	1	1
138239	4109685	5	6
36202157	4156265	3	8
36151165	1515774	0	0
40244591	1177480	0	0
37503959	4336464	5	6
44338227	1119510	0	0
44356731	40223768	2	3
44337569	975125	0	0
44362021	1125315	0	0
44347543	1112807	0	0
44351794	1119510	0	0
45651895	1125315	0	0
45623877	1177480	0	0
45668858	1551099	0	0
45683356	40232448	2	3
45680090	1119510	0	0
45633769	975125	0	0
45700922	1119510	0	0
45783018	1125315	0	0
45685694	1129625	0	0
45706146	1125315	0	0
45792513	1107830	0	0
45789821	1125315	0	0
46239316	1125315	0	0
45793967	1119510	0	0
46310937	742185	0	0
46315598	1310149	0	0
45675371	1332418	0	0
1580756	1367571	0	0
4300157	4048695	4	4
19127918	19127918	0	0
21604566	19115351	1	1
255919	40481087	5	7
36202157	78272	3	11
36151165	1549786	0	0
40243436	40243436	0	0
36718119	4043241	5	6
44338133	1119510	0	0
44350323	40223768	2	3
44337573	1361711	0	0
44362207	1125315	0	0
44347360	1112807	0	0
44351658	1119510	0	0
45651906	1125315	0	0
45668005	1177480	0	0
45668875	1000560	0	0
45679880	40174880	2	3
45680295	1119510	0	0
45633933	975125	0	0
45701056	1119510	0	0
45783033	1125315	0	0
45685868	1129625	0	0
45706165	1125315	0	0
45792172	1192710	0	0
45789893	1125315	0	0
46239298	1125315	0	0
45793984	1119510	0	0
46311134	1551099	0	0
46315602	975125	0	0
45675380	1115008	0	0
1580762	1177480	0	0
4300157	4059173	4	4
19127921	19127922	0	0
21604795	40223774	1	1
4086181	375671	5	7
36202157	81151	3	10
36151170	1778162	0	0
40244494	933724	0	0
37202319	313217	6	7
44338098	1119510	0	0
44356764	19073183	2	3
44337632	1118084	0	0
44362171	1125315	0	0
44343880	1112807	0	0
44351564	1119510	0	0
45652125	1125315	0	0
45667896	1177480	0	0
45668842	1149196	0	0
45679602	40174880	2	3
45680306	1119510	0	0
45630809	975125	0	0
45701347	1119510	0	0
45783154	1125315	0	0
45685299	1129625	0	0
45706174	1125315	0	0
45792175	933724	0	0
45789969	1125315	0	0
46239302	1125315	0	0
45793777	1119510	0	0
46311179	975125	0	0
46315986	1738521	0	0
45675449	914335	0	0
1580850	1713332	0	0
4300157	40479768	4	4
19127921	19133679	0	0
21504611	40171902	1	1
135930	40480160	4	7
36202157	40479422	5	10
36151177	1107830	0	0
40244509	705944	0	0
36702253	4132546	6	8
44362849	1119510	0	0
44364338	1107882	2	3
44337722	1500211	0	0
44362062	1125315	0	0
45620278	1112807	0	0
44351822	1119510	0	0
45652244	1125315	0	0
45668008	1177480	0	0
45668888	1153428	0	0
45679927	19019273	2	3
45680326	1119510	0	0
45630918	975125	0	0
45701064	1119510	0	0
45783157	1125315	0	0
45799837	1129625	0	0
45706176	1125315	0	0
45792690	1112807	0	0
45789695	1125315	0	0
46239303	1125315	0	0
45794038	1119510	0	0
46311368	975125	0	0
46315999	1112807	0	0
45675309	1307863	0	0
1580773	967823	0	0
4223759	4048171	4	4
19127921	19129144	0	0
21010499	40171902	1	1
4309188	81893	3	8
36200000	4113008	4	8
36151296	1153428	0	0
40244527	753626	0	0
36702247	378419	6	8
44362864	1119510	0	0
44339251	1545959	2	3
44337592	920293	0	0
44362064	1125315	0	0
45620238	1112807	0	0
44351825	1119510	0	0
45652245	1125315	0	0
45668365	1177480	0	0
45668889	920293	0	0
45682301	1154615	2	3
45680471	1119510	0	0
45627868	975125	0	0
45700871	1119510	0	0
45782891	1125315	0	0
45797351	1129625	0	0
45706265	1125315	0	0
45792695	1746114	0	0
45789166	1125315	0	0
46239209	1125315	0	0
45794048	1119510	0	0
46311375	975125	0	0
46310172	1153428	0	0
45675329	1149196	0	0
1580890	920293	0	0
4224260	4048171	4	4
19127922	19127922	0	0
21504609	1332418	1	1
4047779	4280726	4	8
36200000	4218389	4	8
36151300	1153428	0	0
40244529	1115008	0	0
36718338	4043241	6	8
44362865	1119510	0	0
44346613	1107882	2	3
45622170	1501700	0	0
44362068	1125315	0	0
45620557	1112807	0	0
44343804	1119510	0	0
45650982	1125315	0	0
45665914	1177480	0	0
45668894	975125	0	0
45682308	19008572	2	3
45680475	1119510	0	0
45676363	975125	0	0
45700784	1119510	0	0
45782999	1125315	0	0
45797431	1129625	0	0
45706323	1125315	0	0
45792695	1741122	0	0
45789167	1125315	0	0
46239012	1125315	0	0
45794130	1119510	0	0
46311338	1154343	0	0
46310187	1322184	0	0
45675392	1396131	0	0
1580850	1759842	0	0
4309188	4310024	4	4
19128008	19128009	0	0
21013671	40171902	1	1
255919	4294548	5	8
36200000	40480160	4	10
36150941	1332418	0	0
40244531	1125315	0	0
37502353	4057420	6	9
44362903	1119510	0	0
44363289	1107882	2	3
45622043	19127890	0	0
45655989	1125315	0	0
45620497	1112807	0	0
44343889	1119510	0	0
45650889	1125315	0	0
45665918	1177480	0	0
45668843	1713332	0	0
45682315	19133768	2	3
45680627	1119510	0	0
45676255	975125	0	0
45700834	1119510	0	0
45783066	1125315	0	0
45682402	1129625	0	0
45706559	1125315	0	0
45792651	738818	0	0
45789170	1125315	0	0
46239013	1125315	0	0
45793882	1119510	0	0
46311297	1332418	0	0
46310132	975125	0	0
45675358	1177480	0	0
1580932	1112807	0	0
4303236	4336464	4	4
19128009	19128009	0	0
21013692	19074679	1	1
4180169	4048171	5	8
36200000	4146173	4	10
36150942	1129625	0	0
40244535	1154029	0	0
37002287	45769019	6	6
44362820	1119510	0	0
44363093	1107882	2	3
45622043	1589505	0	0
45655996	1125315	0	0
44362325	1112807	0	0
44344163	1119510	0	0
45650931	1125315	0	0
45665762	1177480	0	0
45668845	1115008	0	0
45682405	19078461	2	3
45680373	1119510	0	0
45670282	975125	0	0
45697940	1119510	0	0
45783130	1125315	0	0
45794835	1129625	0	0
45706561	1125315	0	0
45792652	1115008	0	0
45789229	1125315	0	0
46239014	1125315	0	0
45794035	1119510	0	0
46311308	1124300	0	0
46309612	1124957	0	0
45675330	1112807	0	0
1580935	1501700	0	0
4227253	317576	4	4
19128021	19128263	0	0
21501117	1759842	3	3
21604180	40223774	5	5
36200000	78272	4	12
36150943	1177480	0	0
40244608	1548195	0	0
37600000	313217	7	8
44362932	1119510	0	0
44356961	1107882	2	3
45622043	1549786	0	0
45655792	1125315	0	0
44362188	1112807	0	0
44344011	1119510	0	0
45650954	1125315	0	0
45666013	1177480	0	0
45668946	1307863	0	0
45682430	19079524	2	3
45680353	1119510	0	0
45670716	975125	0	0
45697921	1119510	0	0
45783131	1125315	0	0
45794909	1129625	0	0
45706192	1125315	0	0
45792458	1115008	0	0
45789260	1125315	0	0
46239019	1125315	0	0
45794106	1119510	0	0
46311239	1124957	0	0
46309613	975125	0	0
45675331	1545958	0	0
1177480	1177480	0	0
4305027	4109685	4	4
19128021	19128022	0	0
21502584	19074679	3	3
21604180	19115351	5	5
36200000	4278672	3	10
36151179	1129625	0	0
40244593	1177480	0	0
36718588	4043241	7	8
44363126	1119510	0	0
44348184	1107882	2	3
45622228	715997	0	0
45655832	1125315	0	0
44362475	1112807	0	0
44344122	1119510	0	0
45650894	1125315	0	0
45666247	1177480	0	0
45668554	1149196	0	0
45706925	19078461	2	3
45680634	1119510	0	0
45670481	975125	0	0
45698022	1119510	0	0
45783110	1125315	0	0
45679334	1129625	0	0
45706197	1125315	0	0
45792676	1149196	0	0
45787032	1125315	0	0
46239020	1125315	0	0
45794108	1119510	0	0
46311579	1729720	0	0
46309616	1000560	0	0
45675332	1119510	0	0
1192710	1192710	0	0
4305027	4059173	4	4
19128022	19128022	0	0
21500001	1759842	3	3
35202457	4310024	5	5
36200000	4066995	3	10
36151187	1545958	0	0
40244611	1149196	0	0
36703500	4043241	7	9
44362548	1119510	0	0
44349397	19078461	2	3
45621903	1110410	0	0
45655844	1125315	0	0
44362665	1112807	0	0
44344070	1119510	0	0
45651124	1125315	0	0
45663767	1177480	0	0
45668557	1192710	0	0
45670484	19078461	2	3
45680690	1119510	0	0
45670697	975125	0	0
45698023	1119510	0	0
45783111	1125315	0	0
45679267	1129625	0	0
45706305	1125315	0	0
45792467	1326303	0	0
45786988	1125315	0	0
46239026	1125315	0	0
45793946	1119510	0	0
46311590	1107830	0	0
46309617	1112807	0	0
45675333	1115008	0	0
791967	791967	0	0
4326426	4337611	4	4
19128050	19128065	0	0
21500001	1741122	3	3
35305792	4144583	5	5
36200000	4155034	5	8
36151334	1177480	0	0
40244682	1112807	0	0
37502353	4198190	8	10
44362770	1119510	0	0
44354055	1107882	2	3
45622021	1738521	0	0
45655911	1125315	0	0
44362381	1112807	0	0
44344388	1119510	0	0
45651131	1125315	0	0
45663502	1177480	0	0
45668645	1778162	0	0
45624800	40228214	2	3
45680694	1119510	0	0
45670700	975125	0	0
45697994	1119510	0	0
45783315	1125315	0	0
45679186	1129625	0	0
45700701	1125315	0	0
45789500	1192710	0	0
45787098	1125315	0	0
46239028	1125315	0	0
45794200	1119510	0	0
46311594	738818	0	0
46309618	1153428	0	0
45675339	791967	0	0
920293	920293	0	0
4304358	4181917	4	4
19128065	19128065	0	0
21500001	1713332	3	3
35302074	378419	5	5
36111047	4116491	4	6
36151340	1115008	0	0
40244683	1112807	0	0
36702253	380378	7	7
44362767	1119510	0	0
44341340	19078461	2	3
45622028	1149196	0	0
45656029	1125315	0	0
44354903	1112807	0	0
44344140	1119510	0	0
45651102	1125315	0	0
45663446	1177480	0	0
45668652	1115008	0	0
45691579	19079524	2	3
45676701	1119510	0	0
45670361	975125	0	0
45698008	1119510	0	0
45783230	1125315	0	0
45679282	1129625	0	0
45700634	1125315	0	0
45789525	1545958	0	0
45786990	1125315	0	0
46239029	1125315	0	0
45794202	1119510	0	0
46306988	1738521	0	0
46309622	1174888	0	0
45675463	1192710	0	0
433125	433125	0	0
4240345	4010253	4	4
19127890	19127890	0	0
21500001	1746114	3	3
35306088	4043241	5	5
36111047	4294548	3	6
36150886	1115008	0	0
40244685	1129625	0	0
36702253	378001	8	10
44362782	1119510	0	0
44352310	19075601	2	3
45622002	1539403	0	0
45656064	1125315	0	0
44355049	1112807	0	0
44344145	1119510	0	0
45651067	1125315	0	0
45663871	1177480	0	0
45668658	740275	0	0
45706950	19078461	2	3
45679455	1119510	0	0
45669178	975125	0	0
45698170	1119510	0	0
45783034	1125315	0	0
45792259	1129625	0	0
45700628	1125315	0	0
45789590	1551099	0	0
45787039	1125315	0	0
46239234	1125315	0	0
45794265	1119510	0	0
46305633	723013	0	0
46309821	1112807	0	0
45675345	1551099	0	0
433644	433644	0	0
4240345	4037675	4	4
21505985	1112807	0	0
21500001	1729720	3	3
35204998	313217	4	5
36110538	4116491	4	6
36150947	1112807	0	0
40244686	1125315	0	0
37203758	40481087	6	7
44362620	1119510	0	0
44350206	1332419	2	3
45621905	1149196	0	0
45656066	1125315	0	0
44355015	1112807	0	0
44343934	1119510	0	0
45651109	1125315	0	0
45660236	1177480	0	0
45668661	1551099	0	0
45630832	40228214	2	3
45677145	1119510	0	0
45669185	975125	0	0
45698189	1119510	0	0
45783458	1125315	0	0
45792249	1129625	0	0
45699774	1125315	0	0
45789563	1332418	0	0
45787052	1125315	0	0
46239270	1125315	0	0
45794219	1119510	0	0
46305589	1149196	0	0
46310029	701322	0	0
45675347	967823	0	0
313217	313217	0	0
4304110	4304110	0	0
21505985	1125315	0	0
21500001	1728416	3	3
21603891	19007333	4	5
36110538	4112343	3	6
36150778	1000560	0	0
40244644	1125315	0	0
37200000	4329847	6	7
44362621	1119510	0	0
44364302	40228214	2	3
45622214	738818	0	0
45656069	1125315	0	0
45655325	1112807	0	0
44344326	1119510	0	0
45647850	1125315	0	0
45660357	1177480	0	0
45668667	1343916	0	0
45685752	19075601	2	3
45677188	1119510	0	0
45666632	975125	0	0
45698205	1119510	0	0
45783141	1125315	0	0
45792480	1129625	0	0
45699781	1125315	0	0
45789627	1112807	0	0
45787132	1125315	0	0
46239413	1125315	0	0
45789336	1119510	0	0
46305694	1305058	0	0
46310038	1192710	0	0
45675399	1129625	0	0
1545959	1545959	0	0
21000967	708298	0	0
21505988	1332418	0	0
21500001	1717327	3	3
21603445	40229134	4	5
36110538	4294548	3	6
36151315	933724	0	0
40244678	1129625	0	0
37200000	317576	6	6
44359397	1119510	0	0
44356668	1332419	2	3
45622089	975125	0	0
45656195	1125315	0	0
44348065	1112807	0	0
44344418	1119510	0	0
45647918	1125315	0	0
45660451	1177480	0	0
45668850	740275	0	0
45658330	19079524	2	3
45677194	1119510	0	0
45666847	975125	0	0
45698214	1119510	0	0
45783081	1125315	0	0
45792098	1129625	0	0
45699783	1125315	0	0
45789628	1367571	0	0
45787133	1125315	0	0
46239414	1125315	0	0
45789341	1119510	0	0
46305986	1174888	0	0
46310041	1112807	0	0
45675348	1549786	0	0
443279	443279	0	0
21000967	723013	0	0
21505901	1125315	0	0
21503967	1174888	3	3
21603445	40232448	4	5
36103041	4056621	4	6
36151348	1129625	0	0
40244678	1125315	0	0
37200000	4048171	5	11
44359451	1119510	0	0
44349678	1332419	2	3
45622216	1310149	0	0
45656405	1125315	0	0
44341412	1112807	0	0
44337475	1119510	0	0
45647927	1125315	0	0
45660453	1177480	0	0
45668732	1738521	0	0
45630905	1539411	2	3
45677209	1119510	0	0
45667001	975125	0	0
45695087	1119510	0	0
45782945	1125315	0	0
45676149	1129625	0	0
45699785	1125315	0	0
45789532	1154343	0	0
45787136	1125315	0	0
46239143	1125315	0	0
45789358	1119510	0	0
46322654	1545958	0	0
46311973	1149196	0	0
45675321	1107830	0	0
375671	375671	0	0
21000967	791967	0	0
21506025	914335	0	0
21503967	1102527	3	3
21604254	35605858	4	5
36102970	4056621	4	6
36151354	1149380	0	0
40244623	1125315	0	0
37503992	4242997	6	7
44359630	1119510	0	0
44364123	19073183	2	3
45622177	1192710	0	0
45655921	1125315	0	0
44341364	1112807	0	0
44338021	1119510	0	0
45648042	1125315	0	0
45660583	1177480	0	0
45668733	1154343	0	0
45686206	1539411	2	3
45677336	1119510	0	0
45667088	975125	0	0
45694787	1119510	0	0
45783143	1125315	0	0
45791951	1129625	0	0
45699912	1125315	0	0
45789610	1000560	0	0
45787104	1125315	0	0
46239145	1125315	0	0
45788750	1119510	0	0
46322659	791967	0	0
46311989	1501700	0	0
45675364	1549786	0	0
4001336	4001336	0	0
21000970	723013	0	0
21506026	914335	0	0
21503967	1177480	3	3
21604254	40231925	4	5
35702767	440448	5	6
36151342	1177480	0	0
40244595	1177480	0	0
37503992	4163971	3	8
44359547	1119510	0	0
44364123	19073188	2	3
45622184	1545958	0	0
45656305	1125315	0	0
44340942	1112807	0	0
44337612	1119510	0	0
45648044	1125315	0	0
45660594	1177480	0	0
45668735	1149196	0	0
45694635	1539411	2	3
45677299	1119510	0	0
45780958	975125	0	0
45695104	1119510	0	0
45783205	1125315	0	0
45789490	1129625	0	0
45699817	1125315	0	0
45789620	1112807	0	0
45787086	1125315	0	0
46239146	1125315	0	0
45788732	1119510	0	0
46322081	1501700	0	0
46311899	1107830	0	0
45675364	19127890	0	0
1766573	1307863	0	0
21000247	1728416	0	0
21506003	1177480	0	0
21503967	1124957	3	3
21603395	40162522	4	5
36202157	4299128	6	6
36151074	1545958	0	0
40244716	1153428	0	0
37503992	4293740	3	3
44359512	1119510	0	0
44339476	19078461	2	3
45622194	1589505	0	0
45656307	1125315	0	0
44341040	1112807	0	0
44337526	1119510	0	0
45648133	1125315	0	0
45660411	1177480	0	0
45668736	1149196	0	0
45630908	19079524	2	3
45677249	1119510	0	0
45706948	975125	0	0
45694915	1119510	0	0
45783425	1125315	0	0
45786511	1129625	0	0
45699818	1125315	0	0
45789622	1729720	0	0
45787139	1125315	0	0
46239156	1125315	0	0
45788822	1119510	0	0
46322692	791967	0	0
46311888	1548195	0	0
45675364	1512674	0	0
1766432	1119510	0	0
21000244	1778162	0	0
21506003	1129625	0	0
21500363	1343916	3	3
21603395	19133768	4	5
36102898	4294548	6	6
36151320	1746114	0	0
40244700	1551099	0	0
37503992	4301346	5	6
44359761	1119510	0	0
44342875	19075601	2	3
45622194	1549786	0	0
45656310	1125315	0	0
44340954	1112807	0	0
44337655	1119510	0	0
45647969	1125315	0	0
45660643	1177480	0	0
45668747	1309944	0	0
45701069	40228214	2	3
45674056	1119510	0	0
45706984	975125	0	0
45695066	1119510	0	0
45783435	1125315	0	0
45786431	1129625	0	0
45699734	1125315	0	0
45789724	1322184	0	0
45787215	1125315	0	0
46239158	1125315	0	0
45788906	1119510	0	0
46322111	1310149	0	0
46312075	701322	0	0
45675470	1778162	0	0
1766436	1343916	0	0
21000290	1738521	0	0
21506003	1115008	0	0
21500363	40169281	3	3
21603395	40229134	4	5
35802131	4218389	5	6
36151320	1741122	0	0
40244684	1125315	0	0
37503992	4337138	4	5
44359700	1119510	0	0
44357095	19075601	2	3
44358795	1545958	0	0
45656215	1125315	0	0
45621793	1112807	0	0
44337713	1119510	0	0
45648148	1125315	0	0
45658434	1177480	0	0
45668748	742185	0	0
45683466	1332419	2	3
45674226	1119510	0	0
45707256	975125	0	0
45645802	1119510	0	0
45783439	1125315	0	0
45785259	1129625	0	0
45699843	1125315	0	0
45789738	1102527	0	0
45787166	1125315	0	0
46239426	1125315	0	0
45788911	1119510	0	0
46322119	1332418	0	0
46312002	1124957	0	0
45675564	1741122	0	0
1759842	1759842	0	0
21000290	1713332	0	0
21506037	1308738	0	0
21502569	1551099	3	3
21604254	40165015	2	5
35802841	4084167	4	5
36151321	1129625	0	0
40244679	1129625	0	0
37500000	4108705	4	8
44355619	1119510	0	0
44356247	1539411	2	3
44358545	1124300	0	0
45652626	1125315	0	0
45620570	1112807	0	0
44337719	1119510	0	0
45648224	1125315	0	0
45658352	1177480	0	0
45668821	1107830	0	0
45645804	40228214	2	3
45673981	1119510	0	0
45707104	975125	0	0
45691530	1119510	0	0
45783258	1125315	0	0
45785436	1129625	0	0
45699853	1125315	0	0
45789631	1112807	0	0
45787167	1125315	0	0
46239160	1125315	0	0
45788929	1119510	0	0
46322125	975125	0	0
46312074	1539403	0	0
45675564	1746114	0	0
1343916	1343916	0	0
21000289	1738521	0	0
21506081	1501700	0	0
21502569	975125	3	3
21603445	40223821	2	5
36110015	4116491	5	5
36151322	914335	0	0
40244680	1125315	0	0
37500000	4337611	4	8
44356063	1119510	0	0
44353962	40228214	2	3
44358650	1589505	0	0
45652690	1125315	0	0
45661699	1112807	0	0
45622045	1119510	0	0
45648232	1125315	0	0
45657582	1177480	0	0
45668831	1154343	0	0
45636945	19078461	2	3
45673779	1119510	0	0
45707109	975125	0	0
45691682	1119510	0	0
45783207	1125315	0	0
45785371	1129625	0	0
45700059	1125315	0	0
45789828	1174888	0	0
45787172	1125315	0	0
46239159	1125315	0	0
45789016	1119510	0	0
46322127	1149196	0	0
46312015	791967	0	0
45675416	1112807	0	0
1000560	1000560	0	0
21000285	1738521	0	0
21506064	1192710	0	0
21502571	19128263	3	3
21603445	40223834	2	5
36111047	433125	5	5
36151326	738818	0	0
40244681	1125315	0	0
37500000	4035793	4	6
44355795	1119510	0	0
44349402	19075601	2	3
44358650	1549786	0	0
45652664	1125315	0	0
45661564	1112807	0	0
45622214	1119510	0	0
45648272	1125315	0	0
45657655	1177480	0	0
45668880	1192710	0	0
45695049	1332419	2	3
45674362	1119510	0	0
45707088	975125	0	0
45691967	1119510	0	0
45783304	1125315	0	0
45785535	1129625	0	0
45700061	1125315	0	0
45789830	967823	0	0
45787333	1125315	0	0
45894584	1125315	0	0
45788868	1119510	0	0
46322581	1174888	0	0
46312021	1501700	0	0
45675497	1192710	0	0
782047	782047	0	0
21000267	1778162	0	0
21505823	1125315	0	0
21502571	19128022	3	3
21603445	19125062	2	5
36111047	198199	5	5
36151083	1107830	0	0
40244648	1124300	0	0
37500000	4197460	4	6
44355653	1119510	0	0
44358904	19075601	2	3
44358654	1713332	0	0
45652667	1125315	0	0
45662009	1112807	0	0
45658585	1119510	0	0
45648273	1125315	0	0
45657943	1177480	0	0
45668880	738818	0	0
45694959	40228214	2	3
45674370	1119510	0	0
45707099	975125	0	0
45691969	1119510	0	0
45783306	1125315	0	0
45785424	1129625	0	0
45693369	1125315	0	0
45789763	1729720	0	0
45787335	1125315	0	0
45894376	1125315	0	0
45788869	1119510	0	0
46322586	1738521	0	0
46312035	975125	0	0
45675502	975125	0	0
441267	441267	0	0
21000289	1728416	0	0
21505824	1125315	0	0
21502571	19128009	3	3
21603445	1150771	2	5
36111047	28060	5	5
36151085	1177480	0	0
40244725	1177480	0	0
37500000	4337138	3	7
44355945	1119510	0	0
44354091	19075601	2	3
44358676	1124957	0	0
45652749	1125315	0	0
45662011	1112807	0	0
45658699	1119510	0	0
45648286	1125315	0	0
45654222	1177480	0	0
45668884	1192710	0	0
45701165	19079524	2	3
45674045	1119510	0	0
45706511	975125	0	0
45691884	1119510	0	0
45783333	1125315	0	0
45785378	1129625	0	0
45693380	1125315	0	0
45789634	1174888	0	0
45787325	1125315	0	0
45894378	1125315	0	0
46296637	1119510	0	0
46322608	738818	0	0
46312263	975125	0	0
45675524	1177480	0	0
80809	80809	0	0
21000289	1778162	0	0
21505824	1119510	0	0
21502571	40221415	3	3
21603445	1150837	2	5
36111047	40481087	4	5
36151209	1000560	0	0
40244594	1177480	0	0
37500000	4330583	3	11
44356190	1119510	0	0
44342756	19075601	2	3
44358767	1717327	0	0
45652751	1125315	0	0
45661915	1112807	0	0
45658796	1119510	0	0
45648156	1125315	0	0
45654332	1177480	0	0
45668952	1305058	0	0
45670605	40228214	2	3
45674052	1119510	0	0
45704274	975125	0	0
45692039	1119510	0	0
45782953	1125315	0	0
45785386	1129625	0	0
45693523	1125315	0	0
45789635	1153428	0	0
45787415	1125315	0	0
45894620	1125315	0	0
46296499	1119510	0	0
46316495	738818	0	0
46312267	1153428	0	0
45675324	1177480	0	0
133834	133834	0	0
21000050	1738521	0	0
21505836	1125315	0	0
21502571	42902245	3	3
21603445	40228230	2	5
36111047	4056621	3	5
36151215	1129625	0	0
40244747	1125315	0	0
37500000	4198190	3	11
44356221	1119510	0	0
44339437	19078461	2	3
44358768	1545958	0	0
45652444	1125315	0	0
45661921	1112807	0	0
45658469	1119510	0	0
45648290	1125315	0	0
45654276	1177480	0	0
45670389	1501700	0	0
45642829	19075601	2	3
45674194	1119510	0	0
45704306	975125	0	0
45691805	1119510	0	0
45780566	1125315	0	0
45783421	1129625	0	0
45693338	1125315	0	0
45789650	738818	0	0
45787194	1125315	0	0
45894661	1125315	0	0
46295018	1119510	0	0
46316509	1332418	0	0
46310341	1174888	0	0
45675434	1738521	0	0
81893	81893	0	0
21000051	1728416	0	0
21505836	1119510	0	0
21502571	19128065	3	3
21603445	1107882	2	5
36110538	4056621	3	5
36151220	1107830	0	0
40244878	791967	0	0
37500000	4323902	3	9
44356044	1119510	0	0
44346843	19078461	2	3
45658524	791967	0	0
45652568	1125315	0	0
45658259	1112807	0	0
45658656	1119510	0	0
45648092	1125315	0	0
45654403	1177480	0	0
45670397	1124300	0	0
45688833	19079524	2	3
45673724	1119510	0	0
45704467	975125	0	0
45688807	1119510	0	0
45780553	1125315	0	0
45783330	1129625	0	0
45693340	1125315	0	0
45789651	933724	0	0
45785502	1125315	0	0
45894431	1125315	0	0
46295088	1119510	0	0
46316510	1310149	0	0
46310251	1154343	0	0
45675525	1307863	0	0
3014576	3014576	0	0
21000051	1717327	0	0
21505839	1125315	0	0
21502571	19127904	3	3
21603445	43012036	2	5
36110538	40481087	4	5
36151222	738818	0	0
40772948	3012494	5	5
37500000	4216130	3	3
44356009	1119510	0	0
44364013	1539411	2	3
45658529	1110410	0	0
45652581	1125315	0	0
45655669	1112807	0	0
45658474	1119510	0	0
45644789	1125315	0	0
45654440	1177480	0	0
45666456	1557272	0	0
45645792	40228214	2	3
45673913	1119510	0	0
45704497	975125	0	0
45688792	1119510	0	0
45780445	1125315	0	0
45783467	1129625	0	0
45693532	1125315	0	0
45789656	975125	0	0
45785602	1125315	0	0
45894436	1125315	0	0
46295196	1119510	0	0
46316513	1149196	0	0
46310263	1174888	0	0
45675532	1153428	0	0
3014599	3014599	0	0
21000051	1738521	0	0
21505840	1125315	0	0
21502571	19127918	3	3
21603041	920334	2	5
36110538	198199	5	5
36151232	1177480	0	0
40772948	3000876	5	5
37500000	4238715	3	3
44356021	1119510	0	0
44349572	40228214	2	3
45658649	1759842	0	0
45652639	1125315	0	0
45655766	1112807	0	0
45658592	1119510	0	0
45644783	1125315	0	0
45654355	1177480	0	0
45666541	1149196	0	0
45700959	19079524	2	3
45674303	1119510	0	0
45701024	975125	0	0
45688927	1119510	0	0
45780659	1125315	0	0
45783523	1129625	0	0
45693571	1125315	0	0
45789647	1778162	0	0
45785603	1125315	0	0
45894438	1125315	0	0
46295537	1119510	0	0
46317368	1326303	0	0
46310309	1174888	0	0
45675646	1177480	0	0
3026361	3026361	0	0
21000052	1738521	0	0
21505843	1112807	0	0
21500269	1308738	3	3
35202457	4329847	3	5
36110538	433125	5	5
36151236	1332418	0	0
40772948	3020655	5	5
37500000	4043071	5	7
44356143	1119510	0	0
44349646	40228214	2	3
45658649	1713332	0	0
45655036	1125315	0	0
45655735	1112807	0	0
45658610	1119510	0	0
45644997	1125315	0	0
45654457	1177480	0	0
45666516	1174888	0	0
45695077	40228214	2	3
45671338	1119510	0	0
45701012	975125	0	0
45689009	1119510	0	0
46244963	1125315	0	0
46291453	1129625	0	0
45693539	1125315	0	0
45789665	1107830	0	0
45785604	1125315	0	0
45894666	1125315	0	0
46295439	1119510	0	0
46317204	1738521	0	0
46310321	1310149	0	0
45675419	1149196	0	0
3027231	3027231	0	0
21000052	1717327	0	0
21505803	1125315	0	0
21604146	1557272	3	3
35202457	317576	3	5
36110538	28060	5	5
36151242	738818	0	0
40772948	3005136	5	5
37500000	4202451	5	5
44356162	1119510	0	0
44346142	40228214	2	3
45658652	1153428	0	0
45655041	1125315	0	0
44348267	1112807	0	0
45658951	1119510	0	0
45644847	1125315	0	0
45654487	1177480	0	0
45666494	1149196	0	0
45633789	19079524	2	3
45671165	1119510	0	0
45698072	975125	0	0
45688980	1119510	0	0
46244687	1125315	0	0
46291709	1129625	0	0
45693543	1125315	0	0
45789666	1107830	0	0
45785682	1125315	0	0
45894728	1125315	0	0
46295624	1119510	0	0
46318002	1149196	0	0
46310447	1746114	0	0
45675476	1124300	0	0
3015632	3015632	0	0
21000052	1728416	0	0
21505804	1112807	0	0
21500284	1153428	3	3
35300000	378419	6	6
35802133	4066995	4	4
36151246	1177480	0	0
40772948	3001247	5	5
37500000	4323208	5	5
44352659	1119510	0	0
44350426	40228214	2	3
45658396	1124957	0	0
45655043	1125315	0	0
44778042	1129625	0	0
45652416	1119510	0	0
45644788	1125315	0	0
45654519	1177480	0	0
45666486	1332418	0	0
45648609	19078461	2	3
45671167	1119510	0	0
45695040	975125	0	0
45689129	1119510	0	0
46244949	1125315	0	0
46291780	1129625	0	0
45693494	1125315	0	0
45789670	1174888	0	0
45785508	1125315	0	0
45893552	1125315	0	0
46295243	1119510	0	0
46317189	975125	0	0
46310447	1741122	0	0
45675482	1177480	0	0
3019406	3019406	0	0
21000054	1728416	0	0
21505805	1112807	0	0
21500284	1129625	3	3
35302548	4144583	6	6
35702118	4027663	4	4
36151249	1115008	0	0
40772948	3027231	5	5
37500000	4057420	5	10
44352665	1119510	0	0
44346661	40228214	2	3
45658451	1551099	0	0
45655057	1125315	0	0
44778286	1129625	0	0
45652468	1119510	0	0
45644895	1125315	0	0
45651952	1177480	0	0
45666544	1557272	0	0
45778449	19078461	2	3
45671242	1119510	0	0
45695021	975125	0	0
45688959	1119510	0	0
45777674	1125315	0	0
46291888	1129625	0	0
45693427	1125315	0	0
45789782	1326303	0	0
45785745	1125315	0	0
45893544	1125315	0	0
46295245	1119510	0	0
46317192	1174888	0	0
46310430	1192710	0	0
45675508	1110410	0	0
3027970	3027970	0	0
21000054	1717327	0	0
21505807	1125315	0	0
21500284	1149196	3	3
35302568	4043241	6	6
36110015	433125	4	4
36151251	914335	0	0
40779555	3049273	5	5
42888892	134438	2	2
44353334	1119510	0	0
44363054	40228214	2	3
45658544	791967	0	0
45655170	1125315	0	0
44778240	1129625	0	0
45652480	1119510	0	0
45644912	1125315	0	0
45651890	1177480	0	0
45666556	1174888	0	0
45685974	19078461	2	3
45671350	1119510	0	0
45695096	975125	0	0
45685763	1119510	0	0
45777770	1125315	0	0
46295775	1129625	0	0
45693733	1125315	0	0
45789673	1501700	0	0
45785569	1125315	0	0
45893547	1125315	0	0
46295351	1119510	0	0
46317882	1174888	0	0
46310433	1000560	0	0
45675445	1119510	0	0
3004501	3004501	0	0
21000053	1728416	0	0
21505808	1115008	0	0
21500284	1150770	3	3
21602359	19128065	6	6
36110015	28060	4	4
36151359	1589505	0	0
37503862	4301346	5	5
43021227	4084167	2	2
44352858	1119510	0	0
44354096	40228214	2	3
45658680	1501700	0	0
45655260	1125315	0	0
44359143	1129625	0	0
45652343	1119510	0	0
45644922	1125315	0	0
45651034	1177480	0	0
45666556	1192710	0	0
45688664	19078461	2	3
45671356	1119510	0	0
45691870	975125	0	0
45685769	1119510	0	0
45777774	1125315	0	0
46244995	1129625	0	0
45693716	1125315	0	0
45789706	1307863	0	0
45785523	1125315	0	0
45893582	1125315	0	0
46295637	1119510	0	0
46317932	967823	0	0
46310383	1549786	0	0
45675445	1192710	0	0
3011505	3011505	0	0
21000057	1738521	0	0
21505808	1177480	0	0
21500284	738818	3	3
21602751	40174880	5	6
36150696	19127922	3	4
36151362	19003953	0	0
37503862	44783196	5	5
43053691	4048695	2	2
44352826	1119510	0	0
44350313	40223768	2	3
45658694	1107830	0	0
45655346	1125315	0	0
44358860	1129625	0	0
45652123	1119510	0	0
45645012	1125315	0	0
45650927	1177480	0	0
45666579	1551099	0	0
45682819	19078461	2	3
45671279	1119510	0	0
45691887	975125	0	0
45686181	1119510	0	0
45778228	1125315	0	0
46242645	1129625	0	0
45693608	1125315	0	0
45789720	1713332	0	0
45785856	1125315	0	0
45893556	1125315	0	0
46244353	1119510	0	0
46317623	1501700	0	0
46310383	19127890	0	0
45675484	1119510	0	0
3016723	3016723	0	0
21000058	1728416	0	0
21505809	1125315	0	0
21500284	1150836	3	3
21604069	42707627	5	6
36157979	1153428	0	0
36150969	1177480	0	0
40792792	3005136	5	5
42804267	40163554	2	3
44352868	1119510	0	0
44350602	19078461	2	3
45658665	740275	0	0
45652854	1125315	0	0
44358570	1129625	0	0
45652544	1119510	0	0
45645014	1125315	0	0
45651063	1177480	0	0
45666517	1326303	0	0
45633767	19078461	2	3
45671228	1119510	0	0
45692009	975125	0	0
45686191	1119510	0	0
45778232	1125315	0	0
46242724	1129625	0	0
45693616	1125315	0	0
45789786	967823	0	0
45785628	1125315	0	0
45893562	1125315	0	0
46244325	1119510	0	0
46317635	1115008	0	0
46310387	1112807	0	0
45675484	738818	0	0
3006734	3006734	0	0
21000056	1738521	0	0
21505811	1125315	0	0
21500284	1192710	3	3
21603890	19007333	5	6
36158036	1149196	0	0
36151106	975125	0	0
40228214	40228214	0	0
42806735	40162522	2	3
44352878	1119510	0	0
44364016	19078461	2	3
45658699	738818	0	0
45652855	1125315	0	0
44358518	1129625	0	0
45652726	1119510	0	0
45644884	1125315	0	0
45651101	1177480	0	0
45666599	1115008	0	0
45683024	19078461	2	3
45671444	1119510	0	0
45688883	975125	0	0
45685933	1119510	0	0
45778069	1125315	0	0
46242759	1129625	0	0
45693588	1125315	0	0
45789834	1713332	0	0
45785608	1125315	0	0
45801384	1125315	0	0
46244331	1119510	0	0
46317653	1326303	0	0
46310354	740275	0	0
45675430	1322184	0	0
3028833	3028833	0	0
21000056	1728416	0	0
21505812	1125315	0	0
21505746	1112807	3	3
21604253	35605858	5	6
36158153	1000560	0	0
36151258	1177480	0	0
40223768	40223768	0	0
42806972	1154615	2	3
44352879	1119510	0	0
44342390	19078461	2	3
45658702	740275	0	0
45652781	1125315	0	0
44351493	1129625	0	0
45652222	1119510	0	0
45644966	1125315	0	0
45651225	1177480	0	0
45666602	1501700	0	0
45682734	19078461	2	3
45669852	1119510	0	0
45688855	975125	0	0
45688607	1119510	0	0
45778126	1125315	0	0
46242651	1129625	0	0
45693599	1125315	0	0
45789834	1759842	0	0
45785639	1125315	0	0
45801411	1125315	0	0
46244446	1119510	0	0
46317662	1713332	0	0
46310326	1192710	0	0
45675431	1115008	0	0
3007461	3007461	0	0
21000063	1728416	0	0
21505812	1119510	0	0
21505746	1125315	3	3
21604685	45892894	5	6
36158154	1112807	0	0
36151116	1115008	0	0
43012432	43012433	0	0
42806854	40231925	2	3
44352720	1119510	0	0
44354015	19078461	2	3
45658709	1322184	0	0
45652782	1125315	0	0
44351625	1129625	0	0
45652371	1119510	0	0
45645027	1125315	0	0
45647953	1177480	0	0
45666646	1174888	0	0
45627856	19078461	2	3
45670281	1119510	0	0
45689095	975125	0	0
45688478	1119510	0	0
45777829	1125315	0	0
46242853	1129625	0	0
45693680	1125315	0	0
45789682	975125	0	0
45785644	1125315	0	0
45801401	1125315	0	0
46244337	1119510	0	0
46317311	1153428	0	0
46310448	1112807	0	0
45675617	1129625	0	0
3012494	3012494	0	0
21000064	1728416	0	0
21505812	1192710	0	0
21505746	1129625	3	3
35204998	381316	3	3
36158162	1112807	0	0
36151121	1107830	0	0
43012433	43012433	0	0
42806951	40174880	2	3
44352907	1119510	0	0
44356404	19078461	2	3
45658796	738818	0	0
45652824	1125315	0	0
44351550	1129625	0	0
45652286	1119510	0	0
45644967	1125315	0	0
45648067	1177480	0	0
45666650	1713332	0	0
45627856	1127433	2	3
45669927	1119510	0	0
45686184	975125	0	0
45682858	1119510	0	0
46244647	1125315	0	0
46242728	1129625	0	0
45693905	1125315	0	0
45789819	1332418	0	0
45785668	1125315	0	0
45801406	1125315	0	0
46244338	1119510	0	0
46317901	1308738	0	0
46310503	1112807	0	0
45675619	1119510	0	0
3019550	3019550	0	0
21000059	1717327	0	0
21505813	1119510	0	0
21505746	738818	3	3
35204998	4163874	3	3
36158186	1112807	0	0
36151260	1129625	0	0
43012695	43012433	0	0
42804387	40162522	2	3
44353190	1119510	0	0
44363104	19078461	2	3
45658798	1115008	0	0
45652838	1125315	0	0
44351477	1129625	0	0
45652487	1119510	0	0
45644972	1125315	0	0
45648072	1177480	0	0
45666650	1759842	0	0
45778418	19078461	2	3
45781324	1119510	0	0
45688608	975125	0	0
45683031	1119510	0	0
46244731	1125315	0	0
46242831	1129625	0	0
45693792	1125315	0	0
45789888	715997	0	0
45785703	1125315	0	0
45801752	1125315	0	0
46244506	1119510	0	0
46317323	975125	0	0
46310512	1551099	0	0
45675619	1192710	0	0
1549786	1549786	0	0
21000065	1728416	0	0
21505813	1129625	0	0
21505746	1119510	3	3
35202457	4324181	3	3
36158132	1539403	0	0
36150988	1177480	0	0
43012696	43012433	0	0
42804430	1551192	2	3
44353228	1119510	0	0
44357290	19078461	2	3
45659051	1307863	0	0
45652840	1125315	0	0
44351570	1129625	0	0
45652376	1119510	0	0
45645030	1125315	0	0
45647999	1177480	0	0
45666626	967823	0	0
45670673	19078461	2	3
45781383	1119510	0	0
45688613	975125	0	0
45683045	1119510	0	0
46244699	1125315	0	0
46242792	1129625	0	0
45693794	1125315	0	0
45789795	1110410	0	0
45785692	1125315	0	0
45801389	1125315	0	0
46244596	1119510	0	0
46317538	1192710	0	0
46310418	1112807	0	0
45675515	1361711	0	0
1551192	1551192	0	0
21000066	1728416	0	0
21505813	738818	0	0
21505746	1192710	3	3
35202461	317009	3	3
36158080	1129625	0	0
36150890	1000560	0	0
43012754	43012754	0	0
42804477	40224805	2	3
44348904	1119510	0	0
44358632	19078461	2	3
45658656	738818	0	0
45652929	1125315	0	0
44351670	1129625	0	0
45652439	1119510	0	0
45645044	1125315	0	0
45647971	1177480	0	0
45666653	1326303	0	0
45707083	19078461	2	3
45781250	1119510	0	0
45688616	975125	0	0
45683084	1119510	0	0
46244668	1125315	0	0
46243032	1129625	0	0
45693686	1125315	0	0
45789962	1192710	0	0
45785754	1125315	0	0
45801456	1125315	0	0
46244478	1119510	0	0
46317545	1343916	0	0
46310610	791967	0	0
45675604	1500211	0	0
1551099	1551099	0	0
21000059	1738521	0	0
21505813	1192710	0	0
21500045	1308738	3	3
21602796	1729720	3	3
36157779	738818	0	0
36150892	1332418	0	0
42805668	1000560	0	0
37203769	260139	1	2
44348974	1119510	0	0
44364056	19078461	2	3
45658657	1500211	0	0
45652812	1125315	0	0
44351903	1129625	0	0
44344268	1119510	0	0
45645101	1125315	0	0
45648223	1177480	0	0
45666595	1192710	0	0
45707345	19078461	2	3
45781353	1119510	0	0
45683060	975125	0	0
45682942	1119510	0	0
46242632	1125315	0	0
46242981	1129625	0	0
45693919	1125315	0	0
45789979	1149380	0	0
45785779	1125315	0	0
45801462	1125315	0	0
45787207	1125315	0	0
46318071	1124957	0	0
46310665	1149196	0	0
45675516	1501700	0	0
1551195	19089061	0	0
21000075	1738521	0	0
21505813	1125315	0	0
21604685	836654	3	3
21602796	1741122	3	3
36157783	1129625	0	0
36151266	1177480	0	0
42805863	701322	0	0
37604005	4329847	1	2
44348984	1119510	0	0
44358898	19078461	2	3
45658479	1174888	0	0
45652885	1125315	0	0
44351822	1129625	0	0
44344272	1119510	0	0
45645106	1125315	0	0
45648237	1177480	0	0
45666729	1192710	0	0
45694930	19078461	2	3
45781625	1119510	0	0
45683190	975125	0	0
45682967	1119510	0	0
46242604	1125315	0	0
46243034	1129625	0	0
45691447	1125315	0	0
45789979	1137529	0	0
45785783	1125315	0	0
45801451	1125315	0	0
45787651	1125315	0	0
46316821	1149196	0	0
46310573	1332418	0	0
45675544	1119510	0	0
1347450	1347450	0	0
21000082	1778162	0	0
21505814	738818	0	0
21604181	782043	3	3
21602796	1728416	3	3
36158082	738818	0	0
36151390	975125	0	0
42805765	723013	0	0
37604005	317576	1	2
44349085	1119510	0	0
44363236	40223768	2	3
45658482	1501700	0	0
45653032	1125315	0	0
44351869	1129625	0	0
44344574	1119510	0	0
45645312	1125315	0	0
45647858	1177480	0	0
45666620	1539403	0	0
45636724	19078461	2	3
45781651	1119510	0	0
45682951	975125	0	0
45683216	1119510	0	0
46242663	1125315	0	0
46242928	1129625	0	0
45691506	1125315	0	0
45789216	740275	0	0
45785979	1125315	0	0
45801512	1125315	0	0
45787229	1125315	0	0
46316838	1149380	0	0
46310596	1192710	0	0
45675558	1539403	0	0
1501700	1501700	0	0
21000109	1717327	0	0
21505814	1192710	0	0
21604181	1154029	3	3
35402588	372328	3	3
36158041	1746114	0	0
36150976	791967	0	0
42805766	1713332	0	0
37604031	381316	1	2
44349122	1119510	0	0
44357065	19078461	2	3
45658606	1545958	0	0
45652849	1125315	0	0
44343895	1129625	0	0
44344578	1119510	0	0
45645202	1125315	0	0
45647827	1177480	0	0
45666772	1738521	0	0
45679806	19078461	2	3
45781215	1119510	0	0
45682308	975125	0	0
45682913	1119510	0	0
46242640	1125315	0	0
46242779	1129625	0	0
45691419	1125315	0	0
45789151	1326303	0	0
45785985	1125315	0	0
45801432	1125315	0	0
45787633	1125315	0	0
46316906	1307863	0	0
46310752	975125	0	0
45675702	1119510	0	0
1503184	1503184	0	0
21000060	1728416	0	0
21505814	1119510	0	0
21604181	19078219	3	3
21605008	1149380	3	3
36158041	1741122	0	0
36211097	4059173	0	0
42805770	1548195	0	0
37521562	44805732	1	1
44349106	1119510	0	0
44346668	19078461	2	3
45658984	1118084	0	0
45652895	1125315	0	0
44344011	1129625	0	0
44344588	1119510	0	0
45645367	1125315	0	0
45644825	1177480	0	0
45666853	1308738	0	0
45630929	19078461	2	3
45779081	1119510	0	0
45660194	1177480	0	0
45683311	1119510	0	0
46240248	1125315	0	0
46242818	1129625	0	0
45690640	1125315	0	0
45789160	1115008	0	0
46296258	1125315	0	0
45801609	1125315	0	0
45787640	1125315	0	0
46316930	715997	0	0
46310522	1309944	0	0
45675708	1192710	0	0
1101352	1361711	0	0
19089061	19089061	0	0
21505814	1112807	0	0
21603365	1119510	3	3
21603444	1149196	3	3
36158049	1174888	0	0
36211127	4142905	0	0
42805612	1129625	0	0
37521571	4186930	1	1
44352013	1119510	0	0
44339679	19078461	2	3
45658987	1332418	0	0
45649459	1125315	0	0
44344003	1129625	0	0
44344528	1119510	0	0
45645378	1125315	0	0
45645024	1177480	0	0
45666857	975125	0	0
45686135	19078461	2	3
45779061	1119510	0	0
45660260	1177480	0	0
45682925	1119510	0	0
46240422	1125315	0	0
46241023	1129625	0	0
45690674	1125315	0	0
45789090	1107830	0	0
46296263	1125315	0	0
45801563	1125315	0	0
45787460	1125315	0	0
46316960	1118084	0	0
46310533	914335	0	0
45675715	1112807	0	0
1101380	1124300	0	0
19029476	19029476	0	0
21505816	738818	0	0
21602098	1149380	3	3
21603444	1129625	3	3
36158196	1177480	0	0
36211129	4237458	0	0
42805709	1124300	0	0
37521572	4186930	1	1
44351934	1119510	0	0
44357070	19078461	2	3
45658853	975125	0	0
45649460	1125315	0	0
44344251	1129625	0	0
44344593	1119510	0	0
45645307	1125315	0	0
45644893	1177480	0	0
45666788	1545958	0	0
45689092	19078461	2	3
45779195	1119510	0	0
45658313	1177480	0	0
45683108	1119510	0	0
46240423	1125315	0	0
46240521	1129625	0	0
45690687	1125315	0	0
45789167	1174888	0	0
46296267	1125315	0	0
45801595	1125315	0	0
45787293	1125315	0	0
46316915	1521369	0	0
46310534	920293	0	0
45675723	738818	0	0
1101382	1124300	0	0
4293740	4293740	0	0
21505816	1119510	0	0
21500290	40223821	3	4
21603444	1107830	3	3
36158278	1177480	0	0
36211130	4278672	0	0
42805711	1115008	0	0
40139614	19126352	1	1
44352083	1119510	0	0
44342133	19078461	2	3
45658886	1332418	0	0
45649594	1125315	0	0
44344688	1129625	0	0
45646265	1119510	0	0
45642139	1125315	0	0
45645028	1177480	0	0
45666859	1310149	0	0
45695019	19078461	2	3
45779208	1119510	0	0
45703855	1177480	0	0
45682929	1119510	0	0
46240218	1125315	0	0
46240604	1129625	0	0
45690762	1125315	0	0
45789248	1154343	0	0
46296277	1125315	0	0
45801565	1125315	0	0
45787601	1125315	0	0
46316915	1549786	0	0
46305288	1332418	0	0
45675548	1119510	0	0
1101382	1115008	0	0
4242997	4242997	0	0
21505816	1125315	0	0
21500290	40223834	3	4
21603444	1150770	3	3
36157986	1738521	0	0
36155831	705944	0	0
42805713	1310149	0	0
40141358	1310034	1	1
44351755	1119510	0	0
44339617	19078461	2	3
45658576	975125	0	0
45649535	1125315	0	0
44344420	1129625	0	0
45646270	1119510	0	0
45642095	1125315	0	0
45645113	1177480	0	0
45666870	1149196	0	0
45778420	19078461	2	3
45779108	1119510	0	0
45703984	1177480	0	0
45679884	1119510	0	0
46240427	1125315	0	0
46240581	1129625	0	0
45690768	1125315	0	0
45789253	933724	0	0
46296068	1125315	0	0
45801566	1125315	0	0
45787613	1125315	0	0
46316963	1551099	0	0
46304812	1112807	0	0
45675589	1129625	0	0
1101329	1124957	0	0
4243062	4243062	0	0
21505816	1192710	0	0
21500290	1107882	3	4
35507258	1539411	2	3
36157987	1177480	0	0
36155788	791967	0	0
42805925	1548195	0	0
40141899	40224132	1	1
44349303	1119510	0	0
44350009	19078461	2	3
45658739	1551099	0	0
45649692	1125315	0	0
44337436	1129625	0	0
45646343	1119510	0	0
45643026	1125315	0	0
45645076	1177480	0	0
45666733	1118084	0	0
45778421	19078461	2	3
45778885	1119510	0	0
45703930	1177480	0	0
45679609	1119510	0	0
46240331	1125315	0	0
45681150	1177480	0	0
45690760	1125315	0	0
45786982	1000560	0	0
46296287	1125315	0	0
45801437	1125315	0	0
45787616	1125315	0	0
46316953	1000560	0	0
46304836	1332418	0	0
45675631	705944	0	0
1101405	1551099	0	0
21001016	1112807	0	0
21505816	1129625	0	0
21604798	45892894	3	4
35507329	19019273	2	3
36157788	738818	0	0
36155724	738818	0	0
42805927	1332418	0	0
40136913	19125062	1	1
44349316	1119510	0	0
44343073	19075601	2	3
45658774	1174888	0	0
45649600	1125315	0	0
44337772	1129625	0	0
44341191	1119510	0	0
45643031	1125315	0	0
45642093	1177480	0	0
45666971	1501700	0	0
45778419	19078461	2	3
45778798	1119510	0	0
45651791	1177480	0	0
45682132	1119510	0	0
46240434	1125315	0	0
45680928	1177480	0	0
45690709	1125315	0	0
45786985	975125	0	0
46296304	1125315	0	0
45801439	1125315	0	0
45787774	1125315	0	0
46316904	1124300	0	0
46305052	967823	0	0
45675826	1112807	0	0
1101405	975125	0	0
21001016	1125315	0	0
21505819	738818	0	0
21604793	45892894	3	4
35507285	35605482	2	3
36157789	1129625	0	0
36155728	1112807	0	0
42805937	1124300	0	0
40142703	1154615	1	1
44345257	1119510	0	0
44342571	1539411	2	3
45658777	1545958	0	0
45649601	1125315	0	0
44337614	1129625	0	0
44341141	1119510	0	0
45643043	1125315	0	0
45642168	1177480	0	0
45664071	1343916	0	0
45778497	19078461	2	3
45779392	1119510	0	0
45651319	1177480	0	0
45682134	1119510	0	0
46240083	1125315	0	0
45681046	1177480	0	0
45690711	1125315	0	0
45787032	1112807	0	0
46296467	1125315	0	0
45801583	1125315	0	0
45787777	1125315	0	0
46311462	1322184	0	0
46305053	701322	0	0
45675775	1119510	0	0
1101410	1548195	0	0
21001017	1112807	0	0
21505819	1192710	0	0
21604181	782047	3	6
35507290	1127433	2	3
36158092	1115008	0	0
36155797	723013	0	0
42819910	1129625	0	0
40023991	19112599	1	1
44345505	1119510	0	0
44357327	1545959	2	3
45658777	1332418	0	0
45649709	1125315	0	0
44337513	1129625	0	0
45643530	1119510	0	0
45643021	1125315	0	0
45639158	1177480	0	0
45664074	1717327	0	0
45698153	19078461	2	3
45779393	1119510	0	0
45651640	1177480	0	0
45660102	1125315	0	0
46240184	1125315	0	0
45680879	1177480	0	0
45690624	1125315	0	0
45787058	1124300	0	0
46292108	1125315	0	0
45801598	1125315	0	0
45801029	1125315	0	0
46311480	1713332	0	0
46305167	1738521	0	0
45675750	1551099	0	0
782043	782043	0	0
21001018	708298	0	0
21505883	1557272	0	0
21604181	19023423	3	6
35507259	19008572	2	3
36158289	1124300	0	0
36155806	1539403	0	0
42819961	1107830	0	0
40023993	43012036	1	1
44345461	1119510	0	0
44364017	1332419	2	3
45658922	1545958	0	0
45649612	1125315	0	0
44337563	1129625	0	0
45643211	1119510	0	0
45642171	1125315	0	0
45639138	1177480	0	0
45664253	1309944	0	0
45651791	19078461	2	3
45779179	1119510	0	0
45652257	1177480	0	0
45661474	1125315	0	0
46240187	1125315	0	0
45681262	1177480	0	0
45690749	1125315	0	0
45786988	1112807	0	0
46292312	1125315	0	0
45801676	1125315	0	0
45801201	1125315	0	0
46311604	1149196	0	0
46304998	1367571	0	0
45896983	1149196	0	0
836654	836654	0	0
21001378	1713332	0	0
19045231	19045231	0	0
21604685	19123231	3	6
35507354	40229134	2	3
36158243	1112807	0	0
36155807	1192710	0	0
42820011	1119510	0	0
40024030	19074841	1	1
44345472	1119510	0	0
44356282	40223768	2	3
45658922	1332418	0	0
45649615	1125315	0	0
44337726	1129625	0	0
45643095	1119510	0	0
45642228	1125315	0	0
45639275	1177480	0	0
45664259	1343916	0	0
45688653	19078461	2	3
45779395	1119510	0	0
45651859	1177480	0	0
45661551	1125315	0	0
46240362	1125315	0	0
45681139	1177480	0	0
45690740	1125315	0	0
45787098	738818	0	0
46292515	1125315	0	0
45801694	1125315	0	0
45801033	1125315	0	0
46311630	738818	0	0
46305014	791967	0	0
45896932	757627	0	0
836659	836659	0	0
21001368	975125	0	0
21500546	1129625	0	0
21500120	40174880	9	10
21604643	19078924	0	3
36158245	1112807	0	0
36155808	1326303	0	0
42820011	738818	0	0
37203772	4283893	1	1
44345229	1119510	0	0
44356818	1545959	2	3
45658923	1361711	0	0
45649783	1125315	0	0
45622007	1129625	0	0
45643002	1119510	0	0
45642185	1125315	0	0
45638969	1177480	0	0
45664273	1548195	0	0
45698116	19078461	2	3
45707639	1119510	0	0
45651808	1177480	0	0
45661665	1125315	0	0
46240369	1125315	0	0
45681223	1177480	0	0
45690819	1125315	0	0
45787102	1310149	0	0
46292319	1125315	0	0
45801695	1125315	0	0
45802515	1125315	0	0
46306165	1367571	0	0
46305084	975125	0	0
45896935	1110410	0	0
378001	378001	0	0
21001379	1729720	0	0
21500546	738818	0	0
21502709	43012036	9	10
21603058	920300	0	3
36158197	1107830	0	0
36155793	1177480	0	0
42805972	975125	0	0
37203767	28060	1	1
44345230	1119510	0	0
44354207	19078461	2	3
45658888	1551099	0	0
45649755	1125315	0	0
45621917	1129625	0	0
45640398	1119510	0	0
45642229	1125315	0	0
45639071	1177480	0	0
45664273	1521369	0	0
45682897	19078461	2	3
45707642	1119510	0	0
45651818	1177480	0	0
45661667	1125315	0	0
46242346	1125315	0	0
45681256	1177480	0	0
45691071	1125315	0	0
45787078	975125	0	0
46292168	1125315	0	0
45801702	1125315	0	0
45802586	1125315	0	0
46306560	1729720	0	0
46305088	975125	0	0
45897040	1589505	0	0
380378	380378	0	0
21001385	1759842	0	0
21500547	1125315	0	0
21502709	46275916	9	10
21603058	920334	0	3
36157928	738818	0	0
36155931	1307863	0	0
42805985	1539403	0	0
37203769	255848	1	1
44345423	1119510	0	0
43534908	1000560	0	0
45658893	1322184	0	0
45649638	1125315	0	0
45622215	1129625	0	0
45640350	1119510	0	0
45642253	1125315	0	0
45638983	1177480	0	0
45664194	1149380	0	0
45685946	19078461	2	3
45777915	1119510	0	0
45700648	1177480	0	0
45661612	1125315	0	0
46242385	1125315	0	0
45675921	1177480	0	0
45687424	1125315	0	0
45787082	975125	0	0
46292123	1125315	0	0
45795901	1125315	0	0
45802590	1125315	0	0
46305976	1729720	0	0
46305097	1112807	0	0
45896897	1119510	0	0
378419	378419	0	0
21001369	975125	0	0
21500547	1129625	0	0
21502709	40228230	9	10
35200000	4329847	3	7
36157797	1310149	0	0
36155941	738818	0	0
42806027	1332418	0	0
37019238	195588	1	1
44345384	1119510	0	0
43534629	967823	0	0
45658903	1310149	0	0
45649645	1125315	0	0
45622190	1129625	0	0
45640480	1119510	0	0
45642330	1125315	0	0
45639124	1177480	0	0
45664194	1137529	0	0
45630738	1332419	2	3
45777877	1119510	0	0
45648724	1177480	0	0
45661642	1125315	0	0
46242096	1125315	0	0
45676061	1177480	0	0
45687691	1125315	0	0
45786991	1551099	0	0
46292182	1125315	0	0
45796124	1125315	0	0
45802594	1125315	0	0
46306501	1192710	0	0
46305102	1332418	0	0
45896952	1738521	0	0
381316	381316	0	0
21001385	1713332	0	0
21500564	836654	0	0
21602886	19074841	0	3
35302072	4144583	7	7
36158291	1177480	0	0
36155906	1177480	0	0
42805950	1115008	0	0
40783242	3013682	1	1
44345576	1119510	0	0
43534632	967823	0	0
45658495	975125	0	0
45649647	1125315	0	0
44358682	1129625	0	0
45640476	1119510	0	0
45642317	1125315	0	0
45640146	1177480	0	0
45664275	1332418	0	0
45660194	19078461	2	3
45707807	1119510	0	0
45648824	1177480	0	0
45660188	1125315	0	0
46242162	1125315	0	0
45676105	1177480	0	0
45687758	1125315	0	0
45786993	1192710	0	0
46292089	1125315	0	0
45796140	1125315	0	0
45801237	1125315	0	0
46306189	1322184	0	0
46305437	914335	0	0
45897052	1119510	0	0
196456	196456	0	0
21001385	1778162	0	0
4326177	4326177	0	0
21502584	19123231	7	8
35302074	4043241	7	7
36158201	1177480	0	0
36156016	738818	0	0
42806074	1124957	0	0
40783474	3008598	1	1
44345407	1119510	0	0
43534633	967823	0	0
45658504	1118084	0	0
45649865	1125315	0	0
45658432	1129625	0	0
45640500	1119510	0	0
45642290	1125315	0	0
45636350	1177480	0	0
45664191	708298	0	0
45701166	1539411	2	3
45707803	1119510	0	0
45648707	1177480	0	0
45658285	1125315	0	0
46242404	1125315	0	0
45676022	1177480	0	0
45687759	1125315	0	0
45786997	1149196	0	0
46292281	1125315	0	0
45795962	1125315	0	0
45801418	1125315	0	0
46306190	1729720	0	0
46305438	1551099	0	0
45897054	1129625	0	0
1539411	1539411	0	0
21001379	1713332	0	0
21011857	1759842	0	0
21502584	19076374	7	8
21602795	19075001	6	7
36158206	738818	0	0
36156091	975125	0	0
42806091	1000560	0	0
40483563	4323208	1	1
44345519	1119510	0	0
43534634	967823	0	0
45658627	1717327	0	0
45649867	1125315	0	0
45658747	1129625	0	0
45640610	1119510	0	0
45639129	1125315	0	0
45633031	1177480	0	0
45664360	1738521	0	0
45669056	1539411	2	3
45707991	1119510	0	0
45648609	1177480	0	0
45658304	1125315	0	0
46240468	1125315	0	0
45672905	1177480	0	0
45687699	1125315	0	0
45787001	1000560	0	0
46292299	1125315	0	0
45795965	1125315	0	0
45801224	1125315	0	0
46306411	1738521	0	0
46305446	1192710	0	0
45897055	1332418	0	0
1549914	19127918	2	2
21001370	975125	0	0
21011857	1717327	0	0
21502584	40232448	7	8
21602795	19073188	4	7
36158324	1124957	0	0
36155942	1115008	0	0
42806201	791967	0	0
40486433	4048171	1	1
44345478	1119510	0	0
43534642	1539403	0	0
45658630	705944	0	0
45649888	1125315	0	0
45658838	1129625	0	0
45640518	1119510	0	0
45639135	1125315	0	0
45659129	1112807	0	0
45664200	791967	0	0
45631013	1332419	2	3
45704677	1119510	0	0
45648943	1177480	0	0
45657929	1125315	0	0
46240469	1125315	0	0
45673063	1177480	0	0
45687353	1125315	0	0
45787004	975125	0	0
46292301	1125315	0	0
45796250	1125315	0	0
45801229	1125315	0	0
46306574	1115008	0	0
46305446	1174888	0	0
45897064	933724	0	0
1549914	42902245	2	2
21001371	975125	0	0
21011858	1717327	0	0
21502584	40236446	7	8
21602795	19074841	4	7
36158326	1589505	0	0
36155837	791967	0	0
42806145	1177480	0	0
40223818	40223821	1	1
44345483	1119510	0	0
43534660	1361711	0	0
45658805	1551099	0	0
45649650	1125315	0	0
45658843	1129625	0	0
45640559	1119510	0	0
45639271	1125315	0	0
45659133	1112807	0	0
45664202	1307863	0	0
45686142	40174880	2	3
45705131	1119510	0	0
45649130	1177480	0	0
45658168	1125315	0	0
46240478	1125315	0	0
45673126	1177480	0	0
45687354	1125315	0	0
45787006	1124300	0	0
46292223	1125315	0	0
45796255	1125315	0	0
45801312	1125315	0	0
46306644	723013	0	0
46305022	933724	0	0
45897067	1177480	0	0
1549914	19128009	2	2
21001372	975125	0	0
21012149	1396131	0	0
21503650	42707627	7	8
21602795	19133873	4	7
36158292	1501700	0	0
36155861	1124300	0	0
42806013	1738521	0	0
40223828	40223834	1	1
44345710	1119510	0	0
43534674	975125	0	0
45659106	1545958	0	0
45649616	1125315	0	0
45658954	1129625	0	0
45637537	1119510	0	0
45639317	1125315	0	0
45657214	1112807	0	0
45664375	1713332	0	0
45685939	19079524	2	3
45704685	1119510	0	0
45646107	1177480	0	0
45703840	1125315	0	0
46240491	1125315	0	0
45673211	1177480	0	0
45687824	1125315	0	0
45787016	740275	0	0
46292477	1125315	0	0
45796218	1125315	0	0
45801329	1125315	0	0
46306516	738818	0	0
46305255	1501700	0	0
45897099	1124957	0	0
1549916	19127904	2	2
21001380	1713332	0	0
21012151	1396131	0	0
21503645	40162522	7	8
21602795	920300	4	7
36158339	740275	0	0
36155876	1112807	0	0
42806100	1343916	0	0
40222857	45892894	1	1
44345606	1119510	0	0
43534879	1154029	0	0
45659109	1124300	0	0
45649898	1125315	0	0
45658864	1129625	0	0
45637191	1119510	0	0
45639325	1125315	0	0
45653899	1112807	0	0
45664280	1115008	0	0
45704418	1127433	2	3
45704696	1119510	0	0
45645747	1177480	0	0
45704006	1125315	0	0
46240558	1125315	0	0
45673307	1177480	0	0
45687630	1125315	0	0
45787039	1192710	0	0
46292470	1125315	0	0
45795975	1125315	0	0
45801333	1125315	0	0
46306246	975125	0	0
46305519	1595799	0	0
45897103	1174888	0	0
1549916	42902245	2	2
21001425	1551099	0	0
21012484	1548195	0	0
21503645	1127433	7	8
35302077	441267	2	2
36158293	1192710	0	0
36155877	1000560	0	0
42806064	1119510	0	0
40222845	40222846	1	1
44345737	1119510	0	0
43534723	1521369	0	0
45659033	1107830	0	0
45649698	1125315	0	0
45658824	1129625	0	0
45637179	1119510	0	0
45639261	1125315	0	0
45647574	1112807	0	0
45664393	738818	0	0
45698149	1545959	2	3
45705059	1119510	0	0
45645625	1177480	0	0
45704007	1125315	0	0
45703292	1125315	0	0
45786671	1177480	0	0
45688002	1125315	0	0
45787059	975125	0	0
46292503	1125315	0	0
45796199	1125315	0	0
45801352	1125315	0	0
46306989	1107830	0	0
46305525	1192710	0	0
45897103	1192710	0	0
4001217	4326177	2	2
21001425	1112807	0	0
21011857	1713332	0	0
21503645	19007333	7	8
21604792	715997	2	2
36158294	1115008	0	0
36155776	1177480	0	0
42805999	1545958	0	0
40144037	40169216	1	1
44345551	1119510	0	0
43534937	1501700	0	0
45658868	1343916	0	0
45649775	1125315	0	0
45652119	1129625	0	0
45637480	1119510	0	0
45639296	1125315	0	0
45644499	1112807	0	0
45664381	1343916	0	0
45706686	1539411	2	3
45633049	1129625	0	0
45645803	1177480	0	0
45704081	1125315	0	0
45703135	1125315	0	0
45785009	1177480	0	0
45687876	1125315	0	0
45787061	1112807	0	0
46292451	1125315	0	0
45796204	1125315	0	0
45795709	1125315	0	0
46306468	738818	0	0
46305525	1174888	0	0
45897172	1153428	0	0
376106	4029498	2	2
21001022	705944	0	0
21011858	1713332	0	0
21503645	19019273	7	8
21604792	836654	2	2
36158295	1545958	0	0
36155916	723013	0	0
42806088	1124300	0	0
40069736	19045231	1	1
44341272	1119510	0	0
43534941	1308738	0	0
45659013	1192710	0	0
45649777	1125315	0	0
45652120	1129625	0	0
45637560	1119510	0	0
45639065	1125315	0	0
45644251	1112807	0	0
45664383	1149380	0	0
45706754	1539411	2	3
45633130	1129625	0	0
45642714	1177480	0	0
45703985	1125315	0	0
45703139	1125315	0	0
45785136	1177480	0	0
45687895	1125315	0	0
45787062	1332418	0	0
46292394	1125315	0	0
45796174	1125315	0	0
45795732	1125315	0	0
46306596	1149196	0	0
46305313	1153428	0	0
45896922	1129625	0	0
1549918	42902245	2	2
21001028	740275	0	0
21011858	1759842	0	0
21503645	19078461	7	8
21604254	1102527	2	2
36158331	975125	0	0
36156017	1124300	0	0
42806090	1713332	0	0
40065329	19007333	1	1
44344459	1119510	0	0
45619689	1192710	0	0
45658871	1124957	0	0
45649059	1125315	0	0
45652321	1129625	0	0
45637412	1119510	0	0
45639191	1125315	0	0
45644687	1112807	0	0
45664470	1000560	0	0
45781123	1545959	2	3
45633230	1129625	0	0
45642757	1177480	0	0
45703926	1125315	0	0
45703232	1125315	0	0
45784943	1177480	0	0
45687653	1125315	0	0
45787067	1174888	0	0
46292520	1125315	0	0
45796175	1125315	0	0
45795768	1125315	0	0
46306230	738818	0	0
46305526	1149196	0	0
45896985	1115008	0	0
1549918	19128263	2	2
21001034	1717327	0	0
21012458	715997	0	0
21503645	1127078	7	8
21604254	1124957	2	2
36158332	1521369	0	0
36156019	1118084	0	0
42806014	19127890	0	0
40069853	40236824	1	1
44344462	1119510	0	0
45619695	1177480	0	0
45658826	1124957	0	0
45648796	1125315	0	0
45652326	1129625	0	0
45640107	1119510	0	0
45639204	1125315	0	0
45644715	1112807	0	0
45664465	1713332	0	0
45680244	1539411	2	3
45676456	1129625	0	0
45642800	1177480	0	0
45704135	1125315	0	0
45703385	1125315	0	0
45784981	1177480	0	0
45687504	1125315	0	0
45787057	1149196	0	0
46292607	1125315	0	0
45796179	1125315	0	0
45795823	1125315	0	0
46306646	933724	0	0
46305476	1149196	0	0
45896860	1307863	0	0
1549918	19128022	2	2
21000141	19133905	2	3
21012458	757627	0	0
21503645	1115171	7	8
21604254	1110410	2	2
36158332	1549786	0	0
36155945	1124300	0	0
42806014	1512674	0	0
40069975	920300	1	1
44341602	1119510	0	0
45619703	1115008	0	0
44352123	1396131	0	0
45649055	1125315	0	0
45652149	1129625	0	0
45639982	1119510	0	0
45639212	1125315	0	0
45641850	1112807	0	0
45664465	1759842	0	0
45671592	1539411	2	3
45676745	1129625	0	0
45642901	1177480	0	0
45703977	1125315	0	0
45703530	1125315	0	0
45782906	1177480	0	0
45687602	1125315	0	0
45787029	1153428	0	0
46287882	1125315	0	0
45796323	1125315	0	0
45795793	1125315	0	0
46306668	1548195	0	0
46305481	1713332	0	0
45896962	1107830	0	0
4003382	4323902	2	2
21001038	19129655	2	3
21012484	1521369	0	0
21500238	1307863	0	0
21604070	19003953	2	2
36158333	1589505	0	0
36156094	1177480	0	0
42806014	1549786	0	0
40066578	40236446	1	1
44341697	1119510	0	0
45619705	1112807	0	0
44351940	1124957	0	0
45649106	1125315	0	0
45652159	1129625	0	0
45634180	1119510	0	0
45639215	1125315	0	0
45641999	1112807	0	0
45664466	1589505	0	0
45677019	1539411	2	3
45676977	1129625	0	0
45688685	1177480	0	0
45703780	1125315	0	0
45703533	1125315	0	0
45783113	1177480	0	0
45687899	1125315	0	0
45787160	933724	0	0
46287907	1125315	0	0
45796325	1125315	0	0
45795858	1125315	0	0
46317223	1174888	0	0
46305489	1112807	0	0
45896965	1112807	0	0
372887	381316	2	2
21000105	19129655	2	3
21012460	757627	0	0
21500238	1332418	0	0
21604035	1124300	2	2
36158333	19127890	0	0
36155847	1115008	0	0
42803541	1713332	0	0
40073531	1551192	1	1
44341767	1119510	0	0
45619706	1174888	0	0
44351944	1308738	0	0
45649117	1125315	0	0
45652164	1129625	0	0
45634181	1119510	0	0
45638990	1125315	0	0
45641830	1112807	0	0
45664466	1548195	0	0
45778764	1539411	2	3
45677067	1129625	0	0
45688664	1177480	0	0
45704033	1125315	0	0
45703264	1125315	0	0
45783125	1177480	0	0
45687902	1125315	0	0
45787153	1549786	0	0
46288115	1125315	0	0
45796191	1125315	0	0
45795839	1125315	0	0
46317297	1115008	0	0
46305330	1192710	0	0
45897049	1332418	0	0
372887	380378	2	2
21000109	19129655	2	3
4283893	4283893	0	0
21500285	1192710	0	0
21604035	1177480	2	2
36158333	1549786	0	0
36155937	1107830	0	0
42803514	1545958	0	0
37503995	4216130	1	1
44341815	1119510	0	0
45621960	967823	0	0
44351945	1310149	0	0
45646491	1125315	0	0
45652339	1129625	0	0
45634040	1119510	0	0
45638996	1125315	0	0
45641955	1112807	0	0
45664479	1154343	0	0
45695375	1539411	2	3
45676540	1129625	0	0
45691385	1177480	0	0
45704053	1125315	0	0
45703267	1125315	0	0
45783139	1177480	0	0
45687906	1125315	0	0
45787153	1589505	0	0
46287987	1125315	0	0
45796469	1125315	0	0
45795841	1125315	0	0
46317460	1192710	0	0
46305346	1000560	0	0
45896969	1119510	0	0
378161	372328	2	2
21000101	19129655	2	3
21000474	1551099	0	0
21503745	1125315	0	0
21603813	1500211	2	2
36158458	1107830	0	0
36156174	920293	0	0
42803452	1125315	0	0
40021695	40228214	1	1
44341816	1119510	0	0
45621558	1595799	0	0
44351852	1000560	0	0
45646477	1125315	0	0
45652619	1129625	0	0
45634117	1119510	0	0
45639298	1125315	0	0
45638950	1112807	0	0
45664282	975125	0	0
45669875	1539411	2	3
45673585	1129625	0	0
45639851	1177480	0	0
45704054	1125315	0	0
45703272	1125315	0	0
45783151	1177480	0	0
45687914	1125315	0	0
45787124	1107830	0	0
46243137	1125315	0	0
45796350	1125315	0	0
45795919	1125315	0	0
45895592	1112807	0	0
46305211	1112807	0	0
45896988	1309944	0	0
375415	4156265	2	2
21000259	46233710	2	3
21000482	1551099	0	0
21503753	967823	0	0
21603041	920293	2	2
36158433	1177480	0	0
36156177	1713332	0	0
42803610	1124300	0	0
40021695	40228230	1	1
44341956	1119510	0	0
45621558	1308738	0	0
44352071	975125	0	0
45646569	1125315	0	0
45652290	1129625	0	0
45634121	1119510	0	0
45640143	1125315	0	0
45638759	1112807	0	0
45664283	1501700	0	0
45707706	19079524	1	1
45673703	1129625	0	0
45685946	1177480	0	0
45703903	1125315	0	0
45703276	1125315	0	0
45778285	1177480	0	0
45687734	1125315	0	0
45787211	1112807	0	0
46243106	1125315	0	0
45796354	1125315	0	0
45795843	1125315	0	0
45895577	1112807	0	0
46305234	975125	0	0
45896972	1177480	0	0
375415	4132546	2	2
21000094	19129655	2	3
21000474	975125	0	0
21503925	1177480	0	0
35102442	439777	2	2
36158371	738818	0	0
36156178	1129625	0	0
42803577	1557272	0	0
40223725	42707627	1	1
44341737	1119510	0	0
45621580	933724	0	0
44352218	1110410	0	0
45646690	1125315	0	0
44344574	1129625	0	0
45634153	1119510	0	0
45640212	1125315	0	0
45639021	1112807	0	0
45664286	975125	0	0
45680453	19079524	1	1
45673518	1129625	0	0
45685974	1177480	0	0
45703906	1125315	0	0
45703348	1125315	0	0
45777840	1177480	0	0
45687738	1125315	0	0
45787213	1713332	0	0
46243140	1125315	0	0
45796310	1125315	0	0
45795972	1125315	0	0
45895767	1112807	0	0
46305246	975125	0	0
45896986	1307863	0	0
4002905	440448	2	2
21000086	19129655	2	3
21000478	1551099	0	0
21503646	1125315	0	0
35205038	317009	2	2
36158375	1192710	0	0
36155953	1000560	0	0
42803508	1545958	0	0
37604042	192671	1	1
42707627	42707627	0	0
45621551	1124957	0	0
45652419	740275	0	0
45646430	1125315	0	0
44344344	1129625	0	0
45634399	1119510	0	0
45635859	1125315	0	0
45638899	1112807	0	0
45664224	967823	0	0
45692252	19079524	1	1
45673842	1129625	0	0
45685980	1177480	0	0
45703907	1125315	0	0
45703541	1125315	0	0
45777891	1177480	0	0
45687741	1125315	0	0
45787219	1115008	0	0
46243147	1125315	0	0
45790958	1125315	0	0
45795761	1125315	0	0
45895653	1112807	0	0
46305497	1149196	0	0
45896987	723013	0	0
4002905	4166224	2	2
21001033	19129655	2	3
21000478	1305058	0	0
21503925	1115008	0	0
35104382	4056621	2	2
36158383	1112807	0	0
36155954	1713332	0	0
42803511	1545958	0	0
40069735	19045231	1	1
44359123	1125315	0	0
45621665	967823	0	0
45652616	1545958	0	0
45646606	1125315	0	0
45646264	1129625	0	0
45634506	1119510	0	0
45635811	1125315	0	0
45635784	1112807	0	0
45664318	1332418	0	0
45689139	19079524	1	1
45673820	1129625	0	0
45636724	1177480	0	0
45651470	1125315	0	0
45703550	1125315	0	0
46242610	1177480	0	0
45687744	1125315	0	0
45787166	738818	0	0
46242867	1125315	0	0
45790725	1125315	0	0
45795808	1125315	0	0
45802109	1112807	0	0
46305514	975125	0	0
45896957	1332418	0	0
4002046	4336464	2	2
21000060	19129655	2	3
21000480	1551099	0	0
21503664	1112807	0	0
35104347	4056621	2	2
36158106	1107830	0	0
36155923	1129625	0	0
42803460	1125315	0	0
40223461	43012036	1	1
44359130	1125315	0	0
45621666	1129625	0	0
45652025	1124300	0	0
45646684	1125315	0	0
45646265	1129625	0	0
45634336	1119510	0	0
45636050	1125315	0	0
45632673	1112807	0	0
45664302	1713332	0	0
45633086	19079524	1	1
45670807	1129625	0	0
45636824	1177480	0	0
45651747	1125315	0	0
45703491	1125315	0	0
46242664	1177480	0	0
45688505	1125315	0	0
45787184	933724	0	0
46242905	1125315	0	0
45790660	1125315	0	0
45795949	1125315	0	0
45802143	1112807	0	0
46305154	1153428	0	0
45896959	1129625	0	0
321887	317576	2	2
21000483	1551192	2	3
21000478	975125	0	0
21503664	1125315	0	0
21601745	1332418	2	2
36158109	1177480	0	0
36155928	1545958	0	0
42803589	1545958	0	0
40126735	40222846	1	1
44358995	1125315	0	0
45621697	738818	0	0
45652026	715997	0	0
45646727	1125315	0	0
45646344	1129625	0	0
45634241	1119510	0	0
45635868	1125315	0	0
45632555	1112807	0	0
45664309	738818	0	0
45707875	19079524	1	1
45670771	1129625	0	0
45636945	1177480	0	0
45651598	1125315	0	0
45703472	1125315	0	0
46240337	1177480	0	0
45684778	1125315	0	0
45787185	920293	0	0
46242907	1125315	0	0
45790739	1125315	0	0
45795951	1125315	0	0
45802233	1112807	0	0
46305352	1332418	0	0
45896998	1129625	0	0
444129	4134304	2	2
21000092	19129655	2	3
4097962	4152936	2	2
21503664	1124957	0	0
21604182	1154029	2	2
36157821	1177480	0	0
36156067	1177480	0	0
42803691	1000560	0	0
40020957	19075001	1	1
44358888	1125315	0	0
45621976	1102527	0	0
45652028	1153428	0	0
45646585	1125315	0	0
45646408	1129625	0	0
45634261	1119510	0	0
45635873	1125315	0	0
45632933	1112807	0	0
45664538	1717327	0	0
45707697	19079524	1	1
45671053	1129625	0	0
45682819	1177480	0	0
45651642	1125315	0	0
45703329	1125315	0	0
46240398	1177480	0	0
45684672	1125315	0	0
45787145	1192710	0	0
46242913	1125315	0	0
45791011	1125315	0	0
45795806	1125315	0	0
45802270	1112807	0	0
46305362	715997	0	0
45897004	1174888	0	0
4000609	30753	2	2
21000267	46233988	2	3
4139262	4010253	2	2
21503664	1177480	0	0
35406308	372328	2	2
36157824	738818	0	0
36156096	1729720	0	0
42803693	1129625	0	0
40483561	4125906	1	1
44359064	1125315	0	0
45621900	715997	0	0
45652204	1107830	0	0
45646733	1125315	0	0
45646068	1129625	0	0
45634314	1119510	0	0
45635902	1125315	0	0
45632870	1112807	0	0
45664544	1192710	0	0
45683509	19079524	1	1
45671054	1129625	0	0
45682832	1177480	0	0
45651320	1125315	0	0
45700402	1125315	0	0
46240284	1177480	0	0
45684677	1125315	0	0
45787145	1174888	0	0
46242917	1125315	0	0
45790779	1125315	0	0
45795876	1125315	0	0
45799301	1112807	0	0
46305362	701322	0	0
45897004	1192710	0	0
4000609	4310024	2	2
21000486	19007333	2	3
4048543	4336464	2	2
21503647	1129625	0	0
35104353	4056621	2	2
36158346	1129625	0	0
36155882	738818	0	0
42803555	1177480	0	0
40024032	19074843	1	1
44359259	1125315	0	0
45621968	1149196	0	0
45652330	1115008	0	0
45646767	1125315	0	0
45646075	1129625	0	0
45634429	1119510	0	0
45635907	1125315	0	0
45632856	1112807	0	0
45778310	975125	0	0
45669375	19079524	1	1
45670744	1129625	0	0
45682879	1177480	0	0
45651326	1125315	0	0
45700114	1125315	0	0
46240275	1177480	0	0
45684517	1125315	0	0
45787243	1539403	0	0
46243016	1125315	0	0
45791022	1125315	0	0
45795877	1125315	0	0
45796783	1112807	0	0
46305363	1729720	0	0
45897132	1177480	0	0
4002367	4337138	2	2
21000148	46233988	2	3
4040549	4337138	2	2
21503647	1112807	0	0
21603819	1500211	2	2
36158348	738818	0	0
36155954	1759842	0	0
42803592	1119510	0	0
40144020	40169281	1	1
44359260	1125315	0	0
45619714	1177480	0	0
45652426	1551099	0	0
45643478	1125315	0	0
45646197	1129625	0	0
45634526	1119510	0	0
45636097	1125315	0	0
45629649	1112807	0	0
45778187	1308738	0	0
45671176	19079524	1	1
45670909	1129625	0	0
45633462	1177480	0	0
45651327	1125315	0	0
45700345	1125315	0	0
46240370	1177480	0	0
45684642	1125315	0	0
45787355	1115008	0	0
46243181	1125315	0	0
45790828	1125315	0	0
45795966	1125315	0	0
45796985	1112807	0	0
46305387	1367571	0	0
45896991	1107830	0	0
374009	378419	2	2
21000148	19129655	2	3
4134294	4112343	2	2
21494966	21494966	0	0
35102397	4280726	2	2
36158362	1361711	0	0
36156054	1713332	0	0
42803517	1713332	0	0
40072606	19006318	1	1
44359262	1125315	0	0
45619741	1177480	0	0
45652427	1308738	0	0
45643706	1125315	0	0
45643144	1129625	0	0
45634620	1119510	0	0
45636135	1125315	0	0
45629651	1112807	0	0
45778049	1332418	0	0
45707565	19079524	1	1
45670973	1129625	0	0
45633590	1177480	0	0
45651329	1125315	0	0
45700465	1125315	0	0
45703413	1177480	0	0
45684648	1125315	0	0
45787325	738818	0	0
46243182	1125315	0	0
45790975	1125315	0	0
45795884	1125315	0	0
45796881	1112807	0	0
46307021	740275	0	0
45897073	1545958	0	0
442564	4152936	2	2
21000289	46233988	2	3
4134294	4294548	2	2
21004920	1717327	0	0
21008595	1545959	2	3
36158437	19127890	0	0
36156054	1759842	0	0
42803517	1759842	0	0
40783186	3004501	4	4
44359278	1125315	0	0
45619796	1112807	0	0
45652468	1192710	0	0
45643479	1125315	0	0
45643399	1129625	0	0
45634377	1119510	0	0
45636139	1125315	0	0
45628031	1112807	0	0
45778150	1124300	0	0
45707312	19079524	1	1
45670984	1129625	0	0
45633776	1177480	0	0
45651451	1125315	0	0
45700507	1125315	0	0
45703471	1177480	0	0
45684741	1125315	0	0
45787356	1174888	0	0
46242996	1125315	0	0
45790954	1125315	0	0
45795930	1125315	0	0
45797024	1112807	0	0
46307147	1112807	0	0
45897151	1107830	0	0
321588	321042	2	2
21000085	19133873	2	3
4134294	260139	2	2
21004864	914335	0	0
21008595	1539411	2	3
36158437	1549786	0	0
36155930	1589505	0	0
42803653	1124957	0	0
40783186	3006906	4	4
44359323	1125315	0	0
45619797	1129625	0	0
45652108	1124957	0	0
45643781	1125315	0	0
45643107	1129625	0	0
45634389	1119510	0	0
45636251	1125315	0	0
45628244	1112807	0	0
45778191	1107830	0	0
45680358	46275916	1	1
45669360	1129625	0	0
45633767	1177480	0	0
45651453	1125315	0	0
45896820	1125315	0	0
45703477	1177480	0	0
45684747	1125315	0	0
45787416	1115008	0	0
46242999	1125315	0	0
45792002	1125315	0	0
45796043	1125315	0	0
46317557	1112807	0	0
46306700	1174888	0	0
45897152	1129625	0	0
374377	44782520	2	2
21000085	19133905	2	3
4181187	257012	2	2
21004929	1717327	0	0
21008593	1545959	2	3
36158440	1149196	0	0
36155930	19127890	0	0
42803431	1738521	0	0
40783186	3024561	4	4
44359329	1125315	0	0
45619797	1177480	0	0
45652216	705944	0	0
45643721	1125315	0	0
45643146	1129625	0	0
45634716	1119510	0	0
45636011	1125315	0	0
45628225	1112807	0	0
45778378	740275	0	0
45680358	19079524	1	1
45669486	1129625	0	0
45679697	1177480	0	0
45652199	1125315	0	0
45896847	1125315	0	0
45700404	1177480	0	0
45684749	1125315	0	0
45787222	1332418	0	0
46242967	1125315	0	0
45791887	1125315	0	0
45795937	1125315	0	0
45794184	1112807	0	0
46306536	1521369	0	0
45897155	1307863	0	0
4000610	4027663	2	2
21000116	46233710	2	3
4181187	40481087	2	2
21005289	1501700	0	0
21008593	1539411	2	3
36158466	1149196	0	0
36155930	1549786	0	0
42803513	1149196	0	0
40783186	3013721	4	4
44359330	1125315	0	0
45619800	975125	0	0
45652161	1124957	0	0
45643485	1125315	0	0
45643441	1129625	0	0
45631284	1119510	0	0
45636015	1125315	0	0
45627077	1112807	0	0
45778053	1124957	0	0
45680465	19079524	1	1
45780799	1129625	0	0
45679806	1177480	0	0
45652061	1125315	0	0
45896879	1125315	0	0
45700468	1177480	0	0
45684607	1125315	0	0
45785498	1308738	0	0
46243067	1125315	0	0
45791895	1125315	0	0
45796051	1125315	0	0
45794006	1112807	0	0
46306543	715997	0	0
45896939	933724	0	0
4001565	4337611	2	2
21000116	46233988	2	3
4088217	4107731	2	2
21004841	1551099	0	0
21601195	967823	2	2
36158441	975125	0	0
36156188	1000560	0	0
42803638	1545958	0	0
40783186	3015632	4	4
44359097	1125315	0	0
45619790	1149196	0	0
45652344	1000560	0	0
45643500	1125315	0	0
45643176	1129625	0	0
45631091	1119510	0	0
45636264	1125315	0	0
45623926	1112807	0	0
45778242	1738521	0	0
45704577	19079524	1	1
45781078	1129625	0	0
45630745	1177480	0	0
45652030	1125315	0	0
45896880	1125315	0	0
45700169	1177480	0	0
45684487	1125315	0	0
45785502	1124957	0	0
46243009	1125315	0	0
45791964	1125315	0	0
45790670	1125315	0	0
45794243	1112807	0	0
46306716	1589505	0	0
45896940	1000560	0	0
4001535	4275113	2	2
21000075	46233988	2	3
4169307	438614	2	2
21004841	975125	0	0
21601240	1326303	2	2
36158445	738818	0	0
36156215	914335	0	0
42803632	1118084	0	0
40783186	3006923	4	4
44359156	1125315	0	0
45619749	1177480	0	0
45652351	967823	0	0
45643690	1125315	0	0
45640393	1129625	0	0
45631295	1119510	0	0
45636017	1125315	0	0
45624078	1112807	0	0
45778251	1501700	0	0
45669996	46275916	1	1
45778670	1129625	0	0
45630790	1177480	0	0
45652065	1125315	0	0
45896882	1125315	0	0
45700254	1177480	0	0
45684509	1125315	0	0
45785504	1107830	0	0
46243013	1125315	0	0
45792008	1125315	0	0
45790674	1125315	0	0
45794272	1112807	0	0
46306555	1322184	0	0
45897090	1118084	0	0
4001377	4163971	2	2
21000075	46233710	2	3
4169307	4302207	2	2
21004864	1110410	0	0
21491100	3023103	2	2
36158455	1129625	0	0
36155989	1545958	0	0
42803730	1713332	0	0
40783186	3027970	4	4
44359165	1125315	0	0
45619776	723013	0	0
45652430	1501700	0	0
45643422	1125315	0	0
45640424	1129625	0	0
45631309	1119510	0	0
45636268	1125315	0	0
45623954	1112807	0	0
45778326	967823	0	0
45669996	19079524	1	1
45778894	1129625	0	0
45630714	1177480	0	0
45652072	1125315	0	0
45896883	1125315	0	0
45896849	1177480	0	0
45684834	1125315	0	0
45785682	738818	0	0
46243220	1125315	0	0
45792013	1125315	0	0
45790355	1125315	0	0
45791465	1112807	0	0
46321710	1551099	0	0
45897013	1177480	0	0
133835	133834	2	2
21001380	19075001	2	3
4169307	4306014	2	2
21004865	1361711	0	0
21491100	3016723	2	2
36158495	1129625	0	0
36156033	1332418	0	0
42803732	1501700	0	0
40783186	3035995	4	4
44359166	1125315	0	0
45619735	1501700	0	0
45652359	1551099	0	0
45643749	1125315	0	0
45640442	1129625	0	0
45631316	1119510	0	0
45636276	1125315	0	0
45623798	1112807	0	0
45778402	1332418	0	0
45673937	19079524	1	1
45778657	1129625	0	0
45630819	1177480	0	0
45651815	1125315	0	0
45896889	1125315	0	0
45697455	1177480	0	0
45684724	1125315	0	0
45785647	914335	0	0
46243224	1125315	0	0
45791865	1125315	0	0
45790405	1125315	0	0
45791386	1112807	0	0
46321779	1124300	0	0
45897016	19002770	0	0
81902	4056621	2	2
21001425	1551192	2	3
4169307	442116	2	2
21005429	1153428	0	0
21601179	967823	2	2
36158513	1177480	0	0
35707989	440448	0	0
42803733	1326303	0	0
40783186	3028833	4	4
44359294	1125315	0	0
45619750	1112807	0	0
45652608	791967	0	0
45643761	1125315	0	0
45637464	1129625	0	0
45633921	1119510	0	0
45636229	1125315	0	0
45623866	1112807	0	0
45778101	1192710	0	0
45673910	19079524	1	1
45778753	1129625	0	0
45630826	1177480	0	0
45697849	1125315	0	0
45896855	1125315	0	0
45697509	1177480	0	0
45684990	1125315	0	0
45785726	1322184	0	0
46243160	1125315	0	0
45791871	1125315	0	0
45790527	1125315	0	0
45791589	1112807	0	0
46321768	723013	0	0
45897018	975125	0	0
81902	198199	2	2
21001054	40232448	2	3
4169307	439406	2	2
21005429	738818	0	0
21600492	1000560	2	2
36158513	1192710	0	0
35708083	30753	0	0
42803752	1501700	0	0
40786257	3010813	4	4
44358892	1125315	0	0
45619754	1305058	0	0
45652176	1149380	0	0
45643647	1125315	0	0
45637475	1129625	0	0
45633925	1119510	0	0
45635855	1125315	0	0
45623697	1112807	0	0
45660966	1107830	0	0
45689103	19079524	1	1
45778870	1129625	0	0
45630816	1177480	0	0
45700643	1125315	0	0
45896891	1125315	0	0
45894727	1177480	0	0
45684821	1125315	0	0
45785727	1112807	0	0
46243167	1125315	0	0
45792039	1125315	0	0
45790463	1125315	0	0
45791667	1112807	0	0
46321736	1326303	0	0
45897084	1332418	0	0
3026023	3014576	2	2
21000050	46233710	2	3
4169307	4169137	2	2
21005679	1713332	0	0
21601153	967823	2	2
36158215	738818	0	0
35708044	81893	0	0
42803857	1000560	0	0
40789534	3009201	4	4
44359011	1125315	0	0
45619719	708298	0	0
45652124	1332418	0	0
45645980	1125315	0	0
45637100	1129625	0	0
45633901	1119510	0	0
45636175	1125315	0	0
45667997	1112807	0	0
45660967	1713332	0	0
45698509	19079524	1	1
45707540	1129625	0	0
45630929	1177480	0	0
45700723	1125315	0	0
45896894	1125315	0	0
45894790	1177480	0	0
45684924	1125315	0	0
45785732	1549786	0	0
46243173	1125315	0	0
45791978	1125315	0	0
45790638	1125315	0	0
45788893	1112807	0	0
46321959	1107830	0	0
45897174	1112807	0	0
3026023	3019550	2	2
21000050	46233988	2	3
4169307	4304110	2	2
21005680	1713332	0	0
21490931	3014576	2	2
36158218	1115008	0	0
35707858	192671	0	0
42803596	723013	0	0
40772935	3024561	4	4
44359304	1125315	0	0
45619756	1539403	0	0
45652176	1137529	0	0
45640699	1125315	0	0
45637550	1129625	0	0
45633842	1119510	0	0
45636162	1125315	0	0
45670351	1112807	0	0
45660973	1343916	0	0
45633125	46275916	1	1
45707177	1129625	0	0
45631065	1177480	0	0
45648717	1125315	0	0
45896861	1125315	0	0
45694674	1177480	0	0
45684726	1125315	0	0
45785732	19127890	0	0
46243052	1125315	0	0
45791078	1125315	0	0
45790647	1125315	0	0
45789112	1112807	0	0
46321783	1738521	0	0
45897176	1307863	0	0
3026023	3023103	2	2
21000485	19007333	2	3
4169307	4048169	2	2
21005429	1107830	0	0
21490931	3009542	2	2
36158221	1107830	0	0
35707864	192671	0	0
42803662	740275	0	0
36718595	4029498	4	4
44359306	1125315	0	0
45619759	1177480	0	0
45652540	1778162	0	0
45640709	1125315	0	0
45637558	1129625	0	0
45633844	1119510	0	0
45635924	1125315	0	0
45668324	1112807	0	0
45661706	19127890	0	0
45673325	19079524	1	1
45707438	1129625	0	0
45631099	1177480	0	0
45648731	1125315	0	0
45697346	1125315	0	0
45694824	1177480	0	0
45684727	1125315	0	0
45785732	1515774	0	0
46243122	1125315	0	0
45791085	1125315	0	0
45790652	1125315	0	0
46301922	1112807	0	0
46321788	1310149	0	0
45897160	1154029	0	0
3026023	3015632	2	2
21000110	19129655	2	3
4169307	4102123	2	2
21005429	1129625	0	0
21490931	3006322	2	2
36158400	1107830	0	0
36211270	4218389	0	0
42803605	920293	0	0
40786267	3010813	4	4
44359093	1125315	0	0
45619857	1153428	0	0
45652541	753626	0	0
45640726	1125315	0	0
45637160	1129625	0	0
45631382	1119510	0	0
45635932	1125315	0	0
45668365	1112807	0	0
45661706	1549786	0	0
45704630	46275916	1	1
45707310	1129625	0	0
45676393	1177480	0	0
45648496	1125315	0	0
45697116	1125315	0	0
45694749	1177480	0	0
45681602	1125315	0	0
45785737	1549786	0	0
46243125	1125315	0	0
45791189	1125315	0	0
45790576	1125315	0	0
46299178	1112807	0	0
46315732	1124957	0	0
45897161	1343916	0	0
3026023	3045716	2	2
21001028	19123231	2	3
4169307	4139681	2	2
21005418	1149380	0	0
21490931	3006906	2	2
36158410	1107830	0	0
36211215	375671	0	0
42803809	1154343	0	0
40786267	3026361	4	4
44351888	1125315	0	0
45619858	1177480	0	0
45652683	1107830	0	0
45640970	1125315	0	0
45637188	1129625	0	0
45631424	1119510	0	0
45635938	1125315	0	0
45665752	1112807	0	0
45661706	1512674	0	0
45698673	46275916	1	1
45707682	1129625	0	0
45628258	1177480	0	0
45648504	1125315	0	0
45697120	1125315	0	0
45694194	1177480	0	0
45681373	1125315	0	0
45785739	705944	0	0
46243126	1125315	0	0
46294624	1125315	0	0
45790422	1125315	0	0
46299586	1112807	0	0
46316385	1539403	0	0
45897164	1738521	0	0
3022035	3014576	2	2
21001028	40236446	2	3
4040400	4218408	2	2
21005429	1149196	0	0
21505608	1361711	2	2
36158417	1192710	0	0
36211224	4132546	0	0
42803609	1551099	0	0
40782957	3026361	4	4
44352027	1125315	0	0
45619935	1539403	0	0
45652610	1729720	0	0
45641039	1125315	0	0
45639940	1129625	0	0
45628143	1119510	0	0
45636021	1125315	0	0
45666030	1112807	0	0
45661707	920293	0	0
45697227	19079524	1	1
45707489	1129625	0	0
45628166	1177480	0	0
45648779	1125315	0	0
45697223	1125315	0	0
45694221	1177480	0	0
45681385	1125315	0	0
45785562	1539403	0	0
46243128	1125315	0	0
46294894	1125315	0	0
45790661	1125315	0	0
46299596	1112807	0	0
46316467	1501700	0	0
45897267	1551099	0	0
3022035	3023103	2	2
21000054	19129655	2	3
4083964	4296204	2	2
21005429	1192710	0	0
21500419	914335	2	2
36157956	1521369	0	0
36211455	4296204	0	0
42803698	1308738	0	0
40782957	3007461	4	4
44352051	1125315	0	0
45619808	914335	0	0
45652613	1107830	0	0
45641060	1125315	0	0
45634207	1129625	0	0
45628146	1119510	0	0
45632981	1125315	0	0
45666135	1112807	0	0
45661646	1361711	0	0
45695126	19079524	1	1
45707585	1129625	0	0
45627856	1177480	0	0
45648853	1125315	0	0
45697436	1125315	0	0
45694531	1177480	0	0
45682613	1125315	0	0
45785552	967823	0	0
46244644	1125315	0	0
46294399	1125315	0	0
45790448	1125315	0	0
46301613	1112807	0	0
46316280	1738521	0	0
45897271	1129625	0	0
3022035	3019550	2	2
21000059	19129655	2	3
4181192	4295880	2	2
21006489	1112807	0	0
21602882	1778162	2	2
36157958	1149380	0	0
36156071	1112807	0	0
42803821	1501700	0	0
40782957	3024561	4	4
44352053	1125315	0	0
44364329	1112807	0	0
45652369	1713332	0	0
45640957	1125315	0	0
45634332	1129625	0	0
45628558	1119510	0	0
45632663	1125315	0	0
45663628	1112807	0	0
45661649	738818	0	0
45689489	19134077	1	1
45707425	1129625	0	0
45627942	1177480	0	0
45648752	1125315	0	0
45697393	1125315	0	0
45694470	1177480	0	0
45682629	1125315	0	0
45785569	738818	0	0
46244713	1125315	0	0
46294636	1125315	0	0
45790485	1125315	0	0
46295502	1112807	0	0
46316373	1521369	0	0
45897273	715997	0	0
3022035	3015632	2	2
21000059	46233988	2	3
4029698	4330583	2	2
21005418	975125	0	0
21500375	40169281	2	2
36157962	1107830	0	0
36156051	1000560	0	0
42803819	1548195	0	0
37622411	4310024	4	4
44352199	1125315	0	0
44361443	1129625	0	0
45652229	1501700	0	0
45640996	1125315	0	0
45634126	1129625	0	0
45628577	1119510	0	0
45632996	1125315	0	0
45663701	1112807	0	0
45661341	1539403	0	0
45686464	46275916	1	1
45707419	1129625	0	0
45676212	1177480	0	0
45648754	1125315	0	0
45697394	1125315	0	0
45694235	1177480	0	0
45682579	1125315	0	0
45785519	975125	0	0
46244717	1125315	0	0
46294831	1125315	0	0
45790486	1125315	0	0
46295717	1112807	0	0
46316373	1548195	0	0
45897237	1589505	0	0
3022035	3045716	2	2
21000059	46233710	2	3
4029698	4242997	2	2
21005429	1150836	0	0
21503963	1125315	2	2
36158469	705944	0	0
36156107	1551099	0	0
42803932	1000560	0	0
37602360	4324181	4	4
44355217	1125315	0	0
44360994	1326303	0	0
45652728	914335	0	0
45640997	1125315	0	0
45634507	1129625	0	0
45628181	1119510	0	0
45633987	1125315	0	0
45663340	1112807	0	0
45661656	1124957	0	0
45686674	46275916	1	1
45704626	1129625	0	0
45624508	1177480	0	0
45648785	1125315	0	0
45697397	1125315	0	0
45694313	1177480	0	0
45682601	1125315	0	0
45785619	1519936	0	0
46244718	1125315	0	0
46294921	1125315	0	0
45790742	1125315	0	0
46296022	1112807	0	0
46315829	1112807	0	0
45897198	1332418	0	0
378125	4043241	2	2
21000057	46233988	2	3
4042150	4199276	2	2
21005672	1310149	0	0
21503963	1112807	2	2
36158471	1000560	0	0
36156108	1332418	0	0
42803705	975125	0	0
40772922	3005136	4	4
44355222	1125315	0	0
44361401	715997	0	0
45652275	1713332	0	0
45640888	1125315	0	0
45634456	1129625	0	0
45628512	1119510	0	0
45633974	1125315	0	0
45660205	1112807	0	0
45661439	1332418	0	0
45686687	19079524	1	1
45704872	1129625	0	0
45624673	1177480	0	0
45648787	1125315	0	0
45697450	1125315	0	0
45691302	1177480	0	0
45681714	1125315	0	0
45785570	1551099	0	0
46240819	1125315	0	0
46294925	1125315	0	0
45790586	1125315	0	0
46295328	1112807	0	0
46315837	1102527	0	0
45897295	1174888	0	0
377091	380378	2	2
21000057	46233710	2	3
4096864	81893	6	7
21005779	1551099	0	0
21503963	1129625	2	2
36158473	975125	0	0
36156135	1000560	0	0
42803846	1154343	0	0
37604009	321042	4	4
44355461	1125315	0	0
44360997	1124957	0	0
45652278	1153428	0	0
45640935	1125315	0	0
45634588	1129625	0	0
45628491	1119510	0	0
45634062	1125315	0	0
45660375	1112807	0	0
45661767	1192710	0	0
45680193	46275916	1	1
45704966	1129625	0	0
45624797	1177480	0	0
45648972	1125315	0	0
45697262	1125315	0	0
45802604	1177480	0	0
45681806	1125315	0	0
45785608	1112807	0	0
46241080	1125315	0	0
46294808	1125315	0	0
45790701	1125315	0	0
46296247	1112807	0	0
46316047	1174888	0	0
45897340	1119510	0	0
378419	4043241	2	2
21001022	40236446	2	3
4182161	4048171	6	7
21006489	1545958	0	0
21500437	914335	2	2
36158475	1548195	0	0
36156137	1551099	0	0
42803571	1551099	0	0
37604009	381316	4	4
44355406	1125315	0	0
44360940	1192710	0	0
45652486	1149196	0	0
45641180	1125315	0	0
45634590	1129625	0	0
45628355	1119510	0	0
45633957	1125315	0	0
45660472	1112807	0	0
45661775	1501700	0	0
45679694	46275916	1	1
45705028	1129625	0	0
45624816	1177480	0	0
45648624	1125315	0	0
45697355	1125315	0	0
45802541	1177480	0	0
45681727	1125315	0	0
45785615	1539403	0	0
46240867	1125315	0	0
46294937	1125315	0	0
45790860	1125315	0	0
46296152	1112807	0	0
46316398	975125	0	0
45897342	1326303	0	0
321588	4329847	2	3
21001057	40232448	2	3
4185503	313217	6	7
21006489	1539403	0	0
21505647	738818	2	2
36158478	1149196	0	0
36156140	1713332	0	0
42803983	1551099	0	0
40785842	3026361	4	4
44355464	1125315	0	0
44361446	1129625	0	0
45652487	1192710	0	0
45640939	1125315	0	0
45631209	1129625	0	0
45625450	1119510	0	0
45633993	1125315	0	0
45654226	1112807	0	0
45661490	1717327	0	0
45671187	46275916	1	1
45701121	1129625	0	0
45625003	1177480	0	0
45649084	1125315	0	0
45697365	1125315	0	0
45802406	1177480	0	0
45681842	1125315	0	0
45785915	757627	0	0
46240868	1125315	0	0
46294175	1125315	0	0
45790868	1125315	0	0
46244695	1112807	0	0
46316407	1545958	0	0
45894756	1129625	0	0
1766436	46275916	2	3
21000083	19074841	2	3
4043182	4198190	6	7
21601161	967823	0	0
21505647	1129625	2	2
36158501	1124957	0	0
36156121	920293	0	0
42803716	1548195	0	0
40783188	3027970	4	4
44352442	1125315	0	0
44361450	1177480	0	0
45652488	1549786	0	0
45641106	1125315	0	0
45631312	1129625	0	0
45625378	1119510	0	0
45634033	1125315	0	0
45654148	1112807	0	0
45661502	1343916	0	0
45671222	19074679	1	1
45701253	1129625	0	0
45670673	1177480	0	0
45649088	1125315	0	0
45697369	1125315	0	0
45688452	1177480	0	0
45681729	1125315	0	0
45785660	1746114	0	0
46240999	1125315	0	0
46294362	1125315	0	0
45790916	1125315	0	0
46244638	1112807	0	0
46316440	1326303	0	0
45894763	1177480	0	0
78831	81151	2	3
21000083	19075001	2	3
4040400	4198190	6	7
21601180	967823	0	0
21500489	933724	2	2
36158484	1118084	0	0
36155890	975125	0	0
42803572	1000560	0	0
40783188	3024561	4	4
44352420	1125315	0	0
44361450	1174888	0	0
45652488	19127890	0	0
45641010	1125315	0	0
45631557	1129625	0	0
45625497	1119510	0	0
45659022	1119510	0	0
45654501	1112807	0	0
45661503	914335	0	0
45670516	46275916	1	1
45701209	1129625	0	0
45670523	1177480	0	0
45649094	1125315	0	0
45697421	1125315	0	0
45688466	1177480	0	0
45681780	1125315	0	0
45785660	1741122	0	0
46240870	1125315	0	0
46294957	1125315	0	0
45790956	1125315	0	0
46244640	1112807	0	0
46316427	933724	0	0
45894791	1177480	0	0
1347450	40220960	2	3
21000083	19133905	2	3
4101796	4043241	6	7
21502623	1713332	0	0
21503968	1125315	2	2
36158485	1124300	0	0
36155893	791967	0	0
42803968	705944	0	0
40782937	3012494	4	4
44352551	1125315	0	0
44361452	933724	0	0
45652291	1110410	0	0
45637567	1125315	0	0
45628561	1129625	0	0
45625290	1119510	0	0
45659125	1119510	0	0
45654482	1112807	0	0
45661806	1332418	0	0
45707864	46275916	1	1
45703450	1129625	0	0
45670537	1177480	0	0
45649154	1125315	0	0
45697521	1125315	0	0
45688382	1177480	0	0
45681790	1125315	0	0
45785861	1115008	0	0
46240882	1125315	0	0
46294430	1125315	0	0
45790571	1125315	0	0
46240008	1112807	0	0
46316444	1000560	0	0
45894834	920293	0	0
1101352	19126352	2	3
21000083	19073188	2	3
4042140	375671	6	10
21502628	1728416	0	0
21503968	1112807	2	2
36158490	1115008	0	0
36155894	723013	0	0
42803945	1000560	0	0
40782937	3001247	4	4
44352602	1125315	0	0
44361403	1115008	0	0
44344272	738818	0	0
45637614	1125315	0	0
45628570	1129625	0	0
45625707	1119510	0	0
45659288	1119510	0	0
45651899	1112807	0	0
45661146	1124957	0	0
45707882	46275916	1	1
45703403	1129625	0	0
45670484	1177480	0	0
45645959	1125315	0	0
45894486	1125315	0	0
45800015	1177480	0	0
45681927	1125315	0	0
45785796	1149196	0	0
46240888	1125315	0	0
46294972	1125315	0	0
45790927	1125315	0	0
46240070	1112807	0	0
46316635	1112807	0	0
45894799	19010482	0	0
782043	782047	2	3
21000083	19133873	2	3
4083964	78272	6	6
21502630	1741122	0	0
21500296	1343916	2	2
36158504	1308738	0	0
36156161	1129625	0	0
42803984	1545958	0	0
37604032	321042	4	4
44352592	1125315	0	0
44361462	975125	0	0
44344273	1343916	0	0
45637575	1125315	0	0
45628633	1129625	0	0
45625640	1119510	0	0
45659135	1119510	0	0
45650925	1112807	0	0
45661154	1107830	0	0
45708020	19079524	1	1
45701656	1129625	0	0
45670365	1177480	0	0
45645996	1125315	0	0
45894709	1125315	0	0
45799986	1177480	0	0
45681939	1125315	0	0
45785929	1713332	0	0
46240749	1125315	0	0
46294677	1125315	0	0
45790786	1125315	0	0
45896708	1112807	0	0
46316656	1149196	0	0
45894567	738818	0	0
836654	836659	2	3
21000083	19129655	2	3
4300157	4134304	6	6
21502656	933724	0	0
21601160	967823	2	2
36158516	1177480	0	0
36156186	1713332	0	0
42803718	1501700	0	0
37604032	4163874	4	4
44352599	1125315	0	0
44361374	1112807	0	0
44344589	1307863	0	0
45637577	1125315	0	0
45628539	1129625	0	0
45625601	1119510	0	0
45659252	1119510	0	0
45651057	1112807	0	0
45661130	1174888	0	0
45633075	1125315	0	0
45698316	1129625	0	0
45669303	1177480	0	0
45646172	1125315	0	0
45694981	1125315	0	0
45799793	1177480	0	0
45681941	1125315	0	0
45785929	1759842	0	0
46240836	1125315	0	0
46294680	1125315	0	0
45790687	1125315	0	0
45896575	1112807	0	0
46316700	1713332	0	0
45894571	1112807	0	0
4002905	4285898	2	3
21000480	1551192	2	3
4101796	375671	6	6
21500371	1149380	0	0
21492840	21494966	2	2
36158520	933724	0	0
36155991	1343916	0	0
42803670	1713332	0	0
40481352	4058899	4	4
44352503	1125315	0	0
44361376	738818	0	0
44344528	738818	0	0
45662059	1310149	0	0
45628480	1129625	0	0
45625603	1119510	0	0
45659178	1119510	0	0
45650906	1112807	0	0
45661181	723013	0	0
45633070	1125315	0	0
45698446	1129625	0	0
45669262	1177480	0	0
45646338	1125315	0	0
45694872	1125315	0	0
45799825	1177480	0	0
45681735	1125315	0	0
45785932	1717327	0	0
46240960	1125315	0	0
46294767	1125315	0	0
45790990	1125315	0	0
45896561	1112807	0	0
46316712	1112807	0	0
45894840	19003953	0	0
1766606	19008572	2	3
21001385	19129655	2	3
4043350	4168004	6	6
21500409	1177480	0	0
35102033	439777	2	2
36158527	1332418	0	0
36155992	1110410	0	0
42803915	1713332	0	0
40481352	4047491	4	4
44352806	1125315	0	0
44360942	1149380	0	0
44344529	933724	0	0
45662024	1107830	0	0
45628307	1129625	0	0
45625751	1119510	0	0
45659325	1119510	0	0
45651091	1112807	0	0
45661183	1361711	0	0
45633064	1125315	0	0
45698448	1129625	0	0
45669314	1177480	0	0
45645677	1125315	0	0
45694190	1125315	0	0
45800191	1177480	0	0
45681860	1125315	0	0
45785667	1000560	0	0
46240961	1125315	0	0
46296634	1125315	0	0
45790995	1125315	0	0
46317431	1112807	0	0
46316346	1112807	0	0
45894843	1500211	0	0
1551099	1551192	2	3
21001385	19073188	2	3
4042150	4330583	6	6
21013795	1110410	0	0
21500416	967823	2	2
36158533	1177480	0	0
36155995	920293	0	0
42803915	1759842	0	0
37203779	317576	4	4
44352453	1125315	0	0
44361193	1115008	0	0
44344539	967823	0	0
45662023	1501700	0	0
45628728	1129625	0	0
45622067	1119510	0	0
45659327	1119510	0	0
45650998	1112807	0	0
45661163	1115008	0	0
45633122	1125315	0	0
45698456	1129625	0	0
45666882	1177480	0	0
45645587	1125315	0	0
45694285	1125315	0	0
45685678	1177480	0	0
45681973	1125315	0	0
45785913	1115008	0	0
46240949	1125315	0	0
46244043	1125315	0	0
46297464	1125315	0	0
46317768	1112807	0	0
46316346	1192710	0	0
45894846	1129625	0	0
376106	381316	2	3
21001385	19133905	2	3
4042150	4242997	6	6
21013786	1728416	0	0
21500259	1343916	2	2
36154376	1174888	0	0
36156001	738818	0	0
42802880	1119510	0	0
37203779	321042	4	4
44352639	1125315	0	0
44361366	1551099	0	0
44344148	1124300	0	0
45662154	1332418	0	0
45625169	1129625	0	0
45622128	1119510	0	0
45656835	1119510	0	0
45647758	1112807	0	0
45661217	1124300	0	0
45633090	1125315	0	0
45698689	1129625	0	0
45666924	1177480	0	0
45645589	1125315	0	0
45694195	1125315	0	0
45685296	1177480	0	0
45678453	1125315	0	0
45785676	1107830	0	0
46241059	1125315	0	0
46244045	1125315	0	0
46297721	1125315	0	0
45794380	1112807	0	0
46316543	1713332	0	0
45894849	1119510	0	0
376106	4066995	2	3
21001385	19074843	2	3
4134598	4163971	6	6
21013767	914335	0	0
21500270	1539403	2	2
36154347	1129625	0	0
36156226	1177480	0	0
42802880	738818	0	0
37302323	4113008	4	4
44352478	1125315	0	0
44361372	1174888	0	0
44344082	1115008	0	0
45662157	19127890	0	0
45625301	1129625	0	0
45622164	1119510	0	0
45657237	1119510	0	0
45648044	1112807	0	0
45661219	1192710	0	0
45633148	1125315	0	0
45698693	1129625	0	0
45667106	1177480	0	0
45645655	1125315	0	0
45694303	1125315	0	0
45685350	1177480	0	0
45678574	1125315	0	0
45785716	740275	0	0
46240953	1125315	0	0
46244046	1125315	0	0
46297640	1125315	0	0
45794436	1112807	0	0
46316543	1759842	0	0
45894851	1119510	0	0
1766448	1107882	2	3
21001385	19073183	2	3
4042150	4323902	5	6
21013768	914335	0	0
21500270	1112807	2	2
36154367	1000560	0	0
36156227	1154029	0	0
42802880	1125315	0	0
37302323	4109685	4	4
44352630	1125315	0	0
44361547	1124957	0	0
44344086	1153428	0	0
45662157	1512674	0	0
45625419	1129625	0	0
45622319	1119510	0	0
45657291	1119510	0	0
45647969	1112807	0	0
45661155	708298	0	0
45633151	1125315	0	0
45698571	1129625	0	0
45778449	1177480	0	0
45645886	1125315	0	0
45694230	1125315	0	0
45685528	1177480	0	0
45678796	1125315	0	0
45785747	1112807	0	0
46241090	1125315	0	0
46244048	1125315	0	0
46297191	1125315	0	0
46306918	1112807	0	0
46316545	791967	0	0
45894852	1551099	0	0
376337	44782520	2	3
21001385	19075001	2	3
4096864	4285898	5	6
21013805	1308738	0	0
21503472	967823	2	2
36154512	1177480	0	0
36156228	1118084	0	0
42803046	1119510	0	0
37302323	4152936	4	4
42802984	1125315	0	0
44361548	1129625	0	0
44344673	1738521	0	0
45662157	1549786	0	0
45625728	1129625	0	0
45622507	1119510	0	0
45657115	1119510	0	0
45647865	1112807	0	0
45661116	1343916	0	0
45676759	1125315	0	0
45698260	1129625	0	0
45639424	19128263	1	2
45645710	1125315	0	0
45694342	1125315	0	0
45685255	1177480	0	0
45678730	1125315	0	0
45785772	1192710	0	0
46241067	1125315	0	0
46244078	1125315	0	0
46297754	1125315	0	0
46307055	1112807	0	0
46316729	757627	0	0
45894853	1192710	0	0
1778162	19075001	2	3
21000056	46233710	2	3
4182161	4294548	5	6
21013911	723013	0	0
21600491	1000560	2	2
36154514	1332418	0	0
36156193	1738521	0	0
42802814	1332418	0	0
37019275	45769019	4	4
42802731	1125315	0	0
44361584	1118084	0	0
44344590	1545958	0	0
45662158	1332418	0	0
45625472	1129625	0	0
45622377	1119510	0	0
45657174	1119510	0	0
45644778	1112807	0	0
45661119	1154029	0	0
45676449	1125315	0	0
45698592	1129625	0	0
45627251	19128022	3	4
45645611	1125315	0	0
45694349	1125315	0	0
45685426	1177480	0	0
45678667	1125315	0	0
45785776	975125	0	0
46241069	1125315	0	0
46244092	1125315	0	0
46297417	1125315	0	0
46307064	1112807	0	0
46316216	1332418	0	0
45894888	1119510	0	0
1101498	19078461	2	3
21000056	46233988	2	3
4182161	4280726	5	6
21013820	1124957	0	0
21500355	1119510	2	2
36154245	1112807	0	0
36156195	1129625	0	0
42802819	1125315	0	0
37203784	40486433	4	4
42802914	1125315	0	0
44361671	1107830	0	0
44344679	920293	0	0
45662112	1000560	0	0
45625549	1129625	0	0
45620938	1119510	0	0
45657260	1119510	0	0
45644995	1112807	0	0
45661175	1115008	0	0
45676458	1125315	0	0
45698607	1129625	0	0
45633494	19133679	3	4
45645745	1125315	0	0
45694479	1125315	0	0
45685527	1177480	0	0
45678875	1125315	0	0
45785777	920293	0	0
46241098	1125315	0	0
46244100	1125315	0	0
46297345	1125315	0	0
46307236	1112807	0	0
46316192	1738521	0	0
45894645	1119510	0	0
1000560	35605482	2	3
21000082	19133873	2	3
4182161	40486433	5	6
21013795	1124957	0	0
21601167	967823	2	2
36154332	1112807	0	0
36156196	1361711	0	0
42802819	1124957	0	0
37203784	4280726	4	4
42802868	1125315	0	0
44361702	738818	0	0
44344683	1545958	0	0
45662136	975125	0	0
45625807	1129625	0	0
45621030	1119510	0	0
45657491	1119510	0	0
45644884	1112807	0	0
45661221	1332418	0	0
45676826	1125315	0	0
45698799	1129625	0	0
45708291	19128009	2	2
45645723	1125315	0	0
45694485	1125315	0	0
45799694	1177480	0	0
45678899	1125315	0	0
45785779	738818	0	0
46240622	1125315	0	0
46244101	1125315	0	0
46297562	1125315	0	0
46307969	1112807	0	0
46316555	1107830	0	0
45894646	1192710	0	0
1549786	44816277	2	3
21000082	19073183	2	3
4043346	313217	5	6
21013820	1174888	0	0
21601194	967823	2	2
36154378	1738521	0	0
36156197	1738521	0	0
42802827	1149196	0	0
40786239	3023430	4	4
44344956	1125315	0	0
44361116	1713332	0	0
44344593	1192710	0	0
45662205	723013	0	0
45625633	1129625	0	0
45621153	1119510	0	0
45657398	1119510	0	0
45645032	1112807	0	0
45661317	1539403	0	0
45676633	1125315	0	0
45697311	1129625	0	0
45708291	19127918	2	2
45645815	1125315	0	0
45694613	1125315	0	0
45797331	1177480	0	0
45678828	1125315	0	0
45785867	1112807	0	0
46240732	1125315	0	0
46244104	1125315	0	0
46297421	1125315	0	0
46302160	1112807	0	0
46310551	1174888	0	0
45894825	1129625	0	0
1549786	43012433	2	3
21000082	19075001	2	3
4042516	4047491	5	6
21013820	1154029	0	0
21504520	19132304	2	2
36154290	1738521	0	0
36156200	1177480	0	0
42802829	1129625	0	0
37220016	4048171	4	4
44344798	1125315	0	0
44360952	1713332	0	0
44344600	723013	0	0
45662071	1110410	0	0
45625748	1129625	0	0
45621046	1119510	0	0
45657401	1119510	0	0
45645114	1112807	0	0
45661460	1738521	0	0
45676802	1125315	0	0
45695171	1129625	0	0
45683963	19128009	2	2
45645695	1125315	0	0
45694458	1125315	0	0
45797412	1177480	0	0
45678830	1125315	0	0
45785881	1115008	0	0
46240641	1125315	0	0
46244114	1125315	0	0
46297649	1125315	0	0
46302018	1112807	0	0
46310616	1501700	0	0
45894830	1129625	0	0
1101405	1551192	2	3
21000082	19073188	2	3
4030654	4198190	5	7
21013820	1110410	0	0
21504520	46221626	2	2
36154317	1124957	0	0
36156201	1129625	0	0
42802829	1125315	0	0
37203771	40481087	4	4
44344986	1125315	0	0
44361554	1177480	0	0
44344477	1149380	0	0
45662076	1539403	0	0
45622139	1129625	0	0
45620770	1119510	0	0
45655376	1119510	0	0
45645057	1112807	0	0
45661359	1548195	0	0
45676550	1125315	0	0
45695421	1129625	0	0
45683963	19127918	2	2
45645702	1125315	0	0
45694425	1125315	0	0
45797378	1177480	0	0
45672509	1125315	0	0
45785713	1549786	0	0
46240625	1125315	0	0
46244064	1125315	0	0
46297656	1125315	0	0
46302451	1112807	0	0
46310726	1309944	0	0
45894608	1107830	0	0
1343916	1594382	2	3
21000082	19074841	2	3
4042140	4112343	5	10
21013911	791967	0	0
21505615	1343916	2	2
36154609	1713332	0	0
36156203	1112807	0	0
42802921	1107830	0	0
37502338	4057420	4	4
44345104	1125315	0	0
44361381	1177480	0	0
44344479	1118084	0	0
45662106	708298	0	0
45622146	1129625	0	0
45621086	1119510	0	0
45655462	1119510	0	0
45645298	1112807	0	0
45661365	1115008	0	0
45676495	1125315	0	0
45691793	1129625	0	0
45677773	19128009	2	2
45645786	1125315	0	0
45694606	1125315	0	0
45797384	1177480	0	0
45672421	1125315	0	0
45785713	1595799	0	0
46240634	1125315	0	0
46244021	1125315	0	0
46297658	1125315	0	0
46306580	1112807	0	0
46310794	975125	0	0
45894895	1177480	0	0
1343916	46275916	2	3
21000082	19133905	2	3
4042140	40486433	5	10
21013911	708298	0	0
21505600	975125	2	2
36154609	1759842	0	0
36156204	1129625	0	0
42802985	1129625	0	0
37203772	4048171	4	4
44345112	1125315	0	0
44361587	1557272	0	0
44344711	1332418	0	0
45662014	1174888	0	0
45622297	1129625	0	0
45621197	1119510	0	0
45655423	1119510	0	0
45642290	1112807	0	0
45661279	1153428	0	0
45676925	1125315	0	0
45692129	1129625	0	0
45694364	19128009	2	2
45645770	1125315	0	0
45694687	1125315	0	0
45682439	1177480	0	0
45672544	1125315	0	0
45785713	1521369	0	0
46240845	1125315	0	0
46244075	1125315	0	0
46297663	1125315	0	0
46306841	1112807	0	0
46310799	1124957	0	0
45894616	1124957	0	0
376208	4310024	2	4
21000478	1551192	2	3
4180627	4336464	5	10
21013864	1112807	0	0
21505600	1589505	2	2
36154715	1129625	0	0
36156206	738818	0	0
42802986	1129625	0	0
37203772	258780	4	4
44345010	1125315	0	0
44361591	1177480	0	0
44344196	1539403	0	0
45662172	1521369	0	0
45622466	1129625	0	0
45621159	1119510	0	0
45653955	1119510	0	0
45639079	1112807	0	0
45661327	914335	0	0
45676926	1125315	0	0
45692322	1129625	0	0
45683640	42902245	2	2
45645825	1125315	0	0
45802384	1125315	0	0
45682405	1177480	0	0
45673187	1125315	0	0
45785890	1115008	0	0
46238191	1125315	0	0
46244140	1125315	0	0
46297284	1125315	0	0
46299777	1112807	0	0
46310846	975125	0	0
45894695	1129625	0	0
376106	4132546	2	4
21000478	19007333	2	3
4180627	4078793	5	7
21013849	1322184	0	0
21505697	705944	2	2
36154716	1129625	0	0
36156083	1305058	0	0
42802987	1112807	0	0
37521809	4057420	4	4
44345019	1125315	0	0
44360959	715997	0	0
44344696	1107830	0	0
45662268	1738521	0	0
45620867	1129625	0	0
45664704	1119510	0	0
45647482	1119510	0	0
45640149	1112807	0	0
45661403	1153428	0	0
45676805	1125315	0	0
45692175	1129625	0	0
45779549	42902245	2	2
45642679	1125315	0	0
45802513	1125315	0	0
45682505	1177480	0	0
45673188	1125315	0	0
45785985	738818	0	0
46240043	1125315	0	0
46244164	1125315	0	0
46297601	1125315	0	0
46300041	1112807	0	0
46310838	19010482	0	0
45894750	1738521	0	0
440029	4112343	2	5
21000482	19007333	2	3
4134598	4242997	5	5
21013966	1738521	0	0
21500485	914335	2	2
36154509	19003953	0	0
36156168	1713332	0	0
42802989	1112807	0	0
40789541	3036780	4	4
44345024	1125315	0	0
44361423	715997	0	0
44344645	1539403	0	0
45662269	738818	0	0
45620829	1129625	0	0
45664714	1119510	0	0
45647393	1119510	0	0
45635869	1112807	0	0
45777830	1124300	0	0
45676969	1125315	0	0
45692264	1129625	0	0
45695953	19128009	2	2
45642704	1125315	0	0
45802498	1125315	0	0
45794846	1177480	0	0
45673384	1125315	0	0
45785964	1124300	0	0
46240207	1125315	0	0
46244165	1125315	0	0
46297973	1125315	0	0
46300144	1112807	0	0
46310854	1332418	0	0
45894753	1192710	0	0
442628	81151	2	5
21000482	1551192	2	3
4134598	4330583	5	5
21013919	1738521	0	0
21500485	933724	2	2
36154511	1713332	0	0
36156168	1759842	0	0
42802990	1192710	0	0
40760929	3019550	4	4
44344975	1125315	0	0
44361435	1501700	0	0
45646038	1322184	0	0
45662203	715997	0	0
45620837	1129625	0	0
45667171	1119510	0	0
45647398	1119510	0	0
45636011	1112807	0	0
45777849	738818	0	0
45676788	1125315	0	0
45692058	1129625	0	0
45654911	40163554	2	3
45642755	1125315	0	0
45802647	1125315	0	0
45794823	1177480	0	0
45673296	1125315	0	0
45785989	1545958	0	0
46240045	1125315	0	0
46244171	1125315	0	0
46297565	1125315	0	0
46318763	1112807	0	0
46305661	723013	0	0
45894772	1343916	0	0
376208	78272	3	8
21000052	46233988	2	3
4182161	257012	5	5
21601198	967823	0	0
21500460	926487	2	2
36154593	920293	0	0
36156434	1000560	0	0
42802992	1119510	0	0
40782918	3001488	4	4
44345051	1125315	0	0
44361679	1115008	0	0
45646189	1310149	0	0
45662331	1308738	0	0
45620772	1129625	0	0
45667415	1119510	0	0
45647552	1119510	0	0
45656818	975125	0	0
45777823	738818	0	0
45676901	1125315	0	0
45692142	1129625	0	0
45654867	40228214	2	3
45642856	1125315	0	0
45802571	1125315	0	0
45794961	1177480	0	0
45673297	1125315	0	0
45785724	1738521	0	0
46238277	1125315	0	0
46244175	1125315	0	0
46297829	1125315	0	0
46318978	1112807	0	0
46305667	1112807	0	0
45894740	1310149	0	0
376208	81151	3	7
21000052	19129655	2	3
4096864	440448	5	5
21504555	1518198	0	0
21505685	1129625	2	2
36154596	1713332	0	0
36156437	1129625	0	0
42802993	1112807	0	0
37203779	4329847	4	5
44345052	1125315	0	0
44361115	1545958	0	0
45646354	1332418	0	0
45662338	1343916	0	0
45620904	1129625	0	0
45664779	1119510	0	0
45647680	1119510	0	0
45657030	975125	0	0
45654732	1308738	0	0
45676974	1125315	0	0
45694662	1129625	0	0
45654831	40232448	2	3
45642870	1125315	0	0
45688436	1125315	0	0
45679480	1177480	0	0
45673404	1125315	0	0
45785831	1501700	0	0
46238379	1125315	0	0
46244228	1125315	0	0
46297923	1125315	0	0
46318918	1112807	0	0
46305729	975125	0	0
45894741	1129625	0	0
440921	4001336	3	6
21000052	46233710	2	3
4040400	4275113	5	5
21504555	1549786	0	0
21505685	1119510	2	2
36154596	1759842	0	0
36156438	1177480	0	0
42802998	1396131	0	0
37102305	4116491	4	5
44345037	1125315	0	0
44361656	1322184	0	0
45646385	705944	0	0
45662034	1551099	0	0
45621193	1129625	0	0
45664815	1119510	0	0
45647566	1119510	0	0
45657121	975125	0	0
45654756	1551099	0	0
45676953	1125315	0	0
45689151	1129625	0	0
45655016	1115171	2	3
45642904	1125315	0	0
45688459	1125315	0	0
45679344	1177480	0	0
45672726	1125315	0	0
45785829	975125	0	0
46238423	1125315	0	0
46244232	1125315	0	0
46298083	1125315	0	0
46319189	1112807	0	0
46305734	933724	0	0
45894743	1119510	0	0
432250	4112343	3	6
21000051	19129655	2	3
4040400	4242997	5	5
21504516	1125315	0	0
21505685	738818	2	2
36154597	1343916	0	0
36156606	1343916	0	0
42803003	1125315	0	0
36718595	4066995	4	5
44345130	1125315	0	0
44361681	1124300	0	0
45646047	1545958	0	0
45662051	933724	0	0
45620962	1129625	0	0
45664795	1119510	0	0
45647945	1119510	0	0
45657404	975125	0	0
45654774	723013	0	0
45676958	1125315	0	0
45689157	1129625	0	0
45655109	40229134	2	3
45688468	1125315	0	0
45688525	1125315	0	0
45679350	1177480	0	0
45672670	1125315	0	0
45785835	1153428	0	0
46238430	1125315	0	0
46244234	1125315	0	0
46297998	1125315	0	0
46312823	1112807	0	0
46305739	1305058	0	0
45894744	1713332	0	0
432250	4294548	3	6
21000051	46233988	2	3
4086921	4323208	5	5
21504604	1738521	0	0
21505685	1192710	2	2
36154603	1000560	0	0
36156609	708298	0	0
42802922	920293	0	0
36718595	381316	4	5
44345240	1125315	0	0
44361692	1153428	0	0
45646293	1326303	0	0
45662052	738818	0	0
45621015	1129625	0	0
45664796	1119510	0	0
45647738	1119510	0	0
45657218	975125	0	0
45654776	1149196	0	0
45676508	1125315	0	0
45689107	1129625	0	0
45654785	40229134	2	3
45688662	1125315	0	0
45688528	1125315	0	0
45679365	1177480	0	0
45672690	1125315	0	0
46296486	1729720	0	0
46238328	1125315	0	0
46244286	1125315	0	0
46297782	1125315	0	0
46312707	1112807	0	0
46305740	1154343	0	0
45894868	1119510	0	0
376106	4001336	3	5
21000051	46233710	2	3
4049222	4048171	5	5
21504524	975125	0	0
21505685	1174888	2	2
36154605	1343916	0	0
36156610	708298	0	0
42802927	1713332	0	0
37203764	441267	4	5
44345000	1125315	0	0
44361392	1124300	0	0
45645895	1307863	0	0
45662054	1717327	0	0
45664594	1129625	0	0
45664800	1119510	0	0
45647835	1119510	0	0
45657461	975125	0	0
45654889	1310149	0	0
45676977	1125315	0	0
45689210	1129625	0	0
45655250	1539411	2	3
45691237	1125315	0	0
45799878	1125315	0	0
45792034	1177480	0	0
45672713	1125315	0	0
46296489	1149380	0	0
46238280	1125315	0	0
46244289	1125315	0	0
46289301	1125315	0	0
46312650	1112807	0	0
46305742	1332418	0	0
45894814	715997	0	0
432250	4056621	3	5
4322976	4218408	2	5
4040551	4216130	5	5
21504611	1307863	0	0
21505679	1119510	2	2
36154612	1129625	0	0
36156580	1332418	0	0
42803007	1551099	0	0
37604009	4329847	4	5
44338171	1125315	0	0
44361399	1115008	0	0
45645966	1551099	0	0
45662304	19127890	0	0
45664675	1129625	0	0
45664832	1119510	0	0
45644561	1119510	0	0
45654095	975125	0	0
45654891	1310149	0	0
45676941	1125315	0	0
45689213	1129625	0	0
45655294	40232448	2	3
45691309	1125315	0	0
45800012	1125315	0	0
45792395	1177480	0	0
45672645	1125315	0	0
46296268	1551099	0	0
46238361	1125315	0	0
46244216	1125315	0	0
46289062	1125315	0	0
46307982	1112807	0	0
46305600	1000560	0	0
45894819	1149196	0	0
376337	4132546	3	5
4322976	4170947	2	6
4040551	4108705	5	5
21505616	1343916	0	0
21505679	1129625	2	2
36154592	1124300	0	0
36156583	1326303	0	0
40492359	40492359	0	0
37604032	4329847	4	5
44338227	1125315	0	0
44361661	1589505	0	0
45645968	1332418	0	0
45662304	1549786	0	0
45667417	1129625	0	0
45665071	1119510	0	0
45645870	1119510	0	0
45654055	975125	0	0
45654849	975125	0	0
45677021	1125315	0	0
45689448	1129625	0	0
45700976	1551192	2	3
45691388	1125315	0	0
45800016	1125315	0	0
45676144	1177480	0	0
45672719	1125315	0	0
46296273	1112807	0	0
46238368	1125315	0	0
46244371	1125315	0	0
46289159	1125315	0	0
46307453	1112807	0	0
46305617	1118084	0	0
45896562	1174888	0	0
133468	78272	3	5
4322976	4163951	2	6
4185503	4142905	5	5
21505633	1112807	0	0
21505679	738818	2	2
36154359	1154343	0	0
36156612	1343916	0	0
40224805	40224805	0	0
37604032	4310024	4	5
44338125	1125315	0	0
44361661	19127890	0	0
45646397	1124300	0	0
45662305	1137529	0	0
45664803	1129625	0	0
45662147	1119510	0	0
45646102	1119510	0	0
45654169	975125	0	0
45654884	1551099	0	0
45677117	1125315	0	0
45689351	1129625	0	0
45701613	19059056	2	3
45639811	1125315	0	0
45799990	1125315	0	0
45676150	1177480	0	0
45672721	1125315	0	0
46296356	1713332	0	0
45897397	1125315	0	0
46244290	1125315	0	0
46289221	1125315	0	0
46308325	1112807	0	0
46305775	1124957	0	0
45896566	1129625	0	0
440921	4299128	3	3
4344497	81151	2	6
4083964	81151	5	5
21505601	1549786	0	0
21505679	1192710	2	2
36154616	1738521	0	0
36156644	1149196	0	0
40229134	40229134	0	0
37219970	313217	4	5
44338098	1125315	0	0
44361661	1549786	0	0
45646404	1110410	0	0
45662305	1149380	0	0
45664806	1129625	0	0
45662269	1119510	0	0
45645929	1119510	0	0
45647443	975125	0	0
45624185	19128263	1	2
45673431	1125315	0	0
45689522	1129625	0	0
45701544	40228214	2	3
45639812	1125315	0	0
45800053	1125315	0	0
45676342	1177480	0	0
45672734	1125315	0	0
46296225	1102527	0	0
45897024	1125315	0	0
46244193	1125315	0	0
46289256	1125315	0	0
46302542	1112807	0	0
46305816	1124300	0	0
45896653	1310149	0	0
197331	195588	3	3
4283893	40481087	1	1
4041261	4275113	5	5
21505601	1519936	0	0
21505679	1174888	2	2
36154618	1112807	0	0
36156600	1713332	0	0
40228230	40228230	0	0
37622411	313217	4	5
44362848	1125315	0	0
44360966	1129625	0	0
45646413	975125	0	0
45662043	975125	0	0
45664810	1129625	0	0
45662052	1119510	0	0
45645933	1119510	0	0
45647554	975125	0	0
45663998	42902245	1	2
45673587	1125315	0	0
45686268	1129625	0	0
45701815	19008572	2	3
45639919	1125315	0	0
45800084	1125315	0	0
45789283	1177480	0	0
45672982	1125315	0	0
46296363	1115008	0	0
45897254	1125315	0	0
46244373	1125315	0	0
46289463	1125315	0	0
46302623	1112807	0	0
46305831	791967	0	0
45896421	782043	0	0
444208	258780	3	3
4283893	257012	1	1
4095203	4149245	5	5
21505634	1125315	0	0
21604390	740275	2	2
36154618	1192710	0	0
36156600	1759842	0	0
37219829	261325	0	0
37602360	317576	4	6
44362849	1125315	0	0
44361674	1713332	0	0
45645970	1174888	0	0
45662208	1115008	0	0
45664345	1129625	0	0
45662344	1119510	0	0
45644728	1119510	0	0
45647689	975125	0	0
45636250	1124300	0	0
45673472	1125315	0	0
45686296	1129625	0	0
45701712	19078924	2	3
45639927	1125315	0	0
45800086	1125315	0	0
45789380	1177480	0	0
45672821	1125315	0	0
46296302	1713332	0	0
45897276	1125315	0	0
46244305	1125315	0	0
46289813	1125315	0	0
46302866	1112807	0	0
46305944	1112807	0	0
45896517	1129625	0	0
4000610	4266809	3	3
4279139	4142905	1	1
4094284	40479422	5	5
21505634	1112807	0	0
21603616	975125	2	2
36154620	1551099	0	0
36156602	1729720	0	0
40758406	40758406	0	0
37502336	4301346	4	6
44362903	1125315	0	0
44361400	1322184	0	0
45645974	967823	0	0
45662210	738818	0	0
45664492	1129625	0	0
45658813	1119510	0	0
45644837	1119510	0	0
45647580	975125	0	0
45636009	708298	0	0
45673538	1125315	0	0
45686290	1129625	0	0
45701914	19133873	2	3
45639695	1125315	0	0
45800087	1125315	0	0
45789220	1177480	0	0
45672847	1125315	0	0
46296302	1759842	0	0
45897147	1125315	0	0
46244402	1125315	0	0
46289814	1125315	0	0
46302603	1112807	0	0
46306118	914335	0	0
45896765	1177480	0	0
4000610	4310024	3	3
19066170	42902245	1	1
4094284	40479768	5	5
21505689	1192710	0	0
21603616	1124300	2	2
36154668	1115008	0	0
36156682	1153428	0	0
40769179	40769179	0	0
37219945	255848	4	6
44362923	1125315	0	0
44361285	1149196	0	0
45646359	967823	0	0
45662211	1326303	0	0
45662098	1129625	0	0
45658830	1119510	0	0
45644747	1119510	0	0
45647931	975125	0	0
45636265	1149196	0	0
45673551	1125315	0	0
45686567	1129625	0	0
45701882	1127433	2	3
45639874	1125315	0	0
45799984	1125315	0	0
45789510	1177480	0	0
45672946	1125315	0	0
46296228	1322184	0	0
45897277	1125315	0	0
46244203	1125315	0	0
46289975	1125315	0	0
46303144	1112807	0	0
46306129	1308738	0	0
45896766	1119510	0	0
4000610	30753	3	3
19081494	19019979	1	1
4136694	78272	5	5
21505689	1174888	0	0
21601239	1326303	2	2
36154380	1112807	0	0
36158858	738818	0	0
37622518	192671	1	1
36718595	4132546	4	6
44362970	1125315	0	0
44361522	975125	0	0
45646125	1154029	0	0
45662236	1154343	0	0
45662012	1129625	0	0
45659146	1119510	0	0
45642000	1119510	0	0
45644672	975125	0	0
45636634	723013	0	0
45673616	1125315	0	0
45686578	1129625	0	0
45701996	19008572	2	3
45639708	1125315	0	0
45800208	1125315	0	0
45789444	1177480	0	0
45672948	1125315	0	0
46296466	975125	0	0
45897298	1125315	0	0
46239383	1125315	0	0
46289757	1125315	0	0
46300379	1112807	0	0
46305964	1322184	0	0
45896768	1521369	0	0
77358	4113008	3	3
4354249	4329847	1	1
4042142	4048171	5	5
21505690	1119510	0	0
21500540	19074679	2	2
36154383	1713332	0	0
36158860	1129625	0	0
37622515	192671	1	1
37102305	198199	4	6
44362971	1125315	0	0
44361296	1129625	0	0
45646128	1310149	0	0
45662243	1107830	0	0
45662222	1129625	0	0
45659083	1119510	0	0
45642014	1119510	0	0
45644710	975125	0	0
45636636	1192710	0	0
45673693	1125315	0	0
45686684	1129625	0	0
45701964	19008572	2	3
45639716	1125315	0	0
45800184	1125315	0	0
45789570	1177480	0	0
45672860	1125315	0	0
46292025	1501700	0	0
45897299	1125315	0	0
46239396	1125315	0	0
46289713	1125315	0	0
46300648	1112807	0	0
46305967	1112807	0	0
45896769	1177480	0	0
432661	40486433	3	3
4353741	4078793	1	1
4297090	4052083	2	2
21505690	1192710	0	0
21604685	40223774	4	4
36154441	1153428	0	0
36158865	975125	0	0
37219942	261325	1	1
37203764	28060	4	7
44362932	1125315	0	0
44361299	1115008	0	0
45645975	1192710	0	0
45662436	1738521	0	0
45662537	1129625	0	0
45659165	1119510	0	0
45641905	1119510	0	0
45644738	975125	0	0
45636523	715997	0	0
45673797	1125315	0	0
45686513	1129625	0	0
45698853	40228214	2	3
45640008	1125315	0	0
45799910	1125315	0	0
45786720	1177480	0	0
45672779	1125315	0	0
46292037	1551099	0	0
45897179	1125315	0	0
46239398	1125315	0	0
46289720	1125315	0	0
46300564	1112807	0	0
46305970	1367571	0	0
45896771	1000560	0	0
432661	4280726	3	3
4303684	42535580	1	1
4297090	4163951	2	2
21500462	926487	0	0
21601744	40171902	4	4
36154711	1000560	0	0
36158868	1149380	0	0
37219939	4280726	1	1
37203764	40481087	4	7
44363041	1125315	0	0
44361476	738818	0	0
45645977	708298	0	0
45662411	1549786	0	0
44341855	1129625	0	0
45659193	1119510	0	0
45641755	1119510	0	0
45641867	975125	0	0
45635923	1107830	0	0
45673676	1125315	0	0
45686472	1129625	0	0
45698480	19078924	2	3
45640097	1125315	0	0
45800095	1125315	0	0
45786666	1177480	0	0
45784497	1125315	0	0
46292109	1000560	0	0
45897416	1125315	0	0
46239474	1125315	0	0
46289680	1125315	0	0
46300829	1112807	0	0
46305972	1717327	0	0
45896772	1112807	0	0
4002367	4337611	3	3
4291025	80809	1	1
4297090	4195803	2	2
21500464	926487	0	0
35100000	4280726	4	4
36154472	1129625	0	0
36158964	1129625	0	0
37219939	257012	1	1
37102305	195588	4	7
44363042	1125315	0	0
44360975	1129625	0	0
45646076	1551099	0	0
45662411	1515774	0	0
44358058	1129625	0	0
45659194	1119510	0	0
45638795	1119510	0	0
45641749	975125	0	0
45635924	1174888	0	0
45673846	1125315	0	0
45683519	1129625	0	0
45698484	19125062	2	3
45639843	1125315	0	0
45800353	1125315	0	0
45786915	1177480	0	0
45784507	1125315	0	0
46292147	1501700	0	0
45897186	1125315	0	0
46239371	1125315	0	0
46289738	1125315	0	0
46300837	1112807	0	0
46305989	1500211	0	0
45896763	1713332	0	0
4003565	4057420	3	3
4293027	4293740	1	1
4297887	30753	2	2
21500438	914335	0	0
21601386	1305058	4	4
36154473	1129625	0	0
36158762	1112807	0	0
37220048	28060	1	1
37219945	4048171	4	8
44363126	1125315	0	0
44361639	1521369	0	0
45646196	975125	0	0
45662411	19127890	0	0
44358059	1129625	0	0
45659195	1119510	0	0
45638757	1119510	0	0
45642087	975125	0	0
45635930	1501700	0	0
45673848	1125315	0	0
45683446	1129625	0	0
45698681	19059056	2	3
45639817	1125315	0	0
45800357	1125315	0	0
45789086	1177480	0	0
45784509	1125315	0	0
46292312	1112807	0	0
45897306	1125315	0	0
46239433	1125315	0	0
46289774	1125315	0	0
46300752	1112807	0	0
46305848	967823	0	0
45896529	715997	0	0
4002404	40492359	3	3
4242997	4163971	1	1
4297887	4266809	2	2
21500424	914335	0	0
21602795	1729720	4	4
36154476	1129625	0	0
36158763	1112807	0	0
40789986	3000963	1	1
37219945	258780	4	8
44359229	1125315	0	0
44361639	1548195	0	0
45646149	1545958	0	0
45662541	1149196	0	0
44357761	1129625	0	0
44341974	1119510	0	0
45638762	1119510	0	0
45638938	975125	0	0
45635934	914335	0	0
45673877	1125315	0	0
45683452	1129625	0	0
45700526	40243436	2	3
45639727	1125315	0	0
45800326	1125315	0	0
45785269	1177480	0	0
45784585	1125315	0	0
46292319	738818	0	0
45897355	1125315	0	0
46239498	1125315	0	0
46289895	1125315	0	0
46301012	1112807	0	0
46306011	19127890	0	0
45896593	1307863	0	0
442628	4149245	3	3
4206587	4107731	1	1
4208786	4035415	2	2
21500478	1177480	0	0
21602795	1728416	4	4
36154477	933724	0	0
36158843	1107830	0	0
40790076	3014599	1	1
37203764	260139	4	8
44359239	1125315	0	0
44361340	1000560	0	0
44341052	1124300	0	0
45662150	1713332	0	0
44357871	1129625	0	0
44357596	1119510	0	0
45638898	1119510	0	0
45638951	975125	0	0
45636017	738818	0	0
45670764	1125315	0	0
45683454	1129625	0	0
45698972	1127433	2	3
45685869	1125315	0	0
45685684	1125315	0	0
45785493	1177480	0	0
45784529	1125315	0	0
46292324	1738521	0	0
45897424	1125315	0	0
46239485	1125315	0	0
46241665	1125315	0	0
46300762	1112807	0	0
46306011	1549786	0	0
45896656	1124957	0	0
442983	40486433	3	3
4295259	4117038	1	1
4324765	4149245	2	2
21500487	933724	0	0
21500263	1332418	4	4
36154481	967823	0	0
36158849	1112807	0	0
40790090	3006734	1	1
37203758	4280726	4	8
44359243	1125315	0	0
44361351	1192710	0	0
44341057	933724	0	0
45662150	1759842	0	0
44358096	1129625	0	0
44357717	1119510	0	0
45638809	1119510	0	0
45639056	975125	0	0
45636172	1154343	0	0
45670807	1125315	0	0
45683485	1129625	0	0
45699041	19019273	2	3
45685786	1125315	0	0
45685694	1125315	0	0
45783536	1177480	0	0
45784579	1125315	0	0
46292065	1545958	0	0
45897393	1125315	0	0
46239513	1125315	0	0
46241668	1125315	0	0
46319337	1112807	0	0
46306026	1112807	0	0
45896787	1149196	0	0
442983	4280726	3	3
4295112	4107731	1	1
4211641	4163872	2	2
21500497	975125	0	0
35402079	372328	4	4
36154482	975125	0	0
36158852	1177480	0	0
40786570	3007461	1	1
37203764	4048171	4	9
44362548	1125315	0	0
44361354	1149380	0	0
44341000	1153428	0	0
45662249	1149196	0	0
44358051	1129625	0	0
44357992	1119510	0	0
45635469	1119510	0	0
45635761	975125	0	0
45632983	1549786	0	0
45670843	1125315	0	0
45685497	1129625	0	0
45698963	1127433	2	3
45685829	1125315	0	0
45685301	1125315	0	0
45783357	1177480	0	0
45784800	1125315	0	0
46292069	975125	0	0
45897394	1125315	0	0
46239637	1125315	0	0
46241638	1125315	0	0
46319154	1112807	0	0
46306052	1343916	0	0
45896790	1112807	0	0
375239	378419	3	3
4297085	4010253	1	1
4271450	4112343	2	2
21500501	1548195	0	0
21500491	1548195	4	4
36154398	1545958	0	0
36158935	738818	0	0
40786848	3015076	1	1
37203764	258780	4	9
44362654	1125315	0	0
44360980	738818	0	0
44341003	933724	0	0
45662257	708298	0	0
44358132	1129625	0	0
44358075	1119510	0	0
45635627	1119510	0	0
45632754	975125	0	0
45632983	1589505	0	0
45670817	1125315	0	0
45680301	1129625	0	0
45695458	40223834	2	3
45685800	1125315	0	0
45685305	1125315	0	0
45783178	1177480	0	0
45784909	1125315	0	0
46292079	1112807	0	0
45897375	1125315	0	0
46239643	1125315	0	0
46241716	1125315	0	0
46239899	1112807	0	0
46305857	1551099	0	0
45896792	933724	0	0
444132	40479422	3	3
4287856	4059978	1	1
4271450	4294548	2	2
21500457	1000560	0	0
21500491	975125	4	4
36154486	723013	0	0
36158938	975125	0	0
40786854	3023430	1	1
37100000	45769019	4	7
44362621	1125315	0	0
44361308	1177480	0	0
44341006	1713332	0	0
45662262	975125	0	0
44354688	1129625	0	0
44358234	1119510	0	0
45635679	1119510	0	0
45632769	975125	0	0
45632658	1124300	0	0
45670792	1125315	0	0
45680179	1129625	0	0
45695644	1332419	2	3
45685820	1125315	0	0
45685257	1125315	0	0
46291054	1177480	0	0
45784596	1125315	0	0
46292098	1332418	0	0
45894914	1125315	0	0
46239559	1125315	0	0
46241617	1125315	0	0
46239852	1112807	0	0
46306346	1124957	0	0
45896530	1112807	0	0
444132	40479768	3	3
4344497	4310024	1	1
4309075	4058899	2	2
21500512	933724	0	0
35102039	4056621	4	4
36154383	1759842	0	0
36158953	1177480	0	0
40786881	3001247	1	1
36424211	1119510	0	0
44359396	1125315	0	0
44361309	975125	0	0
44341006	1759842	0	0
45659014	1115008	0	0
44354602	1129625	0	0
44358044	1119510	0	0
45637137	1119510	0	0
45631085	975125	0	0
45632912	967823	0	0
45670851	1125315	0	0
45680327	1129625	0	0
45695613	40232448	2	3
45685797	1125315	0	0
45685417	1125315	0	0
46290930	1177480	0	0
45784640	1125315	0	0
46292122	1326303	0	0
45894918	1125315	0	0
46239560	1125315	0	0
46241661	1125315	0	0
46322479	1112807	0	0
46306354	1521369	0	0
45896597	1119510	0	0
444211	4152936	3	3
21001028	19074679	1	1
4208699	4012477	2	2
21500523	791967	0	0
35302568	378419	4	4
36154384	1115008	0	0
36158977	1107830	0	0
40786887	3027231	1	1
37521562	4059978	0	0
44359397	1125315	0	0
44361483	1149380	0	0
44341059	1589505	0	0
45658830	738818	0	0
44354740	1129625	0	0
44358112	1119510	0	0
45632445	1153428	0	0
45629680	975125	0	0
45633007	708298	0	0
45670801	1125315	0	0
45680243	1129625	0	0
45695619	1332419	2	3
45685838	1125315	0	0
45685378	1125315	0	0
46291369	1177480	0	0
45784665	1125315	0	0
46292123	1192710	0	0
45894988	1125315	0	0
46239561	1125315	0	0
46241559	1125315	0	0
46316225	1112807	0	0
46306354	1549786	0	0
45896639	1119510	0	0
195002	81893	3	3
4244662	4035415	3	3
19125488	19128263	2	2
21500516	967823	0	0
21503764	1125315	4	4
36154443	1129625	0	0
36158827	1115008	0	0
40787003	3013721	1	1
37521571	4275113	0	0
44359458	1125315	0	0
44361498	1000560	0	0
44341059	1549786	0	0
45658831	1124300	0	0
44354996	1129625	0	0
44358269	1119510	0	0
45632719	967823	0	0
45629656	975125	0	0
45632949	1396131	0	0
45670953	1125315	0	0
45680391	1129625	0	0
45695758	19075001	2	3
45685941	1125315	0	0
45685381	1125315	0	0
46242718	1177480	0	0
45784829	1125315	0	0
46292081	1557272	0	0
45894953	1125315	0	0
46239325	1125315	0	0
46241618	1125315	0	0
46316239	1112807	0	0
46306459	1124300	0	0
45894903	1129625	0	0
375415	4001336	3	3
4244662	80809	3	3
19125488	19128022	2	2
21011856	1759842	0	0
21503764	738818	4	4
36154630	914335	0	0
36158967	1551099	0	0
40770371	3013682	1	1
37521571	4238715	0	0
44359375	1125315	0	0
44361130	1112807	0	0
44341059	19127890	0	0
45659150	975125	0	0
44351191	1129625	0	0
44358293	1119510	0	0
45632723	1124300	0	0
45629625	975125	0	0
45633036	1115008	0	0
45670744	1125315	0	0
45680469	1129625	0	0
45695849	19078924	2	3
45686034	1125315	0	0
45685383	1125315	0	0
46242839	1177480	0	0
45784727	1125315	0	0
46292369	1192710	0	0
45895038	1125315	0	0
46239328	1125315	0	0
46241623	1125315	0	0
46310943	1112807	0	0
46322440	975125	0	0
45894954	715997	0	0
134057	321042	3	3
4244662	80502	3	3
19127891	40221415	2	2
21011856	1717327	0	0
21503764	1119510	4	4
36154387	1177480	0	0
36158968	1107830	0	0
40770372	3016723	1	1
37521572	4238715	0	0
44359451	1125315	0	0
44361644	1308738	0	0
44341253	933724	0	0
45659261	1500211	0	0
44351026	1129625	0	0
44358298	1119510	0	0
45629214	1115008	0	0
45626953	975125	0	0
45632996	1124957	0	0
45670880	1125315	0	0
45680612	1129625	0	0
45695678	40162522	2	3
45685613	1125315	0	0
45799942	1125315	0	0
46243032	1177480	0	0
45784729	1125315	0	0
46292371	1501700	0	0
45895042	1125315	0	0
46239337	1125315	0	0
46241699	1125315	0	0
46311201	1112807	0	0
46322444	975125	0	0
45803787	1307863	0	0
4000731	4337138	3	3
4300244	4337611	3	3
19127891	19127918	2	2
21011482	19010482	0	0
21503764	1129625	4	4
36154506	914335	0	0
36158986	1129625	0	0
40758558	3007461	1	1
40481087	40481087	0	0
44359454	1125315	0	0
44361646	975125	0	0
44341197	1149380	0	0
45659078	1174888	0	0
44350967	1129625	0	0
44354644	1119510	0	0
45629291	1153428	0	0
45628022	975125	0	0
45632998	791967	0	0
45670973	1125315	0	0
45680625	1129625	0	0
45694393	1713671	2	3
45685619	1125315	0	0
45799949	1125315	0	0
46242734	1177480	0	0
45784772	1125315	0	0
46292382	1102527	0	0
45895014	1125315	0	0
46239580	1125315	0	0
46241703	1125315	0	0
46322616	1112807	0	0
46322453	1551099	0	0
45803593	1307863	0	0
376337	4029498	3	3
4266188	4142905	3	3
4311387	45769019	2	2
21008466	1124300	0	0
21503764	1192710	4	4
36154836	1332418	0	0
36158677	1192710	0	0
40758558	3009542	1	1
37521035	4198190	0	0
42801354	1125315	0	0
44361648	1322184	0	0
44341405	1110410	0	0
45658878	1713332	0	0
44352257	1129625	0	0
44354648	1119510	0	0
45629292	1124957	0	0
45627067	975125	0	0
45633968	1545958	0	0
45671058	1125315	0	0
45680689	1129625	0	0
45692427	40229134	2	3
45637361	1125315	0	0
45800006	1125315	0	0
46242802	1177480	0	0
45784929	1125315	0	0
46292135	1112807	0	0
45895188	1125315	0	0
46239581	1125315	0	0
46241706	1125315	0	0
46316529	1112807	0	0
46322392	1307863	0	0
45803624	1119510	0	0
376106	380378	3	3
4241075	4197460	3	3
4248028	313217	2	2
21008595	1539403	0	0
21505615	46275916	4	5
36154710	1149196	0	0
36159084	1129625	0	0
40758558	3024731	1	1
37017711	37017711	0	0
42801354	1174888	0	0
44357442	1129625	0	0
44341071	1124300	0	0
45658970	1717327	0	0
44351879	1129625	0	0
44354767	1119510	0	0
45629303	1174888	0	0
45623726	975125	0	0
45633980	1308738	0	0
45670981	1125315	0	0
45677133	1129625	0	0
45692431	40229134	2	3
45637423	1125315	0	0
45799963	1125315	0	0
46240572	1177480	0	0
45784755	1125315	0	0
46292257	705944	0	0
45895190	1125315	0	0
46239677	1125315	0	0
46241641	1125315	0	0
46318008	1112807	0	0
46322460	967823	0	0
45803625	1119510	0	0
376208	381316	3	3
4241075	4295880	3	3
4248097	443279	2	2
21008593	1539403	0	0
21505697	40236446	4	5
36154837	1343916	0	0
36159089	1548195	0	0
40758558	3010813	1	1
40486433	40486433	0	0
42801439	19127890	0	0
44357426	705944	0	0
44341035	738818	0	0
45659083	738818	0	0
44351811	1129625	0	0
44354772	1119510	0	0
45629377	1115008	0	0
45624050	975125	0	0
45634062	1124957	0	0
45670984	1125315	0	0
45679285	1129625	0	0
45692403	1107882	2	3
45637426	1125315	0	0
45799965	1125315	0	0
46240545	1177480	0	0
45784766	1125315	0	0
46292333	1112807	0	0
45894972	1125315	0	0
46239679	1125315	0	0
46241646	1125315	0	0
46316794	1112807	0	0
46322673	1124957	0	0
45803625	738818	0	0
4000738	4323902	3	3
4243478	4336464	3	3
4231941	40479422	2	2
21008595	1332418	0	0
21500098	19007333	4	5
36154838	19127890	0	0
36158776	1192710	0	0
40758558	3026361	1	1
40223821	40223821	0	0
42801439	1515774	0	0
44357427	791967	0	0
44341140	1545958	0	0
45659091	1192710	0	0
44352368	1129625	0	0
44354723	1119510	0	0
45629442	1326303	0	0
45623801	975125	0	0
45634027	1713332	0	0
45670986	1125315	0	0
45679679	1129625	0	0
45692728	42707627	2	3
45637299	1125315	0	0
45799970	1125315	0	0
46240618	1177480	0	0
45784993	1125315	0	0
46292285	1713332	0	0
45895043	1125315	0	0
46239588	1125315	0	0
46241723	1125315	0	0
46316932	1112807	0	0
46322676	1154343	0	0
45803628	914335	0	0
4000738	4330583	3	3
4306073	4337138	3	3
4231941	40479768	2	2
21008593	1545958	0	0
21500437	40243436	4	5
36154838	1521369	0	0
36158901	1129625	0	0
40758558	3000963	1	1
40223834	40223834	0	0
42801439	1549786	0	0
44357433	933724	0	0
44341148	1115008	0	0
45659110	1539403	0	0
44351252	1129625	0	0
44354623	1119510	0	0
45629169	1174888	0	0
45623885	975125	0	0
45634027	1759842	0	0
45669393	1125315	0	0
45677235	1129625	0	0
45692463	1107882	2	3
45636751	1125315	0	0
45800040	1125315	0	0
46240791	1177480	0	0
45784998	1125315	0	0
46292337	1124300	0	0
45895015	1125315	0	0
46239652	1125315	0	0
46241725	1125315	0	0
46317047	1112807	0	0
46322516	1738521	0	0
45803730	1000560	0	0
4000738	4242997	3	3
4329725	4337611	3	3
21505897	1125315	2	2
21008593	1332418	0	0
21505608	19126352	4	5
36154838	1549786	0	0
36158684	1177480	0	0
40757363	3023103	1	1
40223771	40223774	0	0
42801426	1738521	0	0
44357409	1332418	0	0
45643344	715997	0	0
45658736	1539403	0	0
44351288	1129625	0	0
44354993	1119510	0	0
45629450	1000560	0	0
45668037	975125	0	0
45634130	914335	0	0
45669369	1125315	0	0
45677279	1129625	0	0
45692501	19018935	2	3
45636855	1125315	0	0
45799720	1125315	0	0
46240722	1177480	0	0
45785002	1125315	0	0
46292342	1174888	0	0
45895030	1125315	0	0
46239658	1125315	0	0
46241735	1125315	0	0
46306371	1112807	0	0
46316954	1307863	0	0
45803818	1107830	0	0
376208	4149245	3	4
4329725	4323902	3	3
21500562	836654	2	2
21008820	1738521	0	0
21500270	19059056	4	5
36154724	1000560	0	0
36158903	1129625	0	0
40757363	3013721	1	1
40223774	40223774	0	0
42801344	1332418	0	0
44357384	1149196	0	0
45643100	1500211	0	0
45658978	1107830	0	0
44347504	1129625	0	0
44350811	1119510	0	0
45629310	1322184	0	0
45667994	975125	0	0
45633991	705944	0	0
45669554	1125315	0	0
45674099	1129625	0	0
45692613	1154615	2	3
45636782	1125315	0	0
45799687	1125315	0	0
45681014	1174888	0	0
45784647	1125315	0	0
46292344	1124300	0	0
45895109	1125315	0	0
46239722	1125315	0	0
46241739	1125315	0	0
46306372	1112807	0	0
46317102	1118084	0	0
45803820	1129625	0	0
134057	4329847	3	4
4252534	4116491	3	3
21500562	701322	2	2
21008595	1545958	0	0
21500259	46275916	4	5
36154549	1124300	0	0
36158804	1129625	0	0
40757363	3024561	1	1
40222846	40222846	0	0
42801387	1107830	0	0
44357482	1124957	0	0
45643300	1759842	0	0
45659120	1332418	0	0
44347430	1129625	0	0
44351194	1119510	0	0
45629454	1501700	0	0
45670243	975125	0	0
45634008	1192710	0	0
45669433	1125315	0	0
45673934	1129625	0	0
45692591	19019273	2	3
45636831	1125315	0	0
45797344	1125315	0	0
45681016	1548195	0	0
45782652	1125315	0	0
46292356	1107830	0	0
45895126	1125315	0	0
46239753	1125315	0	0
46241740	1125315	0	0
46306428	1112807	0	0
46317103	1545958	0	0
45803821	738818	0	0
376337	381316	3	4
4207186	40481087	3	3
21001487	19129655	2	3
21010168	1305058	0	0
21503963	19059056	4	5
36154645	1153428	0	0
36158812	1545958	0	0
40757363	3014576	1	1
40224132	40224132	0	0
42801388	1332418	0	0
44357483	1149380	0	0
45643300	1713332	0	0
45658979	1124957	0	0
44347402	1129625	0	0
44350873	1119510	0	0
45629459	1551099	0	0
45665829	975125	0	0
45647429	19127904	3	4
45669436	1125315	0	0
45674263	1129625	0	0
45692672	19112599	2	3
45636765	1125315	0	0
45797350	1125315	0	0
45681165	1713332	0	0
45782402	1125315	0	0
46292216	1192710	0	0
45895069	1125315	0	0
46239712	1125315	0	0
46241682	1125315	0	0
46306243	1112807	0	0
46317120	1551099	0	0
45803821	1119510	0	0
376337	4066995	3	4
4295343	4168004	3	3
21001488	19129655	2	3
21011074	1367571	0	0
21600490	35605482	4	6
36154652	1129625	0	0
36159012	1367571	0	0
40757363	3013682	1	1
40783186	3020630	3	3
42801389	1551099	0	0
44357447	1738521	0	0
45643065	1149196	0	0
45658981	1192710	0	0
44347383	1129625	0	0
44350875	1119510	0	0
45629602	1545958	0	0
45665885	975125	0	0
45644636	19127918	3	4
45669635	1125315	0	0
45673635	1129625	0	0
45692681	1127433	2	3
45636835	1125315	0	0
45797352	1125315	0	0
45681009	1115008	0	0
45782403	1125315	0	0
46292223	1192710	0	0
45895072	1125315	0	0
46239695	1125315	0	0
46241683	1125315	0	0
46306758	1112807	0	0
46317132	1539403	0	0
45803619	1000560	0	0
4002905	81893	3	4
4303802	4240902	3	3
21001486	19129655	2	3
21009299	1738521	0	0
21601237	1539411	4	7
36154654	1129625	0	0
36158785	1521369	0	0
40757363	3004501	1	1
40783186	3016723	3	3
42801392	1124300	0	0
44357518	1149196	0	0
45643352	1149196	0	0
45658982	975125	0	0
44347561	1129625	0	0
44351817	1119510	0	0
45629603	914335	0	0
45666205	975125	0	0
45651017	19128065	3	4
45669539	1125315	0	0
45673717	1129625	0	0
45692682	19076374	2	3
45636961	1125315	0	0
45797339	1125315	0	0
45681165	1759842	0	0
45782408	1125315	0	0
46292235	1112807	0	0
45895214	1125315	0	0
46239733	1125315	0	0
46241750	1125315	0	0
45895616	1177480	0	0
46317273	1557272	0	0
45803793	1177480	0	0
321588	313217	3	4
4303802	433644	3	3
21001762	1551192	2	3
21010499	1307863	0	0
21601237	1332419	4	7
36154728	1129625	0	0
36158787	1129625	0	0
40757363	3006906	1	1
40782937	3006451	3	3
42801396	1551099	0	0
44357571	701322	0	0
45643070	920293	0	0
45659165	1192710	0	0
45647175	1343916	0	0
44352370	1119510	0	0
45629546	1589505	0	0
45666180	975125	0	0
45648172	40221415	3	4
45669521	1125315	0	0
45674349	1129625	0	0
45692844	40223768	2	3
45636968	1125315	0	0
45797393	1125315	0	0
45681011	1110410	0	0
45782662	1125315	0	0
46292239	1149196	0	0
45895143	1125315	0	0
46239736	1125315	0	0
46241708	1125315	0	0
45895637	1177480	0	0
46316985	715997	0	0
45803796	1322184	0	0
135930	4035415	3	4
4303802	37017711	3	3
21001163	1551192	2	3
21010583	1595799	0	0
21600493	35605482	1	3
36154729	1557272	0	0
36158993	1521369	0	0
40757363	3016723	1	1
40785816	3026361	3	3
42801498	967823	0	0
44357493	1149380	0	0
45643310	1107830	0	0
45659193	738818	0	0
45646993	738818	0	0
44351257	1119510	0	0
45629546	1549786	0	0
45663644	975125	0	0
45639313	19127922	3	4
45669604	1125315	0	0
45673927	1129625	0	0
45692803	19126352	2	3
45636971	1125315	0	0
45682355	1125315	0	0
45680892	1124957	0	0
45782350	1125315	0	0
46292477	738818	0	0
45895218	1125315	0	0
45895935	1125315	0	0
46241696	1125315	0	0
45895602	1177480	0	0
46317141	933724	0	0
45803895	1149196	0	0
372887	378419	3	4
4303802	4219399	3	3
19039298	19023398	2	3
21002098	1551099	0	0
21601240	19018935	1	4
36154730	1107830	0	0
36158993	1549786	0	0
40757363	3035995	1	1
40785816	3010813	3	3
42801405	920293	0	0
44357494	1729720	0	0
45643264	1396131	0	0
45659195	1192710	0	0
45647087	738818	0	0
44351288	1119510	0	0
45629563	1000560	0	0
45663668	975125	0	0
45695285	19128009	2	2
45669480	1125315	0	0
45671127	1129625	0	0
45691516	19008572	2	3
45636869	1125315	0	0
45682418	1125315	0	0
45680896	1000560	0	0
45782513	1125315	0	0
46292244	1738521	0	0
45895221	1125315	0	0
45896157	1125315	0	0
46241713	1125315	0	0
45895627	1177480	0	0
46317144	1124957	0	0
45803683	1119510	0	0
255919	4218389	3	4
4207184	4294548	3	3
21505843	19059056	2	3
21002247	1551099	0	0
21500367	1154615	1	2
36154731	1192710	0	0
36159109	1149196	0	0
40757363	3020630	1	1
37503996	4202451	3	3
42806550	1539403	0	0
44357549	738818	0	0
45643071	1332418	0	0
45659283	933724	0	0
45647095	914335	0	0
44347310	1119510	0	0
45629566	708298	0	0
45663435	975125	0	0
45695285	19127918	2	2
45669486	1125315	0	0
45671362	1129625	0	0
45691722	19077572	2	3
45637004	1125315	0	0
45682515	1125315	0	0
45680897	967823	0	0
45782638	1125315	0	0
46292404	1396131	0	0
45895222	1125315	0	0
45896166	1125315	0	0
46241765	1125315	0	0
45895652	1177480	0	0
46317435	1112807	0	0
45803685	967823	0	0
1549786	19127904	3	4
4304916	4266809	3	4
21505816	40229134	2	3
21002238	1551099	0	0
21500260	1343916	1	1
36154734	1192710	0	0
36159114	738818	0	0
40757363	3019550	1	1
40783188	3000963	3	3
42806459	1149380	0	0
44357486	1192710	0	0
45643345	967823	0	0
45659298	701322	0	0
45647219	1367571	0	0
44347485	1119510	0	0
45629131	1107830	0	0
45663867	975125	0	0
45680376	19127918	2	2
45669697	1125315	0	0
45671367	1129625	0	0
45691742	1115171	2	3
45636872	1125315	0	0
45682506	1125315	0	0
45680925	1501700	0	0
45783593	1125315	0	0
46292469	1000560	0	0
45895165	1125315	0	0
45895884	1125315	0	0
46242515	1125315	0	0
45802381	1177480	0	0
46317438	920293	0	0
45803688	1322184	0	0
1549786	19128263	3	4
4302537	192671	3	4
4322976	4191853	2	3
21002151	1717327	0	0
21503530	1322184	1	1
36154842	1549786	0	0
36159115	1521369	0	0
40757364	3004501	1	1
40783188	3020630	3	3
42806327	975125	0	0
44357575	708298	0	0
45643073	1107830	0	0
45659313	975125	0	0
45647223	1309944	0	0
44347741	1119510	0	0
45629233	1174888	0	0
45663914	975125	0	0
45680376	19128009	2	2
45669630	1125315	0	0
45671368	1129625	0	0
45691435	43012433	2	3
45682789	1125315	0	0
45794889	1125315	0	0
45680927	1112807	0	0
45783586	1125315	0	0
46292437	933724	0	0
45895239	1125315	0	0
45896054	1125315	0	0
46242601	1125315	0	0
45801957	1177480	0	0
46317150	715997	0	0
45803594	1119510	0	0
1549786	19128009	3	4
4296373	4336464	3	4
21011857	1713671	2	3
21002151	1741122	0	0
21503530	1112807	1	1
36154657	1129625	0	0
36158923	1177480	0	0
40757364	3013721	1	1
40783188	3004501	3	3
42806463	1149380	0	0
44357490	1545958	0	0
45643075	975125	0	0
45659255	967823	0	0
45647008	1149196	0	0
44347657	1119510	0	0
45629470	1124957	0	0
45660242	975125	0	0
45698865	19128009	2	2
45669500	1125315	0	0
45671504	1129625	0	0
45691663	1115171	2	3
45682794	1125315	0	0
45794833	1125315	0	0
45680933	1112807	0	0
45783561	1125315	0	0
46292438	1589505	0	0
45895333	1125315	0	0
45896134	1125315	0	0
46242602	1125315	0	0
45801972	1177480	0	0
46311341	975125	0	0
45803595	715997	0	0
1549786	19128022	3	4
4206591	4285898	3	4
21000216	46233710	2	3
21002152	1741122	0	0
21503884	708298	1	1
36154743	1118084	0	0
36159096	1738521	0	0
40757364	3024561	1	1
40783188	3028833	3	3
42806471	1115008	0	0
44357502	738818	0	0
45643383	1738521	0	0
44341857	723013	0	0
45645890	1713332	0	0
44347529	1119510	0	0
45629471	1539403	0	0
45660526	975125	0	0
45676997	19128009	2	2
45669600	1125315	0	0
45671509	1129625	0	0
45689697	40232448	2	3
45682688	1125315	0	0
45794820	1125315	0	0
45680915	1332418	0	0
45782749	1125315	0	0
46292390	701322	0	0
45895337	1125315	0	0
45896136	1125315	0	0
46242575	1125315	0	0
45802061	1177480	0	0
46310828	1713332	0	0
45803552	1119510	0	0
1549786	19127918	3	4
4244662	4146173	3	5
21000216	46233988	2	3
21002222	1759842	0	0
21503765	1192710	1	1
36154745	1192710	0	0
36158796	1129625	0	0
40757364	3013682	1	1
40786225	3035995	3	3
42806556	975125	0	0
44357453	1177480	0	0
45643393	1738521	0	0
44341974	738818	0	0
45646143	1154343	0	0
44347545	1119510	0	0
45629560	933724	0	0
45657462	975125	0	0
45676997	19127918	2	2
45669772	1125315	0	0
45671440	1129625	0	0
45689703	40231925	2	3
45682771	1125315	0	0
45794821	1125315	0	0
45680989	757627	0	0
45782727	1125315	0	0
46292694	1124300	0	0
45895300	1125315	0	0
45896137	1125315	0	0
46242612	1125315	0	0
45799312	1177480	0	0
46310829	19127890	0	0
45803862	1124300	0	0
1549786	42902245	3	4
4244662	4066995	3	6
21500546	40232448	2	3
21002222	1713332	0	0
21503765	1125315	1	1
36154748	1192710	0	0
36159115	1549786	0	0
40757364	3023103	1	1
40786225	3006923	3	3
42806474	1713332	0	0
44357562	1129625	0	0
45643594	1154343	0	0
44357954	1332418	0	0
45645894	1174888	0	0
44347623	1119510	0	0
45629505	933724	0	0
45657468	975125	0	0
45689373	19128009	2	2
45780646	1125315	0	0
45669801	1129625	0	0
45689708	40229134	2	3
45682773	1125315	0	0
45794879	1125315	0	0
45681054	1115008	0	0
45782851	1125315	0	0
46293077	1000560	0	0
45894474	1125315	0	0
45896031	1125315	0	0
46242613	1125315	0	0
45799501	1177480	0	0
46310829	1549786	0	0
45803829	1118084	0	0
1344056	46275916	1	1
4244662	4048695	3	6
21001557	46275916	2	3
21002138	1741122	0	0
21503884	753626	1	1
36154532	914335	0	0
36159247	1322184	0	0
40757364	3019550	1	1
37018424	4296204	3	3
42806558	715997	0	0
44357563	1124300	0	0
45643236	738818	0	0
44357893	1361711	0	0
45645856	1361711	0	0
44347625	1119510	0	0
45629572	1115008	0	0
45658393	975125	0	0
45633070	40229134	2	3
45780787	1125315	0	0
45669727	1129625	0	0
45689680	19018935	2	3
45682709	1125315	0	0
45794913	1125315	0	0
45680995	1713332	0	0
45782855	1125315	0	0
46275916	46275916	0	0
45894477	1125315	0	0
45896040	1125315	0	0
46242615	1125315	0	0
45799529	1177480	0	0
46310970	933724	0	0
45803556	1129625	0	0
1344056	1594382	1	1
4244662	78272	3	8
21000289	46233710	2	3
21002113	1713332	0	0
21494873	3051031	1	1
36155000	1551099	0	0
36158800	1551099	0	0
40757364	3020630	1	1
40481384	42535580	3	3
42806223	1713332	0	0
44357564	1778162	0	0
45643357	920293	0	0
44357905	1549786	0	0
45645862	1107830	0	0
44347215	1119510	0	0
45629361	740275	0	0
45657842	975125	0	0
45633130	40232448	2	3
45780816	1125315	0	0
45669824	1129625	0	0
45689876	19133768	2	3
45682977	1125315	0	0
45794918	1125315	0	0
45680997	1501700	0	0
45782771	1125315	0	0
46275919	46275916	0	0
45894407	1125315	0	0
45895997	1125315	0	0
46242567	1125315	0	0
45799483	1177480	0	0
46310971	715997	0	0
45803602	1174888	0	0
1768881	19074843	1	1
4274025	255848	5	8
21011858	1713671	2	3
21002113	1759842	0	0
21494880	3051031	1	1
36155010	1713332	0	0
36158819	1153428	0	0
40757364	3006906	1	1
40785842	3007461	3	3
42806332	1551099	0	0
44357678	1129625	0	0
45643359	1124957	0	0
44358057	1118084	0	0
45645864	1124300	0	0
44347782	1119510	0	0
45629366	1000560	0	0
45657963	975125	0	0
45633173	19019273	2	3
45780824	1125315	0	0
45670504	1129625	0	0
45689876	40162522	2	3
45682826	1125315	0	0
45794959	1125315	0	0
45681000	920293	0	0
45782775	1125315	0	0
46287943	1549786	0	0
45894414	1125315	0	0
45896143	1125315	0	0
46241847	1125315	0	0
45796707	1177480	0	0
46311639	975125	0	0
45803720	1112807	0	0
1551099	19089061	1	1
4274025	4132546	5	8
21001565	40243436	2	3
21002113	1741122	0	0
21492982	3051031	1	1
36155014	1551099	0	0
36158821	1115008	0	0
40757364	3006923	1	1
40785842	3010813	3	3
42806223	1759842	0	0
44357505	1124300	0	0
45643526	1153428	0	0
44357760	738818	0	0
45646137	1149196	0	0
44343351	1119510	0	0
45629474	1174888	0	0
45654111	975125	0	0
45633230	40232448	2	3
45780832	1125315	0	0
45781093	1129625	0	0
45689853	1115171	2	3
45682890	1125315	0	0
45794942	1125315	0	0
45681003	1112807	0	0
45782863	1125315	0	0
46287943	1521369	0	0
45894536	1125315	0	0
45896199	1125315	0	0
46241864	1125315	0	0
45796845	1177480	0	0
46311784	1729720	0	0
45803724	914335	0	0
1778228	19075001	1	1
4201745	4285898	5	8
21001565	46275916	2	3
21002113	1717327	0	0
21490759	3006322	1	1
36154752	1192710	0	0
36158822	1551099	0	0
40757364	3035995	1	1
40786227	3006906	3	3
42806482	967823	0	0
44357687	1545958	0	0
45643527	1154029	0	0
44357793	1115008	0	0
45643848	1308738	0	0
44343552	1119510	0	0
45629475	738818	0	0
45654112	975125	0	0
45676454	1551192	2	3
45780914	1125315	0	0
45781244	1129625	0	0
45686556	46275444	2	3
45633682	1125315	0	0
45679135	1125315	0	0
45681118	1112807	0	0
45780758	1125315	0	0
46287949	1738521	0	0
45894597	1125315	0	0
45896153	1125315	0	0
46241838	1125315	0	0
45797055	1177480	0	0
46311785	933724	0	0
45803804	1326303	0	0
381591	381316	1	1
4244662	4134304	5	8
21000083	19073183	2	3
21002102	1717327	0	0
21490760	3009542	1	1
36154564	1129625	0	0
36158826	1545958	0	0
40757364	3016723	1	1
37604032	4324181	3	3
42806487	1000560	0	0
44357584	1521369	0	0
45643530	738818	0	0
44357765	1310149	0	0
45643860	1174888	0	0
44343553	1119510	0	0
45629486	1137529	0	0
45654368	975125	0	0
45676462	1332419	2	3
45783372	1125315	0	0
45781248	1129625	0	0
45686853	1551192	2	3
45633465	1125315	0	0
45679382	1125315	0	0
45681039	1367571	0	0
45780777	1125315	0	0
46287875	975125	0	0
45894600	1125315	0	0
45896824	1125315	0	0
46241889	1125315	0	0
45794141	1177480	0	0
46311246	1000560	0	0
45803805	1192710	0	0
372887	4029498	1	1
4302537	4166224	5	8
21000268	46233988	2	3
21002102	1738521	0	0
21490760	3014576	1	1
36110253	28060	0	0
36158998	1713332	0	0
40761511	3000963	1	1
40792670	3023103	3	3
42806593	1153428	0	0
44357584	1549786	0	0
45643533	1174888	0	0
44357769	1501700	0	0
45643888	1124300	0	0
44343724	1119510	0	0
45629490	967823	0	0
45654371	975125	0	0
45676637	19008572	2	3
45783389	1125315	0	0
45781472	1129625	0	0
45686731	40232448	2	3
45633756	1125315	0	0
45679388	1125315	0	0
45681168	1307863	0	0
45780895	1125315	0	0
46287882	738818	0	0
45894391	1125315	0	0
45896649	1125315	0	0
46241806	1125315	0	0
45794239	1177480	0	0
46311253	1589505	0	0
45803806	914335	0	0
444208	257012	1	1
4302537	440448	5	8
21000268	46233710	2	3
21002113	1746114	0	0
21490760	3006906	1	1
36152376	1149196	0	0
36159003	738818	0	0
40761547	3016723	1	1
40792670	3045716	3	3
42806225	705944	0	0
44357584	19127890	0	0
45643534	1551099	0	0
44357907	1332418	0	0
45643921	1110410	0	0
44344038	1119510	0	0
45629412	1310149	0	0
45650892	975125	0	0
45676638	19075601	2	3
45783294	1125315	0	0
45781483	1129625	0	0
45687015	40229134	2	3
45633757	1125315	0	0
45679254	1125315	0	0
45680946	1557272	0	0
45780262	1125315	0	0
46287911	1738521	0	0
45894580	1125315	0	0
45896839	1125315	0	0
46241810	1125315	0	0
45794761	1177480	0	0
46311645	1738521	0	0
45803603	1124957	0	0
373087	4066995	1	1
4302537	81893	5	10
21000218	46233988	2	3
21002122	1741122	0	0
21494954	21494966	1	1
36152382	1129625	0	0
36158913	1124300	0	0
40485073	40479768	1	1
40792670	3019550	3	3
42806227	1154343	0	0
44357702	738818	0	0
45643464	1149196	0	0
44357909	1192710	0	0
45643930	1738521	0	0
44344049	1119510	0	0
45629417	1154343	0	0
45648064	975125	0	0
45676767	920334	2	3
45783296	1125315	0	0
45781590	1129625	0	0
45686896	1127433	2	3
45633761	1125315	0	0
45679445	1125315	0	0
45680952	1717327	0	0
45780266	1125315	0	0
46287913	975125	0	0
45894581	1125315	0	0
45896807	1125315	0	0
46241811	1125315	0	0
45794770	1177480	0	0
46311577	1149196	0	0
45803866	738818	0	0
4000610	192671	1	1
4274025	380378	5	7
21001483	19129655	2	3
21002122	1717327	0	0
21491255	3007461	1	1
36152419	1551099	0	0
36159024	1149196	0	0
40485074	40479422	1	1
37019385	195588	3	3
42806638	1307863	0	0
44357703	738818	0	0
45643536	1192710	0	0
44357910	738818	0	0
45643966	1551099	0	0
44344095	1119510	0	0
45629418	1501700	0	0
45645199	975125	0	0
45676927	19008572	2	3
45780969	1125315	0	0
45781594	1129625	0	0
45686813	43012036	2	3
45633762	1125315	0	0
45679648	1125315	0	0
45680954	1738521	0	0
45780328	1125315	0	0
46287927	791967	0	0
45803100	1125315	0	0
45804357	1125315	0	0
46241817	1125315	0	0
45794707	1177480	0	0
46311576	1118084	0	0
45803866	1119510	0	0
4000609	4027663	1	1
4274025	4035415	5	7
21001555	1310034	2	3
21002123	1759842	0	0
21491255	3013721	1	1
36152316	1153428	0	0
36159025	1129625	0	0
40223765	45892894	1	1
40482705	4198190	3	3
42806406	1115008	0	0
44357704	1177480	0	0
45643537	1548195	0	0
44357990	1115008	0	0
45643969	1174888	0	0
44340083	1119510	0	0
45629608	967823	0	0
45642101	975125	0	0
45676958	40229134	2	3
45781032	1125315	0	0
45779225	1129625	0	0
45685609	40236446	2	3
45633821	1125315	0	0
45679121	1125315	0	0
45680955	920293	0	0
45780224	1125315	0	0
46288077	1332418	0	0
46288783	1361711	0	0
45804301	1125315	0	0
46241824	1125315	0	0
45794830	1177480	0	0
46310977	1539403	0	0
45803867	19127890	0	0
4000735	4295880	1	1
4297090	4058899	5	7
21001630	1539411	2	3
21002155	1741122	0	0
21491255	3006923	1	1
36152177	1308738	0	0
36159144	1149380	0	0
40223765	40223768	1	1
40482662	81151	3	3
42806412	1332418	0	0
44357714	1343916	0	0
45640278	1149380	0	0
44357992	738818	0	0
45643971	1738521	0	0
44340439	1119510	0	0
45631270	1545958	0	0
45642258	975125	0	0
45676961	40163554	2	3
45781045	1125315	0	0
45779181	1129625	0	0
45683568	19078924	2	3
45633742	1125315	0	0
45679280	1125315	0	0
45680956	1717327	0	0
45780302	1125315	0	0
46288086	1713332	0	0
46288566	1332418	0	0
45804369	1125315	0	0
46241792	1125315	0	0
45794277	1177480	0	0
46311527	1149380	0	0
45803867	1515774	0	0
4000882	4323902	1	1
4247371	40486433	5	7
21000148	46233710	2	3
21002122	1759842	0	0
21502626	1728416	1	1
36152179	738818	0	0
36159148	1129625	0	0
40224804	40224805	1	1
37203772	260139	3	3
42806595	1177480	0	0
44357529	738818	0	0
45640280	975125	0	0
44357960	1713332	0	0
45643946	738818	0	0
44340387	1119510	0	0
45630933	1153428	0	0
45639269	975125	0	0
45676512	19008572	2	3
45781051	1125315	0	0
45778914	1129625	0	0
45683710	19077572	2	3
45633795	1125315	0	0
45679449	1125315	0	0
45681264	723013	0	0
45780306	1125315	0	0
46288127	1332418	0	0
46288684	1174888	0	0
45804343	1125315	0	0
45897977	1125315	0	0
45794281	1177480	0	0
46311663	967823	0	0
45803867	1549786	0	0
4001336	375671	1	1
4247371	4280726	5	7
21001070	40232448	2	3
21002122	1746114	0	0
21500354	1119510	1	1
36152183	1322184	0	0
36158926	1107830	0	0
40224808	40224132	1	1
37203772	40486433	3	3
42806648	1149196	0	0
44357512	1129625	0	0
45642992	1501700	0	0
44357960	1759842	0	0
45643949	933724	0	0
44340466	1119510	0	0
45631108	1124300	0	0
45635778	975125	0	0
45673493	1551192	2	3
45781103	1125315	0	0
45779165	1129625	0	0
45683747	40229134	2	3
45633904	1125315	0	0
45792049	1125315	0	0
45681132	1149196	0	0
45780307	1125315	0	0
46287987	738818	0	0
46288567	1310149	0	0
45804380	1125315	0	0
45897978	1125315	0	0
45791684	1177480	0	0
46311738	1153428	0	0
45803768	1154029	0	0
4001336	378001	1	1
4322976	4293740	5	7
21001554	1310034	2	3
21002116	914335	0	0
21500290	1153428	1	1
36152204	1778162	0	0
36158929	738818	0	0
40230706	40229134	1	1
37203772	4280726	3	3
42806652	701322	0	0
44357538	1192710	0	0
45643095	738818	0	0
44357963	1153428	0	0
45643939	1174888	0	0
44340369	1119510	0	0
45631321	1154343	0	0
45636069	975125	0	0
45673610	1115171	2	3
45781143	1125315	0	0
45779168	1129625	0	0
45683600	40163554	2	3
45679868	1125315	0	0
45792059	1125315	0	0
45681059	723013	0	0
45780310	1125315	0	0
46287991	701322	0	0
46288688	1115008	0	0
45804382	1125315	0	0
45897971	1125315	0	0
45791699	1177480	0	0
46311417	1343916	0	0
45803844	1521369	0	0
4001565	4337138	1	1
4247371	4001336	5	6
21001554	46275916	2	3
21002125	1746114	0	0
21500290	1149196	1	1
36152338	1153428	0	0
36159065	1149196	0	0
40228218	40228230	1	1
37203769	258780	3	3
42806516	920293	0	0
44357539	1112807	0	0
45643178	1713332	0	0
44358090	1154343	0	0
45643890	1551099	0	0
44340637	1119510	0	0
45631232	791967	0	0
45635894	975125	0	0
45673628	1551192	2	3
45781145	1125315	0	0
45779175	1129625	0	0
45683670	19008572	2	3
45679863	1125315	0	0
45792061	1125315	0	0
45681211	1124300	0	0
45780342	1125315	0	0
46288088	1112807	0	0
46288571	1738521	0	0
45804312	1125315	0	0
45897962	1125315	0	0
45791657	1177480	0	0
46311821	975125	0	0
45803844	1549786	0	0
4001377	4242997	1	1
4297887	81893	5	6
21000244	46233988	2	3
21002123	1717327	0	0
21500290	1150770	1	1
36152343	1115008	0	0
36159070	1177480	0	0
40033902	19018935	1	1
40782821	3023430	3	3
42806529	19127890	0	0
44357542	1713332	0	0
45643179	19002770	0	0
44358093	1551099	0	0
45643891	1124957	0	0
44340196	1119510	0	0
45631247	1713332	0	0
45636206	975125	0	0
45673854	19008572	2	3
45781146	1125315	0	0
45707628	1129625	0	0
45683778	46275444	2	3
45679789	1125315	0	0
45792181	1125315	0	0
45681268	19127890	0	0
45780475	1125315	0	0
46288099	1112807	0	0
46288583	1343916	0	0
45796287	1125315	0	0
45897949	1125315	0	0
45791835	1177480	0	0
46311454	975125	0	0
45803845	1119510	0	0
374364	372328	1	1
4297090	4252419	5	6
21001099	19076374	2	3
21002124	1741122	0	0
21500375	1137529	1	1
36152420	1124300	0	0
36159071	1129625	0	0
40035909	19076374	1	1
37203758	317009	3	3
42806529	1589505	0	0
44357544	1177480	0	0
45643190	1713332	0	0
44358098	1713332	0	0
45644039	1738521	0	0
44340203	1119510	0	0
45631247	1759842	0	0
45633999	975125	0	0
45673831	1551192	2	3
45780982	1125315	0	0
45707651	1129625	0	0
45683783	19132304	2	3
45679588	1125315	0	0
45792089	1125315	0	0
45681268	1549786	0	0
45780277	1125315	0	0
46288101	1174888	0	0
46288216	1307863	0	0
45796417	1125315	0	0
45895695	1125315	0	0
45791741	1177480	0	0
46319021	1713332	0	0
45803847	1177480	0	0
79116	4146173	1	1
4297090	4024289	5	6
21001099	19078924	2	3
21002124	1746114	0	0
21500375	1149380	1	1
36152327	975125	0	0
36159074	1192710	0	0
37622403	317576	1	1
36776613	380378	3	3
42806529	1549786	0	0
44357629	1112807	0	0
45642960	1154029	0	0
44357981	1778162	0	0
45644051	1501700	0	0
44340204	1119510	0	0
45626546	1305058	0	0
45659022	738818	0	0
45673515	40222846	2	3
45781082	1125315	0	0
45707818	1129625	0	0
45683898	1107882	2	3
45630714	1125315	0	0
45792093	1125315	0	0
45681269	1174888	0	0
45780448	1125315	0	0
46288101	1192710	0	0
46288274	1545958	0	0
45796423	1125315	0	0
45895778	1125315	0	0
45788967	1177480	0	0
46319419	1192710	0	0
45803667	1119510	0	0
134222	4278672	1	1
4326426	4198190	5	6
21000284	46233710	2	3
21002124	1759842	0	0
21500375	1154343	1	1
36152328	738818	0	0
36158914	1112807	0	0
37520737	4078793	1	1
37202320	28060	3	4
42806530	723013	0	0
44357639	1545958	0	0
45643002	738818	0	0
44358075	738818	0	0
45643929	715997	0	0
44340316	1119510	0	0
45626351	914335	0	0
45658910	1308738	0	0
45673842	40232448	2	3
45781063	1125315	0	0
45707862	1129625	0	0
45683825	19019273	2	3
45630656	1125315	0	0
45792096	1125315	0	0
45681332	723013	0	0
45780233	1125315	0	0
46243025	1738521	0	0
46288458	1307863	0	0
45797158	1125315	0	0
45895791	1125315	0	0
45788972	1177480	0	0
46319424	701322	0	0
45803673	738818	0	0
134222	4155034	1	1
4293902	4198190	5	6
21506081	40174880	2	3
21002124	1717327	0	0
21500423	914335	1	1
36152422	1713332	0	0
36158917	1177480	0	0
37520740	4337138	1	1
37521016	4198190	3	4
42806509	914335	0	0
44357641	715997	0	0
45643192	975125	0	0
44358081	967823	0	0
45643954	1107830	0	0
44337327	1119510	0	0
45626525	1305058	0	0
45659024	1000560	0	0
45673848	1127433	2	3
45781064	1125315	0	0
45707921	1129625	0	0
45683973	19008572	2	3
45630780	1125315	0	0
45792098	1125315	0	0
45681336	1548195	0	0
45777762	1125315	0	0
46243139	1149196	0	0
46288721	715997	0	0
45797162	1125315	0	0
45895806	1125315	0	0
45788976	1177480	0	0
46319397	1124300	0	0
45803673	1119510	0	0
81902	4116491	1	1
4293032	4198190	5	6
21001773	40228230	2	3
21002140	1741122	0	0
21504554	1518198	1	1
36152422	1759842	0	0
36159298	1129625	0	0
37520797	4197460	1	1
37600000	192671	3	4
42806538	1154029	0	0
44357650	1112807	0	0
45640292	1545958	0	0
44358082	1192710	0	0
45644067	1174888	0	0
44337329	1119510	0	0
45626504	708298	0	0
45659125	738818	0	0
45673851	40174880	2	3
45780856	1125315	0	0
45705040	1129625	0	0
45684060	40232448	2	3
45630769	1125315	0	0
45792206	1125315	0	0
45681145	1107830	0	0
45777723	1125315	0	0
46243140	738818	0	0
46244617	1000560	0	0
45797286	1125315	0	0
45895773	1125315	0	0
46302164	1177480	0	0
46319804	914335	0	0
45803875	1332418	0	0
3026023	3027970	1	1
4244662	4059173	5	6
21001460	19126352	2	3
21002141	1741122	0	0
21504554	1549786	1	1
36152447	1149196	0	0
36159251	1107830	0	0
37219804	261325	1	1
36718595	44782520	3	4
42806539	791967	0	0
44357770	1129625	0	0
45640379	1501700	0	0
44358085	1545958	0	0
45644117	1000560	0	0
45620165	1119510	0	0
45626507	1115008	0	0
45659132	1307863	0	0
45673954	19019273	2	3
45780857	1125315	0	0
45705125	1129625	0	0
45680553	19019273	2	3
45630978	1125315	0	0
45792210	1125315	0	0
45681248	1112807	0	0
45777726	1125315	0	0
46243201	1112807	0	0
46244744	1118084	0	0
45797173	1125315	0	0
45895861	1125315	0	0
46299236	1177480	0	0
46319733	1149380	0	0
45803954	1112807	0	0
3026023	3006906	1	1
4244662	4278672	5	6
21001125	1551192	2	3
21002139	1741122	0	0
21504600	1332418	1	1
36152038	1332418	0	0
36159229	1129625	0	0
37219822	255848	1	1
37203764	4051466	3	4
42806604	1110410	0	0
44357771	1107830	0	0
45640390	723013	0	0
44357731	1361711	0	0
45644043	19003953	0	0
45620181	1119510	0	0
45626495	1738521	0	0
45659221	1115008	0	0
45673962	1115171	2	3
45778549	1125315	0	0
45705099	1129625	0	0
45680713	1154615	2	3
45630605	1125315	0	0
45675985	1125315	0	0
45681251	1595799	0	0
45777649	1125315	0	0
46243205	19010482	0	0
46244657	1124957	0	0
45797266	1125315	0	0
45895910	1125315	0	0
46299489	1177480	0	0
46319831	1551099	0	0
45803960	1149196	0	0
3026023	3004501	1	1
4244662	40479768	5	6
21000198	46233988	2	3
21002129	1717327	0	0
21504600	1545958	1	1
36152424	1107830	0	0
36159197	1177480	0	0
37219832	255848	1	1
37019275	4056621	3	4
42806644	1713332	0	0
44357598	1738521	0	0
45640391	1174888	0	0
44358234	738818	0	0
45644028	1305058	0	0
45620294	1119510	0	0
45626730	1500211	0	0
45659288	738818	0	0
45673884	19008572	2	3
45778557	1125315	0	0
45704925	1129625	0	0
45680671	19059056	2	3
45630904	1125315	0	0
45676035	1125315	0	0
45681219	1545958	0	0
45777653	1125315	0	0
46243190	1332418	0	0
46243249	1717327	0	0
45796485	1125315	0	0
45895965	1125315	0	0
46298825	1177480	0	0
46319832	967823	0	0
45803961	1129625	0	0
3026023	3024561	1	1
4244662	40479422	5	6
21000196	46233710	2	3
21002145	1746114	0	0
21504600	1112807	1	1
36152150	1112807	0	0
36159200	1521369	0	0
40789845	3015632	1	1
37604032	381316	3	4
42806313	1545958	0	0
44357778	1124300	0	0
45640400	1521369	0	0
44358237	1174888	0	0
45643996	920293	0	0
45620243	1119510	0	0
45626516	1153428	0	0
45659173	1501700	0	0
45673807	1115171	2	3
45778558	1125315	0	0
45705068	1129625	0	0
45680674	35605482	2	3
45630803	1125315	0	0
45675877	1125315	0	0
45681229	1174888	0	0
45777632	1125315	0	0
46242898	1154343	0	0
46243270	1738521	0	0
45796535	1125315	0	0
45896009	1125315	0	0
46299418	1177480	0	0
46319706	967823	0	0
45803961	1177480	0	0
3026023	3013721	1	1
4302537	28060	5	6
21001475	40163554	2	3
21505640	967823	0	0
21504600	1539403	1	1
36152150	1129625	0	0
36159200	1548195	0	0
40789893	3023103	1	1
37604032	317576	3	5
42806380	1115008	0	0
44357602	1149196	0	0
45640400	19127890	0	0
44357999	715997	0	0
45644010	1107830	0	0
45620357	1119510	0	0
45626789	1343916	0	0
45659263	914335	0	0
45673869	40223834	2	3
45778559	1125315	0	0
45633040	1177480	0	0
45677361	19078924	2	3
45630999	1125315	0	0
45675882	1125315	0	0
45681082	1107830	0	0
45777805	1125315	0	0
46242900	1746114	0	0
46243272	1174888	0	0
45796629	1125315	0	0
45895929	1125315	0	0
46299213	1177480	0	0
46317471	1326303	0	0
45803962	975125	0	0
3026023	3035995	1	1
4274025	4304110	5	6
21001763	1551192	2	3
21505686	1174888	0	0
21503966	1118084	1	1
36152156	738818	0	0
36159130	738818	0	0
40765634	40769189	1	1
36718588	4132546	3	5
42806603	1153428	0	0
44357788	1118084	0	0
45640400	1549786	0	0
44358041	1154343	0	0
45644017	1154029	0	0
45620153	1119510	0	0
45626503	1149196	0	0
45656821	914335	0	0
45672997	1107882	2	3
45778560	1125315	0	0
45633042	1177480	0	0
45677428	40223834	2	3
45676714	1125315	0	0
45675957	1125315	0	0
45681096	914335	0	0
45777738	1125315	0	0
46242900	1741122	0	0
46243274	1153428	0	0
45796630	1125315	0	0
45896078	1125315	0	0
46302176	1177480	0	0
46317472	1595799	0	0
45803971	1119510	0	0
3026023	3016723	1	1
4274025	4102123	5	6
21001456	19059056	2	3
21505687	1119510	0	0
21504520	1589505	1	1
36110716	195588	0	0
36159132	1107830	0	0
40765634	40769184	1	1
40481841	439777	3	5
42806391	740275	0	0
44357753	1501700	0	0
45640329	19002770	0	0
44358143	1192710	0	0
45644100	723013	0	0
45620474	1119510	0	0
45626538	1729720	0	0
45656824	19127890	0	0
45673319	19078461	2	3
45778666	1125315	0	0
45633146	1177480	0	0
45677509	19078461	2	3
45628373	1125315	0	0
45676149	1125315	0	0
45681098	920293	0	0
45777750	1125315	0	0
46242907	1192710	0	0
46243254	1332418	0	0
45796705	1125315	0	0
45896114	1125315	0	0
46295320	1177480	0	0
46317199	967823	0	0
45803876	1332418	0	0
3026023	3006923	1	1
4274025	4302207	5	6
21001547	1310034	2	3
21505688	1174888	0	0
21504520	975125	1	1
36158141	1177480	0	0
36159040	708298	0	0
40765634	40769179	1	1
37203771	4112343	3	5
42806494	715997	0	0
44357663	701322	0	0
45640335	1115008	0	0
44358155	1713332	0	0
45643983	708298	0	0
44362303	1119510	0	0
45626610	1343916	0	0
45656824	1589505	0	0
45670810	19008572	2	3
45778613	1125315	0	0
45676402	1177480	0	0
45677713	40232448	2	3
45628293	1125315	0	0
45676440	1125315	0	0
45681260	920293	0	0
45777703	1125315	0	0
46242910	1153428	0	0
46243310	1118084	0	0
45796474	1125315	0	0
45896116	1125315	0	0
46296219	1177480	0	0
46317726	933724	0	0
45803880	1119510	0	0
3026023	3020630	1	1
4300157	81151	5	5
21001462	19075601	2	3
21505695	742185	0	0
21504525	975125	1	1
36158254	1713332	0	0
36159239	1000560	0	0
40765634	40769194	1	1
37203771	4294548	3	5
42806596	1115008	0	0
44357773	1332418	0	0
45640364	975125	0	0
44358158	1713332	0	0
45644108	1124300	0	0
44362219	1119510	0	0
45626613	967823	0	0
45656824	1549786	0	0
45670775	1713671	2	3
45778642	1125315	0	0
45676634	1177480	0	0
45677474	19008572	2	3
45628068	1125315	0	0
45676442	1125315	0	0
45681348	1332418	0	0
45706531	1125315	0	0
46242917	738818	0	0
46243296	1192710	0	0
45796476	1125315	0	0
45896118	1125315	0	0
46296392	1177480	0	0
46317869	1778162	0	0
45803881	1119510	0	0
3026023	3013682	1	1
4241075	4107731	5	5
21001462	19059056	2	3
21603673	1343916	0	0
21505601	43012433	1	1
36158254	1759842	0	0
36159139	1115008	0	0
40758528	3004501	1	1
37600000	381316	3	6
42820136	1125315	0	0
44357586	1107830	0	0
45640356	1361711	0	0
44358112	1192710	0	0
45644109	967823	0	0
44362100	1119510	0	0
45626619	738818	0	0
45657147	967823	0	0
45670799	1115171	2	3
45778572	1125315	0	0
45676760	1177480	0	0
45677769	19057271	2	3
45627856	1125315	0	0
45676478	1125315	0	0
45681350	1310149	0	0
45706582	1125315	0	0
46243015	1545958	0	0
46243360	1154029	0	0
45796477	1125315	0	0
45896167	1125315	0	0
46291266	1177480	0	0
46317525	1124300	0	0
45804092	1119510	0	0
3026863	3013721	1	1
4212577	4296204	5	5
21000116	19133905	2	3
21009232	1738521	0	0
21503969	1112807	1	1
36158265	1738521	0	0
36159142	1177480	0	0
40758251	3024561	1	1
37203764	4283893	3	6
42820136	1119510	0	0
44357835	1713332	0	0
45640431	1738521	0	0
44358114	1115008	0	0
45644075	920293	0	0
44362221	1119510	0	0
45626519	1332418	0	0
45657349	1713332	0	0
45671015	1115171	2	3
45778678	1125315	0	0
45676762	1177480	0	0
45677795	43012433	2	3
45627974	1125315	0	0
45676482	1125315	0	0
45681369	1112807	0	0
45706375	1125315	0	0
46243080	1124957	0	0
46243381	1174888	0	0
45796570	1125315	0	0
45803984	1125315	0	0
46244890	1177480	0	0
46317527	1551099	0	0
45804096	1119510	0	0
3026863	3024561	1	1
4306074	4337611	5	5
21000116	19133873	2	3
21010583	1308738	0	0
21503969	1102527	1	1
36158271	1124957	0	0
36159275	1521369	0	0
40771521	3024561	1	1
37600000	4329847	3	7
42801466	705944	0	0
44357841	738818	0	0
45640754	1124300	0	0
44358262	1118084	0	0
45641287	1115008	0	0
44361992	1119510	0	0
45626579	1713332	0	0
45657350	740275	0	0
45671017	40223834	2	3
45778925	1125315	0	0
45677126	1177480	0	0
45677796	19075001	2	3
45628043	1125315	0	0
45789127	1125315	0	0
45675559	1115008	0	0
45706427	1125315	0	0
46243184	1500211	0	0
46243459	1115008	0	0
45796556	1125315	0	0
45803985	1125315	0	0
46244689	1177480	0	0
46317901	1595799	0	0
45803889	967823	0	0
3026863	3035995	1	1
4306074	4323902	5	5
21001477	40163554	2	3
21011215	1154343	0	0
21503969	1125315	1	1
36158425	1177480	0	0
36159275	19127890	0	0
40771521	3016723	1	1
37203764	255848	3	7
42801365	1548195	0	0
44354079	1713332	0	0
45640591	1000560	0	0
44357746	1192710	0	0
45641290	1309944	0	0
44362396	1119510	0	0
45626467	1501700	0	0
45657234	1153428	0	0
45670909	40232448	2	3
45778934	1125315	0	0
45673938	1177480	0	0
45674409	1107882	2	3
45627864	1125315	0	0
45789128	1125315	0	0
45675678	1332418	0	0
45706497	1125315	0	0
46242999	738818	0	0
46243460	1154029	0	0
45796691	1125315	0	0
45803916	1125315	0	0
46239871	1177480	0	0
46317593	715997	0	0
45803973	1118084	0	0
3026863	3006923	1	1
4322976	4230209	5	5
21012458	19077572	2	3
21009234	1741122	0	0
21503969	1124957	1	1
36158427	1107830	0	0
36159275	1549786	0	0
40771521	3000963	1	1
37203764	4294548	3	8
42801479	1174888	0	0
44354079	1759842	0	0
45640592	1551099	0	0
44358001	1539403	0	0
45641220	791967	0	0
44362411	1119510	0	0
45626485	1000560	0	0
45657154	1149196	0	0
45671058	40231925	2	3
45778651	1125315	0	0
45673138	1177480	0	0
45676233	1115171	2	3
45627866	1125315	0	0
45789379	1125315	0	0
45675690	1154029	0	0
45706458	1125315	0	0
46243001	1778162	0	0
46243318	1746114	0	0
45796693	1125315	0	0
45803778	1125315	0	0
46239932	1177480	0	0
46313331	1115008	0	0
45803974	975125	0	0
3022035	3013682	1	1
4344497	40479422	5	5
21012458	836659	2	3
21009234	1759842	0	0
21505667	1119510	1	1
36158430	1177480	0	0
36159276	1595799	0	0
40771562	3009201	1	1
37203764	40486433	3	8
42801479	1125315	0	0
44354174	1149196	0	0
45640596	1102527	0	0
44358013	1326303	0	0
45641118	1115008	0	0
44362333	1119510	0	0
45626556	1759842	0	0
45657356	1746114	0	0
45671037	40165015	2	3
45778894	1125315	0	0
45673319	1177480	0	0
45676257	40163554	2	3
45676354	1125315	0	0
45789384	1125315	0	0
45675691	1112807	0	0
45706462	1125315	0	0
46243002	1192710	0	0
46243318	1741122	0	0
45796537	1125315	0	0
45804104	1125315	0	0
45896586	1177480	0	0
46313501	1115008	0	0
45803975	1713332	0	0
3022035	3006906	1	1
4344497	40479768	5	5
21001116	1115171	2	3
21011074	1322184	0	0
21505667	1125315	1	1
36158535	1153428	0	0
36159276	1549786	0	0
40760919	3013682	1	1
37203764	4112343	3	9
42801338	1332418	0	0
44353948	1115008	0	0
45640492	1738521	0	0
44358266	1174888	0	0
45641128	1149196	0	0
44362493	1119510	0	0
45626756	1107830	0	0
45657356	1741122	0	0
45669554	1127433	2	3
45778967	1125315	0	0
45673258	1177480	0	0
45674425	1115171	2	3
45676586	1125315	0	0
45789324	1125315	0	0
45675754	1124957	0	0
45706642	1125315	0	0
46243067	738818	0	0
46243398	1332418	0	0
45796725	1125315	0	0
45804138	1125315	0	0
45896474	1177480	0	0
46314215	1115008	0	0
45803976	920293	0	0
3022035	3004501	1	1
4208786	4048695	5	5
21012460	45892894	2	3
21602884	1778162	0	0
21500418	967823	1	1
36158536	715997	0	0
36159276	1521369	0	0
36426524	40224132	2	3
37300000	4296204	5	9
42801339	1000560	0	0
44354162	1124300	0	0
45640415	1551099	0	0
44358269	738818	0	0
45641137	738818	0	0
44362584	1119510	0	0
45626850	1107830	0	0
45657017	967823	0	0
45669427	19023398	2	3
45778975	1125315	0	0
45670791	1177480	0	0
45674472	40229134	2	3
45676163	1125315	0	0
45792114	1125315	0	0
45675758	1310149	0	0
45706539	1125315	0	0
46243242	975125	0	0
46243591	740275	0	0
45796663	1125315	0	0
45804190	1125315	0	0
45894675	1177480	0	0
46313945	1115008	0	0
45803979	1129625	0	0
3022035	3016723	1	1
4208786	4066995	5	5
21012460	40223768	2	3
21604180	1127078	4	7
21500442	914335	1	1
36158543	1149196	0	0
36159281	1149380	0	0
36426524	40224805	2	3
37100000	195588	5	8
42801508	1115008	0	0
44354167	1539403	0	0
45640444	1738521	0	0
44358272	1307863	0	0
45641140	1551099	0	0
44362564	1119510	0	0
45626571	723013	0	0
45657278	1500211	0	0
45669531	40163554	2	3
45778657	1125315	0	0
45670884	1177480	0	0
45674546	43012036	2	3
45676193	1125315	0	0
45792243	1125315	0	0
45675844	1112807	0	0
45706732	1125315	0	0
46243243	1107830	0	0
46243261	1000560	0	0
45796654	1125315	0	0
45804042	1125315	0	0
46318304	1177480	0	0
46313902	1115008	0	0
45803998	1343916	0	0
3003823	3006906	1	1
4208786	4059173	5	5
21012460	19077572	2	3
21604180	19077572	4	7
21500486	914335	1	1
36158537	1124957	0	0
36159190	1332418	0	0
36468760	40228214	2	3
37203779	313217	5	6
42801448	705944	0	0
44355253	1124300	0	0
45640450	1153428	0	0
44358179	1118084	0	0
45641209	1589505	0	0
44362369	1119510	0	0
45626556	1713332	0	0
45657287	1310149	0	0
45669640	19008572	2	3
45707447	1125315	0	0
45670842	1177480	0	0
45674566	19023398	2	3
45676203	1125315	0	0
45792070	1125315	0	0
45675852	1501700	0	0
45706726	1125315	0	0
46243006	1500211	0	0
46243285	1557272	0	0
45796656	1125315	0	0
45803941	1125315	0	0
46317962	1177480	0	0
46308049	1115008	0	0
45804009	1129625	0	0
3027995	3045716	1	1
4208786	4278672	5	5
21000701	1545959	2	3
21604180	40165015	4	7
21500496	975125	1	1
36158611	1177480	0	0
36159345	1129625	0	0
36426272	1107882	2	3
37502350	4057420	5	6
42801545	1548195	0	0
44355282	1177480	0	0
45640456	1124300	0	0
44358189	933724	0	0
45641194	1343916	0	0
44355065	1119510	0	0
45626655	1551099	0	0
45657117	1118084	0	0
45669510	40163554	2	3
45707457	1125315	0	0
45671044	1177480	0	0
45674572	1551192	2	3
45676204	1125315	0	0
45789453	1125315	0	0
45675853	1107830	0	0
45706733	1125315	0	0
46243152	740275	0	0
46243286	1112807	0	0
45791169	1125315	0	0
45804212	1125315	0	0
46318225	1177480	0	0
46308317	1115008	0	0
44360761	1125315	0	0
3027995	3019550	1	1
4208786	40479768	5	5
21000633	1551192	2	3
21502709	1150836	7	7
21500522	723013	1	1
36158581	715997	0	0
36159350	1713332	0	0
36426272	19125062	2	3
37100000	4116491	5	6
42801399	1713332	0	0
44355346	1177480	0	0
45640464	1343916	0	0
44358194	705944	0	0
45641162	1738521	0	0
44354966	1119510	0	0
45626659	1332418	0	0
45657431	1192710	0	0
45669256	1127433	2	3
45707177	1125315	0	0
45671053	1177480	0	0
45671471	40162522	2	3
45676277	1125315	0	0
45789465	1125315	0	0
45675643	1124957	0	0
45706685	1125315	0	0
46243220	738818	0	0
46243366	1332418	0	0
45791177	1125315	0	0
45804051	1125315	0	0
46318040	1177480	0	0
46308663	1115008	0	0
44361178	1125315	0	0
3027995	3015632	1	1
4208786	40479422	5	5
21001494	1551192	2	3
21502709	914335	7	7
21500490	933724	1	1
36158558	1112807	0	0
36159350	1759842	0	0
36313967	4012477	2	3
37102305	45769019	5	6
42801399	1759842	0	0
44355311	1129625	0	0
45640438	1107830	0	0
44358275	933724	0	0
45641157	1110410	0	0
44355078	1119510	0	0
45626664	1713332	0	0
45657388	723013	0	0
45669686	46275916	2	3
45707438	1125315	0	0
45671034	1177480	0	0
45671649	19129655	2	3
45676278	1125315	0	0
45786835	1125315	0	0
45675854	1000560	0	0
45706635	1125315	0	0
46243162	1124300	0	0
46243369	1192710	0	0
45791178	1125315	0	0
45803855	1125315	0	0
46312120	1177480	0	0
46311994	1115008	0	0
44361225	1125315	0	0
3027995	3023103	1	1
4326426	4057420	5	5
21000637	1551192	2	3
21502709	1119510	7	7
21500468	926487	1	1
36158559	975125	0	0
36159293	1129625	0	0
36422418	19073183	2	3
37102305	4056621	5	6
42801510	1305058	0	0
44355311	1177480	0	0
45640610	738818	0	0
44358017	791967	0	0
45641295	1501700	0	0
44355018	1119510	0	0
45626777	1174888	0	0
45657485	1000560	0	0
45669603	19018935	2	3
45707521	1125315	0	0
45669470	1177480	0	0
45671490	19019979	2	3
45673478	1125315	0	0
45786658	1125315	0	0
45675833	723013	0	0
45706794	1125315	0	0
46243168	1107830	0	0
46243372	705944	0	0
45791245	1125315	0	0
45804180	1125315	0	0
46312415	1177480	0	0
46303166	1115008	0	0
44361184	1125315	0	0
3027995	3014576	1	1
4297090	4243062	5	5
21001485	19129655	2	3
21502709	1149380	7	7
21505694	742185	1	1
36158568	1177480	0	0
36159049	1115008	0	0
36426554	40222846	2	3
37502341	4242997	5	5
42801513	1125315	0	0
44355316	914335	0	0
45640739	1332418	0	0
44357809	1115008	0	0
45641300	738818	0	0
44354835	1119510	0	0
45626761	933724	0	0
45657268	708298	0	0
45780905	40169216	2	3
45707524	1125315	0	0
45669533	1177480	0	0
45671555	40232448	2	3
45624733	1125315	0	0
45786500	1125315	0	0
45675988	975125	0	0
45706799	1125315	0	0
46243049	1192710	0	0
46243374	1713332	0	0
45791247	1125315	0	0
45804082	1125315	0	0
46312420	1177480	0	0
46303090	1115008	0	0
44361093	1125315	0	0
3004588	3020630	1	1
4297090	4024958	5	5
21001485	19073183	2	3
21502709	1174888	7	7
21505694	705944	1	1
36158652	1112807	0	0
36159054	1192710	0	0
36426554	45892894	2	3
40783186	3009201	5	5
42801515	920293	0	0
44355321	1110410	0	0
45640546	975125	0	0
44358121	1115008	0	0
45641235	1110410	0	0
44354841	1119510	0	0
45626911	1149196	0	0
45657364	1307863	0	0
45780812	19018935	2	3
45707561	1125315	0	0
45669579	1177480	0	0
45671558	1115171	2	3
45624812	1125315	0	0
45786506	1125315	0	0
45675997	715997	0	0
45706845	1125315	0	0
46243056	19003953	0	0
46243349	1332418	0	0
45791331	1125315	0	0
45798787	1125315	0	0
46307458	1177480	0	0
46303311	1115008	0	0
44361362	1125315	0	0
3004588	3027970	1	1
4297090	4163872	5	5
21001485	19073188	2	3
21502709	1153428	7	7
21505698	1174888	1	1
36158612	1129625	0	0
36159244	1177480	0	0
36516781	80809	2	3
37300000	4152936	5	5
42801547	1119510	0	0
44355443	1177480	0	0
45640516	1124957	0	0
44358137	1332418	0	0
45641240	1595799	0	0
44354976	1119510	0	0
45626542	1000560	0	0
45657164	1000560	0	0
45780816	40162522	2	3
45707580	1125315	0	0
45669563	1177480	0	0
45671540	40231925	2	3
45624956	1125315	0	0
45786618	1125315	0	0
45675999	1149196	0	0
46240175	1125315	0	0
46243117	1124300	0	0
46243331	1332418	0	0
45791148	1125315	0	0
45798788	1125315	0	0
46307558	1177480	0	0
46303377	1115008	0	0
44361214	1125315	0	0
3028564	3035995	1	1
4297090	4314290	5	5
21000630	1551192	2	3
21502709	1192710	7	7
21505699	1192710	1	1
36158613	1129625	0	0
36159212	1129625	0	0
36516781	4146173	2	3
40487842	4058899	5	5
42801526	1322184	0	0
44355445	1332418	0	0
45640381	975125	0	0
44358255	1174888	0	0
45641244	738818	0	0
44355089	1119510	0	0
45626688	1305058	0	0
45657124	1115008	0	0
45780914	40162522	2	3
45707141	1125315	0	0
45669583	1177480	0	0
45673029	19132304	2	3
45625027	1125315	0	0
45786939	1125315	0	0
45675836	740275	0	0
45703088	1125315	0	0
46243119	1107830	0	0
46243415	1112807	0	0
45791240	1125315	0	0
45798928	1125315	0	0
46307409	1177480	0	0
46301740	1115008	0	0
44361216	1125315	0	0
3029702	3006906	1	1
4297090	4145310	4	4
21001472	1539411	2	3
21502709	1129625	7	7
21505699	1119510	1	1
36158601	1192710	0	0
36159216	933724	0	0
36516781	4035415	2	3
40487842	4047491	5	5
42801528	1343916	0	0
44355448	1129625	0	0
45640518	1192710	0	0
44358117	1539403	0	0
45642982	1174888	0	0
44355138	1119510	0	0
45623286	738818	0	0
45657168	1154343	0	0
45783534	19008572	2	3
45707486	1125315	0	0
45669759	1177480	0	0
45673147	40231925	2	3
45625033	1125315	0	0
45786740	1125315	0	0
45675663	1778162	0	0
45703089	1125315	0	0
46243122	738818	0	0
46243354	1153428	0	0
45791355	1125315	0	0
45798930	1125315	0	0
46307682	1177480	0	0
46301394	1115008	0	0
44360930	1125315	0	0
3025200	3024561	1	1
4297090	4062501	4	4
21001472	1545959	2	3
21500120	1539403	7	7
21500367	1137529	1	1
36158602	738818	0	0
36159356	1343916	0	0
36474269	1332419	2	3
40789534	3008598	5	5
42801477	1557272	0	0
44355306	1332418	0	0
45640559	1192710	0	0
44357828	1115008	0	0
45642987	1149196	0	0
44354940	1119510	0	0
45623294	738818	0	0
45657490	1107830	0	0
45783181	40236824	2	3
45707222	1125315	0	0
45669613	1177480	0	0
45673211	19078461	2	3
45625039	1125315	0	0
45786648	1125315	0	0
45675669	1192710	0	0
45702778	1125315	0	0
46243126	1192710	0	0
46243449	1322184	0	0
45791211	1125315	0	0
45798950	1125315	0	0
46302453	1177480	0	0
46319563	1115008	0	0
46310771	1125315	0	0
3025200	3023103	1	1
4297090	40478878	4	4
21001578	19018935	2	3
21500120	1521369	7	7
21500367	1154343	1	1
36158639	1192710	0	0
36159426	1177480	0	0
36424040	964261	2	3
37203784	4048171	5	5
42801322	1545958	0	0
44355269	1129625	0	0
45640619	1174888	0	0
44354673	1118084	0	0
45642911	1107830	0	0
44354945	1119510	0	0
45623295	738818	0	0
45657448	1118084	0	0
45781052	1115171	2	3
45707243	1125315	0	0
45780810	1177480	0	0
45670025	19075001	2	3
45670319	1125315	0	0
45786749	1125315	0	0
45676094	1115008	0	0
45703030	1125315	0	0
46243208	1332418	0	0
46243322	1713332	0	0
45791492	1125315	0	0
45798589	1125315	0	0
46302373	1177480	0	0
46319472	1115008	0	0
46310784	1125315	0	0
3025200	3020630	1	1
4326426	4323902	4	4
4297090	4012477	2	5
21500120	19127890	7	7
21503649	1112807	1	1
36158556	1107830	0	0
36159055	1149196	0	0
36424575	46275916	2	3
37503997	4108705	5	5
42801380	1124300	0	0
44355368	791967	0	0
45640757	1174888	0	0
44354488	1000560	0	0
45642932	1738521	0	0
44354949	1119510	0	0
45623296	1343916	0	0
45657293	967823	0	0
45781143	40162522	2	3
45707598	1125315	0	0
45780908	1177480	0	0
45669942	1107882	2	3
45670470	1125315	0	0
45786710	1125315	0	0
45675913	1124300	0	0
45702999	1125315	0	0
46244644	1192710	0	0
46243345	1112807	0	0
45791277	1125315	0	0
45798482	1125315	0	0
46299662	1177480	0	0
46313560	1115008	0	0
46310799	1125315	0	0
3025200	3006906	1	1
4326426	4242997	4	4
4297090	4010253	2	6
21500263	1539411	6	7
21503649	1125315	1	1
36158753	1177480	0	0
36159364	1778162	0	0
36516825	4035415	2	2
42888893	4084167	6	6
42801381	715997	0	0
44355377	1129625	0	0
45640758	1322184	0	0
44354613	1000560	0	0
45642936	1713332	0	0
44354952	1119510	0	0
45623312	1174888	0	0
45657491	738818	0	0
45781013	1115171	2	3
45707599	1125315	0	0
45780966	1177480	0	0
45670173	1551192	2	3
45670621	1125315	0	0
45786920	1125315	0	0
45675954	740275	0	0
45703074	1125315	0	0
46244710	1112807	0	0
46243428	1307863	0	0
45791564	1125315	0	0
45798479	1125315	0	0
46299723	1177480	0	0
46314257	1115008	0	0
46310690	1125315	0	0
3025200	3014576	1	1
4297887	198809	4	4
4322976	4125906	2	7
21500263	1545959	6	7
21503649	1129625	1	1
36158758	1154343	0	0
36159471	1107830	0	0
36516825	80502	2	2
37502341	4163971	6	6
42803048	1713332	0	0
44355377	1177480	0	0
45640771	1153428	0	0
44354617	1738521	0	0
45643048	715997	0	0
44355051	1119510	0	0
45623313	1501700	0	0
45656971	1548195	0	0
45780987	19125062	2	3
45707509	1125315	0	0
45781241	1177480	0	0
45670076	19076374	2	3
45670520	1125315	0	0
45786922	1125315	0	0
45676059	1307863	0	0
45702979	1125315	0	0
46240900	1149196	0	0
46243472	1000560	0	0
45791547	1125315	0	0
45798592	1125315	0	0
46299644	1177480	0	0
46309080	1115008	0	0
46310717	1125315	0	0
3025200	3019550	1	1
4306073	4337611	4	4
4274025	80809	2	6
21503764	40229134	6	7
21505668	1119510	1	1
36158704	1107830	0	0
36159161	1738521	0	0
40039778	42902245	2	2
37602356	313217	6	7
42803050	1112807	0	0
44355380	1124957	0	0
45637368	1367571	0	0
44354413	933724	0	0
45643079	1343916	0	0
44355181	1119510	0	0
45623324	1115008	0	0
45657307	1713332	0	0
45781015	1115171	2	3
45707462	1125315	0	0
45781078	1177480	0	0
45670111	1545959	2	3
45670636	1125315	0	0
45786844	1125315	0	0
45675887	1500211	0	0
45703693	1125315	0	0
46241088	1118084	0	0
46243532	1322184	0	0
45791452	1125315	0	0
45798593	1125315	0	0
46300053	1177480	0	0
46309107	1115008	0	0
46305675	1125315	0	0
3025200	3013721	1	1
4306073	4323902	4	4
21001107	19074679	1	1
21601386	19007333	6	7
21505668	1174888	1	1
36158648	1129625	0	0
36159162	1129625	0	0
36703477	4029498	2	2
37602360	313217	6	7
42803053	1713332	0	0
44355384	1192710	0	0
45637497	1124300	0	0
44354639	1149196	0	0
45643080	1124957	0	0
44355198	1119510	0	0
45623484	1343916	0	0
45657314	1713332	0	0
45781064	40229134	2	3
45707418	1125315	0	0
45778617	1177480	0	0
45669908	40228214	2	3
45670429	1125315	0	0
45786931	1125315	0	0
45675850	1107830	0	0
45703772	1125315	0	0
46240800	1500211	0	0
46243537	1515774	0	0
45791500	1125315	0	0
45798595	1125315	0	0
46300137	1177480	0	0
46309408	1115008	0	0
46305736	1125315	0	0
3025200	3004501	1	1
4207186	4112343	4	4
21001138	19074679	1	1
21495748	3024731	4	4
21603458	1192710	2	2
36158744	1149196	0	0
36159164	1154029	0	0
36303153	4191853	2	2
37600000	4310024	6	7
42803053	1759842	0	0
44355360	1129625	0	0
45637081	1539403	0	0
44354762	1713332	0	0
45643807	1154343	0	0
44347769	1119510	0	0
45623628	1115008	0	0
45657380	1149196	0	0
45780697	40174880	2	3
45704437	1125315	0	0
45778634	1177480	0	0
45783716	40232448	2	3
45669011	1125315	0	0
45786776	1125315	0	0
45675899	1112807	0	0
45703650	1125315	0	0
46240802	1738521	0	0
46243537	1549786	0	0
46298538	1125315	0	0
45798598	1125315	0	0
46296124	1177480	0	0
46308974	1115008	0	0
46305738	1125315	0	0
3025200	3035995	1	1
4201745	28060	4	5
19125489	19128263	1	1
21495748	3002385	4	4
21603503	1150836	2	2
36158634	1129625	0	0
36159171	1307863	0	0
36475223	42902245	2	2
37302325	4066995	6	7
42803175	1545958	0	0
44355464	1192710	0	0
45637537	738818	0	0
44354762	1759842	0	0
45641310	1107830	0	0
44347846	1119510	0	0
45623546	1000560	0	0
45657386	1192710	0	0
45780857	40229134	2	3
45704727	1125315	0	0
45778670	1177480	0	0
45783768	40229134	2	3
45669119	1125315	0	0
45786875	1125315	0	0
45675930	975125	0	0
45703715	1125315	0	0
46240869	1112807	0	0
46243538	975125	0	0
46298711	1125315	0	0
45798704	1125315	0	0
46318469	1177480	0	0
46309379	1115008	0	0
46305749	1125315	0	0
3025200	3016723	1	1
4208786	4149245	4	5
19125489	19128022	1	1
21604180	715997	4	4
21603503	1150770	2	2
36158664	1548195	0	0
36159177	1332418	0	0
36314293	4314290	2	2
37203758	28060	6	7
42803386	1115008	0	0
44354286	1192710	0	0
45637466	1115008	0	0
44354674	933724	0	0
45641309	1115008	0	0
44347857	1119510	0	0
45623393	967823	0	0
45657056	1000560	0	0
45778549	40229134	2	3
45704827	1125315	0	0
45778596	1177480	0	0
45783723	40169281	2	3
45669057	1125315	0	0
45786714	1125315	0	0
45675790	791967	0	0
45703717	1125315	0	0
46240728	1112807	0	0
46243541	975125	0	0
46298716	1125315	0	0
45799845	1125315	0	0
46318480	1177480	0	0
46303718	1115008	0	0
46305606	1125315	0	0
3025200	3013682	1	1
4300244	4336464	4	5
19039300	19023398	1	1
21604180	791967	4	4
21603503	1153428	2	2
36158765	1177480	0	0
36159369	1129625	0	0
36516972	80180	2	2
37203758	4048171	6	9
42801553	1309944	0	0
44354296	1112807	0	0
45637474	1115008	0	0
44354767	738818	0	0
45641346	1174888	0	0
44347820	1119510	0	0
45623527	1501700	0	0
45657459	1310149	0	0
45778613	40229134	2	3
45704842	1125315	0	0
45779055	1177480	0	0
45783759	19073183	2	3
45669070	1125315	0	0
45786851	1125315	0	0
45676100	1124957	0	0
45703096	1125315	0	0
46240823	1332418	0	0
46243470	1539403	0	0
46298417	1125315	0	0
45799859	1125315	0	0
46318712	1177480	0	0
46303846	1115008	0	0
46305763	1125315	0	0
1551198	1551192	1	1
4302537	4027663	4	5
4323715	4108705	1	1
21604180	1102527	4	4
21603503	1107830	2	2
36158768	975125	0	0
36159375	1149196	0	0
40772935	3008598	6	6
37203758	258780	6	9
42801563	914335	0	0
44354352	1326303	0	0
45637505	791967	0	0
44354769	1124957	0	0
45641423	967823	0	0
44347826	1119510	0	0
45623351	1124300	0	0
45657061	1115008	0	0
45778642	40162522	2	3
45704843	1125315	0	0
45707419	1177480	0	0
45783867	1115171	2	3
45669076	1125315	0	0
45786787	1125315	0	0
45675902	975125	0	0
45703165	1125315	0	0
46240870	738818	0	0
46243554	1545958	0	0
46298689	1125315	0	0
45799005	1125315	0	0
46318988	1177480	0	0
46304123	1115008	0	0
46305813	1125315	0	0
1127530	19133768	1	1
4302537	196456	4	5
4323193	78272	1	1
21604180	708298	4	4
21602819	1746114	2	2
36158638	742185	0	0
36159383	1129625	0	0
36516825	4230399	6	6
36718595	375671	6	8
42801601	1125315	0	0
44354351	1177480	0	0
45637170	914335	0	0
44354772	738818	0	0
45641389	1310149	0	0
44347526	1119510	0	0
45623459	1738521	0	0
45657073	1115008	0	0
45778673	40223834	2	3
45704775	1125315	0	0
45704740	1177480	0	0
45783873	19008572	2	3
45669156	1125315	0	0
45786878	1125315	0	0
45676004	791967	0	0
45703182	1125315	0	0
46240883	1308738	0	0
46243555	1551099	0	0
46298722	1125315	0	0
45799006	1125315	0	0
46312664	1177480	0	0
46320565	1115008	0	0
46306110	1125315	0	0
792033	19057271	1	1
4244662	4237458	4	6
4308656	4301346	1	1
21602681	1551099	4	4
21602819	1713332	2	2
36158585	1118084	0	0
36159389	1107830	0	0
37502353	4043071	6	6
36718595	378001	6	8
42801581	1119510	0	0
44354299	1177480	0	0
45637172	1115008	0	0
44354773	920293	0	0
45641335	1343916	0	0
44347678	1119510	0	0
45623735	933724	0	0
45657216	740275	0	0
45778678	40229134	2	3
45704960	1125315	0	0
45704736	1177480	0	0
45783989	40229134	2	3
45669023	1125315	0	0
45786794	1125315	0	0
45676101	1551099	0	0
45703192	1125315	0	0
46240832	705944	0	0
46243476	1192710	0	0
46298859	1125315	0	0
45799017	1125315	0	0
46312547	1177480	0	0
46320378	1115008	0	0
46305944	1125315	0	0
793135	46221626	1	1
4244662	4142905	4	6
4306169	4102123	1	1
21602681	975125	4	4
21603491	1149196	2	2
36158590	1112807	0	0
36159529	1124957	0	0
36903632	4043241	6	6
36718595	378419	6	7
42801554	1778162	0	0
44354355	1129625	0	0
45637509	1332418	0	0
44354774	1124300	0	0
45637942	1124300	0	0
44347720	1119510	0	0
45623418	1107830	0	0
45657340	1545958	0	0
45778889	19019273	2	3
45704882	1125315	0	0
45704787	1177480	0	0
45781626	19078461	2	3
45669309	1125315	0	0
45786798	1125315	0	0
45675800	975125	0	0
45703278	1125315	0	0
46240935	1713332	0	0
46240856	967823	0	0
46298643	1125315	0	0
45799030	1125315	0	0
46312534	1177480	0	0
46320661	1115008	0	0
46305962	1125315	0	0
793136	46221626	1	1
4244662	4149245	4	6
4272162	4266809	1	1
21602681	1501700	4	4
21602515	1549786	2	2
36158660	1107830	0	0
36159540	1521369	0	0
36303153	4163872	6	6
36718595	4043241	8	9
42801569	1177480	0	0
44354359	1112807	0	0
45637539	1501700	0	0
44354797	1548195	0	0
45637944	1539403	0	0
44347722	1119510	0	0
45623438	1343916	0	0
45655363	1000560	0	0
45778975	1127433	2	3
45704562	1125315	0	0
45704975	1177480	0	0
45781568	19023398	2	3
45669293	1125315	0	0
45786964	1125315	0	0
45675872	1154029	0	0
45703221	1125315	0	0
46240935	1759842	0	0
46241051	19003953	0	0
46298782	1125315	0	0
45799038	1125315	0	0
46313054	1177480	0	0
46321276	1115008	0	0
46306113	1125315	0	0
782046	782047	1	1
4244662	40480160	4	6
4272488	81893	1	1
21500263	1539403	4	4
21602515	1548195	2	2
36158710	1177480	0	0
36159540	1595799	0	0
36303153	4314290	6	6
37503992	4057420	5	8
42801636	19127890	0	0
44354363	1545958	0	0
45637559	791967	0	0
44354542	1713332	0	0
45638092	933724	0	0
44347864	1119510	0	0
45623576	1501700	0	0
45655473	1124957	0	0
45707349	1545959	2	3
45704563	1125315	0	0
45704937	1177480	0	0
45781455	40232448	2	3
45669256	1125315	0	0
45786886	1125315	0	0
45675960	975125	0	0
45700124	1125315	0	0
46240970	1713332	0	0
46242539	1112807	0	0
46298988	1125315	0	0
45793548	1125315	0	0
46312851	1177480	0	0
46320638	1115008	0	0
46305901	1125315	0	0
444130	4109685	1	1
4302537	4266809	4	6
4247120	4027663	1	1
21500263	1308738	4	4
21603446	1129625	2	2
36158685	1112807	0	0
36159540	1549786	0	0
40772948	3036780	6	6
37503992	4043071	5	5
42801636	1515774	0	0
44354373	1177480	0	0
45637110	1322184	0	0
44354620	715997	0	0
45638095	1396131	0	0
44348587	1119510	0	0
45623627	1322184	0	0
45655373	967823	0	0
45707538	1115171	2	3
45704891	1125315	0	0
45701209	1177480	0	0
45781301	1115171	2	3
45669314	1125315	0	0
45786893	1125315	0	0
45675962	1192710	0	0
45700107	1125315	0	0
46240970	1759842	0	0
46242541	1551099	0	0
46298991	1125315	0	0
45793504	1125315	0	0
46313035	1177480	0	0
46314305	1115008	0	0
46305902	1125315	0	0
444129	78272	1	1
4302537	4310024	4	6
21505898	1125315	1	1
21500263	1545958	4	4
21603446	40232448	2	2
36158873	1115008	0	0
36159312	1129625	0	0
40772948	3021226	6	6
37503992	4337611	5	6
42801636	1549786	0	0
44354319	975125	0	0
45637192	1154029	0	0
44354574	1332418	0	0
45638109	1713332	0	0
44348553	1119510	0	0
45623562	1551099	0	0
45655449	1515774	0	0
45707120	40165015	2	3
45704569	1125315	0	0
45703453	1177480	0	0
45781305	19029476	2	3
45669379	1125315	0	0
45786896	1125315	0	0
45675966	1124300	0	0
45699932	1125315	0	0
46240949	738818	0	0
46242544	1102527	0	0
46298573	1125315	0	0
45793507	1125315	0	0
46307791	1177480	0	0
46317384	1115008	0	0
46305843	1125315	0	0
444191	4156265	1	1
4244662	81151	4	7
21506024	914335	1	1
21503967	40231925	5	6
21603446	738818	2	2
36158712	1107830	0	0
36159543	1129625	0	0
40772948	3023430	6	6
37503992	4125906	6	6
42801630	1545958	0	0
44354334	1112807	0	0
45637198	1343916	0	0
44354681	723013	0	0
45638109	1759842	0	0
44348328	1119510	0	0
45623645	1124957	0	0
45655347	1124300	0	0
45707582	19019273	2	3
45704570	1125315	0	0
45703693	1177480	0	0
45781814	40232448	2	3
45669144	1125315	0	0
45786900	1125315	0	0
45676104	1112807	0	0
45699935	1125315	0	0
46241053	1154029	0	0
46242167	1124300	0	0
46298873	1125315	0	0
45793575	1125315	0	0
46307955	1177480	0	0
46315287	1115008	0	0
46305974	1125315	0	0
377091	4029498	1	1
21001472	1539403	0	0
21505882	1557272	1	1
21002493	19128009	1	1
21603255	1154343	2	2
36158717	1713332	0	0
36159363	738818	0	0
40772948	3014599	6	6
37503992	4336464	6	10
42801613	1124300	0	0
44354395	1332418	0	0
45637381	1551099	0	0
44354798	1149196	0	0
45638120	1174888	0	0
44348556	1119510	0	0
45623652	1107830	0	0
45655449	1548195	0	0
45707305	1115171	2	3
45704965	1125315	0	0
45703408	1177480	0	0
45781816	40162522	2	3
45666630	1125315	0	0
45789112	1125315	0	0
45676011	1361711	0	0
45700246	1125315	0	0
46240904	791967	0	0
46242289	1107830	0	0
46298892	1125315	0	0
45793672	1125315	0	0
46308120	1177480	0	0
46315159	1115008	0	0
46306018	1125315	0	0
4003535	4330583	1	1
21001475	1310149	0	0
21500563	701322	1	1
21001922	1154615	1	1
21603255	1137529	2	2
36158717	1759842	0	0
36159504	1149196	0	0
37303790	133834	6	6
37503992	4197460	3	4
42801726	1124300	0	0
44354374	19127890	0	0
45637480	738818	0	0
44354799	1149380	0	0
45637970	738818	0	0
44347965	1119510	0	0
45623653	1595799	0	0
45655458	1174888	0	0
45707311	40224805	2	3
45704968	1125315	0	0
45701478	1177480	0	0
45781817	40236824	2	3
45666753	1125315	0	0
45786233	1125315	0	0
45676014	1192710	0	0
45700251	1125315	0	0
46240907	1153428	0	0
46242294	975125	0	0
46299220	1125315	0	0
45793613	1125315	0	0
46307480	1177480	0	0
46315331	1115008	0	0
46306021	1125315	0	0
1768904	19074841	1	1
21001483	1728416	0	0
21500563	757627	1	1
21013543	40171902	1	1
21602798	1738521	2	2
36158726	1124300	0	0
36159507	1305058	0	0
36703477	378001	6	6
37503992	4117038	3	7
42803389	1545958	0	0
44354374	1549786	0	0
45637481	1107830	0	0
44354803	975125	0	0
45638059	1713332	0	0
44348002	1119510	0	0
45623653	1521369	0	0
45655463	1124957	0	0
45707387	1551192	2	3
45704870	1125315	0	0
45698267	1177480	0	0
45781721	19059056	2	3
45666783	1125315	0	0
45786237	1125315	0	0
45676157	1361711	0	0
45700077	1125315	0	0
46240951	1545958	0	0
46242497	1738521	0	0
46298937	1125315	0	0
45793604	1125315	0	0
46307607	1177480	0	0
46309687	1115008	0	0
46306026	1125315	0	0
201337	195588	1	1
21001463	1307863	0	0
21500548	1125315	1	1
257012	257012	0	0
21602119	1149380	2	2
36158877	1000560	0	0
36159545	933724	0	0
36703477	375671	6	6
37503992	4323902	3	7
42803305	1149380	0	0
44354397	1129625	0	0
45637200	1000560	0	0
44354722	1124300	0	0
45638039	1124957	0	0
44348105	1119510	0	0
45623653	1549786	0	0
45655406	1124957	0	0
45707727	19018935	2	3
45704970	1125315	0	0
45698405	1177480	0	0
45781545	40162522	2	3
45666872	1125315	0	0
45786278	1125315	0	0
45676134	1738521	0	0
45700081	1125315	0	0
46241062	933724	0	0
46242365	1118084	0	0
46298939	1125315	0	0
45793783	1125315	0	0
46308065	1177480	0	0
46309738	1115008	0	0
46306028	1125315	0	0
4008090	4043241	1	1
21001472	1545958	0	0
21500548	1129625	1	1
192671	192671	0	0
21602496	1519936	2	2
36158735	1115008	0	0
36159475	1177480	0	0
40792793	3002385	6	6
37503992	4323208	3	3
42803226	1548195	0	0
44354423	1149196	0	0
45637319	1154343	0	0
44354723	738818	0	0
45638042	738818	0	0
44348111	1119510	0	0
45623782	1332418	0	0
45655397	742185	0	0
45707679	1115171	2	3
45705018	1125315	0	0
45698269	1177480	0	0
45781298	1115171	2	3
45666936	1125315	0	0
45786438	1125315	0	0
45676016	1192710	0	0
45700199	1125315	0	0
46241090	738818	0	0
46242368	975125	0	0
46298656	1125315	0	0
45793517	1125315	0	0
46302648	1177480	0	0
46310106	1115008	0	0
46306037	1125315	0	0
1305130	19007333	1	1
21001483	1717327	0	0
21500578	1129625	1	1
1101498	1177480	0	0
21602840	1728416	2	2
36158879	1153428	0	0
36159492	1129625	0	0
40792793	3007461	6	6
37503992	4198190	7	9
42803308	1124300	0	0
44354519	1759842	0	0
45637545	19010482	0	0
44354848	1717327	0	0
45638050	1551099	0	0
44348246	1119510	0	0
45623716	1115008	0	0
45653912	1192710	0	0
45707683	1551192	2	3
45705028	1125315	0	0
45698329	1177480	0	0
45781311	40231925	2	3
45666963	1125315	0	0
45786431	1125315	0	0
45676114	914335	0	0
45700205	1125315	0	0
46241068	1112807	0	0
46242450	1112807	0	0
46291665	1125315	0	0
45793624	1125315	0	0
46302873	1177480	0	0
46304344	1115008	0	0
46305856	1125315	0	0
708336	19078924	1	1
21001486	1728416	0	0
21500563	836654	1	1
1101482	1361711	0	0
21602840	1729720	2	2
36158881	1149196	0	0
36159500	1129625	0	0
36703477	4043241	6	7
37503992	4295880	4	4
42803467	1729720	0	0
44354519	1713332	0	0
45637561	715997	0	0
44354684	1310149	0	0
45638055	1501700	0	0
44340728	1119510	0	0
45667698	1110410	0	0
45653862	1118084	0	0
45707585	40232448	2	3
45705030	1125315	0	0
45698234	1177480	0	0
45781677	19008572	2	3
45667027	1125315	0	0
45786575	1125315	0	0
45675865	967823	0	0
45697612	1125315	0	0
45792444	1115171	2	3
46241131	1000560	0	0
46291669	1125315	0	0
45793626	1125315	0	0
46302759	1177480	0	0
46304840	1115008	0	0
46322295	1125315	0	0
723162	19076374	1	1
21001486	1717327	0	0
4324765	4035415	1	1
1101498	1115008	0	0
35506542	140673	2	2
36158760	723013	0	0
36159502	1107830	0	0
36516772	4230399	6	7
37503992	4108705	4	6
42803448	740275	0	0
44354436	738818	0	0
45637562	738818	0	0
44354695	1713332	0	0
45638173	1000560	0	0
44340744	1119510	0	0
45667684	1115008	0	0
45653865	920293	0	0
45707732	19008572	2	3
45701268	1125315	0	0
45698690	1177480	0	0
45781689	40162522	2	3
45667040	1125315	0	0
45785309	1125315	0	0
45672883	1107830	0	0
45697613	1125315	0	0
45792537	1115171	2	3
46241208	1149196	0	0
46291843	1125315	0	0
45793539	1125315	0	0
46303078	1177480	0	0
46305115	1115008	0	0
46322299	1125315	0	0
201891	4310024	1	1
21001487	1728416	0	0
19124099	19127904	1	1
1101539	1177480	0	0
21602538	40224805	2	2
36158722	1149196	0	0
36159508	1177480	0	0
36303153	4252419	6	7
37503992	44783196	4	6
42803400	1125315	0	0
44354431	1343916	0	0
45637261	1107830	0	0
44354695	1759842	0	0
45638234	1332418	0	0
44340798	1119510	0	0
45667716	1115008	0	0
45653926	1107830	0	0
45707422	43012036	2	3
45701272	1125315	0	0
45698518	1177480	0	0
45783596	40229134	2	3
45666943	1125315	0	0
45785345	1125315	0	0
45672887	1118084	0	0
45697773	1125315	0	0
45792683	19019273	2	3
46241216	1713332	0	0
46290400	1125315	0	0
45793849	1125315	0	0
46303025	1177480	0	0
46304686	1115008	0	0
46322450	1125315	0	0
201618	4266809	1	1
21001488	1717327	0	0
21000640	19128263	1	1
1101489	1305058	0	0
21602538	40224132	2	2
36110722	198199	0	0
36159429	19127890	0	0
36516972	4230399	6	7
37500000	44805732	4	4
42803339	1124300	0	0
44354467	1548195	0	0
45637267	975125	0	0
44354886	1545958	0	0
45638177	1115008	0	0
44340981	1119510	0	0
45667395	1332418	0	0
45653939	1149196	0	0
45704590	19078461	2	3
45701121	1125315	0	0
45698607	1177480	0	0
45783601	1107882	2	3
45666903	1125315	0	0
45785271	1125315	0	0
45672908	1154343	0	0
45697777	1125315	0	0
45792652	1115171	2	3
46241154	1115008	0	0
46290402	1125315	0	0
45793804	1125315	0	0
46300500	1177480	0	0
46321547	1115008	0	0
46322625	1125315	0	0
201909	45769019	1	1
21001456	1112807	0	0
21000640	42902245	1	1
1101498	1118084	0	0
21602538	1500211	2	2
36110689	257012	0	0
36159429	1521369	0	0
37522270	4198190	6	8
37500000	4117038	4	9
42803487	1545958	0	0
44354426	715997	0	0
45637268	975125	0	0
44354900	1309944	0	0
45638169	1154343	0	0
44340833	1119510	0	0
45667726	1539403	0	0
45653913	1738521	0	0
45704635	19073188	2	3
45701208	1125315	0	0
45695240	1177480	0	0
45781902	40232448	2	3
45666848	1125315	0	0
45785273	1125315	0	0
45672893	1118084	0	0
45696895	1125315	0	0
45792458	1115171	2	3
46241119	1192710	0	0
46290385	1125315	0	0
45793741	1125315	0	0
46319070	1177480	0	0
46320825	1115008	0	0
46322626	1125315	0	0
320136	317009	1	1
21001493	1728416	0	0
21000640	19128022	1	1
1101553	1137529	0	0
21602485	19127904	2	2
36110708	4283893	0	0
36159429	1549786	0	0
36303153	4058899	6	8
37500000	4163971	4	10
42803548	975125	0	0
44354851	1545958	0	0
45637430	914335	0	0
44354873	740275	0	0
45638171	1713332	0	0
44340769	1119510	0	0
45667843	705944	0	0
45653904	1305058	0	0
45704595	19023398	2	3
45701169	1125315	0	0
45695276	1177480	0	0
45779235	19059056	2	3
45666986	1125315	0	0
45785360	1125315	0	0
45672959	1115008	0	0
45696977	1125315	0	0
45789622	19133905	2	3
46241122	1137529	0	0
46290396	1125315	0	0
45793815	1125315	0	0
46319088	1177480	0	0
46321315	1115008	0	0
46322627	1125315	0	0
256451	260139	1	1
21001456	1322184	0	0
4297706	4186930	1	1
1101553	1149380	0	0
21602104	975125	2	2
36110597	255848	0	0
36159556	1549786	0	0
36303153	80502	6	8
37500000	4107731	4	8
42803841	1124957	0	0
44354365	1000560	0	0
45637432	1115008	0	0
44354696	1551099	0	0
45638171	1759842	0	0
44340952	1119510	0	0
45667400	1367571	0	0
45653953	1713332	0	0
45704596	40232448	2	3
45701360	1125315	0	0
45695338	1177480	0	0
45779358	40236446	2	3
45666826	1125315	0	0
45785302	1125315	0	0
45673120	1107830	0	0
45696912	1125315	0	0
45789763	19133905	2	3
46241122	1149380	0	0
46290474	1125315	0	0
45793691	1125315	0	0
46239787	1177480	0	0
46321101	1115008	0	0
46322080	1125315	0	0
320136	257012	2	5
21001485	1717327	0	0
19127892	19127918	1	1
1101492	1367571	0	0
21602543	19054876	2	2
36150676	1124300	0	0
36159556	1512674	0	0
36703532	4001336	6	8
37500000	4336464	3	12
42803737	1124300	0	0
44354449	708298	0	0
45637291	1149196	0	0
44354993	1192710	0	0
45638183	738818	0	0
44340843	1119510	0	0
45667793	967823	0	0
45653941	1154343	0	0
45704440	19059056	2	3
45701383	1125315	0	0
45692092	1177480	0	0
45779376	1127433	2	3
45667045	1125315	0	0
45785351	1125315	0	0
45672935	1713332	0	0
45697123	1125315	0	0
45789763	19133873	2	3
46241124	1149196	0	0
46290527	1125315	0	0
45793586	1125315	0	0
46239946	1177480	0	0
46321625	1115008	0	0
46322678	1125315	0	0
320136	258780	4	7
21001477	1310149	0	0
19127892	19127904	1	1
1101539	1115008	0	0
21603283	1149380	2	2
36150681	1115008	0	0
36159559	1129625	0	0
36303153	4329847	6	12
37500000	4242997	3	9
42803340	1129625	0	0
44354450	1129625	0	0
45637309	1307863	0	0
44354637	1310149	0	0
45638251	1549786	0	0
44340854	1119510	0	0
45667806	1115008	0	0
45653975	1308738	0	0
45704445	19129655	2	3
45701292	1125315	0	0
45691793	1177480	0	0
45779377	1127433	2	3
45667051	1125315	0	0
45785352	1125315	0	0
45672936	757627	0	0
45696926	1125315	0	0
45789635	40223834	2	3
46241216	1759842	0	0
46290393	1125315	0	0
45788351	1125315	0	0
46321769	1177480	0	0
46320733	1115008	0	0
46317129	1125315	0	0
320136	4048171	4	7
21001477	1367571	0	0
19127892	19128065	1	1
1101544	1557272	0	0
21603933	1118084	2	2
36150693	1107830	0	0
36159559	1177480	0	0
36303153	195588	6	11
37500000	4059978	3	3
42803341	1729720	0	0
44354452	1129625	0	0
45637310	1713332	0	0
44354817	1118084	0	0
45638251	1595799	0	0
44341042	1119510	0	0
45667911	1149196	0	0
45654019	1124300	0	0
45704448	40223768	2	3
45701404	1125315	0	0
45692274	1177480	0	0
45779318	19018935	2	3
45666956	1125315	0	0
45785293	1125315	0	0
45672914	791967	0	0
45697016	1125315	0	0
45789651	40236824	2	3
46241218	1332418	0	0
46290602	1125315	0	0
45788375	1125315	0	0
46322234	1177480	0	0
46321305	1115008	0	0
46317105	1125315	0	0
320136	255848	4	5
21001028	742185	0	0
19127892	19128263	1	1
1101530	914335	0	0
21603933	1115008	2	2
36150696	1521369	0	0
36159320	738818	0	0
36303153	260139	6	11
37500000	4275113	3	3
42803318	1129625	0	0
44354452	1112807	0	0
45637491	1551099	0	0
44354994	1539403	0	0
45638251	1521369	0	0
44340914	1119510	0	0
45667922	914335	0	0
45654127	1153428	0	0
45704643	40236446	2	3
45701175	1125315	0	0
45692265	1177480	0	0
45780518	1107882	2	3
45666909	1125315	0	0
45785369	1125315	0	0
45672930	1112807	0	0
45696892	1125315	0	0
45789782	19018935	2	3
46241224	1713332	0	0
46290711	1125315	0	0
45788353	1125315	0	0
46321937	1177480	0	0
46315344	1115008	0	0
46317147	1125315	0	0
320136	40481087	4	5
21001028	705944	0	0
19127892	40221415	1	1
1101498	1124300	0	0
21603933	1177480	2	2
36150698	1149380	0	0
36159576	933724	0	0
36516972	4278672	4	6
37500000	4125906	8	8
42803457	1545958	0	0
44354453	1115008	0	0
45637516	1154029	0	0
44354795	1738521	0	0
45638342	1149196	0	0
44340922	1119510	0	0
45667933	1501700	0	0
45654088	1545958	0	0
45704819	19008572	2	3
45703452	1125315	0	0
45691799	1177480	0	0
45780620	19019273	2	3
45667003	1125315	0	0
45785364	1125315	0	0
45673042	1107830	0	0
45697057	1125315	0	0
45789682	19008572	2	3
46241224	1759842	0	0
46290875	1125315	0	0
45788474	1125315	0	0
46322341	1177480	0	0
46315635	1115008	0	0
46311272	1125315	0	0
320136	28060	4	5
21001038	1717327	0	0
19127892	19128022	1	1
1102527	1102527	0	0
21602818	1728416	2	2
36150699	1124300	0	0
36159462	1177480	0	0
36516972	40480160	4	6
37500000	4293740	5	5
42803420	975125	0	0
44354573	1332418	0	0
45637517	920293	0	0
44355069	1115008	0	0
45638305	1124957	0	0
44340924	1119510	0	0
45667936	1124957	0	0
45653980	1000560	0	0
45704878	40174880	2	3
45703459	1125315	0	0
45692243	1177480	0	0
45780701	40229134	2	3
45667124	1125315	0	0
45785578	1125315	0	0
45673043	975125	0	0
45696980	1125315	0	0
45789962	43012036	2	3
46241307	1115008	0	0
46290448	1125315	0	0
45788176	1125315	0	0
46316381	1177480	0	0
46315547	1115008	0	0
46311332	1125315	0	0
138239	78272	4	6
21001034	1728416	0	0
4297090	4191853	1	1
903356	19010482	0	0
21602818	1741122	2	2
36150807	1746114	0	0
36159029	1738521	0	0
36516972	81151	4	7
37500000	4301346	5	8
42803334	1125315	0	0
44354434	1322184	0	0
45637519	1153428	0	0
44354739	933724	0	0
45638380	1729720	0	0
44340894	1119510	0	0
45667609	1153428	0	0
45653984	1309944	0	0
45704970	40229134	2	3
45701456	1125315	0	0
45692305	1177480	0	0
45780706	1107882	2	3
45666998	1125315	0	0
45785398	1125315	0	0
45673220	1501700	0	0
45697002	1125315	0	0
45789151	19018935	2	3
46241138	1149196	0	0
46290779	1125315	0	0
45788463	1125315	0	0
46310721	1177480	0	0
46315875	1115008	0	0
46311661	1125315	0	0
138239	4278672	4	5
21001033	1778162	0	0
21001462	40171902	1	1
903327	1124300	0	0
21602818	1746114	2	2
36150807	1741122	0	0
36159031	1153428	0	0
36516972	4149245	4	7
37500000	44783196	5	8
42803528	1125315	0	0
44354568	1308738	0	0
45637521	1549786	0	0
44354815	975125	0	0
45638443	1551099	0	0
45636976	1119510	0	0
45667617	1154029	0	0
45654009	967823	0	0
45704911	19075601	2	3
45701553	1125315	0	0
45689246	1177480	0	0
45779431	19076374	2	3
45667082	1125315	0	0
45785462	1125315	0	0
45673222	1343916	0	0
45697041	1125315	0	0
45789160	1115171	2	3
46241142	1192710	0	0
46290980	1125315	0	0
45788315	1125315	0	0
46311229	1177480	0	0
46310234	1115008	0	0
46311623	1125315	0	0
138239	40479422	7	8
21001033	1717327	0	0
21001102	19074679	1	1
903386	701322	0	0
21602818	1729720	2	2
36150715	19003953	0	0
36159034	1154029	0	0
36516781	4134304	4	7
40039762	19128009	2	2
40162522	40162522	0	0
44354569	1129625	0	0
45639941	1107830	0	0
44354819	1174888	0	0
45638302	1361711	0	0
45637302	1119510	0	0
45667738	738818	0	0
45654098	1307863	0	0
45705026	19057271	2	3
45701501	1125315	0	0
45689213	1177480	0	0
45779437	40229134	2	3
45667134	1125315	0	0
45785531	1125315	0	0
45673230	1557272	0	0
45697043	1125315	0	0
45789091	1551192	2	3
46241194	1501700	0	0
46290669	1125315	0	0
45788517	1125315	0	0
46310964	1177480	0	0
46312082	1115008	0	0
46311517	1125315	0	0
138239	40479768	7	8
21001035	1778162	0	0
21000643	19128009	1	1
903386	715997	0	0
21602818	1713332	2	2
36150810	1129625	0	0
36159037	1310149	0	0
36516772	81151	4	7
40039762	19127918	2	2
40163554	40163554	0	0
44354662	1326303	0	0
45639831	1149196	0	0
44354830	1713332	0	0
45638445	1124300	0	0
45637397	1119510	0	0
45667751	723013	0	0
45654025	1768849	0	0
45701272	40229134	2	3
45701654	1125315	0	0
45686242	1177480	0	0
45779461	40229134	2	3
45780960	1125315	0	0
45785410	1125315	0	0
45673233	914335	0	0
45697232	1125315	0	0
45787078	19008572	2	3
46241296	1332418	0	0
46290833	1125315	0	0
45788392	1125315	0	0
46310951	1177480	0	0
46310328	1115008	0	0
46311759	1125315	0	0
138239	4146173	5	7
21001035	1728416	0	0
21000643	19127918	1	1
4035415	4035415	0	0
21602818	1717327	2	2
36150855	738818	0	0
36159459	1177480	0	0
36516772	40480160	4	6
37521341	4242997	2	2
37521377	4330583	0	0
44350813	1551099	0	0
45639821	1310149	0	0
44351199	1343916	0	0
45637227	705944	0	0
45637399	1119510	0	0
45667825	1153428	0	0
45654049	1539403	0	0
45701221	19057271	2	3
45701591	1125315	0	0
45686327	1177480	0	0
45707934	19008572	2	3
45780713	1125315	0	0
45785424	1125315	0	0
45672966	1174888	0	0
45697081	1125315	0	0
45787082	19008572	2	3
46241305	1343916	0	0
46291019	1125315	0	0
45788480	1125315	0	0
46305728	1177480	0	0
46305073	1115008	0	0
46311668	1125315	0	0
138239	4149245	5	7
21001035	1717327	0	0
21000643	19128263	1	1
4035793	4035793	0	0
21602858	1741122	2	2
36150860	1129625	0	0
36159460	1153428	0	0
36516772	4142905	4	6
37521694	4043071	2	2
37521342	4242997	0	0
44350612	1115008	0	0
45639825	1396131	0	0
44350878	1548195	0	0
45637125	1717327	0	0
45620724	1119510	0	0
45667402	1307863	0	0
45654027	1309944	0	0
45701383	1127433	2	3
45701592	1125315	0	0
45686248	1177480	0	0
45707950	43012036	2	3
45780643	1125315	0	0
45785495	1125315	0	0
45673176	1192710	0	0
45697302	1125315	0	0
45786991	1551192	2	3
46241248	1112807	0	0
46291036	1125315	0	0
45788440	1125315	0	0
46322513	1177480	0	0
46305089	1115008	0	0
46311822	1125315	0	0
138239	4152936	5	7
21001036	1778162	0	0
21000643	42902245	1	1
4037675	4037675	0	0
21603445	738818	2	2
36150840	701322	0	0
36159585	738818	0	0
36516772	4237458	4	6
37522351	4202451	2	2
43053690	4230399	3	4
44350711	1129625	0	0
45640107	738818	0	0
44351039	1746114	0	0
45637128	738818	0	0
45620746	1119510	0	0
45667760	1717327	0	0
45647311	715997	0	0
45701175	1127433	2	3
45698107	1125315	0	0
45686216	1177480	0	0
45708146	1115171	2	3
45780645	1125315	0	0
45785382	1125315	0	0
45673059	1107830	0	0
45693880	1125315	0	0
45787016	19074679	2	3
46241250	1545958	0	0
46291057	1125315	0	0
45788610	1125315	0	0
46316862	1177480	0	0
46306722	1115008	0	0
46311423	1125315	0	0
138239	4113008	5	5
21001099	708298	0	0
21000643	40221415	1	1
4133840	4133840	0	0
21603445	1150836	2	2
36150825	1551099	0	0
36159588	1713332	0	0
36703500	380378	4	5
40039151	42902245	2	2
43053690	4237458	3	3
44350839	1129625	0	0
45640207	967823	0	0
44351039	1741122	0	0
45634858	1549786	0	0
45661432	1119510	0	0
45667543	1124957	0	0
45647440	1310149	0	0
45703444	42707627	2	3
45698378	1125315	0	0
45686334	1177480	0	0
45707884	40169281	2	3
45778367	1125315	0	0
45785386	1125315	0	0
45673305	1112807	0	0
45693897	1125315	0	0
45787219	1115171	2	3
46241283	1545958	0	0
46291069	1125315	0	0
45788598	1125315	0	0
46306460	1177480	0	0
46310732	1115008	0	0
46311435	1125315	0	0
138239	4035415	5	6
21000082	1728416	0	0
4322976	4035793	4	5
4199276	4199276	0	0
21603249	1154343	2	2
36150828	1149196	0	0
36159597	1174888	0	0
36516961	4048695	4	5
42889648	4001336	2	2
43053690	4059173	3	3
44350579	1177480	0	0
45640184	715997	0	0
44351164	1000560	0	0
45634910	19010482	0	0
45661516	1119510	0	0
45667527	1124300	0	0
45647320	1545958	0	0
45703461	35605482	2	3
45698239	1125315	0	0
45686448	1177480	0	0
45708135	1115171	2	3
45778158	1125315	0	0
45785389	1125315	0	0
45673305	1192710	0	0
45693900	1125315	0	0
45787184	40236824	2	3
46241163	757627	0	0
46290686	1125315	0	0
45788410	1125315	0	0
46306382	1177480	0	0
46306343	1115008	0	0
46311440	1125315	0	0
138239	4059173	5	6
21000078	1728416	0	0
4279903	4242997	4	4
4078793	4078793	0	0
21603249	1137529	2	2
36150920	1107830	0	0
36159599	1115008	0	0
36516961	4066995	4	5
42803400	1127433	2	3
43053690	4048695	3	3
44350419	1129625	0	0
45639982	738818	0	0
44351101	1000560	0	0
45634840	1174888	0	0
45661519	1119510	0	0
45667529	1149196	0	0
45647321	1332418	0	0
45703693	1127433	2	3
45698229	1125315	0	0
45683113	1177480	0	0
45708244	40232448	2	3
45778159	1125315	0	0
45785391	1125315	0	0
45786759	1557272	0	0
45693954	1125315	0	0
45785569	40229134	2	3
46241229	1112807	0	0
46290687	1125315	0	0
45788531	1125315	0	0
46306405	1177480	0	0
46322629	1115008	0	0
46319609	1125315	0	0
135930	80809	4	4
21000108	1717327	0	0
4322976	4052083	4	4
21503371	19008572	3	4
21603282	1149380	2	2
36150730	1149196	0	0
36159613	1149196	0	0
36516825	4237458	4	5
42803341	19133905	2	3
43053690	4066995	3	3
44350399	1307863	0	0
45639984	1551099	0	0
44351102	1115008	0	0
45634858	1589505	0	0
45661744	1119510	0	0
45667727	1118084	0	0
45647353	1332418	0	0
45701464	19077344	2	3
45698446	1125315	0	0
45683318	1177480	0	0
45708075	19018935	2	3
45778165	1125315	0	0
45785559	1125315	0	0
45786663	1326303	0	0
45693955	1125315	0	0
45785619	1519937	2	3
46241252	1153428	0	0
46290694	1125315	0	0
45788413	1125315	0	0
45895652	1129625	0	0
46317054	1115008	0	0
46319645	1125315	0	0
135930	4278672	4	7
21000085	1729720	0	0
4302532	4108705	4	4
21500762	967823	3	3
21602797	1738521	2	2
36150801	1107830	0	0
36159614	738818	0	0
36516825	4142905	4	5
42803318	40232448	2	3
43053690	4278672	3	3
44350403	791967	0	0
45640081	1308738	0	0
44351103	1149380	0	0
45634858	19127890	0	0
45661961	1119510	0	0
45667728	1124300	0	0
45647429	1512674	0	0
45701675	42707627	2	3
45698243	1125315	0	0
45683530	1177480	0	0
45708194	19008572	2	3
45778456	1125315	0	0
45783407	1125315	0	0
45786642	1713332	0	0
45694083	1125315	0	0
45785657	40232448	2	3
46241394	705944	0	0
46290618	1125315	0	0
45788415	1125315	0	0
45895667	1129625	0	0
46317289	1115008	0	0
46319419	1125315	0	0
135930	4066995	4	7
21000060	1717327	0	0
4339468	28060	4	4
21600857	967823	3	3
21602484	19128263	2	2
36150803	1307863	0	0
36159618	1177480	0	0
36516772	4146173	4	5
37521122	4108705	2	3
43021226	4084167	3	3
44350683	738818	0	0
45634179	1396131	0	0
44350992	1124957	0	0
45634926	1310149	0	0
45661877	1119510	0	0
45667861	738818	0	0
45647429	1549786	0	0
45698315	1115171	2	3
45698250	1125315	0	0
45683241	1177480	0	0
45708093	19019273	2	3
45778255	1125315	0	0
45783410	1125315	0	0
45786624	1501700	0	0
45694084	1125315	0	0
45785754	1127433	2	3
46241399	1112807	0	0
46290743	1125315	0	0
45788684	1125315	0	0
45895686	1129625	0	0
46311408	1115008	0	0
46319719	1125315	0	0
135930	4048695	4	7
21000080	1728416	0	0
4339468	40481087	4	4
21601077	1595799	3	3
35507491	1119510	0	0
36150844	1129625	0	0
36151162	1112807	0	0
36703477	378419	4	5
37103727	45769019	2	3
43021227	4174876	3	3
44350407	1310149	0	0
45634181	738818	0	0
44350862	1308738	0	0
45634860	1551099	0	0
45661878	1119510	0	0
45667215	1307863	0	0
45647429	19127890	0	0
45698416	19008572	2	3
45698390	1125315	0	0
45683383	1177480	0	0
45705388	40228214	2	3
45778452	1125315	0	0
45783042	1125315	0	0
45786670	1367571	0	0
45694085	1125315	0	0
45785772	43012036	2	3
46241271	967823	0	0
46291113	1125315	0	0
45788682	1125315	0	0
45802609	1129625	0	0
46311519	1115008	0	0
46319318	1125315	0	0
135930	4149245	4	7
21000086	1728416	0	0
4339468	257012	4	4
21505741	1125315	3	3
35507616	1000560	0	0
36150844	1112807	0	0
36151163	1177480	0	0
36503296	40479422	4	5
42805810	19123231	2	3
43053690	4134304	5	5
44350511	1310149	0	0
45634036	1548195	0	0
44351169	1124300	0	0
45634866	1154343	0	0
45661532	1119510	0	0
45667221	933724	0	0
45647409	1124300	0	0
45698119	1539411	2	3
45698393	1125315	0	0
45685244	1177480	0	0
45705350	1107882	2	3
45778453	1125315	0	0
45783326	1125315	0	0
45784872	1115008	0	0
45693847	1125315	0	0
45785777	920300	2	3
46241257	1322184	0	0
46290845	1125315	0	0
45788639	1125315	0	0
45801954	1129625	0	0
46319409	1115008	0	0
46319544	1125315	0	0
135930	4146173	4	6
21000086	1717327	0	0
4212577	134438	4	4
21505741	1129625	3	3
35507618	1713332	0	0
36150845	1174888	0	0
36151126	1124300	0	0
36503296	40479768	4	5
42806153	1545959	2	3
43021226	4174876	4	4
44350517	933724	0	0
45634182	1343916	0	0
44351171	975125	0	0
45634875	1174888	0	0
45661535	1119510	0	0
45667192	1367571	0	0
45647424	1549786	0	0
45698243	40231925	2	3
45698427	1125315	0	0
45685363	1177480	0	0
45705162	40228214	2	3
45778454	1125315	0	0
45783332	1125315	0	0
45784877	1738521	0	0
45694167	1125315	0	0
45785890	1115171	2	3
46238413	1332418	0	0
46242433	1125315	0	0
45788644	1125315	0	0
45801951	1129625	0	0
46313300	1177480	0	0
46319821	1125315	0	0
135930	81151	4	8
21000088	1728416	0	0
4317258	133834	4	4
21505741	738818	3	3
35507621	1125315	0	0
36150847	1112807	0	0
36151129	1149196	0	0
36516781	40479768	4	5
42803460	1127433	2	3
43021226	439406	5	5
44350520	1129625	0	0
45634185	1115008	0	0
44351174	1729720	0	0
45634879	933724	0	0
45661764	1119510	0	0
45667249	738818	0	0
45647424	19127890	0	0
45698557	19133905	2	3
45698234	1125315	0	0
45680229	1177480	0	0
45705334	43012036	2	3
45778433	1125315	0	0
45783447	1125315	0	0
45785005	1192710	0	0
45694168	1125315	0	0
45785985	40229134	2	3
46238413	1545958	0	0
46242410	1125315	0	0
45788655	1125315	0	0
45802045	1129625	0	0
46313436	1177480	0	0
46319705	1125315	0	0
135930	4237458	5	7
21000089	1728416	0	0
4200532	4056621	4	4
21505741	1119510	3	3
35507621	1174888	0	0
36151098	1332418	0	0
36151136	1307863	0	0
36516781	40479422	4	5
42803691	35605482	2	3
43021226	4306014	5	5
44350532	1129625	0	0
45634052	1713332	0	0
44351182	1545958	0	0
45622566	19127904	3	4
45661983	1119510	0	0
45667252	1307863	0	0
45647462	1115008	0	0
45698694	19076374	2	3
45698689	1125315	0	0
45680268	1177480	0	0
45705553	40228214	2	3
45778434	1125315	0	0
45783448	1125315	0	0
45784861	1192710	0	0
45876249	3010813	3	4
46296486	19133905	2	3
46238443	1738521	0	0
46242049	1125315	0	0
46298029	1125315	0	0
45802122	1129625	0	0
46313610	1177480	0	0
46316999	1125315	0	0
135930	4142905	5	7
21000082	1729720	0	0
4200532	198199	4	4
21505741	1192710	3	3
35507613	1125315	0	0
36151057	1177480	0	0
36151138	1717327	0	0
36603422	4149245	4	4
42803733	19018935	2	3
43021226	442116	5	5
44350541	738818	0	0
45634111	1115008	0	0
44351127	1738521	0	0
44782620	4149245	2	4
45661985	1119510	0	0
45667239	967823	0	0
45647469	1521369	0	0
45698338	1551192	2	3
45698571	1125315	0	0
45680086	1177480	0	0
45705384	40174880	2	3
45778435	1125315	0	0
45783449	1125315	0	0
45784869	1174888	0	0
45876249	3023430	3	4
46296486	19133873	2	3
46238496	705944	0	0
46242437	1125315	0	0
46297686	1125315	0	0
45802075	1129625	0	0
46313568	1177480	0	0
46317253	1125315	0	0
135930	40479422	6	7
21000104	1759842	0	0
4200516	4001336	4	4
21600127	914335	3	3
35507441	1119510	0	0
36150876	1153428	0	0
36151145	1738521	0	0
40772935	3014576	4	4
42803752	40174880	2	3
43021226	438614	5	5
44350685	723013	0	0
45634491	1521369	0	0
44350884	975125	0	0
45654264	19127918	2	2
45661979	1119510	0	0
45665489	967823	0	0
45647469	1549786	0	0
45698264	19008572	2	3
45698544	1125315	0	0
45680441	1177480	0	0
45705396	19008572	2	3
45778436	1125315	0	0
45783467	1125315	0	0
45784750	1549786	0	0
45876249	40766240	3	4
46296468	19079524	2	3
46238527	1112807	0	0
46242372	1125315	0	0
46297688	1125315	0	0
45802179	1129625	0	0
46307999	1177480	0	0
46317519	1125315	0	0
135930	40479768	6	7
21000104	1746114	0	0
4200533	4294548	4	4
21500543	1125315	3	3
35507448	1521369	0	0
36151048	1738521	0	0
36151148	975125	0	0
40772935	3013721	4	4
42803609	1551192	2	3
43021226	40486433	5	5
44350529	1112807	0	0
45634491	1549786	0	0
44350885	1124300	0	0
45654264	19128009	2	2
45658264	1119510	0	0
45665499	1124957	0	0
45647511	1717327	0	0
45698341	19133905	2	3
45698462	1125315	0	0
45680311	1177480	0	0
45705518	1107882	2	3
45778437	1125315	0	0
45783368	1125315	0	0
45785018	967823	0	0
45876249	3036780	3	4
46292108	1127433	2	3
46238531	1332418	0	0
46242439	1125315	0	0
46301453	1125315	0	0
45802188	1129625	0	0
46308406	1177480	0	0
46317182	1125315	0	0
135930	4134304	6	9
21000108	1728416	0	0
4318379	4280726	4	4
21500543	708298	3	3
35507452	1738521	0	0
36151031	1177480	0	0
36151151	914335	0	0
40772935	3028833	4	4
42803571	1551192	2	3
43021226	4280726	5	5
44350831	1118084	0	0
45634491	19127890	0	0
44350954	1118084	0	0
45648225	19128009	2	2
45658254	1119510	0	0
45665434	1310149	0	0
45647550	1154343	0	0
45698616	782047	2	3
45698546	1125315	0	0
45680179	1177480	0	0
45705603	40223821	2	3
45778438	1125315	0	0
45783516	1125315	0	0
45785024	1192710	0	0
45876249	40769184	3	4
46292319	40229134	2	3
46238412	1545958	0	0
46242456	1125315	0	0
46301532	1125315	0	0
45802156	1129625	0	0
46308460	1177480	0	0
46317268	1125315	0	0
135930	4230399	7	8
21000108	1746114	0	0
4318379	40486433	4	4
21500543	791967	3	3
35507453	1119510	0	0
36151169	1149196	0	0
36151288	1115008	0	0
40772935	3023103	4	4
42803984	1545959	2	3
43021226	4102123	5	5
44350634	19127890	0	0
45634149	1174888	0	0
44350956	19127890	0	0
45660620	19128009	2	2
45658105	1119510	0	0
45665530	1149196	0	0
45647555	1107830	0	0
45698628	43012036	2	3
45698709	1125315	0	0
45680243	1177480	0	0
45705603	40223834	2	3
45778439	1125315	0	0
45783531	1125315	0	0
45785128	1713332	0	0
45876249	40769179	3	4
46292324	46233710	2	3
46238319	1713332	0	0
46242457	1125315	0	0
46298196	1125315	0	0
45802248	1129625	0	0
46308678	1177480	0	0
46317269	1125315	0	0
444089	440448	5	5
21000082	1713332	0	0
4309188	4266809	4	4
21500731	1192710	3	3
35507461	975125	0	0
36150927	1129625	0	0
36151289	1124957	0	0
40772935	3013682	4	4
42802990	43012036	2	3
43021226	4169137	5	5
44350634	1515774	0	0
45634143	1118084	0	0
44350956	1515774	0	0
45657550	42902245	2	2
45655599	1119510	0	0
45665531	1107830	0	0
45647485	1549786	0	0
45698341	19133873	2	3
45698576	1125315	0	0
45680397	1177480	0	0
45705483	40232448	2	3
45778440	1125315	0	0
46291167	1125315	0	0
45784935	1545958	0	0
45876249	3007461	3	3
46292069	19008572	2	3
46238319	1759842	0	0
46242051	1125315	0	0
46298206	1125315	0	0
45802232	1129625	0	0
46312181	1177480	0	0
500002101	4296204	3	3
73553	78272	2	5
21000082	1768849	0	0
4171379	45769019	4	4
21500731	1308738	3	3
35507466	1119510	0	0
36150928	1115008	0	0
36151292	1192710	0	0
36516825	4066995	5	5
42802998	19077344	2	3
43021226	4304110	5	5
44350634	1549786	0	0
45634396	1521369	0	0
44350956	1549786	0	0
45659221	19019273	2	3
45655685	1119510	0	0
45665508	1115008	0	0
45647485	19127890	0	0
45698799	40232448	2	3
45698592	1125315	0	0
45680498	1177480	0	0
45705466	40232448	2	3
45778443	1125315	0	0
46291177	1125315	0	0
45785045	975125	0	0
45876249	3015076	3	3
46292122	19018935	2	3
46238535	1309944	0	0
46242140	1125315	0	0
46298219	1125315	0	0
45799462	1129625	0	0
46312201	1177480	0	0
46310013	1545959	2	3
443883	198809	2	3
21000090	1728416	0	0
4214956	4324181	4	4
21500731	967823	3	3
35507466	738818	0	0
36150842	1322184	0	0
36151270	1149196	0	0
36516825	4059173	5	5
42805711	19019273	2	3
43021226	4048169	5	5
44350530	1713332	0	0
45634398	1124957	0	0
44350969	723013	0	0
45659173	40174880	2	3
45655693	1119510	0	0
45665536	1539403	0	0
45647485	1521369	0	0
45698654	19018935	2	3
45698596	1125315	0	0
45680615	1177480	0	0
45705540	19078924	2	3
45778457	1125315	0	0
46291860	1125315	0	0
45785049	1713332	0	0
45876249	3014599	3	3
46292371	40174880	2	3
46238610	1332418	0	0
46242142	1125315	0	0
46298130	1125315	0	0
45799551	1129625	0	0
46312436	1177480	0	0
46316216	1332419	2	3
440921	40479768	6	7
21000061	1728416	0	0
4213310	378419	4	4
21500731	1595799	3	3
35507475	914335	0	0
36150898	1343916	0	0
36151279	1741122	0	0
36516825	4278672	5	5
37522278	4107731	2	3
43021226	4302207	5	5
44350648	1129625	0	0
45634399	738818	0	0
44350971	1124957	0	0
45657202	40232448	2	3
45655700	1119510	0	0
45665445	1501700	0	0
45647491	1500211	0	0
45698667	19008572	2	3
45698364	1125315	0	0
45676675	1177480	0	0
45705505	19057271	2	3
45778458	1125315	0	0
46291572	1125315	0	0
45785050	1000560	0	0
45876249	3006734	3	3
46292216	43012036	2	3
46238399	1309944	0	0
46242223	1125315	0	0
46298169	1125315	0	0
45799490	1129625	0	0
46308815	1177480	0	0
46305102	1332419	2	3
75909	4134304	6	6
21000104	1778162	0	0
4195979	4163874	4	4
21500731	1396131	3	3
35507578	1000560	0	0
36150933	705944	0	0
36151279	1746114	0	0
36516825	4048695	5	5
42803511	1545959	2	3
43021226	4139681	5	5
44350650	1112807	0	0
45634187	1107830	0	0
44351029	1309944	0	0
45657349	19073183	2	3
45655702	1119510	0	0
45665604	1549786	0	0
45647577	1154343	0	0
45698814	1115171	2	3
45698855	1125315	0	0
45677035	1177480	0	0
45705575	19078924	2	3
45778460	1125315	0	0
46291583	1125315	0	0
45784880	715997	0	0
45876249	3002385	3	3
46292404	19077344	2	3
46238344	1192710	0	0
46242086	1125315	0	0
46298237	1125315	0	0
45799529	1129625	0	0
46303280	1177480	0	0
45675371	1332419	2	3
440921	40480160	6	6
21000105	1746114	0	0
4199402	40486433	7	9
4187630	4163874	6	6
35507585	1125315	0	0
36150936	1738521	0	0
36152157	1000560	0	0
36516728	4230399	5	5
42803589	1545959	2	3
43021226	433644	6	6
44350522	1729720	0	0
45634123	1192710	0	0
44351150	1713332	0	0
45657234	40223834	2	3
45655708	1119510	0	0
45665604	19127890	0	0
45647498	1501700	0	0
45697480	19076374	2	3
45697794	1125315	0	0
45679691	1177480	0	0
45705710	40174880	2	3
45778403	1125315	0	0
46291795	1125315	0	0
45784883	1521369	0	0
45876249	3008598	3	3
46292437	40236824	2	3
46238551	1332418	0	0
46242354	1125315	0	0
46298147	1125315	0	0
45799441	1129625	0	0
46303795	1177480	0	0
45650798	1539411	2	3
372887	4043241	5	6
21000105	1717327	0	0
4199402	260139	7	7
4162282	258780	6	6
35507585	1174888	0	0
36150937	1177480	0	0
36152438	1112807	0	0
36702254	378001	5	5
42805950	19019273	2	3
43021226	37017711	6	6
44350523	1192710	0	0
45634127	1332418	0	0
44351150	1759842	0	0
45657154	40228230	2	3
45655767	1119510	0	0
45665688	1501700	0	0
45647691	1149196	0	0
45697481	40223834	2	3
45697788	1125315	0	0
45679692	1177480	0	0
45705566	40228214	2	3
45778368	1125315	0	0
46292019	1125315	0	0
45785145	1112807	0	0
45876249	3009542	3	3
46287913	19008572	2	3
46238577	1112807	0	0
46242491	1125315	0	0
46298339	1125315	0	0
45799536	1129625	0	0
46303682	1177480	0	0
46319805	1539411	2	3
440921	4237458	5	6
21000083	1729720	0	0
4199402	4048171	8	10
4030781	4330583	6	6
35507491	738818	0	0
36156419	1000560	0	0
36152161	1549786	0	0
36516772	40479768	5	6
42802921	1107882	2	3
43021226	4048171	6	6
44350523	1112807	0	0
45634336	738818	0	0
44351151	1115008	0	0
45657268	19078924	2	3
45655750	1119510	0	0
45665639	1107830	0	0
45647558	1124957	0	0
45697495	19008572	2	3
45695167	1125315	0	0
45679552	1177480	0	0
45702004	40229134	2	3
45778354	1125315	0	0
46291478	1125315	0	0
45785214	1501700	0	0
45876249	3027231	3	3
46242790	19077572	2	3
46238608	1548195	0	0
46242499	1125315	0	0
46298358	1125315	0	0
45799638	1129625	0	0
46303655	1177480	0	0
46309108	1539411	2	3
440921	4230399	5	7
21000061	1717327	0	0
4199402	40479422	8	9
138239	4134304	6	7
35507421	1115008	0	0
36156552	742185	0	0
36152162	1129625	0	0
36516772	4278672	5	6
42819961	1107882	2	3
43021226	4240902	6	6
44350845	933724	0	0
45634241	738818	0	0
44351159	1717327	0	0
45657030	19008572	2	3
45655729	1119510	0	0
45665851	1110410	0	0
45647585	1192710	0	0
45697500	1551192	2	3
45695221	1125315	0	0
45677191	1177480	0	0
45702017	43012036	2	3
45778355	1125315	0	0
46291493	1125315	0	0
45784901	1124957	0	0
45876249	3026361	3	3
46243140	40229134	2	3
46238409	1112807	0	0
46242547	1125315	0	0
46298361	1125315	0	0
45799600	1129625	0	0
46303823	1177480	0	0
46320157	19127922	1	2
77960	4134304	5	7
21000090	723013	0	0
4336464	4336464	0	0
138239	4230399	6	7
35507623	975125	0	0
36156641	1343916	0	0
36152436	1539403	0	0
36516772	4149245	5	6
42806145	19078461	2	3
43021226	4219399	6	6
44350652	740275	0	0
45634300	975125	0	0
44352247	1326303	0	0
45657287	40163554	2	3
45655938	1119510	0	0
45665581	1174888	0	0
45647568	1717327	0	0
45695148	19077572	2	3
45695169	1125315	0	0
45677211	1177480	0	0
45702177	1115171	2	3
45778356	1125315	0	0
46291678	1125315	0	0
45785244	1115008	0	0
45876249	3051031	3	3
46243067	40229134	2	3
46238671	1149196	0	0
46242517	1125315	0	0
46298382	1125315	0	0
45796661	1129625	0	0
46301068	1177480	0	0
46320157	19129144	1	2
75909	4230399	5	5
21000092	1746114	0	0
4301346	4301346	0	0
138239	81151	6	7
21604795	715997	0	0
36156429	708298	0	0
36152168	1149196	0	0
36703500	378419	5	7
42803276	19075601	2	3
43021227	37017711	5	5
44350713	1115008	0	0
45634302	1589505	0	0
44352254	1713332	0	0
45657388	19076374	2	3
44348409	1119510	0	0
45665710	1322184	0	0
45647701	1110410	0	0
45695155	19126352	2	3
45695171	1125315	0	0
45677284	1177480	0	0
45701914	19133905	2	3
45778357	1125315	0	0
46291947	1125315	0	0
45784836	933724	0	0
45876249	3009201	3	3
46243015	1545959	2	3
46238635	1115008	0	0
46242356	1125315	0	0
46298545	1125315	0	0
45796848	1129625	0	0
46301735	1177480	0	0
46320157	19133679	1	2
3050940	3000963	5	5
21000093	1778162	0	0
4216130	4216130	0	0
4199402	45769019	6	7
21604797	757627	0	0
36156454	1177480	0	0
36152284	738818	0	0
36503296	78272	5	7
42805927	1332419	2	3
43021227	4240902	5	5
44350902	738818	0	0
45634302	1549786	0	0
44352359	1118084	0	0
45657121	19008572	2	3
44348200	1119510	0	0
45665601	1367571	0	0
45647698	1154343	0	0
45695158	19008572	2	3
45695208	1125315	0	0
45674273	1177480	0	0
45702099	19008572	2	3
45778363	1125315	0	0
46291702	1125315	0	0
45785245	1343916	0	0
45876249	3021226	3	3
46243056	42707627	2	3
46238418	1137529	0	0
46242548	1125315	0	0
46298297	1125315	0	0
45796854	1129625	0	0
46301149	1177480	0	0
46320595	40221415	1	2
440142	313217	4	5
21000092	1717327	0	0
4198190	4198190	0	0
4199402	28060	6	7
21604794	836654	0	0
36156642	1545958	0	0
36152286	1177480	0	0
36703500	375671	5	8
42803513	40228214	2	3
43021227	4219399	5	5
44350904	1149196	0	0
45634501	1115008	0	0
44352365	1310149	0	0
45657164	35605482	2	3
44348413	1119510	0	0
45665523	1551099	0	0
45647800	1115008	0	0
45695222	19019273	2	3
45695209	1125315	0	0
45673635	1177480	0	0
45702194	1107882	2	3
45778364	1125315	0	0
46295775	1125315	0	0
45785248	1549786	0	0
45876249	3001247	3	3
46243119	1107882	2	3
46238511	715997	0	0
46242549	1125315	0	0
46298335	1125315	0	0
45797100	1129625	0	0
46313571	1177480	0	0
46315949	19129144	1	2
140190	4066995	4	5
21000092	1778162	0	0
21000302	1728416	0	0
4199402	40481087	6	8
21604799	701322	0	0
36156433	1713332	0	0
36152288	1107830	0	0
36516972	4134304	5	8
42803555	19078461	2	3
43021227	433644	5	5
44350546	738818	0	0
45634346	1115008	0	0
44351817	738818	0	0
45657124	19019273	2	3
44348416	1119510	0	0
45665736	1000560	0	0
45647708	1192710	0	0
45695224	19008572	2	3
45695282	1125315	0	0
45674287	1177480	0	0
45702113	40165015	2	3
45778461	1125315	0	0
46295785	1125315	0	0
45785248	19127890	0	0
45876249	3006451	3	3
46240800	40224805	2	3
46238695	1192710	0	0
46239602	1125315	0	0
46289695	1125315	0	0
45796889	1129625	0	0
46313809	1177480	0	0
46315949	19127922	1	2
140190	4048695	4	5
21000130	1728416	0	0
21000303	1728416	0	0
4199402	317576	6	8
21500972	19008572	4	5
36155334	1545958	0	0
36152291	1177480	0	0
36516972	40479422	5	8
42805999	1545959	2	3
43021227	4048171	5	5
44350557	1112807	0	0
45634311	791967	0	0
44351995	1549786	0	0
45657307	19073188	2	3
45651975	1119510	0	0
45665525	967823	0	0
45647810	1759842	0	0
45695200	35605482	2	3
45695503	1125315	0	0
45671104	1177480	0	0
45702187	19019273	2	3
45778423	1125315	0	0
46295795	1125315	0	0
45785135	914335	0	0
45876249	3000876	3	3
46240949	40229134	2	3
46238703	1149380	0	0
46239606	1125315	0	0
46289859	1125315	0	0
45797056	1129625	0	0
46313800	1177480	0	0
46315949	19133679	1	2
4000610	4166224	4	5
21000062	1728416	0	0
21000304	1728416	0	0
4180627	40492359	6	8
21500803	40163554	4	5
36155339	1729720	0	0
36152388	1149380	0	0
36516972	40479768	5	8
37502344	4242997	2	4
43021227	4048169	4	4
44350717	1110410	0	0
45634574	705944	0	0
44351995	1521369	0	0
45657061	1115171	2	3
45652232	1119510	0	0
45665555	1149196	0	0
45647814	1729720	0	0
45695226	1115171	2	3
45695283	1125315	0	0
45670916	1177480	0	0
45702044	40162522	2	3
45778424	1125315	0	0
46244852	1125315	0	0
45784839	1124957	0	0
45876249	3001488	3	3
46241100	40236446	2	3
46238489	1112807	0	0
46239737	1125315	0	0
46289864	1125315	0	0
45797176	1129625	0	0
46314534	1177480	0	0
45650604	46275916	1	1
134057	313217	4	5
21000084	1728416	0	0
21000305	1728416	0	0
4309188	4285898	6	7
21500027	46233710	4	5
36155447	1589505	0	0
36152405	1551099	0	0
36516972	4152936	5	7
40236438	40236446	1	1
43021227	4169137	4	4
44350721	1713332	0	0
45634450	975125	0	0
44352000	920293	0	0
45657340	1545959	2	3
45649333	1119510	0	0
45665720	715997	0	0
45647765	1729720	0	0
45695403	40163554	2	3
45695321	1125315	0	0
45671121	1177480	0	0
45703562	1107882	2	3
45778425	1125315	0	0
46244864	1125315	0	0
45784840	1149196	0	0
45876249	3012494	3	3
46240917	40236446	2	3
46238386	1501700	0	0
46239721	1125315	0	0
46289865	1125315	0	0
45794135	1129625	0	0
46314792	1177480	0	0
45650855	46275916	1	1
3050940	3014576	4	5
21000140	1728416	0	0
21000306	1728416	0	0
255919	375671	6	8
21500027	46233988	4	5
36155565	738818	0	0
36152406	1551099	0	0
36516972	4109685	5	6
40163553	40163554	1	1
43021227	4304110	4	4
44350726	738818	0	0
45634454	1307863	0	0
44352002	1545958	0	0
45657461	19008572	2	3
45649574	1119510	0	0
45665630	1746114	0	0
45647810	1713332	0	0
45695421	40232448	2	3
45695416	1125315	0	0
45671258	1177480	0	0
45699132	19008572	2	3
45778426	1125315	0	0
46244994	1125315	0	0
45784841	967823	0	0
45876249	3024731	3	3
46240988	19133905	2	3
46238479	1112807	0	0
46239628	1125315	0	0
46290025	1125315	0	0
45794147	1129625	0	0
46315053	1177480	0	0
46300762	19059056	2	3
3050940	3019550	4	5
21000084	1729720	0	0
21000375	975125	0	0
4176642	4043071	5	5
21501038	1125315	4	4
36155568	1154343	0	0
36151398	738818	0	0
36703532	375671	7	9
37521369	4330583	1	1
43021227	4302207	4	4
44350745	1589505	0	0
45634579	1549786	0	0
44352155	1515774	0	0
45657462	19008572	2	3
44337690	1125315	0	0
45665630	1741122	0	0
45647945	738818	0	0
45695269	19077572	2	3
45695384	1125315	0	0
45671127	1177480	0	0
45699097	1115171	2	3
45778429	1125315	0	0
46244989	1125315	0	0
45784955	1192710	0	0
45876249	3049273	3	3
46240641	40229134	2	3
46238726	1521369	0	0
46239631	1125315	0	0
46290167	1125315	0	0
45794759	1129625	0	0
46308878	1177480	0	0
46301062	40236824	2	3
3050940	3015632	4	5
21000094	1759842	0	0
21000408	1551099	0	0
4176642	4181917	5	5
21502709	40169281	4	4
36155578	1539403	0	0
36151496	738818	0	0
40772948	3001488	7	7
37521136	4108705	1	1
43021227	4280726	4	4
44350750	1729720	0	0
45634579	1589505	0	0
44352155	19127890	0	0
45655371	40232448	2	3
44337601	1125315	0	0
45665632	1110410	0	0
45647738	738818	0	0
45695433	40223768	2	3
45695423	1125315	0	0
45671301	1177480	0	0
45699162	1127433	2	3
45778430	1125315	0	0
46290990	1125315	0	0
45784890	1738521	0	0
45876249	3013721	3	6
46240851	40232448	2	3
46238726	1549786	0	0
46240262	1125315	0	0
46290333	1125315	0	0
45794330	1129625	0	0
46308965	1177480	0	0
46301067	19008572	2	3
3050940	3045716	4	5
21000094	1717327	0	0
21000375	1551099	0	0
4176642	4202451	5	5
21500044	1308738	4	4
36155437	1129625	0	0
36151432	975125	0	0
36403239	4144583	7	7
37521342	4163971	1	1
43021227	439406	4	4
44350941	1192710	0	0
45634638	1192710	0	0
45637632	1125315	0	0
45655266	40228214	2	3
44337873	1125315	0	0
45665854	1107830	0	0
45647746	740275	0	0
45691785	1115171	2	3
45695371	1125315	0	0
45671369	1177480	0	0
45699067	19129655	2	3
45778431	1125315	0	0
46291522	1125315	0	0
45785137	1192710	0	0
45876249	3013682	3	6
46240075	19059056	2	3
46238727	1192710	0	0
46240273	1125315	0	0
46290133	1125315	0	0
45794332	1129625	0	0
46309031	1177480	0	0
46300878	1545959	2	3
133468	4149245	4	6
21000141	1729720	0	0
21000436	1551099	0	0
141960	133834	5	5
21500837	1713671	4	4
36155438	738818	0	0
36151602	1129625	0	0
36403241	4144583	7	7
37521353	4242997	1	1
43021227	4102123	4	4
44350854	1332418	0	0
45634641	1000560	0	0
45637596	1125315	0	0
45655474	40232448	2	3
44778195	1125315	0	0
45665841	1713332	0	0
45647793	1738521	0	0
45692274	19078461	2	3
45695444	1125315	0	0
45671089	1177480	0	0
45699148	19133768	2	3
45778432	1125315	0	0
46291715	1125315	0	0
45785077	1545958	0	0
45876249	3006923	3	6
46240073	19077572	2	3
46238728	1153428	0	0
46240237	1125315	0	0
46289941	1125315	0	0
45791837	1129625	0	0
46309205	1177480	0	0
46301663	40162522	2	3
440921	4059173	4	6
21000096	1746114	0	0
21506108	1307863	2	2
255919	381316	5	5
21500093	1305058	4	4
36155439	738818	0	0
36151439	1107830	0	0
36516781	80180	1	2
43012692	43012433	1	1
43021227	438614	4	4
44350916	967823	0	0
45634687	1154343	0	0
45637640	1125315	0	0
45654127	40223834	2	3
44778271	1125315	0	0
45665657	1102527	0	0
45647835	738818	0	0
45692185	1545959	2	3
45695374	1125315	0	0
45671303	1177480	0	0
45699244	19075001	2	3
45778323	1125315	0	0
46242754	1125315	0	0
45785084	1192710	0	0
45876249	3024561	3	6
46240165	19133905	2	3
46238735	1107830	0	0
46240242	1125315	0	0
46289407	1125315	0	0
45788986	1129625	0	0
46309370	1177480	0	0
46301740	1115171	2	3
3039757	3000963	4	4
21000113	1728416	0	0
21506110	1332418	2	2
4187630	4324181	5	5
21500093	742185	4	4
36155440	738818	0	0
36151603	1149196	0	0
37502353	4125906	7	7
43012693	43012433	1	1
43021227	4139681	4	4
44350927	1124300	0	0
45634430	975125	0	0
45637684	1125315	0	0
45653980	35605482	2	3
44778153	1125315	0	0
45665664	1107830	0	0
45647820	1332418	0	0
45692372	19126352	2	3
45695303	1125315	0	0
45671409	1177480	0	0
45699352	1127433	2	3
45778524	1125315	0	0
46242680	1125315	0	0
45785087	1549786	0	0
45876249	3020630	3	6
46240165	19133873	2	3
45897488	1326303	0	0
45896245	1125315	0	0
46290026	1125315	0	0
45789148	1129625	0	0
46303855	1177480	0	0
46301200	40229134	2	3
440921	4296204	4	4
21000114	1728416	0	0
21500121	1551099	2	2
4185503	317576	5	5
21500936	1124300	4	4
36155328	1129625	0	0
36151501	715997	0	0
37000000	45769019	7	7
43012694	43012433	1	1
43021227	4306014	4	4
44351060	1545958	0	0
45634433	1107830	0	0
45637673	1125315	0	0
45654025	19074843	2	3
44778240	1125315	0	0
45663141	1551099	0	0
45647822	1107830	0	0
45692297	1115171	2	3
45692129	1125315	0	0
45671440	1177480	0	0
45699524	1115171	2	3
45778540	1125315	0	0
46242683	1125315	0	0
45785087	1589505	0	0
45876249	3016723	3	6
46238284	40228230	2	3
45897456	1174888	0	0
45896211	1125315	0	0
46290196	1125315	0	0
46302141	1129625	0	0
46307065	1177480	0	0
46301270	19133873	2	3
73553	40479422	4	4
21000083	1778162	0	0
21500121	975125	2	2
4185503	258780	5	5
21500936	1129625	4	4
36155415	738818	0	0
36151502	1124957	0	0
36303153	378001	8	12
43012697	43012433	1	1
43021227	442116	4	4
44351070	1118084	0	0
45634517	1501700	0	0
45637847	1125315	0	0
45654169	19008572	2	3
44778219	1125315	0	0
45663227	723013	0	0
45647842	1124300	0	0
45692142	40232448	2	3
45692218	1125315	0	0
45669802	1177480	0	0
45695932	40232448	2	3
45778535	1125315	0	0
46242767	1125315	0	0
45785088	1107830	0	0
45876249	3027970	3	6
46238272	1115171	2	3
45897495	1192710	0	0
45896316	1125315	0	0
46290270	1125315	0	0
46301986	1129625	0	0
46304070	1177480	0	0
46301401	19008572	2	3
73553	40479768	4	4
21000110	1746114	0	0
21500101	1500211	2	2
4185503	321042	5	5
21500936	1738521	4	4
36155401	1118084	0	0
36151645	1112807	0	0
36303153	133834	9	11
43012753	43012754	1	1
43021227	40486433	4	4
44351071	1129625	0	0
45634276	1124957	0	0
45637687	1125315	0	0
45647443	19008572	2	3
44357930	1125315	0	0
45663231	738818	0	0
45644496	1174888	0	0
45692379	40228230	2	3
45692089	1125315	0	0
45669786	1177480	0	0
45778418	1177480	0	0
45778465	1125315	0	0
46242769	1125315	0	0
45784852	742185	0	0
45876249	3006906	3	6
46238428	19008572	2	3
45897557	705944	0	0
45896304	1125315	0	0
46290271	1125315	0	0
46301816	1129625	0	0
46304328	1177480	0	0
46301507	19073183	2	3
3050940	3006906	4	4
21000110	1759842	0	0
21500144	19128022	2	2
138239	4155034	5	5
21500936	1149380	4	4
36155599	1551099	0	0
36151519	1589505	0	0
36303153	4302207	7	8
42889344	4102123	1	1
43531054	195588	2	2
44351072	1500211	0	0
45634415	967823	0	0
45637809	1125315	0	0
45647426	19078461	2	3
44357939	1125315	0	0
45663302	1738521	0	0
45644478	1539403	0	0
45694831	19078461	2	3
45692348	1125315	0	0
45669919	1177480	0	0
45778421	1177480	0	0
45778466	1125315	0	0
46242773	1125315	0	0
45785197	1153428	0	0
45876249	3004501	3	6
46238246	19133905	2	3
45897544	1713332	0	0
45896361	1125315	0	0
46290237	1125315	0	0
46298967	1129625	0	0
46304246	1177480	0	0
46301418	19008572	2	3
3050940	3020630	4	4
21000115	1728416	0	0
21500144	19128009	2	2
4030654	4163971	5	5
21500936	1396131	4	4
36155356	738818	0	0
36151525	1501700	0	0
36303153	4149245	7	11
42889648	4132546	1	1
44784105	4109685	2	2
44351079	1112807	0	0
45634526	738818	0	0
45637909	1125315	0	0
45647462	1115171	2	3
44358972	1125315	0	0
45663314	1515774	0	0
45644673	1149196	0	0
45689107	40232448	2	3
45692363	1125315	0	0
45781124	1177480	0	0
45778420	1177480	0	0
45778467	1125315	0	0
46242853	1125315	0	0
45785202	1174888	0	0
45876249	3035995	3	6
45897265	19059056	2	3
45897559	1521369	0	0
45896278	1125315	0	0
46290247	1125315	0	0
46298805	1129625	0	0
46304098	1177480	0	0
46319235	40229134	2	3
3050940	3013721	4	4
21000085	1728416	0	0
21500144	42902245	2	2
4179873	4043241	7	7
21500936	975125	4	4
36155369	738818	0	0
36151445	1149380	0	0
36314535	4015189	0	0
42889655	4218389	1	1
44784105	81151	2	2
44351064	975125	0	0
45634363	1326303	0	0
45637700	1125315	0	0
45647550	1154615	2	3
44358976	1125315	0	0
45663314	19127890	0	0
45644596	1115008	0	0
45689299	19019273	2	3
45692366	1125315	0	0
45781365	1177480	0	0
45778497	1177480	0	0
45778468	1125315	0	0
46242688	1125315	0	0
45785207	1332418	0	0
45876249	3023103	3	7
45897218	19133905	2	3
45897559	1549786	0	0
45896339	1125315	0	0
46290283	1125315	0	0
46301505	1129625	0	0
46320445	1177480	0	0
46319259	40174880	2	3
3050940	3027970	4	4
21000083	1717327	0	0
21500144	19128263	2	2
21500408	1177480	3	3
21500936	1343916	4	4
36155525	1124957	0	0
36151449	738818	0	0
36316010	4052083	0	0
40080661	42707627	1	1
44359428	42902245	2	2
44350796	1129625	0	0
45634369	1149196	0	0
45637702	1125315	0	0
45647554	19008572	2	3
44359058	1125315	0	0
45663314	1549786	0	0
45644551	1545958	0	0
45689162	40229134	2	3
45692284	1125315	0	0
45781314	1177480	0	0
45778419	1177480	0	0
45778265	1125315	0	0
46242888	1125315	0	0
45784942	1115008	0	0
45876249	3014576	3	7
45897348	40232448	2	3
45897578	1545958	0	0
45896400	1125315	0	0
46290255	1125315	0	0
46301646	1129625	0	0
46320472	1177480	0	0
46319652	40231925	2	3
3050940	3004501	4	4
21000099	1746114	0	0
21500144	19128065	2	2
21500408	967823	3	3
21500936	1192710	4	4
36155386	1107830	0	0
36151454	1192710	0	0
36316018	4133840	0	0
40228550	40231925	1	1
44359381	42902245	2	2
44350805	1107830	0	0
45634621	933724	0	0
45637952	1125315	0	0
45647613	40232448	2	3
44359136	1125315	0	0
45663317	1107830	0	0
45644524	920293	0	0
45689397	40174880	2	3
45692299	1125315	0	0
45781655	1177480	0	0
45780671	1177480	0	0
45778365	1125315	0	0
46242962	1125315	0	0
45785223	1326303	0	0
45876249	3015632	3	7
45897191	19008572	2	3
45897628	1154343	0	0
45896537	1125315	0	0
46290258	1125315	0	0
46301851	1129625	0	0
46320593	1177480	0	0
46320058	40229134	2	3
3050940	3035995	4	4
21000100	1778162	0	0
21500144	19127918	2	2
21503967	1110410	3	3
21500936	967823	4	4
36155343	1107830	0	0
36151542	1177480	0	0
36314511	4024958	0	0
40080069	19079524	1	1
44352265	19129144	2	2
44351056	1149196	0	0
45634622	1738521	0	0
45634669	1125315	0	0
45647689	19008572	2	3
44358851	1125315	0	0
45663390	1557272	0	0
45644636	1589505	0	0
45689398	19008572	2	3
45692264	1125315	0	0
45781626	1177480	0	0
45706950	1177480	0	0
45778366	1125315	0	0
46242724	1125315	0	0
45784971	1713332	0	0
45876249	3019550	3	7
45897424	1127433	2	3
45897517	1192710	0	0
45896436	1125315	0	0
46290329	1125315	0	0
46299623	1129625	0	0
46320712	1177480	0	0
46320438	40232448	2	3
3050940	3006923	4	4
21000103	1746114	0	0
21500144	19127904	2	2
21503967	1112807	3	3
21501117	19079524	5	6
36155377	723013	0	0
36151533	1729720	0	0
36316088	4163872	0	0
43012036	43012036	0	0
44352265	19127922	2	2
44351058	1129625	0	0
45634626	1551099	0	0
45634726	1125315	0	0
45647698	1154615	2	3
44358978	1125315	0	0
45663187	1367571	0	0
45644636	19127890	0	0
45689073	40231925	2	3
45692055	1125315	0	0
45778905	1177480	0	0
45706925	1177480	0	0
45778487	1125315	0	0
46242823	1125315	0	0
45784983	791967	0	0
45876249	3045716	3	7
45897411	40232448	2	3
45897634	967823	0	0
45896457	1125315	0	0
46291542	1125315	0	0
46295704	1129625	0	0
46321012	1177480	0	0
46319953	1127433	2	3
3050940	3024561	4	4
21000083	1768849	0	0
21500144	40221415	2	2
21503967	1125315	3	3
21604253	40231925	5	6
36155552	1539403	0	0
36151608	1177480	0	0
36315243	4234705	0	0
42806018	791967	0	0
44352265	19133679	2	2
44350810	1322184	0	0
45634628	1551099	0	0
45634730	1125315	0	0
45647800	1115171	2	3
44359179	1125315	0	0
45663307	1000560	0	0
45644636	1549786	0	0
45689367	40231925	2	3
45692058	1125315	0	0
45779106	1177480	0	0
45706967	1177480	0	0
45778511	1125315	0	0
46242872	1125315	0	0
45785100	1332418	0	0
45876249	3000963	3	7
45895004	45892894	2	3
45897746	1332418	0	0
45896459	1125315	0	0
46291544	1125315	0	0
46295706	1129625	0	0
46314902	1177480	0	0
46320233	19059056	2	3
443783	258780	4	4
21000110	1778162	0	0
4274025	439777	2	2
21503967	1154029	3	3
21500001	19073188	5	6
36155660	1000560	0	0
36151699	967823	0	0
40769184	40769184	0	0
42806042	1713332	0	0
44358755	1115171	2	3
44351185	1177480	0	0
45634386	1174888	0	0
45634552	1125315	0	0
45647766	1127433	2	3
44358336	1125315	0	0
45663298	1309944	0	0
45644386	914335	0	0
45689568	1115171	2	3
45692138	1125315	0	0
45779188	1177480	0	0
45706968	1177480	0	0
45780612	1125315	0	0
46242804	1125315	0	0
45785106	967823	0	0
45885344	80502	4	4
45894948	19132304	2	3
45897641	975125	0	0
45896468	1125315	0	0
46291800	1125315	0	0
46296032	1129625	0	0
46314194	1177480	0	0
46313830	43012036	2	3
75909	4278672	4	4
21000169	975125	0	0
21500130	1515774	2	2
21500454	738818	3	3
21500001	19129655	5	6
36155663	1177480	0	0
36151411	1115008	0	0
40769189	40769189	0	0
42806048	723013	0	0
44358891	920334	2	3
44348371	1129625	0	0
45634711	738818	0	0
45634754	1125315	0	0
45648040	40232448	2	3
44358327	1125315	0	0
45663319	967823	0	0
45644560	1192710	0	0
45686296	40232448	2	3
45694662	1125315	0	0
45779128	1177480	0	0
45707140	1177480	0	0
45780461	1125315	0	0
46242975	1125315	0	0
45785058	1112807	0	0
45885344	4035415	4	4
45895189	42707627	2	3
45897647	19002770	0	0
45896622	1125315	0	0
46241845	1125315	0	0
46295669	1129625	0	0
46317375	1177480	0	0
46313837	42707627	2	3
75865	195588	4	4
21000083	1728416	0	0
21500130	19054876	2	2
21500454	1129625	3	3
21500001	19133905	5	6
36155491	738818	0	0
36151413	19127890	0	0
40769194	40769194	0	0
42806106	1177480	0	0
44359196	19133905	2	3
44348510	1713332	0	0
45634714	1124957	0	0
45637094	1125315	0	0
45647931	19008572	2	3
44358529	1125315	0	0
45663321	1551099	0	0
45645909	1118084	0	0
45686301	1127433	2	3
45694621	1125315	0	0
45777982	1177480	0	0
45707156	1177480	0	0
45780523	1125315	0	0
46242738	1125315	0	0
45785237	975125	0	0
45885344	4134304	8	9
45894960	40236824	2	3
45897807	1118084	0	0
45893839	1125315	0	0
46241955	1125315	0	0
46295324	1129625	0	0
46315157	1177480	0	0
46313731	19018935	2	3
31821	4144583	4	4
21000148	1738521	0	0
21500130	1548195	2	2
21500454	1000560	3	3
21500001	19073183	5	6
36155495	1310149	0	0
36151413	1549786	0	0
40169216	40169216	0	0
42806078	701322	0	0
44359200	1551192	2	3
44348510	1759842	0	0
45634689	19003953	0	0
45637162	1125315	0	0
45644499	19059056	2	3
44358531	1125315	0	0
45663407	1124300	0	0
45646108	1539403	0	0
45686228	1127433	2	3
45694622	1125315	0	0
45707831	1177480	0	0
45707215	1177480	0	0
45706951	1125315	0	0
46242923	1125315	0	0
45785239	1153428	0	0
45885344	78272	8	9
45894973	40236824	2	3
45897772	1174888	0	0
45893930	1125315	0	0
46241958	1125315	0	0
46295693	1129625	0	0
46304516	1177480	0	0
46314075	40229134	2	3
9201	9201	0	0
21000174	975125	0	0
21500130	1589505	2	2
21500363	1154343	3	3
21500001	19133873	5	6
36155496	1545958	0	0
36151637	1192710	0	0
40169281	40169281	0	0
42806081	967823	0	0
44352057	1551192	2	3
44348520	1308738	0	0
45634289	1124300	0	0
45637120	1125315	0	0
45644596	19019273	2	3
44358428	1125315	0	0
45663453	1149196	0	0
45645868	1500211	0	0
45686283	40174880	2	3
45689281	1125315	0	0
45707821	1177480	0	0
45707293	1177480	0	0
45707069	1125315	0	0
46242925	1125315	0	0
45785240	1332418	0	0
45885344	4230399	7	8
45895069	40231925	2	3
45897595	1713332	0	0
45893943	1125315	0	0
46241961	1125315	0	0
46295996	1129625	0	0
46304867	1177480	0	0
46314785	40162522	2	3
9202	9202	0	0
21000116	1729720	0	0
21500130	1500211	2	2
21500363	1149380	3	3
21500001	1713671	5	6
36155497	914335	0	0
36151424	738818	0	0
37521795	4337138	0	0
42806174	1308738	0	0
44352336	46275916	2	3
44348480	1322184	0	0
45634394	1000560	0	0
45637311	1125315	0	0
45644672	19008572	2	3
44358433	1125315	0	0
45663397	715997	0	0
45646112	1124300	0	0
45686375	920334	2	3
45689291	1125315	0	0
45704686	1177480	0	0
45707144	1177480	0	0
45707138	1125315	0	0
46242927	1125315	0	0
45785068	975125	0	0
45885344	4146173	5	6
45895211	40232448	2	3
45897597	1107830	0	0
45893838	1125315	0	0
46241965	1125315	0	0
46296181	1129625	0	0
46321539	1177480	0	0
46314456	43012036	2	3
9203	9203	0	0
19006318	19006318	0	0
21500130	19127890	2	2
21500363	1137529	3	3
21500001	46275444	5	6
36155499	1154343	0	0
36151739	914335	0	0
37521796	4323902	0	0
42806179	1177480	0	0
44355208	40232448	2	3
44348419	1124300	0	0
45631207	1149196	0	0
45637312	1125315	0	0
45646138	19075601	2	3
44358396	1125315	0	0
45663398	1153428	0	0
45646138	1322184	0	0
45686437	19008572	2	3
45689040	1125315	0	0
45704930	1177480	0	0
45707083	1177480	0	0
45707080	1125315	0	0
46243039	1125315	0	0
45786594	1326303	0	0
45885344	81151	5	8
45895197	43012036	2	3
45897642	1717327	0	0
45894024	1125315	0	0
46241968	1125315	0	0
46295649	1129625	0	0
46321127	1177480	0	0
46314512	40236446	2	3
1512674	1512674	0	0
19007333	19007333	0	0
21500130	1512674	2	2
35102039	4280726	3	3
21604146	40173590	5	6
36155501	1309944	0	0
36151743	1332418	0	0
40173590	40173590	0	0
42806182	1192710	0	0
44355210	46275916	2	3
44348694	1177480	0	0
45631288	1309944	0	0
45631644	1125315	0	0
45646096	1551192	2	3
44358419	1125315	0	0
45663405	738818	0	0
45646096	1551099	0	0
45686407	43012036	2	3
45689046	1125315	0	0
45633148	1112807	0	0
45707106	1177480	0	0
45707289	1125315	0	0
46242934	1125315	0	0
45786243	1192710	0	0
45885344	40480160	5	7
45895325	1332419	2	3
45897620	1153428	0	0
45894025	1125315	0	0
46242013	1125315	0	0
46295888	1129625	0	0
46315409	1177480	0	0
46315024	40229134	2	3
1515774	1515774	0	0
4330583	4330583	0	0
21500130	1521369	2	2
21505691	1557272	3	3
21503967	40165015	5	6
36155581	738818	0	0
36151744	1177480	0	0
40171902	40171902	0	0
42806183	1343916	0	0
44355384	43012036	2	3
44348654	933724	0	0
45631287	708298	0	0
45631618	1125315	0	0
45646149	1545959	2	3
44358420	1125315	0	0
45663406	1115008	0	0
45646099	1107830	0	0
45686361	40162522	2	3
45689049	1125315	0	0
45676446	1112807	0	0
45707345	1177480	0	0
45707111	1125315	0	0
46243069	1125315	0	0
45786252	1112807	0	0
45885344	4237458	5	7
45894313	40174880	2	3
45897599	1322184	0	0
45894026	1125315	0	0
46242014	1125315	0	0
46295925	1129625	0	0
46316170	1177480	0	0
46308841	19008572	2	3
1322184	1322184	0	0
4306014	4306014	0	0
21500130	1549786	2	2
21601136	967823	3	3
21503967	19133768	5	6
36155582	1713332	0	0
36151638	1177480	0	0
36424575	1343916	0	0
42806188	1549786	0	0
44352516	1115171	2	3
44348532	1110410	0	0
45631027	1192710	0	0
45631466	1125315	0	0
45644757	19019273	2	3
44358448	1125315	0	0
45663511	1107830	0	0
45646102	738818	0	0
45686472	40232448	2	3
45689145	1125315	0	0
45676986	1112807	0	0
45707152	1177480	0	0
45707329	1125315	0	0
46242745	1125315	0	0
45782803	1548195	0	0
45885344	4142905	5	7
45894536	1127433	2	3
45897601	1107830	0	0
45894027	1125315	0	0
46242016	1125315	0	0
46291186	1129625	0	0
46310220	1177480	0	0
46308974	19019273	2	3
1326303	1326303	0	0
4294548	4294548	0	0
21500130	40221415	2	2
21604792	40223774	3	3
21500284	19112599	5	6
36155654	1174888	0	0
36151545	1153428	0	0
36516824	80180	0	0
42806253	19127890	0	0
44352547	920334	2	3
44346843	1177480	0	0
45631343	1107830	0	0
45631487	1125315	0	0
45644762	40232448	2	3
44358570	1125315	0	0
45663413	920293	0	0
45646155	1501700	0	0
45683177	40228214	2	3
45689157	1125315	0	0
45676633	1112807	0	0
45704590	1177480	0	0
45707097	1125315	0	0
46242816	1125315	0	0
45782803	1521369	0	0
45885344	4149245	6	7
45894580	40231925	2	3
45895389	1539403	0	0
45894028	1125315	0	0
46241912	1125315	0	0
46291149	1129625	0	0
46309630	1177480	0	0
46309107	19019273	2	3
1127078	1127078	0	0
4295880	4295880	0	0
21501218	967823	2	2
21601238	1361711	3	3
21500284	19125062	5	6
36155735	1118084	0	0
36151550	920293	0	0
36474579	1501700	0	0
42806253	1549786	0	0
44352425	1310034	2	3
44346851	1192710	0	0
45631344	914335	0	0
45631651	1125315	0	0
45644732	40236446	2	3
44358572	1125315	0	0
45663522	1118084	0	0
45646157	1343916	0	0
45683482	19073183	2	3
45689317	1125315	0	0
45677119	1112807	0	0
45700851	1177480	0	0
45707566	1125315	0	0
46243045	1125315	0	0
45782804	1124957	0	0
45885344	4066995	6	7
45802828	19077572	2	3
45895325	1332418	0	0
45894030	1125315	0	0
46242240	1125315	0	0
46244757	1129625	0	0
46309819	1177480	0	0
46309408	19019273	2	3
1127433	1127433	0	0
4296204	4296204	0	0
4248801	28060	2	2
21601238	1326303	3	3
21500284	43012036	5	6
36155462	738818	0	0
36151584	1129625	0	0
36468794	967823	0	0
42806222	1548195	0	0
44352503	40162522	2	3
44346866	723013	0	0
45631091	738818	0	0
45631813	1125315	0	0
45644868	40232448	2	3
44358474	1125315	0	0
45663523	1107830	0	0
45645923	914335	0	0
45683543	46233710	2	3
45689320	1125315	0	0
45673704	1112807	0	0
45700940	1177480	0	0
45707356	1125315	0	0
46242783	1125315	0	0
45782810	1112807	0	0
45885344	4278672	6	7
45803250	19008572	2	3
45895161	715997	0	0
45894109	1125315	0	0
46242271	1125315	0	0
46244968	1129625	0	0
46310443	1177480	0	0
46309122	40224805	2	3
920300	920300	0	0
4296205	4296205	0	0
4248801	433125	2	2
21601238	1309944	3	3
21500284	40232448	5	6
36155476	933724	0	0
36151610	1521369	0	0
36469239	1129625	0	0
42806129	1154343	0	0
44352453	40229134	2	3
44346874	723013	0	0
45631300	1110410	0	0
45631709	1125315	0	0
45641677	19019273	2	3
44358627	1125315	0	0
45663525	19127890	0	0
45645929	1192710	0	0
45683543	46233988	2	3
45689162	1125315	0	0
45673801	1112807	0	0
45700774	1177480	0	0
45706870	1125315	0	0
46242818	1125315	0	0
45782812	975125	0	0
45885344	40479768	6	7
45803373	40228214	2	3
45895435	1112807	0	0
45894114	1125315	0	0
46242072	1125315	0	0
46244635	1129625	0	0
46310390	1177480	0	0
46309333	40232448	2	3
920334	920334	0	0
4252419	4252419	0	0
21600651	975125	2	2
21601238	1343916	3	3
21500284	40228214	5	6
36155606	1548195	0	0
36151706	791967	0	0
36469239	1125315	0	0
42806130	1367571	0	0
44352756	1115171	2	3
44346891	1307863	0	0
45631313	1154343	0	0
45631933	1125315	0	0
45641749	19008572	2	3
44351293	1125315	0	0
45663525	1589505	0	0
45646193	1539403	0	0
45683485	40232448	2	3
45689237	1125315	0	0
45673944	1112807	0	0
45701188	1177480	0	0
45706821	1125315	0	0
46243020	1125315	0	0
45782874	1307863	0	0
45885344	4059173	6	7
45803260	19077344	2	3
45895287	1713332	0	0
45894135	1125315	0	0
46241946	1125315	0	0
46240116	1129625	0	0
46310440	1177480	0	0
46309371	40232448	2	3
740275	740275	0	0
4238715	4238715	0	0
21600652	975125	2	2
21602751	1501700	3	3
21500284	40223821	5	6
36155747	1177480	0	0
36151610	1549786	0	0
36468760	1149196	0	0
42806140	1149196	0	0
44352761	40232448	2	3
44346869	1177480	0	0
45633736	723013	0	0
45631879	1125315	0	0
45641684	19057271	2	3
44351356	1125315	0	0
45663150	1149380	0	0
45644757	1115008	0	0
45666469	40232448	2	3
45689215	1125315	0	0
45673134	1112807	0	0
45701197	1177480	0	0
45704175	1125315	0	0
46242787	1125315	0	0
45782918	1310149	0	0
45885344	40479422	6	7
45803411	40232448	2	3
45895289	1115008	0	0
45875954	21494966	3	3
46241950	1125315	0	0
45896674	1129625	0	0
46310537	1177480	0	0
46309379	1115171	2	3
742185	742185	0	0
4237458	4237458	0	0
21502709	19029476	2	2
21604253	1125315	3	3
21500284	1107882	5	6
36155664	1717327	0	0
36151860	1107830	0	0
36300000	4240902	10	11
42806257	1149380	0	0
44352619	40163554	2	3
44346854	757627	0	0
45633889	1000560	0	0
45631781	1125315	0	0
45641900	19133768	2	3
44351369	1125315	0	0
45663153	1738521	0	0
45644760	1124957	0	0
45666412	19078924	2	3
45689389	1125315	0	0
45670766	1112807	0	0
45701022	1177480	0	0
45704202	1125315	0	0
46243103	1125315	0	0
45782920	1551099	0	0
45885344	4048695	6	7
45800456	40229134	2	3
45895270	967823	0	0
45791237	19127922	3	4
46242062	1125315	0	0
45896411	1129625	0	0
46305492	1177480	0	0
46309473	40232448	2	3
757627	757627	0	0
4219399	4219399	0	0
21500595	1115008	2	2
21604253	1154029	3	3
21500284	40223834	5	6
36155620	1129625	0	0
36151864	1112807	0	0
36300000	4304110	9	10
42806260	1713332	0	0
44352742	45892894	2	3
44346856	753626	0	0
45633891	1548195	0	0
45631782	1125315	0	0
45641911	40232448	2	3
44351269	1125315	0	0
45663525	1549786	0	0
45644728	738818	0	0
45666413	1115171	2	3
45689073	1125315	0	0
45670910	1112807	0	0
45698116	1177480	0	0
45704205	1125315	0	0
46240480	1125315	0	0
45782922	1149196	0	0
45885349	78272	5	5
45800427	19075001	2	3
45895326	1000560	0	0
46238184	19123231	2	3
46242234	1125315	0	0
45896472	1129625	0	0
46304723	1177480	0	0
46309366	40231925	2	3
738818	738818	0	0
21001427	1729720	0	0
21500139	1549786	2	2
21604253	1110410	3	3
21500284	1150771	5	6
36155671	1551099	0	0
36151730	1309944	0	0
36300000	258780	9	14
42806134	1115008	0	0
44352483	1115171	2	3
44346876	1154343	0	0
45633823	1174888	0	0
45632199	1125315	0	0
45642022	1310034	2	3
44351214	1125315	0	0
45663373	738818	0	0
45644732	705944	0	0
45664441	43012036	2	3
45689449	1125315	0	0
45669420	1112807	0	0
45698153	1177480	0	0
45704276	1125315	0	0
46240521	1125315	0	0
45782827	967823	0	0
45885349	4134304	4	6
45800479	1115171	2	3
45895372	1192710	0	0
45798249	40232448	2	3
46242182	1125315	0	0
45896473	1129625	0	0
46305546	1177480	0	0
46303718	1115171	2	3
439406	439406	0	0
21001385	1768849	0	0
21500139	43012433	2	2
21604253	1112807	3	3
21500284	40228230	5	6
36155675	1112807	0	0
36151683	738818	0	0
36300000	4051466	8	9
42806146	1125315	0	0
42802580	19133905	2	3
44346947	1192710	0	0
45633826	1115008	0	0
45632200	1125315	0	0
45642072	40162522	2	3
44351493	1125315	0	0
45663194	738818	0	0
45644766	1124300	0	0
45664454	19008572	2	3
45689367	1125315	0	0
45669630	1112807	0	0
45695046	1177480	0	0
45704279	1125315	0	0
46240589	1125315	0	0
45783005	1549786	0	0
45885349	40479422	4	4
45800564	19073183	2	3
45895372	1112807	0	0
45798453	19008572	2	3
46242185	1125315	0	0
45896683	1129625	0	0
46306530	1177480	0	0
46303846	1115171	2	3
439777	439777	0	0
21001430	1551099	0	0
21500139	1519936	2	2
35102398	4056621	3	3
21500284	1150837	5	6
36155766	791967	0	0
36151754	1000560	0	0
36300000	372328	8	11
42806153	1545958	0	0
42802580	19133873	2	3
44346911	1549786	0	0
45633842	1192710	0	0
45632152	1125315	0	0
45642074	19018935	2	3
44351433	1125315	0	0
45663243	1110410	0	0
45644837	738818	0	0
45664522	1127433	2	3
45689535	1125315	0	0
45780723	1112807	0	0
45694639	1177480	0	0
45704285	1125315	0	0
46240559	1125315	0	0
45783005	1515774	0	0
45885349	40479768	4	4
45800525	1127433	2	3
45895363	1500211	0	0
45798667	40163554	2	3
46242309	1125315	0	0
45896687	1129625	0	0
46316470	1177480	0	0
46303861	40162522	2	3
440086	440086	0	0
21001382	1728416	0	0
21500141	975125	2	2
35102397	4056621	3	3
21500363	40169216	5	6
36155772	1115008	0	0
36151779	1192710	0	0
36300000	4113008	8	11
42806144	1548195	0	0
42802731	1127433	2	3
44346911	1512674	0	0
45633939	967823	0	0
45631898	1125315	0	0
45638829	19077344	2	3
44351375	1125315	0	0
45663258	1738521	0	0
45644721	1738521	0	0
45664603	19008572	2	3
45689354	1125315	0	0
45781071	1112807	0	0
45694930	1177480	0	0
45704264	1125315	0	0
46240561	1125315	0	0
45783025	1149196	0	0
45885349	81151	4	4
45800505	40224805	2	3
45895368	1102527	0	0
45798601	40232448	2	3
46241988	1125315	0	0
45894255	1129625	0	0
46316283	1177480	0	0
46303937	1107882	2	3
440448	440448	0	0
21001382	1717327	0	0
21500141	1589505	2	2
35102035	439777	3	3
21502569	1551192	5	6
36155696	715997	0	0
36151693	1309944	0	0
36300000	261325	8	13
42806287	1738521	0	0
42802914	40231925	2	3
44346916	738818	0	0
45633940	1308738	0	0
45631840	1125315	0	0
45638938	19008572	2	3
44351461	1125315	0	0
45663664	967823	0	0
45644866	1174888	0	0
45663979	43012433	2	3
45689615	1125315	0	0
45781072	1112807	0	0
45695019	1177480	0	0
45704186	1125315	0	0
46240556	1125315	0	0
45783027	1332418	0	0
45885352	4230399	3	3
45800599	19077572	2	3
45895476	1124300	0	0
45798603	40174880	2	3
46242312	1125315	0	0
45894357	1129625	0	0
46315978	1177480	0	0
46306441	40236824	2	3
317009	317009	0	0
21001382	1729720	0	0
21500074	933724	2	2
35102392	4056621	3	3
21502620	1738521	5	5
36155609	1124957	0	0
36151883	1112807	0	0
36300000	4066995	7	13
42806217	1309944	0	0
44344956	1127433	2	3
44346991	1549786	0	0
45633948	1557272	0	0
45631515	1125315	0	0
45639056	19008572	2	3
44351616	1125315	0	0
45663155	715997	0	0
45641673	933724	0	0
45663984	19075601	2	3
45689442	1125315	0	0
45781023	1112807	0	0
45695057	1177480	0	0
45704207	1125315	0	0
46240756	1125315	0	0
45783031	1149196	0	0
45885352	4134304	4	4
45800729	40236824	2	3
45895293	1112807	0	0
45798330	19008572	2	3
46242027	1125315	0	0
45799607	1129625	0	0
46316571	1177480	0	0
46306951	19079524	2	3
317576	317576	0	0
21001384	1713332	0	0
21003349	40243436	2	3
21503587	1192710	3	3
21500327	1119510	5	5
36155749	1192710	0	0
36151867	1738521	0	0
36300000	40480160	7	13
42806231	1332418	0	0
44345188	19008572	2	3
44346938	1332418	0	0
45631375	1548195	0	0
45632103	1125315	0	0
45639084	40174880	2	3
44351550	1125315	0	0
45663158	1174888	0	0
45641808	1549786	0	0
45664023	40163554	2	3
45689056	1125315	0	0
45781146	1112807	0	0
45695055	1177480	0	0
45704331	1125315	0	0
46240780	1125315	0	0
45782876	1322184	0	0
45885353	4134304	4	4
45800845	1713671	2	3
45895352	914335	0	0
45798573	19059056	2	3
46242257	1125315	0	0
46318278	1129625	0	0
46310551	1177480	0	0
46304229	19008572	2	3
321042	321042	0	0
21001384	1759842	0	0
21003251	40236824	2	3
35102391	4056621	3	3
21500327	1112807	5	5
36155617	1124300	0	0
36151852	738818	0	0
36300000	4043241	6	15
42806262	1729720	0	0
44345008	40232448	2	3
44347024	738818	0	0
45631378	975125	0	0
45628600	1125315	0	0
45635487	40163554	2	3
44351552	1125315	0	0
45663454	753626	0	0
45641808	1589505	0	0
45663949	1127433	2	3
45689569	1125315	0	0
45780597	1112807	0	0
45697647	1177480	0	0
45704337	1125315	0	0
46240777	1125315	0	0
45783065	967823	0	0
45894456	19128022	3	4
45800847	19133873	2	3
45895355	1107830	0	0
45798352	1115171	2	3
46242041	1125315	0	0
46318132	1129625	0	0
46310959	1177480	0	0
46304123	1115171	2	3
372328	372328	0	0
21001384	975125	0	0
21502622	46275444	2	3
35102395	4056621	3	3
21500327	1129625	5	5
36155697	1124300	0	0
36151858	1177480	0	0
36300000	4202451	6	9
42806234	975125	0	0
44345112	40229134	2	3
44347036	1129625	0	0
45631489	740275	0	0
45628602	1125315	0	0
45635590	40232448	2	3
44351794	1125315	0	0
45663459	738818	0	0
45641809	967823	0	0
45664165	19008572	2	3
45689576	1125315	0	0
45780854	1112807	0	0
45691644	1177480	0	0
45704290	1125315	0	0
46240782	1125315	0	0
45782840	914335	0	0
45792623	19128065	3	4
45797647	40162522	2	3
45895249	975125	0	0
45798763	19008572	2	3
46242203	1125315	0	0
46318251	1129625	0	0
46310712	1177480	0	0
46320565	1115171	2	3
134438	134438	0	0
21001390	975125	0	0
21500589	19133768	2	3
21604685	757627	3	3
21500327	738818	5	5
36155823	1545958	0	0
36151996	1115008	0	0
36303196	4163872	1	1
42806288	1326303	0	0
44345000	1127433	2	3
44347038	1192710	0	0
45631494	1110410	0	0
45628500	1125315	0	0
45635694	1713671	2	3
44351957	1125315	0	0
45663470	1521369	0	0
45641884	914335	0	0
45664116	19074841	2	3
45686256	1125315	0	0
45780856	1112807	0	0
45691983	1177480	0	0
45704227	1125315	0	0
46240790	1125315	0	0
45782833	1738521	0	0
45696797	791967	0	0
45797814	1545959	2	3
45895425	1149380	0	0
45798687	1115171	2	3
46242287	1125315	0	0
46318325	1129625	0	0
46310895	1177480	0	0
46320570	19059056	2	3
140673	140673	0	0
21001402	975125	0	0
21500589	40162522	2	3
21604685	742185	3	3
21500327	1174888	5	5
36157779	1119510	0	0
36152000	1746114	0	0
40236820	40236824	1	1
42806289	1332418	0	0
44338226	19018935	2	3
44346925	1149196	0	0
45631426	1713332	0	0
45628725	1125315	0	0
45636934	19126352	2	3
44351658	1125315	0	0
45663470	1595799	0	0
45641870	967823	0	0
45660789	1332419	2	3
45686258	1125315	0	0
45778553	1112807	0	0
45691403	1177480	0	0
45704296	1125315	0	0
46240544	1125315	0	0
45782891	1174888	0	0
45696730	975125	0	0
45797900	40232448	2	3
45895406	1174888	0	0
45793271	19008572	2	3
46242288	1125315	0	0
46312318	1129625	0	0
46306043	1177480	0	0
46320434	40229134	2	3
28060	28060	0	0
21001414	1778162	0	0
21002773	19129655	2	3
21603890	1305058	3	3
21500327	914335	5	5
36157782	1119510	0	0
36152000	1741122	0	0
36516779	80809	1	1
42806281	1309944	0	0
44338098	40229134	2	3
44346926	1713332	0	0
45631427	1115008	0	0
45631104	1125315	0	0
45635709	40232448	2	3
44351630	1125315	0	0
45663470	1549786	0	0
45641841	1153428	0	0
45660753	19078924	2	3
45686246	1125315	0	0
45778555	1112807	0	0
45688854	1177480	0	0
45704401	1125315	0	0
46240684	1125315	0	0
45782983	1000560	0	0
45696301	1192710	0	0
45795158	19073188	2	3
45895486	1332418	0	0
45793288	1115171	2	3
45893620	1125315	0	0
46312440	1129625	0	0
46317008	1177480	0	0
46320600	1545959	2	3
30753	30753	0	0
21000923	791967	0	0
21003348	40243436	2	3
21603890	19010482	3	3
21500327	1177480	5	5
36158052	1119510	0	0
36198920	1129625	0	0
36302170	4059173	9	12
42806345	1500211	0	0
44362931	1115171	2	3
44347041	1778162	0	0
45631508	1154029	0	0
45631105	1125315	0	0
45636056	19019273	2	3
44351564	1125315	0	0
45663595	1149196	0	0
45641875	1307863	0	0
45661023	1551192	2	3
45686299	1125315	0	0
45778556	1112807	0	0
45688831	1177480	0	0
45704420	1125315	0	0
46240720	1125315	0	0
45782843	1153428	0	0
45696374	1115008	0	0
45795109	19018935	2	3
45895250	1107830	0	0
45793109	1127433	2	3
45893595	1125315	0	0
46312771	1129625	0	0
46317106	1177480	0	0
46320911	46233710	2	3
3045716	3045716	0	0
21000923	723013	0	0
21001827	46275444	2	3
35102047	439777	3	3
21500327	1115008	5	5
36158082	1119510	0	0
36159647	1115008	0	0
36302170	4310024	7	11
42806421	791967	0	0
44359239	1127433	2	3
44347042	1112807	0	0
45631395	1115008	0	0
45628858	1125315	0	0
45632558	1115171	2	3
44351904	1125315	0	0
45637028	1119510	0	0
45641845	791967	0	0
45660672	43012036	2	3
45686301	1125315	0	0
45778667	1112807	0	0
45688940	1177480	0	0
45704525	1125315	0	0
45680974	1119510	0	0
45782992	1115008	0	0
45696564	1500211	0	0
45795112	40163554	2	3
45895487	975125	0	0
45793110	1127433	2	3
45893628	1125315	0	0
46306954	1129625	0	0
46319806	1177480	0	0
46320661	1115171	2	3
3049273	3049273	0	0
21000931	723013	0	0
21012458	40223768	2	3
21603812	1500211	3	3
21502553	1309944	5	5
36157788	1119510	0	0
36159652	914335	0	0
36302170	80502	7	9
42806426	1729720	0	0
44359387	1551192	2	3
44347048	1129625	0	0
45631441	1738521	0	0
45628812	1125315	0	0
45632751	1127433	2	3
44351591	1125315	0	0
45636837	1119510	0	0
45641677	1115008	0	0
45660631	40232448	2	3
45686250	1125315	0	0
45779130	1112807	0	0
45689081	1177480	0	0
45704248	1125315	0	0
45681062	1119510	0	0
45782994	920293	0	0
45696574	1759842	0	0
45795500	46233710	2	3
45895443	1192710	0	0
45793192	40229134	2	3
45893579	1125315	0	0
46307032	1129625	0	0
46317237	1177480	0	0
46320918	40229134	2	3
3051031	3051031	0	0
21000919	723013	0	0
21001427	19133905	2	3
21602722	1551099	3	3
21502553	1545958	5	5
36157910	1119510	0	0
36159653	1129625	0	0
36302170	4314290	7	7
42806433	1115008	0	0
44359368	19133873	2	3
44347070	1545958	0	0
45631544	1174888	0	0
45628912	1125315	0	0
45632824	19133768	2	3
44351822	1125315	0	0
45636838	1119510	0	0
45641684	791967	0	0
45660993	19019273	2	3
45686220	1125315	0	0
45778650	1112807	0	0
45689092	1177480	0	0
45704373	1125315	0	0
45681221	1119510	0	0
45783244	1112807	0	0
45696574	1713332	0	0
45795433	19059056	2	3
45895444	1713332	0	0
45793194	40229134	2	3
45893629	1125315	0	0
46307053	1129625	0	0
46313410	738818	0	0
46321276	1115171	2	3
3001488	3001488	0	0
21000931	708298	0	0
21000196	46233988	2	3
21601744	1332418	3	3
21502553	914335	5	5
36157914	1119510	0	0
36159655	1149196	0	0
36302170	4296205	8	8
42806190	715997	0	0
44359375	40162522	2	3
44347072	933724	0	0
45631544	1192710	0	0
45625857	1125315	0	0
45632811	46233710	2	3
44351830	1125315	0	0
45637150	1119510	0	0
45641687	1110410	0	0
45661024	19019273	2	3
45686228	1125315	0	0
45778892	1112807	0	0
45686109	1177480	0	0
45704418	1125315	0	0
45675832	1119510	0	0
45783072	1549786	0	0
45696383	1174888	0	0
45795435	40162522	2	3
45895515	1112807	0	0
45793370	19078461	2	3
45893602	1125315	0	0
46312066	1129625	0	0
46308558	738818	0	0
46320638	1115171	2	3
3013682	3013682	0	0
21000953	740275	0	0
21001627	19059056	2	3
21601744	1307863	3	3
21502584	1124300	5	5
36157928	1119510	0	0
36159626	1521369	0	0
36302170	4116491	8	10
42806251	701322	0	0
44359984	19059056	2	3
44347172	1549786	0	0
45631501	1110410	0	0
45625946	1125315	0	0
45632769	19008572	2	3
44352111	1125315	0	0
45635940	1119510	0	0
45641888	1124957	0	0
45660989	35605482	2	3
45686681	1125315	0	0
45707373	1112807	0	0
45685748	1177480	0	0
45704503	1125315	0	0
45675925	1119510	0	0
45783072	19127890	0	0
45696384	1192710	0	0
45795293	1115171	2	3
45895444	1759842	0	0
45793480	40231925	2	3
45893696	1125315	0	0
46307219	1129625	0	0
46308297	738818	0	0
46315054	40229134	2	3
3013721	3013721	0	0
21000012	1717327	0	0
21502524	920300	2	3
35306088	378419	3	3
21502584	1129625	5	5
36157802	1119510	0	0
36159626	1549786	0	0
36302170	4296204	8	11
42806357	1548195	0	0
44359527	1125315	0	0
44347172	19127890	0	0
45631453	975125	0	0
45625742	1125315	0	0
45632870	19059056	2	3
44351967	1125315	0	0
45635960	1119510	0	0
45641625	1154343	0	0
45660697	19019273	2	3
45686410	1125315	0	0
45707561	1112807	0	0
45686202	1177480	0	0
45704512	1125315	0	0
45675907	1119510	0	0
45783073	1713332	0	0
45696812	738818	0	0
45795638	19133905	2	3
45895448	1153428	0	0
45793295	19059056	2	3
45893701	1125315	0	0
46307273	1129625	0	0
46308570	738818	0	0
46313873	40162522	2	3
3015076	3015076	0	0
21000013	1728416	0	0
21502524	920334	2	3
21500284	1107830	3	3
21502584	723013	5	5
36158206	1119510	0	0
36159638	1177480	0	0
36302170	4149245	8	12
42806305	1307863	0	0
44359547	1125315	0	0
44347172	1512674	0	0
45631610	1713332	0	0
45625881	1125315	0	0
45632644	40162522	2	3
44351733	1125315	0	0
45632547	1119510	0	0
45641626	1713332	0	0
45661050	19073183	2	3
45686374	1125315	0	0
45707486	1112807	0	0
45686135	1177480	0	0
45704513	1125315	0	0
45675909	1119510	0	0
45783073	1759842	0	0
45696813	975125	0	0
45795638	19133873	2	3
45895340	715997	0	0
45793297	19059056	2	3
45893706	1125315	0	0
46307965	1129625	0	0
46308311	738818	0	0
46314896	40162522	2	3
3021226	3021226	0	0
21000010	1717327	0	0
21001685	40163554	2	3
21600490	1000560	3	3
21502584	738818	5	5
36158323	1119510	0	0
36198896	1129625	0	0
36302170	4278672	8	12
42806546	1107830	0	0
44359700	1125315	0	0
44346957	1177480	0	0
45628148	1192710	0	0
45625885	1125315	0	0
45632804	19019273	2	3
44344098	1125315	0	0
45632789	1119510	0	0
45641894	1307863	0	0
45661053	19008572	2	3
45686401	1125315	0	0
45704607	1112807	0	0
45688653	1177480	0	0
45700800	1125315	0	0
45675910	1119510	0	0
45782837	1192710	0	0
45696818	1192710	0	0
45795382	1107882	2	3
45894537	1174888	0	0
45793305	19057271	2	3
45893753	1125315	0	0
46307354	1129625	0	0
46308692	738818	0	0
46314803	40162522	2	3
3023430	3023430	0	0
21000011	1717327	0	0
21000198	46233710	2	3
21505600	46221626	3	3
21502584	791967	5	5
36158371	1119510	0	0
36198902	1129625	0	0
36302170	40481087	8	12
42806350	1125315	0	0
44359708	1125315	0	0
44347000	1124957	0	0
45628162	1332418	0	0
45625526	1125315	0	0
45631085	19008572	2	3
44344057	1125315	0	0
45632931	1119510	0	0
45641895	791967	0	0
45661076	19008572	2	3
45686529	1125315	0	0
45704440	1112807	0	0
45683024	1177480	0	0
45700909	1125315	0	0
45676095	1119510	0	0
45783095	1112807	0	0
45696820	1548195	0	0
45792584	1115171	2	3
45803236	1192710	0	0
45793460	19076374	2	3
45893729	1125315	0	0
46307312	1129625	0	0
46312350	738818	0	0
46314940	40229134	2	3
3006906	3006906	0	0
21000009	1738521	0	0
21000224	46233988	2	3
21505600	19132304	3	3
21502659	19019273	3	4
36158375	1119510	0	0
36198903	1129625	0	0
36302170	4001336	8	12
42806218	1512674	0	0
44355619	1125315	0	0
44346863	1549786	0	0
45628554	1717327	0	0
45625829	1125315	0	0
45629651	19059056	2	3
44343785	1125315	0	0
45632932	1119510	0	0
45641964	1154343	0	0
45657969	19019273	2	3
45686427	1125315	0	0
45704822	1112807	0	0
45683037	1177480	0	0
45701042	1125315	0	0
45676064	1119510	0	0
45783098	1746114	0	0
45696820	1589505	0	0
45794537	40232448	2	3
45803332	1192710	0	0
45794807	1115171	2	3
45893745	1125315	0	0
46307210	1129625	0	0
46311838	738818	0	0
46314755	40163554	2	3
3006923	3006923	0	0
21000033	1717327	0	0
21000224	46233710	2	3
21505696	705944	3	3
21502621	46275444	3	4
36157824	1119510	0	0
36198925	1521369	0	0
36302170	4230399	8	13
42806218	1549786	0	0
44355521	1125315	0	0
44347011	1361711	0	0
45628573	1115008	0	0
45625835	1125315	0	0
45629720	19133905	2	3
44343804	1125315	0	0
45632941	1119510	0	0
45641967	1548195	0	0
45657996	19059056	2	3
45686684	1125315	0	0
45704672	1112807	0	0
45683085	1177480	0	0
45700803	1125315	0	0
45676014	1119510	0	0
45783098	1741122	0	0
45696824	1107830	0	0
45794734	19077572	2	3
45803198	975125	0	0
45794685	1115171	2	3
45893771	1125315	0	0
46307464	1129625	0	0
46308813	738818	0	0
46314698	1551192	2	3
3024561	3024561	0	0
21000010	1713332	0	0
21002677	19008572	2	3
21603365	1125443	3	3
21502621	1713671	3	4
36158348	1119510	0	0
36198925	1549786	0	0
36302170	4102123	8	9
42806350	1112807	0	0
44356063	1125315	0	0
44347014	705944	0	0
45628590	967823	0	0
45626033	1125315	0	0
45629662	40165015	2	3
44343889	1125315	0	0
45632843	1119510	0	0
45641823	1115008	0	0
45657716	19018935	2	3
45686594	1125315	0	0
45704788	1112807	0	0
45682734	1177480	0	0
45700947	1125315	0	0
45676016	1119510	0	0
45783102	1192710	0	0
45696848	920293	0	0
45792774	40232448	2	3
45803368	19127890	0	0
45787990	1115171	2	3
45893772	1125315	0	0
46307668	1129625	0	0
46303814	738818	0	0
46314856	40228214	2	3
3024731	3024731	0	0
21000049	1738521	0	0
21000218	46233710	2	3
21603365	1174888	3	3
21600960	40163554	3	6
36158445	1119510	0	0
36198927	19127890	0	0
36302170	439406	8	9
42806276	1549786	0	0
44355795	1125315	0	0
44347019	1154343	0	0
45628524	1124300	0	0
45626072	1125315	0	0
45629671	40224805	2	3
44344011	1125315	0	0
45632869	1119510	0	0
45642005	1110410	0	0
45658060	19078924	2	3
45686361	1125315	0	0
45704905	1112807	0	0
45682897	1177480	0	0
45700814	1125315	0	0
45675866	1119510	0	0
45783199	1149380	0	0
45696854	1153428	0	0
45792882	40229134	2	3
45803368	1549786	0	0
45787950	40236824	2	3
45893785	1125315	0	0
46302106	1129625	0	0
46303918	738818	0	0
46317595	19075001	2	3
1729720	1729720	0	0
21000038	1551099	0	0
21001655	40163554	2	3
21500260	46275916	3	4
21600960	19075601	3	6
36158457	1119510	0	0
36198837	1192710	0	0
36302170	4280726	6	13
42806319	1124957	0	0
44355653	1125315	0	0
44347121	1322184	0	0
45628632	1115008	0	0
45626073	1125315	0	0
45629750	1545959	2	3
44344113	1125315	0	0
45632956	1119510	0	0
45641900	1174888	0	0
45657876	40232448	2	3
45683170	1125315	0	0
45704660	1112807	0	0
45661628	1129625	0	0
45700985	1125315	0	0
45672972	1119510	0	0
45783230	1174888	0	0
45696307	1154029	0	0
45792979	1115171	2	3
45803337	1118084	0	0
45788005	43012036	2	3
45893740	1125315	0	0
46302151	1129625	0	0
46300876	738818	0	0
46317746	40229134	2	3
1746114	1746114	0	0
21000242	1728416	0	0
21001824	46275444	2	3
21500290	40228230	3	4
21604253	40165015	3	6
36158215	1119510	0	0
36198839	1512674	0	0
36302170	4029498	6	9
42806392	1545958	0	0
44355810	1125315	0	0
44347124	1738521	0	0
45628508	1192710	0	0
45625906	1125315	0	0
45629757	40162522	2	3
44344121	1125315	0	0
45632958	1119510	0	0
45641908	914335	0	0
45658070	40165015	2	3
45683175	1125315	0	0
45705027	1112807	0	0
45661715	1129625	0	0
45700925	1125315	0	0
45672928	1119510	0	0
45783034	1174888	0	0
45696665	967823	0	0
45792798	43012036	2	3
45803341	967823	0	0
45788038	19077572	2	3
45893741	1125315	0	0
46302107	1129625	0	0
46300885	738818	0	0
46317753	920334	2	3
1741122	1741122	0	0
21000243	1738521	0	0
21003394	1551192	2	3
21500290	19125062	3	4
21500885	975125	3	3
36157952	1119510	0	0
36198839	1549786	0	0
36302170	317009	6	7
42806320	1124957	0	0
44355992	1125315	0	0
44347198	701322	0	0
45628179	1759842	0	0
45626109	1125315	0	0
45629759	40163554	2	3
44343930	1125315	0	0
45630938	1119510	0	0
45642071	1343916	0	0
45658153	19019273	2	3
45683514	1125315	0	0
45701271	1112807	0	0
45704092	1129625	0	0
45701008	1125315	0	0
45673051	1119510	0	0
45783458	1174888	0	0
45696874	738818	0	0
45792799	1115171	2	3
45803427	1332418	0	0
45788040	19076374	2	3
45893836	1125315	0	0
46302306	1129625	0	0
46301915	738818	0	0
46317384	1115171	2	3
1718412	1718412	0	0
21000268	1778162	0	0
21011491	19076374	2	3
21500290	40228214	3	4
21600960	1322184	3	3
36154244	1119510	0	0
36198840	1129625	0	0
36302170	80809	5	9
42806320	1125315	0	0
44356016	1125315	0	0
44347092	738818	0	0
45628179	1713332	0	0
45626091	1125315	0	0
45641759	40232448	2	3
44344252	1125315	0	0
45630940	1119510	0	0
45642022	1309944	0	0
45657743	19075001	2	3
45683350	1125315	0	0
45701404	1112807	0	0
45704053	1129625	0	0
45701001	1125315	0	0
45673228	1119510	0	0
45783077	1115008	0	0
45696882	1174888	0	0
45790056	19078924	2	3
45803428	1115008	0	0
45788146	19059056	2	3
45893751	1125315	0	0
46306854	1129625	0	0
46301200	738818	0	0
46317932	19079524	2	3
1718994	1718412	0	0
19023398	19023398	0	0
21002686	19008572	2	3
21500290	1150771	3	4
21600960	1112807	3	3
36154380	1119510	0	0
36198843	1129625	0	0
36302170	4252419	5	8
42806356	1177480	0	0
44356172	1125315	0	0
44347251	1115008	0	0
45628184	1361711	0	0
45622578	1125315	0	0
45641694	40162522	2	3
44344070	1125315	0	0
45630941	1119510	0	0
45642110	1549786	0	0
45658316	19008572	2	3
45683517	1125315	0	0
45703659	1112807	0	0
45651522	1129625	0	0
45701334	1125315	0	0
45673229	1119510	0	0
45783206	1729720	0	0
45696709	1154343	0	0
45790155	19018935	2	3
45803269	1361711	0	0
45788219	40231925	2	3
45893842	1125315	0	0
46306863	1129625	0	0
46301325	738818	0	0
46315287	1115171	2	3
1738521	1738521	0	0
19023423	19023423	0	0
21003226	40232448	2	3
21500290	1150837	3	4
21600960	1367571	3	3
36154473	1119510	0	0
36199695	1115008	0	0
36302170	4024289	5	8
42806447	1713332	0	0
44355922	1125315	0	0
44347179	1149380	0	0
45628351	1551099	0	0
45622841	1125315	0	0
45641571	40223834	2	3
44344240	1125315	0	0
45629618	1119510	0	0
45642110	1512674	0	0
45654519	19078461	2	3
45683519	1125315	0	0
45701475	1112807	0	0
45651451	1129625	0	0
45701346	1125315	0	0
45673164	1119510	0	0
45783425	1192710	0	0
45696710	967823	0	0
45790160	40229134	2	3
45803349	1192710	0	0
45788226	40162522	2	3
45893885	1125315	0	0
46306967	1129625	0	0
46319235	738818	0	0
46315316	40163554	2	3
1521369	1521369	0	0
4329847	4329847	0	0
21001662	19059056	2	3
21504554	44816277	3	4
21600960	1310149	3	3
36154389	1119510	0	0
36199705	1107830	0	0
36302170	4058899	4	9
42803986	1154343	0	0
44355945	1125315	0	0
44346976	1551099	0	0
45628540	1192710	0	0
45622843	1125315	0	0
45641550	42707627	2	3
44344173	1125315	0	0
45629621	1119510	0	0
45642110	19127890	0	0
45654535	920334	2	3
45683259	1125315	0	0
45701654	1112807	0	0
45651709	1129625	0	0
45701131	1125315	0	0
45784878	1119510	0	0
45783439	1112807	0	0
45696834	1115008	0	0
45789920	40165015	2	3
45803458	1595799	0	0
45788241	1115171	2	3
45893832	1125315	0	0
46306993	1129625	0	0
46320058	738818	0	0
46315344	19019273	2	3
1518198	1518198	0	0
4285898	4285898	0	0
21001665	19007333	2	3
21504609	1332419	3	4
21601605	1361711	3	3
36154728	1119510	0	0
36198927	1515774	0	0
36302170	192671	4	9
42803988	1125315	0	0
44356190	1125315	0	0
44346978	1112807	0	0
45628668	1174888	0	0
45622387	1125315	0	0
45641553	40169281	2	3
44344145	1125315	0	0
45629628	1119510	0	0
45642116	1713332	0	0
45654665	40231925	2	3
45683266	1125315	0	0
45701655	1112807	0	0
45652254	1129625	0	0
45700858	1125315	0	0
45784743	1119510	0	0
45783300	1112807	0	0
45696783	1332418	0	0
45789923	1127433	2	3
45803458	1308738	0	0
45788273	1115171	2	3
45801529	1125315	0	0
46299908	1129625	0	0
46314075	738818	0	0
46315331	1115171	2	3
1539403	1539403	0	0
4240902	4240902	0	0
21003387	46275916	2	3
35100000	439777	3	4
21600002	975125	3	3
36154731	1119510	0	0
36198927	1549786	0	0
37604043	192671	2	2
42803988	1119510	0	0
44356044	1125315	0	0
44347295	1107830	0	0
45628470	1551099	0	0
45622390	1125315	0	0
45641666	40232448	2	3
44343934	1125315	0	0
45629762	1119510	0	0
45642076	1778162	0	0
45654656	1107882	2	3
45683145	1125315	0	0
45701592	1112807	0	0
45652101	1129625	0	0
45700871	1125315	0	0
45784777	1119510	0	0
45783302	1308738	0	0
45696861	740275	0	0
45789810	40229134	2	3
45803468	1112807	0	0
45788070	40229134	2	3
45801760	1125315	0	0
46299933	1129625	0	0
46315024	738818	0	0
46309704	40174880	2	3
1332418	1332418	0	0
4234705	4234705	0	0
21003387	40232448	2	3
21503969	19133768	3	4
21501050	1125315	3	3
36154735	1119510	0	0
36198936	1129625	0	0
40143224	19127904	2	2
42803988	738818	0	0
44356050	1125315	0	0
44347147	1149196	0	0
45628471	975125	0	0
45622396	1125315	0	0
45641782	19019273	2	3
44344428	1125315	0	0
45629741	1119510	0	0
45642072	1174888	0	0
45654672	19008572	2	3
45683547	1125315	0	0
45698234	1112807	0	0
45697738	1129625	0	0
45700872	1125315	0	0
45784855	1119510	0	0
45783305	1000560	0	0
45696864	1192710	0	0
45789814	40162522	2	3
45803523	1149380	0	0
45788324	19019273	2	3
45801546	1125315	0	0
46299875	1129625	0	0
46308793	738818	0	0
46309527	40163554	2	3
1150837	1150837	0	0
21001770	975125	0	0
21000227	46233988	2	3
21503969	40231925	3	4
21604253	1102527	3	3
36154745	1119510	0	0
36198857	1129625	0	0
40143224	19127918	2	2
42803989	1713332	0	0
44356009	1125315	0	0
44347299	1551099	0	0
45628316	1154343	0	0
45622406	1125315	0	0
45641725	40232448	2	3
44337335	1125315	0	0
45629857	1119510	0	0
45642074	1326303	0	0
45654552	1115171	2	3
45683405	1125315	0	0
45698566	1112807	0	0
45697851	1129625	0	0
45700873	1125315	0	0
45784867	1119510	0	0
45783212	1115008	0	0
45696866	791967	0	0
45789992	40229134	2	3
45803527	1310149	0	0
45788254	19073183	2	3
45801547	1125315	0	0
46299687	1129625	0	0
46308948	738818	0	0
46309738	19019273	2	3
1149380	1149380	0	0
21001770	1107830	0	0
21000227	46233710	2	3
21503969	40162522	3	4
21604253	1124957	3	3
36154746	1119510	0	0
36198941	738818	0	0
40143224	40221415	2	2
42803989	1759842	0	0
44356021	1125315	0	0
44347247	1124300	0	0
45628468	1332418	0	0
45622415	1125315	0	0
45638309	40232448	2	3
44337293	1125315	0	0
45629712	1119510	0	0
45642027	1539403	0	0
45655435	40232448	2	3
45683253	1125315	0	0
45698709	1112807	0	0
45700721	1129625	0	0
45700783	1125315	0	0
45784871	1119510	0	0
45780485	933724	0	0
45696867	723013	0	0
45789995	1551192	2	3
45803462	1107830	0	0
46293988	40163554	2	3
45801835	1125315	0	0
46300044	1129625	0	0
46308896	738818	0	0
46309912	40232448	2	3
1149196	1149196	0	0
21001750	1729720	0	0
21003377	19112599	2	3
21504600	19059056	3	4
21501034	914335	3	3
36154748	1119510	0	0
36198943	19127890	0	0
40143224	19128022	2	2
42804015	920293	0	0
44356129	1125315	0	0
44347249	1129625	0	0
45628516	975125	0	0
45622416	1125315	0	0
45638248	19008572	2	3
44337314	1125315	0	0
45626702	1119510	0	0
45642029	1713332	0	0
45655567	40228214	2	3
45685232	1125315	0	0
45695312	1112807	0	0
45700710	1129625	0	0
45700784	1125315	0	0
45785016	1119510	0	0
45780571	1112807	0	0
45802672	967823	0	0
45790118	42707627	2	3
45803507	1115008	0	0
46293933	1115171	2	3
45801891	1125315	0	0
46300195	1129625	0	0
46309307	738818	0	0
46309938	46233710	2	3
1137529	1137529	0	0
21001750	1717327	0	0
21003377	43012036	2	3
21503884	19078924	3	4
21500897	975125	3	3
36154751	1119510	0	0
36198943	1589505	0	0
40143224	19128263	2	2
42803920	1361711	0	0
44356143	1125315	0	0
44347441	1729720	0	0
45628629	967823	0	0
45622546	1125315	0	0
45640184	40223768	2	3
44337421	1125315	0	0
45626699	1119510	0	0
45642157	1501700	0	0
45654870	43012036	2	3
45685243	1125315	0	0
45695278	1112807	0	0
45700715	1129625	0	0
45700828	1125315	0	0
45785024	1119510	0	0
45780429	1000560	0	0
45802697	1124300	0	0
45790188	40229134	2	3
45803509	1124957	0	0
46293662	1551192	2	3
45801724	1125315	0	0
46300404	1129625	0	0
46307005	738818	0	0
46310159	40231925	2	3
1153428	1153428	0	0
21001758	1729720	0	0
21001119	40236446	2	3
21505694	19123231	3	4
21500897	1343916	3	3
36154564	1119510	0	0
36198943	1549786	0	0
40143224	19128065	2	2
42803671	1000560	0	0
44356160	1125315	0	0
44347448	1149196	0	0
45628472	1115008	0	0
45622723	1125315	0	0
45640244	35605482	2	3
44337784	1125315	0	0
45628024	1119510	0	0
45641926	1728416	0	0
45654815	19079524	2	3
45685519	1125315	0	0
45695501	1112807	0	0
45648781	1129625	0	0
45700834	1125315	0	0
45785125	1119510	0	0
45780494	1322184	0	0
45802664	1000560	0	0
45787360	40169281	2	3
45803537	1308738	0	0
46293780	1115171	2	3
45801808	1125315	0	0
46296124	1129625	0	0
46320362	738818	0	0
46310117	40236824	2	3
1150770	1150770	0	0
21001745	1717327	0	0
21009234	46275444	2	3
21505694	40236446	3	4
21500897	1738521	3	3
36154812	1119510	0	0
36198946	1192710	0	0
37203772	28060	2	2
42804005	1125315	0	0
44356162	1125315	0	0
44347057	1112807	0	0
45628477	1307863	0	0
45622726	1125315	0	0
45640073	1115171	2	3
44338021	1125315	0	0
45628210	1119510	0	0
45641939	1310149	0	0
45654824	19008572	2	3
45685567	1125315	0	0
45695326	1112807	0	0
45648929	1129625	0	0
45697940	1125315	0	0
45785127	1119510	0	0
45780496	1149196	0	0
45802720	1549786	0	0
45787256	40229134	2	3
45803515	1149196	0	0
46294059	43012036	2	3
45801809	1125315	0	0
46296315	1129625	0	0
46320454	738818	0	0
46304344	19019273	2	3
1150771	1150771	0	0
21001750	1768849	0	0
21002333	19073188	2	3
21500522	19076374	3	4
21500897	1119510	3	3
36152179	1119510	0	0
36198947	1129625	0	0
36718599	4066995	2	2
42804036	1551099	0	0
44352657	1125315	0	0
44347062	1129625	0	0
45628491	738818	0	0
45622667	1125315	0	0
45638461	40236446	2	3
44337614	1125315	0	0
45623749	1119510	0	0
45641755	1192710	0	0
45651176	1115171	2	3
45680082	1125315	0	0
45691997	1112807	0	0
45649083	1129625	0	0
45697921	1125315	0	0
45785160	1119510	0	0
45780652	1112807	0	0
45802720	19127890	0	0
45787416	1115171	2	3
45803493	1149196	0	0
46294474	19133873	2	3
45801875	1125315	0	0
46318402	1129625	0	0
46320366	738818	0	0
46304653	19076374	2	3
1150836	1150836	0	0
21001750	1738521	0	0
21002333	19073183	2	3
21604253	1127078	3	6
21604564	19115351	3	3
36152180	1119510	0	0
36198968	1589505	0	0
40072443	19127922	2	2
42804037	1000560	0	0
44352659	1125315	0	0
44347203	1332418	0	0
45628607	1539403	0	0
45622743	1125315	0	0
45638468	19129655	2	3
44337534	1125315	0	0
45624070	1119510	0	0
45642040	1124957	0	0
45651215	1115171	2	3
45680272	1125315	0	0
45692063	1112807	0	0
45649086	1129625	0	0
45697884	1125315	0	0
45785161	1119510	0	0
45780667	1153428	0	0
45802720	1521369	0	0
45803242	19019273	2	3
45803574	1367571	0	0
46243663	40229134	2	3
45801876	1125315	0	0
46318709	1129625	0	0
46320410	738818	0	0
46304664	40165015	2	3
926487	926487	0	0
21001770	1551099	0	0
21003376	46275916	2	3
21604253	1127433	3	6
21500937	975125	3	3
36152299	1119510	0	0
36198968	1549786	0	0
40072443	19133679	2	2
42804038	1551099	0	0
44352665	1125315	0	0
44347233	1112807	0	0
45628300	1110410	0	0
45622855	1125315	0	0
45638568	1551192	2	3
44337655	1125315	0	0
45624072	1119510	0	0
45642054	1174888	0	0
45651166	40163554	2	3
45680056	1125315	0	0
45692344	1112807	0	0
45649130	1129625	0	0
45697901	1125315	0	0
45784952	1119510	0	0
45780669	1521369	0	0
45802792	1521369	0	0
45785861	19019273	2	3
45803577	975125	0	0
46243860	1127433	2	3
45802418	1125315	0	0
46318617	1129625	0	0
46320434	738818	0	0
46304703	40232448	2	3
926488	19045231	0	0
21001770	1129625	0	0
21003376	40232448	2	3
21604685	40222846	3	6
21500837	1759842	3	3
36152328	1119510	0	0
36199670	1107830	0	0
40072443	19129144	2	2
42804039	1551099	0	0
44353334	1125315	0	0
44346991	1589505	0	0
45628302	1107830	0	0
45622863	1125315	0	0
45638475	40232448	2	3
44337586	1125315	0	0
45624074	1119510	0	0
45638661	1149196	0	0
45651359	1115171	2	3
45680324	1125315	0	0
45694661	1112807	0	0
45645587	1129625	0	0
45698022	1125315	0	0
45784843	1119510	0	0
45780669	1549786	0	0
45802792	1548195	0	0
45787533	1107882	2	3
45803538	791967	0	0
46243809	19008572	2	3
45802521	1125315	0	0
46318725	1129625	0	0
46320671	738818	0	0
46305172	40229134	2	3
933724	933724	0	0
21001770	1153428	0	0
21000219	46233988	2	3
21604685	836659	3	6
21500837	975125	3	3
36152425	1119510	0	0
36151808	705944	0	0
40483287	198199	2	2
42803675	1713332	0	0
44352823	1125315	0	0
44343221	738818	0	0
45628194	1549786	0	0
45622950	1125315	0	0
45638513	19018935	2	3
45622047	1125315	0	0
45623843	1119510	0	0
45638609	1153428	0	0
45651406	1107882	2	3
45680090	1125315	0	0
45694621	1112807	0	0
45645745	1129625	0	0
45698023	1125315	0	0
45785137	1119510	0	0
45780386	1343916	0	0
45802796	1589505	0	0
46292244	46233710	2	3
45803605	1326303	0	0
46244772	40229134	2	3
45802532	1125315	0	0
46319029	1129625	0	0
46320918	738818	0	0
46304840	1115171	2	3
753626	753626	0	0
21001770	1125315	0	0
21000219	46233710	2	3
21604685	40236446	3	6
21500837	1124300	3	3
36152156	1119510	0	0
36151796	19127890	0	0
37521794	4323902	2	2
42803922	1551099	0	0
44352826	1125315	0	0
44343227	1738521	0	0
45628194	19127890	0	0
45622553	1125315	0	0
45638843	19076374	2	3
45622031	1125315	0	0
45623671	1119510	0	0
45638671	1322184	0	0
45651493	19133873	2	3
45680295	1125315	0	0
45689145	1112807	0	0
45642679	1129625	0	0
45697994	1125315	0	0
45785078	1119510	0	0
46244952	1332418	0	0
45802671	1153428	0	0
45894962	19078924	2	3
45803606	1729720	0	0
46244780	40229134	2	3
45802469	1125315	0	0
46319038	1129625	0	0
46315054	738818	0	0
46304968	19008572	2	3
1332419	1332419	0	0
21001770	1150836	0	0
21003153	40229134	2	3
21601744	1332419	3	6
21500837	967823	3	3
36158570	1119510	0	0
36151796	1549786	0	0
37521794	4337611	2	2
42804022	1125315	0	0
44352769	1125315	0	0
44343068	1177480	0	0
45628194	1589505	0	0
45622557	1125315	0	0
45638624	40163554	2	3
45621917	1125315	0	0
45623792	1119510	0	0
45638610	1192710	0	0
45651382	19133905	2	3
45680301	1125315	0	0
45689185	1112807	0	0
45642689	1129625	0	0
45697997	1125315	0	0
45785220	1119510	0	0
46244955	1112807	0	0
45802710	1738521	0	0
45785995	19079524	2	3
45803610	1307863	0	0
46244899	40232448	2	3
45799052	1125315	0	0
46312996	1129625	0	0
46314899	738818	0	0
46304973	19129655	2	3
4168666	4043241	4	4
21001770	1150770	0	0
21000235	46233988	2	3
21601238	1310034	3	6
21500837	1308738	3	3
36158653	1119510	0	0
36151796	1512674	0	0
37521353	4163971	2	2
42804022	1124957	0	0
44353037	1125315	0	0
44343312	791967	0	0
45628639	1539403	0	0
45622867	1125315	0	0
45635392	19073183	2	3
45622214	1125315	0	0
45623800	1119510	0	0
45638726	738818	0	0
45651388	40163554	2	3
45680560	1125315	0	0
45689366	1112807	0	0
45642702	1129625	0	0
45698008	1125315	0	0
45784959	1119510	0	0
46244771	715997	0	0
45802807	715997	0	0
46240791	19078461	2	3
45803615	1192710	0	0
46244882	40232448	2	3
45798986	1125315	0	0
46312710	1129625	0	0
46314821	738818	0	0
46304776	19018935	2	3
4133611	375671	4	4
21001775	1112807	0	0
21000235	46233710	2	3
21601238	19018935	3	6
21500837	19010482	3	3
36158620	1119510	0	0
36151801	1713332	0	0
37203774	40481087	2	2
42803851	1713332	0	0
44353209	1125315	0	0
44343315	1115008	0	0
45628317	1501700	0	0
45622744	1125315	0	0
45635251	40229134	2	3
45622177	1125315	0	0
45624095	1119510	0	0
45638781	791967	0	0
45651414	19008572	2	3
45680379	1125315	0	0
45686256	1112807	0	0
45642709	1129625	0	0
45698123	1125315	0	0
45785090	1119510	0	0
46244854	715997	0	0
45802753	1112807	0	0
45792099	1107882	2	3
45803583	975125	0	0
46244052	1115171	2	3
45799108	1125315	0	0
46312697	1129625	0	0
46314940	738818	0	0
46305115	1115171	2	3
4133611	378001	4	4
21001775	1177480	0	0
21002299	920300	2	3
21603365	19029476	3	6
21500837	914335	3	3
36158602	1119510	0	0
36151803	738818	0	0
36776613	4029498	2	2
42803851	1759842	0	0
44352868	1125315	0	0
44343317	1115008	0	0
45628439	1307863	0	0
45622937	1125315	0	0
45635260	1115171	2	3
44358676	1125315	0	0
45624055	1119510	0	0
45638782	1115008	0	0
45651690	19019273	2	3
45680327	1125315	0	0
45686286	1112807	0	0
45642813	1129625	0	0
45697972	1125315	0	0
45785092	1119510	0	0
46244935	1154343	0	0
45802891	1322184	0	0
45800064	40174880	2	3
45803559	1551099	0	0
46244005	40162522	2	3
45798990	1125315	0	0
46313039	1129625	0	0
46314979	738818	0	0
46305189	43012036	2	3
4115574	198809	4	4
21001775	1115008	0	0
21002299	920334	2	3
21600491	35605482	3	5
21500837	1343916	3	3
36158705	1119510	0	0
36151827	1115008	0	0
40785765	3006734	2	2
42803852	1125315	0	0
44353153	1125315	0	0
44343282	1307863	0	0
45628357	1551099	0	0
45622742	1125315	0	0
45635439	46275916	2	3
45658557	1125315	0	0
45624056	1119510	0	0
45638882	1728416	0	0
45651717	46233710	2	3
45680391	1125315	0	0
45686382	1112807	0	0
45642870	1129625	0	0
45697977	1125315	0	0
45785093	1119510	0	0
46244726	975125	0	0
45802769	975125	0	0
45795071	40223768	2	3
45803566	1521369	0	0
46243993	1115171	2	3
45799221	1125315	0	0
46313058	1129625	0	0
46314910	738818	0	0
46305279	19008572	2	3
4154161	81151	4	4
21001759	1729720	0	0
21500176	40173590	2	3
35400000	372328	3	5
21500837	1738521	3	3
36158708	1119510	0	0
36152003	1768849	0	0
40785766	3023430	2	2
42803855	1759842	0	0
44352878	1125315	0	0
44343426	1539403	0	0
45625268	1332418	0	0
45622974	1125315	0	0
45635408	40232448	2	3
45658396	1125315	0	0
45623998	1119510	0	0
45638885	1589505	0	0
45648185	40231925	2	3
45680404	1125315	0	0
45686399	1112807	0	0
45642878	1129625	0	0
45698171	1125315	0	0
45785099	1119510	0	0
46244683	1149196	0	0
45803035	1521369	0	0
45795397	40228214	2	3
45803647	967823	0	0
46240097	19008572	2	3
45799246	1125315	0	0
46313118	1129625	0	0
46317746	738818	0	0
46304801	1154615	2	3
4177094	42535580	4	4
21001772	738818	0	0
21003375	40232448	2	3
21601239	19018935	2	5
21500943	975125	3	3
36158872	1119510	0	0
36152004	1192710	0	0
40785850	3006906	2	2
42803855	1713332	0	0
44352879	1125315	0	0
44343241	1713332	0	0
45625190	1361711	0	0
45622774	1125315	0	0
45635185	40174880	2	3
45658432	1125315	0	0
45623692	1119510	0	0
45638829	1396131	0	0
45648308	19078461	2	3
45680469	1125315	0	0
45686582	1112807	0	0
45691237	1129625	0	0
45698205	1125315	0	0
45785228	1119510	0	0
46244684	975125	0	0
45803035	1549786	0	0
45789647	19075001	2	3
45803632	1551099	0	0
46238918	1107882	2	3
45799337	1125315	0	0
46313127	1129625	0	0
46317164	738818	0	0
46304686	19019273	2	3
4028876	258780	4	4
21001751	1713332	0	0
21002321	19129655	2	3
21503664	40231925	2	3
21600962	40163554	1	4
36150703	1119510	0	0
36151666	1177480	0	0
40785861	3013721	2	2
42804076	1124300	0	0
44352881	1125315	0	0
44343243	1115008	0	0
45625474	1153428	0	0
45622776	1125315	0	0
45635506	19018935	2	3
45658452	1125315	0	0
45667988	1119510	0	0
45638838	1154029	0	0
45648209	40232448	2	3
45680471	1125315	0	0
45683517	1112807	0	0
45639704	1129625	0	0
45698214	1125315	0	0
45785175	1119510	0	0
46244943	1153428	0	0
45803039	1153428	0	0
45789720	19073183	2	3
45803584	1539403	0	0
46238968	1127433	2	3
45799339	1125315	0	0
46312877	1129625	0	0
46309502	738818	0	0
46321409	43012036	2	3
4042677	4216130	4	4
21001775	1129625	0	0
21002321	19073188	2	3
21502623	1713671	2	3
21604793	836659	1	4
36150708	1119510	0	0
36151666	1129625	0	0
40785869	3014576	2	2
42803926	1759842	0	0
44352894	1125315	0	0
44343172	1545958	0	0
45625260	1343916	0	0
45623166	1125315	0	0
45635508	40228230	2	3
45658585	1125315	0	0
45667991	1119510	0	0
45638943	1149196	0	0
45649231	19059056	2	3
45680475	1125315	0	0
45683405	1112807	0	0
45685826	1129625	0	0
45698215	1125315	0	0
45786482	1119510	0	0
45777781	1713332	0	0
45802744	1192710	0	0
46296356	19073183	2	3
45803699	1000560	0	0
46238965	40232448	2	3
45799173	1125315	0	0
46307761	1129625	0	0
46309910	738818	0	0
46320884	1154615	2	3
4043670	4323208	4	4
21001752	1125315	0	0
21002321	19073183	2	3
21504555	44816277	2	3
21600985	19075601	1	4
36150740	1119510	0	0
36151669	1738521	0	0
37602361	192671	2	3
42803681	1326303	0	0
44352720	1125315	0	0
44342974	1174888	0	0
45625370	1521369	0	0
45621237	1125315	0	0
45635314	19059056	2	3
45658698	1125315	0	0
45667780	1119510	0	0
45639028	1124957	0	0
45649241	1107882	2	3
45680258	1125315	0	0
45683244	1112807	0	0
45636740	1129625	0	0
45648770	1125315	0	0
45786243	1119510	0	0
45777781	1759842	0	0
45802773	738818	0	0
45797517	19073183	2	3
45800750	19127890	0	0
46238980	1115171	2	3
45799353	1125315	0	0
46307740	1129625	0	0
46309572	738818	0	0
46321637	19059056	2	3
4027384	198199	4	4
21001752	1119510	0	0
21000217	46233988	2	3
21500512	40236824	2	3
21500893	975125	1	1
36150855	1119510	0	0
36151714	1153428	0	0
37203764	317009	2	3
42803926	1713332	0	0
44352907	1125315	0	0
44342996	723013	0	0
45625370	1595799	0	0
45621112	1125315	0	0
45635599	1115171	2	3
45658699	1125315	0	0
45670049	1119510	0	0
45639036	1738521	0	0
45648325	19018935	2	3
45680497	1125315	0	0
45680051	1112807	0	0
45636835	1129625	0	0
45694826	1125315	0	0
45786250	1119510	0	0
45777784	1000560	0	0
45802776	1501700	0	0
45792111	19079524	2	3
45800750	1589505	0	0
46238981	43012036	2	3
45799354	1125315	0	0
46307504	1129625	0	0
46304428	738818	0	0
46321206	46275444	2	3
4042673	40492359	4	4
21001773	1192710	0	0
21000217	46233710	2	3
21005679	19073183	2	3
21500928	975125	1	1
36150834	1119510	0	0
36151722	1177480	0	0
37203772	40481087	2	3
42803684	1713332	0	0
44353181	1125315	0	0
44343377	1759842	0	0
45625370	1549786	0	0
45621129	1125315	0	0
45635324	40174880	2	3
45658700	1125315	0	0
45670079	1119510	0	0
45638898	1192710	0	0
45648455	1127433	2	3
45680612	1125315	0	0
45680173	1112807	0	0
45636991	1129625	0	0
45694552	1125315	0	0
45782873	1119510	0	0
45777732	1305058	0	0
45802783	975125	0	0
45785504	1107882	2	3
45800893	1192710	0	0
46239068	19019273	2	3
45799355	1125315	0	0
46307620	1129625	0	0
46304430	738818	0	0
46321589	40232448	2	3
4115259	260139	4	4
21001752	1192710	0	0
21011482	1551192	2	3
21500438	40243436	2	3
21500931	975125	1	1
36150663	1119510	0	0
36151828	1129625	0	0
37203774	4112343	2	3
42803856	1000560	0	0
44353126	1125315	0	0
44343377	1713332	0	0
45625171	1154343	0	0
45621288	1125315	0	0
45632321	40236824	2	3
45658796	1125315	0	0
45670312	1119510	0	0
45638971	1738521	0	0
45648379	19059056	2	3
45680625	1125315	0	0
45680379	1112807	0	0
45682789	1129625	0	0
45694553	1125315	0	0
45782822	1119510	0	0
45777665	1332418	0	0
45802787	1112807	0	0
45894991	1107882	2	3
45800833	1112807	0	0
46238998	19008572	2	3
45799350	1125315	0	0
46307917	1129625	0	0
46304633	738818	0	0
46321645	19059056	2	3
4091213	195588	4	4
21001773	1150836	0	0
21012460	40222846	2	3
21505616	46275916	2	3
21500919	1738521	1	1
36156431	1119510	0	0
36151830	1501700	0	0
40484533	439777	2	3
42803971	1545958	0	0
44353190	1125315	0	0
44343359	1174888	0	0
45625299	1308738	0	0
45622017	1125315	0	0
45632295	19074843	2	3
45659004	1125315	0	0
45670090	1119510	0	0
45638777	1307863	0	0
45648318	19008572	2	3
45680513	1125315	0	0
45680513	1112807	0	0
45682806	1129625	0	0
45694812	1125315	0	0
45782826	1119510	0	0
45777733	1332418	0	0
45802860	1000560	0	0
45795153	19075001	2	3
45800836	1589505	0	0
46239002	920300	2	3
45799126	1125315	0	0
46308365	1129625	0	0
46304672	738818	0	0
46315335	35605482	2	3
4044022	4301346	4	4
21001752	738818	0	0
21001425	19059056	2	3
21002124	46275444	2	3
21500891	975125	1	1
36155451	1119510	0	0
36151955	1177480	0	0
37019275	4116491	2	3
42803974	1713332	0	0
44353228	1125315	0	0
44343100	1729720	0	0
45625445	1729720	0	0
45621831	1125315	0	0
45632522	19078924	2	3
45658469	1125315	0	0
45668071	1119510	0	0
45639059	1759842	0	0
45648510	40232448	2	3
45680344	1125315	0	0
45680648	1112807	0	0
45682988	1129625	0	0
45694787	1125315	0	0
45783017	1119510	0	0
45777670	1545958	0	0
45802861	738818	0	0
45789090	1107882	2	3
45800960	1174888	0	0
46239101	19008572	2	3
45799213	1125315	0	0
46308397	1129625	0	0
46305172	738818	0	0
46315470	19018935	2	3
4103320	28060	4	4
21001752	1129625	0	0
21003205	43012036	2	3
21602884	19075001	2	3
21500856	914335	1	1
36155565	1119510	0	0
36151960	1112807	0	0
37302323	133834	2	9
42803684	1759842	0	0
44348757	1125315	0	0
44343071	1129625	0	0
45625406	791967	0	0
45621782	1125315	0	0
45632355	40229134	2	3
45658656	1125315	0	0
45668117	1119510	0	0
45639059	1713332	0	0
45648630	40229134	2	3
45680373	1125315	0	0
45677128	1112807	0	0
45682829	1129625	0	0
45695104	1125315	0	0
45783022	1119510	0	0
45777670	1332418	0	0
45802730	738818	0	0
45798005	1107882	2	3
45800854	1501700	0	0
46239220	1115171	2	3
45799220	1125315	0	0
46308380	1129625	0	0
46304936	738818	0	0
46315968	40229134	2	3
4103320	257012	4	4
21001762	1551099	0	0
21002690	19008572	2	3
21011856	1713671	2	3
21500951	1124300	1	1
36155438	1119510	0	0
36151966	1112807	0	0
37203764	4280726	2	8
42804080	1778162	0	0
44348782	1125315	0	0
44343072	1112807	0	0
45625378	738818	0	0
45622001	1125315	0	0
45632571	19075601	2	3
45658838	1125315	0	0
45668118	1119510	0	0
45639037	791967	0	0
45648575	40228214	2	3
45680644	1125315	0	0
45677129	1112807	0	0
45682832	1129625	0	0
45694822	1125315	0	0
45783033	1119510	0	0
45777734	1545958	0	0
45802869	791967	0	0
45789666	1107882	2	3
45800674	1149196	0	0
45894575	19078461	2	3
45799400	1125315	0	0
46302850	1129625	0	0
46321331	738818	0	0
46315547	1115171	2	3
4115390	317576	4	4
21001770	1119510	0	0
21001191	1551192	2	3
21500285	19112599	2	3
21500953	1129625	1	1
36155439	1119510	0	0
36151884	1738521	0	0
37203764	261325	2	8
42804084	1125315	0	0
44348904	1125315	0	0
44343265	1154343	0	0
45625483	1149196	0	0
45621315	1125315	0	0
45632627	19008572	2	3
45658843	1125315	0	0
45668145	1119510	0	0
45639142	1539403	0	0
45645048	40228214	2	3
45680689	1125315	0	0
45677008	1112807	0	0
45633686	1129625	0	0
45694915	1125315	0	0
45783154	1119510	0	0
45777688	1549786	0	0
45802908	1154343	0	0
45894495	1107882	2	3
45800919	1746114	0	0
45894661	1127433	2	3
45793996	1125315	0	0
46302693	1129625	0	0
46321595	738818	0	0
46315566	1127433	2	3
4086181	380378	4	4
21001445	1361711	0	0
21001379	19075001	2	3
21500285	43012036	2	3
21500995	1396131	1	1
36155440	1119510	0	0
36151786	1177480	0	0
37203764	257012	2	7
42804049	1125315	0	0
44348968	1125315	0	0
44343272	1129625	0	0
45625340	1192710	0	0
45621318	1125315	0	0
45632518	19059056	2	3
45658479	1125315	0	0
45668211	1119510	0	0
45639084	1501700	0	0
45645269	19126352	2	3
45680690	1125315	0	0
45679674	1112807	0	0
45633761	1129625	0	0
45694921	1125315	0	0
45782999	1119510	0	0
45777688	1521369	0	0
45802918	1174888	0	0
45797674	1107882	2	3
45800919	1741122	0	0
45894438	40162522	2	3
45793771	1125315	0	0
46302759	1129625	0	0
46315373	738818	0	0
46315754	19018935	2	3
4168644	4219399	4	4
21001447	1361711	0	0
21000228	46233710	2	3
21505695	19123231	2	3
21501009	967823	1	1
36155400	1119510	0	0
36151788	1129625	0	0
37602356	317576	2	6
42804049	1174888	0	0
44348974	1125315	0	0
44343157	1551099	0	0
45625492	920293	0	0
45621447	1125315	0	0
45632365	40232448	2	3
45658610	1125315	0	0
45668143	1119510	0	0
45638997	740275	0	0
45645280	40232448	2	3
45680694	1125315	0	0
45679431	1112807	0	0
45633733	1129625	0	0
45695066	1125315	0	0
45783130	1119510	0	0
45777696	1174888	0	0
45802922	1332418	0	0
45785796	40228214	2	3
45800921	1738521	0	0
45893691	19078461	2	3
45794130	1125315	0	0
46302946	1129625	0	0
46315968	738818	0	0
46315875	19019273	2	3
4168644	4240902	4	4
21001447	1112807	0	0
21000228	46233988	2	3
21005672	40163554	2	3
21501052	1125315	1	1
36155415	1119510	0	0
36151929	1192710	0	0
37602356	4329847	2	6
42804051	1551099	0	0
44349060	1125315	0	0
44343391	19127890	0	0
45625288	1154029	0	0
45664835	1125315	0	0
45632474	19077572	2	3
45658792	1125315	0	0
45668339	1119510	0	0
45638998	1149196	0	0
45645440	19078924	2	3
45676886	1125315	0	0
45677170	1112807	0	0
45630896	1129625	0	0
45697585	1125315	0	0
45783131	1119510	0	0
45777696	1192710	0	0
45802877	1500211	0	0
46292356	1107882	2	3
45800952	1332418	0	0
45801383	1115171	2	3
45793882	1125315	0	0
46302977	1129625	0	0
46311900	738818	0	0
46310132	19008572	2	3
4168644	433644	4	4
21001435	1361711	0	0
21000244	19133873	2	3
21005673	40163554	2	3
21500940	975125	1	1
36155443	1119510	0	0
36151616	1107830	0	0
37602360	381316	2	5
42804052	1551099	0	0
44349019	1125315	0	0
44343391	1549786	0	0
45625290	1192710	0	0
45664972	1125315	0	0
45632489	19023398	2	3
45658753	1125315	0	0
45665962	1119510	0	0
45638816	1717327	0	0
45645485	40228230	2	3
45677014	1125315	0	0
45677401	1112807	0	0
45630856	1129625	0	0
45645903	1125315	0	0
45783196	1119510	0	0
45777698	757627	0	0
45803046	975125	0	0
45797618	1107882	2	3
45800664	1738521	0	0
45801409	40232448	2	3
45793709	1125315	0	0
46302979	1129625	0	0
46311849	738818	0	0
46309613	19008572	2	3
4168644	37017711	4	4
21001447	1367571	0	0
21000244	19073188	2	3
21505633	19059056	2	3
21500962	1124300	1	1
36155353	1119510	0	0
36151885	1177480	0	0
37019275	195588	2	5
42804058	1729720	0	0
44349082	1125315	0	0
44343394	1153428	0	0
45625293	1174888	0	0
45664906	1125315	0	0
45629291	40223834	2	3
45658770	1125315	0	0
45666059	1119510	0	0
45638825	723013	0	0
45645554	1551192	2	3
45676699	1125315	0	0
45677269	1112807	0	0
45630826	1129625	0	0
45691604	1125315	0	0
45783111	1119510	0	0
45777769	1307863	0	0
45803049	1551099	0	0
45787257	1107882	2	3
45800787	975125	0	0
45801482	40232448	2	3
45794081	1125315	0	0
46303186	1129625	0	0
46310653	738818	0	0
46310234	19019273	2	3
4091363	28060	4	4
21000538	1551099	0	0
21000242	46233988	2	3
21013864	19059056	2	3
21502659	1129625	1	1
36155356	1119510	0	0
36151974	1129625	0	0
37604009	317576	2	5
42803995	975125	0	0
44349085	1125315	0	0
44343370	1149196	0	0
45625272	1174888	0	0
45664927	1125315	0	0
45629377	1115171	2	3
45658774	1125315	0	0
45665665	1119510	0	0
45638863	708298	0	0
45645940	19008572	2	3
45677128	1125315	0	0
45674250	1112807	0	0
45630907	1129625	0	0
45691897	1125315	0	0
45783314	1119510	0	0
45777770	1112807	0	0
45803051	1154343	0	0
45792513	1107882	2	3
45801015	1713332	0	0
45801754	19133905	2	3
45794091	1125315	0	0
46303294	1129625	0	0
46310656	738818	0	0
46311849	40229134	2	3
4091532	440448	4	4
21000539	1548195	0	0
21002691	19008572	2	3
21013911	19076374	2	3
21502659	1115008	1	1
36155369	1119510	0	0
36151985	1309944	0	0
37203772	4112343	2	4
42803999	1539403	0	0
44349041	1125315	0	0
44343490	1177480	0	0
45625382	1154029	0	0
45664934	1125315	0	0
45629442	19018935	2	3
45658671	1125315	0	0
45666049	1119510	0	0
45635670	1115008	0	0
45642530	19073188	2	3
45676862	1125315	0	0
45674376	1112807	0	0
45630999	1129625	0	0
45691529	1125315	0	0
45783315	1119510	0	0
45778232	1192710	0	0
45803052	738818	0	0
45789665	1107882	2	3
45801016	1115008	0	0
45801589	1551192	2	3
45793926	1125315	0	0
46303457	1129625	0	0
46310770	738818	0	0
46310321	40163554	2	3
4168335	4230399	4	4
21000537	1549786	0	0
21001385	19133873	2	3
21013911	19078924	2	3
21502659	1308738	1	1
36155389	1119510	0	0
36152110	1717327	0	0
37203772	4294548	2	4
42804001	1124300	0	0
44349122	1125315	0	0
44343330	1322184	0	0
45625409	1000560	0	0
45664883	1125315	0	0
45629169	19133768	2	3
45658945	1125315	0	0
45665887	1119510	0	0
45635421	723013	0	0
45642448	19073183	2	3
45677133	1125315	0	0
45674032	1112807	0	0
45631000	1129625	0	0
45691530	1125315	0	0
45783141	1119510	0	0
45778234	1112807	0	0
45803053	914335	0	0
46238436	40173590	2	3
45801176	1746114	0	0
45801612	1154615	2	3
45794199	1125315	0	0
46300450	1129625	0	0
46304885	738818	0	0
46310443	19078461	2	3
4168335	4156265	4	4
21000534	1500211	0	0
21001834	19074841	2	3
21500371	40169216	2	3
21502621	1717327	1	1
36155483	1119510	0	0
36151936	1551099	0	0
37019275	198199	2	4
42804023	1177480	0	0
44348797	1125315	0	0
44343534	1124957	0	0
45625388	1154029	0	0
45665097	1125315	0	0
45629169	40162522	2	3
45658499	1125315	0	0
45666221	1119510	0	0
45635623	1713332	0	0
45642627	40162522	2	3
45679502	1125315	0	0
45671009	1112807	0	0
45676304	1129625	0	0
45691666	1125315	0	0
45783081	1119510	0	0
45778058	1738521	0	0
45802762	1112807	0	0
45800400	1107882	2	3
45801176	1741122	0	0
45801566	40229134	2	3
45794247	1125315	0	0
46300566	1129625	0	0
46305082	738818	0	0
46310326	43012036	2	3
4090614	4048171	4	4
21000544	1305058	0	0
21000223	46233988	2	3
21002122	46275444	2	3
21502621	1713332	1	1
36155491	1119510	0	0
36152085	738818	0	0
37503995	4336464	1	5
42804024	1551099	0	0
44349106	1125315	0	0
44343411	1129625	0	0
45625538	1539403	0	0
45665187	1125315	0	0
45629387	19008572	2	3
45658947	1125315	0	0
45666175	1119510	0	0
45635623	1759842	0	0
45642602	19076374	2	3
45679472	1125315	0	0
45671385	1112807	0	0
45628233	1129625	0	0
45691682	1125315	0	0
45782946	1119510	0	0
45778069	1174888	0	0
45802989	1174888	0	0
46292423	19078461	2	3
45800782	975125	0	0
45801442	920334	2	3
45794251	1125315	0	0
46301117	1129625	0	0
46305571	738818	0	0
46310328	1115171	2	3
4028387	134438	4	4
21000538	1548195	0	0
21000223	46233710	2	3
21005680	19073188	2	3
21502621	1746114	1	1
36155507	1119510	0	0
36152112	1177480	0	0
37203772	257012	1	2
42804072	1713332	0	0
44351751	1125315	0	0
44343342	791967	0	0
45625719	1539403	0	0
45665020	1125315	0	0
45629179	40232448	2	3
45658954	1125315	0	0
45663761	1119510	0	0
45635627	1192710	0	0
45642585	40232448	2	3
45677185	1125315	0	0
45671389	1112807	0	0
45628288	1129625	0	0
45691920	1125315	0	0
45783143	1119510	0	0
45778121	967823	0	0
45802977	1305058	0	0
46292098	1332419	2	3
45800968	1192710	0	0
45801699	19018935	2	3
45794121	1125315	0	0
46319483	1129625	0	0
46305574	738818	0	0
46310447	46275444	2	3
4042835	4280726	4	4
21000548	1305058	0	0
21000213	46233988	2	3
21005680	19073183	2	3
21502621	1741122	1	1
36155581	1119510	0	0
36152087	753626	0	0
40244879	1125315	0	0
42804073	1713332	0	0
44351755	1125315	0	0
44343435	740275	0	0
45625816	1521369	0	0
45665025	1125315	0	0
45629567	40232448	2	3
45658959	1125315	0	0
45663772	1119510	0	0
45635577	1124300	0	0
45642580	40228230	2	3
45677144	1125315	0	0
45669459	1112807	0	0
45627864	1129625	0	0
45691965	1125315	0	0
45783205	1119510	0	0
45778122	975125	0	0
45802979	1174888	0	0
45800530	1332419	2	3
45801070	1728416	0	0
45801704	1115171	2	3
45794125	1125315	0	0
46319580	1129625	0	0
46305332	738818	0	0
46310512	1551192	2	3
4042835	40486433	4	4
21000565	1305058	0	0
21000213	46233710	2	3
21009232	46233988	2	3
21500479	975125	1	1
36155462	1119510	0	0
36151674	1115008	0	0
40244879	1174888	0	0
42804075	1361711	0	0
44349157	1125315	0	0
44343476	1177480	0	0
45625816	19127890	0	0
45665108	1125315	0	0
45629572	1115171	2	3
45659108	1125315	0	0
45663710	1119510	0	0
45635582	1192710	0	0
45642491	40163554	2	3
45677235	1125315	0	0
45669924	1112807	0	0
45627955	1129625	0	0
45691967	1125315	0	0
45783207	1119510	0	0
45778040	1332418	0	0
45802817	1713332	0	0
45802823	40173590	2	3
45800765	791967	0	0
45801710	40223768	2	3
45794198	1125315	0	0
46319624	1129625	0	0
46321817	738818	0	0
46310656	40229134	2	3
4028908	40478878	4	4
21000594	1539403	0	0
21000243	46233988	2	3
21010168	19007333	2	3
21500522	791967	1	1
36155749	1119510	0	0
36151951	1000560	0	0
40244689	1177480	0	0
42804026	1539403	0	0
44349161	1125315	0	0
44343492	1129625	0	0
45625816	1503184	0	0
45665229	1125315	0	0
45629366	35605482	2	3
45659035	1125315	0	0
45663323	1119510	0	0
45635487	1310149	0	0
45642529	19078461	2	3
45677188	1125315	0	0
45781369	1112807	0	0
45628043	1129625	0	0
45691969	1125315	0	0
45783333	1119510	0	0
45778079	975125	0	0
45802881	1115008	0	0
45800081	19075601	2	3
45800969	1557272	0	0
45795901	40229134	2	3
45794055	1125315	0	0
46319008	1129625	0	0
46321718	738818	0	0
46310665	40228214	2	3
4029205	4181917	4	4
21000571	975125	0	0
21000243	46233710	2	3
21013948	46233710	2	3
21602471	42902245	5	5
36158162	1125315	0	0
36151716	1118084	0	0
40244687	1112807	0	0
42804027	1124300	0	0
44349303	1125315	0	0
44343498	1149196	0	0
45625817	1717327	0	0
45665135	1125315	0	0
45629375	1127433	2	3
45658867	1125315	0	0
45663418	1119510	0	0
45635489	1332418	0	0
45642559	40229134	2	3
45677194	1125315	0	0
45781315	1112807	0	0
45676181	1129625	0	0
45692114	1125315	0	0
45780535	1119510	0	0
45777977	920293	0	0
45802996	1115008	0	0
45802247	19078461	2	3
45800980	975125	0	0
45796012	40163554	2	3
45794266	1125315	0	0
46239821	1129625	0	0
46316605	738818	0	0
46304879	1127433	2	3
4029205	4133840	4	4
21000583	1501700	0	0
21001654	19075601	2	3
21009299	46233710	2	3
21602471	19127922	5	5
36157779	1125315	0	0
36151767	740275	0	0
40244744	1177480	0	0
42805238	1119510	0	0
44349184	1125315	0	0
44343422	738818	0	0
45625570	1308738	0	0
45664954	1125315	0	0
45631323	19008572	2	3
45658826	1125315	0	0
45663441	1119510	0	0
45635494	1110410	0	0
45642629	19008572	2	3
45677304	1125315	0	0
45781444	1112807	0	0
45676163	1129625	0	0
45691753	1125315	0	0
45780654	1119510	0	0
45778145	1112807	0	0
45802999	753626	0	0
45800600	1332419	2	3
45801095	1124300	0	0
45796250	40229134	2	3
45789343	1125315	0	0
46239938	1129625	0	0
46316693	738818	0	0
46305073	19019273	2	3
4029205	4218408	4	4
21000571	1551099	0	0
21013408	1551192	2	3
21009299	46233988	2	3
21602471	19128065	5	5
36157782	1125315	0	0
36151770	1129625	0	0
40244745	1361711	0	0
42805392	1557272	0	0
44349416	1125315	0	0
44343425	1112807	0	0
45625636	1305058	0	0
45665197	1125315	0	0
45631233	19008572	2	3
44351940	1125315	0	0
45663449	1119510	0	0
45635585	1589505	0	0
45642800	19078461	2	3
45677190	1125315	0	0
45781449	1112807	0	0
45676195	1129625	0	0
45691763	1125315	0	0
45780668	1119510	0	0
45778209	1738521	0	0
45803131	1501700	0	0
45803210	1332419	2	3
45801097	1332418	0	0
45796238	44816277	2	3
45789378	1125315	0	0
46321748	1129625	0	0
46316191	738818	0	0
46305126	40232448	2	3
4029205	4151422	4	4
21000591	975125	0	0
21000199	46233988	2	3
21002247	1551192	2	3
21602471	19128022	5	5
36158080	1125315	0	0
36151774	1149380	0	0
40244727	1307863	0	0
42805404	1713332	0	0
44345204	1125315	0	0
44343506	1129625	0	0
45625277	1192710	0	0
45665198	1125315	0	0
45630935	19057271	2	3
45652425	1125315	0	0
45660371	1119510	0	0
45635694	1713332	0	0
45639416	19059056	2	3
45677221	1125315	0	0
45779010	1112807	0	0
45676280	1129625	0	0
45691959	1125315	0	0
46244949	1119510	0	0
45778210	914335	0	0
45800132	1174888	0	0
46288127	1332419	2	3
45800945	1713332	0	0
45796375	19008572	2	3
45789358	1125315	0	0
46321761	1129625	0	0
46310690	738818	0	0
46305089	19019273	2	3
4029205	4246502	4	4
21000591	1551099	0	0
21000199	46233710	2	3
21005418	19008572	2	3
21602471	19127918	5	5
36158082	1125315	0	0
36152010	1545958	0	0
40244733	1177480	0	0
42805379	975125	0	0
44345229	1125315	0	0
44343607	1778162	0	0
45625551	1115008	0	0
45665139	1125315	0	0
45626507	19019273	2	3
45652320	1125315	0	0
45660325	1119510	0	0
45635694	1759842	0	0
45639489	40228214	2	3
45674057	1125315	0	0
45778664	1112807	0	0
45624918	1129625	0	0
45692023	1125315	0	0
46244761	1119510	0	0
45778213	1124957	0	0
45800140	1124957	0	0
46238242	19078461	2	3
45801055	975125	0	0
45796197	19059056	2	3
45789348	1125315	0	0
46321928	1129625	0	0
46305843	738818	0	0
46305514	19008572	2	3
1589505	19128009	3	4
19129655	19129655	0	0
21013433	19074843	2	3
21005289	40174880	2	3
21602471	19128009	5	5
36158049	1125315	0	0
36151834	738818	0	0
40244705	1713332	0	0
42805493	1115008	0	0
44345230	1125315	0	0
44343548	1778162	0	0
45625689	708298	0	0
45665142	1125315	0	0
45626605	1127433	2	3
45652321	1125315	0	0
45660392	1119510	0	0
45637026	967823	0	0
45639496	1545959	2	3
45674078	1125315	0	0
45778782	1112807	0	0
45624824	1129625	0	0
45691683	1125315	0	0
45777664	1119510	0	0
45777871	1713332	0	0
45800145	1309944	0	0
45794858	40223768	2	3
45801071	1738521	0	0
45796057	1115171	2	3
45788770	1125315	0	0
46322141	1129625	0	0
46306028	738818	0	0
46305362	45892894	2	3
1589505	19127918	3	4
19112599	19112599	0	0
21013433	19074841	2	3
21002102	19129655	2	3
21602471	19128263	5	5
36158052	1125315	0	0
36151836	1107830	0	0
40244748	1177480	0	0
42805411	1124300	0	0
44345173	1125315	0	0
44343468	1192710	0	0
45625691	1551099	0	0
45665236	1125315	0	0
45626538	19133905	2	3
45652468	1125315	0	0
45660493	1119510	0	0
45637027	1154029	0	0
45639426	1551192	2	3
45673630	1125315	0	0
45778708	1112807	0	0
45624812	1129625	0	0
45691859	1125315	0	0
45777674	1119510	0	0
45777871	1759842	0	0
45799914	1154343	0	0
45789525	1545959	2	3
45801157	1107830	0	0
45796061	19008572	2	3
45788707	1125315	0	0
46321995	1129625	0	0
46305856	738818	0	0
46305363	19133905	2	3
1588689	19127904	3	4
19115351	19115351	0	0
21002692	19008572	2	3
21002102	46233988	2	3
21602471	19133679	5	5
36158195	1125315	0	0
36152227	1107830	0	0
40244749	1125315	0	0
42804098	1177480	0	0
44345319	1125315	0	0
44343512	1310149	0	0
45625693	1501700	0	0
45665240	1125315	0	0
45626503	40228230	2	3
45652477	1125315	0	0
45660359	1119510	0	0
45637032	1107830	0	0
45639430	19059056	2	3
45673743	1125315	0	0
45778786	1112807	0	0
45670319	1129625	0	0
45691852	1125315	0	0
45778232	1119510	0	0
45777841	975125	0	0
45800102	738818	0	0
45894419	40228214	2	3
45801205	1115008	0	0
45796262	1115171	2	3
45788718	1125315	0	0
46322259	1129625	0	0
46322299	738818	0	0
46321817	40229134	2	3
1512674	19127904	3	4
19073188	19073188	0	0
21000220	46233988	2	3
21002102	46233710	2	3
21602471	19129144	5	5
36157989	1125315	0	0
36152250	1713332	0	0
40244750	1192710	0	0
42804110	1545958	0	0
44345417	1125315	0	0
44343515	1192710	0	0
45625295	1309944	0	0
45665212	1125315	0	0
45626582	40232448	2	3
45652480	1125315	0	0
45660422	1119510	0	0
45637034	1174888	0	0
45639401	43012036	2	3
45674226	1125315	0	0
45779067	1112807	0	0
45670614	1129625	0	0
45692046	1125315	0	0
45778126	1119510	0	0
45777848	740275	0	0
45800104	975125	0	0
45799951	1539411	2	3
45801212	1124957	0	0
45796175	40162522	2	3
45788822	1125315	0	0
46322276	1129625	0	0
46322617	738818	0	0
46315738	40232448	2	3
4023577	81151	3	4
19073183	19073183	0	0
21000220	46233710	2	3
21013849	19075601	2	3
35202051	4163874	5	5
36157788	1125315	0	0
36152250	1759842	0	0
40244750	1125315	0	0
42804107	1551099	0	0
44345423	1125315	0	0
44343543	967823	0	0
45625594	1322184	0	0
45665176	1125315	0	0
45623294	40229134	2	3
45652145	1125315	0	0
45660475	1119510	0	0
45636837	738818	0	0
45639612	43012036	2	3
45674228	1125315	0	0
45779068	1112807	0	0
45670636	1129625	0	0
45691805	1125315	0	0
45777886	1119510	0	0
45777813	1545958	0	0
45800112	1343916	0	0
45794491	1539411	2	3
45801073	1367571	0	0
45796180	19059056	2	3
45788767	1125315	0	0
46322283	1129625	0	0
46322626	738818	0	0
46316300	40232448	2	3
3039466	3045716	3	4
19074679	19074679	0	0
21001816	1713671	2	3
21013919	46233710	2	3
35202051	4051466	5	5
36158242	1125315	0	0
36152353	715997	0	0
40244832	1119510	0	0
42801327	1759842	0	0
44345375	1125315	0	0
44343477	1174888	0	0
45625643	19127890	0	0
45665177	1125315	0	0
45623295	40229134	2	3
45652149	1125315	0	0
45660616	1119510	0	0
45637222	1174888	0	0
45639589	40169281	2	3
45673981	1125315	0	0
45779383	1112807	0	0
45669303	1129625	0	0
45691812	1125315	0	0
46242632	1119510	0	0
46244619	1545958	0	0
45800120	738818	0	0
45794547	19075601	2	3
45801074	1310149	0	0
45796308	19008572	2	3
45788827	1125315	0	0
46322287	1129625	0	0
46311423	738818	0	0
46316368	40232448	2	3
3039466	3019550	3	4
19074694	19074679	0	0
21002694	19112599	2	3
21013919	46233988	2	3
35202051	381316	5	5
36158245	1125315	0	0
36152356	1589505	0	0
40244832	1125315	0	0
42801327	1713332	0	0
44345654	1125315	0	0
44343526	1129625	0	0
45625643	1589505	0	0
45662478	1125315	0	0
45623338	1127433	2	3
45652219	1125315	0	0
45660586	1119510	0	0
45637152	1551099	0	0
45639542	46275444	2	3
45674115	1125315	0	0
45779073	1112807	0	0
45669285	1129625	0	0
45688796	1125315	0	0
46242579	1119510	0	0
46244649	1115008	0	0
45800027	705944	0	0
45790207	19075601	2	3
45801158	1501700	0	0
45796457	19126352	2	3
45788925	1125315	0	0
46322062	1129625	0	0
46311435	738818	0	0
46316407	1545959	2	3
3039466	3014576	3	4
19002770	19002770	0	0
21002694	40232448	2	3
21002098	1551192	2	3
35502617	4144583	5	5
36157914	1125315	0	0
36152356	19127890	0	0
40244833	1112807	0	0
42801330	920293	0	0
44345717	1125315	0	0
44343527	738818	0	0
45625643	1549786	0	0
45662493	1125315	0	0
45623324	1115171	2	3
45652123	1125315	0	0
45657482	1119510	0	0
45636934	1361711	0	0
45639759	40232448	2	3
45673756	1125315	0	0
45707614	1112807	0	0
45666786	1129625	0	0
45688825	1125315	0	0
46242656	1119510	0	0
46244628	1310149	0	0
45800266	1192710	0	0
46240722	19078461	2	3
45801164	715997	0	0
45796349	1115171	2	3
45788904	1125315	0	0
46322326	1129625	0	0
46319821	738818	0	0
46316440	19018935	2	3
3039466	3015632	3	4
19003953	19003953	0	0
21002694	43012036	2	3
21002113	1713671	2	3
35200000	317009	5	5
35802131	40486433	5	10
36152356	1549786	0	0
40244834	1549786	0	0
42801337	1107830	0	0
44345284	1125315	0	0
44343528	975125	0	0
45625650	967823	0	0
45662685	1125315	0	0
45623374	40232448	2	3
45652343	1125315	0	0
45658566	1119510	0	0
45636936	1174888	0	0
45639549	19126352	2	3
45673774	1125315	0	0
45707626	1112807	0	0
45666956	1129625	0	0
45688820	1125315	0	0
46240248	1119510	0	0
46244629	975125	0	0
45800271	914335	0	0
45802891	19075601	2	3
45800883	1551099	0	0
45796310	40162522	2	3
45788905	1125315	0	0
46322338	1129625	0	0
46317591	1129625	0	0
46316729	19077572	2	3
1503184	19128065	3	4
4310024	4310024	0	0
21001288	46233988	2	3
21002113	46275444	2	3
21602752	40174880	4	5
35802131	4280726	5	10
36152080	1129625	0	0
40244751	1112807	0	0
40760920	3016723	1	1
44345298	1125315	0	0
44343593	1322184	0	0
45625658	1500211	0	0
45662503	1125315	0	0
45623628	1115171	2	3
45652554	1125315	0	0
45657589	1119510	0	0
45636936	1192710	0	0
45636477	1115171	2	3
45673779	1125315	0	0
45777897	1112807	0	0
45667003	1129625	0	0
45688772	1125315	0	0
46240351	1119510	0	0
46244673	1738521	0	0
45800279	1174888	0	0
45795155	19075601	2	3
45800884	1332418	0	0
45796430	40232448	2	3
45788906	1125315	0	0
46322356	1129625	0	0
46313418	1129625	0	0
46310794	19008572	2	3
4022924	4109685	3	3
4266809	4266809	0	0
21001288	46233710	2	3
21011074	19059056	2	3
35202051	321042	4	5
35809132	4218389	3	4
36152082	1192710	0	0
40244752	1119510	0	0
40771966	3051031	1	1
44345299	1125315	0	0
44339797	1308738	0	0
45625665	1110410	0	0
45662732	1125315	0	0
45623534	19008572	2	3
45652619	1125315	0	0
45657775	1119510	0	0
45635733	1545958	0	0
45636630	1115171	2	3
45674258	1125315	0	0
45707833	1112807	0	0
45780645	1129625	0	0
45688849	1125315	0	0
46240362	1119510	0	0
46244678	715997	0	0
45800282	1539403	0	0
46296228	19075601	2	3
45800887	975125	0	0
45796434	19078924	2	3
45788929	1125315	0	0
46322359	1129625	0	0
46313270	1129625	0	0
46310690	40229134	2	3
4023317	4152936	3	3
21001448	1310149	0	0
21013411	19073183	2	3
21011074	19075601	2	3
21602472	43012433	4	5
35809132	4043241	8	9
36152418	1129625	0	0
40244752	1125315	0	0
40765349	3000963	1	1
44345519	1125315	0	0
44339798	1115008	0	0
45625602	1154343	0	0
45662514	1125315	0	0
45623361	19008572	2	3
45652726	1125315	0	0
45657822	1119510	0	0
45635940	738818	0	0
45636217	40229134	2	3
45674360	1125315	0	0
45707822	1112807	0	0
45778159	1129625	0	0
45688865	1125315	0	0
46242346	1119510	0	0
46242587	1332418	0	0
45800036	1310149	0	0
45803025	19075601	2	3
45801045	1115008	0	0
45790930	1115171	2	3
45788978	1125315	0	0
46316175	1129625	0	0
46313423	1129625	0	0
46310799	40231925	2	3
4003387	4336464	3	3
21001454	1322184	0	0
21013411	19129655	2	3
21005429	40228214	2	3
21604303	40162522	4	5
35809132	4156265	4	6
36152049	1177480	0	0
40244753	1115008	0	0
40763504	3023103	1	1
44345483	1125315	0	0
44339801	1149380	0	0
45625604	1149196	0	0
45662713	1125315	0	0
45623735	40236824	2	3
45652487	1125315	0	0
45657527	1119510	0	0
45635746	1343916	0	0
45636523	40223768	2	3
45674388	1125315	0	0
45705142	1112807	0	0
45778415	1129625	0	0
45688867	1125315	0	0
46240468	1119510	0	0
46242588	1728416	0	0
45800123	708298	0	0
46240937	19078461	2	3
45800986	1149196	0	0
45790931	40174880	2	3
45788868	1125315	0	0
46316300	1129625	0	0
46313482	1129625	0	0
46310732	1115171	2	3
4086921	45766064	3	3
21001448	1539403	0	0
21013411	1713671	2	3
21005429	40223821	2	3
21604303	40231925	4	5
35809132	4283893	4	6
36152094	933724	0	0
40244754	1115008	0	0
40033943	40232448	1	1
44345686	1125315	0	0
44339849	1129625	0	0
45625801	1107830	0	0
45662727	1125315	0	0
45623743	40232448	2	3
45652187	1125315	0	0
45657627	1119510	0	0
45635753	1110410	0	0
45636485	40232448	2	3
45674338	1125315	0	0
45705064	1112807	0	0
45778416	1129625	0	0
45688936	1125315	0	0
45703288	1119510	0	0
46242615	1192710	0	0
45800249	1332418	0	0
45802371	1539411	2	3
45801178	1332418	0	0
45790732	1332419	2	3
45788869	1125315	0	0
46316325	1129625	0	0
46313379	1129625	0	0
46305962	1127433	2	3
4023577	4059173	3	3
21001448	1322184	0	0
21001378	19073183	2	3
21005429	40223834	2	3
21604303	40229134	4	5
35809132	4132546	4	6
36152099	1129625	0	0
40244755	1125315	0	0
40032939	46233988	1	1
44345710	1125315	0	0
44339905	1545958	0	0
45625619	1149196	0	0
45662612	1125315	0	0
45623562	1551192	2	3
45652712	1125315	0	0
45657948	1119510	0	0
45635757	1107830	0	0
45636655	1115171	2	3
45674045	1125315	0	0
45633082	975125	0	0
45778403	1129625	0	0
45688937	1125315	0	0
45703520	1119510	0	0
46242590	1115008	0	0
45800373	1115008	0	0
45897211	19075601	2	3
45801183	1115008	0	0
45790806	19073183	2	3
45788879	1125315	0	0
46310876	1129625	0	0
46313544	1129625	0	0
46305972	19129655	2	3
4024000	4116491	3	3
21001455	1539403	0	0
21000221	46233988	2	3
21005429	40228230	2	3
21604303	19133768	4	5
35809132	4029498	4	4
36152046	1551099	0	0
40244755	1119510	0	0
40032939	46233710	1	1
44345606	1125315	0	0
44339989	1545958	0	0
45625620	701322	0	0
45662433	1125315	0	0
45623645	40231925	2	3
44344272	1125315	0	0
45654048	1119510	0	0
45635745	967823	0	0
45636678	1551192	2	3
45674052	1125315	0	0
45676636	975125	0	0
45778368	1129625	0	0
45689129	1125315	0	0
45703272	1119510	0	0
46242618	1309944	0	0
45800377	1738521	0	0
45789724	19075601	2	3
45801148	1521369	0	0
45790952	1115171	2	3
46296837	1125315	0	0
46311047	1129625	0	0
46314224	1129625	0	0
46305989	40224805	2	3
432795	4329847	3	3
21001455	1112807	0	0
21000221	46233710	2	3
21006489	19059056	2	3
21601854	1545959	2	5
35809132	140673	4	4
36152228	975125	0	0
40244756	1125315	0	0
40227524	40229134	1	1
44345673	1125315	0	0
44339854	1000560	0	0
45625673	1000560	0	0
45662887	1125315	0	0
45667684	1115171	2	3
44344397	1125315	0	0
45654387	1119510	0	0
45635762	1174888	0	0
45636603	1551192	2	3
45674181	1125315	0	0
45676637	975125	0	0
45778362	1129625	0	0
45686068	1125315	0	0
45703276	1119510	0	0
46242591	1551099	0	0
45800081	1322184	0	0
45897363	19078461	2	3
45801148	1548195	0	0
45791003	19126352	2	3
46296854	1125315	0	0
46311487	1129625	0	0
46313766	1129625	0	0
46305856	40229134	2	3
4003389	4275113	3	3
21001459	1307863	0	0
21002238	1551192	2	3
21006489	1539411	2	3
21601854	1539411	2	5
35809132	4112343	5	8
36152129	1115008	0	0
40244756	1119510	0	0
40225999	40228214	1	1
44345548	1125315	0	0
44339906	738818	0	0
45625752	975125	0	0
45662530	1125315	0	0
45667825	40223834	2	3
44344574	1125315	0	0
45654447	1119510	0	0
45636056	1115008	0	0
45636629	1107882	2	3
45674194	1125315	0	0
45676927	975125	0	0
45778422	1129625	0	0
45686044	1125315	0	0
45703491	1119510	0	0
46242619	1332418	0	0
45800381	1729720	0	0
45795151	19079524	2	3
45801152	1115008	0	0
45791917	19078461	2	3
46296760	1125315	0	0
46311507	1129625	0	0
46313983	1129625	0	0
46305857	1551192	2	3
4022923	4035415	3	3
21001448	1112807	0	0
21001626	40163554	2	3
21006489	1545959	2	3
21604303	1127078	2	5
35809132	4294548	5	8
36152138	1729720	0	0
40244839	1149196	0	0
40758307	40758406	1	1
44345551	1125315	0	0
44339931	1521369	0	0
45625753	1107830	0	0
45661222	1125315	0	0
45667941	19008572	2	3
44344528	1125315	0	0
45654064	1119510	0	0
45636057	967823	0	0
45637054	40229134	2	3
45674346	1125315	0	0
45676511	975125	0	0
45778426	1129625	0	0
45685779	1125315	0	0
45703472	1119510	0	0
46242663	1192710	0	0
45800232	1115008	0	0
45789830	19079524	2	3
45801153	1310149	0	0
45791931	19077344	2	3
46296893	1125315	0	0
46311203	1129625	0	0
46313896	1129625	0	0
46322440	19008572	2	3
4023316	78272	3	3
21001459	1332418	0	0
21001626	19075601	2	3
21008820	46233988	2	3
21604303	1127433	2	5
35809132	4001336	5	7
36152237	1177480	0	0
40244845	1551099	0	0
37219801	258780	0	1
44341272	1125315	0	0
44339811	1115008	0	0
45625754	1124957	0	0
45661355	1125315	0	0
45667817	40232448	2	3
44344469	1125315	0	0
45652032	1119510	0	0
45636062	1343916	0	0
45637317	19078461	2	3
45673717	1125315	0	0
45676512	975125	0	0
45778429	1129625	0	0
45686179	1125315	0	0
45700402	1119510	0	0
46242641	1153428	0	0
45800235	738818	0	0
45785615	1539411	2	3
45799698	1713332	0	0
45792042	19129655	2	3
46296704	1125315	0	0
46311238	1129625	0	0
46308410	1129625	0	0
46322081	40174880	2	3
3039466	3024561	3	3
21001459	1545958	0	0
21001626	19059056	2	3
21008820	46233710	2	3
21601745	1332419	2	5
35809132	40481087	5	7
36152056	715997	0	0
40244851	1119510	0	0
37203783	4280726	1	2
44341399	1125315	0	0
44339885	738818	0	0
45625372	1124300	0	0
45661211	1125315	0	0
45665583	40232448	2	3
44344618	1125315	0	0
45650962	1119510	0	0
45635962	705944	0	0
45633287	19078461	2	3
45673724	1125315	0	0
45673586	975125	0	0
45778430	1129625	0	0
45686181	1125315	0	0
45700466	1119510	0	0
46240423	1112807	0	0
45800238	1115008	0	0
45797898	19079524	2	3
45799700	1174888	0	0
45791099	40224805	2	3
46296709	1125315	0	0
46311596	1129625	0	0
46308540	1129625	0	0
46322629	19019273	2	3
3039466	3006906	3	3
21001456	1361711	0	0
21001430	1551192	2	3
21503925	19078461	2	3
21603445	40228214	2	5
35809132	257012	5	7
36152230	1515774	0	0
40244851	738818	0	0
37219945	317009	1	2
44341400	1125315	0	0
44339888	1149380	0	0
45625811	1778162	0	0
45659363	1125315	0	0
45665710	19075601	2	3
44344485	1125315	0	0
45651131	1119510	0	0
45635786	1548195	0	0
45633343	40232448	2	3
45673913	1125315	0	0
45673597	975125	0	0
45778465	1129625	0	0
45686055	1125315	0	0
45700470	1119510	0	0
46240251	1549786	0	0
45800242	1000560	0	0
45794995	40228214	2	3
45799766	791967	0	0
45791104	1551192	2	3
46296499	1125315	0	0
46305840	1129625	0	0
46308724	1129625	0	0
46317289	1115171	2	3
3039466	3020630	3	3
21001455	1545958	0	0
21000222	46233988	2	3
21503925	19019979	2	3
21603041	920300	2	5
35809132	28060	5	6
36152230	1549786	0	0
40244851	1125315	0	0
40760930	3023103	1	2
44341493	1125315	0	0
44339893	920293	0	0
45625865	1110410	0	0
45659340	1125315	0	0
45665520	19008572	2	3
44344225	1125315	0	0
45651102	1119510	0	0
45632666	1149196	0	0
45633246	46275916	2	3
45673927	1125315	0	0
45673854	975125	0	0
45778466	1129625	0	0
45697545	19059056	2	3
45700473	1119510	0	0
46240217	1112807	0	0
45800064	1501700	0	0
45792676	40228214	2	3
45799771	1115008	0	0
45791096	1115171	2	3
46296546	1125315	0	0
46305720	1129625	0	0
46308672	1129625	0	0
46317297	1115171	2	3
3039466	3013721	3	3
21001456	1367571	0	0
21000222	46233710	2	3
21503925	1115171	2	3
21604182	19023423	2	5
35809132	372328	5	5
36152065	1112807	0	0
40244854	1177480	0	0
37203783	40486433	2	2
44344541	1125315	0	0
44339912	1177480	0	0
45625842	1000560	0	0
45659676	1125315	0	0
45665523	1551192	2	3
44344411	1125315	0	0
45651068	1119510	0	0
45632539	742185	0	0
45633360	1545959	2	3
45674293	1125315	0	0
45673884	975125	0	0
45778467	1129625	0	0
45697713	19019273	2	3
45896843	1119510	0	0
46240378	723013	0	0
45800065	1174888	0	0
45787057	40228214	2	3
45799751	1174888	0	0
46294744	46275916	2	3
46296550	1125315	0	0
46322611	1129625	0	0
46308485	1129625	0	0
46311596	40232448	2	3
3039466	3027970	3	3
21001462	1112807	0	0
21013390	1310034	2	3
4174389	4163971	3	3
21602472	1519937	2	5
35809132	380378	5	5
36151888	1177480	0	0
40244868	933724	0	0
37219939	261325	2	2
44344370	1125315	0	0
44340010	1551099	0	0
45625843	1115008	0	0
45659381	1125315	0	0
45665875	19008572	2	3
45646265	1125315	0	0
45651110	1119510	0	0
45632543	1124300	0	0
45633411	1545959	2	3
45674301	1125315	0	0
45673156	975125	0	0
45778366	1129625	0	0
45697654	40229134	2	3
45896882	1119510	0	0
46240339	1539403	0	0
45800067	738818	0	0
46243139	40228214	2	3
45799756	1107830	0	0
46294889	19008572	2	3
46295178	1125315	0	0
46316744	1129625	0	0
46308639	1129625	0	0
46311341	19008572	2	3
3039466	3004501	3	3
21001462	1361711	0	0
21001603	1551192	2	3
4086181	4029498	3	3
35200000	4324181	3	5
35809132	381316	5	5
36152257	19010482	0	0
40244766	1177480	0	0
37219785	260139	2	2
44344375	1125315	0	0
44339993	1112807	0	0
45625399	715997	0	0
45659438	1125315	0	0
45665720	40223768	2	3
45646353	1125315	0	0
45647988	1119510	0	0
45632547	738818	0	0
45630399	19018935	2	3
45674303	1125315	0	0
45670810	975125	0	0
45706967	1129625	0	0
45697659	19129655	2	3
45896889	1119510	0	0
46240350	1149196	0	0
45800193	1118084	0	0
45897423	40228214	2	3
45799741	1539403	0	0
46294639	40169281	2	3
46295184	1125315	0	0
46317660	1129625	0	0
46312205	1129625	0	0
46311408	19019273	2	3
3039466	3006923	3	3
21001460	1361711	0	0
21001823	19074843	2	3
4036803	4037675	3	3
35202051	317576	4	6
35809132	4048171	7	9
36152259	1124300	0	0
40244693	1129625	0	0
37019308	198199	2	2
44344552	1125315	0	0
44339995	1545958	0	0
45622204	1713332	0	0
45659388	1125315	0	0
45665630	46275444	2	3
45646054	1125315	0	0
45647918	1119510	0	0
45632558	1115008	0	0
45630311	19008572	2	3
45674029	1125315	0	0
45669411	975125	0	0
45707000	1129625	0	0
45697328	40232448	2	3
45896863	1119510	0	0
46240219	1107830	0	0
45800198	1112807	0	0
45803314	40228214	2	3
45799803	1107830	0	0
46294808	40229134	2	3
46295127	1125315	0	0
46316903	1129625	0	0
46312287	1129625	0	0
46311784	19133905	2	3
3039466	3035995	3	3
21001463	1332418	0	0
21002658	1551192	2	3
4038678	440448	3	3
35202051	4329847	4	6
35809132	375671	6	8
36152075	1154343	0	0
40244694	1125315	0	0
40789322	3019406	2	2
44344459	1125315	0	0
44340003	1153428	0	0
45622116	1713332	0	0
45659509	1125315	0	0
45665657	40165015	2	3
45645967	1125315	0	0
45647824	1119510	0	0
45632789	738818	0	0
45630442	19073183	2	3
45674032	1125315	0	0
45669640	975125	0	0
45707125	1129625	0	0
45695966	19008572	2	3
45697161	1119510	0	0
46240307	1192710	0	0
45800395	1759842	0	0
45798014	40228214	2	3
45799805	1738521	0	0
46244044	1115171	2	3
46295278	1125315	0	0
46306067	1129625	0	0
46311912	1129625	0	0
46311785	40236824	2	3
1580876	19008572	2	3
21001463	1545958	0	0
21500577	1127433	2	3
4038678	4166224	3	3
21602472	19127904	4	6
35809132	40486433	6	8
36151891	1589505	0	0
40244768	1112807	0	0
40789329	3020655	2	2
44344463	1125315	0	0
44340018	1129625	0	0
45622116	1759842	0	0
45659542	1125315	0	0
45663141	1551192	2	3
45645970	1125315	0	0
45648240	1119510	0	0
45632790	1738521	0	0
45630220	19018935	2	3
45671338	1125315	0	0
45669601	975125	0	0
45707144	1129625	0	0
45696081	19023398	2	3
45697310	1119510	0	0
46240313	1112807	0	0
45800297	1174888	0	0
45894579	1332419	2	3
45798063	1539403	0	0
46244100	40229134	2	3
46296945	1125315	0	0
46306490	1129625	0	0
46311997	1129625	0	0
46311297	1332419	2	3
3039466	3016723	2	3
21001455	1332418	0	0
21500577	1127078	2	3
4100932	4149245	3	3
21601853	1539411	3	6
35809132	4280726	6	8
36151891	19127890	0	0
40244768	1192710	0	0
40789356	3002385	2	2
44341602	1125315	0	0
44340005	1129625	0	0
45622120	1326303	0	0
45659703	1125315	0	0
45663231	40229134	2	3
45646068	1125315	0	0
45648273	1119510	0	0
45632760	1124300	0	0
45630406	40223834	2	3
45671167	1125315	0	0
45783534	975125	0	0
45707048	1129625	0	0
45693072	19075601	2	3
45697116	1119510	0	0
46240320	1112807	0	0
45800298	1192710	0	0
45797895	40228214	2	3
45798114	1124300	0	0
46244111	19077572	2	3
46297072	1125315	0	0
46306497	1129625	0	0
46311999	1129625	0	0
46311519	1115171	2	3
3039466	3013682	2	3
21001472	1332418	0	0
21013409	1551192	2	3
4099350	4056621	3	3
21601853	1545959	3	6
35809132	378001	6	8
36151891	1549786	0	0
40244696	1154343	0	0
40789179	3009542	2	2
44341592	1125315	0	0
44340168	920293	0	0
45622067	1192710	0	0
45659474	1125315	0	0
45663390	40173590	2	3
45646075	1125315	0	0
45648248	1119510	0	0
45632786	1551099	0	0
45631099	19078461	2	3
45671009	1125315	0	0
45781068	975125	0	0
45707325	1129625	0	0
45692632	19008572	2	3
45697120	1119510	0	0
46240332	1192710	0	0
45800298	1112807	0	0
46293004	1115171	2	3
45798065	1174888	0	0
46244159	19018935	2	3
46297077	1125315	0	0
46306186	1129625	0	0
46303476	1129625	0	0
46311423	40229134	2	3
3039467	3014576	2	3
21001455	1322184	0	0
21001149	1551192	2	3
4099350	198199	3	3
21604685	19077572	3	6
35809132	378419	6	7
36151899	791967	0	0
40244697	1125315	0	0
40789180	3015632	2	2
44341709	1125315	0	0
44339983	1149196	0	0
45622224	933724	0	0
45656518	1125315	0	0
45663321	1551192	2	3
45646197	1125315	0	0
45648099	1119510	0	0
45632787	1149196	0	0
45631353	19073183	2	3
45671068	1125315	0	0
45707732	975125	0	0
45706826	1129625	0	0
45692754	1115171	2	3
45697436	1119510	0	0
46240430	1539403	0	0
45800309	975125	0	0
46292744	19078924	2	3
45798067	1778162	0	0
46244165	40229134	2	3
46297078	1125315	0	0
46306073	1129625	0	0
46303621	1129625	0	0
46306543	40223768	2	3
3039467	3019550	2	3
21001487	1717327	0	0
21500564	19077572	2	3
4038490	45769019	3	3
21604685	40223768	3	6
35702113	28060	7	8
36152208	1112807	0	0
40244758	1125315	0	0
40789182	3024731	2	2
44341676	1125315	0	0
44339986	1115008	0	0
45622072	1124300	0	0
45656316	1125315	0	0
45663398	40223834	2	3
45646198	1125315	0	0
45648105	1119510	0	0
45632823	1000560	0	0
45631343	1107882	2	3
45671125	1125315	0	0
45704819	975125	0	0
45704262	1129625	0	0
45693014	46275916	2	3
45697122	1119510	0	0
46240431	705944	0	0
45800311	1367571	0	0
46293031	19019273	2	3
45798152	1713332	0	0
46244402	40229134	2	3
46297079	1125315	0	0
46306244	1129625	0	0
46303675	1129625	0	0
46317199	19079524	2	3
3039467	3015632	2	3
21000578	1501700	0	0
21500564	836659	2	3
4186701	4275113	3	3
21603444	19125062	3	6
35702113	196456	6	7
36152215	1112807	0	0
40244734	1713332	0	0
40789190	3035995	2	2
44341685	1125315	0	0
44339868	1129625	0	0
45622124	1174888	0	0
45656523	1125315	0	0
45663413	920334	2	3
45646203	1125315	0	0
45644783	1119510	0	0
45632824	1174888	0	0
45630774	19018935	2	3
45671190	1125315	0	0
45704572	975125	0	0
45704331	1129625	0	0
45692818	40236824	2	3
45697394	1119510	0	0
46240399	1192710	0	0
45802597	1332418	0	0
46293420	1127433	2	3
45798090	967823	0	0
46244203	40231925	2	3
46297226	1125315	0	0
46306464	1129625	0	0
46303779	1129625	0	0
46301330	19078461	2	3
3039467	3045716	2	3
21000584	1501700	0	0
21500564	40223768	2	3
4160875	81151	3	3
21603444	1107882	3	6
35702113	198809	6	8
36152217	967823	0	0
40244698	1154343	0	0
37520740	4337611	2	2
44341696	1125315	0	0
44339871	738818	0	0
45622078	1107830	0	0
45656561	1125315	0	0
45663194	40229134	2	3
44340955	1125315	0	0
45644895	1119510	0	0
45632811	1738521	0	0
45630631	1332419	2	3
45671356	1125315	0	0
45704889	975125	0	0
45704362	1129625	0	0
45692809	19008572	2	3
45697397	1119510	0	0
46240401	1112807	0	0
45802412	1149196	0	0
46293159	19019273	2	3
45798104	975125	0	0
46244347	19077572	2	3
46297331	1125315	0	0
46306737	1129625	0	0
46303917	1129625	0	0
46310971	40223768	2	3
1501700	40174880	2	3
21000587	1501700	0	0
21500583	40165015	2	3
4162282	4283893	3	3
21603444	43012036	3	6
35702113	4112343	6	10
36151987	1129625	0	0
40244769	1000560	0	0
40789095	3036780	2	2
44341697	1125315	0	0
44339876	738818	0	0
45622134	708298	0	0
45656353	1125315	0	0
45663258	46233988	2	3
44341251	1125315	0	0
45644922	1119510	0	0
45632928	1124957	0	0
45630624	1107882	2	3
45671367	1125315	0	0
45701370	975125	0	0
45704373	1129625	0	0
45692827	40236446	2	3
45697188	1119510	0	0
46240409	1343916	0	0
45802300	1124957	0	0
46288013	19059056	2	3
45798154	1107830	0	0
46244350	19008572	2	3
46297520	1125315	0	0
46306773	1129625	0	0
46300536	1129625	0	0
45650836	1127433	2	3
1589505	43012754	2	3
21000588	1501700	0	0
21001806	19129655	2	3
4176642	4062501	4	4
21603444	40223834	3	6
35702113	4285898	5	11
36009776	4280726	0	0
40244759	1125315	0	0
40789527	3045716	2	2
44341783	1125315	0	0
44340178	1177480	0	0
45622163	975125	0	0
45656469	1125315	0	0
45663258	46233710	2	3
44341257	1125315	0	0
45645012	1119510	0	0
45632763	1192710	0	0
45630714	1127433	2	3
45671192	1125315	0	0
45701378	975125	0	0
45704596	1129625	0	0
45692828	40232448	2	3
45697355	1119510	0	0
46240083	1112807	0	0
45802350	1154029	0	0
46287970	40223834	2	3
45798127	975125	0	0
45693861	1125315	0	0
46297525	1125315	0	0
45896740	1119510	0	0
46301385	1129625	0	0
45650807	19008572	2	3
4013074	439777	1	1
21000703	1545958	0	0
21001661	1551192	2	3
4176642	4197460	4	4
21603444	40223821	3	6
35702113	4027663	4	7
35708322	4027663	0	0
40244760	1125315	0	0
40758424	3027970	2	2
44341815	1125315	0	0
44339966	1539403	0	0
45622164	738818	0	0
45656474	1125315	0	0
45663595	40228214	2	3
44341191	1125315	0	0
45645027	1119510	0	0
45632798	1000560	0	0
45630710	19074843	2	3
45671279	1125315	0	0
45701391	975125	0	0
45700686	1129625	0	0
45692992	40229134	2	3
45697357	1119510	0	0
46240084	1361711	0	0
45802291	1174888	0	0
46288178	19018935	2	3
45798078	1124957	0	0
45694045	1125315	0	0
46297368	1125315	0	0
45801994	1119510	0	0
46319699	1129625	0	0
45650703	19008572	2	3
1309307	964261	1	1
21000703	1539403	0	0
21002325	920334	2	3
4030660	4163971	4	4
21602471	1519937	3	6
35702113	4310024	3	8
35708276	4027663	0	0
40244760	1112807	0	0
40758424	3020630	2	2
44341816	1125315	0	0
44340185	1110410	0	0
45622055	791967	0	0
45656600	1125315	0	0
45659906	40223834	2	3
45643288	1125315	0	0
45645101	1119510	0	0
45632737	1778162	0	0
45627765	19078924	2	3
45671228	1125315	0	0
45698416	975125	0	0
45700909	1129625	0	0
45693004	1551192	2	3
45697521	1119510	0	0
46240091	1112807	0	0
45802426	1778162	0	0
46287974	19075601	2	3
45798407	1115008	0	0
45694104	1125315	0	0
46297155	1125315	0	0
45801951	1119510	0	0
46319761	1129625	0	0
45675392	19077344	2	3
1309994	1310034	1	1
21000703	1332418	0	0
21002325	920300	2	3
141960	4296204	4	4
21604389	19074679	3	6
35702113	440448	3	10
36154755	1119510	0	0
40244762	1129625	0	0
40763890	40766240	2	2
44341963	1125315	0	0
44340158	1000560	0	0
45624999	1738521	0	0
45656603	1125315	0	0
45659906	40223821	2	3
45643157	1125315	0	0
45645106	1119510	0	0
45633021	1149196	0	0
45627616	35605482	2	3
45671410	1125315	0	0
45698255	975125	0	0
45701052	1129625	0	0
45693104	40229134	2	3
45694980	1119510	0	0
46240446	19010482	0	0
45802435	1112807	0	0
46288688	1115171	2	3
45798074	1110410	0	0
45693747	1125315	0	0
46293433	1125315	0	0
45801941	1119510	0	0
46319770	1129625	0	0
45675399	40232448	2	3
437779	28060	1	1
21001475	1367571	0	0
21013403	1551192	2	3
4042646	4330583	4	4
21602514	40221415	3	6
35702113	4166224	3	10
36154756	1119510	0	0
40244762	1125315	0	0
40760930	3019550	2	2
44341907	1125315	0	0
44340133	975125	0	0
45624834	1545958	0	0
45656176	1125315	0	0
45659661	40223834	2	3
45643144	1125315	0	0
45645202	1119510	0	0
45633030	1115008	0	0
45627642	19008572	2	3
45671444	1125315	0	0
45698264	975125	0	0
45700803	1129625	0	0
45693278	40232448	2	3
45694981	1119510	0	0
46240449	1115008	0	0
45802222	1322184	0	0
46288761	40229134	2	3
45798076	1738521	0	0
45694158	1125315	0	0
46292863	1125315	0	0
45802046	1119510	0	0
46319869	1129625	0	0
45675358	19078461	2	3
437409	4132546	1	1
21001462	1322184	0	0
21002743	40223834	2	3
4300244	4057420	4	4
21604181	19023398	3	6
35702113	192671	3	6
36154686	1119510	0	0
40244764	1177480	0	0
40760892	3000963	2	2
44359507	19127922	3	4
44340062	1177480	0	0
45624970	1192710	0	0
45656573	1125315	0	0
45659665	40229134	2	3
45643317	1125315	0	0
45645381	1119510	0	0
45632831	1367571	0	0
45627588	40232448	2	3
45669801	1125315	0	0
45698707	975125	0	0
45701346	1129625	0	0
45693053	40163554	2	3
45694293	1119510	0	0
46240451	1729720	0	0
45802307	705944	0	0
46288721	40223768	2	3
45798159	1174888	0	0
45693876	1125315	0	0
46293056	1125315	0	0
45802052	1119510	0	0
46319997	1129625	0	0
45675497	43012036	2	3
253506	255848	1	1
21001485	1713332	0	0
21002743	40228230	2	3
4034850	4024958	4	4
35502087	4144583	6	6
35707763	4112343	4	8
36154806	1119510	0	0
40248974	1125315	0	0
37220041	28060	2	2
44784105	40479768	4	4
44340259	1124300	0	0
45624971	1107830	0	0
45658360	1125315	0	0
45659982	19008572	2	3
45643379	1125315	0	0
45642095	1119510	0	0
45632866	914335	0	0
45627699	40162522	2	3
45669747	1125315	0	0
45698667	975125	0	0
45701131	1129625	0	0
45693064	19019273	2	3
45694314	1119510	0	0
46240457	1549786	0	0
45797369	1115008	0	0
46244771	40223768	2	3
45798130	975125	0	0
45693980	1125315	0	0
46293239	1125315	0	0
45801919	1119510	0	0
46320119	1129625	0	0
45675502	19008572	2	3
255573	261325	1	1
21001462	1307863	0	0
21002743	1107882	2	3
4185503	260139	4	4
21603444	40229134	5	6
35707763	198809	4	6
36156498	1119510	0	0
40250182	1332418	0	0
40763503	3016723	2	2
44784105	4152936	3	3
44339957	1310149	0	0
45625007	914335	0	0
45658363	1125315	0	0
45659991	40232448	2	3
45643441	1125315	0	0
45643031	1119510	0	0
45632869	738818	0	0
45627344	43012036	2	3
45669810	1125315	0	0
45698349	975125	0	0
45700858	1129625	0	0
45693065	19023398	2	3
45694342	1119510	0	0
46240457	1589505	0	0
45797465	19127890	0	0
46244856	19078461	2	3
45798252	1717327	0	0
45694010	1125315	0	0
46293093	1125315	0	0
45802173	1119510	0	0
46320154	1129625	0	0
45675532	40223834	2	3
255841	258780	1	1
21001463	1361711	0	0
21002743	1150837	2	3
4185503	255848	4	4
21602471	40224132	5	6
35707763	81893	4	10
36151054	1119510	0	0
40250185	1589505	0	0
40763503	3023103	2	2
43531056	4142905	5	5
44340194	1549786	0	0
45625091	1149196	0	0
45658412	1125315	0	0
45660004	19008572	2	3
45643236	1125315	0	0
45643021	1119510	0	0
45632804	1115008	0	0
45627708	19008572	2	3
45669824	1125315	0	0
45697594	975125	0	0
45697901	1129625	0	0
45690018	1115171	2	3
45694425	1119510	0	0
46240461	1118084	0	0
45797323	1112807	0	0
46243301	40229134	2	3
45798254	1309944	0	0
45694012	1125315	0	0
46293127	1125315	0	0
45802086	1119510	0	0
46313809	1129625	0	0
45675430	19075601	2	3
4015311	4024958	1	1
21001772	1119510	0	0
21002743	40228214	2	3
4030654	4242997	4	4
21602471	43012433	5	6
35707763	196456	4	5
36150930	1119510	0	0
40250193	1119510	0	0
40763503	3013682	2	2
43531052	4285898	6	7
44340194	1521369	0	0
45625096	738818	0	0
45658447	1125315	0	0
45660137	19133905	2	3
45643361	1125315	0	0
45642171	1119510	0	0
45632849	1322184	0	0
45627776	1107882	2	3
45669830	1125315	0	0
45697495	975125	0	0
45698019	1129625	0	0
45689963	40232448	2	3
45694606	1119510	0	0
46240186	1515774	0	0
45797326	738818	0	0
46243381	40162522	2	3
45798262	1000560	0	0
45694015	1125315	0	0
46293304	1125315	0	0
45802152	1119510	0	0
46313836	1129625	0	0
45675715	19059056	2	3
4166904	4146173	1	1
21001772	1129625	0	0
21002743	1150771	2	3
4042673	4336464	4	4
21602471	40224805	5	6
35707763	28060	5	6
36150907	1119510	0	0
40250199	1332418	0	0
40789120	3026361	2	2
43531052	440448	6	6
44340285	1192710	0	0
45625098	1153428	0	0
45656637	1125315	0	0
45660158	40228214	2	3
45643530	1125315	0	0
45642249	1119510	0	0
45632644	1174888	0	0
45627806	19008572	2	3
45669841	1125315	0	0
45697573	975125	0	0
45698141	1129625	0	0
45689982	40236824	2	3
45691133	1119510	0	0
46240186	19127890	0	0
45797328	1307863	0	0
46243318	46275444	2	3
45798263	1112807	0	0
45694017	1125315	0	0
46296448	1125315	0	0
45802089	1119510	0	0
46313734	1129625	0	0
45896932	19077572	2	3
4148204	260139	1	1
21001772	1149196	0	0
21002743	19125062	2	3
4133838	4230209	4	4
21603932	19078461	5	6
35800000	378001	9	11
36150915	1119510	0	0
40244765	1177480	0	0
40791227	3024561	2	2
43531052	198809	5	5
44340288	1738521	0	0
45624935	975125	0	0
45656678	1125315	0	0
45659860	19019273	2	3
45643427	1125315	0	0
45642185	1119510	0	0
45632885	1738521	0	0
45627793	19074843	2	3
45669743	1125315	0	0
45695147	975125	0	0
45698171	1129625	0	0
45689988	19008572	2	3
45691140	1119510	0	0
46240186	1549786	0	0
45797424	1174888	0	0
46243545	40232448	2	3
45798195	1307863	0	0
45694896	1125315	0	0
46296565	1125315	0	0
45802211	1119510	0	0
46314050	1129625	0	0
45897040	46221626	2	3
4148909	4181917	1	1
21001763	1551099	0	0
21002743	40223821	2	3
4133838	4234705	4	4
21603932	19019273	5	6
35800000	40481087	8	10
36150995	1119510	0	0
40244790	1177480	0	0
40770373	3013682	2	2
43531052	4310024	3	4
44340305	1107830	0	0
45624953	967823	0	0
45656617	1125315	0	0
45659884	1107882	2	3
45643430	1125315	0	0
45642330	1119510	0	0
45632889	738818	0	0
45624674	1115171	2	3
45669852	1125315	0	0
45695158	975125	0	0
45648770	1129625	0	0
45690077	40232448	2	3
45802384	1119510	0	0
46240188	1309944	0	0
45797425	1112807	0	0
46243369	43012036	2	3
45798420	1115008	0	0
45694907	1125315	0	0
46296584	1125315	0	0
45802213	1119510	0	0
46314628	1129625	0	0
45897099	40231925	2	3
723013	19115351	1	1
21001772	1192710	0	0
21001666	1551192	2	3
255919	140673	4	4
21603398	19133768	2	3
35800000	4048171	7	12
36151014	1119510	0	0
40248956	1551099	0	0
40770373	3023103	2	2
43531052	195588	3	3
44340426	1713332	0	0
45624981	715997	0	0
45656629	1125315	0	0
45667806	19019273	2	3
45643533	1125315	0	0
45642317	1119510	0	0
45630935	791967	0	0
45624613	40232448	2	3
45669781	1125315	0	0
45695224	975125	0	0
45694826	1129625	0	0
45690263	1127433	2	3
45802387	1119510	0	0
46242562	914335	0	0
45797568	1174888	0	0
46243354	40223834	2	3
45798424	1713332	0	0
45690891	1125315	0	0
46296803	1125315	0	0
45802343	1119510	0	0
46314629	1129625	0	0
45896985	1115171	2	3
715997	40223774	1	1
21001772	1150836	0	0
21001669	19007333	2	3
4042664	4330583	4	4
35508266	19078461	2	3
35800000	4029498	7	7
36151312	1119510	0	0
40244795	920293	0	0
40770373	3016723	2	2
43531053	195588	3	3
44340426	1759842	0	0
45622287	975125	0	0
45653066	1125315	0	0
45635534	40163554	2	3
45643469	1125315	0	0
45642299	1119510	0	0
45630948	1192710	0	0
45624406	19073188	2	3
45670578	1125315	0	0
45695268	975125	0	0
45694553	1129625	0	0
45690268	40174880	2	3
45802647	1119510	0	0
46242249	1713332	0	0
45797465	1549786	0	0
46243322	19073183	2	3
45798517	933724	0	0
45690900	1125315	0	0
46296600	1125315	0	0
45802335	1119510	0	0
46309371	1129625	0	0
45896998	40232448	2	3
1307863	40171902	1	1
21001766	1119510	0	0
21000643	19128022	1	1
444220	4230399	4	4
35507392	40228214	2	3
35800000	140673	7	7
36151316	1119510	0	0
40244803	1119510	0	0
40760921	3013682	2	2
44364134	19128009	2	2
44340405	1149196	0	0
45622275	1738521	0	0
45653161	1125315	0	0
45647263	19019273	2	3
45643536	1125315	0	0
45642325	1119510	0	0
45631202	1192710	0	0
45624412	1115171	2	3
45670592	1125315	0	0
45695296	975125	0	0
45694967	1129625	0	0
45688737	46275444	2	3
45802565	1119510	0	0
46242338	1149196	0	0
45797477	1778162	0	0
46243538	19008572	2	3
45798519	1551099	0	0
45691200	1125315	0	0
46296608	1125315	0	0
45799184	1119510	0	0
46309288	1129625	0	0
45897152	40232448	2	3
4022922	4230399	5	6
21001770	1177480	0	0
21000643	19127904	1	1
4078521	4301346	4	4
35507497	40228214	2	3
35800000	195588	6	6
36151326	1119510	0	0
40244808	1521369	0	0
40760921	3016723	2	2
44341806	19128263	2	2
44340274	701322	0	0
45622292	1310149	0	0
45653011	1125315	0	0
45635633	1107882	2	3
45643095	1125315	0	0
45639327	1119510	0	0
45629664	740275	0	0
45624453	1127433	2	3
45669926	1125315	0	0
45692182	975125	0	0
45694769	1129625	0	0
45688517	1115171	2	3
45802570	1119510	0	0
46242090	1332418	0	0
45797478	1149196	0	0
46243555	1551192	2	3
45798368	791967	0	0
45691204	1125315	0	0
46296728	1125315	0	0
45799500	1119510	0	0
46309305	1129625	0	0
45897018	19008572	2	3
4022922	81151	5	6
21001770	1112807	0	0
21001092	19074679	1	1
4162282	257012	4	4
35508232	40228214	2	3
36200000	4001336	5	10
36151222	1119510	0	0
40244808	19127890	0	0
37502347	4275113	2	2
44341806	19128022	2	2
44340226	1539403	0	0
45622296	1746114	0	0
45653016	1125315	0	0
45633986	46233710	2	3
45643223	1125315	0	0
45639135	1119510	0	0
45629665	1192710	0	0
45624666	19008572	2	3
45669976	1125315	0	0
45689278	975125	0	0
45694804	1129625	0	0
45688697	40229134	2	3
45688171	1119510	0	0
46242090	1545958	0	0
45797531	1115008	0	0
46243476	43012036	2	3
45798290	1107830	0	0
45691079	1125315	0	0
46296661	1125315	0	0
45799621	1119510	0	0
46309310	1129625	0	0
45897273	40223768	2	3
4023995	313217	5	6
21001770	738818	0	0
21001463	40171902	1	1
4162282	255848	4	4
35507733	19075601	2	3
36200000	4134304	5	12
36151225	1119510	0	0
40244808	1549786	0	0
37502347	4059978	2	2
44784105	4059173	2	2
44337795	1118084	0	0
45622296	1741122	0	0
45653021	1125315	0	0
45629566	19078924	2	3
45643152	1125315	0	0
45638932	1119510	0	0
45629720	1729720	0	0
45624685	40232448	2	3
45781318	1125315	0	0
45689398	975125	0	0
45695057	1129625	0	0
45687091	43012036	2	3
45688436	1119510	0	0
46242317	1332418	0	0
45797488	967823	0	0
46241051	42707627	2	3
45798410	1548195	0	0
45691150	1125315	0	0
46296748	1125315	0	0
45799392	1119510	0	0
46309318	1129625	0	0
45897026	1115171	2	3
255919	28060	5	6
21001773	1149196	0	0
21500574	1124300	4	4
4162282	40481087	4	4
35508371	1332419	2	3
36200000	378001	6	11
36151242	1119510	0	0
40250213	1192710	0	0
37502347	4238715	2	2
44364046	42902245	2	2
44337799	1549786	0	0
45622336	1539403	0	0
45653175	1125315	0	0
45625102	1713671	2	3
45643002	1125315	0	0
45639271	1119510	0	0
45629662	1102527	0	0
45624875	40169281	2	3
45781319	1125315	0	0
45686238	975125	0	0
45691897	1129625	0	0
45687104	46233988	2	3
45799882	1119510	0	0
46242387	1112807	0	0
45797497	1332418	0	0
46242544	40165015	2	3
45798412	1115008	0	0
45691206	1125315	0	0
46296507	1125315	0	0
45799449	1119510	0	0
46309173	1129625	0	0
45897342	19018935	2	3
\.


--
-- TOC entry 3887 (class 0 OID 3185484)
-- Dependencies: 209
-- Data for Name: concept_class; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".concept_class (concept_class_id, concept_class_name, concept_class_concept_id) FROM stdin;
\.


--
-- TOC entry 3888 (class 0 OID 3185487)
-- Dependencies: 210
-- Data for Name: concept_relationship; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".concept_relationship (concept_id_1, concept_id_2, relationship_id, valid_start_date, valid_end_date, invalid_reason) FROM stdin;
192671	35208414	Mapped from	1970-01-01	2099-12-31	
1118088	44923712	Mapped from	1970-01-01	2099-12-31	
1569708	35208414	Subsumes	2016-03-25	2099-12-31	
35208414	192671	Maps to	1970-01-01	2099-12-31	
35208414	1569708	Is a	2016-03-25	2099-12-31	
40162359	45011828	Mapped from	2009-08-03	2099-12-31	
44923712	1118088	Maps to	1970-01-01	2099-12-31	
45011828	40162359	Maps to	2009-08-03	2099-12-31	
\.


--
-- TOC entry 3889 (class 0 OID 3185490)
-- Dependencies: 211
-- Data for Name: concept_synonym; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".concept_synonym (concept_id, concept_synonym_name, language_concept_id) FROM stdin;
964261	cyanocobalamin 5000 MCG/ML Injectable Solution	4180186
1322184	clopidogrel	4180186
441267	Cystic fibrosis (disorder)	4180186
1718412	Kyleena 17.5 MCG per 24 HR Intrauterine System	4180186
4336464	Coronary artery bypass grafting	4180186
4102123	Latex allergy	4180186
4237458	Fracture of collar bone	4180186
4280726	Spasmodic rhinorrhoea	4180186
4330583	Vasectomy for contraception	4180186
3014576	Chloride SerPl-sCnc	4180186
4242997	Cholecystectomy	4180186
3049273	DXA Radius+Ulna T-score BMD	4180186
80809	Rheumatoid arthritis	4180186
196456	Gallbladder calculus (disorder)	4180186
4133840	Spirometry	4180186
40480160	Pathological fracture due to osteoporosis (disorder)	4180186
3027970	Calc; Calculation; Chemistry; GLB; Glob; Glob%; Globul; Globulins; Level; Mass concentration; Point in time; QNT; Quan; Quant; Quantitative; Random; Serum; SR	4180186
1519937	Etonogestrel 68 MG Drug Implant	4180186
4151422	Sputum examination (procedure)	4180186
4012477	Glucose challenge test	4180186
4202451	Percutaneous mechanical thrombectomy of portal vein using fluoroscopic guidance	4180186
1729720	phenoxymethylpenicillin	4180186
3006322	Bdy temp; bod; Bodies; BODY TEMPERATURE.MOLEC; Oral; Point in time; QNT; Quan; Quant; Quantitative; Random; Temp; Temperature	4180186
19128263	Trinessa 28 Day Pack	4180186
3023430	Cat Dander IgE Qn	4180186
192671	GI haemorrhage	4180186
3020655	Honey bee IgE Qn	4180186
4295880	Intramuscular injection	4180186
19075601	clopidogrel 75 MG Oral Tablet	4180186
44782520	Chronic paralysis due to lesion of spinal cord (disorder)	4180186
3019550	Sodium [Moles/volume] in Serum or Plasma	4180186
40162522	Acetaminophen 325 MG / Hydrocodone Bitartrate 7.5 MG Oral Tablet	4180186
40169281	fluticasone propionate 250 MCG / salmeterol 50 MCG (salmeterol xinafoate 72.5 MCG) per ACTUAT Dry Powder Inhaler, 60 ACTUAT	4180186
42707627	rocuronium bromide 10 MG/ML Injectable Solution	4180186
964261	Vitamin B 12 5 MG/ML Injectable Solution	4180186
1326303	Digoxin	4180186
441267	Fibrocystic disease	4180186
1718412	Kyleena 19.5 MG Intrauterine System	4180186
4336464	Coronary artery bypass graft operations	4180186
4302207	Allergy to hay	4180186
920293	Nitrofurantoin	4180186
4280726	Seasonal allergic rhinitis	4180186
4330583	Vasectomy (procedure)	4180186
926487	Pancreatin	4180186
4242997	Excision of gallbladder	4180186
4139681	Allergy to dairy product	4180186
80809	Rheumatoid disease	4180186
196456	Gallstones	4180186
4133840	Spirometry (procedure)	4180186
40480160	Pathological fracture due to osteoporosis	4180186
3027970	Globulin [Mass/volume] in Serum by calculation	4180186
1521369	Norethindrone	4180186
19133873	PCN V K+ 250 MG Oral Tablet	4180186
4012477	OGTT - Oral glucose tolerance test	4180186
4202451	Percutaneous mechanical thrombectomy of portal vein using fluoroscopic guidance (procedure)	4180186
1738521	Doxycycline	4180186
3006322	Oral temp	4180186
35605482	2 ML Ondansetron 2 MG/ML Injection	4180186
3016723	Chemistry; CR; Crea; Creat; Level; Mass concentration; Pl; Plasma; Plsm; Point in time; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SR	4180186
192671	GI bleeding	4180186
4337138	Transplant of lung	4180186
4295880	Intramuscular injection (procedure)	4180186
19079524	NaCl 9 MG/ML Injectable Solution	4180186
3010813	#; ABS; absolute; absolutes; Blood; Cnt; Count; Count/volume; CT; HEMATOLOGY/CELL COUNTS; Leuc; Leuk; Leukocyte; Lkcs; Number concentration; Number Concentration (count/vol); Point in time; QNT; Quan; Quant; Quantitative; Random; WB; WBC; WBCs; White blood cell; White blood cells; Whole blood	4180186
3019550	Sodium SerPl-sCnc	4180186
40162522	APAP 325 MG / hydrocodone bitartrate 7.5 MG Oral Tablet	4180186
40163554	Warfarin Sodium 5 MG Oral Tablet	4180186
42707627	rocuronium bromide 50 MG per 5 ML Concentrate for Injectable Solution	4180186
1768849	Cefaclor	4180186
975125	Hydrocortisone	4180186
441267	Cystic fibrosis	4180186
1718412	Levonorgestrel 0.000729 MG/HR Intrauterine System [Kyleena]	4180186
4336464	CAG - Coronary artery graft	4180186
4302207	Allergy to grass pollen	4180186
920300	nitrofurantoin 25 MG per 5 ML Oral Suspension	4180186
4280726	Spasmodic rhinorrhea	4180186
4330583	Vasectomy	4180186
836654	Tacrine	4180186
4242997	Cholecystectomy (procedure)	4180186
4139681	Allergy to dairy product (disorder)	4180186
80809	Proliferative arthritis	4180186
196456	Gallbladder stones	4180186
4156265	Facial laceration	4180186
3013721	Aspartate aminotransferase [Enzymatic activity/volume] in Serum or Plasma	4180186
3027970	Globulin Ser Calc-mCnc	4180186
1521369	norethisterone	4180186
19133873	PCN V Pot 250 MG Oral Tablet	4180186
4012477	Glucose tolerance test (procedure)	4180186
4197460	Injection of epinephrine	4180186
372328	Otitis media	4180186
3006322	Oral temperature	4180186
35605482	ondansetron 4 MG per 2 ML Injection	4180186
3016723	Creatinine [Mass/volume] in Serum or Plasma	4180186
192671	Gastrointestinal bleeding	4180186
4337138	LTx - Lung transplant	4180186
4295880	IMI - Intramuscular injection	4180186
19079524	sodium chloride 0.9 % Injectable Solution	4180186
3010813	Leukocytes [#/volume] in Blood	4180186
4035793	Pulmonary rehabilitation	4180186
40236824	Phenazopyridine hydrochloride 100 MG Oral Tablet	4180186
40165015	Meperidine Hydrochloride 50 MG Oral Tablet	4180186
42902245	{5 (Ethinyl Estradiol 0.02 MG / norethindrone acetate 1 MG Oral Tablet) / 7 (Ethinyl Estradiol 0.03 MG / norethindrone acetate 1 MG Oral Tablet) / 9 (Ethinyl Estradiol 0.035 MG / norethindrone acetate 1 MG Oral Tablet) / 7 (Ferrous fumarate 75 MG Oral Tablet) } Pack [Estrostep Fe 28 Day]	4180186
1778162	Cefuroxime	4180186
317009	Hyperreactive airway disease	4180186
441267	Mucoviscidosis	4180186
1713332	Amoxicillin	4180186
4336464	CABG - Coronary artery bypass graft	4180186
4302207	Allergy to grass pollen (disorder)	4180186
920300	Nitrofurantoin 5 MG/ML Oral Suspension	4180186
4181917	EEG	4180186
4330583	Male surgical sterilisation procedure	4180186
836659	Tacrine 10 MG Oral Capsule	4180186
4242997	Gallbladder excision	4180186
4109685	Laceration of foot	4180186
80809	RA - Rheumatoid arthritis	4180186
196456	Gallstone	4180186
4156265	Facial laceration (disorder)	4180186
3013721	Asp; Aspartate amino transferase; Aspartate transaminase; Aspartic acid; AST; Catalytic Concentration; Chemistry; Glutamic oxaloacetic transaminase; Pl; Plasma; Plsm; Point in time; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SGOT; SR	4180186
19059056	ASA 81 MG Oral Tablet	4180186
433644	Shellfish allergy (disorder)	4180186
19133873	Penicillin V Potassium 250 MG Oral Tablet	4180186
19128065	{7 (Inert Ingredients 1 MG Oral Tablet) / 21 (Mestranol 0.05 MG / Norethindrone 1 MG Oral Tablet) } Pack [Norinyl 1+50 28 Day]	4180186
4197460	Injection of epinephrine (procedure)	4180186
372328	Otitis media (disorder)	4180186
40479422	Injury of medial collateral ligament of knee (disorder)	4180186
40479768	Injury of anterior cruciate ligament	4180186
3016723	Creat SerPl-mCnc	4180186
192671	GIH - Gastrointestinal hemorrhage	4180186
4337138	Transplant of lung (procedure)	4180186
4295880	IM - Intramuscular injection	4180186
19079524	sodium chloride 9 MG/ML Injectable Solution	4180186
3010813	WBC # Bld	4180186
4035793	Pulmonary rehabilitation (regime/therapy)	4180186
40228214	cetirizine HCl 10 MG Oral Tablet	4180186
40758406	AIDS; H+P; H+P.HX; History; Human immunodeficiency virus; Nominal; P prime; Point in time; Random	4180186
42902245	Estrostep Fe 28 Day Pack	4180186
1124300	Diclofenac	4180186
317009	Bronchial hyperresponsiveness	4180186
441267	CF - Cystic fibrosis	4180186
1118084	celecoxib	4180186
4336464	CBG - Coronary bypass graft	4180186
3001488	ABS; Aby; Allergen; Allergens; ALLERGY TESTING; Antby; Anti; Antibodies; Antibody; Arbitrary concentration; Autoantibodies; Autoantibody; f002; f2; f43; Immune globulin E; Immunoglobulin E; Point in time; QNT; Quan; Quant; Quantitative; Random; Serum; SR	4180186
920334	nitrofurantoin macrocrystals 50 MG Oral Capsule	4180186
4181917	Electroencephalogram (procedure)	4180186
4329847	MI - Myocardial infarction	4180186
836659	tacrine 10 MG (tacrine hydrochloride 12.75 MG) Oral Capsule	4180186
4187458	Review of systems	4180186
4109685	Laceration of foot (disorder)	4180186
80809	Rheumatic gout	4180186
196456	Gallbladder calculus	4180186
4198190	Excision of appendix (procedure)	4180186
3013721	AST SerPl-cCnc	4180186
19059056	Aspirin 81 MG Oral Tablet	4180186
433644	Shellfish allergy	4180186
19133873	PEN V K+ 250 MG Oral Tablet	4180186
19128065	Norinyl 1+50 28 Day Pack	4180186
4197460	Injection of adrenaline	4180186
372328	OM - Otitis media	4180186
40479422	Injury of medial collateral ligament of knee	4180186
40479768	Injury of anterior cruciate ligament (disorder)	4180186
3006451	ABS; Aby; Allergen; Allergens; ALLERGY TESTING; Antby; Anti; Antibodies; Antibody; Arbitrary concentration; Autoantibodies; Autoantibody; f256; Immune globulin E; Immunoglobulin E; Juglans sp; Point in time; QNT; Quan; Quant; Quantitative; Random; Serum; SR; Walnut; Walnuts	4180186
255848	Pneumonia (disorder)	4180186
40236446	Methylphenidate Hydrochloride 20 MG Oral Tablet	4180186
4155034	Laceration of forearm (disorder)	4180186
19079524	Sodium Chloride 9 MG/ML Injectable Solution	4180186
134438	Contact eczema	4180186
4037675	Brief general examination	4180186
40228214	cetirizine hydrochloride 10 MG Oral Tablet	4180186
40758406	HIV status	4180186
44783196	Surgical manipulation of joint of knee (procedure)	4180186
1347450	alteplase	4180186
317009	Asthma (disorder)	4180186
441267	CF	4180186
1119510	Dextromethorphan	4180186
4336464	Coronary artery bypass graft	4180186
3001488	Cow milk IgE Ab [Units/volume] in Serum	4180186
920334	NITROFURANTOIN, MACROCRYSTALS 50 MG Oral Capsule	4180186
4181917	Electroencephalogram	4180186
4329847	Myocardial infarct	4180186
3004501	Chemistry; Glu; Gluc; Glucoseur; Level; Mass concentration; Pl; Plasma; Plsm; Point in time; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SR	4180186
4187458	Review of systems (procedure)	4180186
4285898	Polyp of colon (disorder)	4180186
80809	RhA - Rheumatoid arthritis	4180186
196456	Cholecystolithiasis	4180186
4198190	Appendectomy	4180186
1361711	glyceryl trinitrate	4180186
4168004	Burn injury (morphologic abnormality)	4180186
723013	Diazepam	4180186
19133873	PEN V Pot 250 MG Oral Tablet	4180186
19112599	Chlorpheniramine Maleate 2 MG/ML Oral Solution	4180186
257012	Chronic rhinosinusitis	4180186
433125	Infection due to Staphylococcus aureus	4180186
40478878	Screen for 20 common genetic mutations of cystic fibrosis using amplification refractory mutation system polymerase chain reaction assay technique	4180186
40223768	Donepezil hydrochloride 10 MG Oral Tablet	4180186
3006451	Walnut IgE Ab [Units/volume] in Serum	4180186
255848	Pneumonia	4180186
40169216	120 ACTUAT Fluticasone propionate 0.044 MG/ACTUAT Metered Dose Inhaler	4180186
4155034	Laceration of forearm	4180186
19129144	{28 (Norethindrone 0.35 MG Oral Tablet) } Pack [Jolivette 28 Day]	4180186
134438	Dermatitis venenata	4180186
4037675	Brief general examination (procedure)	4180186
40228230	cetirizine hydrochloride 5 MG Oral Tablet	4180186
40769179	Area affected by eczema Head+Neck PhenX	4180186
44783196	Surgical manipulation of joint of knee	4180186
1124957	Oxycodone	4180186
317009	Bronchial hypersensitivity	4180186
4059978	Insertion of subcutaneous contraceptive (procedure)	4180186
1153428	fexofenadine	4180186
4166224	Perforated appendix	4180186
3001488	Cow Milk IgE Qn	4180186
260139	Acute bronchitis	4180186
4181917	Electroencephalography	4180186
4329847	Myocardial infarction	4180186
3004501	Glucose [Mass/volume] in Serum or Plasma	4180186
4202832	Intubation	4180186
4285898	Polyp colon	4180186
80809	Chronic rheumatic arthritis	4180186
196456	GS - Gallstone	4180186
4198190	Excision of appendix	4180186
1361711	Nitroglycerin	4180186
4168004	Burn injury	4180186
753626	Propofol	4180186
4243062	X-ray of wrist	4180186
19112599	chlorpheniramine maleate 2 MG per 1 ML Oral Solution	4180186
257012	Chronic sinusitis (disorder)	4180186
433125	Infection caused by Staphylococcus aureus (disorder)	4180186
40478878	Cystic fibrosis 20 common mutation test	4180186
40223774	Donepezil hydrochloride 23 MG [Aricept]	4180186
3006451	Walnut IgE Qn	4180186
4001336	Commotio cerebri	4180186
40169216	fluticasone propionate 0.044 MG/ACTUAT Metered Dose Inhaler, 120 ACTUAT	4180186
4170947	Bone immobilisation	4180186
19129144	Jolivette 28 Day Pack	4180186
134438	Contact dermatitis	4180186
4043071	Cognitive and behavioral therapy (regime/therapy)	4180186
40229134	Acetaminophen 21.7 MG/ML / Dextromethorphan Hydrobromide 1 MG/ML / doxylamine succinate 0.417 MG/ML Oral Solution	4180186
40769179	Brain; Count/time; Cranial; Cranium; Intracranial; nRate; Number rate; Number Rate = Count/Time; Point in time; QNT; Quan; Quant; Quantitative; Random; Skull	4180186
46275916	1 ML Epinephrine 1 MG/ML Injection	4180186
1125315	Acetaminophen	4180186
317009	BHR - Bronchial hyperreactivity	4180186
4059978	Insertion of subcutaneous contraceptive	4180186
1154029	Fentanyl	4180186
4166224	Rupture of appendix	4180186
3036780	ABS; Aby; Allergen; Allergens; ALLERGY TESTING; American house dust mite; Antby; Anti; Antibodies; Antibody; Arbitrary concentration; Autoantibodies; Autoantibody; D farinae; d002; d2; Dermatophagoides farianae; HDM; House dust mite; Immune globulin E; Immunoglobulin E; Point in time; QNT; Quan; Quant; Quantitative; Random; Serum; SR	4180186
260139	Acute bronchitis (disorder)	4180186
4181917	EEG - Electroencephalography	4180186
4329847	Myocardial infarction (disorder)	4180186
3004501	Glucose SerPl-mCnc	4180186
4202832	Intubation (procedure)	4180186
4285898	Polyp of colon	4180186
80809	Atrophic arthritis	4180186
321042	Cardiac arrest	4180186
4198190	Appendicectomy	4180186
1501700	levothyroxine	4180186
4168004	Burn - lesion	4180186
701322	Memantine	4180186
4243062	Radiography of wrist (procedure)	4180186
19003953	Rocuronium	4180186
257012	Chronic sinusitis	4180186
433125	Staphylococcus aureus infection	4180186
40478878	Screen for 20 common genetic mutations of cystic fibrosis using amplification refractory mutation system polymerase chain reaction assay technique (procedure)	4180186
40223821	Fexofenadine hydrochloride 30 MG Oral Tablet	4180186
1557272	Alendronate	4180186
4001336	MTBI - Mild traumatic brain injury	4180186
45766064	History of one seizure ever	4180186
4170947	Bone immobilization (procedure)	4180186
19076374	Diazepam 5 MG/ML Injectable Solution	4180186
134438	CD - Contact dermatitis	4180186
4043071	Cognitive and behavioral therapy	4180186
40229134	acetaminophen 325 MG / dextromethorphan HBr 15 MG / doxylamine succinate 6.25 MG per 15 ML Oral Solution	4180186
40769179	Percentage area affected by eczema Head and Neck [PhenX]	4180186
46275916	epinephrine 1 MG per 1 ML Injection	4180186
1125443	Dornase Alfa	4180186
317009	Bronchial hyperreactivity	4180186
3013682	Blood urea nitrogen; BUN; Chemistry; Level; Mass concentration; N; N2; Nit; Pl; Plasma; Plsm; Point in time; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SR; UN	4180186
1154343	Albuterol	4180186
4166224	Rupture of appendix (disorder)	4180186
3036780	American house dust mite IgE Ab [Units/volume] in Serum	4180186
261325	Emphysema of lung	4180186
4108705	Intravenous blood transfusion of packed cells	4180186
4329847	Heart attack	4180186
3005136	ABS; Aby; Allergen; Allergens; ALLERGY TESTING; Antby; Anti; Antibodies; Antibody; Arbitrary concentration; Autoantibodies; Autoantibody; C herbarum; Hormodendrum; Immune globulin E; Immunoglobulin E; m002; m2; Point in time; QNT; Quan; Quant; Quantitative; Random; Serum; SR	4180186
21494966	Abd; Abdo; Abdomen+; Abdominal; Exam; Examination; Finding; Findings; H+P; H+P.PX; Nominal; P prime; Phys find; Point in time; Random	4180186
4285898	Colonic polyp	4180186
30753	Esophagitis (disorder)	4180186
321042	Cardiac arrest (disorder)	4180186
4134304	Fracture subluxation of wrist (disorder)	4180186
1137529	salmeterol	4180186
4168004	Burn	4180186
705944	Methylphenidate	4180186
4243062	Radiography of wrist	4180186
19123231	atomoxetine 100 MG (as atomoxetine HCl) Oral Capsule	4180186
258780	Obstructive chronic bronchitis	4180186
433125	Infection caused by Staphylococcus aureus	4180186
19078219	Sufentanil	4180186
757627	Galantamine	4180186
1713671	Amoxicillin 250 MG / Clavulanate 125 MG Oral Tablet	4180186
4001336	Concussion injury of brain (disorder)	4180186
45766064	History of single seizure (situation)	4180186
4170947	Bone immobilization	4180186
19077344	ferrous sulfate 324 MG (iron 65 MG) Oral Tablet	4180186
134438	Contact dermatitis (disorder)	4180186
4043071	Cognitive and behavioural therapy	4180186
40229134	acetaminophen 650 MG / dextromethorphan HBr 30 MG / doxylamine succinate 12.5 MG per 30 ML Oral Solution	4180186
40769184	Area affected by eczema UE-Bl PhenX	4180186
1125443	dornase alfa (desoxyribonuclease)	4180186
317009	Asthma	4180186
3013682	BUN SerPl-mCnc	4180186
1154615	200 ACTUAT Albuterol 0.09 MG/ACTUAT Metered Dose Inhaler	4180186
4166224	Appendicitis with perforation	4180186
3036780	D farinae IgE Qn	4180186
261325	Pulmonary emphysema (disorder)	4180186
4108705	Intravenous blood transfusion of packed cells (procedure)	4180186
4329847	Infarction of heart	4180186
3005136	C herbarum IgE Qn	4180186
21494966	Phys find Abd by Palpation	4180186
3011505	Breathing; End tidal volume; Exp; FEV; FEV1; FEV1%; FEV1/FVC; Forced expiratory volume in 1 second; FVC; Lungs; Point in time; PULMONARY; QNT; Quan; Quant; Quantitative; Random; RS; S prime; VC; Vet; Vol; Vol exp; Volume ratio	4180186
30753	Oesophagitis	4180186
1177480	Ibuprofen	4180186
4134304	Fracture subluxation of wrist	4180186
1396131	ferrous sulfate	4180186
1503184	Mestranol	4180186
4058899	Clavicle X-ray	4180186
4275113	Fitting of coil	4180186
19123231	atomoxetine 100 MG Oral Capsule	4180186
258780	Bronchitis with airway obstruction	4180186
133834	AD - Atopic dermatitis	4180186
19074679	Carbamazepine 20 MG/ML Oral Suspension [Tegretol]	4180186
440448	Appendicitis (disorder)	4180186
1713671	amoxicillin (as amoxicillin trihydrate) 250 MG / clavulanic acid (as clavulanate potassium) 125 MG Oral Tablet	4180186
4001336	Concussion injury of brain	4180186
45766064	History of single seizure	4180186
4169137	Allergy to wheat (disorder)	4180186
19077344	ferrous sulfate 325 MG (iron 65 MG) Oral Tablet	4180186
3014599	ABS; Aby; Allergen; Allergens; ALLERGY TESTING; Antby; Anti; Antibodies; Antibody; Arbitrary concentration; Autoantibodies; Autoantibody; f001; f1; Immune globulin E; Immunoglobulin E; Point in time; QNT; Quan; Quant; Quantitative; Random; Serum; SR	4180186
40213180	meningococcal MCV4P	4180186
40229134	APAP 21.7 MG/ML / Dextromethorphan Hydrobromide 1 MG/ML / doxylamine succinate 0.417 MG/ML Oral Solution	4180186
40769184	Arm; Bil; Bilat; Both; Count/time; EXT; Extr-Bl; nRate; Number rate; Number Rate = Count/Time; Point in time; QNT; Quan; Quant; Quantitative; Random; UE; UE-Bl; Up	4180186
1149196	Cetirizine	4180186
317009	Bronchial asthma	4180186
3013682	Urea nitrogen [Mass/volume] in Serum or Plasma	4180186
4219399	Allergy to fish (disorder)	4180186
4166224	Perforation of appendix	4180186
3008598	Chemistry; FR; FreeT4; FT4; Level; Levothyroxine; Levo-thyroxine; L-thyroxine; Mass concentration; Non-protein bound; Pl; Plasma; Plsm; Point in time; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SR; T4; T-4; T4 Free; thyroid hormone; Thyrox; Thyroxin; Thyrx; Total T4; TT4	4180186
261325	Pulmonary emphysema	4180186
4015189	Microbial culture of sputum	4180186
4329847	Cardiac infarction	4180186
3005136	Cladosporium herbarum IgE Ab [Units/volume] in Serum	4180186
21494966	Physical findings of Abdomen by Palpation	4180186
3011505	FEV1/FVC	4180186
30753	Esophagitis	4180186
1192710	Chlorpheniramine	4180186
40243436	1 ML Atropine Sulfate 1 MG/ML Injection	4180186
1000560	Ondansetron	4180186
1539403	Simvastatin	4180186
4058899	Plain X-ray of clavicle	4180186
4275113	Introduction of intrauterine contraceptive device	4180186
19127890	Inert Ingredients	4180186
258780	Chronic bronchitis with emphysema	4180186
133834	Allergic dermatitis	4180186
19074679	Tegretol 100 MG per 5 ML Oral Suspension	4180186
440448	Appendicitis	4180186
1717327	Ampicillin	4180186
4001336	Brain concussion	4180186
46275444	Piperacillin 4000 MG / tazobactam 500 MG Injection	4180186
4169137	Allergy to wheat	4180186
19077344	ferrous sulfate 325 MG Oral Tablet	4180186
3014599	Egg white IgE Ab [Units/volume] in Serum	4180186
40213180	meningococcal polysaccharide (groups A, C, Y and W-135) diphtheria toxoid conjugate vaccine (MCV4P)	4180186
40213299	hepatitis A vaccine, pediatric/adolescent dosage, 2 dose schedule	4180186
40769184	Percentage area affected by eczema Upper extremity - bilateral [PhenX]	4180186
1149380	fluticasone	4180186
317009	Asthmatic	4180186
4066995	Fracture of vertebral column with spinal cord injury	4180186
4219399	Allergy to fish	4180186
4314290	Chloride measurement, sweat	4180186
3008598	T4 Free SerPl-mCnc	4180186
4234705	Evaluation of psychiatric state of patient	4180186
4015189	Microbial culture of sputum (procedure)	4180186
19045231	Pancreatin 4X 600 MG Oral Tablet	4180186
4059173	Fracture of ankle (disorder)	4180186
4283893	Sinusitis (disorder)	4180186
4048169	Allergy to house dust mite	4180186
378001	Concussion with no loss of consciousness	4180186
78272	Sprain of wrist	4180186
40243436	atropine sulfate 1 MG per 1 ML Injection	4180186
1127078	Acetaminophen 160 MG Oral Tablet	4180186
1539411	Simvastatin 20 MG Oral Tablet	4180186
4058899	Plain X-ray of clavicle (procedure)	4180186
4275113	Insertion of intrauterine contraceptive device (procedure)	4180186
19127904	{24 (drospirenone 3 MG / Ethinyl Estradiol 0.02 MG Oral Tablet) / 4 (Inert Ingredients 1 MG Oral Tablet) } Pack [Yaz 28 Day]	4180186
258780	Chronic obstructive bronchitis	4180186
133834	Disseminated neurodermatitis	4180186
19074679	Tegretol 20 MG/ML Oral Suspension	4180186
440086	Child attention deficit disorder	4180186
1728416	benzylpenicillin	4180186
4001336	Mild traumatic brain injury	4180186
46275444	piperacillin / tazobactam 4.5 GM Injection	4180186
4163951	EKG	4180186
19077344	FESO4 325 MG Oral Tablet	4180186
3014599	Egg White IgE Qn	4180186
40213198	Pneumococcal conjugate PCV 13	4180186
40213306	Hep B, adult	4180186
40769189	Area affected by eczema Trunk PhenX	4180186
1150770	Astemizole	4180186
317009	Airway hyperreactivity	4180186
4066995	Fracture of vertebral column with spinal cord injury (disorder)	4180186
4216130	Percutaneous coronary intervention	4180186
4314290	Cystic fibrosis sweat test (procedure)	4180186
3008598	Thyroxine (T4) free [Mass/volume] in Serum or Plasma	4180186
4234705	Evaluation of psychiatric state of patient (procedure)	4180186
4078793	Electrical cardioversion	4180186
19045231	Pancreatin 600 MG Oral Tablet [Pancreatin 4X]	4180186
4059173	Fracture of ankle	4180186
4283893	Sinusitis	4180186
4048169	Allergy to house dust mite (disorder)	4180186
378001	Concussion with no loss of consciousness (disorder)	4180186
78272	Sprain of wrist joint	4180186
40481087	Viral sinusitis (disorder)	4180186
1127078	APAP 160 MG Oral Tablet	4180186
1545958	atorvastatin	4180186
3026361	#; ABS; absolute; absolutes; Blood; Cnt; Count; Count/volume; CT; Discocytes; Erthrocyte; Erythrocyte; HEMATOLOGY/CELL COUNTS; Number concentration; Number Concentration (count/vol); Point in time; QNT; Quan; Quant; Quantitative; Random; RBC; RBCS; Red blood cell; Red blood cells; Red blood corpuscle; Red blood corpusles; Red cell; Red cells; WB; Whole blood	4180186
4275113	Insertion of IUD	4180186
19127904	Yaz 28 Day Pack	4180186
258780	Emphysematous bronchitis	4180186
133834	Allergic eczema	4180186
19074841	12 HR Cefaclor 500 MG Extended Release Oral Tablet	4180186
440086	Child attention deficit disorder (disorder)	4180186
1728416	Penicillin G	4180186
4029498	Seizure disorder	4180186
4174876	Allergy to bee venom (disorder)	4180186
4163951	Electrocardiographic procedure	4180186
19077572	galantamine 4 MG (as galantamine hydrobromide 5.126 MG) Oral Tablet	4180186
3024561	Alb; Chemistry; Level; Mass concentration; Pl; Plasma; Plsm; Point in time; Protein.albumin; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SR	4180186
40213198	pneumococcal conjugate vaccine, 13 valent	4180186
40213306	hepatitis B vaccine, adult dosage	4180186
40769189	Count/time; nRate; Number rate; Number Rate = Count/Time; Point in time; QNT; Quan; Quant; Quantitative; Random	4180186
1150771	Astemizole 10 MG Oral Tablet	4180186
317576	Arteriosclerotic heart disease	4180186
3024731	Average; Avg; Discocyte; Entitic volume; Erc; Erythrocytes; HEMATOLOGY/CELL COUNTS; MCV; Point in time; QNT; Quan; Quant; Quantitative; Random; RBC; Red blood cell; Red blood cells; Red blood corpuscle; Red blood corpusles; Red cell; Red cells; Vol	4180186
4216130	Percutaneous coronary intervention (procedure)	4180186
4314290	Sweat chloride level	4180186
3006906	Ca; Cal; Chemistry; Level; Mass concentration; Pl; Plasma; Plsm; Point in time; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SR	4180186
4094814	Bullet wound	4180186
4078793	Direct current cardioversion (procedure)	4180186
4323902	Lung volume reduction surgery (procedure)	4180186
4059173	Fracture of distal end of tibia and fibula	4180186
4337611	SLTx - Single lung transplant	4180186
4048169	House dust mite allergy	4180186
378419	Alzheimer dementia	4180186
78272	Wrist sprain	4180186
40481087	Viral sinusitis	4180186
1127433	Acetaminophen 325 MG Oral Tablet	4180186
1545959	atorvastatin 80 MG Oral Tablet	4180186
3026361	Erythrocytes [#/volume] in Blood	4180186
4275113	Insertion of intrauterine device	4180186
4195803	Bone density scan	4180186
258780	COB - Chronic obstructive bronchitis	4180186
133834	Atopic dermatitis	4180186
19074841	cefaclor 500 MG 12 HR Extended Release Oral Tablet	4180186
439777	Anaemia	4180186
1332418	Amlodipine	4180186
4029498	Seizure disorder (disorder)	4180186
4174876	Allergy to bee venom	4180186
4163951	Electrocardiogram	4180186
19077572	Galantamine 4 MG Oral Tablet	4180186
3024561	Albumin [Mass/volume] in Serum or Plasma	4180186
40213201	pneumococcal polysaccharide PPV23	4180186
40213314	Haemophilus influenzae type b vaccine, PRP-OMP conjugate	4180186
40769189	Percentage area affected by eczema Trunk [PhenX]	4180186
1150836	Terfenadine	4180186
317576	Coronary arteriosclerosis	4180186
3024731	MCV [Entitic volume]	4180186
4216130	PCI - Percutaneous coronary intervention	4180186
4314290	Cystic fibrosis sweat test	4180186
3006906	Calcium [Mass/volume] in Serum or Plasma	4180186
4094814	Bullet wound (disorder)	4180186
4078793	Direct current cardioversion	4180186
4323902	Lung volume reduction surgery	4180186
4059173	Ankle fracture	4180186
4337611	Single lung transplant	4180186
4048171	Perennial allergic rhinitis with seasonal variation	4180186
378419	AD - Alzheimer's disease	4180186
78272	Sprain of wrist (disorder)	4180186
40231925	Acetaminophen 325 MG / Oxycodone Hydrochloride 5 MG Oral Tablet	4180186
1127433	APAP 325 MG Oral Tablet	4180186
1545959	atorvastatin (as atorvastatin calcium) 80 MG Oral Tablet	4180186
3026361	RBC # Bld	4180186
4275113	IUD - Fitting of intrauterine device	4180186
4195803	Bone density scan (procedure)	4180186
258780	Chronic obstructive bronchitis (disorder)	4180186
133834	Atopic dermatitis (disorder)	4180186
19074843	Cefaclor 250 MG Oral Capsule	4180186
439777	Anemia	4180186
1332419	Amlodipine 5 MG Oral Tablet	4180186
19129655	Ampicillin 100 MG/ML Injectable Solution	4180186
4116491	Escherichia coli urinary tract infection	4180186
4163951	Electrocardiographic procedure (procedure)	4180186
40766240	Are you covered by health insurance or some other kind of health care plan [PhenX]	4180186
3024561	Albumin SerPl-mCnc	4180186
40213201	pneumococcal polysaccharide vaccine, 23 valent	4180186
40213314	Hib (PRP-OMP)	4180186
40769194	Area affected by eczema LE-Bl PhenX	4180186
1150837	Terfenadine 60 MG Oral Tablet	4180186
317576	Coronary sclerosis	4180186
3024731	MCV RBC	4180186
4230209	Psychiatric follow-up (procedure)	4180186
4314290	Sweat chloride	4180186
3006906	Calcium SerPl-mCnc	4180186
4024289	Radiography of ankle	4180186
19002770	desflurane	4180186
4324181	History of cardiac arrest	4180186
3012494	ABS; Aby; Allergen; Allergens; ALLERGY TESTING; Antby; Anti; Antibodies; Antibody; Arbitrary concentration; Autoantibodies; Autoantibody; f013; f13; Immune globulin E; Immunoglobulin E; Peanut; Point in time; QNT; Quan; Quant; Quantitative; Random; Serum; SR	4180186
4337611	Single lung transplant (procedure)	4180186
4048171	Perennial allergic rhinitis with seasonal variation (disorder)	4180186
378419	Alzheimer disease	4180186
257012	Chronic infection of sinus	4180186
40231925	APAP 325 MG / oxycodone hydrochloride 5 MG Oral Tablet	4180186
1589505	Levonorgestrel	4180186
1548195	Estradiol	4180186
4084167	Acute allergic reaction (disorder)	4180186
4275113	Fitting of intrauterine device	4180186
4199276	Removal of subcutaneous contraceptive (procedure)	4180186
140673	Hypothyroid	4180186
375671	Concussion with loss of consciousness	4180186
19075001	Cefuroxime 250 MG Oral Tablet	4180186
439777	Absolute anaemia	4180186
1332419	amlodipine (as amlodipine besylate) 5 MG Oral Tablet	4180186
19129655	ampicillin (as ampicillin sodium) 100 MG/ML Injectable Solution	4180186
4116491	Escherichia coli urinary tract infection (disorder)	4180186
4163971	Laparoscopic cholecystectomy (procedure)	4180186
40766240	Finding; Findings; Health insurance coverage; Ordinal; Othr; Point in time; QL; Qual; Qualitative; Random; Screen	4180186
1343916	Epinephrine	4180186
40213216	rotavirus, live, monovalent vaccine	4180186
40213320	HPV, quadrivalent	4180186
40769194	Bil; Bilat; Both; Count/time; EXT; Extr-Bl; LE; LE-Bl; Leg; Low; nRate; Number rate; Number Rate = Count/Time; Point in time; QNT; Quan; Quant; Quantitative; Random	4180186
1305058	Methotrexate	4180186
317576	CHD - Coronary heart disease	4180186
3015076	ABS; Aby; Allergen; Allergens; ALLERGY TESTING; Antby; Anti; Antibodies; Antibody; Arbitrary concentration; Autoantibodies; Autoantibody; f014; f14; Gly; Immune globulin E; Immunoglobulin E; Largest; Maximal; Maximum; Peak; Point in time; QNT; Quan; Quant; Quantitative; Random; Serum; Soja hispida; Soy bean; Soya bean; Soyabean; Soybean; SR	4180186
4230209	Psychiatric follow-up	4180186
4145310	Pelvis X-ray (procedure)	4180186
3009542	Blood; Hct; HEMATOLOGY/CELL COUNTS; PCV; Percent; Point in time; QNT; Quan; Quant; Quantitative; Random; Volfr; Volume fraction; WB; Whole blood	4180186
4024289	Radiography of ankle (procedure)	4180186
19006318	PCN G 375 MG/ML Injectable Solution	4180186
4324181	History of cardiac arrest (situation)	4180186
3012494	Peanut IgE Ab [Units/volume] in Serum	4180186
4218389	Whiplash injury	4180186
1307863	Verapamil	4180186
378419	Alzheimer's disease (disorder)	4180186
80502	OP - Osteoporosis	4180186
40232448	Diphenhydramine Hydrochloride 25 MG Oral Tablet	4180186
708298	Midazolam	4180186
3028833	Bili; Bilirubins; Blood; Chemistry; Level; Mass concentration; Point in time; QNT; Quan; Quant; Quantitative; Random; TBIL; WB; Whole blood	4180186
4084167	Acute allergic reaction	4180186
4275113	Insertion of intrauterine contraceptive device	4180186
4199276	Removal of subcutaneous contraceptive	4180186
140673	Hypothyroidism	4180186
133834	Atopic eczema	4180186
19075001	cefuroxime (as cefuroxime axetil) 250 MG Oral Tablet	4180186
439777	Absolute anemia	4180186
1594382	epinephrine (generic for Adrenaclick) 0.3 MG per 0.3 ML Auto-Injector	4180186
19127918	{21 (Ethinyl Estradiol 0.03 MG / Levonorgestrel 0.15 MG Oral Tablet) / 7 (Inert Ingredients 1 MG Oral Tablet) } Pack [Levora 0.15/30 28 Day]	4180186
4304110	Allergy to mildew	4180186
4163971	Endoscopic cholecystectomy	4180186
40766240	Health insurance coverage	4180186
1595799	Ferrous fumarate	4180186
40220960	alteplase 100 MG Injection	4180186
40213320	human papilloma virus vaccine, quadrivalent	4180186
40769194	Percentage area affected by eczema Lower extremity - bilateral [PhenX]	4180186
1309944	Amiodarone	4180186
317576	CAD - Coronary artery disease	4180186
3015076	Soybean IgE Ab [Units/volume] in Serum	4180186
4230399	Closed fracture of hip	4180186
4145310	Pelvis X-ray	4180186
3009542	Hct VFr Bld	4180186
4024289	Ankle X-ray	4180186
19006318	PEN G 375 MG/ML Injectable Solution	4180186
4326177	Medication Reconciliation (procedure)	4180186
3012494	Peanut IgE Qn	4180186
4218389	Whiplash injury to neck	4180186
1308738	cyanocobalamin	4180186
378419	Alzheimer's disease	4180186
80502	Osteoporosis	4180186
40220386	100 ML Propofol 10 MG/ML Injection	4180186
715997	donepezil	4180186
3028833	Bilirub Bld-mCnc	4180186
4043241	Familial Alzheimer's disease of early onset	4180186
4275113	IUCD - Fitting of intrauterine contraceptive device	4180186
4278672	Forearm fracture	4180186
140673	Hypothyroidism (disorder)	4180186
375671	Concussion with loss of consciousness (disorder)	4180186
37017711	Allergy to soy	4180186
439777	Anemia (disorder)	4180186
1594382	NDA020800 0.3 ML Epinephrine 1 MG/ML Auto-Injector	4180186
19127918	Levora 0.15/30 28 Day Pack	4180186
4304110	Allergy to mould	4180186
4163971	Laparoscopic cholecystectomy	4180186
40213154	Influenza, seasonal, injectable, preservative free	4180186
791967	Lorazepam	4180186
4149245	Rupture of patellar tendon (disorder)	4180186
46221626	Levonorgestrel 0.000813 MG/HR Intrauterine System [Liletta]	4180186
40492359	Insertion of biventricular implantable cardioverter defibrillator (procedure)	4180186
1107830	Loratadine	4180186
317576	Coronary heart disease	4180186
3015076	Soybean IgE Qn	4180186
4230399	Closed fracture of hip (disorder)	4180186
4062501	Asthma screening	4180186
3009542	Hematocrit [Volume Fraction] of Blood	4180186
3023103	Chemistry; k; K+; Level; Pl; Plasma; Plsm; Point in time; Potass; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SR; Substance concentration	4180186
19006318	Penicillin G 375 MG/ML Injectable Solution	4180186
4326177	Medication Reconciliation	4180186
9201	Inpatient Visit	4180186
4218389	Acceleration-deceleration injury of neck	4180186
1308738	Vitamin B 12	4180186
80809	Rheumatoid arthritis (disorder)	4180186
80502	Osteoporosis (disorder)	4180186
40220386	propofol 1000 MG per 100 ML Injection	4180186
0	No matching concept	4180186
3028833	Bilirubin.total [Mass/volume] in Blood	4180186
4043241	Familial Alzheimer's disease of early onset (disorder)	4180186
4052083	Pulmonary function test	4180186
4278672	Fracture of forearm (disorder)	4180186
80180	OA - Osteoarthrosis	4180186
4057420	Catheter ablation of tissue of heart	4180186
37017711	Allergy to soy (disorder)	4180186
313217	AF - Atrial fibrillation	4180186
3019406	ABS; Aby; Allergen; Allergens; ALLERGY TESTING; Antby; Anti; Antibodies; Antibody; Arbitrary concentration; Autoantibodies; Autoantibody; Hevea braziliensis; Immune globulin E; Immunoglobulin E; k082; k82; Ltx; Point in time; QNT; Quan; Quant; Quantitative; Random; Serum; SR	4180186
19127922	{28 (Norethindrone 0.35 MG Oral Tablet) } Pack [Camila 28 Day]	4180186
4304110	Allergy to mold	4180186
40213260	zoster	4180186
40213160	IPV	4180186
1549786	Ethinyl Estradiol	4180186
4149245	Patellar tendon rupture	4180186
46221626	Liletta 0.000813 MG/HR Intrauterine System	4180186
40492359	Insertion of biventricular implantable cardioverter defibrillator	4180186
1107882	loratadine 10 MG 24 HR Oral Tablet	4180186
439406	Animal dander allergy	4180186
3000876	ABS; Aby; Allergen; Allergens; ALLERGY TESTING; Antby; Anti; Antibodies; Antibody; Arbitrary concentration; Autoantibodies; Autoantibody; Cod; Codfish; f003; f3; Fish; Immune globulin E; Immunoglobulin E; Point in time; QNT; Quan; Quant; Quantitative; Random; Scrod; Serum; SR	4180186
4027663	PU - Peptic ulcer	4180186
4062501	Asthma screening (procedure)	4180186
3009201	Arbitrary concentration; Chemistry; Pl; Plasma; Plsm; Point in time; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SR; Thyroid stimulating hormone; Thyrotropic hormone; TSH	4180186
3023103	Potassium [Moles/volume] in Serum or Plasma	4180186
4252419	Radiologic examination of knee	4180186
4191853	Allergy screening test	4180186
9202	Outpatient Visit	4180186
4218389	Whiplash injury to neck (disorder)	4180186
198199	Pyelonephritis	4180186
81151	Sprain of ankle	4180186
4132546	Traumatic brain injury (disorder)	4180186
40222846	memantine HCl 2 MG per 1 ML Oral Solution	4180186
3027231	ABS; Aby; Allergen; Allergens; ALLERGY TESTING; Antby; Anti; Antibodies; Antibody; Arbitrary concentration; Autoantibodies; Autoantibody; f004; f4; Immune globulin E; Immunoglobulin E; Point in time; QNT; Quan; Quant; Quantitative; Random; Serum; SR; Triticum sativum; Wheat	4180186
19023398	sevoflurane 1000 MG/ML Inhalant Solution	4180186
4043241	Familial Alzheimer disease of early onset	4180186
4052083	Measurement of respiratory function (procedure)	4180186
4278672	Fracture of forearm	4180186
317576	Coronary artery disease	4180186
4057420	Catheter ablation of tissue of heart (procedure)	4180186
37017711	Allergy to soya	4180186
313217	Atrial fibrillation	4180186
3019406	Latex IgE Ab [Units/volume] in Serum	4180186
19127922	Camila 28 Day Pack	4180186
4304110	Allergy to mold (disorder)	4180186
40213260	zoster vaccine, live	4180186
40213160	poliovirus vaccine, inactivated	4180186
1551099	Prednisone	4180186
4149245	Rupture of patellar tendon	4180186
46221626	Liletta 52 MG Intrauterine System	4180186
40486433	Perennial allergic rhinitis (disorder)	4180186
1107882	Loratadine 10 MG Oral Tablet	4180186
439406	Dander allergy	4180186
3000876	Codfish IgE Ab [Units/volume] in Serum	4180186
4027663	Peptic ulcer disease	4180186
4144583	Diabetes mellitus due to cystic fibrosis (disorder)	4180186
3009201	Thyrotropin [Units/volume] in Serum or Plasma	4180186
3023103	Potassium SerPl-sCnc	4180186
4252419	Knee X-ray	4180186
4191853	Allergy screening test (procedure)	4180186
9203	Emergency Room Visit	4180186
4218408	Taking blood sample	4180186
198199	Pyelonephritis (disorder)	4180186
81151	Sprain of ankle (disorder)	4180186
4132546	Traumatic brain injury	4180186
40222846	Memantine hydrochloride 2 MG/ML Oral Solution	4180186
3027231	Wheat IgE Ab [Units/volume] in Serum	4180186
19023398	sevoflurane 100 % Inhalant Solution	4180186
3007461	#; ABS; absolute; absolutes; Blood; Cnt; Count; Count/volume; CT; HEMATOLOGY/CELL COUNTS; Number concentration; Number Concentration (count/vol); Platelet; Platelet count; Platelt; Plt; Point in time; QNT; Quan; Quant; Quantitative; Random; Thrb; Thrombocyte; Thrombocytes; WB; Whole blood	4180186
4052083	RFT Respiratory function test	4180186
4125906	Suture open wound	4180186
317576	Coronary arteriosclerosis (disorder)	4180186
4048695	Fracture of vertebral column without spinal cord injury (disorder)	4180186
19126352	Nitroglycerin 0.4 MG/ACTUAT Mucosal Spray	4180186
313217	Atrial fibrillation (disorder)	4180186
3019406	Ltx IgE Qn	4180186
19019979	Ibuprofen 100 MG Oral Tablet	4180186
4323208	History of appendectomy	4180186
40213281	DTaP	4180186
45892894	24 HR Donepezil hydrochloride 10 MG / Memantine hydrochloride 28 MG Extended Release Oral Capsule	4180186
1551192	Prednisone 5 MG Oral Tablet	4180186
19125062	Loratadine 5 MG Chewable Tablet	4180186
44805732	Reinsertion of subcutaneous contraceptive	4180186
40486433	Perennial allergic rhinitis	4180186
1110410	Morphine	4180186
439406	Allergy to animal dander (disorder)	4180186
3000876	Codfish IgE Qn	4180186
4027663	Peptic ulceration	4180186
4144583	Diabetes mellitus due to cystic fibrosis	4180186
3009201	TSH SerPl-aCnc	4180186
19073183	Amoxicillin 250 MG Oral Capsule	4180186
4252419	Radiologic examination of knee (procedure)	4180186
19007333	Methotrexate 10 MG Oral Tablet	4180186
4266809	Diverticular disease (disorder)	4180186
4218408	Blood draw	4180186
198809	Acute cholecystitis (disorder)	4180186
81151	Ankle sprain	4180186
4163872	Chest x-ray	4180186
40221415	{5 (dienogest 2 MG / estradiol valerate 2 MG Oral Tablet) / 17 (dienogest 3 MG / estradiol valerate 2 MG Oral Tablet) / 2 (estradiol valerate 1 MG Oral Tablet) / 2 (estradiol valerate 3 MG Oral Tablet) / 2 (Inert Ingredients 1 MG Oral Tablet) } Pack [Natazia 28 Day]	4180186
3027231	Wheat IgE Qn	4180186
19023423	desflurane 990 MG/ML Inhalant Solution	4180186
3007461	Platelet # Bld	4180186
4052083	Measurement of respiratory function	4180186
4125906	Suture open wound (procedure)	4180186
381316	Cerebrovascular accident	4180186
4048695	Fracture of vertebral column without spinal cord injury	4180186
19126352	nitroglycerin 400 MCG/ACTUAT Mucosal Spray	4180186
914335	Atropine	4180186
192671	GIT - Gastrointestinal tract haemorrhage	4180186
19018935	Digoxin 0.125 MG Oral Tablet	4180186
4323208	History of appendicectomy	4180186
40213281	diphtheria, tetanus toxoids and acellular pertussis vaccine	4180186
45892894	donepezil hydrochloride 10 MG / memantine hydrochloride 28 MG 24 HR Extended Release Oral Capsule	4180186
1174888	Hydrocodone	4180186
19078461	ibuprofen 200 MG (as ibuprofen sodium 256 MG) Oral Tablet	4180186
44816277	168 HR Ethinyl Estradiol 0.00146 MG/HR / norelgestromin 0.00625 MG/HR Transdermal System	4180186
40486433	Nonseasonal allergic rhinitis	4180186
1112807	acetylsalicylic acid	4180186
439406	Allergy to animal dander	4180186
3001247	A artemisiifolia; A elatior; ABS; Aby; Allergen; Allergens; ALLERGY TESTING; Ambrosia artemisiifolia; Antby; Anti; Antibodies; Antibody; Arbitrary concentration; Autoantibodies; Autoantibody; Common ragweed; Immune globulin E; Immunoglobulin E; Point in time; QNT; Quan; Quant; Quantitative; Random; Serum; Short ragweed; SR; w001; w1	4180186
4027663	Peptic ulcer	4180186
4299128	Third degree burn (disorder)	4180186
3035995	Alkaline phosphatase [Enzymatic activity/volume] in Serum or Plasma	4180186
19073188	Amoxicillin 500 MG Oral Tablet	4180186
4186930	Change of coil	4180186
19016749	remifentanil	4180186
4266809	Diverticular disease	4180186
4218408	Collection of blood specimen for laboratory	4180186
198809	Acute cholecystitis	4180186
81151	Sprain of ligament of ankle joint	4180186
4163872	Plain chest X-ray	4180186
40221415	Natazia 28 Day Pack	4180186
1512674	drospirenone	4180186
19023423	desflurane 99 % Inhalant Solution	4180186
3007461	Platelets [#/volume] in Blood	4180186
4052083	PFT - Pulmonary function tests	4180186
19133905	PCN V K+ 500 MG Oral Tablet	4180186
381316	Stroke	4180186
4047491	Radiography of humerus (procedure)	4180186
19126352	nitroglycerin 400 MCG/ACTUAT Oral Spray	4180186
967823	Sodium Chloride	4180186
192671	Gastrointestinal hemorrhage	4180186
19018935	digoxin 125 MCG Oral Tablet	4180186
4323208	History of appendectomy (situation)	4180186
40213296	Hep A, adult	4180186
45769019	Female infertility due to cystic fibrosis (disorder)	4180186
782043	Isoflurane	4180186
19078461	Ibuprofen 200 MG Oral Tablet	4180186
44816277	ethinyl estradiol 35 MCG / norelgestromin 150 MCG per 24HR 7 Day Transdermal Patch	4180186
42535580	Ultrasonography of abdomen, right upper quadrant and epigastrium	4180186
1112807	Aspirin	4180186
1741122	tazobactam	4180186
3001247	Common Ragweed IgE Ab [Units/volume] in Serum	4180186
4027663	Gastroduodenal ulcer	4180186
4299128	Third degree burn	4180186
3035995	Alk; Alk phos; Alkaline phos; Alkaline phosphatase.total; ALKP; ALP; AP; Catalytic Concentration; Chemistry; Phos; Phosphtase; Pl; Plasma; Plsm; Point in time; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SR	4180186
4238715	Removing coil	4180186
4186930	IUCD - Change of intrauterine contraceptive device	4180186
19008572	Hydrocortisone 10 MG/ML Topical Cream	4180186
4266809	DD - Diverticular disease	4180186
4218408	Blood withdrawal for testing	4180186
80180	Osteoarthrosis	4180186
81151	Sprain of ankle joint	4180186
4163872	Plain chest X-ray (procedure)	4180186
40224132	0.65 ML medroxyprogesterone acetate 160 MG/ML Prefilled Syringe	4180186
1515774	norgestimate	4180186
19029476	Dornase Alfa 1 MG/ML Inhalant Solution [Pulmozyme]	4180186
4296204	First degree burn (disorder)	4180186
4052083	Lung function tests	4180186
19133905	PCN V Pot 500 MG Oral Tablet	4180186
381316	CVA - Cerebrovascular accident	4180186
4047491	Radiography of humerus	4180186
19126352	nitroglycerin 400 MCG/ACTUAT Sublingual Spray	4180186
28060	Streptococcal sore throat (disorder)	4180186
192671	Gastrointestinal haemorrhage	4180186
4112343	Acute viral pharyngitis	4180186
19054876	dienogest	4180186
40213296	hepatitis A vaccine, adult dosage	4180186
45769019	Female infertility due to cystic fibrosis	4180186
782047	isoflurane 99.9 % Inhalant Solution	4180186
19132304	Levonorgestrel 0.000833 MG/HR Intrauterine System [Mirena]	4180186
44816277	norelgestromin 150 MCG / ethinyl estradiol 35 MCG/Day Weekly Transdermal System	4180186
42535580	Ultrasound of abdomen, right upper quadrant and epigastrium	4180186
1310034	3 ML Amiodarone hydrochloride 50 MG/ML Prefilled Syringe	4180186
1746114	Piperacillin	4180186
3001247	Common Ragweed IgE Qn	4180186
4027663	PUD - Peptic ulcer disease	4180186
4301346	Surgical manipulation of shoulder joint (procedure)	4180186
3035995	ALP SerPl-cCnc	4180186
4238715	Intrauterine contraceptive device removed	4180186
4186930	Change of intrauterine contraceptive device	4180186
19008572	hydrocortisone 1 % (as hydrocortisone acetate 1.2 % ) Topical Cream	4180186
4152936	Laceration of thigh (disorder)	4180186
4218408	Blood sampling	4180186
80180	Osteoarthritis	4180186
81893	Colitis gravis	4180186
4163872	Radiologic examination of chest	4180186
80180	Degenerative arthropathy	4180186
40224132	medroxyprogesterone acetate 104 MG per 0.65 ML Prefilled Syringe	4180186
1102527	Meperidine	4180186
19029476	Pulmozyme 1 MG/ML Inhalant Solution	4180186
4296204	First degree burn	4180186
4052083	PFT	4180186
19133905	Penicillin V Potassium 500 MG Oral Tablet	4180186
381316	Cerebrovascular accident (disorder)	4180186
4047491	Upper arm X-ray	4180186
19126352	NTG 0.4 MG/ACTUAT Mucosal Spray	4180186
28060	Strep throat	4180186
192671	Gastrointestinal hemorrhage (disorder)	4180186
4112343	Acute viral pharyngitis (disorder)	4180186
4107731	Subcutaneous immunotherapy (procedure)	4180186
40213299	Hep A, ped/adol, 2 dose	4180186
45769019	Female hypofertility due to cystic fibrosis	4180186
782047	Isoflurane 999 MG/ML Inhalant Solution	4180186
19132304	Mirena 0.000833 MG/HR Intrauterine System	4180186
40223834	Fexofenadine hydrochloride 60 MG Oral Tablet	4180186
42535580	Ultrasound scan of abdomen, right upper quadrant and epigastrium	4180186
1310034	amiodarone hydrochloride 150 MG per 3 ML Prefilled Syringe	4180186
438614	Allergy to nut	4180186
3000963	Blood; Haemoglobin; Hb; HEMATOLOGY/CELL COUNTS; Hgb; Level; Mass concentration; Point in time; QNT; Quan; Quant; Quantitative; Random; WB; Whole blood	4180186
4027663	Peptic ulcer (disorder)	4180186
4301346	Manipulation of shoulder joint under anesthetic	4180186
933724	Phenazopyridine	4180186
4238715	Removal of intrauterine device (procedure)	4180186
4186930	IUD - Change of intrauterine device	4180186
19008572	hydrocortisone 1 GM per 100 GM Topical Cream	4180186
4152936	Laceration of thigh	4180186
4218408	Collection of blood specimen for laboratory (procedure)	4180186
80180	Hypertrophic polyarthritis	4180186
81893	Ulcerative colitis	4180186
4163872	Chest exclusion X-ray	4180186
40213216	rotavirus, monovalent	4180186
1102527	pethidine	4180186
19057271	Lorazepam 2 MG/ML Injectable Solution	4180186
4296205	Second degree burn (disorder)	4180186
4246502	Neonatal screening	4180186
19133905	PEN V K+ 500 MG Oral Tablet	4180186
380378	Epilepsy (disorder)	4180186
4047491	X-ray of humerus	4180186
19126352	TNG 0.4 MG/ACTUAT Mucosal Spray	4180186
28060	Streptococcal angina	4180186
192671	GI hemorrhage	4180186
4113008	Laceration of hand (disorder)	4180186
4107731	Subcutaneous immunotherapy	4180186
4035415	Torn meniscus	4180186
45769019	Female hypofertility in classical cystic fibrosis	4180186
3021226	ABS; Aby; Allergen; Allergens; ALLERGY TESTING; Antby; Anti; Antibodies; Antibody; Arbitrary concentration; Autoantibodies; Autoantibody; f024; f24; Immune globulin E; Immunoglobulin E; Point in time; Prawns; QNT; Quan; Quant; Quantitative; Random; Serum; Shrimp; SR	4180186
19132304	Mirena 20 MCG per 24HR Intrauterine System	4180186
40173590	alendronic acid 10 MG (as alendronate sodium 13.1 MG) Oral Tablet	4180186
42535580	Ultrasonography of abdomen, right upper quadrant and epigastrium (procedure)	4180186
1310149	Warfarin	4180186
438614	Allergy to nut (disorder)	4180186
3000963	Hemoglobin [Mass/volume] in Blood	4180186
4051466	Childhood asthma (disorder)	4180186
4301346	Manipulation of shoulder joint under anaesthetic	4180186
4056621	Recurrent UTI - urinary tract infection	4180186
4238715	Removal of coil	4180186
4186930	Replacement of contraceptive intrauterine device	4180186
19008572	hydrocortisone 1 % Topical Cream	4180186
3045716	Ag; AnGAP; Chemistry; Level; Pl; Plasma; Plsm; Point in time; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SR; Substance concentration	4180186
4146173	Injury of tendon of the rotator cuff of shoulder (disorder)	4180186
80180	Hypertrophic arthritis	4180186
81893	Ulcerative colitis (disorder)	4180186
4163872	Radiography of chest	4180186
40213227	Td (adult) preservative free	4180186
738818	Doxylamine	4180186
1154615	albuterol 0.09 MG/ACTUAT 200 ACTUAT Metered Dose Inhaler	4180186
4296205	Second degree burn	4180186
4246502	Neonatal screening test	4180186
19133905	PEN V Pot 500 MG Oral Tablet	4180186
380378	Epileptic disorder	4180186
3015632	Carbon dioxide, total [Moles/volume] in Serum or Plasma	4180186
19115351	Diazepam 5 MG [Valium]	4180186
28060	Strept throat	4180186
192671	GI - Gastrointestinal bleed	4180186
4113008	Laceration of hand	4180186
4293740	Injection of tetanus antitoxin	4180186
4035415	Tear of meniscus of knee (disorder)	4180186
46233710	Doxycycline Monohydrate 100 MG Oral Tablet	4180186
3021226	Shrimp IgE Ab [Units/volume] in Serum	4180186
19132304	Mirena 52 MG Intrauterine System	4180186
40173590	Alendronic acid 10 MG Oral Tablet	4180186
43012754	Levonorgestrel 0.00354 MG/HR Drug Implant	4180186
1367571	heparin	4180186
438614	Nut allergy	4180186
3000963	Hgb Bld-mCnc	4180186
4051466	Childhood asthma	4180186
4301346	Surgical manipulation of shoulder joint	4180186
4056621	Recurrent urinary tract infection (disorder)	4180186
4238715	Removal of intrauterine device	4180186
4186930	Replacement of intrauterine contraceptive device	4180186
19010482	Cyclosporine	4180186
3045716	Anion gap in Serum or Plasma	4180186
4146173	Injury of tendon of the rotator cuff of shoulder	4180186
80180	OA - Osteoarthritis	4180186
81893	Idiopathic proctocolitis	4180186
4163872	Chest X-ray	4180186
40213227	tetanus and diphtheria toxoids, adsorbed, preservative free, for adult use	4180186
740275	Carbamazepine	4180186
1154615	albuterol 90 MCG/ACTUAT (albuterol sulfate 108 MCG/ACTUAT from mouthpiece) 200 ACTUAT Metered Dose Inhaler	4180186
4306014	Allergy to tree pollen (disorder)	4180186
4246502	Neonatal screening (procedure)	4180186
19134077	cyclosporine, modified 100 MG [Neoral]	4180186
380378	EP - Epilepsy	4180186
3015632	Carbonic anhydride; cCO2; Chemistry; CO2; CO2 TOTAL; CO2CT; ctCO2; Level; Pl; Plasma; Plsm; Point in time; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SR; Substance concentration; tCO2	4180186
19128009	{7 (Ethinyl Estradiol 0.01 MG Oral Tablet) / 84 (Ethinyl Estradiol 0.03 MG / Levonorgestrel 0.15 MG Oral Tablet) } Pack [Seasonique]	4180186
28060	Streptococcal sore throat	4180186
192671	GIH - Gastrointestinal haemorrhage	4180186
3020630	Chemistry; Level; Mass concentration; Pl; Plasma; Plsm; Point in time; PR; Prot; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SR	4180186
4293740	Injection of tetanus antitoxin (procedure)	4180186
4035415	Tear of cartilage of knee	4180186
46233988	Doxycycline Monohydrate 50 MG Oral Tablet	4180186
3021226	Shrimp IgE Qn	4180186
35605858	1 ML Morphine Sulfate 5 MG/ML Injection	4180186
40171902	Verapamil hydrochloride 40 MG	4180186
43012754	levonorgestrel 36 MG Subcutaneous Drug Implant	4180186
1115008	Naproxen	4180186
442116	Allergy to eggs (disorder)	4180186
3002385	Discocyte; Erc; Erythrocyte morphology index; Erythrocytes; HEMATOLOGY/CELL COUNTS; Point in time; QNT; Quan; Quant; Quantitative; Random; Ratios; RBC; RCMI; RDW; RDW-CV; Red blood cell; Red blood cells; Red blood corpuscle; Red blood corpusles; Red cell; Red cells; Rto	4180186
3051031	History of Hospitalizations+Outpatient visits Narrative	4180186
4142905	Fracture of rib	4180186
4056621	Recurrent urinary tract infection	4180186
4238715	IUD - Removal of intrauterine device	4180186
4186930	Replacement of IUD	4180186
4294548	Acute bacterial sinusitis	4180186
3045716	Anion Gap SerPl-sCnc	4180186
4117038	Bilateral tubal ligation (procedure)	4180186
80180	Degenerative joint disease	4180186
81893	UC - Ulcerative colitis	4180186
4163872	CXR - Chest X-ray	4180186
40213230	Tdap	4180186
742185	atomoxetine	4180186
1154615	albuterol 90 MCG/ACTUAT Metered Dose Inhaler, 200 ACTUAT	4180186
4306014	Allergy to tree pollen	4180186
4010253	Nasal sinus endoscopy	4180186
19133679	{28 (Norethindrone 0.35 MG Oral Tablet) } Pack [Errin 28 Day]	4180186
380378	Epilepsy	4180186
3015632	CO2 SerPl-sCnc	4180186
19128009	Seasonique 91 Day Pack	4180186
28060	Septic sore throat	4180186
192671	Gastrointestinal bleed	4180186
3020630	Protein [Mass/volume] in Serum or Plasma	4180186
4310024	Angiodysplasia of stomach (disorder)	4180186
4035415	Tear of meniscus of knee	4180186
46235214	CLIN; Nominal; Point in time; Random; Sex orient; Typ	4180186
19019273	Naproxen 500 MG Oral Tablet	4180186
35605858	1 ML MS 5 MG/ML Injection	4180186
40174880	Levothyroxine Sodium 0.075 MG Oral Tablet	4180186
43012036	Chlorpheniramine Maleate 4 MG Oral Tablet	4180186
1115171	naproxen sodium 220 MG (as naproxen 200 MG) Oral Tablet	4180186
442116	Allergy to eggs	4180186
3002385	Erythrocyte distribution width [Ratio]	4180186
3051031	H+P; H+P.HX; History; Hospitalizations+OP visits; Narrative; OP; Outpt visits; P prime; Point in time; Random; Report	4180186
4142905	Rib fracture	4180186
4237458	Collar bone fracture	4180186
4238715	Removal of intrauterine contraceptive device	4180186
4186930	Replacement of contraceptive intrauterine device (procedure)	4180186
4294548	Acute bacterial sinusitis (disorder)	4180186
19059528	Alfentanil	4180186
4117038	Bilateral tubal ligation	4180186
80180	Degenerative arthritis	4180186
195588	Cystitis (disorder)	4180186
4163874	History of myocardial infarction (situation)	4180186
40213230	tetanus toxoid, reduced diphtheria toxoid, and acellular pertussis vaccine, adsorbed	4180186
3006734	ABS; Aby; Allergen; Allergens; ALLERGY TESTING; Antby; Anti; Antibodies; Antibody; Arbitrary concentration; Autoantibodies; Autoantibody; Immune globulin E; Immunoglobulin E; Oak; Point in time; QNT; Quan; Quant; Quantitative; Random; Serum; SR; t007; t7; White oak	4180186
1129625	Diphenhydramine	4180186
4024958	Throat culture	4180186
4010253	Nasal sinus endoscopy (procedure)	4180186
19133679	Errin 28 Day Pack	4180186
380378	Epileptic	4180186
3006923	Ala; Alanine transaminase; ALAT; Alpha alanine; ALT; Catalytic Concentration; Chemistry; Glutamic-pyruvic transferase; L-alanine; Pl; Plasma; Plsm; Point in time; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SGPT; SR	4180186
19128022	{7 (Ethinyl Estradiol 0.035 MG / norgestimate 0.18 MG Oral Tablet) / 7 (Ethinyl Estradiol 0.035 MG / norgestimate 0.215 MG Oral Tablet) / 7 (Ethinyl Estradiol 0.035 MG / norgestimate 0.25 MG Oral Tablet) / 7 (Inert Ingredients 1 MG Oral Tablet) } Pack [Ortho Tri-Cyclen 28 Day]	4180186
28060	Streptococcal pharyngitis	4180186
192671	GI - Gastrointestinal hemorrhage	4180186
3020630	Prot SerPl-mCnc	4180186
4310024	Angiodysplasia of stomach	4180186
19089061	Prednisone 2.5 MG [Deltasone]	4180186
46235214	Sexual orientation	4180186
4240902	Allergy to peanuts (disorder)	4180186
35605858	morphine sulfate 5 MG per 1 ML Injection	4180186
40174880	levothyroxine sodium 75 MCG Oral Tablet	4180186
43012433	21 DAY Ethinyl Estradiol 0.000625 MG/HR / Etonogestrel 0.005 MG/HR Vaginal Ring [NuvaRing]	4180186
1115171	Naproxen sodium 220 MG Oral Tablet	4180186
443279	Attempted suicide - cut/stab	4180186
3002385	RDW RBC-Rto	4180186
3051031	Hx of Hospitalizations+OP visits	4180186
4142905	Fracture of rib (disorder)	4180186
4237458	Fracture of clavicle	4180186
4238715	IUCD -Removal of intrauterine contraceptive device	4180186
4330583	Contraceptive method vasectomy	4180186
3014576	Chemistry; Cl; Cl-; Level; Pl; Plasma; Plsm; Point in time; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SR; Substance concentration	4180186
19039298	sevoflurane	4180186
3049273	Arm; BMD; Bone Densiometry; Bone Density Scan; Den; Densiometry; DEX; DEXA; Dual Energy X Ray Absorptiometry; EXT; Films; Forearm; Imaging; Point in time; QNT; Quan; Quant; Quantitative; RADIOLOGY; Random; T-score; UE; Up; Upper extremity; View; Views for BMD; VWS	4180186
195588	Bladder infection	4180186
4163874	History of myocardial infarction	4180186
40213251	varicella	4180186
3006734	White Oak IgE Ab [Units/volume] in Serum	4180186
1518198	norelgestromin	4180186
4024958	Throat culture (procedure)	4180186
4012477	Glucose tolerance test	4180186
19133768	Acetaminophen 750 MG / Hydrocodone Bitartrate 7.5 MG Oral Tablet	4180186
1759842	Clavulanate	4180186
3006923	Alanine aminotransferase [Enzymatic activity/volume] in Serum or Plasma	4180186
19128022	Ortho Tri-Cyclen 28 Day Pack	4180186
3023430	ABS; Aby; Allergen; Allergens; ALLERGY TESTING; Antby; Anti; Antibodies; Antibody; Arbitrary concentration; Autoantibodies; Autoantibody; Cat epithelium; Cat hair; e1; Feline; Felis domesticus; Immune globulin E; Immunoglobulin E; Point in time; QNT; Quan; Quant; Quantitative; Random; Serum; SR	4180186
192671	GI - Gastrointestinal haemorrhage	4180186
3020655	ABS; Aby; Allergen; Allergens; ALLERGY TESTING; Antby; Anti; Antibodies; Antibody; Arbitrary concentration; Autoantibodies; Autoantibody; Honey bee; Honeybee; i001; i1; Immune globulin E; Immunoglobulin E; Point in time; QNT; Quan; Quant; Quantitative; Random; Serum; SR	4180186
4310024	Gastric angiodysplasia	4180186
19078924	Midazolam 1 MG/ML Injectable Solution	4180186
44782520	Chronic spinal paralysis	4180186
4240902	Allergy to peanuts	4180186
40224805	1 ML medroxyprogesterone acetate 150 MG/ML Injection	4180186
40169281	60 ACTUAT Fluticasone propionate 0.25 MG/ACTUAT / salmeterol 0.05 MG/ACTUAT Dry Powder Inhaler	4180186
43012433	NuvaRing 0.12/0.015 MG per 24HR 21 Day Vaginal Ring	4180186
1500211	Medroxyprogesterone	4180186
443279	Attempted suicide - cut/stab (event)	4180186
1718412	Kyleena 0.000729 MG/HR Intrauterine System	4180186
4336464	Coronary artery bypass grafting (procedure)	4180186
4102123	Latex allergy (disorder)	4180186
4237458	Fracture of clavicle (disorder)	4180186
4280726	Seasonal allergic rhinitis (disorder)	4180186
4330583	Male surgical sterilization procedure	4180186
3014576	Chloride [Moles/volume] in Serum or Plasma	4180186
4242997	Removal of gallbladder	4180186
3049273	DXA Radius and Ulna [T-score] Bone density	4180186
80180	Osteoarthritis (disorder)	4180186
195588	Cystitis	4180186
4163874	Past history of myocardial infarction	4180186
40213251	varicella virus vaccine	4180186
3006734	White Oak IgE Qn	4180186
1519936	Etonogestrel	4180186
4151422	Sputum examination	4180186
4012477	GTT - Glucose tolerance test	4180186
19133768	APAP 750 MG / hydrocodone bitartrate 7.5 MG Oral Tablet	4180186
1729720	Penicillin V	4180186
3006923	ALT SerPl-cCnc	4180186
19128263	{7 (Ethinyl Estradiol 0.035 MG / norgestimate 0.18 MG Oral Tablet) / 7 (Ethinyl Estradiol 0.035 MG / norgestimate 0.215 MG Oral Tablet) / 7 (Ethinyl Estradiol 0.035 MG / norgestimate 0.25 MG Oral Tablet) / 7 (Inert Ingredients 1 MG Oral Tablet) } Pack [Trinessa 28 Day]	4180186
3023430	Cat dander IgE Ab [Units/volume] in Serum	4180186
192671	GIT - Gastrointestinal tract hemorrhage	4180186
3020655	Honey bee IgE Ab [Units/volume] in Serum	4180186
4310024	Gastric vascular dysplasia	4180186
19075601	clopidogrel 75 MG (as clopidogrel bisulfate 97.875 MG) Oral Tablet	4180186
44782520	Chronic paralysis due to lesion of spinal cord	4180186
3019550	Chemistry; Level; Na; Na+; Pl; Plasma; Plsm; Point in time; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SR; Substance concentration	4180186
40224805	medroxyprogesterone acetate 150 MG per 1 ML Injection	4180186
40169281	fluticasone propionate 0.25 MG / salmeterol 0.05 MG per ACTUAT Dry Powder Inhaler, 60 ACTUAT	4180186
42707627	rocuronium bromide 100 MG per 10 ML Concentrate for Injectable Solution	4180186
964261	cyanocobalamin 5000 MCG/ML Injectable Solution	4180186
1322184	clopidogrel	4180186
441267	Cystic fibrosis (disorder)	4180186
1718412	Kyleena 17.5 MCG per 24 HR Intrauterine System	4180186
4336464	Coronary artery bypass grafting	4180186
4102123	Latex allergy	4180186
4237458	Fracture of collar bone	4180186
4280726	Spasmodic rhinorrhoea	4180186
4330583	Vasectomy for contraception	4180186
3014576	Chloride SerPl-sCnc	4180186
4242997	Cholecystectomy	4180186
3049273	DXA Radius+Ulna T-score BMD	4180186
80809	Rheumatoid arthritis	4180186
196456	Gallbladder calculus (disorder)	4180186
4133840	Spirometry	4180186
40480160	Pathological fracture due to osteoporosis (disorder)	4180186
3027970	Calc; Calculation; Chemistry; GLB; Glob; Glob%; Globul; Globulins; Level; Mass concentration; Point in time; QNT; Quan; Quant; Quantitative; Random; Serum; SR	4180186
1519937	Etonogestrel 68 MG Drug Implant	4180186
4151422	Sputum examination (procedure)	4180186
4012477	Glucose challenge test	4180186
4202451	Percutaneous mechanical thrombectomy of portal vein using fluoroscopic guidance	4180186
1729720	phenoxymethylpenicillin	4180186
3006322	Bdy temp; bod; Bodies; BODY TEMPERATURE.MOLEC; Oral; Point in time; QNT; Quan; Quant; Quantitative; Random; Temp; Temperature	4180186
19128263	Trinessa 28 Day Pack	4180186
3023430	Cat Dander IgE Qn	4180186
192671	GI haemorrhage	4180186
3020655	Honey bee IgE Qn	4180186
4295880	Intramuscular injection	4180186
19075601	clopidogrel 75 MG Oral Tablet	4180186
44782520	Chronic paralysis due to lesion of spinal cord (disorder)	4180186
3019550	Sodium [Moles/volume] in Serum or Plasma	4180186
40162522	Acetaminophen 325 MG / Hydrocodone Bitartrate 7.5 MG Oral Tablet	4180186
40169281	fluticasone propionate 250 MCG / salmeterol 50 MCG (salmeterol xinafoate 72.5 MCG) per ACTUAT Dry Powder Inhaler, 60 ACTUAT	4180186
42707627	rocuronium bromide 10 MG/ML Injectable Solution	4180186
964261	Vitamin B 12 5 MG/ML Injectable Solution	4180186
1326303	Digoxin	4180186
441267	Fibrocystic disease	4180186
1718412	Kyleena 19.5 MG Intrauterine System	4180186
4336464	Coronary artery bypass graft operations	4180186
4302207	Allergy to hay	4180186
920293	Nitrofurantoin	4180186
4280726	Seasonal allergic rhinitis	4180186
4330583	Vasectomy (procedure)	4180186
926487	Pancreatin	4180186
4242997	Excision of gallbladder	4180186
4139681	Allergy to dairy product	4180186
80809	Rheumatoid disease	4180186
196456	Gallstones	4180186
4133840	Spirometry (procedure)	4180186
40480160	Pathological fracture due to osteoporosis	4180186
3027970	Globulin [Mass/volume] in Serum by calculation	4180186
1521369	Norethindrone	4180186
19133873	PCN V K+ 250 MG Oral Tablet	4180186
4012477	OGTT - Oral glucose tolerance test	4180186
4202451	Percutaneous mechanical thrombectomy of portal vein using fluoroscopic guidance (procedure)	4180186
1738521	Doxycycline	4180186
3006322	Oral temp	4180186
35605482	2 ML Ondansetron 2 MG/ML Injection	4180186
3016723	Chemistry; CR; Crea; Creat; Level; Mass concentration; Pl; Plasma; Plsm; Point in time; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SR	4180186
192671	GI bleeding	4180186
4337138	Transplant of lung	4180186
4295880	Intramuscular injection (procedure)	4180186
19079524	NaCl 9 MG/ML Injectable Solution	4180186
3010813	#; ABS; absolute; absolutes; Blood; Cnt; Count; Count/volume; CT; HEMATOLOGY/CELL COUNTS; Leuc; Leuk; Leukocyte; Lkcs; Number concentration; Number Concentration (count/vol); Point in time; QNT; Quan; Quant; Quantitative; Random; WB; WBC; WBCs; White blood cell; White blood cells; Whole blood	4180186
3019550	Sodium SerPl-sCnc	4180186
40162522	APAP 325 MG / hydrocodone bitartrate 7.5 MG Oral Tablet	4180186
40163554	Warfarin Sodium 5 MG Oral Tablet	4180186
42707627	rocuronium bromide 50 MG per 5 ML Concentrate for Injectable Solution	4180186
1768849	Cefaclor	4180186
975125	Hydrocortisone	4180186
441267	Cystic fibrosis	4180186
1718412	Levonorgestrel 0.000729 MG/HR Intrauterine System [Kyleena]	4180186
4336464	CAG - Coronary artery graft	4180186
4302207	Allergy to grass pollen	4180186
920300	nitrofurantoin 25 MG per 5 ML Oral Suspension	4180186
4280726	Spasmodic rhinorrhea	4180186
4330583	Vasectomy	4180186
836654	Tacrine	4180186
4242997	Cholecystectomy (procedure)	4180186
4139681	Allergy to dairy product (disorder)	4180186
80809	Proliferative arthritis	4180186
196456	Gallbladder stones	4180186
4156265	Facial laceration	4180186
3013721	Aspartate aminotransferase [Enzymatic activity/volume] in Serum or Plasma	4180186
3027970	Globulin Ser Calc-mCnc	4180186
1521369	norethisterone	4180186
19133873	PCN V Pot 250 MG Oral Tablet	4180186
4012477	Glucose tolerance test (procedure)	4180186
4197460	Injection of epinephrine	4180186
372328	Otitis media	4180186
3006322	Oral temperature	4180186
35605482	ondansetron 4 MG per 2 ML Injection	4180186
3016723	Creatinine [Mass/volume] in Serum or Plasma	4180186
192671	Gastrointestinal bleeding	4180186
4337138	LTx - Lung transplant	4180186
4295880	IMI - Intramuscular injection	4180186
19079524	sodium chloride 0.9 % Injectable Solution	4180186
3010813	Leukocytes [#/volume] in Blood	4180186
4035793	Pulmonary rehabilitation	4180186
40236824	Phenazopyridine hydrochloride 100 MG Oral Tablet	4180186
40165015	Meperidine Hydrochloride 50 MG Oral Tablet	4180186
42902245	{5 (Ethinyl Estradiol 0.02 MG / norethindrone acetate 1 MG Oral Tablet) / 7 (Ethinyl Estradiol 0.03 MG / norethindrone acetate 1 MG Oral Tablet) / 9 (Ethinyl Estradiol 0.035 MG / norethindrone acetate 1 MG Oral Tablet) / 7 (Ferrous fumarate 75 MG Oral Tablet) } Pack [Estrostep Fe 28 Day]	4180186
1778162	Cefuroxime	4180186
317009	Hyperreactive airway disease	4180186
441267	Mucoviscidosis	4180186
1713332	Amoxicillin	4180186
4336464	CABG - Coronary artery bypass graft	4180186
4302207	Allergy to grass pollen (disorder)	4180186
920300	Nitrofurantoin 5 MG/ML Oral Suspension	4180186
4181917	EEG	4180186
4330583	Male surgical sterilisation procedure	4180186
836659	Tacrine 10 MG Oral Capsule	4180186
4242997	Gallbladder excision	4180186
4109685	Laceration of foot	4180186
80809	RA - Rheumatoid arthritis	4180186
196456	Gallstone	4180186
4156265	Facial laceration (disorder)	4180186
3013721	Asp; Aspartate amino transferase; Aspartate transaminase; Aspartic acid; AST; Catalytic Concentration; Chemistry; Glutamic oxaloacetic transaminase; Pl; Plasma; Plsm; Point in time; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SGOT; SR	4180186
19059056	ASA 81 MG Oral Tablet	4180186
433644	Shellfish allergy (disorder)	4180186
19133873	Penicillin V Potassium 250 MG Oral Tablet	4180186
19128065	{7 (Inert Ingredients 1 MG Oral Tablet) / 21 (Mestranol 0.05 MG / Norethindrone 1 MG Oral Tablet) } Pack [Norinyl 1+50 28 Day]	4180186
4197460	Injection of epinephrine (procedure)	4180186
372328	Otitis media (disorder)	4180186
40479422	Injury of medial collateral ligament of knee (disorder)	4180186
40479768	Injury of anterior cruciate ligament	4180186
3016723	Creat SerPl-mCnc	4180186
192671	GIH - Gastrointestinal hemorrhage	4180186
4337138	Transplant of lung (procedure)	4180186
4295880	IM - Intramuscular injection	4180186
19079524	sodium chloride 9 MG/ML Injectable Solution	4180186
3010813	WBC # Bld	4180186
4035793	Pulmonary rehabilitation (regime/therapy)	4180186
40228214	cetirizine HCl 10 MG Oral Tablet	4180186
40758406	AIDS; H+P; H+P.HX; History; Human immunodeficiency virus; Nominal; P prime; Point in time; Random	4180186
42902245	Estrostep Fe 28 Day Pack	4180186
1124300	Diclofenac	4180186
317009	Bronchial hyperresponsiveness	4180186
441267	CF - Cystic fibrosis	4180186
1118084	celecoxib	4180186
4336464	CBG - Coronary bypass graft	4180186
40769184	Arm; Bil; Bilat; Both; Count/time; EXT; Extr-Bl; nRate; Number rate; Number Rate = Count/Time; Point in time; QNT; Quan; Quant; Quantitative; Random; UE; UE-Bl; Up	4180186
3001488	ABS; Aby; Allergen; Allergens; ALLERGY TESTING; Antby; Anti; Antibodies; Antibody; Arbitrary concentration; Autoantibodies; Autoantibody; f002; f2; f43; Immune globulin E; Immunoglobulin E; Point in time; QNT; Quan; Quant; Quantitative; Random; Serum; SR	4180186
920334	nitrofurantoin macrocrystals 50 MG Oral Capsule	4180186
4181917	Electroencephalogram (procedure)	4180186
4329847	MI - Myocardial infarction	4180186
836659	tacrine 10 MG (tacrine hydrochloride 12.75 MG) Oral Capsule	4180186
4187458	Review of systems	4180186
4109685	Laceration of foot (disorder)	4180186
80809	Rheumatic gout	4180186
196456	Gallbladder calculus	4180186
4198190	Excision of appendix (procedure)	4180186
3013721	AST SerPl-cCnc	4180186
19059056	Aspirin 81 MG Oral Tablet	4180186
433644	Shellfish allergy	4180186
19133873	PEN V K+ 250 MG Oral Tablet	4180186
19128065	Norinyl 1+50 28 Day Pack	4180186
4197460	Injection of adrenaline	4180186
372328	OM - Otitis media	4180186
40479422	Injury of medial collateral ligament of knee	4180186
40479768	Injury of anterior cruciate ligament (disorder)	4180186
3006451	ABS; Aby; Allergen; Allergens; ALLERGY TESTING; Antby; Anti; Antibodies; Antibody; Arbitrary concentration; Autoantibodies; Autoantibody; f256; Immune globulin E; Immunoglobulin E; Juglans sp; Point in time; QNT; Quan; Quant; Quantitative; Random; Serum; SR; Walnut; Walnuts	4180186
255848	Pneumonia (disorder)	4180186
40236446	Methylphenidate Hydrochloride 20 MG Oral Tablet	4180186
4155034	Laceration of forearm (disorder)	4180186
19079524	Sodium Chloride 9 MG/ML Injectable Solution	4180186
134438	Contact eczema	4180186
4037675	Brief general examination	4180186
40228214	cetirizine hydrochloride 10 MG Oral Tablet	4180186
40758406	HIV status	4180186
44783196	Surgical manipulation of joint of knee (procedure)	4180186
1347450	alteplase	4180186
317009	Asthma (disorder)	4180186
441267	CF	4180186
1119510	Dextromethorphan	4180186
4336464	Coronary artery bypass graft	4180186
3001488	Cow milk IgE Ab [Units/volume] in Serum	4180186
920334	NITROFURANTOIN, MACROCRYSTALS 50 MG Oral Capsule	4180186
4181917	Electroencephalogram	4180186
4329847	Myocardial infarct	4180186
3004501	Chemistry; Glu; Gluc; Glucoseur; Level; Mass concentration; Pl; Plasma; Plsm; Point in time; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SR	4180186
4187458	Review of systems (procedure)	4180186
4285898	Polyp of colon (disorder)	4180186
80809	RhA - Rheumatoid arthritis	4180186
196456	Cholecystolithiasis	4180186
4198190	Appendectomy	4180186
1361711	glyceryl trinitrate	4180186
4168004	Burn injury (morphologic abnormality)	4180186
723013	Diazepam	4180186
19133873	PEN V Pot 250 MG Oral Tablet	4180186
19112599	Chlorpheniramine Maleate 2 MG/ML Oral Solution	4180186
257012	Chronic rhinosinusitis	4180186
433125	Infection due to Staphylococcus aureus	4180186
40478878	Screen for 20 common genetic mutations of cystic fibrosis using amplification refractory mutation system polymerase chain reaction assay technique	4180186
40223768	Donepezil hydrochloride 10 MG Oral Tablet	4180186
3006451	Walnut IgE Ab [Units/volume] in Serum	4180186
255848	Pneumonia	4180186
40169216	120 ACTUAT Fluticasone propionate 0.044 MG/ACTUAT Metered Dose Inhaler	4180186
4155034	Laceration of forearm	4180186
19129144	{28 (Norethindrone 0.35 MG Oral Tablet) } Pack [Jolivette 28 Day]	4180186
134438	Dermatitis venenata	4180186
4037675	Brief general examination (procedure)	4180186
40228230	cetirizine hydrochloride 5 MG Oral Tablet	4180186
40769179	Area affected by eczema Head+Neck PhenX	4180186
44783196	Surgical manipulation of joint of knee	4180186
1124957	Oxycodone	4180186
317009	Bronchial hypersensitivity	4180186
4059978	Insertion of subcutaneous contraceptive (procedure)	4180186
1153428	fexofenadine	4180186
4166224	Perforated appendix	4180186
3001488	Cow Milk IgE Qn	4180186
260139	Acute bronchitis	4180186
4181917	Electroencephalography	4180186
4329847	Myocardial infarction	4180186
3004501	Glucose [Mass/volume] in Serum or Plasma	4180186
4202832	Intubation	4180186
4285898	Polyp colon	4180186
80809	Chronic rheumatic arthritis	4180186
196456	GS - Gallstone	4180186
4198190	Excision of appendix	4180186
1361711	Nitroglycerin	4180186
4168004	Burn injury	4180186
753626	Propofol	4180186
4243062	X-ray of wrist	4180186
19112599	chlorpheniramine maleate 2 MG per 1 ML Oral Solution	4180186
257012	Chronic sinusitis (disorder)	4180186
433125	Infection caused by Staphylococcus aureus (disorder)	4180186
40478878	Cystic fibrosis 20 common mutation test	4180186
40223774	Donepezil hydrochloride 23 MG [Aricept]	4180186
3006451	Walnut IgE Qn	4180186
4001336	Commotio cerebri	4180186
40169216	fluticasone propionate 0.044 MG/ACTUAT Metered Dose Inhaler, 120 ACTUAT	4180186
4170947	Bone immobilisation	4180186
19129144	Jolivette 28 Day Pack	4180186
134438	Contact dermatitis	4180186
4043071	Cognitive and behavioral therapy (regime/therapy)	4180186
40229134	Acetaminophen 21.7 MG/ML / Dextromethorphan Hydrobromide 1 MG/ML / doxylamine succinate 0.417 MG/ML Oral Solution	4180186
40769179	Brain; Count/time; Cranial; Cranium; Intracranial; nRate; Number rate; Number Rate = Count/Time; Point in time; QNT; Quan; Quant; Quantitative; Random; Skull	4180186
46275916	1 ML Epinephrine 1 MG/ML Injection	4180186
1125315	Acetaminophen	4180186
317009	BHR - Bronchial hyperreactivity	4180186
4059978	Insertion of subcutaneous contraceptive	4180186
1154029	Fentanyl	4180186
4166224	Rupture of appendix	4180186
1149196	Cetirizine	4180186
317009	Bronchial asthma	4180186
3013682	Urea nitrogen [Mass/volume] in Serum or Plasma	4180186
3036780	ABS; Aby; Allergen; Allergens; ALLERGY TESTING; American house dust mite; Antby; Anti; Antibodies; Antibody; Arbitrary concentration; Autoantibodies; Autoantibody; D farinae; d002; d2; Dermatophagoides farianae; HDM; House dust mite; Immune globulin E; Immunoglobulin E; Point in time; QNT; Quan; Quant; Quantitative; Random; Serum; SR	4180186
260139	Acute bronchitis (disorder)	4180186
4181917	EEG - Electroencephalography	4180186
4329847	Myocardial infarction (disorder)	4180186
3004501	Glucose SerPl-mCnc	4180186
4202832	Intubation (procedure)	4180186
4285898	Polyp of colon	4180186
80809	Atrophic arthritis	4180186
321042	Cardiac arrest	4180186
4198190	Appendicectomy	4180186
1501700	levothyroxine	4180186
4168004	Burn - lesion	4180186
701322	Memantine	4180186
4243062	Radiography of wrist (procedure)	4180186
19003953	Rocuronium	4180186
257012	Chronic sinusitis	4180186
433125	Staphylococcus aureus infection	4180186
40478878	Screen for 20 common genetic mutations of cystic fibrosis using amplification refractory mutation system polymerase chain reaction assay technique (procedure)	4180186
40223821	Fexofenadine hydrochloride 30 MG Oral Tablet	4180186
1557272	Alendronate	4180186
4001336	MTBI - Mild traumatic brain injury	4180186
45766064	History of one seizure ever	4180186
4170947	Bone immobilization (procedure)	4180186
19076374	Diazepam 5 MG/ML Injectable Solution	4180186
134438	CD - Contact dermatitis	4180186
4043071	Cognitive and behavioral therapy	4180186
40229134	acetaminophen 325 MG / dextromethorphan HBr 15 MG / doxylamine succinate 6.25 MG per 15 ML Oral Solution	4180186
40769179	Percentage area affected by eczema Head and Neck [PhenX]	4180186
46275916	epinephrine 1 MG per 1 ML Injection	4180186
1125443	Dornase Alfa	4180186
317009	Bronchial hyperreactivity	4180186
3013682	Blood urea nitrogen; BUN; Chemistry; Level; Mass concentration; N; N2; Nit; Pl; Plasma; Plsm; Point in time; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SR; UN	4180186
1154343	Albuterol	4180186
4166224	Rupture of appendix (disorder)	4180186
3036780	American house dust mite IgE Ab [Units/volume] in Serum	4180186
261325	Emphysema of lung	4180186
4108705	Intravenous blood transfusion of packed cells	4180186
4329847	Heart attack	4180186
3005136	ABS; Aby; Allergen; Allergens; ALLERGY TESTING; Antby; Anti; Antibodies; Antibody; Arbitrary concentration; Autoantibodies; Autoantibody; C herbarum; Hormodendrum; Immune globulin E; Immunoglobulin E; m002; m2; Point in time; QNT; Quan; Quant; Quantitative; Random; Serum; SR	4180186
21494966	Abd; Abdo; Abdomen+; Abdominal; Exam; Examination; Finding; Findings; H+P; H+P.PX; Nominal; P prime; Phys find; Point in time; Random	4180186
4285898	Colonic polyp	4180186
30753	Esophagitis (disorder)	4180186
321042	Cardiac arrest (disorder)	4180186
4134304	Fracture subluxation of wrist (disorder)	4180186
1137529	salmeterol	4180186
4168004	Burn	4180186
705944	Methylphenidate	4180186
4243062	Radiography of wrist	4180186
19123231	atomoxetine 100 MG (as atomoxetine HCl) Oral Capsule	4180186
258780	Obstructive chronic bronchitis	4180186
433125	Infection caused by Staphylococcus aureus	4180186
19078219	Sufentanil	4180186
757627	Galantamine	4180186
1713671	Amoxicillin 250 MG / Clavulanate 125 MG Oral Tablet	4180186
4001336	Concussion injury of brain (disorder)	4180186
45766064	History of single seizure (situation)	4180186
4170947	Bone immobilization	4180186
19077344	ferrous sulfate 324 MG (iron 65 MG) Oral Tablet	4180186
134438	Contact dermatitis (disorder)	4180186
4043071	Cognitive and behavioural therapy	4180186
40229134	acetaminophen 650 MG / dextromethorphan HBr 30 MG / doxylamine succinate 12.5 MG per 30 ML Oral Solution	4180186
40769184	Area affected by eczema UE-Bl PhenX	4180186
1125443	dornase alfa (desoxyribonuclease)	4180186
317009	Asthma	4180186
3013682	BUN SerPl-mCnc	4180186
1154615	200 ACTUAT Albuterol 0.09 MG/ACTUAT Metered Dose Inhaler	4180186
4166224	Appendicitis with perforation	4180186
3036780	D farinae IgE Qn	4180186
261325	Pulmonary emphysema (disorder)	4180186
4108705	Intravenous blood transfusion of packed cells (procedure)	4180186
4329847	Infarction of heart	4180186
3005136	C herbarum IgE Qn	4180186
21494966	Phys find Abd by Palpation	4180186
3011505	Breathing; End tidal volume; Exp; FEV; FEV1; FEV1%; FEV1/FVC; Forced expiratory volume in 1 second; FVC; Lungs; Point in time; PULMONARY; QNT; Quan; Quant; Quantitative; Random; RS; S prime; VC; Vet; Vol; Vol exp; Volume ratio	4180186
30753	Oesophagitis	4180186
1177480	Ibuprofen	4180186
4134304	Fracture subluxation of wrist	4180186
1396131	ferrous sulfate	4180186
1503184	Mestranol	4180186
4058899	Clavicle X-ray	4180186
4275113	Fitting of coil	4180186
19123231	atomoxetine 100 MG Oral Capsule	4180186
258780	Bronchitis with airway obstruction	4180186
133834	AD - Atopic dermatitis	4180186
19074679	Carbamazepine 20 MG/ML Oral Suspension [Tegretol]	4180186
440448	Appendicitis (disorder)	4180186
1713671	amoxicillin (as amoxicillin trihydrate) 250 MG / clavulanic acid (as clavulanate potassium) 125 MG Oral Tablet	4180186
4001336	Concussion injury of brain	4180186
45766064	History of single seizure	4180186
4169137	Allergy to wheat (disorder)	4180186
19077344	ferrous sulfate 325 MG (iron 65 MG) Oral Tablet	4180186
3014599	ABS; Aby; Allergen; Allergens; ALLERGY TESTING; Antby; Anti; Antibodies; Antibody; Arbitrary concentration; Autoantibodies; Autoantibody; f001; f1; Immune globulin E; Immunoglobulin E; Point in time; QNT; Quan; Quant; Quantitative; Random; Serum; SR	4180186
40213180	meningococcal MCV4P	4180186
40229134	APAP 21.7 MG/ML / Dextromethorphan Hydrobromide 1 MG/ML / doxylamine succinate 0.417 MG/ML Oral Solution	4180186
4219399	Allergy to fish (disorder)	4180186
4166224	Perforation of appendix	4180186
4314290	Sweat chloride level	4180186
3008598	Chemistry; FR; FreeT4; FT4; Level; Levothyroxine; Levo-thyroxine; L-thyroxine; Mass concentration; Non-protein bound; Pl; Plasma; Plsm; Point in time; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SR; T4; T-4; T4 Free; thyroid hormone; Thyrox; Thyroxin; Thyrx; Total T4; TT4	4180186
261325	Pulmonary emphysema	4180186
4015189	Microbial culture of sputum	4180186
4329847	Cardiac infarction	4180186
3005136	Cladosporium herbarum IgE Ab [Units/volume] in Serum	4180186
21494966	Physical findings of Abdomen by Palpation	4180186
3011505	FEV1/FVC	4180186
30753	Esophagitis	4180186
1192710	Chlorpheniramine	4180186
40243436	1 ML Atropine Sulfate 1 MG/ML Injection	4180186
1000560	Ondansetron	4180186
1539403	Simvastatin	4180186
4058899	Plain X-ray of clavicle	4180186
4275113	Introduction of intrauterine contraceptive device	4180186
19127890	Inert Ingredients	4180186
258780	Chronic bronchitis with emphysema	4180186
133834	Allergic dermatitis	4180186
19074679	Tegretol 100 MG per 5 ML Oral Suspension	4180186
440448	Appendicitis	4180186
1717327	Ampicillin	4180186
4001336	Brain concussion	4180186
46275444	Piperacillin 4000 MG / tazobactam 500 MG Injection	4180186
4169137	Allergy to wheat	4180186
19077344	ferrous sulfate 325 MG Oral Tablet	4180186
3014599	Egg white IgE Ab [Units/volume] in Serum	4180186
40213180	meningococcal polysaccharide (groups A, C, Y and W-135) diphtheria toxoid conjugate vaccine (MCV4P)	4180186
40213299	hepatitis A vaccine, pediatric/adolescent dosage, 2 dose schedule	4180186
40769184	Percentage area affected by eczema Upper extremity - bilateral [PhenX]	4180186
1149380	fluticasone	4180186
317009	Asthmatic	4180186
4066995	Fracture of vertebral column with spinal cord injury	4180186
4219399	Allergy to fish	4180186
4314290	Chloride measurement, sweat	4180186
3008598	T4 Free SerPl-mCnc	4180186
4234705	Evaluation of psychiatric state of patient	4180186
4015189	Microbial culture of sputum (procedure)	4180186
19045231	Pancreatin 4X 600 MG Oral Tablet	4180186
4059173	Fracture of ankle (disorder)	4180186
4283893	Sinusitis (disorder)	4180186
4048169	Allergy to house dust mite	4180186
378001	Concussion with no loss of consciousness	4180186
78272	Sprain of wrist	4180186
40243436	atropine sulfate 1 MG per 1 ML Injection	4180186
1127078	Acetaminophen 160 MG Oral Tablet	4180186
1539411	Simvastatin 20 MG Oral Tablet	4180186
4058899	Plain X-ray of clavicle (procedure)	4180186
4275113	Insertion of intrauterine contraceptive device (procedure)	4180186
19127904	{24 (drospirenone 3 MG / Ethinyl Estradiol 0.02 MG Oral Tablet) / 4 (Inert Ingredients 1 MG Oral Tablet) } Pack [Yaz 28 Day]	4180186
258780	Chronic obstructive bronchitis	4180186
133834	Disseminated neurodermatitis	4180186
19074679	Tegretol 20 MG/ML Oral Suspension	4180186
440086	Child attention deficit disorder	4180186
1728416	benzylpenicillin	4180186
4001336	Mild traumatic brain injury	4180186
46275444	piperacillin / tazobactam 4.5 GM Injection	4180186
4163951	EKG	4180186
19077344	FESO4 325 MG Oral Tablet	4180186
3014599	Egg White IgE Qn	4180186
40213198	Pneumococcal conjugate PCV 13	4180186
40213306	Hep B, adult	4180186
40769189	Area affected by eczema Trunk PhenX	4180186
1150770	Astemizole	4180186
317009	Airway hyperreactivity	4180186
4066995	Fracture of vertebral column with spinal cord injury (disorder)	4180186
4216130	Percutaneous coronary intervention	4180186
4314290	Cystic fibrosis sweat test (procedure)	4180186
3008598	Thyroxine (T4) free [Mass/volume] in Serum or Plasma	4180186
4234705	Evaluation of psychiatric state of patient (procedure)	4180186
4078793	Electrical cardioversion	4180186
19045231	Pancreatin 600 MG Oral Tablet [Pancreatin 4X]	4180186
4059173	Fracture of ankle	4180186
4283893	Sinusitis	4180186
4048169	Allergy to house dust mite (disorder)	4180186
378001	Concussion with no loss of consciousness (disorder)	4180186
78272	Sprain of wrist joint	4180186
40481087	Viral sinusitis (disorder)	4180186
1127078	APAP 160 MG Oral Tablet	4180186
1545958	atorvastatin	4180186
3026361	#; ABS; absolute; absolutes; Blood; Cnt; Count; Count/volume; CT; Discocytes; Erthrocyte; Erythrocyte; HEMATOLOGY/CELL COUNTS; Number concentration; Number Concentration (count/vol); Point in time; QNT; Quan; Quant; Quantitative; Random; RBC; RBCS; Red blood cell; Red blood cells; Red blood corpuscle; Red blood corpusles; Red cell; Red cells; WB; Whole blood	4180186
4275113	Insertion of IUD	4180186
19127904	Yaz 28 Day Pack	4180186
258780	Emphysematous bronchitis	4180186
133834	Allergic eczema	4180186
19074841	12 HR Cefaclor 500 MG Extended Release Oral Tablet	4180186
440086	Child attention deficit disorder (disorder)	4180186
1728416	Penicillin G	4180186
4029498	Seizure disorder	4180186
4174876	Allergy to bee venom (disorder)	4180186
4163951	Electrocardiographic procedure	4180186
19077572	galantamine 4 MG (as galantamine hydrobromide 5.126 MG) Oral Tablet	4180186
3024561	Alb; Chemistry; Level; Mass concentration; Pl; Plasma; Plsm; Point in time; Protein.albumin; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SR	4180186
40213198	pneumococcal conjugate vaccine, 13 valent	4180186
40213306	hepatitis B vaccine, adult dosage	4180186
40769189	Count/time; nRate; Number rate; Number Rate = Count/Time; Point in time; QNT; Quan; Quant; Quantitative; Random	4180186
1150771	Astemizole 10 MG Oral Tablet	4180186
317576	Arteriosclerotic heart disease	4180186
3024731	Average; Avg; Discocyte; Entitic volume; Erc; Erythrocytes; HEMATOLOGY/CELL COUNTS; MCV; Point in time; QNT; Quan; Quant; Quantitative; Random; RBC; Red blood cell; Red blood cells; Red blood corpuscle; Red blood corpusles; Red cell; Red cells; Vol	4180186
4216130	Percutaneous coronary intervention (procedure)	4180186
3006906	Ca; Cal; Chemistry; Level; Mass concentration; Pl; Plasma; Plsm; Point in time; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SR	4180186
4094814	Bullet wound	4180186
4078793	Direct current cardioversion (procedure)	4180186
4323902	Lung volume reduction surgery (procedure)	4180186
4059173	Fracture of distal end of tibia and fibula	4180186
4337611	SLTx - Single lung transplant	4180186
4048169	House dust mite allergy	4180186
378419	Alzheimer dementia	4180186
78272	Wrist sprain	4180186
40481087	Viral sinusitis	4180186
1127433	Acetaminophen 325 MG Oral Tablet	4180186
1545959	atorvastatin 80 MG Oral Tablet	4180186
3026361	Erythrocytes [#/volume] in Blood	4180186
4275113	Insertion of intrauterine device	4180186
4195803	Bone density scan	4180186
258780	COB - Chronic obstructive bronchitis	4180186
133834	Atopic dermatitis	4180186
19074841	cefaclor 500 MG 12 HR Extended Release Oral Tablet	4180186
439777	Anaemia	4180186
1332418	Amlodipine	4180186
4029498	Seizure disorder (disorder)	4180186
4174876	Allergy to bee venom	4180186
4163951	Electrocardiogram	4180186
19077572	Galantamine 4 MG Oral Tablet	4180186
3024561	Albumin [Mass/volume] in Serum or Plasma	4180186
40213201	pneumococcal polysaccharide PPV23	4180186
40213314	Haemophilus influenzae type b vaccine, PRP-OMP conjugate	4180186
40769189	Percentage area affected by eczema Trunk [PhenX]	4180186
1150836	Terfenadine	4180186
317576	Coronary arteriosclerosis	4180186
3024731	MCV [Entitic volume]	4180186
4216130	PCI - Percutaneous coronary intervention	4180186
4314290	Cystic fibrosis sweat test	4180186
3006906	Calcium [Mass/volume] in Serum or Plasma	4180186
4094814	Bullet wound (disorder)	4180186
4078793	Direct current cardioversion	4180186
4323902	Lung volume reduction surgery	4180186
4059173	Ankle fracture	4180186
4337611	Single lung transplant	4180186
4048171	Perennial allergic rhinitis with seasonal variation	4180186
378419	AD - Alzheimer's disease	4180186
78272	Sprain of wrist (disorder)	4180186
40231925	Acetaminophen 325 MG / Oxycodone Hydrochloride 5 MG Oral Tablet	4180186
1127433	APAP 325 MG Oral Tablet	4180186
1545959	atorvastatin (as atorvastatin calcium) 80 MG Oral Tablet	4180186
3026361	RBC # Bld	4180186
4275113	IUD - Fitting of intrauterine device	4180186
4195803	Bone density scan (procedure)	4180186
258780	Chronic obstructive bronchitis (disorder)	4180186
133834	Atopic dermatitis (disorder)	4180186
19074843	Cefaclor 250 MG Oral Capsule	4180186
439777	Anemia	4180186
1332419	Amlodipine 5 MG Oral Tablet	4180186
19129655	Ampicillin 100 MG/ML Injectable Solution	4180186
4116491	Escherichia coli urinary tract infection	4180186
4163951	Electrocardiographic procedure (procedure)	4180186
40766240	Are you covered by health insurance or some other kind of health care plan [PhenX]	4180186
3024561	Albumin SerPl-mCnc	4180186
40213201	pneumococcal polysaccharide vaccine, 23 valent	4180186
40213314	Hib (PRP-OMP)	4180186
40769194	Area affected by eczema LE-Bl PhenX	4180186
1150837	Terfenadine 60 MG Oral Tablet	4180186
317576	Coronary sclerosis	4180186
3024731	MCV RBC	4180186
4230209	Psychiatric follow-up (procedure)	4180186
4314290	Sweat chloride	4180186
3006906	Calcium SerPl-mCnc	4180186
4024289	Radiography of ankle	4180186
19002770	desflurane	4180186
4324181	History of cardiac arrest	4180186
3012494	ABS; Aby; Allergen; Allergens; ALLERGY TESTING; Antby; Anti; Antibodies; Antibody; Arbitrary concentration; Autoantibodies; Autoantibody; f013; f13; Immune globulin E; Immunoglobulin E; Peanut; Point in time; QNT; Quan; Quant; Quantitative; Random; Serum; SR	4180186
4337611	Single lung transplant (procedure)	4180186
4048171	Perennial allergic rhinitis with seasonal variation (disorder)	4180186
378419	Alzheimer disease	4180186
257012	Chronic infection of sinus	4180186
40231925	APAP 325 MG / oxycodone hydrochloride 5 MG Oral Tablet	4180186
1589505	Levonorgestrel	4180186
1548195	Estradiol	4180186
4084167	Acute allergic reaction (disorder)	4180186
4275113	Fitting of intrauterine device	4180186
4199276	Removal of subcutaneous contraceptive (procedure)	4180186
140673	Hypothyroid	4180186
375671	Concussion with loss of consciousness	4180186
19075001	Cefuroxime 250 MG Oral Tablet	4180186
439777	Absolute anaemia	4180186
1332419	amlodipine (as amlodipine besylate) 5 MG Oral Tablet	4180186
19129655	ampicillin (as ampicillin sodium) 100 MG/ML Injectable Solution	4180186
4116491	Escherichia coli urinary tract infection (disorder)	4180186
4163971	Laparoscopic cholecystectomy (procedure)	4180186
40766240	Finding; Findings; Health insurance coverage; Ordinal; Othr; Point in time; QL; Qual; Qualitative; Random; Screen	4180186
1343916	Epinephrine	4180186
40213216	rotavirus, live, monovalent vaccine	4180186
40213320	HPV, quadrivalent	4180186
40769194	Bil; Bilat; Both; Count/time; EXT; Extr-Bl; LE; LE-Bl; Leg; Low; nRate; Number rate; Number Rate = Count/Time; Point in time; QNT; Quan; Quant; Quantitative; Random	4180186
1305058	Methotrexate	4180186
317576	CHD - Coronary heart disease	4180186
3015076	ABS; Aby; Allergen; Allergens; ALLERGY TESTING; Antby; Anti; Antibodies; Antibody; Arbitrary concentration; Autoantibodies; Autoantibody; f014; f14; Gly; Immune globulin E; Immunoglobulin E; Largest; Maximal; Maximum; Peak; Point in time; QNT; Quan; Quant; Quantitative; Random; Serum; Soja hispida; Soy bean; Soya bean; Soyabean; Soybean; SR	4180186
4230209	Psychiatric follow-up	4180186
4145310	Pelvis X-ray (procedure)	4180186
3009542	Blood; Hct; HEMATOLOGY/CELL COUNTS; PCV; Percent; Point in time; QNT; Quan; Quant; Quantitative; Random; Volfr; Volume fraction; WB; Whole blood	4180186
4024289	Radiography of ankle (procedure)	4180186
19006318	PCN G 375 MG/ML Injectable Solution	4180186
4324181	History of cardiac arrest (situation)	4180186
3012494	Peanut IgE Ab [Units/volume] in Serum	4180186
4218389	Whiplash injury	4180186
1307863	Verapamil	4180186
378419	Alzheimer's disease (disorder)	4180186
80502	OP - Osteoporosis	4180186
40232448	Diphenhydramine Hydrochloride 25 MG Oral Tablet	4180186
708298	Midazolam	4180186
3028833	Bili; Bilirubins; Blood; Chemistry; Level; Mass concentration; Point in time; QNT; Quan; Quant; Quantitative; Random; TBIL; WB; Whole blood	4180186
4084167	Acute allergic reaction	4180186
4275113	Insertion of intrauterine contraceptive device	4180186
4199276	Removal of subcutaneous contraceptive	4180186
140673	Hypothyroidism	4180186
133834	Atopic eczema	4180186
19075001	cefuroxime (as cefuroxime axetil) 250 MG Oral Tablet	4180186
439777	Absolute anemia	4180186
1594382	epinephrine (generic for Adrenaclick) 0.3 MG per 0.3 ML Auto-Injector	4180186
19127918	{21 (Ethinyl Estradiol 0.03 MG / Levonorgestrel 0.15 MG Oral Tablet) / 7 (Inert Ingredients 1 MG Oral Tablet) } Pack [Levora 0.15/30 28 Day]	4180186
4304110	Allergy to mildew	4180186
4163971	Endoscopic cholecystectomy	4180186
40766240	Health insurance coverage	4180186
1595799	Ferrous fumarate	4180186
40220960	alteplase 100 MG Injection	4180186
40213320	human papilloma virus vaccine, quadrivalent	4180186
40769194	Percentage area affected by eczema Lower extremity - bilateral [PhenX]	4180186
1309944	Amiodarone	4180186
317576	CAD - Coronary artery disease	4180186
3015076	Soybean IgE Ab [Units/volume] in Serum	4180186
4230399	Closed fracture of hip	4180186
4145310	Pelvis X-ray	4180186
3009542	Hct VFr Bld	4180186
4024289	Ankle X-ray	4180186
19006318	PEN G 375 MG/ML Injectable Solution	4180186
4326177	Medication Reconciliation (procedure)	4180186
3012494	Peanut IgE Qn	4180186
4218389	Whiplash injury to neck	4180186
1308738	cyanocobalamin	4180186
378419	Alzheimer's disease	4180186
80502	Osteoporosis	4180186
40220386	100 ML Propofol 10 MG/ML Injection	4180186
715997	donepezil	4180186
3028833	Bilirub Bld-mCnc	4180186
4043241	Familial Alzheimer's disease of early onset	4180186
4275113	IUCD - Fitting of intrauterine contraceptive device	4180186
4278672	Forearm fracture	4180186
140673	Hypothyroidism (disorder)	4180186
375671	Concussion with loss of consciousness (disorder)	4180186
37017711	Allergy to soy	4180186
439777	Anemia (disorder)	4180186
1594382	NDA020800 0.3 ML Epinephrine 1 MG/ML Auto-Injector	4180186
19127918	Levora 0.15/30 28 Day Pack	4180186
4304110	Allergy to mould	4180186
4163971	Laparoscopic cholecystectomy	4180186
40213154	Influenza, seasonal, injectable, preservative free	4180186
791967	Lorazepam	4180186
4149245	Rupture of patellar tendon (disorder)	4180186
46221626	Levonorgestrel 0.000813 MG/HR Intrauterine System [Liletta]	4180186
40492359	Insertion of biventricular implantable cardioverter defibrillator (procedure)	4180186
1107830	Loratadine	4180186
317576	Coronary heart disease	4180186
3015076	Soybean IgE Qn	4180186
4230399	Closed fracture of hip (disorder)	4180186
4062501	Asthma screening	4180186
3009542	Hematocrit [Volume Fraction] of Blood	4180186
3023103	Chemistry; k; K+; Level; Pl; Plasma; Plsm; Point in time; Potass; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SR; Substance concentration	4180186
19006318	Penicillin G 375 MG/ML Injectable Solution	4180186
4326177	Medication Reconciliation	4180186
9201	Inpatient Visit	4180186
4218389	Acceleration-deceleration injury of neck	4180186
1308738	Vitamin B 12	4180186
80809	Rheumatoid arthritis (disorder)	4180186
80502	Osteoporosis (disorder)	4180186
40220386	propofol 1000 MG per 100 ML Injection	4180186
0	No matching concept	4180186
3028833	Bilirubin.total [Mass/volume] in Blood	4180186
4043241	Familial Alzheimer's disease of early onset (disorder)	4180186
4052083	Pulmonary function test	4180186
4278672	Fracture of forearm (disorder)	4180186
80180	OA - Osteoarthrosis	4180186
4057420	Catheter ablation of tissue of heart	4180186
37017711	Allergy to soy (disorder)	4180186
313217	AF - Atrial fibrillation	4180186
3019406	ABS; Aby; Allergen; Allergens; ALLERGY TESTING; Antby; Anti; Antibodies; Antibody; Arbitrary concentration; Autoantibodies; Autoantibody; Hevea braziliensis; Immune globulin E; Immunoglobulin E; k082; k82; Ltx; Point in time; QNT; Quan; Quant; Quantitative; Random; Serum; SR	4180186
19127922	{28 (Norethindrone 0.35 MG Oral Tablet) } Pack [Camila 28 Day]	4180186
4304110	Allergy to mold	4180186
40213260	zoster	4180186
40213160	IPV	4180186
1549786	Ethinyl Estradiol	4180186
4149245	Patellar tendon rupture	4180186
46221626	Liletta 0.000813 MG/HR Intrauterine System	4180186
40492359	Insertion of biventricular implantable cardioverter defibrillator	4180186
1107882	loratadine 10 MG 24 HR Oral Tablet	4180186
439406	Animal dander allergy	4180186
3000876	ABS; Aby; Allergen; Allergens; ALLERGY TESTING; Antby; Anti; Antibodies; Antibody; Arbitrary concentration; Autoantibodies; Autoantibody; Cod; Codfish; f003; f3; Fish; Immune globulin E; Immunoglobulin E; Point in time; QNT; Quan; Quant; Quantitative; Random; Scrod; Serum; SR	4180186
4027663	PU - Peptic ulcer	4180186
4062501	Asthma screening (procedure)	4180186
3009201	Arbitrary concentration; Chemistry; Pl; Plasma; Plsm; Point in time; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SR; Thyroid stimulating hormone; Thyrotropic hormone; TSH	4180186
3023103	Potassium [Moles/volume] in Serum or Plasma	4180186
4252419	Radiologic examination of knee	4180186
4191853	Allergy screening test	4180186
9202	Outpatient Visit	4180186
4218389	Whiplash injury to neck (disorder)	4180186
198199	Pyelonephritis	4180186
81151	Sprain of ankle	4180186
4132546	Traumatic brain injury (disorder)	4180186
40222846	memantine HCl 2 MG per 1 ML Oral Solution	4180186
3027231	ABS; Aby; Allergen; Allergens; ALLERGY TESTING; Antby; Anti; Antibodies; Antibody; Arbitrary concentration; Autoantibodies; Autoantibody; f004; f4; Immune globulin E; Immunoglobulin E; Point in time; QNT; Quan; Quant; Quantitative; Random; Serum; SR; Triticum sativum; Wheat	4180186
19023398	sevoflurane 1000 MG/ML Inhalant Solution	4180186
4043241	Familial Alzheimer disease of early onset	4180186
4052083	Measurement of respiratory function (procedure)	4180186
4278672	Fracture of forearm	4180186
317576	Coronary artery disease	4180186
4057420	Catheter ablation of tissue of heart (procedure)	4180186
37017711	Allergy to soya	4180186
313217	Atrial fibrillation	4180186
3019406	Latex IgE Ab [Units/volume] in Serum	4180186
19127922	Camila 28 Day Pack	4180186
4304110	Allergy to mold (disorder)	4180186
40213260	zoster vaccine, live	4180186
40213160	poliovirus vaccine, inactivated	4180186
1551099	Prednisone	4180186
4149245	Rupture of patellar tendon	4180186
46221626	Liletta 52 MG Intrauterine System	4180186
40486433	Perennial allergic rhinitis (disorder)	4180186
1107882	Loratadine 10 MG Oral Tablet	4180186
439406	Dander allergy	4180186
3000876	Codfish IgE Ab [Units/volume] in Serum	4180186
4027663	Peptic ulcer disease	4180186
4144583	Diabetes mellitus due to cystic fibrosis (disorder)	4180186
3009201	Thyrotropin [Units/volume] in Serum or Plasma	4180186
3023103	Potassium SerPl-sCnc	4180186
4252419	Knee X-ray	4180186
4191853	Allergy screening test (procedure)	4180186
9203	Emergency Room Visit	4180186
4218408	Taking blood sample	4180186
198199	Pyelonephritis (disorder)	4180186
81151	Sprain of ankle (disorder)	4180186
4132546	Traumatic brain injury	4180186
40222846	Memantine hydrochloride 2 MG/ML Oral Solution	4180186
3027231	Wheat IgE Ab [Units/volume] in Serum	4180186
19023398	sevoflurane 100 % Inhalant Solution	4180186
3007461	#; ABS; absolute; absolutes; Blood; Cnt; Count; Count/volume; CT; HEMATOLOGY/CELL COUNTS; Number concentration; Number Concentration (count/vol); Platelet; Platelet count; Platelt; Plt; Point in time; QNT; Quan; Quant; Quantitative; Random; Thrb; Thrombocyte; Thrombocytes; WB; Whole blood	4180186
4052083	RFT Respiratory function test	4180186
4125906	Suture open wound	4180186
317576	Coronary arteriosclerosis (disorder)	4180186
4048695	Fracture of vertebral column without spinal cord injury (disorder)	4180186
19126352	Nitroglycerin 0.4 MG/ACTUAT Mucosal Spray	4180186
313217	Atrial fibrillation (disorder)	4180186
3019406	Ltx IgE Qn	4180186
19019979	Ibuprofen 100 MG Oral Tablet	4180186
4323208	History of appendectomy	4180186
40213281	DTaP	4180186
45892894	24 HR Donepezil hydrochloride 10 MG / Memantine hydrochloride 28 MG Extended Release Oral Capsule	4180186
1551192	Prednisone 5 MG Oral Tablet	4180186
19125062	Loratadine 5 MG Chewable Tablet	4180186
44805732	Reinsertion of subcutaneous contraceptive	4180186
40486433	Perennial allergic rhinitis	4180186
1110410	Morphine	4180186
439406	Allergy to animal dander (disorder)	4180186
3000876	Codfish IgE Qn	4180186
4027663	Peptic ulceration	4180186
4144583	Diabetes mellitus due to cystic fibrosis	4180186
3009201	TSH SerPl-aCnc	4180186
19073183	Amoxicillin 250 MG Oral Capsule	4180186
4252419	Radiologic examination of knee (procedure)	4180186
19007333	Methotrexate 10 MG Oral Tablet	4180186
4266809	Diverticular disease (disorder)	4180186
4218408	Blood draw	4180186
198809	Acute cholecystitis (disorder)	4180186
81151	Ankle sprain	4180186
4163872	Chest x-ray	4180186
40221415	{5 (dienogest 2 MG / estradiol valerate 2 MG Oral Tablet) / 17 (dienogest 3 MG / estradiol valerate 2 MG Oral Tablet) / 2 (estradiol valerate 1 MG Oral Tablet) / 2 (estradiol valerate 3 MG Oral Tablet) / 2 (Inert Ingredients 1 MG Oral Tablet) } Pack [Natazia 28 Day]	4180186
3027231	Wheat IgE Qn	4180186
19023423	desflurane 990 MG/ML Inhalant Solution	4180186
3007461	Platelet # Bld	4180186
4052083	Measurement of respiratory function	4180186
4125906	Suture open wound (procedure)	4180186
381316	Cerebrovascular accident	4180186
4048695	Fracture of vertebral column without spinal cord injury	4180186
19126352	nitroglycerin 400 MCG/ACTUAT Mucosal Spray	4180186
914335	Atropine	4180186
192671	GIT - Gastrointestinal tract haemorrhage	4180186
19018935	Digoxin 0.125 MG Oral Tablet	4180186
4323208	History of appendicectomy	4180186
40213281	diphtheria, tetanus toxoids and acellular pertussis vaccine	4180186
45892894	donepezil hydrochloride 10 MG / memantine hydrochloride 28 MG 24 HR Extended Release Oral Capsule	4180186
1174888	Hydrocodone	4180186
19078461	ibuprofen 200 MG (as ibuprofen sodium 256 MG) Oral Tablet	4180186
44816277	168 HR Ethinyl Estradiol 0.00146 MG/HR / norelgestromin 0.00625 MG/HR Transdermal System	4180186
40486433	Nonseasonal allergic rhinitis	4180186
1112807	acetylsalicylic acid	4180186
439406	Allergy to animal dander	4180186
3001247	A artemisiifolia; A elatior; ABS; Aby; Allergen; Allergens; ALLERGY TESTING; Ambrosia artemisiifolia; Antby; Anti; Antibodies; Antibody; Arbitrary concentration; Autoantibodies; Autoantibody; Common ragweed; Immune globulin E; Immunoglobulin E; Point in time; QNT; Quan; Quant; Quantitative; Random; Serum; Short ragweed; SR; w001; w1	4180186
4027663	Peptic ulcer	4180186
4299128	Third degree burn (disorder)	4180186
3035995	Alkaline phosphatase [Enzymatic activity/volume] in Serum or Plasma	4180186
19073188	Amoxicillin 500 MG Oral Tablet	4180186
4186930	Change of coil	4180186
19016749	remifentanil	4180186
4266809	Diverticular disease	4180186
4218408	Collection of blood specimen for laboratory	4180186
198809	Acute cholecystitis	4180186
81151	Sprain of ligament of ankle joint	4180186
4163872	Plain chest X-ray	4180186
40221415	Natazia 28 Day Pack	4180186
1512674	drospirenone	4180186
19023423	desflurane 99 % Inhalant Solution	4180186
3007461	Platelets [#/volume] in Blood	4180186
4052083	PFT - Pulmonary function tests	4180186
19133905	PCN V K+ 500 MG Oral Tablet	4180186
381316	Stroke	4180186
4047491	Radiography of humerus (procedure)	4180186
19126352	nitroglycerin 400 MCG/ACTUAT Oral Spray	4180186
967823	Sodium Chloride	4180186
192671	Gastrointestinal hemorrhage	4180186
19018935	digoxin 125 MCG Oral Tablet	4180186
4323208	History of appendectomy (situation)	4180186
40213296	Hep A, adult	4180186
45769019	Female infertility due to cystic fibrosis (disorder)	4180186
782043	Isoflurane	4180186
19078461	Ibuprofen 200 MG Oral Tablet	4180186
44816277	ethinyl estradiol 35 MCG / norelgestromin 150 MCG per 24HR 7 Day Transdermal Patch	4180186
42535580	Ultrasonography of abdomen, right upper quadrant and epigastrium	4180186
1112807	Aspirin	4180186
1741122	tazobactam	4180186
3001247	Common Ragweed IgE Ab [Units/volume] in Serum	4180186
4027663	Gastroduodenal ulcer	4180186
4299128	Third degree burn	4180186
3035995	Alk; Alk phos; Alkaline phos; Alkaline phosphatase.total; ALKP; ALP; AP; Catalytic Concentration; Chemistry; Phos; Phosphtase; Pl; Plasma; Plsm; Point in time; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SR	4180186
4238715	Removing coil	4180186
4186930	IUCD - Change of intrauterine contraceptive device	4180186
19008572	Hydrocortisone 10 MG/ML Topical Cream	4180186
4266809	DD - Diverticular disease	4180186
4218408	Blood withdrawal for testing	4180186
80180	Osteoarthrosis	4180186
81151	Sprain of ankle joint	4180186
4163872	Plain chest X-ray (procedure)	4180186
40224132	0.65 ML medroxyprogesterone acetate 160 MG/ML Prefilled Syringe	4180186
1515774	norgestimate	4180186
19029476	Dornase Alfa 1 MG/ML Inhalant Solution [Pulmozyme]	4180186
4296204	First degree burn (disorder)	4180186
4052083	Lung function tests	4180186
19133905	PCN V Pot 500 MG Oral Tablet	4180186
381316	CVA - Cerebrovascular accident	4180186
4047491	Radiography of humerus	4180186
19126352	nitroglycerin 400 MCG/ACTUAT Sublingual Spray	4180186
28060	Streptococcal sore throat (disorder)	4180186
192671	Gastrointestinal haemorrhage	4180186
4112343	Acute viral pharyngitis	4180186
19054876	dienogest	4180186
40213296	hepatitis A vaccine, adult dosage	4180186
45769019	Female infertility due to cystic fibrosis	4180186
782047	isoflurane 99.9 % Inhalant Solution	4180186
19132304	Levonorgestrel 0.000833 MG/HR Intrauterine System [Mirena]	4180186
44816277	norelgestromin 150 MCG / ethinyl estradiol 35 MCG/Day Weekly Transdermal System	4180186
42535580	Ultrasound of abdomen, right upper quadrant and epigastrium	4180186
1310034	3 ML Amiodarone hydrochloride 50 MG/ML Prefilled Syringe	4180186
1746114	Piperacillin	4180186
3001247	Common Ragweed IgE Qn	4180186
4027663	PUD - Peptic ulcer disease	4180186
4301346	Surgical manipulation of shoulder joint (procedure)	4180186
3035995	ALP SerPl-cCnc	4180186
4238715	Intrauterine contraceptive device removed	4180186
4186930	Change of intrauterine contraceptive device	4180186
19008572	hydrocortisone 1 % (as hydrocortisone acetate 1.2 % ) Topical Cream	4180186
4152936	Laceration of thigh (disorder)	4180186
4218408	Blood sampling	4180186
80180	Osteoarthritis	4180186
81893	Colitis gravis	4180186
4163872	Radiologic examination of chest	4180186
40224132	medroxyprogesterone acetate 104 MG per 0.65 ML Prefilled Syringe	4180186
1102527	Meperidine	4180186
19029476	Pulmozyme 1 MG/ML Inhalant Solution	4180186
4296204	First degree burn	4180186
4052083	PFT	4180186
19133905	Penicillin V Potassium 500 MG Oral Tablet	4180186
381316	Cerebrovascular accident (disorder)	4180186
4047491	Upper arm X-ray	4180186
19126352	NTG 0.4 MG/ACTUAT Mucosal Spray	4180186
28060	Strep throat	4180186
192671	Gastrointestinal hemorrhage (disorder)	4180186
4112343	Acute viral pharyngitis (disorder)	4180186
4107731	Subcutaneous immunotherapy (procedure)	4180186
40213299	Hep A, ped/adol, 2 dose	4180186
45769019	Female hypofertility due to cystic fibrosis	4180186
782047	Isoflurane 999 MG/ML Inhalant Solution	4180186
19132304	Mirena 0.000833 MG/HR Intrauterine System	4180186
40223834	Fexofenadine hydrochloride 60 MG Oral Tablet	4180186
42535580	Ultrasound scan of abdomen, right upper quadrant and epigastrium	4180186
1310034	amiodarone hydrochloride 150 MG per 3 ML Prefilled Syringe	4180186
438614	Allergy to nut	4180186
3000963	Blood; Haemoglobin; Hb; HEMATOLOGY/CELL COUNTS; Hgb; Level; Mass concentration; Point in time; QNT; Quan; Quant; Quantitative; Random; WB; Whole blood	4180186
4027663	Peptic ulcer (disorder)	4180186
4301346	Manipulation of shoulder joint under anesthetic	4180186
933724	Phenazopyridine	4180186
4238715	Removal of intrauterine device (procedure)	4180186
4186930	IUD - Change of intrauterine device	4180186
19008572	hydrocortisone 1 GM per 100 GM Topical Cream	4180186
4152936	Laceration of thigh	4180186
4218408	Collection of blood specimen for laboratory (procedure)	4180186
80180	Hypertrophic polyarthritis	4180186
81893	Ulcerative colitis	4180186
4163872	Chest exclusion X-ray	4180186
40213216	rotavirus, monovalent	4180186
1102527	pethidine	4180186
19057271	Lorazepam 2 MG/ML Injectable Solution	4180186
4296205	Second degree burn (disorder)	4180186
4246502	Neonatal screening	4180186
19133905	PEN V K+ 500 MG Oral Tablet	4180186
380378	Epilepsy (disorder)	4180186
4047491	X-ray of humerus	4180186
19126352	TNG 0.4 MG/ACTUAT Mucosal Spray	4180186
28060	Streptococcal angina	4180186
192671	GI hemorrhage	4180186
4113008	Laceration of hand (disorder)	4180186
4107731	Subcutaneous immunotherapy	4180186
4035415	Torn meniscus	4180186
45769019	Female hypofertility in classical cystic fibrosis	4180186
3021226	ABS; Aby; Allergen; Allergens; ALLERGY TESTING; Antby; Anti; Antibodies; Antibody; Arbitrary concentration; Autoantibodies; Autoantibody; f024; f24; Immune globulin E; Immunoglobulin E; Point in time; Prawns; QNT; Quan; Quant; Quantitative; Random; Serum; Shrimp; SR	4180186
19132304	Mirena 20 MCG per 24HR Intrauterine System	4180186
40173590	alendronic acid 10 MG (as alendronate sodium 13.1 MG) Oral Tablet	4180186
42535580	Ultrasonography of abdomen, right upper quadrant and epigastrium (procedure)	4180186
1310149	Warfarin	4180186
438614	Allergy to nut (disorder)	4180186
3000963	Hemoglobin [Mass/volume] in Blood	4180186
4051466	Childhood asthma (disorder)	4180186
4301346	Manipulation of shoulder joint under anaesthetic	4180186
4056621	Recurrent UTI - urinary tract infection	4180186
4238715	Removal of coil	4180186
4186930	Replacement of contraceptive intrauterine device	4180186
19008572	hydrocortisone 1 % Topical Cream	4180186
3045716	Ag; AnGAP; Chemistry; Level; Pl; Plasma; Plsm; Point in time; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SR; Substance concentration	4180186
4146173	Injury of tendon of the rotator cuff of shoulder (disorder)	4180186
80180	Hypertrophic arthritis	4180186
81893	Ulcerative colitis (disorder)	4180186
4163872	Radiography of chest	4180186
40213227	Td (adult) preservative free	4180186
738818	Doxylamine	4180186
1154615	albuterol 0.09 MG/ACTUAT 200 ACTUAT Metered Dose Inhaler	4180186
4296205	Second degree burn	4180186
4246502	Neonatal screening test	4180186
19133905	PEN V Pot 500 MG Oral Tablet	4180186
380378	Epileptic disorder	4180186
3015632	Carbon dioxide, total [Moles/volume] in Serum or Plasma	4180186
19115351	Diazepam 5 MG [Valium]	4180186
28060	Strept throat	4180186
192671	GI - Gastrointestinal bleed	4180186
4113008	Laceration of hand	4180186
4293740	Injection of tetanus antitoxin	4180186
4035415	Tear of meniscus of knee (disorder)	4180186
46233710	Doxycycline Monohydrate 100 MG Oral Tablet	4180186
3021226	Shrimp IgE Ab [Units/volume] in Serum	4180186
19132304	Mirena 52 MG Intrauterine System	4180186
40173590	Alendronic acid 10 MG Oral Tablet	4180186
43012754	Levonorgestrel 0.00354 MG/HR Drug Implant	4180186
1367571	heparin	4180186
438614	Nut allergy	4180186
3000963	Hgb Bld-mCnc	4180186
4051466	Childhood asthma	4180186
4301346	Surgical manipulation of shoulder joint	4180186
4056621	Recurrent urinary tract infection (disorder)	4180186
4238715	Removal of intrauterine device	4180186
4186930	Replacement of intrauterine contraceptive device	4180186
19010482	Cyclosporine	4180186
3045716	Anion gap in Serum or Plasma	4180186
4146173	Injury of tendon of the rotator cuff of shoulder	4180186
80180	OA - Osteoarthritis	4180186
81893	Idiopathic proctocolitis	4180186
4163872	Chest X-ray	4180186
40213227	tetanus and diphtheria toxoids, adsorbed, preservative free, for adult use	4180186
740275	Carbamazepine	4180186
1154615	albuterol 90 MCG/ACTUAT (albuterol sulfate 108 MCG/ACTUAT from mouthpiece) 200 ACTUAT Metered Dose Inhaler	4180186
4306014	Allergy to tree pollen (disorder)	4180186
4246502	Neonatal screening (procedure)	4180186
19134077	cyclosporine, modified 100 MG [Neoral]	4180186
380378	EP - Epilepsy	4180186
3015632	Carbonic anhydride; cCO2; Chemistry; CO2; CO2 TOTAL; CO2CT; ctCO2; Level; Pl; Plasma; Plsm; Point in time; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SR; Substance concentration; tCO2	4180186
19128009	{7 (Ethinyl Estradiol 0.01 MG Oral Tablet) / 84 (Ethinyl Estradiol 0.03 MG / Levonorgestrel 0.15 MG Oral Tablet) } Pack [Seasonique]	4180186
28060	Streptococcal sore throat	4180186
192671	GIH - Gastrointestinal haemorrhage	4180186
3020630	Chemistry; Level; Mass concentration; Pl; Plasma; Plsm; Point in time; PR; Prot; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SR	4180186
4293740	Injection of tetanus antitoxin (procedure)	4180186
4035415	Tear of cartilage of knee	4180186
46233988	Doxycycline Monohydrate 50 MG Oral Tablet	4180186
3021226	Shrimp IgE Qn	4180186
35605858	1 ML Morphine Sulfate 5 MG/ML Injection	4180186
40171902	Verapamil hydrochloride 40 MG	4180186
43012754	levonorgestrel 36 MG Subcutaneous Drug Implant	4180186
1115008	Naproxen	4180186
442116	Allergy to eggs (disorder)	4180186
3002385	Discocyte; Erc; Erythrocyte morphology index; Erythrocytes; HEMATOLOGY/CELL COUNTS; Point in time; QNT; Quan; Quant; Quantitative; Random; Ratios; RBC; RCMI; RDW; RDW-CV; Red blood cell; Red blood cells; Red blood corpuscle; Red blood corpusles; Red cell; Red cells; Rto	4180186
3051031	History of Hospitalizations+Outpatient visits Narrative	4180186
4142905	Fracture of rib	4180186
4056621	Recurrent urinary tract infection	4180186
4238715	IUD - Removal of intrauterine device	4180186
4186930	Replacement of IUD	4180186
4294548	Acute bacterial sinusitis	4180186
3045716	Anion Gap SerPl-sCnc	4180186
4117038	Bilateral tubal ligation (procedure)	4180186
80180	Degenerative joint disease	4180186
81893	UC - Ulcerative colitis	4180186
4163872	CXR - Chest X-ray	4180186
40213230	Tdap	4180186
742185	atomoxetine	4180186
1154615	albuterol 90 MCG/ACTUAT Metered Dose Inhaler, 200 ACTUAT	4180186
4306014	Allergy to tree pollen	4180186
4010253	Nasal sinus endoscopy	4180186
19133679	{28 (Norethindrone 0.35 MG Oral Tablet) } Pack [Errin 28 Day]	4180186
380378	Epilepsy	4180186
3015632	CO2 SerPl-sCnc	4180186
19128009	Seasonique 91 Day Pack	4180186
28060	Septic sore throat	4180186
192671	Gastrointestinal bleed	4180186
3020630	Protein [Mass/volume] in Serum or Plasma	4180186
4310024	Angiodysplasia of stomach (disorder)	4180186
4035415	Tear of meniscus of knee	4180186
46235214	CLIN; Nominal; Point in time; Random; Sex orient; Typ	4180186
19019273	Naproxen 500 MG Oral Tablet	4180186
35605858	1 ML MS 5 MG/ML Injection	4180186
40174880	Levothyroxine Sodium 0.075 MG Oral Tablet	4180186
43012036	Chlorpheniramine Maleate 4 MG Oral Tablet	4180186
1115171	naproxen sodium 220 MG (as naproxen 200 MG) Oral Tablet	4180186
442116	Allergy to eggs	4180186
3002385	Erythrocyte distribution width [Ratio]	4180186
3051031	H+P; H+P.HX; History; Hospitalizations+OP visits; Narrative; OP; Outpt visits; P prime; Point in time; Random; Report	4180186
4142905	Rib fracture	4180186
4237458	Collar bone fracture	4180186
4238715	Removal of intrauterine contraceptive device	4180186
4186930	Replacement of contraceptive intrauterine device (procedure)	4180186
4294548	Acute bacterial sinusitis (disorder)	4180186
19059528	Alfentanil	4180186
4117038	Bilateral tubal ligation	4180186
80180	Degenerative arthritis	4180186
195588	Cystitis (disorder)	4180186
4163874	History of myocardial infarction (situation)	4180186
40213230	tetanus toxoid, reduced diphtheria toxoid, and acellular pertussis vaccine, adsorbed	4180186
3006734	ABS; Aby; Allergen; Allergens; ALLERGY TESTING; Antby; Anti; Antibodies; Antibody; Arbitrary concentration; Autoantibodies; Autoantibody; Immune globulin E; Immunoglobulin E; Oak; Point in time; QNT; Quan; Quant; Quantitative; Random; Serum; SR; t007; t7; White oak	4180186
1129625	Diphenhydramine	4180186
4024958	Throat culture	4180186
4010253	Nasal sinus endoscopy (procedure)	4180186
19133679	Errin 28 Day Pack	4180186
380378	Epileptic	4180186
3006923	Ala; Alanine transaminase; ALAT; Alpha alanine; ALT; Catalytic Concentration; Chemistry; Glutamic-pyruvic transferase; L-alanine; Pl; Plasma; Plsm; Point in time; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SGPT; SR	4180186
19128022	{7 (Ethinyl Estradiol 0.035 MG / norgestimate 0.18 MG Oral Tablet) / 7 (Ethinyl Estradiol 0.035 MG / norgestimate 0.215 MG Oral Tablet) / 7 (Ethinyl Estradiol 0.035 MG / norgestimate 0.25 MG Oral Tablet) / 7 (Inert Ingredients 1 MG Oral Tablet) } Pack [Ortho Tri-Cyclen 28 Day]	4180186
28060	Streptococcal pharyngitis	4180186
192671	GI - Gastrointestinal hemorrhage	4180186
3020630	Prot SerPl-mCnc	4180186
4310024	Angiodysplasia of stomach	4180186
19089061	Prednisone 2.5 MG [Deltasone]	4180186
46235214	Sexual orientation	4180186
4240902	Allergy to peanuts (disorder)	4180186
35605858	morphine sulfate 5 MG per 1 ML Injection	4180186
40174880	levothyroxine sodium 75 MCG Oral Tablet	4180186
43012433	21 DAY Ethinyl Estradiol 0.000625 MG/HR / Etonogestrel 0.005 MG/HR Vaginal Ring [NuvaRing]	4180186
1115171	Naproxen sodium 220 MG Oral Tablet	4180186
443279	Attempted suicide - cut/stab	4180186
3002385	RDW RBC-Rto	4180186
3051031	Hx of Hospitalizations+OP visits	4180186
4142905	Fracture of rib (disorder)	4180186
4237458	Fracture of clavicle	4180186
4238715	IUCD -Removal of intrauterine contraceptive device	4180186
4330583	Contraceptive method vasectomy	4180186
3014576	Chemistry; Cl; Cl-; Level; Pl; Plasma; Plsm; Point in time; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SR; Substance concentration	4180186
19039298	sevoflurane	4180186
3049273	Arm; BMD; Bone Densiometry; Bone Density Scan; Den; Densiometry; DEX; DEXA; Dual Energy X Ray Absorptiometry; EXT; Films; Forearm; Imaging; Point in time; QNT; Quan; Quant; Quantitative; RADIOLOGY; Random; T-score; UE; Up; Upper extremity; View; Views for BMD; VWS	4180186
80180	Degenerative arthropathy	4180186
195588	Bladder infection	4180186
4163874	History of myocardial infarction	4180186
40213251	varicella	4180186
3006734	White Oak IgE Ab [Units/volume] in Serum	4180186
1518198	norelgestromin	4180186
4024958	Throat culture (procedure)	4180186
4012477	Glucose tolerance test	4180186
19133768	Acetaminophen 750 MG / Hydrocodone Bitartrate 7.5 MG Oral Tablet	4180186
1759842	Clavulanate	4180186
3006923	Alanine aminotransferase [Enzymatic activity/volume] in Serum or Plasma	4180186
19128022	Ortho Tri-Cyclen 28 Day Pack	4180186
3023430	ABS; Aby; Allergen; Allergens; ALLERGY TESTING; Antby; Anti; Antibodies; Antibody; Arbitrary concentration; Autoantibodies; Autoantibody; Cat epithelium; Cat hair; e1; Feline; Felis domesticus; Immune globulin E; Immunoglobulin E; Point in time; QNT; Quan; Quant; Quantitative; Random; Serum; SR	4180186
192671	GI - Gastrointestinal haemorrhage	4180186
3020655	ABS; Aby; Allergen; Allergens; ALLERGY TESTING; Antby; Anti; Antibodies; Antibody; Arbitrary concentration; Autoantibodies; Autoantibody; Honey bee; Honeybee; i001; i1; Immune globulin E; Immunoglobulin E; Point in time; QNT; Quan; Quant; Quantitative; Random; Serum; SR	4180186
4310024	Gastric angiodysplasia	4180186
19078924	Midazolam 1 MG/ML Injectable Solution	4180186
44782520	Chronic spinal paralysis	4180186
4240902	Allergy to peanuts	4180186
40224805	1 ML medroxyprogesterone acetate 150 MG/ML Injection	4180186
40169281	60 ACTUAT Fluticasone propionate 0.25 MG/ACTUAT / salmeterol 0.05 MG/ACTUAT Dry Powder Inhaler	4180186
43012433	NuvaRing 0.12/0.015 MG per 24HR 21 Day Vaginal Ring	4180186
1500211	Medroxyprogesterone	4180186
443279	Attempted suicide - cut/stab (event)	4180186
1718412	Kyleena 0.000729 MG/HR Intrauterine System	4180186
4336464	Coronary artery bypass grafting (procedure)	4180186
4102123	Latex allergy (disorder)	4180186
4237458	Fracture of clavicle (disorder)	4180186
4280726	Seasonal allergic rhinitis (disorder)	4180186
4330583	Male surgical sterilization procedure	4180186
3014576	Chloride [Moles/volume] in Serum or Plasma	4180186
4242997	Removal of gallbladder	4180186
3049273	DXA Radius and Ulna [T-score] Bone density	4180186
80180	Osteoarthritis (disorder)	4180186
195588	Cystitis	4180186
4163874	Past history of myocardial infarction	4180186
40213251	varicella virus vaccine	4180186
3006734	White Oak IgE Qn	4180186
1519936	Etonogestrel	4180186
4151422	Sputum examination	4180186
4012477	GTT - Glucose tolerance test	4180186
19133768	APAP 750 MG / hydrocodone bitartrate 7.5 MG Oral Tablet	4180186
1729720	Penicillin V	4180186
3006923	ALT SerPl-cCnc	4180186
19128263	{7 (Ethinyl Estradiol 0.035 MG / norgestimate 0.18 MG Oral Tablet) / 7 (Ethinyl Estradiol 0.035 MG / norgestimate 0.215 MG Oral Tablet) / 7 (Ethinyl Estradiol 0.035 MG / norgestimate 0.25 MG Oral Tablet) / 7 (Inert Ingredients 1 MG Oral Tablet) } Pack [Trinessa 28 Day]	4180186
3023430	Cat dander IgE Ab [Units/volume] in Serum	4180186
192671	GIT - Gastrointestinal tract hemorrhage	4180186
3020655	Honey bee IgE Ab [Units/volume] in Serum	4180186
4310024	Gastric vascular dysplasia	4180186
19075601	clopidogrel 75 MG (as clopidogrel bisulfate 97.875 MG) Oral Tablet	4180186
44782520	Chronic paralysis due to lesion of spinal cord	4180186
3019550	Chemistry; Level; Na; Na+; Pl; Plasma; Plsm; Point in time; QNT; Quan; Quant; Quantitative; Random; SerP; SerPl; SerPlas; Serum; Serum or plasma; SR; Substance concentration	4180186
40224805	medroxyprogesterone acetate 150 MG per 1 ML Injection	4180186
40169281	fluticasone propionate 0.25 MG / salmeterol 0.05 MG per ACTUAT Dry Powder Inhaler, 60 ACTUAT	4180186
42707627	rocuronium bromide 100 MG per 10 ML Concentrate for Injectable Solution	4180186
\.


--
-- TOC entry 3890 (class 0 OID 3185496)
-- Dependencies: 212
-- Data for Name: condition_era; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".condition_era (condition_era_id, person_id, condition_concept_id, condition_era_start_date, condition_era_end_date, condition_occurrence_count) FROM stdin;
60911	3609	40481087	2015-10-12	2015-10-19	1
56623	3362	4112343	1979-10-01	1979-10-08	1
764	42	78272	1922-01-28	1922-02-18	1
86801	5172	80180	1980-03-15	1980-03-16	1
2778	161	80180	2011-01-01	2011-01-02	1
51315	3047	257012	2002-08-24	2002-11-16	1
28349	1677	81893	2001-06-29	2001-06-30	1
57403	3409	40481087	2000-09-01	2000-09-08	1
68471	4053	4112343	1994-03-07	1994-03-19	1
244	12	28060	1972-05-13	1972-05-22	1
64026	3786	260139	1964-12-08	1964-12-15	1
2097	123	80180	1986-03-24	1986-03-25	1
363	19	260139	1977-09-01	1977-09-08	1
59221	3516	4283893	1953-04-23	1953-06-18	1
60110	3562	81151	1990-01-01	1990-01-29	1
66	3	0	1972-12-20	1972-12-21	1
88311	5255	4112343	2014-05-04	2014-05-13	1
2746	160	28060	1961-10-28	1961-11-08	1
58568	3477	134438	1986-03-29	1988-05-21	1
1194	70	372328	1982-08-17	1984-02-05	1
86682	5166	40481087	1978-07-24	1978-07-31	1
54113	3208	40481087	1996-03-09	1996-03-23	1
64734	3832	4294548	2019-06-07	2019-06-08	1
86333	5144	260139	1951-04-19	1951-05-03	1
1386	81	4142905	1963-09-11	1963-12-10	1
78722	4668	40481087	1995-01-20	1995-01-27	1
63153	3734	257012	1955-01-24	1955-01-25	1
1918	114	4156265	1988-08-14	1988-08-28	1
1875	111	80180	2012-02-07	2012-02-08	1
57558	3418	378419	2019-03-03	2019-03-04	1
2129	124	78272	2001-05-06	2001-06-03	1
57251	3401	40481087	1970-03-04	1970-03-11	1
739	41	28060	1983-01-01	1983-01-11	1
1079	64	80180	2009-03-03	2009-03-04	1
89311	5316	40481087	1975-04-16	1975-05-07	1
1096	65	28060	2004-11-06	2004-11-14	1
56140	3330	81151	1975-06-29	1975-07-13	1
58341	3458	80180	2019-03-28	2019-03-29	1
26093	1550	4294548	1977-03-15	1977-05-03	1
1823	105	4112343	1986-09-30	1986-10-10	1
57603	3420	40481087	1983-12-27	1984-01-10	1
27337	1612	40481087	2008-07-09	2008-07-16	1
61520	3638	4051466	1967-05-08	1985-06-27	1
598	35	81893	1996-11-03	1996-11-04	1
85615	5099	28060	1999-02-27	1999-03-11	1
155	7	81151	1985-05-16	1985-06-13	1
1117	66	4112343	1968-04-18	1968-04-27	1
64170	3793	80180	1982-11-07	1982-11-08	1
3041	180	4112343	1999-02-28	1999-03-10	1
82950	4932	40481087	2012-09-21	2012-10-12	1
889	49	81151	1983-04-09	1983-05-07	1
55434	3287	257012	1963-06-09	1963-06-10	1
53581	3177	4112343	1955-02-04	1955-02-12	1
33446	1986	372328	1981-05-13	1981-10-27	1
58144	3446	4218389	1975-02-28	1975-04-04	1
1019	61	81151	1983-12-03	1984-01-07	1
60912	3609	28060	2008-07-26	2008-08-03	1
56624	3362	4112343	2004-08-09	2004-08-16	1
765	42	134438	1935-11-03	1936-09-28	1
86802	5172	81151	1956-08-24	1956-09-21	1
2779	161	4112343	2012-05-26	2012-06-02	1
51316	3047	372328	1978-02-16	1978-07-12	1
28350	1677	4112343	2000-07-11	2000-07-18	1
57404	3409	40481087	2018-09-28	2018-10-19	1
68472	4053	4113008	1988-06-28	1988-07-12	1
245	12	4152936	1980-01-31	1980-02-21	1
64027	3786	260139	1982-07-13	1982-07-27	1
2098	123	260139	1954-01-10	1954-01-24	1
364	19	260139	1997-08-25	1997-09-01	1
59222	3516	40481087	2005-09-27	2005-10-04	1
60111	3562	4027663	2002-08-13	2002-08-14	1
67	3	260139	1969-03-17	1969-03-24	1
88312	5255	4156265	2015-12-18	2016-01-01	1
2747	160	28060	1998-05-31	1998-06-11	1
58569	3477	260139	1969-03-18	1969-03-25	1
1195	70	4112343	1964-02-18	1964-02-27	1
86683	5166	40481087	2004-10-05	2004-10-19	1
54114	3208	40481087	2001-03-05	2001-03-19	1
64735	3832	40481087	1991-06-12	1991-07-03	1
86334	5144	260139	1961-06-17	1961-06-24	1
1387	81	40481087	1969-02-15	1969-02-22	1
78723	4668	40481087	2007-12-09	2007-12-30	1
63154	3734	260139	1952-11-04	1952-11-18	1
1919	114	28060	1974-12-31	1975-01-08	1
1876	111	372328	1985-12-26	1986-05-16	1
57559	3418	4027663	1968-10-10	1968-10-11	1
2130	124	133834	1987-12-22	1987-12-23	1
57252	3401	28060	2007-05-13	2007-05-21	1
740	41	372328	1978-05-30	1978-11-04	1
1080	64	260139	1985-02-28	1985-03-14	1
89312	5316	40481087	1987-04-10	1987-05-01	1
1097	65	257012	1996-07-07	1996-07-08	1
56141	3330	4155034	2007-08-24	2007-09-14	1
58342	3458	260139	1991-06-12	1991-06-26	1
26094	1550	40481087	1990-10-03	1990-10-17	1
1824	105	4113008	1985-10-08	1985-10-22	1
57604	3420	40481087	1997-07-03	1997-07-10	1
27338	1612	40481087	2015-07-17	2015-07-24	1
61521	3638	4059173	2001-01-17	2001-02-16	1
599	35	257012	1989-04-06	1989-04-07	1
85616	5099	80180	1978-09-18	1978-09-19	1
156	7	260139	2001-07-18	2001-08-01	1
1118	66	4152936	1979-03-30	1979-04-20	1
64171	3793	80502	1999-05-25	1999-05-26	1
3042	180	4112343	2015-03-05	2015-03-14	1
82951	4932	81151	1997-11-14	1997-11-28	1
890	49	260139	1978-03-10	1978-03-24	1
55435	3287	378001	1946-05-01	1946-06-30	1
53582	3177	4112343	1968-02-06	1968-02-13	1
33447	1986	372328	2009-12-31	2011-02-01	1
58145	3446	40481087	1977-06-24	1977-07-01	1
1020	61	4112343	2012-08-23	2012-09-03	1
60913	3609	4112343	1998-01-22	1998-01-31	1
56625	3362	4155034	1994-04-17	1994-05-08	1
766	42	260139	1985-02-03	1985-02-17	1
86803	5172	260139	2013-09-20	2013-09-27	1
2780	161	4152936	2009-06-10	2009-07-01	1
51317	3047	4116491	2007-07-18	2007-08-18	1
28351	1677	40481087	1982-09-08	1982-09-29	1
59498	3531	260139	1987-05-30	1987-06-13	1
68473	4053	40481087	2010-02-05	2010-02-12	1
246	12	4278672	1970-09-20	1970-10-20	1
64028	3786	4112343	1966-12-12	1966-12-23	1
2099	123	378001	1984-12-16	1985-01-15	1
365	19	313217	2011-04-10	2011-04-11	1
59223	3516	0	1950-07-26	1950-07-27	1
60112	3562	4112343	2000-10-27	2000-11-08	1
68	3	4278672	2010-08-27	2010-10-26	1
88313	5255	4266809	1996-08-26	1996-08-27	1
2748	160	30753	2005-03-08	2005-03-09	1
58570	3477	440086	1972-03-25	1972-07-01	1
1196	70	4112343	1983-05-06	1983-05-19	1
86684	5166	260139	1969-10-31	1969-11-07	1
54115	3208	40481087	2015-03-14	2015-03-28	1
64736	3832	40481087	1991-08-10	1991-08-17	1
86335	5144	372328	1938-04-19	1938-07-02	1
1388	81	40481087	1995-03-01	1995-03-22	1
78724	4668	40481087	2014-09-30	2014-10-21	1
63155	3734	4109685	1949-07-12	1949-07-26	1
1920	114	28060	1975-10-07	1975-10-18	1
1877	111	40481087	1980-09-21	1980-10-05	1
57560	3418	4112343	2000-09-04	2000-09-17	1
2131	124	260139	1998-03-11	1998-03-25	1
57253	3401	4112343	2001-12-01	2001-12-09	1
741	41	4280726	1977-06-01	1977-06-02	1
1081	64	372328	1976-06-14	1976-09-29	1
89313	5316	40481087	2014-12-20	2015-01-10	1
1098	65	260139	2001-09-15	2001-09-22	1
56142	3330	40481087	2005-03-30	2005-04-06	1
58343	3458	260139	1997-09-29	1997-10-06	1
26095	1550	40481087	2004-05-12	2004-06-02	1
1825	105	4152936	1982-02-12	1982-02-26	1
57605	3420	80180	1998-11-10	1998-11-11	1
29535	1750	78272	1996-04-01	1996-04-15	1
61522	3638	4112343	1970-05-11	1970-05-18	1
600	35	260139	2014-07-26	2014-08-02	1
85617	5099	4109685	1978-11-27	1978-12-18	1
157	7	372328	1968-12-06	1969-02-12	1
1119	66	4155034	1959-04-23	1959-05-14	1
64172	3793	375671	1944-01-06	1944-02-05	1
3043	180	40481087	2000-11-14	2000-11-28	1
82952	4932	134438	1976-11-16	1977-11-17	1
891	49	260139	1997-05-30	1997-06-13	1
55436	3287	4146173	1988-11-05	1988-12-12	1
53583	3177	4112343	1968-07-13	1968-07-26	1
33448	1986	440086	1988-11-17	1989-11-23	1
58146	3446	28060	1991-10-18	1991-10-27	1
1021	61	4112343	2015-12-20	2015-12-28	1
60914	3609	4112343	2007-05-17	2007-05-30	1
56626	3362	4156265	1986-12-11	1986-12-25	1
767	42	260139	1992-04-09	1992-04-16	1
86804	5172	40481087	1946-10-02	1946-10-09	1
2781	161	40481087	1985-09-19	1985-10-10	1
51318	3047	30753	2016-05-06	2016-05-07	1
28352	1677	40481087	2008-10-16	2008-10-30	1
59499	3531	372328	1971-04-15	1972-03-08	1
68474	4053	80180	1999-03-07	1999-03-08	1
247	12	40481087	1980-07-07	1980-07-28	1
64029	3786	4112343	2013-12-09	2013-12-17	1
2100	123	4112343	1967-06-30	1967-07-08	1
366	19	378001	1949-11-26	1949-12-26	1
59224	3516	28060	1947-05-04	1947-05-17	1
60113	3562	4146173	1986-11-18	1987-01-17	1
69	3	40481087	1972-12-27	1973-01-10	1
88314	5255	4294548	1978-11-21	1979-02-20	1
2749	160	260139	1980-01-14	1980-01-28	1
58571	3477	4218389	1995-11-25	1995-12-23	1
1197	70	4283893	2010-01-19	2010-02-09	1
86685	5166	260139	2003-01-18	2003-01-25	1
54116	3208	317576	2008-01-18	2008-01-19	1
64737	3832	40481087	2011-07-11	2011-07-18	1
86336	5144	4112343	2013-04-03	2013-04-13	1
1389	81	40481087	1995-08-28	1995-09-11	1
78725	4668	80180	1997-05-20	1997-05-21	1
63156	3734	4112343	1957-10-31	1957-11-13	1
1921	114	80180	2017-04-16	2017-04-17	1
1878	111	28060	1979-01-13	1979-01-25	1
57561	3418	40481087	2010-02-01	2010-02-15	1
2132	124	261325	2011-03-22	2011-03-23	1
57254	3401	4149245	1965-10-14	1965-12-20	1
742	41	4283893	1999-12-02	2000-03-02	1
1082	64	4155034	2000-08-07	2000-08-21	1
53281	3159	40481087	1989-04-17	1989-05-08	1
1099	65	4112343	1991-07-04	1991-07-17	1
58077	3444	28060	1954-02-10	1954-02-20	1
58344	3458	260139	2004-01-04	2004-01-11	1
26096	1550	40481087	2014-11-13	2014-12-04	1
1826	105	40481087	1976-08-04	1976-08-11	1
57606	3420	260139	1973-06-15	1973-06-29	1
29536	1750	40481087	1998-01-10	1998-01-24	1
61523	3638	4112343	2003-06-24	2003-07-06	1
601	35	372328	1964-07-10	1965-03-02	1
85618	5099	4296205	1989-02-23	1989-03-09	1
158	7	4132546	2000-10-22	2000-10-23	1
1120	66	40481087	1983-04-04	1983-04-11	1
64173	3793	4112343	1959-10-28	1959-11-09	1
3044	180	4112343	1985-09-28	1985-10-08	1
82953	4932	260139	1964-12-08	1964-12-22	1
892	49	372328	1976-11-13	1977-09-17	1
55437	3287	4283893	1971-06-07	1971-08-30	1
53584	3177	4230399	2008-02-18	2008-03-19	1
33449	1986	4112343	1993-11-21	1993-11-30	1
58147	3446	80180	1989-02-19	1989-02-20	1
1022	61	192671	2005-09-15	2005-09-16	1
60915	3609	4155034	2017-06-24	2017-07-15	1
56627	3362	40481087	1971-12-23	1972-01-13	1
768	42	260139	2006-03-04	2006-03-11	1
86805	5172	40481087	1963-10-11	1963-10-18	1
2782	161	40481087	1988-11-29	1988-12-20	1
51319	3047	80180	2017-10-28	2017-10-29	1
28353	1677	80180	2003-04-20	2003-04-21	1
59500	3531	4027663	1992-03-22	1992-03-23	1
68475	4053	81151	1964-09-11	1964-10-02	1
248	12	40481087	1996-03-24	1996-04-14	1
64030	3786	40481087	1959-03-15	1959-04-05	1
2101	123	0	2013-07-10	2013-07-11	1
367	19	4059173	1981-11-08	1981-12-08	1
59225	3516	192671	1978-04-15	1978-04-16	1
60114	3562	4218389	1983-10-30	1983-12-04	1
70	3	40481087	2018-10-22	2018-11-12	1
88315	5255	40481087	1980-08-21	1980-09-04	1
2750	160	260139	1990-01-13	1990-01-27	1
58572	3477	40481087	1967-04-04	1967-04-11	1
1198	70	40481087	1949-06-14	1949-06-28	1
86686	5166	375671	1976-09-29	1976-11-28	1
60759	3601	260139	1971-05-18	1971-05-25	1
64738	3832	40481087	2012-04-11	2012-05-02	1
86337	5144	40481087	1939-12-18	1940-01-01	1
1390	81	28060	2005-08-09	2005-08-17	1
78726	4668	260139	1976-05-22	1976-05-29	1
63157	3734	4112343	1990-02-14	1990-02-22	1
1922	114	260139	2009-11-30	2009-12-07	1
1879	111	4112343	1994-09-21	1994-09-30	1
57562	3418	260139	2008-12-27	2009-01-03	1
2133	124	372328	1989-09-12	1990-02-19	1
57255	3401	40481087	1999-02-12	1999-03-05	1
743	41	40481087	1984-10-06	1984-10-13	1
1083	64	4294548	2017-05-21	2017-06-11	1
53282	3159	40481087	1993-10-21	1993-11-11	1
1100	65	4112343	2011-09-21	2011-10-04	1
58078	3444	28060	1958-01-12	1958-01-20	1
60318	3572	192671	1993-11-20	1993-11-21	1
26097	1550	28060	1972-05-29	1972-06-05	1
1827	105	40481087	2000-06-27	2000-07-18	1
57607	3420	260139	2005-10-20	2005-10-27	1
29537	1750	40481087	2005-08-23	2005-09-13	1
61524	3638	4152936	1987-07-09	1987-07-30	1
602	35	4027663	1990-03-15	1990-03-16	1
85619	5099	40481087	1954-04-28	1954-05-19	1
159	7	40481087	1985-10-14	1985-11-04	1
1121	66	260139	1972-04-16	1972-04-30	1
64174	3793	4112343	1989-06-02	1989-06-10	1
3045	180	40481087	1990-12-15	1990-12-29	1
82954	4932	260139	1997-04-18	1997-04-25	1
893	49	372328	1978-09-12	1979-03-24	1
55438	3287	40481087	1957-03-24	1957-04-07	1
53585	3177	0	2003-01-08	2003-01-09	1
33450	1986	28060	1988-12-03	1988-12-13	1
58148	3446	260139	2007-02-25	2007-03-11	1
1023	61	4051466	1971-01-27	1987-05-07	1
62474	3695	81151	2010-04-09	2010-05-14	1
56628	3362	40481087	1973-09-10	1973-10-01	1
769	42	381316	1993-10-19	1993-10-20	1
86806	5172	40481087	1969-04-07	1969-04-14	1
2783	161	4035415	2016-07-13	2016-09-11	1
51320	3047	40481087	1999-10-22	1999-10-29	1
28354	1677	372328	1971-03-17	1971-06-19	1
59501	3531	4112343	1972-08-30	1972-09-06	1
68476	4053	260139	1963-08-20	1963-08-27	1
249	12	40481087	2013-02-12	2013-03-05	1
64031	3786	40481087	1972-05-06	1972-05-20	1
2102	123	260139	2006-08-17	2006-08-24	1
368	19	4112343	2010-08-23	2010-08-31	1
59226	3516	260139	2002-05-05	2002-05-19	1
60115	3562	257012	1998-08-11	1998-08-12	1
71	3	192671	1958-01-29	1958-01-30	1
88316	5255	78272	1973-08-31	1973-09-21	1
2751	160	260139	2019-04-02	2019-04-16	1
58573	3477	40481087	2006-08-17	2006-09-07	1
1199	70	80180	1983-06-27	1983-06-28	1
86687	5166	40481087	1965-12-01	1965-12-22	1
60760	3601	4051466	1962-06-25	1978-09-29	1
64739	3832	40481087	2017-03-28	2017-04-11	1
86338	5144	40481087	1973-10-25	1973-11-01	1
1391	81	80180	1997-04-30	1997-05-01	1
78727	4668	372328	1963-01-24	1964-01-14	1
63158	3734	4112343	2019-01-07	2019-01-16	1
1923	114	381316	2004-11-22	2004-11-23	1
1880	111	40481087	2011-06-30	2011-07-07	1
57563	3418	4109685	2005-11-20	2005-12-04	1
2134	124	4112343	1994-02-06	1994-02-13	1
57256	3401	78272	1994-07-21	1994-08-04	1
744	41	40481087	2009-09-18	2009-10-09	1
1084	64	40481087	1998-01-18	1998-01-25	1
53283	3159	40481087	2014-09-27	2014-10-04	1
1101	65	4237458	2018-07-31	2018-09-29	1
58079	3444	80180	1970-12-12	1970-12-13	1
60319	3572	260139	2009-10-11	2009-10-25	1
26098	1550	28060	1981-12-18	1981-12-25	1
1828	105	372328	1979-07-28	1980-04-25	1
57608	3420	4112343	1970-08-13	1970-08-25	1
29538	1750	80180	2002-08-24	2002-08-25	1
63530	3756	80180	1976-06-25	1976-06-26	1
603	35	4266809	1997-05-02	1997-05-03	1
85620	5099	40481087	1963-07-09	1963-07-16	1
160	7	4237458	1974-08-12	1974-09-11	1
1122	66	260139	2000-09-27	2000-10-04	1
64175	3793	4285898	1982-05-11	1982-05-12	1
3046	180	40481087	2007-12-01	2007-12-15	1
82955	4932	4112343	2000-03-12	2000-03-19	1
894	49	40481087	1977-02-16	1977-03-09	1
55439	3287	40481087	1981-04-12	1981-04-26	1
53586	3177	28060	1931-11-14	1931-11-25	1
33451	1986	81151	2007-08-25	2007-09-22	1
58149	3446	4134304	1950-08-08	1950-09-07	1
1024	61	4084167	1977-03-04	1977-03-04	1
62475	3695	198809	1996-03-20	1996-03-20	1
56629	3362	40481087	1976-04-13	1976-04-20	1
770	42	4112343	1913-07-15	1913-07-26	1
86807	5172	40481087	1970-06-17	1970-07-01	1
2784	161	4218389	2013-07-31	2013-08-28	1
55525	3293	28060	1940-02-14	1940-02-23	1
28355	1677	375671	1970-05-08	1970-06-07	1
59502	3531	4112343	1999-01-27	1999-02-04	1
68477	4053	260139	1965-06-18	1965-06-25	1
250	12	28060	1995-10-22	1995-10-29	1
64032	3786	40481087	2003-04-24	2003-05-15	1
2103	123	317576	2006-08-23	2006-08-24	1
369	19	4230399	2003-07-16	2003-08-15	1
59227	3516	4043241	2010-09-09	2010-09-10	1
60116	3562	4112343	1975-02-20	1975-02-27	1
72	3	260139	1956-12-15	1956-12-22	1
88317	5255	81151	1996-05-28	1996-07-02	1
2752	160	40481087	1970-08-20	1970-09-03	1
58574	3477	4112343	1968-02-22	1968-03-04	1
1200	70	260139	1960-01-10	1960-01-24	1
86688	5166	260139	1958-09-06	1958-09-20	1
60761	3601	4113008	1992-06-26	1992-07-10	1
64740	3832	4084167	2010-12-21	2010-12-21	1
86339	5144	40481087	1977-03-24	1977-04-07	1
1392	81	4112343	1963-09-14	1963-09-21	1
78728	4668	4112343	2018-09-02	2018-09-13	1
63159	3734	4296205	1978-03-26	1978-04-09	1
1924	114	439777	2006-03-05	2006-03-06	1
1881	111	40481087	2012-06-07	2012-06-28	1
57564	3418	4112343	1974-05-09	1974-05-20	1
2135	124	4237458	1993-11-13	1994-01-12	1
57257	3401	81151	1995-05-31	1995-06-28	1
745	41	257012	2000-01-27	2000-01-28	1
1085	64	78272	2012-04-11	2012-05-09	1
53284	3159	260139	1971-05-25	1971-06-08	1
1102	65	40481087	1988-02-29	1988-03-14	1
58080	3444	195588	1999-11-24	2000-01-22	1
60320	3572	372328	1956-11-16	1957-02-27	1
26099	1550	257012	1977-04-26	1977-04-27	1
1829	105	40481087	1975-03-28	1975-04-04	1
57609	3420	4112343	1991-08-07	1991-08-18	1
29539	1750	260139	2001-05-22	2001-05-29	1
63531	3756	260139	1946-02-03	1946-02-10	1
604	35	40481087	2002-01-18	2002-01-25	1
85621	5099	40481087	1971-07-11	1971-07-25	1
161	7	40481087	1986-08-06	1986-08-13	1
1123	66	4112343	1967-09-10	1967-09-19	1
64176	3793	4296205	1967-05-01	1967-05-29	1
3047	180	260139	1999-06-27	1999-07-04	1
82956	4932	4266809	1996-02-23	1996-02-24	1
895	49	321042	2003-07-12	2003-07-13	1
55440	3287	40481087	1996-04-27	1996-05-18	1
53587	3177	80502	1976-10-20	1976-10-21	1
33452	1986	260139	2005-11-05	2005-11-12	1
58150	3446	40481087	1947-07-30	1947-08-06	1
1025	61	4296204	2009-08-21	2009-09-25	1
62476	3695	260139	1987-03-31	1987-04-14	1
60994	3614	255848	2011-03-21	2011-03-22	1
771	42	4112343	2009-12-06	2009-12-15	1
53512	3174	40481087	2005-01-22	2005-01-29	1
2785	161	260139	1978-02-24	1978-03-10	1
55526	3293	81151	1975-11-11	1975-12-16	1
34965	2078	80180	2017-07-25	2017-07-26	1
59503	3531	40481087	1990-01-02	1990-01-09	1
68478	4053	4294548	1968-01-02	1968-05-07	1
251	12	78272	1988-01-10	1988-02-14	1
64033	3786	372328	1962-11-18	1963-11-19	1
2104	123	40481087	1970-07-12	1970-07-26	1
370	19	4112343	1974-10-19	1974-10-26	1
59228	3516	4112343	1979-04-13	1979-04-22	1
60117	3562	4112343	2003-11-24	2003-12-04	1
73	3	4112343	1959-09-17	1959-09-26	1
88318	5255	81151	1999-02-17	1999-03-03	1
2753	160	372328	1964-03-13	1964-07-02	1
58575	3477	4112343	1988-03-18	1988-03-25	1
1201	70	260139	1962-07-17	1962-07-31	1
86689	5166	40481087	1967-11-21	1967-11-28	1
60762	3601	4218389	1979-01-15	1979-02-05	1
64741	3832	4218389	2012-06-16	2012-07-21	1
86340	5144	260139	1942-02-28	1942-03-07	1
1393	81	4112343	1967-05-19	1967-06-01	1
78729	4668	40481087	1979-03-08	1979-03-15	1
63160	3734	40481087	1966-09-28	1966-10-05	1
1925	114	4116491	1999-03-07	1999-04-11	1
1882	111	372328	1978-01-05	1978-04-07	1
57565	3418	4283893	1949-06-22	1949-07-13	1
2136	124	40481087	2004-02-10	2004-02-24	1
57258	3401	81151	2002-02-21	2002-03-21	1
746	41	260139	1974-10-19	1974-10-26	1
1086	64	4112343	1989-12-01	1989-12-09	1
53285	3159	260139	2002-08-01	2002-08-15	1
1103	65	40481087	1991-07-03	1991-07-10	1
58081	3444	372328	1941-02-04	1941-04-07	1
60321	3572	378001	1958-03-11	1958-04-10	1
26100	1550	40481087	1974-12-05	1974-12-19	1
1830	105	40481087	1996-08-17	1996-09-07	1
57610	3420	4134304	2003-01-27	2003-02-26	1
29540	1750	4112343	1979-07-20	1979-08-01	1
63532	3756	260139	1970-04-07	1970-04-21	1
605	35	40481087	2006-10-29	2006-11-05	1
85622	5099	28060	2017-04-07	2017-04-16	1
162	7	80180	2008-10-17	2008-10-18	1
1124	66	40481087	1978-08-17	1978-09-07	1
64177	3793	40481087	2017-09-10	2017-09-17	1
3048	180	372328	1981-11-09	1982-04-01	1
82957	4932	40481087	2002-07-13	2002-08-03	1
896	49	40481087	1994-08-29	1994-09-19	1
55441	3287	40481087	1999-10-05	1999-10-26	1
53588	3177	81151	1975-05-21	1975-06-11	1
33453	1986	372328	1982-02-24	1982-04-27	1
58151	3446	0	1953-12-12	1953-12-13	1
1026	61	40481087	1981-05-22	1981-06-12	1
62477	3695	321042	2007-02-12	2007-02-13	1
60995	3614	260139	1952-03-13	1952-03-20	1
772	42	40481087	1968-06-01	1968-06-22	1
56819	3375	0	1967-03-04	1967-03-05	1
2786	161	372328	1991-05-16	1991-12-29	1
55527	3293	260139	1912-08-14	1912-08-28	1
34966	2078	4059173	1995-08-30	1995-11-28	1
59504	3531	81151	2009-02-16	2009-03-16	1
68479	4053	4296204	2014-09-24	2014-10-08	1
252	12	80180	2008-04-08	2008-04-09	1
64034	3786	4109685	1991-10-01	1991-10-15	1
2105	123	40481087	2012-03-30	2012-04-13	1
371	19	4112343	2010-01-09	2010-01-22	1
59229	3516	40481087	2017-10-15	2017-11-05	1
60118	3562	4112343	2016-10-27	2016-11-08	1
74	3	40480160	1986-10-04	1986-12-03	1
88319	5255	257012	1979-01-16	1979-01-17	1
2754	160	4027663	1995-07-19	1995-07-20	1
58576	3477	4112343	2000-05-23	2000-05-31	1
1202	70	4112343	1948-08-11	1948-08-22	1
86690	5166	40481087	1995-06-03	1995-06-17	1
60763	3601	40481087	1978-02-13	1978-02-20	1
64742	3832	4283893	1993-04-17	1993-12-11	1
86341	5144	260139	1957-05-25	1957-06-08	1
1394	81	40481087	1986-05-21	1986-06-11	1
78730	4668	40481087	2004-09-06	2004-09-20	1
63161	3734	40481087	2011-11-27	2011-12-04	1
1926	114	4283893	2009-04-23	2009-08-27	1
1883	111	4112343	1979-07-28	1979-08-10	1
57566	3418	40481087	2011-02-15	2011-03-08	1
2137	124	372328	1985-05-30	1985-08-13	1
57259	3401	260139	1982-08-02	1982-08-09	1
747	41	4084167	1976-02-10	1976-02-10	1
1087	64	4112343	1995-07-13	1995-07-21	1
53286	3159	4112343	1966-01-02	1966-01-09	1
1104	65	260139	2005-09-21	2005-10-05	1
58082	3444	4112343	1979-02-02	1979-02-10	1
60322	3572	40481087	1958-01-15	1958-01-22	1
26101	1550	40481087	1980-01-24	1980-02-07	1
1831	105	317576	2000-06-09	2000-06-10	1
57611	3420	4146173	1968-08-09	1968-09-08	1
29541	1750	4155034	2010-10-29	2010-11-19	1
63533	3756	4112343	2009-08-28	2009-09-04	1
606	35	28060	1996-07-02	1996-07-10	1
85623	5099	4112343	1946-04-28	1946-05-07	1
163	7	4001336	2000-10-22	2000-12-21	1
1125	66	40481087	2012-08-27	2012-09-17	1
64178	3793	260139	2008-08-07	2008-08-21	1
3049	180	4112343	1999-04-13	1999-04-25	1
82958	4932	40481087	2005-04-24	2005-05-08	1
897	49	81151	1982-04-16	1982-05-14	1
55442	3287	40481087	2009-12-16	2009-12-30	1
53589	3177	195588	1946-07-12	1946-09-05	1
33454	1986	378001	1981-09-10	1981-11-09	1
58152	3446	81151	1981-01-07	1981-01-28	1
1027	61	28060	1990-05-10	1990-05-20	1
62478	3695	4048171	1985-02-09	1999-02-08	1
60996	3614	372328	1952-11-07	1953-04-05	1
773	42	40481087	1978-02-26	1978-03-19	1
56820	3375	372328	1956-11-19	1957-02-08	1
2787	161	40481087	1989-02-25	1989-03-18	1
55528	3293	372328	1994-03-23	1994-05-21	1
34967	2078	4218389	2008-05-23	2008-06-13	1
59505	3531	372328	1967-04-28	1967-07-05	1
68480	4053	81151	2017-11-21	2017-12-26	1
253	12	372328	1964-08-22	1965-01-06	1
64035	3786	4112343	1985-06-06	1985-06-13	1
2106	123	28060	1998-11-18	1998-11-25	1
372	19	40481087	1970-03-31	1970-04-21	1
59230	3516	257012	1953-05-28	1953-05-29	1
60119	3562	40481087	1980-09-23	1980-10-07	1
75	3	40481087	1980-05-12	1980-05-19	1
88320	5255	260139	1962-01-14	1962-01-21	1
2755	160	40481087	1973-02-27	1973-03-06	1
58577	3477	4112343	2006-01-02	2006-01-13	1
1203	70	4112343	1968-11-28	1968-12-05	1
86691	5166	40481087	2016-09-08	2016-09-29	1
60764	3601	40481087	1985-01-05	1985-01-26	1
64743	3832	40481087	2007-07-01	2007-07-08	1
86342	5144	260139	2013-05-08	2013-05-15	1
1395	81	4112343	1964-09-18	1964-09-29	1
78731	4668	78272	2011-10-05	2011-10-26	1
63162	3734	4112343	1976-03-10	1976-03-23	1
1927	114	40481087	2012-01-23	2012-02-06	1
1884	111	4112343	1994-12-30	1995-01-12	1
57567	3418	28060	1980-12-17	1980-12-30	1
2138	124	4112343	1992-02-26	1992-03-06	1
57260	3401	4112343	1977-10-23	1977-11-03	1
748	41	4112343	1975-04-03	1975-04-10	1
1088	64	40481087	1980-02-22	1980-03-07	1
53287	3159	4112343	2012-11-11	2012-11-18	1
1105	65	4112343	1982-06-11	1982-06-19	1
58083	3444	4112343	2003-03-13	2003-03-20	1
60323	3572	40481087	2005-01-11	2005-01-18	1
27972	1656	195588	2001-11-20	2002-01-02	1
1832	105	4329847	2005-11-11	2005-11-12	1
57612	3420	40481087	1973-05-05	1973-05-26	1
29542	1750	4112343	2006-09-11	2006-09-19	1
63534	3756	4218389	1957-07-25	1957-08-15	1
607	35	28060	2011-02-21	2011-02-28	1
85624	5099	4112343	1988-03-13	1988-03-24	1
164	7	78272	1969-10-02	1969-10-23	1
1126	66	80180	1996-03-09	1996-03-10	1
64179	3793	378001	1947-12-21	1948-01-20	1
3050	180	4116491	1997-04-16	1997-05-25	1
85452	5086	192671	2010-03-26	2010-03-27	1
898	49	4001336	2005-03-26	2005-05-25	1
55443	3287	40481087	2016-07-31	2016-08-07	1
53590	3177	260139	1985-09-03	1985-09-10	1
33455	1986	40481087	1992-11-17	1992-11-24	1
58153	3446	260139	1958-07-29	1958-08-05	1
1028	61	78272	1988-10-12	1988-11-09	1
62479	3695	4109685	1992-09-28	1992-10-19	1
60997	3614	372328	1974-06-25	1977-07-10	1
774	42	40481087	1980-12-24	1981-01-14	1
56821	3375	440448	1967-03-04	1967-03-05	1
2788	161	260139	2016-01-19	2016-01-26	1
55529	3293	4027663	1943-03-09	1943-03-10	1
34968	2078	4278672	2005-05-09	2005-06-08	1
59506	3531	378001	2012-01-30	2012-03-30	1
68481	4053	257012	1968-03-26	1968-05-07	1
254	12	440086	1973-01-27	1981-02-04	1
64036	3786	4112343	1992-03-12	1992-03-23	1
2107	123	260139	1972-02-13	1972-02-20	1
373	19	40481087	2011-02-25	2011-03-18	1
59231	3516	260139	1954-04-20	1954-05-04	1
61926	3660	81151	1988-12-14	1989-01-04	1
76	3	80180	1957-12-08	1957-12-09	1
88321	5255	260139	1991-07-28	1991-08-04	1
2756	160	40481087	2003-05-23	2003-06-06	1
58578	3477	4283893	1979-03-16	1979-06-08	1
1204	70	4112343	1978-01-19	1978-01-28	1
86692	5166	28060	1953-04-06	1953-04-15	1
60765	3601	80809	2000-06-08	2005-01-13	1
64744	3832	40481087	2009-05-06	2009-05-13	1
86343	5144	260139	2017-06-03	2017-06-17	1
1396	81	4112343	2003-06-11	2003-06-20	1
78732	4668	260139	2003-10-07	2003-10-21	1
63163	3734	4112343	1989-04-04	1989-04-16	1
1928	114	28060	1976-01-17	1976-01-28	1
1885	111	4113008	2018-08-28	2018-09-18	1
57568	3418	80180	1977-07-30	1977-07-31	1
2139	124	40481087	1984-09-07	1984-09-14	1
57261	3401	4146173	1983-11-16	1983-12-16	1
749	41	4112343	1999-09-18	1999-09-30	1
1089	64	40481087	1994-12-23	1994-12-30	1
53288	3159	4116491	2014-06-11	2014-07-12	1
1106	65	40481087	2015-02-11	2015-03-04	1
58084	3444	4146173	1969-11-17	1970-01-16	1
60324	3572	81151	2004-01-05	2004-02-09	1
27973	1656	257012	1992-02-22	1992-02-23	1
1833	105	40481087	1978-12-08	1978-12-15	1
57613	3420	40481087	1983-03-10	1983-03-24	1
29543	1750	4155034	1995-04-23	1995-05-07	1
63535	3756	4278672	2001-08-02	2001-10-01	1
608	35	192671	1997-07-25	1997-07-26	1
85625	5099	4116491	1989-02-22	1989-04-01	1
165	7	4112343	1997-04-12	1997-04-20	1
1127	66	372328	1975-09-26	1976-05-14	1
64180	3793	4027663	1971-04-24	1971-04-25	1
3051	180	4134304	1979-03-12	1979-04-11	1
85453	5086	260139	2009-04-30	2009-05-14	1
899	49	4112343	1973-03-08	1973-03-20	1
55444	3287	4152936	1966-12-10	1966-12-31	1
53591	3177	260139	1986-09-08	1986-09-15	1
33456	1986	80180	2014-04-30	2014-05-01	1
58154	3446	372328	1954-10-29	1955-09-19	1
1029	61	80180	2005-08-29	2005-08-30	1
62480	3695	260139	2008-11-30	2008-12-14	1
60998	3614	4043241	2004-07-25	2004-07-26	1
775	42	40481087	1997-03-06	1997-03-13	1
56822	3375	260139	2014-11-23	2014-12-07	1
2789	161	4109685	2018-07-03	2018-07-17	1
55530	3293	4112343	1920-11-16	1920-11-26	1
34969	2078	4294548	2006-05-23	2006-07-11	1
59507	3531	4112343	1990-02-03	1990-02-11	1
68482	4053	372328	2016-01-12	2016-12-25	1
255	12	40481087	1968-01-13	1968-01-20	1
64037	3786	4112343	2011-03-29	2011-04-10	1
2108	123	321042	2013-07-10	2013-07-11	1
374	19	140673	2004-01-17	2004-01-18	1
59232	3516	260139	1956-11-01	1956-11-08	1
61927	3660	4109685	1999-12-22	2000-01-12	1
77	3	81893	1956-06-16	1956-06-17	1
88322	5255	4152936	2004-06-04	2004-06-18	1
2757	160	80180	2006-02-01	2006-02-02	1
58579	3477	4283893	2005-08-08	2005-11-14	1
1205	70	4285898	1983-03-29	1983-03-30	1
86693	5166	260139	1998-06-03	1998-06-17	1
60766	3601	81151	1974-03-02	1974-04-06	1
64745	3832	40481087	2011-10-22	2011-11-05	1
86344	5144	378419	2014-09-27	2014-09-28	1
1397	81	40481087	1963-03-06	1963-03-13	1
78733	4668	4112343	1961-04-11	1961-04-18	1
63164	3734	4230399	2006-07-11	2006-08-10	1
1929	114	81151	1973-04-07	1973-05-05	1
1886	111	4116491	1994-04-27	1994-06-01	1
57569	3418	4112343	2012-06-17	2012-06-25	1
2140	124	40481087	2013-06-12	2013-06-19	1
57262	3401	372328	1962-10-30	1963-07-28	1
750	41	4152936	1979-12-21	1980-01-11	1
1090	64	4109685	2003-10-05	2003-10-26	1
53289	3159	40481087	2002-07-04	2002-07-18	1
1107	65	80180	2009-06-03	2009-06-04	1
58085	3444	40481087	1949-09-03	1949-09-10	1
60325	3572	372328	1958-07-22	1958-08-27	1
27974	1656	80180	2018-07-04	2018-07-05	1
1834	105	40481087	2001-11-17	2001-11-24	1
57614	3420	40481087	2001-05-25	2001-06-15	1
29544	1750	4294548	1973-08-23	1973-09-13	1
63536	3756	40481087	1984-11-14	1984-11-28	1
609	35	372328	1960-06-20	1960-08-30	1
85626	5099	40481087	2000-01-06	2000-01-27	1
166	7	4156265	1972-07-09	1972-07-23	1
1128	66	4027663	1985-06-20	1985-06-21	1
64181	3793	4112343	1966-10-05	1966-10-16	1
3052	180	40486433	1980-04-27	1996-04-25	1
85454	5086	4112343	1970-09-24	1970-10-03	1
900	49	4112343	1988-02-03	1988-02-13	1
55445	3287	4294548	2012-05-24	2012-06-14	1
53592	3177	260139	2006-04-08	2006-04-15	1
33457	1986	4112343	2014-09-12	2014-09-22	1
58155	3446	378001	2005-08-09	2005-09-08	1
1030	61	372328	1969-12-23	1970-06-28	1
62481	3695	372328	1982-12-07	1983-01-10	1
60999	3614	4112343	1967-07-06	1967-07-19	1
776	42	260139	1938-11-10	1938-11-24	1
56823	3375	372328	1958-02-03	1959-02-13	1
2790	161	4113008	2011-07-21	2011-08-11	1
55531	3293	4112343	1927-11-23	1927-12-01	1
34970	2078	40479422	2014-01-13	2014-02-19	1
59508	3531	4112343	2014-07-18	2014-07-31	1
68483	4053	28060	1971-07-10	1971-07-21	1
256	12	81151	1997-02-26	1997-03-19	1
64038	3786	40481087	1967-10-16	1967-10-23	1
2109	123	372328	1956-01-11	1956-03-28	1
375	19	28060	2000-05-15	2000-05-27	1
59233	3516	4112343	1946-06-25	1946-07-05	1
61928	3660	4112343	1988-01-27	1988-02-08	1
78	3	260139	1948-06-14	1948-06-21	1
88323	5255	4218389	1983-03-03	1983-04-07	1
2758	160	81893	2004-11-08	2004-11-09	1
58580	3477	40481087	1961-06-05	1961-06-26	1
1206	70	28060	1993-04-29	1993-05-07	1
86694	5166	260139	2015-05-14	2015-05-28	1
60767	3601	81151	2011-12-28	2012-02-01	1
67899	4017	80502	1980-09-25	1980-09-26	1
86345	5144	4112343	2007-11-21	2007-11-29	1
1398	81	40481087	1983-02-16	1983-03-02	1
78734	4668	4113008	1998-06-01	1998-06-15	1
63165	3734	4283893	1984-09-29	1985-01-12	1
1930	114	257012	2009-06-25	2009-06-26	1
1887	111	4155034	1981-01-30	1981-02-13	1
57570	3418	4116491	1974-10-09	1974-11-24	1
2141	124	80180	2016-12-17	2016-12-18	1
57263	3401	4112343	1971-03-19	1971-03-28	1
751	41	260139	1984-11-04	1984-11-18	1
1091	64	4112343	1982-02-15	1982-02-27	1
53290	3159	40481087	2008-10-21	2008-10-28	1
1108	65	260139	2009-05-28	2009-06-04	1
58086	3444	40481087	1956-05-10	1956-05-31	1
60326	3572	372328	1969-10-02	1970-04-01	1
27975	1656	4112343	1992-07-14	1992-07-25	1
1835	105	0	2005-11-11	2005-11-12	1
57615	3420	40481087	2013-01-03	2013-01-24	1
29545	1750	4296205	2012-09-09	2012-10-14	1
63537	3756	81151	1964-07-28	1964-08-25	1
610	35	4283893	1989-03-09	1989-05-25	1
85627	5099	40481087	2008-02-22	2008-03-14	1
167	7	40481087	1990-12-27	1991-01-10	1
1129	66	4035415	2016-02-26	2016-03-27	1
64182	3793	4112343	2014-07-31	2014-08-10	1
3053	180	28060	1980-01-07	1980-01-16	1
85455	5086	4134304	1978-04-02	1978-05-02	1
901	49	4296205	1992-12-15	1992-12-29	1
55446	3287	4296204	1965-02-20	1965-03-20	1
53593	3177	313217	2012-05-09	2012-05-10	1
38572	2292	81151	1979-02-24	1979-03-24	1
58156	3446	440448	1953-12-12	1953-12-13	1
1031	61	40481087	1980-09-09	1980-09-16	1
62482	3695	372328	1985-05-29	1986-01-20	1
61000	3614	4112343	2010-11-07	2010-11-15	1
777	42	260139	1980-06-21	1980-06-28	1
56824	3375	40481087	1978-02-04	1978-02-18	1
2791	161	4142905	1990-07-20	1990-10-18	1
55532	3293	4112343	1935-07-24	1935-08-06	1
34971	2078	40481087	1996-12-15	1997-01-05	1
59509	3531	4237458	1979-05-25	1979-06-24	1
68484	4053	260139	2015-12-29	2016-01-05	1
257	12	260139	1974-08-01	1974-08-08	1
64039	3786	40481087	2011-01-11	2011-02-01	1
2110	123	4112343	1988-07-21	1988-07-28	1
376	19	80180	1985-05-16	1985-05-17	1
59234	3516	4112343	1976-04-14	1976-04-27	1
61929	3660	4112343	2010-07-16	2010-07-24	1
79	3	372328	2015-08-21	2015-10-12	1
88324	5255	40481087	1964-01-09	1964-01-30	1
2759	160	195588	1992-10-21	1992-12-08	1
58581	3477	40481087	1987-06-01	1987-06-22	1
1207	70	30753	1982-11-29	1982-11-30	1
86695	5166	4112343	1997-09-07	1997-09-18	1
60768	3601	133834	1961-04-16	1976-09-24	1
67900	4017	260139	1989-02-09	1989-02-23	1
86346	5144	4218389	1951-08-09	1951-08-30	1
1399	81	0	1984-03-15	1984-03-16	1
78735	4668	4156265	2014-12-09	2014-12-23	1
63166	3734	4294548	1954-11-15	1955-02-28	1
1931	114	260139	2018-08-24	2018-09-07	1
1888	111	372328	1977-05-21	1977-10-07	1
57571	3418	40481087	2007-02-01	2007-02-08	1
2142	124	372328	1988-03-29	1989-02-13	1
57264	3401	40481087	1960-12-16	1960-12-23	1
752	41	260139	1989-09-24	1989-10-08	1
1092	64	4112343	1985-11-12	1985-11-20	1
54992	3259	78272	1982-03-30	1982-04-20	1
1109	65	372328	1969-06-18	1969-09-05	1
58087	3444	40481087	1974-12-11	1975-01-01	1
60327	3572	372328	2010-01-01	2010-04-14	1
27976	1656	4142905	1981-06-08	1981-07-08	1
1836	105	80180	2003-07-17	2003-07-18	1
58975	3504	255848	2008-11-21	2008-11-22	1
29546	1750	260139	2017-11-03	2017-11-17	1
63538	3756	381316	2006-02-04	2006-02-05	1
611	35	4283893	1995-08-11	1995-09-15	1
85628	5099	28060	1972-11-04	1972-11-16	1
168	7	40481087	1993-03-06	1993-03-27	1
1130	66	4156265	1981-03-10	1981-03-31	1
64183	3793	4113008	1959-05-22	1959-06-12	1
3054	180	28060	1983-09-28	1983-10-06	1
85456	5086	40481087	1981-03-17	1981-04-07	1
902	49	40481087	1979-09-30	1979-10-21	1
55447	3287	40481087	1950-02-14	1950-02-21	1
53594	3177	372328	1918-03-24	1918-06-26	1
38573	2292	257012	1964-12-22	1964-12-23	1
58157	3446	4113008	2006-09-03	2006-09-24	1
1032	61	40481087	2018-08-05	2018-08-26	1
62483	3695	4112343	2013-05-12	2013-05-21	1
61001	3614	40481087	1955-09-07	1955-09-21	1
778	42	260139	1989-05-16	1989-05-23	1
56825	3375	40481087	2000-06-01	2000-06-15	1
2792	161	40481087	2000-02-28	2000-03-06	1
55533	3293	4112343	1982-03-01	1982-03-09	1
34972	2078	372328	1982-07-09	1982-09-15	1
59510	3531	40481087	2007-08-01	2007-08-15	1
68485	4053	4112343	1991-07-07	1991-07-20	1
258	12	372328	1967-10-23	1968-01-10	1
65278	3865	257012	1971-02-23	1971-02-24	1
2111	123	4112343	1988-11-28	1988-12-07	1
377	19	260139	2007-04-21	2007-04-28	1
59235	3516	4112343	2008-08-15	2008-08-28	1
61930	3660	40481087	2011-09-16	2011-09-30	1
80	3	378001	2017-02-21	2017-03-23	1
61526	3639	260139	1960-09-29	1960-10-06	1
2760	160	257012	1985-12-11	1985-12-12	1
58582	3477	40481087	1987-11-28	1987-12-19	1
1208	70	81893	1982-10-30	1982-10-31	1
86696	5166	4112343	2004-02-17	2004-02-26	1
60769	3601	260139	1984-10-01	1984-10-15	1
67901	4017	317576	2000-04-20	2000-04-21	1
86347	5144	80180	1971-09-03	1971-09-04	1
1400	81	440448	1984-03-15	1984-03-16	1
78736	4668	40481087	1976-01-26	1976-02-16	1
63167	3734	40481087	1991-12-14	1992-01-04	1
1932	114	372328	1977-06-15	1977-10-24	1
1889	111	378001	1977-03-22	1977-04-21	1
57572	3418	28060	1990-06-14	1990-06-25	1
2143	124	4112343	1994-10-14	1994-10-27	1
57265	3401	40481087	2002-06-25	2002-07-16	1
753	41	4296204	1999-07-05	1999-07-19	1
1093	64	40481087	1993-07-05	1993-07-26	1
54993	3259	372328	1967-12-02	1968-04-05	1
1110	65	4112343	2005-12-10	2005-12-19	1
58088	3444	40481087	1986-02-15	1986-03-08	1
60328	3572	381316	2014-04-09	2014-04-10	1
27977	1656	40481087	2016-01-18	2016-01-25	1
1837	105	4112343	1979-03-03	1979-03-10	1
58976	3504	260139	1967-06-22	1967-07-06	1
29547	1750	372328	1968-08-12	1968-10-23	1
63539	3756	4112343	1947-01-22	1947-01-31	1
612	35	40481087	1965-12-27	1966-01-17	1
85629	5099	260139	1949-10-01	1949-10-08	1
4041	235	28060	1988-12-02	1988-12-14	1
1131	66	40481087	1988-12-17	1988-12-24	1
64184	3793	4237458	1949-12-10	1950-02-08	1
3055	180	80180	2012-09-29	2012-09-30	1
85457	5086	28060	1980-02-16	1980-02-27	1
903	49	40481087	1985-03-31	1985-04-14	1
55448	3287	40481087	1967-05-10	1967-05-24	1
53595	3177	381316	2012-05-30	2012-05-31	1
38574	2292	4112343	1971-03-27	1971-04-04	1
58158	3446	4218389	1977-01-23	1977-02-27	1
1033	61	28060	1977-12-03	1977-12-12	1
62484	3695	0	2007-02-12	2007-02-13	1
61002	3614	40481087	1960-10-30	1960-11-13	1
779	42	372328	1914-07-09	1914-10-13	1
56826	3375	28060	1993-03-14	1993-03-26	1
2793	161	40481087	2012-02-11	2012-02-25	1
55534	3293	4113008	1990-12-25	1991-01-08	1
34973	2078	4112343	1984-06-02	1984-06-14	1
59511	3531	30753	2000-07-13	2000-07-14	1
68486	4053	40481087	1975-08-05	1975-08-12	1
259	12	4134304	1986-11-16	1986-12-16	1
65279	3865	260139	1977-07-10	1977-07-24	1
2112	123	4112343	2011-04-10	2011-04-17	1
378	19	260139	2017-05-07	2017-05-21	1
59236	3516	4237458	1996-09-24	1996-11-23	1
61931	3660	260139	2005-04-28	2005-05-05	1
81	3	4027663	1946-12-26	1946-12-27	1
61527	3639	260139	1978-03-01	1978-03-08	1
2761	160	260139	1966-01-03	1966-01-17	1
58583	3477	40481087	2008-12-03	2008-12-24	1
1209	70	257012	1998-07-11	1998-07-12	1
86697	5166	4294548	1976-06-06	1976-06-27	1
60770	3601	439777	2018-06-04	2018-06-05	1
67902	4017	381316	2014-08-07	2014-08-08	1
86348	5144	260139	1962-06-21	1962-06-28	1
1401	81	4112343	1993-07-18	1993-07-31	1
78737	4668	40481087	1981-09-09	1981-09-30	1
63168	3734	28060	1981-04-30	1981-05-12	1
1933	114	40481087	2014-05-31	2014-06-14	1
1890	111	4112343	2011-12-18	2011-12-30	1
57573	3418	4266809	1977-07-30	1977-07-31	1
2144	124	40481087	2013-09-24	2013-10-01	1
59660	3539	80180	2016-06-21	2016-06-22	1
754	41	40481087	1976-03-17	1976-03-24	1
1094	64	378001	2005-06-17	2005-07-17	1
54994	3259	372328	1980-01-03	1980-08-08	1
1111	65	4283893	1996-05-19	1996-07-28	1
58089	3444	40481087	1987-10-04	1987-10-11	1
60329	3572	4294548	1967-03-07	1967-05-16	1
27978	1656	260139	1994-06-01	1994-06-15	1
2277	133	28060	2002-11-06	2002-11-13	1
58977	3504	4134304	1937-12-25	1938-01-24	1
29548	1750	4237458	1974-01-13	1974-04-13	1
63540	3756	40481087	1985-10-01	1985-10-15	1
613	35	40481087	1984-02-18	1984-02-25	1
85630	5099	260139	1969-02-11	1969-02-27	1
4042	235	28060	1991-04-04	1991-04-16	1
1132	66	260139	1998-04-18	1998-05-02	1
64185	3793	4296204	2003-11-16	2003-12-21	1
3056	180	372328	1977-12-17	1978-03-30	1
85458	5086	80180	2010-02-27	2010-02-28	1
904	49	40481087	1987-02-10	1987-03-03	1
55449	3287	40481087	1982-03-29	1982-04-12	1
53596	3177	4112343	1928-01-21	1928-01-30	1
38575	2292	4112343	2017-06-19	2017-06-26	1
58159	3446	40481087	1998-05-17	1998-06-07	1
1034	61	372328	1968-08-18	1968-09-29	1
62485	3695	192671	2013-12-22	2013-12-23	1
61003	3614	258780	2003-07-20	2003-07-21	1
780	42	440448	1933-10-29	1933-10-30	1
56827	3375	260139	1983-06-03	1983-06-17	1
2794	161	40481087	2015-04-16	2015-04-30	1
55535	3293	4142905	1996-11-07	1997-02-05	1
34974	2078	4142905	2019-01-24	2019-03-25	1
59512	3531	4112343	1981-09-07	1981-09-16	1
68487	4053	40481087	1990-04-02	1990-04-16	1
260	12	4266809	2008-04-08	2008-04-09	1
65280	3865	260139	2009-08-06	2009-08-13	1
2113	123	4283893	1974-10-10	1974-11-07	1
379	19	4112343	2014-09-11	2014-09-22	1
59237	3516	40479422	2017-03-08	2017-05-14	1
61932	3660	4112343	1976-11-30	1976-12-07	1
82	3	4156265	1967-05-26	1967-06-16	1
61528	3639	260139	1998-06-27	1998-07-04	1
2762	160	260139	2004-10-01	2004-10-08	1
58584	3477	40481087	2017-01-16	2017-01-23	1
1210	70	260139	2007-12-03	2007-12-10	1
86698	5166	40481087	1969-06-27	1969-07-04	1
60771	3601	4084167	1965-01-18	1965-01-18	1
67903	4017	4112343	1922-08-20	1922-09-01	1
86349	5144	4112343	1955-11-17	1955-11-29	1
1402	81	40481087	1956-08-27	1956-09-03	1
78738	4668	40481087	1987-09-17	1987-09-24	1
63169	3734	80180	1986-02-28	1986-03-01	1
1934	114	260139	1999-11-18	1999-12-02	1
1891	111	40481087	1976-05-03	1976-05-10	1
57574	3418	40481087	1965-03-29	1965-04-19	1
2145	124	260139	1990-02-03	1990-02-10	1
59661	3539	4112343	2004-09-23	2004-10-03	1
755	41	40481087	1982-04-24	1982-05-15	1
1095	64	40481087	1975-07-25	1975-08-08	1
54995	3259	4112343	1980-11-12	1980-11-23	1
1112	65	40481087	1998-03-29	1998-04-05	1
58090	3444	28060	1989-09-28	1989-10-05	1
60330	3572	40481087	1972-12-24	1972-12-31	1
27979	1656	4112343	2000-03-19	2000-04-01	1
2278	133	192671	2019-04-05	2019-04-06	1
58978	3504	30753	1955-10-02	1955-10-03	1
32837	1951	4112343	2009-07-20	2009-07-27	1
63541	3756	40481087	1995-02-01	1995-02-22	1
614	35	40481087	2017-12-14	2017-12-28	1
85631	5099	260139	2017-02-16	2017-03-02	1
4043	235	4278672	2000-10-03	2000-11-02	1
1133	66	4112343	1971-07-14	1971-07-22	1
64186	3793	40481087	1964-04-11	1964-05-02	1
3057	180	40481087	2010-08-06	2010-08-13	1
85459	5086	4218389	1970-10-20	1970-11-10	1
905	49	0	2003-07-12	2003-07-13	1
55450	3287	40481087	1996-12-20	1997-01-10	1
53597	3177	4112343	1980-04-25	1980-05-08	1
38576	2292	4113008	1997-10-13	1997-11-03	1
58160	3446	0	1957-12-09	1957-12-10	1
1035	61	4048171	1972-01-27	1972-01-28	1
62486	3695	196456	1996-03-20	1996-03-20	1
61004	3614	260139	1992-07-05	1992-07-12	1
781	42	4059173	1970-06-04	1970-07-04	1
56828	3375	28060	1988-07-22	1988-08-04	1
2795	161	40481087	2018-06-18	2018-07-09	1
55536	3293	4294548	1927-02-24	1927-03-17	1
34975	2078	40481087	1983-01-30	1983-02-20	1
59513	3531	4116491	1994-03-22	1994-05-15	1
69521	4119	28060	2012-05-08	2012-05-19	1
261	12	4294548	1997-01-16	1997-01-30	1
65281	3865	4237458	1969-06-20	1969-07-20	1
2114	123	4283893	1985-10-13	1985-12-01	1
380	19	40481087	1956-12-24	1956-12-31	1
59238	3516	40481087	1982-11-04	1982-11-18	1
61933	3660	4112343	1978-02-04	1978-02-14	1
83	3	4166224	1972-12-20	1972-12-21	1
61529	3639	317576	2007-07-07	2007-07-08	1
2763	160	4310024	2004-06-11	2004-06-12	1
58585	3477	80180	1997-01-08	1997-01-09	1
1211	70	372328	1952-05-20	1953-03-22	1
86699	5166	40481087	1980-03-29	1980-04-19	1
60772	3601	4084167	1976-03-25	1976-03-25	1
67904	4017	4112343	1939-03-18	1939-03-27	1
86350	5144	4112343	1959-08-12	1959-08-22	1
3240	189	260139	2003-07-16	2003-07-30	1
78739	4668	0	2011-04-26	2011-04-27	1
63170	3734	260139	1950-04-10	1950-04-24	1
1935	114	40481087	1991-10-06	1991-10-20	1
1892	111	40481087	1997-09-13	1997-10-04	1
57575	3418	40481087	1972-08-16	1972-08-30	1
2146	124	4048171	1987-03-12	2003-03-10	1
59662	3539	81151	2015-12-30	2016-01-20	1
756	41	80180	2008-07-31	2008-08-01	1
6809	403	28060	1926-03-10	1926-03-22	1
54996	3259	4112343	1990-08-17	1990-08-25	1
1113	65	260139	1996-10-25	1996-11-08	1
58091	3444	372328	1940-05-23	1940-10-07	1
60331	3572	40481087	2010-08-28	2010-09-11	1
27980	1656	4134304	1992-06-10	1992-08-09	1
2279	133	372328	1988-11-03	1988-12-12	1
58979	3504	372328	1924-05-07	1924-07-25	1
32838	1951	4112343	2014-05-03	2014-05-10	1
63542	3756	28060	1948-05-27	1948-06-08	1
615	35	4112343	1992-04-15	1992-04-23	1
85632	5099	4112343	1944-03-31	1944-04-07	1
4044	235	4294548	1988-10-08	1988-11-05	1
1134	66	40481087	1978-11-11	1978-11-18	1
64187	3793	260139	1994-04-14	1994-04-21	1
3375	194	80180	2015-01-31	2015-02-01	1
85460	5086	28060	1974-07-18	1974-07-29	1
906	49	80180	2009-06-13	2009-06-14	1
56152	3332	260139	1976-07-31	1976-08-07	1
53598	3177	4134304	1985-12-15	1986-03-15	1
38577	2292	4152936	2005-02-24	2005-03-17	1
58161	3446	81151	1995-11-02	1995-11-16	1
1036	61	4084167	1978-07-29	1978-07-29	1
62487	3695	372328	1981-10-26	1982-01-11	1
61005	3614	439777	2009-06-11	2009-06-12	1
782	42	4112343	1939-04-12	1939-04-25	1
56829	3375	80180	1995-09-11	1995-09-12	1
4411	260	372328	1969-10-10	1969-12-20	1
55537	3293	40481087	1936-06-23	1936-07-14	1
34976	2078	40481087	1996-03-21	1996-04-11	1
59514	3531	4142905	1975-07-15	1975-10-13	1
69522	4119	257012	1997-07-25	1997-07-26	1
262	12	4310024	2006-06-18	2006-06-19	1
65282	3865	4278672	1957-04-24	1957-05-24	1
2115	123	40481087	1951-08-14	1951-09-04	1
381	19	40481087	1978-02-13	1978-02-20	1
59239	3516	80180	1978-04-09	1978-04-10	1
61934	3660	4113008	1987-11-29	1987-12-20	1
84	3	4218389	1923-12-22	1924-01-12	1
61530	3639	4112343	1928-02-14	1928-02-27	1
2764	160	40481087	1984-02-16	1984-02-23	1
58586	3477	257012	1979-04-20	1979-04-21	1
1212	70	378001	2009-04-21	2009-05-21	1
86700	5166	40481087	1990-08-01	1990-08-22	1
60773	3601	40481087	2003-05-13	2003-05-27	1
67905	4017	4134304	1937-04-08	1937-05-08	1
86351	5144	40481087	1941-10-27	1941-11-03	1
3241	189	440086	1972-05-07	1976-05-16	1
78740	4668	321042	2011-04-26	2011-04-27	1
63171	3734	260139	1957-03-07	1957-03-14	1
1936	114	40481087	2018-08-29	2018-09-19	1
4207	245	81151	2004-12-20	2005-01-03	1
57576	3418	40481087	1998-10-20	1998-11-10	1
2147	124	4051466	1986-03-12	2003-06-13	1
59663	3539	260139	1983-06-01	1983-06-15	1
757	41	81151	1990-01-18	1990-02-22	1
6810	403	28060	1934-03-27	1934-04-03	1
54997	3259	4112343	2008-03-08	2008-03-16	1
1114	65	4116491	2016-03-18	2016-05-16	1
58092	3444	4112343	1955-01-18	1955-01-25	1
60332	3572	28060	1970-12-04	1970-12-13	1
27981	1656	4294548	1992-01-18	1992-04-18	1
2280	133	4027663	2008-12-08	2008-12-09	1
58980	3504	378419	2001-12-28	2001-12-29	1
32839	1951	40481087	1997-04-18	1997-04-25	1
63543	3756	81151	1960-11-25	1960-12-16	1
616	35	4112343	2002-04-14	2002-04-21	1
85633	5099	4112343	1950-05-20	1950-05-31	1
4045	235	40481087	2008-07-13	2008-07-27	1
1135	66	40481087	2017-05-31	2017-06-07	1
64188	3793	378001	1964-04-16	1964-06-15	1
3376	194	260139	2013-06-27	2013-07-04	1
85461	5086	4112343	2018-07-25	2018-08-07	1
907	49	260139	1979-12-21	1980-01-04	1
56153	3332	260139	1982-03-25	1982-04-01	1
53599	3177	4310024	1948-02-07	1948-02-08	1
38578	2292	4294548	1964-11-17	1965-01-26	1
58162	3446	260139	1968-09-23	1968-09-30	1
1037	61	4296204	1974-03-20	1974-04-24	1
62488	3695	40481087	2011-12-24	2011-12-31	1
61006	3614	4059173	1951-05-17	1951-08-15	1
783	42	4112343	1940-10-20	1940-11-01	1
56830	3375	260139	2007-02-24	2007-03-03	1
4412	260	372328	1974-03-05	1974-06-22	1
55538	3293	40481087	1969-07-28	1969-08-18	1
34977	2078	260139	1994-08-07	1994-08-14	1
59515	3531	40481087	1992-06-02	1992-06-16	1
69523	4119	260139	2018-04-10	2018-04-17	1
263	12	40481087	1969-12-19	1969-12-26	1
65283	3865	40479422	2004-11-13	2004-12-20	1
2116	123	40481087	1965-08-16	1965-08-30	1
382	19	40481087	1997-10-14	1997-10-28	1
59240	3516	260139	1984-06-10	1984-06-24	1
61935	3660	78272	1997-03-23	1997-04-06	1
85	3	4266809	1957-12-08	1957-12-09	1
61531	3639	4112343	1973-01-02	1973-01-11	1
2765	160	28060	2016-09-06	2016-09-19	1
58587	3477	260139	2010-08-18	2010-09-01	1
1213	70	4112343	1958-10-31	1958-11-13	1
86701	5166	40481087	2010-05-29	2010-06-05	1
60774	3601	260139	1971-09-24	1971-10-08	1
67906	4017	4294548	1970-06-11	1970-09-03	1
86352	5144	40481087	1970-02-13	1970-03-06	1
3242	189	4112343	1963-08-01	1963-08-11	1
78741	4668	372328	1957-03-31	1957-06-18	1
63172	3734	4116491	1987-07-08	1987-08-26	1
2696	158	28060	1952-05-08	1952-05-16	1
4208	245	4112343	1953-09-03	1953-09-12	1
59106	3510	28060	1952-05-09	1952-05-17	1
2148	124	4112343	1992-04-07	1992-04-15	1
59664	3539	372328	1984-09-15	1984-11-16	1
758	41	260139	1999-03-22	1999-04-05	1
6811	403	28060	1983-01-31	1983-02-08	1
54998	3259	40481087	1976-12-29	1977-01-12	1
1115	65	40481087	1968-07-29	1968-08-19	1
58093	3444	4112343	1981-01-31	1981-02-11	1
60333	3572	30753	1992-06-05	1992-06-06	1
29746	1762	28060	1985-08-23	1985-09-05	1
2281	133	4285898	2018-10-27	2018-10-28	1
58981	3504	4112343	1946-01-27	1946-02-04	1
32840	1951	260139	2003-04-10	2003-04-24	1
63544	3756	81151	1988-07-20	1988-08-10	1
617	35	4112343	2011-01-05	2011-01-18	1
85634	5099	40481087	1949-03-09	1949-03-16	1
4046	235	80180	2016-05-17	2016-05-18	1
8350	487	257012	2007-07-01	2007-07-02	1
64189	3793	4112343	1983-08-22	1983-08-29	1
3377	194	4218389	2010-07-25	2010-08-22	1
85462	5086	40481087	1978-09-17	1978-09-24	1
908	49	260139	2010-04-20	2010-05-04	1
56154	3332	372328	1964-04-03	1964-05-12	1
53600	3177	40480160	1993-10-04	1993-11-03	1
38579	2292	28060	1978-11-09	1978-11-22	1
58163	3446	260139	1970-10-21	1970-11-04	1
1038	61	40481087	1974-10-22	1974-11-05	1
62489	3695	80180	2013-11-17	2013-11-18	1
61007	3614	4112343	1992-07-22	1992-07-29	1
784	42	4112343	1950-04-16	1950-04-29	1
56831	3375	4112343	1976-12-06	1976-12-19	1
4413	260	4266809	2010-03-19	2010-03-20	1
55539	3293	40481087	1995-02-12	1995-02-19	1
34978	2078	4112343	2007-02-15	2007-02-27	1
59516	3531	40481087	1993-11-15	1993-11-22	1
69524	4119	372328	1947-02-24	1947-08-23	1
264	12	40481087	1977-09-24	1977-10-15	1
65284	3865	40481087	2009-12-21	2009-12-28	1
2117	123	40481087	1978-11-21	1978-12-12	1
383	19	40481087	2018-08-13	2018-08-20	1
59241	3516	4112343	1965-06-25	1965-07-07	1
61936	3660	80180	2009-09-26	2009-09-27	1
86	3	40481087	1956-12-15	1956-12-29	1
61532	3639	4112343	1979-01-14	1979-01-21	1
2766	160	81151	1976-02-09	1976-03-08	1
58588	3477	4027663	1990-03-21	1990-03-22	1
1214	70	4112343	1967-11-09	1967-11-20	1
88985	5300	30753	1980-04-11	1980-04-12	1
60775	3601	4112343	1969-01-30	1969-02-10	1
67907	4017	40481087	1966-09-17	1966-09-24	1
86353	5144	260139	1982-04-15	1982-04-22	1
3243	189	4155034	1992-06-02	1992-06-23	1
78742	4668	372328	1958-07-13	1958-12-16	1
63173	3734	4278672	1966-02-27	1966-05-28	1
2697	158	260139	2014-03-29	2014-04-05	1
4209	245	4112343	2002-10-14	2002-10-26	1
59107	3510	28060	1996-05-19	1996-05-31	1
2149	124	4112343	1997-09-12	1997-09-25	1
59665	3539	4294548	1998-12-05	1998-12-26	1
759	41	4051466	1975-06-02	1992-08-31	1
6812	403	257012	1935-01-23	1935-01-24	1
54999	3259	78272	1966-08-25	1966-09-22	1
1116	65	40481087	1969-05-25	1969-06-01	1
58094	3444	4112343	1995-02-08	1995-02-21	1
60334	3572	78272	1980-02-05	1980-03-11	1
29747	1762	192671	1979-12-16	1979-12-17	1
2282	133	28060	1990-05-31	1990-06-10	1
58982	3504	4285898	1955-12-31	1956-01-01	1
32841	1951	372328	1982-10-05	1982-10-19	1
63545	3756	260139	1974-01-01	1974-01-08	1
618	35	4134304	1993-04-28	1993-05-28	1
85635	5099	40481087	1956-12-13	1957-01-03	1
4047	235	380378	1992-09-25	1992-09-26	1
8351	487	260139	2007-05-27	2007-06-03	1
64190	3793	4112343	2004-10-05	2004-10-17	1
3378	194	40481087	2005-12-13	2005-12-20	1
85463	5086	81151	2003-02-20	2003-03-27	1
909	49	4112343	2011-06-14	2011-06-22	1
56155	3332	4027663	1989-11-29	1989-11-30	1
53601	3177	40480160	2002-07-19	2002-08-18	1
38580	2292	258780	2011-01-28	2011-01-29	1
58164	3446	372328	1944-09-08	1944-11-20	1
3632	209	0	1976-12-31	1977-01-01	1
62490	3695	4156265	2015-11-14	2015-12-05	1
61008	3614	4294548	1993-07-02	1993-07-09	1
785	42	40481087	1926-05-12	1926-05-19	1
56832	3375	4112343	2011-02-23	2011-03-07	1
4414	260	4283893	1982-03-02	1982-08-10	1
55540	3293	28060	1958-05-22	1958-06-04	1
34979	2078	4112343	2012-12-29	2013-01-09	1
59517	3531	80180	2001-07-08	2001-07-09	1
69525	4119	40481087	1946-08-19	1946-09-09	1
265	12	40481087	1990-11-10	1990-11-24	1
65285	3865	192671	1990-06-09	1990-06-10	1
2118	123	40481087	2012-10-16	2012-10-23	1
1749	101	0	2001-01-12	2001-01-13	1
59242	3516	4112343	1993-09-09	1993-09-18	1
61937	3660	81151	1979-03-18	1979-04-15	1
87	3	40481087	1971-05-25	1971-06-01	1
61533	3639	40481087	1999-02-11	1999-02-18	1
2767	160	192671	2006-02-19	2006-02-20	1
58589	3477	4112343	1976-04-22	1976-05-04	1
1215	70	4283893	1998-05-16	1998-08-29	1
88986	5300	78272	1994-01-18	1994-02-08	1
60776	3601	4296204	1976-11-21	1976-12-26	1
67908	4017	260139	1930-02-08	1930-02-22	1
86354	5144	4112343	1970-04-30	1970-05-07	1
3244	189	260139	2012-09-24	2012-10-08	1
78743	4668	4134304	1985-06-02	1985-08-31	1
63174	3734	40481087	1960-05-09	1960-05-23	1
2698	158	4112343	1975-11-01	1975-11-10	1
4210	245	4296205	1942-04-03	1942-05-01	1
59108	3510	260139	1997-08-06	1997-08-20	1
2150	124	4112343	2011-01-16	2011-01-23	1
59666	3539	81151	1996-03-23	1996-04-13	1
760	41	4112343	1974-08-20	1974-09-02	1
6813	403	260139	1926-02-07	1926-02-21	1
55000	3259	80180	1999-10-11	1999-10-12	1
2961	173	260139	1985-07-03	1985-07-17	1
58095	3444	40481087	1949-05-15	1949-05-29	1
60335	3572	80180	1993-08-29	1993-08-30	1
29748	1762	260139	1975-09-20	1975-09-27	1
2283	133	30753	2018-03-01	2018-03-02	1
58983	3504	28060	1931-04-04	1931-04-13	1
32842	1951	4112343	2019-05-18	2019-05-25	1
63546	3756	372328	1941-02-19	1941-03-29	1
619	35	4237458	1984-05-15	1984-06-14	1
85636	5099	40481087	1977-01-30	1977-02-06	1
4048	235	40481087	1998-04-23	1998-05-14	1
8352	487	4112343	1984-09-20	1984-09-30	1
64191	3793	4296204	1944-12-01	1945-01-05	1
3379	194	40481087	2015-01-07	2015-01-28	1
85464	5086	260139	2017-05-23	2017-05-30	1
910	49	4237458	1980-02-26	1980-05-26	1
56156	3332	40481087	1968-04-18	1968-05-09	1
53602	3177	40480160	2008-02-18	2008-03-19	1
38581	2292	260139	2009-01-16	2009-01-30	1
58165	3446	4109685	2000-09-20	2000-10-04	1
3633	209	372328	2016-05-03	2016-05-17	1
62491	3695	4218389	2008-03-29	2008-04-19	1
61009	3614	40481087	1953-02-26	1953-03-12	1
786	42	260139	1937-09-07	1937-09-14	1
56833	3375	4166224	1967-03-04	1967-03-05	1
4415	260	40481087	1975-05-16	1975-05-30	1
55541	3293	28060	1996-11-07	1996-11-19	1
34980	2078	372328	1983-04-13	1983-05-18	1
59518	3531	260139	1982-09-07	1982-09-21	1
69526	4119	40481087	2003-01-15	2003-02-05	1
266	12	40481087	1993-01-18	1993-02-01	1
65286	3865	4048171	1960-07-04	1960-07-05	1
2119	123	28060	1960-10-20	1960-11-01	1
1750	101	78272	2016-05-11	2016-06-15	1
59243	3516	4218389	1966-03-08	1966-04-05	1
61938	3660	195588	1998-08-16	1998-09-30	1
88	3	40481087	2016-01-23	2016-01-30	1
61534	3639	80180	1957-01-18	1957-01-19	1
2768	160	195588	1997-12-07	1998-01-17	1
58590	3477	40481087	2018-11-23	2018-12-07	1
1216	70	40481087	1995-02-02	1995-02-23	1
88987	5300	80180	1981-09-03	1981-09-04	1
60777	3601	40481087	1979-11-17	1979-11-24	1
67909	4017	260139	1984-03-04	1984-03-18	1
86355	5144	4112343	2019-03-14	2019-03-27	1
3245	189	372328	1961-11-05	1962-04-15	1
78744	4668	4149245	1987-06-22	1987-08-28	1
63175	3734	40481087	1983-01-16	1983-01-30	1
2699	158	40481087	1949-10-20	1949-11-10	1
4211	245	40481087	1944-05-14	1944-06-04	1
59109	3510	4048171	1937-03-14	1954-03-12	1
2440	144	80180	2011-12-01	2011-12-02	1
59667	3539	260139	1998-08-02	1998-08-16	1
761	41	4112343	2006-02-27	2006-03-11	1
6814	403	260139	1929-02-11	1929-02-18	1
55001	3259	81151	1974-08-11	1974-09-08	1
2962	173	260139	2002-04-06	2002-04-20	1
58096	3444	40481087	1954-10-03	1954-10-10	1
60336	3572	257012	1967-03-28	1967-03-29	1
29749	1762	313217	1998-04-09	1998-04-10	1
2284	133	80180	2019-03-26	2019-03-27	1
58984	3504	81893	1955-09-02	1955-09-03	1
32843	1951	4296204	2018-01-25	2018-03-01	1
63547	3756	4134304	1953-06-16	1953-08-15	1
620	35	4285898	1997-04-02	1997-04-03	1
85637	5099	260139	1953-10-18	1953-11-01	1
4049	235	40481087	1998-06-21	1998-06-28	1
8353	487	4112343	2003-07-08	2003-07-21	1
64192	3793	40481087	2012-08-24	2012-08-31	1
3380	194	372328	1981-06-13	1981-08-27	1
85465	5086	372328	1970-08-21	1970-12-03	1
911	49	4294548	2011-11-25	2011-12-09	1
56157	3332	40481087	1990-08-06	1990-08-27	1
53603	3177	40481087	1916-08-24	1916-09-14	1
38582	2292	4035415	1986-08-14	1986-09-13	1
58166	3446	4112343	1982-11-22	1982-12-03	1
3634	209	4112343	1964-10-14	1964-10-21	1
66150	3920	260139	1999-01-16	1999-01-30	1
61010	3614	81151	1993-04-11	1993-05-16	1
787	42	260139	1999-11-17	1999-11-24	1
56834	3375	40481087	2007-10-12	2007-10-26	1
4416	260	78272	1986-04-28	1986-06-02	1
55542	3293	30753	1949-05-31	1949-06-01	1
34981	2078	40481087	1982-08-17	1982-08-24	1
59519	3531	4112343	1976-12-18	1976-12-30	1
69527	4119	28060	1949-10-12	1949-10-23	1
267	12	260139	1974-10-08	1974-10-15	1
65287	3865	4278672	1978-10-01	1978-11-30	1
2120	123	257012	1985-11-24	1985-11-25	1
1751	101	80180	1965-05-28	1965-05-29	1
59244	3516	4283893	1967-03-14	1967-05-23	1
61939	3660	4116491	1997-07-16	1997-08-16	1
89	3	80502	1986-04-28	1986-04-29	1
61535	3639	257012	1936-12-23	1936-12-24	1
2769	160	260139	1973-02-10	1973-02-17	1
58591	3477	192671	1997-02-12	1997-02-13	1
1217	70	28060	2019-04-24	2019-05-03	1
88988	5300	260139	1959-05-24	1959-06-07	1
60778	3601	40481087	1989-06-12	1989-07-03	1
67910	4017	4112343	2007-04-17	2007-04-27	1
86356	5144	4152936	1968-07-01	1968-07-22	1
3246	189	4112343	1977-08-28	1977-09-05	1
78745	4668	40481087	1982-11-30	1982-12-07	1
63176	3734	4059173	1977-01-30	1977-03-01	1
2700	158	40481087	1973-09-11	1973-10-02	1
4212	245	40481087	1952-04-15	1952-04-22	1
59110	3510	4112343	1974-10-30	1974-11-10	1
2441	144	4112343	1997-10-22	1997-11-04	1
59668	3539	260139	2011-08-19	2011-09-02	1
762	41	4112343	2012-01-12	2012-01-25	1
6815	403	372328	1924-02-29	1924-08-04	1
55002	3259	192671	1999-11-21	1999-11-22	1
2963	173	40481087	1975-05-23	1975-06-13	1
58097	3444	40481087	1982-12-13	1982-12-27	1
60337	3572	372328	1959-02-23	1959-08-26	1
29750	1762	372328	1946-08-01	1946-10-17	1
2285	133	260139	2010-08-11	2010-08-25	1
58985	3504	192671	1956-05-19	1956-05-20	1
32844	1951	40481087	1987-05-17	1987-05-31	1
63548	3756	4218389	1958-09-09	1958-10-07	1
621	35	40481087	1970-02-01	1970-02-15	1
85638	5099	4112343	1986-03-09	1986-03-20	1
4050	235	260139	2000-05-02	2000-05-09	1
8354	487	40481087	1985-10-28	1985-11-18	1
64193	3793	28060	2002-02-06	2002-02-17	1
3381	194	4109685	1988-05-07	1988-05-21	1
85466	5086	372328	1971-05-02	1971-09-02	1
912	49	40481087	2006-03-26	2006-04-16	1
56158	3332	40481087	1999-03-22	1999-03-29	1
53604	3177	80180	1950-04-27	1950-04-28	1
38583	2292	4278672	1964-12-09	1965-02-07	1
58167	3446	4156265	1982-10-20	1982-11-10	1
3635	209	4112343	1993-07-04	1993-07-17	1
66151	3920	372328	1974-12-01	1975-02-01	1
61011	3614	260139	1952-09-17	1952-10-01	1
788	42	4059173	1930-10-04	1931-01-02	1
57523	3417	81151	1948-04-13	1948-05-04	1
4417	260	80180	2010-03-19	2010-03-20	1
55543	3293	80180	1950-04-26	1950-04-27	1
36303	2152	28060	1949-07-14	1949-07-25	1
59520	3531	4237458	1969-01-17	1969-04-17	1
69528	4119	80180	1984-08-26	1984-08-27	1
268	12	260139	1986-10-23	1986-10-30	1
65288	3865	40479422	2009-05-28	2009-07-04	1
2121	123	260139	1952-02-03	1952-02-10	1
1752	101	260139	1932-04-23	1932-05-07	1
59245	3516	40481087	1969-03-22	1969-04-12	1
61940	3660	4278672	1992-06-17	1992-09-15	1
90	3	313217	2001-07-23	2001-07-24	1
61536	3639	260139	1929-03-07	1929-03-21	1
2770	160	260139	2003-06-06	2003-06-13	1
58592	3477	4112343	1977-11-27	1977-12-08	1
1218	70	260139	1981-06-02	1981-06-16	1
88989	5300	4027663	1971-12-20	1971-12-21	1
60779	3601	80180	1992-03-27	1992-03-28	1
67911	4017	4112343	2014-02-01	2014-02-10	1
86357	5144	4156265	2009-11-14	2009-12-05	1
3247	189	4112343	2014-03-07	2014-03-14	1
78746	4668	40481087	2001-11-28	2001-12-12	1
63177	3734	4112343	2007-05-25	2007-06-05	1
2701	158	40481087	1983-04-18	1983-05-09	1
4213	245	40481087	1981-12-03	1981-12-24	1
59111	3510	4155034	1960-03-31	1960-04-14	1
2442	144	40481087	1979-09-04	1979-09-25	1
59669	3539	4112343	1999-06-07	1999-06-20	1
763	41	40481087	1977-10-21	1977-11-11	1
6816	403	4112343	1960-10-13	1960-10-22	1
55003	3259	260139	1969-12-08	1969-12-22	1
2964	173	40481087	1995-09-05	1995-09-19	1
58098	3444	260139	1978-06-04	1978-06-11	1
60338	3572	4155034	1975-01-11	1975-02-01	1
29751	1762	381316	2002-12-26	2002-12-27	1
2286	133	378001	2009-10-14	2009-11-13	1
58986	3504	4027663	1949-02-10	1949-02-11	1
32845	1951	40481087	1998-11-25	1998-12-16	1
63549	3756	40481087	1947-07-23	1947-07-30	1
622	35	40481087	1973-02-07	1973-02-21	1
85639	5099	40481087	1950-10-14	1950-10-21	1
4051	235	372328	1985-05-13	1986-04-21	1
8355	487	40481087	1989-10-18	1989-11-01	1
64194	3793	4112343	1953-07-19	1953-07-30	1
3382	194	4112343	1995-01-06	1995-01-16	1
85467	5086	372328	1972-10-26	1973-03-01	1
2938	171	28060	1991-11-02	1991-11-10	1
56159	3332	40481087	2016-08-13	2016-09-03	1
53605	3177	192671	1950-07-05	1950-07-06	1
38584	2292	40481087	1985-11-13	1985-12-04	1
58168	3446	4278672	1965-05-21	1965-06-20	1
3636	209	4294548	1981-01-07	1981-01-21	1
66152	3920	372328	1975-08-30	1975-10-25	1
61012	3614	260139	1990-10-06	1990-10-13	1
789	42	4112343	1981-10-29	1981-11-11	1
57524	3417	260139	1914-09-20	1914-09-27	1
4418	260	260139	1979-02-22	1979-03-08	1
55544	3293	260139	1960-12-12	1960-12-19	1
36304	2152	260139	2016-10-17	2016-10-31	1
59521	3531	4285898	2001-01-09	2001-01-10	1
69529	4119	195588	1967-07-17	1967-08-18	1
269	12	372328	1970-08-27	1971-01-27	1
65289	3865	40481087	1982-02-01	1982-02-08	1
2122	123	4112343	2001-05-17	2001-05-28	1
1753	101	4112343	1930-05-06	1930-05-18	1
59246	3516	40481087	1979-12-21	1980-01-11	1
61941	3660	260139	2003-03-14	2003-03-21	1
91	3	317576	2012-09-24	2012-09-25	1
61537	3639	260139	1954-06-03	1954-06-17	1
2771	160	439777	2000-07-17	2000-07-18	1
58593	3477	40481087	1964-10-17	1964-11-07	1
1219	70	378001	1984-07-01	1984-07-31	1
88990	5300	4112343	1953-08-07	1953-08-15	1
60780	3601	260139	2011-08-26	2011-09-09	1
67912	4017	4146173	1972-06-24	1972-08-23	1
86358	5144	40481087	1979-05-06	1979-05-20	1
3248	189	4155034	1984-11-20	1984-12-11	1
78747	4668	40481087	2009-12-25	2010-01-15	1
63178	3734	4112343	2019-05-20	2019-05-30	1
2702	158	40481087	2017-08-17	2017-09-07	1
4214	245	40481087	1987-07-29	1987-08-05	1
59112	3510	40481087	1958-05-15	1958-05-29	1
2443	144	40481087	1987-01-22	1987-01-29	1
59670	3539	4112343	2006-04-29	2006-05-10	1
1609	95	4109685	1990-09-19	1990-10-03	1
6817	403	4112343	1992-03-25	1992-04-07	1
55004	3259	40481087	1995-02-16	1995-03-02	1
2965	173	260139	1983-11-03	1983-11-10	1
58099	3444	260139	2013-08-07	2013-08-21	1
60339	3572	40481087	1964-10-22	1964-11-12	1
29752	1762	4112343	1964-06-28	1964-07-08	1
2287	133	40481087	2001-05-08	2001-05-22	1
58987	3504	4112343	1979-02-14	1979-02-21	1
32846	1951	40481087	2015-12-22	2016-01-05	1
63550	3756	40481087	2018-04-28	2018-05-19	1
623	35	40481087	1983-12-01	1983-12-15	1
85640	5099	40481087	1953-01-17	1953-01-24	1
4052	235	4283893	1988-06-30	1988-08-04	1
8356	487	40481087	2000-05-09	2000-05-23	1
64195	3793	40481087	1943-01-20	1943-01-27	1
3383	194	4278672	1990-03-12	1990-04-11	1
85468	5086	372328	1974-02-24	1974-09-05	1
2939	171	80180	2007-12-21	2007-12-22	1
56160	3332	28060	1998-06-19	1998-06-28	1
53606	3177	257012	1968-07-02	1968-07-03	1
38585	2292	78272	1988-08-03	1988-08-31	1
58169	3446	4294548	1971-08-05	1971-12-16	1
3637	209	40481087	1987-03-30	1987-04-13	1
66153	3920	40481087	1977-12-27	1978-01-03	1
61013	3614	4112343	2002-04-09	2002-04-20	1
790	42	4112343	1988-10-15	1988-10-26	1
57525	3417	260139	1989-03-28	1989-04-04	1
4419	260	260139	1979-09-06	1979-09-13	1
55545	3293	372328	1917-04-19	1918-03-02	1
36305	2152	313217	2008-02-23	2008-02-24	1
59522	3531	40481087	1994-01-27	1994-02-03	1
69530	4119	375671	1978-05-14	1978-07-13	1
270	12	4027663	1997-01-21	1997-01-22	1
65290	3865	40481087	1994-08-03	1994-08-24	1
2123	123	4149245	1962-07-08	1962-09-13	1
1754	101	4112343	1942-01-31	1942-02-07	1
59247	3516	40481087	2012-12-03	2012-12-17	1
61942	3660	260139	2006-06-30	2006-07-14	1
92	3	378001	1938-11-24	1939-01-23	1
61538	3639	260139	1994-03-15	1994-03-22	1
2772	160	4056621	1992-10-21	1992-10-22	1
58594	3477	40481087	1993-06-28	1993-07-05	1
1220	70	4027663	1976-04-04	1976-04-05	1
88991	5300	4112343	1979-05-28	1979-06-04	1
60781	3601	4112343	1992-10-11	1992-10-19	1
67913	4017	40481087	2013-11-22	2013-12-13	1
86359	5144	40481087	1983-03-07	1983-03-14	1
3249	189	40481087	2004-02-07	2004-02-28	1
78748	4668	40481087	2012-12-09	2012-12-30	1
63179	3734	40481087	1954-06-25	1954-07-09	1
2703	158	78272	1950-02-17	1950-03-10	1
4215	245	40481087	2007-01-13	2007-01-27	1
59113	3510	40481087	1991-01-13	1991-01-20	1
2444	144	40481087	1990-04-03	1990-04-17	1
59671	3539	260139	2000-10-14	2000-10-28	1
1610	95	4113008	1968-12-29	1969-01-12	1
6818	403	4112343	2004-02-07	2004-02-16	1
55005	3259	260139	1977-07-15	1977-07-29	1
2966	173	4112343	1994-11-11	1994-11-24	1
58100	3444	260139	2019-03-03	2019-03-17	1
60340	3572	4027663	1986-03-14	1986-03-15	1
29753	1762	4112343	1969-12-24	1969-12-31	1
7498	442	192671	1985-09-10	1985-09-11	1
58988	3504	40481087	1943-08-03	1943-08-17	1
32847	1951	81151	1985-10-19	1985-11-09	1
63551	3756	0	2017-12-03	2017-12-04	1
624	35	40481087	1990-10-23	1990-11-06	1
85641	5099	40481087	1992-09-23	1992-10-07	1
4053	235	4296204	1984-06-24	1984-07-29	1
8357	487	40481087	2018-07-30	2018-08-20	1
64196	3793	40481087	2011-03-03	2011-03-24	1
3384	194	40481087	2008-03-17	2008-03-24	1
85469	5086	4112343	1976-11-18	1976-12-01	1
2940	171	4109685	1994-05-15	1994-06-05	1
56161	3332	260139	1987-12-15	1987-12-29	1
53607	3177	260139	1936-05-16	1936-05-30	1
38586	2292	260139	1965-09-07	1965-09-21	1
58170	3446	40481087	1991-11-23	1991-12-14	1
3638	209	260139	1958-10-15	1958-10-22	1
66154	3920	40481087	2003-01-10	2003-01-31	1
61014	3614	4296204	1967-12-19	1968-01-23	1
791	42	4218389	1935-09-08	1935-10-06	1
57526	3417	4112343	1916-10-09	1916-10-17	1
4420	260	372328	1971-03-15	1971-06-19	1
55546	3293	4059173	1944-02-27	1944-03-28	1
36306	2152	381316	1988-01-23	1988-01-24	1
64702	3831	81893	1990-09-13	1990-09-14	1
69531	4119	440448	1976-07-15	1976-07-16	1
271	12	4116491	2002-01-20	2002-03-13	1
65291	3865	40481087	2010-11-28	2010-12-19	1
2124	123	40481087	1957-07-09	1957-07-23	1
1755	101	4112343	2003-08-25	2003-09-07	1
59248	3516	40481087	2014-03-20	2014-04-03	1
61943	3660	4218389	2017-10-09	2017-11-13	1
93	3	440448	1972-12-20	1972-12-21	1
61539	3639	260139	1999-12-27	2000-01-10	1
2773	160	4116491	1992-07-19	1992-09-16	1
64366	3807	260139	1951-10-27	1951-11-10	1
1221	70	4112343	1968-09-18	1968-09-26	1
88992	5300	4155034	2015-04-19	2015-05-03	1
60782	3601	4116491	1980-06-13	1980-07-28	1
67914	4017	257012	1970-08-27	1970-08-28	1
86360	5144	40481087	2018-03-16	2018-04-06	1
3250	189	80180	1992-03-18	1992-03-19	1
79003	4682	28060	1996-02-21	1996-03-01	1
65740	3891	260139	2002-08-12	2002-08-19	1
2704	158	80180	1983-11-11	1983-11-12	1
4216	245	80180	1954-06-24	1954-06-25	1
59114	3510	40481087	1999-07-16	1999-07-30	1
2445	144	195588	2010-12-11	2011-01-11	1
59672	3539	372328	1983-12-27	1984-05-18	1
1611	95	40481087	1964-05-01	1964-05-08	1
6819	403	4112343	2016-08-15	2016-08-23	1
55006	3259	372328	1966-12-23	1967-01-06	1
2967	173	4112343	1996-06-19	1996-06-28	1
58101	3444	4294548	1963-09-01	1963-09-15	1
60341	3572	4237458	1984-01-20	1984-02-19	1
29754	1762	80180	1979-10-12	1979-10-13	1
7499	442	257012	2013-04-19	2013-04-20	1
58989	3504	40481087	1988-03-29	1988-04-12	1
32848	1951	4278672	2015-04-11	2015-07-10	1
63552	3756	28060	1948-09-07	1948-09-16	1
625	35	40481087	1993-11-27	1993-12-11	1
87153	5195	78272	1963-12-28	1964-01-18	1
4054	235	0	1992-05-08	1992-05-09	1
8358	487	80180	2000-01-26	2000-01-27	1
66792	3956	28060	1928-07-31	1928-08-07	1
3385	194	28060	1991-11-11	1991-11-19	1
85470	5086	4112343	1980-12-27	1981-01-09	1
2941	171	4112343	1996-08-17	1996-08-28	1
56162	3332	372328	1962-04-30	1962-05-14	1
53608	3177	260139	1980-02-21	1980-02-28	1
38587	2292	4112343	1975-08-15	1975-08-25	1
58171	3446	40481087	1997-11-19	1997-12-10	1
3639	209	321042	1976-12-31	1977-01-01	1
66155	3920	260139	2004-05-17	2004-05-31	1
61015	3614	40481087	1951-06-22	1951-06-29	1
792	42	40481087	1980-08-10	1980-08-17	1
57527	3417	4142905	2014-06-17	2014-07-17	1
4421	260	378001	1972-05-11	1972-07-10	1
55547	3293	4112343	1917-08-19	1917-08-31	1
36307	2152	4112343	1939-03-25	1939-04-06	1
64703	3831	257012	1997-04-21	1997-04-22	1
69532	4119	4112343	1968-05-18	1968-05-31	1
272	12	4285898	2007-05-14	2007-05-15	1
65292	3865	4112343	1986-04-25	1986-05-05	1
2125	123	40481087	1958-09-25	1958-10-16	1
1756	101	4218389	1965-04-17	1965-05-08	1
59249	3516	40481087	2015-11-29	2015-12-20	1
61944	3660	40481087	1979-10-21	1979-11-04	1
94	3	4059173	1950-01-25	1950-02-24	1
61540	3639	260139	2002-09-06	2002-09-20	1
2774	160	4146173	1965-05-07	1965-07-06	1
64367	3807	260139	1958-06-09	1958-06-23	1
1222	70	4283893	1999-08-31	2000-03-14	1
88993	5300	40481087	1971-11-05	1971-11-19	1
60783	3601	4294548	2017-05-21	2017-07-09	1
67915	4017	260139	1936-05-08	1936-05-22	1
87812	5230	28060	1994-01-05	1994-01-16	1
3251	189	378001	2003-08-25	2003-10-24	1
79004	4682	80180	2011-11-02	2011-11-03	1
65741	3891	4051466	1984-11-30	2002-03-05	1
2705	158	260139	1953-08-31	1953-09-14	1
4217	245	81151	1968-06-13	1968-07-18	1
59115	3510	28060	1935-09-07	1935-09-18	1
2446	144	260139	1984-01-21	1984-01-28	1
59673	3539	40481087	1981-07-15	1981-07-29	1
1612	95	40481087	1978-04-18	1978-04-25	1
6820	403	4134304	1946-03-28	1946-05-27	1
55007	3259	4112343	1981-12-21	1981-12-31	1
2968	173	4142905	1977-11-02	1978-01-01	1
58102	3444	40481087	1966-07-07	1966-07-21	1
60342	3572	4266809	1993-08-29	1993-08-30	1
29755	1762	260139	1948-08-22	1948-09-05	1
7500	442	260139	1964-02-27	1964-03-12	1
58990	3504	40481087	1988-12-17	1989-01-07	1
32849	1951	40481087	1985-11-23	1985-12-14	1
63553	3756	28060	1949-09-14	1949-09-24	1
626	35	80180	1997-05-02	1997-05-03	1
87154	5195	192671	1995-07-26	1995-07-27	1
4055	235	28060	1986-04-19	1986-04-30	1
8359	487	4112343	2008-02-26	2008-03-04	1
66793	3956	257012	1974-09-12	1974-09-13	1
3386	194	4112343	1990-01-07	1990-01-19	1
85471	5086	40481087	1996-09-23	1996-09-30	1
2942	171	4156265	2000-03-04	2000-03-18	1
56163	3332	4112343	2011-05-06	2011-05-14	1
53609	3177	260139	1984-03-27	1984-04-10	1
38588	2292	4112343	2003-08-30	2003-09-12	1
58172	3446	40481087	2004-11-11	2004-11-18	1
3640	209	372328	1992-04-18	1993-03-05	1
66156	3920	4112343	1997-07-27	1997-08-08	1
61016	3614	40481087	2009-11-17	2009-12-08	1
793	42	40481087	1994-03-26	1994-04-16	1
57528	3417	4237458	1980-06-15	1980-07-15	1
4422	260	4112343	1992-02-08	1992-02-19	1
55548	3293	4112343	1927-10-08	1927-10-20	1
36308	2152	4112343	1995-11-25	1995-12-06	1
64704	3831	260139	2013-03-18	2013-03-25	1
69533	4119	4112343	2011-01-01	2011-01-12	1
3867	224	80180	1977-02-21	1977-02-22	1
65293	3865	4112343	1991-11-09	1991-11-22	1
2126	123	40481087	1986-01-05	1986-01-26	1
1757	101	40481087	1991-01-07	1991-01-28	1
59475	3530	28060	1980-10-05	1980-10-18	1
61945	3660	40481087	1999-08-28	1999-09-18	1
95	3	4112343	1991-12-11	1991-12-18	1
61541	3639	372328	1924-05-31	1924-07-19	1
2775	160	4237458	2016-08-05	2016-09-04	1
64368	3807	4027663	1978-09-13	1978-09-14	1
1223	70	40481087	2005-02-23	2005-03-09	1
88994	5300	40481087	1974-01-13	1974-01-27	1
60784	3601	40481087	1967-05-13	1967-06-03	1
67916	4017	260139	1986-10-14	1986-10-21	1
87813	5230	80180	1981-02-13	1981-02-14	1
3252	189	4112343	2003-03-27	2003-04-03	1
79005	4682	81151	1984-03-23	1984-04-06	1
65742	3891	4112343	1988-10-24	1988-11-05	1
2706	158	40481087	1948-07-05	1948-07-19	1
4218	245	260139	1917-05-16	1917-05-30	1
59116	3510	80502	2015-11-27	2015-11-28	1
2447	144	260139	2010-07-21	2010-07-28	1
59674	3539	40481087	2006-01-25	2006-02-01	1
1613	95	40481087	1994-11-25	1994-12-16	1
6821	403	4156265	1939-10-10	1939-10-31	1
55008	3259	4112343	2003-05-22	2003-06-02	1
2969	173	28060	1968-04-27	1968-05-04	1
58103	3444	40481087	1978-09-19	1978-09-26	1
60343	3572	40481087	1999-06-22	1999-07-06	1
29756	1762	261325	1961-03-09	1961-03-10	1
7501	442	260139	1974-12-18	1974-12-25	1
58991	3504	80180	1956-04-29	1956-04-30	1
32850	1951	28060	1991-04-25	1991-05-08	1
63554	3756	260139	1943-11-07	1943-11-21	1
627	35	260139	1978-11-14	1978-11-28	1
87155	5195	4027663	1987-02-10	1987-02-11	1
4056	235	28060	1991-10-15	1991-10-27	1
8360	487	4294548	1993-11-10	1994-04-06	1
66794	3956	260139	1932-12-26	1933-01-09	1
3387	194	40481087	2008-11-24	2008-12-08	1
86079	5128	260139	1966-08-22	1966-08-29	1
2943	171	260139	1981-10-30	1981-11-06	1
56164	3332	4149245	2014-06-08	2014-08-14	1
53610	3177	372328	1917-03-16	1917-06-27	1
38589	2292	4112343	2009-08-13	2009-08-26	1
61633	3644	0	1982-02-24	1982-02-25	1
3641	209	381316	1992-07-31	1992-08-01	1
66157	3920	4218389	2012-11-24	2012-12-29	1
61017	3614	28060	1958-06-11	1958-06-20	1
794	42	40481087	2008-02-22	2008-02-29	1
57529	3417	40480160	2014-06-17	2014-07-17	1
4423	260	257012	1982-04-13	1982-04-14	1
55549	3293	4112343	1984-07-30	1984-08-11	1
36309	2152	4112343	2010-08-20	2010-08-28	1
64705	3831	378001	1989-04-17	1989-06-16	1
69534	4119	4112343	2015-08-04	2015-08-16	1
3868	224	257012	1990-11-07	1990-11-08	1
65294	3865	4283893	1970-12-29	1971-03-09	1
2127	123	40481087	1991-03-09	1991-03-30	1
1758	101	40481087	2008-07-30	2008-08-06	1
59476	3530	321042	2003-01-03	2003-01-04	1
61946	3660	40481087	2001-12-14	2001-12-28	1
96	3	4112343	2004-01-18	2004-01-26	1
61542	3639	378001	1975-02-24	1975-03-26	1
2776	160	4294548	1969-01-24	1969-02-21	1
64369	3807	4059173	1956-01-02	1956-03-02	1
2921	170	372328	1971-12-31	1972-04-13	1
88995	5300	198809	1945-02-13	1945-02-13	1
60785	3601	40481087	1998-07-24	1998-07-31	1
67917	4017	313217	1998-04-09	1998-04-10	1
87814	5230	4112343	1953-03-25	1953-04-05	1
3253	189	4237458	1970-01-08	1970-02-07	1
79006	4682	4112343	1997-02-25	1997-03-04	1
65743	3891	4155034	2007-10-14	2007-11-04	1
2707	158	260139	1954-07-13	1954-07-20	1
4219	245	260139	1961-07-08	1961-07-15	1
59117	3510	260139	1983-01-22	1983-02-05	1
2448	144	372328	1977-02-07	1977-05-27	1
62604	3701	78272	1996-07-23	1996-08-27	1
1614	95	40481087	2002-03-18	2002-04-08	1
6822	403	40481087	1935-08-08	1935-08-22	1
55009	3259	40481087	1967-12-25	1968-01-08	1
2970	173	28060	1976-10-23	1976-11-03	1
58104	3444	40481087	2012-08-17	2012-09-07	1
62005	3666	80180	2000-11-05	2000-11-06	1
29757	1762	4112343	1952-08-01	1952-08-12	1
7502	442	4112343	1970-12-23	1971-01-04	1
58992	3504	4059173	1939-11-15	1940-01-14	1
32851	1951	80180	2013-10-27	2013-10-28	1
63555	3756	260139	1968-12-13	1968-12-27	1
628	35	260139	2007-02-25	2007-03-04	1
87156	5195	4230399	2015-09-08	2015-12-07	1
4057	235	260139	2008-06-02	2008-06-16	1
8361	487	40481087	1991-12-28	1992-01-11	1
66795	3956	372328	1920-08-29	1920-10-24	1
3388	194	28060	1986-06-18	1986-06-25	1
86080	5128	260139	1993-01-11	1993-01-25	1
2944	171	4112343	1991-05-26	1991-06-02	1
56165	3332	40481087	1969-09-10	1969-09-24	1
53611	3177	4027663	1941-07-13	1941-07-14	1
38590	2292	4152936	2007-02-05	2007-02-19	1
61634	3644	134438	1974-01-22	1975-01-17	1
3642	209	440086	1962-02-20	1962-06-19	1
66158	3920	4237458	2009-11-10	2010-01-09	1
61018	3614	80180	1989-11-03	1989-11-04	1
795	42	40481087	2010-02-24	2010-03-03	1
57530	3417	40481087	1928-07-01	1928-07-08	1
4424	260	4059173	2015-04-08	2015-07-07	1
55550	3293	257012	1927-03-10	1927-03-11	1
36310	2152	4166224	1962-02-03	1962-02-04	1
64706	3831	80180	1991-04-11	1991-04-12	1
69535	4119	4152936	1981-04-28	1981-05-12	1
3869	224	260139	1985-12-28	1986-01-11	1
65295	3865	40481087	1978-11-04	1978-11-11	1
2128	123	40481087	2005-01-23	2005-01-30	1
1759	101	28060	1983-04-17	1983-04-25	1
59477	3530	4146173	1972-10-03	1972-11-02	1
61947	3660	40481087	2016-02-15	2016-02-29	1
97	3	4112343	2008-10-05	2008-10-13	1
61543	3639	40481087	1972-12-11	1972-12-18	1
2777	160	4294548	1985-11-20	1986-05-14	1
64370	3807	4112343	1966-12-20	1967-01-02	1
2922	170	4116491	1996-01-29	1996-03-18	1
88996	5300	260139	1965-04-09	1965-04-23	1
60786	3601	40486433	1964-06-24	1964-06-25	1
67918	4017	4112343	1942-11-10	1942-11-21	1
87815	5230	4112343	1990-01-22	1990-02-02	1
3254	189	40481087	1998-03-17	1998-03-31	1
79007	4682	81151	2008-11-10	2008-11-24	1
65744	3891	40481087	1984-04-23	1984-05-07	1
2708	158	260139	1967-10-12	1967-10-19	1
4220	245	4112343	2005-06-16	2005-06-23	1
59118	3510	4027663	1960-03-01	1960-03-02	1
2449	144	40481087	1989-06-25	1989-07-02	1
62605	3701	260139	1986-03-26	1986-04-02	1
1615	95	81893	1991-10-15	1991-10-16	1
6823	403	40481087	1950-11-06	1950-11-13	1
55010	3259	40481087	1997-02-26	1997-03-19	1
2971	173	80180	2003-07-04	2003-07-05	1
58105	3444	40481087	2015-07-29	2015-08-19	1
62006	3666	378001	1969-07-02	1969-08-31	1
29758	1762	4112343	1977-06-23	1977-07-02	1
7503	442	4112343	2015-09-29	2015-10-09	1
58993	3504	4296204	1993-12-01	1993-12-29	1
32852	1951	260139	1995-11-27	1995-12-11	1
63556	3756	261325	2003-04-26	2003-04-27	1
629	35	4112343	1988-06-24	1988-07-02	1
87157	5195	40481087	2009-04-08	2009-04-29	1
4058	235	372328	1984-07-24	1984-10-15	1
8362	487	28060	1972-08-12	1972-08-22	1
66796	3956	372328	1974-12-10	1975-01-05	1
3389	194	257012	2010-11-27	2010-11-28	1
86081	5128	4112343	1963-06-29	1963-07-06	1
2945	171	40481087	1975-03-11	1975-04-01	1
56166	3332	40481087	1982-07-13	1982-07-20	1
53612	3177	4112343	1932-01-27	1932-02-04	1
38591	2292	40481087	2015-02-20	2015-03-06	1
61635	3644	260139	1956-08-03	1956-08-17	1
3643	209	4112343	1951-04-26	1951-05-03	1
66159	3920	40481087	1977-07-07	1977-07-21	1
61019	3614	260139	1959-11-25	1959-12-02	1
796	42	0	1933-10-29	1933-10-30	1
57531	3417	40481087	1979-04-05	1979-04-19	1
4425	260	4112343	1986-05-18	1986-05-25	1
55551	3293	381316	2006-11-25	2006-11-26	1
36311	2152	40481087	1927-11-21	1927-11-28	1
64707	3831	260139	1958-03-11	1958-03-25	1
69536	4119	40481087	1951-04-25	1951-05-16	1
3870	224	372328	1946-05-28	1946-10-01	1
65296	3865	80180	1990-04-06	1990-04-07	1
3898	225	28060	2013-09-25	2013-10-02	1
1760	101	28060	2007-01-22	2007-02-01	1
59478	3530	0	2003-01-03	2003-01-04	1
63308	3744	81893	2003-08-17	2003-08-18	1
98	3	4218389	1987-11-28	1987-12-26	1
61544	3639	40481087	1975-10-04	1975-10-25	1
6314	371	192671	2008-05-27	2008-05-28	1
64371	3807	40481087	1983-06-07	1983-06-28	1
2923	170	40481087	1979-03-29	1979-04-19	1
88997	5300	4112343	1962-02-16	1962-02-25	1
66282	3928	40481087	2016-03-18	2016-03-25	1
67919	4017	40479422	1934-01-17	1934-03-25	1
87816	5230	4112343	1991-07-10	1991-07-17	1
3255	189	372328	1959-04-06	1959-07-19	1
79008	4682	260139	2001-05-10	2001-05-24	1
65745	3891	40481087	1996-03-26	1996-04-16	1
2709	158	260139	1995-03-23	1995-04-06	1
4221	245	4230399	1984-02-25	1984-04-25	1
59119	3510	4059173	1951-02-12	1951-04-13	1
2450	144	40481087	2010-10-13	2010-11-03	1
62606	3701	4134304	1955-12-16	1956-02-14	1
1616	95	260139	1979-02-24	1979-03-03	1
6824	403	40481087	1963-02-15	1963-03-08	1
55011	3259	40481087	2011-08-08	2011-08-22	1
2972	173	260139	2001-02-02	2001-02-09	1
58106	3444	40481087	2018-01-14	2018-01-21	1
62007	3666	4112343	1969-04-29	1969-05-12	1
29759	1762	4112343	1996-03-29	1996-04-11	1
7504	442	4218389	1951-06-03	1951-07-01	1
58994	3504	4310024	1954-11-06	1954-11-07	1
32853	1951	372328	1987-02-25	1987-04-29	1
63557	3756	372328	1944-09-09	1944-11-11	1
630	35	4116491	1997-03-13	1997-04-29	1
87158	5195	80180	1995-05-29	1995-05-30	1
4059	235	4029498	1992-05-08	1992-05-09	1
8363	487	260139	1972-09-11	1972-09-25	1
66797	3956	4112343	1930-01-01	1930-01-09	1
3390	194	4112343	1998-06-01	1998-06-12	1
86082	5128	4113008	1983-05-28	1983-06-18	1
2946	171	40481087	1988-05-31	1988-06-14	1
56167	3332	40481087	2011-09-21	2011-10-05	1
53613	3177	4112343	1949-04-21	1949-05-02	1
38592	2292	28060	1966-11-02	1966-11-15	1
61636	3644	260139	1965-09-05	1965-09-12	1
3644	209	40481087	2000-08-20	2000-09-10	1
66160	3920	28060	1976-07-07	1976-07-16	1
61020	3614	260139	2008-03-30	2008-04-13	1
797	42	28060	1985-05-25	1985-06-01	1
57532	3417	40481087	1993-09-10	1993-09-24	1
4426	260	4112343	1991-01-31	1991-02-10	1
55552	3293	4112343	1921-09-23	1921-10-05	1
36312	2152	40481087	1978-01-02	1978-01-16	1
64708	3831	4112343	1955-09-24	1955-10-06	1
69537	4119	40481087	1984-08-12	1984-08-19	1
3871	224	4029498	1954-10-10	1954-10-11	1
65297	3865	260139	1985-12-10	1985-12-24	1
3899	225	81151	1965-11-30	1965-12-28	1
1761	101	260139	1955-02-17	1955-02-24	1
59479	3530	80180	1995-04-30	1995-05-01	1
63309	3744	260139	1971-06-23	1971-06-30	1
99	3	4278672	1986-10-04	1986-12-03	1
61545	3639	81151	1980-12-24	1981-01-07	1
6315	371	40481087	1975-06-20	1975-07-04	1
64372	3807	40481087	2006-04-18	2006-05-09	1
2924	170	40481087	1991-07-14	1991-08-04	1
88998	5300	40481087	1962-03-05	1962-03-19	1
66283	3928	28060	2006-06-02	2006-06-14	1
67920	4017	40481087	1959-10-25	1959-11-15	1
87817	5230	4278672	1961-09-06	1961-11-05	1
3256	189	4112343	1959-10-06	1959-10-19	1
79009	4682	260139	2008-05-24	2008-06-07	1
65746	3891	80180	2019-06-03	2019-06-04	1
2710	158	4112343	1955-05-05	1955-05-17	1
4222	245	4230399	2015-09-20	2015-10-20	1
59120	3510	4218389	1956-02-16	1956-03-22	1
2451	144	81151	1978-10-30	1978-11-20	1
62607	3701	4283893	1997-08-29	1997-12-26	1
1617	95	40481087	2018-07-22	2018-07-29	1
6825	403	40481087	1964-10-05	1964-10-19	1
55252	3277	81151	1998-11-19	1998-12-10	1
2973	173	260139	2011-07-10	2011-07-24	1
58107	3444	381316	2018-10-29	2018-10-30	1
62008	3666	4112343	1989-02-08	1989-02-16	1
29760	1762	4152936	2012-05-16	2012-05-30	1
7505	442	4283893	1951-01-11	1951-02-01	1
58995	3504	40481087	1939-11-24	1939-12-15	1
32854	1951	4112343	1995-05-21	1995-06-02	1
63558	3756	440448	2017-12-03	2017-12-04	1
631	35	4310024	1995-12-09	1995-12-10	1
87159	5195	81893	1994-03-05	1994-03-06	1
4060	235	4112343	1988-10-19	1988-10-30	1
8364	487	260139	1988-08-10	1988-08-24	1
66798	3956	4112343	1987-08-25	1987-09-02	1
3391	194	4283893	2010-11-06	2011-01-22	1
86083	5128	4230399	2019-05-08	2019-06-07	1
2947	171	260139	2001-01-03	2001-01-17	1
56168	3332	40481087	2016-05-19	2016-06-09	1
53614	3177	4116491	1948-09-04	1948-10-25	1
38593	2292	80180	2006-06-22	2006-06-23	1
61637	3644	260139	1975-05-29	1975-06-12	1
3645	209	4112343	1954-09-18	1954-09-26	1
66161	3920	372328	1974-05-18	1974-08-03	1
61021	3614	372328	1953-12-01	1954-04-11	1
798	42	80180	1950-05-16	1950-05-17	1
57533	3417	28060	1917-04-18	1917-04-29	1
4427	260	40481087	1991-05-31	1991-06-21	1
55553	3293	4237458	2005-06-23	2005-07-23	1
36313	2152	40481087	1978-10-22	1978-11-05	1
64709	3831	4294548	2011-10-10	2011-12-19	1
69538	4119	40481087	2003-12-09	2003-12-16	1
3872	224	4109685	1996-02-19	1996-03-04	1
65298	3865	4283893	2009-08-13	2009-09-17	1
3900	225	81151	1973-08-09	1973-08-30	1
1762	101	313217	2010-06-25	2010-06-26	1
59480	3530	257012	1993-07-04	1993-07-05	1
63310	3744	4112343	1998-01-14	1998-01-22	1
100	3	4294548	1967-09-30	1967-11-04	1
61546	3639	260139	1995-08-15	1995-08-29	1
6316	371	28060	1980-04-13	1980-04-23	1
64373	3807	28060	1953-07-04	1953-07-14	1
2925	170	28060	2003-12-21	2004-01-02	1
88999	5300	40481087	1984-06-29	1984-07-06	1
66284	3928	81151	2005-03-27	2005-05-01	1
67921	4017	40481087	2012-11-01	2012-11-22	1
87818	5230	40481087	1947-10-29	1947-11-19	1
3257	189	40481087	1972-06-02	1972-06-09	1
79010	4682	4156265	2000-09-09	2000-09-23	1
65747	3891	4084167	1998-01-04	1998-01-04	1
2711	158	4155034	1975-02-09	1975-02-23	1
4223	245	40481087	1969-01-29	1969-02-05	1
59121	3510	40481087	1973-04-18	1973-04-25	1
2452	144	260139	1980-10-21	1980-11-04	1
62608	3701	40479422	1984-12-18	1985-01-24	1
1618	95	28060	1965-11-18	1965-11-25	1
6826	403	40481087	1984-04-14	1984-04-21	1
55253	3277	260139	1990-03-06	1990-03-13	1
2974	173	372328	1971-01-08	1971-02-28	1
58108	3444	4112343	1961-07-06	1961-07-18	1
62009	3666	4112343	2013-03-27	2013-04-08	1
29761	1762	40481087	1979-01-29	1979-02-19	1
7506	442	40481087	2007-12-05	2007-12-19	1
58996	3504	40481087	1999-05-20	1999-05-27	1
32855	1951	4142905	1993-05-31	1993-07-30	1
63559	3756	4112343	1999-05-07	1999-05-19	1
632	35	40481087	2002-07-03	2002-07-17	1
87160	5195	257012	1975-01-14	1975-01-15	1
4061	235	40481087	1982-05-12	1982-05-19	1
8365	487	372328	1969-03-29	1969-04-23	1
66799	3956	4112343	1995-08-24	1995-09-01	1
4652	273	28060	2002-07-25	2002-08-02	1
86084	5128	4283893	1983-12-07	1984-01-04	1
2948	171	4156265	1983-06-21	1983-07-12	1
56169	3332	78272	1983-01-01	1983-01-22	1
53615	3177	4296205	1942-03-10	1942-03-24	1
38594	2292	260139	1984-05-13	1984-05-27	1
61638	3644	28060	1947-11-21	1947-12-01	1
3646	209	4112343	1960-02-28	1960-03-07	1
66162	3920	80180	2011-01-09	2011-01-10	1
61022	3614	4112343	1986-05-12	1986-05-24	1
799	42	257012	1969-12-05	1969-12-06	1
57534	3417	28060	1947-04-17	1947-04-26	1
4428	260	40481087	2016-07-15	2016-07-29	1
55554	3293	4278672	2000-10-17	2000-12-16	1
36314	2152	81151	1992-07-01	1992-07-15	1
64710	3831	40481087	1987-10-25	1987-11-08	1
69539	4119	260139	2001-10-22	2001-10-29	1
3873	224	4112343	1975-02-19	1975-03-04	1
65299	3865	40481087	1964-06-21	1964-06-28	1
3901	225	260139	1973-10-21	1973-10-28	1
1763	101	4218389	1955-06-20	1955-07-25	1
59481	3530	4218389	1981-06-18	1981-07-23	1
63311	3744	40481087	1975-10-04	1975-10-18	1
101	3	40480160	2010-08-27	2010-10-26	1
61547	3639	313217	2004-01-31	2004-02-01	1
6317	371	80180	2008-05-11	2008-05-12	1
64374	3807	80180	1988-06-27	1988-06-28	1
2926	170	80180	2009-04-15	2009-04-16	1
89000	5300	196456	1945-02-13	1945-02-13	1
66285	3928	4001336	2009-05-10	2009-07-09	1
67922	4017	80180	1963-08-13	1963-08-14	1
87819	5230	40481087	1949-08-15	1949-09-05	1
3258	189	40481087	1975-06-02	1975-06-16	1
79011	4682	40481087	1984-01-28	1984-02-18	1
65748	3891	4237458	1986-11-03	1987-01-02	1
2712	158	4218389	2001-10-18	2001-11-08	1
4224	245	40481087	1987-03-04	1987-03-25	1
59122	3510	30753	1971-03-19	1971-03-20	1
2453	144	4112343	2000-09-23	2000-10-06	1
62609	3701	40481087	1971-11-22	1971-12-13	1
1619	95	260139	1973-11-04	1973-11-11	1
6827	403	40481087	1984-12-23	1985-01-13	1
55254	3277	40481087	1987-04-09	1987-04-30	1
2975	173	4112343	1986-09-15	1986-09-22	1
58109	3444	4112343	1962-09-15	1962-09-25	1
62010	3666	4112343	2017-01-21	2017-01-28	1
29762	1762	40481087	1989-05-25	1989-06-15	1
7507	442	81151	1997-05-28	1997-07-02	1
59364	3526	81151	1974-05-09	1974-05-30	1
32856	1951	4218389	2012-01-22	2012-02-26	1
63560	3756	4112343	2003-10-27	2003-11-09	1
3135	185	28060	1982-09-24	1982-10-07	1
87161	5195	260139	1985-04-07	1985-04-14	1
4062	235	40481087	1984-03-14	1984-03-21	1
8366	487	372328	1971-03-14	1971-05-05	1
66800	3956	4283893	2011-02-22	2011-03-15	1
4653	273	80180	2011-09-25	2011-09-26	1
86085	5128	40481087	1964-09-16	1964-10-07	1
2949	171	4027663	2001-03-02	2001-03-03	1
56170	3332	80180	1999-04-16	1999-04-17	1
53616	3177	40481087	1920-10-30	1920-11-06	1
38595	2292	260139	2001-12-26	2002-01-09	1
61639	3644	80180	1981-10-25	1981-10-26	1
3647	209	4116491	1985-02-14	1985-04-09	1
66163	3920	260139	1975-04-14	1975-04-21	1
66253	3927	81151	1977-01-16	1977-01-30	1
800	42	260139	1953-06-19	1953-07-03	1
57535	3417	80180	1948-12-28	1948-12-29	1
4429	260	81151	1971-06-02	1971-06-16	1
55555	3293	4283893	1948-12-14	1949-01-18	1
36315	2152	260139	1972-11-25	1972-12-09	1
64711	3831	40481087	1990-02-03	1990-02-24	1
69540	4119	372328	1946-02-12	1946-06-29	1
3874	224	4142905	2010-06-19	2010-07-19	1
65300	3865	40481087	1968-11-12	1968-12-03	1
3902	225	4283893	1992-08-25	1992-09-29	1
1764	101	4218389	2007-07-23	2007-08-27	1
59482	3530	4294548	1993-06-13	1993-08-08	1
63312	3744	134438	2002-12-27	2004-02-21	1
102	3	40481087	1920-09-16	1920-10-07	1
61548	3639	4112343	2009-09-21	2009-10-01	1
6318	371	4112343	1981-05-22	1981-06-04	1
64375	3807	4035415	1974-08-25	1974-10-24	1
2927	170	4112343	1973-01-26	1973-02-05	1
89001	5300	260139	2007-06-15	2007-06-29	1
66286	3928	0	1995-12-06	1995-12-07	1
67923	4017	378419	2010-05-20	2010-05-21	1
87820	5230	40481087	1985-09-26	1985-10-03	1
3259	189	40481087	1986-11-24	1986-12-08	1
79012	4682	40481087	1994-03-21	1994-04-11	1
65749	3891	4112343	2004-08-17	2004-08-30	1
2713	158	40481087	1952-10-31	1952-11-21	1
4225	245	260139	1991-04-10	1991-04-17	1
59123	3510	260139	1975-08-05	1975-08-19	1
2454	144	40481087	1986-01-28	1986-02-18	1
62610	3701	40481087	1979-07-09	1979-07-30	1
1620	95	372328	1962-10-08	1963-08-15	1
6828	403	81151	2018-01-30	2018-02-13	1
55255	3277	40481087	1991-12-11	1991-12-18	1
2976	173	40481087	2005-08-02	2005-08-16	1
58110	3444	4116491	1996-10-16	1996-11-24	1
62011	3666	4296204	1979-10-08	1979-10-29	1
29763	1762	40481087	2001-01-21	2001-02-11	1
7508	442	134438	1980-08-21	1981-05-21	1
59365	3526	257012	1961-12-12	1961-12-13	1
32857	1951	4283893	1993-06-04	1993-07-02	1
63561	3756	4112343	2004-08-09	2004-08-21	1
3136	185	80180	1986-01-22	1986-01-23	1
87162	5195	260139	1993-09-01	1993-09-15	1
4063	235	40481087	1987-04-11	1987-05-02	1
8367	487	378001	1985-04-04	1985-06-03	1
66801	3956	40481087	1956-07-20	1956-07-27	1
4654	273	133834	1980-03-28	1993-01-19	1
86086	5128	40481087	1982-05-27	1982-06-10	1
2950	171	4112343	1972-03-22	1972-04-03	1
56171	3332	81893	1998-01-21	1998-01-22	1
53617	3177	40481087	1954-01-14	1954-01-28	1
38596	2292	372328	1966-08-31	1966-09-14	1
61640	3644	81151	1977-09-11	1977-10-02	1
3648	209	4296205	2003-01-21	2003-02-04	1
66164	3920	4035415	1989-01-29	1989-02-28	1
66254	3927	372328	1949-04-17	1949-07-05	1
801	42	4112343	1962-12-24	1963-01-03	1
57536	3417	80502	1999-09-04	1999-09-05	1
4430	260	192671	2010-04-04	2010-04-05	1
55556	3293	4285898	1950-03-27	1950-03-28	1
36316	2152	4109685	1933-07-13	1933-07-27	1
64712	3831	260139	1962-07-13	1962-07-27	1
69541	4119	4112343	1948-11-02	1948-11-13	1
3875	224	40481087	1944-06-09	1944-06-23	1
65301	3865	40481087	1982-12-14	1982-12-28	1
3903	225	40481087	1991-05-18	1991-05-25	1
1765	101	4237458	2014-07-21	2014-08-20	1
59483	3530	40481087	1982-05-01	1982-05-08	1
63313	3744	260139	2016-03-03	2016-03-10	1
103	3	40481087	1934-06-02	1934-06-09	1
61549	3639	4155034	1961-02-16	1961-03-09	1
6319	371	260139	1968-08-30	1968-09-13	1
64376	3807	4266809	1988-06-27	1988-06-28	1
2928	170	4112343	1992-09-06	1992-09-15	1
89002	5300	4112343	1948-10-17	1948-10-30	1
66287	3928	80180	2012-08-17	2012-08-18	1
67924	4017	4112343	1927-07-10	1927-07-17	1
87821	5230	80502	2005-11-09	2005-11-10	1
3260	189	40481087	1997-09-20	1997-10-11	1
79013	4682	260139	2005-04-02	2005-04-09	1
65750	3891	40481087	1984-06-13	1984-06-20	1
2714	158	40481087	1976-08-24	1976-09-14	1
4226	245	260139	2012-11-23	2012-11-30	1
59124	3510	4146173	1990-06-20	1990-07-20	1
2455	144	40481087	1999-06-05	1999-06-12	1
62611	3701	260139	2004-10-01	2004-10-08	1
1621	95	4112343	1969-11-06	1969-11-15	1
6829	403	260139	1992-11-09	1992-11-23	1
55256	3277	40481087	2012-06-06	2012-06-20	1
3784	219	0	1974-03-29	1974-03-30	1
58111	3444	40481087	1953-12-26	1954-01-02	1
62012	3666	40481087	1984-09-09	1984-09-23	1
29764	1762	4112343	1967-08-25	1967-09-03	1
7509	442	260139	2011-05-28	2011-06-11	1
59366	3526	372328	1951-05-21	1951-06-04	1
32858	1951	40481087	2015-08-24	2015-09-14	1
63562	3756	4237458	1950-07-02	1950-08-01	1
3137	185	260139	2018-05-23	2018-05-30	1
87163	5195	4112343	1961-09-11	1961-09-20	1
5291	312	81893	2015-08-06	2015-08-07	1
8368	487	4283893	1983-10-21	1983-12-02	1
66802	3956	40481087	1957-01-31	1957-02-21	1
4655	273	192671	2011-10-10	2011-10-11	1
86087	5128	40481087	1993-07-21	1993-07-28	1
2951	171	4112343	2005-06-13	2005-06-20	1
56172	3332	260139	1974-11-24	1974-12-01	1
53618	3177	40481087	1970-07-17	1970-07-31	1
38597	2292	4112343	1997-03-19	1997-03-31	1
61641	3644	192671	1981-12-09	1981-12-10	1
3649	209	40481087	1988-11-09	1988-11-16	1
66165	3920	4294548	1986-05-03	1986-05-10	1
66255	3927	372328	1962-02-27	1962-04-10	1
802	42	4156265	1974-06-13	1974-06-27	1
57537	3417	260139	2004-02-25	2004-03-03	1
4431	260	4027663	2000-07-04	2000-07-05	1
55557	3293	40481087	1923-09-23	1923-10-07	1
36317	2152	4112343	1924-05-05	1924-05-16	1
64713	3831	4237458	1971-08-20	1971-11-18	1
69542	4119	4112343	2000-01-18	2000-01-25	1
3876	224	40481087	1972-07-24	1972-08-14	1
65302	3865	40481087	2001-04-28	2001-05-19	1
3904	225	40481087	2014-06-14	2014-06-21	1
1766	101	40481087	1935-03-09	1935-03-23	1
59484	3530	28060	1972-09-24	1972-10-02	1
63314	3744	4112343	1992-09-30	1992-10-11	1
104	3	40481087	1964-03-28	1964-04-11	1
61550	3639	4283893	1936-12-02	1937-03-24	1
6320	371	4112343	1970-08-23	1970-09-02	1
64377	3807	40481087	1958-10-27	1958-11-10	1
2929	170	4152936	1994-06-03	1994-06-24	1
89003	5300	4112343	1957-02-28	1957-03-10	1
66288	3928	192671	2012-09-11	2012-09-12	1
67925	4017	4112343	2009-04-20	2009-04-27	1
87822	5230	260139	1983-12-12	1983-12-19	1
4761	280	81151	1993-11-18	1993-12-09	1
79014	4682	4155034	2009-12-19	2010-01-02	1
65751	3891	40481087	1998-08-09	1998-08-30	1
2715	158	81151	1961-12-28	1962-01-18	1
4227	245	260139	2014-07-23	2014-07-30	1
59125	3510	4152936	1982-04-19	1982-05-03	1
2456	144	40481087	2009-11-21	2009-12-12	1
62612	3701	4112343	1955-07-23	1955-08-05	1
1622	95	4278672	1969-12-08	1970-03-08	1
6830	403	372328	1922-07-27	1922-11-06	1
55257	3277	80180	2004-09-12	2004-09-13	1
3785	219	260139	1968-08-28	1968-09-11	1
58112	3444	40481087	1954-04-10	1954-05-01	1
62013	3666	260139	1971-10-30	1971-11-06	1
29765	1762	4116491	2002-10-30	2002-12-16	1
7510	442	40481087	1978-10-02	1978-10-23	1
59367	3526	4027663	1977-12-20	1977-12-21	1
34012	2025	28060	1910-11-29	1910-12-10	1
63563	3756	40481087	1970-01-06	1970-01-27	1
3138	185	372328	1948-01-16	1948-04-18	1
87164	5195	4112343	1992-04-27	1992-05-06	1
5292	312	260139	1972-05-24	1972-05-31	1
8369	487	40481087	1989-05-08	1989-05-15	1
66803	3956	40481087	1986-12-21	1986-12-28	1
4656	273	4059173	2002-11-21	2002-12-21	1
86088	5128	40481087	2005-12-06	2005-12-13	1
2952	171	4134304	1979-09-10	1979-10-10	1
56173	3332	4059173	1969-07-22	1969-10-20	1
53619	3177	40481087	1991-08-19	1991-09-02	1
38598	2292	4218389	2018-01-22	2018-02-12	1
61642	3644	260139	1959-11-11	1959-11-18	1
3650	209	40481087	1999-10-28	1999-11-18	1
66166	3920	40481087	1981-09-22	1981-10-06	1
66256	3927	4027663	1972-01-22	1972-01-23	1
803	42	4283893	1969-11-21	1970-01-30	1
57538	3417	378001	1999-06-06	1999-07-06	1
4432	260	4048171	1972-07-18	1988-07-16	1
55558	3293	40481087	1941-11-24	1941-12-15	1
36318	2152	4112343	1959-06-18	1959-06-25	1
64714	3831	4294548	1997-02-24	1997-06-16	1
69543	4119	40481087	1969-11-18	1969-11-25	1
3877	224	28060	1959-07-04	1959-07-17	1
66701	3951	81893	1984-11-08	1984-11-09	1
3905	225	80180	2005-07-13	2005-07-14	1
1767	101	40481087	1940-06-18	1940-07-02	1
59485	3530	260139	1978-11-12	1978-11-26	1
63315	3744	4152936	2019-01-17	2019-01-31	1
105	3	40481087	1981-12-15	1981-12-29	1
61551	3639	4283893	1973-10-22	1974-05-06	1
6321	371	40481087	1971-02-21	1971-03-07	1
64378	3807	30753	1986-12-05	1986-12-06	1
2930	170	40481087	1984-01-30	1984-02-13	1
89004	5300	4112343	1986-07-29	1986-08-10	1
66289	3928	372328	1982-09-24	1982-11-14	1
67926	4017	4152936	1948-11-06	1948-11-27	1
87823	5230	378001	1950-07-06	1950-08-05	1
4762	280	260139	1947-08-13	1947-08-27	1
79015	4682	4283893	1986-10-11	1987-02-21	1
65752	3891	40481087	2005-04-01	2005-04-08	1
2716	158	4112343	2001-03-30	2001-04-09	1
4228	245	372328	1920-06-10	1921-05-29	1
59126	3510	80180	1971-11-14	1971-11-15	1
7320	431	195588	1987-12-22	1988-01-22	1
62613	3701	4112343	1968-06-12	1968-06-21	1
1623	95	40481087	1968-08-24	1968-08-31	1
6831	403	4112343	1940-05-18	1940-05-30	1
55258	3277	4112343	1978-05-11	1978-05-24	1
3786	219	380378	1975-05-24	1975-05-25	1
58113	3444	40481087	1993-02-16	1993-02-23	1
62014	3666	260139	1979-12-16	1979-12-30	1
29766	1762	260139	1967-10-06	1967-10-20	1
7511	442	28060	1955-06-29	1955-07-11	1
59368	3526	4112343	1951-10-20	1951-10-27	1
34013	2025	78272	1943-06-06	1943-06-27	1
64990	3849	81151	2009-10-09	2009-11-13	1
3139	185	4112343	1962-08-29	1962-09-05	1
87165	5195	4283893	1993-09-01	1993-12-22	1
5293	312	260139	2006-12-03	2006-12-10	1
8370	487	40481087	2003-08-12	2003-08-26	1
66804	3956	40481087	2002-01-14	2002-02-04	1
4657	273	4084167	1981-04-15	1981-04-15	1
86089	5128	0	1955-07-27	1955-07-28	1
2953	171	4310024	2006-06-30	2006-07-01	1
56174	3332	4296204	1981-03-21	1981-04-11	1
53620	3177	40481087	1996-11-09	1996-11-23	1
38599	2292	40481087	1986-01-10	1986-01-17	1
61643	3644	372328	1948-11-12	1948-12-29	1
3651	209	40481087	2009-05-02	2009-05-16	1
66167	3920	40481087	1986-01-20	1986-01-27	1
66257	3927	4112343	1957-03-04	1957-03-14	1
804	42	40481087	1960-02-29	1960-03-07	1
57539	3417	4116491	1950-04-07	1950-05-14	1
4433	260	4310024	2008-05-28	2008-05-29	1
55559	3293	40481087	1969-03-10	1969-03-24	1
36319	2152	4112343	2016-02-29	2016-03-08	1
64715	3831	40481087	1965-12-30	1966-01-13	1
69544	4119	40481087	2007-08-06	2007-08-13	1
3878	224	192671	1977-03-03	1977-03-04	1
66702	3951	260139	1997-12-11	1997-12-25	1
3906	225	195588	1986-12-30	1987-02-14	1
1768	101	28060	1995-03-25	1995-04-06	1
59486	3530	317576	1970-05-01	1970-05-02	1
63316	3744	40481087	2018-01-14	2018-01-28	1
106	3	40481087	1985-03-22	1985-03-29	1
61552	3639	4283893	2004-10-28	2005-06-23	1
6322	371	40481087	1987-04-11	1987-04-18	1
64379	3807	195588	1973-09-14	1973-10-23	1
2931	170	81151	1998-04-04	1998-05-02	1
89005	5300	4134304	1942-11-17	1943-02-15	1
66290	3928	440448	1995-12-06	1995-12-07	1
67927	4017	40481087	1927-08-29	1927-09-05	1
87824	5230	4112343	1989-02-09	1989-02-22	1
4763	280	4112343	1982-10-09	1982-10-16	1
79016	4682	257012	1986-11-01	1986-11-02	1
65753	3891	40481087	2018-12-04	2018-12-18	1
2717	158	4156265	1992-06-23	1992-07-07	1
4229	245	378001	1922-04-18	1922-06-17	1
59127	3510	260139	1935-10-06	1935-10-13	1
7321	431	260139	1989-05-04	1989-05-18	1
62614	3701	4112343	2011-07-29	2011-08-06	1
1624	95	80180	1993-06-06	1993-06-07	1
6832	403	4283893	1935-01-09	1935-03-06	1
55259	3277	4134304	1997-10-25	1998-01-23	1
3787	219	4112343	1997-06-11	1997-06-20	1
60175	3566	78272	1954-06-07	1954-07-05	1
62015	3666	40481087	1984-06-27	1984-07-04	1
29767	1762	260139	1982-01-25	1982-02-08	1
7512	442	81151	2010-02-24	2010-03-24	1
59369	3526	4112343	2013-06-01	2013-06-14	1
34014	2025	260139	1938-07-18	1938-08-01	1
64991	3849	195588	2005-11-10	2005-12-21	1
3140	185	4134304	1958-08-07	1958-11-05	1
87166	5195	40481087	1978-05-09	1978-05-16	1
5294	312	372328	1985-01-15	1985-01-29	1
8371	487	28060	2013-10-06	2013-10-16	1
66805	3956	80180	1959-02-10	1959-02-11	1
4658	273	4112343	2004-11-20	2004-11-27	1
86090	5128	372328	1929-08-25	1930-01-15	1
4597	270	81151	1995-08-15	1995-09-05	1
56175	3332	4310024	1997-08-24	1997-08-25	1
55939	3315	80180	1990-10-11	1990-10-12	1
38600	2292	40481087	2008-08-28	2008-09-18	1
61644	3644	4142905	1962-03-04	1962-04-03	1
3652	209	40481087	2009-07-24	2009-08-14	1
66168	3920	40481087	1987-08-11	1987-09-01	1
66258	3927	4112343	2013-08-03	2013-08-12	1
805	42	40481087	1985-10-25	1985-11-01	1
57540	3417	40481087	1948-05-10	1948-05-17	1
4434	260	40479422	1990-08-10	1990-09-16	1
55560	3293	134438	1941-03-16	1943-07-04	1
36320	2152	40481087	1984-12-10	1984-12-31	1
64716	3831	81151	1956-04-19	1956-05-10	1
69545	4119	40481087	2018-06-22	2018-07-06	1
3879	224	260139	2008-02-27	2008-03-12	1
66703	3951	4112343	2013-08-26	2013-09-04	1
3907	225	4001336	2006-03-29	2006-04-28	1
1769	101	260139	1945-06-01	1945-06-08	1
59487	3530	4109685	1968-12-02	1968-12-23	1
63317	3744	260139	1979-09-18	1979-10-02	1
2000	117	4112343	1969-10-03	1969-10-15	1
61553	3639	4294548	1987-02-21	1987-05-09	1
6323	371	28060	1982-04-02	1982-04-09	1
64380	3807	260139	1977-03-06	1977-03-13	1
2932	170	4112343	2001-03-06	2001-03-17	1
89006	5300	4237458	2018-03-18	2018-04-17	1
66291	3928	4112343	1993-10-28	1993-11-06	1
67928	4017	40481087	1995-07-29	1995-08-19	1
87825	5230	4134304	2014-02-14	2014-05-15	1
4764	280	4146173	1991-01-26	1991-04-03	1
79017	4682	260139	1992-05-11	1992-05-25	1
65754	3891	4059173	1984-09-14	1984-12-13	1
2718	158	4278672	1948-10-25	1949-01-23	1
4230	245	4112343	1966-02-10	1966-02-23	1
59128	3510	260139	1970-02-12	1970-02-19	1
7322	431	4112343	1964-09-30	1964-10-11	1
62615	3701	40481087	1981-03-29	1981-04-19	1
1625	95	81151	2002-08-01	2002-08-29	1
6833	403	28060	1932-12-16	1932-12-28	1
55260	3277	40481087	2015-12-28	2016-01-11	1
3788	219	4152936	1974-11-24	1974-12-08	1
60176	3566	260139	1965-09-08	1965-09-22	1
62016	3666	81151	1965-08-31	1965-09-21	1
29768	1762	4112343	1961-02-27	1961-03-12	1
7513	442	260139	1971-07-06	1971-07-20	1
59370	3526	4218389	1966-10-13	1966-11-17	1
34015	2025	260139	2012-04-21	2012-04-28	1
64992	3849	260139	1983-12-07	1983-12-21	1
3141	185	40481087	1947-04-12	1947-05-03	1
87167	5195	40481087	1978-08-23	1978-08-30	1
5295	312	4112343	1975-01-12	1975-01-19	1
8372	487	78272	2009-11-08	2009-11-22	1
66806	3956	260139	1944-09-12	1944-09-19	1
4659	273	4230399	2001-09-27	2001-11-26	1
86091	5128	4112343	1971-03-28	1971-04-06	1
4598	270	4113008	1982-04-13	1982-05-04	1
56176	3332	40481087	1962-12-31	1963-01-07	1
55940	3315	195588	2004-04-15	2004-05-22	1
39500	2343	28060	1965-03-30	1965-04-10	1
61645	3644	40481087	1956-11-07	1956-11-28	1
3653	209	80180	1988-07-08	1988-07-09	1
66169	3920	40481087	1992-05-12	1992-05-19	1
66259	3927	4218389	1948-10-19	1948-11-09	1
2992	176	260139	2013-07-21	2013-07-28	1
57541	3417	40481087	1970-05-30	1970-06-13	1
4435	260	40481087	1974-12-20	1975-01-10	1
55561	3293	260139	1998-10-02	1998-10-16	1
36321	2152	40481087	2012-10-10	2012-10-17	1
64717	3831	192671	1991-05-04	1991-05-05	1
69546	4119	0	1976-07-15	1976-07-16	1
3880	224	372328	1944-11-01	1945-04-03	1
66704	3951	4112343	2019-03-09	2019-03-18	1
3908	225	4112343	1971-03-06	1971-03-15	1
1770	101	260139	1962-04-19	1962-04-26	1
59488	3530	4112343	1963-10-04	1963-10-11	1
63318	3744	260139	2009-10-27	2009-11-03	1
2001	117	4112343	2000-09-03	2000-09-12	1
61554	3639	40481087	1980-03-09	1980-03-23	1
6324	371	195588	2000-01-24	2000-03-06	1
64381	3807	372328	1949-08-23	1950-02-25	1
2933	170	4296204	2004-01-31	2004-03-06	1
89007	5300	260139	1998-11-10	1998-11-17	1
66292	3928	40481087	1988-04-03	1988-04-17	1
67929	4017	40481087	1996-10-21	1996-11-11	1
87826	5230	40481087	1952-11-26	1952-12-17	1
4765	280	4294548	1980-01-02	1980-03-26	1
79018	4682	260139	1993-04-10	1993-04-24	1
65755	3891	4112343	2018-09-19	2018-10-01	1
2719	158	4296204	1952-01-29	1952-02-19	1
4231	245	4112343	1971-04-02	1971-04-12	1
59129	3510	4112343	1943-06-10	1943-06-23	1
7323	431	4112343	1975-09-30	1975-10-08	1
62616	3701	28060	1959-12-16	1959-12-25	1
1626	95	372328	1962-04-05	1962-08-09	1
6834	403	28060	1936-08-22	1936-09-04	1
55261	3277	28060	1974-06-20	1974-06-29	1
3789	219	4278672	1985-06-18	1985-07-18	1
60177	3566	260139	1992-01-01	1992-01-15	1
62017	3666	372328	1962-09-16	1962-12-06	1
29769	1762	4112343	1992-01-06	1992-01-19	1
7514	442	372328	1952-02-28	1952-08-02	1
59371	3526	4283893	2003-04-10	2003-08-21	1
34016	2025	378001	1928-12-21	1929-02-19	1
64993	3849	378001	2006-11-24	2006-12-24	1
3142	185	40481087	1988-01-23	1988-02-13	1
87168	5195	40481087	2016-03-23	2016-04-06	1
5296	312	4152936	2012-03-24	2012-04-07	1
8373	487	81151	2015-02-24	2015-03-10	1
66807	3956	260139	1975-11-07	1975-11-14	1
4660	273	40481087	1987-01-11	1987-01-18	1
86092	5128	4112343	1994-10-17	1994-10-30	1
4599	270	321042	2012-06-05	2012-06-06	1
56177	3332	40481087	1987-02-03	1987-02-17	1
55941	3315	4112343	1969-07-27	1969-08-05	1
39501	2343	192671	1996-02-10	1996-02-11	1
61646	3644	317576	1947-12-31	1948-01-01	1
3654	209	4112343	1974-12-29	1975-01-06	1
66170	3920	40481087	1997-06-28	1997-07-05	1
66260	3927	40481087	1957-04-04	1957-04-18	1
2993	176	4048695	1996-04-23	1996-05-25	1
57542	3417	4112343	1925-03-21	1925-03-31	1
6290	370	4296205	1979-08-09	1979-09-13	1
55562	3293	4112343	2005-09-06	2005-09-19	1
36322	2152	28060	1936-06-28	1936-07-05	1
64718	3831	260139	2001-12-07	2001-12-14	1
69547	4119	81151	1949-04-27	1949-06-01	1
3881	224	378001	2015-03-25	2015-05-24	1
66705	3951	4283893	1990-02-21	1990-09-26	1
3909	225	4132546	2006-03-29	2006-03-30	1
1771	101	260139	1973-02-28	1973-03-07	1
59489	3530	4112343	1977-02-10	1977-02-20	1
63319	3744	372328	1971-05-22	1971-06-05	1
2002	117	4112343	2008-03-21	2008-04-03	1
61555	3639	40481087	1984-07-07	1984-07-28	1
6325	371	260139	1991-12-10	1991-12-24	1
64382	3807	378001	2010-01-02	2010-02-01	1
2934	170	260139	2014-01-21	2014-02-04	1
89008	5300	260139	2002-12-25	2003-01-08	1
66293	3928	40481087	2006-06-17	2006-07-01	1
67930	4017	40481087	1999-10-06	1999-10-20	1
87827	5230	40481087	1963-12-25	1964-01-08	1
4766	280	4294548	1995-11-27	1996-01-01	1
79019	4682	372328	1981-02-07	1981-02-21	1
65756	3891	40481087	1988-11-03	1988-11-24	1
2720	158	40481087	1992-03-31	1992-04-21	1
4232	245	4283893	1922-06-23	1922-07-14	1
59130	3510	4112343	1962-05-27	1962-06-03	1
7324	431	4112343	1978-08-26	1978-09-02	1
62617	3701	260139	1955-08-20	1955-09-03	1
1627	95	378001	2007-05-05	2007-07-04	1
6835	403	80180	1962-01-03	1962-01-04	1
55262	3277	260139	1971-07-24	1971-08-07	1
3790	219	78272	1979-07-15	1979-08-19	1
60178	3566	378001	1985-09-09	1985-11-08	1
62018	3666	4112343	1999-03-27	1999-04-09	1
29770	1762	4112343	1997-08-06	1997-08-14	1
7515	442	378419	2016-07-02	2016-07-03	1
59372	3526	4296204	2012-05-10	2012-06-14	1
34017	2025	378001	1995-04-08	1995-05-08	1
64994	3849	440086	1973-11-18	1981-11-26	1
3143	185	40481087	1996-06-05	1996-06-19	1
87169	5195	28060	1986-09-12	1986-09-24	1
5297	312	4230399	1977-04-27	1977-07-26	1
8374	487	257012	1994-01-19	1994-04-06	1
66808	3956	378001	1919-06-15	1919-07-15	1
4661	273	40486433	1979-09-20	1979-09-21	1
86093	5128	4112343	1998-09-13	1998-09-26	1
4600	270	375671	1999-08-15	1999-09-14	1
56178	3332	40481087	2006-11-23	2006-12-07	1
55942	3315	40481087	1966-05-02	1966-05-23	1
39502	2343	260139	1990-07-11	1990-07-25	1
61647	3644	321042	1982-02-24	1982-02-25	1
3655	209	4112343	1976-05-02	1976-05-15	1
71092	4222	81151	1998-07-29	1998-08-26	1
66261	3927	40481087	1969-08-17	1969-08-31	1
2994	176	40481087	1987-08-19	1987-09-02	1
57543	3417	4112343	1925-09-01	1925-09-08	1
6291	370	40481087	1966-09-18	1966-09-25	1
55563	3293	4218389	1984-10-29	1984-11-26	1
36323	2152	80180	1963-05-17	1963-05-18	1
64719	3831	4027663	1982-05-23	1982-05-24	1
69548	4119	381316	2001-09-29	2001-09-30	1
3882	224	4112343	1945-05-02	1945-05-14	1
66706	3951	40481087	1948-04-06	1948-04-27	1
3910	225	4155034	1978-04-06	1978-04-20	1
1772	101	260139	1984-09-07	1984-09-14	1
59490	3530	40481087	1960-06-25	1960-07-02	1
63320	3744	372328	1975-07-14	1976-07-18	1
2003	117	4112343	2011-12-26	2012-01-08	1
61556	3639	28060	1958-11-08	1958-11-15	1
6326	371	4112343	2018-08-29	2018-09-10	1
64383	3807	440086	1956-09-18	1964-09-26	1
2935	170	4001336	2003-01-06	2003-03-07	1
89009	5300	40481087	1954-09-23	1954-10-07	1
67983	4020	28060	1991-03-08	1991-03-16	1
67931	4017	40481087	2004-07-03	2004-07-10	1
87828	5230	40481087	1973-04-28	1973-05-12	1
4767	280	4329847	2019-05-31	2019-06-01	1
79020	4682	40481087	1998-01-26	1998-02-09	1
66016	3909	260139	1964-09-03	1964-09-17	1
3982	232	78272	1947-08-18	1947-09-01	1
4233	245	4283893	1978-01-18	1978-03-15	1
59131	3510	4112343	1980-04-16	1980-04-25	1
7325	431	4112343	1985-05-01	1985-05-10	1
62618	3701	260139	1968-05-06	1968-05-20	1
1628	95	4027663	1983-08-23	1983-08-24	1
6836	403	81151	1996-08-02	1996-08-23	1
55263	3277	4112343	1963-07-08	1963-07-15	1
3791	219	80180	2005-11-01	2005-11-02	1
60179	3566	4112343	1963-08-23	1963-09-05	1
62019	3666	4294548	1989-11-04	1989-12-09	1
29771	1762	40481087	1941-10-01	1941-10-08	1
7516	442	4112343	1947-09-24	1947-10-06	1
59373	3526	40481087	1957-03-11	1957-03-18	1
34018	2025	4113008	1948-01-02	1948-01-16	1
64995	3849	4112343	1975-08-02	1975-08-09	1
3144	185	40481087	2008-03-24	2008-03-31	1
87170	5195	30753	1994-04-04	1994-04-05	1
5298	312	4266809	2017-03-28	2017-03-29	1
8375	487	260139	1995-11-29	1995-12-13	1
66809	3956	439777	1996-10-18	1996-10-19	1
4662	273	372328	1981-05-15	1981-08-30	1
86094	5128	4116491	1962-08-02	1962-09-17	1
4601	270	4112343	1976-09-10	1976-09-19	1
56179	3332	4056621	1980-01-28	1980-01-29	1
55943	3315	40481087	1984-02-21	1984-03-13	1
39503	2343	440086	1966-01-11	1966-10-25	1
61648	3644	378001	1957-02-28	1957-04-29	1
3656	209	4112343	1990-02-05	1990-02-18	1
71093	4222	372328	1951-03-08	1951-05-24	1
66262	3927	4112343	1948-10-22	1948-11-03	1
2995	176	260139	1966-08-19	1966-08-26	1
57544	3417	4230399	2018-03-28	2018-06-26	1
6292	370	40481087	1971-03-04	1971-03-25	1
55564	3293	4310024	1948-07-05	1948-07-06	1
36324	2152	260139	2005-01-26	2005-02-09	1
64720	3831	40481087	1960-01-04	1960-01-25	1
69549	4119	4113008	1964-09-10	1964-09-24	1
3883	224	4112343	1966-05-29	1966-06-05	1
66707	3951	80180	1986-08-30	1986-08-31	1
3911	225	4218389	1971-09-28	1971-10-19	1
1773	101	260139	1989-05-22	1989-06-05	1
59491	3530	40481087	1970-01-20	1970-01-27	1
63321	3744	4027663	1996-12-21	1996-12-22	1
2004	117	4112343	2017-11-23	2017-12-03	1
61557	3639	260139	1964-10-17	1964-10-31	1
8410	489	80180	2016-09-03	2016-09-04	1
64384	3807	40481087	1991-08-23	1991-09-06	1
2936	170	4112343	1983-06-16	1983-06-25	1
89010	5300	40481087	1975-01-28	1975-02-11	1
67984	4020	28060	2011-07-31	2011-08-09	1
67932	4017	40481087	2005-09-12	2005-10-03	1
87829	5230	40481087	2004-10-29	2004-11-05	1
4768	280	40481087	1960-12-06	1960-12-27	1
81115	4816	81151	1993-04-24	1993-05-29	1
66017	3909	260139	1995-06-08	1995-06-15	1
3983	232	80180	1982-12-07	1982-12-08	1
4234	245	4296205	2005-10-30	2005-11-20	1
59132	3510	4112343	1993-10-18	1993-10-31	1
7326	431	4112343	2017-12-17	2017-12-29	1
62619	3701	4112343	1969-02-18	1969-02-25	1
1629	95	4156265	2013-06-02	2013-06-23	1
6837	403	260139	1951-12-16	1952-01-01	1
55264	3277	4283893	2003-07-27	2003-08-17	1
3792	219	4029498	1974-03-29	1974-03-30	1
60180	3566	4112343	1982-06-29	1982-07-09	1
62020	3666	28060	1972-05-27	1972-06-06	1
29772	1762	40481087	1984-01-30	1984-02-13	1
7517	442	4112343	1998-12-26	1999-01-07	1
59374	3526	40481087	1968-03-12	1968-03-26	1
34019	2025	4155034	1918-09-01	1918-09-15	1
64996	3849	4112343	2016-12-27	2017-01-08	1
3145	185	372328	1948-08-16	1948-10-17	1
87171	5195	260139	1980-03-05	1980-03-19	1
5299	312	257012	2000-07-17	2000-07-18	1
8376	487	4112343	1994-09-10	1994-09-19	1
66810	3956	4112343	1934-08-20	1934-09-01	1
4663	273	40481087	1975-10-21	1975-11-04	1
86095	5128	40481087	1935-11-26	1935-12-10	1
4602	270	4112343	1993-08-24	1993-09-02	1
56180	3332	4112343	1971-03-17	1971-03-27	1
55944	3315	81151	2013-12-16	2014-01-20	1
39504	2343	4285898	1995-10-26	1995-10-27	1
61649	3644	4112343	1978-02-13	1978-02-25	1
3657	209	40481087	1971-02-15	1971-02-22	1
71094	4222	40481087	1968-07-29	1968-08-05	1
66263	3927	4146173	1988-07-06	1988-09-04	1
2996	176	260139	1986-08-20	1986-09-03	1
57545	3417	40481087	1945-09-11	1945-09-18	1
6293	370	40481087	1985-07-17	1985-07-24	1
55565	3293	40481087	1934-02-15	1934-03-01	1
36325	2152	4112343	1958-11-08	1958-11-17	1
64721	3831	40481087	2017-12-25	2018-01-08	1
69550	4119	4294548	1997-06-20	1997-11-07	1
3884	224	4218389	1959-09-14	1959-10-19	1
66708	3951	192671	1986-09-17	1986-09-18	1
3912	225	40481087	2018-11-04	2018-11-25	1
1774	101	372328	1988-11-23	1989-06-02	1
59492	3530	40481087	1970-04-06	1970-04-27	1
63322	3744	4310024	2003-06-18	2003-06-19	1
2005	117	40481087	1981-09-24	1981-10-08	1
61558	3639	378419	2001-01-13	2001-01-14	1
8411	489	372328	1975-11-28	1976-02-08	1
64385	3807	28060	1952-02-26	1952-03-10	1
2937	170	4112343	2002-05-14	2002-05-26	1
89011	5300	40481087	1975-12-16	1975-12-23	1
67985	4020	80502	2016-04-28	2016-04-29	1
69201	4101	28060	1971-06-08	1971-06-20	1
87830	5230	378001	2008-08-30	2008-09-29	1
4769	280	40481087	1984-07-21	1984-08-04	1
81116	4816	257012	1983-07-20	1983-07-21	1
66018	3909	260139	1997-12-03	1997-12-10	1
3984	232	378001	1962-04-27	1962-05-27	1
4235	245	40481087	1923-01-15	1923-01-29	1
59133	3510	4112343	2004-10-18	2004-10-26	1
7327	431	40481087	1984-08-12	1984-08-19	1
62620	3701	4155034	1962-05-13	1962-06-03	1
1630	95	40481087	1988-03-09	1988-03-23	1
6838	403	439777	1999-02-08	1999-02-09	1
55265	3277	40481087	2012-08-24	2012-09-07	1
3793	219	4112343	1970-08-19	1970-08-28	1
60181	3566	4112343	1991-11-04	1991-11-13	1
62021	3666	260139	1991-08-22	1991-09-05	1
29773	1762	40481087	1996-01-16	1996-01-23	1
7518	442	4112343	2007-02-27	2007-03-11	1
59375	3526	40481087	1977-03-18	1977-04-08	1
34020	2025	4283893	1992-08-01	1992-09-19	1
64997	3849	4218389	1976-06-06	1976-07-04	1
3146	185	40481087	1989-10-10	1989-10-31	1
87172	5195	260139	2001-02-08	2001-02-22	1
5300	312	260139	2009-05-30	2009-06-06	1
8377	487	4112343	2015-02-12	2015-02-19	1
66811	3956	4112343	2014-11-05	2014-11-15	1
4664	273	40481087	2003-11-11	2003-11-25	1
86096	5128	40481087	1975-12-16	1975-12-23	1
4603	270	4112343	2007-09-22	2007-10-03	1
56181	3332	4112343	1977-02-26	1977-03-07	1
55945	3315	260139	1962-10-30	1962-11-13	1
39505	2343	40481087	2012-08-16	2012-08-30	1
61650	3644	4113008	1979-09-22	1979-10-06	1
6327	372	80180	2004-10-14	2004-10-15	1
71095	4222	40481087	1987-10-02	1987-10-23	1
66264	3927	4218389	1998-09-12	1998-10-03	1
2997	176	4112343	1969-01-07	1969-01-17	1
57546	3417	40481087	2016-03-25	2016-04-15	1
6294	370	40481087	2005-07-10	2005-07-24	1
55566	3293	40481087	1999-03-05	1999-03-26	1
36326	2152	4112343	1973-04-16	1973-04-28	1
65478	3876	28060	1977-05-03	1977-05-12	1
69551	4119	40481087	1955-09-27	1955-10-04	1
3885	224	4294548	1990-10-17	1991-03-13	1
66709	3951	257012	1990-04-25	2004-09-16	1
3913	225	4112343	1974-07-29	1974-08-08	1
1775	101	4029498	1986-11-04	1986-11-05	1
59493	3530	40481087	1989-08-07	1989-08-28	1
63323	3744	80180	2004-12-09	2004-12-10	1
2006	117	40481087	1995-01-07	1995-01-28	1
61559	3639	4059173	1931-12-21	1932-02-19	1
8412	489	4218389	2000-08-02	2000-08-30	1
64386	3807	78272	1995-09-04	1995-09-18	1
3801	220	28060	1985-08-17	1985-08-24	1
89012	5300	40481087	1978-01-19	1978-01-26	1
67986	4020	260139	1964-07-19	1964-07-26	1
69202	4101	4112343	2016-05-21	2016-06-01	1
87831	5230	4109685	2013-04-06	2013-04-20	1
4770	280	0	2019-05-31	2019-06-01	1
81117	4816	440448	1982-11-11	1982-11-12	1
66019	3909	4112343	1962-04-19	1962-04-28	1
3985	232	4112343	1981-03-17	1981-03-30	1
4236	245	40481087	1951-11-04	1951-11-11	1
59134	3510	4112343	2019-05-15	2019-05-22	1
7328	431	260139	1964-11-03	1964-11-10	1
62621	3701	4156265	2000-01-09	2000-01-30	1
3444	197	30753	1995-11-04	1995-11-05	1
6839	403	4109685	2019-01-09	2019-01-23	1
55266	3277	81151	1967-11-11	1967-12-02	1
3794	219	40481087	1973-02-09	1973-02-16	1
60182	3566	80180	1988-06-23	1988-06-24	1
62022	3666	4112343	1966-07-30	1966-08-12	1
29774	1762	40481087	1996-04-27	1996-05-11	1
7519	442	4113008	1992-08-08	1992-08-22	1
59376	3526	4112343	1979-07-15	1979-07-22	1
34021	2025	4294548	1915-11-22	1915-11-29	1
64998	3849	40481087	1996-01-10	1996-01-31	1
3147	185	78272	2015-02-21	2015-03-28	1
87173	5195	4156265	1968-12-22	1969-01-12	1
5301	312	4112343	1997-02-25	1997-03-09	1
8378	487	4152936	1998-10-23	1998-11-06	1
66812	3956	4113008	1983-05-20	1983-06-03	1
4665	273	40481087	2014-11-03	2014-11-17	1
86097	5128	80180	1965-04-23	1965-04-24	1
4604	270	4113008	1965-07-27	1965-08-10	1
56182	3332	4112343	2002-04-09	2002-04-20	1
55946	3315	4112343	1981-11-11	1981-11-23	1
39506	2343	81151	2012-11-09	2012-11-23	1
61651	3644	260139	1961-02-05	1961-02-19	1
6328	372	134438	1985-05-14	1986-06-09	1
71096	4222	378001	1964-04-28	1964-05-28	1
66265	3927	4266809	1981-02-08	1981-02-09	1
2998	176	4112343	1982-07-10	1982-07-17	1
57547	3417	260139	1957-07-22	1957-08-05	1
6295	370	4112343	1965-12-21	1966-01-03	1
56288	3342	80502	1989-11-01	1989-11-02	1
36327	2152	4112343	1991-07-07	1991-07-16	1
65479	3876	81151	1977-07-28	1977-08-25	1
69552	4119	40481087	1967-04-12	1967-04-26	1
3886	224	40481087	2013-08-22	2013-08-29	1
66710	3951	372328	2006-04-18	2006-05-02	1
3914	225	4112343	2012-07-21	2012-07-29	1
1776	101	4059173	2017-07-10	2017-10-08	1
59494	3530	40481087	1994-04-12	1994-05-03	1
63324	3744	4112343	2012-01-13	2012-01-22	1
2007	117	260139	2015-01-21	2015-01-28	1
61560	3639	4112343	1930-06-19	1930-06-29	1
8413	489	4266809	2016-09-03	2016-09-04	1
64387	3807	81893	1986-08-07	1986-08-08	1
3802	220	372328	1982-10-31	1982-12-08	1
89013	5300	40481087	2012-05-16	2012-05-23	1
67987	4020	378001	1979-11-15	1979-12-15	1
69203	4101	40481087	1992-07-09	1992-07-16	1
87832	5230	4112343	1990-10-02	1990-10-11	1
4771	280	28060	1949-04-06	1949-04-18	1
81118	4816	40481087	1994-07-07	1994-07-14	1
66020	3909	372328	1961-10-17	1961-11-24	1
3986	232	40479768	1959-02-05	1959-04-13	1
4237	245	40481087	2006-08-02	2006-08-09	1
59135	3510	4146173	2001-07-22	2001-09-20	1
7329	431	260139	1992-05-11	1992-05-18	1
62622	3701	40481087	1967-02-25	1967-03-11	1
3445	197	80180	1996-07-31	1996-08-01	1
6840	403	4112343	1975-02-26	1975-03-10	1
55267	3277	372328	1965-08-23	1965-11-12	1
3795	219	260139	1975-10-06	1975-10-20	1
60183	3566	4280726	1953-07-29	1953-07-30	1
62023	3666	4113008	2013-06-02	2013-06-23	1
29775	1762	40481087	2008-08-11	2008-08-25	1
7520	442	40481087	1977-05-21	1977-06-04	1
59377	3526	4112343	1986-07-16	1986-07-26	1
34022	2025	40481087	1942-12-29	1943-01-19	1
64999	3849	28060	1969-04-20	1969-05-03	1
3148	185	4112343	1948-10-01	1948-10-10	1
87174	5195	40481087	1970-02-01	1970-02-08	1
5302	312	4112343	2018-03-06	2018-03-19	1
8379	487	4283893	2007-04-29	2007-08-26	1
66813	3956	4296205	1958-11-22	1958-12-27	1
4666	273	81151	2019-02-25	2019-04-01	1
86098	5128	80502	1997-02-19	1997-02-20	1
4605	270	4294548	1964-10-31	1964-11-07	1
56183	3332	4116491	1979-12-02	1980-03-10	2
55947	3315	4112343	2008-05-19	2008-05-31	1
39507	2343	260139	1970-06-30	1970-07-14	1
61652	3644	4112343	1959-06-02	1959-06-10	1
6329	372	378001	2001-05-25	2001-06-24	1
71097	4222	4112343	1969-06-02	1969-06-11	1
66266	3927	40481087	1990-12-13	1990-12-20	1
2999	176	4112343	1986-08-26	1986-09-07	1
57548	3417	260139	1980-01-29	1980-02-12	1
6296	370	4112343	1974-02-05	1974-02-13	1
56289	3342	81151	1926-10-18	1926-11-22	1
36328	2152	40481087	1947-12-15	1948-01-05	1
65480	3876	372328	1975-05-10	1976-05-10	1
69553	4119	40481087	1971-04-25	1971-05-16	1
3887	224	0	1954-10-10	1954-10-11	1
66711	3951	4027663	1975-09-17	1975-09-18	1
3915	225	4218389	1981-05-04	1981-06-08	1
1777	101	4278672	2011-05-08	2011-08-06	1
59495	3530	78272	2001-12-05	2001-12-26	1
63325	3744	4237458	1990-11-08	1991-02-06	1
2008	117	372328	1979-09-08	1980-08-16	1
61561	3639	4112343	1958-03-05	1958-03-12	1
8414	489	40481087	1978-07-20	1978-07-27	1
64388	3807	260139	1965-10-18	1965-10-25	1
3803	220	4112343	1997-07-08	1997-07-16	1
89221	5314	4112343	1980-02-04	1980-02-15	1
67988	4020	4112343	1972-08-08	1972-08-20	1
69204	4101	28060	2008-08-16	2008-08-28	1
87833	5230	4112343	2005-02-19	2005-03-03	1
4772	280	260139	1992-09-21	1992-09-28	1
81119	4816	40481087	2000-09-18	2000-09-25	1
66021	3909	4112343	1972-07-08	1972-07-17	1
3987	232	40481087	1967-05-25	1967-06-01	1
4238	245	28060	1987-10-18	1987-10-31	1
59136	3510	4310024	1970-01-23	1970-01-24	1
7330	431	378001	1958-07-07	1958-08-06	1
62623	3701	80180	1994-05-10	1994-05-11	1
3446	197	81151	1973-01-11	1973-02-08	1
6841	403	4134304	1988-08-14	1988-09-13	1
55268	3277	4113008	2013-12-21	2014-01-11	1
3796	219	4051466	1971-04-06	1987-07-11	1
60184	3566	40481087	2013-08-10	2013-08-17	1
62024	3666	4146173	1997-10-24	1997-12-23	1
29776	1762	40481087	2017-10-13	2017-11-03	1
7521	442	40481087	1998-07-06	1998-07-20	1
59378	3526	4285898	1986-01-07	1986-01-08	1
34023	2025	40481087	1947-03-27	1947-04-17	1
65000	3849	372328	1969-01-23	1969-04-24	1
3149	185	4112343	2009-10-19	2009-11-01	1
87175	5195	40481087	2007-07-19	2007-08-09	1
5303	312	4134304	1991-05-14	1991-06-13	1
8380	487	40481087	1989-12-10	1989-12-31	1
66814	3956	40481087	1951-01-03	1951-01-10	1
4667	273	260139	2003-01-08	2003-01-22	1
86099	5128	260139	1947-10-22	1947-10-29	1
4606	270	40481087	1962-06-21	1962-07-05	1
56184	3332	4266809	1999-04-16	1999-04-17	1
55948	3315	40479422	2006-09-17	2006-10-24	1
39508	2343	4027663	1986-01-06	1986-01-07	1
61653	3644	4112343	1970-02-13	1970-02-22	1
6330	372	4112343	1966-08-18	1966-08-31	1
71098	4222	4112343	2007-05-27	2007-06-06	1
66267	3927	81151	1960-04-10	1960-05-15	1
3000	176	4112343	2005-01-25	2005-02-06	1
57549	3417	260139	1995-08-02	1995-08-09	1
6297	370	4296205	1967-12-07	1968-01-04	1
56290	3342	81893	1949-05-23	1949-05-24	1
36329	2152	40481087	2013-11-17	2013-11-24	1
65481	3876	4112343	1981-06-22	1981-06-29	1
73061	4347	81151	2012-06-12	2012-07-03	1
3888	224	81151	1969-11-25	1969-12-16	1
66712	3951	4112343	1951-01-01	1951-01-10	1
3916	225	260139	2010-08-28	2010-09-11	1
1778	101	4296205	1960-04-29	1960-05-13	1
59496	3530	372328	1960-10-15	1961-03-24	1
63326	3744	40479768	1994-12-17	1995-02-22	1
2009	117	4112343	2011-02-19	2011-02-28	1
61562	3639	4112343	1960-07-11	1960-07-20	1
8415	489	4084167	1976-10-23	1976-10-23	1
64389	3807	372328	1948-01-14	1948-08-28	2
3804	220	260139	1984-11-21	1984-11-28	1
89222	5314	40481087	1989-02-12	1989-03-05	1
67989	4020	4283893	1984-04-18	1984-06-20	1
69205	4101	81893	1998-01-13	1998-01-14	1
87834	5230	40481087	1949-02-18	1949-03-11	1
4773	280	260139	2014-02-15	2014-03-01	1
81120	4816	40481087	2019-03-29	2019-04-12	1
66022	3909	4278672	2011-02-27	2011-03-29	1
3988	232	40481087	1987-07-26	1987-08-09	1
4239	245	80502	2006-07-16	2006-07-17	1
59137	3510	40481087	1987-04-19	1987-04-26	1
7331	431	4059173	1999-01-22	1999-04-22	1
62624	3701	81151	1986-09-16	1986-10-14	1
3447	197	4266809	1996-07-31	1996-08-01	1
6842	403	4155034	1929-07-20	1929-08-03	1
55269	3277	4278672	2017-06-24	2017-09-22	1
3797	219	4112343	2018-06-03	2018-06-12	1
60185	3566	28060	1986-05-20	1986-05-30	1
62025	3666	40481087	2005-09-24	2005-10-01	1
33863	2013	4237458	1975-10-16	1975-12-15	1
7522	442	80180	1985-09-02	1985-09-03	1
59379	3526	260139	2015-01-05	2015-01-19	1
34024	2025	40481087	2009-04-15	2009-04-29	1
65001	3849	439777	2015-11-08	2015-11-09	1
3150	185	4152936	1982-05-03	1982-05-17	1
87176	5195	40481087	2011-03-27	2011-04-10	1
5304	312	40481087	2010-05-11	2010-06-01	1
8381	487	40481087	2005-04-25	2005-05-02	1
66815	3956	40481087	1976-08-31	1976-09-21	1
4668	273	4112343	1983-09-19	1983-10-01	1
86100	5128	260139	1994-11-17	1994-11-24	1
4607	270	40481087	1995-10-02	1995-10-09	1
56185	3332	40481087	1973-04-12	1973-04-26	1
55949	3315	40481087	1966-01-18	1966-01-25	1
39509	2343	4109685	2010-04-03	2010-04-24	1
61654	3644	40481087	1962-04-08	1962-04-22	1
6331	372	4112343	1969-07-18	1969-07-26	1
71099	4222	40481087	1975-01-06	1975-01-20	1
66268	3927	260139	1973-06-11	1973-06-18	1
3001	176	40481087	1974-02-13	1974-02-20	1
57550	3417	4112343	2008-09-03	2008-09-13	1
6298	370	78272	1971-10-06	1971-10-20	1
56291	3342	260139	1927-06-04	1927-06-18	1
36330	2152	40481087	2016-11-15	2016-12-06	1
65482	3876	4294548	1979-08-21	1979-09-18	1
73062	4347	260139	2001-05-07	2001-05-21	1
3889	224	375671	1954-12-09	1955-01-08	1
66713	3951	4112343	1955-11-18	1955-11-25	1
3917	225	4048171	1969-01-10	1984-01-09	1
1779	101	40479768	1978-10-27	1979-01-02	1
59497	3530	378001	1970-11-13	1971-01-12	1
66765	3955	81893	1994-02-19	1994-02-20	1
2010	117	4112343	2016-09-16	2016-09-26	1
61563	3639	4112343	1966-05-24	1966-06-05	1
8416	489	4112343	2010-06-28	2010-07-06	1
64390	3807	372328	1960-04-03	1960-06-25	1
3805	220	260139	1998-06-15	1998-06-29	1
89223	5314	40481087	2003-02-15	2003-02-22	1
67990	4020	28060	1979-04-04	1979-04-14	1
69206	4101	260139	1980-06-08	1980-06-22	1
87835	5230	260139	1996-06-12	1996-06-26	1
4774	280	260139	2017-08-17	2017-08-31	1
81121	4816	81893	2016-01-25	2016-01-26	1
66023	3909	40481087	1995-07-30	1995-08-13	1
3989	232	40481087	2005-03-23	2005-04-13	1
4240	245	81151	1996-07-21	1996-08-04	1
59138	3510	40481087	2008-07-21	2008-08-04	1
7332	431	4112343	1960-09-09	1960-09-19	1
62625	3701	257012	1997-10-03	1997-10-04	1
3448	197	4294548	2012-10-19	2012-11-23	1
6843	403	4230399	1968-08-29	1968-11-27	1
57776	3432	0	1953-11-08	1953-11-09	1
3798	219	78272	1987-08-07	1987-09-11	1
60186	3566	81151	1996-02-14	1996-03-06	1
63971	3784	260139	1951-06-10	1951-06-17	1
33864	2013	80180	1996-08-19	1996-08-20	1
7523	442	4109685	1989-12-08	1989-12-22	1
59380	3526	372328	1953-08-22	1953-12-01	1
34025	2025	28060	1920-08-18	1920-08-28	1
65002	3849	4112343	2013-08-01	2013-08-12	1
3151	185	4296204	1986-02-25	1986-03-25	1
87177	5195	372328	1964-07-25	1965-01-27	1
5305	312	4027663	2006-01-15	2006-01-16	1
8382	487	40481087	2010-09-18	2010-10-02	1
66816	3956	40481087	1977-09-25	1977-10-02	1
4669	273	4112343	2005-09-26	2005-10-09	1
86101	5128	313217	2017-09-20	2017-09-21	1
4608	270	40481087	2006-04-07	2006-04-14	1
58036	3442	80180	2001-03-24	2001-03-25	1
55950	3315	40481087	1980-07-05	1980-07-19	1
39510	2343	40481087	2000-12-11	2000-12-25	1
61655	3644	40481087	1971-03-13	1971-04-03	1
6332	372	4134304	2017-11-27	2017-12-27	1
71100	4222	40481087	1997-08-10	1997-08-17	1
66269	3927	260139	2011-04-02	2011-04-16	1
3002	176	40481087	1989-04-30	1989-05-14	1
57551	3417	4113008	1937-04-20	1937-05-11	1
6299	370	80180	2000-01-08	2000-01-09	1
56292	3342	260139	1938-11-26	1938-12-10	1
36331	2152	0	1962-02-03	1962-02-04	1
65483	3876	40481087	2000-09-06	2000-09-27	1
73063	4347	40481087	2009-06-22	2009-07-06	1
3890	224	4112343	1963-08-29	1963-09-11	1
66714	3951	4134304	1950-01-21	1950-04-21	1
3918	225	4113008	2016-12-01	2016-12-22	1
1780	101	40481087	1968-08-09	1968-08-30	1
60916	3610	260139	2001-01-01	2001-01-08	1
66766	3955	4027663	1988-01-27	1988-01-28	1
2011	117	260139	1984-11-29	1984-12-06	1
61564	3639	4112343	2005-01-05	2005-01-12	1
8417	489	40481087	2009-01-08	2009-01-15	1
64391	3807	4112343	1965-06-15	1965-06-27	1
3806	220	4109685	1985-03-19	1985-04-09	1
89224	5314	40481087	2016-09-08	2016-09-22	1
67991	4020	257012	1973-08-26	1973-08-27	1
69207	4101	378001	1975-07-06	1975-08-05	1
87836	5230	4112343	1974-02-17	1974-02-24	1
4775	280	4109685	1988-05-20	1988-06-10	1
81122	4816	372328	1983-06-02	1983-10-17	1
66024	3909	40481087	2016-12-26	2017-01-16	1
3990	232	0	1963-10-30	1963-10-31	1
4241	245	372328	1917-03-15	1917-05-27	1
62310	3686	78272	2000-12-26	2001-01-23	1
7333	431	4112343	1970-02-13	1970-02-26	1
62626	3701	260139	1980-06-14	1980-06-23	1
3449	197	40481087	1998-07-13	1998-07-27	1
6844	403	4278672	1991-08-29	1991-10-28	1
57777	3432	260139	1994-12-01	1994-12-08	1
3799	219	260139	1991-11-27	1991-12-11	1
60187	3566	440086	1958-07-21	1961-04-10	1
63972	3784	260139	1979-01-01	1979-01-08	1
33865	2013	372328	1956-10-13	1956-11-24	1
7524	442	4112343	1981-03-15	1981-03-28	1
59381	3526	4134304	1964-09-23	1964-10-23	1
34026	2025	28060	1921-03-29	1921-04-06	1
65003	3849	4116491	2006-12-21	2007-01-26	1
3152	185	40481087	1952-07-11	1952-07-25	1
87178	5195	4294548	1974-11-19	1975-03-18	1
5306	312	4294548	2000-06-26	2000-10-23	1
11568	685	372328	1966-03-09	1966-05-16	1
66817	3956	0	1952-10-30	1952-10-31	1
4670	273	40481087	2006-05-19	2006-06-09	1
86102	5128	321042	1955-07-27	1955-07-28	1
4609	270	81151	1985-06-17	1985-07-08	1
58037	3442	4112343	1985-06-26	1985-07-05	1
55951	3315	40481087	1981-04-24	1981-05-01	1
39511	2343	40481087	2013-12-31	2014-01-14	1
61656	3644	40481087	1978-09-01	1978-09-08	1
6333	372	40481087	1962-05-17	1962-06-07	1
71101	4222	40481087	2019-06-13	2019-06-27	1
66270	3927	4112343	1967-10-21	1967-10-31	1
3003	176	40481087	2004-10-28	2004-11-04	1
57552	3417	40480160	2018-03-28	2018-06-26	1
6300	370	372328	1965-08-19	1965-10-07	1
56293	3342	313217	2005-03-30	2005-03-31	1
36332	2152	28060	1924-06-18	1924-06-27	1
65484	3876	40481087	2004-12-13	2004-12-20	1
73064	4347	440448	1993-04-05	1993-04-06	1
3891	224	4112343	1992-02-07	1992-02-14	1
66715	3951	30753	1985-05-07	1985-05-08	1
3919	225	4134304	1975-06-21	1975-07-21	1
1781	101	40481087	2001-11-07	2001-11-28	1
60917	3610	4112343	2012-12-24	2013-01-01	1
66767	3955	4134304	1994-02-28	1994-05-29	1
2012	117	4237458	1982-09-22	1982-10-22	1
61565	3639	40481087	1948-12-26	1949-01-09	1
8418	489	4084167	1977-10-19	1977-10-19	1
64392	3807	40481087	2002-10-16	2002-10-30	1
3807	220	4112343	1986-07-23	1986-08-03	1
89225	5314	260139	1986-11-12	1986-11-19	1
67992	4020	381316	2014-10-02	2014-10-03	1
69208	4101	4027663	1988-02-20	1988-02-21	1
87837	5230	4134304	2002-03-05	2002-04-04	1
4776	280	4134304	2010-10-11	2011-01-09	1
81123	4816	372328	1984-10-11	1985-04-15	1
66025	3909	80180	1999-08-29	1999-08-30	1
3991	232	28060	1945-10-29	1945-11-10	1
4242	245	4296204	2013-09-09	2013-09-30	1
62311	3686	81151	2016-10-01	2016-10-29	1
7334	431	4152936	1985-09-18	1985-10-02	1
62627	3701	260139	1995-10-30	1995-11-06	1
3450	197	40481087	2010-12-15	2010-12-22	1
6845	403	40481087	1931-07-14	1931-07-21	1
57778	3432	372328	1955-01-22	1955-04-15	1
3800	219	40481087	1988-01-05	1988-01-26	1
60188	3566	4112343	1979-07-17	1979-07-28	1
63973	3784	261325	1982-07-20	1982-07-21	1
33866	2013	4112343	2004-10-02	2004-10-12	1
7525	442	4294548	2013-03-29	2013-06-07	1
59382	3526	4142905	1972-08-17	1972-09-16	1
34027	2025	28060	2017-08-10	2017-08-17	1
65004	3849	40481087	2000-09-14	2000-09-28	1
3153	185	40481087	2014-08-04	2014-08-18	1
87179	5195	40481087	1981-07-24	1981-08-14	1
5307	312	40481087	1974-12-18	1975-01-01	1
11569	685	372328	1968-02-05	1968-07-15	1
66818	3956	4027663	1948-10-30	1948-10-31	1
4671	273	28060	1976-02-14	1976-02-27	1
86103	5128	372328	1930-04-15	1930-07-16	1
4610	270	260139	1990-06-27	1990-07-04	1
58038	3442	40481087	2004-11-29	2004-12-06	1
55952	3315	40481087	2013-12-24	2013-12-31	1
39512	2343	80180	1995-12-25	1995-12-26	1
61890	3658	260139	1983-02-08	1983-02-15	1
6334	372	40481087	1972-12-10	1972-12-17	1
71102	4222	80180	1987-01-28	1987-01-29	1
66271	3927	4112343	2015-01-18	2015-01-26	1
3004	176	28060	2003-12-19	2003-12-28	1
57553	3417	40481087	1918-11-05	1918-11-12	1
6301	370	4113008	1970-10-20	1970-11-10	1
56294	3342	4294548	2002-06-18	2002-08-06	1
36333	2152	260139	1922-08-12	1922-08-19	1
65485	3876	40481087	2011-01-23	2011-02-13	1
73065	4347	4283893	2003-01-03	2003-01-31	1
3892	224	4152936	1992-02-19	1992-03-11	1
66716	3951	260139	2014-03-09	2014-03-16	1
3920	225	4278672	1966-10-24	1966-11-23	1
1782	101	0	1986-11-04	1986-11-05	1
60918	3610	4152936	1987-06-20	1987-07-04	1
66768	3955	4285898	1994-11-16	1994-11-17	1
2013	117	80180	2009-01-13	2009-01-14	1
61566	3639	40481087	1982-05-19	1982-06-09	1
8419	489	4237458	1999-09-07	1999-10-07	1
65052	3852	28060	1993-04-17	1993-04-30	1
3808	220	4112343	2011-06-06	2011-06-17	1
89226	5314	4310024	1990-12-14	1990-12-15	1
67993	4020	4112343	1975-10-06	1975-10-18	1
69209	4101	4112343	1968-11-05	1968-11-17	1
87838	5230	40480160	2014-02-14	2014-05-15	1
4777	280	4142905	1962-03-10	1962-04-09	1
81124	4816	260139	1994-03-08	1994-03-22	1
66026	3909	372328	1962-08-21	1962-10-26	1
3992	232	28060	2007-11-11	2007-11-20	1
4243	245	40480160	2015-09-20	2015-10-20	1
62312	3686	192671	2009-12-16	2009-12-17	1
7335	431	40481087	1963-05-19	1963-05-26	1
62628	3701	4112343	2005-11-15	2005-11-24	1
3451	197	260139	1984-08-24	1984-09-07	1
6846	403	40481087	2011-05-24	2011-05-31	1
57779	3432	4112343	2001-06-06	2001-06-18	1
4498	264	28060	1958-05-04	1958-05-13	1
60189	3566	4112343	2000-02-03	2000-02-11	1
63974	3784	372328	1931-01-04	1931-03-17	1
33867	2013	4112343	2012-06-06	2012-06-14	1
7526	442	40481087	1992-04-19	1992-05-03	1
59383	3526	4266809	1986-06-06	1986-06-07	1
34028	2025	80180	1946-12-28	1946-12-29	1
65005	3849	28060	1965-02-14	1965-02-25	1
3154	185	258780	2013-05-26	2013-05-27	1
87180	5195	40481087	1982-08-15	1982-08-22	1
5308	312	80180	2017-03-28	2017-03-29	1
11570	685	378001	1983-02-04	1983-04-05	1
66819	3956	4112343	2004-12-13	2004-12-23	1
4672	273	260139	1980-11-17	1980-11-24	1
86104	5128	4112343	1937-03-18	1937-03-29	1
4611	270	372328	1958-12-01	1959-01-13	1
58039	3442	260139	1974-12-05	1974-12-19	1
55953	3315	40481087	2017-06-10	2017-07-01	1
39513	2343	81151	1958-09-30	1958-11-04	1
61891	3658	260139	1998-01-10	1998-01-24	1
6335	372	40481087	1993-11-05	1993-11-19	1
71103	4222	4027663	1979-06-09	1979-06-10	1
66272	3927	4218389	1979-01-20	1979-02-24	1
3005	176	78272	1971-07-22	1971-08-05	1
57554	3417	40481087	1943-07-28	1943-08-18	1
6302	370	40481087	1968-07-04	1968-07-11	1
56295	3342	40481087	1952-10-29	1952-11-12	1
36334	2152	317576	1980-01-12	1980-01-13	1
65486	3876	80180	2004-07-26	2004-07-27	1
73066	4347	40481087	2005-07-26	2005-08-09	1
3893	224	40481087	1953-10-03	1953-10-24	1
66717	3951	4112343	1973-08-06	1973-08-15	1
3921	225	40481087	1971-11-07	1971-11-21	1
1783	101	321042	2001-01-12	2001-01-13	1
60919	3610	40481087	1945-03-10	1945-03-24	1
66769	3955	40481087	1966-02-28	1966-03-21	1
2014	117	260139	1974-07-08	1974-07-15	1
63564	3757	260139	1973-01-12	1973-01-19	1
8420	489	40481087	1981-12-13	1981-12-20	1
65053	3852	40481087	1956-12-19	1957-01-09	1
3809	220	40481087	1988-02-09	1988-02-16	1
89227	5314	40481087	1953-01-20	1953-02-10	1
67994	4020	4112343	1987-01-19	1987-01-27	1
69210	4101	4116491	1983-02-21	1983-04-04	1
87839	5230	40481087	1975-04-07	1975-04-14	1
4778	280	40481087	1979-05-14	1979-05-28	1
81125	4816	4027663	2007-11-03	2007-11-04	1
66027	3909	378001	1965-04-29	1965-05-29	1
3993	232	260139	2007-08-30	2007-09-07	1
4244	245	40481087	1960-11-15	1960-12-06	1
62313	3686	260139	2013-02-15	2013-03-01	1
7336	431	40481087	1970-11-22	1970-11-29	1
62629	3701	4112343	2011-11-07	2011-11-18	1
3452	197	4112343	2012-07-29	2012-08-09	1
6847	403	260139	1935-01-04	1935-01-11	1
57780	3432	4112343	2008-04-13	2008-04-22	1
4499	264	78272	1972-10-09	1972-10-30	1
60190	3566	4112343	2008-05-02	2008-05-13	1
63975	3784	4112343	1972-08-12	1972-08-21	1
33868	2013	40481087	2003-12-23	2004-01-06	1
12665	752	80180	1991-03-19	1991-03-20	1
59384	3526	4283893	1961-10-31	1961-12-26	1
34029	2025	4112343	1910-08-17	1910-08-30	1
65006	3849	28060	1968-04-13	1968-04-21	1
3155	185	260139	1977-04-30	1977-05-14	1
89525	5329	28060	1985-01-28	1985-02-09	1
5309	312	4112343	2003-03-12	2003-03-21	1
11571	685	4027663	1992-02-01	1992-02-02	1
66820	3956	4237458	2013-02-25	2013-04-26	1
4673	273	260139	2014-03-27	2014-04-10	1
86105	5128	4112343	1947-01-09	1947-01-22	1
4612	270	4027663	1985-01-28	1985-01-29	1
58040	3442	372328	1962-02-02	1962-05-20	1
55954	3315	81151	1968-06-28	1968-08-02	1
39514	2343	260139	2002-11-05	2002-11-12	1
61892	3658	260139	2017-01-17	2017-01-31	1
6336	372	40481087	1996-04-16	1996-05-07	1
71104	4222	4266809	1987-01-28	1987-01-29	1
66273	3927	4218389	2013-12-13	2014-01-17	1
3006	176	80180	2003-03-06	2003-03-07	1
57555	3417	40481087	2010-10-03	2010-10-17	1
6303	370	260139	2004-09-25	2004-10-02	1
56296	3342	40481087	1955-08-08	1955-08-15	1
36335	2152	440448	1962-02-03	1962-02-04	1
65487	3876	260139	1974-04-17	1974-04-24	1
73067	4347	40481087	2017-01-19	2017-02-09	1
3894	224	140673	2016-09-24	2016-09-25	1
66718	3951	4112343	1977-04-28	1977-05-05	1
3922	225	40481087	2005-04-02	2005-04-23	1
1784	101	4112343	1940-11-22	1940-12-03	1
60920	3610	40481087	1997-08-21	1997-09-04	1
66770	3955	40481087	1969-02-09	1969-03-02	1
2015	117	260139	2002-03-21	2002-03-28	1
63565	3757	317576	2018-10-17	2018-10-18	1
8421	489	78272	1987-04-29	1987-05-13	1
65054	3852	40481087	1978-11-23	1978-11-30	1
3810	220	40481087	2016-05-21	2016-06-04	1
89228	5314	40481087	1971-07-04	1971-07-18	1
67995	4020	4112343	2016-02-16	2016-02-27	1
69211	4101	40481087	1966-07-30	1966-08-20	1
709	40	78272	1994-11-19	1994-12-03	1
4779	280	40481087	1986-10-29	1986-11-05	1
81126	4816	4113008	1990-05-26	1990-06-09	1
66028	3909	40481087	1966-07-30	1966-08-13	1
3994	232	372328	1948-11-10	1949-10-12	1
4245	245	40481087	1972-10-24	1972-11-07	1
62314	3686	378001	2011-01-01	2011-01-31	1
7337	431	40481087	1996-07-09	1996-07-23	1
62630	3701	4296204	1966-12-09	1966-12-23	1
3453	197	4156265	1982-07-12	1982-08-02	1
6848	403	313217	1992-12-28	1992-12-29	1
57781	3432	4112343	2012-09-13	2012-09-24	1
4500	264	80180	1984-04-04	1984-04-05	1
60191	3566	4152936	1957-03-21	1957-04-04	1
63976	3784	4283893	1979-12-02	1979-12-30	1
33869	2013	260139	1964-05-06	1964-05-20	1
12666	752	260139	1957-01-16	1957-01-30	1
59385	3526	40481087	1950-05-05	1950-05-12	1
34030	2025	4112343	1950-09-04	1950-09-15	1
65007	3849	80180	2003-06-29	2003-06-30	1
3156	185	317576	1996-02-18	1996-02-19	1
89526	5329	81151	2011-02-25	2011-03-25	1
5310	312	4310024	2014-10-10	2014-10-11	1
11572	685	4296204	2005-05-23	2005-06-13	1
66821	3956	4294548	1974-08-15	1974-09-19	1
4674	273	378001	2013-12-23	2014-02-21	1
86106	5128	4112343	1976-12-07	1976-12-16	1
4613	270	4112343	1968-07-15	1968-07-22	1
58041	3442	375671	1969-04-26	1969-05-26	1
55955	3315	4109685	1983-03-08	1983-03-22	1
39515	2343	372328	1959-05-28	1959-06-20	1
61893	3658	4294548	1991-10-09	1992-01-01	1
6337	372	81151	1999-05-15	1999-06-05	1
71105	4222	40481087	1962-06-17	1962-06-24	1
66274	3927	80180	1981-02-08	1981-02-09	1
3007	176	40481087	1969-02-09	1969-02-16	1
59075	3509	260139	1961-09-20	1961-09-27	1
6304	370	372328	1970-03-15	1970-04-23	1
56297	3342	40481087	1967-04-04	1967-04-18	1
36336	2152	4112343	1985-07-27	1985-08-03	1
65488	3876	260139	2016-12-10	2016-12-17	1
73068	4347	0	1993-04-05	1993-04-06	1
3895	224	4112343	2008-11-18	2008-11-29	1
66719	3951	4112343	1988-05-23	1988-06-05	1
8981	526	80180	2002-04-12	2002-04-13	1
1785	101	4112343	1982-02-08	1982-02-19	1
60921	3610	40481087	2009-03-07	2009-03-21	1
66771	3955	40481087	1983-12-26	1984-01-16	1
2016	117	4112343	2006-04-18	2006-04-29	1
63566	3757	4112343	1947-01-15	1947-01-24	1
8422	489	4027663	2004-05-24	2004-05-25	1
65055	3852	40481087	1985-04-25	1985-05-02	1
3811	220	80180	2019-05-15	2019-05-16	1
89229	5314	40481087	1977-11-15	1977-12-06	1
67996	4020	4152936	1959-12-11	1960-01-01	1
69212	4101	0	1960-02-27	1960-02-28	1
710	40	81151	2003-08-18	2003-09-01	1
4780	280	78272	1976-06-24	1976-07-22	1
81127	4816	4283893	1983-06-08	1983-07-27	1
66029	3909	40481087	1977-02-21	1977-03-07	1
3995	232	440448	1963-10-30	1963-10-31	1
4246	245	40481087	2004-05-16	2004-06-06	1
62315	3686	4134304	1991-01-18	1991-04-18	1
7338	431	81151	1967-01-21	1967-02-25	1
62631	3701	40481087	2005-02-22	2005-03-08	1
3454	197	40481087	1976-07-04	1976-07-11	1
6849	403	372328	1925-05-01	1925-08-03	1
57782	3432	4112343	2017-08-31	2017-09-10	1
4501	264	260139	1958-05-23	1958-05-30	1
60192	3566	4283893	1994-05-28	1994-07-09	1
63977	3784	80180	1965-02-14	1965-02-15	1
33870	2013	4156265	1971-12-22	1972-01-05	1
12667	752	260139	1971-07-25	1971-08-01	1
59386	3526	28060	1955-01-13	1955-01-20	1
34031	2025	4218389	1984-07-06	1984-08-03	1
65008	3849	81151	1964-11-15	1964-12-06	1
3157	185	372328	1947-04-07	1947-07-20	1
89527	5329	260139	2012-05-04	2012-05-18	1
5311	312	40481087	2012-04-26	2012-05-03	1
11573	685	40481087	1968-05-04	1968-05-25	1
66822	3956	40481087	1917-09-02	1917-09-23	1
4675	273	40481087	1996-07-06	1996-07-27	1
86107	5128	4112343	2017-08-20	2017-08-30	1
4614	270	4266809	1995-05-16	1995-05-17	1
58042	3442	4112343	1967-07-07	1967-07-14	1
55956	3315	4112343	1981-05-05	1981-05-12	1
39516	2343	381316	2016-05-21	2016-05-22	1
61894	3658	40481087	1977-08-25	1977-09-15	1
6338	372	260139	1994-11-27	1994-12-04	1
71106	4222	30753	1986-08-01	1986-08-02	1
66275	3927	81893	1979-08-18	1979-08-19	1
3008	176	40481087	1972-09-05	1972-09-12	1
59076	3509	4109685	1984-04-27	1984-05-18	1
6305	370	4112343	1969-02-18	1969-02-27	1
56298	3342	81151	1924-08-08	1924-08-29	1
36337	2152	4296204	1949-08-02	1949-08-16	1
65489	3876	4112343	2001-07-18	2001-07-27	1
73069	4347	80180	2002-10-18	2002-10-19	1
3896	224	4278672	2009-07-24	2009-08-23	1
66720	3951	4294548	1959-03-10	1959-11-10	1
8982	526	372328	1977-01-23	1978-02-08	1
1786	101	4152936	1986-12-21	1987-01-04	1
60922	3610	80180	1985-02-10	1985-02-11	1
66772	3955	40481087	1999-10-03	1999-10-17	1
2017	117	40481087	1970-04-06	1970-04-20	1
63567	3757	4112343	1968-07-13	1968-07-21	1
8423	489	4112343	1976-12-26	1977-01-06	1
65056	3852	40481087	1996-08-03	1996-08-24	1
3812	220	260139	1990-01-12	1990-01-26	1
89230	5314	40481087	1989-05-10	1989-05-17	1
67997	4020	4283893	1973-08-05	1974-01-20	1
69213	4101	28060	1963-09-20	1963-10-01	1
711	40	4134304	1967-08-13	1967-09-12	1
4781	280	260139	2009-01-03	2009-01-10	1
81128	4816	4299128	1999-03-29	1999-05-03	1
66030	3909	40481087	1988-10-12	1988-10-26	1
3996	232	4027663	1970-10-26	1970-10-27	1
7833	458	40481087	1999-05-01	1999-05-22	1
62316	3686	40481087	2012-05-03	2012-05-10	1
7339	431	4112343	2004-08-14	2004-08-25	1
64581	3823	30753	1992-12-27	1992-12-28	1
3455	197	40481087	2002-02-14	2002-02-28	1
6850	403	375671	1941-10-20	1941-11-19	1
57783	3432	4113008	1992-07-16	1992-07-30	1
4502	264	260139	1995-04-03	1995-04-10	1
60193	3566	40481087	1952-01-28	1952-02-11	1
63978	3784	372328	1932-08-08	1932-12-13	1
33871	2013	4283893	1983-06-22	1983-07-06	1
12668	752	260139	2014-05-07	2014-05-21	1
59387	3526	80180	1986-06-06	1986-06-07	1
34032	2025	4283893	2015-11-27	2016-03-04	1
65009	3849	78272	2016-11-06	2016-12-11	1
3158	185	372328	1950-11-06	1951-04-22	1
89528	5329	378001	1979-04-25	1979-06-24	1
5312	312	40481087	2013-05-04	2013-05-11	1
11574	685	40481087	1986-08-18	1986-09-08	1
66823	3956	40481087	1959-11-15	1959-11-22	1
4676	273	40481087	2002-08-02	2002-08-09	1
86108	5128	4230399	2009-12-26	2010-01-25	1
4615	270	40481087	1984-06-29	1984-07-06	1
58043	3442	40481087	1966-08-09	1966-08-30	1
55957	3315	4113008	1977-07-16	1977-08-06	1
39517	2343	4266809	1995-12-25	1995-12-26	1
61895	3658	40481087	1996-06-15	1996-06-29	1
6339	372	378001	1973-06-30	1973-07-30	1
71107	4222	192671	1987-02-17	1987-02-18	1
66276	3927	4112343	1954-05-09	1954-05-16	1
3009	176	4109685	1990-08-02	1990-08-23	1
59077	3509	4113008	1954-12-12	1954-12-26	1
6306	370	4112343	1975-07-12	1975-07-25	1
56299	3342	257012	2002-12-14	2002-12-15	1
36338	2152	40481087	1933-12-01	1933-12-22	1
65490	3876	40481087	1978-04-29	1978-05-20	1
73070	4347	372328	1969-05-24	1969-09-14	1
3897	224	40481087	1944-09-28	1944-10-12	1
66721	3951	4310024	1984-01-13	1984-01-14	1
8983	526	4112343	1986-04-08	1986-04-15	1
1787	101	4218389	2000-06-24	2000-07-29	1
60923	3610	4112343	2001-04-06	2001-04-15	1
66773	3955	40481087	2011-06-03	2011-06-17	1
2590	153	81893	1982-03-27	1982-03-28	1
63568	3757	4146173	1973-04-23	1973-06-22	1
8424	489	4112343	1993-10-12	1993-10-23	1
65057	3852	40481087	1999-02-19	1999-02-26	1
3813	220	260139	1993-07-20	1993-08-03	1
89231	5314	40481087	2000-11-12	2000-11-19	1
67998	4020	40481087	1999-07-08	1999-07-22	1
69214	4101	260139	1978-05-24	1978-05-31	1
712	40	40481087	1952-10-07	1952-10-28	1
4782	280	317576	2015-02-27	2015-02-28	1
81129	4816	0	1982-11-11	1982-11-12	1
66031	3909	28060	2015-03-05	2015-03-12	1
3997	232	4156265	1958-02-26	1958-03-12	1
7834	458	80180	2007-06-21	2007-06-22	1
62317	3686	30753	2008-08-06	2008-08-07	1
7340	431	40481087	1954-11-13	1954-11-27	1
64582	3823	260139	1997-07-09	1997-07-23	1
3456	197	40481087	2013-12-24	2014-01-14	1
6851	403	4112343	1974-09-12	1974-09-25	1
57784	3432	4218389	1974-12-29	1975-01-26	1
4503	264	4149245	1969-10-18	1969-11-24	1
60194	3566	40481087	1980-07-10	1980-07-31	1
63979	3784	40481087	1966-06-29	1966-07-06	1
33872	2013	40481087	1983-04-02	1983-04-16	1
12669	752	321042	1979-02-04	1979-02-05	1
59388	3526	260139	1994-03-07	1994-03-14	1
34033	2025	40481087	1998-07-29	1998-08-12	1
65010	3849	4112343	1980-01-17	1980-01-26	1
3601	207	80180	1975-07-29	1975-07-30	1
89529	5329	4094814	1951-07-30	1951-09-28	1
5650	334	260139	1962-11-12	1962-11-26	1
11575	685	40481087	2016-01-11	2016-01-25	1
66824	3956	40481087	1973-12-28	1974-01-11	1
6104	359	28060	1982-07-13	1982-07-23	1
86109	5128	4294548	2012-02-18	2012-03-10	1
4616	270	40481087	1994-06-19	1994-07-03	1
58044	3442	81151	2011-07-15	2011-08-19	1
55958	3315	4283893	2015-03-31	2015-04-14	1
39518	2343	40481087	1962-04-18	1962-04-25	1
61896	3658	80180	1999-06-13	1999-06-14	1
6340	372	4152936	1968-02-06	1968-02-27	1
71108	4222	260139	1956-03-12	1956-03-19	1
66277	3927	4112343	2013-09-15	2013-09-24	1
3010	176	4112343	1986-10-08	1986-10-15	1
59078	3509	40481087	1956-04-16	1956-04-30	1
6307	370	4112343	1977-04-19	1977-04-28	1
56300	3342	260139	1995-09-17	1995-10-01	1
36812	2180	78272	2010-12-25	2011-01-15	1
65491	3876	4112343	1982-04-28	1982-05-11	1
73071	4347	4134304	1972-11-09	1973-01-08	1
5186	307	260139	1990-08-02	1990-08-16	1
66722	3951	40481087	2004-04-24	2004-05-15	1
8984	526	40481087	1976-07-02	1976-07-09	1
1788	101	40481087	1931-08-01	1931-08-22	1
60924	3610	4112343	2003-07-05	2003-07-13	1
66774	3955	78272	1976-03-20	1976-04-03	1
2591	153	260139	1944-06-06	1944-06-20	1
63569	3757	40481087	1973-10-01	1973-10-08	1
8425	489	4146173	2008-03-21	2008-04-20	1
65058	3852	40481087	2002-02-15	2002-03-01	1
3814	220	260139	2019-01-11	2019-01-25	1
89232	5314	30753	1991-11-09	1991-11-10	1
67999	4020	372328	1958-12-16	1959-02-05	1
69215	4101	260139	2014-08-08	2014-08-15	1
713	40	40481087	1970-02-10	1970-02-17	1
4783	280	4112343	1962-08-09	1962-08-22	1
81130	4816	80180	2017-12-15	2017-12-16	1
66032	3909	260139	2012-12-23	2013-01-06	1
3998	232	4285898	1982-01-11	1982-01-12	1
7835	458	372328	1975-07-11	1975-08-17	1
62318	3686	80180	2009-10-30	2009-10-31	1
7341	431	40481087	1985-06-22	1985-06-29	1
64583	3823	40481087	1958-12-26	1959-01-16	1
3457	197	28060	2015-02-26	2015-03-07	1
6852	403	4294548	1928-05-03	1928-05-24	1
57785	3432	40481087	1955-12-17	1955-12-24	1
4504	264	4296204	2008-07-31	2008-08-21	1
60195	3566	40481087	2004-03-23	2004-03-30	1
63980	3784	40481087	1975-11-01	1975-11-15	1
33873	2013	81151	1965-07-28	1965-08-25	1
12670	752	372328	1950-02-13	1950-04-16	1
59389	3526	4112343	1990-10-07	1990-10-15	1
34034	2025	40481087	2002-05-30	2002-06-13	1
67013	3967	81151	1998-11-13	1998-12-04	1
3602	207	4059173	2009-07-25	2009-09-23	1
89530	5329	4109685	1998-07-14	1998-08-04	1
5651	334	260139	1982-08-25	1982-09-02	1
11576	685	78272	1980-04-15	1980-05-20	1
66825	3956	40481087	1976-05-20	1976-05-27	1
6105	359	257012	1991-09-14	1991-09-15	1
86110	5128	4296204	2008-01-08	2008-02-05	1
4617	270	40481087	2015-09-30	2015-10-07	1
58045	3442	372328	1963-02-14	1963-05-19	1
55959	3315	40481087	2001-06-17	2001-06-24	1
39519	2343	40481087	1972-01-10	1972-01-24	1
61897	3658	257012	1991-11-06	1991-11-07	1
6341	372	40481087	2003-07-07	2003-07-21	1
71109	4222	372328	1951-09-21	1951-11-22	1
66278	3927	40481087	1951-08-13	1951-08-27	1
3011	176	4149245	1975-05-16	1975-07-22	1
59079	3509	28060	1976-09-21	1976-10-04	1
6308	370	4112343	1999-05-05	1999-05-17	1
56301	3342	4112343	1914-03-17	1914-03-30	1
36813	2180	81151	1989-04-05	1989-04-19	1
65492	3876	4112343	1988-02-11	1988-02-23	1
73072	4347	40481087	1997-09-29	1997-10-06	1
5187	307	4109685	1990-08-03	1990-08-24	1
66723	3951	372328	1946-03-13	1946-08-31	1
8985	526	4166224	2008-02-16	2008-02-17	1
1789	101	40481087	1938-04-15	1938-04-22	1
60925	3610	4116491	1966-05-01	1966-06-22	1
66775	3955	80180	1995-03-16	1995-03-17	1
2592	153	440086	1957-06-06	1960-01-14	1
63570	3757	260139	1959-05-11	1959-05-25	1
8426	489	40481087	1981-03-20	1981-04-10	1
65059	3852	40481087	2005-07-15	2005-08-05	1
3815	220	372328	1986-12-17	1987-08-12	1
89233	5314	80180	1992-10-04	1992-10-05	1
68000	4020	4156265	1968-02-18	1968-03-03	1
69216	4101	378001	1962-01-17	1962-03-18	1
714	40	40481087	1998-10-12	1998-10-26	1
4784	280	4112343	1997-11-09	1997-11-19	1
81131	4816	4059173	1997-03-09	1997-06-07	1
66033	3909	372328	1967-02-02	1967-08-11	1
3999	232	40481087	1980-04-17	1980-04-24	1
7836	458	439777	2012-08-03	2012-08-04	1
62319	3686	260139	1972-09-25	1972-10-09	1
7342	431	80180	1985-01-06	1985-01-07	1
64584	3823	78272	2014-10-19	2014-11-23	1
3458	197	81151	1969-02-03	1969-03-03	1
6853	403	40481087	2008-12-14	2008-12-28	1
57786	3432	257012	1952-06-19	1952-06-20	1
4505	264	40481087	1962-11-01	1962-11-08	1
60196	3566	40481087	2010-12-31	2011-01-14	1
63981	3784	260139	1937-05-04	1937-05-18	1
33874	2013	260139	1975-11-24	1975-12-08	1
12671	752	4112343	1985-11-21	1985-12-04	1
59390	3526	4112343	2009-04-12	2009-04-22	1
34035	2025	260139	1926-06-22	1926-06-29	1
67014	3967	260139	1980-01-18	1980-01-25	1
3603	207	4112343	1973-09-10	1973-09-23	1
89531	5329	4113008	1946-10-03	1946-10-24	1
5652	334	260139	2012-11-25	2012-12-02	1
11577	685	78272	1991-03-24	1991-04-07	1
66826	3956	260139	1924-03-22	1924-04-05	1
6106	359	260139	1988-01-08	1988-01-22	1
86111	5128	40480160	2019-05-08	2019-06-07	1
4618	270	0	2012-06-05	2012-06-06	1
58046	3442	4112343	1974-06-11	1974-06-22	1
55960	3315	4112343	2002-02-07	2002-02-16	1
39520	2343	40481087	1980-02-19	1980-03-04	1
61898	3658	372328	1962-07-27	1962-11-11	1
6342	372	195588	1984-05-07	1984-06-10	1
71110	4222	4116491	1970-06-11	1970-07-12	1
66279	3927	40481087	1961-12-29	1962-01-19	1
4707	277	28060	1964-03-02	1964-03-10	1
59080	3509	260139	1961-03-08	1961-03-22	1
6309	370	4112343	2014-07-31	2014-08-11	1
56302	3342	4134304	1979-07-01	1979-07-31	1
36814	2180	260139	1985-02-26	1985-03-12	1
65493	3876	4112343	2006-04-05	2006-04-13	1
73073	4347	40481087	1998-01-09	1998-01-23	1
5188	307	4283893	2016-07-31	2016-11-06	1
66724	3951	378001	1972-02-25	1972-03-26	1
8986	526	4294548	2002-07-14	2002-10-27	1
1790	101	40481087	2017-08-24	2017-09-14	1
60926	3610	40481087	1974-10-26	1974-11-02	1
66776	3955	260139	1989-08-10	1989-08-24	1
2593	153	4027663	1975-06-02	1975-06-03	1
63571	3757	4112343	1988-11-06	1988-11-16	1
8427	489	40481087	1987-04-29	1987-05-06	1
65060	3852	260139	1997-01-02	1997-01-16	1
3816	220	372328	1993-02-11	1993-07-28	1
89234	5314	257012	1963-10-02	1963-10-03	1
68001	4020	4296205	1972-09-08	1972-09-22	1
69217	4101	4112343	1978-05-17	1978-05-30	1
715	40	260139	1972-02-28	1972-03-06	1
4785	280	4134304	1949-11-13	1950-01-12	1
81132	4816	4285898	2017-05-19	2017-05-20	1
66034	3909	4035415	1962-08-13	1962-09-12	1
4000	232	40481087	1998-09-05	1998-09-19	1
7837	458	4112343	1978-03-31	1978-04-07	1
62320	3686	260139	1991-11-29	1991-12-06	1
7343	431	4112343	1951-07-18	1951-07-28	1
64585	3823	257012	2011-01-30	2011-01-31	1
3459	197	81893	1995-10-05	1995-10-06	1
9514	565	260139	1962-10-07	1962-10-21	1
57787	3432	4112343	1995-10-20	1995-11-01	1
4506	264	40481087	1977-01-27	1977-02-17	1
60197	3566	260139	1977-02-23	1977-03-02	1
63982	3784	4112343	1987-07-07	1987-07-19	1
38374	2283	260139	1960-01-15	1960-01-29	1
12672	752	4112343	2014-05-08	2014-05-21	1
59391	3526	4278672	2000-11-09	2000-12-09	1
34036	2025	260139	1965-10-30	1965-11-13	1
67015	3967	260139	2009-07-23	2009-08-06	1
3604	207	4112343	1986-05-21	1986-05-28	1
89532	5329	40481087	1950-10-20	1950-11-03	1
5653	334	4112343	1965-01-13	1965-01-23	1
11578	685	81151	1977-07-09	1977-07-30	1
66827	3956	260139	2012-10-02	2012-10-09	1
6107	359	40481087	2006-03-31	2006-04-07	1
86112	5128	40481087	2000-06-27	2000-07-04	1
4619	270	30753	1994-08-19	1994-08-20	1
58047	3442	4283893	1983-10-27	1983-11-24	1
55961	3315	4112343	2013-02-07	2013-02-18	1
39521	2343	40481087	1988-09-23	1988-10-14	1
61899	3658	375671	1965-07-11	1965-09-09	1
6343	372	260139	1980-02-05	1980-02-12	1
71111	4222	4146173	1959-06-24	1959-08-23	1
66280	3927	40481087	1962-07-26	1962-08-16	1
4708	277	80180	2001-01-05	2001-01-06	1
59081	3509	4112343	1987-11-10	1987-11-19	1
6310	370	4218389	2002-10-12	2002-11-02	1
56303	3342	4152936	1923-07-24	1923-08-14	1
36815	2180	4112343	1984-10-13	1984-10-23	1
65494	3876	4278672	2017-12-23	2018-01-22	1
73074	4347	40481087	2014-06-16	2014-07-07	1
5189	307	40481087	2000-07-15	2000-07-22	1
66725	3951	4112343	1948-12-31	1949-01-08	1
8987	526	40481087	2009-06-28	2009-07-19	1
2318	137	80180	2005-04-12	2005-04-13	1
60927	3610	80809	2017-04-18	2017-04-19	1
66777	3955	260139	2004-03-09	2004-03-16	1
2594	153	4112343	1945-08-10	1945-08-19	1
63572	3757	80180	1985-02-01	1985-02-02	1
8428	489	40481087	1989-01-30	1989-02-13	1
65061	3852	260139	2013-05-05	2013-05-19	1
3817	220	4218389	1991-12-04	1991-12-25	1
89235	5314	260139	1959-05-12	1959-05-19	1
68002	4020	40481087	1979-10-28	1979-11-04	1
69218	4101	40481087	2011-12-10	2011-12-24	1
716	40	372328	1961-03-31	1961-12-27	1
4786	280	80180	1975-01-07	1975-01-08	1
81133	4816	4310024	2015-09-27	2015-09-28	1
67756	4009	80180	1992-05-15	1992-05-16	1
4001	232	40481087	2014-08-01	2014-08-22	1
7838	458	40481087	2014-05-09	2014-05-30	1
62321	3686	378001	1982-12-31	1983-03-01	1
7344	431	4112343	1995-06-19	1995-06-30	1
64586	3823	4112343	1962-11-02	1962-11-15	1
3460	197	260139	1968-09-08	1968-09-15	1
9515	565	372328	1962-06-13	1962-10-17	1
57788	3432	4112343	2008-08-24	2008-09-01	1
4507	264	260139	1978-06-15	1978-06-29	1
60198	3566	260139	2005-07-31	2005-08-14	1
63983	3784	40481087	1967-08-06	1967-08-27	1
38375	2283	372328	1951-04-22	1951-12-31	1
12673	752	40481087	1950-04-29	1950-05-20	1
59392	3526	4296204	1961-12-24	1962-01-07	1
34037	2025	260139	2012-10-26	2012-11-02	1
67016	3967	4112343	1994-12-14	1994-12-25	1
3605	207	4112343	2008-04-06	2008-04-18	1
89533	5329	40481087	1973-08-21	1973-09-11	1
5654	334	4230399	2006-08-29	2006-09-28	1
11579	685	378001	1971-10-09	1971-12-08	1
66828	3956	372328	1917-07-25	1917-10-14	1
6108	359	40481087	2006-09-10	2006-10-01	1
86113	5128	40481087	2005-08-12	2005-09-02	1
4620	270	80180	1995-05-16	1995-05-17	1
58048	3442	40481087	1962-03-13	1962-03-27	1
55962	3315	4146173	2003-08-04	2003-10-03	1
39522	2343	40481087	1996-11-09	1996-11-23	1
61900	3658	4112343	1986-08-16	1986-08-28	1
6344	372	260139	1996-03-30	1996-04-13	1
71112	4222	40481087	1981-05-25	1981-06-08	1
66281	3927	40481087	1986-05-09	1986-05-30	1
4709	277	260139	1976-01-29	1976-02-05	1
59082	3509	4116491	1972-01-09	1972-02-17	1
6311	370	4278672	1994-01-27	1994-02-26	1
56304	3342	4283893	2002-11-09	2003-03-08	1
36816	2180	40481087	2003-06-30	2003-07-21	1
65495	3876	133834	1972-02-02	1972-02-03	1
73075	4347	40481087	2014-08-13	2014-08-27	1
5190	307	80180	2009-09-29	2009-09-30	1
66726	3951	4112343	1963-08-17	1963-08-27	1
8988	526	260139	1973-07-15	1973-07-22	1
2319	137	4084167	1972-10-22	1972-10-23	1
60928	3610	260139	2003-12-05	2003-12-12	1
66778	3955	4112343	1983-10-11	1983-10-18	1
2595	153	40481087	1950-11-20	1950-12-11	1
63573	3757	81151	1956-08-22	1956-09-19	1
9567	569	80502	1993-03-20	1993-03-21	1
65062	3852	372328	1953-08-28	1953-09-11	1
3818	220	40481087	1997-05-05	1997-05-26	1
89236	5314	260139	1962-08-03	1962-08-10	1
68003	4020	40481087	1996-04-26	1996-05-17	1
69219	4101	30753	1998-12-09	1998-12-10	1
717	40	4112343	1974-12-21	1974-12-29	1
4787	280	192671	1975-02-02	1975-02-03	1
81973	4867	28060	1962-12-18	1962-12-27	1
67757	4009	81151	1955-08-18	1955-09-08	1
4002	232	81893	1980-11-17	1980-11-18	1
7839	458	260139	1991-12-12	1991-12-19	1
62322	3686	4027663	2000-11-11	2000-11-12	1
7345	431	40481087	1951-11-16	1951-11-23	1
64587	3823	4112343	1966-12-26	1967-01-03	1
3461	197	4109685	1975-10-26	1975-11-16	1
9516	565	372328	1963-05-15	1964-03-11	1
57789	3432	4278672	1967-05-10	1967-08-08	1
4508	264	317576	2005-09-02	2005-09-03	1
60199	3566	378001	2016-05-20	2016-06-19	1
63984	3784	28060	1932-01-01	1932-01-14	1
38376	2283	378001	1943-12-16	1944-02-14	1
12674	752	40481087	1953-06-10	1953-06-24	1
59393	3526	4310024	1984-11-13	1984-11-14	1
34038	2025	381316	2007-07-21	2007-07-22	1
67017	3967	4155034	1978-08-16	1978-08-30	1
3606	207	4112343	2010-06-11	2010-06-20	1
89534	5329	40481087	2009-08-31	2009-09-21	1
5655	334	4278672	2005-09-03	2005-11-02	1
11580	685	4285898	1999-10-22	1999-10-23	1
66829	3956	440448	1952-10-30	1952-10-31	1
6109	359	4112343	2008-03-06	2008-03-19	1
86114	5128	81151	1943-05-14	1943-05-28	1
4621	270	81893	1994-02-20	1994-02-21	1
58049	3442	40481087	1971-12-08	1971-12-22	1
55963	3315	40481087	1975-11-08	1975-11-22	1
39523	2343	4218389	1986-03-12	1986-04-09	1
61901	3658	4113008	1977-05-09	1977-05-30	1
6345	372	260139	2004-04-14	2004-04-28	1
71113	4222	40481087	1983-01-06	1983-01-20	1
68111	4027	81151	2006-02-16	2006-03-23	1
4710	277	260139	1986-11-20	1986-11-27	1
59083	3509	4218389	1949-12-26	1950-01-23	1
6312	370	40481087	1967-08-27	1967-09-03	1
56305	3342	40481087	1936-12-22	1937-01-12	1
36817	2180	40481087	2011-02-17	2011-03-10	1
65496	3876	4048171	1971-05-28	1971-05-29	1
73076	4347	81151	1971-12-10	1972-01-14	1
5191	307	81151	1987-10-04	1987-10-18	1
66727	3951	4112343	1985-12-21	1986-01-02	1
8989	526	440448	2008-02-16	2008-02-17	1
2320	137	4084167	1981-11-07	1981-11-08	1
60929	3610	4112343	1961-08-07	1961-08-15	1
66779	3955	4294548	1998-07-25	1998-08-01	1
2596	153	40481087	2001-10-03	2001-10-24	1
63574	3757	81151	2004-11-06	2004-11-20	1
9568	569	195588	1941-05-31	1941-07-13	1
65063	3852	4278672	1964-12-28	1965-01-27	1
6401	377	0	1996-11-07	1996-11-08	1
89237	5314	260139	1976-10-04	1976-10-18	1
68004	4020	28060	1979-07-15	1979-07-27	1
69220	4101	80180	1999-06-07	1999-06-08	1
718	40	4112343	2007-05-31	2007-06-08	1
4788	280	260139	1981-01-08	1981-01-15	1
81974	4867	28060	1988-04-12	1988-04-25	1
67758	4009	192671	1992-06-12	1992-06-13	1
4003	232	260139	1977-04-14	1977-04-28	1
7840	458	4035415	2010-06-25	2010-07-25	1
62323	3686	4266809	2009-10-30	2009-10-31	1
7346	431	40481087	1965-02-23	1965-03-16	1
64588	3823	4112343	1991-01-31	1991-02-12	1
3462	197	4283893	1978-09-07	1978-11-09	1
9517	565	40481087	1993-10-18	1993-11-08	1
57790	3432	260139	1951-12-10	1951-12-17	1
4509	264	4112343	1955-12-04	1955-12-14	1
60200	3566	4112343	1981-05-20	1981-06-01	1
63985	3784	140673	1984-06-24	1984-06-25	1
38377	2283	4109685	1988-04-30	1988-05-21	1
12675	752	40481087	1970-07-15	1970-07-29	1
59394	3526	40481087	1962-01-31	1962-02-07	1
34039	2025	4059173	1979-09-01	1979-10-31	1
67018	3967	81151	1966-01-30	1966-02-20	1
3607	207	81151	1961-08-31	1961-10-05	1
89535	5329	260139	1996-03-22	1996-04-05	1
5656	334	4278672	2009-09-12	2009-10-12	1
11581	685	30753	1998-12-26	1998-12-27	1
66830	3956	4218389	1939-05-01	1939-06-05	1
6110	359	28060	1990-06-12	1990-06-23	1
86115	5128	260139	2009-07-26	2009-08-02	1
4622	270	260139	1966-08-23	1966-08-30	1
58050	3442	40481087	1999-12-05	1999-12-19	1
57480	3414	260139	1981-05-01	1981-05-08	1
39524	2343	40481087	2006-08-05	2006-08-26	1
61902	3658	4152936	1980-05-14	1980-05-28	1
6346	372	4112343	1973-02-09	1973-02-22	1
71114	4222	40481087	1998-05-19	1998-05-26	1
68112	4027	257012	1996-03-23	1996-03-24	1
4711	277	381316	2005-11-29	2005-11-30	1
59084	3509	4278672	2011-03-26	2011-06-24	1
6313	370	40481087	2004-04-24	2004-05-08	1
56306	3342	40481087	1947-09-29	1947-10-20	1
36818	2180	40481087	2013-11-17	2013-11-24	1
65497	3876	4112343	2012-09-10	2012-09-22	1
73077	4347	4112343	1987-02-21	1987-03-03	1
5192	307	372328	1979-10-27	1980-11-08	1
66728	3951	4237458	2011-05-31	2011-07-30	1
8990	526	4056621	2004-04-25	2004-04-26	1
2321	137	4112343	1990-07-04	1990-07-12	1
60930	3610	4112343	1978-10-19	1978-10-30	1
66780	3955	40481087	1957-04-08	1957-04-15	1
2597	153	40481087	2013-08-16	2013-08-30	1
63575	3757	260139	2009-08-19	2009-08-26	1
9569	569	260139	1912-10-25	1912-11-01	1
65064	3852	40481087	1982-12-18	1983-01-01	1
6402	377	192671	2003-04-02	2003-04-03	1
89238	5314	372328	1951-09-20	1951-11-02	1
68005	4020	80180	1999-03-11	1999-03-12	1
69221	4101	372328	1965-09-28	1966-10-15	1
719	40	4278672	1961-03-17	1961-06-15	1
4789	280	4109685	1946-10-16	1946-10-30	1
81975	4867	28060	2006-09-19	2006-09-29	1
67759	4009	195588	1996-07-28	1996-08-30	1
4004	232	4278672	2016-03-05	2016-06-03	1
7841	458	40481087	2015-08-31	2015-09-14	1
62324	3686	4283893	2017-07-21	2017-09-01	1
7347	431	40481087	1972-06-30	1972-07-07	1
64589	3823	4134304	1976-01-21	1976-04-20	1
3463	197	40481087	1972-08-24	1972-09-14	1
9518	565	28060	1974-01-13	1974-01-25	1
57791	3432	372328	1957-04-04	1957-10-25	1
4510	264	4112343	1961-09-12	1961-09-24	1
60201	3566	4218389	1975-10-27	1975-12-01	1
63986	3784	195588	1948-07-03	1948-08-15	1
38378	2283	4112343	1940-01-07	1940-01-14	1
12676	752	40481087	1982-05-05	1982-05-19	1
59395	3526	40481087	1982-04-17	1982-04-24	1
34040	2025	4112343	1956-06-18	1956-07-01	1
67019	3967	195588	2000-04-21	2000-06-10	1
3608	207	260139	1996-10-25	1996-11-01	1
89536	5329	381316	1989-03-01	1989-03-02	1
5657	334	40481087	1999-07-12	1999-07-19	1
11582	685	80180	2000-06-18	2000-06-19	1
66831	3956	4237458	1924-06-18	1924-08-17	1
6111	359	78272	1983-09-21	1983-10-19	1
86116	5128	40480160	2009-12-26	2010-01-25	1
4623	270	4112343	2019-03-07	2019-03-16	1
58051	3442	40481087	2018-03-04	2018-03-11	1
57481	3414	378001	1971-12-04	1972-02-02	1
39525	2343	40481087	2007-04-30	2007-05-07	1
61903	3658	4156265	2005-05-17	2005-05-31	1
6347	372	4035415	2018-12-22	2019-02-20	1
72663	4324	81893	1998-08-31	1998-09-01	1
68113	4027	260139	1974-10-04	1974-10-11	1
4712	277	40481087	2001-12-17	2001-12-24	1
59085	3509	40481087	1947-02-07	1947-02-28	1
8383	488	28060	1958-10-24	1958-11-05	1
56307	3342	40481087	1980-10-15	1980-10-22	1
36819	2180	4112343	1979-01-30	1979-02-11	1
68284	4040	260139	2009-03-12	2009-03-26	1
73078	4347	4142905	1974-02-02	1974-03-04	1
5193	307	4027663	2002-06-13	2002-06-14	1
66729	3951	4266809	1986-08-30	1986-08-31	1
8991	526	40481087	1990-03-30	1990-04-20	1
2322	137	4237458	1984-08-11	1984-09-10	1
60931	3610	40481087	2001-12-18	2002-01-08	1
66781	3955	40481087	1978-07-03	1978-07-24	1
2598	153	28060	1951-07-07	1951-07-15	1
63576	3757	4112343	1952-09-26	1952-10-04	1
9570	569	260139	1956-06-10	1956-06-17	1
65065	3852	40481087	1988-01-24	1988-02-14	1
6403	377	260139	1979-01-02	1979-01-16	1
89239	5314	4112343	1958-05-19	1958-05-26	1
68006	4020	260139	1965-02-23	1965-03-02	1
69222	4101	380378	1960-02-27	1960-02-28	1
720	40	40481087	1998-02-16	1998-03-09	1
4790	280	4112343	1997-06-01	1997-06-11	1
81976	4867	260139	2001-07-17	2001-07-24	1
67760	4009	260139	1959-01-12	1959-01-19	1
4005	232	4296205	1953-08-30	1953-09-20	1
7842	458	28060	1978-05-10	1978-05-18	1
62325	3686	28060	1980-01-17	1980-01-26	1
10747	639	80180	1989-05-14	1989-05-15	1
64590	3823	4155034	2009-01-27	2009-02-17	1
3464	197	40481087	1988-03-20	1988-04-10	1
9519	565	40481087	1970-04-24	1970-05-15	1
57792	3432	4218389	1986-09-25	1986-10-16	1
4511	264	4112343	1969-06-18	1969-06-25	1
60202	3566	40481087	1955-04-01	1955-04-15	1
63987	3784	260139	1956-07-02	1956-07-16	1
38379	2283	4112343	1948-07-17	1948-07-29	1
12677	752	28060	1983-11-22	1983-11-30	1
62237	3680	133834	1982-01-24	1982-01-25	1
34041	2025	4112343	1996-08-04	1996-08-17	1
67020	3967	440448	1993-04-25	1993-04-26	1
3609	207	40481087	1986-03-28	1986-04-18	1
89537	5329	4109685	2000-09-22	2000-10-06	1
5658	334	28060	1940-02-13	1940-02-25	1
11583	685	440086	1974-02-05	1978-04-25	1
66832	3956	4310024	1956-09-23	1956-09-24	1
6112	359	260139	1986-09-06	1986-09-13	1
86117	5128	40481087	1930-11-24	1930-12-15	1
4624	270	4285898	1995-02-15	1995-02-16	1
58052	3442	81151	2015-06-20	2015-07-04	1
57482	3414	4112343	1993-01-13	1993-01-23	1
42043	2507	40481087	1985-06-03	1985-06-17	1
61904	3658	40481087	1966-04-12	1966-04-19	1
6348	372	4134304	1962-05-08	1962-07-07	1
72664	4324	4112343	2000-09-19	2000-10-01	1
68114	4027	372328	1975-05-30	1975-10-11	1
4713	277	260139	2010-12-09	2010-12-16	1
59086	3509	40481087	2011-06-18	2011-07-09	1
8384	488	80180	1993-12-10	1993-12-11	1
56308	3342	40481087	1982-04-23	1982-05-14	1
36820	2180	40481087	1989-03-10	1989-03-31	1
68285	4040	260139	2017-03-02	2017-03-09	1
73079	4347	40481087	2008-04-02	2008-04-23	1
5194	307	4112343	1969-09-20	1969-09-29	1
66730	3951	4283893	2004-07-22	2004-09-16	1
8992	526	40481087	2000-10-29	2000-11-12	1
2323	137	40481087	1978-10-30	1978-11-06	1
60932	3610	40481087	2013-07-04	2013-07-18	1
66782	3955	40481087	1990-06-21	1990-06-28	1
2599	153	80180	1984-05-15	1984-05-16	1
63577	3757	4146173	1946-02-16	1946-04-17	1
9571	569	372328	1915-02-11	1915-04-03	1
65066	3852	0	2008-03-31	2008-04-01	1
6404	377	4112343	1985-02-01	1985-02-14	1
89240	5314	4116491	1979-11-17	1979-12-28	1
68007	4020	372328	1960-10-27	1961-02-09	1
69223	4101	4029498	1960-02-27	1960-02-28	1
721	40	40481087	2018-01-20	2018-02-03	1
4791	280	40481087	1947-03-20	1947-04-10	1
81977	4867	378001	2003-02-18	2003-04-19	1
67761	4009	4029498	2005-07-26	2005-07-27	1
4006	232	4296205	1988-11-06	1988-11-27	1
7843	458	260139	1974-02-06	1974-02-13	1
62326	3686	4283893	1973-11-25	1974-01-06	1
10748	639	372328	1956-12-04	1957-12-14	1
64591	3823	4283893	2010-12-12	2011-02-20	1
3465	197	40481087	1991-11-27	1991-12-11	1
9520	565	40481087	1982-08-31	1982-09-14	1
57793	3432	4283893	1952-05-15	1952-09-11	1
4512	264	4112343	1977-02-28	1977-03-13	1
63392	3748	4112343	1992-03-17	1992-03-24	1
63988	3784	372328	1972-03-18	1972-08-01	1
38380	2283	4112343	1980-02-23	1980-03-02	1
12678	752	260139	2008-10-10	2008-10-24	1
62238	3680	372328	1985-01-01	1985-09-24	1
34042	2025	4146173	2016-12-13	2017-02-11	1
67021	3967	4112343	1964-03-14	1964-03-25	1
3610	207	28060	2018-08-09	2018-08-16	1
89538	5329	4112343	1994-11-21	1994-11-30	1
5659	334	28060	1974-09-05	1974-09-15	1
11584	685	4112343	1982-05-18	1982-05-30	1
66833	3956	40481087	1962-02-17	1962-02-24	1
6113	359	260139	1992-06-05	1992-06-19	1
86118	5128	40481087	2015-04-02	2015-04-09	1
4625	270	4310024	1993-06-25	1993-06-26	1
58053	3442	260139	1965-03-19	1965-03-26	1
57483	3414	40481087	1978-05-10	1978-05-24	1
42044	2507	80180	2006-05-12	2006-05-13	1
61905	3658	40481087	1985-02-13	1985-03-06	1
6349	372	40481087	1969-10-05	1969-10-19	1
72665	4324	4116491	2019-06-11	2019-06-12	1
68115	4027	4112343	1976-10-05	1976-10-16	1
4714	277	4112343	1983-10-28	1983-11-05	1
59087	3509	40481087	2016-03-12	2016-03-26	1
8385	488	260139	1962-09-21	1962-09-28	1
56309	3342	40481087	1987-06-26	1987-07-10	1
36821	2180	80180	2017-08-06	2017-08-07	1
68286	4040	40481087	1976-05-15	1976-05-29	1
73869	4392	80180	2018-03-06	2018-03-07	1
5195	307	4112343	2007-03-13	2007-03-22	1
66731	3951	4285898	1985-10-04	1985-10-05	1
8993	526	40481087	2008-10-16	2008-10-23	1
2324	137	40481087	1983-04-21	1983-05-12	1
60933	3610	260139	1985-08-31	1985-09-07	1
66783	3955	40481087	2005-07-05	2005-07-26	1
2600	153	260139	1996-10-22	1996-11-05	1
63578	3757	40481087	1954-10-06	1954-10-13	1
9572	569	378001	1953-11-05	1953-12-05	1
65067	3852	134438	1970-10-10	1971-10-07	1
6405	377	4218389	1987-02-04	1987-02-25	1
89241	5314	4155034	1951-11-19	1951-12-03	1
68008	4020	40481087	1957-04-01	1957-04-22	1
69224	4101	4112343	1961-08-21	1961-08-30	1
722	40	260139	1964-12-28	1965-01-04	1
4792	280	40481087	1968-02-26	1968-03-04	1
81978	4867	4112343	1960-02-19	1960-02-29	1
67762	4009	4296204	1983-07-13	1983-07-27	1
4007	232	40481087	1948-12-17	1948-12-31	1
7844	458	260139	2002-06-23	2002-07-07	1
62327	3686	40481087	1980-12-06	1980-12-27	1
10749	639	4112343	2017-03-23	2017-04-03	1
64592	3823	40481087	1967-12-05	1967-12-19	1
3466	197	81151	1985-09-15	1985-09-29	1
9521	565	40481087	2017-04-22	2017-04-29	1
57794	3432	40481087	1976-05-13	1976-05-27	1
4513	264	4156265	1975-10-15	1975-11-05	1
63393	3748	4112343	2005-08-29	2005-09-05	1
63989	3784	4113008	1952-08-02	1952-08-23	1
38381	2283	40481087	1951-03-24	1951-04-14	1
12679	752	260139	2017-12-01	2017-12-15	1
62239	3680	4084167	1979-11-29	1979-11-29	1
34043	2025	4152936	1969-04-05	1969-04-26	1
67022	3967	40481087	2012-02-05	2012-02-19	1
3611	207	80502	2011-04-10	2011-04-11	1
89539	5329	4116491	1996-01-16	1996-02-16	1
5660	334	260139	1944-09-16	1944-09-23	1
11585	685	4112343	1988-01-31	1988-02-13	1
66834	3956	40481087	2008-03-12	2008-04-02	1
6114	359	4112343	1992-02-15	1992-02-25	1
86119	5128	40481087	2018-09-27	2018-10-18	1
4626	270	40481087	1980-12-18	1981-01-08	1
58054	3442	260139	2006-06-12	2006-06-26	1
57484	3414	40481087	2010-10-31	2010-11-07	1
42045	2507	257012	2005-10-07	2006-04-21	1
61906	3658	40481087	1998-07-28	1998-08-18	1
6921	408	81151	2013-01-05	2013-02-02	1
72666	4324	4310024	1998-07-02	1998-07-03	1
68116	4027	4112343	1986-03-30	1986-04-11	1
4715	277	4112343	2009-10-22	2009-10-31	1
59088	3509	80180	1987-05-25	1987-05-26	1
8386	488	4112343	1995-03-29	1995-04-09	1
56310	3342	80180	1950-04-18	1950-04-19	1
36822	2180	378001	2015-08-22	2015-09-21	1
68287	4040	28060	1981-02-13	1981-02-25	1
73870	4392	260139	2004-12-08	2004-12-15	1
5196	307	4142905	1994-08-08	1994-10-07	1
66732	3951	40481087	1961-06-07	1961-06-14	1
8994	526	0	2008-02-16	2008-02-17	1
2325	137	40481087	1983-07-17	1983-08-07	1
60934	3610	260139	1992-07-14	1992-07-28	1
66784	3955	4266809	1995-03-16	1995-03-17	1
2601	153	378001	1978-04-26	1978-06-25	1
63579	3757	40481087	1967-07-15	1967-07-29	1
9573	569	4278672	1999-10-05	1999-12-04	1
65068	3852	260139	1982-09-20	1982-10-04	1
6406	377	40481087	1999-10-30	1999-11-20	1
89242	5314	4285898	1992-01-08	1992-01-09	1
70964	4214	30753	2004-11-15	2004-11-16	1
69225	4101	4112343	1984-04-01	1984-04-12	1
723	40	260139	2002-03-21	2002-03-28	1
4793	280	40481087	1982-03-22	1982-03-29	1
81979	4867	4112343	2003-03-23	2003-04-05	1
67763	4009	40481087	1955-04-23	1955-05-15	1
4008	232	40481087	1964-07-19	1964-08-02	1
7845	458	372328	1973-03-11	1973-04-22	1
62328	3686	40481087	1983-05-13	1983-05-20	1
10750	639	40481087	1988-12-15	1989-01-05	1
64593	3823	40481087	2014-06-10	2014-07-01	1
3467	197	257012	1978-09-28	1978-09-29	1
9522	565	28060	1963-02-24	1963-03-08	1
57795	3432	40481087	2001-02-22	2001-03-08	1
4514	264	4156265	2007-06-16	2007-07-07	1
63394	3748	4218389	2012-11-15	2012-12-13	1
63990	3784	4116491	1954-08-14	1954-09-30	1
38382	2283	260139	2001-08-07	2001-08-14	1
12680	752	4112343	1960-06-03	1960-06-12	1
62240	3680	4280726	1983-04-09	1983-04-10	1
34044	2025	40481087	1969-04-18	1969-04-25	1
67023	3967	0	1993-04-25	1993-04-26	1
3612	207	260139	1963-02-23	1963-03-09	1
89540	5329	40481087	1949-12-24	1950-01-14	1
5661	334	372328	1939-04-02	1939-05-10	1
11586	685	4266809	2000-06-18	2000-06-19	1
68818	4078	133834	1953-03-05	1969-01-03	1
6115	359	4146173	1994-03-25	1994-05-24	1
58309	3457	78272	1930-12-01	1930-12-15	1
4627	270	40481087	2000-08-21	2000-08-28	1
58055	3442	4116491	1999-06-03	1999-07-19	1
57485	3414	260139	1969-08-17	1969-08-31	1
42046	2507	260139	1992-05-22	1992-06-05	1
61907	3658	40481087	2019-01-09	2019-01-23	1
6922	408	195588	1985-06-01	1985-07-12	1
72667	4324	40481087	1976-09-26	1976-10-17	1
68117	4027	4112343	1991-05-31	1991-06-08	1
4716	277	372328	1966-09-16	1966-11-08	1
59089	3509	81151	1943-01-11	1943-02-01	1
8387	488	4278672	1977-02-02	1977-04-03	1
56311	3342	260139	1977-08-13	1977-08-20	1
36823	2180	4112343	2000-12-30	2001-01-12	1
68288	4040	28060	1986-11-27	1986-12-04	1
73871	4392	4112343	1991-06-15	1991-06-27	1
5197	307	40481087	2008-04-02	2008-04-23	1
68935	4085	260139	1976-10-03	1976-10-10	1
8995	526	81151	1998-11-29	1998-12-27	1
2326	137	40481087	2011-04-18	2011-04-25	1
60935	3610	4296205	2017-06-26	2017-07-10	1
66785	3955	40481087	1957-07-22	1957-08-05	1
2602	153	4109685	1972-10-10	1972-10-24	1
63580	3757	260139	2004-11-20	2004-12-04	1
9574	569	4283893	1994-03-24	1994-04-21	1
65069	3852	4112343	1968-11-10	1968-11-21	1
6407	377	260139	1998-06-06	1998-06-20	1
89243	5314	40481087	2016-01-22	2016-02-05	1
70965	4214	257012	2004-03-31	2004-04-01	1
69226	4101	4112343	1988-01-23	1988-01-30	1
724	40	381316	2006-11-29	2006-11-30	1
4794	280	40481087	2012-12-08	2012-12-29	1
81980	4867	4134304	1979-09-08	1979-11-07	1
67764	4009	40481087	1984-12-03	1984-12-17	1
4009	232	40481087	1969-04-26	1969-05-10	1
7846	458	4112343	1974-04-09	1974-04-20	1
62329	3686	40481087	2009-07-29	2009-08-12	1
10751	639	192671	1989-06-08	1989-06-09	1
64594	3823	81893	1992-08-29	1992-08-30	1
3468	197	4027663	1989-09-11	1989-09-12	1
9523	565	80180	1994-09-28	1994-09-29	1
57796	3432	80180	1994-06-16	1994-06-17	1
4515	264	4329847	2011-11-11	2011-11-12	1
63395	3748	80180	2015-10-30	2015-10-31	1
63991	3784	4142905	1945-07-19	1945-09-17	1
38383	2283	317576	2018-11-19	2018-11-20	1
12681	752	4112343	2016-02-13	2016-02-23	1
62241	3680	28060	1999-11-17	1999-11-29	1
34045	2025	28060	2012-01-28	2012-02-05	1
67024	3967	30753	2002-12-12	2002-12-13	1
3613	207	260139	2009-03-23	2009-03-30	1
89541	5329	40481087	1986-09-03	1986-09-24	1
5662	334	372328	1983-08-17	1985-05-15	1
11587	685	40481087	1979-06-04	1979-06-18	1
68819	4078	260139	1967-09-12	1967-09-19	1
6116	359	4283893	1991-08-17	1992-04-04	1
58310	3457	80502	1976-10-29	1976-10-30	1
6371	376	30753	1998-11-09	1998-11-10	1
58056	3442	4218389	2014-08-03	2014-08-24	1
57486	3414	260139	1982-04-05	1982-04-19	1
42047	2507	260139	2009-03-11	2009-03-25	1
61908	3658	192671	1999-09-01	1999-09-02	1
6923	408	40481087	2005-12-22	2006-01-12	1
72668	4324	40481087	2002-01-15	2002-01-22	1
68118	4027	40481087	1983-04-06	1983-04-27	1
4717	277	81151	1987-09-26	1987-10-17	1
59090	3509	81151	1962-04-18	1962-05-09	1
8388	488	40481087	2000-01-07	2000-01-14	1
56312	3342	260139	1997-02-01	1997-02-08	1
36824	2180	40481087	1986-12-25	1987-01-15	1
68289	4040	4132546	1991-06-04	1991-06-05	1
73872	4392	4113008	2001-09-18	2001-10-09	1
5198	307	40481087	2016-01-21	2016-01-28	1
68936	4085	260139	2006-08-25	2006-09-01	1
8996	526	257012	2002-08-04	2002-08-05	1
2327	137	28060	1978-11-04	1978-11-13	1
60936	3610	40481087	1949-12-05	1949-12-12	1
66786	3955	40481087	1981-03-18	1981-04-01	1
2603	153	4112343	1961-07-23	1961-07-30	1
63581	3757	372328	1947-02-11	1947-07-30	1
9575	569	4294548	1935-11-20	1936-04-01	1
65070	3852	4152936	1995-01-20	1995-02-03	1
6408	377	4112343	1999-04-04	1999-04-14	1
89244	5314	372328	1954-11-16	1955-11-04	1
70966	4214	317576	2018-12-18	2018-12-19	1
69227	4101	4156265	1987-12-30	1988-01-20	1
725	40	4112343	1977-12-15	1977-12-28	1
6210	366	260139	1961-10-03	1961-10-17	1
81981	4867	40479768	2011-03-08	2011-04-14	1
67765	4009	40481087	1987-06-13	1987-07-04	1
4010	232	40481087	1975-05-18	1975-06-08	1
7847	458	4112343	1981-01-04	1981-01-11	1
62330	3686	260139	1985-02-25	1985-03-04	1
10752	639	260139	1965-05-01	1965-05-15	1
64595	3823	313217	2008-11-05	2008-11-06	1
3469	197	4094814	1992-05-25	1992-06-24	1
9524	565	260139	1980-07-14	1980-07-28	1
57797	3432	260139	1989-09-30	1989-10-07	1
4516	264	40481087	1967-10-02	1967-10-16	1
63396	3748	260139	2008-08-09	2008-08-16	1
63992	3784	4218389	1949-08-27	1949-09-17	1
38384	2283	378001	1947-08-27	1947-09-26	1
12682	752	4152936	1979-10-18	1979-11-08	1
62242	3680	80180	2018-05-13	2018-05-14	1
34046	2025	81151	1954-09-11	1954-10-16	1
67025	3967	80180	2003-12-07	2003-12-08	1
3614	207	372328	1945-10-08	1946-09-08	1
89542	5329	40481087	2003-06-05	2003-06-12	1
5663	334	4218389	1979-02-19	1979-03-26	1
11588	685	40481087	1987-08-12	1987-09-02	1
68820	4078	4112343	1964-01-17	1964-01-25	1
6117	359	80180	2014-10-28	2014-10-29	1
58311	3457	257012	1980-03-08	1980-03-09	1
6372	376	260139	1986-12-31	1987-01-14	1
58057	3442	40481087	2017-06-10	2017-07-01	1
57487	3414	260139	2013-10-27	2013-11-10	1
42048	2507	372328	1969-08-19	1969-10-07	1
61909	3658	260139	1992-12-10	1992-12-17	1
6924	408	40481087	2013-11-06	2013-11-27	1
72669	4324	40481087	2007-04-20	2007-05-04	1
68119	4027	80180	2008-04-16	2008-04-17	1
4718	277	4112343	1965-07-05	1965-07-18	1
59091	3509	81151	1989-12-18	1990-01-15	1
8389	488	4112343	1962-07-31	1962-08-09	1
56313	3342	372328	1910-02-02	1910-03-16	1
36825	2180	40481087	1998-05-06	1998-05-20	1
68290	4040	40481087	2003-05-09	2003-05-30	1
73873	4392	4278672	2005-09-18	2005-11-17	1
5199	307	81151	1983-08-05	1983-08-26	1
68937	4085	372328	1961-11-02	1962-03-10	1
8997	526	260139	1988-04-06	1988-04-13	1
2328	137	28060	1985-11-10	1985-11-17	1
60937	3610	40481087	1950-06-19	1950-07-03	1
66787	3955	40481087	2004-05-28	2004-06-04	1
2604	153	4112343	1975-03-03	1975-03-10	1
63582	3757	4112343	1997-05-06	1997-05-14	1
9576	569	40481087	1923-01-05	1923-01-19	1
65071	3852	40481087	1983-04-08	1983-04-29	1
6409	377	4294548	1994-09-30	1994-10-21	1
89245	5314	4027663	1981-11-16	1981-11-17	1
70967	4214	4112343	1981-04-27	1981-05-07	1
69228	4101	4218389	1973-08-17	1973-09-14	1
726	40	4112343	2003-02-05	2003-02-18	1
6211	366	260139	1965-07-10	1965-07-17	1
81982	4867	40481087	1927-05-04	1927-05-11	1
67766	4009	40481087	2006-11-28	2006-12-05	1
4011	232	378001	2002-11-14	2003-01-13	1
7848	458	4112343	1986-05-18	1986-05-29	1
62331	3686	4112343	2016-08-16	2016-08-27	1
10753	639	260139	1983-02-01	1983-02-15	1
64596	3823	372328	1956-06-04	1956-09-19	1
3470	197	4112343	1963-09-05	1963-09-13	1
9525	565	372328	1958-07-19	1958-12-31	2
57798	3432	4029498	1953-11-08	1953-11-09	1
4517	264	40481087	1987-05-26	1987-06-02	1
63397	3748	260139	2009-06-14	2009-06-21	1
63993	3784	40481087	1954-05-10	1954-05-24	1
38385	2283	40481087	1962-10-06	1962-10-27	1
12683	752	4237458	1951-10-15	1952-01-13	1
62243	3680	260139	2000-10-25	2000-11-08	1
34047	2025	260139	1953-08-25	1953-09-01	1
67026	3967	195588	2004-06-09	2004-07-23	1
3615	207	40481087	1994-12-08	1994-12-15	1
89543	5329	4112343	1950-06-18	1950-06-29	1
5664	334	40480160	2006-08-29	2006-09-28	1
13167	776	78272	1967-05-27	1967-06-10	1
68821	4078	4112343	2006-07-26	2006-08-06	1
6118	359	4112343	1978-09-18	1978-09-30	1
58312	3457	372328	1921-04-08	1921-08-12	1
6373	376	372328	1964-03-12	1964-04-02	1
58692	3486	81151	1974-12-06	1975-01-03	1
57488	3414	4112343	2013-04-06	2013-04-15	1
42049	2507	372328	1973-01-19	1973-04-17	1
61910	3658	4112343	1968-09-25	1968-10-07	1
6925	408	28060	1964-08-22	1964-09-02	1
72670	4324	28060	1961-08-12	1961-08-19	1
68120	4027	321042	2014-06-21	2014-06-22	1
4719	277	4112343	1981-06-27	1981-07-06	1
59092	3509	260139	1965-05-11	1965-05-18	1
8390	488	4112343	2016-02-02	2016-02-11	1
56314	3342	378001	1935-08-07	1935-10-06	1
36826	2180	192671	2017-09-28	2017-09-29	1
68291	4040	40481087	2005-11-20	2005-12-04	1
73874	4392	260139	2003-11-27	2003-12-11	1
5200	307	81893	2007-10-10	2007-10-11	1
68938	4085	372328	1966-05-18	1967-05-06	1
8998	526	260139	2018-04-14	2018-04-21	1
2329	137	78272	1974-03-16	1974-04-06	1
60938	3610	40481087	1955-02-12	1955-03-05	1
66788	3955	28060	1996-01-15	1996-01-22	1
2605	153	4152936	2011-02-02	2011-02-16	1
63583	3757	4142905	1957-09-14	1957-12-13	1
9577	569	40481087	1961-12-21	1962-01-04	1
65072	3852	40481087	2006-01-11	2006-01-18	1
6410	377	78272	1971-10-09	1971-11-13	1
89246	5314	4112343	1986-02-15	1986-02-22	1
70968	4214	4283893	1973-02-02	1973-03-09	1
71637	4255	28060	2008-12-16	2008-12-26	1
727	40	4294548	1960-10-25	1960-12-20	1
6212	366	260139	1987-01-14	1987-01-28	1
81983	4867	40481087	1935-09-16	1935-10-07	1
67767	4009	260139	1952-11-26	1952-12-10	1
4012	232	4059173	1983-05-07	1983-07-06	1
7849	458	4116491	2009-08-04	2009-09-16	1
62332	3686	4285898	2009-07-02	2009-07-03	1
10754	639	372328	1954-03-29	1954-06-12	1
64597	3823	4027663	1983-10-06	1983-10-07	1
3471	197	40481087	1983-06-25	1983-07-09	1
9526	565	4218389	1965-06-12	1965-07-17	1
57799	3432	4218389	1964-06-03	1964-06-24	1
4518	264	40481087	2006-04-10	2006-05-01	1
63398	3748	4048695	1984-12-11	1985-01-11	1
63994	3784	40481087	1972-09-06	1972-09-13	1
38386	2283	80180	1975-07-21	1975-07-22	1
12684	752	40481087	1988-05-26	1988-06-09	1
62244	3680	40481087	1986-09-30	1986-10-21	1
34048	2025	260139	1972-10-29	1972-11-05	1
67027	3967	372328	1965-09-02	1966-04-17	1
3616	207	372328	1941-03-19	1941-06-01	1
89544	5329	4155034	1953-09-17	1953-10-08	1
5665	334	40481087	1994-01-31	1994-02-07	1
13168	776	257012	1979-04-27	1979-08-31	1
68822	4078	40481087	2014-06-16	2014-06-30	1
6685	395	80180	1998-04-27	1998-04-28	1
58313	3457	4156265	1938-07-06	1938-07-20	1
6374	376	4112343	1976-09-19	1976-09-30	1
58693	3486	260139	1995-12-30	1996-01-13	1
57489	3414	4112343	2015-01-06	2015-01-17	1
42050	2507	4156265	2017-07-20	2017-08-03	1
61911	3658	4112343	1969-05-07	1969-05-14	1
6926	408	4084167	1962-02-02	1962-02-03	1
72671	4324	372328	1967-01-30	1967-05-28	1
68121	4027	372328	1976-06-07	1976-10-09	1
6735	399	28060	1979-09-17	1979-09-27	1
59093	3509	372328	1942-12-12	1943-03-26	1
8391	488	40481087	2002-08-07	2002-08-14	1
56315	3342	4112343	1971-10-11	1971-10-21	1
36827	2180	40481087	1990-01-30	1990-02-13	1
68292	4040	40481087	2015-03-12	2015-03-26	1
73875	4392	260139	2017-02-22	2017-03-01	1
5201	307	257012	2016-10-09	2016-10-10	1
68939	4085	4112343	2002-11-30	2002-12-08	1
8999	526	4109685	2008-09-05	2008-09-19	1
2330	137	4112343	1995-06-18	1995-06-29	1
60939	3610	40481087	1979-08-14	1979-08-28	1
66789	3955	260139	2007-03-02	2007-03-09	1
2606	153	4283893	2008-02-17	2008-04-06	1
63584	3757	40481087	1946-02-22	1946-03-15	1
9578	569	40481087	1964-03-29	1964-04-19	1
65073	3852	80180	1990-03-17	1990-03-18	1
6411	377	260139	2010-07-19	2010-07-26	1
89247	5314	4156265	1997-05-05	1997-05-26	1
70969	4214	80180	2005-07-13	2005-07-14	1
71638	4255	80180	2010-02-03	2010-02-04	1
728	40	40481087	1982-03-24	1982-04-14	1
6213	366	4112343	1988-01-21	1988-02-01	1
81984	4867	40481087	1961-09-30	1961-10-21	1
67768	4009	260139	1984-01-08	1984-01-15	1
4013	232	4112343	1947-11-01	1947-11-09	1
10768	640	81151	1962-09-11	1962-10-02	1
62333	3686	40481087	1982-03-29	1982-04-12	1
10755	639	372328	1955-07-07	1955-12-10	1
64598	3823	40481087	1979-08-27	1979-09-17	1
3472	197	40481087	2004-11-19	2004-12-10	1
9527	565	40481087	1981-07-07	1981-07-28	1
57800	3432	4278672	2007-09-10	2007-11-09	1
4519	264	0	2011-11-11	2011-11-12	1
63399	3748	4059173	1987-11-27	1987-12-27	1
63995	3784	40481087	1974-10-10	1974-10-17	1
38387	2283	192671	1975-10-06	1975-10-07	1
12685	752	40481087	1994-02-14	1994-02-28	1
62245	3680	81151	1994-03-15	1994-04-05	1
34049	2025	260139	2013-10-03	2013-10-17	1
67028	3967	4266809	2003-12-07	2003-12-08	1
3617	207	4112343	1940-12-20	1940-12-31	1
89545	5329	40481087	1955-04-20	1955-05-04	1
5666	334	81151	1937-07-24	1937-08-28	1
13169	776	4035415	2011-08-16	2011-09-15	1
68823	4078	372328	1955-11-13	1956-07-16	1
6686	395	260139	1982-02-22	1982-03-08	1
58314	3457	40480160	1986-03-31	1986-06-29	1
6375	376	4112343	1998-08-19	1998-08-28	1
58694	3486	4112343	1961-06-18	1961-06-27	1
57490	3414	40481087	2000-09-16	2000-10-07	1
42051	2507	40481087	1982-01-21	1982-02-11	1
61912	3658	4146173	1968-06-25	1968-08-24	1
6927	408	4112343	1967-11-17	1967-11-24	1
72672	4324	4112343	1984-08-29	1984-09-10	1
68122	4027	4112343	1989-02-26	1989-03-09	1
6736	399	260139	1959-09-11	1959-09-25	1
59094	3509	372328	1946-02-08	1946-12-27	1
8392	488	28060	1958-06-13	1958-06-25	1
56316	3342	4116491	1932-07-01	1932-08-06	1
36828	2180	40481087	1991-04-15	1991-05-06	1
68293	4040	80180	2013-01-20	2013-01-21	1
73876	4392	4094814	2016-10-20	2016-11-19	1
5202	307	4278672	2004-12-13	2005-01-12	1
68940	4085	260139	2014-05-20	2014-05-27	1
9000	526	4116491	2004-02-16	2004-06-04	2
2331	137	4112343	2011-03-17	2011-03-28	1
60940	3610	40481087	1991-08-30	1991-09-13	1
66790	3955	40481087	1973-06-14	1973-06-21	1
2607	153	4310024	1981-12-27	1981-12-28	1
64308	3803	30753	2003-06-27	2003-06-28	1
9579	569	40481087	1977-05-15	1977-05-22	1
65074	3852	260139	1965-11-25	1965-12-09	1
6412	377	321042	1996-11-07	1996-11-08	1
89248	5314	4294548	1963-05-29	1963-11-06	1
70970	4214	260139	1981-12-13	1981-12-20	1
71639	4255	260139	1989-12-26	1990-01-09	1
729	40	40481087	2006-04-24	2006-05-15	1
6214	366	4112343	1995-07-26	1995-08-04	1
81985	4867	80180	1950-01-14	1950-01-15	1
67769	4009	260139	1956-07-18	1956-07-25	1
4014	232	4112343	2018-11-23	2018-12-03	1
10769	640	4112343	1982-04-16	1982-04-26	1
62334	3686	40481087	1997-06-12	1997-06-26	1
10756	639	4112343	1982-09-29	1982-10-08	1
64599	3823	80180	1993-10-23	1993-10-24	1
5986	352	80180	2012-08-28	2012-08-29	1
9528	565	40481087	1999-08-15	1999-08-29	1
57801	3432	40481087	1954-09-08	1954-09-15	1
4520	264	78272	1984-09-16	1984-09-30	1
63400	3748	4112343	1981-01-03	1981-01-13	1
63996	3784	40481087	1975-08-21	1975-08-28	1
38388	2283	260139	1986-06-21	1986-06-28	1
12686	752	40481087	2001-01-20	2001-02-03	1
62246	3680	81151	1995-04-30	1995-05-21	1
34050	2025	260139	2014-05-16	2014-05-30	1
67029	3967	40481087	1965-01-14	1965-01-21	1
3618	207	4146173	1981-03-24	1981-05-23	1
89546	5329	40481087	1959-01-05	1959-01-19	1
5667	334	195588	1964-05-28	1964-07-20	1
13170	776	4112343	1978-08-05	1978-08-18	1
68824	4078	378001	1987-08-09	1987-09-08	1
6687	395	4029498	1972-02-13	1972-02-14	1
58315	3457	40481087	1947-04-21	1947-05-05	1
6376	376	4155034	1977-12-29	1978-01-12	1
58695	3486	4112343	1980-04-14	1980-04-27	1
57491	3414	40481087	2007-07-29	2007-08-12	1
42052	2507	40481087	1995-02-14	1995-03-07	1
61913	3658	4278672	1972-09-02	1972-10-02	1
6928	408	4112343	1991-08-24	1991-09-04	1
72673	4324	4156265	1980-07-31	1980-08-21	1
68123	4027	4112343	2014-05-25	2014-06-04	1
6737	399	260139	2016-12-01	2016-12-15	1
59095	3509	4112343	1988-06-18	1988-06-27	1
8393	488	260139	2002-04-01	2002-04-15	1
56317	3342	4134304	1981-07-20	1981-09-18	1
36829	2180	40481087	2012-10-09	2012-10-16	1
68294	4040	81151	1994-08-17	1994-09-21	1
73877	4392	4112343	1991-05-06	1991-05-14	1
5203	307	4310024	2007-07-12	2007-07-13	1
68941	4085	4112343	1999-08-07	1999-08-17	1
9001	526	40481087	1985-10-25	1985-11-15	1
2332	137	4266809	2005-04-12	2005-04-13	1
60941	3610	40481087	2009-10-25	2009-11-15	1
66791	3955	40481087	1987-04-09	1987-04-30	1
2608	153	40481087	2001-11-28	2001-12-12	1
64309	3803	260139	1983-08-29	1983-09-12	1
9580	569	40481087	2006-09-29	2006-10-20	1
65075	3852	321042	2008-03-31	2008-04-01	1
6413	377	40481087	2000-12-20	2001-01-10	1
89249	5314	40481087	1960-07-10	1960-07-17	1
70971	4214	260139	1998-10-24	1998-10-31	1
71640	4255	40481087	1974-05-28	1974-06-04	1
730	40	28060	1983-09-01	1983-09-14	1
6215	366	4112343	2009-08-23	2009-09-03	1
81986	4867	260139	1918-03-20	1918-03-27	1
67770	4009	380378	2005-07-26	2005-07-27	1
4015	232	40481087	1992-04-22	1992-05-06	1
10770	640	40481087	1951-02-16	1951-02-23	1
64814	3836	260139	1997-11-09	1997-11-23	1
10757	639	4112343	2014-02-24	2014-03-06	1
64600	3823	260139	1969-10-25	1969-11-01	1
5987	352	257012	1984-04-03	1984-04-04	1
9529	565	260139	1960-12-07	1960-12-14	1
57802	3432	40481087	2006-04-17	2006-05-08	1
4521	264	192671	1984-06-22	1984-06-23	1
63401	3748	40481087	2004-11-04	2004-11-25	1
66653	3949	80180	2003-07-27	2003-07-28	1
38389	2283	372328	1939-03-12	1939-03-26	1
12687	752	260139	1952-12-09	1952-12-23	1
62247	3680	260139	1984-09-04	1984-09-18	1
34051	2025	313217	1973-11-10	1973-11-11	1
67030	3967	40481087	1986-06-07	1986-06-28	1
3619	207	40481087	1969-02-27	1969-03-20	1
89547	5329	40481087	1967-05-13	1967-05-20	1
5668	334	255848	2017-11-04	2017-11-05	1
13171	776	4112343	1981-10-03	1981-10-11	1
68825	4078	4112343	2007-05-07	2007-05-15	1
6688	395	4109685	1964-12-21	1965-01-11	1
58316	3457	40481087	2006-06-19	2006-06-26	1
6377	376	4285898	1998-12-09	1998-12-10	1
58696	3486	4112343	1990-09-12	1990-09-20	1
57492	3414	260139	1985-03-05	1985-03-12	1
42053	2507	378001	1991-01-17	1991-02-16	1
63424	3750	30753	1993-09-11	1993-09-12	1
6929	408	4146173	2001-05-08	2001-06-07	1
72674	4324	40481087	1982-08-22	1982-09-05	1
68124	4027	4113008	2012-03-21	2012-04-11	1
6738	399	372328	1957-03-23	1957-09-08	1
59096	3509	4156265	1953-11-03	1953-11-17	1
8394	488	4112343	1970-04-02	1970-04-10	1
56318	3342	4230399	2011-10-11	2012-01-09	1
38518	2290	78272	1998-09-03	1998-09-17	1
68295	4040	260139	1979-11-22	1979-12-06	1
73878	4392	40481087	1991-10-07	1991-10-28	1
5204	307	28060	1981-02-02	1981-02-12	1
68942	4085	4112343	2011-10-24	2011-11-02	1
9002	526	40481087	2003-10-27	2003-11-17	1
2333	137	40481087	1991-06-20	1991-06-27	1
64689	3830	28060	1983-03-13	1983-03-21	1
69877	4139	260139	2017-05-04	2017-05-11	1
2609	153	28060	1943-09-11	1943-09-18	1
64310	3803	4266809	2003-12-24	2003-12-25	1
9581	569	28060	1922-01-07	1922-01-18	1
65076	3852	4296204	2003-09-19	2003-10-10	1
6414	377	40481087	2013-09-10	2013-09-24	1
89250	5314	40481087	1960-11-21	1960-12-05	1
70972	4214	372328	1978-06-23	1978-11-14	1
71641	4255	40481087	1974-10-10	1974-10-17	1
731	40	80180	1993-07-12	1993-07-13	1
6216	366	4218389	1996-08-24	1996-09-14	1
81987	4867	260139	2011-07-03	2011-07-10	1
67771	4009	4218389	1951-09-03	1951-10-07	1
4016	232	40481087	1996-09-18	1996-09-25	1
10771	640	40481087	1960-05-02	1960-05-23	1
64815	3836	260139	2008-09-24	2008-10-01	1
10758	639	4149245	2007-04-20	2007-05-27	1
64601	3823	260139	2013-08-07	2013-08-21	1
5988	352	4113008	2002-01-27	2002-02-17	1
9530	565	260139	1967-12-12	1967-12-19	1
60263	3570	257012	1956-08-07	1956-08-08	1
4522	264	260139	2010-11-12	2010-11-26	1
63402	3748	440086	1991-03-10	1997-03-18	1
66654	3949	260139	1976-01-11	1976-01-18	1
38390	2283	4112343	1943-01-29	1943-02-10	1
12688	752	372328	1949-04-28	1949-10-16	1
62248	3680	260139	2006-07-29	2006-08-12	1
34052	2025	378001	1966-02-20	1966-04-21	1
67031	3967	40481087	2005-12-20	2006-01-10	1
6138	362	260139	1996-12-14	1996-12-28	1
89548	5329	40481087	2004-10-12	2004-11-02	1
5669	334	260139	1970-04-21	1970-05-05	1
13172	776	4116491	1995-09-02	1995-10-11	1
68826	4078	4112343	2008-01-11	2008-01-24	1
6689	395	4112343	1971-10-20	1971-10-30	1
58317	3457	260139	1919-06-19	1919-06-26	1
6378	376	4296204	2012-02-13	2012-03-12	1
58697	3486	4112343	2005-05-07	2005-05-14	1
57493	3414	260139	1994-07-24	1994-08-07	1
42054	2507	4283893	2005-09-09	2006-04-21	1
63425	3750	260139	2003-11-24	2003-12-01	1
6930	408	40481087	1997-02-18	1997-03-04	1
72675	4324	40481087	2004-02-16	2004-03-01	1
68125	4027	40481087	1994-02-06	1994-02-13	1
6739	399	4112343	1960-01-22	1960-01-30	1
59097	3509	4156265	1973-06-10	1973-06-24	1
8395	488	4112343	1971-04-07	1971-04-15	1
56319	3342	4266809	1950-04-18	1950-04-19	1
38519	2290	260139	1992-07-02	1992-07-09	1
68296	4040	372328	1977-02-03	1977-04-18	1
73879	4392	40481087	1993-07-27	1993-08-10	1
5205	307	81151	1981-08-17	1981-09-14	1
68943	4085	4283893	1962-01-12	1962-09-07	1
9003	526	40481087	2006-05-10	2006-05-24	1
2334	137	81893	2004-03-18	2004-03-19	1
64690	3830	372328	1985-07-11	1986-03-23	1
69878	4139	372328	1971-07-04	1971-10-15	1
2610	153	81151	1956-08-30	1956-09-20	1
64311	3803	40481087	1969-10-29	1969-11-12	1
9582	569	78272	1916-09-03	1916-09-24	1
65077	3852	40481087	1985-06-09	1985-06-30	1
6415	377	28060	1970-09-18	1970-09-30	1
89251	5314	40481087	1971-11-24	1971-12-08	1
70973	4214	375671	1991-02-22	1991-03-24	1
71642	4255	40481087	1979-07-27	1979-08-03	1
732	40	257012	1960-11-29	1960-11-30	1
6217	366	40481087	1912-07-19	1912-08-09	1
81988	4867	4109685	1988-08-21	1988-09-04	1
67772	4009	40481087	1961-10-10	1961-10-30	1
4017	232	40481087	1998-05-25	1998-06-01	1
10772	640	260139	1967-07-04	1967-07-18	1
64816	3836	372328	1977-08-01	1977-11-11	1
10759	639	40481087	1979-10-06	1979-10-27	1
64602	3823	260139	2014-05-20	2014-06-03	1
5989	352	4266809	2012-08-28	2012-08-29	1
9531	565	40481087	1967-04-10	1967-05-01	1
60264	3570	260139	1963-11-19	1963-11-26	1
4523	264	4112343	1970-09-22	1970-09-29	1
63403	3748	4113008	2015-12-28	2016-01-11	1
66655	3949	4112343	2014-10-12	2014-10-21	1
38391	2283	4112343	1978-10-22	1978-10-29	1
12689	752	4152936	2000-01-22	2000-02-05	1
62249	3680	4218389	2018-06-19	2018-07-24	1
34053	2025	4112343	1911-08-09	1911-08-20	1
67032	3967	40481087	2006-08-15	2006-08-29	1
6139	362	4155034	1991-07-26	1991-08-09	1
89549	5329	40481087	2006-09-01	2006-09-08	1
5670	334	260139	1992-03-25	1992-04-08	1
13173	776	4156265	2003-02-01	2003-02-15	1
68827	4078	40481087	1981-12-16	1981-12-30	1
6690	395	4112343	1995-06-28	1995-07-11	1
58318	3457	260139	1925-11-06	1925-11-20	1
6379	376	40481087	1969-04-29	1969-05-20	1
58698	3486	4218389	1988-09-21	1988-10-19	1
57494	3414	378001	2016-10-29	2016-11-28	1
42055	2507	40481087	2009-07-02	2009-07-09	1
63426	3750	372328	1974-02-25	1974-12-07	1
6931	408	28060	2010-06-29	2010-07-11	1
72676	4324	40481087	2015-10-10	2015-10-24	1
68126	4027	40481087	2011-06-18	2011-07-09	1
6740	399	4112343	1967-12-05	1967-12-18	1
59098	3509	40481087	2002-11-18	2002-11-25	1
8396	488	4112343	1976-04-22	1976-05-05	1
56320	3342	4285898	1950-01-18	1950-01-19	1
38520	2290	40481087	1962-07-24	1962-08-07	1
68297	4040	4001336	1991-06-04	1991-08-03	1
73880	4392	81151	1991-01-02	1991-01-30	1
5206	307	260139	2019-03-03	2019-03-17	1
68944	4085	40481087	1959-05-09	1959-05-23	1
12454	738	260139	1978-08-04	1978-08-18	1
2335	137	4112343	2003-10-17	2003-10-26	1
64691	3830	40481087	2000-07-28	2000-08-18	1
69879	4139	4035415	2006-06-30	2006-08-29	1
2611	153	195588	1997-05-27	1997-07-10	1
64312	3803	40481087	1978-04-06	1978-04-20	1
9583	569	80180	1956-03-02	1956-03-03	1
65078	3852	40481087	1995-09-10	1995-10-01	1
6416	377	78272	1995-07-13	1995-08-17	1
89252	5314	40481087	1993-01-31	1993-02-14	1
70974	4214	4027663	1997-11-22	1997-11-23	1
71643	4255	40481087	1997-05-17	1997-05-31	1
733	40	260139	1985-05-29	1985-06-12	1
6218	366	40481087	1952-11-25	1952-12-09	1
81989	4867	4112343	1975-04-22	1975-05-04	1
67773	4009	0	2005-07-26	2005-07-27	1
4018	232	40481087	2014-09-27	2014-10-18	1
10773	640	260139	1973-05-07	1973-05-14	1
64817	3836	4112343	1981-06-15	1981-06-27	1
10760	639	260139	1998-11-27	1998-12-11	1
64603	3823	381316	2016-11-16	2016-11-17	1
5990	352	40481087	2006-10-02	2006-10-16	1
9532	565	40481087	1973-10-05	1973-10-12	1
60265	3570	260139	1990-02-09	1990-02-16	1
4524	264	4113008	1995-06-05	1995-06-19	1
63404	3748	40481087	1983-10-23	1983-10-30	1
66656	3949	4112343	2017-07-11	2017-07-23	1
38392	2283	4218389	2003-05-03	2003-05-24	1
12690	752	0	1979-02-04	1979-02-05	1
62250	3680	40481087	2006-12-13	2006-12-20	1
34054	2025	4112343	1911-10-21	1911-11-02	1
67033	3967	260139	2013-02-25	2013-03-11	1
6140	362	80180	2017-08-05	2017-08-06	1
89550	5329	78272	2001-09-01	2001-09-15	1
5671	334	378419	2010-07-14	2010-07-15	1
13174	776	4156265	2009-10-11	2009-10-25	1
68828	4078	78272	1968-03-09	1968-03-23	1
6691	395	4112343	2014-06-05	2014-06-16	1
58319	3457	372328	1987-09-25	1988-05-06	1
6380	376	40481087	1974-10-26	1974-11-02	1
58699	3486	440086	1973-12-21	1976-03-26	1
57495	3414	4112343	2001-08-13	2001-08-23	1
42056	2507	81151	1979-08-27	1979-09-17	1
63427	3750	4112343	1979-04-29	1979-05-06	1
6932	408	80180	2004-07-16	2004-07-17	1
72677	4324	30753	1998-09-30	1998-10-01	1
68127	4027	0	2014-06-21	2014-06-22	1
6741	399	4230399	1969-02-23	1969-03-25	1
59099	3509	28060	1956-06-27	1956-07-06	1
8397	488	4152936	2001-10-24	2001-11-07	1
56321	3342	40480160	2011-10-11	2012-01-09	1
38521	2290	40481087	1996-08-15	1996-08-29	1
68298	4040	4027663	2006-02-01	2006-02-02	1
73881	4392	4155034	1997-07-27	1997-08-10	1
5207	307	4112343	2005-05-08	2005-05-21	1
68945	4085	40481087	1994-01-07	1994-01-14	1
12455	738	4112343	2007-02-28	2007-03-07	1
2336	137	4112343	2011-01-02	2011-01-15	1
64692	3830	40481087	2007-07-21	2007-08-11	1
69880	4139	4059173	1994-11-30	1995-02-28	1
2612	153	372328	1943-10-08	1943-11-25	1
64313	3803	40481087	2016-09-04	2016-09-18	1
9584	569	81151	1939-09-24	1939-10-29	1
65079	3852	40481087	2004-02-26	2004-03-18	1
6417	377	80180	2003-02-13	2003-02-14	1
1860	110	260139	2001-04-06	2001-04-13	1
70975	4214	4112343	1986-07-11	1986-07-23	1
71644	4255	40481087	1997-08-06	1997-08-20	1
734	40	372328	1952-11-29	1953-02-11	1
6219	366	28060	2011-12-23	2012-01-04	1
81990	4867	4112343	1983-05-26	1983-06-04	1
67774	4009	260139	1979-03-06	1979-03-20	1
8039	471	4112343	2012-02-29	2012-03-07	1
10774	640	40481087	1954-08-13	1954-08-27	1
64818	3836	40481087	2000-03-31	2000-04-14	1
10761	639	260139	2008-02-16	2008-02-23	1
64604	3823	4059173	1959-05-20	1959-06-19	1
5991	352	78272	1988-08-17	1988-09-07	1
9533	565	40481087	1991-03-08	1991-03-15	1
60266	3570	4112343	1987-12-09	1987-12-22	1
4525	264	40481087	1970-08-10	1970-08-24	1
63405	3748	40481087	1990-11-27	1990-12-11	1
66657	3949	4278672	1980-01-19	1980-03-19	1
38393	2283	40481087	1991-11-07	1991-11-14	1
12691	752	260139	1994-05-03	1994-05-17	1
64773	3834	28060	1989-12-21	1989-12-31	1
34055	2025	4113008	1963-04-02	1963-04-23	1
67034	3967	260139	2018-06-17	2018-07-01	1
6141	362	81151	1989-10-06	1989-11-03	1
89551	5329	80180	1980-09-04	1980-09-05	1
5672	334	4112343	2008-07-04	2008-07-11	1
13175	776	4218389	1962-07-01	1962-07-22	1
68829	4078	372328	1957-01-12	1957-07-22	1
6692	395	4283893	1998-04-22	1998-08-19	1
58320	3457	4112343	1960-04-26	1960-05-03	1
6381	376	40481087	2001-05-06	2001-05-20	1
58700	3486	4112343	1974-09-03	1974-09-12	1
57496	3414	4156265	1974-11-18	1974-12-09	1
42057	2507	4059173	1996-11-16	1997-01-15	1
63428	3750	4310024	1993-05-14	1993-05-15	1
6933	408	260139	1994-06-16	1994-06-30	1
72678	4324	134438	1981-06-13	1982-08-09	1
68128	4027	260139	1994-04-30	1994-05-07	1
6742	399	40481087	1973-09-23	1973-10-14	1
59100	3509	4112343	1946-10-25	1946-11-04	1
8398	488	4283893	1990-10-23	1990-11-20	1
56322	3342	40481087	1938-12-10	1938-12-24	1
38522	2290	80180	1993-04-08	1993-04-09	1
68299	4040	40481087	1977-04-02	1977-04-16	1
73882	4392	40481087	2016-12-14	2017-01-04	1
5208	307	4218389	1991-06-20	1991-07-25	1
68946	4085	40481087	2018-12-09	2018-12-23	1
12456	738	40481087	1983-04-16	1983-04-23	1
2337	137	4230399	1996-10-07	1997-01-05	1
64693	3830	372328	1982-07-13	1982-10-25	1
69881	4139	4285898	2011-01-20	2011-01-21	1
2613	153	4109685	1970-02-09	1970-02-23	1
64314	3803	80180	2003-12-24	2003-12-25	1
9585	569	260139	1947-10-05	1947-10-19	1
65080	3852	40481087	2005-04-19	2005-05-10	1
6418	377	4112343	1975-05-11	1975-05-22	1
1861	110	372328	1979-08-28	1980-01-20	1
70976	4214	40481087	1999-03-31	1999-04-21	1
71645	4255	260139	1988-04-11	1988-04-25	1
735	40	4112343	1959-07-30	1959-08-09	1
6220	366	30753	1943-12-03	1943-12-04	1
81991	4867	4142905	1995-04-01	1995-06-30	1
67775	4009	372328	1952-03-30	1952-07-16	1
8040	471	4113008	2017-09-10	2017-10-01	1
10775	640	40481087	1998-05-02	1998-05-16	1
64819	3836	40481087	2019-02-25	2019-03-04	1
10762	639	260139	2009-03-11	2009-03-18	1
65883	3900	80180	1999-02-16	1999-02-17	1
5992	352	81151	1987-06-26	1987-07-24	1
9534	565	40481087	1993-03-10	1993-03-17	1
60267	3570	4283893	1956-07-03	1956-08-14	1
4526	264	40481087	1980-09-08	1980-09-22	1
63406	3748	28060	1992-10-22	1992-11-01	1
66658	3949	440086	1977-03-15	1979-04-03	1
38394	2283	260139	1941-01-31	1941-02-07	1
12692	752	260139	1997-10-20	1997-11-03	1
64774	3834	257012	1971-11-10	1971-11-11	1
34056	2025	4155034	1965-01-12	1965-01-26	1
67035	3967	372328	1975-05-30	1976-06-13	1
6142	362	4027663	2008-04-14	2008-04-15	1
89552	5329	260139	1947-01-03	1947-01-17	1
5673	334	4146173	1985-12-17	1986-01-16	1
13176	776	40481087	1977-11-16	1977-11-30	1
68830	4078	4112343	1963-09-06	1963-09-18	1
6693	395	40481087	1993-08-27	1993-09-10	1
58321	3457	4112343	2005-08-06	2005-08-18	1
6382	376	260139	1973-05-26	1973-06-02	1
58701	3486	4112343	1986-08-26	1986-09-02	1
57497	3414	40481087	2018-06-03	2018-06-24	1
42058	2507	4218389	2010-12-03	2010-12-24	1
63429	3750	28060	2001-10-16	2001-10-25	1
6934	408	260139	2003-04-27	2003-05-04	1
72679	4324	372328	1963-08-30	1963-11-17	1
68129	4027	260139	2002-06-26	2002-07-03	1
6743	399	40481087	1985-11-16	1985-12-07	1
59101	3509	4112343	1948-02-01	1948-02-09	1
8399	488	40481087	2014-06-17	2014-06-24	1
56323	3342	40481087	1947-12-26	1948-01-16	1
38523	2290	260139	1984-03-07	1984-03-14	1
68300	4040	40481087	2006-10-08	2006-10-29	1
73883	4392	40481087	2013-01-04	2013-01-25	1
5209	307	40481087	1979-11-02	1979-11-09	1
68947	4085	28060	1969-09-08	1969-09-19	1
12457	738	28060	1989-08-21	1989-08-28	1
2338	137	4310024	2003-10-20	2003-10-21	1
64694	3830	4112343	1987-03-01	1987-03-10	1
69882	4139	40481087	2010-02-03	2010-02-24	1
2614	153	4112343	1966-04-09	1966-04-17	1
64315	3803	257012	2014-10-11	2014-10-12	1
9586	569	260139	1964-05-21	1964-06-04	1
66936	3962	28060	2003-11-13	2003-11-22	1
6419	377	4113008	1977-08-04	1977-08-25	1
1862	110	4296204	2003-07-23	2003-08-20	1
70977	4214	28060	1990-03-08	1990-03-20	1
71646	4255	372328	1974-11-19	1975-04-05	1
736	40	4112343	2016-02-23	2016-03-04	1
6221	366	195588	1951-02-09	1951-03-13	1
81992	4867	40481087	1941-10-12	1941-11-02	1
67776	4009	372328	1954-09-04	1955-06-08	1
8041	471	80180	2016-12-16	2016-12-17	1
10776	640	40481087	2009-01-17	2009-02-07	1
64820	3836	260139	2007-10-22	2007-10-29	1
10763	639	4112343	1974-05-16	1974-05-29	1
65884	3900	4155034	2002-05-22	2002-06-12	1
5993	352	81893	2011-01-06	2011-01-07	1
9535	565	40481087	2002-10-17	2002-10-31	1
60268	3570	4294548	2017-05-20	2017-06-10	1
4527	264	81151	1952-06-21	1952-07-19	1
63407	3748	372328	1983-02-20	1984-02-21	1
66659	3949	4112343	1975-05-17	1975-05-25	1
38395	2283	378419	2017-11-13	2017-11-14	1
12693	752	260139	2014-02-27	2014-03-06	1
64775	3834	372328	1957-10-04	1957-12-22	1
34057	2025	40481087	1920-07-14	1920-07-21	1
67036	3967	372328	2008-04-26	2008-05-25	1
6143	362	4113008	1998-07-03	1998-07-17	1
89553	5329	260139	1960-05-12	1960-05-19	1
5674	334	4266809	1972-10-18	1972-10-19	1
13177	776	40481087	2006-12-23	2007-01-13	1
68831	4078	4112343	1989-03-15	1989-03-23	1
6694	395	0	1972-02-13	1972-02-14	1
58322	3457	4294548	1980-02-09	1980-03-29	1
6383	376	4112343	1983-11-27	1983-12-06	1
58702	3486	4278672	1991-09-04	1991-11-03	1
57498	3414	80180	2004-04-04	2004-04-05	1
42059	2507	40481087	1990-05-31	1990-06-07	1
63430	3750	80180	1993-11-10	1993-11-11	1
6935	408	260139	2011-06-03	2011-06-10	1
72680	4324	40481087	1992-08-19	1992-08-26	1
68130	4027	4112343	2004-05-02	2004-05-15	1
6744	399	40481087	2000-10-18	2000-11-08	1
59102	3509	4134304	2015-12-30	2016-03-29	1
8400	488	260139	1988-01-17	1988-01-31	1
56324	3342	40481087	1960-01-28	1960-02-04	1
38524	2290	4237458	1988-02-28	1988-04-28	1
68301	4040	4113008	1982-11-04	1982-11-18	1
74748	4446	260139	1964-12-06	1964-12-20	1
5210	307	40481087	1996-12-14	1996-12-28	1
68948	4085	28060	1997-09-04	1997-09-13	1
12458	738	80180	2014-01-11	2014-01-12	1
2339	137	40481087	1997-03-06	1997-03-27	1
64695	3830	4112343	2012-04-01	2012-04-14	1
69883	4139	4112343	1971-12-03	1971-12-16	1
2615	153	40481087	1948-04-22	1948-04-29	1
64316	3803	260139	1975-05-04	1975-05-11	1
9587	569	4112343	1958-01-24	1958-02-01	1
66937	3962	81151	1953-07-06	1953-07-20	1
6420	377	4296205	1974-08-29	1974-09-19	1
1863	110	40481087	2004-05-31	2004-06-21	1
70978	4214	28060	2008-01-17	2008-01-27	1
71647	4255	372328	1979-04-14	1980-04-19	1
737	40	4237458	2018-06-14	2018-07-14	1
6222	366	260139	1983-02-22	1983-03-08	1
81993	4867	40481087	1991-04-19	1991-04-26	1
67777	4009	4112343	1999-01-26	1999-02-07	1
8042	471	260139	1997-10-28	1997-11-11	1
10777	640	80180	1992-11-07	1992-11-08	1
64821	3836	40481087	1994-02-12	1994-02-26	1
10764	639	4112343	1981-11-22	1981-11-29	1
65885	3900	4266809	1999-02-16	1999-02-17	1
5994	352	260139	1991-09-11	1991-09-18	1
9768	579	28060	1973-09-23	1973-10-05	1
60269	3570	40481087	1971-11-18	1971-11-25	1
4528	264	81151	1977-07-27	1977-08-24	1
63408	3748	4112343	2014-04-22	2014-05-01	1
66660	3949	4112343	2002-03-19	2002-03-29	1
38396	2283	4059173	2017-09-07	2017-10-07	1
12694	752	4112343	1962-06-04	1962-06-13	1
64776	3834	4112343	1973-04-27	1973-05-08	1
34058	2025	40481087	1946-08-09	1946-08-23	1
67037	3967	4027663	1994-04-23	1994-04-24	1
6144	362	4266809	2017-08-05	2017-08-06	1
89554	5329	260139	1977-05-01	1977-05-15	1
5675	334	4285898	1972-02-21	1972-02-22	1
13178	776	78272	1959-08-25	1959-09-15	1
68832	4078	40481087	1960-06-02	1960-06-09	1
6695	395	257012	1998-06-03	1998-06-04	1
58323	3457	40481087	1966-10-13	1966-10-27	1
6384	376	4218389	2017-04-20	2017-05-25	1
58703	3486	40481087	1965-09-03	1965-09-24	1
57499	3414	372328	1971-08-06	1972-03-02	1
42060	2507	40481087	1991-06-07	1991-06-28	1
63431	3750	260139	1977-08-22	1977-09-05	1
6936	408	260139	2011-09-27	2011-10-04	1
72681	4324	40481087	2014-01-04	2014-01-11	1
68131	4027	40481087	1974-05-11	1974-05-18	1
6745	399	40481087	2001-11-11	2001-11-25	1
59103	3509	40481087	1946-04-01	1946-04-08	1
8401	488	260139	2015-08-18	2015-09-01	1
56325	3342	40481087	1997-09-20	1997-10-04	1
38525	2290	4278672	1972-10-05	1972-12-04	1
68302	4040	40481087	2010-07-17	2010-07-31	1
74749	4446	40481087	1984-02-28	1984-03-06	1
5211	307	40481087	2006-09-27	2006-10-04	1
68949	4085	80180	1998-03-13	1998-03-14	1
12459	738	260139	1988-04-22	1988-05-06	1
2340	137	40481087	2017-07-31	2017-08-07	1
64696	3830	40481087	1986-12-25	1987-01-01	1
69884	4139	4152936	2007-09-23	2007-10-07	1
2616	153	40481087	1951-07-17	1951-08-07	1
64317	3803	4112343	2003-04-14	2003-04-21	1
9588	569	4113008	2006-04-01	2006-04-15	1
66938	3962	257012	1958-10-02	1958-10-03	1
6421	377	40481087	1971-12-15	1971-12-22	1
1864	110	40481087	2013-07-29	2013-08-12	1
70979	4214	260139	2005-03-09	2005-03-16	1
71648	4255	4094814	1999-12-11	2000-01-10	1
738	40	40481087	1982-12-18	1983-01-01	1
6223	366	260139	1999-07-03	1999-07-10	1
81994	4867	40481087	2011-10-17	2011-10-31	1
67778	4009	4152936	2004-06-06	2004-06-20	1
8043	471	4283893	1995-07-15	1995-10-21	1
10778	640	260139	1974-01-11	1974-01-18	1
64822	3836	40481087	2007-11-11	2007-11-18	1
10765	639	4116491	1989-12-25	1990-02-07	1
65886	3900	40481087	1988-05-18	1988-06-01	1
5995	352	372328	1980-11-13	1980-12-22	1
9769	579	81151	1994-07-25	1994-08-29	1
60270	3570	40481087	1989-08-15	1989-08-29	1
4529	264	372328	1954-08-10	1954-12-31	1
63409	3748	40481087	2011-04-30	2011-05-14	1
66661	3949	40481087	1994-12-14	1994-12-21	1
38397	2283	4112343	1998-12-24	1999-01-05	1
12695	752	40481087	1967-07-16	1967-07-23	1
64777	3834	4278672	1963-10-03	1964-01-01	1
34059	2025	40481087	1950-09-05	1950-09-19	1
67038	3967	4285898	2003-02-10	2003-02-11	1
6145	362	4310024	2016-11-08	2016-11-09	1
89555	5329	260139	2009-12-01	2009-12-15	1
5676	334	40481087	1938-02-25	1938-03-11	1
13179	776	260139	1961-09-15	1961-09-29	1
68833	4078	80180	1995-10-09	1995-10-10	1
6696	395	372328	1961-11-07	1962-01-23	1
58324	3457	40481087	1975-08-19	1975-09-09	1
6385	376	4310024	1997-12-14	1997-12-15	1
58704	3486	28060	1964-01-17	1964-01-26	1
57500	3414	4112343	2003-10-16	2003-10-23	1
42061	2507	40481087	2003-03-03	2003-03-17	1
63432	3750	4112343	1990-10-05	1990-10-13	1
6937	408	4296204	2014-12-24	2015-01-28	1
72682	4324	80180	1999-07-27	1999-07-28	1
68132	4027	28060	1976-08-25	1976-09-03	1
6746	399	4059173	1968-03-30	1968-04-29	1
59104	3509	40481087	1958-11-24	1958-12-01	1
8402	488	372328	1956-06-22	1956-09-07	1
56326	3342	40481087	2015-11-08	2015-11-15	1
38526	2290	40481087	2003-06-23	2003-07-14	1
69295	4106	30753	1982-12-14	1982-12-15	1
74750	4446	40481087	2009-09-26	2009-10-17	1
8150	479	260139	1984-08-09	1984-08-23	1
68950	4085	260139	1971-05-25	1971-06-01	1
12460	738	260139	1990-07-04	1990-07-18	1
2341	137	30753	2005-02-11	2005-02-12	1
64697	3830	80180	2016-10-22	2016-10-23	1
69885	4139	4296204	2016-01-23	2016-02-27	1
2617	153	28060	1948-05-09	1948-05-19	1
64318	3803	4283893	2014-09-13	2014-12-06	1
9589	569	4283893	2015-01-21	2015-04-08	1
66939	3962	4027663	1979-05-11	1979-05-12	1
6422	377	40481087	1974-05-19	1974-06-09	1
1865	110	28060	1984-04-06	1984-04-17	1
70980	4214	372328	1975-11-13	1976-05-04	1
71649	4255	40481087	1994-03-25	1994-04-01	1
1583	94	80180	1988-06-07	1988-06-08	1
6224	366	4027663	1936-02-13	1936-02-14	1
81995	4867	28060	1931-09-07	1931-09-17	1
67779	4009	40481087	1961-03-22	1961-04-05	1
8044	471	0	1990-04-06	1990-04-07	1
10779	640	372328	1951-06-11	1951-10-15	1
64823	3836	78272	2015-02-04	2015-02-18	1
10766	639	40481087	1953-03-11	1953-04-01	1
65887	3900	40481087	2002-04-26	2002-05-17	1
5996	352	4027663	2005-07-11	2005-07-12	1
9770	579	81151	2005-10-28	2005-12-02	1
60271	3570	40481087	1990-07-04	1990-07-18	1
4530	264	372328	1955-11-26	1956-07-06	1
64895	3841	372328	1975-04-02	1975-09-03	1
66662	3949	40481087	2005-10-02	2005-10-23	1
38398	2283	4149245	1987-02-28	1987-04-06	1
12696	752	40481087	1994-04-08	1994-04-22	1
64778	3834	40481087	2001-02-06	2001-02-20	1
34060	2025	40481087	2010-01-31	2010-02-21	1
67039	3967	40481087	2016-08-05	2016-08-12	1
6146	362	81893	2016-12-08	2016-12-09	1
89556	5329	4035415	1968-12-18	1969-02-16	1
5677	334	40481087	1955-05-18	1955-06-08	1
13180	776	4112343	1971-05-28	1971-06-10	1
68834	4078	260139	1975-03-23	1975-03-30	1
6697	395	372328	1964-11-08	1965-01-26	1
58325	3457	40481087	1982-11-25	1982-12-02	1
6386	376	40481087	1966-09-07	1966-09-14	1
58705	3486	260139	1988-02-24	1988-03-02	1
57501	3414	40481087	1981-09-14	1981-09-21	1
42062	2507	40481087	2006-10-23	2006-11-06	1
63433	3750	4230399	2012-01-11	2012-03-11	1
6938	408	40481087	1969-04-01	1969-04-22	1
72683	4324	260139	1981-08-26	1981-09-02	1
68133	4027	4112343	2017-06-19	2017-06-28	1
6747	399	4109685	1986-06-15	1986-07-06	1
59105	3509	40481087	2013-08-06	2013-08-20	1
8403	488	378001	1995-05-29	1995-06-28	1
56327	3342	30753	1949-08-21	1949-08-22	1
38527	2290	40481087	2009-05-31	2009-06-21	1
69296	4106	260139	1985-10-25	1985-11-01	1
74751	4446	28060	1972-02-23	1972-03-07	1
8151	479	372328	1959-11-11	1962-04-29	1
68951	4085	260139	1983-06-09	1983-06-16	1
12461	738	4109685	1990-08-21	1990-09-04	1
2342	137	134438	2002-06-29	2003-02-25	1
64698	3830	372328	2008-07-26	2010-06-28	1
69886	4139	40481087	1986-11-18	1986-12-02	1
2618	153	4230399	1990-01-23	1990-02-22	1
64319	3803	4285898	2003-08-26	2003-08-27	1
9590	569	40481087	1971-10-18	1971-11-08	1
66940	3962	4112343	1957-12-16	1957-12-23	1
6423	377	40481087	2014-07-27	2014-08-17	1
1866	110	4112343	2012-12-17	2012-12-25	1
70981	4214	4112343	1975-09-15	1975-09-25	1
71650	4255	40481087	1996-03-30	1996-04-13	1
1584	94	260139	1958-02-27	1958-03-13	1
6225	366	4283893	1916-08-25	1916-10-27	1
81996	4867	260139	1948-01-20	1948-02-03	1
67780	4009	40481087	1975-09-23	1975-10-14	1
8045	471	321042	1990-04-06	1990-04-07	1
10780	640	372328	1980-05-15	1982-05-24	1
64824	3836	260139	1987-11-17	1987-12-01	1
10767	639	40481087	1976-01-06	1976-01-20	1
65888	3900	81893	1998-01-22	1998-01-23	1
5997	352	4112343	1994-08-31	1994-09-09	1
9771	579	192671	1999-11-06	1999-11-07	1
60272	3570	40481087	1998-11-08	1998-11-22	1
4531	264	372328	1987-03-26	1987-07-10	1
64896	3841	40481087	2018-03-10	2018-03-31	1
66663	3949	40481087	2011-06-03	2011-06-10	1
38399	2283	4294548	1953-09-02	1953-09-16	1
16507	975	28060	1967-10-03	1967-10-16	1
64779	3834	40481087	2009-10-04	2009-10-11	1
37353	2217	80180	2018-11-06	2018-11-07	1
67385	3987	28060	2012-08-13	2012-08-21	1
6147	362	372328	1982-07-15	1982-08-31	1
89557	5329	4112343	2009-08-17	2009-08-26	1
5678	334	40481087	1972-04-15	1972-04-22	1
13181	776	4134304	1969-06-29	1969-09-27	1
68835	4078	4218389	1986-09-15	1986-10-13	1
6698	395	4112343	1989-01-16	1989-01-29	1
58326	3457	40481087	1990-11-27	1990-12-18	1
6387	376	40481087	1967-02-17	1967-03-03	1
58706	3486	260139	1994-04-01	1994-04-08	1
57502	3414	40481087	1993-04-26	1993-05-17	1
44802	2669	4112343	2002-07-25	2002-08-03	1
63434	3750	4266809	1993-11-10	1993-11-11	1
6939	408	40481087	1970-04-26	1970-05-03	1
72684	4324	260139	2010-11-01	2010-11-08	1
68134	4027	4283893	1996-02-10	1996-05-18	1
6748	399	4112343	1955-09-02	1955-09-14	1
60802	3603	4112343	2002-09-24	2002-10-06	1
8404	488	4112343	1960-07-31	1960-08-08	1
56328	3342	260139	1952-11-13	1952-11-20	1
38528	2290	40481087	2013-04-08	2013-04-29	1
69297	4106	4027663	1975-02-24	1975-02-25	1
74752	4446	81151	1964-05-08	1964-05-29	1
8152	479	4112343	1960-06-06	1960-06-15	1
68952	4085	372328	1960-02-10	1960-03-12	1
12462	738	4156265	1983-03-10	1983-03-31	1
2343	137	372328	1972-08-23	1972-09-06	1
64699	3830	4296204	2005-08-11	2005-09-15	1
69887	4139	28060	1989-01-18	1989-01-31	1
2619	153	40481087	1985-11-15	1985-12-06	1
64320	3803	40481087	1984-06-23	1984-06-30	1
9591	569	40481087	1996-02-11	1996-02-18	1
66941	3962	4112343	1969-08-03	1969-08-13	1
6424	377	40481087	2015-11-15	2015-11-29	1
1867	110	4218389	2009-08-18	2009-09-22	1
70982	4214	4283893	2004-03-03	2004-07-21	1
71651	4255	260139	1990-09-07	1990-09-14	1
1585	94	260139	1982-07-03	1982-07-10	1
6226	366	40481087	1993-08-04	1993-08-18	1
81997	4867	381316	2009-08-26	2009-08-27	1
69650	4125	0	1988-10-25	1988-10-26	1
8046	471	4112343	2000-03-18	2000-03-31	1
10781	640	4112343	1956-01-19	1956-01-29	1
64825	3836	372328	1981-01-27	1981-02-20	1
12494	741	78272	2001-07-22	2001-08-19	1
65889	3900	4027663	1992-06-27	1992-06-28	1
5998	352	40481087	2010-10-01	2010-10-08	1
9772	579	260139	2014-09-12	2014-09-26	1
60273	3570	28060	1968-03-09	1968-03-21	1
4532	264	4112343	1958-09-13	1958-09-25	1
64897	3841	40481087	2018-09-03	2018-09-24	1
66664	3949	260139	2003-01-28	2003-02-04	1
38400	2283	40481087	1940-07-09	1940-07-23	1
16508	975	40481087	1983-05-18	1983-06-08	1
64780	3834	260139	2009-04-27	2009-05-04	1
37354	2217	4112343	1983-08-11	1983-08-22	1
67386	3987	81151	1993-01-21	1993-02-18	1
6148	362	28060	1991-10-30	1991-11-12	1
89558	5329	4116491	1990-12-11	1991-01-17	1
5679	334	40481087	1985-07-18	1985-07-25	1
13182	776	40481087	1964-05-09	1964-05-23	1
68836	4078	40481087	1952-08-08	1952-08-22	1
6699	395	40481087	2003-03-03	2003-03-10	1
61200	3623	28060	1964-05-01	1964-05-11	1
6388	376	40481087	1991-07-12	1991-07-19	1
58707	3486	4237458	2012-04-16	2012-07-15	1
57503	3414	40481087	2007-03-12	2007-03-26	1
44803	2669	4112343	2008-01-05	2008-01-16	1
63435	3750	40481087	1972-11-23	1972-11-30	1
6940	408	40481087	1972-04-01	1972-04-22	1
72685	4324	260139	2016-07-17	2016-07-31	1
68135	4027	40481087	2005-04-08	2005-04-15	1
6749	399	4112343	1994-12-09	1994-12-20	1
60803	3603	4156265	2017-06-08	2017-06-22	1
8405	488	4112343	1995-09-08	1995-09-16	1
56329	3342	4027663	1943-06-29	1943-06-30	1
38529	2290	260139	1998-06-19	1998-07-03	1
69298	4106	4112343	1986-10-03	1986-10-15	1
74753	4446	4112343	1964-04-12	1964-04-21	1
8153	479	4112343	1975-12-26	1976-01-07	1
68953	4085	440086	1966-10-02	1969-04-13	1
12463	738	260139	2000-08-29	2000-09-05	1
2344	137	4027663	1996-06-23	1996-06-24	1
64700	3830	40481087	1984-06-10	1984-07-01	1
69888	4139	80180	2011-09-17	2011-09-18	1
2620	153	40481087	1996-08-17	1996-08-24	1
64321	3803	40481087	1998-09-22	1998-09-29	1
9592	569	81151	2011-01-03	2011-02-07	1
66942	3962	4112343	1985-02-21	1985-03-06	1
6425	377	40481087	2018-10-22	2018-11-12	1
1868	110	4116491	1998-02-09	1998-03-20	1
71569	4250	80180	1982-05-13	1982-05-14	1
71652	4255	4112343	1984-02-03	1984-02-14	1
1586	94	4146173	2000-05-18	2000-06-17	1
6227	366	40481087	2018-11-24	2018-12-08	1
81998	4867	4112343	1967-09-16	1967-09-28	1
69651	4125	260139	1972-08-25	1972-09-01	1
8047	471	257012	1995-08-19	1995-08-20	1
10782	640	4112343	2006-06-20	2006-07-01	1
64826	3836	4112343	2015-03-18	2015-03-25	1
12495	741	260139	1992-11-25	1992-12-02	1
65890	3900	40481087	1983-06-15	1983-07-06	1
5999	352	260139	1981-09-26	1981-10-10	1
9773	579	4112343	1961-07-22	1961-08-04	1
60274	3570	78272	1950-09-26	1950-10-31	1
4533	264	40481087	1965-06-01	1965-06-08	1
64898	3841	260139	1975-04-13	1975-04-20	1
66665	3949	4112343	2011-08-12	2011-08-25	1
38401	2283	40481087	1946-11-24	1946-12-08	1
16509	975	40481087	1987-02-22	1987-03-01	1
64781	3834	378001	2000-03-22	2000-05-21	1
37355	2217	40481087	2010-11-07	2010-11-14	1
67387	3987	4112343	1956-05-15	1956-05-25	1
6149	362	28060	2009-10-09	2009-10-22	1
89559	5329	40481087	1957-07-28	1957-08-04	1
5680	334	40481087	1994-09-13	1994-09-27	1
13183	776	40481087	2002-01-22	2002-02-12	1
68837	4078	40481087	1955-07-15	1955-07-22	1
6700	395	4112343	1984-12-24	1985-01-04	1
61201	3623	78272	2011-04-15	2011-05-06	1
6389	376	28060	1972-01-01	1972-01-13	1
58708	3486	40481087	1972-01-18	1972-02-08	1
59180	3514	260139	1994-02-23	1994-03-09	1
44804	2669	80180	2019-01-12	2019-01-13	1
63436	3750	40481087	1980-09-21	1980-10-05	1
6941	408	40481087	1991-02-20	1991-03-13	1
72686	4324	4027663	1991-06-04	1991-06-05	1
68136	4027	40481087	2017-05-15	2017-05-29	1
6750	399	4112343	1998-10-01	1998-10-08	1
60804	3603	4166224	1967-02-08	1967-02-09	1
8406	488	4134304	1969-08-13	1969-09-12	1
56330	3342	4112343	1936-02-06	1936-02-16	1
38530	2290	372328	1975-05-23	1976-05-29	1
69299	4106	4112343	1995-04-03	1995-04-10	1
74754	4446	4112343	1970-11-17	1970-11-26	1
8154	479	4134304	2016-09-03	2016-10-03	1
68954	4085	40481087	1986-10-23	1986-11-06	1
12464	738	4112343	2018-10-07	2018-10-18	1
2345	137	4109685	2007-04-13	2007-04-27	1
64701	3830	40481087	2015-11-02	2015-11-16	1
69889	4139	4027663	2000-10-29	2000-10-30	1
4105	239	80180	1992-04-26	1992-04-27	1
64322	3803	40481087	2006-10-25	2006-11-15	1
9593	569	4112343	2017-10-01	2017-10-12	1
66943	3962	4113008	2015-09-03	2015-09-24	1
9471	563	28060	1974-10-28	1974-11-05	1
1869	110	4218389	2013-09-01	2013-10-06	1
71570	4250	4059173	2015-04-07	2015-07-06	1
71653	4255	4113008	1975-01-18	1975-02-08	1
1587	94	4296205	1983-07-14	1983-08-11	1
6228	366	80180	1944-08-29	1944-08-30	1
81999	4867	4142905	1987-05-29	1987-07-28	1
69652	4125	372328	1971-06-30	1971-08-24	1
8048	471	4218389	1992-03-27	1992-04-24	1
10783	640	4112343	2007-07-30	2007-08-10	1
64827	3836	4237458	1986-10-04	1986-11-03	1
12496	741	4112343	2001-04-15	2001-04-22	1
65891	3900	4218389	1977-07-11	1977-08-01	1
6000	352	260139	1996-10-03	1996-10-10	1
9774	579	40481087	2006-07-03	2006-07-24	1
60275	3570	378001	1990-03-17	1990-05-16	1
4534	264	40481087	1988-07-01	1988-07-15	1
64899	3841	260139	1982-09-27	1982-10-11	1
66666	3949	4152936	2009-12-12	2009-12-26	1
38402	2283	40481087	1953-05-09	1953-05-30	1
16510	975	40481087	2017-02-18	2017-03-04	1
64782	3834	4109685	2012-04-18	2012-05-02	1
37356	2217	40481087	2017-01-18	2017-02-01	1
67388	3987	4116491	2003-12-14	2004-02-02	1
6150	362	260139	1981-08-21	1981-09-04	1
89560	5329	40481087	1979-04-20	1979-05-04	1
5681	334	40481087	2006-04-22	2006-04-29	1
13184	776	40481087	2009-02-06	2009-02-13	1
68838	4078	40481087	1965-09-20	1965-10-04	1
6701	395	4112343	2017-04-05	2017-04-17	1
61202	3623	4112343	2000-12-10	2000-12-18	1
6390	376	81151	2014-04-01	2014-05-06	1
58709	3486	40481087	2003-09-02	2003-09-23	1
59181	3514	4112343	1978-05-31	1978-06-09	1
44805	2669	4218389	2018-03-08	2018-04-12	1
63437	3750	40481087	2008-07-15	2008-08-05	1
12183	722	4112343	1980-09-10	1980-09-17	1
72687	4324	4112343	1974-09-11	1974-09-18	1
68361	4045	192671	2015-07-17	2015-07-18	1
6751	399	4283893	1998-07-21	1998-09-22	1
60805	3603	40481087	1967-08-06	1967-08-20	1
8407	488	4278672	1966-06-30	1966-07-30	1
56331	3342	4112343	1978-04-19	1978-04-29	1
38531	2290	4059173	1969-01-24	1969-02-23	1
69300	4106	4266809	1984-02-07	1984-02-08	1
74755	4446	4112343	1975-05-25	1975-06-01	1
8155	479	4146173	1949-07-31	1949-09-29	1
68955	4085	257012	1962-02-23	1962-02-24	1
12465	738	40481087	2016-03-09	2016-03-23	1
2346	137	4112343	1977-09-28	1977-10-09	1
69325	4107	372328	1971-04-09	1971-05-17	1
69890	4139	4116491	1996-10-30	1996-12-16	1
4106	239	81893	1990-08-05	1990-08-06	1
64323	3803	4027663	1994-04-05	1994-04-06	1
9594	569	4142905	1976-04-08	1976-07-07	1
66944	3962	40481087	1951-08-24	1951-09-14	1
9472	563	80180	2003-01-18	2003-01-19	1
1870	110	40481087	2012-11-12	2012-11-26	1
71571	4250	4059173	2016-05-31	2016-06-30	1
71654	4255	28060	1984-08-14	1984-08-21	1
1588	94	40481087	1983-07-06	1983-07-27	1
6229	366	257012	1914-10-17	1914-10-18	1
82000	4867	40481087	1932-08-17	1932-08-24	1
69653	4125	4237458	1978-01-08	1978-04-08	1
10625	625	80180	2014-02-13	2014-02-14	1
10784	640	4278672	1957-04-10	1957-07-09	1
64828	3836	80180	2018-12-14	2018-12-15	1
12497	741	4112343	2010-07-05	2010-07-18	1
65892	3900	28060	1967-08-06	1967-08-16	1
6001	352	260139	2007-04-18	2007-04-25	1
9775	579	40481087	2009-07-13	2009-07-27	1
60276	3570	4113008	1980-09-14	1980-10-05	1
4535	264	40481087	2004-06-30	2004-07-14	1
64900	3841	440086	1984-09-25	1986-02-25	1
66667	3949	40481087	1992-07-15	1992-07-22	1
38403	2283	40481087	1970-01-26	1970-02-02	1
16511	975	80180	2000-03-26	2000-03-27	1
64783	3834	4112343	2004-12-27	2005-01-05	1
37357	2217	28060	1993-11-01	1993-11-08	1
67389	3987	40481087	1967-06-24	1967-07-08	1
6151	362	4237458	1995-09-17	1995-11-16	1
49932	2953	4112343	2006-04-19	2006-04-29	1
5682	334	80180	1972-10-18	1972-10-19	1
13185	776	80180	1998-01-12	1998-01-13	1
68839	4078	40486433	1953-08-12	1993-07-12	1
6702	395	4294548	1977-01-11	1977-02-15	1
61203	3623	40481087	1953-12-30	1954-01-13	1
6391	376	4112343	2013-01-12	2013-01-25	1
58710	3486	40481087	2004-12-24	2005-01-07	1
59182	3514	4283893	1988-08-26	1988-10-07	1
44806	2669	4294548	1978-08-05	1978-10-21	1
63438	3750	28060	1977-11-23	1977-12-02	1
12184	722	4112343	2007-12-10	2007-12-19	1
72688	4324	40481087	2003-11-22	2003-12-13	1
68362	4045	260139	1982-03-07	1982-03-21	1
6752	399	40481087	1955-06-08	1955-06-22	1
60806	3603	40481087	1968-06-20	1968-06-27	1
8408	488	40481087	1965-05-14	1965-05-28	1
56332	3342	4155034	1968-07-14	1968-07-28	1
38532	2290	4112343	1959-01-18	1959-01-28	1
69301	4106	4285898	1983-09-10	1983-09-11	1
74756	4446	4112343	1982-01-27	1982-02-09	1
8156	479	4155034	1967-12-15	1968-01-05	1
68956	4085	260139	1964-04-07	1964-04-21	1
12466	738	372328	1981-08-17	1981-12-08	1
2347	137	4112343	1989-04-01	1989-04-08	1
69326	4107	4112343	1996-09-22	1996-10-05	1
69891	4139	4278672	2010-08-22	2010-10-21	1
4107	239	260139	1988-09-01	1988-09-08	1
64324	3803	4112343	1974-05-03	1974-05-14	1
9595	569	40480160	1999-10-05	1999-12-04	1
66945	3962	40481087	1962-01-11	1962-01-18	1
9473	563	40481087	1971-01-27	1971-02-10	1
1871	110	80180	2018-08-23	2018-08-24	1
71572	4250	4294548	2008-07-19	2008-08-09	1
71655	4255	81151	1986-08-30	1986-09-20	1
1589	94	40481087	2010-10-12	2010-10-19	1
6230	366	260139	1970-11-13	1970-11-20	1
82001	4867	28060	1948-02-09	1948-02-20	1
69654	4125	81151	1969-07-10	1969-07-24	1
10626	625	4112343	1990-11-28	1990-12-10	1
10785	640	40481087	1984-07-06	1984-07-27	1
64829	3836	260139	1981-02-12	1981-02-19	1
12498	741	4283893	1982-03-18	1982-08-05	1
65893	3900	30753	1998-03-23	1998-03-24	1
6002	352	372328	1983-03-12	1983-07-04	1
9776	579	40481087	2015-11-12	2015-12-03	1
60277	3570	4134304	1961-10-03	1961-12-02	1
8277	484	28060	1947-08-16	1947-08-29	1
64901	3841	40481087	2000-07-03	2000-07-17	1
66668	3949	4112343	1992-12-22	1993-01-03	1
38404	2283	40481087	1976-04-09	1976-04-23	1
16512	975	260139	2009-07-27	2009-08-03	1
64784	3834	4283893	1992-07-25	1992-09-12	1
37358	2217	4059173	1995-12-02	1996-03-01	1
67390	3987	40481087	2003-09-25	2003-10-02	1
6152	362	40481087	1990-09-07	1990-09-28	1
49933	2953	40481087	2017-03-18	2017-03-25	1
5683	334	80502	2005-06-15	2005-06-16	1
13186	776	4294548	1979-03-30	1979-08-31	1
72000	4278	260139	1989-12-25	1990-01-08	1
6703	395	28060	1983-12-16	1983-12-26	1
61204	3623	40481087	1993-07-15	1993-07-22	1
6392	376	40481087	2007-05-27	2007-06-03	1
58711	3486	40481087	2006-07-07	2006-07-14	1
59183	3514	40481087	1978-03-10	1978-03-17	1
44807	2669	40481087	1987-11-10	1987-12-01	1
63439	3750	28060	1981-01-29	1981-02-11	1
12185	722	4146173	1996-02-20	1996-04-20	1
76173	4525	28060	1984-05-19	1984-05-28	1
68363	4045	372328	1974-08-15	1974-10-26	1
6753	399	40481087	1993-11-21	1993-12-05	1
60807	3603	40481087	1969-08-30	1969-09-13	1
8409	488	40481087	2013-11-23	2013-12-14	1
56333	3342	4294548	1912-05-27	1912-06-17	1
38533	2290	4112343	1970-06-14	1970-06-23	1
69302	4106	40481087	1990-10-09	1990-10-30	1
74757	4446	4112343	1985-07-27	1985-08-08	1
8157	479	40481087	1988-12-30	1989-01-06	1
68957	4085	260139	1994-04-21	1994-04-28	1
12467	738	4112343	1986-08-22	1986-09-04	1
2348	137	4112343	2005-11-15	2005-11-28	1
69327	4107	4112343	2005-08-07	2005-08-18	1
69892	4139	40481087	1991-11-14	1991-11-21	1
4108	239	4112343	1991-11-09	1991-11-21	1
64325	3803	4310024	2002-07-02	2002-07-03	1
9596	569	40481087	1989-01-26	1989-02-09	1
66946	3962	40481087	1990-11-21	1990-12-12	1
9474	563	81151	1970-04-02	1970-04-23	1
1872	110	260139	2015-02-10	2015-02-17	1
71573	4250	40481087	1952-05-27	1952-06-17	1
71656	4255	440086	1981-04-26	1991-05-04	1
1590	94	28060	1959-12-30	1960-01-10	1
6231	366	372328	1912-01-15	1912-04-28	1
82002	4867	378001	2010-01-12	2010-02-11	1
69655	4125	260139	2017-11-03	2017-11-10	1
10627	625	4112343	2006-06-19	2006-06-30	1
10786	640	40481087	1992-02-22	1992-03-14	1
64830	3836	260139	2002-05-19	2002-06-02	1
12499	741	40481087	1991-08-24	1991-08-31	1
65894	3900	258780	2004-09-21	2004-09-22	1
6003	352	4112343	1992-12-27	1993-01-05	1
9777	579	78272	1993-08-31	1993-09-28	1
60278	3570	40481087	1975-08-11	1975-08-25	1
8278	484	78272	1953-08-12	1953-09-02	1
64902	3841	81151	1988-10-29	1988-11-19	1
66669	3949	40481087	1977-05-09	1977-05-30	1
38405	2283	40481087	2004-04-14	2004-05-05	1
16513	975	372328	1966-12-05	1967-04-23	1
64785	3834	28060	1965-07-27	1965-08-04	1
37359	2217	4112343	2015-08-04	2015-08-16	1
67391	3987	40481087	2009-01-29	2009-02-12	1
6596	390	260139	1998-08-21	1998-09-04	1
49934	2953	28060	2009-05-15	2009-05-27	1
5684	334	260139	1963-11-22	1963-12-06	1
13187	776	40481087	2005-05-10	2005-05-24	1
72001	4278	4043241	2017-12-01	2017-12-02	1
6704	395	4112343	1975-02-14	1975-02-27	1
61205	3623	40481087	1994-06-26	1994-07-10	1
6393	376	80180	1999-07-07	1999-07-08	1
58712	3486	80180	2000-12-24	2000-12-25	1
59184	3514	81151	1987-03-03	1987-03-17	1
44808	2669	257012	1978-09-23	1978-09-24	1
63440	3750	378001	1981-06-01	1981-07-31	1
12186	722	4237458	1989-07-26	1989-08-25	1
76174	4525	80180	2007-08-04	2007-08-05	1
68364	4045	4112343	2004-06-23	2004-07-04	1
6754	399	80180	1997-05-07	1997-05-08	1
60808	3603	40481087	1997-03-10	1997-03-24	1
13140	775	80180	1976-05-25	1976-05-26	1
56334	3342	4310024	1949-02-22	1949-02-23	1
38534	2290	4112343	2003-07-30	2003-08-08	1
69303	4106	78272	1960-01-09	1960-02-06	1
74758	4446	4112343	1993-08-28	1993-09-09	1
8158	479	40481087	1993-04-24	1993-05-08	1
68958	4085	372328	1959-09-29	1959-12-12	1
13790	817	260139	2006-09-07	2006-09-14	1
2349	137	40481087	1989-05-16	1989-05-23	1
69328	4107	372328	1984-09-11	1985-03-11	1
69893	4139	40481087	1999-07-20	1999-07-27	1
4109	239	4155034	1970-07-26	1970-08-09	1
64326	3803	40481087	1961-08-12	1961-09-02	1
9597	569	40481087	1994-08-28	1994-09-11	1
66947	3962	78272	2011-12-09	2011-12-23	1
9475	563	134438	1985-04-14	1986-03-15	1
1873	110	40481087	1980-02-01	1980-02-15	1
71574	4250	40481087	1987-07-17	1987-08-07	1
71657	4255	4109685	2019-06-29	2019-06-30	1
1591	94	257012	1976-06-09	1976-06-10	1
6232	366	381316	1974-03-03	1974-03-04	1
82003	4867	4059173	1926-11-01	1927-01-30	1
69656	4125	4112343	1976-07-04	1976-07-12	1
10628	625	4134304	1974-12-25	1975-01-24	1
10787	640	40481087	1997-12-20	1997-12-27	1
64831	3836	372328	1978-05-10	1978-08-11	1
12500	741	40481087	1998-07-16	1998-07-30	1
65895	3900	260139	1978-01-08	1978-01-15	1
6004	352	4285898	2012-01-31	2012-02-01	1
9778	579	80180	1999-08-30	1999-08-31	1
60279	3570	80180	1988-06-08	1988-06-09	1
8279	484	81893	1973-10-21	1973-10-22	1
64903	3841	78272	2009-10-30	2009-12-04	1
68986	4087	80180	2018-01-27	2018-01-28	1
38406	2283	40481087	2011-12-03	2011-12-17	1
16514	975	4112343	1985-10-12	1985-10-19	1
64786	3834	28060	2005-03-09	2005-03-18	1
37360	2217	40481087	2009-11-23	2009-12-07	1
67392	3987	40481087	2014-06-22	2014-06-29	1
6597	390	40481087	1989-12-19	1990-01-09	1
49935	2953	260139	2002-03-20	2002-04-03	1
5685	334	372328	1937-03-26	1937-05-12	1
13188	776	195588	1991-07-23	1991-09-03	1
72002	4278	4112343	1963-11-27	1963-12-09	1
6705	395	4112343	2019-03-09	2019-03-19	1
61206	3623	40481087	2009-04-04	2009-04-11	1
6394	376	4027663	1988-04-20	1988-04-21	1
58713	3486	260139	1969-08-05	1969-08-12	1
59185	3514	260139	1989-09-09	1989-09-16	1
44809	2669	260139	1980-05-22	1980-05-29	1
63441	3750	4112343	1990-01-27	1990-02-03	1
12187	722	40481087	1975-11-11	1975-11-18	1
76175	4525	378001	1971-07-14	1971-08-13	1
68365	4045	4112343	2009-04-10	2009-04-17	1
6755	399	81151	1999-03-30	1999-05-04	1
60809	3603	260139	1973-12-13	1973-12-27	1
13141	775	81151	1955-04-19	1955-05-17	1
56335	3342	40481087	1913-03-19	1913-04-09	1
38535	2290	4155034	1976-11-13	1976-11-27	1
69304	4106	260139	1991-06-05	1991-06-12	1
74759	4446	372328	1963-04-14	1963-06-04	1
8159	479	260139	1964-03-23	1964-04-06	1
68959	4085	4112343	1986-07-24	1986-07-31	1
13791	817	372328	1958-09-21	1958-10-23	1
5111	300	81151	2004-02-05	2004-03-04	1
69329	4107	4112343	2004-10-25	2004-11-07	1
69894	4139	40481087	2000-02-29	2000-03-21	1
4110	239	4237458	1956-12-31	1957-03-31	1
64327	3803	28060	1973-07-22	1973-08-03	1
9598	569	40481087	2008-06-16	2008-06-30	1
66948	3962	372328	1956-12-17	1957-05-03	1
9476	563	372328	1964-06-11	1964-07-19	1
1874	110	40481087	2000-06-06	2000-06-13	1
71575	4250	40481087	1995-11-22	1995-11-29	1
71658	4255	4218389	1977-11-24	1977-12-15	1
1592	94	260139	1972-04-27	1972-05-11	1
6233	366	40481087	1919-09-20	1919-09-27	1
82004	4867	4112343	1947-08-27	1947-09-08	1
69657	4125	40481087	1974-04-22	1974-05-13	1
10629	625	81893	2012-07-23	2012-07-24	1
10788	640	40481087	1999-06-15	1999-07-06	1
64832	3836	440086	1989-03-01	1995-03-10	1
12501	741	0	2000-05-26	2000-05-27	1
65896	3900	4310024	1997-07-26	1997-07-27	1
6005	352	372328	1978-06-13	1978-09-25	1
9779	579	257012	1964-04-20	1964-04-21	1
60280	3570	260139	1952-04-19	1952-04-26	1
8280	484	260139	1976-06-12	1976-06-26	1
64904	3841	80180	2017-03-01	2017-03-02	1
68987	4087	375671	2005-04-05	2005-05-05	1
41408	2466	4059173	1993-07-04	1993-10-02	1
16515	975	4112343	2004-02-15	2004-02-28	1
64787	3834	260139	1967-06-15	1967-06-29	1
37361	2217	260139	2001-01-06	2001-01-13	1
67393	3987	260139	1989-05-23	1989-06-06	1
6598	390	40481087	2017-09-30	2017-10-14	1
49936	2953	372328	1986-04-25	1986-10-17	1
5686	334	4027663	1962-05-29	1962-05-30	1
13189	776	260139	1979-08-22	1979-08-29	1
72003	4278	40481087	1969-09-11	1969-09-18	1
6706	395	40481087	1969-04-08	1969-04-15	1
61207	3623	0	2009-06-05	2009-06-06	1
6395	376	4112343	1991-04-02	1991-04-13	1
58714	3486	260139	1971-03-06	1971-03-20	1
59186	3514	4112343	1987-01-04	1987-01-11	1
44810	2669	260139	1982-09-17	1982-10-01	1
63442	3750	4112343	2005-09-05	2005-09-15	1
12188	722	260139	1975-08-19	1975-08-26	1
76176	4525	4294548	2009-04-07	2009-04-28	1
68366	4045	40481087	1976-04-15	1976-04-22	1
6756	399	257012	1992-07-02	1992-07-03	1
60810	3603	440448	1967-02-08	1967-02-09	1
13142	775	381316	2017-03-15	2017-03-16	1
56336	3342	40481087	1921-11-30	1921-12-14	1
38536	2290	40481087	1959-06-22	1959-07-13	1
69305	4106	372328	1949-01-01	1950-01-20	1
74760	4446	4112343	2003-10-21	2003-11-02	1
8160	479	260139	1989-05-11	1989-05-25	1
68960	4085	4237458	1966-03-26	1966-04-25	1
13792	817	372328	1989-08-11	1992-03-12	1
5112	300	260139	1973-02-19	1973-03-05	1
69330	4107	4113008	1992-01-19	1992-02-02	1
69895	4139	30753	2010-12-21	2010-12-22	1
4111	239	4237458	2012-03-01	2012-04-30	1
64328	3803	78272	2000-12-09	2001-01-13	1
9599	569	40481087	2014-11-02	2014-11-16	1
66949	3962	4294548	1958-08-14	1958-11-20	1
9477	563	4109685	1978-01-11	1978-02-01	1
4170	244	28060	1949-10-27	1949-11-09	1
71576	4250	260139	1980-07-03	1980-07-10	1
71659	4255	40481087	1978-02-03	1978-02-24	1
1593	94	260139	1994-10-24	1994-11-07	1
6234	366	40481087	1933-01-18	1933-02-08	1
82005	4867	4112343	1965-10-14	1965-10-22	1
69658	4125	40481087	1983-11-30	1983-12-21	1
10630	625	257012	2001-04-02	2001-08-13	1
10789	640	40481087	2006-07-05	2006-07-26	1
64833	3836	4112343	1998-06-29	1998-07-11	1
12502	741	78272	1989-12-24	1990-01-21	1
67707	4006	80180	1994-12-25	1994-12-26	1
6006	352	372328	1988-12-04	1989-08-07	1
9780	579	4112343	1966-09-11	1966-09-18	1
60281	3570	372328	1953-03-14	1953-11-15	1
8281	484	372328	1942-11-25	1942-12-09	1
64905	3841	260139	2002-08-29	2002-09-05	1
68988	4087	4218389	1984-05-15	1984-06-19	1
41409	2466	260139	1979-10-17	1979-10-30	1
16516	975	4156265	1975-10-19	1975-11-02	1
64788	3834	317576	2003-08-10	2003-08-11	1
37362	2217	372328	1995-02-05	1995-10-27	1
67394	3987	4278672	2010-04-20	2010-05-20	1
6599	390	4112343	1977-03-29	1977-04-05	1
53372	3167	4112343	1978-09-14	1978-09-26	1
5687	334	4112343	1945-09-29	1945-10-07	1
13190	776	261325	2009-08-06	2009-08-07	1
72004	4278	40481087	1985-05-28	1985-06-18	1
10162	603	260139	1979-04-09	1979-04-23	1
61208	3623	30753	1987-07-30	1987-07-31	1
6396	376	4112343	1995-10-23	1995-10-30	1
58715	3486	378001	1986-09-02	1986-10-02	1
59187	3514	80180	2014-03-02	2014-03-03	1
44811	2669	4112343	1982-02-14	1982-02-22	1
63443	3750	4112343	2010-09-20	2010-09-30	1
12189	722	40481087	1970-11-10	1970-12-01	1
76177	4525	40481087	1968-06-05	1968-06-26	1
68367	4045	40481087	1977-09-19	1977-10-10	1
6757	399	4237458	1980-07-16	1980-09-14	1
60811	3603	4048171	1970-02-12	1970-02-13	1
13143	775	4112343	1964-02-04	1964-02-13	1
56337	3342	40481087	1929-04-11	1929-04-25	1
38537	2290	40481087	1960-09-11	1960-09-25	1
69306	4106	4112343	1985-01-25	1985-02-06	1
74761	4446	4156265	1977-04-21	1977-05-05	1
8161	479	260139	2004-11-03	2004-11-10	1
68961	4085	40481087	1982-11-28	1982-12-05	1
13793	817	439777	1976-05-11	1976-05-12	1
5113	300	80180	2009-11-30	2009-12-01	1
69331	4107	28060	1987-04-18	1987-05-01	1
69896	4139	4112343	2016-04-10	2016-04-18	1
4112	239	4266809	1992-04-26	1992-04-27	1
64329	3803	81893	2002-08-01	2002-08-02	1
9600	569	257012	2015-04-01	2015-04-02	1
66950	3962	4296204	1999-09-08	1999-10-13	1
9478	563	4155034	1986-02-19	1986-03-12	1
4171	244	81893	1965-02-11	1965-02-12	1
71577	4250	260139	1984-02-22	1984-03-07	1
71660	4255	40481087	2006-10-11	2006-10-25	1
1594	94	372328	1954-05-17	1954-09-03	1
6235	366	40481087	1937-07-15	1937-07-29	1
82006	4867	4112343	1996-11-13	1996-11-21	1
69659	4125	260139	2015-05-20	2015-05-27	1
10631	625	372328	1975-05-24	1975-11-11	1
10790	640	40481087	2007-06-30	2007-07-21	1
64834	3836	4155034	1984-10-23	1984-11-13	1
12503	741	81151	1982-10-18	1982-11-01	1
67708	4006	81151	1966-09-18	1966-10-23	1
6007	352	4283893	1984-02-21	1984-04-24	1
9781	579	40481087	1986-02-08	1986-03-01	1
60282	3570	378001	2013-02-14	2013-03-16	1
8282	484	372328	1943-04-08	1943-12-20	1
64906	3841	372328	1974-04-16	1974-09-04	1
68989	4087	40481087	1979-09-16	1979-09-23	1
41410	2466	260139	2000-06-14	2000-06-28	1
16517	975	4278672	1972-01-08	1972-02-07	1
64789	3834	372328	1959-11-12	1960-06-26	1
37363	2217	4112343	2015-05-20	2015-06-01	1
67395	3987	28060	1965-12-06	1965-12-17	1
6600	390	28060	1988-06-10	1988-06-23	1
53373	3167	4112343	2016-12-16	2016-12-24	1
5688	334	4112343	1958-08-02	1958-08-14	1
13191	776	4283893	1997-10-26	1997-11-09	1
72005	4278	80180	1993-07-26	1993-07-27	1
10163	603	260139	2002-06-04	2002-06-11	1
61209	3623	80180	1988-07-24	1988-07-25	1
6397	376	4116491	1996-04-18	1996-05-20	1
58716	3486	40481087	1971-08-02	1971-08-16	1
59188	3514	260139	1981-06-14	1981-06-21	1
44812	2669	4112343	2000-02-21	2000-03-04	1
63444	3750	4134304	1999-03-20	1999-06-18	1
12190	722	40481087	2000-08-16	2000-08-30	1
76178	4525	40481087	1985-10-30	1985-11-20	1
68368	4045	40481087	1979-10-06	1979-10-13	1
6758	399	4294548	2018-04-22	2018-05-20	1
60812	3603	4051466	1969-02-12	1986-07-13	1
13144	775	4142905	1947-05-03	1947-06-02	1
56338	3342	40481087	1944-08-30	1944-09-06	1
38538	2290	28060	1984-05-14	1984-05-25	1
69307	4106	4112343	1988-09-08	1988-09-19	1
74762	4446	4294548	2002-01-04	2002-03-01	1
8162	479	260139	2018-09-21	2018-10-05	1
71854	4269	378001	1971-02-15	1971-03-17	1
13794	817	4112343	1982-07-05	1982-07-12	1
5114	300	260139	2007-08-21	2007-08-28	1
69332	4107	80180	2014-08-16	2014-08-17	1
69897	4139	4266809	2011-09-17	2011-09-18	1
4113	239	40481087	1950-07-08	1950-07-15	1
64330	3803	260139	1966-07-12	1966-07-19	1
9601	569	260139	2012-03-31	2012-04-07	1
66951	3962	40481087	1986-08-19	1986-08-26	1
9479	563	40481087	1967-03-23	1967-04-13	1
4172	244	260139	1974-10-16	1974-10-30	1
71578	4250	4109685	1949-01-11	1949-01-25	1
71661	4255	40481087	2009-12-16	2010-01-06	1
1595	94	4112343	1963-11-21	1963-11-29	1
6236	366	40481087	1948-11-06	1948-11-20	1
82007	4867	4296205	1968-09-21	1968-10-05	1
69660	4125	4112343	2007-02-02	2007-02-12	1
10632	625	40481087	1988-02-21	1988-03-13	1
10791	640	78272	2002-10-02	2002-10-23	1
65664	3887	81151	1957-06-20	1957-07-18	1
12504	741	257012	1982-05-06	1982-05-07	1
67709	4006	257012	1971-05-01	1971-05-02	1
6008	352	4310024	2010-09-08	2010-09-09	1
9782	579	28060	1970-06-02	1970-06-10	1
60283	3570	4112343	1950-01-31	1950-02-08	1
8283	484	4027663	1964-12-27	1964-12-28	1
64907	3841	4112343	2018-09-25	2018-10-04	1
68990	4087	81151	2008-03-20	2008-04-03	1
41411	2466	4155034	1996-08-17	1996-09-07	1
16518	975	260139	2003-01-27	2003-02-03	1
64790	3834	4112343	1974-03-07	1974-03-14	1
42371	2528	4112343	2005-06-02	2005-06-13	1
67396	3987	80180	1997-02-03	1997-02-04	1
6601	390	260139	1989-10-20	1989-10-27	1
53374	3167	40481087	2005-07-04	2005-07-18	1
5689	334	4112343	1986-05-16	1986-05-29	1
13192	776	4283893	2004-08-06	2004-09-03	1
72006	4278	317576	1978-12-29	1978-12-30	1
10164	603	260139	2014-03-12	2014-03-26	1
61210	3623	81151	1999-03-14	1999-04-18	1
6398	376	4142905	1969-02-14	1969-05-15	1
58717	3486	40481087	2010-01-30	2010-02-13	1
59189	3514	440448	2015-08-11	2015-08-12	1
44813	2669	81151	1979-10-24	1979-11-28	1
63445	3750	4285898	1993-10-11	1993-10-12	1
12191	722	40481087	2005-04-12	2005-04-26	1
76179	4525	260139	2007-05-23	2007-05-30	1
68369	4045	40481087	1984-11-23	1984-12-14	1
6759	399	40481087	1977-04-02	1977-04-23	1
60813	3603	0	1967-02-08	1967-02-09	1
13145	775	4294548	1974-04-27	1974-05-18	1
61431	3634	30753	2006-04-05	2006-04-06	1
38539	2290	28060	1999-10-07	1999-10-17	1
69308	4106	4112343	1999-04-21	1999-05-03	1
74763	4446	40481087	1998-08-03	1998-08-17	1
8163	479	372328	1943-01-04	1943-03-28	1
71855	4269	440448	1976-05-01	1976-05-02	1
13795	817	4283893	2005-04-19	2005-09-06	1
5115	300	372328	1973-04-18	1973-06-08	1
69333	4107	372328	1972-01-12	1972-04-17	1
72285	4295	80180	2007-09-28	2007-09-29	1
4114	239	40481087	1958-11-28	1958-12-19	1
64331	3803	372328	1961-12-04	1962-09-19	2
9602	569	381316	1998-02-21	1998-02-22	1
66952	3962	40481087	2018-09-25	2018-10-16	1
9480	563	40481087	1998-04-22	1998-05-06	1
4173	244	372328	1926-05-07	1927-02-07	1
71579	4250	4146173	2017-04-26	2017-06-25	1
72742	4329	372328	1978-11-28	1979-03-11	1
1596	94	4112343	1972-01-19	1972-01-28	1
6237	366	40481087	1952-02-08	1952-02-22	1
82008	4867	40481087	1927-02-07	1927-02-28	1
69661	4125	4237458	1992-06-14	1992-07-14	1
10633	625	4027663	2006-11-27	2006-11-28	1
10792	640	81151	2011-06-08	2011-06-29	1
65665	3887	81151	1960-05-03	1960-05-24	1
12505	741	260139	2004-05-05	2004-05-19	1
67710	4006	372328	1950-09-12	1950-11-28	1
11989	710	260139	1992-07-05	1992-07-12	1
9783	579	260139	2008-08-22	2008-09-05	1
60284	3570	4112343	1995-02-28	1995-03-12	1
8284	484	4109685	2012-06-24	2012-07-08	1
64908	3841	40481087	2002-08-15	2002-08-22	1
68991	4087	260139	2010-10-13	2010-10-20	1
41412	2466	80180	2018-11-24	2018-11-25	1
16519	975	4146173	2009-09-11	2009-10-11	1
64791	3834	40481087	1957-07-11	1957-07-18	1
42372	2528	40481087	1975-09-17	1975-10-01	1
67397	3987	313217	2016-03-05	2016-03-06	1
6602	390	4113008	1980-04-09	1980-04-23	1
53375	3167	28060	1985-04-26	1985-05-06	1
5690	334	4218389	1982-02-08	1982-03-08	1
13193	776	40481087	1986-09-02	1986-09-16	1
72007	4278	4112343	2002-12-28	2003-01-10	1
10165	603	4112343	2010-05-05	2010-05-18	1
61211	3623	81151	2012-03-01	2012-04-05	1
6399	376	4278672	1965-04-06	1965-07-05	1
60023	3560	257012	1971-11-23	1971-11-24	1
59190	3514	4112343	1985-09-01	1985-09-09	1
44814	2669	260139	2010-03-19	2010-03-26	1
63446	3750	260139	1987-11-13	1987-11-27	1
12192	722	40481087	2017-12-09	2017-12-16	1
76180	4525	4218389	2012-04-30	2012-05-21	1
68370	4045	40481087	2000-06-18	2000-07-02	1
6760	399	40481087	2014-05-28	2014-06-04	1
60814	3603	28060	1973-10-01	1973-10-11	1
13146	775	40481087	1973-06-16	1973-06-23	1
61432	3634	80180	2007-03-31	2007-04-01	1
38540	2290	260139	1993-10-28	1993-11-11	1
69309	4106	4152936	1963-01-21	1963-02-04	1
74764	4446	80180	2002-03-05	2002-03-06	1
8164	479	375671	1969-09-26	1969-10-26	1
71856	4269	4112343	1981-10-04	1981-10-12	1
13796	817	4294548	1998-12-21	1999-01-11	1
5116	300	4112343	1982-08-31	1982-09-09	1
69334	4107	4112343	2018-01-15	2018-01-27	1
72286	4295	260139	2009-04-09	2009-04-23	1
4115	239	0	2012-07-05	2012-07-06	1
64332	3803	4109685	2011-04-21	2011-05-05	1
9603	569	4112343	1923-05-15	1923-05-26	1
66953	3962	195588	1997-05-06	1997-06-28	1
9481	563	28060	1969-08-15	1969-08-22	1
4174	244	372328	1938-02-09	1938-04-11	1
71580	4250	40481087	1950-12-07	1950-12-28	1
72743	4329	372328	1982-05-25	1982-10-31	1
1597	94	4294548	1976-03-31	1976-08-18	1
6238	366	40481087	1959-06-15	1959-06-22	1
82009	4867	40481087	1935-01-20	1935-02-10	1
69662	4125	40481087	1985-11-15	1985-11-22	1
10634	625	4112343	1998-01-04	1998-01-13	1
10793	640	260139	1960-03-26	1960-04-02	1
65666	3887	260139	1977-05-20	1977-06-03	1
12506	741	4116491	1995-11-24	1995-12-30	1
67711	4006	381316	2016-08-02	2016-08-03	1
11990	710	372328	1961-10-15	1961-12-26	1
9784	579	4112343	1984-06-13	1984-06-23	1
60285	3570	40481087	1968-10-18	1968-10-25	1
8285	484	4112343	2010-06-05	2010-06-16	1
67543	3995	440086	1982-02-10	1989-02-18	1
68992	4087	372328	1982-01-26	1982-09-29	1
41413	2466	134438	2002-09-17	2003-12-10	1
16520	975	40479768	1979-12-11	1980-01-17	1
64792	3834	40481087	1957-12-22	1957-12-29	1
42373	2528	40481087	1994-04-10	1994-04-17	1
67398	3987	4112343	1980-08-31	1980-09-13	1
6603	390	40481087	1978-04-29	1978-05-20	1
53376	3167	80180	2002-08-14	2002-08-15	1
5691	334	40480160	2005-09-03	2005-11-02	1
15389	914	372328	1948-08-10	1948-11-01	1
72008	4278	4112343	2014-10-11	2014-10-18	1
10166	603	40481087	1986-05-13	1986-06-03	1
61212	3623	372328	1954-06-10	1955-01-30	1
6400	376	40481087	1982-05-31	1982-06-21	1
60024	3560	4109685	2017-04-10	2017-05-01	1
59191	3514	0	2015-08-11	2015-08-12	1
44815	2669	40481087	1996-11-21	1996-11-28	1
63447	3750	372328	1960-12-18	1961-04-01	1
12193	722	80180	2010-04-17	2010-04-18	1
76181	4525	40481087	2015-11-29	2015-12-20	1
68371	4045	28060	2003-03-19	2003-03-27	1
6761	399	81151	1960-01-07	1960-02-11	1
60815	3603	133834	1967-11-05	1983-08-13	1
13147	775	372328	1940-03-10	1940-04-24	1
61433	3634	260139	2008-04-06	2008-04-20	1
38541	2290	4112343	1966-03-26	1966-04-03	1
69310	4106	40481087	2016-03-23	2016-04-13	1
74765	4446	4156265	2014-06-20	2014-07-04	1
8165	479	440086	1952-10-18	1957-10-27	1
71857	4269	4166224	1976-05-01	1976-05-02	1
13797	817	40481087	1993-04-02	1993-04-23	1
5117	300	40481087	1995-01-20	1995-01-27	1
69335	4107	40481087	1987-12-19	1987-12-26	1
72287	4295	4113008	1997-12-18	1998-01-08	1
4116	239	260139	2003-11-21	2003-12-05	1
64333	3803	4112343	1973-05-09	1973-05-20	1
9604	569	4112343	1981-01-03	1981-01-13	1
66954	3962	260139	1969-02-22	1969-03-08	1
9482	563	381316	2005-03-13	2005-03-14	1
4175	244	378001	1944-10-29	1944-11-28	1
71581	4250	40481087	1957-03-29	1957-04-12	1
72744	4329	440086	1991-03-30	1996-04-08	1
1598	94	4296204	1998-07-23	1998-08-27	1
6239	366	40481087	1980-01-24	1980-02-07	1
82010	4867	40481087	1945-10-19	1945-10-26	1
69663	4125	40481087	2009-10-05	2009-10-12	1
10635	625	4112343	1999-06-11	1999-06-24	1
10794	640	260139	1992-04-24	1992-05-01	1
65667	3887	4112343	1957-09-20	1957-09-27	1
12507	741	4134304	1977-12-13	1978-01-12	1
67712	4006	4285898	1994-06-28	1994-06-29	1
11991	710	372328	1964-01-20	1964-03-24	1
9785	579	4146173	2016-06-07	2016-08-06	1
60286	3570	40481087	1978-02-16	1978-03-09	1
8286	484	4278672	1997-03-15	1997-05-14	1
67544	3995	4112343	2001-07-26	2001-08-04	1
68993	4087	4152936	1995-07-06	1995-07-27	1
41414	2466	260139	2004-04-26	2004-05-03	1
16521	975	40481087	2006-02-19	2006-03-12	1
64793	3834	40481087	2007-02-27	2007-03-13	1
42374	2528	28060	1969-11-12	1969-11-25	1
67399	3987	4112343	1990-10-22	1990-11-03	1
6604	390	40481087	1980-09-12	1980-10-03	1
53377	3167	257012	1990-06-15	1990-06-16	1
5692	334	40480160	2009-09-12	2009-10-12	1
15390	914	4134304	2015-06-09	2015-07-09	1
72009	4278	4152936	2010-09-01	2010-09-15	1
10167	603	40481087	1987-12-17	1987-12-24	1
61213	3623	4112343	2012-04-23	2012-05-04	1
6854	404	81893	2000-07-29	2000-07-30	1
60025	3560	4112343	1985-04-27	1985-05-07	1
59192	3514	81151	1982-05-30	1982-06-27	1
44816	2669	40481087	2011-11-17	2011-12-08	1
63448	3750	372328	1961-09-28	1961-12-30	1
12194	722	4112343	1974-07-16	1974-07-29	1
76182	4525	28060	1974-02-01	1974-02-09	1
68372	4045	80180	2015-04-27	2015-04-28	1
6762	399	4112343	1962-02-22	1962-03-04	1
60816	3603	440086	1980-02-03	1984-02-12	1
13148	775	378001	1956-05-11	1956-06-10	1
61434	3634	4237458	2002-10-17	2003-01-15	1
38542	2290	4112343	2005-06-01	2005-06-09	1
69311	4106	28060	1944-07-05	1944-07-17	1
74766	4446	4294548	1997-09-01	1997-09-29	1
8166	479	4152936	2011-11-15	2011-11-29	1
71858	4269	4218389	2013-12-27	2014-01-31	1
13798	817	81151	1961-12-21	1962-01-18	1
5118	300	260139	2005-06-16	2005-06-30	1
69336	4107	40481087	1991-05-18	1991-06-01	1
72288	4295	4266809	2007-09-28	2007-09-29	1
4117	239	4113008	1966-08-25	1966-09-15	1
64334	3803	4116491	2002-04-03	2002-05-17	1
9605	569	4112343	1993-04-14	1993-04-24	1
66955	3962	4112343	1992-08-30	1992-09-10	1
9483	563	440086	1973-04-10	1982-04-18	1
4176	244	378001	1979-02-28	1979-04-29	1
71582	4250	40481087	1958-04-13	1958-04-20	1
72745	4329	4059173	1991-09-20	1991-12-18	1
1599	94	40481087	1979-10-11	1979-10-18	1
6240	366	81893	1943-04-07	1943-04-08	1
82011	4867	40481087	1949-03-15	1949-03-29	1
69664	4125	80180	2006-11-28	2006-11-29	1
10636	625	4112343	2009-09-13	2009-09-26	1
10795	640	40481087	1982-10-01	1982-10-08	1
65668	3887	4266809	1990-04-08	1990-04-09	1
12508	741	40481087	1976-04-27	1976-05-11	1
67713	4006	40481087	1950-01-21	1950-01-28	1
11992	710	4112343	1969-10-21	1969-10-31	1
9786	579	4294548	2012-05-17	2012-08-23	1
60287	3570	40481087	2004-06-29	2004-07-20	1
8287	484	40481087	1953-04-18	1953-05-09	1
67545	3995	4278672	1974-02-27	1974-05-28	1
68994	4087	40481087	2016-03-30	2016-04-13	1
41415	2466	4112343	2002-02-04	2002-02-17	1
16522	975	378001	2018-12-23	2019-02-21	1
64794	3834	80180	1994-06-27	1994-06-28	1
42375	2528	28060	1978-09-04	1978-09-12	1
67400	3987	40481087	1974-08-05	1974-08-12	1
6605	390	40481087	1992-05-04	1992-05-18	1
53378	3167	260139	1983-02-11	1983-02-25	1
5693	334	40481087	1987-12-18	1987-12-25	1
15391	914	4156265	2004-01-24	2004-02-07	1
72010	4278	4294548	2006-04-30	2006-06-04	1
10168	603	28060	1960-11-17	1960-11-30	1
61214	3623	4285898	1988-04-25	1988-04-26	1
6855	404	260139	1965-03-22	1965-04-05	1
60026	3560	40481087	1961-11-02	1961-11-09	1
59193	3514	439777	1997-08-13	1997-08-14	1
48916	2898	28060	1991-09-27	1991-10-05	1
63449	3750	4027663	1986-01-16	1986-01-17	1
12195	722	4152936	2011-11-28	2011-12-19	1
76183	4525	28060	1990-02-27	1990-03-10	1
68373	4045	40481087	2007-08-01	2007-08-22	1
6763	399	4112343	2001-01-28	2001-02-04	1
60817	3603	4112343	1986-07-07	1986-07-19	1
13149	775	4112343	1987-06-14	1987-06-27	1
61435	3634	40481087	2018-03-04	2018-03-25	1
38543	2290	4155034	1999-08-13	1999-09-03	1
69312	4106	4112343	1967-10-18	1967-10-26	1
74767	4446	4294548	2002-10-06	2002-10-27	1
8167	479	4283893	1982-01-14	1982-05-27	1
71859	4269	40481087	1989-06-12	1989-06-26	1
13799	817	4294548	1998-09-01	1998-09-15	1
5119	300	4112343	1988-07-10	1988-07-17	1
69337	4107	40481087	2003-03-02	2003-03-16	1
72289	4295	40481087	1995-07-09	1995-07-23	1
4118	239	40481087	1964-10-26	1964-11-02	1
66986	3966	80180	2003-05-20	2003-05-21	1
9606	569	4112343	2007-12-09	2007-12-20	1
66956	3962	4156265	1981-09-21	1981-10-12	1
9484	563	40481087	1964-08-16	1964-08-30	1
4177	244	4112343	1934-03-29	1934-04-08	1
71583	4250	40481087	1966-05-14	1966-05-21	1
72746	4329	4112343	2001-12-06	2001-12-18	1
1600	94	40481087	1988-11-02	1988-11-09	1
6241	366	192671	1944-10-06	1944-10-07	1
82012	4867	40481087	1967-10-29	1967-11-12	1
69665	4125	321042	1988-10-25	1988-10-26	1
10637	625	4310024	2012-02-24	2012-02-25	1
10796	640	40481087	1994-11-07	1994-11-28	1
65669	3887	40481087	2005-09-12	2005-09-19	1
12509	741	40481087	1999-03-02	1999-03-16	1
67714	4006	40481087	1984-04-24	1984-05-01	1
11993	710	4112343	1980-07-07	1980-07-18	1
9787	579	40481087	1974-04-21	1974-05-05	1
60288	3570	260139	1957-01-16	1957-01-23	1
8288	484	40481087	1954-07-10	1954-07-17	1
67546	3995	4112343	1977-02-15	1977-02-22	1
68995	4087	28060	1985-11-08	1985-11-19	1
41416	2466	4112343	1981-05-11	1981-05-24	1
16523	975	4112343	2004-11-27	2004-12-04	1
64795	3834	372328	1966-08-24	1967-06-25	1
42376	2528	80180	2007-08-03	2007-08-04	1
67401	3987	80502	2014-02-22	2014-02-23	1
6606	390	40481087	2003-11-22	2003-12-06	1
53379	3167	260139	1990-11-06	1990-11-13	1
7072	418	80180	1996-02-01	1996-02-02	1
15392	914	40481087	1973-12-09	1973-12-16	1
72011	4278	40481087	1952-03-18	1952-04-08	1
10169	603	80180	1995-12-15	1995-12-16	1
61215	3623	4296204	1966-03-18	1966-04-08	1
6856	404	260139	2007-01-21	2007-01-28	1
60027	3560	40481087	1979-07-21	1979-08-11	1
59194	3514	4113008	1975-09-13	1975-10-04	1
48917	2898	80180	2016-08-29	2016-08-30	1
63450	3750	4296204	1993-04-29	1993-05-20	1
12196	722	40481087	1995-11-14	1995-12-05	1
76184	4525	81151	1973-06-03	1973-06-24	1
68374	4045	372328	1980-01-28	1980-10-11	1
6764	399	4113008	1972-03-09	1972-03-30	1
60818	3603	80180	2004-03-23	2004-03-24	1
13150	775	4112343	2002-01-11	2002-01-18	1
61436	3634	4156265	2000-11-12	2000-11-26	1
38544	2290	40481087	2001-02-10	2001-02-24	1
69313	4106	4112343	2007-04-09	2007-04-18	1
76286	4530	80180	2008-11-29	2008-11-30	1
8168	479	4294548	1966-04-24	1966-07-10	1
71860	4269	40481087	1997-11-17	1997-12-01	1
13800	817	40479768	2012-12-26	2013-02-01	1
5120	300	4112343	2002-11-03	2002-11-15	1
69338	4107	28060	1995-01-21	1995-01-29	1
72290	4295	40481087	2019-01-16	2019-01-23	1
4119	239	40481087	2001-08-19	2001-09-09	1
66987	3966	195588	2016-11-27	2017-01-15	1
9607	569	4112343	2017-12-12	2017-12-24	1
66957	3962	40481087	1989-08-15	1989-08-22	1
9485	563	40481087	1978-04-13	1978-04-20	1
4178	244	4112343	1946-06-05	1946-06-14	1
71584	4250	40481087	1976-06-21	1976-07-05	1
72747	4329	40481087	1985-09-29	1985-10-06	1
1601	94	260139	1960-10-04	1960-10-18	1
6242	366	260139	1949-05-31	1949-06-07	1
84311	5017	28060	1981-11-05	1981-11-15	1
69666	4125	4109685	1987-11-17	1987-12-08	1
10638	625	28060	1979-04-07	1979-04-15	1
12858	758	28060	1985-05-23	1985-06-04	1
65670	3887	80180	1990-04-08	1990-04-09	1
12510	741	40481087	2007-03-11	2007-03-25	1
67715	4006	40481087	2000-12-23	2000-12-30	1
11994	710	4237458	1973-02-14	1973-04-15	1
9788	579	40481087	1988-07-11	1988-08-01	1
60289	3570	4112343	1994-06-22	1994-07-02	1
8289	484	40481087	1983-01-16	1983-01-23	1
67547	3995	4112343	1992-02-06	1992-02-13	1
68996	4087	28060	1991-08-22	1991-08-31	1
41417	2466	4134304	1989-06-25	1989-08-24	1
16524	975	40481087	1994-07-01	1994-07-15	1
64796	3834	4112343	1993-11-12	1993-11-24	1
42377	2528	375671	2008-04-19	2008-05-19	1
67402	3987	260139	2010-08-17	2010-08-31	1
6607	390	80180	2016-05-15	2016-05-16	1
53380	3167	372328	1964-11-22	1965-05-16	1
7073	418	81151	1971-08-23	1971-09-13	1
15393	914	40481087	2005-10-16	2005-11-06	1
72012	4278	40481087	1957-11-16	1957-12-07	1
10170	603	260139	1973-05-10	1973-05-24	1
61216	3623	40481087	1974-03-18	1974-04-01	1
6857	404	4112343	2002-01-06	2002-01-14	1
60028	3560	28060	1994-05-22	1994-06-04	1
59195	3514	40481087	2004-03-23	2004-03-30	1
48918	2898	372328	1980-03-24	1980-06-24	1
63451	3750	40481087	1974-10-27	1974-11-17	1
12197	722	40481087	2006-07-27	2006-08-03	1
76185	4525	257012	1987-09-14	1988-01-04	1
68375	4045	260139	1988-02-25	1988-03-03	1
6765	399	4280726	1958-04-09	1958-04-10	1
60819	3603	260139	1969-12-18	1969-12-25	1
13151	775	4112343	2013-10-15	2013-10-27	1
61437	3634	4278672	1982-04-21	1982-07-20	1
38545	2290	40481087	2008-01-24	2008-01-31	1
69314	4106	4310024	1982-01-18	1982-01-19	1
76287	4530	260139	1991-11-14	1991-11-21	1
8169	479	40481087	2007-07-04	2007-07-11	1
71861	4269	81151	1975-02-24	1975-03-17	1
13801	817	40481087	1971-09-30	1971-10-21	1
5121	300	4112343	2007-12-20	2008-01-02	1
69339	4107	40481087	2001-02-13	2001-03-06	1
72291	4295	192671	2007-12-11	2007-12-12	1
4120	239	81151	1947-07-17	1947-08-21	1
66988	3966	260139	2005-10-18	2005-10-25	1
9608	569	4116491	1935-04-22	1935-06-02	1
66958	3962	80180	1989-11-24	1989-11-25	1
9486	563	40481087	1980-05-16	1980-05-30	1
4179	244	4112343	1956-01-11	1956-01-18	1
71585	4250	40481087	1995-05-26	1995-06-16	1
72748	4329	40481087	2011-08-27	2011-09-17	1
1602	94	372328	1978-01-30	1978-05-12	1
6243	366	260139	1966-10-18	1966-11-01	1
84312	5017	81151	1983-10-23	1983-11-13	1
69667	4125	40481087	1994-03-15	1994-03-22	1
10639	625	28060	1979-06-17	1979-06-28	1
12859	758	260139	1996-08-23	1996-09-06	1
65671	3887	4027663	1983-06-19	1983-06-20	1
12511	741	372328	1977-04-17	1977-05-01	1
67716	4006	40481087	2004-04-24	2004-05-01	1
11995	710	40481087	1999-12-03	1999-12-17	1
9789	579	28060	1996-09-21	1996-10-01	1
60290	3570	4113008	1966-12-06	1966-12-27	1
8290	484	30753	1974-04-19	1974-04-20	1
67548	3995	40481087	1992-07-12	1992-07-19	1
68997	4087	260139	1983-12-18	1984-01-01	1
43001	2564	28060	1991-08-06	1991-08-17	1
16525	975	40481087	2017-10-09	2017-10-30	1
64797	3834	4283893	1971-10-13	1972-02-02	1
42378	2528	40481087	1977-04-01	1977-04-08	1
67403	3987	4059173	2008-03-01	2008-04-30	1
6608	390	260139	2015-05-20	2015-05-27	1
53381	3167	4035415	2011-09-30	2011-10-30	1
7074	418	257012	1971-07-28	1971-07-29	1
15394	914	4059173	2013-05-20	2013-07-19	1
72013	4278	40481087	2004-01-03	2004-01-17	1
10171	603	372328	1959-08-21	1960-02-12	1
61217	3623	40481087	1979-02-10	1979-02-17	1
6858	404	4156265	2007-12-24	2008-01-07	1
60029	3560	260139	1976-07-11	1976-07-25	1
59196	3514	40481087	2015-12-07	2015-12-14	1
48919	2898	192671	2016-09-03	2016-09-04	1
63452	3750	40481087	2008-12-10	2008-12-24	1
12198	722	260139	1969-07-12	1969-07-19	1
76186	4525	372328	1969-10-22	1969-11-12	1
68376	4045	40481087	1985-04-22	1985-04-29	1
6766	399	4294548	1992-06-04	1993-05-20	1
60820	3603	260139	1974-06-14	1974-06-21	1
13152	775	40481087	1941-04-09	1941-04-16	1
61438	3634	40481087	1990-08-07	1990-08-21	1
39385	2337	28060	1963-11-17	1963-11-24	1
69315	4106	40481087	1946-05-30	1946-06-13	1
76288	4530	4059173	1980-07-19	1980-10-17	1
8170	479	260139	1944-02-29	1944-03-14	1
71862	4269	372328	1968-05-31	1968-08-07	1
13802	817	40481087	2004-08-01	2004-08-15	1
5122	300	40481087	1980-07-17	1980-07-31	1
69340	4107	40481087	2012-01-06	2012-01-20	1
72292	4295	260139	1999-10-20	1999-10-27	1
4121	239	260139	1964-01-20	1964-02-03	1
66989	3966	4285898	2002-10-22	2002-10-23	1
9609	569	4155034	1949-02-08	1949-03-01	1
66959	3962	260139	1963-10-13	1963-10-20	1
9487	563	4112343	2002-03-14	2002-03-21	1
4180	244	4294548	1932-12-08	1932-12-29	1
71586	4250	40481087	1998-02-22	1998-03-08	1
72749	4329	80180	2010-11-10	2010-11-11	1
1603	94	381316	2005-01-28	2005-01-29	1
6244	366	4112343	1981-06-14	1981-06-22	1
84313	5017	260139	1997-07-21	1997-07-28	1
69668	4125	40481087	2012-08-05	2012-08-26	1
10640	625	4266809	2014-02-13	2014-02-14	1
12860	758	260139	2000-05-04	2000-05-11	1
65672	3887	4109685	1984-11-14	1984-11-28	1
12512	741	40481087	1996-04-14	1996-04-21	1
67717	4006	81151	2011-04-30	2011-05-28	1
11996	710	260139	1964-10-30	1964-11-06	1
9790	579	81151	1998-12-06	1999-01-03	1
61076	3618	257012	1994-05-20	1994-05-21	1
8291	484	192671	1974-08-11	1974-08-12	1
67549	3995	80180	2005-11-21	2005-11-22	1
68998	4087	4152936	1990-10-16	1990-10-30	1
43002	2564	257012	1996-06-14	1996-06-15	1
18849	1135	260139	1996-05-09	1996-05-16	1
64798	3834	40481087	1960-04-23	1960-05-07	1
42379	2528	260139	1977-05-03	1977-05-17	1
67404	3987	4134304	1964-11-19	1965-02-17	1
6609	390	4116491	2016-01-26	2016-02-29	1
53382	3167	4112343	1973-08-30	1973-09-07	1
7075	418	260139	2016-04-03	2016-04-17	1
15395	914	4112343	1945-11-27	1945-12-06	1
72014	4278	257012	1982-03-05	1982-03-06	1
10172	603	372328	1985-05-31	1986-11-14	1
61218	3623	40481087	2002-12-16	2002-12-30	1
6859	404	4285898	2001-01-25	2001-01-26	1
60030	3560	260139	1991-08-22	1991-08-29	1
59523	3532	28060	1981-10-13	1981-10-25	1
48920	2898	4116491	2015-02-15	2015-04-06	1
64909	3843	80180	2008-06-21	2008-06-22	1
12199	722	4112343	1980-05-30	1980-06-11	1
76187	4525	40481087	1986-08-24	1986-08-31	1
71013	4217	260139	1976-06-11	1976-06-25	1
6767	399	40481087	1989-11-25	1989-12-09	1
60821	3603	260139	2001-06-02	2001-06-16	1
13153	775	40481087	2010-08-03	2010-08-10	1
61439	3634	28060	1995-07-13	1995-07-25	1
39386	2337	78272	1978-01-28	1978-02-25	1
69316	4106	40481087	1954-03-12	1954-03-26	1
76289	4530	4112343	1976-06-07	1976-06-16	1
8171	479	260139	1949-02-17	1949-03-03	1
71863	4269	372328	1970-06-28	1970-10-07	1
13803	817	40481087	2018-07-07	2018-07-28	1
9012	528	260139	1971-08-25	1971-09-08	1
69341	4107	40481087	2018-12-21	2018-12-28	1
72293	4295	260139	2017-03-02	2017-03-09	1
4122	239	317576	2012-01-12	2012-01-13	1
66990	3966	40481087	2001-06-02	2001-06-09	1
9610	569	4296205	2009-01-29	2009-02-12	1
66960	3962	378001	2006-12-05	2007-01-04	1
9488	563	4155034	1969-04-16	1969-05-07	1
4181	244	4310024	1964-05-17	1964-05-18	1
71587	4250	260139	1947-11-20	1947-11-27	1
72750	4329	81151	1981-03-17	1981-04-14	1
1604	94	40481087	1989-10-13	1989-10-27	1
6245	366	4134304	1998-11-03	1999-02-01	1
84314	5017	40481087	2010-04-28	2010-05-12	1
72887	4337	80180	2006-02-13	2006-02-14	1
10641	625	4283893	2000-12-11	2001-08-13	1
12861	758	378001	1997-07-31	1997-08-30	1
65673	3887	4112343	1970-03-24	1970-04-05	1
12513	741	80180	2011-07-08	2011-07-09	1
67718	4006	260139	1981-08-17	1981-08-31	1
11997	710	372328	1974-10-28	1975-07-15	1
9791	579	260139	1994-03-30	1994-04-06	1
61077	3618	378419	1989-02-25	1989-02-26	1
8292	484	257012	1962-12-19	1962-12-20	1
67550	3995	372328	1973-05-03	1973-07-21	1
68999	4087	40481087	2018-07-09	2018-07-30	1
43003	2564	260139	1993-08-23	1993-09-06	1
18850	1135	372328	1959-09-04	1959-12-05	1
65562	3881	28060	1958-07-14	1958-07-25	1
42380	2528	372328	1991-10-16	1992-06-10	1
67405	3987	4218389	1956-08-12	1956-09-02	1
6610	390	40481087	1988-07-31	1988-08-21	1
53383	3167	4112343	2005-06-21	2005-06-30	1
7076	418	4112343	1983-01-01	1983-01-12	1
15396	914	4112343	1950-05-18	1950-05-29	1
72015	4278	258780	1986-10-31	1986-11-01	1
10173	603	4112343	1962-04-25	1962-05-07	1
61219	3623	81893	1986-12-02	1986-12-03	1
6860	404	40481087	2018-02-11	2018-02-18	1
60031	3560	4112343	1999-06-11	1999-06-21	1
59524	3532	81893	2006-06-28	2006-06-29	1
48921	2898	260139	1984-01-21	1984-01-28	1
64910	3843	192671	2008-06-27	2008-06-28	1
12200	722	4112343	1997-08-21	1997-09-01	1
76188	4525	28060	2013-11-06	2013-11-19	1
71014	4217	372328	1987-09-10	1989-03-01	1
8637	505	378001	1976-01-08	1976-03-08	1
60822	3603	260139	2006-06-21	2006-06-28	1
13154	775	81151	1948-03-28	1948-04-25	1
61440	3634	4027663	1997-02-16	1997-02-17	1
39387	2337	260139	1993-09-08	1993-09-15	1
69317	4106	40481087	1969-05-09	1969-05-23	1
76290	4530	40481087	1992-12-22	1993-01-12	1
8172	479	4112343	2004-07-10	2004-07-21	1
71864	4269	4152936	1981-04-14	1981-05-05	1
13804	817	80180	1999-07-20	1999-07-21	1
9013	528	40481087	1979-11-26	1979-12-17	1
71432	4241	28060	1973-11-13	1973-11-24	1
72294	4295	372328	1975-10-01	1976-07-28	1
4123	239	4112343	1970-06-17	1970-06-29	1
66991	3966	81893	2001-10-27	2001-10-28	1
11401	675	28060	1956-12-03	1956-12-14	1
66961	3962	4112343	1968-04-30	1968-05-08	1
9489	563	40481087	1985-11-05	1985-11-26	1
4182	244	40481087	1934-03-31	1934-04-07	1
71588	4250	4112343	1947-07-22	1947-07-31	1
72751	4329	260139	2013-12-19	2013-12-26	1
1605	94	40481087	2009-01-24	2009-02-14	1
6246	366	4149245	1954-11-21	1954-12-28	1
84315	5017	260139	1996-09-16	1996-09-23	1
72888	4337	192671	2006-04-26	2006-04-27	1
11299	669	28060	2008-04-22	2008-04-30	1
12862	758	4237458	1974-03-20	1974-05-19	1
65674	3887	4112343	2014-09-28	2014-10-11	1
12514	741	321042	2000-05-26	2000-05-27	1
67719	4006	372328	1966-03-09	1966-10-18	1
11998	710	4156265	1992-04-05	1992-04-26	1
9792	579	372328	1963-11-07	1964-02-26	1
61078	3618	4296204	1926-12-22	1927-01-19	1
8293	484	372328	1939-08-26	1939-12-11	1
67551	3995	4112343	2018-08-06	2018-08-18	1
69000	4087	257012	1993-05-18	1993-05-19	1
43004	2564	260139	2002-09-24	2002-10-08	1
18851	1135	4112343	1974-12-17	1974-12-27	1
65563	3881	80180	1992-08-31	1992-09-01	1
42381	2528	4035415	1974-09-15	1974-10-15	1
67406	3987	40481087	1985-09-19	1985-10-03	1
10069	598	80180	2009-10-26	2009-10-27	1
53384	3167	4152936	1979-02-17	1979-03-03	1
7077	418	40481087	1962-05-09	1962-05-23	1
15397	914	4283893	1971-08-17	1972-03-14	1
72016	4278	375671	1987-09-18	1987-11-17	1
10174	603	4112343	1978-01-15	1978-01-28	1
61220	3623	260139	1951-01-12	1951-01-19	1
6861	404	81151	1962-06-04	1962-07-09	1
60032	3560	4283893	1971-09-28	1971-12-21	1
59525	3532	378001	2011-05-29	2011-06-28	1
48922	2898	260139	2000-08-02	2000-08-16	1
64911	3843	260139	1978-02-21	1978-03-07	1
12201	722	40481087	1981-02-25	1981-03-04	1
76189	4525	260139	1969-01-26	1969-02-09	1
71015	4217	4112343	1973-09-06	1973-09-19	1
8638	505	4084167	1983-09-14	1983-09-14	1
60823	3603	260139	2009-07-26	2009-08-02	1
13155	775	4149245	2016-05-24	2016-06-30	1
61441	3634	4285898	2006-11-01	2006-11-02	1
39388	2337	260139	2004-07-08	2004-07-15	1
69318	4106	80180	1984-02-07	1984-02-08	1
76291	4530	40481087	1997-08-25	1997-09-08	1
8173	479	40481087	1943-11-09	1943-11-16	1
71865	4269	4283893	2000-07-27	2000-09-07	1
13805	817	81893	1997-05-01	1997-05-02	1
9014	528	80180	2002-07-02	2002-07-03	1
71433	4241	28060	2008-10-02	2008-10-10	1
72295	4295	4027663	1998-09-15	1998-09-16	1
4124	239	4112343	2009-07-22	2009-07-30	1
66992	3966	192671	2003-05-31	2003-06-01	1
11402	675	78272	2019-06-07	2019-06-08	1
66962	3962	4294548	2018-11-23	2019-01-18	1
9490	563	40481087	1993-02-25	1993-03-11	1
4183	244	80180	1966-06-06	1966-06-07	1
71589	4250	4112343	1996-10-12	1996-10-21	1
72752	4329	4294548	2018-11-04	2018-12-30	1
1606	94	28060	1955-10-12	1955-10-19	1
6247	366	4218389	1995-08-25	1995-09-29	1
84316	5017	260139	2011-10-15	2011-10-29	1
72889	4337	372328	1961-11-14	1962-02-16	1
11300	669	4109685	1998-06-15	1998-07-06	1
12863	758	40481087	1991-01-11	1991-01-25	1
65675	3887	4278672	1968-12-08	1969-01-07	1
12515	741	378001	2004-09-02	2004-11-01	1
67720	4006	4027663	1982-12-13	1982-12-14	1
11999	710	40481087	1967-03-23	1967-03-30	1
9793	579	4112343	1997-07-02	1997-07-09	1
61079	3618	195588	1931-01-17	1931-02-19	1
8294	484	4112343	1991-06-26	1991-07-09	1
67552	3995	4113008	1978-01-07	1978-01-21	1
69001	4087	260139	1988-11-20	1988-11-27	1
43005	2564	372328	1979-07-07	1979-07-28	1
18852	1135	40481087	1984-04-19	1984-05-03	1
65564	3881	260139	2015-11-28	2015-12-12	1
42382	2528	4109685	2018-11-23	2018-12-07	1
67407	3987	40481087	1996-02-15	1996-02-29	1
10070	598	81151	1987-02-14	1987-02-28	1
53385	3167	4283893	1990-05-25	1990-08-31	1
7078	418	40481087	1999-05-07	1999-05-14	1
15398	914	81151	1947-01-18	1947-02-01	1
72017	4278	378001	1964-04-30	1964-06-29	1
10175	603	4155034	2015-09-29	2015-10-20	1
61221	3623	372328	1952-04-04	1952-07-20	1
6862	404	260139	1988-02-10	1988-02-17	1
60033	3560	40481087	1971-03-18	1971-03-25	1
59526	3532	4112343	2014-03-15	2014-03-27	1
48923	2898	372328	1979-09-13	1979-12-25	1
64912	3843	4218389	1979-06-14	1979-07-19	1
12202	722	40481087	1990-05-25	1990-06-08	1
76190	4525	4283893	1987-07-06	1988-01-04	1
71016	4217	4112343	1989-02-22	1989-03-01	1
8639	505	4156265	1971-03-21	1971-04-04	1
60824	3603	372328	1971-09-08	1972-01-02	1
13156	775	4296204	2000-02-20	2000-03-19	1
61442	3634	372328	1974-05-03	1975-02-03	1
39389	2337	4112343	2000-05-11	2000-05-18	1
69319	4106	81151	1966-02-18	1966-03-18	1
76292	4530	81151	1976-08-04	1976-09-08	1
8174	479	40481087	1977-12-14	1977-12-28	1
71866	4269	40481087	1983-01-18	1983-02-08	1
13806	817	192671	1999-09-20	1999-09-21	1
9015	528	4112343	2007-12-03	2007-12-15	1
71434	4241	30753	2006-01-10	2006-01-11	1
72296	4295	4112343	2011-12-23	2012-01-03	1
4125	239	4285898	1991-07-31	1991-08-01	1
66993	3966	378001	2008-03-02	2008-04-01	1
11403	675	80180	1984-04-03	1984-04-04	1
66963	3962	4310024	1988-01-04	1988-01-05	1
15088	890	28060	2015-05-25	2015-06-04	1
4184	244	260139	1923-06-23	1923-06-30	1
71590	4250	4112343	2002-12-04	2002-12-15	1
72753	4329	40481087	2013-08-14	2013-08-28	1
1607	94	260139	2015-11-30	2015-12-14	1
6248	366	4283893	1914-09-05	1914-11-28	1
84317	5017	4283893	1993-09-27	1993-11-22	1
72890	4337	4112343	1987-02-11	1987-02-21	1
11301	669	4112343	1972-03-22	1972-04-01	1
12864	758	80180	2012-10-31	2012-11-01	1
65676	3887	30753	1989-12-09	1989-12-10	1
13896	822	80180	2013-09-21	2013-09-22	1
67721	4006	4134304	1997-12-09	1998-02-07	1
12000	710	40481087	2000-12-20	2001-01-10	1
9794	579	4294548	1964-02-10	1964-06-08	1
61080	3618	260139	1916-08-20	1916-08-27	1
8295	484	4112343	1994-01-26	1994-02-04	1
67553	3995	4116491	2014-02-02	2014-03-06	1
69002	4087	260139	2002-09-17	2002-09-24	1
43006	2564	4112343	1991-11-19	1991-11-30	1
18853	1135	260139	1981-01-01	1981-01-15	1
65565	3881	4112343	1982-06-02	1982-06-15	1
42383	2528	4112343	1970-10-24	1970-11-02	1
67408	3987	40481087	2007-06-19	2007-07-03	1
10071	598	81151	2014-01-07	2014-02-04	1
53386	3167	40481087	2013-01-07	2013-01-28	1
7079	418	81151	1999-09-07	1999-09-21	1
15399	914	260139	2006-07-09	2006-07-16	1
72018	4278	4112343	1955-11-25	1955-12-08	1
10176	603	4278672	1983-09-12	1983-12-11	1
61222	3623	4109685	2013-01-30	2013-02-13	1
6863	404	440086	1970-06-12	1971-11-05	1
60034	3560	40481087	1999-07-24	1999-08-14	1
59527	3532	4112343	2018-07-19	2018-07-28	1
48924	2898	4084167	1980-03-11	1980-03-12	1
64913	3843	4283893	2001-05-25	2001-06-15	1
15040	887	28060	1969-07-25	1969-08-06	1
76191	4525	40481087	1994-05-11	1994-05-18	1
71017	4217	4278672	1991-07-05	1991-09-03	1
8640	505	40481087	1995-04-17	1995-04-24	1
60825	3603	40481087	1981-02-20	1981-02-27	1
13157	775	40481087	1971-04-07	1971-04-21	1
61443	3634	40481087	1986-05-08	1986-05-22	1
39390	2337	4152936	2011-02-28	2011-03-14	1
69320	4106	81893	1982-08-16	1982-08-17	1
76293	4530	4134304	1988-07-07	1988-09-05	1
8175	479	40481087	2004-08-27	2004-09-10	1
71867	4269	0	1976-05-01	1976-05-02	1
13807	817	257012	2005-05-31	2005-06-01	1
9016	528	4112343	2011-09-28	2011-10-07	1
71435	4241	372328	1987-12-26	1990-03-06	1
72297	4295	4285898	2007-05-31	2007-06-01	1
4126	239	4310024	1989-09-09	1989-09-10	1
66994	3966	4027663	1994-12-03	1994-12-04	1
11404	675	260139	1968-04-19	1968-04-26	1
68602	4064	28060	1966-11-18	1966-11-30	1
15089	890	378001	1968-04-11	1968-06-10	1
4185	244	260139	1926-12-20	1926-12-27	1
71591	4250	4112343	2016-03-07	2016-03-15	1
72754	4329	260139	1981-10-16	1981-10-29	1
1608	94	4112343	2004-12-08	2004-12-17	1
6249	366	4283893	2009-12-13	2010-10-31	1
84318	5017	80180	2015-06-27	2015-06-28	1
72891	4337	4116491	2004-05-29	2004-07-22	1
11302	669	260139	2007-05-31	2007-06-14	1
12865	758	81151	1988-12-01	1988-12-15	1
65677	3887	260139	1963-09-19	1963-09-26	1
13897	822	40481087	1992-09-23	1992-10-07	1
67722	4006	4283893	2001-04-08	2001-06-03	1
12001	710	40481087	2007-03-04	2007-03-25	1
9795	579	40481087	1971-08-09	1971-08-30	1
61081	3618	260139	1956-12-23	1957-01-06	1
8296	484	4112343	2010-02-21	2010-03-03	1
67554	3995	260139	1998-04-23	1998-04-30	1
69003	4087	4134304	2013-12-03	2014-02-01	1
43007	2564	4294548	1996-05-24	1997-04-18	1
18854	1135	260139	1992-01-04	1992-01-18	1
65566	3881	4112343	2000-01-25	2000-02-06	1
42384	2528	4112343	2000-05-17	2000-05-27	1
72346	4299	4285898	2012-12-23	2012-12-24	1
10072	598	4266809	2009-10-26	2009-10-27	1
53387	3167	28060	2011-09-29	2011-10-10	1
7080	418	378001	1964-06-30	1964-08-29	1
15400	914	4109685	1967-04-17	1967-05-08	1
72019	4278	4112343	1994-06-01	1994-06-11	1
10177	603	4296204	2008-04-03	2008-05-08	1
61223	3623	4112343	1982-04-10	1982-04-18	1
6864	404	4266809	2001-12-21	2001-12-22	1
60035	3560	80180	1994-08-14	1994-08-15	1
59528	3532	4266809	2007-06-23	2007-06-24	1
48925	2898	4112343	2013-08-22	2013-08-31	1
64914	3843	40481087	1976-06-05	1976-06-26	1
15041	887	80502	2018-02-24	2018-02-25	1
77079	4571	260139	2000-08-03	2000-08-10	1
71018	4217	4285898	2000-06-23	2000-06-24	1
8641	505	40481087	2013-12-22	2014-01-05	1
60826	3603	40481087	1998-12-20	1999-01-10	1
13158	775	195588	1966-11-09	1966-12-20	1
61788	3652	372328	1975-10-11	1976-02-15	1
39391	2337	4283893	1979-10-12	1979-11-30	1
69321	4106	372328	1947-06-16	1947-07-11	1
76294	4530	4237458	1969-05-13	1969-06-12	1
8176	479	80180	1979-12-01	1979-12-02	1
71868	4269	81151	1988-02-28	1988-03-13	1
13808	817	260139	1971-11-01	1971-11-08	1
9017	528	4278672	2002-04-13	2002-07-12	1
71436	4241	4112343	1991-12-16	1991-12-28	1
72298	4295	40481087	1975-10-09	1975-10-30	1
4127	239	40481087	1976-01-12	1976-01-26	1
66995	3966	4112343	2004-09-25	2004-10-05	1
11405	675	260139	1985-03-25	1985-04-08	1
68603	4064	4112343	1991-02-08	1991-02-16	1
15090	890	440086	1970-05-26	1971-01-12	1
4186	244	260139	1954-03-09	1954-03-16	1
71592	4250	4134304	2000-06-24	2000-07-24	1
72755	4329	4112343	1981-12-16	1981-12-26	1
3415	196	80180	2000-09-19	2000-09-20	1
6250	366	4294548	1931-01-17	1931-02-21	1
84319	5017	4112343	1988-07-14	1988-07-26	1
72892	4337	4218389	1966-12-01	1967-01-05	1
11303	669	260139	2018-11-07	2018-11-14	1
12866	758	372328	1977-02-02	1978-03-05	2
65678	3887	260139	1980-09-01	1980-09-08	1
13898	822	40481087	1996-08-22	1996-09-12	1
67723	4006	40481087	2016-03-04	2016-03-25	1
12002	710	80180	2004-04-27	2004-04-28	1
9796	579	40481087	1988-02-26	1988-03-04	1
61082	3618	372328	1913-07-05	1913-12-27	1
8297	484	40481087	1957-12-03	1957-12-17	1
67555	3995	4152936	2010-03-25	2010-04-15	1
69004	4087	4294548	1993-04-20	1993-06-22	1
43008	2564	40481087	1985-06-11	1985-06-18	1
18855	1135	260139	2014-07-13	2014-07-27	1
65567	3881	40481087	1958-05-18	1958-06-08	1
42385	2528	40481087	1983-01-13	1983-01-20	1
72347	4299	40481087	1973-07-20	1973-08-10	1
10073	598	4112343	2000-05-07	2000-05-18	1
53388	3167	30753	2001-09-18	2001-09-19	1
7081	418	4112343	1963-11-04	1963-11-11	1
15401	914	4112343	1980-01-25	1980-02-07	1
72020	4278	4112343	1997-11-25	1997-12-08	1
10178	603	40481087	1966-01-23	1966-02-06	1
61224	3623	40481087	1964-08-23	1964-08-30	1
6865	404	40481087	1968-09-22	1968-09-29	1
60036	3560	260139	2016-11-27	2016-12-04	1
59529	3532	40481087	1999-08-04	1999-08-18	1
48926	2898	4116491	2012-01-08	2012-02-16	1
64915	3843	40481087	1983-09-12	1983-09-19	1
15042	887	81151	1967-10-21	1967-11-11	1
77080	4571	260139	2018-03-11	2018-03-25	1
71019	4217	40481087	1960-05-13	1960-06-03	1
8642	505	80180	2001-11-13	2001-11-14	1
62948	3721	260139	1965-10-06	1965-10-13	1
13159	775	260139	1959-07-01	1959-07-08	1
61789	3652	4294548	1999-06-17	1999-12-16	1
39392	2337	40481087	1978-02-05	1978-02-12	1
69322	4106	4112343	1989-04-21	1989-05-03	1
76295	4530	40481087	1968-12-23	1968-12-30	1
8177	479	257012	1982-02-25	1982-02-26	1
71869	4269	4112343	1973-09-03	1973-09-13	1
13809	817	260139	2008-12-03	2008-12-10	1
9018	528	40481087	1963-01-30	1963-02-13	1
71437	4241	4156265	1965-10-22	1965-11-12	1
72299	4295	40481087	1997-08-17	1997-08-31	1
4128	239	81151	1963-12-25	1964-01-08	1
66996	3966	4152936	1977-06-29	1977-07-13	1
11406	675	372328	1951-04-19	1951-08-21	1
68604	4064	4237458	2004-02-23	2004-05-23	1
15091	890	4112343	1988-04-03	1988-04-15	1
4187	244	378001	1985-09-24	1985-11-23	1
71593	4250	40481087	1997-08-26	1997-09-16	1
72756	4329	4112343	2014-06-18	2014-06-27	1
3416	196	81151	1970-12-21	1971-01-25	1
6251	366	4296205	1923-01-17	1923-02-07	1
84320	5017	40481087	1986-10-14	1986-10-28	1
72893	4337	4296204	1963-03-31	1963-04-21	1
11304	669	4112343	1977-12-03	1977-12-14	1
12867	758	40481087	2000-10-27	2000-11-10	1
65679	3887	260139	1982-11-28	1982-12-12	1
13899	822	40481087	2002-07-19	2002-07-26	1
67724	4006	192671	1995-01-10	1995-01-11	1
12003	710	260139	1985-01-21	1985-01-28	1
11623	687	133834	1967-11-24	1984-03-05	1
61083	3618	378001	1969-03-30	1969-04-29	1
8298	484	40481087	1962-06-01	1962-06-22	1
67556	3995	4156265	1986-01-09	1986-01-30	1
70013	4149	28060	2005-06-25	2005-07-03	1
43009	2564	440086	1986-08-19	1989-02-28	1
18856	1135	378001	1969-02-02	1969-04-03	1
65568	3881	0	1997-01-03	1997-01-04	1
42386	2528	40481087	1992-06-06	1992-06-13	1
72348	4299	40481087	2004-11-25	2004-12-09	1
10074	598	40481087	1988-10-11	1988-10-18	1
53389	3167	81151	1974-01-23	1974-02-13	1
7082	418	4155034	1981-10-20	1981-11-10	1
15402	914	40481087	1979-10-23	1979-10-30	1
72021	4278	4113008	1959-02-05	1959-02-26	1
10179	603	40481087	1978-01-13	1978-01-27	1
61225	3623	40481087	1985-05-21	1985-06-04	1
6866	404	40481087	2001-01-07	2001-01-21	1
60037	3560	40481087	1961-01-08	1961-01-29	1
59530	3532	40481087	2002-08-10	2002-08-31	1
48927	2898	260139	2017-04-02	2017-04-09	1
64916	3843	28060	2000-03-08	2000-03-18	1
15043	887	4283893	1971-06-19	1971-07-10	1
77081	4571	372328	1956-01-17	1956-06-02	1
71020	4217	40481087	1980-08-27	1980-09-03	1
8643	505	81151	1993-08-04	1993-09-08	1
62949	3721	260139	1972-06-12	1972-06-26	1
13160	775	260139	1962-07-23	1962-08-06	1
61790	3652	40481087	1975-07-08	1975-07-22	1
39393	2337	40481087	2000-04-20	2000-05-11	1
69323	4106	4112343	2000-04-29	2000-05-11	1
76296	4530	40481087	1972-04-18	1972-04-25	1
8178	479	260139	2009-06-18	2009-07-02	1
71870	4269	4112343	2005-03-29	2005-04-08	1
13810	817	372328	1958-02-10	1958-04-24	1
9019	528	40481087	1975-03-07	1975-03-14	1
71438	4241	4156265	1985-02-28	1985-03-21	1
72300	4295	260139	1973-07-14	1973-07-28	1
4129	239	260139	1984-10-23	1984-10-30	1
66997	3966	257012	1971-07-02	1971-07-03	1
11407	675	4027663	1975-02-10	1975-02-11	1
68605	4064	40481087	2012-06-06	2012-06-20	1
15092	890	40481087	1967-12-21	1968-01-04	1
4188	244	378419	1990-01-22	1990-01-23	1
71594	4250	40481087	1999-07-08	1999-07-29	1
72757	4329	40479422	2014-10-19	2014-12-24	1
3417	196	4027663	1988-10-07	1988-10-08	1
6252	366	4310024	1942-10-09	1942-10-10	1
84321	5017	40481087	2004-12-29	2005-01-19	1
72894	4337	40481087	1981-04-22	1981-04-29	1
11305	669	4112343	2004-10-27	2004-11-06	1
12868	758	260139	2000-07-12	2000-07-19	1
65680	3887	4116491	1977-06-20	1977-07-23	1
13900	822	372328	1975-09-16	1976-05-07	1
67725	4006	260139	1970-10-05	1970-10-12	1
12004	710	372328	1962-11-21	1963-03-26	1
11624	687	372328	1968-01-16	1968-03-30	1
61084	3618	4112343	1972-12-01	1972-12-14	1
8299	484	40481087	1984-10-21	1984-11-04	1
67557	3995	40481087	1986-09-30	1986-10-07	1
70014	4149	372328	1970-11-12	1970-11-26	1
43010	2564	4112343	2005-08-22	2005-09-03	1
18857	1135	4035415	1981-10-27	1981-11-26	1
65569	3881	78272	1998-05-31	1998-06-21	1
42387	2528	28060	1977-05-30	1977-06-08	1
72349	4299	40481087	2015-05-28	2015-06-11	1
10075	598	81893	2007-10-07	2007-10-08	1
53390	3167	260139	1966-07-06	1966-07-20	1
7083	418	4283893	1971-07-14	1971-12-22	1
15403	914	40481087	1989-04-16	1989-05-07	1
72022	4278	4146173	1960-02-21	1960-04-21	1
10180	603	40481087	1984-03-02	1984-03-16	1
61226	3623	40481087	1996-08-05	1996-08-12	1
6867	404	80180	2001-12-21	2001-12-22	1
60038	3560	40481087	1981-10-04	1981-10-11	1
59531	3532	80180	2007-06-23	2007-06-24	1
48928	2898	372328	1981-04-20	1981-06-23	1
64917	3843	372328	1972-02-21	1972-05-14	1
15044	887	28060	2019-06-24	2019-06-25	1
77082	4571	4149245	2001-03-17	2001-05-23	1
71021	4217	4048171	1962-08-19	1993-07-14	1
8644	505	81893	2000-05-22	2000-05-23	1
62950	3721	372328	1968-02-03	1968-10-18	1
13161	775	260139	1982-09-05	1982-09-12	1
61791	3652	28060	1978-04-06	1978-04-16	1
39394	2337	40481087	2005-03-25	2005-04-08	1
69324	4106	40481087	1959-11-01	1959-11-22	1
76297	4530	40481087	1981-11-09	1981-11-23	1
8179	479	372328	1957-04-13	1958-04-20	1
71871	4269	40481087	1994-10-04	1994-10-25	1
13811	817	4112343	2017-04-11	2017-04-21	1
9020	528	40481087	1981-04-16	1981-05-07	1
71439	4241	40481087	1970-07-18	1970-08-08	1
72301	4295	372328	1976-12-25	1977-08-03	1
4130	239	372328	1963-10-21	1964-01-23	1
66998	3966	378001	1987-05-22	1987-06-21	1
11408	675	4051466	1952-02-23	1967-06-07	1
68606	4064	28060	1972-11-30	1972-12-11	1
15093	890	40481087	1971-04-24	1971-05-15	1
4189	244	4112343	1961-06-24	1961-07-03	1
71595	4250	81151	1996-11-14	1996-12-12	1
72758	4329	40481087	1990-10-17	1990-10-24	1
3418	196	4218389	1984-04-16	1984-05-14	1
6253	366	40481087	1929-07-13	1929-07-20	1
84322	5017	192671	2015-08-17	2015-08-18	1
72895	4337	40481087	1991-01-14	1991-02-04	1
11306	669	4116491	1995-09-25	1995-11-14	1
12869	758	260139	2006-05-03	2006-05-10	1
65681	3887	40481087	1992-06-03	1992-06-17	1
13901	822	4112343	1976-03-26	1976-04-02	1
67726	4006	4283893	1971-04-10	1971-07-24	1
12005	710	439777	1964-04-17	1964-04-18	1
11625	687	372328	1971-11-13	1972-01-01	1
61085	3618	4112343	1987-01-30	1987-02-09	1
8300	484	28060	1940-01-27	1940-02-08	1
68798	4077	260139	1983-11-22	1983-11-29	1
70015	4149	4112343	2008-06-18	2008-06-29	1
43011	2564	4142905	1986-06-05	1986-07-05	1
18858	1135	4112343	1972-03-19	1972-03-30	1
65570	3881	260139	1998-01-13	1998-01-20	1
42388	2528	257012	1997-12-31	1998-01-01	1
72350	4299	81151	1974-11-17	1974-12-08	1
10076	598	192671	2010-01-22	2010-01-23	1
53391	3167	4155034	1996-01-03	1996-01-24	1
7084	418	40481087	2001-02-08	2001-02-22	1
15404	914	80180	1989-03-08	1989-03-09	1
72023	4278	4283893	2000-03-05	2000-11-12	1
10181	603	4112343	2008-11-18	2008-11-25	1
61227	3623	28060	1956-06-27	1956-07-10	1
6868	404	260139	2001-11-07	2001-11-21	1
60039	3560	40481087	1990-12-25	1991-01-01	1
59532	3532	372328	1973-09-13	1973-12-16	1
48929	2898	372328	1982-04-19	1982-12-21	2
64918	3843	4112343	1995-05-24	1995-06-01	1
15045	887	80180	1991-06-27	1991-06-28	1
77083	4571	40481087	1983-06-19	1983-07-10	1
71022	4217	4112343	1976-01-11	1976-01-19	1
8645	505	260139	2013-11-06	2013-11-20	1
62951	3721	4112343	1968-03-25	1968-04-01	1
13162	775	260139	2012-09-06	2012-09-20	1
61792	3652	80180	2009-05-23	2009-05-24	1
39395	2337	4112343	1992-09-25	1992-10-05	1
71059	4220	260139	1973-03-18	1973-04-01	1
76298	4530	40481087	2010-01-12	2010-02-02	1
8180	479	4156265	1955-12-27	1956-01-17	1
71872	4269	80180	2007-06-11	2007-06-12	1
13812	817	40481087	1969-07-21	1969-08-04	1
9021	528	40481087	1986-10-15	1986-11-05	1
71440	4241	40481087	1978-12-03	1978-12-10	1
72302	4295	4296204	1982-08-25	1982-09-08	1
4131	239	4027663	1979-10-17	1979-10-18	1
66999	3966	4112343	1976-03-19	1976-03-30	1
11409	675	4112343	1968-01-31	1968-02-08	1
68607	4064	4218389	1999-06-28	1999-07-19	1
15094	890	40481087	1986-08-21	1986-09-04	1
4190	244	4266809	1966-06-06	1966-06-07	1
71596	4250	260139	1974-03-11	1974-03-25	1
72759	4329	40481087	1997-05-29	1997-06-05	1
3419	196	4237458	1966-06-15	1966-08-14	1
6254	366	40481087	1934-06-09	1934-06-23	1
84323	5017	40481087	1991-05-14	1991-06-04	1
72896	4337	40481087	2010-10-25	2010-11-01	1
11307	669	40481087	1980-11-26	1980-12-10	1
12870	758	4112343	1985-12-03	1985-12-11	1
65682	3887	40481087	2010-08-01	2010-08-08	1
13902	822	4112343	1976-08-04	1976-08-15	1
67727	4006	40481087	1961-05-05	1961-05-12	1
12006	710	4112343	1962-05-15	1962-05-27	1
11626	687	440448	1992-01-17	1992-01-18	1
61086	3618	4112343	1993-09-08	1993-09-18	1
8301	484	80180	1974-06-18	1974-06-19	1
68799	4077	4112343	1998-04-18	1998-04-30	1
70016	4149	192671	2002-10-13	2002-10-14	1
43012	2564	4218389	1995-12-15	1996-01-05	1
18859	1135	40481087	1983-12-07	1983-12-14	1
65571	3881	260139	2013-01-03	2013-01-10	1
42389	2528	260139	2010-07-30	2010-08-13	1
72351	4299	81151	1989-05-23	1989-06-20	1
10077	598	260139	2014-10-21	2014-10-28	1
53392	3167	260139	2017-08-25	2017-09-08	1
7085	418	78272	1958-07-20	1958-08-03	1
15405	914	257012	1971-10-12	1972-03-14	1
72024	4278	40481087	1988-03-09	1988-03-30	1
10182	603	40481087	1986-08-11	1986-08-18	1
61228	3623	78272	1961-02-07	1961-03-14	1
6869	404	4294548	1963-12-31	1964-03-10	1
60040	3560	40481087	2014-06-02	2014-06-09	1
59533	3532	4027663	1996-07-05	1996-07-06	1
48930	2898	4112343	1986-08-09	1986-08-22	1
64919	3843	4112343	2013-06-20	2013-07-03	1
15046	887	81151	2002-07-29	2002-08-19	1
77084	4571	40481087	1992-01-30	1992-02-06	1
71023	4217	40481087	1975-06-10	1975-06-17	1
8646	505	372328	1969-03-31	1969-05-13	1
62952	3721	4294548	2005-01-07	2005-05-13	1
13163	775	4112343	2005-02-05	2005-02-15	1
61793	3652	257012	1999-08-05	1999-08-06	1
39396	2337	40481087	2006-10-09	2006-10-23	1
71060	4220	260139	1986-03-09	1986-03-23	1
76299	4530	260139	1990-01-25	1990-02-08	1
8181	479	40481087	2003-12-19	2003-12-26	1
71873	4269	260139	2010-03-23	2010-03-30	1
13813	817	40481087	2004-04-19	2004-04-26	1
9022	528	40481087	1995-03-31	1995-04-21	1
71441	4241	40481087	1990-07-10	1990-07-31	1
72303	4295	40481087	1982-06-30	1982-07-21	1
4132	239	4329847	2012-07-05	2012-07-06	1
67000	3966	4112343	1989-11-02	1989-11-09	1
11410	675	4218389	1950-12-03	1950-12-31	1
68608	4064	40481087	1985-02-03	1985-02-24	1
15095	890	40481087	2006-02-28	2006-03-21	1
4191	244	4285898	1966-03-08	1966-03-09	1
71597	4250	260139	1988-08-26	1988-09-02	1
72760	4329	195588	2008-03-26	2008-05-24	1
3420	196	40481087	1977-04-13	1977-04-27	1
6255	366	40481087	1954-06-11	1954-07-02	1
85672	5103	80180	1985-02-12	1985-02-13	1
72897	4337	257012	1979-01-15	1979-01-16	1
11308	669	80180	2004-10-07	2004-10-08	1
12871	758	4112343	2007-03-22	2007-04-02	1
65683	3887	192671	1990-06-23	1990-06-24	1
13903	822	4112343	1978-09-08	1978-09-18	1
67728	4006	40481087	1967-01-19	1967-01-26	1
12007	710	40481087	1968-05-31	1968-06-14	1
11627	687	4048695	2003-10-23	2003-12-24	1
61087	3618	40481087	1944-09-03	1944-09-24	1
8302	484	4112343	1965-05-29	1965-06-09	1
68800	4077	28060	1988-10-26	1988-11-03	1
70017	4149	4109685	2006-04-26	2006-05-10	1
43013	2564	4218389	2009-12-22	2010-01-19	1
18860	1135	40481087	2006-08-07	2006-08-14	1
65572	3881	317576	1986-11-07	1986-11-08	1
42390	2528	260139	2011-03-28	2011-04-11	1
72352	4299	4112343	1978-11-15	1978-11-23	1
10078	598	372328	1977-01-07	1977-02-25	1
53393	3167	372328	1960-09-03	1960-11-13	1
7086	418	81151	1959-08-28	1959-09-25	1
15406	914	4146173	1979-07-04	1979-08-03	1
72025	4278	40481087	2004-07-24	2004-08-14	1
10183	603	40481087	2009-04-07	2009-04-21	1
61229	3623	260139	2005-01-06	2005-01-20	1
6870	404	40481087	2008-07-22	2008-08-05	1
60041	3560	81151	1978-03-01	1978-03-15	1
59534	3532	4112343	1976-09-10	1976-09-23	1
48931	2898	4112343	2006-04-21	2006-04-30	1
64920	3843	40481087	2008-11-11	2008-11-18	1
15047	887	260139	1982-04-15	1982-04-22	1
77085	4571	260139	1993-12-29	1994-01-05	1
71024	4217	80180	2001-04-19	2001-04-20	1
8647	505	378001	2011-06-20	2011-07-20	1
62953	3721	40481087	1968-02-28	1968-03-06	1
13164	775	4112343	2010-09-19	2010-09-27	1
61794	3652	260139	2015-03-04	2015-03-11	1
39397	2337	4112343	2015-07-31	2015-08-09	1
71061	4220	4237458	2012-08-10	2012-11-08	1
76300	4530	4152936	2008-09-20	2008-10-04	1
12468	739	372328	1910-09-30	1910-12-14	1
71874	4269	4035415	2006-07-07	2006-09-05	1
13814	817	28060	1970-01-22	1970-01-29	1
9023	528	195588	1981-05-23	1981-06-25	1
71442	4241	40481087	1998-05-25	1998-06-08	1
72304	4295	28060	2018-01-04	2018-01-15	1
4133	239	40481087	1951-11-13	1951-11-27	1
67001	3966	4112343	2015-07-13	2015-07-22	1
11411	675	4283893	1999-09-20	1999-11-15	1
68609	4064	40481087	1998-12-03	1998-12-10	1
15096	890	260139	1966-03-25	1966-04-01	1
4192	244	40481087	1937-10-26	1937-11-02	1
71598	4250	372328	1950-07-05	1950-12-09	1
72761	4329	257012	2018-12-09	2018-12-30	1
3421	196	81893	1998-11-29	1998-11-30	1
6256	366	40481087	1974-01-10	1974-01-17	1
85673	5103	81151	1957-12-15	1958-01-12	1
72898	4337	260139	1984-09-13	1984-09-20	1
11309	669	81151	1985-06-09	1985-06-23	1
12872	758	4109685	2000-07-15	2000-08-05	1
65684	3887	260139	1973-05-08	1973-05-22	1
13904	822	4112343	2007-01-21	2007-02-01	1
67729	4006	28060	1993-07-12	1993-07-19	1
12008	710	40481087	1980-02-18	1980-03-10	1
11628	687	4051466	1970-01-27	1986-05-08	1
61088	3618	80180	1953-01-31	1953-02-01	1
8303	484	4112343	1999-08-08	1999-08-19	1
68801	4077	80180	2010-10-14	2010-10-15	1
70018	4149	4283893	1991-08-16	1991-12-27	1
43014	2564	78272	1983-05-31	1983-06-21	1
18861	1135	80180	1999-06-05	1999-06-06	1
65573	3881	321042	1997-01-03	1997-01-04	1
42391	2528	375671	1981-09-08	1981-10-08	1
72353	4299	4218389	1996-10-11	1996-11-08	1
10079	598	4027663	2001-09-13	2001-09-14	1
53394	3167	4027663	1992-05-28	1992-05-29	1
7087	418	260139	1990-10-01	1990-10-08	1
15407	914	4218389	2016-08-02	2016-08-23	1
72026	4278	28060	2000-12-24	2001-01-05	1
10184	603	40481087	2010-05-21	2010-05-28	1
61230	3623	440448	2009-06-05	2009-06-06	1
6871	404	40481087	2016-05-01	2016-05-15	1
60042	3560	260139	1980-06-12	1980-06-19	1
59535	3532	4112343	1989-12-13	1989-12-26	1
53536	3176	28060	1984-02-01	1984-02-10	1
64921	3843	81151	2007-11-19	2007-12-10	1
15048	887	4059173	1989-11-29	1990-02-27	1
77086	4571	4112343	2009-01-24	2009-02-04	1
71025	4217	4112343	1965-06-09	1965-06-17	1
8648	505	4116491	1998-05-28	1998-07-05	1
62954	3721	40481087	1975-09-19	1975-09-26	1
13165	775	4283893	1962-09-02	1962-09-16	1
61795	3652	372328	1974-04-07	1974-05-19	1
39398	2337	4156265	1990-02-22	1990-03-15	1
71062	4220	4266809	1977-04-05	1977-04-06	1
76301	4530	40481087	1990-08-13	1990-08-27	1
12469	739	4116491	1964-06-23	1964-08-02	1
71875	4269	4112343	1988-08-10	1988-08-23	1
13815	817	81151	1972-11-21	1972-12-26	1
9024	528	372328	1960-07-22	1960-08-05	1
71443	4241	257012	1998-08-13	1998-08-14	1
72305	4295	260139	1992-06-18	1992-07-02	1
5331	316	78272	1929-03-24	1929-04-28	1
67002	3966	4112343	2016-12-15	2016-12-23	1
11412	675	40481087	1958-12-20	1959-01-03	1
68610	4064	28060	2000-07-15	2000-07-28	1
15097	890	260139	1992-03-05	1992-03-19	1
4193	244	40481087	1965-02-01	1965-02-22	1
71599	4250	4112343	2001-08-28	2001-09-06	1
72762	4329	260139	2018-03-15	2018-03-22	1
3422	196	260139	2008-08-31	2008-09-14	1
6257	366	40481087	2003-07-06	2003-07-13	1
85674	5103	260139	1950-01-23	1950-01-30	1
72899	4337	260139	2016-07-06	2016-07-13	1
11310	669	260139	1974-04-09	1974-04-16	1
12873	758	40481087	1973-05-01	1973-05-15	1
65685	3887	260139	1975-06-22	1975-06-29	1
13905	822	40481087	1973-10-20	1973-10-27	1
67730	4006	260139	1951-04-11	1951-04-25	1
12009	710	40481087	2005-04-27	2005-05-04	1
11629	687	4218389	2013-09-02	2013-09-30	1
61089	3618	81151	1923-05-14	1923-06-11	1
8304	484	4112343	2007-10-19	2007-10-31	1
68802	4077	260139	1971-11-30	1971-12-14	1
70019	4149	40481087	1968-05-19	1968-06-09	1
43015	2564	80180	2018-12-24	2018-12-25	1
18862	1135	372328	1959-04-26	1959-06-06	1
65574	3881	40481087	1975-03-15	1975-03-29	1
42392	2528	378001	1979-12-18	1980-01-17	1
72354	4299	28060	1993-01-10	1993-01-17	1
10080	598	4112343	2001-11-10	2001-11-18	1
53395	3167	4218389	2006-08-29	2006-09-26	1
7088	418	260139	1999-04-26	1999-05-10	1
15408	914	40481087	2007-09-05	2007-09-26	1
72027	4278	134438	1973-10-21	1975-11-10	1
10185	603	78272	1964-11-22	1964-12-20	1
61231	3623	4027663	1976-06-12	1976-06-13	1
6872	404	30753	2000-08-28	2000-08-29	1
60043	3560	260139	2012-04-28	2012-05-12	1
59536	3532	4283893	1975-10-20	1975-12-29	1
53537	3176	78272	1982-04-10	1982-04-24	1
64922	3843	260139	1998-05-24	1998-06-07	1
15049	887	4112343	1960-02-03	1960-02-11	1
77087	4571	4155034	1981-03-18	1981-04-01	1
71026	4217	4152936	1965-10-05	1965-10-19	1
8649	505	40486433	1970-06-11	1970-06-12	1
62955	3721	40481087	1978-12-17	1979-01-07	1
13166	775	40481087	2004-06-14	2004-06-28	1
61796	3652	4112343	1977-09-22	1977-10-04	1
39399	2337	28060	1998-12-05	1998-12-17	1
71063	4220	40481087	1943-04-02	1943-04-09	1
76302	4530	40481087	2016-10-03	2016-10-24	1
12470	739	4237458	1991-08-15	1991-10-14	1
75752	4498	28060	1978-07-19	1978-07-26	1
13816	817	375671	1968-10-13	1968-11-12	1
9025	528	378001	1976-12-25	1977-01-24	1
71444	4241	4112343	1985-10-08	1985-10-15	1
72306	4295	40481087	1985-12-07	1985-12-21	1
5332	316	80180	1962-09-12	1962-09-13	1
67003	3966	4294548	1971-04-23	1971-09-10	1
11413	675	40481087	2015-03-15	2015-03-22	1
68611	4064	80180	1997-12-16	1997-12-17	1
15098	890	4112343	1964-10-15	1964-10-23	1
4194	244	40481087	1984-06-13	1984-07-04	1
71600	4250	4116491	1964-02-27	1964-04-12	1
72763	4329	4112343	1982-11-22	1982-12-04	1
3423	196	378001	1986-01-25	1986-03-26	1
8559	500	81893	1997-05-03	1997-05-04	1
85675	5103	260139	1967-12-29	1968-01-05	1
72900	4337	372328	1961-08-08	1961-09-15	1
11311	669	372328	1996-01-13	1997-12-10	1
12874	758	40481087	1979-01-21	1979-02-11	1
65686	3887	4112343	1977-04-02	1977-04-13	1
13906	822	40481087	2008-07-30	2008-08-06	1
67731	4006	260139	1952-07-23	1952-08-06	1
12010	710	40481087	2009-09-16	2009-09-23	1
11630	687	40481087	1996-02-26	1996-03-04	1
61090	3618	260139	1943-03-21	1943-03-28	1
8305	484	4134304	2011-03-02	2011-05-31	1
68803	4077	260139	1990-11-04	1990-11-18	1
70020	4149	80180	2002-08-05	2002-08-06	1
43016	2564	4112343	2012-10-28	2012-11-09	1
18863	1135	4112343	2003-04-30	2003-05-09	1
65575	3881	40481087	1977-08-24	1977-09-14	1
42393	2528	4112343	1979-09-10	1979-09-20	1
72355	4299	78272	1973-12-08	1973-12-22	1
10081	598	4310024	2006-11-11	2006-11-12	1
53396	3167	4266809	2002-08-14	2002-08-15	1
7089	418	4112343	1958-01-24	1958-02-01	1
18150	1092	28060	1967-01-06	1967-01-17	1
72028	4278	4109685	1995-06-08	1995-06-22	1
10186	603	260139	1983-11-03	1983-11-10	1
61232	3623	4112343	1955-01-21	1955-02-01	1
6873	404	81151	1983-01-20	1983-02-03	1
60044	3560	4109685	1987-02-26	1987-03-19	1
59537	3532	81151	1994-06-06	1994-06-27	1
53538	3176	134438	2001-12-03	2002-09-05	1
64923	3843	260139	2004-05-08	2004-05-15	1
15050	887	4218389	2000-08-03	2000-09-07	1
77088	4571	40481087	2010-07-07	2010-07-28	1
71027	4217	40481087	1968-07-27	1968-08-10	1
8650	505	81151	1996-10-22	1996-11-05	1
62956	3721	28060	1971-09-16	1971-09-25	1
15611	925	40481087	2006-03-19	2006-04-02	1
61797	3652	40481087	2006-05-22	2006-05-29	1
39400	2337	80180	2003-07-26	2003-07-27	1
71064	4220	40481087	1972-08-27	1972-09-17	1
76303	4530	378001	2010-08-25	2010-10-24	1
12471	739	4296204	1988-10-15	1988-10-29	1
75753	4498	80180	2013-12-26	2013-12-27	1
13817	817	4027663	1991-05-08	1991-05-09	1
9026	528	40481087	2016-07-08	2016-07-29	1
71445	4241	4294548	1986-01-10	1986-01-24	1
73451	4372	260139	2012-10-13	2012-10-20	1
5333	316	260139	2010-01-19	2010-01-26	1
67004	3966	4310024	2001-03-31	2001-04-01	1
11414	675	81893	1983-07-08	1983-07-09	1
68612	4064	133834	1960-11-12	1960-11-13	1
15099	890	4237458	1961-06-17	1961-08-16	1
4195	244	40481087	1988-01-22	1988-02-05	1
71601	4250	40481087	1971-03-01	1971-03-15	1
72764	4329	4112343	1997-07-20	1997-07-28	1
3424	196	4112343	1991-02-05	1991-02-16	1
8560	500	192671	1998-12-03	1998-12-04	1
85676	5103	439777	1984-09-30	1984-10-01	1
72901	4337	378001	1967-12-01	1968-01-30	1
11312	669	4112343	2014-10-28	2014-11-04	1
12875	758	40481087	1983-12-26	1984-01-09	1
65687	3887	4285898	1990-03-09	1990-03-10	1
13907	822	28060	1973-11-26	1973-12-03	1
67732	4006	4112343	1957-09-06	1957-09-16	1
13385	789	80180	2014-09-04	2014-09-05	1
11631	687	40486433	1969-01-27	1969-01-28	1
61091	3618	4112343	1952-12-08	1952-12-17	1
8306	484	4278672	1947-10-13	1948-01-11	1
68804	4077	4112343	1976-12-03	1976-12-11	1
70021	4149	372328	1966-03-27	1966-06-03	1
43017	2564	4296204	1978-08-11	1978-08-25	1
18864	1135	4112343	2009-10-06	2009-10-19	1
65576	3881	81151	1978-12-23	1979-01-20	1
42394	2528	4112343	1980-10-16	1980-10-26	1
72356	4299	80180	2013-08-20	2013-08-21	1
10082	598	40481087	1983-10-09	1983-10-30	1
53397	3167	40481087	1965-05-16	1965-05-30	1
7090	418	4112343	2011-07-30	2011-08-11	1
18151	1092	80180	1992-10-20	1992-10-21	1
72029	4278	4152936	1978-03-18	1978-04-08	1
10187	603	4112343	2009-05-26	2009-06-06	1
61233	3623	4152936	1958-02-02	1958-02-23	1
6874	404	260139	2011-11-10	2011-11-17	1
60045	3560	4278672	1988-04-12	1988-05-12	1
59538	3532	81151	2017-01-27	2017-02-17	1
53539	3176	260139	1997-06-30	1997-07-07	1
64924	3843	40481087	1976-08-30	1976-09-13	1
15051	887	28060	1971-10-27	1971-11-05	1
77089	4571	4109685	1979-02-06	1979-02-27	1
71028	4217	40481087	2000-10-26	2000-11-09	1
8651	505	260139	2019-02-26	2019-03-07	1
62957	3721	78272	1978-08-28	1978-09-11	1
15612	925	257012	2014-08-09	2014-08-10	1
61798	3652	81151	1992-06-01	1992-06-15	1
39401	2337	260139	2016-09-11	2016-09-18	1
71065	4220	40481087	2009-03-15	2009-04-05	1
76304	4530	4112343	2004-08-19	2004-08-28	1
12472	739	40481087	1916-11-06	1916-11-27	1
75754	4498	260139	1983-12-01	1983-12-15	1
13818	817	4112343	1967-05-25	1967-06-05	1
9027	528	4112343	1977-05-28	1977-06-09	1
71446	4241	40481087	1966-08-23	1966-08-30	1
73452	4372	4112343	1987-07-04	1987-07-16	1
5334	316	4112343	1939-09-14	1939-09-27	1
67005	3966	81151	1974-05-02	1974-05-16	1
11415	675	192671	1984-04-21	1984-04-22	1
68613	4064	4084167	1961-10-01	1961-10-01	1
15100	890	40481087	1969-06-03	1969-06-24	1
4196	244	30753	1965-11-08	1965-11-09	1
71602	4250	40481087	1989-08-05	1989-08-19	1
72765	4329	4112343	2008-09-17	2008-09-26	1
3425	196	4112343	1997-12-14	1997-12-27	1
8561	500	4112343	1983-04-26	1983-05-07	1
85677	5103	440086	1957-10-07	1958-02-03	1
72902	4337	4112343	1974-08-04	1974-08-15	1
11313	669	4294548	2012-02-25	2012-03-17	1
12876	758	40481087	1999-02-20	1999-02-27	1
65688	3887	40481087	1975-08-23	1975-08-30	1
13908	822	81151	1988-02-10	1988-03-09	1
67733	4006	40481087	1990-08-05	1990-08-12	1
13386	789	260139	1987-12-07	1987-12-21	1
11632	687	4084167	1977-05-03	1977-05-03	1
61092	3618	4112343	1961-11-04	1961-11-15	1
8307	484	4283893	1962-11-28	1962-12-26	1
68805	4077	4283893	1994-01-09	1994-02-06	1
70022	4149	372328	1968-06-22	1968-11-22	1
43018	2564	40481087	1992-03-10	1992-03-17	1
18865	1135	4283893	1973-01-17	1973-06-06	1
65577	3881	260139	2017-04-10	2017-04-24	1
42395	2528	4283893	1997-12-03	1998-04-15	1
72357	4299	260139	1978-03-18	1978-04-01	1
18373	1107	260139	1930-04-03	1930-04-10	1
53398	3167	40481087	2003-05-30	2003-06-06	1
7091	418	40481087	1976-05-12	1976-05-26	1
18152	1092	260139	1960-03-11	1960-03-25	1
72030	4278	4283893	1982-02-19	1982-05-07	1
10188	603	40481087	1961-04-21	1961-05-12	1
61234	3623	4218389	1990-07-31	1990-08-28	1
6875	404	4027663	1990-06-07	1990-06-08	1
60046	3560	40481087	1963-04-11	1963-05-02	1
59539	3532	260139	1995-10-31	1995-11-14	1
53540	3176	381316	2014-01-04	2014-01-05	1
64925	3843	40481087	1982-04-23	1982-05-14	1
15052	887	28060	1992-10-17	1992-10-25	1
77090	4571	4116491	2004-06-13	2004-08-03	1
71029	4217	40481087	2012-07-09	2012-07-23	1
8652	505	372328	1972-04-27	1973-05-15	1
62958	3721	80180	2002-08-27	2002-08-28	1
15613	925	260139	2007-04-30	2007-05-14	1
61799	3652	4112343	1981-05-03	1981-05-14	1
39402	2337	381316	2002-10-01	2002-10-02	1
71066	4220	4112343	1953-11-28	1953-12-07	1
76662	4548	80180	2017-09-29	2017-09-30	1
12473	739	260139	1927-10-11	1927-10-25	1
75755	4498	4237458	1983-11-19	1984-02-17	1
13819	817	4112343	1970-06-30	1970-07-07	1
9028	528	40481087	1962-02-19	1962-02-26	1
71447	4241	40481087	1986-08-30	1986-09-20	1
73453	4372	40481087	1984-02-13	1984-03-05	1
5335	316	40479768	1975-12-14	1976-02-19	1
67006	3966	4112343	1968-12-30	1969-01-09	1
11416	675	260139	1950-08-06	1950-08-20	1
68614	4064	4084167	1966-02-08	1966-02-08	1
15101	890	28060	1963-09-08	1963-09-19	1
4197	244	260139	1946-01-29	1946-02-05	1
76947	4563	81151	1980-04-17	1980-05-15	1
72766	4329	4112343	2013-10-04	2013-10-17	1
3426	196	4156265	1985-03-10	1985-03-31	1
8562	500	4155034	1974-06-23	1974-07-07	1
85678	5103	4112343	1967-05-23	1967-06-05	1
72903	4337	4112343	2006-07-29	2006-08-07	1
11314	669	258780	2018-11-21	2018-11-22	1
14371	851	28060	1989-08-22	1989-09-04	1
65689	3887	40481087	1990-06-18	1990-07-09	1
13909	822	40481087	1973-06-03	1973-06-17	1
77974	4625	4109685	1991-07-15	1991-08-05	1
13387	789	260139	1989-05-07	1989-05-21	1
11633	687	4112343	1992-08-30	1992-09-10	1
61093	3618	4112343	1980-04-10	1980-04-18	1
8308	484	4283893	1990-04-14	1990-05-12	1
68806	4077	260139	2013-07-16	2013-07-31	1
70023	4149	4112343	1973-11-16	1973-11-27	1
43019	2564	40481087	1996-02-04	1996-02-18	1
18866	1135	40481087	2002-10-04	2002-10-18	1
65578	3881	40481087	1964-09-12	1964-10-03	1
42396	2528	40481087	1979-05-06	1979-05-27	1
72358	4299	4027663	2005-02-03	2005-02-04	1
18374	1107	4112343	1939-05-13	1939-05-20	1
53399	3167	40481087	2008-09-07	2008-09-21	1
7092	418	40481087	1984-10-19	1984-10-26	1
18153	1092	260139	1981-01-10	1981-01-17	1
72031	4278	40481087	2005-11-12	2005-11-26	1
11749	695	260139	1990-08-18	1990-09-01	1
61235	3623	40481087	1989-07-20	1989-07-27	1
6876	404	4048171	1965-06-20	1965-06-21	1
60047	3560	40481087	1968-12-07	1968-12-21	1
59540	3532	372328	1972-09-29	1972-12-17	1
53541	3176	4134304	1992-04-29	1992-06-28	1
64926	3843	372328	1974-02-03	1974-11-24	1
15053	887	378001	2013-10-20	2013-11-19	1
77091	4571	28060	1958-02-09	1958-02-19	1
71030	4217	28060	1983-04-14	1983-04-23	1
8653	505	4027663	1993-05-29	1993-05-30	1
62959	3721	260139	1968-11-28	1968-12-12	1
15614	925	372328	1971-05-18	1971-11-05	1
61800	3652	4116491	2011-08-31	2011-10-20	1
39403	2337	4116491	1985-07-10	1985-09-02	1
71067	4220	4112343	2008-11-28	2008-12-07	1
76663	4548	4218389	2010-06-15	2010-07-06	1
12474	739	372328	1914-04-27	1914-06-17	1
75756	4498	260139	1979-12-12	1979-12-26	1
13820	817	4237458	2007-01-27	2007-04-27	1
9029	528	40481087	1969-04-18	1969-05-02	1
71448	4241	80180	2006-08-08	2006-08-09	1
73454	4372	40481087	1992-08-12	1992-08-19	1
5336	316	40481087	1935-08-06	1935-08-27	1
67007	3966	4112343	1975-09-08	1975-09-17	1
11417	675	260139	1975-12-16	1975-12-30	1
68615	4064	4134304	1969-11-18	1970-02-16	1
15102	890	80180	1997-09-06	1997-09-07	1
4198	244	4112343	1995-09-17	1995-09-24	1
76948	4563	4112343	1969-05-16	1969-05-26	1
74472	4428	372328	1952-05-13	1952-10-30	1
3427	196	4278672	1957-06-02	1957-08-01	1
8563	500	40481087	2017-04-17	2017-05-01	1
85679	5103	4112343	1968-02-01	1968-02-14	1
72904	4337	40481087	1965-01-10	1965-01-24	1
11315	669	260139	2002-10-16	2002-10-23	1
14372	851	81893	2014-07-18	2014-07-19	1
65690	3887	40481087	2012-05-04	2012-05-25	1
15868	940	80180	1982-07-09	1982-07-10	1
77975	4625	4142905	1975-03-29	1975-06-27	1
13388	789	260139	2005-12-03	2005-12-17	1
11634	687	4237458	1981-07-06	1981-10-04	1
61094	3618	4112343	1984-10-26	1984-11-07	1
8309	484	40481087	2005-09-27	2005-10-18	1
68807	4077	4112343	1984-11-03	1984-11-15	1
70024	4149	4112343	1988-02-13	1988-02-24	1
43020	2564	40481087	2015-04-19	2015-05-10	1
18867	1135	40481087	2011-01-27	2011-02-03	1
65579	3881	40481087	1981-04-24	1981-05-01	1
44169	2630	81151	2014-04-24	2014-05-29	1
72359	4299	4112343	2003-05-07	2003-05-19	1
18375	1107	4142905	2004-12-09	2005-03-09	1
60448	3578	80180	2016-11-09	2016-11-10	1
7093	418	40481087	1997-12-23	1998-01-06	1
18154	1092	4112343	1970-11-11	1970-11-23	1
72179	4288	80180	1994-09-17	1994-09-18	1
11750	695	4112343	1991-02-03	1991-02-15	1
63790	3773	439777	1960-05-01	1960-05-02	1
6877	404	40481087	1969-11-02	1969-11-16	1
60048	3560	40481087	1986-08-22	1986-09-12	1
59541	3532	4112343	1995-07-01	1995-07-11	1
53542	3176	4146173	1994-04-19	1994-06-18	1
64927	3843	4112343	2011-02-20	2011-02-27	1
15054	887	4112343	1996-09-06	1996-09-19	1
77092	4571	80180	1995-04-02	1995-04-03	1
71031	4217	30753	2000-03-25	2000-03-26	1
8654	505	4266809	2001-11-13	2001-11-14	1
62960	3721	40481087	1969-03-10	1969-03-31	1
15615	925	4278672	2005-06-18	2005-08-17	1
61801	3652	4294548	2010-07-11	2010-07-25	1
39404	2337	4155034	1999-12-23	2000-01-06	1
71068	4220	4310024	1974-09-18	1974-09-19	1
76664	4548	4280726	1986-10-24	2002-10-22	1
12475	739	4134304	1975-08-20	1975-09-19	1
75757	4498	260139	2005-04-29	2005-05-13	1
13821	817	40481087	1983-02-27	1983-03-20	1
10400	614	78272	1981-04-20	1981-05-18	1
71449	4241	81893	2005-08-13	2005-08-14	1
73455	4372	80180	2017-10-16	2017-10-17	1
5337	316	40481087	1952-12-01	1952-12-22	1
67008	3966	4112343	1978-08-20	1978-08-31	1
11418	675	4112343	1959-04-06	1959-04-17	1
68616	4064	4146173	1980-06-23	1980-07-23	1
15103	890	81151	1992-10-30	1992-11-20	1
4199	244	40481087	1980-01-11	1980-02-01	1
76949	4563	4112343	2010-05-12	2010-05-24	1
74473	4428	4112343	1966-12-24	1967-01-06	1
3428	196	40481087	2007-09-19	2007-09-26	1
8564	500	28060	1967-05-23	1967-06-03	1
85680	5103	4112343	1984-10-19	1984-11-01	1
72905	4337	4112343	1996-10-04	1996-10-17	1
11316	669	40481087	1972-02-27	1972-03-05	1
14373	851	372328	1982-05-27	1982-08-09	1
66294	3929	80180	1989-10-18	1989-10-19	1
15869	940	260139	1965-07-16	1965-07-23	1
77976	4625	4218389	1981-11-13	1981-12-04	1
13389	789	4112343	1998-09-19	1998-09-26	1
11635	687	40481087	2014-03-01	2014-03-15	1
61095	3618	4283893	1994-04-29	1994-06-24	1
8310	484	40481087	2011-03-29	2011-04-12	1
68808	4077	40481087	2008-11-20	2008-11-27	1
70025	4149	4112343	2011-06-15	2011-06-28	1
43021	2564	40481087	1991-03-24	1991-04-07	1
18868	1135	40481087	1979-05-12	1979-05-26	1
65580	3881	40481087	1981-12-03	1981-12-24	1
44170	2630	257012	1979-07-03	1979-07-04	1
72360	4299	40481087	1974-10-09	1974-10-16	1
18376	1107	4329847	2007-06-15	2007-06-16	1
60449	3578	372328	1973-11-25	1974-01-09	1
7094	418	40481087	2018-01-03	2018-01-10	1
18155	1092	4285898	1992-01-24	1992-01-25	1
72180	4288	260139	1998-12-01	1998-12-15	1
11751	695	4112343	2017-05-13	2017-05-20	1
63791	3773	40481087	1969-12-07	1969-12-21	1
6878	404	40481087	1977-02-14	1977-02-21	1
63357	3746	81151	1947-10-19	1947-11-09	1
59542	3532	4112343	2002-11-04	2002-11-11	1
53543	3176	40481087	1976-05-02	1976-05-09	1
66835	3957	260139	1971-03-04	1971-03-11	1
15055	887	260139	1965-06-05	1965-06-12	1
77093	4571	81151	1958-12-02	1958-12-23	1
71032	4217	4027663	1989-08-05	1989-08-06	1
8655	505	28060	1979-05-10	1979-05-20	1
62961	3721	40481087	1996-09-04	1996-09-11	1
15616	925	80180	2005-01-09	2005-01-10	1
61802	3652	40481087	1992-11-27	1992-12-11	1
39405	2337	4218389	2001-12-26	2002-01-16	1
71069	4220	40481087	1961-06-04	1961-06-25	1
76665	4548	81151	1984-10-12	1984-11-16	1
12476	739	4237458	1978-05-06	1978-07-05	1
75758	4498	4027663	2003-05-18	2003-05-19	1
15846	939	4112343	1980-09-19	1980-09-29	1
10401	614	80180	2000-06-08	2000-06-09	1
71450	4241	260139	1972-12-15	1972-12-22	1
73456	4372	195588	2013-06-03	2013-07-11	1
5338	316	40481087	1979-09-09	1979-09-30	1
67009	3966	4266809	2003-05-20	2003-05-21	1
11419	675	4112343	2013-12-19	2013-12-30	1
68617	4064	81151	1990-01-02	1990-01-16	1
15104	890	4142905	1982-06-25	1982-07-25	1
4200	244	40481087	1983-09-19	1983-10-10	1
76950	4563	78272	2005-01-04	2005-02-01	1
74474	4428	40481087	1966-11-01	1966-11-08	1
3429	196	40481087	2008-09-28	2008-10-12	1
8565	500	80180	1998-09-25	1998-09-26	1
85681	5103	4113008	1946-07-25	1946-08-15	1
72906	4337	4294548	1978-12-04	1979-02-26	1
11317	669	40481087	2007-09-29	2007-10-13	1
14374	851	4112343	1999-01-23	1999-01-30	1
66295	3929	81893	1988-08-24	1988-08-25	1
15870	940	372328	1944-09-16	1944-11-02	1
77977	4625	40481087	2006-11-23	2006-11-30	1
13390	789	4278672	1991-02-22	1991-05-23	1
11636	687	80180	2001-04-07	2001-04-08	1
61096	3618	40481087	1916-12-21	1916-12-28	1
8311	484	28060	2001-11-07	2001-11-17	1
68809	4077	81151	2012-02-26	2012-04-01	1
70026	4149	4112343	2012-09-21	2012-09-29	1
44881	2674	260139	1971-05-25	1971-06-01	1
19255	1155	260139	1990-01-04	1990-01-11	1
65581	3881	40481087	1998-11-04	1998-11-11	1
44171	2630	260139	1975-05-01	1975-05-15	1
72361	4299	40481087	2002-03-29	2002-04-05	1
18377	1107	40481087	1943-12-26	1944-01-09	1
60450	3578	4112343	1976-08-28	1976-09-07	1
7095	418	28060	1996-01-06	1996-01-17	1
18156	1092	40481087	2011-05-10	2011-05-17	1
72181	4288	4112343	2010-10-16	2010-10-27	1
11752	695	40481087	1980-04-29	1980-05-13	1
63792	3773	40481087	2019-01-27	2019-02-10	1
6879	404	40481087	1996-10-17	1996-10-24	1
63358	3746	260139	1945-01-04	1945-01-18	1
59543	3532	4112343	2017-02-12	2017-02-23	1
53544	3176	40481087	1978-10-03	1978-10-10	1
66836	3957	260139	1978-08-31	1978-09-07	1
15056	887	260139	2007-06-12	2007-06-19	1
77094	4571	372328	1956-11-29	1957-06-01	1
71033	4217	4310024	1998-12-31	1999-01-01	1
8656	505	372328	1983-10-20	1984-05-01	1
62962	3721	40481087	2017-05-19	2017-06-09	1
15617	925	258780	2009-05-15	2009-05-16	1
61803	3652	40481087	2007-03-02	2007-03-23	1
39406	2337	40481087	2012-09-29	2012-10-20	1
71070	4220	40481087	2012-07-15	2012-07-22	1
76666	4548	81151	2000-01-11	2000-02-08	1
12477	739	4278672	1935-06-21	1935-09-19	1
75759	4498	4084167	1978-02-18	1978-02-18	1
15847	939	4112343	1997-11-01	1997-11-10	1
10402	614	260139	1990-12-09	1990-12-16	1
71451	4241	260139	1996-02-07	1996-02-21	1
73457	4372	378001	2006-09-10	2006-10-10	1
5339	316	260139	1937-10-24	1937-11-07	1
67010	3966	4283893	2009-06-03	2009-07-01	1
11420	675	4116491	1986-02-07	1986-03-28	1
68618	4064	260139	1984-11-01	1984-11-08	1
15105	890	4218389	1975-03-06	1975-04-03	1
4201	244	40481087	1992-09-18	1992-10-02	1
76951	4563	260139	1970-04-12	1970-04-26	1
74475	4428	40481087	1969-07-31	1969-08-07	1
3430	196	40481087	2013-07-25	2013-08-08	1
8566	500	260139	1966-06-27	1966-07-04	1
85682	5103	4134304	1956-01-25	1956-03-25	1
72907	4337	40481087	1998-05-04	1998-05-11	1
11318	669	40481087	2014-06-12	2014-07-03	1
14375	851	4112343	2011-11-06	2011-11-15	1
66296	3929	258780	1987-04-06	1987-04-07	1
15871	940	4112343	1971-07-11	1971-07-21	1
77978	4625	81151	1977-04-17	1977-05-08	1
13391	789	81151	1992-03-18	1992-04-08	1
11637	687	81151	1993-04-04	1993-04-18	1
61097	3618	40481087	1946-12-19	1947-01-09	1
8312	484	260139	1958-03-21	1958-04-04	1
68810	4077	260139	1975-03-23	1975-04-06	1
70027	4149	40481087	1967-09-25	1967-10-16	1
44882	2674	260139	1983-03-01	1983-03-08	1
19256	1155	4112343	1980-08-05	1980-08-13	1
65582	3881	40481087	2013-02-03	2013-02-17	1
44172	2630	260139	1980-04-27	1980-05-04	1
72362	4299	40481087	2007-01-07	2007-01-14	1
18378	1107	40481087	1955-02-23	1955-03-16	1
60451	3578	4112343	1978-05-31	1978-06-09	1
7096	418	372328	1964-01-20	1964-09-14	1
18157	1092	28060	1959-08-21	1959-08-29	1
72182	4288	40481087	1966-11-16	1966-11-23	1
11753	695	40481087	2016-11-03	2016-11-10	1
63793	3773	260139	1961-11-14	1961-11-28	1
8240	482	30753	2007-03-08	2007-03-09	1
63359	3746	260139	1999-12-24	2000-01-07	1
59544	3532	4230399	1986-12-15	1987-03-15	1
53545	3176	40481087	1981-06-05	1981-06-19	1
66837	3957	260139	2006-08-22	2006-09-05	1
15057	887	372328	1960-04-30	1960-06-18	1
77095	4571	40481087	1959-07-05	1959-07-26	1
71034	4217	40481087	1963-09-22	1963-10-13	1
8657	505	439777	1995-05-29	1995-05-30	1
62963	3721	257012	2005-02-18	2005-02-19	1
15618	925	260139	1982-01-21	1982-02-04	1
61804	3652	28060	2002-05-11	2002-05-21	1
42073	2509	260139	1979-04-27	1979-05-11	1
71071	4220	40481087	2015-02-14	2015-03-07	1
76667	4548	260139	1987-01-02	1987-01-16	1
12478	739	4283893	1978-03-05	1978-04-02	1
75760	4498	40481087	1992-03-30	1992-04-20	1
15848	939	4112343	2004-02-08	2004-02-18	1
10403	614	372328	1964-06-05	1964-08-09	1
71452	4241	4112343	1979-08-27	1979-09-06	1
73458	4372	40481087	1983-12-25	1984-01-08	1
5340	316	260139	2007-11-23	2007-12-07	1
67011	3966	4294548	2016-09-30	2016-12-16	1
11421	675	4266809	1984-04-03	1984-04-04	1
68619	4064	260139	1991-01-04	1991-01-13	1
15106	890	192671	1997-11-11	1997-11-12	1
4202	244	28060	1972-11-04	1972-11-12	1
76952	4563	260139	1976-06-27	1976-07-11	1
74476	4428	40481087	2011-10-17	2011-10-31	1
3431	196	260139	1959-10-22	1959-10-29	1
8567	500	372328	1963-04-25	1963-08-27	1
85683	5103	40481087	1963-02-10	1963-03-03	1
72908	4337	260139	1962-04-07	1962-04-14	1
12614	747	40481087	1992-08-29	1992-09-05	1
14376	851	4237458	1982-06-26	1982-07-26	1
66297	3929	378001	1970-09-12	1970-11-11	1
15872	940	4294548	1951-05-17	1951-10-25	1
77979	4625	260139	1985-08-24	1985-08-31	1
13392	789	260139	1994-12-28	1995-01-04	1
11638	687	260139	1974-12-12	1974-12-26	1
61098	3618	40481087	1966-08-01	1966-08-22	1
8313	484	4112343	1944-01-21	1944-02-01	1
68811	4077	260139	2006-01-12	2006-01-26	1
70028	4149	257012	1991-10-04	1991-10-05	1
44883	2674	260139	1989-02-03	1989-02-10	1
19257	1155	4112343	2016-01-03	2016-01-16	1
65583	3881	28060	2011-07-11	2011-07-20	1
44173	2630	260139	2007-09-18	2007-09-25	1
72363	4299	40481087	2012-12-18	2013-01-01	1
18379	1107	40481087	1992-05-23	1992-06-06	1
60452	3578	4278672	1992-03-18	1992-05-17	1
7097	418	375671	1991-03-23	1991-05-22	1
18158	1092	30753	1991-04-29	1991-04-30	1
72183	4288	4112343	1966-10-11	1966-10-22	1
11754	695	80180	2006-03-01	2006-03-02	1
63794	3773	372328	1961-05-16	1961-10-06	1
8241	482	81151	1983-06-03	1983-06-24	1
63360	3746	375671	1945-08-30	1945-10-29	1
59545	3532	4278672	1977-07-05	1977-10-03	1
53546	3176	40481087	1981-09-22	1981-10-13	1
66838	3957	378001	1983-05-28	1983-07-27	1
15058	887	378001	1983-03-06	1983-05-05	1
77096	4571	40481087	1978-05-25	1978-06-15	1
71035	4217	40481087	2007-03-16	2007-03-30	1
8658	505	4112343	1982-04-07	1982-04-20	1
62964	3721	372328	1964-03-14	1964-04-24	1
15619	925	372328	1973-07-27	1973-11-09	1
61805	3652	4112343	1987-04-16	1987-04-26	1
42074	2509	260139	2004-04-06	2004-04-20	1
71072	4220	260139	2012-07-26	2012-08-09	1
76668	4548	260139	1989-06-27	1989-07-04	1
12479	739	40481087	1967-11-29	1967-12-06	1
75761	4498	40481087	2009-02-26	2009-03-12	1
15849	939	4113008	1981-03-29	1981-04-19	1
10404	614	4112343	1967-06-16	1967-06-24	1
71453	4241	4283893	1998-07-16	1998-10-01	1
73459	4372	40481087	1996-11-04	1996-11-11	1
5341	316	260139	2016-03-26	2016-04-02	1
67012	3966	40481087	1996-07-05	1996-07-19	1
11422	675	372328	1949-10-09	1950-01-24	1
68620	4064	4112343	1961-03-07	1961-03-15	1
15107	890	260139	2012-09-04	2012-09-18	1
4203	244	260139	1993-07-02	1993-07-09	1
76953	4563	260139	1984-04-10	1984-04-17	1
74477	4428	28060	1954-05-05	1954-05-15	1
3432	196	260139	1967-07-29	1967-08-05	1
8568	500	4112343	1991-03-30	1991-04-08	1
85684	5103	40481087	1997-02-07	1997-02-14	1
72909	4337	260139	1964-12-31	1965-01-14	1
12615	747	40481087	2012-02-19	2012-03-11	1
14377	851	4294548	2015-12-24	2016-01-07	1
66298	3929	4112343	1977-07-23	1977-08-01	1
15873	940	4329847	2001-11-29	2001-11-30	1
77980	4625	4109685	1964-01-28	1964-02-11	1
13393	789	4112343	2001-03-16	2001-03-23	1
11639	687	260139	1981-03-18	1981-03-25	1
61099	3618	40481087	1993-07-06	1993-07-27	1
8314	484	40481087	1945-08-01	1945-08-22	1
68812	4077	4059173	1979-08-18	1979-10-17	1
70029	4149	260139	1999-06-03	1999-06-10	1
44884	2674	260139	2007-03-23	2007-03-30	1
19258	1155	40481087	1974-07-16	1974-08-06	1
65584	3881	78272	1981-12-05	1981-12-26	1
44174	2630	4112343	2007-02-18	2007-03-03	1
72364	4299	260139	1982-01-12	1982-01-19	1
18380	1107	28060	1979-04-07	1979-04-15	1
60453	3578	40481087	1976-11-18	1976-12-09	1
7098	418	4059173	1961-05-17	1961-08-15	1
18159	1092	260139	1958-04-29	1958-05-13	1
72184	4288	40481087	1974-03-25	1974-04-01	1
11755	695	260139	1974-10-21	1974-11-04	1
63795	3773	372328	1981-08-22	1982-07-02	1
8242	482	4112343	1974-06-01	1974-06-11	1
63361	3746	375671	1978-04-05	1978-05-05	1
59546	3532	40481087	1971-07-13	1971-08-03	1
53547	3176	40481087	2018-10-07	2018-10-14	1
66839	3957	4112343	2013-06-19	2013-07-02	1
15059	887	4156265	1974-10-05	1974-10-19	1
77097	4571	40481087	1979-12-15	1979-12-29	1
76126	4522	28060	2017-02-12	2017-02-25	1
8659	505	4285898	2001-06-16	2001-06-17	1
62965	3721	4112343	1985-04-15	1985-04-25	1
15620	925	40481087	2002-11-09	2002-11-30	1
61806	3652	4112343	2018-01-28	2018-02-08	1
42075	2509	4112343	1970-05-08	1970-05-19	1
71073	4220	4112343	1968-02-23	1968-03-03	1
76669	4548	372328	1995-05-18	1996-05-07	1
12480	739	40481087	1969-08-04	1969-08-11	1
75762	4498	4296204	1989-01-21	1989-02-25	1
15850	939	40481087	2006-10-29	2006-11-19	1
10405	614	4112343	1984-10-03	1984-10-16	1
71454	4241	78272	1967-10-03	1967-10-17	1
73460	4372	4116491	2009-05-01	2009-06-04	1
5342	316	317576	1976-07-06	1976-07-07	1
67361	3986	0	2009-08-13	2009-08-14	1
11423	675	4112343	1996-09-10	1996-09-18	1
68621	4064	4112343	1999-10-06	1999-10-16	1
15108	890	4112343	1979-02-11	1979-02-19	1
4204	244	4027663	1955-02-19	1955-02-20	1
76954	4563	4112343	1985-12-02	1985-12-13	1
74478	4428	378001	2003-12-25	2004-02-23	1
3433	196	372328	1956-04-08	1956-09-22	1
8569	500	4155034	1962-09-14	1962-10-05	1
85685	5103	4109685	1962-02-20	1962-03-13	1
72910	4337	260139	1977-02-07	1977-02-21	1
12616	747	28060	2005-07-07	2005-07-19	1
14378	851	28060	1990-10-30	1990-11-07	1
66299	3929	4112343	1993-11-07	1993-11-14	1
15874	940	40481087	1968-04-20	1968-04-27	1
77981	4625	4112343	2017-05-31	2017-06-13	1
13394	789	4112343	2014-02-16	2014-02-26	1
11640	687	260139	1983-12-21	1984-01-04	1
61100	3618	255848	1994-07-29	1994-07-30	1
9491	564	4056621	1991-12-22	1991-12-23	1
68813	4077	4112343	2010-06-28	2010-07-05	1
70030	4149	4156265	2007-06-04	2007-06-25	1
44885	2674	375671	2008-12-16	2009-01-15	1
19259	1155	40481087	1980-06-08	1980-06-22	1
65585	3881	372328	1960-06-30	1960-08-05	1
44175	2630	4134304	2013-03-30	2013-04-29	1
72365	4299	260139	2015-02-02	2015-02-16	1
18381	1107	28060	2002-05-30	2002-06-06	1
60454	3578	40481087	1987-01-04	1987-01-18	1
7099	418	4142905	2004-06-26	2004-08-25	1
18160	1092	4112343	1966-08-24	1966-09-04	1
72185	4288	28060	1960-08-22	1960-08-31	1
11756	695	260139	1996-10-15	1996-10-29	1
63796	3773	4112343	1968-02-11	1968-02-23	1
8243	482	4285898	2007-12-03	2007-12-04	1
63362	3746	4027663	1974-12-01	1974-12-02	1
59547	3532	40481087	2002-10-09	2002-10-16	1
53548	3176	260139	2000-08-17	2000-08-31	1
66840	3957	4237458	1964-05-07	1964-08-05	1
15060	887	4294548	2008-12-31	2009-02-11	1
80080	4753	28060	1982-12-31	1983-01-12	1
76127	4522	372328	1981-03-13	1981-12-25	1
8660	505	4296204	1987-11-06	1987-12-04	1
62966	3721	4112343	1990-08-31	1990-09-08	1
15621	925	28060	1999-09-22	1999-10-04	1
63458	3752	78272	2002-10-01	2002-10-29	1
42076	2509	4112343	1998-05-02	1998-05-10	1
71074	4220	4112343	1972-11-10	1972-11-23	1
76670	4548	4112343	1998-01-03	1998-01-11	1
12481	739	80180	1947-12-15	1947-12-16	1
75763	4498	40481087	2016-01-13	2016-02-03	1
15851	939	40481087	2007-07-26	2007-08-16	1
10406	614	372328	1963-10-31	1963-12-08	1
71455	4241	260139	1977-01-01	1977-01-15	1
73461	4372	40481087	1987-11-22	1987-11-29	1
5343	316	4112343	1936-07-19	1936-07-30	1
67362	3986	28060	1967-02-27	1967-03-08	1
11424	675	4155034	1959-10-15	1959-10-29	1
68622	4064	40481087	1985-12-27	1986-01-03	1
15109	890	40481087	1974-01-05	1974-01-19	1
4205	244	4294548	1996-10-18	1996-12-06	1
76955	4563	4112343	1997-09-15	1997-09-25	1
74479	4428	4112343	1994-12-12	1994-12-25	1
3434	196	372328	1957-10-17	1958-03-22	1
8570	500	40481087	2005-12-17	2006-01-07	1
85686	5103	40481087	1980-11-05	1980-11-26	1
72911	4337	381316	1991-02-22	1991-02-23	1
12617	747	260139	1994-06-11	1994-06-18	1
14379	851	40481087	2009-05-13	2009-05-20	1
66300	3929	4155034	1992-04-01	1992-04-15	1
15875	940	40481087	2000-05-18	2000-06-01	1
77982	4625	40481087	1982-03-31	1982-04-21	1
13395	789	40481087	1976-04-14	1976-04-21	1
11641	687	372328	1968-06-28	1968-12-28	1
61101	3618	260139	1960-07-13	1960-07-27	1
9492	564	40481087	1984-12-04	1984-12-25	1
68814	4077	40481087	1995-04-07	1995-04-28	1
72532	4313	28060	1954-10-12	1954-10-19	1
44886	2674	4112343	2000-02-20	2000-03-02	1
19260	1155	40481087	1994-06-13	1994-06-27	1
65586	3881	4112343	1974-10-31	1974-11-10	1
44176	2630	4278672	1978-01-14	1978-02-13	1
72366	4299	372328	1985-09-06	1986-05-18	1
18382	1107	80180	1964-09-30	1964-10-01	1
60455	3578	260139	1998-01-20	1998-02-03	1
7100	418	4278672	1967-09-13	1967-12-12	1
18161	1092	4112343	1969-02-09	1969-02-16	1
72186	4288	260139	1974-06-28	1974-07-05	1
11757	695	4112343	1999-11-03	1999-11-13	1
63797	3773	4112343	1979-12-23	1980-01-03	1
8244	482	40481087	2000-06-20	2000-07-04	1
63363	3746	4112343	1969-06-11	1969-06-21	1
59548	3532	40481087	2009-01-19	2009-01-26	1
53549	3176	372328	1973-09-24	1973-11-10	1
66841	3957	40481087	1966-11-15	1966-12-06	1
15061	887	40481087	1965-04-11	1965-04-18	1
80081	4753	80180	2003-12-09	2003-12-10	1
76128	4522	4112343	1986-06-03	1986-06-12	1
8661	505	40481087	1989-01-21	1989-02-11	1
62967	3721	4116491	1994-11-07	1994-12-21	1
15622	925	81151	2008-07-02	2008-07-23	1
63459	3752	192671	1997-12-31	1998-01-01	1
42077	2509	4116491	2006-05-30	2006-07-15	1
71075	4220	40481087	1949-12-18	1950-01-08	1
76671	4548	4278672	2016-08-03	2016-09-02	1
12482	739	81151	1987-10-16	1987-11-20	1
75764	4498	30753	2012-06-04	2012-06-05	1
15852	939	80180	2005-03-26	2005-03-27	1
10407	614	4218389	1971-08-20	1971-09-10	1
71456	4241	378001	1972-08-21	1972-10-20	1
73462	4372	78272	1997-06-08	1997-06-29	1
5344	316	4142905	2007-10-25	2007-11-24	1
67363	3986	4109685	1990-04-09	1990-04-23	1
11425	675	4310024	1983-03-10	1983-03-11	1
68623	4064	40481087	2017-09-30	2017-10-14	1
15469	918	0	2016-05-20	2016-05-21	1
4206	244	40481087	1964-07-22	1964-07-29	1
76956	4563	40481087	1986-05-02	1986-05-09	1
74480	4428	80180	1991-05-04	1991-05-05	1
3435	196	4112343	2009-01-30	2009-02-07	1
8571	500	81151	1968-06-19	1968-07-03	1
85687	5103	40481087	2006-10-31	2006-11-14	1
72912	4337	40481087	1962-01-10	1962-01-17	1
12618	747	40481087	1976-02-21	1976-03-13	1
14380	851	80180	2016-03-09	2016-03-10	1
66301	3929	4283893	2001-09-03	2002-02-11	1
15876	940	0	2001-11-29	2001-11-30	1
77983	4625	40481087	1985-11-07	1985-11-28	1
13396	789	40481087	1985-02-08	1985-03-01	1
11642	687	4112343	1968-03-18	1968-03-26	1
61102	3618	375671	1956-06-06	1956-08-05	1
9493	564	40481087	2012-12-26	2013-01-02	1
68815	4077	40481087	1995-07-04	1995-07-11	1
72533	4313	260139	1991-08-28	1991-09-04	1
44887	2674	4155034	1996-08-09	1996-08-23	1
19261	1155	40481087	2010-08-26	2010-09-16	1
65587	3881	4112343	1994-01-15	1994-01-22	1
44177	2630	4294548	1979-06-12	1979-09-04	1
72367	4299	4112343	1995-02-09	1995-02-17	1
18383	1107	81151	1980-08-19	1980-09-02	1
60456	3578	260139	2008-05-03	2008-05-17	1
7101	418	4294548	1973-04-22	1973-04-29	1
18162	1092	4112343	2010-03-17	2010-03-28	1
72187	4288	372328	1953-06-29	1953-07-13	1
11758	695	40481087	2007-12-09	2007-12-23	1
63798	3773	40481087	1988-04-06	1988-04-13	1
8245	482	80180	2008-09-28	2008-09-29	1
63364	3746	4218389	1970-01-12	1970-02-16	1
59549	3532	28060	1978-12-14	1978-12-24	1
53550	3176	372328	1976-05-28	1976-11-13	1
66842	3957	260139	1978-10-09	1978-10-23	1
15062	887	40481087	1967-01-13	1967-02-03	1
80082	4753	81151	2013-09-16	2013-09-30	1
76129	4522	4112343	1988-08-04	1988-08-11	1
10247	607	81151	2016-12-28	2017-01-25	1
62968	3721	40481087	2001-10-03	2001-10-17	1
15623	925	378001	1971-11-14	1971-12-14	1
63460	3752	195588	1996-02-18	1996-03-26	1
42078	2509	40481087	1973-06-24	1973-07-15	1
71076	4220	40481087	1950-09-11	1950-09-25	1
76672	4548	40481087	1987-01-08	1987-01-15	1
12483	739	260139	1923-06-26	1923-07-03	1
75765	4498	260139	1996-03-01	1996-03-15	1
15853	939	260139	1989-11-02	1989-11-09	1
10408	614	40481087	1971-05-01	1971-05-15	1
71457	4241	4027663	1996-10-19	1996-10-20	1
73463	4372	260139	1982-01-30	1982-02-06	1
5345	316	4142905	2012-02-01	2012-05-01	1
67364	3986	40481087	1968-01-26	1968-02-16	1
11426	675	40481087	1959-04-09	1959-04-30	1
68624	4064	40486433	1963-05-16	1993-07-12	1
15470	918	28060	1935-06-25	1935-07-02	1
4983	295	260139	1973-12-07	1973-12-21	1
76957	4563	40481087	1989-12-27	1990-01-03	1
74481	4428	81151	1972-10-25	1972-11-07	1
3436	196	4146173	1958-08-26	1958-09-25	1
8572	500	81151	1971-04-19	1971-05-10	1
85688	5103	40481087	2012-06-21	2012-06-28	1
72913	4337	40481087	1976-11-29	1976-12-06	1
12619	747	40481087	1996-07-07	1996-07-21	1
14381	851	372328	1983-06-05	1983-11-07	1
66302	3929	4310024	1988-05-26	1988-05-27	1
15877	940	81151	1950-04-18	1950-05-02	1
77984	4625	40481087	2003-03-05	2003-03-19	1
13397	789	40481087	1993-01-23	1993-02-13	1
11643	687	4112343	1975-11-18	1975-11-27	1
61103	3618	4059173	1982-06-20	1982-09-18	1
9494	564	81151	2006-08-19	2006-09-09	1
68816	4077	40481087	2006-11-18	2006-11-25	1
72534	4313	4112343	1966-01-01	1966-01-11	1
44888	2674	4283893	2003-06-28	2003-07-26	1
19262	1155	40481087	2017-01-04	2017-01-18	1
65588	3881	4134304	1960-11-27	1961-01-26	1
44178	2630	40481087	1973-09-15	1973-10-06	1
72368	4299	4156265	2011-11-20	2011-12-11	1
18384	1107	260139	2001-10-29	2001-11-12	1
60457	3578	4109685	2009-02-17	2009-03-03	1
7102	418	40481087	1975-01-28	1975-02-11	1
18163	1092	4278672	2000-11-29	2001-02-27	1
72188	4288	4112343	2006-12-09	2006-12-19	1
11759	695	28060	1976-06-12	1976-06-20	1
63799	3773	40481087	2018-06-02	2018-06-23	1
8246	482	4027663	1997-10-16	1997-10-17	1
63365	3746	40481087	1968-03-24	1968-03-31	1
59550	3532	30753	2006-08-27	2006-08-28	1
53551	3176	378001	1990-04-10	1990-06-09	1
66843	3957	260139	1994-01-22	1994-01-29	1
15555	923	28060	1970-11-02	1970-11-13	1
80083	4753	260139	1965-06-17	1965-07-01	1
76130	4522	40481087	2002-02-23	2002-03-16	1
10248	607	260139	2018-01-26	2018-02-09	1
62969	3721	28060	2015-02-13	2015-02-23	1
15624	925	4142905	1999-04-21	1999-07-20	1
63461	3752	372328	1960-04-17	1960-05-19	1
42079	2509	80180	2006-05-20	2006-05-21	1
71077	4220	40481087	1964-06-18	1964-07-02	1
76673	4548	40481087	2015-12-08	2015-12-15	1
12484	739	260139	1937-06-17	1937-07-01	1
75766	4498	440086	1986-05-22	1995-05-30	1
15854	939	260139	1997-11-26	1997-12-10	1
10409	614	40481087	2016-09-16	2016-10-07	1
71458	4241	4152936	1976-05-02	1976-05-16	1
73464	4372	260139	1987-07-11	1987-07-25	1
5346	316	4283893	1934-03-22	1934-04-26	1
67365	3986	40481087	1990-08-01	1990-08-22	1
11427	675	40481087	1991-01-18	1991-01-25	1
69727	4130	81151	1998-11-19	1998-12-24	1
15471	918	80180	1954-12-21	1954-12-22	1
4984	295	260139	1990-04-02	1990-04-09	1
76958	4563	40481087	2019-04-28	2019-05-19	1
74482	4428	4112343	2011-04-05	2011-04-13	1
3437	196	257012	1958-02-07	1958-02-08	1
8573	500	372328	1962-03-18	1962-05-29	1
85689	5103	81893	1983-03-25	1983-03-26	1
72914	4337	40481087	2000-11-01	2000-11-08	1
12620	747	80180	1996-01-31	1996-02-01	1
14382	851	4109685	1992-10-01	1992-10-22	1
66303	3929	40481087	1990-12-30	1991-01-20	1
15878	940	257012	1951-06-28	1951-06-29	1
77985	4625	28060	2015-12-28	2016-01-04	1
13398	789	40481087	2007-03-09	2007-03-23	1
11644	687	4294548	2017-09-24	2017-12-24	1
61104	3618	4112343	1971-05-28	1971-06-08	1
9495	564	258780	1990-08-16	1990-08-17	1
68817	4077	40481087	2010-03-29	2010-04-05	1
72535	4313	40481087	1963-06-19	1963-07-10	1
44889	2674	40481087	1998-04-10	1998-04-17	1
19263	1155	260139	1981-03-09	1981-03-23	1
65589	3881	40481087	1978-02-19	1978-03-05	1
44179	2630	40481087	1993-01-15	1993-02-05	1
73546	4376	80180	1961-01-07	1961-01-08	1
18385	1107	317576	1964-01-24	1964-01-25	1
60458	3578	40481087	1985-09-12	1985-10-03	1
7103	418	40481087	1992-05-23	1992-06-13	1
18164	1092	40479768	1962-08-04	1962-09-10	1
72189	4288	4146173	1963-10-05	1963-12-04	1
11760	695	260139	2011-10-31	2011-11-07	1
63800	3773	81151	1990-12-31	1991-01-14	1
8247	482	4112343	1979-08-02	1979-08-09	1
63366	3746	40481087	1980-10-28	1980-11-11	1
59551	3532	378001	2003-10-08	2003-11-07	1
53552	3176	4112343	2012-03-03	2012-03-16	1
66844	3957	4112343	1964-03-10	1964-03-18	1
15556	923	260139	1968-07-23	1968-08-06	1
80084	4753	372328	1962-03-04	1962-05-16	1
76131	4522	80180	2017-08-16	2017-08-17	1
10249	607	372328	1960-03-27	1960-12-23	1
62970	3721	260139	1981-05-19	1981-06-02	1
15625	925	4237458	2018-02-01	2018-03-03	1
63462	3752	4056621	1996-02-18	1996-02-19	1
42080	2509	372328	1974-07-12	1975-01-12	1
71078	4220	40481087	1966-08-29	1966-09-19	1
76674	4548	40481087	2019-06-05	2019-06-06	1
12485	739	378001	1918-09-18	1918-11-17	1
75767	4498	4112343	1982-11-04	1982-11-12	1
15855	939	260139	2014-09-13	2014-09-20	1
10410	614	78272	1992-05-11	1992-06-08	1
71459	4241	4285898	2006-05-10	2006-05-11	1
73465	4372	372328	1985-12-08	1986-02-13	1
5347	316	40481087	1928-02-07	1928-02-14	1
67366	3986	260139	2005-10-17	2005-10-31	1
11428	675	40481087	1991-09-28	1991-10-12	1
69728	4130	4048171	1966-11-26	1966-11-27	1
15472	918	260139	1941-10-11	1941-10-25	1
4985	295	4112343	1992-05-22	1992-06-04	1
76959	4563	80180	2003-07-21	2003-07-22	1
74483	4428	40481087	1992-02-12	1992-03-04	1
3438	196	4116491	1988-10-07	1988-11-07	1
8574	500	4027663	1986-09-13	1986-09-14	1
85690	5103	260139	1992-07-21	1992-08-04	1
74603	4436	0	2003-06-13	2003-06-14	1
12621	747	81151	1985-12-24	1986-01-14	1
14383	851	4112343	1995-04-30	1995-05-11	1
66304	3929	28060	1961-04-05	1961-04-17	1
15879	940	260139	1956-10-06	1956-10-20	1
77986	4625	78272	2000-01-20	2000-02-17	1
13399	789	28060	1985-03-21	1985-03-30	1
11645	687	40481087	1982-10-08	1982-10-29	1
61105	3618	4155034	1936-01-02	1936-01-23	1
9496	564	372328	1956-07-16	1956-09-27	1
69941	4143	28060	1997-04-05	1997-04-13	1
72536	4313	80180	1980-01-27	1980-01-28	1
44890	2674	28060	1973-02-14	1973-02-25	1
19264	1155	260139	1990-05-13	1990-05-20	1
65590	3881	40481087	2018-08-28	2018-09-18	1
44180	2630	30753	1998-01-04	1998-01-05	1
73547	4376	80502	2010-09-19	2010-09-20	1
18386	1107	4112343	1929-04-09	1929-04-19	1
60459	3578	78272	1980-04-22	1980-05-20	1
7104	418	40481087	2002-10-22	2002-11-12	1
18165	1092	40481087	1995-05-27	1995-06-10	1
72190	4288	40481087	1952-12-10	1952-12-24	1
11761	695	4113008	1969-11-15	1969-12-06	1
63801	3773	260139	1982-06-21	1982-06-28	1
8248	482	4112343	2009-04-18	2009-04-29	1
63367	3746	40481087	2005-10-17	2005-11-07	1
59552	3532	4285898	2007-01-24	2007-01-25	1
53553	3176	80180	2007-10-11	2007-10-12	1
66845	3957	4112343	1988-08-13	1988-08-25	1
15557	923	260139	1976-10-30	1976-11-06	1
80085	4753	4059173	2006-02-25	2006-05-26	1
76132	4522	378001	1978-08-26	1978-10-25	1
10250	607	4112343	1971-05-27	1971-06-03	1
62971	3721	378001	1993-05-25	1993-07-24	1
15626	925	4283893	2014-06-28	2015-02-14	1
63463	3752	4059173	1959-08-04	1959-09-03	1
42081	2509	28060	2006-05-02	2006-05-13	1
71079	4220	40481087	2010-12-01	2010-12-15	1
76675	4548	260139	1988-10-15	1988-10-29	1
12486	739	378419	1987-12-16	1987-12-17	1
75768	4498	4112343	2015-03-25	2015-04-06	1
15856	939	40481087	1989-12-16	1989-12-23	1
10411	614	4112343	1984-05-26	1984-06-04	1
74332	4418	78272	1956-05-22	1956-06-12	1
73466	4372	4035415	1993-10-27	1993-11-26	1
5348	316	40481087	1934-10-28	1934-11-04	1
67367	3986	4029498	2009-08-13	2009-08-14	1
11429	675	40481087	2003-06-02	2003-06-09	1
69729	4130	40481087	2005-05-08	2005-05-29	1
15473	918	372328	1949-01-10	1950-10-27	1
4986	295	40481087	1985-03-11	1985-03-18	1
76960	4563	260139	2001-11-03	2001-11-10	1
74484	4428	40481087	2014-03-26	2014-04-16	1
3439	196	4283893	1958-01-03	1958-03-28	1
8575	500	4112343	1977-01-13	1977-01-26	1
85691	5103	4027663	1974-10-03	1974-10-04	1
74604	4436	30753	2006-10-10	2006-10-11	1
12622	747	378001	1978-02-04	1978-03-06	1
14384	851	40481087	1985-02-16	1985-03-09	1
66305	3929	260139	1999-12-14	1999-12-21	1
15880	940	317576	1990-12-20	1990-12-21	1
77987	4625	80180	2001-10-25	2001-10-26	1
13400	789	81151	1990-02-22	1990-03-29	1
11646	687	40481087	2015-02-16	2015-03-02	1
61106	3618	40481087	1922-07-05	1922-07-26	1
9497	564	4112343	1970-07-01	1970-07-11	1
69942	4143	372328	1968-11-08	1969-09-26	1
72537	4313	4001336	1963-01-08	1963-02-07	1
44891	2674	4112343	1989-02-04	1989-02-15	1
19265	1155	260139	2007-10-19	2007-11-02	1
65591	3881	40481087	2019-05-25	2019-06-15	1
44181	2630	440086	1968-12-17	1971-02-16	1
73548	4376	260139	1929-02-15	1929-03-01	1
18387	1107	4112343	2001-03-21	2001-04-01	1
60460	3578	192671	2017-01-08	2017-01-09	1
7105	418	40481087	2010-05-11	2010-05-25	1
18166	1092	78272	2017-05-04	2017-05-18	1
72191	4288	40481087	2004-04-28	2004-05-05	1
11762	695	40481087	1989-06-03	1989-06-10	1
63802	3773	260139	2003-06-09	2003-06-16	1
8249	482	4113008	1980-09-25	1980-10-16	1
63368	3746	257012	1985-03-19	1985-03-20	1
60952	3612	28060	1996-01-11	1996-01-20	1
53554	3176	4296204	2006-10-13	2006-11-03	1
66846	3957	4112343	2016-09-18	2016-09-30	1
15558	923	378001	1995-02-22	1995-03-24	1
80086	4753	40481087	1963-07-06	1963-07-27	1
76133	4522	4112343	1988-09-12	1988-09-23	1
10251	607	40481087	2014-06-01	2014-06-15	1
62972	3721	4112343	2000-12-17	2000-12-24	1
18029	1085	28060	1971-06-03	1971-06-10	1
63464	3752	4142905	1997-12-26	1998-03-26	1
42082	2509	4112343	2010-11-20	2010-11-29	1
71080	4220	80180	1977-04-05	1977-04-06	1
76676	4548	260139	2016-04-17	2016-04-24	1
12487	739	4146173	1930-08-16	1930-10-15	1
75769	4498	4310024	2011-03-12	2011-03-13	1
15857	939	0	2003-07-07	2003-07-08	1
10412	614	4134304	1968-05-07	1968-06-06	1
74333	4418	81151	1952-07-21	1952-08-11	1
73467	4372	4084167	1981-01-03	1981-01-03	1
5349	316	40481087	1958-12-27	1959-01-03	1
67368	3986	4109685	2014-08-18	2014-09-08	1
11430	675	260139	2001-01-17	2001-01-24	1
69730	4130	313217	2014-05-08	2014-05-09	1
15474	918	372328	1978-08-01	1978-11-03	1
4987	295	40481087	2013-02-16	2013-03-09	1
76961	4563	4112343	2005-02-17	2005-02-25	1
74485	4428	28060	1961-11-05	1961-11-17	1
3440	196	4285898	1999-10-25	1999-10-26	1
8576	500	4112343	2009-07-03	2009-07-14	1
85692	5103	4112343	1946-08-29	1946-09-06	1
74605	4436	81893	2006-01-13	2006-01-14	1
12623	747	4109685	2003-07-14	2003-08-04	1
14385	851	40481087	1985-06-12	1985-07-03	1
66306	3929	4112343	1957-02-10	1957-02-22	1
15881	940	372328	1982-07-16	1982-12-02	1
77988	4625	4152936	1974-05-19	1974-06-02	1
13401	789	372328	1972-07-26	1972-10-02	1
11647	687	40481087	2018-03-02	2018-03-23	1
61107	3618	40481087	1958-05-17	1958-06-07	1
9498	564	40481087	1971-12-31	1972-01-07	1
69943	4143	378001	1964-09-13	1964-11-12	1
72538	4313	4285898	1979-05-02	1979-05-03	1
44892	2674	80180	2013-07-01	2013-07-02	1
19266	1155	260139	2010-10-29	2010-11-05	1
66404	3935	30753	1982-02-18	1982-02-19	1
44182	2630	4027663	1990-12-12	1990-12-13	1
73549	4376	375671	1971-02-09	1971-03-11	1
18388	1107	4283893	1971-03-21	1971-04-18	1
60461	3578	372328	1991-01-10	1991-10-02	1
7106	418	40481087	2011-11-21	2011-11-28	1
18167	1092	260139	2009-09-05	2009-09-12	1
72192	4288	40481087	2014-12-16	2014-12-30	1
11763	695	4218389	1984-12-17	1985-01-14	1
63803	3773	4112343	1980-06-04	1980-06-16	1
8250	482	4152936	2013-12-18	2014-01-01	1
63369	3746	372328	1957-06-28	1958-04-17	1
60953	3612	80180	2004-09-24	2004-09-25	1
53555	3176	40481087	1972-10-08	1972-10-22	1
66847	3957	4116491	2002-09-10	2002-10-25	1
15559	923	4112343	2017-09-10	2017-09-19	1
80087	4753	40481087	1985-02-21	1985-03-14	1
76134	4522	192671	2017-11-08	2017-11-09	1
10252	607	40481087	2016-03-11	2016-03-18	1
62973	3721	40481087	1972-07-21	1972-07-28	1
18030	1085	4112343	1976-05-16	1976-05-28	1
63465	3752	4285898	1997-06-20	1997-06-21	1
42083	2509	40481087	2006-03-01	2006-03-15	1
71081	4220	260139	1962-01-16	1962-01-23	1
76677	4548	40481087	1988-03-17	1988-03-31	1
12488	739	4112343	1949-10-08	1949-10-21	1
75770	4498	40481087	1981-08-09	1981-08-16	1
15858	939	260139	2001-06-05	2001-06-19	1
10413	614	4155034	1986-12-18	1987-01-08	1
74334	4418	260139	1979-10-22	1979-10-29	1
73468	4372	4112343	2001-02-04	2001-02-12	1
5350	316	40481087	1980-11-28	1980-12-12	1
67369	3986	40481087	1966-02-05	1966-02-26	1
11431	675	439777	1981-02-08	1981-02-09	1
69731	4130	372328	1966-05-25	1966-10-27	1
15475	918	4109685	1966-02-22	1966-03-08	1
4988	295	28060	1975-08-06	1975-08-18	1
76962	4563	40481087	1970-11-15	1970-11-22	1
74486	4428	195588	2005-11-10	2005-12-16	1
3441	196	40481087	1966-10-19	1966-11-09	1
8577	500	4285898	1998-08-26	1998-08-27	1
85693	5103	4278672	1993-06-28	1993-08-27	1
74606	4436	4027663	1999-05-20	1999-05-21	1
12624	747	4112343	1968-11-05	1968-11-15	1
14386	851	40481087	1999-05-06	1999-05-27	1
66307	3929	4112343	1996-11-01	1996-11-11	1
15882	940	40481087	1946-12-10	1946-12-31	1
77989	4625	260139	1976-10-23	1976-10-30	1
13402	789	4112343	2006-04-14	2006-04-25	1
11648	687	0	1992-01-17	1992-01-18	1
61108	3618	40481087	1991-02-20	1991-03-13	1
9499	564	40481087	1975-04-28	1975-05-19	1
69944	4143	4285898	2000-05-07	2000-05-08	1
72539	4313	40481087	1995-05-12	1995-06-02	1
44893	2674	192671	2013-09-06	2013-09-07	1
19267	1155	372328	1967-10-14	1968-01-29	1
66405	3935	80180	1982-10-16	1982-10-17	1
44183	2630	4112343	2017-04-10	2017-04-21	1
73550	4376	381316	1985-03-19	1985-03-20	1
18389	1107	40481087	1944-10-12	1944-11-02	1
60462	3578	4112343	1973-12-27	1974-01-09	1
11319	670	80180	2017-05-11	2017-05-12	1
18168	1092	4027663	1983-10-08	1983-10-09	1
72193	4288	28060	1973-02-21	1973-03-06	1
11764	695	40481087	2014-10-25	2014-11-08	1
63804	3773	4112343	2009-05-16	2009-05-25	1
8251	482	4266809	2008-09-28	2008-09-29	1
63370	3746	440086	1956-12-05	1961-12-14	1
60954	3612	195588	2003-12-09	2004-01-15	1
53556	3176	40481087	1999-06-11	1999-06-25	1
66848	3957	40481087	1972-06-14	1972-06-21	1
15560	923	40481087	1960-01-12	1960-01-19	1
80088	4753	28060	1975-02-28	1975-03-10	1
76135	4522	260139	1985-04-23	1985-04-30	1
10253	607	28060	1984-09-05	1984-09-16	1
62974	3721	40481087	1992-01-08	1992-01-22	1
18031	1085	4149245	1968-11-12	1969-01-18	1
63466	3752	4296204	1963-07-14	1963-07-28	1
42084	2509	28060	1976-06-20	1976-07-02	1
71082	4220	260139	1992-03-29	1992-04-05	1
76678	4548	40481087	2005-09-04	2005-09-18	1
12489	739	4112343	1971-11-28	1971-12-06	1
75771	4498	40481087	1997-07-31	1997-08-21	1
15859	939	440448	2003-07-07	2003-07-08	1
10414	614	40481087	1977-01-22	1977-01-29	1
74335	4418	260139	1992-10-21	1992-10-28	1
73469	4372	4112343	2007-09-13	2007-09-22	1
5351	316	40481087	1983-09-07	1983-09-14	1
67370	3986	40481087	1970-03-14	1970-03-28	1
11432	675	4112343	2018-11-08	2018-11-19	1
69732	4130	372328	1968-03-24	1968-04-25	1
15476	918	4112343	1948-05-27	1948-06-05	1
4989	295	81893	1991-10-28	1991-10-29	1
76963	4563	40481087	1972-08-21	1972-09-04	1
74487	4428	260139	1983-08-31	1983-09-07	1
3442	196	40481087	1972-04-19	1972-05-03	1
8578	500	40481087	1972-12-26	1973-01-09	1
85694	5103	40481087	1947-04-30	1947-05-07	1
74607	4436	4266809	2008-06-01	2008-06-02	1
12625	747	4218389	2008-06-08	2008-07-06	1
14387	851	28060	2009-07-08	2009-07-15	1
66308	3929	4285898	1989-08-19	1989-08-20	1
15883	940	40481087	1965-12-18	1965-12-25	1
77990	4625	260139	2003-09-27	2003-10-04	1
13403	789	40481087	2015-02-15	2015-03-01	1
11649	687	4084167	1969-06-09	1969-06-09	1
62052	3668	80180	2013-12-04	2013-12-05	1
9500	564	40481087	2012-08-09	2012-08-23	1
69945	4143	134438	1980-10-01	1981-08-27	1
72540	4313	78272	1949-05-09	1949-05-30	1
44894	2674	260139	1987-01-01	1987-01-15	1
19268	1155	372328	1989-04-08	1990-01-15	1
66406	3935	81893	1981-10-21	1981-10-22	1
44184	2630	4296205	2007-04-26	2007-05-31	1
73551	4376	4112343	1925-06-08	1925-06-15	1
18390	1107	40481087	1949-06-15	1949-06-29	1
60463	3578	0	1979-08-03	1979-08-04	1
11320	670	4059173	1978-05-11	1978-08-09	1
18169	1092	4155034	1982-12-22	1983-01-05	1
72194	4288	28060	2010-03-07	2010-03-18	1
17065	1022	81151	2005-12-21	2006-01-11	1
63805	3773	4155034	1963-02-05	1963-02-26	1
8252	482	4278672	1971-11-12	1972-02-10	1
63371	3746	4112343	1970-07-18	1970-07-29	1
60955	3612	4056621	2004-02-12	2004-02-13	1
53557	3176	40481087	2014-05-16	2014-05-23	1
66849	3957	40481087	1991-02-18	1991-03-11	1
15561	923	40481087	1961-10-15	1961-10-29	1
80089	4753	28060	1984-11-03	1984-11-11	1
76136	4522	4112343	1984-12-25	1985-01-07	1
10254	607	260139	1977-11-04	1977-11-11	1
62975	3721	40481087	2001-05-23	2001-05-30	1
18032	1085	40481087	1973-03-11	1973-03-18	1
63467	3752	40481087	2002-05-10	2002-05-31	1
42085	2509	28060	1983-10-26	1983-11-03	1
71083	4220	260139	1995-01-21	1995-01-28	1
76679	4548	40481087	2009-02-04	2009-02-25	1
12490	739	4112343	1981-11-14	1981-11-24	1
75772	4498	40481087	2016-12-06	2016-12-27	1
15860	939	40481087	1974-01-31	1974-02-07	1
10415	614	40481087	1984-11-23	1984-12-14	1
74336	4418	317576	2008-02-01	2008-02-02	1
73470	4372	4155034	2019-06-04	2019-06-25	1
5352	316	40481087	2014-12-19	2015-01-09	1
67371	3986	40481087	1983-06-23	1983-06-30	1
11433	675	4113008	1972-04-23	1972-05-14	1
69733	4130	375671	1993-01-21	1993-03-22	1
15477	918	4112343	1959-10-09	1959-10-18	1
4990	295	260139	1984-10-04	1984-10-18	1
76964	4563	40481087	2008-06-06	2008-06-20	1
74488	4428	260139	1985-05-31	1985-06-14	1
3443	196	40481087	2007-04-29	2007-05-13	1
8579	500	40481087	1983-12-19	1984-01-02	1
85695	5103	40481087	1948-04-10	1948-04-24	1
74608	4436	40479422	2017-06-22	2017-08-28	1
12626	747	40481087	2002-01-27	2002-02-03	1
14388	851	4027663	2008-05-25	2008-05-26	1
66309	3929	40481087	1964-06-11	1964-06-18	1
15884	940	40481087	1994-12-03	1994-12-24	1
77991	4625	378001	1973-05-24	1973-07-23	1
13404	789	260139	1995-12-01	1995-12-15	1
11650	687	4237458	1984-07-20	1984-09-18	1
62053	3668	81151	1996-04-26	1996-05-24	1
9501	564	80180	1995-10-30	1995-10-31	1
69946	4143	372328	1963-04-22	1963-09-06	1
72541	4313	81151	1958-09-10	1958-10-01	1
44895	2674	4027663	2005-04-14	2005-04-15	1
19269	1155	4112343	1996-08-25	1996-09-01	1
66407	3935	4112343	1973-02-26	1973-03-06	1
44185	2630	40481087	1988-11-24	1988-12-01	1
73552	4376	40481087	1934-08-25	1934-09-15	1
18391	1107	40481087	1965-03-02	1965-03-16	1
60464	3578	28060	1992-06-28	1992-07-06	1
11321	670	4112343	1976-04-22	1976-05-02	1
18170	1092	40479422	1997-03-13	1997-05-19	1
72195	4288	260139	1955-09-18	1955-09-25	1
17066	1022	260139	1970-03-31	1970-04-07	1
63806	3773	40481087	2002-12-04	2002-12-18	1
8253	482	260139	1985-07-03	1985-07-10	1
63372	3746	4112343	2013-06-01	2013-06-10	1
60956	3612	4116491	2004-02-12	2004-03-22	1
53558	3176	78272	1989-02-16	1989-03-16	1
66850	3957	40481087	2010-05-11	2010-05-25	1
15562	923	40481087	2010-05-24	2010-06-07	1
80090	4753	28060	1985-05-14	1985-05-23	1
76137	4522	4112343	2003-09-08	2003-09-21	1
10255	607	260139	2009-09-09	2009-09-16	1
62976	3721	40481087	2001-07-06	2001-07-27	1
18033	1085	40481087	1976-01-28	1976-02-11	1
63468	3752	80180	1997-11-17	1997-11-18	1
42086	2509	28060	1984-03-03	1984-03-14	1
71084	4220	372328	1944-02-18	1944-06-06	1
76680	4548	317576	2018-07-03	2018-07-04	1
12491	739	4112343	1992-09-01	1992-09-14	1
77249	4580	195588	2008-02-19	2008-04-10	1
15861	939	40481087	1988-03-30	1988-04-20	1
10416	614	40481087	1991-04-19	1991-04-26	1
74337	4418	372328	1955-01-07	1955-07-01	1
73471	4372	40481087	2015-12-11	2015-12-18	1
5353	316	260139	1932-12-04	1932-12-18	1
67372	3986	40481087	2001-05-31	2001-06-21	1
11434	675	4142905	1958-08-21	1958-10-20	1
69734	4130	378001	1968-07-01	1968-08-30	1
15478	918	4112343	1962-01-07	1962-01-20	1
4991	295	40481087	1964-09-01	1964-09-08	1
76965	4563	40481087	2016-05-16	2016-05-23	1
74489	4428	40481087	1989-10-26	1989-11-15	1
4727	279	260139	1997-03-03	1997-03-10	1
8580	500	40481087	2000-11-28	2000-12-05	1
85696	5103	81151	1944-08-06	1944-09-03	1
74609	4436	40481087	1970-12-03	1970-12-24	1
12627	747	4112343	1965-05-16	1965-05-24	1
14389	851	4112343	1994-10-20	1994-10-29	1
66310	3929	257012	1958-01-21	1958-01-22	1
15885	940	40481087	1995-01-31	1995-02-07	1
77992	4625	40481087	2005-11-08	2005-11-22	1
13405	789	4109685	2000-06-25	2000-07-09	1
11651	687	4283893	2011-10-20	2011-11-03	1
62054	3668	372328	1975-09-30	1975-12-07	1
9502	564	4112343	2005-07-11	2005-07-23	1
69947	4143	4112343	2006-09-27	2006-10-05	1
72542	4313	4266809	1980-01-27	1980-01-28	1
44896	2674	40481087	2005-10-22	2005-10-29	1
19270	1155	4294548	2010-10-22	2011-04-01	1
66408	3935	40481087	1965-01-28	1965-02-18	1
44186	2630	40481087	2005-11-04	2005-11-25	1
73553	4376	40481087	1998-08-23	1998-09-13	1
18392	1107	40481087	2000-12-30	2001-01-13	1
60465	3578	440448	1979-08-03	1979-08-04	1
11322	670	4112343	1980-07-13	1980-07-25	1
18171	1092	40481087	1977-03-29	1977-04-05	1
72196	4288	260139	2000-08-08	2000-08-15	1
17067	1022	4112343	1985-02-23	1985-03-07	1
63807	3773	80180	1996-10-09	1996-10-10	1
8254	482	260139	1991-05-09	1991-05-23	1
63373	3746	40481087	1957-04-08	1957-04-15	1
60957	3612	4116491	2007-03-22	2007-05-13	1
53559	3176	260139	1979-04-28	1979-05-12	1
66851	3957	260139	1989-11-26	1989-12-10	1
15563	923	40481087	2012-02-03	2012-02-17	1
80091	4753	81151	1970-02-20	1970-03-06	1
76138	4522	40481087	1977-04-09	1977-04-30	1
10256	607	372328	1989-05-25	1990-12-21	1
64852	3839	4112343	1981-11-01	1981-11-08	1
18034	1085	40481087	2007-11-22	2007-12-06	1
63469	3752	4112343	1959-04-07	1959-04-19	1
42087	2509	260139	1972-06-24	1972-07-01	1
71085	4220	372328	1947-05-22	1947-12-16	1
76681	4548	378001	1989-06-07	1989-07-07	1
12492	739	40481087	1927-06-10	1927-06-24	1
77250	4580	260139	2002-01-23	2002-02-06	1
15862	939	40481087	2001-10-27	2001-11-03	1
10417	614	260139	1994-05-31	1994-06-07	1
74338	4418	4112343	1976-01-18	1976-01-25	1
74826	4450	80180	2008-12-19	2008-12-20	1
5354	316	372328	1927-10-01	1927-11-08	1
67373	3986	81151	2007-07-23	2007-08-27	1
11435	675	4237458	2013-11-05	2014-02-03	1
69735	4130	4112343	2017-10-15	2017-10-22	1
15479	918	40481087	1923-02-24	1923-03-17	1
4992	295	40481087	1987-04-14	1987-05-05	1
76966	4563	40481087	2019-03-14	2019-03-21	1
74490	4428	40481087	1994-01-02	1994-01-16	1
4728	279	260139	1998-04-05	1998-04-19	1
8581	500	78272	1965-06-21	1965-07-05	1
85697	5103	81151	2014-12-05	2015-01-02	1
74610	4436	40481087	1990-04-14	1990-05-05	1
12628	747	40481087	1967-11-07	1967-11-28	1
14390	851	40481087	1992-10-31	1992-11-21	1
66311	3929	260139	1970-06-27	1970-07-04	1
15886	940	260139	1982-07-13	1982-07-20	1
81905	4861	4112343	1947-06-02	1947-06-13	1
13406	789	4112343	2003-10-11	2003-10-23	1
12327	729	80180	2000-04-07	2000-04-08	1
62055	3668	4112343	1989-09-19	1989-10-02	1
9503	564	4152936	1996-06-21	1996-07-12	1
69948	4143	40481087	1969-08-17	1969-08-31	1
72543	4313	4294548	1990-05-26	1990-06-02	1
44897	2674	81893	2011-11-09	2011-11-10	1
19271	1155	28060	1976-08-14	1976-08-22	1
66409	3935	40481087	1986-06-06	1986-06-20	1
44187	2630	40481087	2012-03-13	2012-03-27	1
73554	4376	40481087	2016-04-29	2016-05-13	1
18393	1107	81151	2000-02-20	2000-03-05	1
60466	3578	40481087	1983-05-16	1983-06-06	1
11323	670	40481087	1983-08-22	1983-09-05	1
18172	1092	81151	1993-07-11	1993-08-01	1
72197	4288	372328	1954-03-10	1954-07-17	1
17068	1022	40481087	1974-02-25	1974-03-11	1
63808	3773	4059173	1981-01-22	1981-02-21	1
8255	482	372328	1974-08-28	1974-10-03	1
63374	3746	40481087	2007-01-09	2007-01-30	1
60958	3612	4218389	1993-01-25	1993-02-22	1
53560	3176	4112343	1985-09-05	1985-09-17	1
66852	3957	261325	1996-12-19	1996-12-20	1
15564	923	260139	1987-02-02	1987-02-16	1
80092	4753	40481087	1975-09-29	1975-10-06	1
76139	4522	40481087	2008-07-21	2008-08-11	1
10257	607	4112343	1986-02-24	1986-03-09	1
64853	3839	4116491	1987-10-14	1987-11-18	1
18035	1085	192671	2004-11-22	2004-11-23	1
63470	3752	4112343	2013-04-05	2013-04-14	1
42088	2509	4237458	1975-11-04	1975-12-04	1
71086	4220	4027663	1966-12-24	1966-12-25	1
76682	4548	4156265	1986-10-07	1986-10-21	1
12493	739	40481087	1981-09-22	1981-10-06	1
77251	4580	78272	1993-10-10	1993-10-24	1
15863	939	40481087	2002-06-09	2002-06-16	1
10418	614	378001	1990-06-21	1990-08-20	1
74339	4418	4112343	2010-02-22	2010-03-04	1
74827	4450	260139	1968-07-09	1968-07-16	1
5355	316	4112343	1990-11-29	1990-12-07	1
67374	3986	81151	2011-08-06	2011-09-03	1
11436	675	4294548	1953-04-29	1953-06-10	1
69736	4130	4155034	1999-12-19	2000-01-02	1
15480	918	40481087	1958-08-18	1958-09-01	1
4993	295	40481087	1992-07-06	1992-07-27	1
76967	4563	4112343	2007-10-14	2007-10-24	1
74491	4428	40481087	1997-09-03	1997-09-24	1
4729	279	372328	1952-08-26	1952-11-07	1
8582	500	372328	1962-07-28	1962-08-28	1
85698	5103	260139	1944-02-09	1944-02-23	1
74611	4436	4113008	1968-05-12	1968-05-26	1
12629	747	40481087	1982-09-13	1982-10-04	1
14391	851	40481087	1999-01-24	1999-01-31	1
66312	3929	372328	1952-12-01	1953-01-12	1
15887	940	378001	1965-02-12	1965-04-13	1
81906	4861	4112343	1952-04-19	1952-05-03	1
14680	867	80180	1966-01-05	1966-01-06	1
12328	729	81151	2000-01-22	2000-02-26	1
62056	3668	4142905	1992-07-02	1992-08-31	1
9504	564	40481087	1984-08-07	1984-08-14	1
69949	4143	375671	1968-07-24	1968-08-23	1
72544	4313	4310024	1978-01-07	1978-01-08	1
44898	2674	4218389	2006-12-29	2007-01-26	1
19272	1155	80180	2007-10-29	2007-10-30	1
66410	3935	28060	1987-10-23	1987-11-01	1
44188	2630	80180	1999-07-28	1999-07-29	1
73555	4376	313217	1978-07-18	1978-07-19	1
18394	1107	4218389	1979-07-28	1979-08-25	1
60467	3578	40481087	1983-12-09	1983-12-16	1
11324	670	40481087	1984-12-03	1984-12-17	1
18173	1092	372328	1955-09-10	1955-12-23	1
72198	4288	4112343	1961-06-28	1961-07-05	1
17069	1022	40481087	2004-04-30	2004-05-07	1
63809	3773	40481087	1984-10-12	1984-10-19	1
8256	482	4112343	1979-03-21	1979-04-02	1
63375	3746	80180	1987-02-11	1987-02-12	1
60959	3612	40481087	1998-01-10	1998-01-17	1
53561	3176	4116491	2000-11-26	2001-01-25	1
66853	3957	372328	1980-07-12	1981-10-29	1
15565	923	260139	2001-05-22	2001-06-05	1
80093	4753	40481087	1989-10-24	1989-10-31	1
77098	4572	257012	2008-06-06	2008-06-07	1
10258	607	4278672	1957-06-11	1957-09-09	1
64854	3839	4134304	2017-04-30	2017-05-30	1
18036	1085	260139	1965-12-30	1966-01-13	1
63471	3752	4266809	1997-11-17	1997-11-18	1
42089	2509	40481087	2018-05-17	2018-05-31	1
71087	4220	4112343	1995-06-27	1995-07-07	1
76683	4548	40481087	2011-05-21	2011-05-28	1
15819	938	28060	1957-11-01	1957-11-10	1
77252	4580	80180	2004-06-09	2004-06-10	1
15864	939	78272	1976-01-27	1976-02-24	1
10419	614	378001	2000-03-28	2000-04-27	1
74340	4418	40481087	1987-09-17	1987-09-24	1
74828	4450	372328	1967-12-10	1968-01-20	1
5356	316	4152936	1932-05-12	1932-06-02	1
67375	3986	260139	1992-06-18	1992-06-25	1
11437	675	40481087	1996-04-25	1996-05-02	1
69737	4130	4294548	2008-01-15	2008-06-10	1
15481	918	40481087	1966-07-26	1966-08-02	1
4994	295	28060	1951-12-03	1951-12-13	1
76968	4563	4142905	1981-04-10	1981-07-09	1
79587	4720	28060	1979-12-28	1980-01-04	1
4730	279	372328	1954-03-02	1954-05-07	1
8583	500	4142905	2013-03-19	2013-05-18	1
85699	5103	317576	2014-02-03	2014-02-04	1
74612	4436	4134304	1980-05-23	1980-06-22	1
12630	747	40481087	1982-11-08	1982-11-15	1
16193	959	30753	1994-08-04	1994-08-05	1
66313	3929	40481087	1966-04-17	1966-05-08	1
15888	940	40481087	1980-05-30	1980-06-20	1
81907	4861	4112343	2017-11-30	2017-12-13	1
14681	867	260139	1971-05-29	1971-06-12	1
12329	729	260139	1974-01-25	1974-02-08	1
62057	3668	4218389	2016-02-28	2016-03-27	1
9505	564	40481087	1984-09-21	1984-09-28	1
69950	4143	4112343	1965-06-13	1965-06-26	1
72545	4313	40481087	2000-03-16	2000-04-06	1
46882	2792	30753	2000-08-17	2000-08-18	1
19273	1155	257012	1979-07-07	2011-04-01	1
66411	3935	260139	1987-05-16	1987-05-30	1
44189	2630	260139	2008-08-22	2008-08-29	1
73556	4376	372328	1921-10-24	1921-11-07	1
18395	1107	4230399	1927-12-14	1928-03-13	1
61299	3626	372328	1979-03-18	1980-03-08	1
11325	670	260139	1984-10-02	1984-10-09	1
18174	1092	372328	1960-04-30	1961-03-24	1
72199	4288	4283893	1996-08-09	1996-08-30	1
17070	1022	260139	1988-12-18	1989-01-01	1
64040	3787	260139	1986-02-14	1986-02-28	1
8257	482	4112343	1990-03-18	1990-03-25	1
63376	3746	4112343	1956-03-06	1956-03-17	1
60960	3612	28060	2017-06-02	2017-06-13	1
53562	3176	4146173	1998-02-27	1998-03-29	1
66854	3957	4152936	2001-12-10	2001-12-24	1
15566	923	4112343	1959-09-12	1959-09-20	1
80094	4753	0	1987-11-18	1987-11-19	1
77099	4572	372328	1981-10-01	1982-05-25	1
10259	607	40481087	1969-08-16	1969-08-23	1
64855	3839	4278672	2012-05-26	2012-08-24	1
18037	1085	372328	1965-10-29	1965-12-11	1
63472	3752	4310024	1995-07-01	1995-07-02	1
43404	2589	257012	1998-09-29	1998-09-30	1
71088	4220	4152936	1995-04-21	1995-05-12	1
76684	4548	40481087	2013-01-26	2013-02-16	1
15820	938	260139	1958-02-12	1958-02-19	1
77253	4580	260139	1971-01-21	1971-02-04	1
15865	939	440086	1977-07-11	1977-12-12	1
10420	614	4142905	1970-04-27	1970-07-26	1
74341	4418	40481087	2013-11-17	2013-12-08	1
74829	4450	372328	1969-02-13	1969-07-19	1
5357	316	4155034	1987-03-23	1987-04-13	1
67376	3986	372328	1967-04-26	1967-08-11	1
13120	774	192671	2008-06-22	2008-06-23	1
69738	4130	80180	2004-04-28	2004-04-29	1
15482	918	260139	2002-12-07	2002-12-14	1
4995	295	28060	1959-09-04	1959-09-13	1
79691	4725	80180	2009-07-31	2009-08-01	1
79588	4720	195588	2016-06-05	2016-07-23	1
4731	279	4112343	1953-10-21	1953-10-29	1
8584	500	4296204	1981-12-27	1982-01-31	1
85700	5103	40481087	2019-03-31	2019-04-14	1
74613	4436	4156265	2007-08-30	2007-09-13	1
12631	747	40481087	1993-01-10	1993-01-17	1
16194	959	260139	1967-02-08	1967-02-15	1
66314	3929	40481087	1978-04-10	1978-05-01	1
15889	940	0	1993-03-04	1993-03-05	1
81908	4861	4285898	1989-04-14	1989-04-15	1
14682	867	260139	1973-05-15	1973-05-22	1
12330	729	4059173	2001-11-17	2002-01-16	1
62058	3668	81151	2008-08-17	2008-09-07	1
9506	564	40481087	2013-08-05	2013-08-26	1
69951	4143	4112343	1978-12-01	1978-12-08	1
72546	4313	40481087	2003-12-24	2004-01-14	1
46883	2792	440086	1965-10-05	1966-05-10	1
19274	1155	4112343	1975-12-03	1975-12-14	1
66412	3935	4296204	1961-05-30	1961-07-04	1
44190	2630	4112343	1962-01-09	1962-01-16	1
73557	4376	372328	2008-03-05	2008-12-16	1
18396	1107	40481087	1982-05-26	1982-06-09	1
61300	3626	4112343	2005-08-31	2005-09-11	1
11326	670	260139	1995-12-11	1995-12-25	1
18175	1092	4112343	1989-04-21	1989-05-04	1
77685	4607	372328	1974-07-08	1974-12-26	1
17071	1022	4112343	1965-06-26	1965-07-08	1
64041	3787	4112343	2008-12-23	2009-01-02	1
8258	482	78272	1988-05-28	1988-07-02	1
63377	3746	4278672	2012-11-02	2012-12-02	1
60961	3612	78272	2009-02-28	2009-03-28	1
53563	3176	40481087	1973-12-24	1974-01-07	1
66855	3957	40481087	1966-10-01	1966-10-08	1
15567	923	4146173	1981-08-13	1981-10-12	1
80095	4753	260139	1973-04-24	1973-05-08	1
77100	4572	4112343	1985-03-09	1985-03-16	1
10260	607	40481087	1977-04-18	1977-05-02	1
64856	3839	40481087	1958-06-26	1958-07-10	1
18038	1085	4112343	2002-10-07	2002-10-14	1
63473	3752	40481087	1973-11-27	1973-12-04	1
43405	2589	4112343	1990-04-15	1990-04-26	1
71089	4220	4283893	1949-04-16	1949-05-14	1
78018	4628	81151	1979-03-06	1979-04-10	1
15821	938	4112343	1969-04-15	1969-04-23	1
77254	4580	260139	1972-11-29	1972-12-13	1
15866	939	4152936	1986-06-22	1986-07-06	1
12996	764	80180	2003-12-24	2003-12-25	1
74342	4418	28060	1959-04-20	1959-05-03	1
74830	4450	4112343	1975-06-03	1975-06-11	1
5358	316	28060	2019-03-13	2019-03-24	1
67377	3986	4112343	1974-04-03	1974-04-16	1
13121	774	195588	2003-07-16	2003-09-08	1
69739	4130	257012	2008-02-12	2008-06-10	1
15483	918	4112343	2001-04-28	2001-05-09	1
4996	295	28060	1964-03-21	1964-04-03	1
79692	4725	81151	1979-07-29	1979-08-26	1
79589	4720	257012	1995-12-31	1996-01-01	1
4732	279	4112343	1992-03-07	1992-03-17	1
8585	500	40481087	1991-11-26	1991-12-10	1
87251	5199	81151	1975-01-20	1975-02-17	1
74614	4436	40481087	2006-12-12	2007-01-02	1
12632	747	40481087	1993-03-27	1993-04-17	1
16195	959	260139	1992-04-17	1992-04-24	1
66315	3929	81151	1956-04-14	1956-04-28	1
15890	940	260139	1947-05-05	1947-05-19	1
81909	4861	40480160	2008-05-09	2008-06-08	1
14683	867	378001	1993-04-28	1993-05-28	1
12331	729	4112343	2014-07-30	2014-08-06	1
62059	3668	260139	1976-09-26	1976-10-03	1
9507	564	28060	1960-01-01	1960-01-10	1
69952	4143	40481087	1961-12-04	1961-12-18	1
72547	4313	28060	1958-12-29	1959-01-05	1
46884	2792	80180	2001-12-10	2001-12-11	1
19275	1155	4112343	1983-09-28	1983-10-06	1
66413	3935	40481087	1946-08-31	1946-09-14	1
44191	2630	40481087	2006-10-29	2006-11-05	1
73558	4376	4112343	1973-01-29	1973-02-06	1
18397	1107	0	2007-06-15	2007-06-16	1
61301	3626	40481087	2014-03-17	2014-03-31	1
11327	670	372328	1974-07-01	1974-10-12	1
18176	1092	4296204	1972-07-19	1972-08-16	1
77686	4607	378001	2005-07-16	2005-08-15	1
17072	1022	4112343	1990-10-10	1990-10-21	1
64042	3787	4278672	1966-06-18	1966-08-17	1
8259	482	81893	2006-12-08	2006-12-09	1
63378	3746	4285898	1986-05-17	1986-05-18	1
60962	3612	260139	1982-06-24	1982-07-08	1
53564	3176	40481087	1983-11-11	1983-11-25	1
66856	3957	40481087	1998-02-20	1998-03-06	1
15568	923	40481087	2005-01-31	2005-02-14	1
80096	4753	440086	1971-06-05	1974-07-27	1
77101	4572	4112343	1999-08-28	1999-09-10	1
10261	607	40481087	1987-05-05	1987-05-19	1
64857	3839	40481087	1968-04-23	1968-05-07	1
18039	1085	40481087	2006-08-29	2006-09-19	1
63474	3752	40481087	1986-07-06	1986-07-13	1
43406	2589	4152936	1998-01-02	1998-01-16	1
71396	4240	260139	1963-04-29	1963-05-13	1
78019	4628	372328	1969-06-26	1969-09-07	1
15822	938	4134304	1963-12-12	1964-01-11	1
77255	4580	260139	1984-06-18	1984-06-25	1
15867	939	4156265	1966-06-04	1966-06-18	1
12997	764	4059173	2012-05-30	2012-06-29	1
74343	4418	260139	2010-01-20	2010-01-27	1
74831	4450	4112343	2012-02-07	2012-02-19	1
5359	316	257012	1934-04-19	1934-04-20	1
67378	3986	4112343	2000-04-01	2000-04-12	1
13122	774	260139	1991-04-16	1991-04-23	1
69740	4130	260139	1986-07-28	1986-08-11	1
15484	918	4134304	1969-01-21	1969-03-22	1
4997	295	80180	1993-06-19	1993-06-20	1
79693	4725	4218389	1988-09-07	1988-09-28	1
79590	4720	260139	1989-08-30	1989-09-13	1
4733	279	40481087	2009-05-24	2009-06-07	1
12038	712	81151	2018-04-20	2018-05-04	1
87252	5199	192671	2001-04-19	2001-04-20	1
74615	4436	321042	2003-06-13	2003-06-14	1
19578	1176	260139	1981-07-29	1981-08-12	1
16196	959	260139	1996-10-18	1996-10-25	1
66316	3929	81151	1991-05-23	1991-06-06	1
15891	940	260139	1971-08-08	1971-08-23	1
81910	4861	257012	1955-08-21	1955-08-22	1
14684	867	4109685	1931-02-18	1931-03-11	1
12332	729	4112343	2015-12-03	2015-12-11	1
62060	3668	40481087	1996-08-18	1996-09-01	1
9508	564	78272	1980-06-10	1980-07-15	1
69953	4143	30753	1999-06-12	1999-06-13	1
72548	4313	260139	2006-02-18	2006-02-25	1
46885	2792	260139	1962-10-12	1962-10-19	1
19276	1155	4112343	1984-10-03	1984-10-10	1
66414	3935	40481087	1956-12-28	1957-01-11	1
44192	2630	81151	1992-07-29	1992-08-12	1
73559	4376	4112343	1977-07-17	1977-07-24	1
18398	1107	260139	1956-12-20	1956-12-27	1
61302	3626	80180	2016-07-25	2016-07-26	1
11328	670	4310024	2015-05-22	2015-05-23	1
18177	1092	40481087	1963-02-09	1963-02-23	1
77687	4607	4112343	1976-10-12	1976-10-24	1
17073	1022	40481087	1967-04-20	1967-04-27	1
64043	3787	40481087	2004-10-02	2004-10-09	1
8260	482	372328	1979-04-10	1979-11-01	1
63379	3746	4294548	1985-02-26	1985-04-09	1
60963	3612	260139	1994-06-21	1994-07-05	1
55908	3314	80180	2003-07-20	2003-07-21	1
66857	3957	40481087	2016-01-03	2016-01-10	1
15569	923	28060	1965-09-21	1965-09-28	1
80097	4753	4112343	1996-11-23	1996-12-06	1
77102	4572	28060	1977-01-08	1977-01-21	1
10262	607	28060	1984-10-20	1984-10-30	1
64858	3839	40481087	1970-10-29	1970-11-05	1
18040	1085	40481087	2016-05-31	2016-06-21	1
63475	3752	81893	1996-04-26	1996-04-27	1
43407	2589	4296204	2016-10-08	2016-10-22	1
71397	4240	317576	2010-11-08	2010-11-09	1
78020	4628	375671	2002-09-06	2002-10-06	1
15823	938	40481087	1947-08-15	1947-08-29	1
77256	4580	372328	1971-07-25	1972-02-01	1
19153	1149	4112343	1997-05-28	1997-06-09	1
12998	764	4112343	2006-11-13	2006-11-25	1
74344	4418	4166224	1954-07-27	1954-07-28	1
74832	4450	4285898	2008-05-23	2008-05-24	1
5360	316	260139	1956-11-04	1956-11-18	1
67379	3986	40481087	2001-07-29	2001-08-19	1
13123	774	260139	1994-12-22	1994-12-29	1
69741	4130	260139	1997-03-02	1997-03-16	1
15485	918	4218389	1964-01-13	1964-02-03	1
4998	295	372328	1953-05-25	1954-05-26	1
79694	4725	40481087	1985-12-14	1985-12-28	1
79591	4720	439777	2007-06-08	2007-06-09	1
4734	279	40481087	2018-09-16	2018-09-30	1
12039	712	321042	2011-04-14	2011-04-15	1
87253	5199	4116491	2011-01-04	2011-02-17	1
74616	4436	375671	1988-06-10	1988-07-10	1
19579	1176	4048171	1966-10-25	1966-10-26	1
16197	959	4112343	1985-05-26	1985-06-07	1
66317	3929	195588	1977-04-29	1977-05-30	1
15892	940	321042	1993-03-04	1993-03-05	1
81911	4861	260139	2003-04-12	2003-04-26	1
14685	867	4112343	1974-09-24	1974-10-01	1
12333	729	40481087	2001-09-07	2001-09-28	1
62061	3668	260139	2000-08-30	2000-09-06	1
9509	564	195588	1991-10-11	1991-11-17	1
69954	4143	80180	2000-12-03	2000-12-04	1
72549	4313	372328	1950-01-04	1950-06-24	1
46886	2792	260139	2008-05-21	2008-05-28	1
19277	1155	4112343	1995-10-15	1995-10-27	1
66415	3935	260139	1958-01-15	1958-01-22	1
44193	2630	81893	1997-11-05	1997-11-06	1
73560	4376	40480160	2010-09-19	2010-10-19	1
18399	1107	372328	1928-08-10	1928-10-26	1
61303	3626	372328	1977-02-05	1977-02-26	1
11329	670	40481087	1994-11-03	1994-11-24	1
18178	1092	40481087	1973-04-06	1973-04-13	1
77688	4607	4112343	1984-03-18	1984-03-28	1
17074	1022	0	2010-02-09	2010-02-10	1
64044	3787	260139	1979-09-28	1979-10-12	1
8261	482	4116491	1991-10-18	1991-11-23	1
63380	3746	40481087	1969-02-02	1969-02-23	1
60964	3612	260139	2000-04-30	2000-05-14	1
55909	3314	192671	2003-09-23	2003-09-24	1
66858	3957	80180	1998-08-02	1998-08-03	1
15570	923	28060	1986-11-05	1986-11-12	1
80098	4753	40481087	1963-10-02	1963-10-23	1
77103	4572	28060	1981-05-17	1981-05-27	1
10263	607	30753	1990-05-29	1990-05-30	1
64859	3839	40481087	2017-11-12	2017-11-26	1
18041	1085	40481087	1973-11-20	1973-12-04	1
63476	3752	195588	1995-12-03	1996-01-14	1
43408	2589	40481087	2000-03-15	2000-04-05	1
71398	4240	4112343	1948-06-10	1948-06-19	1
78021	4628	378001	2007-07-12	2007-08-11	1
15824	938	40481087	2000-02-19	2000-03-04	1
77257	4580	4218389	1975-07-12	1975-08-16	1
19154	1149	4112343	2003-10-07	2003-10-19	1
12999	764	4237458	1989-01-01	1989-01-31	1
74345	4418	40479422	2006-09-30	2006-11-06	1
74833	4450	40481087	1982-05-02	1982-05-23	1
5361	316	260139	1963-06-01	1963-06-15	1
67380	3986	40481087	2017-10-31	2017-11-14	1
13124	774	40481087	2006-03-23	2006-03-30	1
69742	4130	372328	1965-06-17	1965-07-29	1
15486	918	81151	2008-05-20	2008-06-03	1
4999	295	40481087	1973-09-28	1973-10-05	1
79695	4725	40481087	2012-03-06	2012-03-27	1
79592	4720	4142905	1982-02-14	1982-04-15	1
4735	279	28060	1993-06-13	1993-06-20	1
12040	712	40481087	1978-09-21	1978-09-28	1
87254	5199	78272	1973-01-02	1973-01-30	1
74617	4436	80180	2008-06-01	2008-06-02	1
19580	1176	4112343	1965-10-05	1965-10-18	1
16198	959	4112343	2016-12-24	2016-12-31	1
66318	3929	260139	1968-02-13	1968-02-27	1
15893	940	4109685	1979-05-30	1979-06-13	1
81912	4861	317009	1982-06-02	1982-06-03	1
14686	867	40481087	1963-05-06	1963-05-20	1
12334	729	28060	1966-03-09	1966-03-17	1
62062	3668	372328	1991-12-13	1992-09-13	1
9510	564	4112343	1968-09-27	1968-10-07	1
69955	4143	81151	1996-06-27	1996-07-11	1
72550	4313	4027663	1972-07-12	1972-07-13	1
46887	2792	260139	2012-04-26	2012-05-03	1
19278	1155	4112343	2015-11-22	2015-11-30	1
66416	3935	381316	1990-10-24	1990-10-25	1
44194	2630	260139	2015-09-04	2015-09-18	1
73561	4376	40481087	1926-08-26	1926-09-02	1
18400	1107	375671	1947-02-16	1947-03-18	1
61304	3626	4112343	1980-04-24	1980-05-01	1
11330	670	40481087	1997-07-17	1997-07-24	1
18179	1092	40481087	1994-01-13	1994-01-27	1
77689	4607	4156265	1984-10-13	1984-11-03	1
17075	1022	80180	2006-07-09	2006-07-10	1
64045	3787	260139	2010-10-04	2010-10-11	1
9797	580	81151	1930-06-03	1930-07-01	1
63381	3746	40481087	1989-09-22	1989-10-06	1
60965	3612	4116491	2008-05-12	2008-07-11	1
55910	3314	260139	2007-07-16	2007-07-30	1
66859	3957	4155034	1988-04-01	1988-04-22	1
15571	923	80180	1995-02-26	1995-02-27	1
80099	4753	40481087	2014-06-20	2014-07-11	1
77104	4572	80180	2018-10-24	2018-10-25	1
10264	607	81893	1990-01-29	1990-01-30	1
64860	3839	28060	1952-12-12	1952-12-21	1
18042	1085	40481087	1998-07-24	1998-08-14	1
63477	3752	372328	1962-11-05	1962-11-19	1
43409	2589	80180	2015-10-30	2015-10-31	1
71399	4240	4112343	2003-09-01	2003-09-14	1
78022	4628	4112343	1979-12-16	1979-12-25	1
15825	938	40481087	2017-12-09	2017-12-16	1
77258	4580	260139	1967-05-26	1967-06-09	1
19155	1149	4112343	2011-04-12	2011-04-21	1
13000	764	40481087	1990-05-04	1990-05-25	1
74346	4418	40481087	1952-10-24	1952-11-14	1
74834	4450	28060	1975-12-11	1975-12-21	1
5362	316	260139	1996-05-08	1996-05-15	1
67381	3986	80180	1996-06-07	1996-06-08	1
13125	774	80180	2008-04-30	2008-05-01	1
69743	4130	372328	1967-07-24	1967-10-26	1
15487	918	260139	1991-11-14	1991-11-28	1
5000	295	40481087	1990-10-22	1990-11-05	1
79696	4725	81151	1996-02-19	1996-03-18	1
79593	4720	4156265	1987-04-19	1987-05-10	1
4736	279	80180	1991-05-09	1991-05-10	1
12041	712	40481087	1991-02-27	1991-03-20	1
87255	5199	260139	1963-10-09	1963-10-23	1
74618	4436	134438	1984-05-30	1987-05-18	1
19581	1176	4310024	1996-12-09	1996-12-10	1
16199	959	4134304	1970-05-13	1970-07-12	1
66319	3929	372328	1954-01-07	1954-04-12	1
15894	940	4112343	1964-05-05	1964-05-14	1
81913	4861	372328	1948-04-23	1948-05-08	1
14687	867	40481087	1998-10-18	1998-11-01	1
12335	729	192671	2000-04-28	2000-04-29	1
62063	3668	4109685	1993-06-27	1993-07-11	1
9511	564	4116491	1991-12-22	1992-01-28	1
69956	4143	260139	1991-04-26	1991-05-10	1
72551	4313	4278672	1953-09-06	1953-10-06	1
46888	2792	4027663	1990-09-29	1990-09-30	1
19279	1155	40481087	1980-08-26	1980-09-16	1
66417	3935	4146173	1982-01-13	1982-03-14	1
44195	2630	4112343	1972-12-23	1973-01-04	1
73562	4376	40481087	1931-08-13	1931-09-03	1
18401	1107	4112343	1930-08-13	1930-08-25	1
61305	3626	260139	2012-04-04	2012-04-18	1
11331	670	81893	2015-09-19	2015-09-20	1
18180	1092	40481087	1997-06-07	1997-06-14	1
77690	4607	40481087	2013-12-01	2013-12-15	1
17076	1022	260139	1982-01-05	1982-01-19	1
64046	3787	317576	2013-04-13	2013-04-14	1
9798	580	260139	1942-08-16	1942-08-23	1
63382	3746	30753	1985-09-19	1985-09-20	1
60966	3612	40481087	1961-09-16	1961-09-23	1
55911	3314	260139	2008-12-21	2009-01-04	1
66860	3957	4294548	2019-04-01	2019-04-15	1
15572	923	378001	1983-11-01	1983-12-31	1
80100	4753	40481087	2018-08-27	2018-09-10	1
77105	4572	81151	1977-11-08	1977-12-13	1
10265	607	260139	1964-12-03	1964-12-10	1
64861	3839	30753	1993-01-30	1993-01-31	1
18043	1085	40481087	2005-04-14	2005-04-28	1
63478	3752	4027663	1989-12-04	1989-12-05	1
43410	2589	260139	1993-07-29	1993-08-12	1
71400	4240	4283893	1949-10-12	1950-04-12	1
78023	4628	40481087	2013-12-29	2014-01-05	1
15826	938	260139	1990-08-10	1990-08-24	1
77259	4580	4112343	1987-01-23	1987-02-04	1
19156	1149	40481087	1993-04-03	1993-04-17	1
13001	764	260139	1992-05-16	1992-05-30	1
74347	4418	40481087	1991-11-11	1991-12-02	1
74835	4450	372328	1970-03-16	1970-06-13	1
5363	316	4155034	2014-02-20	2014-03-06	1
67382	3986	260139	1971-03-07	1971-03-14	1
13126	774	260139	2017-05-15	2017-05-29	1
69744	4130	40481087	2006-04-29	2006-05-20	1
15488	918	260139	2015-12-19	2016-01-02	1
5001	295	40481087	2013-08-13	2013-09-03	1
79697	4725	195588	2000-09-16	2000-10-27	1
79594	4720	40481087	1980-03-05	1980-03-26	1
4737	279	260139	1958-10-25	1958-11-01	1
12042	712	0	2011-04-14	2011-04-15	1
87256	5199	260139	1974-08-21	1974-09-04	1
74619	4436	4310024	2005-12-14	2005-12-15	1
19582	1176	40481087	1974-07-25	1974-08-08	1
16200	959	4266809	1995-01-31	1995-02-01	1
66320	3929	4027663	1980-04-28	1980-04-29	1
15895	940	4112343	1972-03-19	1972-04-01	1
81914	4861	40481087	2012-07-05	2012-07-26	1
14688	867	40481087	2000-05-29	2000-06-05	1
12336	729	260139	2019-03-20	2019-03-27	1
62064	3668	4112343	1996-04-30	1996-05-10	1
9512	564	4155034	2007-09-04	2007-09-25	1
69957	4143	4027663	1990-09-22	1990-09-23	1
72552	4313	40481087	1958-01-01	1958-01-08	1
46889	2792	4109685	2008-07-25	2008-08-15	1
19280	1155	40481087	2002-03-25	2002-04-01	1
66418	3935	4294548	1958-03-16	1958-03-30	1
44196	2630	4112343	1991-03-03	1991-03-11	1
73563	4376	40481087	1953-02-28	1953-03-14	1
18402	1107	4112343	1956-12-20	1956-12-29	1
61306	3626	81151	1988-08-06	1988-08-27	1
11332	670	4112343	2018-09-13	2018-09-23	1
20718	1246	30753	1979-01-31	1979-02-01	1
77691	4607	4218389	2007-08-05	2007-09-09	1
17077	1022	372328	1969-07-17	1970-03-17	1
64047	3787	440448	1981-11-07	1981-11-08	1
9799	580	372328	1928-01-01	1928-01-15	1
63383	3746	80502	2014-06-12	2014-06-13	1
60967	3612	40481087	2000-07-13	2000-08-03	1
55912	3314	4112343	2016-04-10	2016-04-22	1
66861	3957	40481087	1993-12-01	1993-12-22	1
15573	923	4112343	1978-02-06	1978-02-18	1
80101	4753	260139	1986-11-28	1986-12-12	1
77106	4572	260139	1987-04-17	1987-05-01	1
10266	607	4027663	1979-12-08	1979-12-09	1
64862	3839	260139	1957-09-17	1957-10-01	1
18044	1085	78272	1977-02-05	1977-03-05	1
63479	3752	4112343	1966-03-14	1966-03-26	1
43411	2589	4112343	1995-05-02	1995-05-12	1
71401	4240	40481087	1960-04-13	1960-05-04	1
78024	4628	134438	1986-10-02	1987-09-03	1
15827	938	260139	2000-12-30	2001-01-06	1
77260	4580	40481087	1996-09-25	1996-10-02	1
19157	1149	40481087	2005-07-21	2005-08-11	1
13002	764	260139	2010-01-08	2010-01-15	1
74348	4418	0	1954-07-27	1954-07-28	1
74836	4450	4027663	2001-08-03	2001-08-04	1
5364	316	4278672	2006-08-31	2006-10-30	1
67383	3986	260139	1973-09-24	1973-10-01	1
13127	774	4001336	1980-09-09	1980-10-09	1
69745	4130	260139	2019-05-17	2019-05-31	1
15489	918	4134304	1985-04-27	1985-05-27	1
5002	295	30753	1992-03-26	1992-03-27	1
79698	4725	4048171	1976-09-29	1993-09-27	1
79595	4720	40481087	1985-08-02	1985-08-23	1
4738	279	4112343	2000-01-19	2000-01-27	1
12043	712	80180	2013-07-15	2013-07-16	1
87257	5199	260139	1978-05-13	1978-05-22	1
74620	4436	40481087	1972-07-24	1972-08-07	1
19583	1176	40481087	1992-10-08	1992-10-15	1
16201	959	40481087	1977-05-21	1977-06-11	1
66321	3929	4155034	2004-10-09	2004-10-23	1
15896	940	4155034	1987-05-02	1987-05-23	1
81915	4861	28060	1985-04-21	1985-04-29	1
14689	867	260139	1984-02-02	1984-02-16	1
12337	729	4112343	1969-07-01	1969-07-09	1
62065	3668	40481087	2007-04-12	2007-04-26	1
9513	564	40481087	2015-01-25	2015-02-01	1
69958	4143	4112343	1971-03-31	1971-04-09	1
72553	4313	40481087	1975-12-12	1976-01-02	1
46890	2792	4112343	1963-10-16	1963-10-24	1
19281	1155	260139	1972-10-19	1972-10-26	1
66419	3935	78272	1968-05-28	1968-06-25	1
44197	2630	4266809	1999-07-28	1999-07-29	1
73564	4376	40481087	1963-05-28	1963-06-04	1
18403	1107	4152936	1929-01-07	1929-01-21	1
61307	3626	4112343	1982-06-23	1982-07-01	1
11333	670	40481087	2016-08-19	2016-09-09	1
20719	1246	81893	1979-01-01	1979-01-02	1
77692	4607	260139	1998-01-04	1998-01-11	1
17078	1022	378001	2008-09-27	2008-11-26	1
64048	3787	40481087	1993-08-20	1993-09-03	1
9800	580	4152936	1929-06-24	1929-07-08	1
63384	3746	192671	1987-02-28	1987-03-01	1
60968	3612	260139	2013-10-20	2013-11-03	1
55913	3314	4116491	2009-08-27	2009-10-18	1
66862	3957	40481087	1996-12-12	1996-12-19	1
15574	923	4112343	2014-01-05	2014-01-13	1
80102	4753	321042	1987-11-18	1987-11-19	1
77107	4572	4112343	1980-05-08	1980-05-21	1
10267	607	4112343	1956-03-22	1956-04-02	1
64863	3839	4134304	1951-10-18	1951-12-17	1
18045	1085	80180	2004-11-08	2004-11-09	1
63480	3752	4112343	1989-01-28	1989-02-07	1
43412	2589	4283893	1998-09-01	1998-10-13	1
71402	4240	40481087	1975-07-22	1975-08-12	1
78025	4628	378001	1993-12-22	1994-01-21	1
15828	938	4112343	1980-04-15	1980-04-22	1
77261	4580	28060	1976-11-04	1976-11-15	1
19158	1149	40481087	2007-11-04	2007-11-18	1
13003	764	4112343	1985-10-21	1985-11-02	1
74349	4418	80180	1993-05-07	1993-05-08	1
74837	4450	4059173	2015-04-16	2015-05-16	1
5365	316	40481087	1966-08-03	1966-08-10	1
67384	3986	4109685	1987-04-11	1987-04-25	1
13128	774	4112343	2010-11-15	2010-11-22	1
69746	4130	4218389	1995-12-07	1996-01-04	1
15490	918	40481087	1967-08-06	1967-08-13	1
5003	295	78272	1984-04-12	1984-05-10	1
79699	4725	4112343	1977-05-11	1977-05-21	1
79596	4720	260139	1976-08-15	1976-08-29	1
4739	279	4112343	2001-10-22	2001-10-31	1
12044	712	372328	1977-01-25	1977-04-14	1
87258	5199	260139	2010-01-27	2010-02-10	1
74621	4436	40481087	1990-10-10	1990-10-31	1
19584	1176	78272	1976-05-13	1976-06-17	1
16202	959	28060	1979-01-16	1979-01-27	1
66322	3929	4218389	1983-09-04	1983-10-02	1
15897	940	4237458	1956-05-30	1956-08-28	1
81916	4861	28060	2012-10-18	2012-10-26	1
14690	867	260139	2018-02-26	2018-03-12	1
12338	729	4112343	1984-09-21	1984-10-03	1
62066	3668	40481087	2012-10-01	2012-10-15	1
9740	578	260139	2009-07-22	2009-07-29	1
72242	4291	372328	1975-10-25	1976-04-30	1
72554	4313	40481087	2008-07-27	2008-08-10	1
46891	2792	40481087	2006-12-05	2006-12-12	1
19282	1155	260139	1974-02-19	1974-03-05	1
66420	3935	81151	1958-05-25	1958-06-15	1
46668	2780	28060	1958-06-10	1958-06-18	1
73565	4376	40481087	1963-11-07	1963-11-21	1
18404	1107	40481087	1952-10-20	1952-10-27	1
61308	3626	40481087	1994-10-12	1994-10-19	1
11334	670	28060	1984-08-06	1984-08-18	1
20720	1246	260139	1943-11-22	1943-11-29	1
77693	4607	372328	1975-04-25	1975-06-26	1
17079	1022	4027663	1998-03-23	1998-03-24	1
64049	3787	0	1981-11-07	1981-11-08	1
9801	580	4152936	1958-04-26	1958-05-10	1
63385	3746	195588	1991-11-27	1992-01-17	1
60969	3612	4230399	1974-04-05	1974-06-04	1
55914	3314	4116491	2015-10-17	2015-12-06	1
67503	3993	28060	1949-05-26	1949-06-04	1
15575	923	4112343	2015-12-07	2015-12-18	1
80103	4753	372328	1966-03-26	1966-06-29	1
77108	4572	4112343	2016-08-13	2016-08-22	1
10268	607	40481087	1980-11-17	1980-12-01	1
64864	3839	4296204	2007-11-28	2007-12-19	1
18046	1085	4112343	1988-04-28	1988-05-07	1
63481	3752	40481087	1995-03-05	1995-03-12	1
43413	2589	40481087	1995-07-22	1995-08-12	1
71403	4240	40481087	1996-07-28	1996-08-04	1
78026	4628	4113008	2016-08-23	2016-09-13	1
15829	938	4296204	1976-06-20	1976-07-18	1
77262	4580	372328	1970-12-05	1971-01-26	1
19159	1149	80180	2013-08-09	2013-08-10	1
13004	764	4283893	2011-07-12	2011-08-02	1
74350	4418	260139	1968-11-25	1968-12-09	1
74838	4450	4112343	2018-10-18	2018-10-31	1
5366	316	40481087	1998-07-06	1998-07-20	1
69799	4134	260139	1976-12-19	1977-01-02	1
13129	774	4113008	1985-08-14	1985-08-28	1
69747	4130	40481087	1987-03-31	1987-04-14	1
15491	918	40481087	2012-08-08	2012-08-29	1
5004	295	260139	1980-07-18	1980-07-25	1
79700	4725	40481087	1989-09-15	1989-09-29	1
79597	4720	260139	2009-11-07	2009-11-14	1
4740	279	40481087	2015-09-10	2015-09-24	1
12045	712	40481087	1983-10-10	1983-10-31	1
87259	5199	4112343	1974-09-25	1974-10-06	1
79441	4712	28060	1979-03-18	1979-03-25	1
19585	1176	372328	1966-12-16	1967-09-29	1
16203	959	260139	1978-07-01	1978-07-15	1
66323	3929	4283893	1957-12-10	1958-07-08	1
15898	940	40481087	1982-07-16	1982-07-30	1
81917	4861	80180	1989-05-14	1989-05-15	1
14691	867	4112343	1970-09-05	1970-09-12	1
12339	729	4109685	1972-02-04	1972-02-18	1
62067	3668	81151	2018-01-16	2018-02-13	1
9741	578	372328	1968-11-21	1969-02-26	1
72243	4291	372328	1997-10-24	1999-02-19	1
75312	4476	80180	2000-02-29	2000-03-01	1
46892	2792	81893	2000-04-19	2000-04-20	1
19283	1155	4134304	1981-03-04	1981-04-03	1
66421	3935	260139	1952-02-28	1952-03-13	1
46669	2780	372328	1956-12-21	1957-03-27	1
73566	4376	40481087	1979-06-29	1979-07-13	1
20171	1215	260139	1975-11-20	1975-12-04	1
62177	3676	28060	1989-08-07	1989-08-18	1
11335	670	260139	1977-09-15	1977-09-22	1
20721	1246	4112343	1957-03-26	1957-04-07	1
77694	4607	4112343	2011-12-04	2011-12-15	1
17080	1022	4112343	1968-01-25	1968-02-06	1
64050	3787	0	2016-08-27	2016-08-28	1
9802	580	4156265	2005-10-14	2005-11-04	1
63386	3746	260139	1985-04-14	1985-04-28	1
60970	3612	28060	1967-07-12	1967-07-22	1
55915	3314	4237458	1976-08-25	1976-11-22	1
67504	3993	80180	1980-08-09	1980-08-10	1
15576	923	4155034	1989-04-03	1989-04-24	1
80104	4753	4134304	1968-04-01	1968-05-01	1
77109	4572	4155034	2002-05-06	2002-05-27	1
10269	607	28060	2009-05-09	2009-05-21	1
64865	3839	40481087	1961-10-31	1961-11-14	1
18047	1085	4112343	1995-10-02	1995-10-11	1
63482	3752	372328	1959-06-05	1959-11-19	1
47023	2801	260139	1931-06-16	1931-06-30	1
71404	4240	40481087	2014-08-16	2014-09-06	1
78027	4628	40481087	1974-08-23	1974-08-30	1
15830	938	40481087	1989-07-04	1989-07-11	1
77263	4580	40481087	1967-10-31	1967-11-21	1
19160	1149	81151	2004-12-21	2005-01-04	1
13005	764	40481087	1991-09-25	1991-10-16	1
74351	4418	378001	1957-06-07	1957-07-07	1
74839	4450	4156265	2008-01-09	2008-01-23	1
5367	316	40481087	2004-04-28	2004-05-19	1
69800	4134	4112343	1972-12-14	1972-12-21	1
13130	774	40481087	2017-06-22	2017-07-06	1
69748	4130	40481087	1993-07-20	1993-08-03	1
15492	918	317576	1991-01-11	1991-01-12	1
5005	295	4027663	1983-06-07	1983-06-08	1
79701	4725	40481087	1976-07-21	1976-07-28	1
79598	4720	4027663	2004-06-08	2004-06-09	1
4741	279	260139	1992-02-12	1992-02-26	1
12046	712	28060	1990-07-13	1990-07-26	1
87260	5199	40481087	2013-03-30	2013-04-06	1
79442	4712	372328	2017-05-01	2018-03-23	1
19586	1176	4237458	1991-03-01	1991-04-30	1
16204	959	372328	1958-11-21	1959-03-04	1
68009	4021	80180	1992-05-22	1992-05-23	1
16615	986	81151	1924-09-07	1924-10-05	1
81918	4861	80502	2007-05-22	2007-05-23	1
14692	867	81151	1981-09-14	1981-09-28	1
12340	729	4237458	1962-07-26	1962-10-24	1
62068	3668	378001	1989-05-19	1989-06-18	1
9742	578	372328	1970-05-22	1970-08-26	1
72244	4291	40481087	1989-05-30	1989-06-06	1
75313	4476	81151	1971-06-01	1971-06-15	1
46893	2792	372328	1958-02-04	1958-03-17	1
19284	1155	4294548	1979-05-19	1979-08-04	1
66422	3935	260139	1964-06-20	1964-06-27	1
46670	2780	372328	1960-04-10	1960-12-28	1
73567	4376	40481087	1988-01-29	1988-02-12	1
20172	1215	4283893	2006-02-03	2006-03-31	1
62178	3676	257012	1981-04-28	1981-04-29	1
11336	670	372328	1976-04-03	1976-10-09	1
20722	1246	4112343	1991-09-22	1991-09-30	1
77695	4607	40481087	2019-05-16	2019-06-06	1
17081	1022	4285898	2006-03-11	2006-03-12	1
64051	3787	80180	1998-07-20	1998-07-21	1
9803	580	4294548	1953-09-29	1953-10-27	1
63387	3746	4112343	1990-02-17	1990-02-28	1
60971	3612	260139	1995-05-15	1995-05-22	1
55916	3314	40481087	2006-11-15	2006-11-22	1
67505	3993	195588	1960-12-22	1961-02-03	1
15577	923	40481087	1999-05-14	1999-05-28	1
80105	4753	40481087	2012-12-04	2012-12-18	1
77110	4572	4283893	2008-04-25	2008-06-13	1
10270	607	80180	1991-02-23	1991-02-24	1
64866	3839	40481087	2013-08-08	2013-08-29	1
18048	1085	4237458	2000-07-02	2000-08-01	1
67464	3991	80502	2016-01-23	2016-01-24	1
47024	2801	4112343	1945-06-19	1945-06-29	1
71405	4240	0	1965-07-16	1965-07-17	1
78028	4628	40481087	1984-07-13	1984-07-20	1
15831	938	80180	1987-05-30	1987-05-31	1
77264	4580	40481087	1986-07-20	1986-08-10	1
19161	1149	260139	1987-08-18	1987-08-25	1
13006	764	40481087	2013-07-01	2013-07-15	1
74352	4418	4112343	2000-06-05	2000-06-13	1
74840	4450	4266809	2008-12-19	2008-12-20	1
5368	316	40481087	2006-05-14	2006-05-28	1
69801	4134	4112343	1985-07-02	1985-07-15	1
13131	774	257012	1992-05-13	1992-05-14	1
73647	4381	80180	2005-11-04	2005-11-05	1
15493	918	321042	2016-05-20	2016-05-21	1
5006	295	4059173	2015-11-24	2016-02-22	1
79702	4725	40481087	2000-07-08	2000-07-29	1
79599	4720	4218389	1999-04-07	1999-05-12	1
4742	279	260139	2014-10-24	2014-10-31	1
12047	712	260139	2018-12-25	2019-01-01	1
87261	5199	78272	1971-01-29	1971-02-12	1
79443	4712	4112343	1973-06-23	1973-07-04	1
19587	1176	4266809	1999-04-28	1999-04-29	1
16205	959	378001	1971-07-07	1971-08-06	1
68010	4021	4112343	1960-12-12	1960-12-19	1
16616	986	257012	1932-01-30	1932-01-31	1
81919	4861	4027663	1979-05-27	1979-05-28	1
14693	867	381316	2016-07-05	2016-07-06	1
12341	729	40481087	1978-01-08	1978-01-22	1
62069	3668	4112343	1997-10-06	1997-10-15	1
9743	578	4084167	1967-12-27	1967-12-27	1
72245	4291	40481087	1994-10-15	1994-10-29	1
75314	4476	260139	2003-03-08	2003-03-22	1
46894	2792	372328	1962-07-24	1962-09-17	1
21999	1318	260139	1998-06-06	1998-06-13	1
66423	3935	4027663	1975-12-27	1975-12-28	1
46671	2780	439777	2001-01-06	2001-01-07	1
73568	4376	40481087	2010-07-02	2010-07-23	1
20173	1215	40481087	1973-06-08	1973-06-22	1
62179	3676	260139	1979-10-23	1979-10-30	1
11337	670	4027663	2007-10-26	2007-10-27	1
20723	1246	4152936	1994-03-03	1994-03-24	1
77696	4607	28060	1973-09-15	1973-09-26	1
17082	1022	40481087	2000-04-28	2000-05-12	1
64052	3787	260139	1978-07-16	1978-07-23	1
9804	580	40481087	1940-01-11	1940-01-18	1
63388	3746	40481087	2014-09-29	2014-10-13	1
60972	3612	4059173	1991-12-02	1992-03-01	1
55917	3314	260139	2019-01-18	2019-01-25	1
67506	3993	4112343	1966-03-23	1966-04-01	1
15578	923	40481087	2017-02-28	2017-03-07	1
82697	4916	80180	2013-01-06	2013-01-07	1
77111	4572	40481087	1981-10-22	1981-11-05	1
10271	607	4112343	1964-09-18	1964-09-27	1
64867	3839	260139	1994-07-23	1994-08-06	1
18049	1085	40481087	1968-03-23	1968-03-30	1
67465	3991	4112343	1955-06-12	1955-06-19	1
47025	2801	4112343	1985-06-25	1985-07-08	1
71406	4240	80180	1985-12-02	1985-12-03	1
78029	4628	40481087	2004-08-19	2004-09-09	1
15832	938	260139	1975-05-22	1975-05-29	1
78593	4660	80180	1998-08-12	1998-08-13	1
19162	1149	375671	2017-09-26	2017-11-25	1
13007	764	260139	1997-01-08	1997-01-15	1
74353	4418	28060	1996-10-09	1996-10-22	1
74841	4450	4310024	2006-12-30	2006-12-31	1
7163	422	4112343	1964-07-15	1964-07-25	1
69802	4134	4112343	2018-10-19	2018-10-31	1
13132	774	372328	1983-03-27	1983-09-05	1
73648	4381	260139	1972-04-23	1972-05-07	1
15494	918	372328	1913-10-07	1913-11-14	1
5007	295	4134304	1951-04-06	1951-06-05	1
79703	4725	372328	1977-03-11	1977-05-23	1
79600	4720	4310024	2012-12-03	2012-12-04	1
4743	279	372328	1956-07-25	1956-11-09	1
12048	712	440086	1988-11-03	1989-02-23	1
87262	5199	260139	1999-01-08	1999-01-22	1
79444	4712	4112343	1978-12-06	1978-12-17	1
19588	1176	4296204	1967-08-24	1967-09-28	1
16206	959	4112343	1972-01-13	1972-01-22	1
68011	4021	4112343	1999-03-14	1999-03-24	1
16617	986	260139	1934-05-27	1934-06-03	1
81920	4861	4112343	1961-05-19	1961-05-27	1
14694	867	4112343	1933-07-09	1933-07-18	1
12342	729	40481087	1996-09-21	1996-09-28	1
62070	3668	4116491	2006-08-23	2006-10-15	1
9744	578	4283893	2018-04-19	2018-05-17	1
72246	4291	40481087	2019-06-09	2019-06-10	1
75315	4476	4278672	1968-08-15	1968-11-13	1
46895	2792	4059173	1958-11-01	1958-12-01	1
22000	1318	372328	1941-05-21	1941-08-12	1
66424	3935	4112343	1957-01-04	1957-01-17	1
46672	2780	40481087	1992-11-20	1992-11-27	1
73569	4376	28060	1951-05-01	1951-05-12	1
20174	1215	257012	2006-02-24	2006-02-25	1
62180	3676	4112343	2000-05-25	2000-06-05	1
11338	670	4112343	2012-03-25	2012-04-01	1
20724	1246	40481087	1945-03-24	1945-04-07	1
77697	4607	80180	2014-12-30	2014-12-31	1
17083	1022	81893	2005-03-16	2005-03-17	1
64053	3787	40481087	1977-02-16	1977-03-09	1
9805	580	40481087	1974-09-08	1974-09-29	1
64212	3796	260139	2010-08-18	2010-09-01	1
60973	3612	4112343	1985-06-20	1985-06-28	1
55918	3314	440086	1969-09-06	1980-09-13	1
67507	3993	4112343	1988-04-17	1988-04-27	1
15579	923	260139	2000-10-21	2000-10-28	1
82698	4916	260139	1977-08-30	1977-09-06	1
77112	4572	40481087	2017-08-02	2017-08-09	1
10272	607	4112343	1973-08-24	1973-09-01	1
64868	3839	375671	1961-04-28	1961-05-28	1
18248	1099	78272	1990-02-09	1990-02-23	1
67466	3991	4112343	2002-02-19	2002-03-01	1
47026	2801	4112343	1986-12-04	1986-12-17	1
71407	4240	257012	1950-03-08	1967-06-26	1
78030	4628	80180	2004-09-05	2004-09-06	1
15833	938	260139	1993-12-21	1994-01-04	1
78594	4660	4283893	1976-07-23	1976-08-27	1
19163	1149	4134304	2007-10-21	2008-01-19	1
13008	764	40481087	2014-05-19	2014-06-02	1
74354	4418	260139	1996-12-07	1996-12-21	1
74842	4450	40481087	1973-11-23	1973-12-07	1
7164	422	4112343	1967-07-13	1967-07-22	1
69803	4134	40481087	1979-09-15	1979-10-06	1
13133	774	4112343	1969-12-08	1969-12-16	1
73649	4381	260139	1987-10-23	1987-11-06	1
15495	918	372328	1921-05-06	1921-08-05	1
5008	295	4142905	2017-02-16	2017-05-17	1
79704	4725	4278672	1975-08-19	1975-11-17	1
79601	4720	81151	2012-12-29	2013-01-19	1
4744	279	378001	2009-12-09	2010-02-07	1
12049	712	4112343	2008-07-25	2008-08-03	1
87263	5199	4029498	1976-01-13	1976-01-14	1
79445	4712	4112343	1990-02-28	1990-03-11	1
19589	1176	40481087	1993-09-15	1993-10-06	1
16207	959	40481087	1983-06-19	1983-06-26	1
68012	4021	4296204	1966-04-10	1966-05-01	1
16618	986	260139	1965-06-18	1965-07-02	1
81921	4861	4266809	1989-05-14	1989-05-15	1
14695	867	4112343	2007-12-09	2007-12-18	1
13205	778	78272	1980-12-04	1981-01-01	1
62071	3668	4218389	2001-08-26	2001-09-23	1
9745	578	40481087	2005-12-22	2006-01-05	1
72247	4291	260139	1982-12-08	1982-12-15	1
75316	4476	4296204	1990-04-06	1990-04-27	1
46896	2792	4155034	1972-03-22	1972-04-05	1
22001	1318	378419	2011-08-30	2011-08-31	1
66425	3935	4155034	1983-02-07	1983-02-21	1
46673	2780	40481087	1994-01-27	1994-02-03	1
73570	4376	4059173	1989-05-05	1989-08-03	1
20175	1215	4112343	1987-04-22	1987-04-29	1
62181	3676	4237458	1973-07-29	1973-08-28	1
11339	670	4112343	2018-05-01	2018-05-13	1
20725	1246	81151	1972-01-14	1972-01-28	1
77698	4607	4134304	1988-10-13	1988-12-12	1
17084	1022	321042	2010-02-09	2010-02-10	1
64054	3787	40481087	2000-08-02	2000-08-16	1
9806	580	40481087	1983-04-04	1983-04-18	1
64213	3796	260139	2019-03-11	2019-03-18	1
60974	3612	4112343	1989-07-08	1989-07-15	1
55919	3314	4001336	1978-11-12	1978-12-12	1
67508	3993	4112343	2008-09-23	2008-10-02	1
15580	923	372328	1961-06-29	1961-10-18	1
82699	4916	4112343	2014-04-15	2014-04-27	1
77113	4572	28060	2018-07-16	2018-07-23	1
10273	607	4134304	2001-07-20	2001-09-18	1
64869	3839	440086	1963-10-20	1964-03-22	1
18249	1099	80180	1990-07-27	1990-07-28	1
67467	3991	4112343	2004-01-24	2004-02-06	1
47027	2801	4112343	1990-02-09	1990-02-17	1
71408	4240	260139	1973-03-10	1973-03-24	1
78031	4628	372328	1970-05-05	1970-09-06	1
15834	938	4112343	1949-02-01	1949-02-12	1
78595	4660	40481087	1966-03-04	1966-03-11	1
19164	1149	372328	1980-02-24	1980-04-08	1
14469	857	0	1983-09-18	1983-09-19	1
74355	4418	260139	2018-11-29	2018-12-13	1
74843	4450	40481087	1999-10-16	1999-10-23	1
7165	422	4112343	1984-02-07	1984-02-14	1
69804	4134	40481087	1993-10-22	1993-11-05	1
13134	774	4278672	2006-11-05	2006-12-05	1
73650	4381	4112343	1980-11-19	1980-11-27	1
15496	918	4112343	1917-08-20	1917-08-27	1
5009	295	40481087	1990-06-27	1990-07-18	1
79705	4725	40481087	1997-02-24	1997-03-17	1
79602	4720	260139	1977-11-22	1977-11-29	1
4745	279	4112343	1972-06-08	1972-06-18	1
12050	712	4237458	2003-08-07	2003-10-06	1
87264	5199	4112343	1971-03-31	1971-04-11	1
79446	4712	4310024	2004-07-08	2004-07-09	1
19590	1176	40481087	1995-02-05	1995-02-19	1
16208	959	40481087	1996-11-23	1996-12-07	1
68013	4021	4296204	2010-02-09	2010-02-23	1
16619	986	260139	1968-03-23	1968-04-06	1
81922	4861	4278672	1994-01-22	1994-02-21	1
14696	867	4278672	1998-09-29	1998-11-28	1
13206	778	80180	2011-05-06	2011-05-07	1
62072	3668	4278672	1991-05-09	1991-07-08	1
9746	578	40481087	2010-05-13	2010-06-03	1
72248	4291	372328	1987-06-02	1988-01-15	1
75317	4476	4048171	1964-02-25	1964-02-26	1
46897	2792	4285898	2001-07-13	2001-07-14	1
22002	1318	4296204	2010-06-12	2010-07-03	1
66426	3935	4310024	1981-02-23	1981-02-24	1
46674	2780	0	1957-01-18	1957-01-19	1
73571	4376	4149245	1999-06-12	1999-08-18	1
20176	1215	4112343	1996-11-21	1996-12-01	1
62182	3676	40481087	1973-11-05	1973-11-26	1
11340	670	4113008	1998-08-24	1998-09-14	1
20726	1246	260139	1945-05-23	1945-06-06	1
77699	4607	40481087	1975-01-09	1975-01-16	1
17085	1022	372328	1966-02-19	1966-03-05	1
64055	3787	378001	2011-08-05	2011-09-04	1
9807	580	40481087	2016-08-10	2016-08-24	1
64214	3796	372328	1968-11-08	1969-01-21	1
60975	3612	40481087	1977-05-10	1977-05-24	1
55920	3314	4027663	1996-08-30	1996-08-31	1
67509	3993	4156265	1991-08-31	1991-09-21	1
15581	923	372328	1985-06-14	1987-02-11	1
82700	4916	40481087	2000-07-13	2000-07-20	1
77114	4572	78272	1976-11-08	1976-12-13	1
10274	607	4142905	1954-07-27	1954-08-26	1
64870	3839	4059173	1959-05-09	1959-06-08	1
18250	1099	260139	1963-07-23	1963-07-30	1
67468	3991	4283893	1954-07-19	1954-10-25	1
47028	2801	4283893	1966-03-25	1966-06-03	1
71409	4240	378419	2018-12-24	2018-12-25	1
78032	4628	372328	1971-10-31	1972-03-05	1
15835	938	4112343	1973-06-05	1973-06-17	1
78596	4660	40481087	2005-06-24	2005-07-15	1
19165	1149	40481087	1992-12-20	1992-12-27	1
14470	857	80180	1985-10-15	1985-10-16	1
74356	4418	378001	1990-10-12	1990-11-11	1
74844	4450	30753	2008-01-24	2008-01-25	1
7166	422	4112343	2011-05-15	2011-05-23	1
69805	4134	28060	1985-08-18	1985-08-29	1
13135	774	40481087	1971-05-06	1971-05-20	1
73651	4381	4112343	1993-05-26	1993-06-07	1
15497	918	4155034	1995-03-04	1995-03-25	1
5010	295	40481087	2018-04-17	2018-05-08	1
80301	4761	30753	2018-01-16	2018-01-17	1
79603	4720	260139	1993-03-12	1993-03-26	1
4746	279	4112343	2006-05-10	2006-05-21	1
12051	712	40481087	1976-01-08	1976-01-29	1
87265	5199	4134304	2011-06-08	2011-09-06	1
79447	4712	40481087	1992-10-05	1992-10-26	1
19591	1176	80180	1999-04-28	1999-04-29	1
16209	959	40481087	2002-01-16	2002-01-30	1
68014	4021	40481087	1963-05-27	1963-06-03	1
16620	986	260139	1971-09-24	1971-10-01	1
81923	4861	4283893	1955-07-24	1955-09-11	1
14697	867	40481087	1953-09-25	1953-10-16	1
13207	778	81151	1985-01-10	1985-01-31	1
64113	3790	80180	2001-11-03	2001-11-04	1
9747	578	40481087	2011-12-20	2011-12-27	1
72249	4291	4112343	1997-03-25	1997-04-04	1
75318	4476	4112343	1984-02-26	1984-03-05	1
46898	2792	4310024	1999-07-24	1999-07-25	1
22003	1318	40481087	1954-09-26	1954-10-17	1
67957	4019	28060	1968-01-04	1968-01-11	1
46675	2780	81151	1997-07-11	1997-07-25	1
73572	4376	4152936	2011-10-14	2011-11-04	1
20177	1215	4156265	1999-12-13	1999-12-27	1
62183	3676	40481087	1986-04-28	1986-05-12	1
12568	744	372328	1954-09-01	1955-03-04	1
20727	1246	260139	1947-11-06	1947-11-20	1
77700	4607	40481087	1992-02-22	1992-03-14	1
17086	1022	4112343	1973-11-09	1973-11-21	1
64056	3787	4112343	2004-07-02	2004-07-14	1
9808	580	260139	1964-05-17	1964-05-31	1
64215	3796	4112343	1969-09-05	1969-09-12	1
60976	3612	40481087	2018-01-08	2018-01-29	1
55921	3314	4112343	1966-05-21	1966-05-29	1
67510	3993	40481087	1971-07-20	1971-08-03	1
15582	923	378001	1965-04-09	1965-05-09	1
82701	4916	40481087	2013-01-11	2013-01-25	1
77115	4572	372328	1978-05-02	1978-10-17	1
10275	607	40481087	1952-01-18	1952-02-08	1
64871	3839	4112343	1979-08-06	1979-08-13	1
18251	1099	260139	1968-05-05	1968-05-12	1
67469	3991	4283893	2014-07-25	2014-09-19	1
47029	2801	40481087	1957-03-15	1957-04-05	1
71410	4240	4112343	1947-12-30	1948-01-09	1
78033	4628	4112343	1969-07-27	1969-08-07	1
15836	938	4113008	1971-04-04	1971-04-18	1
78597	4660	81151	1967-06-01	1967-06-15	1
19166	1149	372328	1981-09-30	1982-01-05	1
14471	857	321042	1983-09-18	1983-09-19	1
74357	4418	440086	1960-07-24	1961-03-12	1
74845	4450	192671	2009-03-03	2009-03-04	1
7167	422	40481087	1965-05-31	1965-06-07	1
69806	4134	81151	1955-06-16	1955-07-21	1
13136	774	4283893	1992-04-22	1992-05-27	1
73652	4381	4112343	1994-11-01	1994-11-13	1
15498	918	4218389	1989-03-07	1989-04-04	1
5724	337	28060	1980-11-02	1980-11-11	1
80302	4761	260139	2000-08-20	2000-08-27	1
79604	4720	4285898	2013-12-28	2013-12-29	1
4747	279	4294548	2002-12-29	2003-01-19	1
12052	712	28060	1977-08-25	1977-09-04	1
87266	5199	4294548	2005-03-28	2005-05-16	1
79448	4712	80180	2005-10-01	2005-10-02	1
19592	1176	260139	2002-02-24	2002-03-03	1
16210	959	28060	2017-06-01	2017-06-09	1
68015	4021	40481087	1986-08-07	1986-08-14	1
16621	986	260139	1977-07-02	1977-07-09	1
81924	4861	40481087	1995-02-11	1995-02-25	1
14698	867	81151	2018-01-17	2018-02-21	1
13208	778	81151	2001-12-03	2001-12-17	1
64114	3790	260139	1981-03-29	1981-04-05	1
9748	578	28060	1996-12-18	1996-12-28	1
72250	4291	4237458	2017-01-27	2017-02-26	1
75319	4476	4116491	1992-03-16	1992-04-18	1
46899	2792	40481087	1959-05-08	1959-05-29	1
22004	1318	40481087	1973-07-10	1973-07-17	1
67958	4019	78272	1987-10-31	1987-11-21	1
46676	2780	260139	2018-08-21	2018-08-28	1
73573	4376	4296205	1956-10-20	1956-11-24	1
20178	1215	40481087	1991-09-06	1991-09-13	1
62184	3676	0	1997-02-13	1997-02-14	1
12569	744	4112343	2017-03-06	2017-03-17	1
20728	1246	260139	1983-08-04	1983-08-11	1
77701	4607	40481087	2007-07-30	2007-08-13	1
18575	1118	80180	2014-05-19	2014-05-20	1
64057	3787	4152936	1980-11-01	1980-11-15	1
9809	580	4112343	2017-05-27	2017-06-06	1
64216	3796	4112343	2010-11-10	2010-11-23	1
62868	3718	30753	2001-11-10	2001-11-11	1
55922	3314	4112343	1970-07-10	1970-07-20	1
67511	3993	40481087	1987-12-09	1987-12-23	1
15583	923	378001	1991-02-13	1991-04-14	1
82702	4916	28060	2010-07-10	2010-07-18	1
77116	4572	4112343	1993-12-01	1993-12-13	1
10276	607	40481087	1978-02-04	1978-02-25	1
64872	3839	4294548	1962-06-20	1962-07-18	1
18252	1099	372328	1953-01-07	1953-03-21	1
67470	3991	4294548	1969-03-30	1969-08-03	1
47030	2801	40481087	1966-12-07	1966-12-28	1
71411	4240	4112343	1982-03-10	1982-03-21	1
78034	4628	4112343	1981-06-20	1981-06-29	1
15837	938	4116491	1974-07-12	1974-09-03	1
78598	4660	260139	1967-08-02	1967-08-16	1
19167	1149	4149245	1986-11-19	1986-12-26	1
14472	857	4112343	1976-07-19	1976-07-30	1
74358	4418	440448	1954-07-27	1954-07-28	1
74846	4450	257012	1969-11-11	1969-11-12	1
7168	422	192671	2001-03-04	2001-03-05	1
69807	4134	260139	1987-05-24	1987-06-07	1
13137	774	40481087	1982-08-29	1982-09-12	1
73653	4381	4237458	1973-02-22	1973-05-23	1
15499	918	4218389	1998-10-05	1998-11-09	1
5725	337	78272	2013-10-23	2013-11-27	1
80303	4761	260139	2014-06-19	2014-06-26	1
79605	4720	40481087	2018-05-15	2018-05-22	1
4748	279	40481087	1957-12-20	1958-01-10	1
12053	712	28060	1989-04-05	1989-04-16	1
87267	5199	40481087	2010-10-13	2010-11-03	1
79449	4712	260139	2007-05-25	2007-06-01	1
19593	1176	4084167	1963-10-14	1963-10-14	1
16211	959	4027663	1984-03-19	1984-03-20	1
68016	4021	40481087	2016-05-29	2016-06-12	1
16622	986	4112343	1934-06-21	1934-07-02	1
81925	4861	81893	1988-02-18	1988-02-19	1
14699	867	260139	1963-08-31	1963-09-07	1
13209	778	260139	1990-03-18	1990-03-25	1
64115	3790	4112343	1984-01-08	1984-01-17	1
9749	578	257012	2018-05-10	2018-05-11	1
72251	4291	372328	1974-02-21	1974-05-03	1
75320	4476	40481087	1996-07-19	1996-08-09	1
46900	2792	40481087	1973-09-19	1973-10-03	1
22005	1318	80180	1973-02-17	1973-02-18	1
67959	4019	260139	1992-07-22	1992-08-05	1
46677	2780	40481087	1962-06-05	1962-06-19	1
73574	4376	40481087	1921-07-03	1921-07-17	1
20179	1215	40481087	2014-12-19	2015-01-02	1
62185	3676	260139	1975-10-19	1975-11-02	1
12570	744	4166224	2004-03-17	2004-03-18	1
20729	1246	372328	1939-04-16	1939-07-28	1
77702	4607	40481087	2011-09-27	2011-10-04	1
18576	1118	4051466	1976-08-18	1992-11-22	1
64058	3787	4329847	2016-08-27	2016-08-28	1
9810	580	40481087	1929-03-05	1929-03-12	1
64217	3796	4156265	1986-05-22	1986-06-05	1
62869	3718	372328	1966-03-24	1966-07-04	1
55923	3314	4112343	1990-09-04	1990-09-11	1
67512	3993	28060	1965-04-15	1965-04-23	1
15584	923	4112343	2012-10-27	2012-11-08	1
82703	4916	260139	2005-05-27	2005-06-10	1
77117	4572	4112343	1994-03-15	1994-03-23	1
10277	607	40481087	1993-07-24	1993-08-14	1
64873	3839	40481087	1951-03-29	1951-04-05	1
18253	1099	4112343	1982-12-14	1982-12-22	1
67471	3991	40481087	1962-07-20	1962-08-10	1
47031	2801	40481087	2000-09-09	2000-09-30	1
71412	4240	4156265	1981-11-21	1981-12-05	1
78035	4628	4112343	1992-10-31	1992-11-09	1
15838	938	4146173	2002-08-01	2002-09-30	1
78599	4660	260139	1989-01-02	1989-01-16	1
19168	1149	4296205	2011-11-29	2011-12-27	1
14473	857	4146173	1975-05-31	1975-06-30	1
74359	4418	4112343	1961-06-23	1961-07-02	1
74847	4450	260139	2000-08-28	2000-09-04	1
7169	422	257012	2015-01-31	2015-02-01	1
69808	4134	260139	2017-06-13	2017-06-20	1
13138	774	40481087	1984-09-09	1984-09-23	1
73654	4381	40481087	1995-01-15	1995-01-22	1
15500	918	4237458	1928-01-22	1928-04-21	1
5726	337	80180	1997-07-30	1997-07-31	1
80304	4761	40481087	1988-04-02	1988-04-23	1
79606	4720	80180	2014-01-27	2014-01-28	1
4749	279	40481087	1970-08-11	1970-09-01	1
12054	712	260139	2011-07-27	2011-08-03	1
87268	5199	0	1976-01-13	1976-01-14	1
79450	4712	313217	2017-03-17	2017-03-18	1
19594	1176	4112343	1988-01-24	1988-02-01	1
16212	959	4113008	1969-05-27	1969-06-17	1
68017	4021	81151	2016-06-21	2016-07-05	1
16623	986	40481087	1942-07-10	1942-07-31	1
81926	4861	260139	1958-08-31	1958-09-14	1
14700	867	260139	1986-05-07	1986-05-21	1
13210	778	260139	2008-01-22	2008-02-05	1
64116	3790	4283893	2019-01-31	2019-03-07	1
9750	578	260139	1996-10-06	1996-10-20	1
72252	4291	80180	2016-08-29	2016-08-30	1
75321	4476	40481087	2009-01-25	2009-02-08	1
46901	2792	28060	1968-12-28	1969-01-04	1
22006	1318	81151	1948-06-13	1948-07-11	1
67960	4019	4027663	1996-11-18	1996-11-19	1
46678	2780	28060	1958-12-30	1959-01-11	1
73575	4376	40481087	1948-02-12	1948-02-19	1
20180	1215	80180	2009-04-19	2009-04-20	1
62186	3676	321042	1997-02-13	1997-02-14	1
12571	744	372328	1957-11-18	1958-03-14	1
20730	1246	378419	2012-11-02	2012-11-03	1
77703	4607	40481087	2018-07-31	2018-08-14	1
18577	1118	40481087	2014-02-19	2014-03-12	1
64059	3787	40481087	1976-12-29	1977-01-12	1
9811	580	40481087	1996-11-10	1996-11-17	1
64218	3796	40481087	1969-09-10	1969-09-24	1
62870	3718	372328	1970-10-11	1971-10-11	1
55924	3314	4112343	1995-03-22	1995-04-03	1
67513	3993	260139	1947-07-06	1947-07-13	1
15585	923	40481087	1986-05-26	1986-06-16	1
82704	4916	4156265	1978-06-24	1978-07-08	1
77118	4572	4296204	2008-04-25	2008-05-30	1
11683	691	28060	1959-05-07	1959-05-14	1
64874	3839	40481087	1980-08-14	1980-09-04	1
18254	1099	4112343	1997-10-15	1997-10-26	1
67472	3991	257012	1971-02-23	2005-01-20	1
47032	2801	28060	1926-04-30	1926-05-08	1
71413	4240	4296204	1943-06-11	1943-07-16	1
78036	4628	40481087	1971-06-24	1971-07-01	1
15839	938	4230399	1952-05-13	1952-07-12	1
78600	4660	4112343	1968-07-26	1968-08-06	1
19169	1149	40481087	1983-09-12	1983-10-03	1
14474	857	4283893	1981-02-23	1981-06-15	1
74360	4418	4112343	2012-03-25	2012-04-05	1
74848	4450	4035415	1976-11-22	1977-01-21	1
7170	422	372328	1983-01-04	1984-02-18	1
69809	4134	4109685	1956-07-15	1956-07-29	1
13139	774	40481087	2012-05-05	2012-05-12	1
73655	4381	40481087	2000-03-02	2000-03-09	1
15501	918	40481087	2003-05-15	2003-05-22	1
5727	337	260139	1986-02-04	1986-02-18	1
80305	4761	260139	1989-12-31	1990-01-14	1
79607	4720	192671	2014-04-25	2014-04-26	1
4750	279	40481087	1996-10-19	1996-11-02	1
12055	712	40481087	2010-03-17	2010-04-07	1
87269	5199	80180	2001-03-27	2001-03-28	1
79451	4712	4027663	1998-01-11	1998-01-12	1
19595	1176	4112343	2011-10-30	2011-11-07	1
16213	959	4285898	1994-10-03	1994-10-04	1
68018	4021	372328	1955-02-11	1955-04-20	1
16624	986	40481087	1969-04-07	1969-04-28	1
81927	4861	260139	2017-09-10	2017-09-17	1
14701	867	317576	2014-08-12	2014-08-13	1
13211	778	4112343	1994-02-06	1994-02-14	1
64117	3790	40481087	1976-03-24	1976-04-14	1
9751	578	378001	1976-11-09	1977-01-08	1
72253	4291	4109685	1994-11-03	1994-11-24	1
75322	4476	0	1975-05-04	1975-05-05	1
46902	2792	372328	1975-05-12	1976-02-16	1
22007	1318	260139	1942-06-16	1942-06-23	1
67961	4019	4112343	1985-10-20	1985-10-27	1
46679	2780	81151	2014-10-24	2014-11-14	1
73576	4376	40481087	1973-03-09	1973-03-23	1
20181	1215	192671	2009-06-07	2009-06-08	1
62187	3676	40481087	1994-09-19	1994-09-26	1
12572	744	4112343	1963-01-14	1963-01-22	1
20731	1246	4059173	1969-09-26	1969-11-25	1
78510	4655	260139	1993-06-14	1993-06-21	1
18578	1118	0	1983-08-10	1983-08-11	1
65263	3864	80180	2007-12-16	2007-12-17	1
9812	580	80180	1962-07-16	1962-07-17	1
64219	3796	40481087	1982-03-16	1982-03-23	1
62871	3718	80180	2002-03-10	2002-03-11	1
55925	3314	4310024	2002-04-26	2002-04-27	1
67514	3993	260139	1976-08-11	1976-08-25	1
15586	923	40481087	1998-10-16	1998-11-06	1
82705	4916	40481087	1991-02-24	1991-03-10	1
80219	4758	0	1989-08-13	1989-08-14	1
11684	691	28060	1999-05-24	1999-06-01	1
64875	3839	40481087	1984-09-20	1984-10-04	1
18255	1099	4155034	2018-10-24	2018-11-07	1
67473	3991	260139	1994-01-17	1994-01-31	1
47033	2801	28060	1928-12-24	1929-01-02	1
71414	4240	40481087	1963-10-23	1963-11-13	1
78037	4628	40481087	1988-04-09	1988-04-16	1
15840	938	4278672	2015-10-22	2015-11-21	1
78601	4660	40481087	1964-03-24	1964-04-07	1
19429	1169	0	2012-02-20	2012-02-21	1
14475	857	4294548	1992-09-14	1992-10-12	1
74361	4418	4113008	1994-07-23	1994-08-06	1
74849	4450	4112343	1980-05-29	1980-06-07	1
7171	422	4116491	1982-01-04	1982-02-07	1
69810	4134	4146173	1981-06-18	1981-07-18	1
15587	924	372328	1969-06-28	1970-05-24	1
73656	4381	40481087	2007-02-09	2007-02-16	1
16699	992	257012	1957-10-19	1957-10-20	1
5728	337	440086	1973-09-19	1977-09-28	1
80306	4761	4237458	1998-01-01	1998-01-31	1
79608	4720	4283893	1995-11-05	1996-06-02	1
4751	279	81151	1968-10-01	1968-10-15	1
13455	795	28060	1940-03-02	1940-03-14	1
87270	5199	260139	2005-06-06	2005-06-20	1
79452	4712	40481087	1972-10-03	1972-10-17	1
19596	1176	4285898	1998-10-30	1998-10-31	1
16214	959	40481087	1961-06-16	1961-07-07	1
68019	4021	4112343	1970-10-02	1970-10-15	1
16625	986	40481087	1982-06-10	1982-06-17	1
81928	4861	4112343	1995-12-03	1995-12-12	1
14702	867	378419	2012-07-31	2012-08-01	1
13212	778	4278672	1988-03-16	1988-06-14	1
64118	3790	260139	2005-05-01	2005-05-08	1
9752	578	4155034	2005-10-27	2005-11-10	1
72254	4291	4230399	1978-09-28	1978-12-27	1
75323	4476	195588	1989-02-11	1989-03-17	1
46903	2792	4059173	1994-01-10	1994-04-10	1
22008	1318	260139	1944-05-13	1944-05-27	1
67962	4019	4112343	2012-02-22	2012-03-02	1
46680	2780	192671	2001-12-20	2001-12-21	1
73577	4376	40481087	1983-12-24	1984-01-14	1
20182	1215	381316	1993-05-08	1993-05-09	1
62188	3676	260139	1978-05-22	1978-05-29	1
12573	744	4112343	1963-04-26	1963-05-08	1
20732	1246	4112343	1954-05-28	1954-06-08	1
78511	4655	4112343	1974-01-19	1974-01-26	1
18579	1118	4029498	1983-08-10	1983-08-11	1
65264	3864	260139	1966-11-03	1966-11-17	1
9813	580	81151	2011-08-05	2011-08-19	1
64220	3796	260139	1973-09-14	1973-09-28	1
62872	3718	260139	1989-08-01	1989-08-08	1
55926	3314	40481087	1993-03-01	1993-03-08	1
67515	3993	260139	1991-06-24	1991-07-01	1
16891	1005	260139	2008-10-15	2008-10-22	1
82706	4916	40481087	2000-05-28	2000-06-04	1
80220	4758	260139	1967-01-22	1967-01-29	1
11685	691	40481087	1980-02-20	1980-02-27	1
64876	3839	80180	1994-06-24	1994-06-25	1
18256	1099	40481087	1955-04-05	1955-04-19	1
67474	3991	378001	2000-12-14	2001-01-13	1
47034	2801	255848	2002-04-05	2002-04-06	1
71415	4240	40481087	1971-08-26	1971-09-02	1
78038	4628	40481087	1999-03-26	1999-04-09	1
15841	938	40481087	1990-04-13	1990-05-04	1
78602	4660	40481087	1999-02-22	1999-03-08	1
19430	1169	78272	1952-02-08	1952-03-07	1
14476	857	40481087	1979-12-11	1979-12-25	1
74362	4418	4218389	2003-02-20	2003-03-20	1
74850	4450	4112343	1997-07-24	1997-08-03	1
7172	422	4116491	1984-02-07	1984-04-01	1
69811	4134	4237458	1959-08-13	1959-10-12	1
15588	924	4112343	1992-08-12	1992-08-22	1
73657	4381	40481087	2013-08-01	2013-08-15	1
16700	992	4112343	2000-07-04	2000-07-11	1
5729	337	4059173	1962-06-09	1962-09-07	1
80307	4761	4280726	1984-05-11	1984-05-12	1
79609	4720	40481087	2006-08-17	2006-09-07	1
4752	279	260139	1965-12-05	1965-12-12	1
13456	795	80180	1982-08-23	1982-08-24	1
87271	5199	372328	1966-08-23	1966-10-18	1
79453	4712	40481087	1973-02-21	1973-03-14	1
19597	1176	40481087	1998-05-31	1998-06-14	1
16215	959	80180	1995-01-31	1995-02-01	1
68020	4021	4134304	1961-09-03	1961-11-02	1
16626	986	80180	1951-11-04	1951-11-05	1
81929	4861	4230399	2008-05-09	2008-06-08	1
14703	867	4134304	2002-06-10	2002-09-08	1
13213	778	40481087	1984-12-22	1984-12-29	1
64119	3790	372328	1965-05-21	1965-06-04	1
9753	578	4237458	1970-01-15	1970-04-15	1
72255	4291	40481087	1979-11-29	1979-12-13	1
75324	4476	260139	2008-08-03	2008-08-10	1
46904	2792	4112343	1959-09-28	1959-10-06	1
22009	1318	260139	1997-10-24	1997-11-07	1
67963	4019	4266809	2005-04-30	2005-05-01	1
46681	2780	260139	1979-05-05	1979-05-12	1
73578	4376	28060	1971-09-27	1971-10-06	1
20183	1215	4112343	1990-03-15	1990-03-24	1
62189	3676	260139	1997-03-31	1997-04-14	1
12574	744	4156265	2017-08-29	2017-09-19	1
20733	1246	4112343	1986-12-03	1986-12-13	1
78512	4655	4296204	1980-01-14	1980-02-04	1
18580	1118	4218389	2001-02-21	2001-03-21	1
65265	3864	260139	1974-08-08	1974-08-15	1
9814	580	260139	2017-04-29	2017-05-13	1
64221	3796	372328	2019-02-28	2019-03-01	1
62873	3718	378001	2017-05-07	2017-07-06	1
55927	3314	40481087	1993-07-14	1993-07-21	1
67516	3993	4116491	1965-02-02	1965-03-08	1
16892	1005	28060	1969-09-09	1969-09-18	1
82707	4916	260139	1989-05-06	1989-05-20	1
80221	4758	260139	2013-06-09	2013-06-16	1
11686	691	40481087	1985-11-18	1985-11-25	1
64877	3839	81151	1970-08-09	1970-09-13	1
18257	1099	40481087	1963-11-11	1963-12-02	1
67475	3991	4112343	1981-08-23	1981-09-05	1
47035	2801	260139	1930-08-06	1930-08-13	1
71416	4240	40481087	2011-05-13	2011-05-27	1
78039	4628	40481087	2000-01-10	2000-01-17	1
15842	938	260139	2017-05-22	2017-06-05	1
78603	4660	81151	1989-07-19	1989-08-23	1
19431	1169	260139	1944-09-09	1944-09-23	1
14477	857	40481087	1997-08-22	1997-08-29	1
74363	4418	40481087	2003-10-05	2003-10-12	1
74851	4450	4112343	2004-02-02	2004-02-15	1
7173	422	40481087	1959-10-16	1959-10-23	1
69812	4134	40481087	1961-07-09	1961-07-30	1
15589	924	4156265	1987-06-15	1987-06-29	1
73658	4381	372328	1965-03-29	1965-05-11	1
16701	992	4112343	2004-09-19	2004-09-30	1
5730	337	4156265	2018-11-01	2018-11-22	1
80308	4761	80180	2018-12-12	2018-12-13	1
80354	4764	80180	2007-01-29	2007-01-30	1
4753	279	260139	1967-03-18	1967-04-01	1
13457	795	4112343	1954-02-18	1954-02-27	1
87272	5199	40481087	1978-04-28	1978-05-19	1
79454	4712	40481087	2019-03-31	2019-04-21	1
19598	1176	40481087	2011-05-07	2011-05-14	1
16216	959	372328	1962-07-16	1963-03-06	1
68021	4021	40481087	1962-03-13	1962-03-27	1
16627	986	260139	1932-02-09	1932-02-16	1
81930	4861	40481087	1956-07-16	1956-07-30	1
14704	867	4146173	1937-02-07	1937-03-09	1
13214	778	40481087	1987-08-24	1987-09-14	1
64120	3790	372328	1966-06-29	1966-12-05	1
9754	578	40481087	2009-02-27	2009-03-13	1
72256	4291	40481087	2015-01-18	2015-01-25	1
75325	4476	321042	1975-05-04	1975-05-05	1
46905	2792	4112343	2011-02-26	2011-03-11	1
22010	1318	260139	2014-06-20	2014-07-04	1
67964	4019	40481087	1984-12-31	1985-01-07	1
46682	2780	260139	1993-12-13	1993-12-20	1
73579	4376	192671	1961-02-23	1961-02-24	1
20184	1215	4112343	2008-08-31	2008-09-07	1
62190	3676	260139	2005-07-07	2005-07-21	1
12575	744	4283893	2007-09-23	2007-11-11	1
20734	1246	4134304	2005-07-24	2005-08-23	1
78513	4655	40481087	1968-07-30	1968-08-06	1
18581	1118	4266809	2014-05-19	2014-05-20	1
65266	3864	260139	2003-05-25	2003-06-01	1
9815	580	372328	1930-03-05	1930-08-31	1
64222	3796	375671	2012-03-02	2012-05-01	1
62874	3718	4112343	1977-02-27	1977-03-08	1
55928	3314	28060	1980-04-30	1980-05-10	1
67517	3993	4146173	1942-01-01	1942-01-31	1
16893	1005	4051466	1970-02-27	1986-07-22	1
82708	4916	4059173	1990-03-07	1990-04-06	1
80222	4758	321042	1989-08-13	1989-08-14	1
11687	691	40481087	2004-04-24	2004-05-15	1
64878	3839	4027663	1981-10-15	1981-10-16	1
18258	1099	81151	1983-08-24	1983-09-14	1
67476	3991	4278672	1958-01-29	1958-03-30	1
47036	2801	378001	1927-02-26	1927-04-27	1
71417	4240	260139	1981-05-26	1981-06-09	1
78040	4628	40481087	2002-05-13	2002-05-27	1
15843	938	4112343	1990-06-01	1990-06-13	1
78604	4660	260139	1995-11-24	1995-12-08	1
19432	1169	321042	2012-02-20	2012-02-21	1
14478	857	28060	1954-07-22	1954-07-30	1
74364	4418	40481087	2008-11-20	2008-12-04	1
74852	4450	28060	1982-06-28	1982-07-09	1
7174	422	28060	2016-04-28	2016-05-11	1
69813	4134	40481087	1990-11-15	1990-11-29	1
15590	924	4296205	1998-04-01	1998-05-07	1
73659	4381	40479422	1965-04-28	1965-06-04	1
16702	992	4296204	2015-03-29	2015-05-03	1
5731	337	40481087	1978-12-05	1978-12-19	1
80309	4761	4027663	2011-04-28	2011-04-29	1
80355	4764	260139	1998-07-17	1998-07-31	1
4754	279	260139	1971-02-06	1971-02-13	1
13458	795	4112343	1956-10-18	1956-10-28	1
87273	5199	40481087	1980-09-12	1980-09-26	1
79455	4712	260139	2013-02-28	2013-03-07	1
19599	1176	40481087	2014-09-02	2014-09-09	1
16217	959	4048171	1963-04-01	1977-03-30	1
68022	4021	40481087	1974-04-13	1974-05-04	1
16628	986	4283893	1932-01-09	1932-06-25	1
81931	4861	40481087	1962-08-05	1962-08-12	1
14705	867	4237458	2005-04-25	2005-07-24	1
13215	778	40481087	2011-08-10	2011-08-24	1
64121	3790	4112343	1983-09-29	1983-10-06	1
9755	578	40481087	2010-11-06	2010-11-20	1
74907	4454	78272	2000-05-07	2000-05-28	1
75326	4476	4156265	2001-12-25	2002-01-15	1
46906	2792	4278672	1961-09-16	1961-11-15	1
22011	1318	4112343	1950-04-18	1950-04-27	1
67965	4019	40481087	1997-03-24	1997-03-31	1
46683	2780	372328	1956-02-17	1956-04-25	1
73580	4376	261325	1975-07-01	1975-07-02	1
20185	1215	4134304	1998-09-19	1998-11-18	1
62191	3676	40481087	1975-12-24	1976-01-14	1
12576	744	40481087	1958-04-02	1958-04-16	1
20735	1246	260139	1950-06-13	1950-06-20	1
78514	4655	40481087	1996-05-04	1996-05-25	1
18582	1118	4310024	2011-12-01	2011-12-02	1
65267	3864	4112343	1998-11-16	1998-11-27	1
9816	580	378001	2017-04-19	2017-06-18	1
64223	3796	4155034	1992-10-31	1992-11-21	1
62875	3718	81893	2001-10-11	2001-10-12	1
55929	3314	28060	1989-06-24	1989-07-07	1
67518	3993	4296205	1974-07-03	1974-07-31	1
16894	1005	4112343	1970-04-20	1970-04-30	1
82709	4916	4112343	1981-01-13	1981-01-25	1
80223	4758	372328	1958-05-08	1958-06-15	1
11688	691	40481087	2006-09-09	2006-09-23	1
64879	3839	4134304	1972-08-03	1972-10-02	1
18259	1099	260139	1955-02-27	1955-03-06	1
67477	3991	4283893	2004-12-30	2005-01-20	1
47037	2801	4027663	1955-02-09	1955-02-10	1
71418	4240	440448	1965-07-16	1965-07-17	1
80043	4750	4112343	1973-11-29	1973-12-12	1
15844	938	40481087	1957-10-11	1957-10-18	1
78605	4660	40481087	1976-10-02	1976-10-09	1
19433	1169	4112343	1955-01-12	1955-01-25	1
14479	857	258780	1990-03-11	1990-03-12	1
74365	4418	40481087	2015-10-04	2015-10-18	1
74853	4450	4283893	1969-10-07	1969-12-09	1
7175	422	80180	2000-12-20	2000-12-21	1
69814	4134	40481087	2003-09-22	2003-10-13	1
15591	924	40481087	1968-12-22	1969-01-12	1
73660	4381	40481087	1975-10-26	1975-11-16	1
16703	992	40481087	1957-02-24	1957-03-10	1
5732	337	40481087	2012-12-30	2013-01-13	1
80310	4761	4218389	2008-03-23	2008-04-13	1
80356	4764	4112343	1991-10-01	1991-10-13	1
4755	279	375671	1992-12-08	1993-02-06	1
13459	795	40481087	2011-07-23	2011-07-30	1
87274	5199	40481087	2007-12-08	2007-12-22	1
79456	4712	440448	1972-01-20	1972-01-21	1
19600	1176	81893	1997-07-07	1997-07-08	1
16218	959	40481087	2014-10-01	2014-10-22	1
68023	4021	40481087	1994-06-08	1994-06-15	1
16629	986	40481087	1921-08-12	1921-08-26	1
81932	4861	40481087	1977-10-30	1977-11-06	1
14706	867	40481087	1933-03-14	1933-04-04	1
13216	778	372328	1978-07-18	1978-09-28	1
64122	3790	4310024	1999-05-18	1999-05-19	1
9756	578	40486433	1971-06-06	1971-06-07	1
74908	4454	375671	1946-03-10	1946-05-09	1
75327	4476	4283893	1965-09-04	1965-09-18	1
46907	2792	40481087	1981-04-01	1981-04-15	1
22012	1318	40481087	1940-08-28	1940-09-04	1
67966	4019	40481087	2018-11-02	2018-11-16	1
46684	2780	4112343	1958-10-17	1958-10-28	1
73581	4376	4112343	2009-01-08	2009-01-15	1
20186	1215	4296204	2001-12-16	2002-01-06	1
62192	3676	40481087	1989-10-01	1989-10-08	1
12577	744	40481087	1979-07-23	1979-08-13	1
20736	1246	260139	1971-09-30	1971-10-07	1
78515	4655	28060	1962-12-09	1962-12-19	1
18583	1118	40481087	2007-10-03	2007-10-17	1
65268	3864	40481087	1996-02-24	1996-03-09	1
9817	580	4112343	1930-12-17	1930-12-26	1
64224	3796	4237458	2003-08-26	2003-11-24	1
62876	3718	4043241	2016-10-31	2016-11-01	1
55930	3314	260139	1986-08-05	1986-08-12	1
67519	3993	40481087	1946-10-16	1946-11-06	1
16895	1005	40481087	1979-06-06	1979-06-13	1
82710	4916	4112343	1988-04-22	1988-05-02	1
80224	4758	378001	1965-11-27	1965-12-27	1
11689	691	40481087	2009-06-15	2009-06-22	1
64880	3839	4310024	1991-05-11	1991-05-12	1
18260	1099	260139	2007-05-23	2007-06-06	1
67478	3991	40481087	1956-01-24	1956-02-14	1
47038	2801	4218389	1928-02-21	1928-03-20	1
71419	4240	4112343	1945-12-30	1946-01-06	1
80044	4750	4112343	1998-11-13	1998-11-26	1
15845	938	40481087	1979-08-30	1979-09-20	1
78606	4660	40481087	1990-12-06	1990-12-27	1
19434	1169	4155034	1982-01-30	1982-02-13	1
14480	857	372328	1954-02-20	1954-08-08	1
76192	4526	28060	1997-07-29	1997-08-10	1
74854	4450	40481087	1985-08-14	1985-08-21	1
7176	422	80502	2019-04-27	2019-04-28	1
69815	4134	78272	2014-09-23	2014-10-07	1
15592	924	40481087	1980-02-11	1980-03-03	1
73661	4381	260139	1992-08-29	1992-09-12	1
16704	992	40481087	1990-11-23	1990-12-14	1
5733	337	260139	1991-08-06	1991-08-13	1
80311	4761	4296204	2002-02-09	2002-02-23	1
80357	4764	4112343	2013-12-27	2014-01-05	1
4756	279	4112343	1964-07-07	1964-07-19	1
13460	795	28060	1950-05-25	1950-06-05	1
88756	5283	80180	2011-02-08	2011-02-09	1
79457	4712	40481087	1979-11-13	1979-12-04	1
19601	1176	260139	1971-02-06	1971-02-20	1
16358	969	4146173	2004-07-31	2004-10-06	1
68024	4021	81151	1957-08-29	1957-09-19	1
16630	986	40481087	1953-03-11	1953-04-01	1
83245	4952	260139	1975-02-07	1975-02-21	1
14707	867	40481087	2010-01-23	2010-01-30	1
13217	778	4112343	1980-11-05	1980-11-12	1
64123	3790	40481087	1969-09-06	1969-09-20	1
9757	578	28060	1979-05-31	1979-06-08	1
74909	4454	4109685	1945-04-30	1945-05-14	1
75328	4476	40481087	1964-05-15	1964-06-05	1
46908	2792	40481087	2014-07-10	2014-07-17	1
22013	1318	40481087	1987-11-27	1987-12-18	1
67967	4019	80180	2005-04-30	2005-05-01	1
46685	2780	4112343	2013-02-27	2013-03-07	1
73582	4376	4230399	2010-09-19	2010-10-19	1
20187	1215	40481087	1976-10-11	1976-10-18	1
62193	3676	40481087	2009-02-13	2009-02-20	1
12578	744	0	2004-03-17	2004-03-18	1
20737	1246	260139	1985-11-30	1985-12-14	1
78516	4655	372328	2006-10-03	2008-07-13	1
18584	1118	40481087	2019-06-21	2019-06-22	1
65269	3864	40481087	1999-05-28	1999-06-11	1
9818	580	40481087	1943-02-10	1943-02-17	1
64225	3796	40481087	2005-08-28	2005-09-18	1
62877	3718	4237458	1974-08-07	1974-10-06	1
55931	3314	260139	1999-08-01	1999-08-08	1
67520	3993	40481087	1971-11-06	1971-11-13	1
16896	1005	40481087	1990-09-05	1990-09-19	1
82711	4916	4112343	2013-06-04	2013-06-17	1
80225	4758	4112343	1994-09-11	1994-09-18	1
11690	691	28060	1999-09-30	1999-10-08	1
64881	3839	40481087	1952-02-08	1952-02-29	1
18261	1099	378001	1967-07-23	1967-09-21	1
67479	3991	40481087	1968-06-14	1968-06-28	1
47039	2801	4294548	1923-06-17	1923-06-24	1
71420	4240	4218389	1946-05-01	1946-05-29	1
80045	4750	4116491	1997-04-01	1997-05-07	1
19132	1148	80180	2001-07-01	2001-07-02	1
78607	4660	40481087	2000-04-06	2000-04-27	1
19435	1169	40481087	1956-09-15	1956-10-06	1
14481	857	4112343	1960-02-02	1960-02-12	1
76193	4526	260139	1962-10-23	1962-11-06	1
74855	4450	40481087	2008-03-16	2008-03-23	1
7177	422	260139	1976-12-08	1976-12-22	1
69816	4134	81151	1953-05-13	1953-05-27	1
15593	924	28060	1995-08-11	1995-08-20	1
73662	4381	372328	1967-11-05	1968-05-07	1
16705	992	40481087	2002-01-22	2002-02-05	1
5734	337	372328	1960-01-21	1960-03-02	1
80312	4761	28060	1989-03-23	1989-04-03	1
80358	4764	40481087	1974-10-08	1974-10-15	1
4757	279	4155034	2012-02-27	2012-03-19	1
13461	795	28060	2018-12-17	2018-12-26	1
88757	5283	260139	1982-06-16	1982-06-23	1
79458	4712	40481087	2013-05-15	2013-05-22	1
19602	1176	372328	1964-10-08	1965-03-26	1
16359	969	40481087	2014-12-03	2014-12-24	1
68025	4021	134438	1984-01-12	1985-11-02	1
16631	986	40481087	1975-06-05	1975-06-12	1
83246	4952	260139	1978-05-12	1978-05-19	1
15345	911	260139	1986-01-16	1986-01-30	1
13218	778	40481087	1990-10-06	1990-10-13	1
64124	3790	28060	2001-02-05	2001-02-18	1
9758	578	78272	2001-12-19	2002-01-16	1
74910	4454	4112343	1964-05-21	1964-05-29	1
75329	4476	40481087	1981-12-29	1982-01-05	1
48776	2893	80180	1985-08-05	1985-08-06	1
22014	1318	40481087	1991-02-09	1991-02-23	1
67968	4019	4109685	1979-12-28	1980-01-11	1
46686	2780	40481087	1956-09-22	1956-09-29	1
73583	4376	40481087	2000-02-13	2000-02-20	1
20188	1215	372328	1975-04-23	1975-09-06	1
62194	3676	40481087	2011-01-18	2011-01-25	1
12579	744	28060	2009-11-03	2009-11-10	1
20738	1246	260139	2005-04-12	2005-04-19	1
78517	4655	4027663	1983-12-08	1983-12-09	1
18585	1118	192671	2014-07-07	2014-07-08	1
65270	3864	81151	1978-08-30	1978-10-04	1
9819	580	40481087	1956-10-16	1956-10-23	1
64226	3796	80180	2007-05-23	2007-05-24	1
62878	3718	40481087	1987-12-05	1987-12-12	1
55932	3314	372328	1964-01-30	1964-02-13	1
67521	3993	40481087	1983-07-20	1983-07-27	1
16897	1005	378001	2011-01-08	2011-02-07	1
82712	4916	4112343	2017-12-11	2017-12-18	1
80226	4758	4278672	1999-11-11	2000-02-09	1
11691	691	80180	1994-12-20	1994-12-21	1
64882	3839	40481087	1957-04-12	1957-04-26	1
18262	1099	4266809	1990-07-27	1990-07-28	1
67480	3991	40481087	1971-09-05	1971-09-26	1
47040	2801	4296204	1985-03-26	1985-04-23	1
71421	4240	4294548	1967-04-03	1967-06-26	1
80046	4750	40481087	1975-02-26	1975-03-19	1
19133	1148	81151	1965-12-07	1966-01-11	1
78608	4660	40481087	1983-05-14	1983-05-28	1
19436	1169	40481087	1975-05-05	1975-05-19	1
14482	857	4113008	1979-02-09	1979-02-23	1
76194	4526	260139	1968-04-03	1968-04-17	1
80902	4804	80180	2013-06-25	2013-06-26	1
7178	422	4112343	1972-09-25	1972-10-04	1
69817	4134	260139	1972-01-06	1972-01-13	1
15594	924	375671	2017-10-08	2017-11-06	1
73663	4381	4112343	1965-02-28	1965-03-10	1
16706	992	260139	1971-09-14	1971-09-21	1
5735	337	4109685	1965-09-21	1965-10-05	1
80313	4761	260139	1986-08-03	1986-08-17	1
80359	4764	40481087	1983-07-07	1983-07-21	1
4758	279	4294548	2001-12-13	2001-12-27	1
13462	795	81893	1980-04-05	1980-04-06	1
88758	5283	260139	1989-06-28	1989-07-12	1
79459	4712	0	1972-01-20	1972-01-21	1
19603	1176	4027663	1989-10-12	1989-10-13	1
16360	969	28060	1979-05-05	1979-05-18	1
68026	4021	4112343	1987-10-03	1987-10-11	1
16632	986	28060	1926-11-20	1926-11-29	1
83247	4952	4035415	1979-06-02	1979-07-02	1
15346	911	378001	2009-06-12	2009-07-12	1
13219	778	40481087	1995-04-27	1995-05-04	1
64125	3790	378001	1983-10-14	1983-12-13	1
9759	578	80180	2001-12-08	2001-12-09	1
74911	4454	4134304	1998-02-17	1998-04-18	1
75330	4476	40481087	1990-01-01	1990-01-15	1
48777	2893	81151	1997-08-06	1997-09-03	1
22015	1318	40481087	1998-01-24	1998-02-14	1
67969	4019	4112343	1973-07-15	1973-07-23	1
46687	2780	40481087	2014-07-26	2014-08-09	1
75038	4462	372328	1955-12-30	1956-04-12	1
20189	1215	40481087	1987-07-30	1987-08-20	1
62195	3676	80180	2015-09-22	2015-09-23	1
12580	744	80180	1994-07-01	1994-07-02	1
20739	1246	4027663	1969-08-11	1969-08-12	1
78518	4655	4112343	1962-10-27	1962-11-06	1
18586	1118	195588	2000-08-05	2000-11-15	2
65271	3864	372328	1969-03-20	1969-11-22	1
9820	580	40481087	1975-10-01	1975-10-08	1
64227	3796	81151	1971-12-23	1972-01-06	1
62879	3718	78272	1972-09-18	1972-10-16	1
55933	3314	4112343	1999-12-11	1999-12-19	1
67522	3993	40481087	2010-08-16	2010-09-06	1
16898	1005	4283893	2004-07-12	2004-08-09	1
82713	4916	40481087	2003-10-12	2003-10-26	1
80227	4758	372328	1962-09-22	1963-02-17	1
11692	691	81151	1971-07-20	1971-08-03	1
64883	3839	40481087	1974-04-27	1974-05-11	1
18263	1099	4285898	1990-02-27	1990-02-28	1
67481	3991	40481087	1988-08-06	1988-08-20	1
47041	2801	30753	1964-11-28	1964-11-29	1
71422	4240	40481087	1958-05-05	1958-05-26	1
80047	4750	40481087	2008-10-28	2008-11-04	1
19134	1148	4059173	1967-09-03	1967-10-03	1
78609	4660	40481087	1990-04-27	1990-05-04	1
19437	1169	40481087	1997-06-11	1997-06-25	1
14483	857	195588	1981-02-23	1981-04-13	1
76195	4526	260139	1989-02-04	1989-02-18	1
80903	4804	260139	2006-09-16	2006-09-23	1
7179	422	4112343	1993-01-29	1993-02-08	1
69818	4134	260139	2019-05-13	2019-05-20	1
15595	924	4059173	2013-09-29	2013-12-27	1
73664	4381	40481087	1970-09-07	1970-09-14	1
16707	992	260139	1987-07-01	1987-07-15	1
5736	337	40481087	1985-02-22	1985-03-01	1
80314	4761	372328	1981-09-27	1981-10-11	1
80360	4764	40481087	2010-12-31	2011-01-14	1
4759	279	40481087	1956-04-14	1956-04-21	1
13463	795	260139	1978-02-20	1978-02-27	1
88759	5283	4112343	1999-03-20	1999-03-29	1
79460	4712	81151	1988-03-04	1988-03-18	1
19604	1176	4084167	1981-09-13	1981-09-13	1
16361	969	80180	2014-07-17	2014-07-18	1
68027	4021	40481087	1965-11-28	1965-12-19	1
16633	986	28060	1967-05-23	1967-06-04	1
83248	4952	4112343	2009-02-25	2009-03-05	1
15347	911	4112343	1978-11-26	1978-12-05	1
13220	778	40481087	2001-09-08	2001-09-22	1
64126	3790	4027663	1991-06-24	1991-06-25	1
9760	578	4112343	1996-10-07	1996-10-16	1
74912	4454	4237458	1950-02-15	1950-04-16	1
75331	4476	40481087	2005-04-30	2005-05-07	1
48778	2893	260139	1946-05-18	1946-06-01	1
22016	1318	40481087	1998-04-24	1998-05-15	1
67970	4019	4112343	1993-12-16	1993-12-28	1
46688	2780	80180	2001-09-23	2001-09-24	1
75039	4462	372328	1956-09-09	1957-01-10	1
21708	1306	260139	1971-04-02	1971-04-09	1
62196	3676	372328	1971-06-10	1971-07-22	1
12581	744	81151	1972-04-12	1972-05-03	1
20740	1246	4112343	1997-07-31	1997-08-07	1
78519	4655	4112343	1968-02-24	1968-03-06	1
18587	1118	372328	1975-11-30	1976-01-18	1
65272	3864	4294548	1993-06-17	1993-07-15	1
9821	580	80502	1997-10-05	1997-10-06	1
64228	3796	260139	2016-09-07	2016-09-14	1
62880	3718	81151	2003-12-03	2003-12-17	1
55934	3314	4112343	2010-10-26	2010-11-06	1
67523	3993	40481087	2012-12-31	2013-01-14	1
16899	1005	40479768	1989-02-25	1989-05-03	1
88017	5240	372328	1952-05-27	1952-09-23	1
80228	4758	40481087	1958-08-15	1958-08-29	1
11693	691	260139	2008-01-25	2008-02-08	1
64884	3839	40481087	2014-04-04	2014-04-25	1
18264	1099	81151	1979-09-09	1979-10-14	1
67482	3991	40481087	2005-06-28	2005-07-05	1
47042	2801	78272	1925-02-01	1925-03-08	1
71423	4240	260139	1964-07-23	1964-08-06	1
80048	4750	260139	1977-09-25	1977-10-02	1
19135	1148	4156265	2002-02-15	2002-03-01	1
78610	4660	40481087	2001-05-31	2001-06-07	1
19438	1169	80180	1975-12-23	1975-12-24	1
14484	857	260139	1967-04-14	1967-04-21	1
76196	4526	4112343	1979-09-05	1979-09-15	1
80904	4804	4084167	1978-01-15	1978-01-15	1
7180	422	4112343	2011-03-04	2011-03-12	1
69819	4134	4112343	1964-01-20	1964-01-27	1
15596	924	4112343	1978-11-21	1978-12-04	1
73665	4381	40481087	1982-06-19	1982-06-26	1
16708	992	4142905	2009-12-25	2010-03-25	1
5737	337	372328	1963-04-16	1963-08-28	1
80315	4761	375671	2005-02-07	2005-03-09	1
80361	4764	40481087	2018-05-12	2018-05-19	1
4760	279	40481087	1974-02-21	1974-03-14	1
13464	795	260139	1980-06-21	1980-06-28	1
88760	5283	40481087	1981-02-26	1981-03-12	1
79461	4712	81893	2004-09-06	2004-09-07	1
19605	1176	4084167	1999-11-13	1999-11-13	1
16362	969	260139	1988-07-15	1988-07-29	1
68028	4021	78272	1958-10-14	1958-11-18	1
16634	986	81151	1919-12-12	1920-01-02	1
83249	4952	4294548	1972-03-16	1972-06-29	1
15348	911	4112343	1995-11-30	1995-12-10	1
13221	778	40481087	2002-07-24	2002-07-31	1
64127	3790	4112343	2004-08-03	2004-08-16	1
9761	578	40481087	1975-06-27	1975-07-04	1
74913	4454	40481087	1938-03-03	1938-03-17	1
75332	4476	133834	1962-05-26	1979-10-28	1
48779	2893	260139	1949-05-25	1949-06-01	1
22017	1318	0	1953-03-05	1953-03-06	1
67971	4019	40481087	1970-12-23	1971-01-06	1
46689	2780	260139	1968-04-16	1968-04-30	1
75040	4462	4027663	1981-01-27	1981-01-28	1
21709	1306	260139	1999-11-17	1999-12-01	1
62197	3676	4283893	1981-02-24	1981-06-16	1
12582	744	4112343	1960-03-19	1960-03-26	1
20741	1246	4237458	1947-07-03	1947-09-01	1
78520	4655	4112343	2015-02-17	2015-02-28	1
18588	1118	4116491	2003-11-15	2004-01-12	1
65273	3864	40481087	1967-09-02	1967-09-23	1
9822	580	81151	1946-02-07	1946-02-28	1
64229	3796	4218389	2018-12-26	2019-01-16	1
62881	3718	260139	1973-10-15	1973-10-22	1
55935	3314	40481087	2013-07-28	2013-08-04	1
67524	3993	257012	1989-03-13	1989-03-14	1
16900	1005	40481087	1985-03-22	1985-03-29	1
88018	5240	4112343	1947-08-16	1947-08-28	1
80229	4758	40481087	1959-03-05	1959-03-26	1
11694	691	372328	1961-06-21	1962-06-19	1
65604	3884	28060	2005-05-22	2005-06-02	1
18265	1099	81893	1989-08-01	1989-08-02	1
67483	3991	28060	1972-02-22	1972-02-29	1
47043	2801	78272	1977-07-31	1977-09-04	1
71424	4240	372328	1984-09-03	1985-08-05	1
80049	4750	381316	2019-02-13	2019-02-14	1
19136	1148	4166224	2010-06-10	2010-06-11	1
78611	4660	40481087	2017-03-23	2017-04-13	1
19439	1169	81151	1961-10-16	1961-11-06	1
14485	857	260139	2000-02-27	2000-03-05	1
76197	4526	4112343	1991-10-16	1991-10-28	1
80905	4804	40481087	2004-09-25	2004-10-09	1
7181	422	4283893	2014-12-06	2015-02-28	1
69820	4134	4112343	1981-09-09	1981-09-17	1
15597	924	4294548	2018-09-11	2018-09-18	1
73666	4381	260139	2012-11-18	2012-12-04	1
16709	992	4285898	1986-12-03	1986-12-04	1
5738	337	4112343	2010-01-09	2010-01-22	1
80316	4761	4237458	1989-11-14	1989-12-14	1
80362	4764	78272	1981-11-11	1981-11-25	1
8668	507	255848	2016-04-18	2016-04-19	1
13465	795	260139	1984-02-16	1984-03-01	1
88761	5283	40481087	2002-06-25	2002-07-02	1
79462	4712	40481087	2010-05-31	2010-06-21	1
19606	1176	40481087	1996-05-21	1996-06-04	1
16363	969	381316	2014-12-07	2014-12-08	1
68029	4021	195588	1989-01-03	1989-02-07	1
16635	986	4112343	1923-07-28	1923-08-05	1
83250	4952	4296205	1994-07-13	1994-08-03	1
15349	911	4112343	2005-03-08	2005-03-19	1
13222	778	40481087	2002-12-05	2002-12-19	1
64128	3790	40481087	1993-03-06	1993-03-13	1
9762	578	40481087	1990-07-23	1990-08-06	1
74914	4454	40481087	1978-08-20	1978-09-10	1
75333	4476	260139	1962-04-21	1962-05-05	1
48780	2893	378001	1995-08-17	1995-09-16	1
22018	1318	28060	1949-10-09	1949-10-16	1
67972	4019	40481087	1991-12-09	1991-12-16	1
46690	2780	260139	2008-02-07	2008-02-14	1
75041	4462	4112343	1967-09-01	1967-09-09	1
21710	1306	4116491	2006-07-27	2006-09-17	1
62198	3676	40481087	2007-02-27	2007-03-20	1
12583	744	4113008	2012-01-14	2012-01-28	1
20742	1246	4266809	1980-08-23	1980-08-24	1
78521	4655	40481087	1987-06-21	1987-06-28	1
18589	1118	4155034	1980-06-06	1980-06-20	1
65274	3864	40481087	1995-06-10	1995-06-24	1
9823	580	260139	1980-12-01	1980-12-15	1
64230	3796	260139	1986-05-03	1986-05-17	1
62882	3718	260139	1994-02-02	1994-02-09	1
55936	3314	4266809	2003-07-20	2003-07-21	1
67525	3993	260139	1990-07-20	1990-07-27	1
16901	1005	80180	2007-07-01	2007-07-02	1
88019	5240	4113008	1975-06-14	1975-06-28	1
80230	4758	260139	1985-05-08	1985-05-15	1
11695	691	4112343	1974-08-25	1974-09-01	1
65605	3884	81151	1973-03-22	1973-04-19	1
18266	1099	260139	2005-09-06	2005-09-20	1
67484	3991	257012	1954-09-06	1969-08-03	1
47044	2801	80180	1966-02-21	1966-02-22	1
71425	4240	4112343	1950-07-10	1950-07-22	1
80050	4750	4048171	1968-04-15	1982-04-14	1
19137	1148	40481087	1967-11-02	1967-11-16	1
78808	4674	4112343	1982-09-21	1982-10-02	1
19440	1169	260139	1944-04-13	1944-04-20	1
14486	857	4294548	1985-09-29	1986-01-26	1
76198	4526	4294548	1999-05-02	1999-08-22	1
80906	4804	4027663	2004-03-14	2004-03-15	1
7182	422	40481087	1967-03-05	1967-03-26	1
69821	4134	4112343	2000-11-12	2000-11-19	1
15598	924	40481087	1971-04-08	1971-04-22	1
73667	4381	372328	1967-01-01	1967-05-09	1
16710	992	40481087	1955-08-18	1955-08-25	1
5739	337	40481087	1964-03-09	1964-03-16	1
80317	4761	4278672	1983-11-16	1984-02-14	1
80363	4764	257012	2005-07-16	2005-07-17	1
8669	507	260139	1994-08-04	1994-08-18	1
13466	795	4112343	1961-11-05	1961-11-16	1
88762	5283	40481087	2011-07-17	2011-08-07	1
84851	5051	80180	2013-12-30	2013-12-31	1
19607	1176	40481087	2005-04-15	2005-05-06	1
16364	969	4283893	2019-02-07	2019-02-28	1
68030	4021	260139	1970-06-24	1970-07-08	1
16636	986	4112343	1992-11-03	1992-11-11	1
83251	4952	372328	1973-02-17	1973-03-17	1
15350	911	4112343	2012-03-13	2012-03-23	1
17769	1072	28060	1987-07-22	1987-07-29	1
64129	3790	81893	2000-04-12	2000-04-13	1
9763	578	40481087	2016-03-11	2016-03-25	1
74915	4454	260139	1934-02-20	1934-03-06	1
75334	4476	260139	1992-05-25	1992-06-01	1
48781	2893	4001336	1957-07-09	1957-09-07	1
22019	1318	81151	1972-07-10	1972-07-31	1
67973	4019	192671	2005-05-08	2005-05-09	1
46691	2780	440448	1957-01-18	1957-01-19	1
75042	4462	4112343	1988-08-22	1988-09-02	1
21711	1306	81151	1968-05-28	1968-07-02	1
66488	3939	28060	1978-08-01	1978-08-13	1
12584	744	4156265	1983-12-07	1983-12-28	1
20743	1246	4278672	1955-01-22	1955-03-23	1
78522	4655	40481087	2018-07-27	2018-08-03	1
18590	1118	40481087	1980-10-11	1980-10-18	1
65275	3864	4112343	2010-01-31	2010-02-08	1
9824	580	260139	1991-08-25	1991-09-08	1
64231	3796	317576	2018-11-20	2018-11-21	1
62883	3718	4027663	1991-10-19	1991-10-20	1
55937	3314	4296204	2012-04-18	2012-05-09	1
67526	3993	4112343	2004-02-07	2004-02-15	1
16902	1005	375671	2016-05-11	2016-07-10	1
88020	5240	4218389	2001-12-13	2002-01-03	1
80231	4758	260139	1995-10-21	1995-11-04	1
11696	691	4237458	2019-06-20	2019-06-21	1
65606	3884	260139	1997-01-12	1997-01-19	1
18267	1099	372328	1957-06-28	1958-04-19	1
67485	3991	372328	1947-07-02	1947-09-06	1
47045	2801	257012	1933-05-15	1933-05-16	1
71426	4240	4112343	2003-11-17	2003-11-29	1
80051	4750	4112343	1973-02-19	1973-03-03	1
19138	1148	40481087	2006-08-20	2006-08-27	1
78809	4674	4113008	1984-03-11	1984-03-25	1
19441	1169	4112343	1952-02-18	1952-02-26	1
14487	857	40481087	1988-10-21	1988-10-28	1
76199	4526	4294548	2006-05-22	2006-07-31	1
80907	4804	4266809	2013-06-25	2013-06-26	1
7183	422	28060	2009-07-02	2009-07-11	1
69822	4134	40481087	1980-07-11	1980-08-01	1
15599	924	80180	2004-10-07	2004-10-08	1
73668	4381	378001	2008-07-18	2008-08-17	1
16711	992	40481087	1971-08-19	1971-08-26	1
5740	337	40481087	1990-01-09	1990-01-23	1
80318	4761	4283893	2002-09-16	2002-10-14	1
80364	4764	4112343	2015-03-02	2015-03-14	1
8670	507	260139	1999-07-24	1999-08-07	1
13467	795	4112343	2001-09-30	2001-10-07	1
88763	5283	28060	1981-02-22	1981-03-05	1
84852	5051	260139	1998-07-08	1998-07-22	1
19608	1176	40481087	2009-06-23	2009-07-07	1
16365	969	40481087	1984-07-26	1984-08-09	1
68031	4021	372328	1958-04-04	1958-06-18	1
16637	986	40481087	1967-02-24	1967-03-10	1
83252	4952	439777	1991-03-16	1991-03-17	1
15351	911	40481087	1983-05-08	1983-05-15	1
17770	1072	372328	1966-02-01	1966-08-03	1
64130	3790	372328	1969-05-23	1969-06-16	1
9764	578	81151	1979-10-25	1979-11-15	1
74916	4454	260139	1985-12-08	1985-12-15	1
75335	4476	4084167	1972-12-22	1972-12-22	1
48782	2893	4109685	2009-02-02	2009-02-16	1
22020	1318	255848	2018-12-21	2018-12-22	1
67974	4019	260139	1988-04-05	1988-04-12	1
46692	2780	40481087	1973-03-02	1973-03-09	1
75043	4462	4112343	1993-03-11	1993-03-21	1
21712	1306	4094814	1967-02-03	1967-05-04	1
66489	3939	28060	1982-12-22	1982-12-30	1
12585	744	4218389	1977-12-03	1978-01-07	1
20744	1246	4310024	1978-05-06	1978-05-07	1
78523	4655	81151	1965-04-11	1965-05-02	1
18591	1118	28060	1994-03-29	1994-04-06	1
65276	3864	40481087	1994-04-20	1994-05-11	1
9825	580	4113008	1994-07-30	1994-08-13	1
64232	3796	4112343	1995-03-01	1995-03-13	1
62884	3718	4112343	1979-06-28	1979-07-07	1
55938	3314	40481087	1964-10-04	1964-10-25	1
67527	3993	4152936	1999-03-13	1999-04-03	1
16903	1005	40481087	1967-11-23	1967-11-30	1
88021	5240	40481087	1983-01-11	1983-02-01	1
80232	4758	4155034	1987-06-05	1987-06-26	1
11697	691	81151	1966-11-22	1966-12-13	1
65607	3884	372328	1974-07-15	1974-09-02	1
18268	1099	372328	1977-05-09	1977-06-04	1
67486	3991	4283893	1971-02-02	1971-03-02	1
47046	2801	378419	1996-07-05	1996-07-06	1
71427	4240	4112343	2011-12-20	2012-01-02	1
80052	4750	4285898	2000-03-16	2000-03-17	1
19139	1148	372328	1959-01-21	1959-05-23	1
78810	4674	40481087	1987-11-16	1987-12-07	1
19442	1169	4112343	1975-09-09	1975-09-18	1
14488	857	40481087	2002-09-08	2002-09-15	1
76200	4526	40481087	1985-02-16	1985-03-02	1
80908	4804	40481087	1979-03-19	1979-04-02	1
7184	422	4112343	1997-08-19	1997-08-31	1
69823	4134	80180	1988-11-15	1988-11-16	1
15600	924	4112343	1984-12-04	1984-12-17	1
73669	4381	4112343	2016-03-25	2016-04-06	1
16712	992	40481087	1997-11-15	1997-12-06	1
7560	445	4027663	1943-09-14	1943-09-15	1
80319	4761	4285898	2018-10-13	2018-10-14	1
80365	4764	40481087	1987-05-24	1987-06-14	1
8671	507	40481087	1962-08-20	1962-09-10	1
13468	795	4116491	1973-08-10	1973-09-19	1
88764	5283	257012	1988-08-21	1988-08-22	1
84853	5051	372328	1983-09-15	1983-11-10	1
22666	1355	372328	1967-07-22	1968-03-01	1
16366	969	40481087	1986-04-06	1986-04-27	1
68032	4021	4112343	1974-06-28	1974-07-10	1
16638	986	255848	1996-08-21	1996-08-22	1
83253	4952	40481087	1975-09-19	1975-10-10	1
15352	911	40481087	2005-10-02	2005-10-16	1
17771	1072	4112343	1994-07-23	1994-07-31	1
64131	3790	4112343	1979-05-09	1979-05-21	1
9765	578	133834	1967-09-05	1984-06-07	1
74917	4454	317576	2004-05-15	2004-05-16	1
75336	4476	40481087	2012-11-27	2012-12-18	1
48783	2893	4112343	1966-01-23	1966-02-03	1
22021	1318	313217	2017-08-01	2017-08-02	1
67975	4019	260139	2012-03-06	2012-03-20	1
46693	2780	40481087	1987-08-30	1987-09-13	1
75044	4462	4112343	2014-03-29	2014-04-06	1
21713	1306	4112343	1994-05-24	1994-06-05	1
66490	3939	260139	1993-05-12	1993-05-26	1
12586	744	40481087	1975-01-26	1975-02-09	1
20745	1246	40481087	1945-06-11	1945-06-25	1
78524	4655	81151	1992-09-03	1992-09-24	1
18592	1118	30753	2012-10-26	2012-10-27	1
65277	3864	40481087	2015-12-23	2016-01-13	1
9826	580	40481087	1933-03-29	1933-04-12	1
64233	3796	4112343	2001-01-14	2001-01-27	1
62885	3718	4112343	1985-05-07	1985-05-16	1
57504	3415	260139	2005-11-12	2005-11-26	1
67528	3993	4218389	1957-10-09	1957-10-30	1
17994	1083	30753	2004-08-02	2004-08-03	1
88022	5240	40481087	1992-06-27	1992-07-04	1
80233	4758	40481087	1981-11-25	1981-12-16	1
11698	691	260139	1958-12-06	1958-12-20	1
65608	3884	4112343	2014-04-18	2014-04-30	1
18269	1099	28060	1979-03-23	1979-04-02	1
67487	3991	78272	1948-07-15	1948-08-19	1
47047	2801	4059173	2002-03-25	2002-03-26	1
71428	4240	4134304	2010-10-04	2010-12-03	1
80053	4750	40481087	1970-11-23	1970-12-14	1
19140	1148	4112343	2015-07-04	2015-07-14	1
78811	4674	40481087	1988-03-14	1988-04-04	1
19443	1169	78272	1936-10-08	1936-10-29	1
14489	857	40481087	2005-09-05	2005-09-12	1
76201	4526	40481087	2017-03-13	2017-03-27	1
80909	4804	28060	1990-04-13	1990-04-24	1
7185	422	4237458	1967-01-28	1967-04-28	1
69824	4134	4278672	1960-09-06	1960-11-05	1
15601	924	4112343	2018-06-03	2018-06-10	1
73670	4381	4294548	2012-10-23	2012-11-27	1
16713	992	81893	1986-01-07	1986-01-08	1
7561	445	4112343	1929-08-21	1929-09-01	1
80320	4761	40481087	2003-11-17	2003-12-08	1
80366	4764	40481087	1973-10-31	1973-11-07	1
8672	507	40481087	1981-03-29	1981-04-19	1
13469	795	4266809	1982-08-23	1982-08-24	1
88765	5283	260139	1998-08-29	1998-09-12	1
84854	5051	40481087	2011-12-11	2011-12-25	1
22667	1355	4112343	1966-09-07	1966-09-17	1
16367	969	40481087	2013-07-28	2013-08-04	1
68033	4021	40481087	1992-03-21	1992-04-11	1
16639	986	372328	1918-10-18	1919-04-05	1
83254	4952	40481087	1976-12-10	1976-12-17	1
15353	911	4112343	1984-04-10	1984-04-18	1
17772	1072	4112343	2002-05-21	2002-05-30	1
64132	3790	4112343	1991-01-14	1991-01-27	1
9766	578	260139	1969-02-21	1969-02-28	1
74918	4454	4059173	1927-01-23	1927-04-23	1
75337	4476	40481087	2018-06-29	2018-07-13	1
48784	2893	4112343	1970-11-10	1970-11-17	1
22022	1318	440448	1953-03-05	1953-03-06	1
67976	4019	4112343	1997-10-09	1997-10-18	1
50129	2965	80180	2003-09-03	2003-09-04	1
75045	4462	4116491	1984-01-27	1984-03-15	1
21714	1306	4152936	1980-06-29	1980-07-13	1
66491	3939	372328	1976-05-09	1976-06-27	1
12587	744	372328	1953-10-19	1954-03-05	1
20746	1246	40481087	1957-09-26	1957-10-03	1
78525	4655	195588	2015-12-14	2016-01-19	1
18593	1118	81151	1996-07-26	1996-08-16	1
66670	3950	78272	1981-06-17	1981-07-22	1
9827	580	40481087	1958-03-24	1958-03-31	1
64234	3796	4218389	2006-08-10	2006-08-31	1
62886	3718	4112343	1987-03-11	1987-03-22	1
57505	3415	4112343	1980-03-07	1980-03-16	1
67529	3993	40481087	1970-12-02	1970-12-16	1
17995	1083	80180	2005-04-29	2005-04-30	1
88023	5240	40481087	1992-11-09	1992-11-16	1
80234	4758	80180	1996-11-14	1996-11-15	1
11699	691	260139	1997-04-25	1997-05-09	1
65609	3884	28060	1980-01-18	1980-01-31	1
18270	1099	192671	1990-10-05	1990-10-06	1
67488	3991	80180	1981-08-11	1981-08-12	1
47048	2801	4112343	1979-02-05	1979-02-13	1
71429	4240	40481087	1958-12-27	1959-01-10	1
80054	4750	81151	2014-04-12	2014-05-17	1
19141	1148	4296204	1976-05-18	1976-06-01	1
78812	4674	40481087	2006-03-28	2006-04-04	1
19444	1169	81151	2009-02-21	2009-03-07	1
14490	857	257012	1981-03-30	1981-03-31	1
76202	4526	28060	1954-12-17	1954-12-28	1
80910	4804	30753	2012-02-01	2012-02-02	1
7186	422	40481087	1974-01-23	1974-02-06	1
69825	4134	40481087	1976-02-18	1976-02-25	1
15602	924	4296205	1977-02-15	1977-03-08	1
73671	4381	40481087	1983-10-24	1983-11-07	1
16714	992	260139	1962-12-08	1962-12-15	1
7562	445	4283893	1916-10-23	1916-11-20	1
81609	4847	260139	1996-04-11	1996-04-18	1
80367	4764	40481087	2018-06-25	2018-07-02	1
8673	507	80180	1977-10-03	1977-10-04	1
13470	795	4285898	1981-09-27	1981-09-28	1
88766	5283	4218389	2013-12-04	2014-01-08	1
84855	5051	260139	1986-10-09	1986-10-16	1
22668	1355	4112343	1998-09-25	1998-10-08	1
16368	969	78272	1998-11-02	1998-11-30	1
68034	4021	40481087	2015-04-05	2015-04-26	1
16640	986	378419	1990-09-22	1990-09-23	1
83255	4952	40481087	1984-02-14	1984-02-21	1
15354	911	4112343	1994-04-30	1994-05-07	1
17773	1072	4283893	2015-12-20	2016-04-10	1
64133	3790	40481087	1976-12-17	1976-12-31	1
9767	578	4112343	2008-02-01	2008-02-14	1
74919	4454	4278672	1932-04-26	1932-06-25	1
75706	4496	28060	1953-10-08	1953-10-20	1
48785	2893	4112343	1999-08-14	1999-08-27	1
22023	1318	4112343	1953-07-13	1953-07-21	1
67977	4019	4112343	2001-03-05	2001-03-18	1
50130	2965	260139	1985-02-06	1985-02-13	1
75046	4462	40481087	1981-07-16	1981-07-30	1
21715	1306	4237458	2019-04-11	2019-05-11	1
66492	3939	4266809	2011-12-02	2011-12-03	1
12588	744	440448	2004-03-17	2004-03-18	1
20747	1246	40481087	1987-09-03	1987-09-10	1
78526	4655	260139	2011-11-27	2011-12-04	1
18594	1118	81893	2012-01-30	2012-01-31	1
66671	3950	260139	1976-08-01	1976-08-15	1
9828	580	40481087	1979-03-26	1979-04-16	1
64235	3796	40481087	1970-12-25	1971-01-08	1
65451	3875	80180	2000-02-01	2000-02-02	1
57506	3415	28060	2008-05-22	2008-05-29	1
67530	3993	40481087	2018-01-26	2018-02-02	1
17996	1083	133834	1966-10-23	1983-06-07	1
88024	5240	78272	1974-05-22	1974-06-19	1
80235	4758	4112343	1987-10-07	1987-10-17	1
11700	691	4112343	2007-04-03	2007-04-13	1
65610	3884	260139	1975-10-10	1975-10-24	1
18271	1099	4027663	1982-04-05	1982-04-06	1
67489	3991	257012	2014-09-12	2014-09-13	1
47049	2801	4112343	1983-04-26	1983-05-05	1
71430	4240	40481087	1971-01-12	1971-01-19	1
80055	4750	81893	1998-07-25	1998-07-26	1
19142	1148	28060	1958-08-17	1958-08-24	1
78813	4674	0	1978-08-20	1978-08-21	1
19445	1169	195588	1989-09-30	1989-11-18	1
14491	857	372328	1955-02-04	1955-08-07	1
76203	4526	28060	1959-02-07	1959-02-19	1
80911	4804	260139	1978-10-14	1978-10-21	1
7187	422	40481087	1994-07-28	1994-08-18	1
69826	4134	40481087	2001-07-05	2001-07-26	1
15603	924	40481087	1964-10-29	1964-11-19	1
73672	4381	40481087	1988-12-16	1988-12-23	1
16715	992	372328	1955-05-15	1955-07-31	1
7563	445	40481087	1920-11-06	1920-11-20	1
81610	4847	260139	2002-01-20	2002-02-03	1
80368	4764	372328	1971-01-08	1971-01-22	1
8674	507	372328	1943-06-24	1943-07-30	1
13471	795	40481087	1951-09-29	1951-10-20	1
88767	5283	4278672	1984-09-07	1984-11-06	1
84856	5051	4266809	2013-12-30	2013-12-31	1
22669	1355	4112343	2017-10-02	2017-10-12	1
16369	969	4112343	1988-02-02	1988-02-11	1
68237	4035	378001	1978-10-16	1978-11-15	1
16641	986	4112343	1940-01-03	1940-01-11	1
83256	4952	40481087	2005-02-09	2005-02-23	1
15355	911	4112343	2008-12-02	2008-12-13	1
17774	1072	40481087	1974-01-22	1974-02-12	1
64134	3790	40481087	1989-04-05	1989-04-19	1
11589	686	78272	1994-07-17	1994-08-21	1
74920	4454	40481087	1926-07-30	1926-08-06	1
75707	4496	260139	1972-03-02	1972-03-09	1
48786	2893	4283893	1975-01-03	1975-03-14	1
22024	1318	4218389	1949-05-07	1949-06-11	1
67978	4019	40481087	2014-02-11	2014-02-18	1
50131	2965	260139	2000-08-15	2000-08-29	1
75047	4462	40481087	2002-03-09	2002-03-30	1
21716	1306	40481087	1965-06-30	1965-07-21	1
66493	3939	40481087	2017-03-28	2017-04-04	1
12589	744	4112343	2019-03-08	2019-03-16	1
20748	1246	80180	1980-08-23	1980-08-24	1
78527	4655	4029498	1982-12-08	1982-12-09	1
18595	1118	372328	1990-06-03	1990-12-16	1
66672	3950	260139	2001-12-11	2001-12-25	1
11498	680	78272	1987-08-09	1987-08-23	1
67581	3997	81151	1979-06-07	1979-06-21	1
65452	3875	260139	2017-07-03	2017-07-10	1
57507	3415	80180	2005-04-14	2005-04-15	1
67531	3993	260139	2013-09-05	2013-09-12	1
17997	1083	4084167	1980-05-06	1980-05-06	1
88025	5240	80180	1984-05-31	1984-06-01	1
80236	4758	4113008	1991-05-06	1991-05-27	1
11701	691	260139	1993-08-17	1993-08-31	1
65611	3884	372328	1976-08-22	1977-03-07	1
18272	1099	4112343	1993-04-30	1993-05-07	1
67490	3991	372328	1945-12-28	1946-03-09	1
47050	2801	4266809	1966-02-21	1966-02-22	1
71431	4240	40481087	1998-07-04	1998-07-11	1
80056	4750	378001	1972-07-21	1972-08-20	1
19143	1148	372328	1958-09-15	1958-11-22	1
78814	4674	260139	2006-04-17	2006-04-24	1
19446	1169	4112343	2001-03-06	2001-03-15	1
16016	949	260139	1990-03-09	1990-03-23	1
76204	4526	40481087	1954-09-11	1954-09-18	1
80912	4804	260139	1994-08-07	1994-08-14	1
7935	464	81151	2016-06-24	2016-07-15	1
70402	4176	80180	1952-05-20	1952-05-21	1
15604	924	40481087	2002-11-08	2002-11-29	1
73673	4381	40481087	1989-11-26	1989-12-03	1
16716	992	4027663	1979-08-17	1979-08-18	1
7564	445	40481087	1939-02-10	1939-02-17	1
81611	4847	4112343	2000-09-02	2000-09-12	1
80369	4764	4112343	1989-01-04	1989-01-11	1
8675	507	378419	2010-09-17	2010-09-18	1
13472	795	40481087	2006-01-23	2006-02-13	1
88768	5283	4283893	1988-08-07	1988-09-11	1
84857	5051	40481087	1979-04-23	1979-05-07	1
22670	1355	40481087	1993-10-07	1993-10-21	1
16370	969	40481087	1992-10-27	1992-11-10	1
68238	4035	4112343	2019-03-09	2019-03-19	1
16642	986	4112343	1978-03-12	1978-03-20	1
83257	4952	80180	2008-11-01	2008-11-02	1
15356	911	4112343	2010-06-09	2010-06-18	1
17775	1072	80180	2000-07-28	2000-07-29	1
65344	3869	78272	1911-03-08	1911-04-05	1
11590	686	260139	1966-06-18	1966-06-25	1
74921	4454	40481087	1997-06-09	1997-06-23	1
75708	4496	4152936	1960-12-29	1961-01-19	1
48787	2893	4283893	1986-08-20	1987-01-28	1
22025	1318	40481087	1939-06-09	1939-06-30	1
67979	4019	260139	1974-01-29	1974-02-12	1
50132	2965	260139	2008-11-28	2008-12-05	1
75048	4462	260139	1978-09-02	1978-09-16	1
21717	1306	40481087	2006-07-28	2006-08-04	1
66494	3939	260139	2013-03-29	2013-04-12	1
12590	744	4152936	1996-07-22	1996-08-05	1
20749	1246	192671	1980-11-06	1980-11-07	1
78528	4655	4112343	1998-04-23	1998-04-30	1
18596	1118	4027663	2006-08-04	2006-08-05	1
66673	3950	260139	2016-05-12	2016-05-26	1
11499	680	80180	2002-10-01	2002-10-02	1
67582	3997	257012	2012-05-12	2012-05-13	1
65453	3875	4142905	1967-09-23	1967-11-22	1
57508	3415	260139	1985-10-22	1985-10-29	1
67532	3993	4112343	1980-10-15	1980-10-24	1
17998	1083	260139	1987-10-28	1987-11-04	1
88026	5240	195588	1985-06-15	1985-07-31	1
80237	4758	4116491	2018-03-08	2018-04-11	1
11702	691	372328	1992-09-09	1993-08-24	1
65612	3884	440086	1984-03-24	1990-04-14	1
18273	1099	4156265	1969-06-12	1969-07-03	1
67491	3991	4027663	1973-09-22	1973-09-23	1
47051	2801	40481087	1951-08-25	1951-09-08	1
74075	4405	40481087	1975-01-10	1975-01-17	1
80057	4750	4112343	1980-04-10	1980-04-17	1
19144	1148	440448	2010-06-10	2010-06-11	1
78815	4674	4112343	2015-03-17	2015-03-24	1
19447	1169	4112343	2003-04-08	2003-04-19	1
16017	949	260139	2018-05-06	2018-05-20	1
76205	4526	40481087	1980-10-10	1980-10-24	1
80913	4804	317009	1997-03-23	1997-03-24	1
7936	464	4112343	1986-05-05	1986-05-13	1
70403	4176	260139	1977-09-29	1977-10-06	1
15605	924	78272	2008-03-15	2008-03-29	1
73674	4381	40481087	1997-06-16	1997-07-07	1
16717	992	4059173	1997-02-01	1997-04-02	1
7565	445	40481087	1990-07-29	1990-08-05	1
81612	4847	40481087	1963-05-17	1963-05-24	1
80370	4764	4112343	1997-01-15	1997-01-23	1
8676	507	4112343	1961-01-09	1961-01-22	1
13473	795	40481087	2015-10-15	2015-10-22	1
88769	5283	40481087	1996-05-06	1996-05-20	1
84858	5051	40481087	1997-08-06	1997-08-20	1
22671	1355	40481087	2012-03-22	2012-04-12	1
16371	969	378001	2018-08-24	2018-10-23	1
68239	4035	40481087	1974-08-11	1974-08-25	1
17269	1036	372328	1970-11-29	1971-02-12	1
83258	4952	257012	1972-05-04	1972-05-05	1
15357	911	4280726	1979-03-14	1979-03-15	1
17776	1072	378001	1997-05-15	1997-06-14	1
65345	3869	81151	1943-07-16	1943-08-06	1
11591	686	260139	1976-07-30	1976-08-06	1
74922	4454	80180	1963-06-08	1963-06-09	1
75709	4496	40481087	1995-10-16	1995-11-06	1
48788	2893	40481087	1964-09-15	1964-09-22	1
22026	1318	40481087	1967-01-20	1967-02-03	1
67980	4019	372328	1966-11-06	1967-11-07	1
50133	2965	372328	1970-06-23	1970-08-03	1
75049	4462	260139	1997-05-20	1997-06-03	1
21718	1306	40481087	2014-08-31	2014-09-14	1
66495	3939	40481087	1982-07-21	1982-08-11	1
12591	744	40481087	2015-04-08	2015-04-15	1
20750	1246	372328	2011-03-12	2011-10-28	1
78529	4655	4112343	2006-06-20	2006-07-02	1
18597	1118	4048171	1978-08-18	1978-08-19	1
66674	3950	440448	2008-09-23	2008-09-24	1
11500	680	81151	1968-08-20	1968-09-03	1
67583	3997	260139	2001-04-01	2001-04-15	1
65454	3875	40481087	1965-02-20	1965-03-06	1
57509	3415	4109685	2015-08-22	2015-09-05	1
67533	3993	4294548	1989-01-23	1989-05-01	1
17999	1083	4084167	1967-10-11	1967-10-11	1
88027	5240	257012	1970-09-04	1970-10-09	1
80238	4758	40481087	1961-04-23	1961-05-07	1
11703	691	4218389	1991-09-17	1991-10-15	1
65613	3884	4155034	1983-02-26	1983-03-12	1
18274	1099	4283893	1967-09-20	1967-11-15	1
67492	3991	4112343	1973-10-23	1973-11-01	1
47052	2801	40481087	1957-07-10	1957-07-31	1
74076	4405	80180	2006-09-24	2006-09-25	1
80058	4750	4294548	1988-03-18	1988-04-22	1
19145	1148	4112343	1963-02-03	1963-02-10	1
78816	4674	4218389	1971-09-04	1971-10-02	1
19448	1169	4218389	1980-02-05	1980-03-11	1
16018	949	4112343	1975-03-01	1975-03-10	1
76206	4526	40481087	2007-08-01	2007-08-15	1
80914	4804	4084167	1990-09-10	1990-09-10	1
7937	464	40481087	1983-04-26	1983-05-03	1
70404	4176	260139	1979-01-01	1979-01-15	1
15606	924	260139	1968-02-04	1968-02-11	1
73675	4381	40481087	2017-02-03	2017-02-10	1
16718	992	4112343	1993-08-24	1993-09-05	1
7566	445	30753	1952-12-05	1952-12-06	1
81613	4847	81151	1947-05-12	1947-05-26	1
80371	4764	4294548	2005-06-11	2005-07-23	1
8677	507	4155034	1994-05-11	1994-05-25	1
13474	795	28060	1968-03-16	1968-03-23	1
88770	5283	40481087	2005-05-26	2005-06-09	1
84859	5051	81151	1987-12-02	1987-12-23	1
22672	1355	80180	1996-05-22	1996-05-23	1
16372	969	4152936	1997-09-24	1997-10-08	1
68240	4035	40481087	1998-02-24	1998-03-03	1
17270	1036	4048171	1974-09-11	1974-09-12	1
83259	4952	260139	1973-04-06	1973-04-20	1
15358	911	40481087	2016-08-24	2016-09-14	1
17777	1072	4112343	1977-11-20	1977-11-28	1
65346	3869	260139	1953-08-31	1953-09-07	1
11592	686	372328	1948-01-30	1948-03-19	1
74923	4454	260139	1931-12-30	1932-01-06	1
75710	4496	40481087	1996-01-12	1996-01-19	1
48789	2893	40481087	2005-10-21	2005-11-11	1
22027	1318	40481087	1984-10-24	1984-11-07	1
67981	4019	4094814	1991-05-04	1991-08-02	1
50134	2965	4048171	1972-03-01	1993-07-12	1
75050	4462	4112343	2003-11-26	2003-12-05	1
21719	1306	28060	1959-05-28	1959-06-07	1
66496	3939	40481087	1992-01-24	1992-02-07	1
15658	929	28060	1965-10-04	1965-10-17	1
20751	1246	4035415	1974-09-14	1974-11-13	1
78530	4655	4294548	2017-09-21	2017-11-23	1
18598	1118	4056621	2000-10-04	2000-10-05	1
66675	3950	4112343	1999-07-16	1999-07-25	1
11501	680	372328	1969-08-23	1970-03-02	1
67584	3997	439777	2018-11-08	2018-11-09	1
65455	3875	40481087	1969-11-18	1969-11-25	1
57510	3415	4112343	1991-08-19	1991-09-01	1
67534	3993	40481087	1963-01-17	1963-02-07	1
18000	1083	4283893	1982-10-28	1982-12-30	1
88028	5240	260139	1982-11-08	1982-11-15	1
80239	4758	40481087	1969-09-29	1969-10-13	1
11704	691	40481087	1984-07-12	1984-07-19	1
65614	3884	40481087	1973-04-29	1973-05-20	1
21348	1282	80180	2015-07-13	2015-07-14	1
67493	3991	4266809	1981-08-11	1981-08-12	1
47053	2801	260139	1959-04-13	1959-04-20	1
74077	4405	440086	1977-02-13	1982-02-22	1
80059	4750	40481087	1964-06-08	1964-06-22	1
19146	1148	4112343	1978-05-23	1978-06-05	1
78817	4674	40481087	2014-01-10	2014-01-17	1
19449	1169	4294548	1980-11-23	1980-11-30	1
16019	949	4218389	2005-06-22	2005-07-13	1
76207	4526	28060	2006-06-26	2006-07-09	1
84171	5005	40481087	2003-05-28	2003-06-11	1
7938	464	40481087	2008-06-10	2008-06-17	1
70405	4176	381316	2003-10-23	2003-10-24	1
15607	924	4112343	1963-07-31	1963-08-09	1
74988	4459	80180	2005-05-29	2005-05-30	1
16719	992	4296204	1993-03-26	1993-04-23	1
7567	445	78272	1935-06-02	1935-06-30	1
81614	4847	317576	2013-03-27	2013-03-28	1
80372	4764	40481087	1984-09-22	1984-09-29	1
8678	507	28060	1949-01-27	1949-02-09	1
13475	795	28060	2018-09-09	2018-09-16	1
88771	5283	260139	2008-05-08	2008-05-15	1
84860	5051	81151	1996-12-05	1997-01-02	1
22673	1355	260139	1965-11-28	1965-12-12	1
16373	969	40481087	1981-06-27	1981-07-04	1
68241	4035	260139	1975-07-06	1975-07-20	1
17271	1036	4152936	2000-06-24	2000-07-15	1
83260	4952	372328	1971-05-15	1971-05-29	1
15359	911	372328	1976-04-06	1976-06-13	1
17778	1072	4112343	2003-12-25	2004-01-06	1
65347	3869	4112343	1919-05-27	1919-06-07	1
11593	686	372328	1971-03-17	1974-01-19	1
74924	4454	260139	1932-10-04	1932-10-18	1
75711	4496	40481087	2007-12-23	2007-12-30	1
48790	2893	0	1959-05-30	1959-05-31	1
22028	1318	40481087	2013-07-02	2013-07-16	1
67982	4019	4294548	2001-04-15	2001-06-10	1
50135	2965	4112343	2006-11-19	2006-12-02	1
75051	4462	4112343	2005-11-26	2005-12-07	1
21720	1306	195588	2008-09-16	2008-10-31	1
66497	3939	40481087	2005-11-09	2005-11-30	1
15659	929	260139	1942-06-13	1942-06-20	1
20752	1246	4084167	1939-02-15	1939-02-16	1
78531	4655	40481087	1990-07-19	1990-07-26	1
19923	1202	4112343	1989-12-07	1989-12-19	1
66676	3950	4218389	1972-10-20	1972-11-10	1
11502	680	4146173	1998-10-24	1998-11-23	1
67585	3997	4112343	1981-03-16	1981-03-28	1
65456	3875	28060	2006-11-17	2006-11-26	1
57511	3415	40481087	1977-11-06	1977-11-27	1
67535	3993	40481087	2011-07-10	2011-07-31	1
18001	1083	40486433	1968-05-25	1968-05-26	1
88029	5240	4112343	2011-03-03	2011-03-10	1
80240	4758	40481087	1977-11-05	1977-11-26	1
11964	709	0	2005-08-28	2005-08-29	1
65615	3884	40481087	2002-02-05	2002-02-19	1
21349	1282	378001	1994-02-12	1994-04-13	1
67494	3991	4285898	1981-05-13	1981-05-14	1
47054	2801	260139	1971-02-17	1971-02-24	1
74078	4405	4112343	1971-03-13	1971-03-23	1
80060	4750	40481087	1991-10-11	1991-11-01	1
19147	1148	4112343	2017-05-06	2017-05-17	1
78818	4674	40481087	2014-09-20	2014-10-04	1
19450	1169	4296205	1971-05-18	1971-06-22	1
16020	949	40481087	1989-09-24	1989-10-01	1
76208	4526	257012	1983-11-27	1983-11-28	1
84172	5005	81151	1986-02-23	1986-03-09	1
7939	464	40481087	1996-01-03	1996-01-10	1
70406	4176	4112343	1979-02-14	1979-02-26	1
15608	924	4112343	2011-04-30	2011-05-07	1
74989	4459	81151	1970-11-13	1970-11-27	1
16720	992	4310024	1985-07-11	1985-07-12	1
7568	445	81893	1952-08-07	1952-08-08	1
81615	4847	372328	1943-11-29	1944-02-09	1
80373	4764	40481087	1999-06-17	1999-07-08	1
8679	507	378001	1967-02-02	1967-03-04	1
13476	795	192671	1982-09-03	1982-09-04	1
88772	5283	372328	1978-04-07	1978-08-22	1
84861	5051	4059173	1983-08-25	1983-11-23	1
22674	1355	260139	1971-12-24	1972-01-07	1
21087	1267	28060	2016-01-21	2016-02-02	1
68242	4035	80180	2007-04-02	2007-04-03	1
17272	1036	4294548	2000-11-11	2000-11-25	1
84712	5044	317576	2010-02-03	2010-02-04	1
15360	911	4084167	1984-05-24	1984-05-24	1
17779	1072	4113008	2019-04-20	2019-05-04	1
65348	3869	4278672	1961-07-16	1961-08-15	1
11594	686	4027663	1970-10-07	1970-10-08	1
74925	4454	260139	1955-11-08	1955-11-22	1
75712	4496	4116491	1985-03-03	1985-04-26	1
48791	2893	81151	1952-06-14	1952-07-05	1
22029	1318	372328	1943-04-04	1944-02-22	1
71615	4253	30753	2017-11-04	2017-11-05	1
50136	2965	4278672	1987-09-06	1987-10-06	1
75052	4462	4285898	1989-11-16	1989-11-17	1
21721	1306	260139	1970-03-29	1970-04-05	1
66498	3939	4112343	1995-07-27	1995-08-04	1
15660	929	372328	1919-09-03	1919-11-10	1
20753	1246	4112343	2007-01-18	2007-01-28	1
78532	4655	40481087	2016-06-14	2016-06-21	1
19924	1202	40481087	1999-03-11	1999-03-25	1
66677	3950	40481087	1984-01-09	1984-01-23	1
11503	680	4218389	2008-09-01	2008-10-06	1
67586	3997	4112343	2018-03-28	2018-04-05	1
65457	3875	257012	2011-06-22	2011-06-23	1
57512	3415	40481087	1997-10-20	1997-11-03	1
72032	4279	80180	1987-08-16	1987-08-17	1
18002	1083	78272	1967-05-14	1967-06-18	1
88030	5240	4283893	1970-08-21	1970-10-09	1
80241	4758	40481087	1979-10-24	1979-10-31	1
11965	709	257012	1969-09-02	1969-09-03	1
65616	3884	80180	2011-04-07	2011-04-08	1
21350	1282	4134304	1980-06-25	1980-09-23	1
67495	3991	40481087	1996-06-18	1996-07-09	1
47055	2801	372328	1923-11-09	1924-01-25	1
74079	4405	4112343	1976-05-29	1976-06-09	1
80061	4750	80180	2000-05-15	2000-05-16	1
19148	1148	40481087	1977-08-31	1977-09-14	1
78819	4674	260139	2001-05-31	2001-06-14	1
19451	1169	4329847	2018-08-20	2018-08-21	1
16021	949	80180	2000-02-25	2000-02-26	1
76209	4526	372328	1954-09-04	1954-09-18	1
84173	5005	257012	2013-02-01	2013-02-02	1
7940	464	40481087	2018-12-01	2018-12-22	1
70407	4176	40481087	1944-01-06	1944-01-20	1
15609	924	40481087	1968-05-08	1968-05-22	1
74990	4459	81151	1982-05-20	1982-06-10	1
16721	992	40481087	1959-03-12	1959-04-02	1
7569	445	260139	1931-03-13	1931-03-27	1
81616	4847	4294548	2011-09-01	2011-09-15	1
83109	4943	4112343	1965-05-14	1965-05-21	1
8680	507	40481087	1963-07-13	1963-07-27	1
13477	795	195588	1979-09-18	1979-11-08	1
88773	5283	4237458	1975-08-21	1975-11-19	1
84862	5051	4285898	2013-10-31	2013-11-01	1
22675	1355	260139	1995-11-07	1995-11-14	1
21088	1267	260139	1959-05-13	1959-05-20	1
68243	4035	4112343	2018-04-02	2018-04-11	1
17273	1036	80180	2011-05-13	2011-05-14	1
84713	5044	40481087	1994-11-13	1994-12-04	1
15361	911	4112343	2004-02-29	2004-03-12	1
17780	1072	40481087	1972-11-21	1972-11-28	1
65349	3869	4278672	1980-12-03	1981-03-03	1
11595	686	4112343	1961-03-05	1961-03-12	1
74926	4454	4112343	1980-03-08	1980-03-21	1
75713	4496	4134304	1970-06-22	1970-09-20	1
48792	2893	372328	1954-06-04	1955-06-22	1
22030	1318	40481087	2004-09-17	2004-10-08	1
71616	4253	78272	1995-03-09	1995-04-07	1
50137	2965	4296204	1978-03-13	1978-03-27	1
75053	4462	4310024	1988-06-24	1988-06-25	1
21722	1306	260139	1983-05-16	1983-05-30	1
66499	3939	4310024	2010-02-10	2010-02-11	1
15661	929	372328	1997-07-09	1998-01-12	1
20754	1246	4152936	1961-11-16	1961-12-07	1
78533	4655	0	1982-12-08	1982-12-09	1
19925	1202	4112343	1982-12-27	1983-01-09	1
66678	3950	40481087	2013-08-12	2013-09-02	1
11504	680	4283893	1995-05-26	1995-08-11	1
67587	3997	4134304	1978-04-13	1978-06-12	1
65458	3875	4152936	1971-06-04	1971-06-18	1
57513	3415	260139	1992-01-28	1992-02-04	1
72033	4279	260139	1986-12-05	1986-12-12	1
18003	1083	81893	2004-01-05	2004-01-06	1
88031	5240	40479422	1979-04-06	1979-06-12	1
80242	4758	40481087	2002-03-10	2002-03-31	1
11966	709	4109685	1972-03-04	1972-03-25	1
65617	3884	257012	1992-01-02	1992-01-03	1
21351	1282	40481087	1981-03-17	1981-03-31	1
69749	4131	28060	1985-04-26	1985-05-05	1
47056	2801	4059173	1968-10-16	1968-12-15	1
74080	4405	4218389	2011-06-10	2011-07-01	1
80062	4750	372328	1964-04-04	1964-06-17	1
19149	1148	0	2010-06-10	2010-06-11	1
78820	4674	260139	2012-01-25	2012-02-08	1
19452	1169	40481087	1952-02-26	1952-03-04	1
16022	949	258780	1980-08-25	1980-08-26	1
76210	4526	372328	1955-10-13	1956-03-23	1
84174	5005	4113008	2004-08-31	2004-09-14	1
7941	464	80180	2014-10-23	2014-10-24	1
70408	4176	40481087	1953-10-08	1953-10-29	1
15610	924	40481087	2009-09-30	2009-10-21	1
74991	4459	81151	2015-10-04	2015-11-01	1
16722	992	40481087	1966-01-02	1966-01-09	1
7570	445	260139	1947-09-13	1947-09-27	1
81617	4847	40481087	2008-02-23	2008-03-15	1
83110	4943	4112343	2005-06-09	2005-06-19	1
8681	507	40481087	2001-03-13	2001-04-03	1
13478	795	260139	1965-06-20	1965-06-27	1
88774	5283	40481087	1989-08-13	1989-09-03	1
84863	5051	4310024	2011-08-13	2011-08-14	1
22676	1355	372328	1966-08-23	1966-09-23	1
21089	1267	260139	1969-10-18	1969-11-01	1
68244	4035	4283893	2002-01-19	2002-03-16	1
17274	1036	260139	1981-12-03	1981-12-10	1
84714	5044	28060	1979-08-26	1979-09-07	1
15362	911	40481087	1984-11-13	1984-11-27	1
17781	1072	40481087	1980-11-06	1980-11-27	1
65350	3869	40481087	1945-02-23	1945-03-09	1
11596	686	4112343	1967-09-21	1967-10-04	1
74927	4454	4134304	1996-02-28	1996-03-29	1
75714	4496	4294548	1955-11-02	1955-11-23	1
48793	2893	378001	1999-08-24	1999-10-23	1
22782	1360	80180	2018-06-11	2018-06-12	1
71617	4253	257012	2010-09-17	2010-09-18	1
50138	2965	40481087	1999-03-31	1999-04-07	1
75054	4462	81151	2006-12-23	2007-01-20	1
21723	1306	378001	2017-04-21	2017-05-21	1
66500	3939	40481087	1979-07-21	1979-08-04	1
15662	929	4112343	1937-06-19	1937-07-02	1
20755	1246	40481087	2006-07-08	2006-07-22	1
78534	4655	28060	1970-03-27	1970-04-06	1
19926	1202	4112343	2004-02-22	2004-02-29	1
66679	3950	0	2008-09-23	2008-09-24	1
11505	680	40481087	1989-04-23	1989-04-30	1
67588	3997	4152936	1967-09-17	1967-10-08	1
65459	3875	4283893	1983-09-24	1983-10-22	1
57514	3415	28060	2008-09-28	2008-10-06	1
72034	4279	4237458	1966-11-14	1967-02-12	1
18004	1083	260139	2006-11-12	2006-11-19	1
88032	5240	40481087	1957-08-22	1957-09-05	1
82959	4933	0	1978-03-03	1978-03-04	1
11967	709	4112343	1971-05-26	1971-06-06	1
65618	3884	378001	1979-01-18	1979-03-19	1
21352	1282	40481087	1993-10-28	1993-11-04	1
69750	4131	80180	2018-05-22	2018-05-23	1
47057	2801	4059173	1984-03-01	1984-05-30	1
74081	4405	4283893	1994-10-13	1994-12-08	1
80063	4750	378001	2007-10-16	2007-12-15	1
19150	1148	260139	1964-03-19	1964-03-26	1
78821	4674	4112343	1982-05-12	1982-05-22	1
19453	1169	40481087	2015-06-30	2015-07-07	1
16023	949	260139	1959-11-09	1959-11-16	1
76211	4526	372328	1962-08-19	1962-10-19	1
84175	5005	4283893	2012-10-19	2013-04-19	1
8732	512	260139	2001-09-12	2001-09-26	1
70409	4176	40481087	1981-01-09	1981-01-23	1
18013	1084	192671	2016-08-25	2016-08-26	1
74992	4459	4112343	1964-01-21	1964-01-30	1
16723	992	80180	1987-07-31	1987-08-01	1
7571	445	372328	1917-06-22	1917-09-07	1
81618	4847	80180	1977-07-08	1977-07-09	1
83111	4943	4134304	1970-07-05	1970-10-03	1
8682	507	192671	1977-10-29	1977-10-30	1
13479	795	260139	1987-07-23	1987-07-30	1
88775	5283	28060	1996-08-17	1996-08-29	1
84864	5051	40481087	1982-06-25	1982-07-09	1
22677	1355	372328	1975-11-20	1976-01-23	1
21090	1267	260139	1981-01-17	1981-01-31	1
68245	4035	4112343	1986-11-04	1986-11-15	1
17275	1036	372328	1972-01-08	1972-02-11	1
84715	5044	80180	2015-07-23	2015-07-24	1
15363	911	40481087	2001-05-07	2001-05-21	1
17782	1072	40481087	1995-02-15	1995-02-22	1
65351	3869	40481087	1964-01-27	1964-02-10	1
11597	686	4266809	1980-12-22	1980-12-23	1
74928	4454	4142905	2018-02-23	2018-05-24	1
75715	4496	4296205	2006-10-11	2006-11-01	1
48794	2893	4134304	1948-03-07	1948-06-05	1
22783	1360	4027663	2008-09-26	2008-09-27	1
71618	4253	4112343	1986-11-24	1986-12-01	1
50139	2965	40481087	1975-11-02	1975-11-16	1
75055	4462	192671	1990-10-23	1990-10-24	1
21724	1306	4112343	2014-11-19	2014-11-29	1
66501	3939	40481087	2004-03-04	2004-03-11	1
15663	929	4112343	1956-07-24	1956-08-03	1
21536	1293	257012	1980-01-06	1980-01-07	1
78535	4655	80180	1990-08-28	1990-08-29	1
19927	1202	4112343	2006-03-23	2006-04-01	1
66680	3950	372328	1979-09-14	1980-09-04	1
11506	680	40481087	2017-08-24	2017-09-07	1
67589	3997	4152936	1997-01-17	1997-01-31	1
65460	3875	40481087	2013-08-30	2013-09-13	1
57515	3415	260139	1999-06-20	1999-06-27	1
72035	4279	40481087	2008-05-22	2008-05-29	1
18005	1083	4027663	1997-05-11	1997-05-12	1
88033	5240	40481087	1965-11-29	1965-12-06	1
82960	4933	372328	1971-02-28	1971-05-13	1
11968	709	4112343	1982-01-20	1982-01-27	1
65619	3884	378001	1992-11-19	1992-12-19	1
21353	1282	40481087	2013-02-20	2013-03-13	1
69751	4131	4112343	2011-12-21	2012-01-02	1
47058	2801	4112343	1939-05-11	1939-05-20	1
74082	4405	40481087	1973-09-03	1973-09-10	1
80064	4750	4027663	1989-04-03	1989-04-04	1
19151	1148	4112343	1990-10-04	1990-10-12	1
78822	4674	4166224	1978-08-20	1978-08-21	1
19454	1169	0	2018-08-20	2018-08-21	1
16024	949	372328	1960-01-06	1960-05-16	1
76212	4526	4294548	1983-10-16	1983-12-18	1
84176	5005	40481087	1995-08-11	1995-09-01	1
8733	512	40481087	1960-12-15	1960-12-29	1
70410	4176	40481087	2001-08-16	2001-08-23	1
18014	1084	260139	2010-12-04	2010-12-18	1
74993	4459	4112343	2005-01-14	2005-01-21	1
16724	992	195588	2005-08-10	2005-09-30	1
7572	445	380378	1925-12-18	1925-12-19	1
81619	4847	81151	1953-09-28	1953-10-19	1
83112	4943	4237458	1974-02-14	1974-04-15	1
8683	507	260139	1944-01-21	1944-01-28	1
13480	795	260139	1988-06-08	1988-06-15	1
88776	5283	78272	1982-11-12	1982-12-17	1
84865	5051	40481087	2014-09-17	2014-09-24	1
22678	1355	4112343	1987-09-08	1987-09-21	1
21091	1267	4112343	2005-09-14	2005-09-24	1
68246	4035	40481087	1972-05-27	1972-06-17	1
17276	1036	4051466	1971-09-12	1988-12-13	1
84716	5044	257012	1975-06-28	1975-06-29	1
15364	911	40481087	2017-09-17	2017-09-24	1
17783	1072	40481087	1999-03-26	1999-04-09	1
65352	3869	78272	1950-09-28	1950-10-12	1
11598	686	40481087	2012-04-08	2012-04-29	1
74929	4454	4155034	1969-09-03	1969-09-17	1
75716	4496	40481087	2015-05-31	2015-06-14	1
48795	2893	40481087	1990-05-20	1990-06-03	1
22784	1360	4285898	2018-05-12	2018-05-13	1
71619	4253	4266809	2018-08-01	2018-08-02	1
50140	2965	40481087	1987-01-04	1987-01-11	1
75056	4462	261325	1990-09-20	1990-09-21	1
21725	1306	4156265	2001-12-20	2002-01-10	1
66502	3939	40481087	2017-08-11	2017-09-01	1
15664	929	4112343	1979-01-09	1979-01-21	1
21537	1293	317576	2010-02-23	2010-02-24	1
78536	4655	260139	1998-06-14	1998-06-28	1
19928	1202	4112343	2013-02-24	2013-03-07	1
66681	3950	378001	2003-06-27	2003-07-27	1
11507	680	372328	1967-10-25	1968-01-01	1
67590	3997	40481087	1969-04-18	1969-05-02	1
65461	3875	80502	2018-07-14	2018-07-15	1
57516	3415	4112343	1974-09-21	1974-10-04	1
72036	4279	28060	2007-03-03	2007-03-16	1
18006	1083	4152936	2006-10-21	2006-11-04	1
88034	5240	40481087	1989-12-02	1989-12-16	1
82961	4933	4059173	1970-12-30	1971-01-29	1
11969	709	4283893	1969-07-08	1969-10-14	1
65620	3884	40481087	1974-03-25	1974-04-01	1
21354	1282	4112343	2001-05-10	2001-05-21	1
69752	4131	4283893	1987-08-02	1987-11-29	1
47059	2801	4112343	1988-11-07	1988-11-14	1
74083	4405	40481087	2011-06-20	2011-07-11	1
80065	4750	4112343	2001-07-15	2001-07-23	1
19152	1148	40481087	1959-11-14	1959-12-05	1
78823	4674	40481087	2010-08-16	2010-08-23	1
19455	1169	260139	1937-12-03	1937-12-17	1
16025	949	40481087	1987-10-15	1987-10-29	1
76213	4526	4299128	2012-05-02	2012-06-06	1
84177	5005	40481087	2007-08-24	2007-09-07	1
8734	512	40481087	1972-11-02	1972-11-23	1
70411	4176	378001	2007-09-17	2007-11-16	1
18015	1084	4112343	1979-08-30	1979-09-09	1
74994	4459	4296204	2012-12-03	2012-12-17	1
16725	992	260139	1956-09-07	1956-09-21	1
7573	445	4112343	1936-02-28	1936-03-10	1
81620	4847	81151	1960-09-03	1960-09-24	1
83113	4943	40481087	1981-03-16	1981-04-06	1
8684	507	313217	1990-08-31	1990-09-01	1
13481	795	378001	1993-05-13	1993-06-12	1
88777	5283	4112343	2009-04-09	2009-04-19	1
84866	5051	81151	2016-02-22	2016-03-28	1
22679	1355	4155034	2000-01-02	2000-01-23	1
21092	1267	4283893	1973-03-30	1973-06-08	1
68247	4035	40481087	1995-06-11	1995-07-02	1
17277	1036	4112343	1981-03-23	1981-04-04	1
84717	5044	260139	1986-08-06	1986-08-20	1
15365	911	80180	2015-06-16	2015-06-17	1
17784	1072	40481087	2015-10-21	2015-11-11	1
65353	3869	260139	1981-11-11	1981-11-25	1
11599	686	28060	1967-06-12	1967-06-19	1
74930	4454	4218389	1948-12-24	1949-01-21	1
75717	4496	78272	1964-08-01	1964-08-22	1
48796	2893	78272	1966-07-22	1966-08-19	1
22785	1360	28060	2016-03-28	2016-04-05	1
71620	4253	4285898	2017-12-03	2017-12-04	1
50141	2965	372328	1972-04-28	1972-07-31	1
75057	4462	4266809	1990-09-12	1990-09-13	1
21726	1306	80180	2001-01-14	2001-01-15	1
66503	3939	80180	2011-12-02	2011-12-03	1
15665	929	4113008	1977-05-20	1977-06-03	1
21538	1293	4051466	1942-01-01	1959-04-06	1
78537	4655	4084167	1963-05-22	1963-05-22	1
19929	1202	4116491	2013-06-28	2013-08-21	1
66682	3950	4027663	2004-09-22	2004-09-23	1
11508	680	4048171	1971-10-01	1993-07-12	1
67591	3997	40481087	2013-03-22	2013-04-12	1
65462	3875	195588	2005-11-11	2005-12-20	1
57517	3415	4112343	1997-12-30	1998-01-11	1
72037	4279	260139	1970-10-20	1970-11-03	1
18007	1083	40481087	1995-07-03	1995-07-17	1
88035	5240	40481087	2015-05-10	2015-05-17	1
82962	4933	4112343	1984-08-01	1984-08-13	1
11970	709	28060	1995-06-19	1995-07-02	1
65621	3884	260139	2001-08-27	2001-09-03	1
21355	1282	4116491	1998-03-29	1998-05-12	1
69753	4131	257012	1987-10-11	1987-10-12	1
47060	2801	4283893	1925-12-19	1926-01-16	1
74084	4405	40481087	2018-08-08	2018-08-22	1
80066	4750	4283893	1994-07-26	1994-09-06	1
22303	1333	28060	1969-04-02	1969-04-09	1
78824	4674	40481087	2015-10-05	2015-10-19	1
19456	1169	317576	2014-09-22	2014-09-23	1
16026	949	4112343	1968-06-24	1968-07-01	1
76214	4526	40481087	2011-09-02	2011-09-16	1
84178	5005	260139	2008-08-28	2008-09-11	1
8735	512	40481087	1999-02-11	1999-02-25	1
70412	4176	4112343	1984-03-03	1984-03-13	1
18016	1084	4112343	1995-04-02	1995-04-12	1
74995	4459	260139	1966-09-07	1966-09-14	1
16726	992	260139	1960-07-03	1960-07-10	1
7574	445	4112343	1956-06-21	1956-06-28	1
81621	4847	258780	1975-01-22	1975-01-23	1
83114	4943	40481087	1990-08-24	1990-09-14	1
8685	507	4152936	1946-11-05	1946-11-19	1
13482	795	4027663	1970-08-11	1970-08-12	1
89610	5333	260139	1955-12-06	1955-12-20	1
84867	5051	260139	1992-05-18	1992-06-01	1
22680	1355	40481087	2006-03-23	2006-03-30	1
21093	1267	40481087	2012-08-22	2012-09-05	1
72829	4333	30753	1993-06-08	1993-06-09	1
17278	1036	260139	1998-03-20	1998-03-27	1
84718	5044	372328	2013-02-13	2014-11-26	1
15366	911	260139	2003-12-23	2003-12-30	1
17785	1072	81151	1972-02-14	1972-03-06	1
65354	3869	0	1926-10-09	1926-10-10	1
11600	686	378001	2005-02-23	2005-03-25	1
74931	4454	4278672	2007-03-23	2007-05-22	1
75718	4496	257012	1992-05-11	1992-05-12	1
48797	2893	257012	1975-01-17	1975-01-18	1
22786	1360	30753	2017-08-15	2017-08-16	1
71621	4253	80180	2018-08-01	2018-08-02	1
50142	2965	378001	2015-06-09	2015-08-08	1
75058	4462	4296204	1972-06-03	1972-06-24	1
21727	1306	372328	1961-08-12	1962-06-13	1
66504	3939	260139	2008-09-28	2008-10-05	1
15666	929	4329847	2005-10-10	2005-10-11	1
21539	1293	4112343	1988-02-01	1988-02-10	1
78538	4655	4156265	2009-04-28	2009-05-12	1
19930	1202	40481087	1986-11-09	1986-11-16	1
66683	3950	4278672	1971-09-26	1971-12-25	1
11509	680	4112343	1983-07-06	1983-07-18	1
67592	3997	28060	1973-04-27	1973-05-10	1
65463	3875	260139	1963-06-26	1963-07-10	1
57518	3415	4134304	1979-11-22	1980-02-20	1
72038	4279	260139	1976-03-08	1976-03-22	1
18008	1083	40481087	2002-10-15	2002-10-29	1
88036	5240	81151	1976-05-23	1976-06-20	1
82963	4933	4294548	1997-11-04	1997-11-11	1
11971	709	80180	1988-07-13	1988-07-14	1
65622	3884	4048171	1975-04-03	1991-04-01	1
21356	1282	40481087	1995-10-31	1995-11-14	1
69754	4131	4112343	2000-05-02	2000-05-09	1
47061	2801	4283893	1933-04-17	1933-05-22	1
74085	4405	257012	1994-12-01	1994-12-02	1
82553	4907	260139	1949-09-16	1949-09-30	1
22304	1333	260139	1970-02-13	1970-02-20	1
78825	4674	80180	2005-04-28	2005-04-29	1
19457	1169	40481087	1960-03-28	1960-04-18	1
16027	949	4112343	1993-07-05	1993-07-13	1
76215	4526	28060	1954-08-07	1954-08-17	1
84179	5005	372328	1980-07-24	1981-06-28	1
8736	512	80180	1993-02-24	1993-02-25	1
70413	4176	4112343	2005-12-31	2006-01-09	1
18017	1084	4112343	1996-09-05	1996-09-17	1
74996	4459	260139	1977-12-04	1977-12-11	1
16727	992	372328	1956-07-25	1956-09-23	1
7575	445	4112343	1978-03-07	1978-03-19	1
81622	4847	440086	1950-05-31	1961-06-07	1
83115	4943	40481087	1997-03-18	1997-03-25	1
8686	507	40481087	2008-06-02	2008-06-09	1
13483	795	4109685	2000-11-02	2000-11-16	1
89611	5333	260139	1960-03-09	1960-03-23	1
84868	5051	372328	1980-05-12	1980-10-30	1
22681	1355	28060	1987-07-02	1987-07-09	1
21094	1267	260139	1955-10-21	1955-10-28	1
72830	4333	260139	1983-08-27	1983-09-10	1
17279	1036	4112343	2013-07-17	2013-07-26	1
84719	5044	40481087	1995-11-06	1995-11-20	1
16995	1017	0	1970-06-12	1970-06-13	1
17786	1072	81151	1990-10-28	1990-11-18	1
65355	3869	260139	1947-03-16	1947-03-23	1
11601	686	4112343	2002-06-18	2002-06-28	1
74932	4454	40481087	1930-06-23	1930-07-07	1
75719	4496	372328	1949-01-01	1949-02-17	1
48798	2893	440448	1959-05-30	1959-05-31	1
22787	1360	81893	2017-02-16	2017-02-17	1
71622	4253	4112343	1992-02-05	1992-02-17	1
50143	2965	440086	1982-02-20	1988-02-29	1
75059	4462	40481087	1965-08-14	1965-09-04	1
21728	1306	378001	1986-03-14	1986-05-13	1
66505	3939	4027663	2005-01-12	2005-01-13	1
15667	929	40481087	1919-11-10	1919-11-17	1
21540	1293	4112343	1991-07-26	1991-08-07	1
78539	4655	4296204	1982-11-20	1982-12-25	1
19931	1202	40481087	1997-09-07	1997-09-14	1
66684	3950	4285898	2014-02-07	2014-02-08	1
11510	680	4112343	1986-11-30	1986-12-10	1
67593	3997	260139	1987-02-16	1987-03-02	1
65464	3875	260139	1997-08-20	1997-09-03	1
57519	3415	4146173	1983-09-02	1983-10-09	1
72039	4279	4280726	1954-04-13	1993-07-16	1
18009	1083	260139	2016-03-20	2016-03-27	1
88037	5240	260139	1942-01-14	1942-01-21	1
82964	4933	40479422	1998-10-28	1998-12-04	1
11972	709	260139	1973-11-24	1973-12-08	1
65623	3884	4294548	1991-12-05	1992-03-26	1
21357	1282	40486433	1981-04-09	1981-04-10	1
69755	4131	4218389	1989-04-04	1989-05-02	1
50634	3000	30753	1982-01-28	1982-01-29	1
74086	4405	260139	1968-10-25	1968-11-01	1
82554	4907	260139	1982-04-28	1982-05-05	1
22305	1333	4112343	1978-03-26	1978-04-05	1
78826	4674	372328	1969-01-17	1969-04-29	1
19458	1169	40481087	1979-08-05	1979-08-26	1
16028	949	4237458	1974-07-05	1974-10-03	1
76216	4526	80180	1993-01-17	1993-01-18	1
84180	5005	40479422	2010-03-17	2010-04-23	1
8737	512	260139	1963-10-02	1963-10-16	1
70414	4176	4152936	2010-07-03	2010-07-17	1
18018	1084	40481087	2008-04-23	2008-05-07	1
74997	4459	4112343	1972-08-20	1972-09-01	1
16728	992	378001	1990-06-10	1990-07-10	1
7576	445	4112343	1993-09-29	1993-10-08	1
81623	4847	4218389	1969-11-06	1969-11-27	1
83116	4943	260139	2014-09-30	2014-10-14	1
8687	507	40481087	2009-09-08	2009-09-15	1
13484	795	4218389	1946-07-28	1946-08-18	1
89612	5333	260139	1993-08-27	1993-09-03	1
84869	5051	4027663	2003-11-18	2003-11-19	1
22682	1355	78272	1965-07-29	1965-09-02	1
21095	1267	4112343	1999-01-05	1999-01-18	1
72831	4333	260139	1995-12-10	1995-12-17	1
17280	1036	40481087	1969-12-12	1969-12-19	1
84720	5044	4112343	1976-04-02	1976-04-09	1
16996	1017	78272	1962-12-21	1963-01-11	1
17787	1072	260139	1979-01-12	1979-01-26	1
65356	3869	372328	1909-05-17	1909-07-24	1
11602	686	4156265	1976-01-08	1976-01-22	1
74933	4454	40481087	2009-08-25	2009-09-15	1
75720	4496	372328	1950-04-13	1950-08-17	1
48799	2893	4112343	1952-08-23	1952-08-30	1
22788	1360	257012	1976-07-20	1976-07-21	1
71623	4253	4112343	2010-11-24	2010-12-06	1
50144	2965	4112343	1979-07-07	1979-07-17	1
75060	4462	40481087	1994-09-25	1994-10-09	1
21729	1306	4112343	1984-11-25	1984-12-08	1
66506	3939	40481087	1974-04-29	1974-05-13	1
15668	929	28060	1925-02-07	1925-02-20	1
21541	1293	40481087	1949-07-29	1949-08-05	1
78540	4655	40481087	1984-04-21	1984-04-28	1
19932	1202	40481087	2005-06-30	2005-07-14	1
66685	3950	40481087	1987-11-12	1987-12-03	1
11511	680	4112343	1999-07-21	1999-08-01	1
67594	3997	4156265	1998-02-25	1998-03-11	1
65465	3875	378001	2013-04-27	2013-06-26	1
57520	3415	40481087	1972-08-05	1972-08-26	1
72040	4279	40481087	1969-05-11	1969-05-25	1
18010	1083	378001	1978-09-18	1978-10-18	1
88038	5240	260139	1956-12-06	1956-12-13	1
82965	4933	80180	2007-06-14	2007-06-15	1
11973	709	260139	1977-09-16	1977-09-23	1
65624	3884	40481087	2001-05-14	2001-06-04	1
21358	1282	372328	1980-09-09	1981-03-14	1
69756	4131	40481087	2009-05-30	2009-06-06	1
50635	3000	260139	1951-07-01	1951-07-15	1
74087	4405	260139	1975-12-26	1976-01-09	1
82555	4907	260139	2008-03-16	2008-04-01	1
22306	1333	4112343	2007-06-04	2007-06-15	1
78827	4674	440448	1978-08-20	1978-08-21	1
22271	1332	80180	1979-12-10	1979-12-11	1
16029	949	40481087	2006-02-15	2006-02-22	1
76217	4526	4278672	1987-08-12	1987-11-10	1
84181	5005	40481087	2004-07-10	2004-07-31	1
8738	512	372328	1955-08-13	1956-01-27	1
70415	4176	4278672	1920-04-23	1920-06-22	1
18019	1084	40481087	2009-04-09	2009-04-16	1
74998	4459	40481087	2002-02-20	2002-03-06	1
16729	992	439777	1969-08-19	1969-08-20	1
7577	445	4310024	1952-02-09	1952-02-10	1
81624	4847	4294548	1991-08-31	1991-09-28	1
83117	4943	4112343	1991-09-22	1991-10-04	1
10204	605	78272	2015-04-19	2015-05-10	1
13485	795	40481087	1951-05-09	1951-05-23	1
89613	5333	260139	1993-12-20	1994-01-03	1
84870	5051	40481087	1983-04-10	1983-04-17	1
22683	1355	372328	1966-11-22	1967-03-24	1
21096	1267	4134304	1995-02-27	1995-03-29	1
72832	4333	378001	2018-06-11	2018-07-11	1
17281	1036	260139	1995-07-26	1995-08-02	1
84721	5044	4112343	1985-04-11	1985-04-22	1
16997	1017	372328	1960-01-06	1960-05-22	1
17788	1072	260139	1990-10-20	1990-10-27	1
65357	3869	372328	1914-10-26	1915-04-03	1
11603	686	4285898	1980-10-24	1980-10-25	1
74934	4454	81151	1933-06-20	1933-07-11	1
75721	4496	4112343	1970-01-26	1970-02-04	1
48800	2893	4112343	1972-07-13	1972-07-24	1
22789	1360	4146173	2006-01-25	2006-03-26	1
71624	4253	40481087	2008-09-25	2008-10-09	1
50145	2965	4112343	1985-10-15	1985-10-24	1
75061	4462	80180	1990-09-12	1990-09-13	1
21730	1306	4156265	1962-04-09	1962-04-30	1
66507	3939	40481087	1980-04-05	1980-04-26	1
15669	929	317576	1990-12-03	1990-12-04	1
21542	1293	40481087	1971-12-15	1971-12-29	1
84135	5002	192671	2019-05-25	2019-05-26	1
19933	1202	260139	1993-01-01	1993-01-08	1
66686	3950	40481087	2011-08-31	2011-09-21	1
11512	680	28060	1994-05-17	1994-05-30	1
67595	3997	40481087	1979-11-11	1979-11-18	1
65466	3875	4112343	2019-01-05	2019-01-17	1
57521	3415	40481087	2007-11-20	2007-12-04	1
72041	4279	40481087	1979-05-22	1979-05-29	1
18011	1083	4112343	1969-02-06	1969-02-19	1
88039	5240	4112343	1965-08-24	1965-09-03	1
82966	4933	257012	1973-01-30	1973-01-31	1
11974	709	260139	1987-06-05	1987-06-19	1
66324	3930	28060	1971-07-11	1971-07-21	1
21359	1282	4084167	1991-06-14	1991-06-14	1
69757	4131	260139	1989-09-22	1989-09-29	1
50636	3000	4112343	1987-04-03	1987-04-11	1
74088	4405	372328	1964-11-13	1965-01-25	1
82556	4907	378001	1976-11-05	1977-01-04	1
22307	1333	4112343	2011-11-23	2011-12-06	1
78828	4674	4113008	1973-07-23	1973-08-06	1
22272	1332	4112343	1954-06-22	1954-06-29	1
16030	949	40481087	2012-08-26	2012-09-02	1
76218	4526	40481087	1986-05-02	1986-05-09	1
84182	5005	80180	2008-01-09	2008-01-10	1
8739	512	372328	1960-02-05	1961-02-10	1
70416	4176	40481087	1940-05-04	1940-05-18	1
18020	1084	80180	2016-06-15	2016-06-16	1
74999	4459	81151	1972-11-16	1972-12-07	1
16730	992	4266809	1987-07-31	1987-08-01	1
7578	445	40481087	1926-06-28	1926-07-12	1
81625	4847	40479768	1950-12-06	1951-01-12	1
83118	4943	4218389	1964-10-13	1964-11-03	1
10205	605	372328	1957-01-11	1957-02-22	1
13486	795	40481087	1965-02-16	1965-03-02	1
89614	5333	4059173	1962-12-22	1963-02-20	1
87785	5229	372328	1964-11-09	1965-05-12	1
22684	1355	40481087	1982-09-05	1982-09-26	1
21097	1267	40481087	1960-06-01	1960-06-08	1
72833	4333	4296204	1968-04-15	1968-05-06	1
17282	1036	4112343	1975-09-07	1975-09-20	1
84722	5044	260139	1993-05-15	1993-05-29	1
16998	1017	4112343	1997-07-22	1997-07-29	1
17789	1072	260139	1996-12-03	1996-12-17	1
65358	3869	4112343	1934-08-18	1934-08-31	1
11604	686	40481087	1989-01-29	1989-02-12	1
74935	4454	260139	2005-09-20	2005-10-04	1
75722	4496	4283893	1992-04-20	1992-05-25	1
48801	2893	4112343	1978-04-27	1978-05-08	1
22790	1360	4294548	1981-06-20	1981-07-18	1
71625	4253	28060	1996-06-30	1996-07-08	1
50146	2965	4112343	2012-10-05	2012-10-13	1
75062	4462	40481087	1966-06-07	1966-06-21	1
21731	1306	4278672	1966-01-09	1966-04-09	1
66508	3939	40481087	1987-07-22	1987-08-12	1
15670	929	372328	1924-08-15	1925-07-27	1
21543	1293	378001	1949-09-04	1949-10-04	1
84136	5002	372328	1977-09-13	1978-03-17	1
19934	1202	4112343	1992-08-07	1992-08-19	1
66687	3950	40481087	2012-06-25	2012-07-09	1
11513	680	260139	1986-06-18	1986-07-02	1
67596	3997	40481087	1989-08-25	1989-09-15	1
65467	3875	4116491	2009-12-19	2010-01-30	1
59553	3533	260139	2000-05-25	2000-06-08	1
72042	4279	40481087	1993-03-22	1993-03-29	1
18012	1083	4285898	2005-02-28	2005-03-01	1
88040	5240	4112343	2004-08-20	2004-09-02	1
82967	4933	4027663	2000-02-26	2000-02-27	1
11975	709	372328	1949-10-01	1949-12-11	1
66325	3930	80180	1957-11-06	1957-11-07	1
21360	1282	4109685	2010-10-16	2010-11-06	1
69758	4131	260139	2014-09-23	2014-09-30	1
50637	3000	4112343	1991-10-20	1991-11-01	1
74089	4405	40481087	1966-07-13	1966-08-03	1
82557	4907	378001	2002-04-28	2002-05-28	1
22308	1333	4149245	2002-05-18	2002-06-24	1
78829	4674	4146173	2017-06-21	2017-08-27	1
22273	1332	4155034	2002-12-25	2003-01-08	1
16031	949	260139	2005-10-17	2005-10-31	1
76219	4526	40481087	1995-03-01	1995-03-15	1
84183	5005	260139	2013-12-08	2013-12-15	1
8740	512	4112343	1973-08-15	1973-08-28	1
70417	4176	40481087	1954-12-30	1955-01-13	1
18021	1084	260139	1987-10-18	1987-10-25	1
75000	4459	260139	1968-12-03	1968-12-10	1
16731	992	4283893	1957-09-14	1957-11-09	1
7579	445	40481087	1975-03-10	1975-03-31	1
81626	4847	40481087	1971-10-17	1971-11-07	1
83119	4943	40481087	1976-02-22	1976-03-07	1
10206	605	372328	1961-08-30	1962-04-13	1
13487	795	40481087	1978-01-29	1978-02-12	1
89615	5333	4112343	1981-02-13	1981-02-22	1
87786	5229	4112343	1965-10-20	1965-10-31	1
22685	1355	40481087	2009-04-22	2009-04-29	1
21098	1267	81151	1954-02-27	1954-03-13	1
72834	4333	40481087	1974-10-18	1974-11-01	1
17283	1036	4134304	2006-10-12	2006-11-11	1
84723	5044	4294548	1975-05-10	1975-09-27	1
16999	1017	4112343	2001-01-11	2001-01-24	1
17790	1072	260139	2009-04-14	2009-04-21	1
65359	3869	4112343	1974-12-14	1974-12-27	1
11605	686	40481087	1994-12-22	1994-12-29	1
74936	4454	260139	2015-12-21	2015-12-28	1
75723	4496	80180	1980-08-21	1980-08-22	1
48802	2893	28060	1980-11-25	1980-12-07	1
22791	1360	4294548	2009-12-29	2010-03-23	1
71626	4253	81893	2017-01-07	2017-01-08	1
50147	2965	4142905	1988-08-01	1988-08-31	1
75063	4462	40481087	1978-08-23	1978-08-30	1
21732	1306	40481087	1970-12-31	1971-01-14	1
66509	3939	40481087	1992-12-09	1992-12-23	1
15671	929	40481087	1993-02-12	1993-02-19	1
21544	1293	378001	1978-12-01	1978-12-31	1
84137	5002	378001	1989-07-05	1989-09-03	1
19935	1202	40481087	1993-08-16	1993-08-30	1
66688	3950	81893	2013-01-13	2013-01-14	1
11514	680	260139	1989-03-19	1989-04-02	1
67597	3997	40481087	2004-12-09	2004-12-16	1
65468	3875	4218389	2004-02-09	2004-03-15	1
59554	3533	40481087	1978-05-11	1978-06-01	1
72043	4279	28060	1954-01-20	1954-01-30	1
18286	1101	0	1982-08-22	1982-08-23	1
88041	5240	4116491	1988-07-30	1988-09-02	1
82968	4933	4029498	1978-03-03	1978-03-04	1
11976	709	4112343	1968-02-24	1968-03-08	1
66326	3930	81151	1945-07-13	1945-07-27	1
21361	1282	4112343	1978-08-23	1978-09-04	1
69759	4131	40481087	2018-06-25	2018-07-09	1
50638	3000	4112343	2012-05-17	2012-05-26	1
74090	4405	260139	1983-05-10	1983-05-17	1
82558	4907	440448	1948-02-03	1948-02-04	1
22309	1333	40481087	1961-08-23	1961-09-13	1
78830	4674	4152936	1987-02-08	1987-03-01	1
22274	1332	4218389	1984-07-11	1984-08-01	1
16032	949	4155034	1961-01-30	1961-02-13	1
76220	4526	40481087	2011-11-21	2011-12-05	1
86652	5165	28060	1977-02-07	1977-02-15	1
8741	512	4155034	2013-07-14	2013-07-28	1
70418	4176	40481087	1991-05-07	1991-05-21	1
18022	1084	260139	2004-06-29	2004-07-06	1
75001	4459	440086	1973-10-19	1981-10-26	1
18082	1088	80180	2011-07-11	2011-07-12	1
7580	445	0	1925-09-18	1925-09-19	1
81627	4847	81151	1959-09-18	1959-10-09	1
83120	4943	40481087	1983-12-31	1984-01-21	1
10207	605	4048171	1959-06-22	1959-06-23	1
13488	795	30753	1980-12-01	1980-12-02	1
89616	5333	40481087	1949-12-05	1949-12-19	1
87787	5229	4156265	1968-07-02	1968-07-23	1
22686	1355	260139	1968-02-25	1968-03-03	1
21099	1267	260139	1960-12-17	1960-12-31	1
72835	4333	40481087	2012-04-15	2012-04-22	1
17284	1036	4142905	1978-12-17	1979-01-16	1
84724	5044	40481087	1982-08-26	1982-09-16	1
17000	1017	4237458	2009-09-27	2009-12-26	1
17791	1072	372328	1961-08-12	1961-10-25	1
65360	3869	4112343	1977-04-17	1977-04-27	1
11606	686	30753	1980-01-27	1980-01-28	1
74937	4454	313217	2006-10-07	2006-10-08	1
75724	4496	260139	2010-04-21	2010-05-05	1
48803	2893	4059173	1956-05-15	1956-07-14	1
22792	1360	28060	1993-12-11	1993-12-20	1
71627	4253	260139	1987-06-22	1987-06-29	1
50148	2965	4218389	2012-05-27	2012-06-24	1
75064	4462	40481087	1979-11-28	1979-12-19	1
21733	1306	40481087	1975-06-27	1975-07-04	1
66510	3939	40481087	2012-08-01	2012-08-15	1
15672	929	0	2005-10-10	2005-10-11	1
21545	1293	4112343	1979-05-11	1979-05-23	1
84138	5002	4112343	1977-04-06	1977-04-18	1
19936	1202	40481087	1994-11-02	1994-11-16	1
66689	3950	378001	2016-09-16	2016-10-16	1
11515	680	260139	2001-03-01	2001-03-15	1
67598	3997	81151	2005-05-03	2005-06-07	1
65469	3875	40481087	1985-06-20	1985-06-27	1
59555	3533	30753	1999-05-14	1999-05-15	1
72044	4279	81151	1964-01-24	1964-02-28	1
18287	1101	81151	1981-06-12	1981-07-03	1
88042	5240	4294548	1990-08-19	1990-10-28	1
82969	4933	4059173	1980-03-03	1980-06-01	1
11977	709	4294548	1991-11-17	1991-12-08	1
66327	3930	260139	1917-09-14	1917-09-28	1
21362	1282	4156265	1977-03-29	1977-04-12	1
69760	4131	28060	1996-09-07	1996-09-17	1
50639	3000	4112343	2012-09-25	2012-10-02	1
74091	4405	260139	1996-04-28	1996-05-05	1
82559	4907	4112343	1949-05-20	1949-05-28	1
22310	1333	40481087	1965-07-30	1965-08-13	1
78831	4674	40481087	2003-02-20	2003-03-06	1
22275	1332	4296204	1970-08-14	1970-09-04	1
16033	949	40481087	1970-12-14	1971-01-04	1
80106	4754	28060	1972-03-13	1972-03-25	1
86653	5165	81151	2008-03-21	2008-04-04	1
8742	512	4278672	1969-01-29	1969-02-28	1
70419	4176	260139	2010-02-02	2010-02-09	1
18023	1084	260139	2019-02-20	2019-03-06	1
75002	4459	40481087	1999-08-15	1999-08-29	1
18083	1088	195588	2006-07-22	2006-09-08	1
7581	445	81151	1915-09-01	1915-09-15	1
81628	4847	260139	1959-12-06	1959-12-20	1
83121	4943	40481087	2007-11-17	2007-12-08	1
10208	605	4112343	2000-08-15	2000-08-27	1
13489	795	80502	2006-11-01	2006-11-02	1
89617	5333	40481087	1990-03-19	1990-04-09	1
87788	5229	4237458	1977-06-20	1977-08-19	1
22687	1355	4112343	1963-11-11	1963-11-19	1
21100	1267	260139	1990-01-25	1990-02-08	1
72836	4333	40481087	2018-11-25	2018-12-09	1
17285	1036	4237458	1983-10-22	1984-01-20	1
84725	5044	40481087	1985-08-10	1985-08-24	1
17001	1017	260139	1971-03-11	1971-03-18	1
17792	1072	4059173	1979-05-29	1979-06-28	1
65361	3869	4112343	1994-01-02	1994-01-11	1
11607	686	80180	1980-12-22	1980-12-23	1
74938	4454	378001	2012-05-25	2012-07-24	1
75725	4496	40481087	1985-08-25	1985-09-15	1
48804	2893	4059173	1973-09-11	1973-10-11	1
22793	1360	372328	1977-03-28	1978-01-29	2
71628	4253	260139	2017-06-12	2017-06-26	1
50149	2965	40481087	1990-05-01	1990-05-08	1
75426	4482	80180	1987-08-27	1987-08-28	1
23528	1408	317576	2015-03-23	2015-03-24	1
70360	4173	80180	2002-10-23	2002-10-24	1
15673	929	78272	1992-09-12	1992-09-26	1
21546	1293	4278672	1970-03-18	1970-05-17	1
84139	5002	4134304	1996-03-30	1996-06-28	1
19937	1202	40481087	1998-11-15	1998-12-06	1
66690	3950	440086	1981-09-28	1982-08-23	1
11516	680	260139	2010-12-16	2010-12-23	1
67599	3997	260139	1983-08-26	1983-09-02	1
65470	3875	40481087	1988-12-17	1988-12-24	1
59556	3533	192671	2001-01-13	2001-01-14	1
72045	4279	440086	1964-04-03	1968-04-12	1
18288	1101	440086	1983-08-16	1984-05-08	1
88043	5240	40481087	1999-06-07	1999-06-28	1
82970	4933	4112343	1981-11-05	1981-11-13	1
11978	709	40481087	1951-10-30	1951-11-06	1
66328	3930	317576	1972-07-22	1972-07-23	1
21363	1282	260139	1985-09-14	1985-09-28	1
69761	4131	260139	1988-06-09	1988-06-23	1
50640	3000	4112343	2013-04-03	2013-04-12	1
74092	4405	372328	1969-09-01	1969-11-10	1
82560	4907	40481087	1950-04-07	1950-04-14	1
22311	1333	260139	1974-10-29	1974-11-12	1
80567	4782	28060	2018-03-17	2018-03-24	1
22276	1332	40481087	1946-04-22	1946-04-29	1
16034	949	40481087	1992-04-25	1992-05-02	1
80107	4754	80180	2006-02-02	2006-02-03	1
86654	5165	260139	1970-09-09	1970-09-16	1
8743	512	40479768	1970-01-24	1970-03-02	1
70420	4176	4152936	1979-03-27	1979-04-17	1
18024	1084	372328	1979-09-28	1979-12-14	1
75003	4459	4218389	1999-07-11	1999-08-15	1
18084	1088	260139	1985-06-23	1985-06-30	1
7582	445	81151	1951-08-05	1951-08-19	1
81629	4847	4294548	2005-03-26	2005-04-02	1
83122	4943	0	1962-02-01	1962-02-02	1
10209	605	4112343	2000-10-28	2000-11-09	1
13490	795	372328	1937-04-16	1937-07-28	1
89618	5333	80180	1986-08-13	1986-08-14	1
87789	5229	4266809	2004-04-14	2004-04-15	1
22688	1355	4296204	2007-01-16	2007-01-30	1
21101	1267	260139	2004-02-26	2004-03-11	1
72837	4333	0	1980-08-22	1980-08-23	1
17286	1036	40481087	2007-11-27	2007-12-18	1
84726	5044	40481087	2013-06-25	2013-07-09	1
17002	1017	372328	1976-10-25	1977-04-24	1
17793	1072	40481087	1975-02-14	1975-02-28	1
65362	3869	40481087	1919-11-28	1919-12-05	1
11608	686	260139	1958-11-04	1958-11-18	1
74939	4454	4112343	1932-12-25	1933-01-02	1
75726	4496	40481087	2017-11-09	2017-11-30	1
48805	2893	4112343	1952-01-18	1952-01-25	1
22794	1360	4294548	1976-05-11	1976-08-10	1
71629	4253	4113008	2010-08-16	2010-08-30	1
50150	2965	40481087	2011-12-05	2011-12-19	1
75427	4482	81151	1976-10-01	1976-10-22	1
23529	1408	372328	1947-08-11	1948-07-12	1
70361	4173	260139	1983-01-03	1983-01-10	1
15674	929	4112343	1943-02-03	1943-02-12	1
21547	1293	4278672	2016-09-12	2016-12-11	1
84140	5002	40481087	1977-10-09	1977-10-30	1
19938	1202	78272	2012-07-18	2012-08-22	1
66691	3950	4152936	1979-06-07	1979-06-28	1
11517	680	4112343	2016-10-04	2016-10-17	1
67600	3997	4112343	2001-01-13	2001-01-25	1
65471	3875	28060	1965-04-16	1965-04-23	1
59557	3533	4027663	1990-11-22	1990-11-23	1
72046	4279	4059173	2018-03-16	2018-05-15	1
18289	1101	440448	1985-08-17	1985-08-18	1
88044	5240	78272	1969-06-19	1969-07-17	1
82971	4933	4283893	1972-12-26	1973-04-17	1
11979	709	40481087	1986-04-24	1986-05-08	1
66329	3930	372328	1914-09-28	1914-12-05	1
21364	1282	4084167	1994-03-31	1994-03-31	1
69762	4131	378001	1982-06-10	1982-08-09	1
50641	3000	4152936	1996-11-08	1996-11-29	1
74366	4419	81151	2013-03-03	2013-03-24	1
82561	4907	40481087	1989-08-02	1989-08-16	1
22312	1333	4156265	1990-04-07	1990-04-21	1
80568	4782	30753	2016-01-16	2016-01-17	1
22277	1332	40481087	1965-05-14	1965-06-04	1
16035	949	40481087	2001-09-19	2001-10-03	1
80108	4754	4112343	1972-08-24	1972-08-31	1
86655	5165	260139	1993-04-29	1993-05-06	1
8744	512	40481087	2006-01-17	2006-01-24	1
70421	4176	40481087	1972-10-08	1972-10-15	1
18025	1084	4112343	1990-02-14	1990-02-26	1
75004	4459	40481087	1985-04-07	1985-04-21	1
18085	1088	4112343	2008-02-25	2008-03-04	1
7583	445	257012	1963-10-24	1963-10-25	1
81630	4847	40481087	1950-09-02	1950-09-16	1
83123	4943	28060	1971-12-05	1971-12-14	1
10210	605	134438	1990-06-14	1991-09-07	1
13491	795	378001	1998-03-18	1998-05-17	1
89619	5333	260139	1954-05-10	1954-05-24	1
87790	5229	4283893	2013-02-27	2013-03-27	1
24249	1447	4156265	1963-06-01	1963-06-15	1
21102	1267	378001	1987-11-06	1987-12-06	1
72838	4333	192671	1994-08-13	1994-08-14	1
19093	1146	28060	1967-04-15	1967-04-27	1
84956	5058	30753	1977-11-19	1977-11-20	1
17003	1017	439777	1964-06-13	1964-06-14	1
17794	1072	40481087	1980-03-12	1980-04-02	1
65363	3869	40481087	1920-10-08	1920-10-15	1
11609	686	372328	1951-01-03	1951-09-29	1
74940	4454	4112343	2005-12-09	2005-12-18	1
78627	4662	196456	1989-07-27	1989-07-27	1
48806	2893	4112343	1994-04-30	1994-05-11	1
22795	1360	40481087	1999-02-21	1999-03-07	1
71630	4253	4283893	2010-08-06	2010-11-11	1
50151	2965	372328	1971-04-30	1971-08-02	1
75428	4482	257012	2005-06-14	2005-06-15	1
23530	1408	4112343	1943-12-31	1944-01-09	1
70362	4173	372328	1967-03-11	1967-04-12	1
15675	929	4112343	1958-12-25	1959-01-07	1
21548	1293	40481087	1976-09-11	1976-09-18	1
84141	5002	78272	1988-07-05	1988-08-09	1
19939	1202	80180	2016-11-14	2016-11-15	1
66692	3950	4310024	2012-07-17	2012-07-18	1
11518	680	40479422	2012-07-17	2012-08-23	1
67601	3997	40481087	1983-08-08	1983-08-22	1
65472	3875	81151	1977-01-17	1977-01-31	1
59558	3533	4112343	1978-02-06	1978-02-18	1
72047	4279	40481087	1965-12-09	1965-12-23	1
18290	1101	260139	1974-10-19	1974-11-02	1
88045	5240	257012	1990-09-23	1990-09-24	1
82972	4933	4296204	1974-11-09	1974-11-30	1
11980	709	40481087	1993-03-08	1993-03-29	1
66330	3930	372328	1917-02-01	1917-08-04	1
21365	1282	4146173	1979-06-01	1979-07-01	1
69763	4131	4112343	2009-10-21	2009-10-29	1
50642	3000	4156265	1965-12-13	1966-01-03	1
74367	4419	260139	2005-05-12	2005-05-26	1
82562	4907	40481087	1991-10-13	1991-10-27	1
22313	1333	4218389	1981-07-18	1981-08-22	1
80569	4782	4027663	2008-04-22	2008-04-23	1
22278	1332	30753	1978-12-15	1978-12-16	1
16036	949	40481087	2018-01-13	2018-01-27	1
80109	4754	4283893	2000-05-23	2000-07-04	1
86656	5165	4112343	1964-03-14	1964-03-26	1
8745	512	81151	1956-03-10	1956-04-07	1
70422	4176	40481087	1978-07-25	1978-08-15	1
18026	1084	4218389	2016-10-13	2016-11-10	1
75005	4459	40481087	2002-10-11	2002-10-31	1
18086	1088	4146173	1995-12-07	1996-01-13	1
7584	445	260139	1950-12-23	1950-12-30	1
82821	4924	4048171	1982-12-20	1982-12-21	1
83124	4943	28060	1999-05-29	1999-06-09	1
10211	605	260139	1987-03-09	1987-03-16	1
14870	877	260139	2009-07-15	2009-07-29	1
89620	5333	4043241	1996-01-14	1996-01-15	1
87791	5229	4296204	2007-08-03	2007-09-07	1
24250	1447	40481087	1959-09-26	1959-10-17	1
21103	1267	4059173	1955-02-06	1955-03-08	1
72839	4333	372328	1955-11-15	1956-02-02	1
19094	1146	80180	1998-04-25	1998-04-26	1
84957	5058	260139	1980-11-19	1980-11-26	1
17004	1017	4029498	1970-06-12	1970-06-13	1
17795	1072	40481087	1987-07-31	1987-08-07	1
65364	3869	40481087	1929-01-06	1929-01-27	1
11610	686	4310024	1979-02-01	1979-02-02	1
74941	4454	4218389	1938-05-16	1938-06-06	1
78628	4662	4109685	1953-04-21	1953-05-05	1
48807	2893	4112343	2006-10-22	2006-11-01	1
22796	1360	40481087	1999-12-11	1999-12-25	1
71631	4253	4310024	2016-06-12	2016-06-13	1
50152	2965	4112343	1992-09-20	1992-10-01	1
75429	4482	260139	2019-01-19	2019-01-26	1
23531	1408	4112343	2005-10-27	2005-11-04	1
70363	4173	378001	1986-10-12	1986-12-11	1
15676	929	4155034	1932-07-26	1932-08-09	1
21549	1293	40481087	1993-06-21	1993-06-28	1
84142	5002	80180	2019-03-15	2019-03-16	1
19940	1202	260139	2019-05-23	2019-06-06	1
66693	3950	40481087	1980-06-15	1980-06-22	1
11519	680	40481087	1994-11-07	1994-11-21	1
67602	3997	40481087	1991-02-14	1991-02-28	1
65473	3875	260139	1982-02-09	1982-02-23	1
59559	3533	4113008	2000-04-18	2000-05-09	1
72048	4279	40481087	1978-10-04	1978-10-18	1
18291	1101	260139	1989-07-01	1989-07-08	1
88046	5240	372328	1939-08-26	1939-10-03	1
82973	4933	81151	2007-08-19	2007-09-23	1
11981	709	260139	1953-04-14	1953-04-21	1
66331	3930	40481087	1947-01-07	1947-01-14	1
21366	1282	40481087	1987-05-05	1987-05-26	1
69764	4131	40481087	1984-04-07	1984-04-14	1
50643	3000	4266809	1983-09-20	1983-09-21	1
74368	4419	378001	2010-02-17	2010-04-18	1
82563	4907	40481087	2016-10-11	2016-11-01	1
22314	1333	40481087	1955-10-04	1955-10-25	1
80570	4782	80180	2017-09-07	2017-09-08	1
22279	1332	257012	2014-09-15	2014-09-16	1
18642	1123	81151	1974-11-06	1974-11-27	1
80110	4754	40481087	2012-09-04	2012-09-11	1
86657	5165	40481087	1982-02-11	1982-02-25	1
8746	512	4112343	1970-09-17	1970-09-27	1
70423	4176	260139	1923-07-09	1923-07-23	1
18027	1084	4237458	1982-12-11	1983-02-09	1
75537	4487	0	2010-02-12	2010-02-13	1
18087	1088	28060	1975-08-18	1975-08-26	1
7585	445	260139	1968-03-15	1968-03-22	1
82822	4924	4112343	2014-03-18	2014-03-26	1
83125	4943	28060	2016-02-23	2016-03-05	1
10212	605	260139	2013-06-09	2013-06-16	1
14871	877	4112343	1992-07-15	1992-07-22	1
89621	5333	4112343	1962-10-27	1962-11-05	1
87792	5229	4059173	1989-10-06	1989-11-05	1
24251	1447	40481087	1962-01-12	1962-02-02	1
21104	1267	4112343	1954-10-26	1954-11-02	1
72840	4333	440448	1980-08-22	1980-08-23	1
19095	1146	372328	1961-05-18	1961-06-22	1
84958	5058	260139	1991-04-19	1991-05-03	1
17005	1017	4112343	1966-10-15	1966-10-27	1
17796	1072	40481087	1996-10-22	1996-10-29	1
65365	3869	40481087	1955-01-22	1955-02-05	1
11611	686	40481087	1959-03-08	1959-03-15	1
74942	4454	4237458	1955-12-16	1956-01-15	1
78629	4662	4113008	1998-07-29	1998-08-19	1
53847	3191	260139	1992-05-26	1992-06-09	1
22797	1360	40481087	2003-01-15	2003-01-29	1
71632	4253	192671	2018-10-25	2018-10-26	1
50153	2965	4142905	1971-02-18	1971-04-19	1
75430	4482	4027663	1979-07-15	1979-07-16	1
23532	1408	4156265	1972-09-24	1972-10-08	1
70364	4173	4112343	1965-10-06	1965-10-13	1
15677	929	40481087	1927-04-17	1927-05-08	1
21550	1293	28060	1951-01-28	1951-02-09	1
84143	5002	260139	2009-09-15	2009-09-29	1
19941	1202	4112343	2015-01-29	2015-02-11	1
66694	3950	40481087	1990-04-26	1990-05-17	1
11520	680	28060	1991-06-20	1991-07-01	1
67603	3997	40481087	1992-08-30	1992-09-13	1
65474	3875	4112343	2008-06-21	2008-06-28	1
59560	3533	40481087	1987-11-16	1987-11-30	1
72049	4279	40481087	1980-10-25	1980-11-08	1
18292	1101	260139	2009-02-01	2009-02-15	1
88047	5240	378001	1955-09-01	1955-10-01	1
82974	4933	4218389	1984-09-08	1984-10-06	1
11982	709	4112343	1979-02-26	1979-03-06	1
66332	3930	28060	1923-04-18	1923-04-27	1
21367	1282	40481087	2015-02-10	2015-02-24	1
69765	4131	40481087	2003-05-17	2003-05-24	1
50644	3000	40479422	1975-08-28	1975-11-03	1
74369	4419	78272	1983-07-04	1983-08-08	1
82564	4907	28060	1992-09-14	1992-09-24	1
22315	1333	28060	1957-12-18	1957-12-27	1
80571	4782	260139	1995-06-12	1995-06-26	1
22280	1332	4112343	2008-01-29	2008-02-08	1
18643	1123	40481087	1989-02-25	1989-03-11	1
80111	4754	257012	2000-06-13	2000-06-14	1
86658	5165	80180	2008-02-20	2008-02-21	1
8747	512	4278672	1967-03-11	1967-04-10	1
70424	4176	260139	1945-03-07	1945-03-14	1
18028	1084	40481087	1986-06-02	1986-06-09	1
75538	4487	81151	1965-05-03	1965-05-24	1
18088	1088	28060	1984-09-10	1984-09-23	1
7586	445	378419	1990-07-27	1990-07-28	1
82823	4924	4294548	2016-07-05	2016-08-30	1
83126	4943	80180	1996-03-09	1996-03-10	1
10213	605	4112343	1968-02-28	1968-03-09	1
14872	877	4278672	1984-12-06	1985-01-05	1
89622	5333	40481087	1996-07-13	1996-08-03	1
87793	5229	4109685	1986-11-30	1986-12-21	1
24252	1447	40481087	2013-09-18	2013-09-25	1
21105	1267	4112343	1961-06-29	1961-07-10	1
72841	4333	4112343	1996-11-10	1996-11-17	1
19096	1146	4112343	2003-11-15	2003-11-23	1
84959	5058	260139	1995-04-25	1995-05-04	1
17006	1017	4112343	1995-11-19	1995-11-29	1
17797	1072	81151	1968-03-08	1968-04-05	1
65366	3869	40481087	1969-01-19	1969-02-09	1
11612	686	40481087	1960-10-13	1960-10-20	1
74943	4454	40481087	1922-01-24	1922-02-14	1
78630	4662	40481087	1987-07-19	1987-08-09	1
53848	3191	260139	2016-07-03	2016-07-17	1
22798	1360	40481087	2003-05-07	2003-05-28	1
71633	4253	4027663	2010-12-15	2010-12-16	1
50154	2965	40481087	1976-11-15	1976-11-22	1
75431	4482	4112343	1950-12-20	1950-12-27	1
23533	1408	40481087	2018-09-19	2018-09-26	1
70365	4173	4112343	1985-11-22	1985-12-02	1
15678	929	40481087	1930-12-27	1931-01-03	1
21551	1293	80180	1979-07-09	1979-07-10	1
84144	5002	372328	1976-10-06	1976-12-17	1
19942	1202	40481087	2008-08-03	2008-08-17	1
66695	3950	80180	2014-12-04	2014-12-05	1
11521	680	81151	1971-03-22	1971-04-05	1
67604	3997	40481087	1999-07-17	1999-07-31	1
65475	3875	4283893	2011-04-06	2011-11-30	1
59561	3533	40481087	2016-12-24	2017-01-14	1
72050	4279	40481087	1984-07-25	1984-08-01	1
18293	1101	321042	1982-08-22	1982-08-23	1
88048	5240	4112343	2001-04-28	2001-05-07	1
82975	4933	81151	1986-08-27	1986-10-01	1
11983	709	4329847	2005-08-28	2005-08-29	1
66333	3930	28060	1927-10-05	1927-10-18	1
23965	1432	80180	2005-01-30	2005-01-31	1
73625	4380	192671	2001-10-25	2001-10-26	1
50645	3000	40481087	2004-04-24	2004-05-01	1
74370	4419	260139	1956-01-21	1956-01-28	1
82565	4907	257012	1974-09-15	1974-09-16	1
22316	1333	260139	2006-02-08	2006-02-15	1
80572	4782	4112343	2005-03-01	2005-03-12	1
22281	1332	4113008	1975-05-09	1975-05-30	1
18644	1123	40481087	2019-05-25	2019-06-01	1
80112	4754	260139	1994-08-07	1994-08-21	1
86659	5165	4112343	2005-04-22	2005-05-01	1
8748	512	260139	2013-06-07	2013-06-14	1
70425	4176	260139	1972-12-01	1972-12-08	1
18224	1098	81151	2016-11-06	2016-11-27	1
75539	4487	260139	1987-09-11	1987-09-18	1
18089	1088	260139	1987-10-20	1987-10-27	1
7587	445	4112343	1944-12-25	1945-01-03	1
82824	4924	40481087	1992-10-02	1992-10-09	1
83127	4943	81151	1995-09-29	1995-10-13	1
10214	605	4112343	1995-11-26	1995-12-09	1
14873	877	260139	1998-03-16	1998-03-30	1
89623	5333	192671	1986-09-06	1986-09-07	1
87794	5229	4112343	1973-05-26	1973-06-06	1
24253	1447	81151	2017-07-22	2017-08-26	1
21106	1267	4112343	1969-12-26	1970-01-05	1
72842	4333	40481087	1956-01-19	1956-01-26	1
19097	1146	40481087	1970-03-29	1970-04-12	1
84960	5058	4027663	1969-01-30	1969-01-31	1
17007	1017	40481087	1970-01-21	1970-01-28	1
17798	1072	257012	2016-01-31	2016-02-01	1
65367	3869	40481087	1978-09-11	1978-10-02	1
11613	686	40481087	1961-12-21	1961-12-28	1
74944	4454	40481087	1991-01-14	1991-02-04	1
78631	4662	40481087	1995-10-04	1995-10-25	1
53849	3191	372328	1960-04-13	1960-09-01	1
22799	1360	40481087	2017-02-23	2017-03-09	1
71634	4253	40481087	1984-10-11	1984-10-25	1
52706	3125	81151	1986-12-22	1987-01-19	1
75432	4482	4112343	1958-11-30	1958-12-07	1
23534	1408	80180	1981-03-10	1981-03-11	1
70366	4173	4112343	2014-07-28	2014-08-07	1
15679	929	40481087	1958-03-29	1958-04-12	1
21552	1293	4059173	1945-10-25	1945-11-24	1
84145	5002	372328	1985-11-05	1986-04-18	1
21665	1303	372328	1977-04-18	1977-05-29	1
66696	3950	192671	2015-01-14	2015-01-15	1
11522	680	257012	1995-07-07	1995-07-08	1
67605	3997	28060	1967-05-21	1967-06-02	1
65476	3875	4294548	1974-02-09	1974-04-06	1
59562	3533	80180	2001-01-03	2001-01-04	1
72051	4279	40481087	1995-03-26	1995-04-02	1
18294	1101	378001	1977-09-01	1977-10-01	1
88049	5240	4142905	1997-04-08	1997-06-07	1
82976	4933	4266809	2007-06-14	2007-06-15	1
11984	709	28060	1967-11-09	1967-11-22	1
66334	3930	4112343	1941-01-09	1941-01-16	1
23966	1432	260139	1983-03-06	1983-03-20	1
73626	4380	260139	1983-07-27	1983-08-10	1
50646	3000	80180	1983-09-20	1983-09-21	1
74371	4419	4112343	1965-10-30	1965-11-06	1
82566	4907	260139	2004-09-07	2004-09-14	1
22317	1333	40481087	1957-02-25	1957-03-11	1
80573	4782	4266809	2017-09-07	2017-09-08	1
22282	1332	4218389	1971-08-30	1971-09-27	1
18645	1123	372328	1968-09-08	1968-10-31	1
80113	4754	4112343	2008-07-14	2008-07-24	1
86660	5165	4283893	1990-12-15	1991-03-16	1
8749	512	372328	1994-12-14	1996-03-01	1
70426	4176	260139	1983-05-01	1983-05-15	1
18225	1098	260139	1980-06-11	1980-06-25	1
75540	4487	260139	1990-10-03	1990-10-10	1
18090	1088	260139	1996-10-10	1996-10-24	1
7588	445	40481087	1911-10-27	1911-11-10	1
82825	4924	40481087	2001-04-02	2001-04-16	1
83128	4943	260139	1969-10-18	1969-10-25	1
10215	605	378001	1977-01-26	1977-03-27	1
14874	877	375671	1978-05-28	1978-07-27	1
89624	5333	255848	2002-11-08	2002-11-09	1
87795	5229	4112343	1975-01-31	1975-02-07	1
24254	1447	260139	1988-09-18	1988-10-02	1
21107	1267	4112343	2012-12-20	2013-01-02	1
72843	4333	40481087	1987-01-06	1987-01-20	1
19098	1146	40481087	2009-11-20	2009-12-11	1
84961	5058	4112343	2002-09-04	2002-09-16	1
17008	1017	40481087	1977-12-25	1978-01-01	1
17799	1072	4112343	1979-07-24	1979-08-02	1
65368	3869	80180	1943-07-03	1943-07-04	1
11614	686	40481087	1963-07-29	1963-08-05	1
75606	4490	28060	1971-03-29	1971-04-07	1
78632	4662	40481087	2006-06-06	2006-06-27	1
53850	3191	4218389	1999-03-30	1999-05-04	1
22800	1360	195588	2014-09-25	2014-11-06	1
72811	4331	378001	1976-09-05	1976-11-04	1
52707	3125	81893	1984-02-10	1984-02-11	1
75433	4482	4112343	2011-06-18	2011-06-29	1
23535	1408	81151	1959-08-06	1959-09-03	1
70367	4173	40481087	2007-09-12	2007-09-26	1
15680	929	40481087	1985-04-29	1985-05-20	1
21553	1293	4112343	1981-01-22	1981-02-04	1
84146	5002	4112343	1989-05-19	1989-05-28	1
21666	1303	372328	1977-10-26	1978-02-26	1
66697	3950	4112343	1981-08-08	1981-08-18	1
11523	680	375671	1979-10-20	1979-12-19	1
67606	3997	28060	1969-08-23	1969-09-01	1
65477	3875	4296205	1962-10-28	1962-11-18	1
59563	3533	81151	1972-06-04	1972-06-18	1
72052	4279	40481087	2001-11-02	2001-11-16	1
18295	1101	4152936	2014-10-06	2014-10-20	1
88050	5240	40481087	1956-07-05	1956-07-19	1
82977	4933	4310024	2005-09-22	2005-09-23	1
11985	709	260139	1961-03-12	1961-03-26	1
66335	3930	4112343	1956-06-14	1956-06-27	1
23967	1432	4112343	1962-11-24	1962-12-05	1
73627	4380	4142905	1970-05-19	1970-07-18	1
50647	3000	81151	1976-10-28	1976-12-02	1
74372	4419	80180	1990-12-31	1991-01-01	1
82567	4907	4112343	1967-03-26	1967-04-06	1
22318	1333	40481087	1978-12-24	1979-01-07	1
80574	4782	28060	2006-03-11	2006-03-19	1
22283	1332	4294548	2014-07-07	2015-01-05	1
18646	1123	372328	1970-01-26	1970-05-07	1
80114	4754	40481087	1974-03-09	1974-03-23	1
86661	5165	4294548	2009-05-31	2010-04-04	1
8750	512	4112343	1958-03-04	1958-03-13	1
70427	4176	372328	1918-10-01	1918-12-12	1
18226	1098	4112343	1976-12-10	1976-12-23	1
75541	4487	4112343	2005-01-20	2005-01-28	1
18091	1088	372328	1973-10-23	1974-01-06	1
7589	445	40481087	1964-12-01	1964-12-15	1
82826	4924	80180	2014-01-19	2014-01-20	1
83129	4943	378001	1993-07-11	1993-09-09	1
10216	605	378001	2000-03-08	2000-05-07	1
14875	877	4112343	1996-06-05	1996-06-15	1
89625	5333	372328	1950-12-25	1951-06-10	1
87796	5229	4278672	1963-11-26	1964-02-24	1
24255	1447	260139	2009-01-17	2009-01-31	1
21108	1267	4113008	1968-03-29	1968-04-19	1
72844	4333	80180	1994-06-03	1994-06-04	1
19099	1146	195588	1986-01-08	1986-02-15	1
84962	5058	4218389	1975-06-23	1975-07-14	1
17009	1017	40481087	1990-05-03	1990-05-17	1
17800	1072	4112343	2008-08-16	2008-08-27	1
65369	3869	260139	1941-06-30	1941-07-14	1
11615	686	40481087	1968-01-19	1968-01-26	1
75607	4490	4112343	1971-05-09	1971-05-18	1
78633	4662	28060	1953-08-23	1953-09-05	1
53851	3191	81151	1995-04-15	1995-05-20	1
22801	1360	260139	1981-02-07	1981-02-14	1
72812	4331	4155034	1989-10-27	1989-11-10	1
52708	3125	260139	1962-10-20	1962-11-03	1
75434	4482	4112343	2017-01-02	2017-01-09	1
23536	1408	257012	1982-10-24	1982-10-25	1
70368	4173	28060	1974-03-03	1974-03-11	1
15681	929	40481087	2003-08-04	2003-08-18	1
21554	1293	4294548	1979-12-09	1980-03-30	1
85870	5116	28060	1992-06-04	1992-06-16	1
21667	1303	28060	1976-08-23	1976-09-03	1
66698	3950	4266809	2014-12-04	2014-12-05	1
11524	680	4112343	1995-02-26	1995-03-10	1
67607	3997	80180	2011-09-26	2011-09-27	1
69352	4109	192671	2002-03-25	2002-03-26	1
59564	3533	81151	1973-07-13	1973-08-03	1
72053	4279	28060	1975-10-09	1975-10-16	1
18296	1101	40481087	1986-11-18	1986-12-02	1
88051	5240	40481087	1998-04-27	1998-05-04	1
82978	4933	40481087	1978-03-28	1978-04-11	1
11986	709	317576	1999-07-04	1999-07-05	1
66336	3930	4329847	1979-12-29	1979-12-30	1
23968	1432	4112343	1979-08-22	1979-09-02	1
73628	4380	40481087	1991-04-07	1991-04-14	1
50648	3000	81151	2010-04-20	2010-05-25	1
74373	4419	81151	1972-01-28	1972-03-03	1
82568	4907	4116491	1985-01-23	1985-03-17	1
22319	1333	40481087	1980-12-03	1980-12-24	1
80575	4782	260139	1998-07-16	1998-07-23	1
22284	1332	40481087	1952-09-16	1952-09-23	1
18647	1123	372328	1971-09-29	1972-05-18	1
80115	4754	40481087	1975-07-24	1975-07-31	1
86662	5165	28060	1969-05-31	1969-06-09	1
8751	512	4112343	1960-05-03	1960-05-11	1
70428	4176	4109685	1927-11-13	1927-11-27	1
18227	1098	4112343	2006-11-04	2006-11-11	1
75542	4487	4113008	1968-06-07	1968-06-28	1
18092	1088	4112343	2005-07-08	2005-07-21	1
7590	445	40481087	1990-12-12	1990-12-19	1
82827	4924	133834	1979-06-14	1995-10-05	1
83130	4943	4112343	1967-04-14	1967-04-27	1
10217	605	4146173	1993-06-22	1993-07-22	1
14876	877	4113008	1992-05-28	1992-06-11	1
89626	5333	4112343	1965-11-23	1965-12-02	1
87797	5229	4294548	2000-06-20	2000-07-04	1
24256	1447	4112343	2018-03-31	2018-04-08	1
21109	1267	4116491	1996-04-27	1996-06-03	1
72845	4333	81151	2011-12-01	2011-12-15	1
19100	1146	260139	1990-11-30	1990-12-14	1
84963	5058	40481087	1979-04-15	1979-05-06	1
17010	1017	40481087	2018-05-09	2018-05-30	1
17801	1072	4294548	1988-07-09	1988-07-30	1
65370	3869	321042	1926-10-09	1926-10-10	1
11616	686	40481087	1969-10-26	1969-11-02	1
75608	4490	4155034	1956-02-09	1956-03-01	1
78634	4662	28060	1958-01-16	1958-01-29	1
53852	3191	260139	2013-10-08	2013-10-15	1
22802	1360	260139	2009-11-12	2009-11-26	1
72813	4331	40481087	1977-09-07	1977-09-14	1
52709	3125	260139	1979-06-22	1979-07-06	1
75435	4482	4134304	1966-12-23	1967-01-22	1
23537	1408	372328	1953-12-13	1954-08-16	1
70369	4173	4152936	2012-06-18	2012-07-02	1
15682	929	80180	1961-08-13	1961-08-14	1
21555	1293	28060	1976-07-11	1976-07-22	1
85871	5116	260139	1970-05-07	1970-05-21	1
21668	1303	80180	2012-03-05	2012-03-06	1
66699	3950	40481087	1999-03-09	1999-03-16	1
11525	680	40481087	1980-07-25	1980-08-01	1
67608	3997	260139	2017-07-22	2017-07-29	1
69353	4109	260139	1973-05-19	1973-05-26	1
59565	3533	81893	1999-04-14	1999-04-15	1
72054	4279	260139	1980-12-23	1980-12-30	1
18297	1101	0	1985-08-17	1985-08-18	1
88520	5268	80180	2004-01-04	2004-01-05	1
82979	4933	40481087	2004-06-16	2004-06-30	1
11987	709	4112343	1950-09-27	1950-10-08	1
66337	3930	40481087	1972-04-07	1972-04-21	1
23969	1432	40481087	1964-05-23	1964-06-13	1
73629	4380	40481087	1991-06-19	1991-07-03	1
50649	3000	4112343	1961-07-18	1961-07-30	1
74374	4419	192671	1991-01-20	1991-01-21	1
82569	4907	4134304	1953-03-27	1953-05-26	1
22320	1333	40481087	2018-03-17	2018-04-07	1
80576	4782	4112343	2003-01-31	2003-02-08	1
22285	1332	40481087	1976-06-14	1976-06-21	1
18648	1123	40481087	1969-08-09	1969-08-30	1
80116	4754	40481087	1985-12-26	1986-01-02	1
86663	5165	28060	1973-02-15	1973-02-27	1
8752	512	4112343	1998-12-16	1998-12-27	1
70429	4176	4112343	1991-02-08	1991-02-15	1
18228	1098	40481087	1973-09-15	1973-10-06	1
75543	4487	4218389	2005-10-26	2005-11-16	1
18093	1088	4112343	2005-08-24	2005-09-04	1
7591	445	80180	1953-11-30	1953-12-01	1
82828	4924	260139	2002-06-07	2002-06-14	1
83131	4943	4112343	1986-05-11	1986-05-20	1
10218	605	4156265	1997-05-02	1997-05-23	1
14877	877	4152936	2005-10-22	2005-11-05	1
89627	5333	40481087	1984-10-23	1984-11-06	1
87798	5229	80180	2004-04-14	2004-04-15	1
24257	1447	40481087	2016-11-14	2016-11-28	1
21110	1267	40481087	1961-01-13	1961-01-27	1
72846	4333	260139	1970-12-27	1971-01-03	1
19101	1146	378001	1977-10-17	1977-12-16	1
84964	5058	40481087	2001-10-16	2001-10-23	1
17011	1017	80180	1997-08-24	1997-08-25	1
17802	1072	40481087	1973-08-03	1973-08-17	1
65371	3869	378419	1987-09-26	1987-09-27	1
11617	686	4059173	1954-02-27	1954-03-29	1
75609	4490	4237458	1932-12-11	1933-03-11	1
78635	4662	80180	1994-06-10	1994-06-11	1
53853	3191	4112343	1996-10-13	1996-10-25	1
22803	1360	260139	2015-09-29	2015-10-06	1
72814	4331	40481087	2005-09-09	2005-09-16	1
52710	3125	260139	2010-07-06	2010-07-13	1
75436	4482	4266809	1987-08-27	1987-08-28	1
23538	1408	4112343	1989-06-26	1989-07-06	1
70370	4173	40481087	1963-10-20	1963-11-03	1
15683	929	260139	1934-08-16	1934-08-23	1
21556	1293	260139	2014-10-24	2014-10-31	1
85872	5116	260139	1989-04-14	1989-04-28	1
21669	1303	378001	2007-04-11	2007-06-10	1
66700	3950	40481087	2007-01-09	2007-01-16	1
15502	919	260139	1975-09-09	1975-09-16	1
67609	3997	4112343	1969-12-04	1969-12-12	1
69354	4109	372328	1967-02-01	1967-05-09	1
59566	3533	372328	1969-02-04	1969-11-26	1
72055	4279	4142905	2011-07-21	2011-09-19	1
18298	1101	80180	2016-01-25	2016-01-26	1
88521	5268	260139	1972-03-24	1972-04-07	1
88501	5267	28060	1972-02-23	1972-03-07	1
11988	709	40481087	1957-01-13	1957-02-03	1
66338	3930	0	1979-12-29	1979-12-30	1
23970	1432	40481087	1993-04-09	1993-04-30	1
73630	4380	40481087	1993-06-30	1993-07-21	1
50650	3000	4112343	1976-11-12	1976-11-25	1
74375	4419	4112343	1972-12-02	1972-12-14	1
82570	4907	40481087	1948-05-31	1948-06-07	1
22321	1333	80180	1993-07-10	1993-07-11	1
80577	4782	4310024	2015-06-20	2015-06-21	1
22286	1332	40481087	2010-01-13	2010-01-20	1
18649	1123	40481087	1994-06-22	1994-06-29	1
80117	4754	260139	1971-08-12	1971-08-26	1
86664	5165	257012	1991-01-19	1991-01-20	1
8753	512	40481087	1956-08-12	1956-09-02	1
70430	4176	4294548	1996-11-26	1996-12-31	1
18229	1098	40481087	1998-03-07	1998-03-28	1
75544	4487	40481087	1967-05-25	1967-06-01	1
18094	1088	4266809	2011-07-11	2011-07-12	1
7592	445	255848	1996-05-26	1996-05-27	1
82829	4924	4155034	1991-06-02	1991-06-23	1
83132	4943	4112343	2017-05-02	2017-05-09	1
10219	605	40481087	1972-05-25	1972-06-15	1
14878	877	4294548	1982-12-11	1983-01-08	1
89628	5333	40481087	1999-01-27	1999-02-10	1
87799	5229	260139	2001-12-17	2001-12-31	1
24258	1447	372328	1974-03-05	1974-09-19	1
21111	1267	40481087	1978-01-22	1978-01-29	1
72847	4333	40481087	1973-05-04	1973-05-18	1
19102	1146	4237458	2001-09-11	2001-10-11	1
84965	5058	378001	1945-08-29	1945-10-28	1
17012	1017	257012	2010-02-28	2010-03-01	1
17803	1072	40481087	1993-10-09	1993-10-30	1
65372	3869	4112343	1944-08-09	1944-08-21	1
11618	686	4112343	1960-08-28	1960-09-05	1
75610	4490	40481087	1982-08-25	1982-09-15	1
78636	4662	257012	1984-11-27	1984-11-28	1
53854	3191	260139	2000-10-05	2000-10-12	1
22804	1360	4112343	1985-04-17	1985-04-25	1
72815	4331	40481087	2009-08-31	2009-09-14	1
52711	3125	4112343	1968-05-07	1968-05-16	1
75437	4482	4310024	1985-06-08	1985-06-09	1
23539	1408	4112343	2011-11-07	2011-11-19	1
70371	4173	40481087	1986-11-13	1986-11-27	1
15684	929	260139	1963-08-24	1963-09-07	1
21557	1293	372328	1941-05-19	1941-06-02	1
85873	5116	260139	1998-03-25	1998-04-01	1
21670	1303	40481087	2013-07-17	2013-08-07	1
68914	4084	260139	1987-01-26	1987-02-09	1
15503	919	260139	1998-11-09	1998-11-16	1
67610	3997	4112343	1978-06-17	1978-06-28	1
69355	4109	372328	2013-08-05	2014-12-02	1
59567	3533	4112343	2003-07-09	2003-07-21	1
72056	4279	40481087	1964-08-30	1964-09-06	1
18299	1101	258780	2000-06-25	2000-06-26	1
88522	5268	372328	1965-09-25	1965-12-05	1
88502	5267	78272	1976-01-16	1976-02-20	1
14604	864	80180	1958-05-04	1958-05-05	1
66339	3930	260139	1935-02-28	1935-03-14	1
23971	1432	40481087	1999-01-23	1999-02-13	1
73631	4380	80180	2001-09-28	2001-09-29	1
50651	3000	4134304	1961-04-08	1961-07-07	1
74376	4419	4218389	1971-03-06	1971-04-03	1
82571	4907	80502	2016-05-14	2016-05-15	1
22322	1333	4152936	2013-05-27	2013-06-17	1
80578	4782	260139	2004-05-18	2004-05-25	1
22287	1332	0	2019-01-02	2019-01-03	1
18650	1123	28060	2002-10-03	2002-10-12	1
80118	4754	260139	1991-09-13	1991-09-20	1
86665	5165	4112343	1973-01-03	1973-01-15	1
8754	512	40481087	2004-08-02	2004-08-16	1
70431	4176	4296204	1942-12-08	1943-01-05	1
18230	1098	40481087	2001-01-03	2001-01-10	1
75545	4487	40481087	1996-01-27	1996-02-10	1
18095	1088	40481087	1981-04-23	1981-05-07	1
7593	445	4029498	1925-09-18	1925-09-19	1
82830	4924	28060	1980-03-07	1980-03-17	1
83133	4943	4283893	1997-05-29	1997-11-20	1
10220	605	80180	1995-02-21	1995-02-22	1
14879	877	40481087	2002-03-06	2002-03-27	1
89629	5333	28060	1987-09-01	1987-09-10	1
87800	5229	372328	1963-11-26	1964-05-13	1
24259	1447	4084167	1970-08-23	1970-08-23	1
21112	1267	80180	1990-05-14	1990-05-15	1
72848	4333	81151	1959-08-26	1959-09-30	1
19103	1146	40481087	1960-03-17	1960-03-31	1
84966	5058	4296204	1943-08-05	1943-09-09	1
17013	1017	260139	2007-02-09	2007-02-16	1
17804	1072	40481087	1994-12-02	1994-12-09	1
65373	3869	40481087	1923-01-10	1923-01-31	1
11619	686	4112343	1979-06-05	1979-06-15	1
75611	4490	81151	1925-12-22	1926-01-05	1
78637	4662	260139	2003-12-27	2004-01-03	1
53855	3191	381316	2015-09-24	2015-09-25	1
22805	1360	4134304	2013-06-17	2013-08-16	1
72816	4331	40481087	2014-02-25	2014-03-04	1
52712	3125	4112343	1994-08-10	1994-08-18	1
75438	4482	40481087	1954-01-23	1954-02-06	1
23540	1408	4283893	1994-08-11	1995-02-09	1
70372	4173	40481087	1997-01-11	1997-02-01	1
15685	929	260139	1967-11-16	1967-11-30	1
21558	1293	4112343	1953-04-03	1953-04-11	1
85874	5116	260139	2011-04-24	2011-05-01	1
21671	1303	28060	2005-07-16	2005-07-29	1
68915	4084	4134304	1976-08-01	1976-08-31	1
15504	919	4112343	1974-10-13	1974-10-25	1
67611	3997	4283893	2012-03-17	2012-06-16	1
69356	4109	4027663	1991-11-25	1991-11-26	1
59568	3533	81151	1996-07-03	1996-08-07	1
72057	4279	40481087	1977-02-19	1977-03-05	1
18300	1101	260139	1978-03-10	1978-03-24	1
88523	5268	378001	2012-08-03	2012-09-02	1
88503	5267	80180	2006-01-08	2006-01-09	1
14605	864	260139	1930-05-07	1930-05-21	1
66340	3930	4152936	1917-05-20	1917-06-10	1
23972	1432	260139	1972-06-04	1972-06-11	1
73632	4380	440086	1977-04-17	1978-01-29	1
50652	3000	4296205	1970-11-08	1970-11-22	1
74377	4419	40481087	1980-04-13	1980-05-04	1
82572	4907	260139	1951-02-21	1951-03-07	1
22323	1333	4218389	1976-12-06	1977-01-10	1
80579	4782	40481087	1984-05-15	1984-05-22	1
22288	1332	78272	1950-12-22	1951-01-05	1
18651	1123	260139	1977-03-26	1977-04-09	1
80119	4754	372328	1968-10-29	1969-09-30	1
86666	5165	40481087	1998-09-10	1998-09-17	1
14186	841	133834	1955-07-06	1969-06-30	1
70432	4176	40481087	1933-11-17	1933-12-01	1
18231	1098	80180	1996-09-10	1996-09-11	1
75546	4487	40481087	1996-03-16	1996-03-23	1
18096	1088	4113008	1976-04-10	1976-05-01	1
7594	445	4112343	1954-01-20	1954-01-31	1
82831	4924	28060	1985-05-24	1985-06-01	1
83134	4943	40479768	1979-11-15	1979-12-22	1
10221	605	260139	1961-03-22	1961-04-05	1
14880	877	40481087	2003-05-27	2003-06-10	1
89630	5333	81151	1990-03-30	1990-05-04	1
87801	5229	4027663	1993-11-28	1993-11-29	1
24260	1447	4112343	1974-01-08	1974-01-19	1
21113	1267	257012	1973-05-04	1973-05-05	1
72849	4333	260139	1980-01-17	1980-01-31	1
19104	1146	40481087	1967-06-01	1967-06-08	1
84967	5058	40481087	1957-09-28	1957-10-05	1
17014	1017	4112343	2018-08-26	2018-09-03	1
19828	1194	260139	2003-06-30	2003-07-14	1
65374	3869	40481087	1924-05-03	1924-05-24	1
11620	686	4112343	2007-01-05	2007-01-17	1
75612	4490	372328	1926-04-21	1926-06-05	1
78638	4662	4112343	1971-11-21	1971-11-30	1
53856	3191	4112343	1960-03-31	1960-04-11	1
22806	1360	4266809	2018-06-11	2018-06-12	1
72817	4331	80180	2017-03-24	2017-03-25	1
52713	3125	40481087	1966-05-03	1966-05-17	1
75439	4482	40481087	1982-12-07	1982-12-28	1
23541	1408	40481087	1959-04-06	1959-04-27	1
70373	4173	40481087	2018-05-20	2018-05-27	1
15686	929	378001	1988-09-03	1988-10-03	1
21559	1293	4112343	1979-10-22	1979-10-29	1
85875	5116	372328	1966-10-16	1966-10-30	1
21672	1303	81893	2010-10-12	2010-10-13	1
68916	4084	4294548	1980-09-29	1980-10-06	1
15505	919	4294548	2002-02-06	2002-02-13	1
69845	4137	261325	2012-02-01	2012-02-02	1
69357	4109	4051466	1967-12-08	1984-03-15	1
59569	3533	260139	1994-10-09	1994-10-23	1
72200	4289	28060	1944-11-07	1944-11-19	1
18301	1101	40481087	2011-05-30	2011-06-13	1
88524	5268	260139	2005-08-07	2005-08-14	1
88504	5267	4112343	2013-12-30	2014-01-07	1
14606	864	4112343	1927-12-01	1927-12-13	1
66341	3930	40481087	1927-02-28	1927-03-14	1
23973	1432	260139	2018-09-16	2018-09-23	1
73633	4380	4112343	1986-04-28	1986-05-07	1
50653	3000	4310024	1981-01-03	1981-01-04	1
74378	4419	81151	1959-07-02	1959-08-06	1
82573	4907	372328	1948-12-18	1949-01-08	1
22324	1333	40481087	1973-10-09	1973-10-16	1
85550	5095	81151	1979-01-31	1979-02-21	1
22289	1332	260139	1999-12-14	1999-12-21	1
18652	1123	4112343	1971-05-29	1971-06-05	1
80120	4754	4218389	1991-06-22	1991-07-27	1
86667	5165	40481087	2012-08-13	2012-08-20	1
14187	841	192671	1991-06-27	1991-06-28	1
70433	4176	40481087	1968-05-09	1968-05-23	1
18232	1098	81151	1961-09-09	1961-09-30	1
75547	4487	40481087	2006-09-20	2006-09-27	1
18097	1088	40481087	2011-04-09	2011-04-23	1
7595	445	4112343	1996-01-29	1996-02-09	1
82832	4924	28060	2000-09-24	2000-10-04	1
83135	4943	40481087	2004-07-20	2004-07-27	1
10222	605	260139	1972-04-09	1972-04-23	1
14881	877	80180	2016-02-13	2016-02-14	1
89631	5333	372328	1952-07-04	1952-12-07	1
87802	5229	4112343	2013-04-05	2013-04-18	1
24261	1447	4116491	2009-07-19	2009-09-07	1
21114	1267	375671	1953-03-04	1953-05-03	1
72850	4333	4027663	1982-08-20	1982-08-21	1
19105	1146	40481087	2006-11-15	2006-11-29	1
84968	5058	40481087	1972-12-04	1972-12-11	1
17015	1017	4155034	1984-10-17	1984-11-07	1
19829	1194	4112343	1960-10-23	1960-10-30	1
65375	3869	40481087	1935-10-29	1935-11-12	1
11621	686	4296204	1963-07-11	1963-08-15	1
75613	4490	4112343	1987-04-06	1987-04-14	1
78639	4662	4134304	1965-01-02	1965-02-01	1
53857	3191	4112343	2012-04-07	2012-04-18	1
22807	1360	40481087	2004-01-02	2004-01-23	1
72818	4331	40481087	1979-01-13	1979-02-03	1
52714	3125	40481087	1985-02-09	1985-02-23	1
75440	4482	260139	1994-04-12	1994-04-26	1
23542	1408	40481087	1994-02-15	1994-03-08	1
70374	4173	28060	1977-11-23	1977-12-03	1
15687	929	4051466	1922-08-10	1939-07-10	1
21560	1293	40481087	1940-04-02	1940-04-09	1
85876	5116	4112343	2006-05-21	2006-05-29	1
21673	1303	260139	1977-02-18	1977-02-25	1
68917	4084	40481087	1987-02-08	1987-03-01	1
15506	919	40481087	1979-03-28	1979-04-04	1
69846	4137	372328	1963-01-15	1963-07-03	1
69358	4109	4112343	1990-10-15	1990-10-24	1
59570	3533	372328	1963-04-23	1963-05-07	1
72201	4289	28060	2001-06-24	2001-07-05	1
18302	1101	40481087	2012-02-17	2012-03-09	1
88525	5268	195588	2019-06-14	2019-06-15	1
88505	5267	28060	1971-05-15	1971-05-27	1
14607	864	40481087	1925-04-08	1925-04-29	1
66342	3930	40481087	1956-10-30	1956-11-20	1
23974	1432	4112343	1972-05-17	1972-05-26	1
73634	4380	4112343	1986-06-07	1986-06-18	1
50654	3000	40481087	1976-04-15	1976-05-06	1
74379	4419	40481087	1970-01-13	1970-01-27	1
82574	4907	4112343	1986-04-11	1986-04-18	1
25064	1497	257012	1972-05-18	1972-05-19	1
85551	5095	260139	2016-05-02	2016-05-09	1
22290	1332	317576	1999-08-04	1999-08-05	1
18653	1123	4112343	1988-11-05	1988-11-17	1
80121	4754	40481087	1976-06-04	1976-06-11	1
86668	5165	260139	1974-12-26	1975-01-02	1
14188	841	375671	1989-06-21	1989-08-20	1
72123	4284	28060	1981-11-13	1981-11-25	1
18233	1098	372328	1961-03-13	1961-11-25	1
75548	4487	28060	1985-03-11	1985-03-18	1
18098	1088	78272	1989-03-15	1989-04-12	1
7596	445	4266809	1953-11-30	1953-12-01	1
82833	4924	28060	2002-02-09	2002-02-18	1
83136	4943	257012	1997-09-04	1997-09-05	1
10223	605	372328	1970-01-31	1970-05-29	1
14882	877	4112343	2016-04-20	2016-05-01	1
89632	5333	4112343	1981-07-23	1981-07-31	1
87803	5229	4285898	2004-03-15	2004-03-16	1
24262	1447	4142905	1975-03-14	1975-04-13	1
21115	1267	4113008	2009-05-14	2009-05-28	1
72851	4333	4113008	1980-05-03	1980-05-17	1
19106	1146	372328	1959-12-11	1960-03-24	1
84969	5058	80180	1978-05-18	1978-05-19	1
17016	1017	40481087	1964-06-21	1964-07-12	1
19830	1194	4112343	1971-06-19	1971-06-29	1
65376	3869	40481087	1939-10-30	1939-11-13	1
11622	686	40481087	1946-10-13	1946-11-03	1
75614	4490	4329847	1988-04-23	1988-04-24	1
78640	4662	40481087	1977-03-06	1977-03-13	1
53858	3191	4155034	1968-09-28	1968-10-12	1
24574	1468	80180	1992-03-26	1992-03-27	1
72819	4331	40481087	2012-10-05	2012-10-26	1
52715	3125	40481087	2015-03-14	2015-04-04	1
75441	4482	372328	1952-11-15	1953-04-18	1
23543	1408	28060	1992-11-20	1992-12-01	1
70375	4173	372328	1977-02-18	1977-06-08	1
15688	929	4112343	1946-01-01	1946-01-14	1
21561	1293	40481087	1951-12-01	1951-12-22	1
85877	5116	40481087	1976-02-04	1976-02-11	1
21674	1303	260139	1981-11-03	1981-11-17	1
68918	4084	40481087	2018-11-30	2018-12-07	1
15507	919	40481087	2007-09-24	2007-10-08	1
69847	4137	372328	1966-06-17	1967-01-11	1
69359	4109	40481087	1966-10-01	1966-10-15	1
59571	3533	40481087	2007-01-24	2007-02-07	1
72202	4289	80180	1978-09-28	1978-09-29	1
18303	1101	28060	1976-03-12	1976-03-19	1
88526	5268	260139	1979-05-09	1979-05-16	1
88506	5267	30753	2004-12-14	2004-12-15	1
14608	864	28060	1935-03-08	1935-03-20	1
66343	3930	40481087	1965-01-14	1965-02-04	1
23975	1432	4112343	1991-05-03	1991-05-13	1
73635	4380	40481087	1986-12-29	1987-01-19	1
50655	3000	40481087	2010-01-22	2010-01-29	1
74380	4419	40481087	1981-05-06	1981-05-27	1
82575	4907	4155034	1964-06-27	1964-07-11	1
25065	1497	4283893	1972-04-13	1972-05-25	1
85552	5095	372328	1965-12-30	1966-03-14	1
22291	1332	4112343	1998-06-10	1998-06-19	1
18654	1123	4112343	1995-10-16	1995-10-24	1
80122	4754	78272	1981-02-23	1981-03-16	1
86669	5165	378001	2000-10-29	2000-11-28	1
14189	841	440448	1961-01-14	1961-01-15	1
72124	4284	28060	2011-09-29	2011-10-07	1
18234	1098	4112343	2010-02-26	2010-03-07	1
75549	4487	4112343	2002-09-16	2002-09-29	1
18099	1088	192671	2011-09-10	2011-09-11	1
7597	445	4283893	1963-09-12	1963-10-31	1
82834	4924	257012	2016-08-09	2016-08-10	1
83137	4943	4029498	1962-02-01	1962-02-02	1
10224	605	4109685	1982-11-26	1982-12-17	1
14883	877	4156265	1984-01-27	1984-02-10	1
89633	5333	40481087	2001-10-02	2001-10-16	1
87804	5229	40481087	1967-09-14	1967-10-05	1
24263	1447	80180	1996-01-09	1996-01-10	1
21116	1267	4294548	1996-09-13	1996-11-08	1
72852	4333	40481087	1994-10-16	1994-11-06	1
19107	1146	4112343	1977-02-07	1977-02-19	1
84970	5058	80502	2017-03-05	2017-03-06	1
17017	1017	40481087	1980-01-29	1980-02-19	1
19831	1194	4294548	1963-02-15	1963-08-16	1
65377	3869	40481087	1974-12-19	1974-12-26	1
12299	728	28060	1997-04-20	1997-04-27	1
75615	4490	40481087	1980-02-12	1980-03-04	1
78641	4662	40481087	1978-08-14	1978-09-04	1
53859	3191	40481087	1976-10-21	1976-10-28	1
24575	1468	260139	1951-10-05	1951-10-19	1
72820	4331	4112343	2005-01-09	2005-01-17	1
52716	3125	80180	1985-01-05	1985-01-06	1
75442	4482	40481087	1951-01-25	1951-02-01	1
23544	1408	4283893	1996-09-09	1996-10-14	1
70376	4173	4112343	1987-06-29	1987-07-08	1
15689	929	4296205	1947-05-23	1947-06-27	1
21562	1293	40481087	1985-03-13	1985-03-27	1
85878	5116	40481087	1978-03-29	1978-04-05	1
21675	1303	4027663	2004-05-16	2004-05-17	1
68919	4084	80180	1996-11-29	1996-11-30	1
15508	919	375671	2004-12-29	2005-01-28	1
69848	4137	4112343	1964-01-11	1964-01-21	1
69360	4109	260139	2015-03-21	2015-04-04	1
60977	3613	28060	1981-04-29	1981-05-11	1
72203	4289	260139	2017-11-11	2017-11-18	1
18304	1101	81151	2009-12-03	2009-12-31	1
88527	5268	4112343	1984-03-22	1984-04-03	1
88507	5267	81893	2004-06-17	2004-06-18	1
14609	864	28060	1947-07-19	1947-07-26	1
66344	3930	78272	1916-06-19	1916-07-24	1
23976	1432	4112343	2014-11-12	2014-11-23	1
73636	4380	40481087	2009-05-04	2009-05-11	1
50656	3000	260139	2003-03-24	2003-03-31	1
76221	4527	260139	1963-08-26	1963-09-02	1
82576	4907	4296205	1983-07-02	1983-08-06	1
25066	1497	40481087	1973-04-26	1973-05-03	1
85553	5095	378001	1986-08-13	1986-10-12	1
22292	1332	4134304	1979-12-05	1980-01-04	1
18655	1123	4112343	2001-04-28	2001-05-09	1
80123	4754	260139	1968-07-03	1968-07-17	1
86670	5165	4112343	1969-08-09	1969-08-18	1
14190	841	4112343	2006-01-18	2006-01-29	1
72125	4284	378001	1954-10-01	1954-11-30	1
18235	1098	4116491	1997-11-29	1998-01-21	1
75550	4487	4230399	1953-09-12	1953-12-11	1
18100	1088	260139	2001-01-18	2001-01-25	1
7598	445	40481087	1922-12-18	1923-01-08	1
82835	4924	260139	2011-05-29	2011-06-05	1
83138	4943	4112343	1984-04-11	1984-04-18	1
10225	605	4112343	1957-07-12	1957-07-24	1
14884	877	81151	1999-04-06	1999-04-27	1
54190	3214	30753	2007-12-03	2007-12-04	1
87805	5229	40481087	2002-10-27	2002-11-17	1
24264	1447	81151	1990-09-21	1990-10-12	1
21117	1267	40481087	1979-11-29	1979-12-06	1
72853	4333	40481087	1997-05-03	1997-05-10	1
19108	1146	4237458	1970-11-25	1971-01-24	1
84971	5058	81151	2000-12-29	2001-01-26	1
17018	1017	4112343	1961-04-02	1961-04-13	1
19832	1194	28060	1972-05-25	1972-06-03	1
68879	4081	81151	2007-08-07	2007-09-11	1
12300	728	80180	1990-03-04	1990-03-05	1
75616	4490	0	1988-04-23	1988-04-24	1
78642	4662	81151	1966-12-23	1967-01-13	1
53860	3191	40481087	1996-06-12	1996-06-26	1
24576	1468	372328	1958-01-29	1958-06-18	1
72821	4331	40481087	2004-07-30	2004-08-06	1
52717	3125	81151	2014-08-28	2014-09-25	1
75443	4482	40481087	1991-02-22	1991-03-15	1
23545	1408	40481087	1948-05-16	1948-06-06	1
70377	4173	40481087	1976-06-02	1976-06-16	1
15690	929	40481087	1945-07-23	1945-07-30	1
21563	1293	40481087	2006-01-30	2006-02-06	1
85879	5116	40481087	1988-04-20	1988-05-04	1
21676	1303	4112343	1998-12-09	1998-12-19	1
68920	4084	260139	1971-08-29	1971-09-12	1
15509	919	4296204	1998-02-13	1998-03-06	1
69849	4137	4218389	1999-04-06	1999-05-04	1
69361	4109	372328	1965-05-30	1965-08-10	1
60978	3613	28060	1991-10-18	1991-10-26	1
72204	4289	4027663	1967-07-13	1967-07-14	1
18305	1101	260139	1993-09-09	1993-09-16	1
88528	5268	4155034	2004-08-31	2004-09-14	1
88508	5267	372328	1968-06-26	1968-11-10	1
14610	864	317576	2003-07-28	2003-07-29	1
66345	3930	192671	1958-01-03	1958-01-04	1
23977	1432	40481087	2000-07-13	2000-08-03	1
73637	4380	40481087	2009-06-15	2009-06-22	1
50657	3000	372328	1948-09-13	1948-12-24	1
76222	4527	260139	1980-05-06	1980-05-20	1
82577	4907	40481087	1996-06-09	1996-06-30	1
25067	1497	40481087	1996-06-09	1996-06-23	1
85554	5095	4112343	2003-02-15	2003-02-23	1
22293	1332	4152936	1966-11-12	1966-12-03	1
18656	1123	4113008	2015-02-25	2015-03-18	1
80124	4754	260139	2016-06-28	2016-07-05	1
86671	5165	4116491	1989-12-06	1990-01-07	1
14191	841	4296205	1972-11-26	1972-12-17	1
72126	4284	4218389	2003-02-16	2003-03-09	1
18236	1098	40481087	2018-05-19	2018-06-02	1
75551	4487	40481087	1965-06-07	1965-06-28	1
18101	1088	4027663	2002-07-23	2002-07-24	1
7599	445	40481087	1946-09-13	1946-09-20	1
82836	4924	4296204	2006-11-01	2006-11-15	1
83139	4943	40481087	2000-07-15	2000-08-05	1
10226	605	4112343	1979-04-13	1979-04-20	1
14885	877	81151	2017-09-03	2017-09-24	1
54191	3214	372328	1972-11-11	1973-01-23	1
87806	5229	81151	1973-06-27	1973-07-11	1
24265	1447	81151	2019-05-18	2019-06-01	1
24520	1466	80180	2004-11-16	2004-11-17	1
72854	4333	40481087	2002-01-19	2002-02-02	1
19109	1146	28060	1978-11-15	1978-11-27	1
84972	5058	4112343	1937-07-08	1937-07-21	1
17019	1017	4112343	1967-03-28	1967-04-07	1
19833	1194	80180	2001-05-27	2001-05-28	1
68880	4081	257012	1998-02-28	1998-05-02	1
12301	728	28060	1966-04-10	1966-04-20	1
75617	4490	80180	1963-09-04	1963-09-05	1
78643	4662	198809	1989-07-27	1989-07-27	1
53861	3191	40481087	1999-12-16	1999-12-30	1
24577	1468	4116491	1998-06-03	1998-07-14	1
72822	4331	372328	1981-12-08	1982-11-12	1
52718	3125	260139	1954-04-15	1954-04-29	1
75444	4482	40481087	2004-08-12	2004-08-26	1
23546	1408	40481087	2015-11-11	2015-11-25	1
70378	4173	40481087	1984-07-13	1984-07-20	1
15691	929	40481087	1950-08-12	1950-09-02	1
21564	1293	40481087	2012-12-07	2012-12-14	1
85880	5116	80180	2010-05-03	2010-05-04	1
21677	1303	4266809	2012-03-05	2012-03-06	1
68921	4084	372328	1962-12-13	1963-01-27	1
15510	919	78272	1979-05-19	1979-06-23	1
69850	4137	40481087	1972-08-07	1972-08-28	1
69362	4109	4112343	1999-06-11	1999-06-20	1
60979	3613	30753	2009-03-12	2009-03-13	1
72205	4289	4237458	1944-06-08	1944-08-07	1
18306	1101	372328	1979-01-24	1979-03-25	1
88529	5268	40481087	2007-11-22	2007-12-13	1
88509	5267	4027663	1996-11-26	1996-11-27	1
14611	864	4112343	1947-11-26	1947-12-03	1
66346	3930	258780	1963-11-23	1963-11-24	1
23978	1432	78272	1963-08-19	1963-09-16	1
73638	4380	40481087	2018-01-13	2018-02-03	1
50658	3000	378001	1952-12-21	1953-02-19	1
76223	4527	372328	1964-02-20	1964-03-05	1
82578	4907	40481087	2005-07-29	2005-08-05	1
25068	1497	40481087	2003-10-14	2003-11-04	1
85555	5095	4296205	1978-03-09	1978-04-06	1
22294	1332	40481087	1962-10-08	1962-10-22	1
18657	1123	80180	2007-02-01	2007-02-02	1
80125	4754	375671	2005-02-13	2005-03-15	1
86672	5165	4218389	2011-09-16	2011-10-21	1
14192	841	40481087	1976-01-23	1976-02-13	1
72127	4284	40481087	1948-08-08	1948-08-29	1
18237	1098	260139	1956-11-05	1956-11-12	1
75552	4487	40481087	1980-11-09	1980-11-16	1
18102	1088	4112343	2008-10-31	2008-11-12	1
7600	445	40481087	1953-10-19	1953-10-26	1
82837	4924	40481087	2017-11-30	2017-12-21	1
85256	5077	81893	2001-11-03	2001-11-04	1
10227	605	40481087	1960-08-29	1960-09-19	1
14886	877	260139	2014-07-22	2014-07-29	1
54192	3214	4027663	1999-02-08	1999-02-09	1
87807	5229	192671	2004-05-03	2004-05-04	1
24266	1447	257012	1993-08-28	1993-08-29	1
24521	1466	260139	2016-02-23	2016-03-01	1
76916	4562	80180	1999-10-06	1999-10-07	1
19110	1146	28060	1990-12-26	1991-01-03	1
84973	5058	4285898	1978-02-17	1978-02-18	1
17020	1017	4112343	1995-10-09	1995-10-17	1
19834	1194	372328	1962-08-10	1962-08-24	1
68881	4081	260139	1988-10-25	1988-11-01	1
12302	728	440086	1964-01-20	1964-12-21	1
75618	4490	81151	1929-12-15	1929-12-29	1
78644	4662	4112343	1976-02-11	1976-02-24	1
53862	3191	40481087	2008-01-03	2008-01-17	1
24578	1468	4155034	1958-09-26	1958-10-10	1
74139	4408	260139	1989-10-09	1989-10-23	1
52719	3125	372328	1976-05-29	1976-09-23	1
75445	4482	28060	1955-06-07	1955-06-16	1
23547	1408	81151	1954-09-03	1954-10-01	1
70379	4173	40481087	2013-07-02	2013-07-09	1
15692	929	40481087	1998-07-31	1998-08-21	1
23933	1431	260139	2003-03-14	2003-03-21	1
85881	5116	81151	1979-07-24	1979-08-14	1
23038	1377	4112343	2017-11-16	2017-11-23	1
68922	4084	4109685	1978-06-22	1978-07-13	1
15511	919	260139	1992-08-19	1992-09-02	1
69851	4137	260139	1976-08-23	1976-08-30	1
69363	4109	4112343	2013-06-19	2013-06-28	1
60980	3613	80180	2010-06-05	2010-06-06	1
72206	4289	4310024	1976-08-09	1976-08-10	1
18307	1101	4166224	1985-08-17	1985-08-18	1
88530	5268	40481087	2011-07-30	2011-08-20	1
88510	5267	40481087	1997-07-20	1997-08-10	1
14612	864	4112343	1956-11-27	1956-12-09	1
66347	3930	372328	1916-01-29	1916-08-05	1
23979	1432	372328	1963-10-18	1964-02-04	1
73639	4380	28060	1994-06-08	1994-06-20	1
50659	3000	40481087	1977-12-03	1977-12-17	1
76224	4527	378001	2016-08-06	2016-09-05	1
82579	4907	0	1948-02-03	1948-02-04	1
25069	1497	81151	1943-09-26	1943-10-24	1
85556	5095	40481087	1998-09-10	1998-09-24	1
22295	1332	40481087	1968-12-23	1969-01-13	1
18658	1123	372328	1968-12-30	1969-05-01	1
80126	4754	4112343	1994-04-12	1994-04-25	1
86673	5165	40481087	2010-11-09	2010-11-16	1
14193	841	80180	1991-05-26	1991-05-27	1
72128	4284	40481087	1987-10-24	1987-11-14	1
18238	1098	4112343	1962-03-10	1962-03-18	1
75553	4487	40481087	1986-12-17	1987-01-07	1
18103	1088	4156265	1988-01-29	1988-02-19	1
7601	445	40481087	1966-09-11	1966-09-18	1
82838	4924	78272	1989-04-15	1989-05-13	1
85257	5077	378001	1976-10-29	1976-11-28	1
10228	605	40481087	1975-05-10	1975-05-24	1
14887	877	4112343	2004-06-07	2004-06-19	1
54193	3214	4112343	1976-06-26	1976-07-05	1
87808	5229	260139	2000-07-16	2000-07-23	1
24267	1447	4059173	1972-06-27	1972-07-27	1
24522	1466	372328	1969-07-28	1969-08-11	1
76917	4562	81151	1971-10-17	1971-11-07	1
19111	1146	28060	2001-12-10	2001-12-22	1
84974	5058	40479422	2014-07-17	2014-09-22	1
17021	1017	4294548	2010-02-07	2010-06-13	1
19835	1194	372328	1963-10-18	1964-01-20	1
68882	4081	4112343	2015-06-03	2015-06-12	1
12303	728	4112343	1997-06-30	1997-07-13	1
75619	4490	40481087	1937-11-26	1937-12-17	1
78645	4662	4112343	2004-11-24	2004-12-06	1
53863	3191	40481087	2014-03-24	2014-04-07	1
24579	1468	40481087	1953-06-02	1953-06-09	1
74140	4408	4112343	2015-09-07	2015-09-15	1
52720	3125	375671	1991-11-08	1991-12-08	1
75446	4482	30753	1986-08-02	1986-08-03	1
23548	1408	260139	1956-07-25	1956-08-01	1
70380	4173	372328	1964-11-06	1965-01-20	1
17131	1025	260139	2018-03-20	2018-04-03	1
23934	1431	260139	2019-03-21	2019-04-04	1
85882	5116	4112343	2014-08-18	2014-08-31	1
23039	1377	80180	2015-07-13	2015-07-14	1
68923	4084	40481087	2010-09-02	2010-09-09	1
15512	919	4112343	1986-08-24	1986-09-06	1
69852	4137	260139	2004-04-01	2004-04-15	1
69364	4109	4218389	1991-12-31	1992-02-04	1
60981	3613	81893	2008-09-13	2008-09-14	1
72207	4289	40481087	1957-12-03	1957-12-17	1
19695	1185	260139	2011-06-06	2011-06-20	1
88531	5268	4237458	2008-08-24	2008-09-23	1
88511	5267	192671	2006-04-03	2006-04-04	1
14613	864	4155034	1939-10-06	1939-10-27	1
66348	3930	4112343	1947-10-13	1947-10-26	1
23980	1432	4112343	2016-09-16	2016-09-29	1
73640	4380	78272	2014-04-19	2014-05-10	1
50660	3000	40481087	2011-06-28	2011-07-12	1
76225	4527	4059173	2011-09-02	2011-12-01	1
82580	4907	80180	1984-09-10	1984-09-11	1
25070	1497	4112343	1953-04-09	1953-04-18	1
85557	5095	40481087	2015-03-26	2015-04-02	1
22296	1332	40481087	2002-08-09	2002-08-16	1
21191	1273	78272	1974-04-20	1974-05-18	1
82903	4929	28060	1994-01-12	1994-01-19	1
14194	841	81151	2017-08-23	2017-09-20	1
72129	4284	40481087	2001-07-09	2001-07-23	1
18239	1098	4112343	1995-07-21	1995-08-03	1
75554	4487	40481087	1990-01-26	1990-02-09	1
18104	1088	40481087	1985-07-24	1985-08-14	1
7602	445	40481087	1979-06-14	1979-06-21	1
82839	4924	78272	2013-03-13	2013-04-17	1
85258	5077	4112343	1973-10-05	1973-10-17	1
11656	689	260139	2010-03-27	2010-04-10	1
16958	1015	80180	1988-06-04	1988-06-05	1
54194	3214	4112343	1984-02-27	1984-03-10	1
87809	5229	4112343	2004-08-06	2004-08-17	1
24268	1447	4283893	1993-08-07	1994-08-20	1
24523	1466	4027663	1994-02-27	1994-02-28	1
76918	4562	133834	1961-08-03	1978-04-15	1
19112	1146	81151	1971-11-20	1971-12-18	1
84975	5058	40481087	1967-03-22	1967-03-29	1
17022	1017	40481087	1966-05-12	1966-06-02	1
19836	1194	4109685	1978-09-15	1978-10-06	1
68883	4081	40481087	1988-03-13	1988-04-03	1
12304	728	4112343	2015-06-28	2015-07-10	1
75620	4490	40481087	1981-12-29	1982-01-19	1
78646	4662	4283893	1984-10-30	1985-01-22	1
53864	3191	80180	1998-08-02	1998-08-03	1
24580	1468	40481087	1962-11-09	1962-11-23	1
74141	4408	4155034	2019-02-23	2019-03-09	1
52721	3125	4112343	1962-04-16	1962-04-23	1
75447	4482	78272	1962-01-20	1962-02-17	1
23549	1408	260139	2007-07-07	2007-07-21	1
70381	4173	4112343	1989-10-26	1989-11-05	1
17132	1025	378001	1952-01-24	1952-02-23	1
23935	1431	372328	1952-05-18	1952-09-06	1
85883	5116	40481087	1976-11-13	1976-11-27	1
23040	1377	260139	2008-12-02	2008-12-09	1
68924	4084	40481087	2011-08-11	2011-09-01	1
15513	919	4112343	1992-05-08	1992-05-17	1
69853	4137	4109685	2006-08-09	2006-08-23	1
69365	4109	80180	2002-02-10	2002-02-11	1
60982	3613	372328	1977-10-16	1978-01-01	1
72208	4289	40481087	1959-05-17	1959-05-31	1
19696	1185	381316	1981-02-22	1981-02-23	1
88532	5268	40481087	2015-08-06	2015-08-27	1
88512	5267	260139	2008-09-26	2008-10-03	1
14614	864	4296205	1946-08-21	1946-09-25	1
66349	3930	4146173	1925-11-25	1925-12-25	1
23981	1432	4152936	2005-04-06	2005-04-27	1
73641	4380	260139	1971-09-13	1971-09-20	1
50661	3000	81151	1994-09-29	1994-10-20	1
76226	4527	4112343	1963-02-26	1963-03-11	1
82581	4907	260139	1959-10-28	1959-11-04	1
25071	1497	4278672	2007-02-18	2007-03-20	1
85558	5095	81151	1977-01-22	1977-02-12	1
22297	1332	260139	1970-05-12	1970-05-19	1
21192	1273	260139	2004-09-03	2004-09-10	1
82904	4929	260139	1991-09-11	1991-09-18	1
14195	841	4112343	1958-05-17	1958-05-27	1
72130	4284	260139	1979-12-29	1980-01-12	1
18240	1098	4112343	2013-02-21	2013-03-04	1
75555	4487	40481087	1997-12-18	1997-12-25	1
20646	1242	260139	1975-10-14	1975-10-21	1
7850	459	80180	2008-07-12	2008-07-13	1
82840	4924	4112343	1996-07-04	1996-07-14	1
85259	5077	4112343	2007-09-04	2007-09-11	1
11657	689	4112343	2009-04-29	2009-05-12	1
16959	1015	260139	1979-12-29	1980-01-05	1
54195	3214	4152936	1982-12-17	1982-12-31	1
87810	5229	4310024	2002-09-22	2002-09-23	1
24269	1447	4294548	1963-07-04	1963-08-01	1
24524	1466	4152936	1972-02-13	1972-02-27	1
76919	4562	260139	1985-04-30	1985-05-07	1
19113	1146	260139	2011-10-08	2011-10-15	1
84976	5058	40481087	2013-06-18	2013-06-25	1
18468	1113	28060	1976-05-27	1976-06-04	1
19837	1194	28060	1963-11-15	1963-11-25	1
68884	4081	40481087	2013-11-18	2013-12-09	1
12305	728	4152936	1960-11-21	1960-12-05	1
75621	4490	81151	1931-12-19	1932-01-16	1
78647	4662	40481087	1958-08-30	1958-09-20	1
53865	3191	260139	1993-05-07	1993-05-14	1
24581	1468	40481087	1983-09-12	1983-09-26	1
74142	4408	80180	2017-09-05	2017-09-06	1
52722	3125	4112343	1966-07-02	1966-07-14	1
75448	4482	260139	1952-04-13	1952-04-27	1
23550	1408	4112343	1948-01-19	1948-01-31	1
70382	4173	4134304	1973-03-24	1973-04-23	1
17133	1025	4112343	2013-02-11	2013-02-24	1
23936	1431	372328	1967-08-04	1968-07-27	1
85884	5116	40481087	2010-11-08	2010-11-15	1
23041	1377	40481087	2007-06-05	2007-06-12	1
68925	4084	321042	2010-10-03	2010-10-04	1
15514	919	4112343	1999-05-13	1999-05-22	1
69854	4137	4113008	2002-12-14	2002-12-28	1
69366	4109	81151	1978-09-19	1978-10-10	1
60983	3613	4027663	2002-01-18	2002-01-19	1
72209	4289	40481087	1968-12-18	1968-12-25	1
19697	1185	4112343	1947-04-22	1947-05-03	1
417	23	30753	2010-11-18	2010-11-19	1
88513	5267	4112343	1985-10-12	1985-10-24	1
14615	864	40481087	1973-06-28	1973-07-12	1
68035	4022	78272	1968-02-01	1968-03-07	1
23982	1432	40481087	1993-07-04	1993-07-18	1
73642	4380	260139	1999-01-29	1999-02-05	1
50662	3000	81893	1981-03-04	1981-03-05	1
76227	4527	4112343	2016-09-22	2016-09-30	1
82582	4907	372328	1950-05-03	1950-12-02	1
25072	1497	40481087	1969-06-17	1969-07-01	1
85559	5095	257012	2003-12-10	2003-12-11	1
22298	1332	4027663	1970-05-26	1970-05-27	1
21193	1273	378419	2011-10-24	2011-10-25	1
82905	4929	4112343	1984-10-15	1984-10-28	1
14196	841	4027663	1982-01-08	1982-01-09	1
72131	4284	4112343	1947-03-14	1947-03-22	1
18241	1098	4152936	1975-02-19	1975-03-05	1
75556	4487	40481087	2003-09-18	2003-10-09	1
20647	1242	372328	1960-03-05	1960-05-18	1
7851	459	81893	2007-07-18	2007-07-19	1
82841	4924	4112343	2001-07-02	2001-07-13	1
85260	5077	4266809	2002-10-29	2002-10-30	1
11658	689	4283893	2005-08-07	2005-11-20	1
16960	1015	260139	1984-11-21	1984-11-28	1
54196	3214	40481087	1979-01-17	1979-02-07	1
87811	5229	40481087	2017-08-09	2017-08-23	1
24270	1447	40481087	1985-12-08	1985-12-29	1
24525	1466	4218389	2004-12-19	2005-01-09	1
76920	4562	372328	1963-02-17	1963-07-06	1
19114	1146	4112343	1967-03-05	1967-03-12	1
84977	5058	81893	1976-12-24	1976-12-25	1
18469	1113	80180	2013-07-23	2013-07-24	1
19838	1194	257012	1963-03-08	1963-03-09	1
68885	4081	80180	1999-04-21	1999-04-22	1
12306	728	4294548	1986-06-11	1986-06-18	1
75622	4490	260139	1956-04-15	1956-04-29	1
78648	4662	4294548	1958-12-26	1959-01-09	1
53866	3191	4112343	1958-12-23	1959-01-02	1
24582	1468	40481087	2000-03-08	2000-03-15	1
74143	4408	4155034	2014-05-29	2014-06-19	1
52723	3125	4266809	1985-01-05	1985-01-06	1
75449	4482	372328	1952-02-12	1952-04-19	1
23551	1408	4237458	1978-05-10	1978-07-09	1
70383	4173	4156265	2008-08-17	2008-09-07	1
17134	1025	40481087	2017-11-15	2017-12-06	1
23937	1431	4112343	1961-01-05	1961-01-13	1
85885	5116	40481087	2018-10-24	2018-10-31	1
23042	1377	372328	1982-11-18	1983-05-10	1
68926	4084	4112343	1966-11-25	1966-12-05	1
15515	919	40481087	1994-05-21	1994-06-11	1
69855	4137	40481087	1971-11-26	1971-12-03	1
69367	4109	4112343	1981-06-07	1981-06-16	1
60984	3613	4266809	2010-06-05	2010-06-06	1
72210	4289	40481087	1988-11-01	1988-11-22	1
19698	1185	4112343	1973-02-04	1973-02-15	1
418	23	80180	2012-05-11	2012-05-12	1
88514	5267	4116491	1994-11-27	1995-01-01	1
14616	864	40481087	1998-11-04	1998-11-11	1
68036	4022	4112343	1992-02-16	1992-02-25	1
23983	1432	81151	1984-05-28	1984-06-25	1
73643	4380	260139	2006-06-26	2006-07-10	1
50663	3000	4027663	1974-04-10	1974-04-11	1
76228	4527	40481087	1978-05-28	1978-06-18	1
82583	4907	4112343	1974-01-03	1974-01-12	1
25073	1497	40481087	1993-03-06	1993-03-20	1
85560	5095	381316	2007-01-15	2007-01-16	1
22299	1332	4112343	1951-10-21	1951-11-02	1
21194	1273	40481087	1973-11-27	1973-12-18	1
82906	4929	40481087	2010-05-25	2010-06-15	1
14197	841	4294548	2018-03-16	2018-03-23	1
72132	4284	4112343	1951-04-02	1951-04-13	1
18242	1098	4152936	2011-10-13	2011-11-03	1
75557	4487	78272	1977-08-10	1977-08-24	1
20648	1242	4112343	1986-05-19	1986-05-28	1
7852	459	4027663	1998-08-24	1998-08-25	1
82842	4924	40481087	2018-06-26	2018-07-10	1
85261	5077	260139	1971-02-16	1971-03-02	1
11659	689	40481087	2001-07-01	2001-07-22	1
16961	1015	4112343	1959-06-01	1959-06-10	1
54197	3214	40481087	2004-02-17	2004-02-24	1
88146	5249	260139	1963-07-10	1963-07-17	1
24271	1447	40481087	1993-02-25	1993-03-04	1
24526	1466	40481087	1980-12-04	1980-12-25	1
76921	4562	372328	1965-05-26	1965-08-28	1
19115	1146	4112343	2004-08-21	2004-09-03	1
84978	5058	260139	1966-11-03	1966-11-17	1
18470	1113	195588	2007-11-07	2007-12-14	1
19839	1194	4112343	2011-01-13	2011-01-23	1
68886	4081	260139	1968-02-04	1968-02-11	1
12307	728	40481087	1969-09-25	1969-10-02	1
75623	4490	260139	1980-10-03	1980-10-10	1
78649	4662	40481087	1974-09-25	1974-10-09	1
53867	3191	4112343	1981-10-21	1981-10-28	1
24583	1468	78272	1989-06-18	1989-07-23	1
74144	4408	4237458	2011-07-14	2011-09-12	1
52724	3125	40481087	1959-10-23	1959-10-30	1
75450	4482	4283893	2005-05-31	2005-09-06	1
23552	1408	4283893	1982-07-18	1982-11-07	1
70384	4173	4278672	1964-06-09	1964-08-08	1
17135	1025	78272	1968-03-30	1968-04-27	1
23938	1431	4112343	1984-07-13	1984-07-26	1
85886	5116	28060	2016-08-23	2016-09-04	1
23043	1377	372328	1988-05-13	1988-12-06	1
68927	4084	4112343	1972-02-10	1972-02-22	1
15516	919	40481087	2012-12-18	2013-01-08	1
69856	4137	40481087	2018-09-01	2018-09-22	1
69368	4109	4116491	2004-11-21	2004-12-31	1
60985	3613	375671	1999-05-24	1999-06-23	1
72211	4289	260139	2018-01-18	2018-01-25	1
19699	1185	4112343	2018-06-22	2018-07-03	1
419	23	81893	2010-05-22	2010-05-23	1
88515	5267	40481087	2001-11-25	2001-12-16	1
14617	864	40481087	2002-07-24	2002-08-14	1
68037	4022	40481087	1968-09-18	1968-09-25	1
23984	1432	260139	1979-07-06	1979-07-13	1
73644	4380	4112343	2002-09-09	2002-09-19	1
50664	3000	4112343	1951-07-01	1951-07-09	1
76229	4527	4112343	1988-04-27	1988-05-05	1
82584	4907	4283893	1974-07-14	1974-10-13	1
25074	1497	40481087	1997-09-25	1997-10-16	1
85561	5095	4027663	1994-12-28	1994-12-29	1
22300	1332	4294548	1947-01-01	1947-01-08	1
21195	1273	255848	2016-12-26	2016-12-27	1
82907	4929	4059173	1969-12-18	1970-03-18	1
14198	841	4310024	1989-11-02	1989-11-03	1
72133	4284	4112343	2013-07-02	2013-07-14	1
18243	1098	28060	1962-11-14	1962-11-21	1
75558	4487	260139	1960-05-10	1960-05-17	1
20649	1242	4156265	1989-12-26	1990-01-09	1
7853	459	4112343	1998-07-16	1998-07-25	1
87846	5232	260139	2003-07-09	2003-07-16	1
85262	5077	260139	2006-02-10	2006-02-17	1
11660	689	40481087	2007-04-22	2007-05-13	1
16962	1015	40481087	1984-07-23	1984-08-06	1
54198	3214	40481087	2018-06-17	2018-06-24	1
88147	5249	40481087	1953-11-16	1953-12-07	1
25851	1537	140673	2010-05-31	2010-06-01	1
24527	1466	40481087	1994-07-18	1994-08-01	1
76922	4562	4084167	1962-06-22	1962-06-22	1
19116	1146	4152936	1965-06-12	1965-07-03	1
84979	5058	378001	1981-04-13	1981-06-12	1
18471	1113	372328	1971-12-16	1972-02-22	1
19840	1194	4237458	1995-07-09	1995-10-07	1
68887	4081	4112343	1962-07-01	1962-07-14	1
12308	728	260139	1973-02-17	1973-03-03	1
75624	4490	317576	1984-02-18	1984-02-19	1
78650	4662	40481087	1982-02-24	1982-03-10	1
53868	3191	4112343	2013-11-12	2013-11-23	1
24584	1468	260139	1965-08-11	1965-08-18	1
74145	4408	40481087	1990-05-15	1990-05-29	1
52725	3125	260139	1967-08-20	1967-09-03	1
75451	4482	40481087	1980-10-29	1980-11-12	1
23553	1408	40481087	1955-07-06	1955-07-20	1
70385	4173	40481087	1965-02-01	1965-02-22	1
17136	1025	80180	1974-04-05	1974-04-06	1
23939	1431	4112343	1984-12-26	1985-01-06	1
85887	5116	4112343	2000-01-08	2000-01-18	1
23044	1377	40481087	1988-08-23	1988-09-06	1
68928	4084	4278672	1973-03-20	1973-06-18	1
15517	919	80180	2009-06-05	2009-06-06	1
69857	4137	4283893	2002-10-07	2002-11-18	1
69369	4109	4266809	2002-02-10	2002-02-11	1
60986	3613	4112343	2013-07-04	2013-07-13	1
72212	4289	439777	2005-07-03	2005-07-04	1
19700	1185	40481087	1940-10-16	1940-10-30	1
420	23	260139	2011-11-24	2011-12-01	1
88516	5267	134438	1995-12-04	1996-10-04	1
14618	864	78272	1923-12-19	1924-01-23	1
68038	4022	40481087	2012-06-26	2012-07-03	1
23985	1432	260139	2012-08-29	2012-09-05	1
73645	4380	260139	1977-04-23	1977-04-30	1
50665	3000	4285898	1982-11-24	1982-11-25	1
76230	4527	4283893	1979-09-18	1979-11-06	1
82585	4907	4283893	1982-01-10	1982-03-07	1
25075	1497	40481087	2004-01-10	2004-01-17	1
85562	5095	4112343	2006-06-11	2006-06-18	1
22301	1332	4329847	2019-01-02	2019-01-03	1
21196	1273	4112343	1972-06-02	1972-06-11	1
82908	4929	4283893	1979-03-24	1979-05-12	1
14199	841	40481087	1955-12-31	1956-01-21	1
72134	4284	4112343	2014-09-19	2014-10-01	1
18244	1098	260139	1999-11-30	1999-12-07	1
75559	4487	260139	1980-09-01	1980-09-08	1
20650	1242	40481087	1971-05-01	1971-05-15	1
7854	459	4310024	2006-11-20	2006-11-21	1
87847	5232	372328	1969-01-29	1969-03-15	1
85263	5077	372328	1973-11-30	1974-03-13	1
11661	689	4112343	1989-01-18	1989-01-25	1
16963	1015	40481087	2009-12-29	2010-01-05	1
56008	3320	28060	2012-10-01	2012-10-13	1
88148	5249	28060	1957-09-21	1957-09-30	1
25852	1537	4112343	1963-10-09	1963-10-18	1
24528	1466	40481087	2015-04-16	2015-04-30	1
76923	4562	4112343	1993-10-23	1993-11-04	1
19117	1146	4218389	1969-12-09	1969-12-30	1
84980	5058	4059173	2011-10-31	2011-11-30	1
18472	1113	372328	1974-08-10	1974-10-22	1
19841	1194	40481087	1990-12-31	1991-01-14	1
68888	4081	4134304	1965-03-20	1965-04-19	1
12309	728	260139	1973-08-16	1973-08-30	1
75625	4490	4112343	1981-02-26	1981-03-07	1
81259	4826	28060	1990-04-20	1990-04-27	1
53869	3191	4112343	2015-09-18	2015-09-25	1
24585	1468	4112343	1967-09-05	1967-09-15	1
74146	4408	257012	1986-10-21	1986-10-22	1
52726	3125	260139	1972-04-19	1972-04-26	1
75452	4482	260139	2003-10-08	2003-10-22	1
23554	1408	40481087	1964-05-09	1964-05-16	1
75095	4466	260139	1996-07-16	1996-07-30	1
17137	1025	260139	1956-09-28	1956-10-05	1
23940	1431	4113008	2000-05-18	2000-06-01	1
85888	5116	78272	1969-12-28	1970-01-11	1
26641	1579	28060	1989-03-10	1989-03-20	1
68929	4084	40481087	1971-12-03	1971-12-10	1
15518	919	257012	2002-12-30	2002-12-31	1
69858	4137	4296204	2013-02-17	2013-03-17	1
69370	4109	4285898	2001-11-12	2001-11-13	1
60987	3613	4285898	2009-11-07	2009-11-08	1
72213	4289	4109685	1965-03-25	1965-04-08	1
19701	1185	40481087	1952-04-09	1952-04-23	1
421	23	4027663	2003-09-01	2003-09-02	1
88517	5267	4112343	1979-03-04	1979-03-16	1
14619	864	255848	2011-03-20	2011-03-21	1
68039	4022	78272	2010-06-09	2010-07-14	1
23986	1432	4112343	2018-03-27	2018-04-05	1
73646	4380	4218389	1980-04-26	1980-05-17	1
50666	3000	40481087	1971-08-20	1971-09-03	1
76231	4527	4285898	2001-12-22	2001-12-23	1
82586	4907	40481087	2001-04-11	2001-04-25	1
25076	1497	40481087	2006-05-14	2006-05-21	1
85563	5095	4266809	2002-09-17	2002-09-18	1
22302	1332	40481087	1982-08-28	1982-09-18	1
21197	1273	4112343	1973-12-07	1973-12-16	1
82909	4929	40481087	2002-01-16	2002-01-30	1
14200	841	40481087	1982-06-20	1982-07-11	1
72135	4284	40481087	1982-06-09	1982-06-16	1
18245	1098	372328	1969-01-17	1970-01-10	1
75560	4487	260139	1984-11-17	1984-12-01	1
20651	1242	78272	2014-07-02	2014-07-23	1
7855	459	40481087	1980-02-19	1980-03-11	1
87848	5232	4237458	1972-06-12	1972-09-10	1
85264	5077	4029498	2017-03-04	2017-03-05	1
11662	689	4112343	1991-02-18	1991-03-01	1
16964	1015	260139	1976-07-29	1976-08-05	1
56009	3320	40481087	1998-04-15	1998-05-06	1
88149	5249	28060	1994-03-17	1994-03-28	1
25853	1537	4294548	1978-01-15	1978-01-22	1
24529	1466	81893	2003-11-22	2003-11-23	1
76924	4562	4112343	2018-05-11	2018-05-22	1
19118	1146	40481087	1994-09-08	1994-09-15	1
84981	5058	4112343	1991-10-07	1991-10-18	1
18473	1113	4112343	1992-05-23	1992-06-02	1
19842	1194	260139	1999-03-30	1999-04-13	1
68889	4081	40481087	1968-06-15	1968-07-06	1
12310	728	260139	1983-12-11	1983-12-18	1
75626	4490	4278672	1936-01-25	1936-02-24	1
81260	4826	28060	1992-04-17	1992-04-28	1
53870	3191	4155034	1976-08-31	1976-09-21	1
24586	1468	4112343	1977-02-25	1977-03-10	1
74147	4408	372328	1984-07-20	1984-12-27	1
52727	3125	372328	1951-12-25	1952-03-06	1
75453	4482	378001	1985-04-08	1985-06-07	1
25652	1526	28060	2018-12-03	2018-12-14	1
75096	4466	4112343	2005-03-27	2005-04-08	1
17138	1025	260139	1987-10-21	1987-10-28	1
23941	1431	4278672	1965-05-31	1965-06-30	1
85889	5116	260139	1969-01-03	1969-01-10	1
26642	1579	81893	1986-11-17	1986-11-18	1
68930	4084	40481087	2000-06-26	2000-07-17	1
15519	919	260139	2002-01-30	2002-02-06	1
69859	4137	40481087	1964-04-14	1964-04-28	1
69371	4109	4310024	2000-06-20	2000-06-21	1
60988	3613	40481087	1998-09-15	1998-09-22	1
72214	4289	4109685	1967-01-28	1967-02-18	1
19702	1185	40481087	1973-08-29	1973-09-05	1
422	23	260139	1991-10-01	1991-10-08	1
88518	5267	40481087	1972-11-08	1972-11-29	1
14620	864	260139	1925-11-10	1925-11-17	1
68040	4022	80180	1999-07-28	1999-07-29	1
23987	1432	40481087	1991-06-27	1991-07-11	1
79184	4694	40481087	1993-01-16	1993-01-30	1
50667	3000	40481087	1979-07-15	1979-07-29	1
76232	4527	40481087	1967-05-27	1967-06-17	1
82587	4907	40481087	2004-05-16	2004-05-30	1
25077	1497	40481087	2018-05-09	2018-05-23	1
85564	5095	40481087	1991-08-19	1991-09-09	1
24375	1454	28060	1984-04-06	1984-04-15	1
21198	1273	4112343	1989-06-13	1989-06-20	1
82910	4929	28060	1972-12-05	1972-12-14	1
14201	841	40481087	1988-05-03	1988-05-17	1
72136	4284	40481087	2012-06-02	2012-06-23	1
18246	1098	4152936	1982-02-26	1982-03-19	1
75561	4487	260139	1997-09-04	1997-09-11	1
20652	1242	80180	2000-10-21	2000-10-22	1
7856	459	372328	1975-01-07	1975-08-11	1
87849	5232	40481087	1991-12-22	1992-01-05	1
85265	5077	4310024	2001-10-04	2001-10-05	1
11663	689	40481087	2000-11-13	2000-11-27	1
16965	1015	260139	1994-11-25	1994-12-09	1
56010	3320	28060	1977-04-23	1977-05-04	1
88150	5249	80180	1988-05-13	1988-05-14	1
25854	1537	40481087	1976-10-22	1976-11-12	1
24530	1466	4112343	1996-07-06	1996-07-16	1
76925	4562	40481087	1997-03-17	1997-03-31	1
19119	1146	40481087	1999-08-27	1999-09-17	1
84982	5058	4112343	2001-05-30	2001-06-09	1
18474	1113	4112343	2010-05-25	2010-06-02	1
23432	1401	30753	2006-02-09	2006-02-10	1
68890	4081	40481087	1974-04-13	1974-04-20	1
12311	728	372328	1959-12-27	1961-01-07	1
77635	4604	260139	1991-09-10	1991-09-24	1
81261	4826	80180	1986-04-16	1986-04-17	1
53871	3191	4237458	1969-11-06	1970-01-05	1
24587	1468	4112343	2015-04-05	2015-04-18	1
74148	4408	4294548	1986-09-30	1986-12-23	1
52728	3125	4027663	1976-06-21	1976-06-22	1
75454	4482	4112343	1975-01-15	1975-01-27	1
25653	1526	81151	2007-09-04	2007-09-25	1
75097	4466	4112343	2006-04-05	2006-04-16	1
17139	1025	40481087	1968-07-15	1968-07-29	1
23942	1431	4296204	1994-09-26	1994-10-17	1
85890	5116	260139	1977-05-29	1977-06-05	1
26643	1579	381316	1999-04-29	1999-04-30	1
68931	4084	40481087	2011-03-15	2011-04-05	1
15520	919	4283893	2002-12-16	2003-01-13	1
69860	4137	40481087	1987-04-17	1987-04-24	1
69372	4109	40481087	2009-03-14	2009-03-28	1
60989	3613	440448	1989-01-23	1989-01-24	1
72215	4289	4112343	2002-08-03	2002-08-13	1
19703	1185	40481087	1983-09-22	1983-09-29	1
423	23	4112343	2013-12-06	2013-12-18	1
88519	5267	40481087	1976-04-21	1976-05-05	1
14621	864	372328	1923-08-21	1924-02-04	1
68041	4022	4112343	1968-11-28	1968-12-06	1
23988	1432	40481087	2005-11-11	2005-11-18	1
79185	4694	40481087	2018-01-23	2018-01-30	1
50668	3000	40481087	2007-11-21	2007-11-28	1
76233	4527	40481087	1980-06-10	1980-06-17	1
83308	4957	4112343	1983-07-16	1983-07-28	1
25078	1497	260139	1983-10-25	1983-11-08	1
85565	5095	81151	1970-12-04	1970-12-25	1
24376	1454	372328	1973-09-29	1974-02-15	1
21199	1273	40481087	1952-12-20	1953-01-10	1
82911	4929	80180	2002-07-24	2002-07-25	1
14202	841	40481087	1994-06-23	1994-07-14	1
72137	4284	40481087	2015-06-14	2015-06-21	1
18247	1098	40481087	2000-07-22	2000-07-29	1
75562	4487	372328	1950-08-29	1951-02-16	1
20653	1242	4027663	1993-03-02	1993-03-03	1
7857	459	4035415	1984-12-20	1985-01-19	1
87850	5232	80180	2011-04-09	2011-04-10	1
85266	5077	40481087	2004-02-10	2004-03-02	1
11664	689	81151	1995-04-14	1995-05-12	1
16966	1015	440448	1984-10-19	1984-10-20	1
56011	3320	260139	1970-02-13	1970-02-20	1
88151	5249	257012	1954-12-10	1954-12-17	1
25855	1537	40481087	1997-07-19	1997-08-09	1
24531	1466	4112343	2013-08-12	2013-08-22	1
76926	4562	260139	2015-10-09	2015-10-23	1
19120	1146	40481087	2015-09-20	2015-10-04	1
84983	5058	40481087	2009-07-18	2009-08-01	1
18475	1113	4112343	2010-10-03	2010-10-15	1
23433	1401	4112343	1982-09-11	1982-09-24	1
68891	4081	40481087	1997-07-23	1997-07-30	1
12312	728	378001	2002-06-03	2002-08-02	1
77636	4604	260139	2007-05-22	2007-05-29	1
81262	4826	4112343	1976-01-19	1976-02-01	1
53872	3191	40481087	1995-04-30	1995-05-14	1
24588	1468	4294548	1969-10-24	1969-10-31	1
74149	4408	372328	1982-05-17	1982-07-01	1
52729	3125	4112343	1969-06-12	1969-06-20	1
75455	4482	40481087	1970-12-17	1970-12-31	1
25654	1526	4112343	1988-04-04	1988-04-15	1
75098	4466	40481087	2012-02-28	2012-03-20	1
17140	1025	260139	1958-03-10	1958-03-17	1
23943	1431	40481087	1985-05-25	1985-06-15	1
85891	5116	40481087	1995-10-31	1995-11-21	1
26644	1579	4112343	1968-08-20	1968-08-29	1
68932	4084	0	2010-10-03	2010-10-04	1
17911	1079	81151	1983-02-06	1983-02-20	1
69861	4137	80180	2002-07-09	2002-07-10	1
69373	4109	30753	2001-01-16	2001-01-17	1
60990	3613	40481087	1988-11-23	1988-11-30	1
72216	4289	4112343	2008-11-13	2008-11-23	1
19704	1185	80502	1997-01-05	1997-01-06	1
424	23	4113008	1988-05-08	1988-05-22	1
675	38	260139	1981-09-29	1981-10-13	1
14622	864	378001	1979-11-15	1980-01-14	1
68042	4022	4155034	1993-03-26	1993-04-09	1
25479	1518	28060	1956-10-05	1956-10-13	1
79186	4694	4059173	1998-02-11	1998-03-13	1
50977	3022	28060	1975-04-24	1975-05-07	1
76234	4527	28060	1986-03-28	1986-04-04	1
83309	4957	40481087	2017-01-24	2017-01-31	1
25079	1497	372328	1942-06-16	1942-08-21	1
85566	5095	260139	2012-11-27	2012-12-11	1
24377	1454	4112343	1998-07-28	1998-08-10	1
21200	1273	40481087	1977-06-05	1977-06-26	1
82912	4929	4112343	2012-09-15	2012-09-27	1
14203	841	40481087	1997-04-07	1997-04-28	1
72138	4284	80180	1976-07-17	1976-07-18	1
20476	1232	28060	1965-09-14	1965-09-27	1
75563	4487	4112343	1975-10-20	1975-10-29	1
20654	1242	4285898	2000-04-24	2000-04-25	1
7858	459	4112343	1998-08-25	1998-09-01	1
87851	5232	260139	1983-02-17	1983-02-24	1
85267	5077	0	2017-03-04	2017-03-05	1
11665	689	257012	2005-08-28	2005-08-29	1
16967	1015	4218389	1983-02-05	1983-03-12	1
56012	3320	40481087	1976-08-23	1976-09-13	1
88152	5249	260139	2007-12-03	2007-12-17	1
25856	1537	40481087	2018-04-13	2018-04-27	1
24532	1466	28060	1975-06-30	1975-07-09	1
76927	4562	260139	2016-04-28	2016-05-12	1
19521	1174	4112343	1944-08-22	1944-09-04	1
88421	5262	81893	2008-06-22	2008-06-23	1
18476	1113	4218389	2012-12-10	2012-12-31	1
23434	1401	4152936	1989-11-28	1989-12-12	1
68892	4081	40481087	2000-06-27	2000-07-04	1
12313	728	4112343	1994-04-26	1994-05-05	1
77637	4604	40481087	1985-10-15	1985-10-22	1
81263	4826	4278672	1969-01-19	1969-03-20	1
53873	3191	40481087	2001-02-28	2001-03-07	1
24589	1468	40481087	1977-01-29	1977-02-12	1
74150	4408	4112343	1995-06-10	1995-06-22	1
52730	3125	40481087	1998-06-21	1998-07-12	1
75456	4482	40481087	1977-08-04	1977-08-25	1
25655	1526	4112343	2004-12-30	2005-01-12	1
75099	4466	192671	2008-04-25	2008-04-26	1
17141	1025	40481087	1958-08-17	1958-08-31	1
23944	1431	40481087	2012-08-28	2012-09-04	1
85892	5116	40481087	2018-02-11	2018-02-18	1
26645	1579	4237458	1964-04-02	1964-07-01	1
68933	4084	4134304	1994-08-18	1994-09-17	1
17912	1079	4294548	1964-08-09	1964-09-27	1
69862	4137	260139	1973-02-23	1973-03-09	1
69374	4109	81893	2000-10-18	2000-10-19	1
60991	3613	0	1989-01-23	1989-01-24	1
72217	4289	4116491	1984-07-08	1984-08-31	1
19705	1185	4112343	1987-04-07	1987-04-17	1
425	23	4155034	1986-04-28	1986-05-19	1
676	38	260139	1999-12-24	2000-01-07	1
14623	864	4112343	1974-10-07	1974-10-17	1
68043	4022	4283893	1986-07-16	1986-11-05	1
25480	1518	81151	1967-04-26	1967-05-10	1
79187	4694	4112343	2016-10-18	2016-10-26	1
50978	3022	81151	1991-12-04	1991-12-25	1
76235	4527	78272	1986-05-25	1986-06-15	1
83310	4957	78272	2019-06-20	2019-06-21	1
25080	1497	372328	1945-05-07	1946-03-01	1
85567	5095	40481087	2005-03-18	2005-04-08	1
24378	1454	40481087	1982-06-20	1982-07-04	1
21201	1273	78272	1943-05-05	1943-06-02	1
82913	4929	4113008	1965-11-25	1965-12-09	1
14204	841	0	1961-01-14	1961-01-15	1
72139	4284	260139	1965-11-04	1965-11-11	1
20477	1232	28060	2001-09-28	2001-10-10	1
75564	4487	4112343	2007-06-20	2007-06-28	1
20655	1242	40481087	1981-02-14	1981-02-28	1
7859	459	4278672	2013-12-16	2014-02-14	1
87852	5232	260139	2007-11-15	2007-11-22	1
85268	5077	4112343	1996-07-20	1996-07-30	1
11666	689	4059173	1997-05-31	1997-07-30	1
16968	1015	40481087	2004-03-30	2004-04-20	1
56013	3320	40481087	1985-02-06	1985-02-13	1
88153	5249	4112343	1985-05-20	1985-06-02	1
25857	1537	78272	1960-11-19	1960-12-03	1
24533	1466	4112343	1998-11-04	1998-11-16	1
76928	4562	4051466	1964-02-04	1980-05-11	1
19522	1174	4112343	1971-08-26	1971-09-07	1
88422	5262	4278672	1990-12-24	1991-03-24	1
18477	1113	40481087	1978-04-17	1978-04-24	1
23435	1401	4266809	2007-08-03	2007-08-04	1
68893	4081	40481087	2014-06-16	2014-07-07	1
12314	728	4113008	1970-10-14	1970-10-28	1
77638	4604	260139	1986-08-14	1986-08-28	1
81264	4826	4294548	1985-02-24	1985-03-31	1
53874	3191	40481087	2002-04-08	2002-04-29	1
24590	1468	28060	1956-02-13	1956-02-23	1
74151	4408	40481087	1993-07-19	1993-08-09	1
52731	3125	40481087	2008-09-23	2008-10-07	1
75457	4482	40481087	1978-05-31	1978-06-07	1
25656	1526	40481087	1979-09-18	1979-10-09	1
75100	4466	257012	1986-01-03	1986-01-04	1
17142	1025	40481087	2004-03-07	2004-03-28	1
23945	1431	80180	1989-01-09	1989-01-10	1
85893	5116	40486433	1967-06-05	1983-06-03	1
26646	1579	40481087	1963-05-25	1963-06-08	1
68934	4084	40481087	1962-06-25	1962-07-16	1
17913	1079	40481087	1983-05-30	1983-06-06	1
69863	4137	260139	2013-08-05	2013-08-19	1
69375	4109	133834	1965-05-07	1965-05-08	1
60992	3613	372328	1981-01-15	1982-01-10	1
72218	4289	4266809	1978-09-28	1978-09-29	1
19706	1185	4278672	2008-02-11	2008-04-11	1
426	23	4266809	2012-05-11	2012-05-12	1
677	38	260139	2016-01-01	2016-01-08	1
14624	864	4278672	2001-07-11	2001-09-09	1
68044	4022	4112343	1978-10-04	1978-10-15	1
25481	1518	81151	2009-12-16	2010-01-06	1
79188	4694	4296204	2012-12-24	2013-01-07	1
50979	3022	260139	2003-02-08	2003-02-15	1
76236	4527	260139	2012-03-21	2012-04-04	1
83311	4957	80180	2004-05-16	2004-05-17	1
25081	1497	4142905	1975-11-05	1975-12-05	1
85568	5095	80180	2002-09-17	2002-09-18	1
24379	1454	375671	1983-11-06	1984-01-05	1
21202	1273	80180	1976-08-19	1976-08-20	1
82914	4929	4113008	2004-10-20	2004-11-03	1
14205	841	30753	1990-04-01	1990-04-02	1
72140	4284	372328	1945-10-02	1945-11-08	1
20478	1232	260139	1969-08-21	1969-09-04	1
75565	4487	4329847	2010-02-12	2010-02-13	1
20656	1242	40481087	1996-02-28	1996-03-06	1
7860	459	40481087	2016-06-21	2016-07-12	1
87853	5232	4059173	2016-09-19	2016-11-18	1
85269	5077	40481087	2011-01-23	2011-02-13	1
11667	689	40481087	1982-09-26	1982-10-10	1
16969	1015	0	1973-07-23	1973-07-24	1
56014	3320	80180	1999-02-02	1999-02-03	1
88154	5249	4283893	1981-11-15	1981-11-29	1
25858	1537	80180	1992-01-21	1992-01-22	1
24534	1466	4112343	2008-11-24	2008-12-02	1
76929	4562	4112343	2006-02-01	2006-02-09	1
19523	1174	4283893	1976-11-03	1976-12-01	1
88423	5262	4283893	2015-07-20	2015-08-24	1
18478	1113	40481087	2014-03-13	2014-03-27	1
23436	1401	40481087	2005-04-25	2005-05-16	1
68894	4081	4112343	1969-07-09	1969-07-19	1
12315	728	4156265	1993-06-29	1993-07-20	1
77639	4604	260139	1987-10-23	1987-10-30	1
81265	4826	40481087	1990-10-10	1990-10-31	1
53875	3191	40481087	2017-10-26	2017-11-16	1
24591	1468	260139	1981-06-16	1981-06-23	1
74152	4408	40481087	1995-10-05	1995-10-12	1
52732	3125	78272	1953-06-17	1953-07-08	1
77500	4596	28060	1951-11-09	1951-11-17	1
25657	1526	28060	1985-08-05	1985-08-17	1
75101	4466	260139	1983-03-04	1983-03-18	1
17143	1025	81151	1941-04-18	1941-05-16	1
23946	1431	4285898	1988-04-14	1988-04-15	1
65858	3896	40481087	1979-04-06	1979-04-27	1
26647	1579	40481087	2008-05-05	2008-05-12	1
70169	4160	80180	2004-08-08	2004-08-09	1
17914	1079	40481087	2004-09-02	2004-09-23	1
69864	4137	378001	1997-03-17	1997-04-16	1
69376	4109	260139	1988-09-17	1988-09-24	1
60993	3613	40481087	2009-01-05	2009-01-12	1
72219	4289	40481087	2001-11-23	2001-12-14	1
19707	1185	4294548	2000-07-29	2000-10-07	1
427	23	4285898	2011-08-15	2011-08-16	1
678	38	4112343	2005-06-06	2005-06-14	1
14625	864	4296205	1935-12-21	1936-01-25	1
68045	4022	4112343	1985-05-13	1985-05-21	1
25482	1518	260139	1997-01-22	1997-02-05	1
79189	4694	40481087	1993-12-03	1993-12-24	1
50980	3022	372328	1972-12-01	1973-01-12	1
76237	4527	381316	2001-03-02	2001-03-03	1
83312	4957	81151	2004-11-07	2004-12-05	1
25082	1497	4283893	1984-11-10	1984-12-22	1
85569	5095	260139	1985-06-20	1985-07-04	1
24380	1454	378001	1977-10-08	1977-11-07	1
21203	1273	4112343	1980-10-11	1980-10-24	1
82915	4929	40481087	1989-02-23	1989-03-16	1
14206	841	260139	1966-08-31	1966-09-07	1
72141	4284	4112343	1964-01-07	1964-01-16	1
20479	1232	260139	1991-10-04	1991-10-11	1
75566	4487	40481087	1953-08-22	1953-09-12	1
20657	1242	40481087	2003-04-07	2003-04-28	1
7861	459	260139	1985-02-15	1985-02-22	1
87854	5232	4112343	1978-08-15	1978-08-28	1
85270	5077	80180	2002-10-29	2002-10-30	1
11668	689	40481087	1993-11-01	1993-11-15	1
16970	1015	0	1984-10-19	1984-10-20	1
56015	3320	260139	2000-12-10	2000-12-24	1
88155	5249	40481087	2002-04-12	2002-04-26	1
25859	1537	81151	1969-07-19	1969-08-16	1
24535	1466	4156265	1998-03-12	1998-03-26	1
76930	4562	4283893	1989-11-22	1990-01-17	1
19524	1174	40481087	1976-09-13	1976-09-27	1
88424	5262	40481087	1977-10-04	1977-10-11	1
18479	1113	30753	2012-07-28	2012-07-29	1
23437	1401	40481087	2015-03-22	2015-04-12	1
68895	4081	4112343	2012-10-05	2012-10-14	1
12316	728	40481087	1995-04-08	1995-04-29	1
77640	4604	40481087	2000-10-08	2000-10-29	1
81266	4826	40481087	1994-12-16	1994-12-23	1
54440	3227	80180	2004-10-04	2004-10-05	1
24592	1468	260139	1989-07-13	1989-07-20	1
74153	4408	40481087	2007-10-18	2007-10-25	1
52733	3125	81151	1957-07-17	1957-07-31	1
77501	4596	260139	1947-08-09	1947-08-16	1
25658	1526	80180	2012-10-05	2012-10-06	1
75102	4466	372328	1977-07-31	1977-09-16	1
17144	1025	133834	1940-09-27	1958-02-25	1
23947	1431	4294548	1988-07-04	1988-09-12	1
68446	4052	81893	2013-08-29	2013-08-30	1
26648	1579	40481087	2012-08-25	2012-09-15	1
70170	4160	81151	2017-06-08	2017-06-29	1
17915	1079	40481087	2011-07-06	2011-07-13	1
69865	4137	4112343	2018-01-09	2018-01-21	1
69377	4109	4112343	1982-04-16	1982-04-28	1
62385	3691	78272	1988-03-20	1988-04-03	1
72220	4289	28060	2016-09-24	2016-10-07	1
19708	1185	40481087	1971-03-20	1971-04-03	1
428	23	4296204	1997-02-04	1997-03-04	1
679	38	4283893	1973-09-30	1973-10-14	1
14626	864	40481087	1923-11-25	1923-12-09	1
68046	4022	4116491	1977-07-13	1977-08-20	1
25483	1518	378001	1996-07-27	1996-08-26	1
79190	4694	4112343	1986-05-17	1986-05-27	1
50981	3022	4296204	1975-04-20	1975-05-25	1
76238	4527	4112343	2015-12-11	2015-12-24	1
83313	4957	260139	1977-02-04	1977-02-11	1
25083	1497	4294548	1970-07-19	1970-09-13	1
85570	5095	4294548	2003-11-05	2003-12-17	1
24381	1454	4112343	1984-07-17	1984-07-28	1
21204	1273	4112343	2011-01-29	2011-02-10	1
82916	4929	28060	1968-02-15	1968-02-26	1
14207	841	378001	1990-08-15	1990-10-14	1
72142	4284	4112343	1990-03-17	1990-03-24	1
20480	1232	4294548	1977-06-16	1977-10-20	1
75567	4487	40481087	1958-02-25	1958-03-18	1
20658	1242	30753	2000-03-25	2000-03-26	1
7862	459	4112343	1995-05-03	1995-05-14	1
87855	5232	4112343	1982-12-08	1982-12-16	1
85271	5077	260139	1998-12-12	1998-12-19	1
11669	689	80180	2017-08-01	2017-08-02	1
16971	1015	260139	2010-06-30	2010-07-07	1
56016	3320	81151	1978-02-07	1978-02-21	1
88156	5249	260139	1979-02-02	1979-02-09	1
25860	1537	260139	1977-11-04	1977-11-11	1
24536	1466	40481087	1996-06-30	1996-07-07	1
76931	4562	4294548	1979-03-21	1979-04-11	1
19525	1174	40481087	1996-06-15	1996-06-29	1
88425	5262	40481087	1993-10-31	1993-11-21	1
18480	1113	378001	1972-09-11	1972-11-10	1
23438	1401	80180	2007-08-03	2007-08-04	1
68896	4081	40481087	1962-09-07	1962-09-14	1
12317	728	0	1960-01-22	1960-01-23	1
77641	4604	40481087	2014-12-11	2014-12-18	1
81267	4826	40481087	2011-05-09	2011-05-30	1
54441	3227	372328	1984-05-24	1985-03-19	1
24593	1468	313217	2015-06-03	2015-06-04	1
76010	4514	260139	1999-05-19	1999-06-02	1
52734	3125	81151	1963-12-27	1964-01-31	1
77502	4596	260139	1957-10-25	1957-11-08	1
25659	1526	40481087	1983-06-25	1983-07-16	1
75103	4466	4113008	2016-09-04	2016-09-18	1
17145	1025	4112343	1968-05-30	1968-06-06	1
23948	1431	40481087	1953-05-21	1953-05-28	1
68447	4052	4109685	1986-12-19	1987-01-02	1
26649	1579	80180	1988-03-11	1988-03-12	1
70171	4160	260139	2017-01-27	2017-02-03	1
17916	1079	80180	1993-11-26	1993-11-27	1
69866	4137	40481087	1999-03-27	1999-04-17	1
69378	4109	4112343	2011-01-21	2011-01-28	1
62386	3691	260139	2005-08-28	2005-09-04	1
72221	4289	260139	1964-05-25	1964-06-01	1
19709	1185	81151	2004-06-26	2004-07-31	1
429	23	40481087	2009-05-25	2009-06-01	1
680	38	81151	1967-10-27	1967-11-17	1
14627	864	40481087	1936-09-05	1936-09-12	1
68047	4022	40481087	1976-09-22	1976-09-29	1
25484	1518	4155034	1968-06-03	1968-06-24	1
79191	4694	4237458	1982-08-04	1982-11-02	1
50982	3022	40481087	2016-06-16	2016-06-30	1
76239	4527	4266809	2002-01-21	2002-01-22	1
83314	4957	260139	1978-11-12	1978-11-19	1
25084	1497	40481087	1985-12-24	1986-01-07	1
85571	5095	40481087	1970-12-09	1970-12-30	1
24382	1454	80180	2009-11-14	2009-11-15	1
21205	1273	40481087	1968-06-28	1968-07-19	1
82917	4929	81151	1979-10-27	1979-11-10	1
14208	841	4084167	1966-01-02	1966-01-02	1
72143	4284	4112343	2014-08-09	2014-08-18	1
20481	1232	260139	1996-07-30	1996-08-13	1
75568	4487	40481087	2002-06-09	2002-06-16	1
20659	1242	81151	1969-10-14	1969-11-11	1
7863	459	4112343	1995-06-15	1995-06-28	1
87856	5232	4112343	2004-01-12	2004-01-25	1
85272	5077	260139	2014-05-18	2014-05-25	1
11670	689	372328	1983-08-15	1984-01-29	1
16972	1015	40481087	2015-12-12	2016-01-02	1
56017	3320	260139	1967-03-09	1967-03-23	1
88157	5249	372328	1963-05-20	1963-12-22	1
25861	1537	372328	1960-08-12	1962-05-02	2
24537	1466	40481087	2005-09-22	2005-09-29	1
76932	4562	40481087	2007-01-30	2007-02-13	1
19526	1174	80180	1974-01-25	1974-01-26	1
88426	5262	40481087	2014-09-03	2014-09-17	1
18481	1113	4112343	2010-03-13	2010-03-24	1
23439	1401	81151	1986-03-21	1986-04-18	1
68897	4081	40481087	1965-09-06	1965-09-20	1
12318	728	28060	1963-11-09	1963-11-21	1
77642	4604	260139	2014-04-06	2014-04-20	1
81268	4826	260139	1991-11-07	1991-11-21	1
54442	3227	4112343	1994-03-14	1994-03-25	1
24594	1468	378001	2007-04-20	2007-05-20	1
76011	4514	40481087	1981-10-23	1981-11-06	1
52735	3125	81151	2003-03-10	2003-04-14	1
77503	4596	313217	2013-04-14	2013-04-15	1
25660	1526	28060	1979-09-23	1979-10-03	1
75104	4466	4283893	1985-12-06	1986-09-12	1
17146	1025	4294548	1968-09-05	1968-10-03	1
23949	1431	40481087	1972-01-09	1972-01-30	1
68448	4052	4285898	2014-10-23	2014-10-24	1
26650	1579	4112343	1973-11-03	1973-11-11	1
70172	4160	321042	1965-11-25	1965-11-26	1
17917	1079	81151	1962-02-12	1962-02-26	1
70557	4191	260139	1973-08-24	1973-08-31	1
69379	4109	4116491	2007-12-31	2008-02-17	1
62387	3691	4112343	2000-02-13	2000-02-26	1
72222	4289	260139	2003-12-24	2003-12-31	1
19710	1185	260139	1946-04-13	1946-04-27	1
430	23	372328	2016-01-21	2018-09-13	1
681	38	195588	2004-01-31	2004-03-02	1
14628	864	40481087	1992-07-11	1992-08-01	1
68048	4022	40481087	1983-01-05	1983-01-26	1
25485	1518	4266809	1998-07-14	1998-07-15	1
79192	4694	40481087	2016-07-18	2016-07-25	1
50983	3022	78272	2003-03-27	2003-04-24	1
76240	4527	4283893	1983-01-21	1983-02-11	1
83315	4957	372328	1971-12-01	1972-01-08	1
25085	1497	40481087	1999-04-15	1999-04-29	1
86728	5169	4112343	1998-12-06	1998-12-16	1
24383	1454	260139	1979-01-02	1979-01-09	1
21206	1273	40481087	2008-09-20	2008-10-11	1
82918	4929	4218389	1984-07-16	1984-08-06	1
14209	841	40481087	1965-03-09	1965-03-16	1
72144	4284	28060	1998-04-01	1998-04-08	1
20482	1232	372328	1966-03-09	1966-05-23	1
75569	4487	40481087	2005-09-03	2005-09-17	1
20660	1242	260139	1979-02-14	1979-02-21	1
7864	459	40481087	2012-10-25	2012-11-01	1
87857	5232	4237458	1976-07-21	1976-08-20	1
85273	5077	4027663	1993-03-10	1993-03-11	1
11671	689	40481087	1987-12-21	1987-12-28	1
16973	1015	260139	2012-10-31	2012-11-07	1
56018	3320	260139	2015-06-30	2015-07-07	1
88158	5249	4059173	1951-08-21	1951-11-19	1
25862	1537	372328	1994-02-13	1996-06-19	1
24538	1466	30753	2004-03-21	2004-03-22	1
76933	4562	40486433	1966-02-03	1966-02-04	1
19527	1174	260139	2016-05-29	2016-06-12	1
88427	5262	30753	2009-02-17	2009-02-18	1
18482	1113	4285898	2012-10-26	2012-10-27	1
23440	1401	4112343	1996-06-26	1996-07-09	1
68898	4081	40481087	2000-12-10	2000-12-17	1
12319	728	260139	1982-07-21	1982-07-28	1
77643	4604	4112343	1976-09-12	1976-09-22	1
81269	4826	260139	1996-05-10	1996-05-17	1
54443	3227	40481087	2007-04-29	2007-05-06	1
24595	1468	4112343	1958-09-12	1958-09-20	1
76012	4514	80180	2015-03-29	2015-03-30	1
52736	3125	4112343	1955-06-10	1955-06-18	1
77504	4596	4027663	1970-06-18	1970-06-19	1
25661	1526	372328	1974-05-18	1974-06-01	1
75105	4466	4294548	2013-05-13	2013-05-27	1
17147	1025	4299128	1945-02-24	1945-03-31	1
23950	1431	81151	2003-02-16	2003-03-02	1
68449	4052	40481087	1999-07-19	1999-08-02	1
26651	1579	4112343	1981-12-31	1982-01-13	1
70173	4160	372328	1964-01-26	1964-04-02	1
17918	1079	140673	2016-03-05	2016-03-06	1
70558	4191	372328	1961-08-25	1962-07-27	1
69380	4109	40481087	1969-10-06	1969-10-20	1
62388	3691	4152936	1989-12-24	1990-01-14	1
72223	4289	4134304	1952-07-01	1952-08-30	1
19711	1185	260139	1948-04-21	1948-04-29	1
431	23	40481087	1991-08-08	1991-08-22	1
682	38	378001	1981-04-07	1981-05-07	1
14629	864	28060	1967-12-16	1967-12-25	1
68049	4022	257012	1986-09-10	1986-09-11	1
25486	1518	40481087	1975-09-16	1975-09-30	1
79193	4694	80180	2018-01-17	2018-01-18	1
50984	3022	260139	1976-03-16	1976-03-30	1
76241	4527	4310024	2000-09-28	2000-09-29	1
83316	4957	4112343	2001-08-26	2001-09-06	1
25086	1497	28060	1978-06-08	1978-06-19	1
86729	5169	40481087	1983-10-26	1983-11-09	1
24384	1454	260139	1985-05-09	1985-05-16	1
21207	1273	40481087	2015-11-10	2015-11-17	1
84628	5037	80180	2009-07-28	2009-07-29	1
14210	841	40481087	1965-05-21	1965-06-11	1
72145	4284	260139	1996-01-31	1996-02-07	1
20483	1232	4112343	2002-05-10	2002-05-22	1
75570	4487	78272	1962-07-27	1962-08-17	1
20661	1242	260139	1985-05-07	1985-05-14	1
7865	459	78272	1975-05-07	1975-06-11	1
87858	5232	28060	1989-04-14	1989-04-27	1
85274	5077	4156265	1973-10-31	1973-11-14	1
11672	689	40481087	2017-06-28	2017-07-12	1
16974	1015	321042	1973-07-23	1973-07-24	1
56019	3320	4112343	1974-10-28	1974-11-04	1
88159	5249	40481087	1959-06-02	1959-06-09	1
25863	1537	40481087	1970-07-05	1970-07-19	1
24539	1466	4112343	1978-02-27	1978-03-11	1
76934	4562	260139	1975-09-14	1975-09-21	1
19528	1174	372328	1943-07-27	1943-12-19	1
88428	5262	260139	2008-06-22	2008-06-29	1
18483	1113	40481087	2006-10-29	2006-11-19	1
23441	1401	4112343	1998-05-01	1998-05-08	1
68899	4081	317576	2016-10-31	2016-11-01	1
12320	728	378001	2000-04-14	2000-06-13	1
77644	4604	28060	1971-02-27	1971-03-11	1
81270	4826	4112343	2011-07-31	2011-08-12	1
54444	3227	260139	1990-04-26	1990-05-03	1
24596	1468	4112343	1983-01-11	1983-01-20	1
76013	4514	260139	2014-06-29	2014-07-06	1
52737	3125	4112343	2017-10-18	2017-10-28	1
77505	4596	4112343	1958-04-15	1958-04-28	1
25662	1526	4155034	2005-09-30	2005-10-14	1
75106	4466	40481087	2005-01-10	2005-01-31	1
17148	1025	40481087	1956-10-04	1956-10-18	1
23951	1431	81893	1987-06-19	1987-06-20	1
68450	4052	40481087	1980-03-04	1980-03-11	1
26652	1579	4112343	2019-01-15	2019-01-25	1
70174	4160	4116491	1989-06-28	1989-08-08	1
17919	1079	195588	2010-03-07	2010-04-18	1
70559	4191	4112343	1958-11-10	1958-11-20	1
69381	4109	40481087	1977-05-20	1977-05-27	1
62389	3691	4156265	2012-07-17	2012-08-07	1
72224	4289	40481087	1950-12-11	1951-01-01	1
19712	1185	260139	1962-07-16	1962-07-30	1
1659	97	80180	1986-03-25	1986-03-26	1
683	38	4027663	1997-02-01	1997-02-02	1
14630	864	81151	1963-09-26	1963-10-10	1
68050	4022	4112343	1977-06-24	1977-07-07	1
25487	1518	40481087	1990-10-18	1990-11-08	1
79194	4694	195588	2015-08-01	2015-09-05	1
50985	3022	4278672	1985-04-09	1985-06-08	1
76242	4527	40481087	1987-01-27	1987-02-17	1
83317	4957	40481087	1978-05-06	1978-05-20	1
25087	1497	80180	1974-07-25	1974-07-26	1
86730	5169	40481087	1986-01-03	1986-01-24	1
24385	1454	40481087	2009-06-14	2009-07-05	1
21208	1273	260139	1941-09-13	1941-09-20	1
84629	5037	4156265	1994-12-14	1995-01-04	1
14211	841	40481087	1984-02-10	1984-02-17	1
72146	4284	372328	1945-04-21	1945-05-05	1
20484	1232	40481087	1982-12-13	1982-12-27	1
75571	4487	80180	1988-01-22	1988-01-23	1
20662	1242	372328	1964-02-27	1965-02-24	1
7866	459	81151	1987-12-05	1988-01-02	1
87859	5232	40481087	1973-10-14	1973-10-28	1
85275	5077	4285898	2002-09-29	2002-09-30	1
12011	711	260139	1983-04-05	1983-04-12	1
16975	1015	4112343	1982-08-12	1982-08-20	1
56020	3320	40481087	2009-11-11	2009-11-25	1
88160	5249	81151	1963-02-19	1963-03-12	1
25864	1537	40481087	2008-01-21	2008-01-28	1
24540	1466	40481087	1990-10-10	1990-10-31	1
76935	4562	260139	1982-08-26	1982-09-09	1
19529	1174	4112343	1978-10-31	1978-11-12	1
88429	5262	4027663	2001-12-26	2001-12-27	1
18484	1113	40481087	2008-11-14	2008-11-21	1
23442	1401	4237458	1987-03-14	1987-05-13	1
68900	4081	4112343	1956-12-03	1956-12-14	1
12321	728	440448	1960-01-22	1960-01-23	1
77645	4604	80180	2002-05-06	2002-05-07	1
81271	4826	4152936	2002-11-22	2002-12-13	1
54445	3227	260139	1976-01-22	1976-02-05	1
24597	1468	40481087	1958-06-18	1958-06-25	1
76014	4514	372328	1978-09-04	1978-10-27	1
52738	3125	4113008	2011-09-29	2011-10-13	1
77506	4596	4112343	1993-08-25	1993-09-03	1
25663	1526	40481087	1977-05-09	1977-05-23	1
75107	4466	80180	2008-02-09	2008-02-10	1
17149	1025	40481087	2015-01-09	2015-01-23	1
23952	1431	260139	1963-06-22	1963-07-06	1
68451	4052	40481087	1988-02-18	1988-03-10	1
26653	1579	4155034	1965-06-26	1965-07-10	1
70175	4160	4116491	1993-08-07	1993-09-18	1
17920	1079	260139	2004-12-07	2004-12-14	1
70560	4191	4112343	1961-04-12	1961-04-22	1
69382	4109	40481087	1987-05-14	1987-06-04	1
62390	3691	40481087	1999-09-01	1999-09-08	1
72225	4289	81151	1951-05-03	1951-06-07	1
19713	1185	260139	2000-07-23	2000-07-30	1
1660	97	81893	1984-01-05	1984-01-06	1
684	38	4283893	2003-03-04	2003-07-29	1
14631	864	81151	1988-09-28	1988-10-19	1
68051	4022	4112343	2001-11-05	2001-11-15	1
25488	1518	40481087	2001-06-08	2001-06-15	1
79195	4694	260139	1982-02-07	1982-02-21	1
50986	3022	40481087	1990-09-03	1990-09-17	1
76243	4527	40481087	2004-09-21	2004-09-28	1
83318	4957	40481087	1993-02-06	1993-02-20	1
25088	1497	260139	1979-05-21	1979-06-04	1
86731	5169	40481087	1998-02-25	1998-03-11	1
24386	1454	40481087	2010-10-04	2010-10-11	1
21209	1273	260139	1947-11-29	1947-12-13	1
84630	5037	40481087	2007-03-15	2007-04-05	1
14212	841	40481087	1997-09-04	1997-09-25	1
72147	4284	372328	1947-07-01	1947-11-13	1
20485	1232	40481087	1986-08-14	1986-09-04	1
75572	4487	192671	1988-03-26	1988-03-27	1
20663	1242	4310024	1999-09-27	1999-09-28	1
7867	459	378001	1983-11-26	1983-12-26	1
87860	5232	40481087	1996-07-20	1996-08-03	1
85276	5077	40481087	1977-08-20	1977-09-03	1
12012	711	372328	1955-05-30	1955-12-02	1
16976	1015	4112343	2009-10-29	2009-11-10	1
56021	3320	40481087	2016-05-28	2016-06-11	1
88161	5249	257012	2015-05-15	2015-05-16	1
25865	1537	260139	2010-12-29	2011-01-05	1
24541	1466	40481087	1997-02-08	1997-03-01	1
76936	4562	4035415	1984-12-28	1985-01-27	1
19530	1174	4112343	1987-11-09	1987-11-18	1
88430	5262	4112343	1977-12-01	1977-12-12	1
18485	1113	28060	1986-10-11	1986-10-19	1
23443	1401	40481087	1977-10-13	1977-10-27	1
68901	4081	4112343	1959-07-04	1959-07-13	1
12322	728	4112343	2003-10-13	2003-10-25	1
77646	4604	260139	1971-03-26	1971-04-09	1
81272	4826	40481087	1954-03-03	1954-03-17	1
54446	3227	4112343	1974-03-02	1974-03-15	1
24598	1468	40481087	1981-12-25	1982-01-15	1
76015	4514	4134304	1979-04-16	1979-07-15	1
52739	3125	4152936	1975-09-30	1975-10-21	1
77507	4596	4112343	2016-06-16	2016-06-29	1
25664	1526	378001	1976-12-31	1977-01-30	1
75108	4466	40481087	2012-08-26	2012-09-09	1
18993	1143	81151	2008-04-18	2008-05-23	1
23953	1431	260139	2018-07-09	2018-07-16	1
68452	4052	40481087	2018-06-10	2018-06-17	1
26654	1579	4285898	1987-06-15	1987-06-16	1
70176	4160	4134304	1978-05-17	1978-07-16	1
17921	1079	4112343	1988-03-27	1988-04-07	1
70561	4191	4112343	1989-11-19	1989-12-02	1
69383	4109	40481087	2000-05-03	2000-05-24	1
62391	3691	28060	1999-01-04	1999-01-16	1
72226	4289	4112343	2010-03-21	2010-03-29	1
19714	1185	260139	2012-08-30	2012-09-13	1
1661	97	257012	1982-02-02	1982-02-03	1
685	38	40481087	1993-03-10	1993-03-17	1
14632	864	260139	1960-03-18	1960-03-25	1
68052	4022	40481087	1963-12-30	1964-01-20	1
25489	1518	28060	1981-08-20	1981-08-31	1
79196	4694	4278672	2001-02-25	2001-03-27	1
50987	3022	81151	2011-11-08	2011-11-22	1
76244	4527	40481087	2017-02-01	2017-02-22	1
83319	4957	40481087	2016-08-27	2016-09-17	1
25089	1497	260139	1992-03-11	1992-03-18	1
86732	5169	40481087	2016-12-22	2017-01-12	1
24387	1454	260139	1989-12-23	1989-12-30	1
21210	1273	260139	1969-04-28	1969-05-12	1
84631	5037	40481087	2014-04-05	2014-04-12	1
14213	841	40486433	1954-01-22	1954-01-23	1
72148	4284	372328	1958-03-20	1959-01-15	1
20486	1232	80180	2003-01-19	2003-01-20	1
75573	4487	317576	2004-10-22	2004-10-23	1
20664	1242	40481087	1974-04-07	1974-04-21	1
7868	459	4112343	1985-11-11	1985-11-19	1
87861	5232	40481087	2008-05-10	2008-05-24	1
85277	5077	40481087	1991-07-28	1991-08-11	1
12013	711	4112343	1954-08-06	1954-08-13	1
16977	1015	4146173	1995-11-04	1996-01-03	1
56763	3371	78272	1983-12-01	1983-12-29	1
88162	5249	260139	1955-10-31	1955-11-14	1
25866	1537	378001	1962-12-23	1963-02-21	1
27804	1642	260139	1978-07-15	1978-07-22	1
76937	4562	4283893	2000-06-22	2000-08-03	1
19531	1174	40481087	1980-06-20	1980-07-04	1
88431	5262	4112343	1981-08-27	1981-09-05	1
18486	1113	81893	2011-10-02	2011-10-03	1
23444	1401	40481087	1985-05-24	1985-05-31	1
68902	4081	4294548	1998-01-31	1998-05-02	1
12323	728	40481087	1965-06-05	1965-06-19	1
77647	4604	260139	1977-09-12	1977-09-19	1
81273	4826	40481087	1969-05-25	1969-06-15	1
54447	3227	4142905	1986-02-26	1986-04-27	1
24599	1468	40481087	1997-02-19	1997-02-26	1
76016	4514	4156265	1977-02-11	1977-02-25	1
52740	3125	4155034	1988-11-09	1988-11-23	1
77508	4596	4266809	1979-01-27	1979-01-28	1
25665	1526	4112343	1991-01-04	1991-01-11	1
75109	4466	28060	1976-02-09	1976-02-18	1
18994	1143	372328	1973-09-14	1973-11-02	1
23954	1431	4027663	1978-09-24	1978-09-25	1
68453	4052	80180	2015-09-18	2015-09-19	1
26655	1579	40481087	1976-02-07	1976-02-21	1
70177	4160	4296205	1989-02-18	1989-03-18	1
17922	1079	4156265	2002-04-02	2002-04-23	1
70562	4191	40481087	1977-07-07	1977-07-28	1
69384	4109	40481087	2010-07-27	2010-08-17	1
62392	3691	81151	1955-09-07	1955-09-21	1
72227	4289	4152936	1994-06-26	1994-07-10	1
19715	1185	372328	1939-08-16	1939-11-05	1
1662	97	260139	2001-05-15	2001-05-29	1
686	38	81893	2005-01-25	2005-01-26	1
14633	864	260139	2002-07-14	2002-07-21	1
68053	4022	40481087	1964-12-22	1964-12-29	1
25490	1518	80180	1998-07-14	1998-07-15	1
79197	4694	40481087	2009-04-12	2009-05-03	1
50988	3022	260139	1991-07-18	1991-07-25	1
76245	4527	80180	2002-01-21	2002-01-22	1
83320	4957	260139	1983-09-05	1983-09-19	1
25090	1497	260139	2007-05-01	2007-05-15	1
86733	5169	260139	1977-12-24	1977-12-31	1
24388	1454	260139	1999-11-19	1999-11-26	1
21211	1273	372328	2009-11-14	2010-10-18	1
84632	5037	260139	2014-08-03	2014-08-17	1
15751	933	80180	2011-07-09	2011-07-10	1
72149	4284	4112343	1994-10-03	1994-10-16	1
20487	1232	257012	1977-08-18	1977-08-19	1
75574	4487	40481087	1964-01-24	1964-02-07	1
20665	1242	40481087	1977-12-06	1977-12-27	1
9116	539	80180	1968-12-02	1968-12-03	1
87862	5232	40481087	2016-06-20	2016-06-27	1
85278	5077	40481087	2006-08-25	2006-09-08	1
12014	711	4112343	1976-07-27	1976-08-07	1
16978	1015	4152936	2003-07-25	2003-08-08	1
56764	3371	440086	1988-08-11	1993-08-20	1
88163	5249	381316	2004-04-25	2004-04-26	1
25867	1537	4112343	2014-01-26	2014-02-05	1
27805	1642	260139	2018-07-05	2018-07-12	1
76938	4562	40481087	1966-08-09	1966-08-30	1
19532	1174	40481087	1992-12-03	1992-12-24	1
88432	5262	4112343	2017-02-01	2017-02-10	1
18487	1113	4027663	2005-11-07	2005-11-08	1
23445	1401	40481087	1991-01-20	1991-02-03	1
68903	4081	40481087	1978-12-03	1978-12-24	1
12324	728	40481087	1969-05-08	1969-05-22	1
77648	4604	4112343	1979-03-12	1979-03-24	1
81274	4826	40481087	2005-10-16	2005-10-30	1
54448	3227	40479422	1998-07-23	1998-08-29	1
24600	1468	40481087	2008-02-09	2008-02-16	1
76017	4514	378001	1990-12-14	1991-01-13	1
52741	3125	4294548	1975-12-05	1976-01-02	1
77509	4596	40481087	1963-08-06	1963-08-27	1
25666	1526	4294548	2009-09-26	2009-10-10	1
75110	4466	4112343	1991-05-31	1991-06-08	1
18995	1143	4156265	1979-11-12	1979-11-26	1
23955	1431	4059173	2018-11-08	2018-12-08	1
68454	4052	133834	1977-11-13	1977-11-14	1
26656	1579	40481087	2007-02-21	2007-03-07	1
70178	4160	40481087	1985-09-13	1985-09-27	1
17923	1079	40481087	2010-12-26	2011-01-02	1
70563	4191	40481087	1995-01-03	1995-01-24	1
71518	4247	28060	1995-07-16	1995-07-27	1
62393	3691	260139	1984-01-05	1984-01-19	1
72228	4289	4278672	2017-05-10	2017-08-08	1
19716	1185	372328	1941-10-25	1942-01-25	1
1663	97	4027663	1974-07-11	1974-07-12	1
687	38	257012	2003-05-20	2003-05-21	1
14634	864	378419	1996-08-05	1996-08-06	1
68054	4022	40481087	2015-12-24	2015-12-31	1
25491	1518	4112343	1978-06-21	1978-07-03	1
79198	4694	40481087	2015-02-08	2015-02-15	1
50989	3022	372328	1976-08-24	1977-04-01	1
76246	4527	4027663	1993-06-02	1993-06-03	1
83321	4957	4112343	1979-09-22	1979-10-02	1
25091	1497	372328	1940-11-10	1941-02-21	1
86734	5169	260139	1984-11-25	1984-12-09	1
24389	1454	378001	1986-11-20	1987-01-19	1
22111	1322	28060	2014-07-30	2014-08-12	1
84633	5037	4112343	2014-01-20	2014-01-31	1
15752	933	81151	1991-08-19	1991-09-16	1
72150	4284	40481087	1993-03-24	1993-04-14	1
20488	1232	372328	1968-12-08	1969-09-01	1
75575	4487	40481087	1978-09-08	1978-09-15	1
20666	1242	40481087	2015-03-02	2015-03-23	1
9117	539	260139	1957-03-08	1957-03-15	1
87863	5232	40481087	2017-09-25	2017-10-09	1
86006	5123	80180	2016-08-06	2016-08-07	1
12015	711	40479422	1978-07-28	1978-10-03	1
16979	1015	4156265	1957-11-04	1957-11-18	1
56765	3371	4112343	1981-02-17	1981-02-24	1
88164	5249	4112343	1967-06-14	1967-06-21	1
25868	1537	40481087	1957-02-14	1957-03-07	1
27806	1642	439777	1979-05-15	1979-05-16	1
76939	4562	40481087	1972-12-02	1972-12-16	1
19533	1174	40481087	2015-08-19	2015-09-02	1
88433	5262	78272	2015-05-08	2015-06-12	1
18488	1113	4112343	2009-07-05	2009-07-12	1
23446	1401	40481087	1997-02-08	1997-02-22	1
70222	4165	28060	1938-05-15	1938-05-28	1
12325	728	40481087	1990-08-02	1990-08-23	1
77649	4604	4112343	2008-02-21	2008-02-28	1
81275	4826	372328	1951-09-07	1951-11-17	1
54449	3227	40481087	1980-03-07	1980-03-14	1
24601	1468	317576	1977-02-02	1977-02-03	1
76018	4514	40481087	1985-10-22	1985-11-12	1
52742	3125	40481087	1982-05-05	1982-05-19	1
77510	4596	40481087	1980-10-10	1980-10-31	1
25667	1526	4296204	1972-11-24	1972-12-22	1
75111	4466	4112343	2006-05-18	2006-05-26	1
18996	1143	4237458	1976-01-02	1976-03-02	1
23956	1431	4084167	1950-05-29	1950-05-30	1
68455	4052	372328	1979-05-19	1979-09-20	1
26657	1579	81151	2013-05-29	2013-07-03	1
70179	4160	40481087	1991-09-05	1991-09-19	1
17924	1079	28060	1970-10-15	1970-10-27	1
70564	4191	0	2013-07-26	2013-07-27	1
71519	4247	78272	1993-07-15	1993-08-05	1
62394	3691	4112343	1990-05-08	1990-05-17	1
72229	4289	4285898	1977-11-02	1977-11-03	1
19717	1185	4218389	1971-05-30	1971-06-20	1
1664	97	4059173	1959-09-23	1959-11-22	1
688	38	4112343	1988-03-28	1988-04-04	1
14635	864	4112343	1949-08-25	1949-09-02	1
68055	4022	40481087	2019-06-21	2019-06-22	1
25492	1518	4112343	1992-05-09	1992-05-20	1
81033	4812	28060	2002-05-25	2002-06-06	1
50990	3022	4146173	1978-11-05	1979-01-11	1
76247	4527	4112343	1974-10-12	1974-10-23	1
83322	4957	4134304	1986-08-14	1986-11-12	1
25092	1497	439777	1983-03-05	1983-03-06	1
86735	5169	378001	1967-10-07	1967-12-06	1
24390	1454	4112343	1992-12-17	1992-12-25	1
22112	1322	257012	1965-02-16	1965-02-17	1
84634	5037	40481087	2003-12-05	2003-12-26	1
15753	933	81151	2014-10-15	2014-11-05	1
79159	4691	28060	1974-02-28	1974-03-13	1
20489	1232	4155034	1993-12-12	1993-12-26	1
75576	4487	40481087	1981-07-21	1981-08-11	1
20667	1242	260139	2007-05-20	2007-06-03	1
9118	539	260139	1972-12-15	1972-12-22	1
87864	5232	28060	1978-02-04	1978-02-13	1
86007	5123	372328	1983-11-03	1984-05-07	1
12016	711	40481087	1994-03-21	1994-03-28	1
17570	1057	81151	1963-03-12	1963-03-26	1
56766	3371	4112343	1982-07-21	1982-08-02	1
88165	5249	4112343	1986-03-31	1986-04-08	1
25869	1537	40481087	1982-10-07	1982-10-28	1
27807	1642	40481087	1973-07-10	1973-07-24	1
76940	4562	40481087	2005-03-18	2005-04-01	1
19534	1174	40481087	2016-05-05	2016-05-12	1
88434	5262	80180	2010-04-13	2010-04-14	1
18489	1113	4294548	2013-11-01	2013-11-08	1
23447	1401	81893	2005-04-15	2005-04-16	1
70223	4165	260139	1912-03-15	1912-03-29	1
12326	728	40481087	2014-09-22	2014-10-13	1
77650	4604	4152936	2000-04-21	2000-05-05	1
81276	4826	4112343	2009-11-27	2009-12-05	1
54450	3227	372328	1974-11-26	1975-09-09	1
24602	1468	4112343	2004-06-02	2004-06-13	1
76019	4514	40481087	1990-11-21	1990-12-05	1
52743	3125	40481087	2017-07-27	2017-08-17	1
77511	4596	81151	1971-03-24	1971-04-14	1
25668	1526	40481087	1990-09-13	1990-09-27	1
75112	4466	40481087	1979-09-25	1979-10-02	1
18997	1143	4278672	1983-11-26	1983-12-26	1
23957	1431	4146173	1950-07-28	1950-09-26	1
68456	4052	4027663	2007-04-08	2007-04-09	1
26658	1579	192671	1988-05-25	1988-05-26	1
70180	4160	260139	2015-07-09	2015-07-23	1
17925	1079	260139	1988-07-26	1988-08-02	1
70565	4191	28060	1977-07-10	1977-07-22	1
71520	4247	80180	2018-03-30	2018-03-31	1
62395	3691	4112343	2002-10-15	2002-10-27	1
72230	4289	40481087	1977-03-22	1977-03-29	1
19718	1185	40481087	1976-09-28	1976-10-05	1
1665	97	4116491	1966-11-01	1966-12-22	1
689	38	40481087	1965-08-17	1965-09-07	1
14636	864	4112343	1973-01-01	1973-01-13	1
68174	4032	28060	2007-06-22	2007-07-04	1
25493	1518	4310024	1996-05-25	1996-05-26	1
81034	4812	4109685	1981-12-16	1982-01-06	1
50991	3022	4283893	1982-02-20	1982-04-10	1
76248	4527	40481087	1962-04-09	1962-04-16	1
83323	4957	260139	2003-09-05	2003-09-12	1
25093	1497	4084167	1941-05-09	1941-05-10	1
86736	5169	4112343	1997-01-28	1997-02-10	1
24391	1454	40481087	1992-05-18	1992-06-08	1
22113	1322	260139	1957-02-07	1957-02-14	1
84635	5037	28060	1985-06-22	1985-07-03	1
15754	933	4218389	1981-09-30	1981-10-21	1
79160	4691	4059173	1962-03-28	1962-06-26	1
20490	1232	260139	1989-06-30	1989-07-14	1
75577	4487	40481087	1983-04-11	1983-05-02	1
20668	1242	40481087	1961-11-30	1961-12-14	1
9119	539	260139	1989-01-16	1989-01-23	1
87865	5232	4112343	1968-04-06	1968-04-15	1
86008	5123	4112343	1990-10-23	1990-10-31	1
12017	711	4112343	1971-05-02	1971-05-12	1
17571	1057	260139	2011-04-29	2011-05-06	1
56767	3371	4296204	1996-08-13	1996-09-03	1
88166	5249	4112343	1988-03-02	1988-03-15	1
25870	1537	40481087	2007-04-27	2007-05-18	1
27808	1642	4296205	1981-08-12	1981-08-26	1
76941	4562	78272	2011-10-06	2011-10-27	1
19535	1174	28060	1946-03-28	1946-04-05	1
88435	5262	81151	1978-04-10	1978-05-01	1
18490	1113	40481087	1977-02-23	1977-03-16	1
23448	1401	4112343	1991-01-14	1991-01-21	1
70224	4165	260139	1944-02-11	1944-02-18	1
15131	893	80180	1993-09-26	1993-09-27	1
77651	4604	40481087	2006-02-05	2006-02-19	1
81277	4826	4294548	1956-12-10	1957-01-21	1
54451	3227	4112343	1982-03-07	1982-03-15	1
24603	1468	4112343	2009-03-23	2009-04-02	1
76020	4514	40481087	2008-06-08	2008-06-29	1
52744	3125	40481087	2019-04-15	2019-05-06	1
77512	4596	257012	1958-04-23	1958-04-24	1
25669	1526	40481087	2011-11-06	2011-11-20	1
75113	4466	40481087	1981-01-02	1981-01-23	1
18998	1143	40481087	1989-05-16	1989-06-06	1
23958	1431	40481087	1969-03-26	1969-04-16	1
68457	4052	4112343	1977-02-11	1977-02-22	1
26659	1579	260139	2000-11-30	2000-12-07	1
70181	4160	4218389	2016-07-08	2016-08-12	1
17926	1079	4116491	2016-04-16	2016-05-21	1
70566	4191	80180	1996-10-25	1996-10-26	1
71521	4247	372328	1987-05-18	1988-02-27	1
62396	3691	40481087	1970-06-27	1970-07-11	1
73427	4370	260139	1968-08-30	1968-09-13	1
19719	1185	40481087	1980-10-22	1980-10-29	1
1666	97	4266809	1986-03-25	1986-03-26	1
690	38	40481087	2017-05-25	2017-06-08	1
14637	864	4218389	1997-08-03	1997-08-31	1
68175	4032	80180	1991-01-22	1991-01-23	1
25494	1518	40481087	1992-12-04	1992-12-11	1
81035	4812	4112343	1974-02-16	1974-02-27	1
50992	3022	40481087	1998-10-28	1998-11-11	1
76249	4527	40481087	1981-11-14	1981-11-21	1
83324	4957	260139	2009-09-30	2009-10-07	1
25094	1497	4112343	2014-08-10	2014-08-23	1
86737	5169	4283893	1980-08-17	1980-10-05	1
25030	1496	28060	1952-08-04	1952-08-17	1
22114	1322	378001	1980-01-01	1980-03-01	1
84636	5037	260139	2002-04-08	2002-04-15	1
15755	933	40481087	2009-10-17	2009-10-24	1
79161	4691	4112343	1968-05-08	1968-05-15	1
20491	1232	4112343	1983-05-27	1983-06-04	1
75578	4487	40481087	1994-06-27	1994-07-04	1
20669	1242	40481087	1992-07-06	1992-07-13	1
9120	539	4112343	1980-12-18	1980-12-31	1
87866	5232	4112343	1968-09-15	1968-09-23	1
86009	5123	260139	1985-03-28	1985-04-04	1
12018	711	4112343	2003-02-02	2003-02-11	1
17572	1057	4059173	1989-01-08	1989-02-07	1
56768	3371	40481087	1983-02-25	1983-03-11	1
88167	5249	4112343	2004-07-06	2004-07-13	1
25871	1537	260139	1956-08-13	1956-08-27	1
27809	1642	40481087	1977-08-09	1977-08-16	1
76942	4562	81151	1985-12-23	1986-01-20	1
19536	1174	4112343	1981-10-31	1981-11-09	1
88436	5262	4112343	2003-04-14	2003-04-22	1
18491	1113	40481087	2015-10-25	2015-11-01	1
23449	1401	40481087	2002-01-27	2002-02-17	1
70225	4165	260139	1960-10-22	1960-11-05	1
15132	893	192671	1993-11-09	1993-11-10	1
80827	4800	28060	1975-03-22	1975-03-29	1
81278	4826	40481087	1996-02-23	1996-03-15	1
54452	3227	4112343	2009-09-05	2009-09-18	1
24604	1468	4152936	1964-11-07	1964-11-28	1
79619	4722	4112343	1990-09-07	1990-09-20	1
55463	3289	260139	1989-06-07	1989-06-14	1
77513	4596	260139	1962-11-09	1962-11-16	1
25670	1526	40481087	2017-07-28	2017-08-11	1
75114	4466	40481087	2010-08-10	2010-08-31	1
18999	1143	40481087	2007-05-31	2007-06-07	1
23959	1431	40481087	1974-06-26	1974-07-17	1
68458	4052	4112343	1984-11-15	1984-11-26	1
26660	1579	4027663	1980-12-23	1980-12-24	1
70182	4160	40481087	1968-09-01	1968-09-22	1
17927	1079	4155034	1988-01-25	1988-02-15	1
70567	4191	317576	2010-09-03	2010-09-04	1
71522	4247	4112343	2000-12-01	2000-12-12	1
62397	3691	40481087	2007-02-04	2007-02-11	1
73428	4370	4112343	2010-07-25	2010-08-04	1
19720	1185	40481087	1987-03-18	1987-04-08	1
1667	97	4294548	1981-12-29	1982-02-23	1
691	38	80180	2006-05-20	2006-05-21	1
14638	864	40481087	1950-04-10	1950-04-24	1
68176	4032	260139	1987-02-19	1987-03-05	1
25495	1518	40481087	1997-11-07	1997-11-21	1
81036	4812	4112343	2006-06-17	2006-06-29	1
50993	3022	80180	2012-04-15	2012-04-16	1
77026	4569	260139	1968-11-03	1968-11-10	1
83325	4957	40481087	1990-02-24	1990-03-17	1
25095	1497	4218389	2000-07-26	2000-08-23	1
86738	5169	40481087	1969-04-04	1969-04-11	1
25031	1496	28060	1980-06-12	1980-06-24	1
22115	1322	4112343	1935-09-14	1935-09-25	1
84637	5037	372328	1977-11-13	1978-01-25	1
15756	933	81151	1975-04-14	1975-05-05	1
79162	4691	4134304	1978-12-29	1979-01-28	1
20492	1232	4134304	1971-10-09	1971-11-08	1
75579	4487	40481087	1995-03-07	1995-03-28	1
21452	1289	4059173	1997-05-25	1997-08-23	1
9121	539	4329847	1999-07-25	1999-07-26	1
87867	5232	40481087	1981-12-21	1982-01-04	1
86010	5123	4112343	2013-06-05	2013-06-17	1
12019	711	4112343	2008-01-20	2008-01-31	1
17573	1057	4285898	2003-05-31	2003-06-01	1
56769	3371	40481087	1998-01-20	1998-02-03	1
88168	5249	4152936	1966-05-25	1966-06-08	1
25872	1537	372328	1958-05-04	1958-10-22	1
27810	1642	40481087	1986-09-04	1986-09-11	1
76943	4562	260139	1978-04-09	1978-04-16	1
19537	1174	4116491	1967-01-06	1967-02-14	1
88437	5262	4285898	2009-12-14	2009-12-15	1
19956	1205	80180	2002-01-29	2002-01-30	1
23450	1401	40481087	2003-02-21	2003-02-28	1
70226	4165	321042	1991-01-27	1991-01-28	1
15133	893	195588	1981-09-14	1981-11-02	1
80828	4800	439777	1970-10-29	1970-10-30	1
81279	4826	40481087	2009-05-21	2009-06-11	1
54453	3227	40481087	2011-02-19	2011-03-05	1
24605	1468	4218389	1974-02-09	1974-03-09	1
79620	4722	4132546	1934-01-02	1934-01-03	1
55464	3289	260139	2007-04-04	2007-04-11	1
77514	4596	260139	1988-01-15	1988-01-29	1
26532	1574	80180	2000-12-11	2000-12-12	1
81182	4820	28060	1989-01-25	1989-02-07	1
19000	1143	80180	2015-04-07	2015-04-08	1
23960	1431	40481087	1975-07-20	1975-08-10	1
68459	4052	4113008	2007-01-01	2007-01-22	1
26661	1579	4156265	1959-08-06	1959-08-27	1
70183	4160	0	1965-11-25	1965-11-26	1
17928	1079	40481087	1999-12-28	2000-01-18	1
70568	4191	381316	2004-09-17	2004-09-18	1
71523	4247	4112343	2018-07-15	2018-07-27	1
62398	3691	40481087	2011-02-26	2011-03-19	1
73429	4370	4152936	1966-10-06	1966-10-27	1
19721	1185	80180	1978-08-06	1978-08-07	1
1668	97	40481087	1969-05-21	1969-06-11	1
692	38	260139	1966-08-05	1966-08-19	1
14639	864	40481087	1999-06-17	1999-07-01	1
68177	4032	260139	2002-11-03	2002-11-10	1
25496	1518	40481087	2014-08-14	2014-09-04	1
81037	4812	40481087	1973-02-11	1973-02-25	1
50994	3022	257012	1982-03-13	1982-03-14	1
77027	4569	4112343	1976-06-09	1976-06-18	1
84662	5041	80180	2013-10-04	2013-10-05	1
25096	1497	40481087	1969-11-05	1969-11-12	1
86739	5169	40481087	2016-08-08	2016-08-15	1
25032	1496	260139	1977-03-31	1977-04-14	1
22116	1322	4112343	1942-07-30	1942-08-12	1
84638	5037	28060	1992-05-01	1992-05-12	1
15757	933	372328	1974-03-20	1974-09-03	1
79163	4691	40481087	1991-05-24	1991-06-14	1
20493	1232	4283893	2014-01-15	2014-04-09	1
77441	4593	80180	2007-05-19	2007-05-20	1
21453	1289	40481087	1978-08-30	1978-09-06	1
9122	539	40481087	1953-11-12	1953-11-19	1
88620	5276	81151	1975-07-31	1975-08-21	1
86011	5123	81151	1984-01-02	1984-02-06	1
12020	711	4112343	2012-10-07	2012-10-18	1
17574	1057	40481087	1981-04-02	1981-04-16	1
56770	3371	260139	1999-08-11	1999-08-18	1
88169	5249	4283893	1954-10-08	1954-12-17	1
27951	1655	28060	1986-04-10	1986-04-18	1
27811	1642	40481087	2000-07-06	2000-07-27	1
76944	4562	4084167	1970-11-08	1970-11-08	1
19538	1174	4156265	2003-01-31	2003-02-21	1
88438	5262	40481087	1982-11-19	1982-12-03	1
19957	1205	260139	1975-07-20	1975-08-03	1
23451	1401	40481087	2008-05-09	2008-05-30	1
70227	4165	372328	1913-01-27	1913-03-30	1
15134	893	4112343	2004-03-20	2004-04-01	1
80829	4800	4112343	1997-08-20	1997-08-29	1
81280	4826	81151	1960-04-22	1960-05-06	1
54454	3227	40481087	2013-12-25	2014-01-15	1
24606	1468	40481087	1997-05-03	1997-05-17	1
79621	4722	4156265	1994-07-16	1994-07-30	1
55465	3289	372328	1958-10-27	1958-11-28	1
77515	4596	372328	2013-06-22	2014-04-20	1
26533	1574	4112343	2007-04-24	2007-05-06	1
81183	4820	260139	1982-12-05	1982-12-19	1
19001	1143	260139	1983-06-12	1983-06-19	1
23961	1431	40481087	1993-11-21	1993-11-28	1
68460	4052	4237458	1985-11-24	1985-12-24	1
26662	1579	4266809	1988-03-11	1988-03-12	1
70184	4160	4112343	2012-10-13	2012-10-21	1
17929	1079	40481087	2014-12-31	2015-01-21	1
70569	4191	4283893	1959-04-07	1959-05-19	1
71524	4247	4218389	1991-08-04	1991-08-25	1
62399	3691	260139	1969-07-26	1969-08-02	1
73430	4370	375671	2019-02-28	2019-03-30	1
19722	1185	4112343	1941-01-10	1941-01-22	1
1669	97	78272	2002-07-08	2002-07-29	1
693	38	372328	1966-10-02	1967-02-14	1
17023	1018	372328	1972-02-05	1972-03-20	1
68178	4032	375671	1979-09-11	1979-11-10	1
25497	1518	78272	1959-02-23	1959-03-09	1
81038	4812	372328	1956-12-13	1957-03-20	1
50995	3022	4112343	1990-05-20	1990-05-27	1
77028	4569	80180	2002-08-01	2002-08-02	1
84663	5041	81151	1994-08-20	1994-09-24	1
25097	1497	40481087	2009-08-10	2009-08-17	1
86740	5169	80180	1996-07-05	1996-07-06	1
25033	1496	4112343	1923-12-01	1923-12-09	1
22117	1322	4294548	1965-02-02	1965-03-16	1
84639	5037	81151	2012-09-01	2012-09-15	1
15758	933	4152936	1983-10-11	1983-11-01	1
79164	4691	80180	2002-01-12	2002-01-13	1
20494	1232	40481087	1980-05-14	1980-05-21	1
77442	4593	378001	2000-09-16	2000-10-16	1
21454	1289	40481087	2004-07-11	2004-08-01	1
9123	539	40481087	1954-11-20	1954-11-27	1
88621	5276	260139	1962-06-13	1962-06-27	1
86012	5123	4112343	1989-12-05	1989-12-13	1
12021	711	40481087	1970-04-06	1970-04-27	1
17575	1057	40481087	1982-07-15	1982-07-29	1
56771	3371	372328	1977-10-17	1978-01-20	1
88170	5249	4283893	1984-12-21	1985-01-04	1
27952	1655	260139	1989-08-28	1989-09-11	1
27812	1642	40481087	2004-01-13	2004-02-03	1
76945	4562	4112343	1963-08-20	1963-08-31	1
19539	1174	40481087	1968-11-07	1968-11-14	1
88439	5262	40481087	1993-03-15	1993-03-29	1
19958	1205	4112343	2001-07-27	2001-08-03	1
23452	1401	372328	1978-01-02	1979-01-14	1
70228	4165	381316	1980-04-06	1980-04-07	1
15135	893	4218389	1996-01-30	1996-02-20	1
80830	4800	40481087	1987-11-08	1987-11-29	1
81281	4826	4112343	1968-05-14	1968-05-27	1
54455	3227	40481087	2017-11-30	2017-12-21	1
24813	1482	257012	1983-09-03	1983-09-04	1
79622	4722	40481087	1941-03-02	1941-03-23	1
55466	3289	4027663	1983-12-16	1983-12-17	1
77516	4596	4112343	1939-03-24	1939-04-03	1
26534	1574	4237458	1967-04-19	1967-07-18	1
81184	4820	4109685	1966-01-28	1966-02-18	1
19002	1143	260139	1999-07-18	1999-08-01	1
23962	1431	372328	1954-07-28	1954-09-11	1
68461	4052	4266809	2015-09-18	2015-09-19	1
26663	1579	40481087	1989-06-20	1989-06-27	1
70185	4160	40481087	1963-10-07	1963-10-21	1
17930	1079	372328	1964-01-03	1964-02-23	1
70570	4191	40481087	1975-11-26	1975-12-10	1
71525	4247	4296205	2013-08-20	2013-09-10	1
62400	3691	372328	1957-05-29	1957-07-19	1
73431	4370	4112343	1968-04-04	1968-04-16	1
19723	1185	4112343	1957-07-12	1957-07-24	1
1670	97	81151	1992-09-04	1992-10-09	1
694	38	4112343	1967-10-01	1967-10-11	1
17024	1018	40481087	1996-02-01	1996-02-22	1
68179	4032	4152936	2010-12-23	2011-01-13	1
25498	1518	260139	1997-12-24	1997-12-31	1
81039	4812	4112343	1965-01-24	1965-02-02	1
50996	3022	40481087	1994-09-04	1994-09-11	1
77029	4569	260139	1963-04-19	1963-04-26	1
84664	5041	257012	1981-10-13	1981-12-01	1
26017	1545	80180	2006-05-16	2006-05-17	1
86741	5169	260139	1997-01-20	1997-02-03	1
25034	1496	4112343	1947-04-11	1947-04-21	1
22118	1322	40481087	1960-04-30	1960-05-21	1
84640	5037	372328	1982-05-04	1983-02-02	1
15759	933	372328	1977-08-18	1977-09-01	1
79165	4691	4278672	1969-05-20	1969-08-18	1
21368	1283	78272	2010-07-26	2010-08-16	1
77443	4593	4112343	2002-08-03	2002-08-15	1
21455	1289	40481087	2005-09-02	2005-09-23	1
9124	539	40481087	1982-05-31	1982-06-07	1
88622	5276	260139	1969-12-24	1969-12-31	1
86013	5123	4142905	1994-09-11	1994-12-10	1
12022	711	40481087	1976-10-29	1976-11-12	1
17576	1057	80180	2003-11-27	2003-11-28	1
56772	3371	372328	1981-04-21	1981-07-31	1
88171	5249	4294548	2015-04-10	2015-06-19	1
27953	1655	4112343	1981-08-03	1981-08-14	1
27813	1642	260139	1951-06-22	1951-07-06	1
76946	4562	4156265	1966-07-01	1966-07-15	1
19540	1174	40481087	1970-09-15	1970-10-06	1
88440	5262	28060	2005-06-11	2005-06-19	1
19959	1205	40481087	1961-05-19	1961-06-02	1
23453	1401	4027663	1999-01-22	1999-01-23	1
70229	4165	4152936	1983-09-10	1983-09-24	1
15136	893	40481087	1987-10-28	1987-11-11	1
80831	4800	40481087	1995-09-13	1995-10-04	1
81282	4826	4134304	1967-11-26	1967-12-26	1
62572	3700	260139	1973-12-23	1974-01-06	1
24814	1482	261325	2005-11-19	2005-11-20	1
79623	4722	40481087	1943-12-13	1943-12-27	1
55467	3289	4310024	1993-01-12	1993-01-13	1
77517	4596	4112343	1941-01-25	1941-02-03	1
26535	1574	4283893	1972-06-18	1972-12-17	1
81185	4820	28060	1961-05-30	1961-06-06	1
19003	1143	375671	2004-07-08	2004-08-07	1
23963	1431	4152936	1956-01-28	1956-02-18	1
68462	4052	4310024	2012-10-03	2012-10-04	1
26664	1579	40481087	1993-08-11	1993-08-25	1
70186	4160	40481087	1970-03-23	1970-03-30	1
17931	1079	4112343	1962-07-16	1962-07-26	1
70571	4191	4112343	1962-03-21	1962-03-29	1
71526	4247	40481087	2018-10-16	2018-10-30	1
62401	3691	378001	1970-11-20	1970-12-20	1
73432	4370	4146173	1991-11-15	1992-01-21	1
19724	1185	4112343	2015-01-24	2015-02-06	1
1671	97	140673	2008-07-02	2008-07-03	1
695	38	40481087	2018-01-09	2018-01-23	1
17025	1018	40481087	1997-09-22	1997-09-29	1
68180	4032	4294548	1950-01-09	1950-03-27	1
25499	1518	378001	2016-10-01	2016-11-30	1
81040	4812	4134304	1972-03-08	1972-06-06	1
52238	3096	313217	2011-10-02	2011-10-03	1
77030	4569	260139	1999-02-02	1999-02-16	1
84665	5041	378001	2018-04-21	2018-06-20	1
26018	1545	260139	1996-09-12	1996-09-19	1
86742	5169	40481087	1956-09-18	1956-10-02	1
25035	1496	4296204	1933-05-10	1933-06-14	1
22119	1322	40481087	1967-01-13	1967-01-27	1
84641	5037	4112343	1982-10-22	1982-11-02	1
15760	933	4001336	2000-05-31	2000-06-30	1
79166	4691	4283893	1963-04-27	1963-08-03	1
21369	1283	198809	1972-04-22	1972-04-22	1
77444	4593	4294548	1992-05-06	1992-05-27	1
21456	1289	28060	1973-12-14	1973-12-23	1
9125	539	40481087	1990-12-19	1991-01-02	1
88623	5276	440448	2011-01-07	2011-01-08	1
86014	5123	40481087	1993-05-21	1993-05-28	1
12023	711	80180	1991-06-30	1991-07-01	1
17577	1057	81151	1991-10-25	1991-11-15	1
56773	3371	4112343	1990-01-17	1990-01-29	1
88172	5249	40481087	1980-02-24	1980-03-16	1
27954	1655	40481087	2016-03-31	2016-04-14	1
27814	1642	372328	1951-11-18	1952-02-05	1
79661	4724	80180	1977-12-14	1977-12-15	1
19541	1174	40481087	1996-09-05	1996-09-19	1
88441	5262	28060	2008-07-05	2008-07-17	1
19960	1205	40481087	2009-12-10	2009-12-17	1
23454	1401	4285898	2006-09-07	2006-09-08	1
70230	4165	4237458	1990-08-18	1990-11-16	1
15137	893	4283893	1995-03-25	1995-04-15	1
80832	4800	40481087	2007-10-09	2007-10-30	1
81283	4826	4296205	2019-05-18	2019-06-22	1
62573	3700	372328	1978-08-04	1978-09-20	1
24815	1482	4027663	2006-10-11	2006-10-12	1
79624	4722	257012	1945-10-15	1945-10-16	1
55468	3289	40481087	1986-11-26	1986-12-17	1
77518	4596	4155034	1983-12-07	1983-12-28	1
26536	1574	40481087	1968-10-17	1968-10-31	1
81186	4820	192671	1995-10-24	1995-10-25	1
19004	1143	4112343	1974-05-16	1974-05-24	1
23964	1431	40481087	1966-02-26	1966-03-05	1
68463	4052	81151	1999-06-28	1999-07-12	1
26665	1579	40481087	2017-03-31	2017-04-14	1
70187	4160	40481087	2000-10-07	2000-10-14	1
17932	1079	40481087	1997-09-27	1997-10-04	1
70572	4191	4116491	2010-08-03	2010-09-18	1
71527	4247	372328	1983-05-18	1983-06-25	1
62402	3691	4134304	2011-06-23	2011-09-21	1
73433	4370	40481087	1988-11-11	1988-12-02	1
19725	1185	40480160	2008-02-11	2008-04-11	1
1672	97	258780	1980-07-28	1980-07-29	1
1353	80	28060	1950-03-20	1950-03-29	1
17026	1018	80180	2012-02-20	2012-02-21	1
68181	4032	4296204	2001-10-20	2001-11-10	1
25500	1518	4027663	1986-07-02	1986-07-03	1
81041	4812	4218389	1967-03-09	1967-04-06	1
52239	3096	372328	1968-08-12	1968-12-01	1
77031	4569	372328	1964-12-08	1964-12-29	1
84666	5041	4112343	1981-08-22	1981-08-29	1
26019	1545	378001	1997-10-03	1997-12-02	1
86743	5169	4112343	1969-09-09	1969-09-19	1
25036	1496	4296205	1970-11-23	1970-12-14	1
22120	1322	40481087	1995-12-06	1995-12-13	1
84642	5037	4112343	2015-12-24	2016-01-06	1
15761	933	81151	1986-11-15	1986-12-13	1
79167	4691	4294548	1977-02-18	1977-03-11	1
21370	1283	372328	1960-12-05	1961-02-20	1
77445	4593	40481087	1985-01-16	1985-02-06	1
21457	1289	257012	1966-07-30	1966-07-31	1
9126	539	192671	1969-01-18	1969-01-19	1
88624	5276	4112343	1972-03-21	1972-04-01	1
86015	5123	40481087	2002-04-19	2002-04-26	1
12024	711	81151	1983-06-09	1983-07-07	1
17578	1057	260139	1985-09-01	1985-09-15	1
56774	3371	40481087	1996-05-09	1996-05-23	1
88173	5249	40481087	2007-01-07	2007-01-14	1
27955	1655	260139	1990-11-03	1990-11-10	1
27815	1642	80180	1990-09-24	1990-09-25	1
79662	4724	133834	1942-03-10	1942-03-11	1
19542	1174	81151	1957-09-02	1957-09-23	1
88442	5262	260139	1983-12-27	1984-01-10	1
19961	1205	40481087	2017-09-11	2017-10-02	1
23455	1401	4310024	2004-09-17	2004-09-18	1
70231	4165	4278672	1981-10-20	1981-12-19	1
15138	893	4296204	1967-01-11	1967-02-01	1
80833	4800	28060	1970-12-29	1971-01-09	1
81284	4826	40481087	1970-07-15	1970-08-05	1
62574	3700	378001	1991-09-10	1991-10-10	1
24816	1482	81893	2016-04-01	2016-04-02	1
79625	4722	260139	1938-12-11	1938-12-18	1
55469	3289	81893	1993-08-10	1993-08-11	1
77519	4596	4156265	1954-07-30	1954-08-20	1
26537	1574	28060	1970-03-25	1970-04-07	1
81187	4820	4059173	1967-02-13	1967-05-14	1
19005	1143	4112343	2004-05-19	2004-05-26	1
25186	1505	260139	1978-03-25	1978-04-01	1
68464	4052	260139	1990-07-02	1990-07-09	1
26666	1579	260139	1974-08-18	1974-09-01	1
70188	4160	81151	1969-02-28	1969-04-04	1
19872	1197	28060	1981-12-17	1981-12-27	1
70573	4191	260139	1999-08-15	1999-08-29	1
71528	4247	372328	1985-10-12	1986-02-22	1
62403	3691	4146173	1967-02-09	1967-03-11	1
73434	4370	81151	1964-09-18	1964-10-16	1
19726	1185	40481087	1988-01-12	1988-01-26	1
1673	97	378419	2015-08-10	2015-08-11	1
1354	80	28060	1951-03-25	1951-04-06	1
17027	1018	260139	1987-04-18	1987-05-02	1
68182	4032	40481087	1958-06-19	1958-06-26	1
25501	1518	28060	1955-07-03	1955-07-11	1
81042	4812	4283893	1966-03-22	1966-04-12	1
52240	3096	4059173	1979-08-30	1979-11-28	1
77032	4569	378001	1973-04-25	1973-06-24	1
84667	5041	4112343	1994-03-19	1994-03-27	1
26020	1545	4027663	1995-11-30	1995-12-01	1
86744	5169	4112343	2005-07-14	2005-07-24	1
25037	1496	40481087	1988-08-06	1988-08-27	1
22121	1322	40481087	2005-06-02	2005-06-23	1
85405	5083	28060	1973-12-14	1973-12-24	1
20907	1257	80180	2010-03-08	2010-03-09	1
79168	4691	40481087	1973-11-15	1973-11-29	1
21371	1283	4094814	1971-06-23	1971-08-22	1
77446	4593	40481087	2001-02-04	2001-02-18	1
21458	1289	372328	1962-11-08	1963-02-19	1
9127	539	4112343	1989-07-18	1989-07-26	1
88625	5276	4112343	1999-11-21	1999-12-04	1
86016	5123	28060	1990-03-14	1990-03-26	1
12025	711	81151	2002-03-29	2002-04-26	1
17579	1057	4218389	2002-05-21	2002-06-18	1
56775	3371	28060	1988-12-11	1988-12-21	1
27956	1655	4112343	1984-06-02	1984-06-15	1
27816	1642	257012	1966-07-14	1966-07-15	1
79663	4724	260139	1993-05-14	1993-05-21	1
19543	1174	260139	1951-09-15	1951-09-22	1
88443	5262	260139	2012-08-23	2012-09-06	1
19962	1205	28060	1963-04-07	1963-04-17	1
23456	1401	40481087	1986-03-04	1986-03-11	1
70232	4165	40481087	1945-12-30	1946-01-13	1
15139	893	40481087	1959-10-24	1959-11-14	1
80834	4800	30753	2007-12-14	2007-12-15	1
81285	4826	40481087	1997-08-16	1997-08-23	1
62575	3700	4112343	1983-09-04	1983-09-14	1
24817	1482	260139	1986-09-17	1986-09-24	1
79626	4722	4001336	1934-01-02	1934-03-03	1
55470	3289	260139	1986-10-13	1986-10-20	1
77520	4596	4294548	1979-08-27	1980-01-07	1
26538	1574	260139	2017-09-26	2017-10-10	1
81188	4820	4112343	1974-03-30	1974-04-12	1
19006	1143	40481087	1996-06-11	1996-06-18	1
25187	1505	260139	1983-12-02	1983-12-09	1
68465	4052	260139	1995-01-15	1995-01-22	1
26667	1579	317576	2017-02-23	2017-02-24	1
70189	4160	260139	1964-03-28	1964-04-11	1
19873	1197	260139	1997-11-04	1997-11-11	1
70574	4191	321042	2013-07-26	2013-07-27	1
71529	4247	378001	2008-06-17	2008-08-16	1
62404	3691	40481087	1971-06-15	1971-06-22	1
73435	4370	260139	1969-06-27	1969-07-11	1
20611	1239	28060	1983-06-03	1983-06-12	1
1674	97	4112343	1945-07-22	1945-08-01	1
1355	80	81151	1953-12-31	1954-01-14	1
17028	1018	40481087	1975-12-22	1976-01-12	1
68183	4032	40481087	1998-01-31	1998-02-21	1
25502	1518	260139	2010-04-29	2010-05-06	1
81043	4812	40481087	1978-12-04	1978-12-11	1
52241	3096	4278672	1968-09-26	1968-12-25	1
77033	4569	378001	1996-09-21	1996-11-20	1
84668	5041	4283893	1981-09-15	1981-12-01	1
26021	1545	78272	1992-12-30	1993-01-27	1
86745	5169	4152936	1954-06-26	1954-07-17	1
25038	1496	81151	1949-07-11	1949-08-15	1
22122	1322	40481087	2005-09-30	2005-10-07	1
85406	5083	257012	1975-07-20	1975-09-07	1
20908	1257	260139	1980-10-20	1980-10-27	1
79169	4691	28060	1967-04-03	1967-04-12	1
21372	1283	4112343	1959-09-13	1959-09-23	1
77447	4593	81151	1971-05-03	1971-05-31	1
21459	1289	4112343	2006-12-23	2006-12-31	1
9128	539	4113008	1971-04-04	1971-04-18	1
88626	5276	4112343	2010-02-27	2010-03-08	1
86017	5123	4237458	2004-04-21	2004-05-21	1
12026	711	196456	1967-01-29	1967-01-29	1
17580	1057	4283893	2016-03-01	2016-06-07	1
56776	3371	81151	1985-09-19	1985-10-10	1
27957	1655	40481087	1987-04-07	1987-04-21	1
27817	1642	381316	2008-06-17	2008-06-18	1
79664	4724	439777	1941-05-07	1941-05-08	1
19544	1174	372328	1944-04-17	1944-12-24	1
88444	5262	4113008	2007-01-29	2007-02-19	1
19963	1205	260139	2016-10-06	2016-10-13	1
23457	1401	40481087	2001-08-09	2001-08-23	1
70233	4165	40481087	1982-01-01	1982-01-22	1
15140	893	40481087	2018-02-11	2018-03-04	1
80835	4800	81893	2007-08-17	2007-08-18	1
82094	4873	28060	2009-09-07	2009-09-17	1
62576	3700	4112343	2000-09-29	2000-10-06	1
24818	1482	372328	1975-01-17	1975-03-29	1
79627	4722	4134304	1984-04-09	1984-05-09	1
55471	3289	372328	1960-10-18	1960-12-02	1
77521	4596	40481087	1954-07-02	1954-07-23	1
26539	1574	375671	1961-08-18	1961-10-17	1
81189	4820	40481087	1977-08-23	1977-09-06	1
19007	1143	81151	1980-11-20	1980-12-11	1
25188	1505	372328	1959-05-22	1959-08-22	1
68466	4052	260139	2004-02-26	2004-03-04	1
28878	1713	28060	1999-07-09	1999-07-17	1
70190	4160	260139	1991-05-14	1991-05-21	1
19874	1197	4112343	2012-06-04	2012-06-12	1
70575	4191	4112343	1981-10-03	1981-10-16	1
71530	4247	440086	1995-03-16	2001-03-22	1
62405	3691	40481087	1987-11-03	1987-11-24	1
73436	4370	260139	1993-05-17	1993-05-24	1
20612	1239	78272	1991-09-24	1991-10-08	1
1675	97	4112343	1963-04-13	1963-04-20	1
1356	80	81151	1988-09-12	1988-10-17	1
17029	1018	40481087	2018-06-20	2018-07-04	1
68184	4032	40481087	2005-06-22	2005-07-13	1
25503	1518	378001	1984-05-01	1984-05-31	1
81044	4812	40481087	1997-08-04	1997-08-18	1
52242	3096	40481087	1970-02-27	1970-03-06	1
77034	4569	4112343	1996-07-07	1996-07-19	1
84669	5041	40481087	1971-04-02	1971-04-09	1
26022	1545	257012	1979-01-07	1979-01-08	1
87070	5191	81151	1973-10-03	1973-11-07	1
25039	1496	255848	1998-05-02	1998-05-03	1
22123	1322	260139	1940-07-18	1940-07-25	1
85407	5083	260139	1970-04-21	1970-05-05	1
20909	1257	372328	1977-04-05	1978-03-04	1
79170	4691	28060	1969-10-09	1969-10-20	1
21373	1283	4112343	2012-07-20	2012-07-29	1
77448	4593	260139	1984-06-09	1984-06-23	1
21460	1289	4156265	1963-02-06	1963-02-27	1
9129	539	40481087	1984-02-02	1984-02-16	1
88627	5276	4294548	1973-12-01	1973-12-22	1
137	6	4029498	2003-12-21	2003-12-22	1
12027	711	198809	1967-01-29	1967-01-29	1
17581	1057	4310024	2001-09-08	2001-09-09	1
56777	3371	4112343	2000-09-07	2000-09-17	1
27958	1655	40481087	1994-04-22	1994-05-06	1
27818	1642	4283893	1966-05-12	1966-08-11	1
79665	4724	4278672	2003-09-14	2003-12-13	1
19545	1174	4112343	2013-06-08	2013-06-20	1
88445	5262	4152936	1973-08-20	1973-09-03	1
19964	1205	372328	1961-03-15	1961-03-29	1
23458	1401	40481087	2011-01-20	2011-02-03	1
70234	4165	40481087	1983-06-25	1983-07-16	1
15141	893	260139	2001-01-22	2001-01-29	1
80836	4800	260139	1973-06-17	1973-07-01	1
82095	4873	260139	2004-09-18	2004-10-02	1
62577	3700	4283893	1975-06-06	1975-07-11	1
24819	1482	378001	1982-03-11	1982-04-10	1
79628	4722	4218389	1914-02-18	1914-03-11	1
55472	3289	4112343	1993-10-02	1993-10-14	1
77522	4596	30753	1977-08-05	1977-08-06	1
26540	1574	375671	2016-09-01	2016-10-01	1
81190	4820	80180	1995-10-07	1995-10-08	1
19008	1143	260139	1990-04-24	1990-05-08	1
25189	1505	372328	1974-09-02	1976-05-22	1
68467	4052	372328	1978-06-04	1978-09-21	1
28879	1713	28060	2010-10-20	2010-10-29	1
70191	4160	260139	2004-05-13	2004-05-27	1
19875	1197	4112343	2016-04-26	2016-05-06	1
70576	4191	4112343	1986-12-21	1986-12-31	1
71531	4247	40481087	1989-01-22	1989-02-12	1
62406	3691	80180	1991-01-16	1991-01-17	1
73437	4370	40481087	1988-05-23	1988-06-06	1
20613	1239	257012	1987-10-05	1987-10-06	1
1676	97	4156265	1996-09-16	1996-10-07	1
1357	80	4112343	1975-12-30	1976-01-12	1
17030	1018	260139	1998-03-06	1998-03-20	1
68185	4032	260139	1979-01-31	1979-02-07	1
25504	1518	4112343	1994-03-12	1994-03-24	1
81045	4812	40481087	2011-10-12	2011-11-02	1
52243	3096	40481087	1987-10-12	1987-10-19	1
77035	4569	4296205	1997-10-16	1997-11-20	1
84670	5041	40481087	1978-02-06	1978-02-27	1
26023	1545	4278672	2000-12-16	2001-02-14	1
87071	5191	195588	2018-08-08	2018-09-13	1
25040	1496	372328	1925-11-07	1926-07-18	1
22124	1322	4112343	1954-08-08	1954-08-15	1
85408	5083	4027663	1975-11-10	1975-11-11	1
20910	1257	375671	1983-10-01	1983-11-30	1
79171	4691	257012	1963-05-25	1963-05-26	1
21374	1283	81151	1989-01-19	1989-02-02	1
77449	4593	378001	2017-09-17	2017-10-17	1
21461	1289	4283893	1966-06-25	1966-11-26	1
9130	539	0	1933-03-26	1933-03-27	1
88628	5276	40481087	1967-04-07	1967-04-28	1
138	6	40481087	1976-11-20	1976-12-04	1
12028	711	260139	1985-10-30	1985-11-06	1
17582	1057	40481087	1968-10-18	1968-11-01	1
56778	3371	4112343	2006-08-18	2006-08-26	1
27959	1655	40481087	2006-09-30	2006-10-14	1
27819	1642	4294548	2017-03-04	2017-07-08	1
79666	4724	4294548	1974-05-31	1975-01-03	1
19546	1174	4155034	1941-11-03	1941-11-24	1
88446	5262	4266809	2010-04-13	2010-04-14	1
19965	1205	4116491	1981-10-16	1981-12-03	1
23459	1401	40481087	2016-04-14	2016-04-28	1
70235	4165	28060	1922-02-24	1922-03-09	1
15142	893	4112343	1964-08-26	1964-09-04	1
80837	4800	260139	2007-11-14	2007-11-21	1
82096	4873	372328	1978-10-16	1978-12-22	1
62578	3700	4283893	2011-07-18	2011-09-26	1
24820	1482	378001	1995-09-20	1995-11-19	1
79629	4722	4278672	1918-04-19	1918-05-19	1
55473	3289	4218389	1961-06-24	1961-07-15	1
77523	4596	78272	2016-01-09	2016-02-06	1
26541	1574	378001	1974-06-09	1974-08-08	1
81191	4820	81151	1956-11-20	1956-12-04	1
19009	1143	260139	2012-12-02	2012-12-16	1
25190	1505	4112343	1980-05-03	1980-05-10	1
68468	4052	372328	1985-07-20	1986-02-20	1
28880	1713	28060	2013-05-19	2013-05-27	1
70192	4160	378001	1972-11-14	1972-12-14	1
19876	1197	4283893	2004-12-13	2005-03-21	1
70577	4191	4112343	2012-09-05	2012-09-12	1
71532	4247	260139	2002-04-30	2002-05-07	1
62407	3691	81151	1959-07-02	1959-07-16	1
73438	4370	40481087	2002-03-29	2002-04-19	1
20614	1239	4112343	1982-04-26	1982-05-05	1
1677	97	40481087	1950-04-20	1950-05-04	1
1358	80	80180	1974-09-16	1974-09-17	1
17031	1018	4112343	2018-01-14	2018-01-27	1
68186	4032	313217	2010-07-20	2010-07-21	1
25505	1518	4152936	1957-03-21	1957-04-04	1
81046	4812	28060	1964-02-17	1964-02-26	1
52244	3096	40481087	2003-04-26	2003-05-17	1
77036	4569	4294548	1989-08-23	1989-09-13	1
84671	5041	40481087	2012-03-02	2012-03-23	1
26024	1545	4294548	1978-11-19	1979-02-04	1
87072	5191	378001	2015-05-06	2015-07-05	1
25041	1496	40481087	1966-08-05	1966-08-26	1
22125	1322	4278672	1928-02-21	1928-03-22	1
85409	5083	4112343	1993-09-23	1993-10-03	1
20911	1257	440448	1976-10-28	1976-10-29	1
79172	4691	4112343	1980-05-14	1980-05-26	1
21375	1283	196456	1972-04-22	1972-04-22	1
77450	4593	4294548	2018-04-23	2018-05-28	1
21462	1289	40481087	1981-10-28	1981-11-11	1
9131	539	0	1972-01-02	1972-01-03	1
88629	5276	40481087	1995-07-26	1995-08-09	1
139	6	0	2003-12-21	2003-12-22	1
12029	711	4112343	1959-10-19	1959-10-28	1
17583	1057	30753	2002-08-04	2002-08-05	1
56779	3371	4278672	1982-12-06	1983-01-05	1
27960	1655	80180	2005-10-12	2005-10-13	1
28235	1670	260139	1989-01-03	1989-01-17	1
79667	4724	40481087	1963-04-01	1963-04-22	1
19547	1174	40479422	1963-02-23	1963-05-02	1
88447	5262	4294548	2003-06-06	2003-06-27	1
19966	1205	4142905	1976-07-22	1976-08-21	1
27107	1605	0	2019-05-12	2019-05-13	1
70236	4165	80180	1950-06-28	1950-06-29	1
15143	893	4112343	1971-06-04	1971-06-11	1
80838	4800	4027663	1997-10-23	1997-10-24	1
82097	4873	4027663	2010-07-08	2010-07-09	1
62579	3700	40481087	2007-06-12	2007-07-03	1
24821	1482	4084167	1981-12-11	1981-12-11	1
79630	4722	40481087	2001-10-04	2001-10-11	1
55474	3289	40481087	2004-01-25	2004-02-01	1
77524	4596	80180	1979-01-27	1979-01-28	1
26542	1574	4218389	1972-05-22	1972-06-19	1
81192	4820	4112343	1968-04-18	1968-04-26	1
19010	1143	4112343	1978-06-20	1978-07-02	1
25191	1505	4283893	2014-01-17	2014-03-07	1
68469	4052	4294548	2013-06-24	2013-07-29	1
28881	1713	80180	2010-05-14	2010-05-15	1
70193	4160	4152936	2011-11-18	2011-12-02	1
19877	1197	40481087	1999-08-20	1999-09-03	1
70578	4191	40481087	1958-11-17	1958-12-01	1
71533	4247	260139	2006-12-08	2006-12-22	1
62408	3691	4296204	1964-03-21	1964-04-25	1
73439	4370	80180	1999-03-24	1999-03-25	1
20615	1239	40481087	1982-03-07	1982-03-14	1
1678	97	40481087	1952-12-28	1953-01-11	1
1359	80	81151	2018-03-14	2018-04-11	1
17032	1018	4278672	1982-11-09	1983-01-08	1
68187	4032	4112343	1975-03-20	1975-03-30	1
25506	1518	4285898	1998-02-14	1998-02-15	1
81047	4812	28060	1986-07-26	1986-08-06	1
52245	3096	40481087	2013-05-13	2013-05-27	1
77037	4569	40481087	1971-01-14	1971-01-21	1
84672	5041	260139	2007-02-14	2007-02-28	1
26025	1545	40481087	2013-05-13	2013-05-27	1
87073	5191	4112343	1977-01-19	1977-01-26	1
25042	1496	28060	1948-08-17	1948-08-24	1
22126	1322	40481087	1926-10-07	1926-10-14	1
85410	5083	4266809	1984-01-27	1984-01-28	1
20912	1257	40481087	1977-09-09	1977-09-16	1
79173	4691	40481087	2015-08-14	2015-09-04	1
21376	1283	4112343	1994-11-12	1994-11-20	1
77451	4593	40481087	1996-10-08	1996-10-22	1
21463	1289	81151	2015-09-30	2015-10-28	1
9132	539	0	1999-07-25	1999-07-26	1
88630	5276	40481087	2001-02-05	2001-02-19	1
140	6	372328	1965-06-23	1965-12-07	1
12030	711	40481087	1959-05-18	1959-06-01	1
17584	1057	257012	2016-04-19	2016-04-20	1
56780	3371	40481087	1975-11-22	1975-11-29	1
27961	1655	317009	2004-09-29	2004-09-30	1
28236	1670	260139	2002-12-24	2002-12-31	1
79668	4724	40481087	1977-03-31	1977-04-14	1
19548	1174	40481087	1952-06-15	1952-06-29	1
88448	5262	4310024	2008-01-24	2008-01-25	1
19967	1205	40481087	1990-04-08	1990-04-15	1
27108	1605	80180	1971-08-09	1971-08-10	1
70237	4165	260139	1932-01-15	1932-01-29	1
15144	893	4294548	1976-03-20	1976-06-19	1
80839	4800	4155034	1983-02-07	1983-02-28	1
82098	4873	4112343	2017-11-16	2017-11-25	1
62580	3700	257012	1975-07-04	2011-09-26	1
24822	1482	4112343	2011-06-08	2011-06-17	1
79631	4722	260139	1946-04-17	1946-04-24	1
55475	3289	80180	1995-09-29	1995-09-30	1
77525	4596	260139	1978-11-24	1978-12-08	1
26543	1574	40481087	2007-09-08	2007-09-29	1
81193	4820	4112343	1996-01-03	1996-01-12	1
19011	1143	4112343	1982-12-11	1982-12-23	1
25192	1505	40481087	1978-06-21	1978-06-28	1
68470	4052	40481087	1986-02-15	1986-02-22	1
28882	1713	260139	1999-01-14	1999-01-28	1
70194	4160	40481087	2002-09-11	2002-10-02	1
19878	1197	81151	1987-01-18	1987-02-08	1
71957	4275	30753	2016-11-24	2016-11-25	1
71534	4247	4112343	2019-03-28	2019-04-05	1
62409	3691	40481087	2003-08-27	2003-09-17	1
73440	4370	4112343	1977-04-02	1977-04-15	1
20616	1239	372328	1972-11-11	1972-11-25	1
1679	97	40481087	1980-10-16	1980-10-30	1
1360	80	81893	1972-09-26	1972-09-27	1
17033	1018	4112343	1989-10-05	1989-10-12	1
68188	4032	4113008	1953-04-16	1953-04-30	1
25507	1518	40481087	1963-09-22	1963-09-29	1
81048	4812	28060	1997-05-27	1997-06-06	1
52246	3096	260139	1997-08-27	1997-09-03	1
77038	4569	40481087	2008-12-11	2009-01-01	1
84673	5041	372328	1971-04-23	1971-08-03	1
26026	1545	81151	2013-06-25	2013-07-23	1
87074	5191	4112343	1990-10-29	1990-11-09	1
25043	1496	4112343	1961-12-30	1962-01-06	1
22127	1322	40481087	1933-04-16	1933-05-07	1
85411	5083	4283893	1975-06-15	1975-09-07	1
20913	1257	4112343	1973-05-29	1973-06-10	1
79174	4691	260139	2006-03-09	2006-03-16	1
21377	1283	80180	1998-06-24	1998-06-25	1
77452	4593	28060	1975-09-11	1975-09-21	1
21464	1289	372328	1965-04-17	1965-08-17	1
9133	539	260139	1950-11-24	1950-12-08	1
88631	5276	40481087	2011-06-05	2011-06-26	1
141	6	372328	1969-12-20	1970-12-22	1
12031	711	40481087	1987-08-26	1987-09-16	1
17585	1057	260139	1963-02-11	1963-02-25	1
56781	3371	40481087	1977-12-25	1978-01-15	1
27962	1655	4112343	1973-05-25	1973-06-01	1
28237	1670	4112343	1998-01-15	1998-01-26	1
79669	4724	40481087	1998-03-30	1998-04-20	1
26102	1551	317576	2018-03-12	2018-03-13	1
88449	5262	40481087	1994-04-27	1994-05-18	1
19968	1205	40481087	2016-08-17	2016-09-07	1
27109	1605	317576	2017-10-22	2017-10-23	1
70238	4165	4112343	1960-02-27	1960-03-05	1
15145	893	40481087	1958-10-01	1958-10-22	1
80840	4800	4285898	2008-08-11	2008-08-12	1
82099	4873	4285898	2018-04-27	2018-04-28	1
62581	3700	372328	1971-04-02	1971-08-11	1
24823	1482	4283893	1983-07-09	1983-10-01	1
79632	4722	260139	1967-02-05	1967-02-12	1
55476	3289	260139	1991-06-05	1991-06-12	1
77526	4596	4296205	1951-10-16	1951-11-13	1
26544	1574	257012	1972-07-09	1972-07-10	1
81194	4820	4112343	2010-07-30	2010-08-07	1
19012	1143	4112343	2004-01-05	2004-01-16	1
25193	1505	80180	1992-04-13	1992-04-14	1
73884	4393	260139	1995-10-20	1995-10-27	1
28883	1713	4027663	1998-09-29	1998-09-30	1
71824	4268	78272	1994-12-21	1995-01-18	1
19879	1197	260139	1980-08-23	1980-09-06	1
71958	4275	80180	2018-02-17	2018-02-18	1
71535	4247	260139	1994-01-21	1994-01-28	1
62410	3691	40481087	2015-06-05	2015-06-19	1
73441	4370	4112343	2011-06-02	2011-06-09	1
20617	1239	439777	1980-06-22	1980-06-23	1
1680	97	40481087	1989-10-21	1989-11-04	1
1361	80	260139	1937-07-09	1937-07-16	1
17034	1018	4142905	1972-11-01	1972-12-01	1
68189	4032	40481087	1962-08-09	1962-08-23	1
25508	1518	40481087	1972-08-20	1972-08-27	1
81049	4812	81151	1968-03-01	1968-03-29	1
52247	3096	372328	1964-10-17	1964-11-29	1
79819	4735	0	1983-06-16	1983-06-17	1
84674	5041	4112343	1972-01-20	1972-01-28	1
26027	1545	440086	1981-12-03	1986-12-12	1
87075	5191	4283893	2006-04-26	2006-08-02	1
25044	1496	4112343	1976-08-21	1976-08-30	1
22128	1322	40481087	1946-07-07	1946-07-14	1
85412	5083	4283893	2008-05-10	2008-06-28	1
20914	1257	28060	1976-02-28	1976-03-09	1
79175	4691	4283893	1977-05-18	1977-07-27	1
21378	1283	260139	1984-12-31	1985-01-14	1
77453	4593	372328	1967-05-15	1967-08-17	1
21465	1289	40481087	2014-09-13	2014-10-04	1
9134	539	372328	1934-06-30	1934-09-02	1
88632	5276	0	2011-01-07	2011-01-08	1
142	6	4112343	1993-09-27	1993-10-04	1
12032	711	4112343	1972-08-07	1972-08-14	1
17586	1057	260139	1989-12-10	1989-12-24	1
56782	3371	40481087	2006-05-30	2006-06-06	1
27963	1655	4112343	1974-04-28	1974-05-11	1
28238	1670	80180	2004-06-13	2004-06-14	1
79670	4724	40481087	2014-10-30	2014-11-06	1
26103	1551	4112343	2019-01-02	2019-01-12	1
88450	5262	40481087	2000-07-22	2000-08-12	1
19969	1205	81151	1974-08-04	1974-09-01	1
27110	1605	372328	1937-11-03	1937-12-05	1
70239	4165	4283893	1949-06-18	1949-07-30	1
15146	893	40481087	1994-02-15	1994-02-22	1
80841	4800	80180	2009-03-09	2009-03-10	1
82100	4873	372328	1979-06-20	1979-12-21	1
62582	3700	372328	1982-07-31	1982-10-13	1
24824	1482	80180	2017-08-24	2017-08-25	1
79633	4722	4149245	1924-02-17	1924-03-25	1
55477	3289	372328	1957-07-15	1958-05-30	2
77527	4596	40481087	1951-07-27	1951-08-10	1
26545	1574	260139	1966-07-25	1966-08-08	1
81195	4820	4283893	2009-02-13	2009-06-05	1
19013	1143	4294548	1981-11-08	1982-04-18	1
25194	1505	81151	1968-04-19	1968-05-24	1
73885	4393	260139	2000-08-02	2000-08-09	1
28884	1713	4155034	2009-06-09	2009-06-23	1
71825	4268	80180	1997-06-23	1997-06-24	1
19880	1197	4218389	1988-10-30	1988-11-27	1
71959	4275	260139	1988-03-02	1988-03-09	1
71536	4247	4051466	1986-03-25	2002-12-28	1
62411	3691	40481087	2015-12-23	2016-01-13	1
73442	4370	40481087	2013-02-26	2013-03-12	1
20618	1239	4283893	1987-08-24	1987-10-12	1
1681	97	40481087	1992-08-27	1992-09-03	1
1362	80	260139	1953-02-24	1953-03-10	1
17035	1018	4218389	2009-06-20	2009-07-11	1
68190	4032	78272	1989-08-19	1989-09-23	1
25509	1518	40481087	1982-01-04	1982-01-25	1
81050	4812	372328	1955-03-12	1955-06-22	1
52248	3096	4112343	1968-05-02	1968-05-11	1
79820	4735	28060	1985-08-01	1985-08-09	1
84675	5041	4112343	1983-07-24	1983-08-01	1
26028	1545	4113008	2012-08-15	2012-08-29	1
87076	5191	80180	2012-11-27	2012-11-28	1
25045	1496	4134304	1994-06-16	1994-07-16	1
22129	1322	40481087	1949-08-04	1949-08-18	1
85413	5083	4285898	1983-11-28	1983-11-29	1
20915	1257	192671	2010-04-21	2010-04-22	1
80798	4799	81151	1972-02-15	1972-03-07	1
21379	1283	4112343	1960-11-17	1960-11-25	1
77454	4593	260139	1977-02-01	1977-02-15	1
21466	1289	28060	1975-03-19	1975-03-26	1
9135	539	372328	1935-08-28	1936-03-01	1
88633	5276	81151	1965-08-10	1965-08-31	1
143	6	4237458	1976-05-01	1976-06-30	1
12033	711	4112343	1978-05-01	1978-05-13	1
17587	1057	4112343	1971-08-01	1971-08-08	1
56783	3371	40481087	2014-09-28	2014-10-05	1
27964	1655	4112343	1992-09-16	1992-09-28	1
28239	1670	81151	2002-10-26	2002-11-16	1
79671	4724	260139	1996-10-20	1996-10-27	1
26104	1551	4142905	1979-08-19	1979-11-17	1
53823	3189	4112343	1987-12-08	1987-12-17	1
19970	1205	260139	1964-12-26	1965-01-09	1
27111	1605	4027663	1962-06-22	1962-06-23	1
70240	4165	40481087	1918-11-14	1918-12-05	1
15147	893	40481087	1998-03-07	1998-03-21	1
80842	4800	260139	1977-04-12	1977-04-27	1
82101	4873	4112343	2014-06-24	2014-07-04	1
62583	3700	4156265	1981-01-21	1981-02-04	1
24825	1482	260139	2006-06-13	2006-06-20	1
79634	4722	4278672	2012-10-14	2013-01-12	1
55478	3289	40481087	1960-12-02	1960-12-23	1
77528	4596	40481087	1996-12-11	1996-12-18	1
26546	1574	260139	2002-08-08	2002-08-15	1
81196	4820	4299128	1963-06-15	1963-07-13	1
19014	1143	40481087	1995-02-25	1995-03-11	1
25195	1505	372328	1954-12-29	1955-02-12	1
73886	4393	260139	2006-04-12	2006-04-19	1
28885	1713	4294548	2006-11-27	2007-04-23	1
71826	4268	80502	2016-01-11	2016-01-12	1
19881	1197	40481087	2010-07-30	2010-08-13	1
71960	4275	317576	1994-02-13	1994-02-14	1
72642	4321	81151	2011-03-30	2011-04-13	1
62887	3719	28060	1972-05-21	1972-05-29	1
74883	4452	260139	1964-04-18	1964-04-25	1
20619	1239	40481087	2017-09-11	2017-10-02	1
1682	97	40481087	2006-05-29	2006-06-05	1
1363	80	260139	2018-04-03	2018-04-10	1
17036	1018	4218389	2014-12-12	2015-01-09	1
68191	4032	4112343	1968-01-29	1968-02-11	1
25510	1518	40481087	1994-07-10	1994-07-17	1
81051	4812	4112343	1991-02-15	1991-02-26	1
52249	3096	4278672	2016-04-08	2016-07-07	1
79821	4735	4112343	1994-02-26	1994-03-10	1
84676	5041	4112343	1993-05-11	1993-05-21	1
26029	1545	40481087	1992-05-31	1992-06-14	1
87077	5191	4112343	1990-07-18	1990-07-28	1
25046	1496	4296204	1940-04-08	1940-04-29	1
22130	1322	40481087	1950-07-23	1950-08-13	1
85414	5083	40481087	1966-10-17	1966-10-24	1
20916	1257	260139	1973-12-24	1974-01-07	1
80799	4799	81151	1983-03-10	1983-04-14	1
21380	1283	4294548	1967-08-22	1967-09-19	1
77455	4593	372328	1965-11-29	1966-02-16	1
21467	1289	78272	1972-09-28	1972-10-12	1
9136	539	4149245	1955-12-26	1956-03-02	1
88634	5276	257012	1998-07-17	1998-07-18	1
144	6	40481087	1997-04-26	1997-05-03	1
12034	711	4116491	2009-12-07	2010-01-10	1
17588	1057	4112343	2002-03-31	2002-04-08	1
56784	3371	28060	1984-01-26	1984-02-03	1
27965	1655	4112343	2000-10-19	2000-10-29	1
28240	1670	260139	2014-10-13	2014-10-20	1
79672	4724	372328	1946-11-26	1947-04-23	1
26105	1551	40481087	1958-09-15	1958-09-22	1
53824	3189	40481087	1973-12-01	1973-12-08	1
19971	1205	372328	1965-08-05	1966-01-06	1
27112	1605	4059173	2011-06-01	2011-08-30	1
70241	4165	40481087	1937-01-26	1937-02-09	1
15148	893	257012	1976-05-01	1976-05-02	1
80843	4800	260139	2001-01-28	2001-02-04	1
82102	4873	4310024	2017-01-02	2017-01-03	1
62584	3700	4266809	2005-04-13	2005-04-14	1
24826	1482	372328	1976-10-19	1977-03-26	1
79635	4722	4294548	1956-04-15	1956-05-06	1
55479	3289	40481087	2017-09-27	2017-10-18	1
77529	4596	40481087	2005-02-12	2005-02-19	1
26547	1574	375671	1981-07-02	1981-08-31	1
81197	4820	40481087	1960-05-09	1960-05-16	1
19015	1143	28060	1975-06-21	1975-07-03	1
25196	1505	40481087	1986-03-26	1986-04-02	1
73887	4393	4134304	2016-08-28	2016-09-27	1
28886	1713	30753	2009-08-17	2009-08-18	1
71827	4268	260139	1969-09-28	1969-10-05	1
19882	1197	80180	2015-05-16	2015-05-17	1
71961	4275	4112343	2003-04-15	2003-04-26	1
72643	4321	260139	1968-09-30	1968-10-07	1
62888	3719	260139	1986-11-19	1986-12-03	1
74884	4452	40481087	1965-04-16	1965-05-07	1
20620	1239	28060	1987-10-23	1987-11-02	1
1683	97	30753	1984-11-30	1984-12-01	1
1364	80	4027663	1964-11-02	1964-11-03	1
17723	1068	78272	2006-10-05	2006-11-02	1
68192	4032	4112343	1971-02-26	1971-03-09	1
26969	1598	260139	1969-06-23	1969-06-30	1
81052	4812	4112343	1999-05-31	1999-06-07	1
52250	3096	40481087	1990-02-13	1990-02-27	1
79822	4735	4237458	1982-04-17	1982-07-16	1
84677	5041	4266809	2013-10-04	2013-10-05	1
26030	1545	40481087	1992-07-22	1992-07-29	1
87078	5191	4112343	2015-07-13	2015-07-26	1
25047	1496	40481087	1928-05-15	1928-05-29	1
22131	1322	28060	1945-05-02	1945-05-09	1
85415	5083	28060	1988-03-25	1988-04-06	1
20917	1257	260139	1977-02-20	1977-02-27	1
80800	4799	260139	1971-04-07	1971-04-14	1
21381	1283	40481087	1992-08-16	1992-08-23	1
77456	4593	372328	1966-05-18	1966-08-18	1
21468	1289	80180	2000-11-23	2000-11-24	1
9137	539	4218389	1970-05-18	1970-06-08	1
88635	5276	260139	1960-06-08	1960-06-22	1
145	6	80180	2005-07-13	2005-07-14	1
12035	711	4230399	1990-01-01	1990-03-02	1
17589	1057	40481087	1976-01-31	1976-02-21	1
56785	3371	80180	2011-04-23	2011-04-24	1
27966	1655	40481087	1997-01-25	1997-02-01	1
28241	1670	4112343	2002-08-04	2002-08-15	1
79673	4724	4112343	2015-05-23	2015-06-04	1
26106	1551	40481087	1961-09-14	1961-09-28	1
53825	3189	40481087	1984-04-20	1984-05-11	1
19972	1205	40481087	2013-12-04	2013-12-25	1
27113	1605	4112343	2018-12-08	2018-12-16	1
70242	4165	40481087	1950-08-02	1950-08-09	1
15149	893	260139	1963-08-31	1963-09-07	1
80844	4800	4113008	1974-11-07	1974-11-21	1
82103	4873	80180	2018-10-24	2018-10-25	1
62585	3700	4294548	1992-07-13	1992-10-19	1
24827	1482	40481087	1985-09-26	1985-10-03	1
79636	4722	40481087	1933-03-29	1933-04-05	1
55480	3289	28060	1993-04-20	1993-05-03	1
77530	4596	40481087	2013-01-13	2013-01-20	1
26548	1574	440086	1972-09-29	1972-12-29	1
81198	4820	40481087	1990-08-29	1990-09-12	1
19016	1143	257012	1982-02-21	1982-02-22	1
25197	1505	4112343	2004-10-18	2004-10-25	1
73888	4393	4230399	1987-10-30	1988-01-28	1
28887	1713	257012	1982-12-20	1982-12-21	1
71828	4268	260139	1996-04-25	1996-05-02	1
19883	1197	4112343	1982-12-25	1983-01-04	1
71962	4275	4149245	1992-05-10	1992-06-16	1
72644	4321	260139	1995-01-29	1995-02-12	1
62889	3719	40481087	1966-09-15	1966-10-06	1
74885	4452	28060	1958-05-07	1958-05-17	1
20621	1239	260139	2010-02-27	2010-03-13	1
1684	97	78272	1986-11-30	1987-01-04	1
1365	80	4112343	1985-05-27	1985-06-04	1
17724	1068	80180	2014-11-23	2014-11-24	1
68193	4032	4112343	1989-12-14	1989-12-22	1
26970	1598	260139	1997-05-28	1997-06-04	1
81053	4812	4146173	2000-01-02	2000-03-02	1
52251	3096	4112343	1998-09-03	1998-09-15	1
79823	4735	40481087	1995-05-13	1995-05-20	1
84678	5041	4027663	2002-11-16	2002-11-17	1
26031	1545	40481087	1997-07-10	1997-07-31	1
87079	5191	4152936	1977-08-18	1977-09-08	1
25048	1496	40481087	1953-10-20	1953-11-03	1
22132	1322	78272	1929-02-15	1929-03-08	1
85416	5083	78272	1948-09-12	1948-09-26	1
20918	1257	260139	1987-06-19	1987-07-03	1
80801	4799	378001	1997-06-29	1997-07-29	1
21382	1283	40481087	2000-09-03	2000-09-10	1
77457	4593	4218389	1978-09-21	1978-10-12	1
21469	1289	81151	1965-03-18	1965-04-08	1
9138	539	40481087	1969-08-09	1969-08-16	1
88636	5276	260139	2012-08-19	2012-09-02	1
146	6	372328	1966-10-03	1966-12-06	1
12036	711	40481087	1968-05-19	1968-06-09	1
17590	1057	260139	2007-03-13	2007-03-20	1
56786	3371	372328	1977-07-05	1977-07-19	1
27967	1655	40481087	2002-05-13	2002-05-20	1
28242	1670	4112343	2010-12-03	2010-12-14	1
79674	4724	4278672	2011-03-06	2011-05-05	1
26107	1551	40481087	1982-10-25	1982-11-15	1
53826	3189	40481087	1984-08-15	1984-08-22	1
20231	1219	80180	1978-12-24	1978-12-25	1
27114	1605	4155034	1948-12-13	1948-12-27	1
70243	4165	40481087	2001-05-06	2001-05-27	1
15150	893	372328	1954-09-16	1954-11-29	1
80845	4800	4134304	1989-07-27	1989-10-25	1
82104	4873	372328	1977-02-11	1977-03-25	1
62586	3700	40481087	1973-12-31	1974-01-07	1
24828	1482	372328	1993-01-01	1993-11-06	1
79637	4722	80180	1945-07-25	1945-07-26	1
55481	3289	30753	1994-06-06	1994-06-07	1
77531	4596	81893	1976-10-09	1976-10-10	1
26549	1574	4112343	1967-03-02	1967-03-09	1
81199	4820	78272	2016-10-07	2016-11-11	1
19017	1143	260139	1979-08-16	1979-08-30	1
25198	1505	4112343	2015-10-31	2015-11-13	1
73889	4393	28060	1987-10-02	1987-10-14	1
28888	1713	372328	1972-04-03	1972-06-14	1
71829	4268	4112343	1956-01-13	1956-01-23	1
19884	1197	257012	2005-01-24	2005-01-25	1
71963	4275	260139	2005-02-16	2005-03-02	1
72645	4321	4113008	1965-11-14	1965-12-05	1
62890	3719	40481087	1998-02-20	1998-03-13	1
74886	4452	78272	1978-03-23	1978-04-06	1
20622	1239	372328	1975-11-10	1976-06-10	1
1685	97	260139	1966-04-21	1966-04-28	1
1366	80	4285898	1974-06-18	1974-06-19	1
17725	1068	192671	2015-02-20	2015-02-21	1
68194	4032	4278672	1961-01-18	1961-04-18	1
26971	1598	260139	2002-08-21	2002-09-04	1
81054	4812	80180	1989-12-18	1989-12-19	1
52252	3096	4112343	1999-03-15	1999-03-27	1
79824	4735	260139	1993-06-20	1993-06-27	1
84679	5041	4112343	1976-12-05	1976-12-15	1
26032	1545	81893	2004-12-22	2004-12-23	1
87080	5191	40481087	1973-03-13	1973-03-27	1
25049	1496	40481087	1957-03-26	1957-04-16	1
22133	1322	80180	1958-09-01	1958-09-02	1
85417	5083	80180	1984-01-27	1984-01-28	1
20919	1257	40481087	2011-03-13	2011-03-27	1
80802	4799	4112343	2011-07-27	2011-08-03	1
21383	1283	40481087	2016-07-23	2016-08-06	1
77458	4593	40481087	1979-10-23	1979-11-05	1
21470	1289	81151	1989-04-16	1989-05-07	1
9139	539	260139	1981-06-10	1981-06-17	1
88637	5276	40481087	1962-05-06	1962-05-27	1
147	6	4112343	2001-09-24	2001-10-07	1
12037	711	40481087	1993-03-26	1993-04-16	1
17591	1057	4027663	1995-07-12	1995-07-13	1
56787	3371	372328	1979-04-15	1980-07-25	2
27968	1655	40481087	2002-11-24	2002-12-15	1
28243	1670	40481087	1964-12-07	1964-12-21	1
79675	4724	40481087	1971-05-17	1971-06-07	1
26108	1551	40481087	1983-10-17	1983-11-07	1
53827	3189	4112343	1982-03-01	1982-03-08	1
20232	1219	260139	1949-01-19	1949-02-02	1
27115	1605	4218389	2016-05-05	2016-05-26	1
70244	4165	0	1991-01-27	1991-01-28	1
15151	893	4296204	2012-06-25	2012-07-09	1
80846	4800	40481087	1990-08-25	1990-09-01	1
82105	4873	40481087	1977-09-15	1977-10-06	1
62587	3700	40481087	1976-06-11	1976-06-18	1
24829	1482	4112343	2016-09-20	2016-09-28	1
79638	4722	260139	1941-02-23	1941-03-02	1
55482	3289	440086	1965-12-20	1966-08-29	1
77532	4596	260139	1957-06-18	1957-06-25	1
26550	1574	28060	1965-11-26	1965-12-06	1
81200	4820	81151	1961-06-11	1961-06-25	1
19018	1143	260139	1992-02-05	1992-02-12	1
25199	1505	4113008	1995-03-04	1995-03-25	1
73890	4393	28060	1990-12-30	1991-01-07	1
28889	1713	375671	1985-11-21	1985-12-21	1
71830	4268	4112343	1979-04-22	1979-05-04	1
23817	1426	260139	1983-11-23	1983-11-30	1
71964	4275	4027663	2007-01-06	2007-01-07	1
72646	4321	40481087	1982-10-24	1982-11-07	1
62891	3719	40481087	2005-09-09	2005-09-16	1
74887	4452	80180	1996-11-14	1996-11-15	1
20623	1239	4218389	1980-06-02	1980-06-23	1
1686	97	378001	1993-09-04	1993-11-03	1
1367	80	40481087	1949-11-11	1949-11-18	1
17726	1068	4112343	1978-07-22	1978-08-04	1
68195	4032	4294548	1977-10-18	1978-01-24	1
26972	1598	372328	1958-05-20	1958-06-30	1
81055	4812	317576	2011-07-27	2011-07-28	1
52253	3096	4112343	2012-06-20	2012-07-01	1
79825	4735	321042	1983-06-16	1983-06-17	1
84680	5041	4142905	2013-01-17	2013-03-18	1
26033	1545	192671	2006-07-22	2006-07-23	1
87081	5191	260139	1993-01-22	1993-01-29	1
25050	1496	40481087	1984-07-29	1984-08-05	1
22134	1322	80502	2003-08-13	2003-08-14	1
85418	5083	4059173	1995-06-02	1995-07-02	1
20920	1257	40481087	2014-03-19	2014-04-02	1
80803	4799	4134304	1977-01-10	1977-03-11	1
21384	1283	28060	1975-10-09	1975-10-19	1
77459	4593	40481087	2011-08-02	2011-08-23	1
21471	1289	260139	1976-12-26	1977-01-09	1
9140	539	260139	1986-08-11	1986-08-25	1
88638	5276	40481087	1975-06-24	1975-07-15	1
148	6	4152936	1967-12-10	1967-12-31	1
13365	788	28060	1970-11-06	1970-11-16	1
17592	1057	40481087	2012-01-01	2012-01-15	1
56788	3371	4109685	1998-06-25	1998-07-16	1
27969	1655	40481087	2017-05-15	2017-05-22	1
28244	1670	40481087	2003-03-26	2003-04-16	1
79676	4724	260139	1977-12-26	1978-01-02	1
26109	1551	80180	1998-08-24	1998-08-25	1
53828	3189	4278672	2015-10-11	2015-12-10	1
20233	1219	4112343	1951-05-14	1951-05-27	1
27116	1605	4278672	1958-06-08	1958-07-08	1
70245	4165	28060	1983-03-06	1983-03-13	1
15152	893	40481087	1963-04-05	1963-04-19	1
80847	4800	81151	2005-11-29	2005-12-27	1
82106	4873	40481087	2004-07-07	2004-07-14	1
62588	3700	40481087	1991-04-20	1991-05-11	1
24830	1482	4156265	1987-12-10	1987-12-31	1
79639	4722	372328	2009-07-29	2009-10-11	1
55483	3289	4048695	1968-01-10	1968-03-12	1
77533	4596	260139	1958-11-12	1958-11-21	1
26551	1574	4218389	1986-10-04	1986-11-08	1
81201	4820	257012	2009-03-13	2009-03-14	1
19019	1143	40481087	1990-07-06	1990-07-13	1
25200	1505	40481087	1969-04-19	1969-05-03	1
73891	4393	80180	2019-03-01	2019-03-02	1
28890	1713	4112343	1994-09-18	1994-09-29	1
71831	4268	40481087	1960-01-28	1960-02-18	1
23818	1426	372328	1954-04-30	1954-08-17	1
71965	4275	28060	2008-07-29	2008-08-08	1
72647	4321	40481087	1984-04-06	1984-04-27	1
62892	3719	40481087	2010-03-01	2010-03-22	1
74888	4452	81151	1958-08-16	1958-08-30	1
20624	1239	40481087	1974-12-16	1975-01-06	1
1687	97	4112343	1943-09-19	1943-09-27	1
1368	80	40481087	1959-05-23	1959-05-30	1
17727	1068	4112343	2000-02-28	2000-03-12	1
68196	4032	40481087	1971-11-09	1971-11-30	1
26973	1598	40481087	1964-01-22	1964-02-12	1
81056	4812	4112343	1955-04-13	1955-04-21	1
52254	3096	4113008	2015-02-22	2015-03-15	1
79826	4735	372328	1973-11-30	1974-03-14	1
84681	5041	4310024	2012-03-13	2012-03-14	1
26034	1545	260139	2018-06-27	2018-07-04	1
87082	5191	260139	2002-11-07	2002-11-21	1
25051	1496	40481087	1984-09-12	1984-09-19	1
22135	1322	260139	1989-05-17	1989-05-24	1
85419	5083	4112343	1951-03-05	1951-03-14	1
20921	1257	0	1976-10-28	1976-10-29	1
80804	4799	40481087	1996-02-29	1996-03-14	1
21385	1283	81151	1962-11-25	1962-12-23	1
78283	4641	80180	2004-10-21	2004-10-22	1
21472	1289	260139	1996-03-07	1996-03-14	1
9141	539	317576	1982-11-28	1982-11-29	1
88639	5276	28060	1962-10-26	1962-11-08	1
149	6	4218389	2005-06-17	2005-07-22	1
13366	788	81151	1985-09-16	1985-10-07	1
20058	1211	78272	2013-08-02	2013-09-06	1
58997	3505	28060	1977-07-01	1977-07-09	1
27970	1655	4113008	2002-09-18	2002-10-02	1
28245	1670	28060	1967-09-02	1967-09-11	1
79677	4724	260139	2005-06-13	2005-06-20	1
26110	1551	4112343	1978-09-24	1978-10-05	1
53829	3189	40479422	1985-09-20	1985-11-26	1
20234	1219	4112343	1952-09-20	1952-10-03	1
27117	1605	40481087	1987-02-09	1987-03-02	1
70246	4165	257012	1949-07-02	1949-07-03	1
15153	893	40481087	2014-08-01	2014-08-22	1
80848	4800	4059173	1978-11-30	1979-02-28	1
82107	4873	40481087	2005-03-17	2005-03-31	1
215	11	381316	2002-05-28	2002-05-29	1
24831	1482	40481087	2004-04-03	2004-04-17	1
79640	4722	378001	1915-03-06	1915-05-05	1
55484	3289	4112343	1978-07-29	1978-08-05	1
77534	4596	260139	2017-01-01	2017-01-08	1
26552	1574	40481087	1988-06-05	1988-06-12	1
81202	4820	372328	2003-07-17	2005-01-20	1
20993	1261	195588	2012-05-05	2012-06-06	1
25201	1505	40481087	1971-07-30	1971-08-20	1
73892	4393	260139	2011-12-20	2011-12-27	1
28891	1713	4266809	2010-05-14	2010-05-15	1
71832	4268	28060	1967-08-11	1967-08-22	1
23819	1426	372328	1958-02-27	1958-12-02	1
71966	4275	81893	2016-06-28	2016-06-29	1
72648	4321	80180	2006-05-13	2006-05-14	1
62893	3719	80180	2003-08-16	2003-08-17	1
74889	4452	192671	1996-12-04	1996-12-05	1
20625	1239	80180	2006-02-26	2006-02-27	1
1688	97	4285898	1985-08-27	1985-08-28	1
1369	80	28060	1986-08-29	1986-09-09	1
17728	1068	4112343	2018-10-21	2018-11-02	1
68197	4032	40481087	1996-07-27	1996-08-03	1
26974	1598	40481087	1987-06-20	1987-07-11	1
81057	4812	4112343	1963-05-10	1963-05-22	1
52255	3096	4278672	1970-12-15	1971-02-13	1
79827	4735	378001	2018-06-21	2018-07-21	1
85013	5063	28060	2000-12-02	2000-12-14	1
26035	1545	372328	1974-10-06	1974-11-22	1
87083	5191	40481087	2001-01-08	2001-01-22	1
25052	1496	28060	1933-10-07	1933-10-17	1
22136	1322	260139	2007-06-20	2007-06-27	1
85420	5083	4112343	1980-03-25	1980-04-03	1
20922	1257	317576	2016-11-12	2016-11-13	1
80805	4799	40481087	2011-03-22	2011-04-12	1
21386	1283	81151	1967-01-01	1967-01-15	1
78284	4641	261325	1998-09-03	1998-09-04	1
21473	1289	372328	1963-06-19	1963-08-20	1
9142	539	321042	1972-01-02	1972-01-03	1
88640	5276	80180	1998-03-25	1998-03-26	1
150	6	81151	1980-01-11	1980-02-15	1
13367	788	260139	1998-11-08	1998-11-22	1
20059	1211	81151	1966-12-06	1966-12-20	1
58998	3505	28060	2003-06-06	2003-06-16	1
27971	1655	40481087	1973-08-29	1973-09-12	1
28246	1670	81151	1991-04-13	1991-04-27	1
79678	4724	372328	1942-03-03	1942-04-15	1
26111	1551	4112343	2005-07-01	2005-07-11	1
53830	3189	80180	2000-03-29	2000-03-30	1
20235	1219	4112343	1956-01-17	1956-01-27	1
27118	1605	40481087	1989-08-23	1989-09-06	1
70247	4165	372328	1916-07-12	1917-04-08	1
17805	1073	260139	1983-05-07	1983-05-21	1
80849	4800	4112343	1980-08-03	1980-08-15	1
82108	4873	195588	1996-07-11	1996-08-11	1
216	11	4112343	1955-10-23	1955-11-05	1
30124	1782	80180	1988-01-01	1988-01-02	1
79641	4722	4112343	1974-11-02	1974-11-14	1
55485	3289	4112343	2005-07-14	2005-07-24	1
77535	4596	4112343	2012-06-26	2012-07-03	1
26553	1574	40481087	2010-02-20	2010-03-06	1
81203	4820	4109685	2002-08-08	2002-08-22	1
20994	1261	260139	1990-06-08	1990-06-22	1
25202	1505	40481087	1993-03-05	1993-03-12	1
73893	4393	4112343	1998-08-02	1998-08-11	1
28892	1713	40481087	1988-11-05	1988-11-19	1
71833	4268	260139	1993-05-26	1993-06-09	1
23820	1426	4112343	1970-03-30	1970-04-08	1
71967	4275	40481087	2015-02-06	2015-02-13	1
72649	4321	4218389	1992-09-14	1992-10-05	1
62894	3719	81151	1999-06-03	1999-07-01	1
74890	4452	195588	1978-05-28	1978-07-17	1
20626	1239	258780	2012-07-05	2012-07-06	1
1689	97	4296204	2015-03-23	2015-04-06	1
1370	80	260139	2008-06-03	2008-06-17	1
17729	1068	260139	1992-12-13	1992-12-27	1
68198	4032	257012	1950-02-06	1950-02-07	1
26975	1598	28060	1965-08-13	1965-08-25	1
81058	4812	4112343	2007-09-25	2007-10-05	1
52256	3096	80180	1997-07-31	1997-08-01	1
79828	4735	4113008	2014-05-29	2014-06-12	1
85014	5063	81151	1968-02-12	1968-03-04	1
26036	1545	4059173	1970-09-27	1970-11-26	1
87084	5191	81151	1981-05-20	1981-06-03	1
25053	1496	80180	1957-12-25	1957-12-26	1
22137	1322	372328	2003-01-18	2003-08-13	1
85421	5083	4112343	1992-05-19	1992-05-30	1
20923	1257	4112343	2018-05-30	2018-06-11	1
80806	4799	0	2010-05-01	2010-05-02	1
21387	1283	4152936	1993-11-08	1993-11-22	1
78285	4641	372328	1975-05-02	1975-07-10	1
21474	1289	372328	1964-08-14	1965-02-16	1
9143	539	372328	1933-07-24	1933-09-03	1
88641	5276	81151	1994-05-13	1994-06-03	1
151	6	378001	1984-01-25	1984-03-25	1
13368	788	372328	1972-01-28	1972-02-11	1
20060	1211	81151	1990-04-02	1990-04-16	1
58999	3505	81893	1973-12-23	1973-12-24	1
28542	1691	81151	1953-01-27	1953-03-03	1
28247	1670	257012	1978-11-25	1978-11-26	1
79679	4724	372328	1943-06-09	1943-10-13	1
26112	1551	4113008	1982-10-02	1982-10-16	1
53831	3189	372328	1965-09-14	1965-11-24	1
20236	1219	4112343	1992-10-03	1992-10-13	1
27119	1605	40481087	2018-08-03	2018-08-24	1
70248	4165	4112343	1951-01-22	1951-01-31	1
17806	1073	4112343	1972-01-22	1972-01-31	1
80850	4800	4134304	1985-10-16	1985-11-14	1
82109	4873	4112343	1980-11-25	1980-12-04	1
217	11	4112343	1956-11-02	1956-11-12	1
30125	1782	378001	1953-11-20	1953-12-20	1
79642	4722	4112343	1979-02-23	1979-03-07	1
55486	3289	4134304	1966-12-16	1967-01-15	1
77536	4596	4294548	1958-04-09	1958-06-25	1
26554	1574	40481087	2014-01-20	2014-01-27	1
81204	4820	4112343	1968-02-04	1968-02-15	1
20995	1261	4112343	1973-06-01	1973-06-10	1
25203	1505	40481087	1994-10-10	1994-10-24	1
73894	4393	40481087	1999-11-02	1999-11-23	1
28893	1713	40481087	1997-12-10	1997-12-24	1
71834	4268	260139	2011-12-12	2011-12-19	1
23821	1426	4155034	2009-09-27	2009-10-18	1
71968	4275	81151	1995-04-01	1995-04-23	1
72650	4321	40481087	1995-08-15	1995-08-29	1
62895	3719	4027663	1993-12-31	1994-01-01	1
74891	4452	40481087	1987-09-05	1987-09-26	1
20627	1239	260139	2015-10-20	2015-10-27	1
1690	97	4310024	1983-10-07	1983-10-08	1
1371	80	4112343	2003-09-14	2003-09-21	1
17730	1068	4113008	2004-10-01	2004-10-15	1
68199	4032	260139	1985-08-21	1985-09-04	1
26976	1598	80502	2018-08-06	2018-08-07	1
81059	4812	40481087	1981-05-07	1981-05-21	1
52257	3096	372328	1965-04-28	1965-05-30	1
79829	4735	4112343	1974-08-30	1974-09-09	1
85015	5063	260139	1957-08-20	1957-08-27	1
26037	1545	4152936	2017-04-03	2017-04-17	1
87085	5191	260139	1998-03-06	1998-03-20	1
25054	1496	260139	1924-06-28	1924-07-05	1
22138	1322	381316	2019-01-30	2019-01-31	1
85422	5083	4152936	2013-06-11	2013-07-02	1
20924	1257	4283893	2015-02-01	2015-03-29	1
80807	4799	28060	1998-08-25	1998-09-02	1
21388	1283	40481087	1967-06-08	1967-06-15	1
78286	4641	4112343	1973-08-27	1973-09-06	1
21475	1289	4109685	2011-10-30	2011-11-20	1
9144	539	4029498	1933-03-26	1933-03-27	1
88642	5276	372328	1958-02-18	1958-04-27	1
152	6	4109685	2004-05-09	2004-05-23	1
13369	788	40481087	1993-11-21	1993-12-05	1
20061	1211	133834	1967-11-08	1967-11-09	1
59000	3505	257012	1948-12-22	1948-12-23	1
28543	1691	192671	1985-10-20	1985-10-21	1
28248	1670	260139	2015-10-01	2015-10-08	1
79680	4724	378419	2018-02-28	2018-03-01	1
26113	1551	4152936	1990-04-07	1990-04-28	1
53832	3189	440086	1973-06-14	1975-01-02	1
20237	1219	40481087	1987-04-23	1987-05-07	1
27120	1605	260139	1992-08-20	1992-08-27	1
70249	4165	4112343	1968-12-22	1969-01-04	1
17807	1073	4112343	1986-02-19	1986-03-03	1
82214	4883	28060	1981-12-09	1981-12-22	1
82110	4873	40481087	2002-10-31	2002-11-07	1
218	11	4112343	1970-06-01	1970-06-13	1
30126	1782	4112343	1956-10-08	1956-10-21	1
79643	4722	4156265	1996-06-19	1996-07-10	1
55487	3289	40481087	1972-04-29	1972-05-06	1
77537	4596	40481087	1957-11-11	1957-12-02	1
29081	1724	78272	1954-06-18	1954-07-16	1
81205	4820	40481087	1981-05-23	1981-06-13	1
20996	1261	4218389	1995-01-10	1995-01-31	1
25204	1505	260139	1968-06-19	1968-06-26	1
73895	4393	40481087	2004-05-07	2004-05-28	1
28894	1713	78272	1990-10-26	1990-11-16	1
71835	4268	4112343	1965-05-09	1965-05-20	1
23822	1426	4278672	2005-10-18	2005-11-17	1
71969	4275	260139	1993-03-27	1993-04-03	1
72651	4321	260139	1991-03-23	1991-03-30	1
62896	3719	4043241	2012-01-03	2012-01-04	1
74892	4452	40481087	2016-03-17	2016-04-07	1
20628	1239	4112343	1994-01-30	1994-02-07	1
1691	97	81151	1995-08-25	1995-09-22	1
1372	80	40481087	1942-01-20	1942-01-27	1
17731	1068	4155034	2013-07-28	2013-08-18	1
68200	4032	260139	2001-05-22	2001-06-05	1
26977	1598	81151	1970-02-16	1970-03-02	1
85743	5107	378001	2017-07-22	2017-09-20	1
52258	3096	375671	2008-01-30	2008-03-30	1
79830	4735	4112343	1980-05-14	1980-05-25	1
85016	5063	4027663	1973-03-27	1973-03-28	1
26038	1545	4285898	2005-09-18	2005-09-19	1
87086	5191	260139	2014-09-03	2014-09-10	1
25055	1496	372328	1922-08-06	1922-09-24	1
22139	1322	4112343	1962-02-07	1962-02-15	1
85423	5083	4299128	1993-08-20	1993-09-10	1
20925	1257	40481087	2004-04-04	2004-04-11	1
80808	4799	257012	1963-03-11	1963-03-12	1
21389	1283	40481087	1988-06-09	1988-06-30	1
78287	4641	4112343	2012-03-22	2012-04-04	1
21476	1289	4112343	1989-06-11	1989-06-21	1
9145	539	4112343	1989-11-26	1989-12-05	1
88643	5276	4112343	1981-04-18	1981-04-25	1
153	6	4152936	1971-08-12	1971-08-26	1
13370	788	4112343	2010-06-29	2010-07-10	1
20062	1211	260139	1984-11-26	1984-12-10	1
59001	3505	260139	1992-09-28	1992-10-05	1
28544	1691	260139	2005-06-01	2005-06-08	1
28249	1670	4112343	1984-08-13	1984-08-22	1
79681	4724	4051466	1945-05-13	1961-03-29	1
26114	1551	4283893	1979-03-28	1979-05-09	1
53833	3189	4094814	2003-03-18	2003-05-17	1
20238	1219	81151	1978-08-11	1978-08-25	1
27121	1605	372328	1937-02-23	1937-06-06	1
70250	4165	4112343	1980-01-11	1980-01-20	1
17808	1073	4278672	2017-02-14	2017-04-15	1
82215	4883	260139	2008-08-15	2008-08-29	1
82111	4873	40481087	2017-11-30	2017-12-21	1
219	11	4112343	2003-12-07	2003-12-17	1
30127	1782	4116491	1979-11-19	1979-12-21	1
79644	4722	4278672	2015-09-29	2015-10-29	1
59978	3558	4112343	1977-07-18	1977-07-28	1
77538	4596	40481087	1974-04-06	1974-04-20	1
29082	1724	257012	2009-12-26	2009-12-27	1
81206	4820	40481087	1987-03-20	1987-04-10	1
20997	1261	81151	1973-01-14	1973-02-04	1
25205	1505	378001	1990-03-30	1990-04-29	1
73896	4393	40481087	2018-04-16	2018-05-07	1
28895	1713	260139	2000-04-09	2000-04-24	1
71836	4268	4112343	2015-12-22	2016-01-03	1
23823	1426	40481087	1957-06-21	1957-07-12	1
71970	4275	4285898	2017-08-22	2017-08-23	1
72652	4321	40481087	1985-12-26	1986-01-02	1
62897	3719	4112343	1978-07-28	1978-08-04	1
74893	4452	28060	1955-11-03	1955-11-16	1
20629	1239	4294548	1972-08-22	1972-09-19	1
1692	97	195588	1966-07-13	1966-10-11	2
1373	80	40481087	1950-03-24	1950-04-07	1
17732	1068	28060	1984-10-05	1984-10-15	1
68201	4032	4142905	1960-02-23	1960-03-24	1
26978	1598	195588	1977-01-15	1977-03-06	1
85744	5107	4112343	1997-05-26	1997-06-03	1
52259	3096	4059173	2011-01-14	2011-02-13	1
79831	4735	4112343	1989-10-20	1989-11-02	1
85017	5063	4059173	1957-10-07	1958-01-05	1
26039	1545	4310024	2004-06-25	2004-06-26	1
87087	5191	4112343	2013-02-13	2013-02-21	1
25056	1496	378419	1992-05-03	1992-05-04	1
22140	1322	4156265	1963-05-09	1963-05-30	1
85424	5083	40481087	1988-05-19	1988-05-26	1
22381	1338	28060	1946-10-25	1946-11-06	1
80809	4799	4156265	1969-04-17	1969-05-01	1
21390	1283	40481087	2000-06-19	2000-06-26	1
78288	4641	28060	1967-10-14	1967-10-27	1
21477	1289	4112343	2017-06-07	2017-06-15	1
9146	539	4112343	1990-02-06	1990-02-17	1
88644	5276	4112343	2005-06-08	2005-06-21	1
154	6	40481087	1967-05-19	1967-06-02	1
13371	788	40481087	1998-12-17	1998-12-24	1
20063	1211	260139	1992-01-31	1992-02-07	1
59002	3505	378001	1999-12-03	2000-02-01	1
28545	1691	372328	1950-01-30	1950-06-29	1
28250	1670	4113008	2017-01-01	2017-01-22	1
79682	4724	81151	1952-12-05	1953-01-09	1
26115	1551	40481087	1989-04-14	1989-04-28	1
53834	3189	4112343	1968-08-31	1968-09-09	1
20239	1219	313217	2007-12-10	2007-12-11	1
27122	1605	4112343	1950-08-15	1950-08-22	1
70251	4165	4156265	1917-12-13	1918-01-03	1
17809	1073	40481087	1942-06-30	1942-07-14	1
82216	4883	372328	1947-06-14	1947-11-28	1
83951	4991	378001	1978-11-21	1979-01-20	1
220	11	40481087	1991-07-17	1991-08-07	1
30128	1782	4237458	1968-12-01	1969-03-01	1
79645	4722	4283893	1991-03-11	1991-07-22	1
59979	3558	4112343	1993-10-05	1993-10-15	1
77539	4596	40481087	2014-07-20	2014-07-27	1
29083	1724	260139	2015-01-23	2015-01-30	1
83699	4977	260139	1982-06-02	1982-06-09	1
20998	1261	260139	2006-05-01	2006-05-08	1
25206	1505	4112343	1961-01-29	1961-02-08	1
73897	4393	40481087	2007-09-17	2007-10-08	1
28896	1713	4112343	1989-11-04	1989-11-12	1
71837	4268	4113008	2012-05-18	2012-06-01	1
23824	1426	40481087	1963-11-14	1963-11-21	1
71971	4275	40481087	1999-04-12	1999-04-26	1
72653	4321	40481087	1990-04-16	1990-05-07	1
62898	3719	4112343	1998-10-21	1998-10-30	1
74894	4452	78272	1970-05-29	1970-06-19	1
20630	1239	40481087	2018-10-03	2018-10-17	1
1693	97	260139	1999-07-06	1999-07-20	1
1374	80	40481087	1955-06-17	1955-07-08	1
17733	1068	260139	1987-05-05	1987-05-12	1
68202	4032	4156265	2014-01-27	2014-02-17	1
26979	1598	260139	2009-09-12	2009-09-26	1
85745	5107	4218389	1987-01-03	1987-01-31	1
52260	3096	4112343	2016-07-11	2016-07-19	1
79832	4735	4112343	1990-12-30	1991-01-10	1
85018	5063	4283893	1969-01-05	1969-09-21	1
28409	1683	372328	1973-09-09	1973-12-27	1
87088	5191	40481087	2003-01-21	2003-02-04	1
25057	1496	4112343	1932-01-29	1932-02-11	1
22141	1322	40481087	1982-08-12	1982-08-19	1
85425	5083	257012	2000-11-11	2000-11-12	1
22382	1338	260139	1992-05-24	1992-05-31	1
80810	4799	4283893	1963-02-25	1963-05-27	1
23382	1397	28060	1995-02-13	1995-02-24	1
78289	4641	260139	1978-03-19	1978-03-26	1
21478	1289	4156265	2002-12-25	2003-01-15	1
9147	539	4116491	1984-03-13	1984-04-30	1
88645	5276	4116491	1975-01-15	1975-03-02	1
2661	156	40481087	1981-12-11	1981-12-18	1
13372	788	378001	1993-08-26	1993-09-25	1
20064	1211	4112343	1966-09-11	1966-09-21	1
59003	3505	4112343	1949-11-14	1949-11-22	1
28546	1691	4112343	1959-12-27	1960-01-03	1
28251	1670	28060	1964-06-07	1964-06-18	1
79683	4724	257012	1974-08-02	1974-08-03	1
26116	1551	40481087	1993-06-11	1993-06-18	1
53835	3189	4218389	1987-10-17	1987-11-07	1
20240	1219	4112343	1942-11-14	1942-11-25	1
27123	1605	4112343	1991-03-22	1991-04-04	1
70252	4165	40481087	1924-02-13	1924-02-20	1
17810	1073	40481087	2000-04-25	2000-05-02	1
82217	4883	4109685	1975-06-13	1975-07-04	1
83952	4991	4112343	2009-03-04	2009-03-13	1
221	11	40481087	1998-02-01	1998-02-22	1
30129	1782	40481087	1959-06-30	1959-07-14	1
79646	4722	4294548	1945-08-27	1946-01-14	1
59980	3558	4155034	2011-03-09	2011-03-23	1
77540	4596	40481087	2016-01-26	2016-02-09	1
29084	1724	378001	1951-07-04	1951-09-02	1
83700	4977	260139	1988-07-15	1988-07-22	1
20999	1261	260139	2006-11-06	2006-11-20	1
25207	1505	4112343	1996-03-21	1996-03-31	1
73898	4393	40481087	2009-10-02	2009-10-23	1
28897	1713	4116491	2004-09-27	2004-11-02	1
71838	4268	40481087	1985-07-10	1985-07-31	1
23825	1426	40481087	1997-05-30	1997-06-13	1
73486	4374	30753	2012-08-04	2012-08-05	1
72654	4321	40481087	2015-08-23	2015-09-13	1
62899	3719	4278672	1985-10-09	1985-12-08	1
74895	4452	81151	1971-05-15	1971-05-29	1
24075	1438	260139	1955-04-21	1955-04-28	1
1694	97	4056621	1966-09-06	1966-09-07	1
1375	80	40481087	1981-11-05	1981-11-12	1
17734	1068	372328	2011-12-24	2013-09-20	1
68203	4032	40481087	1974-04-24	1974-05-01	1
26980	1598	40481087	2008-09-21	2008-10-05	1
85746	5107	4112343	1987-08-04	1987-08-17	1
52261	3096	4112343	2019-02-07	2019-02-19	1
79833	4735	4278672	1998-06-22	1998-07-22	1
85019	5063	4283893	1974-01-11	1974-02-01	1
28410	1683	40481087	2013-01-12	2013-02-02	1
87089	5191	40481087	2007-04-06	2007-04-20	1
25058	1496	4112343	1968-12-01	1968-12-14	1
22142	1322	40481087	1982-10-24	1982-11-07	1
85426	5083	4283893	2000-08-26	2000-12-09	1
22383	1338	260139	1997-02-22	1997-03-01	1
80811	4799	80180	1997-02-19	1997-02-20	1
23383	1397	4048171	1981-11-25	1981-11-26	1
78290	4641	260139	1981-07-12	1981-07-26	1
21479	1289	40481087	1995-06-06	1995-06-20	1
9148	539	4116491	1990-04-29	1990-06-16	1
88646	5276	40479768	2015-05-14	2015-06-20	1
2662	156	80180	2019-01-30	2019-01-31	1
13373	788	4112343	1974-11-27	1974-12-09	1
20065	1211	4112343	2007-03-31	2007-04-08	1
59004	3505	4112343	1954-03-04	1954-03-12	1
28547	1691	4112343	2000-01-17	2000-01-27	1
28252	1670	260139	1981-11-03	1981-11-10	1
79684	4724	260139	1994-01-17	1994-01-24	1
26117	1551	40481087	2009-05-30	2009-06-06	1
53836	3189	4294548	2017-09-15	2017-11-03	1
20241	1219	4296204	1968-03-01	1968-04-05	1
27124	1605	4283893	2000-11-29	2001-01-31	1
70253	4165	40481087	1946-03-20	1946-03-27	1
17811	1073	40481087	2005-04-14	2005-04-21	1
82218	4883	4112343	2017-01-09	2017-01-16	1
83953	4991	40481087	1981-08-06	1981-08-20	1
222	11	40481087	2012-08-12	2012-08-19	1
30130	1782	40481087	1963-03-01	1963-03-08	1
79647	4722	40481087	1918-04-05	1918-04-12	1
59981	3558	80180	1994-12-09	1994-12-10	1
78365	4644	30753	1999-11-18	1999-11-19	1
29085	1724	4112343	2016-07-23	2016-07-31	1
83701	4977	260139	1990-08-13	1990-08-27	1
21000	1261	260139	2016-04-12	2016-04-19	1
26704	1585	260139	1957-03-26	1957-04-02	1
74768	4447	4059173	1955-08-30	1955-09-29	1
28898	1713	4296205	2011-07-13	2011-08-17	1
71839	4268	40481087	1990-10-12	1990-10-26	1
23826	1426	80180	1986-09-19	1986-09-20	1
73487	4374	80180	2013-01-31	2013-02-01	1
72655	4321	260139	1993-08-18	1993-09-01	1
62900	3719	4283893	2002-01-26	2002-06-22	1
74896	4452	4237458	1956-06-27	1956-09-25	1
24076	1438	372328	1954-05-31	1954-07-02	1
1695	97	4112343	1948-07-17	1948-07-26	1
1376	80	40481087	2017-04-12	2017-05-03	1
17735	1068	4112343	2003-01-29	2003-02-11	1
70932	4212	80180	2010-02-03	2010-02-04	1
26981	1598	260139	2011-06-19	2011-07-03	1
85747	5107	4112343	1990-12-02	1990-12-15	1
52262	3096	40481087	2010-10-13	2010-10-20	1
79834	4735	40481087	2009-11-09	2009-11-16	1
85020	5063	40481087	1964-01-06	1964-01-27	1
28411	1683	78272	1987-01-27	1987-03-03	1
87090	5191	40481087	2013-05-23	2013-06-13	1
25059	1496	4112343	1971-03-06	1971-03-17	1
22143	1322	28060	1937-06-18	1937-06-25	1
85427	5083	4310024	1982-10-04	1982-10-05	1
22384	1338	260139	2004-10-22	2004-10-29	1
80812	4799	260139	1963-12-16	1963-12-23	1
23384	1397	4084167	1977-11-14	1977-11-14	1
78291	4641	4109685	2017-07-20	2017-08-03	1
23505	1407	80180	2002-11-17	2002-11-18	1
9149	539	40481087	1959-10-09	1959-10-23	1
88647	5276	313217	2009-12-27	2009-12-28	1
2663	156	81151	2013-08-19	2013-09-02	1
13374	788	40481087	1972-11-29	1972-12-06	1
20066	1211	4112343	2008-12-02	2008-12-09	1
59005	3505	4285898	1975-09-14	1975-09-15	1
28548	1691	4266809	1985-07-23	1985-07-24	1
28253	1670	4051466	1968-01-11	1983-11-27	1
79685	4724	378001	1980-09-14	1980-11-13	1
26118	1551	260139	1958-07-12	1958-07-19	1
53837	3189	260139	2002-12-01	2002-12-15	1
20242	1219	40481087	1968-10-22	1968-11-05	1
27125	1605	40481087	1968-08-03	1968-08-17	1
70254	4165	40481087	2011-06-11	2011-07-02	1
17812	1073	40481087	2008-11-08	2008-11-22	1
82219	4883	40481087	1974-08-18	1974-09-01	1
83954	4991	40481087	2002-05-17	2002-05-31	1
223	11	28060	1966-04-08	1966-04-19	1
30131	1782	40481087	1973-06-18	1973-07-09	1
79648	4722	40481087	1928-05-28	1928-06-18	1
59982	3558	195588	1992-03-19	1992-04-26	1
78366	4644	192671	2001-02-16	2001-02-17	1
29086	1724	4278672	1986-05-27	1986-08-25	1
83702	4977	4112343	1999-08-30	1999-09-07	1
21001	1261	261325	2002-07-06	2002-07-07	1
26705	1585	260139	1976-03-26	1976-04-09	1
74769	4447	4112343	1955-09-03	1955-09-10	1
28899	1713	40481087	2004-12-22	2004-12-29	1
71840	4268	40481087	1994-07-06	1994-07-13	1
23827	1426	81151	2013-10-27	2013-11-17	1
73488	4374	134438	2002-05-21	2003-02-15	1
72656	4321	260139	2002-10-05	2002-10-19	1
62901	3719	78272	1989-11-17	1989-12-22	1
74897	4452	40481087	1973-08-01	1973-08-15	1
24077	1438	378001	1966-02-03	1966-04-04	1
1696	97	4116491	1972-12-20	1973-02-04	1
1377	80	81151	1938-08-01	1938-08-22	1
17736	1068	40481087	1992-03-14	1992-03-28	1
70933	4212	81151	1982-02-25	1982-03-25	1
26982	1598	4112343	1972-08-19	1972-08-27	1
85748	5107	4283893	2002-09-19	2002-10-31	1
52263	3096	40481087	2012-11-15	2012-12-06	1
79835	4735	80180	2012-04-14	2012-04-15	1
85021	5063	30753	1980-04-19	1980-04-20	1
28412	1683	80180	2014-01-22	2014-01-23	1
88863	5291	28060	2000-09-09	2000-09-22	1
25060	1496	4112343	1993-08-19	1993-08-29	1
22144	1322	28060	1945-09-09	1945-09-22	1
85428	5083	40481087	1979-03-25	1979-04-01	1
22385	1338	372328	1948-04-08	1948-09-16	1
80813	4799	321042	2010-05-01	2010-05-02	1
23385	1397	4112343	2003-07-29	2003-08-08	1
78292	4641	4112343	1979-10-06	1979-10-13	1
23506	1407	257012	1996-02-25	1996-02-26	1
9150	539	40481087	1976-11-12	1976-11-19	1
88648	5276	378001	1985-10-27	1985-11-26	1
2664	156	260139	2005-06-23	2005-06-30	1
13375	788	40481087	2000-02-24	2000-03-16	1
20067	1211	40481087	1972-06-14	1972-07-05	1
59006	3505	40481087	1938-05-10	1938-05-24	1
28549	1691	40481087	1957-06-14	1957-06-21	1
28254	1670	4283893	1978-09-16	1978-12-23	1
79686	4724	378001	1989-01-30	1989-03-01	1
26119	1551	260139	1996-12-05	1996-12-19	1
53838	3189	378001	1999-08-06	1999-09-05	1
20243	1219	40481087	1980-05-11	1980-05-25	1
27126	1605	40481087	1993-06-13	1993-07-04	1
70255	4165	81151	1925-09-23	1925-10-14	1
17813	1073	260139	1949-07-18	1949-07-25	1
82220	4883	40481087	1979-08-14	1979-08-28	1
83955	4991	28060	1973-06-01	1973-06-11	1
224	11	372328	1960-06-26	1960-11-22	1
30132	1782	40481087	1987-07-03	1987-07-24	1
79649	4722	40481087	1950-05-01	1950-05-08	1
59983	3558	4112343	1965-05-27	1965-06-07	1
78367	4644	257012	1996-01-28	1996-02-04	1
29087	1724	40481087	1959-04-14	1959-05-05	1
83703	4977	40481087	1973-10-11	1973-10-18	1
21002	1261	4109685	1972-03-06	1972-03-20	1
26706	1585	4109685	1950-10-06	1950-10-27	1
74770	4447	40481087	1979-04-07	1979-04-14	1
28900	1713	40481087	2017-11-03	2017-11-17	1
71841	4268	40481087	2006-04-16	2006-04-30	1
23828	1426	260139	1978-11-22	1978-12-06	1
73489	4374	192671	2013-04-13	2013-04-14	1
72657	4321	4112343	1969-01-29	1969-02-11	1
62902	3719	192671	2003-11-03	2003-11-04	1
74898	4452	40481087	1974-02-16	1974-03-09	1
24078	1438	4112343	1959-08-11	1959-08-23	1
1697	97	40481087	1959-10-15	1959-11-05	1
1378	80	192671	1974-10-27	1974-10-28	1
17737	1068	40481087	2008-04-26	2008-05-03	1
70934	4212	372328	1970-07-28	1970-10-09	1
26983	1598	4112343	1984-09-26	1984-10-07	1
85749	5107	28060	2018-03-02	2018-03-14	1
56710	3367	372328	1968-02-06	1969-02-17	1
79836	4735	4237458	2011-01-15	2011-04-15	1
85022	5063	80180	1981-09-11	1981-09-12	1
28413	1683	81893	2012-02-02	2012-02-03	1
88864	5291	80180	2014-08-25	2014-08-26	1
25061	1496	4134304	1979-08-29	1979-10-28	1
22145	1322	375671	2017-09-04	2017-10-04	1
85429	5083	40481087	1996-01-22	1996-02-12	1
22386	1338	4027663	1969-09-30	1969-10-01	1
80814	4799	4112343	2017-11-30	2017-12-11	1
23386	1397	4283893	2013-05-31	2013-07-26	1
78293	4641	40481087	1999-06-02	1999-06-09	1
23507	1407	4146173	1982-08-18	1982-09-17	1
10518	621	28060	1966-05-15	1966-05-24	1
88649	5276	4283893	1998-07-03	1998-11-13	1
2665	156	378001	1988-03-03	1988-04-02	1
13376	788	40481087	2003-11-02	2003-11-16	1
20068	1211	40481087	1977-05-08	1977-05-29	1
59007	3505	40481087	1972-10-24	1972-11-07	1
28550	1691	40481087	1993-08-15	1993-08-22	1
29956	1776	196456	1984-10-13	1984-10-13	1
79687	4724	4112343	1984-05-22	1984-06-03	1
26120	1551	260139	2001-12-07	2001-12-21	1
53839	3189	4109685	1973-01-05	1973-01-26	1
20244	1219	40481087	2008-04-23	2008-05-14	1
27127	1605	260139	1964-10-31	1964-11-14	1
70256	4165	260139	1992-02-08	1992-02-15	1
17814	1073	440086	1944-06-23	1945-12-21	1
82221	4883	80180	1986-03-31	1986-04-01	1
83956	4991	260139	1983-01-18	1983-02-01	1
225	11	378001	2000-04-21	2000-05-21	1
30133	1782	40481087	2002-12-07	2002-12-28	1
79650	4722	40481087	1996-10-31	1996-11-21	1
59984	3558	40481087	1973-04-20	1973-05-11	1
78368	4644	260139	1981-07-01	1981-07-15	1
29088	1724	40481087	1979-09-26	1979-10-17	1
83704	4977	40481087	1974-10-19	1974-10-26	1
21003	1261	40481087	1975-04-19	1975-05-10	1
26707	1585	4112343	1970-09-25	1970-10-08	1
74771	4447	40481087	2010-03-10	2010-03-31	1
28901	1713	192671	2010-07-22	2010-07-23	1
71842	4268	81151	1971-05-28	1971-06-11	1
23829	1426	378001	1974-10-10	1974-12-09	1
73490	4374	260139	1980-09-15	1980-09-22	1
72658	4321	4112343	2004-01-11	2004-01-18	1
62903	3719	195588	2014-12-26	2015-01-29	1
74899	4452	40481087	2012-05-08	2012-05-29	1
24079	1438	4218389	1980-09-01	1980-09-22	1
1698	97	40481087	1971-07-07	1971-07-28	1
1379	80	260139	1975-10-16	1975-10-23	1
17738	1068	440086	1985-09-11	1991-09-20	1
70935	4212	4112343	2019-05-23	2019-05-30	1
26984	1598	40481087	1961-01-10	1961-01-31	1
85750	5107	80180	2011-05-19	2011-05-20	1
56711	3367	375671	2007-09-26	2007-11-25	1
79837	4735	40481087	1975-08-30	1975-09-20	1
85023	5063	260139	1970-03-03	1970-03-17	1
28414	1683	260139	1998-12-28	1999-01-04	1
88865	5291	260139	2007-09-05	2007-09-12	1
25062	1496	4296205	1989-06-07	1989-07-12	1
22146	1322	4112343	1987-10-05	1987-10-16	1
85430	5083	81151	1949-08-22	1949-09-05	1
22387	1338	4112343	1987-01-03	1987-01-11	1
80815	4799	40481087	1960-12-05	1960-12-19	1
23387	1397	81151	1986-01-31	1986-02-14	1
78294	4641	192671	2004-12-29	2004-12-30	1
23508	1407	4218389	1968-10-06	1968-11-10	1
10519	621	78272	2017-05-01	2017-05-15	1
88650	5276	4296205	1970-10-04	1970-10-25	1
2666	156	4112343	1983-12-26	1984-01-02	1
13377	788	40481087	2007-10-02	2007-10-16	1
20069	1211	40481087	1993-06-13	1993-07-04	1
59008	3505	40481087	2001-11-13	2001-11-20	1
28551	1691	40481087	1995-03-22	1995-04-05	1
29957	1776	372328	1918-01-21	1918-04-06	1
79688	4724	4237458	2008-12-16	2009-02-14	1
26121	1551	4112343	1992-06-27	1992-07-05	1
53840	3189	4112343	2005-04-20	2005-04-30	1
20245	1219	260139	1947-08-20	1947-08-27	1
27128	1605	4112343	2010-11-09	2010-11-16	1
70257	4165	372328	1912-08-11	1912-09-29	1
17815	1073	4230399	2010-08-20	2010-09-19	1
82222	4883	81151	1983-03-24	1983-04-14	1
83957	4991	260139	1985-04-23	1985-05-07	1
226	11	4112343	1963-06-13	1963-06-21	1
30134	1782	196456	1956-01-11	1956-01-11	1
79651	4722	40481087	2008-05-15	2008-05-22	1
59985	3558	260139	1964-02-02	1964-02-09	1
78369	4644	260139	2007-07-31	2007-08-14	1
29089	1724	28060	2013-04-29	2013-05-08	1
83705	4977	40481087	1983-12-25	1984-01-01	1
21004	1261	80180	2005-10-24	2005-10-25	1
26708	1585	4112343	2007-06-05	2007-06-12	1
74772	4447	80180	1990-07-27	1990-07-28	1
28902	1713	4283893	1982-11-08	1983-02-07	1
71843	4268	260139	1963-02-04	1963-02-11	1
23830	1426	4112343	1953-12-02	1953-12-12	1
73491	4374	260139	2000-07-27	2000-08-10	1
76057	4520	0	1996-09-28	1996-09-29	1
62904	3719	257012	1968-02-12	1968-02-13	1
74900	4452	260139	1977-01-28	1977-02-04	1
24080	1438	80180	1986-04-29	1986-04-30	1
2384	141	28060	1993-09-22	1993-10-04	1
1380	80	260139	2013-12-29	2014-01-12	1
17739	1068	40481087	1995-10-15	1995-10-29	1
70936	4212	4142905	1981-01-31	1981-04-01	1
26985	1598	40481087	1990-03-18	1990-03-25	1
85751	5107	81151	1981-12-02	1981-12-30	1
56712	3367	4001336	1971-03-22	1971-05-21	1
80127	4755	28060	1944-09-06	1944-09-16	1
85024	5063	372328	1947-03-04	1947-12-12	1
28415	1683	4027663	2002-07-14	2002-07-15	1
88866	5291	372328	1976-12-25	1977-03-27	1
25063	1496	40481087	1989-03-30	1989-04-13	1
22147	1322	4152936	1996-12-02	1996-12-23	1
85431	5083	81893	1982-12-03	1982-12-04	1
22388	1338	40481087	2019-03-03	2019-03-10	1
80816	4799	40481087	1971-03-09	1971-03-30	1
23388	1397	4112343	1990-04-27	1990-05-06	1
78295	4641	195588	1987-07-08	1987-08-25	1
23509	1407	4237458	1971-08-18	1971-09-17	1
10520	621	81151	1982-12-10	1982-12-31	1
88651	5276	40481087	1979-01-01	1979-01-22	1
2667	156	40481087	2008-09-01	2008-09-22	1
13378	788	40481087	2013-04-24	2013-05-08	1
20070	1211	40481087	1998-04-12	1998-05-03	1
59009	3505	28060	2000-02-08	2000-02-18	1
28552	1691	40481087	2000-10-14	2000-11-04	1
29958	1776	4112343	2019-05-17	2019-05-24	1
79689	4724	40481087	1952-11-14	1952-11-28	1
26122	1551	4113008	2008-09-20	2008-10-11	1
53841	3189	40481087	1972-03-18	1972-04-01	1
20246	1219	260139	2013-10-08	2013-10-15	1
27129	1605	4152936	1948-01-27	1948-02-17	1
70258	4165	4112343	1958-02-25	1958-03-05	1
17816	1073	4266809	1974-04-02	1974-04-03	1
82223	4883	192671	1986-04-18	1986-04-19	1
83958	4991	372328	1971-09-08	1971-10-16	1
227	11	4112343	1980-12-27	1981-01-04	1
30135	1782	198809	1956-01-11	1956-01-11	1
79652	4722	40481087	2011-07-11	2011-08-01	1
59986	3558	4112343	1974-10-19	1974-10-31	1
78370	4644	372328	1968-01-26	1968-06-20	1
29090	1724	260139	2015-06-30	2015-07-14	1
83706	4977	40481087	1996-06-03	1996-06-24	1
21005	1261	134438	1989-05-18	1991-03-11	1
26709	1585	4112343	2011-06-23	2011-07-02	1
74773	4447	4155034	1975-01-17	1975-01-31	1
28903	1713	40481087	1976-05-20	1976-06-03	1
71844	4268	260139	1968-07-16	1968-07-30	1
23831	1426	4112343	1980-10-27	1980-11-03	1
73492	4374	4027663	2006-05-13	2006-05-14	1
76058	4520	78272	1938-10-13	1938-11-03	1
62905	3719	260139	1964-02-04	1964-02-11	1
74901	4452	260139	1987-07-15	1987-07-22	1
24081	1438	260139	1952-04-19	1952-05-03	1
2385	141	78272	2013-09-23	2013-10-21	1
1381	80	4112343	1947-12-16	1947-12-28	1
17740	1068	40481087	1997-11-24	1997-12-15	1
70937	4212	4294548	2008-03-15	2008-05-03	1
26986	1598	80180	2003-09-26	2003-09-27	1
85752	5107	260139	1997-10-05	1997-10-12	1
56713	3367	4059173	1976-02-24	1976-04-24	1
80128	4755	80180	1963-09-19	1963-09-20	1
85025	5063	4112343	1954-11-23	1954-12-02	1
28416	1683	4109685	2006-11-18	2006-12-02	1
88867	5291	4113008	2008-03-29	2008-04-12	1
28143	1662	257012	1999-05-06	1999-05-07	1
22148	1322	40481087	2017-04-12	2017-04-26	1
85432	5083	440086	1954-11-15	1965-11-22	1
22389	1338	4112343	1961-03-10	1961-03-17	1
80817	4799	40481087	1975-05-14	1975-05-28	1
23389	1397	4218389	2001-01-10	2001-01-31	1
78296	4641	378001	1990-04-13	1990-05-13	1
23510	1407	40481087	1979-09-15	1979-09-22	1
10521	621	257012	1929-04-11	1929-04-12	1
88652	5276	40481087	1988-10-10	1988-10-24	1
2668	156	40481087	2009-02-26	2009-03-05	1
13379	788	80180	2012-11-18	2012-11-19	1
20071	1211	40481087	2004-02-24	2004-03-09	1
59010	3505	80180	1975-11-13	1975-11-14	1
28553	1691	30753	1984-07-28	1984-07-29	1
29959	1776	4152936	1945-04-23	1945-05-14	1
79690	4724	40481087	1956-02-16	1956-03-01	1
26123	1551	40481087	1963-01-30	1963-02-13	1
53842	3189	40481087	1993-08-10	1993-08-24	1
20247	1219	4112343	1989-03-07	1989-03-20	1
27130	1605	4294548	1941-03-12	1941-05-28	1
70259	4165	4294548	1928-12-03	1928-12-31	1
17817	1073	4278672	1950-09-10	1950-10-10	1
82224	4883	260139	2006-03-11	2006-03-18	1
83959	4991	4112343	2005-07-08	2005-07-21	1
228	11	4134304	1966-08-24	1966-09-23	1
30136	1782	260139	2018-12-02	2018-12-16	1
82799	4923	28060	1969-01-10	1969-01-20	1
59987	3558	40481087	1984-05-18	1984-06-08	1
78371	4644	378001	1971-02-18	1971-04-19	1
29091	1724	372328	1954-11-15	1955-08-29	1
83707	4977	40481087	2001-12-16	2001-12-30	1
21006	1261	260139	1973-01-01	1973-01-08	1
26710	1585	4283893	1963-10-21	1963-11-25	1
74774	4447	4218389	2008-09-04	2008-09-25	1
28904	1713	40481087	1983-03-16	1983-03-30	1
71845	4268	260139	1971-01-30	1971-02-13	1
23832	1426	4113008	1984-07-19	1984-08-09	1
73493	4374	4048171	1979-05-27	1995-05-25	1
76059	4520	80180	1962-05-15	1962-05-16	1
62906	3719	4142905	2004-06-04	2004-09-02	1
74902	4452	4112343	1962-07-29	1962-08-10	1
24082	1438	260139	2017-04-29	2017-05-13	1
2386	141	4112343	1991-01-26	1991-02-02	1
1382	80	40481087	1945-03-19	1945-04-02	1
19973	1206	80180	1999-10-19	1999-10-20	1
70938	4212	28060	1977-01-23	1977-02-01	1
26987	1598	81151	1989-03-22	1989-04-05	1
85753	5107	372328	1980-07-10	1981-05-23	1
56714	3367	40481087	1969-10-02	1969-10-23	1
80129	4755	192671	1963-11-29	1963-11-30	1
85026	5063	4112343	1997-06-30	1997-07-08	1
28417	1683	4112343	1978-10-17	1978-10-27	1
88868	5291	40481087	1997-09-17	1997-09-24	1
28144	1662	40481087	1978-04-29	1978-05-06	1
22149	1322	40481087	2018-07-25	2018-08-15	1
85433	5083	4156265	2011-06-08	2011-06-22	1
22390	1338	4112343	1999-01-26	1999-02-06	1
80818	4799	260139	2010-01-16	2010-01-30	1
23390	1397	133834	1977-08-23	1994-05-26	1
78297	4641	4112343	1997-04-15	1997-04-28	1
23511	1407	81151	1975-04-29	1975-05-27	1
10522	621	313217	2015-03-18	2015-03-19	1
2293	135	30753	2009-03-02	2009-03-03	1
2669	156	372328	1980-02-14	1980-03-30	1
13380	788	372328	1973-04-06	1973-08-15	1
20072	1211	0	1971-10-23	1971-10-24	1
59011	3505	260139	2018-04-28	2018-05-12	1
28554	1691	80180	1985-07-23	1985-07-24	1
29960	1776	4156265	1997-12-07	1997-12-28	1
80271	4760	28060	1968-02-28	1968-03-07	1
27982	1657	4035415	1953-04-24	1953-06-23	1
53843	3189	40481087	2006-02-25	2006-03-11	1
20248	1219	40481087	1954-08-18	1954-09-01	1
27131	1605	40481087	1970-03-16	1970-04-06	1
70260	4165	40481087	1994-07-26	1994-08-16	1
17818	1073	40481087	1944-11-25	1944-12-16	1
82225	4883	381316	1967-04-07	1967-04-08	1
83960	4991	4283893	1983-10-14	1984-02-17	1
229	11	4283893	2019-04-21	2019-04-22	1
30137	1782	372328	1954-04-19	1954-05-03	1
82800	4923	260139	1977-04-15	1977-04-29	1
59988	3558	28060	2010-02-06	2010-02-16	1
78372	4644	4027663	1992-06-27	1992-06-28	1
29092	1724	4112343	1984-05-07	1984-05-19	1
83708	4977	372328	1964-06-14	1964-08-15	1
21007	1261	40481087	2005-06-10	2005-06-17	1
26711	1585	4294548	2012-06-09	2012-07-21	1
74775	4447	28060	1959-02-24	1959-03-08	1
28905	1713	40481087	1990-12-17	1991-01-07	1
71846	4268	372328	1959-01-24	1959-02-16	1
23833	1426	40481087	1990-06-03	1990-06-10	1
73494	4374	4112343	1982-08-21	1982-08-30	1
76060	4520	260139	1948-10-16	1948-10-30	1
62907	3719	40481087	1968-11-03	1968-11-24	1
74903	4452	4142905	1995-02-06	1995-04-07	1
24083	1438	4112343	1965-09-22	1965-10-04	1
2387	141	40481087	2010-12-03	2010-12-17	1
1383	80	40481087	1946-10-31	1946-11-21	1
19974	1206	372328	1965-07-17	1966-01-17	1
70939	4212	260139	2014-12-18	2015-01-01	1
26988	1598	260139	1995-08-15	1995-08-22	1
85754	5107	192671	2011-07-09	2011-07-10	1
56715	3367	81151	1994-06-17	1994-07-22	1
80130	4755	260139	1932-12-04	1932-12-18	1
85027	5063	4116491	1964-03-29	1964-05-14	1
28418	1683	4134304	1985-11-03	1986-02-01	1
88869	5291	260139	1979-10-29	1979-11-12	1
28145	1662	40481087	1988-11-14	1988-11-28	1
24741	1478	80180	2001-12-26	2001-12-27	1
85434	5083	4218389	1992-08-20	1992-09-24	1
22391	1338	4237458	2019-03-23	2019-06-21	1
80819	4799	372328	1958-04-15	1958-07-26	1
23391	1397	4156265	1998-01-12	1998-01-26	1
78298	4641	4112343	1999-02-18	1999-02-25	1
23512	1407	81151	1986-06-28	1986-07-19	1
10523	621	4112343	1919-05-05	1919-05-13	1
2294	135	80180	2009-11-27	2009-11-28	1
2670	156	4283893	1990-12-10	1991-01-28	1
13381	788	4109685	2015-08-01	2015-08-22	1
20073	1211	4116491	2007-10-12	2007-12-11	1
59012	3505	372328	1942-12-06	1943-12-24	1
28555	1691	4027663	1978-07-05	1978-07-06	1
29961	1776	40481087	1920-09-13	1920-09-27	1
80272	4760	28060	1979-07-08	1979-07-19	1
27983	1657	4218389	1966-02-15	1966-03-22	1
55840	3311	28060	2011-09-12	2011-09-20	1
20249	1219	40481087	1973-01-18	1973-02-08	1
27132	1605	40481087	1975-05-15	1975-06-05	1
70261	4165	40481087	1997-08-05	1997-08-19	1
17819	1073	40481087	1962-09-16	1962-09-23	1
82226	4883	4109685	1947-12-11	1948-01-01	1
83961	4991	40481087	1988-10-01	1988-10-15	1
230	11	40481087	1964-03-16	1964-03-23	1
30138	1782	372328	1954-08-01	1954-11-02	1
82801	4923	4278672	1997-03-08	1997-04-07	1
59989	3558	81151	1964-01-01	1964-01-15	1
78373	4644	317576	1990-11-22	1990-11-23	1
29093	1724	4155034	1987-06-21	1987-07-05	1
83709	4977	4112343	1971-07-31	1971-08-13	1
21008	1261	260139	1989-03-29	1989-04-12	1
26712	1585	40481087	1931-04-07	1931-04-28	1
74776	4447	260139	1998-06-03	1998-06-17	1
30625	1812	4112343	2018-01-21	2018-02-03	1
71847	4268	4059173	1961-06-12	1961-07-12	1
23834	1426	40481087	2014-09-03	2014-09-24	1
73495	4374	4112343	1993-12-23	1994-01-02	1
76061	4520	372328	1929-04-28	1929-09-14	1
62908	3719	40481087	1972-01-14	1972-01-28	1
74904	4452	40481087	2003-02-13	2003-02-20	1
24084	1438	40481087	1966-05-12	1966-05-19	1
2388	141	257012	2018-09-25	2018-09-26	1
1384	80	40481087	1955-04-18	1955-05-09	1
19975	1206	4156265	1990-01-24	1990-02-07	1
70940	4212	4112343	1982-09-05	1982-09-15	1
26989	1598	4112343	2017-07-17	2017-07-26	1
85755	5107	260139	1984-05-21	1984-06-04	1
56716	3367	81151	2015-05-01	2015-05-22	1
80131	4755	4116491	1981-10-24	1981-11-25	1
85028	5063	40481087	1970-02-25	1970-03-04	1
28419	1683	40481087	1973-02-18	1973-02-25	1
88870	5291	372328	1976-07-15	1976-09-26	1
28146	1662	40481087	2013-07-18	2013-07-25	1
24742	1478	195588	1990-03-14	1990-04-17	1
1165	69	260139	1975-02-28	1975-03-14	1
22392	1338	40481087	1983-08-14	1983-09-04	1
80820	4799	378001	1971-01-21	1971-03-22	1
23392	1397	40481087	2006-03-26	2006-04-02	1
78299	4641	40481087	1999-12-12	2000-01-02	1
23513	1407	4218389	1970-10-01	1970-10-22	1
10524	621	4112343	1945-05-29	1945-06-09	1
2295	135	260139	2016-05-15	2016-05-22	1
2671	156	40481087	2013-04-22	2013-05-13	1
13382	788	4112343	2007-02-22	2007-03-02	1
20074	1211	40481087	1994-03-06	1994-03-27	1
59013	3505	4112343	1937-09-04	1937-09-16	1
28556	1691	4112343	1960-02-06	1960-02-16	1
29962	1776	40481087	1934-12-11	1934-12-18	1
80273	4760	260139	1971-07-11	1971-07-25	1
27984	1657	4218389	1975-08-02	1975-08-30	1
55841	3311	4112343	1968-11-15	1968-11-25	1
20250	1219	40481087	1995-09-01	1995-09-22	1
27133	1605	40481087	2003-09-10	2003-10-01	1
72601	4319	78272	1986-04-15	1986-05-20	1
17820	1073	80180	1974-04-02	1974-04-03	1
82227	4883	4112343	1986-12-16	1986-12-23	1
83962	4991	40481087	2004-12-23	2004-12-30	1
231	11	40481087	1987-09-24	1987-10-01	1
30139	1782	4112343	2008-11-11	2008-11-20	1
82802	4923	40481087	1997-09-19	1997-10-03	1
59990	3558	258780	2015-05-02	2015-05-03	1
78374	4644	40481087	1993-03-29	1993-04-05	1
29094	1724	4283893	1967-10-23	1967-11-27	1
83710	4977	4112343	1987-11-04	1987-11-15	1
21009	1261	372328	1973-09-27	1973-12-08	1
26713	1585	40481087	1942-05-28	1942-06-04	1
74777	4447	4283893	1972-03-27	1972-05-08	1
30626	1812	40481087	1968-04-21	1968-05-05	1
71848	4268	40479422	1970-04-26	1970-07-02	1
23835	1426	81151	1954-12-26	1955-01-23	1
73496	4374	4112343	1995-05-01	1995-05-09	1
76062	4520	372328	1930-11-08	1931-03-14	1
62909	3719	30753	2002-07-22	2002-07-23	1
75580	4488	260139	1986-12-07	1986-12-14	1
24085	1438	40481087	1982-01-01	1982-01-15	1
2389	141	372328	1987-10-31	1988-09-27	1
1385	80	40481087	2010-03-20	2010-04-10	1
19976	1206	4294548	2002-02-26	2002-04-23	1
70941	4212	4112343	2015-06-26	2015-07-09	1
26990	1598	40481087	1987-11-17	1987-11-24	1
85756	5107	4112343	1994-06-29	1994-07-10	1
56717	3367	260139	1965-12-19	1966-01-02	1
80132	4755	4156265	1933-01-24	1933-02-14	1
85029	5063	40481087	1972-06-28	1972-07-12	1
28420	1683	40481087	1990-11-29	1990-12-13	1
88871	5291	372328	1981-03-06	1981-11-15	1
28147	1662	372328	1964-07-11	1964-08-21	1
24743	1478	260139	1980-07-26	1980-08-02	1
1166	69	4109685	1949-05-28	1949-06-18	1
22393	1338	40481087	1998-01-25	1998-02-08	1
80821	4799	4112343	1970-02-14	1970-02-21	1
23393	1397	40481087	2018-02-08	2018-02-15	1
78300	4641	378001	1992-05-02	1992-07-01	1
23514	1407	40481087	2009-11-13	2009-11-20	1
10525	621	4112343	1947-06-30	1947-07-10	1
2296	135	4027663	2000-06-07	2000-06-08	1
2672	156	260139	1982-07-05	1982-07-12	1
13383	788	4112343	2009-03-23	2009-04-01	1
20075	1211	40481087	2000-02-29	2000-03-07	1
59014	3505	4155034	1993-02-16	1993-03-09	1
28557	1691	40481087	2014-10-28	2014-11-11	1
29963	1776	40481087	1967-04-04	1967-04-18	1
80274	4760	4059173	1964-07-13	1964-08-12	1
27985	1657	40481087	2016-12-16	2016-12-23	1
55842	3311	4155034	1965-11-13	1965-12-04	1
20251	1219	378419	2014-01-13	2014-01-14	1
27134	1605	40481087	2004-08-04	2004-08-11	1
72602	4319	4001336	2018-05-07	2018-07-06	1
17821	1073	80502	1996-08-29	1996-08-30	1
82228	4883	4112343	1993-08-19	1993-08-29	1
83963	4991	257012	1983-12-16	1983-12-17	1
232	11	40481087	1994-07-31	1994-08-14	1
30140	1782	4152936	2009-11-17	2009-12-01	1
82803	4923	80180	2000-05-23	2000-05-24	1
59991	3558	372328	1961-01-16	1961-03-04	1
78375	4644	40481087	2000-08-17	2000-09-07	1
29095	1724	40481087	1954-05-28	1954-06-04	1
83711	4977	4112343	1999-12-06	1999-12-17	1
21010	1261	4112343	1987-05-31	1987-06-07	1
26714	1585	40481087	2009-12-24	2010-01-14	1
74778	4447	257012	1972-04-24	1972-04-25	1
30627	1812	40481087	1984-05-18	1984-05-25	1
71849	4268	40481087	1957-07-12	1957-08-02	1
23836	1426	4112343	1955-11-04	1955-11-12	1
73497	4374	40481087	2013-11-16	2013-11-23	1
76063	4520	4109685	1935-10-24	1935-11-07	1
62910	3719	378001	1974-05-10	1974-06-09	1
75581	4488	4112343	2009-08-24	2009-08-31	1
24086	1438	260139	1965-09-07	1965-09-14	1
2390	141	4001336	1985-03-24	1985-05-23	1
3219	188	30753	1998-08-01	1998-08-02	1
19977	1206	40481087	1965-12-19	1966-01-02	1
70942	4212	260139	1983-10-20	1983-10-27	1
27208	1608	28060	1943-08-05	1943-08-14	1
85757	5107	4112343	2015-10-30	2015-11-09	1
56718	3367	40481087	1964-11-29	1964-12-20	1
80133	4755	40481087	1967-04-14	1967-04-28	1
85030	5063	40481087	2012-06-13	2012-07-04	1
28421	1683	372328	1977-05-10	1977-07-07	1
88872	5291	378001	2001-08-03	2001-09-02	1
28148	1662	4112343	1999-02-12	1999-02-24	1
24744	1478	260139	2012-08-14	2012-08-21	1
1167	69	4112343	1948-04-06	1948-04-18	1
22394	1338	40481087	2002-02-24	2002-03-10	1
80822	4799	4116491	1986-11-09	1986-12-21	1
23394	1397	40481087	2019-02-15	2019-03-01	1
78301	4641	4294548	2013-04-28	2013-05-12	1
23515	1407	40481087	2017-04-20	2017-04-27	1
10526	621	40481087	1942-05-06	1942-05-13	1
2297	135	4112343	1973-07-07	1973-07-15	1
2673	156	4112343	2000-05-09	2000-05-16	1
13384	788	40481087	1971-06-08	1971-06-29	1
20076	1211	80180	2004-12-31	2005-01-01	1
59015	3505	4237458	2009-08-12	2009-11-10	1
28558	1691	28060	1951-01-11	1951-01-24	1
29964	1776	40481087	1980-06-17	1980-06-24	1
80275	4760	4112343	2013-03-28	2013-04-07	1
27986	1657	260139	1994-02-20	1994-02-27	1
55843	3311	40481087	2013-08-29	2013-09-05	1
20252	1219	40481087	1981-05-26	1981-06-16	1
27135	1605	81151	1984-03-23	1984-04-27	1
72603	4319	4112343	2019-06-02	2019-06-12	1
17822	1073	81893	1972-01-13	1972-01-14	1
82229	4883	4218389	1951-07-14	1951-08-18	1
83964	4991	4116491	2007-07-01	2007-08-21	1
233	11	78272	1989-09-22	1989-10-13	1
30141	1782	40481087	1997-10-22	1997-10-29	1
82804	4923	81151	1984-07-16	1984-08-13	1
59992	3558	4001336	1993-04-12	1993-05-12	1
78376	4644	80180	2001-02-10	2001-02-11	1
29096	1724	40481087	1972-09-06	1972-09-27	1
83712	4977	4112343	2004-11-06	2004-11-19	1
21011	1261	40481087	1971-05-19	1971-06-02	1
26715	1585	40481087	2015-05-14	2015-06-04	1
74779	4447	260139	1988-05-10	1988-05-24	1
30628	1812	40481087	2011-04-10	2011-04-17	1
71850	4268	4155034	1980-01-25	1980-02-08	1
23837	1426	4112343	2000-01-26	2000-02-04	1
73498	4374	40481087	2016-10-03	2016-10-24	1
76064	4520	4218389	1985-02-13	1985-03-06	1
62911	3719	4278672	1968-11-07	1968-12-07	1
75582	4488	4142905	1982-09-27	1982-12-26	1
24087	1438	260139	1965-12-15	1965-12-29	1
2391	141	4132546	1985-03-24	1985-03-25	1
3220	188	81151	2011-10-30	2011-11-20	1
19978	1206	40481087	1969-11-20	1969-12-11	1
70943	4212	4112343	1992-10-26	1992-11-07	1
27209	1608	80180	1977-06-25	1977-06-26	1
85758	5107	40481087	2015-05-04	2015-05-25	1
56719	3367	40481087	1984-11-08	1984-11-29	1
80134	4755	40481087	1973-08-30	1973-09-13	1
85031	5063	28060	2000-05-25	2000-06-02	1
28422	1683	375671	2014-08-22	2014-09-21	1
88873	5291	4001336	2010-11-28	2011-01-27	1
28149	1662	4112343	2004-08-27	2004-09-03	1
24745	1478	4112343	1994-01-08	1994-01-16	1
1168	69	4112343	2019-01-30	2019-02-06	1
22395	1338	40481087	2015-10-23	2015-11-13	1
80823	4799	40481087	1961-12-19	1961-12-26	1
23395	1397	80180	2016-08-26	2016-08-27	1
78302	4641	40481087	1969-11-05	1969-11-19	1
23516	1407	260139	1999-09-26	1999-10-03	1
10527	621	40481087	1997-03-28	1997-04-04	1
2298	135	4237458	1988-12-10	1989-03-10	1
2674	156	40481087	2003-09-01	2003-09-22	1
14664	866	4112343	1966-05-08	1966-05-19	1
20077	1211	372328	1969-03-25	1969-10-08	1
59016	3505	4266809	1975-11-13	1975-11-14	1
28559	1691	28060	1951-07-27	1951-08-08	1
29965	1776	40481087	1988-01-20	1988-01-27	1
80276	4760	4112343	2014-09-03	2014-09-16	1
27987	1657	4112343	1949-04-02	1949-04-13	1
55844	3311	260139	2012-01-07	2012-01-21	1
23123	1382	372328	1979-07-16	1979-10-03	1
27136	1605	257012	2001-01-03	2001-01-04	1
72604	4319	4134304	2014-05-28	2014-07-27	1
17823	1073	4152936	1953-10-24	1953-11-07	1
82230	4883	40481087	1950-09-04	1950-09-18	1
83965	4991	40481087	1972-11-09	1972-11-16	1
234	11	260139	1966-10-25	1966-11-08	1
30142	1782	28060	2003-09-17	2003-09-24	1
82805	4923	260139	1974-03-13	1974-03-27	1
59993	3558	4112343	2009-11-22	2009-12-04	1
78377	4644	260139	1964-03-27	1964-04-10	1
29097	1724	40481087	1979-11-25	1979-12-02	1
83713	4977	80180	1997-11-23	1997-11-24	1
21012	1261	40481087	2011-06-24	2011-07-01	1
26716	1585	372328	1931-01-01	1931-07-05	1
74780	4447	260139	2015-01-05	2015-01-12	1
30629	1812	40481087	2014-09-01	2014-09-08	1
71851	4268	4218389	2016-12-07	2016-12-28	1
23838	1426	40481087	1992-10-02	1992-10-16	1
73499	4374	4112343	1986-08-22	1986-08-29	1
76065	4520	4218389	1987-03-26	1987-04-23	1
62912	3719	4283893	1968-01-08	1968-04-01	1
75583	4488	4155034	1992-08-26	1992-09-09	1
24088	1438	4155034	1975-04-17	1975-05-01	1
2392	141	4142905	1995-07-30	1995-09-28	1
3221	188	81893	1998-05-03	1998-05-04	1
19979	1206	81893	1998-06-26	1998-06-27	1
70944	4212	40481087	1972-05-27	1972-06-17	1
27210	1608	260139	2013-05-07	2013-05-21	1
86585	5157	372328	1965-02-11	1965-03-18	1
56720	3367	40481087	2004-12-19	2005-01-02	1
80135	4755	40481087	2016-05-21	2016-06-04	1
85032	5063	260139	1985-08-11	1985-08-18	1
28423	1683	4112343	1983-11-04	1983-11-13	1
88874	5291	40481087	1987-05-28	1987-06-04	1
28150	1662	4112343	2017-11-27	2017-12-10	1
24746	1478	4294548	1998-04-14	1998-04-28	1
1169	69	40481087	1957-12-01	1957-12-08	1
22396	1338	28060	1959-02-03	1959-02-15	1
80824	4799	40481087	1966-07-17	1966-07-24	1
23396	1397	257012	2013-07-19	2013-07-20	1
78303	4641	40481087	1979-10-03	1979-10-10	1
23517	1407	4155034	1992-12-14	1992-12-28	1
10528	621	40481087	2002-02-04	2002-02-11	1
2299	135	4266809	2009-11-27	2009-11-28	1
5694	335	257012	1966-02-14	1966-02-15	1
14665	866	4112343	1979-09-19	1979-09-29	1
20078	1211	440448	1971-10-23	1971-10-24	1
59017	3505	40481087	1975-10-01	1975-10-15	1
28560	1691	81893	1983-12-01	1983-12-02	1
29966	1776	40481087	1991-08-16	1991-08-30	1
80277	4760	4152936	2012-11-28	2012-12-19	1
27988	1657	4112343	1951-12-01	1951-12-09	1
55845	3311	4152936	1974-07-20	1974-08-03	1
23124	1382	372328	1982-04-20	1983-04-13	1
27137	1605	260139	2011-05-22	2011-06-05	1
72605	4319	4059173	1995-10-30	1996-01-28	1
17824	1073	4218389	1964-10-10	1964-11-14	1
82231	4883	40481087	2011-07-16	2011-07-30	1
83966	4991	40481087	1995-04-20	1995-04-27	1
235	11	260139	2008-02-20	2008-03-05	1
30143	1782	78272	1973-01-09	1973-01-30	1
82806	4923	4237458	1977-01-24	1977-03-25	1
59994	3558	40481087	2004-05-01	2004-05-22	1
78378	4644	372328	1965-03-08	1965-06-10	1
29098	1724	80180	1992-11-15	1992-11-16	1
83714	4977	257012	1976-02-19	1976-02-20	1
22587	1352	28060	1951-09-21	1951-10-01	1
26717	1585	372328	1987-04-12	1988-03-06	1
74781	4447	372328	1953-07-11	1953-07-25	1
30630	1812	260139	1984-06-12	1984-06-19	1
71852	4268	40481087	1978-09-16	1978-10-07	1
23839	1426	4112343	1970-07-09	1970-07-21	1
73500	4374	4112343	2001-10-05	2001-10-15	1
76066	4520	40481087	1946-11-02	1946-11-16	1
62913	3719	40481087	1964-02-09	1964-02-23	1
75584	4488	40481087	1987-10-29	1987-11-12	1
24089	1438	40481087	1954-09-10	1954-09-17	1
2393	141	4294548	2018-09-11	2019-01-15	1
3222	188	192671	2000-02-09	2000-02-10	1
19980	1206	260139	1979-11-19	1979-11-26	1
70945	4212	40481087	1991-06-20	1991-07-04	1
27211	1608	372328	1943-08-03	1944-02-12	1
86586	5157	40481087	2002-05-07	2002-05-21	1
56721	3367	28060	2015-10-13	2015-10-25	1
80136	4755	260139	1925-06-06	1925-06-20	1
85033	5063	260139	1999-06-08	1999-06-22	1
28424	1683	4112343	1987-11-25	1987-12-06	1
88875	5291	40481087	2007-04-12	2007-04-19	1
28151	1662	40481087	1974-05-28	1974-06-11	1
24747	1478	40481087	1966-07-11	1966-08-01	1
1170	69	40481087	1981-05-02	1981-05-16	1
22397	1338	80180	1978-08-09	1978-08-10	1
80825	4799	40481087	1984-07-16	1984-07-23	1
23397	1397	260139	1989-02-15	1989-03-01	1
78304	4641	40481087	2006-08-07	2006-08-28	1
23518	1407	4237458	1989-03-05	1989-04-04	1
10529	621	28060	1926-02-09	1926-02-17	1
2300	135	4310024	2008-09-03	2008-09-04	1
5695	335	78272	1973-03-27	1973-04-10	1
14666	866	40481087	1981-11-19	1981-12-03	1
20079	1211	4048171	1967-10-29	1967-10-30	1
59018	3505	40481087	1982-06-18	1982-07-02	1
28561	1691	4059173	1977-06-25	1977-08-24	1
29967	1776	40481087	1991-12-07	1991-12-14	1
80278	4760	40481087	1994-08-31	1994-09-14	1
27989	1657	4112343	1977-10-12	1977-10-23	1
55846	3311	40481087	1970-08-10	1970-08-24	1
23125	1382	4112343	1997-01-25	1997-02-06	1
27138	1605	321042	2019-05-12	2019-05-13	1
72606	4319	4132546	2018-05-07	2018-05-08	1
17825	1073	4285898	1973-10-04	1973-10-05	1
82232	4883	28060	1954-01-12	1954-01-21	1
83967	4991	80180	2006-04-12	2006-04-13	1
236	11	4112343	1971-08-08	1971-08-16	1
30144	1782	4059173	1961-09-09	1961-12-08	1
82807	4923	4266809	2000-05-23	2000-05-24	1
61503	3638	28060	1999-10-29	1999-11-10	1
78379	4644	4296204	1985-12-01	1986-01-05	1
29099	1724	81151	1957-03-02	1957-03-30	1
83715	4977	260139	1963-02-01	1963-02-15	1
22588	1352	28060	1972-07-13	1972-07-21	1
26718	1585	4112343	1973-02-25	1973-03-04	1
74782	4447	4051466	1953-08-27	1970-11-28	1
30631	1812	4112343	2018-05-08	2018-05-18	1
71853	4268	40481087	1993-12-17	1993-12-31	1
23840	1426	4112343	2006-09-01	2006-09-14	1
73501	4374	4113008	1986-03-29	1986-04-19	1
76067	4520	81151	1945-10-27	1945-11-10	1
62914	3719	40481087	1976-08-11	1976-08-18	1
75585	4488	40481087	1994-01-16	1994-02-06	1
24090	1438	40481087	1983-05-19	1983-05-26	1
2394	141	40481087	1990-03-05	1990-03-26	1
3223	188	372328	1968-08-18	1968-11-03	1
19981	1206	260139	1993-11-12	1993-11-26	1
70946	4212	40481087	2013-02-11	2013-03-04	1
27212	1608	4112343	1949-09-14	1949-09-26	1
86587	5157	0	1985-04-06	1985-04-07	1
56722	3367	80180	2002-10-10	2002-10-11	1
80137	4755	260139	2011-12-15	2011-12-22	1
85034	5063	378001	1942-02-28	1942-04-29	1
28425	1683	4283893	1981-12-18	1982-02-05	1
88876	5291	260139	1992-09-09	1992-09-16	1
28152	1662	40481087	1996-08-24	1996-09-07	1
24748	1478	40481087	1985-03-31	1985-04-14	1
1171	69	40481087	1981-09-20	1981-10-11	1
22398	1338	81151	2007-11-30	2007-12-21	1
80826	4799	40481087	1998-08-06	1998-08-20	1
23398	1397	260139	2008-12-18	2008-12-25	1
80747	4795	372328	2011-10-09	2011-11-23	1
23519	1407	40481087	1987-03-22	1987-04-12	1
10530	621	28060	1926-04-21	1926-04-29	1
2301	135	40481087	1997-06-28	1997-07-19	1
5696	335	80180	2003-04-29	2003-04-30	1
14667	866	40481087	1988-09-04	1988-09-11	1
20080	1211	4109685	1980-10-07	1980-10-21	1
59019	3505	40486433	1939-02-12	1956-02-10	1
28562	1691	4112343	1972-05-16	1972-05-24	1
29968	1776	4112343	1983-03-18	1983-03-30	1
80279	4760	40481087	2018-05-06	2018-05-20	1
27990	1657	4112343	1984-03-21	1984-03-29	1
55847	3311	40481087	1977-12-24	1977-12-31	1
23126	1382	4142905	1994-08-26	1994-10-25	1
27139	1605	372328	1938-04-04	1938-06-05	1
72607	4319	81151	2013-04-19	2013-05-03	1
17826	1073	40480160	2017-02-14	2017-04-15	1
82233	4883	260139	1987-05-17	1987-05-24	1
83968	4991	81151	1992-09-08	1992-10-13	1
237	11	4134304	1998-04-02	1998-07-01	1
30145	1782	4112343	1970-03-13	1970-03-26	1
82808	4923	40481087	1984-12-18	1985-01-01	1
61504	3638	260139	2014-07-27	2014-08-10	1
78380	4644	40481087	1968-12-09	1968-12-30	1
29100	1724	260139	1950-05-12	1950-05-19	1
83716	4977	372328	1962-03-07	1962-05-26	1
22589	1352	78272	1970-07-29	1970-08-26	1
26719	1585	4152936	1960-11-17	1960-12-01	1
74783	4447	4146173	1967-11-25	1968-01-24	1
30632	1812	28060	1971-03-04	1971-03-13	1
78612	4661	4112343	2008-02-23	2008-03-05	1
23841	1426	4278672	2007-10-08	2008-01-06	1
73502	4374	40481087	1993-09-12	1993-10-03	1
76068	4520	260139	1972-01-13	1972-01-20	1
62915	3719	40481087	1983-05-20	1983-06-03	1
75586	4488	80180	2018-02-10	2018-02-11	1
24091	1438	40481087	1983-11-27	1983-12-18	1
2395	141	40481087	1994-07-10	1994-07-31	1
3224	188	4112343	2011-02-09	2011-02-20	1
19982	1206	260139	1998-07-19	1998-07-26	1
70947	4212	257012	2008-04-19	2008-04-20	1
27213	1608	4112343	1987-05-06	1987-05-16	1
86588	5157	260139	1980-08-10	1980-08-24	1
56723	3367	260139	1992-04-23	1992-04-30	1
80138	4755	378001	1976-08-11	1976-10-10	1
85035	5063	4112343	1973-01-27	1973-02-05	1
28426	1683	378001	2003-03-09	2003-05-08	1
88877	5291	40481087	1990-07-27	1990-08-17	1
28153	1662	80180	1999-05-24	1999-05-25	1
24749	1478	40481087	1999-03-31	1999-04-21	1
1172	69	40481087	1986-10-21	1986-11-11	1
22399	1338	195588	1974-09-29	1974-11-14	1
82329	4890	81151	1927-01-11	1927-02-01	1
23399	1397	4112343	1977-02-21	1977-03-04	1
80748	4795	4116491	1995-10-27	1995-12-23	1
23520	1407	40481087	1999-06-27	1999-07-04	1
10531	621	381316	1995-11-29	1995-11-30	1
2302	135	260139	2017-11-14	2017-11-21	1
5697	335	260139	1978-04-23	1978-04-30	1
14668	866	40481087	1989-02-14	1989-03-07	1
20081	1211	40481087	1975-02-28	1975-03-14	1
59020	3505	260139	1946-02-20	1946-02-27	1
28563	1691	4112343	1977-07-31	1977-08-11	1
29969	1776	40479768	2018-04-17	2018-05-24	1
80280	4760	28060	1955-03-27	1955-04-05	1
27991	1657	4112343	2010-08-20	2010-08-28	1
55848	3311	40481087	1986-09-21	1986-10-12	1
23127	1382	260139	2003-08-04	2003-08-11	1
27140	1605	381316	2006-09-17	2006-09-18	1
72608	4319	260139	2009-04-04	2009-04-11	1
17827	1073	40481087	1942-11-20	1942-11-27	1
82234	4883	4112343	1955-03-19	1955-03-30	1
83969	4991	134438	1997-07-10	1998-04-09	1
238	11	4218389	1994-05-20	1994-06-24	1
30146	1782	40481087	1993-12-26	1994-01-02	1
82809	4923	260139	1979-05-08	1979-05-22	1
61505	3638	4112343	1966-07-17	1966-07-28	1
78381	4644	260139	1970-03-14	1970-03-21	1
29101	1724	260139	1958-06-08	1958-06-22	1
83717	4977	4112343	1970-04-29	1970-05-06	1
22590	1352	198809	1976-07-29	1976-07-29	1
26720	1585	4296205	1959-12-09	1959-12-23	1
74784	4447	4218389	2012-10-04	2012-10-25	1
30633	1812	80180	2003-10-04	2003-10-05	1
78613	4661	40481087	2015-03-05	2015-03-26	1
23842	1426	40481087	1975-07-27	1975-08-17	1
73503	4374	40481087	2015-03-24	2015-04-07	1
76069	4520	4113008	1937-08-28	1937-09-18	1
64619	3825	260139	1958-08-15	1958-08-29	1
75587	4488	257012	1978-05-18	1978-05-19	1
24092	1438	40481087	2004-12-06	2004-12-20	1
2396	141	260139	1987-03-16	1987-03-30	1
3225	188	40481087	1999-05-26	1999-06-09	1
19983	1206	260139	2011-03-11	2011-03-18	1
70948	4212	260139	1995-01-28	1995-02-11	1
27214	1608	4112343	2014-10-08	2014-10-16	1
86589	5157	313217	2019-05-16	2019-05-17	1
56724	3367	260139	2009-10-06	2009-10-13	1
80139	4755	440448	1933-11-06	1933-11-07	1
85036	5063	4134304	2019-02-08	2019-03-10	1
28427	1683	4237458	2012-10-01	2012-11-30	1
88878	5291	260139	1996-08-01	1996-08-15	1
28154	1662	260139	1969-11-14	1969-11-28	1
24750	1478	40481087	1999-12-23	2000-01-06	1
1173	69	40481087	1999-09-22	1999-10-06	1
22400	1338	372328	1947-04-19	1947-09-11	1
82330	4890	134438	1946-11-19	1947-11-18	1
23400	1397	4112343	2002-07-18	2002-07-30	1
80749	4795	4218389	2003-03-24	2003-04-14	1
23521	1407	28060	2012-10-02	2012-10-15	1
10532	621	4112343	1973-08-19	1973-08-29	1
2303	135	4218389	2001-01-06	2001-02-03	1
5698	335	260139	2005-12-15	2005-12-22	1
14669	866	28060	1966-08-18	1966-08-27	1
20082	1211	28060	1978-01-22	1978-01-29	1
59021	3505	4027663	1967-01-29	1967-01-30	1
28564	1691	4155034	2014-12-08	2014-12-29	1
29970	1776	40481087	1964-01-22	1964-02-12	1
80281	4760	80180	1995-03-06	1995-03-07	1
27992	1657	4237458	2013-01-12	2013-04-12	1
55849	3311	28060	2015-10-02	2015-10-12	1
23128	1382	4112343	2007-08-17	2007-08-29	1
27141	1605	4112343	2007-08-10	2007-08-23	1
72609	4319	4155034	1997-12-18	1998-01-08	1
17828	1073	40481087	1995-12-21	1996-01-11	1
82235	4883	40481087	2019-03-29	2019-04-05	1
83970	4991	260139	1976-04-16	1976-04-23	1
239	11	4218389	1996-04-14	1996-05-12	1
30147	1782	260139	1955-08-13	1955-08-27	1
82810	4923	260139	1980-11-18	1980-11-25	1
61506	3638	40481087	1997-11-12	1997-11-19	1
78382	4644	372328	1963-12-27	1964-06-11	1
29102	1724	4112343	1997-03-15	1997-03-22	1
83718	4977	4112343	2000-03-18	2000-03-30	1
22591	1352	260139	1946-09-05	1946-09-19	1
26721	1585	40481087	1952-08-21	1952-08-28	1
74785	4447	4278672	1989-06-16	1989-09-14	1
30634	1812	260139	1973-01-21	1973-02-04	1
78614	4661	81151	1983-06-10	1983-06-24	1
23843	1426	40481087	1977-05-13	1977-06-03	1
73504	4374	260139	1976-08-20	1976-09-03	1
76070	4520	378001	1949-06-22	1949-07-22	1
64620	3825	4112343	1994-09-06	1994-09-18	1
75588	4488	4112343	1989-11-25	1989-12-04	1
24093	1438	28060	2009-01-13	2009-01-21	1
2397	141	372328	1987-01-13	1987-02-03	1
3226	188	260139	1988-10-22	1988-10-29	1
19984	1206	372328	1964-11-06	1965-01-18	1
70949	4212	4112343	1993-10-04	1993-10-15	1
27215	1608	4155034	1982-04-06	1982-04-20	1
86590	5157	4112343	1982-08-31	1982-09-10	1
56725	3367	4112343	1965-12-19	1965-12-27	1
80140	4755	4112343	1947-04-06	1947-04-19	1
85037	5063	40481087	1951-01-20	1951-02-10	1
28428	1683	4285898	2013-04-27	2013-04-28	1
88879	5291	260139	2002-01-02	2002-01-16	1
28155	1662	4294548	1999-03-04	1999-05-27	1
24751	1478	28060	1961-10-19	1961-10-30	1
1174	69	260139	2000-11-15	2000-11-22	1
22401	1338	4112343	1994-04-08	1994-04-20	1
82331	4890	260139	1976-04-09	1976-04-16	1
23989	1433	80180	1995-08-18	1995-08-19	1
80750	4795	81151	2001-02-27	2001-04-03	1
23522	1407	372328	1973-11-09	1974-11-02	1
10533	621	40481087	1918-07-30	1918-08-13	1
2304	135	40481087	1997-08-23	1997-09-06	1
5699	335	4109685	1990-07-01	1990-07-22	1
14670	866	78272	1970-11-10	1970-12-01	1
20083	1211	81151	2009-07-19	2009-08-02	1
59022	3505	4112343	1963-12-02	1963-12-15	1
28565	1691	40481087	1966-01-10	1966-01-31	1
29971	1776	28060	1921-08-06	1921-08-13	1
80282	4760	260139	1971-03-04	1971-03-11	1
27993	1657	40481087	1969-05-21	1969-06-11	1
55850	3311	80180	1995-07-05	1995-07-06	1
23129	1382	260139	1985-06-16	1985-06-30	1
27142	1605	4296204	1992-01-16	1992-02-13	1
72610	4319	80180	2012-07-21	2012-07-22	1
17829	1073	28060	1980-03-23	1980-04-02	1
82236	4883	260139	2004-08-23	2004-08-30	1
83971	4991	4109685	1973-03-31	1973-04-21	1
240	11	4278672	1987-10-03	1987-11-02	1
30148	1782	260139	1960-02-01	1960-02-08	1
82811	4923	372328	1970-01-01	1970-03-24	1
61507	3638	40481087	2002-03-25	2002-04-01	1
78383	4644	372328	1968-11-17	1969-06-26	1
29103	1724	4113008	1995-07-23	1995-08-06	1
83719	4977	4294548	1998-06-23	1998-07-28	1
22592	1352	260139	1959-08-12	1959-08-19	1
26722	1585	40481087	1999-12-07	1999-12-28	1
74786	4447	40481087	1969-09-24	1969-10-01	1
30635	1812	260139	1992-05-09	1992-05-23	1
78615	4661	192671	2018-04-27	2018-04-28	1
23844	1426	40481087	2001-04-29	2001-05-06	1
73505	4374	372328	1976-12-16	1977-02-03	1
76071	4520	4112343	1942-08-01	1942-08-14	1
64621	3825	4112343	1998-12-30	1999-01-10	1
75589	4488	4278672	2012-02-27	2012-05-27	1
24094	1438	260139	1992-05-18	1992-05-25	1
2398	141	378001	2016-08-06	2016-09-05	1
3227	188	260139	2012-04-08	2012-04-22	1
19985	1206	4112343	1995-05-02	1995-05-10	1
70950	4212	4134304	1984-01-14	1984-03-14	1
27216	1608	40481087	1947-08-25	1947-09-01	1
86591	5157	4112343	2007-01-14	2007-01-26	1
56726	3367	4112343	1977-10-11	1977-10-21	1
80141	4755	4112343	2017-03-14	2017-03-21	1
85038	5063	40481087	1959-11-30	1959-12-21	1
28429	1683	4294548	1994-02-02	1994-04-13	1
64495	3817	4112343	1984-12-19	1984-12-31	1
29783	1764	260139	1968-11-16	1968-11-30	1
24752	1478	198809	1975-05-03	1975-05-03	1
1175	69	4294548	1952-04-20	1952-10-19	1
22402	1338	4310024	1975-03-28	1975-03-29	1
82332	4890	4112343	1923-03-05	1923-03-14	1
23990	1433	260139	1975-05-28	1975-06-11	1
80751	4795	260139	1991-06-28	1991-07-12	1
23523	1407	4112343	1998-12-02	1998-12-13	1
10534	621	40481087	1946-10-27	1946-11-17	1
2305	135	40481087	2018-11-13	2018-11-27	1
5700	335	40481087	2006-11-03	2006-11-17	1
14671	866	372328	1962-10-23	1963-08-25	1
20084	1211	260139	1967-01-07	1967-01-14	1
59023	3505	4112343	1973-11-05	1973-11-17	1
28566	1691	40481087	1987-07-19	1987-08-09	1
29972	1776	80180	1954-06-11	1954-06-12	1
80283	4760	260139	1974-12-08	1974-12-22	1
27994	1657	40481087	1993-08-11	1993-08-25	1
55851	3311	134438	1990-03-20	1991-12-11	1
23130	1382	260139	2019-06-19	2019-06-20	1
27143	1605	4296205	1999-12-03	1999-12-31	1
72611	4319	258780	1999-12-22	1999-12-23	1
17830	1073	28060	1996-08-08	1996-08-16	1
82237	4883	4059173	1973-04-24	1973-06-23	1
83972	4991	4112343	2001-12-13	2001-12-23	1
241	11	40481087	1970-07-28	1970-08-04	1
30149	1782	378001	2005-02-11	2005-04-12	1
82812	4923	372328	1978-03-12	1978-04-11	1
61508	3638	80180	2002-12-13	2002-12-14	1
78384	4644	4112343	1980-11-01	1980-11-10	1
29104	1724	4155034	2019-02-01	2019-02-22	1
83720	4977	40481087	2009-12-27	2010-01-10	1
22593	1352	4112343	2016-03-26	2016-04-03	1
26723	1585	40481087	2000-12-30	2001-01-20	1
76305	4531	0	2017-04-29	2017-04-30	1
30636	1812	378001	1988-07-29	1988-08-28	1
78616	4661	4112343	1994-05-25	1994-06-03	1
25241	1508	80180	1963-12-07	1963-12-08	1
73506	4374	372328	1978-08-27	1978-11-02	1
76072	4520	40481087	1964-11-16	1964-11-30	1
64622	3825	4113008	1965-10-11	1965-10-25	1
75590	4488	40481087	1987-06-09	1987-06-23	1
24095	1438	372328	1953-12-08	1954-01-01	1
2399	141	40481087	2012-05-18	2012-06-01	1
3228	188	4146173	1985-11-01	1985-12-01	1
19986	1206	4166224	1972-02-10	1972-02-11	1
70951	4212	40481087	1977-08-27	1977-09-10	1
27217	1608	40481087	1968-02-20	1968-02-27	1
86592	5157	40481087	2004-08-17	2004-08-31	1
56727	3367	4155034	2010-10-10	2010-10-24	1
80142	4755	4156265	1945-03-13	1945-03-27	1
85039	5063	78272	1979-05-06	1979-06-03	1
28430	1683	4296204	1981-04-30	1981-05-28	1
64496	3817	40481087	1989-10-15	1989-10-22	1
29784	1764	4146173	1984-10-12	1984-11-11	1
24753	1478	372328	1962-04-15	1962-05-29	1
1176	69	4294548	1977-10-05	1977-10-26	1
22403	1338	40481087	2016-02-19	2016-03-11	1
82333	4890	4142905	1981-12-26	1982-02-24	1
23991	1433	4027663	1985-12-28	1985-12-29	1
80752	4795	4294548	2008-05-20	2008-07-22	1
23524	1407	4146173	1985-08-02	1985-09-01	1
10535	621	40481087	1995-01-23	1995-02-06	1
2306	135	260139	2010-10-21	2010-10-28	1
5701	335	260139	1986-03-21	1986-03-28	1
14672	866	4112343	2017-04-24	2017-05-06	1
20085	1211	4051466	1966-10-29	1983-02-10	1
59024	3505	4112343	1982-09-14	1982-09-23	1
28567	1691	260139	1970-06-29	1970-07-13	1
29973	1776	80502	2006-10-28	2006-10-29	1
80284	4760	260139	1985-06-27	1985-07-12	1
27995	1657	0	1998-04-22	1998-04-23	1
55852	3311	260139	1986-02-13	1986-02-27	1
23131	1382	4152936	2019-05-17	2019-06-07	1
27144	1605	40481087	1963-09-08	1963-09-22	1
72612	4319	260139	1998-09-19	1998-09-26	1
17831	1073	78272	2004-06-17	2004-07-22	1
82238	4883	4112343	1982-12-20	1983-01-02	1
83973	4991	4152936	1994-08-04	1994-08-25	1
242	11	40481087	1974-01-21	1974-01-28	1
30150	1782	4112343	2003-02-03	2003-02-16	1
82813	4923	381316	2018-06-19	2018-06-20	1
61509	3638	81151	1976-04-23	1976-05-07	1
78385	4644	4155034	1995-08-16	1995-08-30	1
29105	1724	260139	1975-02-20	1975-03-06	1
83721	4977	28060	1981-06-24	1981-07-06	1
22594	1352	40481087	1983-09-26	1983-10-10	1
26724	1585	40481087	2004-08-02	2004-08-16	1
76306	4531	81151	1948-05-28	1948-06-11	1
30637	1812	260139	2005-09-02	2005-09-16	1
78617	4661	4112343	2013-04-10	2013-04-19	1
25242	1508	372328	1925-01-03	1925-03-10	1
73507	4374	372328	1989-06-07	1989-06-21	1
76073	4520	28060	1940-04-04	1940-04-12	1
64623	3825	4116491	1988-06-02	1988-08-01	1
75591	4488	40481087	2017-12-25	2018-01-01	1
24096	1438	4112343	1982-04-10	1982-04-19	1
2400	141	40481087	2012-11-05	2012-11-12	1
3229	188	40481087	1967-08-03	1967-08-10	1
19987	1206	4285898	1999-03-23	1999-03-24	1
70952	4212	40481087	1981-11-23	1981-11-30	1
27218	1608	40481087	1968-10-01	1968-10-22	1
86593	5157	80180	2000-08-19	2000-08-20	1
56728	3367	4218389	1993-05-25	1993-06-22	1
80143	4755	40481087	1932-03-06	1932-03-13	1
85040	5063	257012	1969-01-19	1969-09-21	1
28431	1683	40481087	2016-06-23	2016-06-30	1
64497	3817	40481087	2007-09-09	2007-09-23	1
29785	1764	40481087	1962-01-08	1962-01-15	1
24754	1478	4084167	1977-11-22	1977-11-22	1
1177	69	40481087	1979-01-27	1979-02-03	1
22404	1338	30753	1976-11-17	1976-11-18	1
82334	4890	4237458	1998-09-28	1998-10-28	1
23992	1433	4112343	1963-07-18	1963-07-30	1
80753	4795	40481087	1974-07-24	1974-08-07	1
23525	1407	4294548	1995-12-24	1996-07-07	1
10536	621	40481087	2017-11-24	2017-12-08	1
2307	135	4218389	2005-11-09	2005-12-07	1
5702	335	260139	1986-10-25	1986-11-08	1
14673	866	4156265	2007-03-22	2007-04-05	1
20086	1211	4155034	2012-06-17	2012-07-08	1
59025	3505	4112343	1998-06-05	1998-06-15	1
28568	1691	372328	1946-01-04	1946-06-20	1
29974	1776	81151	1920-09-07	1920-10-05	1
80285	4760	372328	1960-05-28	1960-10-12	1
27996	1657	80180	1987-02-01	1987-02-02	1
55853	3311	260139	1969-10-10	1969-10-24	1
23132	1382	40481087	1985-12-17	1985-12-31	1
27145	1605	40481087	1991-03-09	1991-03-23	1
72613	4319	372328	1982-12-11	1983-11-23	1
17832	1073	260139	1966-11-24	1966-12-01	1
82239	4883	4112343	2015-12-05	2015-12-13	1
83974	4991	40481087	2000-04-07	2000-04-21	1
243	11	80180	1987-06-15	1987-06-16	1
30151	1782	4112343	2008-03-05	2008-03-12	1
82814	4923	4027663	1993-10-02	1993-10-03	1
61510	3638	260139	1988-09-19	1988-09-26	1
78386	4644	4294548	1995-11-26	1996-02-04	1
29106	1724	375671	1996-07-31	1996-08-30	1
83722	4977	196456	2010-12-07	2010-12-08	1
22595	1352	40481087	1998-01-01	1998-01-22	1
26725	1585	260139	1949-02-15	1949-02-22	1
76307	4531	260139	1949-05-21	1949-06-04	1
30638	1812	4112343	2003-01-26	2003-02-06	1
78618	4661	80180	2018-02-21	2018-02-22	1
25243	1508	372328	1928-03-24	1928-12-11	1
73508	4374	4112343	1985-02-18	1985-02-27	1
76074	4520	258780	1957-04-20	1957-04-21	1
64624	3825	40481087	1957-09-29	1957-10-13	1
75592	4488	28060	2002-01-17	2002-01-30	1
24097	1438	4112343	1997-01-02	1997-01-14	1
2401	141	40481087	2013-04-17	2013-05-01	1
3230	188	28060	1967-10-25	1967-11-07	1
19988	1206	40481087	2012-02-06	2012-02-27	1
70953	4212	40481087	2014-05-05	2014-05-26	1
27219	1608	40481087	1981-05-10	1981-05-31	1
86594	5157	372328	1976-03-28	1976-05-06	1
56729	3367	81151	1997-07-06	1997-07-20	1
80144	4755	40481087	1979-05-21	1979-05-28	1
85041	5063	260139	1944-05-20	1944-05-27	1
31139	1846	260139	1963-05-25	1963-06-01	1
64498	3817	260139	1964-12-21	1965-01-04	1
29786	1764	40481087	1977-11-01	1977-11-15	1
24755	1478	4084167	1981-04-12	1981-04-12	1
1178	69	40481087	1989-10-02	1989-10-09	1
22405	1338	372328	1956-07-06	1956-11-01	1
82335	4890	40481087	1932-12-31	1933-01-21	1
23993	1433	4112343	2017-03-21	2017-03-30	1
80754	4795	40481087	1990-09-17	1990-10-01	1
23526	1407	40481087	1989-08-07	1989-08-21	1
10537	621	372328	1915-11-04	1916-01-26	1
2308	135	81151	1980-01-29	1980-02-26	1
5703	335	4112343	2014-06-06	2014-06-16	1
14674	866	28060	2015-12-16	2015-12-27	1
20087	1211	4156265	2004-04-02	2004-04-16	1
59026	3505	4112343	2008-02-21	2008-03-04	1
28569	1691	4113008	2015-12-24	2016-01-07	1
29975	1776	81151	2001-01-11	2001-02-15	1
80286	4760	381316	2018-03-28	2018-03-29	1
27997	1657	260139	1990-11-23	1990-12-07	1
55854	3311	260139	1979-01-15	1979-01-29	1
23133	1382	28060	1992-12-05	1992-12-15	1
27146	1605	40481087	1992-11-18	1992-12-09	1
72614	4319	4155034	1982-09-12	1982-10-03	1
17833	1073	260139	2006-01-23	2006-02-01	1
84107	5001	28060	1969-12-19	1969-12-27	1
87022	5189	381316	2007-09-09	2007-09-10	1
2457	145	28060	1991-08-21	1991-08-31	1
30871	1829	40481087	1972-01-01	1972-01-22	1
82815	4923	4112343	2005-07-11	2005-07-22	1
61511	3638	260139	2013-02-19	2013-03-05	1
78387	4644	40481087	2008-04-07	2008-04-21	1
29107	1724	439777	2016-08-26	2016-08-27	1
83723	4977	198809	2010-12-07	2010-12-08	1
22596	1352	0	1984-11-25	1984-11-26	1
26726	1585	4112343	1967-05-03	1967-05-12	1
76308	4531	260139	2009-12-24	2009-12-31	1
30639	1812	4146173	1971-06-29	1971-07-29	1
78619	4661	81151	2016-08-29	2016-09-12	1
25244	1508	4112343	1949-10-13	1949-10-24	1
73509	4374	4156265	2003-12-16	2004-01-06	1
76075	4520	260139	1981-02-24	1981-03-10	1
64625	3825	40481087	1988-02-21	1988-03-06	1
75593	4488	4112343	1976-03-06	1976-03-18	1
24098	1438	40481087	1955-08-19	1955-08-26	1
2402	141	80180	2015-11-12	2015-11-13	1
3231	188	28060	2018-04-17	2018-04-28	1
19989	1206	30753	1999-02-21	1999-02-22	1
74259	4413	28060	1961-10-08	1961-10-15	1
27220	1608	257012	1961-12-20	1961-12-21	1
86595	5157	4059173	1974-02-12	1974-03-14	1
56730	3367	260139	2000-08-18	2000-08-25	1
80145	4755	40481087	2001-09-18	2001-10-02	1
85042	5063	260139	1967-05-09	1967-05-16	1
31140	1846	260139	2002-11-30	2002-12-14	1
64499	3817	260139	2010-07-13	2010-07-27	1
29787	1764	80180	1996-12-12	1996-12-13	1
24756	1478	4294548	2018-08-26	2018-08-27	1
1179	69	40481087	2005-02-16	2005-03-02	1
22406	1338	4237458	1948-04-13	1948-05-13	1
82336	4890	40481087	1956-11-25	1956-12-16	1
23994	1433	40481087	1960-11-07	1960-11-28	1
80755	4795	40481087	2003-08-02	2003-08-09	1
23527	1407	40481087	2009-09-17	2009-10-08	1
10538	621	4059173	1919-04-17	1919-05-17	1
2309	135	192671	2010-02-01	2010-02-02	1
5704	335	4296204	2012-07-26	2012-08-23	1
14675	866	80180	1998-01-17	1998-01-18	1
20088	1211	40481087	2013-11-25	2013-12-09	1
59027	3505	4294548	1948-10-06	1949-01-05	1
29921	1773	81151	1988-04-04	1988-05-02	1
29976	1776	198809	1984-10-13	1984-10-13	1
80287	4760	4112343	1982-08-03	1982-08-16	1
27998	1657	321042	1998-04-22	1998-04-23	1
55855	3311	260139	1981-02-18	1981-02-25	1
23134	1382	80180	2014-07-07	2014-07-08	1
27147	1605	40481087	1994-09-04	1994-09-25	1
72615	4319	40481087	1996-11-02	1996-11-16	1
17834	1073	372328	1936-11-22	1937-03-04	1
84108	5001	260139	1961-01-19	1961-02-02	1
87023	5189	4112343	2012-11-13	2012-11-25	1
2458	145	81151	1955-06-27	1955-08-01	1
30872	1829	260139	1985-04-02	1985-04-16	1
82816	4923	4155034	2014-09-05	2014-09-19	1
61512	3638	372328	1968-06-04	1969-04-17	1
79128	4690	372328	1958-03-31	1958-05-17	1
29108	1724	4112343	1952-08-29	1952-09-08	1
83724	4977	260139	2015-03-31	2015-04-14	1
22597	1352	80180	1989-09-07	1989-09-08	1
26727	1585	40481087	1930-04-01	1930-04-15	1
76309	4531	372328	1918-02-21	1918-08-03	1
30640	1812	4278672	2005-09-28	2005-11-27	1
78620	4661	372328	1979-11-28	1980-03-20	1
25245	1508	4112343	1972-07-08	1972-07-18	1
73510	4374	4294548	2011-05-08	2011-06-05	1
76076	4520	317576	1991-01-05	1991-01-06	1
64626	3825	260139	1992-06-06	1992-06-13	1
75594	4488	4283893	1978-03-30	1978-06-29	1
24099	1438	40481087	1958-04-21	1958-05-05	1
2403	141	40481087	2008-10-21	2008-11-04	1
3232	188	78272	1986-10-27	1986-11-10	1
19990	1206	257012	2002-04-09	2002-04-10	1
74260	4413	80180	1997-11-14	1997-11-15	1
27221	1608	260139	1950-01-17	1950-01-31	1
86596	5157	40481087	1967-02-27	1967-03-06	1
56731	3367	260139	2001-05-24	2001-06-07	1
80146	4755	40481087	2004-05-27	2004-06-17	1
85043	5063	260139	2000-05-19	2000-06-02	1
31141	1846	372328	1952-07-20	1952-12-04	1
64500	3817	4113008	2011-05-17	2011-05-31	1
29788	1764	81151	1970-07-07	1970-07-28	1
24757	1478	40481087	1965-05-05	1965-05-12	1
1180	69	80180	1984-08-02	1984-08-03	1
22407	1338	40481087	2003-10-06	2003-10-20	1
82337	4890	40481087	1970-06-07	1970-06-28	1
23995	1433	195588	2019-01-03	2019-02-20	1
80756	4795	260139	1977-11-22	1977-12-06	1
23845	1427	78272	2000-10-16	2000-11-06	1
10539	621	4112343	1918-09-22	1918-10-05	1
2310	135	260139	2000-11-10	2000-11-24	1
5705	335	260139	1974-07-22	1974-08-05	1
14676	866	4112343	1994-04-16	1994-04-26	1
20409	1229	260139	2001-08-24	2001-09-07	1
59028	3505	4299128	1970-07-12	1970-08-16	1
29922	1773	4112343	1967-05-19	1967-05-29	1
29977	1776	260139	1947-12-17	1947-12-24	1
80288	4760	4142905	1972-07-31	1972-10-29	1
27999	1657	372328	1946-06-24	1946-12-04	1
55856	3311	4113008	1965-01-03	1965-01-17	1
23135	1382	260139	1987-12-25	1988-01-08	1
27148	1605	40481087	2002-12-29	2003-01-05	1
72616	4319	40481087	2006-08-05	2006-08-26	1
17835	1073	4027663	1964-06-18	1964-06-19	1
84109	5001	4112343	2001-02-25	2001-03-05	1
87024	5189	40481087	1957-01-16	1957-02-06	1
2459	145	260139	1995-02-02	1995-02-16	1
30873	1829	4116491	2005-06-24	2005-08-11	1
82817	4923	40481087	1997-08-04	1997-08-11	1
61513	3638	4112343	1977-05-15	1977-05-24	1
79129	4690	4113008	2004-05-06	2004-05-20	1
29109	1724	4112343	1953-01-10	1953-01-18	1
83725	4977	4112343	1990-09-02	1990-09-15	1
22598	1352	80809	1971-07-29	1971-07-30	1
26728	1585	40481087	1941-12-10	1941-12-24	1
76310	4531	4109685	1943-09-08	1943-09-22	1
30641	1812	40481087	2006-12-03	2006-12-24	1
78621	4661	40481087	1982-11-11	1982-11-25	1
25246	1508	4112343	1976-06-09	1976-06-20	1
73511	4374	40481087	1989-05-21	1989-05-28	1
76077	4520	372328	1950-03-04	1952-06-14	1
64627	3825	4113008	1988-12-14	1988-12-28	1
75595	4488	40481087	1984-06-03	1984-06-17	1
24100	1438	40481087	1961-09-23	1961-09-30	1
5934	350	28060	1994-03-03	1994-03-11	1
3233	188	260139	1981-09-10	1981-09-17	1
19991	1206	260139	2001-02-12	2001-02-19	1
74261	4413	260139	1976-08-04	1976-08-18	1
27222	1608	260139	1957-09-10	1957-09-17	1
86597	5157	40481087	2004-11-04	2004-11-18	1
56732	3367	260139	2017-08-17	2017-08-24	1
80147	4755	40481087	2013-11-04	2013-11-25	1
85044	5063	260139	2010-05-20	2010-06-04	1
31142	1846	4059173	2007-04-24	2007-06-23	1
64501	3817	40481087	2007-01-27	2007-02-03	1
29789	1764	81893	1995-03-23	1995-03-24	1
24758	1478	40481087	2008-05-01	2008-05-15	1
1181	69	260139	1955-12-24	1956-01-07	1
22689	1356	28060	1981-02-14	1981-02-26	1
82338	4890	40481087	1980-07-13	1980-07-27	1
23996	1433	260139	2004-01-09	2004-01-16	1
80757	4795	372328	1969-12-12	1970-10-14	1
23846	1427	372328	1958-11-23	1959-10-14	2
10540	621	4112343	1931-10-15	1931-10-28	1
2311	135	40481087	1991-01-09	1991-01-23	1
5706	335	4112343	1973-10-24	1973-11-04	1
14677	866	40481087	2000-03-16	2000-03-30	1
20410	1229	375671	1976-07-18	1976-09-16	1
59029	3505	40481087	1994-05-08	1994-05-15	1
29923	1773	4218389	1966-08-07	1966-08-28	1
29978	1776	260139	1977-05-08	1977-05-15	1
80289	4760	4149245	1956-10-16	1956-11-22	1
28000	1657	4112343	1996-06-09	1996-06-20	1
55857	3311	4156265	2011-09-18	2011-10-09	1
23136	1382	260139	2002-08-02	2002-08-09	1
29682	1759	4116491	2016-12-23	2017-02-13	1
72617	4319	40481087	2007-03-03	2007-03-10	1
17836	1073	4112343	1983-06-20	1983-07-01	1
84110	5001	4112343	2013-09-10	2013-09-20	1
87025	5189	28060	1966-07-06	1966-07-19	1
2460	145	372328	1952-02-27	1952-05-06	1
30874	1829	40481087	1993-01-06	1993-01-20	1
82818	4923	192671	2000-06-14	2000-06-15	1
61514	3638	4112343	2009-08-06	2009-08-17	1
79130	4690	4134304	1965-02-22	1965-04-23	1
29110	1724	4294548	2009-06-06	2010-04-10	1
83726	4977	4218389	1980-06-01	1980-07-06	1
22599	1352	192671	1989-09-23	1989-09-24	1
26729	1585	40481087	1949-08-18	1949-09-01	1
76311	4531	4112343	1936-02-20	1936-03-01	1
30642	1812	40481087	2012-01-19	2012-02-09	1
78622	4661	40481087	1987-04-12	1987-04-19	1
25247	1508	4134304	2014-10-06	2015-01-04	1
73512	4374	40481087	2012-09-06	2012-09-13	1
76078	4520	4294548	1955-03-13	1955-03-20	1
64628	3825	28060	1988-11-25	1988-12-04	1
75596	4488	28060	1978-10-08	1978-10-21	1
25343	1512	260139	1979-07-17	1979-07-24	1
5935	350	195588	1982-09-12	1982-11-04	1
3234	188	260139	1986-03-28	1986-04-04	1
19992	1206	372328	1969-05-01	1970-01-26	1
74262	4413	4112343	2008-02-06	2008-02-14	1
27223	1608	260139	1990-09-17	1990-09-24	1
86598	5157	372328	1963-11-07	1963-12-19	1
56733	3367	4112343	1967-07-23	1967-08-03	1
80148	4755	260139	2001-03-22	2001-04-05	1
85045	5063	4112343	2004-10-27	2004-11-04	1
31143	1846	40481087	1959-04-21	1959-05-05	1
64502	3817	260139	1968-08-18	1968-08-25	1
29790	1764	260139	1970-05-27	1970-06-10	1
24759	1478	28060	2015-07-21	2015-07-29	1
1182	69	372328	1947-11-05	1948-10-06	1
22690	1356	81151	1983-08-01	1983-08-29	1
82339	4890	78272	2015-05-07	2015-05-21	1
23997	1433	4266809	1995-08-18	1995-08-19	1
80758	4795	80180	2005-10-09	2005-10-10	1
23847	1427	40481087	1959-06-30	1959-07-14	1
10541	621	4112343	1974-09-25	1974-10-02	1
2312	135	40481087	2001-11-20	2001-12-04	1
5707	335	4155034	1982-03-24	1982-04-14	1
14678	866	260139	1972-10-31	1972-11-14	1
20411	1229	440086	1966-05-12	1972-05-20	1
59030	3505	40481087	2004-02-17	2004-03-09	1
29924	1773	4294548	1996-04-03	1996-04-24	1
29979	1776	313217	2003-10-11	2003-10-12	1
80290	4760	4237458	1969-05-18	1969-07-17	1
28001	1657	40481087	1957-01-27	1957-02-17	1
55858	3311	40481087	1979-10-01	1979-10-22	1
23137	1382	40481087	1990-11-11	1990-12-02	1
29683	1759	260139	1993-12-16	1993-12-23	1
73311	4364	260139	2007-05-28	2007-06-04	1
17837	1073	40480160	2010-08-20	2010-09-19	1
84111	5001	260139	2006-12-19	2006-12-26	1
87026	5189	80180	1998-10-28	1998-10-29	1
2461	145	372328	1953-04-01	1953-11-10	1
30875	1829	80180	2002-08-09	2002-08-10	1
82819	4923	4112343	2007-02-14	2007-02-23	1
61515	3638	40481087	1985-08-04	1985-08-11	1
79131	4690	4152936	1993-05-20	1993-06-03	1
29111	1724	40481087	1959-12-08	1959-12-15	1
83727	4977	4218389	2013-11-09	2013-12-14	1
22600	1352	196456	1976-07-29	1976-07-29	1
26730	1585	40481087	1954-02-28	1954-03-07	1
76312	4531	4112343	2011-07-11	2011-07-19	1
30643	1812	40481087	2015-06-13	2015-06-27	1
78623	4661	40481087	2001-08-10	2001-08-24	1
25248	1508	40481087	1965-03-26	1965-04-02	1
74787	4448	257012	2010-01-25	2010-01-26	1
76079	4520	4329847	1996-09-28	1996-09-29	1
64629	3825	260139	1958-02-21	1958-02-28	1
75597	4488	28060	1996-05-03	1996-05-15	1
25344	1512	372328	1976-05-02	1976-05-16	1
5936	350	372328	1961-12-06	1962-02-23	1
3235	188	40481087	1997-04-13	1997-04-27	1
19993	1206	440448	1972-02-10	1972-02-11	1
74263	4413	4112343	2016-12-01	2016-12-14	1
27224	1608	40481087	1980-01-02	1980-01-09	1
86599	5157	372328	1966-12-08	1967-03-16	1
56734	3367	4112343	2014-07-10	2014-07-19	1
80149	4755	372328	1928-06-19	1928-09-07	1
85046	5063	4218389	2010-10-18	2010-11-22	1
31144	1846	40481087	1964-11-02	1964-11-09	1
64503	3817	260139	1991-03-30	1991-04-06	1
29791	1764	260139	1981-09-24	1981-10-08	1
24760	1478	196456	1975-05-03	1975-05-03	1
1183	69	375671	2013-07-17	2013-08-16	1
22691	1356	134438	1995-02-06	1996-04-02	1
82340	4890	81151	1969-04-12	1969-04-26	1
23998	1433	40481087	1994-01-25	1994-02-15	1
80759	4795	260139	1974-02-20	1974-03-06	1
23848	1427	81151	1982-03-13	1982-04-03	1
10542	621	4112343	1978-12-14	1978-12-22	1
5785	340	81151	2007-10-29	2007-11-26	1
5708	335	4294548	1966-01-10	1966-03-07	1
14679	866	4112343	2003-06-12	2003-06-19	1
20412	1229	40481087	2016-02-12	2016-03-04	1
59031	3505	260139	1970-02-10	1970-02-24	1
29925	1773	40481087	1988-09-12	1988-10-03	1
29980	1776	372328	1918-08-04	1918-10-05	1
80291	4760	40481087	1984-05-02	1984-05-16	1
28002	1657	40481087	1985-02-23	1985-03-09	1
55859	3311	40481087	1997-12-21	1998-01-11	1
23138	1382	40481087	2008-03-08	2008-03-22	1
29684	1759	260139	2012-09-15	2012-09-22	1
73312	4364	372328	1956-01-21	1956-12-16	1
17838	1073	40481087	1951-08-17	1951-09-07	1
84112	5001	372328	1961-10-14	1962-01-28	1
87027	5189	260139	1972-01-15	1972-01-22	1
2462	145	4035415	1973-01-28	1973-03-29	1
30876	1829	4113008	1989-07-22	1989-08-12	1
82820	4923	40481087	2009-02-10	2009-02-24	1
61516	3638	40481087	1999-01-18	1999-02-01	1
79132	4690	40481087	2016-03-20	2016-04-03	1
29112	1724	40481087	1962-09-05	1962-09-12	1
83728	4977	4283893	1975-12-25	1976-11-25	1
22601	1352	4112343	2016-01-12	2016-01-24	1
26731	1585	40481087	2003-03-19	2003-04-02	1
76313	4531	4278672	1983-07-22	1983-10-20	1
32525	1934	372328	1963-12-03	1964-01-04	1
78624	4661	4112343	1986-06-26	1986-07-05	1
25249	1508	40481087	1982-04-18	1982-05-09	1
74788	4448	4112343	1994-07-10	1994-07-17	1
76080	4520	40481087	1957-09-10	1957-09-17	1
64630	3825	381316	1998-01-02	1998-01-03	1
75598	4488	28060	2011-11-23	2011-11-30	1
25345	1512	372328	1979-11-04	1980-07-30	1
5937	350	4112343	1968-07-16	1968-07-27	1
3236	188	80180	1999-11-24	1999-11-25	1
19994	1206	4113008	1991-03-04	1991-03-18	1
74264	4413	40481087	1975-09-25	1975-10-16	1
27225	1608	40481087	1983-05-29	1983-06-12	1
86600	5157	375671	1982-09-28	1982-10-28	1
57371	3409	28060	2011-06-01	2011-06-09	1
80150	4755	372328	1930-03-01	1930-09-19	1
85047	5063	4266809	1981-09-11	1981-09-12	1
31145	1846	40481087	1984-03-01	1984-03-08	1
64504	3817	260139	2017-06-25	2017-07-09	1
29792	1764	4266809	1996-12-12	1996-12-13	1
24761	1478	257012	2018-10-07	2018-10-08	1
1184	69	4112343	1972-06-12	1972-06-22	1
22692	1356	4027663	2005-01-27	2005-01-28	1
82341	4890	260139	1938-10-12	1938-10-26	1
23999	1433	260139	1970-01-13	1970-01-27	1
80760	4795	4112343	2011-02-07	2011-02-17	1
23849	1427	260139	2011-07-20	2011-07-27	1
10543	621	4112343	2013-07-24	2013-08-04	1
5786	340	4112343	1963-07-21	1963-07-29	1
5709	335	40481087	1975-11-20	1975-12-11	1
16980	1016	260139	2009-06-15	2009-06-22	1
20413	1229	40481087	2019-06-24	2019-06-25	1
59032	3505	4112343	1959-11-13	1959-11-21	1
29926	1773	28060	1959-07-19	1959-07-29	1
29981	1776	372328	1921-06-27	1921-10-08	1
80292	4760	40481087	2013-03-17	2013-03-24	1
28003	1657	28060	1955-11-22	1955-12-03	1
58822	3494	192671	1999-02-24	1999-02-25	1
23734	1418	80180	2014-08-08	2014-08-09	1
29685	1759	372328	1990-02-26	1990-12-17	1
73313	4364	40481087	1962-10-28	1962-11-18	1
17839	1073	40481087	1978-03-10	1978-03-17	1
84113	5001	378001	2000-03-12	2000-04-11	1
87028	5189	40481087	1987-04-07	1987-04-28	1
2463	145	4051466	1952-12-06	1968-03-21	1
30877	1829	4152936	1975-07-22	1975-08-05	1
85315	5079	372328	1970-12-11	1970-12-25	1
61517	3638	40481087	1966-10-21	1966-11-04	1
79133	4690	81151	1971-11-18	1971-12-02	1
29113	1724	40481087	1982-03-27	1982-04-10	1
83729	4977	40481087	1971-08-26	1971-09-16	1
22602	1352	40481087	1976-10-03	1976-10-24	1
26732	1585	28060	1942-09-30	1942-10-08	1
76314	4531	4294548	1987-07-15	1987-10-14	1
32526	1934	372328	1965-09-06	1966-01-15	1
78625	4661	40481087	1979-03-09	1979-03-23	1
25250	1508	40481087	2014-02-13	2014-02-27	1
74789	4448	4112343	1994-09-16	1994-09-29	1
76081	4520	40481087	1983-06-30	1983-07-07	1
64631	3825	4059173	1956-05-31	1956-06-30	1
75599	4488	4218389	1990-08-16	1990-09-06	1
25346	1512	4113008	2010-10-01	2010-10-15	1
5938	350	4112343	1970-12-16	1970-12-27	1
3237	188	4027663	1991-11-11	1991-11-12	1
19995	1206	4152936	1998-08-08	1998-08-29	1
74265	4413	40481087	1987-01-21	1987-02-04	1
27226	1608	40481087	1985-02-27	1985-03-06	1
86601	5157	381316	2015-05-14	2015-05-15	1
57372	3409	4134304	1957-05-06	1957-08-04	1
80151	4755	4112343	1941-09-11	1941-09-21	1
85048	5063	4285898	1981-01-14	1981-01-15	1
31146	1846	80180	1987-11-09	1987-11-10	1
64505	3817	372328	1967-02-07	1967-07-07	1
29793	1764	4285898	1996-06-15	1996-06-16	1
24762	1478	260139	1975-09-05	1975-09-19	1
1185	69	40481087	2003-03-17	2003-03-31	1
22693	1356	4112343	1988-01-06	1988-01-19	1
82342	4890	260139	1951-06-16	1951-06-30	1
24000	1433	260139	1977-04-11	1977-04-18	1
80761	4795	4116491	1998-12-22	1999-02-14	1
23850	1427	4059173	1968-06-03	1968-07-03	1
10544	621	4283893	1929-02-21	1929-06-06	1
5787	340	40481087	1975-09-22	1975-10-13	1
5710	335	40481087	2017-03-29	2017-04-12	1
16981	1016	4112343	2011-11-16	2011-11-29	1
20414	1229	260139	2001-04-17	2001-04-24	1
59033	3505	4112343	1965-03-11	1965-03-18	1
29927	1773	260139	1982-08-01	1982-08-08	1
29982	1776	4112343	1923-07-07	1923-07-14	1
80293	4760	28060	1968-09-06	1968-09-17	1
28004	1657	81151	1947-09-09	1947-09-23	1
58823	3494	4112343	2012-10-17	2012-10-26	1
23735	1418	260139	2016-12-21	2017-01-04	1
29686	1759	4112343	1999-09-16	1999-09-24	1
73314	4364	40481087	1972-10-01	1972-10-08	1
20676	1245	260139	1970-06-04	1970-06-18	1
84114	5001	4112343	1963-04-10	1963-04-22	1
87029	5189	40481087	1999-01-31	1999-02-14	1
2464	145	4112343	1951-12-19	1951-12-29	1
30878	1829	40481087	1997-04-05	1997-04-26	1
85316	5079	4112343	1983-08-17	1983-08-28	1
61518	3638	40481087	2011-03-21	2011-04-11	1
79134	4690	260139	2013-09-08	2013-09-15	1
29114	1724	40481087	1995-02-08	1995-02-15	1
83730	4977	40481087	2016-04-16	2016-04-30	1
22603	1352	372328	1993-02-28	1993-08-15	1
26733	1585	80180	1966-02-04	1966-02-05	1
76315	4531	40481087	1978-11-04	1978-11-18	1
32527	1934	4112343	1992-07-24	1992-08-06	1
78626	4661	40481087	2012-12-02	2012-12-09	1
25251	1508	28060	1933-09-11	1933-09-23	1
74790	4448	40481087	1965-01-02	1965-01-16	1
76082	4520	40481087	1990-01-07	1990-01-28	1
64632	3825	4112343	1977-01-14	1977-01-23	1
75600	4488	40481087	1979-12-28	1980-01-18	1
25347	1512	40481087	1994-05-05	1994-05-12	1
5939	350	4112343	1980-06-10	1980-06-18	1
3238	188	4112343	1999-01-26	1999-02-08	1
19996	1206	4294548	1965-01-10	1965-01-17	1
74266	4413	81151	2006-10-29	2006-12-03	1
27227	1608	28060	1960-06-23	1960-07-03	1
86602	5157	440448	1985-04-06	1985-04-07	1
57373	3409	40481087	2016-02-06	2016-02-20	1
80152	4755	4112343	2018-08-14	2018-08-26	1
85049	5063	40481087	2000-03-21	2000-04-11	1
31147	1846	81151	2003-06-23	2003-07-14	1
64506	3817	4112343	2014-02-24	2014-03-04	1
29794	1764	4296205	1993-05-28	1993-06-18	1
24763	1478	260139	2009-12-12	2009-12-27	1
1186	69	78272	1988-02-24	1988-03-16	1
22694	1356	4112343	2001-08-11	2001-08-22	1
82343	4890	372328	1924-08-24	1924-10-29	1
24001	1433	260139	1980-07-12	1980-07-26	1
23851	1427	4112343	1957-11-29	1957-12-09	1
10545	621	4294548	1976-06-14	1976-08-23	1
5788	340	40481087	2014-01-11	2014-01-25	1
7107	419	28060	1941-06-17	1941-06-29	1
16982	1016	40481087	1975-03-09	1975-03-30	1
20415	1229	4116491	1977-05-09	1977-06-18	1
59034	3505	4112343	2014-01-05	2014-01-16	1
29928	1773	4048171	1954-09-01	1954-09-02	1
29983	1776	4112343	1974-05-21	1974-06-01	1
80294	4760	4112343	1998-04-06	1998-04-13	1
28005	1657	372328	1944-02-27	1944-04-05	1
58824	3494	40481087	1978-05-03	1978-05-17	1
23736	1418	378001	2003-01-09	2003-02-08	1
29687	1759	80180	2019-03-08	2019-03-09	1
73315	4364	40481087	2010-06-07	2010-06-21	1
20677	1245	4218389	1984-07-05	1984-08-09	1
84115	5001	4112343	2007-10-02	2007-10-11	1
87030	5189	4112343	1962-08-16	1962-08-23	1
2465	145	40481087	1979-06-05	1979-06-26	1
30879	1829	40481087	2009-06-30	2009-07-21	1
85317	5079	4112343	1991-12-28	1992-01-10	1
61519	3638	40481087	2013-03-07	2013-03-28	1
79135	4690	4112343	2015-04-09	2015-04-16	1
29115	1724	40481087	2018-09-01	2018-09-22	1
22604	1352	4112343	1986-08-24	1986-08-31	1
26734	1585	81151	1990-04-19	1990-05-03	1
76316	4531	40481087	1983-02-03	1983-02-17	1
32528	1934	4294548	1963-05-03	1963-05-24	1
78832	4675	260139	1960-06-02	1960-06-16	1
25252	1508	260139	1967-09-13	1967-09-27	1
74791	4448	40481087	2000-08-22	2000-09-05	1
76083	4520	40481087	1991-10-25	1991-11-08	1
64633	3825	4113008	1988-01-28	1988-02-18	1
75601	4488	40481087	2001-10-03	2001-10-17	1
25348	1512	372328	1977-03-12	1977-05-18	1
5940	350	4112343	1989-02-04	1989-02-13	1
3239	188	4113008	1975-09-11	1975-09-25	1
19997	1206	0	1972-02-10	1972-02-11	1
74267	4413	260139	1965-09-15	1965-09-29	1
27228	1608	81151	1951-11-03	1951-11-24	1
86603	5157	4059173	2018-01-22	2018-03-23	1
57374	3409	40481087	2017-12-19	2017-12-26	1
80153	4755	4237458	1925-12-02	1926-03-02	1
85050	5063	40481087	2019-01-04	2019-01-18	1
31148	1846	4027663	1979-12-21	1979-12-22	1
66082	3916	260139	2012-10-07	2012-10-21	1
29795	1764	40481087	2003-05-24	2003-06-07	1
24764	1478	378001	1963-02-09	1963-03-11	1
1187	69	4112343	2000-09-25	2000-10-02	1
22695	1356	4112343	2012-09-24	2012-10-04	1
82344	4890	4109685	1942-05-13	1942-06-03	1
24002	1433	81151	1989-05-01	1989-05-29	1
23852	1427	4116491	1986-11-01	1986-12-24	1
10546	621	40481087	1979-08-15	1979-09-05	1
5789	340	260139	1996-02-26	1996-03-11	1
7108	419	257012	1959-09-18	1959-09-19	1
16983	1016	195588	2007-06-04	2007-07-15	1
20416	1229	40481087	1957-08-31	1957-09-07	1
59035	3505	40481087	1965-08-18	1965-08-25	1
29929	1773	4084167	1967-10-04	1967-10-04	1
29984	1776	4112343	1988-02-03	1988-02-14	1
80295	4760	40481087	1955-08-29	1955-09-12	1
28006	1657	372328	1949-09-19	1949-12-14	1
58825	3494	40481087	1990-09-20	1990-09-27	1
23737	1418	4001336	2005-10-25	2005-12-24	1
29688	1759	260139	2001-09-25	2001-10-02	1
73316	4364	40481087	2011-05-23	2011-06-06	1
20678	1245	40481087	1947-12-18	1948-01-01	1
84116	5001	4113008	1993-09-24	1993-10-15	1
87031	5189	4112343	1982-01-13	1982-01-21	1
2466	145	195588	1973-11-24	1974-01-15	1
30880	1829	260139	2003-07-17	2003-07-24	1
85318	5079	4237458	1969-07-28	1969-10-26	1
52603	3118	40486433	1952-12-11	1967-12-10	1
79136	4690	4278672	1959-02-24	1959-04-25	1
29311	1738	260139	1971-11-02	1971-11-16	1
22605	1352	4294548	1999-08-10	1999-08-31	1
26735	1585	260139	1939-05-08	1939-05-15	1
76317	4531	80180	1950-03-13	1950-03-14	1
32529	1934	4296204	1992-04-11	1992-04-25	1
78833	4675	260139	1969-03-23	1969-04-06	1
25253	1508	4112343	1974-07-09	1974-07-18	1
74792	4448	40481087	2012-07-23	2012-08-13	1
77124	4574	30753	1991-02-01	1991-02-02	1
64634	3825	4156265	2009-03-13	2009-03-27	1
75602	4488	40481087	2016-07-06	2016-07-27	1
25349	1512	4112343	2002-11-30	2002-12-10	1
5941	350	81151	2003-01-03	2003-01-24	1
3524	202	192671	1982-05-16	1982-05-17	1
19998	1206	134438	1988-02-11	1989-03-10	1
74268	4413	378001	1986-04-17	1986-06-16	1
27229	1608	260139	1945-01-26	1945-02-02	1
86604	5157	4112343	1991-12-24	1992-01-01	1
57375	3409	80180	1999-08-19	1999-08-20	1
80154	4755	40481087	1928-12-22	1929-01-12	1
86210	5137	260139	1972-02-20	1972-03-05	1
31149	1846	4059173	2018-01-26	2018-02-25	1
66083	3916	4027663	2004-09-27	2004-09-28	1
29796	1764	257012	1974-06-15	1974-06-16	1
24765	1478	4112343	1966-01-11	1966-01-20	1
1188	69	4155034	1997-12-24	1998-01-07	1
22696	1356	4149245	2007-09-22	2007-10-29	1
82345	4890	4112343	2010-06-16	2010-06-29	1
24003	1433	192671	1995-11-08	1995-11-09	1
23853	1427	4296205	2008-08-26	2008-09-09	1
10547	621	40481087	2004-11-04	2004-11-11	1
5790	340	4112343	2010-12-05	2010-12-13	1
7109	419	4155034	1915-06-09	1915-06-30	1
16984	1016	195588	2010-07-14	2010-09-01	1
20417	1229	40481087	1984-02-23	1984-03-01	1
59396	3527	28060	1971-07-03	1971-07-15	1
29930	1773	4112343	1978-07-18	1978-07-25	1
29985	1776	4142905	1992-12-03	1993-01-02	1
80296	4760	40481087	1969-10-05	1969-10-12	1
28007	1657	4059173	2008-01-09	2008-03-09	1
58826	3494	40481087	1996-10-01	1996-10-22	1
23738	1418	40481087	2005-07-12	2005-07-26	1
29689	1759	260139	2005-06-25	2005-07-02	1
73317	4364	81151	1967-05-13	1967-06-17	1
20679	1245	40481087	1951-03-21	1951-04-11	1
84117	5001	4146173	1964-03-02	1964-04-01	1
87032	5189	4152936	2018-07-25	2018-08-15	1
2467	145	260139	1969-05-17	1969-05-31	1
30881	1829	4112343	2001-12-05	2001-12-14	1
85319	5079	4285898	2008-03-20	2008-03-21	1
52604	3118	28060	1950-03-03	1950-03-16	1
79137	4690	40481087	1975-04-12	1975-04-19	1
29312	1738	260139	1986-07-15	1986-07-29	1
22606	1352	40481087	2005-12-05	2005-12-26	1
26736	1585	260139	1953-12-30	1954-01-13	1
76318	4531	257012	1987-08-05	1987-08-06	1
32530	1934	40481087	1963-03-21	1963-03-28	1
78834	4675	260139	1988-09-22	1988-10-06	1
25254	1508	40481087	1944-10-15	1944-10-22	1
74793	4448	40481087	2018-03-23	2018-04-13	1
77125	4574	80180	1992-06-25	1992-06-26	1
64635	3825	40481087	1961-09-28	1961-10-19	1
77670	4606	80180	2016-12-17	2016-12-18	1
25350	1512	4112343	2003-10-08	2003-10-18	1
5942	350	317576	1991-11-08	1991-11-09	1
3525	202	257012	1962-12-27	1963-01-03	1
19999	1206	4027663	1992-02-03	1992-02-04	1
74269	4413	4112343	1962-07-13	1962-07-21	1
27230	1608	260139	2017-12-05	2017-12-12	1
87329	5203	28060	1967-01-14	1967-01-24	1
57376	3409	81151	2002-11-11	2002-12-09	1
80155	4755	40481087	1989-05-12	1989-05-26	1
86211	5137	372328	1971-08-29	1973-06-06	2
31150	1846	40481087	1964-05-13	1964-05-27	1
66084	3916	4051466	1980-10-10	1998-01-16	1
29797	1764	260139	1978-11-01	1978-11-08	1
24766	1478	4112343	1969-11-01	1969-11-14	1
1189	69	40481087	1968-08-17	1968-08-24	1
22697	1356	40481087	2013-06-03	2013-06-24	1
82346	4890	4116491	1978-12-20	1979-01-31	1
24004	1433	260139	1978-11-11	1978-11-18	1
23854	1427	40481087	1994-12-17	1994-12-31	1
10548	621	40481087	2013-09-01	2013-09-08	1
5791	340	40481087	1974-05-16	1974-05-23	1
7110	419	4294548	1959-07-24	1959-10-23	1
16985	1016	260139	2013-06-02	2013-06-16	1
20418	1229	40481087	2001-09-04	2001-09-18	1
59397	3527	381316	2013-11-28	2013-11-29	1
29931	1773	4112343	2011-07-20	2011-08-02	1
29986	1776	4218389	1940-11-24	1940-12-15	1
80297	4760	260139	1986-07-21	1986-07-28	1
28008	1657	4112343	1990-07-29	1990-08-09	1
58827	3494	81151	1991-02-03	1991-02-24	1
23739	1418	81151	1973-09-22	1973-10-13	1
29690	1759	260139	2006-01-29	2006-02-05	1
73318	4364	4112343	1961-09-05	1961-09-18	1
20680	1245	40481087	1968-11-02	1968-11-23	1
84118	5001	40481087	1974-02-05	1974-02-12	1
87033	5189	40481087	1957-09-10	1957-09-24	1
2468	145	260139	1977-12-17	1977-12-31	1
30882	1829	40481087	1969-03-31	1969-04-07	1
85320	5079	372328	1969-08-27	1969-11-16	1
52605	3118	28060	1950-10-15	1950-10-24	1
79138	4690	195588	2010-05-27	2010-07-17	1
29313	1738	372328	1971-10-31	1972-05-07	1
22607	1352	28060	1947-04-05	1947-04-14	1
26737	1585	260139	1959-10-20	1959-11-03	1
76319	4531	260139	1916-05-21	1916-05-28	1
32531	1934	40481087	1979-02-20	1979-03-13	1
78835	4675	372328	1916-05-01	1916-06-11	1
25255	1508	40481087	1961-06-01	1961-06-08	1
74794	4448	260139	1962-04-05	1962-04-12	1
77126	4574	260139	1968-04-14	1968-04-21	1
64636	3825	40481087	1984-01-20	1984-02-03	1
77671	4606	40481087	1994-12-16	1994-12-30	1
25351	1512	40481087	1998-04-21	1998-04-28	1
5943	350	378001	2005-08-11	2005-10-10	1
3526	202	260139	2013-06-10	2013-06-17	1
20000	1206	4266809	1999-10-19	1999-10-20	1
74270	4413	4112343	1992-03-02	1992-03-15	1
27231	1608	4112343	1960-01-16	1960-01-23	1
87330	5203	260139	1961-09-15	1961-09-22	1
57377	3409	195588	2002-06-04	2002-07-15	1
80156	4755	40481087	1994-09-03	1994-09-17	1
86212	5137	372328	1991-04-03	1992-08-26	1
31151	1846	40481087	2013-08-08	2013-08-22	1
66085	3916	4112343	1983-05-18	1983-05-28	1
29798	1764	372328	1959-11-02	1960-02-11	2
24767	1478	4112343	2005-10-18	2005-10-25	1
1190	69	40481087	1976-03-21	1976-04-04	1
22698	1356	30753	2015-12-16	2015-12-17	1
82347	4890	40479422	1972-02-10	1972-03-18	1
24005	1433	4294548	1973-10-30	1973-12-04	1
23855	1427	80180	1995-09-15	1995-09-16	1
10549	621	78272	1922-12-27	1923-01-24	1
5792	340	40481087	1987-08-12	1987-08-19	1
7111	419	40481087	1942-03-10	1942-03-24	1
16986	1016	4146173	1985-07-09	1985-08-08	1
20419	1229	80180	1990-09-18	1990-09-19	1
59398	3527	4112343	2018-03-22	2018-04-01	1
29932	1773	4146173	1960-11-06	1960-12-06	1
29987	1776	4278672	1922-09-09	1922-12-08	1
80298	4760	4112343	1975-12-11	1975-12-24	1
28009	1657	4112343	2004-11-07	2004-11-15	1
58828	3494	4112343	1962-02-22	1962-03-04	1
23740	1418	40481087	1988-08-26	1988-09-16	1
29691	1759	81151	1993-02-17	1993-03-10	1
73319	4364	4134304	1960-10-09	1960-11-08	1
20681	1245	40481087	1969-08-29	1969-09-05	1
84119	5001	40481087	1991-04-18	1991-05-02	1
87034	5189	40481087	1980-09-28	1980-10-05	1
2469	145	4112343	1952-09-28	1952-10-11	1
30883	1829	40481087	1984-02-26	1984-03-18	1
85321	5079	4027663	1996-12-03	1996-12-04	1
52606	3118	40479768	1972-08-22	1972-09-28	1
79139	4690	378001	1987-06-16	1987-07-16	1
29314	1738	4112343	1975-09-07	1975-09-16	1
22608	1352	260139	1959-12-07	1959-12-14	1
26738	1585	372328	1930-02-23	1930-04-06	1
76320	4531	260139	1924-02-26	1924-03-11	1
32532	1934	372328	1961-05-24	1961-07-08	1
78836	4675	4134304	1949-04-16	1949-05-16	1
25256	1508	40481087	1990-03-05	1990-03-12	1
74795	4448	260139	1987-11-28	1987-12-12	1
77127	4574	372328	1968-04-03	1968-04-17	1
64637	3825	40481087	1993-08-07	1993-08-14	1
77672	4606	260139	1987-09-07	1987-09-14	1
25352	1512	40481087	2010-11-14	2010-12-05	1
5944	350	4112343	1962-10-05	1962-10-12	1
3527	202	260139	2014-11-18	2014-12-02	1
20001	1206	4310024	1997-09-29	1997-09-30	1
74271	4413	4113008	1975-08-22	1975-09-12	1
27232	1608	4112343	1967-07-28	1967-08-04	1
87331	5203	4112343	1940-11-16	1940-11-25	1
57378	3409	260139	2001-12-27	2002-01-10	1
80157	4755	40481087	2017-07-05	2017-07-19	1
86213	5137	372328	2010-04-24	2010-07-28	1
31152	1846	4112343	1968-11-04	1968-11-16	1
66086	3916	30753	2014-09-15	2014-09-16	1
29799	1764	372328	1963-10-23	1964-07-09	1
24768	1478	4112343	2008-11-10	2008-11-20	1
1191	69	40481087	2002-10-29	2002-11-12	1
22699	1356	440086	1980-02-03	1989-02-10	1
82348	4890	40481087	1928-10-29	1928-11-19	1
26991	1599	28060	1962-11-26	1962-12-03	1
23856	1427	81151	1973-06-07	1973-06-28	1
10550	621	80180	1953-11-29	1953-11-30	1
5793	340	40481087	2006-11-05	2006-11-12	1
7112	419	40481087	1954-03-25	1954-04-15	1
16987	1016	40481087	2013-03-30	2013-04-20	1
20420	1229	378001	1966-04-12	1966-05-12	1
59399	3527	40481087	1964-08-01	1964-08-22	1
29933	1773	40481087	1999-06-14	1999-06-21	1
29988	1776	40481087	1931-07-11	1931-07-25	1
80299	4760	4112343	1993-08-19	1993-08-26	1
28010	1657	4152936	2014-02-06	2014-02-20	1
58829	3494	4112343	1970-07-20	1970-08-01	1
23741	1418	28060	1978-01-02	1978-01-15	1
29692	1759	192671	2019-04-03	2019-04-04	1
73320	4364	40481087	1955-04-16	1955-04-30	1
20682	1245	40481087	1982-04-07	1982-04-21	1
84120	5001	40481087	2006-08-17	2006-09-07	1
87035	5189	260139	1970-04-05	1970-04-19	1
2470	145	195588	1983-03-08	1983-04-10	1
30884	1829	40481087	2014-01-01	2014-01-08	1
85322	5079	4152936	1981-08-24	1981-09-14	1
52607	3118	40481087	1983-08-14	1983-09-04	1
79140	4690	4112343	1997-10-03	1997-10-12	1
29315	1738	4112343	1985-06-08	1985-06-15	1
22609	1352	261325	1993-08-15	1993-08-16	1
26739	1585	372328	1935-03-16	1935-07-14	1
76321	4531	260139	1941-09-17	1941-10-01	1
32533	1934	4112343	1963-02-15	1963-02-25	1
78837	4675	4278672	2007-12-06	2008-01-05	1
25257	1508	81151	2011-09-17	2011-10-22	1
74796	4448	378001	1966-09-09	1966-11-08	1
77128	4574	439777	1974-03-12	1974-03-13	1
64638	3825	40481087	1996-01-10	1996-01-24	1
77673	4606	260139	1990-10-09	1990-10-16	1
25353	1512	80180	2016-10-19	2016-10-20	1
5945	350	4112343	1991-11-03	1991-11-10	1
3528	202	4112343	1980-07-03	1980-07-16	1
20002	1206	40481087	1980-10-20	1980-11-10	1
74272	4413	4146173	2001-08-26	2001-10-25	1
27233	1608	4112343	1985-06-01	1985-06-13	1
87332	5203	4294548	1973-08-30	1973-09-27	1
57379	3409	372328	1968-05-06	1968-05-20	1
80158	4755	0	1933-11-06	1933-11-07	1
86214	5137	4112343	1995-02-06	1995-02-15	1
31153	1846	4310024	1986-08-16	1986-08-17	1
66087	3916	372328	1980-12-22	1981-03-11	1
29800	1764	4027663	1985-08-27	1985-08-28	1
24769	1478	4296204	1972-01-23	1972-02-27	1
1192	69	40481087	2004-09-28	2004-10-12	1
22700	1356	40481087	1981-06-19	1981-07-03	1
82349	4890	80180	1957-07-02	1957-07-03	1
26992	1599	192671	1998-02-23	1998-02-24	1
23857	1427	40481087	2011-03-15	2011-04-05	1
10551	621	80502	2003-01-08	2003-01-09	1
5794	340	81151	1963-11-14	1963-12-19	1
7113	419	40481087	1966-07-09	1966-07-30	1
16988	1016	28060	1996-03-16	1996-03-23	1
20421	1229	4112343	1954-12-15	1954-12-28	1
59400	3527	40481087	2002-07-10	2002-07-24	1
29934	1773	40481087	2015-02-05	2015-02-26	1
29989	1776	40481087	1961-12-21	1961-12-28	1
80300	4760	4296205	2015-11-04	2015-12-02	1
28011	1657	4283893	1987-09-02	1987-10-07	1
58830	3494	258780	1999-04-29	1999-04-30	1
23742	1418	257012	2001-08-15	2001-08-16	1
29693	1759	372328	1986-01-25	1986-03-10	1
73321	4364	40481087	1998-08-12	1998-09-02	1
20683	1245	40481087	1995-09-16	1995-10-07	1
84121	5001	40481087	2019-01-11	2019-01-25	1
87036	5189	4112343	1981-05-03	1981-05-15	1
2471	145	260139	1957-12-15	1957-12-22	1
30885	1829	40481087	2018-08-22	2018-09-12	1
85323	5079	28060	1985-01-20	1985-01-29	1
52608	3118	4156265	1956-07-26	1956-08-16	1
79141	4690	4155034	1992-05-04	1992-05-25	1
29316	1738	40481087	1976-09-09	1976-09-16	1
22610	1352	321042	1984-11-25	1984-11-26	1
26740	1585	4112343	1941-12-24	1942-01-01	1
76322	4531	317576	1994-10-29	1994-10-30	1
32534	1934	80180	2000-08-12	2000-08-13	1
78838	4675	40480160	1994-07-17	1994-08-16	1
25258	1508	372328	1924-03-01	1924-04-08	1
74797	4448	4027663	1987-04-07	1987-04-08	1
77129	4574	4027663	1985-03-09	1985-03-10	1
64639	3825	40481087	1997-07-23	1997-07-30	1
77674	4606	4112343	1996-08-22	1996-09-03	1
25354	1512	257012	2014-03-09	2014-03-10	1
5946	350	4112343	1997-04-28	1997-05-10	1
3529	202	4266809	1982-02-16	1982-02-17	1
20003	1206	40481087	2008-07-29	2008-08-19	1
74273	4413	4278672	1976-08-07	1976-09-06	1
27234	1608	4112343	2017-11-02	2017-11-09	1
87333	5203	40481087	1949-11-03	1949-11-17	1
57380	3409	4112343	1961-01-24	1961-02-02	1
80159	4755	260139	1941-07-27	1941-08-03	1
86215	5137	260139	1970-11-04	1970-11-18	1
31154	1846	40481087	1971-10-10	1971-10-31	1
66088	3916	4266809	2016-05-07	2016-05-08	1
29801	1764	4112343	1994-08-04	1994-08-16	1
24770	1478	81151	2013-08-04	2013-08-18	1
1193	69	40481087	2006-04-03	2006-04-24	1
22701	1356	40481087	1981-09-08	1981-09-15	1
82350	4890	80502	2000-09-06	2000-09-07	1
26993	1599	372328	1964-12-26	1965-04-12	1
23858	1427	260139	1979-07-07	1979-07-21	1
10552	621	378001	1967-08-01	1967-08-31	1
5795	340	4112343	1998-03-01	1998-03-12	1
7114	419	40481087	1991-10-23	1991-10-30	1
16989	1016	260139	2000-12-19	2001-01-02	1
20422	1229	4112343	1986-12-11	1986-12-23	1
59401	3527	40481087	2005-04-14	2005-05-05	1
29935	1773	4218389	1992-01-12	1992-02-16	1
29990	1776	40481087	1999-10-11	1999-10-25	1
84479	5031	0	1941-02-01	1941-02-02	1
28012	1657	40481087	2011-11-24	2011-12-08	1
58831	3494	260139	1968-03-22	1968-03-29	1
23743	1418	260139	1988-03-09	1988-03-16	1
29694	1759	372328	1987-11-30	1988-06-06	1
73322	4364	260139	2019-01-08	2019-01-15	1
20684	1245	0	1985-08-27	1985-08-28	1
84122	5001	80180	1997-01-03	1997-01-04	1
87037	5189	4218389	1978-08-19	1978-09-23	1
2472	145	378001	2004-08-09	2004-09-08	1
36207	2149	28060	1961-10-08	1961-10-15	1
85324	5079	80180	2008-05-19	2008-05-20	1
52609	3118	40481087	1956-03-05	1956-03-26	1
79142	4690	4156265	1991-05-26	1991-06-09	1
29317	1738	40481087	1998-01-11	1998-01-25	1
22611	1352	4112343	1985-07-16	1985-07-26	1
26741	1585	4156265	1969-09-15	1969-10-06	1
76323	4531	372328	1915-01-26	1915-05-08	1
32535	1934	4094814	1985-08-16	1985-10-15	1
78839	4675	40480160	2012-07-12	2012-09-10	1
25259	1508	378001	1968-05-05	1968-06-04	1
74798	4448	4218389	1978-05-09	1978-06-06	1
77130	4574	4112343	2008-06-11	2008-06-20	1
64640	3825	80180	1994-06-21	1994-06-22	1
77675	4606	4112343	2003-09-01	2003-09-08	1
25355	1512	260139	1983-04-05	1983-04-12	1
5947	350	4237458	1970-11-03	1971-02-01	1
3530	202	40481087	1944-07-17	1944-08-07	1
20190	1216	80180	2012-05-09	2012-05-10	1
74274	4413	40481087	1994-05-23	1994-06-06	1
27235	1608	40481087	1942-03-20	1942-03-27	1
87334	5203	40481087	1950-06-20	1950-06-27	1
57381	3409	4112343	2017-03-13	2017-03-20	1
80160	4755	4134304	2014-05-24	2014-06-23	1
86216	5137	260139	2008-07-13	2008-07-27	1
31155	1846	192671	1987-12-07	1987-12-08	1
66089	3916	4285898	2015-08-11	2015-08-12	1
29802	1764	4112343	2002-06-08	2002-06-18	1
24771	1478	81151	2016-04-04	2016-04-18	1
4565	268	0	1989-02-16	1989-02-17	1
22702	1356	40481087	2009-08-24	2009-09-14	1
82351	4890	260139	1965-10-31	1965-11-14	1
26994	1599	4112343	1991-12-18	1991-12-30	1
23859	1427	4112343	1978-06-24	1978-07-03	1
10553	621	4112343	1929-04-14	1929-04-26	1
5796	340	40481087	1967-01-02	1967-01-16	1
7115	419	80180	1954-08-08	1954-08-09	1
16990	1016	4112343	2002-10-22	2002-10-30	1
20423	1229	40481087	1961-05-28	1961-06-18	1
59402	3527	40481087	2017-03-19	2017-03-26	1
29936	1773	40481087	1955-02-13	1955-02-27	1
29991	1776	81151	1931-08-23	1931-09-13	1
84480	5031	81151	2009-08-28	2009-09-11	1
28439	1685	78272	2014-12-13	2015-01-10	1
58832	3494	260139	1981-04-01	1981-04-15	1
23744	1418	260139	2016-01-18	2016-01-25	1
29695	1759	40481087	1999-02-21	1999-03-07	1
73323	4364	372328	1952-09-21	1952-12-07	1
20685	1245	0	2003-10-10	2003-10-11	1
84123	5001	4112343	2010-01-31	2010-02-12	1
87038	5189	40481087	1986-03-15	1986-04-05	1
2473	145	4113008	1984-04-12	1984-04-26	1
36208	2149	80180	1995-11-25	1995-11-26	1
85325	5079	260139	1999-11-08	1999-11-22	1
52610	3118	40481087	2004-12-19	2005-01-02	1
79143	4690	40481087	1964-11-07	1964-11-28	1
29318	1738	40481087	1998-08-02	1998-08-09	1
22612	1352	4112343	1996-10-09	1996-10-19	1
26742	1585	40481087	1930-10-18	1930-11-01	1
76324	4531	4109685	1916-07-19	1916-08-02	1
32536	1934	4156265	2001-11-02	2001-11-23	1
78840	4675	40481087	1980-06-19	1980-07-10	1
25260	1508	381316	1982-11-23	1982-11-24	1
74799	4448	4294548	2009-11-23	2010-03-29	1
77131	4574	40481087	2019-04-21	2019-04-28	1
64641	3825	372328	1955-07-06	1955-08-19	1
77676	4606	4112343	2010-06-07	2010-06-14	1
25356	1512	4283893	2014-02-16	2014-04-27	1
5948	350	40481087	2006-06-06	2006-06-27	1
3531	202	40481087	1965-05-27	1965-06-10	1
20191	1216	4146173	2017-02-06	2017-04-07	1
74275	4413	0	1996-11-29	1996-11-30	1
27236	1608	40481087	1965-09-18	1965-09-25	1
87335	5203	40481087	1997-01-29	1997-02-19	1
57382	3409	4112343	2017-05-21	2017-06-02	1
81453	4837	321042	2004-03-23	2004-03-24	1
86217	5137	4112343	1968-09-15	1968-09-22	1
31156	1846	260139	1975-10-24	1975-11-07	1
66090	3916	4310024	2013-07-22	2013-07-23	1
29803	1764	4112343	2003-05-18	2003-05-31	1
24772	1478	260139	1997-12-22	1997-12-29	1
4566	268	4112343	1979-07-06	1979-07-17	1
22703	1356	80180	2016-09-11	2016-09-12	1
82352	4890	260139	1971-01-29	1971-02-05	1
26995	1599	4112343	2013-10-07	2013-10-18	1
23860	1427	4142905	1958-09-24	1958-11-23	1
10554	621	4112343	1939-11-17	1939-11-26	1
5797	340	40481087	1981-11-14	1981-12-05	1
7116	419	255848	1995-12-01	1995-12-02	1
16991	1016	80180	2010-01-24	2010-01-25	1
20424	1229	40481087	1983-06-02	1983-06-23	1
59403	3527	30753	2001-09-26	2001-09-27	1
29937	1773	40481087	1977-05-08	1977-05-15	1
29992	1776	372328	1920-01-28	1920-04-03	1
84481	5031	260139	1928-02-17	1928-02-24	1
28440	1685	80180	2015-10-19	2015-10-20	1
58833	3494	375671	1985-01-05	1985-03-06	1
23745	1418	378001	1979-07-14	1979-08-13	1
29696	1759	40481087	2012-05-05	2012-05-26	1
73324	4364	40479768	1963-09-24	1963-10-31	1
20686	1245	260139	1948-11-11	1948-11-25	1
84124	5001	4237458	1973-05-05	1973-06-04	1
89745	5343	28060	1991-03-04	1991-03-16	1
2474	145	4116491	1980-01-14	1980-03-08	1
36209	2149	81151	1982-03-14	1982-04-04	1
85326	5079	4112343	2002-12-15	2002-12-25	1
52611	3118	261325	1983-06-05	1983-06-06	1
79144	4690	40481087	2003-10-01	2003-10-15	1
29319	1738	28060	1976-07-13	1976-07-21	1
22613	1352	40481087	1998-06-30	1998-07-07	1
26743	1585	40481087	1944-02-03	1944-02-10	1
76325	4531	4113008	2004-10-29	2004-11-19	1
32537	1934	192671	2000-09-08	2000-09-09	1
78841	4675	40481087	1988-07-05	1988-07-12	1
25261	1508	440086	1936-12-28	1938-08-29	1
74800	4448	40481087	1958-07-02	1958-07-16	1
77132	4574	28060	1958-12-02	1958-12-14	1
64642	3825	40481087	1979-05-24	1979-06-07	1
77677	4606	4112343	2017-11-07	2017-11-16	1
25357	1512	28060	1987-10-03	1987-10-16	1
5949	350	198809	1995-09-11	1995-09-11	1
3532	202	40481087	1990-04-09	1990-04-16	1
20192	1216	40481087	2009-12-21	2010-01-11	1
74276	4413	28060	1966-06-04	1966-06-17	1
27237	1608	40481087	1983-11-14	1983-11-28	1
87336	5203	28060	1947-01-24	1947-02-05	1
57383	3409	4134304	2005-01-27	2005-02-26	1
81454	4837	372328	1949-09-17	1949-11-29	1
86218	5137	4113008	1998-04-21	1998-05-05	1
31157	1846	260139	1979-09-29	1979-10-13	1
66091	3916	40479422	1997-06-17	1997-07-24	1
29804	1764	4310024	1994-10-24	1994-10-25	1
24773	1478	4048171	1964-03-27	1964-03-28	1
4567	268	4112343	2004-12-04	2004-12-13	1
22704	1356	260139	1988-11-04	1988-11-11	1
82353	4890	260139	1980-05-26	1980-06-09	1
26996	1599	4278672	1966-11-09	1966-12-09	1
23861	1427	4152936	1983-01-28	1983-02-18	1
10555	621	4112343	1952-12-12	1952-12-21	1
5798	340	80180	1995-06-24	1995-06-25	1
7117	419	4112343	1915-01-11	1915-01-20	1
16992	1016	378001	1983-05-21	1983-07-20	1
20425	1229	78272	2012-06-09	2012-06-23	1
59404	3527	80180	2002-03-25	2002-03-26	1
29938	1773	80180	1986-01-29	1986-01-30	1
29993	1776	4109685	1921-09-30	1921-10-14	1
84482	5031	260139	1943-08-05	1943-08-19	1
28441	1685	4112343	1980-09-10	1980-09-20	1
58834	3494	4094814	2014-12-20	2015-01-19	1
23746	1418	4112343	2002-06-12	2002-06-19	1
30518	1804	28060	1945-02-08	1945-02-19	1
73325	4364	28060	1961-03-26	1961-04-04	1
20687	1245	313217	2016-07-01	2016-07-02	1
84125	5001	40479422	1975-04-25	1975-07-01	1
89746	5343	28060	2008-08-11	2008-08-24	1
2475	145	4149245	1981-07-06	1981-08-05	1
36210	2149	260139	1996-10-12	1996-10-19	1
85327	5079	4266809	2008-05-19	2008-05-20	1
52612	3118	372328	1951-05-08	1951-09-09	1
79145	4690	40481087	2006-05-19	2006-06-02	1
29320	1738	80180	2013-02-27	2013-02-28	1
22614	1352	40481087	1999-03-13	1999-04-03	1
26744	1585	40481087	1987-03-01	1987-03-08	1
76326	4531	4283893	1927-02-20	1927-03-06	1
32538	1934	260139	2013-01-22	2013-01-29	1
78842	4675	40481087	2000-06-16	2000-06-30	1
25262	1508	4146173	1986-04-01	1986-05-31	1
74801	4448	40481087	1964-08-16	1964-08-30	1
77133	4574	40481087	1986-12-18	1987-01-01	1
64643	3825	40481087	1992-10-20	1992-11-03	1
77678	4606	4134304	2013-06-03	2013-07-03	1
25358	1512	40481087	1994-11-15	1994-11-29	1
5950	350	260139	2008-11-01	2008-11-08	1
3533	202	40481087	2004-08-20	2004-08-27	1
20193	1216	28060	1971-03-22	1971-04-01	1
74277	4413	260139	2012-04-18	2012-04-25	1
27238	1608	40481087	2010-09-20	2010-09-27	1
87337	5203	260139	1941-05-16	1941-05-30	1
57384	3409	40481087	1968-03-18	1968-04-01	1
81455	4837	375671	1980-11-01	1980-12-01	1
86219	5137	28060	1999-11-22	1999-11-30	1
31158	1846	378001	1956-08-28	1956-10-27	1
66092	3916	40479422	2007-08-01	2007-10-07	1
29805	1764	40481087	1961-06-30	1961-07-07	1
24774	1478	4084167	1990-11-23	1990-11-23	1
4568	268	4299128	1977-05-29	1977-06-19	1
22705	1356	372328	2016-08-07	2016-10-14	1
82354	4890	313217	2009-12-09	2009-12-10	1
26997	1599	40481087	1981-07-28	1981-08-11	1
23862	1427	40481087	1983-03-16	1983-03-30	1
10556	621	40481087	1951-01-31	1951-02-21	1
5799	340	375671	2005-03-13	2005-04-12	1
7118	419	4142905	1979-12-26	1980-03-25	1
16993	1016	378001	1993-11-24	1993-12-24	1
20426	1229	134438	1980-05-15	1981-01-10	1
59405	3527	81151	1974-02-19	1974-03-12	1
29939	1773	260139	1969-12-21	1970-01-04	1
29994	1776	4112343	1926-08-30	1926-09-11	1
84483	5031	260139	2015-01-07	2015-01-14	1
28442	1685	4112343	2004-03-16	2004-03-29	1
58835	3494	4109685	1984-01-27	1984-02-10	1
23747	1418	4112343	2012-08-29	2012-09-05	1
30519	1804	4112343	1945-07-23	1945-08-05	1
73326	4364	80180	1987-05-16	1987-05-17	1
20688	1245	372328	1935-10-02	1935-11-15	1
84126	5001	40481087	1965-01-03	1965-01-10	1
89747	5343	4112343	1999-02-21	1999-02-28	1
2476	145	40481087	1954-02-11	1954-02-25	1
36211	2149	4112343	1962-12-13	1962-12-25	1
85328	5079	81893	2007-03-26	2007-03-27	1
52613	3118	4112343	1989-05-03	1989-05-16	1
79146	4690	28060	2008-05-03	2008-05-12	1
29321	1738	260139	1979-05-01	1979-05-17	1
22615	1352	40481087	2015-03-14	2015-03-28	1
28789	1707	4027663	1998-08-03	1998-08-04	1
76327	4531	40481087	1943-06-02	1943-06-16	1
32539	1934	372328	1963-04-29	1963-07-06	1
78843	4675	40481087	2008-02-17	2008-03-02	1
25263	1508	4152936	1967-05-20	1967-06-10	1
74802	4448	40481087	1999-06-10	1999-06-24	1
77134	4574	40481087	1991-07-18	1991-08-08	1
64644	3825	40481087	2017-09-19	2017-09-26	1
77679	4606	40481087	1990-01-20	1990-02-03	1
25359	1512	40481087	2002-04-12	2002-04-26	1
5951	350	4112343	1972-07-07	1972-07-19	1
3534	202	28060	2002-11-23	2002-12-06	1
20194	1216	81151	1993-11-20	1993-12-25	1
74278	4413	4112343	1998-01-15	1998-01-25	1
27239	1608	81151	1947-12-10	1947-12-24	1
87338	5203	260139	1973-08-03	1973-08-10	1
57385	3409	40481087	1987-12-21	1988-01-04	1
81456	4837	4001336	1987-06-28	1987-08-27	1
86220	5137	80180	2004-03-28	2004-03-29	1
31159	1846	4094814	1963-12-20	1964-03-19	1
66093	3916	40481087	1987-01-26	1987-02-09	1
29806	1764	40481087	1997-01-11	1997-01-18	1
24775	1478	4155034	2001-09-22	2001-10-06	1
4569	268	40481087	2019-05-23	2019-05-30	1
22706	1356	4112343	1986-12-29	1987-01-09	1
82355	4890	372328	1925-07-26	1925-11-04	1
26998	1599	260139	1971-10-24	1971-10-31	1
23863	1427	40481087	1985-02-26	1985-03-19	1
10557	621	40481087	1962-07-01	1962-07-08	1
5800	340	4237458	2001-05-03	2001-06-02	1
7119	419	40481087	1938-08-06	1938-08-20	1
16994	1016	40481087	1975-12-03	1975-12-10	1
20427	1229	260139	1957-07-29	1957-08-05	1
59406	3527	4084167	1962-03-10	1962-03-10	1
29940	1773	372328	1957-04-26	1957-08-11	1
29995	1776	4112343	1964-08-26	1964-09-08	1
84484	5031	372328	1922-01-08	1922-07-15	1
28443	1685	4266809	2015-10-19	2015-10-20	1
58836	3494	40481087	2017-06-11	2017-06-25	1
23748	1418	4132546	2005-10-25	2005-10-26	1
30520	1804	40481087	1946-08-23	1946-08-30	1
73327	4364	260139	2005-03-18	2005-04-01	1
20689	1245	378001	1999-10-25	1999-12-24	1
84127	5001	40481087	1966-01-14	1966-01-21	1
89748	5343	4112343	2009-04-22	2009-05-04	1
2477	145	40481087	1962-02-22	1962-03-08	1
36212	2149	4112343	1999-05-24	1999-06-06	1
85329	5079	260139	1970-12-22	1970-12-29	1
52614	3118	40481087	1969-08-07	1969-08-21	1
79147	4690	80180	2001-03-20	2001-03-21	1
29322	1738	260139	2006-03-19	2006-04-02	1
24909	1490	81151	1998-11-10	1998-11-24	1
28790	1707	4266809	2006-04-18	2006-04-19	1
76328	4531	40481087	1952-09-03	1952-09-10	1
32540	1934	372328	1964-07-02	1965-01-09	1
78844	4675	260139	1959-07-08	1959-07-15	1
25264	1508	4156265	1943-01-12	1943-01-26	1
74803	4448	28060	1955-05-14	1955-05-24	1
77135	4574	28060	1982-09-21	1982-10-02	1
65434	3874	28060	1986-06-14	1986-06-23	1
77680	4606	40481087	2012-07-03	2012-07-24	1
25360	1512	40481087	2005-09-13	2005-10-04	1
5952	350	4112343	2009-11-07	2009-11-17	1
3535	202	78272	1940-05-02	1940-05-23	1
20195	1216	261325	2013-01-08	2013-01-09	1
74279	4413	260139	2013-06-21	2013-07-05	1
27240	1608	260139	1952-03-01	1952-03-08	1
87339	5203	317576	1988-08-31	1988-09-01	1
57386	3409	40481087	2003-07-02	2003-07-09	1
81457	4837	4112343	1966-05-09	1966-05-19	1
86221	5137	260139	1975-01-17	1975-01-24	1
31160	1846	4112343	1956-03-03	1956-03-10	1
66094	3916	40481087	1987-05-15	1987-06-05	1
29807	1764	30753	1995-07-21	1995-07-22	1
26206	1558	80180	1992-09-01	1992-09-02	1
4570	268	28060	1969-10-12	1969-10-22	1
22707	1356	4285898	2016-05-14	2016-05-15	1
82356	4890	4112343	1934-08-15	1934-08-28	1
26999	1599	378001	2003-09-26	2003-10-26	1
23864	1427	40481087	1990-05-27	1990-06-03	1
10558	621	40481087	1966-02-23	1966-03-02	1
5801	340	40481087	1962-03-29	1962-04-19	1
7120	419	30753	1953-05-15	1953-05-16	1
17746	1070	80180	2009-09-14	2009-09-15	1
20428	1229	260139	2005-07-29	2005-08-12	1
59407	3527	4084167	1963-04-09	1963-04-09	1
29941	1773	4084167	1965-01-14	1965-01-14	1
29996	1776	4112343	2014-09-29	2014-10-08	1
84485	5031	4112343	1931-09-09	1931-09-17	1
28444	1685	4296204	1989-09-11	1989-09-25	1
58837	3494	28060	1964-10-23	1964-11-01	1
23749	1418	4294548	2001-07-18	2001-09-12	1
30521	1804	40481087	1953-12-27	1954-01-10	1
73328	4364	260139	2012-11-15	2012-11-22	1
20690	1245	440448	1985-08-27	1985-08-28	1
84128	5001	40481087	1968-07-17	1968-07-31	1
89749	5343	40481087	2001-03-16	2001-03-30	1
2478	145	40481087	1985-12-30	1986-01-06	1
36213	2149	40481087	1993-08-10	1993-08-31	1
85330	5079	40481087	1974-07-07	1974-07-14	1
52615	3118	40481087	2004-06-22	2004-07-13	1
79148	4690	80502	2016-10-01	2016-10-02	1
29323	1738	4112343	1972-05-01	1972-05-09	1
24910	1490	4027663	1962-12-03	1962-12-04	1
28791	1707	40481087	2005-04-07	2005-04-14	1
76329	4531	40481087	1974-05-01	1974-05-22	1
32541	1934	4112343	2001-04-22	2001-04-30	1
78845	4675	378001	2001-06-10	2001-08-09	1
25265	1508	4283893	2004-04-26	2004-09-06	1
74804	4448	80180	1995-01-20	1995-01-21	1
77136	4574	81151	1970-11-28	1971-01-02	1
65435	3874	80180	2014-10-06	2014-10-07	1
77681	4606	260139	2018-04-10	2018-04-17	1
25361	1512	40481087	2011-12-09	2011-12-23	1
5953	350	4155034	1999-05-10	1999-05-24	1
3536	202	260139	1998-01-30	1998-02-06	1
20196	1216	378001	1983-08-15	1983-10-14	1
74280	4413	372328	1962-07-01	1962-10-11	1
27241	1608	372328	1945-03-08	1946-02-16	1
87340	5203	372328	1938-03-31	1938-07-20	1
57387	3409	28060	1955-11-17	1955-11-25	1
81458	4837	4112343	1992-03-06	1992-03-13	1
86222	5137	260139	1992-07-20	1992-08-03	1
31161	1846	4112343	1976-07-09	1976-07-18	1
66095	3916	40486433	1983-10-10	1983-10-11	1
29808	1764	260139	1992-12-22	1992-12-29	1
26207	1558	198809	1962-06-14	1962-06-14	1
4571	268	372328	1967-11-18	1968-01-30	1
22708	1356	4310024	2014-10-22	2014-10-23	1
82357	4890	4112343	2004-11-05	2004-11-12	1
27000	1599	4112343	1987-02-26	1987-03-10	1
29588	1753	4112343	2011-04-22	2011-05-01	1
10559	621	40481087	1997-01-04	1997-01-18	1
5802	340	40481087	1977-12-08	1977-12-29	1
7121	419	78272	1924-12-23	1925-01-13	1
17747	1070	81151	1976-09-12	1976-10-03	1
20429	1229	40481087	1955-12-12	1956-01-02	1
59408	3527	4112343	1962-11-08	1962-11-15	1
29942	1773	4112343	1974-01-25	1974-02-05	1
29997	1776	40481087	1959-12-13	1959-12-27	1
84486	5031	4112343	1944-11-08	1944-11-17	1
28445	1685	30753	2014-08-25	2014-08-26	1
58838	3494	80180	1999-01-18	1999-01-19	1
23750	1418	40481087	2004-06-04	2004-06-11	1
30522	1804	40481087	1996-01-02	1996-01-16	1
73329	4364	4112343	1958-08-25	1958-09-07	1
20691	1245	4059173	1959-02-17	1959-05-18	1
84129	5001	260139	1965-02-11	1965-02-18	1
89750	5343	40486433	1986-01-08	1986-01-09	1
2479	145	40481087	1997-08-26	1997-09-02	1
36214	2149	40486433	1962-04-24	1962-04-25	1
85968	5121	30753	1999-05-07	1999-05-08	1
57759	3431	78272	1967-06-16	1967-07-07	1
79149	4690	257012	2005-05-06	2005-05-07	1
29324	1738	4296205	2014-12-19	2015-01-02	1
24911	1490	4059173	1993-01-10	1993-02-09	1
28792	1707	80180	2006-04-18	2006-04-19	1
76330	4531	40481087	1989-08-09	1989-08-16	1
32542	1934	4112343	2017-04-07	2017-04-18	1
78846	4675	4134304	1994-07-17	1994-08-16	1
25266	1508	40481087	1927-06-21	1927-07-12	1
74805	4448	4112343	1961-12-20	1961-12-30	1
77137	4574	4112343	2007-01-05	2007-01-14	1
920	53	260139	1992-11-06	1992-11-20	1
77682	4606	4113008	2006-10-24	2006-11-07	1
29486	1748	81151	1976-12-26	1977-01-23	1
5954	350	28060	2019-04-15	2019-04-23	1
3537	202	40481087	1963-07-07	1963-07-28	1
20197	1216	4109685	2006-05-21	2006-06-04	1
74281	4413	372328	1964-02-03	1964-04-09	1
27242	1608	378001	1959-04-16	1959-05-16	1
87341	5203	378001	1978-06-04	1978-08-03	1
57388	3409	28060	1955-12-27	1956-01-06	1
81459	4837	372328	1954-07-16	1954-12-07	1
86223	5137	260139	2002-09-05	2002-09-12	1
31162	1846	4112343	2010-12-18	2010-12-25	1
66096	3916	28060	2001-11-20	2001-11-30	1
29809	1764	260139	1995-01-19	1995-01-26	1
26208	1558	260139	2006-04-06	2006-04-13	1
4572	268	80180	2004-01-28	2004-01-29	1
25969	1542	260139	1970-09-01	1970-09-15	1
82358	4890	4116491	1976-11-04	1976-12-20	1
27001	1599	4112343	2006-10-14	2006-10-27	1
29589	1753	4296204	1972-05-09	1972-05-23	1
10560	621	40481087	2001-06-18	2001-07-02	1
5803	340	40481087	1993-07-25	1993-08-08	1
7122	419	80502	1992-04-12	1992-04-13	1
17748	1070	192671	2009-10-30	2009-10-31	1
20430	1229	40481087	2003-01-19	2003-02-02	1
59409	3527	4112343	2018-08-01	2018-08-08	1
29943	1773	4112343	1984-12-24	1985-01-05	1
29998	1776	40481087	2012-11-24	2012-12-15	1
84487	5031	4134304	1990-08-17	1990-10-16	1
28446	1685	192671	2016-01-14	2016-01-15	1
58839	3494	260139	2003-07-03	2003-07-17	1
23751	1418	40481087	2012-09-23	2012-09-30	1
30523	1804	372328	1940-03-10	1940-09-23	1
73330	4364	4112343	2007-07-20	2007-07-31	1
20692	1245	4112343	1964-05-27	1964-06-04	1
84130	5001	260139	2000-06-07	2000-06-21	1
89751	5343	260139	1998-01-04	1998-01-11	1
2480	145	80180	1990-10-06	1990-10-07	1
36215	2149	4084167	1959-10-15	1959-10-15	1
85969	5121	80180	2000-02-01	2000-02-02	1
57760	3431	80180	1999-05-19	1999-05-20	1
79150	4690	260139	1978-10-14	1978-10-28	1
29325	1738	40481087	2004-02-16	2004-03-08	1
24912	1490	4112343	1999-04-18	1999-04-27	1
28793	1707	372328	1973-10-23	1974-01-14	1
76331	4531	260139	1944-05-20	1944-06-03	1
32543	1934	4218389	1999-01-19	1999-02-16	1
78847	4675	4296205	1946-09-08	1946-09-29	1
25267	1508	40481087	1980-07-04	1980-07-18	1
74806	4448	4112343	2008-02-22	2008-03-04	1
77138	4574	4112343	2009-10-17	2009-10-29	1
921	53	372328	1967-01-02	1967-04-19	1
77683	4606	78272	1992-05-12	1992-06-09	1
29487	1748	260139	1964-10-08	1964-10-22	1
5955	350	80180	2004-08-22	2004-08-23	1
3538	202	40481087	2010-03-04	2010-03-25	1
20198	1216	4116491	1988-07-24	1988-09-10	1
74282	4413	4029498	1996-11-29	1996-11-30	1
27243	1608	381316	2016-04-16	2016-04-17	1
87342	5203	4112343	1985-11-18	1985-12-01	1
57389	3409	195588	2004-07-14	2004-09-01	1
81460	4837	40481087	1990-11-18	1990-12-02	1
86224	5137	260139	2011-02-24	2011-03-10	1
31163	1846	4266809	1987-11-09	1987-11-10	1
66097	3916	80180	2016-05-07	2016-05-08	1
29810	1764	378001	2018-05-20	2018-06-19	1
26209	1558	372328	1957-09-01	1957-10-03	1
4573	268	260139	1990-03-23	1990-03-30	1
25970	1542	4112343	1992-03-24	1992-04-06	1
82359	4890	40481087	1926-11-09	1926-11-30	1
27002	1599	4112343	2008-01-21	2008-02-02	1
29590	1753	40481087	1970-01-29	1970-02-19	1
12877	759	28060	1980-08-22	1980-09-02	1
7473	440	28060	1997-03-23	1997-04-01	1
7123	419	81151	1988-12-08	1989-01-12	1
17749	1070	260139	1982-06-05	1982-06-19	1
20431	1229	40481087	2004-03-03	2004-03-10	1
59410	3527	4294548	2001-05-19	2001-06-09	1
29944	1773	40481087	1984-09-10	1984-09-24	1
33264	1977	260139	1957-08-07	1957-08-14	1
84488	5031	4283893	1990-05-07	1990-09-24	1
28447	1685	260139	1997-10-29	1997-11-12	1
58840	3494	440086	1970-08-03	1977-08-11	1
23752	1418	4027663	2006-08-20	2006-08-21	1
30524	1804	378001	1976-10-22	1976-11-21	1
73331	4364	4112343	2013-01-31	2013-02-10	1
20693	1245	4296205	1949-02-18	1949-03-11	1
84131	5001	4109685	1970-01-30	1970-02-20	1
89752	5343	372328	1986-02-15	1986-06-08	1
2481	145	372328	1950-10-21	1950-11-04	1
36216	2149	4112343	1968-07-12	1968-07-21	1
85970	5121	260139	1988-10-12	1988-10-26	1
57761	3431	4051466	1964-10-16	1982-01-19	1
79151	4690	4112343	1998-01-12	1998-01-22	1
29326	1738	4112343	1974-01-30	1974-02-10	1
24913	1490	4112343	1999-06-27	1999-07-07	1
28794	1707	4112343	1988-01-12	1988-01-21	1
76332	4531	260139	1967-12-11	1967-12-25	1
32544	1934	4283893	1987-12-01	1987-12-22	1
78848	4675	40480160	2006-11-11	2006-12-11	1
25268	1508	40481087	2001-03-21	2001-04-04	1
74807	4448	40481087	1961-03-07	1961-03-28	1
77139	4574	4112343	2013-09-10	2013-09-21	1
922	53	4112343	1977-05-23	1977-05-31	1
77684	4606	40481087	1985-11-21	1985-12-05	1
29488	1748	260139	1975-02-28	1975-03-07	1
5956	350	81151	1984-02-23	1984-03-29	1
3539	202	81151	2008-09-26	2008-10-24	1
20199	1216	4278672	1973-03-10	1973-04-09	1
74283	4413	4094814	1969-01-25	1969-02-24	1
27244	1608	4112343	1953-01-12	1953-01-20	1
87343	5203	4329847	1999-02-17	1999-02-18	1
57390	3409	260139	1985-10-25	1985-11-01	1
81461	4837	40481087	1996-06-10	1996-06-24	1
86225	5137	4051466	1970-06-27	1986-10-05	1
33057	1964	81151	2009-04-25	2009-05-23	1
66098	3916	81893	2013-11-19	2013-11-20	1
29811	1764	4218389	2000-09-09	2000-10-14	1
26210	1558	378001	1995-09-12	1995-11-11	1
4574	268	4166224	1989-02-16	1989-02-17	1
25971	1542	80180	2005-07-02	2005-07-03	1
82360	4890	40481087	1967-02-01	1967-02-15	1
27003	1599	40481087	1980-11-09	1980-11-23	1
29591	1753	28060	1998-04-18	1998-04-29	1
12878	759	260139	2005-07-25	2005-08-01	1
7474	440	260139	1994-03-07	1994-03-21	1
7124	419	260139	1922-10-31	1922-11-07	1
17750	1070	40481087	1977-02-14	1977-02-21	1
20432	1229	40481087	2011-05-10	2011-05-31	1
59411	3527	40481087	1996-09-26	1996-10-03	1
31341	1854	260139	1973-06-21	1973-07-05	1
33265	1977	260139	1984-12-18	1985-01-01	1
84489	5031	4294548	1994-09-10	1994-12-10	1
28448	1685	4112343	1989-01-10	1989-01-22	1
58841	3494	4112343	1967-04-22	1967-05-04	1
23753	1418	4285898	2014-03-11	2014-03-12	1
30525	1804	381316	1999-06-14	1999-06-15	1
73332	4364	40481087	1983-08-19	1983-08-26	1
20694	1245	40481087	1943-06-30	1943-07-07	1
84132	5001	4112343	1984-01-14	1984-01-24	1
89753	5343	4084167	1999-05-11	1999-05-11	1
2482	145	4155034	1979-10-24	1979-11-14	1
36217	2149	40481087	1962-03-29	1962-04-12	1
85971	5121	4112343	1981-10-29	1981-11-05	1
57762	3431	4116491	1988-10-03	1988-11-05	1
79152	4690	4116491	2012-07-16	2012-09-09	1
29327	1738	4112343	2005-11-29	2005-12-09	1
24914	1490	4310024	1972-06-28	1972-06-29	1
28795	1707	40481087	1990-01-19	1990-02-09	1
76333	4531	4059173	1995-04-20	1995-05-20	1
32545	1934	40481087	1976-09-21	1976-10-05	1
78849	4675	40481087	1928-01-03	1928-01-24	1
25269	1508	28060	1959-07-07	1959-07-15	1
74808	4448	30753	1993-11-26	1993-11-27	1
77140	4574	4113008	1985-10-15	1985-10-29	1
923	53	4112343	1980-02-19	1980-02-27	1
79208	4696	80180	1985-12-25	1985-12-26	1
29489	1748	260139	1987-09-01	1987-09-15	1
5957	350	196456	1995-09-11	1995-09-11	1
3540	202	378419	2016-01-02	2016-01-03	1
20200	1216	40481087	1997-04-12	1997-04-19	1
74284	4413	4112343	1981-01-31	1981-02-12	1
27245	1608	4112343	2012-11-04	2012-11-14	1
87344	5203	40481087	1952-09-22	1952-10-13	1
57391	3409	372328	1960-08-18	1961-04-13	1
81462	4837	0	2004-03-23	2004-03-24	1
86226	5137	4116491	1997-06-13	1997-07-25	1
33058	1964	4112343	1961-10-01	1961-10-09	1
66099	3916	4112343	1979-11-18	1979-12-01	1
29812	1764	4283893	1974-06-01	1974-07-13	1
26211	1558	4283893	2016-10-30	2016-11-27	1
4575	268	40481087	2016-08-08	2016-08-29	1
25972	1542	260139	2012-10-13	2012-10-27	1
82361	4890	40481087	1998-02-17	1998-03-03	1
27004	1599	40481087	2013-09-12	2013-09-19	1
29592	1753	4027663	1993-04-30	1993-05-01	1
12879	759	260139	2017-09-07	2017-09-21	1
7475	440	80180	2009-02-17	2009-02-18	1
7125	419	260139	1943-02-22	1943-03-01	1
17751	1070	260139	1979-11-27	1979-12-11	1
21797	1310	28060	1953-11-02	1953-11-11	1
59412	3527	40481087	2015-07-16	2015-07-23	1
31342	1854	260139	1986-07-05	1986-07-12	1
33266	1977	313217	2012-05-31	2012-06-01	1
84490	5031	40481087	1947-09-08	1947-09-29	1
28449	1685	40481087	1987-02-09	1987-03-02	1
58842	3494	4112343	1996-12-13	1996-12-24	1
23754	1418	40481087	1979-05-31	1979-06-07	1
30526	1804	4112343	1943-03-07	1943-03-20	1
73333	4364	40481087	2013-06-03	2013-06-24	1
20695	1245	40481087	1983-02-24	1983-03-17	1
84133	5001	4112343	2010-07-16	2010-07-27	1
89754	5343	4112343	2010-04-01	2010-04-14	1
2483	145	4156265	1982-06-01	1982-06-22	1
36218	2149	81151	1960-02-12	1960-03-04	1
85972	5121	4266809	2000-02-01	2000-02-02	1
57763	3431	4218389	1981-09-05	1981-09-26	1
79153	4690	4155034	1980-02-09	1980-02-23	1
29328	1738	4218389	1980-11-12	1980-12-17	1
24915	1490	40481087	1960-02-03	1960-02-24	1
28796	1707	40481087	1990-10-16	1990-10-30	1
76334	4531	4112343	1923-10-12	1923-10-23	1
32546	1934	40481087	1977-07-07	1977-07-21	1
78850	4675	40481087	1947-05-06	1947-05-20	1
25270	1508	80502	1984-12-11	1984-12-12	1
74809	4448	4112343	1965-03-17	1965-03-29	1
77141	4574	40481087	2000-03-31	2000-04-21	1
924	53	4230399	1988-02-26	1988-04-26	1
79209	4696	260139	1962-02-03	1962-02-10	1
29490	1748	4112343	2007-01-24	2007-01-31	1
5958	350	378001	1986-12-14	1987-01-13	1
3541	202	381316	1997-10-25	1997-10-26	1
20201	1216	260139	2005-12-18	2005-12-25	1
74285	4413	4112343	1986-01-20	1986-01-29	1
27246	1608	4134304	1979-04-22	1979-06-21	1
87345	5203	78272	1980-03-25	1980-04-22	1
57392	3409	4109685	1984-06-04	1984-06-18	1
81463	4837	80180	1981-11-03	1981-11-04	1
86227	5137	4156265	1987-06-06	1987-06-27	1
33059	1964	40481087	2010-04-11	2010-04-25	1
66100	3916	4112343	2019-04-04	2019-04-13	1
29813	1764	40479422	2008-12-01	2009-02-06	1
26212	1558	40481087	1955-08-29	1955-09-05	1
4576	268	378001	1992-05-01	1992-05-31	1
25973	1542	378001	1990-11-27	1991-01-26	1
82362	4890	81151	2000-10-17	2000-11-21	1
27005	1599	80180	1997-12-21	1997-12-22	1
29593	1753	4051466	1967-05-14	1986-05-29	1
12880	759	372328	1946-07-27	1946-12-11	1
7476	440	4112343	1995-12-17	1995-12-28	1
7126	419	372328	1916-06-22	1916-07-23	1
17752	1070	260139	2007-02-11	2007-02-18	1
21798	1310	372328	2013-10-10	2013-10-11	1
59413	3527	28060	1975-06-28	1975-07-08	1
31343	1854	260139	1992-08-17	1992-08-24	1
33267	1977	4112343	1921-12-10	1921-12-19	1
84491	5031	40481087	1975-06-14	1975-07-05	1
28450	1685	40481087	2002-12-11	2002-12-25	1
58843	3494	4112343	1997-08-22	1997-09-04	1
23755	1418	40481087	2013-10-01	2013-10-15	1
30527	1804	4116491	1976-10-03	1976-11-18	1
75259	4474	81151	2017-10-17	2017-11-21	1
20696	1245	40481087	2012-02-01	2012-02-08	1
84134	5001	40481087	1976-03-11	1976-04-01	1
89755	5343	4113008	2016-11-04	2016-11-18	1
2484	145	4237458	2003-05-17	2003-08-15	1
36219	2149	257012	1961-12-22	1961-12-23	1
85973	5121	4310024	1998-08-10	1998-08-11	1
57764	3431	28060	1967-10-15	1967-10-28	1
79154	4690	4155034	2007-05-05	2007-05-26	1
29329	1738	40481087	1991-04-06	1991-04-13	1
24916	1490	257012	1996-09-03	1996-10-01	1
28797	1707	40481087	2013-03-04	2013-03-11	1
76335	4531	4112343	1940-05-11	1940-05-20	1
35030	2082	80180	1975-09-15	1975-09-16	1
78851	4675	40481087	1974-04-23	1974-04-30	1
25271	1508	81151	1934-03-09	1934-03-30	1
74810	4448	4112343	1966-01-26	1966-02-03	1
77142	4574	260139	1990-02-06	1990-02-13	1
925	53	40481087	1991-10-29	1991-11-12	1
79210	4696	4112343	2006-01-16	2006-01-25	1
29491	1748	4146173	1995-06-09	1995-08-08	1
5959	350	4112343	1971-10-25	1971-11-06	1
3542	202	4112343	1990-07-09	1990-07-17	1
23099	1381	28060	2016-08-21	2016-09-02	1
74286	4413	4283893	1990-05-25	1990-06-08	1
27247	1608	4152936	1974-11-23	1974-12-14	1
87346	5203	260139	1996-10-10	1996-10-17	1
57393	3409	4112343	1992-07-21	1992-07-28	1
81464	4837	260139	1979-01-15	1979-01-29	1
86228	5137	40481087	1993-05-10	1993-05-17	1
33060	1964	40481087	2011-02-24	2011-03-03	1
66101	3916	40481087	2016-05-12	2016-05-19	1
29814	1764	40481087	1969-01-16	1969-01-23	1
26213	1558	40481087	1963-08-28	1963-09-04	1
4577	268	440448	1989-02-16	1989-02-17	1
25974	1542	4112343	2003-04-12	2003-04-21	1
82363	4890	4112343	2000-06-15	2000-06-26	1
27006	1599	195588	2002-04-29	2002-06-13	1
29594	1753	4112343	1973-03-09	1973-03-16	1
12881	759	4112343	1973-03-23	1973-03-30	1
7477	440	40481087	1983-03-14	1983-03-21	1
7127	419	378419	1990-04-01	1990-04-02	1
17753	1070	260139	2017-06-26	2017-07-03	1
21799	1310	4112343	1951-07-04	1951-07-15	1
59414	3527	260139	1987-09-13	1987-09-20	1
31344	1854	260139	1993-05-07	1993-05-14	1
33268	1977	4146173	1948-11-22	1949-01-21	1
84492	5031	40481087	1983-11-28	1983-12-05	1
28451	1685	260139	1985-09-13	1985-09-27	1
58844	3494	4112343	2015-12-12	2015-12-22	1
25765	1532	260139	2006-03-02	2006-03-16	1
30528	1804	4218389	1986-06-02	1986-06-23	1
75260	4474	260139	1981-09-29	1981-10-06	1
20697	1245	78272	1986-06-30	1986-08-04	1
85941	5119	260139	1997-10-24	1997-11-07	1
89756	5343	4278672	1998-09-10	1998-11-09	1
2485	145	40481087	1973-10-14	1973-10-28	1
36220	2149	4112343	1963-12-24	1964-01-01	1
85974	5121	40481087	1966-09-13	1966-10-04	1
57765	3431	4112343	1968-09-23	1968-10-01	1
79155	4690	4218389	1974-01-20	1974-02-10	1
29330	1738	40481087	2013-05-25	2013-06-01	1
24917	1490	260139	1992-10-18	1992-11-01	1
28798	1707	372328	1976-06-02	1976-07-26	1
76336	4531	4329847	2017-04-29	2017-04-30	1
35031	2082	378001	2011-02-22	2011-03-24	1
78852	4675	80180	1948-01-09	1948-01-10	1
25272	1508	257012	2004-05-31	2004-06-01	1
74811	4448	40481087	1969-06-01	1969-06-08	1
77143	4574	372328	1958-10-02	1959-02-20	1
926	53	40481087	2008-02-14	2008-02-21	1
79211	4696	40481087	1960-11-14	1960-11-28	1
29492	1748	40481087	1947-07-09	1947-07-23	1
5960	350	4112343	2017-05-10	2017-05-22	1
3543	202	4112343	2002-05-19	2002-05-26	1
23100	1381	80180	2018-11-10	2018-11-11	1
74287	4413	40481087	1968-05-06	1968-05-27	1
27248	1608	4283893	1961-10-11	1962-06-27	1
87347	5203	4112343	1949-11-23	1949-12-03	1
57394	3409	4112343	2010-04-28	2010-05-05	1
81465	4837	260139	2008-05-29	2008-06-12	1
86229	5137	4155034	1989-05-17	1989-06-07	1
33061	1964	40481087	2017-03-01	2017-03-08	1
66102	3916	440086	1989-10-01	1989-12-31	1
31164	1847	260139	1931-08-15	1931-08-22	1
26214	1558	40481087	2018-04-29	2018-05-13	1
4578	268	4112343	2007-08-03	2007-08-11	1
25975	1542	4155034	1978-02-19	1978-03-05	1
82364	4890	40481087	1923-07-07	1923-07-21	1
27007	1599	260139	1962-09-28	1962-10-12	1
29595	1753	4112343	1976-03-31	1976-04-11	1
12882	759	4155034	2015-11-02	2015-11-23	1
7478	440	40481087	2016-08-11	2016-08-25	1
7128	419	381316	1994-07-31	1994-08-01	1
17754	1070	4112343	2000-06-29	2000-07-10	1
21800	1310	4134304	1968-02-03	1968-05-03	1
59415	3527	4027663	1994-07-05	1994-07-06	1
31345	1854	260139	2012-12-12	2012-12-26	1
33269	1977	40481087	1936-02-02	1936-02-16	1
84493	5031	80502	2000-10-14	2000-10-15	1
28452	1685	372328	1985-05-14	1985-12-29	1
59592	3536	195588	2016-01-19	2016-03-07	1
25766	1532	260139	2014-05-04	2014-05-18	1
30529	1804	40481087	1998-11-24	1998-12-15	1
75261	4474	260139	1994-08-01	1994-08-08	1
20698	1245	80180	1976-09-06	1976-09-07	1
85942	5119	4280726	1966-05-14	1981-05-12	1
89757	5343	80180	2019-02-12	2019-02-13	1
2486	145	40481087	1993-10-31	1993-11-07	1
36221	2149	4112343	1998-11-12	1998-11-23	1
85975	5121	81151	1998-10-19	1998-11-16	1
57766	3431	40481087	1969-10-10	1969-10-24	1
79156	4690	4283893	1960-02-24	1960-04-27	1
29331	1738	4116491	2009-05-09	2009-06-14	1
24918	1490	372328	1942-09-07	1942-11-19	1
28799	1707	40481087	1998-08-23	1998-09-06	1
76337	4531	40481087	1956-06-29	1956-07-13	1
35032	2082	4112343	1967-02-23	1967-03-08	1
78853	4675	81151	1941-01-09	1941-02-06	1
25273	1508	4112343	1941-12-12	1941-12-22	1
75656	4492	260139	1992-02-06	1992-02-20	1
77144	4574	4112343	1964-12-15	1964-12-22	1
927	53	78272	1965-05-01	1965-05-22	1
79212	4696	40481087	1995-06-12	1995-06-26	1
29493	1748	40481087	1961-05-13	1961-06-03	1
5961	350	4152936	1965-05-19	1965-06-02	1
3544	202	4112343	2005-04-26	2005-05-07	1
23101	1381	261325	2006-08-12	2006-08-13	1
76891	4561	260139	1954-01-22	1954-02-05	1
27249	1608	4283893	1988-05-26	1988-07-21	1
87348	5203	40481087	1988-03-19	1988-03-26	1
57395	3409	4237458	2011-04-26	2011-07-25	1
81466	4837	313217	2008-11-18	2008-11-19	1
87691	5223	80180	2004-10-27	2004-10-28	1
33062	1964	4112343	1979-10-07	1979-10-18	1
66103	3916	4112343	1979-09-03	1979-09-16	1
31165	1847	260139	1949-05-10	1949-05-17	1
26215	1558	28060	1999-08-03	1999-08-11	1
4579	268	40481087	2001-10-28	2001-11-18	1
25976	1542	40481087	1999-02-23	1999-03-02	1
82365	4890	40481087	1928-12-24	1929-01-14	1
27008	1599	260139	1972-11-19	1972-12-03	1
29596	1753	4113008	1968-05-16	1968-05-30	1
12883	759	4285898	1980-02-14	1980-02-15	1
7479	440	81151	1975-11-28	1975-12-26	1
7129	419	4027663	1944-07-21	1944-07-22	1
17755	1070	40481087	2011-04-29	2011-05-06	1
21801	1310	260139	1944-02-11	1944-02-25	1
59416	3527	4112343	2012-08-05	2012-08-18	1
31346	1854	4059173	2006-04-26	2006-07-25	1
33270	1977	40481087	1975-01-29	1975-02-12	1
84494	5031	257012	1990-06-11	1990-06-12	1
28453	1685	4027663	2005-02-03	2005-02-04	1
59593	3536	4027663	1990-10-31	1990-11-01	1
25767	1532	372328	1981-01-01	1981-03-04	1
30530	1804	260139	1989-07-12	1989-07-19	1
75262	4474	372328	2017-11-17	2018-07-06	1
20699	1245	81151	1937-07-23	1937-08-20	1
85943	5119	40481087	2018-11-28	2018-12-12	1
89758	5343	260139	1985-01-23	1985-01-30	1
5212	308	81151	1962-02-05	1962-03-05	1
36222	2149	4112343	2006-01-04	2006-01-17	1
85976	5121	81893	1998-09-09	1998-09-10	1
57767	3431	28060	1971-11-19	1971-12-02	1
79157	4690	4283893	1985-02-01	1985-03-01	1
31992	1903	0	1975-06-16	1975-06-17	1
24919	1490	4134304	1982-05-08	1982-08-06	1
28800	1707	30753	2005-03-24	2005-03-25	1
76338	4531	40481087	1985-01-12	1985-01-19	1
35033	2082	40481087	1943-12-25	1944-01-01	1
78854	4675	81151	1961-04-13	1961-05-11	1
25274	1508	4112343	2000-01-19	2000-01-26	1
75657	4492	372328	1949-06-21	1949-07-12	1
77145	4574	4112343	1990-06-24	1990-07-02	1
928	53	4001336	1966-06-16	1966-08-15	1
79213	4696	372328	1989-08-12	1991-03-20	1
29494	1748	28060	1959-02-12	1959-02-21	1
5962	350	40481087	1962-01-13	1962-01-20	1
3545	202	4218389	2015-10-18	2015-11-15	1
23102	1381	372328	1982-07-12	1983-05-14	1
76892	4561	372328	1952-06-30	1952-09-17	1
27250	1608	4294548	1992-04-08	1992-04-22	1
87349	5203	40481087	1996-12-14	1996-12-21	1
57396	3409	40481087	2005-05-04	2005-05-25	1
81467	4837	372328	1952-02-17	1952-05-27	1
87692	5223	257012	1991-11-14	1991-11-15	1
33063	1964	4112343	2004-08-08	2004-08-16	1
66104	3916	4134304	2003-07-23	2003-10-21	1
31166	1847	260139	1956-02-29	1956-03-14	1
26216	1558	260139	1996-01-21	1996-01-28	1
6881	406	40481087	1955-06-08	1955-06-22	1
25977	1542	28060	1984-10-16	1984-10-29	1
82366	4890	40481087	1947-03-18	1947-04-08	1
27009	1599	372328	1962-06-28	1962-10-08	1
29597	1753	40481087	1973-07-30	1973-08-20	1
12884	759	4310024	1978-02-24	1978-02-25	1
7480	440	260139	1983-09-18	1983-09-25	1
7130	419	4278672	1969-07-21	1969-08-20	1
17756	1070	260139	1987-01-02	1987-01-16	1
21802	1310	260139	1945-04-11	1945-04-18	1
59417	3527	4266809	2002-03-25	2002-03-26	1
31347	1854	4266809	2012-04-06	2012-04-07	1
33271	1977	28060	1988-05-20	1988-05-30	1
84495	5031	260139	1973-04-30	1973-05-07	1
28454	1685	4112343	1999-01-01	1999-01-08	1
59594	3536	4112343	1975-09-29	1975-10-11	1
25768	1532	40481087	2004-10-11	2004-10-25	1
30531	1804	372328	1936-03-12	1936-06-22	1
75263	4474	378001	2013-12-07	2014-02-05	1
20700	1245	260139	1940-04-10	1940-04-17	1
85944	5119	260139	1980-12-09	1980-12-23	1
89759	5343	378001	1997-07-17	1997-09-15	1
5213	308	260139	1963-01-11	1963-01-18	1
36223	2149	4112343	2016-06-27	2016-07-07	1
85977	5121	372328	1964-11-16	1965-02-26	1
57768	3431	372328	1966-06-21	1966-09-14	1
79158	4690	4283893	2005-04-15	2005-06-17	1
31993	1903	80180	2005-02-28	2005-03-01	1
24920	1490	4218389	2011-01-20	2011-02-10	1
28801	1707	4112343	1988-11-18	1988-11-29	1
76339	4531	28060	1941-02-18	1941-02-28	1
35034	2082	40481087	1957-07-27	1957-08-17	1
78855	4675	260139	1945-10-14	1945-10-21	1
25275	1508	4142905	1949-02-23	1949-05-24	1
75658	4492	378001	1984-12-24	1985-01-23	1
77146	4574	4283893	1962-10-15	1962-11-19	1
929	53	4112343	1998-03-27	1998-04-08	1
79214	4696	4027663	1979-03-07	1979-03-08	1
29495	1748	80180	1987-05-08	1987-05-09	1
7682	452	28060	1973-03-17	1973-03-24	1
3546	202	4294548	1962-09-27	1963-01-03	1
23103	1381	4027663	2007-05-27	2007-05-28	1
76893	4561	4112343	1969-10-27	1969-11-03	1
27251	1608	40481087	1943-03-30	1943-04-13	1
87350	5203	0	1999-02-17	1999-02-18	1
57397	3409	78272	1966-11-15	1966-12-06	1
81468	4837	372328	1968-07-26	1968-10-29	1
87693	5223	372328	1970-09-06	1970-10-31	1
33064	1964	40481087	2018-12-07	2018-12-21	1
66105	3916	4156265	1987-10-17	1987-11-07	1
31167	1847	260139	1961-09-24	1961-10-08	1
26217	1558	372328	1957-02-12	1957-04-04	1
6882	406	40481087	1959-05-31	1959-06-07	1
25978	1542	260139	2016-10-19	2016-11-02	1
82367	4890	40481087	1996-11-09	1996-11-16	1
27010	1599	372328	1980-05-23	1982-07-05	1
29598	1753	40481087	1985-01-13	1985-01-20	1
12885	759	40481087	1974-12-21	1975-01-04	1
7481	440	40481087	1982-02-01	1982-02-08	1
7131	419	4285898	1954-01-10	1954-01-11	1
17757	1070	4112343	1988-08-14	1988-08-27	1
21803	1310	260139	1953-04-07	1953-04-14	1
59418	3527	40481087	1989-08-16	1989-09-06	1
31348	1854	40481087	2010-09-30	2010-10-21	1
33272	1977	81151	2000-05-05	2000-05-19	1
84496	5031	378001	1950-12-24	1951-02-22	1
28455	1685	40481087	2001-01-24	2001-02-14	1
59595	3536	4116491	2009-12-11	2010-01-20	1
25769	1532	40481087	2009-12-04	2009-12-18	1
30532	1804	4027663	1963-10-07	1963-10-08	1
75264	4474	4112343	2018-02-23	2018-03-04	1
20701	1245	260139	2011-05-29	2011-06-05	1
85945	5119	260139	2000-09-24	2000-10-08	1
89760	5343	4084167	1984-04-26	1984-04-26	1
5214	308	372328	1964-11-21	1965-11-23	1
36224	2149	4155034	1990-09-19	1990-10-10	1
85978	5121	4112343	1965-09-13	1965-09-20	1
57769	3431	4112343	1993-08-31	1993-09-10	1
85800	5111	192671	1980-02-02	1980-02-03	1
31994	1903	260139	1995-09-14	1995-09-28	1
24921	1490	4283893	1996-08-06	1996-10-01	1
28802	1707	4112343	1991-06-20	1991-07-01	1
76340	4531	80502	2004-12-25	2004-12-26	1
35035	2082	40481087	2011-01-19	2011-01-26	1
78856	4675	260139	1972-06-16	1972-06-30	1
25276	1508	40480160	2014-10-06	2015-01-04	1
75659	4492	4112343	1974-01-09	1974-01-18	1
77147	4574	40481087	1960-11-26	1960-12-17	1
930	53	4278672	1974-05-05	1974-06-04	1
79215	4696	4112343	2014-07-15	2014-07-26	1
29496	1748	260139	1955-05-01	1955-05-08	1
7683	452	78272	1973-09-14	1973-10-05	1
3547	202	28060	1989-07-02	1989-07-13	1
23104	1381	4142905	1983-12-04	1984-02-02	1
76894	4561	40481087	1968-01-12	1968-02-02	1
27252	1608	40481087	1955-11-26	1955-12-03	1
87351	5203	78272	1942-01-09	1942-02-13	1
57398	3409	260139	1982-05-27	1982-06-03	1
81469	4837	4112343	2002-09-19	2002-10-01	1
87694	5223	4112343	1973-08-15	1973-08-26	1
33065	1964	80180	2000-08-10	2000-08-11	1
66106	3916	4296205	2010-11-20	2010-12-25	1
31168	1847	4027663	1946-10-31	1946-11-01	1
26218	1558	4109685	1969-04-10	1969-05-01	1
6883	406	40481087	1971-03-01	1971-03-15	1
25979	1542	313217	2015-11-25	2015-11-26	1
83587	4972	80180	1988-09-20	1988-09-21	1
27011	1599	4142905	1979-12-31	1980-02-29	1
29599	1753	40481087	1987-03-16	1987-04-06	1
12886	759	81151	1973-12-23	1974-01-06	1
7482	440	40481087	1988-06-01	1988-06-22	1
7132	419	4310024	1953-01-15	1953-01-16	1
17758	1070	40481087	2018-12-30	2019-01-06	1
21804	1310	372328	1968-09-30	1971-09-24	1
59419	3527	40481087	1994-03-19	1994-04-02	1
31349	1854	80180	2012-04-06	2012-04-07	1
33273	1977	260139	1931-01-29	1931-02-12	1
84497	5031	4029498	1941-02-01	1941-02-02	1
28456	1685	40481087	2019-01-20	2019-02-10	1
59596	3536	4146173	1971-02-28	1971-03-30	1
25770	1532	40481087	2012-03-12	2012-03-19	1
30533	1804	4109685	1955-10-29	1955-11-12	1
75265	4474	40481087	1997-04-29	1997-05-20	1
20702	1245	260139	2013-06-05	2013-06-19	1
85946	5119	4112343	1964-11-26	1964-12-05	1
89761	5343	4112343	2017-06-23	2017-07-01	1
5215	308	4296204	1976-01-21	1976-02-11	1
36225	2149	4294548	1961-11-10	1962-01-19	1
85979	5121	4112343	2006-10-29	2006-11-05	1
57770	3431	40481087	1983-06-18	1983-07-02	1
85801	5111	40481087	1956-07-07	1956-07-28	1
31995	1903	372328	1964-06-08	1964-11-24	1
24922	1490	4285898	1973-10-21	1973-10-22	1
28803	1707	40481087	1982-06-14	1982-06-21	1
76341	4531	81151	1982-06-13	1982-06-27	1
35036	2082	378001	1959-07-11	1959-08-10	1
78857	4675	260139	1984-08-28	1984-09-11	1
25277	1508	40481087	1979-08-25	1979-09-01	1
75660	4492	4116491	1976-07-29	1976-09-21	1
77148	4574	40481087	1980-04-27	1980-05-18	1
931	53	40481087	1965-03-07	1965-03-28	1
79216	4696	40481087	1951-05-22	1951-05-29	1
29497	1748	372328	1948-03-28	1948-09-11	1
7684	452	260139	1976-03-28	1976-04-04	1
3548	202	80180	1982-02-16	1982-02-17	1
23105	1381	40481087	1984-06-10	1984-06-24	1
76895	4561	28060	1959-04-12	1959-04-20	1
27253	1608	40481087	1999-02-21	1999-03-14	1
87352	5203	80180	1973-02-25	1973-02-26	1
57399	3409	378001	1958-07-30	1958-09-28	1
81470	4837	28060	1956-08-15	1956-08-25	1
87695	5223	4112343	2015-05-18	2015-05-26	1
33066	1964	81151	1966-07-05	1966-08-09	1
69465	4116	81151	1980-06-21	1980-07-12	1
31169	1847	4112343	1922-11-24	1922-12-04	1
26219	1558	4294548	1991-01-16	1991-02-13	1
6884	406	40481087	1990-02-08	1990-03-01	1
25980	1542	372328	1966-06-22	1966-08-03	1
83588	4972	260139	1984-07-11	1984-07-25	1
27012	1599	4266809	1997-12-21	1997-12-22	1
29600	1753	40481087	2008-03-23	2008-03-30	1
12887	759	260139	1948-12-14	1948-12-21	1
7483	440	40481087	2005-01-21	2005-02-04	1
7133	419	40481087	1916-05-13	1916-05-27	1
18450	1112	260139	2012-07-05	2012-07-12	1
21805	1310	4112343	2011-01-24	2011-02-04	1
59420	3527	40481087	2013-08-27	2013-09-17	1
31350	1854	4051466	1972-11-09	1993-01-05	1
33274	1977	4112343	1972-05-28	1972-06-10	1
84498	5031	4112343	1959-08-03	1959-08-10	1
28457	1685	78272	1983-08-23	1983-09-13	1
59597	3536	40481087	2003-11-06	2003-11-13	1
25771	1532	40481087	2013-07-19	2013-08-09	1
30534	1804	4112343	1973-03-28	1973-04-06	1
75266	4474	80180	1998-12-15	1998-12-16	1
20703	1245	4112343	1961-03-31	1961-04-09	1
85947	5119	40481087	1965-09-12	1965-09-26	1
89762	5343	40481087	1992-08-04	1992-08-11	1
5216	308	40481087	1975-11-29	1975-12-13	1
36226	2149	40481087	1975-07-10	1975-07-17	1
85980	5121	4156265	2013-06-30	2013-07-14	1
57771	3431	381316	2001-10-17	2001-10-18	1
85802	5111	0	1984-12-03	1984-12-04	1
31996	1903	4294548	1976-08-02	1976-12-13	1
24923	1490	40481087	1939-06-11	1939-06-18	1
28804	1707	40481087	1997-07-30	1997-08-20	1
76342	4531	260139	2008-07-24	2008-07-31	1
35037	2082	28060	1978-08-11	1978-08-20	1
78858	4675	313217	1998-11-29	1998-11-30	1
25278	1508	40481087	2012-02-03	2012-02-17	1
75661	4492	4134304	1975-01-25	1975-04-25	1
77906	4622	28060	1961-09-28	1961-10-09	1
932	53	40481087	1982-08-31	1982-09-07	1
79217	4696	40481087	1968-07-26	1968-08-09	1
29498	1748	4112343	1949-05-23	1949-06-01	1
7685	452	4112343	2002-02-24	2002-03-04	1
3549	202	81151	1942-04-13	1942-05-18	1
23106	1381	260139	1990-01-03	1990-01-10	1
76896	4561	4027663	1975-04-06	1975-04-07	1
29444	1746	80180	1988-04-23	1988-04-24	1
87353	5203	4112343	1950-02-04	1950-02-11	1
57400	3409	4112343	1959-07-21	1959-08-02	1
81471	4837	81151	1963-02-06	1963-02-20	1
87696	5223	81151	2019-01-11	2019-02-01	1
33067	1964	260139	2013-08-13	2013-08-20	1
69466	4116	81893	2010-09-02	2010-09-03	1
31170	1847	4112343	1941-12-25	1942-01-02	1
26220	1558	40481087	1975-10-03	1975-10-24	1
6885	406	40481087	2000-02-16	2000-03-08	1
25981	1542	81151	1992-11-16	1992-12-21	1
83589	4972	372328	1956-01-17	1956-12-29	1
27013	1599	40481087	1982-04-13	1982-04-20	1
29601	1753	80180	2002-06-17	2002-06-18	1
12888	759	260139	1957-10-07	1957-10-21	1
7484	440	372328	1974-06-06	1974-11-20	1
7134	419	40481087	1994-12-20	1995-01-10	1
18451	1112	372328	1967-01-09	1967-04-02	1
21806	1310	4142905	1944-01-10	1944-03-10	1
59421	3527	260139	1969-06-03	1969-06-17	1
31351	1854	4218389	1999-08-03	1999-08-31	1
33275	1977	40481087	1915-12-18	1915-12-25	1
84499	5031	4218389	1995-05-23	1995-06-13	1
28458	1685	40481087	2005-07-17	2005-07-31	1
59598	3536	28060	1974-06-24	1974-07-04	1
25772	1532	40481087	1990-11-09	1990-11-30	1
30535	1804	40481087	1939-04-04	1939-04-25	1
75267	4474	4027663	1988-05-31	1988-06-01	1
20704	1245	4142905	2008-08-08	2008-11-06	1
85948	5119	40481087	1998-10-08	1998-10-15	1
89763	5343	28060	1994-08-30	1994-09-11	1
5217	308	40481087	2013-11-01	2013-11-15	1
36227	2149	40481087	2005-10-04	2005-10-25	1
85981	5121	192671	2000-04-10	2000-04-11	1
57772	3431	4112343	1972-05-01	1972-05-09	1
85803	5111	260139	1948-09-10	1948-09-17	1
31997	1903	40481087	2001-05-14	2001-05-21	1
24924	1490	80180	1974-02-18	1974-02-19	1
28805	1707	40481087	2008-03-07	2008-03-21	1
76343	4531	381316	1965-01-09	1965-01-10	1
35038	2082	78272	1945-01-20	1945-02-24	1
78859	4675	372328	1915-05-12	1915-06-06	1
26786	1588	0	1981-12-01	1981-12-02	1
75662	4492	4283893	1958-07-12	1958-09-06	1
77907	4622	80180	1997-08-03	1997-08-04	1
933	53	40481087	2001-05-31	2001-06-14	1
79218	4696	28060	1953-02-02	1953-02-11	1
29499	1748	4112343	1998-04-01	1998-04-08	1
7686	452	40481087	1970-09-21	1970-10-05	1
3550	202	81151	1951-09-28	1951-10-12	1
23107	1381	260139	2017-04-25	2017-05-02	1
76897	4561	4112343	1954-05-25	1954-06-03	1
29445	1746	260139	1964-03-26	1964-04-02	1
87354	5203	40481087	1998-06-23	1998-07-07	1
57401	3409	40481087	1980-02-04	1980-02-25	1
81472	4837	260139	2006-10-28	2006-11-04	1
87697	5223	260139	1968-06-20	1968-07-04	1
33068	1964	40481087	2014-12-14	2015-01-04	1
69467	4116	260139	1996-12-20	1996-12-27	1
31171	1847	40481087	1947-04-24	1947-05-15	1
26221	1558	40481087	1977-11-19	1977-12-03	1
6886	406	40481087	2004-12-21	2005-01-11	1
25982	1542	260139	1986-12-27	1987-01-10	1
83590	4972	4112343	1954-09-27	1954-10-06	1
27014	1599	81151	1964-12-14	1965-01-18	1
29602	1753	260139	1988-06-02	1988-06-09	1
12889	759	260139	1962-10-03	1962-10-17	1
7485	440	372328	2006-01-06	2006-03-29	1
7135	419	260139	1952-02-13	1952-02-27	1
18452	1112	378001	2013-01-26	2013-03-27	1
21807	1310	80180	1980-07-09	1980-07-10	1
59422	3527	4112343	1978-03-26	1978-04-03	1
31352	1854	4294548	2015-05-05	2015-11-24	1
33276	1977	40481087	1933-07-02	1933-07-09	1
84500	5031	4296204	2017-01-02	2017-01-30	1
28459	1685	40481087	2010-12-11	2010-12-25	1
59599	3536	192671	2000-02-18	2000-02-19	1
25773	1532	80180	2014-03-13	2014-03-14	1
30536	1804	40481087	1998-04-12	1998-04-19	1
75268	4474	4112343	1998-04-01	1998-04-12	1
20705	1245	40481087	1963-11-08	1963-11-22	1
85949	5119	40481087	2000-03-17	2000-03-31	1
89764	5343	372328	1988-05-28	1988-12-18	1
5218	308	260139	1996-04-04	1996-04-18	1
36228	2149	81151	1972-10-27	1972-12-01	1
85982	5121	260139	2019-01-19	2019-01-26	1
57773	3431	4112343	1987-01-24	1987-02-02	1
85804	5111	40481087	1980-05-21	1980-06-04	1
31998	1903	40481087	2010-09-06	2010-09-20	1
24925	1490	81151	1940-11-23	1940-12-14	1
37252	2210	28060	1978-12-26	1979-01-06	1
76344	4531	4112343	1973-06-14	1973-06-27	1
35039	2082	81151	1969-02-18	1969-03-04	1
78860	4675	4059173	2012-07-12	2012-09-10	1
26787	1588	80180	2005-03-13	2005-03-14	1
75663	4492	4283893	1969-11-07	1970-05-01	1
77908	4622	192671	1997-08-31	1997-09-01	1
934	53	78272	1976-01-25	1976-02-29	1
79219	4696	81151	1966-01-08	1966-01-29	1
29500	1748	4112343	2017-10-26	2017-11-03	1
7687	452	260139	2017-02-21	2017-02-28	1
3551	202	81893	1980-08-25	1980-08-26	1
23108	1381	40481087	1997-11-18	1997-12-02	1
76898	4561	40481087	1993-10-25	1993-11-08	1
29446	1746	260139	2005-10-28	2005-11-04	1
57402	3409	40481087	1998-09-14	1998-10-05	1
81473	4837	4112343	2005-12-16	2005-12-27	1
87698	5223	260139	1970-10-20	1970-10-27	1
33069	1964	260139	1997-08-22	1997-09-05	1
69468	4116	260139	2008-12-23	2008-12-30	1
31172	1847	40481087	1954-09-11	1954-09-18	1
26222	1558	40481087	1989-06-05	1989-06-19	1
6887	406	40481087	2008-10-29	2008-11-19	1
25983	1542	4112343	2013-04-01	2013-04-14	1
83591	4972	4230399	1997-08-30	1997-09-29	1
27015	1599	4027663	1987-05-03	1987-05-04	1
29603	1753	372328	1965-04-02	1965-05-13	1
12890	759	260139	1982-12-30	1983-01-13	1
7486	440	378001	2009-08-29	2009-10-28	1
7136	419	260139	1987-03-08	1987-03-22	1
18453	1112	4112343	2004-08-18	2004-08-30	1
21808	1310	134438	1969-03-01	1971-02-21	1
59423	3527	4142905	1979-01-15	1979-04-15	1
31353	1854	40481087	1975-05-20	1975-06-10	1
33277	1977	40481087	1973-09-07	1973-09-28	1
84501	5031	40481087	1930-01-20	1930-01-27	1
31013	1840	372328	1978-02-02	1978-03-25	1
59600	3536	257012	2006-12-02	2006-12-03	1
25774	1532	4112343	2018-09-27	2018-10-06	1
30537	1804	80180	1972-05-22	1972-05-23	1
75269	4474	4112343	2011-11-14	2011-11-24	1
20706	1245	40481087	1991-06-17	1991-07-01	1
85950	5119	80180	2001-08-16	2001-08-17	1
89765	5343	4112343	1987-12-09	1987-12-17	1
5219	308	40481087	2004-04-10	2004-04-24	1
36229	2149	260139	1959-08-17	1959-08-31	1
85983	5121	4027663	1993-06-12	1993-06-13	1
57774	3431	4152936	1975-11-22	1975-12-06	1
85805	5111	260139	1960-06-17	1960-07-01	1
31999	1903	28060	1969-05-16	1969-05-29	1
24926	1490	260139	1968-09-29	1968-10-13	1
37253	2210	80180	1974-05-04	1974-05-05	1
76345	4531	4156265	2017-04-15	2017-04-29	1
35040	2082	375671	1972-10-14	1972-11-13	1
78861	4675	4112343	1921-10-19	1921-11-01	1
26788	1588	195588	2011-11-22	2011-12-23	1
75664	4492	4294548	2012-09-19	2012-12-19	1
77909	4622	260139	1996-01-15	1996-01-29	1
935	53	80180	1999-12-24	1999-12-25	1
79220	4696	260139	1954-12-24	1954-12-31	1
29501	1748	40479768	1989-07-03	1989-08-09	1
7688	452	372328	1967-08-05	1968-08-23	1
3552	202	260139	1948-12-18	1949-01-01	1
23109	1381	40481087	2010-03-27	2010-04-03	1
76899	4561	28060	1980-04-12	1980-04-20	1
29447	1746	4056621	2005-03-01	2005-03-02	1
340	18	4059173	1995-06-25	1995-09-23	1
81474	4837	4152936	1964-02-15	1964-02-29	1
87699	5223	4109685	2005-10-07	2005-10-21	1
33070	1964	40481087	2003-06-28	2003-07-12	1
69469	4116	4027663	2002-10-09	2002-10-10	1
31173	1847	40481087	1989-03-16	1989-03-23	1
26223	1558	28060	2000-12-04	2000-12-11	1
6888	406	80180	1996-06-27	1996-06-28	1
25984	1542	4237458	2007-11-03	2007-12-03	1
83592	4972	4283893	1977-05-02	1977-05-23	1
27016	1599	4310024	1996-05-30	1996-05-31	1
29604	1753	372328	1968-07-26	1969-02-13	1
12891	759	4112343	1947-05-25	1947-06-04	1
7487	440	40481087	1999-10-31	1999-11-14	1
7137	419	372328	1913-10-17	1914-01-04	1
18454	1112	4283893	2011-02-05	2011-04-02	1
21809	1310	260139	1954-07-27	1954-08-10	1
59424	3527	4156265	1971-04-22	1971-05-06	1
31354	1854	40481087	2000-10-02	2000-10-16	1
33278	1977	40481087	1996-01-02	1996-01-16	1
84502	5031	40481087	1947-11-03	1947-11-17	1
31014	1840	4112343	1985-12-21	1986-01-01	1
59601	3536	4112343	1996-06-23	1996-07-06	1
25775	1532	4283893	2013-12-13	2014-01-31	1
30538	1804	192671	1972-06-05	1972-06-06	1
75270	4474	4146173	1996-10-16	1996-11-15	1
20707	1245	28060	1947-08-31	1947-09-08	1
85951	5119	260139	1976-11-21	1976-11-28	1
89766	5343	4112343	2015-02-19	2015-03-04	1
5220	308	40481087	2006-10-23	2006-10-30	1
36230	2149	260139	2004-09-26	2004-10-03	1
85984	5121	4112343	2012-03-10	2012-03-17	1
57775	3431	4152936	2000-08-17	2000-09-07	1
85806	5111	317576	1967-07-24	1967-07-25	1
32000	1903	260139	2014-08-21	2014-08-28	1
24927	1490	372328	1941-01-22	1941-05-15	1
37254	2210	257012	1975-12-06	1975-12-07	1
76346	4531	4296205	1930-04-21	1930-05-19	1
35041	2082	375671	2004-11-25	2004-12-25	1
78862	4675	4112343	1968-01-01	1968-01-11	1
26789	1588	260139	1984-10-01	1984-10-15	1
75665	4492	40481087	2002-04-18	2002-05-09	1
77910	4622	372328	1966-06-19	1967-02-09	1
936	53	257012	2011-10-06	2011-10-07	1
79221	4696	260139	1958-12-31	1959-01-14	1
29502	1748	40481087	1971-09-15	1971-09-22	1
7689	452	4035415	2013-06-07	2013-08-06	1
3553	202	260139	1964-03-11	1964-03-18	1
23110	1381	40481087	2010-08-08	2010-08-29	1
76900	4561	30753	1983-10-26	1983-10-27	1
29448	1746	4112343	1970-10-26	1970-11-06	1
341	18	4112343	1991-09-13	1991-09-22	1
81475	4837	40481087	2007-10-31	2007-11-14	1
87700	5223	4112343	1968-04-22	1968-04-29	1
33071	1964	40481087	2012-03-02	2012-03-24	1
69470	4116	4156265	1994-03-01	1994-03-15	1
31174	1847	28060	1952-09-07	1952-09-20	1
26224	1558	196456	1962-06-14	1962-06-14	1
6889	406	260139	2011-05-23	2011-05-30	1
25985	1542	40481087	1976-09-02	1976-09-16	1
83593	4972	40481087	1970-07-10	1970-07-31	1
27017	1599	40481087	1975-01-28	1975-02-04	1
29605	1753	40481087	1970-07-26	1970-08-09	1
12892	759	4112343	1959-01-03	1959-01-16	1
7488	440	40481087	2005-09-08	2005-09-29	1
7138	419	4112343	1928-09-11	1928-09-19	1
18455	1112	40481087	2008-11-02	2008-11-09	1
21810	1310	260139	1959-07-17	1959-07-24	1
59425	3527	4278672	1963-04-04	1963-07-03	1
31355	1854	192671	2012-05-19	2012-05-20	1
33279	1977	81151	1938-03-15	1938-04-19	1
84503	5031	40481087	1960-08-02	1960-08-23	1
31015	1840	40481087	1986-12-10	1986-12-17	1
59602	3536	4112343	2017-10-16	2017-10-26	1
25776	1532	40481087	1977-12-06	1977-12-20	1
30539	1804	260139	1981-09-14	1981-09-21	1
75271	4474	4156265	2002-05-18	2002-06-08	1
20708	1245	134438	1963-09-07	1964-06-03	1
85952	5119	260139	1985-04-02	1985-04-16	1
89767	5343	40481087	1985-09-24	1985-10-01	1
5221	308	28060	1963-12-30	1964-01-08	1
36231	2149	260139	2010-01-12	2010-01-19	1
85985	5121	4112343	2017-03-22	2017-03-29	1
61357	3629	372328	1959-07-20	1959-10-26	1
85807	5111	28060	1949-04-09	1949-04-17	1
32001	1903	378001	2006-10-17	2006-11-16	1
24928	1490	4112343	1959-01-01	1959-01-14	1
37255	2210	260139	1982-09-08	1982-09-15	1
76347	4531	40481087	1915-02-02	1915-02-16	1
35042	2082	4035415	1997-04-06	1997-05-06	1
78863	4675	4112343	2009-02-02	2009-02-14	1
26790	1588	260139	1992-03-23	1992-04-06	1
75666	4492	260139	1952-06-06	1952-06-13	1
77911	4622	4112343	1994-11-01	1994-11-11	1
937	53	4283893	2011-08-11	2011-12-01	1
79222	4696	439777	1997-03-02	1997-03-03	1
29503	1748	40481087	2001-05-05	2001-05-19	1
7690	452	4112343	1989-02-02	1989-02-11	1
3554	202	4027663	1970-09-02	1970-09-03	1
23111	1381	40481087	2014-02-14	2014-02-21	1
76901	4561	81893	1983-09-26	1983-09-27	1
29449	1746	4116491	2004-12-14	2005-04-19	2
342	18	4116491	1997-11-09	1998-01-09	1
81476	4837	40486433	1951-12-28	1967-12-26	1
87701	5223	40481087	1991-02-08	1991-02-22	1
36555	2166	80180	2000-12-24	2000-12-25	1
69471	4116	40481087	1986-08-12	1986-08-26	1
31175	1847	260139	1919-12-13	1919-12-20	1
26225	1558	4112343	2018-08-12	2018-08-24	1
6890	406	4112343	1955-01-08	1955-01-17	1
28570	1692	30753	2015-11-30	2015-12-01	1
83594	4972	0	1991-01-04	1991-01-05	1
27018	1599	40481087	2002-07-12	2002-08-02	1
29606	1753	40481087	1973-10-28	1973-11-04	1
12893	759	4152936	1992-09-19	1992-10-03	1
7914	462	80180	2014-08-28	2014-08-29	1
7139	419	4112343	1950-05-16	1950-05-24	1
18456	1112	4155034	1968-07-02	1968-07-16	1
21811	1310	380378	2013-02-11	2013-02-12	1
63004	3725	80180	2006-11-13	2006-11-14	1
31356	1854	257012	2015-06-09	2015-06-10	1
33280	1977	81151	1993-08-19	1993-09-09	1
84504	5031	40481087	2004-05-27	2004-06-03	1
31016	1840	80180	2016-12-29	2016-12-30	1
59603	3536	4113008	2006-08-07	2006-08-28	1
25777	1532	40481087	2001-06-13	2001-06-20	1
30540	1804	372328	1937-11-14	1938-03-21	1
75272	4474	4266809	1998-12-15	1998-12-16	1
20709	1245	321042	2003-10-10	2003-10-11	1
85953	5119	81151	1978-05-14	1978-05-28	1
89768	5343	40481087	1995-10-02	1995-10-09	1
5222	308	40481087	1967-02-15	1967-03-08	1
36232	2149	381316	2005-11-12	2005-11-13	1
85986	5121	4283893	2016-08-24	2016-09-07	1
61358	3629	4112343	1995-11-03	1995-11-10	1
85808	5111	80180	1979-12-06	1979-12-07	1
32002	1903	4029498	1975-06-16	1975-06-17	1
24929	1490	40481087	1969-11-08	1969-11-22	1
37256	2210	260139	2002-05-01	2002-05-15	1
76348	4531	40481087	1935-06-28	1935-07-05	1
35043	2082	4112343	1944-05-27	1944-06-05	1
78864	4675	4155034	1917-01-01	1917-01-15	1
26791	1588	260139	2010-09-03	2010-09-10	1
75667	4492	378001	1993-11-07	1994-01-06	1
77912	4622	4112343	1996-02-08	1996-02-20	1
938	53	40481087	1978-01-24	1978-02-14	1
79223	4696	40481087	1968-12-13	1968-12-27	1
29504	1748	40481087	2011-09-05	2011-09-19	1
7691	452	4112343	1998-09-02	1998-09-11	1
3555	202	4155034	1971-07-29	1971-08-12	1
23112	1381	260139	2009-08-14	2009-08-28	1
76902	4561	4112343	2003-12-01	2003-12-13	1
29450	1746	4278672	2000-03-25	2000-06-23	1
343	18	40481087	1973-09-25	1973-10-09	1
86138	5132	28060	1968-11-28	1968-12-11	1
87702	5223	81151	1996-06-21	1996-07-26	1
36556	2166	195588	1992-05-05	1992-06-22	1
69472	4116	40481087	1999-09-22	1999-10-06	1
31176	1847	4285898	1957-08-19	1957-08-20	1
26226	1558	40481087	1957-02-03	1957-02-24	1
6891	406	134438	1974-02-20	1975-02-17	1
28571	1692	192671	2017-01-28	2017-01-29	1
83595	4972	257012	1952-08-31	1952-09-01	1
27254	1609	81151	1960-11-01	1960-12-06	1
29607	1753	40481087	2000-12-30	2001-01-06	1
12894	759	40481087	1947-05-01	1947-05-08	1
7915	462	260139	1981-06-23	1981-07-07	1
7140	419	4152936	1923-11-15	1923-11-29	1
18457	1112	4283893	1992-12-17	1993-02-18	1
21812	1310	4029498	2013-02-11	2013-02-12	1
63005	3725	81151	1998-07-19	1998-08-23	1
31357	1854	378001	1985-10-15	1985-12-14	1
33281	1977	260139	1926-11-07	1926-11-21	1
84505	5031	260139	1922-07-28	1922-08-11	1
31017	1840	260139	2006-09-04	2006-09-18	1
59604	3536	4116491	2006-10-27	2006-12-12	1
25778	1532	260139	2010-04-06	2010-04-20	1
30541	1804	4112343	1950-05-12	1950-05-25	1
75273	4474	40481087	1969-01-15	1969-02-05	1
20710	1245	4166224	1985-08-27	1985-08-28	1
85954	5119	372328	1968-02-06	1968-04-23	1
59434	3528	260139	1994-05-17	1994-05-24	1
5223	308	40481087	1977-02-13	1977-02-27	1
36233	2149	4112343	2018-04-30	2018-05-10	1
85987	5121	378001	1976-02-17	1976-03-18	1
61359	3629	4113008	1992-03-02	1992-03-23	1
85809	5111	4329847	1984-12-03	1984-12-04	1
32003	1903	4112343	1984-04-11	1984-04-18	1
24930	1490	30753	1972-12-25	1972-12-26	1
37257	2210	372328	1937-09-20	1938-01-02	1
76349	4531	40481087	1963-11-11	1963-11-18	1
35044	2082	4112343	1949-06-12	1949-06-23	1
78865	4675	40481087	1948-07-18	1948-08-01	1
26792	1588	4112343	2016-02-05	2016-02-18	1
75668	4492	4112343	1996-05-11	1996-05-21	1
77913	4622	4294548	1998-09-05	1999-01-09	1
939	53	28060	1967-11-29	1967-12-09	1
79224	4696	40481087	1994-06-21	1994-07-12	1
29505	1748	260139	1949-04-23	1949-04-30	1
7692	452	28060	2003-08-28	2003-09-06	1
3556	202	40481087	1953-12-24	1954-01-14	1
23113	1381	4112343	2018-03-28	2018-04-07	1
76903	4561	40481087	1958-04-05	1958-04-12	1
29451	1746	40481087	1954-10-09	1954-10-16	1
344	18	40481087	1974-06-13	1974-06-20	1
86139	5132	80180	2003-06-15	2003-06-16	1
87703	5223	260139	1997-08-01	1997-08-08	1
36557	2166	260139	1970-12-13	1970-12-20	1
69473	4116	260139	2006-01-28	2006-02-11	1
31177	1847	40481087	1991-04-21	1991-05-12	1
26227	1558	40481087	1965-09-28	1965-10-19	1
6892	406	372328	1952-09-16	1952-10-28	1
28572	1692	4029498	1982-08-15	1982-08-16	1
83596	4972	260139	1957-10-10	1957-10-24	1
27255	1609	260139	1986-11-14	1986-11-28	1
29608	1753	40481087	2007-06-12	2007-06-19	1
12895	759	40481087	1960-03-06	1960-03-27	1
7916	462	260139	1986-09-16	1986-09-23	1
7141	419	4237458	1964-09-15	1964-11-14	1
18458	1112	80180	2007-06-03	2007-06-04	1
21813	1310	4112343	1979-05-03	1979-05-12	1
63006	3725	4059173	1981-09-16	1981-12-15	1
31358	1854	4027663	2000-10-26	2000-10-27	1
33282	1977	260139	1963-12-20	1963-12-27	1
84506	5031	372328	1920-06-06	1920-07-17	1
31018	1840	260139	2017-07-20	2017-07-27	1
59605	3536	40481087	1982-01-27	1982-02-03	1
25779	1532	372328	1980-08-13	1980-09-03	1
30542	1804	4283893	1992-12-22	1993-01-12	1
75274	4474	40481087	1990-09-13	1990-09-27	1
20711	1245	40481087	1953-05-05	1953-05-26	1
85955	5119	4059173	1998-08-11	1998-10-10	1
59435	3528	4112343	1982-10-14	1982-10-22	1
5224	308	40481087	1999-09-07	1999-09-28	1
36234	2149	40481087	1984-10-06	1984-10-20	1
85988	5121	440086	1973-06-17	1982-06-25	1
61360	3629	4237458	1965-09-29	1965-12-28	1
85810	5111	40481087	1958-09-25	1958-10-09	1
32004	1903	4112343	2007-08-20	2007-08-29	1
24931	1490	81893	1972-11-25	1972-11-26	1
37258	2210	4112343	1990-09-08	1990-09-19	1
79393	4707	260139	1980-11-30	1980-12-14	1
35045	2082	4237458	2007-12-10	2008-03-09	1
78866	4675	40481087	1975-01-04	1975-01-11	1
26793	1588	40481087	1970-10-14	1970-10-21	1
75669	4492	4218389	1957-07-07	1957-07-28	1
77914	4622	40481087	1963-01-28	1963-02-04	1
940	53	372328	1962-12-13	1963-01-23	1
79225	4696	81151	1955-01-22	1955-02-05	1
29506	1748	260139	2012-03-06	2012-03-20	1
7693	452	81151	1964-10-26	1964-11-30	1
3557	202	40481087	1956-03-10	1956-03-24	1
23114	1381	4278672	1993-11-11	1994-02-09	1
76904	4561	40481087	1996-11-30	1996-12-14	1
29452	1746	40481087	2001-05-31	2001-06-14	1
345	18	40481087	2000-03-27	2000-04-03	1
86140	5132	81151	1991-09-26	1991-10-31	1
87704	5223	372328	1970-12-30	1971-05-01	1
36558	2166	260139	1990-04-10	1990-04-24	1
69474	4116	40481087	2009-11-18	2009-12-02	1
31178	1847	81893	1956-09-23	1956-09-24	1
26228	1558	40481087	1986-01-18	1986-01-25	1
6893	406	4112343	1959-12-25	1960-01-05	1
28573	1692	4112343	2012-10-22	2012-11-04	1
83597	4972	378001	1991-01-04	1991-03-05	1
27256	1609	372328	1943-06-23	1943-09-02	1
29609	1753	28060	1965-04-03	1965-04-16	1
12896	759	40481087	1969-07-14	1969-07-21	1
7917	462	372328	1992-06-17	1992-10-29	1
7142	419	4237458	1991-07-01	1991-07-31	1
18459	1112	81151	1971-03-03	1971-04-07	1
21814	1310	4112343	2013-03-29	2013-04-06	1
63007	3725	4112343	2006-10-24	2006-11-06	1
31359	1854	4116491	2008-12-19	2009-02-10	1
33283	1977	260139	2007-04-13	2007-04-27	1
84507	5031	372328	1924-08-03	1925-01-17	1
31019	1840	4112343	1983-01-22	1983-02-03	1
59606	3536	40481087	1990-05-27	1990-06-10	1
25780	1532	372328	1983-04-23	1983-09-14	1
33896	2016	81151	2002-06-13	2002-07-11	1
75275	4474	28060	1973-02-24	1973-03-09	1
20712	1245	40481087	1984-02-19	1984-02-26	1
85956	5119	4112343	2010-12-08	2010-12-19	1
59436	3528	4112343	1989-02-18	1989-02-27	1
5225	308	80180	1999-02-26	1999-02-27	1
36870	2185	28060	1948-06-09	1948-06-22	1
85989	5121	40481087	1974-11-30	1974-12-14	1
61361	3629	40481087	1975-01-04	1975-01-18	1
85811	5111	40481087	1961-05-31	1961-06-21	1
32005	1903	4155034	2009-05-04	2009-05-25	1
24932	1490	4112343	1953-08-19	1953-08-28	1
37259	2210	4146173	2006-09-05	2006-10-05	1
79394	4707	260139	1986-04-12	1986-04-26	1
35046	2082	40481087	1943-07-05	1943-07-19	1
78867	4675	40481087	2007-08-29	2007-09-12	1
26794	1588	4112343	1972-03-07	1972-03-16	1
75670	4492	28060	1948-02-28	1948-03-12	1
77915	4622	81893	1995-12-12	1995-12-13	1
941	53	372328	1967-09-16	1968-04-24	1
79226	4696	81893	1985-06-28	1985-06-29	1
29507	1748	40481087	2014-10-11	2014-11-01	1
7694	452	260139	2008-12-14	2008-12-21	1
3558	202	40481087	1995-02-26	1995-03-05	1
23115	1381	4285898	2018-08-12	2018-08-13	1
76905	4561	28060	1998-03-21	1998-03-28	1
29453	1746	40481087	2007-04-17	2007-04-24	1
346	18	40481087	2011-10-24	2011-11-07	1
86141	5132	378001	2017-05-17	2017-07-16	1
87705	5223	4112343	1990-05-01	1990-05-14	1
36559	2166	4112343	1975-03-14	1975-03-26	1
69475	4116	40481087	2011-07-02	2011-07-23	1
31179	1847	192671	1958-04-09	1958-04-10	1
26229	1558	40481087	1993-07-10	1993-07-24	1
6894	406	4112343	2016-03-13	2016-03-23	1
28574	1692	4310024	2015-06-03	2015-06-04	1
83598	4972	440448	1991-01-04	1991-01-05	1
27257	1609	40481087	1961-06-05	1961-06-26	1
29610	1753	30753	2001-08-21	2001-08-22	1
12897	759	4027663	1971-12-28	1971-12-29	1
7918	462	40481087	2001-01-10	2001-01-24	1
7143	419	40481087	1945-11-09	1945-11-30	1
18460	1112	260139	2000-06-11	2000-06-18	1
21815	1310	4283893	1988-12-10	1989-02-18	1
63008	3725	4152936	1970-09-23	1970-10-14	1
31360	1854	4296205	2015-02-08	2015-03-08	1
33284	1977	317576	1963-12-26	1963-12-27	1
84508	5031	372328	2019-01-04	2019-05-25	1
31020	1840	40481087	1976-12-18	1977-01-01	1
59607	3536	260139	1990-11-16	1990-11-30	1
25781	1532	4278672	1986-04-14	1986-07-13	1
33897	2016	4112343	2009-07-28	2009-08-06	1
75276	4474	81151	1980-07-07	1980-07-28	1
20713	1245	40481087	1990-11-29	1990-12-13	1
85957	5119	40481087	1963-06-09	1963-06-16	1
59437	3528	4112343	2006-05-10	2006-05-17	1
5226	308	260139	1961-08-11	1961-08-18	1
36871	2185	4112343	1946-12-04	1946-12-14	1
85990	5121	40481087	1997-03-25	1997-04-01	1
61362	3629	40481087	2018-09-26	2018-10-03	1
86530	5153	28060	1972-01-07	1972-01-17	1
32006	1903	4218389	2014-01-29	2014-02-26	1
24933	1490	4230399	1970-09-08	1970-12-07	1
37260	2210	40481087	1937-12-25	1938-01-15	1
79395	4707	4112343	1975-01-01	1975-01-11	1
35047	2082	40481087	1967-07-05	1967-07-12	1
78868	4675	80502	1991-10-20	1991-10-21	1
26795	1588	4112343	2004-02-25	2004-03-08	1
75671	4492	80180	1987-09-10	1987-09-11	1
77916	4622	372328	1957-09-17	1958-01-02	1
942	53	4112343	1964-10-06	1964-10-13	1
79227	4696	260139	2017-12-20	2018-01-03	1
29508	1748	260139	2006-02-21	2006-02-28	1
7695	452	372328	1963-01-05	1963-02-15	1
6546	387	28060	1979-05-18	1979-05-31	1
23116	1381	40481087	2001-12-16	2001-12-30	1
76906	4561	80180	1984-06-22	1984-06-23	1
29454	1746	28060	1972-01-04	1972-01-11	1
347	18	78272	1983-05-31	1983-06-28	1
86142	5132	40481087	2010-10-15	2010-10-22	1
87706	5223	4112343	2014-11-06	2014-11-16	1
36560	2166	40481087	1973-12-23	1974-01-06	1
69476	4116	80180	2012-06-23	2012-06-24	1
31180	1847	260139	1926-12-24	1927-01-07	1
26230	1558	257012	1987-02-17	1987-02-18	1
6895	406	40481087	1958-10-10	1958-10-24	1
28575	1692	40481087	1986-07-04	1986-07-18	1
83599	4972	4112343	1963-12-22	1964-01-02	1
27258	1609	40481087	1977-04-07	1977-04-21	1
29611	1753	133834	1964-07-13	1981-09-12	1
12898	759	4109685	1977-01-20	1977-02-10	1
7919	462	260139	2002-02-03	2002-02-10	1
7144	419	40481087	1965-05-29	1965-06-05	1
18461	1112	40481087	2005-06-21	2005-07-12	1
21816	1310	40481087	1944-07-17	1944-08-07	1
63009	3725	28060	2016-03-20	2016-04-01	1
31361	1854	81893	2009-09-19	2009-09-20	1
33285	1977	372328	1911-11-02	1912-01-18	1
84509	5031	4112343	1962-04-30	1962-05-09	1
31021	1840	40481087	1985-11-19	1985-12-10	1
59608	3536	260139	2005-12-09	2005-12-16	1
25782	1532	40481087	1986-04-15	1986-04-29	1
33898	2016	4112343	2017-06-14	2017-06-21	1
75277	4474	81151	1983-06-13	1983-06-27	1
20714	1245	40481087	1998-05-31	1998-06-21	1
87544	5215	260139	2014-09-04	2014-09-11	1
59438	3528	40481087	1980-07-16	1980-07-30	1
5227	308	260139	1964-11-09	1964-11-16	1
36872	2185	4116491	1987-01-26	1987-03-07	1
87996	5239	28060	2007-05-17	2007-05-26	1
61363	3629	28060	1961-02-24	1961-03-09	1
86531	5153	78272	1960-01-08	1960-01-29	1
32007	1903	40481087	2001-06-29	2001-07-20	1
24934	1490	4230399	2018-10-01	2018-10-31	1
37261	2210	40481087	1985-10-15	1985-10-29	1
79396	4707	4112343	1991-11-14	1991-11-26	1
35048	2082	40481087	1990-08-15	1990-08-22	1
78869	4675	260139	1923-01-01	1923-01-15	1
26796	1588	4113008	2018-12-30	2019-01-13	1
75672	4492	4112343	1955-03-08	1955-03-19	1
77917	4622	375671	1979-05-30	1979-07-29	1
1136	67	28060	2017-07-12	2017-07-22	1
79228	4696	372328	1953-03-03	1953-07-22	1
29509	1748	4109685	1980-08-05	1980-08-19	1
7696	452	4112343	1993-06-21	1993-06-29	1
6547	387	260139	1975-08-22	1975-09-05	1
23117	1381	40481087	2015-12-21	2016-01-04	1
76907	4561	260139	1984-08-06	1984-08-13	1
29455	1746	81151	1953-10-09	1953-11-06	1
348	18	80180	2009-03-21	2009-03-22	1
86143	5132	260139	2009-10-01	2009-10-08	1
87707	5223	4294548	1991-08-29	1992-05-07	1
36561	2166	28060	1976-12-16	1976-12-28	1
69477	4116	81151	1970-09-07	1970-10-12	1
31181	1847	372328	1915-07-06	1915-10-17	1
26231	1558	4027663	1981-04-22	1981-04-23	1
6896	406	40481087	1969-05-24	1969-05-31	1
28576	1692	40481087	2016-04-24	2016-05-08	1
83600	4972	4112343	1965-05-28	1965-06-09	1
27259	1609	372328	1946-10-15	1947-02-26	1
29612	1753	4283893	1999-09-07	1999-09-28	1
12899	759	4112343	1961-12-04	1961-12-17	1
7920	462	4112343	2000-11-25	2000-12-06	1
7985	469	313217	2013-09-28	2013-09-29	1
18462	1112	40481087	2011-11-04	2011-11-18	1
21817	1310	40481087	1951-03-10	1951-03-17	1
63010	3725	4278672	1972-06-05	1972-08-04	1
31362	1854	195588	2005-10-25	2005-12-20	1
33286	1977	4109685	1990-11-12	1990-12-03	1
84510	5031	4112343	1969-12-15	1969-12-24	1
31022	1840	260139	2016-02-17	2016-02-24	1
59609	3536	4109685	1994-11-24	1994-12-08	1
27501	1626	78272	1967-08-30	1967-09-13	1
33899	2016	40481087	2006-05-03	2006-05-24	1
75278	4474	81893	1997-08-22	1997-08-23	1
20715	1245	40481087	1998-11-25	1998-12-02	1
87545	5215	4112343	1949-06-18	1949-07-01	1
59439	3528	40481087	1990-04-18	1990-05-09	1
5228	308	260139	2006-04-07	2006-04-21	1
36873	2185	4155034	1970-02-16	1970-03-02	1
87997	5239	372328	1971-07-02	1971-11-10	1
61364	3629	257012	1973-05-31	1973-06-01	1
86532	5153	40481087	1947-05-22	1947-06-05	1
32008	1903	40481087	2012-10-16	2012-10-23	1
24935	1490	40481087	1938-12-13	1939-01-03	1
37262	2210	40481087	1991-11-24	1991-12-15	1
79397	4707	4112343	1996-03-06	1996-03-15	1
35049	2082	40481087	1990-09-26	1990-10-03	1
78870	4675	260139	1930-05-20	1930-06-03	1
26797	1588	40481087	1968-08-02	1968-08-16	1
75673	4492	4152936	1996-12-21	1997-01-04	1
77918	4622	4112343	2018-12-04	2018-12-14	1
1137	67	80180	2011-08-29	2011-08-30	1
79229	4696	4112343	2005-01-11	2005-01-19	1
29510	1748	4112343	2008-08-27	2008-09-09	1
7697	452	40481087	1976-02-04	1976-02-11	1
6548	387	4059173	1974-08-26	1974-10-25	1
23118	1381	81893	2017-07-18	2017-07-19	1
76908	4561	260139	2015-06-23	2015-06-30	1
29456	1746	81151	2014-07-10	2014-08-07	1
349	18	4112343	1992-01-21	1992-02-03	1
86144	5132	4237458	1979-09-29	1979-10-29	1
87708	5223	40481087	1977-08-05	1977-08-12	1
36562	2166	4109685	2006-01-27	2006-02-17	1
69478	4116	4112343	1980-08-16	1980-08-28	1
31182	1847	4059173	1928-05-28	1928-08-26	1
26232	1558	4294548	1987-01-27	1987-04-21	1
6897	406	81151	2010-10-26	2010-11-30	1
28577	1692	81893	2015-10-31	2015-11-01	1
83601	4972	4112343	1996-12-04	1996-12-12	1
27260	1609	381316	1998-10-28	1998-10-29	1
29613	1753	4310024	2000-05-28	2000-05-29	1
12900	759	4266809	1980-06-13	1980-06-14	1
7921	462	40481087	1989-02-01	1989-02-15	1
7986	469	372328	1936-03-29	1936-05-09	1
18463	1112	192671	2007-08-17	2007-08-18	1
21818	1310	40481087	1971-01-10	1971-01-17	1
63011	3725	4283893	2000-01-18	2000-02-15	1
31363	1854	4112343	1973-08-23	1973-09-03	1
33287	1977	4112343	1913-02-25	1913-03-10	1
84511	5031	4112343	1980-04-01	1980-04-13	1
31023	1840	4112343	1978-10-01	1978-10-11	1
59610	3536	4112343	1999-08-24	1999-09-04	1
27502	1626	198809	1989-12-17	1989-12-17	1
33900	2016	78272	1998-05-30	1998-07-04	1
75279	4474	260139	1966-10-04	1966-10-18	1
20716	1245	40481087	2016-06-21	2016-07-12	1
87546	5215	4112343	1992-09-14	1992-09-21	1
59440	3528	81151	1993-08-31	1993-09-28	1
5229	308	260139	2016-11-25	2016-12-09	1
36874	2185	40481087	1970-02-15	1970-03-08	1
87998	5239	4027663	1999-11-16	1999-11-17	1
61365	3629	4112343	1989-01-26	1989-02-04	1
86533	5153	40481087	1987-12-27	1988-01-03	1
32009	1903	257012	1976-10-11	1976-10-12	1
24936	1490	40481087	1985-01-08	1985-01-29	1
37263	2210	260139	1943-03-25	1943-04-01	1
79398	4707	4142905	1977-03-19	1977-06-17	1
35050	2082	28060	1997-03-17	1997-03-29	1
78871	4675	260139	1953-09-11	1953-09-25	1
26798	1588	40481087	1972-01-19	1972-02-09	1
75674	4492	40481087	2005-09-29	2005-10-20	1
77919	4622	4266809	1997-08-03	1997-08-04	1
1138	67	260139	1988-10-07	1988-10-21	1
79230	4696	4152936	2017-06-30	2017-07-14	1
29511	1748	40481087	1950-07-16	1950-08-06	1
7698	452	40481087	2000-10-08	2000-10-29	1
6549	387	4112343	1976-04-21	1976-04-30	1
23119	1381	4059173	1982-02-12	1982-03-14	1
76909	4561	372328	1961-12-29	1962-03-21	1
29457	1746	195588	2002-11-01	2002-12-15	1
350	18	4112343	2012-11-15	2012-11-27	1
86145	5132	4278672	1973-03-04	1973-06-02	1
87709	5223	40481087	1993-05-09	1993-05-16	1
36563	2166	4146173	2003-01-13	2003-03-14	1
69479	4116	4218389	2004-07-27	2004-08-17	1
31183	1847	4112343	1922-02-18	1922-02-25	1
26233	1558	40481087	1974-01-13	1974-02-03	1
6898	406	260139	1966-02-06	1966-02-20	1
28578	1692	260139	1982-08-17	1982-08-24	1
83602	4972	4230399	1999-08-20	1999-09-19	1
27261	1609	4112343	1994-04-27	1994-05-08	1
29614	1753	40481087	1965-02-08	1965-02-15	1
12901	759	40481087	1970-07-24	1970-08-07	1
7922	462	40481087	2008-11-21	2008-11-28	1
7987	469	372328	1937-04-04	1937-11-06	2
18464	1112	260139	1990-11-05	1990-11-12	1
21819	1310	40481087	1972-09-14	1972-09-28	1
63012	3725	40481087	1978-03-21	1978-04-04	1
31475	1864	80180	2004-09-14	2004-09-15	1
33288	1977	4112343	1917-11-18	1917-11-27	1
84512	5031	4112343	1984-09-22	1984-10-01	1
31024	1840	4294548	1994-04-15	1994-05-13	1
59611	3536	4112343	2009-04-17	2009-04-29	1
27503	1626	372328	1935-10-26	1935-12-08	1
33901	2016	80180	2017-03-20	2017-03-21	1
75280	4474	260139	2018-10-02	2018-10-09	1
20717	1245	40481087	2017-03-16	2017-03-23	1
87547	5215	4112343	1998-09-23	1998-10-01	1
59441	3528	81151	1997-07-09	1997-08-06	1
5230	308	4112343	1966-04-01	1966-04-14	1
36875	2185	40481087	1986-07-11	1986-07-18	1
87999	5239	4112343	2002-11-24	2002-12-05	1
61366	3629	4294548	1982-04-17	1982-06-05	1
86534	5153	40481087	2011-01-10	2011-01-24	1
32010	1903	260139	2016-07-20	2016-07-27	1
24937	1490	40481087	2017-02-20	2017-02-27	1
37264	2210	260139	1951-01-21	1951-02-04	1
79399	4707	4294548	2016-02-16	2016-04-05	1
35051	2082	4134304	2017-02-20	2017-04-21	1
78872	4675	260139	1971-11-28	1971-12-05	1
26799	1588	40481087	1972-08-12	1972-09-02	1
75675	4492	78272	1949-06-21	1949-07-19	1
77920	4622	4285898	1996-12-06	1996-12-07	1
1139	67	260139	1996-10-05	1996-10-12	1
79231	4696	40481087	1999-12-11	2000-01-01	1
29512	1748	40481087	1959-12-24	1960-01-14	1
7699	452	80180	2002-04-15	2002-04-16	1
6550	387	4112343	2014-01-29	2014-02-09	1
23120	1381	4112343	1986-02-22	1986-03-02	1
76910	4561	4059173	1988-08-20	1988-11-18	1
29458	1746	260139	1954-04-08	1954-04-22	1
351	18	4156265	1970-09-22	1970-10-06	1
86146	5132	40481087	1986-11-28	1986-12-12	1
87710	5223	40481087	2005-08-19	2005-09-09	1
36564	2166	40481087	1986-05-02	1986-05-23	1
69480	4116	4294548	1969-11-17	1969-12-01	1
31184	1847	4112343	1926-09-03	1926-09-13	1
26234	1558	40481087	1978-01-11	1978-02-01	1
6899	406	260139	2007-07-22	2007-08-05	1
28579	1692	4112343	1983-04-14	1983-04-24	1
83603	4972	4146173	1990-01-09	1990-03-10	1
27262	1609	4156265	1957-03-01	1957-03-22	1
32204	1916	80180	2007-05-13	2007-05-14	1
12902	759	40481087	1981-05-10	1981-05-17	1
7923	462	40481087	1996-11-03	1996-11-24	1
7988	469	372328	1939-03-03	1939-05-06	1
18465	1112	4112343	1982-01-23	1982-02-03	1
21820	1310	0	2013-02-11	2013-02-12	1
63013	3725	40481087	1999-10-20	1999-11-10	1
31476	1864	260139	1971-04-08	1971-04-22	1
33289	1977	40481087	1949-11-25	1949-12-16	1
84513	5031	4112343	1985-10-28	1985-11-07	1
31025	1840	4059173	1986-08-19	1986-11-17	1
59612	3536	40481087	1969-02-15	1969-03-01	1
27504	1626	40481087	1963-03-24	1963-04-07	1
33902	2016	4112343	2002-01-19	2002-02-01	1
75281	4474	4283893	2007-05-16	2007-07-11	1
21565	1294	80180	2011-03-29	2011-03-30	1
87548	5215	4237458	2004-03-30	2004-05-29	1
59442	3528	260139	2011-11-04	2011-11-11	1
5231	308	4112343	1980-11-29	1980-12-06	1
36876	2185	80180	1981-03-18	1981-03-19	1
88000	5239	4285898	2010-12-03	2010-12-04	1
61367	3629	80180	2000-07-27	2000-07-28	1
86535	5153	260139	1970-03-27	1970-04-10	1
32011	1903	4112343	2010-07-16	2010-07-26	1
25873	1538	260139	1960-05-18	1960-05-25	1
37265	2210	260139	1954-01-05	1954-01-12	1
79400	4707	257012	2016-03-08	2016-03-09	1
35052	2082	40481087	2000-01-21	2000-02-11	1
78873	4675	375671	1959-06-23	1959-08-22	1
26800	1588	40481087	1985-08-11	1985-08-18	1
75676	4492	81151	1981-03-24	1981-04-14	1
77921	4622	40481087	1972-02-24	1972-03-16	1
1140	67	372328	1973-03-06	1973-03-20	1
79232	4696	40481087	2000-07-04	2000-07-25	1
29513	1748	40481087	1993-10-03	1993-10-17	1
7700	452	260139	2017-10-27	2017-11-10	1
6551	387	40481087	1984-01-15	1984-01-29	1
23121	1381	4112343	1993-02-24	1993-03-06	1
76911	4561	4285898	1983-12-25	1983-12-26	1
29459	1746	260139	1967-10-13	1967-10-20	1
352	18	40481087	2018-11-05	2018-11-19	1
86147	5132	28060	1972-12-24	1973-01-02	1
87711	5223	40481087	2014-12-16	2014-12-30	1
36565	2166	4112343	1978-05-26	1978-06-05	1
69481	4116	40481087	1973-09-20	1973-10-11	1
31185	1847	4112343	1960-09-10	1960-09-19	1
26235	1558	40481087	1978-03-11	1978-03-18	1
6900	406	260139	2014-10-08	2014-10-22	1
28580	1692	4266809	2017-01-23	2017-01-24	1
83604	4972	4283893	1980-04-13	1980-11-30	1
27263	1609	40481087	1989-02-22	1989-03-15	1
32205	1916	260139	1972-01-04	1972-01-11	1
12903	759	40481087	2006-07-12	2006-07-26	1
7924	462	195588	1999-09-11	1999-10-21	1
7989	469	4237458	2014-12-19	2015-03-19	1
18466	1112	4112343	1988-05-05	1988-05-13	1
21821	1310	372328	1987-09-30	1988-03-25	1
63014	3725	4112343	1970-06-27	1970-07-04	1
31477	1864	260139	2008-04-22	2008-04-29	1
33290	1977	40481087	1955-09-16	1955-10-07	1
84514	5031	4112343	2018-10-18	2018-10-31	1
31026	1840	4112343	1986-10-02	1986-10-12	1
59613	3536	80180	2000-01-17	2000-01-18	1
27505	1626	40481087	1976-03-18	1976-04-01	1
33903	2016	4112343	2013-07-20	2013-08-02	1
75282	4474	40481087	1988-09-02	1988-09-16	1
21566	1294	260139	1978-09-19	1978-10-03	1
87549	5215	4296205	2017-12-22	2018-01-05	1
59443	3528	375671	2008-03-11	2008-05-10	1
5232	308	4112343	2012-01-25	2012-02-05	1
36877	2185	81151	1959-05-13	1959-06-10	1
88001	5239	40481087	2008-11-20	2008-12-11	1
61368	3629	260139	1988-09-30	1988-10-07	1
86536	5153	440448	1963-12-25	1963-12-26	1
32012	1903	4112343	2018-05-19	2018-05-31	1
25874	1538	260139	2006-04-04	2006-04-18	1
37266	2210	4156265	2014-12-22	2015-01-05	1
79401	4707	372328	1975-03-30	1975-08-14	1
37595	2232	80180	2005-09-16	2005-09-17	1
78874	4675	381316	1975-09-07	1975-09-08	1
26801	1588	40481087	1998-12-11	1999-01-01	1
75677	4492	257012	1970-02-06	1970-02-07	1
77922	4622	40481087	1983-03-08	1983-03-22	1
1141	67	4112343	1975-02-12	1975-02-23	1
80648	4788	372328	1976-07-20	1976-10-31	1
29514	1748	40481087	1997-05-06	1997-05-20	1
7701	452	372328	1965-12-31	1966-02-11	1
6552	387	81151	1987-07-19	1987-08-16	1
23122	1381	4112343	2001-07-24	2001-08-06	1
76912	4561	4294548	2002-08-23	2002-09-13	1
29460	1746	260139	1997-05-30	1997-06-13	1
353	18	28060	1979-05-24	1979-06-01	1
86148	5132	4112343	2002-01-13	2002-01-22	1
87712	5223	28060	1972-06-08	1972-06-17	1
36566	2166	4146173	2009-09-29	2009-10-29	1
69482	4116	40481087	2000-11-06	2000-11-27	1
31186	1847	4278672	1926-06-08	1926-07-08	1
26236	1558	40481087	1979-03-22	1979-03-29	1
6901	406	375671	1992-03-04	1992-04-03	1
28581	1692	40481087	1990-10-30	1990-11-06	1
83605	4972	40481087	1961-12-20	1962-01-03	1
27264	1609	257012	2002-02-28	2002-03-01	1
32206	1916	260139	1987-07-24	1987-07-31	1
12904	759	40481087	2013-08-07	2013-08-21	1
7925	462	260139	2009-12-01	2009-12-08	1
7990	469	40481087	1963-02-17	1963-02-24	1
18467	1112	40481087	1969-10-03	1969-10-10	1
21822	1310	4112343	2010-04-01	2010-04-11	1
63015	3725	40481087	2007-01-14	2007-01-21	1
31478	1864	372328	1971-02-05	1971-10-15	1
33291	1977	40481087	2005-04-07	2005-04-14	1
84515	5031	4296204	1946-02-20	1946-03-20	1
31027	1840	4294548	1985-05-25	1985-06-15	1
59614	3536	4056621	2016-03-28	2016-03-29	1
27506	1626	40481087	1990-02-23	1990-03-02	1
33904	2016	4266809	2017-03-20	2017-03-21	1
75283	4474	40481087	2004-08-16	2004-08-23	1
21567	1294	4112343	1999-03-17	1999-03-29	1
87550	5215	40481087	1960-11-22	1960-12-13	1
59444	3528	4029498	1958-11-03	1958-11-04	1
5233	308	40481087	2004-07-30	2004-08-13	1
36878	2185	4113008	1954-09-22	1954-10-05	1
88002	5239	257012	1991-11-28	1991-11-29	1
61369	3629	4112343	1975-08-27	1975-09-04	1
86537	5153	4285898	1986-07-10	1986-07-11	1
32013	1903	40481087	1999-07-25	1999-08-15	1
25875	1538	260139	2010-04-28	2010-05-05	1
37267	2210	4166224	1969-10-19	1969-10-20	1
79402	4707	260139	1999-07-28	1999-08-04	1
37596	2232	260139	2009-08-29	2009-09-05	1
78875	4675	4112343	1921-02-11	1921-02-20	1
26802	1588	40481087	2006-01-29	2006-02-12	1
75678	4492	260139	1959-06-09	1959-06-23	1
77923	4622	40481087	2007-08-30	2007-09-06	1
1142	67	4112343	2010-01-07	2010-01-18	1
80649	4788	378001	1999-10-09	1999-11-08	1
29515	1748	40481087	2003-01-14	2003-01-28	1
7702	452	372328	2009-08-18	2010-12-24	1
6553	387	81151	1991-08-25	1991-09-08	1
25801	1535	372328	1979-10-03	1980-03-10	1
76913	4561	4296204	2004-12-24	2005-01-07	1
29461	1746	4094814	1957-10-16	1958-01-14	1
354	18	4218389	2016-01-06	2016-02-03	1
86149	5132	40481087	1994-11-09	1994-11-30	1
87713	5223	260139	1974-05-11	1974-05-25	1
36567	2166	4278672	1986-09-09	1986-12-08	1
69483	4116	28060	2002-11-12	2002-11-25	1
31187	1847	40481087	1957-09-07	1957-09-28	1
26237	1558	40481087	1982-08-16	1982-08-30	1
6902	406	4112343	1984-09-29	1984-10-12	1
28582	1692	40481087	1992-10-03	1992-10-10	1
83606	4972	40481087	2016-12-14	2016-12-28	1
27265	1609	372328	1955-05-19	1956-04-18	1
32207	1916	378001	1996-12-12	1997-01-11	1
12905	759	80180	1980-06-13	1980-06-14	1
7926	462	372328	1979-10-01	1980-02-21	1
7991	469	40481087	1987-02-23	1987-03-09	1
21587	1297	260139	1989-11-04	1989-11-18	1
21823	1310	4112343	2010-12-11	2010-12-24	1
64799	3835	28060	1967-12-10	1967-12-17	1
31479	1864	40481087	1994-10-14	1994-11-04	1
33292	1977	40481087	2009-11-18	2009-12-02	1
84516	5031	40481087	1938-05-12	1938-05-19	1
33025	1962	192671	1999-02-24	1999-02-25	1
59615	3536	4112343	1971-01-01	1971-01-08	1
27507	1626	28060	1958-09-15	1958-09-26	1
33905	2016	40481087	1983-10-02	1983-10-23	1
75284	4474	40481087	2013-03-18	2013-03-25	1
21568	1294	40481087	1974-02-20	1974-02-27	1
87551	5215	40481087	1994-02-06	1994-02-13	1
59445	3528	40481087	1965-02-05	1965-02-26	1
5234	308	40481087	2004-12-16	2004-12-23	1
36879	2185	4218389	1962-04-24	1962-05-30	1
88003	5239	372328	1966-07-22	1966-11-02	1
61370	3629	40479768	1973-05-20	1973-07-26	1
86538	5153	40479422	2014-06-14	2014-08-20	1
32014	1903	40481087	2009-10-14	2009-11-04	1
25876	1538	372328	1931-02-27	1931-05-11	1
37268	2210	40481087	1963-02-10	1963-03-03	1
79403	4707	4278672	2018-07-12	2018-09-10	1
37597	2232	4109685	2001-09-08	2001-09-22	1
78876	4675	4112343	1986-06-09	1986-06-19	1
26803	1588	40481087	2010-07-20	2010-07-27	1
75679	4492	381316	1992-10-27	1992-10-28	1
77924	4622	257012	1998-10-10	1998-10-11	1
1143	67	260139	1992-08-09	1992-08-23	1
80650	4788	40481087	1982-04-24	1982-05-15	1
29516	1748	40481087	2005-09-21	2005-09-28	1
7703	452	4112343	2019-04-17	2019-04-27	1
6554	387	40481087	1984-08-04	1984-08-11	1
25802	1535	372328	1999-12-26	2001-04-09	1
76914	4561	4310024	1982-10-31	1982-11-01	1
29462	1746	4116491	2014-05-23	2014-06-23	1
355	18	40481087	2004-08-16	2004-09-06	1
86150	5132	28060	1974-02-28	1974-03-08	1
87714	5223	260139	1978-02-08	1978-02-22	1
36568	2166	40481087	1987-07-22	1987-08-05	1
69484	4116	192671	2012-07-20	2012-07-21	1
31188	1847	40481087	1967-07-04	1967-07-18	1
26238	1558	40481087	1988-07-20	1988-08-03	1
6903	406	4112343	1994-07-26	1994-08-02	1
28583	1692	40481087	1996-10-25	1996-11-15	1
83607	4972	28060	1974-05-25	1974-06-02	1
27266	1609	4059173	1993-10-13	1994-01-10	1
32208	1916	4113008	2004-10-31	2004-11-21	1
12906	759	313217	2003-02-19	2003-02-20	1
7927	462	4112343	1999-02-20	1999-03-03	1
7992	469	40481087	1989-01-04	1989-01-18	1
21588	1297	260139	2007-10-16	2007-10-30	1
21824	1310	40481087	1989-06-27	1989-07-11	1
64800	3835	80180	2004-08-29	2004-08-30	1
31480	1864	78272	1996-08-22	1996-09-05	1
33293	1977	80180	1952-04-20	1952-04-21	1
84517	5031	40481087	1977-05-03	1977-05-24	1
33026	1962	4112343	1985-02-10	1985-02-17	1
59616	3536	4116491	2016-03-28	2016-05-17	1
27508	1626	28060	1987-10-28	1987-11-09	1
33906	2016	81151	2003-05-07	2003-05-21	1
75285	4474	28060	1969-10-22	1969-10-30	1
21569	1294	28060	2014-07-12	2014-07-24	1
87552	5215	80180	1982-03-19	1982-03-20	1
62444	3694	0	1969-04-06	1969-04-07	1
7282	430	140673	1990-06-05	1990-06-06	1
36880	2185	40480160	2015-06-05	2015-07-05	1
88004	5239	4094814	1979-02-14	1979-05-15	1
61371	3629	40481087	1982-10-12	1982-10-26	1
86539	5153	40481087	1965-04-01	1965-04-08	1
32015	1903	78272	1973-07-21	1973-08-11	1
25877	1538	4112343	1965-12-07	1965-12-19	1
37269	2210	40481087	1965-10-24	1965-11-07	1
79404	4707	80180	2012-08-12	2012-08-13	1
37598	2232	40481087	1987-06-11	1987-06-25	1
78877	4675	4112343	2001-08-31	2001-09-10	1
26804	1588	40481087	2014-01-15	2014-01-29	1
75680	4492	4112343	1993-05-11	1993-05-24	1
77925	4622	260139	1983-01-06	1983-01-20	1
1144	67	40481087	1986-09-23	1986-09-30	1
80651	4788	40481087	2008-11-03	2008-11-10	1
32034	1905	28060	1990-01-27	1990-02-04	1
7704	452	40481087	1965-03-31	1965-04-14	1
6555	387	40481087	1999-10-29	1999-11-19	1
25803	1535	4027663	2006-03-27	2006-03-28	1
76915	4561	40481087	1958-07-19	1958-07-26	1
29463	1746	4294548	1961-12-25	1962-02-05	1
356	18	40481087	2006-12-04	2006-12-11	1
86151	5132	260139	1970-05-21	1970-05-28	1
87715	5223	260139	2010-10-17	2010-10-31	1
36569	2166	40481087	1994-09-03	1994-09-24	1
69485	4116	372328	1969-08-13	1969-09-25	1
31189	1847	40481087	1971-06-05	1971-06-26	1
27599	1632	372328	1954-03-08	1954-06-28	1
6904	406	4156265	1987-06-15	1987-06-29	1
28584	1692	40481087	2000-08-05	2000-08-12	1
83608	4972	4059173	2016-09-19	2016-12-18	1
27267	1609	4112343	2008-09-24	2008-10-02	1
32209	1916	4051466	1974-10-10	1991-01-16	1
12907	759	375671	2000-04-24	2000-06-23	1
7928	462	4112343	2013-12-30	2014-01-07	1
7993	469	260139	2004-10-20	2004-10-27	1
21589	1297	40481087	1979-08-15	1979-08-22	1
21825	1310	40486433	1945-03-07	1959-03-06	1
64801	3835	40481087	1988-04-06	1988-04-20	1
31481	1864	4146173	2018-06-26	2018-08-25	1
33294	1977	260139	1922-01-10	1922-01-24	1
84518	5031	40481087	2009-09-11	2009-09-25	1
33027	1962	4283893	2009-10-29	2009-11-26	1
59617	3536	4285898	1999-07-21	1999-07-22	1
27509	1626	80180	1970-01-10	1970-01-11	1
33907	2016	192671	2017-04-14	2017-04-15	1
75286	4474	28060	1972-07-19	1972-07-28	1
21570	1294	260139	1997-04-11	1997-04-18	1
87553	5215	372328	1941-11-04	1942-04-20	1
62445	3694	80180	1995-11-16	1995-11-17	1
7283	430	195588	1978-06-08	1978-07-28	1
36881	2185	40481087	1950-10-30	1950-11-20	1
88005	5239	4294548	1991-11-14	1992-01-02	1
61372	3629	78272	1990-02-27	1990-03-13	1
86540	5153	80180	1987-02-05	1987-02-06	1
32016	1903	260139	1971-03-05	1971-03-19	1
25878	1538	4112343	1980-05-06	1980-05-17	1
37270	2210	0	1969-10-19	1969-10-20	1
79405	4707	260139	2014-03-20	2014-03-27	1
37599	2232	28060	2019-06-18	2019-06-25	1
78878	4675	4218389	2014-07-02	2014-07-23	1
26805	1588	260139	2004-01-17	2004-01-24	1
75681	4492	4237458	1959-05-19	1959-06-18	1
77926	4622	260139	1986-09-14	1986-09-28	1
1145	67	378001	1980-07-27	1980-08-26	1
80652	4788	40481087	2013-01-23	2013-01-30	1
32035	1905	260139	1973-06-12	1973-06-26	1
7705	452	40481087	1973-02-26	1973-03-12	1
6556	387	40481087	2011-09-22	2011-09-29	1
25804	1535	4112343	2016-03-31	2016-04-10	1
80328	4763	372328	1953-01-08	1953-01-22	1
29464	1746	4296204	2015-06-03	2015-06-24	1
357	18	40481087	2012-03-14	2012-04-04	1
86152	5132	260139	2011-06-01	2011-06-15	1
87716	5223	372328	1971-10-28	1972-11-04	1
36570	2166	28060	2015-04-26	2015-05-09	1
69486	4116	372328	1979-07-05	1979-11-01	1
31190	1847	80180	1958-01-16	1958-01-17	1
27600	1632	4112343	1989-09-10	1989-09-21	1
6905	406	40481087	1962-06-27	1962-07-04	1
28585	1692	40481087	2012-09-14	2012-10-05	1
83609	4972	4113008	1956-09-13	1956-10-04	1
27268	1609	4142905	2014-02-15	2014-05-17	1
32210	1916	4059173	1977-07-18	1977-08-17	1
12908	759	4059173	2016-11-17	2017-01-16	1
7929	462	40481087	1988-11-21	1988-11-28	1
7994	469	4112343	1951-05-27	1951-06-07	1
21590	1297	40481087	1981-05-09	1981-05-23	1
23153	1384	28060	1997-08-30	1997-09-10	1
64802	3835	40481087	2018-01-07	2018-01-14	1
31482	1864	40481087	2006-11-07	2006-11-28	1
33295	1977	4109685	2007-12-09	2007-12-23	1
84519	5031	40481087	2010-03-03	2010-03-24	1
33028	1962	40481087	2001-11-16	2001-11-23	1
59618	3536	4294548	2006-11-04	2007-03-31	1
27510	1626	81151	1943-09-14	1943-10-05	1
33908	2016	4109685	1989-05-26	1989-06-16	1
75287	4474	260139	1966-02-23	1966-03-09	1
21571	1294	372328	1975-01-07	1975-04-26	1
87554	5215	4112343	1943-08-28	1943-09-04	1
62446	3694	260139	1961-06-18	1961-07-02	1
7284	430	4035415	1997-12-05	1998-01-04	1
36882	2185	40481087	1964-02-25	1964-03-10	1
88006	5239	260139	2004-09-23	2004-10-07	1
61373	3629	260139	1994-11-18	1994-12-02	1
86541	5153	260139	1955-10-03	1955-10-10	1
32017	1903	260139	1978-06-11	1978-06-18	1
25879	1538	4112343	1982-07-08	1982-07-20	1
37271	2210	28060	2016-06-21	2016-07-03	1
79406	4707	372328	1990-03-28	1990-10-25	1
37600	2232	260139	2016-10-13	2016-10-20	1
78879	4675	4278672	2006-11-11	2006-12-11	1
26806	1588	260139	2015-07-05	2015-07-12	1
75682	4492	4237458	1964-03-23	1964-05-22	1
77927	4622	260139	2010-11-23	2010-12-07	1
1146	67	378001	1996-10-31	1996-12-30	1
80653	4788	80180	2014-01-02	2014-01-03	1
32036	1905	372328	1966-07-18	1966-10-28	1
10317	610	260139	1998-01-28	1998-02-11	1
6557	387	80180	2016-07-06	2016-07-07	1
25805	1535	4285898	2012-06-18	2012-06-19	1
80329	4763	4112343	1950-10-22	1950-11-01	1
29465	1746	40481087	1962-04-13	1962-04-27	1
358	18	4112343	1969-10-31	1969-11-08	1
86153	5132	4059173	2014-05-03	2014-06-02	1
87717	5223	40481087	2008-10-29	2008-11-12	1
36571	2166	260139	1970-01-08	1970-01-15	1
69487	4116	4112343	1981-11-22	1981-11-30	1
31191	1847	255848	1995-06-15	1995-06-16	1
27601	1632	4112343	1996-10-16	1996-10-27	1
6906	406	40481087	1965-04-26	1965-05-10	1
28586	1692	0	1982-08-15	1982-08-16	1
83610	4972	4283893	1952-08-10	1952-11-30	1
27269	1609	40481087	2001-03-18	2001-03-25	1
32211	1916	4109685	1973-09-23	1973-10-07	1
12909	759	4112343	2005-12-24	2006-01-02	1
7930	462	40481087	1992-07-06	1992-07-20	1
7995	469	40481087	1938-03-28	1938-04-18	1
21591	1297	40481087	1986-09-29	1986-10-13	1
23154	1384	4112343	1987-09-20	1987-09-28	1
64803	3835	81151	1966-08-14	1966-09-11	1
31483	1864	4112343	1989-03-03	1989-03-10	1
33296	1977	4112343	1998-04-09	1998-04-19	1
84520	5031	40481087	2011-03-27	2011-04-10	1
33029	1962	40481087	2015-06-07	2015-06-21	1
59619	3536	4310024	1998-01-27	1998-01-28	1
27511	1626	313217	1995-08-27	1995-08-28	1
33909	2016	4146173	1986-07-11	1986-09-09	1
75288	4474	372328	1966-11-18	1967-04-14	1
21572	1294	260139	1985-09-05	1985-09-12	1
87555	5215	4152936	1973-10-17	1973-11-07	1
62447	3694	313217	2016-02-23	2016-02-24	1
7285	430	4109685	2009-09-03	2009-09-24	1
36883	2185	40481087	1973-06-26	1973-07-10	1
88007	5239	4059173	1972-08-19	1972-10-18	1
61374	3629	260139	2014-03-24	2014-03-31	1
86542	5153	4027663	1976-12-19	1976-12-20	1
32018	1903	260139	1981-12-30	1982-01-06	1
25880	1538	40481087	1985-04-16	1985-04-30	1
37272	2210	81151	1958-06-02	1958-06-23	1
79407	4707	4112343	2000-02-25	2000-03-05	1
37601	2232	4294548	1971-04-26	1971-05-31	1
78880	4675	40480160	2007-12-06	2008-01-05	1
26807	1588	440448	1981-12-01	1981-12-02	1
75683	4492	40481087	1963-08-20	1963-09-03	1
77928	4622	4218389	1962-12-20	1963-01-24	1
1147	67	4112343	1972-11-10	1972-11-20	1
80654	4788	372328	1978-07-27	1978-10-29	1
32037	1905	4112343	1980-01-09	1980-01-17	1
10318	610	260139	2010-08-22	2010-09-05	1
6558	387	4134304	1998-04-04	1998-07-03	1
25806	1535	30753	2012-04-19	2012-04-20	1
80330	4763	40479768	1989-11-21	1990-01-20	1
29466	1746	40481087	2004-07-02	2004-07-23	1
359	18	4112343	1991-08-01	1991-08-10	1
86154	5132	4134304	2019-06-06	2019-06-07	1
88382	5259	28060	1973-08-24	1973-09-04	1
36572	2166	260139	2001-06-13	2001-06-27	1
69488	4116	4266809	2012-06-23	2012-06-24	1
31192	1847	260139	1990-10-28	1990-11-04	1
27602	1632	4294548	1983-03-08	1983-06-01	1
6907	406	40481087	1995-03-14	1995-03-21	1
28587	1692	4285898	2016-02-28	2016-02-29	1
83611	4972	40481087	1968-06-06	1968-06-13	1
27270	1609	40481087	2015-04-05	2015-04-19	1
32212	1916	40481087	1986-09-14	1986-09-21	1
12910	759	4113008	1969-03-28	1969-04-18	1
10458	616	192671	2001-03-05	2001-03-06	1
7996	469	40481087	1990-04-18	1990-04-25	1
21592	1297	80180	2014-10-23	2014-10-24	1
23155	1384	4112343	1995-03-04	1995-03-11	1
64804	3835	4112343	1997-05-27	1997-06-04	1
31484	1864	4112343	1994-06-15	1994-06-26	1
33297	1977	4294548	2006-09-14	2006-10-26	1
84521	5031	80180	1956-06-17	1956-06-18	1
33030	1962	40481087	2015-08-26	2015-09-16	1
59620	3536	40481087	2016-02-20	2016-03-12	1
27512	1626	317576	2006-10-29	2006-10-30	1
33910	2016	40481087	2000-02-05	2000-02-26	1
75289	4474	440086	1971-06-05	1981-06-12	1
21573	1294	372328	1986-11-24	1987-11-21	1
87556	5215	40481087	1958-12-13	1958-12-27	1
62448	3694	4027663	1987-04-02	1987-04-03	1
7286	430	4112343	1991-05-06	1991-05-15	1
36884	2185	40481087	1979-07-18	1979-08-08	1
88008	5239	4294548	2006-08-21	2006-08-28	1
61375	3629	372328	1957-06-13	1957-10-28	1
86543	5153	40481087	1964-03-25	1964-04-01	1
32019	1903	4156265	2019-01-01	2019-01-22	1
25881	1538	40481087	2012-11-12	2012-11-19	1
37273	2210	440448	1969-10-19	1969-10-20	1
79408	4707	4283893	1987-05-16	1987-06-13	1
37602	2232	192671	2005-12-05	2005-12-06	1
78881	4675	40481087	1919-04-28	1919-05-12	1
26808	1588	40481087	1974-01-31	1974-02-21	1
77589	4602	440086	1987-05-07	1989-03-02	1
77929	4622	40481087	1978-12-17	1978-12-24	1
1148	67	4112343	2006-07-13	2006-07-25	1
80655	4788	4112343	1985-02-18	1985-02-28	1
32038	1905	28060	2010-04-04	2010-04-16	1
10319	610	4048171	1967-09-05	1981-09-03	1
6559	387	260139	1980-04-16	1980-04-23	1
25807	1535	80180	2013-04-14	2013-04-15	1
80331	4763	40481087	1951-11-22	1951-12-13	1
29467	1746	28060	1962-06-28	1962-07-08	1
360	18	4278672	1998-10-07	1999-01-05	1
88079	5242	80180	2000-02-03	2000-02-04	1
88383	5259	28060	1994-09-03	1994-09-15	1
36573	2166	40481087	1975-09-06	1975-09-20	1
69489	4116	40479422	1996-10-30	1997-01-05	1
31193	1847	372328	1981-05-03	1981-11-08	1
27603	1632	40481087	1971-02-25	1971-03-11	1
6908	406	40481087	1995-11-23	1995-11-30	1
28588	1692	80180	2017-01-23	2017-01-24	1
83612	4972	40481087	2011-07-28	2011-08-04	1
27271	1609	80180	1980-01-29	1980-01-30	1
32213	1916	40481087	1995-10-10	1995-10-31	1
12911	759	40481087	2006-08-30	2006-09-06	1
10459	616	372328	1961-06-21	1961-12-09	1
7997	469	30753	1976-05-08	1976-05-09	1
21593	1297	260139	2011-06-30	2011-07-07	1
23156	1384	4112343	2002-03-22	2002-03-31	1
64805	3835	4116491	2006-09-08	2006-10-17	1
31485	1864	4116491	2012-11-21	2012-12-26	1
33298	1977	40481087	1944-08-11	1944-08-18	1
84522	5031	260139	2002-02-06	2002-02-13	1
33031	1962	80180	1999-02-19	1999-02-20	1
59621	3536	40481087	2019-02-04	2019-02-18	1
27513	1626	372328	1939-10-26	1939-12-10	1
33911	2016	40481087	2011-05-30	2011-06-20	1
75290	4474	4112343	1965-11-26	1965-12-08	1
21574	1294	372328	1989-04-14	1989-12-02	1
87557	5215	40481087	1984-09-14	1984-10-05	1
62449	3694	4112343	1988-01-14	1988-01-23	1
7287	430	40481087	1972-04-13	1972-04-27	1
36885	2185	195588	1990-03-06	1990-04-10	1
88009	5239	4310024	2009-05-12	2009-05-13	1
61376	3629	4294548	1973-04-26	1973-07-05	1
86544	5153	40481087	1977-06-11	1977-06-18	1
32020	1903	40481087	1962-07-26	1962-08-09	1
25882	1538	28060	1994-05-19	1994-05-31	1
37274	2210	4112343	1954-09-05	1954-09-17	1
79409	4707	40481087	1976-04-28	1976-05-05	1
37603	2232	257012	1971-05-17	1971-05-31	1
78882	4675	40481087	1926-11-10	1926-12-01	1
26809	1588	40481087	1989-11-01	1989-11-22	1
77590	4602	40481087	1992-10-14	1992-10-28	1
77930	4622	28060	1968-11-04	1968-11-15	1
1149	67	40481087	1997-05-11	1997-05-18	1
80656	4788	4112343	1989-04-11	1989-04-21	1
32039	1905	260139	1996-12-01	1996-12-15	1
10320	610	4155034	1963-08-25	1963-09-08	1
6560	387	372328	1976-01-18	1976-02-01	1
25808	1535	260139	1980-09-20	1980-09-27	1
80332	4763	40481087	1983-10-20	1983-11-03	1
29468	1746	260139	1957-07-07	1957-07-21	1
361	18	40481087	1967-07-16	1967-07-23	1
88080	5242	260139	1996-12-07	1996-12-14	1
88384	5259	28060	2011-03-21	2011-04-02	1
36574	2166	40481087	1993-09-08	1993-09-29	1
70606	4194	4112343	2003-12-16	2003-12-26	1
31194	1847	378001	1958-11-17	1958-12-17	1
27604	1632	40481087	1975-01-28	1975-02-11	1
8182	480	80502	1998-03-18	1998-03-19	1
28589	1692	4027663	2007-08-09	2007-08-10	1
83975	4992	440086	1995-05-14	1998-05-31	1
27272	1609	81151	1980-11-21	1980-12-19	1
32214	1916	40481087	2001-02-10	2001-03-03	1
14345	850	30753	1988-09-30	1988-10-01	1
10460	616	375671	1981-04-12	1981-05-12	1
7998	469	80180	1977-02-02	1977-02-03	1
21594	1297	40481087	1979-10-27	1979-11-10	1
23157	1384	4237458	1989-03-09	1989-04-08	1
64806	3835	40481087	1991-07-11	1991-08-01	1
31486	1864	4152936	2014-02-03	2014-02-17	1
33299	1977	40481087	1950-09-21	1950-10-05	1
84523	5031	378001	1966-01-04	1966-03-05	1
33032	1962	260139	2019-01-22	2019-01-29	1
59622	3536	40486433	1967-11-13	1982-11-11	1
27514	1626	40481087	1936-04-02	1936-04-09	1
33912	2016	40481087	2013-11-12	2013-12-03	1
75291	4474	4112343	2002-01-23	2002-02-03	1
21575	1294	4230399	1978-08-19	1978-11-17	1
87558	5215	40481087	1992-06-03	1992-06-10	1
62450	3694	4310024	1993-05-30	1993-05-31	1
7288	430	40481087	1998-08-08	1998-08-29	1
36886	2185	260139	1982-10-26	1982-11-08	1
88010	5239	28060	2001-01-20	2001-01-29	1
61377	3629	4294548	1986-11-09	1986-12-07	1
86545	5153	0	1963-12-25	1963-12-26	1
32319	1923	260139	1962-06-13	1962-06-27	1
25883	1538	80180	1964-02-14	1964-02-15	1
37275	2210	4112343	1971-07-23	1971-08-02	1
87656	5222	81151	1926-04-03	1926-04-17	1
37604	2232	260139	1999-07-18	1999-08-01	1
78883	4675	40481087	1930-03-22	1930-03-29	1
26810	1588	40481087	2007-11-12	2007-11-26	1
77591	4602	28060	1985-12-26	1986-01-07	1
77931	4622	30753	1996-07-09	1996-07-10	1
1150	67	260139	1980-01-31	1980-02-14	1
80657	4788	28060	1978-09-10	1978-09-20	1
32040	1905	40481087	2005-10-27	2005-11-10	1
10321	610	40481087	1968-10-02	1968-10-16	1
6561	387	372328	1977-12-22	1978-08-11	1
25809	1535	260139	1986-10-28	1986-11-11	1
80333	4763	80180	1990-04-24	1990-04-25	1
29469	1746	372328	1996-05-16	1996-11-28	1
362	18	40481087	1976-12-13	1976-12-20	1
88081	5242	81151	1997-12-20	1998-01-10	1
88385	5259	80180	1999-11-06	1999-11-07	1
37130	2202	80180	2011-04-20	2011-04-21	1
70607	4194	4112343	2005-04-23	2005-05-01	1
31195	1847	378419	1988-12-18	1988-12-19	1
27605	1632	40481087	2003-05-22	2003-06-05	1
8183	480	134438	1971-05-18	1972-08-11	1
29875	1770	378001	2007-10-03	2007-12-02	1
83976	4992	440448	2007-05-12	2007-05-13	1
27273	1609	260139	1984-06-19	1984-06-26	1
32215	1916	40481087	2019-06-19	2019-06-20	1
14346	850	80180	1990-01-23	1990-01-24	1
10461	616	4112343	2014-01-27	2014-02-05	1
7999	469	195588	1975-11-20	1976-01-13	1
21595	1297	40481087	1998-04-20	1998-05-11	1
23158	1384	40481087	1985-04-25	1985-05-09	1
64807	3835	4296205	1984-10-06	1984-10-27	1
31487	1864	40481087	1966-07-10	1966-07-31	1
33300	1977	40481087	1966-04-20	1966-05-11	1
84524	5031	381316	1995-08-19	1995-08-20	1
33033	1962	4112343	1967-10-04	1967-10-16	1
64523	3820	80180	2005-07-23	2005-07-24	1
27515	1626	40481087	1984-06-20	1984-07-04	1
33913	2016	260139	1998-05-11	1998-05-25	1
77151	4576	260139	1968-05-13	1968-05-20	1
21576	1294	40481087	1983-10-14	1983-10-28	1
87559	5215	40481087	2006-08-08	2006-08-22	1
62451	3694	40481087	2017-06-20	2017-06-27	1
7289	430	40481087	2002-06-19	2002-07-10	1
36887	2185	40481087	1957-05-23	1957-06-06	1
88011	5239	80180	2011-08-30	2011-08-31	1
62149	3675	80180	2008-11-22	2008-11-23	1
86546	5153	28060	1998-04-02	1998-04-09	1
32320	1923	260139	2008-08-10	2008-08-24	1
25884	1538	313217	2008-05-05	2008-05-06	1
37276	2210	4146173	2003-07-23	2003-09-21	1
87657	5222	260139	1924-01-15	1924-01-22	1
37605	2232	4155034	2011-12-29	2012-01-12	1
78884	4675	40481087	1947-09-25	1947-10-16	1
26811	1588	28060	1975-08-29	1975-09-09	1
77592	4602	80180	2011-05-21	2011-05-22	1
77932	4622	4027663	1988-01-18	1988-01-19	1
1151	67	372328	1976-01-04	1976-10-03	1
80658	4788	81151	1989-08-11	1989-09-01	1
32041	1905	260139	2018-01-20	2018-02-03	1
10322	610	40481087	1969-01-20	1969-01-27	1
6562	387	4218389	2011-03-27	2011-05-01	1
25810	1535	4112343	1983-08-09	1983-08-19	1
80334	4763	260139	2009-04-23	2009-05-07	1
29470	1746	4112343	1987-02-25	1987-03-04	1
4351	254	4283893	1993-03-08	1993-04-05	1
88082	5242	313217	2018-08-31	2018-09-01	1
88386	5259	257012	1977-05-10	1977-05-11	1
37131	2202	257012	2016-12-17	2016-12-18	1
70608	4194	40481087	1984-02-21	1984-02-28	1
31196	1847	4112343	1919-05-20	1919-06-02	1
27606	1632	28060	1962-07-26	1962-08-05	1
8184	480	260139	1984-03-03	1984-03-17	1
29876	1770	4112343	1998-01-19	1998-01-29	1
83977	4992	40481087	1989-11-10	1989-12-01	1
27274	1609	260139	1992-11-03	1992-11-10	1
32216	1916	192671	2007-06-07	2007-06-08	1
14347	850	372328	1964-09-05	1965-04-13	1
10462	616	40481087	1985-03-16	1985-04-06	1
8000	469	260139	1955-07-02	1955-07-09	1
21596	1297	372328	1981-10-26	1982-01-17	1
23159	1384	40481087	2000-01-19	2000-02-02	1
64808	3835	40481087	1978-01-20	1978-02-03	1
31488	1864	40481087	1989-03-14	1989-04-04	1
33301	1977	40481087	2011-04-05	2011-04-26	1
84525	5031	4112343	1968-10-05	1968-10-17	1
33034	1962	4113008	1992-09-20	1992-10-04	1
64524	3820	372328	1967-08-07	1967-10-27	1
27516	1626	40481087	1994-09-15	1994-09-22	1
33914	2016	372328	1981-03-09	1981-05-19	1
77152	4576	372328	1955-04-25	1955-07-06	1
21577	1294	81151	1989-11-19	1989-12-03	1
87560	5215	260139	1944-02-23	1944-03-01	1
62452	3694	78272	1958-11-30	1958-12-21	1
7290	430	28060	1965-05-23	1965-06-05	1
36888	2185	40481087	1958-10-06	1958-10-20	1
88012	5239	81893	2010-03-08	2010-03-09	1
62150	3675	257012	1978-05-09	1978-05-10	1
86547	5153	30753	1985-12-12	1985-12-13	1
32321	1923	4112343	1973-03-21	1973-03-31	1
25885	1538	4112343	1950-12-03	1950-12-11	1
37277	2210	4152936	1966-07-11	1966-08-01	1
87658	5222	260139	1935-02-21	1935-02-28	1
37606	2232	4296204	1968-02-13	1968-03-05	1
78885	4675	40481087	1960-08-06	1960-08-13	1
26812	1588	372328	1961-08-31	1961-11-12	1
77593	4602	40481087	1996-12-11	1996-12-25	1
77933	4622	4112343	2017-07-31	2017-08-08	1
1152	67	40481087	1977-12-17	1978-01-07	1
80659	4788	372328	1977-08-27	1977-10-30	1
32042	1905	317576	1983-08-05	1983-08-06	1
10323	610	260139	1993-05-21	1993-06-04	1
9279	549	4112343	2004-04-26	2004-05-08	1
25811	1535	4112343	2015-10-31	2015-11-12	1
80335	4763	4035415	1983-06-21	1983-07-21	1
29471	1746	40481087	1958-06-02	1958-06-09	1
4352	254	40481087	1967-07-02	1967-07-23	1
88083	5242	372328	1964-09-14	1965-01-01	1
88387	5259	260139	1973-02-11	1973-02-18	1
37132	2202	4294548	1996-05-23	1996-08-15	1
70609	4194	80180	2014-07-06	2014-07-07	1
31197	1847	4112343	1923-11-03	1923-11-14	1
27607	1632	260139	1958-05-18	1958-06-01	1
8185	480	260139	2010-05-02	2010-05-16	1
29877	1770	40481087	1979-03-16	1979-04-06	1
83978	4992	40481087	1992-05-28	1992-06-04	1
27275	1609	372328	1949-03-17	1950-03-15	1
32217	1916	260139	2001-09-09	2001-09-23	1
14348	850	4027663	1978-02-10	1978-02-11	1
10463	616	0	1962-01-03	1962-01-04	1
8001	469	375671	1960-12-18	1961-01-17	1
21597	1297	4116491	2013-08-04	2013-09-15	1
23160	1384	40481087	2003-09-20	2003-10-11	1
64809	3835	40481087	1984-09-05	1984-09-19	1
31489	1864	260139	1979-11-04	1979-11-11	1
33648	1999	372328	1982-10-10	1983-09-30	1
84526	5031	4283893	1986-05-31	1986-06-21	1
33035	1962	4278672	2005-03-28	2005-05-27	1
64525	3820	4294548	1979-01-12	1979-05-25	1
27517	1626	40481087	1995-01-25	1995-02-01	1
33915	2016	372328	1983-09-06	1983-11-15	1
77153	4576	78272	1957-08-12	1957-09-09	1
21578	1294	260139	2000-10-06	2000-10-13	1
87561	5215	260139	2000-01-08	2000-01-22	1
62453	3694	81151	1993-04-26	1993-05-24	1
7291	430	80180	1972-10-27	1972-10-28	1
36889	2185	40481087	1988-08-14	1988-09-04	1
88013	5239	192671	2011-10-26	2011-10-27	1
62151	3675	260139	1970-03-03	1970-03-17	1
86548	5153	81893	1985-08-14	1985-08-15	1
32322	1923	4112343	1999-03-17	1999-03-25	1
25886	1538	4112343	2009-09-26	2009-10-08	1
37278	2210	4218389	1975-03-17	1975-04-21	1
87659	5222	313217	2004-02-12	2004-02-13	1
37607	2232	40481087	1971-03-07	1971-03-21	1
78886	4675	40481087	1964-03-03	1964-03-10	1
26813	1588	4112343	1999-06-08	1999-06-19	1
77594	4602	260139	2015-07-16	2015-07-30	1
77934	4622	40481087	1999-10-13	1999-11-03	1
1153	67	40481087	1985-02-04	1985-02-25	1
80660	4788	40481087	1979-01-14	1979-02-04	1
32043	1905	4296204	1997-12-02	1997-12-16	1
10324	610	4112343	1996-12-26	1997-01-03	1
9280	549	4155034	2011-04-18	2011-05-09	1
25812	1535	40481087	1979-10-30	1979-11-06	1
80336	4763	4218389	1951-06-18	1951-07-09	1
29472	1746	40481087	1964-07-22	1964-08-05	1
4353	254	40481087	1969-03-23	1969-04-06	1
88084	5242	40481087	1975-05-26	1975-06-16	1
88388	5259	4278672	1973-09-29	1973-11-28	1
37133	2202	4294548	2011-06-19	2011-07-17	1
70610	4194	81151	2005-11-19	2005-12-17	1
31198	1847	4116491	1963-10-27	1963-12-13	1
27608	1632	4029498	1962-07-20	1962-07-21	1
8186	480	260139	2010-09-15	2010-09-22	1
29878	1770	40481087	2016-08-13	2016-09-03	1
83979	4992	28060	2014-03-01	2014-03-14	1
27276	1609	4084167	1959-07-29	1959-07-29	1
32218	1916	260139	2015-09-12	2015-09-19	1
14349	850	4094814	2019-05-13	2019-05-14	1
10464	616	28060	1977-08-11	1977-08-23	1
8002	469	4112343	1936-11-28	1936-12-10	1
21598	1297	40481087	2008-03-25	2008-04-01	1
23161	1384	40481087	2006-05-06	2006-05-13	1
64810	3835	81151	2001-02-14	2001-03-21	1
31490	1864	261325	2009-12-18	2009-12-19	1
33649	1999	4156265	2013-04-22	2013-05-06	1
84527	5031	4296205	1982-10-07	1982-10-28	1
33036	1962	40481087	1991-08-18	1991-09-01	1
64526	3820	78272	1977-11-12	1977-12-17	1
27518	1626	0	2010-10-10	2010-10-11	1
33916	2016	4027663	2009-12-02	2009-12-03	1
77154	4576	260139	1956-03-30	1956-04-13	1
21579	1294	4112343	1984-11-19	1984-11-26	1
87562	5215	321042	1960-07-11	1960-07-12	1
62454	3694	375671	1990-02-11	1990-03-13	1
7292	430	80502	2011-11-19	2011-11-20	1
36890	2185	80502	2000-09-28	2000-09-29	1
88014	5239	260139	1968-10-11	1968-10-18	1
62152	3675	260139	2018-02-28	2018-03-07	1
86549	5153	192671	1987-03-14	1987-03-15	1
32323	1923	40481087	1955-04-09	1955-04-16	1
25887	1538	4294548	1945-05-21	1945-07-30	1
37279	2210	4294548	1975-09-06	1976-02-28	1
87660	5222	372328	1919-03-11	1919-06-26	1
37608	2232	40481087	1997-04-30	1997-05-14	1
78887	4675	40481087	1977-07-06	1977-07-27	1
26814	1588	4166224	1981-12-01	1981-12-02	1
77595	4602	40481087	2006-03-13	2006-03-27	1
80161	4756	28060	2006-04-02	2006-04-11	1
1154	67	40481087	2000-07-09	2000-07-23	1
80661	4788	40481087	2016-06-19	2016-07-10	1
32044	1905	40481087	1992-09-13	1992-09-27	1
10325	610	4116491	2015-09-22	2015-11-01	1
9281	549	40481087	1973-07-17	1973-07-31	1
25813	1535	40481087	2011-08-11	2011-08-25	1
80337	4763	4283893	1997-09-24	1998-01-21	1
29473	1746	40481087	2003-11-08	2003-11-29	1
4354	254	40481087	1975-07-13	1975-08-03	1
88085	5242	440086	1969-07-25	1980-08-01	1
88389	5259	4294548	1977-04-19	1977-12-27	1
37134	2202	40481087	1974-11-12	1974-11-19	1
70611	4194	4112343	1976-08-28	1976-09-10	1
31199	1847	40481087	1960-06-20	1960-07-04	1
27609	1632	4112343	2002-06-01	2002-06-10	1
8187	480	372328	1937-10-16	1938-01-26	1
29879	1770	78272	1981-05-26	1981-06-23	1
83980	4992	372328	1987-09-03	1987-10-22	1
27277	1609	4152936	1950-10-13	1950-11-03	1
32219	1916	372328	1977-06-04	1978-02-13	1
14350	850	4112343	1987-07-03	1987-07-12	1
10465	616	28060	2006-06-24	2006-07-04	1
8003	469	4310024	1974-07-18	1974-07-19	1
21599	1297	260139	1983-09-18	1983-10-02	1
23162	1384	40481087	2012-08-16	2012-08-23	1
64811	3835	4112343	1976-11-30	1976-12-12	1
31491	1864	40481087	1978-07-06	1978-07-20	1
33650	1999	40481087	2012-09-26	2012-10-03	1
84528	5031	40481087	1930-08-30	1930-09-20	1
33037	1962	4112343	1966-10-28	1966-11-04	1
64527	3820	81151	2015-08-31	2015-09-28	1
27519	1626	196456	1989-12-17	1989-12-17	1
33917	2016	4230399	2011-09-06	2011-10-06	1
77155	4576	372328	1955-12-03	1956-02-01	1
23865	1428	80180	1984-03-30	1984-03-31	1
87563	5215	372328	1954-09-14	1955-05-09	1
62455	3694	4059173	1972-12-21	1973-01-20	1
7293	430	260139	1954-10-11	1954-10-18	1
36891	2185	260139	1983-11-12	1983-11-19	1
88015	5239	372328	1970-10-12	1970-11-04	1
62153	3675	4112343	1995-08-09	1995-08-18	1
86550	5153	260139	1982-11-21	1982-11-28	1
32324	1923	255848	2018-04-09	2018-04-10	1
25888	1538	40481087	2001-06-23	2001-07-14	1
37280	2210	40481087	1961-07-01	1961-07-15	1
87661	5222	40481087	1938-06-08	1938-06-22	1
37609	2232	40481087	2014-08-20	2014-08-27	1
78888	4675	40481087	2009-10-31	2009-11-21	1
26815	1588	40481087	1980-12-23	1980-12-30	1
77596	4602	260139	1996-04-30	1996-05-07	1
80162	4756	80502	2004-09-11	2004-09-12	1
1155	67	40481087	2004-09-07	2004-09-14	1
80662	4788	4112343	1999-03-31	1999-04-12	1
32045	1905	80180	2008-08-31	2008-09-01	1
10326	610	4134304	1976-10-11	1976-12-10	1
9282	549	40481087	1979-12-03	1979-12-17	1
25814	1535	260139	1989-01-03	1989-01-17	1
80338	4763	257012	1997-10-15	1997-10-16	1
29474	1746	28060	1997-08-09	1997-08-20	1
4355	254	40481087	1977-07-28	1977-08-18	1
88086	5242	40481087	1987-10-18	1987-10-25	1
88390	5259	40481087	1972-02-10	1972-02-24	1
37135	2202	260139	1997-12-24	1997-12-31	1
70612	4194	4112343	1984-04-03	1984-04-14	1
31200	1847	40481087	1981-11-09	1981-11-16	1
27610	1632	4112343	2011-09-24	2011-10-07	1
8188	480	4218389	1943-10-15	1943-11-05	1
29880	1770	257012	2008-11-24	2008-11-25	1
83981	4992	40481087	2002-03-19	2002-03-26	1
27278	1609	4218389	1996-09-27	1996-10-18	1
32220	1916	4112343	2007-04-30	2007-05-09	1
14351	850	4112343	2013-03-14	2013-03-27	1
10466	616	81151	1969-07-09	1969-08-13	1
8004	469	40481087	1955-07-27	1955-08-10	1
21600	1297	260139	2000-12-26	2001-01-02	1
23163	1384	80180	2016-11-27	2016-11-28	1
64812	3835	4113008	1986-09-17	1986-10-01	1
31492	1864	40481087	1984-08-23	1984-08-30	1
33651	1999	40481087	2013-07-06	2013-07-13	1
84529	5031	40481087	1935-11-02	1935-11-16	1
33038	1962	4155034	1979-06-03	1979-06-17	1
64528	3820	192671	2005-08-10	2005-08-11	1
27520	1626	372328	1937-07-30	1937-12-05	1
33918	2016	4285898	2016-06-23	2016-06-24	1
77156	4576	4112343	1965-02-05	1965-02-14	1
23866	1428	260139	1962-12-07	1962-12-14	1
87564	5215	4059173	1970-02-05	1970-04-06	1
62456	3694	4109685	1961-11-05	1961-11-19	1
7294	430	260139	1986-01-05	1986-01-19	1
36892	2185	260139	2018-11-23	2018-11-30	1
88016	5239	4278672	1997-03-11	1997-06-09	1
62154	3675	40481087	1986-01-14	1986-02-04	1
86551	5153	4059173	1977-03-30	1977-04-29	1
32325	1923	260139	2013-03-27	2013-04-03	1
25889	1538	260139	1938-02-21	1938-02-28	1
37281	2210	40481087	1991-03-10	1991-03-24	1
87662	5222	28060	1965-06-06	1965-06-16	1
37610	2232	40481087	2018-05-15	2018-05-29	1
82112	4874	80180	2004-02-11	2004-02-12	1
27057	1602	4112343	1973-12-19	1973-12-26	1
77597	4602	4112343	1996-06-16	1996-06-27	1
80163	4756	81151	1994-08-15	1994-09-12	1
1156	67	40481087	2011-05-18	2011-06-08	1
80873	4802	80180	2005-06-20	2005-06-21	1
32046	1905	81151	2000-10-31	2000-11-21	1
10327	610	40481087	1997-01-05	1997-01-12	1
9283	549	40481087	2014-08-08	2014-08-29	1
25815	1535	260139	1995-11-21	1995-11-28	1
80339	4763	260139	2003-08-15	2003-08-22	1
29475	1746	28060	2014-03-27	2014-04-09	1
4356	254	40481087	1987-12-30	1988-01-20	1
88087	5242	28060	2017-05-12	2017-05-21	1
88391	5259	40481087	1972-08-01	1972-08-22	1
37136	2202	372328	1974-01-09	1974-03-21	1
70613	4194	28060	2010-03-06	2010-03-17	1
33072	1965	40481087	2008-09-17	2008-10-08	1
27611	1632	4294548	1965-05-01	1965-05-22	1
8189	480	40481087	1946-10-06	1946-10-20	1
29881	1770	260139	1986-06-01	1986-06-15	1
83982	4992	40481087	2006-05-13	2006-05-27	1
27279	1609	4283893	2002-01-24	2002-06-07	1
32221	1916	40481087	2004-05-23	2004-05-30	1
14352	850	4218389	1991-07-11	1991-08-08	1
10467	616	260139	2003-07-12	2003-07-26	1
8005	469	40481087	1956-11-08	1956-11-15	1
21601	1297	4112343	2002-02-09	2002-02-22	1
23164	1384	372328	1986-12-09	1987-02-24	1
64813	3835	40481087	2015-10-30	2015-11-13	1
32945	1956	28060	1994-01-27	1994-02-07	1
33652	1999	28060	1990-03-22	1990-04-02	1
84530	5031	40481087	1948-05-22	1948-06-05	1
33039	1962	40481087	1985-12-21	1986-01-11	1
64529	3820	4109685	1998-03-07	1998-03-21	1
27521	1626	4112343	1948-08-21	1948-08-28	1
33919	2016	40481087	2008-09-19	2008-10-03	1
77157	4576	4112343	1970-03-21	1970-04-03	1
23867	1428	4112343	1995-11-19	1995-12-02	1
87565	5215	4296204	2002-05-12	2002-06-09	1
62457	3694	4112343	1978-02-20	1978-03-05	1
7295	430	372328	1933-06-20	1933-11-25	1
36893	2185	372328	1972-04-19	1973-02-21	1
2220	129	260139	1994-08-25	1994-09-08	1
62155	3675	192671	2009-01-09	2009-01-10	1
86552	5153	4283893	1992-10-15	1992-11-19	1
32326	1923	4112343	1958-12-13	1958-12-22	1
25890	1538	260139	1992-11-18	1992-12-02	1
37282	2210	260139	2016-05-10	2016-05-24	1
87663	5222	80180	1961-03-25	1961-03-26	1
37611	2232	260139	1979-03-18	1979-03-25	1
82113	4874	4048695	2006-11-26	2006-12-28	1
27058	1602	4113008	1971-04-10	1971-04-24	1
77598	4602	4112343	2004-02-20	2004-03-02	1
80164	4756	260139	1977-06-03	1977-06-10	1
1157	67	40481087	2018-06-07	2018-06-21	1
80874	4802	260139	2003-05-17	2003-05-31	1
32047	1905	195588	2006-02-08	2006-03-16	1
10328	610	40481087	1997-09-18	1997-10-09	1
9284	549	81151	1962-07-08	1962-07-29	1
25816	1535	4112343	2009-09-07	2009-09-16	1
80340	4763	372328	1955-09-09	1956-08-07	1
29476	1746	81151	1963-11-14	1963-12-05	1
4357	254	40481087	1991-11-29	1991-12-06	1
88088	5242	260139	1975-11-18	1975-12-02	1
88392	5259	40479422	2008-04-19	2008-05-26	1
37137	2202	40481087	1978-06-06	1978-06-20	1
70614	4194	372328	1981-08-28	1982-04-11	1
33073	1965	81151	1986-04-20	1986-05-11	1
27612	1632	40481087	1956-01-06	1956-01-20	1
8190	480	40481087	1949-12-12	1949-12-26	1
29882	1770	260139	2006-04-28	2006-05-14	1
83983	4992	0	2007-05-12	2007-05-13	1
27280	1609	40481087	1946-12-08	1946-12-15	1
32222	1916	372328	1984-02-12	1984-03-19	1
14353	850	4283893	2009-05-13	2009-06-17	1
10468	616	260139	2012-11-14	2012-11-21	1
8006	469	40481087	2000-03-21	2000-03-28	1
25783	1533	28060	2014-08-27	2014-09-03	1
23165	1384	4112343	1994-11-22	1994-12-01	1
66377	3934	260139	1939-02-16	1939-03-02	1
32946	1956	78272	1975-01-23	1975-02-13	1
33653	1999	40481087	2019-02-08	2019-02-22	1
84531	5031	40481087	1951-08-27	1951-09-10	1
33040	1962	40481087	2003-04-25	2003-05-16	1
64530	3820	4155034	2002-12-25	2003-01-08	1
27522	1626	4283893	2007-05-08	2007-06-05	1
38831	2309	80180	2016-10-10	2016-10-11	1
77158	4576	4112343	2014-08-30	2014-09-07	1
23868	1428	4112343	2006-07-24	2006-08-01	1
87566	5215	0	1960-07-11	1960-07-12	1
62458	3694	4134304	1971-08-29	1971-11-27	1
7296	430	378419	2005-07-16	2005-07-17	1
36894	2185	4112343	1965-09-23	1965-10-05	1
2221	129	4112343	1987-01-20	1987-02-01	1
62156	3675	260139	1998-11-16	1998-11-23	1
86553	5153	40481087	1949-06-02	1949-06-09	1
32327	1923	40481087	1948-03-17	1948-04-07	1
25891	1538	372328	1932-04-06	1932-05-09	1
37283	2210	4059173	1943-08-20	1943-11-18	1
87664	5222	134438	1946-07-19	1947-08-18	1
37612	2232	260139	1981-07-13	1981-07-27	1
82114	4874	4155034	1992-12-25	1993-01-08	1
27059	1602	4278672	2006-05-25	2006-07-24	1
77599	4602	40481087	1977-11-13	1977-12-04	1
80165	4756	4112343	1990-02-03	1990-02-11	1
3760	217	28060	1979-12-27	1980-01-04	1
80875	4802	4059173	1971-12-05	1972-03-04	1
32048	1905	260139	1986-02-19	1986-02-26	1
10329	610	28060	1966-09-09	1966-09-18	1
9285	549	192671	1987-12-28	1987-12-29	1
25817	1535	40481087	2012-01-01	2012-01-15	1
80341	4763	4112343	1962-03-13	1962-03-22	1
29477	1746	260139	1970-11-15	1970-11-29	1
4358	254	260139	1953-07-09	1953-07-16	1
88089	5242	260139	1993-10-30	1993-11-13	1
88393	5259	40481087	1970-07-01	1970-07-15	1
37138	2202	260139	1982-08-26	1982-09-09	1
70615	4194	4112343	2003-08-08	2003-08-17	1
33074	1965	372328	1980-07-13	1981-01-25	1
27613	1632	40481087	1988-01-10	1988-01-31	1
8191	480	40481087	1953-08-03	1953-08-17	1
29883	1770	4112343	1984-03-12	1984-03-22	1
83984	4992	80180	2019-03-24	2019-03-25	1
32705	1946	28060	1977-09-20	1977-10-01	1
32223	1916	4146173	1995-12-18	1996-02-16	1
14354	850	40481087	1947-04-26	1947-05-17	1
10469	616	440448	1962-01-03	1962-01-04	1
8007	469	260139	1946-07-06	1946-07-13	1
25784	1533	260139	2013-07-22	2013-08-05	1
23166	1384	4134304	1991-03-29	1991-04-28	1
66378	3934	4112343	1998-09-06	1998-09-14	1
32947	1956	260139	1996-04-23	1996-05-07	1
33654	1999	80180	2017-02-05	2017-02-06	1
85184	5073	78272	1976-11-29	1976-12-27	1
33041	1962	40481087	2004-05-16	2004-05-23	1
64531	3820	40481087	2004-07-22	2004-07-29	1
27523	1626	40481087	1977-07-04	1977-07-25	1
38832	2309	4142905	1980-04-06	1980-06-05	1
77159	4576	40481087	2007-04-13	2007-04-27	1
23869	1428	40481087	1981-11-28	1981-12-19	1
87567	5215	81151	1982-08-20	1982-09-24	1
62459	3694	4152936	2006-07-15	2006-08-05	1
7297	430	4001336	2006-09-19	2006-10-19	1
36895	2185	4112343	2013-10-25	2013-11-05	1
2222	129	4112343	1996-12-23	1997-01-03	1
62157	3675	372328	1967-11-13	1967-12-25	1
86554	5153	40481087	1959-01-24	1959-02-14	1
32328	1923	40481087	1994-10-16	1994-11-06	1
25892	1538	381316	2016-09-19	2016-09-20	1
37284	2210	4059173	1985-11-24	1986-01-23	1
87665	5222	260139	1928-10-28	1928-11-11	1
37613	2232	4294548	1992-06-05	1992-07-17	1
82115	4874	4294548	1980-08-02	1980-11-01	1
27060	1602	40481087	2004-07-30	2004-08-06	1
77600	4602	40481087	1983-09-10	1983-09-24	1
80166	4756	4155034	1985-11-25	1985-12-16	1
3761	217	260139	2016-03-06	2016-03-13	1
80876	4802	4112343	1999-12-11	1999-12-18	1
32049	1905	260139	2003-11-28	2003-12-05	1
10330	610	28060	1973-08-27	1973-09-03	1
9286	549	40481087	1989-02-03	1989-02-17	1
25818	1535	28060	1997-01-22	1997-01-29	1
80342	4763	4112343	1979-10-04	1979-10-13	1
29478	1746	372328	1958-07-15	1959-07-30	1
4359	254	260139	1962-10-29	1962-11-12	1
88090	5242	40481087	1988-07-26	1988-08-02	1
88394	5259	4109685	2004-05-19	2004-06-09	1
37139	2202	4112343	1978-02-20	1978-03-01	1
70616	4194	260139	2012-06-18	2012-07-02	1
33075	1965	378001	1989-03-26	1989-04-25	1
27614	1632	40481087	2016-02-04	2016-02-25	1
8192	480	40481087	1964-09-16	1964-09-30	1
29884	1770	40481087	1979-06-11	1979-06-18	1
83985	4992	40481087	1989-04-30	1989-05-07	1
32706	1946	260139	1953-12-19	1953-12-26	1
32224	1916	40479768	1982-05-23	1982-06-29	1
14355	850	40481087	1961-04-11	1961-05-02	1
10470	616	40481087	1999-03-01	1999-03-08	1
8008	469	260139	2010-08-28	2010-09-11	1
25785	1533	378001	2000-08-23	2000-09-22	1
23167	1384	4146173	1996-04-08	1996-06-14	1
66379	3934	4237458	1945-08-02	1945-10-31	1
32948	1956	260139	2016-01-07	2016-01-14	1
33655	1999	134438	2011-09-22	2012-07-19	1
85185	5073	80180	1977-05-17	1977-05-18	1
33042	1962	28060	1968-06-13	1968-06-23	1
64532	3820	40481087	2017-08-19	2017-09-09	1
27524	1626	40481087	1981-06-13	1981-06-27	1
38833	2309	260139	1990-08-29	1990-09-05	1
77160	4576	28060	2011-09-23	2011-10-01	1
23870	1428	40481087	1994-10-03	1994-10-10	1
87568	5215	81151	2008-08-06	2008-09-10	1
62460	3694	4237458	1995-02-13	1995-04-14	1
7298	430	4112343	1989-04-04	1989-04-13	1
36896	2185	4134304	2015-06-05	2015-07-05	1
2223	129	4112343	2004-10-04	2004-10-13	1
62158	3675	4112343	1994-12-01	1994-12-08	1
86555	5153	40481087	1983-10-21	1983-11-11	1
32329	1923	40481087	2011-08-09	2011-08-23	1
25893	1538	4112343	1937-06-28	1937-07-11	1
37285	2210	4112343	1945-12-11	1945-12-19	1
87666	5222	260139	1977-04-29	1977-05-13	1
37614	2232	40481087	1966-07-02	1966-07-23	1
82116	4874	40481087	1995-09-22	1995-10-13	1
27061	1602	260139	1969-09-04	1969-09-18	1
79259	4700	28060	1958-01-03	1958-01-13	1
80167	4756	4296204	1969-05-25	1969-06-22	1
3762	217	4112343	2017-03-15	2017-03-27	1
80877	4802	40481087	2016-09-04	2016-09-25	1
32050	1905	372328	1972-01-30	1973-02-09	1
10331	610	378001	1974-11-21	1974-12-21	1
9287	549	40481087	2004-12-30	2005-01-20	1
25819	1535	28060	1999-10-19	1999-10-28	1
80343	4763	4112343	1989-06-25	1989-07-02	1
29479	1746	4116491	2011-04-18	2011-05-24	1
4360	254	260139	2000-10-07	2000-10-21	1
2524	149	192671	1982-12-09	1982-12-10	1
88395	5259	4112343	1989-09-14	1989-09-26	1
37140	2202	4283893	2016-11-26	2017-02-25	1
70617	4194	40481087	2001-09-05	2001-09-19	1
33076	1965	4027663	2000-01-22	2000-01-23	1
27615	1632	0	1962-07-20	1962-07-21	1
8193	480	40481087	1997-04-18	1997-04-25	1
29885	1770	40481087	2002-07-12	2002-07-26	1
83986	4992	40481087	1996-04-21	1996-05-12	1
32707	1946	260139	1985-07-21	1985-08-04	1
32225	1916	40481087	1976-01-17	1976-01-31	1
14356	850	40481087	1995-06-12	1995-06-19	1
10471	616	4112343	1974-12-11	1974-12-23	1
8009	469	372328	1938-03-06	1938-05-07	1
25786	1533	40481087	2002-05-11	2002-06-01	1
23168	1384	40479422	1994-01-12	1994-02-18	1
66380	3934	4283893	1951-12-13	1952-07-03	1
32949	1956	260139	1967-03-07	1967-03-21	1
33656	1999	440086	1991-09-20	1992-01-03	1
85186	5073	81151	1937-06-01	1937-06-22	1
33043	1962	28060	1972-08-05	1972-08-14	1
64533	3820	28060	1968-07-05	1968-07-12	1
27525	1626	28060	1956-07-19	1956-07-26	1
38834	2309	378001	1994-03-22	1994-05-21	1
77161	4576	260139	1963-04-02	1963-04-09	1
23871	1428	260139	1954-02-03	1954-02-17	1
87569	5215	260139	2008-07-29	2008-08-05	1
62461	3694	40481087	1972-05-26	1972-06-09	1
7299	430	4112343	2008-04-30	2008-05-11	1
36897	2185	4237458	1992-09-03	1992-10-03	1
2224	129	4283893	2010-08-30	2010-10-04	1
62159	3675	40481087	1969-08-12	1969-08-19	1
86556	5153	40481087	2001-12-09	2001-12-23	1
32330	1923	80180	1972-06-29	1972-06-30	1
25894	1538	4155034	1999-07-05	1999-07-26	1
37286	2210	4112343	1994-12-30	1995-01-12	1
87667	5222	260139	2009-10-15	2009-10-29	1
39278	2333	198809	1978-05-19	1978-05-19	1
82117	4874	260139	1972-06-14	1972-06-21	1
27062	1602	4294548	2005-02-11	2005-03-18	1
79260	4700	81151	1998-06-05	1998-06-19	1
80168	4756	40481087	1955-08-16	1955-08-23	1
3763	217	40481087	1981-11-09	1981-11-23	1
80878	4802	260139	1970-03-23	1970-03-30	1
32051	1905	4112343	1990-08-07	1990-08-16	1
10332	610	4112343	1972-11-19	1972-11-26	1
9288	549	80180	1987-12-04	1987-12-05	1
25820	1535	81151	1999-09-10	1999-10-01	1
80344	4763	4112343	2005-04-29	2005-05-06	1
30347	1793	28060	1967-06-13	1967-06-21	1
4361	254	4112343	1954-12-01	1954-12-08	1
2525	149	260139	1999-03-29	1999-04-05	1
88396	5259	4146173	1961-07-13	1961-09-11	1
37141	2202	40481087	1993-09-24	1993-10-01	1
70618	4194	40481087	2014-12-15	2014-12-29	1
33077	1965	30753	2009-03-15	2009-03-16	1
27616	1632	0	1988-11-13	1988-11-14	1
8194	480	40481087	2003-03-01	2003-03-08	1
29886	1770	80180	2014-12-19	2014-12-20	1
83987	4992	40481087	2016-08-07	2016-08-14	1
32708	1946	4112343	1926-07-25	1926-08-05	1
32565	1936	28060	1949-07-12	1949-07-24	1
14357	850	260139	1971-03-15	1971-03-29	1
10472	616	4112343	2018-10-13	2018-10-26	1
8010	469	378001	1988-01-10	1988-02-09	1
25787	1533	80180	2009-09-10	2009-09-11	1
23169	1384	372328	1984-06-03	1984-08-21	1
66381	3934	40481087	1957-05-09	1957-05-30	1
32950	1956	4112343	1977-10-12	1977-10-21	1
33657	1999	4134304	1991-07-12	1991-08-11	1
85187	5073	317576	2009-08-29	2009-08-30	1
33044	1962	28060	2015-08-20	2015-08-27	1
64534	3820	28060	1968-11-10	1968-11-21	1
27526	1626	261325	2000-09-24	2000-09-25	1
38835	2309	40481087	1990-05-19	1990-05-26	1
77162	4576	260139	1983-06-02	1983-06-16	1
23872	1428	260139	1998-09-18	1998-10-02	1
87570	5215	375671	1998-08-01	1998-09-30	1
62462	3694	40481087	2010-01-13	2010-01-20	1
7300	430	4132546	2006-09-19	2006-09-20	1
36898	2185	4278672	1942-12-24	1943-02-22	1
2225	129	40481087	1992-12-21	1993-01-11	1
62160	3675	40481087	1998-10-26	1998-11-09	1
86557	5153	40481087	2016-11-02	2016-11-23	1
32331	1923	257012	1940-07-16	1940-07-17	1
25895	1538	40481087	1998-09-07	1998-09-28	1
37287	2210	4294548	1948-03-28	1948-04-04	1
87668	5222	260139	2015-07-21	2015-08-04	1
39279	2333	260139	1953-09-18	1953-09-25	1
82118	4874	260139	1976-12-12	1976-12-26	1
27063	1602	40481087	1987-11-29	1987-12-20	1
79261	4700	260139	2015-03-13	2015-03-20	1
80169	4756	40481087	1973-06-23	1973-07-14	1
3764	217	40481087	1990-02-15	1990-03-08	1
80879	4802	4294548	1968-08-02	1968-10-31	1
32052	1905	4112343	2018-06-04	2018-06-13	1
10333	610	4112343	1987-08-22	1987-09-04	1
9289	549	260139	2014-08-31	2014-09-14	1
25821	1535	260139	1998-03-29	1998-04-05	1
80345	4763	4146173	1961-10-14	1961-12-13	1
30348	1793	81151	1953-11-10	1953-12-08	1
4362	254	28060	1986-06-08	1986-06-18	1
2526	149	260139	2011-09-15	2011-09-29	1
88397	5259	40481087	1977-03-04	1977-03-11	1
37142	2202	4109685	1987-06-30	1987-07-14	1
71340	4238	80180	2005-11-03	2005-11-04	1
33078	1965	192671	2010-05-27	2010-05-28	1
27617	1632	28060	1966-02-18	1966-02-27	1
8195	480	28060	1980-02-29	1980-03-07	1
29887	1770	81151	1992-09-23	1992-10-21	1
83988	4992	260139	2004-05-07	2004-05-21	1
32709	1946	4112343	1974-07-23	1974-08-03	1
32566	1936	80180	1984-11-03	1984-11-04	1
14358	850	40481087	1965-03-20	1965-03-27	1
10473	616	4155034	2004-07-01	2004-07-22	1
8011	469	440086	1944-11-27	1951-04-09	1
25788	1533	260139	1983-10-24	1983-10-31	1
23170	1384	375671	1995-01-14	1995-03-15	1
66382	3934	40481087	1965-09-24	1965-10-08	1
32951	1956	4155034	2002-07-21	2002-08-11	1
33658	1999	4296204	1996-11-12	1996-12-17	1
85188	5073	4112343	1943-02-16	1943-02-24	1
33045	1962	81151	1998-04-06	1998-05-04	1
64535	3820	78272	2013-09-12	2013-10-10	1
27527	1626	321042	2010-10-10	2010-10-11	1
38836	2309	28060	1977-09-07	1977-09-16	1
77163	4576	381316	1984-08-08	1984-08-09	1
23873	1428	4112343	2004-03-23	2004-04-02	1
87571	5215	4112343	1945-08-28	1945-09-05	1
62463	3694	30753	1994-03-26	1994-03-27	1
7301	430	4237458	1938-10-11	1938-12-10	1
36899	2185	40481087	1950-09-19	1950-09-25	1
2226	129	4113008	1989-02-11	1989-03-04	1
62161	3675	40481087	2012-02-26	2012-03-18	1
87415	5207	81151	1980-12-05	1980-12-26	1
32332	1923	372328	1948-09-29	1949-09-02	1
25896	1538	40481087	2008-09-11	2008-09-25	1
37288	2210	40481087	1950-08-28	1950-09-18	1
87669	5222	372328	1920-02-23	1920-06-24	1
39280	2333	313217	1990-04-17	1990-04-18	1
82119	4874	4112343	1981-12-27	1982-01-09	1
27064	1602	81151	2013-04-18	2013-05-23	1
79262	4700	375671	1974-06-11	1974-07-11	1
80170	4756	80180	1985-04-16	1985-04-17	1
3765	217	40481087	1998-10-23	1998-10-30	1
80880	4802	40481087	1972-12-15	1973-01-05	1
32053	1905	40481087	1977-06-29	1977-07-13	1
10334	610	4112343	1991-10-14	1991-10-21	1
9290	549	4116491	1986-07-22	1986-09-14	1
25822	1535	372328	1978-05-03	1978-07-10	1
80346	4763	40481087	1995-06-08	1995-06-29	1
30349	1793	81151	1972-03-03	1972-03-17	1
4363	254	80180	1985-06-05	1985-06-06	1
2527	149	4152936	1958-07-21	1958-08-11	1
88398	5259	40481087	2010-04-30	2010-05-07	1
37143	2202	4283893	1985-11-16	1985-11-30	1
71341	4238	195588	1992-11-16	1993-01-06	1
33079	1965	260139	1982-04-12	1982-04-19	1
27618	1632	80180	1993-01-22	1993-01-23	1
8196	480	260139	1994-11-07	1994-11-14	1
29888	1770	4112343	2017-12-25	2018-01-04	1
83989	4992	4112343	1996-08-19	1996-08-29	1
32710	1946	4113008	1975-01-29	1975-02-19	1
32567	1936	81151	1965-02-03	1965-03-10	1
14359	850	81893	1987-12-05	1987-12-06	1
10474	616	4166224	1962-01-03	1962-01-04	1
8012	469	4027663	1967-11-22	1967-11-23	1
25789	1533	4027663	1998-12-22	1998-12-23	1
23171	1384	4112343	2015-04-23	2015-05-05	1
66383	3934	40481087	1979-05-20	1979-06-10	1
32952	1956	4278672	1972-11-04	1973-02-02	1
33659	1999	260139	1981-03-08	1981-03-22	1
85189	5073	40481087	1951-06-12	1951-07-03	1
33046	1962	4112343	1992-04-13	1992-04-24	1
64536	3820	257012	1979-02-09	1979-02-10	1
27528	1626	378001	1993-06-26	1993-08-25	1
38837	2309	28060	1983-05-19	1983-05-27	1
77164	4576	4112343	1991-11-28	1991-12-05	1
23874	1428	40481087	1982-11-20	1982-11-27	1
87572	5215	4142905	1941-04-08	1941-07-07	1
62464	3694	260139	2017-09-14	2017-09-21	1
7302	430	40481087	1991-05-24	1991-06-07	1
40289	2394	28060	1919-01-23	1919-02-02	1
2227	129	4152936	1983-04-23	1983-05-14	1
62162	3675	4112343	1974-10-24	1974-11-03	1
87416	5207	192671	1995-05-04	1995-05-05	1
32333	1923	378419	2010-05-21	2010-05-22	1
25897	1538	372328	1931-07-10	1931-08-10	1
37289	2210	40481087	1973-05-07	1973-05-14	1
87670	5222	4112343	1979-06-07	1979-06-20	1
39281	2333	372328	1925-11-23	1926-02-09	1
82120	4874	4112343	1995-11-30	1995-12-10	1
27065	1602	260139	1967-10-25	1967-11-08	1
79263	4700	440086	1965-05-18	1967-05-30	1
80171	4756	378001	1999-07-02	1999-08-01	1
3766	217	81151	1993-09-30	1993-10-28	1
80881	4802	40481087	1988-06-17	1988-06-24	1
32054	1905	40481087	1988-08-22	1988-08-29	1
10335	610	4152936	1965-06-29	1965-07-13	1
9291	549	4146173	2008-05-03	2008-07-02	1
25823	1535	4112343	1995-12-16	1995-12-26	1
80347	4763	40481087	2009-01-29	2009-02-12	1
30350	1793	81893	1961-02-26	1961-02-27	1
4364	254	260139	1988-05-28	1988-06-04	1
2528	149	40481087	1955-02-15	1955-03-08	1
88399	5259	40481087	2012-02-01	2012-02-22	1
37144	2202	40481087	1999-11-03	1999-11-10	1
71342	4238	195588	1998-01-05	1998-02-19	1
33080	1965	4112343	1990-04-11	1990-04-23	1
27619	1632	321042	1988-11-13	1988-11-14	1
8197	480	260139	2002-08-20	2002-09-03	1
29889	1770	4283893	2008-11-10	2008-12-15	1
86514	5152	28060	1973-01-22	1973-01-31	1
32711	1946	4146173	2011-12-07	2012-01-06	1
32568	1936	40481087	1960-07-13	1960-07-27	1
14360	850	378001	1961-12-01	1961-12-31	1
10475	616	40481087	1990-09-12	1990-09-19	1
8013	469	4152936	1969-07-04	1969-07-18	1
25790	1533	4112343	2015-07-31	2015-08-13	1
23172	1384	40481087	1983-02-14	1983-02-28	1
66384	3934	0	1957-03-06	1957-03-07	1
32953	1956	80180	2005-07-29	2005-07-30	1
33660	1999	372328	1978-06-20	1978-09-01	1
85190	5073	40481087	1999-05-24	1999-06-14	1
33047	1962	4112343	1993-08-20	1993-08-29	1
64537	3820	260139	1979-09-05	1979-09-19	1
27529	1626	4116491	1993-12-29	1994-02-21	1
38838	2309	78272	1987-03-31	1987-04-28	1
77165	4576	4112343	2013-08-22	2013-09-03	1
23875	1428	81151	1952-09-10	1952-09-30	1
87573	5215	4296205	1978-07-14	1978-08-11	1
62465	3694	372328	1961-06-17	1962-07-03	1
7303	430	40481087	1998-10-04	1998-10-11	1
40290	2394	81151	1912-02-25	1912-03-10	1
2228	129	40481087	2008-05-13	2008-06-03	1
62163	3675	4112343	1988-10-24	1988-11-01	1
87417	5207	260139	2001-07-21	2001-07-28	1
32334	1923	4218389	1953-06-13	1953-07-11	1
25898	1538	4048171	1932-06-08	1932-06-09	1
38025	2260	260139	1952-02-17	1952-02-24	1
87671	5222	81151	2016-05-15	2016-06-12	1
39282	2333	4056621	1962-07-29	1962-07-30	1
82121	4874	40481087	2003-05-09	2003-05-23	1
27066	1602	372328	1975-06-13	1975-12-17	1
79264	4700	4285898	1989-12-28	1989-12-29	1
80172	4756	4112343	1946-10-11	1946-10-22	1
3767	217	260139	1981-05-08	1981-05-22	1
80882	4802	4112343	2009-08-11	2009-08-23	1
34081	2027	28060	1969-01-15	1969-01-25	1
10336	610	4155034	1995-08-24	1995-09-14	1
9292	549	40481087	1999-12-30	2000-01-20	1
25824	1535	4112343	2012-07-06	2012-07-16	1
80348	4763	81151	1987-03-02	1987-04-06	1
30351	1793	257012	1933-09-05	1933-09-06	1
4365	254	381316	2006-05-05	2006-05-06	1
2529	149	80180	1982-10-23	1982-10-24	1
88400	5259	28060	1966-05-20	1966-05-31	1
37145	2202	40481087	2018-05-26	2018-06-02	1
71343	4238	40481087	2011-08-13	2011-09-03	1
33081	1965	4294548	1995-03-11	1995-03-25	1
27620	1632	4296204	1989-11-27	1989-12-18	1
8198	480	4296204	1995-11-21	1995-12-05	1
29890	1770	40481087	1984-02-29	1984-03-14	1
86515	5152	80180	2012-05-13	2012-05-14	1
32712	1946	4230399	1997-05-24	1997-06-23	1
32569	1936	260139	1979-07-11	1979-07-18	1
14361	850	4112343	2000-10-05	2000-10-15	1
10476	616	40481087	2010-08-12	2010-08-26	1
8014	469	4285898	1977-01-03	1977-01-04	1
25791	1533	4294548	2006-12-31	2007-02-11	1
23173	1384	40481087	1999-10-29	1999-11-12	1
66385	3934	28060	1976-11-15	1976-11-26	1
32954	1956	40481087	1985-07-08	1985-07-29	1
33661	1999	40481087	2018-06-23	2018-07-07	1
85191	5073	81151	1946-03-07	1946-04-11	1
33048	1962	4112343	2014-07-11	2014-07-24	1
64538	3820	260139	2015-12-11	2015-12-18	1
27530	1626	4218389	1977-07-22	1977-08-19	1
38839	2309	78272	2005-07-22	2005-08-12	1
77166	4576	4152936	1981-11-02	1981-11-16	1
23876	1428	260139	1979-11-17	1979-12-01	1
87574	5215	40481087	1997-03-05	1997-03-19	1
62466	3694	440086	1965-04-07	1966-02-09	1
7304	430	255848	2012-10-07	2012-10-08	1
40291	2394	372328	1987-05-27	1987-10-12	1
2229	129	28060	1986-10-07	1986-10-18	1
62164	3675	4112343	2000-03-27	2000-04-08	1
87418	5207	372328	1960-09-05	1960-12-21	1
32335	1923	4283893	1940-05-14	1940-08-06	1
25899	1538	4109685	1993-12-19	1994-01-02	1
38026	2260	260139	1997-05-29	1997-06-12	1
87672	5222	260139	1947-12-21	1948-01-04	1
39283	2333	4112343	1921-12-27	1922-01-05	1
82122	4874	257012	1980-10-11	1980-11-01	1
27067	1602	4059173	2001-06-20	2001-07-20	1
79265	4700	381316	1973-03-13	1973-03-14	1
80173	4756	4156265	1997-10-26	1997-11-09	1
3768	217	260139	2010-09-16	2010-09-30	1
80883	4802	40481087	1973-08-09	1973-08-30	1
34082	2027	80180	2002-03-27	2002-03-28	1
10337	610	4278672	2008-12-04	2009-02-02	1
9293	549	28060	1958-09-01	1958-09-12	1
25825	1535	4112343	2015-12-16	2015-12-28	1
80349	4763	4112343	1953-04-20	1953-04-27	1
30352	1793	260139	1934-04-14	1934-04-28	1
4366	254	4155034	1992-12-10	1992-12-31	1
2530	149	260139	1947-01-21	1947-01-28	1
88401	5259	81151	1972-10-13	1972-11-03	1
39904	2367	28060	2018-06-26	2018-07-08	1
71344	4238	40481087	2018-10-04	2018-10-18	1
33082	1965	40481087	2006-08-02	2006-08-23	1
27621	1632	40481087	1965-02-10	1965-02-24	1
8199	480	28060	1939-11-08	1939-11-17	1
29891	1770	40481087	1998-01-29	1998-02-19	1
86516	5152	4112343	2001-10-25	2001-11-01	1
32713	1946	4283893	1981-08-26	1981-11-25	1
32570	1936	372328	1950-05-06	1950-07-28	1
14362	850	4152936	1978-04-06	1978-04-20	1
10477	616	80180	2000-12-08	2000-12-09	1
8015	469	40481087	1999-04-13	1999-04-20	1
25792	1533	4296205	2009-03-09	2009-04-13	1
23644	1412	28060	1969-02-02	1969-02-10	1
66386	3934	80180	1972-09-23	1972-09-24	1
32955	1956	4112343	1995-07-06	1995-07-15	1
34774	2069	260139	1963-06-22	1963-07-06	1
85192	5073	260139	1963-09-15	1963-09-22	1
33049	1962	4113008	1967-01-23	1967-02-06	1
64539	3820	378001	1986-02-03	1986-03-05	1
27531	1626	40481087	1968-04-18	1968-05-02	1
38840	2309	4112343	1999-04-04	1999-04-16	1
77167	4576	40481087	1959-05-11	1959-05-18	1
23877	1428	378001	1945-09-17	1945-11-15	1
88968	5299	372328	1973-10-30	1973-11-13	1
62467	3694	4029498	1969-04-06	1969-04-07	1
7305	430	260139	1940-11-30	1940-12-14	1
40292	2394	4059173	1988-01-06	1988-03-06	1
2230	129	372328	1975-08-03	1975-09-15	1
62165	3675	4112343	2017-12-03	2017-12-16	1
87419	5207	4112343	1990-03-07	1990-03-16	1
32336	1923	40481087	1945-11-14	1945-11-21	1
25900	1538	4112343	1965-09-26	1965-10-05	1
38027	2260	4112343	1975-11-14	1975-11-26	1
87673	5222	260139	1973-07-09	1973-07-16	1
39284	2333	4112343	1945-01-18	1945-01-26	1
82123	4874	260139	1972-09-20	1972-10-04	1
27068	1602	4109685	2000-08-10	2000-08-24	1
79266	4700	4112343	1959-01-09	1959-01-22	1
80174	4756	4156265	2010-12-01	2010-12-15	1
3769	217	4112343	1979-05-18	1979-05-27	1
80884	4802	40481087	1974-10-01	1974-10-22	1
34083	2027	260139	1961-08-15	1961-08-22	1
10338	610	40481087	1963-08-04	1963-08-25	1
9294	549	81151	1977-03-12	1977-04-16	1
25826	1535	4230399	2008-02-16	2008-05-16	1
80350	4763	4112343	1962-12-18	1962-12-31	1
30353	1793	260139	1947-02-16	1947-03-02	1
4367	254	40481087	1999-12-27	2000-01-10	1
2531	149	4112343	2016-12-02	2016-12-15	1
88402	5259	260139	1987-09-05	1987-09-12	1
39905	2367	78272	1990-01-06	1990-01-27	1
71345	4238	260139	1962-04-29	1962-05-06	1
33083	1965	28060	1974-05-26	1974-06-02	1
27622	1632	81151	1976-10-09	1976-11-05	1
8200	480	28060	2000-02-04	2000-02-13	1
29892	1770	40481087	2000-05-30	2000-06-13	1
86517	5152	40481087	1994-01-26	1994-02-09	1
32714	1946	40481087	1992-01-09	1992-01-30	1
32571	1936	439777	2007-02-06	2007-02-07	1
14363	850	4285898	1989-08-26	1989-08-27	1
10478	616	4059173	1959-11-29	1960-02-27	1
8016	469	40481087	2006-05-31	2006-06-21	1
25793	1533	40481087	1991-02-16	1991-03-02	1
23645	1412	80180	1997-05-24	1997-05-25	1
66387	3934	260139	1952-03-26	1952-04-09	1
32956	1956	40481087	2016-09-23	2016-10-14	1
34775	2069	260139	1997-01-28	1997-02-11	1
85193	5073	378419	2007-08-18	2007-08-19	1
33050	1962	4156265	1987-02-05	1987-02-19	1
64540	3820	40481087	1979-06-29	1979-07-13	1
27532	1626	40481087	1973-01-14	1973-01-28	1
38841	2309	4230399	1986-02-04	1986-04-05	1
77168	4576	40481087	1992-06-17	1992-06-24	1
23878	1428	4278672	1998-06-05	1998-08-04	1
88969	5299	372328	1974-09-09	1974-11-17	1
62468	3694	4152936	1984-02-22	1984-03-14	1
7306	430	4112343	1992-11-08	1992-11-17	1
40293	2394	4112343	1973-06-18	1973-06-27	1
2231	129	4112343	1993-08-01	1993-08-09	1
62166	3675	4283893	1978-03-14	1978-07-18	1
87420	5207	4218389	1969-03-03	1969-04-07	1
32337	1923	40481087	1980-11-01	1980-11-22	1
25901	1538	4112343	2004-07-09	2004-07-20	1
38028	2260	378001	2002-09-20	2002-10-20	1
87674	5222	260139	1983-10-13	1983-10-27	1
39285	2333	4112343	2007-02-02	2007-02-13	1
82124	4874	40481087	2016-07-19	2016-08-02	1
27069	1602	4112343	1971-11-19	1971-11-27	1
79267	4700	4156265	1952-03-17	1952-04-07	1
80175	4756	40481087	1962-07-25	1962-08-15	1
3770	217	4112343	2011-01-04	2011-01-15	1
80885	4802	257012	1968-08-23	1968-08-24	1
34084	2027	4296205	1968-02-09	1968-03-15	1
10339	610	40481087	2011-02-04	2011-02-11	1
9295	549	195588	1989-09-13	1989-10-26	1
25827	1535	40481087	1981-11-03	1981-11-10	1
80351	4763	4112343	2005-02-12	2005-02-24	1
30354	1793	260139	2002-10-14	2002-10-28	1
4368	254	40481087	2003-05-01	2003-05-15	1
2532	149	40481087	1985-09-03	1985-09-17	1
88403	5259	372328	1959-02-24	1959-04-06	1
39906	2367	80180	2016-04-06	2016-04-07	1
71346	4238	260139	1973-12-05	1973-12-19	1
33084	1965	80180	2010-04-09	2010-04-10	1
27623	1632	257012	1983-05-18	1983-05-19	1
8201	480	80180	1983-06-22	1983-06-23	1
29893	1770	40481087	2006-09-07	2006-09-14	1
86518	5152	40481087	1973-03-28	1973-04-11	1
32715	1946	257012	1981-10-28	1981-10-29	1
32572	1936	4112343	1960-01-12	1960-01-21	1
14364	850	372328	1949-03-09	1949-07-26	1
10479	616	4296204	1983-03-03	1983-03-24	1
13972	826	195588	1998-07-07	1998-08-14	1
25794	1533	30753	2009-04-13	2009-04-14	1
23646	1412	195588	2007-05-02	2007-06-16	1
66388	3934	4218389	1981-08-07	1981-08-28	1
33683	2002	260139	2002-08-02	2002-08-09	1
34776	2069	4112343	1959-04-09	1959-04-18	1
85194	5073	4283893	1977-10-04	1977-12-06	1
33837	2012	260139	2014-02-23	2014-03-02	1
64541	3820	40481087	1995-02-27	1995-03-06	1
27533	1626	40481087	1982-05-02	1982-05-23	1
38842	2309	40481087	1998-10-20	1998-11-03	1
77169	4576	80180	1993-03-31	1993-04-01	1
23879	1428	4283893	1980-06-02	1980-06-30	1
88970	5299	4283893	1978-06-11	1978-07-02	1
62469	3694	40481087	1993-03-26	1993-04-16	1
7307	430	4146173	1964-10-24	1964-12-23	1
40294	2394	40481087	1953-09-14	1953-10-05	1
2232	129	4112343	2002-09-07	2002-09-14	1
62167	3675	40481087	2014-06-24	2014-07-15	1
87421	5207	40481087	1991-01-03	1991-01-24	1
32338	1923	28060	1946-08-09	1946-08-16	1
25902	1538	4113008	1960-08-23	1960-09-13	1
38029	2260	4283893	1984-05-22	1984-11-13	1
87675	5222	4112343	1962-05-09	1962-05-22	1
39286	2333	4283893	1987-09-09	1987-09-30	1
82125	4874	40481087	1975-03-09	1975-03-23	1
27070	1602	80180	2001-11-23	2001-11-24	1
79268	4700	4310024	1987-12-09	1987-12-10	1
80176	4756	40481087	1987-10-02	1987-10-09	1
3771	217	40481087	1997-12-30	1998-01-20	1
80886	4802	260139	1968-11-21	1968-12-05	1
34085	2027	40481087	2001-06-23	2001-06-30	1
10340	610	80180	2004-12-07	2004-12-08	1
9296	549	257012	1954-08-30	1954-08-31	1
30570	1808	78272	2018-07-29	2018-08-19	1
80352	4763	4237458	1966-08-19	1966-09-18	1
30355	1793	372328	1942-01-28	1943-09-15	1
4369	254	375671	1965-03-07	1965-05-06	1
2533	149	0	1948-08-17	1948-08-18	1
88404	5259	4156265	2012-03-06	2012-03-27	1
39907	2367	260139	1999-09-04	1999-09-18	1
71347	4238	321042	1978-12-28	1978-12-29	1
33085	1965	260139	1988-06-11	1988-06-25	1
27624	1632	260139	2004-01-07	2004-01-21	1
8202	480	81151	1960-07-08	1960-07-22	1
29894	1770	28060	1996-01-21	1996-01-28	1
86519	5152	28060	1976-08-14	1976-08-23	1
32716	1946	260139	2017-10-20	2017-10-27	1
32573	1936	40481087	1953-11-21	1953-12-12	1
14365	850	4112343	1955-09-06	1955-09-17	1
10480	616	40481087	1965-03-11	1965-03-25	1
13973	826	260139	1993-03-16	1993-03-30	1
25795	1533	4112343	1974-01-13	1974-01-26	1
23647	1412	260139	1975-11-27	1975-12-11	1
66389	3934	4283893	1988-02-01	1988-03-07	1
33684	2002	372328	2007-10-21	2008-08-14	1
34777	2069	4218389	1967-02-28	1967-03-21	1
85195	5073	40481087	1978-07-13	1978-08-03	1
33838	2012	372328	1959-12-18	1960-01-08	1
64542	3820	81151	1989-08-16	1989-09-20	1
27534	1626	40481087	1986-10-30	1986-11-20	1
38843	2309	40481087	2000-10-31	2000-11-14	1
77170	4576	260139	1955-10-23	1955-10-30	1
23880	1428	40481087	1977-03-07	1977-03-21	1
88971	5299	0	1998-06-06	1998-06-07	1
62470	3694	40481087	1995-10-08	1995-10-22	1
7308	430	40481087	1937-03-27	1937-04-17	1
40295	2394	40481087	1954-04-09	1954-04-16	1
2233	129	4112343	2010-08-14	2010-08-27	1
62168	3675	40481087	2019-02-27	2019-03-13	1
87422	5207	81893	1994-01-26	1994-01-27	1
32339	1923	80502	1993-02-12	1993-02-13	1
25903	1538	40481087	1932-06-26	1932-07-03	1
38030	2260	40481087	1944-07-31	1944-08-14	1
87676	5222	4112343	1997-05-18	1997-05-30	1
39287	2333	4294548	1926-10-07	1927-03-17	1
82126	4874	40481087	2010-09-20	2010-10-11	1
27071	1602	81151	1967-05-26	1967-06-30	1
79269	4700	40481087	2010-01-21	2010-01-28	1
80177	4756	40481087	1996-01-02	1996-01-09	1
3772	217	4112343	1980-08-04	1980-08-16	1
80887	4802	4112343	2008-04-08	2008-04-16	1
34086	2027	40481087	2011-09-15	2011-09-29	1
10341	610	257012	1965-08-16	1965-08-17	1
9297	549	260139	1989-05-19	1989-06-02	1
30571	1808	260139	1971-08-03	1971-08-10	1
80353	4763	40481087	1960-07-03	1960-07-17	1
30356	1793	4112343	1999-07-18	1999-07-30	1
4370	254	4112343	1971-07-15	1971-07-23	1
2534	149	28060	1943-11-08	1943-11-21	1
88405	5259	40481087	1992-09-18	1992-09-25	1
39908	2367	260139	2003-04-01	2003-04-08	1
71348	4238	372328	1963-04-23	1963-08-08	1
33086	1965	372328	1976-01-13	1976-07-04	1
27625	1632	372328	1955-04-23	1955-06-27	1
8203	480	260139	1941-11-25	1941-12-02	1
29895	1770	260139	1995-01-04	1995-01-18	1
86520	5152	260139	2013-06-19	2013-06-26	1
32717	1946	4112343	1960-06-22	1960-07-04	1
32574	1936	40481087	2012-04-24	2012-05-08	1
14366	850	4112343	2018-03-05	2018-03-12	1
10481	616	40481087	1997-09-18	1997-10-02	1
13974	826	375671	1998-03-19	1998-05-18	1
25796	1533	4310024	2008-05-18	2008-05-19	1
23648	1412	260139	2006-11-05	2006-11-19	1
66390	3934	4283893	2014-10-17	2015-03-06	1
33685	2002	4112343	1999-04-09	1999-04-18	1
34778	2069	40481087	1955-03-24	1955-04-07	1
85196	5073	255848	2012-06-22	2012-06-23	1
33839	2012	4112343	1987-08-07	1987-08-17	1
64543	3820	4112343	1992-05-21	1992-06-03	1
27535	1626	40481087	1988-05-22	1988-05-29	1
38844	2309	81151	1977-01-08	1977-01-22	1
77171	4576	260139	1988-05-03	1988-05-17	1
23881	1428	40481087	1977-12-25	1978-01-08	1
88972	5299	260139	1979-09-30	1979-10-07	1
62471	3694	81893	1993-10-27	1993-10-28	1
7309	430	40481087	1948-06-27	1948-07-18	1
40296	2394	28060	1978-11-29	1978-12-09	1
2234	129	40481087	1989-10-09	1989-10-30	1
62169	3675	4112343	1968-04-13	1968-04-26	1
87423	5207	260139	1997-09-13	1997-09-27	1
32340	1923	372328	1937-06-23	1937-11-26	1
25904	1538	40481087	1942-01-17	1942-01-31	1
38031	2260	40481087	1976-05-06	1976-05-27	1
87677	5222	4142905	1928-02-06	1928-03-07	1
39288	2333	40481087	1985-08-20	1985-09-10	1
83878	4988	80180	1991-04-27	1991-04-28	1
27072	1602	4112343	1964-05-13	1964-05-25	1
79270	4700	40481087	2016-08-30	2016-09-06	1
80178	4756	260139	1949-05-12	1949-05-26	1
3773	217	4112343	1986-11-14	1986-11-21	1
80888	4802	4113008	2003-12-17	2004-01-07	1
34087	2027	372328	1962-03-12	1962-05-25	1
10342	610	372328	1977-10-10	1977-12-22	1
9298	549	372328	1953-05-26	1953-07-08	1
30572	1808	372328	1979-04-18	1979-09-25	1
87886	5234	0	1977-08-24	1977-08-25	1
30357	1793	4294548	1923-08-12	1923-09-23	1
4371	254	4146173	1981-01-12	1981-02-11	1
2535	149	40481087	2004-10-13	2004-10-27	1
1	1	81151	1970-12-03	1970-12-31	1
39909	2367	372328	1975-04-27	1975-07-08	1
71349	4238	378001	2012-04-24	2012-06-23	1
33087	1965	440086	1987-01-25	1987-03-29	1
27626	1632	4112343	1969-11-12	1969-11-20	1
8204	480	260139	1958-10-13	1958-10-20	1
29896	1770	372328	1983-03-17	1984-03-25	1
86521	5152	378001	2013-04-14	2013-06-13	1
32718	1946	4112343	1963-10-18	1963-10-25	1
32575	1936	78272	1980-06-19	1980-07-03	1
14367	850	4310024	1987-08-07	1987-08-08	1
10482	616	40481087	2019-04-20	2019-05-11	1
13975	826	4112343	2006-04-05	2006-04-14	1
25797	1533	260139	2016-09-27	2016-10-06	1
23649	1412	4112343	1995-07-20	1995-07-29	1
66391	3934	40481087	1972-04-12	1972-04-19	1
33686	2002	4112343	2001-03-12	2001-03-22	1
34779	2069	28060	1959-02-24	1959-03-09	1
85197	5073	260139	1970-03-08	1970-03-15	1
33840	2012	4149245	1978-02-25	1978-05-03	1
64544	3820	40481087	2007-10-21	2007-11-04	1
28977	1718	28060	1982-11-23	1982-12-05	1
38845	2309	260139	1999-03-15	1999-03-29	1
77172	4576	4112343	1986-01-12	1986-01-24	1
23882	1428	40481087	1996-05-08	1996-05-22	1
88973	5299	260139	2000-04-20	2000-05-04	1
62472	3694	260139	2019-01-24	2019-02-07	1
7310	430	40481087	1960-03-07	1960-03-21	1
40297	2394	80180	1953-02-04	1953-02-05	1
2235	129	80180	2014-03-21	2014-03-22	1
62170	3675	4112343	2001-07-05	2001-07-18	1
87424	5207	372328	1957-12-31	1958-06-18	1
32341	1923	378001	1972-10-29	1972-11-28	1
25905	1538	40481087	1948-09-21	1948-10-05	1
38032	2260	40481087	1986-05-15	1986-05-29	1
87678	5222	40481087	1923-05-25	1923-06-15	1
39289	2333	80502	2000-06-13	2000-06-14	1
83879	4988	28060	2006-12-10	2006-12-17	1
27073	1602	4112343	2006-08-07	2006-08-15	1
79271	4700	80180	1990-10-24	1990-10-25	1
80179	4756	260139	1952-03-19	1952-03-26	1
3774	217	4112343	1997-08-29	1997-09-10	1
80889	4802	40481087	2016-11-02	2016-11-15	1
34088	2027	4027663	1995-03-09	1995-03-10	1
10343	610	4112343	2013-01-13	2013-01-24	1
9299	549	4112343	1985-12-22	1985-12-31	1
30573	1808	40481087	1981-06-27	1981-07-04	1
87887	5234	260139	1949-02-28	1949-03-14	1
30358	1793	40481087	1964-06-05	1964-06-12	1
4372	254	40481087	1988-07-26	1988-08-09	1
2536	149	28060	1971-07-10	1971-07-17	1
2	1	317576	2006-03-09	2006-03-10	1
39910	2367	4112343	2013-05-11	2013-05-21	1
71350	4238	4056621	1992-11-16	1992-11-17	1
33088	1965	4112343	2009-06-16	2009-06-24	1
27627	1632	4146173	1972-12-28	1973-01-27	1
8205	480	260139	1995-02-13	1995-02-27	1
29897	1770	4112343	2017-03-21	2017-03-28	1
86522	5152	4112343	1988-02-23	1988-03-04	1
32719	1946	4112343	1969-06-26	1969-07-04	1
32576	1936	81151	1949-10-08	1949-11-05	1
14368	850	40481087	1968-12-15	1968-12-22	1
10852	644	80180	2013-05-30	2013-05-31	1
13976	826	4156265	2014-10-21	2014-11-04	1
25798	1533	4155034	2017-08-29	2017-09-19	1
23650	1412	40481087	1966-03-07	1966-03-28	1
66392	3934	4112343	1972-09-22	1972-10-05	1
33687	2002	4112343	2008-09-12	2008-09-25	1
34780	2069	28060	1965-09-18	1965-09-30	1
85198	5073	40481087	1949-08-02	1949-08-16	1
33841	2012	4283893	2017-04-19	2017-05-24	1
66050	3913	80180	2001-07-05	2001-07-06	1
28978	1718	80180	2010-07-28	2010-07-29	1
38846	2309	4149245	2018-01-06	2018-03-14	1
77173	4576	4237458	1962-02-15	1962-04-16	1
23883	1428	81151	1995-08-22	1995-09-19	1
88974	5299	378001	2013-10-14	2013-12-13	1
62473	3694	4112343	1996-04-14	1996-04-21	1
7311	430	40481087	2008-10-12	2008-10-26	1
40298	2394	260139	1914-08-14	1914-08-28	1
2236	129	40481087	1984-02-24	1984-03-02	1
62171	3675	4112343	2012-07-22	2012-07-30	1
87425	5207	40481087	1959-01-01	1959-01-08	1
32342	1923	378001	2012-09-29	2012-11-28	1
25906	1538	40481087	1952-06-25	1952-07-02	1
38033	2260	80502	2012-09-30	2012-10-01	1
87679	5222	40481087	1937-01-24	1937-02-07	1
39290	2333	81151	1948-02-17	1948-03-16	1
83880	4988	260139	1988-03-28	1988-04-11	1
27074	1602	4134304	1972-03-19	1972-04-18	1
79272	4700	260139	1963-03-21	1963-04-04	1
80180	4756	260139	1953-06-21	1953-06-28	1
3775	217	4112343	2017-10-24	2017-11-05	1
82187	4881	28060	1992-03-16	1992-03-29	1
34089	2027	4112343	1963-10-04	1963-10-11	1
10344	610	4116491	2013-08-17	2013-09-22	1
9300	549	4112343	2010-05-09	2010-05-19	1
30574	1808	78272	1969-12-26	1970-01-16	1
87888	5234	372328	1937-09-27	1937-11-10	1
30359	1793	40481087	1991-01-05	1991-01-12	1
4373	254	40481087	1993-07-12	1993-07-26	1
2537	149	260139	1960-02-21	1960-03-06	1
3	1	372328	1980-03-15	1983-02-03	1
39911	2367	40481087	1998-01-31	1998-02-14	1
71351	4238	4109685	1998-10-21	1998-11-04	1
33089	1965	40481087	1998-10-14	1998-11-04	1
27628	1632	4294548	1993-12-07	1993-12-21	1
8206	480	260139	2004-04-11	2004-04-25	1
29898	1770	4116491	2010-06-03	2010-07-18	1
86523	5152	40481087	2006-08-12	2006-08-19	1
32720	1946	4294548	1960-01-06	1960-01-13	1
32577	1936	260139	1962-12-31	1963-01-07	1
14369	850	40481087	2010-12-18	2011-01-08	1
10853	644	260139	2015-10-11	2015-10-25	1
13977	826	4283893	2015-02-06	2015-04-17	1
25799	1533	40481087	1984-05-27	1984-06-17	1
23651	1412	260139	1979-08-23	1979-08-30	1
66393	3934	4113008	1941-10-01	1941-10-22	1
33688	2002	4218389	2019-02-14	2019-03-14	1
34781	2069	80180	1988-09-01	1988-09-02	1
85199	5073	40481087	1956-02-15	1956-02-22	1
33842	2012	40481087	2017-08-30	2017-09-06	1
66051	3913	134438	1981-10-20	1982-11-17	1
28979	1718	260139	1980-03-09	1980-03-23	1
38847	2309	4278672	2013-11-28	2013-12-28	1
77174	4576	40481087	1991-06-04	1991-06-18	1
23884	1428	372328	1950-04-23	1950-08-09	1
88975	5299	4152936	1994-09-10	1994-09-24	1
62788	3714	78272	1940-03-05	1940-03-26	1
7312	430	81151	1973-03-11	1973-04-15	1
40299	2394	372328	1912-09-22	1912-10-06	1
2237	129	40481087	1996-06-02	1996-06-09	1
62172	3675	4156265	1990-08-14	1990-09-04	1
87426	5207	80180	1995-03-22	1995-03-23	1
32343	1923	4112343	1970-10-22	1970-10-30	1
25907	1538	40481087	1991-03-06	1991-03-13	1
38034	2260	257012	1984-11-06	1984-11-07	1
87680	5222	40481087	1995-04-28	1995-05-05	1
39291	2333	81151	2001-07-21	2001-08-25	1
83881	4988	4112343	2012-04-22	2012-04-29	1
27075	1602	4156265	1995-09-15	1995-10-06	1
79273	4700	4027663	1980-05-14	1980-05-15	1
80181	4756	378419	2018-12-01	2018-12-02	1
3776	217	4218389	2013-06-15	2013-07-13	1
82188	4881	81151	1967-09-28	1967-11-02	1
34090	2027	4112343	2005-12-29	2006-01-11	1
10345	610	4155034	1989-12-02	1989-12-23	1
9301	549	4283893	1954-07-26	1955-06-13	1
30575	1808	260139	2014-04-27	2014-05-04	1
87889	5234	440448	1977-08-24	1977-08-25	1
30360	1793	40481087	2001-04-08	2001-04-22	1
5880	347	4112343	2015-03-03	2015-03-15	1
2538	149	260139	1975-05-25	1975-06-01	1
4	1	4278672	1958-03-11	1958-06-09	1
39912	2367	257012	2013-10-04	2013-10-05	1
71352	4238	4112343	1967-01-03	1967-01-10	1
36575	2167	260139	1993-07-26	1993-08-09	1
27629	1632	40481087	1999-07-29	1999-08-05	1
8207	480	317576	2016-10-05	2016-10-06	1
29899	1770	4294548	1996-07-15	1996-07-29	1
86524	5152	81151	2015-07-03	2015-07-24	1
32721	1946	40481087	1942-01-08	1942-01-15	1
32578	1936	4112343	1953-07-04	1953-07-13	1
14370	850	40481087	2013-05-02	2013-05-09	1
10854	644	4112343	2011-09-20	2011-09-28	1
13978	826	40481087	1989-11-02	1989-11-16	1
25800	1533	40481087	2003-07-01	2003-07-15	1
23652	1412	260139	2002-02-25	2002-03-04	1
66394	3934	4296204	1967-06-08	1967-06-22	1
33689	2002	4278672	1986-05-24	1986-07-23	1
34782	2069	81151	2011-04-30	2011-06-04	1
85200	5073	40481087	1959-01-13	1959-01-27	1
33843	2012	372328	1971-05-10	1971-07-16	1
66052	3913	378001	2007-07-08	2007-08-07	1
28980	1718	260139	2011-10-14	2011-10-28	1
38848	2309	40481087	1986-10-25	1986-11-01	1
78541	4656	317576	1959-09-20	1959-09-21	1
23885	1428	4112343	1972-10-27	1972-11-05	1
88976	5299	78272	2018-12-17	2019-01-07	1
62789	3714	80180	1958-07-28	1958-07-29	1
7313	430	260139	1949-12-15	1949-12-29	1
40300	2394	4112343	1962-11-17	1962-11-24	1
4952	292	4112343	1984-08-28	1984-09-08	1
62173	3675	4237458	1968-04-11	1968-06-10	1
87427	5207	4112343	1977-04-30	1977-05-11	1
32344	1923	4112343	2007-08-12	2007-08-24	1
31511	1867	28060	1972-11-20	1972-12-03	1
38035	2260	4112343	1976-03-28	1976-04-08	1
87681	5222	40481087	2009-10-26	2009-11-09	1
39292	2333	195588	1962-07-29	1962-08-31	1
83882	4988	4116491	1983-04-14	1983-06-03	1
27076	1602	40481087	1980-10-23	1980-10-30	1
79274	4700	4112343	1955-08-31	1955-09-12	1
80182	4756	4112343	1944-07-09	1944-07-19	1
3777	217	40481087	1982-05-28	1982-06-18	1
82189	4881	40481087	2003-01-03	2003-01-17	1
34091	2027	4112343	2013-05-08	2013-05-17	1
10346	610	4218389	1973-11-28	1973-12-26	1
9302	549	40481087	1996-10-16	1996-11-06	1
30576	1808	372328	1967-01-11	1968-01-16	1
87890	5234	4027663	1970-08-25	1970-08-26	1
30361	1793	40481087	2003-12-17	2004-01-07	1
5881	347	258780	1996-11-03	1996-11-04	1
2539	149	372328	1942-06-15	1942-07-28	1
5	1	40481087	1996-08-25	1996-09-15	1
39913	2367	4296204	1983-03-16	1983-04-13	1
71353	4238	4112343	1993-06-23	1993-07-05	1
36576	2167	4027663	2010-03-07	2010-03-08	1
28330	1676	260139	1983-01-28	1983-02-11	1
8208	480	378001	1968-04-02	1968-06-01	1
29900	1770	40481087	1998-12-21	1998-12-28	1
86525	5152	192671	2012-06-20	2012-06-21	1
32722	1946	40481087	1958-08-31	1958-09-07	1
32579	1936	4116491	1983-02-12	1983-03-20	1
16171	958	257012	2014-07-15	2014-07-16	1
10855	644	4112343	2017-05-30	2017-06-07	1
13979	826	28060	1998-12-30	1999-01-08	1
27536	1627	80180	1987-11-04	1987-11-05	1
23653	1412	372328	1964-09-24	1964-11-14	1
66395	3934	40481087	1946-10-11	1946-11-01	1
33690	2002	4283893	1992-04-24	1992-07-03	1
34783	2069	40481087	1995-03-22	1995-04-06	1
85201	5073	40481087	2010-02-18	2010-02-25	1
33844	2012	4112343	1977-05-20	1977-05-29	1
66053	3913	4112343	2005-03-19	2005-03-29	1
28981	1718	40481087	1973-09-19	1973-10-03	1
40646	2419	28060	1970-08-01	1970-08-09	1
78542	4656	4059173	1966-11-09	1967-01-08	1
23886	1428	4112343	1983-03-16	1983-03-25	1
88977	5299	80180	2007-01-20	2007-01-21	1
62790	3714	192671	1958-09-08	1958-09-09	1
7314	430	260139	2006-02-15	2006-02-22	1
40301	2394	4112343	1964-04-21	1964-05-04	1
4953	292	4112343	2017-10-30	2017-11-06	1
62174	3675	40481087	1987-01-07	1987-01-21	1
87428	5207	40481087	1963-06-22	1963-07-06	1
32345	1923	4156265	1938-10-16	1938-10-30	1
31512	1867	260139	1983-04-28	1983-05-05	1
38036	2260	4112343	1982-02-10	1982-02-19	1
87682	5222	28060	1922-12-21	1922-12-30	1
39293	2333	195588	1967-08-30	1967-10-14	1
83883	4988	4152936	2007-09-13	2007-09-27	1
27077	1602	40481087	1988-11-22	1988-12-13	1
79275	4700	40481087	1979-06-15	1979-06-29	1
80183	4756	4112343	1964-08-01	1964-08-14	1
3778	217	80180	2017-07-11	2017-07-12	1
82190	4881	28060	1957-05-10	1957-05-17	1
34092	2027	40481087	1965-10-27	1965-11-10	1
10347	610	4283893	1965-06-21	1965-09-20	1
11867	703	80180	1989-02-01	1989-02-02	1
30577	1808	4112343	2016-01-19	2016-01-28	1
87891	5234	4112343	1948-01-20	1948-02-02	1
30362	1793	80180	1963-03-18	1963-03-19	1
5882	347	260139	1975-08-21	1975-09-04	1
2540	149	4029498	1948-08-17	1948-08-18	1
6	1	40481087	2018-01-04	2018-01-11	1
39914	2367	40481087	1978-10-17	1978-11-07	1
71354	4238	4116491	1992-08-23	1992-10-12	1
36577	2167	4266809	2017-09-21	2017-09-22	1
28331	1676	4112343	1998-01-10	1998-01-22	1
8209	480	4109685	1961-06-17	1961-07-08	1
29901	1770	40481087	2005-03-19	2005-04-09	1
86526	5152	260139	2002-01-17	2002-01-31	1
32723	1946	40481087	1985-06-14	1985-06-21	1
32580	1936	4155034	1955-08-04	1955-08-25	1
16172	958	4152936	2012-10-04	2012-10-18	1
10856	644	4116491	1997-10-16	1997-11-23	1
13980	826	381316	1988-06-09	1988-06-10	1
27537	1627	260139	1977-01-12	1977-01-27	1
23654	1412	378001	1994-03-01	1994-04-30	1
66396	3934	40481087	1955-08-25	1955-09-08	1
33691	2002	40481087	2015-11-15	2015-11-29	1
34784	2069	372328	1952-06-17	1952-09-28	1
85202	5073	0	1947-04-11	1947-04-12	1
33845	2012	4156265	2006-06-05	2006-06-26	1
66054	3913	4283893	1966-10-05	1967-04-12	1
28982	1718	40481087	1999-12-04	1999-12-18	1
40647	2419	260139	1972-11-19	1972-12-03	1
78543	4656	4112343	1996-12-17	1996-12-28	1
23887	1428	4218389	1958-09-30	1958-11-03	1
88978	5299	375671	2016-10-28	2016-11-27	1
62791	3714	257012	1936-04-10	1936-04-11	1
7315	430	372328	1931-09-18	1931-11-28	1
40302	2394	4142905	1979-10-20	1979-12-19	1
4954	292	40481087	2004-10-02	2004-10-16	1
62175	3675	40481087	2000-09-05	2000-09-19	1
87429	5207	40481087	1979-01-20	1979-01-27	1
32346	1923	40481087	1967-10-15	1967-11-05	1
31513	1867	372328	1973-03-19	1973-05-29	1
38037	2260	4112343	1992-08-28	1992-09-10	1
87683	5222	81151	1937-06-18	1937-07-09	1
39294	2333	260139	1941-12-17	1941-12-31	1
83884	4988	40481087	1964-12-09	1964-12-23	1
29571	1752	378001	1992-01-11	1992-02-10	1
79276	4700	40481087	1987-10-23	1987-11-13	1
80184	4756	4112343	2003-12-02	2003-12-13	1
3779	217	260139	1997-09-04	1997-09-11	1
82191	4881	28060	2018-03-14	2018-03-24	1
34093	2027	40481087	1974-10-01	1974-10-22	1
10348	610	40481087	1967-08-19	1967-09-02	1
11868	703	260139	1976-04-06	1976-04-13	1
30578	1808	4218389	1997-11-18	1997-12-16	1
87892	5234	4112343	1965-09-15	1965-09-25	1
30363	1793	260139	1932-07-29	1932-08-12	1
5883	347	4112343	1998-12-27	1999-01-08	1
2541	149	4112343	1960-05-28	1960-06-04	1
7	1	260139	1976-10-20	1976-11-03	1
39915	2367	375671	1978-06-10	1978-08-09	1
71355	4238	40481087	2007-07-09	2007-07-30	1
36578	2167	4285898	2017-03-25	2017-03-26	1
28332	1676	4237458	1999-06-02	1999-07-02	1
8210	480	4112343	1945-06-20	1945-07-01	1
33729	2005	80180	2010-01-14	2010-01-15	1
86527	5152	4109685	2002-09-18	2002-10-09	1
32724	1946	40481087	2006-11-11	2006-12-02	1
32581	1936	4230399	2009-07-31	2009-08-30	1
16173	958	40481087	1968-11-11	1968-12-02	1
10857	644	40481087	1988-01-05	1988-01-12	1
13981	826	4112343	2019-01-07	2019-01-18	1
27538	1627	260139	1995-10-05	1995-10-12	1
23655	1412	4051466	1963-05-20	1980-08-21	1
66397	3934	257012	1952-01-31	1988-03-07	1
33692	2002	81151	1976-04-06	1976-05-04	1
34785	2069	4112343	1991-01-27	1991-02-05	1
85203	5073	28060	1959-09-29	1959-10-09	1
33846	2012	40481087	1973-04-12	1973-04-26	1
66055	3913	40481087	1989-12-30	1990-01-20	1
28983	1718	372328	1980-07-26	1981-03-21	1
40648	2419	260139	1985-06-09	1985-06-16	1
78544	4656	4296204	1950-10-06	1950-11-03	1
25208	1506	28060	1975-12-30	1976-01-10	1
88979	5299	380378	2011-09-18	2011-09-19	1
62792	3714	260139	1924-06-07	1924-06-14	1
7316	430	4237458	1941-10-25	1941-11-24	1
40303	2394	260139	1956-04-19	1956-04-26	1
4955	292	40481087	2006-07-17	2006-07-24	1
62176	3675	40481087	2012-11-18	2012-11-25	1
87430	5207	40481087	2011-03-19	2011-03-26	1
32347	1923	40481087	2004-06-25	2004-07-09	1
31514	1867	372328	1977-01-13	1977-03-01	1
38038	2260	4155034	2009-04-16	2009-05-07	1
87684	5222	261325	1998-01-08	1998-01-09	1
39295	2333	372328	1922-12-18	1923-05-08	1
83885	4988	40481087	1996-07-25	1996-08-08	1
29572	1752	4112343	2001-07-06	2001-07-19	1
79277	4700	372328	1953-01-11	1953-04-28	1
80185	4756	40481087	1976-12-31	1977-01-21	1
3780	217	372328	1979-08-15	1980-03-18	1
82192	4881	78272	1984-11-09	1984-12-07	1
34094	2027	40481087	1985-07-21	1985-08-11	1
11075	654	80180	2001-07-26	2001-07-27	1
11869	703	313217	2006-01-27	2006-01-28	1
30579	1808	40481087	1993-08-05	1993-08-12	1
87893	5234	4112343	1988-08-28	1988-09-04	1
30364	1793	260139	1978-07-01	1978-07-08	1
5884	347	4218389	2015-07-20	2015-08-17	1
2542	149	4112343	2005-06-20	2005-07-01	1
8	1	4027663	1975-01-21	1975-01-22	1
39916	2367	4283893	2013-08-30	2013-10-11	1
71356	4238	78272	1969-12-17	1970-01-21	1
36579	2167	40481087	1984-03-19	1984-03-26	1
28333	1676	40481087	1990-02-17	1990-03-03	1
8211	480	4112343	1998-01-04	1998-01-12	1
33730	2005	372328	1976-09-07	1977-01-15	1
86528	5152	4218389	1987-12-31	1988-02-04	1
32725	1946	28060	1936-09-13	1936-09-25	1
32582	1936	40481087	1988-04-07	1988-04-21	1
16174	958	40481087	1989-03-22	1989-04-05	1
10858	644	40481087	1988-08-17	1988-08-24	1
13982	826	40481087	1958-09-24	1958-10-08	1
27539	1627	372328	1972-03-12	1975-02-22	1
23656	1412	4109685	1970-06-25	1970-07-09	1
66398	3934	321042	1957-03-06	1957-03-07	1
33693	2002	81151	1982-07-02	1982-08-06	1
34786	2069	4237458	1955-05-03	1955-06-02	1
85204	5073	313217	2001-07-14	2001-07-15	1
33847	2012	40481087	2003-03-28	2003-04-11	1
66056	3913	28060	1979-06-24	1979-07-01	1
28984	1718	4112343	2010-09-10	2010-09-22	1
40649	2419	260139	2000-01-30	2000-02-06	1
78545	4656	4329847	2008-06-29	2008-06-30	1
25209	1506	28060	1980-05-02	1980-05-12	1
88980	5299	440086	1980-06-10	1981-03-17	1
62793	3714	260139	1963-03-31	1963-04-14	1
7317	430	40481087	1954-07-22	1954-07-29	1
40304	2394	40481087	1931-01-21	1931-02-04	1
4956	292	80180	2017-01-16	2017-01-17	1
63711	3767	81893	2016-11-29	2016-11-30	1
87431	5207	195588	1980-01-05	1980-03-05	1
32348	1923	40481087	2016-09-02	2016-09-23	1
31515	1867	372328	1978-05-06	1979-03-13	1
38039	2260	4237458	1994-09-02	1994-12-01	1
87685	5222	372328	1919-10-24	1919-12-25	1
39296	2333	378001	1934-01-19	1934-03-20	1
83886	4988	30753	1990-04-02	1990-04-03	1
29573	1752	4283893	2015-01-26	2015-03-02	1
79278	4700	40481087	1962-11-26	1962-12-10	1
80186	4756	40481087	2009-12-30	2010-01-06	1
3781	217	40481087	1994-05-21	1994-06-11	1
82193	4881	80180	1988-11-18	1988-11-19	1
34095	2027	30753	2001-10-28	2001-10-29	1
11076	654	4112343	1979-05-31	1979-06-10	1
11870	703	4027663	1978-12-16	1978-12-17	1
30580	1808	80180	2003-12-18	2003-12-19	1
87894	5234	4155034	1993-08-28	1993-09-11	1
30365	1793	372328	1921-02-26	1921-05-18	1
5885	347	4237458	1982-10-11	1982-11-10	1
2543	149	4146173	1957-04-27	1957-06-26	1
9	1	4112343	2017-05-12	2017-05-20	1
39917	2367	40481087	2009-11-22	2009-12-13	1
71357	4238	4112343	1987-06-11	1987-06-23	1
36580	2167	40481087	2005-09-01	2005-09-15	1
28334	1676	40481087	1985-04-21	1985-05-05	1
8212	480	4112343	2017-06-17	2017-06-26	1
33731	2005	372328	1977-10-12	1978-07-22	1
86529	5152	40481087	1973-06-17	1973-07-08	1
32726	1946	80180	1963-01-06	1963-01-07	1
32583	1936	78272	2010-08-25	2010-09-15	1
16175	958	40481087	1994-02-14	1994-02-21	1
10859	644	40481087	2002-05-14	2002-06-04	1
13983	826	40481087	1990-07-20	1990-08-03	1
27540	1627	4116491	1971-05-27	1971-07-11	1
23657	1412	4112343	1992-04-13	1992-04-22	1
66399	3934	4155034	1991-02-07	1991-02-21	1
33694	2002	260139	1980-05-17	1980-05-31	1
34787	2069	40481087	1952-02-26	1952-03-04	1
85205	5073	372328	1936-01-08	1936-03-21	1
33848	2012	0	1996-01-25	1996-01-26	1
66057	3913	372328	1964-04-10	1964-09-24	1
28985	1718	4152936	2006-02-19	2006-03-12	1
40650	2419	372328	1949-07-26	1949-09-30	1
78546	4656	40481087	1963-03-14	1963-03-21	1
25210	1506	372328	1949-01-30	1949-07-09	1
88981	5299	4029498	1998-06-06	1998-06-07	1
62794	3714	260139	1985-10-03	1985-10-17	1
7318	430	40481087	1964-03-05	1964-03-19	1
40305	2394	255848	1992-02-04	1992-02-05	1
4957	292	40481087	1979-04-05	1979-04-12	1
63712	3767	260139	2000-11-29	2000-12-06	1
87432	5207	260139	1967-01-15	1967-01-22	1
34307	2037	40481087	1962-02-11	1962-02-25	1
31516	1867	4059173	1990-08-17	1990-10-16	1
38040	2260	40481087	2013-03-15	2013-04-05	1
87686	5222	4112343	1937-07-18	1937-07-31	1
39297	2333	378419	2001-06-19	2001-06-20	1
83887	4988	81893	1989-08-05	1989-08-06	1
29574	1752	40481087	1999-06-05	1999-06-12	1
79279	4700	40481087	1972-01-27	1972-02-03	1
80187	4756	192671	1985-04-21	1985-04-22	1
3782	217	40481087	2002-02-16	2002-03-02	1
82194	4881	81151	1952-05-21	1952-06-18	1
34096	2027	260139	2019-01-04	2019-01-18	1
11077	654	40481087	2007-10-16	2007-11-06	1
11871	703	40481087	1964-08-01	1964-08-15	1
30581	1808	81151	1993-12-11	1994-01-08	1
87895	5234	4283893	1960-12-14	1961-02-15	1
30366	1793	381316	2006-08-30	2006-08-31	1
5886	347	40481087	1992-12-24	1993-01-07	1
3938	227	28060	1999-08-07	1999-08-14	1
10	1	4156265	1982-09-11	1982-10-02	1
39918	2367	260139	1978-03-14	1978-03-21	1
71358	4238	4112343	2010-07-25	2010-08-07	1
36581	2167	80180	2017-09-21	2017-09-22	1
28335	1676	80180	2014-10-21	2014-10-22	1
8213	480	40481087	1950-05-01	1950-05-15	1
33732	2005	4155034	2018-03-18	2018-04-08	1
87395	5206	81151	1982-08-16	1982-08-30	1
32727	1946	192671	1963-02-12	1963-02-13	1
32584	1936	260139	1987-02-07	1987-02-14	1
16176	958	260139	1990-01-15	1990-01-22	1
10860	644	260139	1984-09-22	1984-09-29	1
13984	826	40481087	2008-04-26	2008-05-10	1
27541	1627	40481087	2002-10-25	2002-11-08	1
23658	1412	4112343	1994-01-13	1994-01-25	1
66400	3934	4218389	2011-11-03	2011-11-24	1
33695	2002	260139	1996-02-09	1996-02-16	1
34788	2069	40481087	1972-03-14	1972-03-28	1
85206	5073	372328	1937-05-15	1937-09-18	1
33849	2012	80180	1994-04-13	1994-04-14	1
66058	3913	4112343	2006-08-22	2006-08-29	1
28986	1718	40481087	1977-10-21	1977-11-04	1
40651	2419	378001	2018-12-10	2019-01-09	1
78547	4656	40481087	2008-04-20	2008-04-27	1
25211	1506	4112343	1947-09-27	1947-10-10	1
88982	5299	4059173	1988-11-10	1989-01-09	1
62795	3714	4112343	1924-05-09	1924-05-19	1
7319	430	40481087	2001-10-30	2001-11-13	1
40306	2394	372328	1916-11-14	1917-03-05	1
4958	292	40481087	2012-04-29	2012-05-06	1
63713	3767	372328	1988-08-15	1989-01-20	1
87433	5207	260139	2017-02-06	2017-02-20	1
34308	2037	28060	1980-10-01	1980-10-08	1
31517	1867	40481087	2006-02-22	2006-03-15	1
38041	2260	80180	1983-11-19	1983-11-20	1
87687	5222	4112343	1956-05-24	1956-06-06	1
39298	2333	4112343	1954-04-12	1954-04-24	1
83888	4988	4027663	1979-04-15	1979-04-16	1
29575	1752	260139	1993-06-07	1993-06-21	1
79280	4700	40481087	1977-01-12	1977-01-19	1
80188	4756	260139	2003-05-26	2003-06-09	1
4543	266	372328	1967-06-26	1967-07-10	1
82195	4881	372328	1952-09-18	1953-06-21	1
34097	2027	372328	1965-09-06	1965-11-05	1
11078	654	28060	1971-07-31	1971-08-07	1
11872	703	40481087	2018-11-01	2018-11-08	1
30582	1808	260139	1963-03-05	1963-03-12	1
87896	5234	4285898	1978-11-16	1978-11-17	1
30367	1793	4027663	1951-06-04	1951-06-05	1
5887	347	80180	2011-12-28	2011-12-29	1
3939	227	80180	2009-11-01	2009-11-02	1
11	1	4285898	1981-12-15	1981-12-16	1
39919	2367	260139	1986-09-20	1986-10-04	1
71359	4238	4146173	2001-08-20	2001-10-19	1
36582	2167	4112343	1988-03-26	1988-04-07	1
28336	1676	257012	1999-03-03	1999-03-04	1
8214	480	40481087	1958-01-30	1958-02-13	1
33733	2005	40481087	1975-01-08	1975-01-29	1
87396	5206	40481087	1977-01-20	1977-01-27	1
32728	1946	313217	2014-01-04	2014-01-05	1
32585	1936	260139	2013-08-15	2013-08-22	1
16177	958	4112343	1969-05-06	1969-05-15	1
10861	644	4112343	1978-08-08	1978-08-17	1
13985	826	257012	2015-02-20	2015-02-21	1
27542	1627	40481087	2011-10-28	2011-11-18	1
23659	1412	40481087	2015-01-03	2015-01-24	1
66401	3934	4218389	2015-12-03	2015-12-31	1
33696	2002	260139	2010-04-19	2010-04-26	1
34789	2069	40481087	1988-05-31	1988-06-21	1
85207	5073	440448	1947-04-11	1947-04-12	1
33850	2012	81151	1976-02-22	1976-03-07	1
66059	3913	4113008	2017-11-12	2017-11-26	1
28987	1718	40481087	1987-07-21	1987-08-11	1
40652	2419	4112343	1971-07-09	1971-07-21	1
78548	4656	80180	1993-06-12	1993-06-13	1
25212	1506	40479422	1952-08-29	1952-10-05	1
88983	5299	40481087	1986-04-30	1986-05-14	1
62796	3714	4218389	1966-03-27	1966-04-24	1
8049	472	4112343	2014-04-01	2014-04-13	1
40307	2394	378419	1983-09-19	1983-09-20	1
4959	292	375671	1980-01-21	1980-02-20	1
63714	3767	4112343	2019-06-28	2019-06-29	1
87434	5207	4027663	1988-01-03	1988-01-04	1
34309	2037	28060	1982-08-01	1982-08-14	1
31518	1867	81151	2018-06-21	2018-07-26	1
38042	2260	260139	1969-10-15	1969-10-22	1
87688	5222	4112343	2003-02-01	2003-02-14	1
39299	2333	4112343	1966-02-24	1966-03-07	1
83889	4988	4113008	1960-09-11	1960-09-25	1
29576	1752	4112343	2000-05-01	2000-05-11	1
80589	4784	81151	2018-08-28	2018-10-02	1
80189	4756	4112343	1946-12-24	1947-01-02	1
4544	266	4084167	1984-12-25	1984-12-25	1
82196	4881	375671	1980-12-23	1981-02-21	1
34098	2027	4112343	1977-03-18	1977-03-30	1
11079	654	260139	2007-05-22	2007-06-05	1
11873	703	260139	1992-06-19	1992-07-03	1
30583	1808	4112343	1969-06-03	1969-06-10	1
87897	5234	4310024	1978-03-21	1978-03-22	1
30368	1793	4035415	1962-05-25	1962-07-24	1
5888	347	4112343	2002-11-22	2002-12-03	1
3940	227	4112343	2003-07-25	2003-08-01	1
12	1	40481087	1967-05-30	1967-06-20	1
39920	2367	260139	2004-05-04	2004-05-11	1
71360	4238	40479422	2013-06-18	2013-07-25	1
36583	2167	4155034	1993-08-23	1993-09-06	1
28337	1676	4283893	1999-01-20	1999-04-07	1
8215	480	40481087	2003-12-09	2003-12-30	1
33734	2005	40481087	2001-04-12	2001-05-03	1
87397	5206	40481087	2006-12-27	2007-01-17	1
32729	1946	372328	1930-01-04	1930-12-06	1
32586	1936	4218389	1951-09-26	1951-10-24	1
16178	958	4283893	1973-05-10	1973-06-14	1
10862	644	40481087	1979-11-05	1979-11-19	1
13986	826	372328	1963-11-18	1964-07-02	1
27543	1627	4112343	1995-11-15	1995-11-25	1
23660	1412	78272	1981-12-08	1981-12-22	1
66402	3934	40481087	1992-10-18	1992-11-08	1
33697	2002	378001	2002-07-13	2002-08-12	1
34790	2069	40481087	2004-05-24	2004-06-07	1
85208	5073	4112343	1941-01-12	1941-01-24	1
33851	2012	260139	1965-06-02	1965-06-16	1
66060	3913	40481087	1969-04-10	1969-05-01	1
28988	1718	40481087	2005-01-29	2005-02-19	1
40653	2419	4112343	2000-11-02	2000-11-13	1
78549	4656	4112343	1993-06-24	1993-07-05	1
25213	1506	28060	1948-10-22	1948-11-01	1
88984	5299	192671	2007-03-28	2007-03-29	1
62797	3714	4230399	2007-02-18	2007-04-19	1
8050	472	4134304	2003-06-16	2003-08-15	1
40308	2394	4218389	1955-06-23	1955-07-28	1
4960	292	4112343	2015-07-30	2015-08-08	1
63715	3767	80180	2018-10-20	2018-10-21	1
87435	5207	4112343	1971-01-24	1971-01-31	1
34310	2037	80180	2000-05-20	2000-05-21	1
31519	1867	372328	1981-07-30	1982-03-30	1
38043	2260	40481087	2017-09-19	2017-10-03	1
87689	5222	4294548	1933-10-29	1933-11-05	1
39300	2333	40481087	1938-06-16	1938-06-23	1
83890	4988	40481087	1978-11-11	1978-11-18	1
29577	1752	4146173	1993-12-01	1993-12-31	1
80590	4784	260139	1953-10-08	1953-10-15	1
80190	4756	4152936	1991-07-18	1991-08-01	1
4545	266	40481087	2004-02-23	2004-03-15	1
82197	4881	4112343	1957-02-27	1957-03-09	1
34099	2027	4310024	2000-08-04	2000-08-05	1
11080	654	260139	2010-03-03	2010-03-10	1
11874	703	260139	2007-09-08	2007-09-22	1
30584	1808	4112343	1986-10-10	1986-10-22	1
87898	5234	40481087	1954-08-05	1954-08-12	1
30369	1793	4112343	1919-10-06	1919-10-19	1
5889	347	40481087	2000-10-02	2000-10-16	1
3941	227	4112343	2008-10-17	2008-10-28	1
13	1	40481087	2000-10-31	2000-11-07	1
39921	2367	378001	1987-03-23	1987-04-22	1
71361	4238	40481087	1977-04-07	1977-04-28	1
36584	2167	40481087	1984-07-30	1984-08-06	1
30196	1786	260139	1965-06-02	1965-06-16	1
8216	480	81151	1994-11-12	1994-11-26	1
33735	2005	192671	2010-02-12	2010-02-13	1
87398	5206	28060	1981-12-21	1982-01-02	1
32730	1946	381316	1973-10-20	1973-10-21	1
35515	2108	260139	1951-09-26	1951-10-10	1
16179	958	4294548	2014-06-03	2014-08-05	1
10863	644	40481087	2006-01-21	2006-01-28	1
13987	826	4112343	1967-01-04	1967-01-13	1
27544	1627	4112343	2000-06-03	2000-06-15	1
23661	1412	4155034	1987-08-14	1987-09-04	1
66403	3934	40481087	1993-12-10	1993-12-31	1
33698	2002	4285898	2012-07-26	2012-07-27	1
34791	2069	260139	1977-12-26	1978-01-02	1
85209	5073	4112343	1996-04-30	1996-05-09	1
33852	2012	260139	2009-11-21	2009-12-05	1
66061	3913	40481087	1989-05-08	1989-05-29	1
28989	1718	4112343	1972-07-21	1972-08-03	1
40654	2419	4112343	2013-11-05	2013-11-17	1
78550	4656	40481087	1993-02-19	1993-03-05	1
25214	1506	80502	2006-04-01	2006-04-02	1
89314	5317	260139	1976-03-08	1976-03-22	1
62798	3714	40481087	2017-06-28	2017-07-12	1
8051	472	260139	1979-04-10	1979-04-17	1
40309	2394	40481087	1970-10-25	1970-11-01	1
4961	292	40481087	2016-08-22	2016-09-05	1
63716	3767	4027663	2010-02-09	2010-02-10	1
87436	5207	4134304	1960-05-19	1960-08-17	1
34311	2037	4059173	1974-01-30	1974-04-30	1
31520	1867	4112343	1985-01-01	1985-01-11	1
38851	2311	81151	2010-11-03	2010-12-01	1
87690	5222	40481087	1959-12-05	1959-12-26	1
39301	2333	40481087	1957-09-14	1957-09-28	1
83891	4988	40481087	1987-07-21	1987-08-04	1
29578	1752	28060	2009-08-08	2009-08-21	1
80591	4784	4218389	1967-04-02	1967-04-23	1
80191	4756	40481087	2000-10-22	2000-11-12	1
4546	266	40481087	2016-10-08	2016-10-15	1
82198	4881	4218389	1994-04-19	1994-05-17	1
34100	2027	40481087	1977-05-15	1977-05-29	1
11081	654	40481087	1981-03-16	1981-03-23	1
11875	703	260139	2009-05-04	2009-05-18	1
30585	1808	4116491	2001-01-27	2001-03-28	1
87899	5234	40481087	1958-12-28	1959-01-18	1
30370	1793	4285898	1962-06-21	1962-06-22	1
5890	347	40481087	2014-06-14	2014-06-21	1
3942	227	40481087	1972-03-20	1972-03-27	1
14	1	81893	1981-05-19	1981-05-20	1
39922	2367	40481087	1996-09-12	1996-10-03	1
71362	4238	40481087	1981-07-30	1981-08-06	1
36585	2167	192671	2017-10-03	2017-10-04	1
30197	1786	4112343	1989-04-09	1989-04-16	1
8217	480	260139	1944-07-20	1944-07-27	1
33736	2005	260139	1988-07-24	1988-08-07	1
87399	5206	28060	1999-06-23	1999-07-04	1
32731	1946	4109685	1935-02-07	1935-02-28	1
35516	2108	260139	1974-03-09	1974-03-23	1
16180	958	4296205	1979-12-07	1980-01-11	1
10864	644	28060	1987-06-04	1987-06-14	1
13988	826	80180	1991-06-29	1991-06-30	1
27545	1627	4237458	1964-12-24	1965-01-23	1
23662	1412	4294548	1980-07-16	1980-09-03	1
67933	4018	192671	2001-09-09	2001-09-10	1
33699	2002	40481087	2012-10-11	2012-10-25	1
34792	2069	4112343	1958-08-17	1958-08-25	1
85210	5073	4142905	1936-04-07	1936-07-06	1
33853	2012	375671	2004-07-15	2004-08-14	1
66062	3913	260139	1972-01-01	1972-01-15	1
28990	1718	40481087	2018-02-17	2018-02-24	1
40655	2419	4152936	1959-05-10	1959-05-24	1
78551	4656	40481087	2011-05-30	2011-06-06	1
25215	1506	372328	1946-09-30	1947-01-11	1
89315	5317	28060	1983-12-22	1983-12-29	1
62799	3714	78272	1956-06-28	1956-07-19	1
8052	472	4112343	1996-09-20	1996-10-01	1
41751	2486	260139	2007-02-07	2007-02-21	1
4962	292	81151	1988-07-07	1988-08-04	1
63717	3767	4112343	2003-04-09	2003-04-18	1
87437	5207	4285898	1994-07-25	1994-07-26	1
34312	2037	4112343	1968-07-19	1968-08-01	1
31521	1867	4146173	2014-06-12	2014-08-11	1
38852	2311	372328	1964-06-07	1964-10-10	1
88359	5258	80180	1999-07-10	1999-07-11	1
39302	2333	81151	1936-01-09	1936-02-06	1
83892	4988	40481087	1998-10-05	1998-10-26	1
29579	1752	372328	1979-10-17	1979-12-02	1
80592	4784	40481087	1970-02-17	1970-03-03	1
81402	4834	80180	2003-04-25	2003-04-26	1
4547	266	28060	1999-04-22	1999-05-05	1
82199	4881	40479768	1981-12-18	1982-02-23	1
34101	2027	260139	1963-04-16	1963-04-30	1
11082	654	40481087	2004-04-15	2004-04-29	1
11876	703	260139	2013-12-25	2014-01-08	1
30586	1808	40481087	1963-07-10	1963-07-31	1
87900	5234	40481087	2000-07-25	2000-08-15	1
30371	1793	4294548	1936-10-11	1936-10-25	1
5891	347	4112343	1991-05-29	1991-06-05	1
3943	227	4112343	2006-12-14	2006-12-25	1
15	1	4112343	1975-10-12	1975-10-19	1
39923	2367	40481087	2017-03-02	2017-03-23	1
71363	4238	40481087	1993-02-11	1993-02-18	1
36586	2167	372328	1979-05-09	1979-05-23	1
30198	1786	4278672	1970-11-02	1971-01-01	1
8218	480	260139	1975-09-23	1975-10-07	1
33737	2005	372328	1974-05-08	1974-07-20	1
87400	5206	260139	1993-06-14	1993-06-28	1
32732	1946	4112343	1973-01-16	1973-01-26	1
35517	2108	260139	2006-10-14	2006-10-28	1
16181	958	40481087	2003-02-01	2003-02-22	1
10865	644	4109685	1976-10-16	1976-10-30	1
13989	826	4134304	2013-09-26	2013-12-25	1
27546	1627	40481087	1985-12-08	1985-12-15	1
23663	1412	40481087	1964-05-04	1964-05-11	1
67934	4018	260139	1967-08-08	1967-08-15	1
33700	2002	80180	2013-03-23	2013-03-24	1
34793	2069	4112343	1978-01-25	1978-02-02	1
85211	5073	4142905	1967-08-19	1967-09-18	1
33854	2012	260139	1957-08-31	1957-09-14	1
66063	3913	260139	2004-06-28	2004-07-12	1
28991	1718	40481087	2019-01-27	2019-02-03	1
40656	2419	40481087	2014-07-01	2014-07-15	1
78552	4656	260139	2009-08-29	2009-09-12	1
25216	1506	4112343	1950-09-26	1950-10-07	1
89316	5317	28060	1984-01-29	1984-02-06	1
62800	3714	260139	1973-04-24	1973-05-08	1
8053	472	80180	2018-10-06	2018-10-07	1
41752	2486	378001	2003-01-19	2003-02-18	1
4963	292	260139	1985-01-26	1985-02-09	1
63718	3767	28060	1986-05-13	1986-05-23	1
87438	5207	4310024	1993-08-29	1993-08-30	1
34313	2037	78272	1966-02-13	1966-03-13	1
31522	1867	40481087	1977-05-16	1977-06-06	1
38853	2311	372328	1976-11-06	1977-10-01	1
88360	5258	4112343	1966-09-18	1966-10-01	1
39303	2333	196456	1978-05-19	1978-05-19	1
83893	4988	40481087	2000-02-26	2000-03-04	1
29580	1752	372328	1982-06-20	1982-12-05	1
80593	4784	80180	1987-11-08	1987-11-09	1
81403	4834	372328	1962-06-21	1962-10-21	1
4548	266	375671	1986-05-17	1986-06-16	1
82200	4881	381316	2017-03-05	2017-03-06	1
34102	2027	260139	2002-11-03	2002-11-10	1
11083	654	372328	1964-02-06	1964-07-24	1
11877	703	4112343	1984-08-07	1984-08-18	1
30587	1808	40481087	1970-07-02	1970-07-16	1
87901	5234	81151	1977-09-07	1977-09-21	1
30372	1793	4296205	1943-04-02	1943-05-07	1
7449	439	260139	1987-08-17	1987-08-24	1
3944	227	4278672	1980-07-01	1980-09-29	1
16	1	4112343	2008-01-16	2008-01-26	1
41481	2469	81151	1981-09-07	1981-10-12	1
71364	4238	40481087	1993-09-23	1993-10-14	1
36587	2167	40481087	1992-12-07	1992-12-14	1
30199	1786	40481087	1962-06-21	1962-07-12	1
8219	480	260139	2013-09-12	2013-09-19	1
33738	2005	4112343	2004-06-11	2004-06-23	1
87401	5206	372328	1980-07-27	1980-09-20	1
32733	1946	40481087	1927-10-24	1927-11-14	1
35518	2108	4094814	1987-06-03	1987-09-01	1
16182	958	28060	2012-12-07	2012-12-16	1
10866	644	4278672	1982-09-29	1982-11-28	1
13990	826	40481087	2000-05-19	2000-06-02	1
27547	1627	195588	1977-08-26	1977-10-19	1
23664	1412	257012	1980-08-06	1980-08-07	1
67935	4018	372328	1964-06-23	1964-08-04	1
33701	2002	81151	1995-05-07	1995-05-21	1
34794	2069	40481087	1981-03-17	1981-03-31	1
85212	5073	40481087	1960-06-25	1960-07-09	1
33855	2012	260139	1968-03-10	1968-03-17	1
66064	3913	4134304	1969-11-10	1970-01-09	1
28992	1718	260139	1991-10-27	1991-11-03	1
40657	2419	81151	1955-11-22	1955-12-27	1
78553	4656	372328	1951-08-02	1951-08-16	1
25217	1506	4112343	1958-08-28	1958-09-07	1
89317	5317	80180	2014-05-20	2014-05-21	1
62801	3714	372328	1925-12-28	1926-01-20	1
8054	472	4296205	1992-06-29	1992-07-13	1
41753	2486	4237458	1996-12-21	1997-02-19	1
4964	292	260139	1996-07-17	1996-07-31	1
63719	3767	28060	2017-09-20	2017-10-02	1
87439	5207	40481087	2016-12-31	2017-01-07	1
34314	2037	372328	1963-02-07	1963-03-22	1
31523	1867	40481087	2002-12-18	2003-01-01	1
38854	2311	4112343	1993-11-04	1993-11-13	1
88361	5258	4112343	2009-09-01	2009-09-13	1
39304	2333	257012	1926-11-18	1926-11-19	1
83894	4988	40481087	2002-08-27	2002-09-03	1
29581	1752	4296204	2004-11-03	2004-11-17	1
80594	4784	81151	1958-11-10	1958-12-15	1
81404	4834	378001	1991-12-04	1992-01-03	1
4549	266	4084167	1973-02-24	1973-02-24	1
83477	4967	257012	1978-10-07	1978-10-08	1
34103	2027	378001	1963-02-05	1963-03-07	1
11084	654	40481087	2014-11-07	2014-11-14	1
11878	703	4112343	2015-11-05	2015-11-12	1
34393	2044	80180	1997-01-18	1997-01-19	1
87902	5234	195588	1977-10-06	1977-11-24	1
30373	1793	40481087	1920-05-29	1920-06-19	1
7450	439	372328	1980-06-15	1980-09-04	1
3945	227	4296205	2014-07-03	2014-07-31	1
17	1	40481087	2012-02-14	2012-02-28	1
41482	2469	260139	1993-04-08	1993-04-15	1
71365	4238	40481087	1999-02-23	1999-03-16	1
36588	2167	40481087	1996-10-01	1996-10-15	1
30200	1786	40481087	1964-08-07	1964-08-21	1
8220	480	4059173	1954-02-10	1954-03-12	1
33739	2005	4278672	2013-08-11	2013-10-10	1
87402	5206	40481087	1983-07-03	1983-07-10	1
32734	1946	40481087	1955-02-19	1955-03-12	1
35519	2108	4134304	1945-03-10	1945-04-09	1
16183	958	134438	1980-01-08	1980-09-04	1
10867	644	40481087	1996-02-22	1996-03-07	1
13991	826	40481087	2009-06-10	2009-07-01	1
27548	1627	372328	1955-09-13	1955-10-08	1
23665	1412	260139	1991-02-08	1991-02-22	1
67936	4018	372328	1966-06-25	1966-11-01	1
33702	2002	81893	2011-07-02	2011-07-03	1
36167	2147	28060	2016-06-10	2016-06-18	1
85213	5073	40481087	1966-04-16	1966-04-30	1
33856	2012	378001	1962-03-07	1962-04-06	1
66065	3913	40481087	1998-07-13	1998-07-20	1
28993	1718	372328	1969-08-02	1969-08-23	1
40658	2419	4112343	2013-02-21	2013-03-06	1
78554	4656	372328	1963-05-15	1963-10-13	1
25218	1506	4112343	1959-07-08	1959-07-19	1
89318	5317	260139	1978-01-10	1978-01-17	1
62802	3714	4155034	1964-01-09	1964-01-23	1
8055	472	40481087	2002-02-14	2002-02-28	1
41754	2486	40481087	1977-05-13	1977-06-03	1
4965	292	372328	1978-07-30	1978-11-18	1
63720	3767	378001	2013-11-15	2014-01-14	1
89445	5325	28060	1952-10-03	1952-10-14	1
34315	2037	4266809	2000-05-20	2000-05-21	1
31524	1867	80180	2006-07-04	2006-07-05	1
38855	2311	40481087	1965-09-08	1965-09-15	1
88362	5258	4112343	2014-02-20	2014-03-03	1
39305	2333	260139	1926-02-01	1926-02-08	1
83895	4988	78272	1967-05-22	1967-06-19	1
29582	1752	40481087	2011-11-10	2011-11-17	1
80595	4784	260139	2009-05-16	2009-05-23	1
81405	4834	40481087	1995-04-03	1995-04-17	1
4550	266	4230399	2018-09-26	2018-11-25	1
83478	4967	260139	2014-11-19	2014-11-26	1
34104	2027	40481087	2016-07-09	2016-07-23	1
11085	654	40481087	2015-08-17	2015-08-24	1
11879	703	40481087	1952-08-14	1952-09-04	1
34394	2044	260139	1967-03-19	1967-03-26	1
87903	5234	260139	1956-06-25	1956-07-09	1
30374	1793	40481087	1986-05-09	1986-05-23	1
7451	439	4112343	1979-07-24	1979-08-02	1
3946	227	40481087	2017-07-21	2017-07-28	1
18	1	28060	1953-02-06	1953-02-16	1
41483	2469	260139	1993-08-14	1993-08-28	1
71366	4238	0	1978-12-28	1978-12-29	1
36589	2167	40481087	1997-07-20	1997-08-10	1
30201	1786	40481087	1977-01-07	1977-01-28	1
9834	582	28060	2014-04-02	2014-04-14	1
33740	2005	40481087	2017-05-04	2017-05-18	1
87403	5206	40481087	1985-09-03	1985-09-10	1
32735	1946	40481087	1986-04-26	1986-05-03	1
35520	2108	4134304	1986-05-09	1986-08-07	1
16184	958	4296204	2002-12-12	2002-12-26	1
10868	644	260139	1980-09-26	1980-10-10	1
14276	844	260139	1993-10-01	1993-10-17	1
27549	1627	4116491	1972-07-10	1972-08-27	1
23666	1412	260139	2011-01-12	2011-01-19	1
67937	4018	378001	1972-11-29	1973-01-28	1
33703	2002	257012	1981-08-21	1981-08-22	1
36168	2147	260139	1958-03-01	1958-03-08	1
85214	5073	40481087	1999-08-18	1999-09-08	1
33857	2012	440448	1996-01-25	1996-01-26	1
66066	3913	40481087	2014-03-03	2014-03-17	1
28994	1718	372328	1986-12-20	1989-04-22	1
40659	2419	4134304	1989-12-12	1990-02-10	1
78555	4656	4146173	1987-07-22	1987-09-20	1
25219	1506	4112343	1978-11-28	1978-12-08	1
89319	5317	260139	2012-08-31	2012-09-14	1
62803	3714	40481087	1981-10-16	1981-10-30	1
8056	472	28060	1983-12-16	1983-12-25	1
41755	2486	40481087	2003-09-16	2003-10-07	1
5741	338	4285898	2001-07-04	2001-07-05	1
63721	3767	192671	2018-12-06	2018-12-07	1
89446	5325	257012	1980-04-03	1980-04-04	1
34316	2037	4285898	1999-09-23	1999-09-24	1
31525	1867	372328	1974-07-23	1974-08-27	1
38856	2311	40481087	1978-09-25	1978-10-02	1
88363	5258	40481087	1972-02-17	1972-02-24	1
39306	2333	260139	1958-09-19	1958-09-26	1
83896	4988	78272	1983-07-30	1983-08-20	1
29583	1752	40481087	2013-09-14	2013-09-28	1
80596	4784	28060	2004-02-08	2004-02-19	1
81406	4834	40481087	2019-01-31	2019-02-07	1
4551	266	40481087	1979-01-31	1979-02-07	1
83479	4967	4112343	1970-01-16	1970-01-23	1
35355	2097	81151	1982-11-04	1982-12-02	1
11086	654	260139	2018-08-26	2018-09-02	1
11880	703	40481087	1955-07-30	1955-08-13	1
34395	2044	378001	2009-11-01	2009-12-01	1
87904	5234	4035415	1953-02-05	1953-03-07	1
30375	1793	40481087	1993-02-07	1993-02-14	1
7452	439	4112343	1979-09-03	1979-09-13	1
3947	227	81151	2019-05-06	2019-05-27	1
19	1	80180	1982-08-12	1982-08-13	1
41484	2469	372328	1971-10-30	1972-01-09	1
71367	4238	4112343	1973-06-10	1973-06-22	1
36590	2167	40481087	2013-03-15	2013-03-22	1
30202	1786	40481087	1982-04-07	1982-04-21	1
9835	582	81151	1986-03-17	1986-04-21	1
33741	2005	28060	1979-11-12	1979-11-25	1
87404	5206	40481087	2000-09-29	2000-10-20	1
32736	1946	260139	1942-10-30	1942-11-13	1
35521	2108	4134304	2017-07-23	2017-09-21	1
16185	958	40481087	1969-09-05	1969-09-19	1
10869	644	260139	1989-06-02	1989-06-09	1
14277	844	4027663	1994-04-16	1994-04-17	1
27550	1627	4142905	1981-09-26	1981-10-26	1
23667	1412	260139	2018-07-31	2018-08-14	1
67938	4018	4059173	1964-12-20	1965-01-19	1
33704	2002	4294548	1981-07-17	1981-09-11	1
36169	2147	260139	1973-08-27	1973-09-10	1
86061	5127	260139	1972-07-07	1972-07-14	1
33858	2012	4094814	1983-03-08	1983-06-06	1
66067	3913	257012	1966-11-23	1966-11-24	1
28995	1718	4112343	1976-04-16	1976-04-24	1
40660	2419	4294548	1977-10-29	1977-11-19	1
78556	4656	40481087	1955-11-18	1955-12-02	1
25220	1506	40481087	1989-10-11	1989-10-25	1
89320	5317	40481087	1996-12-06	1996-12-27	1
62804	3714	78272	1965-02-16	1965-03-02	1
8057	472	134438	1998-01-26	1998-09-27	1
41756	2486	4112343	1979-10-26	1979-11-08	1
5742	338	40481087	1967-08-24	1967-08-31	1
63722	3767	260139	1997-03-15	1997-03-29	1
89447	5325	260139	1973-03-16	1973-03-30	1
34317	2037	28060	2002-12-29	2003-01-08	1
31526	1867	372328	1977-07-29	1978-03-07	1
38857	2311	40481087	1987-11-21	1987-12-05	1
88364	5258	81151	1965-03-25	1965-04-29	1
39307	2333	260139	1997-10-03	1997-10-10	1
83897	4988	192671	1991-06-05	1991-06-06	1
29584	1752	80180	2016-03-10	2016-03-11	1
80597	4784	260139	1971-01-15	1971-01-29	1
81407	4834	81151	2001-06-05	2001-07-10	1
4552	266	40481087	1980-03-10	1980-03-24	1
83480	4967	28060	1968-12-07	1968-12-20	1
35356	2097	195588	1996-02-29	1996-04-13	1
11087	654	4112343	1990-05-16	1990-05-26	1
11881	703	40481087	1976-08-17	1976-08-31	1
34396	2044	4266809	1997-01-18	1997-01-19	1
87905	5234	4109685	1965-09-05	1965-09-19	1
30376	1793	28060	2005-12-28	2006-01-07	1
7453	439	4112343	2009-04-06	2009-04-17	1
3948	227	375671	1979-05-08	1979-06-07	1
20	1	260139	1971-01-04	1971-01-18	1
41485	2469	4027663	1998-07-25	1998-07-26	1
71368	4238	4112343	1997-04-19	1997-05-01	1
36591	2167	40481087	2018-01-01	2018-01-22	1
30203	1786	28060	1959-12-18	1959-12-26	1
9836	582	192671	2005-04-04	2005-04-05	1
33742	2005	257012	2007-09-21	2007-09-22	1
87405	5206	40481087	2017-10-26	2017-11-09	1
32737	1946	260139	1974-11-08	1974-11-15	1
35522	2108	40481087	1955-10-12	1955-10-19	1
16186	958	40481087	1996-04-16	1996-04-30	1
10870	644	260139	2003-11-04	2003-11-11	1
14278	844	4048171	1970-04-29	1993-07-17	1
27551	1627	40481087	1985-07-29	1985-08-05	1
23668	1412	4116491	2010-06-15	2010-07-20	1
67939	4018	4112343	1980-12-27	1981-01-07	1
33705	2002	40481087	2005-06-27	2005-07-11	1
36170	2147	260139	1988-01-23	1988-02-06	1
86062	5127	260139	1984-02-16	1984-02-23	1
33859	2012	4112343	2002-08-01	2002-08-11	1
66068	3913	260139	1982-07-14	1982-07-28	1
28996	1718	4112343	1989-08-04	1989-08-15	1
40661	2419	40481087	1953-05-12	1953-05-19	1
78557	4656	40481087	2008-10-29	2008-11-05	1
25221	1506	80180	1985-08-06	1985-08-07	1
89321	5317	40481087	2003-12-27	2004-01-17	1
62805	3714	80502	2012-12-19	2012-12-20	1
8058	472	40481087	2018-07-10	2018-07-24	1
41757	2486	4285898	2010-12-03	2010-12-04	1
5743	338	40481087	1974-09-29	1974-10-06	1
63723	3767	260139	2016-03-13	2016-03-20	1
89448	5325	4112343	1979-09-10	1979-09-21	1
34318	2037	30753	1998-12-27	1998-12-28	1
31527	1867	40481087	1973-07-24	1973-07-31	1
38858	2311	260139	1960-10-28	1960-11-04	1
88365	5258	260139	1982-11-23	1982-11-30	1
39308	2333	4109685	1991-04-19	1991-05-10	1
83898	4988	260139	1977-04-17	1977-04-24	1
29585	1752	40481087	1978-11-29	1978-12-06	1
80598	4784	260139	1987-01-06	1987-01-13	1
81408	4834	260139	1999-07-10	1999-07-17	1
4553	266	40481087	2011-03-11	2011-04-01	1
83481	4967	80180	2003-11-10	2003-11-11	1
35357	2097	260139	1988-02-01	1988-02-15	1
11088	654	4112343	2017-06-05	2017-06-17	1
11882	703	28060	1981-12-06	1981-12-18	1
34397	2044	4285898	1996-10-20	1996-10-21	1
87906	5234	40481087	1990-07-29	1990-08-19	1
30377	1793	80502	1988-06-01	1988-06-02	1
7454	439	4113008	2002-10-18	2002-11-08	1
3949	227	4283893	1985-12-21	1986-01-11	1
21	1	378001	2008-05-18	2008-07-17	1
41486	2469	4112343	1990-05-24	1990-06-01	1
71369	4238	40481087	1966-11-08	1966-11-22	1
36592	2167	81893	2016-02-29	2016-03-01	1
30204	1786	80180	1984-12-08	1984-12-09	1
9837	582	260139	1996-10-02	1996-10-09	1
33743	2005	260139	2013-05-02	2013-05-09	1
87406	5206	260139	1980-11-25	1980-12-09	1
32738	1946	4112343	2000-06-05	2000-06-16	1
35523	2108	40481087	1961-03-26	1961-04-02	1
16187	958	80180	1993-08-15	1993-08-16	1
10871	644	372328	1975-12-21	1976-01-28	1
14279	844	4112343	1978-05-30	1978-06-07	1
27552	1627	28060	1971-02-09	1971-02-22	1
23669	1412	4155034	1983-12-12	1984-01-02	1
67940	4018	4112343	2017-12-09	2017-12-21	1
33706	2002	40481087	2006-03-17	2006-04-07	1
36171	2147	4109685	1987-05-02	1987-05-16	1
86063	5127	260139	1994-10-26	1994-11-09	1
33860	2012	4237458	1970-07-23	1970-08-22	1
66069	3913	4109685	1996-10-19	1996-11-02	1
28997	1718	4112343	2003-05-06	2003-05-16	1
40662	2419	40481087	2013-10-15	2013-10-29	1
78558	4656	0	2008-06-29	2008-06-30	1
25222	1506	4112343	1963-11-28	1963-12-09	1
89322	5317	81151	1981-04-23	1981-05-07	1
62806	3714	260139	1963-01-21	1963-01-28	1
8854	520	28060	2012-06-28	2012-07-11	1
41758	2486	40481087	1982-06-12	1982-06-19	1
5744	338	80180	2001-08-03	2001-08-04	1
63724	3767	372328	1986-10-08	1987-01-23	1
89449	5325	4156265	1952-01-05	1952-01-26	1
34319	2037	260139	1970-07-23	1970-08-06	1
31528	1867	40481087	1976-07-22	1976-08-12	1
38859	2311	4112343	2008-01-03	2008-01-14	1
88366	5258	260139	1997-11-02	1997-11-16	1
39309	2333	4112343	1926-12-11	1926-12-23	1
83899	4988	372328	1979-01-05	1980-04-29	1
29586	1752	40481087	1987-08-28	1987-09-04	1
80599	4784	260139	2010-07-18	2010-08-01	1
81409	4834	372328	1962-02-04	1962-04-22	1
4554	266	80180	2006-10-04	2006-10-05	1
83482	4967	372328	1961-06-28	1961-09-04	1
35358	2097	4112343	2010-12-28	2011-01-05	1
11089	654	40481087	2001-10-12	2001-10-19	1
11883	703	81151	1974-04-16	1974-05-21	1
34398	2044	40481087	1996-09-24	1996-10-01	1
87907	5234	40481087	2000-06-02	2000-06-16	1
30378	1793	260139	1982-04-20	1982-05-04	1
7455	439	4134304	1993-04-08	1993-06-07	1
3950	227	40481087	1989-09-27	1989-10-11	1
22	1	4112343	1961-07-05	1961-07-14	1
41487	2469	4112343	2007-07-04	2007-07-12	1
71370	4238	40481087	1979-11-22	1979-11-29	1
36593	2167	4296204	2018-02-27	2018-04-03	1
30205	1786	4112343	1968-10-21	1968-11-02	1
9838	582	260139	2008-03-23	2008-03-30	1
33744	2005	4112343	1982-09-13	1982-09-23	1
87407	5206	4112343	1995-11-15	1995-11-25	1
32739	1946	4237458	2008-10-23	2008-11-22	1
35524	2108	40481087	1974-04-17	1974-05-08	1
16188	958	260139	2013-12-06	2013-12-13	1
10872	644	372328	1977-12-18	1978-03-29	1
14280	844	4112343	1992-01-28	1992-02-09	1
27553	1627	257012	1953-06-23	1953-06-24	1
23670	1412	4156265	1999-11-30	1999-12-14	1
67941	4018	4152936	1968-02-03	1968-02-24	1
33707	2002	4027663	2002-03-06	2002-03-07	1
36172	2147	4112343	1967-02-24	1967-03-04	1
86064	5127	372328	1971-02-11	1971-08-27	1
33861	2012	40481087	1966-05-21	1966-06-11	1
66070	3913	40481087	1986-08-09	1986-08-16	1
28998	1718	4112343	2013-09-09	2013-09-16	1
40663	2419	80180	1979-10-02	1979-10-03	1
78559	4656	80502	2009-11-08	2009-11-09	1
25223	1506	4112343	1971-02-01	1971-02-09	1
89323	5317	257012	2011-01-14	2011-01-15	1
62807	3714	4059173	1937-01-20	1937-03-21	1
8855	520	81151	1997-02-25	1997-03-11	1
41759	2486	40481087	1982-10-25	1982-11-01	1
5745	338	260139	1995-06-01	1995-06-15	1
63725	3767	372328	1989-07-19	1990-01-26	1
89450	5325	4294548	1980-02-21	1980-04-24	1
34320	2037	372328	1960-05-15	1960-07-22	1
31529	1867	40481087	1982-07-17	1982-07-31	1
38860	2311	40481087	1977-07-05	1977-07-26	1
88367	5258	4112343	1994-10-27	1994-11-03	1
39310	2333	4113008	1940-09-12	1940-09-26	1
83900	4988	4142905	1956-02-05	1956-04-05	1
29587	1752	40481087	1996-11-19	1996-12-10	1
80600	4784	4112343	2007-07-04	2007-07-13	1
81410	4834	372328	1964-10-10	1965-04-25	1
4555	266	378001	1985-03-23	1985-04-22	1
83483	4967	4112343	1961-12-27	1962-01-09	1
35359	2097	28060	1990-11-05	1990-11-12	1
12912	760	40481087	2011-05-24	2011-06-07	1
11884	703	372328	1954-05-31	1954-12-03	1
34399	2044	40481087	2006-04-04	2006-04-18	1
87908	5234	80180	1979-07-14	1979-07-15	1
30379	1793	260139	1990-05-28	1990-06-11	1
7456	439	4142905	1983-05-31	1983-06-30	1
3951	227	260139	2005-10-20	2005-10-27	1
23	1	4112343	1971-01-24	1971-02-02	1
41488	2469	4134304	1979-09-18	1979-11-17	1
73909	4395	81151	1982-07-10	1982-07-24	1
36594	2167	4310024	2015-10-02	2015-10-03	1
30206	1786	4112343	1980-08-16	1980-08-23	1
9839	582	372328	1977-06-08	1977-10-26	1
33745	2005	4112343	2005-04-21	2005-04-30	1
87408	5206	4112343	2017-09-01	2017-09-12	1
32740	1946	40481087	1948-09-19	1948-10-03	1
35525	2108	260139	1957-04-12	1957-04-26	1
16189	958	4048695	1982-11-26	1983-01-26	1
10873	644	372328	1981-05-12	1981-10-07	1
14281	844	4112343	2005-05-04	2005-05-13	1
27554	1627	260139	1970-06-28	1970-07-05	1
23671	1412	40481087	1967-07-27	1967-08-17	1
67942	4018	40481087	1966-01-19	1966-02-02	1
33708	2002	40479768	1983-08-01	1983-10-07	1
36173	2147	4112343	1971-07-15	1971-07-24	1
86065	5127	4059173	1980-03-25	1980-04-24	1
33862	2012	40481087	2007-07-27	2007-08-03	1
66071	3913	40481087	2015-08-17	2015-08-24	1
28999	1718	40481087	1990-12-31	1991-01-14	1
40664	2419	378001	1946-09-10	1946-11-09	1
78560	4656	4112343	1997-09-27	1997-10-05	1
25224	1506	4152936	1998-03-22	1998-04-05	1
89324	5317	260139	1973-11-03	1973-11-17	1
62808	3714	4112343	1937-08-24	1937-09-01	1
8856	520	260139	1993-09-23	1993-10-07	1
41760	2486	40481087	1989-03-04	1989-03-25	1
5746	338	4084167	1975-09-04	1975-09-04	1
63726	3767	4112343	1998-06-20	1998-07-01	1
89451	5325	4296205	1989-10-22	1989-11-05	1
34321	2037	4027663	1990-04-08	1990-04-09	1
36661	2173	28060	1934-05-29	1934-06-09	1
38861	2311	40481087	2015-08-07	2015-08-21	1
88368	5258	4294548	1967-01-23	1967-09-04	1
39311	2333	4116491	1962-05-22	1962-07-01	1
83901	4988	4218389	1977-12-23	1978-01-27	1
32226	1917	28060	1959-06-27	1959-07-07	1
80601	4784	4112343	2013-12-12	2013-12-23	1
81411	4834	4109685	2008-12-30	2009-01-20	1
4556	266	4237458	1967-05-27	1967-07-26	1
83484	4967	4112343	1995-06-12	1995-06-23	1
35360	2097	192671	2014-04-17	2014-04-18	1
12913	760	81151	1992-09-13	1992-10-04	1
11885	703	4112343	1956-09-18	1956-09-30	1
34400	2044	28060	1978-04-20	1978-05-02	1
87909	5234	195588	1971-08-25	1971-10-08	1
30380	1793	260139	2002-06-16	2002-06-30	1
7457	439	40481087	2009-07-05	2009-07-19	1
3952	227	372328	1974-04-04	1974-08-23	1
24	1	4112343	1991-01-31	1991-02-10	1
41489	2469	4266809	2008-08-06	2008-08-07	1
73910	4395	4112343	1966-09-28	1966-10-05	1
36595	2167	40481087	1991-09-08	1991-09-22	1
30207	1786	4112343	1980-09-25	1980-10-07	1
9840	582	378001	1992-12-15	1993-01-14	1
33746	2005	4112343	2017-07-28	2017-08-07	1
87409	5206	80180	2017-10-26	2017-10-27	1
32741	1946	40481087	1954-07-11	1954-07-18	1
35526	2108	313217	2018-12-28	2018-12-29	1
16190	958	4112343	1975-06-17	1975-06-24	1
10874	644	4112343	2001-08-02	2001-08-12	1
14282	844	4134304	1982-01-29	1982-04-29	1
27555	1627	372328	1980-06-25	1983-01-29	1
23672	1412	40481087	1993-05-06	1993-05-20	1
67943	4018	40481087	1997-02-06	1997-02-13	1
33709	2002	40481087	2005-04-05	2005-04-19	1
36174	2147	4112343	1995-01-17	1995-01-28	1
86066	5127	40481087	2002-03-28	2002-04-04	1
34570	2054	30753	2009-02-04	2009-02-05	1
67683	4005	260139	1973-04-10	1973-04-17	1
32471	1929	80180	1993-05-26	1993-05-27	1
40665	2419	4112343	1952-05-13	1952-05-23	1
78561	4656	4155034	1989-05-12	1989-06-02	1
25225	1506	4283893	1986-09-28	1987-04-19	1
89325	5317	260139	1983-09-20	1983-09-27	1
62809	3714	4112343	1982-02-21	1982-03-04	1
8857	520	372328	1983-02-19	1985-06-06	1
41761	2486	80180	2011-03-03	2011-03-04	1
5747	338	4112343	2006-02-20	2006-03-01	1
63727	3767	4112343	2011-08-07	2011-08-19	1
89452	5325	372328	2008-11-18	2009-01-18	1
34322	2037	4112343	1962-02-08	1962-02-20	1
36662	2173	260139	2012-08-27	2012-09-10	1
38862	2311	260139	1973-08-31	1973-09-14	1
88369	5258	40481087	1973-06-23	1973-07-07	1
39312	2333	4156265	1998-10-30	1998-11-20	1
83902	4988	4266809	1991-04-27	1991-04-28	1
32227	1917	28060	1984-03-01	1984-03-10	1
80602	4784	4156265	2009-11-22	2009-12-13	1
81412	4834	4112343	2009-03-15	2009-03-25	1
4557	266	4283893	2003-07-31	2003-08-21	1
83485	4967	4112343	2010-05-07	2010-05-18	1
35361	2097	257012	1993-08-03	1993-08-04	1
12914	760	260139	1992-12-08	1992-12-22	1
11886	703	4112343	1981-07-25	1981-08-04	1
34401	2044	81893	1995-05-29	1995-05-30	1
87910	5234	258780	1997-04-23	1997-04-24	1
30381	1793	317576	1980-07-23	1980-07-24	1
7458	439	372328	1982-06-26	1983-05-05	1
3953	227	378001	1999-04-23	1999-06-22	1
25	1	4296205	1978-06-22	1978-07-27	1
41490	2469	40481087	1975-05-14	1975-05-28	1
73911	4395	40481087	1954-06-16	1954-07-07	1
36596	2167	40481087	1991-10-30	1991-11-06	1
30208	1786	4112343	1988-07-29	1988-08-09	1
9841	582	4285898	2004-04-11	2004-04-12	1
33747	2005	4294548	2007-06-08	2007-10-26	1
87410	5206	4112343	1983-10-28	1983-11-05	1
32742	1946	40481087	1993-05-03	1993-05-17	1
35527	2108	440448	1978-08-31	1978-09-01	1
16191	958	40481087	1985-09-18	1985-10-02	1
10875	644	40481087	1987-10-17	1987-10-31	1
14283	844	4283893	1971-02-03	1971-02-24	1
27556	1627	4112343	1965-04-26	1965-05-08	1
23673	1412	40481087	2018-04-13	2018-05-04	1
67944	4018	81151	1978-07-22	1978-08-12	1
34586	2056	28060	1981-05-17	1981-05-28	1
36175	2147	40481087	1973-01-15	1973-02-05	1
86067	5127	80180	2009-11-13	2009-11-14	1
34571	2054	372328	1974-01-09	1974-04-25	1
67684	4005	4134304	1981-05-03	1981-06-02	1
32472	1929	372328	1990-12-01	1991-11-07	1
40666	2419	4112343	1965-02-15	1965-02-27	1
78562	4656	40481087	1958-01-27	1958-02-10	1
25226	1506	40481087	1957-02-11	1957-02-25	1
89326	5317	260139	2006-03-01	2006-03-08	1
62810	3714	4218389	1928-07-15	1928-08-05	1
8858	520	4109685	1980-12-30	1981-01-20	1
41762	2486	260139	1978-09-29	1978-10-06	1
5748	338	4112343	2016-07-16	2016-07-27	1
63728	3767	40481087	1987-09-12	1987-10-03	1
89453	5325	4059173	1948-11-21	1948-12-21	1
34323	2037	4218389	2002-04-03	2002-05-01	1
36663	2173	372328	1934-11-14	1935-06-18	1
38863	2311	4112343	1971-09-17	1971-09-30	1
88370	5258	40481087	2003-04-20	2003-04-27	1
39313	2333	4156265	1999-10-16	1999-10-30	1
83903	4988	4283893	1975-09-06	1975-09-20	1
32228	1917	260139	1955-11-30	1955-12-07	1
80603	4784	40481087	1981-05-13	1981-05-20	1
81413	4834	4134304	1971-03-24	1971-04-23	1
4558	266	40481087	2008-04-29	2008-05-20	1
83486	4967	4134304	1982-07-08	1982-10-06	1
35362	2097	260139	1982-09-06	1982-09-20	1
12915	760	4112343	2017-06-28	2017-07-07	1
11887	703	4134304	1952-02-11	1952-04-11	1
34402	2044	260139	1993-08-07	1993-08-14	1
87911	5234	260139	1995-04-02	1995-04-16	1
30382	1793	372328	1971-06-20	1972-03-08	1
7459	439	372328	2002-12-21	2005-10-27	1
3954	227	4112343	1972-03-17	1972-03-29	1
26	1	40479768	1981-08-10	1981-09-16	1
41491	2469	40481087	1992-08-28	1992-09-04	1
73912	4395	40481087	1977-06-14	1977-07-05	1
36597	2167	40481087	1999-12-05	1999-12-26	1
30209	1786	4112343	2010-11-24	2010-12-04	1
9842	582	40481087	1966-10-30	1966-11-20	1
33748	2005	40481087	1985-06-13	1985-07-04	1
87411	5206	4112343	1985-10-27	1985-11-04	1
34105	2028	260139	1980-01-17	1980-02-01	1
35528	2108	4112343	1950-11-25	1950-12-03	1
16192	958	40481087	2017-11-23	2017-12-14	1
12723	754	28060	1952-01-11	1952-01-19	1
14284	844	4294548	2018-03-21	2018-04-04	1
27557	1627	4294548	1953-06-02	1953-11-17	1
29035	1720	81151	2007-10-30	2007-12-04	1
67945	4018	260139	2005-07-12	2005-07-26	1
34587	2056	80180	2016-02-26	2016-02-27	1
36176	2147	260139	1984-12-24	1985-01-07	1
86068	5127	378001	2010-07-16	2010-08-15	1
34572	2054	80180	2010-08-28	2010-08-29	1
67685	4005	40481087	1978-12-22	1978-12-29	1
32473	1929	4112343	2019-01-12	2019-01-20	1
40667	2419	4112343	1974-09-04	1974-09-17	1
78563	4656	40481087	1961-01-04	1961-01-18	1
25227	1506	28060	1972-09-05	1972-09-15	1
89327	5317	372328	1974-01-30	1974-02-20	1
62811	3714	4283893	1936-01-10	1936-06-05	1
8859	520	4112343	1977-03-20	1977-03-30	1
41763	2486	372328	1974-07-20	1974-08-30	1
5749	338	4027663	1992-04-12	1992-04-13	1
63729	3767	40481087	2004-02-15	2004-02-22	1
89454	5325	4112343	1991-04-22	1991-05-01	1
34324	2037	40481087	1991-02-01	1991-02-08	1
36664	2173	372328	1942-10-09	1943-08-03	1
38864	2311	4112343	2009-12-08	2009-12-20	1
88371	5258	260139	1984-09-22	1984-10-06	1
39314	2333	4283893	1982-11-19	1983-05-27	1
83904	4988	40481087	1957-11-02	1957-11-09	1
32229	1917	4112343	1986-07-30	1986-08-06	1
80604	4784	28060	1963-03-23	1963-03-31	1
81414	4834	40481087	2013-11-14	2013-11-21	1
4559	266	372328	1971-09-17	1972-04-17	1
83487	4967	40481087	1983-07-09	1983-07-30	1
35363	2097	372328	1979-04-24	1979-08-11	1
12916	760	40481087	1970-11-02	1970-11-09	1
11888	703	4155034	1992-09-13	1992-09-27	1
34403	2044	372328	1964-11-27	1965-03-20	1
87912	5234	4094814	1995-07-03	1995-08-02	1
30383	1793	4112343	1987-10-08	1987-10-18	1
7460	439	4146173	2013-08-12	2013-09-11	1
3955	227	4112343	2010-08-23	2010-09-01	1
2031	119	80180	1995-05-01	1995-05-02	1
41492	2469	40481087	2014-09-03	2014-09-24	1
73913	4395	40481087	2009-10-23	2009-11-06	1
39887	2366	260139	2008-06-06	2008-06-20	1
30210	1786	4112343	2014-03-22	2014-03-29	1
9843	582	81151	1965-11-27	1966-01-01	1
33749	2005	40481087	2000-08-19	2000-09-09	1
87412	5206	4112343	1996-04-26	1996-05-06	1
34106	2028	378001	1955-10-14	1955-11-13	1
35529	2108	4112343	1976-09-18	1976-09-28	1
17509	1054	80180	1973-01-25	1973-01-26	1
12724	754	78272	1945-01-14	1945-02-18	1
14285	844	40481087	1978-12-19	1978-12-26	1
27558	1627	40481087	1978-08-15	1978-08-29	1
29036	1720	40481087	1980-09-29	1980-10-13	1
67946	4018	372328	1968-01-25	1968-11-05	1
34588	2056	260139	1994-04-09	1994-04-23	1
36177	2147	321042	2005-03-25	2005-03-26	1
86069	5127	4112343	2002-10-27	2002-11-06	1
34573	2054	4027663	1999-06-17	1999-06-18	1
67686	4005	40481087	1979-03-05	1979-03-26	1
32474	1929	4155034	1966-08-16	1966-09-06	1
40668	2419	40481087	1955-07-13	1955-07-20	1
78933	4678	81151	2017-12-01	2017-12-22	1
25228	1506	257012	1986-10-19	1986-10-20	1
89328	5317	4112343	2009-10-23	2009-11-05	1
62812	3714	40481087	2007-11-06	2007-11-13	1
8860	520	40481087	1983-12-02	1983-12-09	1
41764	2486	40481087	2015-05-02	2015-05-23	1
5750	338	4112343	2016-05-08	2016-05-15	1
63850	3777	192671	2018-09-19	2018-09-20	1
89455	5325	4218389	2009-04-24	2009-05-22	1
34325	2037	40481087	1995-10-23	1995-11-13	1
36665	2173	378001	1972-08-17	1972-09-16	1
38865	2311	40481087	1976-10-19	1976-11-02	1
88372	5258	4059173	1968-01-14	1968-02-13	1
39315	2333	40481087	2006-03-14	2006-03-21	1
83905	4988	40481087	1983-03-02	1983-03-09	1
32230	1917	4218389	1983-01-06	1983-02-10	1
80605	4784	260139	1996-03-02	1996-03-16	1
81415	4834	78272	1969-02-27	1969-04-03	1
4560	266	4112343	1973-12-25	1974-01-02	1
83488	4967	372328	1963-11-23	1964-05-04	1
35364	2097	4112343	2011-04-09	2011-04-16	1
12917	760	40481087	1992-03-14	1992-03-28	1
11889	703	40481087	2004-05-26	2004-06-09	1
34404	2044	372328	1966-04-14	1966-09-24	1
87913	5234	4112343	1956-11-18	1956-11-30	1
30384	1793	4152936	1996-12-04	1996-12-18	1
7461	439	40481087	1986-07-23	1986-08-13	1
5148	304	28060	2005-09-14	2005-09-23	1
2032	119	195588	2008-12-13	2009-02-07	1
41493	2469	40481087	2016-03-12	2016-03-26	1
73914	4395	28060	2018-05-31	2018-06-08	1
39888	2366	28060	1968-11-13	1968-11-21	1
30211	1786	4294548	2001-03-30	2001-06-22	1
9844	582	4112343	1978-08-03	1978-08-10	1
33750	2005	40481087	2016-12-06	2016-12-27	1
87413	5206	4296205	1986-05-11	1986-06-01	1
34107	2028	378001	1989-07-31	1989-09-29	1
35530	2108	4112343	2015-12-04	2015-12-12	1
17510	1054	260139	1997-07-08	1997-07-15	1
12725	754	260139	1947-08-03	1947-08-17	1
14286	844	30753	2001-02-03	2001-02-04	1
27559	1627	40481087	2009-12-08	2009-12-29	1
29037	1720	40481087	2000-08-27	2000-09-03	1
67947	4018	378001	2003-01-03	2003-02-02	1
34589	2056	372328	1991-12-12	1992-03-25	1
36178	2147	378001	1965-07-26	1965-09-24	1
86070	5127	40481087	1973-12-08	1973-12-22	1
34574	2054	4156265	1985-05-11	1985-05-25	1
67687	4005	40481087	1979-07-03	1979-07-10	1
32475	1929	4155034	2016-11-03	2016-11-17	1
40669	2419	260139	1948-07-03	1948-07-10	1
78934	4678	4112343	1963-03-02	1963-03-09	1
25229	1506	313217	2011-04-30	2011-05-01	1
89329	5317	4112343	2011-01-03	2011-01-16	1
62813	3714	260139	1950-03-10	1950-03-24	1
8861	520	40481087	1987-08-27	1987-09-17	1
41765	2486	4027663	2004-03-14	2004-03-15	1
5751	338	40481087	2014-02-18	2014-02-25	1
63851	3777	372328	1987-07-10	1987-10-01	1
89456	5325	40481087	1960-08-28	1960-09-11	1
37809	2243	378001	2000-06-19	2000-08-18	1
36666	2173	4027663	1964-06-29	1964-06-30	1
38866	2311	80180	1993-05-11	1993-05-12	1
88373	5258	4112343	1984-03-04	1984-03-11	1
39316	2333	80180	1957-04-13	1957-04-14	1
85535	5094	4112343	1994-09-08	1994-09-19	1
32231	1917	40481087	1998-02-05	1998-02-19	1
80606	4784	372328	1976-09-06	1977-01-15	1
81416	4834	81151	1994-02-21	1994-03-14	1
4561	266	4146173	1993-11-06	1993-12-06	1
83489	4967	378001	1964-05-13	1964-07-12	1
35365	2097	4152936	1993-02-07	1993-02-21	1
12918	760	80180	1998-01-01	1998-01-02	1
11890	703	260139	1995-12-24	1996-01-07	1
34405	2044	378001	1974-07-08	1974-08-07	1
87914	5234	4142905	1989-07-20	1989-09-18	1
30385	1793	40479422	1991-01-05	1991-03-06	1
7462	439	40481087	2000-10-27	2000-11-17	1
5149	304	257012	1974-07-30	1974-11-05	1
2033	119	4112343	1957-02-04	1957-02-13	1
41494	2469	80180	2008-08-06	2008-08-07	1
73915	4395	81151	1981-08-09	1981-09-13	1
39889	2366	80180	2006-06-25	2006-06-26	1
30212	1786	4059173	1959-03-05	1959-06-03	1
9845	582	4112343	2004-04-11	2004-04-21	1
33751	2005	28060	2003-12-04	2003-12-12	1
87414	5206	40481087	1984-01-13	1984-02-03	1
34108	2028	4112343	1956-11-09	1956-11-18	1
35531	2108	4166224	1978-08-31	1978-09-01	1
17511	1054	4027663	1963-12-09	1963-12-10	1
12726	754	260139	1950-08-12	1950-08-26	1
14287	844	192671	2002-10-10	2002-10-11	1
29000	1719	28060	1965-06-12	1965-06-23	1
29038	1720	40481087	2005-12-12	2006-01-02	1
67948	4018	4109685	1975-12-14	1976-01-04	1
34590	2056	4059173	1982-01-10	1982-04-10	1
36179	2147	4112343	1975-12-30	1976-01-12	1
86071	5127	40481087	1990-01-20	1990-01-27	1
34575	2054	4278672	2014-07-22	2014-10-20	1
67688	4005	40481087	1986-04-08	1986-04-15	1
32476	1929	4294548	1996-01-20	1996-02-24	1
40670	2419	4112343	2003-04-03	2003-04-14	1
78935	4678	4112343	1973-07-29	1973-08-11	1
25230	1506	381316	2012-10-13	2012-10-14	1
89330	5317	4283893	2011-06-26	2011-10-16	1
62814	3714	313217	2005-11-09	2005-11-10	1
8862	520	40481087	1990-02-10	1990-03-03	1
41766	2486	4112343	1992-10-03	1992-10-12	1
5752	338	40481087	2016-02-22	2016-03-07	1
63852	3777	4285898	2017-10-05	2017-10-06	1
89457	5325	40481087	1962-02-09	1962-03-02	1
37810	2243	4112343	1988-06-09	1988-06-17	1
36667	2173	40481087	1949-07-07	1949-07-28	1
38867	2311	260139	1963-03-25	1963-04-08	1
88374	5258	4112343	1993-03-26	1993-04-02	1
39317	2333	81151	1990-03-20	1990-04-24	1
85536	5094	80180	2017-12-07	2017-12-08	1
32232	1917	260139	1982-08-08	1982-08-22	1
80607	4784	4112343	1968-11-03	1968-11-11	1
81417	4834	4112343	1984-08-10	1984-08-19	1
6450	380	372328	1972-01-11	1972-02-18	1
83490	4967	40481087	1996-05-01	1996-05-08	1
35366	2097	4296204	1998-10-23	1998-11-27	1
12919	760	260139	2007-06-21	2007-06-28	1
11891	703	4237458	1966-07-27	1966-10-25	1
34406	2044	4112343	1982-09-10	1982-09-20	1
87915	5234	4152936	1962-09-30	1962-10-21	1
30386	1793	40481087	1986-02-26	1986-03-05	1
7463	439	28060	1981-07-07	1981-07-19	1
5150	304	260139	1959-05-24	1959-06-07	1
2034	119	4112343	1958-11-08	1958-11-18	1
41495	2469	81893	2006-11-15	2006-11-16	1
73916	4395	4146173	1974-07-17	1974-09-15	1
39890	2366	260139	2003-08-14	2003-08-21	1
30213	1786	4112343	1947-03-10	1947-03-22	1
9846	582	40481087	2004-02-19	2004-02-26	1
33752	2005	40481087	2008-01-31	2008-02-14	1
89085	5306	372328	1969-09-24	1969-12-28	1
34109	2028	4112343	1997-10-27	1997-11-07	1
35532	2108	40481087	1946-12-07	1946-12-21	1
17512	1054	4059173	2000-02-03	2000-05-03	1
12727	754	4142905	1950-09-20	1950-10-20	1
14288	844	260139	1966-11-20	1966-11-27	1
29001	1719	81151	2007-12-17	2008-01-07	1
29039	1720	28060	1980-02-27	1980-03-09	1
67949	4018	40481087	1995-04-21	1995-05-12	1
34591	2056	4155034	2001-04-30	2001-05-14	1
36180	2147	4156265	2013-08-27	2013-09-10	1
86072	5127	40481087	1995-11-03	1995-11-24	1
34576	2054	28060	1979-10-13	1979-10-21	1
67689	4005	28060	1989-01-08	1989-01-19	1
32477	1929	40481087	1964-04-01	1964-04-08	1
40671	2419	40481087	1951-01-26	1951-02-16	1
78936	4678	4152936	1982-09-22	1982-10-06	1
25231	1506	4112343	1948-01-12	1948-01-23	1
89331	5317	4294548	2010-12-17	2011-02-18	1
62815	3714	381316	2005-09-21	2005-09-22	1
8863	520	28060	1971-07-08	1971-07-17	1
41767	2486	40481087	2005-07-04	2005-07-18	1
5753	338	28060	1979-03-05	1979-03-13	1
63853	3777	40481087	2014-11-22	2014-12-06	1
89458	5325	40481087	1963-02-04	1963-02-25	1
37811	2243	40481087	1978-12-22	1978-12-29	1
36668	2173	40481087	1963-12-27	1964-01-10	1
38868	2311	260139	1972-04-22	1972-05-06	1
88375	5258	4112343	2000-04-09	2000-04-19	1
39318	2333	255848	2010-04-03	2010-04-04	1
85537	5094	81151	1981-11-11	1981-12-16	1
32233	1917	372328	1952-05-18	1952-06-08	1
80608	4784	4113008	1998-07-09	1998-07-23	1
81418	4834	195588	2016-05-01	2016-06-21	1
6451	380	440086	1983-11-09	1984-03-21	1
83491	4967	4112343	1971-11-16	1971-11-28	1
35367	2097	40481087	1989-04-07	1989-04-14	1
12920	760	4059173	1977-06-20	1977-07-20	1
11892	703	40481087	1980-01-21	1980-01-28	1
34407	2044	40481087	1983-09-29	1983-10-13	1
87916	5234	40481087	1989-12-05	1989-12-12	1
30387	1793	260139	1955-01-06	1955-01-20	1
7464	439	80180	2013-05-08	2013-05-09	1
5151	304	260139	1965-10-31	1965-11-14	1
2035	119	4112343	1962-09-30	1962-10-08	1
41496	2469	260139	2017-02-07	2017-02-21	1
73917	4395	4283893	2010-12-31	2011-02-11	1
39891	2366	372328	1966-06-10	1966-08-22	1
30214	1786	4112343	1967-03-22	1967-03-30	1
9847	582	4027663	1993-02-23	1993-02-24	1
34708	2063	28060	1987-01-11	1987-01-24	1
89086	5306	372328	1971-01-22	1971-06-27	1
34110	2028	40481087	1954-08-04	1954-08-25	1
35533	2108	40481087	1973-03-31	1973-04-14	1
17513	1054	4112343	1972-11-30	1972-12-12	1
12728	754	4283893	2009-05-31	2010-02-28	1
14289	844	4084167	1980-05-09	1980-05-09	1
29002	1719	260139	1973-06-25	1973-07-02	1
29040	1720	260139	1991-09-26	1991-10-03	1
67950	4018	28060	1987-06-09	1987-06-17	1
34592	2056	4283893	1993-09-22	1993-10-20	1
36181	2147	40481087	1976-01-26	1976-02-16	1
86073	5127	40481087	1999-06-13	1999-07-04	1
34577	2054	260139	1973-04-16	1973-04-23	1
67690	4005	80180	2012-03-27	2012-03-28	1
32478	1929	40481087	1981-10-12	1981-10-26	1
40672	2419	40481087	1987-08-06	1987-08-27	1
78937	4678	40481087	1962-10-23	1962-11-13	1
25232	1506	4156265	1964-12-01	1964-12-15	1
89332	5317	4112343	1973-11-03	1973-11-13	1
62816	3714	4112343	1929-06-25	1929-07-03	1
8864	520	80502	2011-01-06	2011-01-07	1
43193	2576	80180	2019-04-12	2019-04-13	1
5754	338	81151	1969-02-07	1969-03-07	1
63854	3777	30753	2016-11-09	2016-11-10	1
89459	5325	40481087	2018-09-04	2018-09-11	1
37812	2243	81151	1967-01-16	1967-01-30	1
36669	2173	4112343	1976-11-21	1976-12-02	1
38869	2311	260139	1982-08-05	1982-08-12	1
88376	5258	40481087	1988-09-23	1988-09-30	1
39319	2333	381316	2007-04-03	2007-04-04	1
85538	5094	134438	1999-05-03	2000-05-28	1
32234	1917	4310024	1984-11-21	1984-11-22	1
80609	4784	40481087	2010-11-20	2010-12-04	1
81419	4834	260139	1983-09-13	1983-09-27	1
6452	380	4237458	1986-08-25	1986-10-24	1
83492	4967	4112343	1993-04-10	1993-04-22	1
35368	2097	378001	1993-12-18	1994-01-17	1
12921	760	260139	1966-11-16	1966-11-23	1
18428	1110	4112343	1994-03-14	1994-03-22	1
34408	2044	40481087	1994-05-24	1994-05-31	1
87917	5234	40481087	1990-06-16	1990-06-23	1
30388	1793	260139	1977-01-13	1977-01-20	1
7465	439	260139	1980-10-14	1980-10-21	1
5152	304	4027663	1987-04-30	1987-05-01	1
2036	119	40481087	1956-02-01	1956-02-15	1
41497	2469	40481087	1978-02-16	1978-03-09	1
73918	4395	4283893	2013-12-03	2014-02-11	1
39892	2366	4112343	2015-10-28	2015-11-04	1
30215	1786	4112343	1979-11-08	1979-11-19	1
9848	582	4059173	1961-01-22	1961-04-22	1
34709	2063	40481087	1988-01-26	1988-02-02	1
89087	5306	4218389	1997-06-19	1997-07-10	1
34111	2028	40481087	1967-01-27	1967-02-17	1
35534	2108	40481087	2004-12-05	2004-12-19	1
17514	1054	4112343	1992-01-03	1992-01-16	1
12729	754	40481087	1958-11-23	1958-12-07	1
14290	844	4112343	2008-03-01	2008-03-12	1
29003	1719	4218389	1993-02-23	1993-03-30	1
29041	1720	4283893	2011-12-08	2012-05-17	1
67951	4018	260139	1990-05-04	1990-05-11	1
34593	2056	40481087	1979-05-01	1979-05-15	1
36182	2147	40481087	2001-04-09	2001-04-23	1
86074	5127	40481087	2017-08-22	2017-08-29	1
34578	2054	260139	1987-01-11	1987-01-25	1
67691	4005	260139	1990-05-01	1990-05-08	1
32479	1929	372328	1954-09-18	1954-11-25	1
40673	2419	40481087	1990-03-22	1990-04-12	1
78938	4678	40481087	1964-03-12	1964-03-19	1
26745	1586	80180	1974-10-19	1974-10-20	1
89333	5317	4112343	2001-09-05	2001-09-13	1
62817	3714	4112343	1958-07-14	1958-07-26	1
8865	520	257012	1983-08-30	1983-10-25	1
43194	2576	372328	1981-12-11	1982-04-15	1
5755	338	260139	1974-06-13	1974-06-20	1
63855	3777	4027663	2010-04-20	2010-04-21	1
89460	5325	378419	2018-03-11	2018-03-12	1
37813	2243	260139	1980-06-11	1980-06-25	1
36670	2173	4218389	1987-07-30	1987-08-27	1
38870	2311	4112343	1960-08-31	1960-09-12	1
88377	5258	257012	1967-02-20	1967-02-21	1
39320	2333	4156265	1951-03-31	1951-04-14	1
85539	5094	4112343	2004-12-26	2005-01-07	1
32235	1917	4027663	1978-06-26	1978-06-27	1
80610	4784	40481087	2013-11-27	2013-12-04	1
81420	4834	40481087	1968-11-06	1968-11-13	1
6453	380	40481087	2016-06-28	2016-07-05	1
83493	4967	4283893	1978-09-02	1978-10-28	1
35369	2097	4112343	1986-12-15	1986-12-23	1
12922	760	4112343	1971-10-22	1971-10-31	1
18429	1110	80180	2014-11-27	2014-11-28	1
34409	2044	40481087	1999-06-24	1999-07-01	1
87918	5234	28060	1936-12-02	1936-12-15	1
30389	1793	4146173	2005-07-04	2005-09-02	1
7466	439	260139	2007-08-11	2007-08-18	1
5153	304	4112343	1966-03-29	1966-04-09	1
2037	119	40481087	1987-10-29	1987-11-19	1
41498	2469	372328	1977-04-12	1977-07-24	1
73919	4395	40481087	1970-08-06	1970-08-13	1
39893	2366	28060	1978-10-04	1978-10-11	1
30216	1786	4155034	2001-02-22	2001-03-15	1
9849	582	4112343	1971-11-09	1971-11-21	1
34710	2063	40481087	2014-07-26	2014-08-02	1
89088	5306	40481087	1973-11-12	1973-11-26	1
34112	2028	0	1977-11-27	1977-11-28	1
35535	2108	40481087	2016-04-27	2016-05-04	1
17515	1054	4112343	2002-11-20	2002-11-30	1
12730	754	257012	1992-02-20	2010-02-28	1
14291	844	4218389	2002-03-06	2002-04-10	1
29004	1719	4294548	2005-06-30	2005-07-14	1
29042	1720	40481087	2012-10-20	2012-11-03	1
67952	4018	260139	2000-06-18	2000-07-02	1
34594	2056	40481087	1988-10-02	1988-10-09	1
36183	2147	80180	1989-03-06	1989-03-07	1
86075	5127	260139	1989-06-28	1989-07-05	1
34579	2054	192671	2010-10-05	2010-10-06	1
67692	4005	372328	1975-02-20	1976-03-06	1
32480	1929	372328	1955-02-23	1955-04-28	1
41374	2463	260139	2001-02-19	2001-03-05	1
78939	4678	40481087	1971-12-14	1971-12-28	1
26746	1586	257012	1985-12-11	1985-12-12	1
89334	5317	4112343	2003-03-08	2003-03-17	1
62818	3714	4112343	1997-09-15	1997-09-26	1
8866	520	260139	1964-07-08	1964-07-15	1
43195	2576	40481087	1985-06-16	1985-07-07	1
5756	338	260139	2003-10-21	2003-11-04	1
63856	3777	40479768	1990-04-25	1990-07-01	1
89461	5325	4059173	1955-01-10	1955-02-09	1
37814	2243	4027663	1996-01-14	1996-01-15	1
36671	2173	4294548	1994-02-05	1994-02-19	1
38871	2311	40481087	1965-10-21	1965-11-11	1
88378	5258	372328	1958-11-27	1959-01-07	1
39321	2333	40481087	1931-01-01	1931-01-15	1
85540	5094	4237458	1991-09-25	1991-11-24	1
32236	1917	4266809	1987-03-11	1987-03-12	1
83409	4963	80180	2009-03-21	2009-03-22	1
82659	4913	28060	2018-03-02	2018-03-12	1
6454	380	372328	1973-03-14	1973-04-20	1
83494	4967	40481087	1961-12-30	1962-01-20	1
35370	2097	4294548	1993-06-29	1993-12-07	1
12923	760	4112343	1984-05-28	1984-06-05	1
18430	1110	81151	2019-01-14	2019-01-28	1
34410	2044	40481087	2015-05-17	2015-05-31	1
87919	5234	378419	2006-07-19	2006-07-20	1
30390	1793	4218389	1975-12-27	1976-01-24	1
7467	439	4112343	1988-03-16	1988-03-28	1
5154	304	4266809	1998-03-18	1998-03-19	1
2038	119	81151	2008-12-18	2009-01-08	1
41499	2469	378001	1986-04-19	1986-05-19	1
73920	4395	40481087	1998-03-28	1998-04-18	1
39894	2366	78272	2001-05-21	2001-06-11	1
30217	1786	40481087	2016-02-11	2016-02-18	1
9850	582	4112343	1998-05-29	1998-06-08	1
34711	2063	78272	1979-05-08	1979-06-12	1
89089	5306	40481087	1981-01-09	1981-01-30	1
34113	2028	140673	2018-11-17	2018-11-18	1
35536	2108	30753	1974-06-21	1974-06-22	1
17516	1054	4152936	1984-02-15	1984-03-07	1
12731	754	372328	1938-02-20	1938-05-03	1
14292	844	40481087	1992-01-24	1992-02-14	1
29005	1719	28060	2015-05-27	2015-06-07	1
29043	1720	257012	2012-03-08	2012-03-09	1
67953	4018	80180	2001-08-08	2001-08-09	1
34595	2056	4035415	1990-09-25	1990-10-25	1
36184	2147	81151	1955-06-14	1955-07-19	1
86076	5127	4283893	1971-06-18	1971-07-16	1
34580	2054	4048171	1974-06-30	1990-06-28	1
67693	4005	378001	1982-06-27	1982-07-27	1
32481	1929	4112343	1974-01-07	1974-01-15	1
41375	2463	439777	2008-03-31	2008-04-01	1
78940	4678	40481087	1972-03-06	1972-03-27	1
26747	1586	260139	2001-10-15	2001-10-22	1
89335	5317	4112343	2008-09-20	2008-09-27	1
62819	3714	4112343	2019-06-06	2019-06-19	1
8867	520	4109685	2001-12-15	2001-12-29	1
43196	2576	28060	1993-09-27	1993-10-06	1
5757	338	260139	2008-11-01	2008-11-15	1
63857	3777	40481087	2015-01-14	2015-01-21	1
89462	5325	4112343	1955-08-03	1955-08-14	1
37815	2243	4112343	2018-12-25	2019-01-04	1
36672	2173	40481087	1991-03-10	1991-03-17	1
38872	2311	40481087	2003-08-18	2003-09-01	1
88379	5258	372328	1960-03-02	1960-07-06	1
39322	2333	40481087	1949-09-30	1949-10-21	1
85541	5094	40481087	1982-01-19	1982-01-26	1
32237	1917	40481087	1999-09-17	1999-10-01	1
83410	4963	260139	1976-05-29	1976-06-05	1
82660	4913	260139	2017-09-23	2017-10-07	1
6455	380	40481087	1998-04-22	1998-04-29	1
85894	5117	40481087	1987-06-22	1987-07-13	1
35371	2097	80180	2014-03-21	2014-03-22	1
12924	760	4112343	1999-06-20	1999-06-30	1
18431	1110	260139	1988-10-11	1988-10-18	1
34411	2044	260139	2016-10-14	2016-10-28	1
87920	5234	4155034	1960-09-26	1960-10-10	1
30391	1793	4278672	1919-07-07	1919-09-05	1
7468	439	4112343	2008-04-01	2008-04-10	1
5155	304	4310024	1996-11-23	1996-11-24	1
2039	119	4116491	2012-02-07	2012-04-08	1
41500	2469	4112343	2016-09-24	2016-10-01	1
73921	4395	80180	1992-04-13	1992-04-14	1
39895	2366	81151	1972-03-10	1972-03-24	1
30218	1786	81151	2014-04-06	2014-04-20	1
9851	582	4142905	2016-09-10	2016-10-10	1
34712	2063	257012	1987-03-06	1987-03-07	1
89090	5306	40481087	1990-07-30	1990-08-20	1
34114	2028	4029498	1977-11-27	1977-11-28	1
35537	2108	81151	1993-05-02	1993-05-30	1
17517	1054	4266809	1973-01-25	1973-01-26	1
12732	754	372328	1939-11-24	1940-01-23	1
14293	844	40481087	2008-05-27	2008-06-10	1
29006	1719	81151	1961-09-15	1961-10-06	1
29044	1720	372328	1979-12-26	1980-03-08	1
67954	4018	40481087	1984-05-03	1984-05-24	1
34596	2056	4112343	2017-07-22	2017-07-30	1
36185	2147	4112343	1962-04-08	1962-04-18	1
86077	5127	260139	1975-12-17	1975-12-31	1
34581	2054	4112343	1999-03-14	1999-03-24	1
67694	4005	4109685	2006-11-23	2006-12-07	1
32482	1929	4112343	1998-06-19	1998-06-28	1
41376	2463	40481087	1980-06-05	1980-06-12	1
78941	4678	40481087	1986-08-17	1986-08-31	1
26748	1586	4056621	1966-05-10	1966-05-11	1
89336	5317	40481087	2018-06-18	2018-07-09	1
62820	3714	4218389	1949-07-07	1949-08-04	1
8868	520	4113008	1972-03-05	1972-03-19	1
43197	2576	260139	2018-09-05	2018-09-12	1
5758	338	378001	1987-07-31	1987-09-29	1
63858	3777	80180	2018-07-02	2018-07-03	1
89463	5325	40481087	1964-02-27	1964-03-12	1
37816	2243	40481087	1997-07-16	1997-08-06	1
36673	2173	40481087	2007-11-15	2007-12-06	1
41331	2461	4027663	1993-10-25	1993-10-26	1
88380	5258	372328	1962-11-23	1963-07-10	1
39323	2333	40481087	1966-08-21	1966-09-11	1
85542	5094	40481087	1984-10-17	1984-10-31	1
32238	1917	80180	1987-03-11	1987-03-12	1
83411	4963	378001	1975-07-03	1975-08-02	1
82661	4913	40481087	1975-09-11	1975-09-18	1
6456	380	372328	1974-02-14	1974-04-19	1
85895	5117	40481087	1990-11-02	1990-11-23	1
35372	2097	372328	1982-09-24	1983-09-24	1
12925	760	4296204	1979-05-11	1979-05-25	1
18432	1110	260139	2002-08-27	2002-09-10	1
34412	2044	4283893	1982-10-13	1983-01-26	1
87921	5234	4294548	1976-11-02	1977-01-04	1
30392	1793	4283893	1933-08-08	1933-09-19	1
7469	439	40481087	1990-01-03	1990-01-17	1
5156	304	40481087	1984-01-14	1984-01-28	1
2040	119	40481087	1973-11-30	1973-12-21	1
41501	2469	4116491	1988-07-27	1988-09-10	1
73922	4395	4059173	1949-10-26	1949-12-25	1
39896	2366	372328	1970-07-02	1970-08-24	1
30219	1786	257012	2001-04-27	2001-04-28	1
9852	582	4310024	2002-06-21	2002-06-22	1
34713	2063	4112343	1985-01-09	1985-01-18	1
89091	5306	28060	1983-12-03	1983-12-14	1
34115	2028	4112343	1966-11-30	1966-12-11	1
35538	2108	260139	1947-12-06	1947-12-20	1
17518	1054	4283893	1994-12-25	1995-05-21	1
12733	754	372328	1943-02-06	1943-08-03	1
14294	844	28060	1972-05-22	1972-05-29	1
29007	1719	260139	1959-08-28	1959-09-11	1
29045	1720	4278672	1998-03-21	1998-06-19	1
67955	4018	40481087	1986-02-22	1986-03-01	1
34597	2056	4112343	2019-02-21	2019-02-28	1
36186	2147	40481087	1978-04-12	1978-05-04	1
86078	5127	40481087	1975-04-23	1975-04-30	1
34582	2054	4278672	2019-06-26	2019-06-27	1
67695	4005	40481087	1980-03-11	1980-04-01	1
32483	1929	40481087	1962-11-11	1962-12-02	1
41377	2463	40481087	1989-06-01	1989-06-15	1
78942	4678	40481087	2014-01-05	2014-01-12	1
26749	1586	4278672	1964-03-12	1964-05-11	1
3090	183	28060	1988-07-27	1988-08-07	1
62821	3714	40481087	1994-07-03	1994-07-10	1
8869	520	40481087	1956-04-20	1956-05-11	1
43198	2576	372328	1980-10-03	1981-01-15	1
5759	338	4112343	1968-06-16	1968-06-26	1
63859	3777	81893	2016-01-14	2016-01-15	1
89464	5325	28060	2009-02-28	2009-03-08	1
37817	2243	40481087	1997-09-12	1997-09-26	1
36674	2173	28060	1938-07-21	1938-08-01	1
41332	2461	4112343	1981-12-16	1981-12-24	1
88381	5258	40481087	2007-04-14	2007-04-21	1
39324	2333	40481087	1969-03-07	1969-03-28	1
85543	5094	28060	2006-10-18	2006-10-30	1
32239	1917	81893	1985-06-19	1985-06-20	1
83412	4963	4112343	1985-02-19	1985-03-03	1
82662	4913	40481087	1987-08-19	1987-08-26	1
6457	380	4112343	2008-08-24	2008-09-04	1
85896	5117	40481087	2010-11-14	2010-11-28	1
35373	2097	40481087	2009-11-20	2009-12-04	1
12926	760	40481087	1990-08-02	1990-08-16	1
18433	1110	4112343	2003-07-07	2003-07-17	1
34413	2044	40481087	2008-11-08	2008-11-29	1
87922	5234	4296204	1972-04-15	1972-05-06	1
30393	1793	40481087	1918-09-18	1918-10-02	1
7470	439	40481087	2007-09-18	2007-10-09	1
5157	304	30753	1997-04-22	1997-04-23	1
2041	119	40481087	1974-08-27	1974-09-17	1
41502	2469	4283893	2015-12-26	2016-02-06	1
73923	4395	4134304	1960-11-27	1961-02-25	1
39897	2366	4059173	1974-12-09	1975-03-09	1
30220	1786	260139	2007-11-05	2007-11-19	1
9853	582	40481087	1989-09-27	1989-10-04	1
34714	2063	40481087	1973-11-11	1973-11-25	1
89092	5306	28060	1995-04-29	1995-05-11	1
34116	2028	4112343	1985-01-04	1985-01-15	1
35539	2108	4112343	1980-05-14	1980-05-26	1
17519	1054	40481087	1934-03-20	1934-04-10	1
12734	754	4112343	1961-10-30	1961-11-08	1
14295	844	80180	2002-09-26	2002-09-27	1
29008	1719	4027663	1985-04-02	1985-04-03	1
29046	1720	40481087	1980-11-20	1980-12-04	1
67956	4018	40481087	2011-06-05	2011-06-12	1
34598	2056	257012	1993-10-13	1993-10-14	1
36187	2147	0	2005-03-25	2005-03-26	1
87868	5233	378001	1963-08-18	1963-09-17	1
34583	2054	40481087	2012-09-25	2012-10-02	1
67696	4005	40481087	1995-10-04	1995-10-11	1
32484	1929	40481087	1985-02-16	1985-03-09	1
41378	2463	40481087	1995-02-20	1995-03-06	1
78943	4678	80180	1991-01-02	1991-01-03	1
26750	1586	40480160	2008-07-03	2008-09-01	1
3091	183	80180	2017-03-02	2017-03-03	1
62822	3714	40481087	2011-10-31	2011-11-21	1
8870	520	40481087	1997-07-21	1997-08-11	1
43199	2576	4112343	1982-04-11	1982-04-24	1
5760	338	40481087	1981-12-06	1981-12-20	1
63860	3777	257012	1996-11-23	1996-11-24	1
89465	5325	80180	1985-08-14	1985-08-15	1
37818	2243	40481087	2000-11-18	2000-12-09	1
36675	2173	28060	1998-09-09	1998-09-20	1
41333	2461	4112343	1984-04-23	1984-05-03	1
61500	3637	260139	1991-05-20	1991-05-28	1
39325	2333	40481087	1971-09-21	1971-10-12	1
85544	5094	260139	2006-06-05	2006-06-12	1
32240	1917	378001	1953-12-09	1954-01-08	1
83413	4963	4112343	1994-10-27	1994-11-05	1
82663	4913	80180	2004-05-25	2004-05-26	1
6458	380	28060	1996-07-16	1996-07-27	1
85897	5117	80180	1998-02-13	1998-02-14	1
35374	2097	40481087	2011-11-03	2011-11-24	1
12927	760	40481087	2016-05-18	2016-05-25	1
18434	1110	40481087	1988-10-08	1988-10-22	1
34414	2044	40481087	2014-09-28	2014-10-12	1
88679	5278	28060	2006-01-24	2006-02-06	1
32120	1911	372328	1950-05-17	1950-11-06	1
7471	439	378001	1992-01-14	1992-03-14	1
5158	304	81151	1968-10-01	1968-11-05	1
2042	119	372328	2015-02-15	2016-02-23	1
41503	2469	40481087	1972-01-03	1972-01-24	1
73924	4395	4230399	2013-11-08	2013-12-08	1
39898	2366	4134304	1983-06-25	1983-09-23	1
30221	1786	372328	1947-12-03	1948-02-07	1
9854	582	40481087	1996-11-05	1996-11-19	1
34715	2063	40481087	2008-01-14	2008-01-21	1
89093	5306	4283893	1970-10-19	1970-11-23	1
34117	2028	4112343	2011-05-02	2011-05-14	1
35540	2108	4112343	1995-07-08	1995-07-20	1
17520	1054	260139	1957-05-05	1957-05-19	1
12735	754	4237458	1972-09-15	1972-11-14	1
14296	844	81893	2000-07-08	2000-07-09	1
29009	1719	4051466	1961-04-15	1976-07-25	1
29047	1720	40481087	2013-03-12	2013-04-02	1
69229	4102	28060	1979-09-09	1979-09-18	1
34599	2056	372328	1987-12-10	1988-03-02	1
36188	2147	257012	2002-10-27	2002-10-28	1
87869	5233	4152936	2003-02-17	2003-03-03	1
36444	2160	80180	1998-07-22	1998-07-23	1
67697	4005	78272	1999-03-14	1999-04-04	1
32485	1929	4112343	1987-01-08	1987-01-16	1
41379	2463	78272	1978-08-21	1978-09-18	1
78944	4678	260139	2016-07-02	2016-07-16	1
26751	1586	40481087	1947-11-04	1947-11-18	1
3092	183	260139	1976-02-18	1976-02-25	1
65520	3879	0	2015-11-25	2015-11-26	1
8871	520	78272	1978-01-17	1978-02-14	1
43200	2576	4283893	1990-10-14	1990-12-09	1
5761	338	40481087	1998-11-28	1998-12-05	1
63861	3777	260139	2000-03-05	2000-03-12	1
89466	5325	81151	1970-12-17	1970-12-31	1
37819	2243	40481087	2007-08-26	2007-09-02	1
36676	2173	80180	1975-02-17	1975-02-18	1
41334	2461	4112343	1987-08-17	1987-08-24	1
61501	3637	260139	2009-01-24	2009-02-07	1
39326	2333	40481087	1992-06-12	1992-06-19	1
85545	5094	378001	1980-01-21	1980-03-21	1
32241	1917	381316	2006-06-04	2006-06-05	1
83414	4963	40481087	2010-09-20	2010-10-04	1
82664	4913	4112343	1989-11-26	1989-12-05	1
6459	380	80180	2012-06-14	2012-06-15	1
85898	5117	81893	1996-08-22	1996-08-23	1
35719	2119	80180	2001-05-23	2001-05-24	1
16310	967	260139	1987-06-16	1987-06-23	1
18435	1110	40481087	2006-09-27	2006-10-04	1
34415	2044	40481087	2018-07-19	2018-08-09	1
88680	5278	192671	2013-10-23	2013-10-24	1
32121	1911	378001	1999-01-31	1999-03-02	1
7472	439	4112343	1990-03-20	1990-04-02	1
5159	304	260139	2018-05-26	2018-06-09	1
2043	119	4059173	1967-05-28	1967-07-27	1
41504	2469	40481087	2006-09-26	2006-10-10	1
73925	4395	40481087	1953-03-17	1953-03-24	1
39899	2366	40481087	2014-02-11	2014-03-04	1
30222	1786	4237458	1986-07-11	1986-10-09	1
9855	582	40481087	2018-12-14	2018-12-21	1
34716	2063	260139	2008-04-30	2008-05-14	1
89094	5306	40481087	1978-07-08	1978-07-15	1
34118	2028	4155034	2003-09-16	2003-10-07	1
35541	2108	4266809	1975-11-13	1975-11-14	1
17521	1054	372328	1934-06-09	1934-11-23	1
12736	754	4278672	1952-07-11	1952-08-10	1
14297	844	4059173	1979-01-15	1979-03-16	1
29010	1719	4285898	1995-09-22	1995-09-23	1
29048	1720	80180	2014-05-11	2014-05-12	1
69230	4102	80180	2006-06-25	2006-06-26	1
34600	2056	40481087	1977-09-11	1977-10-02	1
36189	2147	4051466	1956-10-03	1972-01-20	1
87870	5233	4278672	1980-04-20	1980-07-19	1
36445	2160	81151	1997-09-09	1997-09-23	1
67698	4005	260139	1971-02-12	1971-02-19	1
32486	1929	4155034	1975-09-19	1975-10-10	1
41380	2463	81151	1979-10-13	1979-11-03	1
78945	4678	40481087	1980-10-16	1980-10-23	1
26752	1586	40481087	1953-09-25	1953-10-16	1
3093	183	260139	1983-01-26	1983-02-09	1
65521	3879	80502	2010-04-08	2010-04-09	1
8872	520	80180	1988-05-18	1988-05-19	1
43201	2576	40481087	1990-01-19	1990-02-09	1
5762	338	40481087	2008-04-22	2008-05-13	1
63862	3777	260139	2012-04-09	2012-04-23	1
89467	5325	260139	1991-11-22	1991-11-29	1
37820	2243	80180	2005-09-03	2005-09-04	1
36677	2173	81893	1973-11-24	1973-11-25	1
41335	2461	4278672	2006-01-19	2006-02-18	1
61502	3637	4109685	1989-03-15	1989-03-29	1
40496	2411	4112343	2008-02-12	2008-02-21	1
85546	5094	4112343	1989-10-04	1989-10-14	1
32242	1917	4112343	1953-03-15	1953-03-26	1
83415	4963	4113008	2006-02-25	2006-03-18	1
82665	4913	4112343	1995-04-10	1995-04-18	1
6460	380	260139	2009-08-25	2009-09-08	1
85899	5117	4027663	1988-03-02	1988-03-03	1
35720	2119	4112343	1962-11-20	1962-12-03	1
16311	967	260139	2011-07-09	2011-07-16	1
18436	1110	40481087	2008-07-30	2008-08-06	1
34416	2044	30753	1996-03-24	1996-03-25	1
88681	5278	40481087	1970-11-08	1970-11-22	1
32122	1911	4112343	1991-02-06	1991-02-14	1
7638	449	0	1968-10-27	1968-10-28	1
5160	304	4109685	1978-01-17	1978-02-07	1
2044	119	4112343	1956-03-29	1956-04-09	1
42985	2563	257012	1997-03-16	1997-03-17	1
73926	4395	40481087	1953-05-29	1953-06-12	1
39900	2366	260139	1982-01-18	1982-01-25	1
30223	1786	40481087	1959-11-05	1959-11-26	1
9856	582	80180	2005-02-05	2005-02-06	1
34717	2063	260139	2018-08-06	2018-08-13	1
89095	5306	40481087	1987-11-16	1987-12-07	1
34119	2028	4294548	1968-03-18	1968-04-08	1
35542	2108	4278672	1961-07-19	1961-10-17	1
17522	1054	378001	1988-01-07	1988-03-07	1
12737	754	4294548	1991-12-19	1992-05-21	1
14298	844	4152936	1995-04-21	1995-05-12	1
29011	1719	4310024	1994-11-26	1994-11-27	1
29049	1720	372328	1981-06-01	1981-11-21	1
69231	4102	80809	1997-03-14	2001-12-18	1
34601	2056	40481087	2010-08-01	2010-08-22	1
36190	2147	4112343	1989-10-03	1989-10-13	1
87871	5233	40481087	1964-03-03	1964-03-17	1
36446	2160	81151	2009-09-11	2009-10-09	1
67699	4005	4112343	2009-07-06	2009-07-13	1
32487	1929	372328	1957-08-15	1958-01-23	1
41381	2463	372328	1972-03-14	1972-09-14	1
78946	4678	81151	1957-08-13	1957-09-03	1
26753	1586	40481087	1979-11-11	1979-12-02	1
3094	183	440086	1982-10-22	1984-03-16	1
65522	3879	134438	1965-12-14	1967-03-11	1
8873	520	81151	1951-11-04	1951-11-18	1
43202	2576	40481087	1996-12-13	1996-12-20	1
5763	338	40486433	1971-04-25	1986-04-23	1
63863	3777	4152936	1992-04-21	1992-05-05	1
89468	5325	372328	1946-06-05	1946-09-15	1
37821	2243	81893	2004-09-08	2004-09-09	1
36678	2173	192671	1975-04-22	1975-04-23	1
41336	2461	4310024	2000-04-21	2000-04-22	1
61770	3651	78272	1975-07-04	1975-07-25	1
40497	2411	375671	1981-07-03	1981-08-02	1
85547	5094	4112343	1990-04-15	1990-04-28	1
32243	1917	40481087	1955-04-10	1955-04-17	1
83416	4963	28060	1986-08-26	1986-09-07	1
82666	4913	257012	1973-02-08	1973-02-09	1
6461	380	260139	2013-07-12	2013-07-26	1
85900	5117	4112343	1967-09-23	1967-10-06	1
35721	2119	4112343	1982-10-21	1982-11-03	1
16312	967	40481087	1940-12-11	1940-12-25	1
18437	1110	40481087	2016-08-31	2016-09-21	1
34417	2044	257012	1982-12-29	1982-12-30	1
88682	5278	80180	2013-10-15	2013-10-16	1
32123	1911	4112343	1996-06-20	1996-06-27	1
7639	449	80180	1993-08-11	1993-08-12	1
5161	304	4294548	1964-05-24	1964-06-14	1
2045	119	4112343	1991-02-10	1991-02-17	1
42986	2563	4112343	1998-04-21	1998-05-04	1
73927	4395	40481087	1965-11-02	1965-11-23	1
39901	2366	4112343	1967-06-09	1967-06-20	1
30224	1786	40481087	1969-12-31	1970-01-07	1
9857	582	260139	1973-09-17	1973-10-01	1
34718	2063	4112343	2017-07-27	2017-08-03	1
89096	5306	40481087	2006-05-04	2006-05-11	1
34120	2028	80180	1987-02-08	1987-02-09	1
35543	2108	4285898	1975-03-18	1975-03-19	1
17523	1054	4109685	2012-03-01	2012-03-15	1
12738	754	40481087	1939-08-23	1939-09-13	1
14299	844	40481087	1980-05-25	1980-06-01	1
29012	1719	260139	1973-03-18	1973-03-25	1
29050	1720	4109685	2009-12-23	2010-01-06	1
69232	4102	192671	2006-08-10	2006-08-11	1
36699	2174	260139	2000-08-02	2000-08-09	1
36191	2147	4294548	2002-10-13	2002-12-14	1
87872	5233	40481087	2018-08-21	2018-08-28	1
36447	2160	192671	1998-09-23	1998-09-24	1
67700	4005	28060	2013-09-08	2013-09-19	1
32488	1929	4283893	1974-04-22	1974-05-13	1
41382	2463	372328	1975-04-02	1976-04-01	1
78947	4678	4112343	1956-01-25	1956-02-06	1
26754	1586	40481087	1988-04-26	1988-05-03	1
3095	183	4112343	1975-11-22	1975-12-02	1
65523	3879	257012	1942-02-04	1942-02-05	1
8874	520	260139	1958-03-04	1958-03-11	1
43203	2576	40481087	2003-02-22	2003-03-01	1
10806	642	260139	1985-06-08	1985-06-22	1
63864	3777	4283893	1996-07-27	1996-11-30	1
89469	5325	4283893	1996-08-03	1996-12-21	1
37822	2243	192671	2005-10-16	2005-10-17	1
36679	2173	257012	1966-06-04	1966-06-05	1
41337	2461	40481087	1979-03-03	1979-03-17	1
61771	3651	4112343	2014-01-31	2014-02-10	1
40498	2411	4112343	1987-07-04	1987-07-17	1
85548	5094	4112343	2006-01-06	2006-01-19	1
32587	1937	260139	2015-04-06	2015-04-13	1
83417	4963	28060	2010-08-31	2010-09-07	1
82667	4913	4112343	2007-04-18	2007-04-26	1
6462	380	4112343	1996-06-04	1996-06-14	1
85901	5117	4112343	1983-08-17	1983-08-29	1
35722	2119	4112343	1984-05-30	1984-06-10	1
16313	967	40481087	1955-10-17	1955-11-07	1
18438	1110	260139	2010-09-10	2010-09-24	1
34418	2044	375671	1985-08-09	1985-10-08	1
88683	5278	4112343	1984-05-24	1984-06-06	1
32124	1911	40481087	1953-06-19	1953-07-03	1
7640	449	260139	1981-07-23	1981-08-06	1
5162	304	4294548	1967-07-08	1967-08-12	1
2046	119	40481087	1968-04-07	1968-04-21	1
42987	2563	4152936	2000-03-06	2000-03-27	1
73928	4395	40481087	1988-08-13	1988-08-20	1
39902	2366	40481087	1970-03-27	1970-04-03	1
30225	1786	40481087	1983-05-22	1983-05-29	1
9858	582	372328	1959-07-02	1959-08-12	1
34719	2063	40481087	2013-01-03	2013-01-24	1
89097	5306	81151	1990-08-27	1990-09-24	1
34121	2028	260139	1967-04-02	1967-04-16	1
35544	2108	40481087	2010-03-01	2010-03-22	1
17524	1054	4310024	1971-01-06	1971-01-07	1
12739	754	40481087	1944-11-04	1944-11-18	1
14300	844	40481087	1989-06-19	1989-07-03	1
29013	1719	372328	1958-02-03	1958-03-18	1
30754	1821	440086	1947-07-02	1955-07-10	1
69233	4102	4155034	1977-11-12	1977-12-03	1
36700	2174	40481087	1994-03-05	1994-03-12	1
36192	2147	40481087	1996-10-31	1996-11-21	1
87873	5233	80180	1998-06-25	1998-06-26	1
36448	2160	195588	1993-07-03	1993-08-12	1
67701	4005	4112343	1978-12-04	1978-12-12	1
32489	1929	40481087	1989-07-23	1989-08-06	1
41383	2463	4112343	1975-10-08	1975-10-17	1
78948	4678	40481087	1990-08-16	1990-08-30	1
26755	1586	80502	1999-10-17	1999-10-18	1
3096	183	4134304	1981-05-04	1981-08-02	1
65524	3879	260139	1996-10-13	1996-10-20	1
8875	520	260139	1975-06-30	1975-07-07	1
43204	2576	4112343	1997-03-22	1997-04-01	1
10807	642	381316	2017-10-08	2017-10-09	1
63865	3777	4310024	2015-05-19	2015-05-20	1
89470	5325	40481087	1967-06-03	1967-06-24	1
37823	2243	260139	1982-07-23	1982-08-06	1
36680	2173	260139	1959-08-07	1959-08-14	1
41338	2461	40481087	1988-08-04	1988-08-11	1
61772	3651	40481087	1975-03-17	1975-03-31	1
40499	2411	4112343	1995-12-05	1995-12-15	1
85549	5094	4218389	2000-12-06	2001-01-03	1
32588	1937	4152936	1969-12-08	1969-12-22	1
83418	4963	260139	1980-10-29	1980-11-05	1
82668	4913	40481087	1986-02-28	1986-03-21	1
6463	380	40481087	1985-08-06	1985-08-20	1
85902	5117	4237458	1988-03-16	1988-06-14	1
35723	2119	4155034	1992-05-05	1992-05-19	1
16314	967	40481087	1974-09-07	1974-09-14	1
18439	1110	40481087	1984-10-06	1984-10-20	1
34419	2044	4027663	1986-10-08	1986-10-09	1
88684	5278	40481087	1972-08-18	1972-08-25	1
32125	1911	40481087	1962-03-24	1962-04-14	1
7641	449	440448	1968-10-27	1968-10-28	1
5163	304	40479422	2017-12-07	2018-01-13	1
2047	119	40481087	1976-05-18	1976-05-25	1
42988	2563	4283893	1997-02-16	1997-07-13	1
73929	4395	40481087	1994-09-25	1994-10-09	1
39903	2366	40481087	1989-04-02	1989-04-16	1
33159	1971	81151	1981-08-08	1981-08-22	1
9859	582	378001	2009-03-21	2009-04-20	1
34720	2063	80180	2014-05-19	2014-05-20	1
89098	5306	372328	1969-03-20	1969-04-27	1
34122	2028	260139	2007-01-12	2007-01-19	1
35545	2108	0	1978-08-31	1978-09-01	1
17525	1054	40481087	1944-01-23	1944-02-13	1
12740	754	80180	1973-08-05	1973-08-06	1
14301	844	40481087	2017-03-30	2017-04-20	1
29014	1719	372328	1959-06-11	1959-09-15	1
30755	1821	4112343	1954-09-30	1954-10-08	1
69234	4102	4156265	1972-02-14	1972-03-06	1
36701	2174	40481087	2013-03-21	2013-04-04	1
36193	2147	40481087	2002-08-22	2002-09-05	1
87874	5233	81151	1993-09-09	1993-10-07	1
36449	2160	372328	1962-03-03	1962-06-18	1
67702	4005	4112343	1979-05-15	1979-05-28	1
32490	1929	40481087	1995-12-09	1995-12-16	1
41384	2463	28060	2004-05-30	2004-06-10	1
78949	4678	260139	1973-01-23	1973-02-06	1
26756	1586	195588	1966-03-05	1966-04-19	1
3097	183	4155034	1975-10-19	1975-11-02	1
65525	3879	40481087	1961-02-08	1961-03-01	1
8876	520	260139	1983-06-21	1983-06-28	1
43205	2576	4152936	2015-04-24	2015-05-15	1
10808	642	4112343	2017-06-26	2017-07-06	1
63866	3777	4112343	2004-11-10	2004-11-18	1
55037	3260	40481087	2000-03-26	2000-04-16	1
37824	2243	4112343	1993-01-25	1993-02-07	1
36681	2173	260139	1997-02-27	1997-03-06	1
41339	2461	40481087	1993-08-21	1993-08-28	1
61773	3651	4112343	2005-06-06	2005-06-15	1
40500	2411	40481087	1967-09-22	1967-10-06	1
86710	5168	28060	2000-04-20	2000-05-01	1
32589	1937	4283893	2006-05-21	2006-07-30	1
83419	4963	372328	1980-01-08	1980-05-05	1
82669	4913	40481087	2010-01-21	2010-01-28	1
8325	486	4056621	1997-01-05	1997-01-06	1
85903	5117	4280726	1960-03-16	1977-03-14	1
35724	2119	4156265	2018-12-13	2019-01-03	1
16315	967	40481087	1992-12-05	1992-12-26	1
18440	1110	40481087	1991-10-15	1991-10-22	1
34420	2044	40481087	1962-12-14	1962-12-21	1
88685	5278	4051466	1973-05-15	1988-08-30	1
32126	1911	40481087	1976-10-04	1976-10-25	1
7642	449	4112343	1980-09-09	1980-09-21	1
5164	304	40481087	1957-06-07	1957-06-21	1
2048	119	40481087	2000-01-23	2000-02-13	1
42989	2563	80180	2009-01-22	2009-01-23	1
73930	4395	40481087	2010-07-11	2010-07-25	1
41442	2468	28060	1970-07-07	1970-07-15	1
33160	1971	260139	1993-07-04	1993-07-11	1
9860	582	4112343	1966-08-26	1966-09-04	1
34721	2063	260139	1984-11-08	1984-11-22	1
89099	5306	40481087	1985-01-15	1985-01-22	1
34123	2028	378001	1970-04-28	1970-05-28	1
35546	2108	80180	1975-11-13	1975-11-14	1
17526	1054	40481087	1955-08-12	1955-09-02	1
12741	754	375671	1968-02-18	1968-04-18	1
14302	844	260139	1989-04-02	1989-04-16	1
29015	1719	4112343	1985-12-23	1986-01-02	1
30756	1821	4112343	1959-10-13	1959-10-23	1
69235	4102	4294548	2007-09-22	2007-12-22	1
36702	2174	260139	1991-06-03	1991-06-17	1
36968	2191	4112343	1971-12-13	1971-12-23	1
87875	5233	260139	2012-02-12	2012-02-26	1
36450	2160	372328	1963-07-13	1963-12-16	1
67703	4005	4112343	2013-04-27	2013-05-10	1
35902	2131	81151	2003-06-10	2003-07-01	1
41385	2463	80180	2006-07-20	2006-07-21	1
78950	4678	260139	1974-01-06	1974-01-13	1
26757	1586	260139	1972-07-10	1972-07-24	1
3098	183	4294548	2009-09-07	2009-09-28	1
65526	3879	40481087	1986-05-10	1986-05-31	1
8877	520	4112343	1961-02-16	1961-02-28	1
43206	2576	78272	2017-04-04	2017-04-18	1
10809	642	4152936	1967-07-31	1967-08-21	1
63867	3777	4296205	2005-01-27	2005-02-24	1
55038	3260	260139	1989-10-07	1989-10-21	1
37825	2243	4266809	2005-09-03	2005-09-04	1
36682	2173	4059173	1940-10-13	1940-11-12	1
41340	2461	4112343	1984-03-15	1984-03-22	1
61774	3651	28060	1985-02-23	1985-03-06	1
40501	2411	40481087	1984-10-12	1984-11-02	1
86711	5168	81151	2011-05-27	2011-06-17	1
32590	1937	40481087	1967-07-27	1967-08-17	1
83420	4963	4112343	1982-08-25	1982-09-02	1
82670	4913	81151	2002-06-04	2002-07-09	1
8326	486	40481087	2009-09-04	2009-09-18	1
85904	5117	40481087	1983-10-14	1983-11-04	1
35725	2119	4296205	1980-04-03	1980-05-08	1
16316	967	40481087	2016-08-24	2016-08-31	1
18441	1110	40481087	2001-05-29	2001-06-19	1
34421	2044	40481087	2010-02-28	2010-03-14	1
88686	5278	4112343	1997-09-27	1997-10-06	1
32127	1911	40481087	1991-06-07	1991-06-28	1
7643	449	4116491	1996-10-19	1996-12-08	1
5165	304	40481087	1982-03-03	1982-03-17	1
2049	119	40481087	2010-04-24	2010-05-15	1
42990	2563	260139	1991-02-12	1991-02-26	1
73931	4395	40481087	2018-09-27	2018-10-18	1
41443	2468	80180	1976-01-21	1976-01-22	1
33161	1971	372328	1973-01-15	1973-02-16	1
9861	582	4112343	1971-12-23	1972-01-03	1
34722	2063	4112343	1987-12-21	1987-12-28	1
89100	5306	80180	2013-01-23	2013-01-24	1
34124	2028	4112343	1971-10-19	1971-10-26	1
35547	2108	81893	1973-08-25	1973-08-26	1
17527	1054	40481087	1964-01-25	1964-02-15	1
12742	754	4109685	1970-01-08	1970-01-29	1
14303	844	372328	1967-12-14	1968-02-24	1
29016	1719	4112343	2010-01-28	2010-02-07	1
30757	1821	4112343	1966-05-03	1966-05-13	1
69236	4102	40479422	1997-09-19	1997-10-26	1
36703	2174	372328	1974-12-27	1975-03-09	1
36969	2191	40481087	1972-09-13	1972-10-04	1
87876	5233	378001	1966-08-02	1966-09-01	1
36451	2160	4027663	1991-07-04	1991-07-05	1
67704	4005	4152936	1992-09-02	1992-09-16	1
35903	2131	4109685	1978-10-14	1978-10-28	1
41386	2463	81151	2009-12-25	2010-01-29	1
78951	4678	4112343	1970-08-03	1970-08-12	1
26758	1586	260139	1997-02-26	1997-03-05	1
3099	183	40481087	1992-11-12	1992-11-26	1
65527	3879	80180	1981-03-23	1981-03-24	1
8878	520	4113008	1953-12-07	1953-12-28	1
43207	2576	257012	1990-11-11	1990-11-12	1
10810	642	40481087	1955-06-09	1955-06-16	1
63868	3777	40481087	2001-03-14	2001-03-28	1
55039	3260	260139	1994-03-31	1994-04-14	1
37826	2243	30753	2004-10-08	2004-10-09	1
36683	2173	4059173	1942-08-04	1942-11-02	1
41341	2461	4112343	1994-02-22	1994-03-07	1
61775	3651	80180	1995-10-07	1995-10-08	1
40502	2411	260139	2014-11-09	2014-11-16	1
86712	5168	372328	1973-04-27	1973-08-03	1
32591	1937	40481087	1972-04-27	1972-05-04	1
83421	4963	4112343	2001-10-03	2001-10-15	1
82671	4913	260139	1979-05-24	1979-05-31	1
8327	486	40481087	2010-01-23	2010-02-13	1
85905	5117	40481087	1997-01-28	1997-02-18	1
35726	2119	40481087	1965-05-01	1965-05-08	1
16317	967	30753	1972-09-30	1972-10-01	1
18442	1110	257012	1998-07-08	1998-07-09	1
37891	2250	80180	1995-03-18	1995-03-19	1
88687	5278	4278672	1984-12-16	1985-02-14	1
32128	1911	40481087	2002-08-06	2002-08-20	1
7644	449	257012	2000-02-08	2000-02-09	1
5166	304	40481087	1997-12-24	1998-01-14	1
2050	119	4283893	2018-03-12	2018-04-09	1
42991	2563	4059173	1979-01-12	1979-04-12	1
73932	4395	28060	1981-12-17	1981-12-27	1
41444	2468	260139	1963-04-29	1963-05-06	1
33162	1971	372328	1974-04-23	1975-02-28	1
9862	582	4266809	2005-02-05	2005-02-06	1
34723	2063	4283893	1987-01-23	1987-03-27	1
89101	5306	81151	2003-08-08	2003-09-12	1
34125	2028	4112343	1995-12-22	1996-01-04	1
35548	2108	260139	1946-10-03	1946-10-10	1
17528	1054	40481087	1987-03-22	1987-04-12	1
12743	754	4112343	1969-04-02	1969-04-14	1
14304	844	378001	1967-04-18	1967-06-17	1
29017	1719	40481087	1979-06-19	1979-07-03	1
30758	1821	260139	1939-11-22	1939-12-06	1
69237	4102	260139	1974-08-11	1974-08-25	1
36704	2174	4294548	1990-12-08	1991-04-13	1
36970	2191	28060	1985-02-07	1985-02-18	1
87877	5233	4112343	2001-02-07	2001-02-17	1
36452	2160	4056621	1993-09-16	1993-09-17	1
67705	4005	4156265	1971-05-12	1971-05-26	1
35904	2131	78272	1962-06-19	1962-07-10	1
41387	2463	260139	1999-01-04	1999-01-18	1
78952	4678	4112343	2015-06-06	2015-06-19	1
26759	1586	4059173	2008-07-03	2008-09-01	1
3100	183	372328	1978-08-04	1978-09-28	1
65528	3879	81151	1951-02-01	1951-03-08	1
8879	520	78272	1965-09-26	1965-10-17	1
43208	2576	260139	2002-12-09	2002-12-16	1
10811	642	40481087	1960-01-27	1960-02-10	1
63869	3777	40481087	2010-12-15	2011-01-05	1
55040	3260	378001	2005-07-20	2005-09-18	1
37827	2243	260139	1977-08-22	1977-09-05	1
36684	2173	4152936	1960-03-02	1960-03-23	1
41342	2461	40481087	2013-01-17	2013-01-24	1
61776	3651	257012	1998-09-14	1998-09-15	1
40503	2411	372328	1965-05-28	1965-09-09	1
86713	5168	4112343	2014-02-20	2014-02-28	1
32592	1937	4116491	2004-05-03	2004-06-16	1
83422	4963	4112343	2017-08-03	2017-08-13	1
82672	4913	260139	1995-12-17	1995-12-31	1
8328	486	4112343	1982-08-27	1982-09-09	1
85906	5117	30753	1997-06-18	1997-06-19	1
35727	2119	40481087	2014-05-29	2014-06-19	1
16318	967	260139	1939-01-14	1939-01-28	1
18443	1110	4084167	1983-04-09	1983-04-09	1
37892	2250	4112343	1994-07-17	1994-07-30	1
88688	5278	4283893	2008-01-03	2008-01-24	1
32129	1911	28060	1948-03-17	1948-03-29	1
7645	449	260139	1975-02-09	1975-02-23	1
5167	304	40481087	2003-11-19	2003-12-10	1
2051	119	40481087	1960-08-27	1960-09-10	1
42992	2563	4294548	1980-08-25	1980-09-15	1
73933	4395	4112343	2010-05-30	2010-06-11	1
41445	2468	260139	2016-10-07	2016-10-21	1
33163	1971	4084167	1979-11-17	1979-11-17	1
11542	682	80180	2008-06-26	2008-06-27	1
34724	2063	40481087	1993-01-12	1993-01-26	1
89102	5306	372328	1973-05-17	1973-12-30	1
34126	2028	4134304	1997-11-16	1998-01-15	1
35549	2108	4027663	1967-09-01	1967-09-02	1
17529	1054	81151	1973-04-29	1973-05-13	1
12744	754	4116491	1989-08-11	1989-09-30	1
14305	844	4266809	2002-09-26	2002-09-27	1
29018	1719	40481087	2001-06-05	2001-06-12	1
30759	1821	4112343	1972-12-22	1973-01-04	1
69238	4102	4112343	1973-04-25	1973-05-02	1
36705	2174	40481087	1978-03-16	1978-04-06	1
36971	2191	81893	2010-04-04	2010-04-05	1
87878	5233	4112343	2018-06-08	2018-06-21	1
36453	2160	4109685	1982-09-14	1982-09-28	1
67706	4005	40481087	1971-08-16	1971-08-23	1
35905	2131	80180	1986-12-04	1986-12-05	1
41388	2463	372328	1971-06-29	1971-09-16	1
78953	4678	40481087	1975-06-15	1975-07-06	1
26760	1586	4152936	1961-04-13	1961-04-27	1
3101	183	0	1986-10-22	1986-10-23	1
65529	3879	192671	1981-05-08	1981-05-09	1
8880	520	4113008	1969-04-29	1969-05-20	1
43209	2576	4112343	1982-01-28	1982-02-08	1
10812	642	40481087	1967-01-09	1967-01-16	1
67194	3976	260139	1985-10-29	1985-11-05	1
55041	3260	4266809	1998-06-07	1998-06-08	1
37828	2243	260139	1978-12-08	1978-12-22	1
36685	2173	4283893	1966-05-07	1966-07-16	1
41343	2461	260139	2010-04-04	2010-04-11	1
61777	3651	4283893	1998-07-27	1998-09-21	1
40504	2411	4112343	2017-11-04	2017-11-12	1
86714	5168	40481087	2015-11-21	2015-12-05	1
32593	1937	40479422	1977-07-13	1977-09-18	1
83423	4963	40481087	2008-06-18	2008-06-25	1
82673	4913	4059173	1981-04-25	1981-07-24	1
8329	486	4146173	2008-06-24	2008-08-23	1
85907	5117	257012	1972-06-13	1972-06-14	1
35728	2119	4112343	1988-01-25	1988-02-07	1
16319	967	260139	1994-02-18	1994-03-04	1
18444	1110	4156265	2009-08-20	2009-09-03	1
37893	2250	40481087	2008-10-24	2008-11-14	1
88689	5278	40481087	1990-04-29	1990-05-13	1
32130	1911	260139	1957-06-28	1957-07-05	1
7646	449	261325	1991-08-29	1991-08-30	1
5168	304	28060	2018-12-27	2019-01-03	1
2052	119	40481087	1980-08-09	1980-08-30	1
42993	2563	40481087	1985-03-28	1985-04-11	1
73934	4395	4237458	1963-03-17	1963-04-16	1
41446	2468	372328	1943-05-14	1944-03-26	1
33164	1971	4112343	1980-03-03	1980-03-13	1
11543	682	260139	1982-02-20	1982-03-06	1
39677	2352	0	1970-10-26	1970-10-27	1
89103	5306	378001	1983-03-07	1983-05-06	1
34127	2028	40481087	1950-10-05	1950-10-19	1
35550	2108	4112343	1948-03-28	1948-04-05	1
17530	1054	257012	1995-02-26	1995-02-27	1
12745	754	40481087	1970-07-12	1970-08-02	1
14306	844	40481087	1978-10-20	1978-11-10	1
29019	1719	40481087	2014-03-07	2014-03-21	1
30760	1821	4112343	1983-02-12	1983-02-20	1
69239	4102	4237458	1981-08-14	1981-11-12	1
36706	2174	40481087	1995-03-15	1995-03-29	1
36972	2191	260139	1981-04-23	1981-05-07	1
87879	5233	260139	1956-11-18	1956-12-02	1
36454	2160	4112343	1994-01-24	1994-02-04	1
68427	4051	78272	1993-10-08	1993-10-29	1
35906	2131	260139	1955-12-03	1955-12-10	1
41389	2463	4112343	2011-06-05	2011-06-18	1
78954	4678	40481087	1985-05-09	1985-05-16	1
26761	1586	4294548	1985-11-06	1986-05-28	1
3102	183	28060	1996-11-26	1996-12-07	1
65530	3879	195588	1966-12-07	1967-01-16	1
8881	520	4116491	1974-11-03	1974-12-24	1
43210	2576	4155034	1993-10-25	1993-11-15	1
10813	642	78272	1993-10-01	1993-10-15	1
67195	3976	4027663	1997-04-09	1997-04-10	1
55042	3260	40481087	1976-02-26	1976-03-18	1
37829	2243	260139	1984-12-29	1985-01-05	1
36686	2173	4294548	1953-07-12	1953-09-20	1
41344	2461	4112343	1996-03-29	1996-04-11	1
61778	3651	40481087	1969-07-28	1969-08-11	1
40505	2411	4156265	1999-10-02	1999-10-23	1
86715	5168	40481087	2016-12-06	2016-12-27	1
32594	1937	40481087	1989-04-12	1989-04-26	1
83424	4963	40481087	2011-06-06	2011-06-13	1
82674	4913	4109685	1976-12-03	1976-12-17	1
8330	486	4285898	1998-11-14	1998-11-15	1
85908	5117	4294548	2002-05-30	2002-09-19	1
35729	2119	4112343	1989-06-04	1989-06-13	1
16320	967	4001336	1952-11-29	1952-12-29	1
18445	1110	4278672	1992-10-18	1992-12-17	1
37894	2250	260139	1973-02-11	1973-02-18	1
88690	5278	40481087	1999-07-03	1999-07-10	1
32131	1911	4112343	1953-02-05	1953-02-16	1
7647	449	372328	1976-03-03	1977-03-10	1
5169	304	260139	2003-09-03	2003-09-10	1
2053	119	40481087	1991-04-11	1991-05-02	1
42994	2563	260139	1983-04-16	1983-04-23	1
73935	4395	40481087	1948-06-11	1948-07-02	1
41447	2468	40481087	1975-06-15	1975-06-29	1
33165	1971	40481087	1994-10-23	1994-10-30	1
11544	682	40481087	2015-10-27	2015-11-03	1
39678	2352	133834	1973-07-19	1973-07-20	1
89104	5306	439777	1989-01-14	1989-01-15	1
34128	2028	40481087	1995-12-20	1996-01-10	1
35551	2108	4218389	1949-11-14	1949-12-19	1
17531	1054	260139	1939-08-13	1939-08-27	1
12746	754	40481087	1974-12-15	1974-12-29	1
17104	1024	260139	1971-03-15	1971-03-29	1
29020	1719	80180	1996-05-19	1996-05-20	1
30761	1821	4152936	1955-09-19	1955-10-10	1
69240	4102	40481087	1974-12-09	1974-12-23	1
36707	2174	40481087	1996-06-26	1996-07-10	1
36973	2191	4027663	2004-04-10	2004-04-11	1
87880	5233	4112343	2012-07-23	2012-08-05	1
36455	2160	4112343	2003-03-20	2003-03-31	1
68428	4051	81151	1982-05-04	1982-06-08	1
35907	2131	260139	1959-06-20	1959-06-27	1
41390	2463	4134304	1970-03-06	1970-06-04	1
81320	4828	4112343	1989-06-06	1989-06-19	1
26762	1586	260139	1966-05-14	1966-05-21	1
3103	183	440448	1986-10-22	1986-10-23	1
65531	3879	4218389	1941-11-03	1941-12-01	1
8882	520	4294548	1983-08-02	1983-10-25	1
43211	2576	40481087	2009-02-06	2009-02-20	1
10814	642	260139	1950-06-06	1950-06-13	1
67196	3976	4059173	1969-01-16	1969-02-15	1
56459	3353	81151	1954-03-16	1954-04-20	1
37830	2243	4112343	1967-08-16	1967-08-28	1
36687	2173	40481087	1974-11-21	1974-12-05	1
41345	2461	40481087	2014-08-26	2014-09-02	1
61779	3651	40481087	1991-08-11	1991-08-25	1
40506	2411	4285898	2001-03-15	2001-03-16	1
86716	5168	260139	1979-08-03	1979-08-10	1
32595	1937	195588	2009-06-15	2009-07-19	1
83425	4963	81151	1981-12-28	1982-02-01	1
82675	4913	4294548	1972-11-02	1973-05-17	1
8331	486	4310024	1997-08-21	1997-08-22	1
85909	5117	4310024	1995-11-26	1995-11-27	1
35730	2119	40481087	1991-04-22	1991-05-06	1
16321	967	4027663	1962-10-08	1962-10-09	1
18446	1110	4283893	1998-05-27	1998-08-05	1
37895	2250	372328	1960-10-12	1961-05-31	1
88691	5278	40481087	2010-05-20	2010-06-10	1
32132	1911	28060	1960-01-13	1960-01-23	1
7648	449	40481087	1992-11-29	1992-12-20	1
5170	304	4142905	1957-04-02	1957-07-01	1
2054	119	40481087	2000-03-19	2000-04-09	1
42995	2563	4112343	1972-10-11	1972-10-22	1
73936	4395	40481087	1961-08-06	1961-08-20	1
41448	2468	40481087	1986-12-27	1987-01-03	1
33166	1971	30753	2011-01-23	2011-01-24	1
11545	682	78272	1972-10-08	1972-11-05	1
39679	2352	4112343	2014-05-16	2014-05-24	1
89105	5306	4112343	1992-10-29	1992-11-06	1
34129	2028	40481087	2004-08-03	2004-08-24	1
35552	2108	40481087	1940-06-09	1940-06-16	1
17532	1054	372328	1999-11-12	2000-08-04	1
12747	754	40481087	2019-06-20	2019-06-21	1
17105	1024	260139	1992-02-10	1992-02-24	1
29021	1719	80502	2017-06-13	2017-06-14	1
30762	1821	4155034	1963-04-01	1963-04-22	1
69241	4102	40481087	1996-06-21	1996-07-12	1
36708	2174	80180	2012-02-06	2012-02-07	1
36974	2191	4112343	1979-01-16	1979-01-23	1
87881	5233	40481087	1990-08-22	1990-09-12	1
36456	2160	4116491	1993-09-16	1993-11-10	1
68429	4051	40481087	1998-01-29	1998-02-12	1
35908	2131	40481087	1977-02-10	1977-02-24	1
41391	2463	40481087	2005-05-21	2005-06-04	1
81321	4828	4112343	2017-11-21	2017-12-02	1
26763	1586	372328	1953-04-27	1954-04-18	1
3104	183	40481087	2006-07-11	2006-07-18	1
65532	3879	4230399	2003-06-03	2003-08-02	1
8883	520	40481087	1969-10-06	1969-10-27	1
44698	2662	4156265	2000-09-29	2000-10-13	1
10815	642	260139	1995-12-03	1995-12-10	1
67197	3976	4112343	1964-04-13	1964-04-21	1
56460	3353	260139	1976-11-01	1976-11-08	1
37831	2243	4113008	1968-01-25	1968-02-08	1
36688	2173	40481087	2007-03-31	2007-04-14	1
41346	2461	80180	2003-03-07	2003-03-08	1
61780	3651	260139	1992-01-07	1992-01-21	1
40507	2411	4310024	1999-10-22	1999-10-23	1
86717	5168	260139	2009-08-04	2009-08-11	1
32596	1937	260139	1980-12-12	1980-12-26	1
83426	4963	192671	2009-05-25	2009-05-26	1
82676	4913	40481087	1988-11-26	1988-12-03	1
8332	486	40481087	1988-10-12	1988-10-26	1
85910	5117	40481087	1964-07-14	1964-07-21	1
35731	2119	260139	1976-04-25	1976-05-02	1
16322	967	4112343	1990-11-04	1990-11-14	1
20389	1228	260139	1989-03-06	1989-03-20	1
37896	2250	4112343	2013-10-19	2013-10-29	1
88692	5278	260139	1981-06-07	1981-06-14	1
32133	1911	28060	1989-08-02	1989-08-11	1
7649	449	40481087	1994-09-20	1994-09-27	1
5171	304	4283893	1974-06-25	1974-11-05	1
2641	155	80180	1990-09-20	1990-09-21	1
42996	2563	4112343	1988-01-04	1988-01-11	1
76269	4529	4112343	2017-10-28	2017-11-05	1
41449	2468	40481087	1997-01-13	1997-02-03	1
33167	1971	81893	2010-07-27	2010-07-28	1
11546	682	4109685	1983-04-12	1983-04-26	1
39680	2352	4285898	2011-09-06	2011-09-07	1
89106	5306	4296205	2013-01-22	2013-02-19	1
34130	2028	260139	1959-03-29	1959-04-12	1
35553	2108	40481087	1945-12-23	1946-01-06	1
17533	1054	378419	2007-09-14	2007-09-15	1
12748	754	40486433	1942-08-30	1993-07-13	1
17106	1024	317576	2016-05-29	2016-05-30	1
29022	1719	260139	1961-03-05	1961-03-19	1
30763	1821	40481087	1943-07-09	1943-07-23	1
69242	4102	4112343	1973-11-29	1973-12-07	1
36709	2174	257012	1991-01-19	1991-01-20	1
36975	2191	4112343	1984-01-29	1984-02-10	1
87882	5233	81151	1958-10-08	1958-11-12	1
36457	2160	40479422	2012-06-25	2012-08-31	1
68430	4051	40481087	2018-12-24	2019-01-07	1
35909	2131	378001	2012-01-15	2012-02-14	1
41392	2463	378001	1994-08-16	1994-10-15	1
81322	4828	4152936	2000-11-02	2000-11-23	1
26764	1586	4112343	1978-10-23	1978-11-01	1
3105	183	372328	1979-02-25	1979-10-04	1
65533	3879	4283893	1942-01-07	1942-02-11	1
8884	520	40481087	1970-02-03	1970-02-17	1
44699	2662	80180	2016-07-02	2016-07-03	1
10816	642	4027663	1962-12-23	1962-12-24	1
67198	3976	4266809	2007-09-24	2007-09-25	1
56461	3353	260139	1978-08-02	1978-08-16	1
37832	2243	4285898	2005-03-07	2005-03-08	1
36689	2173	439777	1974-06-27	1974-06-28	1
41347	2461	81151	1976-01-13	1976-01-27	1
61781	3651	260139	2009-10-03	2009-10-10	1
40508	2411	40481087	2011-09-14	2011-10-05	1
86718	5168	439777	2015-02-15	2015-02-16	1
32597	1937	4112343	2010-09-10	2010-09-22	1
83427	4963	260139	1982-07-06	1982-07-13	1
82677	4913	40481087	1992-06-20	1992-07-04	1
8333	486	40481087	1989-08-01	1989-08-15	1
85911	5117	81151	1984-03-23	1984-04-06	1
35732	2119	260139	2017-12-12	2017-12-19	1
16323	967	4237458	2003-03-12	2003-06-10	1
20390	1228	4156265	2001-09-19	2001-10-10	1
37897	2250	4310024	1993-06-26	1993-06-27	1
88693	5278	372328	1987-05-05	1987-06-26	1
32134	1911	260139	1959-11-23	1959-12-07	1
7650	449	134438	1984-10-29	1986-01-27	1
5172	304	4285898	1997-05-22	1997-05-23	1
2642	155	81151	2011-05-22	2011-06-19	1
42997	2563	4146173	1977-01-22	1977-02-21	1
76270	4529	4152936	1985-04-25	1985-05-09	1
41450	2468	28060	1972-09-18	1972-09-26	1
33168	1971	260139	1997-09-06	1997-09-20	1
11547	682	4112343	1975-12-24	1976-01-02	1
39681	2352	40481087	1971-04-29	1971-05-06	1
89107	5306	40481087	2009-01-02	2009-01-16	1
34131	2028	260139	2016-09-24	2016-10-01	1
35554	2108	40481087	1965-12-12	1966-01-02	1
17534	1054	4048171	1934-12-23	1951-12-21	1
12749	754	4059173	2008-04-09	2008-05-09	1
17107	1024	4109685	1979-04-11	1979-05-02	1
29023	1719	260139	2015-01-28	2015-02-04	1
30764	1821	40481087	1964-01-13	1964-01-27	1
69243	4102	4146173	1973-10-27	1973-12-03	1
39806	2359	260139	1978-11-29	1978-12-13	1
36976	2191	40481087	1979-11-29	1979-12-06	1
87883	5233	4112343	1968-03-22	1968-03-29	1
36458	2160	260139	1989-01-11	1989-01-18	1
68431	4051	28060	1986-12-11	1986-12-24	1
35910	2131	4084167	1962-03-30	1962-03-30	1
41393	2463	4112343	1992-09-18	1992-09-26	1
81323	4828	4278672	1984-05-01	1984-06-30	1
26765	1586	4112343	2003-07-27	2003-08-05	1
3106	183	4112343	1978-05-23	1978-06-01	1
65534	3879	40481087	1976-01-21	1976-02-04	1
8885	520	40481087	1974-03-07	1974-03-28	1
44700	2662	372328	1979-04-22	1979-07-06	1
10817	642	4112343	1944-10-11	1944-10-20	1
67199	3976	4310024	2006-01-02	2006-01-03	1
56462	3353	4027663	1949-12-21	1949-12-22	1
37833	2243	40481087	1996-03-07	1996-03-14	1
36690	2173	4112343	1931-10-02	1931-10-10	1
41348	2461	260139	1991-02-24	1991-03-10	1
61782	3651	4112343	1979-08-15	1979-08-23	1
40509	2411	80180	2001-05-14	2001-05-15	1
86719	5168	4112343	1999-02-16	1999-02-24	1
32598	1937	4155034	1979-07-10	1979-07-31	1
83428	4963	260139	2011-12-24	2011-12-31	1
82678	4913	40481087	2005-11-29	2005-12-06	1
8334	486	40481087	1997-10-20	1997-11-03	1
85912	5117	81151	2017-12-09	2017-12-30	1
35733	2119	4237458	1962-05-08	1962-06-07	1
16324	967	4278672	2002-02-15	2002-04-16	1
20391	1228	4280726	1979-07-12	1979-07-13	1
37898	2250	40481087	1960-05-24	1960-05-31	1
88694	5278	4230399	1971-06-28	1971-09-26	1
32135	1911	4112343	1986-07-08	1986-07-15	1
7651	449	260139	1985-08-17	1985-08-31	1
5173	304	40481087	1972-12-19	1972-12-26	1
2643	155	260139	2005-07-09	2005-07-16	1
42998	2563	4156265	1986-06-04	1986-06-18	1
76271	4529	28060	1970-03-26	1970-04-05	1
41451	2468	81151	1979-05-19	1979-06-09	1
33169	1971	372328	1972-04-27	1972-08-18	1
11548	682	4112343	1983-04-12	1983-04-22	1
39682	2352	40486433	1974-11-01	1974-11-02	1
62717	3708	198199	1999-05-08	1999-06-12	1
34132	2028	4112343	1974-04-15	1974-04-28	1
35760	2122	260139	1982-03-09	1982-03-16	1
17535	1054	4109685	1956-02-14	1956-02-28	1
12750	754	40481087	1940-01-18	1940-01-25	1
17108	1024	40481087	1979-08-04	1979-08-18	1
29024	1719	4059173	2004-12-27	2005-01-26	1
30765	1821	40481087	1981-07-04	1981-07-11	1
69244	4102	40481087	1987-03-26	1987-04-02	1
39807	2359	317576	2011-04-25	2011-04-26	1
36977	2191	40481087	2009-08-24	2009-09-14	1
87884	5233	4294548	1974-12-25	1975-02-05	1
36459	2160	260139	1995-11-14	1995-11-21	1
68432	4051	260139	1995-11-23	1995-12-07	1
35911	2131	4112343	1993-11-28	1993-12-08	1
41394	2463	4294548	1979-07-22	1979-08-05	1
81324	4828	40481087	1978-01-10	1978-01-17	1
26766	1586	4116491	1966-05-10	1966-06-26	1
3107	183	4112343	1984-08-01	1984-08-13	1
65535	3879	40481087	1983-12-31	1984-01-21	1
8886	520	40481087	1976-09-22	1976-09-29	1
44701	2662	4035415	2018-02-17	2018-03-20	1
10818	642	4266809	1971-06-09	1971-06-10	1
67200	3976	40481087	1976-09-21	1976-09-28	1
56463	3353	4112343	1996-11-28	1996-12-11	1
37834	2243	40481087	2003-08-04	2003-08-11	1
36691	2173	4112343	1972-10-02	1972-10-10	1
41349	2461	4266809	2003-03-07	2003-03-08	1
61783	3651	4112343	1996-08-06	1996-08-19	1
40510	2411	372328	1967-07-01	1967-12-07	1
86720	5168	80180	2010-01-07	2010-01-08	1
32599	1937	28060	1966-08-10	1966-08-19	1
83429	4963	440086	1987-05-11	1990-09-03	1
82988	4935	30753	2002-06-07	2002-06-08	1
8335	486	40481087	1999-11-30	1999-12-21	1
85913	5117	260139	1979-09-17	1979-10-01	1
35734	2119	40481087	1981-11-18	1981-12-09	1
16325	967	4283893	1947-05-29	1947-07-03	1
20392	1228	4294548	2008-06-01	2008-06-22	1
37899	2250	260139	1958-07-27	1958-08-10	1
60291	3571	4048171	1975-08-30	1975-08-31	1
32136	1911	4134304	1960-03-12	1960-06-10	1
7652	449	260139	2001-02-19	2001-02-26	1
5174	304	80180	1998-03-18	1998-03-19	1
2644	155	40481087	1980-06-15	1980-06-22	1
42999	2563	40481087	1978-05-16	1978-05-30	1
76272	4529	80180	1997-08-30	1997-08-31	1
41452	2468	257012	1959-01-14	1959-01-15	1
33170	1971	372328	2015-08-27	2017-04-07	1
11549	682	4112343	1994-03-28	1994-04-08	1
39683	2352	28060	2013-02-10	2013-02-18	1
62718	3708	372328	1980-10-24	1981-03-13	1
34133	2028	4156265	1984-07-13	1984-07-27	1
35761	2122	260139	2001-06-29	2001-07-06	1
17536	1054	4155034	1985-11-27	1985-12-18	1
12751	754	40481087	1954-11-01	1954-11-08	1
17109	1024	40481087	1987-11-13	1987-11-27	1
29025	1719	4109685	2007-01-07	2007-01-21	1
30766	1821	28060	1971-08-17	1971-08-29	1
69245	4102	260139	1969-09-28	1969-10-05	1
39808	2359	381316	1982-12-27	1982-12-28	1
36978	2191	80180	2011-12-25	2011-12-26	1
87885	5233	40481087	1962-11-25	1962-12-02	1
36460	2160	260139	2005-12-23	2005-12-30	1
68433	4051	372328	1977-08-15	1977-12-21	1
35912	2131	81151	1956-06-29	1956-07-20	1
42489	2537	0	1960-08-13	1960-08-14	1
81325	4828	40481087	1993-10-17	1993-10-24	1
26767	1586	40481087	1961-09-13	1961-09-27	1
3108	183	4112343	2007-04-16	2007-04-24	1
65536	3879	40481087	2014-04-26	2014-05-17	1
8887	520	40481087	1990-12-05	1990-12-19	1
44702	2662	40481087	1991-07-26	1991-08-09	1
10819	642	4278672	2017-11-18	2017-12-18	1
67201	3976	40481087	1988-07-03	1988-07-10	1
56464	3353	4112343	2005-07-29	2005-08-08	1
39012	2320	0	1941-08-02	1941-08-03	1
36692	2173	40479422	2010-06-27	2010-09-02	1
41350	2461	40481087	1995-09-22	1995-10-13	1
61784	3651	4278672	1973-02-14	1973-05-15	1
40511	2411	4027663	1994-06-25	1994-06-26	1
86721	5168	4112343	1975-10-06	1975-10-19	1
32600	1937	80180	2001-03-25	2001-03-26	1
83430	4963	4112343	1973-12-13	1973-12-25	1
82989	4935	134438	1985-09-26	1986-11-21	1
8336	486	30753	1998-06-17	1998-06-18	1
85914	5117	260139	1993-07-02	1993-07-09	1
35735	2119	40481087	1987-05-20	1987-06-03	1
16326	967	40481087	1955-08-26	1955-09-09	1
20393	1228	4237458	2003-09-30	2003-11-29	1
37900	2250	260139	1974-08-13	1974-08-20	1
60292	3571	4084167	1972-12-16	1972-12-17	1
32137	1911	40481087	1976-05-08	1976-05-29	1
7653	449	260139	2001-06-27	2001-07-11	1
5175	304	81151	2004-03-22	2004-04-19	1
2645	155	40481087	1994-03-30	1994-04-13	1
43000	2563	40479768	1972-04-11	1972-05-18	1
76273	4529	192671	1997-09-09	1997-09-10	1
41453	2468	260139	1939-12-03	1939-12-10	1
33171	1971	40481087	1996-12-25	1997-01-08	1
11550	682	378001	2000-06-25	2000-07-25	1
39684	2352	28060	2018-08-02	2018-08-13	1
62719	3708	4084167	1978-01-08	1978-01-08	1
34134	2028	4296204	2015-12-03	2015-12-31	1
35762	2122	4027663	2003-10-13	2003-10-14	1
17537	1054	40481087	1986-02-12	1986-02-19	1
12752	754	40481087	1977-11-21	1977-12-05	1
17110	1024	80180	1983-01-05	1983-01-06	1
29026	1719	4112343	1965-03-30	1965-04-11	1
30767	1821	78272	1952-12-12	1953-01-02	1
69246	4102	4112343	1972-08-16	1972-08-26	1
39809	2359	40481087	1926-02-14	1926-02-21	1
36979	2191	4112343	1995-03-31	1995-04-11	1
88653	5277	78272	2018-07-06	2018-07-20	1
36461	2160	4310024	1997-04-28	1997-04-29	1
68434	4051	372328	1979-04-15	1980-01-02	1
35913	2131	260139	1956-06-09	1956-06-23	1
42490	2537	80180	1990-01-23	1990-01-24	1
81326	4828	40481087	1999-08-29	1999-09-19	1
26768	1586	78272	1967-04-26	1967-05-10	1
3109	183	40481087	1975-06-29	1975-07-06	1
65537	3879	81151	1946-08-21	1946-09-25	1
8888	520	40481087	2010-03-15	2010-03-29	1
44703	2662	372328	1980-05-31	1980-10-03	1
10820	642	40481087	1994-05-01	1994-05-08	1
67202	3976	40481087	2005-04-16	2005-05-07	1
56465	3353	4296204	1991-05-02	1991-06-06	1
39013	2320	260139	1957-11-20	1957-12-04	1
36693	2173	40481087	1957-01-09	1957-01-23	1
41351	2461	40481087	2002-02-16	2002-03-09	1
61785	3651	40481087	1968-01-20	1968-01-27	1
40512	2411	4112343	2019-02-08	2019-02-20	1
86722	5168	4112343	2017-08-15	2017-08-27	1
32601	1937	257012	2006-06-18	2006-06-19	1
83431	4963	4112343	1975-07-20	1975-07-30	1
82990	4935	195588	1996-09-16	1996-11-04	1
8337	486	80180	1999-03-14	1999-03-15	1
85915	5117	4294548	1972-04-18	1972-07-04	1
35736	2119	28060	1961-10-13	1961-10-24	1
16327	967	40481087	1984-06-12	1984-06-19	1
20394	1228	40481087	1999-08-31	1999-09-21	1
37901	2250	260139	1993-12-27	1994-01-03	1
60293	3571	4112343	1980-12-10	1980-12-23	1
32138	1911	40481087	1979-02-18	1979-03-11	1
7654	449	4112343	1999-12-12	1999-12-23	1
5176	304	192671	1998-05-03	1998-05-04	1
2646	155	40486433	1959-05-13	1973-05-11	1
44936	2677	30753	2006-05-02	2006-05-03	1
76274	4529	4112343	1972-11-23	1972-12-02	1
41454	2468	260139	1981-08-08	1981-08-15	1
33172	1971	28060	1971-04-07	1971-04-17	1
11551	682	4112343	1981-09-04	1981-09-15	1
39685	2352	81893	2010-09-11	2010-09-12	1
62720	3708	4113008	2011-01-15	2011-02-05	1
34135	2028	40481087	1946-07-12	1946-07-19	1
35763	2122	4112343	1980-01-18	1980-01-27	1
17538	1054	40481087	1988-06-13	1988-06-20	1
12753	754	40481087	1985-04-03	1985-04-17	1
17111	1024	4059173	2012-08-16	2012-09-15	1
29027	1719	4112343	1967-02-15	1967-02-27	1
30768	1821	192671	1982-11-03	1982-11-04	1
69247	4102	4112343	1997-12-13	1997-12-20	1
39810	2359	40481087	1998-12-21	1999-01-04	1
36980	2191	4285898	2011-02-28	2011-03-01	1
88654	5277	80180	1997-09-06	1997-09-07	1
36462	2160	40481087	2012-01-18	2012-02-08	1
68435	4051	40481087	1978-03-02	1978-03-09	1
35914	2131	260139	1958-07-17	1958-07-24	1
42491	2537	372328	1948-08-11	1948-10-24	1
81327	4828	40481087	2012-05-20	2012-05-27	1
26769	1586	81151	1954-06-21	1954-07-19	1
3110	183	40481087	1998-11-01	1998-11-15	1
65538	3879	260139	1969-06-10	1969-06-17	1
13910	823	78272	1949-10-25	1949-11-15	1
44704	2662	375671	1981-06-11	1981-07-11	1
10821	642	40481087	2005-08-17	2005-08-24	1
67203	3976	28060	1989-09-03	1989-09-13	1
56466	3353	40480160	1998-11-26	1999-01-25	1
39014	2320	260139	2001-08-23	2001-08-30	1
36694	2173	40481087	1970-04-04	1970-04-11	1
41352	2461	40481087	2016-12-26	2017-01-09	1
61786	3651	40481087	1974-09-20	1974-10-11	1
40513	2411	4299128	1993-01-01	1993-02-05	1
86723	5168	40481087	1996-05-22	1996-05-29	1
32602	1937	4112343	1965-03-06	1965-03-15	1
83432	4963	40481087	2013-01-11	2013-01-25	1
82991	4935	4146173	1988-06-04	1988-08-03	1
8338	486	81893	1997-09-20	1997-09-21	1
87508	5213	80180	1977-11-23	1977-11-24	1
35737	2119	81151	1994-03-10	1994-03-24	1
16328	967	40481087	1992-06-16	1992-06-30	1
20395	1228	0	2016-06-26	2016-06-27	1
37902	2250	378001	1990-08-27	1990-10-26	1
60294	3571	4134304	2005-05-27	2005-07-26	1
32139	1911	80180	1984-05-05	1984-05-06	1
7655	449	4283893	1999-11-09	2000-02-29	1
5177	304	260139	2010-04-21	2010-04-28	1
2647	155	4112343	1976-07-26	1976-08-05	1
44937	2677	80180	2006-11-27	2006-11-28	1
76275	4529	40481087	1980-08-28	1980-09-18	1
41455	2468	260139	1998-07-21	1998-07-28	1
33173	1971	260139	1981-05-12	1981-05-19	1
11552	682	4112343	2018-03-21	2018-03-28	1
39686	2352	4027663	2004-10-17	2004-10-18	1
62721	3708	260139	1998-06-30	1998-07-14	1
37383	2220	372328	1942-05-15	1942-07-22	1
35764	2122	4112343	1987-06-21	1987-06-28	1
17539	1054	81893	1971-10-03	1971-10-04	1
14429	855	80180	1999-03-08	1999-03-09	1
17112	1024	4112343	2008-05-28	2008-06-10	1
29028	1719	4112343	2015-04-15	2015-04-25	1
30769	1821	260139	1974-11-18	1974-11-25	1
69248	4102	4146173	1983-12-02	1984-01-01	1
39811	2359	28060	1945-10-12	1945-10-24	1
36981	2191	40481087	1991-05-05	1991-05-12	1
88655	5277	260139	1970-02-17	1970-03-03	1
36463	2160	28060	1974-05-16	1974-05-28	1
68436	4051	40481087	1980-10-30	1980-11-20	1
35915	2131	260139	2014-09-07	2014-09-14	1
42492	2537	4112343	1973-07-04	1973-07-13	1
81328	4828	80180	2014-01-07	2014-01-08	1
26770	1586	260139	1954-10-20	1954-11-03	1
3111	183	40481087	2019-03-16	2019-04-06	1
65539	3879	372328	1941-02-06	1941-02-20	1
13911	823	80502	2005-01-17	2005-01-18	1
44705	2662	40481087	2017-10-13	2017-10-27	1
10822	642	372328	1935-12-25	1936-03-08	1
67204	3976	80180	2007-09-24	2007-09-25	1
56467	3353	30753	1958-05-13	1958-05-14	1
39015	2320	4112343	1962-07-13	1962-07-26	1
36695	2173	40481087	1982-06-03	1982-06-17	1
43950	2619	28060	1948-03-24	1948-04-06	1
61787	3651	40481087	1977-03-27	1977-04-17	1
40514	2411	40481087	2005-01-25	2005-02-08	1
86724	5168	260139	1973-05-17	1973-05-24	1
32603	1937	4112343	1970-12-27	1971-01-04	1
84192	5007	372328	1983-06-25	1983-09-04	1
82992	4935	4266809	2003-08-01	2003-08-02	1
8339	486	195588	1996-10-25	1997-02-11	2
87509	5213	81151	2007-03-14	2007-04-11	1
35738	2119	134438	1983-06-14	1984-04-13	1
16329	967	80180	1973-10-25	1973-10-26	1
20396	1228	80180	2009-01-13	2009-01-14	1
37903	2250	4112343	1958-12-24	1959-01-05	1
60295	3571	40481087	1984-08-06	1984-08-20	1
32140	1911	260139	2002-07-30	2002-08-13	1
7656	449	40481087	1981-06-11	1981-06-25	1
5178	304	4112343	1960-11-16	1960-11-24	1
2648	155	40481087	1994-05-22	1994-05-29	1
44938	2677	81151	1975-10-26	1975-11-16	1
76276	4529	81151	2016-10-30	2016-12-04	1
41456	2468	4112343	1998-12-24	1999-01-04	1
33174	1971	260139	1983-10-02	1983-10-16	1
11553	682	40481087	2004-11-04	2004-11-18	1
39687	2352	4051466	1972-11-01	1990-02-05	1
62722	3708	4051466	1979-05-20	1996-08-24	1
37384	2220	4112343	1976-09-03	1976-09-16	1
35765	2122	4112343	1990-04-28	1990-05-10	1
17540	1054	260139	1996-10-26	1996-11-02	1
14430	855	260139	1968-12-22	1968-12-29	1
17113	1024	4218389	1991-10-10	1991-10-31	1
29029	1719	4134304	1967-03-09	1967-04-08	1
30770	1821	4112343	1944-07-30	1944-08-06	1
70843	4208	30753	1978-07-05	1978-07-06	1
39812	2359	28060	1962-11-18	1962-11-27	1
36982	2191	40481087	1972-11-09	1972-11-30	1
88656	5277	260139	1998-08-05	1998-08-12	1
36464	2160	81893	1997-06-27	1997-06-28	1
68437	4051	40481087	2002-01-01	2002-01-08	1
35916	2131	4112343	1953-06-16	1953-06-28	1
42493	2537	4112343	2003-04-21	2003-05-01	1
81329	4828	134438	1996-05-09	1999-09-21	1
26771	1586	317576	1966-05-22	1966-05-23	1
6622	392	192671	2012-05-14	2012-05-15	1
65540	3879	372328	1987-02-19	1988-05-12	1
13912	823	4237458	2011-07-23	2011-09-21	1
44706	2662	260139	1995-10-28	1995-11-10	1
10823	642	372328	1936-06-06	1936-12-06	1
67205	3976	81151	2003-03-24	2003-04-28	1
56468	3353	80180	1959-04-08	1959-04-09	1
39016	2320	4156265	2017-12-10	2017-12-31	1
36696	2173	40481087	1996-12-12	1997-01-02	1
43951	2619	81151	1966-02-17	1966-03-17	1
63592	3759	81151	2008-12-21	2009-01-25	1
40980	2439	372328	1976-02-11	1976-04-21	1
86725	5168	372328	1971-05-27	1971-08-06	1
32604	1937	4134304	1968-10-14	1968-11-13	1
84193	5007	4112343	2012-12-23	2013-01-05	1
82993	4935	40479422	1999-02-07	1999-03-16	1
8340	486	257012	1975-04-07	1975-04-08	1
87510	5213	260139	1984-03-24	1984-03-31	1
35739	2119	378001	2012-11-14	2012-12-14	1
16330	967	81151	2007-05-20	2007-06-10	1
20397	1228	257012	2008-06-15	2008-06-16	1
37904	2250	40481087	1999-04-04	1999-04-25	1
60296	3571	40481087	1999-04-27	1999-05-18	1
32141	1911	261325	1997-09-01	1997-09-02	1
10421	615	80502	2000-09-09	2000-09-10	1
5179	304	4112343	2009-11-04	2009-11-13	1
2649	155	40481087	2003-07-19	2003-07-26	1
44939	2677	378001	1986-06-22	1986-07-22	1
76277	4529	258780	1985-12-01	1985-12-02	1
41457	2468	4218389	1985-01-08	1985-02-05	1
33175	1971	4112343	1985-12-16	1985-12-24	1
11554	682	372328	1972-07-10	1972-10-25	1
39688	2352	4112343	1997-04-10	1997-04-22	1
62723	3708	40481087	1992-02-09	1992-02-16	1
37385	2220	4112343	1983-03-18	1983-03-28	1
35766	2122	4152936	1992-03-12	1992-03-26	1
17541	1054	4112343	1949-11-21	1949-11-30	1
14431	855	195588	1993-11-14	1994-01-02	1
17114	1024	40481087	1995-09-25	1995-10-16	1
29030	1719	4218389	1987-02-22	1987-03-29	1
30771	1821	40481087	2000-05-07	2000-05-28	1
70844	4208	80180	1978-10-03	1978-10-04	1
39813	2359	28060	1983-04-13	1983-04-26	1
36983	2191	40481087	1982-03-31	1982-04-14	1
88657	5277	4112343	2004-10-13	2004-10-22	1
36465	2160	4112343	1988-12-12	1988-12-20	1
68438	4051	40481087	2017-12-16	2017-12-23	1
35917	2131	4152936	1988-06-07	1988-06-28	1
42494	2537	40481087	1952-01-01	1952-01-08	1
81330	4828	260139	2009-07-14	2009-07-21	1
26772	1586	4112343	1952-07-02	1952-07-10	1
6623	392	4237458	1978-03-20	1978-04-19	1
65541	3879	4112343	1975-11-29	1975-12-10	1
13913	823	40480160	2011-07-23	2011-09-21	1
44707	2662	40479422	2002-07-05	2002-08-11	1
10824	642	372328	1938-04-30	1938-06-05	1
67206	3976	260139	1976-07-09	1976-07-16	1
56469	3353	81151	1943-10-19	1943-11-09	1
39017	2320	40481087	1972-07-11	1972-08-01	1
36697	2173	40481087	2005-01-26	2005-02-02	1
43952	2619	260139	2010-05-30	2010-06-13	1
63593	3759	40481087	1980-06-26	1980-07-17	1
40981	2439	4116491	2006-05-09	2006-06-11	1
86726	5168	40481087	2010-02-20	2010-03-13	1
32605	1937	40481087	1990-07-29	1990-08-05	1
84194	5007	4112343	2013-07-06	2013-07-17	1
82994	4935	40481087	1978-07-19	1978-08-09	1
8341	486	4112343	1986-09-21	1986-09-29	1
87511	5213	372328	1942-09-14	1943-05-27	1
35740	2119	40481087	1998-04-08	1998-04-29	1
16331	967	257012	1983-08-18	1983-08-19	1
20398	1228	4116491	2014-06-26	2014-08-09	1
37905	2250	40481087	2015-01-19	2015-01-26	1
60297	3571	28060	1977-05-28	1977-06-08	1
32142	1911	372328	1946-07-24	1946-11-04	1
10422	615	4112343	1913-12-21	1914-01-03	1
5508	326	28060	1979-09-23	1979-10-06	1
2650	155	40481087	2005-06-20	2005-07-11	1
44940	2677	4112343	1991-02-02	1991-02-12	1
76278	4529	4112343	1984-11-03	1984-11-14	1
41458	2468	4283893	1958-11-26	1959-04-01	1
33176	1971	4113008	1984-04-08	1984-04-22	1
11555	682	372328	1974-10-15	1975-10-29	1
39689	2352	4112343	1997-06-25	1997-07-02	1
62724	3708	40481087	2014-05-20	2014-05-27	1
37386	2220	4112343	2003-11-06	2003-11-15	1
35767	2122	81151	1974-10-15	1974-10-29	1
17542	1054	40481087	1955-02-22	1955-03-08	1
14432	855	372328	1958-03-18	1958-05-02	1
17115	1024	260139	1955-07-17	1955-07-31	1
29031	1719	4218389	1991-03-08	1991-04-05	1
30772	1821	28060	1950-06-09	1950-06-19	1
70845	4208	81151	1960-05-30	1960-06-13	1
39814	2359	80180	1965-01-30	1965-01-31	1
36984	2191	40481087	2008-02-18	2008-02-25	1
88658	5277	4283893	2009-08-07	2009-08-21	1
36466	2160	4156265	2014-05-23	2014-06-13	1
68439	4051	80180	2009-09-29	2009-09-30	1
35918	2131	40481087	1958-01-25	1958-02-15	1
42495	2537	40481087	1964-03-14	1964-03-28	1
81331	4828	372328	1972-02-20	1972-04-18	1
26773	1586	40481087	1940-05-14	1940-06-04	1
6624	392	40481087	1978-05-24	1978-05-31	1
65542	3879	4112343	1977-02-06	1977-02-19	1
13914	823	40480160	2013-07-12	2013-09-10	1
44708	2662	40481087	1993-07-05	1993-07-12	1
10825	642	378419	2016-01-17	2016-01-18	1
67207	3976	260139	2018-04-15	2018-04-22	1
56470	3353	81151	1983-01-18	1983-02-22	1
39018	2320	81151	1945-03-14	1945-04-18	1
36698	2173	40481087	2009-04-07	2009-04-21	1
43953	2619	260139	2011-07-26	2011-08-02	1
63594	3759	134438	1983-08-12	1984-04-14	1
40982	2439	81151	1989-10-25	1989-11-08	1
86727	5168	40481087	2019-03-24	2019-03-31	1
32606	1937	40481087	2013-08-28	2013-09-11	1
84195	5007	4156265	2008-08-26	2008-09-09	1
82995	4935	40481087	2003-11-05	2003-11-19	1
8342	486	4116491	1998-02-11	1998-04-05	1
87512	5213	4112343	2009-03-30	2009-04-07	1
35741	2119	40481087	2004-09-02	2004-09-23	1
16332	967	260139	2014-06-01	2014-06-15	1
20399	1228	40481087	1981-10-04	1981-10-25	1
37906	2250	192671	1995-05-12	1995-05-13	1
60298	3571	133834	1976-04-06	1989-05-10	1
32143	1911	4113008	1979-08-30	1979-09-13	1
10423	615	4112343	1946-06-14	1946-06-21	1
5509	326	80180	2004-03-09	2004-03-10	1
2651	155	260139	2014-04-02	2014-04-16	1
44941	2677	4266809	2006-11-27	2006-11-28	1
76279	4529	4116491	1993-11-09	1993-12-29	1
41459	2468	40481087	1983-10-24	1983-11-07	1
33177	1971	4116491	1993-03-08	1993-04-22	1
11556	682	4112343	2005-09-09	2005-09-22	1
39690	2352	4266809	2012-08-01	2012-08-02	1
62725	3708	192671	2015-08-07	2015-08-08	1
37387	2220	28060	2013-12-07	2013-12-17	1
35768	2122	260139	2011-07-15	2011-07-29	1
17543	1054	40481087	1975-07-25	1975-08-01	1
14433	855	372328	1959-04-27	1959-10-30	1
17116	1024	260139	1981-12-17	1981-12-24	1
29032	1719	4218389	2006-02-20	2006-03-13	1
30773	1821	80180	1982-08-12	1982-08-13	1
70846	4208	260139	1950-07-26	1950-08-09	1
39815	2359	81151	2008-12-16	2009-01-06	1
38663	2297	80180	2012-06-13	2012-06-14	1
88659	5277	4296204	1963-11-24	1963-12-08	1
36467	2160	40481087	2003-01-30	2003-02-13	1
68440	4051	192671	2009-10-14	2009-10-15	1
35919	2131	40481087	1995-10-27	1995-11-03	1
42496	2537	40481087	1965-11-27	1965-12-11	1
81332	4828	4283893	1980-05-16	1980-06-20	1
26774	1586	40481087	1965-07-13	1965-07-20	1
6625	392	40481087	2015-10-22	2015-11-05	1
65543	3879	40481087	1986-03-18	1986-04-01	1
13915	823	40481087	1952-11-15	1952-11-29	1
45317	2698	80180	2019-04-17	2019-04-18	1
10826	642	4112343	1999-05-19	1999-06-01	1
67208	3976	4112343	1994-05-22	1994-06-03	1
56471	3353	260139	1930-03-03	1930-03-17	1
39019	2320	260139	1947-11-01	1947-11-15	1
39734	2356	81151	1984-06-28	1984-07-12	1
43954	2619	317576	2004-10-22	2004-10-23	1
63595	3759	260139	1966-03-03	1966-03-17	1
40983	2439	260139	1993-10-04	1993-10-18	1
87039	5190	78272	1965-03-09	1965-03-23	1
32607	1937	40481087	2016-10-04	2016-10-25	1
84196	5007	4294548	1999-11-18	1999-11-25	1
82996	4935	40481087	2005-08-15	2005-08-29	1
8343	486	4283893	1975-02-24	1975-05-19	1
87513	5213	4296204	1981-11-11	1981-11-25	1
35742	2119	40481087	2013-04-18	2013-04-25	1
16333	967	317576	2011-07-16	2011-07-17	1
20400	1228	40481087	2000-03-26	2000-04-16	1
37907	2250	260139	1965-12-03	1965-12-10	1
60299	3571	257012	2000-11-15	2000-11-16	1
32144	1911	4116491	1987-11-16	1987-12-30	1
10424	615	4155034	1999-03-30	1999-04-13	1
5510	326	4027663	1996-05-25	1996-05-26	1
2652	155	372328	1958-12-12	1959-04-17	1
44942	2677	4278672	1974-11-30	1974-12-30	1
76280	4529	28060	1965-11-08	1965-11-15	1
41460	2468	40481087	1991-02-14	1991-03-07	1
33178	1971	40481087	1991-12-19	1992-01-02	1
11557	682	40481087	1975-11-28	1975-12-12	1
39691	2352	40481087	1993-02-14	1993-02-28	1
62726	3708	260139	1979-03-06	1979-03-20	1
37388	2220	80180	1987-07-23	1987-07-24	1
35769	2122	260139	2017-09-07	2017-09-21	1
18729	1128	81151	2016-03-16	2016-04-13	1
14434	855	375671	1968-09-05	1968-10-05	1
17117	1024	260139	1987-07-21	1987-08-04	1
29033	1719	40481087	1974-07-17	1974-08-07	1
30774	1821	260139	1960-08-18	1960-09-01	1
70847	4208	260139	1961-02-17	1961-02-24	1
39816	2359	260139	1941-01-31	1941-02-14	1
38664	2297	40481087	1987-02-01	1987-02-22	1
88660	5277	40481087	1963-12-06	1963-12-13	1
36468	2160	40481087	2017-08-17	2017-09-07	1
68441	4051	4155034	2018-07-20	2018-08-03	1
39226	2330	4112343	1995-04-08	1995-04-15	1
42497	2537	40481087	1977-04-17	1977-04-24	1
81333	4828	4294548	2012-08-03	2012-08-24	1
27081	1604	28060	1953-11-30	1953-12-09	1
6626	392	4112343	1991-02-24	1991-03-07	1
65544	3879	81151	1944-09-16	1944-09-30	1
13916	823	40481087	2008-07-05	2008-07-26	1
45318	2698	81151	1989-08-02	1989-08-16	1
10827	642	4112343	2013-01-20	2013-01-31	1
67209	3976	4112343	2007-09-27	2007-10-07	1
56472	3353	260139	1933-03-03	1933-03-10	1
39020	2320	260139	1955-08-11	1955-08-25	1
39735	2356	260139	2015-12-14	2015-12-28	1
43955	2619	4142905	1944-10-10	1944-11-09	1
63596	3759	4112343	1973-02-26	1973-03-10	1
40984	2439	260139	2008-05-18	2008-06-01	1
87040	5190	260139	1990-10-05	1990-10-19	1
35555	2109	80180	2005-12-04	2005-12-05	1
84197	5007	40481087	1994-08-03	1994-08-17	1
82997	4935	0	1995-09-18	1995-09-19	1
8344	486	378001	1978-07-02	1978-08-31	1
87514	5213	40481087	1952-07-08	1952-07-22	1
38939	2318	81893	2001-09-08	2001-09-09	1
16334	967	381316	1953-04-25	1953-04-26	1
20401	1228	40481087	2019-01-05	2019-01-26	1
37908	2250	260139	2007-10-14	2007-10-28	1
60300	3571	260139	1980-10-07	1980-10-14	1
32145	1911	40481087	1948-05-20	1948-06-10	1
10425	615	4296204	2019-06-27	2019-06-28	1
5511	326	81151	1995-06-20	1995-07-11	1
2653	155	4294548	2016-01-23	2016-03-12	1
44943	2677	40481087	1972-10-20	1972-11-02	1
76281	4529	28060	1993-07-14	1993-07-21	1
41461	2468	40481087	2010-10-14	2010-10-28	1
33179	1971	40481087	2017-12-22	2018-01-12	1
11558	682	40481087	1988-09-09	1988-09-23	1
39692	2352	80180	2012-08-01	2012-08-02	1
62727	3708	260139	1984-07-20	1984-07-27	1
37389	2220	81151	1949-07-07	1949-07-28	1
35770	2122	372328	1978-08-25	1978-09-30	1
18730	1128	260139	1975-02-21	1975-02-28	1
14435	855	378001	1958-09-14	1958-10-14	1
17118	1024	4296205	2004-08-23	2004-09-27	1
29034	1719	40481087	1983-05-18	1983-06-01	1
30775	1821	260139	1978-07-07	1978-07-21	1
70848	4208	372328	1940-05-15	1940-10-29	1
39817	2359	260139	2004-03-21	2004-04-04	1
38665	2297	40481087	1990-11-11	1990-11-18	1
88661	5277	40481087	1995-12-21	1996-01-11	1
36469	2160	4112343	1967-10-06	1967-10-19	1
68442	4051	4280726	1979-01-22	1993-01-20	1
39227	2330	40481087	1976-08-22	1976-08-29	1
42498	2537	28060	1957-01-09	1957-01-17	1
81334	4828	28060	1982-04-19	1982-04-28	1
27082	1604	30753	1989-11-14	1989-11-15	1
6627	392	78272	1988-02-26	1988-03-11	1
65545	3879	260139	1984-10-05	1984-10-12	1
13917	823	0	1977-11-14	1977-11-15	1
45319	2698	260139	2017-05-08	2017-05-15	1
10828	642	4285898	1970-08-13	1970-08-14	1
67210	3976	4278672	2017-11-10	2018-01-09	1
56473	3353	4112343	1983-01-04	1983-01-12	1
39021	2320	4112343	1986-09-22	1986-10-04	1
39736	2356	440086	1988-10-30	1990-06-17	1
43956	2619	40481087	1980-02-26	1980-03-11	1
63597	3759	4152936	1982-08-05	1982-08-19	1
40985	2439	260139	2012-12-24	2013-01-07	1
87041	5190	4109685	1988-01-20	1988-02-03	1
35556	2109	81151	1979-02-04	1979-02-25	1
84198	5007	0	1995-03-24	1995-03-25	1
82998	4935	372328	1969-01-01	1969-09-04	1
8345	486	4027663	1987-10-28	1987-10-29	1
87515	5213	40481087	1982-06-07	1982-06-14	1
38940	2318	378001	1965-11-16	1965-12-16	1
16335	967	440086	1944-10-12	1950-10-21	1
20402	1228	195588	2016-08-08	2016-09-08	1
37909	2250	378001	2005-08-08	2005-10-07	1
60301	3571	4112343	1979-06-02	1979-06-15	1
32146	1911	40481087	1982-07-02	1982-07-16	1
10426	615	260139	1920-07-16	1920-07-30	1
5512	326	372328	1973-03-17	1973-05-07	1
2654	155	4112343	1971-05-11	1971-05-23	1
44944	2677	40481087	2010-07-09	2010-07-23	1
76282	4529	260139	1965-04-12	1965-04-19	1
41462	2468	260139	1966-11-06	1966-11-13	1
33180	1971	80180	2012-02-17	2012-02-18	1
11559	682	40481087	2002-12-16	2003-01-06	1
39693	2352	4237458	1977-03-23	1977-04-22	1
62728	3708	372328	1981-05-12	1982-03-19	1
37390	2220	260139	1947-12-16	1947-12-23	1
35771	2122	4155034	1975-09-24	1975-10-08	1
18731	1128	372328	1970-05-17	1970-07-03	1
14436	855	4266809	1999-03-08	1999-03-09	1
17119	1024	40481087	1966-02-02	1966-02-09	1
29177	1729	78272	2014-02-14	2014-03-14	1
30776	1821	260139	2016-02-14	2016-02-21	1
70849	4208	440086	1952-11-18	1956-11-27	1
39818	2359	4112343	1955-09-06	1955-09-15	1
38666	2297	4059173	1978-06-12	1978-08-11	1
88662	5277	28060	1968-09-26	1968-10-09	1
36470	2160	4156265	2002-03-31	2002-04-21	1
68443	4051	260139	2005-01-08	2005-01-15	1
39228	2330	40481087	1990-06-12	1990-06-19	1
42499	2537	4029498	1960-08-13	1960-08-14	1
81335	4828	260139	2000-07-17	2000-07-31	1
27083	1604	80180	1991-02-07	1991-02-08	1
6628	392	80180	2012-03-16	2012-03-17	1
65546	3879	4029498	2015-11-25	2015-11-26	1
13918	823	260139	1964-08-08	1964-08-22	1
45320	2698	40481087	1999-02-01	1999-02-22	1
10829	642	40481087	1983-02-01	1983-02-22	1
67211	3976	40481087	1965-06-12	1965-06-26	1
56474	3353	4112343	1992-12-21	1992-12-30	1
39022	2320	4112343	2007-01-14	2007-01-24	1
39737	2356	4218389	1998-12-26	1999-01-30	1
43957	2619	40481087	1985-08-21	1985-08-28	1
63598	3759	80180	2009-03-16	2009-03-17	1
40986	2439	4112343	2014-04-24	2014-05-03	1
87042	5190	4112343	1967-09-17	1967-09-25	1
35557	2109	40481087	1973-12-07	1973-12-14	1
84199	5007	40481087	2016-03-22	2016-04-05	1
82999	4935	4027663	1993-09-17	1993-09-18	1
8346	486	4112343	1979-05-29	1979-06-10	1
87516	5213	40481087	2010-07-31	2010-08-14	1
38941	2318	378001	1967-11-06	1967-12-06	1
16336	967	4109685	1977-04-06	1977-04-27	1
20403	1228	260139	1984-10-13	1984-10-20	1
37910	2250	4027663	1987-02-28	1987-03-01	1
60302	3571	4112343	2014-04-15	2014-04-26	1
32743	1947	257012	1987-04-17	1987-04-18	1
10427	615	378001	1915-01-26	1915-03-27	1
5513	326	4134304	1980-01-10	1980-04-09	1
2655	155	4112343	1988-04-08	1988-04-16	1
44945	2677	260139	2016-05-04	2016-05-11	1
76283	4529	4112343	1989-01-25	1989-02-04	1
41463	2468	260139	1994-03-27	1994-04-03	1
33181	1971	372328	1973-09-14	1974-02-22	1
12370	732	28060	2008-08-09	2008-08-18	1
39694	2352	40481087	1981-08-18	1981-08-25	1
62729	3708	4112343	1983-04-16	1983-04-26	1
37391	2220	260139	1980-08-24	1980-08-31	1
35772	2122	4155034	1995-03-11	1995-04-01	1
18732	1128	372328	1971-07-28	1971-12-31	1
14437	855	4285898	1999-01-07	1999-01-08	1
17120	1024	40481087	1972-12-26	1973-01-02	1
29178	1729	81151	1984-06-02	1984-06-16	1
30777	1821	313217	1986-08-03	1986-08-04	1
70850	4208	4059173	2013-10-04	2013-11-03	1
39819	2359	4155034	2007-12-01	2007-12-22	1
38667	2297	4112343	2014-06-06	2014-06-18	1
88663	5277	81151	1961-10-30	1961-12-04	1
36471	2160	40481087	1981-07-27	1981-08-03	1
68444	4051	372328	1975-08-09	1975-12-24	1
39229	2330	40481087	2002-11-18	2002-12-09	1
42500	2537	4051466	1950-08-23	1966-12-01	1
81336	4828	372328	1967-07-09	1967-08-16	1
27084	1604	81151	1977-04-01	1977-05-06	1
6629	392	260139	1979-02-14	1979-02-28	1
65547	3879	4112343	1945-06-16	1945-06-27	1
13919	823	260139	1970-05-08	1970-05-15	1
45321	2698	4109685	2001-01-15	2001-01-29	1
10830	642	40481087	2012-10-25	2012-11-08	1
67212	3976	40481087	1970-09-05	1970-09-26	1
56475	3353	4237458	1971-06-20	1971-07-20	1
39023	2320	40481087	1989-02-12	1989-03-05	1
39738	2356	4285898	2016-03-17	2016-03-18	1
43958	2619	40481087	1989-01-17	1989-02-07	1
63599	3759	260139	1977-11-14	1977-11-28	1
40987	2439	4112343	1976-05-29	1976-06-11	1
87043	5190	4152936	1962-06-02	1962-06-23	1
35558	2109	40481087	1979-07-21	1979-08-04	1
84200	5007	80180	2019-04-07	2019-04-08	1
83000	4935	4285898	2002-12-04	2002-12-05	1
8347	486	4112343	2004-03-29	2004-04-11	1
87517	5213	260139	1991-09-23	1991-10-07	1
38942	2318	4112343	1978-01-10	1978-01-22	1
16337	967	4109685	2019-02-07	2019-02-28	1
20404	1228	372328	2016-03-27	2016-07-09	1
37911	2250	4109685	1988-07-17	1988-08-07	1
60303	3571	4134304	1983-10-20	1984-01-18	1
32744	1947	260139	1968-02-01	1968-02-15	1
10428	615	4112343	1987-11-17	1987-11-27	1
5514	326	40481087	1970-12-05	1970-12-19	1
2656	155	4112343	2018-12-06	2018-12-19	1
44946	2677	440086	1985-04-11	1987-08-14	1
76284	4529	4112343	1997-12-29	1998-01-07	1
41464	2468	4112343	1941-09-23	1941-10-05	1
33182	1971	4027663	2001-03-06	2001-03-07	1
12371	732	260139	2000-09-16	2000-09-30	1
39695	2352	40481087	2001-02-22	2001-03-08	1
62730	3708	4112343	1992-05-12	1992-05-22	1
37392	2220	4112343	1954-04-15	1954-04-28	1
35773	2122	4310024	2012-04-08	2012-04-09	1
18733	1128	4266809	2006-04-08	2006-04-09	1
14438	855	40481087	1957-12-25	1958-01-15	1
17121	1024	40481087	1997-03-16	1997-04-06	1
29179	1729	260139	1985-07-28	1985-08-11	1
30778	1821	4048695	1967-05-31	1967-07-31	1
70851	4208	4112343	1972-08-17	1972-08-25	1
39820	2359	4278672	1995-06-07	1995-07-07	1
38668	2297	40481087	2017-09-20	2017-09-27	1
88664	5277	4112343	2004-03-07	2004-03-15	1
36472	2160	40481087	1984-10-22	1984-10-29	1
68445	4051	40481087	2011-05-30	2011-06-13	1
39230	2330	40481087	2008-09-15	2008-09-29	1
42501	2537	4112343	1953-05-20	1953-05-29	1
81337	4828	4112343	1974-07-04	1974-07-17	1
27085	1604	4027663	1981-10-22	1981-10-23	1
6630	392	40481087	1984-09-04	1984-09-18	1
65548	3879	4112343	1956-05-03	1956-05-11	1
13920	823	261325	2008-12-15	2008-12-16	1
45322	2698	4112343	1994-04-12	1994-04-20	1
10831	642	28060	1972-01-28	1972-02-07	1
67213	3976	81151	1976-06-08	1976-06-29	1
56476	3353	4278672	1998-11-26	1999-01-25	1
39024	2320	192671	1980-03-23	1980-03-24	1
39739	2356	40481087	2006-09-21	2006-10-12	1
43959	2619	40481087	1997-05-01	1997-05-15	1
63600	3759	4027663	1997-08-01	1997-08-02	1
40988	2439	40481087	1993-12-30	1994-01-06	1
87044	5190	40481087	1975-08-27	1975-09-17	1
35559	2109	372328	1973-10-18	1974-11-03	1
84201	5007	260139	1999-08-02	1999-08-16	1
83001	4935	40481087	1981-04-30	1981-05-07	1
8348	486	4266809	1999-03-14	1999-03-15	1
87518	5213	4112343	1949-10-01	1949-10-13	1
38943	2318	4266809	2003-05-01	2003-05-02	1
16338	967	4155034	1973-01-13	1973-01-27	1
20405	1228	440448	2016-06-26	2016-06-27	1
37912	2250	4112343	1990-03-25	1990-04-06	1
60304	3571	40481087	1975-11-01	1975-11-15	1
32745	1947	260139	1979-04-05	1979-04-12	1
10429	615	40481087	1962-07-03	1962-07-10	1
5515	326	30753	2003-07-13	2003-07-14	1
2657	155	4146173	1995-11-12	1995-12-12	1
44947	2677	4027663	1999-04-09	1999-04-10	1
76285	4529	4149245	1998-09-28	1998-11-04	1
41465	2468	4112343	1974-02-20	1974-03-03	1
33183	1971	4112343	1993-06-16	1993-06-28	1
12372	732	257012	2007-07-31	2007-08-01	1
39696	2352	40481087	2007-07-11	2007-07-18	1
62731	3708	4112343	1996-10-29	1996-11-06	1
37393	2220	4112343	1989-07-10	1989-07-19	1
35774	2122	260139	1991-05-02	1991-05-16	1
18734	1128	4294548	1991-08-23	1991-09-06	1
14439	855	40481087	1988-02-05	1988-02-26	1
17122	1024	28060	1999-01-30	1999-02-11	1
29180	1729	40481087	1983-07-16	1983-07-30	1
30779	1821	4112343	1964-07-30	1964-08-09	1
70852	4208	4156265	1972-10-08	1972-10-22	1
39821	2359	40481087	1955-10-22	1955-11-05	1
38669	2297	372328	1976-10-20	1977-02-10	1
88665	5277	4237458	1955-12-31	1956-02-29	1
36473	2160	40481087	2008-01-25	2008-02-01	1
69413	4113	372328	1963-04-11	1964-03-30	1
39231	2330	80180	2008-06-27	2008-06-28	1
42502	2537	4112343	1988-11-24	1988-12-03	1
81338	4828	40481087	1969-09-02	1969-09-16	1
27086	1604	4112343	1957-02-24	1957-03-07	1
6631	392	40481087	1989-01-01	1989-01-22	1
65549	3879	4116491	1971-01-15	1971-03-05	1
13921	823	440448	1977-11-14	1977-11-15	1
45323	2698	4112343	2004-02-01	2004-02-13	1
10832	642	28060	2013-12-31	2014-01-10	1
67214	3976	260139	1996-03-13	1996-03-27	1
56477	3353	40481087	1935-03-10	1935-03-17	1
39025	2320	372328	1947-05-03	1947-07-19	1
39740	2356	30753	2015-09-19	2015-09-20	1
43960	2619	30753	1977-04-25	1977-04-26	1
63601	3759	4116491	1987-08-04	1987-09-17	1
40989	2439	80180	2014-08-25	2014-08-26	1
87045	5190	40481087	1977-05-18	1977-06-01	1
35560	2109	4112343	1985-11-11	1985-11-24	1
84202	5007	4029498	1995-03-24	1995-03-25	1
83002	4935	40481087	1989-09-26	1989-10-10	1
8349	486	40481087	1993-10-28	1993-11-04	1
87519	5213	4112343	1950-04-12	1950-04-24	1
38944	2318	40481087	1973-04-11	1973-05-02	1
16339	967	4266809	1973-10-25	1973-10-26	1
20406	1228	4146173	1985-11-12	1985-12-12	1
37913	2250	40481087	1997-02-22	1997-03-08	1
60305	3571	40481087	2004-11-18	2004-12-02	1
32746	1947	260139	1995-05-16	1995-05-30	1
10430	615	40481087	2015-08-16	2015-09-06	1
5516	326	260139	1973-05-18	1973-06-01	1
2658	155	4156265	1985-09-21	1985-10-05	1
44948	2677	4112343	1974-06-07	1974-06-15	1
76717	4551	28060	1990-04-30	1990-05-07	1
41466	2468	4112343	2005-03-04	2005-03-11	1
33184	1971	4112343	1996-02-17	1996-02-26	1
12373	732	260139	2009-06-04	2009-06-18	1
39697	2352	30753	2011-07-08	2011-07-09	1
62732	3708	4112343	2006-08-18	2006-08-29	1
37394	2220	4112343	2008-06-22	2008-07-03	1
35775	2122	4109685	1998-04-15	1998-04-29	1
18735	1128	4310024	2005-01-13	2005-01-14	1
14440	855	81893	1998-05-12	1998-05-13	1
17123	1024	81151	1982-03-17	1982-03-31	1
29181	1729	40481087	2003-02-03	2003-02-24	1
30780	1821	4152936	1998-10-07	1998-10-21	1
70853	4208	4218389	1995-04-16	1995-05-21	1
39822	2359	40481087	2000-05-03	2000-05-24	1
38670	2297	378001	2005-10-18	2005-12-17	1
88666	5277	4283893	1982-08-09	1982-08-30	1
37157	2204	28060	1987-11-19	1987-12-01	1
69414	4113	4112343	1991-09-03	1991-09-16	1
39232	2330	260139	2015-10-21	2015-10-28	1
42503	2537	40481087	2007-05-30	2007-06-13	1
81339	4828	40481087	1989-05-11	1989-06-01	1
27087	1604	4218389	1959-09-28	1959-10-26	1
6632	392	28060	1985-12-11	1985-12-19	1
65550	3879	4294548	1996-01-18	1996-04-25	1
13922	823	4112343	2017-11-19	2017-11-27	1
45324	2698	4112343	2005-12-07	2005-12-16	1
10833	642	80180	1971-06-09	1971-06-10	1
67215	3976	4152936	1977-05-25	1977-06-08	1
56478	3353	40481087	1942-11-03	1942-11-17	1
39026	2320	4112343	1950-02-18	1950-03-02	1
39741	2356	4112343	1983-01-08	1983-01-20	1
43961	2619	260139	1964-04-18	1964-05-02	1
63602	3759	4294548	1971-09-07	1972-04-04	1
40990	2439	260139	1978-03-19	1978-03-26	1
87046	5190	40481087	1987-05-30	1987-06-06	1
35561	2109	81151	1994-05-21	1994-06-04	1
84203	5007	4109685	2000-06-25	2000-07-09	1
83003	4935	80180	2003-08-01	2003-08-02	1
9709	576	80180	2001-12-10	2001-12-11	1
87520	5213	40481087	1974-06-03	1974-06-10	1
38945	2318	40481087	1996-08-10	1996-08-17	1
16340	967	4294548	1993-12-26	1994-05-01	1
20407	1228	40479422	1980-01-06	1980-03-13	1
37914	2250	40481087	2003-11-07	2003-11-14	1
60306	3571	40481087	2013-02-24	2013-03-17	1
32747	1947	372328	1952-12-25	1953-06-28	1
10431	615	40481087	2017-03-07	2017-03-14	1
5517	326	4112343	1972-02-22	1972-02-29	1
2659	155	40481087	1961-09-03	1961-09-17	1
44949	2677	4112343	2004-07-08	2004-07-18	1
76718	4551	4112343	1983-04-26	1983-05-05	1
41467	2468	4152936	1939-04-05	1939-04-19	1
33185	1971	4116491	1996-04-21	1996-06-08	1
12374	732	4283893	2007-07-10	2007-11-13	1
39698	2352	260139	2000-01-24	2000-02-07	1
62733	3708	4112343	2007-01-27	2007-02-06	1
37395	2220	4266809	1987-07-23	1987-07-24	1
35776	2122	4112343	1987-10-27	1987-11-07	1
18736	1128	40481087	1996-07-08	1996-07-29	1
14441	855	260139	1980-10-08	1980-10-22	1
17124	1024	260139	1995-02-21	1995-03-07	1
29182	1729	40481087	2012-05-11	2012-05-18	1
30781	1821	4155034	1978-08-02	1978-08-23	1
70854	4208	4237458	1944-11-20	1944-12-20	1
39823	2359	260139	1927-12-03	1927-12-10	1
38671	2297	4296204	2017-05-18	2017-06-01	1
88667	5277	40481087	1972-03-05	1972-03-26	1
37158	2204	372328	1950-02-11	1950-07-13	1
69415	4113	4283893	1969-12-12	1970-01-16	1
39233	2330	372328	1979-08-29	1980-06-30	1
42504	2537	81151	1957-11-13	1957-12-04	1
81340	4828	40481087	2007-08-17	2007-09-07	1
27088	1604	40481087	1993-12-29	1994-01-05	1
6633	392	260139	2019-01-31	2019-02-14	1
66171	3921	372328	1994-02-23	1994-09-21	1
13923	823	4142905	2017-10-19	2017-11-18	1
45325	2698	4112343	2011-03-21	2011-04-03	1
10834	642	260139	1944-03-14	1944-03-28	1
67216	3976	40481087	1998-10-24	1998-11-07	1
56479	3353	80502	1995-11-25	1995-11-26	1
39027	2320	4237458	1954-05-01	1954-06-30	1
39742	2356	4218389	2017-05-25	2017-06-15	1
43962	2619	4027663	1966-11-04	1966-11-05	1
63603	3759	40481087	2010-05-16	2010-05-23	1
40991	2439	372328	1973-05-12	1973-10-24	2
87047	5190	40481087	1991-10-22	1991-11-05	1
35562	2109	372328	1971-02-16	1971-05-02	1
84204	5007	40481087	1998-09-01	1998-09-15	1
83004	4935	81893	2002-05-08	2002-05-09	1
9710	576	260139	2015-06-01	2015-06-08	1
87521	5213	40481087	1984-05-12	1984-05-19	1
38946	2318	28060	1999-03-09	1999-03-16	1
16341	967	40481087	2005-11-07	2005-11-28	1
20408	1228	40481087	2007-09-15	2007-09-29	1
39208	2329	372328	1976-08-06	1976-12-28	1
60307	3571	260139	2001-04-04	2001-04-11	1
32748	1947	378001	1979-05-22	1979-07-21	1
10432	615	28060	1929-07-17	1929-07-26	1
5518	326	81893	2002-08-17	2002-08-18	1
2660	155	40481087	1987-03-23	1987-03-30	1
44950	2677	4156265	2014-02-24	2014-03-18	1
76719	4551	4112343	2005-07-18	2005-07-28	1
41468	2468	40481087	1987-04-09	1987-04-30	1
33186	1971	40481087	2011-02-01	2011-02-22	1
12375	732	40481087	2010-11-05	2010-11-12	1
39699	2352	4029498	1970-10-26	1970-10-27	1
62734	3708	40481087	1977-07-20	1977-07-27	1
37396	2220	40481087	2019-01-26	2019-02-16	1
35777	2122	4266809	2013-08-01	2013-08-02	1
18737	1128	80180	2006-04-08	2006-04-09	1
14442	855	4027663	1990-11-15	1990-11-16	1
17125	1024	261325	2019-06-16	2019-06-17	1
29183	1729	40481087	2016-04-25	2016-05-02	1
30782	1821	4155034	2010-02-20	2010-03-13	1
70855	4208	0	1981-04-07	1981-04-08	1
39824	2359	4112343	1997-08-14	1997-08-24	1
38672	2297	40481087	1981-12-01	1981-12-22	1
88668	5277	40481087	1989-11-22	1989-12-13	1
37159	2204	4112343	1983-08-20	1983-08-31	1
69416	4113	40481087	1979-12-21	1979-12-28	1
39234	2330	4112343	2009-08-30	2009-09-07	1
42505	2537	372328	1949-04-22	1949-07-24	1
81341	4828	81151	1974-11-28	1974-12-19	1
27089	1604	260139	1997-02-27	1997-03-13	1
6634	392	4112343	1997-01-06	1997-01-19	1
66172	3921	4278672	1986-08-17	1986-09-16	1
13924	823	40480160	2017-10-19	2017-11-18	1
45326	2698	4283893	2002-04-14	2002-06-16	1
10835	642	313217	2007-09-09	2007-09-10	1
67217	3976	40481087	2002-12-09	2002-12-23	1
56480	3353	260139	1955-04-02	1955-04-16	1
39028	2320	4266809	1980-01-15	1980-01-16	1
39743	2356	4294548	2007-10-15	2007-10-22	1
43963	2619	4112343	2008-05-04	2008-05-15	1
63604	3759	30753	2008-06-19	2008-06-20	1
40992	2439	4218389	1975-05-02	1975-06-06	1
87048	5190	80180	1991-11-12	1991-11-13	1
35563	2109	4112343	1992-11-19	1992-12-02	1
84205	5007	40481087	2005-02-05	2005-02-12	1
83005	4935	4112343	1968-08-18	1968-08-25	1
9711	576	4237458	2001-07-01	2001-09-29	1
87522	5213	40481087	1994-06-04	1994-06-18	1
38947	2318	81151	1984-03-11	1984-04-08	1
16342	967	28060	1937-10-31	1937-11-10	1
23174	1385	28060	1972-05-22	1972-05-31	1
39209	2329	40481087	1973-07-07	1973-07-28	1
60308	3571	378001	2006-07-21	2006-09-19	1
32749	1947	439777	1961-10-14	1961-10-15	1
10433	615	260139	1933-06-28	1933-07-05	1
5519	326	192671	2004-04-10	2004-04-11	1
5388	318	257012	1959-07-07	1959-07-08	1
44951	2677	40481087	1975-12-25	1976-01-01	1
76720	4551	40481087	1988-12-23	1988-12-30	1
41469	2468	40481087	2004-10-29	2004-11-05	1
33489	1989	260139	1984-04-14	1984-04-21	1
12376	732	40481087	2016-10-01	2016-10-22	1
39700	2352	40481087	1984-11-13	1984-11-20	1
62735	3708	40481087	2007-03-05	2007-03-19	1
37397	2220	260139	1978-06-20	1978-07-04	1
35778	2122	40481087	2013-06-29	2013-07-13	1
18738	1128	260139	1979-04-29	1979-05-13	1
14443	855	4112343	1997-03-27	1997-04-06	1
17126	1024	4134304	1952-02-02	1952-03-03	1
29184	1729	80180	2011-08-15	2011-08-16	1
30783	1821	40481087	2000-09-01	2000-09-22	1
70856	4208	260139	1941-11-08	1941-11-22	1
39825	2359	4112343	2017-03-28	2017-04-10	1
38673	2297	40481087	1998-03-19	1998-03-26	1
88669	5277	40481087	2002-03-18	2002-04-08	1
37160	2204	4112343	1988-01-01	1988-01-14	1
69417	4113	80180	1992-05-13	1992-05-14	1
39235	2330	4152936	1980-03-26	1980-04-09	1
42506	2537	372328	1950-11-16	1951-01-21	1
81342	4828	378001	1986-05-21	1986-06-20	1
27090	1604	372328	1958-12-08	1959-10-15	1
6635	392	4112343	1997-09-18	1997-09-30	1
66173	3921	4283893	1982-12-14	1983-01-25	1
13925	823	40481087	1955-04-23	1955-05-14	1
45327	2698	40481087	1987-02-20	1987-02-27	1
10836	642	372328	1940-07-24	1940-12-15	1
67218	3976	28060	1988-10-27	1988-11-03	1
56481	3353	260139	1962-04-23	1962-04-30	1
39029	2320	28060	1997-01-19	1997-02-01	1
39744	2356	40481087	2009-05-21	2009-06-11	1
43964	2619	40481087	1951-07-05	1951-07-26	1
63605	3759	257012	1971-10-05	1971-10-06	1
40993	2439	4218389	1981-02-04	1981-03-11	1
87049	5190	260139	2009-03-20	2009-04-03	1
35564	2109	40481087	1975-07-15	1975-08-05	1
85820	5113	78272	1970-02-08	1970-03-08	1
83006	4935	4112343	1973-03-03	1973-03-13	1
9712	576	40481087	2015-12-17	2015-12-31	1
87523	5213	40481087	2003-05-09	2003-05-30	1
38948	2318	196456	1969-03-09	1969-03-09	1
16343	967	140673	1993-09-30	1993-10-01	1
23175	1385	78272	1963-12-24	1964-01-07	1
39210	2329	40481087	1981-10-04	1981-10-18	1
60309	3571	4112343	1984-11-05	1984-11-16	1
32750	1947	4112343	2017-01-03	2017-01-12	1
10434	615	4112343	1942-07-22	1942-08-02	1
5520	326	4112343	1985-03-11	1985-03-20	1
5389	318	4112343	2000-12-06	2000-12-18	1
44952	2677	40481087	1985-05-18	1985-05-25	1
76721	4551	40481087	2005-10-07	2005-10-28	1
41470	2468	40481087	2012-04-27	2012-05-18	1
33490	1989	440086	1963-02-12	1970-02-20	1
12377	732	260139	1984-05-11	1984-05-25	1
39701	2352	40481087	2016-09-04	2016-09-11	1
62736	3708	80180	2015-06-18	2015-06-19	1
37398	2220	260139	2007-01-31	2007-02-07	1
35779	2122	30753	2013-02-02	2013-02-03	1
18739	1128	260139	2017-01-23	2017-01-30	1
14444	855	4152936	1967-07-29	1967-08-12	1
17127	1024	40481087	1954-12-24	1954-12-31	1
29185	1729	81151	2004-03-03	2004-04-07	1
34206	2033	260139	1978-05-08	1978-05-15	1
70857	4208	4112343	1943-08-01	1943-08-13	1
39826	2359	40481087	1951-12-27	1952-01-03	1
39559	2346	81893	1985-04-22	1985-04-23	1
88670	5277	78272	1996-12-14	1996-12-28	1
37161	2204	4112343	1988-06-15	1988-06-26	1
69418	4113	260139	1958-07-08	1958-07-15	1
39236	2330	40481087	1986-12-11	1986-12-25	1
42507	2537	440086	1959-08-14	1965-08-22	1
81343	4828	4112343	1977-10-01	1977-10-12	1
27091	1604	4112343	1959-09-27	1959-10-10	1
6636	392	4283893	2000-03-03	2000-03-31	1
66174	3921	4294548	1987-08-09	1987-09-20	1
13926	823	80180	1979-01-26	1979-01-27	1
47212	2812	80180	1970-12-15	1970-12-16	1
10837	642	372328	1992-04-16	1992-07-26	1
67219	3976	372328	1966-12-28	1967-03-23	1
56482	3353	372328	1927-11-12	1927-12-03	1
39030	2320	80180	1980-01-15	1980-01-16	1
39745	2356	372328	1985-02-23	1985-10-30	1
43965	2619	40481087	2012-11-30	2012-12-07	1
63606	3759	260139	2010-07-05	2010-07-19	1
40994	2439	4218389	2018-12-06	2019-01-10	1
87050	5190	378001	2005-01-04	2005-03-05	1
35565	2109	78272	1985-06-23	1985-07-07	1
85821	5113	81151	1999-11-20	1999-12-18	1
83007	4935	4112343	2017-03-24	2017-03-31	1
9713	576	28060	1969-03-22	1969-04-03	1
87524	5213	28060	1985-02-23	1985-03-04	1
38949	2318	257012	1991-05-18	1991-05-19	1
16344	967	260139	1956-10-26	1956-11-09	1
23176	1385	260139	1965-08-17	1965-08-31	1
39211	2329	40481087	2001-09-19	2001-09-26	1
60310	3571	4112343	1988-08-01	1988-08-13	1
32751	1947	4134304	1976-04-07	1976-07-06	1
10435	615	4112343	2003-03-11	2003-03-23	1
7231	426	260139	1981-03-26	1981-04-09	1
5390	318	78272	1956-12-14	1957-01-04	1
44953	2677	40481087	1986-06-27	1986-07-04	1
76722	4551	192671	2015-12-30	2015-12-31	1
41471	2468	260139	1959-01-09	1959-01-23	1
33491	1989	4112343	1976-05-30	1976-06-09	1
12378	732	4112343	1999-07-31	1999-08-10	1
42312	2524	80180	1987-03-26	1987-03-27	1
62737	3708	4059173	1988-09-12	1988-10-12	1
37399	2220	4027663	1976-04-06	1976-04-07	1
35780	2122	80180	2013-08-01	2013-08-02	1
18740	1128	4027663	1995-07-20	1995-07-21	1
14445	855	40481087	1973-04-05	1973-04-26	1
17128	1024	40481087	1965-02-14	1965-02-28	1
29186	1729	372328	1978-07-04	1978-08-16	1
34207	2033	260139	2004-10-17	2004-10-31	1
70858	4208	4112343	1959-05-06	1959-05-15	1
39827	2359	40481087	1959-04-24	1959-05-15	1
39560	2346	4027663	1976-01-30	1976-01-31	1
88671	5277	260139	1990-09-21	1990-10-05	1
37162	2204	4113008	1980-04-07	1980-04-21	1
69419	4113	4112343	1986-05-21	1986-05-29	1
40515	2412	28060	1955-08-12	1955-08-24	1
42508	2537	40481087	1957-05-20	1957-06-10	1
81344	4828	4112343	1984-05-21	1984-05-31	1
27092	1604	40481087	1967-09-11	1967-10-02	1
6637	392	40481087	2003-05-23	2003-06-06	1
66175	3921	40481087	2011-07-25	2011-08-08	1
13927	823	378001	1954-07-22	1954-08-21	1
47213	2812	260139	1971-10-13	1971-10-27	1
10838	642	4113008	2010-12-20	2011-01-10	1
67220	3976	378001	2014-10-27	2014-12-26	1
56483	3353	4112343	2012-07-03	2012-07-12	1
39031	2320	81893	1979-01-20	1979-01-21	1
39746	2356	80180	2017-02-10	2017-02-11	1
43966	2619	40481087	2013-05-12	2013-06-02	1
63607	3759	372328	1964-11-07	1965-01-17	1
40995	2439	40481087	2016-01-19	2016-02-02	1
87051	5190	4112343	1964-07-24	1964-07-31	1
35566	2109	4112343	1974-02-01	1974-02-11	1
85822	5113	4029498	1974-03-14	1974-03-15	1
83008	4935	4166224	1995-09-18	1995-09-19	1
9714	576	28060	1997-07-31	1997-08-13	1
87525	5213	260139	1942-11-23	1942-11-30	1
38950	2318	4027663	1995-01-18	1995-01-19	1
16345	967	260139	1984-08-01	1984-08-08	1
23177	1385	260139	1997-05-17	1997-05-24	1
39212	2329	80180	2014-03-22	2014-03-23	1
60311	3571	40481087	1979-03-07	1979-03-28	1
32752	1947	4156265	1991-08-17	1991-08-31	1
10436	615	4113008	1991-05-06	1991-05-20	1
7232	426	372328	1966-02-12	1966-04-21	1
5391	318	78272	1962-04-08	1962-04-29	1
44954	2677	40481087	2000-01-07	2000-01-28	1
76723	4551	257012	2003-09-16	2003-09-17	1
41472	2468	260139	1986-11-19	1986-11-26	1
33492	1989	4116491	1997-02-03	1997-03-20	1
12379	732	4112343	2001-07-04	2001-07-14	1
42313	2524	4112343	1986-01-28	1986-02-08	1
62738	3708	4142905	2003-07-26	2003-09-24	1
37400	2220	4112343	1986-03-15	1986-03-27	1
37943	2256	260139	1989-11-11	1989-11-25	1
18741	1128	4294548	2009-05-01	2009-05-29	1
14446	855	40481087	1982-11-13	1982-11-27	1
17129	1024	40481087	1970-04-28	1970-05-05	1
29187	1729	4283893	2004-03-27	2004-08-14	1
34208	2033	4112343	2011-04-14	2011-04-24	1
70859	4208	4112343	2012-09-06	2012-09-18	1
39828	2359	40481087	2003-03-15	2003-03-29	1
39561	2346	4146173	2001-07-31	2001-09-29	1
88672	5277	372328	1956-07-28	1956-12-12	1
37163	2204	40481087	1946-11-14	1946-11-28	1
69420	4113	40481087	1959-09-08	1959-09-15	1
40516	2412	260139	1985-10-20	1985-10-27	1
42509	2537	40481087	1990-06-22	1990-06-29	1
84236	5013	4112343	1973-04-07	1973-04-17	1
27093	1604	40481087	1995-04-06	1995-04-20	1
6638	392	40481087	2014-05-16	2014-05-23	1
66176	3921	40481087	2017-10-10	2017-10-17	1
13928	823	4112343	1954-12-22	1954-12-29	1
47214	2812	260139	2012-11-24	2012-12-08	1
10839	642	4113008	2017-01-08	2017-01-22	1
67221	3976	4112343	1967-09-07	1967-09-16	1
56484	3353	4156265	1983-12-19	1984-01-09	1
39032	2320	260139	2015-06-19	2015-07-03	1
39747	2356	192671	2017-02-27	2017-02-28	1
43967	2619	260139	1943-09-18	1943-10-02	1
63608	3759	4112343	1978-09-13	1978-09-26	1
42651	2545	4043241	2000-09-14	2000-09-15	1
87052	5190	40481087	1970-05-26	1970-06-16	1
35567	2109	4112343	2017-02-28	2017-03-12	1
85823	5113	4112343	1979-01-17	1979-01-29	1
83009	4935	4310024	2001-06-12	2001-06-13	1
9715	576	372328	1971-06-06	1971-08-11	1
87526	5213	260139	2003-11-11	2003-11-18	1
38951	2318	4112343	1967-01-17	1967-01-26	1
16346	967	260139	2018-03-08	2018-03-22	1
23178	1385	439777	2007-05-02	2007-05-03	1
39213	2329	81151	1976-12-11	1976-12-25	1
60312	3571	40481087	1996-04-26	1996-05-03	1
32753	1947	4283893	1974-11-18	1974-12-16	1
10437	615	40481087	1931-08-18	1931-08-25	1
7233	426	372328	1969-09-02	1969-12-18	1
5392	318	260139	1961-04-23	1961-05-07	1
44955	2677	40481087	2000-09-01	2000-09-22	1
76724	4551	260139	2016-07-20	2016-07-27	1
41473	2468	260139	2003-01-10	2003-01-17	1
33493	1989	4155034	1994-05-31	1994-06-14	1
12380	732	40481087	2012-01-13	2012-01-20	1
42314	2524	40481087	1970-04-07	1970-04-28	1
62739	3708	40481087	1984-07-28	1984-08-11	1
37401	2220	40481087	1992-08-10	1992-08-24	1
37944	2256	4112343	2004-11-18	2004-11-29	1
18742	1128	40481087	1973-08-04	1973-08-18	1
14447	855	40481087	1991-02-19	1991-03-05	1
17130	1024	40481087	2014-05-15	2014-05-29	1
29188	1729	40481087	1999-03-28	1999-04-18	1
34209	2033	40481087	1966-01-27	1966-02-17	1
70860	4208	4285898	1978-08-04	1978-08-05	1
39829	2359	260139	1984-11-14	1984-11-21	1
39562	2346	4285898	1986-04-17	1986-04-18	1
88673	5277	4294548	1969-02-19	1969-03-12	1
37164	2204	40481087	1985-08-28	1985-09-04	1
69421	4113	40481087	1976-09-11	1976-10-02	1
40517	2412	260139	2009-06-11	2009-06-18	1
42510	2537	40486433	1951-08-23	1951-08-24	1
84237	5013	4329847	2013-05-31	2013-06-01	1
27094	1604	40481087	1999-06-04	1999-06-11	1
8703	510	81893	2007-05-15	2007-05-16	1
66177	3921	81151	2007-07-19	2007-08-23	1
13929	823	4112343	2007-12-04	2007-12-17	1
47215	2812	40481087	1977-08-11	1977-08-18	1
10840	642	4152936	1949-12-11	1950-01-01	1
67222	3976	4112343	2018-10-13	2018-10-23	1
56485	3353	28060	1962-05-02	1962-05-10	1
39033	2320	4027663	1973-07-25	1973-07-26	1
39748	2356	4027663	2006-10-26	2006-10-27	1
43968	2619	260139	1980-06-27	1980-07-04	1
63609	3759	4112343	1982-06-08	1982-06-16	1
42652	2545	4112343	1973-08-11	1973-08-19	1
87053	5190	40481087	1983-08-07	1983-08-14	1
35568	2109	40481087	1996-09-12	1996-10-03	1
85824	5113	4112343	1989-10-17	1989-10-26	1
83010	4935	40481087	1987-12-21	1988-01-11	1
9716	576	440086	1973-08-29	1974-07-03	1
87527	5213	372328	1941-03-02	1941-05-22	1
38952	2318	4112343	1983-06-27	1983-07-06	1
16347	967	4112343	1936-05-28	1936-06-04	1
23179	1385	4112343	2000-10-09	2000-10-18	1
39214	2329	4237458	1982-10-25	1983-01-23	1
60313	3571	80180	2007-02-01	2007-02-02	1
32754	1947	40481087	1963-12-09	1963-12-23	1
10438	615	40481087	1996-07-17	1996-07-24	1
7234	426	378001	2009-01-27	2009-03-28	1
5393	318	260139	1974-03-07	1974-03-21	1
44956	2677	28060	1981-12-08	1981-12-17	1
76725	4551	372328	1977-02-25	1977-05-04	1
41474	2468	4035415	1946-05-12	1946-06-11	1
33494	1989	40481087	1987-01-01	1987-01-08	1
12381	732	78272	1977-03-18	1977-04-15	1
42315	2524	40481087	1971-12-26	1972-01-02	1
62740	3708	40486433	1981-05-19	1981-05-20	1
37402	2220	40481087	2014-09-06	2014-09-13	1
37945	2256	4230399	1985-05-04	1985-07-03	1
18743	1128	40481087	2004-12-23	2005-01-13	1
14448	855	30753	1998-10-09	1998-10-10	1
22616	1353	28060	1980-12-26	1981-01-08	1
29189	1729	40481087	2014-05-15	2014-05-29	1
34210	2033	40481087	1980-12-04	1980-12-18	1
70861	4208	40481087	1952-11-14	1952-12-05	1
39830	2359	260139	1998-12-10	1998-12-17	1
39563	2346	28060	1959-10-17	1959-10-24	1
88674	5277	40481087	1960-10-10	1960-10-17	1
37165	2204	40481087	1989-01-22	1989-02-05	1
69422	4113	81151	2011-08-14	2011-09-04	1
40518	2412	40481087	1951-04-26	1951-05-10	1
42511	2537	81151	1952-05-22	1952-06-12	1
84238	5013	0	2013-05-31	2013-06-01	1
27095	1604	192671	1991-04-13	1991-04-14	1
8704	510	440086	1975-09-30	1983-10-08	1
66178	3921	4112343	2008-09-21	2008-10-01	1
13930	823	4230399	2013-07-12	2013-09-10	1
47216	2812	40481087	2014-03-19	2014-04-09	1
10841	642	4218389	2006-01-10	2006-02-14	1
67223	3976	40481087	1972-03-26	1972-04-09	1
56486	3353	28060	1979-04-14	1979-04-23	1
39034	2320	4029498	1941-08-02	1941-08-03	1
39749	2356	4112343	2002-04-14	2002-04-26	1
43969	2619	4112343	1948-05-08	1948-05-18	1
63610	3759	4112343	1997-01-02	1997-01-12	1
42653	2545	4113008	1947-09-14	1947-10-05	1
87054	5190	81151	2015-02-11	2015-03-11	1
35781	2123	260139	1954-03-28	1954-04-11	1
85825	5113	0	1974-03-14	1974-03-15	1
83011	4935	260139	1970-10-24	1970-11-07	1
9717	576	4084167	2000-10-31	2000-10-31	1
87528	5213	439777	2018-05-27	2018-05-28	1
38953	2318	4112343	1995-07-17	1995-07-27	1
16348	967	4283893	1983-08-04	1983-11-10	1
23180	1385	4146173	1999-10-21	1999-11-20	1
39215	2329	40481087	1977-10-12	1977-10-26	1
60314	3571	260139	2017-07-17	2017-07-31	1
32755	1947	40481087	1981-12-18	1981-12-25	1
10439	615	28060	1911-07-20	1911-07-31	1
7235	426	4112343	1969-12-05	1969-12-18	1
5394	318	372328	1955-01-24	1955-04-11	1
44957	2677	134438	2000-04-15	2001-06-09	1
76726	4551	372328	1980-09-15	1980-12-31	1
41475	2468	4112343	1970-12-16	1970-12-27	1
33495	1989	260139	1967-10-25	1967-11-08	1
12382	732	80180	2015-11-19	2015-11-20	1
42316	2524	40481087	1999-05-18	1999-06-01	1
63042	3728	81151	1984-09-09	1984-09-23	1
37403	2220	81893	1986-11-25	1986-11-26	1
37946	2256	4296204	2004-12-20	2005-01-03	1
18744	1128	40481087	2014-02-07	2014-02-14	1
14449	855	372328	1962-03-18	1962-11-09	1
22617	1353	81151	1969-11-02	1969-11-30	1
29190	1729	257012	2004-05-15	2004-05-16	1
34211	2033	40481087	2002-07-11	2002-08-01	1
70862	4208	40481087	1977-10-02	1977-10-09	1
39831	2359	4112343	1926-10-10	1926-10-19	1
39564	2346	80180	1986-11-13	1986-11-14	1
88675	5277	40481087	1983-07-01	1983-07-22	1
37166	2204	28060	1967-06-22	1967-07-02	1
69423	4113	192671	1992-06-03	1992-06-04	1
40519	2412	81151	1952-06-05	1952-06-26	1
42512	2537	260139	2006-10-08	2006-10-22	1
84239	5013	80180	2005-08-01	2005-08-02	1
27096	1604	258780	1999-03-11	1999-03-12	1
8705	510	4112343	2001-11-08	2001-11-21	1
66179	3921	4266809	2014-06-26	2014-06-27	1
13931	823	28060	2011-01-13	2011-01-24	1
47217	2812	81151	1991-07-12	1991-08-09	1
10842	642	4237458	1935-10-26	1936-01-24	1
67224	3976	40481087	2000-02-08	2000-02-15	1
56487	3353	260139	1947-01-27	1947-02-03	1
39035	2320	4109685	1976-08-03	1976-08-17	1
39750	2356	4266809	2017-02-10	2017-02-11	1
43970	2619	4112343	1979-12-15	1979-12-27	1
63611	3759	4112343	2005-09-01	2005-09-09	1
42654	2545	4218389	1977-06-29	1977-08-03	1
87055	5190	4109685	1971-05-21	1971-06-04	1
35782	2123	260139	1980-03-30	1980-04-06	1
85826	5113	0	2017-03-05	2017-03-06	1
83012	4935	372328	2008-06-11	2009-11-19	1
9718	576	4109685	1982-06-22	1982-07-06	1
87529	5213	4112343	1943-04-25	1943-05-04	1
38954	2318	4112343	2015-06-24	2015-07-03	1
16349	967	40481087	2016-04-13	2016-04-20	1
23181	1385	4296205	1997-11-09	1997-11-30	1
39216	2329	40481087	1979-12-21	1980-01-04	1
60315	3571	4112343	1994-06-16	1994-06-25	1
32756	1947	80502	2009-06-21	2009-06-22	1
10440	615	80180	1941-12-05	1941-12-06	1
7236	426	40481087	1988-08-20	1988-08-27	1
5395	318	440086	1966-05-01	1966-09-04	1
44958	2677	192671	2007-01-26	2007-01-27	1
76727	4551	4027663	2009-01-18	2009-01-19	1
41476	2468	4294548	1940-10-05	1940-11-02	1
33496	1989	372328	1952-11-11	1953-01-23	1
12383	732	260139	1986-07-18	1986-08-01	1
42317	2524	372328	1951-09-20	1951-11-24	1
63043	3728	260139	2005-11-19	2005-11-26	1
37404	2220	260139	1966-12-15	1966-12-22	1
37947	2256	260139	1992-09-05	1992-09-19	1
18745	1128	81893	2005-06-12	2005-06-13	1
14450	855	4094814	2001-04-15	2001-04-16	1
22618	1353	260139	2017-04-18	2017-04-25	1
29191	1729	40481087	1995-12-02	1995-12-09	1
34212	2033	80180	1995-02-25	1995-02-26	1
70863	4208	81151	1984-07-21	1984-08-11	1
39832	2359	4112343	1957-02-07	1957-02-16	1
39565	2346	260139	1952-11-03	1952-11-17	1
88676	5277	40481087	1998-08-06	1998-08-27	1
37167	2204	80180	1986-11-16	1986-11-17	1
69424	4113	260139	1978-05-25	1978-06-01	1
40520	2412	260139	1990-11-02	1990-11-16	1
42513	2537	381316	1998-09-06	1998-09-07	1
84240	5013	4294548	1990-08-28	1990-10-16	1
27097	1604	260139	1990-06-18	1990-07-02	1
8706	510	4218389	1984-12-23	1985-01-20	1
66180	3921	80180	2014-06-26	2014-06-27	1
13932	823	260139	2009-02-01	2009-02-08	1
47218	2812	378001	1939-07-01	1939-08-30	1
10843	642	4294548	1973-08-19	1973-09-16	1
69120	4094	4156265	2017-10-25	2017-11-08	1
56488	3353	260139	1947-12-14	1947-12-28	1
39036	2320	4112343	1952-11-19	1952-11-28	1
39751	2356	40481087	1987-08-18	1987-08-25	1
43971	2619	4112343	1982-08-15	1982-08-24	1
63612	3759	4142905	1974-07-18	1974-09-16	1
42655	2545	4283893	1972-05-30	1972-09-19	1
87056	5190	4112343	2006-07-19	2006-07-27	1
35783	2123	260139	1991-07-25	1991-08-08	1
85827	5113	28060	2013-05-02	2013-05-11	1
83013	4935	440448	1995-09-18	1995-09-19	1
9719	576	40481087	1994-09-24	1994-10-15	1
87530	5213	4155034	1975-03-04	1975-03-18	1
38955	2318	4294548	2013-09-21	2014-01-04	1
22906	1368	80180	1992-05-26	1992-05-27	1
23182	1385	4296205	2016-03-23	2016-04-13	1
39217	2329	40481087	1991-08-05	1991-08-12	1
60316	3571	4294548	2000-08-16	2001-02-28	1
32757	1947	260139	1951-12-17	1951-12-24	1
10441	615	81151	1944-11-19	1944-12-17	1
7237	426	40481087	2017-09-18	2017-10-09	1
5396	318	4112343	1960-06-27	1960-07-09	1
44959	2677	260139	2009-07-02	2009-07-09	1
76728	4551	4266809	2015-10-09	2015-10-10	1
41477	2468	40481087	1950-02-21	1950-03-07	1
33497	1989	378001	1953-01-10	1953-02-09	1
12384	732	260139	1988-12-27	1989-01-10	1
42318	2524	4112343	1968-03-11	1968-03-21	1
63044	3728	4059173	2007-07-30	2007-09-28	1
37405	2220	260139	1973-10-06	1973-10-13	1
37948	2256	40481087	2005-08-23	2005-09-06	1
18746	1128	4112343	1993-03-04	1993-03-15	1
16451	973	80180	1953-12-25	1953-12-26	1
22619	1353	4109685	1964-09-08	1964-09-29	1
29192	1729	28060	2015-01-03	2015-01-16	1
34213	2033	260139	1959-05-11	1959-05-25	1
70864	4208	81893	1977-11-07	1977-11-08	1
39833	2359	4112343	2002-08-02	2002-08-13	1
39566	2346	260139	1972-10-10	1972-10-24	1
88677	5277	40481087	2012-06-12	2012-06-19	1
37168	2204	260139	1952-12-05	1952-12-19	1
69425	4113	260139	2007-01-01	2007-01-15	1
40521	2412	4156265	1951-05-21	1951-06-11	1
42514	2537	4112343	1958-01-15	1958-01-22	1
84241	5013	40481087	1983-06-18	1983-07-02	1
27098	1604	4285898	1990-03-14	1990-03-15	1
8707	510	257012	1988-09-20	1988-09-21	1
66181	3921	192671	2014-09-04	2014-09-05	1
13933	823	375671	1998-01-02	1998-03-03	1
47219	2812	40481087	1958-10-25	1958-11-15	1
10844	642	4296205	1989-12-23	1990-01-20	1
69121	4094	40481087	2006-09-28	2006-10-12	1
56489	3353	260139	2012-06-20	2012-06-27	1
39037	2320	4112343	1992-11-03	1992-11-10	1
39752	2356	40481087	2012-05-01	2012-05-22	1
43972	2619	4112343	1986-12-02	1986-12-09	1
63613	3759	4152936	1987-03-26	1987-04-16	1
42656	2545	40481087	1971-05-10	1971-05-31	1
87057	5190	4142905	1969-04-01	1969-05-31	1
35784	2123	40481087	1959-06-01	1959-06-15	1
85828	5113	78272	2016-03-14	2016-04-18	1
83014	4935	4112343	1965-08-21	1965-09-02	1
9720	576	40481087	2012-12-16	2012-12-30	1
87531	5213	40481087	2016-10-16	2016-10-30	1
38956	2318	4310024	2000-12-12	2000-12-13	1
22907	1368	4112343	2008-02-28	2008-03-11	1
23183	1385	40481087	2013-06-20	2013-07-11	1
39218	2329	28060	1977-03-14	1977-03-26	1
60317	3571	40481087	1972-03-29	1972-04-12	1
32758	1947	4112343	1955-06-15	1955-06-22	1
10442	615	81151	1965-05-01	1965-05-22	1
7238	426	0	2007-01-04	2007-01-05	1
5397	318	4112343	2005-11-26	2005-12-08	1
44960	2677	372328	2015-01-29	2016-04-23	1
76729	4551	30753	2015-01-12	2015-01-13	1
41478	2468	40481087	1952-12-27	1953-01-17	1
33498	1989	378001	1953-12-06	1954-02-04	1
12385	732	4112343	1991-06-05	1991-06-12	1
42319	2524	4112343	1970-12-08	1970-12-15	1
63045	3728	4112343	1990-02-24	1990-03-05	1
37406	2220	260139	1991-06-07	1991-06-14	1
37949	2256	28060	1989-05-17	1989-05-29	1
18747	1128	28060	1987-01-21	1987-02-03	1
16452	973	80502	1994-09-12	1994-09-13	1
22620	1353	4112343	2011-03-27	2011-04-09	1
29193	1729	30753	2010-04-22	2010-04-23	1
34214	2033	260139	1962-03-17	1962-03-31	1
70865	4208	260139	1943-10-15	1943-10-29	1
39834	2359	4237458	1998-03-23	1998-04-22	1
39567	2346	260139	1983-05-14	1983-05-21	1
88678	5277	40481087	1982-12-06	1982-12-27	1
37169	2204	372328	1948-10-26	1949-02-16	1
69426	4113	372328	1961-07-20	1961-09-18	1
40522	2412	40481087	1966-04-30	1966-05-07	1
42515	2537	4296204	1991-03-11	1991-04-01	1
84242	5013	40481087	1987-01-18	1987-02-08	1
27099	1604	40481087	1978-11-10	1978-11-17	1
8708	510	260139	1984-09-27	1984-10-11	1
66182	3921	4027663	2007-11-05	2007-11-06	1
13934	823	381316	2019-04-15	2019-04-16	1
47220	2812	40481087	1978-10-21	1978-11-04	1
10845	642	40481087	1953-06-30	1953-07-14	1
69122	4094	28060	1968-03-31	1968-04-11	1
56490	3353	372328	1930-04-21	1930-12-13	1
39038	2320	4310024	1978-12-21	1978-12-22	1
45106	2686	260139	1969-09-07	1969-09-14	1
43973	2619	4294548	1948-09-18	1948-10-09	1
63614	3759	4266809	2009-03-16	2009-03-17	1
42657	2545	40481087	1975-03-16	1975-03-23	1
87058	5190	40481087	1965-01-27	1965-02-10	1
35785	2123	40481087	1991-04-08	1991-04-29	1
85829	5113	80180	2004-03-26	2004-03-27	1
83015	4935	4152936	1981-08-26	1981-09-09	1
9721	576	4112343	1971-06-24	1971-07-01	1
65436	3874	372328	1983-08-15	1983-11-30	1
38957	2318	40481087	2001-01-28	2001-02-18	1
22908	1368	4156265	1985-01-30	1985-02-20	1
23184	1385	28060	1972-11-29	1972-12-07	1
39219	2329	260139	2008-07-27	2008-08-10	1
63742	3769	78272	2003-11-06	2003-11-20	1
32759	1947	4112343	1959-08-13	1959-08-20	1
10443	615	260139	1914-01-03	1914-01-17	1
7239	426	134438	1984-01-16	1984-10-12	1
5398	318	4112343	2007-08-02	2007-08-11	1
44961	2677	4134304	1980-09-21	1980-10-21	1
76730	4551	80180	2015-10-09	2015-10-10	1
41479	2468	40481087	1993-11-30	1993-12-21	1
33499	1989	40481087	1992-04-16	1992-05-07	1
12386	732	40481087	1992-02-03	1992-02-24	1
42320	2524	4112343	1993-06-02	1993-06-11	1
63046	3728	4112343	1984-06-13	1984-06-21	1
37407	2220	4059173	2005-02-04	2005-05-05	1
37950	2256	192671	2012-05-31	2012-06-01	1
18748	1128	4112343	2002-11-26	2002-12-03	1
16453	973	260139	1953-09-02	1953-09-16	1
22621	1353	40481087	1985-10-21	1985-11-11	1
29194	1729	378001	1981-05-19	1981-07-18	1
34215	2033	260139	2013-03-25	2013-04-01	1
70866	4208	4112343	1976-09-06	1976-09-16	1
39835	2359	4283893	1938-07-20	1938-08-31	1
39568	2346	4112343	1959-09-05	1959-09-14	1
37170	2204	378001	1964-06-17	1964-08-16	1
69427	4113	4112343	1972-02-27	1972-03-08	1
40523	2412	40481087	1970-07-23	1970-08-13	1
42516	2537	40481087	1999-07-19	1999-08-02	1
84243	5013	317576	2010-09-10	2010-09-11	1
27100	1604	40481087	1990-02-25	1990-03-11	1
8709	510	378001	1977-03-03	1977-04-02	1
66183	3921	4230399	1999-07-10	1999-09-08	1
13935	823	4112343	1950-02-25	1950-03-05	1
47221	2812	260139	1999-07-20	1999-08-03	1
12790	756	372328	1968-04-04	1968-07-10	1
69123	4094	80180	1991-02-26	1991-02-27	1
56491	3353	4059173	1937-11-19	1937-12-19	1
39039	2320	40481087	1946-02-16	1946-03-09	1
45107	2686	260139	1996-10-24	1996-11-07	1
43974	2619	4310024	1976-03-31	1976-04-01	1
63615	3759	40481087	1970-09-15	1970-10-06	1
42658	2545	40481087	2005-04-10	2005-05-01	1
87059	5190	40481087	1967-02-18	1967-03-04	1
35786	2123	40481087	2008-04-06	2008-04-27	1
85830	5113	372328	1978-11-23	1979-03-24	1
83016	4935	40481087	1983-02-01	1983-02-08	1
9722	576	40481087	1991-12-27	1992-01-03	1
65437	3874	4134304	1986-09-28	1986-11-27	1
38958	2318	78272	1964-11-16	1964-12-21	1
22909	1368	4299128	1970-09-18	1970-10-16	1
23185	1385	80180	1999-12-20	1999-12-21	1
39220	2329	372328	1973-12-27	1974-06-18	1
63743	3769	81151	1951-03-18	1951-04-15	1
32760	1947	4294548	1987-03-20	1987-10-09	1
10444	615	260139	1982-05-22	1982-06-05	1
7240	426	260139	2015-12-05	2015-12-12	1
5399	318	80502	2013-09-02	2013-09-03	1
44962	2677	40481087	1982-07-07	1982-07-28	1
76731	4551	260139	1981-09-03	1981-09-17	1
41480	2468	40481087	2003-09-09	2003-09-30	1
33500	1989	80180	1986-07-26	1986-07-27	1
15449	917	260139	1981-02-11	1981-02-25	1
42321	2524	40481087	1987-07-20	1987-08-10	1
63047	3728	40481087	1988-03-22	1988-04-12	1
37408	2220	40481087	1944-06-10	1944-06-24	1
37951	2256	4112343	1993-05-12	1993-05-19	1
18749	1128	40481087	1993-02-05	1993-02-19	1
16454	973	260139	1993-12-03	1993-12-10	1
22622	1353	40481087	2001-03-31	2001-04-07	1
29195	1729	4027663	2003-09-01	2003-09-02	1
34216	2033	372328	1958-03-16	1958-05-13	1
70867	4208	4112343	1999-01-23	1999-02-04	1
39836	2359	40481087	1933-06-23	1933-07-07	1
39569	2346	4142905	1974-08-22	1974-09-21	1
37171	2204	439777	1954-09-11	1954-09-12	1
69428	4113	4112343	1985-02-11	1985-02-21	1
40524	2412	40481087	2008-02-14	2008-03-06	1
42517	2537	40481087	2010-12-29	2011-01-12	1
84244	5013	4112343	2000-02-26	2000-03-10	1
27101	1604	372328	1955-06-21	1955-10-06	1
8710	510	4112343	1979-07-22	1979-08-03	1
66184	3921	4296204	2004-08-12	2004-09-02	1
13936	823	4112343	1953-02-19	1953-02-26	1
47222	2812	372328	1940-04-26	1940-05-10	1
12791	756	372328	1985-04-12	1985-04-26	1
69124	4094	40481087	1997-10-26	1997-11-09	1
56492	3353	4112343	1939-03-18	1939-03-31	1
39040	2320	40481087	1952-09-10	1952-09-24	1
45108	2686	260139	2001-04-17	2001-05-01	1
43975	2619	40481087	1942-08-31	1942-09-14	1
67320	3984	78272	1969-05-17	1969-05-31	1
42659	2545	257012	1972-06-27	1972-06-28	1
87060	5190	40481087	2000-12-23	2001-01-13	1
35787	2123	80180	1986-11-29	1986-11-30	1
85831	5113	4112343	1971-01-08	1971-01-15	1
83017	4935	40481087	1988-08-17	1988-08-24	1
9723	576	40481087	2013-03-09	2013-03-23	1
65438	3874	40481087	1988-09-26	1988-10-10	1
38959	2318	198809	1969-03-09	1969-03-09	1
22910	1368	40481087	1973-07-05	1973-07-19	1
23186	1385	257012	2008-08-31	2008-09-01	1
39221	2329	4112343	1996-04-01	1996-04-08	1
63744	3769	4112343	1978-04-29	1978-05-10	1
32761	1947	40481087	1970-09-21	1970-10-05	1
10445	615	372328	1915-03-27	1916-01-29	1
7241	426	4112343	1975-05-06	1975-05-13	1
5400	318	260139	2004-07-05	2004-07-19	1
44963	2677	40481087	1988-01-29	1988-02-05	1
76732	4551	4134304	2001-04-20	2001-07-19	1
45598	2712	260139	1988-09-26	1988-10-03	1
33501	1989	4112343	2010-08-14	2010-08-24	1
15450	917	260139	1990-04-16	1990-04-23	1
42322	2524	261325	2002-07-06	2002-07-07	1
63048	3728	80180	2011-01-21	2011-01-22	1
37409	2220	40481087	1953-03-15	1953-03-29	1
37952	2256	40481087	1994-09-06	1994-09-13	1
21060	1266	78272	1991-02-07	1991-03-14	1
16455	973	4112343	1945-04-07	1945-04-17	1
22623	1353	40481087	2006-02-19	2006-03-12	1
29196	1729	4112343	2001-05-05	2001-05-15	1
34217	2033	4112343	2003-07-14	2003-07-22	1
70868	4208	4294548	1995-08-05	1996-04-13	1
39837	2359	40481087	2003-08-02	2003-08-23	1
39570	2346	4142905	2016-09-10	2016-12-09	1
37172	2204	4112343	1949-09-25	1949-10-02	1
69429	4113	4113008	2005-11-08	2005-11-29	1
40525	2412	4112343	1954-12-04	1954-12-13	1
43917	2617	257012	2009-07-30	2009-07-31	1
84245	5013	4113008	2003-04-11	2003-04-25	1
27102	1604	372328	1957-10-25	1958-10-09	1
8711	510	4112343	1979-11-02	1979-11-14	1
66185	3921	260139	2008-02-25	2008-03-10	1
13937	823	4112343	1969-02-14	1969-02-24	1
47223	2812	4112343	2014-11-25	2014-12-02	1
12792	756	4112343	1981-05-25	1981-06-02	1
69125	4094	40481087	2010-06-01	2010-06-22	1
56493	3353	4112343	1993-11-28	1993-12-10	1
39041	2320	40481087	1962-08-10	1962-08-24	1
45109	2686	4112343	1962-05-18	1962-05-27	1
43976	2619	40481087	1976-06-18	1976-07-09	1
67321	3984	4218389	2016-01-05	2016-02-02	1
42660	2545	375671	1961-02-23	1961-03-25	1
87061	5190	40481087	2008-06-12	2008-06-26	1
35788	2123	260139	1967-01-24	1967-01-31	1
85832	5113	4112343	2007-01-10	2007-01-19	1
84566	5035	0	2003-03-03	2003-03-04	1
9724	576	81151	1999-06-28	1999-07-12	1
65439	3874	40481087	1994-06-16	1994-06-30	1
38960	2318	372328	1963-08-24	1963-10-05	1
22911	1368	40481087	1997-10-12	1997-10-26	1
23187	1385	260139	2012-01-26	2012-02-02	1
39222	2329	40481087	2016-01-16	2016-01-23	1
63745	3769	4218389	1970-05-05	1970-06-02	1
32762	1947	40481087	1982-08-30	1982-09-06	1
10446	615	4084167	1926-12-24	1926-12-24	1
7242	426	40481087	1980-03-07	1980-03-14	1
5401	318	4094814	2011-02-11	2011-05-12	1
44964	2677	40481087	1995-05-08	1995-05-29	1
76733	4551	4283893	2003-09-02	2003-11-11	1
45599	2712	372328	1964-05-29	1964-09-08	1
33502	1989	4218389	2010-07-20	2010-08-10	1
15451	917	372328	1967-11-10	1968-04-25	1
42323	2524	372328	1950-08-12	1950-08-26	1
63049	3728	81151	1987-08-09	1987-08-23	1
37410	2220	40481087	1965-02-01	1965-02-22	1
37953	2256	80180	2012-03-23	2012-03-24	1
21061	1266	260139	2000-06-26	2000-07-03	1
16456	973	4112343	2005-12-18	2005-12-27	1
22624	1353	80180	1992-11-05	1992-11-06	1
29197	1729	4112343	2018-03-04	2018-03-17	1
34218	2033	40481087	1972-01-18	1972-02-01	1
70869	4208	4310024	1977-08-09	1977-08-10	1
39925	2369	4112343	1981-12-31	1982-01-10	1
39571	2346	40481087	1982-08-23	1982-08-30	1
37173	2204	4112343	1982-12-13	1982-12-21	1
69430	4113	4156265	2008-10-14	2008-10-28	1
40526	2412	4296204	1982-11-16	1982-12-14	1
43918	2617	378001	1970-08-31	1970-09-30	1
84246	5013	81151	1969-06-17	1969-07-08	1
27103	1604	4237458	2018-12-27	2019-01-26	1
8712	510	4266809	2008-01-10	2008-01-11	1
66186	3921	372328	1982-02-09	1982-04-21	1
13938	823	4112343	2009-12-08	2009-12-18	1
47224	2812	4230399	1947-06-19	1947-08-18	1
12793	756	4112343	2015-08-06	2015-08-16	1
69126	4094	40481087	2016-03-31	2016-04-14	1
56494	3353	4134304	1948-05-16	1948-06-15	1
39042	2320	40481087	1993-01-19	1993-01-26	1
45110	2686	4112343	1971-06-13	1971-06-22	1
43977	2619	40481087	1996-06-08	1996-06-29	1
67322	3984	4278672	2018-07-21	2018-08-20	1
42661	2545	375671	1986-05-18	1986-07-17	1
87062	5190	28060	1974-10-21	1974-10-31	1
35789	2123	4112343	1963-05-23	1963-06-01	1
85833	5113	4112343	2019-05-13	2019-05-21	1
84567	5035	80180	1969-06-07	1969-06-08	1
9725	576	260139	2013-09-24	2013-10-08	1
65440	3874	40481087	2019-04-28	2019-05-19	1
38961	2318	4112343	1964-01-24	1964-02-01	1
22912	1368	40481087	2006-02-20	2006-02-27	1
23188	1385	4112343	1983-11-24	1983-12-05	1
39223	2329	4112343	1978-04-23	1978-05-03	1
63746	3769	40481087	1951-01-26	1951-02-16	1
32763	1947	40481087	2004-05-20	2004-06-03	1
10447	615	4112343	2004-06-18	2004-06-27	1
7243	426	80180	2011-01-22	2011-01-23	1
5402	318	4112343	1973-10-03	1973-10-10	1
46992	2799	4112343	1986-06-02	1986-06-14	1
76734	4551	40481087	1979-07-23	1979-08-06	1
45600	2712	372328	1966-09-05	1966-12-06	1
33503	1989	40481087	1963-11-20	1963-11-27	1
15452	917	440086	1973-05-13	1976-10-17	1
42324	2524	40481087	1963-06-11	1963-06-25	1
63050	3728	4283893	1982-11-24	1983-01-26	1
37411	2220	40481087	1968-11-08	1968-11-22	1
37954	2256	260139	1992-02-23	1992-03-08	1
21062	1266	260139	2004-12-11	2004-12-18	1
16457	973	4113008	1998-02-16	1998-03-09	1
22625	1353	4112343	1966-01-04	1966-01-11	1
31809	1892	80180	1993-09-19	1993-09-20	1
34219	2033	81151	2006-11-29	2006-12-27	1
70870	4208	40481087	1986-09-29	1986-10-13	1
39926	2369	4112343	1994-06-08	1994-06-19	1
39572	2346	40481087	1986-07-15	1986-08-05	1
37174	2204	4156265	1986-03-21	1986-04-04	1
69431	4113	4218389	1964-06-04	1964-06-25	1
40527	2412	80180	1994-12-01	1994-12-02	1
43919	2617	4112343	1965-04-18	1965-04-27	1
84247	5013	260139	1966-10-12	1966-10-19	1
27104	1604	4310024	1989-02-17	1989-02-18	1
8713	510	40481087	1988-03-06	1988-03-13	1
66187	3921	372328	1983-08-14	1983-10-19	1
13939	823	40481087	1966-04-24	1966-05-08	1
47225	2812	40481087	1959-06-19	1959-07-10	1
12794	756	4237458	1974-02-18	1974-05-19	1
69127	4094	28060	2004-09-16	2004-09-23	1
56495	3353	40481087	1942-03-18	1942-04-01	1
39043	2320	40481087	2004-11-02	2004-11-16	1
45111	2686	4112343	2013-08-23	2013-09-04	1
43978	2619	40481087	2016-07-25	2016-08-01	1
67323	3984	40481087	2009-10-05	2009-10-26	1
42662	2545	378001	1951-08-15	1951-09-14	1
87063	5190	81151	1986-03-17	1986-03-31	1
35790	2123	4296204	1984-06-17	1984-07-15	1
85834	5113	4218389	2014-04-03	2014-04-24	1
84568	5035	260139	1990-04-07	1990-04-14	1
9726	576	4112343	1979-01-22	1979-02-03	1
65441	3874	28060	2016-06-09	2016-06-16	1
38962	2318	4112343	1972-01-02	1972-01-11	1
22913	1368	40481087	2007-01-01	2007-01-08	1
23189	1385	4112343	1992-11-06	1992-11-17	1
39224	2329	4112343	2012-09-13	2012-09-24	1
63747	3769	40481087	1971-06-06	1971-06-20	1
32764	1947	80180	1989-10-22	1989-10-23	1
10448	615	4116491	1958-01-10	1958-02-27	1
7244	426	260139	1988-01-08	1988-01-15	1
5403	318	4294548	1959-06-09	1959-12-01	1
46993	2799	4112343	2008-05-23	2008-05-31	1
76735	4551	40481087	1989-02-04	1989-02-11	1
45601	2712	40479422	1998-11-23	1998-12-30	1
33504	1989	40481087	2008-11-14	2008-12-05	1
15453	917	4112343	2015-06-26	2015-07-03	1
42325	2524	40481087	1966-09-12	1966-09-19	1
63051	3728	40481087	1988-01-07	1988-01-14	1
37412	2220	40481087	1971-05-18	1971-06-08	1
37955	2256	4142905	1990-06-07	1990-07-07	1
21063	1266	260139	2017-12-11	2017-12-25	1
16458	973	260139	1944-07-27	1944-08-03	1
22626	1353	4142905	1968-08-09	1968-11-07	1
31810	1892	260139	2006-05-24	2006-05-31	1
34220	2033	4112343	1983-07-06	1983-07-19	1
70871	4208	40481087	1999-11-28	1999-12-12	1
39927	2369	40481087	1995-02-26	1995-03-12	1
39573	2346	40481087	1997-03-17	1997-04-07	1
37175	2204	4156265	2000-06-20	2000-07-04	1
69432	4113	40481087	1960-05-17	1960-05-24	1
40528	2412	372328	1951-02-20	1951-05-04	1
43920	2617	4112343	1995-05-30	1995-06-09	1
84248	5013	260139	1990-07-26	1990-08-09	1
27105	1604	40479422	1973-04-15	1973-05-22	1
8714	510	260139	1979-11-19	1979-12-03	1
69269	4105	260139	1947-12-03	1947-12-17	1
13940	823	40481087	1971-11-15	1971-11-29	1
47226	2812	40481087	1992-08-11	1992-09-01	1
12795	756	4310024	1998-02-22	1998-02-23	1
69128	4094	260139	1959-12-17	1959-12-24	1
56496	3353	40481087	1958-08-01	1958-08-15	1
40449	2406	28060	1975-05-30	1975-06-10	1
45112	2686	4112343	2015-12-26	2016-01-07	1
43979	2619	80180	1978-08-18	1978-08-19	1
67324	3984	80180	1995-02-01	1995-02-02	1
42663	2545	439777	1968-07-20	1968-07-21	1
87064	5190	260139	1998-07-20	1998-08-04	1
35791	2123	80502	2009-06-19	2009-06-20	1
85835	5113	40481087	1987-11-15	1987-11-29	1
84569	5035	4027663	1961-05-25	1961-05-26	1
9727	576	4113008	1997-04-18	1997-05-09	1
65442	3874	260139	2012-06-15	2012-06-29	1
38963	2318	4112343	1987-12-16	1987-12-24	1
22914	1368	28060	1976-09-02	1976-09-09	1
23190	1385	4296205	2003-06-02	2003-06-30	1
39225	2329	40481087	1995-09-28	1995-10-12	1
63748	3769	40481087	1976-10-11	1976-10-18	1
32765	1947	260139	1986-12-20	1986-12-27	1
10449	615	4134304	1995-01-29	1995-04-29	1
7245	426	4112343	1971-06-14	1971-06-22	1
5404	318	80180	1994-12-10	1994-12-11	1
46994	2799	4278672	1995-05-14	1995-06-13	1
76736	4551	40481087	2016-03-11	2016-04-01	1
45602	2712	40481087	1974-03-15	1974-03-22	1
33505	1989	40481087	2017-05-27	2017-06-17	1
15454	917	4296205	1977-07-31	1977-09-04	1
42326	2524	40481087	1975-12-20	1976-01-10	1
63052	3728	40481087	1995-04-12	1995-04-26	1
37413	2220	40481087	1976-03-20	1976-04-03	1
37956	2256	4146173	1984-05-09	1984-07-08	1
21064	1266	4134304	1971-03-19	1971-04-18	1
16459	973	260139	1990-04-27	1990-05-11	1
22627	1353	257012	1961-11-17	1961-11-18	1
31811	1892	260139	2008-11-08	2008-11-22	1
34221	2033	4112343	2017-07-25	2017-08-03	1
70872	4208	78272	2012-09-18	2012-10-09	1
39928	2369	40481087	2015-04-02	2015-04-09	1
39574	2346	40481087	2004-12-03	2004-12-17	1
37176	2204	40481087	1972-02-17	1972-02-24	1
69433	4113	40481087	1976-07-20	1976-08-03	1
40529	2412	4112343	2001-06-26	2001-07-07	1
43921	2617	4112343	2018-07-10	2018-07-19	1
84249	5013	4218389	1966-07-12	1966-08-02	1
27106	1604	40481087	1962-06-19	1962-07-03	1
8715	510	260139	2006-08-03	2006-08-17	1
69270	4105	381316	2019-02-16	2019-02-17	1
13941	823	40481087	1980-05-24	1980-06-14	1
47227	2812	4035415	2000-04-23	2000-06-22	1
12796	756	40481087	1979-04-28	1979-05-05	1
69129	4094	260139	1974-09-08	1974-09-22	1
56497	3353	40481087	1975-10-22	1975-11-12	1
40450	2406	81151	1958-01-20	1958-02-17	1
45113	2686	40481087	1985-08-24	1985-09-14	1
43980	2619	260139	2013-02-24	2013-03-03	1
67325	3984	260139	1957-05-07	1957-05-21	1
42664	2545	4112343	1977-08-31	1977-09-10	1
87065	5190	372328	1993-04-20	1994-10-28	1
35792	2123	260139	1961-06-06	1961-06-13	1
85836	5113	28060	2011-07-31	2011-08-10	1
84570	5035	4112343	1975-01-12	1975-01-24	1
9728	576	4296204	1969-04-17	1969-05-01	1
65443	3874	4027663	2006-12-17	2006-12-18	1
38964	2318	40481087	1995-11-22	1995-12-06	1
22915	1368	260139	1971-07-03	1971-07-17	1
23191	1385	40481087	2002-10-31	2002-11-14	1
40879	2435	28060	1979-07-17	1979-07-24	1
63749	3769	40481087	1985-08-08	1985-08-15	1
32766	1947	4278672	1956-05-22	1956-08-20	1
10450	615	4155034	1996-04-23	1996-05-14	1
7246	426	40481087	1981-12-12	1981-12-19	1
5405	318	4112343	1977-01-25	1977-02-06	1
46995	2799	4285898	2017-10-15	2017-10-16	1
76737	4551	40481087	2017-08-30	2017-09-13	1
45603	2712	40481087	1988-09-08	1988-09-29	1
33506	1989	28060	1954-02-05	1954-02-13	1
15455	917	40481087	1970-06-26	1970-07-10	1
43145	2572	81893	2008-08-08	2008-08-09	1
63053	3728	40481087	2000-12-30	2001-01-13	1
37414	2220	40481087	1976-06-08	1976-06-29	1
37957	2256	40481087	1985-11-08	1985-11-15	1
21065	1266	4294548	1993-04-20	1993-07-20	1
16460	973	372328	1918-11-24	1919-04-28	1
22628	1353	260139	1968-10-19	1968-11-02	1
31812	1892	372328	1964-07-23	1965-06-24	1
34222	2033	4237458	1956-04-25	1956-07-24	1
70873	4208	80809	1972-11-13	1972-11-27	1
39929	2369	28060	2002-09-07	2002-09-16	1
39575	2346	40481087	2016-12-22	2016-12-29	1
37177	2204	40481087	1977-11-02	1977-11-16	1
69434	4113	40481087	1995-07-25	1995-08-08	1
40530	2412	4112343	2009-12-24	2010-01-05	1
43922	2617	4156265	2016-06-05	2016-06-26	1
88899	5295	372328	1910-05-27	1910-09-07	1
29660	1758	81151	1988-06-07	1988-07-12	1
8716	510	372328	1966-08-28	1966-12-10	1
69271	4105	4112343	1969-01-28	1969-02-07	1
13942	823	40481087	1995-04-06	1995-04-13	1
47228	2812	4152936	1962-08-29	1962-09-12	1
12797	756	40481087	1983-06-19	1983-07-03	1
69130	4094	260139	1992-09-27	1992-10-04	1
56498	3353	40481087	1990-09-29	1990-10-13	1
40451	2406	260139	1954-09-07	1954-09-21	1
45114	2686	28060	2011-03-25	2011-04-04	1
43981	2619	372328	1941-01-29	1941-04-18	1
67326	3984	260139	1989-08-31	1989-09-14	1
42665	2545	4112343	1992-09-06	1992-09-13	1
87066	5190	378001	2016-01-05	2016-03-05	1
35793	2123	260139	1974-03-12	1974-03-19	1
85837	5113	4109685	1978-12-28	1979-01-18	1
84571	5035	4283893	1945-08-27	1945-12-24	1
9729	576	40486433	1971-09-06	1971-09-07	1
65444	3874	4266809	2014-10-06	2014-10-07	1
38965	2318	30753	2001-11-07	2001-11-08	1
22916	1368	378001	1994-06-03	1994-08-02	1
23192	1385	260139	2007-05-14	2007-05-28	1
40880	2435	28060	2011-01-26	2011-02-06	1
63750	3769	40481087	2017-06-18	2017-06-25	1
32767	1947	40481087	1949-04-21	1949-04-28	1
10451	615	4237458	2003-02-21	2003-03-23	1
7247	426	28060	1967-12-05	1967-12-15	1
5406	318	4112343	2010-04-01	2010-04-14	1
46996	2799	4310024	2017-01-18	2017-01-19	1
78093	4631	28060	1920-12-01	1920-12-10	1
45604	2712	40481087	2007-08-29	2007-09-05	1
33507	1989	81151	1956-12-20	1957-01-17	1
15456	917	40481087	1976-10-12	1976-11-02	1
43146	2572	4155034	1971-05-15	1971-05-29	1
63054	3728	260139	2012-05-03	2012-05-17	1
38118	2266	372328	1971-12-11	1972-05-20	1
38800	2307	372328	1966-08-25	1966-09-08	1
21066	1266	40481087	1978-06-15	1978-06-22	1
16461	973	4112343	1951-01-20	1951-02-01	1
22629	1353	372328	1960-06-01	1961-02-13	1
31813	1892	4112343	1987-12-16	1987-12-29	1
34223	2033	4283893	1984-02-07	1985-03-12	1
70874	4208	257012	1995-09-02	1995-09-03	1
39930	2369	40486433	1985-05-09	2000-05-07	1
39576	2346	28060	2019-02-13	2019-02-21	1
37178	2204	40481087	1979-07-16	1979-07-23	1
69435	4113	28060	1984-05-05	1984-05-13	1
40531	2412	40481087	1996-03-04	1996-03-11	1
43923	2617	40481087	1973-07-26	1973-08-09	1
88900	5295	378419	1995-09-06	1995-09-07	1
29661	1758	260139	2013-01-22	2013-02-05	1
8717	510	372328	1967-06-08	1967-09-09	1
69272	4105	4112343	1973-11-15	1973-11-24	1
13943	823	40481087	2001-07-16	2001-08-06	1
47229	2812	40481087	1981-08-26	1981-09-02	1
12798	756	40481087	1987-06-21	1987-06-28	1
69131	4094	260139	2010-09-02	2010-09-09	1
56499	3353	40481087	1991-01-20	1991-02-03	1
40452	2406	381316	1993-09-23	1993-09-24	1
45115	2686	260139	1962-01-10	1962-01-24	1
43982	2619	372328	1945-10-24	1946-10-11	1
67327	3984	40481087	1975-08-07	1975-08-28	1
42666	2545	40481087	1969-07-27	1969-08-10	1
87067	5190	40481087	1959-05-28	1959-06-04	1
35794	2123	372328	1952-07-22	1952-09-26	1
85838	5113	40479422	1974-02-15	1974-03-24	1
84572	5035	4283893	2003-07-19	2003-08-02	1
12343	730	28060	1973-12-18	1973-12-28	1
65445	3874	4280726	1983-12-30	2000-12-27	1
38966	2318	80180	2003-05-01	2003-05-02	1
22917	1368	4113008	1958-04-10	1958-04-24	1
23193	1385	4112343	1975-09-27	1975-10-05	1
40881	2435	260139	2014-03-07	2014-03-21	1
63751	3769	260139	1954-04-02	1954-04-09	1
32768	1947	40481087	1958-02-19	1958-03-05	1
10452	615	40480160	2003-02-21	2003-03-23	1
7248	426	440448	2007-01-04	2007-01-05	1
5407	318	40481087	1958-03-17	1958-04-07	1
46997	2799	40481087	1995-07-17	1995-07-24	1
78094	4631	28060	1921-03-14	1921-03-23	1
45605	2712	260139	1980-07-01	1980-07-08	1
33508	1989	4109685	1984-01-26	1984-02-16	1
15457	917	40481087	1990-04-01	1990-04-22	1
43147	2572	40481087	1995-10-24	1995-10-31	1
63055	3728	4155034	1995-04-13	1995-05-04	1
38119	2266	4112343	1996-05-09	1996-05-19	1
38801	2307	372328	1967-05-06	1967-09-19	1
21067	1266	40481087	1989-06-19	1989-07-03	1
16462	973	4112343	1960-09-13	1960-09-23	1
22630	1353	378001	1982-09-23	1982-10-23	1
31814	1892	4113008	1968-02-24	1968-03-16	1
34224	2033	40481087	1965-12-09	1965-12-23	1
70875	4208	321042	1981-04-07	1981-04-08	1
39931	2369	260139	2004-07-03	2004-07-17	1
39577	2346	372328	1946-12-03	1947-01-15	1
37179	2204	40481087	2016-05-13	2016-06-03	1
69436	4113	81151	1990-04-10	1990-04-24	1
40532	2412	40481087	2018-10-15	2018-10-22	1
43924	2617	40481087	1984-04-12	1984-05-03	1
88901	5295	381316	1982-07-07	1982-07-08	1
29662	1758	4112343	1974-03-24	1974-04-02	1
8718	510	372328	1969-09-28	1970-09-12	1
69273	4105	4283893	1948-01-06	1948-03-02	1
16643	987	80180	1988-01-09	1988-01-10	1
48261	2863	30753	2005-01-26	2005-01-27	1
12799	756	40481087	2000-04-20	2000-05-04	1
69132	4094	372328	1963-03-15	1963-07-04	1
57953	3439	260139	1970-02-22	1970-03-01	1
40453	2406	4112343	1964-03-05	1964-03-14	1
45116	2686	4109685	1967-12-02	1967-12-16	1
43983	2619	4059173	1948-06-21	1948-07-21	1
67328	3984	78272	1970-06-25	1970-07-30	1
42667	2545	40481087	1984-02-10	1984-02-24	1
87068	5190	40481087	1962-02-23	1962-03-09	1
35795	2123	372328	1958-01-11	1958-04-25	1
85839	5113	40481087	1990-05-23	1990-06-06	1
84573	5035	4310024	1967-04-19	1967-04-20	1
12344	730	260139	1962-09-16	1962-09-30	1
65446	3874	30753	2013-08-12	2013-08-13	1
38967	2318	260139	1979-09-01	1979-09-15	1
22918	1368	40481087	1971-02-20	1971-03-13	1
23194	1385	4112343	1991-06-30	1991-07-12	1
40882	2435	372328	1988-02-07	1988-09-23	1
63752	3769	260139	1964-02-10	1964-02-24	1
32769	1947	40481087	2011-09-04	2011-09-18	1
10453	615	40481087	1917-07-19	1917-07-26	1
7249	426	4283893	1989-04-30	1989-06-11	1
5408	318	40481087	1979-04-25	1979-05-16	1
46998	2799	40481087	2010-12-08	2010-12-15	1
78095	4631	81151	2013-05-01	2013-05-22	1
45606	2712	372328	1966-04-01	1966-06-07	1
33509	1989	4112343	1976-02-20	1976-02-29	1
15458	917	260139	2004-01-19	2004-02-02	1
43148	2572	260139	2005-01-18	2005-01-25	1
63056	3728	40481087	2007-02-19	2007-02-26	1
38120	2266	4112343	2009-05-14	2009-05-24	1
38802	2307	372328	1985-07-16	1986-12-09	1
21068	1266	257012	1980-02-02	1980-02-03	1
16463	973	4113008	1997-04-08	1997-04-22	1
22631	1353	4112343	2001-09-09	2001-09-16	1
31815	1892	4116491	1999-07-05	1999-08-09	1
34225	2033	40481087	1970-03-07	1970-03-21	1
70876	4208	378419	2008-04-08	2008-04-09	1
39932	2369	260139	2006-07-09	2006-07-23	1
39578	2346	372328	1949-09-01	1950-01-11	1
37180	2204	28060	1950-07-03	1950-07-15	1
69437	4113	260139	1972-02-04	1972-02-18	1
42747	2550	28060	1986-05-02	1986-05-09	1
43925	2617	78272	2001-03-21	2001-04-25	1
88902	5295	4112343	1917-02-12	1917-02-23	1
29663	1758	4112343	2017-01-16	2017-01-27	1
8719	510	4048695	1983-09-28	1983-11-29	1
69274	4105	40481087	1979-10-03	1979-10-17	1
16644	987	80502	2013-10-27	2013-10-28	1
48262	2863	257012	1994-10-19	1994-10-20	1
12800	756	40481087	2011-03-16	2011-03-23	1
69133	4094	4237458	1959-09-02	1959-11-01	1
57954	3439	260139	1988-04-26	1988-05-03	1
40454	2406	4112343	1974-07-22	1974-08-01	1
45117	2686	4218389	2009-12-10	2010-01-14	1
43984	2619	4112343	1949-02-16	1949-02-24	1
67329	3984	81151	1964-08-27	1964-09-10	1
42668	2545	28060	1988-05-16	1988-05-29	1
87069	5190	40481087	1965-12-12	1965-12-19	1
35796	2123	4059173	1959-05-30	1959-08-28	1
85840	5113	40481087	2017-04-22	2017-05-13	1
84574	5035	40481087	1985-05-27	1985-06-17	1
12345	730	260139	2013-08-10	2013-08-24	1
65447	3874	4112343	1985-03-08	1985-03-18	1
38968	2318	4294548	1991-04-06	1991-12-07	1
22919	1368	40481087	1974-12-20	1975-01-03	1
23195	1385	40481087	1966-03-21	1966-04-04	1
40883	2435	40481087	2007-06-09	2007-06-16	1
63753	3769	260139	1981-07-29	1981-08-05	1
32770	1947	28060	1956-06-17	1956-06-25	1
10454	615	40481087	1947-08-07	1947-08-14	1
7250	426	40481087	1990-06-14	1990-07-05	1
5539	328	30753	2013-08-16	2013-08-17	1
46999	2799	372328	1985-04-06	1986-03-19	1
78096	4631	260139	1913-10-09	1913-10-16	1
45607	2712	4112343	2008-01-25	2008-02-07	1
33510	1989	4146173	1976-12-03	1977-01-02	1
15459	917	372328	1965-05-05	1965-10-21	1
43149	2572	260139	2015-02-04	2015-02-11	1
63057	3728	40481087	2013-07-03	2013-07-17	1
38121	2266	4218389	2015-07-07	2015-08-11	1
38803	2307	4112343	1977-05-25	1977-06-02	1
21069	1266	378001	1976-03-22	1976-05-21	1
16464	973	40481087	1920-12-18	1920-12-25	1
22632	1353	4112343	2007-02-21	2007-03-05	1
31816	1892	40481087	1978-10-13	1978-11-03	1
34226	2033	40481087	1972-08-04	1972-08-11	1
70877	4208	4027663	1971-11-14	1971-11-15	1
39933	2369	4051466	1984-05-09	2001-04-01	1
39579	2346	378001	1953-03-01	1953-03-31	1
37181	2204	28060	1955-04-20	1955-05-01	1
69438	4113	4237458	1969-03-31	1969-04-30	1
42748	2550	78272	2001-07-10	2001-07-31	1
43926	2617	260139	1969-08-28	1969-09-04	1
88903	5295	4112343	1934-01-26	1934-02-06	1
29664	1758	40481087	1987-03-26	1987-04-02	1
8720	510	4112343	2001-06-24	2001-07-07	1
69275	4105	40481087	1988-05-04	1988-05-11	1
16645	987	260139	1954-01-28	1954-02-11	1
48263	2863	40481087	2010-11-25	2010-12-16	1
12801	756	81893	1999-01-18	1999-01-19	1
69134	4094	4296204	1967-03-24	1967-04-21	1
57955	3439	313217	2015-12-10	2015-12-11	1
40455	2406	4112343	1978-08-26	1978-09-06	1
45118	2686	4278672	1994-03-20	1994-06-18	1
43985	2619	4112343	1987-06-10	1987-06-22	1
67330	3984	260139	1958-03-26	1958-04-02	1
42669	2545	80180	1987-01-02	1987-01-03	1
88845	5290	317576	2017-08-11	2017-08-12	1
35797	2123	4094814	1995-10-23	1995-12-22	1
85841	5113	440448	2017-03-05	2017-03-06	1
84575	5035	192671	1969-07-27	1969-07-28	1
12346	730	4134304	1960-05-02	1960-07-31	1
65448	3874	4112343	1998-05-25	1998-06-04	1
40713	2424	260139	1991-10-31	1991-11-07	1
22920	1368	40481087	1985-07-14	1985-07-21	1
23196	1385	28060	1970-07-21	1970-07-31	1
40884	2435	80180	2015-11-20	2015-11-21	1
63754	3769	381316	2016-04-17	2016-04-18	1
32771	1947	81151	1954-03-20	1954-04-03	1
10455	615	40481087	1978-12-19	1979-01-09	1
7251	426	40481087	2000-08-18	2000-09-08	1
5540	328	372328	1981-12-12	1982-04-04	1
47000	2799	4156265	2000-05-17	2000-05-31	1
78097	4631	260139	1918-12-21	1918-12-28	1
45608	2712	4113008	2003-08-06	2003-08-27	1
33511	1989	40479422	1988-10-22	1988-11-28	1
15460	917	4094814	2005-11-06	2006-02-04	1
43150	2572	4027663	1999-06-17	1999-06-18	1
64456	3814	260139	1983-02-01	1983-02-15	1
38122	2266	4285898	2008-02-28	2008-02-29	1
38804	2307	4278672	2013-02-07	2013-03-09	1
21070	1266	4112343	2018-10-21	2018-10-30	1
16465	973	40481087	1926-02-21	1926-03-14	1
22633	1353	4112343	2009-12-22	2009-12-30	1
31817	1892	40481087	1989-06-15	1989-07-06	1
34227	2033	40481087	1975-08-23	1975-09-06	1
70878	4208	4112343	1944-05-13	1944-05-20	1
39934	2369	80180	2018-07-18	2018-07-19	1
39580	2346	378001	1991-11-21	1991-12-21	1
37182	2204	260139	1986-09-18	1986-09-25	1
69439	4113	40479422	1997-01-17	1997-02-23	1
42749	2550	80180	2019-06-26	2019-06-27	1
43927	2617	4112343	1972-05-22	1972-05-29	1
88904	5295	4112343	1941-10-13	1941-10-22	1
29665	1758	40481087	1991-09-15	1991-10-06	1
8721	510	4218389	2012-02-05	2012-02-26	1
69276	4105	80180	1983-04-12	1983-04-13	1
16646	987	4112343	2011-07-28	2011-08-04	1
48264	2863	40481087	2019-05-01	2019-05-08	1
12802	756	260139	2005-01-04	2005-01-11	1
69135	4094	28060	1957-10-15	1957-10-24	1
57956	3439	4112343	1952-05-27	1952-06-09	1
40456	2406	4112343	1985-01-15	1985-01-25	1
45119	2686	40481087	1989-10-29	1989-11-19	1
43986	2619	4296204	1976-06-22	1976-07-20	1
67331	3984	260139	1963-12-13	1963-12-27	1
42670	2545	255848	2008-01-06	2008-01-07	1
88846	5290	4112343	1994-11-03	1994-11-15	1
35798	2123	4112343	1952-01-08	1952-01-17	1
85842	5113	4059173	1986-01-02	1986-02-01	1
84576	5035	257012	1945-10-08	1945-10-09	1
12347	730	260139	1966-04-17	1966-04-24	1
65449	3874	4112343	2009-03-09	2009-03-17	1
40714	2424	372328	1964-03-05	1964-05-21	1
22921	1368	40481087	2018-09-13	2018-09-27	1
23197	1385	372328	1962-07-02	1962-10-19	1
40885	2435	81893	2014-02-28	2014-03-01	1
63755	3769	40481087	1960-01-05	1960-01-12	1
32772	1947	260139	1950-02-11	1950-02-25	1
10456	615	40481087	1997-03-29	1997-04-19	1
8109	476	260139	1985-07-31	1985-08-14	1
5541	328	4112343	2002-11-16	2002-11-26	1
47001	2799	40481087	1980-11-07	1980-11-14	1
78098	4631	260139	1936-04-01	1936-04-08	1
45609	2712	40481087	1987-07-18	1987-08-08	1
34982	2079	260139	2005-11-01	2005-11-08	1
15461	917	4146173	1976-08-05	1976-10-04	1
43151	2572	4112343	1979-08-05	1979-08-14	1
64457	3814	372328	1976-07-23	1976-11-07	1
38123	2266	40481087	1996-06-18	1996-07-09	1
38805	2307	40481087	1966-03-20	1966-04-10	1
21071	1266	4294548	1980-01-12	1980-03-01	1
16466	973	40481087	1932-01-10	1932-01-31	1
22634	1353	4152936	1986-05-05	1986-05-26	1
31818	1892	40481087	2013-02-06	2013-02-20	1
34228	2033	40481087	2000-02-01	2000-02-15	1
70879	4208	4112343	1962-04-03	1962-04-11	1
39935	2369	4084167	1981-12-29	1981-12-29	1
39581	2346	4112343	1950-01-19	1950-01-27	1
37183	2204	4112343	1966-05-16	1966-05-27	1
69440	4113	40481087	1983-04-17	1983-05-08	1
42750	2550	40481087	1986-06-07	1986-06-21	1
43928	2617	40481087	1979-11-12	1979-11-26	1
88905	5295	4112343	1993-09-08	1993-09-16	1
29666	1758	28060	1974-11-02	1974-11-13	1
8722	510	40481087	1975-06-17	1975-07-08	1
69277	4105	260139	1957-05-14	1957-05-28	1
16647	987	4113008	2004-02-19	2004-03-11	1
48265	2863	80180	2006-04-21	2006-04-22	1
12803	756	4027663	1991-07-29	1991-07-30	1
69136	4094	260139	1958-09-09	1958-09-23	1
57957	3439	4112343	1990-08-15	1990-08-25	1
40457	2406	40481087	1953-11-17	1953-11-24	1
45120	2686	40481087	1997-08-09	1997-08-23	1
43987	2619	40481087	1972-12-10	1972-12-31	1
67332	3984	260139	1975-05-09	1975-05-16	1
42671	2545	372328	1949-09-24	1950-07-20	1
88847	5290	40481087	1992-11-14	1992-11-21	1
35799	2123	4112343	1984-11-11	1984-11-19	1
85843	5113	4112343	1972-08-09	1972-08-20	1
84577	5035	260139	1996-12-10	1996-12-24	1
12348	730	372328	1958-10-05	1959-03-21	1
65450	3874	4285898	2014-05-09	2014-05-10	1
40715	2424	40481087	1968-09-16	1968-09-23	1
22922	1368	372328	1956-04-20	1956-06-27	1
23198	1385	378001	1972-09-21	1972-10-21	1
40886	2435	372328	1974-08-02	1974-10-18	1
63756	3769	40481087	1962-05-09	1962-05-16	1
32773	1947	4112343	1998-03-30	1998-04-09	1
10457	615	40481087	2009-10-20	2009-11-10	1
8110	476	372328	1972-06-21	1972-08-26	1
5542	328	4116491	2005-10-22	2005-12-15	1
47002	2799	40481087	1988-01-12	1988-01-19	1
78099	4631	4059173	2002-06-28	2002-09-26	1
45610	2712	40481087	1988-01-14	1988-02-04	1
34983	2079	40481087	1980-03-31	1980-04-21	1
15462	917	80180	2005-03-31	2005-04-01	1
43152	2572	4116491	2019-06-12	2019-06-13	1
64458	3814	4112343	1975-06-02	1975-06-10	1
38124	2266	40481087	2002-08-16	2002-08-30	1
38806	2307	40481087	1989-12-09	1989-12-23	1
21072	1266	40481087	2006-11-14	2006-11-28	1
16467	973	40481087	1982-05-07	1982-05-21	1
22635	1353	4294548	1961-10-13	1962-01-26	1
31819	1892	260139	1981-03-28	1981-04-04	1
34229	2033	28060	1992-09-01	1992-09-08	1
70880	4208	4112343	2000-04-30	2000-05-08	1
41589	2477	28060	1967-06-10	1967-06-18	1
39582	2346	4112343	1958-10-28	1958-11-05	1
37184	2204	4112343	1984-10-28	1984-11-03	1
69441	4113	40481087	1986-08-27	1986-09-10	1
42751	2550	257012	1997-08-21	1997-08-22	1
43929	2617	80180	1987-07-15	1987-07-16	1
88906	5295	4294548	1914-11-10	1915-05-25	1
29667	1758	81151	2000-01-11	2000-02-15	1
8723	510	80180	2008-01-10	2008-01-11	1
69278	4105	40481087	1977-04-26	1977-05-10	1
16648	987	4134304	2002-10-27	2003-01-25	1
48266	2863	81151	1972-02-19	1972-03-11	1
12804	756	4112343	1971-07-07	1971-07-16	1
69137	4094	440086	1965-09-10	1975-09-18	1
57958	3439	4112343	1998-03-17	1998-03-26	1
40458	2406	0	1961-05-11	1961-05-12	1
45121	2686	40481087	1999-05-21	1999-05-28	1
43988	2619	40481087	1996-01-10	1996-01-31	1
67333	3984	313217	2014-11-26	2014-11-27	1
42672	2545	4112343	1952-08-20	1952-08-29	1
88848	5290	40481087	2000-05-19	2000-06-09	1
35800	2123	4116491	2007-04-22	2007-05-27	1
85844	5113	4112343	1985-04-30	1985-05-10	1
84578	5035	4112343	1938-07-23	1938-08-02	1
12349	730	372328	1962-02-07	1962-03-24	1
68062	4024	78272	2005-07-10	2005-08-07	1
40716	2424	40481087	1994-03-12	1994-03-26	1
22923	1368	372328	1956-10-25	1956-11-28	1
23199	1385	4112343	2006-11-20	2006-12-01	1
40887	2435	4027663	2004-11-02	2004-11-03	1
63757	3769	40481087	1974-03-12	1974-03-19	1
32774	1947	4116491	1976-10-10	1976-11-11	1
10998	651	192671	2012-06-08	2012-06-09	1
8111	476	4112343	2006-05-21	2006-05-28	1
5543	328	439777	2004-10-22	2004-10-23	1
47003	2799	81893	2017-06-17	2017-06-18	1
78100	4631	4112343	1948-06-06	1948-06-13	1
45611	2712	40481087	2008-04-07	2008-04-21	1
34984	2079	81151	2002-07-03	2002-07-17	1
15463	917	4112343	1978-12-25	1979-01-04	1
43153	2572	30753	2009-04-05	2009-04-06	1
64459	3814	4142905	1987-06-26	1987-08-25	1
38125	2266	192671	2008-07-01	2008-07-02	1
38807	2307	28060	1973-11-01	1973-11-09	1
21073	1266	28060	1980-07-31	1980-08-09	1
16468	973	260139	1962-12-29	1963-01-12	1
22636	1353	40481087	1969-06-23	1969-07-14	1
31820	1892	378001	1984-04-12	1984-06-11	1
34230	2033	257012	1984-03-13	1984-03-14	1
70881	4208	40481087	1998-02-09	1998-03-02	1
41590	2477	4112343	1963-10-14	1963-10-26	1
39583	2346	4134304	1982-08-10	1982-11-08	1
37185	2204	4112343	2004-09-02	2004-09-14	1
69442	4113	40481087	1992-11-16	1992-11-30	1
42752	2550	4116491	2018-02-13	2018-03-20	1
43930	2617	260139	1956-09-16	1956-09-23	1
88907	5295	260139	1981-11-16	1981-11-23	1
29668	1758	4112343	1973-11-12	1973-11-23	1
8724	510	260139	2012-07-27	2012-08-03	1
69279	4105	260139	1950-08-04	1950-08-18	1
16649	987	4237458	1965-10-26	1966-01-24	1
48267	2863	4112343	1964-03-12	1964-03-22	1
12805	756	4296204	1996-08-26	1996-09-23	1
69138	4094	4112343	1981-01-05	1981-01-16	1
57959	3439	4155034	1962-04-02	1962-04-23	1
40459	2406	260139	1949-01-08	1949-01-15	1
45122	2686	40481087	2005-05-01	2005-05-08	1
45711	2721	40481087	2016-06-14	2016-06-28	1
67334	3984	372328	1955-12-13	1956-05-30	1
42673	2545	4294548	1975-07-30	1975-09-17	1
88849	5290	372328	1956-09-21	1957-03-29	1
35801	2123	40479422	1994-10-21	1994-12-27	1
85845	5113	4112343	1993-12-07	1993-12-18	1
84579	5035	4112343	1943-09-19	1943-09-28	1
12350	730	4116491	1978-04-08	1978-05-27	1
68063	4024	260139	1981-09-16	1981-09-23	1
40717	2424	80180	2004-04-19	2004-04-20	1
22924	1368	4112343	1965-02-19	1965-03-03	1
23200	1385	4112343	2016-11-12	2016-11-22	1
40888	2435	4112343	1978-02-13	1978-02-20	1
63758	3769	40481087	1989-05-31	1989-06-07	1
32775	1947	4218389	2012-08-10	2012-09-07	1
10999	651	257012	1981-11-03	1981-11-04	1
8112	476	4112343	2015-02-11	2015-02-21	1
5544	328	4112343	1995-09-12	1995-09-23	1
47004	2799	4278672	1986-08-29	1986-11-27	1
78101	4631	4112343	1960-06-14	1960-06-25	1
45612	2712	80180	2000-08-08	2000-08-09	1
34985	2079	4112343	1960-03-06	1960-03-13	1
15464	917	40481087	1966-08-04	1966-08-25	1
43154	2572	378001	1978-02-21	1978-03-23	1
64460	3814	4296204	1995-09-12	1995-10-10	1
38126	2266	260139	1991-04-28	1991-05-05	1
38808	2307	80180	2003-11-12	2003-11-13	1
21074	1266	260139	1974-09-09	1974-09-23	1
16469	973	260139	2006-10-11	2006-10-18	1
22637	1353	260139	1985-06-12	1985-06-19	1
31821	1892	4094814	2018-06-13	2018-09-11	1
34231	2033	260139	1980-08-03	1980-08-17	1
72767	4330	260139	2000-01-04	2000-01-11	1
41591	2477	4112343	2010-11-09	2010-11-18	1
39584	2346	4152936	1966-04-22	1966-05-06	1
37186	2204	4155034	1959-07-30	1959-08-13	1
70666	4199	28060	1945-02-03	1945-02-16	1
42753	2550	4283893	1997-07-24	1997-10-02	1
43931	2617	4112343	1962-08-18	1962-08-29	1
88908	5295	4112343	1998-07-24	1998-07-31	1
29669	1758	4152936	1973-02-12	1973-02-26	1
8725	510	375671	1966-08-28	1966-09-27	1
69280	4105	260139	1995-09-13	1995-09-27	1
16650	987	4296205	1970-08-01	1970-09-05	1
48268	2863	4112343	1969-08-27	1969-09-04	1
12806	756	30753	1999-11-14	1999-11-15	1
69139	4094	4294548	1961-11-18	1961-12-02	1
57960	3439	28060	1999-07-23	1999-07-30	1
40460	2406	260139	1965-10-05	1965-10-19	1
45123	2686	40481087	2010-07-18	2010-08-08	1
45712	2721	80180	2010-07-23	2010-07-24	1
67335	3984	4112343	1959-04-11	1959-04-23	1
42674	2545	260139	1959-11-12	1959-11-26	1
88850	5290	4112343	2005-05-23	2005-05-31	1
35802	2123	40481087	1987-07-23	1987-07-30	1
85846	5113	4156265	1981-02-06	1981-02-27	1
84580	5035	4112343	1982-10-12	1982-10-22	1
12351	730	4283893	2006-11-29	2007-02-07	1
68064	4024	378001	1987-03-17	1987-04-16	1
40718	2424	4112343	2014-11-30	2014-12-08	1
22925	1368	40481087	1994-01-11	1994-01-25	1
23201	1385	4283893	2008-07-20	2008-09-07	1
40889	2435	4112343	1981-04-15	1981-04-28	1
63759	3769	260139	1957-04-25	1957-05-09	1
32776	1947	40481087	1969-11-27	1969-12-18	1
11000	651	4027663	2002-04-29	2002-04-30	1
8113	476	40481087	2018-12-27	2019-01-10	1
5545	328	40481087	1991-07-14	1991-08-04	1
47005	2799	40481087	1988-05-27	1988-06-17	1
78102	4631	4112343	1977-10-28	1977-11-06	1
45613	2712	81151	1978-04-07	1978-05-12	1
34986	2079	4112343	2006-01-28	2006-02-04	1
15465	917	40481087	1967-03-02	1967-03-09	1
43155	2572	4112343	2014-05-28	2014-06-05	1
64461	3814	40481087	1999-09-26	1999-10-17	1
38127	2266	4027663	2000-12-06	2000-12-07	1
38809	2307	260139	1993-01-20	1993-02-03	1
21075	1266	260139	1992-07-21	1992-08-04	1
16470	973	4051466	1917-08-23	1933-12-01	1
22638	1353	4112343	1981-05-11	1981-05-23	1
31822	1892	4109685	1981-04-07	1981-04-28	1
34232	2033	40481087	1973-03-15	1973-03-29	1
72768	4330	372328	1948-04-18	1948-11-27	2
41592	2477	40481087	1970-11-03	1970-11-17	1
39585	2346	30753	1985-09-19	1985-09-20	1
37187	2204	4156265	1965-08-11	1965-08-25	1
70667	4199	257012	2016-05-19	2016-05-20	1
42754	2550	4294548	2012-11-15	2012-12-20	1
43932	2617	40481087	1997-04-14	1997-04-28	1
88909	5295	4113008	1958-10-03	1958-10-24	1
29670	1758	40481087	2003-01-13	2003-01-20	1
8726	510	4027663	1999-09-24	1999-09-25	1
69281	4105	4112343	2009-05-18	2009-05-26	1
16651	987	192671	1988-02-16	1988-02-17	1
48269	2863	4237458	1988-05-16	1988-08-14	1
12807	756	80180	2001-02-06	2001-02-07	1
69140	4094	40481087	1958-02-17	1958-03-03	1
57961	3439	81151	1955-09-08	1955-10-06	1
40461	2406	372328	1946-02-22	1946-05-16	1
45124	2686	260139	1956-11-01	1956-11-08	1
45713	2721	260139	1971-04-26	1971-05-10	1
67336	3984	4112343	1967-08-11	1967-08-22	1
42675	2545	372328	1948-06-10	1948-07-01	1
88851	5290	4237458	1979-05-29	1979-08-27	1
35803	2123	40481087	1987-10-07	1987-10-21	1
85847	5113	40481087	1990-10-13	1990-11-03	1
84581	5035	4266809	1969-06-07	1969-06-08	1
12352	730	40481087	1982-04-24	1982-05-01	1
68065	4024	4001336	1988-05-10	1988-06-09	1
40719	2424	40481087	1964-05-11	1964-06-01	1
22926	1368	372328	1982-05-16	1982-09-15	1
25578	1523	372328	2001-08-25	2002-04-30	1
40890	2435	4112343	2001-01-26	2001-02-02	1
63760	3769	260139	2019-03-20	2019-04-03	1
32777	1947	40481087	1985-04-30	1985-05-21	1
11001	651	4035415	1987-08-11	1987-09-10	1
8114	476	4218389	1992-06-27	1992-08-01	1
5546	328	80180	2014-04-13	2014-04-14	1
47006	2799	80180	2018-01-13	2018-01-14	1
78103	4631	4112343	2005-12-19	2005-12-28	1
45614	2712	81151	2018-03-11	2018-04-08	1
34987	2079	4152936	2008-01-17	2008-02-07	1
15466	917	40481087	1975-10-20	1975-11-10	1
43156	2572	4218389	1999-10-29	1999-11-19	1
64462	3814	260139	1977-08-19	1977-09-02	1
38128	2266	4112343	1971-04-04	1971-04-17	1
38810	2307	40481087	2010-04-29	2010-05-20	1
21076	1266	40481087	1983-04-22	1983-05-13	1
16471	973	4112343	1977-05-28	1977-06-06	1
22639	1353	4294548	2008-11-02	2009-01-11	1
31823	1892	4112343	1979-11-19	1979-11-27	1
34233	2033	40481087	1975-12-10	1975-12-24	1
72769	4330	4027663	1978-12-14	1978-12-15	1
41593	2477	40481087	2002-04-26	2002-05-10	1
39586	2346	260139	1953-09-26	1953-10-10	1
37188	2204	40481087	1954-02-25	1954-03-04	1
70668	4199	4112343	1953-06-06	1953-06-15	1
42755	2550	40481087	1987-07-21	1987-08-04	1
43933	2617	81151	1955-11-20	1955-12-18	1
88910	5295	28060	1985-08-06	1985-08-19	1
29671	1758	192671	2002-11-07	2002-11-08	1
8727	510	4283893	1988-07-19	1988-09-27	1
69282	4105	4112343	2010-02-24	2010-03-05	1
16652	987	260139	1970-09-29	1970-10-13	1
48270	2863	4283893	1994-09-21	1994-11-30	1
12808	756	260139	1981-04-01	1981-04-08	1
69141	4094	40481087	1970-11-23	1970-12-14	1
57962	3439	260139	1972-06-20	1972-07-04	1
40462	2406	372328	1947-04-11	1947-11-20	1
45125	2686	260139	1966-07-12	1966-07-26	1
45714	2721	260139	1990-06-10	1990-06-17	1
67337	3984	40481087	1963-06-12	1963-07-03	1
42676	2545	4112343	1994-03-11	1994-03-20	1
88852	5290	4296205	1971-09-03	1971-10-08	1
35804	2123	260139	1988-12-21	1989-01-04	1
89014	5301	192671	1953-03-01	1953-03-02	1
84582	5035	4278672	1997-08-14	1997-10-13	1
12353	730	40481087	1997-01-18	1997-02-01	1
68066	4024	260139	2006-04-29	2006-05-13	1
40720	2424	40481087	1988-07-14	1988-08-04	1
22927	1368	378001	1967-02-06	1967-03-08	1
25579	1523	372328	1957-02-04	1957-03-19	1
40891	2435	4294548	1988-07-25	1988-11-07	1
63761	3769	4146173	1971-06-27	1971-07-27	1
32778	1947	40481087	2019-03-15	2019-03-22	1
11002	651	40481087	1994-03-19	1994-03-26	1
8115	476	40481087	1977-11-29	1977-12-20	1
5547	328	195588	2011-12-14	2012-01-22	1
47007	2799	4027663	2007-03-27	2007-03-28	1
78104	4631	4112343	2006-10-27	2006-11-08	1
45615	2712	260139	1978-11-13	1978-11-20	1
34988	2079	40481087	1976-06-07	1976-06-14	1
15467	917	40481087	2006-09-02	2006-09-09	1
43157	2572	4283893	2005-10-16	2005-11-13	1
64463	3814	4112343	2012-11-09	2012-11-21	1
38129	2266	4266809	2008-04-28	2008-04-29	1
38811	2307	372328	1963-06-25	1963-09-10	1
21077	1266	40481087	2014-02-24	2014-03-03	1
16472	973	4112343	2001-04-02	2001-04-12	1
22640	1353	40481087	1957-07-22	1957-07-29	1
31824	1892	28060	1999-10-29	1999-11-06	1
34234	2033	40481087	2012-10-16	2012-10-23	1
72770	4330	4112343	2004-03-29	2004-04-07	1
41594	2477	80180	1998-06-06	1998-06-07	1
39587	2346	4112343	1953-07-12	1953-07-25	1
37189	2204	40481087	1966-12-30	1967-01-06	1
70669	4199	4112343	1960-01-24	1960-02-05	1
42756	2550	40481087	1993-07-11	1993-07-25	1
43934	2617	260139	2001-01-23	2001-02-06	1
88911	5295	257012	1915-01-12	1915-01-13	1
29672	1758	260139	2004-02-01	2004-02-08	1
8728	510	40479422	2005-06-04	2005-08-10	1
69283	4105	4113008	2000-11-14	2000-12-05	1
16653	987	260139	2003-03-18	2003-03-25	1
48271	2863	40481087	2019-03-09	2019-03-23	1
12809	756	4112343	1967-03-01	1967-03-14	1
69142	4094	40481087	1993-04-23	1993-05-14	1
57963	3439	4112343	1968-05-04	1968-05-11	1
40463	2406	40481087	1980-08-27	1980-09-10	1
45126	2686	260139	2005-07-09	2005-07-23	1
45715	2721	40481087	1973-01-19	1973-02-02	1
67338	3984	28060	1968-01-21	1968-02-01	1
42677	2545	40481087	1949-01-15	1949-02-05	1
88853	5290	80180	1995-05-15	1995-05-16	1
35805	2123	260139	2018-08-27	2018-09-10	1
89015	5301	260139	1929-09-11	1929-09-18	1
84583	5035	40481087	1952-07-29	1952-08-05	1
12354	730	78272	2000-04-02	2000-05-07	1
68067	4024	4027663	2006-01-21	2006-01-22	1
40721	2424	372328	1967-11-02	1968-05-30	1
22928	1368	381316	2019-06-26	2019-06-27	1
25580	1523	40481087	1978-10-04	1978-10-11	1
40892	2435	4310024	2013-12-30	2013-12-31	1
63762	3769	80180	1990-09-04	1990-09-05	1
35457	2103	28060	2015-04-01	2015-04-09	1
11003	651	40481087	2011-11-06	2011-11-27	1
8116	476	40481087	2007-12-21	2007-12-28	1
5548	328	260139	1985-04-27	1985-05-11	1
47008	2799	40481087	2015-05-02	2015-05-09	1
78105	4631	4166224	1934-08-04	1934-08-05	1
45616	2712	260139	1995-10-30	1995-11-13	1
34989	2079	40481087	1996-06-01	1996-06-08	1
15468	917	260139	1996-11-18	1996-12-02	1
43158	2572	40481087	1986-01-31	1986-02-07	1
64464	3814	40481087	1975-12-03	1975-12-17	1
38130	2266	4283893	1980-03-24	1980-04-07	1
38812	2307	4109685	1972-03-09	1972-03-23	1
21078	1266	80180	2004-12-20	2004-12-21	1
16473	973	4283893	1921-12-29	1922-03-09	1
22641	1353	40481087	1978-04-03	1978-04-24	1
31825	1892	261325	2007-05-17	2007-05-18	1
35257	2091	28060	2010-10-31	2010-11-13	1
72771	4330	4155034	1995-12-31	1996-01-14	1
41595	2477	195588	2001-02-15	2001-03-30	1
39588	2346	4266809	1986-11-13	1986-11-14	1
37190	2204	40481087	2003-04-30	2003-05-14	1
70670	4199	4112343	1986-05-19	1986-05-30	1
42757	2550	375671	1984-01-11	1984-02-10	1
43935	2617	317576	2014-09-06	2014-09-07	1
88912	5295	260139	1946-01-06	1946-01-13	1
29673	1758	4116491	2008-08-07	2008-09-11	1
9418	558	80180	2002-03-13	2002-03-14	1
69284	4105	40481087	1985-03-24	1985-04-14	1
16654	987	372328	1954-06-26	1954-08-08	1
48272	2863	40486433	1966-09-20	1966-09-21	1
12810	756	4112343	1969-02-03	1969-02-15	1
70103	4156	317576	2004-11-15	2004-11-16	1
57964	3439	4142905	1969-02-20	1969-04-21	1
40464	2406	80180	1979-04-20	1979-04-21	1
45127	2686	4112343	2016-04-08	2016-04-17	1
45716	2721	40481087	1979-11-05	1979-11-12	1
67339	3984	78272	2006-10-19	2006-11-23	1
44441	2647	195588	2005-12-04	2006-01-28	1
88854	5290	40481087	1956-09-26	1956-10-03	1
35806	2123	372328	1951-01-12	1951-03-30	1
89016	5301	313217	1999-01-07	1999-01-08	1
84584	5035	40481087	1965-09-03	1965-09-17	1
12355	730	80180	2002-11-18	2002-11-19	1
68068	4024	40481087	1997-09-29	1997-10-20	1
40722	2424	4112343	1985-02-26	1985-03-06	1
22929	1368	4112343	1958-04-13	1958-04-25	1
25581	1523	40481087	2006-08-02	2006-08-23	1
40893	2435	257012	1988-09-12	1988-09-13	1
64135	3791	260139	1937-07-08	1937-07-22	1
35458	2103	78272	1982-11-17	1982-12-01	1
11004	651	80180	2012-04-11	2012-04-12	1
8117	476	260139	1977-05-28	1977-06-11	1
5549	328	260139	2004-08-12	2004-08-19	1
48505	2876	258780	1989-08-03	1989-08-04	1
78106	4631	40481087	1942-02-28	1942-03-21	1
45617	2712	372328	1968-01-30	1968-12-10	1
34990	2079	40481087	2009-12-02	2009-12-09	1
17880	1077	80180	1979-11-26	1979-11-27	1
43159	2572	80180	2009-07-04	2009-07-05	1
64465	3814	40481087	1998-01-14	1998-01-28	1
38131	2266	30753	2007-10-01	2007-10-02	1
38813	2307	4296204	1999-09-28	1999-10-19	1
21079	1266	81151	1984-06-08	1984-07-13	1
16474	973	40481087	1917-10-09	1917-10-30	1
24938	1491	257012	2005-10-08	2005-10-09	1
31826	1892	4059173	1974-07-13	1974-09-11	1
35258	2091	372328	1965-06-12	1965-07-24	1
72772	4330	4278672	1968-09-04	1968-11-03	1
41596	2477	260139	1974-01-05	1974-01-12	1
39589	2346	40481087	1968-02-16	1968-03-01	1
37191	2204	260139	1954-12-10	1954-12-24	1
70671	4199	4218389	1946-11-12	1946-12-17	1
42758	2550	4112343	1993-08-03	1993-08-15	1
43936	2617	372328	1953-12-30	1954-01-13	1
88913	5295	372328	1949-05-15	1951-01-24	1
29674	1758	40481087	1984-08-31	1984-09-14	1
9419	558	260139	1974-09-22	1974-10-06	1
69285	4105	28060	1950-05-24	1950-06-06	1
16655	987	4112343	1956-04-20	1956-05-03	1
48273	2863	260139	1990-03-18	1990-04-01	1
12811	756	40479768	1995-08-25	1995-10-01	1
70104	4156	4112343	1998-11-09	1998-11-18	1
57965	3439	4237458	1967-01-02	1967-04-02	1
40465	2406	321042	1961-05-11	1961-05-12	1
45128	2686	40481087	1975-01-29	1975-02-12	1
45717	2721	40481087	1999-02-07	1999-02-14	1
67340	3984	260139	1961-03-19	1961-03-26	1
44442	2647	260139	1974-08-25	1974-09-01	1
88855	5290	260139	1957-06-19	1957-06-26	1
35807	2123	372328	1953-12-20	1954-04-02	1
89017	5301	372328	1923-09-03	1924-01-03	1
84585	5035	28060	1979-03-20	1979-03-30	1
12356	730	4112343	1984-05-08	1984-05-15	1
68069	4024	40481087	2003-08-13	2003-08-27	1
40723	2424	4112343	2018-07-21	2018-07-31	1
22930	1368	4112343	2018-08-20	2018-08-29	1
25582	1523	40481087	2010-07-08	2010-07-29	1
40894	2435	4112343	1982-09-22	1982-09-30	1
64136	3791	381316	2014-11-01	2014-11-02	1
35459	2103	260139	1978-02-13	1978-02-20	1
11005	651	81893	2010-04-22	2010-04-23	1
8118	476	260139	2002-02-11	2002-02-25	1
5550	328	260139	2014-03-31	2014-04-07	1
48506	2876	260139	1981-07-08	1981-07-15	1
78107	4631	40481087	1948-05-16	1948-06-06	1
45618	2712	4112343	1998-04-04	1998-04-16	1
34991	2079	40481087	2018-11-28	2018-12-05	1
17881	1077	40481087	1977-07-13	1977-07-27	1
43160	2572	4109685	2011-10-17	2011-11-07	1
64466	3814	40481087	2008-09-06	2008-09-13	1
38132	2266	372328	1984-03-18	1985-01-26	1
38814	2307	40481087	1970-09-24	1970-10-15	1
21080	1266	260139	1972-03-15	1972-03-22	1
16475	973	40481087	1965-10-11	1965-10-25	1
24939	1491	378001	1988-02-24	1988-04-24	1
31827	1892	4112343	1969-09-28	1969-10-11	1
35259	2091	40481087	2001-09-15	2001-09-22	1
72773	4330	4310024	1984-11-07	1984-11-08	1
41597	2477	372328	1956-03-23	1956-05-06	1
39590	2346	40481087	1990-11-21	1990-12-12	1
37192	2204	4109685	1950-07-19	1950-08-09	1
70672	4199	4283893	2016-03-31	2016-06-09	1
42759	2550	4116491	2012-01-09	2012-02-15	1
43937	2617	4283893	2001-02-15	2001-03-29	1
88914	5295	4112343	1914-09-05	1914-09-12	1
29675	1758	40481087	2018-02-03	2018-02-17	1
9420	558	40481087	1966-04-13	1966-04-27	1
69286	4105	28060	2001-07-04	2001-07-14	1
16656	987	40481087	2009-09-07	2009-09-21	1
48274	2863	372328	1963-10-04	1964-02-20	1
12812	756	40481087	1990-01-21	1990-02-04	1
70105	4156	40481087	1965-07-15	1965-08-05	1
57966	3439	4283893	1997-04-19	1997-05-17	1
40466	2406	4112343	1949-05-08	1949-05-20	1
45129	2686	40481087	1999-10-01	1999-10-22	1
45718	2721	260139	2013-04-07	2013-04-14	1
67341	3984	260139	1965-05-23	1965-05-30	1
44443	2647	372328	1971-05-12	1971-08-22	1
88856	5290	378001	1961-02-27	1961-04-28	1
35808	2123	4278672	2002-05-19	2002-08-17	1
89018	5301	4056621	1940-10-13	1940-10-14	1
84586	5035	30753	1968-05-13	1968-05-14	1
12357	730	4112343	2017-12-03	2017-12-11	1
68070	4024	28060	1989-08-04	1989-08-11	1
40724	2424	4296204	1997-09-08	1997-09-22	1
22931	1368	4146173	2001-08-25	2001-09-24	1
25583	1523	81151	1973-08-09	1973-08-23	1
40895	2435	4266809	2015-11-20	2015-11-21	1
64137	3791	4112343	1944-09-24	1944-10-03	1
35460	2103	372328	1973-06-19	1973-07-21	1
11006	651	321042	1999-01-28	1999-01-29	1
8119	476	4112343	1968-06-14	1968-06-23	1
5551	328	4310024	2012-11-19	2012-11-20	1
48507	2876	372328	1964-08-05	1964-09-17	1
78108	4631	40481087	1950-02-15	1950-03-01	1
45619	2712	4296204	1968-12-04	1968-12-25	1
34992	2079	260139	1967-08-16	1967-08-23	1
17882	1077	40481087	1981-09-10	1981-09-24	1
43161	2572	4112343	1996-04-17	1996-04-30	1
64467	3814	28060	1987-12-08	1987-12-17	1
38133	2266	378001	1999-04-18	1999-06-17	1
38815	2307	40481087	2006-08-04	2006-08-11	1
21081	1266	260139	1994-11-16	1994-11-23	1
16476	973	81151	1965-03-22	1965-04-26	1
24940	1491	4059173	1982-04-26	1982-07-25	1
31828	1892	4218389	1962-06-04	1962-06-25	1
35260	2091	81151	1979-07-29	1979-08-12	1
72774	4330	40481087	1957-02-09	1957-02-23	1
41598	2477	4116491	2003-03-30	2003-05-08	1
40337	2396	317576	1989-02-01	1989-02-02	1
37193	2204	4112343	1958-06-18	1958-06-25	1
70673	4199	40481087	1952-02-21	1952-03-06	1
42760	2550	4146173	2018-02-02	2018-04-10	1
43938	2617	4283893	2009-04-30	2009-08-06	1
88915	5295	40481087	1942-02-07	1942-02-21	1
29676	1758	80180	2002-09-28	2002-09-29	1
9421	558	40481087	1978-11-25	1978-12-02	1
69287	4105	257012	1948-02-10	1948-02-11	1
16657	987	40481087	2015-10-28	2015-11-18	1
48275	2863	40481087	1968-10-14	1968-10-28	1
12813	756	81151	1982-09-04	1982-09-18	1
70106	4156	40481087	1997-09-12	1997-09-19	1
57967	3439	40481087	1977-02-28	1977-03-14	1
40467	2406	4283893	1991-09-19	1992-01-09	1
45130	2686	40481087	2014-01-27	2014-02-03	1
45719	2721	372328	1971-11-20	1972-10-21	1
67342	3984	260139	2008-10-16	2008-10-30	1
44444	2647	4112343	1975-10-20	1975-10-31	1
88857	5290	378001	1989-02-05	1989-04-06	1
35809	2123	40481087	1954-05-02	1954-05-23	1
89019	5301	40481087	1998-08-23	1998-08-30	1
84587	5035	81151	1935-05-07	1935-05-28	1
12358	730	4142905	1965-11-02	1965-12-02	1
68071	4024	261325	2003-08-24	2003-08-25	1
40725	2424	28060	1971-04-02	1971-04-09	1
22932	1368	4237458	1959-05-19	1959-06-18	1
25584	1523	260139	1959-06-25	1959-07-09	1
40896	2435	30753	2014-09-26	2014-09-27	1
64138	3791	40481087	1967-01-29	1967-02-05	1
35461	2103	4112343	1983-08-15	1983-08-28	1
11007	651	4283893	1981-07-21	1981-11-10	1
8120	476	4112343	1990-06-01	1990-06-11	1
5552	328	40481087	1999-12-25	2000-01-08	1
48508	2876	4146173	1997-02-04	1997-04-05	1
78109	4631	40481087	1960-09-11	1960-10-02	1
45620	2712	4278672	1968-01-09	1968-02-08	1
34993	2079	260139	1989-05-21	1989-05-28	1
17883	1077	40481087	1993-01-03	1993-01-24	1
43162	2572	4285898	2009-06-04	2009-06-05	1
64468	3814	80180	2013-04-10	2013-04-11	1
38134	2266	4152936	1978-06-25	1978-07-16	1
42614	2543	78272	2015-02-19	2015-03-19	1
21082	1266	4294548	1969-05-05	1969-06-23	1
16477	973	260139	1916-09-06	1916-09-20	1
24941	1491	4112343	1975-09-13	1975-09-23	1
31829	1892	4283893	2005-03-15	2005-04-26	1
35261	2091	372328	2004-01-01	2005-07-09	1
72775	4330	40481087	1971-05-25	1971-06-15	1
41599	2477	4218389	1982-02-24	1982-03-31	1
40338	2396	4152936	1941-04-27	1941-05-11	1
37194	2204	4149245	1957-04-03	1957-06-10	1
70674	4199	40481087	2003-08-16	2003-09-06	1
42761	2550	4059173	1997-01-02	1997-03-03	1
43939	2617	40481087	1996-02-06	1996-02-13	1
88916	5295	40481087	1952-09-01	1952-09-15	1
29677	1758	372328	1962-11-07	1963-01-25	1
9422	558	40481087	2014-08-03	2014-08-17	1
69288	4105	260139	1993-06-20	1993-07-04	1
16658	987	260139	1959-08-12	1959-08-19	1
48276	2863	40481087	2003-09-21	2003-09-28	1
12814	756	260139	1973-08-23	1973-08-30	1
70107	4156	4155034	1966-09-22	1966-10-06	1
57968	3439	40481087	1984-12-09	1984-12-16	1
40468	2406	260139	1981-01-30	1981-02-13	1
45131	2686	40481087	2014-07-12	2014-08-02	1
45720	2721	40481087	1976-10-21	1976-11-11	1
67343	3984	372328	1956-08-28	1956-11-28	1
44445	2647	40481087	1978-12-09	1978-12-23	1
88858	5290	4084167	1955-01-30	1955-01-30	1
41246	2456	28060	1969-04-14	1969-04-26	1
89020	5301	28060	1986-03-28	1986-04-04	1
84588	5035	255848	2014-10-06	2014-10-07	1
12359	730	40481087	1968-11-18	1968-12-02	1
68072	4024	4112343	2006-09-14	2006-09-21	1
40726	2424	196456	1997-06-06	1997-06-06	1
22933	1368	40481087	1963-07-19	1963-07-26	1
25585	1523	260139	2014-08-14	2014-08-28	1
40897	2435	4112343	2010-01-18	2010-01-28	1
64139	3791	260139	1944-06-01	1944-06-15	1
35462	2103	4156265	2002-08-18	2002-09-08	1
11008	651	4285898	2011-09-14	2011-09-15	1
8121	476	4156265	1983-05-25	1983-06-15	1
5553	328	4027663	2007-10-22	2007-10-23	1
48509	2876	4152936	2016-05-25	2016-06-15	1
78110	4631	40481087	1981-03-12	1981-04-02	1
46961	2798	80180	1994-02-18	1994-02-19	1
34994	2079	4109685	1978-06-18	1978-07-09	1
17884	1077	78272	2007-05-03	2007-05-17	1
45026	2682	260139	2009-12-01	2009-12-08	1
64469	3814	260139	1988-10-29	1988-11-05	1
38135	2266	80180	2008-04-28	2008-04-29	1
42615	2543	192671	2001-06-21	2001-06-22	1
21083	1266	4294548	1982-09-22	1983-02-16	1
16478	973	372328	1920-03-23	1920-05-03	1
24942	1491	4112343	1996-11-12	1996-11-22	1
31830	1892	4294548	1979-03-12	1979-04-02	1
35262	2091	4112343	1989-11-25	1989-12-03	1
72776	4330	40481087	1975-12-27	1976-01-17	1
41600	2477	40481087	1991-02-09	1991-02-16	1
40339	2396	4278672	1997-10-19	1997-12-18	1
37195	2204	40481087	1964-04-18	1964-05-10	1
70675	4199	134438	1962-04-29	1963-01-28	1
42762	2550	40481087	1996-05-17	1996-05-24	1
43940	2617	40481087	2006-04-11	2006-04-25	1
88917	5295	40481087	1993-05-20	1993-06-03	1
29678	1758	4112343	1975-07-12	1975-07-22	1
9423	558	378001	1998-10-13	1998-11-12	1
69289	4105	260139	2009-02-16	2009-02-23	1
16659	987	260139	1991-10-01	1991-10-15	1
48277	2863	28060	1961-11-14	1961-11-21	1
12815	756	372328	1966-08-29	1966-10-12	1
70108	4156	4329847	2006-02-27	2006-02-28	1
57969	3439	78272	1964-12-08	1965-01-12	1
40469	2406	260139	1991-03-02	1991-03-09	1
45132	2686	80180	1995-02-28	1995-03-01	1
45721	2721	40481087	2015-12-25	2016-01-08	1
67344	3984	372328	2004-07-19	2004-12-29	1
44446	2647	40481087	2003-02-09	2003-03-02	1
88859	5290	4134304	1954-11-01	1954-12-01	1
41247	2456	260139	2001-08-03	2001-08-17	1
89021	5301	260139	1974-06-14	1974-06-21	1
84589	5035	260139	1982-03-02	1982-03-16	1
12360	730	40481087	1998-11-29	1998-12-06	1
68073	4024	40481087	2015-05-14	2015-05-21	1
40727	2424	198809	1997-06-06	1997-06-06	1
24451	1460	28060	1988-10-05	1988-10-13	1
25586	1523	4112343	1996-10-11	1996-10-18	1
40898	2435	4294548	2014-12-12	2014-12-26	1
64140	3791	260139	2000-07-04	2000-07-11	1
35463	2103	4278672	1975-02-27	1975-05-28	1
11009	651	0	1999-01-28	1999-01-29	1
8122	476	40481087	1970-04-10	1970-05-01	1
5554	328	4112343	1989-04-05	1989-04-15	1
48510	2876	4155034	1967-05-22	1967-06-12	1
78111	4631	40481087	2014-02-09	2014-02-16	1
46962	2798	4116491	1999-11-09	1999-12-26	1
34995	2079	4112343	1980-06-28	1980-07-10	1
17885	1077	260139	1983-10-06	1983-10-13	1
45027	2682	4112343	1978-08-21	1978-08-30	1
64470	3814	4278672	1975-09-27	1975-12-26	1
38136	2266	81151	1993-03-29	1993-04-19	1
42616	2543	4109685	1978-05-22	1978-06-12	1
21084	1266	4294548	2013-05-30	2013-08-22	1
16479	973	4155034	2016-06-02	2016-06-16	1
24943	1491	4112343	2008-05-05	2008-05-16	1
31831	1892	40481087	2001-10-10	2001-10-24	1
35263	2091	40481087	1971-12-09	1971-12-16	1
72777	4330	40481087	1988-07-24	1988-07-31	1
41601	2477	40486433	1957-03-05	1957-03-06	1
40340	2396	40481087	1936-04-30	1936-05-21	1
44899	2675	0	1996-01-23	1996-01-24	1
70676	4199	260139	1948-03-08	1948-03-22	1
42763	2550	40481087	2000-09-22	2000-10-13	1
43941	2617	40481087	2008-09-18	2008-09-25	1
88918	5295	40481087	1995-09-27	1995-10-18	1
29679	1758	40481087	1966-10-22	1966-10-29	1
9424	558	4112343	1983-09-02	1983-09-14	1
69290	4105	372328	1951-10-12	1952-02-23	1
16660	987	260139	2018-05-15	2018-05-29	1
48278	2863	28060	2015-05-07	2015-05-16	1
12816	756	4109685	1992-10-25	1992-11-08	1
70109	4156	40481087	1991-10-22	1991-11-12	1
57970	3439	81151	2009-02-20	2009-03-20	1
40470	2406	4112343	1982-03-21	1982-03-28	1
45133	2686	4112343	1956-11-02	1956-11-12	1
45722	2721	40481087	2018-08-22	2018-09-05	1
67345	3984	4112343	1958-04-04	1958-04-13	1
44447	2647	260139	1988-01-31	1988-02-07	1
88860	5290	4218389	2000-05-08	2000-05-29	1
41248	2456	372328	1961-01-06	1961-04-09	1
89022	5301	378001	1929-08-11	1929-09-10	1
84590	5035	372328	1932-09-19	1932-11-07	1
12361	730	80502	2017-09-16	2017-09-17	1
68074	4024	80180	2016-05-08	2016-05-09	1
40728	2424	260139	1975-12-05	1975-12-12	1
24452	1460	80180	2017-09-03	2017-09-04	1
25587	1523	4142905	1988-11-02	1989-01-31	1
43548	2597	81893	2009-02-07	2009-02-08	1
64141	3791	372328	1915-08-24	1915-11-06	1
35464	2103	4283893	2012-05-18	2012-08-17	1
11010	651	198199	2011-04-27	2011-06-17	1
8123	476	40481087	2013-12-01	2013-12-15	1
5555	328	4266809	2014-04-13	2014-04-14	1
48511	2876	40481087	1983-11-22	1983-11-29	1
78112	4631	28060	2009-09-08	2009-09-17	1
46963	2798	40481087	1956-03-06	1956-03-20	1
34996	2079	4218389	2016-03-26	2016-04-23	1
17886	1077	372328	1947-05-13	1947-07-25	1
45028	2682	4112343	1982-02-11	1982-02-22	1
64471	3814	40481087	1976-02-20	1976-03-05	1
38137	2266	260139	1985-10-17	1985-10-24	1
42617	2543	4112343	2011-06-02	2011-06-13	1
21085	1266	40481087	1967-08-14	1967-09-04	1
16480	973	40481087	1927-07-14	1927-07-28	1
24944	1491	4112343	2008-11-13	2008-11-22	1
31832	1892	40481087	2012-12-22	2012-12-29	1
35264	2091	260139	1967-12-31	1968-01-07	1
72778	4330	40481087	2013-08-15	2013-09-05	1
41602	2477	81151	1969-10-02	1969-10-30	1
40341	2396	40481087	1939-12-28	1940-01-11	1
44900	2675	260139	1993-02-19	1993-02-26	1
70677	4199	260139	1976-01-04	1976-01-18	1
42764	2550	40481087	2013-08-22	2013-09-12	1
47393	2822	260139	1980-06-01	1980-06-08	1
88919	5295	28060	1917-01-01	1917-01-09	1
29680	1758	40481087	1985-12-16	1985-12-23	1
9425	558	192671	2002-03-22	2002-03-23	1
69291	4105	4112343	2007-10-13	2007-10-22	1
16661	987	40481087	1960-11-26	1960-12-03	1
48279	2863	4027663	1995-09-06	1995-09-07	1
12817	756	4278672	1972-12-25	1973-01-24	1
70110	4156	40481087	1993-02-09	1993-03-02	1
57971	3439	372328	1957-01-30	1957-08-15	1
40471	2406	40481087	1954-01-31	1954-02-07	1
45134	2686	4113008	1972-10-20	1972-11-10	1
45723	2721	313217	2017-04-22	2017-04-23	1
67346	3984	4112343	2005-12-16	2005-12-27	1
44448	2647	372328	1973-02-12	1973-05-20	1
88861	5290	40481087	1972-03-21	1972-03-28	1
41249	2456	4112343	1992-04-04	1992-04-15	1
89023	5301	4112343	1955-11-27	1955-12-09	1
84591	5035	378419	2009-08-03	2009-08-04	1
12362	730	81151	1959-05-03	1959-06-07	1
68075	4024	4285898	2016-01-09	2016-01-10	1
40729	2424	260139	2005-06-30	2005-07-14	1
24453	1460	260139	1989-07-19	1989-08-02	1
25588	1523	40481087	1986-04-07	1986-04-14	1
43549	2597	260139	2001-06-05	2001-06-12	1
64142	3791	4059173	1982-10-13	1983-01-11	1
35465	2103	40481087	1976-04-30	1976-05-21	1
11011	651	260139	1997-01-22	1997-02-05	1
8124	476	80180	2002-07-29	2002-07-30	1
5556	328	40481087	1984-08-05	1984-08-19	1
48512	2876	80180	2004-12-18	2004-12-19	1
78113	4631	257012	1968-08-03	1978-12-17	1
46964	2798	40481087	1973-05-04	1973-05-25	1
34997	2079	0	1956-12-17	1956-12-18	1
17887	1077	4112343	1978-07-02	1978-07-15	1
45029	2682	4237458	2017-02-04	2017-05-05	1
65779	3893	4112343	2004-09-06	2004-09-16	1
38138	2266	260139	1995-05-31	1995-06-14	1
42618	2543	40481087	1968-07-08	1968-07-15	1
21086	1266	40481087	1979-07-26	1979-08-09	1
16481	973	40481087	1970-12-07	1970-12-28	1
24945	1491	4266809	2006-05-20	2006-05-21	1
32444	1928	80180	2010-07-15	2010-07-16	1
35265	2091	260139	1984-11-09	1984-11-23	1
72779	4330	30753	1986-01-01	1986-01-02	1
41603	2477	260139	1957-06-17	1957-07-01	1
40342	2396	80180	1961-08-30	1961-08-31	1
44901	2675	260139	1993-09-25	1993-10-02	1
70678	4199	260139	1987-12-15	1987-12-29	1
43577	2598	260139	2007-04-25	2007-05-02	1
47394	2822	378001	2017-07-28	2017-09-26	1
88920	5295	80180	1943-02-08	1943-02-09	1
29681	1758	40481087	2016-03-18	2016-04-08	1
9426	558	4113008	2000-11-01	2000-11-22	1
69292	4105	4156265	1960-09-24	1960-10-15	1
16662	987	40481087	1972-08-09	1972-08-16	1
48280	2863	4310024	2004-03-02	2004-03-03	1
12818	756	40481087	2013-08-14	2013-08-28	1
70111	4156	28060	1958-10-29	1958-11-07	1
57972	3439	4001336	1954-08-14	1954-10-13	1
41018	2442	28060	1979-12-18	1979-12-28	1
45135	2686	4152936	1998-06-27	1998-07-11	1
45724	2721	4001336	2018-05-22	2018-07-21	1
67347	3984	4146173	2011-09-28	2011-10-28	1
44449	2647	28060	1980-10-15	1980-10-25	1
88862	5290	40486433	1955-11-13	1955-11-14	1
41250	2456	4112343	2016-09-23	2016-10-02	1
89024	5301	4112343	1980-04-03	1980-04-12	1
84592	5035	381316	1995-06-19	1995-06-20	1
12363	730	372328	1959-09-17	1960-03-19	1
68076	4024	40481087	2000-05-16	2000-05-23	1
40730	2424	4237458	1979-08-14	1979-11-12	1
24454	1460	372328	1982-07-24	1982-08-07	1
25589	1523	40481087	2009-08-28	2009-09-04	1
43550	2597	40481087	1971-06-30	1971-07-21	1
64143	3791	4112343	1948-02-16	1948-02-27	1
35466	2103	40481087	2009-02-04	2009-02-25	1
11012	651	378001	2009-05-31	2009-07-30	1
11184	662	28060	1964-01-07	1964-01-20	1
5557	328	40481087	1991-03-23	1991-04-06	1
48513	2876	4112343	2008-06-04	2008-06-13	1
78114	4631	260139	1978-03-27	1978-04-03	1
46965	2798	40481087	2013-08-06	2013-08-27	1
34998	2079	80180	1991-06-25	1991-06-26	1
17888	1077	4112343	2004-04-03	2004-04-11	1
45030	2682	40481087	2014-11-01	2014-11-15	1
65780	3893	40481087	1985-02-09	1985-02-23	1
38139	2266	372328	1969-06-12	1969-08-23	1
42619	2543	4112343	1993-11-11	1993-11-21	1
21857	1313	80180	2011-08-03	2011-08-04	1
16482	973	40481087	1990-12-12	1990-12-19	1
24946	1491	4283893	2005-09-24	2005-10-15	1
32445	1928	260139	1993-06-10	1993-06-24	1
35266	2091	260139	1995-12-27	1996-01-10	1
72780	4330	260139	1959-06-13	1959-06-27	1
41604	2477	260139	1998-04-06	1998-04-13	1
40343	2396	260139	1967-09-19	1967-10-03	1
44902	2675	260139	2013-12-13	2013-12-20	1
70679	4199	4112343	1956-02-01	1956-02-13	1
43578	2598	40481087	2016-06-20	2016-07-04	1
47395	2822	4156265	1983-07-06	1983-07-27	1
88921	5295	80502	1990-08-08	1990-08-09	1
32177	1915	80180	2006-08-14	2006-08-15	1
9427	558	4113008	2003-11-05	2003-11-26	1
69293	4105	40481087	1953-09-10	1953-09-24	1
16663	987	28060	1999-09-17	1999-09-28	1
49029	2905	80180	1999-10-06	1999-10-07	1
13647	807	0	1971-01-13	1971-01-14	1
70112	4156	78272	1960-03-06	1960-03-27	1
57973	3439	4112343	1957-08-16	1957-08-29	1
41019	2442	4112343	1978-12-06	1978-12-19	1
45136	2686	40481087	1970-05-26	1970-06-16	1
45725	2721	4218389	1989-10-16	1989-11-20	1
73610	4379	80180	2007-11-30	2007-12-01	1
44450	2647	80180	2014-08-19	2014-08-20	1
2170	126	260139	1978-11-07	1978-11-14	1
41251	2456	4278672	1968-02-15	1968-03-16	1
89025	5301	4112343	1981-07-07	1981-07-19	1
84593	5035	4112343	1940-07-23	1940-08-01	1
12364	730	4112343	2012-03-21	2012-04-01	1
68077	4024	40481087	2006-12-15	2006-12-22	1
40731	2424	4294548	1969-06-25	1969-07-16	1
24455	1460	40481087	1997-01-13	1997-02-03	1
25590	1523	40481087	2011-09-27	2011-10-18	1
43551	2597	40481087	1990-12-15	1990-12-22	1
64144	3791	4152936	1966-03-27	1966-04-10	1
35467	2103	28060	2015-09-07	2015-09-14	1
11013	651	4112343	1983-09-05	1983-09-17	1
11185	662	260139	1976-01-01	1976-01-15	1
5558	328	40481087	2001-11-07	2001-11-14	1
48514	2876	4112343	2012-08-24	2012-09-06	1
78115	4631	317576	2015-09-18	2015-09-19	1
46966	2798	81151	1986-08-20	1986-09-03	1
34999	2079	260139	1970-05-25	1970-06-01	1
17889	1077	40481087	2012-06-01	2012-06-22	1
45031	2682	81151	1978-05-20	1978-06-24	1
65781	3893	40481087	1998-09-18	1998-10-02	1
38140	2266	4113008	2006-12-07	2006-12-21	1
42620	2543	40481087	1979-08-05	1979-08-12	1
21858	1313	40481087	2004-02-19	2004-02-26	1
17448	1051	257012	2012-03-23	2012-03-24	1
24947	1491	80180	2006-05-20	2006-05-21	1
32446	1928	260139	1997-09-21	1997-09-30	1
35267	2091	4112343	1978-08-04	1978-08-13	1
72781	4330	372328	1946-01-21	1946-03-30	1
41605	2477	378001	1971-09-20	1971-11-19	1
40344	2396	260139	1972-10-23	1972-11-06	1
44903	2675	372328	1963-02-18	1963-07-07	1
70680	4199	4112343	2003-08-01	2003-08-10	1
43579	2598	81151	1988-08-22	1988-09-26	1
47396	2822	260139	1996-09-30	1996-10-14	1
88922	5295	260139	1939-11-22	1939-11-29	1
32178	1915	440086	1983-03-03	1983-09-15	1
9428	558	40481087	2012-04-15	2012-05-06	1
69294	4105	40481087	2004-12-19	2005-01-02	1
16664	987	260139	1984-01-13	1984-01-20	1
49030	2905	260139	1981-02-14	1981-02-21	1
13648	807	81151	1964-09-04	1964-10-02	1
70113	4156	192671	1997-04-02	1997-04-03	1
57974	3439	40481087	1961-06-03	1961-06-17	1
41020	2442	4155034	1982-06-23	1982-07-14	1
45137	2686	40481087	1994-09-03	1994-09-17	1
51321	3048	257012	2015-04-04	2015-04-05	1
73611	4379	4112343	2009-02-25	2009-03-07	1
44451	2647	4059173	1996-06-29	1996-09-27	1
2171	126	372328	1951-04-24	1951-06-25	1
41252	2456	40481087	1976-07-07	1976-07-21	1
89026	5301	4134304	1925-11-30	1925-12-30	1
84594	5035	4112343	1962-05-24	1962-06-02	1
12365	730	40481087	1979-06-13	1979-07-04	1
71499	4246	260139	1989-05-02	1989-05-09	1
42410	2530	260139	1988-08-04	1988-08-11	1
24456	1460	78272	2016-11-20	2016-12-25	1
25591	1523	80180	1996-01-21	1996-01-22	1
43552	2597	81151	1999-06-07	1999-06-28	1
64145	3791	4237458	1980-11-22	1981-01-21	1
35468	2103	4112343	2017-03-10	2017-03-19	1
11014	651	4112343	1985-09-07	1985-09-15	1
11186	662	317576	1995-03-21	1995-03-22	1
11225	664	372328	1983-11-26	1983-12-10	1
48515	2876	4112343	2017-12-12	2017-12-20	1
78116	4631	440448	1934-08-04	1934-08-05	1
46967	2798	257012	1960-10-05	1960-10-06	1
35000	2079	260139	1975-12-28	1976-01-11	1
17890	1077	260139	1950-08-27	1950-09-10	1
45032	2682	81151	1989-09-24	1989-10-29	1
65782	3893	28060	1979-10-07	1979-10-14	1
40826	2431	372328	1976-05-25	1976-06-30	1
42621	2543	40481087	2017-02-28	2017-03-14	1
21859	1313	40481087	2004-04-03	2004-04-17	1
17449	1051	260139	2010-03-11	2010-03-25	1
24948	1491	317576	1997-02-18	1997-02-19	1
32447	1928	4113008	1996-02-24	1996-03-16	1
35268	2091	4112343	1979-01-12	1979-01-20	1
72782	4330	372328	1951-06-15	1951-12-08	1
41606	2477	4112343	2003-10-05	2003-10-18	1
40345	2396	372328	1920-08-15	1920-10-27	1
44904	2675	372328	1966-01-22	1967-01-15	1
70681	4199	4116491	1955-04-24	1955-06-01	1
43580	2598	260139	2017-04-29	2017-05-13	1
47397	2822	260139	2001-09-04	2001-09-11	1
88923	5295	260139	1944-05-08	1944-05-15	1
32179	1915	4112343	2011-12-18	2011-12-27	1
9429	558	381316	2003-09-04	2003-09-05	1
71115	4223	28060	1971-06-22	1971-07-03	1
16665	987	4218389	1988-08-06	1988-09-10	1
49031	2905	4112343	1971-08-19	1971-08-30	1
13649	807	440448	1971-01-13	1971-01-14	1
70114	4156	260139	2017-12-24	2017-12-31	1
57975	3439	40481087	2000-10-03	2000-10-17	1
41021	2442	40481087	1981-06-10	1981-07-01	1
45474	2706	28060	1973-02-14	1973-02-23	1
51322	3048	4283893	2015-02-28	2015-05-09	1
73612	4379	260139	1997-07-08	1997-07-15	1
44452	2647	4112343	2011-02-16	2011-02-28	1
2172	126	4112343	1947-10-22	1947-10-30	1
41253	2456	40481087	2002-03-14	2002-03-28	1
89027	5301	80180	1953-01-12	1953-01-13	1
84595	5035	4283893	1934-06-20	1934-07-04	1
12366	730	40481087	1990-06-27	1990-07-18	1
71500	4246	372328	1972-04-30	1972-11-22	1
42411	2530	260139	2001-08-05	2001-08-12	1
24457	1460	4112343	1983-04-21	1983-05-01	1
25592	1523	260139	1974-07-29	1974-08-12	1
43553	2597	4027663	2002-11-16	2002-11-17	1
64146	3791	40481087	1936-12-20	1937-01-03	1
35469	2103	4134304	1991-06-17	1991-08-16	1
11015	651	40481087	1984-08-02	1984-08-09	1
11187	662	372328	1961-02-17	1961-05-31	1
11226	664	372328	1986-02-27	1986-06-19	1
48516	2876	40481087	2014-04-25	2014-05-02	1
78117	4631	4109685	1995-03-09	1995-03-23	1
46968	2798	260139	1988-04-21	1988-04-28	1
35001	2079	372328	1957-03-10	1957-05-24	1
17891	1077	260139	1958-11-18	1958-11-25	1
45033	2682	192671	2016-06-01	2016-06-02	1
65783	3893	260139	1994-07-07	1994-07-21	1
40827	2431	4027663	2003-07-13	2003-07-14	1
42622	2543	80180	2001-03-28	2001-03-29	1
21860	1313	192671	2011-09-04	2011-09-05	1
17450	1051	4059173	1975-06-17	1975-07-17	1
24949	1491	372328	1970-08-27	1970-10-13	1
32448	1928	4116491	2016-07-23	2016-09-14	1
35269	2091	4283893	1967-10-20	1967-11-03	1
72783	4330	4112343	1951-07-27	1951-08-03	1
41607	2477	4112343	2007-04-04	2007-04-12	1
40346	2396	372328	1921-11-21	1922-04-26	1
44905	2675	381316	2012-08-19	2012-08-20	1
70682	4199	4294548	1954-04-01	1954-06-03	1
43581	2598	4112343	1998-01-20	1998-02-01	1
47398	2822	260139	2016-02-27	2016-03-05	1
88924	5295	260139	1961-09-22	1961-09-29	1
32180	1915	40481087	1990-04-19	1990-04-26	1
9430	558	440086	1968-11-01	1970-09-25	1
71116	4223	80180	1989-08-05	1989-08-06	1
16666	987	4296205	1979-07-20	1979-08-24	1
49032	2905	4112343	1986-05-15	1986-05-25	1
13650	807	4112343	1957-10-14	1957-10-27	1
70115	4156	4112343	1957-06-23	1957-07-05	1
57976	3439	28060	1983-06-06	1983-06-19	1
41022	2442	40481087	1986-10-01	1986-10-08	1
45475	2706	81151	1975-10-03	1975-10-17	1
51323	3048	40481087	2004-03-01	2004-03-22	1
73613	4379	4294548	1973-04-29	1973-05-27	1
44453	2647	4294548	2014-10-06	2014-11-03	1
2173	126	4112343	1950-09-16	1950-09-25	1
41254	2456	80180	1995-05-04	1995-05-05	1
89028	5301	372328	1921-10-22	1922-01-05	1
84596	5035	4283893	1990-08-26	1990-11-04	1
15161	895	372328	1988-02-03	1989-03-10	1
71501	4246	4285898	2004-07-16	2004-07-17	1
42412	2530	372328	1964-10-23	1965-01-03	1
24458	1460	257012	1982-11-20	1982-11-21	1
25593	1523	40481087	1971-05-30	1971-06-06	1
43554	2597	4112343	1983-09-27	1983-10-10	1
64147	3791	40481087	1983-11-14	1983-11-28	1
35470	2103	192671	2010-11-02	2010-11-03	1
11016	651	40481087	1987-07-04	1987-07-18	1
11188	662	4112343	1986-01-08	1986-01-19	1
11227	664	378001	1995-07-31	1995-08-30	1
48517	2876	4112343	1971-03-03	1971-03-10	1
78118	4631	4112343	1924-05-09	1924-05-17	1
46969	2798	4112343	1983-11-25	1983-12-05	1
35002	2079	378001	1974-08-08	1974-09-07	1
17892	1077	260139	1999-08-14	1999-08-28	1
45034	2682	260139	1977-03-06	1977-03-13	1
65784	3893	378001	1975-07-26	1975-09-24	1
40828	2431	4112343	1976-11-04	1976-11-12	1
42623	2543	81151	2011-10-17	2011-11-07	1
21861	1313	4112343	1999-08-30	1999-09-06	1
17451	1051	4112343	2010-03-07	2010-03-18	1
24950	1491	4027663	1998-10-29	1998-10-30	1
32449	1928	4142905	1983-11-29	1984-02-27	1
35270	2091	4294548	2007-08-21	2007-09-18	1
72784	4330	4134304	2012-03-20	2012-06-18	1
41608	2477	4112343	2009-01-05	2009-01-14	1
40347	2396	372328	1923-06-20	1923-10-24	1
44906	2675	4218389	1996-10-20	1996-11-10	1
70683	4199	40481087	1985-04-01	1985-04-22	1
43582	2598	4112343	2001-12-13	2001-12-23	1
47399	2822	4112343	2007-12-05	2007-12-18	1
88925	5295	375671	1973-04-08	1973-05-08	1
32181	1915	40481087	1999-05-27	1999-06-17	1
9431	558	4112343	1977-07-08	1977-07-17	1
71117	4223	260139	1966-07-08	1966-07-15	1
19549	1175	28060	1949-01-15	1949-01-24	1
49033	2905	4112343	2003-02-27	2003-03-06	1
13651	807	4218389	2014-10-15	2014-11-19	1
70116	4156	4237458	1962-12-12	1963-02-10	1
57977	3439	80180	1995-05-06	1995-05-07	1
41023	2442	40481087	2007-05-15	2007-05-22	1
45476	2706	372328	1964-07-02	1964-09-15	1
51324	3048	4294548	1977-12-31	1978-01-21	1
73614	4379	28060	2003-12-29	2004-01-09	1
44454	2647	40481087	2000-12-07	2000-12-14	1
2174	126	4112343	2004-02-27	2004-03-05	1
41255	2456	260139	1959-11-30	1959-12-14	1
89029	5301	372328	1923-05-30	1923-07-05	1
84597	5035	40481087	1937-09-23	1937-09-30	1
15162	895	4146173	1984-07-26	1984-09-24	1
71502	4246	28060	1973-05-10	1973-05-18	1
42413	2530	40481087	1973-08-02	1973-08-23	1
24459	1460	260139	1991-01-30	1991-02-06	1
25594	1523	40481087	2008-06-22	2008-06-29	1
43555	2597	4134304	1983-12-30	1984-01-29	1
64148	3791	40481087	1989-04-05	1989-04-26	1
35471	2103	257012	2012-07-06	2012-07-07	1
11017	651	40481087	1995-02-28	1995-03-07	1
11189	662	4218389	1992-10-01	1992-11-04	1
11228	664	4109685	2007-05-20	2007-06-03	1
48518	2876	4112343	1995-09-01	1995-09-10	1
78119	4631	4112343	1929-07-22	1929-08-01	1
46970	2798	4152936	1977-05-25	1977-06-08	1
35003	2079	440448	1956-12-17	1956-12-18	1
17893	1077	4112343	1989-09-28	1989-10-07	1
45035	2682	260139	2017-12-04	2017-12-11	1
65785	3893	4113008	1999-11-15	1999-11-29	1
40829	2431	40481087	1991-07-11	1991-07-25	1
42624	2543	4029498	1964-10-18	1964-10-19	1
21862	1313	4112343	2012-04-03	2012-04-14	1
17452	1051	40481087	2014-01-02	2014-01-23	1
24951	1491	4329847	2011-07-12	2011-07-13	1
32450	1928	40479768	2018-02-19	2018-03-28	1
35271	2091	40481087	1967-09-08	1967-09-15	1
72785	4330	4218389	1988-12-02	1989-01-06	1
41609	2477	4155034	1967-10-22	1967-11-12	1
40348	2396	439777	1995-10-31	1995-11-01	1
44907	2675	4294548	1992-08-06	1992-08-13	1
70684	4199	40481087	1987-08-30	1987-09-13	1
43583	2598	4113008	1992-07-07	1992-07-28	1
47400	2822	40481087	1993-12-11	1993-12-18	1
88926	5295	4112343	1937-11-18	1937-12-01	1
32182	1915	78272	1985-03-07	1985-03-21	1
9432	558	4112343	1981-11-27	1981-12-07	1
71118	4223	260139	1973-02-27	1973-03-06	1
19550	1175	28060	1965-04-01	1965-04-09	1
49034	2905	4112343	2004-04-03	2004-04-14	1
13652	807	40481087	1963-12-09	1963-12-23	1
70117	4156	4283893	1968-01-26	1968-02-23	1
57978	3439	4112343	1968-06-13	1968-06-20	1
41024	2442	40481087	2014-10-06	2014-10-27	1
45477	2706	4112343	1967-10-16	1967-10-28	1
51325	3048	80180	2008-08-24	2008-08-25	1
73615	4379	81151	1990-05-28	1990-06-25	1
44455	2647	28060	1977-02-23	1977-03-04	1
2175	126	4283893	1994-01-13	1994-02-10	1
41256	2456	372328	1956-05-18	1956-07-01	1
89030	5301	4296204	1959-01-04	1959-02-08	1
84598	5035	40481087	1976-06-28	1976-07-05	1
15163	895	40481087	1970-07-20	1970-08-10	1
71503	4246	4112343	1967-05-01	1967-05-11	1
42414	2530	40481087	1975-06-19	1975-06-26	1
24460	1460	4152936	1984-03-15	1984-03-29	1
26476	1571	260139	1980-03-06	1980-03-13	1
43556	2597	4296204	1990-06-26	1990-07-24	1
64149	3791	40481087	2009-06-08	2009-06-15	1
35472	2103	4112343	1994-08-04	1994-08-17	1
11018	651	40481087	1997-10-31	1997-11-14	1
11190	662	40481087	1975-05-26	1975-06-16	1
11229	664	4296204	2006-07-03	2006-07-24	1
48519	2876	4116491	2004-09-29	2004-10-31	1
78120	4631	4112343	2008-08-03	2008-08-11	1
46971	2798	40481087	1999-01-15	1999-02-05	1
35004	2079	4112343	1958-03-06	1958-03-15	1
17894	1077	40481087	2016-09-08	2016-09-15	1
45036	2682	372328	1978-01-20	1978-03-17	1
65786	3893	78272	1996-10-17	1996-10-31	1
40830	2431	40481087	2013-07-22	2013-07-29	1
42625	2543	4112343	2001-08-12	2001-08-20	1
21863	1313	260139	1993-12-22	1993-12-29	1
17453	1051	80180	2001-03-17	2001-03-18	1
24952	1491	40481087	1995-02-04	1995-02-11	1
32451	1928	40481087	1975-09-18	1975-10-02	1
35272	2091	40481087	2004-07-17	2004-07-31	1
72786	4330	4296205	1987-11-24	1987-12-08	1
41610	2477	28060	2015-01-30	2015-02-09	1
40349	2396	4112343	1958-07-03	1958-07-14	1
44908	2675	40481087	1963-12-24	1963-12-31	1
70685	4199	40481087	2004-10-06	2004-10-13	1
43584	2598	40481087	1977-05-29	1977-06-19	1
47401	2822	80180	2011-11-30	2011-12-01	1
88927	5295	4134304	1971-02-18	1971-04-19	1
32183	1915	260139	2006-05-20	2006-06-03	1
9433	558	4278672	1977-11-04	1978-02-02	1
71119	4223	260139	1979-05-16	1979-05-23	1
19551	1175	80180	1974-05-06	1974-05-07	1
49035	2905	4112343	2004-06-16	2004-06-23	1
13653	807	40481087	1965-09-21	1965-10-12	1
70118	4156	40481087	1959-12-16	1960-01-06	1
57979	3439	40481087	1960-05-19	1960-06-02	1
41025	2442	80180	2008-09-19	2008-09-20	1
45478	2706	4112343	1999-08-09	1999-08-16	1
51326	3048	192671	2008-09-03	2008-09-04	1
73616	4379	257012	1973-05-20	1973-05-21	1
44456	2647	260139	1975-11-13	1975-11-27	1
2176	126	40481087	1955-09-06	1955-09-20	1
41257	2456	4112343	1995-08-01	1995-08-12	1
89031	5301	40481087	1937-02-21	1937-02-28	1
84599	5035	40481087	1983-07-08	1983-07-29	1
15164	895	40481087	2003-09-22	2003-10-13	1
71504	4246	40481087	1968-11-08	1968-11-29	1
42415	2530	260139	1968-10-03	1968-10-17	1
24461	1460	4156265	2017-10-21	2017-11-11	1
26477	1571	260139	1995-01-25	1995-02-08	1
43557	2597	40481087	1997-06-24	1997-07-08	1
64150	3791	40481087	2010-06-15	2010-06-22	1
35473	2103	80180	2010-09-21	2010-09-22	1
11019	651	40481087	2006-04-08	2006-04-29	1
11191	662	40481087	1979-09-01	1979-09-15	1
11230	664	80180	2016-12-17	2016-12-18	1
48520	2876	372328	1966-09-07	1967-03-16	1
78121	4631	4156265	1982-06-03	1982-06-24	1
46972	2798	260139	1973-03-21	1973-04-04	1
36339	2153	80180	2006-03-30	2006-03-31	1
17895	1077	28060	1996-02-05	1996-02-13	1
45037	2682	4112343	1995-10-13	1995-10-26	1
65787	3893	260139	1988-09-17	1988-09-24	1
40831	2431	30753	2012-06-05	2012-06-06	1
42626	2543	4294548	1998-01-13	1998-01-20	1
21864	1313	4112343	1996-01-23	1996-02-04	1
17454	1051	195588	2000-02-01	2000-03-28	1
24953	1491	0	2011-07-12	2011-07-13	1
32452	1928	40481087	1982-04-17	1982-05-08	1
35273	2091	80180	2001-10-26	2001-10-27	1
72787	4330	40481087	1959-07-22	1959-07-29	1
41611	2477	4112343	1993-10-01	1993-10-09	1
40350	2396	4112343	1979-02-22	1979-03-04	1
44909	2675	40481087	1984-06-22	1984-07-13	1
70686	4199	260139	1994-05-29	1994-06-05	1
43585	2598	40481087	1986-09-07	1986-09-14	1
47402	2822	4112343	1998-03-01	1998-03-14	1
88928	5295	4134304	1977-12-13	1978-02-11	1
32184	1915	372328	1977-05-18	1977-08-09	1
9434	558	4296204	1985-04-26	1985-05-24	1
71120	4223	4113008	2004-05-23	2004-06-13	1
19552	1175	4048171	1943-08-04	1959-08-02	1
49036	2905	40481087	1990-01-01	1990-01-15	1
13654	807	4112343	1970-06-24	1970-07-05	1
70119	4156	40481087	1971-12-13	1971-12-27	1
57980	3439	40481087	2003-01-14	2003-01-28	1
41026	2442	260139	2012-06-24	2012-07-08	1
45479	2706	4294548	2011-08-27	2011-09-17	1
51327	3048	378001	2014-11-11	2015-01-10	1
73617	4379	260139	1975-06-17	1975-06-24	1
44457	2647	40481087	1984-06-03	1984-06-17	1
2177	126	40481087	1969-01-10	1969-01-17	1
41258	2456	40481087	2002-12-01	2002-12-22	1
89032	5301	40481087	1954-01-27	1954-02-17	1
84600	5035	40481087	1995-01-21	1995-02-11	1
15165	895	260139	1980-02-22	1980-03-07	1
71505	4246	40481087	1969-07-02	1969-07-09	1
42416	2530	260139	2017-04-21	2017-04-28	1
24462	1460	4294548	1982-10-30	1983-01-22	1
26478	1571	4112343	1974-08-29	1974-09-05	1
43558	2597	40481087	1999-11-14	1999-12-05	1
64151	3791	192671	1947-12-25	1947-12-26	1
35474	2103	260139	1982-03-03	1982-03-17	1
11020	651	28060	1988-11-29	1988-12-06	1
11192	662	81893	1999-07-09	1999-07-10	1
11231	664	4112343	1991-02-05	1991-02-15	1
48521	2876	4142905	2011-03-23	2011-05-22	1
78122	4631	4283893	1968-06-01	1968-09-07	1
46973	2798	260139	1977-12-27	1978-01-03	1
36340	2153	81151	1975-02-06	1975-02-20	1
17896	1077	81151	2006-03-04	2006-04-08	1
45038	2682	40481087	1981-11-08	1981-11-15	1
65788	3893	4112343	2018-07-07	2018-07-15	1
40832	2431	260139	1992-09-29	1992-10-06	1
42627	2543	4310024	1999-08-06	1999-08-07	1
21865	1313	4112343	1997-09-28	1997-10-07	1
17455	1051	4112343	1973-09-08	1973-09-21	1
24954	1491	28060	1970-12-28	1971-01-05	1
32453	1928	40481087	1996-05-27	1996-06-17	1
35274	2091	260139	2013-02-05	2013-02-19	1
72788	4330	40481087	1971-07-21	1971-08-11	1
41612	2477	4112343	2001-08-30	2001-09-12	1
40351	2396	4112343	1985-07-04	1985-07-13	1
44910	2675	40481087	1986-12-09	1986-12-30	1
70687	4199	260139	2011-02-08	2011-02-15	1
43586	2598	40481087	1995-12-22	1995-12-29	1
47403	2822	4296204	1977-11-13	1977-12-04	1
88929	5295	4152936	1995-04-13	1995-04-27	1
32185	1915	4156265	1989-06-28	1989-07-19	1
9435	558	4296204	2002-12-12	2003-01-09	1
71121	4223	4134304	1972-04-06	1972-07-05	1
19553	1175	4112343	2001-01-15	2001-01-26	1
49037	2905	40481087	1997-02-13	1997-02-20	1
13655	807	4112343	1971-03-06	1971-03-19	1
70120	4156	0	2006-02-27	2006-02-28	1
60344	3573	81151	1970-04-05	1970-04-19	1
41027	2442	4051466	1973-06-27	1990-09-26	1
45480	2706	378001	2012-01-16	2012-03-16	1
51328	3048	40481087	1995-07-27	1995-08-10	1
73618	4379	4112343	2007-12-22	2007-12-31	1
44458	2647	40481087	1993-04-09	1993-04-23	1
2178	126	40481087	1989-05-26	1989-06-09	1
41259	2456	260139	1972-11-06	1972-11-20	1
89033	5301	40481087	1960-07-20	1960-08-03	1
84601	5035	40481087	1997-02-06	1997-02-13	1
15166	895	260139	1989-12-28	1990-01-04	1
71506	4246	4027663	1996-12-20	1996-12-21	1
42417	2530	4112343	1979-04-10	1979-04-17	1
24463	1460	4296204	1999-10-07	1999-10-21	1
26479	1571	4112343	1988-06-10	1988-06-18	1
43559	2597	40481087	2002-02-28	2002-03-07	1
64152	3791	260139	1966-03-15	1966-03-29	1
35475	2103	372328	1972-07-12	1972-08-19	1
11021	651	260139	2013-11-22	2013-12-06	1
11193	662	260139	1989-03-01	1989-03-15	1
11232	664	40481087	2011-11-18	2011-12-09	1
48522	2876	4283893	1979-09-10	1979-10-08	1
78123	4631	4283893	1978-10-22	1978-12-17	1
46974	2798	372328	2015-05-19	2015-09-20	1
36341	2153	260139	1996-08-18	1996-08-25	1
17897	1077	4112343	1987-05-30	1987-06-09	1
45039	2682	40481087	2004-11-08	2004-11-29	1
65789	3893	80180	2011-04-28	2011-04-29	1
40833	2431	4237458	1975-06-30	1975-07-30	1
42628	2543	40481087	2016-07-20	2016-07-27	1
21866	1313	4112343	1989-07-17	1989-07-27	1
17456	1051	4112343	1978-06-14	1978-06-25	1
24955	1491	192671	2006-05-25	2006-05-26	1
32454	1928	4059173	1974-03-21	1974-04-20	1
35275	2091	4112343	1997-04-27	1997-05-08	1
72789	4330	40481087	1983-07-22	1983-07-29	1
41613	2477	40481087	1956-09-25	1956-10-16	1
40352	2396	4237458	2000-09-03	2000-10-03	1
44911	2675	40481087	1999-10-12	1999-10-19	1
70688	4199	4112343	2016-09-13	2016-09-25	1
43587	2598	40481087	1998-11-20	1998-11-27	1
47404	2822	40481087	1977-03-26	1977-04-02	1
88930	5295	4156265	1933-07-25	1933-08-15	1
32186	1915	4156265	2018-09-13	2018-09-27	1
10092	600	30753	1987-04-23	1987-04-24	1
71122	4223	4156265	1997-05-16	1997-05-30	1
19554	1175	4218389	1945-12-29	1946-01-19	1
49038	2905	40481087	2004-07-21	2004-07-28	1
13656	807	4230399	1991-10-25	1991-12-24	1
70121	4156	80180	1997-03-02	1997-03-03	1
60345	3573	4112343	1931-05-17	1931-05-29	1
41028	2442	4112343	2008-09-29	2008-10-09	1
45481	2706	4113008	2000-08-06	2000-08-27	1
51329	3048	40481087	2002-06-12	2002-07-03	1
73619	4379	4142905	1987-04-14	1987-07-13	1
44459	2647	40481087	1998-03-04	1998-03-18	1
2179	126	80180	1989-09-03	1989-09-04	1
41260	2456	260139	1998-10-10	1998-10-17	1
89034	5301	40481087	2000-11-24	2000-12-08	1
84602	5035	28060	1976-04-21	1976-05-01	1
15167	895	317576	1980-02-29	1980-03-01	1
71507	4246	40481087	2003-07-13	2003-08-03	1
42418	2530	4112343	1979-07-18	1979-07-26	1
27697	1636	28060	1969-05-09	1969-05-19	1
26480	1571	4112343	1991-07-04	1991-07-11	1
43560	2597	4112343	1976-11-23	1976-11-30	1
64153	3791	40481087	1931-11-04	1931-11-11	1
35476	2103	372328	1972-11-17	1973-01-20	1
11022	651	372328	1983-04-04	1983-04-18	1
11194	662	372328	1963-05-21	1963-08-28	1
11233	664	134438	2010-07-09	2011-03-12	1
48523	2876	40481087	1977-09-01	1977-09-15	1
78124	4631	40481087	1923-05-27	1923-06-17	1
46975	2798	4112343	1958-10-16	1958-10-23	1
36342	2153	4112343	1981-12-23	1982-01-01	1
17898	1077	4278672	1963-10-16	1964-01-14	1
45040	2682	260139	1974-08-10	1974-08-24	1
65790	3893	4296205	1978-11-07	1978-11-21	1
40834	2431	40481087	1979-08-17	1979-08-31	1
42629	2543	0	1964-10-18	1964-10-19	1
21867	1313	40481087	1978-04-18	1978-05-09	1
17457	1051	4112343	1998-06-24	1998-07-05	1
24956	1491	440086	1975-11-04	1986-11-11	1
32455	1928	4112343	1979-04-27	1979-05-05	1
35276	2091	4152936	1988-06-25	1988-07-16	1
72790	4330	40481087	2008-04-20	2008-05-04	1
41614	2477	40481087	1968-04-24	1968-05-08	1
40353	2396	4329847	2001-02-21	2001-02-22	1
44912	2675	80180	2002-01-04	2002-01-05	1
70689	4199	4113008	1980-06-05	1980-06-19	1
43588	2598	28060	1985-09-09	1985-09-22	1
47405	2822	40481087	1993-03-16	1993-04-06	1
89687	5337	4048171	1974-02-28	1993-07-11	1
32187	1915	40481087	1980-06-21	1980-07-12	1
10093	600	81151	1994-11-07	1994-11-28	1
71123	4223	40481087	1980-09-11	1980-09-25	1
19555	1175	40481087	1947-01-29	1947-02-19	1
49039	2905	260139	1987-10-07	1987-10-14	1
13657	807	28060	1981-10-25	1981-11-05	1
70122	4156	260139	1992-04-19	1992-04-26	1
60346	3573	4142905	2000-01-24	2000-03-24	1
41029	2442	4112343	2014-04-12	2014-04-19	1
45482	2706	40481087	1989-07-30	1989-08-20	1
52860	3134	80180	1963-09-04	1963-09-05	1
73620	4379	4283893	1969-11-19	1969-12-10	1
44460	2647	40486433	1973-12-19	1989-12-17	1
2180	126	372328	1950-11-23	1950-12-25	1
41261	2456	4283893	1997-07-06	1997-08-03	1
89035	5301	81151	1936-03-07	1936-04-04	1
84603	5035	81151	1976-07-21	1976-08-04	1
15168	895	440086	1967-02-03	1970-02-27	1
71508	4246	28060	1974-01-16	1974-01-28	1
42419	2530	4112343	1996-09-21	1996-10-04	1
27698	1636	260139	1983-02-04	1983-02-18	1
26481	1571	4112343	2007-05-05	2007-05-12	1
43561	2597	4112343	2003-09-10	2003-09-23	1
64154	3791	40481087	1955-09-02	1955-09-23	1
35477	2103	372328	1975-11-08	1976-04-17	1
11023	651	4116491	2014-06-16	2014-08-05	1
11195	662	372328	1977-09-13	1977-11-08	1
11234	664	260139	1987-09-07	1987-09-14	1
48716	2890	260139	1985-01-08	1985-01-15	1
78125	4631	40481087	1933-08-29	1933-09-05	1
46976	2798	4112343	1978-08-11	1978-08-21	1
36343	2153	4112343	2009-12-18	2009-12-31	1
17899	1077	40481087	1953-10-13	1953-10-27	1
45041	2682	260139	2014-07-16	2014-07-30	1
65791	3893	40481087	2011-05-06	2011-05-27	1
40835	2431	40481087	2007-10-03	2007-10-17	1
42630	2543	28060	1979-09-04	1979-09-14	1
21868	1313	40481087	1978-11-13	1978-11-27	1
17458	1051	40481087	1982-03-27	1982-04-10	1
24957	1491	4112343	1980-10-13	1980-10-22	1
32456	1928	257012	1979-08-12	1979-08-13	1
35277	2091	40481087	1968-10-04	1968-10-18	1
72791	4330	80180	1987-02-25	1987-02-26	1
41615	2477	40481087	1971-05-21	1971-05-28	1
40354	2396	40481087	1938-04-18	1938-05-02	1
44913	2675	260139	2005-12-29	2006-01-12	1
70690	4199	4237458	1940-02-17	1940-05-17	1
43589	2598	80180	2008-07-18	2008-07-19	1
47406	2822	260139	1990-09-16	1990-09-30	1
89688	5337	4112343	1977-08-17	1977-08-26	1
32188	1915	40481087	1991-12-22	1992-01-12	1
10094	600	81893	1986-12-24	1986-12-25	1
71124	4223	40481087	2011-08-31	2011-09-21	1
19556	1175	40481087	1950-05-09	1950-05-16	1
49040	2905	372328	1971-08-04	1971-11-08	1
13658	807	4112343	1960-05-17	1960-05-30	1
70123	4156	4294548	1966-04-09	1966-04-30	1
60347	3573	4285898	1962-12-04	1962-12-05	1
41030	2442	4266809	2008-09-19	2008-09-20	1
45483	2706	40481087	1990-05-23	1990-06-13	1
52861	3134	81151	1949-06-04	1949-07-09	1
73621	4379	28060	1983-04-08	1983-04-17	1
46047	2747	28060	1995-09-30	1995-10-10	1
2181	126	4156265	2010-05-26	2010-06-16	1
41262	2456	40481087	2018-06-09	2018-06-23	1
89036	5301	260139	1949-04-30	1949-05-07	1
84604	5035	313217	2011-08-15	2011-08-16	1
15169	895	4112343	2005-10-10	2005-10-18	1
71509	4246	80180	2005-01-12	2005-01-13	1
42420	2530	4278672	1980-09-09	1980-12-08	1
27699	1636	260139	1994-06-13	1994-06-20	1
26482	1571	40481087	1976-11-06	1976-11-13	1
43562	2597	4112343	2012-02-12	2012-02-23	1
64155	3791	40481087	1997-07-20	1997-08-03	1
35478	2103	4116491	2009-05-04	2009-06-07	1
11024	651	4152936	2007-08-26	2007-09-09	1
11196	662	4027663	1993-09-13	1993-09-14	1
11235	664	372328	1986-10-17	1987-06-25	1
48717	2890	4112343	1983-02-17	1983-03-01	1
78126	4631	40481087	2013-01-17	2013-02-07	1
46977	2798	4112343	2006-07-21	2006-07-30	1
36344	2153	4152936	1992-09-18	1992-10-09	1
17900	1077	40481087	1969-11-09	1969-11-16	1
45042	2682	40481087	2011-08-28	2011-09-11	1
69607	4123	260139	1984-10-24	1984-11-07	1
40836	2431	28060	1979-05-04	1979-05-17	1
42631	2543	260139	2015-10-23	2015-10-30	1
22884	1367	372328	1965-12-26	1966-04-08	1
17459	1051	372328	1970-01-14	1971-01-26	1
24958	1491	4112343	2002-05-26	2002-06-04	1
32457	1928	260139	1980-06-09	1980-06-16	1
35278	2091	40481087	1994-06-26	1994-07-17	1
72792	4330	80502	2006-02-18	2006-02-19	1
41616	2477	40481087	1986-09-13	1986-09-27	1
40355	2396	40481087	1946-12-11	1946-12-18	1
44914	2675	4109685	2006-06-21	2006-07-05	1
70691	4199	4283893	2017-08-11	2017-09-01	1
43590	2598	372328	1976-02-27	1976-06-15	1
47407	2822	372328	1976-12-18	1977-03-02	1
89689	5337	4134304	1973-10-04	1973-11-03	1
32189	1915	40481087	2011-03-03	2011-03-24	1
10095	600	260139	1960-06-04	1960-06-11	1
71125	4223	28060	1968-07-14	1968-07-21	1
19557	1175	40481087	2017-02-15	2017-03-08	1
49041	2905	4112343	2010-08-23	2010-08-31	1
13659	807	4112343	2015-07-14	2015-07-21	1
72387	4304	30753	2001-02-24	2001-02-25	1
60348	3573	40481087	1931-04-24	1931-05-15	1
41031	2442	4310024	2005-04-08	2005-04-09	1
45484	2706	40481087	2015-04-06	2015-04-20	1
52862	3134	4112343	2006-11-12	2006-11-25	1
73622	4379	260139	1985-12-29	1986-01-05	1
46048	2747	80180	2009-11-14	2009-11-15	1
2182	126	40481087	1961-07-28	1961-08-11	1
41263	2456	28060	1981-10-21	1981-10-28	1
89037	5301	381316	2003-05-01	2003-05-02	1
84605	5035	321042	2003-03-03	2003-03-04	1
15170	895	40481087	1973-05-05	1973-05-26	1
71510	4246	260139	1969-10-14	1969-10-28	1
42421	2530	40481087	2017-05-20	2017-05-27	1
27700	1636	372328	1956-04-10	1956-05-18	1
26483	1571	40481087	1982-03-06	1982-03-27	1
43563	2597	40481087	1997-02-24	1997-03-17	1
64156	3791	80180	1947-10-10	1947-10-11	1
38141	2267	4112343	1966-06-13	1966-06-23	1
11025	651	4266809	2012-04-11	2012-04-12	1
11197	662	4112343	1999-12-22	2000-01-02	1
11236	664	372328	1997-10-30	1998-08-27	1
48718	2890	40481087	1973-10-28	1973-11-11	1
78127	4631	0	1934-08-04	1934-08-05	1
46978	2798	4134304	1958-04-18	1958-06-17	1
36345	2153	40481087	1972-06-23	1972-07-14	1
17901	1077	40481087	1999-11-26	1999-12-10	1
45043	2682	80180	2016-05-25	2016-05-26	1
69608	4123	4059173	1977-11-10	1978-01-09	1
40837	2431	4112343	1972-07-19	1972-07-27	1
42632	2543	372328	1967-08-04	1967-09-24	1
22885	1367	4112343	1966-08-24	1966-09-01	1
17460	1051	4109685	1988-08-07	1988-08-21	1
24959	1491	4310024	2004-11-26	2004-11-27	1
32458	1928	378001	1976-05-09	1976-07-08	1
35279	2091	40481087	2016-02-09	2016-02-23	1
72793	4330	260139	1964-03-30	1964-04-07	1
45086	2685	80180	1981-01-05	1981-01-06	1
40356	2396	0	2001-02-21	2001-02-22	1
44915	2675	40481087	1974-08-12	1974-08-26	1
70692	4199	4294548	1968-08-23	1968-09-20	1
43591	2598	4152936	2011-11-16	2011-12-07	1
47408	2822	4112343	1999-06-10	1999-06-17	1
89690	5337	372328	1971-12-14	1972-01-30	1
32190	1915	257012	1992-12-02	1992-12-03	1
10096	600	372328	1954-03-07	1954-04-14	1
71126	4223	372328	1961-11-25	1962-01-05	1
19558	1175	28060	1942-07-20	1942-08-02	1
49042	2905	4266809	1999-10-06	1999-10-07	1
13660	807	4112343	2015-11-21	2015-11-30	1
72388	4304	80180	2002-02-19	2002-02-20	1
60349	3573	40481087	1942-03-15	1942-04-05	1
41032	2442	40481087	1998-03-12	1998-03-26	1
45485	2706	40481087	2018-11-07	2018-11-14	1
52863	3134	4237458	1988-12-07	1989-03-07	1
73623	4379	260139	1986-11-25	1986-12-02	1
46049	2747	260139	1974-03-05	1974-03-19	1
2183	126	40481087	1976-04-29	1976-05-06	1
41264	2456	78272	2002-04-17	2002-05-01	1
89038	5301	4112343	1998-11-01	1998-11-09	1
84606	5035	4059173	1996-06-20	1996-09-18	1
15171	895	40481087	1991-10-05	1991-10-19	1
71511	4246	260139	2005-08-14	2005-08-28	1
42422	2530	81151	1968-03-06	1968-04-10	1
27701	1636	372328	1959-08-31	1960-01-15	1
26484	1571	28060	1967-04-28	1967-05-11	1
43564	2597	40481087	2014-08-09	2014-08-30	1
64157	3791	260139	1932-06-26	1932-07-03	1
38142	2267	4112343	1993-07-19	1993-07-26	1
11026	651	40481087	2012-06-29	2012-07-20	1
11198	662	4152936	2018-02-05	2018-02-26	1
11237	664	4112343	1985-03-22	1985-04-03	1
48719	2890	195588	2009-11-26	2010-01-15	1
78128	4631	81151	1921-12-24	1922-01-21	1
46979	2798	4155034	1976-07-08	1976-07-29	1
36346	2153	40481087	2008-11-25	2008-12-16	1
17902	1077	40481087	2004-12-20	2005-01-03	1
45044	2682	4112343	2009-02-17	2009-02-24	1
69609	4123	4112343	2003-05-01	2003-05-09	1
40838	2431	40481087	1996-04-04	1996-04-25	1
42633	2543	4027663	1993-10-11	1993-10-12	1
22886	1367	4116491	2002-04-21	2002-06-11	1
17461	1051	4112343	1990-09-22	1990-10-03	1
24960	1491	40481087	1983-06-11	1983-07-02	1
32459	1928	4112343	2011-06-03	2011-06-16	1
35280	2091	40481087	2016-05-28	2016-06-18	1
72794	4330	260139	1977-08-29	1977-09-12	1
45087	2685	372328	1943-01-25	1943-03-04	1
40357	2396	81151	1946-01-15	1946-01-29	1
44916	2675	40481087	1979-08-08	1979-08-22	1
70693	4199	40481087	2009-08-25	2009-09-08	1
43592	2598	4278672	1986-09-02	1986-10-02	1
52815	3132	28060	1974-08-22	1974-09-04	1
89691	5337	372328	1974-12-15	1975-02-02	1
32191	1915	260139	1984-05-13	1984-05-20	1
10097	600	4027663	1978-12-31	1979-01-01	1
71127	4223	4112343	1967-07-04	1967-07-16	1
19559	1175	260139	1981-05-16	1981-05-30	1
49043	2905	40481087	1983-10-07	1983-10-28	1
13661	807	4156265	1965-10-27	1965-11-10	1
72389	4304	4266809	2002-02-19	2002-02-20	1
60350	3573	40481087	1949-06-04	1949-06-25	1
41033	2442	40481087	2008-08-23	2008-09-13	1
45486	2706	317576	2006-06-20	2006-06-21	1
52864	3134	4283893	1998-10-09	1998-11-27	1
73624	4379	372328	1974-11-18	1975-06-03	1
46050	2747	372328	1978-01-25	1978-03-19	1
2184	126	40481087	1991-07-07	1991-07-21	1
41265	2456	260139	1971-12-03	1971-12-10	1
89039	5301	4116491	1940-07-24	1940-12-01	2
84607	5035	4112343	1963-11-28	1963-12-10	1
15172	895	40481087	1995-07-07	1995-07-28	1
71512	4246	4112343	2002-04-03	2002-04-16	1
42423	2530	81151	1970-12-26	1971-01-30	1
27702	1636	4112343	1960-08-18	1960-08-25	1
26485	1571	80180	1998-08-05	1998-08-06	1
43565	2597	28060	2016-02-05	2016-02-14	1
64158	3791	260139	1976-09-19	1976-09-26	1
38143	2267	4112343	1997-03-10	1997-03-17	1
13746	814	80180	2019-05-24	2019-05-25	1
11199	662	4155034	1993-10-01	1993-10-15	1
11238	664	4112343	2017-07-02	2017-07-13	1
48720	2890	4134304	1970-08-23	1970-10-22	1
78129	4631	260139	1939-10-21	1939-11-04	1
46980	2798	4283893	1960-08-31	1960-12-28	1
36347	2153	81151	1972-04-17	1972-05-22	1
18118	1091	28060	1987-01-16	1987-01-29	1
45045	2682	40481087	1986-11-24	1986-12-08	1
69610	4123	4112343	2015-02-08	2015-02-17	1
40839	2431	80180	2013-07-30	2013-07-31	1
42634	2543	4112343	1991-01-15	1991-01-22	1
22887	1367	4146173	1994-01-22	1994-03-23	1
17462	1051	4112343	2013-11-28	2013-12-08	1
24961	1491	28060	1979-05-08	1979-05-19	1
32460	1928	40481087	1988-06-22	1988-07-06	1
36093	2141	4059173	1956-01-31	1956-03-01	1
72795	4330	4134304	1963-09-01	1963-11-30	1
45088	2685	4112343	2011-12-20	2011-12-28	1
40358	2396	195588	1971-11-06	1971-12-26	1
44917	2675	260139	1969-06-18	1969-07-02	1
70694	4199	28060	1939-01-25	1939-02-02	1
43593	2598	40481087	1985-04-17	1985-05-08	1
52816	3132	78272	1968-12-07	1968-12-21	1
89692	5337	4278672	1981-07-24	1981-08-23	1
32192	1915	4109685	2001-12-13	2001-12-27	1
10098	600	4112343	1974-01-06	1974-01-19	1
71128	4223	4112343	1984-07-25	1984-08-05	1
19560	1175	372328	1941-04-24	1941-07-06	1
49044	2905	78272	2007-08-25	2007-09-08	1
13662	807	40481087	1961-09-29	1961-10-13	1
72390	4304	40481087	1979-09-17	1979-10-01	1
60351	3573	40481087	1967-03-07	1967-03-14	1
41034	2442	30753	2007-01-28	2007-01-29	1
45487	2706	378001	1994-12-06	1995-01-05	1
52865	3134	40481087	1978-10-04	1978-10-18	1
79096	4689	192671	2007-12-12	2007-12-13	1
46051	2747	40481087	1999-05-30	1999-06-06	1
2185	126	40481087	1998-10-25	1998-11-08	1
41266	2456	40481087	1984-01-19	1984-02-02	1
89040	5301	40481087	1921-02-01	1921-02-08	1
84608	5035	4112343	2011-10-21	2011-10-30	1
15173	895	28060	2011-10-15	2011-10-24	1
71513	4246	4112343	2002-08-17	2002-08-29	1
42424	2530	372328	1965-03-04	1965-04-04	1
27703	1636	4266809	2000-06-13	2000-06-14	1
26486	1571	4084167	1958-04-12	1958-04-12	1
43566	2597	30753	2009-09-05	2009-09-06	1
64159	3791	260139	2003-11-25	2003-12-02	1
38144	2267	4112343	2016-12-26	2017-01-04	1
13747	814	372328	1984-12-18	1985-06-22	1
11200	662	4283893	2003-01-23	2003-02-20	1
11239	664	4218389	1988-11-29	1989-01-03	1
48721	2890	4283893	1982-05-19	1982-11-03	1
78130	4631	4109685	1997-03-12	1997-03-26	1
46981	2798	81151	1967-11-27	1967-12-25	1
36348	2153	372328	1966-09-16	1966-10-29	1
18119	1091	28060	2017-02-26	2017-03-08	1
45046	2682	40481087	2005-12-29	2006-01-19	1
69611	4123	4218389	1997-12-25	1998-01-29	1
40840	2431	372328	1989-09-20	1990-09-19	1
42635	2543	4155034	1965-11-12	1965-11-26	1
22888	1367	4278672	1969-03-15	1969-06-13	1
17463	1051	4283893	2012-02-03	2012-10-19	1
24962	1491	78272	1990-10-11	1990-11-01	1
32461	1928	40481087	1988-09-13	1988-09-27	1
36094	2141	4112343	1955-10-20	1955-10-27	1
72796	4330	4155034	1953-07-13	1953-07-27	1
45089	2685	40481087	1997-02-05	1997-02-26	1
40359	2396	260139	1986-03-06	1986-03-20	1
44918	2675	260139	1976-05-31	1976-06-07	1
70695	4199	80180	1979-08-06	1979-08-07	1
43594	2598	40481087	1988-03-13	1988-03-27	1
52817	3132	81151	1981-03-18	1981-04-15	1
89693	5337	80180	2010-09-30	2010-10-01	1
32193	1915	4296205	2005-12-06	2005-12-20	1
10099	600	4112343	1980-09-17	1980-09-29	1
71129	4223	28060	1969-11-15	1969-11-26	1
19561	1175	4112343	1947-10-07	1947-10-19	1
49045	2905	81893	1998-03-15	1998-03-16	1
13663	807	40481087	1975-05-28	1975-06-18	1
72391	4304	40481087	1999-11-08	1999-11-29	1
60352	3573	40481087	1982-07-28	1982-08-18	1
41035	2442	4027663	1998-06-14	1998-06-15	1
45488	2706	4112343	1968-12-24	1969-01-04	1
52866	3134	40481087	1988-03-06	1988-03-27	1
79097	4689	260139	1993-12-29	1994-01-12	1
46052	2747	81151	1990-01-29	1990-02-26	1
2186	126	28060	1952-08-16	1952-08-25	1
41267	2456	40481087	1985-03-06	1985-03-13	1
89041	5301	40481087	1946-04-19	1946-05-03	1
84609	5035	4142905	1948-04-19	1948-07-18	1
15174	895	80180	2005-12-10	2005-12-11	1
71514	4246	4310024	2004-01-18	2004-01-19	1
42425	2530	4112343	1983-06-08	1983-06-17	1
27704	1636	40481087	2004-09-12	2004-09-19	1
26487	1571	4294548	1984-06-22	1984-08-03	1
43567	2597	80180	2010-08-31	2010-09-01	1
64160	3791	313217	2011-06-25	2011-06-26	1
38145	2267	40481087	1972-09-12	1972-09-26	1
13748	814	4027663	2008-07-05	2008-07-06	1
11201	662	4283893	2017-06-16	2017-07-28	1
11240	664	4278672	2005-04-09	2005-06-08	1
48722	2890	40481087	1979-10-20	1979-10-27	1
78131	4631	4112343	1979-08-31	1979-09-08	1
46982	2798	260139	1963-06-23	1963-07-07	1
36349	2153	4112343	1981-05-14	1981-05-26	1
18120	1091	4027663	1988-05-30	1988-05-31	1
48360	2867	81151	1979-06-11	1979-06-25	1
69612	4123	4285898	1998-08-10	1998-08-11	1
40841	2431	4112343	1996-02-20	1996-02-29	1
42636	2543	40481087	1971-02-06	1971-02-13	1
22889	1367	40481087	1998-10-21	1998-11-04	1
17464	1051	40481087	2013-09-21	2013-09-28	1
24963	1491	372328	1974-06-24	1974-10-22	1
32462	1928	40481087	1998-03-15	1998-04-05	1
36095	2141	4112343	1956-07-26	1956-08-08	1
72797	4330	40480160	2012-03-20	2012-06-18	1
45090	2685	40481087	2012-05-07	2012-05-14	1
40360	2396	4112343	1934-03-09	1934-03-16	1
44919	2675	440448	1996-01-23	1996-01-24	1
70696	4199	260139	2014-09-28	2014-10-05	1
43595	2598	260139	1994-02-24	1994-03-03	1
52818	3132	260139	1967-07-18	1967-08-01	1
89694	5337	378001	1987-01-24	1987-03-25	1
32194	1915	40481087	1981-04-17	1981-05-08	1
10100	600	28060	1983-08-17	1983-08-29	1
71130	4223	260139	1971-09-18	1971-10-02	1
19562	1175	4112343	2002-01-06	2002-01-17	1
49046	2905	260139	1995-08-29	1995-09-12	1
13664	807	40481087	2009-12-05	2009-12-12	1
72392	4304	40481087	2002-09-22	2002-09-29	1
60353	3573	40481087	1989-02-18	1989-03-11	1
41036	2442	4134304	1979-07-09	1979-09-07	1
45489	2706	4142905	1973-01-16	1973-02-15	1
52867	3134	40481087	2017-09-02	2017-09-16	1
79098	4689	4112343	1981-08-23	1981-09-02	1
46053	2747	81151	2007-02-27	2007-03-13	1
2187	126	81151	1985-08-30	1985-10-04	1
41268	2456	40481087	1987-03-08	1987-03-22	1
89253	5315	0	1979-04-15	1979-04-16	1
84610	5035	40481087	1968-02-11	1968-03-03	1
15175	895	372328	1963-12-16	1964-01-10	1
71515	4246	40481087	1967-07-02	1967-07-09	1
42426	2530	4230399	1972-12-20	1973-01-19	1
27705	1636	30753	1999-06-19	1999-06-20	1
26488	1571	40481087	1994-05-18	1994-06-01	1
43568	2597	81151	1973-01-12	1973-01-26	1
64161	3791	4112343	2007-10-19	2007-10-28	1
38146	2267	40481087	1980-12-20	1980-12-27	1
13749	814	40481087	1986-03-09	1986-03-23	1
11202	662	4329847	2012-06-06	2012-06-07	1
11241	664	40481087	1985-10-21	1985-11-04	1
48723	2890	40481087	2011-03-26	2011-04-09	1
78132	4631	40481087	1947-07-28	1947-08-11	1
46983	2798	260139	2005-09-27	2005-10-04	1
36350	2153	4112343	2012-05-23	2012-05-31	1
18121	1091	4048171	1961-06-13	1975-06-12	1
48361	2867	260139	2003-10-05	2003-10-19	1
69613	4123	40481087	1991-12-21	1992-01-11	1
40842	2431	4112343	1999-01-18	1999-01-27	1
44238	2633	440086	1958-10-13	1965-10-21	1
22890	1367	28060	2000-05-17	2000-05-24	1
17465	1051	40486433	1970-02-15	1970-02-16	1
24964	1491	4112343	1985-06-02	1985-06-12	1
32463	1928	260139	1974-03-22	1974-04-05	1
36096	2141	4112343	1973-10-24	1973-11-02	1
72798	4330	40481087	1950-08-15	1950-09-05	1
45091	2685	260139	1943-02-25	1943-03-04	1
40361	2396	4112343	1937-12-27	1938-01-05	1
44920	2675	4112343	2001-04-14	2001-04-23	1
70697	4199	372328	1963-01-17	1963-05-16	1
43596	2598	260139	2003-07-17	2003-07-26	1
52819	3132	372328	1965-11-23	1965-12-07	1
89695	5337	4296204	2009-06-27	2009-07-25	1
32195	1915	40481087	2012-07-22	2012-08-05	1
10101	600	78272	1973-06-25	1973-07-09	1
71131	4223	372328	1958-08-18	1959-07-03	2
19563	1175	260139	2009-04-19	2009-05-03	1
49047	2905	372328	1972-01-07	1972-11-13	1
13665	807	78272	1998-04-21	1998-05-12	1
72393	4304	257012	2015-03-18	2015-03-19	1
60354	3573	260139	1968-11-30	1968-12-07	1
41037	2442	40481087	1982-11-02	1982-11-16	1
45490	2706	40481087	1964-11-08	1964-11-22	1
52868	3134	260139	1977-08-22	1977-08-29	1
79099	4689	4112343	2000-08-25	2000-09-06	1
46054	2747	260139	1984-02-20	1984-02-27	1
2188	126	378001	2000-06-17	2000-07-17	1
41269	2456	40481087	1999-06-29	1999-07-20	1
89254	5315	80180	1957-03-25	1957-03-26	1
85437	5085	28060	1977-04-11	1977-04-18	1
15176	895	4112343	2008-03-20	2008-03-31	1
71516	4246	40481087	1971-03-08	1971-03-29	1
42427	2530	40481087	1995-04-05	1995-04-26	1
27706	1636	80180	2000-06-13	2000-06-14	1
26489	1571	40481087	2011-06-25	2011-07-02	1
43569	2597	260139	1981-08-30	1981-09-13	1
64162	3791	4134304	2012-04-08	2012-06-07	1
38147	2267	40481087	1986-06-01	1986-06-08	1
13750	814	4116491	2011-07-05	2011-08-20	1
11203	662	40481087	1962-06-21	1962-07-12	1
11242	664	40481087	2002-08-16	2002-08-30	1
48724	2890	260139	1991-07-13	1991-07-27	1
78133	4631	40481087	2011-11-10	2011-11-17	1
46984	2798	4112343	1996-05-01	1996-05-10	1
36351	2153	40481087	1984-03-18	1984-03-25	1
18122	1091	40481087	2002-07-13	2002-07-27	1
48362	2867	257012	1992-12-25	1993-01-22	1
69614	4123	40481087	1994-12-31	1995-01-07	1
40843	2431	4156265	1995-05-16	1995-05-30	1
44239	2633	4266809	1981-08-28	1981-08-29	1
22891	1367	81151	1966-04-25	1966-05-30	1
17466	1051	260139	1982-02-12	1982-02-19	1
24965	1491	4142905	1995-08-07	1995-09-06	1
32464	1928	260139	2004-09-24	2004-10-08	1
36097	2141	4112343	2004-07-25	2004-08-07	1
72799	4330	40481087	1967-03-26	1967-04-09	1
45092	2685	260139	1952-10-13	1952-10-27	1
40362	2396	4112343	1959-06-11	1959-06-23	1
44921	2675	4112343	2006-12-25	2007-01-04	1
70698	4199	4112343	1972-01-04	1972-01-12	1
43597	2598	40481087	2004-02-05	2004-02-19	1
52820	3132	40481087	1994-06-25	1994-07-16	1
89696	5337	40481087	1982-11-25	1982-12-16	1
32196	1915	260139	1987-06-06	1987-06-13	1
10102	600	4152936	2012-08-25	2012-09-15	1
71132	4223	372328	1960-07-27	1960-12-30	1
19564	1175	372328	1942-07-01	1943-01-03	1
49048	2905	372328	1974-06-06	1974-11-25	1
13666	807	80180	1994-09-22	1994-09-23	1
72394	4304	260139	1967-05-11	1967-05-25	1
60355	3573	372328	1928-03-02	1928-12-29	1
41038	2442	40481087	2010-01-11	2010-01-25	1
45491	2706	40481087	1966-10-19	1966-11-02	1
52869	3134	313217	2007-02-15	2007-02-16	1
79100	4689	40481087	1998-01-07	1998-01-28	1
46055	2747	260139	2008-12-09	2008-12-23	1
2189	126	40481087	1955-04-16	1955-04-30	1
42589	2542	134438	1986-06-01	1987-05-03	1
89255	5315	260139	1949-10-23	1949-11-06	1
85438	5085	40481087	2012-10-14	2012-10-28	1
15177	895	28060	2007-08-11	2007-08-22	1
71517	4246	40481087	1987-05-09	1987-05-30	1
42428	2530	40481087	2008-04-22	2008-04-29	1
27707	1636	81893	1998-09-22	1998-09-23	1
26490	1571	28060	1979-02-15	1979-02-24	1
43570	2597	260139	1996-06-04	1996-06-18	1
64163	3791	4146173	2002-01-31	2002-04-01	1
38148	2267	40481087	1999-07-05	1999-07-19	1
13751	814	40481087	2003-03-14	2003-04-04	1
11204	662	40481087	1969-09-11	1969-09-18	1
14017	829	28060	1973-12-16	1973-12-23	1
48725	2890	260139	2013-08-12	2013-08-19	1
78134	4631	78272	1925-01-05	1925-02-02	1
46985	2798	4116491	1998-09-30	1998-11-09	1
36352	2153	257012	1994-11-28	1994-11-29	1
18123	1091	40481087	2005-11-14	2005-12-05	1
48363	2867	4112343	1982-11-11	1982-11-21	1
69615	4123	378001	1967-04-16	1967-06-15	1
40844	2431	4266809	2013-07-30	2013-07-31	1
44240	2633	4285898	1981-03-31	1981-04-01	1
22892	1367	260139	2006-06-25	2006-07-02	1
17467	1051	4051466	1969-02-15	1984-05-27	1
24966	1491	4155034	2001-06-06	2001-06-27	1
32465	1928	4112343	1998-09-26	1998-10-06	1
36098	2141	40481087	1980-03-08	1980-03-22	1
72800	4330	40481087	1978-04-12	1978-05-03	1
45093	2685	260139	1967-12-17	1967-12-31	1
40363	2396	4112343	1991-09-14	1991-09-24	1
44922	2675	4278672	1978-02-13	1978-04-14	1
70699	4199	4112343	1973-09-07	1973-09-20	1
47770	2841	4329847	1984-10-21	1984-10-22	1
52821	3132	440086	1976-07-03	1981-07-12	1
89697	5337	260139	2014-08-31	2014-09-07	1
32197	1915	260139	2002-11-29	2002-12-06	1
10103	600	4285898	1987-06-22	1987-06-23	1
71133	4223	4112343	1984-12-06	1984-12-17	1
19565	1175	372328	1981-07-14	1982-08-08	1
49049	2905	375671	1999-10-06	1999-11-05	1
13667	807	192671	1994-11-04	1994-11-05	1
72395	4304	4029498	1977-09-08	1977-09-09	1
60356	3573	378001	1956-08-16	1956-09-15	1
41039	2442	28060	1978-05-30	1978-06-08	1
45492	2706	40481087	1984-05-07	1984-05-21	1
52870	3134	4112343	1996-06-06	1996-06-18	1
79101	4689	40481087	1998-03-07	1998-03-21	1
46056	2747	372328	1976-02-21	1976-03-06	1
2190	126	40481087	1973-11-27	1973-12-04	1
42590	2542	192671	2003-04-24	2003-04-25	1
89256	5315	372328	1919-06-18	1919-11-23	1
85439	5085	372328	1976-12-08	1977-02-17	1
15178	895	81151	1962-11-21	1962-12-05	1
72618	4320	196456	1970-05-14	1970-05-14	1
42429	2530	80180	2000-09-04	2000-09-05	1
27708	1636	260139	1975-07-20	1975-07-27	1
26491	1571	81151	2001-03-27	2001-04-10	1
43571	2597	260139	2008-10-05	2008-10-12	1
64164	3791	4152936	1953-09-17	1953-10-01	1
38149	2267	40481087	2007-10-31	2007-11-14	1
13752	814	260139	2003-04-15	2003-04-22	1
11205	662	40481087	1970-09-21	1970-10-12	1
14018	829	28060	2006-09-13	2006-09-23	1
48726	2890	40481087	2003-06-22	2003-06-29	1
78135	4631	80180	1953-09-17	1953-09-18	1
46986	2798	4218389	1973-05-27	1973-06-24	1
36353	2153	260139	1981-06-30	1981-07-07	1
18124	1091	80180	1997-12-14	1997-12-15	1
48364	2867	4134304	1988-06-07	1988-07-07	1
69616	4123	4142905	2013-02-09	2013-03-11	1
40845	2431	4310024	2011-09-09	2011-09-10	1
44241	2633	40481087	1960-04-05	1960-04-26	1
22893	1367	4283893	2006-04-30	2006-09-24	1
17468	1051	4084167	1966-03-06	1966-03-06	1
24967	1491	4294548	2005-11-19	2005-12-17	1
32466	1928	4237458	2019-04-22	2019-05-22	1
36099	2141	260139	1958-04-07	1958-04-14	1
72801	4330	40481087	2006-06-03	2006-06-24	1
45094	2685	40481087	2002-05-08	2002-05-22	1
40364	2396	4278672	1971-02-08	1971-05-09	1
44923	2675	4294548	2012-10-18	2012-11-08	1
70700	4199	4112343	2012-04-25	2012-05-05	1
47771	2841	40481087	1961-11-08	1961-11-15	1
52822	3132	4112343	1971-10-26	1971-11-04	1
89698	5337	40481087	1998-07-03	1998-07-24	1
32198	1915	372328	2013-04-02	2014-03-11	1
10104	600	4310024	1986-08-26	1986-08-27	1
71134	4223	4142905	1973-05-01	1973-05-31	1
19566	1175	440086	1953-07-25	1953-12-26	1
49050	2905	4027663	1991-11-22	1991-11-23	1
13668	807	260139	1973-11-17	1973-11-24	1
72396	4304	4112343	1990-09-08	1990-09-21	1
60357	3573	4027663	1955-04-20	1955-04-21	1
41040	2442	81151	1997-07-25	1997-08-15	1
45493	2706	80180	2006-11-19	2006-11-20	1
52871	3134	4155034	2001-08-01	2001-08-22	1
79102	4689	80180	2007-10-12	2007-10-13	1
46057	2747	440086	1983-06-09	1983-11-10	1
2191	126	40481087	1983-09-02	1983-09-16	1
42591	2542	260139	2005-04-04	2005-04-11	1
89257	5315	372328	1920-09-18	1921-05-29	1
85440	5085	4285898	2012-12-19	2012-12-20	1
15179	895	81151	1971-11-18	1971-12-02	1
72619	4320	257012	1984-03-11	1984-04-01	1
42430	2530	260139	1978-04-06	1978-04-20	1
27709	1636	4112343	1997-08-05	1997-08-17	1
26492	1571	192671	1998-08-27	1998-08-28	1
43572	2597	378001	1993-06-08	1993-08-07	1
64165	3791	4155034	1939-05-20	1939-06-03	1
38150	2267	80180	2009-11-17	2009-11-18	1
13753	814	40481087	1988-06-16	1988-07-07	1
11206	662	40481087	1982-09-06	1982-09-13	1
14019	829	78272	1980-03-12	1980-04-16	1
48727	2890	80180	2001-12-13	2001-12-14	1
78136	4631	81151	1984-08-12	1984-09-02	1
46987	2798	40481087	1961-12-01	1961-12-15	1
36354	2153	4112343	1974-10-06	1974-10-16	1
18125	1091	4112343	1961-12-12	1961-12-21	1
48365	2867	40481087	2007-07-06	2007-07-20	1
69617	4123	4266809	1999-01-07	1999-01-08	1
40846	2431	40481087	1986-04-02	1986-04-16	1
44242	2633	80180	1981-08-28	1981-08-29	1
22894	1367	40481087	1990-11-24	1990-12-08	1
17469	1051	4112343	1969-03-21	1969-03-29	1
24968	1491	40481087	1982-01-05	1982-01-12	1
32467	1928	4283893	1979-06-17	1979-12-02	1
36100	2141	4112343	1947-11-04	1947-11-14	1
72802	4330	40481087	2015-09-30	2015-10-21	1
45095	2685	372328	1966-07-01	1968-01-04	1
40365	2396	4296204	1954-10-14	1954-11-04	1
44924	2675	40481087	1980-12-20	1981-01-03	1
70701	4199	4116491	1957-05-31	1957-07-04	1
47772	2841	80180	1990-11-03	1990-11-04	1
52823	3132	4112343	1995-05-05	1995-05-14	1
3288	191	260139	1968-09-30	1968-10-07	1
32199	1915	4237458	1991-07-09	1991-10-07	1
10105	600	40481087	1992-02-10	1992-02-17	1
71135	4223	4218389	1975-04-21	1975-05-12	1
19567	1175	4152936	1979-06-25	1979-07-09	1
49051	2905	4112343	1967-03-01	1967-03-09	1
13669	807	4112343	1967-03-26	1967-04-08	1
72397	4304	4294548	2014-12-31	2015-08-12	1
60358	3573	4109685	1978-09-04	1978-09-25	1
41041	2442	81893	2006-03-04	2006-03-05	1
45494	2706	4109685	2001-08-22	2001-09-05	1
52872	3134	4218389	1966-11-07	1966-12-12	1
79103	4689	381316	1993-03-02	1993-03-03	1
46058	2747	4112343	2005-05-23	2005-06-02	1
2192	126	40481087	2016-04-14	2016-04-28	1
42592	2542	4112343	1984-05-23	1984-06-05	1
89258	5315	4112343	1934-06-03	1934-06-10	1
85441	5085	4310024	2011-02-28	2011-03-01	1
15180	895	40481087	1980-01-25	1980-02-15	1
72620	4320	260139	2013-05-25	2013-06-08	1
42431	2530	4112343	1985-06-10	1985-06-18	1
27710	1636	28060	2013-04-27	2013-05-10	1
26493	1571	257012	1984-07-27	1984-07-28	1
43573	2597	4112343	1983-12-13	1983-12-21	1
66614	3946	80180	2003-02-25	2003-02-26	1
38151	2267	260139	1983-10-21	1983-10-28	1
13754	814	40481087	2004-09-30	2004-10-07	1
11207	662	40481087	1991-01-03	1991-01-24	1
14020	829	80180	2010-03-30	2010-03-31	1
48728	2890	257012	1982-06-23	1982-06-24	1
78137	4631	260139	1921-10-25	1921-11-08	1
46988	2798	40481087	1973-02-21	1973-02-28	1
36355	2153	4112343	2007-04-22	2007-05-01	1
18126	1091	4116491	1999-05-28	1999-07-03	1
48366	2867	40481087	2010-01-10	2010-01-24	1
69618	4123	372328	1963-08-14	1963-12-01	1
40847	2431	40481087	1987-10-17	1987-10-24	1
44243	2633	372328	1951-01-19	1951-03-22	1
22895	1367	372328	1967-11-29	1968-04-05	1
17470	1051	4112343	1975-10-15	1975-10-24	1
28495	1689	260139	1975-02-19	1975-02-26	1
32468	1928	4283893	1984-06-03	1984-07-08	1
36101	2141	40481087	1950-06-23	1950-07-14	1
72803	4330	78272	1955-08-16	1955-09-13	1
45096	2685	4283893	1994-09-21	1994-10-12	1
40366	2396	40481087	1993-09-21	1993-10-05	1
44925	2675	81151	1964-09-10	1964-09-24	1
70702	4199	4296205	1970-06-14	1970-06-28	1
47773	2841	4112343	1953-03-09	1953-03-18	1
52824	3132	4278672	1995-07-01	1995-09-29	1
3289	191	378419	1997-10-14	1997-10-15	1
32200	1915	4294548	1992-10-14	1992-12-23	1
10106	600	260139	1987-04-09	1987-04-16	1
71136	4223	4283893	1983-07-19	1983-08-30	1
19568	1175	260139	1953-09-20	1953-09-27	1
49052	2905	4285898	1998-12-10	1998-12-11	1
13670	807	40481087	1990-09-03	1990-09-24	1
72398	4304	40481087	1969-04-16	1969-05-07	1
60359	3573	4112343	1941-01-18	1941-01-30	1
41042	2442	260139	1975-07-31	1975-08-07	1
45495	2706	4218389	2010-02-20	2010-03-27	1
52873	3134	40481087	1926-05-07	1926-05-28	1
79104	4689	4027663	1996-05-02	1996-05-03	1
46059	2747	4218389	1980-06-29	1980-07-20	1
2193	126	372328	1950-04-06	1950-06-26	1
42593	2542	4112343	2000-03-26	2000-04-04	1
89259	5315	4112343	1977-02-15	1977-02-26	1
85442	5085	40481087	2009-05-11	2009-05-25	1
15181	895	40481087	1982-04-12	1982-04-19	1
72621	4320	260139	2018-07-22	2018-07-29	1
42432	2530	40481087	1971-12-25	1972-01-01	1
27711	1636	260139	2019-02-16	2019-03-02	1
26494	1571	4084167	1966-01-06	1966-01-06	1
43574	2597	40481087	1999-01-06	1999-01-20	1
66615	3946	260139	1999-01-04	1999-01-11	1
38152	2267	372328	1969-08-24	1969-11-17	1
13755	814	30753	2018-03-30	2018-03-31	1
11208	662	40481087	2001-06-21	2001-06-28	1
14021	829	260139	2016-01-13	2016-01-20	1
48729	2890	372328	1964-02-26	1964-05-15	1
78138	4631	378001	1986-08-23	1986-09-22	1
46989	2798	40481087	2010-03-14	2010-03-28	1
36356	2153	4283893	1994-11-07	1995-04-03	1
18127	1091	4152936	2016-04-07	2016-04-28	1
48367	2867	378001	1985-07-23	1985-08-22	1
69619	4123	4027663	1992-06-17	1992-06-18	1
40848	2431	40481087	2001-10-04	2001-10-25	1
44244	2633	372328	1951-11-17	1952-09-25	1
22896	1367	4112343	1997-05-23	1997-05-31	1
17471	1051	4113008	1991-08-06	1991-08-20	1
28496	1689	378001	1943-09-14	1943-10-14	1
32469	1928	40481087	1979-03-20	1979-04-10	1
36102	2141	40481087	1958-05-03	1958-05-10	1
72804	4330	257012	1979-07-03	1979-07-04	1
45097	2685	40481087	1989-06-27	1989-07-11	1
40367	2396	260139	1959-01-25	1959-02-01	1
44926	2675	4112343	2000-02-07	2000-02-15	1
70703	4199	40481087	1985-12-24	1985-12-31	1
47774	2841	4112343	1968-01-01	1968-01-10	1
52825	3132	40481087	1991-07-17	1991-08-07	1
3290	191	4112343	1962-05-24	1962-06-03	1
32201	1915	40481087	1976-11-26	1976-12-03	1
10107	600	321042	1997-02-19	1997-02-20	1
71137	4223	40481087	1968-12-31	1969-01-07	1
19569	1175	372328	1943-06-02	1943-07-04	1
49053	2905	4296204	2014-05-04	2014-05-18	1
13671	807	40481087	1996-06-03	1996-06-10	1
72399	4304	0	1977-09-08	1977-09-09	1
60360	3573	4112343	1946-05-24	1946-06-03	1
41043	2442	4112343	1977-12-19	1977-12-28	1
46824	2788	81151	1980-01-08	1980-02-12	1
52874	3134	40481087	1961-05-30	1961-06-20	1
79105	4689	4112343	2001-10-31	2001-11-13	1
46060	2747	40481087	2013-11-10	2013-11-24	1
2194	126	4112343	2016-09-30	2016-10-08	1
42594	2542	4116491	2015-05-18	2015-06-24	1
89260	5315	192671	1957-05-08	1957-05-09	1
85443	5085	80180	2013-11-14	2013-11-15	1
15409	915	78272	2012-08-03	2012-08-17	1
72622	4320	372328	1973-02-11	1973-09-02	2
42433	2530	40481087	1988-02-25	1988-03-03	1
27712	1636	372328	1960-03-15	1961-01-20	1
26495	1571	4142905	1971-02-03	1971-03-05	1
43575	2597	40481087	1999-02-26	1999-03-12	1
66616	3946	4027663	1991-03-15	1991-03-16	1
38153	2267	372328	1971-10-08	1971-11-29	1
13756	814	4112343	1988-02-05	1988-02-12	1
11209	662	0	2012-06-06	2012-06-07	1
14022	829	4059173	2012-03-29	2012-05-28	1
48730	2890	4112343	2015-03-16	2015-03-24	1
78139	4631	4112343	1933-10-10	1933-10-22	1
46990	2798	40481087	2012-03-22	2012-04-05	1
36357	2153	40481087	2009-08-22	2009-09-05	1
18128	1091	40481087	2010-08-19	2010-09-09	1
48368	2867	4283893	1992-11-06	1993-01-22	1
69620	4123	4112343	1971-02-22	1971-03-03	1
40849	2431	40481087	2017-12-14	2018-01-04	1
44245	2633	375671	1965-05-14	1965-07-13	1
22897	1367	4155034	1992-05-18	1992-06-01	1
17472	1051	40481087	1975-09-20	1975-10-04	1
28497	1689	378419	2019-01-10	2019-01-11	1
32470	1928	40481087	1981-09-28	1981-10-12	1
36103	2141	40481087	1981-06-24	1981-07-08	1
72805	4330	4112343	2007-05-24	2007-06-01	1
45098	2685	28060	1989-05-05	1989-05-17	1
40368	2396	372328	1924-05-21	1924-10-29	1
44927	2675	4113008	1992-01-01	1992-01-15	1
70704	4199	40481087	1991-05-01	1991-05-15	1
47775	2841	4112343	1983-02-23	1983-03-05	1
52826	3132	40481087	1993-10-01	1993-10-22	1
3291	191	4112343	1987-07-25	1987-08-04	1
32202	1915	40481087	1987-06-14	1987-06-28	1
10108	600	4112343	1967-06-30	1967-07-08	1
71138	4223	81151	2019-04-26	2019-05-17	1
19570	1175	4059173	1967-02-28	1967-04-29	1
49054	2905	195588	2006-11-18	2007-01-08	1
16408	971	28060	1966-08-18	1966-08-28	1
72400	4304	260139	1988-05-03	1988-05-17	1
60361	3573	4112343	2004-01-12	2004-01-22	1
41044	2442	40481087	1974-10-11	1974-10-25	1
46825	2788	372328	1983-03-23	1984-03-04	1
52875	3134	40481087	1969-01-15	1969-01-22	1
79106	4689	4285898	2007-01-14	2007-01-15	1
46061	2747	28060	1980-10-28	1980-11-04	1
5268	311	28060	2016-01-11	2016-01-22	1
42595	2542	4278672	1978-05-12	1978-07-11	1
89261	5315	260139	1942-01-04	1942-01-18	1
85444	5085	4027663	2004-09-02	2004-09-03	1
15410	915	260139	2010-01-27	2010-02-10	1
72623	4320	4112343	1984-03-16	1984-03-24	1
43772	2610	78272	1960-05-21	1960-06-04	1
27713	1636	4059173	2012-01-15	2012-02-14	1
26496	1571	40481087	1959-07-13	1959-08-03	1
43576	2597	40481087	2018-01-18	2018-02-01	1
66617	3946	4112343	1965-02-14	1965-02-24	1
38154	2267	375671	1969-12-22	1970-02-20	1
13757	814	4112343	1989-06-08	1989-06-17	1
11210	662	80180	2001-05-29	2001-05-30	1
14023	829	4112343	1984-04-26	1984-05-06	1
48731	2890	4112343	2016-09-15	2016-09-23	1
78140	4631	4112343	1992-04-04	1992-04-12	1
46991	2798	40481087	2017-10-13	2017-10-20	1
36358	2153	40481087	2014-08-18	2014-08-25	1
18129	1091	28060	1967-09-23	1967-10-02	1
48369	2867	40481087	2003-09-03	2003-09-17	1
69621	4123	4112343	1977-07-03	1977-07-12	1
43825	2613	80180	1996-09-14	1996-09-15	1
44246	2633	4027663	1973-10-09	1973-10-10	1
22898	1367	40481087	2000-10-01	2000-10-22	1
17473	1051	40481087	1980-08-14	1980-08-28	1
28498	1689	4112343	1963-02-07	1963-02-20	1
34433	2046	0	2014-04-01	2014-04-02	1
36104	2141	260139	1959-03-12	1959-03-26	1
72806	4330	4283893	1979-06-05	1979-09-04	1
45099	2685	81151	1992-04-12	1992-05-10	1
40369	2396	381316	2000-11-08	2000-11-09	1
48753	2892	260139	1975-06-18	1975-06-25	1
70705	4199	40481087	2012-06-30	2012-07-14	1
47776	2841	4134304	1986-10-06	1986-12-05	1
52827	3132	80180	2007-04-17	2007-04-18	1
3292	191	4156265	1983-10-06	1983-10-27	1
32203	1915	40481087	2007-06-10	2007-06-17	1
10109	600	4112343	2008-01-30	2008-02-10	1
71139	4223	192671	1989-11-01	1989-11-02	1
19571	1175	4112343	2000-05-08	2000-05-18	1
49055	2905	260139	2007-06-24	2007-07-01	1
16409	971	81151	1965-08-20	1965-09-17	1
72401	4304	260139	1993-10-30	1993-11-06	1
60362	3573	4134304	1936-02-19	1936-03-20	1
41045	2442	40481087	1979-01-10	1979-01-24	1
46826	2788	40481087	2008-12-10	2008-12-17	1
52876	3134	40481087	2003-09-26	2003-10-10	1
79107	4689	40481087	1968-04-09	1968-04-16	1
46062	2747	260139	2019-04-30	2019-05-07	1
5269	311	80180	2011-10-06	2011-10-07	1
42596	2542	40481087	1969-03-21	1969-04-11	1
89262	5315	260139	1945-02-14	1945-02-28	1
85445	5085	4112343	2009-05-14	2009-05-27	1
15411	915	372328	1971-10-11	1972-09-02	1
72624	4320	4156265	1979-07-10	1979-07-24	1
43773	2610	257012	1978-12-12	1978-12-13	1
27714	1636	4112343	1963-09-12	1963-09-22	1
26497	1571	40481087	1981-05-27	1981-06-03	1
46313	2761	80180	2017-07-04	2017-07-05	1
66618	3946	4112343	1970-10-27	1970-11-07	1
38155	2267	4112343	1988-01-03	1988-01-14	1
13758	814	4112343	1993-05-29	1993-06-05	1
11211	662	378001	2011-07-13	2011-09-11	1
14024	829	4027663	2003-06-10	2003-06-11	1
48732	2890	40481087	1973-07-17	1973-07-24	1
78141	4631	4112343	1995-04-01	1995-04-13	1
48733	2891	372328	1978-12-26	1979-11-08	1
38546	2291	260139	2018-12-19	2018-12-26	1
18130	1091	260139	1966-05-18	1966-05-25	1
48370	2867	40481087	2013-04-15	2013-05-06	1
69622	4123	4152936	1965-07-04	1965-07-25	1
43826	2613	260139	1990-11-19	1990-12-03	1
44247	2633	4109685	1991-11-24	1991-12-08	1
22899	1367	80180	2005-02-04	2005-02-05	1
17474	1051	40481087	2005-08-16	2005-08-30	1
28499	1689	40481087	1993-01-02	1993-01-09	1
34434	2046	28060	1945-03-03	1945-03-15	1
36105	2141	40479768	1961-09-01	1961-10-08	1
72807	4330	4283893	1986-04-09	1986-05-28	1
45100	2685	258780	1965-01-28	1965-01-29	1
40370	2396	4112343	1949-08-09	1949-08-16	1
48754	2892	372328	1974-01-22	1974-03-08	1
71305	4235	80180	2014-02-05	2014-02-06	1
47777	2841	4237458	1981-11-01	1981-12-31	1
52828	3132	81151	1999-08-09	1999-09-13	1
3293	191	40481087	1921-06-04	1921-06-11	1
33920	2017	260139	2001-08-08	2001-08-22	1
10110	600	4116491	1984-12-29	1985-02-03	1
71140	4223	260139	1976-11-19	1976-11-26	1
19572	1175	4112343	2001-03-28	2001-04-08	1
49056	2905	260139	2012-12-03	2012-12-10	1
16410	971	195588	2005-05-11	2005-07-05	1
72402	4304	4027663	1991-09-05	1991-09-06	1
60363	3573	4310024	1960-12-14	1960-12-15	1
41046	2442	40481087	1979-04-03	1979-04-17	1
46827	2788	4283893	2014-10-22	2014-11-19	1
52877	3134	81151	1924-08-09	1924-09-13	1
79108	4689	40481087	1971-05-11	1971-06-01	1
46063	2747	4112343	2008-05-01	2008-05-09	1
5270	311	4094814	1993-08-22	1993-09-21	1
42597	2542	4112343	1986-02-26	1986-03-07	1
89263	5315	372328	1916-09-16	1916-11-26	1
85446	5085	4155034	2003-05-21	2003-06-11	1
15412	915	4112343	2006-01-27	2006-02-09	1
72625	4320	4112343	2018-07-10	2018-07-19	1
43774	2610	40481087	1988-06-15	1988-07-06	1
27715	1636	4285898	1999-08-18	1999-08-19	1
26498	1571	40481087	2003-03-20	2003-04-03	1
46314	2761	378001	2004-06-12	2004-08-11	1
66619	3946	4112343	2001-08-02	2001-08-12	1
38156	2267	4112343	2012-12-09	2012-12-16	1
13759	814	4278672	1995-12-21	1996-03-20	1
11212	662	4112343	1979-03-05	1979-03-12	1
14025	829	28060	1983-05-19	1983-05-31	1
53768	3184	80180	2003-10-08	2003-10-09	1
78142	4631	4237458	1929-10-09	1929-12-08	1
48734	2891	4112343	1977-02-08	1977-02-18	1
38547	2291	372328	1964-01-26	1964-03-19	1
18131	1091	260139	1971-01-22	1971-01-29	1
48371	2867	80180	2014-12-24	2014-12-25	1
69623	4123	40481087	2018-08-10	2018-08-31	1
43827	2613	378001	1956-03-08	1956-05-07	1
44248	2633	4112343	1970-05-06	1970-05-16	1
22900	1367	257012	2006-06-11	2006-06-12	1
17475	1051	40481087	2017-09-10	2017-09-24	1
28500	1689	40481087	2001-05-05	2001-05-26	1
34435	2046	317576	2004-02-24	2004-02-25	1
36106	2141	40481087	1955-01-28	1955-02-11	1
72808	4330	40481087	1950-07-04	1950-07-11	1
45101	2685	260139	1982-12-14	1982-12-28	1
40371	2396	4112343	1973-06-13	1973-06-22	1
48755	2892	40481087	1985-04-21	1985-05-05	1
71306	4235	260139	2001-12-23	2001-12-30	1
47778	2841	40481087	1962-08-18	1962-09-01	1
52829	3132	0	1976-07-05	1976-07-06	1
3294	191	40481087	1923-07-11	1923-07-25	1
33921	2017	40481087	1974-04-11	1974-04-25	1
10111	600	4237458	1956-02-25	1956-03-26	1
71141	4223	372328	1962-11-01	1963-01-11	1
19573	1175	4112343	2011-01-01	2011-01-12	1
49057	2905	260139	2015-05-31	2015-06-14	1
16411	971	4112343	2008-03-03	2008-03-16	1
72403	4304	40481087	1968-07-08	1968-07-15	1
60364	3573	28060	1941-07-02	1941-07-15	1
41047	2442	40481087	1991-02-21	1991-03-14	1
46828	2788	40479768	2017-11-24	2018-01-30	1
52878	3134	257012	1998-11-13	1998-11-14	1
79109	4689	40481087	2004-04-28	2004-05-19	1
46064	2747	40481087	2009-05-08	2009-05-29	1
5271	311	4152936	1978-05-22	1978-06-12	1
42598	2542	4112343	2017-04-22	2017-05-01	1
89264	5315	4027663	1947-06-11	1947-06-12	1
85447	5085	40481087	1994-10-11	1994-10-25	1
15413	915	4112343	2009-10-22	2009-10-30	1
72626	4320	4116491	2016-03-17	2016-05-04	1
43775	2610	192671	1992-07-12	1992-07-13	1
27716	1636	28060	1966-12-07	1966-12-20	1
26499	1571	40481087	2017-08-08	2017-08-29	1
46315	2761	40481087	2007-08-14	2007-08-21	1
66620	3946	4266809	2003-02-25	2003-02-26	1
38157	2267	40481087	1968-11-04	1968-11-25	1
13760	814	4283893	2005-08-08	2005-09-26	1
11213	662	4266809	2001-05-29	2001-05-30	1
14026	829	28060	1987-04-23	1987-04-30	1
53769	3184	260139	2017-08-11	2017-08-18	1
78143	4631	4283893	2019-06-27	2019-06-28	1
48735	2891	4218389	2012-08-11	2012-09-01	1
38548	2291	4112343	2011-10-02	2011-10-12	1
18132	1091	4112343	1972-11-07	1972-11-16	1
48372	2867	4112343	1979-09-13	1979-09-26	1
69624	4123	80180	1999-01-07	1999-01-08	1
43828	2613	440448	2003-05-03	2003-05-04	1
44249	2633	4310024	1980-07-04	1980-07-05	1
22901	1367	372328	1981-08-25	1982-06-18	1
18806	1133	28060	1968-05-12	1968-05-24	1
28501	1689	80180	1984-05-06	1984-05-07	1
34436	2046	4112343	1992-11-26	1992-12-03	1
36107	2141	40481087	1992-07-18	1992-08-08	1
72809	4330	40481087	1985-04-25	1985-05-09	1
45102	2685	4112343	1967-06-19	1967-06-29	1
41626	2480	257012	1996-07-01	1996-07-02	1
48756	2892	40481087	1999-06-30	1999-07-21	1
71307	4235	260139	2011-05-13	2011-05-20	1
47779	2841	317576	1983-09-11	1983-09-12	1
52830	3132	192671	2007-05-01	2007-05-02	1
3295	191	40481087	1924-10-26	1924-11-02	1
33922	2017	40481087	1976-03-21	1976-04-11	1
10112	600	40479768	2018-07-16	2018-09-21	1
71142	4223	40481087	2003-11-20	2003-12-04	1
19574	1175	4296205	2018-11-11	2018-12-02	1
49058	2905	260139	2019-06-17	2019-07-01	1
16412	971	40481087	1993-01-20	1993-01-27	1
72404	4304	40481087	2013-11-08	2013-11-29	1
60365	3573	30753	1962-01-08	1962-01-09	1
42886	2556	260139	1982-07-01	1982-07-15	1
46829	2788	40481087	1993-03-13	1993-03-20	1
52879	3134	372328	1965-05-06	1965-09-09	1
79110	4689	28060	1968-07-07	1968-07-15	1
46065	2747	40481087	2012-07-20	2012-08-10	1
5272	311	28060	1991-03-31	1991-04-07	1
42599	2542	40481087	1975-03-29	1975-04-12	1
89265	5315	4112343	1952-06-20	1952-06-30	1
85448	5085	81893	2011-04-29	2011-04-30	1
15414	915	4112343	2012-03-30	2012-04-10	1
72627	4320	40481087	2013-06-04	2013-06-11	1
43776	2610	260139	2011-11-20	2011-12-04	1
27717	1636	81151	1967-05-13	1967-06-10	1
26500	1571	28060	2003-02-12	2003-02-22	1
46316	2761	28060	1985-07-24	1985-07-31	1
66621	3946	28060	1989-07-22	1989-08-04	1
38158	2267	40481087	1983-11-21	1983-12-05	1
13761	814	40481087	1982-06-08	1982-06-22	1
11214	662	4112343	1997-03-26	1997-04-03	1
14027	829	260139	1977-01-28	1977-02-04	1
53770	3184	372328	1963-03-22	1963-08-08	1
78144	4631	40481087	1948-09-11	1948-09-18	1
48736	2891	40481087	2007-11-16	2007-11-30	1
38549	2291	40481087	1967-05-31	1967-06-14	1
18133	1091	4112343	1990-12-10	1990-12-18	1
48373	2867	4112343	1989-06-19	1989-06-28	1
69625	4123	4112343	1967-02-26	1967-03-11	1
43829	2613	4112343	1984-06-04	1984-06-12	1
44250	2633	40481087	1954-10-18	1954-11-01	1
22902	1367	4152936	1978-03-28	1978-04-18	1
18807	1133	80180	2000-07-20	2000-07-21	1
28502	1689	81151	2019-03-28	2019-05-02	1
34437	2046	4113008	1995-01-18	1995-02-08	1
36108	2141	40481087	1995-10-30	1995-11-13	1
72810	4330	40481087	2004-04-14	2004-05-05	1
45103	2685	4112343	2013-09-19	2013-10-02	1
41627	2480	372328	1957-11-06	1958-04-09	1
48757	2892	40481087	2002-11-10	2002-11-17	1
71308	4235	4027663	2005-02-22	2005-02-23	1
47780	2841	4218389	1979-12-14	1980-01-11	1
52831	3132	440448	1976-07-05	1976-07-06	1
3296	191	40481087	1931-03-10	1931-03-17	1
33923	2017	40481087	2018-04-28	2018-05-12	1
10113	600	40481087	1986-03-23	1986-04-06	1
71468	4243	372328	1969-02-12	1969-03-28	1
19575	1175	40481087	1953-05-07	1953-05-28	1
50601	2997	78272	1994-01-29	1994-02-12	1
16413	971	40481087	1997-07-12	1997-08-02	1
72405	4304	28060	1996-05-24	1996-06-03	1
60366	3573	80502	2003-10-18	2003-10-19	1
42887	2556	4112343	1981-05-17	1981-05-24	1
46830	2788	40481087	2006-01-02	2006-01-16	1
52880	3134	4156265	1981-10-24	1981-11-14	1
79111	4689	260139	1998-10-01	1998-10-15	1
46066	2747	28060	1994-09-23	1994-10-04	1
5273	311	260139	2008-01-04	2008-01-18	1
42600	2542	80180	2003-03-07	2003-03-08	1
89266	5315	4112343	1962-08-05	1962-08-15	1
85449	5085	4112343	1986-12-01	1986-12-09	1
15415	915	4156265	2018-03-19	2018-04-02	1
72628	4320	40481087	2015-11-05	2015-11-12	1
43777	2610	40481087	1971-04-30	1971-05-14	1
27718	1636	260139	1963-08-03	1963-08-10	1
26501	1571	260139	1959-07-08	1959-07-22	1
46317	2761	260139	2011-07-06	2011-07-13	1
66622	3946	28060	2013-03-15	2013-03-25	1
38159	2267	81151	1980-02-28	1980-04-03	1
13762	814	40481087	1994-03-17	1994-03-24	1
11215	662	4296205	1971-04-27	1971-05-25	1
14028	829	4112343	1988-11-22	1988-11-30	1
53771	3184	4112343	2011-01-11	2011-01-20	1
78145	4631	40481087	1948-12-25	1949-01-15	1
48737	2891	260139	1974-10-20	1974-10-27	1
38550	2291	40481087	1978-09-19	1978-09-26	1
18134	1091	4310024	1995-11-25	1995-11-26	1
48374	2867	40481087	1990-10-19	1990-11-09	1
69626	4123	4112343	2015-03-23	2015-04-05	1
43830	2613	40481087	1963-11-03	1963-11-17	1
44251	2633	40481087	1963-12-12	1963-12-26	1
22903	1367	4296204	1980-03-08	1980-03-22	1
18808	1133	4112343	1966-05-09	1966-05-21	1
28503	1689	257012	1949-04-07	1949-04-08	1
34438	2046	40481087	1959-06-19	1959-07-03	1
36109	2141	28060	1949-09-07	1949-09-18	1
74154	4409	28060	1978-11-07	1978-11-16	1
45104	2685	4156265	1974-09-30	1974-10-14	1
41628	2480	4112343	1967-07-03	1967-07-13	1
48758	2892	28060	1979-05-12	1979-05-24	1
71309	4235	4112343	2012-06-23	2012-07-04	1
47781	2841	4296205	1950-04-22	1950-05-20	1
52832	3132	4112343	1983-09-20	1983-10-01	1
3297	191	40481087	1988-08-12	1988-08-26	1
33924	2017	80180	2007-10-08	2007-10-09	1
10114	600	0	1997-02-19	1997-02-20	1
71469	4243	372328	1972-06-15	1972-12-29	1
19576	1175	40481087	1989-07-23	1989-08-06	1
50602	2997	80180	2016-11-09	2016-11-10	1
16414	971	80180	1980-09-15	1980-09-16	1
72406	4304	380378	1978-01-26	1978-01-27	1
60367	3573	260139	1926-06-12	1926-06-26	1
42888	2556	192671	2004-08-16	2004-08-17	1
46831	2788	80180	2018-06-27	2018-06-28	1
52881	3134	40481087	1973-03-11	1973-04-01	1
79112	4689	372328	1969-04-29	1970-04-14	2
46067	2747	260139	1988-12-28	1989-01-11	1
5274	311	4112343	2005-10-23	2005-11-02	1
42601	2542	260139	1989-02-14	1989-02-21	1
89267	5315	4112343	1973-05-23	1973-06-04	1
85450	5085	40481087	2001-04-30	2001-05-14	1
15416	915	4283893	1965-09-24	1965-10-29	1
72629	4320	30753	2009-08-11	2009-08-12	1
43778	2610	40481087	1971-06-20	1971-07-11	1
27719	1636	372328	1963-04-10	1963-08-09	1
26502	1571	4112343	1968-12-05	1968-12-15	1
46318	2761	4112343	1997-05-12	1997-05-23	1
66623	3946	4155034	1964-01-01	1964-01-15	1
38160	2267	260139	1979-07-05	1979-07-12	1
13763	814	40481087	2017-02-03	2017-02-17	1
11216	662	40481087	1993-08-17	1993-08-24	1
14029	829	40481087	2005-11-18	2005-12-02	1
53772	3184	4112343	2015-12-26	2016-01-06	1
78146	4631	40481087	1992-05-10	1992-05-17	1
48738	2891	260139	2011-03-13	2011-03-27	1
38551	2291	40481087	2014-12-01	2014-12-08	1
18135	1091	40481087	1975-04-20	1975-05-04	1
50375	2985	81151	1989-01-26	1989-02-16	1
69627	4123	4156265	1976-12-24	1977-01-14	1
43831	2613	40481087	2018-06-25	2018-07-09	1
44252	2633	40481087	1991-12-13	1991-12-20	1
22904	1367	40481087	1992-01-07	1992-01-28	1
18809	1133	4142905	1973-10-25	1973-12-24	1
28504	1689	4112343	2000-11-28	2000-12-08	1
34439	2046	81151	1952-09-18	1952-10-09	1
36110	2141	80180	1978-06-20	1978-06-21	1
74155	4409	80180	2005-06-28	2005-06-29	1
45105	2685	4218389	1950-07-17	1950-08-07	1
41629	2480	4112343	1975-05-21	1975-06-03	1
48759	2892	80180	2007-06-08	2007-06-09	1
71310	4235	40481087	2002-07-31	2002-08-14	1
47782	2841	40481087	1950-05-28	1950-06-11	1
54657	3238	80180	2006-12-09	2006-12-10	1
3298	191	40481087	1992-09-13	1992-10-04	1
33925	2017	4296205	1972-09-11	1972-09-25	1
10115	600	80180	1987-08-21	1987-08-22	1
71470	4243	4109685	1987-02-08	1987-02-22	1
19577	1175	40481087	2004-03-26	2004-04-16	1
50603	2997	40481087	2016-09-23	2016-10-07	1
16415	971	260139	1961-09-12	1961-09-26	1
72407	4304	40481087	1994-07-23	1994-07-30	1
60368	3573	260139	1940-04-10	1940-04-24	1
42889	2556	40481087	1998-08-06	1998-08-27	1
46832	2788	440086	1991-03-16	1991-04-20	1
52882	3134	40481087	1974-08-01	1974-08-22	1
79113	4689	4035415	2017-02-09	2017-04-11	1
46068	2747	4112343	2007-01-24	2007-02-05	1
5275	311	4112343	2016-07-22	2016-08-02	1
42602	2542	4294548	2006-07-24	2006-08-14	1
89268	5315	28060	1944-04-19	1944-05-02	1
85451	5085	40481087	2017-04-10	2017-05-01	1
15417	915	40481087	1964-08-10	1964-08-24	1
72630	4320	80180	2010-02-07	2010-02-08	1
43779	2610	40481087	1996-10-13	1996-11-02	1
27720	1636	4027663	1990-02-01	1990-02-02	1
26503	1571	4112343	1973-08-22	1973-09-02	1
46319	2761	260139	1982-09-08	1982-09-15	1
66624	3946	4285898	2002-11-27	2002-11-28	1
38161	2267	40481087	2008-10-14	2008-11-04	1
14451	856	78272	1984-12-28	1985-01-25	1
12427	736	440086	1985-01-02	1986-11-05	1
14030	829	81893	2008-08-07	2008-08-08	1
53773	3184	40481087	1966-02-12	1966-02-26	1
78147	4631	40481087	1992-10-23	1992-11-13	1
48739	2891	4283893	1979-11-27	1980-02-26	1
38552	2291	0	1966-10-14	1966-10-15	1
18136	1091	40481087	2016-09-15	2016-09-29	1
50376	2985	81151	1993-01-26	1993-02-09	1
69628	4123	4310024	1997-08-15	1997-08-16	1
43832	2613	28060	1960-09-17	1960-09-24	1
44253	2633	40481087	1996-01-05	1996-01-19	1
22905	1367	40481087	1994-07-21	1994-08-04	1
18810	1133	4310024	1998-08-30	1998-08-31	1
28505	1689	4113008	1992-02-04	1992-02-18	1
34440	2046	260139	1951-02-15	1951-02-22	1
36111	2141	81151	1955-03-23	1955-04-06	1
74156	4409	81151	1983-07-15	1983-08-19	1
45456	2705	81151	1966-09-20	1966-10-25	1
41630	2480	4218389	2010-08-29	2010-09-19	1
48760	2892	260139	1978-06-10	1978-06-17	1
71311	4235	40481087	2005-02-04	2005-02-18	1
47783	2841	40481087	1952-12-05	1952-12-26	1
54658	3238	261325	2017-03-06	2017-03-07	1
3299	191	80180	1960-04-07	1960-04-08	1
33926	2017	40481087	1989-04-08	1989-04-29	1
10116	600	260139	1978-03-30	1978-04-13	1
71471	4243	4112343	1970-09-07	1970-09-16	1
20780	1249	28060	1979-01-17	1979-01-25	1
50604	2997	4112343	2015-12-08	2015-12-20	1
16416	971	372328	1946-06-18	1946-10-18	1
72408	4304	40481087	2011-11-20	2011-12-11	1
60369	3573	260139	2010-06-13	2010-06-20	1
42890	2556	40481087	2006-04-24	2006-05-15	1
46833	2788	4112343	1979-01-14	1979-01-24	1
52883	3134	40481087	1978-04-11	1978-05-02	1
79114	4689	4109685	2005-12-27	2006-01-17	1
46069	2747	4112343	2012-08-20	2012-08-31	1
5276	311	40481087	1986-01-17	1986-02-07	1
42603	2542	40481087	1966-06-23	1966-06-30	1
89269	5315	30753	1955-09-02	1955-09-03	1
88107	5245	81151	2001-09-18	2001-10-16	1
15418	915	40481087	1987-01-13	1987-01-20	1
72631	4320	192671	2010-03-23	2010-03-24	1
43780	2610	40481087	2005-02-26	2005-03-19	1
27721	1636	4112343	1987-03-20	1987-03-30	1
26504	1571	4283893	2001-11-27	2001-12-18	1
46320	2761	40481087	1983-02-09	1983-02-16	1
66625	3946	40481087	1986-09-25	1986-10-02	1
38162	2267	4112343	2000-08-30	2000-09-11	1
14452	856	80180	2006-02-24	2006-02-25	1
12428	736	4112343	1974-06-25	1974-07-03	1
14031	829	378001	1992-12-09	1993-01-08	1
53774	3184	40481087	2006-05-15	2006-05-22	1
79353	4705	80180	2009-03-23	2009-03-24	1
48740	2891	80180	2014-05-01	2014-05-02	1
38553	2291	4112343	1966-01-18	1966-01-30	1
18137	1091	28060	2007-11-20	2007-12-01	1
50377	2985	260139	2017-10-12	2017-10-26	1
69629	4123	40481087	1970-06-17	1970-06-24	1
43833	2613	260139	1965-08-05	1965-08-12	1
44254	2633	30753	1980-12-01	1980-12-02	1
24542	1467	260139	1998-04-16	1998-04-30	1
18811	1133	40481087	1976-05-19	1976-06-09	1
28506	1689	4278672	1952-07-28	1952-09-26	1
34441	2046	260139	1961-04-01	1961-04-08	1
36112	2141	81151	2006-02-14	2006-03-07	1
74157	4409	4283893	1981-01-19	1981-04-20	1
45457	2705	81151	2012-03-27	2012-04-24	1
41631	2480	4283893	1996-06-10	1996-07-22	1
48761	2892	260139	1997-07-18	1997-08-01	1
71312	4235	4112343	1979-11-30	1979-12-11	1
47784	2841	0	1984-10-21	1984-10-22	1
54659	3238	4112343	1985-06-06	1985-06-16	1
3300	191	257012	1923-02-08	1923-02-09	1
33927	2017	372328	1974-05-04	1975-03-11	1
10117	600	378001	1962-07-23	1962-08-22	1
71472	4243	4112343	1992-10-24	1992-10-31	1
20781	1249	4237458	2002-08-24	2002-09-23	1
50605	2997	40481087	2007-03-28	2007-04-11	1
16417	971	378001	2005-07-24	2005-08-23	1
73195	4355	30753	2017-12-30	2017-12-31	1
60370	3573	4112343	1938-06-24	1938-07-02	1
42891	2556	260139	1970-06-13	1970-06-27	1
46834	2788	40481087	1986-12-07	1986-12-21	1
52884	3134	40481087	2001-08-18	2001-09-01	1
79115	4689	4152936	1972-01-13	1972-02-03	1
46070	2747	40481087	2001-12-31	2002-01-07	1
5277	311	40481087	2016-10-23	2016-10-30	1
42604	2542	40481087	1990-08-28	1990-09-11	1
89270	5315	257012	1932-08-14	1932-08-15	1
88108	5245	260139	1990-12-02	1990-12-16	1
15419	915	40481087	2004-02-24	2004-03-16	1
72632	4320	198809	1970-05-14	1970-05-14	1
43781	2610	40481087	2017-10-21	2017-11-04	1
27722	1636	4134304	2002-04-07	2002-05-07	1
26505	1571	40481087	1971-07-09	1971-07-30	1
46321	2761	40481087	1989-04-20	1989-04-27	1
66626	3946	81151	1972-06-01	1972-06-15	1
38163	2267	4296204	1990-09-08	1990-10-13	1
14453	856	372328	1989-01-03	1991-08-16	1
12429	736	4112343	1979-05-24	1979-05-31	1
14032	829	4112343	1983-04-09	1983-04-16	1
53775	3184	372328	1966-05-24	1967-02-16	1
79354	4705	260139	1973-03-14	1973-03-28	1
48741	2891	257012	1979-12-25	1979-12-26	1
38554	2291	4116491	2010-10-01	2010-11-02	1
18138	1091	81893	1996-03-24	1996-03-25	1
50378	2985	372328	1964-12-12	1964-12-26	1
69630	4123	40481087	1976-05-28	1976-06-04	1
43834	2613	372328	1960-04-16	1960-09-23	1
44255	2633	372328	1950-03-16	1950-09-21	1
24543	1467	372328	1935-06-14	1935-09-01	1
18812	1133	40481087	1994-07-23	1994-08-06	1
28507	1689	4296204	1986-02-14	1986-03-07	1
34442	2046	260139	2001-01-31	2001-02-07	1
36113	2141	134438	1970-07-09	1971-07-09	1
74158	4409	40481087	2017-02-07	2017-02-28	1
45458	2705	40481087	1963-07-19	1963-08-02	1
41632	2480	40481087	1968-10-12	1968-11-02	1
48762	2892	4113008	2014-03-03	2014-03-17	1
71313	4235	4149245	2007-03-09	2007-04-15	1
47785	2841	40481087	1954-01-26	1954-02-09	1
54660	3238	40481087	1979-12-15	1979-12-29	1
3301	191	260139	1946-04-17	1946-05-01	1
33928	2017	4112343	2011-04-15	2011-04-27	1
10118	600	440086	1968-01-03	1972-01-12	1
71473	4243	4112343	1998-09-01	1998-09-10	1
20782	1249	28060	2004-04-29	2004-05-06	1
50606	2997	4149245	2004-12-16	2005-01-22	1
16418	971	4112343	1947-04-01	1947-04-13	1
73196	4355	372328	1983-12-16	1984-03-24	1
60371	3573	4112343	1958-10-01	1958-10-10	1
42892	2556	260139	1975-09-07	1975-09-21	1
46835	2788	40481087	1990-12-05	1990-12-19	1
52885	3134	40481087	2002-07-05	2002-07-26	1
79116	4689	4156265	1994-08-07	1994-08-28	1
46357	2765	0	1994-05-08	1994-05-09	1
5278	311	78272	2014-02-17	2014-03-03	1
42605	2542	28060	2006-12-30	2007-01-11	1
89271	5315	260139	1957-09-09	1957-09-23	1
88109	5245	4112343	2011-02-16	2011-02-28	1
15420	915	40481087	2005-09-15	2005-10-06	1
72633	4320	4027663	2000-03-21	2000-03-22	1
43782	2610	28060	1983-09-13	1983-09-20	1
27723	1636	4278672	2016-04-23	2016-06-22	1
29394	1743	81151	1967-11-20	1967-12-11	1
46322	2761	40481087	1990-03-31	1990-04-07	1
66627	3946	260139	1970-04-01	1970-04-15	1
38164	2267	40481087	1977-11-06	1977-11-27	1
14454	856	4112343	1982-04-24	1982-05-05	1
12430	736	4310024	2007-09-24	2007-09-25	1
14033	829	4112343	1998-02-14	1998-02-24	1
53776	3184	4109685	1997-06-19	1997-07-10	1
79355	4705	260139	1979-05-22	1979-05-29	1
48742	2891	4109685	1982-08-07	1982-08-28	1
38555	2291	40481087	2017-03-03	2017-03-24	1
18139	1091	260139	1973-12-25	1974-01-08	1
50379	2985	372328	1968-07-19	1968-09-28	1
70805	4205	28060	1978-03-11	1978-03-18	1
43835	2613	4112343	1982-05-03	1982-05-12	1
44256	2633	4112343	1999-10-27	1999-11-08	1
24544	1467	439777	2006-03-08	2006-03-09	1
18813	1133	40481087	2002-08-26	2002-09-09	1
28508	1689	260139	1982-03-23	1982-03-30	1
34443	2046	372328	2003-08-13	2004-02-24	1
36114	2141	372328	1950-11-14	1951-06-18	1
74159	4409	0	1999-10-28	1999-10-29	1
45459	2705	40481087	1975-07-06	1975-07-20	1
41633	2480	80809	1988-10-24	1988-10-25	1
48763	2892	28060	1981-05-24	1981-06-02	1
71314	4235	4296205	1987-10-15	1987-11-19	1
47786	2841	40481087	1988-01-27	1988-02-10	1
54661	3238	4112343	1981-09-14	1981-09-22	1
3302	191	260139	2002-03-09	2002-03-16	1
33929	2017	40481087	1982-10-15	1982-11-05	1
10119	600	4112343	2006-01-31	2006-02-07	1
71474	4243	4294548	2002-08-02	2002-09-20	1
20783	1249	260139	1973-05-29	1973-06-05	1
50607	2997	40481087	2008-04-11	2008-05-02	1
16419	971	4152936	1985-12-01	1985-12-15	1
73197	4355	40481087	1991-03-04	1991-03-18	1
60372	3573	4112343	1989-12-28	1990-01-05	1
42893	2556	260139	1978-05-14	1978-05-21	1
46836	2788	40481087	2005-10-18	2005-10-25	1
52886	3134	40481087	2005-02-07	2005-02-28	1
79117	4689	4218389	2014-03-06	2014-03-28	1
46358	2765	260139	1949-06-04	1949-06-18	1
5279	311	4112343	1980-09-10	1980-09-23	1
42606	2542	260139	1994-10-11	1994-10-18	1
89272	5315	260139	1977-03-02	1977-03-16	1
88110	5245	40481087	2007-06-24	2007-07-08	1
15421	915	4112343	1960-05-27	1960-06-08	1
72634	4320	40481087	1986-01-28	1986-02-04	1
43783	2610	30753	1991-04-24	1991-04-25	1
27724	1636	40481087	1995-08-19	1995-08-26	1
29395	1743	440448	2011-01-25	2011-01-26	1
46323	2761	28060	1992-12-23	1992-12-31	1
66628	3946	378001	1986-11-29	1986-12-29	1
38165	2267	40481087	2007-06-13	2007-06-27	1
14455	856	4112343	2005-04-06	2005-04-15	1
12431	736	40481087	1983-12-02	1983-12-23	1
14034	829	4112343	2016-09-04	2016-09-14	1
53777	3184	4166224	2000-02-23	2000-02-24	1
79356	4705	260139	1984-11-28	1984-12-05	1
48743	2891	78272	2017-02-07	2017-02-28	1
38556	2291	40486433	1963-10-20	1963-10-21	1
18140	1091	260139	1985-04-18	1985-04-25	1
50380	2985	4112343	1996-07-08	1996-07-16	1
70806	4205	4112343	1982-09-25	1982-10-03	1
43836	2613	4112343	2007-06-27	2007-07-09	1
44257	2633	4112343	2002-09-27	2002-10-07	1
24545	1467	440086	1942-03-24	1943-06-01	1
18814	1133	81893	1999-06-26	1999-06-27	1
28509	1689	260139	1986-06-08	1986-06-22	1
34444	2046	372328	2005-06-18	2006-03-07	1
36115	2141	4112343	1961-05-18	1961-05-27	1
74160	4409	4112343	1975-08-08	1975-08-21	1
45460	2705	40481087	2007-07-01	2007-07-15	1
41634	2480	260139	1996-10-28	1996-11-11	1
48764	2892	81151	2002-09-11	2002-10-02	1
71315	4235	40481087	1990-01-22	1990-01-29	1
49438	2927	80180	1982-07-03	1982-07-04	1
54662	3238	40481087	1986-08-31	1986-09-14	1
3303	191	261325	1989-09-19	1989-09-20	1
33930	2017	40481087	1994-02-08	1994-03-01	1
10120	600	4152936	1984-09-09	1984-09-30	1
71475	4243	40481087	1979-05-22	1979-05-29	1
20784	1249	260139	2017-07-03	2017-07-17	1
50608	2997	195588	2001-09-29	2001-11-18	1
16420	971	260139	1979-07-02	1979-07-09	1
73198	4355	40481087	1996-08-23	1996-09-06	1
60373	3573	4278672	1957-07-12	1957-09-10	1
42894	2556	4112343	2012-01-16	2012-01-25	1
48434	2871	28060	1955-09-19	1955-10-01	1
52887	3134	40481087	2015-04-14	2015-04-28	1
79118	4689	40481087	1989-07-05	1989-07-26	1
46359	2765	260139	1978-07-18	1978-08-01	1
5280	311	40481087	2007-12-22	2008-01-05	1
42607	2542	260139	2001-06-15	2001-06-22	1
89273	5315	372328	1917-10-22	1917-11-25	1
88111	5245	257012	1985-07-19	1985-07-20	1
15422	915	4112343	1989-01-02	1989-01-10	1
72635	4320	40481087	1994-12-27	1995-01-03	1
43784	2610	80180	1992-06-17	1992-06-18	1
28257	1672	78272	1962-08-01	1962-09-05	1
29396	1743	4059173	1999-09-08	1999-10-08	1
46324	2761	260139	2006-11-20	2006-11-27	1
66629	3946	4112343	1963-10-07	1963-10-20	1
41182	2450	192671	1986-06-04	1986-06-05	1
14456	856	4146173	1979-05-29	1979-06-28	1
12432	736	40481087	2003-04-29	2003-05-20	1
14035	829	40481087	1988-08-03	1988-08-10	1
53778	3184	40481087	2004-04-28	2004-05-19	1
79357	4705	4112343	1995-10-03	1995-10-13	1
48744	2891	81151	1993-10-29	1993-11-19	1
38557	2291	28060	2016-02-21	2016-03-01	1
18141	1091	260139	1989-02-04	1989-02-18	1
50381	2985	4156265	1979-08-26	1979-09-16	1
70807	4205	4112343	1988-08-17	1988-08-25	1
43837	2613	80809	2016-04-27	2016-04-28	1
44258	2633	40481087	1956-05-30	1956-06-20	1
24546	1467	4048695	2011-07-17	2011-08-18	1
18815	1133	195588	2012-06-27	2012-08-13	1
28510	1689	260139	2000-09-20	2000-10-04	1
34445	2046	4112343	2006-03-27	2006-04-06	1
36116	2141	40481087	1966-07-06	1966-07-13	1
74161	4409	4112343	1982-09-28	1982-10-09	1
45461	2705	40481087	2006-09-11	2006-09-25	1
41635	2480	260139	2010-09-09	2010-09-23	1
48765	2892	4112343	1975-08-16	1975-08-27	1
71316	4235	40481087	2016-10-23	2016-10-30	1
49439	2927	81151	1954-05-21	1954-06-04	1
54663	3238	28060	2009-01-13	2009-01-24	1
3304	191	378001	1926-01-31	1926-04-01	1
33931	2017	40481087	2015-11-14	2015-12-05	1
10121	600	4230399	2002-01-20	2002-04-20	1
71476	4243	40481087	2017-08-09	2017-08-30	1
20785	1249	4001336	2014-01-23	2014-03-24	1
50609	2997	260139	1993-12-01	1993-12-15	1
16421	971	372328	1946-01-02	1946-04-19	1
73199	4355	40481087	1999-05-29	1999-06-12	1
60374	3573	40481087	1934-03-08	1934-03-15	1
42895	2556	4155034	1991-05-28	1991-06-11	1
48435	2871	4237458	1960-11-18	1961-01-17	1
52888	3134	28060	1945-09-20	1945-09-30	1
79119	4689	40481087	2015-07-23	2015-08-13	1
46360	2765	260139	1994-08-17	1994-08-31	1
5281	311	40481087	2008-08-09	2008-08-23	1
42608	2542	260139	2018-12-30	2019-01-06	1
89274	5315	4329847	1979-04-15	1979-04-16	1
88112	5245	4113008	2004-06-02	2004-06-23	1
15423	915	4134304	1961-01-19	1961-03-20	1
72636	4320	260139	2004-02-01	2004-02-08	1
43785	2610	4027663	1983-06-30	1983-07-01	1
28258	1672	81893	1987-09-18	1987-09-19	1
29397	1743	4278672	1965-12-30	1966-01-29	1
46325	2761	372328	1984-09-25	1985-04-29	1
66630	3946	4156265	2007-07-12	2007-08-02	1
41183	2450	260139	1966-11-13	1966-11-27	1
14457	856	40479422	1971-11-30	1972-01-06	1
12433	736	40481087	2009-08-09	2009-08-30	1
14266	843	28060	1996-02-15	1996-02-28	1
53779	3184	260139	1989-07-27	1989-08-10	1
79358	4705	40481087	1990-03-17	1990-04-07	1
48745	2891	260139	1996-05-05	1996-05-12	1
38558	2291	80180	1997-05-22	1997-05-23	1
18142	1091	4112343	1976-07-29	1976-08-10	1
50382	2985	4218389	2008-12-17	2009-01-21	1
70808	4205	4294548	2010-07-18	2010-08-29	1
43838	2613	260139	1967-06-15	1967-06-22	1
44259	2633	40481087	1970-10-14	1970-11-04	1
24547	1467	4112343	1962-07-12	1962-07-23	1
18816	1133	40481087	1998-10-02	1998-10-09	1
28511	1689	4112343	1967-01-02	1967-01-11	1
34446	2046	4283893	1982-03-21	1982-04-25	1
36117	2141	40481087	1970-09-27	1970-10-18	1
74162	4409	4283893	1993-03-19	1993-05-21	1
45462	2705	80180	1978-03-13	1978-03-14	1
41636	2480	372328	1957-01-25	1957-04-10	1
48766	2892	40481087	2006-12-01	2006-12-22	1
71317	4235	260139	1995-06-06	1995-06-20	1
49440	2927	81151	1957-02-18	1957-03-25	1
54664	3238	81151	2006-03-11	2006-04-01	1
3305	191	4112343	1923-05-19	1923-05-30	1
33932	2017	28060	1971-02-20	1971-02-27	1
10122	600	4294548	1978-04-15	1978-05-27	1
71477	4243	4283893	2015-05-24	2015-12-13	1
20786	1249	4112343	2018-11-23	2018-12-03	1
50836	3011	4155034	2003-03-14	2003-04-04	1
16422	971	4109685	1994-03-03	1994-03-24	1
73200	4355	40481087	2001-05-08	2001-05-22	1
60375	3573	40481087	1937-07-04	1937-07-18	1
42896	2556	4218389	1981-09-12	1981-10-17	1
48436	2871	40481087	1956-02-07	1956-02-14	1
52889	3134	260139	1974-03-22	1974-04-05	1
79120	4689	28060	1981-01-08	1981-01-21	1
46361	2765	261325	2005-10-25	2005-10-26	1
5282	311	40481087	2010-02-22	2010-03-08	1
42609	2542	4059173	1974-12-29	1975-03-29	1
89275	5315	40481087	1922-06-26	1922-07-10	1
88113	5245	4294548	1985-05-31	1985-08-09	1
15424	915	40481087	1987-07-27	1987-08-17	1
72637	4320	260139	2019-02-26	2019-03-05	1
43786	2610	4035415	1969-05-18	1969-07-17	1
28259	1672	372328	1955-08-17	1956-04-04	2
29398	1743	260139	2012-06-21	2012-07-05	1
47787	2842	260139	1982-06-19	1982-07-03	1
66631	3946	40481087	1973-04-22	1973-04-29	1
41184	2450	260139	2005-07-01	2005-07-15	1
14458	856	40481087	1972-11-13	1972-12-04	1
12434	736	81893	2008-03-22	2008-03-23	1
14267	843	260139	1983-07-26	1983-08-02	1
53780	3184	260139	2004-12-02	2004-12-16	1
79359	4705	40481087	2007-11-07	2007-11-14	1
48746	2891	260139	2000-09-21	2000-10-05	1
38559	2291	440448	1966-10-14	1966-10-15	1
18143	1091	4112343	2009-06-27	2009-07-04	1
50383	2985	40481087	1983-08-18	1983-08-25	1
70809	4205	78272	2004-07-18	2004-08-22	1
43839	2613	4283893	1978-10-06	1978-11-03	1
44260	2633	40481087	2014-11-13	2014-11-20	1
24548	1467	4112343	1963-09-18	1963-09-30	1
18817	1133	192671	2000-09-05	2000-09-06	1
28512	1689	4112343	1984-02-12	1984-02-24	1
34447	2046	40481087	1948-04-21	1948-05-12	1
40397	2402	260139	1998-02-16	1998-02-23	1
74163	4409	4283893	2008-09-18	2008-12-18	1
45463	2705	260139	1969-07-09	1969-07-16	1
41637	2480	372328	1961-03-24	1961-10-18	1
48767	2892	81151	1974-09-19	1974-10-17	1
71318	4235	378001	2016-12-14	2017-02-12	1
49441	2927	260139	1962-07-20	1962-07-27	1
54665	3238	4149245	1997-05-20	1997-07-26	1
3306	191	4134304	1939-03-31	1939-04-30	1
33933	2017	81151	1983-05-01	1983-06-05	1
10123	600	40481087	1977-04-11	1977-05-02	1
71478	4243	257012	2015-06-28	2015-06-29	1
20787	1249	80180	2009-10-06	2009-10-07	1
50837	3011	40481087	1995-09-21	1995-10-05	1
16423	971	4112343	1966-11-29	1966-12-08	1
73201	4355	40481087	2009-01-18	2009-01-25	1
60376	3573	40481087	1940-10-21	1940-11-11	1
42897	2556	4296205	2007-12-14	2008-01-18	1
48437	2871	40481087	1963-12-26	1964-01-02	1
52890	3134	381316	2015-04-16	2015-04-17	1
79121	4689	30753	2006-03-20	2006-03-21	1
46362	2765	378419	2016-12-27	2016-12-28	1
5283	311	40481087	2010-09-13	2010-09-20	1
42610	2542	4112343	1965-12-18	1965-12-25	1
89276	5315	40481087	1942-03-13	1942-03-27	1
88114	5245	80180	2015-12-10	2015-12-11	1
15425	915	40481087	1999-12-20	2000-01-10	1
72638	4320	4112343	1989-08-28	1989-09-07	1
43787	2610	4134304	1964-04-13	1964-05-14	1
28260	1672	4112343	1974-06-11	1974-06-20	1
29399	1743	4112343	1997-11-13	1997-11-20	1
47788	2842	4112343	1970-06-25	1970-07-02	1
66632	3946	40481087	1992-06-28	1992-07-12	1
41185	2450	4112343	1988-03-04	1988-03-16	1
14459	856	40481087	2002-07-23	2002-07-30	1
12435	736	257012	2008-06-03	2008-06-10	1
14268	843	4112343	2016-04-17	2016-04-30	1
53781	3184	372328	1995-11-16	1998-08-13	1
79360	4705	40481087	2013-10-27	2013-11-10	1
48747	2891	378001	1976-12-06	1977-02-04	1
38560	2291	4051466	1964-10-19	1980-10-09	1
18144	1091	4113008	1998-07-27	1998-08-10	1
50384	2985	40481087	2000-11-09	2000-11-16	1
70810	4205	80180	2011-01-13	2011-01-14	1
43840	2613	40481087	1979-10-05	1979-10-12	1
44261	2633	372328	1948-05-13	1948-06-24	1
24549	1467	4112343	2006-03-15	2006-03-27	1
18818	1133	260139	2005-10-16	2005-10-30	1
28513	1689	4112343	2007-02-06	2007-02-19	1
34448	2046	40481087	1973-06-13	1973-06-27	1
40398	2402	372328	1978-03-20	1978-08-21	1
74164	4409	40481087	2013-08-31	2013-09-21	1
45464	2705	260139	2011-11-24	2011-12-08	1
41638	2480	40481087	1980-09-02	1980-09-09	1
48768	2892	372328	1974-11-03	1975-03-07	1
71319	4235	4266809	2014-02-05	2014-02-06	1
49442	2927	372328	1942-10-21	1943-01-01	1
54666	3238	40481087	1974-05-26	1974-06-09	1
3307	191	4218389	1987-08-07	1987-09-11	1
33934	2017	260139	1980-07-03	1980-07-17	1
10124	600	40481087	1977-08-06	1977-08-13	1
71479	4243	260139	2015-05-11	2015-05-18	1
20788	1249	81151	2018-03-03	2018-04-07	1
50838	3011	40481087	2017-12-16	2018-01-06	1
16424	971	4112343	1991-04-18	1991-05-01	1
73202	4355	260139	1994-03-13	1994-03-20	1
60377	3573	40481087	1957-09-05	1957-09-19	1
42898	2556	80180	2004-06-03	2004-06-04	1
48438	2871	40481087	1976-06-23	1976-06-30	1
52891	3134	4112343	2002-01-20	2002-02-02	1
79122	4689	260139	1981-07-27	1981-08-03	1
46363	2765	381316	2005-01-11	2005-01-12	1
5284	311	81151	2016-09-18	2016-10-23	1
42611	2542	4113008	1998-11-23	1998-12-07	1
89277	5315	40481087	1970-08-02	1970-08-16	1
88115	5245	192671	2016-01-31	2016-02-01	1
15426	915	28060	2010-06-28	2010-07-06	1
72639	4320	4266809	2010-02-07	2010-02-08	1
43788	2610	81893	1990-12-24	1990-12-25	1
28261	1672	4112343	2011-07-18	2011-07-26	1
29400	1743	40481087	1985-05-25	1985-06-15	1
47789	2842	4237458	1964-08-24	1964-11-22	1
66633	3946	4112343	1980-06-19	1980-06-26	1
41186	2450	4112343	2016-10-29	2016-11-11	1
14460	856	372328	1971-10-16	1971-11-19	1
12436	736	260139	1982-10-06	1982-10-20	1
14269	843	28060	1984-02-24	1984-03-05	1
53782	3184	372328	2004-01-14	2004-02-05	1
79361	4705	260139	1983-01-09	1983-01-23	1
48748	2891	4112343	2019-05-11	2019-05-19	1
38561	2291	4112343	1992-12-11	1992-12-21	1
18145	1091	4266809	1997-12-14	1997-12-15	1
50385	2985	40481087	2019-05-01	2019-05-08	1
70811	4205	4112343	1984-12-24	1985-01-02	1
43841	2613	40481087	1983-11-29	1983-12-13	1
44262	2633	4112343	1957-08-28	1957-09-09	1
24550	1467	40481087	1962-07-09	1962-07-16	1
18819	1133	4027663	1991-07-03	1991-07-04	1
28514	1689	4283893	1949-03-10	1949-08-18	1
34449	2046	40481087	1996-04-19	1996-05-03	1
40399	2402	4048171	1978-09-20	1978-09-21	1
74165	4409	28060	1968-11-13	1968-11-23	1
45465	2705	372328	1998-03-08	1998-10-03	1
41639	2480	80180	1991-06-16	1991-06-17	1
48769	2892	4112343	1980-05-20	1980-05-28	1
71320	4235	4218389	2012-11-14	2012-12-05	1
49443	2927	378001	1995-04-05	1995-06-04	1
54667	3238	260139	1974-06-21	1974-06-28	1
3308	191	40481087	1941-12-28	1942-01-04	1
33935	2017	260139	1985-04-26	1985-05-03	1
10125	600	40481087	2018-04-09	2018-04-23	1
71480	4243	372328	1969-12-23	1970-06-26	1
20789	1249	260139	2000-06-24	2000-07-01	1
50839	3011	28060	2003-04-02	2003-04-09	1
16425	971	40481087	1964-11-01	1964-11-22	1
73203	4355	4112343	2002-02-28	2002-03-13	1
60378	3573	40481087	1959-11-14	1959-12-05	1
42899	2556	40481087	1978-09-04	1978-09-11	1
48439	2871	40481087	1990-09-22	1990-10-13	1
52892	3134	4283893	2016-11-24	2016-12-15	1
79123	4689	440086	1981-05-06	1981-07-01	1
46364	2765	4112343	1963-11-28	1963-12-05	1
5285	311	260139	1986-09-09	1986-09-16	1
42612	2542	4134304	1980-03-02	1980-04-01	1
89278	5315	81893	1955-02-04	1955-02-05	1
88116	5245	4112343	2006-04-29	2006-05-12	1
15427	915	378001	1988-07-26	1988-09-24	1
72640	4320	4294548	1984-02-19	1984-04-01	1
43789	2610	372328	1960-06-20	1960-12-09	1
28262	1672	4113008	2007-09-19	2007-10-10	1
29401	1743	40481087	1986-08-16	1986-08-23	1
47790	2842	40481087	1967-05-13	1967-05-27	1
66634	3946	4112343	1988-11-13	1988-11-20	1
41187	2450	4146173	1957-09-29	1957-10-29	1
14461	856	372328	1982-01-25	1982-07-09	1
12437	736	4112343	1986-01-26	1986-02-04	1
14270	843	372328	1984-11-03	1985-04-06	1
53783	3184	440448	2000-02-23	2000-02-24	1
79362	4705	260139	1997-07-14	1997-07-28	1
48749	2891	4116491	1995-11-17	1996-01-09	1
38562	2291	4112343	1995-06-13	1995-06-25	1
18146	1091	40481087	1956-07-12	1956-07-26	1
50386	2985	80180	2001-12-23	2001-12-24	1
70812	4205	40481087	2008-06-15	2008-06-22	1
43842	2613	40481087	1989-04-07	1989-04-28	1
44263	2633	4112343	1991-08-27	1991-09-07	1
24551	1467	40481087	1978-04-16	1978-05-07	1
18820	1133	4230399	2011-03-10	2011-05-09	1
28515	1689	40481087	1973-02-19	1973-03-12	1
34450	2046	28060	1991-04-27	1991-05-05	1
40400	2402	4218389	1983-03-11	1983-04-08	1
74166	4409	28060	1969-06-24	1969-07-06	1
45466	2705	378001	1971-09-29	1971-11-28	1
41640	2480	378001	1980-01-09	1980-02-08	1
48770	2892	4112343	2015-04-09	2015-04-21	1
71321	4235	40481087	1979-06-07	1979-06-14	1
49444	2927	4152936	2013-10-27	2013-11-10	1
54668	3238	260139	1986-02-27	1986-03-13	1
3309	191	260139	1967-06-30	1967-07-07	1
33936	2017	4112343	2009-10-09	2009-10-19	1
13331	785	372328	1968-10-12	1968-11-17	1
71481	4243	4112343	1999-11-07	1999-11-19	1
20790	1249	439777	1988-01-20	1988-01-21	1
50840	3011	80180	2009-02-15	2009-02-16	1
16426	971	40481087	1970-11-28	1970-12-12	1
73204	4355	4112343	2007-04-20	2007-04-30	1
60379	3573	40481087	1963-09-24	1963-10-15	1
43683	2604	260139	1966-02-18	1966-03-04	1
48440	2871	372328	1951-06-09	1951-08-20	1
52893	3134	40481087	1924-06-17	1924-07-08	1
79124	4689	4116491	2012-04-28	2012-06-02	1
46365	2765	4112343	1981-12-13	1981-12-20	1
5286	311	260139	1993-11-10	1993-11-17	1
42613	2542	40481087	1970-05-12	1970-05-19	1
89279	5315	317576	1967-12-10	1967-12-11	1
88117	5245	40481087	1984-09-10	1984-09-24	1
15428	915	4112343	1977-01-11	1977-01-21	1
72641	4320	40481087	2019-02-02	2019-02-23	1
43790	2610	4112343	1964-05-01	1964-05-12	1
28263	1672	4116491	1979-04-23	1979-06-06	1
29402	1743	0	2011-01-25	2011-01-26	1
47791	2842	40481087	2000-10-06	2000-10-20	1
66635	3946	40481087	1988-09-28	1988-10-12	1
41188	2450	4218389	2014-03-09	2014-04-06	1
14462	856	4230399	2015-05-18	2015-07-17	1
12438	736	4285898	2009-08-14	2009-08-15	1
14271	843	4112343	1986-12-23	1986-12-30	1
53784	3184	4146173	2008-10-10	2008-11-09	1
79363	4705	372328	1976-08-23	1977-03-24	1
48750	2891	40481087	1992-05-29	1992-06-19	1
38563	2291	4134304	1977-12-20	1978-02-18	1
18147	1091	40481087	1972-03-13	1972-03-27	1
50387	2985	260139	1994-12-03	1994-12-17	1
70813	4205	260139	2003-04-26	2003-05-10	1
43843	2613	40481087	2016-05-13	2016-05-27	1
44264	2633	4278672	2018-02-19	2018-05-20	1
24552	1467	40481087	1997-04-21	1997-04-28	1
18821	1133	4266809	2000-07-20	2000-07-21	1
28516	1689	40481087	2008-02-12	2008-02-26	1
34451	2046	78272	1966-03-30	1966-04-13	1
40401	2402	40481087	2003-05-16	2003-05-23	1
74167	4409	81151	1976-12-27	1977-01-17	1
45467	2705	4112343	1985-04-18	1985-04-28	1
41641	2480	4112343	1970-03-01	1970-03-14	1
48771	2892	4113008	1990-12-22	1991-01-12	1
71322	4235	40481087	2008-02-09	2008-03-01	1
49445	2927	4230399	1987-05-17	1987-07-16	1
54669	3238	372328	1968-03-23	1968-05-06	1
3310	191	260139	1981-11-29	1981-12-06	1
40624	2418	0	1995-09-01	1995-09-02	1
13332	785	4112343	1989-04-29	1989-05-06	1
71482	4243	40481087	1977-10-06	1977-10-20	1
20791	1249	4132546	2014-01-23	2014-01-24	1
50841	3011	81151	1978-01-19	1978-02-02	1
16427	971	260139	2010-01-26	2010-02-02	1
73205	4355	40481087	2009-05-03	2009-05-10	1
60380	3573	80180	1963-09-30	1963-10-01	1
43684	2604	260139	2016-11-21	2016-12-05	1
48441	2871	440086	1960-12-08	1963-09-05	1
52894	3134	40481087	2017-02-19	2017-02-26	1
79125	4689	40481087	1986-03-22	1986-04-12	1
46366	2765	4112343	2001-02-11	2001-02-24	1
5287	311	378001	1995-10-11	1995-12-10	1
44040	2622	28060	1942-12-17	1942-12-27	1
89280	5315	375671	1926-02-26	1926-04-27	1
88118	5245	28060	1984-03-11	1984-03-23	1
15429	915	40481087	2008-06-27	2008-07-18	1
74030	4403	80180	1973-08-09	1973-08-10	1
43791	2610	4112343	1967-01-27	1967-02-05	1
28264	1672	4296205	2000-01-15	2000-01-29	1
29403	1743	80180	2002-01-15	2002-01-16	1
47792	2842	40481087	2004-11-27	2004-12-18	1
68863	4080	378001	1989-01-17	1989-02-16	1
41189	2450	40481087	2005-04-12	2005-05-03	1
14463	856	40481087	1971-08-07	1971-08-14	1
12439	736	4294548	1997-12-03	1997-12-17	1
14272	843	80180	2017-09-04	2017-09-05	1
53785	3184	40481087	2002-01-26	2002-02-02	1
79364	4705	4112343	1985-05-21	1985-05-31	1
48751	2891	40481087	1999-04-20	1999-04-27	1
38564	2291	4149245	1971-02-18	1971-04-26	1
18148	1091	40481087	1997-03-18	1997-04-08	1
50388	2985	372328	1966-06-19	1966-09-24	1
70814	4205	439777	1995-01-02	1995-01-03	1
43844	2613	0	2003-05-03	2003-05-04	1
44265	2633	40481087	1964-08-30	1964-09-06	1
24553	1467	260139	1944-02-29	1944-03-07	1
18822	1133	40481087	1996-05-03	1996-05-10	1
28517	1689	40481087	2014-12-30	2015-01-13	1
34452	2046	260139	1991-11-12	1991-11-19	1
40402	2402	40481087	2011-09-16	2011-10-07	1
74168	4409	257012	1981-02-23	1981-02-24	1
45468	2705	4155034	2013-03-20	2013-04-03	1
41642	2480	4112343	1998-05-05	1998-05-13	1
48772	2892	4294548	1986-06-21	1986-07-05	1
73095	4349	4134304	1984-11-21	1985-02-19	1
49446	2927	40481087	1956-06-29	1956-07-20	1
54670	3238	4237458	1972-11-27	1972-12-27	1
3311	191	4112343	1964-02-27	1964-03-11	1
40625	2418	195588	1998-08-29	1998-09-29	1
13333	785	4155034	1984-12-17	1985-01-07	1
71483	4243	40481087	1999-05-31	1999-06-14	1
20792	1249	40481087	1978-03-12	1978-03-26	1
50842	3011	260139	2014-05-12	2014-05-19	1
16428	971	4112343	1960-11-04	1960-11-13	1
73206	4355	260139	2019-04-12	2019-04-19	1
60381	3573	192671	1963-12-21	1963-12-22	1
43685	2604	4112343	1986-03-04	1986-03-11	1
48442	2871	40481087	1960-08-22	1960-09-05	1
53028	3144	260139	1965-02-18	1965-02-25	1
79126	4689	40481087	1991-09-19	1991-10-03	1
46367	2765	40481087	1956-09-25	1956-10-09	1
5288	311	440086	1984-07-24	1985-07-09	1
44041	2622	30753	1974-09-18	1974-09-19	1
89281	5315	4112343	1928-07-19	1928-08-01	1
88119	5245	375671	2003-07-08	2003-08-07	1
15430	915	40481087	2016-07-12	2016-07-19	1
74031	4403	81151	1999-05-01	1999-05-29	1
43792	2610	4112343	2013-11-11	2013-11-24	1
28265	1672	40481087	1984-03-24	1984-04-07	1
29404	1743	260139	1968-03-20	1968-04-03	1
47793	2842	260139	1973-01-10	1973-01-17	1
68864	4080	4109685	2014-05-06	2014-05-20	1
41190	2450	40481087	2018-10-29	2018-11-12	1
14464	856	40481087	1998-01-15	1998-02-05	1
12440	736	80180	2009-10-13	2009-10-14	1
14273	843	372328	1983-11-22	1984-04-07	1
53786	3184	0	2000-02-23	2000-02-24	1
79365	4705	4112343	1992-10-04	1992-10-15	1
48752	2891	40481087	2002-07-15	2002-08-05	1
38565	2291	4155034	1989-05-21	1989-06-04	1
18149	1091	40481087	1999-10-31	1999-11-21	1
50389	2985	4112343	1968-06-26	1968-07-07	1
70815	4205	4027663	2000-12-31	2001-01-01	1
43845	2613	260139	1957-10-01	1957-10-15	1
44266	2633	40481087	1978-11-01	1978-11-15	1
24554	1467	4116491	1955-03-21	1955-05-04	1
18823	1133	260139	1973-03-30	1973-04-06	1
28518	1689	28060	1945-12-03	1945-12-12	1
34453	2046	372328	1942-10-11	1942-12-01	1
40403	2402	40481087	2014-05-30	2014-06-13	1
74169	4409	260139	2016-09-29	2016-10-13	1
45469	2705	4218389	1965-09-27	1965-10-25	1
41643	2480	4134304	2009-06-05	2009-09-03	1
48773	2892	40481087	1973-08-30	1973-09-13	1
73096	4349	40481087	1989-03-06	1989-03-27	1
49447	2927	40481087	2000-12-20	2000-12-27	1
54671	3238	40481087	1987-01-17	1987-02-07	1
3312	191	4116491	1958-05-23	1958-06-26	1
40626	2418	4112343	2011-04-30	2011-05-10	1
13334	785	40481087	1978-06-30	1978-07-14	1
71484	4243	80180	2007-09-26	2007-09-27	1
20793	1249	40481087	1981-07-14	1981-08-04	1
50843	3011	372328	1980-01-09	1981-01-20	1
16429	971	4112343	1981-07-24	1981-08-05	1
73207	4355	4109685	2013-05-14	2013-05-28	1
60382	3573	4112343	1996-11-02	1996-11-15	1
43686	2604	4112343	1995-03-07	1995-03-14	1
48443	2871	40481087	2015-05-26	2015-06-16	1
53029	3144	260139	1992-03-10	1992-03-24	1
79127	4689	40481087	2009-11-24	2009-12-15	1
46368	2765	81151	1978-01-18	1978-02-01	1
5289	311	4152936	2004-08-24	2004-09-07	1
44042	2622	80180	1975-03-17	1975-03-18	1
89282	5315	4112343	1957-07-05	1957-07-17	1
88120	5245	4112343	2016-01-07	2016-01-15	1
15431	915	28060	2015-08-24	2015-09-05	1
74032	4403	260139	1950-08-12	1950-08-19	1
43793	2610	4278672	1973-04-26	1973-06-26	1
28266	1672	28060	2006-02-03	2006-02-11	1
29405	1743	372328	1969-01-13	1970-01-14	1
47794	2842	260139	1989-07-14	1989-07-23	1
68865	4080	4134304	1998-01-30	1998-03-01	1
41191	2450	78272	1970-08-22	1970-09-26	1
14465	856	372328	1970-10-06	1970-11-20	1
12441	736	260139	2002-08-21	2002-09-04	1
14274	843	378001	2009-07-08	2009-09-06	1
53787	3184	260139	1973-01-29	1973-02-12	1
79366	4705	4134304	1975-11-27	1975-12-27	1
51012	3025	78272	1953-10-15	1953-11-05	1
38566	2291	4294548	1988-05-12	1988-05-19	1
25284	1510	81151	1968-05-13	1968-05-27	1
50390	2985	4134304	1990-10-09	1991-01-07	1
70816	4205	4285898	2010-07-17	2010-07-18	1
43846	2613	260139	2001-01-27	2001-02-10	1
44267	2633	40481087	1997-05-18	1997-06-08	1
24555	1467	4218389	1994-03-20	1994-04-17	1
18824	1133	4112343	2014-12-22	2014-12-29	1
28519	1689	260139	1959-10-21	1959-11-04	1
34454	2046	378001	1944-08-31	1944-10-30	1
40404	2402	80180	2014-03-18	2014-03-19	1
74170	4409	321042	1999-10-28	1999-10-29	1
45470	2705	40481087	1974-03-13	1974-04-03	1
41644	2480	40481087	1956-09-03	1956-09-10	1
48774	2892	40481087	1985-12-08	1985-12-15	1
73097	4349	4112343	1999-06-19	1999-06-29	1
49448	2927	30753	1981-04-09	1981-04-10	1
55319	3280	257012	1952-01-16	1952-01-17	1
3313	191	4283893	1922-11-09	1923-03-08	1
40627	2418	4134304	1981-09-09	1981-12-08	1
13335	785	40481087	2014-10-08	2014-10-29	1
71485	4243	260139	1989-12-26	1990-01-09	1
20794	1249	40481087	1998-12-10	1998-12-24	1
50844	3011	4112343	1975-08-07	1975-08-18	1
16430	971	4146173	1954-10-17	1954-11-16	1
73208	4355	4266809	2019-04-24	2019-04-25	1
60383	3573	4134304	1934-10-27	1935-01-25	1
43687	2604	4113008	2000-07-02	2000-07-16	1
48444	2871	4112343	1972-05-08	1972-05-17	1
53030	3144	372328	1966-01-02	1966-05-04	1
81002	4811	372328	1963-12-07	1964-03-23	1
46369	2765	4155034	1998-01-31	1998-02-14	1
5290	311	4237458	1987-09-23	1987-12-22	1
44043	2622	260139	1941-05-16	1941-05-30	1
89283	5315	4112343	1959-04-09	1959-04-20	1
88121	5245	4155034	1989-09-07	1989-09-21	1
15432	915	78272	2000-04-24	2000-05-08	1
74033	4403	260139	1986-04-20	1986-04-27	1
43794	2610	4278672	2000-09-02	2000-11-30	1
28267	1672	192671	1989-06-20	1989-06-21	1
29406	1743	40481087	2004-07-27	2004-08-10	1
47795	2842	4109685	1979-11-09	1979-11-23	1
68866	4080	4310024	2001-01-18	2001-01-19	1
41192	2450	80180	1986-05-15	1986-05-16	1
14466	856	4059173	2011-09-06	2011-10-06	1
12442	736	4027663	1999-12-30	1999-12-31	1
14275	843	40481087	1993-01-08	1993-01-22	1
53788	3184	4296204	1978-04-02	1978-04-30	1
79367	4705	40481087	1980-01-12	1980-02-02	1
51013	3025	372328	1946-10-22	1947-02-03	1
38567	2291	40481087	1965-01-26	1965-02-02	1
25285	1510	40481087	1959-01-08	1959-01-22	1
50391	2985	4142905	2016-07-13	2016-10-11	1
70817	4205	40481087	2000-12-26	2001-01-16	1
43847	2613	4112343	2004-10-29	2004-11-06	1
44268	2633	40481087	2003-12-13	2004-01-03	1
24556	1467	40481087	1950-05-15	1950-06-05	1
18825	1133	4283893	1987-07-20	1987-08-24	1
28520	1689	4112343	1953-01-07	1953-01-19	1
34455	2046	4112343	1945-08-14	1945-08-27	1
40405	2402	372328	1977-07-10	1977-08-22	1
74171	4409	372328	1967-07-18	1967-09-28	1
45471	2705	260139	1980-12-16	1980-12-23	1
41645	2480	40481087	1969-06-09	1969-06-23	1
48775	2892	40481087	1990-12-18	1991-01-08	1
73098	4349	4113008	1987-01-10	1987-01-31	1
49449	2927	81893	1980-12-10	1980-12-11	1
55320	3280	261325	2016-12-08	2016-12-09	1
3314	191	4283893	1981-05-13	1981-08-12	1
40628	2418	4156265	1996-09-20	1996-10-04	1
13336	785	80180	2004-07-15	2004-07-16	1
71486	4243	260139	1993-11-06	1993-11-20	1
20795	1249	28060	1971-12-09	1971-12-21	1
50845	3011	4112343	1980-01-10	1980-01-20	1
16431	971	4294548	1977-01-18	1977-03-08	1
73209	4355	4296204	2010-10-13	2010-10-27	1
60384	3573	4152936	1937-03-15	1937-03-29	1
43688	2604	40481087	1964-08-25	1964-09-15	1
48445	2871	4112343	1978-10-16	1978-10-28	1
53031	3144	378001	1985-07-05	1985-08-04	1
81003	4811	372328	1964-07-22	1964-09-22	1
46370	2765	4296204	1993-04-13	1993-04-27	1
5441	321	260139	1968-08-08	1968-08-22	1
44044	2622	372328	1931-10-04	1932-01-16	1
89284	5315	4283893	1932-06-26	1932-09-25	1
88122	5245	40481087	1978-12-11	1979-01-01	1
15433	915	80180	1995-08-04	1995-08-05	1
74034	4403	4059173	1940-10-01	1940-11-30	1
43795	2610	4283893	1978-11-07	1980-01-22	1
28268	1672	4112343	1958-10-31	1958-11-07	1
29407	1743	40481087	2015-08-21	2015-09-04	1
47796	2842	4112343	1983-04-29	1983-05-08	1
68867	4080	80180	2002-10-10	2002-10-11	1
41193	2450	260139	1984-05-18	1984-06-01	1
14467	856	40481087	1992-10-27	1992-11-03	1
12443	736	40481087	1979-03-05	1979-03-19	1
15776	935	28060	1946-02-19	1946-02-26	1
57328	3407	80180	2005-08-02	2005-08-03	1
79368	4705	40481087	1994-03-22	1994-03-29	1
51014	3025	372328	1950-05-25	1950-11-06	1
38568	2291	81151	1998-09-15	1998-10-13	1
25286	1510	40481087	1995-08-04	1995-08-18	1
50392	2985	40481087	2005-04-29	2005-05-20	1
70818	4205	40481087	2018-02-08	2018-02-15	1
43848	2613	4112343	2018-09-11	2018-09-18	1
46493	2771	0	1972-09-01	1972-09-02	1
24557	1467	40481087	1953-09-24	1953-10-15	1
18826	1133	40481087	1989-11-17	1989-12-08	1
28521	1689	4112343	1960-05-15	1960-05-22	1
34456	2046	4112343	1977-06-30	1977-07-08	1
40406	2402	4051466	1978-09-20	1995-12-23	1
74172	4409	378001	1970-01-03	1970-03-04	1
45472	2705	260139	2017-08-19	2017-08-26	1
41646	2480	40481087	1972-05-14	1972-05-28	1
50266	2976	80180	1995-09-26	1995-09-27	1
73099	4349	40481087	1998-11-10	1998-12-01	1
49450	2927	260139	1945-04-10	1945-04-24	1
55321	3280	4112343	1959-08-04	1959-08-11	1
3315	191	4296205	2000-06-04	2000-06-25	1
40629	2418	40481087	1975-04-05	1975-04-26	1
13337	785	372328	1969-06-15	1969-11-23	1
71487	4243	4112343	2018-03-15	2018-03-26	1
20796	1249	78272	2019-05-02	2019-06-06	1
50846	3011	4112343	1994-10-05	1994-10-15	1
17483	1053	195588	2018-03-03	2018-04-18	1
73210	4355	40481087	1997-06-09	1997-06-30	1
60385	3573	4152936	1989-03-31	1989-04-21	1
43689	2604	28060	1994-07-27	1994-08-07	1
48446	2871	40481087	1951-06-18	1951-06-25	1
53032	3144	4112343	1981-07-10	1981-07-19	1
81004	4811	4112343	1967-02-06	1967-02-13	1
46371	2765	40481087	1958-06-10	1958-06-17	1
5442	321	260139	1973-04-13	1973-04-27	1
44045	2622	378001	1963-07-18	1963-08-17	1
89285	5315	4310024	1954-09-07	1954-09-08	1
88123	5245	40481087	2018-01-18	2018-01-25	1
15434	915	192671	1995-09-17	1995-09-18	1
74035	4403	4059173	1943-11-15	1944-02-13	1
43796	2610	40481087	1961-09-20	1961-09-27	1
28269	1672	4112343	1962-08-20	1962-09-01	1
29408	1743	78272	1974-10-05	1974-10-19	1
47797	2842	40481087	1968-01-31	1968-02-07	1
68868	4080	81893	2001-04-18	2001-04-19	1
41194	2450	439777	1974-12-29	1974-12-30	1
14468	856	28060	1981-03-15	1981-03-26	1
12444	736	40481087	1987-07-10	1987-07-24	1
15777	935	80180	1972-06-24	1972-06-25	1
57329	3407	4112343	1966-11-09	1966-11-19	1
79369	4705	40481087	2010-07-22	2010-08-05	1
51015	3025	4112343	1985-05-01	1985-05-14	1
38569	2291	260139	2001-03-14	2001-03-21	1
25287	1510	40481087	1999-12-30	2000-01-20	1
50393	2985	0	1967-06-17	1967-06-18	1
70819	4205	81893	2008-12-24	2008-12-25	1
43849	2613	4113008	1974-10-14	1974-11-04	1
46494	2771	198809	1974-09-02	1974-09-02	1
24558	1467	80180	1967-10-09	1967-10-10	1
18827	1133	40481087	2018-09-23	2018-09-30	1
28522	1689	4156265	1964-10-23	1964-11-06	1
34457	2046	4329847	2014-04-01	2014-04-02	1
40407	2402	4084167	1990-08-31	1990-08-31	1
74173	4409	40481087	1976-08-08	1976-08-22	1
45473	2705	313217	2010-12-11	2010-12-12	1
41647	2480	40481087	1986-06-18	1986-06-25	1
50267	2976	260139	2011-05-06	2011-05-20	1
73100	4349	28060	1992-07-14	1992-07-23	1
49451	2927	260139	1990-12-31	1991-01-14	1
55322	3280	4112343	1999-01-25	1999-02-01	1
3316	191	40481087	1956-10-24	1956-11-14	1
40630	2418	40481087	1980-06-06	1980-06-27	1
13338	785	4112343	1985-02-03	1985-02-16	1
71488	4243	40481087	1979-11-30	1979-12-07	1
20797	1249	260139	2016-02-26	2016-03-04	1
50847	3011	4112343	1978-09-05	1978-09-14	1
17484	1053	260139	2017-05-28	2017-06-04	1
73211	4355	80180	2019-04-24	2019-04-25	1
60386	3573	4156265	2010-11-27	2010-12-18	1
43690	2604	81151	1986-05-21	1986-06-18	1
48447	2871	40481087	1958-03-10	1958-03-31	1
53033	3144	40481087	1990-11-03	1990-11-24	1
81005	4811	4112343	1967-10-16	1967-10-28	1
46372	2765	40481087	1968-06-01	1968-06-08	1
5443	321	260139	1991-12-29	1992-01-12	1
44046	2622	4112343	1953-01-30	1953-02-09	1
56971	3383	4112343	2005-11-19	2005-11-27	1
88477	5265	81151	2012-02-11	2012-03-03	1
15435	915	260139	1969-08-06	1969-08-13	1
74036	4403	4230399	1992-10-04	1992-11-03	1
43797	2610	40481087	1968-11-24	1968-12-01	1
28270	1672	4112343	1966-09-11	1966-09-18	1
29409	1743	4156265	2012-03-24	2012-04-14	1
47798	2842	260139	1995-04-23	1995-04-30	1
68869	4080	260139	2007-01-25	2007-02-01	1
41195	2450	4112343	1974-05-07	1974-05-15	1
15987	948	28060	1980-08-08	1980-08-15	1
12445	736	40481087	2010-08-02	2010-08-23	1
15778	935	4027663	1962-03-04	1962-03-05	1
57330	3407	4116491	1985-01-19	1985-03-01	1
79370	4705	4112343	1989-02-11	1989-02-20	1
51016	3025	4112343	1992-02-08	1992-02-18	1
38570	2291	40481087	1995-10-17	1995-11-07	1
25288	1510	40481087	2010-11-28	2010-12-05	1
50394	2985	260139	1981-04-16	1981-04-30	1
70820	4205	40481087	1982-11-16	1982-12-07	1
43850	2613	4152936	1958-11-23	1958-12-07	1
46495	2771	260139	1920-09-15	1920-09-29	1
24559	1467	81151	1966-08-30	1966-09-13	1
21156	1271	81151	1969-10-24	1969-11-07	1
28523	1689	40481087	1943-03-26	1943-04-02	1
34458	2046	40481087	1953-05-22	1953-06-12	1
40408	2402	4112343	1977-08-10	1977-08-20	1
74174	4409	40481087	1990-02-28	1990-03-07	1
48375	2868	260139	1966-02-22	1966-03-01	1
41648	2480	260139	1975-07-21	1975-08-04	1
50268	2976	4027663	1987-06-15	1987-06-16	1
73101	4349	80180	2019-05-12	2019-05-13	1
49452	2927	260139	2004-07-05	2004-07-19	1
55323	3280	4296204	1991-05-17	1991-06-14	1
3317	191	40481087	1965-03-08	1965-03-15	1
40631	2418	40481087	1988-06-27	1988-07-18	1
13339	785	260139	1966-09-24	1966-10-08	1
71489	4243	40481087	1983-10-22	1983-11-12	1
20798	1249	4059173	1984-09-27	1984-12-26	1
50848	3011	4113008	1983-04-07	1983-04-28	1
17485	1053	40481087	2008-11-20	2008-11-27	1
73212	4355	260139	2018-07-08	2018-07-15	1
60387	3573	40481087	1940-07-09	1940-07-16	1
43691	2604	4296204	1997-08-19	1997-09-16	1
48448	2871	40481087	1968-07-14	1968-07-28	1
53034	3144	40481087	1998-12-11	1998-12-25	1
81006	4811	4134304	1965-12-26	1966-03-26	1
46373	2765	40481087	1974-06-14	1974-06-28	1
5444	321	378001	2001-02-25	2001-03-27	1
44047	2622	40481087	1933-09-28	1933-10-05	1
56972	3383	4113008	1995-09-27	1995-10-18	1
88478	5265	260139	2018-12-15	2018-12-29	1
15436	915	260139	1973-08-23	1973-09-06	1
74037	4403	40481087	1936-10-01	1936-10-08	1
43798	2610	40481087	1990-10-01	1990-10-08	1
28271	1672	40481087	1988-11-07	1988-11-21	1
29410	1743	4296204	2006-07-03	2006-07-24	1
47799	2842	40481087	1963-12-04	1963-12-25	1
68870	4080	4027663	1992-05-25	1992-05-26	1
41196	2450	40481087	1952-04-03	1952-04-24	1
15988	948	28060	1993-06-19	1993-06-26	1
12446	736	30753	2008-10-18	2008-10-19	1
15779	935	4134304	1936-04-09	1936-07-08	1
57331	3407	4285898	2005-01-04	2005-01-05	1
79371	4705	4218389	2007-04-13	2007-05-18	1
51017	3025	4218389	1996-02-23	1996-03-15	1
38571	2291	40481087	1997-07-05	1997-07-26	1
25289	1510	78272	1970-07-16	1970-08-20	1
50395	2985	260139	1982-11-28	1982-12-05	1
70821	4205	40481087	1999-02-19	1999-02-26	1
43851	2613	40481087	1986-03-10	1986-03-17	1
46496	2771	313217	1978-01-20	1978-01-21	1
24560	1467	4112343	1957-11-20	1957-12-02	1
21157	1271	192671	2010-11-13	2010-11-14	1
28524	1689	40481087	2007-05-02	2007-05-09	1
34459	2046	40481087	1965-07-10	1965-07-17	1
40409	2402	4112343	1984-02-19	1984-03-03	1
74175	4409	40481087	2001-06-30	2001-07-21	1
48376	2868	375671	2001-03-03	2001-04-02	1
41649	2480	372328	1964-05-05	1964-11-04	1
50269	2976	4029498	1955-06-23	1955-06-24	1
73102	4349	81151	1991-02-09	1991-03-09	1
49453	2927	4283893	1973-05-28	1973-07-16	1
55324	3280	40481087	1962-09-13	1962-09-27	1
3318	191	28060	1924-12-24	1925-01-06	1
40632	2418	80180	2009-06-17	2009-06-18	1
13340	785	260139	1989-08-15	1989-08-22	1
71490	4243	40481087	1999-09-19	1999-10-10	1
20799	1249	4112343	1983-09-04	1983-09-14	1
50849	3011	4112343	2014-09-09	2014-09-22	1
17486	1053	40481087	2015-12-29	2016-01-12	1
73213	4355	372328	1981-11-14	1981-12-26	1
60388	3573	40481087	1956-12-20	1957-01-03	1
43692	2604	40481087	1965-02-21	1965-02-28	1
48449	2871	40481087	1990-11-20	1990-12-11	1
53035	3144	40481087	2019-04-07	2019-04-14	1
81007	4811	4294548	1968-02-07	1968-02-14	1
46374	2765	40481087	1974-09-05	1974-09-19	1
5445	321	440086	1975-11-09	1979-11-18	1
44048	2622	40481087	1969-06-20	1969-06-27	1
56973	3383	4156265	2014-11-07	2014-11-28	1
88479	5265	321042	2008-06-05	2008-06-06	1
15437	915	372328	1965-05-28	1965-12-11	1
74038	4403	40481087	1996-11-20	1996-12-04	1
46712	2782	80502	2000-03-22	2000-03-23	1
28272	1672	260139	2001-08-17	2001-08-31	1
30732	1820	0	2015-01-31	2015-02-01	1
47800	2842	40481087	2001-07-25	2001-08-08	1
68871	4080	4285898	2002-09-10	2002-09-11	1
41197	2450	28060	1985-11-29	1985-12-12	1
15989	948	80180	1998-03-03	1998-03-04	1
12447	736	260139	1976-08-14	1976-08-28	1
15780	935	4237458	1961-08-26	1961-09-25	1
57332	3407	40481087	2002-02-05	2002-02-19	1
79372	4705	40481087	2019-06-21	2019-06-22	1
51018	3025	260139	1979-09-01	1979-09-08	1
43383	2588	81151	1979-07-02	1979-08-06	1
25290	1510	78272	2010-01-29	2010-02-26	1
50396	2985	260139	2006-05-01	2006-05-08	1
70822	4205	40481087	2011-09-28	2011-10-05	1
46608	2777	80180	1999-11-07	1999-11-08	1
46497	2771	4112343	1939-02-25	1939-03-07	1
24561	1467	4112343	1966-09-15	1966-09-22	1
21158	1271	260139	1968-09-01	1968-09-15	1
31294	1852	80180	2007-05-18	2007-05-19	1
34460	2046	40481087	1999-08-25	1999-09-01	1
40410	2402	40481087	2016-04-09	2016-04-16	1
74176	4409	4112343	1983-09-06	1983-09-13	1
48377	2868	4109685	1970-03-02	1970-03-16	1
41650	2480	4113008	1977-12-06	1977-12-20	1
50270	2976	4112343	1956-08-20	1956-09-02	1
73103	4349	40481087	1990-06-27	1990-07-04	1
49454	2927	40481087	1943-03-25	1943-04-01	1
55325	3280	40481087	1966-08-06	1966-08-27	1
3319	191	260139	1957-10-12	1957-10-19	1
40633	2418	81151	1976-04-21	1976-05-26	1
13341	785	4112343	1969-10-10	1969-10-23	1
72689	4325	28060	1969-01-03	1969-01-11	1
22524	1348	375671	1947-07-12	1947-08-11	1
50850	3011	40481087	1975-07-11	1975-07-18	1
17487	1053	195588	2014-01-20	2014-03-04	1
73214	4355	4027663	2010-04-11	2010-04-12	1
61138	3621	260139	1930-01-23	1930-01-30	1
43693	2604	40481087	1979-11-20	1979-12-04	1
48450	2871	40481087	1998-12-25	1999-01-08	1
53036	3144	4218389	1980-10-31	1980-11-28	1
81008	4811	40481087	1966-07-27	1966-08-10	1
46375	2765	28060	2013-07-08	2013-07-15	1
5446	321	4134304	1966-08-18	1966-10-17	1
44049	2622	40481087	2018-07-24	2018-08-14	1
56974	3383	40481087	1993-10-13	1993-10-27	1
88480	5265	4112343	1973-09-26	1973-10-07	1
15438	915	4112343	1979-10-10	1979-10-20	1
74039	4403	4027663	1963-02-23	1963-02-24	1
46713	2782	257012	1997-12-25	1997-12-26	1
28273	1672	4027663	1982-04-22	1982-04-23	1
30733	1820	80180	2014-08-17	2014-08-18	1
47801	2842	80180	1995-12-05	1995-12-06	1
68872	4080	260139	1985-01-19	1985-02-02	1
41198	2450	260139	1994-05-22	1994-05-29	1
15990	948	4112343	2015-12-30	2016-01-11	1
12448	736	260139	2000-10-22	2000-10-29	1
15781	935	4266809	1972-06-24	1972-06-25	1
57333	3407	30753	2004-11-05	2004-11-06	1
79373	4705	195588	2010-06-06	2010-07-20	1
51019	3025	260139	1996-05-16	1996-05-30	1
43384	2588	372328	2008-06-10	2008-09-14	1
25291	1510	80180	2002-01-10	2002-01-11	1
50397	2985	372328	1967-06-21	1967-09-23	1
71169	4225	28060	1991-08-01	1991-08-10	1
46609	2777	192671	1999-12-04	1999-12-05	1
46498	2771	4112343	1942-05-22	1942-06-01	1
24562	1467	4146173	1993-02-23	1993-04-24	1
21159	1271	260139	1986-02-10	1986-02-17	1
31295	1852	260139	1974-05-03	1974-05-10	1
34461	2046	28060	1948-02-17	1948-02-29	1
40411	2402	81151	1987-01-17	1987-02-07	1
74177	4409	4112343	2002-11-05	2002-11-18	1
48378	2868	4112343	1969-08-21	1969-09-03	1
41651	2480	40481087	1979-05-27	1979-06-03	1
50271	2976	260139	1966-08-26	1966-09-09	1
73104	4349	40481087	1995-10-13	1995-10-20	1
49455	2927	378001	1999-04-14	1999-06-13	1
55326	3280	40481087	1991-04-22	1991-04-29	1
3320	191	260139	1991-07-25	1991-08-01	1
40634	2418	260139	1989-05-14	1989-05-28	1
13342	785	40481087	2007-07-21	2007-08-11	1
72690	4325	80180	2002-05-03	2002-05-04	1
22525	1348	378001	1923-11-24	1924-01-23	1
50851	3011	40481087	1980-02-29	1980-03-07	1
17488	1053	260139	1979-10-22	1979-10-29	1
73215	4355	4109685	2017-05-07	2017-05-28	1
61139	3621	260139	1967-07-03	1967-07-10	1
43694	2604	40481087	2013-04-30	2013-05-07	1
48451	2871	40481087	2007-11-27	2007-12-04	1
53037	3144	40481087	1988-11-20	1988-12-04	1
81009	4811	40481087	2001-08-01	2001-08-08	1
46376	2765	80180	1974-06-26	1974-06-27	1
5447	321	40481087	1990-05-06	1990-05-20	1
44050	2622	28060	1950-06-04	1950-06-12	1
56975	3383	40481087	2010-02-20	2010-03-06	1
88481	5265	40481087	1995-08-08	1995-08-15	1
15439	915	4112343	1997-08-29	1997-09-07	1
74040	4403	4059173	1946-11-29	1947-01-28	1
46714	2782	260139	1962-11-19	1962-11-26	1
28274	1672	4156265	1973-10-07	1973-10-28	1
30734	1820	260139	2010-11-20	2010-12-04	1
47802	2842	81151	1970-03-26	1970-04-30	1
68873	4080	378001	2007-02-12	2007-04-13	1
41199	2450	372328	1952-07-27	1952-12-11	1
15991	948	4218389	1978-03-15	1978-04-05	1
12449	736	4112343	1977-10-17	1977-10-30	1
15782	935	40481087	1939-03-01	1939-03-08	1
57334	3407	4266809	2005-08-02	2005-08-03	1
79374	4705	372328	1982-05-27	1982-06-17	1
51020	3025	375671	1994-11-30	1995-01-29	1
43385	2588	4112343	1994-11-17	1994-11-27	1
25292	1510	81151	2014-01-06	2014-01-20	1
50398	2985	4112343	1978-03-02	1978-03-14	1
71170	4225	30753	2013-11-22	2013-11-23	1
46610	2777	195588	2013-03-19	2013-05-02	1
46499	2771	4112343	1969-10-11	1969-10-19	1
24563	1467	40481087	1980-01-02	1980-01-23	1
21160	1271	4027663	1998-12-31	1999-01-01	1
31296	1852	372328	1974-06-30	1974-08-07	1
34462	2046	28060	2011-12-08	2011-12-21	1
40412	2402	260139	1980-02-26	1980-03-04	1
74178	4409	4112343	2011-10-04	2011-10-17	1
48379	2868	40481087	2008-01-12	2008-01-19	1
48071	2857	4094814	1987-07-08	1987-10-06	1
50272	2976	260139	2005-09-19	2005-10-03	1
73105	4349	40481087	2016-08-05	2016-08-12	1
49456	2927	378001	2007-11-28	2007-12-28	1
55327	3280	378001	1964-09-02	1964-10-02	1
3321	191	381316	1969-11-04	1969-11-05	1
40635	2418	440448	1995-09-01	1995-09-02	1
14784	871	440086	1978-01-15	1984-01-24	1
72691	4325	260139	1986-05-21	1986-06-04	1
22526	1348	4112343	1948-06-25	1948-07-05	1
52200	3093	80180	2009-11-03	2009-11-04	1
17489	1053	260139	2004-09-23	2004-10-07	1
73216	4355	4112343	2009-11-19	2009-12-01	1
61140	3621	372328	1927-05-30	1928-01-28	1
43695	2604	28060	1991-02-28	1991-03-11	1
48452	2871	80180	1996-07-12	1996-07-13	1
53038	3144	28060	1964-01-28	1964-02-07	1
81010	4811	40481087	2012-07-01	2012-07-08	1
46377	2765	81151	1960-02-24	1960-03-23	1
5448	321	81151	1983-11-22	1983-12-06	1
44051	2622	195588	1971-10-29	1971-12-13	1
56976	3383	80180	2018-06-03	2018-06-04	1
88482	5265	260139	1990-08-26	1990-09-09	1
15440	915	4146173	1999-01-30	1999-03-31	1
74041	4403	4266809	1973-08-09	1973-08-10	1
46715	2782	372328	1921-08-10	1921-10-26	1
28275	1672	4266809	1989-04-10	1989-04-11	1
30735	1820	4112343	1999-02-09	1999-02-19	1
47803	2842	260139	2002-02-23	2002-03-02	1
68874	4080	4113008	1970-10-03	1970-10-24	1
41200	2450	4112343	1980-01-17	1980-01-28	1
15992	948	4283893	1972-01-16	1972-05-21	1
12450	736	4155034	2010-07-15	2010-08-05	1
15783	935	40481087	1945-09-05	1945-09-26	1
57335	3407	4296204	1999-07-15	1999-08-05	1
79375	4705	4112343	1978-04-19	1978-04-26	1
51021	3025	439777	1988-11-15	1988-11-16	1
43386	2588	81151	1987-01-26	1987-02-16	1
25293	1510	81893	2001-01-15	2001-01-16	1
50399	2985	40481087	1987-06-14	1987-06-21	1
71171	4225	260139	1983-11-11	1983-11-18	1
46611	2777	260139	1968-05-21	1968-05-28	1
46500	2771	4156265	1946-11-23	1946-12-14	1
24564	1467	260139	1988-07-19	1988-08-02	1
21161	1271	4112343	2014-04-15	2014-04-26	1
31297	1852	372328	1976-09-25	1977-01-26	1
34463	2046	80180	1984-11-29	1984-11-30	1
40413	2402	40481087	2003-03-01	2003-03-08	1
74179	4409	40481087	1978-02-22	1978-03-01	1
48380	2868	260139	2009-05-31	2009-06-07	1
48072	2857	4112343	1970-10-19	1970-10-27	1
50273	2976	372328	1958-01-08	1958-05-29	1
73106	4349	260139	2008-05-20	2008-05-27	1
49457	2927	4142905	1983-03-09	1983-06-07	1
55328	3280	4156265	1969-08-28	1969-09-11	1
3322	191	4059173	1924-02-11	1924-03-12	1
40636	2418	4218389	1980-10-16	1980-11-13	1
14785	871	4112343	1986-06-18	1986-06-29	1
72692	4325	260139	2012-02-04	2012-02-18	1
22527	1348	4112343	1963-11-30	1963-12-13	1
52201	3093	4112343	1979-02-01	1979-02-13	1
17490	1053	372328	1978-08-31	1979-02-23	1
73217	4355	4310024	2016-11-05	2016-11-06	1
61141	3621	4112343	1924-12-29	1925-01-09	1
43696	2604	260139	2011-05-19	2011-05-26	1
48453	2871	81151	1967-07-15	1967-08-05	1
53039	3144	80180	2007-05-03	2007-05-04	1
81011	4811	78272	1992-04-09	1992-04-23	1
46378	2765	260139	1984-06-10	1984-06-24	1
5449	321	4152936	1967-11-11	1967-11-25	1
44052	2622	378001	2015-08-05	2015-09-04	1
56977	3383	4112343	1988-11-04	1988-11-15	1
88483	5265	372328	1971-02-06	1971-07-29	1
19798	1193	80180	1987-03-15	1987-03-16	1
74042	4403	4296205	1964-06-02	1964-06-16	1
46716	2782	378419	1996-04-24	1996-04-25	1
28276	1672	40481087	1974-04-14	1974-04-21	1
30736	1820	28060	1982-03-19	1982-03-31	1
47804	2842	260139	2017-02-12	2017-02-26	1
68875	4080	4134304	1971-11-18	1972-01-17	1
41201	2450	40481087	1975-01-28	1975-02-04	1
15993	948	40481087	1984-10-04	1984-10-18	1
12451	736	4266809	2009-10-13	2009-10-14	1
15784	935	40481087	1946-01-03	1946-01-10	1
57336	3407	40481087	1980-02-02	1980-02-23	1
79376	4705	4112343	2013-05-12	2013-05-19	1
51022	3025	4283893	1969-12-22	1970-06-01	1
43387	2588	260139	1966-06-22	1966-06-29	1
25294	1510	260139	1960-05-26	1960-06-09	1
50400	2985	40481087	1988-04-21	1988-04-28	1
71172	4225	4027663	2006-03-29	2006-03-30	1
46612	2777	260139	2000-08-30	2000-09-13	1
46501	2771	40481087	1956-04-22	1956-05-13	1
24565	1467	4112343	1935-04-17	1935-04-24	1
21162	1271	4156265	1978-12-20	1979-01-10	1
31298	1852	4112343	2011-01-24	2011-02-02	1
34464	2046	260139	1946-11-21	1946-11-28	1
40414	2402	40481087	2014-02-01	2014-02-22	1
74180	4409	40481087	1985-12-31	1986-01-14	1
48381	2868	372328	1966-06-21	1966-09-14	1
48073	2857	4112343	1992-11-15	1992-11-22	1
50274	2976	40481087	1964-05-11	1964-05-25	1
73107	4349	372328	1983-05-01	1983-08-11	1
49458	2927	4294548	2012-11-18	2013-01-06	1
55329	3280	4218389	1952-10-07	1952-11-04	1
3323	191	4059173	1994-05-07	1994-08-05	1
40637	2418	28060	1983-04-19	1983-04-26	1
14786	871	4266809	2003-12-30	2003-12-31	1
72693	4325	4112343	1979-08-01	1979-08-14	1
22528	1348	4112343	2000-06-09	2000-06-19	1
52202	3093	4155034	1984-11-19	1984-12-10	1
17491	1053	378001	1996-10-09	1996-11-08	1
73218	4355	40481087	2018-12-27	2019-01-17	1
61142	3621	4218389	1960-05-06	1960-05-27	1
43697	2604	372328	1957-04-04	1957-05-18	1
48454	2871	260139	1959-07-29	1959-08-12	1
53040	3144	260139	1974-11-16	1974-11-30	1
81012	4811	80180	1999-10-25	1999-10-26	1
46379	2765	260139	1989-04-07	1989-04-14	1
5450	321	4294548	1998-10-26	1998-11-09	1
44053	2622	4027663	1963-10-31	1963-11-01	1
56978	3383	4112343	2016-03-05	2016-03-13	1
88484	5265	378001	1978-08-12	1978-09-11	1
19799	1193	81151	1955-08-09	1955-09-13	1
74043	4403	40481087	1949-01-18	1949-02-01	1
46717	2782	4113008	1956-06-03	1956-06-17	1
28277	1672	40481087	1988-01-22	1988-02-05	1
30737	1820	260139	1984-01-09	1984-01-23	1
47805	2842	440086	1971-09-22	1971-12-22	1
68876	4080	40481087	1981-02-14	1981-03-07	1
41202	2450	4112343	2009-02-26	2009-03-09	1
15994	948	40481087	1985-05-22	1985-06-12	1
12452	736	4294548	2008-04-29	2008-06-10	1
15785	935	257012	1992-09-11	1992-09-12	1
57337	3407	372328	1964-06-18	1964-07-02	1
79377	4705	4112343	2016-04-07	2016-04-17	1
51023	3025	40481087	1947-05-26	1947-06-02	1
43388	2588	260139	1967-03-06	1967-03-13	1
25295	1510	260139	1970-05-21	1970-06-04	1
50401	2985	40481087	2001-06-19	2001-07-10	1
71173	4225	4310024	2013-05-26	2013-05-27	1
46613	2777	260139	2004-05-02	2004-05-09	1
46502	2771	40481087	1967-06-23	1967-06-30	1
24566	1467	4112343	1951-09-30	1951-10-08	1
21163	1271	4285898	2010-01-17	2010-01-18	1
31299	1852	4112343	2017-06-01	2017-06-10	1
34465	2046	4146173	1969-12-23	1970-01-29	1
44557	2654	80180	1983-04-18	1983-04-19	1
74181	4409	40481087	1992-11-28	1992-12-12	1
48382	2868	4059173	1969-02-05	1969-04-06	1
48074	2857	28060	1979-01-15	1979-01-26	1
50275	2976	40481087	1965-07-25	1965-08-08	1
73108	4349	4001336	1990-01-15	1990-02-14	1
49459	2927	40481087	1977-06-03	1977-06-10	1
55330	3280	40481087	1965-12-19	1966-01-02	1
3324	191	4112343	1953-05-13	1953-05-23	1
40638	2418	78272	1979-02-10	1979-02-24	1
14787	871	40481087	2005-12-21	2006-01-11	1
72694	4325	4112343	1988-04-01	1988-04-10	1
22529	1348	4156265	1977-12-01	1977-12-22	1
52203	3093	28060	1983-01-27	1983-02-05	1
17492	1053	4294548	1976-07-07	1976-09-22	1
75875	4505	192671	1981-11-16	1981-11-17	1
61143	3621	4278672	1929-08-03	1929-09-02	1
43698	2604	4112343	1996-10-08	1996-10-15	1
48455	2871	372328	1952-05-16	1952-11-17	1
53041	3144	372328	1965-05-02	1965-11-03	1
81013	4811	192671	1999-12-03	1999-12-04	1
46380	2765	378001	1956-12-11	1957-01-10	1
5451	321	80180	2003-06-20	2003-06-21	1
44054	2622	4112343	1990-01-13	1990-01-22	1
56979	3383	4134304	1988-04-06	1988-05-06	1
88485	5265	4112343	1996-12-07	1996-12-17	1
19800	1193	81151	1964-03-20	1964-04-17	1
74044	4403	40481087	1958-11-29	1958-12-20	1
46718	2782	4285898	1954-08-02	1954-08-03	1
28278	1672	78272	1957-03-09	1957-03-30	1
30738	1820	260139	2006-12-02	2006-12-09	1
47806	2842	4112343	1985-03-02	1985-03-09	1
68877	4080	40481087	1988-09-03	1988-09-10	1
41203	2450	40481087	1952-08-30	1952-09-20	1
15995	948	260139	1965-12-13	1965-12-20	1
12453	736	40481087	2011-03-26	2011-04-09	1
15786	935	313217	1990-05-09	1990-05-10	1
57338	3407	4027663	1994-01-17	1994-01-18	1
79378	4705	40481087	1982-07-30	1982-08-20	1
51024	3025	40481087	1949-02-26	1949-03-12	1
43389	2588	260139	1985-09-16	1985-09-30	1
25296	1510	372328	1974-02-17	1974-06-23	1
50402	2985	260139	1969-10-18	1969-10-25	1
71174	4225	40481087	1983-11-18	1983-12-02	1
46614	2777	4112343	2017-08-31	2017-09-10	1
46503	2771	40481087	1973-08-06	1973-08-20	1
24567	1467	4112343	1953-04-03	1953-04-13	1
21164	1271	40481087	2009-06-18	2009-07-09	1
31300	1852	4155034	2016-10-29	2016-11-19	1
34466	2046	40481087	1940-07-31	1940-08-07	1
44558	2654	81151	1945-06-26	1945-07-31	1
74182	4409	40481087	1997-05-05	1997-05-26	1
48383	2868	40481087	1965-06-03	1965-06-17	1
48075	2857	4109685	1979-12-02	1979-12-16	1
50276	2976	260139	2013-07-04	2013-07-11	1
73962	4398	260139	1984-02-07	1984-02-21	1
49460	2927	40481087	1991-04-29	1991-05-06	1
55331	3280	40481087	1967-06-02	1967-06-16	1
3325	191	4112343	1957-04-03	1957-04-16	1
40639	2418	40481087	1984-04-13	1984-04-27	1
14788	871	40481087	2014-09-28	2014-10-19	1
72695	4325	4112343	1995-12-01	1995-12-10	1
22530	1348	40481087	1938-03-02	1938-03-23	1
52204	3093	260139	2019-03-26	2019-04-02	1
17493	1053	40481087	2001-04-17	2001-04-24	1
75876	4505	4112343	1958-08-11	1958-08-18	1
61144	3621	80180	1955-08-27	1955-08-28	1
43699	2604	4152936	2017-05-18	2017-06-01	1
48456	2871	4112343	2003-04-21	2003-04-28	1
53042	3144	372328	1964-07-22	1964-08-05	1
81014	4811	260139	1979-01-27	1979-02-10	1
46381	2765	440448	1994-05-08	1994-05-09	1
5452	321	81151	1996-06-30	1996-07-21	1
44055	2622	4112343	1996-03-24	1996-04-05	1
56980	3383	40481087	1998-02-08	1998-02-15	1
88486	5265	40481087	1991-11-27	1991-12-18	1
19801	1193	260139	2008-07-08	2008-07-15	1
74045	4403	40481087	1993-04-14	1993-05-05	1
46719	2782	40481087	1939-08-24	1939-08-31	1
28279	1672	80180	1989-04-10	1989-04-11	1
30739	1820	381316	2004-09-14	2004-09-15	1
47807	2842	4112343	1996-02-12	1996-02-20	1
68878	4080	260139	1993-09-05	1993-09-19	1
41204	2450	40481087	1973-03-09	1973-03-30	1
15996	948	372328	1960-05-11	1960-08-26	1
17232	1033	80180	2007-07-17	2007-07-18	1
15787	935	440086	1938-03-10	1948-03-17	1
57339	3407	4112343	1969-11-04	1969-11-13	1
79379	4705	40481087	1999-04-08	1999-04-15	1
51025	3025	40481087	1989-07-21	1989-08-04	1
43390	2588	261325	2012-10-14	2012-10-15	1
25297	1510	4112343	2019-02-03	2019-02-14	1
50403	2985	321042	1967-06-17	1967-06-18	1
71175	4225	40481087	2002-10-29	2002-11-05	1
46615	2777	4142905	1993-10-01	1993-10-31	1
46504	2771	40481087	1989-05-06	1989-05-13	1
24568	1467	4112343	1989-03-29	1989-04-09	1
21165	1271	80180	2010-10-14	2010-10-15	1
31301	1852	4218389	2011-09-05	2011-09-26	1
34467	2046	40481087	1946-01-16	1946-01-23	1
44559	2654	260139	2015-03-31	2015-04-07	1
74183	4409	40481087	1998-08-24	1998-09-07	1
48384	2868	40481087	1987-08-11	1987-08-25	1
48076	2857	4112343	2011-05-19	2011-05-27	1
50277	2976	4112343	1984-03-02	1984-03-15	1
73963	4398	260139	1993-04-15	1993-04-22	1
49461	2927	257012	2012-12-30	2012-12-31	1
55332	3280	40481087	1978-07-16	1978-07-23	1
3326	191	4112343	1977-07-04	1977-07-13	1
40640	2418	40481087	2005-05-15	2005-05-29	1
14789	871	40481087	2018-12-06	2018-12-20	1
72696	4325	4112343	2009-11-27	2009-12-05	1
22531	1348	40481087	1948-04-01	1948-04-15	1
52205	3093	378001	1988-07-22	1988-08-21	1
17494	1053	28060	1985-03-25	1985-04-02	1
75877	4505	4152936	1942-02-20	1942-03-13	1
61145	3621	260139	1972-02-28	1972-03-06	1
43700	2604	4218389	1973-01-24	1973-02-28	1
48457	2871	4237458	2017-03-15	2017-04-14	1
53043	3144	372328	1967-11-25	1968-05-08	1
81015	4811	440448	1995-04-10	1995-04-11	1
46382	2765	4112343	1949-03-21	1949-04-03	1
5453	321	4112343	1965-09-25	1965-10-07	1
44056	2622	4113008	1964-07-12	1964-08-02	1
58907	3501	28060	1957-09-01	1957-09-13	1
88487	5265	40481087	2008-04-14	2008-05-05	1
19802	1193	4112343	1974-01-21	1974-01-28	1
74046	4403	78272	1987-01-15	1987-01-29	1
46720	2782	40481087	1959-01-16	1959-01-30	1
28280	1672	260139	2002-10-31	2002-11-07	1
30740	1820	440448	2015-01-31	2015-02-01	1
47808	2842	40481087	1990-12-15	1990-12-22	1
73334	4365	260139	2005-12-09	2005-12-23	1
41205	2450	40481087	1977-01-31	1977-02-21	1
15997	948	372328	1961-08-21	1962-02-23	1
17233	1033	81151	1995-02-05	1995-03-05	1
15788	935	4112343	1954-07-15	1954-07-27	1
57340	3407	4112343	2016-06-23	2016-07-05	1
79380	4705	40481087	2009-07-14	2009-07-21	1
51026	3025	0	2002-10-14	2002-10-15	1
43391	2588	4112343	1993-07-02	1993-07-10	1
25298	1510	40481087	1970-10-28	1970-11-11	1
50404	2985	372328	1976-10-16	1976-11-13	1
71176	4225	80180	2014-06-20	2014-06-21	1
46616	2777	4237458	2007-02-03	2007-03-05	1
46505	2771	40481087	2015-02-05	2015-02-19	1
24569	1467	4112343	2012-02-27	2012-03-09	1
21166	1271	81893	2009-01-22	2009-01-23	1
31302	1852	4294548	2012-11-02	2012-11-23	1
35069	2084	4056621	2002-01-13	2002-01-14	1
44560	2654	40481087	1974-02-18	1974-02-25	1
74184	4409	40481087	2001-05-03	2001-05-24	1
48385	2868	317576	2002-10-16	2002-10-17	1
48077	2857	4113008	1967-08-24	1967-09-07	1
50278	2976	0	1955-06-23	1955-06-24	1
73964	4398	372328	1963-05-10	1964-02-22	1
49462	2927	260139	1950-05-06	1950-05-20	1
55333	3280	40481087	2006-03-16	2006-03-30	1
3327	191	40479768	1929-09-12	1929-11-18	1
40641	2418	40481087	2005-12-04	2005-12-11	1
14790	871	80180	2003-12-30	2003-12-31	1
72697	4325	4283893	1980-06-17	1980-08-12	1
22532	1348	40481087	1964-06-27	1964-07-18	1
52206	3093	4112343	1989-11-02	1989-11-09	1
17495	1053	81151	2018-05-08	2018-05-22	1
75878	4505	4296205	1993-03-29	1993-05-03	1
61146	3621	4112343	1950-09-19	1950-10-02	1
43701	2604	40481087	1960-10-22	1960-11-05	1
48458	2871	40481087	1993-01-06	1993-01-20	1
53044	3144	4116491	1998-05-20	1998-07-08	1
81016	4811	4285898	1999-07-27	1999-07-28	1
46383	2765	4112343	1966-08-23	1966-08-31	1
5454	321	4112343	1965-12-07	1965-12-17	1
44057	2622	4285898	1975-02-15	1975-02-16	1
58908	3501	81151	1993-04-02	1993-04-24	1
88488	5265	0	2008-06-05	2008-06-06	1
19803	1193	4146173	1950-08-21	1950-10-20	1
74047	4403	81151	1969-06-20	1969-07-18	1
46721	2782	40481087	1987-05-08	1987-05-29	1
28281	1672	4218389	1992-01-22	1992-02-26	1
30741	1820	40481087	1987-07-08	1987-07-22	1
47809	2842	40481087	2012-04-17	2012-05-01	1
73335	4365	313217	2001-07-23	2001-07-24	1
41206	2450	40481087	1993-09-03	1993-09-10	1
15998	948	4059173	1967-05-12	1967-08-10	1
17234	1033	4112343	1975-01-19	1975-01-27	1
15789	935	4134304	1931-04-06	1931-06-05	1
57341	3407	4152936	2006-05-30	2006-06-20	1
80024	4749	28060	2008-11-25	2008-12-05	1
51027	3025	80180	1984-08-03	1984-08-04	1
43392	2588	80180	2002-04-03	2002-04-04	1
25299	1510	40481087	1987-12-20	1988-01-10	1
50405	2985	4112343	1968-12-05	1968-12-16	1
71177	4225	4266809	2014-06-20	2014-06-21	1
46617	2777	40481087	1971-11-20	1971-12-04	1
46506	2771	81151	1940-03-08	1940-03-29	1
24570	1467	40481087	1940-08-23	1940-09-06	1
21167	1271	4112343	2013-05-05	2013-05-16	1
31303	1852	40481087	1977-04-25	1977-05-16	1
35070	2084	4112343	1971-05-29	1971-06-07	1
44561	2654	40481087	2015-05-15	2015-06-05	1
76973	4565	80180	1981-10-17	1981-10-18	1
48386	2868	372328	1967-05-12	1968-09-25	2
48078	2857	40481087	1965-11-10	1965-11-17	1
50279	2976	261325	1979-07-05	1979-07-06	1
73965	4398	4112343	2017-08-11	2017-08-18	1
49463	2927	260139	1958-05-21	1958-06-04	1
55334	3280	78272	1967-09-17	1967-10-08	1
3328	191	40481087	1971-02-21	1971-02-28	1
40642	2418	260139	2018-06-02	2018-06-09	1
14791	871	260139	1971-09-20	1971-10-04	1
72698	4325	40481087	1984-05-28	1984-06-18	1
22533	1348	260139	1920-03-15	1920-03-22	1
52207	3093	4116491	1998-06-19	1998-08-05	1
17496	1053	257012	1976-08-11	1976-08-12	1
75879	4505	40481087	1947-07-14	1947-07-21	1
61147	3621	4112343	1984-11-21	1984-11-29	1
43702	2604	40481087	1969-03-17	1969-04-07	1
48459	2871	40481087	2013-02-12	2013-02-26	1
53045	3144	4296204	1968-01-03	1968-02-07	1
81017	4811	40481087	1973-05-26	1973-06-02	1
46384	2765	4113008	1952-12-11	1953-01-01	1
5455	321	4112343	1994-02-04	1994-02-15	1
44058	2622	40481087	2008-01-01	2008-01-15	1
58909	3501	4112343	1949-12-25	1950-01-07	1
88489	5265	81151	1982-08-21	1982-09-25	1
19804	1193	4218389	1959-05-25	1959-06-15	1
74048	4403	260139	1969-02-21	1969-03-07	1
46722	2782	28060	1956-01-04	1956-01-15	1
28282	1672	40481087	1979-11-26	1979-12-10	1
30742	1820	78272	1995-04-30	1995-05-14	1
49720	2944	80180	1997-09-13	1997-09-14	1
73336	4365	372328	1963-06-11	1964-05-04	1
41207	2450	40481087	1993-11-15	1993-12-06	1
15999	948	4112343	1976-08-16	1976-08-25	1
17235	1033	4112343	1993-06-21	1993-06-29	1
15790	935	40481087	1974-01-22	1974-02-05	1
57342	3407	4310024	2003-11-11	2003-11-12	1
80025	4749	81151	2007-03-29	2007-04-26	1
51028	3025	257012	1970-03-16	1970-03-17	1
43393	2588	260139	2010-09-28	2010-10-12	1
25300	1510	40481087	2016-07-11	2016-08-01	1
50406	2985	40481087	1968-11-29	1968-12-06	1
71178	4225	372328	1980-04-29	1980-06-12	1
46618	2777	40481087	1978-09-12	1978-09-19	1
46507	2771	378001	1972-03-16	1972-05-15	1
24571	1467	40481087	1942-11-01	1942-11-15	1
21168	1271	40481087	1971-01-24	1971-01-31	1
31304	1852	40481087	1995-07-16	1995-08-06	1
35071	2084	4112343	1990-07-11	1990-07-19	1
44562	2654	78272	2004-08-09	2004-09-06	1
76974	4565	257012	1966-08-12	1966-08-13	1
48387	2868	4112343	1968-02-12	1968-02-24	1
48079	2857	40481087	2014-10-10	2014-10-24	1
50280	2976	4112343	1957-01-31	1957-02-09	1
73966	4398	4237458	1970-08-23	1970-11-21	1
49464	2927	4027663	1975-04-16	1975-04-17	1
55335	3280	80180	1986-12-18	1986-12-19	1
3329	191	40481087	1997-10-13	1997-10-20	1
40643	2418	372328	1975-12-23	1976-02-10	1
14792	871	4112343	1971-01-24	1971-02-06	1
72699	4325	28060	1969-12-10	1969-12-17	1
22534	1348	378419	1992-11-02	1992-11-03	1
52208	3093	40481087	1996-10-19	1996-11-09	1
17497	1053	372328	1981-06-12	1981-09-04	1
75880	4505	40481087	1957-03-30	1957-04-13	1
61148	3621	4113008	1973-12-15	1974-01-05	1
43703	2604	40481087	2015-06-02	2015-06-16	1
50480	2989	0	1987-06-16	1987-06-17	1
53046	3144	40481087	1997-08-28	1997-09-11	1
81018	4811	40481087	1995-11-11	1995-11-25	1
46385	2765	4134304	1946-11-15	1947-02-13	1
5456	321	4112343	1997-10-01	1997-10-10	1
44059	2622	28060	1945-06-15	1945-06-28	1
58910	3501	4134304	1994-03-19	1994-06-18	1
88490	5265	4112343	2018-12-21	2018-12-29	1
19805	1193	78272	2017-08-01	2017-08-15	1
74049	4403	261325	1989-05-13	1989-05-14	1
46723	2782	80180	1955-03-30	1955-03-31	1
28283	1672	40481087	2004-02-06	2004-02-13	1
30743	1820	195588	2008-01-31	2008-03-18	1
49721	2944	81151	1969-10-10	1969-11-14	1
73337	4365	380378	1982-07-15	1982-07-16	1
44108	2626	28060	2003-12-20	2004-01-02	1
16000	948	4152936	2007-12-29	2008-01-19	1
17236	1033	40481087	1981-01-28	1981-02-11	1
15791	935	40481087	1983-10-25	1983-11-08	1
57343	3407	40481087	2013-07-26	2013-08-09	1
80026	4749	372328	1994-04-08	1994-12-24	1
51029	3025	260139	1992-08-31	1992-09-07	1
43394	2588	439777	2016-08-17	2016-08-18	1
25301	1510	260139	2005-09-05	2005-09-12	1
50407	2985	40481087	1981-02-07	1981-02-21	1
71179	4225	372328	1983-04-28	1984-03-15	1
46619	2777	40481087	1982-08-08	1982-08-22	1
46508	2771	381316	1991-10-18	1991-10-19	1
24572	1467	40481087	1974-02-22	1974-03-01	1
21169	1271	40481087	2011-07-07	2011-07-14	1
31305	1852	40481087	2003-12-19	2004-01-09	1
35072	2084	40481087	1994-04-06	1994-04-27	1
44563	2654	81151	1988-12-19	1989-01-09	1
76975	4565	260139	2004-11-03	2004-11-17	1
48388	2868	4329847	2016-02-10	2016-02-11	1
48080	2857	260139	1965-11-02	1965-11-16	1
50281	2976	4112343	1981-04-05	1981-04-14	1
73967	4398	40481087	1964-08-25	1964-09-01	1
49465	2927	4059173	2010-09-13	2010-12-12	1
55336	3280	260139	1974-02-15	1974-03-01	1
3330	191	40481087	1999-09-17	1999-09-24	1
40644	2418	40481087	1986-02-23	1986-03-02	1
14793	871	40481087	2011-03-22	2011-04-12	1
72700	4325	260139	1996-08-30	1996-09-06	1
22535	1348	4112343	1972-06-01	1972-06-11	1
52209	3093	40481087	2000-04-18	2000-04-25	1
17498	1053	4029498	1982-01-28	1982-01-29	1
75881	4505	40481087	2007-09-26	2007-10-10	1
61149	3621	4142905	1989-01-16	1989-03-17	1
43704	2604	80180	1997-08-12	1997-08-13	1
50481	2989	4294548	1976-06-02	1976-06-09	1
53047	3144	40481087	2003-08-06	2003-08-20	1
81019	4811	40481087	2003-07-07	2003-07-28	1
46386	2765	40481087	1935-09-20	1935-10-11	1
5457	321	4156265	1978-03-02	1978-03-23	1
44060	2622	192671	1975-05-22	1975-05-23	1
58911	3501	4218389	1968-02-17	1968-03-23	1
88491	5265	4113008	2008-03-12	2008-04-02	1
19806	1193	260139	1979-12-05	1979-12-12	1
74050	4403	4112343	1942-01-26	1942-02-06	1
46724	2782	313217	1977-01-26	1977-01-27	1
30974	1837	80180	2000-07-22	2000-07-23	1
30744	1820	4112343	1986-08-08	1986-08-15	1
49722	2944	81151	1991-07-02	1991-08-06	1
73338	4365	381316	2016-01-10	2016-01-11	1
44109	2626	260139	1974-03-08	1974-03-15	1
16001	948	4237458	1972-05-15	1972-07-14	1
17237	1033	40481087	2004-04-03	2004-04-17	1
15792	935	40481087	1939-12-09	1939-12-30	1
57344	3407	81151	2010-04-30	2010-05-21	1
80027	4749	40479768	2014-02-18	2014-03-27	1
51030	3025	372328	1948-08-26	1948-11-01	1
43395	2588	4059173	1978-06-07	1978-09-05	1
25302	1510	372328	1959-10-28	1960-01-10	1
50408	2985	40481087	1983-01-21	1983-02-11	1
71180	4225	78272	2002-09-01	2002-10-06	1
46620	2777	40481087	2014-12-10	2014-12-31	1
46509	2771	4029498	1972-09-01	1972-09-02	1
24573	1467	40481087	1983-10-11	1983-10-25	1
21170	1271	40481087	2015-11-26	2015-12-03	1
31306	1852	81151	1989-05-12	1989-06-02	1
35073	2084	80180	1999-08-17	1999-08-18	1
44564	2654	260139	1955-01-06	1955-01-20	1
76976	4565	378001	1976-02-08	1976-03-09	1
48389	2868	40481087	1985-07-09	1985-07-16	1
48081	2857	4134304	1980-10-12	1980-12-10	1
50282	2976	4112343	2011-01-24	2011-02-05	1
73968	4398	40481087	2008-09-13	2008-10-04	1
49466	2927	4112343	1994-11-18	1994-11-29	1
55337	3280	4112343	1968-12-24	1968-12-31	1
6175	364	260139	1951-05-12	1951-05-19	1
40645	2418	40481087	2000-07-20	2000-08-03	1
14794	871	81151	2002-10-20	2002-11-03	1
72701	4325	40481087	1967-08-15	1967-08-29	1
22536	1348	4112343	1997-11-11	1997-11-21	1
52210	3093	40481087	2006-06-02	2006-06-09	1
17499	1053	4059173	2001-11-12	2002-02-10	1
75882	4505	381316	1980-12-16	1980-12-17	1
61150	3621	4156265	1950-01-15	1950-01-29	1
43705	2604	260139	1978-10-03	1978-10-10	1
50482	2989	40479422	1960-01-28	1960-03-05	1
54596	3236	28060	1942-03-14	1942-03-23	1
81020	4811	40481087	2007-10-10	2007-10-17	1
46387	2765	28060	1956-07-26	1956-08-03	1
5458	321	40481087	1964-09-06	1964-09-13	1
44061	2622	260139	1991-08-04	1991-08-18	1
58912	3501	40481087	1956-04-26	1956-05-11	1
88492	5265	4152936	1970-12-08	1970-12-22	1
19807	1193	378001	1975-01-04	1975-02-03	1
74051	4403	4152936	1949-10-14	1949-11-04	1
46725	2782	4112343	1932-07-28	1932-08-04	1
30975	1837	260139	1971-06-07	1971-06-21	1
30745	1820	4156265	1992-07-23	1992-08-13	1
49723	2944	260139	1965-12-01	1965-12-15	1
73339	4365	4029498	1982-07-15	1982-07-16	1
44110	2626	372328	1965-04-22	1965-06-08	1
16002	948	40481087	1989-01-01	1989-01-22	1
17238	1033	40481087	2014-09-12	2014-10-03	1
15793	935	30753	1971-08-29	1971-08-30	1
57345	3407	4112343	1984-01-31	1984-02-08	1
80028	4749	40481087	1979-11-23	1979-12-14	1
51031	3025	4112343	1994-03-10	1994-03-18	1
43396	2588	4218389	1972-06-03	1972-07-08	1
25303	1510	4112343	1977-09-24	1977-10-07	1
50409	2985	40481087	1993-02-07	1993-02-14	1
71181	4225	4112343	1996-12-15	1996-12-28	1
46621	2777	4283893	1978-01-31	1978-03-07	1
46510	2771	4112343	1917-12-06	1917-12-16	1
26336	1565	372328	1968-05-25	1968-08-18	1
21171	1271	28060	1979-04-06	1979-04-19	1
31307	1852	4294548	2010-07-12	2010-11-22	1
35074	2084	81151	1984-03-23	1984-04-06	1
44565	2654	260139	1968-05-21	1968-06-04	1
76977	4565	4112343	1993-11-08	1993-11-21	1
48390	2868	0	2016-02-10	2016-02-11	1
48082	2857	40481087	1969-02-08	1969-02-22	1
50283	2976	4266809	1995-09-26	1995-09-27	1
73969	4398	28060	1964-01-25	1964-02-03	1
49467	2927	4266809	1982-07-03	1982-07-04	1
55338	3280	4237458	1954-09-25	1954-10-25	1
6176	364	260139	1988-05-05	1988-05-12	1
41353	2462	80180	2002-02-10	2002-02-11	1
14795	871	195588	2014-01-06	2014-02-24	1
72702	4325	40481087	1972-10-27	1972-11-03	1
22537	1348	4294548	1941-05-10	1941-05-31	1
52211	3093	260139	2016-07-30	2016-08-06	1
17500	1053	4218389	1989-01-21	1989-02-18	1
75883	4505	4109685	1985-04-26	1985-05-10	1
61151	3621	4283893	1991-04-24	1991-05-29	1
43706	2604	372328	1957-10-15	1958-02-15	1
50483	2989	40481087	1954-11-29	1954-12-06	1
54597	3236	260139	1940-04-17	1940-05-01	1
81021	4811	0	1995-04-10	1995-04-11	1
46388	2765	81151	1949-11-29	1949-12-27	1
5459	321	40481087	1991-04-21	1991-05-12	1
44062	2622	4112343	1933-05-27	1933-06-05	1
58913	3501	40481087	1964-04-05	1964-04-27	1
88493	5265	40481087	2016-04-28	2016-05-05	1
19808	1193	4142905	1951-11-14	1952-01-13	1
74052	4403	4294548	1947-10-02	1948-06-17	1
46726	2782	4112343	1940-11-04	1940-11-11	1
30976	1837	4059173	1976-05-17	1976-06-16	1
30746	1820	4294548	2015-07-14	2015-08-04	1
49724	2944	4112343	2000-01-03	2000-01-13	1
73340	4365	4112343	1952-01-21	1952-02-01	1
44111	2626	372328	2018-05-07	2018-07-31	1
16003	948	81893	1997-07-06	1997-07-07	1
17239	1033	40481087	2015-01-10	2015-01-17	1
15794	935	192671	1972-07-04	1972-07-05	1
57346	3407	40481087	2016-05-04	2016-05-25	1
80029	4749	40481087	2003-05-15	2003-06-05	1
51032	3025	4294548	1986-11-01	1986-12-27	1
43397	2588	28060	1994-09-04	1994-09-17	1
25304	1510	4310024	2000-05-20	2000-05-21	1
50410	2985	40481087	2016-03-02	2016-03-09	1
71182	4225	40481087	2003-03-11	2003-03-18	1
46622	2777	40481087	1960-07-05	1960-07-12	1
46511	2771	4112343	1994-05-12	1994-05-21	1
26337	1565	4001336	1971-03-11	1971-04-10	1
21172	1271	260139	1991-07-23	1991-07-30	1
31308	1852	4294548	2011-11-24	2011-12-29	1
35075	2084	195588	2002-01-13	2002-02-24	1
44566	2654	260139	1980-06-16	1980-06-23	1
76978	4565	4155034	1955-12-13	1955-12-27	1
48391	2868	80180	2003-10-15	2003-10-16	1
48083	2857	40481087	2005-08-09	2005-08-23	1
50284	2976	4285898	1995-01-29	1995-01-30	1
73970	4398	28060	1965-01-31	1965-02-13	1
49468	2927	40481087	1972-10-31	1972-11-21	1
55339	3280	28060	2000-07-26	2000-08-05	1
6177	364	260139	2016-09-10	2016-09-24	1
41354	2462	260139	1966-01-17	1966-01-24	1
14796	871	260139	2001-09-03	2001-09-10	1
72703	4325	40481087	1980-12-18	1981-01-08	1
22538	1348	40481087	1919-07-15	1919-08-05	1
52212	3093	4109685	1973-05-16	1973-06-06	1
17501	1053	4296204	2017-03-23	2017-04-13	1
75884	4505	4112343	1951-11-04	1951-11-15	1
61152	3621	40481087	1977-11-07	1977-11-28	1
43707	2604	4112343	1989-08-23	1989-09-05	1
50484	2989	40481087	1993-01-16	1993-01-23	1
54598	3236	260139	1987-03-27	1987-04-10	1
81022	4811	260139	1962-09-16	1962-09-23	1
46389	2765	81151	2016-12-06	2017-01-03	1
5460	321	40481087	1991-08-19	1991-08-26	1
44063	2622	40481087	1946-09-20	1946-10-11	1
58914	3501	40481087	1967-02-15	1967-03-01	1
88494	5265	80180	2003-03-05	2003-03-06	1
19809	1193	4296204	1984-10-27	1984-12-01	1
74053	4403	40481087	1955-05-09	1955-05-23	1
46727	2782	4112343	1967-09-04	1967-09-13	1
30977	1837	4084167	1964-01-23	1964-01-23	1
30747	1820	260139	1989-08-25	1989-09-08	1
49725	2944	4310024	1996-02-21	1996-02-22	1
73341	4365	40481087	1968-12-21	1969-01-04	1
44112	2626	4112343	1988-07-01	1988-07-09	1
16004	948	4027663	1991-09-11	1991-09-12	1
17240	1033	40481087	2016-05-20	2016-06-03	1
15795	935	378001	1932-05-30	1932-06-29	1
59693	3541	78272	1991-04-01	1991-04-15	1
80030	4749	40481087	2011-07-22	2011-07-29	1
51033	3025	40481087	1961-12-13	1961-12-27	1
43398	2588	81151	2016-07-13	2016-07-27	1
25305	1510	40479422	1978-08-08	1978-10-14	1
51946	3081	260139	1969-09-20	1969-09-27	1
73004	4343	257012	1988-06-25	1988-06-26	1
46623	2777	40481087	2012-10-13	2012-10-20	1
46512	2771	40481087	1947-04-09	1947-04-30	1
26338	1565	4132546	1971-03-11	1971-03-12	1
21173	1271	4112343	1991-09-17	1991-09-27	1
31309	1852	40481087	2001-09-11	2001-09-25	1
35076	2084	260139	1986-06-03	1986-06-17	1
44567	2654	372328	1949-11-02	1950-10-26	1
76979	4565	4156265	2018-11-24	2018-12-15	1
48609	2882	80180	2005-09-21	2005-09-22	1
48084	2857	28060	1968-03-22	1968-03-30	1
50285	2976	40481087	1993-01-22	1993-01-29	1
73971	4398	28060	2013-08-17	2013-08-28	1
49469	2927	40481087	1988-05-21	1988-06-04	1
55340	3280	80502	2011-11-10	2011-11-11	1
6178	364	372328	1950-02-13	1950-07-30	1
41355	2462	372328	1964-09-22	1965-03-14	1
14797	871	378001	1981-08-11	1981-10-10	1
72704	4325	78272	1982-11-03	1982-11-17	1
22539	1348	40481087	1924-09-29	1924-10-06	1
52213	3093	4283893	2012-04-25	2012-06-27	1
17502	1053	40481087	1995-03-24	1995-04-14	1
75885	4505	40481087	1937-06-22	1937-07-13	1
61153	3621	260139	1924-11-29	1924-12-13	1
43708	2604	4112343	2000-04-28	2000-05-11	1
50485	2989	80180	1998-02-27	1998-02-28	1
54599	3236	4112343	1931-08-25	1931-09-07	1
81023	4811	260139	2006-08-21	2006-08-29	1
46390	2765	372328	1937-06-05	1937-10-26	1
5461	321	40481087	1999-11-09	1999-11-23	1
44064	2622	40481087	1976-03-01	1976-03-22	1
58915	3501	40481087	2005-03-20	2005-04-04	1
88495	5265	4112343	2007-08-23	2007-09-05	1
19810	1193	40481087	1957-10-22	1957-11-12	1
74054	4403	40481087	1961-01-16	1961-01-30	1
46728	2782	4112343	1983-03-26	1983-04-03	1
30978	1837	4278672	1965-02-16	1965-05-17	1
30748	1820	4112343	1999-05-22	1999-06-04	1
49726	2944	40481087	1962-04-27	1962-05-04	1
73342	4365	40481087	1974-07-10	1974-07-31	1
44113	2626	4134304	1976-01-25	1976-03-25	1
16005	948	4112343	1989-12-27	1990-01-04	1
17241	1033	81151	1977-03-06	1977-04-10	1
15796	935	381316	1994-05-25	1994-05-26	1
59694	3541	80180	2010-07-17	2010-07-18	1
80031	4749	4112343	1986-07-11	1986-07-20	1
51034	3025	40481087	1991-10-28	1991-11-04	1
43399	2588	260139	1981-05-01	1981-05-08	1
25306	1510	40481087	1998-05-11	1998-06-01	1
51947	3081	260139	2005-10-30	2005-11-06	1
73005	4343	4112343	1960-04-23	1960-05-02	1
46624	2777	40481087	2016-07-31	2016-08-07	1
46513	2771	0	1955-11-11	1955-11-12	1
26339	1565	4283893	1995-05-27	1995-09-16	1
21929	1316	40481087	1972-01-29	1972-02-19	1
31310	1852	40481087	2016-12-09	2016-12-23	1
35077	2084	260139	1997-04-29	1997-05-06	1
44568	2654	375671	1979-05-04	1979-07-03	1
76980	4565	4296205	1961-06-28	1961-07-19	1
48610	2882	260139	1990-09-06	1990-09-13	1
48085	2857	78272	1989-07-27	1989-08-17	1
51123	3030	257012	2015-10-16	2015-10-17	1
73972	4398	260139	1996-09-05	1996-09-19	1
49470	2927	40481087	2007-08-02	2007-08-09	1
55341	3280	372328	1957-03-15	1957-08-01	1
6179	364	4112343	1973-02-08	1973-02-17	1
41356	2462	4112343	1980-10-24	1980-11-04	1
14798	871	4027663	1993-01-11	1993-01-12	1
72705	4325	260139	1972-09-14	1972-09-21	1
22540	1348	40481087	1959-10-20	1959-10-27	1
52214	3093	40481087	1999-05-05	1999-05-19	1
17503	1053	40481087	1998-01-06	1998-01-27	1
75886	4505	40481087	1944-08-13	1944-08-27	1
61154	3621	260139	1959-02-28	1959-03-07	1
43709	2604	4152936	1962-01-08	1962-01-22	1
50486	2989	81893	1996-03-09	1996-03-10	1
54600	3236	4156265	1994-06-07	1994-06-21	1
81024	4811	4112343	1962-06-17	1962-06-30	1
46391	2765	372328	1938-04-24	1939-05-02	1
5462	321	40481087	2019-01-21	2019-02-11	1
44065	2622	195588	1975-12-12	1976-01-14	1
58916	3501	80180	1985-03-09	1985-03-10	1
88496	5265	4112343	2011-04-20	2011-05-01	1
19811	1193	78272	1953-09-04	1953-09-18	1
74055	4403	40481087	1981-10-31	1981-11-07	1
46729	2782	4112343	1995-04-01	1995-04-14	1
30979	1837	4283893	1968-08-30	1968-10-18	1
30749	1820	40481087	1984-03-13	1984-03-20	1
49727	2944	40481087	2001-02-16	2001-02-23	1
73343	4365	0	1982-07-15	1982-07-16	1
44114	2626	40481087	1986-07-03	1986-07-10	1
16006	948	4142905	2000-11-05	2000-12-05	1
17242	1033	439777	1999-07-29	1999-07-30	1
15797	935	4112343	1991-10-12	1991-10-20	1
59695	3541	81151	1987-04-08	1987-04-22	1
80032	4749	40481087	1981-07-12	1981-08-02	1
51035	3025	134438	1971-11-27	1974-04-20	1
43400	2588	4112343	1999-03-09	1999-03-19	1
25307	1510	40481087	2019-02-26	2019-03-05	1
51948	3081	260139	2015-09-03	2015-09-17	1
73006	4343	4112343	1979-02-16	1979-02-28	1
46625	2777	40481087	2017-04-13	2017-05-04	1
46514	2771	80180	1946-09-23	1946-09-24	1
26340	1565	81893	1998-12-29	1998-12-30	1
21930	1316	28060	1963-09-29	1963-10-08	1
31311	1852	28060	1976-07-22	1976-07-29	1
35078	2084	4116491	2001-11-08	2001-12-23	1
44569	2654	4156265	1989-12-05	1989-12-26	1
76981	4565	40481087	1945-09-11	1945-09-25	1
48611	2882	4112343	1988-04-20	1988-04-30	1
48086	2857	80180	2006-03-16	2006-03-17	1
51124	3030	4155034	2013-08-26	2013-09-09	1
73973	4398	4218389	1998-04-28	1998-05-26	1
49471	2927	40481087	2009-05-08	2009-05-29	1
55342	3280	372328	2001-05-12	2001-09-13	1
6180	364	40481087	2004-01-19	2004-01-26	1
41357	2462	4112343	1994-10-26	1994-11-08	1
14799	871	4035415	2001-10-25	2001-11-24	1
72706	4325	260139	2014-08-19	2014-09-02	1
22541	1348	40481087	1960-08-01	1960-08-08	1
52215	3093	40481087	2017-06-08	2017-06-15	1
17504	1053	0	1982-01-28	1982-01-29	1
75887	4505	40481087	1959-12-05	1959-12-12	1
61155	3621	260139	1993-11-01	1993-11-15	1
43710	2604	40481087	2011-01-26	2011-02-02	1
50487	2989	378001	1967-11-24	1968-01-23	1
54601	3236	4296205	1958-10-29	1958-11-26	1
81025	4811	4112343	1969-05-23	1969-05-30	1
46392	2765	378001	2015-12-12	2016-02-10	1
5463	321	28060	1989-08-17	1989-08-27	1
44066	2622	378001	1997-09-08	1997-10-08	1
58917	3501	260139	1962-08-16	1962-08-23	1
19812	1193	81151	1980-12-03	1980-12-17	1
74056	4403	81151	1989-09-15	1989-10-20	1
46730	2782	4113008	1945-07-03	1945-07-24	1
30980	1837	260139	1961-01-10	1961-01-17	1
30750	1820	40481087	1995-05-17	1995-05-24	1
49728	2944	40481087	2002-08-25	2002-09-15	1
73344	4365	28060	1993-12-09	1993-12-20	1
44115	2626	78272	2014-01-05	2014-01-19	1
16007	948	40481087	1983-11-26	1983-12-03	1
17243	1033	40481087	1978-03-06	1978-03-13	1
15798	935	4283893	1992-08-28	1992-10-30	1
59696	3541	4112343	2013-07-14	2013-07-24	1
80033	4749	28060	1983-12-09	1983-12-22	1
51036	3025	260139	2001-01-14	2001-01-21	1
43401	2588	4155034	1969-06-05	1969-06-19	1
25308	1510	257012	1995-02-21	1995-02-22	1
51949	3081	381316	2011-09-07	2011-09-08	1
73007	4343	4112343	1997-01-11	1997-01-21	1
46626	2777	4149245	1985-11-06	1985-12-13	1
46515	2771	260139	1913-07-30	1913-08-06	1
26341	1565	257012	1995-07-08	1995-07-09	1
21931	1316	260139	1998-03-22	1998-03-29	1
31312	1852	257012	2010-08-23	2011-12-29	1
35079	2084	40481087	2003-06-16	2003-07-07	1
44570	2654	4283893	1985-01-04	1985-02-22	1
76982	4565	40481087	2001-04-29	2001-05-20	1
48612	2882	40481087	2004-08-14	2004-09-04	1
48087	2857	260139	1969-08-02	1969-08-09	1
51125	3030	4294548	2015-08-14	2015-11-20	1
73974	4398	4283893	1986-07-01	1986-10-14	1
49800	2947	80180	2018-09-28	2018-09-29	1
55343	3280	4218389	1982-12-02	1982-12-30	1
6181	364	40481087	2012-11-15	2012-11-29	1
41358	2462	40481087	2009-08-17	2009-09-07	1
14800	871	40481087	1995-01-03	1995-01-10	1
72707	4325	40481087	1970-11-18	1970-12-09	1
22542	1348	40481087	1971-09-16	1971-10-07	1
52216	3093	260139	2011-02-28	2011-03-14	1
17505	1053	28060	1981-02-04	1981-02-13	1
75888	4505	28060	1981-05-21	1981-06-03	1
61156	3621	378419	1991-05-11	1991-05-12	1
46157	2752	28060	2008-06-09	2008-06-20	1
50488	2989	4027663	1986-06-15	1986-06-16	1
54602	3236	40481087	1943-03-31	1943-04-14	1
81026	4811	4113008	2011-02-17	2011-03-10	1
46393	2765	4112343	1936-05-15	1936-05-25	1
5464	321	372328	1962-05-11	1962-07-22	1
44067	2622	4112343	1971-02-08	1971-02-19	1
58918	3501	4112343	2014-10-13	2014-10-22	1
19813	1193	260139	1975-04-15	1975-04-29	1
74057	4403	257012	1948-01-01	1948-01-02	1
46731	2782	4294548	1997-11-27	1998-05-14	1
30981	1837	260139	1964-01-04	1964-01-18	1
30751	1820	40481087	2001-04-30	2001-05-07	1
49729	2944	260139	1981-09-02	1981-09-16	1
73345	4365	80180	1991-05-29	1991-05-30	1
44116	2626	260139	1994-07-30	1994-08-13	1
16008	948	40481087	1991-07-18	1991-08-08	1
17244	1033	40481087	1979-07-12	1979-08-02	1
15799	935	4296204	1976-11-05	1976-11-19	1
59697	3541	4146173	2015-09-11	2015-10-11	1
80034	4749	372328	1979-11-14	1980-10-18	1
51037	3025	317576	1949-10-31	1949-11-01	1
43402	2588	40481087	1989-04-29	1989-05-13	1
25309	1510	260139	1992-11-14	1992-11-21	1
51950	3081	4035415	1985-09-21	1985-11-20	1
73008	4343	4112343	2004-08-14	2004-08-25	1
46627	2777	4155034	1999-05-03	1999-05-17	1
46516	2771	321042	1955-11-11	1955-11-12	1
26342	1565	260139	1998-11-25	1998-12-09	1
21932	1316	372328	1949-10-21	1949-12-27	1
31313	1852	4283893	1975-09-28	1975-10-26	1
35080	2084	260139	1977-04-25	1977-05-09	1
44571	2654	40479422	1983-04-13	1983-06-19	1
76983	4565	40481087	2004-11-09	2004-11-16	1
48613	2882	4051466	1975-05-19	1993-12-24	1
48088	2857	260139	1984-11-27	1984-12-04	1
51126	3030	40481087	1993-09-11	1993-09-18	1
73975	4398	40481087	2009-04-09	2009-04-16	1
49801	2947	40481087	1983-07-13	1983-07-20	1
55344	3280	4294548	1951-11-21	1952-04-02	1
6182	364	40481087	2013-11-03	2013-11-17	1
41359	2462	260139	2008-06-11	2008-06-18	1
14801	871	30753	2002-12-05	2002-12-06	1
72708	4325	40481087	1972-08-09	1972-08-23	1
22543	1348	40481087	2001-08-09	2001-08-30	1
52217	3093	4112343	1973-03-19	1973-03-31	1
17506	1053	80180	2015-03-11	2015-03-12	1
75889	4505	4112343	2015-11-02	2015-11-09	1
61157	3621	4112343	1945-09-05	1945-09-13	1
46158	2752	81151	1967-03-22	1967-04-12	1
50489	2989	4112343	1963-09-04	1963-09-17	1
54603	3236	40481087	1964-02-26	1964-03-18	1
81027	4811	4218389	1994-03-13	1994-04-18	1
46394	2765	4112343	2007-08-26	2007-09-04	1
5465	321	4112343	1998-10-08	1998-10-19	1
44068	2622	4116491	1982-01-12	1982-03-09	1
58919	3501	4146173	2005-02-03	2005-03-05	1
19814	1193	4112343	1977-05-16	1977-05-25	1
74058	4403	260139	1982-07-12	1982-07-26	1
46732	2782	4296205	1964-01-07	1964-01-28	1
30982	1837	260139	1966-05-11	1966-05-18	1
30752	1820	40481087	2011-02-20	2011-02-27	1
49730	2944	260139	1998-03-08	1998-03-15	1
73346	4365	378001	1983-06-19	1983-07-19	1
44117	2626	260139	2007-12-19	2008-01-02	1
16009	948	260139	1974-05-09	1974-05-23	1
17245	1033	28060	1982-03-25	1982-04-02	1
15800	935	4310024	1971-05-01	1971-05-02	1
59698	3541	40481087	1979-10-28	1979-11-18	1
80035	4749	4112343	2001-04-06	2001-04-18	1
51038	3025	378001	1955-09-26	1955-10-26	1
43403	2588	40481087	1991-09-05	1991-09-19	1
25310	1510	260139	1995-05-12	1995-05-26	1
51951	3081	4112343	1970-09-15	1970-09-27	1
73009	4343	4112343	2012-03-03	2012-03-13	1
46628	2777	40481087	1988-06-28	1988-07-12	1
46517	2771	372328	1915-01-19	1915-09-03	1
26343	1565	260139	2017-08-18	2017-09-01	1
21933	1316	372328	1950-08-24	1950-10-31	1
31314	1852	40481087	1992-12-30	1993-01-20	1
35081	2084	260139	2002-02-18	2002-02-25	1
44572	2654	40481087	1964-01-16	1964-02-06	1
76984	4565	28060	1963-03-30	1963-04-07	1
48614	2882	4112343	2006-07-08	2006-07-16	1
48089	2857	4146173	1988-08-01	1988-08-31	1
51127	3030	260139	1984-09-03	1984-09-17	1
73976	4398	80180	1998-07-27	1998-07-28	1
49802	2947	81893	2017-08-04	2017-08-05	1
55345	3280	40481087	1971-07-04	1971-07-18	1
6183	364	80180	1983-08-07	1983-08-08	1
41360	2462	260139	2011-10-24	2011-10-31	1
14802	871	372328	1968-12-03	1968-12-24	1
72709	4325	40481087	1974-03-05	1974-03-12	1
22544	1348	80180	1954-03-06	1954-03-07	1
52218	3093	4112343	1998-04-28	1998-05-11	1
17507	1053	260139	1978-08-19	1978-09-02	1
75890	4505	4155034	2016-04-02	2016-04-23	1
61158	3621	4112343	1956-06-06	1956-06-19	1
46159	2752	140673	2004-03-04	2004-03-05	1
50490	2989	4112343	1980-04-05	1980-04-13	1
54604	3236	80180	1958-05-12	1958-05-13	1
81028	4811	40481087	1964-10-08	1964-10-28	1
46395	2765	4112343	2013-08-17	2013-08-28	1
12549	743	80180	2011-11-08	2011-11-09	1
44069	2622	4152936	2018-05-21	2018-06-04	1
58920	3501	4152936	2017-12-27	2018-01-17	1
19815	1193	4142905	1976-01-29	1976-02-28	1
74059	4403	4109685	1962-06-29	1962-07-13	1
46733	2782	40481087	1923-04-09	1923-04-30	1
30983	1837	439777	1970-05-11	1970-05-12	1
30753	1820	40481087	2019-02-21	2019-02-28	1
49731	2944	4149245	2006-10-16	2006-12-22	1
73347	4365	4294548	1990-08-01	1990-09-12	1
44118	2626	260139	2018-08-15	2018-08-22	1
16010	948	372328	1964-05-13	1964-09-04	1
17246	1033	28060	1983-03-31	1983-04-13	1
18895	1137	260139	1956-11-18	1956-11-25	1
59699	3541	40481087	1995-05-04	1995-05-11	1
80036	4749	4112343	2015-08-05	2015-08-17	1
51039	3025	378001	1976-04-08	1976-05-08	1
44756	2666	4112343	1961-11-20	1961-11-29	1
25311	1510	372328	1963-09-21	1963-10-13	1
51952	3081	4294548	1987-10-01	1987-11-19	1
73010	4343	4283893	1997-04-17	1997-10-02	1
46629	2777	81151	1969-07-13	1969-08-03	1
46518	2771	4094814	1914-07-23	1914-10-21	1
26344	1565	440086	1972-09-11	1974-09-02	1
21934	1316	4027663	1982-10-18	1982-10-19	1
31315	1852	28060	1978-05-24	1978-06-06	1
35082	2084	260139	2003-10-19	2003-10-26	1
44573	2654	378001	1997-11-14	1997-12-14	1
76985	4565	260139	1972-02-18	1972-03-03	1
48615	2882	40481087	1984-10-11	1984-10-25	1
48090	2857	40481087	1980-11-26	1980-12-10	1
51128	3030	372328	1984-02-12	1984-07-24	1
73977	4398	81151	1962-03-03	1962-04-07	1
49803	2947	4218389	1981-10-12	1981-11-15	1
58617	3481	0	2001-05-12	2001-05-13	1
6184	364	192671	1983-08-31	1983-09-01	1
41361	2462	4218389	2018-08-15	2018-09-12	1
14803	871	4113008	1975-10-28	1975-11-11	1
72710	4325	40481087	1989-07-01	1989-07-08	1
22545	1348	260139	1931-07-07	1931-07-14	1
52219	3093	4112343	2003-11-13	2003-11-25	1
17508	1053	372328	1976-06-28	1976-07-12	1
75891	4505	40481087	1946-08-25	1946-09-08	1
61159	3621	4230399	1963-12-08	1964-03-07	1
46160	2752	257012	1993-12-18	1994-05-21	1
50491	2989	40481087	1974-10-26	1974-11-02	1
54605	3236	260139	1953-08-06	1953-08-20	1
81029	4811	40481087	2016-03-24	2016-04-14	1
46396	2765	4280726	1939-05-28	1953-05-26	1
12550	743	4112343	1991-02-22	1991-03-07	1
44070	2622	4237458	1998-10-03	1998-11-02	1
58921	3501	40481087	1988-03-17	1988-03-31	1
19816	1193	40481087	1976-11-09	1976-11-23	1
74060	4403	4112343	1945-09-19	1945-10-02	1
46734	2782	40481087	1989-07-25	1989-08-15	1
30984	1837	4112343	1973-11-14	1973-11-23	1
31894	1898	260139	1979-10-23	1979-10-30	1
49732	2944	4218389	1976-03-01	1976-03-22	1
73348	4365	4296205	1985-07-08	1985-07-29	1
44119	2626	4059173	1991-08-04	1991-09-03	1
16011	948	4294548	2003-10-09	2003-10-23	1
17247	1033	28060	1984-01-28	1984-02-06	1
18896	1137	4134304	1957-01-06	1957-04-06	1
59700	3541	4112343	1983-06-17	1983-06-27	1
80037	4749	40479422	1999-08-01	1999-10-07	1
51040	3025	4329847	2002-10-14	2002-10-15	1
44757	2666	4112343	1980-04-05	1980-04-12	1
25312	1510	4027663	1992-10-24	1992-10-25	1
51953	3081	40481087	1949-02-15	1949-03-08	1
73011	4343	40481087	2013-11-12	2013-11-26	1
46630	2777	81151	1988-12-27	1989-01-24	1
46519	2771	4112343	1995-09-15	1995-09-22	1
26345	1565	4112343	1972-02-07	1972-02-15	1
21935	1316	4112343	1989-06-25	1989-07-03	1
31316	1852	260139	2001-01-19	2001-01-26	1
35083	2084	260139	2015-10-25	2015-11-01	1
44574	2654	4112343	1951-08-27	1951-09-04	1
76986	4565	40481087	1951-09-02	1951-09-23	1
48616	2882	4048171	1974-05-19	1974-05-20	1
50860	3013	78272	1960-01-23	1960-02-13	1
51129	3030	375671	2002-01-26	2002-02-25	1
73978	4398	257012	1986-10-07	1986-10-08	1
49804	2947	4266809	2018-09-28	2018-09-29	1
58618	3481	317576	1995-06-24	1995-06-25	1
6185	364	260139	1948-01-20	1948-02-03	1
41362	2462	40481087	1988-12-20	1989-01-10	1
14804	871	4237458	1967-11-09	1968-01-08	1
72711	4325	81151	1971-10-18	1971-11-01	1
22546	1348	260139	1947-07-10	1947-07-24	1
52220	3093	4156265	1981-02-24	1981-03-10	1
18761	1131	260139	1982-03-16	1982-03-23	1
75892	4505	40481087	1949-08-18	1949-09-01	1
61160	3621	40481087	1976-01-05	1976-01-12	1
46161	2752	260139	2010-04-15	2010-04-29	1
50492	2989	81151	1956-04-13	1956-05-18	1
54606	3236	260139	2003-06-27	2003-07-12	1
81030	4811	260139	2002-10-31	2002-11-14	1
47898	2846	28060	1979-06-21	1979-06-29	1
12551	743	4112343	2015-03-01	2015-03-10	1
44071	2622	4266809	1975-03-17	1975-03-18	1
58922	3501	40481087	1991-09-20	1991-10-04	1
19817	1193	40481087	2004-04-07	2004-04-28	1
74061	4403	4112343	1959-09-23	1959-10-04	1
46735	2782	30753	1954-04-04	1954-04-05	1
30985	1837	4112343	1974-03-27	1974-04-04	1
31895	1898	4112343	1976-07-09	1976-07-20	1
49733	2944	4285898	1997-08-14	1997-08-15	1
73349	4365	40481087	1991-07-18	1991-08-01	1
44120	2626	4112343	1981-01-26	1981-02-06	1
16012	948	40479422	1964-05-20	1964-07-26	1
17248	1033	260139	1974-07-22	1974-08-05	1
18897	1137	4155034	1993-09-02	1993-09-23	1
59701	3541	4112343	1988-01-04	1988-01-13	1
80038	4749	40481087	2005-11-28	2005-12-12	1
51041	3025	40481087	1982-02-04	1982-02-18	1
44758	2666	4283893	2018-01-19	2018-02-16	1
25313	1510	4059173	1989-06-18	1989-08-17	1
51954	3081	40481087	1979-06-17	1979-07-08	1
73012	4343	80180	1995-06-20	1995-06-21	1
46631	2777	257012	1978-02-28	1978-03-07	1
46520	2771	4112343	2001-06-24	2001-07-03	1
26346	1565	40481087	1983-01-14	1983-01-28	1
21936	1316	4112343	2006-04-21	2006-04-29	1
31317	1852	372328	1977-04-26	1978-02-01	1
35084	2084	4112343	1981-07-16	1981-07-26	1
44575	2654	4134304	2010-03-09	2010-06-07	1
76987	4565	195588	1999-07-25	1999-09-05	1
48617	2882	4112343	1996-07-20	1996-07-28	1
50861	3013	81151	1971-11-12	1971-12-17	1
51130	3030	40481087	1989-06-13	1989-06-27	1
73979	4398	372328	1960-01-13	1960-03-26	1
49805	2947	4310024	2016-09-08	2016-09-09	1
58619	3481	4112343	2014-08-17	2014-08-24	1
6186	364	260139	2014-09-05	2014-09-12	1
41363	2462	40481087	1995-04-15	1995-04-29	1
14805	871	40481087	1966-12-20	1967-01-10	1
72712	4325	40481087	2010-06-23	2010-07-07	1
22547	1348	4112343	1914-06-18	1914-06-30	1
52221	3093	40481087	2008-02-04	2008-02-11	1
18762	1131	260139	1995-10-14	1995-10-21	1
75893	4505	40481087	1995-09-12	1995-09-26	1
61161	3621	40481087	1980-10-20	1980-11-10	1
46162	2752	372328	1960-01-15	1960-08-14	1
50493	2989	260139	1972-03-14	1972-03-28	1
54607	3236	4112343	2008-02-17	2008-02-24	1
81031	4811	4027663	1990-04-10	1990-04-11	1
47899	2846	80180	2017-08-28	2017-08-29	1
12552	743	4283893	2005-01-28	2005-09-02	1
44072	2622	4310024	1973-09-23	1973-09-24	1
58923	3501	28060	1961-01-27	1961-02-09	1
19818	1193	28060	1953-03-12	1953-03-25	1
74062	4403	4294548	1975-04-25	1975-06-13	1
46736	2782	81893	1953-09-06	1953-09-07	1
30986	1837	40481087	1965-06-21	1965-07-12	1
31896	1898	4112343	1987-02-06	1987-02-19	1
49734	2944	260139	2010-10-07	2010-10-21	1
73350	4365	260139	1989-08-27	1989-09-03	1
44121	2626	40481087	1972-03-21	1972-04-11	1
16013	948	40481087	1959-01-26	1959-02-16	1
17249	1033	40481087	1991-11-25	1991-12-02	1
18898	1137	4218389	1984-11-24	1984-12-29	1
59702	3541	4112343	1992-02-22	1992-03-05	1
80039	4749	80180	2011-05-25	2011-05-26	1
51884	3079	81151	2003-07-17	2003-07-31	1
44759	2666	40481087	1966-07-12	1966-07-19	1
25314	1510	4116491	1995-10-24	1995-11-25	1
51955	3081	375671	1990-07-27	1990-09-25	1
73013	4343	260139	1961-07-28	1961-08-11	1
46632	2777	260139	1975-06-04	1975-06-11	1
46521	2771	4156265	1961-08-27	1961-09-10	1
26347	1565	260139	1974-07-24	1974-08-07	1
21937	1316	40481087	1972-11-20	1972-12-11	1
31318	1852	372328	2018-10-29	2019-02-27	1
35085	2084	4116491	1995-10-02	1995-11-10	1
44576	2654	40481087	1955-08-09	1955-08-23	1
76988	4565	260139	1977-05-23	1977-05-30	1
48618	2882	40481087	1993-12-14	1994-01-04	1
50862	3013	260139	2007-05-02	2007-05-09	1
51131	3030	40481087	2005-01-24	2005-02-14	1
73980	4398	4112343	1994-05-14	1994-05-26	1
49806	2947	40481087	1997-05-16	1997-05-23	1
58620	3481	40481087	2002-04-03	2002-04-24	1
6187	364	4112343	1988-04-23	1988-05-04	1
41364	2462	40481087	2009-12-11	2009-12-18	1
14806	871	40481087	1979-04-13	1979-04-20	1
74093	4406	372328	1942-04-21	1942-08-01	1
22548	1348	4112343	1954-08-06	1954-08-17	1
52222	3093	40481087	2011-11-28	2011-12-19	1
18763	1131	4112343	1974-10-25	1974-11-03	1
75894	4505	40481087	2000-08-05	2000-08-26	1
61162	3621	28060	1932-03-07	1932-03-14	1
46163	2752	40481087	2016-08-31	2016-09-21	1
50494	2989	440448	1987-06-16	1987-06-17	1
54608	3236	4113008	1993-06-28	1993-07-12	1
81032	4811	4310024	1998-01-02	1998-01-03	1
47900	2846	260139	2003-11-21	2003-12-05	1
12553	743	40481087	1981-07-09	1981-07-23	1
44073	2622	40481087	1941-05-03	1941-05-10	1
58924	3501	30753	1983-12-15	1983-12-16	1
19819	1193	81151	1965-05-12	1965-05-26	1
74063	4403	40481087	1937-07-10	1937-07-17	1
46737	2782	260139	1952-02-01	1952-02-08	1
30987	1837	40481087	1968-12-25	1969-01-01	1
31897	1898	4112343	1998-12-09	1998-12-19	1
49735	2944	372328	1960-03-31	1960-05-08	1
73351	4365	4112343	2013-01-12	2013-01-23	1
44122	2626	40481087	2002-02-02	2002-02-23	1
16014	948	40481087	1999-04-06	1999-04-27	1
17250	1033	40481087	2013-12-02	2013-12-09	1
18899	1137	40481087	1957-12-16	1957-12-30	1
59703	3541	40481087	1973-06-04	1973-06-25	1
80040	4749	260139	1978-07-23	1978-08-06	1
51885	3079	257012	2006-09-17	2006-09-18	1
44760	2666	81151	1953-01-05	1953-02-02	1
25315	1510	4134304	1960-11-21	1961-01-20	1
51956	3081	4059173	1955-04-06	1955-06-05	1
73014	4343	260139	1994-01-28	1994-02-11	1
46633	2777	378001	1978-02-16	1978-04-17	1
46522	2771	40481087	1948-07-28	1948-08-11	1
26348	1565	40481087	1965-08-18	1965-09-08	1
21938	1316	40481087	1997-06-23	1997-07-14	1
31319	1852	375671	1983-08-12	1983-10-11	1
35086	2084	4156265	1979-06-27	1979-07-18	1
44577	2654	40481087	2014-03-31	2014-04-14	1
76989	4565	260139	1991-08-27	1991-09-03	1
52056	3086	260139	1980-05-27	1980-06-03	1
50863	3013	372328	1962-03-13	1962-06-19	1
51132	3030	40481087	2005-07-23	2005-08-13	1
73981	4398	4237458	1961-02-06	1961-05-07	1
49807	2947	4156265	1991-03-28	1991-04-19	1
58621	3481	81151	1987-02-03	1987-02-17	1
6188	364	4218389	2017-08-18	2017-09-08	1
41365	2462	260139	1989-09-19	1989-10-03	1
17053	1021	81151	1962-07-22	1962-08-12	1
74094	4406	4112343	1942-03-25	1942-04-07	1
22549	1348	4112343	1977-06-19	1977-07-01	1
54199	3215	4112343	1986-02-06	1986-02-18	1
18764	1131	4112343	1984-03-16	1984-03-27	1
75895	4505	80180	1981-10-23	1981-10-24	1
61163	3621	192671	1955-11-19	1955-11-20	1
46164	2752	80180	1992-03-27	1992-03-28	1
50495	2989	4112343	1962-02-27	1962-03-09	1
54609	3236	4218389	1979-12-06	1980-01-10	1
85759	5108	260139	1999-01-28	1999-02-11	1
47901	2846	4112343	1982-02-14	1982-02-25	1
12554	743	40481087	1995-09-21	1995-10-12	1
44074	2622	40481087	1992-10-01	1992-10-15	1
58925	3501	375671	1970-12-29	1971-01-28	1
19820	1193	81151	2000-02-11	2000-03-03	1
74064	4403	40481087	1955-07-29	1955-08-12	1
46738	2782	4112343	1935-12-19	1935-12-30	1
30988	1837	40481087	1972-08-20	1972-08-27	1
31898	1898	4112343	2005-09-26	2005-10-07	1
49736	2944	4027663	1987-01-24	1987-01-25	1
73352	4365	4146173	1990-04-04	1990-06-03	1
44123	2626	260139	1981-11-07	1981-11-14	1
16015	948	40481087	2010-06-27	2010-07-11	1
17251	1033	4112343	1983-05-16	1983-05-29	1
18900	1137	40481087	1987-04-07	1987-04-14	1
59704	3541	28060	2018-09-27	2018-10-08	1
80041	4749	4112343	1981-10-07	1981-10-17	1
51886	3079	440086	1947-04-17	1951-04-26	1
44761	2666	4112343	2016-12-21	2016-12-28	1
25316	1510	4283893	1995-01-10	1995-06-27	1
51957	3081	4112343	1974-09-08	1974-09-16	1
73015	4343	4112343	1989-03-11	1989-03-22	1
46634	2777	4218389	2015-10-20	2015-11-09	1
46523	2771	40481087	1952-06-30	1952-07-07	1
26349	1565	40481087	2010-08-03	2010-08-24	1
21939	1316	40481087	2002-11-21	2002-12-05	1
31320	1852	4112343	1987-03-22	1987-03-29	1
35087	2084	4283893	1971-09-17	1971-10-08	1
44578	2654	4027663	1972-10-27	1972-10-28	1
76990	4565	260139	1993-08-25	1993-09-01	1
52057	3086	372328	1971-07-12	1971-09-01	1
50864	3013	4109685	1952-06-19	1952-07-03	1
51133	3030	40481087	2007-04-11	2007-04-25	1
73982	4398	4294548	2008-04-25	2008-06-06	1
49808	2947	4218389	1998-09-09	1998-10-14	1
58622	3481	4329847	2015-04-04	2015-04-05	1
6189	364	40481087	1969-04-25	1969-05-16	1
41366	2462	4112343	1964-09-25	1964-10-05	1
17054	1021	81151	1993-09-10	1993-10-15	1
74095	4406	4112343	1960-07-19	1960-07-30	1
22550	1348	4112343	1985-11-29	1985-12-11	1
54200	3215	4112343	1992-12-16	1992-12-23	1
18765	1131	40481087	1973-06-21	1973-07-05	1
75896	4505	260139	1945-05-07	1945-05-21	1
61164	3621	261325	1969-07-12	1969-07-13	1
46165	2752	195588	1972-03-12	1972-04-22	1
50496	2989	4285898	1997-04-03	1997-04-04	1
54610	3236	4278672	1930-07-28	1930-10-26	1
85760	5108	40481087	1980-03-18	1980-04-08	1
47902	2846	4112343	1986-06-06	1986-06-16	1
12555	743	257012	1983-11-06	1983-11-07	1
44075	2622	40481087	2011-12-02	2011-12-23	1
58926	3501	378001	1974-11-08	1974-12-08	1
19821	1193	260139	1968-01-20	1968-02-03	1
74065	4403	40481087	1980-03-26	1980-04-02	1
46739	2782	4112343	1959-10-30	1959-11-11	1
30989	1837	40481087	1991-12-15	1991-12-22	1
31899	1898	80180	2011-08-14	2011-08-15	1
49737	2944	4218389	1970-11-09	1970-11-30	1
73353	4365	4156265	1976-03-12	1976-03-26	1
44124	2626	372328	1966-07-03	1966-12-06	1
16241	962	28060	1994-03-02	1994-03-10	1
17252	1033	4278672	1980-12-20	1981-03-20	1
18901	1137	40481087	1998-10-31	1998-11-07	1
59705	3541	260139	2014-08-18	2014-09-01	1
80042	4749	4112343	2003-08-10	2003-08-21	1
51887	3079	4112343	1972-04-14	1972-04-25	1
44762	2666	4152936	1955-12-19	1956-01-09	1
25317	1510	4285898	2001-11-11	2001-11-12	1
51958	3081	4112343	1984-09-07	1984-09-20	1
73016	4343	4113008	1963-04-11	1963-04-25	1
46635	2777	40481087	1975-04-27	1975-05-11	1
46524	2771	40481087	1955-12-27	1956-01-17	1
26350	1565	30753	1999-05-28	1999-05-29	1
21940	1316	40481087	2015-05-07	2015-05-21	1
32959	1958	80180	2010-08-01	2010-08-02	1
35088	2084	4296204	1976-08-27	1976-09-10	1
44579	2654	4112343	1985-06-09	1985-06-18	1
76991	4565	260139	2011-11-04	2011-11-11	1
52058	3086	4112343	1985-12-18	1985-12-25	1
50865	3013	4112343	1962-12-25	1963-01-02	1
51134	3030	40481087	2014-01-24	2014-02-14	1
73983	4398	40481087	1960-05-20	1960-06-10	1
49809	2947	30753	2017-11-02	2017-11-03	1
58623	3481	40481087	1984-02-28	1984-03-20	1
6190	364	4112343	1981-04-08	1981-04-20	1
41367	2462	4112343	2008-03-30	2008-04-12	1
17055	1021	4027663	1979-12-05	1979-12-06	1
74096	4406	4112343	1965-06-06	1965-06-14	1
22551	1348	40481087	1921-11-28	1921-12-05	1
54201	3215	4237458	1995-01-02	1995-02-01	1
18766	1131	260139	1988-01-22	1988-02-05	1
75897	4505	260139	1992-12-12	1992-12-26	1
61165	3621	372328	1923-07-06	1923-07-20	1
46166	2752	260139	1954-04-03	1954-04-10	1
50497	2989	40481087	1968-03-03	1968-03-24	1
54611	3236	4296204	1992-07-05	1992-08-02	1
85761	5108	40481087	2003-03-06	2003-03-20	1
47903	2846	4156265	1990-04-20	1990-05-04	1
12556	743	260139	1983-08-23	1983-09-06	1
45744	2724	80180	1999-11-23	1999-11-24	1
58927	3501	378001	1998-05-12	1998-07-11	1
19822	1193	260139	1998-06-07	1998-06-21	1
76084	4521	80180	1958-10-11	1958-10-12	1
46740	2782	40481087	1929-05-06	1929-05-27	1
30990	1837	40481087	2001-11-25	2001-12-16	1
31900	1898	372328	1973-11-21	1974-05-13	1
49738	2944	81151	1972-09-20	1972-10-18	1
73354	4365	40481087	1955-02-10	1955-02-24	1
44125	2626	4112343	1975-06-13	1975-06-23	1
16242	962	81893	1993-09-25	1993-09-26	1
19199	1151	260139	2014-01-26	2014-02-09	1
18902	1137	80180	1991-10-24	1991-10-25	1
59706	3541	40481087	1968-04-10	1968-04-24	1
81857	4859	196456	1971-06-05	1971-06-05	1
51888	3079	4134304	1979-05-24	1979-06-23	1
44763	2666	80180	1992-06-24	1992-06-25	1
25318	1510	40481087	1996-04-21	1996-05-12	1
51959	3081	4285898	1984-01-09	1984-01-10	1
73017	4343	4278672	1967-03-05	1967-04-04	1
46636	2777	40481087	2013-12-18	2014-01-08	1
46525	2771	40481087	2018-09-06	2018-09-13	1
26351	1565	80180	1999-11-24	1999-11-25	1
21941	1316	80180	1994-05-03	1994-05-04	1
32960	1958	260139	2008-03-10	2008-03-17	1
35089	2084	40481087	1965-09-29	1965-10-13	1
44580	2654	4112343	2007-03-29	2007-04-08	1
76992	4565	260139	2012-10-23	2012-10-30	1
52059	3086	4112343	2009-12-04	2009-12-13	1
50866	3013	4112343	1985-04-19	1985-04-28	1
51135	3030	80180	2018-07-25	2018-07-26	1
73984	4398	40481087	1980-08-04	1980-08-25	1
49810	2947	260139	1987-08-13	1987-08-20	1
58624	3481	40481087	1989-06-12	1989-07-03	1
6191	364	4156265	1961-03-10	1961-03-31	1
41368	2462	4112343	2018-05-23	2018-06-04	1
17056	1021	4294548	1975-01-18	1975-04-12	1
74097	4406	40481087	1945-07-22	1945-08-05	1
22552	1348	40481087	1971-04-20	1971-05-11	1
54202	3215	40481087	1988-12-10	1988-12-31	1
18767	1131	4142905	1979-01-30	1979-04-30	1
75898	4505	260139	1999-07-25	1999-08-08	1
61166	3621	375671	1937-06-22	1937-07-22	1
46167	2752	4112343	2018-09-29	2018-10-09	1
50498	2989	40481087	2014-02-09	2014-02-16	1
54612	3236	260139	1948-05-26	1948-06-09	1
85762	5108	80180	2002-05-28	2002-05-29	1
47904	2846	40481087	1999-09-19	1999-10-10	1
12557	743	372328	1977-01-25	1977-04-10	1
45745	2724	80502	2015-04-19	2015-04-20	1
58928	3501	4112343	1997-07-01	1997-07-10	1
19823	1193	4112343	1954-03-23	1954-04-03	1
76085	4521	192671	1958-11-18	1958-11-19	1
46741	2782	40481087	1943-02-18	1943-03-04	1
30991	1837	28060	2016-11-21	2016-11-28	1
31901	1898	4059173	1996-05-15	1996-06-14	1
49739	2944	81893	1997-01-16	1997-01-17	1
73355	4365	40481087	2011-06-23	2011-07-07	1
44126	2626	40481087	2001-08-22	2001-08-29	1
16243	962	192671	1995-07-09	1995-07-10	1
19200	1151	372328	1990-04-17	1990-11-06	1
18903	1137	192671	1992-01-13	1992-01-14	1
59707	3541	40481087	2006-11-14	2006-11-21	1
81858	4859	260139	1985-09-22	1985-10-06	1
51889	3079	4152936	1975-08-22	1975-09-12	1
44764	2666	260139	1955-07-25	1955-08-01	1
26820	1590	78272	1965-12-02	1965-12-23	1
51960	3081	40481087	1954-01-18	1954-02-01	1
73018	4343	40479422	1958-07-29	1958-10-04	1
50043	2960	4112343	1969-08-12	1969-08-23	1
46526	2771	196456	1974-09-02	1974-09-02	1
26352	1565	260139	1998-03-14	1998-03-28	1
21942	1316	81151	1968-05-05	1968-06-09	1
32961	1958	440086	1981-07-24	1981-11-20	1
35090	2084	40481087	1979-07-06	1979-07-27	1
44581	2654	4112343	2011-02-20	2011-03-05	1
76993	4565	4112343	1977-12-21	1977-12-28	1
52060	3086	28060	1982-05-27	1982-06-03	1
50867	3013	4294548	1953-09-17	1953-10-22	1
51136	3030	81151	2001-01-17	2001-01-31	1
73985	4398	40481087	1997-07-24	1997-08-14	1
49811	2947	4027663	2008-05-13	2008-05-14	1
58625	3481	40481087	1996-12-31	1997-01-21	1
6192	364	40481087	1961-05-18	1961-06-01	1
41369	2462	4296205	1997-09-29	1997-11-03	1
17057	1021	80180	1990-01-16	1990-01-17	1
74098	4406	40481087	1985-01-13	1985-02-03	1
22553	1348	28060	1979-07-22	1979-08-01	1
54203	3215	80180	2018-01-11	2018-01-12	1
18768	1131	4218389	1989-05-07	1989-06-04	1
75899	4505	4048171	1941-07-27	1993-07-13	1
62026	3667	4112343	1995-03-29	1995-04-10	1
46168	2752	40481087	1983-04-24	1983-05-01	1
50499	2989	28060	1958-10-02	1958-10-13	1
54613	3236	260139	1952-02-05	1952-02-12	1
85763	5108	81151	1967-08-20	1967-09-17	1
47905	2846	260139	2001-08-24	2001-08-31	1
12558	743	4283893	1983-10-09	1983-12-18	1
45746	2724	4112343	1955-08-19	1955-08-31	1
58929	3501	4296204	1995-07-13	1995-07-27	1
19824	1193	4112343	1987-01-05	1987-01-13	1
76086	4521	260139	1972-12-10	1972-12-17	1
46742	2782	28060	1922-02-08	1922-02-20	1
30992	1837	78272	1974-04-30	1974-05-28	1
31902	1898	4152936	1994-06-04	1994-06-25	1
49740	2944	257012	2013-09-14	2013-09-15	1
73356	4365	28060	1960-03-23	1960-04-05	1
44127	2626	40481087	2016-12-13	2017-01-03	1
16244	962	260139	1982-09-25	1982-10-09	1
19201	1151	4296204	2009-04-14	2009-05-12	1
18904	1137	260139	2010-05-15	2010-05-22	1
59708	3541	40481087	2016-12-05	2016-12-19	1
81859	4859	372328	1955-10-17	1956-04-01	1
51890	3079	40481087	1937-04-05	1937-04-26	1
44765	2666	4112343	1952-05-13	1952-05-25	1
26821	1590	260139	2003-05-20	2003-05-27	1
51961	3081	40481087	1954-10-08	1954-10-22	1
73019	4343	40481087	1979-07-01	1979-07-08	1
50044	2960	4283893	1988-08-25	1988-09-22	1
46527	2771	260139	1973-12-22	1973-12-29	1
26353	1565	4027663	1990-09-07	1990-09-08	1
21943	1316	260139	1949-12-22	1950-01-05	1
32962	1958	4310024	2007-12-15	2007-12-16	1
35091	2084	40481087	2011-06-04	2011-06-25	1
44582	2654	4283893	1959-07-12	1959-08-02	1
76994	4565	4278672	2016-11-04	2017-02-02	1
52061	3086	372328	1971-11-30	1972-03-01	1
50868	3013	40481087	1962-06-12	1962-06-26	1
51137	3030	134438	2002-08-20	2003-06-16	1
73986	4398	40481087	2010-12-14	2010-12-28	1
49812	2947	4048695	2000-07-05	2000-08-06	1
58626	3481	40481087	1999-09-16	1999-10-07	1
6193	364	40481087	1971-06-14	1971-07-05	1
41370	2462	40481087	1983-02-24	1983-03-17	1
17058	1021	81151	1992-09-24	1992-10-15	1
74099	4406	40481087	1999-05-26	1999-06-09	1
22554	1348	81151	1932-12-06	1932-12-27	1
54204	3215	134438	2002-10-04	2003-08-04	1
18769	1131	40481087	2013-06-05	2013-06-12	1
75900	4505	4059173	1938-04-12	1938-06-11	1
62027	3667	4112343	2014-07-11	2014-07-19	1
46169	2752	40481087	1986-02-22	1986-03-01	1
50500	2989	260139	1966-08-20	1966-09-03	1
54614	3236	313217	1982-12-24	1982-12-25	1
85764	5108	260139	1962-04-19	1962-05-04	1
47906	2846	372328	1977-10-11	1978-06-11	1
12559	743	4296205	2004-05-01	2004-05-15	1
45747	2724	4112343	1961-07-13	1961-07-26	1
58930	3501	40481087	1974-10-28	1974-11-18	1
19825	1193	4112343	1992-09-14	1992-09-26	1
76087	4521	4134304	1928-03-12	1928-05-11	1
46743	2782	78272	1936-08-21	1936-09-18	1
30993	1837	260139	1980-01-15	1980-01-29	1
31903	1898	4266809	2011-08-14	2011-08-15	1
49741	2944	260139	2016-05-30	2016-06-13	1
73357	4365	260139	1958-03-18	1958-04-01	1
44128	2626	28060	1968-11-03	1968-11-15	1
16245	962	260139	1989-09-15	1989-09-29	1
19202	1151	80180	2019-06-06	2019-06-07	1
18905	1137	4043241	2007-10-19	2007-10-20	1
59709	3541	260139	1998-10-25	1998-11-08	1
81860	4859	4112343	1958-09-02	1958-09-09	1
51891	3079	40481087	1982-03-01	1982-03-08	1
44766	2666	4112343	1954-08-15	1954-08-25	1
26822	1590	4059173	2014-08-23	2014-10-22	1
51962	3081	28060	1957-06-27	1957-07-08	1
73020	4343	40481087	1990-04-25	1990-05-16	1
50045	2960	4283893	2012-12-14	2013-02-01	1
46528	2771	378001	1996-03-01	1996-04-30	1
26354	1565	4285898	1999-08-26	1999-08-27	1
21944	1316	260139	1976-09-26	1976-10-03	1
32963	1958	40481087	1980-03-18	1980-04-01	1
35092	2084	28060	1992-12-07	1992-12-15	1
47754	2839	80180	2006-08-06	2006-08-07	1
76995	4565	4294548	1966-06-03	1966-08-19	1
52062	3086	4112343	1974-07-14	1974-07-24	1
50869	3013	28060	1963-05-06	1963-05-14	1
51138	3030	372328	1981-10-17	1981-11-24	1
73987	4398	40481087	2019-04-22	2019-05-13	1
49813	2947	4112343	1989-08-04	1989-08-16	1
58627	3481	40481087	2011-07-12	2011-07-19	1
6194	364	40481087	1986-12-05	1986-12-12	1
41371	2462	28060	1966-10-27	1966-11-06	1
17059	1021	378001	2019-05-02	2019-06-01	1
74100	4406	40481087	2016-08-06	2016-08-13	1
22555	1348	260139	1942-09-03	1942-09-17	1
54205	3215	260139	1979-02-27	1979-03-06	1
18770	1131	80180	2004-12-14	2004-12-15	1
75901	4505	4112343	2007-07-20	2007-07-31	1
62028	3667	4152936	1974-10-23	1974-11-13	1
46170	2752	81151	1982-10-20	1982-11-17	1
50501	2989	260139	1986-11-16	1986-11-30	1
54615	3236	381316	2016-07-15	2016-07-16	1
85765	5108	260139	1998-11-20	1998-11-27	1
47907	2846	4059173	1979-12-30	1980-03-29	1
12560	743	40481087	1982-01-27	1982-02-10	1
45748	2724	4112343	1983-07-17	1983-07-27	1
58931	3501	81893	1983-04-19	1983-04-20	1
19826	1193	4112343	2006-06-17	2006-06-24	1
76088	4521	40481087	1963-06-11	1963-07-02	1
46744	2782	260139	1987-06-20	1987-07-04	1
30994	1837	260139	1990-04-23	1990-04-30	1
31904	1898	40481087	2018-11-14	2018-11-28	1
49742	2944	4294548	2013-07-13	2013-11-23	1
73358	4365	372328	1954-05-08	1954-06-28	1
44129	2626	80180	2000-03-09	2000-03-10	1
16246	962	4027663	1983-11-02	1983-11-03	1
19203	1151	260139	2019-04-01	2019-04-08	1
18906	1137	4132546	1962-10-07	1962-10-08	1
59710	3541	4152936	1978-12-07	1978-12-21	1
81861	4859	4112343	1980-11-07	1980-11-19	1
51892	3079	40481087	1989-08-03	1989-08-17	1
44767	2666	4112343	1975-07-20	1975-07-27	1
26823	1590	4112343	1989-06-07	1989-06-16	1
51963	3081	81151	1978-06-02	1978-06-30	1
73021	4343	28060	2019-06-24	2019-06-25	1
50046	2960	4296204	1993-02-11	1993-02-25	1
46529	2771	4152936	1990-09-08	1990-09-29	1
26355	1565	4310024	1998-07-02	1998-07-03	1
21945	1316	260139	2004-07-26	2004-08-09	1
32964	1958	81151	2003-09-12	2003-10-17	1
35093	2084	372328	1967-02-16	1968-09-25	2
47755	2839	81893	2005-08-11	2005-08-12	1
76996	4565	40481087	1954-05-17	1954-05-31	1
52063	3086	4112343	1993-12-14	1993-12-27	1
50870	3013	80180	1992-10-02	1992-10-03	1
51139	3030	378001	1999-11-24	2000-01-23	1
73988	4398	260139	2005-05-23	2005-06-06	1
49814	2947	40481087	2004-03-23	2004-04-07	1
58628	3481	80180	2014-06-05	2014-06-06	1
6195	364	372328	1947-10-20	1948-01-25	1
41372	2462	134438	1988-10-08	1989-11-06	1
17060	1021	81151	1976-06-29	1976-07-20	1
74101	4406	260139	1969-11-27	1969-12-04	1
22556	1348	260139	1988-10-02	1988-10-18	1
54206	3215	260139	2000-03-21	2000-03-28	1
18771	1131	4112343	2012-03-04	2012-03-15	1
75902	4505	4112343	2009-10-22	2009-10-31	1
62029	3667	4155034	1977-09-28	1977-10-12	1
46171	2752	260139	1989-12-07	1989-12-14	1
50502	2989	260139	1993-11-10	1993-11-24	1
54616	3236	4059173	1988-07-26	1988-10-24	1
85766	5108	260139	2002-11-14	2002-11-28	1
47908	2846	4155034	1984-02-07	1984-02-21	1
12561	743	260139	2006-09-15	2006-09-29	1
45749	2724	4112343	2010-12-17	2010-12-27	1
58932	3501	260139	1949-11-24	1949-12-01	1
19827	1193	40481087	2008-03-14	2008-03-21	1
76089	4521	28060	1991-01-17	1991-01-24	1
46745	2782	381316	2002-03-06	2002-03-07	1
30995	1837	372328	1961-08-06	1961-10-20	1
31905	1898	40481087	2019-01-05	2019-01-12	1
49743	2944	40481087	2007-06-26	2007-07-10	1
73359	4365	40481087	1971-10-31	1971-11-13	1
44130	2626	4278672	1968-02-06	1968-04-06	1
16247	962	4112343	1994-12-07	1994-12-17	1
19204	1151	4112343	1989-12-10	1989-12-22	1
18907	1137	4156265	1975-06-01	1975-06-15	1
59711	3541	4296204	2000-06-26	2000-07-31	1
81862	4859	4112343	2018-08-30	2018-09-06	1
51893	3079	40481087	1997-08-14	1997-08-28	1
44768	2666	4112343	1992-08-08	1992-08-18	1
26824	1590	4112343	2011-09-16	2011-09-28	1
51964	3081	192671	1984-05-30	1984-05-31	1
73022	4343	80502	2014-12-15	2014-12-16	1
50047	2960	40481087	1968-08-30	1968-09-06	1
46530	2771	4278672	2013-09-28	2013-10-28	1
26356	1565	40481087	1992-08-13	1992-09-03	1
21946	1316	260139	2013-04-30	2013-05-14	1
32965	1958	372328	1996-02-25	1996-10-08	1
35094	2084	40481087	1981-08-23	1981-09-06	1
47756	2839	260139	1977-11-22	1977-12-06	1
76997	4565	40481087	2019-05-26	2019-06-02	1
52064	3086	4155034	1982-11-11	1982-11-25	1
50871	3013	372328	1951-09-23	1951-11-06	1
51140	3030	4059173	1986-05-24	1986-08-22	1
73989	4398	378001	1991-09-02	1991-11-01	1
53203	3157	372328	1955-07-01	1955-12-09	1
58629	3481	321042	2001-05-12	2001-05-13	1
6196	364	4109685	1991-08-21	1991-09-04	1
41373	2462	40481087	2005-03-13	2005-04-03	1
17061	1021	372328	1958-02-13	1958-11-27	1
74102	4406	4112343	1967-07-06	1967-07-19	1
22557	1348	372328	1913-01-20	1913-04-07	1
54207	3215	260139	2016-07-21	2016-08-04	1
18772	1131	40481087	1968-02-05	1968-02-12	1
77405	4591	30753	1994-03-02	1994-03-03	1
62030	3667	28060	1976-04-11	1976-04-21	1
46172	2752	372328	1952-06-10	1952-08-24	1
50503	2989	378001	1959-02-02	1959-03-04	1
54617	3236	4112343	1998-09-23	1998-10-06	1
85767	5108	317576	2012-12-30	2012-12-31	1
47909	2846	4283893	1987-09-03	1987-10-01	1
12562	743	4112343	2004-01-14	2004-01-24	1
45750	2724	40481087	1977-07-28	1977-08-11	1
58933	3501	260139	1961-05-15	1961-05-22	1
21513	1292	80180	1990-03-23	1990-03-24	1
76090	4521	81151	1992-09-23	1992-10-07	1
46746	2782	4027663	1944-11-12	1944-11-13	1
30996	1837	440086	1973-05-10	1973-12-20	1
31906	1898	28060	1991-04-03	1991-04-16	1
53236	3158	80180	1990-02-06	1990-02-07	1
73360	4365	40481087	1989-03-22	1989-03-29	1
44131	2626	40481087	1992-11-11	1992-12-02	1
16248	962	4112343	2006-02-18	2006-02-27	1
19205	1151	40481087	2002-08-24	2002-09-14	1
18908	1137	40481087	1984-02-25	1984-03-03	1
60575	3589	4112343	2009-02-04	2009-02-14	1
81863	4859	4116491	2002-04-13	2002-06-01	1
51894	3079	80180	1972-11-26	1972-11-27	1
44769	2666	4112343	2000-06-08	2000-06-17	1
26825	1590	40481087	1988-07-27	1988-08-17	1
51965	3081	260139	1975-05-31	1975-06-14	1
73023	4343	260139	1955-07-17	1955-07-31	1
50048	2960	40481087	1985-01-29	1985-02-05	1
46531	2771	40481087	1933-12-18	1934-01-08	1
30815	1826	260139	1965-04-17	1965-05-01	1
21947	1316	4059173	2018-09-27	2018-12-26	1
32966	1958	4027663	1998-07-20	1998-07-21	1
35876	2130	260139	1968-02-04	1968-02-18	1
47757	2839	378001	2010-11-19	2011-01-18	1
76998	4565	4112343	1948-03-25	1948-04-03	1
52065	3086	40481087	1971-03-22	1971-04-12	1
50872	3013	4112343	1968-05-19	1968-06-01	1
51141	3030	4112343	2013-07-04	2013-07-17	1
73990	4398	4237458	1990-08-08	1990-09-07	1
53204	3157	372328	2011-12-09	2012-01-27	1
58630	3481	378001	2006-04-08	2006-06-07	1
6197	364	4112343	1987-02-19	1987-02-27	1
43891	2616	81151	1975-08-07	1975-09-11	1
17062	1021	4310024	1987-07-01	1987-07-02	1
74103	4406	4112343	1986-05-11	1986-05-23	1
22558	1348	4035415	1919-09-16	1919-11-15	1
54208	3215	317576	2009-04-06	2009-04-07	1
18773	1131	134438	1997-08-10	1998-08-05	1
77406	4591	260139	1964-06-18	1964-06-25	1
62031	3667	80180	2007-01-22	2007-01-23	1
46173	2752	4059173	1969-03-02	1969-05-01	1
50504	2989	4112343	1971-04-10	1971-04-22	1
54618	3236	4112343	2016-06-27	2016-07-04	1
85768	5108	372328	1962-07-29	1962-12-30	1
47910	2846	40481087	2010-04-23	2010-05-14	1
12563	743	4296205	1991-11-08	1991-12-06	1
45751	2724	40481087	2004-02-12	2004-02-19	1
58934	3501	260139	2012-02-03	2012-02-17	1
21514	1292	81151	1986-02-26	1986-03-26	1
76091	4521	260139	1976-02-19	1976-02-26	1
46747	2782	4112343	1953-02-07	1953-02-16	1
30997	1837	4112343	1962-09-04	1962-09-11	1
31907	1898	257012	1982-09-04	1982-09-05	1
53237	3158	260139	1950-11-20	1950-11-27	1
75292	4475	80180	2013-09-30	2013-10-01	1
46583	2776	192671	2014-02-21	2014-02-22	1
16249	962	4146173	1973-07-08	1973-09-06	1
19206	1151	28060	1986-11-14	1986-11-25	1
18909	1137	40481087	1996-06-01	1996-06-22	1
60576	3589	80180	2016-11-06	2016-11-07	1
81864	4859	4155034	2013-07-28	2013-08-18	1
51895	3079	260139	1965-11-28	1965-12-12	1
44770	2666	40481087	1953-10-10	1953-10-17	1
26826	1590	40481087	1994-07-25	1994-08-08	1
51966	3081	260139	1984-05-14	1984-05-21	1
73024	4343	260139	1997-02-27	1997-03-13	1
50049	2960	28060	1956-03-19	1956-03-29	1
50196	2970	81151	1993-01-19	1993-02-09	1
30816	1826	4112343	1975-08-27	1975-09-08	1
21948	1316	4112343	1950-04-23	1950-05-06	1
32967	1958	4112343	1972-04-23	1972-05-04	1
35877	2130	260139	2004-07-16	2004-07-23	1
47758	2839	4035415	1986-04-29	1986-06-28	1
76999	4565	4112343	1955-03-29	1955-04-08	1
52066	3086	40481087	1971-07-17	1971-07-24	1
50873	3013	40481087	1982-02-02	1982-02-23	1
51142	3030	4113008	1995-12-31	1996-01-14	1
73991	4398	40481087	1973-06-22	1973-07-06	1
53205	3157	4112343	1957-03-11	1957-03-22	1
58631	3481	4155034	2007-07-02	2007-07-16	1
6198	364	4134304	2018-07-05	2018-08-04	1
43892	2616	257012	1990-04-10	1990-04-11	1
17063	1021	40481087	1956-05-29	1956-06-19	1
74104	4406	4112343	2008-04-16	2008-04-27	1
22559	1348	4112343	1918-09-09	1918-09-17	1
54209	3215	372328	1980-06-02	1980-09-01	1
18774	1131	260139	2016-04-05	2016-04-12	1
77407	4591	375671	2005-11-12	2006-01-11	1
62032	3667	260139	1978-03-16	1978-03-30	1
46174	2752	4155034	1954-04-01	1954-04-15	1
50505	2989	4142905	1998-10-12	1998-11-11	1
54619	3236	80502	2014-09-05	2014-09-06	1
85769	5108	4112343	1962-10-18	1962-10-26	1
47911	2846	78272	1996-12-28	1997-02-01	1
12564	743	40481087	2016-12-24	2016-12-31	1
45752	2724	28060	1994-12-30	1995-01-07	1
58935	3501	372328	1950-06-22	1950-11-09	1
21515	1292	440086	1963-08-12	1968-08-20	1
76092	4521	378419	2000-06-08	2000-06-09	1
46748	2782	4112343	1957-08-10	1957-08-22	1
30998	1837	40481087	1984-10-31	1984-11-14	1
31908	1898	260139	2013-05-25	2013-06-01	1
53238	3158	4109685	1963-04-14	1963-04-28	1
75293	4475	260139	2012-09-10	2012-09-17	1
46584	2776	372328	1984-11-21	1985-10-20	1
16250	962	30753	1993-10-25	1993-10-26	1
19207	1151	260139	2000-01-15	2000-01-22	1
18910	1137	81151	1988-10-09	1988-11-06	1
60577	3589	372328	1983-02-17	1983-06-07	1
81865	4859	40481087	1967-10-19	1967-11-09	1
51896	3079	260139	1995-08-30	1995-09-13	1
44771	2666	81151	1959-12-19	1960-01-23	1
26827	1590	40481087	1997-11-26	1997-12-17	1
51967	3081	378001	1965-06-12	1965-07-12	1
73025	4343	260139	2007-08-31	2007-09-07	1
50050	2960	28060	2011-02-25	2011-03-07	1
50197	2970	134438	1999-04-15	1999-12-13	1
30817	1826	4285898	1977-09-19	1977-09-20	1
21949	1316	4112343	2009-12-10	2009-12-17	1
32968	1958	4112343	1987-12-22	1987-12-31	1
35878	2130	4112343	1974-12-19	1974-12-28	1
47759	2839	4310024	2005-04-13	2005-04-14	1
77000	4565	40479422	1962-07-14	1962-09-19	1
52067	3086	40481087	2010-05-04	2010-05-18	1
50874	3013	28060	1997-09-24	1997-10-03	1
51143	3030	4296204	1989-04-08	1989-05-06	1
76350	4532	0	1946-04-10	1946-04-11	1
53206	3157	4113008	2011-02-12	2011-03-05	1
58632	3481	4156265	1981-04-09	1981-04-30	1
6199	364	40481087	1975-04-22	1975-04-29	1
43893	2616	4112343	1963-09-27	1963-10-10	1
17064	1021	40481087	2016-12-09	2016-12-30	1
74105	4406	4112343	2014-12-23	2014-12-31	1
22560	1348	4112343	1936-06-18	1936-06-25	1
54210	3215	4283893	2009-08-27	2009-10-08	1
18775	1131	372328	1966-04-08	1966-07-20	1
77408	4591	4218389	1974-07-25	1974-08-29	1
62033	3667	260139	1985-02-02	1985-02-16	1
46175	2752	4156265	1960-01-14	1960-01-28	1
50506	2989	4156265	2010-07-16	2010-08-06	1
54620	3236	260139	1933-05-15	1933-05-22	1
85770	5108	4278672	1974-03-14	1974-04-13	1
47912	2846	195588	2016-06-14	2016-08-09	1
12565	743	4112343	1986-08-07	1986-08-15	1
45753	2724	78272	1959-11-23	1959-12-28	1
58936	3501	4027663	1975-11-27	1975-11-28	1
21516	1292	4112343	1961-07-21	1961-07-31	1
76093	4521	4059173	1933-04-15	1933-06-14	1
46749	2782	4112343	1958-07-22	1958-08-04	1
30999	1837	40481087	1993-11-18	1993-12-02	1
31909	1898	4027663	2002-11-29	2002-11-30	1
53239	3158	4112343	1994-11-24	1994-12-07	1
75294	4475	260139	2014-10-18	2014-10-25	1
46585	2776	4027663	2002-07-06	2002-07-07	1
16251	962	80180	1995-04-18	1995-04-19	1
19208	1151	4283893	2008-09-21	2009-01-03	1
18911	1137	81151	1989-10-02	1989-10-23	1
60578	3589	4084167	1998-03-30	1998-03-31	1
81866	4859	81151	1958-11-30	1958-12-14	1
51897	3079	40481087	1944-01-25	1944-02-01	1
44772	2666	81151	1971-11-21	1971-12-12	1
26828	1590	4112343	1971-11-14	1971-11-27	1
51968	3081	4027663	1976-01-16	1976-01-17	1
73026	4343	4112343	2005-11-22	2005-12-03	1
50051	2960	81151	1970-02-14	1970-03-14	1
50198	2970	4310024	2003-11-03	2003-11-04	1
30818	1826	260139	1999-04-13	1999-04-20	1
21950	1316	4283893	2016-04-23	2016-06-11	1
32969	1958	4112343	1996-11-26	1996-12-03	1
35879	2130	4283893	2001-03-29	2001-06-21	1
47760	2839	81151	1984-06-17	1984-07-08	1
77001	4565	40481087	1976-05-04	1976-05-18	1
52068	3086	40481087	2016-06-20	2016-07-04	1
50875	3013	260139	1982-05-15	1982-05-22	1
51755	3072	440086	1968-07-15	1968-10-14	1
76351	4532	28060	1911-04-27	1911-05-10	1
53207	3157	40481087	1985-08-09	1985-08-23	1
58633	3481	0	2015-04-04	2015-04-05	1
6200	364	40481087	2000-11-07	2000-11-28	1
43894	2616	4112343	2002-07-04	2002-07-14	1
18546	1117	80180	1978-09-28	1978-09-29	1
74106	4406	4112343	2018-07-14	2018-07-21	1
22561	1348	40481087	1918-03-03	1918-03-17	1
54211	3215	40481087	1978-04-10	1978-05-01	1
18776	1131	372328	1967-07-15	1968-01-17	1
77409	4591	40481087	1989-01-28	1989-02-04	1
62034	3667	4059173	2000-02-14	2000-04-14	1
46176	2752	260139	1956-07-14	1956-07-21	1
50507	2989	4218389	2002-05-24	2002-06-28	1
54621	3236	4112343	1951-11-03	1951-11-12	1
85771	5108	40481087	1995-07-26	1995-08-09	1
47913	2846	372328	1973-07-20	1973-09-02	1
12566	743	4112343	2001-07-15	2001-07-26	1
45754	2724	440086	1961-05-21	1963-07-07	1
58937	3501	4112343	1990-03-12	1990-03-23	1
21517	1292	40481087	2013-02-07	2013-02-14	1
76094	4521	4112343	1967-12-03	1967-12-12	1
46750	2782	4149245	1955-05-03	1955-07-09	1
31000	1837	40481087	2014-07-18	2014-08-08	1
31910	1898	4109685	2011-08-25	2011-09-15	1
53240	3158	4132546	1956-05-20	1956-05-21	1
75295	4475	4112343	2018-09-29	2018-10-06	1
46586	2776	4266809	2014-01-14	2014-01-15	1
16252	962	4266809	1995-04-18	1995-04-19	1
19209	1151	40481087	2016-12-01	2016-12-15	1
18912	1137	260139	1974-07-27	1974-08-03	1
60579	3589	4094814	1983-11-14	1984-01-13	1
81867	4859	198809	1971-06-05	1971-06-05	1
51898	3079	40481087	1948-11-12	1948-12-03	1
44773	2666	260139	2007-06-11	2007-06-18	1
26829	1590	4112343	1976-01-08	1976-01-15	1
51969	3081	4155034	2016-07-10	2016-07-31	1
73027	4343	4155034	2009-10-23	2009-11-06	1
50052	2960	81151	1996-02-10	1996-03-02	1
50199	2970	40481087	1996-02-18	1996-02-25	1
30819	1826	378001	1989-08-21	1989-10-20	1
21951	1316	4310024	1992-09-10	1992-09-11	1
32970	1958	4152936	2004-09-11	2004-09-25	1
35880	2130	40481087	1962-08-18	1962-08-25	1
47761	2839	372328	1973-05-16	1973-07-30	1
77002	4565	40481087	1985-09-06	1985-09-27	1
52069	3086	80180	2004-09-06	2004-09-07	1
50876	3013	260139	2005-02-22	2005-03-08	1
51756	3072	4059173	1995-11-27	1995-12-27	1
76352	4532	260139	1949-03-04	1949-03-11	1
53208	3157	40481087	2002-05-23	2002-06-06	1
58634	3481	81151	1986-03-05	1986-04-09	1
6494	384	4112343	1991-07-03	1991-07-11	1
43895	2616	40481087	1973-05-14	1973-05-28	1
18547	1117	260139	2002-06-30	2002-07-07	1
74107	4406	4294548	1976-02-23	1976-04-26	1
22562	1348	40481087	1939-10-19	1939-11-09	1
54212	3215	260139	1982-01-31	1982-02-07	1
18777	1131	4112343	1991-09-21	1991-10-02	1
77410	4591	260139	1982-10-05	1982-10-19	1
62035	3667	4112343	1998-10-22	1998-11-01	1
46177	2752	260139	1964-12-08	1964-12-15	1
51171	3035	28060	2007-11-08	2007-11-15	1
54622	3236	4112343	1953-10-03	1953-10-16	1
85772	5108	260139	2002-03-10	2002-03-17	1
47914	2846	4112343	1993-05-12	1993-05-24	1
12567	743	40481087	2016-01-13	2016-01-20	1
45755	2724	4112343	1969-11-27	1969-12-09	1
58938	3501	4112343	1991-12-14	1991-12-25	1
21518	1292	40481087	2015-07-26	2015-08-09	1
76095	4521	4278672	1924-04-02	1924-07-01	1
46751	2782	40481087	1933-11-10	1933-11-17	1
31001	1837	257012	1968-09-27	1968-09-28	1
31911	1898	4112343	2001-09-06	2001-09-13	1
53241	3158	4237458	1977-04-01	1977-06-30	1
75296	4475	4134304	1988-08-27	1988-10-26	1
46587	2776	4283893	1993-09-27	1993-12-13	1
16253	962	40481087	1955-03-24	1955-03-31	1
19210	1151	260139	1994-12-30	1995-01-06	1
18913	1137	260139	2011-04-06	2011-04-20	1
60580	3589	4112343	1990-10-13	1990-10-26	1
81868	4859	257012	2010-07-25	2010-07-26	1
51899	3079	40481087	1959-03-20	1959-03-27	1
44774	2666	372328	1954-10-27	1954-11-21	1
26830	1590	4237458	1965-01-06	1965-02-05	1
51970	3081	4218389	1976-07-14	1976-08-11	1
73028	4343	4283893	1988-05-28	1988-08-27	1
50053	2960	260139	1958-10-16	1958-10-23	1
50200	2970	40481087	1999-12-03	1999-12-24	1
30820	1826	4112343	1961-08-30	1961-09-06	1
21952	1316	40481087	2018-08-08	2018-08-29	1
32971	1958	40481087	2013-01-29	2013-02-12	1
35881	2130	40481087	1983-11-25	1983-12-09	1
47762	2839	372328	1987-08-16	1988-01-25	1
77003	4565	40481087	1990-10-08	1990-10-15	1
52070	3086	260139	1987-01-30	1987-02-06	1
50877	3013	372328	1962-09-17	1963-06-25	1
51757	3072	4112343	1962-03-08	1962-03-20	1
76353	4532	260139	1980-06-28	1980-07-12	1
53209	3157	40481087	2004-10-29	2004-11-12	1
58635	3481	40481087	1988-05-05	1988-05-12	1
6495	384	40481087	1962-09-23	1962-10-07	1
43896	2616	40481087	1988-09-15	1988-10-06	1
18548	1117	4027663	1968-11-14	1968-11-15	1
74108	4406	40481087	1950-09-17	1950-10-08	1
24272	1448	372328	1977-11-23	1978-03-08	1
54213	3215	4109685	2003-10-17	2003-10-31	1
18778	1131	4112343	2010-08-25	2010-09-07	1
77411	4591	4112343	1997-02-10	1997-02-22	1
62036	3667	40481087	1990-03-24	1990-03-31	1
46178	2752	4112343	1955-11-23	1955-12-05	1
51172	3035	80180	2004-09-30	2004-10-01	1
54623	3236	4112343	2008-07-26	2008-08-04	1
85773	5108	372328	1961-06-22	1961-10-02	1
47915	2846	4112343	2017-09-16	2017-09-26	1
13838	820	28060	1992-06-30	1992-07-11	1
45756	2724	4112343	1979-08-22	1979-09-02	1
58939	3501	4156265	1969-01-17	1969-02-07	1
21519	1292	40486433	1954-08-21	1954-08-22	1
76096	4521	40481087	1942-03-21	1942-04-04	1
46752	2782	40481087	1991-03-15	1991-03-29	1
31002	1837	260139	2015-07-02	2015-07-16	1
31912	1898	4294548	1982-08-14	1983-04-09	1
53242	3158	4278672	1964-05-22	1964-06-21	1
75297	4475	372328	1987-06-04	1988-05-30	1
46588	2776	40481087	2016-05-16	2016-06-06	1
16254	962	40481087	1979-03-11	1979-03-18	1
19211	1151	372328	1985-11-15	1986-01-28	1
18914	1137	4001336	1962-10-07	1962-12-06	1
60581	3589	40481087	2016-01-30	2016-02-20	1
81869	4859	260139	1962-02-03	1962-02-17	1
51900	3079	40481087	2012-02-25	2012-03-03	1
44775	2666	40481087	1958-02-01	1958-02-15	1
26831	1590	40481087	1975-08-18	1975-09-08	1
51971	3081	4266809	1984-05-08	1984-05-09	1
73029	4343	40481087	1959-08-01	1959-08-22	1
50054	2960	372328	1957-11-19	1958-01-09	1
50201	2970	40481087	2005-07-31	2005-08-07	1
30821	1826	4296204	1957-11-23	1957-12-07	1
21953	1316	28060	2004-08-16	2004-08-26	1
32972	1958	78272	1989-09-20	1989-10-25	1
35882	2130	260139	1962-02-11	1962-02-25	1
47763	2839	4152936	2017-08-14	2017-08-28	1
77004	4565	40481087	2006-03-20	2006-03-27	1
52071	3086	260139	2014-10-22	2014-11-05	1
50878	3013	372328	1986-12-21	1988-06-28	1
51758	3072	4156265	1975-10-22	1975-11-12	1
76354	4532	4112343	1912-07-15	1912-07-25	1
53210	3157	78272	2000-08-17	2000-09-07	1
60203	3567	80180	2004-05-10	2004-05-11	1
6496	384	81151	1962-04-20	1962-05-25	1
43897	2616	40481087	2002-01-04	2002-01-18	1
18549	1117	4109685	1943-10-03	1943-10-24	1
74109	4406	40481087	1978-04-23	1978-05-14	1
24273	1448	4283893	1991-01-27	1991-03-03	1
54214	3215	40481087	1996-06-01	1996-06-15	1
18779	1131	40481087	2009-04-06	2009-04-20	1
77412	4591	4113008	1989-11-22	1989-12-06	1
62037	3667	28060	1968-07-06	1968-07-19	1
46179	2752	4112343	1962-01-05	1962-01-12	1
51173	3035	260139	1986-10-30	1986-11-06	1
54624	3236	4278672	2013-10-09	2013-11-08	1
85774	5108	40481087	2009-03-26	2009-04-16	1
47916	2846	4230399	1982-04-18	1982-05-18	1
13839	820	257012	2002-09-23	2002-09-24	1
45757	2724	4116491	1989-05-14	1989-07-13	1
58940	3501	40481087	2003-03-09	2003-03-23	1
21520	1292	372328	1953-05-31	1953-07-21	1
76097	4521	40481087	1991-10-18	1991-11-01	1
47521	2829	260139	1992-08-11	1992-08-18	1
31003	1837	4112343	2017-01-28	2017-02-10	1
31913	1898	40481087	2007-12-16	2008-01-06	1
53243	3158	40481087	1957-03-24	1957-04-07	1
75298	4475	4059173	1994-03-28	1994-04-28	1
46589	2776	28060	1989-04-01	1989-04-12	1
16255	962	81151	1957-06-06	1957-06-27	1
19212	1151	372328	1987-12-19	1988-04-27	1
18915	1137	4218389	1952-08-09	1952-08-30	1
60582	3589	260139	2007-03-16	2007-03-30	1
81870	4859	4112343	1974-07-01	1974-07-10	1
51901	3079	40481087	2014-09-27	2014-10-04	1
44776	2666	40481087	1988-09-26	1988-10-03	1
26832	1590	80180	1999-02-07	1999-02-08	1
51972	3081	40481087	1957-10-12	1957-11-02	1
73030	4343	28060	1967-09-26	1967-10-04	1
50055	2960	4112343	1999-08-28	1999-09-09	1
50202	2970	40481087	2009-01-06	2009-01-27	1
30822	1826	40481087	1947-12-22	1947-12-29	1
21954	1316	81151	2006-08-19	2006-09-16	1
32973	1958	81893	2008-06-12	2008-06-13	1
35883	2130	372328	2004-02-23	2004-07-22	1
47764	2839	40481087	2001-09-25	2001-10-02	1
77771	4613	260139	1996-02-15	1996-02-22	1
52072	3086	4112343	1971-10-14	1971-10-26	1
50879	3013	4059173	1963-12-24	1964-02-22	1
51759	3072	4294548	1999-01-09	1999-07-10	1
76355	4532	4112343	1953-02-21	1953-03-06	1
53211	3157	81151	1953-07-29	1953-08-26	1
60204	3567	378001	1995-10-30	1995-12-29	1
6497	384	4112343	1965-10-03	1965-10-10	1
43898	2616	80502	2012-01-10	2012-01-11	1
18550	1117	4112343	1957-11-30	1957-12-08	1
74110	4406	40481087	2015-07-23	2015-08-06	1
24274	1448	4294548	2012-02-15	2012-04-18	1
54215	3215	40481087	1997-10-16	1997-10-23	1
18780	1131	40481087	2013-11-18	2013-12-02	1
77413	4591	4310024	1993-08-04	1993-08-05	1
62038	3667	81151	2010-01-22	2010-02-12	1
46180	2752	4112343	1997-06-09	1997-06-22	1
51174	3035	260139	1999-09-21	1999-09-28	1
54625	3236	40481087	1944-07-12	1944-08-02	1
85775	5108	4112343	1963-10-23	1963-10-29	1
47917	2846	4278672	1981-02-22	1981-05-23	1
13840	820	372328	1967-02-05	1967-04-27	1
45758	2724	4296205	2011-07-10	2011-07-24	1
59795	3547	81151	2001-03-02	2001-03-23	1
21521	1292	4084167	1960-09-21	1960-09-21	1
76098	4521	40481087	2001-01-19	2001-01-26	1
47522	2829	4112343	1961-05-12	1961-05-19	1
31004	1837	4116491	1992-05-05	1992-06-24	1
31914	1898	30753	2010-09-18	2010-09-19	1
53244	3158	40481087	1961-12-19	1962-01-09	1
75299	4475	4112343	1981-08-06	1981-08-13	1
46590	2776	28060	2001-04-13	2001-04-22	1
16256	962	260139	2016-05-20	2016-05-27	1
19213	1151	40481087	1997-04-24	1997-05-15	1
18916	1137	40481087	1957-02-19	1957-03-12	1
60583	3589	372328	1985-09-24	1985-12-09	1
81871	4859	40481087	1985-06-27	1985-07-18	1
51902	3079	78272	1971-03-02	1971-03-16	1
44777	2666	40481087	2013-05-31	2013-06-07	1
26833	1590	81151	1979-02-13	1979-02-27	1
51973	3081	80180	1984-05-08	1984-05-09	1
73031	4343	4109685	1999-07-04	1999-07-18	1
50056	2960	4112343	2016-04-13	2016-04-25	1
50203	2970	40481087	2014-12-03	2014-12-17	1
30823	1826	40481087	1949-07-28	1949-08-18	1
21955	1316	81151	2013-03-13	2013-03-27	1
32974	1958	260139	1987-09-02	1987-09-16	1
35884	2130	4237458	1976-02-27	1976-04-27	1
47765	2839	40481087	2015-07-27	2015-08-17	1
77772	4613	4059173	1990-03-13	1990-04-12	1
52073	3086	4112343	1981-09-18	1981-09-28	1
50880	3013	4112343	1984-03-13	1984-03-24	1
51760	3072	40481087	1959-08-22	1959-09-12	1
76356	4532	4112343	1955-02-25	1955-03-09	1
53212	3157	4134304	1964-07-29	1964-10-27	1
60205	3567	4294548	2016-09-15	2016-10-06	1
6498	384	4112343	1971-05-14	1971-05-25	1
43899	2616	81151	1974-06-29	1974-07-13	1
18551	1117	4155034	1980-04-12	1980-04-26	1
74111	4406	80180	1981-08-29	1981-08-30	1
24275	1448	80180	2009-03-09	2009-03-10	1
54216	3215	40481087	2015-11-28	2015-12-19	1
19328	1159	4152936	2007-09-03	2007-09-24	1
77414	4591	81151	1977-08-13	1977-08-27	1
62039	3667	257012	1972-06-03	1972-06-04	1
46181	2752	4112343	1998-04-21	1998-04-30	1
51175	3035	260139	2017-02-26	2017-03-05	1
54626	3236	40481087	1976-01-22	1976-02-12	1
85776	5108	4112343	1982-01-23	1982-02-05	1
47918	2846	81151	1978-03-26	1978-04-09	1
13841	820	372328	1982-06-17	1982-07-29	1
45759	2724	40481087	1983-03-21	1983-04-04	1
59796	3547	260139	2004-07-04	2004-07-18	1
21522	1292	4084167	1963-06-14	1963-06-14	1
76099	4521	40481087	2003-10-18	2003-11-01	1
47523	2829	4112343	1963-03-12	1963-03-19	1
33227	1975	0	1973-01-29	1973-01-30	1
31915	1898	260139	1986-10-24	1986-10-31	1
53245	3158	40481087	1977-06-24	1977-07-08	1
75300	4475	4278672	1983-08-24	1983-09-23	1
46591	2776	260139	1980-09-16	1980-09-30	1
16257	962	4112343	1955-09-30	1955-10-10	1
20843	1253	4112343	1978-01-20	1978-01-30	1
18917	1137	40481087	1969-06-24	1969-07-15	1
60584	3589	4112343	1991-06-25	1991-07-08	1
81872	4859	40481087	1997-12-18	1997-12-25	1
51903	3079	372328	1934-07-14	1934-09-27	1
50669	3001	260139	1998-12-27	1999-01-10	1
26834	1590	378001	1987-10-14	1987-12-12	1
51974	3081	81893	1983-08-12	1983-08-13	1
73032	4343	4112343	1974-06-03	1974-06-10	1
50057	2960	40481087	1976-08-30	1976-09-06	1
50204	2970	81893	2004-01-02	2004-01-03	1
30824	1826	40481087	1950-06-14	1950-07-05	1
21956	1316	260139	1952-03-18	1952-04-01	1
32975	1958	372328	1979-05-16	1979-07-24	1
35885	2130	40481087	1977-02-13	1977-03-06	1
47766	2839	260139	2012-11-06	2012-11-13	1
77773	4613	4116491	1987-05-17	1987-07-03	1
52074	3086	4294548	1972-09-23	1972-10-14	1
50881	3013	4112343	2012-04-18	2012-04-30	1
51761	3072	321042	1964-02-01	1964-02-02	1
76357	4532	4152936	1946-03-04	1946-03-18	1
53213	3157	4142905	1960-03-22	1960-06-20	1
60206	3567	40481087	1991-08-01	1991-08-08	1
6499	384	4112343	2012-10-29	2012-11-10	1
43900	2616	372328	1955-08-01	1955-11-01	1
18552	1117	40481087	1988-05-09	1988-05-16	1
74112	4406	195588	1976-11-13	1977-01-08	1
24276	1448	81151	1978-01-01	1978-01-15	1
54217	3215	28060	2007-10-08	2007-10-15	1
19329	1159	4237458	1982-03-18	1982-04-17	1
77415	4591	81893	1994-01-31	1994-02-01	1
62040	3667	260139	1985-11-14	1985-11-21	1
46182	2752	4294548	1993-09-25	1994-05-21	1
51176	3035	4112343	1966-04-10	1966-04-20	1
54627	3236	40481087	1987-12-16	1987-12-23	1
47919	2846	40481087	1987-01-17	1987-01-31	1
13842	820	40481087	1965-11-20	1965-12-11	1
45760	2724	4112343	1975-04-01	1975-04-14	1
59797	3547	260139	2009-10-05	2009-10-12	1
21523	1292	4112343	1986-05-04	1986-05-15	1
76100	4521	40481087	2004-08-06	2004-08-13	1
47524	2829	4278672	1978-02-09	1978-04-10	1
33228	1975	81151	1924-10-28	1924-11-11	1
31916	1898	260139	2007-09-12	2007-09-19	1
53246	3158	4112343	1950-08-01	1950-08-14	1
75301	4475	40481087	2013-12-01	2013-12-15	1
46592	2776	372328	1991-07-21	1991-11-24	1
16258	962	4112343	1983-04-18	1983-04-26	1
20844	1253	4152936	1969-02-23	1969-03-09	1
18918	1137	40481087	1983-12-08	1983-12-22	1
60585	3589	40481087	2018-06-16	2018-06-23	1
81873	4859	260139	1955-08-19	1955-08-26	1
51904	3079	4112343	1979-08-20	1979-09-01	1
50670	3001	4027663	1974-02-11	1974-02-12	1
26835	1590	4112343	2008-02-20	2008-03-01	1
51975	3081	4112343	1968-04-15	1968-04-25	1
73033	4343	4112343	2017-01-18	2017-01-31	1
50058	2960	40481087	1985-03-15	1985-04-05	1
50205	2970	260139	2003-10-05	2003-10-12	1
30825	1826	40481087	1960-10-16	1960-10-23	1
21957	1316	260139	1953-03-23	1953-03-30	1
32976	1958	4112343	1995-04-24	1995-05-05	1
35886	2130	257012	2001-04-12	2001-04-13	1
47767	2839	4027663	1999-02-14	1999-02-15	1
77774	4613	40481087	1973-06-22	1973-07-13	1
55673	3298	28060	1984-04-22	1984-04-30	1
50882	3013	4142905	2014-05-05	2014-08-03	1
51762	3072	4112343	1974-01-27	1974-02-05	1
76358	4532	40481087	1916-08-15	1916-09-05	1
53214	3157	4310024	1983-07-27	1983-07-28	1
60207	3567	40481087	2005-11-19	2005-12-03	1
6500	384	4116491	2018-07-03	2018-08-16	1
43901	2616	4112343	1966-03-02	1966-03-11	1
18553	1117	40481087	1999-10-27	1999-11-10	1
74113	4406	4112343	1948-01-08	1948-01-21	1
24277	1448	260139	1973-12-24	1974-01-07	1
54218	3215	260139	1981-09-24	1981-10-01	1
19330	1159	40481087	1992-06-10	1992-06-24	1
77416	4591	192671	1995-04-10	1995-04-11	1
62041	3667	260139	2012-12-04	2012-12-18	1
46183	2752	40481087	1972-04-01	1972-04-15	1
51177	3035	4112343	1984-04-17	1984-04-26	1
54628	3236	40481087	2008-08-13	2008-08-20	1
47920	2846	40481087	1988-12-31	1989-01-07	1
13843	820	40481087	1981-03-19	1981-04-09	1
45761	2724	4155034	1997-10-30	1997-11-20	1
59798	3547	378001	1996-07-26	1996-08-25	1
21524	1292	4112343	2017-11-02	2017-11-10	1
76101	4521	255848	2009-04-22	2009-04-23	1
47525	2829	40481087	1996-10-27	1996-11-17	1
33229	1975	372328	1928-10-24	1929-02-02	1
31917	1898	4112343	1981-09-24	1981-10-03	1
53247	3158	260139	1985-10-20	1985-11-03	1
75302	4475	375671	1995-04-23	1995-05-23	1
46593	2776	4112343	2001-06-23	2001-07-04	1
16259	962	4112343	2010-12-06	2010-12-16	1
20845	1253	40481087	1956-09-06	1956-09-20	1
18919	1137	40481087	1984-09-07	1984-09-14	1
60586	3589	40481087	2019-02-26	2019-03-20	1
81874	4859	260139	1963-10-17	1963-10-31	1
51905	3079	28060	1934-06-18	1934-06-30	1
50671	3001	4112343	1969-04-23	1969-05-02	1
26836	1590	40481087	1978-06-29	1978-07-13	1
51976	3081	4112343	1980-08-19	1980-08-28	1
73034	4343	4155034	1978-10-03	1978-10-24	1
50059	2960	40481087	1997-09-21	1997-09-28	1
50206	2970	260139	2018-09-25	2018-10-02	1
30826	1826	28060	1985-06-18	1985-06-30	1
21958	1316	260139	1985-06-02	1985-06-09	1
32977	1958	40481087	1988-04-26	1988-05-03	1
35887	2130	260139	1994-05-13	1994-05-27	1
49193	2913	81151	1988-03-14	1988-03-28	1
77775	4613	40481087	1984-07-23	1984-08-06	1
55674	3298	80180	2006-10-30	2006-10-31	1
50883	3013	40481087	1963-07-27	1963-08-03	1
51763	3072	4112343	1987-11-26	1987-12-08	1
76359	4532	40481087	1926-08-26	1926-09-16	1
53215	3157	40481087	1971-12-02	1971-12-16	1
60208	3567	260139	2012-03-03	2012-03-17	1
6501	384	40481087	1965-06-02	1965-06-09	1
43902	2616	40481087	1982-10-17	1982-11-07	1
18554	1117	81151	1937-11-12	1937-12-03	1
74114	4406	4112343	1989-08-07	1989-08-15	1
24278	1448	372328	1976-01-12	1976-03-03	1
54219	3215	260139	1997-10-24	1997-10-31	1
19331	1159	40481087	2001-02-01	2001-02-22	1
77417	4591	260139	2012-01-09	2012-01-23	1
62042	3667	40481087	1976-11-24	1976-12-01	1
47646	2835	28060	1981-10-28	1981-11-04	1
51178	3035	260139	1974-08-25	1974-09-01	1
58646	3483	28060	1963-11-29	1963-12-07	1
47921	2846	40481087	2017-05-13	2017-06-03	1
13844	820	40481087	1995-02-10	1995-03-03	1
45762	2724	28060	1957-01-24	1957-02-01	1
59799	3547	4059173	1977-12-03	1978-01-02	1
21525	1292	260139	1959-05-31	1959-06-14	1
76102	4521	317576	1970-04-16	1970-04-17	1
47526	2829	40481087	2007-11-29	2007-12-06	1
33230	1975	4112343	1936-02-10	1936-02-18	1
31918	1898	40481087	1996-12-01	1996-12-08	1
53248	3158	381316	2002-01-10	2002-01-11	1
75303	4475	40481087	1984-05-26	1984-06-09	1
46594	2776	4155034	2013-02-23	2013-03-16	1
16260	962	4134304	1964-03-27	1964-04-26	1
20846	1253	40481087	1959-12-12	1959-12-19	1
18920	1137	40481087	1997-01-27	1997-02-03	1
62551	3699	80180	2014-01-15	2014-01-16	1
81875	4859	260139	1980-03-14	1980-03-21	1
51906	3079	260139	1957-05-16	1957-05-30	1
50672	3001	4152936	1986-09-06	1986-09-27	1
26837	1590	40481087	2000-01-13	2000-01-27	1
51977	3081	40481087	1958-06-07	1958-06-14	1
73035	4343	4218389	1992-02-13	1992-03-12	1
50060	2960	40481087	2005-04-27	2005-05-18	1
50207	2970	4027663	1996-04-08	1996-04-09	1
30827	1826	80180	1978-05-17	1978-05-18	1
21959	1316	4266809	1994-05-03	1994-05-04	1
32978	1958	28060	1981-05-19	1981-05-26	1
35888	2130	4155034	1980-06-05	1980-06-19	1
49194	2913	257012	1957-11-26	1957-11-27	1
77776	4613	40481087	1985-10-06	1985-10-27	1
55675	3298	4112343	1972-12-10	1972-12-20	1
50884	3013	40481087	2009-12-06	2009-12-27	1
51764	3072	4155034	2008-01-23	2008-02-13	1
76360	4532	40481087	1928-10-14	1928-11-04	1
53216	3157	28060	1965-12-20	1965-12-28	1
60209	3567	4112343	2017-04-06	2017-04-17	1
6502	384	40481087	1971-08-15	1971-08-29	1
43903	2616	80180	1987-12-08	1987-12-09	1
18555	1117	81893	1976-12-07	1976-12-08	1
74115	4406	4112343	1998-08-29	1998-09-05	1
24279	1448	4027663	2002-03-21	2002-03-22	1
54220	3215	372328	1978-06-30	1978-09-11	1
19332	1159	260139	1986-01-27	1986-02-10	1
77418	4591	4027663	1983-09-11	1983-09-12	1
62043	3667	40481087	2000-11-11	2000-12-02	1
47647	2835	80502	1993-05-04	1993-05-05	1
51179	3035	372328	1968-01-28	1968-11-29	1
58647	3483	80180	1988-12-31	1989-01-01	1
55188	3272	81151	1987-04-11	1987-05-09	1
13845	820	40481087	2000-05-26	2000-06-09	1
45763	2724	28060	1969-04-19	1969-04-29	1
59800	3547	4112343	1997-04-20	1997-04-29	1
21526	1292	260139	1995-09-16	1995-09-30	1
76103	4521	4112343	1968-06-19	1968-06-29	1
47527	2829	40481087	2017-08-08	2017-08-15	1
33231	1975	4134304	1928-08-22	1928-11-20	1
31919	1898	40481087	2004-10-05	2004-10-26	1
53249	3158	440086	1963-08-22	1967-03-30	1
75304	4475	40481087	1988-03-25	1988-04-01	1
46595	2776	4283893	1986-07-31	1986-09-25	1
16261	962	40481087	1975-02-04	1975-02-25	1
20847	1253	40481087	1995-09-13	1995-10-04	1
18921	1137	260139	1959-03-14	1959-03-22	1
62552	3699	4109685	1994-10-12	1994-11-02	1
81876	4859	4112343	1983-06-10	1983-06-23	1
51907	3079	4112343	1986-04-28	1986-05-08	1
50673	3001	4310024	1979-07-10	1979-07-11	1
26838	1590	260139	1985-05-24	1985-06-07	1
51978	3081	40481087	1971-06-14	1971-06-28	1
73036	4343	40481087	1962-10-12	1962-10-19	1
50061	2960	28060	1955-03-07	1955-03-14	1
50208	2970	4112343	1980-06-14	1980-06-22	1
30828	1826	260139	1997-12-25	1998-01-08	1
21960	1316	4296204	1959-12-28	1960-01-18	1
32979	1958	192671	2010-10-01	2010-10-02	1
35889	2130	40481087	1988-09-20	1988-10-11	1
49195	2913	4112343	1973-02-27	1973-03-09	1
77777	4613	40481087	2018-07-18	2018-08-08	1
55676	3298	81151	2018-06-28	2018-07-26	1
57556	3418	260139	1991-07-09	1991-07-23	1
51765	3072	4294548	2012-11-05	2012-12-17	1
76361	4532	40481087	1954-01-19	1954-02-09	1
53217	3157	80180	1986-05-12	1986-05-13	1
60210	3567	40481087	2001-07-13	2001-08-03	1
6503	384	40481087	1979-04-13	1979-04-27	1
43904	2616	81151	1996-02-23	1996-03-22	1
18556	1117	372328	1936-09-18	1936-10-31	1
74116	4406	4116491	1978-01-08	1978-02-15	1
24280	1448	4112343	1986-04-05	1986-04-14	1
54221	3215	378001	2010-03-28	2010-04-27	1
19333	1159	4112343	2002-09-02	2002-09-10	1
77419	4591	4156265	2018-04-08	2018-04-29	1
62044	3667	28060	1977-09-15	1977-09-27	1
47648	2835	260139	2004-11-11	2004-11-18	1
51180	3035	372328	1990-04-08	1992-11-06	1
58648	3483	81151	1996-11-09	1996-12-14	1
55189	3272	257012	2003-05-04	2003-12-28	1
13846	820	28060	1969-05-09	1969-05-22	1
45764	2724	28060	1974-11-17	1974-11-29	1
59801	3547	192671	2014-07-17	2014-07-18	1
21527	1292	4112343	1965-10-09	1965-10-19	1
76104	4521	4112343	1987-02-23	1987-03-07	1
47528	2829	80180	1988-01-13	1988-01-14	1
33232	1975	40481087	1931-12-28	1932-01-18	1
32402	1926	260139	2000-01-06	2000-01-20	1
53250	3158	4001336	1956-05-20	1956-07-19	1
75305	4475	40481087	2005-08-27	2005-09-17	1
46596	2776	4285898	2013-02-18	2013-02-19	1
16262	962	257012	1965-09-19	1965-09-20	1
20848	1253	260139	2012-07-05	2012-07-19	1
18922	1137	317576	1983-08-12	1983-08-13	1
62553	3699	4310024	2011-04-01	2011-04-02	1
81877	4859	4134304	1982-07-11	1982-09-09	1
51908	3079	4283893	2006-06-18	2006-10-15	1
50674	3001	40481087	1951-04-03	1951-04-10	1
26839	1590	260139	2006-10-23	2006-11-05	1
51979	3081	40481087	1977-06-04	1977-06-18	1
73776	4388	28060	2000-04-04	2000-04-15	1
50062	2960	80180	1988-10-12	1988-10-13	1
50209	2970	40481087	1977-12-14	1977-12-28	1
30829	1826	372328	1940-01-27	1940-02-10	1
21961	1316	40481087	1958-07-14	1958-08-04	1
32980	1958	4285898	2010-03-04	2010-03-05	1
35890	2130	40481087	2012-10-29	2012-11-19	1
49196	2913	4152936	2002-05-14	2002-06-04	1
77778	4613	28060	2005-10-07	2005-10-16	1
55677	3298	40481087	1993-03-20	1993-04-10	1
57557	3418	372328	1949-07-17	1949-10-02	1
51766	3072	40481087	1959-10-21	1959-11-11	1
76362	4532	40481087	1954-08-17	1954-08-31	1
53218	3157	81151	1966-09-17	1966-10-15	1
60211	3567	372328	1972-11-29	1973-06-14	1
6504	384	80180	1996-05-11	1996-05-12	1
43905	2616	81151	2017-04-01	2017-04-29	1
18557	1117	4146173	1947-10-03	1947-11-02	1
74117	4406	40481087	1955-04-23	1955-05-07	1
24281	1448	4112343	1996-11-07	1996-11-20	1
54222	3215	4112343	1978-06-02	1978-06-14	1
19334	1159	40481087	1981-07-28	1981-08-04	1
77420	4591	4266809	1995-01-26	1995-01-27	1
62045	3667	81151	1972-03-16	1972-04-06	1
47649	2835	378001	1927-08-17	1927-10-16	1
51181	3035	4218389	1972-04-06	1972-04-27	1
58649	3483	4112343	1976-12-11	1976-12-19	1
55190	3272	4283893	2003-03-16	2003-12-28	1
13847	820	28060	1999-06-09	1999-06-18	1
45765	2724	81151	1962-09-13	1962-10-04	1
59802	3547	4112343	1982-10-23	1982-11-03	1
21528	1292	4218389	1987-01-20	1987-02-17	1
76105	4521	4112343	1991-09-23	1991-10-06	1
47529	2829	260139	1959-01-21	1959-02-04	1
33233	1975	28060	1952-11-21	1952-12-04	1
32403	1926	260139	2016-01-11	2016-01-18	1
53251	3158	4112343	1996-08-31	1996-09-08	1
75306	4475	40481087	2017-08-04	2017-08-11	1
46597	2776	40481087	1981-11-15	1981-11-22	1
16263	962	4112343	1951-02-09	1951-02-22	1
20849	1253	260139	2017-01-28	2017-02-04	1
18923	1137	378001	1956-02-11	1956-03-12	1
62554	3699	40481087	1991-08-05	1991-08-26	1
81878	4859	80180	1993-11-01	1993-11-02	1
51909	3079	4296205	2014-04-04	2014-05-09	1
50675	3001	40481087	1980-01-08	1980-01-15	1
26840	1590	4112343	1964-09-11	1964-09-21	1
53973	3199	260139	1989-05-08	1989-05-15	1
73777	4388	378001	1987-06-11	1987-08-10	1
50063	2960	4112343	1956-01-11	1956-01-18	1
50210	2970	40481087	1991-10-07	1991-10-14	1
30830	1826	4112343	1945-08-02	1945-08-13	1
21962	1316	40481087	1984-07-17	1984-07-24	1
34608	2058	40479422	2013-08-09	2013-09-15	1
35891	2130	80180	1996-05-12	1996-05-13	1
49197	2913	4112343	1956-12-28	1957-01-09	1
77779	4613	260139	2018-05-21	2018-06-04	1
55678	3298	40481087	2006-09-07	2006-09-28	1
69631	4124	81151	1985-08-29	1985-09-12	1
51767	3072	40481087	1961-12-08	1961-12-15	1
76363	4532	40481087	1968-04-22	1968-04-29	1
53219	3157	195588	2008-06-20	2008-08-01	1
60212	3567	4112343	2003-07-22	2003-08-04	1
6505	384	260139	1966-04-30	1966-05-14	1
43906	2616	4112343	2009-10-08	2009-10-21	1
18558	1117	4218389	1984-05-03	1984-05-24	1
74118	4406	40481087	2017-06-18	2017-07-02	1
24282	1448	4310024	2007-05-19	2007-05-20	1
54223	3215	40481087	1987-09-20	1987-10-11	1
19335	1159	40481087	1997-07-26	1997-08-16	1
77421	4591	80180	1995-01-26	1995-01-27	1
62046	3667	260139	2007-10-05	2007-10-19	1
47650	2835	381316	1988-07-05	1988-07-06	1
51182	3035	4266809	2004-09-30	2004-10-01	1
58650	3483	4112343	1984-06-14	1984-06-24	1
55191	3272	40481087	1999-04-02	1999-04-16	1
13848	820	80180	2004-12-27	2004-12-28	1
45766	2724	439777	2013-05-08	2013-05-09	1
59803	3547	40481087	1975-09-20	1975-10-04	1
21529	1292	40479768	1999-01-15	1999-03-23	1
76106	4521	4112343	2006-10-19	2006-10-31	1
47530	2829	440086	1958-09-02	1968-09-09	1
33234	1975	80180	1957-04-23	1957-04-24	1
32404	1926	378001	2014-03-12	2014-05-11	1
53252	3158	4113008	1974-05-03	1974-05-17	1
75307	4475	260139	1992-10-06	1992-10-13	1
46598	2776	40481087	2016-01-04	2016-01-11	1
16264	962	4294548	1961-10-30	1962-01-15	1
20850	1253	372328	1960-11-24	1961-02-22	1
18924	1137	378001	1965-10-21	1965-12-20	1
62555	3699	40481087	2007-11-01	2007-11-15	1
81879	4859	260139	1956-08-29	1956-09-12	1
54461	3229	375671	2000-12-14	2001-01-13	1
50676	3001	40481087	1984-02-13	1984-02-20	1
26841	1590	4112343	1989-09-16	1989-09-25	1
53974	3199	260139	2009-12-28	2010-01-11	1
73778	4388	4112343	1983-04-07	1983-04-17	1
50064	2960	4112343	2008-05-25	2008-06-06	1
50211	2970	40481087	1994-06-06	1994-06-20	1
30831	1826	4112343	1949-06-25	1949-07-03	1
21963	1316	40481087	1997-11-20	1997-12-11	1
34609	2058	80180	2000-08-03	2000-08-04	1
35892	2130	260139	1982-02-14	1982-02-28	1
49198	2913	4112343	2003-04-19	2003-04-29	1
77780	4613	4001336	2014-08-04	2014-10-03	1
55679	3298	28060	1984-06-02	1984-06-13	1
69632	4124	4112343	1980-05-30	1980-06-09	1
51768	3072	40481087	1969-05-15	1969-05-22	1
76364	4532	81151	1974-06-10	1974-06-24	1
53220	3157	260139	1984-06-17	1984-07-01	1
60213	3567	4112343	2010-03-01	2010-03-10	1
6506	384	260139	2008-02-10	2008-02-17	1
43907	2616	4283893	1990-03-06	1990-05-01	1
18559	1117	4285898	1978-03-02	1978-03-03	1
74119	4406	372328	2004-07-06	2005-02-05	1
24283	1448	4112343	2008-10-19	2008-10-26	1
54224	3215	40481087	2010-11-08	2010-11-15	1
19336	1159	40481087	2011-08-17	2011-08-31	1
77422	4591	260139	2003-03-19	2003-03-26	1
62047	3667	372328	1972-05-15	1972-06-13	1
47651	2835	4112343	1936-09-07	1936-09-20	1
51183	3035	4278672	1968-05-27	1968-07-26	1
58651	3483	40481087	1956-03-07	1956-03-28	1
55192	3272	372328	1971-08-03	1971-08-17	1
13849	820	4112343	1978-07-20	1978-07-30	1
45767	2724	40481087	1985-01-01	1985-01-15	1
59804	3547	80180	2014-05-23	2014-05-24	1
21530	1292	40481087	2014-12-12	2014-12-19	1
76107	4521	4113008	1951-12-07	1951-12-28	1
47531	2829	4112343	1968-01-05	1968-01-12	1
33235	1975	378001	1966-01-05	1966-02-04	1
32405	1926	4112343	1978-11-10	1978-11-23	1
53253	3158	4218389	1967-04-07	1967-05-12	1
75308	4475	260139	2016-01-19	2016-02-02	1
46599	2776	81893	2012-03-25	2012-03-26	1
16265	962	4294548	1965-09-05	1966-01-16	1
20851	1253	4059173	1975-08-05	1975-10-04	1
18925	1137	4112343	1973-11-19	1973-11-28	1
62556	3699	81893	2012-01-26	2012-01-27	1
81880	4859	372328	1969-03-24	1969-11-02	1
54462	3229	4155034	2014-11-22	2014-12-13	1
50677	3001	40481087	2002-12-01	2002-12-15	1
26842	1590	4146173	2005-10-09	2005-11-07	1
53975	3199	378001	1986-05-21	1986-07-20	1
73779	4388	4112343	2004-12-24	2005-01-04	1
50065	2960	4283893	1993-05-08	1993-08-07	1
50212	2970	40481087	1998-10-20	1998-11-03	1
30832	1826	4283893	1963-02-16	1963-03-09	1
24784	1480	81151	2000-10-24	2000-11-07	1
34610	2058	4112343	2016-03-19	2016-03-26	1
35893	2130	372328	1974-12-04	1975-03-27	1
49199	2913	4283893	1957-11-05	1957-12-03	1
77781	4613	4112343	1976-11-28	1976-12-07	1
55680	3298	81151	1979-12-06	1979-12-20	1
69633	4124	4283893	1996-01-11	1996-02-22	1
51769	3072	40481087	2013-08-22	2013-09-05	1
76365	4532	140673	1964-04-03	1964-04-04	1
53221	3157	372328	1952-12-31	1953-03-13	1
60214	3567	40481087	2011-02-25	2011-03-11	1
6507	384	4113008	2003-07-03	2003-07-17	1
43908	2616	4294548	1996-01-07	1996-03-31	1
18560	1117	4296204	1982-05-16	1982-06-13	1
74120	4406	378001	1947-09-22	1947-10-22	1
24284	1448	4112343	2008-11-28	2008-12-07	1
56022	3321	81151	1980-01-09	1980-01-30	1
19337	1159	40481087	2013-03-30	2013-04-13	1
77423	4591	375671	1959-04-15	1959-05-15	1
62048	3667	4116491	2000-07-02	2000-08-07	1
47652	2835	4134304	1913-11-07	1913-12-07	1
51184	3035	4294548	1991-01-21	1991-02-11	1
58652	3483	40481087	2001-03-04	2001-03-11	1
55193	3272	372328	1972-01-14	1972-05-16	1
13850	820	4283893	2002-08-05	2003-02-03	1
46457	2770	260139	1961-10-09	1961-10-23	1
59805	3547	4112343	2009-06-28	2009-07-05	1
21531	1292	260139	1981-06-24	1981-07-08	1
76108	4521	4134304	1996-12-15	1997-02-13	1
47532	2829	40481087	1961-01-02	1961-01-16	1
33236	1975	440086	1936-02-08	1940-02-17	1
32406	1926	4112343	1987-07-23	1987-08-03	1
53254	3158	4294548	2000-03-15	2000-04-05	1
75309	4475	4218389	2008-05-14	2008-06-04	1
46600	2776	134438	2005-07-12	2006-05-09	1
16266	962	4296205	1962-02-01	1962-03-08	1
20852	1253	4112343	2004-03-18	2004-03-26	1
18926	1137	4112343	1996-06-03	1996-06-15	1
62557	3699	4112343	1985-07-16	1985-07-23	1
81881	4859	4112343	1972-03-01	1972-03-09	1
54463	3229	4283893	2018-05-25	2018-06-15	1
50678	3001	40481087	2016-11-25	2016-12-09	1
27019	1600	28060	1959-11-30	1959-12-13	1
53976	3199	4166224	2006-01-25	2006-01-26	1
73780	4388	40481087	1990-11-10	1990-11-24	1
50066	2960	28060	1969-05-06	1969-05-13	1
50213	2970	40481087	2008-01-02	2008-01-23	1
30833	1826	40481087	1949-10-25	1949-11-08	1
24785	1480	260139	1971-10-24	1971-11-07	1
34611	2058	4116491	2008-10-15	2008-11-30	1
35894	2130	4112343	1971-08-24	1971-09-02	1
49200	2913	40481087	2007-09-20	2007-09-27	1
77782	4613	4218389	1967-04-17	1967-05-22	1
55681	3298	260139	1985-05-04	1985-05-18	1
69634	4124	40481087	1981-10-12	1981-10-26	1
51770	3072	80180	2003-05-23	2003-05-24	1
76366	4532	260139	1983-02-02	1983-02-16	1
53222	3157	372328	1957-10-29	1958-06-20	1
60215	3567	260139	1991-12-21	1992-01-04	1
6508	384	4156265	1967-12-25	1968-01-08	1
43909	2616	40481087	2003-09-15	2003-09-29	1
18561	1117	40481087	1945-01-22	1945-02-05	1
74121	4406	4218389	1975-04-28	1975-05-19	1
24285	1448	40481087	1982-04-19	1982-05-10	1
56023	3321	372328	2014-04-10	2017-01-30	1
19338	1159	80180	2014-11-30	2014-12-01	1
77424	4591	4112343	1991-12-26	1992-01-07	1
62049	3667	4294548	1972-03-11	1972-06-10	1
47653	2835	4296205	1983-01-28	1983-02-11	1
51185	3035	40481087	1976-11-04	1976-11-11	1
58653	3483	40481087	2010-09-09	2010-09-23	1
55194	3272	4285898	2004-04-21	2004-04-22	1
13851	820	40481087	1968-09-03	1968-09-24	1
46458	2770	381316	2015-08-15	2015-08-16	1
59806	3547	40481087	1980-02-15	1980-02-22	1
21532	1292	4156265	1972-02-26	1972-03-11	1
76109	4521	4142905	1972-05-11	1972-08-09	1
47533	2829	40481087	1984-04-20	1984-04-27	1
33237	1975	4029498	1973-01-29	1973-01-30	1
32407	1926	4285898	2005-08-20	2005-08-21	1
53255	3158	4294548	2001-07-08	2001-07-15	1
75310	4475	40481087	2004-06-12	2004-06-26	1
46601	2776	372328	1978-05-28	1978-06-18	1
16267	962	4310024	1992-11-29	1992-11-30	1
20853	1253	40481087	2002-01-04	2002-01-25	1
18927	1137	40481087	1968-06-10	1968-06-24	1
62558	3699	4112343	2008-08-23	2008-09-01	1
81882	4859	4112343	1999-10-29	1999-11-05	1
54464	3229	40481087	1991-01-05	1991-01-12	1
50679	3001	28060	1995-01-04	1995-01-15	1
27020	1600	80180	1978-01-12	1978-01-13	1
53977	3199	80180	2009-06-11	2009-06-12	1
73781	4388	28060	1967-05-02	1967-05-09	1
50067	2960	257012	1993-07-17	1993-07-18	1
50214	2970	28060	1980-01-31	1980-02-11	1
30834	1826	40481087	1978-09-21	1978-10-12	1
24786	1480	260139	1989-05-06	1989-05-13	1
34612	2058	4266809	2000-08-03	2000-08-04	1
35895	2130	4112343	1977-02-18	1977-03-03	1
49201	2913	80180	1979-06-05	1979-06-06	1
77783	4613	40481087	1999-12-04	1999-12-25	1
55682	3298	372328	1975-11-22	1976-07-25	1
69635	4124	260139	2013-03-22	2013-03-29	1
51771	3072	257012	2012-12-03	2012-12-04	1
76367	4532	372328	1911-03-08	1911-03-22	1
53223	3157	4112343	1965-01-13	1965-01-20	1
60216	3567	260139	2002-06-29	2002-07-13	1
6509	384	40481087	1978-05-29	1978-06-12	1
43910	2616	40481087	2008-12-21	2009-01-11	1
18562	1117	40481087	2006-01-16	2006-01-23	1
74122	4406	40481087	1943-07-20	1943-07-27	1
24286	1448	40481087	2002-03-10	2002-03-31	1
56024	3321	40481087	1997-10-05	1997-10-26	1
19339	1159	260139	2010-11-05	2010-11-19	1
77425	4591	4112343	2016-06-16	2016-06-28	1
62050	3667	40481087	1971-05-26	1971-06-09	1
47654	2835	40481087	1919-08-17	1919-08-24	1
51186	3035	260139	1995-04-07	1995-04-14	1
58654	3483	260139	1965-10-20	1965-10-27	1
55195	3272	40481087	1974-09-14	1974-10-05	1
13852	820	40481087	1990-10-15	1990-10-29	1
46459	2770	4059173	2009-10-09	2009-11-08	1
59807	3547	40481087	1986-05-25	1986-06-01	1
21533	1292	4218389	1960-05-24	1960-06-28	1
76110	4521	40481087	1939-11-12	1939-11-26	1
47534	2829	40481087	2015-03-07	2015-03-14	1
33238	1975	40481087	1965-08-27	1965-09-17	1
32408	1926	4294548	1995-07-25	1995-08-01	1
53256	3158	28060	1986-02-25	1986-03-09	1
75311	4475	40481087	2012-12-14	2012-12-28	1
46602	2776	372328	1982-01-28	1982-10-03	1
16268	962	40481087	1951-08-15	1951-09-05	1
20854	1253	40481087	2005-03-16	2005-03-23	1
20952	1259	78272	1991-02-15	1991-03-01	1
62559	3699	4112343	2010-01-25	2010-02-06	1
81883	4859	4294548	2010-04-18	2011-01-16	1
54465	3229	257012	2001-01-17	2001-01-18	1
50680	3001	80180	1981-12-26	1981-12-27	1
27021	1600	4134304	1978-08-26	1978-10-25	1
53978	3199	372328	1975-08-19	1976-01-07	1
73782	4388	28060	2006-05-02	2006-05-15	1
50068	2960	260139	2011-11-16	2011-11-23	1
50215	2970	28060	2017-05-23	2017-05-30	1
30835	1826	40481087	2010-09-20	2010-09-27	1
24787	1480	4113008	1974-09-06	1974-09-20	1
34613	2058	40481087	1974-05-02	1974-05-09	1
35896	2130	4112343	2008-04-21	2008-05-03	1
49202	2913	260139	1964-02-20	1964-02-27	1
77784	4613	40481087	2001-02-23	2001-03-16	1
55683	3298	4109685	1976-01-12	1976-01-26	1
69636	4124	4109685	1977-02-28	1977-03-14	1
51772	3072	260139	1983-03-15	1983-03-22	1
76368	4532	378419	1989-03-04	1989-03-05	1
53224	3157	4112343	1970-06-07	1970-06-19	1
60217	3567	40481087	1992-03-11	1992-03-25	1
6510	384	195588	2013-05-17	2013-07-04	1
43911	2616	260139	1987-04-24	1987-05-08	1
18563	1117	257012	1992-12-17	1992-12-18	1
77039	4570	260139	1991-12-21	1991-12-28	1
24287	1448	40481087	2019-04-17	2019-04-24	1
56025	3321	40481087	2007-05-09	2007-05-16	1
19340	1159	372328	1980-09-24	1980-11-01	1
77426	4591	40481087	1974-10-30	1974-11-06	1
62051	3667	40481087	1986-08-20	1986-09-03	1
47655	2835	40481087	1949-09-02	1949-09-23	1
51187	3035	4027663	1995-12-12	1995-12-13	1
58655	3483	260139	2006-06-25	2006-07-09	1
55196	3272	260139	1988-01-07	1988-01-14	1
13853	820	40481087	1995-09-06	1995-09-13	1
46460	2770	4112343	1933-11-22	1933-11-29	1
59808	3547	40481087	1994-05-29	1994-06-12	1
21534	1292	40481087	1974-11-14	1974-12-05	1
76111	4521	40481087	1950-06-28	1950-07-12	1
47535	2829	140673	2017-08-18	2017-08-19	1
33239	1975	40481087	1969-05-05	1969-05-12	1
32409	1926	40481087	1980-03-26	1980-04-16	1
53257	3158	81151	1971-09-18	1971-10-16	1
75832	4503	260139	1944-07-11	1944-07-18	1
46603	2776	80180	2014-01-14	2014-01-15	1
16269	962	40481087	2005-01-06	2005-01-20	1
20855	1253	80180	1997-03-13	1997-03-14	1
20953	1259	134438	1981-03-28	1983-11-18	1
62560	3699	4112343	2017-06-01	2017-06-12	1
81884	4859	40481087	1983-06-25	1983-07-02	1
54466	3229	4112343	1991-04-10	1991-04-23	1
50681	3001	81151	1958-10-09	1958-11-13	1
27022	1600	372328	1945-12-26	1946-03-04	1
53979	3199	378001	1998-05-18	1998-07-17	1
73783	4388	260139	1981-06-03	1981-06-10	1
50069	2960	4112343	1961-12-30	1962-01-12	1
50216	2970	80180	2004-11-27	2004-11-28	1
30836	1826	40481087	2016-12-11	2016-12-18	1
24788	1480	4155034	1980-03-22	1980-04-12	1
34614	2058	40481087	1987-12-26	1988-01-16	1
35897	2130	4113008	1987-04-14	1987-04-28	1
49203	2913	4112343	1959-12-27	1960-01-05	1
77785	4613	260139	1996-09-21	1996-09-28	1
55684	3298	4152936	1972-08-09	1972-08-30	1
69637	4124	4112343	1976-03-08	1976-03-19	1
51773	3072	4112343	1998-08-14	1998-08-26	1
76369	4532	4112343	1939-02-22	1939-03-03	1
53225	3157	4112343	1972-01-13	1972-01-25	1
60218	3567	40481087	2010-07-15	2010-07-22	1
6511	384	260139	2014-04-18	2014-05-02	1
43912	2616	260139	1997-03-12	1997-03-26	1
18564	1117	260139	1974-05-03	1974-05-10	1
77040	4570	372328	1941-03-21	1941-11-29	1
24288	1448	28060	1981-05-19	1981-05-29	1
56026	3321	40481087	2011-06-02	2011-06-09	1
19341	1159	372328	1984-03-15	1984-06-30	1
77427	4591	40481087	2011-01-18	2011-02-08	1
65303	3866	78272	2000-08-15	2000-09-19	1
47656	2835	40481087	1963-06-05	1963-06-12	1
51188	3035	4109685	1978-02-25	1978-03-18	1
58656	3483	440086	1962-01-22	1964-10-12	1
55197	3272	40481087	1971-07-12	1971-07-26	1
13854	820	40481087	2017-09-21	2017-09-28	1
46461	2770	4112343	1935-06-23	1935-07-04	1
59809	3547	40481087	2016-06-23	2016-07-14	1
21535	1292	40481087	2011-05-30	2011-06-13	1
76112	4521	40481087	1961-06-23	1961-07-14	1
47536	2829	260139	1992-10-18	1992-11-01	1
33240	1975	192671	1957-06-15	1957-06-16	1
32410	1926	40481087	1992-05-27	1992-06-03	1
53258	3158	260139	1979-02-12	1979-02-26	1
75833	4503	260139	1992-06-11	1992-06-25	1
46604	2776	260139	1987-03-01	1987-03-08	1
18629	1122	80180	2004-01-28	2004-01-29	1
20856	1253	260139	2000-03-22	2000-04-05	1
20954	1259	4109685	2007-07-05	2007-07-19	1
62561	3699	4266809	2014-01-15	2014-01-16	1
81885	4859	40481087	1999-09-23	1999-10-07	1
54467	3229	40481087	1988-07-29	1988-08-12	1
50682	3001	260139	2013-02-02	2013-02-16	1
27023	1600	4112343	1993-04-04	1993-04-12	1
53980	3199	440448	2006-01-25	2006-01-26	1
73784	4388	260139	2017-09-13	2017-09-27	1
50070	2960	4112343	1976-06-20	1976-06-29	1
50217	2970	260139	1981-02-23	1981-03-02	1
30837	1826	30753	1977-05-22	1977-05-23	1
24789	1480	80180	2001-07-01	2001-07-02	1
34615	2058	40481087	1994-02-20	1994-02-27	1
35898	2130	4294548	1983-03-13	1983-05-22	1
49204	2913	4237458	1948-01-14	1948-02-13	1
77786	4613	372328	1971-08-08	1972-05-07	1
55685	3298	40481087	1976-11-24	1976-12-08	1
69638	4124	28060	2002-06-11	2002-06-19	1
51774	3072	0	1964-02-01	1964-02-02	1
76370	4532	4112343	1966-03-13	1966-03-21	1
53226	3157	4112343	2000-10-26	2000-11-03	1
61674	3647	30753	1968-12-07	1968-12-08	1
6512	384	372328	1961-08-23	1961-11-06	1
43913	2616	260139	2018-12-10	2018-12-24	1
18565	1117	4112343	1998-05-25	1998-06-06	1
77041	4570	381316	1991-09-21	1991-09-22	1
24289	1448	81893	2007-07-18	2007-07-19	1
56027	3321	40481087	2018-04-26	2018-05-17	1
19342	1159	372328	1986-05-21	1986-07-12	1
80449	4773	260139	1963-10-02	1963-10-09	1
65304	3866	80180	1990-02-18	1990-02-19	1
47657	2835	40481087	1981-07-25	1981-08-01	1
51189	3035	381316	2014-09-12	2014-09-13	1
58657	3483	4112343	1968-04-15	1968-04-24	1
55198	3272	40481087	2001-03-14	2001-03-21	1
13855	820	260139	1991-05-01	1991-05-08	1
46462	2770	4112343	1947-07-30	1947-08-08	1
59810	3547	81151	2018-01-23	2018-02-13	1
23902	1430	30753	1984-11-07	1984-11-08	1
76113	4521	40481087	1976-11-22	1976-11-29	1
47537	2829	372328	1951-01-02	1951-02-12	1
33241	1975	4142905	1923-01-07	1923-02-06	1
32411	1926	40481087	2008-04-29	2008-05-06	1
53259	3158	4112343	1949-12-24	1949-12-31	1
75834	4503	260139	1999-07-31	1999-08-14	1
46605	2776	4283893	1983-01-21	1983-02-11	1
18630	1122	378001	2005-10-14	2005-12-13	1
20857	1253	260139	2010-09-20	2010-09-27	1
20955	1259	4112343	1962-06-06	1962-06-18	1
62562	3699	40481087	2015-04-12	2015-05-03	1
84990	5060	80180	2009-10-09	2009-10-10	1
54468	3229	40481087	1994-05-04	1994-05-18	1
50683	3001	372328	1952-06-27	1953-02-03	1
27024	1600	4237458	1971-10-02	1971-12-31	1
53981	3199	4112343	1976-03-17	1976-03-30	1
73785	4388	4112343	1978-11-21	1978-11-28	1
50071	2960	4112343	1982-01-31	1982-02-08	1
50218	2970	378001	1990-01-05	1990-03-06	1
30838	1826	260139	2004-02-27	2004-03-05	1
24790	1480	260139	1982-02-23	1982-03-09	1
34616	2058	28060	2001-06-26	2001-07-03	1
35899	2130	40481087	1972-09-07	1972-09-28	1
49205	2913	40481087	1949-05-16	1949-05-23	1
77787	4613	4146173	1973-10-17	1973-12-16	1
57221	3399	30753	2015-02-19	2015-02-20	1
69639	4124	80180	2014-03-01	2014-03-02	1
51775	3072	257012	1999-01-30	1999-07-10	1
76371	4532	4155034	1956-10-21	1956-11-11	1
53227	3157	4112343	2002-11-27	2002-12-05	1
61675	3647	4112343	1943-06-30	1943-07-07	1
6513	384	4112343	1975-03-07	1975-03-15	1
43914	2616	372328	1953-09-17	1953-11-03	1
18566	1117	40481087	1936-02-27	1936-03-05	1
77042	4570	4112343	1958-12-12	1958-12-19	1
24290	1448	4112343	1993-10-08	1993-10-21	1
56028	3321	28060	1977-06-26	1977-07-03	1
19343	1159	40481087	1994-03-22	1994-04-05	1
80450	4773	260139	1977-12-26	1978-01-02	1
65305	3866	81151	2003-07-06	2003-07-27	1
47658	2835	40481087	2014-05-16	2014-05-30	1
51190	3035	4112343	1985-02-22	1985-03-04	1
58658	3483	4112343	2017-09-03	2017-09-14	1
55199	3272	40481087	2007-08-15	2007-08-29	1
13856	820	372328	1970-03-12	1970-05-21	1
46463	2770	4112343	1951-05-22	1951-06-02	1
59811	3547	257012	1981-08-18	1981-08-19	1
23903	1430	81893	1984-01-12	1984-01-13	1
76114	4521	80502	2008-11-13	2008-11-14	1
47538	2829	372328	1952-06-06	1952-08-11	1
33242	1975	40481087	1948-02-19	1948-03-04	1
32412	1926	80180	2006-06-16	2006-06-17	1
53260	3158	4112343	1958-12-04	1958-12-15	1
75835	4503	4112343	1977-04-06	1977-04-13	1
46606	2776	40481087	2002-11-01	2002-11-15	1
18631	1122	4156265	1991-09-07	1991-09-28	1
20858	1253	260139	2012-04-20	2012-05-04	1
20956	1259	4112343	1981-07-12	1981-07-21	1
62563	3699	30753	2012-09-22	2012-09-23	1
84991	5060	260139	2004-09-07	2004-09-21	1
54469	3229	40481087	2019-01-20	2019-02-10	1
50684	3001	375671	1949-03-09	1949-05-08	1
27025	1600	40481087	1968-05-13	1968-06-03	1
53982	3199	4112343	2010-07-04	2010-07-12	1
73786	4388	4112343	1996-05-10	1996-05-23	1
50072	2960	4112343	1998-02-18	1998-03-03	1
50219	2970	4134304	2015-01-15	2015-02-14	1
30839	1826	260139	2017-02-27	2017-03-13	1
24791	1480	260139	2006-04-11	2006-04-18	1
34617	2058	81893	1998-07-15	1998-07-16	1
35900	2130	40481087	1990-06-10	1990-06-17	1
49206	2913	40481087	1978-05-26	1978-06-16	1
77788	4613	4146173	1994-10-18	1994-11-17	1
57222	3399	260139	1987-01-18	1987-01-25	1
69640	4124	4112343	1988-05-30	1988-06-12	1
51776	3072	372328	1960-08-11	1960-09-24	1
76372	4532	40481087	1917-07-10	1917-07-24	1
53228	3157	4283893	1996-01-05	1996-01-19	1
61676	3647	40481087	1988-11-28	1988-12-05	1
6514	384	4112343	1991-04-22	1991-05-03	1
43915	2616	372328	1954-11-28	1955-05-03	1
18567	1117	40481087	1968-08-12	1968-09-02	1
77043	4570	4294548	1985-11-12	1986-01-07	1
24291	1448	40481087	1984-10-01	1984-10-22	1
56029	3321	260139	2013-02-16	2013-02-23	1
19344	1159	40481087	2001-11-28	2001-12-12	1
80451	4773	4112343	1967-07-12	1967-07-25	1
65306	3866	260139	2009-12-03	2009-12-10	1
47659	2835	81151	1956-07-15	1956-08-19	1
51191	3035	4112343	2016-02-04	2016-02-11	1
58659	3483	4146173	2000-11-23	2000-12-23	1
55200	3272	80180	2004-09-18	2004-09-19	1
13857	820	4001336	1977-07-12	1977-08-11	1
46464	2770	4112343	1951-07-04	1951-07-17	1
59812	3547	260139	1987-02-16	1987-02-23	1
23904	1430	260139	1971-12-16	1971-12-23	1
76115	4521	260139	1967-08-16	1967-08-23	1
47539	2829	40481087	1958-08-02	1958-08-09	1
33243	1975	40481087	1959-06-14	1959-06-21	1
32413	1926	372328	1973-03-26	1973-09-15	1
54968	3258	28060	1989-04-26	1989-05-03	1
75836	4503	40481087	1937-08-20	1937-09-03	1
46607	2776	40481087	2014-10-22	2014-11-05	1
18632	1122	40481087	1992-05-27	1992-06-17	1
20859	1253	372328	1956-12-28	1957-02-13	1
20957	1259	4112343	1997-10-11	1997-10-18	1
62564	3699	257012	1996-12-14	1996-12-15	1
84992	5060	4134304	2012-10-23	2012-12-22	1
54470	3229	80180	2019-04-14	2019-04-15	1
50685	3001	378001	2000-11-12	2000-12-12	1
27026	1600	260139	2008-08-06	2008-08-13	1
53983	3199	4112343	2015-07-17	2015-07-30	1
73787	4388	4278672	1975-01-15	1975-03-16	1
50073	2960	4156265	2009-03-24	2009-04-07	1
50220	2970	4285898	2004-10-28	2004-10-29	1
30840	1826	378001	2000-03-26	2000-05-25	1
24792	1480	378001	1996-11-14	1997-01-13	1
34618	2058	260139	1972-09-26	1972-10-03	1
35901	2130	40481087	2014-06-19	2014-06-26	1
49207	2913	4112343	1989-09-15	1989-09-28	1
77789	4613	40481087	1999-10-16	1999-10-30	1
57223	3399	4112343	2018-10-03	2018-10-12	1
69641	4124	4112343	1988-12-10	1988-12-18	1
51777	3072	4112343	1969-12-09	1969-12-17	1
76373	4532	40481087	1926-05-14	1926-05-21	1
53229	3157	4285898	1985-11-13	1985-11-14	1
61677	3647	40481087	2003-09-04	2003-09-11	1
6515	384	4112343	2004-03-06	2004-03-13	1
43916	2616	40481087	2005-07-28	2005-08-04	1
18568	1117	40481087	1988-03-27	1988-04-03	1
77044	4570	40480160	2003-08-10	2003-09-09	1
26082	1550	260139	1993-05-07	1993-05-14	1
56030	3321	4152936	1991-03-17	1991-03-31	1
19345	1159	40481087	2014-07-14	2014-07-28	1
80452	4773	40481087	1992-10-06	1992-10-27	1
65307	3866	372328	1953-03-24	1953-09-15	1
47660	2835	81151	1988-11-11	1988-11-25	1
51192	3035	40481087	1968-02-04	1968-02-11	1
58660	3483	40481087	1969-08-24	1969-08-31	1
55201	3272	4027663	1996-06-02	1996-06-03	1
13858	820	4112343	1980-10-19	1980-10-29	1
46465	2770	4112343	1953-07-08	1953-07-18	1
59813	3547	372328	1972-10-30	1972-12-18	1
23905	1430	4109685	1972-02-24	1972-03-09	1
76116	4521	260139	1996-05-06	1996-05-20	1
47540	2829	4112343	1966-05-06	1966-05-13	1
33244	1975	28060	1932-07-22	1932-07-29	1
32414	1926	372328	1974-09-12	1975-03-22	1
54969	3258	28060	2010-09-15	2010-09-28	1
75837	4503	40481087	1981-01-25	1981-02-01	1
47475	2827	28060	1923-01-21	1923-02-03	1
18633	1122	40481087	2004-08-22	2004-09-12	1
20860	1253	4112343	1977-05-14	1977-05-22	1
20958	1259	40481087	1962-01-06	1962-01-27	1
62565	3699	4027663	2001-07-07	2001-07-08	1
84993	5060	40481087	2000-09-01	2000-09-22	1
54471	3229	372328	1984-03-13	1984-05-18	1
50686	3001	4112343	2019-02-21	2019-03-03	1
27027	1600	4112343	1952-10-24	1952-11-03	1
53984	3199	40481087	1979-03-07	1979-03-21	1
73788	4388	40479422	1996-10-21	1996-12-27	1
50074	2960	40481087	2017-01-19	2017-01-26	1
50221	2970	4112343	1990-07-03	1990-07-12	1
30841	1826	4027663	1971-02-28	1971-03-01	1
24793	1480	440086	1975-01-19	1975-02-16	1
34619	2058	4027663	1992-10-19	1992-10-20	1
37719	2238	4051466	1971-08-11	1987-11-15	1
49208	2913	4294548	2014-12-28	2015-03-29	1
77790	4613	40481087	2002-08-15	2002-09-05	1
57224	3399	4218389	2019-01-29	2019-02-19	1
69642	4124	40481087	1973-08-26	1973-09-16	1
51778	3072	40481087	1986-02-28	1986-03-14	1
76374	4532	40481087	1969-11-28	1969-12-12	1
53230	3157	4294548	2008-01-02	2008-04-16	1
61678	3647	28060	1940-08-05	1940-08-13	1
6516	384	40481087	1980-11-24	1980-12-08	1
49483	2929	372328	1975-10-11	1975-10-25	1
18569	1117	40481087	2012-09-23	2012-10-07	1
77045	4570	40481087	1958-10-04	1958-10-18	1
26083	1550	4112343	1993-10-08	1993-10-21	1
56031	3321	40481087	1982-01-01	1982-01-08	1
19346	1159	4112343	2012-09-19	2012-09-26	1
80453	4773	28060	1961-04-02	1961-04-10	1
65308	3866	4218389	1955-05-13	1955-06-10	1
47661	2835	257012	1938-06-24	1938-06-25	1
51193	3035	40481087	1979-07-07	1979-07-14	1
58661	3483	40481087	1972-06-13	1972-07-04	1
55202	3272	4112343	1979-07-26	1979-08-03	1
13859	820	4112343	2008-05-02	2008-05-15	1
46466	2770	4112343	1981-04-26	1981-05-06	1
59814	3547	372328	1973-12-13	1974-06-17	1
23906	1430	4134304	1955-05-24	1955-08-22	1
76117	4521	313217	2000-06-08	2000-06-09	1
47541	2829	4112343	1979-05-17	1979-05-30	1
33245	1975	28060	1961-09-21	1961-09-30	1
32415	1926	372328	1988-09-20	1989-08-12	1
54970	3258	260139	1990-12-23	1990-12-30	1
75838	4503	40481087	2004-07-24	2004-07-31	1
47476	2827	80180	1958-04-08	1958-04-09	1
18634	1122	78272	1976-11-10	1976-11-24	1
20861	1253	40481087	2000-06-16	2000-07-07	1
20959	1259	28060	1990-10-03	1990-10-16	1
62566	3699	4285898	2013-05-20	2013-05-21	1
84994	5060	372328	1976-12-31	1977-03-07	1
54472	3229	4112343	1999-01-15	1999-01-26	1
50687	3001	40481087	1967-10-01	1967-10-15	1
27028	1600	4112343	1967-08-04	1967-08-15	1
53985	3199	40481087	1985-04-27	1985-05-11	1
73789	4388	40481087	1967-11-21	1967-12-05	1
54738	3242	4112343	1999-02-23	1999-03-04	1
50222	2970	4266809	2004-11-27	2004-11-28	1
30842	1826	4035415	1964-05-04	1964-06-03	1
24794	1480	4112343	1993-01-24	1993-02-02	1
34620	2058	40481087	1999-11-05	1999-11-12	1
37720	2238	40481087	1979-06-15	1979-06-22	1
49209	2913	40481087	1952-12-10	1952-12-31	1
77791	4613	80180	2003-06-27	2003-06-28	1
57225	3399	40481087	1987-06-26	1987-07-10	1
69643	4124	4146173	1991-03-15	1991-04-14	1
51779	3072	40481087	1992-08-16	1992-09-06	1
76375	4532	40481087	1983-06-30	1983-07-07	1
53231	3157	40481087	1956-12-16	1956-12-23	1
61679	3647	257012	1997-06-01	1997-06-02	1
6517	384	40481087	2010-09-11	2010-09-25	1
49484	2929	4112343	1994-01-06	1994-01-15	1
18570	1117	30753	1977-11-02	1977-11-03	1
77046	4570	40481087	1973-03-24	1973-04-14	1
26084	1550	4278672	1981-02-07	1981-05-08	1
56032	3321	40481087	2014-01-31	2014-02-07	1
19347	1159	40481087	1985-12-17	1986-01-07	1
80454	4773	81151	1989-01-21	1989-02-11	1
65309	3866	40481087	1952-10-08	1952-10-29	1
47662	2835	260139	1915-10-29	1915-11-05	1
51194	3035	40481087	2015-07-11	2015-08-01	1
58662	3483	40481087	1984-09-08	1984-09-22	1
55203	3272	4112343	1982-11-17	1982-11-26	1
13860	820	40481087	1969-03-02	1969-03-16	1
46467	2770	40481087	1934-04-23	1934-05-14	1
59815	3547	372328	1976-02-07	1976-06-28	1
23907	1430	40481087	1949-11-26	1949-12-17	1
76118	4521	375671	1978-08-08	1978-09-07	1
47542	2829	4112343	1989-01-08	1989-01-15	1
33246	1975	372328	1927-04-16	1928-01-28	1
32416	1926	4112343	1978-07-02	1978-07-10	1
54971	3258	4112343	1991-04-27	1991-05-06	1
75839	4503	313217	2014-04-01	2014-04-02	1
47477	2827	260139	1945-07-21	1945-08-04	1
18635	1122	372328	1985-11-23	1986-09-29	1
20862	1253	40481087	2009-08-06	2009-08-27	1
20960	1259	260139	2008-03-15	2008-03-29	1
62567	3699	28060	1974-11-29	1974-12-10	1
84995	5060	4278672	1988-06-01	1988-07-01	1
54473	3229	4112343	2005-03-29	2005-04-06	1
50688	3001	40481087	1977-08-30	1977-09-13	1
27029	1600	4156265	2008-03-10	2008-03-31	1
53986	3199	0	2006-01-25	2006-01-26	1
73790	4388	40481087	2002-04-28	2002-05-19	1
54739	3242	28060	2014-09-13	2014-09-25	1
50223	2970	4283893	1987-02-18	1987-04-22	1
30843	1826	4112343	2016-01-22	2016-01-31	1
24795	1480	4329847	2006-08-04	2006-08-05	1
34621	2058	81151	1968-06-17	1968-07-08	1
37721	2238	28060	1970-12-26	1971-01-05	1
49210	2913	40481087	1954-02-01	1954-02-15	1
77792	4613	372328	1967-10-14	1967-10-28	1
57226	3399	40481087	2005-02-08	2005-02-15	1
69644	4124	40481087	1983-11-23	1983-12-14	1
51780	3072	40481087	2019-04-12	2019-05-03	1
76376	4532	28060	1912-02-07	1912-02-14	1
53232	3157	40481087	1960-07-12	1960-07-26	1
61680	3647	260139	1950-12-08	1950-12-15	1
8592	502	313217	2011-04-02	2011-04-03	1
49485	2929	40479768	1990-10-22	1990-12-28	1
18571	1117	192671	1978-11-29	1978-11-30	1
77047	4570	28060	1944-05-03	1944-05-14	1
26085	1550	40481087	1985-05-20	1985-05-27	1
56033	3321	80180	2011-06-30	2011-07-01	1
19348	1159	40481087	1986-12-12	1987-01-02	1
80455	4773	260139	2009-06-04	2009-06-18	1
65310	3866	40481087	1953-07-02	1953-07-23	1
47663	2835	260139	2013-10-12	2013-10-19	1
53905	3195	80180	1984-10-09	1984-10-10	1
58663	3483	40481087	1985-06-27	1985-07-18	1
55204	3272	40481087	1972-11-23	1972-12-14	1
13861	820	40481087	1976-03-18	1976-04-08	1
46468	2770	40481087	1984-02-23	1984-03-08	1
59816	3547	4112343	1977-03-09	1977-03-20	1
23908	1430	40481087	1958-02-23	1958-03-16	1
76119	4521	4112343	1942-02-28	1942-03-09	1
47543	2829	4113008	1990-09-04	1990-09-18	1
33247	1975	378001	1971-11-05	1972-01-04	1
32417	1926	4112343	1997-05-16	1997-05-25	1
54972	3258	4112343	1998-07-23	1998-08-04	1
75840	4503	372328	1939-01-07	1939-05-30	1
47478	2827	378001	1945-03-20	1945-05-19	1
18636	1122	40481087	2007-12-15	2008-01-05	1
20863	1253	260139	1970-12-16	1970-12-23	1
20961	1259	4027663	1973-03-23	1973-03-24	1
62568	3699	372328	1976-10-16	1977-06-16	1
84996	5060	40481087	2004-12-09	2004-12-23	1
54474	3229	4112343	2017-09-02	2017-09-13	1
50689	3001	40481087	1982-11-05	1982-11-12	1
27030	1600	4283893	1981-10-12	1981-11-09	1
53987	3199	260139	2012-04-14	2012-04-21	1
73791	4388	80180	2007-12-28	2007-12-29	1
54740	3242	260139	1985-04-02	1985-04-09	1
50224	2970	40481087	2008-11-25	2008-12-02	1
30844	1826	4237458	1956-10-29	1956-12-28	1
24796	1480	372328	1968-02-10	1968-06-28	1
34622	2058	81151	1970-04-29	1970-05-27	1
37722	2238	80180	2002-07-17	2002-07-18	1
49985	2957	195588	1978-06-17	1978-08-08	1
77793	4613	378001	1997-07-04	1997-09-02	1
57227	3399	4027663	2008-02-01	2008-02-02	1
69645	4124	40481087	1988-07-29	1988-08-12	1
54412	3226	80180	2012-07-07	2012-07-08	1
76377	4532	80180	1945-08-26	1945-08-27	1
53233	3157	257012	2008-03-26	2008-03-27	1
61681	3647	260139	1963-06-11	1963-06-25	1
8593	502	4112343	1960-11-01	1960-11-11	1
49486	2929	260139	1992-10-13	1992-10-20	1
18572	1117	260139	1986-07-06	1986-07-20	1
77048	4570	28060	2002-11-09	2002-11-22	1
26086	1550	258780	1996-10-19	1996-10-20	1
56034	3321	4109685	1982-11-15	1982-11-29	1
19349	1159	40481087	2009-05-13	2009-05-20	1
80456	4773	372328	1964-05-27	1964-10-15	1
65311	3866	81151	1960-10-11	1960-11-08	1
47664	2835	378001	1933-05-17	1933-06-16	1
53906	3195	260139	1968-02-13	1968-02-20	1
58664	3483	192671	1989-01-07	1989-01-08	1
56500	3355	28060	1975-07-26	1975-08-06	1
13862	820	40481087	1989-12-27	1990-01-10	1
46469	2770	40481087	1986-04-04	1986-04-25	1
59817	3547	4283893	1981-07-21	1981-10-13	1
23909	1430	40481087	1973-08-02	1973-08-23	1
76120	4521	4112343	1965-09-05	1965-09-12	1
47544	2829	40481087	2018-07-17	2018-07-24	1
33248	1975	40481087	1938-05-23	1938-06-06	1
32418	1926	4155034	1986-05-17	1986-06-07	1
54973	3258	4116491	2008-05-27	2008-07-07	1
75841	4503	4112343	1987-09-20	1987-09-27	1
47479	2827	4112343	1946-12-20	1947-01-01	1
18637	1122	4059173	1972-08-03	1972-11-01	1
20864	1253	4218389	1990-11-14	1990-12-19	1
20962	1259	4112343	2005-11-23	2005-12-05	1
62569	3699	439777	1999-07-08	1999-07-09	1
84997	5060	4112343	1977-07-01	1977-07-08	1
54475	3229	378001	2010-11-13	2011-01-12	1
50690	3001	40481087	2012-12-30	2013-01-06	1
27031	1600	40481087	1956-11-03	1956-11-10	1
53988	3199	40481087	2003-09-12	2003-10-03	1
73792	4388	372328	1968-05-11	1968-07-27	1
54741	3242	260139	1988-04-24	1988-05-08	1
54529	3232	80180	2004-06-27	2004-06-28	1
30845	1826	40481087	1995-08-19	1995-09-09	1
24797	1480	378001	1983-08-25	1983-09-24	1
34623	2058	381316	2017-11-15	2017-11-16	1
37723	2238	260139	1978-10-13	1978-10-27	1
49986	2957	260139	1949-06-24	1949-07-08	1
77794	4613	378001	2003-12-30	2004-01-29	1
57228	3399	4112343	1987-01-30	1987-02-07	1
69646	4124	40481087	1996-05-28	1996-06-04	1
54413	3226	257012	1997-07-10	1997-07-11	1
76378	4532	260139	1943-04-20	1943-05-04	1
53234	3157	4027663	1978-06-28	1978-06-29	1
61682	3647	372328	1956-05-09	1956-06-13	1
8594	502	4112343	1990-12-06	1990-12-19	1
49487	2929	4112343	1999-02-21	1999-03-01	1
18573	1117	4112343	1997-02-14	1997-02-26	1
77049	4570	257012	1985-12-10	1985-12-11	1
26087	1550	260139	2007-12-03	2007-12-17	1
56035	3321	4112343	2005-10-08	2005-10-17	1
21043	1265	192671	2018-02-20	2018-02-21	1
80457	4773	4294548	1959-05-30	1959-09-12	1
65312	3866	372328	1958-01-22	1958-05-27	1
47665	2835	4112343	1938-05-16	1938-05-26	1
53907	3195	372328	1951-10-29	1952-03-31	1
58665	3483	260139	2015-06-04	2015-06-18	1
56501	3355	80180	2007-10-09	2007-10-10	1
13863	820	40481087	2006-12-19	2007-01-09	1
46470	2770	40481087	1987-09-23	1987-10-07	1
60668	3595	78272	1989-08-08	1989-09-12	1
23910	1430	40481087	2000-07-13	2000-07-27	1
76121	4521	4112343	1968-05-12	1968-05-19	1
47545	2829	40481087	2018-09-29	2018-10-13	1
34881	2075	28060	1982-06-07	1982-06-20	1
32419	1926	4237458	1984-06-26	1984-08-25	1
54974	3258	4218389	1997-10-26	1997-11-23	1
75842	4503	4294548	2010-07-07	2010-12-01	1
47480	2827	4152936	1968-03-19	1968-04-02	1
18638	1122	4134304	1992-07-24	1992-09-22	1
20865	1253	4218389	2015-08-10	2015-09-14	1
20963	1259	40481087	1954-05-04	1954-05-11	1
62570	3699	4294548	1996-11-02	1996-12-21	1
84998	5060	40481087	2018-06-22	2018-06-29	1
54476	3229	4001336	2008-11-23	2008-12-23	1
50691	3001	28060	1959-07-03	1959-07-12	1
27032	1600	40481087	1958-11-06	1958-11-13	1
53989	3199	40481087	2015-12-29	2016-01-19	1
73793	4388	372328	1970-09-15	1971-07-31	1
54742	3242	260139	2002-10-04	2002-10-18	1
54530	3232	192671	2004-07-15	2004-07-16	1
30846	1826	40481087	1998-03-05	1998-03-19	1
24798	1480	4112343	1998-09-07	1998-09-19	1
34624	2058	4283893	1972-12-31	1973-01-28	1
37724	2238	260139	1986-04-23	1986-05-07	1
49987	2957	260139	1954-02-15	1954-03-01	1
77795	4613	4113008	1980-09-10	1980-10-01	1
57229	3399	4112343	1990-10-23	1990-11-02	1
69647	4124	40481087	1998-07-01	1998-07-15	1
54414	3226	260139	1995-10-09	1995-10-16	1
76379	4532	440448	1946-04-10	1946-04-11	1
53235	3157	4266809	1986-05-12	1986-05-13	1
61683	3647	4156265	1941-05-28	1941-06-11	1
8595	502	4155034	1953-10-06	1953-10-20	1
49488	2929	40481087	1990-10-17	1990-10-24	1
18574	1117	4294548	1992-11-26	1993-02-25	1
77050	4570	4112343	1993-08-03	1993-08-11	1
26088	1550	4112343	1982-12-21	1983-01-01	1
56036	3321	4294548	2000-06-18	2000-08-06	1
21044	1265	4112343	2011-08-11	2011-08-21	1
80458	4773	4294548	1966-06-26	1966-07-17	1
65313	3866	4109685	1968-04-30	1968-05-21	1
47666	2835	4112343	1968-05-05	1968-05-15	1
53908	3195	4112343	1979-06-24	1979-07-04	1
58666	3483	4278672	1970-05-09	1970-07-08	1
56502	3355	260139	2002-02-08	2002-02-15	1
13864	820	40481087	2018-05-04	2018-05-25	1
46471	2770	40481087	2000-05-01	2000-05-22	1
60669	3595	260139	1957-07-03	1957-07-10	1
23911	1430	195588	1997-11-09	1998-01-01	1
76122	4521	40481087	1922-01-19	1922-02-09	1
49620	2939	80180	1997-10-31	1997-11-01	1
34882	2075	80180	2006-03-10	2006-03-11	1
32420	1926	40481087	1982-09-12	1982-09-26	1
54975	3258	4278672	1994-06-14	1994-08-13	1
75843	4503	40481087	1999-08-05	1999-08-12	1
47481	2827	4294548	1927-09-29	1927-10-13	1
18639	1122	40481087	2007-09-04	2007-09-11	1
20866	1253	40481087	1984-12-13	1985-01-03	1
20964	1259	40481087	1976-03-03	1976-03-17	1
62571	3699	40481087	1988-03-26	1988-04-16	1
84999	5060	4146173	1994-01-31	1994-04-01	1
54477	3229	4113008	2003-12-29	2004-01-19	1
50692	3001	81151	1970-07-13	1970-08-10	1
27033	1600	40481087	1960-09-09	1960-09-30	1
53990	3199	40481087	2017-10-18	2017-11-08	1
73794	4388	4109685	1974-01-29	1974-02-19	1
54743	3242	40481087	1986-12-05	1986-12-26	1
54531	3232	4296204	1999-07-14	1999-08-11	1
30847	1826	40481087	2013-04-19	2013-04-26	1
24799	1480	4278672	1973-07-13	1973-10-11	1
34625	2058	4283893	2014-10-31	2014-11-21	1
37725	2238	260139	2003-10-14	2003-10-28	1
49988	2957	260139	1981-11-30	1981-12-14	1
77796	4613	40481087	1995-07-12	1995-08-02	1
57230	3399	4112343	2010-08-01	2010-08-12	1
69648	4124	40481087	2000-04-13	2000-05-04	1
54415	3226	260139	2008-06-25	2008-07-02	1
76380	4532	4112343	1910-08-13	1910-08-26	1
55292	3279	78272	2010-02-06	2010-02-20	1
61684	3647	4218389	2010-11-09	2010-12-14	1
8596	502	40481087	1947-10-17	1947-10-31	1
49489	2929	40481087	2001-10-22	2001-10-29	1
19906	1201	372328	1976-01-24	1976-03-17	1
77051	4570	4112343	1994-05-11	1994-05-24	1
26089	1550	40481087	1969-07-19	1969-07-26	1
56037	3321	40481087	1985-10-26	1985-11-02	1
21045	1265	4218389	1999-05-02	1999-05-23	1
80459	4773	4294548	2016-06-12	2016-07-17	1
65314	3866	4112343	1952-06-01	1952-06-08	1
47667	2835	4112343	1982-05-04	1982-05-14	1
53909	3195	4112343	2007-01-24	2007-02-05	1
58667	3483	40481087	1955-05-19	1955-06-02	1
56503	3355	4112343	1967-10-10	1967-10-22	1
13865	820	28060	1964-10-22	1964-10-29	1
46472	2770	80180	1972-06-12	1972-06-13	1
60670	3595	372328	1952-07-16	1952-09-18	1
23912	1430	260139	2017-11-18	2017-12-02	1
76123	4521	40481087	1948-11-05	1948-11-26	1
49621	2939	195588	1994-01-10	1994-03-02	1
34883	2075	260139	1993-05-08	1993-05-22	1
32421	1926	81893	2004-10-24	2004-10-25	1
54976	3258	81151	1990-09-14	1990-09-28	1
75844	4503	40481087	2018-05-29	2018-06-12	1
47482	2827	195588	1968-05-20	1968-07-11	1
18640	1122	260139	1972-01-08	1972-01-22	1
22325	1334	4112343	1997-10-11	1997-10-19	1
20965	1259	30753	1980-11-11	1980-11-12	1
63295	3743	80180	2017-10-23	2017-10-24	1
86230	5138	4109685	2013-03-19	2013-04-02	1
54478	3229	4294548	2000-12-20	2001-01-24	1
50693	3001	260139	1961-12-03	1961-12-10	1
27034	1600	40481087	1972-02-18	1972-02-25	1
53991	3199	81151	1980-08-22	1980-09-19	1
73795	4388	4112343	1966-09-22	1966-10-03	1
54744	3242	40481087	1994-02-24	1994-03-17	1
54532	3232	4310024	2002-11-05	2002-11-06	1
33249	1976	372328	1985-09-19	1985-11-25	1
24800	1480	0	2006-08-04	2006-08-05	1
34626	2058	4310024	1998-04-16	1998-04-17	1
37726	2238	4112343	1985-04-25	1985-05-07	1
49989	2957	40480160	2017-08-15	2017-09-14	1
82777	4922	28060	2013-01-04	2013-01-14	1
57231	3399	4278672	2000-04-09	2000-06-08	1
69649	4124	40481087	2015-12-17	2015-12-31	1
54416	3226	4027663	1999-09-29	1999-09-30	1
76381	4532	4112343	1970-02-02	1970-02-09	1
55293	3279	260139	1958-07-11	1958-07-25	1
61685	3647	40481087	1991-02-01	1991-02-15	1
8597	502	80180	1979-08-26	1979-08-27	1
49490	2929	260139	2004-10-05	2004-10-19	1
19907	1201	372328	1977-04-11	1977-09-21	1
77052	4570	4112343	2008-04-25	2008-05-03	1
26090	1550	40481087	2015-10-09	2015-10-23	1
56038	3321	4146173	2013-05-04	2013-07-10	1
21046	1265	40481087	1987-12-23	1988-01-13	1
80460	4773	4296205	1964-09-24	1964-10-29	1
65315	3866	4237458	1964-08-19	1964-09-18	1
47668	2835	4112343	2006-12-06	2006-12-15	1
53910	3195	40481087	1949-03-30	1949-04-20	1
58668	3483	40481087	1970-08-01	1970-08-15	1
56504	3355	4278672	1986-07-31	1986-10-29	1
13866	820	260139	2009-10-14	2009-10-21	1
46473	2770	260139	1941-12-08	1941-12-22	1
60671	3595	4112343	1996-08-09	1996-08-18	1
23913	1430	4027663	1974-11-15	1974-11-16	1
76124	4521	40481087	1970-10-02	1970-10-16	1
49622	2939	260139	1974-09-29	1974-10-06	1
34884	2075	372328	1970-06-20	1970-11-10	1
32422	1926	4027663	1998-04-04	1998-04-05	1
54977	3258	372328	1985-03-31	1985-05-08	1
75845	4503	260139	1977-08-20	1977-08-27	1
47483	2827	255848	2001-10-02	2001-10-03	1
18641	1122	4051466	1973-11-23	1989-03-04	1
22326	1334	40481087	1971-05-18	1971-06-01	1
20966	1259	80180	1981-10-07	1981-10-08	1
63296	3743	4059173	1979-07-05	1979-10-03	1
86231	5138	4134304	2011-02-28	2011-04-29	1
54479	3229	40481087	2001-10-30	2001-11-13	1
50694	3001	375671	2002-10-03	2002-11-02	1
27035	1600	40481087	2004-12-16	2005-01-06	1
53992	3199	372328	1983-06-29	1984-02-15	1
73796	4388	4134304	1968-05-11	1968-06-10	1
54745	3242	80180	2015-11-25	2015-11-26	1
54533	3232	4152936	1983-11-21	1983-12-05	1
33250	1976	4218389	2010-07-01	2010-07-22	1
24801	1480	260139	2001-12-26	2002-01-02	1
34627	2058	40481087	1974-06-15	1974-06-29	1
37727	2238	4112343	1997-02-16	1997-02-27	1
49990	2957	40481087	1986-03-09	1986-03-23	1
82778	4922	192671	2013-08-01	2013-08-02	1
57232	3399	4112343	1983-05-12	1983-05-21	1
70738	4202	80180	2009-01-20	2009-01-21	1
54417	3226	40481087	1978-12-06	1978-12-20	1
76382	4532	40481087	1949-01-26	1949-02-09	1
55294	3279	4059173	1974-08-14	1974-10-13	1
61686	3647	40481087	2014-02-22	2014-03-08	1
8598	502	260139	1955-03-31	1955-04-07	1
49491	2929	4283893	2010-05-13	2010-07-29	1
19908	1201	4112343	1976-08-24	1976-09-05	1
77053	4570	4112343	2014-02-18	2014-03-03	1
26091	1550	78272	2015-03-11	2015-04-15	1
56039	3321	40481087	1979-06-18	1979-07-09	1
21047	1265	40481087	1989-12-09	1989-12-23	1
80461	4773	40481087	1976-04-22	1976-05-13	1
65316	3866	40481087	1952-05-28	1952-06-04	1
47669	2835	4149245	1989-10-21	1989-11-27	1
53911	3195	40481087	1968-06-17	1968-06-24	1
58669	3483	40481087	1999-05-15	1999-06-05	1
56505	3355	40481087	1990-01-27	1990-02-17	1
13867	820	4112343	1974-12-26	1975-01-04	1
46474	2770	260139	1973-06-10	1973-06-17	1
60672	3595	4112343	2017-07-03	2017-07-14	1
23914	1430	4310024	1983-12-13	1983-12-14	1
76125	4521	40481087	2006-05-14	2006-06-04	1
49623	2939	4112343	1977-10-17	1977-10-30	1
34885	2075	378001	2005-07-08	2005-09-06	1
32423	1926	4112343	1980-06-19	1980-06-28	1
54978	3258	4112343	1996-10-18	1996-10-30	1
75846	4503	260139	1998-12-24	1998-12-31	1
47484	2827	260139	1971-01-22	1971-01-29	1
21174	1272	0	1991-08-30	1991-08-31	1
22327	1334	40481087	1997-04-07	1997-04-28	1
20967	1259	260139	2001-03-14	2001-03-21	1
63297	3743	260139	1981-11-22	1981-11-29	1
86232	5138	40481087	1985-07-30	1985-08-20	1
55789	3307	378001	1967-10-12	1967-12-10	1
50695	3001	4112343	1957-08-28	1957-09-10	1
27036	1600	40481087	2015-03-11	2015-04-01	1
53993	3199	40481087	2014-09-12	2014-09-26	1
73797	4388	28060	1975-02-28	1975-03-10	1
54746	3242	260139	1982-01-09	1982-01-16	1
54534	3232	4266809	2004-06-27	2004-06-28	1
33251	1976	40481087	2007-10-01	2007-10-08	1
24802	1480	4112343	1969-03-08	1969-03-17	1
36644	2172	372328	1981-05-11	1981-09-12	1
37728	2238	4112343	2010-09-19	2010-10-01	1
49991	2957	4112343	1977-06-21	1977-06-29	1
82779	4922	372328	1977-12-26	1978-01-09	1
57233	3399	4112343	1996-11-02	1996-11-10	1
70739	4202	4112343	2016-04-10	2016-04-21	1
54418	3226	40481087	1995-11-10	1995-11-24	1
76383	4532	40481087	1958-02-17	1958-03-10	1
55295	3279	4094814	1972-10-23	1972-12-22	1
61687	3647	81151	1947-04-11	1947-04-25	1
8599	502	4112343	2007-08-24	2007-09-04	1
49492	2929	40481087	2009-05-26	2009-06-09	1
19909	1201	40481087	1983-01-22	1983-02-12	1
77054	4570	4112343	2018-11-11	2018-11-19	1
26092	1550	80180	2004-08-25	2004-08-26	1
56741	3370	81151	1974-06-16	1974-06-30	1
21048	1265	40481087	2001-05-17	2001-06-07	1
80462	4773	40481087	1984-10-03	1984-10-10	1
65317	3866	40481087	1960-02-23	1960-03-08	1
47670	2835	4283893	1938-05-27	1938-09-09	1
53912	3195	40481087	2009-02-28	2009-03-07	1
58670	3483	40481087	2001-11-11	2001-11-18	1
56506	3355	40481087	2007-07-22	2007-08-12	1
13868	820	40481087	1987-01-16	1987-01-23	1
46475	2770	260139	1991-01-30	1991-02-06	1
60673	3595	40481087	2010-08-13	2010-08-20	1
23915	1430	40481087	1954-04-04	1954-04-18	1
77935	4623	372328	1946-04-15	1946-10-22	1
49624	2939	4112343	2012-07-12	2012-07-23	1
34886	2075	4027663	1996-11-22	1996-11-23	1
32424	1926	4134304	2005-07-27	2005-08-26	1
54979	3258	4296205	1993-04-15	1993-05-20	1
75847	4503	40481087	1939-10-28	1939-11-04	1
47485	2827	260139	1984-03-23	1984-04-06	1
21175	1272	28060	2018-12-14	2018-12-27	1
22328	1334	78272	1997-01-23	1997-02-27	1
20968	1259	378001	2014-03-14	2014-05-13	1
63298	3743	260139	2018-09-26	2018-10-10	1
86233	5138	40481087	1990-04-04	1990-04-25	1
55790	3307	4237458	1975-08-31	1975-09-30	1
50696	3001	4112343	1990-11-11	1990-11-24	1
27037	1600	81151	2005-04-20	2005-05-25	1
54291	3219	0	2015-01-11	2015-01-12	1
73798	4388	81151	1970-04-01	1970-05-06	1
54747	3242	4278672	1988-03-06	1988-05-05	1
54535	3232	40481087	1982-02-10	1982-02-17	1
33252	1976	260139	2008-06-07	2008-06-21	1
24803	1480	4112343	1978-07-29	1978-08-09	1
36645	2172	4112343	1985-05-06	1985-05-15	1
37729	2238	4296204	1989-01-16	1989-02-20	1
49992	2957	4112343	1988-04-04	1988-04-11	1
82780	4922	440086	1984-08-01	1988-10-19	1
57234	3399	4285898	2015-12-16	2015-12-17	1
70740	4202	40481087	1982-01-03	1982-01-10	1
54419	3226	30753	2010-12-15	2010-12-16	1
76384	4532	40481087	1979-01-03	1979-01-17	1
55296	3279	4112343	1994-03-04	1994-03-13	1
61688	3647	260139	2004-03-31	2004-04-07	1
8600	502	4112343	2016-10-15	2016-10-24	1
49493	2929	80180	2014-08-22	2014-08-23	1
19910	1201	80180	2007-10-23	2007-10-24	1
77055	4570	4134304	1942-10-24	1942-12-23	1
56742	3370	260139	2003-05-17	2003-05-31	1
21049	1265	40481087	2008-02-09	2008-02-16	1
80463	4773	28060	1960-04-21	1960-05-03	1
65318	3866	40481087	1990-04-28	1990-05-05	1
47671	2835	40481087	1965-05-10	1965-05-31	1
53913	3195	28060	1962-03-30	1962-04-10	1
58671	3483	40481087	2007-10-25	2007-11-15	1
56507	3355	28060	1964-09-28	1964-10-10	1
13869	820	40481087	1989-06-17	1989-06-24	1
46476	2770	4029498	1945-03-31	1945-04-01	1
60674	3595	81151	1951-05-04	1951-06-08	1
23916	1430	0	1965-11-18	1965-11-19	1
77936	4623	378001	1944-11-26	1945-01-25	1
49625	2939	40481087	1962-07-08	1962-07-29	1
34887	2075	4112343	1977-02-10	1977-02-17	1
32425	1926	4266809	2006-06-16	2006-06-17	1
54980	3258	80180	2019-01-15	2019-01-16	1
75848	4503	80180	1971-01-04	1971-01-05	1
47486	2827	372328	1924-02-11	1924-05-06	1
21176	1272	80180	2015-11-24	2015-11-25	1
22329	1334	372328	1982-06-02	1983-03-27	1
20969	1259	4112343	1953-04-03	1953-04-10	1
63299	3743	40481087	1992-10-19	1992-11-09	1
86234	5138	260139	1993-02-12	1993-02-26	1
55791	3307	40481087	1995-12-27	1996-01-03	1
50697	3001	4112343	2015-10-28	2015-11-06	1
27038	1600	195588	1984-11-16	1984-12-27	1
54292	3219	81151	1990-08-24	1990-09-28	1
73799	4388	4051466	1970-08-26	1985-12-06	1
54748	3242	40481087	2004-09-23	2004-10-14	1
54536	3232	40481087	2001-04-13	2001-05-04	1
33253	1976	372328	1984-05-13	1984-05-27	1
24804	1480	40481087	1968-03-20	1968-04-10	1
36646	2172	4146173	1991-05-02	1991-06-01	1
37730	2238	4296204	2009-04-18	2009-05-02	1
49993	2957	4294548	1989-08-13	1989-08-20	1
82781	4922	40481087	1999-01-01	1999-01-08	1
57235	3399	40481087	1990-07-29	1990-08-19	1
70741	4202	40481087	1997-01-13	1997-01-20	1
54420	3226	260139	1982-01-28	1982-02-11	1
76385	4532	28060	1937-01-17	1937-01-30	1
55297	3279	40481087	1955-02-02	1955-02-16	1
61689	3647	4027663	1961-10-15	1961-10-16	1
8601	502	4142905	2000-10-13	2001-01-11	1
49494	2929	40481087	1989-09-02	1989-09-16	1
19911	1201	4027663	2000-10-04	2000-10-05	1
77056	4570	4152936	1954-11-20	1954-12-04	1
56743	3370	372328	1977-05-01	1977-09-04	1
21050	1265	40481087	2012-10-27	2012-11-10	1
80464	4773	257012	1959-07-25	1959-07-26	1
65319	3866	28060	1957-05-16	1957-05-24	1
47672	2835	40481087	2005-01-02	2005-01-16	1
53914	3195	81151	2001-12-14	2002-01-18	1
58672	3483	40481087	2016-02-03	2016-02-17	1
56508	3355	28060	1966-12-02	1966-12-10	1
13870	820	40481087	2000-08-16	2000-09-06	1
46477	2770	4084167	1948-02-04	1948-02-04	1
60675	3595	257012	1976-09-18	1976-09-19	1
23917	1430	78272	2010-01-01	2010-01-22	1
77937	4623	4112343	1942-01-20	1942-01-29	1
49626	2939	40481087	1990-01-06	1990-01-27	1
34888	2075	4112343	1978-04-14	1978-04-27	1
32426	1926	4310024	2004-02-27	2004-02-28	1
54981	3258	260139	1989-08-22	1989-08-29	1
75849	4503	257012	2010-09-08	2010-09-09	1
47487	2827	4112343	1953-10-10	1953-10-21	1
21177	1272	260139	2002-01-07	2002-01-21	1
22330	1334	4112343	1991-01-03	1991-01-14	1
20970	1259	4112343	2006-05-08	2006-05-15	1
63300	3743	40481087	2008-12-21	2008-12-28	1
86235	5138	372328	1989-03-17	1989-09-01	1
55792	3307	40481087	1996-03-12	1996-04-02	1
50698	3001	4113008	1980-12-15	1981-01-05	1
27039	1600	260139	1965-04-17	1965-04-24	1
54293	3219	260139	1994-05-16	1994-05-30	1
73800	4388	4152936	1971-03-02	1971-03-16	1
54749	3242	4112343	1989-07-03	1989-07-14	1
54537	3232	4112343	2017-11-10	2017-11-18	1
33254	1976	372328	1986-12-20	1987-11-30	1
24805	1480	40481087	1969-06-10	1969-07-01	1
36647	2172	372328	1980-08-12	1980-09-13	1
37731	2238	40481087	1989-12-31	1990-01-21	1
49994	2957	40481087	1950-09-04	1950-09-24	1
82782	4922	40481087	2000-07-10	2000-07-17	1
57236	3399	80180	2016-08-13	2016-08-14	1
70742	4202	40481087	2003-05-12	2003-05-26	1
54421	3226	372328	1983-09-13	1984-02-19	1
76386	4532	81151	1998-08-17	1998-09-07	1
55298	3279	40481087	1967-07-15	1967-08-05	1
61690	3647	4112343	1946-08-22	1946-09-03	1
8602	502	40481087	1959-09-04	1959-09-25	1
49495	2929	40481087	1998-12-17	1998-12-31	1
19912	1201	4112343	2000-11-01	2000-11-10	1
77057	4570	4155034	1961-11-27	1961-12-18	1
56744	3370	4112343	1990-05-05	1990-05-12	1
21051	1265	372328	1981-04-06	1981-07-19	1
80465	4773	4112343	1974-12-18	1974-12-28	1
65320	3866	28060	1966-02-10	1966-02-17	1
47673	2835	40481087	2016-09-23	2016-10-14	1
53915	3195	4112343	2002-12-03	2002-12-15	1
58673	3483	81151	2018-07-22	2018-08-26	1
56509	3355	372328	1963-05-03	1963-06-14	1
14087	834	81151	1967-09-15	1967-10-20	1
46478	2770	4112343	1938-11-18	1938-12-01	1
60676	3595	260139	1973-03-31	1973-04-14	1
23918	1430	80180	1986-03-02	1986-03-03	1
77938	4623	4112343	1943-09-22	1943-10-05	1
49627	2939	40481087	1997-12-23	1998-01-13	1
34889	2075	4112343	2018-11-15	2018-11-22	1
32427	1926	81151	2017-12-21	2018-01-18	1
54982	3258	440086	1995-05-31	1999-06-09	1
75850	4503	260139	1973-08-16	1973-08-23	1
47488	2827	4112343	1978-02-14	1978-02-23	1
21178	1272	321042	1991-08-30	1991-08-31	1
22331	1334	4113008	1973-09-05	1973-09-26	1
20971	1259	4218389	1988-05-26	1988-06-30	1
63301	3743	260139	1990-05-18	1990-05-25	1
86236	5138	4112343	1992-10-15	1992-10-28	1
55793	3307	40481087	2008-06-13	2008-07-04	1
50699	3001	40481087	1958-04-25	1958-05-02	1
27040	1600	4142905	2013-09-01	2013-10-31	1
54294	3219	260139	1997-09-15	1997-09-29	1
73801	4388	40481087	1985-11-06	1985-11-27	1
54750	3242	40481087	1981-09-16	1981-09-23	1
54538	3232	40481087	1981-01-01	1981-01-08	1
33255	1976	4296204	1995-07-15	1995-08-19	1
26251	1560	80180	1974-12-20	1974-12-21	1
36648	2172	40481087	1982-03-27	1982-04-10	1
37732	2238	4112343	1993-01-28	1993-02-04	1
49995	2957	40481087	1953-08-15	1953-08-29	1
82783	4922	80180	2013-06-15	2013-06-16	1
57237	3399	40481087	1997-05-22	1997-06-12	1
70743	4202	28060	1981-12-30	1982-01-11	1
54422	3226	28060	1971-01-09	1971-01-19	1
76387	4532	255848	1998-10-13	1998-10-14	1
55299	3279	28060	1966-08-29	1966-09-11	1
61691	3647	4112343	1979-05-27	1979-06-04	1
8603	502	40481087	1979-08-25	1979-09-01	1
52833	3133	80180	1989-06-03	1989-06-04	1
19913	1201	81893	2006-05-31	2006-06-01	1
77058	4570	4230399	2003-08-10	2003-09-09	1
56745	3370	4112343	2000-04-22	2000-04-29	1
21052	1265	4116491	2017-05-02	2017-06-16	1
80466	4773	4112343	2002-11-01	2002-11-10	1
65321	3866	28060	1973-07-12	1973-07-25	1
47674	2835	80180	1950-10-19	1950-10-20	1
53916	3195	4112343	2018-06-08	2018-06-16	1
58674	3483	372328	1955-10-11	1955-12-31	1
56510	3355	4059173	2017-05-10	2017-07-09	1
14088	834	372328	1957-06-12	1957-08-12	1
46479	2770	4112343	1940-11-21	1940-12-02	1
60677	3595	372328	1951-08-02	1951-09-20	1
23919	1430	260139	1946-02-11	1946-02-25	1
77939	4623	4112343	1959-02-28	1959-03-07	1
49628	2939	28060	1954-03-03	1954-03-16	1
34890	2075	81151	2012-06-01	2012-06-29	1
32428	1926	372328	1973-11-14	1974-03-16	1
54983	3258	4112343	2005-11-27	2005-12-07	1
75851	4503	4112343	1948-03-23	1948-04-05	1
47489	2827	4294548	1968-01-16	1968-04-02	1
21179	1272	372328	1985-04-06	1985-08-30	1
22332	1334	40481087	2008-08-06	2008-08-27	1
20972	1259	4266809	1981-10-07	1981-10-08	1
63302	3743	372328	1980-04-14	1980-07-20	1
86237	5138	4112343	2017-11-30	2017-12-10	1
55794	3307	28060	1995-05-03	1995-05-15	1
50700	3001	372328	1951-06-27	1952-01-29	1
27041	1600	4156265	2002-07-21	2002-08-04	1
54295	3219	260139	2018-12-11	2018-12-18	1
73802	4388	40481087	1991-04-02	1991-04-23	1
54751	3242	40481087	1994-10-18	1994-11-08	1
54539	3232	30753	2003-09-01	2003-09-02	1
33256	1976	80180	2017-11-01	2017-11-02	1
26252	1560	192671	1975-02-16	1975-02-17	1
36649	2172	372328	1979-09-02	1980-03-15	2
37733	2238	4155034	2005-08-16	2005-09-06	1
49996	2957	40481087	1954-03-02	1954-03-16	1
82784	4922	195588	2002-09-14	2002-10-21	1
59825	3549	4027663	1986-05-28	1986-05-29	1
70744	4202	133834	1971-08-20	1988-10-11	1
54423	3226	192671	2012-08-04	2012-08-05	1
76388	4532	372328	1911-07-20	1911-09-23	1
55300	3279	80180	1993-05-11	1993-05-12	1
61692	3647	4156265	1991-09-01	1991-09-22	1
8604	502	81151	2009-03-30	2009-05-04	1
52834	3133	372328	2011-01-24	2011-03-23	1
19914	1201	260139	1987-06-26	1987-07-10	1
77059	4570	4285898	1971-10-07	1971-10-08	1
56746	3370	40481087	1975-02-18	1975-02-25	1
21053	1265	40481087	1994-02-08	1994-02-15	1
80467	4773	40481087	2015-11-25	2015-12-09	1
65322	3866	81151	1977-10-31	1977-11-14	1
47675	2835	375671	1935-03-08	1935-04-07	1
53917	3195	4134304	2006-11-23	2006-12-23	1
58675	3483	4152936	1953-11-20	1953-12-04	1
56511	3355	4112343	1980-12-22	1981-01-02	1
14089	834	4027663	1989-07-01	1989-07-02	1
46480	2770	4294548	1978-09-25	1978-11-13	1
60678	3595	378001	1968-11-05	1969-01-04	1
23920	1430	260139	2000-09-02	2000-09-16	1
77940	4623	40481087	1936-08-23	1936-09-06	1
49629	2939	78272	1964-06-21	1964-07-19	1
34891	2075	260139	2019-04-03	2019-04-10	1
32429	1926	372328	1975-10-18	1976-03-27	1
54984	3258	4112343	2012-08-20	2012-08-30	1
75852	4503	4112343	1992-04-07	1992-04-19	1
47490	2827	4296204	1936-11-04	1936-12-02	1
21180	1272	40481087	2005-11-18	2005-12-09	1
22333	1334	372328	1971-10-11	1972-01-30	1
20973	1259	40481087	1968-10-28	1968-11-04	1
63303	3743	4294548	1983-08-01	1983-10-31	1
86238	5138	4278672	2001-08-28	2001-11-26	1
55795	3307	80180	2003-07-05	2003-07-06	1
50701	3001	4155034	1956-11-27	1956-12-18	1
27042	1600	4218389	1952-02-23	1952-03-15	1
54296	3219	4230399	1996-08-27	1996-09-26	1
73803	4388	40481087	1998-02-20	1998-03-13	1
54752	3242	40481087	2013-07-08	2013-07-22	1
54540	3232	81151	1964-07-12	1964-08-02	1
33257	1976	260139	2003-12-02	2003-12-09	1
26253	1560	260139	1946-07-16	1946-07-23	1
36650	2172	372328	1984-05-29	1984-09-22	1
37734	2238	40481087	2018-12-28	2019-01-04	1
49997	2957	40481087	1963-07-05	1963-07-26	1
82785	4922	40479422	1983-05-29	1983-08-04	1
59826	3549	4112343	1982-04-20	1982-04-28	1
70745	4202	4112343	2008-11-02	2008-11-15	1
54424	3226	4113008	2008-05-26	2008-06-16	1
76389	4532	372328	1912-10-17	1913-03-22	1
55301	3279	195588	2015-09-27	2015-11-01	1
61693	3647	4218389	2007-01-01	2007-01-29	1
8605	502	260139	2017-06-20	2017-06-27	1
52835	3133	4027663	1982-02-15	1982-02-16	1
19915	1201	4152936	1995-11-01	1995-11-15	1
77060	4570	40481087	1939-10-17	1939-11-07	1
56747	3370	260139	2019-04-20	2019-05-04	1
21054	1265	40486433	1983-05-18	1999-05-16	1
80468	4773	28060	1987-01-28	1987-02-06	1
65323	3866	260139	1984-04-12	1984-04-19	1
47676	2835	4112343	1948-02-06	1948-02-19	1
53918	3195	40481087	2015-12-10	2015-12-31	1
58676	3483	4296205	1978-02-26	1978-03-19	1
56512	3355	4112343	1997-10-07	1997-10-16	1
14090	834	4112343	1971-10-30	1971-11-12	1
46481	2770	4296204	2001-10-23	2001-11-20	1
60679	3595	80180	1993-10-20	1993-10-21	1
23921	1430	440448	1965-11-18	1965-11-19	1
77941	4623	40481087	1975-12-07	1975-12-28	1
49630	2939	4112343	2010-01-22	2010-02-04	1
34892	2075	4112343	2016-06-17	2016-06-24	1
32430	1926	4112343	2007-01-07	2007-01-16	1
54985	3258	4237458	1995-07-09	1995-10-07	1
75853	4503	4149245	2001-02-10	2001-03-19	1
47491	2827	40481087	1980-09-01	1980-09-08	1
21181	1272	40481087	2018-07-07	2018-07-21	1
22334	1334	372328	1974-05-19	1975-02-09	1
20974	1259	78272	1953-01-02	1953-01-16	1
63304	3743	40481087	1980-01-08	1980-01-15	1
86239	5138	40481087	2009-11-10	2009-12-01	1
55796	3307	4112343	1968-08-25	1968-09-04	1
50702	3001	4266809	1981-12-26	1981-12-27	1
27043	1600	40481087	1965-05-13	1965-05-20	1
54297	3219	40481087	2011-08-24	2011-09-07	1
73804	4388	40481087	2013-03-01	2013-03-15	1
56339	3343	4084167	1977-07-01	1977-07-01	1
54541	3232	381316	2019-04-29	2019-04-30	1
33258	1976	372328	1988-01-29	1988-12-05	1
26254	1560	313217	2018-02-05	2018-02-06	1
36651	2172	4112343	1991-11-11	1991-11-20	1
37735	2238	4296204	2000-09-20	2000-10-11	1
49998	2957	40481087	1990-05-25	1990-06-08	1
82786	4922	40481087	2018-11-30	2018-12-07	1
59827	3549	4112343	1999-07-15	1999-07-24	1
70746	4202	4134304	1974-02-28	1974-03-30	1
54425	3226	4156265	1984-04-06	1984-04-27	1
76390	4532	439777	1960-04-04	1960-04-05	1
55302	3279	260139	1998-11-14	1998-11-28	1
61694	3647	40481087	1958-11-20	1958-11-27	1
8606	502	321042	2016-03-05	2016-03-06	1
52836	3133	4278672	1972-09-25	1972-12-24	1
19916	1201	40481087	1994-05-21	1994-05-28	1
77061	4570	40481087	1993-12-31	1994-01-21	1
56748	3370	4084167	1977-01-31	1977-01-31	1
21055	1265	80180	2017-12-18	2017-12-19	1
80469	4773	80180	1997-03-30	1997-03-31	1
65324	3866	260139	2003-04-28	2003-05-05	1
47677	2835	4116491	1957-11-01	1957-12-14	1
53919	3195	0	1953-11-21	1953-11-22	1
58677	3483	40481087	1970-05-05	1970-05-26	1
56513	3355	40481087	1968-12-09	1968-12-30	1
14091	834	4283893	2008-05-29	2009-03-26	1
46482	2770	0	1945-03-31	1945-04-01	1
60680	3595	260139	1980-04-19	1980-05-03	1
23922	1430	4112343	1999-03-01	1999-03-13	1
77942	4623	40481087	2005-11-09	2005-11-16	1
49631	2939	4112343	2013-09-17	2013-09-26	1
34893	2075	4218389	2017-05-04	2017-05-25	1
32431	1926	40481087	1986-01-17	1986-01-24	1
54986	3258	40481087	1996-04-05	1996-04-19	1
75854	4503	40481087	1957-07-09	1957-07-23	1
47492	2827	40481087	1985-08-22	1985-08-29	1
21182	1272	28060	1990-12-16	1990-12-23	1
22335	1334	40481087	1969-07-29	1969-08-19	1
20975	1259	81893	1979-12-17	1979-12-18	1
63305	3743	372328	1978-07-10	1978-10-22	1
86240	5138	80180	2018-05-11	2018-05-12	1
55797	3307	81151	1981-01-30	1981-02-20	1
50703	3001	4285898	1981-01-30	1981-01-31	1
27044	1600	40481087	1973-06-26	1973-07-03	1
54298	3219	40481087	2003-02-09	2003-03-02	1
73805	4388	40481087	2019-04-22	2019-04-29	1
56340	3343	4296204	2016-03-08	2016-04-12	1
54542	3232	4027663	1994-09-08	1994-09-09	1
33259	1976	40481087	2003-08-10	2003-08-17	1
26255	1560	372328	1937-05-14	1937-06-21	1
36652	2172	4278672	2007-07-07	2007-09-05	1
37736	2238	40481087	1977-07-27	1977-08-17	1
49999	2957	40481087	1999-01-20	1999-02-03	1
82787	4922	28060	1981-08-11	1981-08-20	1
59828	3549	4285898	1995-05-16	1995-05-17	1
70747	4202	40481087	1981-01-12	1981-02-02	1
54426	3226	4218389	1995-03-01	1995-04-05	1
76391	4532	4237458	1984-03-03	1984-05-02	1
55303	3279	260139	2010-07-28	2010-08-04	1
61695	3647	80180	1970-01-01	1970-01-02	1
8607	502	372328	1977-02-02	1978-06-24	1
52837	3133	372328	1964-03-28	1965-02-24	1
19917	1201	40481087	2005-04-05	2005-04-12	1
77062	4570	40481087	2003-07-31	2003-08-21	1
56749	3370	4112343	1976-06-08	1976-06-16	1
21056	1265	378001	1989-05-24	1989-06-23	1
80470	4773	4112343	1993-11-04	1993-11-16	1
65325	3866	4112343	2018-08-30	2018-09-11	1
47678	2835	4237458	2012-01-31	2012-03-31	1
53920	3195	372328	1951-02-10	1951-04-02	1
60143	3565	28060	1947-12-17	1947-12-30	1
56514	3355	40481087	1971-03-25	1971-04-08	1
14092	834	40481087	1960-06-13	1960-06-27	1
46483	2770	257012	1978-10-16	1978-10-17	1
60681	3595	378001	2006-06-15	2006-07-15	1
23923	1430	4113008	1986-04-25	1986-05-09	1
77943	4623	28060	1968-02-05	1968-02-16	1
49632	2939	28060	1953-03-25	1953-04-04	1
34894	2075	4237458	2019-04-15	2019-04-16	1
35235	2090	0	1974-03-20	1974-03-21	1
54987	3258	40481087	2009-04-19	2009-04-26	1
77175	4577	372328	1983-08-08	1983-10-15	1
47493	2827	40481087	1989-10-16	1989-10-23	1
21183	1272	260139	2008-10-04	2008-10-18	1
22336	1334	40481087	1980-06-20	1980-07-04	1
20976	1259	192671	1981-10-16	1981-10-17	1
63306	3743	4112343	1986-03-02	1986-03-15	1
86241	5138	4112343	2001-08-13	2001-08-23	1
55798	3307	257012	1979-08-16	1979-08-17	1
50704	3001	40481087	1952-11-06	1952-11-13	1
27045	1600	40481087	1981-05-01	1981-05-08	1
54299	3219	28060	1983-05-04	1983-05-16	1
79866	4738	40481087	1926-07-11	1926-08-01	1
56341	3343	260139	1995-11-26	1995-12-03	1
54543	3232	4112343	1969-06-17	1969-06-24	1
33260	1976	40481087	2015-09-04	2015-09-18	1
26256	1560	4112343	1936-02-12	1936-02-25	1
36653	2172	4294548	1996-11-20	1996-11-27	1
40855	2433	4155034	1955-01-01	1955-01-22	1
50000	2957	80180	1985-05-14	1985-05-15	1
82788	4922	195588	2000-07-28	2000-09-14	1
59829	3549	40481087	1959-05-23	1959-06-13	1
70748	4202	40481087	1986-08-25	1986-09-01	1
54427	3226	4283893	1997-05-22	1997-07-17	1
76392	4532	40481087	1985-02-02	1985-02-09	1
55304	3279	372328	1956-05-03	1956-09-04	1
61696	3647	192671	1970-01-06	1970-01-07	1
8608	502	4112343	2011-11-15	2011-11-22	1
52838	3133	4112343	1999-06-09	1999-06-17	1
19918	1201	78272	1979-03-09	1979-03-30	1
77063	4570	28060	1976-12-16	1976-12-27	1
56750	3370	4156265	1984-06-21	1984-07-12	1
21057	1265	4112343	1998-06-10	1998-06-18	1
80471	4773	4112343	2003-05-11	2003-05-24	1
65326	3866	4146173	1975-11-11	1975-12-11	1
47679	2835	4283893	2010-02-27	2010-04-03	1
53921	3195	4112343	1976-10-26	1976-11-03	1
60144	3565	78272	1973-11-30	1973-12-14	1
56515	3355	40481087	1979-08-27	1979-09-17	1
14093	834	40481087	1966-09-02	1966-09-09	1
46484	2770	40481087	1951-01-21	1951-01-28	1
60682	3595	4134304	1985-06-09	1985-09-07	1
23924	1430	4283893	1991-08-12	1991-09-30	1
77944	4623	30753	1970-12-25	1970-12-26	1
49633	2939	28060	1977-03-27	1977-04-07	1
34895	2075	4294548	1973-10-14	1973-10-21	1
35236	2090	4112343	2006-04-30	2006-05-13	1
54988	3258	372328	1983-03-25	1983-05-11	1
77176	4577	4112343	1986-07-25	1986-08-03	1
47494	2827	28060	1934-10-14	1934-10-21	1
21184	1272	372328	1982-06-30	1982-08-20	1
22337	1334	80180	2008-11-30	2008-12-01	1
20977	1259	260139	1994-02-27	1994-03-13	1
63307	3743	40481087	1980-05-22	1980-06-12	1
86242	5138	78272	2009-05-18	2009-06-08	1
55799	3307	4283893	1979-08-02	1979-10-18	1
50705	3001	40481087	1967-01-21	1967-01-28	1
27046	1600	40481087	2009-11-17	2009-12-08	1
54300	3219	80180	2018-04-24	2018-04-25	1
79867	4738	28060	1915-12-17	1915-12-27	1
56342	3343	260139	2001-03-30	2001-04-06	1
54544	3232	40481087	1967-02-02	1967-02-23	1
33261	1976	40486433	1985-12-26	2001-12-24	1
26257	1560	4112343	1968-01-10	1968-01-18	1
36654	2172	40481087	1990-12-29	1991-01-12	1
40856	2433	4218389	1994-03-17	1994-04-21	1
50001	2957	80502	2008-02-02	2008-02-03	1
82789	4922	260139	1983-11-27	1983-12-04	1
59830	3549	40481087	1989-12-10	1989-12-17	1
70749	4202	40481087	1999-11-15	1999-11-22	1
54428	3226	4285898	2011-11-10	2011-11-11	1
76601	4546	80180	2010-10-31	2010-11-01	1
55305	3279	4112343	1971-01-21	1971-02-02	1
61697	3647	260139	1954-05-21	1954-05-28	1
8609	502	40481087	2001-05-13	2001-05-27	1
52839	3133	4266809	1989-06-03	1989-06-04	1
19919	1201	192671	2008-01-19	2008-01-20	1
77064	4570	80180	1972-08-02	1972-08-03	1
56751	3370	4283893	2005-12-28	2006-05-03	1
21058	1265	4278672	1991-04-14	1991-07-13	1
80472	4773	40481087	1963-06-29	1963-07-06	1
65327	3866	40481087	1989-08-11	1989-08-25	1
47680	2835	40480160	2012-01-31	2012-03-31	1
53922	3195	4134304	1962-04-13	1962-05-13	1
60145	3565	260139	1955-11-21	1955-11-28	1
56516	3355	4112343	1969-06-16	1969-06-26	1
14094	834	40481087	1990-10-28	1990-11-18	1
46485	2770	40481087	1958-05-13	1958-06-03	1
60683	3595	4156265	1987-07-29	1987-08-19	1
23925	1430	4296205	1993-12-28	1994-01-25	1
77945	4623	134438	1955-05-15	1956-07-11	1
49634	2939	28060	1977-08-06	1977-08-17	1
34896	2075	40481087	2008-02-15	2008-03-07	1
35237	2090	4237458	2004-09-07	2004-12-06	1
54989	3258	4112343	1992-01-04	1992-01-12	1
77177	4577	4112343	1996-10-26	1996-11-03	1
47495	2827	81151	1984-04-08	1984-05-13	1
21185	1272	40481087	2014-12-29	2015-01-19	1
22338	1334	81151	1969-12-20	1970-01-17	1
20978	1259	260139	2016-07-23	2016-07-30	1
64486	3817	78272	2019-02-18	2019-03-25	1
86243	5138	372328	1978-09-28	1978-11-10	1
55800	3307	40481087	2001-07-09	2001-07-30	1
50706	3001	40481087	2001-09-25	2001-10-02	1
27047	1600	40481087	2013-07-26	2013-08-09	1
54301	3219	260139	1985-05-24	1985-05-31	1
79868	4738	30753	1943-07-06	1943-07-07	1
56343	3343	4112343	1991-06-06	1991-06-13	1
54545	3232	40481087	1970-12-11	1970-12-18	1
33262	1976	4112343	2004-08-30	2004-09-10	1
26258	1560	4112343	2014-08-29	2014-09-06	1
36655	2172	40481087	1999-08-19	1999-09-02	1
40857	2433	4237458	1986-02-27	1986-05-28	1
50002	2957	260139	1991-12-03	1991-12-10	1
82790	4922	260139	2007-08-01	2007-08-08	1
59831	3549	40481087	2000-06-04	2000-06-25	1
70750	4202	40486433	1976-05-20	1976-05-21	1
54429	3226	40481087	1976-10-02	1976-10-09	1
76602	4546	260139	1973-02-03	1973-02-17	1
55306	3279	4112343	2006-12-06	2006-12-14	1
61698	3647	260139	2018-06-25	2018-07-09	1
8610	502	40481087	2011-10-10	2011-10-17	1
52840	3133	40481087	1976-09-03	1976-09-17	1
19920	1201	260139	2005-12-13	2005-12-20	1
77065	4570	260139	1997-05-31	1997-06-07	1
56752	3370	80180	2011-10-30	2011-10-31	1
21059	1265	40481087	1983-02-04	1983-02-11	1
80473	4773	40481087	1970-07-31	1970-08-14	1
65328	3866	140673	2017-09-24	2017-09-25	1
47681	2835	40481087	1969-04-18	1969-05-02	1
53923	3195	4149245	2015-09-07	2015-11-13	1
60146	3565	4027663	1971-02-26	1971-02-27	1
56517	3355	4112343	1978-06-24	1978-07-02	1
14095	834	81151	1971-06-01	1971-07-06	1
46486	2770	40481087	1992-01-22	1992-02-05	1
60684	3595	40481087	1981-07-21	1981-07-28	1
23926	1430	40481087	1984-10-03	1984-10-10	1
77946	4623	260139	1937-11-30	1937-12-14	1
49635	2939	372328	1963-12-24	1964-02-04	1
34897	2075	40486433	1968-12-06	1968-12-07	1
35238	2090	4278672	1971-03-07	1971-06-05	1
54990	3258	40481087	1994-08-29	1994-09-05	1
77178	4577	4283893	2015-08-01	2015-10-03	1
47496	2827	257012	1968-03-05	1968-03-06	1
21186	1272	81151	1994-12-24	1995-01-07	1
22339	1334	40479768	1972-08-04	1972-10-10	1
20979	1259	4112343	1957-12-17	1957-12-27	1
64487	3817	260139	1997-06-12	1997-06-19	1
86244	5138	40481087	1998-06-21	1998-07-05	1
55801	3307	195588	2009-10-11	2009-11-10	1
50997	3023	28060	1995-07-15	1995-07-26	1
30491	1801	80180	1994-07-31	1994-08-01	1
54302	3219	440448	2015-01-11	2015-01-12	1
79869	4738	80180	1944-12-27	1944-12-28	1
56344	3343	40481087	2018-03-19	2018-03-26	1
58058	3443	78272	2018-11-28	2018-12-26	1
33263	1976	4134304	1993-05-26	1993-06-25	1
26259	1560	4283893	1960-09-16	1960-10-28	1
36656	2172	40481087	2006-02-04	2006-02-25	1
40858	2433	40481087	1977-08-24	1977-08-31	1
50003	2957	4113008	1956-10-13	1956-11-02	1
82791	4922	4113008	2011-12-05	2011-12-26	1
59832	3549	40481087	2004-07-02	2004-07-09	1
70751	4202	28060	1990-09-29	1990-10-07	1
54430	3226	40481087	1992-05-16	1992-05-23	1
76603	4546	260139	1994-04-03	1994-04-10	1
55307	3279	4278672	1995-03-27	1995-06-25	1
61699	3647	381316	1992-08-19	1992-08-20	1
8611	502	0	2016-03-05	2016-03-06	1
52841	3133	40481087	1985-08-25	1985-09-01	1
19921	1201	4113008	2013-06-13	2013-06-27	1
77066	4570	372328	1939-11-22	1940-05-25	1
56753	3370	260139	2005-05-04	2005-05-18	1
21869	1314	28060	1936-04-28	1936-05-09	1
80474	4773	40481087	2015-04-07	2015-04-21	1
65329	3866	4116491	2004-09-27	2004-11-18	1
47682	2835	40481087	1997-04-01	1997-04-08	1
53924	3195	40481087	2005-10-17	2005-11-07	1
60147	3565	4112343	1963-03-15	1963-03-22	1
56518	3355	4134304	1977-11-15	1978-02-13	1
14096	834	372328	1956-08-08	1956-10-15	1
46487	2770	260139	1952-01-28	1952-02-11	1
60685	3595	40481087	2006-12-20	2006-12-27	1
23927	1430	80502	2004-10-12	2004-10-13	1
77947	4623	4266809	1971-08-22	1971-08-23	1
49636	2939	4112343	1958-03-28	1958-04-05	1
34898	2075	192671	2006-05-05	2006-05-06	1
35239	2090	4296204	2016-04-07	2016-04-21	1
54991	3258	40481087	2009-10-02	2009-10-16	1
77179	4577	40481087	2007-07-17	2007-08-07	1
47497	2827	4112343	1926-10-16	1926-10-25	1
21187	1272	260139	1986-11-08	1986-11-22	1
22340	1334	40481087	1990-04-18	1990-05-09	1
20980	1259	4112343	2005-03-11	2005-03-24	1
64488	3817	260139	2012-09-16	2012-09-23	1
88325	5256	28060	1970-07-21	1970-07-28	1
55802	3307	4059173	1972-09-15	1972-10-15	1
50998	3023	80180	2018-02-02	2018-02-03	1
30492	1801	81151	1967-01-05	1967-01-26	1
54303	3219	4059173	2005-11-08	2006-02-06	1
79870	4738	195588	1937-10-15	1937-11-25	1
56345	3343	4048171	1980-06-12	1980-06-13	1
58059	3443	372328	1978-07-02	1978-08-16	1
33626	1998	30753	2014-12-05	2014-12-06	1
26260	1560	40481087	1949-05-19	1949-06-09	1
36657	2172	80180	2012-07-20	2012-07-21	1
40859	2433	40481087	2019-02-28	2019-03-14	1
50004	2957	4230399	2017-08-15	2017-09-14	1
82792	4922	4283893	1981-01-14	1981-01-28	1
59833	3549	80180	1995-06-15	1995-06-16	1
70752	4202	260139	1995-02-10	1995-02-24	1
54431	3226	40481087	2012-02-05	2012-02-12	1
76604	4546	375671	1982-07-15	1982-08-14	1
55308	3279	40481087	1959-01-31	1959-02-21	1
61700	3647	440086	1943-10-20	1946-02-27	1
8612	502	260139	1979-06-01	1979-06-08	1
52842	3133	30753	1988-08-07	1988-08-08	1
19922	1201	4310024	2005-11-02	2005-11-03	1
77067	4570	372328	1957-12-05	1959-02-21	1
56754	3370	4156265	1977-06-14	1977-06-28	1
21870	1314	28060	1977-01-01	1977-01-12	1
81151	4819	28060	1960-09-18	1960-09-25	1
65330	3866	40481087	1951-06-11	1951-06-25	1
47683	2835	40481087	2010-11-06	2010-11-27	1
53925	3195	192671	1984-10-22	1984-10-23	1
60148	3565	4116491	1966-02-27	1966-04-10	1
56519	3355	4218389	1995-06-14	1995-07-05	1
14097	834	4112343	1968-06-07	1968-06-16	1
46488	2770	260139	1996-04-07	1996-04-14	1
60686	3595	260139	1999-11-02	1999-11-16	1
23928	1430	257012	1991-09-16	1991-09-17	1
77948	4623	40481087	1946-05-23	1946-06-06	1
49637	2939	4112343	1985-06-21	1985-06-30	1
34899	2075	260139	2000-09-14	2000-09-21	1
35240	2090	40481087	1980-12-06	1980-12-20	1
69090	4092	4112343	1982-07-08	1982-07-21	1
77180	4577	40481087	2018-03-31	2018-04-21	1
47498	2827	81151	1999-06-24	1999-07-29	1
21188	1272	4112343	2010-01-13	2010-01-26	1
25098	1498	260139	1987-10-15	1987-10-28	1
20981	1259	4296204	1960-12-05	1960-12-19	1
64489	3817	372328	1968-07-31	1968-08-30	1
88326	5256	80180	2004-02-15	2004-02-16	1
55803	3307	4059173	1982-03-17	1982-04-16	1
50999	3023	260139	2014-04-05	2014-04-12	1
30493	1801	260139	1964-01-31	1964-02-14	1
54304	3219	4112343	1986-12-28	1987-01-10	1
79871	4738	257012	1942-06-22	1942-06-23	1
56346	3343	4084167	1993-04-11	1993-04-11	1
58060	3443	4116491	2006-03-01	2006-04-17	1
33627	1998	260139	2019-02-22	2019-03-01	1
26261	1560	40481087	1983-09-30	1983-10-07	1
36658	2172	260139	2004-01-25	2004-02-08	1
40860	2433	28060	1961-01-30	1961-02-07	1
50005	2957	40481087	1973-05-26	1973-06-09	1
82793	4922	4283893	2010-11-01	2011-01-03	1
59834	3549	4283893	1990-06-23	1990-10-20	1
70753	4202	4084167	1972-10-06	1972-10-06	1
54432	3226	40481087	2017-11-20	2017-12-11	1
76605	4546	4116491	2005-06-19	2005-07-22	1
55309	3279	40481087	1977-07-10	1977-07-31	1
61701	3647	4112343	1978-02-20	1978-03-02	1
8613	502	4112343	2015-08-06	2015-08-19	1
52843	3133	260139	1962-09-20	1962-10-04	1
20290	1223	78272	1954-04-22	1954-05-20	1
77068	4570	4112343	2009-08-28	2009-09-09	1
56755	3370	4218389	1990-10-09	1990-10-30	1
21871	1314	260139	1998-10-04	1998-10-11	1
81152	4819	372328	1963-11-30	1964-04-28	1
67040	3968	0	1928-02-03	1928-02-04	1
47684	2835	78272	1914-12-02	1914-12-23	1
53926	3195	260139	1990-03-19	1990-04-02	1
60149	3565	4285898	1982-03-15	1982-03-16	1
56520	3355	40481087	1974-07-28	1974-08-18	1
14098	834	4218389	1965-09-20	1965-10-25	1
46489	2770	378001	2007-07-22	2007-08-21	1
60687	3595	4294548	1976-08-14	1976-11-06	1
23929	1430	4112343	1986-09-09	1986-09-17	1
77949	4623	40481087	1985-05-16	1985-05-23	1
49638	2939	4294548	2000-02-09	2000-07-12	1
34900	2075	4112343	1968-08-18	1968-08-25	1
35241	2090	40481087	1990-01-08	1990-01-29	1
69091	4092	4112343	1996-11-19	1996-12-02	1
77181	4577	4112343	2015-03-30	2015-04-11	1
47499	2827	313217	2000-12-26	2000-12-27	1
21189	1272	40481087	2001-12-24	2001-12-31	1
25099	1498	260139	2008-09-11	2008-09-18	1
20982	1259	40481087	1987-03-26	1987-04-16	1
64490	3817	4059173	1995-10-08	1995-12-07	1
88327	5256	260139	1972-11-23	1972-12-07	1
55804	3307	4112343	1967-07-16	1967-07-28	1
51000	3023	40481087	1999-09-29	1999-10-20	1
30494	1801	378001	1990-06-24	1990-07-24	1
54305	3219	4112343	2014-10-16	2014-10-27	1
79872	4738	260139	1922-12-17	1922-12-24	1
56347	3343	4112343	1983-08-02	1983-08-14	1
58061	3443	40481087	1979-02-01	1979-02-15	1
33628	1998	4112343	1983-08-13	1983-08-25	1
26262	1560	40481087	2001-01-12	2001-01-19	1
36659	2172	260139	2016-01-19	2016-01-26	1
40861	2433	80180	1992-01-27	1992-01-28	1
50006	2957	40481087	1996-02-14	1996-03-06	1
82794	4922	40481087	2003-01-12	2003-02-02	1
59835	3549	40481087	1972-04-12	1972-04-19	1
70754	4202	4112343	1972-01-13	1972-01-21	1
54433	3226	28060	2004-10-24	2004-11-03	1
76606	4546	40481087	2018-09-16	2018-09-23	1
55310	3279	40481087	1981-12-12	1982-01-02	1
61702	3647	4112343	1989-10-13	1989-10-26	1
8614	502	40481087	1968-04-17	1968-05-01	1
52844	3133	372328	1961-09-14	1962-02-07	1
20291	1223	260139	1966-01-21	1966-01-28	1
77069	4570	40481087	1969-06-27	1969-07-04	1
56756	3370	4294548	2003-09-30	2003-12-30	1
21872	1314	375671	1938-01-04	1938-02-03	1
81153	4819	439777	1960-09-21	1960-09-22	1
67041	3968	321042	1928-02-03	1928-02-04	1
47685	2835	81151	2018-01-29	2018-03-05	1
53927	3195	260139	2006-10-21	2006-11-04	1
60150	3565	4310024	1980-03-25	1980-03-26	1
56521	3355	40481087	1994-01-03	1994-01-24	1
14099	834	4218389	1983-01-04	1983-01-25	1
46490	2770	4142905	2004-11-04	2004-12-04	1
60688	3595	40481087	1962-03-15	1962-03-22	1
23930	1430	4112343	1995-10-04	1995-10-17	1
77950	4623	40481087	2009-05-06	2009-05-13	1
49639	2939	40481087	1987-01-24	1987-02-14	1
34901	2075	4112343	2007-02-11	2007-02-18	1
35242	2090	40481087	2002-07-04	2002-07-18	1
69092	4092	4112343	2007-04-04	2007-04-14	1
77182	4577	40479422	2002-03-31	2002-06-06	1
47500	2827	378419	1990-10-30	1990-10-31	1
21190	1272	40481087	2009-08-28	2009-09-18	1
25100	1498	260139	2015-04-17	2015-05-01	1
20983	1259	40481087	2019-01-03	2019-01-17	1
64491	3817	4112343	1970-01-26	1970-02-04	1
88328	5256	372328	1964-05-15	1964-10-23	1
55805	3307	4112343	1991-11-06	1991-11-17	1
51001	3023	78272	1993-04-24	1993-05-29	1
30495	1801	4155034	1963-12-01	1963-12-22	1
54306	3219	40481087	1984-12-02	1984-12-09	1
79873	4738	4001336	1945-07-08	1945-07-09	1
56348	3343	40481087	2007-05-19	2007-06-09	1
58062	3443	40481087	1993-06-20	1993-07-04	1
33629	1998	4112343	1986-11-09	1986-11-16	1
26263	1560	40481087	2016-03-09	2016-03-23	1
36660	2172	378001	1996-03-06	1996-04-05	1
40862	2433	260139	1962-12-22	1962-12-29	1
50007	2957	28060	1958-02-20	1958-03-01	1
82795	4922	4048695	2013-11-15	2014-01-15	1
59836	3549	40481087	1986-07-13	1986-07-20	1
70755	4202	40481087	1980-07-04	1980-07-11	1
54434	3226	78272	1980-07-05	1980-07-26	1
76607	4546	260139	2012-12-19	2012-12-26	1
55311	3279	260139	1966-09-14	1966-09-28	1
61703	3647	4294548	1997-04-20	1997-06-29	1
8615	502	40481087	1974-08-05	1974-08-12	1
52845	3133	378001	1965-01-05	1965-03-06	1
20292	1223	372328	2010-11-24	2011-05-06	1
77070	4570	28060	1947-07-29	1947-08-11	1
56757	3370	40481087	1978-09-16	1978-09-30	1
21873	1314	4112343	1938-03-31	1938-04-09	1
81154	4819	40481087	1970-10-28	1970-11-11	1
67042	3968	375671	1944-06-10	1944-08-09	1
47686	2835	260139	1966-05-12	1966-05-19	1
53928	3195	380378	1953-11-21	1953-11-22	1
60151	3565	40481087	2001-01-10	2001-01-31	1
56522	3355	40481087	2004-03-09	2004-03-30	1
14100	834	4278672	1963-05-04	1963-08-02	1
46491	2770	4294548	1951-03-08	1951-03-29	1
60689	3595	40481087	2011-05-26	2011-06-09	1
23931	1430	40481087	1955-12-17	1955-12-31	1
77951	4623	28060	1931-06-06	1931-06-14	1
49640	2939	40481087	2013-01-09	2013-01-30	1
34902	2075	4218389	1980-06-14	1980-07-19	1
35243	2090	28060	2008-07-02	2008-07-14	1
69093	4092	40481087	1981-03-02	1981-03-09	1
77183	4577	80180	2019-03-17	2019-03-18	1
47501	2827	4112343	1952-08-06	1952-08-15	1
22150	1323	28060	1971-05-18	1971-05-28	1
25101	1498	40481087	2000-06-12	2000-07-03	1
22725	1358	28060	1968-09-15	1968-09-24	1
64492	3817	4112343	2001-02-06	2001-02-17	1
88329	5256	4112343	1988-01-21	1988-01-28	1
55806	3307	40481087	1968-01-17	1968-01-24	1
51002	3023	81893	2016-06-12	2016-06-13	1
30496	1801	4218389	2003-09-28	2003-10-19	1
55705	3301	28060	1976-08-02	1976-08-13	1
79874	4738	4116491	1935-09-11	1935-10-16	1
56349	3343	80180	2019-05-17	2019-05-18	1
58063	3443	40481087	2006-03-29	2006-04-13	1
33630	1998	4112343	1998-10-30	1998-11-06	1
26264	1560	260139	1963-04-07	1963-04-14	1
36985	2192	28060	1963-04-12	1963-04-20	1
40863	2433	40481087	1970-05-21	1970-06-04	1
50008	2957	195588	1977-04-26	1977-06-17	1
82796	4922	4112343	1984-01-09	1984-01-20	1
59837	3549	40481087	2018-02-02	2018-02-23	1
73759	4387	28060	1985-05-20	1985-05-30	1
54435	3226	372328	1971-02-23	1971-07-18	1
76608	4546	4112343	1982-10-17	1982-10-24	1
55312	3279	372328	1955-07-25	1955-09-06	1
61704	3647	40481087	1943-10-20	1943-11-03	1
9303	550	378001	1956-10-26	1956-11-25	1
52846	3133	4112343	1987-06-10	1987-06-23	1
20293	1223	4112343	1985-01-27	1985-02-09	1
77071	4570	80502	1997-01-25	1997-01-26	1
56758	3370	257012	2003-10-28	2003-10-29	1
21874	1314	4283893	2013-09-08	2013-09-22	1
81155	4819	40481087	1983-02-12	1983-02-19	1
67043	3968	4109685	1952-02-29	1952-03-14	1
47687	2835	260139	1998-01-23	1998-02-06	1
53929	3195	4029498	1953-11-21	1953-11-22	1
60152	3565	40481087	2005-10-16	2005-10-23	1
57889	3437	4027663	1943-04-20	1943-04-21	1
14101	834	4294548	1992-03-20	1992-06-05	1
46492	2770	40481087	1956-08-06	1956-08-13	1
65757	3892	30753	2000-08-09	2000-08-10	1
23932	1430	40481087	1995-02-20	1995-03-06	1
77952	4623	80180	1971-08-22	1971-08-23	1
49641	2939	257012	2000-03-29	2000-03-30	1
34903	2075	4266809	2006-03-10	2006-03-11	1
35244	2090	78272	1976-06-08	1976-07-06	1
69094	4092	40481087	1991-10-02	1991-10-16	1
77184	4577	257012	1988-07-21	1988-07-22	1
47502	2827	4230399	1987-05-28	1987-08-26	1
22151	1323	80180	2005-02-09	2005-02-10	1
25102	1498	4112343	1966-04-08	1966-04-20	1
22726	1358	28060	1976-07-27	1976-08-05	1
64493	3817	4112343	2008-06-12	2008-06-23	1
88330	5256	28060	2018-08-02	2018-08-15	1
55807	3307	40481087	1998-07-29	1998-08-19	1
51003	3023	372328	1985-11-02	1986-10-04	1
30497	1801	40481087	1956-03-17	1956-03-31	1
55706	3301	260139	1985-01-27	1985-02-10	1
79875	4738	4294548	1942-05-18	1942-10-12	1
56350	3343	378001	1985-02-19	1985-03-21	1
58064	3443	372328	1981-10-28	1982-09-29	1
33631	1998	4112343	2014-08-17	2014-08-28	1
26265	1560	4112343	1944-03-18	1944-03-29	1
36986	2192	28060	2013-10-15	2013-10-28	1
40864	2433	260139	1996-02-06	1996-02-20	1
50009	2957	260139	2007-01-10	2007-01-24	1
82797	4922	4112343	1985-07-16	1985-07-29	1
59838	3549	28060	1997-01-13	1997-01-23	1
73760	4387	28060	1990-01-05	1990-01-17	1
54436	3226	4112343	1969-10-02	1969-10-13	1
76609	4546	4112343	2000-06-06	2000-06-13	1
55313	3279	372328	1957-11-28	1958-01-14	1
64197	3795	260139	2004-04-03	2004-04-17	1
9304	550	4112343	2001-05-29	2001-06-06	1
52847	3133	4112343	1995-07-14	1995-07-27	1
20294	1223	40481087	1963-10-20	1963-10-27	1
77072	4570	260139	1964-08-30	1964-09-13	1
56759	3370	260139	2015-01-14	2015-01-28	1
21875	1314	40481087	1959-10-20	1959-10-27	1
81156	4819	40481087	2011-04-15	2011-04-29	1
67044	3968	4112343	1939-07-30	1939-08-11	1
47688	2835	4112343	1917-05-24	1917-05-31	1
53930	3195	4112343	1959-04-01	1959-04-11	1
60153	3565	40481087	2008-03-16	2008-04-06	1
57890	3437	4112343	1965-09-05	1965-09-15	1
14102	834	4294548	1998-04-10	1998-06-12	1
49555	2935	28060	2001-01-27	2001-02-09	1
65758	3892	260139	2019-02-02	2019-02-16	1
25154	1504	28060	1960-11-30	1960-12-12	1
77953	4623	80502	1989-09-26	1989-09-27	1
49642	2939	4112343	2011-07-01	2011-07-14	1
34904	2075	372328	1966-07-28	1966-11-08	1
35245	2090	80180	2002-06-12	2002-06-13	1
69095	4092	260139	1989-07-15	1989-07-29	1
77185	4577	372328	1988-04-04	1988-06-18	1
47503	2827	40481087	1941-01-11	1941-02-01	1
22152	1323	378001	2008-01-12	2008-03-12	1
25103	1498	40481087	1965-10-17	1965-10-31	1
22727	1358	260139	1964-05-27	1964-06-10	1
64494	3817	80180	2000-05-29	2000-05-30	1
88331	5256	195588	1983-11-07	1983-12-17	1
55808	3307	40481087	2006-04-11	2006-04-18	1
51004	3023	378001	1982-11-18	1982-12-18	1
30498	1801	40481087	1962-11-04	1962-11-11	1
55707	3301	4112343	1949-08-21	1949-08-29	1
79876	4738	372328	1911-03-11	1911-08-25	1
56351	3343	440086	1985-06-04	1988-05-10	1
58065	3443	4112343	1986-06-23	1986-07-03	1
33632	1998	4113008	2017-05-13	2017-05-27	1
26266	1560	4112343	2017-01-27	2017-02-03	1
36987	2192	30753	1995-02-06	1995-02-07	1
40865	2433	317576	2014-03-16	2014-03-17	1
50010	2957	4112343	1948-08-29	1948-09-07	1
82798	4922	40481087	2019-04-12	2019-04-26	1
59839	3549	4112343	2001-05-18	2001-05-25	1
73761	4387	4112343	1992-06-06	1992-06-17	1
54437	3226	4266809	2012-07-07	2012-07-08	1
76610	4546	4112343	2014-05-31	2014-06-09	1
55314	3279	40481087	1957-01-13	1957-02-03	1
64198	3795	28060	2009-10-06	2009-10-16	1
9305	550	4116491	1957-11-09	1957-12-16	1
52848	3133	4112343	2002-07-04	2002-07-15	1
20295	1223	40481087	2007-05-22	2007-06-12	1
77073	4570	260139	1985-05-15	1985-05-29	1
56760	3370	40481087	1984-05-08	1984-05-15	1
21876	1314	40481087	1977-02-23	1977-03-02	1
81157	4819	40481087	2013-02-25	2013-03-04	1
67045	3968	4112343	1954-03-29	1954-04-06	1
47689	2835	4112343	1929-03-31	1929-04-13	1
54358	3223	28060	1985-09-24	1985-10-06	1
60154	3565	4112343	1999-10-02	1999-10-15	1
57891	3437	4142905	1921-03-09	1921-05-08	1
14103	834	4310024	1995-04-26	1995-04-27	1
49556	2935	81151	2004-02-08	2004-02-22	1
65759	3892	4112343	1968-06-15	1968-06-25	1
25155	1504	260139	2004-10-17	2004-10-31	1
77954	4623	260139	1986-08-26	1986-09-09	1
49643	2939	4146173	1987-02-19	1987-04-20	1
34905	2075	4084167	1967-04-24	1967-04-24	1
35246	2090	260139	1999-05-05	1999-05-12	1
69096	4092	260139	2018-04-09	2018-04-16	1
77186	4577	4283893	1988-07-07	1988-09-15	1
50075	2961	0	1972-09-26	1972-09-27	1
22153	1323	4152936	1977-12-08	1977-12-29	1
25104	1498	192671	2007-05-02	2007-05-03	1
22728	1358	260139	1965-03-06	1965-03-20	1
3058	181	198199	1996-09-10	1996-10-16	1
88332	5256	260139	1965-07-16	1965-07-23	1
58769	3490	260139	1990-04-23	1990-04-30	1
51005	3023	4027663	2010-10-17	2010-10-18	1
30499	1801	40481087	1987-11-08	1987-11-22	1
55708	3301	4112343	1970-08-22	1970-09-01	1
79877	4738	4218389	1924-03-02	1924-03-30	1
56352	3343	4051466	1978-06-13	1995-09-12	1
58066	3443	4285898	2012-02-18	2012-02-19	1
33633	1998	4310024	2013-10-11	2013-10-12	1
26267	1560	40481087	1982-11-22	1982-11-29	1
36988	2192	260139	1956-05-18	1956-05-25	1
40866	2433	372328	1958-02-14	1958-12-28	1
50011	2957	4146173	1970-02-22	1970-03-24	1
85279	5078	30753	1944-04-12	1944-04-13	1
59840	3549	4134304	2012-02-16	2012-03-17	1
73762	4387	28060	1974-11-13	1974-11-25	1
54438	3226	40481087	1971-04-30	1971-05-07	1
76611	4546	4283893	1983-05-17	1983-05-31	1
55315	3279	40481087	1995-05-30	1995-06-20	1
64199	3795	80180	2010-05-25	2010-05-26	1
9306	550	255848	2002-06-17	2002-06-18	1
52849	3133	40481087	1965-10-10	1965-10-24	1
20296	1223	30753	1989-01-23	1989-01-24	1
77074	4570	372328	1937-09-20	1938-01-01	1
56761	3370	40481087	1998-08-08	1998-08-22	1
21877	1314	40481087	1980-07-20	1980-08-10	1
81158	4819	28060	1962-10-18	1962-10-25	1
67046	3968	4112343	1972-04-02	1972-04-12	1
47690	2835	4112343	1968-08-14	1968-08-24	1
54359	3223	260139	1944-02-09	1944-02-16	1
60155	3565	4112343	2000-04-14	2000-04-25	1
57892	3437	40481087	1937-03-10	1937-03-31	1
14104	834	40481087	1980-02-03	1980-02-17	1
49557	2935	372328	1980-10-02	1981-03-18	1
65760	3892	4285898	2000-12-07	2000-12-08	1
25156	1504	4059173	1959-06-20	1959-09-18	1
77955	4623	4027663	1963-05-06	1963-05-07	1
49644	2939	40481087	2002-02-08	2002-03-01	1
34906	2075	4112343	2009-11-07	2009-11-17	1
35247	2090	4112343	1972-04-03	1972-04-12	1
69097	4092	378001	1983-03-17	1983-04-16	1
77187	4577	4283893	2016-07-06	2016-08-31	1
50076	2961	28060	1982-12-12	1982-12-21	1
22154	1323	40481087	1969-05-29	1969-06-12	1
25105	1498	378001	1990-09-27	1990-10-27	1
22729	1358	4112343	1965-12-21	1965-12-28	1
3059	181	80180	2010-08-28	2010-08-29	1
88333	5256	4294548	2013-09-25	2013-10-09	1
58770	3490	4112343	1969-08-24	1969-09-06	1
51006	3023	4266809	2018-02-02	2018-02-03	1
30500	1801	28060	1981-12-27	1982-01-03	1
55709	3301	4112343	1984-06-06	1984-06-14	1
79878	4738	4266809	1944-12-27	1944-12-28	1
56353	3343	4084167	1978-11-25	1978-11-25	1
58067	3443	4294548	1992-10-22	1992-12-16	1
33634	1998	80180	2015-10-01	2015-10-02	1
26268	1560	81151	2009-02-05	2009-03-12	1
36989	2192	260139	1959-08-10	1959-08-17	1
40867	2433	4059173	1966-09-21	1966-11-20	1
50012	2957	40481087	1949-06-29	1949-07-06	1
85280	5078	81151	1987-06-01	1987-07-06	1
59841	3549	40481087	1963-09-27	1963-10-18	1
73763	4387	80180	2007-11-24	2007-11-25	1
54439	3226	40481087	1974-04-30	1974-05-07	1
76612	4546	28060	1984-06-18	1984-06-27	1
55316	3279	260139	2016-08-04	2016-08-18	1
64200	3795	4112343	2007-01-10	2007-01-17	1
9307	550	260139	1966-08-23	1966-09-06	1
52850	3133	40481087	2008-05-12	2008-05-26	1
20297	1223	260139	1989-05-23	1989-05-30	1
77075	4570	4027663	1962-01-17	1962-01-18	1
56762	3370	40481087	2012-09-07	2012-09-21	1
21878	1314	40481087	1997-03-20	1997-04-10	1
81159	4819	80180	2003-03-30	2003-03-31	1
67047	3968	4112343	1977-07-18	1977-07-29	1
47691	2835	4112343	1977-04-12	1977-04-21	1
54360	3223	260139	1945-02-12	1945-02-19	1
60156	3565	4218389	1950-01-02	1950-01-30	1
57893	3437	40481087	1943-07-05	1943-07-12	1
14105	834	40481087	2017-09-16	2017-10-07	1
49558	2935	40481087	2015-06-17	2015-07-08	1
65761	3892	40481087	1977-01-07	1977-01-21	1
25157	1504	4112343	1992-09-30	1992-10-10	1
77956	4623	4112343	1958-02-20	1958-03-04	1
51242	3041	4112343	1993-11-28	1993-12-10	1
34907	2075	4294548	1966-04-08	1966-07-15	1
35248	2090	4112343	1973-10-08	1973-10-17	1
69098	4092	4112343	2001-07-11	2001-07-22	1
77188	4577	40481087	1987-12-21	1988-01-04	1
50077	2961	440448	1972-09-26	1972-09-27	1
22155	1323	40481087	1970-07-14	1970-07-28	1
25106	1498	4112343	1974-04-11	1974-04-18	1
22730	1358	40481087	1965-04-03	1965-04-24	1
3060	181	372328	1975-02-08	1975-02-22	1
88334	5256	40481087	1990-10-13	1990-10-20	1
58771	3490	40481087	1952-01-11	1952-01-25	1
51007	3023	4116491	2008-10-17	2008-12-06	1
30501	1801	313217	2007-08-08	2007-08-09	1
55710	3301	40481087	1938-12-06	1938-12-20	1
79879	4738	40481087	1922-11-08	1922-11-22	1
56354	3343	4112343	1999-05-03	1999-05-12	1
58068	3443	40481087	1982-08-08	1982-08-29	1
33635	1998	260139	2017-09-21	2017-10-05	1
26269	1560	372328	1935-04-14	1935-06-24	1
36990	2192	260139	1972-04-23	1972-04-30	1
40868	2433	4218389	1984-05-17	1984-06-07	1
50013	2957	40481087	1967-01-13	1967-01-20	1
85281	5078	255848	2001-09-23	2001-09-24	1
59842	3549	40481087	2002-02-20	2002-03-06	1
73764	4387	372328	1968-04-02	1968-07-26	1
55809	3308	0	1996-11-18	1996-11-19	1
76613	4546	260139	1999-01-16	1999-01-30	1
55317	3279	40481087	1970-10-25	1970-11-15	1
64201	3795	40481087	1979-03-21	1979-04-11	1
9308	550	260139	1974-10-25	1974-11-08	1
52851	3133	260139	2010-04-08	2010-04-22	1
20298	1223	260139	2015-01-24	2015-02-07	1
77076	4570	4112343	1938-02-18	1938-03-03	1
57587	3420	4059173	1969-09-03	1969-10-03	1
21879	1314	40481087	2000-07-29	2000-08-19	1
81160	4819	260139	1982-01-26	1982-02-02	1
67048	3968	4112343	1979-01-23	1979-01-30	1
47692	2835	4296204	1963-02-14	1963-03-14	1
54361	3223	4112343	1959-10-17	1959-10-29	1
60157	3565	4266809	1982-05-14	1982-05-15	1
57894	3437	40481087	1951-02-15	1951-03-01	1
14106	834	260139	1977-09-18	1977-09-25	1
49559	2935	80180	2013-08-16	2013-08-17	1
65762	3892	40481087	2015-09-04	2015-09-11	1
25158	1504	4116491	2003-06-09	2003-07-15	1
77957	4623	4112343	1964-02-11	1964-02-23	1
51243	3041	40481087	2008-07-07	2008-07-14	1
34908	2075	40481087	2000-04-11	2000-04-18	1
35249	2090	40481087	1985-10-03	1985-10-10	1
69099	4092	4112343	2007-02-22	2007-03-03	1
77189	4577	40481087	2012-07-20	2012-08-10	1
50078	2961	40481087	1977-10-04	1977-10-11	1
22156	1323	40481087	1977-05-27	1977-06-17	1
25107	1498	40481087	1978-04-01	1978-04-15	1
22731	1358	28060	1970-07-18	1970-07-25	1
3061	181	4112343	2006-10-08	2006-10-18	1
88335	5256	78272	1988-04-14	1988-05-19	1
58772	3490	40481087	1955-07-16	1955-08-06	1
51008	3023	260139	2017-06-26	2017-07-03	1
30502	1801	4084167	1955-05-17	1955-05-18	1
55711	3301	40481087	1974-07-26	1974-08-16	1
79880	4738	260139	1917-11-05	1917-11-12	1
56355	3343	4112343	2005-07-13	2005-07-21	1
58069	3443	40481087	1989-04-29	1989-05-06	1
33636	1998	4112343	1990-01-02	1990-01-13	1
26270	1560	4112343	1944-11-27	1944-12-07	1
36991	2192	260139	1975-06-30	1975-07-07	1
40869	2433	40481087	1976-07-10	1976-07-24	1
50014	2957	40481087	1996-11-09	1996-11-23	1
85282	5078	260139	1956-10-03	1956-10-17	1
59843	3549	260139	1986-08-03	1986-08-17	1
73765	4387	40481087	1975-01-22	1975-02-05	1
55810	3308	28060	1960-11-14	1960-11-27	1
76614	4546	378001	2018-07-06	2018-08-05	1
55318	3279	40481087	1972-03-16	1972-03-30	1
64202	3795	40481087	1985-05-18	1985-05-25	1
9309	550	260139	1975-12-14	1975-12-28	1
52852	3133	372328	1956-09-19	1956-10-31	1
20299	1223	375671	2009-03-23	2009-05-22	1
77077	4570	4310024	1970-07-14	1970-07-15	1
57588	3420	4112343	1997-06-19	1997-07-02	1
21880	1314	40481087	2007-04-22	2007-05-13	1
81161	4819	260139	2002-08-20	2002-09-03	1
67049	3968	4112343	1990-07-22	1990-08-01	1
47693	2835	40481087	1924-10-02	1924-10-23	1
54362	3223	4112343	1981-10-06	1981-10-13	1
60158	3565	40481087	1962-02-10	1962-03-03	1
57895	3437	28060	1916-05-09	1916-05-16	1
14107	834	260139	2014-05-17	2014-05-24	1
49560	2935	260139	2002-04-22	2002-04-29	1
65763	3892	81893	1999-09-14	1999-09-15	1
25159	1504	4218389	1986-04-29	1986-05-27	1
77958	4623	4112343	1973-10-21	1973-11-03	1
51244	3041	40486433	1980-03-09	1980-03-10	1
36771	2177	80180	2005-06-03	2005-06-04	1
35250	2090	40481087	1986-03-16	1986-03-23	1
69100	4092	4278672	1986-12-26	1987-01-25	1
77190	4577	28060	1996-05-15	1996-05-27	1
50079	2961	40481087	1995-07-05	1995-07-19	1
22157	1323	40481087	2002-06-29	2002-07-20	1
25108	1498	40481087	1997-08-12	1997-08-19	1
22732	1358	260139	1969-04-01	1969-04-15	1
3062	181	40481087	1997-03-22	1997-03-29	1
88336	5256	260139	1987-08-23	1987-08-30	1
58773	3490	40481087	1972-08-15	1972-09-05	1
51009	3023	40481087	2009-01-08	2009-01-22	1
30503	1801	260139	2009-11-24	2009-12-01	1
55712	3301	260139	1975-11-19	1975-11-26	1
79881	4738	4027663	1934-09-11	1934-09-12	1
56356	3343	4152936	2017-04-07	2017-04-28	1
58070	3443	40481087	2010-04-29	2010-05-20	1
33637	1998	40481087	1989-10-26	1989-11-16	1
26271	1560	4112343	1984-05-27	1984-06-03	1
36992	2192	260139	2000-05-01	2000-05-08	1
40870	2433	4112343	2004-05-25	2004-06-06	1
51657	3067	260139	1991-09-10	1991-09-17	1
85283	5078	378419	1993-06-07	1993-06-08	1
59844	3549	4112343	1972-01-19	1972-01-26	1
73766	4387	28060	1974-07-04	1974-07-15	1
55811	3308	372328	1947-10-08	1948-01-19	1
76615	4546	4112343	2009-12-27	2010-01-07	1
57816	3434	28060	1964-01-19	1964-02-01	1
64203	3795	40481087	2011-05-05	2011-05-26	1
9310	550	260139	1994-09-24	1994-10-08	1
52853	3133	372328	1958-10-21	1959-01-28	1
20300	1223	4278672	1983-07-17	1983-09-15	1
77078	4570	40481087	1996-06-17	1996-07-01	1
57589	3420	40481087	1984-02-16	1984-02-23	1
21881	1314	80180	1966-08-25	1966-08-26	1
81162	4819	4112343	1989-05-06	1989-05-19	1
67050	3968	40481087	1919-04-23	1919-05-07	1
47694	2835	40481087	1931-07-24	1931-08-14	1
54363	3223	40481087	1953-08-30	1953-09-20	1
60159	3565	40481087	1965-06-06	1965-06-20	1
57896	3437	260139	1976-12-28	1977-01-04	1
14108	834	4109685	2012-11-18	2012-12-02	1
49561	2935	372328	1978-06-26	1978-09-13	1
65764	3892	4294548	1973-04-09	1973-05-21	1
25160	1504	40481087	1944-02-06	1944-02-27	1
77959	4623	4112343	1996-05-08	1996-05-19	1
51245	3041	4112343	1983-10-02	1983-10-11	1
36772	2177	192671	2005-07-04	2005-07-05	1
35251	2090	260139	2011-06-10	2011-06-24	1
69101	4092	28060	1996-08-08	1996-08-18	1
77191	4577	260139	1992-03-24	1992-04-07	1
50080	2961	40481087	1999-09-28	1999-10-05	1
22158	1323	372328	1962-03-02	1962-04-14	1
25109	1498	40481087	2008-08-25	2008-09-15	1
22733	1358	4113008	2002-01-05	2002-01-26	1
3063	181	4112343	2008-05-11	2008-05-18	1
88337	5256	4112343	1980-11-04	1980-11-13	1
58774	3490	40481087	1974-12-31	1975-01-14	1
51010	3023	40481087	2013-01-09	2013-01-16	1
30504	1801	380378	1966-07-18	1966-07-19	1
55713	3301	4059173	1948-06-11	1948-07-11	1
79882	4738	40481087	1910-10-21	1910-11-04	1
56357	3343	40481087	2004-05-15	2004-05-29	1
58071	3443	30753	2011-05-25	2011-05-26	1
33638	1998	40481087	2002-09-12	2002-10-03	1
26272	1560	40481087	1941-11-13	1941-11-20	1
36993	2192	372328	1957-01-11	1957-11-21	2
40871	2433	4218389	1981-06-04	1981-07-02	1
51658	3067	260139	1994-10-18	1994-11-01	1
85284	5078	4051466	1914-05-07	1930-08-14	1
59845	3549	4112343	1981-11-07	1981-11-20	1
73767	4387	4146173	1972-07-08	1972-08-14	1
55812	3308	4112343	1977-08-03	1977-08-10	1
76616	4546	4112343	2011-12-29	2012-01-10	1
57817	3434	28060	1994-07-30	1994-08-12	1
64204	3795	40481087	2012-07-28	2012-08-11	1
9311	550	378419	1996-10-16	1996-10-17	1
52854	3133	4059173	1961-01-26	1961-03-27	1
20301	1223	40481087	1961-01-21	1961-01-28	1
79773	4732	372328	1964-07-06	1964-07-20	1
57590	3420	40481087	2002-08-14	2002-08-21	1
21882	1314	257012	1996-07-20	1996-07-21	1
81163	4819	4156265	1988-01-23	1988-02-06	1
67051	3968	40481087	1931-09-23	1931-10-14	1
47695	2835	40481087	1932-06-14	1932-06-21	1
54364	3223	40481087	1985-04-03	1985-04-10	1
60160	3565	81893	1980-07-23	1980-07-24	1
57897	3437	260139	1980-11-30	1980-12-14	1
14109	834	40481087	1957-08-08	1957-08-22	1
49562	2935	4109685	1987-01-10	1987-01-24	1
65765	3892	40481087	1987-05-07	1987-05-14	1
25161	1504	40481087	1976-10-19	1976-11-09	1
77960	4623	4152936	1970-12-10	1970-12-31	1
51246	3041	4112343	2001-10-30	2001-11-11	1
36773	2177	260139	1969-07-13	1969-07-27	1
35252	2090	321042	1974-03-20	1974-03-21	1
69102	4092	80180	2015-02-12	2015-02-13	1
77192	4577	260139	2017-05-03	2017-05-10	1
50081	2961	44782520	1999-05-02	1999-05-03	1
22159	1323	4112343	2017-12-18	2017-12-30	1
25110	1498	80180	2007-04-21	2007-04-22	1
22734	1358	4134304	1976-04-07	1976-05-07	1
3064	181	260139	1984-09-19	1984-10-03	1
88338	5256	4112343	1986-05-20	1986-05-30	1
58775	3490	40481087	1978-08-04	1978-08-11	1
53749	3183	260139	1998-02-11	1998-02-25	1
30505	1801	4029498	1966-07-18	1966-07-19	1
55714	3301	4109685	2016-12-30	2017-01-13	1
81699	4852	78272	1985-03-19	1985-04-16	1
58072	3443	80180	2012-05-19	2012-05-20	1
33639	1998	260139	2012-01-12	2012-01-19	1
26273	1560	40481087	1968-09-22	1968-09-29	1
36994	2192	4112343	1975-06-20	1975-06-28	1
42765	2551	28060	1970-06-22	1970-07-02	1
51659	3067	372328	1941-01-12	1941-02-25	1
85285	5078	4112343	1979-06-20	1979-07-01	1
59846	3549	4113008	2015-05-31	2015-06-21	1
73768	4387	4296205	1967-07-07	1967-08-04	1
55813	3308	372328	1948-11-14	1949-01-17	1
76617	4546	40481087	1990-07-29	1990-08-05	1
57818	3434	378001	1949-05-17	1949-06-16	1
64205	3795	4059173	1993-06-28	1993-07-28	1
9312	550	4112343	1965-09-13	1965-09-20	1
52855	3133	4112343	1960-07-03	1960-07-16	1
20302	1223	40481087	2000-06-15	2000-06-29	1
79774	4732	4112343	2018-01-10	2018-01-17	1
57591	3420	28060	1970-01-02	1970-01-14	1
21883	1314	260139	1977-07-01	1977-07-15	1
81164	4819	40481087	1965-07-27	1965-08-17	1
67052	3968	28060	1923-04-12	1923-04-24	1
47696	2835	40481087	1948-07-26	1948-08-02	1
54365	3223	81151	1981-06-06	1981-06-20	1
60161	3565	260139	2000-04-04	2000-04-11	1
57898	3437	372328	1977-05-16	1978-01-14	1
14110	834	80180	1996-08-18	1996-08-19	1
49563	2935	40481087	2012-10-07	2012-10-21	1
65766	3892	80180	2001-10-03	2001-10-04	1
25162	1504	40481087	2005-06-16	2005-06-30	1
77961	4623	4285898	1971-02-23	1971-02-24	1
51247	3041	4296204	1987-02-09	1987-03-09	1
36774	2177	372328	1971-05-17	1972-05-03	1
35253	2090	4116491	1994-05-25	1994-07-08	1
69103	4092	372328	1976-11-18	1977-05-12	1
77193	4577	372328	1985-06-06	1986-06-14	2
50082	2961	28060	1987-12-10	1987-12-18	1
22160	1323	4155034	1997-09-15	1997-10-06	1
25111	1498	372328	1969-01-19	1969-02-24	1
22735	1358	4283893	1957-08-10	1957-10-05	1
3065	181	4112343	1994-07-01	1994-07-09	1
88339	5256	4112343	1994-02-28	1994-03-09	1
58776	3490	40481087	1983-03-27	1983-04-03	1
53750	3183	4278672	2017-05-30	2017-06-29	1
30506	1801	4112343	2011-02-15	2011-02-25	1
55715	3301	4112343	1954-02-07	1954-02-14	1
81700	4852	260139	1951-10-17	1951-10-24	1
58073	3443	260139	1981-09-16	1981-09-23	1
33640	1998	4266809	2015-10-01	2015-10-02	1
26274	1560	40481087	1994-12-15	1995-01-05	1
36995	2192	4112343	1992-01-19	1992-01-28	1
42766	2551	260139	2017-03-04	2017-03-18	1
51660	3067	439777	1969-12-11	1969-12-12	1
85286	5078	4134304	1983-05-23	1983-06-22	1
59847	3549	40481087	1958-01-09	1958-01-23	1
73769	4387	40481087	1970-01-28	1970-02-11	1
55814	3308	4112343	1949-05-04	1949-05-17	1
76618	4546	28060	2015-12-02	2015-12-09	1
57819	3434	4296204	1961-02-20	1961-03-06	1
64206	3795	4112343	1994-04-26	1994-05-03	1
9313	550	81151	1950-06-09	1950-06-30	1
52856	3133	4112343	1965-10-19	1965-11-01	1
20303	1223	40481087	2003-12-19	2004-01-02	1
79775	4732	4237458	1961-11-19	1962-01-18	1
57592	3420	28060	1980-01-22	1980-02-04	1
21884	1314	4112343	1941-05-25	1941-06-03	1
81165	4819	40481087	1969-12-17	1969-12-24	1
67053	3968	28060	1923-11-24	1923-12-05	1
47697	2835	40481087	1961-07-31	1961-08-07	1
54366	3223	255848	1998-07-03	1998-07-04	1
60162	3565	260139	2019-03-10	2019-03-24	1
57899	3437	4001336	1988-10-30	1988-10-31	1
14111	834	81893	1995-08-24	1995-08-25	1
49564	2935	4155034	2018-06-08	2018-06-22	1
65767	3892	81151	2014-04-03	2014-04-17	1
25163	1504	80180	1985-01-15	1985-01-16	1
77962	4623	40481087	1932-11-29	1932-12-06	1
51248	3041	40481087	1980-10-18	1980-11-01	1
36775	2177	4134304	1982-10-02	1982-10-31	1
35254	2090	40481087	2012-08-29	2012-09-12	1
69104	4092	40481087	2006-05-08	2006-05-29	1
77194	4577	4112343	2015-06-13	2015-06-25	1
50083	2961	80180	2007-11-01	2007-11-02	1
22161	1323	78272	2018-06-18	2018-07-16	1
25112	1498	4112343	2012-08-29	2012-09-08	1
22736	1358	40481087	2015-06-16	2015-06-30	1
3392	195	81151	1959-01-11	1959-02-01	1
88340	5256	4142905	2008-03-05	2008-06-03	1
58777	3490	40481087	2002-07-28	2002-08-18	1
53751	3183	40481087	2007-11-22	2007-11-29	1
30507	1801	4155034	1996-12-19	1997-01-02	1
55716	3301	4112343	2005-02-07	2005-02-20	1
81701	4852	260139	1962-12-15	1962-12-22	1
58074	3443	260139	1994-05-20	1994-06-03	1
33641	1998	40481087	1998-08-07	1998-08-28	1
26275	1560	81151	1940-06-16	1940-07-07	1
36996	2192	4112343	1992-04-28	1992-05-10	1
42767	2551	40481087	1964-10-25	1964-11-08	1
51661	3067	4116491	1982-12-08	1983-01-27	1
85287	5078	40481087	1919-10-03	1919-10-10	1
62693	3707	81151	1975-09-27	1975-11-01	1
73770	4387	40481087	2018-03-27	2018-04-03	1
55815	3308	4112343	1957-06-20	1957-06-30	1
76619	4546	260139	2004-06-15	2004-06-22	1
57820	3434	40479768	1951-06-06	1951-08-12	1
64207	3795	40481087	2004-09-17	2004-10-01	1
9314	550	260139	1963-09-30	1963-10-07	1
52857	3133	4310024	1987-08-13	1987-08-14	1
20304	1223	28060	1975-12-07	1975-12-14	1
79776	4732	80180	1992-09-27	1992-09-28	1
57593	3420	81151	1975-09-02	1975-09-23	1
21885	1314	4112343	1945-03-15	1945-03-22	1
81166	4819	40481087	1984-04-23	1984-04-30	1
67054	3968	260139	2019-01-27	2019-02-10	1
47698	2835	40481087	1968-11-20	1968-12-11	1
54367	3223	4296204	1938-04-25	1938-05-23	1
60163	3565	40481087	1958-03-28	1958-04-11	1
57900	3437	4109685	1936-03-20	1936-04-03	1
14112	834	257012	1992-04-24	1992-04-25	1
49565	2935	4294548	1980-05-22	1980-06-12	1
65768	3892	4027663	1993-06-22	1993-06-23	1
25164	1504	372328	1942-06-05	1942-08-25	1
77963	4623	40481087	1979-06-19	1979-07-10	1
51249	3041	257012	1981-09-08	1981-09-09	1
36776	2177	260139	1971-04-16	1971-04-23	1
35255	2090	260139	1969-11-14	1969-11-21	1
69105	4092	192671	2015-04-29	2015-04-30	1
77195	4577	40481087	1986-06-02	1986-06-23	1
50084	2961	81151	2004-03-06	2004-04-03	1
22162	1323	4059173	2016-04-29	2016-05-29	1
29823	1766	80180	1996-08-27	1996-08-28	1
22737	1358	4112343	1978-11-25	1978-12-05	1
3393	195	260139	1974-04-01	1974-04-15	1
88341	5256	40481087	1966-09-13	1966-09-27	1
58778	3490	40481087	2011-01-11	2011-01-18	1
53752	3183	134438	2014-02-07	2014-11-07	1
30508	1801	40481087	1997-08-07	1997-08-14	1
55717	3301	4285898	1974-01-11	1974-01-12	1
81702	4852	4112343	1990-01-02	1990-01-15	1
58075	3443	4027663	2003-03-02	2003-03-03	1
33642	1998	4027663	2006-09-13	2006-09-14	1
26276	1560	260139	1997-12-12	1997-12-26	1
36997	2192	4112343	1996-11-16	1996-11-26	1
42768	2551	40481087	1995-01-02	1995-01-23	1
51662	3067	4134304	2015-11-09	2015-12-09	1
85288	5078	40481087	1925-05-17	1925-05-24	1
62694	3707	4027663	1999-06-23	1999-06-24	1
73771	4387	260139	2002-08-04	2002-08-11	1
55816	3308	4329847	1996-11-18	1996-11-19	1
76620	4546	378001	1992-12-19	1993-02-17	1
57821	3434	260139	1973-06-21	1973-07-05	1
64208	3795	192671	2010-08-11	2010-08-12	1
9315	550	260139	1983-06-20	1983-06-27	1
52858	3133	40481087	1973-06-22	1973-07-13	1
20305	1223	80180	1989-10-20	1989-10-21	1
79777	4732	260139	1995-02-28	1995-03-07	1
57594	3420	260139	2002-07-29	2002-08-05	1
21886	1314	4283893	1996-06-22	1996-10-12	1
81167	4819	40481087	1987-08-20	1987-09-03	1
67055	3968	313217	2006-03-31	2006-04-01	1
47699	2835	40481087	1980-02-11	1980-02-25	1
54368	3223	40481087	1983-07-27	1983-08-03	1
60164	3565	40481087	1964-10-26	1964-11-02	1
57901	3437	4112343	1927-01-23	1927-02-04	1
14113	834	260139	1989-11-09	1989-11-23	1
49566	2935	40481087	1999-12-09	1999-12-23	1
65769	3892	4109685	1970-12-15	1971-01-05	1
25165	1504	4112343	1968-05-05	1968-05-15	1
77964	4623	81151	1938-03-28	1938-05-02	1
51250	3041	40481087	1988-08-28	1988-09-11	1
36777	2177	260139	1990-09-12	1990-09-19	1
35256	2090	40481087	1979-04-01	1979-04-08	1
69106	4092	260139	1987-09-24	1987-10-08	1
78564	4657	28060	1972-05-27	1972-06-05	1
50085	2961	195588	2017-09-14	2017-10-16	1
22163	1323	4112343	1986-10-19	1986-10-29	1
29824	1766	4112343	1952-12-23	1953-01-05	1
22738	1358	4113008	1965-02-20	1965-03-06	1
3394	195	4112343	1987-10-12	1987-10-23	1
88342	5256	372328	1963-09-23	1963-10-18	1
58779	3490	28060	1950-04-22	1950-05-02	1
53753	3183	260139	2004-11-30	2004-12-07	1
30509	1801	40481087	2003-06-23	2003-07-07	1
55718	3301	40481087	1972-12-10	1972-12-24	1
81703	4852	4116491	1994-01-04	1994-02-20	1
58076	3443	40481087	1994-02-04	1994-02-25	1
33643	1998	4285898	2015-02-03	2015-02-04	1
26277	1560	372328	1941-09-28	1942-01-05	1
36998	2192	4112343	2013-09-02	2013-09-12	1
42769	2551	78272	2016-09-06	2016-10-04	1
51663	3067	4283893	1968-04-02	1968-04-30	1
85289	5078	40481087	1934-10-07	1934-10-21	1
62695	3707	40481087	2009-12-20	2010-01-03	1
73772	4387	4112343	1979-08-03	1979-08-16	1
55817	3308	40481087	1954-05-11	1954-06-01	1
77993	4626	260139	1990-12-14	1990-12-28	1
57822	3434	372328	1954-01-10	1954-04-08	1
64209	3795	372328	1974-02-08	1974-04-23	1
9316	550	4112343	1964-09-10	1964-09-17	1
52859	3133	40481087	1981-02-01	1981-02-08	1
20306	1223	257012	1980-12-15	1980-12-16	1
79778	4732	4152936	1997-11-24	1997-12-08	1
57595	3420	40481087	1984-04-29	1984-05-13	1
21887	1314	40481087	1940-02-28	1940-03-06	1
81168	4819	40481087	1999-01-29	1999-02-12	1
67056	3968	381316	1972-07-07	1972-07-08	1
47700	2835	40481087	1983-12-27	1984-01-03	1
54369	3223	40481087	1995-02-11	1995-02-25	1
60165	3565	80180	1982-05-14	1982-05-15	1
57902	3437	4112343	1966-02-13	1966-02-22	1
14114	834	4112343	1977-12-14	1977-12-22	1
49567	2935	40481087	2000-12-22	2001-01-12	1
65770	3892	4112343	1984-01-27	1984-02-07	1
25166	1504	40481087	1942-10-30	1942-11-06	1
79726	4729	260139	1980-05-03	1980-05-10	1
51251	3041	40481087	2013-02-23	2013-03-09	1
36778	2177	81151	2002-09-17	2002-10-15	1
36062	2140	4112343	1955-08-18	1955-08-26	1
69107	4092	4112343	1973-10-09	1973-10-21	1
78565	4657	260139	1987-08-07	1987-08-21	1
50086	2961	260139	1994-06-29	1994-07-13	1
22164	1323	4134304	1987-05-11	1987-07-10	1
29825	1766	4112343	1994-04-15	1994-04-26	1
22739	1358	40481087	1973-03-12	1973-04-02	1
3395	195	40481087	1986-01-16	1986-02-06	1
88343	5256	40481087	1982-01-12	1982-01-19	1
58780	3490	80180	1987-06-21	1987-06-22	1
53754	3183	4230399	1999-07-04	1999-09-02	1
30510	1801	40481087	2005-07-01	2005-07-15	1
55719	3301	40481087	2008-07-12	2008-08-02	1
81704	4852	4156265	1995-01-24	1995-02-07	1
60049	3561	260139	2007-08-24	2007-08-31	1
33644	1998	40481087	1985-02-05	1985-02-12	1
26278	1560	4278672	2017-01-29	2017-04-29	1
36999	2192	4237458	1962-08-13	1962-10-12	1
42770	2551	260139	1985-10-29	1985-11-05	1
51664	3067	4296204	1998-03-08	1998-03-29	1
85290	5078	40481087	1995-08-27	1995-09-03	1
62696	3707	40481087	2013-03-27	2013-04-03	1
73773	4387	4156265	1993-05-26	1993-06-09	1
55818	3308	81151	1951-07-19	1951-08-16	1
77994	4626	372328	1977-02-25	1977-04-11	1
57823	3434	40481087	1952-11-06	1952-11-27	1
64210	3795	4112343	1996-11-21	1996-12-01	1
9317	550	4112343	1977-02-20	1977-03-03	1
53071	3147	80180	1983-09-19	1983-09-20	1
20307	1223	4310024	1988-11-24	1988-11-25	1
79779	4732	4166224	1970-07-21	1970-07-22	1
57596	3420	40481087	1987-04-04	1987-04-18	1
21888	1314	40481087	1978-06-01	1978-06-22	1
81169	4819	28060	1967-08-14	1967-08-23	1
67057	3968	4112343	1927-08-19	1927-08-28	1
49275	2917	81151	2013-08-19	2013-09-16	1
54370	3223	0	1949-07-12	1949-07-13	1
60166	3565	81151	1957-11-19	1957-12-24	1
57903	3437	4112343	1974-05-13	1974-05-25	1
14115	834	4112343	1978-08-21	1978-08-29	1
49568	2935	40481087	2007-10-14	2007-10-28	1
65771	3892	4155034	2013-02-23	2013-03-09	1
25167	1504	40481087	1944-10-02	1944-10-23	1
79727	4729	260139	1984-12-27	1985-01-03	1
51252	3041	40481087	2017-04-22	2017-05-13	1
36779	2177	372328	1969-03-13	1969-03-27	1
36063	2140	4310024	1987-07-27	1987-07-28	1
69108	4092	40481087	1988-09-04	1988-09-11	1
78566	4657	260139	1993-05-05	1993-05-19	1
50087	2961	260139	2005-12-28	2006-01-04	1
22165	1323	28060	1986-07-10	1986-07-17	1
29826	1766	4112343	2007-01-22	2007-02-02	1
22740	1358	40481087	1982-04-20	1982-05-04	1
3396	195	28060	1965-12-07	1965-12-16	1
88344	5256	40481087	2011-05-10	2011-05-31	1
58781	3490	80502	2005-11-11	2005-11-12	1
53755	3183	28060	1992-05-27	1992-06-09	1
30511	1801	40481087	2008-06-06	2008-06-13	1
55720	3301	28060	1996-07-08	1996-07-21	1
81705	4852	28060	1966-10-12	1966-10-22	1
60050	3561	313217	1973-04-16	1973-04-17	1
33645	1998	40481087	2011-08-25	2011-09-15	1
26279	1560	40481087	1967-06-29	1967-07-06	1
37000	2192	40481087	1977-01-31	1977-02-14	1
42771	2551	4112343	1978-02-24	1978-03-05	1
51665	3067	40481087	1989-01-02	1989-01-09	1
85291	5078	81151	1981-03-06	1981-04-03	1
62697	3707	80180	2008-07-05	2008-07-06	1
73774	4387	40481087	1994-09-28	1994-10-05	1
55819	3308	81151	1977-12-18	1978-01-22	1
77995	4626	40481087	1978-06-29	1978-07-20	1
57824	3434	40481087	1958-11-04	1958-11-11	1
64211	3795	40481087	2014-10-09	2014-10-23	1
9318	550	28060	1927-03-16	1927-03-25	1
53072	3147	260139	1947-11-09	1947-11-23	1
20308	1223	40481087	1968-08-06	1968-08-20	1
79780	4732	40481087	1984-06-16	1984-07-07	1
57597	3420	81151	1982-12-15	1983-01-12	1
21889	1314	44782520	1946-07-21	1946-07-22	1
81170	4819	28060	1970-02-10	1970-02-17	1
67058	3968	4134304	2018-05-25	2018-08-23	1
49276	2917	378419	2017-02-15	2017-02-16	1
54371	3223	28060	1948-07-05	1948-07-12	1
60167	3565	260139	1951-08-27	1951-09-03	1
57904	3437	4134304	1915-03-13	1915-05-12	1
14116	834	40481087	1997-07-17	1997-08-07	1
49569	2935	81151	1994-03-18	1994-04-01	1
65772	3892	40481087	1970-08-05	1970-08-19	1
25168	1504	40481087	1959-09-14	1959-09-21	1
79728	4729	378001	1978-12-09	1979-01-08	1
51253	3041	80180	2018-04-12	2018-04-13	1
36780	2177	40481087	1985-09-25	1985-10-09	1
36064	2140	81893	1988-05-22	1988-05-23	1
70302	4168	80180	2010-06-12	2010-06-13	1
78567	4657	260139	2009-06-11	2009-06-18	1
50088	2961	4112343	1978-04-25	1978-05-06	1
22166	1323	260139	1984-03-08	1984-03-15	1
29827	1766	40481087	1968-11-05	1968-11-12	1
22741	1358	80180	1996-08-01	1996-08-02	1
3397	195	28060	2014-10-15	2014-10-25	1
64018	3786	260139	1981-04-12	1981-04-19	1
58782	3490	260139	1961-06-23	1961-07-07	1
53756	3183	80180	2017-07-14	2017-07-15	1
30512	1801	0	1966-07-18	1966-07-19	1
55721	3301	80180	1974-05-11	1974-05-12	1
81706	4852	195588	1995-02-20	1995-04-20	1
60051	3561	4027663	1936-01-25	1936-01-26	1
33646	1998	40481087	2012-09-15	2012-09-22	1
26280	1560	40481087	1968-08-07	1968-08-14	1
37001	2192	40481087	1978-02-14	1978-03-07	1
42772	2551	40481087	1983-02-14	1983-02-28	1
51666	3067	40481087	1998-06-30	1998-07-21	1
85292	5078	260139	1973-04-22	1973-05-06	1
62698	3707	81893	2006-07-16	2006-07-17	1
73775	4387	40481087	2010-08-21	2010-08-28	1
55820	3308	260139	1979-11-17	1979-11-24	1
77996	4626	260139	1994-12-08	1994-12-22	1
57825	3434	80180	1983-11-05	1983-11-06	1
806	43	372328	1957-03-17	1957-05-27	1
9319	550	80180	1956-07-02	1956-07-03	1
53073	3147	260139	1980-01-01	1980-01-15	1
20309	1223	28060	1955-06-03	1955-06-16	1
79781	4732	40481087	1996-07-12	1996-07-26	1
57598	3420	260139	1993-04-22	1993-04-29	1
21890	1314	372328	1930-10-13	1931-01-24	1
81171	4819	4112343	1976-06-17	1976-06-27	1
67059	3968	40480160	2018-05-25	2018-08-23	1
49277	2917	4112343	1966-05-14	1966-05-27	1
54372	3223	80180	1959-12-21	1959-12-22	1
60168	3565	260139	1977-06-12	1977-06-19	1
57905	3437	40481087	1928-07-03	1928-07-17	1
14117	834	40481087	2012-03-16	2012-04-06	1
49570	2935	4134304	1981-01-11	1981-03-12	1
65773	3892	4112343	1967-06-06	1967-06-19	1
25169	1504	40481087	1960-11-20	1960-12-04	1
79729	4729	4112343	1973-10-08	1973-10-19	1
51254	3041	378001	2005-04-03	2005-06-02	1
36781	2177	40481087	2013-10-15	2013-11-04	1
36065	2140	260139	1962-10-08	1962-10-22	1
70303	4168	372328	1973-12-18	1974-03-09	1
78568	4657	375671	1966-04-09	1966-05-09	1
50089	2961	4166224	1972-09-26	1972-09-27	1
22167	1323	260139	2011-08-23	2011-09-06	1
29828	1766	40481087	2001-07-31	2001-08-07	1
22742	1358	260139	1987-03-04	1987-03-18	1
3398	195	257012	1998-11-22	1998-11-23	1
64019	3786	4112343	1961-10-27	1961-11-06	1
58783	3490	260139	1978-05-02	1978-05-09	1
53757	3183	4059173	1988-05-02	1988-06-01	1
30513	1801	4112343	2010-07-08	2010-07-16	1
55722	3301	372328	1938-10-02	1938-12-13	1
81707	4852	260139	1956-12-28	1957-01-11	1
60052	3561	4112343	1953-08-16	1953-08-25	1
33647	1998	40481087	2016-07-10	2016-07-17	1
27838	1646	0	1982-11-22	1982-11-23	1
37002	2192	40481087	2005-06-24	2005-07-01	1
42773	2551	40481087	2011-12-30	2012-01-06	1
51667	3067	40481087	2017-10-15	2017-10-22	1
85293	5078	372328	1983-06-12	1983-07-25	1
62699	3707	372328	1969-09-28	1969-12-08	1
74622	4437	28060	1976-10-01	1976-10-08	1
55821	3308	317576	1981-04-27	1981-04-28	1
77997	4626	372328	1979-06-30	1979-10-08	1
57826	3434	372328	1950-05-12	1950-09-28	1
807	43	4112343	1967-07-18	1967-07-30	1
9320	550	80502	1980-03-26	1980-03-27	1
53074	3147	375671	1969-09-10	1969-10-10	1
20310	1223	28060	1959-12-23	1959-12-30	1
79782	4732	81151	1976-06-03	1976-06-17	1
57599	3420	378001	2000-02-12	2000-04-12	1
21891	1314	372328	1935-05-03	1936-02-01	1
81172	4819	4112343	1995-01-19	1995-01-28	1
67060	3968	40481087	1921-07-03	1921-07-10	1
49278	2917	4112343	1998-10-04	1998-10-15	1
54373	3223	80502	1987-06-17	1987-06-18	1
60169	3565	372328	1945-12-24	1946-02-09	1
57906	3437	40481087	1982-05-15	1982-06-05	1
14118	834	40481087	2018-02-09	2018-02-23	1
49571	2935	4237458	1984-12-21	1985-01-20	1
65774	3892	4112343	1972-03-09	1972-03-16	1
25170	1504	40481087	1983-09-03	1983-09-24	1
79730	4729	40481087	1968-03-14	1968-03-21	1
51255	3041	4084167	2005-08-03	2005-08-04	1
36782	2177	4112343	1985-07-20	1985-07-29	1
36066	2140	260139	1998-03-20	1998-04-03	1
70304	4168	378001	1992-08-10	1992-10-09	1
78569	4657	375671	2013-06-29	2013-07-29	1
50090	2961	4294548	2004-08-14	2004-09-18	1
22168	1323	40481087	1988-11-21	1988-12-12	1
29829	1766	40481087	2003-09-03	2003-09-17	1
22743	1358	372328	1959-09-20	1960-07-14	1
3399	195	260139	1970-01-14	1970-01-21	1
64020	3786	4112343	1974-03-27	1974-04-06	1
58784	3490	4051466	1947-09-21	1964-12-21	1
53758	3183	4084167	1981-08-07	1981-08-07	1
37310	2213	28060	1997-09-14	1997-09-22	1
55723	3301	378001	1965-03-14	1965-04-13	1
81708	4852	372328	1950-08-12	1950-10-12	1
60053	3561	4112343	1972-08-16	1972-08-25	1
36944	2190	28060	1953-10-23	1953-11-01	1
27839	1646	81893	1980-04-14	1980-04-15	1
37003	2192	80180	1996-04-01	1996-04-02	1
42774	2551	260139	2008-02-08	2008-02-22	1
51668	3067	80180	1976-07-27	1976-07-28	1
85294	5078	4112343	1979-01-09	1979-01-20	1
62700	3707	372328	1973-11-19	1974-06-10	1
74623	4437	260139	1976-08-31	1976-09-07	1
55822	3308	80180	1984-06-15	1984-06-16	1
77998	4626	372328	1981-08-28	1981-10-19	1
57827	3434	4112343	1961-08-16	1961-08-29	1
808	43	4112343	2018-07-19	2018-07-30	1
9321	550	4113008	1962-07-27	1962-08-17	1
53075	3147	378001	1977-08-29	1977-10-28	1
20311	1223	81151	1995-01-15	1995-02-05	1
79783	4732	260139	1982-08-03	1982-08-17	1
57600	3420	4112343	1972-10-15	1972-10-26	1
21892	1314	378419	2017-07-15	2017-07-16	1
81173	4819	4283893	2016-06-21	2016-07-26	1
67061	3968	40481087	1929-02-19	1929-02-26	1
49279	2917	40481087	1987-08-29	1987-09-19	1
54374	3223	257012	1976-08-10	1976-08-11	1
60170	3565	439777	1976-02-25	1976-02-26	1
57907	3437	195588	1946-04-19	1946-05-23	1
19020	1144	260139	1992-10-15	1992-10-29	1
51387	3053	4112343	2003-01-09	2003-01-18	1
65775	3892	4112343	1977-06-22	1977-06-29	1
25171	1504	40481087	1989-03-01	1989-03-08	1
79731	4729	40481087	1977-12-05	1977-12-26	1
51256	3041	4112343	1992-11-23	1992-12-01	1
36783	2177	40481087	1993-02-04	1993-02-11	1
36067	2140	440086	1962-06-03	1963-10-13	1
70305	4168	40481087	1981-07-03	1981-07-17	1
78570	4657	4112343	2012-09-06	2012-09-15	1
50091	2961	40481087	1982-03-24	1982-04-07	1
22169	1323	40481087	1995-09-15	1995-09-29	1
29830	1766	40481087	2010-05-19	2010-05-26	1
22744	1358	378001	1967-03-26	1967-04-25	1
3400	195	372328	1961-09-27	1962-02-19	1
64021	3786	4112343	1981-09-11	1981-09-21	1
58785	3490	4109685	2012-06-27	2012-07-11	1
53759	3183	4112343	1982-07-06	1982-07-16	1
37311	2213	260139	2003-04-05	2003-04-12	1
55724	3301	4112343	1992-12-30	1993-01-08	1
81709	4852	372328	1952-01-07	1952-10-30	1
60054	3561	4112343	1974-04-19	1974-04-28	1
36945	2190	30753	1983-03-26	1983-03-27	1
27840	1646	372328	1956-12-06	1957-04-20	1
37004	2192	4283893	1979-06-07	1979-09-06	1
42775	2551	260139	2014-12-22	2015-01-05	1
51669	3067	257012	1968-04-23	1968-04-24	1
85295	5078	4113008	1942-02-17	1942-03-10	1
62701	3707	4112343	2014-06-20	2014-06-30	1
74624	4437	372328	1969-10-05	1969-12-17	1
55823	3308	260139	1977-08-02	1977-08-16	1
77999	4626	40481087	1987-01-06	1987-01-27	1
57828	3434	4112343	1964-04-05	1964-04-12	1
809	43	4112343	2018-11-30	2018-12-12	1
9322	550	4134304	1920-12-13	1921-03-13	1
53076	3147	4112343	1962-10-04	1962-10-12	1
20312	1223	260139	1982-08-20	1982-08-27	1
79784	4732	4112343	1966-08-07	1966-08-17	1
57601	3420	4112343	1998-12-27	1999-01-08	1
21893	1314	4112343	1966-03-17	1966-03-29	1
81174	4819	40481087	1966-01-22	1966-01-29	1
67062	3968	28060	1985-05-02	1985-05-15	1
49280	2917	40481087	1991-08-20	1991-08-27	1
54375	3223	260139	1923-07-14	1923-07-28	1
60171	3565	4112343	1971-05-12	1971-05-19	1
57908	3437	260139	1971-05-20	1971-05-27	1
19021	1144	260139	1999-06-27	1999-07-04	1
51388	3053	4134304	1997-10-31	1998-01-29	1
65776	3892	40481087	1963-03-03	1963-03-10	1
25172	1504	40481087	2004-10-23	2004-11-13	1
79732	4729	40481087	1984-08-26	1984-09-02	1
51257	3041	4112343	2014-05-09	2014-05-20	1
36784	2177	40481087	2012-01-11	2012-01-18	1
36068	2140	4112343	1966-10-29	1966-11-09	1
70306	4168	40481087	1998-08-31	1998-09-07	1
78571	4657	40481087	1966-10-12	1966-11-02	1
50092	2961	40481087	1990-10-28	1990-11-18	1
28338	1677	30753	2002-02-24	2002-02-25	1
29831	1766	40481087	2018-03-23	2018-03-30	1
22745	1358	4155034	1986-10-12	1986-10-26	1
3401	195	40481087	1987-10-08	1987-10-22	1
64022	3786	4112343	2017-08-02	2017-08-14	1
58786	3490	81151	1954-11-24	1954-12-29	1
53760	3183	4283893	1994-09-21	1994-10-05	1
37312	2213	4112343	1982-01-01	1982-01-12	1
55725	3301	4112343	1995-04-01	1995-04-14	1
81710	4852	4218389	2003-01-26	2003-03-02	1
60055	3561	4112343	2011-07-01	2011-07-14	1
36946	2190	260139	1952-06-28	1952-07-05	1
27841	1646	440448	1982-11-22	1982-11-23	1
37005	2192	4285898	1995-10-04	1995-10-05	1
42776	2551	372328	1959-03-19	1959-04-30	1
51670	3067	260139	1970-10-09	1970-10-23	1
85296	5078	4266809	1945-06-06	1945-06-07	1
62702	3707	4310024	2006-01-17	2006-01-18	1
74625	4437	4283893	1985-03-12	1985-05-28	1
55824	3308	260139	1991-02-05	1991-02-19	1
78000	4626	134438	1997-11-04	1998-11-02	1
57829	3434	4112343	1994-05-20	1994-05-27	1
810	43	4116491	1991-12-09	1992-01-14	1
9323	550	4278672	1977-07-29	1977-09-27	1
53077	3147	4112343	1970-01-04	1970-01-11	1
20313	1223	260139	1989-07-31	1989-08-07	1
79785	4732	4112343	1985-02-10	1985-02-18	1
57602	3420	40481087	1970-02-05	1970-02-12	1
21894	1314	4112343	1982-05-19	1982-05-30	1
81175	4819	40481087	1998-03-15	1998-03-29	1
67063	3968	80180	1950-07-18	1950-07-19	1
49281	2917	40481087	2009-08-03	2009-08-10	1
54376	3223	440448	1949-07-12	1949-07-13	1
60172	3565	4112343	1986-06-03	1986-06-10	1
57909	3437	260139	1980-05-19	1980-06-02	1
19022	1144	372328	1971-03-04	1971-05-16	1
51389	3053	40481087	1994-01-12	1994-02-02	1
65777	3892	40481087	1972-09-13	1972-10-04	1
25173	1504	260139	1993-12-05	1993-12-12	1
79733	4729	81151	2006-12-31	2007-01-28	1
51258	3041	4283893	1981-08-04	1981-10-27	1
38635	2295	40481087	1984-02-16	1984-03-01	1
36069	2140	4112343	1980-01-01	1980-01-10	1
70307	4168	40481087	2002-09-22	2002-10-13	1
78572	4657	40481087	1969-02-26	1969-03-19	1
50093	2961	257012	1972-02-26	1972-02-27	1
28339	1677	4112343	1979-09-19	1979-09-28	1
29832	1766	28060	1958-10-10	1958-10-19	1
22746	1358	4218389	2004-02-15	2004-03-21	1
3402	195	40481087	1989-12-19	1990-01-02	1
64023	3786	40481087	1960-08-05	1960-08-26	1
58787	3490	260139	1980-09-22	1980-10-01	1
53761	3183	4294548	1983-03-06	1983-03-20	1
37313	2213	40481087	2008-02-12	2008-02-26	1
55726	3301	4278672	2011-05-31	2011-07-30	1
81711	4852	40481087	2007-06-06	2007-06-20	1
60056	3561	4266809	1943-11-09	1943-11-10	1
36947	2190	4296204	2008-05-06	2008-05-27	1
27842	1646	4156265	1943-09-16	1943-10-07	1
37006	2192	40481087	1970-04-09	1970-04-23	1
42777	2551	4116491	2000-10-29	2000-12-11	1
51671	3067	260139	1984-11-14	1984-11-21	1
85297	5078	4294548	1939-09-02	1939-09-23	1
62703	3707	40481087	1982-09-26	1982-10-10	1
74626	4437	40481087	1971-09-01	1971-09-15	1
55825	3308	372328	1949-09-14	1950-01-16	1
78001	4626	260139	1982-01-31	1982-02-07	1
57830	3434	4113008	2009-04-23	2009-05-14	1
811	43	4218389	1999-07-10	1999-08-14	1
9324	550	40481087	1946-04-10	1946-05-01	1
53078	3147	4283893	1959-05-13	1959-06-10	1
20314	1223	313217	2012-05-11	2012-05-12	1
79786	4732	4112343	2007-08-23	2007-09-02	1
3183	187	260139	1965-10-07	1965-10-21	1
21895	1314	40481087	1952-12-04	1952-12-18	1
81176	4819	260139	1993-12-03	1993-12-17	1
67064	3968	260139	1968-08-28	1968-09-04	1
49282	2917	40481087	2014-02-22	2014-03-08	1
54377	3223	4152936	1997-11-23	1997-12-14	1
60173	3565	40481087	1958-07-17	1958-07-24	1
57910	3437	378001	1966-01-31	1966-04-01	1
19023	1144	40481087	2008-08-05	2008-08-26	1
51390	3053	40481087	1994-09-05	1994-09-12	1
65778	3892	40481087	2014-05-29	2014-06-05	1
25174	1504	440448	1960-06-07	1960-06-08	1
79734	4729	260139	2018-07-02	2018-07-09	1
51259	3041	40481087	2019-05-10	2019-05-24	1
38636	2295	260139	1994-09-16	1994-09-30	1
36070	2140	40481087	1958-09-30	1958-10-21	1
70308	4168	28060	1973-04-26	1973-05-08	1
78573	4657	40481087	1994-08-04	1994-08-11	1
50094	2961	372328	1976-11-27	1977-09-11	1
28340	1677	4112343	1991-12-09	1991-12-22	1
29833	1766	260139	1961-05-09	1961-05-16	1
22747	1358	4237458	2010-08-17	2010-10-16	1
3403	195	80180	1993-09-24	1993-09-25	1
64024	3786	81151	2007-06-28	2007-08-02	1
58788	3490	4112343	1987-11-16	1987-11-24	1
53762	3183	4294548	2014-12-28	2015-02-08	1
37314	2213	80180	1995-08-05	1995-08-06	1
55727	3301	40481087	1983-12-02	1983-12-09	1
81712	4852	28060	1970-05-08	1970-05-17	1
60057	3561	40481087	1917-10-28	1917-11-11	1
36948	2190	40481087	1999-02-09	1999-03-02	1
27843	1646	4278672	2012-03-22	2012-05-21	1
37007	2192	0	2001-12-06	2001-12-07	1
42778	2551	4218389	1990-07-04	1990-07-25	1
51672	3067	4112343	1997-11-09	1997-11-22	1
85298	5078	40481087	1912-09-27	1912-10-04	1
62704	3707	40481087	2002-02-13	2002-02-27	1
74627	4437	40481087	1996-05-04	1996-05-11	1
55826	3308	4109685	1952-09-09	1952-09-30	1
78002	4626	260139	2017-11-16	2017-11-30	1
57831	3434	260139	1968-09-06	1968-09-13	1
812	43	40481087	1957-01-22	1957-01-29	1
9325	550	40481087	1954-11-20	1954-12-11	1
53079	3147	40481087	1978-02-21	1978-03-14	1
20315	1223	4027663	1980-03-01	1980-03-02	1
79787	4732	40481087	1984-03-29	1984-04-12	1
3184	187	372328	1947-04-13	1947-06-30	1
21896	1314	40481087	1953-09-22	1953-10-13	1
81177	4819	260139	2015-11-03	2015-11-10	1
67065	3968	260139	2007-05-21	2007-05-28	1
49283	2917	80180	1976-02-10	1976-02-11	1
54378	3223	40481087	1952-11-12	1952-11-26	1
60174	3565	40481087	1979-06-14	1979-06-28	1
57911	3437	4112343	1960-10-19	1960-10-29	1
19024	1144	4035415	2009-05-02	2009-07-01	1
51391	3053	40481087	2002-02-23	2002-03-02	1
65970	3906	78272	1989-09-14	1989-10-19	1
25175	1504	4237458	1957-04-01	1957-06-30	1
79735	4729	4059173	1965-09-18	1965-10-18	1
52932	3137	28060	1919-02-27	1919-03-10	1
38637	2295	260139	2001-03-12	2001-03-19	1
36071	2140	40481087	1959-04-28	1959-05-05	1
70309	4168	260139	1973-12-20	1974-01-03	1
78574	4657	260139	1977-06-12	1977-06-26	1
50095	2961	4066995	1999-05-02	1999-06-02	1
28341	1677	4152936	1974-01-17	1974-01-31	1
29834	1766	372328	1957-05-29	1958-06-10	1
22748	1358	40481087	1956-01-14	1956-01-21	1
3404	195	440086	1969-03-14	1970-02-13	1
64025	3786	195588	1987-12-02	1988-01-24	1
58789	3490	40481087	1946-04-19	1946-05-03	1
53763	3183	260139	1982-05-06	1982-05-13	1
37315	2213	260139	1975-07-07	1975-07-14	1
55728	3301	40481087	2006-05-10	2006-05-17	1
81713	4852	260139	1975-11-23	1975-11-30	1
60058	3561	40481087	1958-11-01	1958-11-15	1
36949	2190	28060	2017-06-05	2017-06-12	1
27844	1646	4310024	1979-08-18	1979-08-19	1
37008	2192	257012	1979-07-19	1979-07-20	1
42779	2551	40481087	1969-02-23	1969-03-09	1
51673	3067	4113008	1958-05-11	1958-05-25	1
85299	5078	40481087	1925-11-27	1925-12-18	1
62705	3707	40481087	2003-12-24	2003-12-31	1
74628	4437	80180	2010-11-14	2010-11-15	1
55827	3308	4112343	1950-08-14	1950-08-22	1
78003	4626	378001	1993-07-31	1993-09-29	1
57832	3434	260139	1978-08-22	1978-09-05	1
813	43	260139	1978-12-23	1979-01-06	1
9326	550	40481087	1969-07-30	1969-08-20	1
53080	3147	40481087	1990-11-14	1990-11-21	1
20316	1223	4112343	1953-04-01	1953-04-12	1
79788	4732	40481087	1997-02-27	1997-03-20	1
3185	187	4109685	1980-01-09	1980-01-30	1
21897	1314	40481087	1970-06-07	1970-06-21	1
81178	4819	4112343	1965-09-10	1965-09-21	1
67066	3968	4112343	1996-01-12	1996-01-19	1
49284	2917	313217	1989-09-13	1989-09-14	1
54379	3223	40481087	1953-01-02	1953-01-23	1
54388	3223	40481087	1992-03-13	1992-03-20	1
57912	3437	4218389	1938-03-24	1938-04-28	1
19025	1144	4109685	1980-01-16	1980-01-30	1
51392	3053	4116491	2014-01-01	2014-02-17	1
65971	3906	260139	1978-03-13	1978-03-20	1
25176	1504	40481087	1979-10-02	1979-10-16	1
79736	4729	81151	2000-09-05	2000-10-03	1
52933	3137	28060	1928-06-23	1928-07-03	1
38638	2295	4113008	1996-12-23	1997-01-06	1
36072	2140	40481087	1975-05-30	1975-06-20	1
70310	4168	4283893	1975-09-14	1975-10-12	1
78575	4657	4112343	1990-12-21	1990-12-29	1
50096	2961	40481087	1996-08-21	1996-09-04	1
28342	1677	4266809	2003-04-20	2003-04-21	1
29835	1766	40481087	1970-02-10	1970-03-03	1
22749	1358	40481087	1956-12-22	1957-01-05	1
3405	195	4112343	1976-11-22	1976-12-05	1
58790	3490	40481087	2014-07-08	2014-07-15	1
53764	3183	260139	1993-10-19	1993-11-02	1
37316	2213	260139	2011-12-16	2011-12-23	1
55729	3301	28060	1939-11-27	1939-12-09	1
81714	4852	260139	1977-07-25	1977-08-08	1
60059	3561	40481087	1965-11-14	1965-11-28	1
36950	2190	80180	1983-09-22	1983-09-23	1
27845	1646	40481087	1974-12-30	1975-01-13	1
37009	2192	321042	2001-12-06	2001-12-07	1
42780	2551	40481087	1976-03-09	1976-03-16	1
51674	3067	4218389	1968-11-28	1968-12-26	1
85300	5078	40481087	1938-06-10	1938-07-01	1
62706	3707	40481087	2004-05-07	2004-05-14	1
74629	4437	372328	1970-06-15	1970-12-16	1
55828	3308	40481087	1981-10-12	1981-10-19	1
78004	4626	4112343	1990-09-18	1990-09-27	1
57833	3434	260139	2001-04-11	2001-04-25	1
814	43	4112343	1993-05-16	1993-05-27	1
9327	550	40481087	1999-02-22	1999-03-01	1
53081	3147	28060	1948-07-05	1948-07-12	1
20317	1223	4283893	1980-09-22	1980-12-22	1
79789	4732	0	1970-07-21	1970-07-22	1
3186	187	4112343	1996-04-08	1996-04-19	1
21898	1314	78272	1955-04-06	1955-05-04	1
81179	4819	4112343	1980-05-09	1980-05-21	1
67067	3968	4134304	1954-01-03	1954-02-02	1
49285	2917	372328	1940-04-28	1940-08-07	1
54380	3223	260139	1925-11-24	1925-12-01	1
56866	3378	28060	1977-05-03	1977-05-16	1
57913	3437	4294548	1945-05-09	1945-05-30	1
19026	1144	4112343	1989-08-08	1989-08-19	1
51393	3053	4116491	2015-02-17	2015-04-01	1
65972	3906	260139	1978-06-20	1978-07-04	1
25177	1504	40481087	2009-04-19	2009-04-26	1
79737	4729	40481087	1984-10-11	1984-11-01	1
52934	3137	28060	1981-04-13	1981-04-21	1
38639	2295	80180	2005-10-21	2005-10-22	1
36073	2140	40481087	1985-01-06	1985-01-20	1
70311	4168	40481087	1977-09-10	1977-09-17	1
78576	4657	4116491	1990-11-10	1991-01-05	1
50097	2961	40481087	2019-03-08	2019-03-16	1
28343	1677	40481087	2011-11-20	2011-12-04	1
29836	1766	40481087	1999-03-09	1999-03-16	1
22750	1358	40481087	1966-06-27	1966-07-11	1
3406	195	4112343	2004-05-29	2004-06-05	1
58791	3490	81151	1950-03-22	1950-04-19	1
53765	3183	372328	1983-04-29	1983-07-17	1
37317	2213	40481087	2008-11-28	2008-12-05	1
55730	3301	78272	1973-01-31	1973-02-28	1
81715	4852	260139	1986-06-09	1986-06-23	1
60060	3561	40481087	2001-07-17	2001-08-07	1
36951	2190	372328	1955-12-08	1956-01-16	1
27846	1646	40481087	1999-09-13	1999-09-20	1
37010	2192	4027663	1986-12-15	1986-12-16	1
42781	2551	80180	1998-06-27	1998-06-28	1
51675	3067	40481087	1947-01-17	1947-01-24	1
85301	5078	80180	1945-06-06	1945-06-07	1
62707	3707	40481087	1986-12-24	1986-12-31	1
74630	4437	4027663	2000-01-01	2000-01-02	1
55829	3308	40481087	1987-11-22	1987-12-13	1
78005	4626	40481087	1995-01-24	1995-01-31	1
57834	3434	378001	2002-09-27	2002-11-26	1
815	43	4156265	1990-03-24	1990-04-07	1
9960	592	28060	1975-11-29	1975-12-09	1
53082	3147	257012	2017-06-14	2017-06-15	1
20318	1223	4285898	1989-08-21	1989-08-22	1
79790	4732	28060	1957-04-16	1957-04-25	1
3187	187	40481087	1959-08-06	1959-08-13	1
21899	1314	260139	1970-12-14	1970-12-21	1
81180	4819	4230399	1976-09-22	1976-11-21	1
67068	3968	4155034	1936-10-29	1936-11-19	1
49286	2917	4146173	1952-07-10	1952-09-08	1
54381	3223	378419	1991-07-10	1991-07-11	1
56867	3378	260139	1970-05-05	1970-05-19	1
57914	3437	4299128	1920-03-16	1920-04-13	1
19027	1144	4112343	2016-06-12	2016-06-23	1
51394	3053	4146173	1988-06-20	1988-07-20	1
65973	3906	372328	1947-01-28	1947-10-01	1
25178	1504	40481087	2011-02-23	2011-03-02	1
79738	4729	40481087	2009-11-11	2009-12-02	1
52935	3137	260139	1910-06-13	1910-06-27	1
38640	2295	81151	1980-07-29	1980-08-19	1
36074	2140	40481087	1999-02-08	1999-02-22	1
70312	4168	40481087	1993-09-05	1993-09-19	1
78577	4657	4218389	2002-01-07	2002-01-28	1
50098	2961	4112343	1985-05-14	1985-05-24	1
28344	1677	372328	1970-05-08	1970-06-20	1
29837	1766	260139	1994-05-13	1994-05-27	1
24158	1442	140673	2016-01-19	2016-01-20	1
3407	195	4218389	1977-11-23	1977-12-28	1
58792	3490	260139	1969-10-30	1969-11-13	1
53766	3183	40481087	1994-03-29	1994-04-19	1
37318	2213	40481087	2010-10-04	2010-10-11	1
55731	3301	78272	1988-11-06	1988-11-27	1
81716	4852	372328	1951-03-11	1951-04-12	1
60061	3561	40481087	2007-03-15	2007-03-22	1
36952	2190	4027663	1976-05-01	1976-05-02	1
27847	1646	40481087	2011-03-26	2011-04-09	1
37011	2192	4112343	1959-01-16	1959-01-29	1
42782	2551	260139	1991-01-09	1991-01-23	1
51676	3067	40481087	1969-04-01	1969-04-08	1
85302	5078	4027663	1937-04-24	1937-04-25	1
62708	3707	40481087	2012-06-30	2012-07-21	1
74631	4437	4112343	1999-06-07	1999-06-14	1
57076	3391	80180	2019-05-29	2019-05-30	1
78006	4626	80180	2009-11-09	2009-11-10	1
57835	3434	440086	1957-04-20	1957-05-18	1
816	43	40481087	1962-06-11	1962-06-18	1
9961	592	80180	2007-03-09	2007-03-10	1
53083	3147	258780	1972-02-14	1972-02-15	1
20319	1223	4294548	2012-09-18	2012-10-09	1
79791	4732	440448	1970-07-21	1970-07-22	1
3188	187	40481087	2013-10-17	2013-11-06	1
21900	1314	260139	2012-04-22	2012-05-06	1
81181	4819	40481087	2016-12-30	2017-01-20	1
67069	3968	4278672	2003-06-13	2003-09-11	1
49287	2917	4152936	2016-08-31	2016-09-14	1
54382	3223	4112343	1986-06-06	1986-06-18	1
56868	3378	378001	1998-11-26	1999-01-25	1
57915	3437	40481087	1915-03-19	1915-04-02	1
19028	1144	28060	1975-03-14	1975-03-23	1
51395	3053	40481087	2001-04-13	2001-04-20	1
65974	3906	375671	1967-01-13	1967-02-12	1
25179	1504	0	1960-06-07	1960-06-08	1
79739	4729	80180	2000-03-08	2000-03-09	1
52936	3137	372328	1912-03-02	1912-03-30	1
38641	2295	4112343	1984-08-23	1984-09-05	1
36075	2140	40481087	2002-05-12	2002-05-19	1
70313	4168	4283893	1996-07-12	1996-08-02	1
78578	4657	40481087	2001-09-08	2001-09-22	1
50099	2961	4294548	1972-01-29	1972-03-25	1
28345	1677	4027663	1994-07-06	1994-07-07	1
29838	1766	261325	1981-01-06	1981-01-07	1
24159	1442	260139	1963-01-25	1963-02-01	1
3408	195	4294548	1998-10-18	1998-12-06	1
58793	3490	260139	1993-06-22	1993-07-06	1
53767	3183	40481087	1996-07-31	1996-08-14	1
37319	2213	260139	1980-11-15	1980-11-22	1
55732	3301	4027663	1963-03-30	1963-03-31	1
81717	4852	4059173	1967-03-26	1967-05-26	1
60062	3561	40481087	2014-04-19	2014-05-10	1
36953	2190	4112343	1978-12-07	1978-12-16	1
27848	1646	40481087	2014-08-27	2014-09-10	1
37012	2192	4112343	1986-06-02	1986-06-15	1
42783	2551	375671	1984-02-06	1984-03-07	1
51677	3067	40481087	2019-04-22	2019-05-06	1
85303	5078	4035415	1997-09-02	1997-10-02	1
62709	3707	40481087	2014-03-07	2014-03-21	1
74632	4437	4112343	2000-10-07	2000-10-15	1
57077	3391	4059173	2009-12-04	2010-02-02	1
78007	4626	260139	2007-01-05	2007-01-12	1
57836	3434	4112343	1989-09-29	1989-10-11	1
817	43	40481087	1991-08-15	1991-08-29	1
9962	592	40481087	1995-03-14	1995-03-28	1
53084	3147	4112343	1955-08-20	1955-08-30	1
20320	1223	40481087	1964-07-30	1964-08-20	1
79792	4732	40481087	1969-03-20	1969-04-10	1
3189	187	192671	1985-02-08	1985-02-09	1
21901	1314	317576	2012-01-14	2012-01-15	1
84324	5018	80180	1980-01-25	1980-01-26	1
67070	3968	4294548	1934-10-29	1934-12-24	1
49288	2917	40481087	2007-08-31	2007-09-07	1
54383	3223	4237458	1929-02-11	1929-03-13	1
56869	3378	4112343	1989-02-15	1989-02-27	1
57916	3437	40481087	1917-11-23	1917-12-07	1
19029	1144	28060	2013-09-13	2013-09-22	1
51396	3053	40481087	2018-12-21	2018-12-28	1
65975	3906	4112343	1978-06-27	1978-07-06	1
25180	1504	4112343	1987-10-05	1987-10-13	1
79740	4729	4059173	1967-11-07	1968-01-06	1
52937	3137	381316	1987-11-14	1987-11-15	1
38642	2295	4237458	2015-07-01	2015-08-30	1
36076	2140	28060	1989-11-22	1989-12-04	1
70314	4168	40481087	1986-08-28	1986-09-11	1
78579	4657	28060	1982-05-25	1982-06-03	1
51299	3047	260139	1990-03-26	1990-04-09	1
28346	1677	4156265	2018-08-08	2018-08-22	1
29839	1766	4146173	2015-05-25	2015-07-24	1
24160	1442	260139	2005-03-11	2005-03-18	1
3409	195	40481087	1966-05-11	1966-05-25	1
58794	3490	4112343	1975-05-09	1975-05-19	1
57347	3408	81151	2010-01-06	2010-01-27	1
37320	2213	4152936	1972-05-23	1972-06-06	1
55733	3301	40481087	1950-06-27	1950-07-04	1
81718	4852	4266809	1990-09-17	1990-09-18	1
60063	3561	28060	1983-03-14	1983-03-26	1
36954	2190	4156265	1988-01-08	1988-01-22	1
27849	1646	80180	1982-03-05	1982-03-06	1
37013	2192	40481087	1970-07-28	1970-08-11	1
42784	2551	4056621	2000-10-29	2000-10-30	1
51678	3067	0	1960-12-20	1960-12-21	1
85304	5078	4112343	1961-10-04	1961-10-13	1
62710	3707	28060	1980-10-03	1980-10-14	1
74633	4437	40481087	1986-03-29	1986-04-19	1
57078	3391	4283893	1986-11-07	1987-03-13	1
78008	4626	4112343	2006-07-09	2006-07-20	1
57837	3434	4142905	1965-08-12	1965-11-10	1
818	43	40481087	2003-06-28	2003-07-05	1
9963	592	40481087	1983-03-27	1983-04-17	1
53085	3147	4156265	2014-07-28	2014-08-18	1
23045	1378	28060	1967-03-15	1967-03-23	1
82714	4917	80180	2016-06-28	2016-06-29	1
3190	187	378001	1974-06-05	1974-08-04	1
21902	1314	4066995	1946-07-21	1946-09-20	1
84325	5018	81151	1955-09-23	1955-10-21	1
67071	3968	40481087	1918-09-13	1918-09-20	1
49289	2917	28060	1990-02-08	1990-02-15	1
54384	3223	4278672	1919-08-03	1919-11-01	1
56870	3378	4283893	1966-12-01	1967-01-26	1
57917	3437	40481087	1970-10-26	1970-11-09	1
19030	1144	260139	1981-06-10	1981-06-17	1
51397	3053	439777	1987-01-08	1987-01-09	1
65976	3906	4294548	2010-05-23	2010-05-30	1
25181	1504	4112343	1988-04-11	1988-04-20	1
79741	4729	4112343	2000-05-03	2000-05-15	1
52938	3137	4112343	1930-04-27	1930-05-05	1
38643	2295	40481087	2006-04-25	2006-05-02	1
36077	2140	30753	1988-10-19	1988-10-20	1
70315	4168	40481087	1988-03-09	1988-03-30	1
78580	4657	80180	1999-02-15	1999-02-16	1
51300	3047	260139	1993-09-28	1993-10-05	1
28347	1677	40481087	1993-02-10	1993-03-03	1
29840	1766	40481087	2001-02-08	2001-02-22	1
24161	1442	260139	2006-08-23	2006-08-30	1
3410	195	40481087	1998-02-28	1998-03-14	1
58795	3490	4156265	2017-03-17	2017-03-31	1
57348	3408	257012	1997-05-27	1997-05-28	1
37321	2213	28060	1987-03-19	1987-03-29	1
55734	3301	40481087	1991-12-03	1991-12-17	1
81719	4852	4294548	1977-01-01	1977-02-05	1
60064	3561	81893	1941-12-19	1941-12-20	1
36955	2190	4266809	1983-09-22	1983-09-23	1
27850	1646	81151	2014-02-10	2014-02-24	1
37014	2192	40481087	2018-09-30	2018-10-07	1
42785	2551	4112343	1998-04-20	1998-04-28	1
51679	3067	28060	1951-06-22	1951-07-02	1
85305	5078	4156265	1956-05-25	1956-06-15	1
62711	3707	260139	1984-09-10	1984-09-17	1
74634	4437	81893	2008-08-26	2008-08-27	1
57079	3391	40481087	1990-11-29	1990-12-06	1
78009	4626	4230399	2016-05-01	2016-05-31	1
57838	3434	40481087	1992-01-22	1992-02-05	1
819	43	28060	1959-08-08	1959-08-19	1
9964	592	40481087	2005-10-06	2005-10-13	1
53086	3147	40481087	1973-02-02	1973-02-23	1
23046	1378	80180	1981-07-26	1981-07-27	1
82715	4917	4112343	2002-02-15	2002-02-25	1
3191	187	4112343	1978-11-05	1978-11-16	1
21903	1314	4112343	1935-06-21	1935-06-30	1
84326	5018	372328	1942-07-03	1942-10-22	1
67072	3968	40481087	1932-05-20	1932-06-03	1
49290	2917	372328	1939-01-20	1939-02-03	1
54385	3223	4294548	1976-07-20	1976-08-31	1
56871	3378	40481087	1979-02-12	1979-02-19	1
57918	3437	80180	1955-03-03	1955-03-04	1
19031	1144	260139	2006-03-31	2006-04-14	1
51398	3053	4109685	1982-11-05	1982-11-19	1
65977	3906	4296204	2004-05-03	2004-06-07	1
25182	1504	4112343	2005-08-06	2005-08-15	1
79742	4729	4112343	2009-01-29	2009-02-05	1
52939	3137	4112343	1935-05-10	1935-05-17	1
38644	2295	40481087	2013-09-10	2013-09-24	1
36078	2140	260139	1963-06-21	1963-07-05	1
71722	4260	372328	1941-05-14	1941-08-12	1
78581	4657	4112343	1968-05-01	1968-05-14	1
51301	3047	372328	1975-02-11	1975-07-02	1
28348	1677	28060	1985-06-02	1985-06-10	1
29841	1766	40481087	2005-04-17	2005-05-08	1
24162	1442	4112343	1946-07-07	1946-07-14	1
3411	195	40481087	2016-09-01	2016-09-15	1
58796	3490	4278672	1951-02-13	1951-04-14	1
57349	3408	4027663	2000-06-29	2000-06-30	1
37322	2213	134438	1991-07-19	1993-02-10	1
55735	3301	40481087	2010-01-29	2010-02-05	1
81720	4852	40481087	1956-04-28	1956-05-13	1
60065	3561	260139	1925-02-12	1925-02-19	1
36956	2190	4278672	2014-09-23	2014-12-22	1
27851	1646	260139	2018-03-23	2018-04-06	1
37015	2192	28060	1955-10-20	1955-10-30	1
42786	2551	4116491	2000-08-10	2000-09-24	1
51680	3067	81151	1979-08-01	1979-08-15	1
85306	5078	4156265	1998-09-27	1998-10-18	1
62712	3707	260139	1986-10-08	1986-10-15	1
74635	4437	4218389	2018-02-20	2018-03-13	1
57080	3391	40481087	2011-12-12	2011-12-19	1
78010	4626	4294548	1984-04-24	1984-05-15	1
58379	3462	257012	1961-05-27	1961-05-28	1
820	43	80180	1997-03-22	1997-03-23	1
9965	592	40481087	2012-11-11	2012-11-18	1
53087	3147	40481087	1998-02-20	1998-02-27	1
23047	1378	134438	1974-06-20	1975-02-21	1
82716	4917	4112343	2015-09-16	2015-09-26	1
3192	187	4112343	2000-10-27	2000-11-08	1
21904	1314	4112343	1955-12-28	1956-01-07	1
84327	5018	4294548	2018-09-11	2019-01-01	1
67073	3968	40481087	1944-03-11	1944-03-18	1
49291	2917	4112343	1949-05-30	1949-06-11	1
54386	3223	40481087	1967-09-14	1967-09-28	1
56872	3378	28060	1978-11-10	1978-11-22	1
57919	3437	192671	1955-04-23	1955-04-24	1
19032	1144	40481087	1993-11-24	1993-12-15	1
51399	3053	4112343	2006-10-01	2006-10-12	1
65978	3906	40481087	1978-05-31	1978-06-07	1
25183	1504	4112343	2015-09-23	2015-10-01	1
79743	4729	4155034	1993-11-20	1993-12-11	1
52940	3137	4116491	1947-06-27	1947-08-14	1
38645	2295	372328	1974-11-28	1975-01-14	1
36079	2140	260139	1964-12-25	1965-01-01	1
71723	4260	378001	1948-08-26	1948-09-25	1
78582	4657	4278672	1969-03-24	1969-04-23	1
51302	3047	4112343	1990-06-10	1990-06-21	1
31117	1845	80180	1997-07-24	1997-07-25	1
24163	1442	4112343	1996-05-18	1996-05-28	1
3412	195	4112343	2014-12-25	2015-01-01	1
58797	3490	4278672	1956-01-23	1956-04-22	1
57350	3408	4112343	1976-10-29	1976-11-07	1
37323	2213	260139	2004-09-04	2004-09-18	1
55736	3301	40481087	2011-09-03	2011-09-10	1
81721	4852	40481087	1986-10-24	1986-10-30	1
60066	3561	260139	1949-02-12	1949-02-19	1
36957	2190	40481087	1963-01-06	1963-01-13	1
27852	1646	4027663	1969-11-23	1969-11-24	1
37016	2192	260139	1986-07-11	1986-07-25	1
43598	2599	78272	1986-08-19	1986-09-16	1
51681	3067	192671	1976-10-06	1976-10-07	1
85307	5078	4294548	1915-07-27	1915-08-17	1
62713	3707	260139	2002-08-23	2002-09-06	1
74636	4437	4266809	2010-11-14	2010-11-15	1
57081	3391	257012	1986-12-12	1986-12-13	1
82592	4909	372328	1978-04-14	1978-05-22	1
58380	3462	260139	1994-09-26	1994-10-03	1
821	43	4059173	1987-03-10	1987-04-09	1
9966	592	260139	1975-08-01	1975-08-08	1
53088	3147	28060	1953-06-20	1953-06-28	1
23048	1378	260139	2017-07-18	2017-08-01	1
82717	4917	4146173	2018-03-04	2018-05-03	1
3193	187	4112343	2006-12-22	2006-12-30	1
21905	1314	4152936	1980-05-22	1980-06-12	1
84328	5018	40481087	1967-05-14	1967-06-04	1
67074	3968	40481087	1961-07-12	1961-07-26	1
49292	2917	4112343	2012-01-08	2012-01-20	1
54387	3223	40481087	1978-09-28	1978-10-12	1
56873	3378	28060	1998-12-10	1998-12-18	1
57920	3437	4112343	1956-06-03	1956-06-11	1
19033	1144	78272	1990-10-04	1990-11-08	1
51400	3053	4156265	2009-03-02	2009-03-16	1
65979	3906	28060	1982-04-01	1982-04-12	1
25184	1504	4152936	1954-05-03	1954-05-17	1
79744	4729	40481087	1993-07-23	1993-07-30	1
52941	3137	4296205	1933-06-10	1933-07-08	1
38646	2295	372328	1976-06-07	1976-07-13	1
36080	2140	375671	1988-03-14	1988-04-13	1
71724	4260	378419	2018-10-30	2018-10-31	1
78583	4657	40481087	2005-10-09	2005-10-23	1
51303	3047	4283893	2002-07-20	2002-11-16	1
31118	1845	260139	1972-04-22	1972-05-06	1
24164	1442	40481087	1999-07-31	1999-08-14	1
3413	195	4134304	1997-08-15	1997-11-13	1
58798	3490	40481087	2000-03-10	2000-03-31	1
57351	3408	4112343	2011-06-06	2011-06-14	1
37324	2213	4048695	1969-05-08	1969-07-08	1
56945	3382	4112343	1969-10-03	1969-10-10	1
81722	4852	40481087	2018-02-28	2018-03-15	1
60067	3561	4112343	1930-04-01	1930-04-09	1
36958	2190	78272	1957-10-28	1957-11-18	1
27853	1646	4112343	1967-05-31	1967-06-07	1
37017	2192	260139	1997-01-11	1997-01-18	1
43599	2599	372328	1980-09-14	1981-01-03	1
51682	3067	260139	1974-08-31	1974-09-07	1
85308	5078	40481087	1982-06-14	1982-06-28	1
62714	3707	372328	1970-04-07	1970-06-08	1
74637	4437	4285898	2010-05-18	2010-05-19	1
57082	3391	4146173	1997-06-03	1997-08-09	1
82593	4909	4116491	1999-06-10	1999-07-15	1
58381	3462	372328	1969-12-05	1970-10-02	1
822	43	4112343	1996-07-14	1996-07-24	1
9967	592	40481087	1993-08-30	1993-09-13	1
53089	3147	260139	1992-02-24	1992-03-02	1
23049	1378	4155034	1952-06-29	1952-07-13	1
82718	4917	28060	1996-04-04	1996-04-16	1
3194	187	4296204	2001-04-15	2001-05-13	1
21906	1314	4294548	2015-05-24	2015-07-19	1
84329	5018	257012	2002-08-23	2002-08-24	1
67075	3968	40481087	1966-12-06	1966-12-27	1
49293	2917	40481087	1966-11-16	1966-11-23	1
56874	3378	257012	1966-12-29	1966-12-30	1
57921	3437	4285898	1954-09-04	1954-09-05	1
19034	1144	80180	2014-09-14	2014-09-15	1
51401	3053	80180	2018-07-24	2018-07-25	1
65980	3906	80180	1984-04-28	1984-04-29	1
25185	1504	4294548	1942-02-11	1942-02-25	1
80192	4757	0	2001-03-17	2001-03-18	1
52942	3137	40481087	1972-06-21	1972-07-12	1
38647	2295	4112343	1973-11-04	1973-11-16	1
36081	2140	4027663	1978-05-30	1978-05-31	1
71725	4260	4112343	1981-07-01	1981-07-13	1
78584	4657	195588	1987-10-01	1987-11-11	1
51304	3047	4310024	2015-05-12	2015-05-13	1
31119	1845	4283893	1978-02-24	1978-06-02	1
24165	1442	80180	1980-12-18	1980-12-19	1
3414	195	40481087	2005-06-11	2005-06-25	1
59675	3540	260139	1984-05-06	1984-05-13	1
57352	3408	4283893	1997-04-01	1997-07-08	1
37325	2213	4112343	1989-05-19	1989-05-26	1
56946	3382	4112343	1975-08-13	1975-08-23	1
81723	4852	28060	1960-11-30	1960-12-08	1
60068	3561	4112343	1940-08-15	1940-08-22	1
36959	2190	4112343	2000-04-18	2000-05-01	1
27854	1646	40481087	1964-06-02	1964-06-16	1
37018	2192	260139	1997-11-15	1997-11-29	1
43600	2599	372328	1988-08-24	1988-11-05	1
51683	3067	260139	2003-10-21	2003-10-28	1
85309	5078	28060	1962-04-14	1962-04-21	1
62715	3707	4285898	2008-02-06	2008-02-07	1
74638	4437	40481087	1999-01-04	1999-01-18	1
57083	3391	4283893	1994-07-26	1994-10-04	1
82594	4909	40481087	1997-08-14	1997-09-04	1
58382	3462	4294548	1987-01-21	1987-02-04	1
823	43	4112343	2007-10-28	2007-11-10	1
11818	700	260139	2003-05-06	2003-05-13	1
53090	3147	378001	1990-01-21	1990-02-20	1
23050	1378	40481087	2001-02-21	2001-03-14	1
82719	4917	28060	1989-02-16	1989-02-28	1
3195	187	40481087	1985-11-24	1985-12-15	1
21907	1314	40481087	2011-03-02	2011-03-16	1
84330	5018	260139	1963-05-07	1963-05-21	1
67076	3968	40481087	1969-08-19	1969-08-26	1
49294	2917	40481087	1976-03-10	1976-03-31	1
56875	3378	260139	1965-10-08	1965-10-22	1
57922	3437	4296205	1972-11-25	1972-12-23	1
19035	1144	134438	1991-06-09	1992-07-03	1
51402	3053	4112343	1992-11-15	1992-11-28	1
65981	3906	260139	1989-10-18	1989-10-25	1
27149	1606	81893	1987-10-20	1987-10-21	1
80193	4757	80180	1994-10-05	1994-10-06	1
52943	3137	81151	1982-05-06	1982-06-03	1
38648	2295	40481087	1986-11-22	1986-11-29	1
36082	2140	4134304	1960-01-20	1960-03-20	1
71726	4260	4112343	2016-10-11	2016-10-20	1
78585	4657	260139	2010-07-15	2010-07-29	1
51305	3047	40481087	1977-01-06	1977-01-20	1
31120	1845	260139	1979-01-31	1979-02-14	1
24166	1442	260139	1973-04-09	1973-04-16	1
6078	358	260139	1976-02-16	1976-03-01	1
59676	3540	260139	1994-10-19	1994-11-02	1
57353	3408	4285898	2008-02-18	2008-02-19	1
37326	2213	4230399	1974-06-26	1974-09-24	1
56947	3382	4278672	1992-04-20	1992-05-20	1
81724	4852	30753	1989-07-24	1989-07-25	1
60069	3561	4112343	1948-09-24	1948-10-07	1
36960	2190	40481087	1972-12-30	1973-01-20	1
27855	1646	260139	1941-05-30	1941-06-13	1
37019	2192	4116491	2001-12-11	2002-02-02	1
43601	2599	4142905	1984-10-28	1984-11-27	1
51684	3067	260139	2018-07-13	2018-07-20	1
85310	5078	317576	1980-07-07	1980-07-08	1
62716	3707	40481087	1994-06-27	1994-07-18	1
74639	4437	28060	1984-03-15	1984-03-25	1
57084	3391	4283893	2001-04-09	2001-04-30	1
82595	4909	260139	2017-02-07	2017-02-14	1
58383	3462	4294548	1992-07-05	1992-09-20	1
824	43	40481087	1997-12-03	1997-12-17	1
11819	700	439777	2011-06-06	2011-06-07	1
53091	3147	4059173	1955-01-29	1955-04-29	1
23051	1378	40481087	2006-09-12	2006-09-19	1
82720	4917	4134304	1993-08-23	1993-11-21	1
3196	187	40481087	2010-01-06	2010-01-27	1
21908	1314	40481087	2016-11-18	2016-11-25	1
84331	5018	260139	2009-08-27	2009-09-03	1
67077	3968	80502	1994-01-21	1994-01-22	1
49295	2917	260139	1941-02-10	1941-02-17	1
56876	3378	372328	1959-12-07	1959-12-21	1
57923	3437	40481087	1921-04-25	1921-05-09	1
19036	1144	260139	1987-10-04	1987-10-11	1
51403	3053	4112343	2016-12-20	2017-01-02	1
65982	3906	4112343	1980-01-29	1980-02-10	1
27150	1606	192671	1989-06-03	1989-06-04	1
80194	4757	260139	1961-10-29	1961-11-05	1
52944	3137	4112343	1965-06-24	1965-07-03	1
38649	2295	40481087	2007-08-30	2007-09-06	1
36083	2140	4266809	1989-10-14	1989-10-15	1
71727	4260	40481087	1984-09-26	1984-10-10	1
78586	4657	372328	1961-08-03	1961-09-15	1
51306	3047	40481087	2013-04-27	2013-05-11	1
31121	1845	260139	2019-02-06	2019-02-13	1
24167	1442	372328	1948-02-25	1948-07-13	1
6079	358	372328	1944-12-29	1945-12-11	1
59677	3540	372328	1974-07-27	1974-10-07	1
57354	3408	40481087	2015-12-06	2015-12-27	1
37327	2213	40481087	1986-05-14	1986-06-04	1
56948	3382	4283893	1991-11-27	1991-12-25	1
81725	4852	80180	1990-09-17	1990-09-18	1
36961	2190	40481087	2009-04-17	2009-05-01	1
27856	1646	260139	1946-01-14	1946-01-28	1
37020	2192	40481087	1974-07-30	1974-08-06	1
43602	2599	40481087	2019-06-12	2019-06-13	1
51685	3067	321042	1960-12-20	1960-12-21	1
85311	5078	4112343	1936-04-20	1936-05-01	1
65719	3890	378001	1975-11-19	1975-12-19	1
74640	4437	30753	2009-06-22	2009-06-23	1
57085	3391	28060	1990-09-09	1990-09-17	1
82596	4909	372328	1975-07-16	1975-09-22	1
58384	3462	40481087	1992-04-13	1992-04-27	1
825	43	40481087	2010-01-06	2010-01-27	1
11820	700	4113008	2017-06-11	2017-07-02	1
53092	3147	4112343	1962-05-26	1962-06-04	1
23052	1378	260139	1950-12-18	1951-01-01	1
82721	4917	40481087	1985-01-07	1985-01-14	1
3197	187	80180	1984-11-29	1984-11-30	1
24495	1464	28060	1998-03-08	1998-03-20	1
84332	5018	4112343	1995-03-13	1995-03-21	1
67078	3968	257012	1934-11-19	1934-11-20	1
49296	2917	260139	1964-11-14	1964-11-28	1
56877	3378	372328	1961-09-11	1962-06-30	1
57924	3437	40481087	1924-04-02	1924-04-16	1
19037	1144	260139	2013-10-16	2013-10-30	1
51404	3053	40481087	2007-03-12	2007-03-19	1
65983	3906	40481087	2011-03-02	2011-03-09	1
27151	1606	260139	1988-10-07	1988-10-15	1
80195	4757	4109685	1982-09-06	1982-09-20	1
52945	3137	4116491	1939-04-10	1939-05-18	1
39435	2340	372328	1961-01-22	1961-02-05	1
36084	2140	80180	1989-10-14	1989-10-15	1
71728	4260	40481087	1993-05-03	1993-05-10	1
78587	4657	4112343	1973-01-02	1973-01-10	1
51307	3047	28060	1976-11-06	1976-11-16	1
31122	1845	378001	1965-02-27	1965-03-29	1
24168	1442	4112343	1994-03-17	1994-03-26	1
6080	358	4112343	1948-02-13	1948-02-22	1
59678	3540	4134304	1976-09-14	1976-11-13	1
57355	3408	30753	2007-07-23	2007-07-24	1
37328	2213	40481087	1986-11-07	1986-11-28	1
56949	3382	40481087	1980-10-04	1980-10-18	1
81726	4852	195588	1993-10-26	1993-12-07	1
36962	2190	372328	1985-11-09	1987-12-21	1
27857	1646	260139	1948-02-18	1948-03-03	1
37021	2192	40481087	2003-03-11	2003-04-01	1
43603	2599	81151	2001-03-01	2001-03-22	1
51686	3067	4112343	2009-05-26	2009-06-06	1
85312	5078	4112343	1952-12-07	1952-12-19	1
65720	3890	4112343	1974-12-12	1974-12-19	1
74641	4437	257012	1985-05-07	1985-05-08	1
57086	3391	260139	1994-10-19	1994-10-26	1
82597	4909	4112343	2004-02-17	2004-03-01	1
58385	3462	40481087	2010-03-12	2010-03-26	1
826	43	28060	1961-02-11	1961-02-18	1
11821	700	40481087	1991-09-24	1991-10-01	1
53093	3147	4283893	2017-04-26	2017-06-21	1
23053	1378	4218389	1981-08-10	1981-09-14	1
82722	4917	81151	1997-12-14	1998-01-18	1
3198	187	260139	1999-07-27	1999-08-03	1
24496	1464	4112343	1968-05-03	1968-05-14	1
84333	5018	4112343	2009-05-08	2009-05-19	1
67079	3968	260139	1913-10-01	1913-10-15	1
49297	2917	439777	1962-08-27	1962-08-28	1
56878	3378	4237458	2017-04-20	2017-05-20	1
57925	3437	40481087	1946-12-26	1947-01-02	1
19038	1144	372328	1972-06-09	1972-11-12	1
53118	3149	80180	1989-10-31	1989-11-01	1
65984	3906	40481087	2016-05-16	2016-05-23	1
27152	1606	4283893	2006-05-06	2006-08-12	1
80196	4757	4155034	2004-05-27	2004-06-17	1
52946	3137	4142905	1975-04-13	1975-05-13	1
39436	2340	372328	1961-06-06	1961-08-10	1
36085	2140	372328	1952-09-28	1952-11-12	1
71729	4260	40481087	2001-12-29	2002-01-05	1
78588	4657	40479422	1995-06-06	1995-07-13	1
51308	3047	81151	1989-04-28	1989-05-26	1
31123	1845	378001	1988-03-28	1988-05-27	1
24169	1442	4116491	1974-01-29	1974-03-18	1
6081	358	40481087	1943-08-16	1943-09-06	1
59679	3540	80180	2013-07-07	2013-07-08	1
57356	3408	80180	2008-10-15	2008-10-16	1
41282	2458	78272	1996-05-05	1996-06-09	1
56950	3382	4109685	1965-12-17	1966-01-07	1
81727	4852	260139	1967-10-29	1967-11-11	1
36963	2190	4112343	1961-12-23	1962-01-01	1
27858	1646	260139	2010-12-12	2010-12-19	1
39753	2357	28060	1981-01-24	1981-02-03	1
43604	2599	260139	1981-09-10	1981-09-24	1
51687	3067	4134304	1967-03-09	1967-04-08	1
85313	5078	4112343	1971-07-07	1971-07-19	1
65721	3890	40481087	2019-01-12	2019-02-02	1
74642	4437	4112343	1981-01-17	1981-01-29	1
57087	3391	260139	2015-08-05	2015-08-19	1
82598	4909	4116491	2003-07-14	2003-09-06	1
58386	3462	40481087	2019-06-16	2019-06-23	1
827	43	260139	1979-10-19	1979-11-02	1
11822	700	40481087	2004-12-16	2004-12-30	1
53094	3147	40481087	1948-09-21	1948-09-28	1
23054	1378	40481087	1949-01-01	1949-01-15	1
82723	4917	4112343	1991-01-22	1991-01-30	1
3199	187	4027663	1977-07-15	1977-07-16	1
24497	1464	80180	2002-08-13	2002-08-14	1
84334	5018	4155034	1963-07-16	1963-08-06	1
67080	3968	260139	1944-02-04	1944-02-11	1
49298	2917	4112343	1971-03-06	1971-03-18	1
56879	3378	40481087	1965-04-17	1965-05-01	1
58293	3457	81151	1921-02-07	1921-02-21	1
19039	1144	378001	2012-04-16	2012-05-16	1
53119	3149	4134304	2012-11-22	2012-12-22	1
65985	3906	260139	1955-07-17	1955-07-24	1
27153	1606	4296205	1953-12-12	1954-01-16	1
80197	4757	40481087	1973-09-28	1973-10-05	1
52947	3137	40481087	1937-07-14	1937-07-21	1
39437	2340	4027663	1991-02-24	1991-02-25	1
36086	2140	4113008	1984-02-13	1984-03-05	1
71730	4260	4112343	1960-11-08	1960-11-16	1
78589	4657	40481087	1985-03-04	1985-03-18	1
51309	3047	81893	2015-12-08	2015-12-09	1
31124	1845	4112343	1969-10-24	1969-11-05	1
24170	1442	4296204	1975-07-03	1975-07-24	1
6082	358	40481087	1952-11-26	1952-12-17	1
59680	3540	372328	1976-06-28	1977-01-03	1
57357	3408	81151	1984-02-19	1984-03-18	1
41283	2458	81151	1981-09-23	1981-10-21	1
56951	3382	40481087	1995-10-11	1995-10-25	1
81728	4852	372328	1950-01-24	1950-04-13	1
36964	2190	4112343	1986-03-13	1986-03-22	1
27859	1646	372328	1946-01-03	1946-02-02	1
39754	2357	260139	1955-03-19	1955-04-02	1
43605	2599	4112343	1984-01-29	1984-02-09	1
51688	3067	4134304	2010-12-05	2011-01-04	1
85314	5078	4113008	1988-05-31	1988-06-21	1
65722	3890	28060	1960-03-16	1960-03-29	1
74643	4437	40481087	1971-05-06	1971-05-27	1
57088	3391	4237458	2005-12-25	2006-01-24	1
82599	4909	80180	2008-08-26	2008-08-27	1
58387	3462	4112343	1969-05-20	1969-05-27	1
828	43	378001	1984-07-23	1984-08-22	1
11823	700	40481087	2008-05-19	2008-06-02	1
53095	3147	40481087	1977-02-10	1977-02-17	1
23055	1378	28060	1962-10-29	1962-11-05	1
82724	4917	4113008	1994-12-16	1994-12-30	1
3200	187	4059173	1948-04-07	1948-05-08	1
24498	1464	192671	2002-11-01	2002-11-02	1
84335	5018	4294548	2002-07-05	2002-11-01	1
67081	3968	260139	1965-02-19	1965-02-26	1
49299	2917	40481087	1941-10-12	1941-10-19	1
56880	3378	78272	1961-03-01	1961-03-15	1
58294	3457	134438	1936-09-03	1937-11-27	1
19040	1144	4059173	2003-01-04	2003-02-03	1
53120	3149	40481087	1951-10-24	1951-11-07	1
65986	3906	260139	1957-03-12	1957-03-19	1
27154	1606	4310024	1987-08-21	1987-08-22	1
80198	4757	81151	1975-02-17	1975-03-17	1
52948	3137	195588	1943-05-17	1943-06-28	1
39438	2340	4112343	1984-10-03	1984-10-13	1
36087	2140	4146173	1987-03-20	1987-05-19	1
71731	4260	4112343	1982-09-08	1982-09-17	1
78590	4657	40481087	1991-03-23	1991-04-13	1
51310	3047	4027663	2005-07-18	2005-07-19	1
31125	1845	40481087	1997-05-17	1997-05-31	1
24171	1442	40481087	1965-05-16	1965-05-30	1
6083	358	40481087	1971-06-10	1971-07-01	1
59681	3540	4112343	1977-10-25	1977-11-01	1
57358	3408	260139	1997-01-13	1997-01-20	1
41284	2458	4059173	2015-02-28	2015-04-29	1
56952	3382	40481087	1998-10-14	1998-10-28	1
81729	4852	4027663	1981-10-28	1981-10-29	1
36965	2190	4112343	1995-06-05	1995-06-13	1
27860	1646	372328	2017-12-31	2018-01-27	1
39755	2357	260139	1957-09-26	1957-10-10	1
43606	2599	4112343	1990-12-06	1990-12-18	1
51689	3067	81151	1943-02-01	1943-03-01	1
88594	5274	4296204	1966-02-22	1966-03-22	1
65723	3890	260139	1976-09-07	1976-09-21	1
76833	4559	80180	1983-05-29	1983-05-30	1
57089	3391	40481087	1982-08-27	1982-09-10	1
82600	4909	81151	1993-01-08	1993-02-05	1
58388	3462	4112343	1990-06-15	1990-06-22	1
829	43	4109685	1994-11-12	1994-12-03	1
11824	700	4155034	2008-09-05	2008-09-26	1
53096	3147	78272	1964-08-09	1964-09-06	1
23056	1378	378001	2010-10-12	2010-11-11	1
82725	4917	40481087	1984-07-18	1984-08-01	1
3201	187	4112343	1951-12-22	1951-12-29	1
24499	1464	260139	1996-03-31	1996-04-07	1
84336	5018	260139	1979-03-13	1979-03-27	1
67082	3968	4112343	1994-05-13	1994-05-21	1
49300	2917	40481087	1949-08-13	1949-08-27	1
56881	3378	80809	1996-07-10	2000-08-18	1
58295	3457	4218389	1960-04-25	1960-05-16	1
19041	1144	40481087	1981-09-15	1981-09-22	1
53121	3149	4112343	1996-10-04	1996-10-14	1
65987	3906	260139	2001-10-20	2001-10-27	1
27155	1606	40481087	1962-10-18	1962-11-01	1
80199	4757	260139	1985-09-02	1985-09-09	1
52949	3137	260139	1919-01-12	1919-01-19	1
39439	2340	4278672	1966-07-26	1966-10-24	1
36088	2140	40481087	1952-06-05	1952-06-26	1
71732	4260	4296205	1945-11-19	1945-12-10	1
81345	4829	192671	2012-07-04	2012-07-05	1
51311	3047	4112343	1993-01-07	1993-01-20	1
31126	1845	40481087	2011-07-29	2011-08-12	1
24172	1442	40481087	1995-01-17	1995-01-31	1
6084	358	40481087	1980-06-19	1980-07-10	1
59682	3540	4218389	2005-02-05	2005-02-26	1
57359	3408	372328	1971-10-25	1971-12-13	1
41285	2458	4112343	1973-04-22	1973-05-05	1
56953	3382	40481087	2018-06-24	2018-07-15	1
81730	4852	4056621	1994-01-04	1994-01-05	1
36966	2190	4218389	1982-02-10	1982-03-10	1
27861	1646	4112343	1981-10-22	1981-11-02	1
39756	2357	4112343	1958-12-26	1959-01-07	1
43607	2599	4218389	1981-11-22	1981-12-13	1
51690	3067	260139	1971-07-21	1971-08-04	1
88595	5274	40481087	1999-03-21	1999-04-04	1
65724	3890	4112343	1987-01-19	1987-02-01	1
76834	4559	81151	1947-03-09	1947-03-23	1
57090	3391	40481087	2018-02-23	2018-03-09	1
82601	4909	372328	1976-03-20	1976-05-24	1
58389	3462	4146173	1985-06-14	1985-08-20	1
830	43	40481087	1976-08-10	1976-08-24	1
11825	700	44782520	1997-06-04	1997-06-05	1
53097	3147	81151	1988-11-29	1988-12-27	1
23057	1378	4152936	2013-08-27	2013-09-10	1
84644	5039	260139	2014-04-13	2014-04-27	1
3202	187	4112343	1962-02-08	1962-02-16	1
24500	1464	260139	2018-11-09	2018-11-16	1
84337	5018	4116491	1980-11-05	1980-12-07	1
67083	3968	4296205	1977-07-01	1977-07-29	1
49301	2917	40481087	1952-06-20	1952-06-27	1
56882	3378	321042	2014-05-10	2014-05-11	1
58296	3457	40481087	1947-07-12	1947-07-26	1
19042	1144	40481087	2003-01-06	2003-01-27	1
53122	3149	4134304	1961-12-13	1962-01-12	1
65988	3906	4059173	2011-04-02	2011-06-01	1
27156	1606	40481087	1987-08-03	1987-08-17	1
80200	4757	4112343	1971-10-20	1971-10-30	1
52950	3137	260139	1920-07-27	1920-08-03	1
39440	2340	260139	1999-06-11	1999-06-18	1
36089	2140	40481087	1972-01-03	1972-01-10	1
71733	4260	40481087	2010-02-23	2010-03-02	1
81346	4829	260139	1999-12-03	1999-12-17	1
51312	3047	40481087	1985-06-14	1985-07-05	1
31127	1845	378001	1974-04-11	1974-05-11	1
24173	1442	40481087	2011-01-18	2011-02-01	1
6085	358	40481087	2004-06-09	2004-06-23	1
59683	3540	28060	1975-11-23	1975-12-04	1
57360	3408	372328	1974-08-29	1975-06-23	1
41286	2458	40481087	1998-03-03	1998-03-10	1
56954	3382	28060	2013-05-02	2013-05-13	1
81731	4852	4112343	1995-04-23	1995-05-05	1
36967	2190	40481087	2011-01-26	2011-02-02	1
27862	1646	4112343	2018-10-06	2018-10-16	1
39757	2357	4112343	1969-10-26	1969-11-08	1
43608	2599	4109685	1979-12-19	1980-01-02	1
51691	3067	372328	1945-09-02	1945-12-04	1
88596	5274	260139	1953-09-29	1953-10-06	1
65725	3890	4112343	1990-04-19	1990-04-27	1
76835	4559	4294548	2011-05-05	2011-07-07	1
57091	3391	260139	2008-07-16	2008-07-30	1
82602	4909	4112343	2014-12-05	2014-12-14	1
58390	3462	4294548	1996-08-08	1997-02-20	1
3012	177	4116491	2016-04-12	2016-06-04	1
11826	700	4066995	1997-06-04	1997-07-05	1
53098	3147	81151	1993-12-31	1994-01-14	1
23058	1378	4218389	1945-05-16	1945-06-06	1
84645	5039	4112343	1999-08-28	1999-09-06	1
3203	187	4112343	1990-06-29	1990-07-08	1
24501	1464	439777	1965-11-30	1965-12-01	1
84338	5018	4218389	1959-08-01	1959-09-05	1
67084	3968	40480160	2003-06-13	2003-09-11	1
49302	2917	40481087	1983-08-27	1983-09-10	1
56883	3378	4146173	2019-01-10	2019-02-09	1
58297	3457	40481087	1952-03-10	1952-03-24	1
20800	1250	80180	1991-08-01	1991-08-02	1
53123	3149	40481087	1953-12-31	1954-01-21	1
65989	3906	4112343	1944-01-16	1944-01-23	1
27157	1606	30753	1988-01-18	1988-01-19	1
80201	4757	4112343	1983-12-28	1984-01-09	1
52951	3137	260139	1944-01-16	1944-01-23	1
39441	2340	4112343	1967-12-21	1967-12-29	1
36090	2140	40481087	1988-08-08	1988-08-29	1
71734	4260	28060	1940-05-02	1940-05-15	1
81347	4829	4112343	2001-10-14	2001-10-24	1
51313	3047	40481087	1985-09-09	1985-09-30	1
31128	1845	4112343	1962-01-17	1962-01-30	1
24174	1442	78272	2017-06-13	2017-06-27	1
6086	358	28060	1982-02-27	1982-03-10	1
59684	3540	4112343	1982-05-10	1982-05-18	1
57361	3408	4109685	1999-06-12	1999-07-03	1
41287	2458	40481087	2013-01-03	2013-01-24	1
56955	3382	80180	2003-08-29	2003-08-30	1
81732	4852	4112343	2003-07-24	2003-08-05	1
39591	2347	260139	2008-01-31	2008-02-07	1
27863	1646	30753	1981-03-10	1981-03-11	1
39758	2357	4116491	1997-12-25	1998-02-12	1
43609	2599	4112343	2018-12-25	2019-01-03	1
51692	3067	4112343	1955-07-12	1955-07-20	1
88597	5274	4112343	1965-07-13	1965-07-24	1
65726	3890	4112343	1995-07-04	1995-07-12	1
76836	4559	40481087	1971-01-19	1971-02-09	1
57092	3391	40481087	1983-03-16	1983-03-23	1
82603	4909	4156265	1985-12-25	1986-01-15	1
58391	3462	80180	1995-03-09	1995-03-10	1
3013	177	372328	1969-12-04	1970-11-08	1
11827	700	4112343	1979-03-13	1979-03-24	1
53099	3147	260139	2008-06-18	2008-07-02	1
23059	1378	40481087	1962-06-11	1962-06-25	1
84646	5039	4156265	1984-02-22	1984-03-14	1
3204	187	4112343	2002-12-01	2002-12-09	1
24502	1464	4027663	1993-11-23	1993-11-24	1
84339	5018	260139	1942-05-06	1942-05-13	1
67085	3968	40481087	1928-09-10	1928-09-17	1
49303	2917	40481087	1987-12-26	1988-01-02	1
56884	3378	40481087	1978-08-01	1978-08-08	1
58298	3457	40481087	1979-05-19	1979-06-09	1
20801	1250	4001336	1988-05-12	1988-06-11	1
53124	3149	40481087	1993-02-27	1993-03-06	1
65990	3906	4294548	1968-05-24	1968-06-14	1
27158	1606	257012	2006-07-29	2006-07-30	1
80202	4757	4283893	2004-01-16	2004-05-14	1
52952	3137	4112343	1921-12-27	1922-01-09	1
39442	2340	4112343	2013-03-31	2013-04-09	1
36091	2140	40481087	1989-10-28	1989-11-18	1
71735	4260	28060	1959-12-04	1959-12-11	1
81348	4829	4296204	1994-10-10	1994-11-07	1
51314	3047	78272	2008-05-16	2008-05-30	1
31129	1845	4112343	1979-02-19	1979-03-02	1
24175	1442	4112343	1966-05-02	1966-05-11	1
6087	358	381316	2012-07-31	2012-08-01	1
59685	3540	4112343	2016-05-28	2016-06-06	1
57362	3408	4112343	1992-05-20	1992-05-29	1
41288	2458	28060	1975-09-25	1975-10-08	1
56956	3382	260139	1962-05-18	1962-05-25	1
81733	4852	4299128	1969-05-15	1969-06-12	1
39592	2347	4112343	1975-03-13	1975-03-24	1
27864	1646	195588	1977-11-21	1977-12-31	1
39759	2357	40481087	1943-05-29	1943-06-12	1
43610	2599	40481087	1992-02-20	1992-02-27	1
51693	3067	4155034	2009-12-26	2010-01-09	1
88598	5274	4112343	1966-11-01	1966-11-12	1
65727	3890	40481087	1953-08-23	1953-09-13	1
76837	4559	40481087	1976-08-18	1976-08-25	1
57093	3391	40481087	1999-08-18	1999-09-08	1
82604	4909	4218389	1977-06-05	1977-07-10	1
1311	78	260139	1991-10-28	1991-11-04	1
3014	177	4112343	1983-12-27	1984-01-04	1
11828	700	4283893	1983-05-26	1983-06-30	1
53100	3147	372328	1949-10-27	1949-11-10	1
23060	1378	260139	1964-09-26	1964-10-10	1
84647	5039	4283893	1984-08-19	1984-09-09	1
3205	187	4113008	1957-04-20	1957-05-05	1
24503	1464	40481087	1986-02-18	1986-03-11	1
84340	5018	4112343	1957-12-13	1957-12-25	1
67086	3968	40481087	1948-05-02	1948-05-16	1
49304	2917	40481087	2003-12-27	2004-01-10	1
56885	3378	40481087	2010-04-23	2010-05-07	1
58299	3457	40481087	2012-03-31	2012-04-21	1
20802	1250	4112343	1954-10-15	1954-10-27	1
53125	3149	28060	1968-10-17	1968-10-30	1
65991	3906	40481087	1993-02-23	1993-03-16	1
27159	1606	260139	1990-04-09	1990-04-23	1
80203	4757	40481087	1967-02-06	1967-02-27	1
52953	3137	40481087	1914-04-28	1914-05-05	1
39443	2340	40481087	1974-10-19	1974-11-01	1
36092	2140	40481087	2006-05-03	2006-05-24	1
71736	4260	28060	1999-06-04	1999-06-11	1
81349	4829	40481087	2015-12-12	2015-12-19	1
31130	1845	40481087	1982-06-17	1982-07-08	1
24176	1442	40481087	1958-05-08	1958-05-15	1
6088	358	4112343	1996-11-13	1996-11-24	1
59686	3540	192671	2013-07-26	2013-07-27	1
57363	3408	40481087	1980-10-07	1980-10-21	1
41289	2458	260139	1982-05-23	1982-05-30	1
56957	3382	4112343	1967-06-20	1967-07-02	1
81734	4852	4310024	1989-02-23	1989-02-24	1
39593	2347	4237458	1974-03-06	1974-05-05	1
27865	1646	4112343	1956-03-12	1956-03-25	1
39760	2357	40481087	1993-08-23	1993-08-30	1
43611	2599	80180	2011-05-05	2011-05-06	1
51694	3067	40481087	1952-05-05	1952-05-19	1
88599	5274	4112343	2002-10-01	2002-10-08	1
65728	3890	40481087	1973-10-13	1973-10-20	1
76838	4559	40481087	1985-12-20	1986-01-10	1
57248	3401	80180	1997-08-02	1997-08-03	1
82605	4909	40481087	1991-09-25	1991-10-09	1
1312	78	260139	2009-04-14	2009-04-21	1
3015	177	40481087	1985-12-29	1986-01-05	1
11829	700	40481087	1998-08-29	1998-09-05	1
53101	3147	372328	1962-09-03	1963-01-21	1
23061	1378	260139	1968-01-10	1968-01-24	1
84648	5039	40481087	1992-12-02	1992-12-09	1
3206	187	4237458	2012-04-15	2012-07-14	1
24504	1464	4112343	1972-08-23	1972-09-03	1
84341	5018	4237458	1976-03-30	1976-06-28	1
68962	4086	195588	2016-11-18	2016-12-23	1
49917	2953	260139	1999-02-18	1999-02-25	1
56886	3378	40481087	2017-08-07	2017-08-14	1
58300	3457	28060	1926-10-11	1926-10-20	1
20803	1250	4283893	1959-08-27	1959-11-12	1
53126	3149	260139	2001-01-31	2001-02-14	1
65992	3906	40481087	2017-06-25	2017-07-02	1
27160	1606	260139	1999-04-16	1999-04-30	1
80204	4757	40481087	2007-01-06	2007-01-27	1
52954	3137	40481087	1931-11-11	1931-11-18	1
39444	2340	80180	1999-05-14	1999-05-15	1
39089	2325	80180	2013-04-06	2013-04-07	1
71737	4260	260139	1968-12-19	1968-12-26	1
81350	4829	372328	1973-11-13	1974-05-17	1
31131	1845	40481087	2007-04-06	2007-04-13	1
24177	1442	40481087	1986-11-07	1986-11-21	1
6089	358	28060	1988-08-16	1988-08-26	1
59687	3540	375671	2016-10-26	2016-11-25	1
57364	3408	28060	1992-08-30	1992-09-11	1
41290	2458	260139	2016-12-19	2017-01-02	1
56958	3382	4155034	1963-12-07	1963-12-28	1
81735	4852	40481087	1956-08-18	1956-08-25	1
39594	2347	4310024	2010-01-21	2010-01-22	1
27866	1646	4112343	2008-09-12	2008-09-24	1
39761	2357	28060	1977-07-30	1977-08-10	1
43612	2599	4059173	1983-01-07	1983-02-06	1
52576	3117	80180	2008-04-14	2008-04-15	1
88600	5274	4112343	2002-11-09	2002-11-19	1
65729	3890	40481087	1984-07-29	1984-08-12	1
76839	4559	40481087	2009-05-18	2009-06-08	1
57249	3401	260139	1960-07-13	1960-07-27	1
82606	4909	40481087	2008-02-14	2008-02-28	1
1313	78	372328	1967-07-04	1967-09-14	1
3016	177	80180	2000-05-31	2000-06-01	1
11830	700	40481087	2000-03-07	2000-03-14	1
53102	3147	40481087	1947-12-12	1947-12-19	1
23062	1378	261325	1999-07-20	1999-07-21	1
84649	5039	80180	2010-10-02	2010-10-03	1
3207	187	40481087	1954-10-04	1954-10-25	1
24505	1464	40481087	1998-08-10	1998-08-31	1
84342	5018	40481087	1964-01-16	1964-01-23	1
68963	4086	258780	2007-06-07	2007-06-08	1
49918	2953	4112343	2017-07-27	2017-08-03	1
56887	3378	0	2014-05-10	2014-05-11	1
58301	3457	80180	1952-08-13	1952-08-14	1
20804	1250	195588	1984-03-15	1984-04-30	1
53127	3149	4218389	1958-02-11	1958-03-04	1
65993	3906	80502	2012-10-31	2012-11-01	1
27161	1606	260139	2011-04-13	2011-04-20	1
80205	4757	81893	1993-08-11	1993-08-12	1
52955	3137	28060	1927-03-18	1927-03-27	1
39445	2340	40481087	2006-03-25	2006-04-16	1
39090	2325	260139	1981-01-06	1981-01-13	1
71738	4260	260139	1976-12-15	1976-12-22	1
81351	4829	4112343	1998-03-24	1998-04-01	1
31132	1845	257012	1978-03-17	1978-03-18	1
24178	1442	260139	1955-01-21	1955-02-04	1
6090	358	80180	1976-10-02	1976-10-03	1
59688	3540	4112343	2005-04-18	2005-04-25	1
57365	3408	78272	1998-05-04	1998-05-18	1
41291	2458	40481087	1978-01-20	1978-02-10	1
56959	3382	4218389	2005-07-11	2005-08-01	1
81736	4852	40481087	1958-01-22	1958-02-12	1
39595	2347	40481087	1990-02-07	1990-02-14	1
27867	1646	4296204	1973-03-03	1973-03-17	1
39762	2357	28060	1993-10-02	1993-10-10	1
46088	2749	28060	1974-03-17	1974-03-25	1
52577	3117	4112343	1995-05-01	1995-05-10	1
88601	5274	40481087	1979-09-18	1979-09-25	1
65730	3890	40481087	1991-12-08	1991-12-15	1
76840	4559	81151	1962-04-03	1962-05-01	1
57250	3401	40481087	1968-02-20	1968-03-05	1
82607	4909	40481087	2008-07-04	2008-07-18	1
1314	78	372328	1968-03-13	1968-06-13	1
3017	177	81151	1973-10-15	1973-11-04	1
11831	700	40481087	2000-10-17	2000-10-31	1
56132	3330	81151	2013-03-16	2013-04-20	1
23063	1378	372328	1949-09-22	1950-01-10	1
84650	5039	260139	2019-02-11	2019-02-25	1
3208	187	40481087	1962-04-07	1962-04-14	1
24506	1464	40481087	2004-09-05	2004-09-12	1
84343	5018	40481087	1992-09-25	1992-10-16	1
68964	4086	4109685	1986-06-04	1986-06-18	1
49919	2953	4230399	1988-12-10	1989-03-10	1
56888	3378	80180	1994-12-03	1994-12-04	1
58302	3457	260139	2011-04-18	2011-04-25	1
20805	1250	257012	1959-10-08	1959-10-09	1
53128	3149	40479422	1965-10-23	1965-12-29	1
65994	3906	260139	1990-06-23	1990-07-07	1
27162	1606	372328	1953-03-17	1953-06-08	1
80206	4757	195588	2008-03-15	2008-04-21	1
52956	3137	80180	1945-04-23	1945-04-24	1
39446	2340	30753	1998-01-18	1998-01-19	1
39091	2325	260139	1999-09-17	1999-10-01	1
71739	4260	378001	1974-08-10	1974-09-09	1
81352	4829	80180	2012-06-17	2012-06-18	1
31133	1845	260139	2006-02-07	2006-02-21	1
24179	1442	260139	1968-12-02	1968-12-16	1
6091	358	260139	1957-03-27	1957-04-03	1
59689	3540	4113008	2019-06-13	2019-06-14	1
57366	3408	4266809	2008-10-15	2008-10-16	1
41292	2458	40481087	2008-05-09	2008-05-23	1
56960	3382	28060	2014-07-10	2014-07-23	1
81737	4852	40481087	1975-06-22	1975-07-06	1
39596	2347	40481087	1994-04-03	1994-04-17	1
28172	1666	28060	1944-11-01	1944-11-10	1
39763	2357	80180	1973-12-26	1973-12-27	1
46089	2749	4112343	2006-02-19	2006-02-27	1
52578	3117	40481087	1993-02-08	1993-02-22	1
88602	5274	260139	1998-03-16	1998-03-30	1
65731	3890	40481087	1997-11-20	1997-12-11	1
76841	4559	257012	2011-06-09	2011-06-10	1
180	9	4112343	1982-05-01	1982-05-09	1
86307	5143	78272	1976-10-06	1976-10-27	1
1315	78	4112343	1998-02-28	1998-03-08	1
3018	177	372328	2011-12-03	2012-05-14	1
11832	700	40481087	2010-11-24	2010-12-01	1
56133	3330	372328	1975-04-30	1975-09-14	1
23064	1378	4112343	1957-03-18	1957-03-27	1
84651	5039	317576	2008-12-30	2008-12-31	1
3209	187	40481087	1986-03-21	1986-04-04	1
24507	1464	28060	2016-07-26	2016-08-04	1
84344	5018	40481087	2012-11-14	2012-12-05	1
68965	4086	4112343	2018-10-14	2018-10-24	1
49920	2953	40481087	1985-02-08	1985-02-22	1
56889	3378	260139	2000-06-12	2000-06-26	1
58303	3457	4112343	2016-09-21	2016-10-02	1
20806	1250	260139	1970-10-03	1970-10-17	1
53129	3149	40481087	1961-02-20	1961-03-13	1
65995	3906	4112343	1993-12-13	1993-12-22	1
27163	1606	372328	1956-11-19	1956-12-24	1
80207	4757	40481087	2004-11-19	2004-12-10	1
52957	3137	81151	1961-02-11	1961-02-25	1
39447	2340	260139	1963-02-12	1963-02-26	1
39092	2325	260139	2009-08-29	2009-09-12	1
71740	4260	4027663	1967-12-29	1967-12-30	1
81353	4829	260139	2007-10-07	2007-10-14	1
31134	1845	372328	1964-08-31	1964-09-23	1
24180	1442	4059173	2012-09-07	2012-12-06	1
6092	358	4112343	1955-07-17	1955-07-25	1
59690	3540	4218389	1988-02-14	1988-03-06	1
57367	3408	40481087	1970-08-08	1970-08-29	1
41293	2458	78272	2003-03-05	2003-04-02	1
56961	3382	260139	1978-11-01	1978-11-08	1
81738	4852	40481087	2003-09-11	2003-09-18	1
39597	2347	81151	1980-03-04	1980-03-18	1
28173	1666	260139	1951-05-20	1951-05-27	1
39764	2357	260139	2005-01-25	2005-02-01	1
46090	2749	40481087	1967-06-23	1967-06-30	1
52579	3117	40481087	1996-11-08	1996-11-15	1
88603	5274	260139	1999-12-18	2000-01-01	1
65732	3890	192671	1993-03-25	1993-03-26	1
76842	4559	260139	1981-11-25	1981-12-09	1
181	9	4156265	2008-06-10	2008-06-24	1
86308	5143	80180	2000-10-20	2000-10-21	1
1316	78	4112343	2003-07-14	2003-07-23	1
3019	177	381316	2009-11-08	2009-11-09	1
11833	700	28060	1991-11-20	1991-12-01	1
56134	3330	40481087	1994-08-27	1994-09-17	1
23065	1378	40481087	1997-04-29	1997-05-06	1
84652	5039	4112343	1991-03-13	1991-03-26	1
3210	187	81151	1977-03-20	1977-04-25	1
24508	1464	260139	1963-02-15	1963-02-22	1
87181	5196	260139	2002-09-12	2002-09-19	1
68966	4086	4152936	1979-11-23	1979-12-07	1
49921	2953	40481087	1999-08-31	1999-09-14	1
56890	3378	4112343	1974-07-22	1974-07-30	1
58304	3457	4134304	1986-03-31	1986-06-29	1
20807	1250	260139	1997-10-03	1997-10-17	1
53130	3149	40481087	2017-04-08	2017-04-29	1
65996	3906	40481087	1945-08-13	1945-08-27	1
27164	1606	372328	1995-05-04	1996-04-29	1
80208	4757	40481087	2015-06-20	2015-07-11	1
52958	3137	375671	1910-03-13	1910-05-12	1
39448	2340	372328	1962-11-02	1963-02-06	1
39093	2325	372328	1972-05-21	1972-10-05	1
71741	4260	4112343	1987-06-27	1987-07-06	1
81354	4829	40481087	2009-02-02	2009-02-09	1
31135	1845	4112343	1992-11-21	1992-11-29	1
24181	1442	4112343	1965-06-07	1965-06-20	1
6093	358	4112343	1960-12-27	1961-01-03	1
59691	3540	40481087	1980-01-02	1980-01-23	1
57368	3408	40481087	1977-01-03	1977-01-17	1
41294	2458	372328	1972-03-14	1972-04-30	1
56962	3382	372328	1963-02-10	1963-04-25	1
83148	4945	260139	2008-03-10	2008-03-24	1
39598	2347	317576	2002-02-25	2002-02-26	1
28174	1666	4134304	1982-06-22	1982-08-21	1
39765	2357	372328	1941-03-04	1941-04-22	1
46091	2749	40481087	2005-05-07	2005-05-14	1
52580	3117	28060	1981-08-01	1981-08-11	1
88604	5274	375671	1960-08-22	1960-10-21	1
65733	3890	260139	1962-09-29	1962-10-13	1
76843	4559	260139	2015-05-25	2015-06-01	1
182	9	40481087	1980-11-14	1980-11-21	1
86309	5143	260139	1966-10-31	1966-11-07	1
1317	78	4112343	2014-09-07	2014-09-18	1
3020	177	4112343	1969-04-28	1969-05-11	1
11834	700	80180	2014-12-27	2014-12-28	1
56135	3330	260139	2009-06-02	2009-06-09	1
23066	1378	40481087	2001-10-17	2001-10-31	1
84653	5039	4113008	1976-05-13	1976-06-03	1
3211	187	81151	1999-04-21	1999-05-26	1
24509	1464	4112343	1965-01-08	1965-01-18	1
87182	5196	260139	2017-01-08	2017-01-24	1
68967	4086	4152936	1990-03-19	1990-04-10	1
49922	2953	28060	2012-08-10	2012-08-20	1
56891	3378	4112343	1975-01-29	1975-02-11	1
58305	3457	4294548	1981-03-30	1981-05-25	1
20808	1250	260139	2002-12-02	2002-12-16	1
53131	3149	260139	1982-08-05	1982-08-12	1
65997	3906	40481087	1962-01-06	1962-01-20	1
27165	1606	4059173	1964-05-14	1964-07-13	1
80209	4757	257012	1985-03-22	1985-03-23	1
52959	3137	4112343	1948-05-09	1948-05-22	1
39449	2340	4112343	1990-06-18	1990-06-29	1
39094	2325	4230399	2007-10-06	2007-12-05	1
71742	4260	4310024	1977-07-24	1977-07-25	1
81355	4829	40481087	2016-07-21	2016-08-11	1
31136	1845	4152936	1996-04-15	1996-04-29	1
24182	1442	4112343	1965-11-20	1965-12-01	1
6094	358	40481087	1953-10-21	1953-11-11	1
59692	3540	40481087	1983-11-09	1983-11-30	1
57369	3408	40481087	1988-12-14	1989-01-04	1
41295	2458	40481087	2004-08-29	2004-09-19	1
56963	3382	4112343	1968-07-28	1968-08-07	1
83149	4945	40481087	1964-03-14	1964-04-04	1
39599	2347	4112343	2015-02-26	2015-03-11	1
28175	1666	4152936	1977-01-28	1977-02-18	1
39766	2357	4218389	1960-12-10	1960-12-31	1
46092	2749	78272	1980-08-09	1980-09-13	1
52581	3117	372328	2005-03-16	2008-02-27	1
88605	5274	4112343	1966-02-20	1966-03-05	1
65734	3890	372328	1955-07-07	1955-12-27	1
76844	4559	4059173	1945-12-14	1946-02-12	1
183	9	40481087	1987-07-09	1987-07-30	1
86310	5143	260139	1982-03-01	1982-03-15	1
1318	78	4237458	1978-09-25	1978-11-24	1
3021	177	4112343	1991-10-28	1991-11-09	1
11835	700	372328	1980-12-30	1981-05-20	1
56136	3330	4112343	2015-05-01	2015-05-12	1
25680	1528	28060	1973-01-11	1973-01-23	1
84654	5039	372328	1974-10-21	1974-12-31	1
3212	187	372328	1947-09-28	1947-12-28	1
24510	1464	4112343	1975-11-21	1975-11-30	1
87183	5196	372328	1956-02-08	1956-07-13	1
68968	4086	40481087	1979-07-02	1979-07-09	1
49923	2953	4112343	1993-12-14	1993-12-22	1
56892	3378	4112343	1988-04-06	1988-04-19	1
58306	3457	40481087	1942-06-24	1942-07-08	1
20809	1250	4294548	1988-03-15	1988-04-05	1
53132	3149	260139	1992-05-22	1992-06-05	1
67860	4014	372328	1983-10-14	1984-04-22	1
27166	1606	4112343	1986-11-12	1986-11-20	1
80210	4757	260139	2018-10-17	2018-10-24	1
52960	3137	4283893	1982-09-27	1982-11-22	1
39450	2340	4285898	1998-06-18	1998-06-19	1
39095	2325	40481087	1973-11-18	1973-11-25	1
71743	4260	40481087	1973-10-28	1973-11-18	1
81356	4829	260139	1983-09-10	1983-09-24	1
31137	1845	40481087	1992-04-23	1992-05-07	1
24183	1442	4278672	2004-12-18	2005-02-16	1
6095	358	40481087	1964-06-21	1964-06-28	1
62528	3698	80180	1992-02-09	1992-02-10	1
57370	3408	40481087	2003-12-13	2004-01-03	1
41296	2458	80180	2006-03-01	2006-03-02	1
56964	3382	4112343	1979-04-08	1979-04-16	1
83150	4945	40481087	1986-05-29	1986-06-05	1
39600	2347	4285898	2012-04-10	2012-04-11	1
28176	1666	40481087	1940-01-15	1940-02-05	1
39767	2357	4237458	2012-11-26	2013-02-24	1
46093	2749	81151	1974-04-08	1974-04-29	1
52582	3117	4112343	1979-01-04	1979-01-11	1
88606	5274	4112343	1999-01-26	1999-02-07	1
65735	3890	4283893	1968-04-03	1968-04-24	1
76845	4559	4112343	1995-09-20	1995-09-27	1
184	9	40481087	2005-04-30	2005-05-21	1
86311	5143	260139	1986-06-25	1986-07-09	1
1319	78	4112343	1967-02-07	1967-02-16	1
3022	177	4113008	2007-09-15	2007-10-06	1
11836	700	40481087	1993-01-28	1993-02-18	1
56137	3330	80180	2018-01-14	2018-01-15	1
25681	1528	372328	1960-03-04	1960-03-18	1
84655	5039	4112343	1991-05-29	1991-06-10	1
3213	187	4112343	1977-06-01	1977-06-12	1
24511	1464	4112343	2002-06-01	2002-06-09	1
87184	5196	4112343	1959-09-13	1959-09-22	1
68969	4086	40481087	1994-07-15	1994-07-29	1
49924	2953	4266809	2019-01-17	2019-01-18	1
56893	3378	4112343	2011-04-17	2011-04-28	1
58307	3457	40481087	1979-03-27	1979-04-10	1
20810	1250	40481087	1968-09-24	1968-10-08	1
53133	3149	4001336	1959-02-27	1959-03-29	1
67861	4014	372328	1993-07-04	1996-05-19	1
27167	1606	4112343	1987-09-20	1987-10-01	1
80211	4757	4027663	1984-03-21	1984-03-22	1
52961	3137	40481087	1936-02-01	1936-02-15	1
42005	2504	372328	1966-09-18	1966-11-21	1
39096	2325	40481087	1987-01-08	1987-01-29	1
71744	4260	80180	1979-11-11	1979-11-12	1
81357	4829	372328	1972-11-04	1973-02-16	1
31138	1845	40481087	1998-10-30	1998-11-13	1
24184	1442	40481087	1970-02-12	1970-02-26	1
6096	358	40481087	1965-12-25	1966-01-08	1
62529	3698	372328	1952-10-26	1953-02-10	1
59214	3516	28060	1957-09-25	1957-10-04	1
41297	2458	375671	1986-03-29	1986-05-28	1
56965	3382	4112343	1990-01-19	1990-01-31	1
83151	4945	40481087	1987-02-09	1987-03-02	1
39601	2347	40481087	1989-04-21	1989-05-05	1
28177	1666	40481087	1962-08-31	1962-09-21	1
39768	2357	40481087	1951-08-05	1951-08-26	1
46094	2749	4112343	1961-12-16	1961-12-25	1
52583	3117	4112343	1995-12-08	1995-12-18	1
88607	5274	4218389	1976-03-29	1976-04-19	1
65736	3890	40481087	1969-06-24	1969-07-01	1
76846	4559	4116491	2005-01-06	2005-02-12	1
185	9	40481087	2013-10-10	2013-10-24	1
86312	5143	260139	2006-01-01	2006-01-15	1
1320	78	4112343	1997-10-20	1997-10-28	1
3023	177	40481087	1976-05-07	1976-05-14	1
13423	793	260139	1982-03-23	1982-03-30	1
56138	3330	4027663	2007-09-29	2007-09-30	1
25682	1528	40481087	1978-07-05	1978-07-12	1
84656	5039	4237458	1994-12-17	1995-03-17	1
3214	187	4112343	1979-03-17	1979-03-26	1
24512	1464	4113008	1970-11-04	1970-11-25	1
87185	5196	40481087	1952-07-07	1952-07-14	1
68970	4086	40481087	1998-01-16	1998-02-06	1
49925	2953	40481087	1988-08-14	1988-08-21	1
56894	3378	40481087	1989-04-06	1989-04-20	1
58308	3457	40481087	1999-04-13	1999-04-20	1
20811	1250	40481087	1978-09-22	1978-10-06	1
53134	3149	4112343	2006-11-24	2006-12-07	1
67862	4014	40481087	1999-11-26	1999-12-03	1
27168	1606	4112343	1994-01-31	1994-02-10	1
80212	4757	4029498	2001-03-17	2001-03-18	1
52962	3137	40481087	1957-12-08	1957-12-29	1
42006	2504	4218389	1968-01-11	1968-02-08	1
39097	2325	40481087	1991-01-15	1991-01-22	1
71745	4260	4112343	1939-01-27	1939-02-06	1
81358	4829	4112343	2009-01-16	2009-01-27	1
33115	1967	80180	1994-02-20	1994-02-21	1
24185	1442	40481087	1997-11-23	1997-11-30	1
6097	358	40481087	1969-10-26	1969-11-09	1
62530	3698	4112343	1982-01-07	1982-01-19	1
59215	3516	255848	2017-12-31	2018-01-01	1
41298	2458	4112343	1972-09-11	1972-09-21	1
56966	3382	4113008	2018-06-24	2018-07-08	1
83152	4945	40481087	1991-04-07	1991-04-14	1
39602	2347	80180	2012-09-07	2012-09-08	1
28178	1666	40481087	1967-08-31	1967-09-14	1
39769	2357	40481087	1956-05-06	1956-05-20	1
46095	2749	4112343	1968-12-22	1969-01-01	1
52584	3117	4266809	2008-04-14	2008-04-15	1
88608	5274	4278672	2006-06-16	2006-09-14	1
65737	3890	40481087	1990-02-20	1990-03-13	1
76847	4559	81151	1985-03-06	1985-03-27	1
186	9	28060	1996-02-09	1996-02-17	1
86313	5143	40481087	1964-12-13	1964-12-27	1
1321	78	4112343	2003-08-23	2003-09-01	1
3024	177	40481087	2012-11-04	2012-11-11	1
13424	793	260139	1983-11-04	1983-11-11	1
56139	3330	4310024	2016-01-25	2016-01-26	1
25683	1528	40481087	2004-03-14	2004-03-28	1
84657	5039	40481087	1981-08-22	1981-08-29	1
3215	187	40481087	1953-02-18	1953-03-04	1
24513	1464	4134304	1965-09-01	1965-11-30	1
87186	5196	40481087	1976-07-13	1976-07-27	1
68971	4086	40481087	2010-12-07	2010-12-21	1
49926	2953	28060	1993-11-02	1993-11-11	1
56895	3378	40481087	2003-11-10	2003-11-17	1
1631	96	381316	1989-09-16	1989-09-17	1
20812	1250	40481087	2006-06-03	2006-06-24	1
53135	3149	4112343	2009-02-25	2009-03-06	1
67863	4014	4059173	2018-10-29	2018-12-28	1
27169	1606	4112343	2014-03-01	2014-03-13	1
80213	4757	4112343	1971-07-09	1971-07-18	1
58230	3454	260139	1995-10-02	1995-10-09	1
42007	2504	40481087	1954-10-26	1954-11-09	1
39098	2325	40481087	1994-10-11	1994-10-18	1
71746	4260	40481087	1975-08-17	1975-09-07	1
81359	4829	4112343	2019-04-07	2019-04-19	1
33116	1967	192671	1994-05-17	1994-05-18	1
25921	1540	80180	1994-03-11	1994-03-12	1
6098	358	28060	2009-03-23	2009-04-03	1
62531	3698	40481087	1968-08-24	1968-09-14	1
59216	3516	260139	1949-01-07	1949-01-21	1
41299	2458	4112343	1985-03-20	1985-04-01	1
56967	3382	40481087	1973-05-23	1973-06-06	1
83153	4945	40481087	1995-07-10	1995-07-17	1
39603	2347	195588	2015-11-21	2016-01-09	1
28179	1666	40481087	1994-05-17	1994-05-31	1
39770	2357	80502	2009-02-24	2009-02-25	1
46096	2749	4112343	1972-08-14	1972-08-23	1
52585	3117	4027663	2000-07-25	2000-07-26	1
88609	5274	40481087	1988-02-19	1988-03-11	1
65738	3890	40481087	2012-03-03	2012-03-10	1
76848	4559	260139	1990-03-09	1990-03-23	1
187	9	4051466	1982-07-26	1997-11-11	1
86314	5143	40481087	1971-12-09	1971-12-16	1
1322	78	40481087	1991-10-05	1991-10-12	1
3025	177	28060	1969-03-13	1969-03-24	1
13425	793	260139	1988-01-30	1988-02-13	1
54915	3253	4296205	2018-08-05	2018-08-19	1
25684	1528	80180	2001-11-14	2001-11-15	1
84658	5039	40481087	2008-12-23	2008-12-30	1
3216	187	40481087	1966-09-26	1966-10-03	1
24514	1464	4155034	2017-06-21	2017-07-05	1
87187	5196	40481087	1996-08-06	1996-08-13	1
68972	4086	260139	2016-11-12	2016-11-19	1
49927	2953	80180	2019-01-17	2019-01-18	1
59848	3550	28060	2019-05-20	2019-05-29	1
1632	96	4112343	1927-08-26	1927-09-03	1
20813	1250	260139	1963-11-18	1963-11-25	1
53136	3149	4132546	1959-02-27	1959-02-28	1
67864	4014	4112343	1975-02-18	1975-03-02	1
27170	1606	40481087	1985-05-24	1985-06-07	1
80214	4757	4112343	1991-05-03	1991-05-15	1
58231	3454	378001	1994-04-08	1994-05-08	1
42008	2504	40481087	2015-10-28	2015-11-04	1
39099	2325	28060	2018-10-30	2018-11-08	1
71747	4260	40481087	2003-05-05	2003-05-26	1
81360	4829	40481087	1973-06-11	1973-07-02	1
33117	1967	372328	1960-11-15	1961-09-28	1
25922	1540	260139	1966-06-18	1966-07-02	1
6099	358	81893	1975-06-10	1975-06-11	1
62532	3698	28060	1963-12-07	1963-12-17	1
59217	3516	439777	1964-07-21	1964-07-22	1
41300	2458	40481087	2002-06-26	2002-07-03	1
57094	3392	40481087	1996-08-12	1996-09-02	1
83154	4945	40481087	1997-02-14	1997-02-21	1
39604	2347	260139	2006-08-01	2006-08-08	1
28180	1666	80180	1976-11-14	1976-11-15	1
39771	2357	260139	1973-05-02	1973-05-09	1
46097	2749	40481087	1978-09-07	1978-09-21	1
52586	3117	4116491	1997-07-26	1997-08-30	1
88610	5274	80180	1989-11-13	1989-11-14	1
65739	3890	80180	1993-01-28	1993-01-29	1
76849	4559	372328	1956-12-04	1957-11-05	1
188	9	78272	1990-09-15	1990-09-29	1
86315	5143	40481087	1996-07-01	1996-07-08	1
1323	78	40481087	2002-02-24	2002-03-03	1
3026	177	40479422	2002-05-07	2002-07-13	1
13426	793	375671	1984-10-07	1984-11-06	1
54916	3253	40481087	1983-11-27	1983-12-04	1
25685	1528	260139	1970-05-12	1970-05-26	1
84659	5039	260139	1979-12-25	1980-01-01	1
3217	187	40481087	1967-12-03	1967-12-24	1
24515	1464	40481087	1982-08-08	1982-08-29	1
87188	5196	378001	1961-11-08	1962-01-07	1
68973	4086	260139	2019-02-09	2019-02-16	1
49928	2953	372328	2019-03-28	2019-03-29	1
59849	3550	78272	1985-07-16	1985-07-30	1
1633	96	4112343	1947-09-22	1947-10-03	1
20814	1250	4112343	1958-12-08	1958-12-20	1
53137	3149	40481087	1984-01-18	1984-02-08	1
67865	4014	4112343	2006-08-29	2006-09-11	1
27171	1606	40481087	1997-06-13	1997-07-04	1
80215	4757	4112343	1996-07-21	1996-08-01	1
58232	3454	40481087	1998-02-13	1998-02-27	1
42009	2504	260139	2006-04-02	2006-04-16	1
39100	2325	260139	1983-07-04	1983-07-11	1
73169	4353	80180	2008-01-09	2008-01-10	1
82149	4878	28060	1963-11-02	1963-11-09	1
33118	1967	4084167	1960-07-18	1960-07-18	1
25923	1540	260139	2004-12-08	2004-12-15	1
6100	358	378001	1964-08-16	1964-10-15	1
62533	3698	28060	1966-09-03	1966-09-15	1
59218	3516	440448	1950-07-26	1950-07-27	1
42534	2540	81151	1985-05-31	1985-07-05	1
57095	3392	4112343	1979-11-04	1979-11-17	1
83155	4945	260139	1982-05-03	1982-05-17	1
39605	2347	378001	1984-06-25	1984-08-24	1
28181	1666	81151	1991-09-03	1991-09-24	1
39772	2357	4112343	1953-01-16	1953-01-23	1
46098	2749	40481087	2018-01-13	2018-01-27	1
52587	3117	4156265	2015-03-24	2015-04-07	1
88611	5274	81151	1981-03-24	1981-04-28	1
76850	4559	4296205	1966-11-06	1966-12-11	1
189	9	260139	1985-06-15	1985-06-29	1
86316	5143	378001	2010-12-17	2011-01-16	1
1324	78	80180	2003-02-15	2003-02-16	1
3027	177	40481087	1991-11-12	1991-11-19	1
13427	793	40481087	1975-01-24	1975-02-14	1
54917	3253	40481087	1996-10-18	1996-10-25	1
25686	1528	4218389	2012-03-13	2012-04-10	1
84660	5039	372328	1977-01-19	1977-06-28	1
3218	187	40481087	1987-09-06	1987-09-27	1
24516	1464	40481087	2005-10-13	2005-10-27	1
87189	5196	4112343	2006-01-21	2006-02-01	1
68974	4086	4134304	2006-06-20	2006-09-18	1
49929	2953	4027663	2009-11-05	2009-11-06	1
59850	3550	81151	1994-10-11	1994-11-08	1
1634	96	4112343	1985-08-26	1985-09-05	1
20815	1250	4237458	1955-03-13	1955-06-11	1
55420	3287	0	1967-07-10	1967-07-11	1
67866	4014	40481087	1985-08-25	1985-09-01	1
27172	1606	40481087	2002-11-04	2002-11-25	1
80216	4757	4266809	1994-10-05	1994-10-06	1
58233	3454	40481087	2010-10-31	2010-11-14	1
42010	2504	40481087	2003-12-02	2003-12-09	1
39101	2325	4112343	1999-01-03	1999-01-12	1
73170	4353	4134304	1980-08-30	1980-09-29	1
82150	4878	378001	1973-08-06	1973-09-05	1
33119	1967	4112343	2019-04-26	2019-05-03	1
25924	1540	372328	1964-07-26	1964-10-19	1
6101	358	4027663	1967-12-19	1967-12-20	1
62534	3698	260139	1996-03-16	1996-03-23	1
59219	3516	4112343	1999-10-20	1999-10-28	1
42535	2540	260139	1971-08-23	1971-09-06	1
57096	3392	4112343	2005-09-19	2005-09-28	1
83156	4945	260139	1992-11-22	1992-12-06	1
39606	2347	4112343	1974-06-06	1974-06-15	1
28182	1666	260139	1971-02-10	1971-02-24	1
39773	2357	4112343	1967-06-28	1967-07-05	1
46099	2749	260139	1966-09-19	1966-09-26	1
52588	3117	4218389	2018-09-18	2018-10-09	1
88612	5274	375671	2013-07-09	2013-09-07	1
76851	4559	40481087	1952-10-14	1952-10-28	1
190	9	4109685	2003-02-23	2003-03-09	1
86317	5143	40481087	1986-05-11	1986-05-18	1
1325	78	28060	1985-05-13	1985-05-23	1
3481	199	28060	1993-08-14	1993-08-24	1
13428	793	40481087	2009-10-24	2009-11-14	1
54918	3253	40481087	1987-01-23	1987-01-30	1
25687	1528	4278672	2007-02-24	2007-05-25	1
84661	5039	4112343	1979-12-27	1980-01-06	1
4839	286	260139	1928-08-05	1928-08-19	1
24856	1486	0	2001-12-23	2001-12-24	1
87190	5196	40481087	2015-05-27	2015-06-03	1
68975	4086	78272	1987-05-14	1987-06-04	1
49930	2953	4059173	1984-11-01	1984-12-31	1
59851	3550	260139	1991-07-17	1991-07-24	1
1635	96	40481087	1933-11-16	1933-12-07	1
20816	1250	4283893	1994-01-09	1994-02-27	1
55421	3287	80180	1980-04-17	1980-04-18	1
67867	4014	40481087	1993-11-27	1993-12-18	1
27173	1606	40481087	2008-12-26	2009-01-02	1
80217	4757	4294548	1985-02-22	1985-05-17	1
58234	3454	40481087	2014-09-19	2014-10-10	1
42011	2504	80180	1989-12-31	1990-01-01	1
39102	2325	4112343	1999-12-09	1999-12-22	1
73171	4353	4142905	1992-01-30	1992-03-30	1
82151	4878	440448	2011-12-25	2011-12-26	1
33120	1967	40481087	1965-08-20	1965-08-27	1
25925	1540	40481087	1964-01-04	1964-01-11	1
6102	358	4112343	1978-03-08	1978-03-16	1
59220	3516	4230399	1981-12-12	1982-02-10	1
42536	2540	260139	1991-11-30	1991-12-07	1
57097	3392	4116491	1996-12-23	1997-01-28	1
83157	4945	40481087	1973-12-10	1973-12-31	1
39607	2347	4266809	2012-09-07	2012-09-08	1
28183	1666	260139	2018-05-04	2018-05-18	1
39774	2357	4296205	1952-07-04	1952-07-25	1
46100	2749	260139	2014-03-29	2014-04-05	1
52589	3117	40481087	2005-09-26	2005-10-03	1
88613	5274	4112343	1954-11-26	1954-12-06	1
76852	4559	40481087	1983-08-12	1983-08-26	1
191	9	4112343	2000-05-28	2000-06-06	1
86318	5143	40481087	2001-07-05	2001-07-19	1
1326	78	372328	1967-11-13	1967-12-14	1
3482	199	260139	1951-01-12	1951-01-19	1
13429	793	260139	1993-08-10	1993-08-17	1
54919	3253	40481087	2013-08-04	2013-08-18	1
25688	1528	40481087	1977-07-10	1977-07-31	1
85345	5081	28060	1974-04-27	1974-05-08	1
4840	286	372328	1929-01-30	1929-04-27	1
24857	1486	81893	1989-08-25	1989-08-26	1
87191	5196	28060	1952-10-27	1952-11-06	1
68976	4086	260139	1979-02-28	1979-03-07	1
49931	2953	4112343	1988-05-17	1988-05-28	1
59852	3550	260139	1995-10-03	1995-10-10	1
1636	96	260139	1944-09-01	1944-09-15	1
20817	1250	4296204	1985-05-09	1985-05-23	1
55422	3287	372328	1946-04-01	1946-06-17	1
67868	4014	40481087	2008-12-22	2009-01-12	1
27174	1606	28060	1958-06-12	1958-06-25	1
80218	4757	40481087	1980-01-08	1980-01-15	1
58235	3454	372328	1983-04-06	1983-06-13	1
42012	2504	260139	1970-12-28	1971-01-04	1
39103	2325	40481087	1980-12-26	1981-01-02	1
73172	4353	40481087	2004-09-26	2004-10-17	1
82152	4878	4051466	1965-01-11	1985-02-16	1
33121	1967	40481087	1974-12-16	1974-12-30	1
25926	1540	40481087	1987-06-09	1987-06-16	1
6103	358	4112343	1982-10-08	1982-10-15	1
62535	3698	260139	2009-06-24	2009-07-08	1
42537	2540	4218389	1942-08-23	1942-09-13	1
57098	3392	40481087	1976-02-16	1976-02-23	1
83158	4945	40481087	1988-01-01	1988-01-15	1
39608	2347	30753	2011-11-12	2011-11-13	1
28184	1666	4218389	1940-02-07	1940-02-28	1
39775	2357	40480160	2012-11-26	2013-02-24	1
46101	2749	372328	1961-05-16	1961-05-30	1
52590	3117	192671	2008-05-11	2008-05-12	1
88614	5274	4112343	2002-03-26	2002-04-03	1
76853	4559	40481087	1991-10-19	1991-10-26	1
192	9	4112343	2003-10-23	2003-11-04	1
86319	5143	40481087	2008-08-20	2008-09-03	1
1327	78	4156265	1968-11-25	1968-12-16	1
3483	199	260139	1954-01-27	1954-02-10	1
13430	793	192671	2010-06-18	2010-06-19	1
54920	3253	40486433	1972-05-25	1972-05-26	1
25689	1528	40481087	1993-06-25	1993-07-09	1
85346	5081	78272	1975-01-30	1975-02-20	1
4841	286	4112343	1969-03-18	1969-03-30	1
24858	1486	260139	2001-03-11	2001-03-18	1
87192	5196	78272	1989-01-15	1989-02-12	1
68977	4086	378001	1976-04-12	1976-05-13	1
59853	3550	40481087	1990-01-26	1990-02-09	1
1637	96	260139	1962-05-22	1962-05-29	1
20818	1250	40481087	1967-03-11	1967-03-25	1
55423	3287	372328	1949-02-01	1949-06-20	1
67869	4014	80180	2006-10-02	2006-10-03	1
27175	1606	78272	1977-08-04	1977-08-18	1
81421	4835	257012	1998-04-02	1998-04-03	1
58236	3454	372328	1986-09-02	1987-02-09	1
42013	2504	378001	2010-12-08	2011-02-06	1
39104	2325	40481087	2014-09-17	2014-10-08	1
73173	4353	28060	1990-05-20	1990-05-28	1
82153	4878	4112343	1968-11-14	1968-11-22	1
33122	1967	40481087	1975-06-05	1975-06-12	1
25927	1540	40481087	2013-11-02	2013-11-23	1
6658	394	260139	1962-11-14	1962-11-21	1
62536	3698	4112343	1954-08-18	1954-08-25	1
42538	2540	4296204	1997-11-20	1997-12-11	1
57099	3392	260139	1968-04-25	1968-05-09	1
83159	4945	40481087	2005-03-18	2005-04-08	1
39609	2347	260139	1982-03-25	1982-04-08	1
28185	1666	40481087	2002-05-28	2002-06-18	1
39776	2357	40481087	1952-03-31	1952-04-21	1
46102	2749	378001	2004-11-27	2005-01-26	1
52591	3117	260139	1985-10-28	1985-11-04	1
88615	5274	4142905	1956-12-11	1957-02-09	1
76854	4559	40481087	2011-10-14	2011-10-28	1
193	9	4152936	2011-01-10	2011-01-31	1
86320	5143	260139	1968-04-20	1968-05-04	1
1328	78	40481087	2004-03-27	2004-04-03	1
3484	199	4112343	1947-12-01	1947-12-09	1
13431	793	260139	1992-07-02	1992-07-09	1
54921	3253	80180	2005-12-31	2006-01-01	1
25690	1528	40481087	2013-06-14	2013-07-05	1
85347	5081	81151	1951-05-01	1951-05-15	1
4842	286	4112343	1994-09-25	1994-10-08	1
24859	1486	260139	2007-06-16	2007-06-23	1
87193	5196	260139	1958-12-26	1959-01-02	1
68978	4086	40481087	1993-05-31	1993-06-14	1
59854	3550	4112343	1992-07-23	1992-07-31	1
1638	96	261325	1951-05-26	1951-05-27	1
20819	1250	40481087	1982-05-23	1982-06-06	1
55424	3287	4112343	1997-11-17	1997-11-30	1
67870	4014	260139	1976-09-11	1976-09-18	1
27176	1606	81151	1962-04-04	1962-04-25	1
81422	4835	260139	2004-06-02	2004-06-09	1
58237	3454	4112343	2015-08-17	2015-08-24	1
42014	2504	439777	1981-10-19	1981-10-20	1
39105	2325	195588	2014-10-18	2014-11-29	1
73174	4353	372328	1967-04-04	1967-07-16	1
82154	4878	4152936	1970-12-06	1970-12-20	1
33123	1967	4035415	2006-09-18	2006-10-18	1
25928	1540	192671	1994-05-06	1994-05-07	1
6659	394	4112343	1967-09-27	1967-10-05	1
62537	3698	4112343	1975-11-28	1975-12-06	1
42539	2540	4310024	1973-01-12	1973-01-13	1
57100	3392	372328	1969-04-19	1969-05-10	1
83160	4945	80180	1989-03-06	1989-03-07	1
39610	2347	4027663	2001-11-24	2001-11-25	1
28186	1666	81151	2015-08-19	2015-09-09	1
39777	2357	40481087	1981-07-17	1981-08-07	1
46103	2749	4112343	1999-08-14	1999-08-23	1
52592	3117	375671	1999-11-13	1999-12-13	1
88616	5274	40481087	2016-12-06	2016-12-13	1
76855	4559	28060	1956-11-18	1956-11-28	1
194	9	40481087	1985-07-06	1985-07-13	1
86321	5143	440086	1972-12-06	1974-01-30	1
2796	162	80180	1972-04-07	1972-04-08	1
3485	199	4112343	1957-07-11	1957-07-24	1
13432	793	260139	2017-11-18	2017-11-25	1
54922	3253	4112343	1987-03-23	1987-03-31	1
25691	1528	81151	2009-05-14	2009-05-28	1
85348	5081	257012	1960-07-23	1960-07-24	1
4843	286	4112343	1997-05-28	1997-06-04	1
24860	1486	372328	1960-01-15	1961-04-30	2
87194	5196	260139	1995-05-16	1995-05-23	1
68979	4086	40481087	2014-04-13	2014-04-27	1
59855	3550	4296205	2005-08-12	2005-09-09	1
1639	96	4237458	1931-07-24	1931-08-23	1
20820	1250	40481087	1993-02-13	1993-03-06	1
55425	3287	40481087	1974-09-20	1974-10-11	1
67871	4014	378001	1984-07-29	1984-09-27	1
27177	1606	260139	1985-01-29	1985-02-05	1
81423	4835	4112343	1996-12-04	1996-12-16	1
58238	3454	4296205	2019-03-12	2019-04-16	1
42015	2504	4230399	1963-08-05	1963-10-04	1
39106	2325	260139	2012-11-25	2012-12-09	1
73175	4353	440086	1976-08-04	1981-05-27	1
82155	4878	40481087	1971-08-26	1971-09-09	1
33124	1967	4112343	1958-07-01	1958-07-10	1
25929	1540	4027663	1987-07-21	1987-07-22	1
6660	394	4134304	1922-03-21	1922-06-19	1
62538	3698	40481087	1954-03-26	1954-04-02	1
42540	2540	40481087	1964-06-15	1964-06-22	1
57101	3392	372328	1974-11-10	1974-11-24	1
83161	4945	378001	1969-08-08	1969-09-07	1
39611	2347	4156265	2001-11-23	2001-12-14	1
28187	1666	81151	2018-08-24	2018-09-28	1
39778	2357	40481087	1985-01-24	1985-01-31	1
46104	2749	4156265	1983-05-31	1983-06-21	1
52593	3117	4294548	2004-11-24	2004-12-22	1
114	5	260139	2012-10-16	2012-10-23	1
76856	4559	80502	2015-07-28	2015-07-29	1
195	9	40481087	1996-04-18	1996-05-09	1
86322	5143	4112343	1995-09-28	1995-10-07	1
2797	162	260139	2001-06-25	2001-07-02	1
3486	199	4112343	1958-02-20	1958-03-03	1
13433	793	4112343	1980-03-06	1980-03-15	1
54923	3253	4112343	2004-02-16	2004-02-25	1
25692	1528	260139	1971-03-31	1971-04-07	1
85349	5081	260139	1989-08-12	1989-08-19	1
4844	286	4113008	2013-07-09	2013-07-23	1
24861	1486	4112343	1958-12-25	1959-01-01	1
87195	5196	4218389	1993-08-20	1993-09-17	1
68980	4086	80180	2016-08-31	2016-09-01	1
59856	3550	40481087	1993-03-02	1993-03-16	1
1640	96	78272	1996-10-01	1996-10-15	1
20821	1250	81151	1981-03-26	1981-04-30	1
55426	3287	192671	1980-07-02	1980-07-03	1
67872	4014	40481087	1971-05-07	1971-05-14	1
27178	1606	4112343	1957-08-24	1957-09-01	1
81424	4835	4230399	1974-03-10	1974-04-09	1
58239	3454	40481087	2013-07-28	2013-08-18	1
42016	2504	40481087	2002-02-22	2002-03-08	1
39107	2325	260139	2019-06-19	2019-06-20	1
73176	4353	40481087	1982-01-20	1982-01-27	1
82156	4878	40481087	1984-04-10	1984-05-01	1
33125	1967	4112343	1993-04-22	1993-05-03	1
25930	1540	4112343	1966-07-31	1966-08-11	1
6661	394	4294548	1981-04-06	1981-05-04	1
62539	3698	40481087	1971-02-10	1971-03-03	1
42541	2540	81151	1962-08-04	1962-08-25	1
57102	3392	4112343	1973-08-28	1973-09-05	1
83162	4945	4116491	1985-04-21	1985-05-28	1
39612	2347	40481087	1984-04-21	1984-05-12	1
28188	1666	4112343	1941-07-04	1941-07-16	1
39779	2357	28060	1951-01-14	1951-01-24	1
46105	2749	80180	1994-04-08	1994-04-09	1
487	30	133834	1971-01-19	1988-03-21	1
115	5	260139	2015-08-10	2015-08-17	1
76857	4559	195588	2001-12-05	2002-01-07	1
196	9	40481087	2016-07-19	2016-08-02	1
86323	5143	40481087	1969-02-10	1969-02-17	1
2798	162	260139	2013-12-31	2014-01-07	1
3487	199	4112343	2009-11-10	2009-11-22	1
13434	793	4112343	1980-04-15	1980-04-23	1
54924	3253	4112343	2005-09-19	2005-09-29	1
25693	1528	4112343	1964-09-12	1964-09-22	1
85350	5081	321042	1935-05-17	1935-05-18	1
4845	286	4283893	1936-08-13	1936-10-22	1
24862	1486	4112343	2018-07-18	2018-07-31	1
87196	5196	4294548	2014-01-03	2014-01-24	1
68981	4086	260139	1991-10-02	1991-10-16	1
59857	3550	80180	2016-11-05	2016-11-06	1
1641	96	80180	1963-04-02	1963-04-03	1
20822	1250	260139	1961-06-11	1961-06-18	1
55427	3287	260139	2009-07-31	2009-08-07	1
67873	4014	40481087	1976-07-21	1976-08-04	1
27179	1606	4266809	1989-05-12	1989-05-13	1
81425	4835	4294548	1998-01-22	1998-04-24	1
58240	3454	372328	1983-09-11	1983-11-14	1
42017	2504	40481087	2003-04-09	2003-04-30	1
39108	2325	4112343	2004-07-31	2004-08-11	1
73177	4353	40481087	1992-03-14	1992-03-28	1
82157	4878	40481087	1993-01-18	1993-02-01	1
33126	1967	4142905	1956-09-07	1956-11-06	1
25931	1540	4283893	1962-07-12	1962-10-04	1
6662	394	40481087	1926-11-03	1926-11-24	1
62540	3698	40481087	2007-12-03	2007-12-10	1
42542	2540	81893	1973-11-08	1973-11-09	1
57103	3392	4112343	1987-03-14	1987-03-24	1
83163	4945	40481087	1995-01-28	1995-02-04	1
41652	2481	4112343	1990-08-02	1990-08-14	1
28189	1666	4112343	1949-02-18	1949-03-01	1
39780	2357	81151	1999-07-10	1999-08-07	1
46106	2749	81151	1978-09-05	1978-09-19	1
488	30	260139	1998-04-21	1998-05-05	1
116	5	378001	1971-08-08	1971-09-07	1
76858	4559	260139	1950-09-21	1950-10-05	1
197	9	40486433	1983-07-26	1997-07-24	1
86324	5143	40481087	1982-12-23	1982-12-30	1
2799	162	372328	1978-03-14	1978-11-28	1
3488	199	40481087	1945-02-18	1945-03-11	1
13435	793	40481087	1974-08-06	1974-08-20	1
54925	3253	40481087	1976-05-17	1976-05-31	1
25694	1528	4112343	1980-08-18	1980-08-28	1
85351	5081	4112343	1928-10-04	1928-10-14	1
4846	286	40481087	1964-08-18	1964-08-25	1
24863	1486	40481087	1973-04-22	1973-05-13	1
87197	5196	40481087	1988-07-29	1988-08-19	1
68982	4086	4112343	2017-06-10	2017-06-17	1
59858	3550	81893	2016-02-09	2016-02-10	1
1642	96	260139	1935-03-06	1935-03-13	1
20823	1250	4112343	1986-01-31	1986-02-11	1
55428	3287	321042	1967-07-10	1967-07-11	1
67874	4014	134438	1997-11-25	1999-02-20	1
27180	1606	40481087	1975-10-31	1975-11-07	1
81426	4835	40481087	2001-02-14	2001-03-07	1
58241	3454	372328	1984-07-11	1984-08-13	1
42018	2504	78272	1968-12-04	1968-12-18	1
39109	2325	4116491	2017-11-28	2018-01-17	1
73178	4353	260139	1991-11-26	1991-12-03	1
82158	4878	0	2011-12-25	2011-12-26	1
33127	1967	40481087	1959-06-01	1959-06-15	1
25932	1540	40481087	1990-02-06	1990-02-27	1
6663	394	40481087	1956-01-27	1956-02-10	1
62541	3698	260139	1952-10-28	1952-11-11	1
42543	2540	192671	1975-01-29	1975-01-30	1
57104	3392	4112343	2006-09-26	2006-10-05	1
83164	4945	28060	1994-11-08	1994-11-18	1
41653	2481	40481087	1990-02-07	1990-02-28	1
28190	1666	4156265	1953-01-20	1953-02-03	1
39781	2357	260139	1953-07-31	1953-08-14	1
46107	2749	260139	1991-03-21	1991-03-28	1
489	30	260139	2018-04-23	2018-04-30	1
117	5	4059173	2012-10-08	2012-12-07	1
76859	4559	372328	1950-11-18	1951-10-02	1
198	9	28060	1987-08-13	1987-08-24	1
86325	5143	40481087	1996-11-13	1996-11-27	1
2800	162	4112343	1980-07-26	1980-08-03	1
3489	199	40481087	1945-07-14	1945-07-21	1
13436	793	40481087	1977-03-11	1977-03-18	1
54926	3253	440086	1981-05-16	1988-05-24	1
25695	1528	4112343	1989-12-13	1989-12-21	1
85352	5081	4152936	1986-09-04	1986-09-25	1
4847	286	40481087	1968-09-09	1968-09-30	1
24864	1486	40481087	1975-10-22	1975-11-12	1
87198	5196	40481087	2007-09-22	2007-09-29	1
68983	4086	4155034	1994-08-31	1994-09-21	1
59859	3550	372328	1986-05-12	1986-06-28	1
1643	96	260139	1940-05-16	1940-05-30	1
20824	1250	4112343	1996-05-22	1996-05-30	1
55429	3287	4112343	1971-12-20	1972-01-01	1
67875	4014	260139	1977-02-27	1977-03-13	1
27181	1606	40481087	1991-06-03	1991-06-10	1
81427	4835	375671	2007-07-15	2007-09-13	1
58242	3454	4027663	2008-02-29	2008-03-01	1
42019	2504	4112343	1957-12-06	1957-12-13	1
39110	2325	4142905	1976-07-29	1976-08-28	1
73179	4353	40481087	2002-08-12	2002-09-02	1
82159	4878	78272	1969-10-21	1969-11-11	1
33128	1967	28060	1971-06-03	1971-06-15	1
25933	1540	40481087	2009-05-27	2009-06-17	1
6664	394	40481087	1993-08-30	1993-09-06	1
62542	3698	260139	2000-02-03	2000-02-10	1
42544	2540	372328	1969-02-02	1971-02-23	1
57105	3392	4112343	2016-06-27	2016-07-10	1
83165	4945	4112343	1992-04-11	1992-04-19	1
41654	2481	40481087	2007-12-21	2008-01-11	1
28191	1666	40481087	1958-02-05	1958-02-19	1
39782	2357	372328	1941-10-19	1942-04-21	1
46108	2749	4156265	2007-10-13	2007-10-27	1
490	30	372328	1972-04-06	1972-07-22	1
118	5	4112343	1977-06-08	1977-06-18	1
76860	4559	372328	1965-01-27	1967-12-19	1
199	9	80180	2014-08-05	2014-08-06	1
86326	5143	81151	1979-09-12	1979-10-10	1
2801	162	4112343	2016-09-25	2016-10-05	1
3490	199	40481087	1996-03-13	1996-04-03	1
13437	793	80180	2010-05-14	2010-05-15	1
54927	3253	4051466	1974-05-25	1989-09-05	1
25696	1528	4112343	2009-04-13	2009-04-26	1
85353	5081	4230399	2004-11-19	2004-12-19	1
4848	286	28060	1934-02-04	1934-02-17	1
24865	1486	321042	2001-12-23	2001-12-24	1
87199	5196	28060	1958-01-11	1958-01-19	1
68984	4086	4296205	1991-02-03	1991-02-17	1
59860	3550	4112343	1993-05-01	1993-05-08	1
1644	96	317576	1984-02-18	1984-02-19	1
20825	1250	4218389	1987-05-13	1987-06-17	1
55430	3287	4116491	1988-06-29	1988-08-17	1
67876	4014	372328	1968-02-24	1968-05-05	1
27182	1606	28060	1958-04-01	1958-04-11	1
81428	4835	4027663	2000-04-22	2000-04-23	1
58243	3454	80180	2016-10-19	2016-10-20	1
42020	2504	4112343	1971-05-06	1971-05-14	1
39111	2325	4218389	1996-05-15	1996-06-05	1
73180	4353	4112343	1968-05-31	1968-06-11	1
82160	4878	4109685	1964-01-30	1964-02-20	1
33129	1967	78272	1983-11-29	1983-12-27	1
25934	1540	81893	1992-12-16	1992-12-17	1
6665	394	260139	1997-01-28	1997-02-04	1
62543	3698	375671	2006-01-14	2006-03-15	1
42545	2540	4027663	1966-12-15	1966-12-16	1
57106	3392	40481087	1974-01-28	1974-02-18	1
83166	4945	4112343	2010-08-28	2010-09-08	1
41655	2481	4112343	1996-10-12	1996-10-23	1
28192	1666	28060	1994-06-07	1994-06-17	1
39783	2357	4116491	1995-11-15	1995-12-26	1
46109	2749	4278672	1966-08-18	1966-11-16	1
491	30	372328	1974-11-09	1975-07-26	1
119	5	4112343	1983-08-04	1983-08-12	1
76861	4559	4112343	1985-12-28	1986-01-06	1
200	9	372328	1982-04-30	1982-06-24	1
86327	5143	260139	1967-03-09	1967-03-23	1
2802	162	80502	2009-10-20	2009-10-21	1
3491	199	80180	1983-04-07	1983-04-08	1
13438	793	260139	2003-02-27	2003-03-06	1
54928	3253	4112343	1984-12-17	1984-12-29	1
25697	1528	40481087	1991-03-14	1991-04-04	1
85354	5081	40481087	1940-06-24	1940-07-15	1
4849	286	260139	1982-03-16	1982-03-30	1
24866	1486	4027663	1982-07-03	1982-07-04	1
87200	5196	80180	1993-04-09	1993-04-10	1
68985	4086	40481087	2015-11-23	2015-12-14	1
59861	3550	4112343	2018-05-14	2018-05-22	1
1645	96	372328	1942-12-23	1943-05-01	1
28078	1659	260139	1971-06-07	1971-06-14	1
55431	3287	4283893	1963-05-12	1963-09-22	1
67877	4014	4112343	1976-05-29	1976-06-05	1
27183	1606	80180	1989-05-12	1989-05-13	1
81429	4835	4112343	1971-01-26	1971-02-02	1
58244	3454	260139	1998-02-27	1998-03-13	1
42021	2504	4112343	1997-06-27	1997-07-07	1
39112	2325	40481087	2002-04-15	2002-04-29	1
73181	4353	40479768	1972-11-03	1972-12-10	1
82161	4878	4294548	1991-06-06	1991-06-20	1
33130	1967	78272	1985-10-17	1985-11-07	1
25935	1540	257012	1962-08-09	1962-08-10	1
6666	394	4112343	1922-12-20	1922-12-31	1
62544	3698	40481087	1996-10-04	1996-10-25	1
42546	2540	4112343	1992-09-15	1992-09-28	1
57107	3392	80180	2002-02-10	2002-02-11	1
83167	4945	4283893	1974-04-09	1974-05-07	1
41656	2481	4112343	2015-10-17	2015-10-24	1
28193	1666	260139	1948-08-25	1948-09-01	1
39784	2357	40481087	2008-03-20	2008-03-27	1
46110	2749	40481087	1985-12-20	1986-01-10	1
492	30	4084167	1971-02-11	1971-02-11	1
120	5	4283893	1996-04-19	1996-05-03	1
76862	4559	40481087	1962-01-14	1962-01-28	1
201	9	4113008	2012-12-21	2013-01-11	1
86328	5143	4059173	1965-04-07	1965-05-07	1
2803	162	372328	1940-07-14	1940-10-29	1
3492	199	260139	2010-02-04	2010-02-18	1
13439	793	40479422	2012-02-13	2012-04-20	1
54929	3253	4112343	1989-02-21	1989-03-04	1
25698	1528	40481087	2018-10-14	2018-10-28	1
85355	5081	40481087	1953-08-29	1953-09-05	1
4850	286	260139	1995-12-27	1996-01-10	1
24867	1486	4112343	1971-07-31	1971-08-08	1
87201	5196	260139	2005-09-04	2005-09-11	1
71876	4270	192671	2005-09-15	2005-09-16	1
59862	3550	4266809	2016-11-05	2016-11-06	1
1646	96	378001	1962-05-12	1962-06-11	1
28079	1659	4112343	1969-08-15	1969-08-23	1
55432	3287	4294548	2004-05-11	2004-07-06	1
67878	4014	40481087	1970-07-19	1970-08-02	1
27184	1606	260139	2000-12-28	2001-01-04	1
81430	4835	4112343	1980-07-16	1980-07-28	1
58245	3454	260139	2014-08-24	2014-08-31	1
42022	2504	40481087	1971-02-22	1971-03-01	1
39113	2325	40481087	2005-05-21	2005-05-28	1
73182	4353	40481087	1978-12-07	1978-12-28	1
82162	4878	4310024	1997-05-26	1997-05-27	1
33131	1967	260139	2016-03-17	2016-03-31	1
25936	1540	372328	1998-09-21	1998-12-21	1
6667	394	4112343	1955-02-10	1955-02-18	1
62545	3698	40481087	2014-04-14	2014-04-28	1
42547	2540	4296205	1950-11-30	1950-12-14	1
57108	3392	260139	2013-09-12	2013-09-19	1
83168	4945	4283893	1975-03-08	1975-04-19	1
41657	2481	4113008	1997-07-21	1997-08-11	1
28194	1666	372328	1935-06-03	1935-09-14	1
39785	2357	40481087	2010-05-21	2010-06-11	1
49415	2926	28060	1995-12-03	1995-12-11	1
493	30	4109685	1980-06-14	1980-07-05	1
121	5	4294548	1991-11-21	1993-01-28	1
76863	4559	40481087	1983-01-28	1983-02-04	1
202	9	40481087	1990-10-20	1990-11-10	1
86329	5143	4218389	1992-04-04	1992-04-25	1
2804	162	4112343	1951-06-19	1951-06-30	1
3493	199	4112343	2001-02-17	2001-02-24	1
13440	793	40481087	2008-02-13	2008-02-27	1
54930	3253	4134304	2012-02-08	2012-03-09	1
25699	1528	81151	1972-01-31	1972-02-14	1
85356	5081	40481087	1958-02-19	1958-03-12	1
4851	286	4134304	2017-06-02	2017-08-31	1
24868	1486	4310024	1989-01-27	1989-01-28	1
87202	5196	260139	2006-10-07	2006-10-14	1
71877	4270	260139	1980-12-06	1980-12-13	1
59863	3550	4294548	2014-09-19	2014-10-31	1
1647	96	4112343	1925-08-26	1925-09-02	1
28080	1659	4155034	1983-05-03	1983-05-17	1
55433	3287	40481087	1983-10-11	1983-10-25	1
69587	4122	28060	2013-06-23	2013-07-05	1
27185	1606	260139	2012-08-14	2012-08-28	1
81431	4835	4266809	2010-04-10	2010-04-11	1
58246	3454	4142905	1997-02-21	1997-05-22	1
42023	2504	40481087	1996-05-26	1996-06-16	1
39114	2325	40481087	2015-06-13	2015-06-27	1
73183	4353	40481087	2012-04-15	2012-04-29	1
82163	4878	40481087	1980-02-02	1980-02-23	1
33132	1967	4112343	2010-10-16	2010-10-24	1
25937	1540	4112343	1979-09-06	1979-09-15	1
6668	394	4112343	1966-01-23	1966-01-31	1
62546	3698	28060	2004-06-26	2004-07-05	1
42548	2540	80180	1975-01-02	1975-01-03	1
57109	3392	4112343	2010-06-19	2010-06-27	1
83169	4945	40481087	1965-04-06	1965-04-20	1
41658	2481	40481087	2002-12-21	2003-01-11	1
28195	1666	4059173	1941-11-19	1941-12-19	1
42254	2521	81151	1980-08-17	1980-09-07	1
49416	2926	80180	2017-10-29	2017-10-30	1
494	30	4112343	1990-09-13	1990-09-21	1
122	5	40481087	2016-07-22	2016-07-29	1
76864	4559	40481087	1992-05-28	1992-06-11	1
203	9	40481087	2012-12-17	2013-01-07	1
86330	5143	40481087	1984-01-01	1984-01-15	1
2805	162	4112343	1957-02-02	1957-02-14	1
3494	199	4156265	1965-01-26	1965-02-16	1
14900	879	78272	2007-06-27	2007-07-25	1
54931	3253	40481087	1974-03-06	1974-03-20	1
25700	1528	257012	1991-06-20	1991-06-21	1
85357	5081	40481087	2006-07-24	2006-08-07	1
4852	286	4152936	1975-10-26	1975-11-09	1
24869	1486	40481087	1975-02-09	1975-02-16	1
87203	5196	40481087	1993-06-01	1993-06-15	1
71878	4270	260139	1995-09-22	1995-10-06	1
59864	3550	40481087	1986-08-16	1986-09-06	1
1648	96	4134304	1942-02-26	1942-04-27	1
28081	1659	4283893	1974-12-19	1975-06-05	1
27	2	258780	1989-09-26	1989-09-27	1
69588	4122	260139	2004-06-12	2004-06-19	1
27186	1606	260139	2018-02-10	2018-02-17	1
81432	4835	4285898	2009-11-10	2009-11-11	1
58247	3454	4155034	2005-09-07	2005-09-21	1
42024	2504	40481087	2014-03-24	2014-03-31	1
41124	2447	30753	2016-01-04	2016-01-05	1
75187	4471	134438	1984-07-12	1985-10-06	1
82164	4878	80180	1999-06-15	1999-06-16	1
33133	1967	4112343	2014-05-10	2014-05-18	1
25938	1540	4142905	1973-04-10	1973-05-10	1
6669	394	4329847	1989-03-27	1989-03-28	1
62547	3698	260139	1960-07-04	1960-07-11	1
42549	2540	257012	1963-09-20	1963-09-21	1
57110	3392	40481087	1984-09-15	1984-10-06	1
84874	5053	81151	2004-03-15	2004-04-12	1
41659	2481	40481087	2008-09-15	2008-10-06	1
28196	1666	4112343	1953-04-13	1953-04-25	1
42255	2521	260139	1981-11-05	1981-11-12	1
49417	2926	195588	2000-09-13	2000-10-28	1
495	30	4112343	1993-03-19	1993-03-31	1
123	5	28060	1980-08-05	1980-08-18	1
78258	4639	30753	2002-12-09	2002-12-10	1
5239	310	257012	1952-10-31	1952-11-01	1
86331	5143	40481087	1990-03-05	1990-03-26	1
2806	162	4218389	2007-09-05	2007-09-26	1
3495	199	378001	1999-10-16	1999-12-15	1
14901	879	80180	1989-02-16	1989-02-17	1
57740	3430	261325	1989-03-04	1989-03-05	1
25701	1528	372328	1964-06-25	1964-12-25	1
85358	5081	0	1935-05-17	1935-05-18	1
4853	286	40479422	1978-12-30	1979-02-05	1
24870	1486	40481087	2007-03-24	2007-03-31	1
87204	5196	40481087	2016-08-05	2016-08-26	1
71879	4270	372328	1978-03-15	1979-02-06	1
59865	3550	40481087	2013-02-04	2013-02-18	1
1649	96	4296205	1979-07-12	1979-08-02	1
28082	1659	40481087	1972-06-06	1972-06-13	1
28	2	4059173	1990-04-14	1990-07-13	1
69589	4122	4112343	1988-04-26	1988-05-04	1
27187	1606	378001	1984-07-12	1984-08-11	1
81433	4835	40481087	2016-11-19	2016-12-03	1
58248	3454	4266809	2016-10-19	2016-10-20	1
45172	2690	0	2001-08-02	2001-08-03	1
41125	2447	260139	1995-07-24	1995-08-07	1
75188	4471	372328	1963-03-28	1963-06-17	1
82165	4878	257012	1990-07-17	1990-07-18	1
33134	1967	4116491	1980-10-06	1980-11-15	1
25939	1540	4266809	1994-03-11	1994-03-12	1
6670	394	40481087	1993-12-14	1994-01-04	1
62548	3698	260139	1989-05-05	1989-05-12	1
42550	2540	260139	1990-10-27	1990-11-03	1
1229	72	4112343	1965-10-10	1965-10-21	1
84875	5053	140673	2017-02-07	2017-02-08	1
41660	2481	40481087	2009-03-11	2009-03-25	1
28197	1666	4112343	1979-05-13	1979-05-23	1
42256	2521	378001	1978-09-27	1978-10-27	1
49418	2926	372328	1982-11-12	1982-11-26	1
496	30	4112343	2017-03-11	2017-03-24	1
124	5	80180	2009-05-30	2009-05-31	1
78259	4639	81151	1973-03-06	1973-04-03	1
5240	310	260139	1972-09-08	1972-09-15	1
86332	5143	40481087	1997-06-04	1997-06-18	1
2807	162	40481087	1964-08-13	1964-08-20	1
3496	199	4112343	2018-12-06	2018-12-14	1
14902	879	40481087	1958-09-24	1958-10-08	1
57741	3430	381316	2011-10-08	2011-10-09	1
25702	1528	4109685	2004-05-26	2004-06-09	1
85359	5081	78272	1927-12-28	1928-01-18	1
4854	286	40481087	1943-10-23	1943-10-30	1
24871	1486	133834	1960-02-21	1973-04-13	1
89634	5334	80180	2001-01-30	2001-01-31	1
71880	4270	440086	1977-01-14	1978-06-23	1
59866	3550	28060	1988-07-02	1988-07-10	1
1650	96	4329847	1997-01-25	1997-01-26	1
28083	1659	40481087	1979-11-17	1979-12-08	1
29	2	4112343	1969-09-18	1969-09-28	1
69590	4122	40481087	1997-01-15	1997-02-05	1
27188	1606	4027663	1979-12-26	1979-12-27	1
81434	4835	4112343	2008-11-14	2008-11-27	1
58249	3454	40481087	1997-05-29	1997-06-12	1
45173	2690	28060	1992-01-24	1992-02-06	1
41126	2447	4112343	2010-10-16	2010-10-27	1
75189	4471	4237458	1996-04-03	1996-06-02	1
82166	4878	4027663	1987-12-30	1987-12-31	1
33135	1967	40481087	2001-03-06	2001-03-13	1
25940	1540	4283893	1965-04-11	1965-05-30	1
6671	394	0	1989-03-27	1989-03-28	1
62549	3698	4296204	1963-04-02	1963-04-30	1
42551	2540	4112343	1968-02-12	1968-02-22	1
1230	72	4156265	1964-11-11	1964-11-25	1
84876	5053	257012	1998-09-09	1998-09-10	1
41661	2481	378001	2018-06-22	2018-08-21	1
28198	1666	40481087	1960-02-16	1960-03-08	1
42257	2521	378001	1983-06-24	1983-08-23	1
49419	2926	4027663	2010-09-11	2010-09-12	1
497	30	260139	2004-11-26	2004-12-05	1
125	5	40479768	1990-03-31	1990-06-06	1
78260	4639	260139	2004-10-09	2004-10-23	1
5241	310	4134304	1961-11-26	1962-02-24	1
2808	162	260139	1979-07-29	1979-08-05	1
3497	199	4116491	2003-04-01	2003-05-13	1
14903	879	40481087	1984-12-28	1985-01-04	1
57742	3430	40481087	1989-02-28	1989-03-14	1
25703	1528	4294548	1991-05-09	1991-08-29	1
85360	5081	80180	1955-02-14	1955-02-15	1
4855	286	40481087	1973-06-12	1973-06-26	1
24872	1486	195588	1995-06-30	1995-08-21	1
89635	5334	40481087	1984-06-26	1984-07-03	1
71881	4270	4112343	1991-03-15	1991-03-22	1
59867	3550	4027663	2009-07-15	2009-07-16	1
1651	96	40481087	1971-09-23	1971-10-07	1
28084	1659	81151	2011-08-02	2011-08-16	1
30	2	4112343	1999-12-01	1999-12-08	1
69591	4122	40481087	2009-03-02	2009-03-09	1
27189	1606	4112343	1959-06-23	1959-07-04	1
81435	4835	4296205	2011-03-26	2011-04-16	1
58250	3454	40481087	2011-10-17	2011-10-31	1
45174	2690	260139	1972-08-17	1972-08-31	1
41127	2447	4112343	2011-02-27	2011-03-11	1
75190	4471	40481087	1964-11-20	1964-11-27	1
82167	4878	40481087	2004-03-10	2004-03-31	1
33136	1967	40486433	1958-10-19	1958-10-20	1
25941	1540	28060	1960-01-23	1960-01-30	1
6672	394	260139	1982-01-22	1982-01-29	1
62550	3698	40481087	1980-08-17	1980-08-24	1
42552	2540	4155034	1953-11-28	1953-12-19	1
1231	72	40481087	1952-04-20	1952-05-11	1
84877	5053	260139	2018-07-21	2018-07-28	1
41662	2481	40481087	1974-04-01	1974-04-08	1
28199	1666	40481087	1985-12-16	1985-12-23	1
42258	2521	4112343	2009-06-09	2009-06-16	1
49420	2926	4112343	1992-12-06	1992-12-16	1
498	30	378001	2000-03-22	2000-04-21	1
126	5	40481087	1989-10-02	1989-10-23	1
78261	4639	4112343	1982-04-02	1982-04-10	1
5242	310	4283893	1952-08-08	1953-01-16	1
2809	162	260139	1984-06-15	1984-06-22	1
3498	199	4294548	2007-09-08	2007-09-22	1
14904	879	372328	2011-09-13	2012-04-09	1
57743	3430	317576	2001-03-17	2001-03-18	1
25704	1528	40481087	1994-04-10	1994-04-17	1
85361	5081	255848	2006-11-07	2006-11-08	1
4856	286	260139	1934-05-22	1934-05-29	1
24873	1486	4112343	2006-08-07	2006-08-18	1
89636	5334	40481087	1993-02-21	1993-03-14	1
71882	4270	260139	1994-01-06	1994-01-13	1
59868	3550	4112343	1993-09-06	1993-09-18	1
1652	96	40481087	1994-03-17	1994-03-31	1
28085	1659	257012	1975-01-23	1975-06-05	1
31	2	4112343	2001-02-03	2001-02-10	1
69592	4122	80180	2013-08-22	2013-08-23	1
27190	1606	4285898	1988-08-15	1988-08-16	1
81436	4835	0	1985-04-26	1985-04-27	1
59956	3556	80180	2013-10-01	2013-10-02	1
45175	2690	372328	1951-07-30	1951-09-06	1
41128	2447	4218389	2011-02-09	2011-03-09	1
75191	4471	40481087	1969-11-09	1969-11-23	1
82168	4878	40481087	2007-06-23	2007-06-30	1
33137	1967	260139	2001-12-12	2001-12-19	1
25942	1540	28060	1986-04-12	1986-04-25	1
6673	394	317576	1978-06-05	1978-06-06	1
63277	3742	28060	1995-04-02	1995-04-14	1
42553	2540	4155034	1972-12-21	1973-01-04	1
1232	72	40481087	1957-11-19	1957-11-26	1
84878	5053	4112343	1948-02-11	1948-02-21	1
41663	2481	40481087	1981-05-29	1981-06-19	1
28200	1666	40481087	2007-03-30	2007-04-06	1
42259	2521	4218389	1986-08-07	1986-09-04	1
49421	2926	4112343	2012-10-13	2012-10-21	1
499	30	4112343	1998-02-04	1998-02-17	1
127	5	40481087	2007-11-11	2007-11-18	1
78262	4639	4294548	1991-06-05	1991-07-24	1
5243	310	4310024	1981-09-08	1981-09-09	1
2810	162	4116491	1976-11-12	1976-12-20	1
3499	199	40481087	2013-10-25	2013-11-15	1
14905	879	4112343	1995-12-23	1995-12-31	1
57744	3430	4112343	2017-04-23	2017-05-03	1
25705	1528	40481087	1995-01-18	1995-01-25	1
85362	5081	260139	1947-09-19	1947-10-03	1
4857	286	260139	1943-01-01	1943-01-08	1
24874	1486	4294548	1982-03-18	1982-09-09	1
89637	5334	40481087	2001-01-06	2001-01-27	1
71883	4270	372328	1970-07-30	1970-12-22	1
59869	3550	4155034	2012-07-04	2012-07-25	1
1653	96	0	1997-01-25	1997-01-26	1
28086	1659	260139	1980-01-29	1980-02-05	1
32	2	4146173	1960-08-14	1960-09-13	1
69593	4122	81893	2012-08-27	2012-08-28	1
27191	1606	40481087	1960-07-16	1960-07-23	1
81437	4835	80180	2010-04-10	2010-04-11	1
59957	3556	257012	1984-04-26	1984-04-27	1
45176	2690	4027663	1973-09-24	1973-09-25	1
41129	2447	40481087	1984-05-07	1984-05-28	1
75192	4471	40481087	1975-08-27	1975-09-17	1
82169	4878	40481087	2008-06-03	2008-06-24	1
33138	1967	4112343	2002-06-19	2002-06-26	1
25943	1540	260139	1971-11-11	1971-11-18	1
6674	394	4112343	1941-01-09	1941-01-21	1
63278	3742	30753	2009-04-26	2009-04-27	1
42554	2540	4294548	1963-09-06	1964-01-10	1
1233	72	40481087	2003-05-06	2003-05-27	1
84879	5053	4283893	1998-07-22	1998-10-07	1
41664	2481	40481087	1984-10-10	1984-10-31	1
30062	1780	260139	1981-02-01	1981-02-15	1
42260	2521	40481087	1970-09-24	1970-10-15	1
49422	2926	40481087	2016-01-10	2016-01-24	1
500	30	4116491	1999-08-08	1999-09-12	1
128	5	40481087	2012-01-31	2012-02-07	1
78263	4639	4310024	2002-03-14	2002-03-15	1
5244	310	40481087	1976-03-20	1976-04-03	1
2811	162	40481087	1941-04-16	1941-04-30	1
3500	199	372328	1942-04-27	1942-06-10	1
14906	879	4294548	1981-09-15	1981-11-10	1
57745	3430	4134304	1972-10-15	1973-01-13	1
26571	1576	260139	2009-11-27	2009-12-04	1
85363	5081	260139	1964-11-04	1964-11-18	1
4858	286	4112343	1973-02-19	1973-03-04	1
24875	1486	40481087	1990-04-24	1990-05-15	1
89638	5334	28060	1976-10-01	1976-10-11	1
71884	4270	4112343	2013-06-10	2013-06-18	1
59870	3550	40481087	2004-01-23	2004-02-13	1
1654	96	378001	1932-08-17	1932-10-16	1
28087	1659	372328	1976-07-17	1977-04-18	1
33	2	40481087	1953-05-14	1953-05-21	1
69594	4122	4285898	2013-04-24	2013-04-25	1
27192	1606	40481087	2002-09-12	2002-09-26	1
81438	4835	372328	1987-06-30	1987-07-14	1
59958	3556	372328	1987-09-28	1988-07-25	1
45177	2690	40481087	1953-08-26	1953-09-09	1
41130	2447	40481087	2000-03-29	2000-04-05	1
75193	4471	40481087	1973-06-10	1973-06-17	1
82170	4878	81893	1997-11-22	1997-11-23	1
33139	1967	4296204	1969-01-02	1969-01-16	1
25944	1540	260139	1984-11-27	1984-12-04	1
6675	394	4112343	1978-08-11	1978-08-24	1
63279	3742	260139	2003-03-27	2003-04-10	1
42555	2540	40481087	1941-09-03	1941-09-24	1
1234	72	78272	1985-10-04	1985-10-18	1
84880	5053	40481087	1972-03-22	1972-04-12	1
41665	2481	40481087	1996-09-02	1996-09-16	1
30063	1780	260139	1988-11-30	1988-12-14	1
42261	2521	40481087	1974-03-01	1974-03-08	1
49423	2926	4112343	1992-08-25	1992-09-05	1
501	30	40481087	1977-02-17	1977-03-10	1
129	5	257012	1991-12-12	1991-12-13	1
78264	4639	40481087	1992-05-28	1992-06-11	1
5245	310	40481087	1982-05-10	1982-05-31	1
2812	162	40481087	1957-10-20	1957-11-10	1
3501	199	372328	1945-12-21	1946-03-13	1
14907	879	40481087	1956-08-23	1956-08-30	1
57746	3430	40481087	1963-09-10	1963-09-24	1
26572	1576	378001	1998-11-28	1999-01-27	1
85364	5081	378419	1999-10-15	1999-10-16	1
4859	286	4112343	1973-10-03	1973-10-12	1
24876	1486	80180	1991-07-16	1991-07-17	1
89639	5334	40481087	2012-09-24	2012-10-15	1
71885	4270	4146173	1987-10-29	1987-12-28	1
60705	3598	0	2014-12-14	2014-12-15	1
1655	96	4112343	1951-05-16	1951-05-25	1
28088	1659	4112343	1977-09-13	1977-09-21	1
34	2	255848	2008-03-15	2008-03-16	1
69595	4122	260139	2010-09-17	2010-10-01	1
27193	1606	40481087	2003-07-02	2003-07-16	1
81439	4835	440448	1985-04-26	1985-04-27	1
59959	3556	4112343	2017-01-27	2017-02-03	1
45178	2690	30753	1983-06-19	1983-06-20	1
41131	2447	40481087	2005-08-16	2005-09-06	1
75194	4471	40481087	1986-02-27	1986-03-20	1
82171	4878	260139	1988-01-25	1988-02-08	1
34507	2051	260139	1984-04-14	1984-04-21	1
25945	1540	381316	2018-12-10	2018-12-11	1
6676	394	4112343	1987-05-11	1987-05-20	1
63280	3742	4027663	2001-08-06	2001-08-07	1
42556	2540	40481087	2003-08-27	2003-09-03	1
1235	72	78272	2008-06-19	2008-07-17	1
84881	5053	40481087	1989-06-13	1989-06-20	1
41666	2481	40481087	2006-03-04	2006-03-25	1
30064	1780	372328	1966-11-07	1966-11-21	1
42262	2521	40481087	2014-04-17	2014-04-24	1
49424	2926	4266809	2017-10-29	2017-10-30	1
502	30	40481087	1999-03-09	1999-03-16	1
130	5	260139	1974-05-11	1974-05-18	1
78265	4639	80180	2004-07-01	2004-07-02	1
5246	310	28060	1998-01-28	1998-02-08	1
2813	162	40481087	1998-08-13	1998-08-20	1
3502	199	4112343	1951-05-26	1951-06-02	1
14908	879	81151	1967-04-23	1967-05-28	1
57747	3430	40481087	1973-09-24	1973-10-01	1
26573	1576	4237458	1983-12-17	1984-02-15	1
85365	5081	4112343	1954-03-09	1954-03-20	1
4860	286	4134304	2016-05-08	2016-08-06	1
24877	1486	81151	1970-08-20	1970-09-03	1
89640	5334	40481087	2017-05-31	2017-06-07	1
71886	4270	40481087	2017-12-01	2017-12-08	1
60706	3598	28060	1963-02-03	1963-02-15	1
1656	96	4116491	1985-12-26	1986-02-12	1
28089	1659	4112343	1992-05-06	1992-05-13	1
35	2	372328	1920-07-01	1920-09-07	1
69596	4122	4112343	1975-01-18	1975-01-31	1
27194	1606	40481087	2006-10-19	2006-11-02	1
81440	4835	40481087	1981-03-09	1981-03-23	1
59960	3556	40481087	1988-05-31	1988-06-14	1
45179	2690	317576	1971-06-03	1971-06-04	1
41132	2447	260139	1985-06-27	1985-07-04	1
75195	4471	80180	1998-05-18	1998-05-19	1
82172	4878	4084167	1963-08-03	1963-08-03	1
34508	2051	372328	1967-03-27	1967-10-29	1
25946	1540	4285898	1994-01-10	1994-01-11	1
6677	394	40481087	1976-06-17	1976-06-24	1
63281	3742	28060	1984-08-04	1984-08-11	1
42557	2540	40481087	2012-06-23	2012-06-30	1
1236	72	80180	1984-12-26	1984-12-27	1
84882	5053	40481087	1992-11-06	1992-11-13	1
41667	2481	40481087	2013-05-11	2013-06-01	1
30065	1780	372328	1982-04-01	1983-03-01	1
42263	2521	28060	1961-01-04	1961-01-13	1
49425	2926	4294548	1990-07-30	1990-08-06	1
503	30	40481087	2012-01-10	2012-01-31	1
131	5	260139	2003-09-10	2003-09-17	1
78266	4639	81893	2002-05-13	2002-05-14	1
5247	310	81893	1982-01-06	1982-01-07	1
2814	162	260139	1964-11-06	1964-11-20	1
3503	199	4112343	1952-12-24	1952-12-31	1
14909	879	4278672	1986-02-17	1986-03-19	1
57748	3430	372328	1964-01-31	1964-06-20	1
26574	1576	4310024	2005-01-25	2005-01-26	1
85366	5081	4156265	1939-03-21	1939-04-04	1
4861	286	4296204	1993-01-22	1993-02-26	1
24878	1486	257012	1982-04-15	1982-04-16	1
89641	5334	28060	2008-11-25	2008-12-07	1
71887	4270	80180	2005-06-26	2005-06-27	1
60707	3598	260139	2004-03-21	2004-04-04	1
1657	96	40481087	1968-06-15	1968-07-06	1
28090	1659	4237458	1980-03-19	1980-06-17	1
36	2	4112343	1963-02-05	1963-02-18	1
69597	4122	4134304	1995-11-25	1996-02-23	1
29637	1756	30753	2012-06-22	2012-06-23	1
81441	4835	40481087	1983-06-19	1983-07-03	1
59961	3556	40481087	1994-02-19	1994-03-12	1
45180	2690	4112343	1949-06-01	1949-06-11	1
41133	2447	4027663	2008-08-13	2008-08-14	1
75196	4471	260139	1963-11-14	1963-11-21	1
82173	4878	4112343	1971-01-14	1971-01-21	1
34509	2051	4109685	1974-05-10	1974-05-31	1
25947	1540	40481087	1973-02-24	1973-03-17	1
6678	394	40481087	1985-08-20	1985-09-03	1
63282	3742	372328	1972-07-04	1972-07-18	1
42558	2540	28060	1994-05-22	1994-06-01	1
1237	72	4112343	1992-10-01	1992-10-14	1
84883	5053	80180	1987-06-05	1987-06-06	1
41668	2481	78272	1984-06-01	1984-06-29	1
30066	1780	4283893	1986-12-11	1987-04-23	1
42264	2521	78272	1964-04-15	1964-05-13	1
49426	2926	40481087	1991-09-28	1991-10-12	1
504	30	78272	2002-05-11	2002-06-08	1
132	5	260139	2012-02-10	2012-02-17	1
78267	4639	192671	2004-09-05	2004-09-06	1
5248	310	260139	1952-02-04	1952-02-18	1
2815	162	4112343	1968-10-18	1968-10-26	1
3504	199	4112343	1977-07-24	1977-08-06	1
14910	879	4296205	2009-03-16	2009-04-06	1
57749	3430	4146173	1995-08-16	1995-10-15	1
26575	1576	80180	2007-04-15	2007-04-16	1
85367	5081	4296204	1919-11-05	1919-12-10	1
4862	286	40481087	1934-12-09	1934-12-16	1
24879	1486	4048171	1960-07-15	1993-07-18	1
89642	5334	81151	1986-06-23	1986-07-21	1
71888	4270	40481087	1989-04-28	1989-05-05	1
60708	3598	372328	1948-07-28	1949-03-06	1
1658	96	40481087	1970-04-05	1970-04-26	1
28091	1659	4283893	2000-11-30	2001-01-18	1
37	2	4296204	1974-03-04	1974-03-25	1
69598	4122	40481087	1976-12-11	1976-12-25	1
29638	1756	192671	2013-07-14	2013-07-15	1
84533	5034	0	1993-11-13	1993-11-14	1
59962	3556	192671	2013-10-15	2013-10-16	1
45181	2690	4112343	1993-04-03	1993-04-12	1
41134	2447	40481087	1994-06-13	1994-06-20	1
75197	4471	381316	2001-01-08	2001-01-09	1
82174	4878	4112343	2000-04-19	2000-05-01	1
34510	2051	4134304	2012-12-28	2013-01-27	1
31273	1851	260139	2000-11-08	2000-11-15	1
6679	394	80180	1957-06-10	1957-06-11	1
63283	3742	4112343	1988-03-25	1988-04-07	1
42559	2540	81151	1972-02-04	1972-02-25	1
1238	72	4112343	1994-03-12	1994-03-19	1
84884	5053	40481087	1963-06-17	1963-07-01	1
41669	2481	80180	2004-09-24	2004-09-25	1
30067	1780	40481087	1994-03-23	1994-04-13	1
42265	2521	195588	1989-03-02	1989-04-12	1
49427	2926	40481087	1998-12-12	1998-12-26	1
505	30	80180	2009-03-23	2009-03-24	1
133	5	260139	1971-03-12	1971-03-26	1
78268	4639	4059173	1986-03-26	1986-04-25	1
5249	310	4112343	1997-02-19	1997-02-28	1
2816	162	4155034	2005-10-31	2005-11-14	1
3505	199	4278672	2007-07-06	2007-08-05	1
14911	879	40481087	1982-08-14	1982-09-04	1
57750	3430	4152936	2005-09-22	2005-10-13	1
26576	1576	4027663	1999-09-29	1999-09-30	1
85368	5081	40481087	1942-04-14	1942-04-21	1
4863	286	78272	2008-01-09	2008-02-06	1
24880	1486	40481087	1960-04-21	1960-05-05	1
89643	5334	260139	1970-10-25	1970-11-08	1
71889	4270	4048695	1992-01-06	1992-02-06	1
60709	3598	378001	1955-03-29	1955-04-28	1
2366	140	80180	2003-11-14	2003-11-15	1
28092	1659	40481087	1986-02-09	1986-03-02	1
38	2	40481087	1922-05-27	1922-06-03	1
69599	4122	40481087	1994-04-19	1994-04-26	1
29639	1756	260139	2008-02-19	2008-02-26	1
84534	5034	378001	1954-05-15	1954-07-14	1
59963	3556	260139	2000-08-22	2000-08-29	1
45182	2690	40481087	1971-11-08	1971-11-29	1
41135	2447	40481087	2006-08-08	2006-08-29	1
75198	4471	40481087	1962-02-06	1962-02-27	1
82175	4878	4283893	1990-06-26	1990-10-02	1
34511	2051	4156265	1963-11-13	1963-12-04	1
31274	1851	260139	2014-10-12	2014-10-19	1
6680	394	260139	1953-03-10	1953-03-24	1
63284	3742	4310024	2007-12-03	2007-12-04	1
42560	2540	378419	2018-04-10	2018-04-11	1
1239	72	40481087	1990-11-15	1990-11-29	1
84885	5053	40481087	1973-08-14	1973-08-28	1
41670	2481	260139	1978-10-03	1978-10-17	1
30068	1780	40481087	1997-10-28	1997-11-11	1
42266	2521	372328	1949-01-13	1949-05-30	2
49428	2926	30753	2016-12-03	2016-12-04	1
506	30	260139	2013-12-06	2013-12-14	1
134	5	375671	2016-06-19	2016-07-19	1
78269	4639	28060	1971-07-18	1971-07-25	1
5250	310	4112343	2002-09-17	2002-09-24	1
2817	162	4283893	1981-10-28	1981-12-02	1
3506	199	40481087	1995-02-05	1995-02-12	1
14912	879	40481087	1998-04-01	1998-04-08	1
57751	3430	40481087	1966-05-20	1966-05-27	1
26577	1576	4112343	1972-01-18	1972-01-30	1
85369	5081	40481087	2004-01-08	2004-01-29	1
4864	286	80180	1970-08-08	1970-08-09	1
24881	1486	40481087	1972-02-07	1972-02-21	1
89644	5334	260139	1988-11-06	1988-11-13	1
71890	4270	4112343	2005-03-11	2005-03-23	1
60710	3598	378001	1958-03-13	1958-04-12	1
2367	140	40481087	1981-10-03	1981-10-10	1
28093	1659	40481087	1986-07-05	1986-07-12	1
39	2	40481087	1942-09-17	1942-10-01	1
69600	4122	40481087	2006-04-03	2006-04-10	1
29640	1756	4094814	2017-07-11	2017-10-09	1
84535	5034	440086	1932-02-09	1932-09-20	1
59964	3556	4283893	1984-03-22	1984-05-17	1
45183	2690	40481087	1992-08-28	1992-09-18	1
41136	2447	80180	2017-02-27	2017-02-28	1
75199	4471	40481087	1975-05-16	1975-05-23	1
82176	4878	40481087	1985-06-30	1985-07-14	1
34512	2051	4283893	2009-01-23	2009-03-20	1
31275	1851	372328	1980-02-26	1980-05-15	1
6681	394	4112343	1926-01-16	1926-01-24	1
63285	3742	40481087	1988-04-02	1988-04-16	1
42561	2540	440086	1947-12-20	1949-04-23	1
1240	72	260139	1985-05-26	1985-06-02	1
84886	5053	4112343	1964-03-16	1964-03-26	1
41671	2481	372328	1972-05-05	1972-06-25	1
30069	1780	81893	2004-09-28	2004-09-29	1
42267	2521	381316	2006-03-20	2006-03-21	1
49429	2926	81151	2018-10-04	2018-11-08	1
507	30	4112343	1988-03-14	1988-03-24	1
135	5	4048171	1973-07-30	1987-07-29	1
78270	4639	28060	1984-05-30	1984-06-10	1
5251	310	4155034	1955-02-17	1955-03-03	1
2818	162	40481087	1944-03-20	1944-04-10	1
4690	276	4112343	2009-04-03	2009-04-14	1
14913	879	40481087	2013-05-28	2013-06-11	1
57752	3430	40481087	1988-01-15	1988-01-29	1
26578	1576	4296205	1982-02-20	1982-03-27	1
85370	5081	260139	1997-06-20	1997-06-27	1
4865	286	260139	1973-07-19	1973-07-26	1
24882	1486	40481087	1984-11-06	1984-11-13	1
89645	5334	260139	2018-12-07	2018-12-21	1
71891	4270	40481087	2015-11-22	2015-12-06	1
60711	3598	4112343	1977-06-02	1977-06-14	1
2368	140	40481087	1994-05-10	1994-05-31	1
28094	1659	257012	2001-01-11	2001-01-12	1
40	2	40481087	1967-12-27	1968-01-03	1
69601	4122	257012	2001-05-13	2001-05-14	1
29641	1756	4112343	1980-08-03	1980-08-10	1
84536	5034	4112343	1929-06-05	1929-06-12	1
59965	3556	4156265	2000-01-23	2000-02-13	1
45184	2690	28060	1961-11-06	1961-11-14	1
41137	2447	258780	2014-10-08	2014-10-09	1
75200	4471	40481087	1986-04-24	1986-05-15	1
86776	5172	192671	1980-05-04	1980-05-05	1
34513	2051	40481087	1996-05-18	1996-05-25	1
31276	1851	4112343	1992-09-23	1992-09-30	1
6682	394	4113008	1938-07-25	1938-08-08	1
63286	3742	40481087	1988-06-24	1988-07-15	1
42562	2540	4156265	1996-11-04	1996-11-25	1
1241	72	40481087	1979-01-10	1979-01-24	1
84887	5053	40481087	1956-01-05	1956-01-19	1
41672	2481	372328	2012-07-25	2013-03-17	1
30070	1780	372328	2019-02-20	2019-02-21	1
42268	2521	4112343	1952-08-29	1952-09-09	1
49430	2926	192671	2017-11-28	2017-11-29	1
508	30	4112343	1992-02-15	1992-02-22	1
136	5	40481087	1977-08-14	1977-08-28	1
78271	4639	260139	1994-07-15	1994-07-29	1
5252	310	4266809	1984-02-25	1984-02-26	1
2819	162	40481087	1945-11-09	1945-11-16	1
4691	276	40481087	1981-11-21	1981-12-05	1
14914	879	40481087	2016-12-31	2017-01-21	1
57753	3430	40481087	2000-03-25	2000-04-15	1
26579	1576	40481087	2002-01-02	2002-01-16	1
85371	5081	372328	1946-10-14	1947-04-18	1
4866	286	372328	1929-06-26	1929-07-27	1
26357	1566	260139	1985-05-04	1985-05-11	1
89646	5334	372328	1966-10-19	1967-01-25	1
72502	4312	195588	1987-09-09	1987-10-11	1
60712	3598	4237458	1945-01-20	1945-03-21	1
2369	140	40481087	1999-08-11	1999-08-18	1
28095	1659	372328	1971-03-07	1971-06-14	1
41	2	40481087	1968-10-07	1968-10-21	1
69602	4122	4027663	2002-01-07	2002-01-08	1
29642	1756	40481087	2011-03-19	2011-04-09	1
84537	5034	81893	1958-07-02	1958-07-03	1
59966	3556	4156265	2002-01-03	2002-01-17	1
45185	2690	80180	1983-12-16	1983-12-17	1
41138	2447	4285898	2016-08-01	2016-08-02	1
75201	4471	28060	1975-04-27	1975-05-09	1
86777	5172	4112343	1957-01-13	1957-01-22	1
34514	2051	28060	1993-06-13	1993-06-26	1
31277	1851	4283893	1994-03-19	1994-04-16	1
6683	394	4283893	1961-09-20	1961-10-25	1
63287	3742	40481087	1989-01-16	1989-02-06	1
42563	2540	4283893	1986-12-03	1987-02-25	1
1242	72	40481087	2005-06-20	2005-07-11	1
84888	5053	260139	1979-08-27	1979-09-10	1
41673	2481	4059173	2012-08-22	2012-10-21	1
30071	1780	378001	1966-06-10	1966-08-09	1
42269	2521	4112343	1969-03-18	1969-03-28	1
49431	2926	260139	1990-10-12	1990-10-26	1
509	30	4134304	1975-06-11	1975-08-10	1
1937	115	257012	1962-09-22	1962-09-23	1
78272	4639	372328	1975-07-24	1976-02-06	1
5253	310	40481087	1968-11-29	1968-12-20	1
3689	212	0	2012-03-10	2012-03-11	1
4692	276	40481087	2001-10-03	2001-10-24	1
14915	879	257012	1981-11-03	1981-11-04	1
57754	3430	40481087	2012-08-16	2012-09-06	1
26580	1576	30753	2005-09-22	2005-09-23	1
85372	5081	4112343	1918-10-12	1918-10-25	1
4867	286	378001	1977-12-05	1978-01-04	1
26358	1566	4027663	1993-10-28	1993-10-29	1
89647	5334	372328	1983-09-21	1986-03-12	1
72503	4312	260139	1994-04-02	1994-04-16	1
60713	3598	40481087	1967-07-18	1967-07-25	1
2370	140	28060	1972-08-22	1972-09-04	1
28096	1659	4113008	2004-08-24	2004-09-07	1
42	2	260139	1931-09-03	1931-09-17	1
69603	4122	4266809	2013-08-22	2013-08-23	1
29643	1756	40481087	2011-12-12	2011-12-19	1
84538	5034	260139	1927-11-28	1927-12-05	1
59967	3556	40481087	1983-09-24	1983-10-15	1
45186	2690	4112343	1962-04-17	1962-04-29	1
41139	2447	40481087	1985-12-27	1986-01-17	1
75202	4471	260139	1962-07-03	1962-07-10	1
86778	5172	4152936	1988-11-16	1988-11-30	1
34515	2051	257012	2009-02-20	2009-02-21	1
31278	1851	381316	2017-12-28	2017-12-29	1
6684	394	40481087	1924-08-16	1924-09-06	1
63288	3742	40481087	1992-06-28	1992-07-19	1
42564	2540	40481087	1939-03-18	1939-04-08	1
1243	72	378001	1959-02-11	1959-04-12	1
84889	5053	260139	1986-02-18	1986-03-04	1
41674	2481	40481087	1979-01-17	1979-01-31	1
30072	1780	4027663	1994-06-08	1994-06-09	1
42270	2521	4112343	1986-01-02	1986-01-12	1
49432	2926	4285898	2017-03-03	2017-03-04	1
510	30	40481087	1998-11-23	1998-11-30	1
1938	115	4112343	2015-01-29	2015-02-09	1
78273	4639	4027663	1995-02-14	1995-02-15	1
5254	310	40481087	1969-09-24	1969-10-08	1
3690	212	28060	1993-12-15	1993-12-22	1
4693	276	260139	1983-08-18	1983-08-25	1
14916	879	372328	1953-04-06	1953-04-20	1
57755	3430	40481087	2015-04-30	2015-05-14	1
26581	1576	192671	2007-06-28	2007-06-29	1
85373	5081	4112343	1944-04-10	1944-04-20	1
4868	286	378001	1994-03-23	1994-04-22	1
26359	1566	4051466	1970-11-10	1987-02-17	1
89648	5334	4113008	2008-08-24	2008-09-14	1
72504	4312	260139	2005-09-02	2005-09-16	1
60714	3598	40481087	1996-01-10	1996-01-24	1
2371	140	28060	1974-06-30	1974-07-08	1
28097	1659	80180	2006-08-25	2006-08-26	1
43	2	378419	2000-07-25	2000-07-26	1
69604	4122	4283893	2001-04-22	2001-05-20	1
29644	1756	4112343	1993-08-06	1993-08-15	1
84539	5034	260139	1980-09-25	1980-10-09	1
59968	3556	40481087	1995-07-14	1995-07-28	1
45187	2690	40481087	1952-12-10	1952-12-24	1
41140	2447	40481087	2010-03-19	2010-04-02	1
4247	246	80180	2000-06-03	2000-06-04	1
86779	5172	4266809	1980-03-15	1980-03-16	1
34516	2051	4116491	2013-11-05	2013-12-23	1
31279	1851	4112343	2007-05-04	2007-05-13	1
11893	704	81151	1985-12-21	1986-01-11	1
63289	3742	80180	2010-09-18	2010-09-19	1
42565	2540	40481087	1996-04-16	1996-04-30	1
1244	72	4112343	1968-02-12	1968-02-23	1
84890	5053	378001	2016-05-30	2016-06-29	1
41992	2503	260139	1999-01-07	1999-01-21	1
30073	1780	4112343	1967-11-04	1967-11-15	1
42271	2521	4112343	2001-07-06	2001-07-17	1
49433	2926	40481087	2009-07-26	2009-08-09	1
511	30	40481087	2006-10-10	2006-10-31	1
1939	115	4283893	1995-06-30	1995-07-28	1
78274	4639	40481087	2015-10-18	2015-11-01	1
5255	310	40481087	1988-01-30	1988-02-20	1
3691	212	80180	2012-12-30	2012-12-31	1
4694	276	40481087	1986-03-22	1986-03-29	1
14917	879	440086	1963-02-08	1963-06-21	1
57756	3430	80180	2003-06-20	2003-06-21	1
26582	1576	4112343	2003-04-15	2003-04-26	1
85374	5081	4112343	1972-05-26	1972-06-04	1
4869	286	4112343	1969-07-02	1969-07-09	1
26360	1566	4283893	2009-12-27	2010-03-14	1
89649	5334	260139	1967-12-01	1967-12-08	1
72505	4312	40481087	1969-07-23	1969-07-30	1
60715	3598	40481087	2008-02-21	2008-03-06	1
2372	140	81151	2015-11-09	2015-11-23	1
28098	1659	440086	1976-03-15	1983-06-27	1
44	2	4109685	1952-07-13	1952-07-27	1
69605	4122	4310024	2011-11-01	2011-11-02	1
29645	1756	80180	2013-05-18	2013-05-19	1
84540	5034	372328	1922-11-08	1923-01-20	1
59969	3556	40481087	2003-01-26	2003-02-16	1
45188	2690	40481087	1977-11-03	1977-11-10	1
45915	2739	30753	1991-07-02	1991-07-03	1
4248	246	81151	1981-06-06	1981-06-27	1
86780	5172	40481087	1980-02-14	1980-03-06	1
34517	2051	4116491	2017-12-22	2018-01-22	1
31280	1851	4296204	1997-09-24	1997-10-08	1
11894	704	134438	1986-12-10	1987-10-11	1
63290	3742	81893	2008-06-30	2008-07-01	1
42566	2540	40481087	2002-05-08	2002-05-29	1
1245	72	4112343	1989-10-02	1989-10-13	1
84891	5053	4059173	1991-06-24	1991-08-23	1
41993	2503	378001	1992-07-08	1992-09-06	1
30074	1780	4112343	2010-09-28	2010-10-06	1
42272	2521	4156265	1949-02-12	1949-03-05	1
49434	2926	260139	1984-09-04	1984-09-11	1
512	30	40481087	2018-04-13	2018-04-27	1
1940	115	4296204	1978-05-23	1978-06-06	1
79463	4713	81893	2009-04-21	2009-04-22	1
5256	310	40481087	1989-02-23	1989-03-02	1
3692	212	260139	1980-08-27	1980-09-03	1
4695	276	40481087	1991-01-09	1991-01-23	1
20033	1209	28060	1991-05-13	1991-05-24	1
57757	3430	260139	1975-03-06	1975-03-13	1
26583	1576	40481087	2015-05-13	2015-06-03	1
85375	5081	4112343	1982-04-29	1982-05-10	1
4870	286	4142905	2006-10-16	2006-12-15	1
26361	1566	40481087	2018-02-07	2018-02-14	1
89650	5334	260139	1988-02-01	1988-02-08	1
72506	4312	40481087	2008-11-22	2008-11-29	1
60716	3598	80180	1980-07-05	1980-07-06	1
2373	140	4152936	1995-01-07	1995-01-28	1
28099	1659	4112343	1999-10-07	1999-10-15	1
45	2	4142905	1993-03-29	1993-05-28	1
69606	4122	40481087	1982-07-05	1982-07-12	1
29646	1756	260139	1995-11-06	1995-11-20	1
84541	5034	378001	1933-08-12	1933-10-11	1
59970	3556	40481087	2009-03-24	2009-04-14	1
45189	2690	260139	1956-11-19	1956-11-26	1
45916	2739	260139	1969-07-24	1969-07-31	1
4249	246	260139	2003-05-23	2003-06-06	1
86781	5172	40481087	2005-10-24	2005-11-07	1
34518	2051	40481087	1985-11-15	1985-12-06	1
31281	1851	40481087	2003-07-07	2003-07-21	1
11895	704	257012	1968-02-17	1968-02-18	1
63291	3742	260139	1993-09-14	1993-09-28	1
43989	2620	4112343	1992-08-01	1992-08-10	1
1246	72	4218389	1979-07-10	1979-08-07	1
84892	5053	4112343	1956-12-08	1956-12-20	1
41994	2503	4112343	2009-06-01	2009-06-10	1
30075	1780	40481087	1977-07-18	1977-07-25	1
42273	2521	40481087	1971-02-18	1971-03-11	1
49435	2926	40481087	1989-08-15	1989-08-29	1
513	30	78272	1972-07-05	1972-07-26	1
1941	115	40481087	1964-04-27	1964-05-18	1
79464	4713	260139	2000-02-12	2000-02-26	1
5257	310	80180	1984-02-25	1984-02-26	1
3693	212	372328	1996-04-15	1996-06-22	1
4696	276	78272	2011-08-10	2011-08-24	1
20034	1209	372328	1978-07-16	1978-08-17	1
57758	3430	40481087	1986-03-04	1986-03-18	1
26584	1576	28060	1980-03-19	1980-03-27	1
85376	5081	4112343	1994-04-08	1994-04-16	1
4871	286	4155034	2019-05-23	2019-06-13	1
26362	1566	257012	2010-02-21	2010-03-14	1
89651	5334	372328	1964-10-16	1965-01-27	1
72507	4312	372328	1963-04-09	1963-08-14	1
60717	3598	260139	1950-05-25	1950-06-01	1
2374	140	81151	1992-03-25	1992-04-22	1
28100	1659	40481087	1974-06-10	1974-06-17	1
46	2	4156265	1977-04-08	1977-04-22	1
70774	4204	192671	1988-12-26	1988-12-27	1
29647	1756	375671	1982-08-14	1982-09-13	1
84542	5034	4112343	1951-01-19	1951-01-26	1
59971	3556	4134304	1994-01-24	1994-04-24	1
45190	2690	372328	1949-06-27	1949-09-08	1
45917	2739	4059173	1988-06-26	1988-08-25	1
4250	246	4112343	1970-11-26	1970-12-03	1
86782	5172	40481087	2008-01-05	2008-01-26	1
34519	2051	40481087	2011-04-17	2011-04-24	1
31282	1851	40481087	2009-04-24	2009-05-01	1
11896	704	260139	1999-03-20	1999-04-03	1
63292	3742	40481087	1985-09-02	1985-09-09	1
43990	2620	4116491	2002-11-02	2002-12-25	1
1247	72	4230399	1969-09-30	1969-10-30	1
84893	5053	4112343	1967-03-14	1967-03-21	1
41995	2503	81151	1986-10-10	1986-11-07	1
30076	1780	40481087	2003-01-19	2003-02-02	1
42274	2521	80180	1983-12-31	1984-01-01	1
49436	2926	40481087	1991-08-06	1991-08-20	1
514	30	4237458	1977-08-29	1977-09-28	1
1942	115	40481087	1969-04-11	1969-04-18	1
79465	4713	4027663	1998-12-30	1998-12-31	1
5258	310	4027663	1974-06-12	1974-06-13	1
3694	212	380378	2014-11-01	2014-11-02	1
4697	276	378001	1988-12-08	1989-02-06	1
20035	1209	4294548	1985-06-04	1985-11-12	1
60480	3580	81151	1990-05-10	1990-05-31	1
26585	1576	4112343	1999-10-18	1999-10-31	1
85377	5081	4134304	1989-08-10	1989-09-09	1
4872	286	40479768	1976-10-04	1976-11-10	1
26363	1566	260139	2000-08-13	2000-08-20	1
89652	5334	372328	1978-04-27	1979-02-14	1
72508	4312	4051466	1963-09-22	1981-09-16	1
60718	3598	317576	1996-04-07	1996-04-08	1
2375	140	4112343	1998-05-07	1998-05-18	1
29716	1761	78272	1960-10-12	1960-11-15	1
47	2	4237458	1934-01-19	1934-03-20	1
70775	4204	4112343	1983-05-21	1983-06-02	1
29648	1756	4112343	2009-04-25	2009-05-08	1
84543	5034	4152936	1945-02-10	1945-03-03	1
59972	3556	40481087	2017-10-07	2017-10-21	1
45191	2690	4109685	1997-04-30	1997-05-21	1
45918	2739	4112343	2014-06-09	2014-06-17	1
4251	246	40481087	1962-08-19	1962-09-02	1
86783	5172	260139	1967-06-08	1967-06-22	1
34520	2051	28060	1976-10-18	1976-10-26	1
31283	1851	40481087	2011-12-22	2012-01-12	1
11897	704	260139	2015-12-07	2015-12-14	1
63293	3742	40481087	1996-09-01	1996-09-22	1
43991	2620	4278672	1979-09-19	1979-11-18	1
1248	72	4294548	2000-07-17	2000-10-09	1
84894	5053	4155034	1992-07-18	1992-08-01	1
41996	2503	260139	2013-05-26	2013-06-09	1
30077	1780	80180	2006-02-20	2006-02-21	1
42275	2521	260139	1985-08-24	1985-09-07	1
49437	2926	40481087	2006-02-23	2006-03-09	1
515	30	4283893	2014-02-17	2014-04-28	1
1943	115	192671	2001-04-15	2001-04-16	1
79466	4713	4112343	1990-12-28	1991-01-10	1
5259	310	4112343	1976-11-25	1976-12-02	1
3695	212	4113008	1978-11-04	1978-11-18	1
4698	276	4112343	1993-10-12	1993-10-20	1
20036	1209	372328	1986-06-29	1986-10-02	1
60481	3580	260139	1986-03-13	1986-03-27	1
26586	1576	40481087	1974-12-06	1974-12-20	1
85378	5081	4146173	1995-08-09	1995-09-08	1
4873	286	40481087	1993-08-19	1993-09-02	1
26364	1566	40481087	1992-06-21	1992-07-05	1
89653	5334	4112343	1965-10-12	1965-10-25	1
72509	4312	4084167	1978-06-09	1978-06-10	1
60719	3598	4112343	1984-07-19	1984-07-29	1
2376	140	4296204	1970-05-31	1970-06-21	1
29717	1761	260139	1995-09-30	1995-10-07	1
48	2	4278672	1924-01-12	1924-04-11	1
70776	4204	4112343	1987-06-12	1987-06-19	1
29649	1756	28060	1977-05-13	1977-05-20	1
84544	5034	4156265	1967-04-07	1967-04-28	1
61450	3636	28060	1993-03-12	1993-03-21	1
45192	2690	4156265	1996-03-22	1996-04-05	1
45919	2739	4152936	1986-07-23	1986-08-06	1
4252	246	40481087	2001-03-31	2001-04-07	1
86784	5172	372328	1957-01-23	1957-04-23	1
34521	2051	260139	1969-03-18	1969-04-01	1
31284	1851	80180	2016-07-16	2016-07-17	1
11898	704	4155034	1994-10-26	1994-11-16	1
63294	3742	4112343	2017-12-18	2017-12-30	1
43992	2620	4278672	1992-11-05	1993-02-03	1
1249	72	4294548	2018-03-12	2018-04-09	1
84895	5053	4155034	2001-07-15	2001-07-29	1
41997	2503	372328	1975-03-12	1975-07-29	1
30078	1780	257012	1986-12-25	1986-12-26	1
42276	2521	4112343	1955-02-07	1955-02-19	1
51503	3060	260139	1968-02-25	1968-03-03	1
516	30	40481087	2012-06-08	2012-06-22	1
1944	115	4112343	2019-04-20	2019-04-29	1
79467	4713	4283893	2015-04-17	2015-10-09	1
5260	310	4152936	1981-06-14	1981-07-05	1
3696	212	40481087	1973-10-02	1973-10-23	1
4699	276	4112343	1998-05-31	1998-06-13	1
20037	1209	372328	1995-06-17	1996-06-20	1
60482	3580	260139	2006-10-15	2006-10-22	1
26587	1576	40481087	1986-03-01	1986-03-22	1
85379	5081	4283893	1981-09-18	1981-10-30	1
4874	286	40481087	2011-01-06	2011-01-27	1
26365	1566	80180	2002-11-10	2002-11-11	1
89654	5334	40481087	1970-04-26	1970-05-03	1
72510	4312	4109685	1989-09-08	1989-09-29	1
60720	3598	4329847	2014-12-14	2014-12-15	1
2377	140	40481087	1989-01-09	1989-01-30	1
29718	1761	372328	1957-10-27	1958-08-11	1
49	2	40481087	1926-09-15	1926-10-06	1
70777	4204	4112343	2016-02-28	2016-03-06	1
29650	1756	4027663	2002-07-30	2002-07-31	1
84545	5034	40481087	1922-06-20	1922-07-04	1
61451	3636	80180	2010-10-23	2010-10-24	1
45193	2690	4266809	1983-12-16	1983-12-17	1
45920	2739	28060	1960-03-25	1960-04-07	1
4253	246	40481087	2004-08-25	2004-09-08	1
86785	5172	4112343	1963-07-22	1963-08-04	1
34522	2051	260139	1980-03-17	1980-03-31	1
31285	1851	260139	2001-01-15	2001-01-22	1
11899	704	40481087	1983-02-17	1983-03-10	1
65869	3899	78272	1998-08-19	1998-09-23	1
43993	2620	4296204	1988-09-01	1988-09-22	1
1250	72	40481087	1952-02-23	1952-03-15	1
84896	5053	4155034	2013-09-22	2013-10-13	1
41998	2503	4112343	1998-07-25	1998-08-06	1
30079	1780	260139	1974-08-28	1974-09-04	1
42277	2521	4112343	1967-04-15	1967-04-27	1
51504	3060	4027663	1952-03-22	1952-03-23	1
517	30	40486433	1973-08-21	1973-08-22	1
1945	115	4116491	1975-10-28	1976-03-02	2
79468	4713	40481087	2013-07-29	2013-08-19	1
5261	310	4155034	2014-03-05	2014-03-26	1
3697	212	260139	1996-06-13	1996-06-20	1
4700	276	4112343	2006-03-05	2006-03-17	1
20038	1209	4112343	2014-12-31	2015-01-07	1
60483	3580	372328	1979-03-18	1979-11-09	1
31788	1889	40481087	1990-01-19	1990-01-26	1
85380	5081	40481087	1977-09-25	1977-10-02	1
6563	388	4029498	2017-08-29	2017-08-30	1
26366	1566	192671	2003-01-01	2003-01-02	1
89655	5334	40481087	2007-04-05	2007-04-19	1
72511	4312	4109685	2019-05-16	2019-05-30	1
60721	3598	40481087	1959-08-31	1959-09-21	1
2378	140	81151	1976-05-20	1976-06-17	1
29719	1761	4112343	1994-08-29	1994-09-08	1
50	2	40481087	1955-01-16	1955-01-30	1
70778	4204	4283893	1980-07-08	1980-08-05	1
29651	1756	40481087	1973-05-09	1973-05-23	1
84546	5034	28060	1973-06-24	1973-07-05	1
61452	3636	260139	1979-03-12	1979-03-26	1
45194	2690	4310024	1982-11-21	1982-11-22	1
45921	2739	260139	1988-07-22	1988-08-05	1
4254	246	30753	1999-05-10	1999-05-11	1
86786	5172	4112343	1975-11-30	1975-12-10	1
34523	2051	4112343	1980-07-11	1980-07-18	1
31286	1851	4001336	2006-09-21	2006-10-21	1
11900	704	40481087	1983-10-13	1983-10-27	1
65870	3899	260139	2010-10-21	2010-10-28	1
43994	2620	40481087	1979-03-20	1979-04-03	1
1251	72	40481087	1986-05-25	1986-06-01	1
85098	5067	260139	1976-12-20	1977-01-03	1
41999	2503	4112343	2003-11-09	2003-11-17	1
30080	1780	260139	1983-02-06	1983-02-13	1
42278	2521	4112343	1997-05-18	1997-05-26	1
51505	3060	4112343	1934-10-07	1934-10-20	1
4903	289	28060	2005-08-13	2005-08-23	1
1946	115	40481087	1973-08-02	1973-08-09	1
79469	4713	40481087	2017-11-03	2017-11-24	1
5262	310	372328	1951-09-06	1951-11-24	1
3698	212	260139	2012-07-28	2012-08-11	1
4701	276	4278672	1978-06-04	1978-07-04	1
20039	1209	4146173	2003-08-23	2003-10-22	1
60484	3580	40481087	1995-10-20	1995-10-27	1
31789	1889	40481087	1993-08-14	1993-09-04	1
85381	5081	40481087	1988-06-02	1988-06-23	1
6564	388	4112343	1962-12-12	1962-12-20	1
26367	1566	4109685	1985-05-01	1985-05-15	1
67624	3998	321042	1982-08-26	1982-08-27	1
72512	4312	4112343	1989-11-09	1989-11-22	1
60722	3598	40481087	1992-06-22	1992-07-06	1
2379	140	260139	1986-12-05	1986-12-19	1
29720	1761	4230399	2014-04-21	2014-05-21	1
51	2	40481087	2002-01-01	2002-01-08	1
70779	4204	40481087	1978-07-07	1978-07-14	1
29652	1756	40481087	1977-08-08	1977-08-22	1
84547	5034	80180	1959-07-27	1959-07-28	1
61453	3636	260139	1997-10-13	1997-10-27	1
45195	2690	4329847	2001-08-02	2001-08-03	1
45922	2739	4112343	1995-04-05	1995-04-13	1
4255	246	378001	1963-10-06	1963-12-05	1
86787	5172	4112343	2001-11-09	2001-11-19	1
34524	2051	4296204	1981-08-22	1981-09-12	1
31287	1851	4112343	1995-12-17	1995-12-29	1
11901	704	40481087	1990-08-30	1990-09-06	1
65871	3899	81151	1985-05-31	1985-06-28	1
43995	2620	40481087	2005-04-09	2005-04-30	1
2844	164	28060	1966-06-05	1966-06-15	1
85099	5067	372328	1983-10-13	1983-12-25	1
42000	2503	40481087	1994-04-07	1994-04-28	1
30081	1780	4051466	1967-06-22	1985-03-12	1
42279	2521	40481087	1962-10-10	1962-10-31	1
51506	3060	4112343	1955-06-15	1955-06-22	1
4904	289	260139	2014-08-19	2014-08-26	1
1947	115	80180	2001-04-04	2001-04-05	1
79470	4713	80180	2010-08-14	2010-08-15	1
5263	310	4152936	2002-07-15	2002-08-05	1
3699	212	4029498	2012-03-10	2012-03-11	1
4702	276	80180	2013-01-16	2013-01-17	1
20040	1209	80180	2014-01-17	2014-01-18	1
60485	3580	40481087	2007-05-25	2007-06-01	1
31790	1889	80180	2018-04-28	2018-04-29	1
85382	5081	78272	1969-05-10	1969-05-31	1
6565	388	4112343	1999-09-04	1999-09-15	1
26368	1566	4112343	1972-08-12	1972-08-24	1
67625	3998	4027663	1977-06-04	1977-06-05	1
72513	4312	4294548	2001-10-10	2001-11-21	1
60723	3598	4059173	1985-02-19	1985-04-20	1
2380	140	378001	1982-02-16	1982-03-18	1
29721	1761	40481087	1967-03-09	1967-03-30	1
52	2	80180	1956-12-04	1956-12-05	1
70780	4204	40481087	2012-03-13	2012-03-27	1
29653	1756	40481087	1979-06-21	1979-06-28	1
84548	5034	260139	1956-12-14	1956-12-28	1
61454	3636	4112343	1999-09-30	1999-10-12	1
45196	2690	40481087	1949-07-03	1949-07-24	1
45923	2739	4112343	1998-11-10	1998-11-17	1
4256	246	4027663	1990-11-18	1990-11-19	1
86788	5172	40481087	1965-11-12	1965-11-19	1
34525	2051	80180	2005-06-25	2005-06-26	1
31288	1851	40481087	2006-07-11	2006-08-01	1
11902	704	40481087	1992-02-05	1992-02-12	1
65872	3899	260139	2003-12-18	2003-12-25	1
43996	2620	81151	2001-06-21	2001-07-26	1
2845	164	80180	2009-02-11	2009-02-12	1
85100	5067	4051466	1978-06-08	1993-09-18	1
42001	2503	28060	1985-09-17	1985-09-29	1
30082	1780	4112343	1972-01-27	1972-02-06	1
42280	2521	40481087	1975-09-06	1975-09-20	1
51507	3060	4112343	1995-03-22	1995-03-31	1
4905	289	4112343	1962-10-29	1962-11-11	1
1948	115	81151	2011-04-14	2011-04-28	1
79471	4713	257012	1976-11-19	1976-11-20	1
5264	310	4283893	1973-10-26	1973-11-23	1
3700	212	40481087	1970-05-25	1970-06-15	1
4703	276	260139	1983-04-11	1983-04-18	1
20041	1209	81893	2012-04-27	2012-04-28	1
60486	3580	257012	1990-03-15	1990-03-16	1
31791	1889	4109685	2009-04-14	2009-05-05	1
85383	5081	81151	1985-07-27	1985-08-10	1
6566	388	4155034	2006-02-16	2006-03-02	1
26369	1566	4146173	2012-10-20	2012-12-19	1
67626	3998	4112343	1953-03-15	1953-03-25	1
72514	4312	40481087	1963-02-03	1963-02-17	1
60724	3598	4112343	1980-10-24	1980-11-06	1
2381	140	4112343	1999-08-12	1999-08-23	1
29722	1761	40481087	1980-04-25	1980-05-17	1
53	2	195588	1952-05-24	1952-07-08	1
70781	4204	40481087	2017-02-07	2017-02-21	1
32644	1941	260139	1988-11-25	1988-12-09	1
84549	5034	260139	1965-01-30	1965-02-06	1
61455	3636	4112343	2004-04-19	2004-04-29	1
45197	2690	40481087	1970-06-17	1970-07-08	1
45924	2739	4146173	1997-03-11	1997-04-10	1
4257	246	4051466	1963-12-02	1979-03-14	1
86789	5172	40481087	2004-05-04	2004-05-25	1
34526	2051	260139	2002-08-07	2002-08-14	1
31289	1851	0	1988-12-05	1988-12-06	1
11903	704	40481087	2008-03-25	2008-04-01	1
65873	3899	4112343	1988-01-17	1988-01-29	1
43997	2620	260139	2015-11-09	2015-11-23	1
2846	164	192671	2009-02-26	2009-02-27	1
85101	5067	40481087	1987-12-15	1987-12-22	1
42002	2503	80180	2017-02-24	2017-02-25	1
30083	1780	4310024	2003-11-03	2003-11-04	1
42281	2521	40481087	2011-07-18	2011-07-25	1
51508	3060	4278672	1998-06-06	1998-09-04	1
4906	289	4134304	1970-09-15	1970-12-13	1
1949	115	4027663	1988-10-24	1988-10-25	1
79472	4713	372328	1970-11-12	1970-12-18	1
5265	310	40481087	1957-10-31	1957-11-21	1
3701	212	28060	1972-09-07	1972-09-18	1
4704	276	4112343	1978-11-02	1978-11-12	1
20042	1209	372328	1978-01-06	1978-02-16	1
60487	3580	372328	1983-05-22	1983-12-02	1
31792	1889	4109685	2015-10-31	2015-11-21	1
85384	5081	260139	1915-12-28	1916-01-04	1
6567	388	40481087	1960-11-27	1960-12-04	1
26370	1566	4310024	2000-05-24	2000-05-25	1
67627	3998	4112343	1993-02-04	1993-02-11	1
72515	4312	40481087	1989-12-20	1989-12-27	1
60725	3598	4218389	2006-01-30	2006-03-06	1
2382	140	40481087	1970-02-05	1970-02-12	1
29723	1761	40481087	1989-07-20	1989-07-27	1
54	2	260139	1955-10-22	1955-10-29	1
70782	4204	372328	1952-12-01	1953-01-26	1
32645	1941	372328	1973-03-17	1973-05-24	1
84550	5034	260139	1989-05-02	1989-05-16	1
61456	3636	4113008	2017-03-18	2017-04-08	1
47105	2804	78272	2015-06-30	2015-07-21	1
45925	2739	4283893	1995-07-22	1995-09-02	1
4258	246	4112343	1962-11-12	1962-11-22	1
86790	5172	40481087	2015-08-25	2015-09-01	1
34527	2051	4112343	1974-05-22	1974-05-31	1
31290	1851	258780	2009-07-16	2009-07-17	1
11904	704	40481087	2015-09-28	2015-10-19	1
65874	3899	80180	2015-07-08	2015-07-09	1
43998	2620	4218389	2005-03-07	2005-04-11	1
2847	164	260139	1986-07-27	1986-08-10	1
85102	5067	260139	1990-07-30	1990-08-13	1
42003	2503	4048171	1978-02-26	1978-02-27	1
30084	1780	40481087	1999-12-10	1999-12-31	1
42282	2521	28060	2012-11-29	2012-12-12	1
51509	3060	40481087	1930-11-05	1930-11-19	1
4907	289	78272	2000-02-09	2000-03-08	1
1950	115	4112343	1961-05-26	1961-06-06	1
79473	4713	440086	1975-01-05	1984-01-13	1
5266	310	40481087	1983-01-04	1983-01-25	1
3702	212	78272	2011-01-20	2011-02-03	1
4705	276	4112343	1984-04-16	1984-04-29	1
20043	1209	372328	1980-03-09	1980-08-14	1
60488	3580	4109685	1986-04-10	1986-05-01	1
31793	1889	4113008	1994-06-18	1994-07-02	1
85385	5081	260139	1970-07-07	1970-07-21	1
6568	388	40481087	1967-07-07	1967-07-14	1
26371	1566	40481087	2000-12-12	2000-12-19	1
67628	3998	4112343	2011-10-25	2011-11-05	1
72516	4312	40481087	1995-03-25	1995-04-08	1
60726	3598	40481087	1945-02-25	1945-03-18	1
2383	140	40481087	1974-01-27	1974-02-03	1
29724	1761	378001	1993-03-11	1993-04-11	1
55	2	260139	1980-07-25	1980-08-10	1
70783	4204	4027663	1979-08-07	1979-08-08	1
32646	1941	4059173	1988-12-14	1989-01-13	1
84551	5034	4112343	1969-04-24	1969-05-02	1
61457	3636	40481087	1984-04-20	1984-05-11	1
47106	2804	260139	1961-06-07	1961-06-21	1
45926	2739	4285898	1992-02-27	1992-02-28	1
4259	246	4112343	1986-08-10	1986-08-21	1
86791	5172	78272	2006-04-30	2006-05-21	1
34528	2051	40481087	1966-03-11	1966-03-25	1
31291	1851	372328	1982-11-01	1982-11-15	1
11905	704	78272	1977-06-08	1977-07-06	1
65875	3899	260139	2016-06-06	2016-06-13	1
43999	2620	40481087	2001-10-09	2001-10-30	1
2848	164	372328	1971-04-26	1971-12-20	1
85103	5067	4230399	1978-04-03	1978-05-03	1
42004	2503	4112343	2006-02-06	2006-02-16	1
30085	1780	40481087	2002-10-22	2002-11-12	1
42283	2521	195588	1986-01-09	1986-03-03	1
51510	3060	40481087	1962-12-02	1962-12-23	1
4908	289	372328	1962-11-12	1963-02-18	1
1951	115	4112343	1980-11-08	1980-11-20	1
79474	4713	4112343	1973-08-14	1973-08-27	1
5267	310	40481087	1985-10-19	1985-11-02	1
3703	212	372328	1980-04-14	1980-09-06	1
4706	276	40481087	2008-01-26	2008-02-16	1
20044	1209	378001	2001-09-02	2001-10-02	1
60489	3580	4112343	1975-10-07	1975-10-16	1
31794	1889	40481087	2002-03-25	2002-04-01	1
85386	5081	4112343	1939-11-19	1939-11-29	1
6569	388	0	2017-08-29	2017-08-30	1
26372	1566	40481087	2005-03-03	2005-03-17	1
67629	3998	4134304	1970-09-09	1970-11-08	1
72517	4312	40486433	1962-09-22	1962-09-23	1
60727	3598	40481087	1954-03-07	1954-03-21	1
4324	250	260139	1995-01-25	1995-02-08	1
29725	1761	4112343	1963-11-27	1963-12-08	1
56	2	260139	1994-06-05	1994-06-19	1
70784	4204	4112343	1980-11-21	1980-12-01	1
32647	1941	40481087	1982-05-16	1982-05-23	1
84552	5034	4112343	1970-08-28	1970-09-06	1
290	16	81151	2014-06-27	2014-07-25	1
47107	2804	378001	1999-04-25	1999-05-25	1
45927	2739	40481087	1955-04-16	1955-04-23	1
4260	246	4296205	1974-03-12	1974-04-09	1
86792	5172	260139	2017-05-11	2017-05-25	1
36529	2165	81151	1962-04-20	1962-05-11	1
31292	1851	380378	1988-12-05	1988-12-06	1
11906	704	372328	1968-02-26	1968-08-28	1
65876	3899	4112343	1993-11-01	1993-11-09	1
44000	2620	40481087	2005-02-18	2005-03-04	1
2849	164	4283893	1972-01-08	1972-02-19	1
85104	5067	80180	2012-02-08	2012-02-09	1
43321	2583	372328	1973-01-30	1973-05-21	1
30086	1780	28060	1978-05-06	1978-05-15	1
42284	2521	260139	1948-03-20	1948-04-03	1
51511	3060	40481087	1965-08-11	1965-09-01	1
4909	289	372328	1964-11-09	1965-03-01	1
1952	115	4218389	1962-08-17	1962-09-14	1
79475	4713	4112343	1999-02-01	1999-02-14	1
5416	320	28060	1981-11-19	1981-11-29	1
3704	212	4116491	2015-03-10	2015-04-29	1
6014	354	261325	1996-01-05	1996-01-06	1
20045	1209	4112343	1978-04-10	1978-04-18	1
60490	3580	4283893	1990-02-08	1990-04-19	1
31795	1889	40481087	2018-03-06	2018-03-13	1
85387	5081	4112343	1944-05-21	1944-05-28	1
6570	388	260139	1994-08-16	1994-08-30	1
26373	1566	81151	1979-10-02	1979-10-30	1
67630	3998	40481087	1971-01-11	1971-02-01	1
72518	4312	80180	1995-07-29	1995-07-30	1
60728	3598	40481087	1993-01-09	1993-01-16	1
4325	250	260139	2002-08-13	2002-08-27	1
29726	1761	4112343	1996-07-01	1996-07-11	1
57	2	260139	1996-04-10	1996-04-24	1
70785	4204	4112343	1995-10-06	1995-10-19	1
32648	1941	40481087	1987-10-29	1987-11-12	1
84553	5034	4266809	1959-07-27	1959-07-28	1
291	16	40481087	1986-09-29	1986-10-20	1
47108	2804	4109685	1965-02-28	1965-03-14	1
45928	2739	40481087	1975-10-14	1975-11-04	1
4261	246	4310024	1998-03-16	1998-03-17	1
86793	5172	372328	1948-06-16	1948-09-07	1
36530	2165	260139	1957-10-14	1957-10-21	1
31293	1851	4029498	1988-12-05	1988-12-06	1
11907	704	4218389	1999-06-23	1999-07-21	1
65877	3899	4112343	2018-04-26	2018-05-05	1
44001	2620	80180	2000-10-23	2000-10-24	1
2850	164	40481087	1991-10-20	1991-10-27	1
85105	5067	4142905	1988-12-06	1989-02-04	1
43322	2583	4112343	1978-02-28	1978-03-13	1
30087	1780	30753	2005-01-26	2005-01-27	1
42285	2521	4112343	1953-01-10	1953-01-17	1
51512	3060	40481087	1972-10-15	1972-11-05	1
4910	289	4112343	1972-02-26	1972-03-10	1
1953	115	4294548	1962-08-25	1962-09-29	1
79476	4713	4283893	1976-08-20	1977-02-04	1
5417	320	260139	1961-02-23	1961-03-09	1
3705	212	372328	1975-02-23	1976-03-06	1
6015	354	4112343	1993-10-18	1993-10-31	1
20046	1209	4112343	2009-11-16	2009-11-26	1
60491	3580	40481087	1977-04-03	1977-04-10	1
31796	1889	4112343	1995-10-15	1995-10-28	1
85388	5081	4112343	1957-11-30	1957-12-10	1
6571	388	375671	1966-08-03	1966-09-02	1
26374	1566	260139	2017-03-16	2017-03-23	1
67631	3998	81151	2008-08-02	2008-09-06	1
72519	4312	133834	1961-02-14	1977-06-17	1
60729	3598	28060	1980-09-10	1980-09-21	1
4326	250	372328	1980-10-26	1981-02-04	1
29727	1761	40481087	1989-10-29	1989-11-12	1
58	2	260139	1996-10-01	1996-10-08	1
70786	4204	4156265	2006-07-17	2006-07-31	1
32649	1941	40481087	2011-09-03	2011-09-24	1
84554	5034	40481087	1936-06-28	1936-07-05	1
292	16	260139	1994-01-01	1994-01-08	1
47109	2804	4112343	2010-05-28	2010-06-07	1
45929	2739	372328	1956-05-31	1956-08-22	1
4262	246	81151	1980-06-27	1980-07-11	1
86794	5172	375671	1951-11-28	1951-12-28	1
36531	2165	4112343	1985-10-11	1985-10-23	1
32886	1953	4112343	2008-08-05	2008-08-14	1
11908	704	40481087	1970-09-10	1970-09-17	1
65878	3899	4134304	2018-08-09	2018-11-07	1
44002	2620	260139	1989-01-31	1989-02-14	1
2851	164	40481087	2007-01-04	2007-01-18	1
85106	5067	4156265	2002-04-27	2002-05-11	1
43323	2583	4116491	2000-06-07	2000-07-20	1
30088	1780	4112343	2011-07-06	2011-07-16	1
42286	2521	4112343	1959-10-30	1959-11-09	1
51513	3060	40481087	1982-01-16	1982-02-06	1
4911	289	40481087	2007-07-08	2007-07-29	1
1954	115	28060	1983-11-08	1983-11-15	1
79477	4713	30753	2009-12-17	2009-12-18	1
5418	320	260139	1984-10-10	1984-10-17	1
3706	212	4112343	1984-12-18	1984-12-30	1
6016	354	4218389	2008-06-12	2008-07-03	1
20047	1209	4149245	2004-09-16	2004-10-23	1
60492	3580	40481087	1994-10-02	1994-10-16	1
31797	1889	4112343	2012-07-03	2012-07-15	1
85389	5081	4294548	1960-05-07	1961-01-14	1
6572	388	378001	1974-07-20	1974-08-19	1
26375	1566	4142905	1970-08-20	1970-09-19	1
67632	3998	81893	1985-01-28	1985-01-29	1
72520	4312	257012	2001-10-31	2001-11-01	1
60730	3598	195588	1978-03-18	1978-05-04	1
4327	250	4155034	1975-01-09	1975-01-30	1
29728	1761	40481087	2001-04-22	2001-05-13	1
59	2	313217	2007-09-04	2007-09-05	1
70787	4204	4218389	1994-05-16	1994-06-20	1
32650	1941	40481087	2017-07-23	2017-07-30	1
84555	5034	40481087	1986-12-17	1986-12-24	1
293	16	4029498	1983-10-10	1983-10-11	1
47110	2804	40481087	1973-11-02	1973-11-23	1
45930	2739	372328	1957-03-20	1958-02-26	1
4263	246	260139	1970-03-05	1970-03-12	1
86795	5172	4027663	1971-03-28	1971-03-29	1
36532	2165	40481087	1987-02-28	1987-03-14	1
32887	1953	80180	1998-03-11	1998-03-12	1
11909	704	30753	2000-08-21	2000-08-22	1
65879	3899	260139	1991-10-29	1991-11-12	1
44003	2620	4059173	1973-03-24	1973-05-23	1
2852	164	78272	2000-10-31	2000-11-28	1
85107	5067	4218389	1977-04-17	1977-05-08	1
43324	2583	4294548	2018-07-23	2018-08-27	1
30089	1780	4134304	1989-02-09	1989-04-10	1
50452	2988	260139	2002-10-22	2002-11-05	1
51514	3060	40481087	1992-09-11	1992-10-02	1
4912	289	378001	1987-02-17	1987-03-19	1
1955	115	258780	2019-03-03	2019-03-04	1
79478	4713	81151	1982-08-11	1982-08-25	1
5419	320	4112343	1958-10-08	1958-10-19	1
3707	212	4112343	2015-12-30	2016-01-12	1
6017	354	40481087	2002-02-18	2002-03-04	1
20048	1209	40481087	2004-07-06	2004-07-27	1
60493	3580	40481087	1996-12-29	1997-01-12	1
31798	1889	40481087	1995-05-02	1995-05-23	1
85390	5081	40481087	1984-02-25	1984-03-17	1
6573	388	380378	2017-08-29	2017-08-30	1
26376	1566	40481087	1969-10-01	1969-10-15	1
67633	3998	372328	1953-06-10	1954-06-03	1
72521	4312	260139	1982-10-16	1982-10-23	1
60731	3598	372328	1947-10-07	1948-02-29	1
4328	250	40481087	2005-01-03	2005-01-17	1
29729	1761	28060	1959-04-10	1959-04-20	1
60	2	372328	1921-06-04	1921-08-09	1
70788	4204	40481087	1954-03-04	1954-03-11	1
32651	1941	81151	2009-04-28	2009-05-19	1
84556	5034	30753	1958-11-29	1958-11-30	1
294	16	40481087	1985-08-05	1985-08-26	1
47111	2804	40481087	2010-08-09	2010-08-23	1
45931	2739	4112343	2007-01-05	2007-01-15	1
4264	246	261325	1998-09-03	1998-09-04	1
86796	5172	4112343	1946-03-31	1946-04-10	1
36533	2165	378001	1978-05-17	1978-07-16	1
32888	1953	260139	1993-07-26	1993-08-09	1
11910	704	80180	2001-02-17	2001-02-18	1
65880	3899	4112343	2006-10-04	2006-10-15	1
44004	2620	4112343	1966-02-03	1966-02-15	1
2853	164	372328	1967-12-24	1968-06-10	1
85108	5067	4283893	2013-05-01	2013-05-29	1
43325	2583	40481087	1978-11-07	1978-11-28	1
30090	1780	4296204	1993-05-19	1993-06-09	1
50453	2988	372328	1965-10-22	1965-11-14	1
51515	3060	40481087	2011-11-19	2011-12-10	1
4913	289	4112343	1996-08-04	1996-08-14	1
1956	115	260139	1997-10-13	1997-10-27	1
79479	4713	4278672	1970-12-12	1971-01-11	1
5420	320	4152936	1960-12-24	1961-01-07	1
3708	212	4113008	2007-04-20	2007-05-11	1
6018	354	40481087	2011-09-08	2011-09-22	1
20049	1209	257012	1985-07-02	1985-07-03	1
60494	3580	40481087	2007-11-03	2007-11-24	1
31799	1889	40481087	2000-10-01	2000-10-22	1
88052	5241	81151	1976-01-13	1976-02-10	1
6574	388	4112343	1956-04-07	1956-04-15	1
26377	1566	40481087	1994-08-31	1994-09-07	1
67634	3998	4112343	1962-02-08	1962-02-16	1
72522	4312	372328	1959-12-15	1960-02-24	1
60732	3598	4112343	1956-06-23	1956-07-05	1
4329	250	80180	2008-12-26	2008-12-27	1
29730	1761	80180	1995-03-02	1995-03-03	1
61	2	4112343	1960-10-31	1960-11-13	1
70789	4204	260139	1950-09-15	1950-09-29	1
32652	1941	4059173	1981-11-21	1981-12-21	1
84557	5034	260139	1923-01-08	1923-01-22	1
295	16	80180	2013-03-21	2013-03-22	1
47112	2804	78272	1996-02-26	1996-03-11	1
45932	2739	4266809	1992-03-28	1992-03-29	1
4265	246	378001	2002-11-04	2003-01-03	1
86797	5172	4113008	1959-07-08	1959-07-22	1
36534	2165	4112343	1963-11-15	1963-11-25	1
32889	1953	4112343	1969-08-21	1969-08-29	1
11911	704	260139	1978-07-04	1978-07-18	1
65881	3899	4112343	2012-12-14	2012-12-21	1
44005	2620	4112343	2001-11-25	2001-12-02	1
2854	164	4109685	2018-09-25	2018-10-09	1
85109	5067	40481087	1980-12-02	1980-12-16	1
43326	2583	0	2001-06-08	2001-06-09	1
30091	1780	40481087	1997-02-01	1997-02-22	1
50454	2988	381316	2012-06-24	2012-06-25	1
51516	3060	260139	1925-06-24	1925-07-01	1
4914	289	40481087	1961-12-06	1961-12-13	1
1957	115	260139	2001-06-30	2001-07-14	1
79480	4713	4283893	1979-04-03	1979-08-07	1
5421	320	4152936	2004-08-09	2004-08-23	1
3709	212	40481087	1975-04-23	1975-05-07	1
6019	354	40481087	2017-06-09	2017-06-16	1
20050	1209	372328	1981-11-07	1982-08-19	1
60495	3580	80180	2017-07-31	2017-08-01	1
31800	1889	40481087	2006-01-18	2006-02-01	1
88053	5241	260139	2001-04-02	2001-04-09	1
6575	388	4112343	1966-12-03	1966-12-10	1
27749	1640	28060	2005-03-24	2005-04-06	1
67635	3998	40481087	1998-04-16	1998-04-23	1
72523	4312	372328	1982-01-06	1984-09-19	1
60733	3598	4112343	1979-10-04	1979-10-12	1
4330	250	4112343	1987-08-02	1987-08-15	1
29731	1761	81151	2019-04-16	2019-05-21	1
62	2	4112343	1984-08-14	1984-08-27	1
70790	4204	260139	1993-03-18	1993-04-01	1
32653	1941	80180	2009-11-23	2009-11-24	1
84558	5034	260139	1930-12-22	1930-12-29	1
296	16	372328	1972-04-10	1972-06-21	1
47113	2804	260139	1983-08-09	1983-08-16	1
45933	2739	40481087	1990-08-24	1990-09-07	1
4266	246	4112343	1972-04-28	1972-05-06	1
86798	5172	4155034	1952-10-23	1952-11-13	1
36535	2165	4146173	1970-10-26	1970-11-25	1
32890	1953	4112343	1990-05-12	1990-05-22	1
11912	704	372328	1976-03-19	1976-10-06	1
65882	3899	40481087	2018-02-13	2018-02-27	1
44006	2620	4218389	1989-08-18	1989-09-22	1
2855	164	4112343	2000-05-30	2000-06-08	1
85110	5067	28060	1974-08-04	1974-08-14	1
43327	2583	28060	1973-02-01	1973-02-09	1
36274	2151	80180	1958-07-22	1958-07-23	1
50455	2988	440086	1976-06-06	1980-06-15	1
51517	3060	260139	2000-08-19	2000-09-02	1
4915	289	40481087	1990-06-22	1990-07-13	1
1958	115	372328	1960-12-25	1961-01-08	1
79481	4713	40481087	1979-11-13	1979-11-20	1
5422	320	4218389	1968-07-27	1968-08-31	1
3710	212	40481087	2009-09-13	2009-09-27	1
6020	354	4294548	2013-08-18	2013-08-25	1
20051	1209	4027663	2002-09-02	2002-09-03	1
60496	3580	4112343	2015-10-17	2015-10-25	1
32510	1933	378001	1994-01-21	1994-02-20	1
88054	5241	4112343	2009-03-08	2009-03-17	1
6576	388	4112343	1975-04-14	1975-04-26	1
27750	1640	260139	1992-03-25	1992-04-01	1
67636	3998	0	1982-08-26	1982-08-27	1
72524	4312	4112343	1987-07-09	1987-07-19	1
60734	3598	40481087	1964-01-07	1964-01-28	1
4331	250	40481087	1980-03-19	1980-04-09	1
29732	1761	260139	1985-12-21	1986-01-04	1
63	2	4112343	1985-07-26	1985-08-06	1
70791	4204	378001	1971-05-26	1971-06-25	1
32654	1941	372328	1976-04-19	1976-07-22	1
84559	5034	260139	1973-12-22	1973-12-29	1
297	16	372328	1974-06-11	1974-09-18	1
47114	2804	372328	1954-04-27	1954-09-15	1
45934	2739	80180	1992-03-28	1992-03-29	1
4267	246	4142905	1961-11-15	1962-01-14	1
86799	5172	40481087	1956-06-23	1956-07-14	1
36536	2165	4237458	2003-01-13	2003-02-12	1
32891	1953	372328	1956-08-28	1957-01-14	1
11913	704	4027663	1990-12-02	1990-12-03	1
66107	3917	260139	1994-01-20	1994-02-03	1
44007	2620	40481087	1974-12-20	1975-01-03	1
2856	164	40481087	1990-07-01	1990-07-22	1
85111	5067	260139	2006-11-18	2006-12-02	1
43328	2583	372328	1973-07-20	1973-11-19	1
36275	2151	260139	1958-02-09	1958-02-16	1
50456	2988	4112343	2011-10-04	2011-10-13	1
51518	3060	4112343	1937-05-11	1937-05-24	1
4916	289	40481087	1991-07-13	1991-07-27	1
1959	115	372328	1961-07-07	1961-10-08	1
79482	4713	78272	1986-07-05	1986-07-26	1
5423	320	40481087	1979-11-03	1979-11-10	1
3711	212	40481087	2016-04-02	2016-04-09	1
6021	354	4296204	1989-10-29	1989-11-19	1
20052	1209	4134304	1984-04-04	1984-07-03	1
60497	3580	4142905	1989-05-15	1989-06-14	1
32511	1933	4112343	1963-06-07	1963-06-19	1
88055	5241	40481087	1973-04-16	1973-04-23	1
6577	388	4155034	2000-04-04	2000-04-18	1
27751	1640	4112343	2011-06-06	2011-06-15	1
67637	3998	4266809	1986-06-22	1986-06-23	1
72525	4312	40481087	1968-10-26	1968-11-16	1
60735	3598	40481087	2007-03-06	2007-03-20	1
4332	250	372328	1975-12-05	1976-01-21	1
29733	1761	4112343	1958-06-07	1958-06-14	1
64	2	4112343	1995-04-18	1995-04-25	1
70792	4204	4112343	1967-12-19	1967-12-26	1
32655	1941	378001	1995-09-09	1995-11-08	1
84560	5034	317576	1993-01-23	1993-01-24	1
298	16	4112343	2015-02-13	2015-02-26	1
47115	2804	4134304	1952-08-05	1952-11-03	1
45935	2739	255848	2015-11-17	2015-11-18	1
4268	246	4266809	2000-06-03	2000-06-04	1
86800	5172	28060	1990-04-26	1990-05-08	1
36537	2165	4294548	2010-08-11	2010-11-03	1
32892	1953	372328	1960-07-27	1961-07-17	1
11914	704	4237458	1968-01-27	1968-04-26	1
66108	3917	4218389	1968-08-02	1968-08-30	1
46425	2768	28060	1974-11-13	1974-11-22	1
2857	164	40481087	2000-11-17	2000-12-01	1
85112	5067	378001	1992-12-15	1993-02-13	1
43329	2583	4059173	1971-07-10	1971-10-08	1
36276	2151	381316	1992-12-09	1992-12-10	1
50457	2988	4285898	2000-09-18	2000-09-19	1
51519	3060	4112343	1985-07-01	1985-07-10	1
4917	289	80180	1992-12-22	1992-12-23	1
1960	115	4056621	1976-01-02	1976-01-03	1
79483	4713	260139	1978-09-02	1978-09-16	1
5424	320	40481087	2008-01-21	2008-02-11	1
4475	263	80180	1991-03-28	1991-03-29	1
6022	354	40481087	1992-05-30	1992-06-20	1
20053	1209	40481087	1987-01-14	1987-01-28	1
60498	3580	4296204	1993-03-16	1993-04-20	1
32512	1933	40481087	1972-03-19	1972-03-26	1
88056	5241	40481087	1978-11-29	1978-12-13	1
6578	388	40481087	1981-06-07	1981-06-28	1
27752	1640	4230399	2006-09-14	2006-11-13	1
67638	3998	4285898	1985-07-27	1985-07-28	1
72526	4312	40481087	1990-04-04	1990-04-11	1
63117	3732	80180	1993-12-24	1993-12-25	1
4333	250	4112343	1977-03-02	1977-03-14	1
29734	1761	4112343	1996-09-11	1996-09-24	1
65	2	40481087	1957-09-24	1957-10-15	1
70793	4204	4112343	1999-05-02	1999-05-13	1
32656	1941	4294548	2004-02-13	2004-03-05	1
84561	5034	4027663	1953-02-03	1953-02-04	1
299	16	4134304	2004-01-21	2004-03-21	1
47116	2804	4218389	1993-02-13	1993-03-13	1
45936	2739	4027663	1985-03-10	1985-03-11	1
4269	246	4285898	1999-07-09	1999-07-10	1
36538	2165	40481087	1963-09-17	1963-09-24	1
32893	1953	4112343	1982-03-14	1982-03-23	1
11915	704	4294548	1967-11-04	1968-03-16	1
66109	3917	40481087	1978-09-26	1978-10-03	1
46426	2768	260139	2002-08-26	2002-09-09	1
2858	164	4112343	2005-10-13	2005-10-24	1
85113	5067	40481087	1990-05-18	1990-05-25	1
43330	2583	4059173	1993-06-28	1993-07-28	1
36277	2151	4112343	1959-06-04	1959-06-12	1
50458	2988	40481087	1991-08-13	1991-08-27	1
51520	3060	4112343	1999-12-07	1999-12-15	1
4918	289	260139	2010-10-17	2010-10-31	1
1961	115	4112343	1965-09-15	1965-09-26	1
79484	4713	375671	1976-10-11	1976-12-10	1
5425	320	195588	1977-02-13	1977-04-08	1
4476	263	260139	1955-02-16	1955-03-02	1
6023	354	40481087	1992-09-24	1992-10-01	1
20445	1231	28060	1958-06-21	1958-07-02	1
60499	3580	40481087	2007-08-08	2007-08-29	1
32513	1933	195588	1979-05-25	1979-07-06	1
88057	5241	40481087	1989-11-23	1989-11-30	1
6579	388	80180	1988-10-25	1988-10-26	1
27753	1640	40481087	1942-10-12	1942-10-19	1
67639	3998	40481087	1959-04-15	1959-05-06	1
72527	4312	4084167	1961-02-07	1961-02-08	1
63118	3732	381316	2016-09-18	2016-09-19	1
4334	250	4112343	1983-02-12	1983-02-20	1
29735	1761	4283893	2011-09-25	2011-10-23	1
1969	116	260139	1952-11-22	1952-12-06	1
70794	4204	4155034	1972-04-20	1972-05-11	1
32657	1941	40481087	1979-12-16	1979-12-23	1
84562	5034	4112343	1982-05-20	1982-05-27	1
300	16	40481087	1987-04-25	1987-05-16	1
47117	2804	260139	1956-09-14	1956-09-21	1
45937	2739	4043241	2009-04-22	2009-04-23	1
4270	246	28060	1964-09-13	1964-09-26	1
36539	2165	80180	1991-09-15	1991-09-16	1
32894	1953	4112343	1997-08-17	1997-08-30	1
11916	704	260139	1982-08-03	1982-08-10	1
66110	3917	40481087	1980-12-26	1981-01-16	1
46427	2768	4112343	1984-05-06	1984-05-19	1
2859	164	4112343	2011-12-23	2012-01-03	1
88293	5255	28060	1993-07-02	1993-07-12	1
43331	2583	4112343	1991-04-16	1991-04-24	1
36278	2151	40481087	1922-11-28	1922-12-05	1
50459	2988	81151	1975-08-15	1975-09-05	1
51521	3060	4112343	2017-08-14	2017-08-24	1
4919	289	372328	1961-01-04	1961-02-20	1
1962	115	4112343	2004-10-27	2004-11-09	1
79485	4713	4112343	1969-11-19	1969-11-29	1
5426	320	372328	1957-11-10	1958-01-26	1
4477	263	372328	1957-06-04	1957-11-24	1
6024	354	40481087	2005-11-18	2005-12-02	1
20446	1231	28060	2002-05-13	2002-05-23	1
60500	3580	40481087	2008-09-26	2008-10-10	1
32514	1933	4059173	1960-05-19	1960-08-17	1
88058	5241	40481087	1990-01-04	1990-01-11	1
6580	388	372328	1956-08-04	1957-01-22	1
27754	1640	40481087	2019-05-16	2019-06-06	1
67640	3998	40481087	1976-07-12	1976-08-02	1
72528	4312	4109685	1999-04-10	1999-05-01	1
63119	3732	4027663	1982-07-10	1982-07-11	1
4335	250	4112343	1996-11-28	1996-12-09	1
29736	1761	40481087	1959-06-26	1959-07-17	1
1970	116	260139	1994-11-27	1994-12-11	1
70795	4204	4285898	1988-02-26	1988-02-27	1
32658	1941	40481087	1997-12-27	1998-01-10	1
84563	5034	4294548	1975-02-20	1975-03-13	1
301	16	40481087	1990-04-06	1990-04-20	1
47118	2804	260139	1963-02-16	1963-02-23	1
45938	2739	4112343	1954-12-09	1954-12-21	1
4271	246	78272	2018-03-15	2018-04-05	1
36540	2165	134438	1978-06-02	1979-04-28	1
32895	1953	4116491	2002-07-28	2002-09-11	1
11917	704	4112343	1970-05-20	1970-05-27	1
66111	3917	40481087	2008-07-09	2008-07-30	1
46428	2768	4112343	1995-11-20	1995-11-27	1
2860	164	40481087	1984-10-19	1984-11-02	1
88294	5255	378001	2008-04-28	2008-06-27	1
43332	2583	4134304	1986-08-20	1986-10-19	1
36279	2151	40481087	1948-06-05	1948-06-12	1
50460	2988	260139	1972-09-16	1972-09-23	1
51522	3060	4218389	2010-03-19	2010-04-09	1
4920	289	4112343	2000-04-27	2000-05-07	1
1963	115	4112343	2011-04-10	2011-04-19	1
79486	4713	4285898	2010-05-16	2010-05-17	1
5427	320	4218389	1961-11-03	1961-12-01	1
4478	263	4112343	1991-04-25	1991-05-03	1
6025	354	260139	1973-03-24	1973-04-07	1
20447	1231	81151	1992-07-26	1992-08-16	1
60501	3580	260139	2003-02-25	2003-03-04	1
32515	1933	4112343	1968-06-25	1968-07-02	1
88059	5241	80180	2001-04-01	2001-04-02	1
6581	388	4112343	1968-12-31	1969-01-12	1
27755	1640	260139	1978-08-30	1978-09-06	1
67641	3998	40481087	2010-09-21	2010-09-28	1
72529	4312	4112343	1963-08-28	1963-09-10	1
63120	3732	4149245	2015-11-09	2015-12-16	1
4336	250	4218389	1983-02-17	1983-03-10	1
29737	1761	40481087	1962-12-04	1962-12-18	1
1971	116	4112343	1989-11-11	1989-11-19	1
70796	4204	40481087	1972-04-12	1972-05-03	1
32659	1941	260139	1995-03-13	1995-03-27	1
84564	5034	4329847	1993-11-13	1993-11-14	1
302	16	40481087	2005-12-03	2005-12-17	1
47119	2804	260139	2017-08-18	2017-09-01	1
45939	2739	4112343	1962-03-31	1962-04-13	1
4272	246	260139	2011-08-12	2011-08-26	1
36541	2165	260139	1968-11-24	1968-12-01	1
32896	1953	4146173	1980-06-23	1980-08-22	1
11918	704	4112343	2007-09-12	2007-09-20	1
66112	3917	80180	2000-05-21	2000-05-22	1
46429	2768	40481087	1985-04-30	1985-05-07	1
2861	164	40481087	1996-07-11	1996-08-01	1
88295	5255	4112343	1971-07-27	1971-08-04	1
43333	2583	4296204	1989-07-05	1989-07-19	1
36280	2151	40481087	1979-12-16	1979-12-23	1
50461	2988	260139	2006-12-22	2007-01-05	1
51523	3060	4278672	2012-03-29	2012-04-28	1
4921	289	4112343	2016-06-30	2016-07-11	1
1964	115	4237458	2006-06-09	2006-07-09	1
85114	5068	80180	1973-03-26	1973-03-27	1
5428	320	4218389	1973-02-06	1973-02-27	1
4479	263	4112343	2015-10-02	2015-10-14	1
6026	354	260139	2001-10-18	2001-10-25	1
20448	1231	260139	1982-01-07	1982-01-14	1
60502	3580	4116491	1998-03-18	1998-05-02	1
32516	1933	4112343	1999-10-20	1999-11-02	1
88060	5241	4142905	1969-04-19	1969-05-19	1
6582	388	4112343	1976-09-18	1976-09-30	1
27756	1640	260139	2003-06-18	2003-07-02	1
68737	4072	80180	2011-11-17	2011-11-18	1
72530	4312	4112343	2009-08-13	2009-08-24	1
63121	3732	81151	1997-12-17	1998-01-14	1
4337	250	260139	2018-06-05	2018-06-19	1
29738	1761	40481087	1986-01-23	1986-01-30	1
1972	116	4218389	1959-07-22	1959-08-12	1
70797	4204	40481087	2005-01-03	2005-01-10	1
32660	1941	260139	1997-03-18	1997-04-01	1
84565	5034	40479768	1971-03-08	1971-04-14	1
303	16	40481087	2009-11-05	2009-11-12	1
47120	2804	378001	1982-05-14	1982-06-13	1
45940	2739	4112343	1989-01-24	1989-02-01	1
4273	246	4112343	1984-12-03	1984-12-16	1
36542	2165	372328	1959-07-17	1960-05-03	1
32897	1953	40481087	1969-04-01	1969-04-22	1
13349	787	28060	1988-06-14	1988-06-26	1
66113	3917	80809	2008-08-27	2012-03-09	1
46430	2768	28060	2006-04-04	2006-04-16	1
2862	164	260139	1979-11-22	1979-11-29	1
88296	5255	4283893	1997-08-11	1997-09-08	1
43334	2583	40481087	1995-04-04	1995-04-18	1
36281	2151	0	1999-12-08	1999-12-09	1
50462	2988	4112343	1999-05-14	1999-05-26	1
51524	3060	40479768	1945-09-05	1945-10-12	1
4922	289	40481087	2005-02-19	2005-03-12	1
1965	115	4266809	2001-04-04	2001-04-05	1
85115	5068	260139	1983-08-29	1983-09-05	1
5429	320	40481087	1973-04-26	1973-05-03	1
4480	263	4152936	2013-08-21	2013-09-11	1
6027	354	4218389	2012-04-13	2012-05-18	1
20449	1231	4112343	1952-10-12	1952-10-21	1
60503	3580	4283893	2014-11-17	2015-02-09	1
32517	1933	4112343	2016-11-05	2016-11-16	1
88061	5241	4152936	2012-10-26	2012-11-09	1
6583	388	40481087	1986-08-06	1986-08-27	1
27757	1640	381316	2015-06-10	2015-06-11	1
68738	4072	4152936	2004-04-16	2004-04-30	1
72531	4312	40481087	1998-04-30	1998-05-21	1
63122	3732	378001	2011-10-31	2011-11-30	1
5031	297	28060	1989-07-20	1989-08-02	1
29739	1761	28060	1958-02-25	1958-03-04	1
1973	116	40481087	1956-08-19	1956-09-09	1
70798	4204	28060	1955-12-20	1956-01-02	1
32661	1941	372328	1975-05-14	1975-07-24	1
88459	5264	80180	2004-07-13	2004-07-14	1
304	16	0	1983-10-10	1983-10-11	1
47121	2804	4112343	1959-12-29	1960-01-08	1
45941	2739	4112343	1995-08-14	1995-08-24	1
4274	246	4155034	1975-02-03	1975-02-24	1
36543	2165	4112343	1995-10-05	1995-10-16	1
32898	1953	40481087	1988-03-21	1988-03-28	1
13350	787	192671	2017-04-02	2017-04-03	1
66114	3917	257012	1983-09-14	1983-09-15	1
46431	2768	80180	2010-07-15	2010-07-16	1
2863	164	378001	1979-03-26	1979-04-25	1
88297	5255	4285898	1995-10-01	1995-10-02	1
43335	2583	260139	1985-10-26	1985-11-09	1
36282	2151	260139	1969-03-17	1969-03-31	1
50463	2988	4283893	2017-11-16	2017-11-30	1
51525	3060	40481087	1931-01-27	1931-02-03	1
4923	289	40481087	2010-11-15	2010-11-29	1
1966	115	40481087	1968-07-03	1968-07-10	1
85116	5068	4059173	2007-11-06	2008-02-04	1
5430	320	28060	2008-10-09	2008-10-22	1
4481	263	4294548	1964-12-28	1965-03-01	1
6028	354	80180	1989-12-12	1989-12-13	1
20450	1231	4112343	1990-12-28	1991-01-06	1
61321	3628	28060	1927-05-27	1927-06-08	1
32518	1933	4285898	1997-09-12	1997-09-13	1
88062	5241	40481087	1994-06-28	1994-07-12	1
6584	388	40481087	2008-11-21	2008-11-28	1
27758	1640	4112343	1956-08-11	1956-08-20	1
68739	4072	40481087	1977-06-02	1977-06-23	1
75338	4477	257012	1987-11-17	1987-11-18	1
63123	3732	4266809	1993-12-24	1993-12-25	1
5032	297	4112343	1952-02-15	1952-02-28	1
29740	1761	28060	2001-01-01	2001-01-10	1
1974	116	40481087	1983-12-27	1984-01-10	1
70799	4204	28060	2010-12-15	2010-12-24	1
32662	1941	440086	1986-02-12	1987-01-28	1
88460	5264	260139	1980-04-26	1980-05-03	1
305	16	260139	1985-03-05	1985-03-12	1
47122	2804	4112343	1975-07-22	1975-07-29	1
46219	2757	80180	2007-07-14	2007-07-15	1
4275	246	40481087	1993-06-26	1993-07-03	1
36544	2165	4112343	2010-10-31	2010-11-10	1
32899	1953	40481087	2000-01-04	2000-01-11	1
13351	787	4112343	2014-03-28	2014-04-10	1
66115	3917	372328	1972-10-10	1973-08-23	1
46432	2768	260139	1980-07-13	1980-07-20	1
2864	164	4112343	1989-12-14	1989-12-24	1
88298	5255	4296204	1961-11-13	1961-11-27	1
43336	2583	260139	2018-10-25	2018-11-08	1
36283	2151	313217	1975-04-30	1975-05-01	1
50464	2988	4310024	1998-07-01	1998-07-02	1
51526	3060	40481087	1967-01-23	1967-02-06	1
4924	289	40481087	2015-06-13	2015-06-27	1
1967	115	40481087	1982-09-27	1982-10-04	1
85117	5068	4112343	1934-09-12	1934-09-21	1
5431	320	80180	1995-08-28	1995-08-29	1
4482	263	257012	1965-02-08	1965-02-09	1
6029	354	195588	1980-12-29	1981-02-03	1
20451	1231	4112343	2009-08-18	2009-08-25	1
61322	3628	81151	1967-07-22	1967-08-26	1
32519	1933	40481087	1960-04-24	1960-05-15	1
88063	5241	28060	1972-01-06	1972-01-14	1
6585	388	40486433	1956-09-20	1973-09-18	1
27759	1640	4112343	1994-12-16	1994-12-27	1
68740	4072	40481087	1982-02-25	1982-03-11	1
75339	4477	260139	2009-12-21	2010-01-04	1
63124	3732	4283893	1993-02-20	1993-05-15	1
5033	297	4112343	1960-03-20	1960-04-02	1
29741	1761	260139	1967-07-09	1967-07-23	1
1975	116	40481087	2006-03-04	2006-03-18	1
70800	4204	80180	1988-10-23	1988-10-24	1
32663	1941	4155034	1974-01-11	1974-02-01	1
88461	5264	4294548	1992-02-11	1992-02-25	1
306	16	4112343	1976-09-20	1976-10-02	1
47123	2804	4112343	1982-01-05	1982-01-18	1
46220	2757	257012	1974-06-26	2006-07-19	1
4966	293	81151	2018-03-04	2018-03-25	1
36545	2165	4278672	1961-03-26	1961-05-25	1
32900	1953	80502	2014-10-27	2014-10-28	1
13352	787	4146173	2016-03-03	2016-05-02	1
66116	3917	40481087	1970-11-25	1970-12-02	1
46433	2768	4109685	1972-07-24	1972-08-07	1
2865	164	4112343	1990-03-26	1990-04-06	1
88299	5255	372328	1971-10-06	1972-08-10	1
43337	2583	440448	2001-06-08	2001-06-09	1
36284	2151	372328	1919-11-04	1920-03-17	1
50465	2988	40481087	1967-01-22	1967-02-05	1
51527	3060	40481087	2004-01-09	2004-01-23	1
5828	343	260139	1981-10-01	1981-10-08	1
1968	115	40481087	1984-04-01	1984-04-22	1
85118	5068	4112343	1953-04-22	1953-04-29	1
5432	320	192671	1995-10-19	1995-10-20	1
4483	263	4112343	1960-10-20	1960-10-30	1
6030	354	260139	1957-06-30	1957-07-14	1
20452	1231	28060	1946-12-01	1946-12-09	1
61323	3628	257012	1942-11-16	1942-11-17	1
32520	1933	80180	1998-05-10	1998-05-11	1
88064	5241	192671	2001-04-15	2001-04-16	1
6586	388	81151	1965-06-18	1965-07-09	1
27760	1640	40480160	2006-09-14	2006-11-13	1
68741	4072	78272	1999-08-27	1999-09-10	1
75340	4477	4027663	1995-11-13	1995-11-14	1
63125	3732	40481087	1969-03-15	1969-03-22	1
5034	297	4112343	1963-07-18	1963-07-31	1
29742	1761	4109685	1972-10-14	1972-10-28	1
1976	116	80180	1970-02-14	1970-02-15	1
70801	4204	260139	2015-05-19	2015-06-02	1
32664	1941	40481087	2016-03-09	2016-03-23	1
88462	5264	40481087	2010-07-12	2010-08-02	1
307	16	4155034	1975-05-25	1975-06-08	1
47124	2804	4112343	1982-07-20	1982-07-30	1
46221	2757	4296204	1974-02-27	1974-03-27	1
4967	293	260139	1975-01-20	1975-02-03	1
36546	2165	40479768	1989-09-16	1989-10-23	1
32901	1953	134438	1983-08-09	1984-08-03	1
13353	787	40481087	1997-04-26	1997-05-10	1
66117	3917	40481087	1986-11-16	1986-11-23	1
46434	2768	40481087	1975-08-06	1975-08-13	1
2866	164	4112343	1997-05-03	1997-05-12	1
88300	5255	4027663	1986-12-17	1986-12-18	1
43338	2583	4112343	1973-12-10	1973-12-20	1
36285	2151	4112343	1957-12-27	1958-01-08	1
50466	2988	80180	2001-07-15	2001-07-16	1
51528	3060	30753	1960-08-12	1960-08-13	1
5829	343	372328	1971-11-22	1972-01-08	1
2721	159	28060	1957-12-02	1957-12-12	1
85119	5068	4112343	1971-12-06	1971-12-13	1
5433	320	261325	1990-06-17	1990-06-18	1
4484	263	4218389	1979-02-23	1979-03-23	1
6031	354	372328	1957-12-25	1958-06-12	1
20453	1231	78272	1975-03-09	1975-04-06	1
61324	3628	260139	1926-09-11	1926-09-25	1
32521	1933	260139	1980-12-02	1980-12-16	1
88065	5241	378001	1974-01-23	1974-02-22	1
6587	388	257012	1955-10-19	1955-10-20	1
27761	1640	40481087	2000-09-22	2000-10-13	1
68742	4072	192671	2012-01-09	2012-01-10	1
75341	4477	4112343	1966-11-09	1966-11-16	1
63126	3732	4112343	1980-01-02	1980-01-12	1
5035	297	4112343	1967-12-17	1967-12-30	1
29743	1761	4113008	2016-05-10	2016-05-31	1
1977	116	372328	1927-07-05	1927-10-16	1
70802	4204	372328	1954-07-20	1955-08-01	1
35484	2105	372328	1974-10-17	1974-11-24	1
88463	5264	78272	1978-11-02	1978-11-30	1
308	16	4155034	1989-06-24	1989-07-08	1
47125	2804	40479768	1983-04-09	1983-05-16	1
46222	2757	40481087	2006-10-26	2006-11-02	1
4968	293	378001	2005-11-07	2005-12-07	1
36547	2165	40481087	1970-11-25	1970-12-16	1
32902	1953	260139	1957-06-26	1957-07-03	1
13354	787	4112343	1978-05-19	1978-05-27	1
66118	3917	81151	1970-05-22	1970-06-26	1
46435	2768	28060	2009-10-30	2009-11-11	1
2867	164	40481087	1990-05-13	1990-05-27	1
88301	5255	4112343	1976-09-08	1976-09-15	1
43339	2583	4112343	1980-09-29	1980-10-08	1
36286	2151	4294548	1919-06-13	1919-08-08	1
50467	2988	81151	1972-09-15	1972-09-29	1
51529	3060	81151	2002-09-13	2002-09-27	1
5830	343	4112343	1987-09-02	1987-09-13	1
2722	159	28060	1968-08-29	1968-09-05	1
85120	5068	40481087	1970-07-15	1970-08-05	1
5434	320	40479422	1974-02-22	1974-04-30	1
4485	263	40481087	1981-01-11	1981-02-01	1
6032	354	378001	1967-11-03	1968-01-02	1
20454	1231	81151	1972-03-18	1972-04-22	1
61325	3628	260139	1999-03-10	1999-03-24	1
32522	1933	372328	1959-11-21	1960-05-06	1
88066	5241	4059173	2017-05-17	2017-08-15	1
6588	388	372328	1957-08-20	1958-01-21	1
27762	1640	80180	1976-04-20	1976-04-21	1
68743	4072	260139	2002-11-10	2002-11-17	1
75342	4477	4112343	1974-03-27	1974-04-04	1
63127	3732	4112343	2010-11-01	2010-11-11	1
5036	297	40481087	1954-03-10	1954-03-24	1
29744	1761	40481087	1965-06-13	1965-06-20	1
1978	116	378419	2000-12-03	2000-12-04	1
70803	4204	4112343	1962-10-29	1962-11-11	1
35485	2105	372328	1979-09-29	1979-12-09	1
88464	5264	260139	2016-02-22	2016-02-29	1
1791	102	257012	1989-09-04	1989-10-02	1
47126	2804	40481087	1998-05-25	1998-06-15	1
46223	2757	4112343	2000-07-25	2000-08-02	1
4969	293	0	2005-10-04	2005-10-05	1
36548	2165	257012	2010-10-06	2010-10-07	1
32903	1953	372328	1969-05-06	1969-09-01	1
13355	787	4112343	2011-11-24	2011-12-07	1
66119	3917	372328	1974-12-16	1975-09-04	1
46436	2768	4027663	1998-06-03	1998-06-04	1
6991	411	260139	1961-02-11	1961-02-25	1
88302	5255	4112343	1977-01-17	1977-01-25	1
43340	2583	40481087	1982-03-17	1982-04-07	1
36287	2151	40481087	1944-06-23	1944-07-07	1
50468	2988	81151	2003-01-18	2003-02-01	1
51530	3060	260139	1987-03-09	1987-03-16	1
5831	343	4294548	1987-10-19	1987-12-07	1
2723	159	78272	1963-05-23	1963-06-27	1
85121	5068	28060	1945-08-06	1945-08-18	1
5435	320	40481087	1960-05-05	1960-05-26	1
4486	263	260139	1988-09-04	1988-09-11	1
6033	354	4112343	2004-07-09	2004-07-17	1
20455	1231	4134304	1949-11-14	1950-01-13	1
61326	3628	4112343	1955-04-28	1955-05-09	1
32523	1933	4027663	1989-05-22	1989-05-23	1
88067	5241	4112343	1975-08-27	1975-09-04	1
6589	388	378001	1968-07-23	1968-09-21	1
27763	1640	260139	1989-03-18	1989-04-01	1
68744	4072	40481087	1987-06-20	1987-07-11	1
75343	4477	4113008	1978-10-01	1978-10-22	1
63128	3732	4155034	1985-06-09	1985-06-23	1
5037	297	40481087	1956-06-16	1956-06-30	1
29745	1761	40481087	1966-06-20	1966-07-04	1
1979	116	4109685	2002-04-19	2002-05-03	1
70804	4204	4266809	1988-10-23	1988-10-24	1
35486	2105	378001	1988-09-03	1988-10-03	1
88465	5264	4112343	2008-07-18	2008-07-30	1
1792	102	4296205	1994-06-10	1994-07-15	1
47127	2804	80180	1990-06-17	1990-06-18	1
46224	2757	4278672	1976-02-15	1976-04-15	1
4970	293	80180	2006-12-22	2006-12-23	1
36549	2165	260139	1975-01-25	1975-02-01	1
32904	1953	4112343	1973-11-10	1973-11-23	1
13356	787	40481087	1985-06-17	1985-07-01	1
66120	3917	4218389	1980-12-30	1981-01-27	1
46437	2768	4152936	1988-02-15	1988-03-07	1
6992	411	260139	1973-11-17	1973-12-01	1
88303	5255	4112343	2010-09-12	2010-09-19	1
43341	2583	80180	2006-11-23	2006-11-24	1
36288	2151	40481087	1951-06-02	1951-06-23	1
50469	2988	4109685	2008-12-01	2008-12-15	1
51531	3060	372328	1926-12-14	1927-03-05	1
5832	343	40481087	1970-12-05	1970-12-26	1
2724	159	80180	1989-08-28	1989-08-29	1
85122	5068	317576	2008-11-22	2008-11-23	1
5436	320	260139	1971-09-14	1971-09-21	1
4487	263	4027663	1981-06-13	1981-06-14	1
6034	354	4113008	1968-12-27	1969-01-17	1
20456	1231	4152936	1986-10-05	1986-10-26	1
61327	3628	4112343	2003-08-06	2003-08-14	1
32524	1933	4113008	2015-05-01	2015-05-22	1
88068	5241	4112343	2012-04-02	2012-04-10	1
6590	388	4218389	1969-09-16	1969-10-14	1
27764	1640	4112343	1959-02-09	1959-02-20	1
68745	4072	40481087	2011-05-12	2011-06-02	1
75344	4477	40479422	2012-06-25	2012-08-31	1
63129	3732	4285898	1993-11-24	1993-11-25	1
5038	297	40481087	2000-08-04	2000-08-18	1
31051	1842	28060	1968-08-07	1968-08-15	1
1980	116	4112343	1959-06-11	1959-06-18	1
71143	4224	81151	2010-10-21	2010-11-04	1
35487	2105	4112343	1978-10-27	1978-11-07	1
88466	5264	4283893	2019-01-25	2019-02-22	1
1793	102	78272	1991-08-20	1991-09-24	1
47128	2804	378001	1966-04-08	1966-06-07	1
46225	2757	4294548	1974-06-05	1974-07-03	1
4971	293	4112343	1971-10-10	1971-10-23	1
36550	2165	260139	2014-07-03	2014-07-10	1
32905	1953	4278672	1964-06-17	1964-07-17	1
13357	787	80180	2017-01-07	2017-01-08	1
66121	3917	40481087	1974-09-19	1974-10-10	1
46438	2768	4155034	2010-09-08	2010-09-29	1
6993	411	260139	2012-03-25	2012-04-01	1
88304	5255	4112343	2018-06-24	2018-07-06	1
43342	2583	257012	2018-08-20	2018-08-21	1
36289	2151	81151	1926-05-31	1926-06-28	1
50470	2988	4112343	1979-08-08	1979-08-17	1
51532	3060	4112343	1952-11-14	1952-11-24	1
5833	343	40481087	1981-03-31	1981-04-14	1
2725	159	372328	1955-08-12	1955-12-27	1
85123	5068	4109685	1966-06-16	1966-06-30	1
5437	320	4152936	1995-08-08	1995-08-29	1
4488	263	4112343	2014-07-28	2014-08-05	1
6035	354	40481087	2014-01-30	2014-02-20	1
20457	1231	40481087	1977-05-09	1977-05-16	1
61328	3628	4146173	1971-05-07	1971-07-06	1
34372	2043	28060	1970-05-28	1970-06-04	1
88069	5241	4116491	2019-03-13	2019-04-18	1
6591	388	4283893	1955-07-20	1956-01-18	1
27765	1640	4113008	1992-03-17	1992-03-31	1
68746	4072	0	2004-08-31	2004-09-01	1
75345	4477	40481087	1969-06-29	1969-07-20	1
63130	3732	4310024	1992-03-04	1992-03-05	1
5039	297	28060	1970-10-27	1970-11-07	1
31052	1842	80180	2004-11-28	2004-11-29	1
1981	116	40481087	1939-04-12	1939-04-19	1
71144	4224	4112343	2008-04-13	2008-04-26	1
35488	2105	4237458	1981-02-12	1981-04-13	1
88467	5264	40481087	1983-10-26	1983-11-16	1
1794	102	372328	1974-01-16	1974-06-02	1
47129	2804	4112343	1975-09-28	1975-10-07	1
46226	2757	381316	2017-01-20	2017-01-21	1
4972	293	440448	2005-10-04	2005-10-05	1
36551	2165	372328	1954-11-28	1955-02-08	1
33785	2007	40481087	1993-03-09	1993-03-23	1
13358	787	81151	1979-07-11	1979-08-15	1
66122	3917	40481087	1982-12-12	1982-12-19	1
46439	2768	4266809	2010-07-15	2010-07-16	1
6994	411	378001	2005-05-11	2005-07-10	1
88305	5255	80180	1996-08-26	1996-08-27	1
43343	2583	4112343	1999-10-12	1999-10-25	1
36290	2151	260139	1954-09-02	1954-09-16	1
50471	2988	4112343	1998-06-10	1998-06-17	1
51533	3060	4112343	1971-12-29	1972-01-09	1
5834	343	40481087	1989-05-08	1989-05-22	1
2726	159	4218389	1962-04-07	1962-04-28	1
85124	5068	4112343	1973-07-07	1973-07-19	1
5438	320	4218389	1998-06-14	1998-07-12	1
4489	263	81151	1958-03-31	1958-04-14	1
6036	354	40481087	2018-07-20	2018-08-03	1
20458	1231	28060	1955-04-11	1955-04-20	1
61329	3628	4329847	2006-08-19	2006-08-20	1
34373	2043	4283893	1974-12-08	1975-03-30	1
88070	5241	40481087	1965-04-16	1965-04-23	1
6592	388	40481087	2007-07-16	2007-07-23	1
27766	1640	28060	1948-05-11	1948-05-24	1
68747	4072	260139	2010-10-28	2010-11-11	1
75346	4477	40481087	1974-08-02	1974-08-23	1
63131	3732	40481087	1956-01-18	1956-01-25	1
5040	297	260139	2010-02-12	2010-02-19	1
31053	1842	40481087	1974-12-09	1974-12-23	1
1982	116	28060	1934-05-10	1934-05-23	1
71145	4224	4112343	2016-02-18	2016-02-27	1
35489	2105	40481087	1977-06-12	1977-07-03	1
88468	5264	40481087	1996-10-07	1996-10-28	1
1795	102	4112343	2014-08-02	2014-08-12	1
47130	2804	4112343	1997-08-14	1997-08-21	1
46227	2757	4112343	1977-12-11	1977-12-19	1
4973	293	4294548	1995-08-08	1995-08-22	1
36552	2165	4112343	1982-10-18	1982-10-25	1
33786	2007	0	1994-07-17	1994-07-18	1
13359	787	260139	1978-02-17	1978-02-24	1
66123	3917	313217	2014-02-27	2014-02-28	1
46440	2768	40481087	1992-09-04	1992-09-18	1
6995	411	40481087	1968-09-28	1968-10-12	1
88306	5255	81151	1965-08-08	1965-09-12	1
43344	2583	4166224	2001-06-08	2001-06-09	1
36291	2151	260139	1967-06-08	1967-06-22	1
50472	2988	4149245	1993-01-03	1993-03-11	1
51534	3060	4278672	1994-08-26	1994-09-25	1
5835	343	40481087	2010-10-14	2010-10-21	1
2727	159	40479422	1997-12-23	1998-02-28	1
85125	5068	4112343	1974-04-16	1974-04-28	1
5439	320	4237458	1959-11-30	1960-01-29	1
4490	263	313217	2016-08-28	2016-08-29	1
6719	398	0	1967-02-11	1967-02-12	1
20459	1231	260139	1957-07-07	1957-07-21	1
61330	3628	40481087	1929-07-09	1929-07-16	1
34374	2043	40481087	1995-04-17	1995-04-24	1
88071	5241	40481087	2000-02-17	2000-03-02	1
8521	498	80180	2010-06-09	2010-06-10	1
27767	1640	80502	1996-05-08	1996-05-09	1
68748	4072	372328	1975-02-04	1975-05-17	1
75347	4477	40481087	2002-12-13	2002-12-20	1
63132	3732	40481087	1960-12-08	1960-12-22	1
5041	297	4112343	1965-05-23	1965-05-30	1
31054	1842	40481087	1975-12-26	1976-01-09	1
1983	116	78272	1936-02-18	1936-03-24	1
71146	4224	4310024	1984-08-27	1984-08-28	1
35490	2105	40481087	1988-12-15	1988-12-22	1
88469	5264	4112343	1969-06-23	1969-07-01	1
1796	102	4283893	1989-07-03	1989-10-02	1
47131	2804	4112343	1999-06-14	1999-06-24	1
46228	2757	4278672	1978-03-06	1978-06-04	1
4974	293	260139	1983-08-22	1983-08-29	1
36553	2165	4146173	2009-12-07	2010-01-13	1
33787	2007	78272	2014-09-06	2014-10-11	1
13360	787	378001	1987-01-05	1987-03-06	1
66124	3917	4112343	1971-04-20	1971-05-01	1
46441	2768	30753	2009-05-21	2009-05-22	1
6996	411	40481087	1991-11-18	1991-12-09	1
88307	5255	81893	1994-06-08	1994-06-09	1
44613	2657	0	1970-09-05	1970-09-06	1
36292	2151	317576	1988-07-13	1988-07-14	1
50473	2988	40481087	1968-03-10	1968-03-31	1
51535	3060	4310024	1959-07-19	1959-07-20	1
5836	343	40481087	2017-06-10	2017-06-24	1
2728	159	78272	2013-11-06	2013-12-11	1
85126	5068	4112343	1998-04-05	1998-04-13	1
5440	320	40481087	1956-08-25	1956-09-15	1
4491	263	372328	1960-02-12	1960-06-05	1
6720	398	260139	1925-02-26	1925-03-05	1
20460	1231	260139	1968-04-21	1968-05-06	1
61331	3628	40481087	1955-06-08	1955-06-29	1
34375	2043	40481087	1997-04-21	1997-05-12	1
88072	5241	28060	1996-01-20	1996-02-01	1
8522	498	4112343	1972-06-14	1972-06-22	1
27768	1640	378419	2013-08-21	2013-08-22	1
68749	4072	372328	2010-01-18	2010-02-01	1
75348	4477	40481087	2010-10-06	2010-10-13	1
63133	3732	81893	1992-10-30	1992-10-31	1
5042	297	4112343	1970-05-20	1970-05-29	1
31055	1842	40481087	1999-06-05	1999-06-19	1
1984	116	260139	1938-03-10	1938-03-24	1
71147	4224	40479422	1950-11-14	1951-01-20	1
35491	2105	30753	2011-08-04	2011-08-05	1
88470	5264	4112343	2018-01-12	2018-01-21	1
1797	102	40481087	2016-11-15	2016-12-06	1
47132	2804	4152936	1988-03-20	1988-04-10	1
46229	2757	4294548	1982-05-29	1982-06-19	1
4975	293	4237458	1978-04-03	1978-07-02	1
36554	2165	4294548	2000-08-07	2000-09-25	1
33788	2007	80180	2018-08-21	2018-08-22	1
13361	787	4112343	1978-09-26	1978-10-04	1
66125	3917	4283893	1983-06-22	1984-08-22	1
46442	2768	372328	1973-12-16	1974-05-21	1
6997	411	28060	1963-11-28	1963-12-05	1
88308	5255	133834	1964-02-08	1977-03-01	1
44614	2657	80180	2000-05-19	2000-05-20	1
36293	2151	4112343	1925-07-06	1925-07-16	1
50474	2988	28060	1972-10-18	1972-10-25	1
51536	3060	40481087	1924-10-02	1924-10-09	1
5837	343	260139	1988-11-25	1988-12-09	1
2729	159	317576	1985-03-19	1985-03-20	1
85127	5068	40481087	1982-06-09	1982-06-23	1
8071	474	28060	1982-12-04	1982-12-16	1
4492	263	4059173	2010-11-05	2011-01-04	1
6721	398	4218389	1941-08-30	1941-09-20	1
20461	1231	260139	1977-02-04	1977-02-18	1
61332	3628	40481087	1985-01-31	1985-02-07	1
34376	2043	40481087	2000-12-01	2000-12-22	1
88073	5241	28060	2005-10-14	2005-10-24	1
8523	498	40481087	1982-02-20	1982-03-06	1
27769	1640	4112343	1968-03-08	1968-03-18	1
68750	4072	440448	2004-08-31	2004-09-01	1
75349	4477	4294548	1987-09-15	1987-12-01	1
63134	3732	4112343	1961-07-16	1961-07-23	1
5043	297	4112343	2015-09-16	2015-09-29	1
31056	1842	40481087	2007-06-01	2007-06-08	1
1985	116	4112343	1931-10-13	1931-10-21	1
71148	4224	40481087	1965-01-06	1965-01-27	1
35492	2105	80180	2013-01-25	2013-01-26	1
88471	5264	40481087	1971-08-16	1971-08-23	1
1798	102	260139	2010-03-10	2010-03-24	1
47133	2804	40481087	1964-01-10	1964-01-17	1
46230	2757	4294548	2006-04-19	2006-07-19	1
4976	293	4294548	2014-09-05	2014-09-12	1
38445	2287	80180	1982-05-10	1982-05-11	1
33789	2007	321042	1994-07-17	1994-07-18	1
13362	787	40481087	2012-07-19	2012-07-26	1
68493	4055	30753	2006-05-26	2006-05-27	1
46443	2768	40481087	1972-01-04	1972-01-18	1
6998	411	80180	2003-03-02	2003-03-03	1
88309	5255	260139	1984-11-22	1984-11-29	1
44615	2657	257012	2009-03-08	2009-03-09	1
36294	2151	4294548	1946-01-06	1946-02-10	1
50475	2988	4027663	1990-06-03	1990-06-04	1
51537	3060	40481087	1925-04-16	1925-04-30	1
5838	343	4027663	1998-01-24	1998-01-25	1
2730	159	372328	1959-07-09	1959-12-22	1
85128	5068	260139	1969-10-26	1969-11-09	1
8072	474	4112343	1998-04-12	1998-04-21	1
4493	263	4112343	1997-08-01	1997-08-12	1
6722	398	28060	1940-04-08	1940-04-18	1
20462	1231	378001	1979-12-10	1980-01-09	1
61333	3628	0	2006-08-19	2006-08-20	1
34377	2043	40481087	2012-04-21	2012-04-28	1
88074	5241	81151	1987-03-14	1987-04-11	1
8524	498	78272	1977-08-16	1977-09-20	1
27770	1640	4112343	1987-09-09	1987-09-22	1
68751	4072	4112343	2006-01-24	2006-02-03	1
75350	4477	81151	1964-09-16	1964-10-14	1
63135	3732	4112343	1972-09-25	1972-10-07	1
5044	297	4218389	1986-07-13	1986-08-17	1
31057	1842	28060	1997-08-08	1997-08-17	1
1986	116	4294548	1994-04-25	1994-05-30	1
71149	4224	40481087	1968-12-13	1968-12-27	1
35493	2105	81893	2011-05-06	2011-05-07	1
88472	5264	40481087	2005-06-22	2005-06-29	1
1799	102	4112343	1991-03-22	1991-04-03	1
47134	2804	40481087	2002-05-30	2002-06-13	1
46231	2757	40481087	2007-08-05	2007-08-26	1
4977	293	40481087	2004-03-12	2004-03-26	1
38446	2287	260139	1958-04-28	1958-05-05	1
33790	2007	372328	1987-12-27	1988-01-10	1
13363	787	40481087	1985-08-05	1985-08-19	1
68494	4055	78272	1980-01-08	1980-01-29	1
49524	2933	4112343	1954-07-25	1954-08-04	1
6999	411	260139	1982-06-01	1982-06-15	1
88310	5255	372328	1961-05-17	1961-05-31	1
44616	2657	321042	1970-09-05	1970-09-06	1
36295	2151	4329847	1999-12-08	1999-12-09	1
50476	2988	4112343	1974-01-20	1974-02-02	1
51538	3060	40481087	1932-03-08	1932-03-22	1
5839	343	4084167	1971-02-25	1971-02-25	1
2731	159	40481087	1980-03-08	1980-03-29	1
85129	5068	260139	1975-07-19	1975-08-02	1
8073	474	4294548	1975-07-21	1975-08-11	1
4494	263	4112343	2002-12-16	2002-12-24	1
6723	398	78272	1966-08-29	1966-09-26	1
20463	1231	4112343	1960-01-25	1960-02-06	1
61334	3628	260139	1931-02-06	1931-02-20	1
34378	2043	260139	1966-09-15	1966-09-29	1
88075	5241	260139	2017-03-18	2017-03-25	1
8525	498	260139	1988-02-06	1988-02-13	1
27771	1640	4112343	1996-01-24	1996-02-06	1
68752	4072	40481087	2012-08-03	2012-08-17	1
75351	4477	4059173	1967-08-30	1967-09-29	1
63136	3732	4278672	1958-04-02	1958-07-01	1
5045	297	40481087	2018-11-26	2018-12-17	1
31058	1842	4285898	2004-07-01	2004-07-02	1
1987	116	40481087	1963-08-11	1963-08-18	1
71150	4224	40481087	1976-04-28	1976-05-12	1
35494	2105	4027663	2001-08-11	2001-08-12	1
88473	5264	372328	1968-08-26	1968-10-08	1
1800	102	4218389	1983-06-28	1983-08-02	1
48883	2897	78272	1970-11-23	1970-12-28	1
46232	2757	40481087	2014-09-27	2014-10-18	1
5764	339	372328	1987-11-09	1988-07-30	1
38447	2287	260139	1984-12-13	1984-12-20	1
33791	2007	372328	1991-11-25	1992-10-18	1
13364	787	40481087	2007-08-22	2007-09-05	1
68495	4055	81893	2006-02-25	2006-02-26	1
49525	2933	4112343	2011-07-24	2011-07-31	1
7000	411	4048171	1961-02-27	1993-07-17	1
44617	2657	4112343	1968-01-29	1968-02-10	1
36296	2151	40481087	1923-12-07	1923-12-28	1
50477	2988	4112343	2003-02-07	2003-02-15	1
51539	3060	40481087	1964-08-20	1964-09-10	1
5840	343	4112343	1998-01-22	1998-02-04	1
2732	159	81151	1976-05-19	1976-06-16	1
85130	5068	313217	2009-11-28	2009-11-29	1
8074	474	28060	2002-03-03	2002-03-13	1
4495	263	40481087	1958-09-02	1958-09-09	1
6724	398	317576	1947-12-06	1947-12-07	1
20464	1231	4112343	1978-04-15	1978-04-24	1
61335	3628	260139	1965-10-25	1965-11-01	1
34379	2043	260139	1995-09-23	1995-09-30	1
88076	5241	372328	1962-04-26	1962-07-03	1
8526	498	4112343	1998-02-07	1998-02-16	1
30004	1778	4266809	2017-09-25	2017-09-26	1
68753	4072	260139	1995-10-18	1995-11-01	1
75352	4477	4237458	1970-10-13	1970-11-12	1
63137	3732	4296204	1999-01-09	1999-02-06	1
5046	297	4112343	1976-12-09	1976-12-21	1
31059	1842	40481087	2001-02-13	2001-02-27	1
1988	116	28060	1937-07-25	1937-08-01	1
71151	4224	260139	1973-12-15	1973-12-29	1
35495	2105	4112343	2012-07-10	2012-07-20	1
88474	5264	4112343	2002-07-09	2002-07-17	1
1801	102	40481087	2004-07-22	2004-08-12	1
48884	2897	81893	2001-07-19	2001-07-20	1
54932	3254	81151	1974-09-04	1974-09-18	1
5765	339	440086	1992-08-11	2000-08-19	1
38448	2287	4112343	2008-12-31	2009-01-10	1
33792	2007	260139	2015-01-14	2015-01-28	1
14718	869	80180	1949-11-23	1949-11-24	1
68496	4055	4027663	1996-10-30	1996-10-31	1
49526	2933	40481087	2017-08-23	2017-08-30	1
7001	411	4112343	1975-05-27	1975-06-03	1
44618	2657	4149245	2016-01-16	2016-02-22	1
36297	2151	40481087	1980-01-29	1980-02-05	1
50478	2988	4283893	1986-08-02	1986-08-30	1
51540	3060	80180	1961-02-08	1961-02-09	1
5841	343	4112343	2013-02-17	2013-02-26	1
2733	159	4112343	1968-04-20	1968-04-30	1
85131	5068	372328	1933-10-07	1933-11-25	1
8075	474	372328	1974-02-21	1974-11-24	1
4496	263	40481087	1963-04-25	1963-05-02	1
6725	398	4152936	1955-07-09	1955-07-30	1
20465	1231	4112343	2015-03-31	2015-04-08	1
61336	3628	372328	1917-01-29	1917-08-04	1
34380	2043	40481087	1976-07-28	1976-08-04	1
88077	5241	372328	1981-10-21	1984-05-29	1
8527	498	4112343	2016-06-12	2016-06-24	1
30005	1778	4285898	2017-03-29	2017-03-30	1
68754	4072	372328	1980-06-19	1980-08-23	1
75353	4477	40481087	1988-05-04	1988-05-25	1
65695	3889	28060	1966-02-25	1966-03-07	1
5047	297	40481087	1974-12-27	1975-01-10	1
31060	1842	260139	1981-07-29	1981-08-12	1
1989	116	28060	2004-10-03	2004-10-14	1
71152	4224	40481087	1959-04-08	1959-04-29	1
35496	2105	4155034	2008-06-04	2008-06-18	1
88475	5264	4237458	1977-09-08	1977-12-07	1
1802	102	80180	2008-12-03	2008-12-04	1
48885	2897	260139	1979-03-17	1979-03-31	1
54933	3254	372328	1963-12-31	1964-05-10	2
5766	339	4112343	1993-04-22	1993-05-03	1
38449	2287	4283893	1946-01-05	1946-02-23	1
33793	2007	4112343	2002-11-22	2002-12-01	1
14719	869	260139	1998-08-10	1998-08-17	1
68497	4055	4112343	1984-08-17	1984-08-29	1
49527	2933	81151	1958-08-29	1958-09-26	1
7002	411	4112343	1982-03-01	1982-03-09	1
44619	2657	378001	1971-08-10	1971-10-09	1
36298	2151	81151	1963-02-14	1963-02-28	1
50479	2988	40481087	1979-11-08	1979-11-29	1
51541	3060	260139	1928-07-23	1928-08-06	1
5842	343	4310024	2003-03-24	2003-03-25	1
2734	159	4112343	1971-05-24	1971-06-05	1
85132	5068	381316	2009-07-11	2009-07-12	1
8076	474	4027663	1996-12-07	1996-12-08	1
4497	263	40481087	2002-01-21	2002-02-11	1
6726	398	4329847	1967-02-11	1967-02-12	1
20466	1231	28060	1970-09-15	1970-09-22	1
61337	3628	4296204	1973-04-26	1973-05-31	1
34381	2043	80180	1997-08-21	1997-08-22	1
88078	5241	40481087	2001-01-04	2001-01-18	1
8528	498	40481087	1987-10-28	1987-11-11	1
30006	1778	260139	2017-10-01	2017-10-15	1
68755	4072	4113008	2013-12-09	2013-12-23	1
75354	4477	40481087	2006-08-06	2006-08-20	1
65696	3889	81151	2018-05-06	2018-05-27	1
5048	297	40481087	2009-02-06	2009-02-27	1
31061	1842	4027663	1994-08-13	1994-08-14	1
1990	116	192671	1970-03-12	1970-03-13	1
71153	4224	40481087	1979-01-06	1979-01-27	1
35497	2105	4285898	2012-06-29	2012-06-30	1
88476	5264	4283893	2012-11-27	2012-12-18	1
7410	437	80180	1987-07-22	1987-07-23	1
48886	2897	260139	1985-12-30	1986-01-13	1
54934	3254	372328	1967-03-26	1967-05-07	1
5767	339	4112343	1996-12-16	1996-12-23	1
38450	2287	4329847	2001-01-26	2001-01-27	1
33794	2007	40481087	2004-01-31	2004-02-14	1
14720	869	372328	1914-09-16	1914-11-20	1
68498	4055	4112343	1996-06-08	1996-06-20	1
49528	2933	317576	2011-10-10	2011-10-11	1
7003	411	4237458	1980-08-29	1980-09-28	1
44620	2657	40481087	2003-04-01	2003-04-15	1
36299	2151	40481087	1930-01-01	1930-01-08	1
52035	3084	260139	1982-03-03	1982-03-17	1
51542	3060	260139	1932-12-16	1932-12-23	1
5843	343	40481087	2007-08-11	2007-08-25	1
2735	159	4112343	1994-08-19	1994-08-27	1
85133	5068	4112343	1931-08-20	1931-08-27	1
8077	474	4112343	1980-08-02	1980-08-14	1
6273	369	80180	2016-10-14	2016-10-15	1
6727	398	260139	1927-08-23	1927-08-30	1
20467	1231	28060	1989-06-27	1989-07-04	1
61338	3628	40481087	1939-03-04	1939-03-25	1
34382	2043	257012	1975-01-19	1975-01-20	1
8529	498	4155034	2007-05-16	2007-06-06	1
30007	1778	372328	1983-04-02	1983-04-23	1
68756	4072	4134304	1977-10-21	1977-12-20	1
75355	4477	28060	1971-11-24	1971-12-05	1
65697	3889	40481087	1994-10-23	1994-11-06	1
5049	297	40481087	2010-07-28	2010-08-18	1
31062	1842	4112343	2000-11-02	2000-11-12	1
1991	116	257012	1977-07-11	1977-07-12	1
71154	4224	40481087	1981-03-24	1981-03-31	1
35498	2105	40481087	2010-12-21	2011-01-04	1
54646	3237	4134304	1971-01-27	1971-02-26	1
7411	437	260139	1950-01-23	1950-02-06	1
48887	2897	440086	1974-06-01	1978-06-10	1
54935	3254	40481087	1968-06-15	1968-06-29	1
5768	339	4112343	1997-03-25	1997-04-05	1
38451	2287	40481087	1956-03-09	1956-03-23	1
33795	2007	28060	1994-05-27	1994-06-06	1
14721	869	4001336	2017-10-15	2017-12-14	1
68499	4055	4266809	2007-02-20	2007-02-21	1
49529	2933	372328	1955-11-13	1956-04-30	1
7004	411	40481087	2017-09-20	2017-10-04	1
44621	2657	4112343	1977-12-20	1977-12-31	1
36300	2151	40481087	1940-11-18	1940-12-02	1
52036	3084	4112343	2019-06-14	2019-06-21	1
51543	3060	260139	1991-11-21	1991-11-28	1
5844	343	40481087	2016-09-24	2016-10-08	1
2736	159	4112343	1997-12-11	1997-12-21	1
85134	5068	4112343	1937-11-05	1937-11-12	1
8078	474	40481087	1978-11-15	1978-12-06	1
6274	369	81151	1993-11-19	1993-12-03	1
6728	398	260139	1948-02-13	1948-02-27	1
20468	1231	80180	1978-01-21	1978-01-22	1
61339	3628	80180	1954-03-07	1954-03-08	1
34383	2043	4112343	1978-10-21	1978-11-01	1
8530	498	260139	1972-04-16	1972-04-30	1
30008	1778	4027663	2010-05-10	2010-05-11	1
68757	4072	40481087	1981-10-05	1981-10-19	1
75356	4477	28060	1975-08-28	1975-09-04	1
65698	3889	40481087	2005-01-15	2005-02-05	1
5050	297	80180	1993-08-25	1993-08-26	1
31063	1842	4218389	1986-05-02	1986-05-30	1
1992	116	260139	1980-01-25	1980-02-01	1
71155	4224	40481087	2003-08-09	2003-08-30	1
35499	2105	40481087	2018-01-26	2018-02-02	1
54647	3237	40481087	1931-06-24	1931-07-01	1
7412	437	372328	1951-08-30	1952-01-29	1
48888	2897	4218389	1979-03-16	1979-04-20	1
54936	3254	40481087	1977-05-13	1977-06-03	1
5769	339	4112343	2002-11-08	2002-11-18	1
38452	2287	40481087	1962-08-18	1962-08-25	1
33796	2007	260139	1993-07-29	1993-08-05	1
14722	869	4109685	1947-02-06	1947-02-20	1
68500	4055	4310024	2005-11-27	2005-11-28	1
49530	2933	4112343	1978-07-08	1978-07-16	1
7005	411	28060	1964-01-07	1964-01-14	1
44622	2657	4112343	2002-02-25	2002-03-05	1
36301	2151	40481087	1974-11-25	1974-12-09	1
52037	3084	4112343	1993-10-04	1993-10-16	1
51544	3060	260139	1994-03-18	1994-03-25	1
5845	343	80180	2005-09-09	2005-09-10	1
2737	159	4112343	1999-03-17	1999-03-28	1
85135	5068	40481087	1931-11-23	1931-11-30	1
8079	474	40481087	2008-05-11	2008-05-18	1
6275	369	260139	2014-09-18	2014-10-02	1
6729	398	4296205	1957-04-20	1957-05-18	1
20469	1231	195588	1965-01-04	1965-02-27	1
61340	3628	260139	1920-04-30	1920-05-14	1
34384	2043	4112343	2005-04-15	2005-04-23	1
8531	498	372328	1974-08-02	1974-10-31	1
30009	1778	40481087	1984-01-02	1984-01-09	1
68758	4072	40481087	1998-01-21	1998-02-11	1
75357	4477	80180	2005-08-27	2005-08-28	1
65699	3889	40481087	2016-02-02	2016-02-23	1
5051	297	195588	1995-06-06	1995-07-09	1
31064	1842	40481087	1991-04-29	1991-05-13	1
1993	116	372328	1929-05-08	1929-10-13	1
71156	4224	260139	1978-07-24	1978-08-07	1
35500	2105	81151	1994-07-04	1994-07-18	1
54648	3237	40481087	1934-02-04	1934-02-25	1
7413	437	4027663	1978-02-04	1978-02-05	1
48889	2897	4230399	2017-11-15	2017-12-15	1
54937	3254	40481087	1987-12-17	1987-12-24	1
5770	339	4237458	1994-08-09	1994-09-08	1
38453	2287	40481087	2002-08-17	2002-09-07	1
33797	2007	372328	1988-11-05	1989-04-09	1
14723	869	4112343	1950-07-15	1950-07-26	1
68501	4055	260139	2013-12-23	2014-01-06	1
49531	2933	40481087	1987-09-20	1987-10-04	1
7006	411	28060	1995-11-07	1995-11-19	1
44623	2657	4283893	2013-06-05	2013-07-03	1
36302	2151	40481087	1975-03-14	1975-04-04	1
52038	3084	4112343	2010-01-17	2010-01-28	1
51545	3060	381316	2003-01-25	2003-01-26	1
5846	343	81893	2003-09-20	2003-09-21	1
2738	159	4142905	1984-04-05	1984-06-04	1
85136	5068	28060	1956-09-14	1956-09-23	1
8080	474	28060	1976-02-14	1976-02-22	1
6276	369	372328	1982-03-22	1982-06-05	1
6730	398	40481087	1954-05-01	1954-05-08	1
20470	1231	260139	1960-07-15	1960-07-29	1
61341	3628	317576	2002-04-13	2002-04-14	1
34385	2043	4112343	2018-01-19	2018-01-31	1
8532	498	40481087	1978-02-20	1978-03-06	1
30010	1778	40481087	2016-11-16	2016-12-07	1
73472	4373	4112343	1978-06-09	1978-06-19	1
75358	4477	378001	1986-06-12	1986-07-12	1
65700	3889	40481087	2018-12-16	2018-12-23	1
5052	297	260139	1953-01-09	1953-01-23	1
31065	1842	372328	1967-02-11	1967-07-28	1
1994	116	4112343	1934-07-25	1934-08-07	1
71157	4224	260139	2008-12-14	2008-12-21	1
35501	2105	260139	1978-11-27	1978-12-04	1
54649	3237	78272	2012-02-19	2012-03-11	1
7414	437	4112343	2003-09-26	2003-10-05	1
48890	2897	4285898	2003-04-10	2003-04-11	1
54938	3254	40481087	1990-01-20	1990-02-10	1
5771	339	40481087	2016-08-19	2016-09-02	1
38454	2287	40481087	2012-12-19	2012-12-26	1
33798	2007	40481087	1996-11-08	1996-11-29	1
14724	869	4112343	1993-01-23	1993-01-30	1
68502	4055	372328	1970-07-29	1970-10-14	1
49532	2933	40481087	2000-09-30	2000-10-21	1
7007	411	260139	1970-08-03	1970-08-17	1
44624	2657	4294548	2009-01-18	2009-08-16	1
40247	2392	78272	1940-07-02	1940-07-23	1
52039	3084	4155034	1980-08-09	1980-08-30	1
51546	3060	4112343	1944-05-20	1944-05-27	1
5847	343	4084167	1972-10-19	1972-10-19	1
2739	159	40481087	1992-11-27	1992-12-11	1
85137	5068	28060	1984-12-02	1984-12-10	1
8081	474	80180	2005-08-17	2005-08-18	1
6277	369	4283893	1991-06-21	1991-10-18	1
6731	398	80180	1962-03-08	1962-03-09	1
20471	1231	4112343	1958-05-09	1958-05-18	1
61342	3628	4109685	1987-09-15	1987-09-29	1
34386	2043	4283893	2004-09-08	2004-11-24	1
8533	498	40481087	1982-11-09	1982-11-16	1
30011	1778	80180	2017-09-25	2017-09-26	1
73473	4373	192671	2018-02-04	2018-02-05	1
75359	4477	4310024	2002-12-11	2002-12-12	1
65701	3889	80180	1976-03-21	1976-03-22	1
5053	297	260139	1999-11-21	1999-12-05	1
31066	1842	4112343	1990-03-25	1990-04-01	1
1995	116	4142905	1944-10-08	1944-12-07	1
71158	4224	372328	1951-02-12	1951-12-26	1
35502	2105	260139	2015-03-06	2015-03-20	1
54650	3237	378419	2006-04-26	2006-04-27	1
7415	437	4278672	2017-11-06	2018-01-05	1
48891	2897	4294548	2013-06-23	2013-06-30	1
54939	3254	40481087	2006-09-01	2006-09-08	1
5772	339	260139	1993-05-19	1993-06-02	1
38455	2287	0	2001-01-26	2001-01-27	1
37078	2199	0	1995-07-19	1995-07-20	1
14725	869	4112343	2007-06-18	2007-06-29	1
68503	4055	40481087	1997-07-01	1997-07-08	1
49533	2933	28060	1957-10-31	1957-11-08	1
7008	411	260139	2005-10-13	2005-10-27	1
44625	2657	40481087	2000-01-18	2000-02-08	1
40248	2392	81151	1974-06-16	1974-07-07	1
52040	3084	40481087	2003-07-24	2003-08-14	1
51547	3060	4266809	1961-02-08	1961-02-09	1
5848	343	4285898	2004-11-13	2004-11-14	1
2740	159	260139	1971-12-17	1971-12-31	1
85138	5068	260139	1962-04-09	1962-04-16	1
8082	474	81151	1982-12-02	1982-12-16	1
6278	369	40481087	2006-04-08	2006-04-29	1
6732	398	372328	1925-12-22	1926-02-06	1
20472	1231	4112343	2018-09-23	2018-10-04	1
61343	3628	4112343	1952-10-28	1952-11-07	1
34387	2043	4294548	2017-10-08	2017-10-15	1
9215	546	30753	1980-11-29	1980-11-30	1
30012	1778	81893	2016-07-02	2016-07-03	1
73474	4373	372328	1978-10-06	1978-12-12	1
75360	4477	40481087	1982-11-18	1982-12-02	1
65702	3889	260139	1943-11-12	1943-11-26	1
5054	297	4218389	2011-04-08	2011-05-13	1
31067	1842	4112343	1991-09-24	1991-10-06	1
1996	116	4152936	2001-03-04	2001-03-25	1
71159	4224	4027663	1978-01-01	1978-01-02	1
35503	2105	4112343	1996-07-22	1996-08-02	1
54651	3237	4112343	1985-09-10	1985-09-21	1
7416	437	40481087	1965-03-03	1965-03-24	1
48892	2897	40481087	1961-01-07	1961-01-14	1
54940	3254	4112343	2018-10-14	2018-10-22	1
5773	339	372328	1984-10-02	1985-01-19	1
38456	2287	0	2014-01-24	2014-01-25	1
37079	2199	28060	1996-01-02	1996-01-10	1
14726	869	40481087	1918-03-27	1918-04-03	1
68504	4055	80180	2007-02-20	2007-02-21	1
49534	2933	81151	1978-06-13	1978-06-27	1
7009	411	378001	1995-06-03	1995-08-02	1
44626	2657	28060	1989-08-15	1989-08-23	1
40249	2392	257012	1978-11-05	1978-11-06	1
52041	3084	321042	2015-10-21	2015-10-22	1
51548	3060	40481087	1932-11-25	1932-12-02	1
5849	343	40481087	1996-03-21	1996-04-04	1
2741	159	260139	1997-08-18	1997-08-25	1
85139	5068	372328	1936-09-10	1937-06-05	1
8083	474	81893	2003-08-28	2003-08-29	1
6279	369	40481087	2012-05-05	2012-05-12	1
6733	398	4112343	1964-11-12	1964-11-19	1
20473	1231	4142905	2000-11-01	2001-01-30	1
61344	3628	4112343	1971-12-23	1972-01-05	1
34388	2043	40481087	1985-10-24	1985-11-14	1
9216	546	257012	1947-07-08	1947-07-09	1
30013	1778	4112343	1997-02-21	1997-03-02	1
73475	4373	4027663	2005-12-29	2005-12-30	1
75727	4497	28060	1963-08-04	1963-08-14	1
65703	3889	260139	2004-03-09	2004-03-16	1
5055	297	40481087	1964-10-23	1964-11-13	1
31420	1860	0	1985-11-11	1985-11-12	1
1997	116	4237458	1964-06-16	1964-09-14	1
71160	4224	4048171	1951-01-15	1993-07-14	1
35504	2105	4310024	2011-02-05	2011-02-06	1
54652	3237	4146173	1945-10-21	1945-12-20	1
7417	437	40481087	1976-01-04	1976-01-25	1
48893	2897	40481087	1984-07-26	1984-08-09	1
54941	3254	40481087	1975-11-28	1975-12-19	1
5774	339	257012	1995-01-23	1995-01-24	1
38457	2287	28060	1969-09-06	1969-09-17	1
37080	2199	4112343	1980-02-21	1980-03-01	1
14727	869	40481087	1971-04-03	1971-04-10	1
68505	4055	378001	1975-08-02	1975-09-01	1
49535	2933	4112343	1956-09-25	1956-10-04	1
7010	411	4112343	1971-10-05	1971-10-14	1
44627	2657	372328	2011-07-11	2012-06-30	1
40250	2392	260139	1958-07-23	1958-07-30	1
52042	3084	40481087	1980-07-15	1980-08-05	1
51549	3060	40481087	1966-05-07	1966-05-21	1
5850	343	30753	2004-06-16	2004-06-17	1
2742	159	4112343	1990-06-29	1990-07-10	1
85140	5068	375671	1977-02-02	1977-04-03	1
8084	474	4112343	1993-05-23	1993-06-05	1
6280	369	4109685	1997-02-15	1997-03-01	1
6734	398	40481087	1957-05-31	1957-06-07	1
20474	1231	40481087	1965-03-30	1965-04-13	1
61345	3628	4112343	2005-07-07	2005-07-19	1
34389	2043	40481087	1988-04-09	1988-04-16	1
9217	546	260139	1950-12-28	1951-01-04	1
30014	1778	4112343	1998-01-29	1998-02-06	1
73476	4373	40481087	1979-08-23	1979-08-30	1
75728	4497	260139	1978-03-06	1978-03-20	1
65704	3889	313217	2003-10-12	2003-10-13	1
5056	297	40481087	2005-08-29	2005-09-19	1
31421	1860	260139	1971-04-24	1971-05-08	1
1998	116	4283893	1977-06-13	1977-07-25	1
71161	4224	4109685	1956-01-24	1956-02-07	1
35505	2105	40481087	1982-05-06	1982-05-13	1
54653	3237	4296205	1986-05-08	1986-06-05	1
7418	437	372328	1947-06-07	1947-07-22	1
48894	2897	40481087	2012-11-13	2012-11-20	1
54942	3254	40481087	1976-09-22	1976-10-06	1
5775	339	260139	1996-02-28	1996-03-06	1
38458	2287	81151	1987-12-12	1988-01-09	1
37081	2199	4112343	1993-09-05	1993-09-12	1
14728	869	40481087	1979-04-04	1979-04-25	1
68506	4055	4296204	1997-06-28	1997-07-12	1
49536	2933	4112343	1958-01-09	1958-01-22	1
7011	411	4112343	2001-02-24	2001-03-08	1
44628	2657	4112343	1980-02-22	1980-03-01	1
40251	2392	439777	1939-01-29	1939-01-30	1
52043	3084	40481087	1982-05-02	1982-05-16	1
51550	3060	40481087	1978-01-14	1978-01-28	1
5851	343	192671	2005-11-12	2005-11-13	1
2743	159	4112343	2007-03-17	2007-03-25	1
85141	5068	4112343	1946-12-15	1946-12-24	1
8085	474	4112343	2015-05-05	2015-05-14	1
6281	369	4156265	2013-03-07	2013-03-28	1
9331	552	28060	1954-02-08	1954-02-18	1
20475	1231	40481087	1968-08-05	1968-08-19	1
61346	3628	4278672	1985-09-25	1985-10-25	1
34390	2043	260139	1973-12-30	1974-01-06	1
9218	546	260139	1990-04-22	1990-04-29	1
30015	1778	4142905	1993-07-08	1993-09-06	1
73477	4373	40481087	2011-07-28	2011-08-11	1
75729	4497	260139	1996-04-13	1996-04-27	1
65705	3889	4112343	1939-04-07	1939-04-14	1
5057	297	40481087	2014-01-08	2014-01-15	1
31422	1860	4112343	1966-11-15	1966-11-26	1
1999	116	40481087	1943-10-30	1943-11-20	1
71162	4224	4112343	1955-09-23	1955-10-01	1
35506	2105	40481087	2000-06-20	2000-07-11	1
54654	3237	40481087	1931-10-04	1931-10-11	1
7419	437	4112343	2005-01-28	2005-02-10	1
48895	2897	28060	1983-12-13	1983-12-21	1
54943	3254	40481087	2001-07-17	2001-08-07	1
5776	339	260139	2008-12-13	2008-12-27	1
38459	2287	260139	1981-01-06	1981-01-20	1
37082	2199	40481087	1982-07-11	1982-08-01	1
14729	869	40481087	2005-03-31	2005-04-07	1
68507	4055	40481087	1969-02-10	1969-03-03	1
49537	2933	40481087	1981-10-25	1981-11-15	1
7012	411	4112343	2007-12-03	2007-12-10	1
44629	2657	4112343	1995-05-25	1995-06-01	1
40252	2392	4112343	1928-06-17	1928-06-28	1
52044	3084	40481087	1996-12-06	1996-12-20	1
51551	3060	40481087	1984-04-04	1984-04-18	1
5852	343	260139	1994-04-13	1994-04-27	1
2744	159	40481087	1998-06-18	1998-06-25	1
85142	5068	4113008	1987-10-08	1987-10-22	1
8086	474	4152936	1976-05-11	1976-06-01	1
6282	369	378001	1988-01-20	1988-03-20	1
9332	552	378001	1964-01-13	1964-02-12	1
25524	1520	80180	1971-01-11	1971-01-12	1
61347	3628	40481087	1924-07-13	1924-07-27	1
34391	2043	372328	1958-05-28	1958-08-17	1
9219	546	439777	1987-11-03	1987-11-04	1
30016	1778	4283893	2003-04-04	2003-06-20	1
73478	4373	28060	1977-02-03	1977-02-12	1
75730	4497	4112343	1962-04-29	1962-05-10	1
65706	3889	4112343	1998-11-18	1998-12-01	1
5963	351	260139	1991-11-26	1991-12-10	1
31423	1860	4146173	1979-10-07	1979-11-06	1
2560	152	80180	2000-03-11	2000-03-12	1
71163	4224	4112343	2005-05-14	2005-05-26	1
35507	2105	40481087	2016-01-15	2016-01-29	1
54655	3237	40481087	1950-03-05	1950-03-26	1
7420	437	4294548	1995-01-10	1995-02-21	1
48896	2897	260139	1974-06-22	1974-06-29	1
54944	3254	4112343	1964-02-01	1964-02-10	1
5777	339	372328	1985-09-16	1986-01-18	1
38460	2287	321042	2014-01-24	2014-01-25	1
37083	2199	40481087	2005-04-03	2005-04-17	1
14730	869	40481087	2018-11-30	2018-12-07	1
68508	4055	40481087	1980-08-08	1980-08-22	1
49538	2933	80180	1998-07-30	1998-07-31	1
7013	411	4156265	1981-10-23	1981-11-13	1
44630	2657	4112343	2018-07-13	2018-07-24	1
40253	2392	4112343	1937-01-14	1937-01-21	1
52045	3084	0	2015-10-21	2015-10-22	1
51552	3060	40481087	2017-01-19	2017-01-26	1
5853	343	440086	1984-01-28	1988-02-06	1
2745	159	40481087	2011-04-26	2011-05-03	1
86390	5146	260139	1947-03-04	1947-03-11	1
8087	474	4294548	1976-03-17	1976-03-24	1
6283	369	4134304	1982-01-21	1982-03-22	1
9333	552	4112343	1958-05-10	1958-05-22	1
25525	1520	260139	1963-05-04	1963-05-11	1
61348	3628	40481087	1992-02-06	1992-02-20	1
34392	2043	4059173	1973-01-09	1973-02-08	1
9220	546	4059173	1946-11-28	1946-12-28	1
30017	1778	30753	2016-11-29	2016-11-30	1
73479	4373	372328	1977-05-30	1977-06-13	1
75731	4497	4112343	1983-02-12	1983-02-25	1
65707	3889	40481087	2002-09-30	2002-10-21	1
5964	351	260139	2017-11-17	2017-12-01	1
31424	1860	0	1991-12-23	1991-12-24	1
2561	152	257012	1986-09-28	1987-01-11	1
71164	4224	80180	1986-01-19	1986-01-20	1
35508	2105	28060	1980-07-31	1980-08-13	1
54656	3237	40481087	1950-06-03	1950-06-24	1
7421	437	40481087	1983-06-09	1983-06-23	1
48897	2897	372328	1962-09-22	1962-11-10	1
54945	3254	4112343	2008-07-21	2008-08-03	1
5778	339	4283893	1994-10-17	1995-02-13	1
38461	2287	4112343	1999-01-24	1999-02-04	1
37084	2199	4283893	2015-09-05	2015-11-14	1
14731	869	313217	1993-04-23	1993-04-24	1
68509	4055	260139	1970-05-01	1970-05-15	1
49539	2933	192671	1998-10-16	1998-10-17	1
7014	411	40481087	1968-06-11	1968-06-25	1
52136	3090	80180	2001-02-02	2001-02-03	1
40254	2392	40481087	1922-11-06	1922-11-13	1
52046	3084	80180	2017-05-02	2017-05-03	1
52376	3106	4112343	2010-05-12	2010-05-20	1
5854	343	4048171	1972-02-07	1972-02-08	1
5611	332	78272	1980-08-27	1980-09-24	1
86391	5146	260139	1950-11-26	1950-12-03	1
8088	474	4294548	1977-10-24	1978-02-13	1
6284	369	40481087	1986-07-03	1986-07-10	1
9334	552	4112343	1963-04-12	1963-04-19	1
25526	1520	260139	1969-08-08	1969-08-15	1
61349	3628	80502	1974-12-28	1974-12-29	1
35974	2135	78272	2011-05-24	2011-06-07	1
9221	546	4112343	2014-06-14	2014-06-27	1
30018	1778	81151	2015-01-14	2015-02-04	1
73480	4373	4296205	1976-11-01	1976-12-06	1
75732	4497	4142905	1987-07-18	1987-09-16	1
65708	3889	40481087	2010-01-15	2010-01-29	1
5965	351	4027663	2010-11-21	2010-11-22	1
31425	1860	80180	1996-10-02	1996-10-03	1
2562	152	40481087	1976-03-30	1976-04-06	1
71165	4224	260139	1996-12-04	1996-12-11	1
35509	2105	192671	2013-04-19	2013-04-20	1
55355	3283	192671	2016-07-03	2016-07-04	1
7422	437	40481087	1997-08-15	1997-08-29	1
48898	2897	4109685	1968-12-19	1969-01-02	1
54946	3254	4116491	1984-11-25	1985-01-08	1
5779	339	4294548	2017-09-04	2017-10-16	1
38462	2287	4294548	2010-04-04	2010-04-25	1
37085	2199	4285898	2016-01-04	2016-01-05	1
14732	869	372328	1914-01-11	1914-03-20	1
68510	4055	260139	1979-09-29	1979-10-06	1
49540	2933	378001	2018-06-27	2018-08-26	1
7015	411	40481087	1995-03-29	1995-04-19	1
52137	3090	260139	1961-09-21	1961-10-05	1
40255	2392	40481087	1974-08-23	1974-08-30	1
52047	3084	372328	1978-04-22	1978-08-02	1
52377	3106	4218389	1957-03-03	1957-03-31	1
5855	343	4116491	1999-01-24	1999-03-12	1
5612	332	260139	1978-04-12	1978-04-19	1
86392	5146	260139	1966-07-14	1966-07-28	1
8089	474	4310024	2002-10-02	2002-10-03	1
6285	369	40481087	1990-10-26	1990-11-16	1
9335	552	4112343	1980-12-18	1980-12-27	1
25527	1520	260139	2002-09-22	2002-09-29	1
61350	3628	260139	2000-08-16	2000-08-30	1
35975	2135	81151	1953-02-05	1953-03-12	1
9222	546	4278672	1953-10-22	1954-01-20	1
30019	1778	257012	2003-06-06	2003-06-07	1
73481	4373	40481087	1990-03-08	1990-03-15	1
75733	4497	4283893	1992-06-22	1992-10-12	1
65709	3889	4113008	1949-06-11	1949-07-02	1
5966	351	4266809	2018-06-07	2018-06-08	1
31426	1860	81893	1995-01-11	1995-01-12	1
2563	152	40481087	2007-05-01	2007-05-22	1
71166	4224	260139	2019-03-30	2019-04-13	1
35510	2105	40481087	1977-08-07	1977-08-21	1
55356	3283	195588	2005-07-07	2005-08-17	1
7423	437	40481087	2018-05-17	2018-05-24	1
48899	2897	4112343	2001-12-06	2001-12-17	1
54947	3254	40481087	2004-11-28	2004-12-05	1
5780	339	40481087	2000-04-23	2000-05-14	1
38463	2287	40481087	1958-03-19	1958-04-02	1
37086	2199	4294548	2012-06-15	2012-07-27	1
14733	869	4112343	1971-12-11	1971-12-18	1
68511	4055	4112343	1995-02-06	1995-02-13	1
49541	2933	40481087	1955-06-25	1955-07-09	1
7016	411	40481087	1996-06-21	1996-07-12	1
52138	3090	260139	1989-10-28	1989-11-11	1
40256	2392	40481087	1995-07-06	1995-07-13	1
52048	3084	4035415	2017-04-18	2017-05-18	1
52378	3106	80180	1990-03-22	1990-03-23	1
5856	343	4142905	1987-06-01	1987-08-30	1
5613	332	4051466	1965-06-20	1982-09-22	1
86393	5146	4112343	1972-02-23	1972-03-04	1
8090	474	40481087	2008-11-20	2008-12-04	1
6286	369	40481087	2018-07-18	2018-08-08	1
9336	552	4283893	1975-04-02	1975-07-02	1
25528	1520	40481087	1973-12-06	1973-12-13	1
61351	3628	372328	1915-10-23	1915-11-06	1
35976	2135	81151	2004-05-09	2004-05-30	1
9223	546	40481087	1960-10-08	1960-10-29	1
30020	1778	4112343	2012-02-25	2012-03-07	1
73482	4373	80180	2018-01-10	2018-01-11	1
75734	4497	4296204	1973-05-29	1973-06-26	1
65710	3889	40481087	1961-09-25	1961-10-09	1
5967	351	40481087	2001-09-16	2001-09-23	1
31427	1860	260139	1995-09-30	1995-10-07	1
2564	152	40481087	2012-01-31	2012-02-14	1
71167	4224	4266809	1986-01-19	1986-01-20	1
35511	2105	40481087	1989-01-29	1989-02-12	1
55357	3283	260139	2001-12-12	2001-12-19	1
7424	437	78272	2010-05-19	2010-06-16	1
48900	2897	4218389	1983-07-28	1983-08-25	1
54948	3254	80180	2005-02-08	2005-02-09	1
5781	339	40481087	2005-12-23	2006-01-13	1
38464	2287	40481087	1964-02-22	1964-03-07	1
37087	2199	40481087	2013-07-01	2013-07-15	1
14734	869	4112343	1973-03-13	1973-03-25	1
68512	4055	4112343	2001-10-26	2001-11-03	1
49542	2933	40481087	1986-04-02	1986-04-23	1
7017	411	40481087	2002-01-18	2002-02-08	1
52139	3090	40481087	1980-07-19	1980-08-02	1
40257	2392	260139	1955-05-18	1955-05-25	1
52049	3084	4112343	1995-03-13	1995-03-25	1
52379	3106	260139	1973-05-11	1973-05-25	1
5857	343	4266809	2005-09-09	2005-09-10	1
5614	332	4084167	1979-09-18	1979-09-18	1
86394	5146	4112343	1994-01-10	1994-01-22	1
8091	474	78272	1978-03-23	1978-04-27	1
6287	369	260139	1990-05-11	1990-05-25	1
9337	552	40481087	1952-05-17	1952-05-31	1
25529	1520	40481087	1984-09-21	1984-10-05	1
61352	3628	4112343	1956-10-31	1956-11-10	1
35977	2135	4112343	1966-06-12	1966-06-20	1
9224	546	40481087	1975-12-18	1976-01-08	1
30021	1778	40481087	2017-10-08	2017-10-22	1
73483	4373	4048171	1979-01-12	1979-01-13	1
75735	4497	40481087	2000-10-09	2000-10-23	1
65711	3889	81151	1961-12-26	1962-01-16	1
5968	351	80180	2018-06-07	2018-06-08	1
31428	1860	321042	1991-12-23	1991-12-24	1
2565	152	196456	1973-12-15	1973-12-15	1
71168	4224	4285898	1985-10-21	1985-10-22	1
35835	2127	40481087	1966-05-10	1966-05-17	1
55358	3283	4027663	2008-07-06	2008-07-07	1
7425	437	195588	1978-02-04	1978-03-15	1
48901	2897	4218389	2001-03-23	2001-04-13	1
54949	3254	4218389	1978-03-31	1978-05-05	1
5782	339	80180	2019-06-21	2019-06-22	1
38465	2287	78272	1945-12-12	1945-12-26	1
37088	2199	257012	2015-09-19	2015-09-20	1
14735	869	40481087	1925-03-05	1925-03-26	1
68513	4055	4112343	2006-05-13	2006-05-22	1
49543	2933	40481087	2004-11-08	2004-11-22	1
7018	411	260139	1972-08-14	1972-08-21	1
52140	3090	260139	2005-03-06	2005-03-13	1
40258	2392	260139	1984-02-24	1984-03-09	1
52050	3084	4112343	2008-06-15	2008-06-23	1
52380	3106	260139	2012-12-28	2013-01-11	1
5858	343	4294548	1980-01-17	1980-01-31	1
5615	332	4112343	1991-12-20	1991-12-29	1
86395	5146	80180	1979-02-13	1979-02-14	1
8092	474	257012	1977-12-12	1977-12-13	1
6288	369	260139	2009-03-22	2009-03-29	1
9338	552	40481087	1977-05-30	1977-06-20	1
25530	1520	40481087	2000-03-20	2000-04-10	1
61353	3628	4112343	1995-10-04	1995-10-14	1
35978	2135	4112343	1967-02-16	1967-02-26	1
9225	546	40481087	1991-09-22	1991-09-29	1
31675	1879	28060	1984-02-05	1984-02-16	1
73484	4373	4084167	1976-07-04	1976-07-04	1
75736	4497	28060	1971-04-07	1971-04-15	1
65712	3889	260139	1954-02-03	1954-02-10	1
5969	351	260139	1985-02-28	1985-03-14	1
31429	1860	372328	1963-03-24	1963-10-07	1
2566	152	4112343	1998-10-22	1998-10-31	1
72977	4342	78272	1975-07-01	1975-07-15	1
35836	2127	40481087	1976-08-21	1976-09-04	1
55359	3283	4142905	1987-11-24	1988-02-22	1
7426	437	260139	2002-09-23	2002-10-07	1
48902	2897	40481087	1965-01-28	1965-02-04	1
56391	3347	260139	1984-12-13	1984-12-27	1
5783	339	4296205	1990-02-03	1990-03-03	1
38466	2287	81151	1944-11-26	1944-12-17	1
37089	2199	260139	1981-05-13	1981-05-27	1
14736	869	28060	1970-06-25	1970-07-02	1
68514	4055	4112343	2007-05-20	2007-06-02	1
50176	2969	81151	1967-11-07	1967-12-12	1
7019	411	260139	1981-12-24	1981-12-31	1
52141	3090	4109685	1980-09-10	1980-10-01	1
40259	2392	260139	2019-02-17	2019-03-03	1
52051	3084	4134304	2006-10-13	2006-12-12	1
52381	3106	4112343	1963-07-03	1963-07-15	1
5859	343	40481087	2004-05-01	2004-05-22	1
5616	332	4112343	2007-05-26	2007-06-04	1
86396	5146	257012	1969-12-04	1969-12-05	1
8093	474	260139	2017-09-04	2017-09-18	1
6289	369	40481087	1984-02-16	1984-03-08	1
9339	552	40481087	2006-07-18	2006-07-25	1
25531	1520	40481087	2001-08-10	2001-08-24	1
61354	3628	4283893	1942-10-12	1943-03-08	1
35979	2135	4155034	1963-06-18	1963-07-02	1
9226	546	80180	1981-05-28	1981-05-29	1
31676	1879	80180	1995-10-15	1995-10-16	1
73485	4373	40481087	1981-05-27	1981-06-17	1
75737	4497	81151	1978-01-31	1978-03-07	1
65713	3889	260139	1958-04-16	1958-04-23	1
5970	351	440448	2016-11-21	2016-11-22	1
31430	1860	4112343	1978-08-26	1978-09-06	1
2567	152	4152936	1995-03-03	1995-03-24	1
72978	4342	260139	1987-05-06	1987-05-14	1
35837	2127	40481087	1978-05-02	1978-05-23	1
55360	3283	80180	2016-05-25	2016-05-26	1
7427	437	4112343	1994-02-04	1994-02-13	1
48903	2897	40481087	1996-07-09	1996-07-23	1
56392	3347	260139	2002-08-31	2002-09-14	1
5784	339	40481087	2008-07-06	2008-07-27	1
38467	2287	317576	1962-05-04	1962-05-05	1
37090	2199	372328	1980-05-17	1980-06-29	1
14737	869	78272	1920-12-19	1921-01-02	1
69490	4117	80180	1996-05-29	1996-05-30	1
50177	2969	4112343	1970-06-28	1970-07-07	1
7020	411	4112343	1989-08-30	1989-09-08	1
52142	3090	4112343	2008-02-08	2008-02-16	1
40260	2392	313217	1997-05-16	1997-05-17	1
52052	3084	40481087	1980-01-21	1980-02-11	1
52382	3106	40481087	1960-06-26	1960-07-17	1
7527	443	28060	1979-09-24	1979-10-03	1
5617	332	80180	2007-05-19	2007-05-20	1
86397	5146	260139	2000-01-18	2000-01-25	1
8094	474	372328	1975-03-24	1975-11-30	1
9618	571	260139	1980-05-17	1980-05-31	1
9340	552	28060	1955-04-15	1955-04-22	1
25532	1520	28060	1982-08-31	1982-09-10	1
61355	3628	40480160	1985-09-25	1985-10-25	1
35980	2135	4278672	1961-06-28	1961-09-26	1
9227	546	4112343	1968-08-19	1968-09-01	1
31677	1879	4112343	1995-12-17	1995-12-25	1
74856	4451	28060	2005-03-22	2005-04-04	1
75738	4497	4112343	2011-09-13	2011-09-25	1
65714	3889	260139	1964-02-23	1964-03-08	1
5971	351	4112343	1978-12-27	1979-01-07	1
31431	1860	4112343	1991-07-14	1991-07-22	1
2568	152	4237458	1992-02-17	1992-03-18	1
72979	4342	260139	1998-08-05	1998-08-12	1
35838	2127	40481087	1996-02-21	1996-03-06	1
55361	3283	4059173	2018-10-12	2018-11-11	1
7428	437	40481087	1959-11-10	1959-11-17	1
48904	2897	40481087	2004-04-21	2004-05-12	1
56393	3347	4112343	1963-03-17	1963-03-25	1
7811	457	80180	1986-03-28	1986-03-29	1
38468	2287	4059173	1969-07-19	1969-08-18	1
37091	2199	4027663	2009-07-14	2009-07-15	1
14738	869	260139	1960-09-04	1960-09-11	1
69491	4117	260139	2012-06-30	2012-07-07	1
50178	2969	4113008	1986-03-03	1986-03-24	1
7021	411	40481087	2002-07-13	2002-08-03	1
52143	3090	40481087	1966-03-05	1966-03-26	1
40261	2392	4035415	1916-11-30	1916-12-30	1
52053	3084	40481087	2005-04-12	2005-04-26	1
52383	3106	192671	1990-05-10	1990-05-11	1
7528	443	28060	2015-03-01	2015-03-13	1
5618	332	260139	1969-02-14	1969-02-21	1
86398	5146	260139	2012-05-29	2012-06-05	1
8095	474	4156265	1990-09-05	1990-09-26	1
9619	571	4112343	2018-07-09	2018-07-19	1
9341	552	78272	1966-01-02	1966-01-23	1
25533	1520	257012	1960-01-05	1960-01-06	1
61356	3628	40481087	1998-09-25	1998-10-16	1
35981	2135	40481087	1981-06-24	1981-07-15	1
9228	546	4134304	1961-10-10	1962-01-08	1
31678	1879	4218389	1983-02-23	1983-03-23	1
74857	4451	260139	1957-03-14	1957-03-21	1
75739	4497	40481087	1986-12-02	1986-12-16	1
65715	3889	372328	1941-06-23	1941-08-17	1
5972	351	4112343	2014-12-15	2014-12-26	1
31432	1860	4112343	1994-11-04	1994-11-15	1
2569	152	40481087	1976-10-11	1976-10-25	1
72980	4342	4112343	1964-06-01	1964-06-10	1
35839	2127	40481087	2018-11-15	2018-11-22	1
55362	3283	4266809	2016-05-25	2016-05-26	1
7429	437	40481087	1962-02-09	1962-02-16	1
48905	2897	40481087	2005-03-13	2005-03-20	1
56394	3347	4112343	1963-07-26	1963-08-04	1
7812	457	81151	1989-03-27	1989-04-17	1
38469	2287	4112343	1957-08-02	1957-08-09	1
37092	2199	4112343	1991-01-05	1991-01-15	1
14739	869	260139	1980-06-30	1980-07-14	1
69492	4117	4112343	1966-04-11	1966-04-18	1
50179	2969	40481087	2006-01-30	2006-02-13	1
9670	573	28060	1960-03-03	1960-03-11	1
52144	3090	28060	2002-07-31	2002-08-07	1
40262	2392	4112343	1956-05-13	1956-05-22	1
53885	3194	0	1983-03-28	1983-03-29	1
57175	3397	81151	1994-09-03	1994-09-17	1
7529	443	80180	2005-09-29	2005-09-30	1
5619	332	260139	1993-12-29	1994-01-12	1
86399	5146	381316	2013-07-15	2013-07-16	1
8096	474	4266809	2005-08-17	2005-08-18	1
9620	571	4294548	2012-01-06	2012-02-03	1
9342	552	257012	1975-04-30	1975-05-01	1
25534	1520	4112343	1946-05-22	1946-06-03	1
63835	3776	4112343	2008-01-23	2008-01-30	1
35982	2135	28060	2000-12-30	2001-01-08	1
9229	546	4134304	2010-05-17	2010-06-16	1
31679	1879	4237458	1994-11-25	1995-01-24	1
74858	4451	260139	1974-12-27	1975-01-03	1
75740	4497	260139	2005-01-22	2005-01-29	1
65716	3889	4155034	2010-05-04	2010-05-18	1
5973	351	4296204	1985-10-18	1985-11-01	1
31433	1860	4142905	1984-05-13	1984-07-12	1
2570	152	40481087	1992-01-10	1992-01-31	1
72981	4342	4112343	2010-11-06	2010-11-14	1
35840	2127	195588	1978-08-30	1978-10-06	1
55363	3283	4294548	1993-09-21	1993-10-12	1
7430	437	40481087	1985-10-16	1985-10-30	1
48906	2897	40481087	2018-08-10	2018-08-31	1
56395	3347	40479422	1993-10-22	1993-11-28	1
7813	457	260139	2003-03-01	2003-03-15	1
38470	2287	4112343	1988-02-29	1988-03-08	1
37093	2199	4266809	2016-10-30	2016-10-31	1
14740	869	260139	1997-04-04	1997-04-18	1
69493	4117	40481087	1967-09-25	1967-10-09	1
50180	2969	81151	2007-01-24	2007-02-28	1
9671	573	28060	1974-01-22	1974-02-03	1
52145	3090	4156265	2003-05-25	2003-06-15	1
40263	2392	4112343	1976-01-22	1976-01-29	1
53886	3194	80180	1980-08-24	1980-08-25	1
57176	3397	81893	1980-09-01	1980-09-02	1
7530	443	81151	1983-02-01	1983-03-08	1
5620	332	260139	2019-03-30	2019-04-13	1
86400	5146	4113008	1953-08-19	1953-09-02	1
8097	474	4285898	2004-11-20	2004-11-21	1
9621	571	40481087	1955-08-02	1955-08-16	1
9343	552	372328	1954-10-21	1955-03-01	1
25535	1520	4134304	2002-10-29	2003-01-27	1
63836	3776	4113008	1994-12-30	1995-01-13	1
35983	2135	81151	1969-07-14	1969-08-11	1
9230	546	4266809	1981-05-28	1981-05-29	1
31680	1879	40481087	1996-03-25	1996-04-08	1
74859	4451	4112343	1987-01-31	1987-02-11	1
75741	4497	260139	2013-11-06	2013-11-13	1
65717	3889	40481087	1940-07-05	1940-07-26	1
5974	351	40481087	1984-08-03	1984-08-24	1
31434	1860	4285898	1996-01-06	1996-01-07	1
2571	152	40481087	2007-01-10	2007-01-24	1
72982	4342	4155034	2016-07-21	2016-08-11	1
35841	2127	260139	1966-10-03	1966-10-10	1
55364	3283	40481087	1993-06-04	1993-06-18	1
7431	437	30753	1986-03-29	1986-03-30	1
48907	2897	28060	1967-07-29	1967-08-05	1
56396	3347	40481087	1980-11-02	1980-11-09	1
7814	457	372328	1969-08-09	1970-03-31	1
38471	2287	4112343	1998-02-17	1998-02-24	1
37094	2199	40481087	1998-12-14	1998-12-28	1
14741	869	381316	2006-09-29	2006-09-30	1
69494	4117	192671	1996-08-08	1996-08-09	1
50181	2969	260139	1982-04-24	1982-05-01	1
9672	573	81151	2013-07-17	2013-08-14	1
52146	3090	40481087	1981-04-27	1981-05-18	1
40264	2392	4112343	2012-10-18	2012-10-29	1
53887	3194	81893	1979-06-01	1979-06-02	1
57177	3397	257012	1971-05-27	1971-05-28	1
7531	443	260139	1993-07-27	1993-08-03	1
5621	332	4112343	1988-03-27	1988-04-05	1
86401	5146	40481087	1948-08-02	1948-08-23	1
10715	636	4294548	2003-04-30	2003-05-28	1
9622	571	40481087	1968-06-18	1968-07-02	1
9344	552	375671	2014-06-10	2014-07-10	1
25536	1520	4142905	2010-10-17	2010-12-16	1
63837	3776	4278672	1987-03-21	1987-06-19	1
35984	2135	4134304	1957-08-18	1957-10-17	1
9231	546	4278672	1944-12-08	1945-02-06	1
31681	1879	28060	2019-04-24	2019-05-07	1
74860	4451	4112343	1999-11-08	1999-11-15	1
75742	4497	372328	1958-02-17	1958-03-03	1
65718	3889	40481087	1952-01-02	1952-01-09	1
5975	351	4112343	2002-04-07	2002-04-18	1
31435	1860	40481087	1973-11-12	1973-11-19	1
2572	152	28060	2017-01-26	2017-02-05	1
72983	4342	4296204	2014-07-20	2014-08-10	1
35842	2127	260139	2004-09-11	2004-09-25	1
55365	3283	40481087	2002-07-16	2002-07-30	1
7432	437	81151	1960-11-25	1960-12-09	1
48908	2897	372328	1965-11-24	1966-05-21	1
56397	3347	40481087	1994-03-28	1994-04-18	1
7815	457	40479422	1998-07-04	1998-08-10	1
38472	2287	4218389	1960-07-10	1960-08-14	1
37095	2199	40481087	2013-11-21	2013-12-05	1
14742	869	4112343	1984-09-24	1984-10-04	1
69495	4117	372328	1965-04-16	1965-05-21	1
50182	2969	260139	2000-11-03	2000-11-17	1
9673	573	4112343	1998-10-28	1998-11-06	1
52147	3090	40481087	1988-11-16	1988-12-07	1
40265	2392	4152936	1926-05-12	1926-06-02	1
53888	3194	260139	1968-01-02	1968-01-09	1
57178	3397	260139	1952-04-07	1952-04-21	1
7532	443	375671	2005-01-23	2005-02-22	1
5622	332	4112343	1994-08-17	1994-08-29	1
86402	5146	40481087	1974-12-22	1974-12-29	1
10716	636	40481087	1957-08-27	1957-09-17	1
9623	571	40481087	1999-11-28	1999-12-19	1
9345	552	4027663	1977-09-11	1977-09-12	1
25537	1520	40481087	2018-11-13	2018-11-20	1
63838	3776	40481087	1993-07-04	1993-07-18	1
35985	2135	40481087	1971-07-05	1971-07-12	1
9232	546	28060	1986-03-11	1986-03-24	1
31682	1879	372328	1963-05-11	1963-09-14	1
74861	4451	4112343	2019-05-22	2019-05-31	1
75743	4497	372328	1958-06-01	1958-09-02	1
69673	4127	80180	1988-02-04	1988-02-05	1
5976	351	4285898	2017-10-10	2017-10-11	1
31436	1860	40481087	1997-03-14	1997-03-21	1
2573	152	195588	2010-12-25	2011-02-09	1
72984	4342	4310024	1992-03-23	1992-03-24	1
35843	2127	4112343	2005-09-10	2005-09-18	1
55366	3283	40481087	2013-12-19	2014-01-02	1
7433	437	81893	1985-12-29	1985-12-30	1
48909	2897	40481087	1977-08-05	1977-08-26	1
56398	3347	40481087	2001-04-20	2001-05-11	1
7816	457	40481087	1962-02-07	1962-02-28	1
38473	2287	28060	1970-02-17	1970-03-01	1
37096	2199	40481087	2018-05-08	2018-05-22	1
14743	869	4113008	1936-10-10	1936-10-31	1
69496	4117	4112343	1970-03-02	1970-03-10	1
50183	2969	4112343	1978-05-29	1978-06-06	1
9674	573	4112343	2009-06-09	2009-06-16	1
52148	3090	78272	1994-11-17	1994-12-08	1
40266	2392	4294548	1932-08-18	1932-09-08	1
53889	3194	260139	1974-08-24	1974-08-31	1
57179	3397	260139	1954-01-06	1954-01-20	1
7533	443	378001	2015-06-15	2015-08-14	1
5623	332	4294548	1990-04-08	1990-04-29	1
86403	5146	40481087	1987-04-02	1987-04-23	1
10717	636	40481087	1998-05-21	1998-06-04	1
9624	571	80180	1992-01-03	1992-01-04	1
9346	552	4116491	1982-09-10	1982-10-21	1
25538	1520	81151	1963-06-28	1963-07-26	1
63839	3776	81151	2017-03-25	2017-04-15	1
35986	2135	28060	1958-02-13	1958-02-23	1
9233	546	260139	1946-02-03	1946-02-10	1
31683	1879	4112343	1961-05-23	1961-06-02	1
74862	4451	4152936	1980-01-11	1980-01-25	1
75744	4497	372328	1974-01-11	1974-11-19	1
69674	4127	81151	1957-06-02	1957-07-07	1
5977	351	40481087	1986-02-24	1986-03-17	1
31437	1860	260139	1992-08-04	1992-08-18	1
2574	152	198809	1973-12-15	1973-12-15	1
72985	4342	40481087	2005-10-24	2005-11-14	1
35844	2127	40481087	1971-07-29	1971-08-12	1
55367	3283	372328	1981-10-15	1981-12-18	1
7434	437	378001	1961-10-05	1961-11-04	1
48910	2897	80180	2003-11-06	2003-11-07	1
56399	3347	80180	1992-06-19	1992-06-20	1
7817	457	40481087	2003-02-24	2003-03-17	1
38474	2287	81151	1940-12-26	1941-01-16	1
37097	2199	80180	2016-10-30	2016-10-31	1
14744	869	4155034	1915-12-02	1915-12-16	1
69497	4117	40481087	1972-11-20	1972-11-27	1
50184	2969	4112343	1985-11-28	1985-12-07	1
9675	573	4152936	1974-04-15	1974-04-29	1
52149	3090	260139	1978-04-11	1978-04-25	1
40267	2392	4294548	1978-10-15	1978-11-12	1
53890	3194	317576	1971-01-11	1971-01-12	1
57180	3397	260139	1961-09-18	1961-10-02	1
7534	443	40481087	1971-09-11	1971-10-02	1
5624	332	40481087	1966-06-29	1966-07-06	1
86404	5146	40481087	1988-09-23	1988-10-14	1
10718	636	40481087	2000-05-30	2000-06-06	1
9625	571	257012	1956-06-07	1956-06-08	1
9347	552	40481087	2013-04-15	2013-05-06	1
25539	1520	260139	1952-01-08	1952-01-22	1
63840	3776	192671	2007-11-18	2007-11-19	1
35987	2135	257012	2000-02-09	2000-02-10	1
9234	546	260139	2001-01-03	2001-01-17	1
31684	1879	4294548	1999-01-29	1999-03-12	1
74863	4451	192671	1992-11-10	1992-11-11	1
75745	4497	4027663	1982-09-19	1982-09-20	1
69675	4127	260139	1976-07-05	1976-07-19	1
5978	351	40481087	1997-10-24	1997-10-31	1
31438	1860	317576	1973-12-03	1973-12-04	1
2575	152	260139	1976-09-10	1976-09-17	1
72986	4342	378001	1964-12-25	1965-01-24	1
35845	2127	78272	1995-06-23	1995-07-07	1
55368	3283	4112343	2004-03-30	2004-04-06	1
7435	437	4112343	2007-06-03	2007-06-11	1
48911	2897	260139	1977-02-21	1977-02-28	1
56400	3347	260139	1982-02-18	1982-02-25	1
7818	457	260139	2007-03-10	2007-03-17	1
38475	2287	257012	1964-09-17	1964-09-18	1
37098	2199	260139	2016-02-27	2016-03-12	1
14745	869	4155034	1952-06-23	1952-07-07	1
69498	4117	40481087	1989-01-07	1989-01-21	1
50185	2969	40481087	1976-05-01	1976-05-08	1
9676	573	40481087	1991-03-26	1991-04-16	1
52150	3090	260139	2006-02-07	2006-02-21	1
40268	2392	80180	1948-05-16	1948-05-17	1
53891	3194	4266809	1980-08-24	1980-08-25	1
57181	3397	4027663	1972-06-10	1972-06-11	1
7535	443	40481087	1981-12-17	1982-01-07	1
5625	332	40481087	2010-02-11	2010-02-18	1
86405	5146	4112343	2018-11-14	2018-11-22	1
10719	636	40481087	2004-05-01	2004-05-15	1
9626	571	260139	2005-08-03	2005-08-10	1
9348	552	80180	1986-05-27	1986-05-28	1
25540	1520	4112343	1978-07-12	1978-07-19	1
63841	3776	4112343	2014-08-28	2014-09-04	1
35988	2135	260139	1967-05-12	1967-05-19	1
9235	546	260139	2004-01-21	2004-01-28	1
31685	1879	4296204	1984-03-17	1984-04-07	1
74864	4451	440086	1962-05-10	1964-03-05	1
75746	4497	40481087	1989-09-06	1989-09-27	1
69676	4127	260139	2005-09-27	2005-10-11	1
5979	351	40481087	2008-01-27	2008-02-03	1
31439	1860	372328	1960-12-15	1961-04-03	1
2576	152	260139	2010-09-23	2010-09-30	1
72987	4342	4112343	2013-02-04	2013-02-16	1
35846	2127	260139	1970-07-23	1970-08-06	1
55369	3283	4237458	1981-02-28	1981-05-29	1
7436	437	4296204	2007-07-06	2007-08-03	1
48912	2897	4027663	1992-05-27	1992-05-28	1
56401	3347	4116491	2005-05-02	2005-06-18	1
7819	457	4112343	2008-11-17	2008-11-24	1
38476	2287	313217	2004-05-21	2004-05-22	1
37099	2199	372328	1985-06-03	1985-07-07	1
14746	869	40481087	2004-07-21	2004-07-28	1
69499	4117	28060	1964-05-10	1964-05-19	1
50186	2969	40481087	2002-06-10	2002-06-24	1
9677	573	80180	1996-01-10	1996-01-11	1
52151	3090	4112343	1999-04-07	1999-04-17	1
40269	2392	80502	1986-03-14	1986-03-15	1
53892	3194	40481087	1951-12-31	1952-01-21	1
57182	3397	4112343	1952-06-19	1952-06-29	1
7536	443	40481087	2017-04-02	2017-04-23	1
5626	332	78272	1979-09-18	1979-10-02	1
86406	5146	78272	1952-08-03	1952-08-24	1
10720	636	257012	1958-07-18	1958-07-19	1
9627	571	4142905	1968-02-09	1968-05-09	1
9349	552	260139	1969-07-17	1969-07-31	1
25541	1520	4112343	2000-03-13	2000-03-21	1
63842	3776	4149245	2010-11-20	2011-01-26	1
35989	2135	4112343	2006-10-10	2006-10-18	1
9236	546	4112343	1966-03-21	1966-03-31	1
31686	1879	28060	1967-10-31	1967-11-13	1
74865	4451	4112343	1979-03-03	1979-03-12	1
75747	4497	80180	1992-11-05	1992-11-06	1
69677	4127	4109685	1948-07-23	1948-08-13	1
5980	351	0	2016-11-21	2016-11-22	1
31440	1860	4027663	1985-10-20	1985-10-21	1
2577	152	4056621	2010-12-25	2010-12-26	1
72988	4342	28060	1980-04-02	1980-04-15	1
35847	2127	372328	2005-06-28	2006-09-23	1
55370	3283	4310024	2014-09-03	2014-09-04	1
7437	437	4310024	1985-10-30	1985-10-31	1
48913	2897	4112343	1998-03-11	1998-03-24	1
56402	3347	4237458	2011-02-16	2011-04-17	1
7820	457	4278672	2009-05-14	2009-07-13	1
38477	2287	378419	2013-07-12	2013-07-13	1
37100	2199	378001	2016-01-09	2016-03-09	1
14747	869	28060	1961-01-02	1961-01-09	1
69500	4117	260139	1980-03-16	1980-03-23	1
50187	2969	40481087	2018-08-17	2018-08-24	1
9678	573	260139	1964-03-10	1964-03-24	1
52152	3090	4294548	1980-11-09	1980-11-23	1
40270	2392	260139	1942-12-31	1943-01-14	1
53893	3194	372328	1944-11-01	1944-11-15	1
57183	3397	4283893	1992-09-20	1993-01-31	1
7537	443	260139	1980-11-15	1980-11-29	1
5627	332	378001	1988-06-14	1988-07-14	1
86407	5146	4283893	1969-10-23	1969-12-11	1
10721	636	260139	2017-03-19	2017-03-26	1
9628	571	40481087	1996-08-31	1996-09-07	1
9350	552	4112343	1958-11-20	1958-12-02	1
25542	1520	40481087	1966-12-29	1967-01-05	1
63843	3776	28060	1979-12-29	1980-01-05	1
35990	2135	4116491	1991-01-22	1991-03-08	1
9237	546	4116491	1982-11-04	1982-12-07	1
31687	1879	28060	1968-09-11	1968-09-23	1
74866	4451	4146173	2018-12-08	2019-02-06	1
75748	4497	378001	1976-01-12	1976-02-11	1
69678	4127	4112343	2000-11-18	2000-11-26	1
5981	351	28060	1986-04-04	1986-04-13	1
31441	1860	40481087	1991-11-21	1991-12-05	1
2578	152	4112343	1969-09-16	1969-09-28	1
72989	4342	372328	1959-02-09	1959-06-12	1
35848	2127	4112343	2016-12-21	2016-12-30	1
55371	3283	40481087	2003-04-05	2003-04-12	1
7438	437	40481087	1962-10-19	1962-11-09	1
48914	2897	4310024	2000-11-21	2000-11-22	1
56403	3347	4294548	1956-12-07	1957-01-25	1
7821	457	4283893	1958-07-01	1958-10-21	1
38478	2287	4059173	1954-09-10	1954-10-10	1
37101	2199	440448	1995-07-19	1995-07-20	1
14748	869	260139	1947-07-19	1947-07-26	1
69501	4117	260139	1998-11-05	1998-11-12	1
50188	2969	81151	1969-12-31	1970-01-28	1
9679	573	260139	1977-03-25	1977-04-01	1
53467	3172	80180	2012-10-28	2012-10-29	1
40271	2392	260139	1960-01-22	1960-01-29	1
53894	3194	4027663	1973-06-07	1973-06-08	1
57184	3397	40481087	1962-09-04	1962-09-18	1
7538	443	4155034	2006-03-19	2006-04-03	1
5628	332	4112343	1986-06-27	1986-07-05	1
86408	5146	4296205	2017-01-29	2017-03-05	1
10722	636	4112343	1960-12-05	1960-12-18	1
9629	571	4112343	2004-01-24	2004-02-06	1
9351	552	4134304	1962-01-23	1962-03-24	1
25543	1520	81151	1955-02-19	1955-03-12	1
63844	3776	80180	2007-09-12	2007-09-13	1
35991	2135	4294548	2000-01-12	2000-03-08	1
9238	546	4156265	2004-11-23	2004-12-14	1
31688	1879	78272	1982-01-01	1982-01-29	1
74867	4451	40481087	1963-02-11	1963-03-04	1
75749	4497	4112343	2003-10-12	2003-10-23	1
69679	4127	4152936	1985-08-09	1985-08-30	1
5982	351	192671	2018-06-28	2018-06-29	1
31442	1860	192671	1996-12-24	1996-12-25	1
2579	152	4112343	1970-06-28	1970-07-08	1
72990	4342	4027663	1986-06-28	1986-06-29	1
35849	2127	4218389	1992-07-17	1992-08-07	1
55372	3283	40481087	2008-10-18	2008-11-08	1
7439	437	40481087	1981-11-03	1981-11-10	1
48915	2897	40481087	1994-02-27	1994-03-13	1
56404	3347	40481087	1956-06-12	1956-07-03	1
7822	457	40481087	1957-04-21	1957-04-28	1
38479	2287	4112343	2000-08-01	2000-08-11	1
37102	2199	4134304	1984-04-26	1984-07-25	1
14749	869	260139	1992-04-11	1992-04-18	1
69502	4117	372328	1964-05-07	1964-05-21	1
50189	2969	81151	1977-09-18	1977-10-16	1
9680	573	260139	1982-10-31	1982-11-07	1
53468	3172	260139	2005-01-23	2005-01-30	1
40272	2392	260139	2013-09-25	2013-10-09	1
53895	3194	4109685	1950-07-03	1950-07-24	1
57185	3397	28060	2008-10-18	2008-10-27	1
7539	443	40481087	2008-12-22	2009-01-05	1
5629	332	4142905	1972-08-25	1972-10-24	1
86409	5146	40481087	1962-02-19	1962-02-26	1
10723	636	4112343	2004-01-04	2004-01-12	1
9630	571	4112343	2009-12-09	2009-12-19	1
9352	552	40481087	1964-08-03	1964-08-24	1
25544	1520	4112343	1941-11-02	1941-11-13	1
63845	3776	260139	2006-10-08	2006-10-15	1
35992	2135	40481087	1983-12-07	1983-12-28	1
9239	546	40481087	1955-11-21	1955-11-28	1
31689	1879	80502	2019-05-04	2019-05-05	1
74868	4451	40481087	1992-01-26	1992-02-02	1
75750	4497	40481087	1972-08-11	1972-08-18	1
69680	4127	81151	2011-11-03	2011-12-01	1
5983	351	260139	1982-10-05	1982-10-12	1
31443	1860	378001	1987-03-29	1987-04-28	1
2580	152	4112343	1976-04-11	1976-04-18	1
72991	4342	4112343	2009-07-28	2009-08-09	1
35850	2127	40481087	1995-08-29	1995-09-19	1
55373	3283	372328	1980-07-03	1980-12-19	1
7440	437	40481087	1987-12-27	1988-01-10	1
50944	3019	372328	1991-08-19	1992-06-10	1
56405	3347	40481087	1959-09-21	1959-10-05	1
7823	457	40481087	1971-03-22	1971-04-05	1
38480	2287	4278672	2014-01-22	2014-01-23	1
38223	2273	4112343	1989-07-20	1989-07-27	1
14750	869	372328	1947-05-01	1947-07-25	1
69503	4117	4112343	2017-10-18	2017-10-30	1
50190	2969	4112343	1987-08-01	1987-08-08	1
9681	573	260139	1992-07-07	1992-07-14	1
53469	3172	372328	1983-04-19	1983-11-10	1
40273	2392	261325	1951-10-12	1951-10-13	1
53896	3194	4156265	1954-05-04	1954-05-18	1
57186	3397	30753	1981-07-28	1981-07-29	1
7540	443	372328	1970-01-10	1970-02-23	1
5630	332	40481087	1964-05-18	1964-06-01	1
87747	5228	30753	1968-02-07	1968-02-08	1
10724	636	4283893	2012-09-22	2012-10-13	1
9631	571	40481087	1966-01-04	1966-01-25	1
9353	552	40481087	2001-04-06	2001-04-13	1
25545	1520	4112343	1955-06-18	1955-06-29	1
63846	3776	4112343	2003-12-03	2003-12-13	1
35993	2135	80180	1983-11-15	1983-11-16	1
9240	546	40481087	1995-02-17	1995-03-03	1
31690	1879	4294548	1987-01-01	1987-03-12	1
74869	4451	28060	1976-07-03	1976-07-15	1
75751	4497	40481087	1977-11-27	1977-12-11	1
69681	4127	40481087	2011-10-16	2011-10-23	1
5984	351	4112343	2000-05-02	2000-05-15	1
31444	1860	4112343	1985-12-01	1985-12-11	1
2581	152	4116491	2010-10-20	2010-11-20	1
72992	4342	40481087	1989-03-11	1989-03-25	1
35851	2127	80180	1997-01-07	1997-01-08	1
55374	3283	40481087	1998-05-26	1998-06-02	1
10366	613	80502	2016-05-27	2016-05-28	1
50945	3019	4112343	1988-05-08	1988-05-21	1
56406	3347	40481087	1961-11-12	1961-12-03	1
7824	457	28060	2016-05-17	2016-05-30	1
38481	2287	4283893	1964-08-13	1965-01-28	1
38224	2273	4283893	1997-05-28	1997-07-02	1
14751	869	372328	1979-03-09	1980-02-01	1
69504	4117	40481087	1989-09-25	1989-10-16	1
50191	2969	40481087	1993-11-10	1993-11-17	1
9682	573	4112343	1965-07-27	1965-08-06	1
53470	3172	40479768	1999-01-09	1999-02-15	1
40274	2392	372328	1919-09-16	1920-01-09	1
53897	3194	40481087	1978-09-23	1978-10-07	1
57187	3397	80180	1981-12-25	1981-12-26	1
7541	443	372328	1973-02-07	1973-11-26	1
5631	332	260139	1982-09-26	1982-10-10	1
87748	5228	195588	1960-06-13	1960-08-06	1
10725	636	260139	2013-07-14	2013-07-28	1
9632	571	40481087	1970-03-31	1970-04-07	1
9354	552	40481087	2002-09-10	2002-10-01	1
25546	1520	4112343	1955-10-29	1955-11-08	1
63847	3776	4155034	1991-12-25	1992-01-15	1
35994	2135	134438	1968-02-04	1969-01-05	1
9241	546	81893	1980-07-02	1980-07-03	1
31691	1879	40481087	2006-06-10	2006-06-17	1
74870	4451	80180	1992-08-20	1992-08-21	1
80553	4781	28060	1987-03-09	1987-03-20	1
69682	4127	81151	1951-08-28	1951-10-02	1
5985	351	4310024	2016-09-15	2016-09-16	1
31445	1860	4310024	1994-06-15	1994-06-16	1
2582	152	4278672	2000-10-23	2000-11-22	1
72993	4342	80180	1993-02-16	1993-02-17	1
35852	2127	372328	1962-11-22	1963-02-09	1
58133	3446	257012	1971-09-09	1971-09-10	1
10367	613	260139	2007-08-07	2007-08-21	1
50946	3019	4310024	2014-02-19	2014-02-20	1
56407	3347	40481087	1986-07-18	1986-08-01	1
7825	457	260139	1954-04-01	1954-04-15	1
38482	2287	4296204	1965-07-19	1965-08-09	1
38225	2273	40481087	1993-02-05	1993-02-12	1
14752	869	4059173	1937-11-25	1938-02-23	1
69505	4117	78272	2011-09-03	2011-10-01	1
50192	2969	80180	2009-05-25	2009-05-26	1
9683	573	40481087	1968-03-22	1968-04-05	1
53471	3172	4112343	1985-08-21	1985-08-29	1
40275	2392	375671	2019-02-11	2019-03-13	1
53898	3194	134438	1968-06-15	1969-04-15	1
57188	3397	81151	1976-11-10	1976-12-01	1
7542	443	4113008	1991-06-23	1991-07-07	1
5632	332	260139	2005-10-28	2005-11-04	1
87749	5228	260139	1939-01-09	1939-01-23	1
10726	636	313217	1999-05-28	1999-05-29	1
9633	571	40481087	1995-09-17	1995-10-01	1
9355	552	40481087	2007-10-25	2007-11-08	1
25547	1520	4283893	1959-12-01	1960-01-26	1
63848	3776	40481087	1974-08-31	1974-09-07	1
35995	2135	260139	1953-02-06	1953-02-20	1
9242	546	378001	1978-12-10	1979-02-08	1
31692	1879	40481087	2015-03-05	2015-03-19	1
74871	4451	260139	1999-03-29	1999-04-05	1
80554	4781	372328	1997-11-07	1998-11-20	1
69683	4127	257012	1955-01-18	1955-01-19	1
7706	453	260139	1977-02-09	1977-02-23	1
31446	1860	4329847	1985-11-11	1985-11-12	1
2583	152	4294548	1986-08-10	1987-01-11	1
72994	4342	81893	1992-05-22	1992-05-23	1
37290	2211	4027663	1996-06-13	1996-06-14	1
58134	3446	260139	1959-12-01	1959-12-08	1
10368	613	4116491	1987-11-02	1987-12-26	1
50947	3019	40481087	1997-07-26	1997-08-16	1
56408	3347	40481087	2007-03-20	2007-04-10	1
7826	457	4112343	1961-03-27	1961-04-08	1
41505	2470	192671	1992-12-29	1992-12-30	1
38226	2273	40481087	1998-01-06	1998-01-20	1
14753	869	4112343	1922-06-02	1922-06-09	1
69506	4117	81151	1997-05-14	1997-06-18	1
50193	2969	4156265	2002-02-28	2002-03-21	1
9684	573	40481087	1980-08-23	1980-09-13	1
53472	3172	4112343	1991-09-30	1991-10-13	1
40276	2392	4109685	1954-10-08	1954-10-29	1
53899	3194	260139	1980-11-29	1980-12-06	1
57189	3397	4294548	1971-03-25	1971-06-24	1
7543	443	4230399	2012-05-01	2012-06-30	1
5633	332	4112343	1969-06-15	1969-06-25	1
87750	5228	260139	1958-08-10	1958-08-17	1
10727	636	4237458	2018-01-04	2018-04-04	1
9634	571	40481087	2009-09-06	2009-09-13	1
9356	552	40481087	2015-08-31	2015-09-07	1
25548	1520	40481087	2003-11-19	2003-11-26	1
63849	3776	40481087	1996-05-09	1996-05-16	1
35996	2135	4152936	1968-09-03	1968-09-17	1
9243	546	4027663	1972-11-06	1972-11-07	1
31693	1879	260139	1980-05-12	1980-05-26	1
74872	4451	260139	2001-07-08	2001-07-15	1
80555	4781	0	2002-09-29	2002-09-30	1
69684	4127	260139	1965-11-22	1965-12-06	1
7707	453	260139	2014-04-18	2014-04-25	1
31447	1860	40481087	1995-12-20	1996-01-10	1
2584	152	40481087	1989-12-05	1989-12-12	1
72995	4342	260139	1964-01-02	1964-01-09	1
37291	2211	4112343	1981-05-30	1981-06-06	1
58135	3446	260139	1972-08-01	1972-08-08	1
10369	613	4155034	1992-08-17	1992-09-07	1
50948	3019	81893	2014-03-21	2014-03-22	1
56409	3347	4112343	1956-10-05	1956-10-16	1
7827	457	4112343	1964-12-22	1965-01-03	1
41506	2470	4109685	1962-09-25	1962-10-16	1
38227	2273	192671	2016-06-25	2016-06-26	1
14754	869	4112343	1971-03-01	1971-03-14	1
69507	4117	4027663	1988-12-07	1988-12-08	1
50194	2969	40481087	1997-08-05	1997-08-26	1
9685	573	40481087	2015-11-27	2015-12-04	1
53473	3172	4155034	1982-12-20	1983-01-03	1
40277	2392	4112343	1922-06-06	1922-06-17	1
53900	3194	321042	1983-03-28	1983-03-29	1
57190	3397	40481087	1995-01-17	1995-02-07	1
7544	443	4112343	2016-11-06	2016-11-13	1
5634	332	4283893	2004-12-19	2005-01-30	1
87751	5228	260139	1969-06-21	1969-06-28	1
10728	636	40481087	1972-08-13	1972-08-20	1
9635	571	40481087	2013-04-06	2013-04-13	1
9357	552	30753	1985-12-28	1985-12-29	1
26402	1568	260139	1959-04-29	1959-05-13	1
65173	3859	80502	1993-03-06	1993-03-07	1
35997	2135	40481087	1965-01-09	1965-01-30	1
9244	546	4112343	1977-07-18	1977-07-25	1
31694	1879	4155034	1988-04-16	1988-04-30	1
74873	4451	4149245	1997-02-24	1997-04-02	1
80556	4781	260139	2013-09-15	2013-09-22	1
69685	4127	4112343	1967-10-13	1967-10-25	1
7708	453	440086	1981-05-12	1985-07-09	1
32985	1960	28060	1983-05-27	1983-06-06	1
2585	152	40481087	2018-05-18	2018-05-25	1
72996	4342	372328	1958-06-30	1958-09-12	1
37292	2211	4112343	1989-09-08	1989-09-20	1
58136	3446	260139	2015-10-04	2015-10-18	1
10370	613	40481087	1945-10-30	1945-11-13	1
50949	3019	260139	2001-03-01	2001-03-15	1
56410	3347	4112343	1969-09-02	1969-09-15	1
7828	457	4218389	1996-09-07	1996-10-12	1
41507	2470	4112343	1974-08-09	1974-08-18	1
38228	2273	4285898	2016-04-03	2016-04-04	1
14755	869	4132546	2017-10-15	2017-10-16	1
69508	4117	4112343	1996-03-26	1996-04-07	1
50195	2969	40481087	2002-11-28	2002-12-12	1
9686	573	260139	1971-04-08	1971-04-22	1
53474	3172	40481087	1978-07-19	1978-08-02	1
40278	2392	4283893	1984-12-18	1985-01-22	1
53901	3194	28060	1957-02-27	1957-03-09	1
57191	3397	40481087	2003-06-04	2003-06-18	1
7545	443	4218389	1985-03-27	1985-04-24	1
8017	470	260139	2013-01-27	2013-02-10	1
87752	5228	4113008	2007-11-16	2007-11-30	1
10729	636	40481087	2005-05-18	2005-05-25	1
9636	571	260139	2014-05-27	2014-06-03	1
9358	552	260139	1991-08-31	1991-09-14	1
26403	1568	260139	1975-02-12	1975-02-19	1
65174	3859	260139	1926-12-25	1927-01-08	1
37636	2235	28060	1963-12-05	1963-12-17	1
9245	546	4112343	2011-03-15	2011-03-28	1
31695	1879	40481087	1960-06-03	1960-06-24	1
74874	4451	4294548	1984-09-05	1984-09-26	1
80557	4781	378001	2016-12-25	2017-02-23	1
69686	4127	4112343	1991-08-23	1991-09-05	1
7709	453	4112343	1975-04-23	1975-05-02	1
32986	1960	4112343	1935-03-15	1935-03-28	1
2586	152	81151	2017-02-26	2017-03-19	1
72997	4342	4084167	1958-10-28	1958-10-28	1
37293	2211	4285898	2006-03-03	2006-03-04	1
58137	3446	378419	2016-12-05	2016-12-06	1
10371	613	40481087	1978-06-13	1978-07-04	1
50950	3019	78272	1995-03-01	1995-03-29	1
56411	3347	4218389	1990-10-17	1990-11-07	1
7829	457	257012	1958-08-12	1958-08-13	1
41508	2470	4112343	1983-03-19	1983-03-30	1
38229	2273	40481087	1985-09-14	1985-09-21	1
14756	869	4152936	1975-09-05	1975-09-26	1
69509	4117	40481087	1998-04-08	1998-04-15	1
52772	3129	30753	2013-07-31	2013-08-01	1
9687	573	378001	2016-05-30	2016-07-29	1
53475	3172	40481087	2002-12-23	2003-01-06	1
40279	2392	40481087	1928-11-18	1928-12-02	1
53902	3194	4285898	1980-07-25	1980-07-26	1
57192	3397	40481087	2009-04-12	2009-05-03	1
7546	443	4278672	1984-03-02	1984-04-01	1
8018	470	40481087	1966-09-07	1966-09-28	1
87753	5228	40481087	1961-04-18	1961-05-09	1
10730	636	40481087	2016-03-31	2016-04-14	1
9637	571	439777	1956-08-29	1956-08-30	1
9359	552	372328	1952-03-16	1952-06-03	1
26404	1568	260139	1977-09-08	1977-09-15	1
65175	3859	260139	1931-03-10	1931-03-24	1
37637	2235	260139	2002-09-09	2002-09-16	1
9246	546	4283893	1947-06-03	1947-09-16	1
31696	1879	40481087	1965-10-02	1965-10-23	1
74875	4451	40481087	1969-09-04	1969-09-18	1
80558	4781	4142905	2007-05-17	2007-08-15	1
69687	4127	4152936	1994-03-16	1994-04-06	1
7710	453	40481087	1979-02-06	1979-02-27	1
32987	1960	4112343	1987-10-15	1987-10-25	1
2587	152	372328	1969-03-19	1969-04-02	1
72998	4342	4084167	1993-01-30	1993-01-30	1
37294	2211	40481087	1996-07-13	1996-08-03	1
58138	3446	380378	1958-04-07	1958-04-08	1
10372	613	40481087	1998-08-12	1998-08-26	1
50951	3019	192671	2015-11-29	2015-11-30	1
56412	3347	4218389	2005-04-29	2005-05-27	1
7830	457	440086	1960-08-11	1969-08-19	1
41509	2470	40481087	2008-06-24	2008-07-08	1
38230	2273	40481087	2010-08-03	2010-08-17	1
15262	905	4029498	1974-09-20	1974-09-21	1
71371	4239	80180	1990-06-07	1990-06-08	1
52773	3129	260139	2006-12-25	2007-01-08	1
9688	573	4112343	2008-04-19	2008-04-27	1
53476	3172	40481087	2003-03-14	2003-03-21	1
40280	2392	40481087	1947-07-27	1947-08-10	1
53903	3194	40481087	1952-11-25	1952-12-09	1
57193	3397	28060	1951-01-13	1951-01-25	1
7547	443	4278672	2013-05-26	2013-06-25	1
8019	470	40481087	2008-12-11	2009-01-01	1
87754	5228	40481087	1983-04-14	1983-04-21	1
10731	636	80180	1982-11-19	1982-11-20	1
9638	571	4112343	1958-04-14	1958-04-24	1
9360	552	4112343	2012-12-12	2012-12-24	1
26405	1568	372328	1956-10-09	1957-08-11	1
65176	3859	260139	1993-07-08	1993-07-22	1
37638	2235	372328	1960-02-16	1960-12-07	1
9247	546	4294548	2001-06-07	2001-07-05	1
31697	1879	40481087	1970-03-10	1970-03-24	1
74876	4451	372328	1954-06-26	1954-10-17	1
80559	4781	40481087	1983-06-29	1983-07-20	1
69688	4127	260139	1973-06-24	1973-07-01	1
7711	453	40481087	1982-09-16	1982-09-30	1
32988	1960	40481087	1938-06-01	1938-06-08	1
2588	152	40481087	1971-09-10	1971-09-17	1
72999	4342	4112343	1971-05-06	1971-05-16	1
37295	2211	4112343	1984-08-22	1984-09-03	1
58139	3446	440086	1951-12-11	1953-07-28	1
10373	613	40481087	2014-12-04	2014-12-11	1
50952	3019	4027663	2004-04-27	2004-04-28	1
56413	3347	40481087	1960-03-08	1960-03-15	1
7831	457	4059173	1958-08-07	1958-10-06	1
41510	2470	80180	1992-12-21	1992-12-22	1
38231	2273	4027663	2009-10-12	2009-10-13	1
15263	905	4283893	1982-12-10	1982-12-24	1
71372	4239	4112343	1972-01-21	1972-01-31	1
52774	3129	4112343	2012-05-05	2012-05-17	1
9689	573	4155034	1988-08-13	1988-08-27	1
53477	3172	40481087	2009-12-23	2010-01-13	1
40281	2392	40481087	2018-08-16	2018-08-23	1
53904	3194	40481087	1977-06-09	1977-06-23	1
57194	3397	260139	1980-07-05	1980-07-12	1
7548	443	40481087	1977-10-05	1977-10-19	1
8020	470	260139	2009-04-29	2009-05-06	1
87755	5228	40481087	2005-02-03	2005-02-24	1
10732	636	260139	1998-11-16	1998-11-23	1
9639	571	4113008	1958-06-10	1958-07-01	1
9361	552	4112343	2014-02-21	2014-03-03	1
26406	1568	4112343	1966-04-23	1966-05-03	1
65177	3859	261325	1987-09-10	1987-09-11	1
37639	2235	381316	2012-12-12	2012-12-13	1
9248	546	40481087	1948-03-21	1948-04-11	1
31698	1879	40481087	1995-11-03	1995-11-17	1
74877	4451	372328	1955-05-15	1956-04-22	1
80560	4781	40481087	2011-04-30	2011-05-07	1
69689	4127	372328	1949-04-19	1949-06-05	1
7712	453	40481087	1987-08-12	1987-08-19	1
32989	1960	195588	1951-07-03	1951-08-21	1
2589	152	40481087	1993-05-31	1993-06-14	1
73000	4342	4112343	1989-12-27	1990-01-06	1
37296	2211	4112343	1992-04-09	1992-04-16	1
58140	3446	4029498	1957-12-09	1957-12-10	1
10374	613	195588	1995-02-04	1995-03-27	1
50953	3019	4218389	2000-10-28	2000-12-02	1
56414	3347	81151	1986-02-26	1986-03-12	1
7832	457	4116491	2009-08-13	2009-09-17	1
41511	2470	260139	2000-01-11	2000-01-18	1
38232	2273	40481087	1988-11-12	1988-11-19	1
15264	905	4296204	2007-11-01	2007-12-06	1
71373	4239	4116491	1980-09-17	1980-10-29	1
52775	3129	4134304	1998-03-27	1998-05-26	1
9690	573	40481087	1992-12-12	1992-12-19	1
53478	3172	40481087	2016-12-14	2016-12-28	1
40282	2392	260139	1942-09-17	1942-10-01	1
54335	3222	260139	2002-11-21	2002-11-28	1
57195	3397	260139	2010-01-08	2010-01-22	1
7549	443	40481087	1977-12-25	1978-01-01	1
8021	470	372328	1955-11-07	1955-12-20	1
87756	5228	81151	1972-03-19	1972-04-23	1
10733	636	372328	1952-01-21	1952-02-15	1
9640	571	4283893	1956-04-19	1956-08-16	1
9362	552	4237458	2015-06-05	2015-09-03	1
26407	1568	40481087	1988-07-14	1988-07-28	1
65178	3859	313217	2016-04-16	2016-04-17	1
37640	2235	440086	1963-12-02	1969-12-10	1
9249	546	40481087	1953-05-21	1953-05-28	1
31699	1879	40481087	2009-01-09	2009-01-30	1
74878	4451	4059173	2003-09-28	2003-12-27	1
80561	4781	80180	2018-05-16	2018-05-17	1
69690	4127	378001	1975-01-04	1975-02-03	1
7713	453	40481087	1995-08-12	1995-09-02	1
32990	1960	195588	1955-09-29	1955-11-20	1
5576	331	80180	1974-11-08	1974-11-09	1
73001	4342	4113008	2015-08-05	2015-08-26	1
37297	2211	4134304	1997-02-03	1997-03-05	1
58141	3446	4112343	1984-04-29	1984-05-12	1
10375	613	260139	1951-07-25	1951-08-01	1
50954	3019	4237458	1992-04-15	1992-05-15	1
56415	3347	257012	1957-01-04	1957-01-05	1
12819	757	28060	1986-03-23	1986-04-05	1
41512	2470	372328	1960-09-18	1960-11-21	1
38233	2273	40481087	2001-08-08	2001-08-15	1
15265	905	40481087	1973-06-05	1973-06-26	1
71374	4239	4283893	1968-10-27	1968-11-24	1
52776	3129	40481087	1975-01-02	1975-01-09	1
9691	573	260139	2014-08-08	2014-08-22	1
53479	3172	260139	2015-12-20	2016-01-03	1
40283	2392	260139	1957-02-12	1957-02-27	1
54336	3222	372328	1956-04-19	1956-12-18	1
57196	3397	4112343	2010-04-24	2010-05-01	1
7885	461	372328	1954-05-11	1954-07-20	1
8022	470	4109685	1961-08-07	1961-08-28	1
87757	5228	195588	1966-08-05	1966-10-02	1
10734	636	4294548	1958-06-20	1958-08-01	1
9641	571	40481087	1974-10-21	1974-10-28	1
9363	552	40481087	1951-12-23	1952-01-13	1
26408	1568	260139	1960-01-22	1960-01-29	1
65179	3859	4112343	1992-04-08	1992-04-17	1
37641	2235	4266809	1983-05-21	1983-05-22	1
10019	596	255848	2005-06-13	2005-06-14	1
34819	2071	260139	1972-10-08	1972-10-22	1
74879	4451	4142905	1976-04-01	1976-05-01	1
80562	4781	260139	1998-12-03	1998-12-10	1
69691	4127	381316	2012-04-01	2012-04-02	1
7714	453	81151	1971-04-10	1971-05-08	1
32991	1960	378419	2002-11-12	2002-11-13	1
5577	331	81151	1948-08-28	1948-10-02	1
73002	4342	40481087	1977-10-25	1977-11-01	1
37298	2211	40481087	1998-01-03	1998-01-10	1
58142	3446	4112343	1990-07-14	1990-07-22	1
10376	613	260139	2015-05-15	2015-05-29	1
50955	3019	4266809	2015-10-12	2015-10-13	1
56416	3347	4112343	1999-08-12	1999-08-19	1
12820	757	255848	1998-10-17	1998-10-18	1
41513	2470	4109685	2015-08-07	2015-08-28	1
38234	2273	40481087	2015-03-03	2015-03-10	1
15266	905	0	1974-09-20	1974-09-21	1
71375	4239	40479422	1993-07-29	1993-10-04	1
52777	3129	40481087	1991-03-17	1991-03-31	1
9692	573	4112343	1963-08-24	1963-09-05	1
53480	3172	4112343	1997-02-15	1997-02-28	1
40284	2392	260139	2011-03-24	2011-03-31	1
54337	3222	4152936	2007-08-06	2007-08-27	1
57197	3397	4142905	1957-12-06	1958-02-04	1
7886	461	4112343	1966-08-01	1966-08-11	1
8023	470	4112343	1960-02-15	1960-02-22	1
87758	5228	4109685	1938-02-04	1938-02-25	1
10735	636	4294548	1993-05-26	1993-06-09	1
9642	571	40481087	1980-02-08	1980-02-29	1
9364	552	40481087	1962-04-18	1962-05-09	1
26409	1568	260139	1986-01-03	1986-01-10	1
65180	3859	4112343	2016-04-08	2016-04-20	1
37642	2235	4285898	1983-03-22	1983-03-23	1
10020	596	372328	1949-02-11	1949-04-26	1
34820	2071	372328	1968-04-01	1968-05-22	1
74880	4451	4283893	1993-07-05	1993-09-27	1
80563	4781	4112343	2016-12-14	2016-12-22	1
69692	4127	4112343	2018-10-27	2018-11-08	1
7715	453	81893	2003-04-02	2003-04-03	1
32992	1960	40481087	1939-03-10	1939-03-17	1
5578	331	196456	1997-04-18	1997-04-18	1
73003	4342	40481087	1997-08-15	1997-08-29	1
37299	2211	260139	1984-03-15	1984-03-22	1
58143	3446	4112343	1996-01-05	1996-01-14	1
10377	613	4112343	1949-08-07	1949-08-18	1
50956	3019	40481087	1978-03-09	1978-03-30	1
56417	3347	4152936	2008-06-10	2008-07-01	1
12821	757	257012	1925-01-25	1925-01-26	1
41514	2470	40481087	1974-09-28	1974-10-12	1
38235	2273	30753	2015-08-07	2015-08-08	1
15267	905	372328	1974-06-17	1975-03-01	1
71376	4239	40481087	2014-10-11	2014-11-01	1
52778	3129	40481087	1998-06-28	1998-07-19	1
9693	573	4112343	2008-08-28	2008-09-08	1
53481	3172	4237458	2004-09-16	2004-11-15	1
40285	2392	4112343	1967-01-27	1967-02-06	1
54338	3222	4237458	1959-04-20	1959-05-20	1
57198	3397	40481087	1968-11-22	1968-11-29	1
7887	461	4112343	2015-11-05	2015-11-13	1
8024	470	4112343	1989-01-14	1989-01-25	1
87759	5228	4112343	1972-01-05	1972-01-17	1
10736	636	40481087	1959-02-03	1959-02-17	1
11374	673	260139	1973-11-20	1973-11-27	1
9365	552	40481087	1967-06-17	1967-07-08	1
26410	1568	4059173	1960-03-22	1960-05-21	1
65181	3859	40481087	1950-08-18	1950-09-01	1
37643	2235	40481087	1968-06-11	1968-07-02	1
10021	596	4112343	1979-01-12	1979-01-24	1
34821	2071	40481087	1983-12-18	1984-01-08	1
74881	4451	40481087	1961-07-28	1961-08-11	1
80564	4781	40481087	1991-05-18	1991-06-08	1
69693	4127	4283893	1954-12-14	1955-03-08	1
7716	453	372328	1971-10-07	1971-10-21	1
32993	1960	40481087	1958-08-14	1958-08-28	1
5579	331	198809	1997-04-18	1997-04-18	1
74582	4435	80180	2000-10-14	2000-10-15	1
37300	2211	440086	1985-06-16	1986-10-19	1
10378	613	4112343	1997-07-27	1997-08-09	1
50957	3019	40481087	2016-07-13	2016-07-27	1
56418	3347	40481087	1979-08-10	1979-08-31	1
12822	757	375671	1991-01-06	1991-03-07	1
41515	2470	81151	1968-04-17	1968-05-15	1
38236	2273	80180	2016-05-03	2016-05-04	1
15268	905	4278672	1974-03-24	1974-06-22	1
71377	4239	260139	1971-11-20	1971-12-04	1
52779	3129	80180	2014-12-23	2014-12-24	1
9694	573	40481087	1979-11-11	1979-11-18	1
53482	3172	260139	1980-02-06	1980-02-13	1
40286	2392	4152936	1937-09-02	1937-09-16	1
54339	3222	40481087	1953-09-23	1953-10-07	1
57199	3397	40481087	2004-07-18	2004-08-01	1
7888	461	40481087	1971-08-05	1971-08-26	1
8025	470	4294548	1956-05-11	1956-06-01	1
87760	5228	4134304	1941-01-01	1941-04-01	1
10737	636	40481087	1981-03-14	1981-03-21	1
11375	673	372328	1962-09-17	1962-11-30	1
9366	552	40481087	1986-12-06	1986-12-13	1
26411	1568	4112343	1999-02-10	1999-02-18	1
65182	3859	40481087	2004-06-12	2004-06-19	1
37644	2235	40481087	1988-10-23	1988-11-06	1
10022	596	4113008	1982-09-21	1982-10-05	1
34822	2071	260139	1989-01-19	1989-01-26	1
74882	4451	40481087	2018-08-24	2018-09-07	1
80565	4781	81151	1998-10-03	1998-10-31	1
69694	4127	40481087	1953-10-30	1953-11-13	1
7717	453	4027663	1997-05-08	1997-05-09	1
32994	1960	195588	1954-08-20	1954-09-29	1
5580	331	260139	1998-05-31	1998-06-07	1
74583	4435	192671	2000-11-16	2000-11-17	1
37301	2211	4142905	1973-04-10	1973-06-09	1
10379	613	4230399	2007-03-07	2007-05-06	1
50958	3019	80180	2015-10-12	2015-10-13	1
60544	3583	372328	1971-01-24	1971-04-13	1
12823	757	378419	1989-05-07	1989-05-08	1
41516	2470	195588	1998-01-22	1998-02-27	1
38237	2273	81151	1994-05-24	1994-06-21	1
15269	905	4296204	2019-03-29	2019-04-26	1
71378	4239	375671	1971-10-23	1971-11-22	1
52780	3129	4059173	2008-08-31	2008-09-30	1
9896	587	30753	2014-03-08	2014-03-09	1
53483	3172	260139	1986-11-21	1986-11-28	1
40287	2392	40481087	2010-08-01	2010-08-22	1
54340	3222	257012	1964-10-07	1964-10-08	1
57200	3397	78272	1981-09-06	1981-10-11	1
7889	461	40481087	2000-09-07	2000-09-28	1
8026	470	372328	1958-03-09	1958-06-17	1
87761	5228	4146173	1985-11-11	1986-01-10	1
11109	656	0	1996-12-28	1996-12-29	1
11376	673	372328	1966-06-12	1966-10-14	1
10229	606	78272	1987-06-09	1987-07-14	1
26412	1568	81151	1993-01-12	1993-02-16	1
65183	3859	260139	1973-06-01	1973-06-15	1
37645	2235	28060	1992-07-19	1992-07-31	1
10023	596	4155034	2000-05-03	2000-05-17	1
34823	2071	378001	1986-11-23	1987-01-22	1
78440	4649	81151	1978-08-22	1978-09-05	1
80566	4781	440448	2002-09-29	2002-09-30	1
69695	4127	40481087	2019-03-23	2019-04-13	1
7718	453	4112343	1977-05-22	1977-05-30	1
32995	1960	372328	1932-04-28	1932-06-14	1
5581	331	260139	2004-03-27	2004-04-03	1
74584	4435	260139	1989-12-01	1989-12-08	1
37302	2211	4310024	2004-10-09	2004-10-10	1
10380	613	4283893	1987-02-07	1987-06-20	1
53653	3179	81151	1925-10-30	1925-11-20	1
60545	3583	4048171	1973-11-11	1973-11-12	1
12824	757	4112343	1925-04-27	1925-05-06	1
41517	2470	260139	2007-02-26	2007-03-12	1
38238	2273	81893	2015-05-09	2015-05-10	1
15270	905	80180	2009-04-29	2009-04-30	1
71379	4239	378419	2019-01-19	2019-01-20	1
52781	3129	4283893	2007-02-07	2007-04-04	1
9897	587	4112343	2009-06-23	2009-06-30	1
53484	3172	4112343	1977-07-23	1977-07-30	1
41910	2498	4112343	2008-06-10	2008-06-22	1
54341	3222	260139	2017-05-19	2017-05-26	1
57201	3397	4109685	1973-03-17	1973-03-31	1
7890	461	28060	1969-06-28	1969-07-06	1
8027	470	372328	1959-03-14	1959-12-22	1
87762	5228	40481087	1963-10-03	1963-10-17	1
11110	656	4112343	1979-10-06	1979-10-13	1
11377	673	4035415	2014-08-05	2014-09-04	1
10230	606	80180	2010-07-28	2010-07-29	1
26413	1568	81151	2017-12-07	2017-12-28	1
65184	3859	4112343	1965-03-18	1965-03-30	1
37646	2235	28060	2012-10-26	2012-11-06	1
10024	596	4278672	1953-09-18	1953-11-17	1
34824	2071	4112343	2006-07-24	2006-08-02	1
78441	4649	195588	2015-01-30	2015-03-16	1
81286	4827	30753	1990-05-22	1990-05-23	1
71235	4229	78272	2001-07-03	2001-07-24	1
7719	453	4112343	2000-01-03	2000-01-16	1
32996	1960	372328	1934-12-31	1935-03-26	1
5582	331	4112343	1944-01-19	1944-01-31	1
74585	4435	317576	2002-04-15	2002-04-16	1
37303	2211	40481087	2011-03-26	2011-04-09	1
10381	613	40481087	1965-11-08	1965-11-29	1
53654	3179	255848	2002-02-14	2002-02-15	1
60546	3583	4218389	1985-10-07	1985-11-11	1
12825	757	4116491	1943-12-20	1944-01-21	1
41518	2470	260139	2014-01-20	2014-01-27	1
38239	2273	4112343	1994-06-04	1994-06-11	1
15271	905	81151	1979-02-26	1979-03-12	1
71380	4239	4051466	1952-10-01	1968-01-13	1
52782	3129	40481087	1989-10-02	1989-10-16	1
9898	587	4266809	2015-06-01	2015-06-02	1
53485	3172	4112343	2016-09-17	2016-09-26	1
41911	2498	4218389	1995-08-29	1995-09-26	1
54342	3222	375671	1993-11-17	1993-12-17	1
57202	3397	4112343	2001-10-11	2001-10-24	1
7891	461	4027663	1973-07-21	1973-07-22	1
8028	470	4112343	1964-05-05	1964-05-12	1
87763	5228	40481087	2005-11-26	2005-12-03	1
11111	656	4112343	2012-07-04	2012-07-12	1
11378	673	4051466	1964-09-28	1981-01-09	1
10231	606	372328	1975-07-12	1975-10-22	1
26414	1568	4112343	2011-05-31	2011-06-09	1
65185	3859	4112343	1974-02-13	1974-02-26	1
37647	2235	80180	1983-05-21	1983-05-22	1
10025	596	40481087	1978-12-21	1979-01-11	1
34825	2071	4134304	1973-03-06	1973-05-05	1
78442	4649	260139	1999-01-06	1999-01-20	1
81287	4827	80180	1991-01-17	1991-01-18	1
71236	4229	80180	1993-09-24	1993-09-25	1
7720	453	4112343	2017-05-19	2017-05-29	1
32997	1960	4027663	1959-07-01	1959-07-02	1
5583	331	4112343	2018-11-30	2018-12-10	1
74586	4435	4294548	1996-04-18	1996-05-23	1
37304	2211	80180	2007-01-27	2007-01-28	1
10382	613	40481087	1966-12-31	1967-01-14	1
53655	3179	260139	1996-02-04	1996-02-11	1
60547	3583	260139	1988-01-26	1988-02-09	1
12826	757	4218389	1940-10-22	1940-11-19	1
41519	2470	372328	1959-09-11	1959-11-23	1
38240	2273	4266809	2016-05-03	2016-05-04	1
15272	905	260139	1973-01-30	1973-02-13	1
71381	4239	4112343	2018-08-12	2018-08-20	1
52783	3129	260139	1972-02-13	1972-02-20	1
9899	587	40481087	1986-06-17	1986-07-08	1
53486	3172	40481087	1991-09-28	1991-10-05	1
41912	2498	40481087	1987-09-15	1987-09-29	1
54343	3222	4112343	2015-09-06	2015-09-14	1
57203	3397	4134304	1956-01-16	1956-02-15	1
7892	461	4310024	1983-05-15	1983-05-16	1
8029	470	4112343	1965-10-06	1965-10-15	1
87764	5228	40481087	2012-02-07	2012-02-28	1
11112	656	40481087	1966-10-22	1966-11-12	1
11379	673	4296205	1983-03-20	1983-04-10	1
10232	606	378001	1976-01-08	1976-02-07	1
26415	1568	4112343	2012-12-03	2012-12-16	1
65186	3859	4112343	1996-08-25	1996-09-07	1
37648	2235	40481087	1953-12-30	1954-01-20	1
10026	596	28060	1981-12-12	1981-12-22	1
34826	2071	4134304	1977-02-13	1977-03-15	1
78443	4649	260139	2010-05-03	2010-05-17	1
81288	4827	4112343	2017-12-29	2018-01-07	1
71237	4229	260139	2011-10-20	2011-10-27	1
7721	453	4296205	2004-02-05	2004-03-04	1
32998	1960	4112343	1944-01-13	1944-01-21	1
5584	331	4294548	1983-10-23	1984-01-22	1
74587	4435	81151	2018-11-11	2018-12-09	1
37305	2211	81893	2005-08-05	2005-08-06	1
10383	613	4001336	1954-08-07	1954-10-06	1
53656	3179	378419	1993-07-31	1993-08-01	1
60548	3583	4084167	1971-11-20	1971-11-20	1
12827	757	40481087	1934-02-03	1934-02-10	1
41520	2470	4112343	1981-08-15	1981-08-24	1
38241	2273	4310024	2015-02-08	2015-02-09	1
15273	905	372328	1972-06-25	1972-08-26	1
71382	4239	81151	1951-09-10	1951-10-08	1
52784	3129	4112343	2003-03-02	2003-03-10	1
9900	587	80180	2015-06-01	2015-06-02	1
53487	3172	40481087	1993-07-31	1993-08-07	1
41913	2498	40481087	2012-03-30	2012-04-13	1
54344	3222	4294548	1964-09-16	1965-01-27	1
57204	3397	4285898	1981-08-27	1981-08-28	1
7893	461	80502	2018-12-18	2018-12-19	1
8030	470	4112343	2017-10-26	2017-11-03	1
87765	5228	28060	2015-05-03	2015-05-15	1
11113	656	40481087	1999-05-20	1999-05-27	1
11380	673	40481087	1989-08-21	1989-08-28	1
10233	606	4112343	1992-03-28	1992-04-04	1
26416	1568	80180	1993-05-13	1993-05-14	1
65187	3859	4283893	1982-02-20	1982-03-20	1
37649	2235	40481087	1989-10-07	1989-10-28	1
10027	596	80180	1984-02-28	1984-02-29	1
34827	2071	81151	2005-12-13	2006-01-03	1
78444	4649	4112343	2004-11-18	2004-11-27	1
81289	4827	4116491	1994-11-27	1995-01-06	1
71238	4229	4112343	1970-11-11	1970-11-20	1
7722	453	30753	2003-06-01	2003-06-02	1
32999	1960	4112343	1950-11-17	1950-11-24	1
5585	331	40481087	1965-09-26	1965-10-10	1
74588	4435	81893	2000-01-18	2000-01-19	1
37306	2211	257012	2013-07-18	2013-07-19	1
10384	613	4112343	1973-09-26	1973-10-05	1
53657	3179	4112343	1928-02-04	1928-02-14	1
60549	3583	4112343	1989-08-21	1989-08-29	1
12828	757	40481087	1998-09-07	1998-09-28	1
41521	2470	4112343	2004-07-09	2004-07-22	1
39955	2372	28060	1977-11-13	1977-11-20	1
15274	905	372328	1989-01-16	1991-05-18	1
71383	4239	372328	1951-03-14	1951-09-01	1
52785	3129	40481087	1985-03-27	1985-04-17	1
9901	587	260139	1980-11-07	1980-11-14	1
53488	3172	40481087	2000-02-11	2000-03-03	1
41914	2498	40481087	2018-10-18	2018-11-01	1
54345	3222	40481087	1957-12-23	1958-01-13	1
57205	3397	4310024	1980-05-04	1980-05-05	1
7894	461	260139	1953-03-27	1953-04-03	1
8031	470	40481087	1971-12-10	1971-12-31	1
87766	5228	192671	1969-01-21	1969-01-22	1
11114	656	28060	1971-06-06	1971-06-19	1
11381	673	28060	1987-05-10	1987-05-21	1
10234	606	40481087	1999-03-28	1999-04-18	1
26417	1568	4112343	2009-06-27	2009-07-08	1
65188	3859	40480160	1995-10-23	1996-01-21	1
37650	2235	40481087	2001-08-01	2001-08-08	1
10028	596	260139	1958-02-26	1958-03-12	1
34828	2071	40481087	1986-09-03	1986-09-17	1
78445	4649	4112343	2017-12-23	2018-01-02	1
81290	4827	40481087	1971-12-28	1972-01-04	1
71239	4229	4237458	1957-03-02	1957-05-01	1
7723	453	81151	1992-04-17	1992-05-08	1
33000	1960	4112343	1968-08-05	1968-08-12	1
5586	331	260139	1968-01-10	1968-01-24	1
74589	4435	260139	1982-03-15	1982-03-29	1
37307	2211	260139	2001-08-16	2001-08-23	1
10385	613	4112343	1994-10-26	1994-11-06	1
53658	3179	4310024	1956-01-21	1956-01-22	1
60550	3583	80180	2002-11-12	2002-11-13	1
12829	757	192671	1950-01-22	1950-01-23	1
41522	2470	4112343	2019-05-07	2019-05-20	1
39956	2372	260139	1965-05-02	1965-05-16	1
15275	905	4027663	1999-09-14	1999-09-15	1
71384	4239	372328	1954-06-17	1954-11-20	1
52786	3129	40481087	2006-03-14	2006-04-04	1
9902	587	260139	1983-02-17	1983-02-24	1
53489	3172	40481087	2018-09-27	2018-10-04	1
41915	2498	81151	1982-12-23	1983-01-06	1
54346	3222	80180	1993-03-12	1993-03-13	1
57206	3397	40481087	1956-05-24	1956-05-31	1
7895	461	260139	2011-03-11	2011-03-18	1
8032	470	40481087	1995-10-29	1995-11-12	1
87767	5228	260139	1937-01-11	1937-01-18	1
11115	656	30753	2006-07-17	2006-07-18	1
11382	673	81151	2012-05-26	2012-06-16	1
10235	606	28060	2008-04-12	2008-04-25	1
26418	1568	4156265	1964-09-27	1964-10-11	1
65189	3859	40481087	1926-12-03	1926-12-17	1
37651	2235	30753	1982-05-26	1982-05-27	1
10029	596	4112343	1951-01-03	1951-01-15	1
34829	2071	80180	2004-05-22	2004-05-23	1
78446	4649	80180	2003-05-28	2003-05-29	1
81291	4827	260139	1982-05-20	1982-05-27	1
71240	4229	40481087	1960-04-15	1960-05-06	1
7724	453	80180	2004-05-26	2004-05-27	1
33001	1960	4218389	1973-08-17	1973-09-21	1
5587	331	4112343	1957-12-21	1957-12-30	1
74590	4435	4027663	1990-12-26	1990-12-27	1
37308	2211	4283893	2013-06-06	2013-09-05	1
10386	613	40481087	1953-11-06	1953-11-27	1
53659	3179	40481087	1929-11-16	1929-11-23	1
60551	3583	4084167	1975-07-05	1975-07-05	1
12830	757	313217	1976-01-11	1976-01-12	1
41523	2470	4116491	1993-12-06	1994-01-23	1
39957	2372	4112343	1975-03-10	1975-03-18	1
15276	905	40481087	1980-06-24	1980-07-15	1
71385	4239	4112343	1953-11-01	1953-11-14	1
52787	3129	40481087	2012-04-15	2012-04-29	1
9903	587	4283893	1994-06-02	1994-07-07	1
54101	3208	80180	2011-04-21	2011-04-22	1
41916	2498	40481087	1973-01-09	1973-01-23	1
54347	3222	260139	1959-04-30	1959-05-14	1
57207	3397	40481087	1978-11-21	1978-11-28	1
7896	461	381316	1998-01-06	1998-01-07	1
8033	470	40481087	1996-04-19	1996-05-10	1
87768	5228	260139	1971-03-04	1971-03-11	1
11116	656	80180	2008-04-07	2008-04-08	1
11383	673	4112343	1995-02-09	1995-02-19	1
10236	606	4142905	1992-01-19	1992-03-19	1
26419	1568	4237458	1967-07-28	1967-10-26	1
65190	3859	40481087	1952-09-27	1952-10-04	1
37652	2235	81151	1959-03-28	1959-04-25	1
10030	596	4156265	1979-12-15	1980-01-05	1
34830	2071	260139	1976-12-08	1976-12-15	1
78447	4649	81151	2010-01-25	2010-02-15	1
81292	4827	260139	2016-02-29	2016-03-14	1
71241	4229	40481087	1988-02-13	1988-02-20	1
7725	453	372328	1976-03-28	1976-04-30	1
33002	1960	4266809	1971-05-14	1971-05-15	1
5588	331	4112343	2001-02-28	2001-03-07	1
74591	4435	4237458	2015-09-28	2015-10-28	1
37309	2211	40481087	2010-05-15	2010-05-22	1
10387	613	40481087	1954-10-28	1954-11-18	1
53660	3179	40481087	1974-06-04	1974-06-18	1
60552	3583	81151	2003-02-10	2003-03-17	1
12831	757	4112343	1921-08-05	1921-08-12	1
41524	2470	4112343	1971-10-12	1971-10-21	1
39958	2372	40481087	1986-03-18	1986-04-01	1
15277	905	40481087	2010-04-20	2010-04-27	1
71386	4239	4112343	2016-10-09	2016-10-19	1
52788	3129	28060	2009-04-09	2009-04-17	1
9904	587	40481087	2011-04-14	2011-04-28	1
54102	3208	372328	1990-03-17	1993-03-19	1
41917	2498	317576	2006-04-08	2006-04-09	1
54348	3222	372328	1952-01-27	1952-03-11	1
57208	3397	40481087	1994-03-04	1994-03-18	1
7897	461	4155034	2001-02-19	2001-03-05	1
8034	470	40481087	2013-08-13	2013-08-20	1
87769	5228	372328	1939-10-27	1940-01-25	1
11117	656	440086	1971-01-02	1971-11-06	1
11384	673	4218389	1967-05-24	1967-06-28	1
10237	606	40481087	2008-05-08	2008-05-29	1
26420	1568	40481087	1975-02-09	1975-02-16	1
65191	3859	40481087	2017-12-16	2018-01-06	1
37653	2235	81893	1982-01-26	1982-01-27	1
10031	596	40481087	1956-10-25	1956-11-01	1
34831	2071	260139	1993-04-22	1993-04-29	1
78448	4649	260139	2015-03-01	2015-03-15	1
81293	4827	372328	1954-04-16	1954-11-18	1
71242	4229	40481087	1993-05-30	1993-06-13	1
9045	533	28060	1984-05-08	1984-05-17	1
33003	1960	4294548	1950-07-24	1950-09-18	1
5589	331	4112343	2009-12-22	2009-12-30	1
74592	4435	40481087	1988-09-12	1988-09-19	1
38044	2261	30753	2000-08-22	2000-08-23	1
10388	613	40481087	1986-03-30	1986-04-06	1
53661	3179	40481087	1978-11-03	1978-11-17	1
60553	3583	4112343	1999-03-12	1999-03-22	1
12832	757	4116491	1941-11-01	1941-12-20	1
48697	2889	4112343	1961-08-13	1961-08-26	1
39959	2372	0	1967-04-02	1967-04-03	1
15278	905	28060	1972-01-18	1972-01-29	1
71387	4239	40481087	2013-06-02	2013-06-09	1
52789	3129	260139	1998-11-07	1998-11-21	1
9905	587	257012	1994-06-23	1994-06-24	1
54103	3208	4112343	2004-01-19	2004-01-27	1
41918	2498	372328	1973-03-31	1973-06-16	1
54349	3222	381316	2012-10-30	2012-10-31	1
60736	3599	80180	2006-06-10	2006-06-11	1
7898	461	28060	1954-07-15	1954-07-24	1
8035	470	80180	1989-06-26	1989-06-27	1
87770	5228	4027663	1960-06-13	1960-06-14	1
11118	656	4112343	1972-09-14	1972-09-26	1
11385	673	4218389	1984-12-30	1985-01-27	1
10238	606	40481087	2010-02-24	2010-03-03	1
26421	1568	40481087	2003-05-20	2003-05-27	1
65192	3859	375671	1964-09-05	1964-10-05	1
37654	2235	260139	2012-03-24	2012-03-31	1
10032	596	40481087	1995-12-04	1995-12-25	1
34832	2071	4112343	1983-04-14	1983-04-22	1
78449	4649	372328	1970-02-05	1970-04-20	1
81294	4827	4059173	1983-04-28	1983-05-28	1
71243	4229	40481087	1996-05-05	1996-05-12	1
9046	533	80180	2003-11-14	2003-11-15	1
33004	1960	4294548	1979-09-10	1979-10-08	1
5590	331	4112343	2017-02-24	2017-03-08	1
74593	4435	28060	1976-08-26	1976-09-08	1
38045	2261	80180	2001-08-17	2001-08-18	1
10389	613	40481087	2002-02-12	2002-03-05	1
53662	3179	40481087	1996-03-24	1996-04-07	1
60554	3583	4142905	2018-12-23	2019-03-23	1
12833	757	4218389	1974-02-24	1974-03-17	1
48698	2889	4112343	1977-08-05	1977-08-14	1
39960	2372	28060	1984-08-17	1984-08-24	1
15279	905	260139	1997-10-07	1997-10-21	1
71388	4239	260139	1952-09-06	1952-09-13	1
52790	3129	4027663	2004-05-09	2004-05-10	1
9906	587	372328	1994-08-12	1995-05-10	1
54104	3208	4113008	1992-09-07	1992-09-21	1
41919	2498	372328	1976-05-31	1977-01-01	1
54350	3222	40481087	1994-06-03	1994-06-24	1
60737	3599	81151	1973-03-30	1973-04-27	1
7899	461	28060	1958-03-06	1958-03-15	1
8036	470	81151	1967-03-30	1967-04-13	1
87771	5228	4112343	1956-09-30	1956-10-11	1
11119	656	4266809	2008-04-07	2008-04-08	1
11386	673	81151	1978-09-28	1978-10-12	1
10239	606	260139	1978-07-27	1978-08-03	1
27440	1622	81151	2000-10-28	2000-12-02	1
65193	3859	4059173	1936-12-01	1936-12-31	1
37655	2235	40481087	1966-01-24	1966-02-14	1
10033	596	28060	1972-01-09	1972-01-17	1
34833	2071	4142905	1970-02-20	1970-05-21	1
78450	4649	40481087	1982-05-10	1982-05-31	1
81295	4827	4059173	1990-01-21	1990-02-20	1
71244	4229	40481087	2004-04-30	2004-05-14	1
9047	533	260139	1980-03-30	1980-04-06	1
33005	1960	4310024	1969-01-24	1969-01-25	1
5591	331	4218389	1956-03-24	1956-04-21	1
74594	4435	28060	2005-11-09	2005-11-17	1
38046	2261	81151	1975-08-18	1975-09-22	1
10390	613	28060	1970-01-03	1970-01-11	1
53663	3179	80502	1979-12-29	1979-12-30	1
61395	3631	4109685	2006-04-19	2006-05-03	1
12834	757	4283893	1925-01-11	1925-03-15	1
48699	2889	4112343	2010-10-01	2010-10-10	1
39961	2372	260139	1998-10-30	1998-11-13	1
15280	905	260139	2018-09-22	2018-09-29	1
71389	4239	260139	1957-01-22	1957-02-05	1
52791	3129	4112343	2012-12-17	2012-12-29	1
9907	587	4027663	2008-03-14	2008-03-15	1
54105	3208	81151	1986-04-07	1986-05-12	1
41920	2498	4112343	1975-12-19	1975-12-31	1
54351	3222	260139	1958-08-25	1958-09-01	1
60738	3599	260139	1974-12-22	1975-01-05	1
7900	461	80180	1985-01-04	1985-01-05	1
8037	470	40481087	1956-11-07	1956-11-21	1
87772	5228	4116491	1972-09-30	1972-10-31	1
11120	656	40481087	1984-08-30	1984-09-06	1
11387	673	4001336	1965-04-04	1965-06-03	1
10240	606	372328	1976-06-18	1976-07-21	1
27441	1622	260139	1995-11-14	1995-11-28	1
65194	3859	4059173	1995-10-23	1996-01-21	1
37656	2235	40481087	2002-10-10	2002-10-17	1
10034	596	40481087	1950-12-10	1950-12-17	1
34834	2071	40481087	1990-03-06	1990-03-27	1
78451	4649	81151	2002-07-31	2002-09-04	1
81296	4827	4112343	1980-08-16	1980-08-26	1
71245	4229	260139	1996-03-10	1996-03-17	1
9048	533	372328	1968-02-01	1968-07-17	1
33006	1960	78272	1936-02-07	1936-03-13	1
5592	331	4218389	2002-06-19	2002-07-24	1
74595	4435	78272	2000-03-29	2000-04-19	1
38047	2261	81151	2007-11-17	2007-12-08	1
10391	613	80180	1977-01-23	1977-01-24	1
53664	3179	260139	1988-12-19	1988-12-26	1
61396	3631	4112343	1977-12-15	1977-12-26	1
12835	757	4310024	1947-08-27	1947-08-28	1
48700	2889	440448	2017-03-07	2017-03-08	1
39962	2372	372328	1965-04-01	1965-05-14	1
15281	905	372328	1972-02-03	1972-02-26	1
71390	4239	4112343	1958-02-24	1958-03-03	1
52792	3129	40481087	1979-04-24	1979-05-08	1
9908	587	4112343	2004-05-08	2004-05-16	1
54106	3208	260139	1997-01-11	1997-01-25	1
41921	2498	4218389	1986-10-17	1986-11-14	1
54352	3222	260139	2011-01-03	2011-01-10	1
60739	3599	4112343	1966-07-06	1966-07-16	1
7901	461	81893	1983-10-12	1983-10-13	1
8038	470	40481087	1993-08-14	1993-09-04	1
87773	5228	4266809	1968-12-03	1968-12-04	1
11121	656	40481087	2004-08-28	2004-09-04	1
11388	673	40481087	1965-10-06	1965-10-20	1
10241	606	4112343	1975-12-11	1975-12-20	1
27442	1622	260139	1998-10-29	1998-11-05	1
65195	3859	40481087	1954-02-05	1954-02-19	1
37657	2235	28060	2000-10-19	2000-10-26	1
10035	596	40481087	1961-07-16	1961-07-30	1
36144	2145	28060	1968-06-30	1968-07-11	1
78452	4649	260139	2004-05-11	2004-05-18	1
81297	4827	4113008	1970-12-18	1971-01-01	1
71246	4229	4112343	1996-05-08	1996-05-18	1
9049	533	4112343	1999-01-02	1999-01-12	1
33007	1960	80180	1971-05-14	1971-05-15	1
5593	331	40481087	1968-07-03	1968-07-17	1
74596	4435	40481087	1987-07-24	1987-08-14	1
38048	2261	372328	1964-02-03	1964-04-14	1
10392	613	192671	1977-02-09	1977-02-10	1
53665	3179	4112343	1922-05-23	1922-06-02	1
61397	3631	4112343	1980-05-17	1980-05-28	1
12836	757	40481087	1916-10-05	1916-10-19	1
48701	2889	4112343	1968-05-25	1968-06-05	1
39963	2372	440448	1967-04-02	1967-04-03	1
15282	905	380378	1977-04-30	1977-05-01	1
71391	4239	4142905	1958-02-03	1958-05-04	1
52793	3129	40481087	1984-12-13	1984-12-20	1
9909	587	4310024	2013-06-11	2013-06-12	1
54107	3208	4112343	2003-09-08	2003-09-20	1
41922	2498	4237458	2018-08-26	2018-09-25	1
54353	3222	260139	2015-06-10	2015-06-24	1
60740	3599	4296204	1976-11-07	1976-12-05	1
7902	461	260139	1951-12-10	1951-12-24	1
8833	518	192671	2007-05-21	2007-05-22	1
87774	5228	40481087	1948-01-18	1948-02-01	1
11122	656	260139	2011-05-28	2011-06-04	1
11389	673	80180	1995-12-03	1995-12-04	1
10242	606	195588	1997-02-06	1997-03-10	1
27443	1622	260139	2015-04-08	2015-04-22	1
65196	3859	40481087	1981-08-03	1981-08-17	1
37658	2235	81151	1968-11-03	1968-12-01	1
10036	596	40481087	2003-03-27	2003-04-10	1
36145	2145	80180	1999-09-28	1999-09-29	1
78453	4649	4112343	1990-08-23	1990-09-01	1
81298	4827	40481087	1971-03-21	1971-03-28	1
71247	4229	4218389	1995-07-30	1995-09-03	1
9050	533	4283893	1999-06-23	1999-07-28	1
33008	1960	81893	1969-08-22	1969-08-23	1
5594	331	40481087	1969-08-18	1969-09-01	1
74597	4435	30753	2000-06-16	2000-06-17	1
38049	2261	4112343	2016-09-19	2016-10-01	1
10393	613	372328	1937-10-05	1937-10-19	1
53666	3179	4285898	1958-01-10	1958-01-11	1
61398	3631	40481087	1980-11-03	1980-11-17	1
12837	757	40481087	1951-02-07	1951-02-28	1
48702	2889	4112343	2009-12-23	2010-01-03	1
39964	2372	4112343	1992-04-27	1992-05-07	1
15283	905	4112343	1969-06-19	1969-06-30	1
71392	4239	4218389	2001-09-22	2001-10-13	1
55383	3285	28060	1963-01-26	1963-02-04	1
9910	587	372328	1983-10-22	1984-03-07	1
54108	3208	4142905	1975-10-02	1975-11-01	1
41923	2498	80180	2007-11-18	2007-11-19	1
54354	3222	378001	1998-09-22	1998-11-21	1
60741	3599	40481087	1998-11-14	1998-11-21	1
7903	461	260139	1955-04-24	1955-05-01	1
8834	518	372328	1971-01-26	1971-03-09	1
87775	5228	78272	1939-01-21	1939-02-11	1
11123	656	4027663	1995-12-27	1995-12-28	1
11390	673	81151	1998-03-20	1998-04-03	1
10243	606	260139	2004-02-20	2004-02-27	1
27444	1622	4112343	1997-09-20	1997-10-02	1
65197	3859	80180	1957-11-26	1957-11-27	1
37659	2235	372328	1955-07-17	1955-11-09	1
10037	596	28060	1952-07-09	1952-07-20	1
36146	2145	81151	2015-06-05	2015-06-19	1
78454	4649	4112343	2018-03-04	2018-03-12	1
81299	4827	40481087	1973-07-03	1973-07-10	1
71248	4229	40481087	1984-06-06	1984-06-27	1
9051	533	4155034	1971-04-16	1971-05-07	1
33009	1960	260139	1955-09-27	1955-10-11	1
5595	331	40481087	2009-12-21	2010-01-11	1
74598	4435	4112343	1973-07-31	1973-08-08	1
38050	2261	40481087	2000-08-02	2000-08-09	1
10394	613	4112343	1978-07-12	1978-07-20	1
53667	3179	40481087	1922-11-22	1922-11-29	1
61399	3631	40481087	1993-04-20	1993-05-04	1
12838	757	40481087	1956-11-05	1956-11-26	1
48703	2889	40481087	1970-11-29	1970-12-20	1
39965	2372	4283893	1994-06-27	1994-08-08	1
15284	905	4112343	2010-01-10	2010-01-22	1
71393	4239	4283893	1952-02-13	1952-03-19	1
55384	3285	78272	1964-05-17	1964-06-14	1
11480	679	81893	2007-03-25	2007-03-26	1
54109	3208	4152936	2001-03-08	2001-03-29	1
41924	2498	81151	1972-08-03	1972-08-17	1
54355	3222	4112343	1971-03-19	1971-03-28	1
60742	3599	28060	1979-10-10	1979-10-22	1
7904	461	260139	1993-02-07	1993-02-14	1
8835	518	372328	1973-01-27	1973-06-05	1
87776	5228	80180	1968-12-03	1968-12-04	1
11124	656	4112343	1966-02-24	1966-03-03	1
11391	673	4149245	2005-11-22	2005-12-29	1
10244	606	378001	1996-11-23	1997-01-22	1
27445	1622	4112343	2006-07-21	2006-08-02	1
65198	3859	260139	1949-08-25	1949-09-08	1
37660	2235	4027663	1976-11-28	1976-11-29	1
10038	596	372328	1950-10-18	1951-01-23	1
36147	2145	4112343	1971-05-30	1971-06-08	1
78455	4649	4278672	1984-05-06	1984-06-05	1
81300	4827	40481087	1987-10-03	1987-10-24	1
71249	4229	40481087	1999-05-04	1999-05-18	1
9052	533	4155034	1988-08-05	1988-08-19	1
33010	1960	260139	1983-10-04	1983-10-11	1
5596	331	257012	1983-12-11	1983-12-12	1
74599	4435	4156265	1978-04-03	1978-04-24	1
38051	2261	260139	1974-01-13	1974-01-20	1
10395	613	4116491	1988-12-25	1989-02-05	1
53668	3179	40481087	1971-12-04	1971-12-11	1
61400	3631	260139	1989-05-24	1989-05-31	1
12839	757	40481087	1981-04-24	1981-05-15	1
48704	2889	0	2017-03-07	2017-03-08	1
39966	2372	78272	2007-07-11	2007-07-25	1
15285	905	4152936	1988-02-23	1988-03-15	1
71394	4239	40479422	2019-04-12	2019-05-19	1
55385	3285	257012	2010-07-17	2010-07-18	1
11481	679	260139	1996-08-01	1996-08-15	1
54110	3208	40481087	1968-03-17	1968-03-31	1
41925	2498	260139	1992-01-22	1992-02-05	1
54356	3222	4283893	1996-06-21	1996-09-27	1
60743	3599	260139	2018-08-29	2018-09-05	1
7905	461	372328	1950-06-17	1950-07-01	1
8836	518	375671	1989-10-18	1989-11-17	1
87777	5228	81893	1967-09-10	1967-09-11	1
11125	656	4112343	1980-01-13	1980-01-23	1
11392	673	40481087	2003-08-23	2003-09-06	1
10245	606	4296205	2013-12-24	2014-01-07	1
27446	1622	40481087	1998-07-13	1998-07-27	1
65199	3859	260139	1954-10-15	1954-10-22	1
37661	2235	40481087	1974-06-07	1974-06-14	1
10039	596	4043241	2001-03-06	2001-03-07	1
36148	2145	4112343	1974-02-23	1974-03-03	1
78456	4649	40481087	1995-06-17	1995-06-24	1
81301	4827	40481087	2014-12-17	2014-12-31	1
71250	4229	40481087	2018-10-05	2018-10-19	1
9053	533	40481087	1975-12-29	1976-01-05	1
33011	1960	4059173	2007-01-26	2007-03-27	1
5597	331	260139	1999-12-31	2000-01-14	1
74600	4435	4285898	2000-09-14	2000-09-15	1
38052	2261	260139	2012-03-31	2012-04-07	1
10396	613	4155034	2002-04-18	2002-05-02	1
53669	3179	40481087	1972-07-15	1972-08-05	1
61401	3631	260139	1994-03-03	1994-03-10	1
12840	757	40481087	1987-04-22	1987-04-29	1
48705	2889	80180	2002-02-23	2002-02-24	1
39967	2372	4112343	1970-04-22	1970-05-02	1
15286	905	4218389	2008-10-01	2008-10-22	1
71395	4239	40481087	1976-12-21	1977-01-04	1
55386	3285	260139	1981-04-15	1981-04-29	1
11482	679	4027663	1999-04-01	1999-04-02	1
54111	3208	4296205	2016-02-09	2016-02-23	1
41926	2498	4112343	1985-11-09	1985-11-19	1
54357	3222	40481087	2013-12-04	2013-12-11	1
60744	3599	4146173	2015-03-16	2015-05-22	1
7906	461	4112343	1950-12-17	1950-12-29	1
8837	518	4027663	1999-06-23	1999-06-24	1
87778	5228	260139	1949-03-10	1949-03-24	1
11126	656	4146173	2011-03-24	2011-04-30	1
12263	727	81151	1944-05-17	1944-06-07	1
10246	606	40481087	1985-08-23	1985-08-30	1
27447	1622	80180	2012-12-08	2012-12-09	1
65200	3859	260139	1971-09-24	1971-10-08	1
37662	2235	40481087	1975-09-16	1975-09-23	1
10040	596	4113008	1962-10-01	1962-10-15	1
36149	2145	4134304	1965-12-10	1966-02-08	1
78457	4649	40481087	1997-11-09	1997-11-30	1
81302	4827	40481087	2015-09-06	2015-09-27	1
71251	4229	28060	1953-10-16	1953-10-27	1
9054	533	40481087	1989-11-28	1989-12-05	1
33012	1960	4112343	1958-11-16	1958-11-25	1
5598	331	260139	2006-11-20	2006-12-04	1
74601	4435	40481087	2018-09-03	2018-09-10	1
38053	2261	260139	2017-04-12	2017-04-26	1
10397	613	40481087	1956-01-17	1956-01-24	1
53670	3179	260139	1970-04-09	1970-04-23	1
61402	3631	4296204	1980-04-30	1980-06-04	1
12841	757	260139	1940-10-09	1940-10-23	1
48706	2889	81151	2007-06-12	2007-07-17	1
39968	2372	4155034	1974-04-14	1974-05-05	1
15287	905	4266809	2009-04-29	2009-04-30	1
73899	4394	28060	1978-03-22	1978-04-04	1
55387	3285	4112343	1994-09-13	1994-09-23	1
11483	679	4283893	1973-09-06	1973-10-11	1
54112	3208	40481087	1984-07-12	1984-08-02	1
41927	2498	4112343	1996-10-25	1996-11-06	1
55628	3296	28060	1949-09-29	1949-10-08	1
60745	3599	260139	2012-11-19	2012-11-26	1
7907	461	4112343	1988-05-31	1988-06-11	1
8838	518	4134304	1977-04-24	1977-05-24	1
87779	5228	372328	1952-05-21	1953-04-09	1
11127	656	4218389	1999-09-27	1999-11-01	1
12264	727	260139	1926-11-26	1926-12-03	1
14640	865	81151	1983-01-13	1983-02-03	1
27448	1622	260139	1982-03-09	1982-03-23	1
65201	3859	372328	1923-05-14	1923-08-25	1
39327	2334	313217	2011-06-23	2011-06-24	1
10041	596	40481087	1965-06-17	1965-06-24	1
36150	2145	40481087	1992-03-13	1992-04-03	1
78458	4649	372328	1971-06-14	1971-07-19	1
81303	4827	81893	1989-06-26	1989-06-27	1
71252	4229	81151	1974-07-29	1974-08-19	1
9055	533	257012	1999-07-21	1999-07-28	1
33013	1960	4156265	1969-11-15	1969-12-06	1
5599	331	40481087	1951-04-08	1951-04-29	1
74602	4435	40481087	2018-11-15	2018-12-06	1
38054	2261	4112343	2006-02-05	2006-02-12	1
10398	613	40481087	1969-11-08	1969-11-22	1
53671	3179	260139	1987-06-13	1987-06-27	1
61403	3631	40481087	1994-02-05	1994-02-12	1
12842	757	260139	1990-05-21	1990-05-28	1
48707	2889	260139	1961-06-15	1961-06-22	1
39969	2372	28060	1966-07-27	1966-08-09	1
15288	905	4294548	1998-12-30	1999-01-13	1
73900	4394	81151	1978-02-18	1978-03-11	1
55388	3285	4112343	1995-09-21	1995-10-01	1
11484	679	28060	1978-05-10	1978-05-17	1
60070	3561	4112343	1965-08-24	1965-09-04	1
41928	2498	4278672	1997-10-15	1997-11-14	1
55629	3296	81151	1963-09-04	1963-10-02	1
60746	3599	372328	1971-06-09	1972-04-21	1
7908	461	4112343	1992-03-26	1992-04-07	1
8839	518	4285898	2006-12-13	2006-12-14	1
87780	5228	4112343	1970-04-03	1970-04-12	1
11128	656	40481087	1967-05-18	1967-06-08	1
12265	727	260139	1927-04-03	1927-04-17	1
14641	865	372328	1974-03-31	1975-08-13	1
27449	1622	260139	2002-06-12	2002-06-26	1
65202	3859	378001	2017-03-31	2017-05-30	1
39328	2334	372328	1936-02-29	1936-05-07	1
10042	596	40481087	1994-05-30	1994-06-06	1
36151	2145	40481087	1998-11-03	1998-11-17	1
78459	4649	40481087	1992-04-17	1992-04-24	1
81304	4827	134438	1967-12-11	1968-09-11	1
71253	4229	372328	1959-08-14	1960-06-25	1
9056	533	260139	1981-05-29	1981-06-12	1
33014	1960	4283893	1995-04-22	1995-06-17	1
5600	331	40481087	1963-05-04	1963-05-18	1
76550	4543	28060	1988-08-23	1988-09-02	1
38055	2261	40481087	1988-01-29	1988-02-12	1
10399	613	40481087	1989-04-15	1989-04-22	1
53672	3179	4112343	1933-11-15	1933-11-23	1
61404	3631	40481087	2000-07-15	2000-07-22	1
12843	757	4027663	1939-11-02	1939-11-03	1
48708	2889	4112343	1995-02-13	1995-02-26	1
39970	2372	80180	1997-12-09	1997-12-10	1
15289	905	40481087	1995-11-25	1995-12-09	1
73901	4394	4112343	1985-05-28	1985-06-07	1
55389	3285	40481087	1965-10-02	1965-10-09	1
11485	679	28060	1984-10-27	1984-11-09	1
60071	3561	4112343	1972-02-04	1972-02-15	1
43231	2578	4112343	1990-08-14	1990-08-26	1
55630	3296	260139	2004-07-04	2004-07-18	1
60747	3599	40481087	1976-05-19	1976-06-02	1
7909	461	4146173	2005-02-12	2005-04-13	1
8840	518	81151	1995-10-17	1995-10-31	1
87781	5228	4237458	2013-08-30	2013-09-29	1
11129	656	40481087	1969-11-01	1969-11-08	1
12266	727	372328	1914-08-23	1914-10-09	1
14642	865	4112343	1969-04-14	1969-04-22	1
27450	1622	4156265	2015-02-08	2015-02-22	1
65203	3859	4112343	1931-06-03	1931-06-12	1
39329	2334	378419	2018-08-02	2018-08-03	1
12097	718	260139	1983-10-26	1983-11-09	1
36152	2145	260139	1968-06-29	1968-07-13	1
78460	4649	40481087	1996-05-26	1996-06-09	1
81305	4827	260139	1995-02-02	1995-02-09	1
71254	4229	4112343	1954-11-24	1954-12-01	1
9057	533	4112343	2002-12-26	2003-01-05	1
33015	1960	40481087	1937-06-06	1937-06-27	1
5601	331	40481087	1963-11-20	1963-11-27	1
76551	4543	372328	1981-07-29	1981-08-12	1
38056	2261	40481087	1989-10-10	1989-10-31	1
10975	649	28060	1979-09-12	1979-09-22	1
53673	3179	40481087	1944-12-27	1945-01-17	1
61405	3631	4112343	1991-09-02	1991-09-14	1
12844	757	4112343	1942-02-03	1942-02-12	1
48709	2889	40481087	2001-05-18	2001-06-08	1
39971	2372	372328	1966-07-08	1967-05-26	1
23019	1376	78272	1999-12-16	2000-01-13	1
73902	4394	4237458	2000-08-12	2000-11-10	1
55390	3285	40481087	1972-09-28	1972-10-19	1
11486	679	30753	2007-11-20	2007-11-21	1
60072	3561	4112343	2013-08-06	2013-08-16	1
43232	2578	40481087	2014-12-04	2014-12-25	1
55631	3296	372328	1937-11-02	1937-12-03	1
60748	3599	40481087	1982-07-10	1982-07-24	1
7910	461	4299128	2017-05-10	2017-06-14	1
8841	518	372328	1974-10-02	1975-06-10	1
87782	5228	4285898	1968-03-08	1968-03-09	1
11130	656	440448	1996-12-28	1996-12-29	1
12267	727	4059173	1991-04-23	1991-06-22	1
14643	865	260139	1945-09-01	1945-09-08	1
27451	1622	40481087	1984-03-03	1984-03-24	1
65204	3859	4112343	1980-05-27	1980-06-08	1
39330	2334	4059173	1964-08-14	1964-10-13	1
12098	718	440086	1978-02-23	1978-03-30	1
36153	2145	260139	1978-07-27	1978-08-03	1
78461	4649	40481087	2003-10-07	2003-10-21	1
81306	4827	4112343	1983-03-18	1983-03-29	1
71255	4229	4112343	1983-03-21	1983-03-31	1
9058	533	4112343	2007-11-14	2007-11-27	1
33016	1960	40481087	1961-02-19	1961-03-12	1
5602	331	40481087	1966-10-14	1966-11-04	1
76552	4543	40481087	1998-11-16	1998-11-30	1
38057	2261	81151	1994-04-15	1994-04-29	1
10976	649	28060	1985-05-25	1985-06-04	1
53674	3179	80180	1958-12-06	1958-12-07	1
61406	3631	80180	2010-08-06	2010-08-07	1
12845	757	4112343	1961-02-06	1961-02-15	1
48710	2889	28060	1969-09-29	1969-10-12	1
39972	2372	4112343	1977-05-08	1977-05-15	1
23020	1376	260139	2007-09-11	2007-09-25	1
73903	4394	4112343	1993-10-27	1993-11-03	1
55391	3285	40481087	1978-02-25	1978-03-18	1
11487	679	4285898	2008-08-16	2008-08-17	1
60073	3561	4113008	1998-08-22	1998-09-12	1
43233	2578	81151	1990-12-10	1990-12-24	1
55632	3296	4059173	1949-02-19	1949-03-21	1
60749	3599	40481087	1983-08-23	1983-08-30	1
7911	461	40481087	1994-08-01	1994-08-15	1
8842	518	40481087	1971-05-03	1971-05-17	1
87783	5228	40481087	1942-02-20	1942-03-13	1
11131	656	4109685	2004-10-05	2004-10-26	1
12268	727	4112343	1934-05-07	1934-05-16	1
14644	865	260139	1992-07-22	1992-08-05	1
27452	1622	28060	1989-01-21	1989-01-31	1
65205	3859	4112343	2009-02-05	2009-02-12	1
39331	2334	4112343	1975-06-05	1975-06-15	1
12099	718	4112343	1971-11-01	1971-11-12	1
36154	2145	260139	1989-09-05	1989-09-19	1
78462	4649	40481087	2008-08-04	2008-08-25	1
81307	4827	4112343	1992-11-07	1992-11-14	1
71256	4229	4112343	2005-12-30	2006-01-06	1
9059	533	4112343	2015-07-22	2015-07-30	1
34529	2052	80180	2003-07-13	2003-07-14	1
5603	331	372328	1936-10-23	1937-04-08	1
76553	4543	40481087	2014-01-06	2014-01-20	1
38058	2261	81893	2000-07-23	2000-07-24	1
10977	649	321042	2011-01-25	2011-01-26	1
53675	3179	378001	1943-08-18	1943-10-17	1
61407	3631	260139	1978-09-10	1978-09-17	1
12846	757	4112343	1964-01-04	1964-01-15	1
48711	2889	378001	1997-07-04	1997-08-03	1
39973	2372	4112343	1991-06-22	1991-06-29	1
23021	1376	260139	2012-07-17	2012-07-24	1
73904	4394	40481087	2006-08-27	2006-09-10	1
55392	3285	40481087	1980-01-27	1980-02-10	1
11488	679	40481087	1983-03-12	1983-04-02	1
60074	3561	4134304	1943-12-04	1944-01-03	1
43234	2578	260139	1971-12-21	1971-12-28	1
55633	3296	4237458	2019-02-08	2019-04-09	1
60750	3599	40481087	2001-02-15	2001-03-08	1
7912	461	40481087	2000-01-25	2000-02-01	1
8843	518	40481087	2018-02-25	2018-03-11	1
87784	5228	40481087	1956-07-23	1956-08-06	1
11132	656	4112343	1972-10-29	1972-11-07	1
12269	727	4134304	1998-01-16	1998-04-16	1
14645	865	260139	2000-01-01	2000-01-08	1
27453	1622	260139	1978-04-07	1978-04-21	1
65206	3859	40481087	1990-02-14	1990-02-21	1
39332	2334	4294548	1965-11-16	1965-11-30	1
12100	718	4112343	1978-08-10	1978-08-21	1
36155	2145	260139	1993-09-09	1993-09-23	1
80915	4805	257012	1972-06-06	1972-06-07	1
81308	4827	4112343	1993-08-15	1993-08-24	1
71257	4229	4155034	1953-05-17	1953-05-31	1
9060	533	4116491	1991-07-25	1991-09-07	1
34530	2052	260139	2015-03-03	2015-03-10	1
5604	331	378001	1946-09-08	1946-11-07	1
76554	4543	80180	2017-10-13	2017-10-14	1
38059	2261	372328	1964-08-12	1964-10-13	1
10978	649	4112343	1972-05-26	1972-06-02	1
53676	3179	381316	1987-05-23	1987-05-24	1
61408	3631	260139	2015-03-22	2015-03-29	1
12847	757	4283893	1932-06-11	1932-08-06	1
48712	2889	4112343	2007-10-25	2007-11-03	1
39974	2372	40481087	1987-07-04	1987-07-25	1
23022	1376	439777	1979-11-11	1979-11-12	1
73905	4394	80180	2013-02-04	2013-02-05	1
55393	3285	28060	1978-11-13	1978-11-22	1
11489	679	40481087	2003-12-10	2003-12-31	1
60075	3561	4156265	1997-09-12	1997-09-26	1
43235	2578	260139	1972-12-31	1973-01-07	1
55634	3296	4283893	1997-12-03	1998-05-27	1
63138	3733	260139	1984-04-28	1984-05-12	1
7913	461	40481087	2011-01-12	2011-02-02	1
8844	518	28060	1982-05-14	1982-05-22	1
11133	656	4156265	2012-05-24	2012-06-07	1
12270	727	40481087	1952-05-16	1952-05-30	1
14646	865	4310024	1978-11-10	1978-11-11	1
27454	1622	40481087	1980-06-02	1980-06-16	1
66529	3941	192671	1999-08-10	1999-08-11	1
39333	2334	4294548	1973-11-25	1973-12-02	1
12101	718	4113008	1967-03-23	1967-04-13	1
36156	2145	372328	1976-07-17	1976-10-02	1
80916	4805	260139	1996-03-30	1996-04-13	1
81309	4827	4112343	2008-05-10	2008-05-19	1
71258	4229	78272	1956-02-15	1956-03-07	1
9061	533	4142905	1979-07-24	1979-08-23	1
34531	2052	40481087	2005-04-24	2005-05-08	1
5605	331	4112343	1993-01-28	1993-02-06	1
76555	4543	260139	1984-04-16	1984-04-30	1
38060	2261	372328	1990-11-30	1992-01-14	1
10979	649	260139	1973-08-16	1973-08-23	1
53677	3179	4027663	1948-10-24	1948-10-25	1
61409	3631	4237458	1981-03-31	1981-04-30	1
12848	757	40481087	1947-08-08	1947-08-22	1
48713	2889	40481087	1991-11-07	1991-11-14	1
39975	2372	40481087	2017-02-17	2017-02-24	1
23023	1376	4112343	1992-06-26	1992-07-09	1
73906	4394	260139	2014-05-12	2014-05-26	1
55394	3285	260139	1962-07-28	1962-08-04	1
11490	679	40481087	2007-11-16	2007-12-07	1
60076	3561	4283893	1911-10-31	1912-01-23	1
43236	2578	372328	2003-04-06	2004-10-21	1
55635	3296	40481087	1950-07-20	1950-08-10	1
63139	3733	260139	2003-04-10	2003-04-24	1
12697	753	81151	1968-08-19	1968-09-02	1
8845	518	81893	2006-07-16	2006-07-17	1
11134	656	4285898	2007-06-12	2007-06-13	1
12271	727	40481087	2003-01-01	2003-01-15	1
14647	865	40481087	2010-05-16	2010-06-06	1
27455	1622	40481087	2014-03-14	2014-03-21	1
66530	3941	260139	1964-10-30	1964-11-13	1
39334	2334	40481087	1965-04-22	1965-04-29	1
12102	718	4218389	2007-06-10	2007-07-08	1
36157	2145	372328	1969-02-22	1969-08-23	1
80917	4805	260139	2019-02-13	2019-02-20	1
81310	4827	4285898	1990-12-18	1990-12-19	1
71259	4229	78272	1967-07-08	1967-08-05	1
9062	533	4218389	1997-02-03	1997-03-03	1
34532	2052	260139	1964-02-24	1964-03-09	1
5606	331	4294548	1993-10-28	1994-01-06	1
76556	4543	375671	1997-03-28	1997-05-27	1
38061	2261	4027663	1992-10-28	1992-10-29	1
10980	649	4142905	1978-04-26	1978-06-25	1
53678	3179	4059173	1932-10-14	1933-01-12	1
61410	3631	40481087	2002-02-20	2002-03-06	1
12849	757	28060	1926-05-05	1926-05-15	1
48714	2889	40481087	1995-04-04	1995-04-11	1
42344	2526	372328	1976-08-14	1976-11-29	1
23024	1376	40481087	1981-03-02	1981-03-16	1
73907	4394	4112343	2004-03-13	2004-03-21	1
55395	3285	260139	1996-02-26	1996-03-11	1
11491	679	80180	2009-02-12	2009-02-13	1
60077	3561	4294548	1951-10-23	1952-01-08	1
43237	2578	4112343	1988-11-09	1988-11-21	1
55636	3296	40481087	1959-05-30	1959-06-20	1
63140	3733	4112343	2003-06-01	2003-06-08	1
12698	753	260139	1978-10-14	1978-10-21	1
8846	518	260139	2015-03-07	2015-03-21	1
11135	656	40481087	1964-07-11	1964-07-25	1
12272	727	40481087	2008-07-24	2008-07-31	1
14648	865	81151	1993-04-11	1993-04-25	1
27456	1622	78272	1998-11-17	1998-12-08	1
66531	3941	260139	1969-06-20	1969-06-27	1
39335	2334	40481087	2005-09-02	2005-09-23	1
12103	718	40481087	1991-04-20	1991-05-11	1
36158	2145	40481087	1965-10-20	1965-11-03	1
80918	4805	4296204	2016-10-24	2016-11-14	1
81311	4827	4310024	1989-04-27	1989-04-28	1
71260	4229	134438	1979-06-22	1980-06-16	1
9063	533	4278672	1963-06-27	1963-08-26	1
34533	2052	260139	1973-03-28	1973-04-04	1
5607	331	40479422	1942-09-22	1942-10-29	1
76557	4543	4109685	2001-06-05	2001-06-26	1
38062	2261	260139	1990-05-30	1990-06-13	1
10981	649	4218389	1974-03-13	1974-04-17	1
53679	3179	4155034	1944-09-11	1944-09-25	1
63888	3779	4112343	1978-09-05	1978-09-13	1
12850	757	28060	1928-05-07	1928-05-14	1
48715	2889	40481087	2005-10-20	2005-11-03	1
42345	2526	4112343	1982-05-16	1982-05-27	1
23025	1376	40481087	1985-08-24	1985-09-07	1
73908	4394	40481087	1983-11-26	1983-12-17	1
55396	3285	321042	2011-03-12	2011-03-13	1
11492	679	4112343	1981-12-28	1982-01-09	1
60078	3561	40481087	1967-11-24	1967-12-15	1
43238	2578	4146173	1975-05-03	1975-07-02	1
55637	3296	40481087	1972-02-24	1972-03-09	1
63141	3733	40481087	1999-07-27	1999-08-03	1
12699	753	260139	2007-01-17	2007-01-24	1
8847	518	372328	1974-04-01	1974-06-04	1
11136	656	40481087	1989-09-18	1989-10-09	1
12273	727	260139	1917-04-10	1917-04-24	1
14649	865	260139	1972-07-28	1972-08-04	1
27457	1622	81151	2011-11-05	2011-11-26	1
66532	3941	4027663	1990-01-15	1990-01-16	1
39336	2334	258780	1960-02-11	1960-02-12	1
12104	718	321042	1974-10-19	1974-10-20	1
36159	2145	40481087	1966-02-07	1966-02-21	1
80919	4805	40481087	1963-12-25	1964-01-15	1
81312	4827	40481087	1964-02-01	1964-02-08	1
71261	4229	260139	1963-06-26	1963-07-10	1
9064	533	40481087	2000-07-01	2000-07-22	1
34534	2052	260139	1978-05-04	1978-05-18	1
5608	331	40481087	1937-06-27	1937-07-18	1
76558	4543	40481087	1992-10-05	1992-10-12	1
38063	2261	372328	1969-07-19	1969-10-21	1
10982	649	0	2011-01-25	2011-01-26	1
53680	3179	40481087	1925-01-22	1925-02-05	1
63889	3779	4266809	2003-01-16	2003-01-17	1
12851	757	80180	1949-11-14	1949-11-15	1
51833	3077	80180	1992-05-03	1992-05-04	1
42346	2526	4113008	2012-04-19	2012-05-03	1
23026	1376	40481087	1993-04-06	1993-04-27	1
76696	4550	78272	1980-01-08	1980-02-05	1
55397	3285	4112343	1988-04-06	1988-04-13	1
11493	679	260139	2007-11-01	2007-11-15	1
60079	3561	40481087	1974-11-15	1974-11-29	1
43239	2578	40481087	2010-11-28	2010-12-19	1
55638	3296	40481087	1979-05-07	1979-05-14	1
63142	3733	4112343	1987-01-13	1987-01-24	1
12700	753	378001	2006-03-31	2006-04-30	1
8848	518	40481087	1982-09-25	1982-10-09	1
11137	656	40481087	1992-07-03	1992-07-17	1
12274	727	260139	1949-09-20	1949-09-27	1
14650	865	4146173	2006-01-08	2006-02-07	1
27458	1622	4112343	1977-02-13	1977-02-22	1
66533	3941	4112343	1965-06-13	1965-06-20	1
39337	2334	381316	2015-08-27	2015-08-28	1
12105	718	378001	2014-02-01	2014-03-03	1
36160	2145	28060	2013-08-09	2013-08-21	1
80920	4805	40481087	1981-03-20	1981-04-10	1
81313	4827	40481087	1968-04-22	1968-04-29	1
71262	4229	260139	1963-08-10	1963-08-24	1
9065	533	40481087	2005-04-05	2005-04-19	1
34535	2052	260139	2013-02-02	2013-02-09	1
5609	331	40481087	1944-08-19	1944-09-02	1
76559	4543	40481087	1984-08-20	1984-09-10	1
38064	2261	4112343	1984-08-19	1984-08-28	1
10983	649	28060	1975-09-19	1975-10-02	1
53681	3179	40481087	1939-10-11	1939-10-18	1
63890	3779	378001	1995-12-19	1996-02-17	1
12852	757	81151	1988-10-13	1988-11-17	1
51834	3077	192671	1992-05-08	1992-05-09	1
42347	2526	40479422	1996-06-30	1996-09-05	1
23027	1376	40481087	1996-08-18	1996-09-08	1
76697	4550	372328	1968-02-23	1968-08-25	1
55398	3285	4112343	2019-06-11	2019-06-21	1
11494	679	260139	2011-06-11	2011-06-18	1
60080	3561	192671	1944-01-20	1944-01-21	1
43240	2578	4218389	2015-06-16	2015-07-14	1
55639	3296	40481087	2000-04-24	2000-05-08	1
63143	3733	40481087	2006-06-27	2006-07-11	1
12701	753	4112343	1976-02-26	1976-03-08	1
8849	518	40481087	1996-06-06	1996-06-13	1
11138	656	40481087	1999-08-03	1999-08-17	1
12275	727	378419	2008-02-01	2008-02-02	1
14651	865	40481087	1974-01-05	1974-01-19	1
27459	1622	40481087	1984-05-29	1984-06-05	1
66534	3941	4112343	2014-07-05	2014-07-17	1
39338	2334	4059173	1942-11-24	1943-02-22	1
12106	718	40479422	1970-03-28	1970-05-04	1
36161	2145	4035415	1982-03-16	1982-04-15	1
80921	4805	260139	1983-07-07	1983-07-21	1
81314	4827	40481087	2006-07-22	2006-08-05	1
71263	4229	260139	1985-05-05	1985-05-19	1
9066	533	4048171	1966-08-07	1981-08-05	1
34536	2052	28060	1987-03-26	1987-04-07	1
5610	331	40481087	1992-06-15	1992-06-29	1
76560	4543	4218389	1984-07-13	1984-08-03	1
38065	2261	4152936	1973-10-13	1973-10-27	1
10984	649	257012	2011-04-29	2011-04-30	1
53682	3179	40481087	1957-12-19	1958-01-09	1
63891	3779	4027663	1995-03-29	1995-03-30	1
12853	757	81893	1948-05-23	1948-05-24	1
51835	3077	260139	2013-04-01	2013-04-08	1
42348	2526	40481087	1988-04-10	1988-04-17	1
23028	1376	80180	2019-04-20	2019-04-21	1
76698	4550	40481087	1976-06-19	1976-07-10	1
55399	3285	40481087	1970-08-19	1970-09-02	1
11495	679	40481087	1975-11-05	1975-11-19	1
60081	3561	257012	1911-12-12	1911-12-13	1
43241	2578	80180	2008-04-04	2008-04-05	1
55640	3296	0	1938-09-26	1938-09-27	1
63144	3733	78272	1980-07-17	1980-08-21	1
12702	753	4266809	2005-08-05	2005-08-06	1
8850	518	80180	2007-05-12	2007-05-13	1
12516	742	260139	1926-06-10	1926-06-24	1
12276	727	4112343	1916-11-11	1916-11-22	1
14652	865	40481087	1981-01-19	1981-02-02	1
27460	1622	40481087	1984-10-10	1984-10-31	1
66535	3941	4310024	1997-12-09	1997-12-10	1
39339	2334	4112343	1939-02-15	1939-02-22	1
12107	718	40481087	1992-11-07	1992-11-14	1
36162	2145	4112343	2016-12-04	2016-12-17	1
80922	4805	260139	1999-08-12	1999-08-26	1
81315	4827	40481087	2014-03-31	2014-04-14	1
71264	4229	260139	2008-08-14	2008-08-28	1
11090	655	4112343	1989-09-05	1989-09-18	1
34537	2052	260139	2000-11-29	2000-12-06	1
14036	830	0	1973-11-24	1973-11-25	1
76561	4543	40481087	2002-04-20	2002-05-04	1
38066	2261	4237458	1993-02-19	1993-05-20	1
10985	649	260139	2010-03-23	2010-04-06	1
54081	3207	28060	1971-02-09	1971-02-22	1
63892	3779	4112343	1985-12-08	1985-12-15	1
12854	757	260139	1935-05-24	1935-06-07	1
51836	3077	375671	2006-04-14	2006-05-14	1
42349	2526	40481087	2001-09-25	2001-10-02	1
23029	1376	260139	1986-11-25	1986-12-09	1
76699	4550	28060	1977-09-07	1977-09-20	1
55400	3285	40481087	1980-04-16	1980-04-30	1
11496	679	40481087	1980-07-04	1980-07-18	1
60082	3561	260139	1930-09-23	1930-09-30	1
43242	2578	260139	2008-03-06	2008-03-20	1
55641	3296	78272	1971-03-24	1971-04-21	1
63145	3733	80180	2011-03-22	2011-03-23	1
12703	753	372328	1970-12-07	1971-02-28	1
8851	518	4112343	1981-03-07	1981-03-19	1
12517	742	261325	1960-03-28	1960-03-29	1
12277	727	4237458	1988-08-06	1988-09-05	1
14653	865	40481087	2004-11-04	2004-11-18	1
27461	1622	40481087	1995-03-16	1995-03-23	1
66536	3941	40481087	1988-05-22	1988-05-29	1
39340	2334	4112343	1999-07-23	1999-07-30	1
12108	718	40481087	2018-11-05	2018-11-12	1
36163	2145	4113008	1993-10-14	1993-10-28	1
80923	4805	4112343	1985-08-26	1985-09-02	1
81316	4827	260139	2006-07-12	2006-07-19	1
71265	4229	372328	1998-01-07	1998-05-23	1
11091	655	40481087	2005-02-19	2005-02-26	1
34538	2052	4112343	2012-04-26	2012-05-04	1
14037	830	4112343	1985-05-11	1985-05-21	1
76562	4543	40481087	2018-05-06	2018-05-20	1
38067	2261	40481087	1986-06-16	1986-06-30	1
10986	649	4027663	1998-02-05	1998-02-06	1
54082	3207	372328	1963-08-12	1963-11-21	1
63893	3779	4218389	2012-06-20	2012-07-18	1
12855	757	4113008	1978-09-22	1978-10-06	1
51837	3077	4027663	1980-05-21	1980-05-22	1
42350	2526	4113008	2004-05-17	2004-05-31	1
23030	1376	372328	1979-12-31	1980-04-18	1
76700	4550	80180	2000-11-13	2000-11-14	1
55401	3285	0	2011-03-12	2011-03-13	1
11497	679	40481087	1998-12-17	1998-12-31	1
60083	3561	260139	2002-06-13	2002-06-27	1
43243	2578	4112343	1971-01-28	1971-02-09	1
55642	3296	80180	1980-06-26	1980-06-27	1
63146	3733	372328	1979-05-07	1979-10-16	1
12704	753	4112343	2013-02-08	2013-02-17	1
8852	518	4237458	2013-07-28	2013-08-27	1
12518	742	372328	1930-09-16	1931-03-02	1
12278	727	40480160	1998-01-16	1998-04-16	1
14654	865	40481087	2006-05-17	2006-05-31	1
29352	1740	80180	1989-10-12	1989-10-13	1
66537	3941	40481087	1992-01-14	1992-01-21	1
39341	2334	4152936	1977-06-21	1977-07-05	1
12109	718	260139	2016-01-27	2016-02-03	1
36931	2189	28060	1998-04-02	1998-04-11	1
80924	4805	40481087	2006-09-26	2006-10-03	1
81317	4827	4027663	1979-12-01	1979-12-02	1
71266	4229	4112343	1984-11-22	1984-12-03	1
11092	655	81151	2000-04-29	2000-05-13	1
34539	2052	4218389	2014-06-30	2014-07-28	1
14038	830	4112343	1994-06-19	1994-06-30	1
78155	4633	28060	1991-03-26	1991-04-05	1
38068	2261	40481087	1999-06-16	1999-06-30	1
10987	649	4112343	1987-06-26	1987-07-09	1
54083	3207	40481087	1963-06-26	1963-07-10	1
63894	3779	80180	2003-01-16	2003-01-17	1
12856	757	4146173	1917-09-23	1917-10-23	1
51838	3077	4035415	1979-11-18	1979-12-18	1
42351	2526	4218389	2014-04-23	2014-05-21	1
23031	1376	4112343	2002-07-03	2002-07-14	1
76701	4550	4112343	1966-10-21	1966-11-01	1
55402	3285	80180	1997-11-25	1997-11-26	1
14981	884	260139	1985-08-21	1985-08-28	1
60084	3561	375671	1927-08-30	1927-09-29	1
43244	2578	40481087	1996-11-13	1996-12-04	1
55643	3296	257012	1998-01-14	1998-01-15	1
63147	3733	372328	1981-04-08	1981-10-27	1
12705	753	4112343	2017-03-31	2017-04-07	1
8853	518	4310024	2006-05-17	2006-05-18	1
12519	742	4218389	1961-04-27	1961-06-01	1
12279	727	40481087	1930-01-04	1930-01-25	1
14655	865	40481087	2017-07-08	2017-07-22	1
29353	1740	4112343	1955-06-27	1955-07-08	1
66538	3941	40481087	2001-12-03	2001-12-17	1
39342	2334	40481087	1951-10-28	1951-11-11	1
12110	718	4112343	1986-02-11	1986-02-22	1
36932	2189	4112343	1999-07-07	1999-07-20	1
80925	4805	40481087	2008-08-29	2008-09-12	1
81318	4827	4112343	1963-05-03	1963-05-15	1
71267	4229	40481087	1999-12-23	2000-01-13	1
11093	655	260139	1991-12-12	1991-12-19	1
34540	2052	0	2015-10-19	2015-10-20	1
14039	830	40481087	1961-08-21	1961-09-04	1
78156	4633	260139	1965-06-05	1965-06-19	1
38069	2261	40481087	2002-09-04	2002-09-11	1
10988	649	4112343	2013-10-24	2013-10-31	1
54084	3207	40481087	1972-06-19	1972-06-26	1
63895	3779	260139	1975-08-07	1975-08-14	1
12857	757	4285898	1949-02-17	1949-02-18	1
51839	3077	4109685	1972-03-10	1972-03-31	1
42352	2526	40481087	1983-03-19	1983-04-02	1
23032	1376	40481087	1982-02-18	1982-03-04	1
76702	4550	4134304	1971-03-26	1971-04-25	1
55403	3285	372328	1962-06-27	1962-10-20	1
14982	884	260139	2006-07-11	2006-07-25	1
60085	3561	378001	1970-06-15	1970-08-14	1
43245	2578	40481087	2018-01-14	2018-01-21	1
55644	3296	260139	1944-05-17	1944-05-24	1
63148	3733	134438	1997-11-12	1998-11-07	1
12706	753	4156265	1997-08-31	1997-09-14	1
10597	624	80180	1978-04-30	1978-05-01	1
12520	742	80180	1968-02-19	1968-02-20	1
12280	727	40481087	1984-05-31	1984-06-14	1
14656	865	28060	1955-12-10	1955-12-23	1
29354	1740	4112343	1977-07-16	1977-07-25	1
66539	3941	40481087	2006-03-01	2006-03-08	1
39343	2334	40481087	1965-09-05	1965-09-12	1
12111	718	4296204	1992-09-05	1992-09-26	1
36933	2189	4112343	2012-04-15	2012-04-24	1
80926	4805	192671	2003-08-18	2003-08-19	1
81319	4827	4278672	1963-08-27	1963-10-26	1
73731	4384	28060	1991-10-03	1991-10-15	1
11094	655	4112343	1973-11-07	1973-11-16	1
34541	2052	321042	2015-10-19	2015-10-20	1
14040	830	40481087	2000-08-22	2000-08-29	1
78157	4633	372328	1960-09-28	1960-11-01	1
41320	2460	260139	2012-10-11	2012-10-18	1
10989	649	4266809	2007-05-29	2007-05-30	1
54085	3207	40481087	1993-07-02	1993-07-23	1
63896	3779	372328	1975-02-07	1975-03-15	1
13626	806	257012	1991-08-02	2002-11-26	1
51840	3077	4112343	1973-12-06	1973-12-17	1
42353	2526	40481087	1990-06-06	1990-06-20	1
23033	1376	260139	2004-09-06	2004-09-13	1
76703	4550	40481087	1974-03-14	1974-04-04	1
55404	3285	4112343	1998-02-19	1998-03-02	1
14983	884	321042	2005-05-24	2005-05-25	1
60086	3561	4059173	2010-06-11	2010-07-11	1
48205	2861	78272	2019-06-19	2019-06-20	1
55645	3296	372328	1937-07-22	1937-09-03	1
63149	3733	372328	1976-09-06	1976-10-19	1
12707	753	40481087	1978-10-13	1978-10-27	1
10598	624	4134304	2019-05-27	2019-05-28	1
12521	742	260139	1974-08-14	1974-08-21	1
12281	727	40481087	1999-06-06	1999-06-13	1
14657	865	80180	1980-06-02	1980-06-03	1
29355	1740	4112343	1986-05-10	1986-05-18	1
66540	3941	40481087	2013-08-18	2013-09-08	1
39344	2334	40481087	1992-06-22	1992-07-06	1
12112	718	0	1974-10-19	1974-10-20	1
36934	2189	40481087	2002-01-18	2002-02-08	1
80927	4805	317576	2017-10-27	2017-10-28	1
82046	4872	195588	1953-07-25	1953-09-01	1
73732	4384	78272	1999-10-01	1999-10-22	1
11095	655	4112343	1986-09-13	1986-09-20	1
37204	2206	81893	2006-10-20	2006-10-21	1
14041	830	80180	1995-08-04	1995-08-05	1
78158	4633	4109685	2014-10-11	2014-10-25	1
41321	2460	372328	1988-04-06	1988-07-13	1
10990	649	40481087	1985-04-19	1985-05-03	1
54086	3207	0	1994-12-01	1994-12-02	1
63897	3779	4285898	2002-07-20	2002-07-21	1
13627	806	260139	1971-02-17	1971-03-03	1
51841	3077	4112343	1975-03-13	1975-03-21	1
42354	2526	80180	2012-12-28	2012-12-29	1
23034	1376	4112343	1995-04-27	1995-05-08	1
76704	4550	40481087	1989-12-06	1989-12-13	1
55405	3285	4155034	1980-06-04	1980-06-18	1
14984	884	4230399	1989-06-08	1989-09-06	1
60087	3561	4112343	1917-08-23	1917-09-03	1
48206	2861	4112343	1980-10-17	1980-10-30	1
55646	3296	380378	1966-09-18	1966-09-19	1
63150	3733	375671	2011-10-08	2011-12-07	1
12708	753	28060	1973-04-27	1973-05-08	1
10599	624	40481087	1998-02-21	1998-02-28	1
12522	742	378001	2003-01-13	2003-03-14	1
12282	727	28060	1920-02-06	1920-02-17	1
14658	865	260139	1957-06-05	1957-06-12	1
29356	1740	4116491	2012-09-05	2012-10-11	1
66541	3941	40481087	2016-03-03	2016-03-24	1
39345	2334	81151	1951-06-10	1951-06-24	1
12113	718	80180	2005-09-29	2005-09-30	1
36935	2189	134438	2010-02-02	2011-09-26	1
80928	4805	4109685	1972-05-04	1972-05-18	1
82047	4872	257012	2007-04-06	2007-04-07	1
73733	4384	260139	1978-10-17	1978-10-24	1
11096	655	4112343	2008-09-20	2008-09-30	1
37205	2206	260139	2006-08-25	2006-09-08	1
14042	830	81151	1965-11-19	1965-12-24	1
78159	4633	4283893	1975-06-20	1975-08-29	1
41322	2460	4112343	2016-10-20	2016-10-30	1
10991	649	80180	2007-05-29	2007-05-30	1
54087	3207	372328	1961-06-28	1961-11-16	1
63898	3779	28060	1970-07-07	1970-07-18	1
13628	806	260139	2009-01-18	2009-01-25	1
51842	3077	4142905	1968-01-01	1968-03-01	1
42355	2526	81151	2000-07-16	2000-08-06	1
23035	1376	4134304	1983-06-13	1983-09-11	1
76705	4550	40481087	1994-05-26	1994-06-09	1
55406	3285	40481087	1959-05-21	1959-05-28	1
14985	884	40479768	2011-12-29	2012-02-04	1
60088	3561	4218389	1979-04-29	1979-05-20	1
48207	2861	4112343	2013-11-13	2013-11-24	1
55647	3296	440448	1938-09-26	1938-09-27	1
63151	3733	40481087	1988-06-11	1988-06-18	1
12709	753	30753	2005-01-07	2005-01-08	1
10600	624	40481087	2010-04-19	2010-05-03	1
12523	742	4112343	1970-02-05	1970-02-18	1
12283	727	80180	1947-05-12	1947-05-13	1
14659	865	4027663	1970-04-16	1970-04-17	1
29357	1740	40481087	1980-06-14	1980-06-28	1
66542	3941	40481087	2019-01-15	2019-01-29	1
39346	2334	4109685	2005-06-13	2005-06-27	1
12114	718	260139	2000-04-22	2000-05-06	1
36936	2189	4112343	2009-10-13	2009-10-24	1
80929	4805	40481087	1986-01-22	1986-02-05	1
82048	4872	260139	1944-05-29	1944-06-12	1
73734	4384	372328	1968-02-11	1968-06-24	2
11097	655	40481087	2014-08-14	2014-09-04	1
37206	2206	4112343	1984-09-29	1984-10-12	1
14043	830	372328	1962-06-22	1962-10-31	1
78160	4633	4310024	1991-02-15	1991-02-16	1
41323	2460	4112343	2006-08-17	2006-08-29	1
10992	649	372328	1970-07-02	1970-07-16	1
54088	3207	440086	1972-12-07	1975-01-30	1
63899	3779	78272	2003-06-10	2003-07-08	1
13629	806	372328	1962-01-03	1962-12-16	1
51843	3077	4218389	1963-03-02	1963-03-30	1
42356	2526	40481087	1988-06-24	1988-07-08	1
23036	1376	4146173	1987-07-22	1987-08-21	1
76706	4550	4112343	1999-04-01	1999-04-14	1
55407	3285	40481087	1978-11-21	1978-11-28	1
14986	884	40481087	1996-10-02	1996-10-16	1
60089	3561	4283893	1947-02-22	1947-05-10	1
48208	2861	28060	1999-01-16	1999-01-29	1
55648	3296	4029498	1966-09-18	1966-09-19	1
63152	3733	40481087	2006-02-05	2006-02-19	1
12710	753	260139	1999-11-30	1999-12-14	1
10601	624	40481087	2013-02-07	2013-02-14	1
12524	742	4237458	1991-11-12	1992-01-11	1
12284	727	80502	1993-04-23	1993-04-24	1
14660	865	4112343	1987-04-22	1987-05-03	1
29358	1740	0	1952-09-06	1952-09-07	1
66543	3941	195588	1992-01-15	1992-02-17	1
39347	2334	4112343	1977-09-03	1977-09-14	1
12115	718	40481087	1968-02-22	1968-02-29	1
36937	2189	40481087	1989-09-21	1989-10-05	1
80930	4805	80180	2003-07-01	2003-07-02	1
82049	4872	260139	1952-08-14	1952-08-21	1
73735	4384	372328	1982-01-12	1982-11-15	1
11098	655	78272	1964-06-18	1964-07-09	1
37207	2206	40481087	2005-11-26	2005-12-03	1
14044	830	440448	1973-11-24	1973-11-25	1
78161	4633	80180	1992-09-07	1992-09-08	1
41324	2460	4112343	2015-05-17	2015-05-28	1
10993	649	4278672	1972-11-18	1973-02-16	1
54089	3207	4112343	2011-12-21	2011-12-29	1
63900	3779	4310024	2001-06-25	2001-06-26	1
13630	806	4027663	1986-12-23	1986-12-24	1
51844	3077	4218389	1965-04-18	1965-05-16	1
42357	2526	40481087	2002-06-04	2002-06-11	1
23037	1376	40481087	2011-01-29	2011-02-05	1
76707	4550	4112343	2002-12-26	2003-01-02	1
55408	3285	4113008	1970-11-10	1970-11-24	1
14987	884	0	2005-05-24	2005-05-25	1
60090	3561	40481087	1954-11-30	1954-12-14	1
48209	2861	257012	1965-03-26	1965-03-27	1
55649	3296	4237458	2016-02-24	2016-05-24	1
64407	3811	80502	2000-08-24	2000-08-25	1
12711	753	40481087	1970-02-15	1970-02-22	1
10602	624	81151	1968-07-27	1968-08-17	1
12525	742	40481087	1945-03-06	1945-03-27	1
12285	727	260139	1951-08-04	1951-08-11	1
14661	865	4112343	2002-10-13	2002-10-20	1
29359	1740	260139	1988-08-09	1988-08-16	1
66544	3941	195588	1993-02-16	1993-03-22	1
39348	2334	4142905	1979-06-25	1979-07-25	1
12116	718	40481087	1976-01-23	1976-01-30	1
36938	2189	4112343	2003-04-01	2003-04-14	1
80931	4805	260139	2003-08-28	2003-09-04	1
82050	4872	375671	1961-09-06	1961-10-06	1
73736	4384	260139	2008-11-27	2008-12-11	1
11099	655	80180	2003-06-19	2003-06-20	1
37208	2206	30753	2007-06-17	2007-06-18	1
14045	830	4113008	1981-09-22	1981-10-06	1
78162	4633	192671	1992-09-27	1992-09-28	1
41325	2460	4152936	1991-04-04	1991-04-18	1
10994	649	4294548	2011-04-15	2011-10-07	1
54090	3207	40481087	1984-01-31	1984-02-14	1
63901	3779	40481087	1981-02-10	1981-02-17	1
13631	806	4134304	2010-01-03	2010-04-03	1
51845	3077	40481087	1953-06-27	1953-07-04	1
42358	2526	372328	1977-04-28	1977-05-30	1
26615	1578	80180	1986-05-16	1986-05-17	1
76708	4550	40481087	1974-10-07	1974-10-21	1
55409	3285	4283893	2010-06-19	2010-11-06	1
14988	884	80180	2017-09-16	2017-09-17	1
60091	3561	30753	1942-11-14	1942-11-15	1
48210	2861	260139	2010-11-25	2010-12-09	1
55650	3296	40481087	1963-08-05	1963-08-12	1
64408	3811	81151	1985-10-05	1985-11-09	1
12712	753	40481087	2005-12-28	2006-01-18	1
10603	624	4142905	1957-01-30	1957-03-31	1
12526	742	40481087	1992-03-26	1992-04-02	1
12286	727	372328	1915-04-07	1915-10-08	1
14662	865	4285898	1980-03-04	1980-03-05	1
29360	1740	4112343	1994-08-06	1994-08-16	1
66545	3941	40481087	1982-01-20	1982-01-27	1
39349	2334	40481087	1973-06-29	1973-07-20	1
20349	1227	28060	1967-01-21	1967-02-02	1
36939	2189	4156265	1988-09-18	1988-10-02	1
80932	4805	4294548	1972-05-09	1972-06-27	1
82051	4872	4112343	1976-05-08	1976-05-16	1
73737	4384	4084167	1976-03-31	1976-03-31	1
11100	655	195588	1989-01-14	1989-02-25	1
37209	2206	80180	2008-03-13	2008-03-14	1
14046	830	4218389	1970-08-30	1970-09-20	1
78163	4633	372328	1959-07-23	1959-11-03	1
41326	2460	40481087	2010-05-30	2010-06-20	1
10995	649	40481087	1986-03-04	1986-03-18	1
54091	3207	81151	1982-11-05	1982-12-10	1
63902	3779	40481087	1991-09-28	1991-10-12	1
13632	806	4218389	2012-03-23	2012-04-27	1
51846	3077	40481087	1963-07-30	1963-08-06	1
42359	2526	40481087	1986-11-19	1986-12-10	1
26616	1578	195588	1977-03-29	1977-05-03	1
76709	4550	40481087	1980-01-29	1980-02-19	1
55410	3285	40481087	1978-05-25	1978-06-15	1
14989	884	4112343	1981-10-16	1981-10-23	1
60092	3561	80180	1943-11-09	1943-11-10	1
48211	2861	372328	1965-05-28	1965-10-11	1
55651	3296	260139	1948-10-02	1948-10-09	1
64409	3811	260139	1932-05-17	1932-05-24	1
12713	753	40481087	2007-08-31	2007-09-14	1
10604	624	4237458	2011-07-17	2011-09-15	1
12527	742	40481087	2010-12-02	2010-12-09	1
12287	727	4113008	1969-08-25	1969-09-15	1
14663	865	4296204	1998-12-25	1999-01-15	1
29361	1740	4134304	2010-08-24	2010-09-23	1
66546	3941	80180	1999-08-01	1999-08-02	1
39350	2334	40481087	1983-06-18	1983-07-02	1
20350	1227	257012	1983-09-07	1983-09-08	1
36940	2189	80180	2012-11-16	2012-11-17	1
82276	4886	260139	1984-03-10	1984-03-17	1
82052	4872	4112343	2013-11-10	2013-11-18	1
73738	4384	4109685	1968-03-12	1968-03-26	1
11101	655	40481087	1972-10-10	1972-10-31	1
37210	2206	260139	2017-09-09	2017-09-23	1
14047	830	40481087	1972-01-08	1972-01-22	1
78164	4633	4112343	2002-07-09	2002-07-16	1
41327	2460	40481087	2017-12-18	2018-01-08	1
13718	812	260139	1996-09-26	1996-10-10	1
54092	3207	260139	1968-07-22	1968-08-05	1
63903	3779	40481087	1996-02-24	1996-03-09	1
13633	806	4294548	1991-07-05	1991-09-13	1
51847	3077	78272	1991-09-16	1991-09-30	1
43174	2574	81151	1973-01-30	1973-03-06	1
26617	1578	4112343	1981-12-27	1982-01-04	1
76710	4550	40481087	1985-04-02	1985-04-23	1
55411	3285	40481087	1997-10-03	1997-10-17	1
14990	884	4155034	1984-09-11	1984-10-02	1
60093	3561	260139	1977-07-15	1977-07-22	1
48212	2861	372328	1966-11-05	1967-04-10	1
55652	3296	260139	1998-04-22	1998-04-29	1
64410	3811	260139	1932-08-24	1932-09-07	1
12714	753	40481087	2019-01-21	2019-02-04	1
10605	624	4294548	1945-03-13	1945-05-08	1
12528	742	28060	1933-07-29	1933-08-10	1
12288	727	4152936	2013-10-24	2013-11-07	1
18503	1115	260139	2000-10-11	2000-10-25	1
29362	1740	4266809	1989-10-12	1989-10-13	1
66547	3941	40481087	1983-06-26	1983-07-10	1
39351	2334	40481087	2017-01-01	2017-01-08	1
20351	1227	317576	2013-03-20	2013-03-21	1
36941	2189	260139	1981-03-31	1981-04-07	1
82277	4886	4112343	1980-07-02	1980-07-09	1
82053	4872	4155034	1926-12-29	1927-01-12	1
73739	4384	4294548	2018-01-24	2018-03-07	1
11102	655	81151	1999-06-06	1999-07-04	1
37211	2206	372328	1976-03-30	1976-11-12	1
14048	830	40481087	1985-08-18	1985-09-01	1
78165	4633	4285898	1992-06-09	1992-06-10	1
41328	2460	80180	2018-02-16	2018-02-17	1
13719	812	260139	2006-07-06	2006-07-13	1
54093	3207	4237458	1960-10-01	1960-12-30	1
63904	3779	40481087	2001-08-15	2001-08-29	1
13634	806	40481087	2002-05-03	2002-05-17	1
51848	3077	4112343	1983-02-10	1983-02-23	1
43175	2574	81151	1982-08-31	1982-09-28	1
26618	1578	40481087	1962-08-03	1962-08-24	1
76711	4550	40481087	1989-03-11	1989-04-01	1
56186	3334	81151	2017-09-12	2017-10-03	1
14991	884	4237458	2007-02-25	2007-05-26	1
60094	3561	4001336	1954-08-08	1954-09-07	1
48213	2861	378001	2014-05-16	2014-07-15	1
55653	3296	378419	2018-08-17	2018-08-18	1
64411	3811	4112343	1965-08-30	1965-09-07	1
12715	753	80180	2005-08-05	2005-08-06	1
10606	624	4294548	2010-09-07	2010-10-19	1
12529	742	28060	1990-03-29	1990-04-09	1
12289	727	40481087	1932-08-08	1932-08-22	1
18504	1115	4048171	1950-07-12	1950-07-13	1
29363	1740	40481087	1984-08-14	1984-09-04	1
66548	3941	40481087	2008-12-28	2009-01-04	1
39352	2334	28060	1942-05-10	1942-05-17	1
20352	1227	4109685	1949-05-24	1949-06-07	1
36942	2189	260139	2004-04-08	2004-04-22	1
82278	4886	4112343	2009-08-25	2009-09-07	1
82054	4872	4218389	2008-07-06	2008-08-10	1
73740	4384	40481087	1969-08-10	1969-08-31	1
11103	655	260139	1975-05-24	1975-05-31	1
37212	2206	4027663	2000-11-25	2000-11-26	1
14049	830	40481087	2009-04-21	2009-04-28	1
78166	4633	40481087	1994-02-27	1994-03-20	1
41329	2460	372328	1986-03-31	1986-07-16	1
13720	812	4112343	1971-10-01	1971-10-10	1
54094	3207	78272	1990-07-01	1990-07-29	1
65109	3856	80180	2012-02-05	2012-02-06	1
13635	806	4112343	2010-11-09	2010-11-21	1
51849	3077	4116491	2011-05-28	2011-07-14	1
43176	2574	192671	2005-08-01	2005-08-02	1
26619	1578	40481087	1970-12-15	1971-01-05	1
76712	4550	40481087	2018-06-29	2018-07-06	1
56187	3334	4059173	1946-10-20	1947-01-18	1
14992	884	40481087	2007-11-27	2007-12-18	1
60095	3561	4112343	1946-10-23	1946-11-03	1
48214	2861	4059173	1977-04-25	1977-07-24	1
55654	3296	4112343	1939-04-16	1939-04-25	1
64412	3811	4112343	1967-08-31	1967-09-10	1
12716	753	81893	2004-05-12	2004-05-13	1
10607	624	40481087	2012-03-18	2012-04-08	1
12530	742	81151	1975-05-19	1975-06-09	1
12290	727	40481087	1940-12-16	1941-01-06	1
18505	1115	4142905	1958-01-14	1958-02-13	1
29364	1740	40481087	2010-09-25	2010-10-16	1
66549	3941	81151	2017-02-07	2017-02-28	1
39353	2334	28060	1949-08-12	1949-08-19	1
20353	1227	4112343	1967-09-02	1967-09-10	1
36943	2189	40481087	1995-10-10	1995-10-17	1
82279	4886	4112343	2014-02-15	2014-02-25	1
82055	4872	40481087	1921-12-30	1922-01-06	1
73741	4384	40481087	1998-01-28	1998-02-11	1
11104	655	260139	1979-04-10	1979-04-17	1
37213	2206	81151	1990-11-23	1990-12-14	1
14050	830	28060	2016-09-21	2016-09-30	1
78167	4633	81151	2017-08-10	2017-08-31	1
41330	2460	4051466	1988-08-14	2003-11-25	1
13721	812	4112343	1996-10-05	1996-10-14	1
54095	3207	80180	1995-08-19	1995-08-20	1
65110	3856	260139	1975-06-27	1975-07-04	1
13636	806	40481087	2000-05-22	2000-06-05	1
51850	3077	4146173	1976-12-19	1977-01-18	1
43177	2574	372328	1961-05-04	1961-06-14	1
26620	1578	40481087	1992-07-31	1992-08-21	1
76713	4550	372328	1963-06-06	1963-08-18	1
56188	3334	4112343	1981-07-01	1981-07-14	1
14993	884	81151	1982-09-17	1982-10-22	1
60096	3561	4134304	1967-04-02	1967-05-02	1
48215	2861	4112343	1970-03-15	1970-03-26	1
55655	3296	4112343	1944-11-27	1944-12-07	1
64413	3811	4112343	1982-09-05	1982-09-13	1
12717	753	260139	1973-02-25	1973-03-04	1
10608	624	260139	2019-05-16	2019-05-23	1
12531	742	260139	1972-08-22	1972-08-29	1
12291	727	40481087	1994-12-25	1995-01-01	1
18506	1115	4283893	1985-10-02	1985-10-16	1
29365	1740	260139	1962-10-16	1962-10-23	1
66550	3941	260139	1963-12-19	1964-01-02	1
39354	2334	78272	1966-10-03	1966-10-17	1
20354	1227	4112343	1988-04-21	1988-05-04	1
39526	2344	81151	1983-09-02	1983-09-16	1
82280	4886	40481087	1997-01-13	1997-02-03	1
82056	4872	40481087	1927-12-10	1927-12-24	1
73742	4384	4084167	1968-09-08	1968-09-08	1
11105	655	381316	2013-03-30	2013-03-31	1
37214	2206	192671	2008-04-09	2008-04-10	1
14051	830	260139	1973-07-12	1973-07-19	1
78168	4633	81893	1992-01-11	1992-01-12	1
44282	2636	260139	1989-12-25	1990-01-01	1
13722	812	4112343	2005-05-01	2005-05-10	1
54096	3207	321042	1994-12-01	1994-12-02	1
65111	3856	260139	1991-06-21	1991-07-05	1
13637	806	80180	1997-12-05	1997-12-06	1
51851	3077	4294548	1972-03-23	1972-05-04	1
43178	2574	4112343	1976-06-11	1976-06-20	1
26621	1578	40481087	1993-08-21	1993-09-11	1
76714	4550	40481087	1964-07-05	1964-07-26	1
56189	3334	4112343	1986-02-28	1986-03-10	1
14994	884	81151	2008-03-21	2008-04-18	1
60097	3561	4283893	1945-02-07	1945-03-28	1
48216	2861	4283893	1965-03-05	1965-04-16	1
55656	3296	4112343	2010-08-18	2010-08-28	1
64414	3811	4112343	2007-03-06	2007-03-19	1
12718	753	260139	2009-11-11	2009-11-18	1
10609	624	378001	2005-01-19	2005-02-18	1
12532	742	313217	2008-07-21	2008-07-22	1
12292	727	4112343	2007-12-20	2007-12-28	1
18507	1115	40481087	1998-08-06	1998-08-27	1
29366	1740	260139	1992-08-26	1992-09-09	1
66551	3941	260139	1986-05-31	1986-06-14	1
39355	2334	80180	1971-07-05	1971-07-06	1
20355	1227	4278672	1950-04-03	1950-05-03	1
39527	2344	372328	1970-10-04	1970-11-30	1
82281	4886	40481087	2017-11-22	2017-12-06	1
82057	4872	40481087	1930-06-19	1930-07-10	1
73743	4384	4112343	1970-11-29	1970-12-11	1
11106	655	4112343	1964-01-21	1964-01-28	1
37215	2206	4112343	1990-02-14	1990-02-25	1
14052	830	260139	1984-12-30	1985-01-06	1
78169	4633	257012	1975-08-01	1975-08-02	1
44283	2636	260139	2011-11-11	2011-11-18	1
13723	812	40481087	1984-06-07	1984-06-28	1
54097	3207	372328	1962-10-12	1962-11-15	1
65112	3856	372328	1975-05-26	1975-07-09	1
13638	806	81151	1962-07-02	1962-07-30	1
51852	3077	40481087	1953-12-08	1953-12-22	1
43179	2574	4112343	1996-12-04	1996-12-15	1
26622	1578	260139	1950-09-27	1950-10-11	1
76715	4550	40481087	2010-04-23	2010-05-07	1
56190	3334	40481087	1950-10-06	1950-10-27	1
14995	884	260139	1981-04-19	1981-04-26	1
60098	3561	4285898	1943-10-10	1943-10-11	1
48217	2861	40481087	2010-06-18	2010-06-25	1
55657	3296	4166224	1938-09-26	1938-09-27	1
64415	3811	40481087	1962-08-25	1962-09-01	1
12719	753	4027663	1997-09-16	1997-09-17	1
10610	624	4109685	1973-04-23	1973-05-07	1
12533	742	4112343	1926-01-12	1926-01-19	1
12293	727	4278672	1974-03-23	1974-04-22	1
18508	1115	28060	1967-01-29	1967-02-08	1
29367	1740	4029498	1952-09-06	1952-09-07	1
66552	3941	4266809	1999-08-01	1999-08-02	1
39356	2334	260139	1942-09-26	1942-10-10	1
20356	1227	40481087	1969-07-11	1969-07-25	1
39528	2344	4112343	1989-03-26	1989-04-08	1
82282	4886	80180	2002-04-15	2002-04-16	1
82058	4872	40481087	1939-10-29	1939-11-12	1
73744	4384	40481087	2014-12-22	2015-01-05	1
11107	655	4112343	1996-10-13	1996-10-20	1
37216	2206	260139	1987-11-10	1987-11-17	1
14053	830	378001	1962-12-05	1963-01-04	1
78170	4633	260139	1991-08-03	1991-08-10	1
44284	2636	260139	2017-08-22	2017-09-05	1
13724	812	28060	1973-10-30	1973-11-08	1
54098	3207	40481087	1965-10-03	1965-10-17	1
65113	3856	372328	1979-07-22	1980-07-23	1
13639	806	260139	1983-09-05	1983-09-12	1
51853	3077	28060	1987-07-03	1987-07-15	1
43180	2574	40481087	1995-07-29	1995-08-05	1
26623	1578	4112343	2013-10-23	2013-11-03	1
76716	4550	40481087	2018-09-10	2018-09-17	1
56191	3334	81151	2001-10-31	2001-12-05	1
14996	884	260139	2013-11-26	2013-12-03	1
60099	3561	40481087	1925-05-12	1925-05-19	1
48218	2861	81151	2005-03-20	2005-04-03	1
55658	3296	40481087	1964-12-13	1964-12-27	1
64416	3811	28060	2008-04-13	2008-04-22	1
12720	753	4112343	2011-07-05	2011-07-18	1
10611	624	4112343	1994-02-18	1994-03-01	1
12534	742	4112343	1951-12-08	1951-12-19	1
12294	727	40481087	1928-06-15	1928-07-06	1
18509	1115	260139	1950-06-27	1950-07-04	1
29368	1740	4285898	1988-12-16	1988-12-17	1
66553	3941	40481087	1994-07-16	1994-08-06	1
39357	2334	4146173	1997-09-23	1997-11-22	1
20357	1227	40481087	2006-01-27	2006-02-10	1
39529	2344	4116491	2008-03-03	2008-04-07	1
82283	4886	260139	1979-09-25	1979-10-02	1
82059	4872	40481087	1955-12-10	1955-12-31	1
73745	4384	80180	2005-08-25	2005-08-26	1
11108	655	4116491	1985-12-05	1986-01-15	1
37217	2206	260139	2001-04-08	2001-04-22	1
14054	830	4112343	1967-06-13	1967-06-21	1
78171	4633	313217	2009-12-01	2009-12-02	1
44285	2636	317576	1997-07-04	1997-07-05	1
13725	812	40481087	1973-06-26	1973-07-17	1
54099	3207	40481087	1999-10-26	1999-11-02	1
65114	3856	40481087	1975-04-04	1975-04-11	1
13640	806	4112343	1960-07-13	1960-07-21	1
51854	3077	78272	1978-02-12	1978-02-26	1
43181	2574	28060	1975-05-04	1975-05-16	1
26624	1578	40481087	2016-03-17	2016-03-31	1
78061	4630	80180	1993-04-07	1993-04-08	1
56192	3334	372328	1951-01-27	1951-10-11	1
14997	884	260139	2017-06-16	2017-06-23	1
60100	3561	40481087	1943-07-20	1943-08-10	1
48219	2861	260139	1999-06-29	1999-07-13	1
55659	3296	40481087	1985-03-21	1985-04-11	1
64417	3811	4112343	1948-03-20	1948-03-31	1
12721	753	40481087	1999-03-20	1999-03-27	1
10612	624	4112343	1996-08-21	1996-09-02	1
12535	742	4112343	1965-09-08	1965-09-15	1
12295	727	40481087	1931-07-25	1931-08-08	1
18510	1115	375671	1952-11-11	1952-12-11	1
29369	1740	40481087	1968-05-22	1968-05-29	1
66554	3941	40481087	2005-04-09	2005-04-30	1
39358	2334	4296205	1996-10-23	1996-11-27	1
20358	1227	260139	1974-12-25	1975-01-08	1
39530	2344	4266809	1999-11-21	1999-11-22	1
82284	4886	260139	1996-10-13	1996-10-20	1
82060	4872	40481087	1962-06-05	1962-06-12	1
73746	4384	4112343	1973-07-29	1973-08-05	1
12928	761	80180	2015-05-30	2015-05-31	1
37218	2206	372328	1974-02-20	1974-05-10	1
14055	830	4112343	1973-10-29	1973-11-09	1
78172	4633	4048695	1987-01-04	1987-03-07	1
44286	2636	4112343	1996-08-29	1996-09-11	1
13726	812	40481087	1978-08-26	1978-09-02	1
54100	3207	40481087	2001-03-03	2001-03-17	1
65115	3856	40481087	1992-03-08	1992-03-22	1
13641	806	4112343	1999-02-28	1999-03-10	1
51855	3077	257012	1972-04-20	1972-04-21	1
43182	2574	30753	2003-08-17	2003-08-18	1
26625	1578	81151	1954-01-29	1954-02-19	1
78062	4630	257012	1980-05-16	1980-05-17	1
56193	3334	40481087	1955-04-12	1955-05-03	1
14998	884	372328	1979-04-29	1979-08-14	1
61578	3641	28060	1943-11-18	1943-11-27	1
48220	2861	378001	1978-05-20	1978-06-19	1
55660	3296	0	1966-09-18	1966-09-19	1
64418	3811	4218389	1945-04-17	1945-05-08	1
12722	753	40481087	2006-09-23	2006-09-30	1
10613	624	4218389	1964-07-22	1964-08-19	1
12536	742	4112343	1968-10-31	1968-11-08	1
12296	727	40481087	1960-01-25	1960-02-08	1
18511	1115	4142905	2014-12-12	2015-02-10	1
29370	1740	40481087	1975-07-27	1975-08-03	1
72409	4305	260139	1999-10-14	1999-10-28	1
39359	2334	40481087	1942-12-29	1943-01-05	1
20359	1227	313217	2016-04-06	2016-04-07	1
39531	2344	40481087	1988-10-18	1988-11-08	1
82285	4886	260139	2005-04-06	2005-04-20	1
82061	4872	78272	1941-04-28	1941-06-02	1
73747	4384	4155034	1982-12-08	1982-12-29	1
12929	761	81893	2014-03-06	2014-03-07	1
37219	2206	4112343	2010-08-13	2010-08-20	1
14056	830	4112343	2016-02-09	2016-02-21	1
78173	4633	4112343	1973-07-12	1973-07-24	1
44287	2636	4112343	2006-04-18	2006-04-30	1
13727	812	40481087	1984-04-11	1984-05-02	1
55883	3313	260139	1958-08-05	1958-08-12	1
65116	3856	260139	1984-06-18	1984-06-25	1
13642	806	4152936	1967-03-06	1967-03-20	1
51856	3077	317576	2013-11-20	2013-11-21	1
43183	2574	80180	2005-05-08	2005-05-09	1
26626	1578	260139	1948-02-02	1948-02-09	1
78063	4630	260139	1973-07-15	1973-07-22	1
56194	3334	40481087	1976-04-19	1976-04-26	1
14999	884	40481087	2011-04-10	2011-04-24	1
61579	3641	78272	1947-06-27	1947-07-18	1
48221	2861	4112343	1970-04-28	1970-05-11	1
55661	3296	192671	1980-07-15	1980-07-16	1
64419	3811	4294548	1942-07-09	1942-07-16	1
16483	974	380378	1956-06-24	1956-06-25	1
10614	624	40481087	1992-11-06	1992-11-13	1
12537	742	4112343	1978-01-11	1978-01-18	1
12297	727	40481087	1981-01-27	1981-02-10	1
18512	1115	4152936	1984-11-14	1984-12-05	1
29371	1740	40481087	1995-10-10	1995-10-17	1
72410	4305	260139	2012-08-01	2012-08-15	1
39360	2334	40481087	1956-02-26	1956-03-04	1
20360	1227	372328	1940-10-08	1941-01-29	1
39532	2344	28060	1968-07-02	1968-07-13	1
82286	4886	260139	2017-12-16	2017-12-23	1
82062	4872	80180	1955-11-07	1955-11-08	1
73748	4384	40481087	1975-09-04	1975-09-18	1
12930	761	260139	2004-01-31	2004-02-14	1
37220	2206	4278672	1986-01-18	1986-02-17	1
14057	830	40481087	1961-12-09	1961-12-30	1
78174	4633	40481087	1960-04-26	1960-05-03	1
44288	2636	4155034	1995-12-13	1995-12-27	1
13728	812	80180	2004-12-14	2004-12-15	1
55884	3313	260139	1978-03-31	1978-04-07	1
65117	3856	4112343	1983-06-12	1983-06-24	1
13643	806	4294548	2002-10-22	2002-11-26	1
51857	3077	4112343	2016-06-14	2016-06-24	1
43184	2574	440086	1968-01-02	1979-01-09	1
26627	1578	317576	2015-07-19	2015-07-20	1
78064	4630	260139	2012-01-15	2012-01-22	1
56195	3334	28060	2019-04-27	2019-05-07	1
15000	884	40486433	1982-09-12	1982-09-13	1
61580	3641	4112343	1913-10-30	1913-11-10	1
48222	2861	4112343	1981-11-27	1981-12-04	1
55662	3296	4112343	1948-08-21	1948-09-01	1
64420	3811	40481087	1953-12-29	1954-01-19	1
16484	974	4029498	1956-06-24	1956-06-25	1
10615	624	40481087	2012-06-15	2012-07-06	1
12538	742	40481087	1961-10-08	1961-10-22	1
12298	727	40481087	1998-10-19	1998-11-02	1
18513	1115	40481087	1995-03-28	1995-04-18	1
29372	1740	40481087	2008-02-18	2008-03-03	1
72411	4305	375671	1978-10-17	1978-12-16	1
40899	2436	81151	1957-07-21	1957-08-11	1
20361	1227	4112343	1966-11-09	1966-11-21	1
39533	2344	80180	1999-11-21	1999-11-22	1
82287	4886	378001	2018-11-25	2018-12-25	1
82063	4872	81151	1960-09-20	1960-10-11	1
76475	4538	80180	1987-05-22	1987-05-23	1
12931	761	4283893	1996-08-06	1996-09-03	1
37221	2206	4285898	2007-08-16	2007-08-17	1
14058	830	40481087	1963-07-01	1963-07-15	1
78175	4633	40481087	2015-08-06	2015-08-13	1
44289	2636	40481087	1991-04-09	1991-04-30	1
13729	812	4112343	1977-08-20	1977-08-30	1
55885	3313	260139	1994-03-15	1994-03-22	1
65118	3856	28060	1983-01-04	1983-01-11	1
13644	806	30753	1996-02-14	1996-02-15	1
51858	3077	4113008	1975-03-16	1975-03-30	1
43185	2574	4112343	1972-02-09	1972-02-17	1
26628	1578	4059173	1999-08-22	1999-11-20	1
78065	4630	4109685	1982-08-08	1982-08-29	1
56196	3334	80180	1981-08-07	1981-08-08	1
15001	884	78272	1991-08-27	1991-09-17	1
61581	3641	4112343	1915-07-04	1915-07-14	1
48223	2861	4134304	1987-12-20	1988-01-19	1
55663	3296	4112343	1972-06-12	1972-06-19	1
64421	3811	40481087	1960-01-25	1960-02-01	1
16485	974	4112343	1979-01-22	1979-01-30	1
10616	624	81151	1965-07-15	1965-08-12	1
12539	742	40481087	1971-01-10	1971-01-17	1
14938	882	28060	1971-01-24	1971-02-05	1
18514	1115	260139	1959-07-20	1959-08-03	1
29373	1740	372328	1957-02-12	1957-08-17	1
72412	4305	4084167	2004-04-19	2004-04-20	1
40900	2436	260139	1919-07-09	1919-07-23	1
20362	1227	4112343	2003-09-26	2003-10-08	1
39534	2344	40481087	1990-02-06	1990-02-20	1
82288	4886	4027663	1992-08-30	1992-08-31	1
82064	4872	372328	1930-11-14	1931-09-22	1
76476	4538	4027663	1978-05-09	1978-05-10	1
12932	761	260139	2008-01-16	2008-01-23	1
37222	2206	40481087	2000-02-13	2000-02-20	1
14059	830	40481087	1980-03-18	1980-04-08	1
78176	4633	260139	1961-08-12	1961-08-26	1
44290	2636	40481087	1992-10-26	1992-11-16	1
13730	812	4112343	1994-12-03	1994-12-11	1
55886	3313	28060	1956-07-17	1956-07-25	1
65119	3856	195588	1998-09-27	1998-10-29	1
13645	806	40481087	1996-04-24	1996-05-08	1
51859	3077	4266809	1992-05-03	1992-05-04	1
43186	2574	40481087	1970-07-24	1970-07-31	1
26629	1578	4112343	1972-03-04	1972-03-16	1
78066	4630	4283893	1980-03-07	1980-06-20	1
56197	3334	260139	1954-04-13	1954-04-27	1
15002	884	133834	1981-01-25	1981-01-26	1
61582	3641	4156265	1924-08-30	1924-09-20	1
48224	2861	4155034	1982-03-30	1982-04-20	1
55664	3296	4112343	2003-12-08	2003-12-19	1
64422	3811	40481087	1983-07-05	1983-07-26	1
16486	974	4112343	1998-10-03	1998-10-13	1
10617	624	81151	2014-08-30	2014-09-20	1
12540	742	28060	1926-11-18	1926-11-29	1
14939	882	80180	1987-12-03	1987-12-04	1
18515	1115	260139	1970-05-09	1970-05-16	1
29374	1740	4027663	1978-08-31	1978-09-01	1
72413	4305	4112343	2007-08-28	2007-09-07	1
40901	2436	260139	1970-10-25	1970-11-08	1
20363	1227	4112343	2013-02-19	2013-02-28	1
39535	2344	30753	1998-09-27	1998-09-28	1
82289	4886	4112343	1975-01-14	1975-01-27	1
82065	4872	4112343	1936-07-06	1936-07-18	1
76477	4538	4112343	1981-07-12	1981-07-22	1
12933	761	372328	1981-09-30	1981-11-20	1
37223	2206	40481087	2018-03-06	2018-03-13	1
14060	830	372328	1961-04-14	1961-04-28	1
78177	4633	4027663	1983-11-19	1983-11-20	1
44291	2636	40481087	2010-07-16	2010-07-23	1
13731	812	28060	2016-10-11	2016-10-24	1
55887	3313	80180	1991-12-28	1991-12-29	1
65120	3856	372328	1976-01-04	1976-07-07	1
13646	806	40481087	2011-03-23	2011-04-06	1
51860	3077	40481087	1955-10-18	1955-11-01	1
43187	2574	378001	2007-01-19	2007-02-18	1
26630	1578	4112343	1997-04-19	1997-05-02	1
78067	4630	4285898	1992-07-11	1992-07-12	1
56198	3334	378001	1961-09-01	1961-10-31	1
15003	884	4149245	1981-08-16	1981-10-22	1
61583	3641	4218389	1987-01-03	1987-01-31	1
48225	2861	4283893	1968-06-07	1968-07-12	1
55665	3296	40481087	1958-02-07	1958-02-28	1
64423	3811	28060	1944-12-24	1945-01-04	1
16487	974	4218389	1971-08-05	1971-09-09	1
10618	624	257012	1945-04-24	1945-04-25	1
12541	742	78272	2009-10-08	2009-10-22	1
14940	882	260139	1987-10-18	1987-10-25	1
18516	1115	260139	2010-10-11	2010-10-18	1
29375	1740	4155034	1961-06-21	1961-07-12	1
72414	4305	4156265	1973-09-29	1973-10-13	1
40902	2436	260139	2009-04-13	2009-04-27	1
20364	1227	28060	1984-12-27	1985-01-04	1
39536	2344	4027663	1992-03-07	1992-03-08	1
82290	4886	4112343	2004-11-02	2004-11-15	1
82066	4872	4112343	1972-04-19	1972-04-27	1
76478	4538	4112343	1986-09-07	1986-09-20	1
12934	761	4112343	2008-02-23	2008-03-01	1
38331	2280	80180	2002-06-16	2002-06-17	1
14061	830	4112343	1971-02-01	1971-02-11	1
78178	4633	40479768	1974-01-05	1974-03-13	1
44292	2636	0	2019-03-08	2019-03-09	1
13732	812	81151	1983-08-11	1983-08-25	1
55888	3313	260139	1967-01-29	1967-02-12	1
65121	3856	4112343	1977-04-27	1977-05-05	1
16128	956	260139	1945-04-15	1945-04-22	1
51861	3077	40481087	1995-10-07	1995-10-21	1
43188	2574	4027663	1992-12-26	1992-12-27	1
26631	1578	4278672	2018-11-01	2019-01-30	1
78068	4630	40481087	1962-11-23	1962-11-30	1
56199	3334	4112343	1981-12-12	1981-12-20	1
18308	1102	4112343	2014-10-17	2014-10-30	1
61584	3641	40481087	1984-07-31	1984-08-21	1
48226	2861	40481087	1974-12-15	1974-12-29	1
55666	3296	40481087	1993-11-04	1993-11-18	1
64424	3811	28060	1994-03-31	1994-04-09	1
16488	974	4296204	2013-02-21	2013-03-14	1
10619	624	260139	1961-11-07	1961-11-14	1
12542	742	378001	1993-02-04	1993-04-05	1
14941	882	372328	1945-04-22	1945-06-02	1
18517	1115	378001	1982-10-26	1982-11-25	1
29376	1740	4294548	1994-01-20	1994-06-09	1
72415	4305	40481087	2013-04-26	2013-05-10	1
40903	2436	378001	1976-08-01	1976-09-30	1
20365	1227	78272	1954-01-12	1954-02-16	1
39537	2344	4156265	1969-05-27	1969-06-17	1
82291	4886	260139	1989-08-12	1989-08-26	1
82067	4872	4218389	2011-04-27	2011-05-18	1
76479	4538	4278672	2011-10-29	2011-12-28	1
12935	761	40481087	2006-01-21	2006-02-11	1
38332	2280	257012	1983-04-17	1983-04-18	1
14062	830	4112343	1992-05-18	1992-05-27	1
79560	4719	28060	1957-09-04	1957-09-15	1
44293	2636	81151	2013-04-26	2013-05-31	1
13733	812	260139	1988-09-30	1988-10-07	1
55889	3313	40481087	2018-11-26	2018-12-17	1
65122	3856	4112343	1986-08-08	1986-08-16	1
16129	956	260139	2004-01-31	2004-02-14	1
51862	3077	40481087	2006-03-05	2006-03-12	1
43189	2574	4113008	1976-02-19	1976-03-04	1
26632	1578	40481087	1949-01-03	1949-01-24	1
78069	4630	40481087	1982-01-20	1982-02-03	1
56200	3334	4112343	2000-07-27	2000-08-03	1
18309	1102	372328	1983-11-26	1984-01-03	1
61585	3641	28060	1978-02-07	1978-02-14	1
48227	2861	40481087	1995-09-18	1995-10-09	1
55667	3296	40481087	1994-06-23	1994-07-14	1
64425	3811	260139	1929-06-13	1929-06-27	1
16489	974	40481087	1973-09-30	1973-10-07	1
10620	624	260139	1966-07-22	1966-08-05	1
12543	742	378419	2012-12-17	2012-12-18	1
14942	882	372328	1946-10-25	1946-11-30	1
18518	1115	4112343	2013-11-07	2013-11-17	1
32362	1925	80180	1984-01-31	1984-02-01	1
72416	4305	80180	1997-12-27	1997-12-28	1
40904	2436	4112343	1970-03-23	1970-04-02	1
20366	1227	80180	1980-05-31	1980-06-01	1
39538	2344	40481087	2004-12-30	2005-01-20	1
82292	4886	4134304	1968-07-22	1968-10-20	1
82068	4872	4294548	2007-02-16	2007-05-11	1
76480	4538	40479422	1972-10-02	1972-11-08	1
12936	761	40481087	2010-09-23	2010-10-07	1
38333	2280	260139	1984-05-02	1984-05-16	1
15737	932	80180	2002-07-06	2002-07-07	1
79561	4719	80180	1972-05-11	1972-05-12	1
44294	2636	4109685	2018-07-04	2018-07-18	1
13734	812	4109685	1970-01-07	1970-01-21	1
55890	3313	28060	1958-02-18	1958-02-27	1
65123	3856	4112343	1989-06-02	1989-06-09	1
16130	956	372328	1936-06-29	1936-08-12	1
51863	3077	40481087	2018-09-13	2018-09-20	1
43190	2574	40481087	2015-03-29	2015-04-12	1
26633	1578	40481087	1949-08-01	1949-08-15	1
78070	4630	81151	1964-11-05	1964-11-19	1
56201	3334	40481087	1981-08-03	1981-08-10	1
18310	1102	4112343	1986-11-14	1986-11-27	1
61586	3641	260139	2000-06-24	2000-07-08	1
48228	2861	40481087	2002-11-26	2002-12-03	1
55668	3296	40481087	2014-11-27	2014-12-04	1
64426	3811	260139	1991-11-23	1991-12-07	1
16490	974	0	1993-06-16	1993-06-17	1
10621	624	260139	1969-10-17	1969-10-24	1
12544	742	4112343	1989-03-23	1989-03-31	1
14943	882	40481087	1970-12-31	1971-01-21	1
18519	1115	4113008	1964-10-09	1964-10-30	1
32363	1925	260139	1975-06-08	1975-06-15	1
72417	4305	372328	1958-12-17	1959-01-30	1
40905	2436	4112343	1985-04-14	1985-04-27	1
20367	1227	260139	1956-01-08	1956-01-22	1
39539	2344	40481087	2006-04-21	2006-04-28	1
82293	4886	4237458	1973-08-25	1973-10-24	1
82069	4872	40481087	2009-04-26	2009-05-10	1
76481	4538	40481087	1961-08-04	1961-08-11	1
12937	761	260139	1988-07-26	1988-08-02	1
38334	2280	4112343	1969-09-04	1969-09-17	1
15738	932	81151	1975-08-22	1975-09-05	1
79562	4719	257012	1945-04-15	1945-04-16	1
44295	2636	4112343	1997-07-12	1997-07-20	1
13735	812	4142905	1979-09-01	1979-10-31	1
55891	3313	260139	1971-10-17	1971-10-24	1
65124	3856	4112343	2015-02-26	2015-03-10	1
16131	956	4112343	1958-03-01	1958-03-08	1
51864	3077	260139	2007-10-09	2007-10-23	1
43191	2574	81893	2003-01-18	2003-01-19	1
26634	1578	40481087	1952-06-06	1952-06-27	1
78071	4630	195588	1983-01-20	1983-03-10	1
56202	3334	28060	1959-12-13	1959-12-22	1
18311	1102	4112343	2018-03-14	2018-03-21	1
61587	3641	440086	1920-10-30	1922-04-08	1
48229	2861	40481087	2009-02-04	2009-02-18	1
55669	3296	40481087	2018-06-22	2018-07-06	1
64427	3811	260139	1998-08-03	1998-08-17	1
16491	974	28060	1960-02-07	1960-02-17	1
10622	624	4278672	1947-01-23	1947-04-23	1
12545	742	4152936	1952-10-20	1952-11-10	1
14944	882	78272	1993-11-06	1993-11-27	1
18520	1115	4152936	2007-01-09	2007-01-23	1
32364	1925	372328	1946-06-26	1946-12-28	1
72418	4305	4278672	2019-06-12	2019-06-13	1
40906	2436	4156265	1992-03-10	1992-03-31	1
20368	1227	260139	1965-03-07	1965-03-14	1
39540	2344	81893	1997-11-01	1997-11-02	1
82294	4886	4294548	1989-07-10	1990-01-15	1
82070	4872	28060	1990-08-17	1990-08-27	1
76482	4538	40481087	2001-02-06	2001-02-20	1
12938	761	260139	1991-04-19	1991-05-03	1
38335	2280	40481087	1973-04-14	1973-05-05	1
15739	932	4112343	2003-05-29	2003-06-09	1
79563	4719	260139	2009-10-22	2009-10-29	1
44296	2636	4218389	1975-06-26	1975-07-31	1
14492	858	28060	1975-02-10	1975-02-17	1
55892	3313	372328	1956-12-25	1957-12-27	2
65125	3856	40481087	1991-06-23	1991-07-07	1
16132	956	4112343	1964-11-12	1964-11-22	1
51865	3077	381316	2014-06-11	2014-06-12	1
43192	2574	260139	1978-12-31	1979-01-14	1
26635	1578	40481087	1983-05-08	1983-05-15	1
78072	4630	260139	1995-03-01	1995-03-15	1
56203	3334	40481087	2000-06-07	2000-06-14	1
18312	1102	4280726	1970-01-30	1986-01-28	1
61588	3641	4155034	1979-04-01	1979-04-15	1
48230	2861	40481087	2015-12-05	2015-12-26	1
64428	3811	378419	2005-09-22	2005-09-23	1
16492	974	80180	1993-04-06	1993-04-07	1
10623	624	4294548	1980-06-09	1981-03-02	1
12546	742	4294548	1981-05-03	1981-05-17	1
14945	882	260139	1975-03-17	1975-03-24	1
18521	1115	40481087	1953-08-17	1953-08-31	1
32365	1925	4112343	1966-01-01	1966-01-12	1
72419	4305	40481087	2004-11-11	2004-12-02	1
40907	2436	4283893	1990-08-01	1990-09-12	1
20369	1227	260139	2012-03-06	2012-03-20	1
39541	2344	260139	1970-11-19	1970-11-26	1
82295	4886	4310024	2000-02-25	2000-02-26	1
82071	4872	81151	1999-07-10	1999-07-24	1
76483	4538	40481087	2012-11-25	2012-12-02	1
12939	761	4152936	1994-04-25	1994-05-16	1
38336	2280	40481087	1999-11-04	1999-11-18	1
15740	932	4237458	1971-01-15	1971-02-14	1
79564	4719	378001	1952-10-03	1952-11-02	1
44297	2636	260139	2014-11-15	2014-11-29	1
14493	858	4112343	1997-12-22	1998-01-02	1
55893	3313	4112343	2014-12-14	2014-12-26	1
65126	3856	28060	1976-10-18	1976-10-25	1
16133	956	4112343	1996-04-25	1996-05-02	1
51866	3077	4134304	1954-06-17	1954-08-16	1
44984	2680	80180	2007-10-17	2007-10-18	1
26636	1578	28060	1952-01-11	1952-01-18	1
78073	4630	260139	2002-11-14	2002-11-21	1
56204	3334	40481087	2019-04-11	2019-04-18	1
18313	1102	40481087	1981-09-04	1981-09-11	1
61589	3641	4278672	1992-11-30	1993-02-28	1
48231	2861	28060	1964-07-05	1964-07-13	1
64429	3811	4112343	1969-12-31	1970-01-07	1
16493	974	195588	1999-06-14	1999-08-01	1
10624	624	40481087	2009-08-06	2009-08-13	1
12547	742	40481087	2011-03-16	2011-03-23	1
14946	882	440086	1955-12-21	1962-12-29	1
18522	1115	40481087	1988-02-11	1988-02-25	1
32366	1925	4112343	2007-12-06	2007-12-18	1
72420	4305	28060	1984-08-31	1984-09-09	1
40908	2436	40481087	1913-07-16	1913-08-06	1
20370	1227	440086	1946-08-23	1947-09-19	1
39542	2344	372328	1967-07-07	1967-08-21	1
82296	4886	28060	1972-01-16	1972-01-28	1
82072	4872	260139	1968-03-01	1968-03-08	1
76484	4538	192671	1987-06-01	1987-06-02	1
12940	761	40481087	1982-12-15	1982-12-22	1
38337	2280	28060	1976-04-16	1976-04-28	1
15741	932	40481087	2014-06-21	2014-07-12	1
79565	4719	378001	1970-06-15	1970-08-14	1
44298	2636	372328	1964-03-25	1965-03-26	1
14494	858	4142905	1979-11-15	1980-01-14	1
55894	3313	4146173	1992-04-20	1992-06-19	1
65127	3856	40481087	2008-09-03	2008-09-24	1
16134	956	4230399	1950-04-08	1950-06-07	1
51867	3077	40481087	1966-11-27	1966-12-11	1
44985	2680	260139	1975-06-23	1975-07-07	1
26637	1578	28060	1998-05-30	1998-06-11	1
78074	4630	378001	2009-02-22	2009-03-24	1
57981	3440	81151	1960-12-14	1960-12-28	1
18314	1102	40481087	1988-11-11	1988-11-25	1
61590	3641	40481087	1953-08-16	1953-08-23	1
48232	2861	80180	2006-10-10	2006-10-11	1
64430	3811	4112343	1989-01-13	1989-01-23	1
16494	974	195588	2001-07-31	2001-09-10	1
13944	825	80180	2011-02-14	2011-02-15	1
12548	742	40481087	2014-10-10	2014-10-11	1
14947	882	4112343	1950-11-24	1950-12-07	1
18523	1115	40481087	2002-11-13	2002-12-04	1
32367	1925	4237458	1952-07-12	1952-08-11	1
72421	4305	4134304	1969-09-20	1969-12-19	1
40909	2436	40481087	1913-11-13	1913-11-27	1
20371	1227	4112343	1951-12-12	1951-12-25	1
39543	2344	40481087	1968-01-09	1968-01-30	1
82297	4886	78272	1978-09-28	1978-10-26	1
82073	4872	260139	2005-12-21	2006-01-04	1
76485	4538	195588	2012-04-30	2012-06-18	1
12941	761	28060	1987-01-04	1987-01-13	1
38338	2280	133834	1975-06-10	1986-12-14	1
15742	932	81151	1986-04-10	1986-05-08	1
79566	4719	4084167	1940-09-01	1940-09-01	1
44299	2636	4048171	1963-04-22	1979-04-20	1
14495	858	80180	2009-09-28	2009-09-29	1
55895	3313	4155034	1976-08-28	1976-09-11	1
66555	3942	81151	2004-09-05	2004-10-10	1
16135	956	40481087	2010-08-27	2010-09-03	1
54500	3231	0	1983-10-09	1983-10-10	1
44986	2680	260139	1981-04-09	1981-04-23	1
26638	1578	4155034	2017-10-16	2017-11-06	1
78075	4630	4059173	1965-09-15	1965-11-14	1
57982	3440	81151	1973-04-24	1973-05-15	1
18315	1102	40481087	2010-01-05	2010-01-26	1
61591	3641	40481087	1959-05-30	1959-06-20	1
48233	2861	260139	1989-04-24	1989-05-08	1
64431	3811	40481087	2014-06-21	2014-06-28	1
16495	974	372328	1956-12-21	1957-03-03	1
13945	825	260139	1971-03-12	1971-03-26	1
13871	821	192671	1985-02-18	1985-02-19	1
14948	882	4112343	2007-05-01	2007-05-11	1
18524	1115	40481087	2013-09-16	2013-09-23	1
32368	1925	4237458	1957-06-16	1957-07-16	1
72422	4305	40481087	1974-08-30	1974-09-13	1
40910	2436	40481087	1940-12-26	1941-01-09	1
20372	1227	4112343	2018-02-04	2018-02-16	1
39544	2344	40481087	1999-10-08	1999-10-22	1
82298	4886	192671	2002-05-01	2002-05-02	1
82074	4872	260139	2007-09-22	2007-09-29	1
76486	4538	257012	2014-02-28	2014-03-01	1
12942	761	260139	2007-11-08	2007-11-15	1
38339	2280	260139	1995-08-28	1995-09-04	1
15743	932	4027663	1995-02-18	1995-02-19	1
79567	4719	4146173	2017-01-21	2017-02-20	1
44300	2636	4329847	2019-03-08	2019-03-09	1
14496	858	4283893	2008-04-23	2008-07-02	1
55896	3313	4156265	2010-11-03	2010-11-17	1
66556	3942	372328	1978-09-17	1978-12-28	1
16136	956	40481087	2012-06-29	2012-07-06	1
54501	3231	28060	1962-09-01	1962-09-11	1
44987	2680	4112343	1985-01-14	1985-01-21	1
26639	1578	40481087	1955-04-21	1955-05-05	1
78076	4630	4266809	1993-04-07	1993-04-08	1
57983	3440	81151	1978-02-18	1978-03-11	1
18316	1102	80180	2012-05-02	2012-05-03	1
61592	3641	40481087	1992-11-29	1992-12-06	1
48234	2861	4112343	1992-05-12	1992-05-20	1
64432	3811	80180	1955-12-13	1955-12-14	1
16496	974	440448	1993-06-16	1993-06-17	1
13946	825	260139	1982-01-31	1982-02-14	1
13872	821	4112343	2003-09-18	2003-09-25	1
14949	882	4146173	1980-12-14	1981-02-12	1
18525	1115	80180	1987-05-17	1987-05-18	1
32369	1925	40481087	1947-08-16	1947-08-30	1
72423	4305	28060	1963-07-28	1963-08-08	1
40911	2436	40481087	1960-03-27	1960-04-03	1
20373	1227	4278672	1946-04-10	1946-07-09	1
41675	2482	40481087	1987-06-23	1987-07-14	1
82299	4886	195588	1987-09-01	1987-10-04	1
82075	4872	372328	1918-07-14	1919-07-15	1
76487	4538	260139	1986-09-21	1986-09-28	1
12943	761	260139	2015-03-29	2015-04-12	1
38340	2280	260139	2015-11-01	2015-11-15	1
15744	932	4283893	1986-03-31	1986-09-01	1
79568	4719	40481087	2019-04-22	2019-05-13	1
44301	2636	40481087	1997-05-03	1997-05-17	1
16037	950	81151	1985-05-26	1985-06-16	1
55897	3313	40481087	1977-10-01	1977-10-22	1
66557	3942	4112343	1981-04-08	1981-04-20	1
16137	956	80180	1975-10-13	1975-10-14	1
54502	3231	260139	1960-04-27	1960-05-11	1
44988	2680	4112343	1991-10-20	1991-10-30	1
26640	1578	40481087	2006-07-12	2006-08-02	1
78077	4630	4296204	1966-10-10	1966-10-31	1
57984	3440	260139	1942-10-07	1942-10-14	1
18317	1102	260139	1998-07-26	1998-08-02	1
61593	3641	40481087	1999-04-26	1999-05-10	1
48235	2861	4294548	1976-01-02	1976-04-30	1
64433	3811	81151	1925-05-04	1925-06-01	1
16497	974	4112343	1984-08-02	1984-08-13	1
13947	825	372328	1971-08-18	1971-09-18	1
13873	821	40481087	1966-10-10	1966-10-24	1
14950	882	40479768	2015-05-18	2015-07-24	1
18526	1115	372328	1954-01-05	1954-07-12	1
32370	1925	40481087	1963-12-17	1963-12-31	1
72424	4305	4112343	1975-02-08	1975-02-17	1
40912	2436	40481087	2009-09-11	2009-09-18	1
20374	1227	4283893	1983-08-17	1983-11-16	1
41676	2482	260139	1975-09-08	1975-09-22	1
82300	4886	257012	1989-10-16	1989-10-17	1
82076	4872	4109685	1968-06-01	1968-06-22	1
76488	4538	4112343	1982-05-21	1982-05-30	1
12944	761	4027663	2005-12-08	2005-12-09	1
38341	2280	4112343	1986-08-31	1986-09-07	1
15745	932	4310024	2000-10-14	2000-10-15	1
79569	4719	260139	1966-07-05	1966-07-12	1
44302	2636	80180	2002-04-25	2002-04-26	1
16038	950	4112343	2000-07-30	2000-08-09	1
55898	3313	40481087	1983-08-27	1983-09-17	1
66558	3942	40481087	2019-03-21	2019-03-28	1
16138	956	80502	2006-05-03	2006-05-04	1
54503	3231	260139	1996-07-01	1996-07-08	1
44989	2680	40479422	1986-02-08	1986-04-16	1
30644	1813	28060	2007-09-03	2007-09-16	1
78078	4630	40481087	1986-07-20	1986-07-27	1
57985	3440	260139	1957-10-16	1957-10-23	1
18318	1102	260139	2005-07-01	2005-07-08	1
61594	3641	80180	1957-12-10	1957-12-11	1
48236	2861	40481087	1993-05-10	1993-05-24	1
64434	3811	255848	2016-12-23	2016-12-24	1
16498	974	4142905	1960-03-05	1960-05-04	1
13948	825	4109685	1984-07-30	1984-08-13	1
13874	821	40481087	1977-09-03	1977-09-24	1
14951	882	40481087	1976-04-29	1976-05-13	1
18527	1115	40481087	1981-07-10	1981-07-17	1
32371	1925	40481087	1970-01-01	1970-01-22	1
72425	4305	4112343	1997-07-07	1997-07-18	1
40913	2436	40481087	2017-06-13	2017-06-27	1
20375	1227	4296204	1960-07-14	1960-08-04	1
41677	2482	40481087	1997-03-30	1997-04-06	1
82301	4886	372328	1968-05-23	1968-08-12	1
82077	4872	4112343	1915-09-30	1915-10-12	1
76489	4538	4112343	2002-09-06	2002-09-15	1
12945	761	4051466	1980-12-21	1998-06-05	1
38342	2280	40481087	1985-10-18	1985-11-08	1
15746	932	40481087	1977-02-18	1977-03-11	1
79570	4719	4218389	1944-10-10	1944-11-14	1
44303	2636	260139	1973-09-06	1973-09-13	1
16039	950	4294548	2015-10-05	2015-11-16	1
55899	3313	40481087	1986-10-08	1986-10-15	1
66559	3942	81151	1993-03-02	1993-04-06	1
16139	956	260139	1949-08-29	1949-09-12	1
54504	3231	372328	2010-03-19	2010-07-29	1
44990	2680	40481087	2001-07-21	2001-07-28	1
30645	1813	80180	2016-10-29	2016-10-30	1
78079	4630	40481087	2015-06-17	2015-07-08	1
57986	3440	372328	2009-07-11	2009-08-25	1
18319	1102	4149245	2003-02-14	2003-03-23	1
61595	3641	260139	2002-01-03	2002-01-10	1
48237	2861	40481087	1998-03-02	1998-03-16	1
64435	3811	260139	1963-10-02	1963-10-16	1
16499	974	4142905	2014-04-08	2014-06-07	1
13949	825	4112343	1982-09-13	1982-09-21	1
13875	821	80180	1985-01-24	1985-01-25	1
14952	882	40481087	1987-05-23	1987-06-13	1
20202	1217	81151	2014-07-11	2014-08-08	1
32372	1925	40481087	2018-01-23	2018-02-13	1
72426	4305	4112343	2014-03-06	2014-03-17	1
40914	2436	80180	1948-06-25	1948-06-26	1
20376	1227	40479422	1961-08-29	1961-11-04	1
41678	2482	372328	1974-12-11	1975-02-20	1
82302	4886	4112343	1971-09-06	1971-09-17	1
82078	4872	4112343	1979-08-03	1979-08-11	1
76490	4538	40481087	1960-05-28	1960-06-04	1
12946	761	40481087	1982-08-05	1982-08-12	1
38343	2280	28060	1993-04-04	1993-04-15	1
15747	932	4059173	2017-05-25	2017-08-23	1
79571	4719	4283893	1945-03-04	1945-04-22	1
44304	2636	260139	2015-12-12	2015-12-19	1
16040	950	40481087	1984-12-20	1984-12-27	1
55900	3313	40481087	1995-01-21	1995-01-28	1
66560	3942	4283893	2015-08-02	2015-08-30	1
16140	956	4112343	1961-10-20	1961-10-27	1
54505	3231	4146173	1989-03-30	1989-05-06	1
44991	2680	372328	1996-05-16	1996-10-24	1
30646	1813	260139	1987-07-20	1987-08-03	1
78080	4630	30753	1992-01-13	1992-01-14	1
57987	3440	4059173	1955-05-31	1955-06-30	1
18320	1102	4283893	1974-08-23	1974-09-20	1
61596	3641	4112343	1967-10-24	1967-10-31	1
57621	3422	0	1978-12-16	1978-12-17	1
64436	3811	4134304	1927-05-22	1927-08-20	1
16500	974	40481087	1988-09-26	1988-10-17	1
13950	825	40481087	2003-09-14	2003-10-05	1
13876	821	81151	1969-08-12	1969-09-02	1
14953	882	28060	1957-06-07	1957-06-16	1
20203	1217	260139	2003-07-05	2003-07-12	1
32373	1925	28060	1966-02-13	1966-02-23	1
72427	4305	4296204	2013-07-15	2013-08-12	1
40915	2436	260139	1942-10-28	1942-11-11	1
20377	1227	40481087	2019-04-27	2019-05-04	1
41679	2482	4146173	1995-02-24	1995-05-02	1
82303	4886	4237458	1970-11-09	1971-02-07	1
82079	4872	4112343	1997-01-24	1997-02-05	1
76491	4538	40481087	1977-02-25	1977-03-18	1
12947	761	40481087	1983-06-25	1983-07-09	1
38344	2280	260139	1982-07-28	1982-08-11	1
15748	932	4266809	2002-07-06	2002-07-07	1
79572	4719	40481087	1979-04-11	1979-05-02	1
44305	2636	4112343	1962-10-05	1962-10-14	1
16041	950	40481087	2000-09-05	2000-09-19	1
55901	3313	40481087	2009-05-23	2009-06-13	1
66561	3942	40481087	2009-01-12	2009-01-26	1
16141	956	4116491	1980-05-24	1980-07-01	1
54506	3231	4156265	1957-11-22	1957-12-13	1
44992	2680	4134304	1987-05-11	1987-08-09	1
30647	1813	260139	2007-04-21	2007-05-05	1
78081	4630	260139	1959-03-09	1959-03-23	1
57988	3440	4112343	1950-03-02	1950-03-10	1
18321	1102	40481087	1997-01-21	1997-02-04	1
61597	3641	4134304	1915-08-18	1915-09-17	1
57622	3422	28060	1975-03-08	1975-03-19	1
64437	3811	40481087	1946-04-05	1946-04-12	1
16501	974	0	1956-06-24	1956-06-25	1
13951	825	40481087	2018-09-14	2018-09-21	1
13877	821	4112343	1978-04-04	1978-04-14	1
14954	882	381316	2016-12-10	2016-12-11	1
20204	1217	372328	1974-02-19	1974-06-21	1
32374	1925	78272	2006-11-10	2006-12-08	1
75855	4504	372328	1972-11-17	1973-08-25	1
40916	2436	260139	2014-12-08	2014-12-22	1
20378	1227	260139	1949-12-22	1950-01-05	1
41680	2482	4230399	1976-07-03	1976-09-01	1
82304	4886	4237458	1982-06-07	1982-09-05	1
82080	4872	4283893	1942-10-03	1942-11-28	1
76492	4538	40481087	1997-03-18	1997-04-08	1
19362	1162	28060	1987-12-01	1987-12-13	1
38345	2280	260139	1993-12-20	1994-01-03	1
15749	932	81893	2000-11-13	2000-11-14	1
79573	4719	40481087	1985-06-04	1985-06-25	1
44306	2636	4112343	1968-03-17	1968-03-28	1
16042	950	80180	2010-02-28	2010-03-01	1
55902	3313	372328	1956-03-16	1956-03-30	1
66562	3942	80180	2019-05-30	2019-05-31	1
16142	956	4152936	1952-05-27	1952-06-17	1
54507	3231	40481087	1956-02-15	1956-02-29	1
44993	2680	4294548	1985-09-03	1985-11-26	1
30648	1813	28060	2002-06-04	2002-06-16	1
78082	4630	260139	1985-08-20	1985-09-03	1
57989	3440	4112343	2004-04-07	2004-04-19	1
18322	1102	260139	1970-10-06	1970-10-20	1
61598	3641	4218389	1946-06-27	1946-08-01	1
57623	3422	257012	1970-01-30	1970-01-31	1
64438	3811	40481087	1952-07-16	1952-07-30	1
16502	974	4112343	1969-06-02	1969-06-09	1
13952	825	260139	1972-04-15	1972-04-29	1
13878	821	4112343	1981-03-01	1981-03-13	1
14955	882	4112343	1965-06-07	1965-06-20	1
20205	1217	40481087	1973-07-17	1973-07-24	1
32375	1925	260139	1962-01-23	1962-02-06	1
75856	4504	4112343	1981-07-07	1981-07-16	1
40917	2436	381316	1961-11-25	1961-11-26	1
20379	1227	260139	2000-06-03	2000-06-10	1
41681	2482	40481087	1978-04-29	1978-05-06	1
83348	4960	81151	1952-08-11	1952-09-01	1
82081	4872	40481087	1977-08-01	1977-08-08	1
76493	4538	40481087	2015-02-20	2015-03-13	1
19363	1162	260139	2002-07-15	2002-07-29	1
38346	2280	372328	1972-04-19	1972-05-10	1
15750	932	4294548	1997-11-07	1998-01-09	1
79574	4719	81151	1992-06-19	1992-07-03	1
44307	2636	4112343	2001-08-01	2001-08-08	1
16043	950	372328	1974-02-21	1974-04-28	1
55903	3313	4112343	1974-05-06	1974-05-16	1
66563	3942	4112343	1991-09-29	1991-10-12	1
16143	956	4237458	1948-01-19	1948-04-18	1
54508	3231	80180	1980-01-01	1980-01-02	1
44994	2680	4294548	1993-07-25	1993-10-17	1
30649	1813	260139	1990-10-09	1990-10-16	1
78083	4630	4146173	1995-10-04	1995-11-03	1
57990	3440	4113008	1981-09-21	1981-10-12	1
18323	1102	260139	2013-10-26	2013-11-09	1
61599	3641	40480160	1992-11-30	1993-02-28	1
57624	3422	260139	1980-05-10	1980-05-17	1
64439	3811	40481087	1966-11-15	1966-11-22	1
16503	974	4112343	2010-08-14	2010-08-23	1
13953	825	260139	1976-02-05	1976-02-19	1
13879	821	4113008	1960-06-09	1960-06-30	1
14956	882	4149245	2013-06-20	2013-08-26	1
20206	1217	40481087	1990-10-30	1990-11-06	1
32376	1925	372328	1947-06-26	1947-12-27	1
75857	4504	4112343	2005-12-08	2005-12-20	1
40918	2436	4112343	1920-08-03	1920-08-13	1
20380	1227	378419	2016-04-06	2016-04-07	1
41682	2482	40481087	2008-07-01	2008-07-22	1
83349	4960	260139	1918-09-28	1918-10-05	1
82082	4872	40481087	1994-03-04	1994-03-18	1
76494	4538	30753	1986-01-27	1986-01-28	1
19364	1162	378001	1982-08-02	1982-10-01	1
38347	2280	4048171	1974-06-10	1974-06-11	1
16541	978	78272	2003-06-19	2003-07-10	1
79575	4719	260139	1953-01-28	1953-02-11	1
46544	2774	81151	1977-04-07	1977-04-21	1
16044	950	4112343	2002-08-02	2002-08-09	1
55904	3313	4237458	1960-07-23	1960-08-22	1
66564	3942	4237458	1989-06-21	1989-07-21	1
16144	956	40481087	1940-01-14	1940-01-21	1
54509	3231	4112343	1983-03-11	1983-03-23	1
44995	2680	4296204	2009-06-14	2009-07-12	1
30650	1813	4134304	2016-03-18	2016-04-17	1
78084	4630	4155034	1993-11-29	1993-12-13	1
57991	3440	40481087	1944-11-26	1944-12-17	1
18324	1102	4112343	2006-10-14	2006-10-27	1
61600	3641	40481087	1920-10-29	1920-11-05	1
57625	3422	260139	2006-08-18	2006-09-01	1
67781	4010	28060	2015-10-21	2015-10-31	1
16504	974	4166224	1993-06-16	1993-06-17	1
13954	825	260139	2010-04-13	2010-04-20	1
13880	821	40481087	1955-01-15	1955-01-22	1
14957	882	81151	2002-02-13	2002-03-20	1
20207	1217	40481087	2013-03-14	2013-03-21	1
32377	1925	4112343	1991-01-11	1991-01-18	1
75858	4504	4112343	2007-04-18	2007-04-29	1
40919	2436	4112343	1966-03-30	1966-04-10	1
20381	1227	4112343	1977-06-23	1977-07-04	1
41683	2482	80180	2015-05-20	2015-05-21	1
83350	4960	378001	1947-08-08	1947-10-07	1
82083	4872	40481087	2009-03-07	2009-03-21	1
76495	4538	260139	2009-06-08	2009-06-22	1
19365	1162	4059173	1952-10-08	1952-11-07	1
38348	2280	4112343	1980-03-09	1980-03-22	1
16542	978	195588	2014-08-05	2014-09-16	1
79576	4719	372328	1935-04-01	1935-05-12	1
46545	2774	260139	1971-07-11	1971-07-25	1
16045	950	4134304	1988-03-02	1988-05-31	1
55905	3313	4296205	1997-06-23	1997-07-14	1
1429	84	28060	1974-11-10	1974-11-21	1
16145	956	28060	1941-11-04	1941-11-14	1
54510	3231	40481087	1949-04-15	1949-04-22	1
44996	2680	4296205	2014-12-13	2015-01-03	1
30651	1813	4278672	1986-07-24	1986-10-22	1
78085	4630	40481087	1970-06-30	1970-07-21	1
57992	3440	40481087	1960-10-13	1960-10-27	1
18325	1102	40481087	1975-04-24	1975-05-01	1
61601	3641	40481087	1929-07-11	1929-07-18	1
57626	3422	4155034	1990-01-22	1990-02-05	1
67782	4010	80180	2012-12-17	2012-12-18	1
16505	974	4109685	1976-06-14	1976-07-05	1
13955	825	372328	1972-08-13	1972-10-21	1
13881	821	40481087	1961-11-22	1961-11-29	1
14958	882	260139	2018-09-03	2018-09-17	1
20208	1217	40481087	2013-12-24	2014-01-14	1
32378	1925	4112343	1997-12-15	1997-12-27	1
75859	4504	4237458	2003-11-05	2003-12-05	1
40920	2436	4146173	2018-02-04	2018-03-06	1
20382	1227	4112343	2000-05-02	2000-05-13	1
41684	2482	260139	1990-06-04	1990-06-11	1
83351	4960	378001	1982-02-01	1982-04-02	1
82084	4872	28060	1946-11-05	1946-11-13	1
76496	4538	4112343	1954-11-08	1954-11-17	1
19366	1162	4112343	1931-08-01	1931-08-14	1
38349	2280	4112343	1985-09-24	1985-10-03	1
16543	978	4112343	2014-04-04	2014-04-13	1
79577	4719	4299128	2003-06-06	2003-06-20	1
46546	2774	260139	1975-04-23	1975-05-07	1
16046	950	40481087	2013-09-19	2013-10-10	1
55906	3313	40481087	1992-04-23	1992-04-30	1
1430	84	260139	1995-08-01	1995-08-15	1
16146	956	78272	1944-12-14	1945-01-04	1
54511	3231	40481087	2012-04-01	2012-04-08	1
44997	2680	40481087	2008-12-26	2009-01-02	1
30652	1813	372328	1984-09-23	1984-11-24	1
78086	4630	40481087	2012-12-16	2012-12-23	1
57993	3440	140673	2015-02-20	2015-02-21	1
18326	1102	40481087	2005-03-03	2005-03-24	1
61602	3641	40481087	1942-11-13	1942-12-04	1
57627	3422	4283893	2011-09-11	2011-12-18	1
67783	4010	4112343	1981-05-01	1981-05-08	1
16506	974	40481087	1967-02-05	1967-02-26	1
13956	825	4109685	2013-08-02	2013-08-23	1
13882	821	40481087	1965-05-19	1965-06-09	1
14959	882	40481087	1966-10-04	1966-10-18	1
20209	1217	80180	2013-02-26	2013-02-27	1
32379	1925	4152936	2002-12-17	2002-12-31	1
75860	4504	40481087	1972-12-22	1973-01-05	1
40921	2436	4156265	2000-05-18	2000-06-08	1
20383	1227	4230399	2004-05-22	2004-07-21	1
41685	2482	4035415	1991-05-16	1991-06-15	1
83352	4960	4112343	1916-10-08	1916-10-21	1
82085	4872	28060	1971-08-08	1971-08-19	1
76497	4538	4112343	1999-06-15	1999-06-23	1
19367	1162	4112343	1936-11-16	1936-11-23	1
38350	2280	4113008	2000-08-27	2000-09-10	1
16544	978	4134304	1985-01-24	1985-04-24	1
79578	4719	40481087	2000-08-01	2000-08-22	1
46547	2774	4156265	2016-10-26	2016-11-16	1
16047	950	28060	1981-03-29	1981-04-08	1
55907	3313	40481087	2017-03-08	2017-03-29	1
1431	84	372328	1975-04-08	1975-05-22	1
16147	956	372328	1950-08-29	1951-07-25	1
54512	3231	260139	1954-07-12	1954-07-26	1
44998	2680	40481087	2012-11-20	2012-12-11	1
30653	1813	4112343	2004-05-07	2004-05-20	1
78087	4630	81893	1991-08-16	1991-08-17	1
57994	3440	372328	1945-11-19	1946-02-12	1
20533	1236	80180	1963-09-07	1963-09-08	1
61603	3641	40481087	1987-04-14	1987-05-05	1
57628	3422	4294548	1987-09-21	1987-10-05	1
67784	4010	4237458	2018-04-30	2018-05-30	1
18828	1134	260139	1966-08-01	1966-08-15	1
13957	825	4112343	1994-06-22	1994-07-05	1
13883	821	40481087	1991-11-18	1991-11-25	1
16812	1000	257012	1964-10-30	1964-10-31	1
20210	1217	81151	1988-10-20	1988-11-24	1
32380	1925	4152936	2019-02-03	2019-02-17	1
75861	4504	80180	2010-12-23	2010-12-24	1
40922	2436	4296205	1922-07-27	1922-08-24	1
20384	1227	4237458	1981-02-22	1981-04-23	1
41686	2482	4112343	1984-02-24	1984-03-03	1
83353	4960	4112343	1973-12-18	1973-12-29	1
82086	4872	260139	1960-07-25	1960-08-08	1
76498	4538	4113008	2003-12-26	2004-01-09	1
19368	1162	40481087	1976-05-06	1976-05-13	1
38351	2280	4283893	1983-03-20	1983-08-21	1
16545	978	4266809	2012-04-22	2012-04-23	1
79579	4719	28060	1997-08-19	1997-08-31	1
46548	2774	4218389	1981-11-26	1981-12-31	1
16048	950	372328	1972-09-10	1972-10-29	1
56601	3362	28060	1979-05-23	1979-06-02	1
1432	84	40481087	2001-11-07	2001-11-28	1
16148	956	4109685	1969-10-12	1969-10-26	1
54513	3231	260139	1966-04-16	1966-04-30	1
44999	2680	257012	1985-09-17	1985-09-18	1
30654	1813	260139	1990-02-02	1990-02-09	1
78088	4630	260139	2009-09-17	2009-10-01	1
57995	3440	4112343	1988-01-28	1988-02-04	1
20534	1236	80502	2010-07-29	2010-07-30	1
61604	3641	40481087	1993-08-12	1993-08-19	1
57629	3422	40481087	1978-08-16	1978-09-06	1
67785	4010	40481087	2015-06-03	2015-06-17	1
18829	1134	257012	1993-06-15	1993-06-16	1
13958	825	40481087	2016-12-04	2016-12-11	1
13884	821	260139	1968-08-08	1968-08-15	1
16813	1000	4112343	1989-08-10	1989-08-17	1
20211	1217	257012	2012-11-30	2012-12-01	1
32381	1925	40481087	1956-11-16	1956-11-23	1
75862	4504	260139	1970-08-01	1970-08-15	1
40923	2436	40481087	1916-07-22	1916-08-12	1
20385	1227	4237458	2017-09-11	2017-10-11	1
41687	2482	4134304	2002-03-26	2002-06-24	1
83354	4960	4112343	1990-10-03	1990-10-15	1
82087	4872	4112343	1933-11-07	1933-11-15	1
76499	4538	4283893	2014-01-31	2014-05-02	1
19369	1162	40481087	1989-01-21	1989-02-04	1
38352	2280	40479768	1997-04-08	1997-05-15	1
16546	978	40481087	2008-10-11	2008-10-25	1
79580	4719	28060	2006-10-15	2006-10-27	1
46549	2774	40481087	1947-02-05	1947-02-26	1
16049	950	440086	1981-05-21	1982-04-08	1
56602	3362	257012	1990-01-19	1990-01-20	1
1433	84	40481087	2007-02-05	2007-02-12	1
16149	956	4112343	1942-11-11	1942-11-18	1
54514	3231	260139	2001-05-30	2001-06-13	1
45000	2680	260139	1978-12-18	1979-01-01	1
30655	1813	372328	1984-04-05	1984-05-26	1
78089	4630	4027663	1983-01-20	1983-01-21	1
57996	3440	4134304	1944-01-29	1944-02-28	1
20535	1236	372328	1921-07-24	1921-10-06	1
61605	3641	80502	1992-11-30	1992-12-01	1
57630	3422	40481087	1999-08-04	1999-08-18	1
67786	4010	260139	2006-01-13	2006-01-20	1
18830	1134	372328	1942-02-04	1942-08-09	1
13959	825	40481087	2017-09-16	2017-09-30	1
13885	821	372328	1951-08-26	1951-11-17	1
16814	1000	4237458	1964-11-03	1964-12-03	1
20212	1217	261325	1994-09-23	1994-09-24	1
32382	1925	40481087	1978-01-15	1978-02-05	1
75863	4504	260139	2012-03-05	2012-03-19	1
40924	2436	40481087	1963-08-22	1963-08-29	1
20386	1227	4278672	1943-03-27	1943-05-26	1
41688	2482	40481087	1981-07-27	1981-08-17	1
83355	4960	4156265	1955-08-17	1955-09-07	1
82088	4872	4112343	1946-07-27	1946-08-05	1
76500	4538	40481087	1988-01-22	1988-01-29	1
19370	1162	4112343	1959-11-08	1959-11-18	1
38353	2280	372328	1974-09-27	1975-05-21	1
16547	978	40481087	2018-11-09	2018-11-30	1
79581	4719	81151	1969-06-06	1969-06-20	1
46550	2774	40481087	1972-12-05	1972-12-19	1
16050	950	4146173	1999-08-02	1999-10-01	1
56603	3362	260139	1966-09-02	1966-09-09	1
1434	84	28060	1982-07-13	1982-07-26	1
16150	956	4112343	1983-06-18	1983-07-01	1
54515	3231	260139	2005-01-29	2005-02-12	1
45001	2680	372328	1974-01-28	1974-02-11	1
32547	1935	28060	1981-05-01	1981-05-13	1
78090	4630	4112343	1973-09-23	1973-10-04	1
57997	3440	4146173	1995-09-29	1995-11-05	1
20536	1236	4109685	1999-03-31	1999-04-14	1
61606	3641	375671	2016-07-27	2016-09-25	1
57631	3422	40481087	2016-11-27	2016-12-18	1
67787	4010	4109685	2019-05-25	2019-06-15	1
18831	1134	4112343	1949-06-01	1949-06-14	1
13960	825	260139	1988-02-06	1988-02-13	1
13886	821	4027663	1974-06-06	1974-06-07	1
16815	1000	28060	1995-12-16	1995-12-29	1
20213	1217	4112343	1978-05-04	1978-05-12	1
32383	1925	40481087	2012-05-18	2012-05-25	1
75864	4504	4059173	1992-03-07	1992-05-06	1
40925	2436	134438	1930-03-19	1931-03-16	1
20387	1227	40481087	1952-02-13	1952-03-05	1
41689	2482	40481087	1997-10-11	1997-10-18	1
83356	4960	4296205	1943-09-30	1943-10-28	1
82089	4872	4112343	2015-11-12	2015-11-25	1
76501	4538	4112343	1958-06-01	1958-06-11	1
19371	1162	40481087	1962-05-07	1962-05-21	1
38354	2280	4112343	2000-08-08	2000-08-19	1
16548	978	28060	1979-09-25	1979-10-03	1
79582	4719	4112343	2012-05-01	2012-05-12	1
46551	2774	40481087	1985-08-19	1985-08-26	1
16051	950	40481087	1985-11-01	1985-11-15	1
56604	3362	4112343	1957-09-22	1957-10-03	1
1435	84	257012	2013-11-24	2013-11-25	1
16151	956	4112343	2004-07-22	2004-08-04	1
54516	3231	440448	1983-10-09	1983-10-10	1
45002	2680	4109685	1976-09-14	1976-09-28	1
32548	1935	4112343	1977-10-06	1977-10-15	1
78091	4630	4112343	1991-07-03	1991-07-13	1
57998	3440	4152936	2004-12-22	2005-01-05	1
20537	1236	4112343	2002-12-20	2003-01-02	1
61607	3641	4294548	1991-03-20	1991-05-01	1
57632	3422	78272	1977-11-21	1977-12-26	1
67788	4010	4112343	2007-12-17	2007-12-28	1
18832	1134	4134304	2013-07-02	2013-08-01	1
13961	825	372328	1971-01-10	1971-06-19	2
13887	821	4112343	1956-11-30	1956-12-09	1
16816	1000	80180	2008-01-22	2008-01-23	1
20214	1217	4112343	1990-07-09	1990-07-16	1
32384	1925	40481087	2013-04-26	2013-05-10	1
75865	4504	4112343	2017-12-05	2017-12-18	1
40926	2436	260139	1961-09-18	1961-10-02	1
20388	1227	40481087	2014-05-04	2014-05-18	1
43277	2580	198199	1980-06-03	1980-07-12	1
83357	4960	40481087	1930-10-01	1930-10-22	1
82090	4872	4152936	2018-11-07	2018-11-21	1
76502	4538	4112343	2013-04-22	2013-05-03	1
19372	1162	40481087	1978-01-09	1978-01-23	1
38355	2280	4112343	2002-07-11	2002-07-20	1
16549	978	28060	1981-05-29	1981-06-11	1
79583	4719	4152936	2013-12-24	2014-01-07	1
46552	2774	40481087	2004-01-27	2004-02-03	1
16052	950	260139	1985-06-05	1985-06-12	1
56605	3362	4283893	1990-01-05	1990-03-02	1
1436	84	260139	1996-11-08	1996-11-22	1
16152	956	40481087	1936-02-07	1936-02-14	1
54517	3231	4112343	2000-10-22	2000-11-01	1
45003	2680	4112343	1977-09-13	1977-09-22	1
32549	1935	40481087	2018-09-20	2018-10-04	1
78092	4630	40481087	1976-09-25	1976-10-16	1
57999	3440	4218389	2009-11-10	2009-12-15	1
20538	1236	4237458	1994-08-24	1994-09-23	1
61608	3641	40481087	1923-08-27	1923-09-03	1
57633	3422	80180	2001-08-27	2001-08-28	1
67789	4010	0	1977-05-05	1977-05-06	1
18833	1134	40481087	2006-12-17	2006-12-24	1
13962	825	378001	1982-10-09	1982-11-08	1
13888	821	4134304	1978-04-18	1978-07-17	1
16817	1000	372328	1965-01-02	1965-02-16	1
20215	1217	4294548	1993-06-01	1993-06-15	1
32385	1925	260139	1954-02-04	1954-02-11	1
75866	4504	4113008	2008-08-10	2008-08-24	1
40927	2436	4237458	1963-02-11	1963-04-12	1
23269	1390	81151	1980-03-07	1980-04-04	1
43278	2580	260139	1980-01-03	1980-01-17	1
83358	4960	40481087	1943-05-05	1943-05-12	1
82091	4872	40481087	1925-06-25	1925-07-16	1
76503	4538	40481087	1957-03-30	1957-04-06	1
19373	1162	28060	1981-09-24	1981-10-01	1
38356	2280	40481087	1972-06-25	1972-07-09	1
16550	978	80180	2012-04-22	2012-04-23	1
79584	4719	40481087	1935-11-03	1935-11-17	1
46553	2774	28060	1978-08-28	1978-09-08	1
16053	950	4059173	1983-04-16	1983-06-15	1
56606	3362	40481087	1967-04-18	1967-05-09	1
1437	84	4112343	1974-05-16	1974-05-26	1
16153	956	40481087	1936-08-18	1936-08-25	1
54518	3231	4294548	2012-02-04	2012-02-25	1
45004	2680	4112343	2003-06-10	2003-06-21	1
32550	1935	28060	1972-12-21	1972-12-29	1
79330	4704	195588	1999-12-10	2000-01-18	1
58000	3440	28060	1985-06-30	1985-07-11	1
20539	1236	4237458	2001-03-04	2001-04-03	1
61609	3641	40481087	1976-05-29	1976-06-05	1
57634	3422	260139	1981-03-21	1981-04-04	1
67790	4010	28060	1981-03-18	1981-03-30	1
18834	1134	260139	1955-06-08	1955-06-22	1
13963	825	439777	1970-09-12	1970-09-13	1
13889	821	81893	1984-02-29	1984-03-01	1
16818	1000	4112343	1967-12-22	1968-01-01	1
20216	1217	40481087	1977-09-10	1977-10-01	1
32386	1925	372328	1945-06-19	1945-09-29	1
75867	4504	313217	2019-06-22	2019-06-23	1
40928	2436	40481087	1965-05-25	1965-06-01	1
23270	1390	378001	1994-09-18	1994-10-18	1
43279	2580	260139	1989-07-29	1989-08-12	1
83359	4960	140673	1977-03-31	1977-04-01	1
82092	4872	40481087	1953-11-05	1953-11-12	1
76504	4538	40481087	1985-04-11	1985-05-02	1
19374	1162	260139	1922-12-31	1923-01-14	1
40079	2381	28060	1945-05-06	1945-05-16	1
16551	978	257012	1978-10-20	1978-10-21	1
79585	4719	40481087	1950-01-31	1950-02-07	1
46554	2774	260139	1941-04-17	1941-04-24	1
16054	950	4155034	1984-07-09	1984-07-30	1
56607	3362	28060	1965-06-26	1965-07-04	1
1438	84	4112343	1974-06-28	1974-07-10	1
16154	956	40481087	1961-07-20	1961-08-03	1
54519	3231	40481087	1956-12-01	1956-12-22	1
45005	2680	4112343	2013-07-02	2013-07-11	1
32551	1935	260139	1989-12-13	1989-12-27	1
79331	4704	4134304	1982-09-04	1982-11-03	1
58001	3440	80180	1980-10-21	1980-10-22	1
20540	1236	4294548	1993-04-14	1993-04-21	1
61610	3641	40481087	2007-03-05	2007-03-19	1
57635	3422	260139	1995-09-20	1995-10-04	1
67791	4010	260139	1994-01-27	1994-02-10	1
18835	1134	4035415	1947-07-19	1947-08-18	1
13964	825	4112343	2002-03-26	2002-04-06	1
13890	821	260139	1953-07-18	1953-07-25	1
16819	1000	4116491	2016-01-30	2016-03-03	1
20217	1217	40481087	1995-06-11	1995-07-02	1
32387	1925	4112343	1985-12-11	1985-12-24	1
75868	4504	4294548	1995-07-06	1995-07-20	1
40929	2436	40481087	2001-05-26	2001-06-16	1
23271	1390	40481087	2009-10-20	2009-11-10	1
43280	2580	4112343	1962-04-22	1962-05-02	1
83360	4960	4112343	1921-10-16	1921-10-29	1
82093	4872	40481087	1980-06-29	1980-07-06	1
76505	4538	40481087	1991-04-21	1991-05-12	1
19375	1162	260139	1942-02-15	1942-02-22	1
40080	2381	321042	2013-01-30	2013-01-31	1
16552	978	260139	1985-10-23	1985-10-30	1
79586	4719	40481087	1999-09-16	1999-09-30	1
46555	2774	260139	1946-11-01	1946-11-08	1
16055	950	40481087	1980-11-05	1980-11-12	1
56608	3362	81151	1981-09-10	1981-10-08	1
1439	84	4112343	1999-07-10	1999-07-19	1
16155	956	40481087	2017-06-18	2017-07-09	1
54520	3231	40481087	1968-02-29	1968-03-21	1
45006	2680	4152936	2017-09-19	2017-10-03	1
32552	1935	40481087	1998-12-15	1998-12-29	1
79332	4704	4155034	1969-01-01	1969-01-15	1
58002	3440	81151	1998-09-20	1998-10-25	1
20541	1236	40481087	1950-08-23	1950-09-06	1
67558	3996	81151	1976-09-01	1976-09-22	1
57636	3422	4112343	2003-02-24	2003-03-09	1
67792	4010	260139	1999-11-24	1999-12-01	1
18836	1134	4112343	1952-05-03	1952-05-11	1
13965	825	40481087	2018-04-05	2018-04-12	1
13891	821	260139	1967-02-22	1967-03-08	1
16820	1000	4285898	2007-06-26	2007-06-27	1
20218	1217	40481087	2015-07-15	2015-08-05	1
32388	1925	4112343	1990-05-03	1990-05-13	1
75869	4504	40481087	1987-04-20	1987-05-11	1
40930	2436	260139	1980-08-21	1980-09-04	1
23272	1390	40481087	2017-05-07	2017-05-28	1
43281	2580	4112343	1962-08-04	1962-08-13	1
83361	4960	4112343	1939-07-01	1939-07-12	1
83918	4990	28060	2008-02-04	2008-02-12	1
76506	4538	40481087	1999-12-31	2000-01-07	1
19376	1162	372328	1924-09-05	1925-07-18	1
40081	2381	378001	1979-10-02	1979-12-01	1
16553	978	4027663	2000-08-08	2000-08-09	1
79883	4739	28060	1916-10-22	1916-11-01	1
46556	2774	317576	1997-12-26	1997-12-27	1
16056	950	40481087	1983-02-08	1983-02-22	1
56609	3362	4218389	1960-04-05	1960-05-03	1
1440	84	4283893	2013-09-15	2013-12-08	1
16156	956	260139	2001-03-24	2001-04-07	1
54521	3231	40481087	2018-08-14	2018-08-21	1
45007	2680	40481087	1972-05-16	1972-05-23	1
32553	1935	40481087	2016-06-03	2016-06-24	1
79333	4704	4218389	2010-09-21	2010-10-26	1
58003	3440	260139	1954-02-18	1954-03-04	1
20542	1236	40481087	1967-02-07	1967-02-14	1
67559	3996	81151	1983-05-19	1983-06-09	1
57637	3422	0	1973-11-12	1973-11-13	1
67793	4010	372328	1982-12-05	1983-04-21	1
18837	1134	40481087	1951-08-16	1951-09-06	1
13966	825	78272	2011-06-23	2011-07-14	1
13892	821	260139	2008-11-15	2008-11-29	1
16821	1000	0	2017-01-29	2017-01-30	1
20219	1217	381316	2018-10-19	2018-10-20	1
32389	1925	4112343	2013-04-24	2013-05-05	1
75870	4504	260139	1983-11-11	1983-11-18	1
40931	2436	317576	2008-02-02	2008-02-03	1
23273	1390	28060	1981-04-22	1981-05-05	1
43282	2580	4112343	1988-10-29	1988-11-05	1
83362	4960	40481087	1960-04-16	1960-04-23	1
83919	4990	372328	1966-07-02	1967-01-25	1
76507	4538	40481087	2014-10-04	2014-10-18	1
19377	1162	440086	1930-10-29	1937-11-06	1
40082	2381	4112343	1942-10-09	1942-10-17	1
16554	978	4059173	1995-09-29	1995-12-28	1
79884	4739	260139	1919-06-09	1919-06-16	1
46557	2774	4112343	1968-11-02	1968-11-15	1
17387	1046	80180	2012-10-15	2012-10-16	1
56610	3362	40481087	1989-08-18	1989-09-01	1
1441	84	40481087	1993-10-08	1993-10-22	1
16157	956	260139	2014-09-28	2014-10-05	1
54522	3231	260139	1996-08-09	1996-08-16	1
45008	2680	4112343	1999-04-22	1999-04-29	1
32554	1935	80180	2009-03-09	2009-03-10	1
79334	4704	4266809	2010-07-25	2010-07-26	1
58004	3440	378001	1943-03-05	1943-04-04	1
20543	1236	40481087	1984-10-20	1984-11-03	1
67560	3996	4149245	1989-05-08	1989-06-14	1
57638	3422	28060	2012-09-19	2012-09-29	1
67794	4010	380378	1977-05-05	1977-05-06	1
18838	1134	40481087	1953-10-31	1953-11-14	1
13967	825	260139	1997-09-22	1997-09-29	1
13893	821	4112343	1968-12-07	1968-12-18	1
16822	1000	260139	1970-09-04	1970-09-18	1
20220	1217	4112343	1973-06-12	1973-06-25	1
32390	1925	4237458	1959-06-06	1959-07-06	1
75871	4504	4059173	1978-01-20	1978-03-21	1
40932	2436	4112343	1953-11-21	1953-12-01	1
23274	1390	81151	2007-05-13	2007-05-27	1
43283	2580	4112343	2005-02-19	2005-03-02	1
83363	4960	40481087	1984-11-19	1984-12-10	1
83920	4990	4112343	2012-03-26	2012-04-07	1
78207	4636	260139	1963-10-18	1963-10-25	1
19378	1162	4112343	1958-07-03	1958-07-13	1
40083	2381	4112343	1973-03-17	1973-03-25	1
16555	978	28060	2011-11-02	2011-11-13	1
79885	4739	260139	1930-08-05	1930-08-12	1
46558	2774	4112343	1995-07-12	1995-07-21	1
17388	1046	81151	1983-04-06	1983-05-11	1
56611	3362	40481087	1995-07-12	1995-07-26	1
1442	84	40481087	1996-12-14	1996-12-28	1
16158	956	4218389	1955-02-02	1955-02-23	1
54523	3231	4112343	1979-02-16	1979-03-01	1
45009	2680	4294548	1997-02-24	1997-04-07	1
32555	1935	372328	1965-09-26	1966-01-11	1
79335	4704	260139	1982-01-03	1982-01-10	1
58005	3440	4112343	1962-03-11	1962-03-18	1
20544	1236	28060	1971-04-26	1971-05-06	1
67561	3996	4218389	2016-06-22	2016-07-13	1
57639	3422	134438	1993-12-19	1994-10-20	1
67795	4010	4029498	1977-05-05	1977-05-06	1
18839	1134	40481087	2003-11-20	2003-11-27	1
13968	825	378001	1972-06-03	1972-07-03	1
13894	821	40481087	1965-02-20	1965-03-13	1
16823	1000	260139	1972-04-20	1972-05-04	1
20221	1217	4283893	2012-10-19	2013-01-04	1
32391	1925	4294548	1989-01-20	1989-02-17	1
75872	4504	40481087	1974-05-05	1974-05-19	1
40933	2436	4218389	1915-12-26	1916-01-30	1
23275	1390	4027663	1996-12-22	1996-12-23	1
43284	2580	4310024	1993-01-26	1993-01-27	1
83364	4960	80180	1949-11-28	1949-11-29	1
83921	4990	4116491	1983-02-23	1983-04-18	1
78208	4636	372328	1950-11-24	1951-05-29	1
19379	1162	4134304	1993-03-07	1993-04-06	1
40084	2381	4112343	1992-05-01	1992-05-11	1
16556	978	4294548	1978-10-06	1979-04-06	1
79886	4739	4112343	1920-08-16	1920-08-29	1
46559	2774	40481087	1940-05-27	1940-06-03	1
17389	1046	81151	1988-06-13	1988-07-18	1
56612	3362	28060	1984-01-17	1984-01-25	1
1443	84	80180	2014-03-29	2014-03-30	1
16159	956	4218389	1956-02-18	1956-03-24	1
54524	3231	40481087	1953-08-04	1953-08-25	1
45010	2680	40481087	1984-03-30	1984-04-06	1
32556	1935	40481087	1994-05-24	1994-06-14	1
79336	4704	260139	2009-11-01	2009-11-08	1
58006	3440	4112343	1993-07-11	1993-07-21	1
20545	1236	4112343	1921-07-27	1921-08-05	1
67562	3996	40481087	1984-02-06	1984-02-27	1
57640	3422	321042	1973-11-12	1973-11-13	1
67796	4010	4112343	1983-08-29	1983-09-11	1
18840	1134	28060	1940-07-26	1940-08-05	1
13969	825	40481087	1976-05-18	1976-06-08	1
13895	821	40481087	2015-01-31	2015-02-14	1
16824	1000	4027663	1997-02-03	1997-02-04	1
20222	1217	40481087	2008-04-01	2008-04-08	1
32392	1925	40481087	1953-07-06	1953-07-27	1
75873	4504	40481087	2001-06-23	2001-07-07	1
40934	2436	4278672	1990-01-20	1990-03-21	1
23276	1390	4112343	1972-07-27	1972-08-05	1
43285	2580	0	1979-05-07	1979-05-08	1
83365	4960	378001	1923-08-02	1923-10-01	1
83922	4990	4142905	1966-03-04	1966-06-02	1
78209	4636	40481087	1976-07-08	1976-07-22	1
19380	1162	40481087	1943-04-06	1943-04-27	1
40085	2381	4112343	2007-10-08	2007-10-19	1
16557	978	40481087	1982-08-24	1982-08-31	1
79887	4739	4294548	1980-08-14	1980-12-11	1
46560	2774	40481087	2010-11-06	2010-11-13	1
17390	1046	257012	1995-12-05	1995-12-06	1
56613	3362	78272	2010-12-10	2011-01-07	1
1444	84	260139	1976-07-02	1976-07-16	1
16160	956	40481087	1945-03-03	1945-03-10	1
54525	3231	40481087	1954-03-01	1954-03-22	1
45011	2680	40481087	1994-06-19	1994-07-03	1
32557	1935	40481087	2006-03-01	2006-03-22	1
79337	4704	4027663	1999-12-10	1999-12-11	1
58007	3440	4112343	2013-12-02	2013-12-15	1
20546	1236	4112343	1938-08-26	1938-09-02	1
67563	3996	257012	2005-02-05	2005-02-06	1
57641	3422	380378	1978-12-16	1978-12-17	1
67797	4010	4112343	1994-01-17	1994-01-26	1
18841	1134	28060	1948-01-30	1948-02-06	1
13970	825	40481087	1999-08-14	1999-08-28	1
17309	1039	81151	1977-08-17	1977-09-07	1
16825	1000	4237458	1966-10-24	1967-01-22	1
20223	1217	28060	2012-11-21	2012-12-01	1
32393	1925	40481087	1981-08-11	1981-08-25	1
75874	4504	40481087	2018-06-14	2018-07-05	1
40935	2436	40481087	1917-03-19	1917-03-26	1
23277	1390	4112343	2001-02-22	2001-03-04	1
43286	2580	80180	1995-01-16	1995-01-17	1
83366	4960	378419	1984-12-08	1984-12-09	1
83923	4990	4237458	1967-03-29	1967-06-27	1
78210	4636	40481087	1978-10-19	1978-10-26	1
19381	1162	40481087	1943-08-04	1943-08-11	1
40086	2381	40481087	1970-01-24	1970-02-14	1
16558	978	40481087	2002-11-20	2002-12-04	1
79888	4739	40481087	1920-01-31	1920-02-21	1
46561	2774	28060	2004-04-06	2004-04-13	1
17391	1046	260139	1980-09-19	1980-09-26	1
56614	3362	80180	1996-05-31	1996-06-01	1
1445	84	372328	1977-02-10	1977-07-07	1
16161	956	40481087	1996-06-08	1996-06-15	1
54526	3231	40481087	1974-11-22	1974-12-06	1
45500	2708	78272	1993-11-02	1993-11-23	1
32558	1935	192671	2009-04-10	2009-04-11	1
79338	4704	4310024	2008-06-05	2008-06-06	1
58008	3440	4112343	2017-07-28	2017-08-09	1
20547	1236	4112343	2010-12-25	2011-01-06	1
67564	3996	260139	1979-12-16	1979-12-30	1
57642	3422	4029498	1978-12-16	1978-12-17	1
67798	4010	4294548	2016-05-21	2016-06-11	1
18842	1134	80180	1978-09-09	1978-09-10	1
13971	825	40481087	2005-01-06	2005-01-27	1
17310	1039	4218389	2001-09-08	2001-10-06	1
16826	1000	4278672	1976-02-18	1976-03-19	1
20224	1217	81151	2019-04-14	2019-04-28	1
32394	1925	40481087	1998-12-05	1998-12-19	1
77384	4590	260139	1968-08-09	1968-08-16	1
40936	2436	40481087	1929-07-27	1929-08-17	1
23278	1390	4155034	1967-10-21	1967-11-11	1
43287	2580	317576	1963-05-20	1963-05-21	1
83367	4960	4112343	1948-03-30	1948-04-06	1
83924	4990	4237458	1979-12-21	1980-03-20	1
78211	4636	81151	1962-02-08	1962-02-22	1
19382	1162	80180	1963-07-08	1963-07-09	1
40087	2381	40481087	1975-10-14	1975-10-28	1
18928	1138	80180	2016-03-12	2016-03-13	1
79889	4739	40481087	1924-08-03	1924-08-17	1
46562	2774	260139	1995-12-03	1995-12-17	1
17392	1046	260139	2000-03-17	2000-03-31	1
56615	3362	4109685	2013-11-22	2013-12-13	1
1446	84	4112343	2008-09-03	2008-09-15	1
16162	956	40481087	2009-01-15	2009-01-29	1
54527	3231	40481087	1981-05-10	1981-05-24	1
45501	2708	80180	1988-10-16	1988-10-17	1
32559	1935	260139	1980-01-12	1980-01-26	1
79339	4704	40481087	1983-08-07	1983-08-14	1
58009	3440	4134304	2015-10-29	2015-11-28	1
20548	1236	4155034	1978-11-02	1978-11-16	1
67565	3996	260139	2003-04-05	2003-04-12	1
57643	3422	4294548	1970-01-09	1970-02-20	1
67799	4010	40481087	1981-09-16	1981-09-30	1
18843	1134	372328	1940-09-23	1941-02-09	1
14321	847	28060	1992-01-23	1992-02-03	1
17311	1039	4294548	2005-11-06	2006-03-12	1
16827	1000	4294548	1964-08-14	1965-03-19	1
20225	1217	260139	2006-12-13	2006-12-27	1
32395	1925	195588	2000-01-07	2000-02-12	1
77385	4590	4112343	2012-04-19	2012-04-26	1
40937	2436	40481087	1953-11-10	1953-11-24	1
23279	1390	4294548	2000-09-17	2000-10-08	1
43288	2580	372328	1962-10-07	1963-05-20	1
83368	4960	4112343	1968-08-08	1968-08-15	1
83925	4990	4294548	1982-05-14	1982-06-04	1
78212	4636	40481087	2004-02-02	2004-02-23	1
19383	1162	255848	2007-01-02	2007-01-03	1
40088	2381	40481087	1986-10-07	1986-10-14	1
18929	1138	4035415	2007-03-15	2007-04-14	1
79890	4739	80180	1952-01-31	1952-02-01	1
46563	2774	372328	1941-01-16	1941-02-28	1
17393	1046	4112343	1980-02-07	1980-02-16	1
56616	3362	4112343	2011-08-12	2011-08-23	1
1447	84	372328	1979-09-25	1980-01-17	1
16374	970	28060	1960-05-11	1960-05-23	1
54528	3231	40481087	1994-01-23	1994-01-30	1
45502	2708	257012	1963-01-08	1963-01-09	1
32560	1935	260139	1993-01-23	1993-01-30	1
79340	4704	28060	1968-10-05	1968-10-17	1
58010	3440	4152936	2014-09-20	2014-10-04	1
20549	1236	4218389	1961-04-30	1961-05-28	1
67566	3996	260139	2016-10-05	2016-10-12	1
57644	3422	372328	1988-09-24	1990-09-24	1
67800	4010	260139	1985-01-24	1985-02-07	1
18844	1134	4112343	1973-05-22	1973-06-03	1
14322	847	28060	2008-05-22	2008-05-29	1
17312	1039	4296204	2002-09-01	2002-09-15	1
16828	1000	4310024	2006-03-03	2006-03-04	1
20226	1217	260139	2010-11-22	2010-12-06	1
32396	1925	372328	1971-09-22	1973-02-24	1
77386	4590	40481087	1959-09-30	1959-10-14	1
40938	2436	40481087	1966-01-03	1966-01-17	1
23280	1390	40481087	1974-12-21	1975-01-11	1
43289	2580	40481087	1971-09-04	1971-09-25	1
83369	4960	4155034	1964-10-19	1964-11-02	1
83926	4990	40481087	1964-01-22	1964-01-29	1
78213	4636	40481087	2015-08-01	2015-08-08	1
19384	1162	260139	1921-08-24	1921-09-07	1
40089	2381	78272	1961-06-10	1961-07-08	1
18930	1138	40481087	1987-09-25	1987-10-09	1
79891	4739	260139	1930-10-13	1930-10-27	1
46564	2774	4112343	1945-02-25	1945-03-05	1
17394	1046	4112343	2016-07-29	2016-08-07	1
56617	3362	40481087	1962-10-28	1962-11-04	1
1448	84	4112343	1984-06-19	1984-06-27	1
16375	970	28060	1965-01-11	1965-01-20	1
56998	3386	28060	1982-06-04	1982-06-12	1
45503	2708	260139	1993-02-07	1993-02-14	1
32561	1935	260139	2004-05-04	2004-05-18	1
79341	4704	80180	2010-07-25	2010-07-26	1
58011	3440	4296205	1959-01-10	1959-01-24	1
20550	1236	4278672	2005-12-08	2006-01-07	1
67567	3996	317576	2003-02-25	2003-02-26	1
57645	3422	40481087	1980-10-04	1980-10-18	1
67801	4010	439777	1999-04-30	1999-05-01	1
18845	1134	4112343	2001-07-10	2001-07-22	1
14323	847	80180	2011-06-11	2011-06-12	1
17313	1039	4296204	2008-08-14	2008-09-18	1
16829	1000	81151	1995-02-08	1995-03-08	1
20227	1217	260139	2015-05-28	2015-06-11	1
32397	1925	4134304	1960-05-01	1960-05-31	1
77387	4590	40481087	1989-04-12	1989-04-26	1
40939	2436	40481087	1984-03-21	1984-03-28	1
23281	1390	40481087	1992-03-22	1992-03-29	1
43290	2580	30753	1993-11-22	1993-11-23	1
83370	4960	4294548	1965-02-03	1965-02-24	1
83927	4990	40481087	1975-05-02	1975-05-23	1
78214	4636	80180	1986-10-26	1986-10-27	1
19385	1162	260139	1933-09-13	1933-09-20	1
40090	2381	80180	1973-04-28	1973-04-29	1
18931	1138	40481087	1992-05-24	1992-06-07	1
79892	4739	260139	1938-11-26	1938-12-10	1
46565	2774	4230399	2011-03-27	2011-04-26	1
17395	1046	4142905	1975-03-19	1975-06-17	1
56618	3362	40481087	1975-04-29	1975-05-13	1
1449	84	40486433	1979-03-20	1979-03-21	1
16376	970	260139	1967-11-28	1967-12-12	1
56999	3386	4027663	1996-11-24	1996-11-25	1
45504	2708	372328	1954-09-05	1954-11-15	1
32562	1935	4059173	1978-03-22	1978-04-21	1
79342	4704	260139	1972-01-17	1972-01-24	1
58012	3440	40481087	1949-02-01	1949-02-15	1
20551	1236	40479422	1939-10-16	1939-11-22	1
67568	3996	4112343	1974-07-16	1974-07-28	1
57646	3422	40481087	1995-06-04	1995-06-18	1
67802	4010	40481087	2009-10-10	2009-10-24	1
18846	1134	4237458	1999-06-16	1999-07-16	1
14324	847	4109685	1973-08-29	1973-09-19	1
17314	1039	40481087	1982-09-30	1982-10-07	1
16830	1000	380378	2017-01-29	2017-01-30	1
20228	1217	372328	1973-09-09	1973-12-21	1
32398	1925	4278672	1949-07-28	1949-08-27	1
77388	4590	260139	1980-11-13	1980-11-20	1
42678	2546	80180	2011-09-10	2011-09-11	1
23282	1390	40481087	2006-03-20	2006-04-03	1
43291	2580	260139	1963-07-15	1963-07-29	1
83371	4960	40481087	1934-08-07	1934-08-14	1
83928	4990	40481087	1980-08-31	1980-09-14	1
78215	4636	260139	1972-07-01	1972-07-08	1
19386	1162	260139	1994-07-27	1994-08-10	1
40091	2381	81151	1948-05-14	1948-06-18	1
18932	1138	260139	1993-12-20	1994-01-03	1
79893	4739	260139	1943-12-27	1944-01-10	1
46566	2774	40481087	2015-05-28	2015-06-11	1
17396	1046	40481087	1989-09-29	1989-10-20	1
56619	3362	40481087	2001-06-01	2001-06-08	1
3112	184	28060	1966-10-28	1966-11-05	1
16377	970	4112343	2001-12-26	2002-01-02	1
57000	3386	4113008	1988-12-31	1989-01-21	1
45505	2708	4146173	2002-03-30	2002-04-29	1
32563	1935	40481087	1973-10-20	1973-11-03	1
79343	4704	372328	1970-04-15	1970-11-28	1
58013	3440	40481087	1958-08-04	1958-08-18	1
20552	1236	40480160	2012-01-06	2012-03-06	1
67569	3996	4112343	1995-09-19	1995-09-27	1
57647	3422	40481087	2006-12-16	2006-12-30	1
70706	4200	81151	2009-04-15	2009-05-13	1
18847	1134	4283893	1993-05-25	1993-10-05	1
14325	847	4112343	1993-05-29	1993-06-08	1
17315	1039	40481087	1991-06-01	1991-06-15	1
16831	1000	4029498	2017-01-29	2017-01-30	1
20229	1217	40481087	1987-02-19	1987-03-12	1
32399	1925	40481087	1962-04-03	1962-04-17	1
77389	4590	378001	2008-10-27	2008-12-26	1
42679	2546	195588	1993-03-23	1993-05-03	1
23283	1390	30753	2006-07-13	2006-07-14	1
43292	2580	260139	2015-08-21	2015-08-28	1
83372	4960	28060	1919-05-13	1919-05-26	1
83929	4990	40481087	1986-09-17	1986-10-01	1
78216	4636	4112343	1956-05-28	1956-06-04	1
19387	1162	378419	1999-02-13	1999-02-14	1
40092	2381	260139	1997-11-25	1997-12-09	1
18933	1138	372328	1982-08-18	1983-01-06	1
79894	4739	372328	1927-09-11	1928-08-11	1
46567	2774	40481087	2018-06-02	2018-06-23	1
17397	1046	28060	1984-08-25	1984-09-04	1
56620	3362	40481087	2013-07-10	2013-07-17	1
3113	184	80502	2016-08-01	2016-08-02	1
16378	970	4218389	1956-02-18	1956-03-17	1
57001	3386	4310024	2005-05-21	2005-05-22	1
45506	2708	40481087	1972-12-08	1972-12-22	1
32564	1935	40481087	1997-11-04	1997-11-11	1
79344	4704	4112343	1983-10-27	1983-11-08	1
58014	3440	40481087	1965-11-09	1965-11-16	1
20553	1236	40481087	1932-02-15	1932-03-07	1
67570	3996	40481087	1976-11-28	1976-12-05	1
60827	3604	28060	1984-08-05	1984-08-18	1
70707	4200	260139	1974-09-18	1974-10-02	1
18848	1134	40481087	1947-05-25	1947-06-01	1
14326	847	4237458	1967-02-02	1967-04-03	1
17316	1039	40481087	2012-01-30	2012-02-13	1
16832	1000	4059173	1972-08-23	1972-11-21	1
28930	1716	81151	1963-04-14	1963-05-12	1
32400	1925	40481087	1965-03-01	1965-03-22	1
77390	4590	4278672	2002-09-29	2002-12-28	1
42680	2546	372328	1976-08-19	1976-09-02	1
23284	1390	192671	2006-12-19	2006-12-20	1
43293	2580	4112343	1992-05-19	1992-05-29	1
83373	4960	260139	1930-09-03	1930-09-17	1
83930	4990	40481087	1995-09-15	1995-09-29	1
78217	4636	4112343	2003-07-14	2003-07-21	1
19388	1162	40481087	1950-12-09	1950-12-30	1
40093	2381	372328	1939-05-02	1939-08-23	1
18934	1138	372328	1985-06-24	1986-01-16	1
79895	4739	378001	1951-11-18	1951-12-18	1
46568	2774	80180	1977-09-29	1977-09-30	1
17398	1046	4112343	2002-12-31	2003-01-08	1
56621	3362	260139	2004-11-08	2004-11-22	1
3114	184	260139	1964-01-25	1964-02-08	1
16379	970	40481087	1952-12-14	1952-12-21	1
57002	3386	40481087	1979-01-16	1979-01-23	1
45507	2708	40481087	1995-10-20	1995-10-27	1
34345	2041	78272	1993-04-12	1993-05-03	1
79345	4704	4112343	1990-06-07	1990-06-15	1
58015	3440	40481087	1987-03-14	1987-03-28	1
20554	1236	40481087	1936-01-25	1936-02-15	1
67571	3996	28060	1979-07-03	1979-07-11	1
60828	3604	260139	1993-02-17	1993-03-03	1
70708	4200	4294548	2018-03-19	2018-04-09	1
19228	1154	257012	2008-02-04	2008-02-05	1
14327	847	40481087	1975-09-09	1975-09-30	1
17317	1039	40481087	2012-12-14	2012-12-21	1
16833	1000	4113008	2011-06-12	2011-06-26	1
28931	1716	81151	1966-01-26	1966-03-02	1
32401	1925	40481087	1980-04-03	1980-04-10	1
77391	4590	4310024	1994-05-03	1994-05-04	1
42681	2546	372328	1976-12-31	1977-03-04	1
23285	1390	40481087	1977-05-26	1977-06-02	1
43294	2580	4112343	2000-08-04	2000-08-13	1
83374	4960	260139	1948-01-02	1948-01-16	1
83931	4990	80180	2002-08-02	2002-08-03	1
78218	4636	80502	2006-08-15	2006-08-16	1
19389	1162	40481087	1968-05-27	1968-06-10	1
40094	2381	378001	1952-01-29	1952-03-29	1
18935	1138	4280726	1985-02-05	1999-02-04	1
79896	4739	4109685	1954-09-03	1954-09-17	1
46569	2774	260139	1952-01-18	1952-01-25	1
17399	1046	4152936	1992-02-28	1992-03-20	1
56622	3362	378001	2011-12-03	2012-02-01	1
3115	184	260139	2019-03-06	2019-03-13	1
16380	970	40481087	2000-03-03	2000-03-10	1
57003	3386	28060	2012-04-06	2012-04-17	1
45508	2708	40481087	2005-07-15	2005-08-05	1
34346	2041	78272	1994-04-28	1994-06-02	1
79346	4704	4113008	1998-04-13	1998-04-27	1
58016	3440	40481087	1998-11-02	1998-11-16	1
20555	1236	40481087	1938-09-08	1938-09-29	1
67572	3996	80180	2003-02-27	2003-02-28	1
60829	3604	260139	2000-05-06	2000-05-20	1
70709	4200	40481087	2011-04-13	2011-04-20	1
19229	1154	4084167	1971-03-05	1971-03-05	1
14328	847	40481087	1998-03-03	1998-03-24	1
17318	1039	372328	1965-04-28	1966-03-05	1
16834	1000	4266809	2008-01-22	2008-01-23	1
28932	1716	372328	1950-06-21	1950-10-06	1
39115	2326	28060	2011-08-25	2011-09-02	1
77392	4590	40481087	1966-02-06	1966-02-20	1
42682	2546	260139	1990-05-19	1990-06-02	1
23286	1390	40481087	2000-05-21	2000-06-11	1
43295	2580	4285898	1994-05-21	1994-05-22	1
83375	4960	372328	1909-06-16	1909-07-24	1
83932	4990	378001	2004-08-11	2004-09-10	1
78219	4636	4112343	2000-11-14	2000-11-23	1
19390	1162	40481087	1982-03-10	1982-03-24	1
40095	2381	4112343	1938-08-08	1938-08-18	1
18936	1138	40481087	1998-10-10	1998-10-31	1
79897	4739	4113008	1913-09-07	1913-09-21	1
46570	2774	260139	1968-03-03	1968-03-17	1
17400	1046	4294548	1995-11-14	1996-03-12	1
61458	3636	260139	1993-11-17	1993-12-01	1
3116	184	4294548	2006-05-05	2006-07-14	1
16381	970	40481087	2006-12-11	2006-12-25	1
57004	3386	4142905	1984-12-31	1985-03-01	1
45509	2708	40481087	2012-04-02	2012-04-09	1
34347	2041	260139	1974-06-13	1974-06-27	1
79347	4704	40481087	1970-09-28	1970-10-05	1
58017	3440	40481087	2017-09-05	2017-09-12	1
20556	1236	40481087	1998-04-01	1998-04-08	1
67573	3996	4027663	1996-11-05	1996-11-06	1
60830	3604	260139	1996-03-24	1996-03-31	1
70710	4200	260139	1991-05-07	1991-05-14	1
19230	1154	4112343	1981-02-14	1981-02-23	1
14329	847	192671	2011-06-26	2011-06-27	1
17319	1039	4112343	2003-08-05	2003-08-16	1
16835	1000	4296204	1973-12-16	1973-12-30	1
28933	1716	372328	1951-10-31	1952-10-17	1
39116	2326	81151	1990-09-16	1990-10-07	1
77393	4590	40481087	1990-12-24	1990-12-31	1
42683	2546	260139	1992-09-01	1992-09-08	1
23287	1390	80180	2006-10-11	2006-10-12	1
43296	2580	28060	1995-02-16	1995-03-01	1
83376	4960	4112343	1965-07-09	1965-07-21	1
83933	4990	4112343	2001-10-15	2001-10-27	1
78220	4636	4112343	2007-12-30	2008-01-09	1
19391	1162	40481087	1995-05-10	1995-05-17	1
40096	2381	4112343	1951-09-26	1951-10-03	1
18937	1138	28060	1981-07-26	1981-08-08	1
79898	4739	4152936	1934-10-01	1934-10-22	1
46571	2774	372328	1941-04-29	1941-05-30	1
17401	1046	40481087	1984-10-19	1984-11-02	1
61459	3636	260139	2002-07-22	2002-08-05	1
3117	184	40481087	1953-05-28	1953-06-11	1
16382	970	28060	1960-07-25	1960-08-03	1
57005	3386	4218389	1976-05-14	1976-06-18	1
45510	2708	260139	1959-07-12	1959-07-26	1
34348	2041	317576	1998-09-01	1998-09-02	1
79348	4704	372328	1968-02-06	1968-05-25	1
58018	3440	28060	1980-12-12	1980-12-22	1
20557	1236	260139	1979-01-23	1979-01-30	1
67574	3996	4146173	1990-05-10	1990-07-09	1
60831	3604	372328	1987-08-08	1987-10-09	1
70711	4200	260139	2016-12-24	2016-12-31	1
19231	1154	4112343	2011-11-29	2011-12-06	1
14330	847	260139	2007-11-30	2007-12-14	1
17320	1039	4112343	2012-06-03	2012-06-12	1
16836	1000	40481087	1980-10-04	1980-10-18	1
28934	1716	4112343	1977-05-28	1977-06-05	1
39117	2326	260139	1988-10-14	1988-10-28	1
77394	4590	4027663	1986-11-06	1986-11-07	1
42684	2546	260139	2014-12-13	2014-12-20	1
23288	1390	4059173	2013-12-21	2014-03-21	1
43297	2580	260139	1991-10-03	1991-10-10	1
83377	4960	4113008	1991-02-14	1991-03-07	1
83934	4990	4116491	1981-01-19	1981-02-23	1
78221	4636	4156265	1948-05-08	1948-05-22	1
21225	1276	260139	2017-04-13	2017-04-27	1
40097	2381	4112343	1980-09-17	1980-09-27	1
18938	1138	81151	1984-02-09	1984-03-15	1
79899	4739	4329847	1993-06-26	1993-06-27	1
46572	2774	4296204	2007-03-20	2007-04-17	1
17402	1046	40481087	1987-09-25	1987-10-02	1
61460	3636	260139	2006-05-03	2006-05-17	1
3118	184	40481087	1955-12-05	1955-12-26	1
16383	970	28060	1997-03-10	1997-03-21	1
57006	3386	40481087	2006-07-18	2006-07-25	1
45511	2708	260139	1968-03-05	1968-03-12	1
34349	2041	372328	1964-04-25	1964-06-02	1
79349	4704	378001	1967-10-09	1967-12-08	1
58019	3440	4112343	1999-04-24	1999-05-03	1
20558	1236	4156265	1938-11-06	1938-11-20	1
67575	3996	4278672	2010-08-23	2010-09-22	1
60832	3604	4112343	1992-04-24	1992-05-02	1
70712	4200	40481087	1976-08-03	1976-08-17	1
19232	1154	4134304	2002-05-21	2002-08-19	1
14331	847	321042	1970-07-24	1970-07-25	1
17321	1039	40481087	1973-03-20	1973-04-03	1
16837	1000	40481087	1990-07-03	1990-07-24	1
28935	1716	4112343	2013-01-09	2013-01-20	1
39118	2326	4152936	1966-11-16	1966-11-30	1
77395	4590	4112343	1988-06-27	1988-07-07	1
42685	2546	4146173	1990-07-28	1990-08-27	1
23289	1390	40481087	1976-12-07	1976-12-21	1
43298	2580	260139	2005-05-13	2005-05-20	1
83378	4960	4152936	1935-01-01	1935-01-15	1
83935	4990	4116491	1986-04-17	1986-06-02	1
78222	4636	40481087	1954-08-10	1954-08-24	1
21226	1276	4155034	1992-02-03	1992-02-17	1
40098	2381	4156265	2003-08-16	2003-08-30	1
18939	1138	440086	1994-01-27	1998-02-26	1
79900	4739	40481087	1912-08-20	1912-09-03	1
46573	2774	40481087	1950-06-15	1950-06-29	1
17403	1046	40481087	1991-06-19	1991-07-03	1
61461	3636	260139	2010-02-10	2010-02-17	1
3119	184	40481087	1965-11-11	1965-11-18	1
16384	970	81151	2002-12-21	2003-01-18	1
57007	3386	40481087	2018-07-01	2018-07-08	1
45512	2708	260139	1983-08-03	1983-08-10	1
34350	2041	372328	1969-11-01	1970-02-10	1
79350	4704	4112343	1970-11-09	1970-11-17	1
58020	3440	4278672	1959-12-20	1960-02-18	1
20559	1236	4237458	2012-01-06	2012-03-06	1
67576	3996	4294548	2005-01-15	2005-03-26	1
60833	3604	4112343	1998-02-16	1998-02-24	1
70713	4200	40481087	2010-08-26	2010-09-09	1
19233	1154	40481087	1971-04-10	1971-05-01	1
14332	847	4027663	1999-03-31	1999-04-01	1
17322	1039	257012	2006-01-15	2006-01-16	1
16838	1000	40481087	2001-01-03	2001-01-24	1
28936	1716	4280726	1948-10-26	1963-10-25	1
39119	2326	40481087	1983-06-25	1983-07-02	1
77396	4590	4156265	1962-06-10	1962-07-01	1
42686	2546	40481087	1982-01-26	1982-02-09	1
23290	1390	40481087	2011-07-10	2011-07-31	1
43299	2580	260139	2012-06-14	2012-06-28	1
83379	4960	4237458	1989-12-21	1990-03-21	1
83936	4990	4237458	1974-01-21	1974-04-21	1
78223	4636	40481087	1980-10-23	1980-11-13	1
21227	1276	40481087	2000-08-23	2000-09-06	1
40099	2381	40481087	1948-04-22	1948-05-13	1
18940	1138	4112343	1994-04-04	1994-04-16	1
79901	4739	40481087	1976-04-19	1976-05-03	1
47347	2821	257012	1925-08-25	1925-08-26	1
17404	1046	195588	2009-04-29	2009-06-18	1
61462	3636	4112343	1998-02-25	1998-03-08	1
3120	184	40481087	1980-12-05	1980-12-26	1
16385	970	4112343	1972-12-11	1972-12-24	1
57008	3386	80180	2007-09-08	2007-09-09	1
45513	2708	4112343	1996-11-09	1996-11-20	1
34351	2041	378001	2017-07-31	2017-08-30	1
79351	4704	4112343	1982-04-21	1982-05-02	1
58021	3440	40481087	1944-04-03	1944-04-24	1
20560	1236	4296204	2012-12-31	2013-01-14	1
67577	3996	4112343	2001-06-01	2001-06-08	1
60834	3604	40481087	1987-11-23	1987-11-30	1
70714	4200	28060	1979-06-26	1979-07-04	1
19234	1154	40481087	1984-04-26	1984-05-17	1
14333	847	40481087	1987-10-04	1987-10-18	1
17323	1039	40479422	1996-09-27	1996-12-03	1
18050	1086	28060	1970-02-17	1970-03-01	1
28937	1716	40481087	1971-03-22	1971-04-05	1
39120	2326	375671	1952-02-03	1952-03-04	1
77397	4590	40481087	1964-01-27	1964-02-10	1
42687	2546	40481087	2006-07-30	2006-08-20	1
23595	1410	0	2010-03-25	2010-03-26	1
43300	2580	321042	1979-05-07	1979-05-08	1
83380	4960	40481087	1931-03-28	1931-04-18	1
83937	4990	40481087	1988-09-25	1988-10-16	1
78224	4636	40481087	1994-06-12	1994-06-19	1
21228	1276	80180	1995-08-21	1995-08-22	1
40100	2381	0	2013-01-30	2013-01-31	1
18941	1138	4112343	2004-05-07	2004-05-15	1
79902	4739	40481087	1980-04-19	1980-05-10	1
47348	2821	260139	1936-11-05	1936-11-19	1
17405	1046	40481087	1978-01-10	1978-01-17	1
61463	3636	81893	2009-10-28	2009-10-29	1
3121	184	80180	1987-01-03	1987-01-04	1
16386	970	4112343	1976-09-05	1976-09-16	1
57009	3386	372328	1970-10-22	1970-11-05	1
45514	2708	81151	1994-11-18	1994-12-16	1
34352	2041	4112343	1974-05-31	1974-06-13	1
79352	4704	40481087	1991-11-09	1991-11-16	1
58022	3440	40481087	1986-09-02	1986-09-09	1
20561	1236	4296205	1932-01-28	1932-02-11	1
67578	3996	4112343	2012-02-15	2012-02-25	1
60835	3604	40481087	1990-03-12	1990-03-19	1
70715	4200	80180	2006-09-23	2006-09-24	1
19235	1154	40481087	2010-06-28	2010-07-19	1
14334	847	0	1970-07-24	1970-07-25	1
17324	1039	40481087	1980-02-01	1980-02-08	1
18051	1086	260139	1973-04-02	1973-04-16	1
28938	1716	40481087	1980-01-29	1980-02-19	1
39121	2326	4027663	1985-01-30	1985-01-31	1
77398	4590	40481087	1986-08-12	1986-08-19	1
42688	2546	28060	1981-04-27	1981-05-09	1
23596	1410	30753	2003-05-31	2003-06-01	1
43301	2580	372328	1961-04-24	1961-05-15	1
83381	4960	40481087	1958-09-27	1958-10-18	1
83938	4990	40481087	2012-12-24	2012-12-31	1
81631	4848	80180	1996-08-24	1996-08-25	1
21229	1276	372328	1961-10-13	1962-02-16	1
40101	2381	81151	1987-07-13	1987-08-10	1
18942	1138	40481087	2011-12-10	2011-12-24	1
79903	4739	0	1993-06-26	1993-06-27	1
47349	2821	260139	1946-04-02	1946-04-09	1
17406	1046	40481087	2019-04-17	2019-04-24	1
61464	3636	257012	1994-04-10	1994-04-11	1
3122	184	260139	1983-12-02	1983-12-09	1
16387	970	4112343	1982-11-18	1982-11-26	1
57010	3386	372328	1974-11-14	1975-11-23	1
45515	2708	260139	1965-09-29	1965-10-06	1
34353	2041	40481087	1984-06-15	1984-06-29	1
79994	4748	378001	1954-10-14	1954-12-13	1
58023	3440	40481087	2004-07-22	2004-08-05	1
20562	1236	40481087	1989-09-16	1989-09-23	1
67579	3996	4266809	2003-02-27	2003-02-28	1
60836	3604	372328	1984-10-31	1985-01-11	1
70716	4200	372328	1971-01-05	1971-05-26	1
19236	1154	40481087	2017-11-17	2017-12-01	1
14335	847	28060	2008-10-27	2008-11-05	1
17325	1039	80180	2003-03-29	2003-03-30	1
18052	1086	260139	1993-12-01	1993-12-15	1
28939	1716	257012	1979-06-09	1979-06-10	1
39122	2326	4152936	1985-02-23	1985-03-16	1
77399	4590	80180	1995-11-24	1995-11-25	1
42689	2546	260139	1989-09-12	1989-09-19	1
23597	1410	80180	2004-05-25	2004-05-26	1
43302	2580	4027663	1983-06-03	1983-06-04	1
84159	5004	192671	2012-09-13	2012-09-14	1
83939	4990	40481087	2018-02-12	2018-02-19	1
81632	4848	260139	1960-01-08	1960-01-15	1
21230	1276	4029498	1968-03-05	1968-03-06	1
40102	2381	260139	2003-10-29	2003-11-12	1
18943	1138	40481087	2015-02-12	2015-02-26	1
79904	4739	257012	1980-10-23	1980-10-24	1
47350	2821	260139	1999-03-26	1999-04-02	1
17407	1046	195588	2010-06-18	2010-07-27	1
61465	3636	378001	1979-12-05	1980-01-04	1
3123	184	4112343	1972-10-07	1972-10-16	1
16388	970	4112343	1985-09-14	1985-09-23	1
57011	3386	4112343	1973-04-10	1973-04-21	1
45516	2708	4048695	1986-05-20	1986-07-21	1
34354	2041	40481087	1998-08-20	1998-09-10	1
79995	4748	4112343	1963-12-28	1964-01-06	1
60101	3562	28060	1997-02-04	1997-02-11	1
20563	1236	40481087	2017-02-06	2017-02-20	1
67580	3996	4283893	1973-06-25	1973-07-09	1
60837	3604	372328	1987-03-02	1987-04-10	1
70717	4200	372328	1973-06-14	1974-06-05	1
19237	1154	260139	2014-07-19	2014-08-02	1
14336	847	4155034	1985-03-20	1985-04-10	1
17326	1039	260139	1995-06-15	1995-06-29	1
18053	1086	372328	1967-06-01	1967-11-17	1
28940	1716	260139	1990-01-30	1990-02-06	1
39123	2326	40481087	1978-05-23	1978-06-13	1
77400	4590	81893	1994-11-29	1994-11-30	1
42690	2546	440086	1987-03-25	1993-04-02	1
23598	1410	260139	1991-12-05	1991-12-19	1
43303	2580	40481087	1974-12-13	1974-12-20	1
84160	5004	260139	1984-07-30	1984-08-13	1
83940	4990	260139	1975-04-09	1975-04-23	1
81633	4848	260139	2007-08-14	2007-08-28	1
21231	1276	4112343	1963-10-17	1963-10-28	1
40103	2381	4112343	1941-12-01	1941-12-10	1
18944	1138	40481087	2019-03-12	2019-04-02	1
79905	4739	260139	1919-09-15	1919-09-29	1
47351	2821	260139	2003-11-13	2003-11-20	1
17408	1046	372328	1972-08-01	1972-10-15	1
61466	3636	4027663	2003-07-07	2003-07-08	1
3124	184	40481087	2004-12-19	2005-01-02	1
16389	970	4112343	2010-05-23	2010-05-31	1
57012	3386	4113008	2019-02-04	2019-02-18	1
45517	2708	4218389	2000-05-18	2000-06-08	1
34355	2041	40481087	2009-02-23	2009-03-16	1
79996	4748	4156265	1982-10-22	1982-11-05	1
60102	3562	4156265	2005-11-06	2005-11-27	1
20564	1236	28060	1933-12-04	1933-12-16	1
70540	4190	4113008	1987-01-13	1987-02-03	1
60838	3604	4112343	2014-12-09	2014-12-22	1
70718	4200	378001	1982-06-06	1982-08-05	1
19238	1154	372328	1971-10-31	1971-11-14	1
14337	847	40481087	1970-07-25	1970-08-15	1
17327	1039	372328	1964-09-24	1965-02-27	1
18054	1086	4112343	2004-04-05	2004-04-18	1
28941	1716	378001	1959-03-06	1959-04-05	1
39124	2326	0	2011-01-24	2011-01-25	1
77401	4590	4112343	1990-05-02	1990-05-13	1
42691	2546	4059173	1987-07-14	1987-08-13	1
23599	1410	321042	2010-03-25	2010-03-26	1
43304	2580	40481087	1987-04-23	1987-05-07	1
84161	5004	378001	2008-10-21	2008-12-20	1
83941	4990	260139	2002-07-31	2002-08-07	1
81634	4848	378001	1956-08-24	1956-10-23	1
21232	1276	40481087	1966-09-23	1966-10-14	1
40104	2381	4112343	1968-12-26	1969-01-03	1
18945	1138	4112343	1994-12-15	1994-12-25	1
79906	4739	260139	1962-08-08	1962-08-15	1
47352	2821	378001	1991-06-29	1991-07-29	1
17409	1046	4112343	1972-11-03	1972-11-11	1
61467	3636	4112343	1978-11-11	1978-11-24	1
3125	184	40481087	2015-12-02	2015-12-09	1
16390	970	40481087	1966-03-18	1966-04-01	1
57013	3386	4283893	2004-11-20	2004-12-04	1
45518	2708	4237458	1973-01-28	1973-04-28	1
34356	2041	40481087	2010-04-05	2010-04-12	1
79997	4748	40479768	1997-07-19	1997-08-25	1
60103	3562	4310024	2012-07-06	2012-07-07	1
20565	1236	78272	2017-07-22	2017-08-05	1
70541	4190	4294548	1995-10-18	1995-11-01	1
60839	3604	4294548	1988-03-06	1988-05-15	1
70719	4200	40481087	1970-10-15	1970-10-29	1
19239	1154	4109685	2009-11-01	2009-11-22	1
14338	847	40481087	1975-07-28	1975-08-04	1
17328	1039	4237458	1978-10-02	1978-12-01	1
18055	1086	40481087	2008-09-06	2008-09-13	1
28942	1716	4112343	1963-02-17	1963-02-26	1
39125	2326	260139	1963-01-07	1963-01-14	1
77402	4590	4283893	2007-07-14	2007-08-04	1
42692	2546	4155034	1976-01-22	1976-02-12	1
23600	1410	4027663	1996-03-07	1996-03-08	1
45380	2702	28060	2014-08-17	2014-08-30	1
84162	5004	4278672	2015-07-17	2015-09-15	1
83942	4990	260139	2008-06-06	2008-06-13	1
81635	4848	4112343	2012-01-27	2012-02-08	1
21233	1276	40481087	1984-11-16	1984-11-30	1
40105	2381	40481087	1954-03-05	1954-03-12	1
18946	1138	4134304	2018-03-17	2018-06-15	1
79907	4739	372328	1910-11-22	1911-02-04	1
47353	2821	4027663	1952-05-24	1952-05-25	1
17410	1046	4218389	1996-03-29	1996-04-26	1
61468	3636	4218389	1993-04-25	1993-05-23	1
3126	184	28060	1950-02-25	1950-03-10	1
16391	970	4112343	1953-08-03	1953-08-12	1
57014	3386	40481087	1981-08-18	1981-09-01	1
45519	2708	40481087	2009-11-21	2009-12-05	1
34357	2041	80809	2008-02-14	2011-05-29	1
79998	4748	260139	1959-03-23	1959-04-06	1
60104	3562	40481087	1983-04-04	1983-04-18	1
20566	1236	372328	1922-08-02	1923-01-04	1
70542	4190	257012	2018-11-01	2018-11-02	1
60840	3604	80180	2019-05-16	2019-05-17	1
70720	4200	40481087	2005-01-26	2005-02-02	1
19240	1154	4116491	1995-08-31	1995-10-19	1
14339	847	40481087	1996-03-13	1996-04-03	1
17329	1039	40481087	1982-06-06	1982-06-27	1
18056	1086	30753	2003-11-24	2003-11-25	1
28943	1716	4112343	1969-11-22	1969-12-02	1
39126	2326	260139	1986-01-14	1986-01-28	1
77403	4590	40481087	1958-11-07	1958-11-28	1
42693	2546	4230399	1985-05-25	1985-06-24	1
23601	1410	4152936	2008-02-22	2008-03-07	1
45381	2702	260139	1992-11-09	1992-11-23	1
84163	5004	40481087	1999-09-16	1999-09-23	1
83943	4990	4112343	1980-01-22	1980-02-04	1
81636	4848	4113008	1980-08-16	1980-09-06	1
21234	1276	40481087	1992-03-30	1992-04-20	1
40106	2381	40481087	1974-08-01	1974-08-15	1
18947	1138	40481087	1987-05-01	1987-05-22	1
79908	4739	372328	1911-09-02	1911-11-04	1
47354	2821	4112343	1933-05-24	1933-05-31	1
17411	1046	40481087	2006-02-24	2006-03-17	1
61469	3636	4294548	1999-04-15	1999-08-12	1
3127	184	257012	2006-05-26	2006-05-27	1
16392	970	4112343	1988-11-10	1988-11-21	1
57015	3386	40481087	1984-01-28	1984-02-18	1
45520	2708	81151	2010-02-16	2010-03-02	1
34358	2041	4112343	1992-02-13	1992-02-26	1
79999	4748	260139	1970-08-16	1970-08-30	1
60105	3562	80180	2014-03-28	2014-03-29	1
20567	1236	372328	1925-08-21	1926-07-15	1
70543	4190	4280726	1976-08-05	1976-08-06	1
60841	3604	81151	1990-01-03	1990-01-31	1
70721	4200	4112343	1995-08-13	1995-08-21	1
19241	1154	40481087	1976-02-16	1976-03-01	1
15708	931	260139	1975-06-09	1975-06-23	1
17330	1039	40481087	2010-10-26	2010-11-16	1
18057	1086	4109685	1975-09-17	1975-10-01	1
28944	1716	4294548	1978-10-30	1978-11-20	1
39127	2326	260139	1999-04-05	1999-04-19	1
77404	4590	40481087	1962-01-07	1962-01-28	1
42694	2546	40481087	2002-12-28	2003-01-11	1
23602	1410	4296205	1970-12-24	1971-01-07	1
45382	2702	375671	1964-01-25	1964-03-25	1
84164	5004	133834	1977-11-10	1995-05-23	1
83944	4990	4112343	2006-09-03	2006-09-10	1
81637	4848	4142905	1966-10-01	1966-12-30	1
21235	1276	40481087	1997-12-25	1998-01-01	1
40107	2381	40481087	1993-09-15	1993-09-29	1
18948	1138	40481087	2011-10-29	2011-11-05	1
79909	4739	4084167	1922-02-25	1922-02-25	1
47355	2821	4283893	1980-03-13	1980-04-10	1
18603	1120	28060	1972-07-30	1972-08-06	1
61470	3636	40481087	1986-05-08	1986-05-29	1
3128	184	4112343	2012-08-19	2012-08-28	1
16393	970	4112343	2016-05-01	2016-05-09	1
57016	3386	78272	1974-08-02	1974-08-23	1
45521	2708	4112343	1990-05-02	1990-05-13	1
34359	2041	40481087	2010-12-13	2010-12-27	1
80000	4748	260139	1995-12-28	1996-01-11	1
60106	3562	4278672	1974-07-21	1974-08-20	1
20568	1236	4112343	1966-11-06	1966-11-15	1
70544	4190	40481087	2019-04-25	2019-05-02	1
60842	3604	4112343	1985-06-18	1985-06-29	1
70722	4200	40481087	2007-01-29	2007-02-05	1
19242	1154	40481087	1988-08-14	1988-08-28	1
15709	931	4112343	2006-04-19	2006-04-28	1
17331	1039	40481087	2011-03-24	2011-03-31	1
18058	1086	4112343	2007-03-07	2007-03-20	1
28945	1716	40481087	2012-12-15	2012-12-29	1
39128	2326	372328	1952-10-30	1953-01-15	1
78754	4670	260139	1962-03-21	1962-03-28	1
43494	2594	28060	1983-07-30	1983-08-08	1
23603	1410	40481087	2014-07-28	2014-08-11	1
45383	2702	4112343	1982-12-11	1982-12-18	1
84165	5004	4112343	1998-02-17	1998-02-26	1
83945	4990	40481087	1964-04-06	1964-04-20	1
81638	4848	40481087	1964-04-09	1964-04-16	1
21236	1276	40481087	1998-02-07	1998-02-28	1
40108	2381	28060	1945-12-16	1945-12-25	1
22408	1339	80180	2006-03-20	2006-03-21	1
79910	4739	4112343	1924-04-12	1924-04-25	1
47356	2821	4294548	1937-01-16	1937-05-01	1
18604	1120	80180	1997-03-07	1997-03-08	1
61471	3636	372328	1973-10-07	1973-12-21	1
3129	184	4152936	2017-10-03	2017-10-17	1
16394	970	4112343	2016-09-07	2016-09-18	1
57017	3386	81151	1978-07-08	1978-08-05	1
45522	2708	4112343	2013-03-30	2013-04-06	1
34360	2041	28060	1964-06-25	1964-07-07	1
80001	4748	4112343	1969-08-11	1969-08-23	1
60107	3562	4283893	1998-06-02	1998-09-01	1
20569	1236	4112343	2015-11-15	2015-11-24	1
70545	4190	0	1977-07-31	1977-08-01	1
60843	3604	4112343	1992-06-03	1992-06-14	1
70723	4200	40481087	2017-04-25	2017-05-16	1
19243	1154	40481087	2002-10-05	2002-10-19	1
15710	931	4113008	1965-05-07	1965-05-21	1
19043	1145	30753	1980-12-06	1980-12-07	1
18059	1086	4218389	2012-03-20	2012-04-24	1
28946	1716	40481087	2018-02-05	2018-02-26	1
39129	2326	40481087	1959-06-04	1959-06-11	1
78755	4670	4112343	1977-03-21	1977-04-03	1
43495	2594	192671	2015-05-22	2015-05-23	1
23604	1410	28060	1976-01-21	1976-01-31	1
45384	2702	4112343	1995-12-21	1995-12-29	1
84166	5004	80180	2012-08-21	2012-08-22	1
83946	4990	260139	1971-03-09	1971-03-23	1
81639	4848	40481087	1989-09-17	1989-10-01	1
21237	1276	0	1968-03-05	1968-03-06	1
40109	2381	28060	2012-11-25	2012-12-06	1
22409	1339	4112343	1968-05-04	1968-05-17	1
79911	4739	4112343	1957-03-16	1957-03-23	1
47357	2821	40481087	1964-09-15	1964-09-22	1
18605	1120	372328	1958-10-28	1959-02-09	1
61472	3636	378001	2014-12-29	2015-02-27	1
3130	184	4156265	1984-07-07	1984-07-28	1
16395	970	4296204	1977-03-27	1977-04-10	1
57018	3386	440086	1976-11-29	1986-12-07	1
45523	2708	4155034	1987-05-17	1987-06-07	1
34361	2041	372328	1965-02-27	1965-05-04	1
80002	4748	4112343	1969-12-23	1970-01-05	1
60108	3562	40481087	1992-09-05	1992-09-26	1
20570	1236	4294548	1922-03-26	1922-04-02	1
70546	4190	440448	1977-07-31	1977-08-01	1
60844	3604	4112343	2005-06-21	2005-06-28	1
70724	4200	40486433	1972-06-25	1987-06-24	1
19244	1154	80180	2006-07-14	2006-07-15	1
15711	931	40481087	1999-05-05	1999-05-19	1
19044	1145	81151	1961-10-22	1961-11-26	1
18060	1086	4285898	2004-04-22	2004-04-23	1
28947	1716	260139	1982-07-02	1982-07-16	1
39130	2326	40481087	1965-03-19	1965-03-26	1
78756	4670	4113008	2018-07-10	2018-07-31	1
43496	2594	260139	2002-04-25	2002-05-09	1
23605	1410	81893	2002-12-01	2002-12-02	1
45385	2702	4112343	2017-10-14	2017-10-23	1
84167	5004	317576	1995-05-02	1995-05-03	1
83947	4990	4112343	1965-05-12	1965-05-25	1
81640	4848	40481087	2007-06-19	2007-07-03	1
21238	1276	260139	1967-03-18	1967-03-25	1
40110	2381	257012	2012-12-11	2012-12-12	1
22410	1339	4310024	2003-07-04	2003-07-05	1
79912	4739	4112343	1984-07-14	1984-07-22	1
47358	2821	40481087	1998-01-10	1998-01-17	1
18606	1120	375671	1984-10-11	1984-12-10	1
61473	3636	440086	1985-07-11	1986-05-08	1
3131	184	40481087	1990-03-15	1990-03-29	1
16396	970	40481087	1975-10-17	1975-11-07	1
57019	3386	4116491	2009-11-21	2009-12-24	1
45524	2708	4283893	2003-11-20	2004-02-12	1
34362	2041	372328	1968-02-18	1969-02-04	1
80003	4748	4134304	1946-08-27	1946-11-25	1
60109	3562	81151	1975-06-16	1975-07-14	1
20571	1236	40479422	1966-12-28	1967-03-05	1
70547	4190	4294548	2018-08-09	2018-12-20	1
64722	3832	134438	2005-01-13	2006-04-08	1
72915	4338	78272	1993-01-28	1993-02-25	1
19245	1154	81151	2005-05-05	2005-05-26	1
15712	931	40481087	2015-01-27	2015-02-03	1
19045	1145	372328	1941-04-21	1941-07-30	1
18061	1086	4310024	2002-07-02	2002-07-03	1
28948	1716	4109685	1971-08-31	1971-09-21	1
39131	2326	28060	1985-01-10	1985-01-17	1
78757	4670	4296204	1993-04-03	1993-05-01	1
43497	2594	260139	2013-05-23	2013-06-06	1
23606	1410	375671	1987-02-12	1987-04-14	1
45386	2702	40481087	1979-12-30	1980-01-13	1
84168	5004	372328	1979-06-26	1979-08-14	1
83948	4990	4112343	1975-02-06	1975-02-16	1
81641	4848	40481087	2016-11-25	2016-12-09	1
21239	1276	260139	1976-09-15	1976-09-29	1
40111	2381	317576	1996-05-15	1996-05-16	1
22411	1339	81151	1977-08-19	1977-09-09	1
79913	4739	4218389	1944-05-02	1944-06-06	1
47359	2821	255848	2010-06-29	2010-06-30	1
18607	1120	4112343	1979-11-01	1979-11-11	1
61474	3636	4112343	2010-04-02	2010-04-15	1
3132	184	28060	1949-04-14	1949-04-27	1
16397	970	80180	1986-12-17	1986-12-18	1
57020	3386	4155034	1986-02-24	1986-03-17	1
45525	2708	4294548	1962-11-27	1963-01-22	1
34363	2041	4112343	1968-04-18	1968-04-30	1
80004	4748	40481087	1957-04-25	1957-05-09	1
53932	3196	260139	1995-10-31	1995-11-07	1
20572	1236	40481087	1948-12-12	1948-12-26	1
70548	4190	40481087	1996-06-05	1996-06-12	1
64723	3832	372328	1991-12-31	1992-08-20	1
72916	4338	4027663	1990-07-04	1990-07-05	1
19246	1154	378001	2004-05-10	2004-07-09	1
15713	931	28060	1965-11-20	1965-11-30	1
19046	1145	4112343	1940-05-02	1940-05-11	1
18062	1086	40481087	1970-05-08	1970-05-22	1
28949	1716	4109685	1978-11-13	1978-12-04	1
39132	2326	28060	2009-07-23	2009-08-04	1
78758	4670	40481087	1958-08-13	1958-09-03	1
43498	2594	4112343	1979-07-29	1979-08-09	1
23607	1410	4112343	1969-02-04	1969-02-13	1
45387	2702	28060	2007-10-10	2007-10-20	1
84169	5004	378001	1991-04-24	1991-06-23	1
83949	4990	4112343	2016-03-21	2016-03-30	1
81642	4848	40481087	2017-06-13	2017-06-20	1
21240	1276	4112343	1962-03-15	1962-03-24	1
40112	2381	378001	1973-11-02	1973-12-02	1
22412	1339	4112343	1994-04-05	1994-04-13	1
79914	4739	40481087	1944-02-27	1944-03-05	1
47360	2821	260139	1960-12-12	1960-12-21	1
18608	1120	4112343	2012-12-04	2012-12-11	1
61475	3636	4278672	1981-12-24	1982-01-23	1
3133	184	4112343	1950-06-12	1950-06-20	1
16398	970	81151	1998-11-07	1998-12-12	1
57021	3386	4155034	1990-11-12	1990-12-03	1
45526	2708	40481087	1980-05-20	1980-06-03	1
34364	2041	78272	1974-09-21	1974-10-19	1
80005	4748	40481087	2017-12-24	2018-01-14	1
53933	3196	260139	2011-09-07	2011-09-14	1
20573	1236	40481087	1957-05-11	1957-05-25	1
70549	4190	40481087	2005-08-12	2005-08-19	1
64724	3832	40481087	1999-03-18	1999-04-08	1
72917	4338	4109685	1973-02-28	1973-03-14	1
19247	1154	4112343	1991-07-03	1991-07-15	1
15714	931	81151	1975-12-30	1976-01-27	1
19047	1145	4112343	1942-05-20	1942-05-27	1
18063	1086	40481087	1989-08-19	1989-09-09	1
28950	1716	4112343	1977-08-05	1977-08-12	1
39133	2326	30753	1992-07-22	1992-07-23	1
78759	4670	40481087	1959-11-06	1959-11-27	1
43499	2594	4112343	1981-05-01	1981-05-09	1
23608	1410	4112343	2005-05-30	2005-06-08	1
45388	2702	260139	1978-01-28	1978-02-04	1
84170	5004	40481087	2014-04-16	2014-05-07	1
83950	4990	40481087	1996-08-31	1996-09-14	1
81643	4848	260139	1975-04-27	1975-05-11	1
21241	1276	4112343	1967-09-10	1967-09-19	1
40113	2381	440086	1943-03-17	1944-10-11	1
22413	1339	4112343	2005-01-17	2005-01-28	1
79915	4739	28060	1948-02-18	1948-02-28	1
47361	2821	260139	1983-11-07	1983-11-14	1
18609	1120	4112343	2013-08-12	2013-08-22	1
61476	3636	4294548	1994-03-27	1994-05-08	1
3134	184	4237458	1991-03-24	1991-05-23	1
16399	970	260139	1966-12-24	1966-12-31	1
57022	3386	40481087	1993-04-06	1993-04-13	1
46770	2786	81151	1987-11-05	1987-12-03	1
34365	2041	80180	2007-07-09	2007-07-10	1
80006	4748	260139	2004-04-04	2004-04-11	1
53934	3196	4112343	1998-05-24	1998-06-03	1
27339	1613	195588	1994-06-10	1994-07-28	1
70550	4190	40481087	2009-09-04	2009-09-18	1
64725	3832	40481087	2016-03-19	2016-03-26	1
72918	4338	4112343	2005-04-28	2005-05-10	1
19248	1154	4112343	2013-08-28	2013-09-08	1
15715	931	257012	1988-10-17	1988-10-18	1
19048	1145	4152936	2006-08-02	2006-08-16	1
18064	1086	81151	2013-03-20	2013-04-03	1
28951	1716	4237458	1993-06-18	1993-09-16	1
39134	2326	78272	2015-10-15	2015-11-12	1
78760	4670	40481087	1973-02-21	1973-02-28	1
43500	2594	4112343	1994-05-13	1994-05-23	1
23609	1410	40481087	2004-08-07	2004-08-28	1
45389	2702	372328	1944-02-16	1944-03-19	1
87451	5210	28060	1982-10-31	1982-11-12	1
86746	5170	81151	1997-08-28	1997-10-02	1
81644	4848	4112343	1997-11-22	1997-12-01	1
21242	1276	4112343	2014-02-16	2014-02-23	1
40114	2381	4109685	1982-11-15	1982-12-06	1
22414	1339	81151	1970-04-23	1970-05-28	1
79916	4739	317576	1982-11-13	1982-11-14	1
47362	2821	372328	1923-07-24	1923-11-06	1
18610	1120	4116491	2016-01-08	2016-02-24	1
61477	3636	4294548	1998-01-23	1998-05-15	1
4825	285	28060	1971-08-20	1971-09-01	1
16400	970	260139	2003-08-16	2003-08-23	1
57023	3386	40481087	1994-06-16	1994-07-07	1
46771	2786	260139	1963-04-29	1963-05-13	1
34366	2041	260139	1972-07-14	1972-07-21	1
80007	4748	4112343	1978-04-25	1978-05-02	1
53935	3196	4218389	2000-11-25	2000-12-30	1
27340	1613	260139	1959-12-17	1959-12-24	1
70551	4190	80180	2013-08-09	2013-08-10	1
64726	3832	81151	1985-11-02	1985-11-16	1
72919	4338	4112343	2011-10-09	2011-10-21	1
19249	1154	4237458	2016-08-17	2016-11-15	1
15716	931	317576	2015-10-16	2015-10-17	1
19049	1145	40481087	1965-01-30	1965-02-20	1
18065	1086	4027663	1994-06-04	1994-06-05	1
28952	1716	4237458	2010-08-25	2010-10-24	1
39135	2326	80180	1994-01-13	1994-01-14	1
78761	4670	40481087	2008-07-12	2008-07-26	1
43501	2594	4285898	2015-01-07	2015-01-08	1
23610	1410	40481087	2006-08-24	2006-08-31	1
45390	2702	372328	1944-09-15	1945-09-23	1
87452	5210	4112343	2013-07-03	2013-07-16	1
86747	5170	4059173	1983-04-02	1983-07-01	1
81645	4848	4113008	1988-10-24	1988-11-07	1
21243	1276	4112343	2015-04-22	2015-04-30	1
40115	2381	4112343	1953-10-23	1953-11-01	1
22415	1339	260139	2001-05-12	2001-05-19	1
79917	4739	4084167	1915-03-31	1915-03-31	1
47363	2821	378419	2001-11-13	2001-11-14	1
18611	1120	4278672	1971-12-19	1972-01-18	1
61478	3636	40481087	2001-06-07	2001-06-14	1
4826	285	78272	1982-09-19	1982-10-10	1
16401	970	372328	1956-11-14	1957-05-19	1
57024	3386	40481087	2005-12-06	2005-12-13	1
46772	2786	260139	2003-11-17	2003-12-01	1
34367	2041	378001	2006-07-29	2006-08-28	1
80008	4748	4112343	1999-02-13	1999-02-23	1
53936	3196	40481087	1987-09-23	1987-09-30	1
27341	1613	260139	1966-03-04	1966-03-11	1
70552	4190	4109685	2000-08-23	2000-09-13	1
64727	3832	81151	2001-01-26	2001-02-09	1
72920	4338	4294548	1979-03-23	1979-05-18	1
19250	1154	4283893	2007-12-31	2008-03-03	1
15717	931	372328	1975-09-17	1976-07-02	1
19050	1145	40481087	1995-04-22	1995-05-06	1
18066	1086	4134304	2015-04-23	2015-06-22	1
28953	1716	4294548	1953-10-08	1953-11-12	1
39136	2326	81151	1991-10-02	1991-11-06	1
78762	4670	40481087	2009-10-27	2009-11-10	1
43502	2594	40481087	1977-12-21	1977-12-28	1
23611	1410	28060	1973-02-24	1973-03-04	1
45391	2702	372328	1946-10-18	1947-10-05	1
87453	5210	4310024	2013-02-24	2013-02-25	1
86748	5170	4112343	2012-05-01	2012-05-10	1
81646	4848	4266809	1996-08-24	1996-08-25	1
21244	1276	4278672	2010-08-11	2010-09-10	1
40116	2381	4112343	1955-06-26	1955-07-05	1
22416	1339	378001	1972-04-17	1972-05-17	1
79918	4739	4112343	1937-09-18	1937-09-25	1
47364	2821	4112343	1921-08-28	1921-09-10	1
18612	1120	4283893	1958-06-07	1958-08-23	1
61731	3650	80502	1997-05-30	1997-05-31	1
4827	285	4296204	2010-06-15	2010-07-20	1
16402	970	4113008	1996-07-29	1996-08-19	1
58727	3488	260139	2000-01-19	2000-01-26	1
46773	2786	378419	2002-10-12	2002-10-13	1
34368	2041	4155034	1966-01-15	1966-02-05	1
80009	4748	40481087	1958-09-10	1958-09-24	1
53937	3196	257012	2002-05-15	2002-05-16	1
27342	1613	372328	1954-10-12	1955-01-22	1
70553	4190	4112343	1989-05-04	1989-05-14	1
64728	3832	260139	1993-08-23	1993-08-30	1
72921	4338	28060	1967-12-01	1967-12-14	1
19251	1154	4283893	1974-08-18	1974-09-15	1
15718	931	4112343	1966-01-01	1966-01-09	1
19051	1145	195588	1956-08-19	1956-09-24	1
18067	1086	4146173	1974-08-23	1974-09-22	1
28954	1716	40479768	2009-06-24	2009-07-31	1
39137	2326	260139	2008-06-03	2008-06-17	1
78763	4670	80180	1989-07-15	1989-07-16	1
43503	2594	40481087	1981-02-16	1981-03-09	1
23612	1410	260139	2016-12-19	2017-01-02	1
45392	2702	375671	1989-05-13	1989-06-12	1
87454	5210	372328	1975-05-20	1975-11-11	1
86749	5170	4296204	1991-03-12	1991-04-02	1
81647	4848	4285898	1996-03-27	1996-03-28	1
21245	1276	40481087	1979-02-01	1979-02-15	1
40117	2381	4112343	2004-01-12	2004-01-24	1
22417	1339	4027663	1994-04-07	1994-04-08	1
79919	4739	4112343	1947-11-05	1947-11-16	1
47365	2821	4155034	1962-01-04	1962-01-18	1
18613	1120	4283893	1968-08-19	1968-11-18	1
61732	3650	260139	1931-03-08	1931-03-15	1
4828	285	4310024	2004-03-12	2004-03-13	1
16403	970	4142905	1953-04-04	1953-07-03	1
58728	3488	4278672	1991-06-29	1991-07-29	1
46774	2786	4112343	2014-10-21	2014-10-31	1
34369	2041	40481087	2009-07-19	2009-08-02	1
80010	4748	40481087	1966-01-21	1966-02-04	1
53938	3196	260139	1978-04-27	1978-05-04	1
27343	1613	4112343	1990-07-30	1990-08-10	1
70554	4190	40481087	1993-09-14	1993-09-21	1
64729	3832	40481087	1996-09-01	1996-09-22	1
72922	4338	260139	2014-04-26	2014-05-10	1
19252	1154	40481087	1986-06-12	1986-06-19	1
15719	931	4152936	1978-10-13	1978-10-27	1
19052	1145	257012	2017-01-05	2017-01-06	1
18068	1086	4146173	1989-09-17	1989-10-17	1
28955	1716	40481087	1960-02-29	1960-03-21	1
39138	2326	260139	2010-02-20	2010-03-06	1
78764	4670	260139	1964-03-18	1964-03-25	1
43504	2594	40481087	1986-06-20	1986-07-11	1
23613	1410	372328	1971-04-23	1972-02-16	1
45393	2702	4112343	1968-07-21	1968-07-30	1
87455	5210	4027663	2004-11-28	2004-11-29	1
86750	5170	40481087	1985-08-31	1985-09-14	1
81648	4848	40481087	1959-04-20	1959-04-27	1
21246	1276	40481087	1979-05-21	1979-06-11	1
40118	2381	4294548	2012-11-20	2012-11-21	1
22418	1339	4134304	1968-12-29	1969-03-29	1
79920	4739	4112343	1960-12-06	1960-12-15	1
47366	2821	4218389	2000-06-11	2000-07-02	1
18614	1120	40481087	1962-04-09	1962-04-16	1
61733	3650	260139	1935-04-03	1935-04-17	1
4829	285	40481087	2012-08-19	2012-08-26	1
16404	970	4146173	1997-09-13	1997-10-13	1
58729	3488	40481087	1954-04-26	1954-05-17	1
46775	2786	4155034	2006-12-23	2007-01-06	1
34370	2041	40481087	2013-04-21	2013-05-05	1
80011	4748	40481087	1988-03-16	1988-04-06	1
53939	3196	372328	1975-08-23	1976-03-23	1
27344	1613	4112343	2006-09-29	2006-10-08	1
70555	4190	40481087	1997-01-14	1997-01-21	1
64730	3832	78272	2006-10-11	2006-11-15	1
72923	4338	372328	2011-12-06	2013-10-19	1
19253	1154	40481087	1995-12-28	1996-01-04	1
15720	931	4156265	1964-05-28	1964-06-11	1
19053	1145	260139	1948-12-30	1949-01-06	1
18069	1086	4283893	2001-06-11	2001-07-09	1
28956	1716	40481087	1967-09-17	1967-10-01	1
39139	2326	372328	2000-12-04	2001-02-08	1
78765	4670	260139	1993-07-03	1993-07-10	1
43505	2594	28060	1975-03-30	1975-04-08	1
23614	1410	378001	1988-03-08	1988-05-08	1
45394	2702	4112343	1974-04-02	1974-04-12	1
87456	5210	4109685	2000-05-29	2000-06-19	1
86751	5170	40481087	2010-01-13	2010-02-03	1
81649	4848	40481087	1989-06-03	1989-06-10	1
21247	1276	40481087	1991-06-06	1991-06-27	1
40119	2381	40481087	1951-01-07	1951-01-14	1
22419	1339	4218389	1999-04-17	1999-05-08	1
79921	4739	4152936	1950-10-03	1950-10-24	1
47367	2821	4278672	1990-05-05	1990-06-04	1
18615	1120	40481087	1994-01-26	1994-02-16	1
61734	3650	260139	2007-01-31	2007-02-14	1
4830	285	372328	2009-08-28	2010-05-31	1
16405	970	4294548	2008-07-25	2008-08-01	1
58730	3488	40481087	1974-01-22	1974-02-05	1
46776	2786	4283893	1924-03-01	1924-04-26	1
35929	2133	40481087	2003-06-23	2003-06-30	1
80012	4748	40481087	2015-07-04	2015-07-18	1
53940	3196	40481087	1974-10-21	1974-11-04	1
27345	1613	40481087	1960-12-16	1961-01-06	1
70556	4190	40481087	2002-08-02	2002-08-23	1
64731	3832	80180	2016-06-27	2016-06-28	1
72924	4338	4112343	1983-08-23	1983-09-05	1
19254	1154	40481087	2019-02-02	2019-02-16	1
15721	931	40481087	2007-03-14	2007-04-04	1
19054	1145	4112343	2002-09-11	2002-09-23	1
18070	1086	40481087	1965-11-13	1965-11-27	1
28957	1716	40481087	1988-08-12	1988-08-26	1
39140	2326	4029498	2011-01-24	2011-01-25	1
78766	4670	4112343	1963-11-21	1963-11-29	1
43506	2594	30753	2014-11-08	2014-11-09	1
23615	1410	4266809	2004-05-25	2004-05-26	1
45395	2702	260139	1986-03-28	1986-04-06	1
87457	5210	4112343	1978-02-12	1978-02-20	1
86752	5170	80180	2004-12-08	2004-12-09	1
81650	4848	28060	1963-11-30	1963-12-10	1
21248	1276	40481087	2016-08-12	2016-08-19	1
40120	2381	40481087	2001-12-25	2002-01-08	1
22420	1339	4285898	2005-10-21	2005-10-22	1
79922	4739	40481087	1940-09-29	1940-10-06	1
47368	2821	4278672	2005-05-07	2005-06-06	1
18616	1120	40481087	1994-09-22	1994-09-29	1
61735	3650	372328	1931-06-04	1932-03-18	1
4831	285	4112343	1996-04-23	1996-05-06	1
16406	970	40481087	1977-08-05	1977-08-26	1
58731	3488	40481087	1981-04-06	1981-04-20	1
46777	2786	40480160	2002-03-19	2002-05-18	1
35930	2133	80180	2003-08-17	2003-08-18	1
80013	4748	80180	1983-10-17	1983-10-18	1
53941	3196	40481087	1979-05-18	1979-06-08	1
27346	1613	260139	1973-03-30	1973-04-13	1
71924	4274	260139	1943-04-22	1943-04-29	1
64732	3832	257012	1993-05-15	1993-05-16	1
72925	4338	4266809	1998-01-18	1998-01-19	1
22808	1361	28060	1955-09-06	1955-09-16	1
15722	931	40481087	2017-12-18	2018-01-08	1
19055	1145	4112343	2004-05-19	2004-05-26	1
18071	1086	40481087	1996-02-10	1996-03-02	1
28958	1716	40481087	1994-12-30	1995-01-13	1
39141	2326	4112343	1966-11-19	1966-11-29	1
78767	4670	4155034	1958-02-08	1958-02-22	1
43507	2594	80180	2015-05-07	2015-05-08	1
23616	1410	4310024	2002-08-04	2002-08-05	1
45396	2702	260139	2000-02-20	2000-02-27	1
87458	5210	4113008	2009-03-04	2009-03-18	1
86753	5170	260139	2015-12-23	2016-01-06	1
81651	4848	195588	2003-09-02	2003-10-06	1
21249	1276	4084167	1958-05-02	1958-05-02	1
43059	2567	260139	1986-10-24	1986-10-31	1
22421	1339	40481087	2013-08-10	2013-08-24	1
79923	4739	40481087	1975-09-24	1975-10-15	1
47369	2821	4283893	1925-04-28	1925-10-13	1
18617	1120	4112343	1966-03-23	1966-04-01	1
61736	3650	4112343	1953-04-16	1953-04-29	1
4832	285	40481087	1984-08-16	1984-09-06	1
16407	970	40481087	2019-03-15	2019-03-29	1
58732	3488	40481087	1994-01-19	1994-01-26	1
46778	2786	40480160	2009-07-24	2009-08-23	1
35931	2133	4112343	2003-11-18	2003-12-01	1
80014	4748	372328	1946-06-28	1946-09-13	1
53942	3196	40481087	1984-04-11	1984-05-02	1
27347	1613	260139	1979-10-13	1979-10-20	1
71925	4274	372328	1926-01-29	1926-11-12	1
64733	3832	4146173	2017-06-25	2017-07-25	1
72926	4338	40481087	1975-11-24	1975-12-01	1
22809	1361	80180	1982-02-10	1982-02-11	1
15723	931	80180	2000-03-25	2000-03-26	1
19056	1145	4112343	2016-05-04	2016-05-13	1
18072	1086	40481087	2014-07-23	2014-08-13	1
28959	1716	80180	1977-11-01	1977-11-02	1
39142	2326	4112343	1983-02-05	1983-02-18	1
78768	4670	260139	1967-02-23	1967-03-02	1
43508	2594	372328	1980-11-08	1981-03-04	1
23617	1410	40481087	1983-10-27	1983-11-16	1
45397	2702	4112343	1989-02-15	1989-02-24	1
87459	5210	40481087	1978-05-12	1978-06-02	1
86754	5170	4112343	1990-03-02	1990-03-12	1
81652	4848	260139	2003-10-25	2003-11-01	1
21250	1276	4142905	2009-07-17	2009-09-15	1
43060	2567	260139	2011-10-21	2011-11-04	1
22422	1339	30753	2004-11-25	2004-11-26	1
79924	4739	40481087	1981-07-15	1981-07-29	1
47370	2821	4283893	1927-09-11	1927-11-13	1
18618	1120	4112343	1989-11-22	1989-12-04	1
61737	3650	4112343	1980-06-13	1980-06-25	1
4833	285	80180	2006-07-30	2006-07-31	1
19301	1158	372328	1983-01-31	1983-07-10	1
58733	3488	260139	1990-04-05	1990-04-12	1
46779	2786	40481087	1927-06-19	1927-07-03	1
35932	2133	40481087	1966-01-10	1966-01-31	1
80015	4748	4059173	1976-03-27	1976-06-25	1
53943	3196	40481087	1993-01-02	1993-01-16	1
27348	1613	372328	1955-03-23	1955-04-23	1
71926	4274	4112343	1983-04-13	1983-04-20	1
72927	4338	40481087	2006-09-01	2006-09-15	1
22810	1361	195588	1973-08-26	1973-10-17	1
15724	931	260139	1965-12-20	1965-12-27	1
19057	1145	4134304	2011-12-18	2012-01-17	1
18073	1086	80180	2004-07-21	2004-07-22	1
28960	1716	260139	1965-03-06	1965-03-13	1
39143	2326	4112343	2008-10-15	2008-10-25	1
78769	4670	4112343	2019-03-28	2019-04-08	1
43509	2594	4112343	1978-09-22	1978-09-30	1
25595	1524	0	1969-01-12	1969-01-13	1
45398	2702	4112343	2003-11-20	2003-11-28	1
87460	5210	40481087	1991-12-08	1991-12-29	1
86755	5170	40479768	1981-02-04	1981-03-13	1
81653	4848	4027663	1986-09-06	1986-09-07	1
21251	1276	4156265	2015-09-14	2015-09-28	1
43061	2567	81151	1984-12-05	1984-12-26	1
22423	1339	260139	2018-07-16	2018-07-23	1
81739	4853	4112343	1965-04-09	1965-04-22	1
47371	2821	4283893	1996-06-13	1996-10-10	1
18619	1120	372328	1961-08-27	1961-11-06	1
61738	3650	4112343	1991-05-30	1991-06-07	1
4834	285	81893	2005-02-05	2005-02-06	1
19302	1158	4112343	1979-10-07	1979-10-20	1
58734	3488	372328	1954-04-20	1954-05-28	1
46780	2786	40481087	1944-03-30	1944-04-20	1
35933	2133	40481087	2016-04-27	2016-05-18	1
80016	4748	4059173	1984-10-25	1984-12-24	1
53944	3196	40481087	1996-12-02	1996-12-16	1
27349	1613	372328	1958-01-07	1958-04-19	1
71927	4274	4112343	1989-09-30	1989-10-08	1
72928	4338	4112343	1989-01-09	1989-01-21	1
22811	1361	260139	2000-06-08	2000-06-22	1
15725	931	372328	1963-01-04	1963-02-22	1
19058	1145	4283893	1944-08-10	1944-09-07	1
18074	1086	260139	1980-03-19	1980-04-02	1
28961	1716	375671	1991-05-30	1991-07-29	1
39144	2326	4113008	2000-07-21	2000-08-04	1
78770	4670	4156265	1994-04-26	1994-05-17	1
43510	2594	4237458	1979-09-03	1979-10-03	1
25596	1524	257012	2015-02-13	2015-02-14	1
45399	2702	4116491	1980-10-03	1980-11-24	1
87461	5210	40481087	1994-06-17	1994-07-08	1
86756	5170	40481087	1988-09-26	1988-10-10	1
81654	4848	4112343	1959-03-13	1959-03-22	1
21252	1276	40481087	1978-02-22	1978-03-01	1
43062	2567	260139	2018-01-10	2018-01-17	1
22424	1339	4142905	1973-05-12	1973-08-10	1
81740	4853	4112343	2008-10-22	2008-11-04	1
47372	2821	4310024	1957-08-21	1957-08-22	1
18620	1120	4278672	1987-10-26	1988-01-24	1
61739	3650	4218389	1992-05-26	1992-06-16	1
4835	285	192671	2006-08-16	2006-08-17	1
19303	1158	40481087	1995-10-13	1995-10-20	1
58735	3488	372328	1955-05-23	1955-07-29	1
46781	2786	40481087	1953-03-11	1953-04-01	1
35934	2133	260139	2009-10-16	2009-10-23	1
80017	4748	4112343	1946-11-27	1946-12-08	1
53945	3196	40481087	2018-08-01	2018-08-22	1
27350	1613	4027663	1981-05-08	1981-05-09	1
71928	4274	4112343	1993-03-24	1993-04-06	1
72929	4338	4285898	1997-06-22	1997-06-23	1
22812	1361	378001	1947-03-26	1947-05-25	1
15726	931	4112343	1993-04-02	1993-04-10	1
19059	1145	4283893	2016-09-29	2017-03-30	1
18075	1086	260139	1988-11-23	1988-11-30	1
28962	1716	4218389	1970-09-07	1970-10-05	1
39145	2326	4266809	1994-01-13	1994-01-14	1
78771	4670	40481087	1961-08-23	1961-08-30	1
43511	2594	4266809	2015-05-07	2015-05-08	1
25597	1524	4112343	2005-10-31	2005-11-10	1
45400	2702	4155034	1947-04-10	1947-04-24	1
87462	5210	40481087	2002-12-29	2003-01-19	1
86757	5170	40481087	2018-04-27	2018-05-11	1
81655	4848	4112343	1986-07-15	1986-07-22	1
21253	1276	40481087	2007-01-11	2007-01-25	1
43063	2567	4112343	2008-01-20	2008-01-31	1
22709	1357	28060	1980-07-29	1980-08-06	1
81741	4853	4113008	1978-04-15	1978-05-06	1
47373	2821	4112343	1950-05-18	1950-05-27	1
18621	1120	40481087	2005-03-13	2005-03-20	1
61740	3650	4285898	1964-01-12	1964-01-13	1
4836	285	260139	1984-11-09	1984-11-23	1
19304	1158	40481087	2005-09-04	2005-09-18	1
58736	3488	372328	1959-10-14	1960-02-05	1
46782	2786	30753	1958-10-16	1958-10-17	1
35935	2133	372328	1970-09-09	1971-05-24	1
80018	4748	4112343	1963-07-14	1963-07-27	1
53946	3196	28060	1989-06-28	1989-07-08	1
27351	1613	4112343	2005-02-25	2005-03-06	1
71929	4274	40481087	1928-02-26	1928-03-11	1
72930	4338	4310024	1996-01-29	1996-01-30	1
22813	1361	4112343	1954-10-02	1954-10-09	1
15727	931	4112343	1995-02-01	1995-02-14	1
19060	1145	4294548	1961-10-03	1961-10-24	1
18076	1086	260139	1990-02-24	1990-03-03	1
28963	1716	4283893	1966-08-23	1966-09-13	1
41074	2444	260139	2011-01-18	2011-01-25	1
78772	4670	40481087	1997-04-02	1997-04-16	1
43512	2594	40481087	1989-04-01	1989-04-08	1
25598	1524	28060	2003-04-19	2003-04-30	1
45401	2702	40481087	1941-12-12	1942-01-02	1
87463	5210	28060	1974-01-26	1974-02-02	1
86758	5170	81151	1971-10-13	1971-11-03	1
81656	4848	4112343	2000-09-17	2000-09-25	1
21254	1276	40481087	2014-01-27	2014-02-17	1
43064	2567	4218389	2018-08-30	2018-10-04	1
22710	1357	81151	1976-01-21	1976-02-25	1
81742	4853	4296204	2002-06-29	2002-07-13	1
47374	2821	40481087	1973-03-01	1973-03-22	1
18622	1120	40481087	2011-01-23	2011-02-13	1
61741	3650	40481087	1932-07-07	1932-07-21	1
4837	285	375671	1979-06-07	1979-08-06	1
19305	1158	80180	2016-12-13	2016-12-14	1
58737	3488	40481087	1973-07-11	1973-07-18	1
46783	2786	80180	1959-10-11	1959-10-12	1
35936	2133	4112343	2014-02-10	2014-02-19	1
80019	4748	4116491	1996-09-23	1996-11-11	1
53947	3196	28060	2011-01-10	2011-01-19	1
27352	1613	4116491	1990-05-06	1990-06-11	1
71930	4274	40481087	1967-08-02	1967-08-16	1
72931	4338	80180	1998-01-18	1998-01-19	1
22814	1361	4112343	1994-12-18	1994-12-25	1
15728	931	4283893	1988-09-12	1988-10-31	1
19061	1145	40481087	1942-05-11	1942-05-18	1
18077	1086	4266809	2004-07-21	2004-07-22	1
28964	1716	4294548	1979-04-28	1979-09-22	1
41075	2444	381316	2013-08-11	2013-08-12	1
78773	4670	40481087	2007-10-30	2007-11-06	1
43513	2594	81893	2014-03-13	2014-03-14	1
25599	1524	378001	2015-08-12	2015-10-11	1
45402	2702	40481087	1952-04-18	1952-04-25	1
87464	5210	80180	2015-06-14	2015-06-15	1
86759	5170	81151	1980-03-20	1980-04-10	1
81657	4848	4112343	2018-04-10	2018-04-18	1
24464	1461	4112343	1968-09-17	1968-09-29	1
43065	2567	260139	1977-11-14	1977-11-21	1
22711	1357	81151	2000-05-19	2000-06-09	1
81743	4853	372328	1968-03-25	1968-04-24	1
47375	2821	40481087	1993-06-09	1993-06-23	1
18623	1120	40481087	2013-02-10	2013-03-03	1
61742	3650	40481087	2015-03-20	2015-03-27	1
4838	285	4027663	1995-05-19	1995-05-20	1
19306	1158	81151	2017-02-14	2017-03-14	1
58738	3488	28060	1993-03-19	1993-03-30	1
46784	2786	80502	1993-08-21	1993-08-22	1
35937	2133	40479422	1996-11-21	1996-12-28	1
80020	4748	4218389	1965-05-19	1965-06-23	1
53948	3196	80180	2008-05-22	2008-05-23	1
27353	1613	40481087	1974-09-01	1974-09-08	1
71931	4274	28060	1930-03-10	1930-03-23	1
72932	4338	4278672	1966-06-05	1966-07-05	1
22815	1361	4112343	1995-11-24	1995-12-04	1
15729	931	40481087	1968-03-13	1968-03-27	1
19062	1145	40481087	1989-03-15	1989-03-29	1
18078	1086	40481087	1969-11-13	1969-12-04	1
28965	1716	40481087	1959-06-22	1959-06-29	1
41076	2444	4112343	1973-12-03	1973-12-13	1
78774	4670	81151	1969-12-21	1970-01-04	1
43514	2594	378001	1984-10-06	1984-11-05	1
25600	1524	440448	1969-01-12	1969-01-13	1
45403	2702	40481087	1978-07-15	1978-07-29	1
87465	5210	81151	2016-12-06	2017-01-03	1
86760	5170	372328	1973-09-02	1973-12-07	1
81658	4848	4218389	1970-12-09	1971-01-06	1
24465	1461	4218389	2007-11-12	2007-12-10	1
43066	2567	4112343	2018-07-09	2018-07-16	1
22712	1357	260139	1978-04-19	1978-04-26	1
81744	4853	4112343	2015-04-04	2015-04-16	1
47376	2821	28060	1927-03-14	1927-03-23	1
18624	1120	4112343	2018-04-29	2018-05-06	1
61743	3650	28060	1961-09-18	1961-09-25	1
6153	363	78272	1965-08-01	1965-09-05	1
19307	1158	192671	2016-12-27	2016-12-28	1
58739	3488	81151	1978-05-12	1978-06-16	1
46785	2786	81151	1956-01-19	1956-02-09	1
37615	2233	28060	1976-01-15	1976-01-27	1
80021	4748	40481087	1954-12-21	1954-12-28	1
53949	3196	260139	1984-12-18	1984-12-25	1
27354	1613	80180	1992-06-19	1992-06-20	1
71932	4274	80180	1958-05-31	1958-06-01	1
72933	4338	40481087	2007-06-20	2007-07-04	1
22816	1361	4155034	1987-06-22	1987-07-06	1
15730	931	40481087	2012-06-15	2012-07-06	1
19063	1145	40481087	1991-06-22	1991-07-06	1
19748	1188	40481087	1992-03-08	1992-03-15	1
28966	1716	40481087	2015-01-25	2015-02-15	1
41077	2444	4112343	1981-01-02	1981-01-09	1
78775	4670	260139	1978-09-12	1978-09-26	1
43515	2594	4027663	2004-02-19	2004-02-20	1
25601	1524	4027663	1992-01-06	1992-01-07	1
45404	2702	80180	1983-04-21	1983-04-22	1
87466	5210	40481087	1993-05-01	1993-05-15	1
86761	5170	440086	1979-12-25	1987-01-02	1
81659	4848	40481087	2008-10-02	2008-10-16	1
24466	1461	40481087	2014-10-22	2014-11-12	1
43067	2567	40481087	2009-05-17	2009-05-31	1
22713	1357	260139	2015-04-22	2015-05-06	1
81745	4853	4285898	1999-02-19	1999-02-20	1
47377	2821	28060	1993-06-25	1993-07-08	1
18625	1120	4116491	2014-11-18	2015-01-08	1
61744	3650	80180	1964-08-09	1964-08-10	1
6154	363	260139	1977-05-01	1977-05-15	1
19308	1158	257012	2010-07-18	2010-07-19	1
58740	3488	261325	1988-07-29	1988-07-30	1
46786	2786	255848	2015-12-03	2015-12-04	1
37616	2233	260139	1986-01-03	1986-01-10	1
80022	4748	40481087	2003-02-24	2003-03-03	1
53950	3196	372328	1972-08-24	1972-09-07	1
27355	1613	260139	1961-01-27	1961-02-03	1
71933	4274	195588	1958-02-05	1958-03-23	1
74657	4439	80180	1995-04-12	1995-04-13	1
22817	1361	4237458	1999-10-31	1999-12-30	1
15731	931	40481087	2015-12-09	2015-12-23	1
19064	1145	81893	1980-04-10	1980-04-11	1
19749	1188	40481087	1995-12-01	1995-12-08	1
30588	1809	260139	1971-03-02	1971-03-09	1
41078	2444	4113008	1965-04-23	1965-05-07	1
78776	4670	260139	1982-03-24	1982-03-31	1
43516	2594	260139	1977-02-17	1977-02-24	1
25602	1524	4112343	1997-06-27	1997-07-05	1
45405	2702	81151	1999-09-18	1999-10-09	1
87467	5210	40481087	2003-11-21	2003-11-28	1
86762	5170	4112343	1979-06-05	1979-06-13	1
81660	4848	40481087	2014-11-23	2014-11-30	1
24467	1461	80180	2008-07-28	2008-07-29	1
43068	2567	80180	2014-02-01	2014-02-02	1
22714	1357	378001	1989-01-17	1989-03-18	1
81746	4853	40481087	1974-04-11	1974-04-25	1
47378	2821	78272	1937-07-02	1937-07-23	1
18626	1120	40481087	1963-10-17	1963-11-07	1
61745	3650	260139	1968-09-18	1968-10-02	1
6155	363	4112343	2002-01-07	2002-01-19	1
19309	1158	4112343	1998-02-15	1998-02-22	1
58741	3488	440086	1965-02-16	1965-03-16	1
46787	2786	372328	1935-06-24	1936-05-23	1
37617	2233	260139	2009-04-10	2009-04-24	1
80023	4748	40481087	2016-08-19	2016-08-26	1
53951	3196	4112343	2006-04-26	2006-05-05	1
27356	1613	260139	1987-10-28	1987-11-04	1
71934	4274	4112343	2009-11-10	2009-11-23	1
74658	4439	260139	1999-02-18	1999-03-04	1
22818	1361	40481087	1973-05-13	1973-05-27	1
15732	931	81151	1974-01-04	1974-02-08	1
19065	1145	260139	2002-06-08	2002-06-15	1
19750	1188	40481087	1998-01-31	1998-02-21	1
30589	1809	372328	1978-12-18	1979-01-24	1
41079	2444	40481087	1959-09-24	1959-10-08	1
78777	4670	372328	1954-05-30	1954-07-07	1
43517	2594	260139	1993-07-03	1993-07-10	1
25603	1524	4112343	2004-05-27	2004-06-04	1
45406	2702	257012	1985-04-27	1985-04-28	1
87468	5210	192671	2015-08-12	2015-08-13	1
86763	5170	4112343	2010-02-24	2010-03-09	1
81661	4848	30753	1995-05-02	1995-05-03	1
24468	1461	372328	1969-07-13	1969-10-02	1
43069	2567	260139	1978-05-01	1978-05-08	1
22715	1357	4112343	2012-07-20	2012-07-30	1
81747	4853	40481087	1985-07-03	1985-07-10	1
47379	2821	80180	1959-02-12	1959-02-13	1
18627	1120	40481087	1989-07-08	1989-07-15	1
61746	3650	381316	2014-07-04	2014-07-05	1
6156	363	4112343	2012-04-29	2012-05-12	1
19310	1158	4112343	2015-02-15	2015-02-27	1
58742	3488	4112343	1966-06-29	1966-07-06	1
46788	2786	4027663	1953-04-20	1953-04-21	1
37618	2233	4113008	2001-09-06	2001-09-20	1
82535	4905	81151	1988-06-08	1988-06-29	1
53952	3196	4112343	2012-09-14	2012-09-26	1
27357	1613	4112343	1960-09-11	1960-09-18	1
71935	4274	4237458	2018-04-10	2018-06-09	1
74659	4439	4112343	1985-12-22	1986-01-04	1
22819	1361	260139	1980-09-30	1980-10-14	1
15733	931	260139	2009-07-26	2009-08-09	1
19066	1145	372328	1938-11-22	1939-02-01	1
19751	1188	80180	2013-03-13	2013-03-14	1
30590	1809	4112343	1970-02-25	1970-03-08	1
41080	2444	40481087	1988-10-08	1988-10-22	1
78778	4670	378001	1977-02-26	1977-04-27	1
43518	2594	372328	1975-07-26	1975-11-05	1
25604	1524	4156265	1973-01-10	1973-01-24	1
45407	2702	372328	1943-05-31	1943-09-19	1
87469	5210	260139	1981-05-20	1981-05-27	1
86764	5170	4155034	1990-03-26	1990-04-16	1
81662	4848	81151	2017-03-10	2017-04-14	1
24469	1461	40481087	1990-06-15	1990-07-06	1
43070	2567	372328	1980-10-27	1981-05-23	1
22716	1357	4134304	1984-06-12	1984-09-10	1
81748	4853	40481087	1992-09-06	1992-09-27	1
47380	2821	81151	1961-01-18	1961-02-08	1
22074	1321	0	1995-06-24	1995-06-25	1
61747	3650	4109685	1986-12-10	1986-12-24	1
6157	363	4237458	2005-07-01	2005-07-31	1
19311	1158	372328	1980-11-27	1981-01-11	1
58743	3488	4155034	1990-06-13	1990-07-04	1
46789	2786	4146173	1954-12-25	1955-02-23	1
37619	2233	40481087	1975-03-08	1975-03-29	1
82536	4905	260139	1982-07-11	1982-07-18	1
53953	3196	4266809	2008-05-22	2008-05-23	1
27358	1613	4266809	1992-06-19	1992-06-20	1
71936	4274	40481087	1983-04-29	1983-05-13	1
74660	4439	40481087	1968-03-04	1968-03-18	1
22820	1361	372328	1952-07-18	1952-09-29	1
15734	931	4112343	1966-08-08	1966-08-18	1
19067	1145	4027663	1972-08-15	1972-08-16	1
19752	1188	4296204	2015-12-28	2016-01-18	1
30591	1809	4112343	1996-05-21	1996-05-30	1
41081	2444	40481087	1991-07-17	1991-07-31	1
78779	4670	4112343	1961-06-24	1961-07-03	1
43519	2594	40481087	1984-07-30	1984-08-20	1
25605	1524	81893	2002-05-28	2002-05-29	1
45408	2702	381316	1998-08-09	1998-08-10	1
87470	5210	4113008	1996-09-26	1996-10-17	1
86765	5170	40481087	1985-04-04	1985-04-25	1
81663	4848	192671	1996-11-19	1996-11-20	1
24470	1461	40481087	2005-09-10	2005-10-01	1
43071	2567	4112343	1978-11-09	1978-11-19	1
22717	1357	28060	2018-01-03	2018-01-12	1
81749	4853	40481087	1995-08-22	1995-09-12	1
47381	2821	372328	1920-07-01	1920-09-07	1
22075	1321	260139	1965-02-01	1965-02-08	1
61748	3650	4112343	1940-11-06	1940-11-18	1
6158	363	4283893	1973-10-06	1974-03-16	1
19312	1158	372328	2005-02-14	2007-06-24	1
58744	3488	4218389	1967-12-08	1968-01-05	1
46790	2786	4266809	1959-10-11	1959-10-12	1
37620	2233	40481087	1978-08-19	1978-09-02	1
82537	4905	4155034	2018-09-20	2018-10-04	1
53954	3196	40481087	1980-02-11	1980-02-25	1
27359	1613	260139	1962-07-02	1962-07-09	1
71937	4274	40481087	1984-03-16	1984-03-23	1
74661	4439	40481087	2005-08-17	2005-09-07	1
22821	1361	372328	1978-10-13	1979-09-10	1
15735	931	40481087	1972-01-13	1972-02-03	1
19068	1145	4112343	1986-12-18	1986-12-30	1
19753	1188	40481087	2015-05-02	2015-05-09	1
30592	1809	4294548	2017-06-04	2017-08-13	1
41082	2444	40481087	2018-05-16	2018-05-23	1
78780	4670	4116491	1990-03-22	1990-05-22	1
43520	2594	40481087	1993-01-26	1993-02-16	1
25606	1524	134438	1996-01-12	1996-11-07	1
45409	2702	4112343	1976-12-29	1977-01-08	1
87471	5210	40481087	1980-03-28	1980-04-11	1
86766	5170	40481087	1993-10-22	1993-11-05	1
81664	4848	4310024	1995-02-01	1995-02-02	1
24471	1461	40481087	2016-09-11	2016-09-25	1
43072	2567	40481087	1993-08-25	1993-09-01	1
22718	1357	40481087	1990-08-23	1990-08-30	1
81750	4853	40481087	1999-06-30	1999-07-07	1
47382	2821	4112343	1947-06-19	1947-07-02	1
22076	1321	372328	1962-10-14	1962-12-06	1
61749	3650	4149245	1984-12-13	1985-01-19	1
6159	363	40481087	1965-06-09	1965-06-16	1
19313	1158	4112343	2003-06-28	2003-07-11	1
58745	3488	40481087	2000-09-18	2000-09-25	1
46791	2786	4278672	2002-03-19	2002-05-18	1
37621	2233	40481087	2015-03-15	2015-03-29	1
82538	4905	40481087	2007-03-26	2007-04-02	1
53955	3196	40481087	1990-10-19	1990-11-09	1
27360	1613	4094814	2006-10-23	2006-10-24	1
71938	4274	260139	1947-05-09	1947-05-23	1
74662	4439	192671	1995-07-01	1995-07-02	1
22822	1361	4112343	1981-08-14	1981-08-25	1
15736	931	40481087	1993-11-12	1993-11-26	1
19069	1145	4112343	2015-05-31	2015-06-08	1
19754	1188	4142905	1983-09-17	1983-11-16	1
30593	1809	4112343	1995-09-09	1995-09-20	1
41083	2444	260139	1985-02-02	1985-02-09	1
78781	4670	40481087	1965-08-17	1965-08-24	1
44405	2644	80180	2014-11-19	2014-11-20	1
25607	1524	4112343	1968-09-21	1968-10-02	1
45410	2702	4294548	1985-03-23	1985-09-14	1
87472	5210	40481087	1984-04-27	1984-05-11	1
86767	5170	4112343	1989-06-23	1989-07-02	1
81665	4848	40481087	1978-05-10	1978-05-31	1
24472	1461	28060	2005-05-20	2005-06-01	1
44862	2673	4048171	1982-02-13	1996-02-12	1
22719	1357	40481087	1999-06-23	1999-06-30	1
81751	4853	40481087	1999-09-11	1999-10-02	1
47383	2821	4112343	1960-08-05	1960-08-15	1
22077	1321	4112343	2003-12-29	2004-01-08	1
61750	3650	4237458	1940-11-04	1940-12-04	1
6160	363	40481087	1980-05-19	1980-06-09	1
19314	1158	4112343	2014-02-11	2014-02-18	1
58746	3488	40481087	2015-02-18	2015-03-04	1
46792	2786	4278672	2009-07-24	2009-08-23	1
37622	2233	78272	1997-06-24	1997-07-29	1
82539	4905	4112343	1989-02-15	1989-02-27	1
53956	3196	260139	1983-09-16	1983-09-23	1
27361	1613	4112343	1981-07-31	1981-08-13	1
71939	4274	260139	1999-07-31	1999-08-14	1
74663	4439	260139	1989-07-08	1989-07-22	1
22823	1361	40481087	2016-07-17	2016-08-07	1
19609	1177	28060	1978-04-23	1978-05-02	1
19070	1145	4230399	1977-02-05	1977-04-06	1
19755	1188	28060	1987-09-29	1987-10-06	1
30594	1809	4113008	2004-12-01	2004-12-15	1
41084	2444	378001	1996-09-21	1996-11-20	1
78966	4680	4059173	1995-01-24	1995-02-23	1
44406	2644	372328	1985-05-28	1986-01-27	1
25608	1524	4112343	1969-01-04	1969-01-13	1
48143	2859	378001	1966-01-10	1966-02-09	1
87473	5210	40481087	2015-03-06	2015-03-20	1
86768	5170	4112343	1991-07-07	1991-07-16	1
81666	4848	40481087	1981-02-22	1981-03-08	1
24473	1461	4156265	1994-09-30	1994-10-21	1
44863	2673	4112343	2010-03-27	2010-04-06	1
22720	1357	260139	1980-03-18	1980-03-25	1
81752	4853	28060	1964-09-27	1964-10-08	1
47384	2821	4112343	1971-03-25	1971-04-05	1
22078	1321	4113008	1987-04-25	1987-05-09	1
61751	3650	28060	1938-05-31	1938-06-10	1
6161	363	81151	1996-01-24	1996-02-28	1
19315	1158	40481087	1991-12-08	1991-12-15	1
58747	3488	80180	1992-05-30	1992-05-31	1
46793	2786	4296205	1957-03-05	1957-04-02	1
37623	2233	260139	1973-01-28	1973-02-04	1
82540	4905	4237458	1978-07-31	1978-08-30	1
53957	3196	260139	2004-01-19	2004-02-02	1
27362	1613	4113008	2002-03-04	2002-03-18	1
71940	4274	4112343	1960-05-16	1960-05-25	1
74664	4439	372328	1955-03-08	1955-05-18	1
22824	1361	81151	1974-07-02	1974-07-30	1
19610	1177	372328	1964-01-24	1964-04-06	1
19071	1145	4294548	1952-12-30	1953-05-12	1
21322	1281	81151	2008-10-31	2008-11-28	1
30595	1809	40481087	2009-11-16	2009-12-07	1
41085	2444	4112343	1960-02-16	1960-02-29	1
78967	4680	4112343	1957-12-13	1957-12-25	1
44407	2644	4112343	1985-01-19	1985-01-29	1
25609	1524	4112343	1993-06-02	1993-06-14	1
48144	2859	4027663	1969-06-08	1969-06-09	1
89042	5302	80180	2010-07-15	2010-07-16	1
86769	5170	4112343	2007-07-23	2007-08-05	1
81667	4848	40481087	1990-09-02	1990-09-09	1
24474	1461	40481087	1967-05-02	1967-05-09	1
44864	2673	4146173	2006-04-06	2006-05-06	1
22721	1357	40481087	1986-08-02	1986-08-09	1
81753	4853	28060	1965-08-22	1965-09-04	1
47385	2821	4112343	1991-12-17	1991-12-29	1
22079	1321	4113008	2016-12-26	2017-01-09	1
61752	3650	28060	2015-07-03	2015-07-14	1
6162	363	260139	1995-10-16	1995-10-23	1
19316	1158	40481087	2014-08-02	2014-08-16	1
58748	3488	257012	1997-08-11	1997-08-12	1
46794	2786	40481087	1962-06-21	1962-07-12	1
37624	2233	260139	2013-06-03	2013-06-10	1
82541	4905	80180	2016-09-04	2016-09-05	1
53958	3196	4027663	1999-03-31	1999-04-01	1
27363	1613	4285898	1992-04-20	1992-04-21	1
71941	4274	4116491	1949-11-19	1950-01-07	1
74665	4439	4266809	1995-04-12	1995-04-13	1
22825	1361	4059173	1955-01-13	1955-03-14	1
19611	1177	4109685	2016-01-03	2016-01-24	1
19072	1145	40481087	1978-10-14	1978-10-21	1
21323	1281	372328	1973-12-02	1974-12-14	1
30596	1809	260139	1996-10-05	1996-10-19	1
41086	2444	4112343	1971-01-05	1971-01-14	1
78968	4680	4112343	1989-02-18	1989-03-03	1
44408	2644	260139	2018-10-28	2018-11-04	1
25610	1524	4112343	1998-06-02	1998-06-13	1
48145	2859	4278672	1969-08-22	1969-11-20	1
89043	5302	372328	1973-05-25	1973-08-10	1
86770	5170	4112343	2014-07-31	2014-08-09	1
82470	4899	28060	1924-11-19	1924-12-01	1
24475	1461	40481087	1998-10-27	1998-11-10	1
44865	2673	4218389	2017-07-07	2017-08-11	1
22722	1357	80180	2014-11-07	2014-11-08	1
81754	4853	80180	1999-04-20	1999-04-21	1
47386	2821	4152936	1977-11-25	1977-12-09	1
22080	1321	4152936	1960-05-27	1960-06-17	1
61753	3650	260139	1955-09-30	1955-10-14	1
6163	363	372328	1968-08-15	1969-06-17	1
19317	1158	81151	1984-03-11	1984-03-25	1
58749	3488	260139	1960-04-20	1960-05-04	1
46795	2786	40481087	1994-01-16	1994-01-23	1
37625	2233	40481087	1984-02-12	1984-02-19	1
82542	4905	4112343	2008-01-21	2008-01-31	1
53959	3196	4283893	2002-04-24	2002-06-19	1
27364	1613	40481087	1985-06-18	1985-07-02	1
71942	4274	4116491	1954-01-06	1954-02-06	1
74666	4439	40481087	1969-01-19	1969-02-02	1
22826	1361	4112343	1979-04-01	1979-04-11	1
19612	1177	4113008	1966-04-13	1966-05-04	1
19073	1145	40481087	1981-12-08	1981-12-15	1
21324	1281	372328	1975-06-12	1976-02-21	1
30597	1809	4112343	1982-12-04	1982-12-14	1
41087	2444	4112343	1976-11-29	1976-12-12	1
78969	4680	4112343	1991-11-19	1991-11-29	1
44409	2644	372328	1980-11-07	1981-01-19	1
25611	1524	4116491	2008-01-02	2008-02-13	1
48146	2859	40481087	1982-07-04	1982-07-25	1
89044	5302	40481087	1979-02-02	1979-02-23	1
86771	5170	40481087	1980-04-04	1980-04-25	1
82471	4899	80180	1964-05-01	1964-05-02	1
24666	1475	260139	2017-12-29	2018-01-05	1
44866	2673	4230399	2009-03-21	2009-05-20	1
22723	1357	260139	1976-10-18	1976-10-25	1
81755	4853	260139	2000-07-20	2000-08-03	1
47387	2821	4266809	1959-02-12	1959-02-13	1
22081	1321	4218389	2007-11-09	2007-12-14	1
61754	3650	260139	1977-01-29	1977-02-12	1
6164	363	372328	2016-10-08	2017-07-25	1
19318	1158	81151	1999-07-05	1999-07-19	1
58750	3488	372328	1957-06-18	1957-07-26	1
46796	2786	81151	2014-12-25	2015-01-15	1
37626	2233	80180	2014-07-10	2014-07-11	1
82543	4905	40481087	1978-08-06	1978-08-20	1
54225	3216	372328	1955-02-17	1955-05-31	1
27365	1613	40481087	2006-03-20	2006-04-03	1
71943	4274	4156265	1997-11-12	1997-11-26	1
74667	4439	40481087	1976-09-01	1976-09-22	1
22827	1361	4112343	1999-04-20	1999-04-29	1
19613	1177	4155034	2000-07-04	2000-07-25	1
19074	1145	40481087	1999-07-18	1999-07-25	1
21325	1281	4112343	2000-07-09	2000-07-20	1
30598	1809	40481087	1999-07-21	1999-08-04	1
41088	2444	40479422	1963-02-26	1963-05-04	1
78970	4680	4155034	1967-07-31	1967-08-14	1
44410	2644	40481087	1988-06-07	1988-06-21	1
25612	1524	4285898	2003-05-23	2003-05-24	1
48147	2859	28060	1951-06-13	1951-06-25	1
89045	5302	40481087	2006-07-27	2006-08-10	1
86772	5170	40481087	1988-04-10	1988-04-24	1
82472	4899	195588	1951-05-25	1951-06-25	1
24667	1475	372328	1935-01-20	1935-02-03	1
44867	2673	4283893	2003-05-28	2004-07-21	1
22724	1357	4134304	1982-05-24	1982-07-23	1
81756	4853	372328	1963-07-03	1963-07-17	1
47388	2821	4283893	2006-04-10	2006-07-31	1
22082	1321	4266809	2002-02-06	2002-02-07	1
61755	3650	260139	1992-02-28	1992-03-13	1
6165	363	4112343	1974-06-19	1974-07-02	1
19319	1158	195588	1999-07-31	1999-09-18	1
58751	3488	4112343	1965-08-22	1965-09-01	1
46797	2786	192671	1959-12-27	1959-12-28	1
37627	2233	81151	1987-01-13	1987-02-17	1
82544	4905	260139	2018-09-01	2018-09-08	1
54226	3216	4112343	2015-05-31	2015-06-08	1
29549	1751	28060	1985-06-20	1985-06-29	1
71944	4274	4237458	1995-08-25	1995-11-23	1
74668	4439	28060	1961-12-19	1961-12-26	1
22828	1361	4112343	2003-08-07	2003-08-14	1
19614	1177	40481087	1974-08-05	1974-08-26	1
19075	1145	28060	1939-04-24	1939-05-06	1
21326	1281	40481087	1997-08-01	1997-08-15	1
30599	1809	28060	1964-07-05	1964-07-13	1
41089	2444	40481087	1963-11-21	1963-12-05	1
78971	4680	4218389	1988-08-07	1988-08-28	1
44411	2644	260139	2006-05-26	2006-06-02	1
25613	1524	4294548	2015-01-23	2015-05-15	1
48148	2859	372328	1943-10-08	1943-11-22	1
89046	5302	260139	1980-04-19	1980-04-26	1
86773	5170	40481087	2003-09-19	2003-10-10	1
82473	4899	372328	1924-07-24	1925-05-12	1
24668	1475	4027663	1968-08-14	1968-08-15	1
44868	2673	40481087	1979-06-06	1979-06-13	1
24126	1441	260139	2008-10-25	2008-11-01	1
81757	4853	372328	1963-12-14	1964-04-15	1
47389	2821	40481087	1920-07-07	1920-07-14	1
22083	1321	4296205	1961-07-12	1961-08-09	1
61756	3650	260139	2000-03-21	2000-03-28	1
6166	363	40481087	1967-04-13	1967-05-04	1
19320	1158	260139	1992-10-27	1992-11-10	1
58752	3488	4283893	1997-07-14	1997-09-29	1
46798	2786	195588	1965-04-17	1965-05-20	1
37628	2233	4116491	1998-01-25	1998-03-10	1
82545	4905	4112343	1977-07-09	1977-07-17	1
54227	3216	4218389	1974-02-12	1974-03-19	1
29550	1751	78272	2013-01-14	2013-02-18	1
71945	4274	40481087	1929-06-11	1929-07-02	1
74669	4439	372328	1955-07-17	1955-08-17	1
22829	1361	40481087	1997-05-27	1997-06-03	1
19615	1177	40481087	2005-12-15	2006-01-05	1
19076	1145	28060	2018-09-01	2018-09-10	1
21327	1281	257012	1991-11-02	1991-11-03	1
30600	1809	80180	1995-01-23	1995-01-24	1
41090	2444	40481087	1980-07-17	1980-07-31	1
78972	4680	4237458	1979-10-24	1980-01-22	1
44412	2644	40481087	2002-02-13	2002-02-20	1
25614	1524	40481087	1972-02-23	1972-03-01	1
48149	2859	372328	1945-01-15	1945-05-21	1
89047	5302	260139	1992-07-23	1992-08-06	1
82474	4899	4112343	1925-02-02	1925-02-12	1
24669	1475	4112343	1997-11-17	1997-11-25	1
44869	2673	257012	2003-08-06	2003-08-07	1
24127	1441	372328	1974-02-19	1974-06-17	1
81758	4853	4027663	1988-05-02	1988-05-03	1
47390	2821	40481087	1928-07-18	1928-07-25	1
22084	1321	40481087	1960-05-04	1960-05-11	1
61757	3650	260139	2002-06-08	2002-06-22	1
6167	363	40481087	1981-11-06	1981-11-27	1
19321	1158	260139	2004-06-14	2004-06-28	1
59712	3542	28060	1938-01-02	1938-01-13	1
46799	2786	257012	1924-03-15	1924-03-16	1
37629	2233	40481087	1972-08-07	1972-08-28	1
82546	4905	4112343	1977-08-18	1977-08-31	1
54228	3216	40481087	1961-10-18	1961-11-01	1
29551	1751	192671	2017-11-13	2017-11-14	1
71946	4274	40481087	1929-09-06	1929-09-20	1
74670	4439	4027663	1984-11-30	1984-12-01	1
22830	1361	40481087	2015-01-09	2015-01-16	1
19616	1177	372328	1968-10-12	1969-04-14	1
19077	1145	80180	1981-12-01	1981-12-02	1
21328	1281	260139	1978-06-22	1978-07-06	1
30601	1809	4112343	1969-05-21	1969-05-30	1
41091	2444	40481087	1988-08-27	1988-09-03	1
78973	4680	4278672	1987-05-15	1987-07-14	1
44413	2644	40481087	2004-03-20	2004-03-27	1
25615	1524	40481087	2008-12-02	2008-12-16	1
48150	2859	4296204	1992-05-23	1992-06-13	1
89048	5302	260139	1996-01-03	1996-01-17	1
82475	4899	4112343	1933-01-03	1933-01-13	1
24670	1475	4155034	1966-04-21	1966-05-05	1
44870	2673	4112343	1979-12-08	1979-12-16	1
24128	1441	378001	1996-07-28	1996-08-27	1
81759	4853	40481087	1999-04-02	1999-04-23	1
47391	2821	40481087	1965-06-26	1965-07-03	1
22085	1321	40481087	1974-01-06	1974-01-27	1
61758	3650	4112343	1971-10-17	1971-10-28	1
6168	363	80180	2001-01-09	2001-01-10	1
19322	1158	4112343	2010-01-07	2010-01-15	1
59713	3542	260139	1948-06-05	1948-06-12	1
46800	2786	372328	2004-02-10	2004-12-11	1
37630	2233	40481087	1973-11-30	1973-12-07	1
82547	4905	4112343	1980-06-19	1980-07-01	1
54229	3216	40481087	1973-12-03	1973-12-10	1
29552	1751	260139	2017-05-24	2017-06-07	1
71947	4274	40481087	1952-05-31	1952-06-14	1
74671	4439	40481087	1992-02-07	1992-02-21	1
22831	1361	40481087	2018-03-09	2018-03-30	1
19617	1177	4112343	1980-07-22	1980-08-01	1
19078	1145	257012	1953-01-13	1961-10-24	1
21329	1281	260139	1997-11-30	1997-12-07	1
30602	1809	4278672	1978-08-20	1978-10-19	1
41092	2444	4112343	1980-03-27	1980-04-06	1
78974	4680	0	1946-04-08	1946-04-09	1
44414	2644	40481087	2009-06-07	2009-06-21	1
25616	1524	80180	2004-02-17	2004-02-18	1
48151	2859	40481087	1949-08-10	1949-08-24	1
89049	5302	4112343	1997-02-17	1997-02-28	1
82476	4899	4112343	1980-03-02	1980-03-12	1
24671	1475	4266809	1981-03-24	1981-03-25	1
44871	2673	40481087	2011-09-27	2011-10-04	1
24129	1441	0	1985-11-11	1985-11-12	1
81760	4853	40481087	2013-10-26	2013-11-16	1
47392	2821	40481087	1973-11-22	1973-12-06	1
22086	1321	40481087	1990-11-02	1990-11-23	1
61759	3650	4218389	1928-05-20	1928-06-10	1
6169	363	257012	1973-12-29	1973-12-30	1
19323	1158	4112343	2010-06-16	2010-06-28	1
59714	3542	372328	1938-03-29	1938-06-11	1
46801	2786	4059173	1926-03-13	1926-05-12	1
39248	2332	260139	1975-12-31	1976-01-07	1
82548	4905	40481087	2001-04-28	2001-05-19	1
54230	3216	40481087	1981-10-04	1981-10-18	1
29553	1751	4218389	1986-05-28	1986-07-02	1
71948	4274	28060	1986-01-06	1986-01-16	1
74672	4439	40481087	2012-06-07	2012-06-14	1
22832	1361	260139	2008-08-28	2008-09-11	1
19618	1177	40481087	1983-05-18	1983-06-08	1
19079	1145	260139	1958-04-20	1958-04-27	1
21330	1281	321042	2012-07-21	2012-07-22	1
30603	1809	40481087	1963-03-20	1963-03-27	1
41093	2444	4112343	1988-04-04	1988-04-17	1
78975	4680	80180	1952-07-25	1952-07-26	1
47874	2845	195588	2009-09-18	2009-11-04	1
25617	1524	260139	1988-02-23	1988-03-01	1
48152	2859	40481087	1950-09-26	1950-10-03	1
89050	5302	4112343	2004-11-19	2004-11-26	1
82477	4899	4112343	1994-05-12	1994-05-19	1
24672	1475	4310024	1977-12-10	1977-12-11	1
44872	2673	80180	2016-08-16	2016-08-17	1
24130	1441	80180	2012-11-26	2012-11-27	1
81761	4853	260139	1995-03-18	1995-04-01	1
50245	2975	80180	1997-09-16	1997-09-17	1
22087	1321	78272	2000-11-10	2000-12-15	1
61760	3650	4283893	1978-04-12	1978-07-12	1
6170	363	4112343	2013-01-09	2013-01-19	1
19324	1158	4283893	2010-06-13	2010-08-15	1
59715	3542	4112343	1990-05-09	1990-05-22	1
46802	2786	4059173	2004-01-08	2004-03-08	1
39249	2332	372328	1958-12-11	1959-04-04	1
82549	4905	40481087	2018-05-13	2018-05-27	1
54231	3216	260139	1959-10-26	1959-11-09	1
29554	1751	40481087	2013-09-17	2013-09-24	1
71949	4274	260139	1938-04-27	1938-05-11	1
74673	4439	4112343	1958-10-22	1958-11-02	1
22833	1361	372328	1942-04-21	1942-08-10	1
19619	1177	40481087	1985-05-29	1985-06-19	1
19080	1145	260139	1964-02-27	1964-03-12	1
21331	1281	4156265	2002-10-12	2002-11-02	1
35128	2087	260139	1923-08-16	1923-08-23	1
41094	2444	40481087	2018-09-28	2018-10-19	1
78976	4680	81151	1976-01-29	1976-02-12	1
47875	2845	260139	1965-08-11	1965-08-25	1
25618	1524	4112343	1968-03-08	1968-03-21	1
48153	2859	40481087	1975-08-22	1975-09-05	1
89051	5302	40481087	1982-10-13	1982-10-27	1
82478	4899	4112343	1996-02-28	1996-03-08	1
24673	1475	40481087	1948-09-13	1948-10-04	1
44873	2673	195588	2014-01-29	2014-03-19	1
24131	1441	378001	1976-11-05	1976-12-05	1
81762	4853	260139	2018-09-06	2018-09-20	1
50246	2975	260139	2004-04-06	2004-04-13	1
22088	1321	80180	2002-02-06	2002-02-07	1
61761	3650	81893	1962-12-18	1962-12-19	1
6171	363	4156265	2000-03-08	2000-03-29	1
19325	1158	40481087	1994-08-07	1994-08-14	1
59716	3542	4113008	1950-11-21	1950-12-12	1
46803	2786	4112343	1978-07-22	1978-07-31	1
39250	2332	4109685	1978-07-29	1978-08-19	1
84697	5043	80180	2008-03-25	2008-03-26	1
54232	3216	378001	1977-01-02	1977-03-03	1
29555	1751	28060	1990-05-07	1990-05-17	1
71950	4274	260139	1973-10-29	1973-11-05	1
74674	4439	4112343	2005-12-22	2005-12-31	1
22834	1361	4112343	1951-11-01	1951-11-13	1
19620	1177	260139	1989-05-13	1989-05-27	1
19081	1145	260139	1968-11-28	1968-12-05	1
21332	1281	4283893	1991-09-07	1992-01-25	1
35129	2087	381316	2011-06-15	2011-06-16	1
41095	2444	80180	1998-11-14	1998-11-15	1
78977	4680	380378	1946-11-11	1946-11-12	1
47876	2845	375671	1972-07-15	1972-08-14	1
25619	1524	4112343	1987-09-08	1987-09-15	1
48154	2859	40481087	1995-02-20	1995-03-06	1
89052	5302	40481087	2003-06-16	2003-06-30	1
82479	4899	40481087	1931-05-28	1931-06-04	1
24674	1475	40481087	2001-10-03	2001-10-24	1
44874	2673	4112343	2001-03-28	2001-04-10	1
24132	1441	4112343	1971-03-11	1971-03-20	1
81763	4853	4112343	1970-07-12	1970-07-25	1
50247	2975	4084167	1975-05-30	1975-05-30	1
22089	1321	81151	1999-11-02	1999-11-16	1
61762	3650	257012	1978-06-14	1978-06-15	1
6172	363	40481087	2008-04-18	2008-05-02	1
19326	1158	40481087	2007-08-17	2007-08-31	1
59717	3542	40481087	1988-05-30	1988-06-06	1
46804	2786	4294548	1972-08-27	1972-10-08	1
39251	2332	4112343	1984-10-22	1984-11-03	1
84698	5043	260139	2004-08-04	2004-08-18	1
54233	3216	4112343	1994-11-20	1994-11-28	1
29556	1751	28060	2011-05-15	2011-05-22	1
71951	4274	260139	1978-11-10	1978-11-17	1
74675	4439	4152936	2002-03-01	2002-03-22	1
22835	1361	4112343	1977-11-23	1977-12-03	1
19621	1177	260139	1998-06-24	1998-07-08	1
19082	1145	260139	1977-03-12	1977-03-26	1
21333	1281	40481087	1970-04-11	1970-05-02	1
35130	2087	4112343	1959-10-19	1959-10-31	1
41096	2444	4218389	2007-12-23	2008-01-20	1
78978	4680	4112343	1924-01-01	1924-01-09	1
47877	2845	4112343	1994-12-16	1994-12-26	1
25620	1524	4112343	1988-03-16	1988-03-29	1
48155	2859	28060	1951-09-27	1951-10-04	1
89053	5302	40481087	2004-10-01	2004-10-08	1
82480	4899	257012	1988-11-13	1988-11-14	1
24675	1475	81151	1984-12-26	1985-01-09	1
44875	2673	40481087	1995-11-21	1995-11-28	1
24133	1441	4112343	1989-10-26	1989-11-02	1
81764	4853	4112343	1994-01-22	1994-02-04	1
50248	2975	4294548	1976-03-01	1976-03-08	1
22090	1321	260139	2015-12-11	2015-12-18	1
61763	3650	260139	2013-12-17	2013-12-31	1
6173	363	4218389	1990-08-25	1990-09-22	1
19327	1158	40481087	2008-09-02	2008-09-16	1
59718	3542	40481087	2016-01-10	2016-01-24	1
46805	2786	4310024	1958-05-19	1958-05-20	1
39252	2332	4112343	2001-12-08	2001-12-15	1
84699	5043	375671	2009-08-14	2009-09-13	1
54234	3216	4112343	2004-10-08	2004-10-21	1
29557	1751	81151	1980-09-12	1980-09-26	1
71952	4274	372328	1986-03-02	1987-01-02	1
74676	4439	4310024	1992-07-26	1992-07-27	1
22836	1361	4112343	1980-10-06	1980-10-16	1
19622	1177	4112343	1978-01-11	1978-01-20	1
19083	1145	260139	2012-08-14	2012-08-28	1
21334	1281	40481087	1975-02-12	1975-03-05	1
35131	2087	4112343	1965-03-07	1965-03-16	1
42814	2554	260139	1973-12-29	1974-01-05	1
78979	4680	4237458	1985-06-24	1985-08-23	1
47878	2845	4266809	1994-10-12	1994-10-13	1
25621	1524	40481087	1973-04-30	1973-05-07	1
48156	2859	28060	2005-04-08	2005-04-17	1
89054	5302	40481087	2017-03-06	2017-03-13	1
82481	4899	372328	1922-10-19	1922-11-02	1
24676	1475	260139	1944-03-05	1944-03-12	1
44876	2673	40481087	2007-07-11	2007-08-01	1
24134	1441	4112343	1993-03-20	1993-03-30	1
81765	4853	4266809	1999-04-20	1999-04-21	1
50249	2975	40481087	1996-09-09	1996-09-30	1
22091	1321	4027663	1990-06-24	1990-06-25	1
61764	3650	260139	2017-03-07	2017-03-21	1
6174	363	40481087	2003-09-12	2003-10-03	1
21015	1264	261325	1986-05-02	1986-05-03	1
59719	3542	80180	1980-08-05	1980-08-06	1
46806	2786	40481087	1985-03-11	1985-03-25	1
39253	2332	4296204	1987-01-04	1987-01-25	1
84700	5043	4112343	1998-06-07	1998-06-16	1
54235	3216	4266809	1995-10-30	1995-10-31	1
29558	1751	260139	1979-04-22	1979-04-29	1
71953	4274	4059173	1943-01-30	1943-03-01	1
76790	4557	28060	1934-10-05	1934-10-16	1
26302	1563	80180	1997-09-01	1997-09-02	1
19623	1177	4112343	2006-03-19	2006-04-01	1
19084	1145	4112343	1940-12-10	1940-12-23	1
21335	1281	40481087	1981-10-04	1981-10-18	1
35132	2087	4112343	2008-10-09	2008-10-17	1
42815	2554	260139	1979-08-09	1979-08-23	1
78980	4680	40481087	1917-10-02	1917-10-16	1
47879	2845	28060	1953-10-30	1953-11-08	1
25622	1524	40481087	1981-04-02	1981-04-23	1
48157	2859	80180	1976-10-24	1976-10-25	1
89055	5302	28060	1989-01-15	1989-01-26	1
82482	4899	4112343	1921-10-27	1921-11-04	1
24677	1475	260139	1963-12-30	1964-01-13	1
44877	2673	260139	2007-10-30	2007-11-13	1
24135	1441	4112343	1997-08-07	1997-08-16	1
81766	4853	40481087	1991-08-14	1991-09-04	1
50250	2975	0	1975-04-06	1975-04-07	1
22092	1321	4112343	2018-05-01	2018-05-14	1
61765	3650	4027663	1956-07-22	1956-07-23	1
9191	545	81151	1974-10-23	1974-11-20	1
21016	1264	4112343	1987-12-28	1988-01-05	1
59720	3542	4112343	1992-09-12	1992-09-25	1
46807	2786	372328	1947-01-26	1948-07-03	1
39254	2332	40481087	1957-07-25	1957-08-15	1
84701	5043	4112343	2007-07-31	2007-08-10	1
54236	3216	4310024	1993-07-12	1993-07-13	1
29559	1751	4112343	1993-06-03	1993-06-16	1
71954	4274	4112343	1964-06-06	1964-06-17	1
76791	4557	80180	1966-04-22	1966-04-23	1
26303	1563	81151	1976-08-21	1976-09-18	1
19624	1177	40481087	1984-09-09	1984-09-23	1
19085	1145	4112343	1967-08-17	1967-08-26	1
21336	1281	40481087	1991-01-18	1991-02-01	1
35133	2087	4218389	1977-09-28	1977-10-19	1
42816	2554	260139	1991-07-22	1991-07-29	1
78981	4680	40481087	1925-02-12	1925-02-19	1
47880	2845	78272	1961-03-24	1961-04-14	1
26506	1572	317576	1968-03-01	1968-03-02	1
48158	2859	260139	1948-06-02	1948-06-09	1
89056	5302	4112343	1976-02-10	1976-02-22	1
82483	4899	40479422	1976-10-15	1976-12-21	1
24678	1475	260139	1993-04-29	1993-05-13	1
44878	2673	4112343	1979-06-30	1979-07-07	1
24136	1441	4112343	2016-12-17	2016-12-29	1
81767	4853	40481087	2009-11-17	2009-12-08	1
50251	2975	81151	2000-01-19	2000-02-16	1
22093	1321	4283893	1973-02-08	1973-04-05	1
61766	3650	4112343	1938-10-10	1938-10-17	1
9192	545	375671	1998-05-18	1998-06-17	1
21017	1264	40481087	1955-06-26	1955-07-10	1
59721	3542	4113008	1993-01-14	1993-02-04	1
46808	2786	4109685	1966-03-16	1966-03-30	1
39255	2332	40481087	1963-04-11	1963-04-25	1
84702	5043	378001	1997-07-18	1997-08-17	1
54237	3216	40481087	2014-03-12	2014-04-02	1
29560	1751	4134304	1987-05-28	1987-06-27	1
71955	4274	4278672	2002-07-03	2002-10-01	1
76792	4557	81893	1964-07-31	1964-08-01	1
26304	1563	260139	1971-06-06	1971-06-20	1
19625	1177	40481087	2008-01-30	2008-02-20	1
19086	1145	4116491	1957-09-24	1957-10-28	1
21337	1281	40481087	1999-01-13	1999-02-03	1
35134	2087	4237458	1927-09-23	1927-10-23	1
42817	2554	4109685	1965-12-27	1966-01-17	1
78982	4680	40481087	1978-12-17	1979-01-07	1
47881	2845	80180	1994-10-12	1994-10-13	1
26507	1572	40481087	1992-12-15	1993-01-05	1
48159	2859	4112343	1948-03-19	1948-03-26	1
89057	5302	40481087	2005-08-09	2005-08-23	1
82484	4899	40481087	1929-08-22	1929-08-29	1
24679	1475	4112343	1934-11-23	1934-12-01	1
44879	2673	40481087	2007-11-05	2007-11-12	1
24137	1441	4294548	1993-09-25	1993-11-06	1
81768	4853	40481087	2012-06-03	2012-06-24	1
50252	2975	4059173	1965-11-18	1965-12-18	1
22094	1321	40481087	1965-02-21	1965-03-14	1
61767	3650	4112343	1961-11-25	1961-12-05	1
9193	545	4056621	2017-12-13	2017-12-14	1
21018	1264	40481087	1957-08-06	1957-08-13	1
59722	3542	4155034	2009-05-18	2009-06-08	1
46809	2786	4112343	1961-08-07	1961-08-18	1
39256	2332	192671	1996-12-04	1996-12-05	1
84703	5043	4112343	2012-08-14	2012-08-22	1
54238	3216	40481087	2017-11-17	2017-12-01	1
29561	1751	40481087	2008-08-24	2008-09-07	1
71956	4274	40481087	1996-10-24	1996-11-14	1
76793	4557	260139	1942-12-20	1943-01-03	1
26305	1563	260139	1998-02-03	1998-02-10	1
19626	1177	40481087	2015-05-01	2015-05-22	1
19087	1145	4278672	2018-08-13	2018-10-12	1
21338	1281	40481087	2018-01-29	2018-02-19	1
35135	2087	4278672	2015-01-03	2015-04-03	1
42818	2554	4112343	1969-03-14	1969-03-21	1
78983	4680	260139	1950-06-21	1950-06-28	1
47882	2845	260139	1961-01-19	1961-02-02	1
26508	1572	40481087	1994-03-08	1994-03-15	1
48160	2859	4112343	1973-08-02	1973-08-12	1
89058	5302	40481087	2007-01-12	2007-01-19	1
82485	4899	40481087	1991-02-05	1991-02-12	1
24680	1475	4112343	1941-04-02	1941-04-11	1
44880	2673	40481087	2015-06-24	2015-07-15	1
24138	1441	4299128	1994-10-02	1994-11-06	1
81769	4853	40481087	2017-02-06	2017-02-20	1
50253	2975	4059173	2011-01-19	2011-04-19	1
22095	1321	40481087	2017-07-24	2017-07-31	1
61768	3650	40481087	1951-10-16	1951-10-23	1
9194	545	4112343	1974-08-27	1974-09-04	1
21019	1264	40481087	1958-09-14	1958-09-28	1
59723	3542	4156265	1957-05-09	1957-05-23	1
46810	2786	4152936	1936-09-16	1936-09-30	1
39257	2332	260139	1960-06-11	1960-06-20	1
84704	5043	4283893	2004-10-22	2004-12-17	1
54239	3216	40481087	2018-10-05	2018-10-12	1
29562	1751	81151	1999-04-23	1999-05-14	1
73513	4375	260139	1936-03-12	1936-03-19	1
76794	4557	260139	1988-07-21	1988-07-28	1
26306	1563	4283893	2018-05-03	2018-05-31	1
19627	1177	80180	2004-01-04	2004-01-05	1
19088	1145	4285898	1981-03-06	1981-03-07	1
21339	1281	0	2012-07-21	2012-07-22	1
35136	2087	4294548	1964-05-02	1964-12-26	1
42819	2554	4294548	1978-08-01	1978-10-31	1
78984	4680	381316	2000-01-01	2000-01-02	1
47883	2845	378001	1964-01-29	1964-03-29	1
26509	1572	40481087	1995-02-15	1995-02-22	1
48161	2859	4112343	1994-12-21	1994-12-31	1
89059	5302	40481087	2017-04-21	2017-04-28	1
82486	4899	28060	1994-07-22	1994-08-04	1
24681	1475	4112343	2002-11-14	2002-11-23	1
48460	2872	80180	1998-10-11	1998-10-12	1
24139	1441	40481087	1994-07-13	1994-07-27	1
85083	5066	81151	1973-01-06	1973-02-03	1
50254	2975	4283893	2001-02-15	2001-04-12	1
22096	1321	4112343	1966-06-26	1966-07-04	1
61769	3650	40481087	1985-06-10	1985-06-17	1
9195	545	4112343	2007-09-21	2007-10-01	1
21020	1264	40481087	1970-05-27	1970-06-17	1
59724	3542	4294548	1994-12-12	1994-12-26	1
46811	2786	4278672	1939-07-17	1939-10-15	1
39258	2332	260139	1997-03-05	1997-03-19	1
84705	5043	260139	2013-09-16	2013-09-30	1
54240	3216	80180	1995-10-30	1995-10-31	1
29563	1751	260139	1988-02-21	1988-02-28	1
73514	4375	260139	1966-07-08	1966-07-22	1
76795	4557	260139	1988-12-26	1989-01-02	1
26307	1563	40481087	2001-08-13	2001-08-20	1
19628	1177	40481087	1989-09-02	1989-09-16	1
19089	1145	40481087	1963-11-18	1963-12-02	1
21340	1281	80180	2005-11-10	2005-11-11	1
35137	2087	40481087	1974-12-12	1975-01-02	1
42820	2554	40480160	2015-12-26	2016-03-25	1
78985	4680	4113008	1957-04-10	1957-04-24	1
47884	2845	4112343	2009-05-13	2009-05-23	1
26510	1572	195588	1987-06-16	1987-08-08	1
48162	2859	4266809	1976-10-24	1976-10-25	1
89168	5312	28060	1961-07-13	1961-07-26	1
82487	4899	78272	1972-10-10	1972-11-14	1
24682	1475	40481087	1997-12-12	1997-12-19	1
48461	2872	4112343	1959-06-07	1959-06-14	1
24140	1441	40481087	2017-01-06	2017-01-13	1
85084	5066	4112343	1982-12-16	1982-12-25	1
50255	2975	260139	1973-09-09	1973-09-16	1
22097	1321	4112343	1973-12-28	1974-01-04	1
65016	3851	81151	1987-08-02	1987-08-16	1
9196	545	4116491	2017-09-27	2017-11-15	1
21021	1264	40481087	1982-05-21	1982-06-04	1
59725	3542	40479768	2002-09-15	2002-11-21	1
46812	2786	40480160	2004-01-08	2004-03-08	1
39259	2332	440086	1968-04-17	1975-04-26	1
84706	5043	4112343	1975-11-06	1975-11-19	1
54241	3216	260139	2002-06-13	2002-06-27	1
29564	1751	4109685	2004-03-18	2004-04-01	1
73515	4375	372328	1929-01-30	1929-06-16	1
76796	4557	372328	1971-03-09	1971-04-25	1
26308	1563	40481087	2015-12-24	2016-01-07	1
19629	1177	40481087	1992-11-07	1992-11-14	1
19090	1145	40481087	1976-05-31	1976-06-21	1
21341	1281	372328	1972-02-22	1972-06-10	1
35138	2087	40481087	2004-10-12	2004-10-19	1
42821	2554	40481087	1967-01-22	1967-02-05	1
78986	4680	4142905	1928-09-25	1928-12-24	1
47885	2845	40481087	2012-02-05	2012-02-26	1
26511	1572	260139	2016-07-27	2016-08-10	1
48163	2859	40481087	1946-08-30	1946-09-20	1
89169	5312	81893	1972-07-19	1972-07-20	1
82488	4899	81151	1998-03-01	1998-03-15	1
24683	1475	260139	2000-01-09	2000-01-23	1
48462	2872	4112343	1960-01-12	1960-01-25	1
24141	1441	133834	1967-07-03	1985-03-18	1
85085	5066	4134304	2015-02-28	2015-03-30	1
50256	2975	260139	1997-08-06	1997-08-20	1
22098	1321	4112343	2013-09-27	2013-10-09	1
65017	3851	255848	2000-09-14	2000-09-15	1
9197	545	4155034	2018-09-30	2018-10-21	1
21022	1264	40481087	1982-12-09	1982-12-30	1
59726	3542	80502	2017-09-23	2017-09-24	1
46813	2786	40481087	1929-12-25	1930-01-08	1
39260	2332	4112343	1960-09-02	1960-09-14	1
84707	5043	4149245	1994-08-26	1994-11-01	1
54242	3216	4294548	1999-05-25	1999-06-29	1
29565	1751	40481087	2017-10-22	2017-10-29	1
73516	4375	440448	1946-07-06	1946-07-07	1
76797	4557	4112343	1934-11-16	1934-11-23	1
26309	1563	28060	2002-10-24	2002-10-31	1
19630	1177	40481087	2012-11-02	2012-11-16	1
19091	1145	40481087	1979-02-24	1979-03-17	1
21342	1281	4112343	2006-10-19	2006-10-30	1
35139	2087	40481087	2007-06-12	2007-06-19	1
42822	2554	40481087	2000-01-11	2000-01-18	1
78987	4680	4155034	1944-12-30	1945-01-13	1
47886	2845	81893	1993-08-18	1993-08-19	1
26512	1572	4112343	1991-04-02	1991-04-11	1
48164	2859	40481087	1964-09-22	1964-09-29	1
89170	5312	260139	2005-04-24	2005-05-01	1
82489	4899	260139	1947-09-10	1947-09-17	1
24684	1475	4059173	1951-02-25	1951-04-26	1
48463	2872	4112343	1974-11-19	1974-11-27	1
24142	1441	260139	1976-10-08	1976-10-22	1
85086	5066	80180	2011-07-16	2011-07-17	1
50257	2975	40481087	1988-10-06	1988-10-13	1
22099	1321	4112343	2014-09-07	2014-09-15	1
65018	3851	260139	1918-12-22	1918-12-29	1
9198	545	4278672	2015-10-16	2016-01-14	1
21023	1264	28060	1997-06-20	1997-06-29	1
59727	3542	4112343	1941-01-28	1941-02-06	1
48318	2865	80180	2003-03-11	2003-03-12	1
39261	2332	40481087	2001-09-08	2001-09-15	1
84708	5043	40481087	1975-03-16	1975-03-23	1
54243	3216	192671	1995-12-22	1995-12-23	1
29566	1751	80180	2017-09-08	2017-09-09	1
73517	4375	4112343	1946-04-14	1946-04-21	1
76798	4557	4112343	1942-09-13	1942-09-25	1
26310	1563	372328	1959-01-09	1959-05-30	1
19631	1177	40481087	2014-09-14	2014-09-28	1
19092	1145	40481087	1998-01-27	1998-02-17	1
21343	1281	440086	1981-12-31	1988-01-09	1
35140	2087	80502	1998-07-01	1998-07-02	1
42823	2554	372328	1944-11-05	1945-07-19	1
78988	4680	4296204	1925-04-23	1925-05-14	1
47887	2845	378001	1994-01-21	1994-03-22	1
26513	1572	4237458	1976-01-24	1976-04-23	1
48165	2859	40481087	1988-05-31	1988-06-21	1
89171	5312	372328	1943-05-22	1943-10-11	1
82490	4899	261325	1967-02-21	1967-02-22	1
24685	1475	4112343	1980-05-03	1980-05-16	1
48464	2872	4156265	1992-07-14	1992-08-04	1
24143	1441	321042	1985-11-11	1985-11-12	1
85087	5066	257012	2018-10-07	2018-10-08	1
50258	2975	40481087	2016-12-24	2017-01-14	1
22100	1321	4283893	2019-05-01	2019-05-02	1
65019	3851	372328	1924-07-08	1925-06-01	1
9199	545	40481087	1972-05-11	1972-05-18	1
21024	1264	80180	1987-12-14	1987-12-15	1
59728	3542	4112343	1964-09-07	1964-09-20	1
48319	2865	372328	2003-03-24	2005-08-08	1
39262	2332	81893	1995-04-06	1995-04-07	1
84709	5043	257012	2004-11-19	2004-11-20	1
54244	3216	260139	1963-10-22	1963-11-05	1
29567	1751	81151	1995-05-16	1995-06-13	1
73518	4375	4112343	1959-01-08	1959-01-15	1
76799	4557	4112343	1997-04-19	1997-05-02	1
26311	1563	4001336	2009-11-24	2009-12-24	1
22425	1340	28060	1958-02-16	1958-02-24	1
19490	1173	260139	1957-08-06	1957-08-20	1
21344	1281	4112343	1989-03-27	1989-04-06	1
35141	2087	257012	1944-03-23	1957-10-13	1
42824	2554	4112343	1963-12-17	1963-12-24	1
78989	4680	40481087	1995-04-14	1995-05-05	1
47888	2845	4112343	1982-03-12	1982-03-21	1
26514	1572	40481087	1970-12-28	1971-01-04	1
48166	2859	40481087	1995-09-10	1995-09-17	1
89172	5312	4027663	1964-10-24	1964-10-25	1
82491	4899	4283893	1988-10-16	1988-12-11	1
24686	1475	4112343	2002-01-06	2002-01-15	1
48465	2872	40481087	1981-07-05	1981-07-12	1
24144	1441	372328	1994-01-03	1996-01-01	1
85088	5066	4156265	1997-08-17	1997-08-31	1
50259	2975	40481087	2018-07-16	2018-07-30	1
22101	1321	40481087	1987-09-20	1987-10-11	1
65020	3851	4112343	1912-10-26	1912-11-05	1
9200	545	40481087	1996-12-15	1997-01-05	1
21025	1264	260139	1974-04-13	1974-04-27	1
59729	3542	4112343	2007-12-08	2007-12-20	1
48320	2865	378001	2003-03-31	2003-04-30	1
39263	2332	4027663	1987-04-13	1987-04-14	1
84710	5043	4112343	1976-09-17	1976-09-28	1
54245	3216	372328	1956-03-26	1956-05-29	1
29568	1751	260139	2008-04-02	2008-04-09	1
73519	4375	4294548	1968-05-14	1968-07-23	1
76800	4557	4113008	1924-05-27	1924-06-17	1
26312	1563	4112343	1958-06-17	1958-06-28	1
22426	1340	81151	1985-09-30	1985-10-28	1
19491	1173	4146173	1969-11-29	1969-12-29	1
21345	1281	4134304	1984-06-18	1984-08-17	1
35142	2087	260139	1941-06-07	1941-06-21	1
42825	2554	4112343	1968-04-05	1968-04-15	1
78990	4680	260139	1933-01-13	1933-01-20	1
47889	2845	4296205	2001-04-14	2001-05-12	1
26515	1572	40481087	1983-08-20	1983-08-27	1
48167	2859	81893	1975-06-02	1975-06-03	1
89173	5312	4112343	1997-07-28	1997-08-06	1
82492	4899	28060	1934-10-07	1934-10-16	1
24687	1475	40481087	1967-02-20	1967-02-27	1
48466	2872	321042	1971-09-07	1971-09-08	1
24145	1441	375671	1991-10-18	1991-12-17	1
85089	5066	40481087	1975-06-02	1975-06-16	1
50260	2975	260139	1984-11-03	1984-11-10	1
22102	1321	40481087	1991-12-26	1992-01-16	1
65021	3851	4112343	1950-10-29	1950-11-10	1
9201	545	378001	1976-10-10	1976-12-09	1
21026	1264	260139	1993-03-31	1993-04-14	1
59730	3542	4278672	2010-07-03	2010-09-01	1
48321	2865	4112343	1993-06-06	1993-06-14	1
39264	2332	4278672	1964-08-11	1964-09-10	1
84711	5043	40481087	2013-05-13	2013-05-20	1
54246	3216	4027663	1985-06-14	1985-06-15	1
29569	1751	40481087	2014-10-24	2014-11-14	1
73520	4375	40481087	1959-08-03	1959-08-24	1
76801	4557	4156265	1968-01-31	1968-02-21	1
26313	1563	4112343	1983-06-28	1983-07-05	1
22427	1340	4112343	1934-02-24	1934-03-06	1
19492	1173	40481087	1960-02-12	1960-03-04	1
21346	1281	40481087	1985-02-04	1985-02-25	1
35143	2087	260139	2004-01-20	2004-02-03	1
42826	2554	4112343	2017-08-16	2017-08-25	1
78991	4680	372328	1910-06-11	1910-06-25	1
47890	2845	40481087	1966-03-31	1966-04-14	1
26516	1572	40481087	2000-05-04	2000-05-25	1
48168	2859	260139	1944-01-08	1944-01-15	1
89174	5312	4296204	2004-12-16	2005-01-06	1
82493	4899	192671	1964-06-13	1964-06-14	1
24688	1475	40481087	1969-12-20	1970-01-03	1
48467	2872	4112343	1968-04-15	1968-04-23	1
24146	1441	4112343	2004-02-14	2004-02-27	1
85090	5066	372328	1971-08-15	1972-03-18	1
50261	2975	260139	2008-05-24	2008-05-31	1
22103	1321	40481087	2016-03-15	2016-03-22	1
65022	3851	40479768	1927-10-04	1927-11-10	1
9202	545	440086	1980-10-06	1989-10-14	1
21027	1264	4112343	1987-08-16	1987-08-27	1
59731	3542	40481087	1944-02-01	1944-02-15	1
48322	2865	4112343	1981-06-29	1981-07-08	1
39265	2332	4278672	1988-11-15	1988-12-15	1
88345	5257	4112343	1988-01-10	1988-01-21	1
54247	3216	4059173	1958-06-01	1958-07-31	1
29570	1751	40481087	2015-11-18	2015-11-25	1
73521	4375	40481087	1985-02-16	1985-02-23	1
76802	4557	4278672	2017-06-24	2017-09-22	1
26314	1563	40481087	2018-03-22	2018-03-29	1
22428	1340	4116491	1948-07-20	1948-08-24	1
19493	1173	40481087	1965-02-11	1965-02-25	1
21347	1281	40481087	1987-11-21	1987-11-28	1
35144	2087	260139	2009-08-06	2009-08-13	1
42827	2554	4230399	2015-12-26	2016-03-25	1
78992	4680	372328	1910-11-22	1911-03-25	1
47891	2845	40481087	1973-07-13	1973-07-20	1
26517	1572	40481087	2008-12-14	2008-12-28	1
48169	2859	260139	1966-01-17	1966-01-31	1
89175	5312	40481087	1980-11-19	1980-12-10	1
82494	4899	378419	1993-10-12	1993-10-13	1
24689	1475	40481087	1989-07-15	1989-07-22	1
48468	2872	4112343	1990-11-05	1990-11-16	1
24147	1441	4112343	2004-12-24	2004-12-31	1
85091	5066	4035415	1983-08-31	1983-10-30	1
50262	2975	260139	2017-09-23	2017-10-07	1
22104	1321	28060	2007-06-22	2007-06-29	1
65023	3851	40481087	1912-05-31	1912-06-07	1
9203	545	4027663	1997-10-02	1997-10-03	1
21028	1264	4146173	1987-01-03	1987-03-04	1
59732	3542	40481087	1961-06-23	1961-07-14	1
48323	2865	4112343	1998-09-20	1998-09-30	1
39266	2332	4294548	1958-05-20	1958-06-10	1
88346	5257	4112343	1998-09-08	1998-09-18	1
54248	3216	4113008	1961-08-14	1961-09-04	1
30419	1796	80180	2017-09-06	2017-09-07	1
73522	4375	40481087	2017-02-26	2017-03-12	1
76803	4557	4283893	2011-03-02	2011-03-30	1
26315	1563	260139	1978-04-04	1978-04-18	1
22429	1340	4294548	1916-11-11	1917-08-11	1
19494	1173	40481087	1965-04-03	1965-04-17	1
23412	1399	260139	1992-07-18	1992-07-25	1
35145	2087	4283893	1957-07-28	1957-10-13	1
42828	2554	4283893	1957-11-09	1958-01-25	1
78993	4680	372328	1913-04-13	1914-03-28	1
47892	2845	40481087	2003-05-23	2003-06-13	1
26518	1572	40481087	2019-02-13	2019-03-06	1
48170	2859	372328	1955-12-25	1956-06-25	1
89176	5312	40481087	1982-08-11	1982-09-01	1
82495	4899	4109685	1945-06-20	1945-07-04	1
24690	1475	80180	1981-03-24	1981-03-25	1
48469	2872	4113008	1954-10-27	1954-11-17	1
24148	1441	4112343	2013-08-18	2013-08-31	1
85092	5066	4112343	2014-09-10	2014-09-23	1
50263	2975	372328	1965-05-22	1965-09-12	1
22105	1321	257012	2019-05-22	2019-05-23	1
65024	3851	40481087	1935-07-04	1935-07-11	1
9204	545	4084167	1974-06-25	1974-06-25	1
21029	1264	40481087	1961-02-21	1961-03-07	1
59733	3542	40481087	1993-02-08	1993-02-15	1
48324	2865	4112343	2004-01-04	2004-01-13	1
39267	2332	28060	1963-09-01	1963-09-10	1
88347	5257	260139	1986-07-03	1986-07-17	1
54249	3216	4113008	1963-07-26	1963-08-09	1
30420	1796	372328	1994-11-11	1995-05-17	1
73523	4375	140673	1982-06-26	1982-06-27	1
76804	4557	40481087	2002-05-31	2002-06-21	1
26316	1563	4112343	1961-05-14	1961-05-22	1
22430	1340	4296204	1980-01-25	1980-02-29	1
19495	1173	40481087	2009-01-23	2009-02-13	1
23413	1399	260139	1988-04-01	1988-04-08	1
35146	2087	40480160	2015-01-03	2015-04-03	1
42829	2554	40481087	1969-05-30	1969-06-13	1
78994	4680	378001	1912-03-02	1912-05-01	1
47893	2845	81151	1955-06-19	1955-07-24	1
26519	1572	80180	1997-12-25	1997-12-26	1
48171	2859	378001	1956-07-01	1956-08-30	1
89177	5312	28060	1995-01-14	1995-01-22	1
82496	4899	4112343	1961-01-30	1961-02-08	1
24691	1475	80502	2005-02-17	2005-02-18	1
48470	2872	4166224	1979-03-07	1979-03-08	1
24149	1441	4237458	2013-11-01	2013-12-31	1
85093	5066	4294548	2018-07-22	2018-10-28	1
50264	2975	440448	1975-04-06	1975-04-07	1
22106	1321	260139	1968-01-26	1968-02-09	1
65025	3851	40481087	1960-11-15	1960-11-29	1
9205	545	4112343	1981-01-31	1981-02-10	1
21030	1264	40481087	1988-06-29	1988-07-13	1
59734	3542	40481087	1990-03-06	1990-03-20	1
48325	2865	4112343	2007-08-28	2007-09-07	1
39268	2332	80180	1996-10-27	1996-10-28	1
88348	5257	4112343	1979-09-09	1979-09-22	1
54250	3216	4285898	1995-04-03	1995-04-04	1
30421	1796	4112343	2014-11-01	2014-11-10	1
73524	4375	260139	1933-06-09	1933-06-16	1
76805	4557	81151	1951-12-21	1952-01-25	1
26317	1563	40481087	2014-03-20	2014-03-27	1
22431	1340	40480160	2014-04-29	2014-05-29	1
19496	1173	40481087	2009-07-20	2009-07-27	1
23414	1399	4112343	1978-08-08	1978-08-17	1
35147	2087	40481087	1926-02-09	1926-03-02	1
42830	2554	28060	1940-02-08	1940-02-20	1
78995	4680	4029498	1946-04-08	1946-04-09	1
47894	2845	260139	2014-02-10	2014-02-24	1
26520	1572	81151	1989-07-12	1989-08-09	1
48172	2859	4112343	1953-05-29	1953-06-05	1
89178	5312	260139	1961-05-04	1961-05-11	1
82497	4899	4112343	1984-12-19	1984-12-28	1
24692	1475	260139	1980-09-11	1980-09-25	1
48471	2872	4329847	1999-08-17	1999-08-18	1
24150	1441	40481087	1973-05-03	1973-05-10	1
85094	5066	81151	1982-08-15	1982-09-05	1
50265	2975	4112343	1973-04-13	1973-04-24	1
22107	1321	260139	1978-05-22	1978-06-05	1
65026	3851	80180	1948-10-08	1948-10-09	1
9206	545	4112343	1983-06-04	1983-06-12	1
21031	1264	260139	2001-02-02	2001-02-09	1
48326	2865	4218389	1970-08-16	1970-09-20	1
39269	2332	260139	1957-05-21	1957-06-04	1
88349	5257	4149245	2014-04-03	2014-06-09	1
54251	3216	40481087	2005-09-04	2005-09-18	1
30422	1796	40481087	1980-04-04	1980-04-11	1
73525	4375	260139	1952-06-13	1952-06-20	1
76806	4557	4027663	1954-04-10	1954-04-11	1
26318	1563	40481087	2016-11-07	2016-11-21	1
22432	1340	40481087	1934-01-08	1934-01-15	1
19497	1173	260139	1989-08-06	1989-08-20	1
23415	1399	4296204	2008-04-21	2008-05-26	1
35148	2087	40481087	1941-09-15	1941-09-22	1
42831	2554	80180	1968-02-09	1968-02-10	1
78996	4680	4112343	1963-09-27	1963-10-05	1
47895	2845	4027663	1983-09-25	1983-09-26	1
26521	1572	260139	1995-07-30	1995-08-06	1
48173	2859	4112343	1972-07-28	1972-08-05	1
89179	5312	4112343	1950-07-16	1950-07-29	1
82498	4899	4113008	1973-09-10	1973-10-01	1
24693	1475	4112343	1959-12-06	1959-12-16	1
48472	2872	40481087	1959-02-04	1959-02-25	1
24151	1441	40481087	1982-11-27	1982-12-18	1
85095	5066	195588	2000-03-30	2000-05-15	1
51330	3049	317576	1980-03-28	1980-03-29	1
22108	1321	260139	2000-10-15	2000-10-29	1
65027	3851	260139	1935-12-31	1936-01-14	1
9207	545	4112343	2007-05-09	2007-05-20	1
21032	1264	440086	1956-12-31	1965-01-08	1
48327	2865	260139	2002-07-31	2002-08-07	1
39270	2332	260139	1994-12-30	1995-01-13	1
88350	5257	40481087	1994-10-12	1994-10-26	1
56923	3381	260139	1986-10-10	1986-10-24	1
30423	1796	40481087	2015-11-28	2015-12-12	1
73526	4375	313217	2006-06-25	2006-06-26	1
76807	4557	4059173	1969-11-12	1970-01-11	1
26319	1563	260139	1976-04-06	1976-04-13	1
22433	1340	40481087	1962-07-17	1962-07-31	1
19498	1173	372328	1947-06-15	1947-08-18	1
23416	1399	40481087	1960-12-05	1960-12-26	1
35149	2087	40481087	1959-04-14	1959-04-21	1
42832	2554	134438	1964-07-26	1965-06-26	1
78997	4680	4112343	1975-11-02	1975-11-15	1
47896	2845	4112343	2015-04-24	2015-05-07	1
26522	1572	4112343	1980-01-20	1980-01-29	1
48174	2859	4112343	2014-02-03	2014-02-11	1
89180	5312	4112343	1951-11-22	1951-12-02	1
82499	4899	4283893	1961-07-04	1961-08-01	1
24694	1475	4146173	1990-06-12	1990-07-12	1
48473	2872	0	1971-09-07	1971-09-08	1
24152	1441	81151	1999-06-13	1999-07-18	1
85096	5066	260139	2011-06-18	2011-07-02	1
51331	3049	4112343	1998-03-31	1998-04-07	1
22109	1321	440448	1995-06-24	1995-06-25	1
65028	3851	317576	1992-07-06	1992-07-07	1
9208	545	4310024	2003-02-28	2003-03-01	1
21033	1264	4112343	1949-12-21	1949-12-30	1
48328	2865	372328	1970-06-17	1970-07-01	1
39271	2332	4278672	1967-08-26	1967-10-25	1
88351	5257	372328	1979-06-08	1979-08-22	1
56924	3381	372328	1973-12-07	1974-05-13	1
30424	1796	81151	2016-05-01	2016-06-05	1
73527	4375	317576	2015-08-16	2015-08-17	1
76808	4557	4112343	1965-03-12	1965-03-24	1
26320	1563	317009	1977-06-25	1977-06-26	1
22434	1340	80180	1952-01-31	1952-02-01	1
19499	1173	372328	1959-05-17	1959-08-24	1
23417	1399	40481087	2003-06-03	2003-06-17	1
35150	2087	40481087	1972-09-24	1972-10-15	1
42833	2554	260139	1933-12-26	1934-01-02	1
78998	4680	4112343	1982-01-14	1982-01-24	1
47897	2845	4116491	2015-11-03	2015-12-05	1
26523	1572	4156265	1972-11-26	1972-12-10	1
48175	2859	4283893	1967-04-25	1967-06-27	1
89181	5312	4112343	1995-12-22	1996-01-03	1
83209	4949	80180	2013-02-28	2013-03-01	1
24695	1475	4152936	1961-01-03	1961-01-17	1
48474	2872	0	1979-03-07	1979-03-08	1
24153	1441	260139	1993-10-10	1993-10-24	1
85097	5066	40481087	1994-06-12	1994-06-19	1
51332	3049	4112343	2006-08-27	2006-09-07	1
22110	1321	40481087	1987-05-25	1987-06-15	1
65029	3851	321042	1985-10-14	1985-10-15	1
9209	545	40481087	2013-11-13	2013-11-27	1
21034	1264	28060	1953-05-16	1953-05-27	1
48329	2865	372328	1971-02-26	1971-07-05	1
39272	2332	4285898	1996-04-30	1996-05-01	1
88352	5257	4218389	1980-01-04	1980-02-01	1
56925	3381	4112343	1979-12-23	1980-01-02	1
30425	1796	4146173	1983-01-13	1983-02-12	1
73528	4375	378001	1949-11-11	1949-12-11	1
76809	4557	4237458	2001-11-15	2002-02-13	1
26321	1563	4112343	2003-07-01	2003-07-14	1
22435	1340	81151	1927-12-17	1928-01-07	1
19500	1173	40481087	1952-11-05	1952-11-12	1
23418	1399	40481087	2006-03-09	2006-03-16	1
35151	2087	40481087	2012-04-02	2012-04-23	1
42834	2554	372328	1936-06-11	1936-07-02	1
78999	4680	40481087	1911-02-14	1911-02-28	1
49893	2951	28060	1962-03-31	1962-04-09	1
26524	1572	4237458	1974-10-31	1974-12-30	1
48176	2859	40481087	1955-02-16	1955-03-09	1
89182	5312	4218389	1987-06-21	1987-07-19	1
83210	4949	4027663	2003-09-14	2003-09-15	1
24696	1475	4296204	2003-02-04	2003-03-11	1
48475	2872	0	1999-08-17	1999-08-18	1
24154	1441	4112343	1974-06-03	1974-06-14	1
86420	5148	378001	1962-12-01	1963-01-30	1
51333	3049	40481087	1993-11-21	1993-11-28	1
24425	1459	30753	1975-02-25	1975-02-26	1
65030	3851	372328	1913-05-20	1914-04-06	2
9210	545	80180	2004-05-23	2004-05-24	1
21035	1264	28060	1953-08-28	1953-09-10	1
48330	2865	372328	1974-01-20	1975-01-20	1
39273	2332	4310024	1995-01-06	1995-01-07	1
88353	5257	4230399	1989-02-13	1989-05-14	1
56926	3381	4112343	2008-08-19	2008-08-30	1
30426	1796	4283893	1995-10-04	1995-11-08	1
73529	4375	4112343	1939-06-11	1939-06-18	1
76810	4557	40480160	2001-11-15	2002-02-13	1
26322	1563	4152936	1975-10-12	1975-10-26	1
22436	1340	257012	1913-02-09	1913-02-10	1
19501	1173	40481087	2006-03-19	2006-04-02	1
23419	1399	80180	1992-10-09	1992-10-10	1
35152	2087	28060	1951-06-21	1951-06-29	1
42835	2554	372328	1939-05-18	1939-07-13	1
79000	4680	40481087	1980-05-09	1980-05-30	1
49894	2951	80180	1999-12-26	1999-12-27	1
26525	1572	40481087	1968-02-26	1968-03-04	1
48177	2859	40481087	1979-06-24	1979-07-15	1
89183	5312	4266809	1973-06-14	1973-06-15	1
83211	4949	4112343	1975-09-09	1975-09-20	1
24697	1475	40481087	1950-12-02	1950-12-09	1
48476	2872	260139	1988-01-03	1988-01-10	1
24155	1441	4218389	2018-11-05	2018-11-26	1
86421	5148	4142905	1970-08-22	1970-11-19	1
51334	3049	0	1986-12-05	1986-12-06	1
24426	1459	372328	1943-02-08	1943-03-18	1
65031	3851	378419	1994-07-18	1994-07-19	1
9211	545	81893	2003-11-25	2003-11-26	1
21036	1264	28060	2004-09-24	2004-10-05	1
48331	2865	4112343	1969-01-25	1969-02-01	1
39274	2332	40481087	1960-04-05	1960-04-19	1
88354	5257	40481087	1995-04-02	1995-04-16	1
56927	3381	40481087	1981-10-20	1981-11-03	1
30427	1796	4310024	2014-10-22	2014-10-23	1
73530	4375	4112343	1957-05-26	1957-06-03	1
76811	4557	40480160	2017-06-24	2017-09-22	1
26323	1563	4294548	1977-06-11	1977-07-16	1
22437	1340	260139	1916-06-04	1916-06-18	1
19502	1173	40481087	2012-08-16	2012-08-30	1
23420	1399	260139	1967-05-25	1967-06-01	1
35153	2087	81151	1974-03-04	1974-03-18	1
42836	2554	4109685	1950-08-27	1950-09-17	1
79001	4680	40481087	1990-03-15	1990-04-05	1
49895	2951	372328	1959-11-11	1960-01-24	1
26526	1572	81151	1987-09-23	1987-10-21	1
48178	2859	40481087	2002-03-20	2002-03-27	1
89184	5312	40481087	1951-11-14	1951-12-05	1
83212	4949	4112343	1980-02-12	1980-02-25	1
24698	1475	40481087	1985-02-20	1985-02-27	1
48477	2872	4155034	1968-04-07	1968-04-21	1
24156	1441	4237458	1974-01-20	1974-02-19	1
86422	5148	257012	1966-02-23	1966-02-24	1
51335	3049	260139	1988-05-22	1988-06-05	1
24427	1459	4027663	1967-12-04	1967-12-05	1
65032	3851	4116491	1931-04-26	1931-06-24	1
9212	545	4266809	2004-05-23	2004-05-24	1
21037	1264	260139	2014-05-03	2014-05-17	1
48332	2865	4112343	2008-12-03	2008-12-15	1
39275	2332	40481087	1963-07-02	1963-07-09	1
88355	5257	80180	2014-03-21	2014-03-22	1
56928	3381	40481087	2008-03-24	2008-04-07	1
30428	1796	40481087	1993-04-02	1993-04-09	1
73531	4375	4166224	1946-07-06	1946-07-07	1
76812	4557	40481087	1936-12-25	1937-01-08	1
26324	1563	40481087	1998-11-28	1998-12-19	1
22438	1340	260139	1955-04-26	1955-05-10	1
19503	1173	78272	1987-06-12	1987-07-03	1
23421	1399	260139	1995-01-12	1995-01-19	1
35154	2087	140673	1968-05-30	1968-05-31	1
42837	2554	40481087	1959-07-25	1959-08-01	1
81936	4865	4112343	1981-12-22	1981-12-31	1
49896	2951	372328	1964-01-03	1964-09-06	1
26527	1572	4112343	1997-06-10	1997-06-18	1
49124	2909	78272	1967-01-15	1967-02-19	1
89185	5312	40481087	1957-11-11	1957-11-18	1
83213	4949	40481087	1997-06-15	1997-06-29	1
24699	1475	40481087	2000-05-14	2000-06-04	1
48478	2872	40481087	1958-02-13	1958-03-06	1
24157	1441	40481087	1990-01-17	1990-02-07	1
86423	5148	4112343	1983-12-23	1984-01-05	1
51336	3049	4112343	2013-10-03	2013-10-12	1
24428	1459	4112343	1948-11-09	1948-11-21	1
65033	3851	40481087	1928-11-16	1928-11-30	1
9213	545	195588	2017-12-13	2018-01-22	1
21038	1264	378001	1952-09-03	1952-10-03	1
48333	2865	40481087	1980-01-02	1980-01-16	1
39276	2332	40481087	1967-10-24	1967-10-31	1
88356	5257	4112343	1996-10-06	1996-10-16	1
56929	3381	260139	1974-08-23	1974-09-06	1
30429	1796	4027663	2009-03-27	2009-03-28	1
73532	4375	28060	1957-12-04	1957-12-12	1
76813	4557	40481087	1947-01-24	1947-02-07	1
26325	1563	40481087	2000-06-19	2000-07-10	1
22439	1340	372328	1912-10-22	1913-01-05	1
19504	1173	80180	1986-01-19	1986-01-20	1
23422	1399	372328	1960-11-26	1961-03-08	1
35155	2087	260139	1936-09-15	1936-09-22	1
42838	2554	80502	2003-12-25	2003-12-26	1
81937	4865	4149245	1977-11-08	1978-01-14	1
49897	2951	4113008	1983-08-07	1983-08-21	1
26528	1572	4112343	2018-09-27	2018-10-08	1
49125	2909	140673	1999-02-12	1999-02-13	1
89186	5312	40481087	1982-10-08	1982-10-15	1
83214	4949	40481087	2002-12-30	2003-01-20	1
24700	1475	40481087	2016-06-16	2016-06-30	1
48479	2872	317576	1968-08-06	1968-08-07	1
25986	1543	378001	1943-09-05	1943-10-05	1
86424	5148	4283893	1966-01-19	1966-04-28	1
51337	3049	4112343	2014-10-10	2014-10-23	1
24429	1459	4112343	1981-10-28	1981-11-05	1
65034	3851	40481087	1951-10-21	1951-10-28	1
9214	545	40481087	2008-08-13	2008-09-03	1
21039	1264	4112343	2017-09-30	2017-10-09	1
48334	2865	40481087	1987-07-17	1987-08-07	1
39277	2332	40481087	2006-07-28	2006-08-18	1
88357	5257	40481087	1987-02-02	1987-02-16	1
56930	3381	260139	2015-07-24	2015-08-07	1
30430	1796	4112343	1986-11-07	1986-11-15	1
73533	4375	257012	1943-06-29	1943-06-30	1
76814	4557	40481087	1996-06-25	1996-07-09	1
30152	1783	28060	2008-12-19	2008-12-26	1
22440	1340	372328	1916-05-19	1916-06-11	1
19505	1173	260139	1994-08-27	1994-09-03	1
23423	1399	4112343	1961-04-26	1961-05-07	1
35156	2087	260139	1938-04-16	1938-04-23	1
42839	2554	192671	1968-03-29	1968-03-30	1
81938	4865	4294548	1998-04-05	1998-04-26	1
49898	2951	4237458	1986-04-07	1986-05-07	1
26529	1572	40481087	1974-11-19	1974-12-10	1
49126	2909	378001	1971-09-26	1971-10-26	1
89187	5312	40481087	1987-06-28	1987-07-19	1
83215	4949	40481087	2009-04-22	2009-04-29	1
30298	1791	260139	2005-07-07	2005-07-14	1
48480	2872	372328	1954-03-31	1954-08-17	1
25987	1543	4329847	1994-10-23	1994-10-24	1
86425	5148	40481087	1984-11-26	1984-12-17	1
51338	3049	4155034	2017-06-20	2017-07-11	1
24430	1459	40481087	1963-03-18	1963-03-25	1
65035	3851	40481087	1952-07-03	1952-07-24	1
20130	1214	28060	2018-04-05	2018-04-15	1
21040	1264	40481087	1984-01-30	1984-02-13	1
50435	2987	260139	1995-07-16	1995-07-30	1
40964	2438	80180	2016-08-27	2016-08-28	1
88358	5257	40481087	2000-08-25	2000-09-08	1
56931	3381	372328	1972-05-04	1972-08-14	1
30431	1796	4112343	1991-05-10	1991-05-21	1
73534	4375	260139	1976-10-27	1976-11-10	1
76815	4557	40481087	2016-05-02	2016-05-23	1
30153	1783	133834	1962-12-15	1976-10-07	1
22441	1340	4112343	1912-09-23	1912-10-05	1
19506	1173	372328	1946-06-03	1946-08-19	1
23424	1399	4218389	1994-12-28	1995-01-25	1
35157	2087	317576	2001-07-18	2001-07-19	1
42840	2554	195588	1967-07-19	1967-08-25	1
81939	4865	40479768	1981-11-24	1982-01-30	1
49899	2951	40481087	1959-11-17	1959-12-01	1
26530	1572	40481087	1977-08-31	1977-09-14	1
49127	2909	4296204	1956-07-27	1956-08-10	1
89188	5312	40481087	1999-09-21	1999-10-12	1
83216	4949	81151	1994-10-26	1994-11-16	1
30299	1791	260139	2017-02-12	2017-02-19	1
48481	2872	440448	1979-03-07	1979-03-08	1
25988	1543	40481087	1943-07-15	1943-07-29	1
86426	5148	40481087	1986-02-16	1986-03-02	1
51339	3049	40481087	1981-12-01	1981-12-15	1
24431	1459	40481087	1972-03-26	1972-04-16	1
65036	3851	40481087	1953-06-28	1953-07-19	1
20131	1214	80180	1978-01-07	1978-01-08	1
21041	1264	40481087	2002-06-07	2002-06-28	1
50436	2987	4112343	1981-08-22	1981-09-01	1
40965	2438	260139	2014-01-12	2014-01-19	1
2621	154	260139	1990-01-14	1990-01-28	1
56932	3381	372328	1979-04-19	1979-12-03	1
30432	1796	4296204	2015-03-10	2015-04-07	1
73535	4375	372328	1933-03-27	1933-06-25	1
76816	4557	81151	1973-08-23	1973-09-13	1
30154	1783	4112343	2001-11-01	2001-11-13	1
22442	1340	4112343	1935-03-03	1935-03-16	1
19507	1173	4027663	1975-09-04	1975-09-05	1
23425	1399	4218389	2000-09-25	2000-10-30	1
35158	2087	4112343	1922-08-21	1922-09-02	1
42841	2554	257012	1957-12-07	1978-10-31	1
81940	4865	40481087	1981-08-09	1981-08-30	1
49900	2951	40481087	1965-05-27	1965-06-10	1
27396	1618	375671	1981-11-30	1982-01-29	1
49128	2909	40481087	1991-01-31	1991-02-07	1
89189	5312	80180	1973-06-14	1973-06-15	1
83217	4949	372328	1972-12-20	1973-03-01	1
30300	1791	260139	2017-03-22	2017-04-05	1
48482	2872	40481087	1962-11-12	1962-12-03	1
25989	1543	40481087	1945-08-24	1945-09-14	1
86427	5148	80180	1998-01-21	1998-01-22	1
51340	3049	40481087	2011-12-31	2012-01-21	1
24432	1459	40481087	2000-05-27	2000-06-10	1
65037	3851	40481087	1989-05-13	1989-06-03	1
20132	1214	81151	1947-10-08	1947-11-05	1
21042	1264	40481087	2017-02-17	2017-03-03	1
50437	2987	4134304	1989-01-28	1989-02-27	1
40966	2438	4112343	1989-07-19	1989-07-30	1
2622	154	4112343	1979-07-02	1979-07-09	1
56933	3381	4112343	1972-12-13	1972-12-25	1
30433	1796	40481087	2017-05-14	2017-05-21	1
73536	4375	4112343	1996-01-03	1996-01-14	1
76817	4557	260139	1998-06-22	1998-06-29	1
30155	1783	4112343	2007-03-20	2007-03-27	1
22443	1340	4152936	1975-03-01	1975-03-22	1
19508	1173	40481087	1968-12-05	1968-12-12	1
23426	1399	40481087	1986-03-19	1986-04-02	1
35159	2087	4112343	1980-12-07	1980-12-16	1
42842	2554	260139	1942-06-20	1942-07-04	1
81941	4865	40481087	1991-04-29	1991-05-06	1
49901	2951	40481087	2006-11-29	2006-12-20	1
27397	1618	4329847	2006-04-12	2006-04-13	1
49129	2909	80180	1986-09-03	1986-09-04	1
89190	5312	80502	1998-12-14	1998-12-15	1
83218	4949	372328	1973-08-28	1973-11-29	1
30301	1791	372328	1957-01-13	1957-05-02	1
48483	2872	40481087	1990-10-02	1990-10-09	1
25990	1543	40481087	1975-11-07	1975-11-14	1
86428	5148	372328	1962-10-03	1963-01-21	1
51341	3049	0	1991-07-12	1991-07-13	1
24433	1459	40481087	2010-12-04	2010-12-11	1
65038	3851	40481087	1995-07-24	1995-07-31	1
20133	1214	4048171	1942-01-03	1959-01-01	1
21909	1315	81151	1960-05-04	1960-06-08	1
50438	2987	28060	1983-02-24	1983-03-05	1
40967	2438	28060	1995-01-03	1995-01-14	1
2623	154	40481087	2000-10-13	2000-11-03	1
56934	3381	4112343	2005-04-21	2005-05-03	1
30434	1796	4112343	1980-04-30	1980-05-11	1
73537	4375	40481087	1969-09-22	1969-10-13	1
76818	4557	4112343	1974-04-07	1974-04-16	1
30156	1783	40481087	1967-09-21	1967-10-05	1
22444	1340	4278672	2014-04-29	2014-05-29	1
19509	1173	40481087	1984-12-24	1985-01-14	1
23427	1399	40481087	2018-12-13	2018-12-20	1
35160	2087	4112343	2013-02-24	2013-03-03	1
42843	2554	317576	1999-12-02	1999-12-03	1
81942	4865	28060	1991-10-26	1991-11-02	1
49902	2951	260139	1965-03-06	1965-03-13	1
27398	1618	40481087	1985-12-17	1985-12-31	1
49130	2909	192671	1986-09-22	1986-09-23	1
89191	5312	260139	1961-12-09	1961-12-16	1
83219	4949	4112343	1977-04-16	1977-04-26	1
30302	1791	378001	1975-02-23	1975-04-24	1
48808	2894	372328	1923-09-04	1924-01-19	1
25991	1543	40481087	1983-01-13	1983-02-03	1
86429	5148	372328	1975-09-16	1976-05-04	1
51342	3049	78272	2005-10-18	2005-11-22	1
24434	1459	81893	1974-08-29	1974-08-30	1
65039	3851	260139	1969-02-17	1969-03-03	1
20134	1214	4152936	1945-10-27	1945-11-17	1
21910	1315	260139	1973-02-09	1973-02-23	1
50439	2987	4112343	1973-07-23	1973-07-31	1
40968	2438	257012	2005-11-10	2005-11-11	1
2624	154	257012	1980-09-23	1980-09-24	1
56935	3381	28060	1972-03-09	1972-03-17	1
30435	1796	4112343	1987-01-18	1987-01-27	1
73538	4375	40481087	1973-05-31	1973-06-14	1
76819	4557	4116491	1952-04-10	1952-05-27	1
30157	1783	195588	2017-07-26	2017-09-18	1
22445	1340	40481087	1919-01-11	1919-01-25	1
19510	1173	40481087	2013-04-04	2013-04-18	1
23428	1399	440086	1972-06-26	1978-07-05	1
35161	2087	4294548	1944-02-17	1944-05-11	1
42844	2554	372328	1940-07-07	1941-07-24	1
81943	4865	81151	1995-02-10	1995-02-24	1
49903	2951	260139	1983-09-21	1983-09-28	1
27399	1618	0	2006-04-12	2006-04-13	1
49131	2909	258780	1969-04-13	1969-04-14	1
89192	5312	375671	1940-11-19	1941-01-18	1
83220	4949	4112343	2017-06-11	2017-06-23	1
30303	1791	4112343	1971-04-08	1971-04-18	1
48809	2894	378419	1999-11-13	1999-11-14	1
25992	1543	80180	1981-03-29	1981-03-30	1
86430	5148	4237458	1996-05-07	1996-07-06	1
51343	3049	260139	1997-10-14	1997-10-28	1
24435	1459	257012	1946-08-31	1946-09-01	1
65040	3851	372328	1916-12-21	1917-04-16	1
20135	1214	4155034	1969-10-01	1969-10-22	1
21911	1315	4112343	1982-03-06	1982-03-15	1
50440	2987	78272	2003-09-12	2003-10-17	1
40969	2438	4146173	2015-09-06	2015-11-05	1
2625	154	4112343	1989-01-20	1989-01-29	1
56936	3381	28060	1982-01-25	1982-02-05	1
30436	1796	4112343	2005-07-10	2005-07-20	1
73539	4375	40481087	1987-02-20	1987-02-27	1
76820	4557	40481087	1998-11-03	1998-11-10	1
30158	1783	378001	1989-06-03	1989-07-03	1
22446	1340	40481087	1938-02-28	1938-03-21	1
19511	1173	40481087	2018-04-28	2018-05-05	1
23429	1399	4048171	1962-07-06	1962-07-07	1
35162	2087	40481087	1985-11-14	1985-12-05	1
42845	2554	4112343	1934-09-24	1934-10-04	1
81944	4865	260139	1980-06-29	1980-07-06	1
49904	2951	4059173	1963-10-21	1964-01-19	1
27400	1618	80180	2013-05-21	2013-05-22	1
49132	2909	4112343	1999-01-25	1999-02-04	1
89193	5312	4112343	1948-02-14	1948-02-25	1
83221	4949	4266809	2013-02-28	2013-03-01	1
30304	1791	40481087	1983-02-24	1983-03-10	1
48810	2894	4059173	1995-10-22	1996-01-20	1
25993	1543	317576	1986-08-24	1986-08-25	1
86431	5148	40481087	1965-01-25	1965-02-15	1
51344	3049	321042	1991-07-12	1991-07-13	1
24436	1459	4134304	1997-07-15	1997-09-13	1
65041	3851	4112343	1958-10-30	1958-11-10	1
20136	1214	40481087	1992-03-03	1992-03-17	1
21912	1315	4112343	1990-08-03	1990-08-13	1
50441	2987	80180	2015-05-02	2015-05-03	1
40970	2438	4152936	2010-01-21	2010-02-04	1
2626	154	4294548	1980-08-26	1980-10-14	1
56937	3381	78272	1988-01-11	1988-01-25	1
30437	1796	4155034	1997-06-28	1997-07-12	1
73540	4375	0	1946-07-06	1946-07-07	1
76821	4557	40481087	2013-01-26	2013-02-16	1
30159	1783	4048171	1961-08-02	1961-08-03	1
22447	1340	260139	1919-05-01	1919-05-15	1
19512	1173	28060	1951-03-11	1951-03-22	1
23430	1399	40481087	1962-10-25	1962-11-15	1
35163	2087	80180	1956-04-18	1956-04-19	1
42846	2554	4112343	1976-05-15	1976-05-27	1
81945	4865	4027663	2004-01-23	2004-01-24	1
49905	2951	260139	1963-08-23	1963-09-06	1
27401	1618	4310024	2011-04-02	2011-04-03	1
49133	2909	40481087	1954-12-11	1955-01-01	1
89194	5312	4310024	1972-01-21	1972-01-22	1
83222	4949	4294548	1979-12-13	1980-02-14	1
30305	1791	40481087	2010-08-22	2010-09-05	1
48811	2894	4237458	1991-02-24	1991-04-25	1
25994	1543	4035415	1957-03-25	1957-05-24	1
86432	5148	378001	1961-02-09	1961-03-11	1
51345	3049	4329847	1986-12-05	1986-12-06	1
24437	1459	4283893	1946-07-27	1946-12-07	1
65042	3851	4112343	1959-01-13	1959-01-23	1
20137	1214	260139	1944-02-07	1944-02-14	1
21913	1315	4112343	2010-10-31	2010-11-13	1
50442	2987	192671	2015-07-03	2015-07-04	1
40971	2438	40481087	2010-10-05	2010-10-12	1
2627	154	4310024	2011-01-11	2011-01-12	1
56938	3381	80180	2011-01-15	2011-01-16	1
30438	1796	4294548	1983-08-29	1983-10-17	1
73541	4375	80180	1969-07-19	1969-07-20	1
76822	4557	40481087	2013-05-25	2013-06-08	1
30160	1783	4051466	1961-08-02	1978-11-05	1
22448	1340	378001	1944-03-13	1944-05-12	1
19513	1173	4218389	1993-02-01	1993-02-22	1
23431	1399	40481087	1990-01-16	1990-02-06	1
35164	2087	257012	1964-05-30	1964-05-31	1
42847	2554	4112343	2005-09-24	2005-10-02	1
81946	4865	4112343	1991-08-12	1991-08-25	1
49906	2951	40481087	1986-11-14	1986-12-05	1
27402	1618	40481087	1994-02-21	1994-03-14	1
49134	2909	28060	1997-02-08	1997-02-20	1
89195	5312	40481087	1944-07-07	1944-07-14	1
83223	4949	40481087	1977-07-04	1977-07-18	1
30306	1791	81151	1970-04-15	1970-05-20	1
48812	2894	4296205	2004-09-18	2004-10-23	1
25995	1543	4112343	1986-04-23	1986-05-06	1
86433	5148	4112343	1981-02-26	1981-03-05	1
51346	3049	40481087	2014-12-13	2015-01-03	1
24438	1459	4294548	2018-06-07	2018-11-22	1
65043	3851	4112343	1982-10-20	1982-10-31	1
20138	1214	378001	2009-07-29	2009-08-28	1
21914	1315	28060	1971-03-21	1971-04-02	1
50443	2987	4059173	1979-05-21	1979-08-19	1
40972	2438	372328	2017-11-05	2018-04-15	1
2628	154	80180	2012-03-06	2012-03-07	1
56939	3381	81151	2007-01-15	2007-02-19	1
32055	1906	260139	1975-10-27	1975-11-03	1
73542	4375	80502	2018-03-04	2018-03-05	1
76823	4557	0	1978-12-31	1979-01-01	1
30161	1783	4112343	1975-06-18	1975-06-25	1
22449	1340	378001	2002-01-02	2002-03-03	1
19514	1173	4237458	1949-03-19	1949-04-18	1
24015	1435	28060	1969-09-08	1969-09-17	1
35165	2087	260139	1955-09-07	1955-09-21	1
42848	2554	4112343	2007-01-28	2007-02-09	1
81947	4865	4112343	2010-01-08	2010-01-16	1
49907	2951	260139	1968-10-24	1968-10-31	1
27403	1618	30753	2011-10-29	2011-10-30	1
49135	2909	195588	1969-04-04	1969-05-27	1
89196	5312	30753	1972-09-17	1972-09-18	1
83224	4949	40481087	1991-10-19	1991-11-09	1
30307	1791	198199	2011-11-11	2011-12-19	1
48813	2894	40481087	2001-06-07	2001-06-14	1
25996	1543	40481087	1958-09-03	1958-09-17	1
86434	5148	4278672	1974-09-30	1974-12-28	1
51347	3049	40481087	2015-02-10	2015-02-17	1
24439	1459	40481087	2008-12-16	2009-01-06	1
65044	3851	4283893	1971-02-03	1971-08-11	1
20139	1214	4109685	1987-02-11	1987-02-25	1
21915	1315	80180	1996-03-21	1996-03-22	1
50444	2987	4283893	1977-08-07	1977-09-18	1
40973	2438	4155034	1997-05-15	1997-05-29	1
2629	154	260139	1985-03-29	1985-04-05	1
56940	3381	260139	2007-01-29	2007-02-05	1
32056	1906	260139	1980-01-13	1980-01-20	1
73543	4375	260139	1946-05-27	1946-06-03	1
76824	4557	80502	1990-08-12	1990-08-13	1
30162	1783	4112343	1979-05-09	1979-05-18	1
22450	1340	4294548	1931-03-28	1931-04-18	1
19515	1173	4266809	1986-01-19	1986-01-20	1
24016	1435	28060	1976-08-21	1976-09-01	1
35166	2087	260139	2009-10-13	2009-10-27	1
42849	2554	40481087	1949-08-11	1949-08-18	1
81948	4865	4112343	2015-05-22	2015-05-30	1
49908	2951	260139	2017-09-10	2017-09-17	1
27404	1618	81893	2011-05-02	2011-05-03	1
49136	2909	198809	1962-04-07	1962-04-07	1
89197	5312	260139	1998-12-04	1998-12-18	1
83225	4949	192671	2013-03-31	2013-04-01	1
30308	1791	260139	1975-04-25	1975-05-02	1
48814	2894	28060	1966-08-01	1966-08-11	1
25997	1543	40481087	1988-09-12	1988-09-26	1
86435	5148	40481087	2000-04-23	2000-05-14	1
51348	3049	80180	2014-08-02	2014-08-03	1
24440	1459	80180	1976-03-21	1976-03-22	1
65045	3851	40481087	1961-09-02	1961-09-16	1
20140	1214	4112343	1941-03-26	1941-04-04	1
21916	1315	260139	1962-02-24	1962-03-10	1
50445	2987	40481087	1993-03-04	1993-03-11	1
40974	2438	40481087	1993-07-08	1993-07-22	1
2630	154	260139	2017-07-15	2017-07-22	1
56941	3381	260139	2018-06-05	2018-06-12	1
32057	1906	372328	1963-01-01	1963-04-20	1
73544	4375	4116491	1980-06-26	1980-07-28	1
76825	4557	81151	1932-10-03	1932-10-31	1
30163	1783	40481087	1968-05-08	1968-05-15	1
22451	1340	40481087	1914-10-31	1914-11-14	1
19516	1173	4296204	1982-09-22	1982-10-06	1
24017	1435	80180	2002-09-26	2002-09-27	1
35167	2087	4059173	1997-02-06	1997-04-07	1
42850	2554	40481087	1952-09-06	1952-09-13	1
81949	4865	40481087	1985-09-15	1985-09-22	1
49909	2951	40481087	1961-04-29	1961-05-13	1
27405	1618	260139	1986-01-09	1986-01-23	1
49137	2909	257012	1960-06-21	1960-06-22	1
89198	5312	261325	1973-12-31	1974-01-01	1
83226	4949	372328	1977-11-08	1978-09-07	1
30309	1791	4112343	1966-02-19	1966-03-03	1
48815	2894	78272	1956-07-01	1956-07-29	1
25998	1543	0	1994-10-23	1994-10-24	1
86436	5148	40481087	2013-02-11	2013-02-18	1
51349	3049	260139	1997-09-05	1997-09-12	1
24441	1459	4112343	2015-06-11	2015-06-19	1
65046	3851	0	1985-10-14	1985-10-15	1
20141	1214	4112343	1942-12-27	1943-01-03	1
21917	1315	4149245	1962-05-29	1962-08-04	1
50446	2987	40481087	2012-03-07	2012-03-14	1
40975	2438	28060	1981-12-15	1981-12-25	1
2631	154	40481087	1984-10-30	1984-11-20	1
56942	3381	4112343	1988-01-08	1988-01-19	1
32058	1906	4112343	1963-04-04	1963-04-13	1
73545	4375	4294548	1943-05-25	1943-11-16	1
76826	4557	321042	1978-12-31	1979-01-01	1
30164	1783	80180	2002-03-03	2002-03-04	1
22452	1340	40481087	1981-09-28	1981-10-12	1
19517	1173	40481087	1991-08-16	1991-08-30	1
24018	1435	257012	1964-06-08	1964-06-09	1
35168	2087	4112343	1927-02-11	1927-02-23	1
42851	2554	40481087	1953-02-17	1953-02-24	1
81950	4865	40481087	2007-07-29	2007-08-12	1
49910	2951	40481087	1984-12-02	1984-12-16	1
27406	1618	4027663	2002-05-09	2002-05-10	1
49138	2909	260139	1952-03-21	1952-03-28	1
89199	5312	372328	1939-09-26	1940-01-08	1
83227	4949	375671	2006-07-16	2006-09-14	1
30310	1791	4112343	2011-03-30	2011-04-08	1
48816	2894	80180	1958-04-23	1958-04-24	1
25999	1543	4112343	1969-04-25	1969-05-06	1
1705	99	0	1996-10-17	1996-10-18	1
51350	3049	4218389	2011-07-24	2011-08-21	1
24442	1459	4285898	1975-12-22	1975-12-23	1
65047	3851	81151	1963-09-02	1963-10-07	1
20142	1214	4112343	1947-02-14	1947-02-21	1
21918	1315	4155034	1974-10-14	1974-10-28	1
50447	2987	28060	1992-10-01	1992-10-13	1
40976	2438	81151	1987-03-18	1987-04-08	1
2632	154	40481087	1988-11-04	1988-11-25	1
56943	3381	372328	1974-10-10	1974-11-11	1
32059	1906	40481087	1968-08-13	1968-08-27	1
75684	4493	80180	2017-01-29	2017-01-30	1
76827	4557	372328	1925-08-20	1926-04-04	1
30165	1783	81151	1994-03-09	1994-03-30	1
22453	1340	40481087	2000-04-11	2000-04-25	1
19518	1173	40481087	1994-10-19	1994-11-02	1
24019	1435	260139	1980-10-27	1980-11-10	1
35169	2087	4112343	1974-06-28	1974-07-11	1
42852	2554	40481087	1966-11-30	1966-12-14	1
81951	4865	81151	1985-01-14	1985-02-11	1
49911	2951	40481087	2013-05-24	2013-05-31	1
27407	1618	40481087	1976-12-05	1976-12-26	1
49139	2909	260139	1990-07-15	1990-07-29	1
89200	5312	4112343	1980-10-18	1980-10-27	1
83228	4949	4285898	2012-12-30	2012-12-31	1
30311	1791	4112343	2016-11-10	2016-11-17	1
48817	2894	4149245	1998-03-17	1998-05-23	1
26000	1543	4112343	1974-01-13	1974-01-25	1
1706	99	257012	1998-11-08	1998-11-09	1
52895	3135	80180	2005-10-13	2005-10-14	1
24443	1459	4296204	1944-11-29	1944-12-20	1
65048	3851	257012	1971-05-12	1971-05-13	1
20143	1214	4112343	2009-12-31	2010-01-13	1
21919	1315	4310024	1995-01-26	1995-01-27	1
50448	2987	260139	1989-05-30	1989-06-13	1
40977	2438	260139	1988-06-12	1988-06-26	1
2633	154	40481087	2000-07-31	2000-08-07	1
56944	3381	40481087	2013-05-18	2013-06-01	1
32060	1906	40481087	1974-03-22	1974-03-29	1
75685	4493	260139	1995-06-05	1995-06-12	1
76828	4557	4112343	1960-02-24	1960-03-04	1
30166	1783	260139	1968-04-11	1968-04-18	1
22454	1340	78272	1926-12-08	1926-12-22	1
19519	1173	40481087	1995-07-09	1995-07-23	1
24020	1435	260139	2010-03-23	2010-04-06	1
35170	2087	4112343	1983-03-09	1983-03-21	1
42853	2554	40481087	1980-03-30	1980-04-06	1
81952	4865	260139	2005-04-28	2005-05-05	1
49912	2951	40481087	2018-07-11	2018-08-01	1
27408	1618	40481087	1990-04-15	1990-05-06	1
49140	2909	4112343	1977-04-12	1977-04-23	1
89201	5312	4112343	2006-10-21	2006-10-28	1
83229	4949	40481087	2001-05-17	2001-05-31	1
30312	1791	40481087	1991-11-02	1991-11-23	1
48818	2894	40479422	1932-07-30	1932-10-05	1
26001	1543	40481087	1950-02-28	1950-03-14	1
1707	99	440448	1996-10-17	1996-10-18	1
52896	3135	260139	1978-12-24	1979-01-07	1
24444	1459	28060	1949-01-23	1949-02-04	1
65049	3851	260139	1962-11-05	1962-11-12	1
20144	1214	4152936	1979-04-03	1979-04-24	1
21920	1315	40481087	2006-05-02	2006-05-16	1
50449	2987	372328	1975-08-10	1975-10-27	1
40978	2438	4294548	2005-09-22	2005-11-24	1
2634	154	30753	2011-06-10	2011-06-11	1
59764	3545	78272	1994-07-30	1994-08-27	1
32061	1906	28060	2012-03-26	2012-04-04	1
75686	4493	4112343	2004-07-11	2004-07-24	1
76829	4557	40481087	1979-09-22	1979-10-06	1
30167	1783	4084167	1962-03-13	1962-03-13	1
22455	1340	80502	1971-07-15	1971-07-16	1
19520	1173	40481087	1997-06-19	1997-06-26	1
24021	1435	372328	2014-03-12	2014-04-26	1
35171	2087	4142905	1989-04-19	1989-07-18	1
42854	2554	40481087	1988-09-28	1988-10-05	1
81953	4865	375671	1994-02-15	1994-03-17	1
51443	3057	80180	1973-06-14	1973-06-15	1
27409	1618	192671	2013-06-07	2013-06-08	1
49141	2909	4112343	1998-08-17	1998-08-26	1
89202	5312	4152936	1971-08-30	1971-09-13	1
83230	4949	40481087	2005-08-15	2005-09-05	1
30313	1791	40481087	2016-12-10	2016-12-24	1
48819	2894	40481087	1941-09-05	1941-09-19	1
26002	1543	40481087	1975-02-27	1975-03-06	1
1708	99	4112343	1992-04-11	1992-04-22	1
52897	3135	260139	1990-09-08	1990-09-22	1
24445	1459	81151	2006-10-26	2006-11-16	1
65050	3851	4112343	1927-10-21	1927-10-28	1
20145	1214	4294548	1997-06-02	1997-06-16	1
21921	1315	28060	1965-10-08	1965-10-16	1
50450	2987	4112343	1989-11-30	1989-12-12	1
40979	2438	40481087	1991-05-05	1991-05-12	1
2635	154	4027663	2001-11-14	2001-11-15	1
59765	3545	80180	2011-12-13	2011-12-14	1
32062	1906	372328	1964-01-15	1964-04-18	1
75687	4493	4296204	1988-01-22	1988-02-12	1
76830	4557	40481087	1983-09-20	1983-09-27	1
30168	1783	4084167	1974-06-14	1974-06-14	1
22456	1340	260139	1948-03-09	1948-03-23	1
22225	1328	28060	1993-02-22	1993-03-06	1
24022	1435	4112343	1996-12-16	1996-12-28	1
35172	2087	4152936	1950-11-21	1950-12-05	1
42855	2554	40481087	2001-11-16	2001-12-07	1
81954	4865	4112343	1995-11-14	1995-11-22	1
51444	3057	260139	1979-11-10	1979-11-17	1
27410	1618	260139	1992-12-21	1993-01-04	1
49142	2909	4112343	2004-06-09	2004-06-22	1
89203	5312	4155034	1942-09-10	1942-10-01	1
83231	4949	40481087	1995-10-25	1995-11-15	1
30314	1791	28060	1955-08-24	1955-08-31	1
48820	2894	40481087	1994-11-26	1994-12-03	1
26003	1543	260139	1941-06-19	1941-06-26	1
1709	99	4218389	1960-10-12	1960-11-02	1
52898	3135	4112343	1998-01-25	1998-02-07	1
24446	1459	260139	1990-06-02	1990-06-16	1
65051	3851	40481087	1989-11-08	1989-11-15	1
20146	1214	40481087	1996-03-28	1996-04-04	1
21922	1315	30753	1995-10-23	1995-10-24	1
50451	2987	4112343	1992-12-13	1992-12-25	1
44425	2646	260139	1980-02-13	1980-02-20	1
2636	154	4112343	1994-03-05	1994-03-14	1
59766	3545	260139	1974-10-03	1974-10-17	1
32063	1906	4296205	2017-05-18	2017-06-08	1
75688	4493	4294548	1991-01-15	1991-03-05	1
76831	4557	40481087	2010-01-16	2010-01-30	1
30169	1783	4156265	1986-08-04	1986-08-18	1
22457	1340	260139	1986-09-09	1986-09-23	1
22226	1328	28060	2010-04-08	2010-04-18	1
24023	1435	4155034	1996-02-13	1996-02-27	1
35173	2087	40481087	1946-03-09	1946-03-23	1
42856	2554	40481087	2016-04-01	2016-04-22	1
81955	4865	4310024	2011-08-19	2011-08-20	1
51445	3057	372328	1941-05-30	1942-04-27	1
27411	1618	317576	1999-03-03	1999-03-04	1
49143	2909	196456	1962-04-07	1962-04-07	1
89204	5312	4285898	1973-02-14	1973-02-15	1
84811	5049	80180	1998-12-08	1998-12-09	1
30315	1791	80180	1992-01-05	1992-01-06	1
48821	2894	81151	1967-07-02	1967-07-30	1
26004	1543	260139	1971-07-21	1971-07-28	1
1710	99	4278672	2011-09-11	2011-10-11	1
52899	3135	4283893	1976-07-25	1976-09-26	1
24447	1459	4112343	1958-07-18	1958-07-29	1
68708	4071	78272	1992-11-27	1992-12-18	1
20147	1214	28060	2008-01-30	2008-02-08	1
21923	1315	4027663	1988-06-01	1988-06-02	1
52003	3083	80180	1994-07-07	1994-07-08	1
44426	2646	260139	2008-11-25	2008-12-02	1
2637	154	4218389	1979-05-29	1979-07-03	1
59767	3545	4112343	1996-01-09	1996-01-20	1
32064	1906	40481087	1962-10-13	1962-10-20	1
75689	4493	40481087	2002-02-11	2002-02-25	1
78225	4637	378001	2007-02-05	2007-04-06	1
30170	1783	40481087	1995-02-01	1995-02-08	1
22458	1340	4027663	1943-07-22	1943-07-23	1
22227	1328	78272	1995-02-21	1995-03-07	1
24024	1435	4283893	1964-05-11	1964-06-22	1
35174	2087	40481087	1988-02-01	1988-02-15	1
43627	2602	80502	2009-03-25	2009-03-26	1
81956	4865	40481087	1975-03-01	1975-03-08	1
51446	3057	4112343	1938-10-28	1938-11-05	1
27412	1618	4112343	1978-06-21	1978-07-03	1
49144	2909	260139	1954-08-18	1954-08-25	1
89205	5312	40481087	1970-06-18	1970-07-09	1
84812	5049	81151	1999-07-07	1999-07-28	1
30316	1791	260139	1963-11-19	1963-11-26	1
48822	2894	372328	1927-11-03	1928-01-28	1
26005	1543	440086	1950-10-18	1951-11-21	1
1711	99	4283893	1998-10-04	1998-11-15	1
52900	3135	40481087	1969-06-09	1969-06-23	1
24448	1459	4266809	1976-03-21	1976-03-22	1
68709	4071	260139	1962-09-11	1962-09-18	1
20148	1214	260139	1993-05-19	1993-06-02	1
21924	1315	4156265	2010-02-21	2010-03-07	1
52004	3083	195588	1990-04-19	1990-06-08	1
44427	2646	321042	2007-12-14	2007-12-15	1
2638	154	4285898	2011-09-08	2011-09-09	1
59768	3545	40481087	1972-08-01	1972-08-08	1
32065	1906	40481087	2016-11-01	2016-11-21	1
75690	4493	257012	1991-02-26	1991-02-27	1
78226	4637	4112343	1988-04-22	1988-04-29	1
30171	1783	40481087	1995-08-15	1995-08-29	1
22459	1340	4112343	1913-08-03	1913-08-11	1
22228	1328	81151	1980-12-31	1981-02-04	1
24025	1435	40481087	1964-08-29	1964-09-19	1
35175	2087	40481087	1990-05-13	1990-05-27	1
43628	2602	257012	1980-05-09	1980-05-10	1
81957	4865	40481087	2008-07-15	2008-07-29	1
51447	3057	4112343	1991-06-30	1991-07-13	1
27413	1618	4112343	1984-06-04	1984-06-13	1
49145	2909	260139	1957-05-13	1957-05-27	1
56091	3325	40481087	2002-01-17	2002-02-07	1
84813	5049	321042	1998-02-18	1998-02-19	1
30317	1791	372328	1980-12-27	1983-02-10	1
48823	2894	4112343	1974-04-04	1974-04-12	1
26006	1543	4237458	1946-06-21	1946-09-19	1
1712	99	78272	2001-01-01	2001-01-15	1
52901	3135	40481087	1984-06-15	1984-06-29	1
24449	1459	4283893	2002-12-06	2003-02-07	1
68710	4071	260139	1965-10-03	1965-10-17	1
20149	1214	372328	1940-03-27	1940-06-06	1
21925	1315	40481087	1989-10-06	1989-10-20	1
52005	3083	260139	1951-05-30	1951-06-13	1
44428	2646	4112343	1998-07-05	1998-07-16	1
2639	154	40481087	1977-09-11	1977-10-02	1
59769	3545	40481087	1975-12-30	1976-01-13	1
32066	1906	372328	1965-06-13	1965-10-24	1
75691	4493	40481087	2008-06-30	2008-07-14	1
78227	4637	4112343	1991-05-30	1991-06-08	1
30172	1783	260139	1981-03-15	1981-03-22	1
22460	1340	4112343	1978-05-13	1978-05-20	1
22229	1328	81151	2013-01-31	2013-02-28	1
24026	1435	40481087	2010-09-03	2010-09-24	1
35176	2087	40481087	1999-09-12	1999-10-03	1
43629	2602	260139	2006-02-28	2006-03-14	1
81958	4865	78272	1974-12-26	1975-01-23	1
51448	3057	4112343	2008-09-01	2008-09-13	1
27414	1618	4112343	2013-08-11	2013-08-21	1
49146	2909	260139	1972-03-13	1972-03-20	1
56092	3325	80180	2004-12-23	2004-12-24	1
84814	5049	381316	2002-07-31	2002-08-01	1
30318	1791	4112343	1965-01-11	1965-01-23	1
48824	2894	4112343	1974-06-15	1974-06-28	1
27890	1649	260139	1969-11-02	1969-11-16	1
1713	99	260139	1980-11-30	1980-12-14	1
52902	3135	40481087	2011-05-08	2011-05-15	1
24450	1459	40481087	1972-01-12	1972-01-19	1
68711	4071	4094814	1969-12-07	1970-02-05	1
20150	1214	372328	1942-03-28	1942-10-01	1
21926	1315	372328	1961-05-29	1961-11-14	1
52006	3083	4112343	1952-05-27	1952-06-09	1
44429	2646	40481087	1985-01-23	1985-02-13	1
2640	154	40481087	1998-12-11	1999-01-01	1
59770	3545	40481087	1994-09-11	1994-09-18	1
32067	1906	4112343	1981-09-23	1981-10-04	1
75692	4493	260139	1989-11-13	1989-11-27	1
78228	4637	4218389	1980-12-20	1981-01-24	1
30173	1783	4112343	1974-07-10	1974-07-20	1
22461	1340	4283893	1912-12-29	1913-08-31	1
22230	1328	260139	1980-11-16	1980-11-30	1
24027	1435	40481087	2015-03-07	2015-03-21	1
37676	2237	80502	1999-10-24	1999-10-25	1
43630	2602	4155034	2014-02-27	2014-03-13	1
81959	4865	80180	2013-06-09	2013-06-10	1
51449	3057	4155034	1992-02-13	1992-03-05	1
29252	1736	80180	2010-01-13	2010-01-14	1
49147	2909	4116491	1963-02-21	1963-04-06	1
56093	3325	40481087	2009-11-02	2009-11-16	1
84815	5049	4059173	1970-07-18	1970-10-16	1
30319	1791	4112343	1976-10-19	1976-10-28	1
48825	2894	4112343	2005-03-03	2005-03-16	1
27891	1649	260139	1985-01-05	1985-01-12	1
1714	99	260139	2015-03-28	2015-04-04	1
52903	3135	192671	2005-11-30	2005-12-01	1
27675	1635	0	2013-03-27	2013-03-28	1
68712	4071	4112343	1987-03-15	1987-03-24	1
20151	1214	4112343	1952-09-25	1952-10-03	1
21927	1315	372328	1962-09-10	1963-03-05	1
52007	3083	4112343	1988-10-14	1988-10-25	1
44430	2646	0	2007-12-14	2007-12-15	1
4064	236	30753	1989-12-02	1989-12-03	1
59771	3545	260139	1973-03-24	1973-03-31	1
32068	1906	40481087	1967-04-04	1967-04-11	1
75693	4493	375671	1997-04-25	1997-05-25	1
78229	4637	40481087	1975-04-23	1975-05-14	1
30174	1783	4112343	1982-10-01	1982-10-10	1
22462	1340	4283893	1934-12-18	1935-04-09	1
22231	1328	260139	2008-02-17	2008-02-24	1
24028	1435	260139	2008-11-20	2008-11-27	1
37677	2237	81893	1965-06-25	1965-06-26	1
43631	2602	28060	2019-06-11	2019-06-23	1
81960	4865	4155034	1991-01-11	1991-02-01	1
51450	3057	28060	1942-03-08	1942-03-15	1
29253	1736	257012	1976-01-17	1976-01-18	1
49148	2909	4283893	1960-04-12	1960-07-05	1
56094	3325	28060	2007-10-29	2007-11-08	1
84816	5049	4294548	1988-12-22	1989-03-23	1
30320	1791	4112343	1983-01-29	1983-02-09	1
48826	2894	40481087	1942-05-23	1942-06-13	1
27892	1649	317576	2007-03-14	2007-03-15	1
1715	99	261325	1995-12-23	1995-12-24	1
52904	3135	260139	2003-08-03	2003-08-10	1
27676	1635	81151	1976-07-29	1976-08-19	1
68713	4071	4112343	1993-01-05	1993-01-16	1
20152	1214	4113008	2012-05-14	2012-06-04	1
21928	1315	4155034	1964-05-25	1964-06-08	1
52008	3083	40481087	1957-01-03	1957-01-17	1
44431	2646	80180	2009-07-18	2009-07-19	1
4065	236	257012	2004-07-12	2004-07-13	1
59772	3545	372328	1988-10-13	1989-04-26	1
32069	1906	40481087	1969-07-30	1969-08-13	1
75694	4493	4112343	1987-04-30	1987-05-10	1
78230	4637	40481087	1995-04-27	1995-05-11	1
31599	1874	260139	1982-04-29	1982-05-06	1
22463	1340	40481087	1956-05-23	1956-06-13	1
22232	1328	261325	1980-12-04	1980-12-05	1
24029	1435	4112343	1997-01-29	1997-02-05	1
37678	2237	372328	1934-08-18	1934-10-28	1
43632	2602	30753	1986-07-17	1986-07-18	1
81961	4865	4266809	2013-06-09	2013-06-10	1
51451	3057	81151	1978-06-28	1978-07-26	1
29254	1736	260139	1992-05-02	1992-05-09	1
49149	2909	40481087	1992-02-08	1992-02-29	1
56095	3325	81151	1965-05-07	1965-06-11	1
84817	5049	40481087	2005-06-18	2005-06-25	1
30321	1791	4112343	1986-03-29	1986-04-07	1
48827	2894	40481087	1956-10-23	1956-11-06	1
27893	1649	4059173	1960-09-12	1960-12-11	1
1716	99	439777	2016-10-10	2016-10-11	1
52905	3135	4027663	1994-05-29	1994-05-30	1
27677	1635	260139	2005-07-19	2005-08-02	1
68714	4071	40481087	1953-04-06	1953-04-20	1
20153	1214	4218389	1968-09-15	1968-10-06	1
22841	1365	195588	1993-08-14	1993-11-27	2
52009	3083	195588	1994-06-07	1994-07-28	1
44432	2646	260139	1982-02-19	1982-02-26	1
4066	236	260139	1978-01-01	1978-01-08	1
59773	3545	40481087	1995-08-21	1995-09-04	1
32070	1906	40481087	1973-12-24	1974-01-15	1
75695	4493	40481087	2012-08-01	2012-08-15	1
78231	4637	40481087	2017-04-04	2017-04-18	1
31600	1874	4112343	1987-10-18	1987-10-27	1
22642	1354	80180	2019-06-16	2019-06-17	1
22233	1328	372328	1947-08-29	1948-01-01	1
24030	1435	4112343	2018-10-16	2018-10-23	1
37679	2237	378001	1959-07-28	1959-08-27	1
43633	2602	78272	2018-02-20	2018-03-20	1
81962	4865	40481087	2004-09-29	2004-10-06	1
51452	3057	260139	1941-04-15	1941-04-29	1
29255	1736	260139	1999-06-20	1999-07-04	1
50560	2993	80180	2012-09-15	2012-09-16	1
56096	3325	260139	1963-09-16	1963-09-23	1
84818	5049	4112343	2001-10-24	2001-11-01	1
30322	1791	4142905	1995-07-08	1995-09-06	1
48828	2894	81151	1993-11-10	1993-12-01	1
27894	1649	4113008	1978-05-02	1978-05-23	1
1717	99	4237458	2015-09-20	2015-12-19	1
52906	3135	4112343	1970-08-30	1970-09-11	1
27678	1635	40481087	1990-11-21	1990-12-05	1
68715	4071	40481087	1977-09-01	1977-09-08	1
20154	1214	40481087	1955-03-14	1955-03-21	1
22842	1365	4112343	2013-04-06	2013-04-19	1
52010	3083	4112343	1978-01-31	1978-02-07	1
44433	2646	260139	1986-11-16	1986-11-23	1
4067	236	4027663	1979-03-15	1979-03-16	1
59774	3545	192671	2012-03-07	2012-03-08	1
32071	1906	40481087	1999-06-20	1999-06-27	1
77601	4603	80502	2010-10-28	2010-10-29	1
78232	4637	78272	1975-12-12	1976-01-16	1
31601	1874	4112343	2005-11-24	2005-12-07	1
22643	1354	260139	1981-07-29	1981-08-12	1
22234	1328	4109685	1969-04-19	1969-05-03	1
24031	1435	4155034	1994-02-09	1994-02-23	1
37680	2237	4027663	1958-11-04	1958-11-05	1
43634	2602	81151	1954-07-30	1954-08-20	1
85649	5101	260139	1971-04-16	1971-04-30	1
51453	3057	4112343	1973-08-20	1973-08-31	1
29256	1736	4283893	2003-12-31	2004-02-25	1
50561	2993	40481087	2002-09-16	2002-09-30	1
56097	3325	4112343	1979-06-18	1979-06-30	1
84819	5049	4294548	1968-02-08	1968-02-15	1
30323	1791	4218389	1968-03-21	1968-04-25	1
48829	2894	260139	1986-05-08	1986-05-22	1
27895	1649	4113008	1988-03-31	1988-04-21	1
1718	99	40481087	1960-03-25	1960-04-08	1
52907	3135	4112343	1986-02-21	1986-02-28	1
27679	1635	81893	2010-04-02	2010-04-03	1
68716	4071	40481087	1978-04-13	1978-04-27	1
20155	1214	40481087	1959-03-05	1959-03-19	1
22843	1365	4278672	1996-05-30	1996-07-29	1
52011	3083	4112343	2006-07-09	2006-07-16	1
44434	2646	260139	2002-02-21	2002-02-28	1
4068	236	4112343	1955-02-01	1955-02-08	1
59775	3545	260139	1985-05-15	1985-05-29	1
32072	1906	40486433	1964-11-18	1964-11-19	1
77602	4603	260139	1962-05-10	1962-05-24	1
78233	4637	81151	2003-05-13	2003-05-27	1
31602	1874	40481087	1988-09-01	1988-09-15	1
22644	1354	260139	1982-03-12	1982-03-19	1
22235	1328	4218389	1953-04-15	1953-05-13	1
24032	1435	4156265	1984-05-18	1984-06-01	1
37681	2237	4112343	1956-01-30	1956-02-09	1
43635	2602	260139	1959-08-18	1959-08-25	1
85650	5101	260139	1997-12-23	1998-01-06	1
51454	3057	4296204	2004-10-28	2004-11-11	1
29257	1736	40481087	1983-11-11	1983-11-18	1
50562	2993	261325	2004-08-28	2004-08-29	1
56098	3325	4112343	1984-01-21	1984-01-29	1
84820	5049	257012	1989-01-05	1989-01-06	1
30324	1791	4296204	1965-05-01	1965-06-05	1
48830	2894	260139	1986-11-30	1986-12-07	1
27896	1649	40481087	1963-05-05	1963-05-19	1
1719	99	28060	1967-10-11	1967-10-19	1
52908	3135	4112343	1991-04-05	1991-04-14	1
27680	1635	260139	2014-07-30	2014-08-06	1
68717	4071	40481087	1990-05-23	1990-06-06	1
20156	1214	40481087	1964-01-27	1964-02-17	1
22844	1365	40481087	1967-03-09	1967-03-16	1
52012	3083	4283893	1987-03-06	1987-04-10	1
44435	2646	372328	1977-12-23	1978-06-16	1
4069	236	4113008	1987-03-13	1987-03-27	1
59776	3545	260139	1997-02-11	1997-02-18	1
32073	1906	80180	1997-09-25	1997-09-26	1
77603	4603	372328	1959-12-13	1960-08-18	1
78234	4637	378001	1990-09-18	1990-11-17	1
31603	1874	80180	2014-12-20	2014-12-21	1
22645	1354	260139	2013-12-06	2013-12-13	1
22236	1328	40481087	1999-04-20	1999-05-11	1
24033	1435	40481087	1970-03-12	1970-03-19	1
37682	2237	4112343	1991-02-04	1991-02-15	1
43636	2602	378001	1963-02-04	1963-03-06	1
85651	5101	4112343	1986-07-26	1986-08-03	1
51455	3057	40480160	2017-10-04	2017-12-03	1
29258	1736	260139	1989-09-06	1989-09-13	1
50563	2993	4112343	1981-07-16	1981-07-23	1
56099	3325	40481087	1975-08-17	1975-09-07	1
84821	5049	258780	2019-02-06	2019-02-07	1
30325	1791	40481087	1971-10-02	1971-10-23	1
48831	2894	372328	1924-08-16	1925-01-17	1
27897	1649	80180	1993-05-17	1993-05-18	1
1720	99	192671	2000-03-11	2000-03-12	1
52909	3135	4152936	2001-07-16	2001-07-30	1
27681	1635	4278672	1973-08-14	1973-11-12	1
68718	4071	28060	2014-01-08	2014-01-17	1
20157	1214	40481087	1964-03-26	1964-04-09	1
22845	1365	372328	2009-02-25	2009-12-03	1
52013	3083	28060	1962-01-19	1962-01-27	1
44436	2646	4112343	1979-03-21	1979-03-30	1
4070	236	4134304	1983-12-29	1984-03-28	1
59777	3545	4230399	1983-05-29	1983-08-27	1
32074	1906	260139	1981-03-16	1981-03-30	1
77604	4603	4112343	1990-05-17	1990-05-26	1
78235	4637	4112343	1993-06-28	1993-07-10	1
31604	1874	260139	2000-11-27	2000-12-11	1
22646	1354	260139	2018-02-22	2018-03-01	1
22237	1328	372328	1946-09-01	1946-10-03	1
24034	1435	40481087	1976-01-23	1976-02-06	1
37683	2237	4116491	1970-12-17	1971-01-20	1
43637	2602	4027663	1979-09-22	1979-09-23	1
85652	5101	81151	1962-07-01	1962-07-22	1
51456	3057	40481087	1985-12-01	1985-12-08	1
29259	1736	4116491	1989-06-23	1989-08-16	1
50564	2993	4152936	2017-01-19	2017-02-09	1
56100	3325	40481087	1985-07-23	1985-08-06	1
84822	5049	260139	1966-05-11	1966-05-25	1
30326	1791	40481087	1981-05-08	1981-05-29	1
48832	2894	378001	1934-07-27	1934-09-25	1
27898	1649	378001	1971-08-16	1971-09-15	1
1721	99	372328	1959-06-22	1959-10-03	1
52910	3135	260139	1963-09-05	1963-09-12	1
27682	1635	40481087	2006-06-06	2006-06-27	1
68719	4071	257012	1986-08-20	1986-08-21	1
20158	1214	40481087	1983-09-19	1983-10-10	1
22846	1365	40481087	1979-07-08	1979-07-22	1
52014	3083	260139	1955-12-21	1955-12-28	1
44437	2646	4112343	1992-05-24	1992-06-05	1
4071	236	4266809	1990-10-28	1990-10-29	1
59778	3545	40481087	2018-05-12	2018-05-26	1
32075	1906	4112343	1970-02-08	1970-02-20	1
77605	4603	4112343	2007-05-12	2007-05-22	1
78236	4637	4152936	1989-08-10	1989-08-24	1
31605	1874	378001	1975-08-02	1975-10-01	1
22647	1354	4294548	1989-12-15	1989-12-22	1
22238	1328	4035415	1976-02-26	1976-04-26	1
24035	1435	40481087	1978-03-05	1978-03-12	1
37684	2237	4278672	1991-03-17	1991-05-16	1
43638	2602	4109685	1992-01-03	1992-01-24	1
85653	5101	378001	1994-04-03	1994-05-03	1
51457	3057	40481087	1991-09-17	1991-09-24	1
29260	1736	4116491	1989-09-20	1989-11-03	1
50565	2993	40481087	1974-06-16	1974-06-23	1
56101	3325	40481087	2019-02-02	2019-02-09	1
84823	5049	260139	1996-04-28	1996-05-12	1
30327	1791	81151	1997-08-31	1997-09-28	1
48833	2894	4112343	1925-06-29	1925-07-06	1
27899	1649	40481087	1989-04-28	1989-05-05	1
1722	99	4035415	1968-10-21	1968-11-20	1
52911	3135	4112343	1993-05-06	1993-05-17	1
27683	1635	40481087	2007-11-25	2007-12-09	1
68720	4071	4112343	2011-04-09	2011-04-20	1
20159	1214	40481087	1992-05-21	1992-06-11	1
22847	1365	80180	2002-06-28	2002-06-29	1
52015	3083	4112343	1969-07-20	1969-08-01	1
44438	2646	4155034	1991-05-14	1991-05-28	1
4072	236	40481087	1974-06-12	1974-07-03	1
59779	3545	78272	2010-09-02	2010-10-07	1
32076	1906	40481087	1993-10-22	1993-11-11	1
77606	4603	4283893	1960-04-04	1961-03-06	1
78237	4637	4299128	2008-04-30	2008-05-14	1
31606	1874	378001	2014-08-03	2014-09-02	1
22648	1354	257012	2012-02-03	2012-02-04	1
22239	1328	4112343	1978-06-30	1978-07-08	1
24036	1435	40481087	1998-10-27	1998-11-03	1
37685	2237	40481087	1959-01-16	1959-01-23	1
43639	2602	4142905	2017-01-26	2017-04-26	1
85654	5101	4112343	1989-02-21	1989-03-02	1
51458	3057	28060	1949-01-08	1949-01-15	1
29261	1736	4283893	1975-10-11	1976-05-08	1
50566	2993	40481087	1994-11-29	1994-12-20	1
56102	3325	28060	1974-05-02	1974-05-14	1
84824	5049	4112343	1977-06-15	1977-06-28	1
30328	1791	81151	2006-06-13	2006-07-04	1
48834	2894	4112343	1996-02-06	1996-02-18	1
27900	1649	40481087	2003-08-09	2003-08-23	1
1723	99	4112343	2008-06-28	2008-07-08	1
52912	3135	40481087	2010-12-16	2010-12-30	1
27684	1635	30753	2011-02-26	2011-02-27	1
68721	4071	4113008	2003-06-24	2003-07-08	1
20160	1214	40481087	2008-12-20	2009-01-03	1
22848	1365	372328	1963-10-21	1963-11-28	1
52016	3083	4112343	1972-06-18	1972-06-26	1
44439	2646	40481087	1995-12-23	1996-01-13	1
4073	236	40481087	1994-03-27	1994-04-10	1
59780	3545	260139	1998-09-13	1998-09-20	1
32808	1950	28060	1952-10-10	1952-10-22	1
77607	4603	40481087	1937-10-14	1937-11-04	1
78238	4637	40481087	2000-09-15	2000-09-22	1
31607	1874	4109685	1978-05-18	1978-06-01	1
22649	1354	260139	1998-04-18	1998-05-02	1
22240	1328	4156265	2014-03-25	2014-04-15	1
24037	1435	40481087	2001-06-29	2001-07-13	1
37686	2237	40481087	1959-07-30	1959-08-13	1
43640	2602	4285898	1986-10-15	1986-10-16	1
85655	5101	4113008	2004-09-07	2004-09-28	1
51459	3057	372328	1950-10-12	1951-06-18	1
29262	1736	40481087	1976-06-16	1976-06-30	1
50567	2993	40481087	2001-02-23	2001-03-16	1
56103	3325	28060	1981-03-24	1981-04-03	1
84825	5049	4283893	1970-09-09	1970-09-23	1
30329	1791	260139	1963-05-14	1963-05-21	1
48835	2894	4218389	1929-11-08	1929-12-13	1
27901	1649	0	2017-08-23	2017-08-24	1
1724	99	4113008	2004-07-28	2004-08-18	1
52913	3135	257012	1976-08-29	1976-08-30	1
27685	1635	81151	1988-01-19	1988-02-16	1
68722	4071	4296204	1986-02-11	1986-03-04	1
20161	1214	40481087	2019-03-08	2019-03-22	1
22849	1365	4001336	1977-03-11	1977-04-10	1
52017	3083	4112343	1976-09-07	1976-09-19	1
44440	2646	4278672	1988-04-29	1988-07-28	1
4074	236	28060	1981-11-22	1981-12-04	1
59781	3545	372328	1973-01-21	1973-02-04	1
32809	1950	372328	1944-06-23	1944-08-17	1
77608	4603	40481087	2008-02-07	2008-02-28	1
78239	4637	28060	1980-04-20	1980-04-30	1
31608	1874	4112343	2014-12-22	2014-12-30	1
22650	1354	4152936	1980-01-27	1980-02-17	1
22241	1328	40481087	1967-06-25	1967-07-09	1
24038	1435	28060	1975-11-17	1975-11-24	1
37687	2237	40481087	1960-11-11	1960-11-18	1
43641	2602	4294548	1980-04-11	1980-08-29	1
85656	5101	40481087	1976-12-23	1977-01-06	1
51460	3057	381316	2016-10-24	2016-10-25	1
29263	1736	40481087	2007-01-12	2007-02-02	1
50568	2993	375671	1982-07-10	1982-08-09	1
59060	3508	260139	1971-12-20	1971-12-27	1
84826	5049	0	1998-02-18	1998-02-19	1
30330	1791	260139	1969-12-30	1970-01-13	1
48836	2894	40479422	1923-01-07	1923-02-13	1
27902	1649	4109685	1972-10-09	1972-10-30	1
1725	99	40481087	1962-05-04	1962-05-11	1
52914	3135	260139	1979-12-27	1980-01-03	1
27686	1635	321042	2013-03-27	2013-03-28	1
68723	4071	40481087	1964-08-27	1964-09-03	1
20162	1214	28060	1967-09-19	1967-09-29	1
22850	1365	4056621	1993-10-19	1993-10-20	1
52018	3083	4112343	1977-06-19	1977-07-02	1
46342	2764	80180	2009-10-09	2009-10-10	1
4075	236	80180	1990-10-28	1990-10-29	1
59782	3545	4112343	1991-02-19	1991-03-02	1
32810	1950	378001	1955-06-26	1955-08-25	1
77609	4603	28060	1970-05-17	1970-05-30	1
78240	4637	40481087	1993-01-16	1993-01-30	1
31609	1874	40481087	2010-10-28	2010-11-04	1
22651	1354	4237458	1995-05-29	1995-06-28	1
22242	1328	80180	1989-05-01	1989-05-02	1
24039	1435	4116491	1987-02-12	1987-04-06	1
37688	2237	40481087	1961-11-21	1961-12-12	1
43642	2602	40481087	1984-05-19	1984-06-09	1
85657	5101	40481087	1979-11-29	1979-12-06	1
51461	3057	4059173	2017-10-04	2017-12-03	1
29264	1736	40481087	2016-06-23	2016-07-14	1
50569	2993	4296205	2007-12-17	2008-01-07	1
59061	3508	260139	2013-03-10	2013-03-17	1
84827	5049	260139	1969-11-07	1969-11-21	1
30331	1791	260139	1988-06-07	1988-06-21	1
48837	2894	40479422	1997-02-13	1997-04-21	1
27903	1649	4112343	1976-06-03	1976-06-11	1
1726	99	28060	1972-01-30	1972-02-11	1
52915	3135	260139	2005-05-02	2005-05-09	1
27687	1635	4112343	1983-03-29	1983-04-06	1
68724	4071	40481087	1974-08-21	1974-09-11	1
20163	1214	260139	1954-02-17	1954-03-03	1
22851	1365	4112343	1965-11-10	1965-11-18	1
52019	3083	4218389	1979-06-29	1979-07-20	1
46343	2764	378001	1999-07-09	1999-09-07	1
4076	236	192671	1990-12-21	1990-12-22	1
59783	3545	40481087	2000-07-18	2000-08-08	1
32811	1950	40481087	1973-06-18	1973-07-09	1
77610	4603	81151	2000-11-22	2000-12-27	1
78241	4637	40481087	1998-01-31	1998-02-21	1
31610	1874	4109685	1987-04-15	1987-05-06	1
22652	1354	40481087	1993-03-15	1993-03-29	1
22243	1328	195588	1999-07-13	1999-08-14	1
24040	1435	40481087	1969-07-03	1969-07-10	1
37689	2237	40481087	1996-09-30	1996-10-21	1
43643	2602	0	1964-11-04	1964-11-05	1
85658	5101	40481087	2016-05-16	2016-06-06	1
51462	3057	4112343	1966-07-16	1966-07-24	1
29265	1736	195588	1985-05-04	1985-06-24	1
50570	2993	40481087	1974-11-25	1974-12-09	1
59062	3508	4230399	1966-08-08	1966-10-07	1
84828	5049	260139	1981-05-21	1981-06-04	1
30332	1791	4296205	1996-08-01	1996-09-05	1
48838	2894	40481087	1946-02-28	1946-03-14	1
27904	1649	28060	1963-08-29	1963-09-09	1
1727	99	80180	2000-01-03	2000-01-04	1
52916	3135	260139	2011-08-19	2011-08-26	1
27688	1635	4112343	2019-05-01	2019-05-14	1
68725	4071	260139	2003-12-07	2003-12-14	1
20164	1214	260139	1978-05-31	1978-06-14	1
22852	1365	4112343	1988-10-19	1988-10-31	1
52020	3083	4278672	1955-04-22	1955-07-21	1
46344	2764	439777	2015-08-14	2015-08-15	1
4077	236	260139	1985-05-02	1985-05-09	1
59784	3545	40481087	2011-07-21	2011-08-11	1
32812	1950	40481087	1989-07-06	1989-07-20	1
77611	4603	260139	1972-04-14	1972-04-28	1
78242	4637	80180	2013-04-01	2013-04-02	1
31611	1874	4112343	2010-12-15	2010-12-27	1
22653	1354	40481087	1994-01-02	1994-01-09	1
22244	1328	260139	1966-11-05	1966-11-12	1
24041	1435	40481087	1996-05-14	1996-06-04	1
37690	2237	40481087	2006-11-29	2006-12-13	1
43644	2602	80180	1986-11-14	1986-11-15	1
85659	5101	260139	1994-04-26	1994-05-03	1
51463	3057	40481087	1960-05-28	1960-06-18	1
29266	1736	195588	1990-11-03	1990-12-10	1
50571	2993	40481087	1990-02-23	1990-03-16	1
59063	3508	4230399	2019-05-02	2019-05-03	1
84829	5049	378001	1965-10-12	1965-11-11	1
30333	1791	40481087	1955-03-03	1955-03-24	1
51083	3028	0	1978-04-19	1978-04-20	1
27905	1649	260139	1960-03-18	1960-03-25	1
1728	99	81151	1959-08-21	1959-09-18	1
52917	3135	4112343	2008-10-13	2008-10-24	1
27689	1635	4266809	2012-02-21	2012-02-22	1
68726	4071	439777	2005-09-19	2005-09-20	1
20165	1214	260139	1985-06-06	1985-06-20	1
22853	1365	4116491	1994-11-27	1995-01-15	1
52021	3083	4278672	1964-02-04	1964-05-04	1
46345	2764	4285898	2009-09-09	2009-09-10	1
4078	236	372328	1952-09-25	1953-02-26	1
60627	3593	78272	2018-09-02	2018-09-30	1
32813	1950	40481087	2004-07-07	2004-07-21	1
77612	4603	4156265	2014-03-19	2014-04-09	1
78243	4637	260139	1988-05-09	1988-05-16	1
31612	1874	4112343	2011-01-27	2011-02-07	1
22654	1354	260139	1980-06-26	1980-07-03	1
22245	1328	260139	1987-12-25	1988-01-01	1
24042	1435	81151	2002-05-26	2002-06-30	1
37691	2237	40481087	2012-04-23	2012-05-14	1
43645	2602	260139	1972-10-17	1972-10-24	1
85660	5101	4218389	1991-02-20	1991-03-20	1
51464	3057	80502	1997-03-03	1997-03-04	1
29267	1736	260139	2006-07-15	2006-07-29	1
50572	2993	4112343	1987-08-22	1987-09-01	1
59064	3508	260139	1961-11-04	1961-11-11	1
84830	5049	440086	1971-01-29	1972-12-22	1
31711	1882	81151	1972-12-17	1973-01-21	1
51084	3028	30753	1999-01-08	1999-01-09	1
27906	1649	260139	1994-10-26	1994-11-02	1
1729	99	372328	1994-04-02	1995-12-23	1
52918	3135	4310024	2004-01-22	2004-01-23	1
27690	1635	4283893	1993-05-29	1993-06-26	1
68727	4071	4112343	1976-07-30	1976-08-07	1
20166	1214	4230399	1955-12-23	1956-01-22	1
22854	1365	4132546	1977-03-11	1977-03-12	1
52022	3083	4278672	2013-02-19	2013-04-20	1
46346	2764	40481087	1988-12-10	1988-12-17	1
4079	236	378001	1953-12-06	1954-01-05	1
60628	3593	4112343	1960-11-20	1960-11-27	1
32814	1950	80180	1978-12-17	1978-12-18	1
77613	4603	40481087	1973-07-29	1973-08-19	1
78244	4637	260139	2009-05-28	2009-06-04	1
31613	1874	260139	1987-06-22	1987-07-06	1
22655	1354	372328	1986-06-24	1987-04-17	1
22246	1328	372328	1945-12-23	1946-04-04	1
24043	1435	260139	1967-12-16	1967-12-30	1
37692	2237	30753	1966-03-22	1966-03-23	1
43646	2602	321042	1964-11-04	1964-11-05	1
85661	5101	4218389	2016-03-29	2016-05-03	1
51465	3057	372328	1938-07-28	1938-12-12	1
29268	1736	4142905	2010-07-02	2010-09-30	1
50573	2993	4155034	1989-02-03	1989-02-24	1
59065	3508	4294548	1978-12-10	1979-03-04	1
84831	5049	4112343	2002-05-03	2002-05-11	1
31712	1882	260139	1973-02-17	1973-03-03	1
51085	3028	80180	2000-07-01	2000-07-02	1
27907	1649	4329847	2017-08-23	2017-08-24	1
1730	99	4112343	1974-05-02	1974-05-15	1
52919	3135	40481087	1977-06-01	1977-06-15	1
27691	1635	80180	2012-02-21	2012-02-22	1
68728	4071	4112343	2010-03-01	2010-03-13	1
20167	1214	40481087	1970-06-16	1970-06-23	1
22855	1365	4142905	1967-05-03	1967-07-02	1
52023	3083	40481087	1962-10-25	1962-11-01	1
46347	2764	40481087	2008-09-14	2008-09-28	1
4080	236	4109685	2009-01-21	2009-02-11	1
60629	3593	4113008	1987-09-03	1987-09-24	1
32815	1950	80502	2011-01-06	2011-01-07	1
77614	4603	40481087	2015-12-25	2016-01-08	1
78245	4637	4112343	1990-07-21	1990-07-31	1
31614	1874	4112343	1986-08-08	1986-08-20	1
22656	1354	4112343	1980-02-28	1980-03-06	1
22247	1328	381316	2019-06-13	2019-06-14	1
24044	1435	260139	2016-09-11	2016-09-18	1
37693	2237	372328	1931-10-27	1932-04-17	1
43647	2602	372328	1948-11-28	1949-02-09	1
85662	5101	4230399	2002-12-17	2003-01-16	1
51466	3057	4112343	1941-09-24	1941-10-05	1
29269	1736	4294548	2001-04-12	2001-09-06	1
50574	2993	40481087	1971-03-19	1971-03-26	1
59066	3508	40481087	1984-02-15	1984-03-07	1
84832	5049	4218389	1993-08-16	1993-09-06	1
31713	1882	372328	1969-09-04	1969-10-18	1
51086	3028	372328	1964-08-24	1965-04-08	1
27908	1649	40481087	1979-01-31	1979-02-14	1
1731	99	40481087	1976-09-30	1976-10-14	1
53048	3145	80180	2010-12-03	2010-12-04	1
27692	1635	260139	1981-08-03	1981-08-17	1
68729	4071	40481087	2015-03-26	2015-04-16	1
20168	1214	40481087	1983-01-22	1983-02-12	1
22856	1365	40481087	1970-04-05	1970-04-12	1
52024	3083	40481087	1994-03-10	1994-03-24	1
46348	2764	260139	1977-04-07	1977-04-21	1
4081	236	4112343	1983-02-11	1983-02-19	1
60630	3593	4142905	1953-03-14	1953-04-13	1
32816	1950	81151	1956-06-20	1956-07-18	1
77615	4603	80180	1970-01-24	1970-01-25	1
78246	4637	4112343	1993-12-11	1993-12-19	1
31615	1874	4218389	2006-11-22	2006-12-13	1
22657	1354	40481087	2007-12-04	2007-12-25	1
22248	1328	4278672	1948-04-11	1948-07-10	1
24045	1435	4237458	1968-07-11	1968-10-09	1
37694	2237	4112343	1939-05-22	1939-05-30	1
43648	2602	381316	1985-09-04	1985-09-05	1
85663	5101	80180	1998-10-10	1998-10-11	1
51467	3057	4112343	1995-03-28	1995-04-10	1
29270	1736	40481087	1984-11-18	1984-12-09	1
50575	2993	40481087	2003-02-03	2003-02-17	1
59067	3508	260139	2010-12-25	2011-01-08	1
84833	5049	40481087	1998-10-10	1998-10-17	1
31714	1882	4296204	1999-03-06	1999-03-20	1
51087	3028	378001	1999-02-22	1999-04-23	1
27909	1649	40481087	1996-07-03	1996-07-10	1
1732	99	40481087	1979-11-05	1979-11-19	1
53049	3145	260139	2005-05-08	2005-05-15	1
27693	1635	372328	1975-05-06	1975-09-24	1
68730	4071	78272	1961-04-18	1961-05-23	1
20169	1214	40481087	1997-02-05	1997-02-26	1
22857	1365	28060	2007-11-22	2007-11-30	1
52025	3083	40481087	2010-03-05	2010-03-12	1
46349	2764	375671	2013-12-22	2014-01-21	1
4082	236	4112343	1988-02-10	1988-02-18	1
60631	3593	4285898	1988-01-30	1988-01-31	1
32817	1950	81151	1988-08-29	1988-09-19	1
77616	4603	81151	1940-09-23	1940-10-28	1
78247	4637	4155034	2011-12-25	2012-01-15	1
31616	1874	4283893	1978-12-20	1979-01-17	1
22658	1354	260139	1994-09-14	1994-09-28	1
22249	1328	4294548	1952-03-28	1952-05-09	1
24046	1435	4278672	2009-01-24	2009-04-24	1
37695	2237	4112343	1947-08-20	1947-08-30	1
43649	2602	4112343	2009-11-20	2009-11-27	1
85664	5101	260139	1973-08-23	1973-09-06	1
51468	3057	4278672	1966-12-28	1967-03-28	1
29271	1736	40481087	2016-08-21	2016-09-11	1
50576	2993	40481087	2015-05-20	2015-06-03	1
59068	3508	372328	1957-10-24	1958-02-05	1
84834	5049	40481087	2012-05-26	2012-06-02	1
31715	1882	40481087	1973-04-23	1973-04-30	1
51088	3028	440448	1978-04-19	1978-04-20	1
27910	1649	40481087	2011-02-18	2011-03-04	1
1733	99	40481087	1995-03-05	1995-03-19	1
53050	3145	440086	1980-08-27	1980-11-05	1
27694	1635	4027663	1999-10-12	1999-10-13	1
68731	4071	80180	1998-08-07	1998-08-08	1
20170	1214	40481087	2018-12-17	2018-12-31	1
22858	1365	260139	1978-06-05	1978-06-12	1
52026	3083	28060	1996-11-13	1996-11-24	1
46350	2764	4310024	2008-09-14	2008-09-15	1
4083	236	4112343	2003-07-30	2003-08-07	1
60632	3593	40481087	2008-08-11	2008-08-18	1
32818	1950	260139	1998-12-09	1998-12-16	1
77617	4603	257012	1960-06-27	1960-06-28	1
79489	4715	260139	1996-07-14	1996-07-28	1
31617	1874	40481087	2016-11-09	2016-11-30	1
22659	1354	4112343	2000-11-17	2000-11-24	1
22250	1328	40481087	1988-05-24	1988-06-07	1
24047	1435	40481087	1996-10-08	1996-10-29	1
37696	2237	4112343	1973-01-29	1973-02-06	1
43650	2602	40480160	2017-01-26	2017-04-26	1
85665	5101	372328	1962-02-01	1962-12-15	1
51469	3057	40481087	1945-01-01	1945-01-08	1
29272	1736	260139	1970-09-01	1970-09-08	1
53513	3175	28060	1954-02-25	1954-03-08	1
59069	3508	372328	1958-09-03	1958-11-05	1
86361	5145	0	2018-01-13	2018-01-14	1
31716	1882	260139	2018-10-20	2018-11-03	1
51089	3028	4112343	1968-05-06	1968-05-16	1
31201	1848	28060	1954-11-24	1954-12-06	1
1734	99	40481087	2012-01-12	2012-01-19	1
53051	3145	4112343	1973-04-19	1973-04-30	1
27695	1635	40481087	1996-05-16	1996-05-23	1
68732	4071	372328	1952-11-01	1953-01-08	1
23245	1389	260139	2008-09-10	2008-09-24	1
22859	1365	260139	1986-02-20	1986-02-27	1
52027	3083	4109685	2004-10-20	2004-11-03	1
46351	2764	40481087	2000-10-14	2000-11-04	1
4084	236	81151	2000-06-16	2000-07-07	1
60633	3593	80180	1988-02-29	1988-03-01	1
32819	1950	261325	1983-01-06	1983-01-07	1
77618	4603	260139	1931-02-14	1931-02-21	1
79490	4715	4027663	1984-07-31	1984-08-01	1
33368	1982	372328	1927-06-25	1927-08-11	1
22660	1354	4294548	2011-11-25	2012-03-30	1
22251	1328	28060	1973-04-11	1973-04-23	1
25454	1517	28060	1996-04-27	1996-05-05	1
37697	2237	4218389	1943-10-29	1943-11-19	1
43651	2602	40481087	1956-05-27	1956-06-03	1
85666	5101	4112343	1999-12-09	1999-12-22	1
51470	3057	40481087	1975-08-04	1975-08-18	1
29273	1736	260139	2011-10-24	2011-11-07	1
53514	3175	28060	1999-05-16	1999-05-28	1
59070	3508	372328	1961-09-20	1961-11-08	1
86362	5145	4112343	1967-10-08	1967-10-18	1
31717	1882	4112343	1973-07-16	1973-07-27	1
51090	3028	4112343	1990-04-05	1990-04-18	1
31202	1848	80180	1982-09-25	1982-09-26	1
2421	143	260139	1982-10-29	1982-11-12	1
53052	3145	4155034	2001-12-15	2002-01-05	1
27696	1635	40481087	2019-01-18	2019-02-01	1
68733	4071	4112343	1989-06-14	1989-06-22	1
23246	1389	372328	1955-07-03	1955-08-13	1
22860	1365	260139	1993-10-19	1993-11-02	1
52028	3083	4112343	2011-02-23	2011-03-02	1
46352	2764	40481087	2003-02-01	2003-02-08	1
4085	236	372328	1951-09-18	1951-11-29	1
60634	3593	192671	1988-03-27	1988-03-28	1
32820	1950	40481087	2003-06-16	2003-07-07	1
77619	4603	4112343	1996-09-24	1996-10-03	1
79491	4715	4283893	1957-05-12	1957-06-30	1
33369	1982	4109685	1960-07-08	1960-07-29	1
22661	1354	40481087	1978-05-13	1978-06-03	1
22252	1328	4112343	1950-05-03	1950-05-16	1
25455	1517	81151	1945-02-22	1945-03-08	1
37698	2237	4230399	2005-10-29	2005-12-28	1
43652	2602	40481087	1959-09-21	1959-09-28	1
85667	5101	4116491	1995-12-20	1996-01-25	1
55228	3275	80180	1992-02-21	1992-02-22	1
29274	1736	372328	1974-04-12	1975-04-24	1
53515	3175	372328	1959-08-09	1959-11-10	1
59071	3508	80180	1995-11-09	1995-11-10	1
86363	5145	4113008	1968-04-04	1968-04-25	1
31718	1882	4278672	1971-09-24	1971-12-23	1
51091	3028	4112343	2001-06-22	2001-06-30	1
31203	1848	195588	1981-10-12	1981-11-14	1
2422	143	260139	2000-08-16	2000-08-23	1
53053	3145	40481087	2018-02-23	2018-03-16	1
28362	1679	28060	2012-06-30	2012-07-13	1
68734	4071	4112343	1994-09-09	1994-09-20	1
23247	1389	4059173	1962-04-27	1962-06-26	1
22861	1365	372328	1975-10-26	1976-09-16	1
52029	3083	4155034	1952-02-23	1952-03-08	1
46353	2764	372328	1977-12-01	1978-04-21	1
4086	236	372328	1956-06-10	1957-03-07	1
60635	3593	313217	2017-06-14	2017-06-15	1
32821	1950	40481087	2018-08-28	2018-09-11	1
77620	4603	4237458	2004-09-07	2004-10-07	1
79492	4715	40481087	1976-09-24	1976-10-01	1
33370	1982	4142905	2004-05-01	2004-07-30	1
22662	1354	40481087	1982-02-19	1982-03-12	1
22253	1328	4112343	1951-11-09	1951-11-17	1
25456	1517	440086	1944-10-30	1947-11-10	1
37699	2237	78272	1990-02-15	1990-03-22	1
43653	2602	28060	1994-11-15	1994-11-25	1
85668	5101	40481087	2008-11-11	2008-11-18	1
55229	3275	195588	1997-03-31	1997-05-08	1
29275	1736	4056621	1989-09-20	1989-09-21	1
53516	3175	4112343	1993-04-04	1993-04-15	1
59072	3508	257012	1979-02-25	1979-02-26	1
86364	5145	4237458	2001-11-26	2002-01-25	1
31719	1882	260139	1987-06-13	1987-06-20	1
51092	3028	4266809	2000-07-01	2000-07-02	1
31204	1848	260139	2010-01-24	2010-02-07	1
2423	143	40481087	1965-01-09	1965-01-30	1
53054	3145	260139	1987-09-01	1987-09-08	1
28363	1679	4112343	1975-06-15	1975-06-22	1
68735	4071	4294548	1986-07-23	1986-11-05	1
23248	1389	4112343	1966-06-22	1966-07-04	1
22862	1365	440086	1977-08-18	1980-10-16	1
52030	3083	4156265	1969-09-05	1969-09-19	1
46354	2764	4027663	2003-08-17	2003-08-18	1
4087	236	4112343	1982-11-01	1982-11-10	1
60636	3593	4112343	1957-06-25	1957-07-06	1
32822	1950	28060	1951-04-08	1951-04-17	1
77621	4603	4278672	2018-01-18	2018-03-19	1
79493	4715	40481087	2010-05-03	2010-05-24	1
33371	1982	4149245	1957-05-18	1957-07-24	1
22663	1354	40481087	1984-07-04	1984-07-11	1
22254	1328	4112343	1956-04-27	1956-05-09	1
25457	1517	40481087	2014-08-04	2014-08-11	1
37700	2237	260139	1968-02-05	1968-02-19	1
43654	2602	260139	1948-11-30	1948-12-14	1
87205	5197	81151	1959-03-21	1959-04-25	1
55230	3275	4112343	1967-08-18	1967-08-26	1
29276	1736	40481087	1980-08-13	1980-08-20	1
53517	3175	40481087	1957-07-11	1957-07-25	1
59073	3508	260139	1996-03-21	1996-03-28	1
86365	5145	4296205	1979-08-26	1979-09-23	1
31720	1882	4112343	2016-12-21	2017-01-03	1
51093	3028	4283893	1999-11-10	2000-02-02	1
31205	1848	4116491	1975-09-07	1975-10-14	1
2424	143	372328	1965-11-26	1966-01-09	1
53055	3145	372328	1975-04-06	1975-08-10	1
28364	1679	40481087	2013-04-04	2013-04-18	1
68736	4071	40481087	2008-10-06	2008-10-20	1
23249	1389	4112343	1981-05-01	1981-05-13	1
22863	1365	4142905	1974-02-25	1974-05-26	1
52031	3083	4156265	1997-02-15	1997-03-01	1
46355	2764	40481087	1994-04-26	1994-05-10	1
4088	236	4112343	1987-09-29	1987-10-11	1
60637	3593	4112343	1974-06-08	1974-06-19	1
32823	1950	372328	1944-11-15	1945-05-03	1
77622	4603	4296204	1959-07-21	1959-08-18	1
79494	4715	28060	1983-12-26	1984-01-08	1
33372	1982	40481087	1925-01-01	1925-01-22	1
22664	1354	40481087	1988-07-26	1988-08-16	1
24304	1450	80180	1996-03-19	1996-03-20	1
25458	1517	80180	1981-04-09	1981-04-10	1
37701	2237	372328	1933-09-09	1933-10-22	1
43655	2602	4112343	1958-06-13	1958-06-23	1
87206	5197	81151	1987-07-27	1987-08-10	1
55231	3275	4112343	1982-03-24	1982-04-03	1
29277	1736	40481087	2000-01-26	2000-02-09	1
53518	3175	28060	1987-02-12	1987-02-22	1
59074	3508	40481087	2014-01-07	2014-01-14	1
86366	5145	40481087	1986-10-28	1986-11-04	1
31721	1882	4113008	2010-06-20	2010-07-04	1
51094	3028	40481087	1976-02-29	1976-03-21	1
31206	1848	40481087	2011-04-03	2011-04-24	1
2425	143	4112343	1988-06-14	1988-06-27	1
53056	3145	40481087	1974-11-14	1974-11-28	1
28365	1679	260139	2019-02-17	2019-02-24	1
69771	4133	80180	2009-10-10	2009-10-11	1
23250	1389	4112343	1995-02-01	1995-02-11	1
22864	1365	40481087	1974-10-25	1974-11-01	1
52032	3083	40481087	1963-02-07	1963-02-14	1
46356	2764	40481087	2011-05-21	2011-05-28	1
4089	236	4310024	1988-11-07	1988-11-08	1
60638	3593	4112343	1985-01-02	1985-01-11	1
32824	1950	4112343	1978-05-10	1978-05-23	1
77623	4603	40481087	1955-03-12	1955-03-26	1
79495	4715	28060	2017-09-05	2017-09-13	1
33373	1982	40481087	1928-08-13	1928-08-27	1
22665	1354	40481087	2009-11-23	2009-11-30	1
24305	1450	81151	1976-01-09	1976-01-30	1
25459	1517	260139	1984-11-25	1984-12-02	1
37702	2237	4218389	1940-08-10	1940-09-14	1
43656	2602	4112343	1998-04-11	1998-04-20	1
87207	5197	192671	1995-11-12	1995-11-13	1
55232	3275	4112343	2012-01-27	2012-02-04	1
29278	1736	40481087	2004-05-31	2004-06-21	1
53519	3175	4112343	1954-05-09	1954-05-22	1
62916	3720	81893	1988-08-20	1988-08-21	1
86367	5145	40481087	1990-01-23	1990-02-06	1
31722	1882	40486433	1970-08-17	1987-08-15	1
51095	3028	192671	2000-08-07	2000-08-08	1
31207	1848	30753	1981-10-30	1981-10-31	1
2426	143	40481087	2007-12-18	2008-01-08	1
53057	3145	40481087	1975-11-02	1975-11-23	1
28366	1679	372328	1971-10-20	1972-03-07	1
69772	4133	378001	1982-07-13	1982-09-11	1
23251	1389	4278672	1965-03-12	1965-06-10	1
22865	1365	40481087	1975-11-04	1975-11-18	1
52033	3083	40481087	1975-07-20	1975-08-03	1
47922	2847	28060	1989-11-12	1989-11-19	1
4090	236	40481087	1957-05-28	1957-06-04	1
60639	3593	4218389	2017-08-17	2017-09-07	1
32825	1950	4112343	1982-12-31	1983-01-11	1
77624	4603	40481087	1990-08-18	1990-08-25	1
79496	4715	80180	1995-01-14	1995-01-15	1
33374	1982	40481087	1941-10-07	1941-10-28	1
24233	1446	78272	2003-10-17	2003-11-21	1
24306	1450	260139	1999-11-03	1999-11-17	1
25460	1517	4035415	2013-02-09	2013-03-11	1
37703	2237	4285898	1966-11-17	1966-11-18	1
43657	2602	4310024	1985-10-20	1985-10-21	1
87208	5197	260139	1954-06-17	1954-06-24	1
55233	3275	4156265	1985-10-25	1985-11-08	1
30713	1819	257012	1977-08-28	1977-08-29	1
53520	3175	4112343	1957-01-07	1957-01-16	1
62917	3720	260139	1967-01-07	1967-01-14	1
86368	5145	40481087	1998-12-26	1999-01-02	1
31723	1882	80180	2004-07-22	2004-07-23	1
51096	3028	4112343	1987-11-04	1987-11-16	1
31208	1848	260139	1978-07-07	1978-07-21	1
2427	143	40481087	2014-04-13	2014-04-27	1
53058	3145	40481087	1991-05-13	1991-06-03	1
28367	1679	372328	1973-06-30	1973-09-04	1
69773	4133	4112343	1992-06-19	1992-07-01	1
23252	1389	40481087	1965-04-18	1965-04-25	1
26378	1567	80180	2008-05-06	2008-05-07	1
52034	3083	40481087	1983-11-24	1983-12-15	1
47923	2847	260139	1985-06-12	1985-06-26	1
4091	236	372328	1952-01-28	1952-02-28	1
60640	3593	260139	1961-09-29	1961-10-13	1
32826	1950	4230399	2016-01-26	2016-03-26	1
77625	4603	40481087	1993-05-16	1993-05-30	1
79497	4715	81893	1993-09-22	1993-09-23	1
33375	1982	40481087	1950-07-20	1950-07-27	1
24234	1446	372328	1984-09-08	1984-10-09	1
24307	1450	375671	2017-03-16	2017-05-15	1
25461	1517	4112343	1985-02-08	1985-02-21	1
37704	2237	4294548	2013-12-14	2014-01-11	1
43658	2602	40481087	1961-01-28	1961-02-11	1
87209	5197	260139	1964-08-24	1964-09-07	1
55234	3275	260139	1993-04-02	1993-04-09	1
30714	1819	4112343	2013-12-04	2013-12-14	1
53521	3175	40481087	2009-09-13	2009-09-27	1
62918	3720	4112343	1980-12-01	1980-12-10	1
86369	5145	80180	1991-04-24	1991-04-25	1
31724	1882	260139	1985-11-27	1985-12-11	1
51097	3028	4112343	2018-07-03	2018-07-12	1
31209	1848	313217	2011-02-17	2011-02-18	1
2428	143	40481087	2016-01-12	2016-01-19	1
53059	3145	40481087	2012-12-08	2012-12-15	1
28368	1679	372328	1974-01-02	1974-08-20	1
69774	4133	4112343	2018-11-25	2018-12-04	1
23253	1389	28060	2012-03-28	2012-04-04	1
26379	1567	260139	2014-09-15	2014-09-29	1
54252	3217	260139	1993-08-13	1993-08-27	1
47924	2847	378001	1996-08-05	1996-09-04	1
4092	236	4283893	2004-04-26	2004-10-04	1
60641	3593	4027663	1977-03-13	1977-03-14	1
32827	1950	40481087	1964-04-14	1964-04-28	1
77626	4603	40481087	1998-05-09	1998-05-23	1
79498	4715	260139	1985-01-07	1985-01-14	1
33376	1982	40481087	1960-12-06	1960-12-13	1
24235	1446	4112343	2004-01-05	2004-01-15	1
24308	1450	40481087	2013-05-20	2013-06-03	1
25462	1517	40481087	1985-11-16	1985-12-07	1
37705	2237	40481087	1938-11-28	1938-12-12	1
43659	2602	40481087	1986-05-08	1986-05-22	1
87210	5197	260139	1966-09-28	1966-10-05	1
55235	3275	260139	2002-06-01	2002-06-15	1
30715	1819	40481087	1990-01-17	1990-01-31	1
53522	3175	260139	1989-11-17	1989-11-24	1
62919	3720	4285898	1989-11-13	1989-11-14	1
86370	5145	260139	2000-02-18	2000-02-25	1
31725	1882	4112343	1991-10-22	1991-11-02	1
51098	3028	4027663	1993-04-14	1993-04-15	1
31210	1848	378001	1953-04-30	1953-05-30	1
2429	143	28060	1979-05-20	1979-05-29	1
53060	3145	4001336	1990-12-13	1991-02-11	1
28369	1679	4112343	1991-10-10	1991-10-19	1
69775	4133	40481087	1993-09-19	1993-09-26	1
23254	1389	80180	1997-07-12	1997-07-13	1
26380	1567	4048171	1980-01-01	1980-01-02	1
54253	3217	4109685	1992-01-19	1992-02-09	1
47925	2847	4112343	1968-04-14	1968-04-23	1
4093	236	4285898	1990-04-01	1990-04-02	1
60642	3593	4112343	1966-09-08	1966-09-17	1
32828	1950	40481087	1985-08-13	1985-09-03	1
77627	4603	40481087	2018-08-30	2018-09-13	1
79499	4715	4001336	1951-08-04	1951-09-03	1
33377	1982	28060	1992-10-26	1992-11-05	1
24236	1446	80180	2017-08-09	2017-08-10	1
24309	1450	260139	1991-12-31	1992-01-14	1
25463	1517	40481087	2006-02-27	2006-03-20	1
37706	2237	28060	1955-10-18	1955-10-31	1
43660	2602	40481087	1991-05-01	1991-05-08	1
87211	5197	260139	1986-10-21	1986-11-04	1
55236	3275	4112343	1971-02-07	1971-02-16	1
30716	1819	78272	2007-02-14	2007-03-14	1
53523	3175	4112343	1992-07-28	1992-08-06	1
62920	3720	40481087	1977-10-30	1977-11-20	1
86371	5145	321042	2018-01-13	2018-01-14	1
31726	1882	4278672	2015-04-09	2015-05-09	1
51099	3028	40481087	1974-12-07	1974-12-28	1
31211	1848	378001	1959-04-20	1959-06-19	1
2430	143	80180	1999-01-17	1999-01-18	1
53061	3145	4142905	1974-05-11	1974-06-10	1
28370	1679	4112343	2000-03-06	2000-03-17	1
69776	4133	260139	2005-05-02	2005-05-16	1
23255	1389	378001	1997-03-24	1997-04-23	1
26381	1567	4112343	1989-10-07	1989-10-14	1
54254	3217	4109685	1998-05-08	1998-05-29	1
47926	2847	4112343	1975-07-20	1975-07-27	1
7151	421	80180	2001-04-28	2001-04-29	1
60643	3593	40481087	1973-06-21	1973-07-05	1
32829	1950	195588	1966-09-06	1966-10-30	1
77628	4603	28060	1931-05-18	1931-05-26	1
79500	4715	4152936	2008-09-03	2008-09-17	1
33378	1982	80180	1963-08-05	1963-08-06	1
24237	1446	372328	1985-06-06	1985-10-08	1
24310	1450	372328	1965-01-13	1965-04-18	1
25464	1517	313217	2017-04-17	2017-04-18	1
37707	2237	80180	1967-01-16	1967-01-17	1
45890	2736	80180	2015-07-11	2015-07-12	1
87212	5197	40481087	1969-08-02	1969-08-09	1
55237	3275	4134304	1973-09-28	1973-11-27	1
30717	1819	80180	2014-08-28	2014-08-29	1
53524	3175	4156265	1993-12-24	1994-01-07	1
62921	3720	40481087	2001-06-30	2001-07-14	1
86372	5145	372328	1958-06-26	1958-08-16	1
31727	1882	4294548	2007-07-09	2007-07-16	1
51100	3028	40481087	2004-08-08	2004-08-15	1
31212	1848	4112343	1983-07-23	1983-08-01	1
2431	143	4112343	1990-02-20	1990-03-03	1
53062	3145	40481087	1984-04-15	1984-05-06	1
28371	1679	4155034	2013-03-27	2013-04-17	1
69777	4133	4113008	2012-07-10	2012-07-31	1
23256	1389	4112343	1959-07-16	1959-07-26	1
26382	1567	4112343	2017-01-15	2017-01-27	1
54255	3217	40481087	1987-03-25	1987-04-08	1
47927	2847	4218389	1973-06-13	1973-07-11	1
7152	421	372328	1966-07-11	1966-08-24	1
60644	3593	40481087	2003-11-18	2003-11-25	1
32830	1950	260139	2017-02-03	2017-02-10	1
77629	4603	4112343	1939-12-13	1939-12-22	1
79501	4715	4310024	1993-02-23	1993-02-24	1
33379	1982	260139	1960-02-14	1960-02-21	1
24238	1446	4112343	1993-05-22	1993-06-03	1
24311	1450	378001	1990-09-13	1990-10-13	1
25465	1517	380378	1949-10-29	1949-10-30	1
37708	2237	260139	1936-05-05	1936-05-12	1
45891	2736	372328	1974-06-24	1974-07-17	1
87213	5197	40481087	1974-01-23	1974-02-13	1
55238	3275	40481087	1960-06-13	1960-07-04	1
30718	1819	372328	1999-09-26	1999-10-10	1
53525	3175	4218389	1996-10-23	1996-11-27	1
62922	3720	40481087	2008-02-13	2008-03-05	1
86373	5145	372328	1999-02-08	1999-03-27	1
31728	1882	40481087	1991-10-02	1991-10-23	1
51101	3028	260139	2010-05-27	2010-06-03	1
31213	1848	4112343	2004-04-24	2004-05-01	1
2432	143	4218389	1979-06-16	1979-07-07	1
53063	3145	40481087	1989-09-07	1989-09-14	1
28372	1679	4310024	2008-03-19	2008-03-20	1
69778	4133	4296205	1978-05-21	1978-06-04	1
23257	1389	40481087	1989-04-05	1989-04-19	1
26383	1567	40481087	1986-07-09	1986-07-16	1
54256	3217	80180	2018-10-14	2018-10-15	1
47928	2847	40481087	1990-07-09	1990-07-23	1
7153	421	4296204	1972-03-10	1972-03-31	1
60645	3593	40481087	2004-04-01	2004-04-08	1
32831	1950	375671	1967-11-18	1968-01-17	1
77630	4603	4156265	1982-04-17	1982-05-01	1
79502	4715	40481087	1970-05-01	1970-05-22	1
33380	1982	317576	1976-09-23	1976-09-24	1
24239	1446	4152936	2008-09-25	2008-10-16	1
24312	1450	4112343	2011-05-24	2011-06-03	1
25466	1517	4029498	1949-10-29	1949-10-30	1
37709	2237	260139	1960-06-15	1960-06-29	1
45892	2736	4112343	1976-05-04	1976-05-15	1
87214	5197	40481087	1976-05-10	1976-05-31	1
55239	3275	40481087	1977-03-14	1977-04-04	1
30719	1819	375671	2014-10-03	2014-12-02	1
53526	3175	40481087	1994-08-07	1994-08-28	1
62923	3720	28060	2002-09-02	2002-09-13	1
86374	5145	4112343	1996-06-20	1996-06-29	1
36397	2156	257012	1984-01-10	1994-07-10	1
51102	3028	313217	2007-05-17	2007-05-18	1
31214	1848	4266809	1982-09-25	1982-09-26	1
2433	143	372328	2001-04-05	2002-03-10	1
53064	3145	4278672	1976-03-01	1976-05-30	1
28373	1679	40481087	1978-02-23	1978-03-16	1
69779	4133	4310024	2008-03-19	2008-03-20	1
23258	1389	40481087	1991-05-17	1991-06-07	1
26384	1567	40481087	1991-05-27	1991-06-03	1
54257	3217	260139	1995-12-24	1995-12-31	1
47929	2847	40481087	1994-09-08	1994-09-29	1
7154	421	4296204	1999-07-09	1999-07-30	1
60646	3593	40481087	2006-11-30	2006-12-14	1
32832	1950	4112343	1945-04-23	1945-05-06	1
77631	4603	4218389	1969-10-24	1969-11-21	1
79503	4715	260139	2004-09-27	2004-10-04	1
33381	1982	4142905	1997-02-07	1997-05-08	1
24240	1446	372328	1984-03-30	1984-07-10	1
24313	1450	4218389	1965-11-27	1966-01-01	1
25467	1517	4112343	1954-09-04	1954-09-15	1
37710	2237	260139	2001-11-01	2001-11-15	1
45893	2736	4112343	2004-11-16	2004-11-24	1
87215	5197	40481087	1996-12-14	1996-12-21	1
55240	3275	40481087	1977-05-12	1977-05-19	1
30720	1819	4112343	2009-01-08	2009-01-17	1
53527	3175	80180	1999-05-02	1999-05-03	1
62924	3720	80180	1990-06-11	1990-06-12	1
86375	5145	40481087	1970-12-19	1971-01-02	1
36398	2156	4112343	2005-10-28	2005-11-04	1
51103	3028	40481087	1981-01-02	1981-01-23	1
31215	1848	40481087	1947-04-10	1947-04-17	1
2434	143	378001	1975-09-05	1975-11-04	1
53065	3145	40481087	1988-10-19	1988-11-02	1
28374	1679	40481087	1983-11-11	1983-11-18	1
69780	4133	40481087	1977-03-04	1977-03-11	1
23259	1389	40481087	1999-07-03	1999-07-24	1
26385	1567	40481087	2009-12-20	2010-01-10	1
54258	3217	260139	2006-06-09	2006-06-16	1
47930	2847	260139	1989-12-20	1990-01-03	1
7155	421	4059173	1977-09-02	1977-10-02	1
60647	3593	28060	1965-04-06	1965-04-15	1
32833	1950	40480160	2016-01-26	2016-03-26	1
77632	4603	40480160	2018-01-18	2018-03-19	1
79504	4715	4112343	1962-07-09	1962-07-16	1
33382	1982	4296204	1993-03-09	1993-03-30	1
24241	1446	378001	1992-05-17	1992-07-16	1
24314	1450	40481087	1969-06-16	1969-06-30	1
25468	1517	4112343	2017-12-15	2017-12-26	1
37711	2237	317576	2005-12-04	2005-12-05	1
45894	2736	4294548	1981-09-07	1982-11-01	1
87216	5197	80180	1995-09-28	1995-09-29	1
55241	3275	40481087	1981-09-02	1981-09-16	1
30721	1819	4283893	1977-07-31	1977-10-16	1
53528	3175	260139	2010-07-09	2010-07-23	1
62925	3720	81151	1957-02-19	1957-03-12	1
86376	5145	257012	2001-02-01	2001-02-02	1
36399	2156	4112343	2011-08-08	2011-08-16	1
51104	3028	40481087	1994-03-21	1994-04-04	1
31216	1848	40481087	1970-09-22	1970-09-29	1
2435	143	4218389	2004-08-24	2004-09-28	1
53066	3145	40481087	2001-09-15	2001-09-29	1
28375	1679	40481087	2004-06-27	2004-07-11	1
69781	4133	40481087	1999-01-04	1999-01-18	1
23260	1389	28060	1967-06-01	1967-06-10	1
26386	1567	4112343	1981-02-07	1981-02-17	1
54259	3217	40481087	2017-02-04	2017-02-25	1
47931	2847	260139	2009-06-09	2009-06-23	1
7156	421	40481087	1990-02-27	1990-03-13	1
60648	3593	81893	1987-06-04	1987-06-05	1
32834	1950	40481087	1986-04-10	1986-04-17	1
77633	4603	40481087	1964-02-25	1964-03-10	1
79505	4715	4112343	2014-08-30	2014-09-07	1
33383	1982	40481087	1940-11-25	1940-12-02	1
24242	1446	4112343	2002-04-01	2002-04-14	1
24315	1450	40481087	1997-05-13	1997-06-03	1
25469	1517	40481087	1955-10-05	1955-10-12	1
37712	2237	4112343	1966-06-20	1966-07-01	1
45895	2736	40481087	2016-01-12	2016-01-19	1
87217	5197	196456	1962-06-05	1962-06-06	1
55242	3275	40481087	1984-08-07	1984-08-21	1
30722	1819	40481087	2008-08-14	2008-08-28	1
53529	3175	372328	1954-11-19	1955-02-01	1
62926	3720	260139	1957-11-17	1957-11-24	1
86377	5145	372328	1959-03-14	1959-08-15	1
36400	2156	4134304	1988-04-18	1988-06-17	1
51105	3028	40481087	2004-02-19	2004-03-04	1
31217	1848	40481087	1979-11-16	1979-11-23	1
2436	143	4278672	1981-04-27	1981-05-27	1
54629	3237	78272	1959-01-16	1959-01-30	1
28376	1679	28060	1974-08-06	1974-08-17	1
69782	4133	40481087	2002-09-05	2002-09-19	1
23261	1389	260139	1956-10-27	1956-11-10	1
26387	1567	4156265	1990-07-05	1990-07-26	1
54260	3217	4112343	1989-07-06	1989-07-17	1
47932	2847	4112343	2016-05-19	2016-05-30	1
7157	421	192671	2001-07-24	2001-07-25	1
60649	3593	260139	1974-06-17	1974-07-01	1
32835	1950	40481087	2008-11-05	2008-11-12	1
77634	4603	40481087	1989-06-01	1989-06-15	1
79506	4715	4112343	2016-12-27	2017-01-06	1
33384	1982	40481087	1987-09-29	1987-10-20	1
24243	1446	378001	2005-11-10	2006-01-09	1
24316	1450	260139	1970-03-08	1970-03-15	1
25470	1517	40481087	1968-12-02	1968-12-09	1
37713	2237	4116491	1968-11-01	1968-12-17	1
45896	2736	4109685	2019-05-16	2019-06-06	1
87218	5197	198809	1962-06-05	1962-06-06	1
55243	3275	40481087	1994-07-09	1994-07-16	1
30723	1819	40481087	2013-03-14	2013-04-04	1
53530	3175	375671	1978-05-17	1978-06-16	1
62927	3720	372328	1954-07-05	1954-09-14	1
86378	5145	372328	1960-11-07	1961-08-26	1
36401	2156	40481087	1992-09-27	1992-10-04	1
51784	3074	28060	1952-08-01	1952-08-11	1
31218	1848	192671	1982-10-10	1982-10-11	1
2437	143	40481087	1991-11-17	1991-12-08	1
54630	3237	81151	1951-08-21	1951-09-04	1
28377	1679	4156265	1973-09-09	1973-09-23	1
69783	4133	40481087	2012-07-04	2012-07-11	1
23262	1389	260139	1972-08-15	1972-08-22	1
26388	1567	40481087	2003-10-04	2003-10-18	1
54261	3217	4112343	1993-07-27	1993-08-03	1
47933	2847	4283893	1965-09-14	1965-11-23	1
7158	421	4112343	1970-03-23	1970-04-04	1
60650	3593	372328	1957-12-18	1958-03-05	1
32836	1950	40481087	2013-01-27	2013-02-17	1
79281	4701	260139	1991-02-01	1991-02-15	1
79507	4715	4285898	1994-11-15	1994-11-16	1
33385	1982	0	2006-10-19	2006-10-20	1
24244	1446	4112343	1987-10-12	1987-10-20	1
24317	1450	260139	2015-11-24	2015-12-08	1
25471	1517	0	1949-10-29	1949-10-30	1
37714	2237	40480160	2005-10-29	2005-12-28	1
45897	2736	40481087	1975-04-16	1975-05-07	1
87219	5197	260139	1960-11-20	1960-12-04	1
55244	3275	195588	2003-05-07	2003-06-24	1
30724	1819	81151	1991-06-10	1991-07-08	1
53531	3175	4112343	2009-09-03	2009-09-15	1
62928	3720	4027663	1980-03-30	1980-03-31	1
86379	5145	4056621	1978-12-02	1978-12-03	1
36402	2156	40481087	2008-10-17	2008-10-24	1
51785	3074	257012	1975-05-08	1975-05-09	1
31219	1848	372328	1962-04-13	1962-09-20	1
2438	143	40481087	2006-05-01	2006-05-22	1
54631	3237	81151	1954-06-20	1954-07-11	1
28378	1679	4266809	2009-06-12	2009-06-13	1
69784	4133	40481087	2019-02-13	2019-02-27	1
23263	1389	439777	1962-03-03	1962-03-04	1
26389	1567	40481087	2010-06-15	2010-06-22	1
54262	3217	28060	1997-04-18	1997-04-27	1
47934	2847	4294548	1963-10-12	1963-11-23	1
7159	421	4112343	1996-05-22	1996-06-02	1
60651	3593	4109685	1984-01-01	1984-01-22	1
35375	2098	4283893	2007-08-28	2008-07-22	1
79282	4701	372328	1973-12-22	1974-05-03	1
79508	4715	40481087	1999-03-27	1999-04-03	1
33386	1982	28060	1954-01-14	1954-01-27	1
24245	1446	4112343	1997-02-15	1997-02-23	1
24318	1450	372328	1963-10-09	1964-01-19	1
25472	1517	4035415	1998-04-29	1998-05-29	1
37715	2237	40481087	1958-01-06	1958-01-13	1
45898	2736	40481087	2000-04-27	2000-05-18	1
87220	5197	4027663	1984-04-13	1984-04-14	1
55245	3275	260139	1996-10-21	1996-11-04	1
30725	1819	195588	2006-05-17	2006-07-06	1
53532	3175	4116491	2006-11-11	2006-12-24	1
62929	3720	4112343	1975-06-16	1975-06-27	1
86380	5145	4112343	1977-05-02	1977-05-09	1
36403	2156	192671	2009-05-07	2009-05-08	1
51786	3074	260139	1968-04-07	1968-04-21	1
31220	1848	375671	1988-07-16	1988-08-15	1
2439	143	40481087	2014-09-03	2014-09-10	1
54632	3237	375671	1964-08-31	1964-09-30	1
28379	1679	4278672	1989-07-01	1989-09-29	1
69785	4133	81893	2008-05-18	2008-05-19	1
23264	1389	40481087	1982-03-27	1982-04-17	1
26390	1567	40481087	2016-04-10	2016-04-17	1
54263	3217	260139	1999-07-28	1999-08-11	1
47935	2847	40481087	1962-10-17	1962-10-24	1
7160	421	40481087	1980-11-30	1980-12-07	1
60652	3593	4112343	1980-06-19	1980-06-26	1
35376	2098	40481087	2013-11-29	2013-12-13	1
79283	4701	4112343	2010-03-24	2010-03-31	1
79509	4715	40481087	2009-01-15	2009-01-29	1
33387	1982	81151	1961-06-24	1961-07-29	1
24246	1446	4112343	2010-09-11	2010-09-18	1
24319	1450	372328	1966-02-12	1966-04-17	1
25473	1517	40481087	1940-10-24	1940-11-07	1
37716	2237	40481087	1971-12-29	1972-01-12	1
45899	2736	257012	1981-11-16	1981-11-17	1
87221	5197	4094814	1972-09-13	1972-11-12	1
55246	3275	4112343	1965-06-16	1965-06-28	1
30726	1819	40481087	1994-12-11	1994-12-18	1
53533	3175	4237458	1995-02-01	1995-03-03	1
62930	3720	4142905	1979-01-16	1979-02-15	1
86381	5145	4112343	1981-02-21	1981-03-01	1
36404	2156	195588	2008-07-12	2008-08-24	1
51787	3074	4112343	1962-05-25	1962-06-04	1
31221	1848	4112343	1989-11-29	1989-12-08	1
4314	249	28060	2013-07-21	2013-08-01	1
54633	3237	4109685	1928-05-02	1928-05-23	1
28380	1679	40481087	1973-11-16	1973-12-07	1
69786	4133	260139	1985-04-15	1985-04-22	1
23265	1389	40481087	1986-01-05	1986-01-12	1
26391	1567	28060	1980-07-29	1980-08-08	1
54264	3217	4112343	2006-12-08	2006-12-19	1
47936	2847	40481087	1962-12-30	1963-01-06	1
7161	421	40481087	1995-02-21	1995-02-28	1
60653	3593	4266809	1988-02-29	1988-03-01	1
35377	2098	4112343	1968-02-06	1968-02-18	1
79284	4701	4113008	2015-11-11	2015-12-02	1
79510	4715	40481087	2016-03-30	2016-04-06	1
33388	1982	257012	1978-11-15	1978-11-16	1
24247	1446	40481087	1992-11-19	1992-12-03	1
24320	1450	4112343	2010-01-21	2010-01-28	1
25474	1517	40481087	1944-01-26	1944-02-02	1
37717	2237	40481087	1974-04-09	1974-04-23	1
45900	2736	4294548	2005-01-01	2005-03-05	1
87222	5197	40481087	2006-05-22	2006-06-12	1
55247	3275	260139	1973-10-30	1973-11-06	1
30727	1819	260139	1989-08-20	1989-08-27	1
53534	3175	4294548	1960-09-14	1960-09-28	1
62931	3720	4278672	1968-09-10	1968-12-09	1
86382	5145	4112343	1992-03-05	1992-03-12	1
36405	2156	260139	2014-02-12	2014-02-26	1
51788	3074	4112343	2001-11-18	2001-11-30	1
31222	1848	4278672	1985-04-03	1985-05-03	1
4315	249	260139	2011-01-19	2011-01-26	1
54634	3237	4112343	1948-04-04	1948-04-15	1
28381	1679	40481087	1992-11-07	1992-11-21	1
69787	4133	4027663	2001-07-24	2001-07-25	1
23266	1389	4112343	2006-01-17	2006-01-26	1
26392	1567	260139	1989-07-07	1989-07-14	1
57128	3394	260139	2003-12-01	2003-12-08	1
47937	2847	40481087	1978-09-15	1978-09-29	1
7162	421	40481087	2009-03-22	2009-04-12	1
60654	3593	4294548	1967-11-01	1967-12-13	1
35378	2098	4112343	1999-11-16	1999-11-28	1
79285	4701	4132546	1987-05-16	1987-05-17	1
79511	4715	260139	1970-01-26	1970-02-02	1
33389	1982	260139	1939-03-25	1939-04-08	1
24248	1446	40481087	2001-03-30	2001-04-06	1
24321	1450	4112343	2015-03-17	2015-03-26	1
25475	1517	40481087	1954-07-15	1954-08-05	1
37718	2237	40481087	2001-12-02	2001-12-16	1
45901	2736	40481087	1998-12-14	1998-12-28	1
87223	5197	81893	1994-08-04	1994-08-05	1
56435	3352	80180	2003-07-01	2003-07-02	1
30728	1819	260139	1998-04-13	1998-04-27	1
53535	3175	40481087	2001-02-01	2001-02-22	1
62932	3720	4283893	1980-10-10	1980-11-14	1
86383	5145	4112343	2015-06-23	2015-07-05	1
36406	2156	372328	1968-08-01	1969-07-03	1
51789	3074	381316	1993-11-10	1993-11-11	1
31223	1848	4310024	1980-10-05	1980-10-06	1
4316	249	4112343	1992-02-29	1992-03-10	1
54635	3237	4112343	2004-02-17	2004-02-29	1
28382	1679	28060	2001-11-09	2001-11-22	1
69788	4133	4112343	1993-09-25	1993-10-07	1
23267	1389	4296205	2007-08-29	2007-09-19	1
26393	1567	4084167	2002-09-05	2002-09-06	1
57129	3394	4112343	1967-08-27	1967-09-03	1
47938	2847	28060	1975-03-09	1975-03-18	1
8774	515	78272	2001-01-11	2001-02-01	1
60655	3593	40481087	1954-03-18	1954-04-08	1
35379	2098	4112343	2004-06-18	2004-06-25	1
79286	4701	40481087	1972-10-23	1972-11-13	1
79512	4715	372328	1955-11-10	1956-07-25	1
33390	1982	260139	1996-07-15	1996-07-24	1
25828	1536	28060	1968-10-29	1968-11-09	1
24322	1450	40481087	2009-01-29	2009-02-05	1
25476	1517	40481087	1961-04-20	1961-05-04	1
39169	2328	192671	1999-06-28	1999-06-29	1
45902	2736	28060	2019-06-12	2019-06-23	1
87224	5197	4109685	1995-08-28	1995-09-18	1
56436	3352	372328	1976-09-20	1976-10-22	1
30729	1819	4112343	1981-04-07	1981-04-15	1
54120	3211	80180	1996-11-03	1996-11-04	1
62933	3720	40481087	1971-12-11	1971-12-25	1
86384	5145	4116491	1978-09-04	1978-10-28	1
36407	2156	4134304	1967-06-08	1967-08-07	1
51790	3074	4218389	1971-07-19	1971-08-09	1
31224	1848	40481087	1992-11-20	1992-12-04	1
4317	249	4116491	2017-08-13	2017-09-17	1
54636	3237	40481087	1936-11-18	1936-11-25	1
28383	1679	80180	2009-06-12	2009-06-13	1
69789	4133	4112343	2015-01-01	2015-01-12	1
23268	1389	40481087	1965-07-31	1965-08-14	1
26394	1567	4112343	2008-08-16	2008-08-28	1
57130	3394	4112343	1982-06-17	1982-06-27	1
47939	2847	78272	1983-10-17	1983-11-21	1
8775	515	80180	1981-03-27	1981-03-28	1
60656	3593	40481087	1972-12-25	1973-01-15	1
35380	2098	4156265	2005-07-18	2005-08-01	1
79287	4701	80180	2011-07-10	2011-07-11	1
79513	4715	40481087	1978-02-01	1978-02-15	1
33391	1982	4112343	1943-06-02	1943-06-15	1
25829	1536	260139	1919-09-17	1919-09-24	1
24323	1450	40481087	2017-07-19	2017-08-02	1
25477	1517	40481087	2014-02-15	2014-03-01	1
39170	2328	4112343	1980-01-13	1980-01-23	1
45903	2736	372328	1970-05-03	1970-07-15	1
87225	5197	4112343	1971-04-20	1971-05-01	1
56437	3352	4112343	1964-12-23	1964-12-31	1
30730	1819	4112343	1989-01-07	1989-01-20	1
54121	3211	4113008	1968-06-07	1968-06-21	1
62934	3720	40481087	2011-06-25	2011-07-16	1
86385	5145	4116491	1978-12-02	1979-01-20	1
36408	2156	4283893	1983-05-24	1984-02-21	1
51791	3074	40481087	1988-12-10	1988-12-17	1
31225	1848	40481087	2005-12-03	2005-12-24	1
4318	249	4155034	2004-11-19	2004-12-10	1
54637	3237	40481087	1949-08-25	1949-09-01	1
28384	1679	260139	2009-04-04	2009-04-11	1
69790	4133	40481087	1993-03-08	1993-03-15	1
23555	1409	81151	1922-02-02	1922-03-09	1
26395	1567	260139	1981-11-21	1981-12-05	1
57131	3394	40481087	1993-05-28	1993-06-04	1
47940	2847	80180	2001-11-18	2001-11-19	1
8776	515	260139	1971-09-12	1971-09-26	1
60657	3593	40481087	1988-05-26	1988-06-02	1
35381	2098	4294548	1972-09-18	1972-12-18	1
79288	4701	257012	1989-08-24	1989-08-25	1
79514	4715	40481087	1986-02-12	1986-02-26	1
33392	1982	4112343	1948-10-18	1948-10-29	1
25830	1536	260139	1964-02-03	1964-02-10	1
24324	1450	260139	1979-04-29	1979-05-06	1
25478	1517	40481087	2016-01-12	2016-02-02	1
39171	2328	4112343	2003-09-21	2003-09-28	1
45904	2736	372328	1982-08-04	1983-06-01	1
87226	5197	4112343	2002-09-27	2002-10-07	1
56438	3352	4112343	2012-06-20	2012-06-27	1
30731	1819	4112343	2010-09-10	2010-09-18	1
54122	3211	4152936	1970-05-12	1970-06-02	1
62935	3720	40481087	2016-07-25	2016-08-08	1
86386	5145	4283893	2000-12-28	2001-06-14	1
36409	2156	40481087	1988-12-31	1989-01-07	1
51792	3074	40481087	1991-03-16	1991-04-06	1
31226	1848	81893	1981-08-01	1981-08-02	1
4319	249	80180	2016-12-06	2016-12-07	1
54638	3237	28060	1928-06-05	1928-06-17	1
28385	1679	4027663	2002-09-22	2002-09-23	1
69791	4133	28060	1981-03-08	1981-03-18	1
23556	1409	192671	1960-04-29	1960-04-30	1
26396	1567	260139	2018-05-12	2018-05-26	1
57132	3394	40481087	1997-02-21	1997-03-07	1
47941	2847	257012	1965-10-19	1965-10-20	1
8777	515	317576	1996-11-23	1996-11-24	1
60658	3593	40481087	2008-02-13	2008-03-05	1
35382	2098	40481087	2004-10-29	2004-11-19	1
79289	4701	260139	1975-06-06	1975-06-20	1
82444	4898	260139	1983-03-29	1983-04-12	1
33393	1982	4112343	1957-06-11	1957-06-22	1
25831	1536	261325	1966-02-20	1966-02-21	1
24325	1450	260139	1995-02-09	1995-02-16	1
26943	1597	28060	2006-03-11	2006-03-20	1
39172	2328	4112343	2014-07-05	2014-07-15	1
46233	2758	257012	1952-12-18	1952-12-19	1
87227	5197	4296205	2009-04-07	2009-05-05	1
56439	3352	4296205	1984-10-22	1984-11-12	1
32278	1921	260139	1965-08-20	1965-08-27	1
54123	3211	4278672	1966-04-19	1966-07-18	1
62936	3720	260139	2008-05-09	2008-05-16	1
86387	5145	40481087	1969-04-07	1969-04-21	1
36410	2156	40481087	2003-01-29	2003-02-12	1
51793	3074	40481087	1999-02-27	1999-03-20	1
31227	1848	134438	1967-09-16	1969-07-07	1
4320	249	4156265	2005-11-05	2005-11-26	1
54639	3237	260139	1981-12-04	1981-12-18	1
28386	1679	4112343	1989-06-12	1989-06-19	1
69792	4133	192671	2009-11-25	2009-11-26	1
23557	1409	260139	1937-09-07	1937-09-21	1
26397	1567	4084167	1991-09-28	1991-09-29	1
57133	3394	372328	1971-02-03	1971-09-18	1
47942	2847	4155034	1993-03-03	1993-03-24	1
8778	515	372328	1942-08-14	1942-08-28	1
63095	3731	260139	2011-08-22	2011-09-05	1
35383	2098	40481087	2007-03-17	2007-03-24	1
79290	4701	260139	1977-12-27	1978-01-10	1
82445	4898	260139	1991-08-26	1991-09-02	1
33394	1982	4112343	1961-02-05	1961-02-18	1
25832	1536	372328	1913-12-02	1914-06-07	1
24326	1450	372328	1968-09-03	1969-04-27	1
26944	1597	78272	1969-12-04	1969-12-25	1
39173	2328	4294548	1985-12-25	1986-01-15	1
46234	2758	372328	1942-07-06	1942-08-07	1
87228	5197	40481087	2005-08-12	2005-08-19	1
56440	3352	4310024	2001-05-12	2001-05-13	1
32279	1921	260139	1987-03-06	1987-03-20	1
54124	3211	40481087	2006-04-02	2006-04-09	1
62937	3720	260139	2010-10-04	2010-10-11	1
86388	5145	40481087	1983-11-30	1983-12-07	1
36411	2156	80180	2009-03-04	2009-03-05	1
51794	3074	80180	1986-07-20	1986-07-21	1
31228	1848	260139	1960-08-23	1960-09-06	1
4321	249	40481087	1987-01-31	1987-02-07	1
54640	3237	40481087	1986-08-20	1986-09-10	1
28387	1679	4283893	1985-10-17	1985-11-07	1
69793	4133	4112343	1994-05-06	1994-05-18	1
23558	1409	4112343	1962-08-24	1962-09-01	1
26398	1567	4112343	1997-05-06	1997-05-13	1
57134	3394	40481087	2002-12-02	2002-12-23	1
47943	2847	40481087	1980-08-24	1980-09-07	1
8779	515	4027663	1972-03-14	1972-03-15	1
63096	3731	4112343	2012-04-11	2012-04-20	1
35384	2098	260139	1970-12-21	1970-12-28	1
79291	4701	260139	2008-11-02	2008-11-16	1
82446	4898	260139	2008-01-05	2008-01-19	1
33395	1982	4112343	1963-03-13	1963-03-25	1
25833	1536	260139	1917-12-28	1918-01-11	1
24327	1450	4112343	1983-10-25	1983-11-07	1
26945	1597	4001336	1957-03-28	1957-05-27	1
39174	2328	4294548	1992-09-01	1993-01-19	1
46235	2758	372328	1950-09-24	1951-03-16	1
87229	5197	0	1993-04-11	1993-04-11	1
56441	3352	261325	1998-12-18	1998-12-19	1
32280	1921	4059173	1968-07-10	1968-10-08	1
54125	3211	28060	1972-02-29	1972-03-10	1
62938	3720	4112343	1963-02-20	1963-03-05	1
86389	5145	40481087	2018-02-20	2018-03-13	1
36412	2156	260139	1978-10-10	1978-10-17	1
51795	3074	372328	1996-03-24	1996-07-24	1
31229	1848	260139	1970-12-15	1970-12-29	1
4322	249	40481087	2001-11-27	2001-12-18	1
54641	3237	80180	1964-09-15	1964-09-16	1
28388	1679	40481087	1981-02-03	1981-02-17	1
69794	4133	4152936	2004-11-14	2004-12-05	1
23559	1409	4112343	2016-12-15	2016-12-27	1
26399	1567	4283893	2014-10-07	2014-11-11	1
57135	3394	260139	1972-11-25	1972-12-02	1
47944	2847	40481087	1987-06-10	1987-06-17	1
8780	515	4112343	1989-11-18	1989-11-30	1
63097	3731	4134304	1991-05-20	1991-08-18	1
35385	2098	372328	1962-11-01	1962-12-12	1
79292	4701	372328	1971-02-25	1971-05-07	1
82447	4898	4059173	1962-10-27	1962-11-26	1
33396	1982	4112343	1983-06-10	1983-06-18	1
25834	1536	372328	1912-08-25	1912-09-08	1
24328	1450	4156265	1994-11-21	1994-12-12	1
26946	1597	4048695	1987-10-22	1987-12-22	1
39175	2328	40481087	1964-04-10	1964-04-17	1
46236	2758	4109685	1978-06-22	1978-07-06	1
87230	5197	372328	1954-02-15	1954-03-30	1
56442	3352	4112343	1966-11-22	1966-12-04	1
32281	1921	4116491	1992-11-20	1993-01-07	1
54126	3211	28060	2009-03-31	2009-04-12	1
62939	3720	40481087	1984-09-01	1984-09-15	1
88187	5251	80180	1962-03-09	1962-03-10	1
36413	2156	4112343	1969-10-27	1969-11-05	1
51796	3074	4112343	1979-05-24	1979-06-05	1
31230	1848	439777	2015-08-28	2015-08-29	1
4323	249	40481087	2019-04-25	2019-05-16	1
54642	3237	260139	1928-07-02	1928-07-16	1
30177	1785	81151	1962-06-20	1962-07-25	1
69795	4133	4155034	2005-10-31	2005-11-14	1
23560	1409	40481087	1957-06-03	1957-06-10	1
26400	1567	40481087	1978-06-16	1978-06-23	1
57136	3394	260139	1975-11-19	1975-11-26	1
47945	2847	40481087	2000-12-02	2000-12-09	1
8781	515	4112343	2005-06-12	2005-06-23	1
63098	3731	40481087	2009-10-15	2009-11-05	1
35386	2098	4112343	2009-02-03	2009-02-11	1
79293	4701	4001336	1987-05-16	1987-07-15	1
82448	4898	4112343	1978-03-28	1978-04-06	1
33397	1982	4112343	1985-09-23	1985-10-01	1
25835	1536	375671	1920-02-15	1920-03-16	1
24329	1450	40481087	2002-09-10	2002-09-24	1
26947	1597	4278672	1985-09-02	1985-11-01	1
39176	2328	40481087	2004-09-23	2004-10-14	1
46237	2758	4112343	1959-04-10	1959-04-19	1
87231	5197	372328	1956-06-17	1956-09-18	1
56443	3352	40481087	1972-10-17	1972-11-07	1
32282	1921	40481087	1975-01-30	1975-02-20	1
54127	3211	372328	1958-11-13	1959-05-01	1
62940	3720	40481087	1997-04-16	1997-04-23	1
88188	5251	81151	1928-11-13	1928-12-11	1
36414	2156	81151	2017-02-15	2017-03-22	1
51797	3074	4112343	1981-06-25	1981-07-02	1
31231	1848	4027663	1975-09-07	1975-09-08	1
5058	298	78272	1982-07-26	1982-08-23	1
54643	3237	260139	2000-01-17	2000-01-31	1
30178	1785	257012	1994-10-25	1994-10-26	1
69796	4133	40481087	1987-08-24	1987-08-31	1
23561	1409	40481087	2016-11-22	2016-12-13	1
26401	1567	40481087	1984-03-01	1984-03-15	1
57137	3394	260139	2016-02-17	2016-03-02	1
47946	2847	28060	1968-12-23	1969-01-05	1
8782	515	4218389	1985-04-07	1985-05-05	1
63099	3731	4112343	1989-01-28	1989-02-08	1
35387	2098	4294548	1981-02-13	1981-05-01	1
79294	4701	4112343	1976-08-28	1976-09-04	1
82449	4898	4152936	1991-08-24	1991-09-07	1
33398	1982	4112343	1996-07-18	1996-07-27	1
25836	1536	4109685	1944-03-10	1944-03-24	1
24330	1450	40481087	2018-03-08	2018-03-22	1
26948	1597	40481087	2013-03-21	2013-04-11	1
39177	2328	40481087	2012-03-01	2012-03-15	1
46238	2758	4112343	1961-07-17	1961-07-29	1
87232	5197	381316	2012-05-08	2012-05-09	1
56444	3352	40481087	2008-10-12	2008-11-02	1
32283	1921	40481087	1992-12-07	1992-12-28	1
54128	3211	4112343	1974-02-01	1974-02-10	1
62941	3720	372328	1956-12-02	1957-03-12	1
88189	5251	260139	1947-05-18	1947-06-01	1
36415	2156	4112343	2016-01-25	2016-02-05	1
51798	3074	4112343	2002-06-02	2002-06-09	1
31232	1848	4109685	1957-03-10	1957-03-31	1
5059	298	80180	1990-02-18	1990-02-19	1
54644	3237	4112343	1971-10-13	1971-10-22	1
30179	1785	372328	2016-01-12	2016-09-26	1
69797	4133	40481087	2014-12-07	2014-12-14	1
23562	1409	81151	1928-09-03	1928-09-24	1
27772	1641	78272	1964-06-13	1964-07-04	1
57138	3394	381316	2010-08-21	2010-08-22	1
47947	2847	4112343	1990-11-18	1990-11-30	1
8783	515	40479422	1976-11-13	1976-12-20	1
63100	3731	40481087	2000-02-27	2000-03-05	1
35388	2098	40481087	1999-02-02	1999-02-23	1
79295	4701	4283893	1989-06-15	1989-12-21	1
82450	4898	40481087	1976-10-05	1976-10-19	1
33399	1982	4152936	1983-10-02	1983-10-23	1
25837	1536	40481087	1939-07-26	1939-08-09	1
25126	1500	260139	2015-04-30	2015-05-07	1
26949	1597	81151	1949-05-04	1949-05-18	1
39178	2328	40481087	2018-04-04	2018-04-25	1
46239	2758	4112343	1979-07-18	1979-07-26	1
87233	5197	4112343	1975-09-09	1975-09-16	1
56445	3352	28060	1972-09-22	1972-10-04	1
32284	1921	40481087	2012-03-23	2012-04-13	1
54129	3211	4112343	1996-04-18	1996-04-27	1
62942	3720	4112343	1966-01-19	1966-02-01	1
88190	5251	380378	1922-02-27	1922-02-28	1
36416	2156	4294548	1994-04-03	1994-07-10	1
51799	3074	4112343	2002-12-09	2002-12-19	1
31233	1848	4112343	1973-10-30	1973-11-11	1
5060	298	317576	2019-02-12	2019-02-13	1
54645	3237	4112343	2009-12-01	2009-12-12	1
30180	1785	40481087	1957-04-26	1957-05-03	1
69798	4133	40481087	2018-10-30	2018-11-06	1
23563	1409	260139	2006-03-11	2006-03-27	1
27773	1641	81151	1956-09-11	1956-10-16	1
57139	3394	4112343	1986-02-07	1986-02-18	1
47948	2847	40481087	1965-03-22	1965-04-12	1
8784	515	40481087	1959-01-14	1959-01-28	1
63101	3731	260139	1978-10-28	1978-11-04	1
35389	2098	80180	2001-11-06	2001-11-07	1
79296	4701	260139	1978-12-26	1979-01-09	1
82451	4898	40481087	1995-12-17	1995-12-24	1
33400	1982	4294548	1978-11-01	1979-10-10	1
25838	1536	28060	1915-04-14	1915-04-22	1
25127	1500	80180	2001-10-25	2001-10-26	1
26950	1597	4084167	1945-04-25	1945-04-25	1
39179	2328	30753	1998-07-08	1998-07-09	1
46240	2758	4112343	1985-11-08	1985-11-18	1
87234	5197	40481087	1978-12-22	1979-01-12	1
56446	3352	30753	2002-05-07	2002-05-08	1
32285	1921	80180	1995-03-02	1995-03-03	1
54130	3211	4112343	1998-04-19	1998-04-26	1
62943	3720	4112343	1983-06-01	1983-06-12	1
88191	5251	4029498	1922-02-27	1922-02-28	1
36417	2156	40481087	2007-06-27	2007-07-18	1
51800	3074	4112343	2009-04-18	2009-04-29	1
31234	1848	40481087	1974-12-12	1975-01-02	1
5061	298	372328	1974-09-30	1976-07-27	1
4293	248	80180	2012-12-09	2012-12-10	1
30181	1785	260139	2013-09-25	2013-10-09	1
72321	4297	81151	1999-11-12	1999-12-03	1
23564	1409	4112343	1966-04-17	1966-04-24	1
27774	1641	81151	1967-04-20	1967-05-11	1
57140	3394	4278672	1980-02-16	1980-05-16	1
47949	2847	40481087	1967-10-23	1967-11-06	1
8785	515	40481087	2012-01-13	2012-02-03	1
63102	3731	260139	1999-10-16	1999-10-23	1
35390	2098	257012	1972-11-06	1972-11-07	1
79297	4701	378001	2003-02-17	2003-03-19	1
82452	4898	192671	1998-01-09	1998-01-10	1
33401	1982	4294548	1981-01-08	1981-04-02	1
25839	1536	4112343	1959-07-04	1959-07-15	1
25128	1500	4112343	1984-08-30	1984-09-10	1
26951	1597	4155034	1994-07-18	1994-08-01	1
39180	2328	81893	1997-10-11	1997-10-12	1
46241	2758	4112343	2000-03-08	2000-03-21	1
87235	5197	40481087	1986-09-07	1986-09-14	1
56447	3352	78272	1975-06-28	1975-07-12	1
32286	1921	81151	2015-01-26	2015-02-23	1
54131	3211	40481087	1995-07-11	1995-07-25	1
62944	3720	4155034	2013-01-01	2013-01-15	1
88192	5251	40481087	1957-09-08	1957-09-22	1
36738	2176	28060	1991-09-13	1991-09-20	1
51801	3074	4152936	2018-07-15	2018-07-29	1
31553	1870	195588	1957-04-09	1957-05-15	1
5062	298	4152936	2010-06-18	2010-07-02	1
4294	248	260139	1996-04-16	1996-04-23	1
30182	1785	4112343	1962-04-09	1962-04-16	1
72322	4297	260139	2008-01-28	2008-02-04	1
23565	1409	4294548	1992-10-10	1992-12-12	1
27775	1641	260139	1981-05-23	1981-05-30	1
57141	3394	40481087	2017-05-15	2017-06-05	1
47950	2847	40481087	1976-10-28	1976-11-18	1
8786	515	40481087	2016-04-20	2016-04-27	1
63103	3731	260139	2016-09-15	2016-09-22	1
35391	2098	260139	1973-11-19	1973-12-03	1
79298	4701	381316	2015-04-03	2015-04-04	1
82453	4898	4112343	2005-04-01	2005-04-09	1
33402	1982	28060	1984-03-18	1984-03-31	1
25840	1536	4112343	1964-08-18	1964-08-30	1
25129	1500	4112343	2007-04-15	2007-04-23	1
26952	1597	4237458	1965-02-28	1965-04-29	1
39181	2328	260139	1969-12-09	1969-12-16	1
46242	2758	4310024	1978-06-20	1978-06-21	1
87236	5197	40481087	1989-12-02	1989-12-16	1
56448	3352	4112343	2017-06-03	2017-06-12	1
32287	1921	195588	1992-09-13	1992-10-23	1
54132	3211	40481087	2004-09-12	2004-10-03	1
62945	3720	4294548	1999-07-19	1999-08-09	1
88193	5251	40481087	1968-08-03	1968-08-10	1
36739	2176	378001	2008-11-30	2009-01-29	1
51802	3074	4218389	2005-09-30	2005-10-21	1
31554	1870	260139	1947-10-21	1947-11-04	1
5063	298	4155034	2000-12-16	2001-01-06	1
4295	248	372328	1995-09-21	1996-04-23	1
30183	1785	4134304	1961-05-26	1961-06-25	1
72323	4297	372328	1984-03-04	1985-02-02	1
23566	1409	40481087	1932-09-29	1932-10-13	1
27776	1641	4112343	1970-11-23	1970-12-06	1
57142	3394	80180	1999-10-09	1999-10-10	1
49353	2921	78272	1964-07-03	1964-07-17	1
8787	515	40481087	2019-04-20	2019-05-04	1
63104	3731	4112343	1985-07-09	1985-07-16	1
35392	2098	4112343	1973-07-22	1973-07-31	1
79299	4701	4116491	2001-11-19	2001-12-27	1
82454	4898	4278672	1990-07-30	1990-08-29	1
33403	1982	78272	1987-05-05	1987-06-09	1
25841	1536	4112343	1965-01-31	1965-02-13	1
25130	1500	40481087	1985-02-20	1985-02-27	1
26953	1597	4283893	2010-10-18	2011-02-21	1
39182	2328	260139	1975-09-06	1975-09-20	1
46243	2758	28060	1947-03-12	1947-03-25	1
89656	5335	80180	1992-10-01	1992-10-02	1
56449	3352	40481087	2003-02-26	2003-03-05	1
32288	1921	4056621	1992-11-20	1992-11-21	1
54133	3211	40481087	2018-10-09	2018-10-30	1
62946	3720	4296204	1996-09-13	1996-09-27	1
88194	5251	0	1922-02-27	1922-02-28	1
36740	2176	4112343	1956-11-20	1956-11-28	1
51803	3074	4283893	1975-04-10	1975-08-14	1
31555	1870	381316	1961-02-19	1961-02-20	1
5064	298	40481087	1964-07-23	1964-08-13	1
4296	248	375671	1988-06-08	1988-07-08	1
30184	1785	4155034	2001-10-28	2001-11-18	1
72324	4297	4112343	1973-10-06	1973-10-14	1
23567	1409	40481087	1957-10-17	1957-10-24	1
27777	1641	4112343	2010-11-24	2010-12-06	1
57143	3394	260139	2018-12-29	2019-01-05	1
49354	2921	258780	1975-06-10	1975-06-11	1
8788	515	260139	1966-05-11	1966-05-25	1
63105	3731	4294548	1980-01-27	1980-05-11	1
35393	2098	4112343	2002-01-17	2002-01-29	1
79300	4701	40481087	1974-07-14	1974-07-28	1
82455	4898	4294548	1985-12-09	1985-12-30	1
33404	1982	260139	1987-08-16	1987-08-30	1
25842	1536	4218389	1971-02-01	1971-03-01	1
25131	1500	40481087	2015-08-04	2015-08-11	1
26954	1597	40481087	2013-07-16	2013-07-30	1
39183	2328	260139	2007-10-04	2007-10-18	1
46244	2758	260139	1996-01-08	1996-01-22	1
89657	5335	81151	1964-03-22	1964-04-12	1
56450	3352	192671	2003-08-02	2003-08-03	1
32289	1921	4112343	1978-03-18	1978-03-30	1
54134	3211	28060	1963-10-19	1963-11-01	1
62947	3720	40481087	2000-08-11	2000-08-25	1
88195	5251	81151	1935-11-05	1935-11-19	1
36741	2176	4112343	1989-09-15	1989-09-22	1
51804	3074	40481087	1994-03-26	1994-04-16	1
31556	1870	80180	1957-05-29	1957-05-30	1
5065	298	40481087	1966-08-08	1966-08-22	1
4297	248	4237458	1990-04-29	1990-07-28	1
30185	1785	4112343	1958-06-18	1958-06-26	1
72325	4297	4283893	1990-06-14	1990-07-12	1
23568	1409	40481087	1996-10-29	1996-11-19	1
27778	1641	4285898	1997-01-04	1997-01-05	1
57144	3394	372328	1978-02-13	1978-12-16	1
49355	2921	4112343	2005-08-20	2005-08-28	1
8789	515	381316	2014-05-24	2014-05-25	1
63106	3731	40479768	1984-07-27	1984-09-02	1
35394	2098	4113008	2007-04-23	2007-05-14	1
79301	4701	78272	1990-07-04	1990-07-25	1
82456	4898	40481087	1963-06-27	1963-07-11	1
33405	1982	378001	1971-09-05	1971-10-05	1
25843	1536	4278672	1926-11-10	1927-01-09	1
25132	1500	4152936	1965-07-26	1965-08-09	1
26955	1597	28060	1959-02-26	1959-03-10	1
39184	2328	260139	2015-12-26	2016-01-02	1
46245	2758	260139	2012-02-07	2012-02-21	1
89658	5335	260139	1980-03-30	1980-04-06	1
56451	3352	260139	1998-03-31	1998-04-14	1
32290	1921	40481087	1982-02-21	1982-03-14	1
54135	3211	260139	2001-11-19	2001-12-03	1
65625	3885	260139	1981-10-29	1981-11-12	1
88196	5251	255848	1980-03-03	1980-03-04	1
36742	2176	4218389	1966-07-20	1966-08-24	1
51805	3074	260139	1972-09-28	1972-10-12	1
31557	1870	260139	1932-07-24	1932-07-31	1
5066	298	40481087	2014-03-17	2014-03-31	1
4298	248	40481087	1998-12-28	1999-01-18	1
30186	1785	4112343	1989-11-21	1989-12-01	1
72326	4297	40481087	2000-02-25	2000-03-17	1
23569	1409	28060	1993-05-27	1993-06-03	1
27779	1641	4310024	1996-05-09	1996-05-10	1
57145	3394	40481087	1971-09-06	1971-09-13	1
49356	2921	4230399	1989-05-07	1989-07-06	1
8790	515	4112343	1969-01-21	1969-02-03	1
63107	3731	40481087	1995-11-25	1995-12-16	1
35653	2116	260139	1965-02-04	1965-02-11	1
79302	4701	81151	1989-05-05	1989-06-09	1
82457	4898	28060	1954-02-12	1954-02-20	1
33406	1982	4112343	1949-04-29	1949-05-09	1
25844	1536	40481087	1958-01-06	1958-01-27	1
25133	1500	260139	1973-11-12	1973-11-26	1
26956	1597	28060	2003-04-12	2003-04-23	1
39185	2328	4285898	1999-04-04	1999-04-05	1
46246	2758	313217	2005-11-18	2005-11-19	1
89659	5335	440086	1966-08-19	1968-04-05	1
56452	3352	4027663	1993-10-16	1993-10-17	1
32291	1921	260139	1955-02-06	1955-02-13	1
54136	3211	40481087	1979-11-22	1979-11-29	1
65626	3885	4113008	1995-02-11	1995-03-04	1
88197	5251	375671	1936-10-14	1936-12-13	1
36743	2176	4283893	1968-03-19	1968-04-30	1
51806	3074	372328	1953-12-20	1954-02-03	1
31558	1870	4112343	1925-05-04	1925-05-12	1
5067	298	78272	1968-05-05	1968-06-09	1
4299	248	260139	1981-02-16	1981-03-02	1
30187	1785	4218389	1956-08-24	1956-09-14	1
72327	4297	198809	1991-02-19	1991-02-19	1
23570	1409	80180	1960-03-04	1960-03-05	1
27780	1641	40481087	2001-02-24	2001-03-17	1
57146	3394	40481087	2001-07-21	2001-08-04	1
49357	2921	40481087	1945-08-26	1945-09-09	1
8791	515	4294548	1998-11-16	1998-11-30	1
63108	3731	40481087	1996-06-21	1996-07-12	1
35654	2116	260139	1979-03-26	1979-04-09	1
79303	4701	4112343	1990-02-25	1990-03-06	1
82458	4898	80180	1997-11-22	1997-11-23	1
33407	1982	4278672	1933-11-20	1933-12-20	1
25845	1536	40481087	1964-05-30	1964-06-20	1
25134	1500	4112343	1966-07-25	1966-08-02	1
26957	1597	80180	1981-04-06	1981-04-07	1
39186	2328	40481087	1981-10-02	1981-10-09	1
46247	2758	372328	1942-01-02	1942-02-06	1
89660	5335	40481087	1971-07-01	1971-07-22	1
56453	3352	4112343	1972-04-09	1972-04-21	1
32292	1921	260139	2003-03-13	2003-03-20	1
54137	3211	40481087	1985-02-08	1985-02-22	1
65627	3885	4155034	2011-12-19	2012-01-02	1
88198	5251	4112343	1943-01-20	1943-02-02	1
36744	2176	81151	1957-07-16	1957-08-06	1
51807	3074	4112343	1964-06-27	1964-07-09	1
31559	1870	4152936	1953-01-25	1953-02-08	1
5068	298	260139	1996-07-18	1996-07-25	1
4300	248	260139	1990-12-21	1990-12-28	1
30188	1785	4283893	1997-12-21	1998-02-15	1
72328	4297	372328	1974-10-28	1974-12-14	1
23571	1409	257012	1936-05-31	1936-06-01	1
27781	1641	40481087	2016-03-04	2016-03-25	1
49358	2921	40481087	1950-10-19	1950-10-26	1
8792	515	40481087	1949-09-12	1949-10-03	1
63109	3731	28060	1976-09-11	1976-09-22	1
35655	2116	4156265	2006-10-25	2006-11-08	1
79304	4701	4296204	1978-08-17	1978-08-31	1
82459	4898	260139	1954-03-14	1954-03-28	1
33408	1982	4283893	1981-08-06	1981-10-22	1
25846	1536	80180	1945-05-09	1945-05-10	1
25135	1500	4152936	1968-03-26	1968-04-16	1
26958	1597	257012	1984-10-09	1984-10-10	1
39187	2328	40481087	1988-07-08	1988-07-15	1
46248	2758	4294548	1952-11-13	1953-09-24	1
89661	5335	40481087	2019-03-17	2019-04-07	1
56454	3352	4112343	1989-07-08	1989-07-19	1
32293	1921	260139	2012-12-17	2012-12-24	1
54138	3211	40481087	1989-07-07	1989-07-14	1
65628	3885	40481087	1967-01-20	1967-01-27	1
88199	5251	4112343	1947-12-11	1947-12-20	1
36745	2176	81151	2007-01-26	2007-02-09	1
51808	3074	4112343	2009-05-30	2009-06-08	1
31560	1870	40481087	1923-02-11	1923-02-25	1
5069	298	4112343	1981-12-03	1981-12-13	1
4301	248	372328	1975-06-17	1975-07-08	1
30189	1785	40481087	2003-06-24	2003-07-08	1
72329	4297	4152936	1979-11-01	1979-11-22	1
23572	1409	260139	1931-10-14	1931-10-28	1
27782	1641	260139	1963-12-05	1963-12-12	1
49359	2921	40481087	1991-05-27	1991-06-10	1
8793	515	40481087	2009-11-09	2009-11-16	1
63110	3731	80180	2008-03-03	2008-03-04	1
35656	2116	4296205	2012-10-07	2012-11-11	1
80945	4807	28060	1967-07-12	1967-07-25	1
82460	4898	260139	1999-06-23	1999-07-07	1
33409	1982	4294548	1929-03-01	1929-03-22	1
25847	1536	80502	1971-11-28	1971-11-29	1
25136	1500	40481087	1970-01-08	1970-01-15	1
26959	1597	260139	1954-07-08	1954-07-22	1
39188	2328	40481087	1994-10-04	1994-10-11	1
46249	2758	40481087	1995-02-25	1995-03-04	1
89662	5335	4112343	1973-05-07	1973-05-17	1
56455	3352	4134304	1981-02-10	1981-03-12	1
32294	1921	372328	1951-12-23	1952-03-03	1
54139	3211	40481087	1994-01-26	1994-02-09	1
65629	3885	40481087	1969-09-02	1969-09-23	1
88200	5251	4112343	1965-10-03	1965-10-10	1
36746	2176	81893	1999-05-07	1999-05-08	1
51809	3074	4156265	1998-11-15	1998-12-06	1
31561	1870	40481087	1931-10-17	1931-11-07	1
5070	298	4218389	1954-12-24	1955-01-14	1
4302	248	4059173	2009-05-19	2009-06-18	1
30190	1785	80180	1990-12-14	1990-12-15	1
72330	4297	4296204	1986-04-19	1986-05-24	1
23573	1409	4112343	1939-06-29	1939-07-09	1
27783	1641	372328	1967-02-07	1968-01-03	1
49360	2921	78272	1941-05-14	1941-06-04	1
8794	515	257012	1958-07-31	1958-08-01	1
63111	3731	81151	1988-04-14	1988-05-05	1
35657	2116	40481087	1979-11-30	1979-12-07	1
80946	4807	78272	1972-05-09	1972-06-13	1
82461	4898	260139	2003-09-16	2003-09-23	1
33410	1982	4329847	2006-10-19	2006-10-20	1
25848	1536	260139	1919-02-08	1919-02-22	1
25137	1500	40481087	1971-01-18	1971-02-08	1
26960	1597	260139	1993-01-15	1993-01-29	1
39189	2328	40481087	2005-11-13	2005-11-27	1
46250	2758	80180	1980-06-09	1980-06-10	1
89663	5335	4112343	2001-07-01	2001-07-11	1
56456	3352	4285898	2002-08-05	2002-08-06	1
32295	1921	4113008	2016-01-19	2016-02-09	1
54140	3211	260139	1961-06-02	1961-06-16	1
65630	3885	28060	1973-06-17	1973-06-26	1
88201	5251	40481087	1922-12-02	1922-12-16	1
36747	2176	257012	1990-12-25	1991-01-15	1
51810	3074	40481087	1959-07-28	1959-08-18	1
31562	1870	40481087	1932-10-09	1932-10-16	1
5071	298	40481087	1956-07-09	1956-07-30	1
4303	248	4134304	1982-11-07	1982-12-07	1
30191	1785	81151	1958-05-07	1958-06-11	1
72331	4297	372328	1976-11-03	1976-12-11	1
23574	1409	4112343	1958-12-28	1959-01-08	1
27784	1641	4112343	1968-11-23	1968-12-01	1
49361	2921	81151	2005-11-09	2005-11-30	1
8795	515	4112343	1955-10-07	1955-10-15	1
63112	3731	257012	1980-02-10	1980-02-11	1
35658	2116	40481087	2003-12-14	2004-01-04	1
80947	4807	257012	1959-01-19	1959-09-14	1
82462	4898	260139	2012-03-28	2012-04-11	1
33411	1982	40481087	1923-11-19	1923-12-03	1
25849	1536	40481087	1913-01-27	1913-02-03	1
25138	1500	40481087	1984-02-05	1984-02-19	1
26961	1597	4109685	1956-04-11	1956-05-02	1
39190	2328	40481087	2017-07-19	2017-08-02	1
46251	2758	4112343	1954-11-16	1954-11-29	1
89664	5335	40481087	1972-07-23	1972-08-13	1
56457	3352	40481087	1973-04-11	1973-04-25	1
32296	1921	40481087	1992-09-23	1992-09-30	1
54141	3211	4112343	1966-02-22	1966-03-01	1
65631	3885	80180	2004-10-26	2004-10-27	1
88202	5251	40481087	1959-11-19	1959-12-10	1
36748	2176	372328	1962-04-20	1962-07-30	1
51811	3074	40481087	1967-05-14	1967-05-28	1
31563	1870	4112343	1924-10-26	1924-11-03	1
5072	298	40481087	1996-04-24	1996-05-01	1
4304	248	40481087	2012-01-18	2012-01-25	1
30192	1785	4112343	2010-08-17	2010-08-29	1
72332	4297	4116491	2018-12-26	2019-02-16	1
23575	1409	4112343	1967-11-17	1967-11-24	1
27785	1641	40481087	1958-10-09	1958-10-16	1
49362	2921	372328	1941-05-26	1941-08-26	1
8796	515	4266809	1981-03-27	1981-03-28	1
63113	3731	372328	1974-06-20	1974-08-31	1
35659	2116	40481087	2008-02-09	2008-02-23	1
80948	4807	4056621	2002-05-26	2002-05-27	1
82463	4898	4112343	1954-07-21	1954-07-30	1
33412	1982	40481087	1963-12-05	1963-12-12	1
25850	1536	40481087	1967-02-14	1967-02-21	1
25139	1500	40481087	1994-08-16	1994-08-23	1
26962	1597	28060	1953-08-15	1953-08-23	1
39191	2328	28060	1961-04-08	1961-04-18	1
46252	2758	4112343	1960-03-15	1960-03-23	1
89665	5335	40481087	1973-05-18	1973-06-08	1
56458	3352	40481087	2018-08-21	2018-09-04	1
32297	1921	40481087	2008-04-15	2008-05-06	1
54142	3211	4152936	1965-06-09	1965-06-23	1
65632	3885	260139	1978-07-27	1978-08-10	1
88203	5251	4112343	1952-01-30	1952-02-10	1
36749	2176	4112343	1961-01-10	1961-01-17	1
51812	3074	40481087	1968-11-27	1968-12-04	1
31564	1870	4112343	1943-05-27	1943-06-03	1
5073	298	40481087	2013-06-22	2013-07-13	1
4305	248	134438	1990-08-04	1991-08-29	1
30193	1785	4294548	1994-08-23	1994-12-13	1
72333	4297	4294548	1983-10-20	1983-11-10	1
23576	1409	4112343	1996-12-18	1996-12-27	1
27786	1641	40481087	1991-04-28	1991-05-19	1
49363	2921	4112343	1956-02-27	1956-03-08	1
8797	515	4285898	1980-05-01	1980-05-02	1
63114	3731	372328	1990-01-09	1990-02-10	1
35660	2116	40481087	2016-04-08	2016-04-22	1
80949	4807	40481087	1956-07-06	1956-07-20	1
82464	4898	40481087	2005-12-09	2005-12-23	1
33562	1992	30753	2018-03-02	2018-03-03	1
28525	1690	4112343	1983-01-07	1983-01-14	1
25140	1500	40481087	2008-07-19	2008-08-02	1
26963	1597	28060	1960-10-01	1960-10-11	1
39192	2328	28060	2016-07-08	2016-07-19	1
46253	2758	4112343	1976-06-24	1976-07-01	1
89666	5335	40481087	2004-11-27	2004-12-11	1
57926	3438	192671	1947-03-07	1947-03-08	1
32298	1921	81151	1964-08-16	1964-08-30	1
54143	3211	4218389	1992-02-07	1992-03-06	1
65633	3885	4059173	1968-09-06	1968-10-06	1
88204	5251	4278672	1933-11-15	1933-12-15	1
36750	2176	40481087	1997-05-19	1997-06-09	1
54389	3224	80180	2001-12-20	2001-12-21	1
31565	1870	28060	1939-09-30	1939-10-12	1
5074	298	28060	1952-10-08	1952-10-20	1
4306	248	4112343	2013-01-16	2013-01-24	1
30194	1785	40481087	1996-10-12	1996-10-19	1
72334	4297	40481087	1999-06-01	1999-06-22	1
23577	1409	4112343	2005-11-14	2005-11-25	1
27787	1641	40481087	1995-07-05	1995-07-26	1
49364	2921	4112343	1988-04-04	1988-04-17	1
8798	515	4294548	1977-06-26	1977-07-31	1
63115	3731	4059173	1989-03-31	1989-04-30	1
35661	2116	378419	2018-02-19	2018-02-20	1
80950	4807	28060	1987-03-29	1987-04-11	1
82465	4898	260139	1966-09-20	1966-10-04	1
33563	1992	4027663	2009-03-14	2009-03-15	1
28526	1690	4155034	2009-12-27	2010-01-17	1
28013	1658	28060	1925-03-16	1925-03-24	1
26964	1597	372328	1947-06-14	1947-07-05	1
39193	2328	80180	1999-05-04	1999-05-05	1
46254	2758	4112343	2013-01-01	2013-01-12	1
89667	5335	4112343	1984-03-23	1984-03-30	1
57927	3438	260139	1944-01-03	1944-01-10	1
32299	1921	260139	1991-07-06	1991-07-13	1
54144	3211	40481087	1963-01-30	1963-02-13	1
65634	3885	4109685	1963-11-11	1963-12-02	1
88205	5251	40481087	1927-07-31	1927-08-14	1
36751	2176	40481087	2000-06-01	2000-06-15	1
54390	3224	260139	1971-01-18	1971-02-01	1
31566	1870	260139	1927-04-13	1927-04-20	1
5075	298	260139	1959-03-05	1959-03-19	1
4307	248	40481087	1979-02-01	1979-02-15	1
30195	1785	40481087	2019-01-23	2019-02-06	1
72335	4297	28060	1975-04-08	1975-04-16	1
23578	1409	4112343	2007-03-23	2007-04-04	1
27788	1641	40481087	1999-10-11	1999-10-25	1
49365	2921	40481087	1995-12-24	1995-12-31	1
8799	515	40481087	1956-12-04	1956-12-25	1
63116	3731	40481087	2006-03-13	2006-03-27	1
35662	2116	4142905	2015-09-27	2015-12-26	1
80951	4807	260139	1981-01-03	1981-01-17	1
82466	4898	4112343	1983-02-11	1983-02-23	1
33564	1992	4048171	1978-03-29	1978-03-30	1
28527	1690	4094814	2015-12-17	2015-12-18	1
28014	1658	30753	1947-01-12	1947-01-13	1
26965	1597	4084167	1948-11-08	1948-11-08	1
39194	2328	81151	1959-06-03	1959-06-24	1
46255	2758	4266809	1980-06-09	1980-06-10	1
89668	5335	4113008	1975-08-18	1975-09-01	1
57928	3438	4142905	1934-09-03	1934-10-03	1
32300	1921	372328	1957-02-05	1957-08-26	1
56085	3325	28060	1964-06-12	1964-06-22	1
65635	3885	4112343	1966-10-29	1966-11-06	1
88206	5251	40481087	1938-09-21	1938-10-12	1
36752	2176	40481087	2017-05-24	2017-06-07	1
54391	3224	40481087	1963-03-05	1963-03-26	1
31567	1870	260139	1943-01-15	1943-01-30	1
5076	298	260139	1973-07-16	1973-07-30	1
4308	248	40481087	1997-11-13	1997-11-27	1
30918	1834	28060	1970-12-13	1970-12-25	1
72336	4297	80180	2017-02-14	2017-02-15	1
23579	1409	4294548	1936-02-02	1936-08-09	1
27789	1641	80180	1997-10-31	1997-11-01	1
49366	2921	80180	1979-05-25	1979-05-26	1
8800	515	40481087	1977-02-27	1977-03-20	1
64444	3813	4112343	1973-08-30	1973-09-12	1
35663	2116	40481087	1952-09-13	1952-09-20	1
80952	4807	260139	1988-07-27	1988-08-10	1
82467	4898	4112343	2017-05-09	2017-05-16	1
33565	1992	4134304	2015-10-24	2015-11-23	1
28528	1690	28060	1979-12-31	1980-01-12	1
28015	1658	192671	1948-01-29	1948-01-30	1
26966	1597	4112343	1973-02-08	1973-02-15	1
39195	2328	4027663	1988-09-18	1988-09-19	1
46256	2758	40481087	1994-11-12	1994-11-19	1
89669	5335	4218389	1981-09-29	1981-10-27	1
57929	3438	4283893	1939-04-25	1939-05-16	1
32301	1921	4112343	1954-10-09	1954-10-17	1
56086	3325	372328	1964-05-12	1964-05-26	1
65636	3885	40481087	1966-03-05	1966-03-19	1
88207	5251	40481087	1961-06-07	1961-06-14	1
36753	2176	28060	1975-02-19	1975-03-01	1
54392	3224	140673	2016-12-31	2017-01-01	1
31568	1870	40481087	1955-10-23	1955-10-30	1
5077	298	260139	2008-02-02	2008-02-16	1
4309	248	40481087	2012-03-01	2012-03-08	1
30919	1834	28060	1987-05-14	1987-05-23	1
72337	4297	196456	1991-02-19	1991-02-19	1
23580	1409	40481087	1920-03-23	1920-03-30	1
27790	1641	192671	1997-11-10	1997-11-11	1
49367	2921	372328	1940-07-18	1940-09-24	1
8801	515	140673	2009-03-05	2009-03-06	1
64445	3813	40481087	1986-12-17	1986-12-31	1
35664	2116	40481087	1975-01-17	1975-01-31	1
80953	4807	260139	2005-02-22	2005-03-08	1
82468	4898	4218389	1971-04-13	1971-05-11	1
33566	1992	80180	2019-01-26	2019-01-27	1
28529	1690	81151	2002-07-03	2002-08-07	1
28016	1658	260139	1974-10-12	1974-10-19	1
26967	1597	4152936	1960-06-10	1960-06-24	1
39196	2328	40481087	1955-07-01	1955-07-22	1
46257	2758	28060	2012-05-21	2012-06-03	1
89670	5335	40481087	1966-10-14	1966-10-28	1
57930	3438	40481087	1913-11-27	1913-12-18	1
32302	1921	4112343	1999-10-07	1999-10-16	1
56087	3325	372328	1966-01-16	1966-05-25	1
65637	3885	81151	1984-03-21	1984-04-18	1
88208	5251	40481087	1974-04-10	1974-04-24	1
36754	2176	80180	2000-06-30	2000-07-01	1
54393	3224	192671	2002-01-26	2002-01-27	1
32906	1954	4112343	1940-06-08	1940-06-18	1
5078	298	372328	1953-01-03	1953-03-17	1
4310	248	260139	1984-01-18	1984-01-25	1
30920	1834	260139	1971-06-11	1971-06-25	1
72338	4297	260139	1977-12-13	1977-12-27	1
23581	1409	40481087	1960-01-17	1960-02-07	1
27791	1641	372328	1957-07-08	1957-08-28	1
49368	2921	40481087	1968-09-29	1968-10-20	1
8802	515	372328	1943-04-25	1943-08-28	1
64446	3813	4237458	1982-09-11	1982-12-10	1
35665	2116	40481087	1977-07-27	1977-08-10	1
80954	4807	260139	2012-04-08	2012-04-22	1
82469	4898	4283893	1956-03-07	1956-03-28	1
33567	1992	81151	2016-09-18	2016-10-23	1
28530	1690	257012	2012-09-12	2012-09-13	1
28017	1658	372328	1914-11-25	1915-04-05	1
26968	1597	4294548	1984-09-04	1984-12-25	1
39197	2328	40481087	1970-07-24	1970-07-31	1
46258	2758	78272	1943-12-02	1943-12-23	1
89671	5335	40481087	2007-04-06	2007-04-13	1
57931	3438	40481087	1988-06-02	1988-06-09	1
32303	1921	4156265	1988-07-25	1988-08-15	1
56088	3325	4112343	2005-03-11	2005-03-24	1
65638	3885	260139	2005-09-19	2005-09-26	1
88209	5251	28060	1933-01-04	1933-01-11	1
36755	2176	260139	1959-01-08	1959-01-22	1
54394	3224	40481087	1987-10-14	1987-10-21	1
32907	1954	4112343	1976-08-16	1976-08-23	1
5079	298	372328	1955-09-03	1956-02-07	1
4311	248	378001	2016-11-08	2016-12-08	1
30921	1834	260139	1988-12-08	1988-12-22	1
72339	4297	4134304	1978-09-07	1978-11-06	1
23582	1409	40481087	1998-10-16	1998-10-23	1
27792	1641	378001	1976-08-21	1976-10-20	1
49369	2921	40481087	1985-05-14	1985-05-21	1
8803	515	4059173	2012-08-02	2012-10-31	1
64447	3813	260139	1995-08-06	1995-08-13	1
35666	2116	40481087	1987-03-09	1987-03-23	1
80955	4807	4112343	1948-04-16	1948-04-25	1
84778	5048	28060	1970-06-27	1970-07-08	1
33568	1992	378001	1976-04-16	1976-06-15	1
28531	1690	375671	2013-11-27	2013-12-27	1
28018	1658	4116491	1946-04-22	1946-05-26	1
27291	1611	28060	1981-04-10	1981-04-23	1
39198	2328	28060	1960-12-26	1961-01-04	1
46259	2758	81893	1979-02-15	1979-02-16	1
89672	5335	81151	1972-06-29	1972-08-03	1
57932	3438	28060	1957-11-20	1957-11-27	1
32304	1921	40481087	1963-06-02	1963-06-23	1
56089	3325	4112343	2005-07-26	2005-08-06	1
65639	3885	260139	2014-06-18	2014-06-25	1
88210	5251	192671	1962-05-29	1962-05-30	1
36756	2176	372328	1957-09-14	1957-10-28	1
54395	3224	28060	1960-03-19	1960-04-01	1
32908	1954	4112343	1982-12-22	1983-01-02	1
5080	298	4112343	1975-08-24	1975-09-03	1
4312	248	4112343	1983-12-06	1983-12-18	1
30922	1834	317576	2014-07-20	2014-07-21	1
72340	4297	40481087	2005-03-27	2005-04-03	1
23583	1409	28060	1971-04-10	1971-04-20	1
27793	1641	378001	1982-08-20	1982-09-19	1
49370	2921	40481087	2011-01-19	2011-02-09	1
8804	515	4112343	1961-11-14	1961-11-26	1
64448	3813	378001	1997-11-12	1998-01-11	1
35667	2116	40481087	2005-03-06	2005-03-27	1
80956	4807	4155034	1954-03-03	1954-03-17	1
84779	5048	81151	1999-06-24	1999-07-08	1
33569	1992	4112343	1983-07-22	1983-07-30	1
28532	1690	4278672	1978-05-10	1978-08-08	1
28019	1658	4266809	1948-01-07	1948-01-08	1
27292	1611	260139	1968-12-13	1968-12-27	1
39199	2328	257012	1992-11-17	1992-11-18	1
46260	2758	372328	1940-08-28	1940-11-08	1
89673	5335	40481087	1970-08-13	1970-08-27	1
57933	3438	80180	1946-12-29	1946-12-30	1
37580	2231	28060	2012-12-02	2012-12-15	1
56090	3325	4283893	1973-12-27	1974-02-14	1
65640	3885	4112343	1967-06-05	1967-06-17	1
88211	5251	260139	1954-04-12	1954-04-27	1
36757	2176	4266809	2000-06-30	2000-07-01	1
54396	3224	4112343	1971-09-05	1971-09-16	1
32909	1954	4112343	1988-05-06	1988-05-15	1
5081	298	4112343	2018-09-02	2018-09-14	1
4313	248	40481087	2016-04-25	2016-05-09	1
30923	1834	40481087	2007-08-31	2007-09-07	1
72341	4297	40481087	2010-08-10	2010-08-31	1
23584	1409	260139	1997-11-17	1997-12-01	1
27794	1641	4027663	1987-09-14	1987-09-15	1
49371	2921	372328	1941-01-22	1941-02-25	1
8805	515	4283893	1958-06-26	1958-09-11	1
64449	3813	40481087	1979-02-08	1979-02-22	1
35668	2116	40481087	2008-12-26	2009-01-16	1
80957	4807	4218389	1971-05-17	1971-06-14	1
84780	5048	4048171	1962-10-30	1977-10-28	1
33570	1992	40481087	1984-04-10	1984-04-24	1
28533	1690	4283893	1996-06-13	1996-08-01	1
28020	1658	40481087	1940-01-29	1940-02-12	1
27293	1611	260139	2011-10-12	2011-10-19	1
39200	2328	260139	1972-05-15	1972-05-22	1
46261	2758	4027663	1972-02-22	1972-02-23	1
57934	3438	378419	1986-09-20	1986-09-21	1
37581	2231	80180	2008-07-18	2008-07-19	1
633	36	260139	1966-07-12	1966-07-26	1
65641	3885	4112343	2009-04-02	2009-04-11	1
88212	5251	4043241	1970-05-25	1970-05-26	1
36758	2176	40481087	1956-10-26	1956-11-09	1
54397	3224	4116491	2000-01-05	2000-02-13	1
32910	1954	4152936	1981-05-29	1981-06-12	1
5082	298	40481087	1953-08-09	1953-08-16	1
5089	299	192671	2000-10-07	2000-10-08	1
30924	1834	28060	2016-05-17	2016-05-30	1
75006	4460	260139	2008-08-21	2008-08-28	1
23585	1409	4001336	1921-02-07	1921-03-09	1
27795	1641	4112343	1963-08-09	1963-08-20	1
49372	2921	4112343	1960-05-18	1960-05-28	1
11243	665	4218389	1992-02-22	1992-03-14	1
64450	3813	40481087	2016-01-23	2016-02-06	1
35669	2116	192671	1990-10-19	1990-10-20	1
80958	4807	4283893	1958-12-15	1959-09-14	1
84781	5048	4112343	1981-06-11	1981-06-19	1
33571	1992	81893	2017-07-05	2017-07-06	1
28534	1690	4283893	2012-08-15	2012-10-17	1
28021	1658	40481087	1944-06-09	1944-06-30	1
27294	1611	381316	2017-04-09	2017-04-10	1
39201	2328	260139	2009-12-08	2009-12-15	1
46262	2758	4112343	1947-01-27	1947-02-06	1
57935	3438	40481087	1919-09-27	1919-10-11	1
37582	2231	440086	1977-05-07	1988-05-14	1
634	36	372328	1961-10-17	1962-03-27	1
65642	3885	40481087	1969-07-20	1969-07-27	1
88213	5251	4094814	1931-10-27	1931-12-26	1
36759	2176	40481087	1973-01-12	1973-01-26	1
54398	3224	4283893	2012-02-18	2012-04-07	1
32911	1954	4296205	1972-11-07	1972-12-12	1
5083	298	40481087	2007-05-12	2007-05-19	1
5090	299	378001	1995-06-14	1995-07-14	1
30925	1834	257012	1969-04-28	1969-05-05	1
75007	4460	375671	1949-03-22	1949-04-21	1
23586	1409	4112343	1930-12-18	1930-12-27	1
27796	1641	40481087	1959-12-15	1959-12-22	1
49373	2921	40481087	1970-10-16	1970-10-23	1
11244	665	40481087	1958-12-18	1959-01-08	1
64451	3813	80180	2006-07-12	2006-07-13	1
35670	2116	260139	1972-07-04	1972-07-18	1
80959	4807	40481087	1976-03-26	1976-04-09	1
84782	5048	4116491	1976-10-19	1976-11-21	1
33572	1992	195588	2011-03-14	2011-04-29	1
28535	1690	80180	2009-12-12	2009-12-13	1
28022	1658	40481087	1957-04-11	1957-04-25	1
27295	1611	440448	1989-05-31	1989-06-01	1
39202	2328	372328	1955-08-23	1955-12-05	1
46263	2758	4112343	1975-08-19	1975-08-27	1
57936	3438	40481087	1988-09-14	1988-10-05	1
37583	2231	4218389	2010-09-20	2010-10-11	1
635	36	4112343	2004-04-22	2004-05-03	1
65643	3885	40481087	1972-09-14	1972-10-05	1
88214	5251	4156265	1923-03-24	1923-04-14	1
36760	2176	30753	1999-09-04	1999-09-05	1
54399	3224	260139	1981-02-18	1981-02-25	1
32912	1954	40479768	1960-05-07	1960-06-13	1
5084	298	40481087	2010-11-07	2010-11-28	1
5091	299	4294548	1971-02-11	1971-03-04	1
30926	1834	260139	1955-05-18	1955-06-01	1
75008	4460	378001	1984-01-09	1984-02-08	1
23587	1409	4112343	1933-04-17	1933-04-27	1
27797	1641	4112343	1976-02-12	1976-02-25	1
49832	2949	260139	1978-12-11	1978-12-25	1
11245	665	40481087	2007-09-19	2007-10-10	1
64452	3813	260139	2012-10-01	2012-10-15	1
35671	2116	260139	2005-12-02	2005-12-16	1
80960	4807	40481087	1988-07-14	1988-07-21	1
84783	5048	4218389	1966-08-13	1966-09-10	1
33573	1992	257012	2014-05-18	2014-05-19	1
28536	1690	260139	1985-05-05	1985-05-12	1
28023	1658	40481087	1964-07-23	1964-08-13	1
27296	1611	4112343	1977-02-16	1977-02-28	1
39203	2328	4266809	1999-05-04	1999-05-05	1
46264	2758	4112343	1979-12-26	1980-01-07	1
57937	3438	40481087	1991-04-28	1991-05-12	1
37584	2231	40481087	1979-11-26	1979-12-03	1
636	36	80180	1993-05-30	1993-05-31	1
65644	3885	81151	1980-05-27	1980-06-10	1
88215	5251	40481087	1964-05-07	1964-05-21	1
36761	2176	78272	1994-12-25	1995-01-29	1
54400	3224	260139	1983-01-18	1983-02-01	1
32913	1954	40481087	1954-05-29	1954-06-19	1
5085	298	260139	1967-02-24	1967-03-10	1
5092	299	40481087	2008-06-09	2008-06-16	1
30927	1834	260139	1969-10-02	1969-10-09	1
75009	4460	4278672	2003-07-19	2003-08-18	1
23588	1409	4132546	1921-02-07	1921-02-08	1
27798	1641	4149245	1962-06-17	1962-07-24	1
49833	2949	372328	1950-10-23	1951-01-02	1
11246	665	40481087	2009-05-09	2009-05-23	1
64453	3813	4156265	1994-11-07	1994-11-28	1
35672	2116	40481087	1966-04-15	1966-04-29	1
80961	4807	80180	1981-03-10	1981-03-11	1
84784	5048	4218389	1993-08-03	1993-08-24	1
33574	1992	260139	1984-03-06	1984-03-13	1
28537	1690	4112343	1981-10-05	1981-10-13	1
28024	1658	40481087	1968-09-30	1968-10-14	1
27297	1611	40481087	1972-05-25	1972-06-15	1
39204	2328	4283893	1993-08-22	1993-10-03	1
46265	2758	4146173	1983-12-07	1984-02-05	1
57938	3438	195588	1938-04-10	1938-06-02	1
37585	2231	260139	1990-08-28	1990-09-04	1
637	36	260139	1988-10-26	1988-11-09	1
65645	3885	81151	2001-10-28	2001-11-11	1
88216	5251	40481087	1970-08-09	1970-08-23	1
36762	2176	372328	1960-08-13	1961-07-24	1
54401	3224	40481087	1969-06-30	1969-07-21	1
32914	1954	40481087	1960-09-22	1960-09-29	1
5086	298	260139	1989-11-18	1989-11-25	1
5093	299	40481087	2010-07-14	2010-07-21	1
30928	1834	260139	1993-12-09	1993-12-23	1
75010	4460	40481087	1950-03-22	1950-04-05	1
23589	1409	4134304	1946-05-23	1946-07-22	1
27799	1641	4266809	1997-10-31	1997-11-01	1
49834	2949	4218389	1995-12-03	1995-12-31	1
11247	665	80180	1993-08-10	1993-08-11	1
64454	3813	40481087	1994-04-02	1994-04-23	1
35673	2116	40481087	1978-08-11	1978-09-01	1
80962	4807	260139	1974-03-15	1974-03-22	1
84785	5048	4285898	1991-08-07	1991-08-08	1
33575	1992	4112343	1985-10-20	1985-11-02	1
28538	1690	4112343	1999-06-24	1999-07-07	1
28025	1658	40481087	1971-11-04	1971-11-25	1
27298	1611	40481087	2011-10-15	2011-11-05	1
39205	2328	4283893	2012-10-18	2012-12-06	1
46266	2758	4152936	1941-12-21	1942-01-11	1
57939	3438	255848	1991-12-23	1991-12-24	1
37586	2231	4112343	1977-11-29	1977-12-08	1
638	36	260139	1996-04-28	1996-05-13	1
65646	3885	260139	1987-09-19	1987-09-26	1
2055	120	81151	1979-12-28	1980-01-18	1
36763	2176	378001	1968-04-15	1968-06-14	1
54402	3224	40481087	1975-07-27	1975-08-10	1
32915	1954	40481087	1984-02-25	1984-03-10	1
5087	298	260139	2004-11-11	2004-11-18	1
5094	299	80180	2000-07-22	2000-07-23	1
30929	1834	375671	1982-04-05	1982-06-04	1
75011	4460	40481087	1981-12-18	1981-12-25	1
23590	1409	4156265	2012-09-03	2012-09-24	1
27800	1641	40481087	1960-09-25	1960-10-02	1
49835	2949	4218389	2010-05-30	2010-07-04	1
11248	665	260139	2006-07-31	2006-08-07	1
64455	3813	40481087	2002-11-16	2002-11-23	1
35674	2116	40481087	2019-06-11	2019-06-18	1
80963	4807	440086	1953-03-27	1963-04-04	1
84786	5048	40481087	2008-05-09	2008-05-16	1
33576	1992	40481087	2015-12-19	2016-01-02	1
28539	1690	40481087	2003-10-01	2003-10-15	1
28026	1658	40481087	1972-06-27	1972-07-04	1
27299	1611	40481087	2017-01-14	2017-01-28	1
39206	2328	4296205	1991-01-07	1991-02-04	1
46267	2758	40481087	1944-02-17	1944-02-24	1
57940	3438	260139	1927-01-03	1927-01-10	1
37587	2231	4278672	1982-09-03	1982-11-02	1
639	36	372328	1963-07-20	1963-10-01	1
65647	3885	260139	2003-06-06	2003-06-13	1
2056	120	40481087	1983-06-16	1983-07-07	1
36764	2176	4027663	1990-08-12	1990-08-13	1
57039	3389	260139	1998-04-05	1998-04-19	1
32916	1954	28060	1997-11-05	1997-11-13	1
5088	298	4296205	2014-02-11	2014-03-04	1
5095	299	260139	1975-01-31	1975-02-07	1
30930	1834	40481087	2013-03-15	2013-04-05	1
75012	4460	40481087	1985-12-31	1986-01-14	1
23591	1409	4283893	1976-06-18	1976-08-27	1
27801	1641	40481087	1979-01-31	1979-02-21	1
49836	2949	40479768	1974-10-17	1974-11-23	1
11249	665	4112343	1958-03-21	1958-03-29	1
65954	3904	28060	1986-04-17	1986-04-27	1
35675	2116	80180	1990-10-04	1990-10-05	1
80964	4807	4112343	1961-02-19	1961-03-02	1
84787	5048	40481087	2012-05-04	2012-05-11	1
33577	1992	81151	1992-10-19	1992-11-23	1
28540	1690	40481087	2007-01-05	2007-01-19	1
28027	1658	28060	1926-06-21	1926-06-29	1
27300	1611	0	1989-05-31	1989-06-01	1
39207	2328	40481087	1977-08-02	1977-08-16	1
46268	2758	40481087	1959-09-29	1959-10-13	1
57941	3438	439777	1980-03-30	1980-03-31	1
37588	2231	40481087	2016-12-12	2016-12-26	1
640	36	4155034	2011-07-06	2011-07-27	1
65648	3885	4112343	1977-06-06	1977-06-17	1
2057	120	40481087	1999-05-28	1999-06-18	1
36765	2176	4112343	1963-09-05	1963-09-16	1
57040	3389	4112343	2010-03-14	2010-03-27	1
32917	1954	80180	1970-08-14	1970-08-15	1
5892	348	4152936	2015-11-21	2015-12-05	1
5096	299	313217	2018-06-30	2018-07-01	1
30931	1834	28060	1985-01-13	1985-01-21	1
75013	4460	80180	1979-10-21	1979-10-22	1
23592	1409	40481087	1941-12-20	1942-01-03	1
27802	1641	40481087	1983-03-09	1983-03-16	1
49837	2949	40481087	1969-06-21	1969-06-28	1
11250	665	4112343	1964-07-26	1964-08-04	1
65955	3904	260139	1995-05-05	1995-05-12	1
35676	2116	4112343	1971-07-04	1971-07-16	1
80965	4807	4112343	1975-01-17	1975-01-28	1
84788	5048	195588	1982-11-20	1983-01-13	1
33578	1992	4112343	1977-11-10	1977-11-17	1
28541	1690	40481087	2012-02-27	2012-03-13	1
28028	1658	28060	2005-02-26	2005-03-08	1
27301	1611	4112343	1998-12-23	1999-01-05	1
40549	2414	260139	1944-10-31	1944-11-07	1
46269	2758	40481087	1989-04-16	1989-05-07	1
57942	3438	4027663	1939-04-10	1939-04-11	1
37589	2231	260139	1981-07-11	1981-07-25	1
641	36	40481087	1959-01-28	1959-02-18	1
65649	3885	4116491	1995-11-08	1996-01-05	1
2058	120	372328	1978-12-15	1979-03-17	1
36766	2176	4283893	1990-11-27	1991-01-15	1
57041	3389	4283893	2001-04-15	2001-05-27	1
32918	1954	260139	1964-05-04	1964-05-11	1
5893	348	78272	1991-05-05	1991-06-09	1
5097	299	40481087	2007-05-16	2007-06-06	1
30932	1834	80180	1986-07-13	1986-07-14	1
75014	4460	260139	1989-04-05	1989-04-12	1
23593	1409	40481087	1943-03-05	1943-03-26	1
27803	1641	40481087	1988-05-23	1988-06-06	1
49838	2949	40481087	1981-08-10	1981-08-31	1
11251	665	4296205	1993-01-08	1993-01-22	1
65956	3904	40481087	2010-05-20	2010-05-27	1
35677	2116	4112343	1979-12-05	1979-12-16	1
80966	4807	40481087	1967-11-09	1967-11-30	1
84789	5048	260139	1959-10-20	1959-10-27	1
33579	1992	4294548	2014-04-27	2014-06-22	1
31364	1855	4027663	2004-03-13	2004-03-14	1
28029	1658	80502	1992-01-27	1992-01-28	1
27302	1611	4112343	2003-01-28	2003-02-10	1
40550	2414	260139	1981-10-29	1981-11-05	1
46270	2758	40481087	2006-01-14	2006-01-28	1
57943	3438	4112343	1916-08-10	1916-08-23	1
37590	2231	4109685	2017-07-06	2017-07-27	1
642	36	40481087	1988-03-23	1988-03-30	1
65650	3885	4152936	1987-11-29	1987-12-20	1
2059	120	378001	1983-01-02	1983-03-03	1
36767	2176	40481087	1973-03-02	1973-03-23	1
57042	3389	40481087	1966-06-29	1966-07-06	1
32919	1954	4112343	1967-06-15	1967-06-24	1
5894	348	260139	1994-12-16	1994-12-30	1
5098	299	28060	1962-04-09	1962-04-17	1
30933	1834	257012	2006-05-02	2006-05-03	1
75015	4460	4112343	1956-06-05	1956-06-15	1
23594	1409	40481087	1943-10-30	1943-11-06	1
28215	1669	258780	1998-02-16	1998-02-17	1
49839	2949	40481087	1991-06-16	1991-06-30	1
11252	665	40481087	1963-03-23	1963-04-06	1
65957	3904	260139	1991-06-21	1991-06-28	1
35678	2116	4112343	1984-12-21	1985-01-02	1
80967	4807	28060	1961-04-05	1961-04-13	1
84790	5048	372328	1964-09-06	1965-08-13	1
33580	1992	4310024	2017-02-05	2017-02-06	1
31365	1855	4051466	1977-03-27	1994-06-29	1
28030	1658	317576	1996-02-19	1996-02-20	1
27303	1611	4134304	1991-07-28	1991-10-26	1
40551	2414	4112343	1961-12-27	1962-01-07	1
47724	2837	4112343	1974-05-09	1974-05-22	1
57944	3438	4142905	1924-06-27	1924-08-26	1
37591	2231	4112343	1986-08-26	1986-09-07	1
643	36	40481087	1991-10-16	1991-10-30	1
65651	3885	4296205	1973-09-10	1973-10-01	1
2060	120	4112343	1988-04-28	1988-05-08	1
36768	2176	40481087	2003-10-04	2003-10-11	1
57043	3389	80180	1996-06-08	1996-06-09	1
32920	1954	4112343	1995-10-08	1995-10-15	1
5895	348	372328	1977-08-16	1978-01-02	1
5099	299	260139	2011-11-27	2011-12-04	1
30934	1834	372328	1946-10-31	1947-01-12	1
75016	4460	4112343	1968-02-17	1968-02-24	1
29332	1739	78272	2016-08-23	2016-09-27	1
28216	1669	317576	1996-11-18	1996-11-19	1
49840	2949	257012	1980-10-01	1980-10-02	1
11253	665	40481087	1964-07-08	1964-07-15	1
65958	3904	372328	1984-12-03	1985-02-07	1
35679	2116	40481087	1990-07-11	1990-07-25	1
80968	4807	80502	2006-03-09	2006-03-10	1
84791	5048	4155034	1975-11-22	1975-12-06	1
33581	1992	40481087	1995-08-31	1995-09-07	1
31366	1855	4109685	1995-01-24	1995-02-14	1
28031	1658	378001	1912-04-25	1912-05-25	1
27304	1611	4294548	2002-10-06	2002-10-27	1
40552	2414	4116491	1980-04-02	1980-05-08	1
47725	2837	4112343	1991-06-04	1991-06-17	1
57945	3438	4218389	1965-10-20	1965-11-10	1
37592	2231	4112343	1987-11-05	1987-11-12	1
644	36	28060	1959-11-18	1959-11-29	1
65652	3885	40481087	2018-10-10	2018-10-17	1
2061	120	4112343	2019-05-30	2019-06-08	1
36769	2176	40481087	2004-01-14	2004-01-28	1
57044	3389	260139	2005-02-04	2005-02-18	1
32921	1954	40481087	1942-01-03	1942-01-10	1
5896	348	40481087	1977-05-25	1977-06-08	1
5100	299	40481087	1978-12-28	1979-01-11	1
30935	1834	440086	1960-01-31	1964-02-09	1
75017	4460	4112343	1973-12-26	1974-01-03	1
29333	1739	81151	1973-02-14	1973-03-07	1
28217	1669	372328	1964-02-06	1965-01-18	1
49841	2949	372328	1951-03-03	1951-04-03	1
11254	665	260139	1995-08-02	1995-08-16	1
65959	3904	4116491	2005-02-15	2005-04-05	1
35680	2116	40481087	1995-08-05	1995-08-19	1
80969	4807	260139	1957-10-24	1957-11-07	1
84792	5048	4156265	2007-12-23	2008-01-06	1
33582	1992	40481087	2011-01-21	2011-02-04	1
31367	1855	4112343	1990-05-03	1990-05-12	1
28032	1658	439777	1912-04-30	1912-05-01	1
27305	1611	81151	2013-11-29	2013-12-20	1
40553	2414	4237458	1933-04-29	1933-07-28	1
47726	2837	4112343	1998-03-15	1998-03-23	1
57946	3438	4294548	1930-04-20	1930-05-04	1
37593	2231	40481087	2007-07-14	2007-07-28	1
645	36	133834	1960-06-19	1960-06-20	1
68204	4033	257012	2018-02-19	2018-02-20	1
2062	120	4146173	2004-01-12	2004-03-12	1
36770	2176	40481087	2016-12-25	2017-01-15	1
57045	3389	4112343	2004-09-02	2004-09-09	1
32922	1954	40481087	1984-05-16	1984-06-06	1
5897	348	40481087	2001-05-22	2001-06-12	1
5101	299	40481087	1983-11-24	1983-12-15	1
30936	1834	4112343	1954-10-22	1954-11-04	1
75018	4460	40481087	1979-08-10	1979-08-24	1
29334	1739	439777	1986-04-07	1986-04-08	1
28218	1669	4134304	1965-01-22	1965-04-22	1
49842	2949	4059173	1956-05-24	1956-06-23	1
11255	665	4059173	1966-12-30	1967-03-30	1
65960	3904	4152936	2006-01-01	2006-01-22	1
35681	2116	40481087	2006-06-29	2006-07-13	1
80970	4807	378001	1957-10-27	1957-12-26	1
84793	5048	4278672	2016-05-23	2016-08-21	1
36850	2184	81151	1973-01-14	1973-02-11	1
31368	1855	4113008	1996-12-05	1996-12-26	1
28033	1658	4027663	1936-04-24	1936-04-25	1
27306	1611	260139	1977-06-21	1977-07-05	1
40554	2414	40481087	1984-11-22	1984-12-13	1
47727	2837	40481087	1975-09-21	1975-09-28	1
57947	3438	4310024	1945-10-05	1945-10-06	1
37594	2231	4156265	2006-12-26	2007-01-09	1
646	36	260139	2012-06-04	2012-06-11	1
68205	4033	372328	2017-02-03	2018-04-24	1
2063	120	4155034	2016-03-30	2016-04-13	1
38602	2294	80180	1997-09-02	1997-09-03	1
57046	3389	4112343	2013-12-08	2013-12-17	1
32923	1954	40481087	2004-12-06	2004-12-20	1
5898	348	260139	2003-11-29	2003-12-06	1
5102	299	40481087	2000-10-24	2000-11-14	1
30937	1834	4112343	1998-05-10	1998-05-19	1
75019	4460	28060	1951-12-08	1951-12-16	1
29335	1739	4112343	1969-03-11	1969-03-22	1
28219	1669	40481087	1960-02-05	1960-02-19	1
49843	2949	4112343	1992-04-04	1992-04-16	1
11256	665	4112343	1997-12-11	1997-12-24	1
65961	3904	40481087	1999-07-16	1999-07-23	1
35682	2116	40481087	2009-10-19	2009-11-02	1
80971	4807	4116491	2002-03-15	2002-07-13	2
84794	5048	40481087	1964-08-31	1964-09-07	1
36851	2184	192671	2003-02-26	2003-02-27	1
31369	1855	4155034	1991-12-27	1992-01-10	1
28034	1658	4112343	1929-06-15	1929-06-28	1
27307	1611	4112343	2002-12-18	2002-12-25	1
40555	2414	40481087	1985-06-19	1985-07-03	1
47728	2837	40481087	1993-07-16	1993-07-30	1
57948	3438	80502	1989-06-17	1989-06-18	1
40415	2404	28060	1979-11-07	1979-11-16	1
647	36	313217	2018-01-09	2018-01-10	1
68206	4033	4112343	2009-05-02	2009-05-15	1
2064	120	4237458	1992-11-10	1993-02-08	1
38603	2294	4112343	1994-11-28	1994-12-11	1
57047	3389	4278672	1976-07-28	1976-09-26	1
32924	1954	4043241	1998-12-24	1998-12-25	1
5899	348	372328	1979-08-25	1980-07-07	1
5103	299	40481087	2006-01-24	2006-02-14	1
30938	1834	4134304	1955-11-18	1955-12-18	1
75020	4460	260139	1987-11-04	1987-11-11	1
29336	1739	4112343	2018-01-28	2018-02-07	1
28220	1669	40481087	1998-02-01	1998-02-15	1
49844	2949	4156265	2006-08-05	2006-08-19	1
11257	665	4112343	2018-01-21	2018-02-02	1
65962	3904	40481087	2013-08-01	2013-08-22	1
38188	2270	440086	1992-05-27	1996-06-05	1
80972	4807	4155034	1946-03-24	1946-04-14	1
84795	5048	40481087	1965-05-11	1965-06-01	1
36852	2184	378001	1970-01-30	1970-03-01	1
31370	1855	40481087	1992-12-14	1992-12-21	1
28035	1658	4112343	2001-01-01	2001-01-14	1
27308	1611	4156265	1972-11-20	1972-12-04	1
40556	2414	40481087	1994-11-22	1994-12-06	1
47729	2837	80180	2008-01-10	2008-01-11	1
57949	3438	260139	1918-03-02	1918-03-16	1
40416	2404	81151	1974-01-22	1974-02-12	1
648	36	372328	1959-04-19	1959-06-30	1
68207	4033	40481087	1997-08-18	1997-09-01	1
2065	120	80180	2017-03-18	2017-03-19	1
38604	2294	4113008	2018-11-10	2018-12-01	1
57048	3389	40481087	1978-04-10	1978-04-17	1
32925	1954	4112343	1944-09-28	1944-10-11	1
5900	348	4112343	1978-05-16	1978-05-26	1
5104	299	28060	1967-04-09	1967-04-17	1
30939	1834	4237458	1960-04-25	1960-06-24	1
75021	4460	260139	2009-07-26	2009-08-02	1
29337	1739	40481087	2017-04-12	2017-04-19	1
28221	1669	40481087	2002-03-05	2002-03-26	1
49845	2949	40481087	1969-03-24	1969-04-14	1
11258	665	40481087	1979-01-06	1979-01-27	1
65963	3904	80180	2015-01-04	2015-01-05	1
38189	2270	4112343	2012-05-29	2012-06-11	1
82240	4884	4296204	2006-12-06	2006-12-27	1
84796	5048	40481087	1987-01-20	1987-02-03	1
36853	2184	4051466	1970-02-21	1986-05-28	1
31371	1855	40481087	2005-10-02	2005-10-09	1
28036	1658	4113008	1928-01-07	1928-01-21	1
27309	1611	40481087	1999-07-03	1999-07-17	1
40557	2414	28060	1940-07-07	1940-07-16	1
47730	2837	440448	1996-07-28	1996-07-29	1
57950	3438	260139	1977-08-11	1977-08-18	1
40417	2404	381316	1997-07-13	1997-07-14	1
649	36	4116491	2014-10-07	2014-11-24	1
68208	4033	40481087	2009-07-14	2009-07-21	1
2066	120	260139	2000-11-08	2000-11-22	1
38605	2294	4283893	1980-02-05	1980-03-18	1
57049	3389	40481087	1991-06-15	1991-06-29	1
32926	1954	4155034	1952-12-01	1952-12-15	1
5901	348	4237458	1990-01-10	1990-04-10	1
5105	299	81151	2015-07-29	2015-08-26	1
30940	1834	4283893	1969-04-07	1969-05-05	1
75022	4460	4113008	1993-12-17	1994-01-07	1
29338	1739	133834	1970-05-08	1970-05-09	1
28222	1669	80180	1998-10-15	1998-10-16	1
49846	2949	40481087	1991-10-07	1991-10-28	1
11259	665	40481087	2000-04-25	2000-05-02	1
65964	3904	372328	1979-05-23	1979-08-02	1
38190	2270	40481087	1989-01-16	1989-01-30	1
82241	4884	40481087	1976-10-08	1976-10-22	1
84797	5048	30753	1991-01-09	1991-01-10	1
36854	2184	4155034	1993-05-27	1993-06-17	1
31372	1855	260139	2016-10-31	2016-11-14	1
28037	1658	4310024	1945-05-22	1945-05-23	1
27310	1611	28060	1952-08-09	1952-08-22	1
40558	2414	28060	1964-11-23	1964-12-04	1
47731	2837	4112343	1969-08-18	1969-08-30	1
57951	3438	4146173	1942-07-23	1942-09-21	1
40418	2404	4112343	1987-04-09	1987-04-18	1
650	36	4283893	1971-04-07	1971-05-19	1
68209	4033	260139	2010-09-06	2010-09-20	1
2067	120	4218389	2007-07-25	2007-08-15	1
38606	2294	40481087	1967-06-10	1967-07-01	1
57050	3389	40481087	1991-10-06	1991-10-13	1
32927	1954	255848	2006-04-16	2006-04-17	1
5902	348	4296205	1994-03-25	1994-04-15	1
5106	299	260139	2017-06-06	2017-06-20	1
30941	1834	4294548	2006-04-04	2006-05-30	1
75023	4460	4134304	2012-04-02	2012-06-01	1
29339	1739	260139	1985-06-13	1985-06-27	1
28223	1669	440086	1970-01-30	1977-02-07	1
49847	2949	80180	1986-04-02	1986-04-03	1
11260	665	40481087	2006-07-05	2006-07-19	1
65965	3904	40481087	2008-12-11	2008-12-18	1
38191	2270	40481087	2012-03-15	2012-03-22	1
82242	4884	40481087	1982-01-31	1982-02-14	1
84798	5048	81893	1990-12-10	1990-12-11	1
36855	2184	40481087	1975-02-08	1975-03-01	1
31373	1855	4112343	2005-11-21	2005-12-01	1
28038	1658	40480160	1995-04-14	1995-06-13	1
27311	1611	80180	1997-10-10	1997-10-11	1
40559	2414	80180	1957-04-14	1957-04-15	1
47732	2837	4112343	2018-10-18	2018-10-27	1
57952	3438	40481087	1920-02-13	1920-03-05	1
40419	2404	4134304	1968-08-21	1968-11-19	1
651	36	4294548	2010-10-25	2010-11-29	1
68210	4033	260139	2016-04-11	2016-04-18	1
2068	120	4283893	1997-03-02	1997-03-30	1
38607	2294	40481087	1995-02-05	1995-02-26	1
57051	3389	40481087	1994-09-04	1994-09-11	1
32928	1954	372328	1936-12-25	1937-04-08	1
5903	348	40481087	1984-03-21	1984-03-28	1
5107	299	260139	2019-01-12	2019-01-19	1
30942	1834	40481087	1954-07-10	1954-07-17	1
75024	4460	4155034	1961-03-19	1961-04-09	1
29340	1739	372328	1972-04-20	1973-03-22	1
28224	1669	4112343	1985-01-20	1985-01-30	1
49848	2949	4112343	2019-04-11	2019-04-21	1
11261	665	40481087	2010-10-23	2010-11-06	1
65966	3904	40481087	2014-04-24	2014-05-08	1
38192	2270	4112343	1996-04-12	1996-04-22	1
82243	4884	80180	2016-02-28	2016-02-29	1
84799	5048	260139	1995-02-26	1995-03-12	1
36856	2184	260139	2012-05-19	2012-06-02	1
31374	1855	4310024	2013-10-07	2013-10-08	1
28039	1658	40481087	1926-06-01	1926-06-15	1
27312	1611	260139	1990-09-07	1990-09-21	1
40560	2414	260139	1954-05-30	1954-06-13	1
47733	2837	40481087	1979-02-28	1979-03-07	1
58327	3458	40481087	2017-04-07	2017-04-21	1
40420	2404	40481087	1987-11-30	1987-12-21	1
652	36	40481087	1970-05-22	1970-06-05	1
68211	4033	4294548	2009-03-06	2009-05-09	1
2069	120	372328	1978-06-06	1978-09-16	1
38608	2294	40481087	2006-02-04	2006-02-18	1
57052	3389	40481087	2010-08-12	2010-09-02	1
32929	1954	378001	1964-04-23	1964-05-23	1
5904	348	28060	1986-03-16	1986-03-27	1
5108	299	261325	2013-12-21	2013-12-22	1
30943	1834	40481087	1961-03-21	1961-03-28	1
75025	4460	40481087	1965-09-22	1965-10-13	1
29341	1739	4112343	1994-09-11	1994-09-18	1
28225	1669	4310024	1997-05-23	1997-05-24	1
49849	2949	4134304	1960-03-04	1960-05-03	1
11262	665	81151	1986-08-17	1986-09-21	1
65967	3904	260139	2009-06-09	2009-06-16	1
38193	2270	40481087	1986-12-17	1986-12-31	1
82244	4884	372328	1973-03-20	1973-06-30	1
84800	5048	372328	1961-07-10	1961-07-24	1
36857	2184	40481087	1994-10-26	1994-11-02	1
31375	1855	40481087	1992-02-26	1992-03-11	1
28040	1658	40481087	1937-07-16	1937-08-06	1
27313	1611	372328	1955-07-23	1955-11-13	1
40561	2414	260139	1989-07-08	1989-07-22	1
47734	2837	0	1996-07-28	1996-07-29	1
58328	3458	81151	1983-06-30	1983-07-21	1
40421	2404	40481087	1989-04-21	1989-05-12	1
653	36	40481087	1982-01-11	1982-01-18	1
68212	4033	40481087	2000-03-24	2000-03-31	1
2070	120	4112343	1981-08-22	1981-09-01	1
38609	2294	40481087	2009-06-09	2009-06-23	1
57053	3389	28060	2003-03-28	2003-04-10	1
32930	1954	4059173	1949-12-17	1950-02-15	1
5905	348	80180	2010-07-09	2010-07-10	1
5109	299	4112343	1965-10-29	1965-11-11	1
30944	1834	40481087	1976-01-06	1976-01-20	1
75026	4460	260139	1952-07-05	1952-07-19	1
29342	1739	4134304	1997-03-15	1997-06-13	1
28226	1669	192671	1998-12-29	1998-12-30	1
49850	2949	4283893	1980-09-03	1981-01-07	1
11263	665	260139	2011-08-21	2011-09-06	1
65968	3904	40481087	2012-06-21	2012-06-28	1
38194	2270	80180	2019-03-12	2019-03-13	1
82245	4884	372328	1977-05-15	1977-10-22	1
84801	5048	4027663	1983-10-18	1983-10-19	1
36858	2184	28060	1973-01-15	1973-01-23	1
31376	1855	40481087	1995-10-12	1995-10-19	1
28041	1658	40481087	1952-03-09	1952-03-30	1
27314	1611	4112343	2012-05-27	2012-06-07	1
40562	2414	313217	1994-08-18	1994-08-19	1
47735	2837	260139	1998-09-23	1998-10-02	1
58329	3458	260139	1985-05-22	1985-06-05	1
40422	2404	40481087	2000-09-15	2000-09-22	1
654	36	28060	2006-11-22	2006-11-30	1
68213	4033	40481087	2002-05-27	2002-06-03	1
2071	120	4283893	1986-12-24	1987-02-18	1
38610	2294	40481087	2010-11-08	2010-11-29	1
57054	3389	4112343	1998-02-12	1998-02-21	1
32931	1954	4112343	1969-05-15	1969-05-23	1
5906	348	4059173	1984-10-08	1985-01-06	1
5110	299	40481087	1964-05-06	1964-05-13	1
30945	1834	40481087	1978-06-14	1978-06-21	1
75027	4460	260139	2006-08-24	2006-09-07	1
29343	1739	40481087	1970-11-17	1970-11-24	1
28227	1669	4134304	1998-03-30	1998-05-29	1
49851	2949	40481087	1962-03-31	1962-04-21	1
11264	665	4112343	2007-07-09	2007-07-17	1
70823	4206	260139	1980-09-16	1980-09-23	1
38195	2270	81151	2012-01-24	2012-02-07	1
82246	4884	4035415	1980-12-22	1981-01-21	1
84802	5048	4112343	2003-12-24	2003-12-31	1
36859	2184	80180	2002-12-23	2002-12-24	1
31377	1855	40481087	2006-02-11	2006-02-25	1
28042	1658	40481087	1988-12-16	1989-01-06	1
27315	1611	40481087	1952-08-12	1952-09-02	1
40563	2414	4329847	1994-05-26	1994-05-27	1
47736	2837	260139	2008-10-11	2008-10-25	1
58330	3458	372328	1988-04-04	1988-06-17	1
40423	2404	40481087	2017-08-02	2017-08-16	1
655	36	257012	2010-11-22	2010-11-23	1
68214	4033	40481087	2012-11-10	2012-11-24	1
2511	148	260139	2008-09-09	2008-09-23	1
38611	2294	40481087	2011-09-03	2011-09-17	1
57055	3389	4113008	2016-12-25	2017-01-08	1
32932	1954	40481087	1944-11-01	1944-11-08	1
5907	348	40481087	1978-05-10	1978-05-17	1
5909	349	260139	1994-01-21	1994-02-04	1
30946	1834	40481087	1997-02-09	1997-02-16	1
75028	4460	372328	1944-01-18	1944-03-13	1
29344	1739	40481087	1999-10-01	1999-10-15	1
28228	1669	4218389	1959-12-29	1960-01-19	1
49852	2949	28060	1970-09-11	1970-09-24	1
11265	665	40481087	1988-11-12	1988-11-19	1
70824	4206	378001	1961-10-29	1961-12-28	1
38196	2270	260139	2016-04-12	2016-04-26	1
82247	4884	4112343	1976-01-16	1976-01-23	1
84803	5048	40481087	1966-08-30	1966-09-06	1
36860	2184	372328	1967-08-14	1967-10-25	1
31378	1855	40481087	2006-10-29	2006-11-19	1
28043	1658	40481087	1999-12-17	2000-01-07	1
28720	1703	257012	1950-02-02	1950-02-03	1
40564	2414	40481087	1927-06-25	1927-07-09	1
47737	2837	260139	2015-01-23	2015-01-30	1
58331	3458	375671	2010-01-21	2010-03-22	1
40424	2404	81151	1975-12-04	1975-12-18	1
656	36	260139	1974-05-20	1974-05-27	1
68215	4033	28060	1979-11-21	1979-12-03	1
2512	148	4230399	1993-06-12	1993-08-11	1
38612	2294	260139	1984-12-20	1985-01-03	1
57056	3389	4278672	1973-01-15	1973-02-14	1
32933	1954	40481087	1975-07-22	1975-08-05	1
5908	348	40481087	1984-10-29	1984-11-12	1
5910	349	4112343	1959-07-26	1959-08-05	1
30947	1834	40481087	2017-08-16	2017-08-23	1
75029	4460	4112343	1954-10-03	1954-10-12	1
29345	1739	40481087	2017-01-19	2017-02-02	1
28229	1669	4218389	2012-05-15	2012-06-12	1
49853	2949	260139	1964-05-13	1964-05-20	1
11266	665	40481087	2013-06-02	2013-06-23	1
70825	4206	4112343	1974-05-10	1974-05-17	1
38197	2270	4156265	1988-05-08	1988-05-29	1
82248	4884	4112343	2013-03-21	2013-04-01	1
84804	5048	40481087	1977-05-20	1977-06-03	1
36861	2184	372328	1969-02-16	1969-07-23	1
31379	1855	81151	1978-10-31	1978-11-14	1
28044	1658	80180	1948-01-07	1948-01-08	1
28721	1703	378001	2002-03-11	2002-05-10	1
40565	2414	0	1994-05-26	1994-05-27	1
47738	2837	4112343	1978-09-01	1978-09-08	1
58332	3458	4112343	2008-09-06	2008-09-13	1
40425	2404	260139	1987-05-15	1987-05-22	1
657	36	260139	2001-06-17	2001-07-01	1
68216	4033	80180	2014-07-25	2014-07-26	1
2513	148	4112343	1991-09-09	1991-09-22	1
38613	2294	378001	1973-04-26	1973-05-26	1
57057	3389	260139	1976-08-28	1976-09-11	1
32934	1954	40481087	1997-11-30	1997-12-21	1
7348	432	80502	2001-04-09	2001-04-10	1
5911	349	4112343	1974-04-04	1974-04-17	1
30948	1834	78272	2009-01-13	2009-02-17	1
75030	4460	4112343	1985-02-08	1985-02-17	1
29346	1739	80180	2009-04-26	2009-04-27	1
28230	1669	4027663	1992-01-25	1992-01-26	1
49854	2949	4112343	2002-02-27	2002-03-07	1
13998	828	378001	1982-03-24	1982-04-23	1
70826	4206	4218389	1959-01-15	1959-02-12	1
38198	2270	40481087	1987-10-26	1987-11-16	1
82249	4884	28060	1975-11-09	1975-11-16	1
84805	5048	40481087	2012-12-13	2012-12-20	1
36862	2184	378001	1995-05-08	1995-07-07	1
31380	1855	260139	1998-11-16	1998-11-23	1
28045	1658	81151	1939-03-24	1939-04-21	1
28722	1703	4109685	1997-08-20	1997-09-03	1
40566	2414	78272	1929-06-05	1929-06-19	1
47739	2837	4112343	2001-04-08	2001-04-19	1
58333	3458	4113008	1992-06-03	1992-06-24	1
40426	2404	4109685	1998-08-10	1998-08-31	1
658	36	260139	2008-06-08	2008-06-22	1
68217	4033	260139	2003-09-17	2003-10-01	1
2514	148	4296204	2007-05-10	2007-06-07	1
38614	2294	4112343	1998-12-22	1998-12-29	1
57058	3389	372328	1961-01-18	1961-02-01	1
32935	1954	40481087	2003-10-27	2003-11-03	1
7349	432	257012	1986-06-08	1986-06-09	1
5912	349	4113008	2014-05-18	2014-06-08	1
30949	1834	81151	1981-04-05	1981-05-10	1
75031	4460	40481087	1985-02-15	1985-03-01	1
29347	1739	260139	1999-10-14	1999-10-28	1
28231	1669	4112343	1995-11-08	1995-11-21	1
49855	2949	40481087	2003-01-04	2003-01-25	1
13999	828	4112343	1956-04-06	1956-04-17	1
70827	4206	40481087	1950-11-04	1950-11-25	1
38199	2270	40481087	2009-12-07	2009-12-21	1
82250	4884	372328	1974-05-26	1974-09-28	1
84806	5048	80180	1991-10-06	1991-10-07	1
36863	2184	4112343	2003-04-19	2003-05-01	1
31381	1855	260139	2004-03-22	2004-04-05	1
28046	1658	81151	1978-08-24	1978-09-21	1
28723	1703	4112343	1984-06-10	1984-06-22	1
40567	2414	192671	1957-05-09	1957-05-10	1
47740	2837	40481087	1994-09-02	1994-09-09	1
58334	3458	40481087	1987-12-03	1987-12-10	1
40427	2404	4112343	1969-11-17	1969-11-28	1
659	36	375671	1982-10-29	1982-12-28	1
68218	4033	375671	1987-06-12	1987-07-12	1
2515	148	78272	1995-06-02	1995-07-07	1
38615	2294	4155034	1961-11-20	1961-12-11	1
57059	3389	372328	1963-02-21	1963-08-12	1
33712	2004	81151	1987-01-08	1987-02-12	1
7350	432	4001336	1958-02-05	1958-03-07	1
5913	349	4237458	1969-08-28	1969-10-27	1
30950	1834	4112343	1989-06-13	1989-06-23	1
75380	4480	40481087	1987-08-17	1987-08-31	1
29348	1739	4152936	1976-05-20	1976-06-03	1
28232	1669	4112343	2007-12-21	2007-12-30	1
49856	2949	40481087	2003-05-04	2003-05-11	1
14000	828	40481087	1954-03-19	1954-04-09	1
70828	4206	260139	1961-03-07	1961-03-21	1
38200	2270	195588	2001-05-25	2001-06-26	1
82251	4884	4051466	1975-10-28	1992-02-04	1
84807	5048	260139	1978-01-22	1978-01-29	1
36864	2184	40481087	2009-10-23	2009-10-30	1
31382	1855	440086	1989-03-17	1989-09-22	1
28047	1658	81151	2010-12-21	2011-01-11	1
28724	1703	4296204	1956-01-04	1956-01-25	1
40568	2414	260139	1919-05-31	1919-06-14	1
47741	2837	260139	1992-04-19	1992-05-03	1
58335	3458	40481087	1996-09-02	1996-09-16	1
40428	2404	4283893	1969-10-23	1969-11-06	1
660	36	378001	1976-11-29	1977-01-28	1
68219	4033	4283893	2018-02-05	2018-04-24	1
2516	148	80180	2012-12-25	2012-12-26	1
38616	2294	4237458	1978-06-29	1978-07-29	1
57060	3389	4112343	1996-02-15	1996-02-22	1
33713	2004	4112343	1979-12-18	1979-12-25	1
7351	432	4155034	1989-12-24	1990-01-07	1
5914	349	40481087	1991-12-23	1992-01-13	1
30951	1834	4218389	1954-12-18	1955-01-22	1
75381	4480	40481087	2002-04-15	2002-04-22	1
29349	1739	4112343	1996-04-13	1996-04-20	1
28233	1669	40481087	1965-06-28	1965-07-19	1
51477	3059	0	1990-04-15	1990-04-16	1
14001	828	257012	1988-09-25	1988-09-26	1
70829	4206	261325	1983-09-06	1983-09-07	1
38201	2270	257012	1980-02-04	1980-02-05	1
82252	4884	4112343	2001-08-24	2001-09-04	1
84808	5048	260139	1992-08-24	1992-08-31	1
36865	2184	81151	2019-05-30	2019-05-31	1
31383	1855	4109685	1979-10-10	1979-10-31	1
28048	1658	257012	1981-02-13	1981-02-14	1
28725	1703	40481087	1971-12-24	1972-01-07	1
40569	2414	260139	1950-06-10	1950-06-24	1
47742	2837	375671	1988-05-09	1988-06-08	1
58336	3458	28060	2000-07-31	2000-08-07	1
40429	2404	4285898	2008-03-19	2008-03-20	1
661	36	4112343	1962-10-18	1962-10-29	1
68220	4033	440086	1978-10-12	1981-12-09	1
2517	148	440086	1987-10-13	1996-10-20	1
38617	2294	40481087	1967-11-04	1967-11-18	1
57061	3389	40481087	1977-08-16	1977-09-06	1
33714	2004	4112343	1993-03-17	1993-03-30	1
7352	432	40481087	1943-03-21	1943-03-28	1
5915	349	40481087	2001-08-08	2001-08-29	1
30952	1834	40481087	1946-04-09	1946-04-16	1
75382	4480	4112343	1966-09-01	1966-09-11	1
29350	1739	4152936	2011-09-28	2011-10-19	1
28234	1669	40481087	1974-10-09	1974-10-30	1
51478	3059	81151	1978-05-07	1978-05-28	1
14002	828	260139	2000-01-13	2000-01-27	1
70830	4206	4112343	1968-02-12	1968-02-22	1
38202	2270	4112343	1979-05-30	1979-06-09	1
82253	4884	4156265	1978-02-22	1978-03-08	1
84809	5048	260139	2002-05-15	2002-05-22	1
36866	2184	260139	1987-01-02	1987-01-09	1
31384	1855	30753	2015-03-01	2015-03-02	1
28049	1658	260139	1928-07-31	1928-08-14	1
28726	1703	78272	1963-11-05	1963-11-19	1
40570	2414	317576	1991-08-01	1991-08-02	1
47743	2837	40481087	1977-06-26	1977-07-03	1
58337	3458	28060	2006-08-10	2006-08-17	1
40430	2404	80180	2008-04-18	2008-04-19	1
662	36	4156265	1964-10-19	1964-11-02	1
68221	4033	4112343	2010-05-13	2010-05-25	1
2518	148	4112343	2011-08-09	2011-08-22	1
38618	2294	81151	1972-04-17	1972-05-01	1
57062	3389	40481087	2007-04-01	2007-04-22	1
33715	2004	40481087	1990-02-25	1990-03-04	1
7353	432	40481087	1953-03-12	1953-03-19	1
5916	349	40481087	2004-04-21	2004-04-28	1
30953	1834	40481087	1968-10-25	1968-11-01	1
75383	4480	4134304	1966-09-02	1966-12-01	1
29351	1739	40481087	1969-09-11	1969-09-18	1
30022	1779	30753	1976-02-11	1976-02-12	1
51479	3059	257012	1989-10-31	1989-11-01	1
14003	828	372328	1954-06-12	1954-09-21	1
70831	4206	40481087	1955-02-07	1955-02-14	1
38203	2270	4294548	1979-12-31	1980-04-14	1
82254	4884	40481087	1983-10-14	1983-10-28	1
84810	5048	40481087	1989-04-30	1989-05-14	1
36867	2184	4027663	1995-02-08	1995-02-09	1
31385	1855	80180	2016-11-20	2016-11-21	1
28050	1658	260139	1971-03-31	1971-04-09	1
28727	1703	4112343	1963-07-27	1963-08-08	1
40571	2414	40481087	1941-11-27	1941-12-11	1
47744	2837	40481087	1984-06-13	1984-06-27	1
58338	3458	4109685	2013-05-05	2013-05-26	1
40431	2404	372328	1966-05-04	1966-08-14	1
663	36	40479422	2001-03-23	2001-04-29	1
68222	4033	40481087	1995-02-07	1995-02-21	1
2519	148	4218389	2000-08-09	2000-09-13	1
38619	2294	372328	1972-01-22	1972-12-15	1
57278	3403	81151	1980-03-03	1980-03-24	1
33716	2004	40481087	2016-05-15	2016-06-05	1
7354	432	40481087	1957-08-01	1957-08-15	1
5917	349	40481087	2016-04-04	2016-04-11	1
30954	1834	40481087	1979-11-19	1979-12-03	1
75384	4480	40481087	1997-06-18	1997-07-02	1
31963	1902	372328	1949-09-20	1949-11-13	1
30023	1779	81893	1975-10-14	1975-10-15	1
51480	3059	378001	1989-08-28	1989-09-27	1
14004	828	4112343	1986-05-26	1986-06-08	1
70832	4206	40481087	1962-09-10	1962-10-01	1
38204	2270	40481087	1987-04-06	1987-04-20	1
82255	4884	40481087	1998-04-09	1998-04-16	1
36868	2184	4266809	2002-12-23	2002-12-24	1
31386	1855	372328	1976-12-10	1977-02-25	1
28051	1658	260139	2008-03-13	2008-03-27	1
28728	1703	4112343	1995-09-06	1995-09-19	1
40572	2414	40481087	1946-08-25	1946-09-08	1
47745	2837	40481087	2001-11-10	2001-11-17	1
58339	3458	40481087	1986-01-21	1986-02-04	1
40432	2404	4027663	1998-11-27	1998-11-28	1
664	36	40481087	1969-05-04	1969-05-18	1
74230	4412	78272	1967-03-14	1967-03-28	1
2520	148	40481087	1989-07-26	1989-08-09	1
38620	2294	4112343	1972-01-28	1972-02-04	1
57279	3403	4112343	2011-04-11	2011-04-20	1
33717	2004	260139	1984-05-25	1984-06-01	1
7355	432	40481087	1998-11-29	1998-12-13	1
5918	349	81151	2001-09-09	2001-09-23	1
30955	1834	40481087	2005-10-07	2005-10-28	1
75385	4480	80180	1998-08-10	1998-08-11	1
31964	1902	4112343	2019-03-07	2019-03-17	1
30024	1779	140673	2009-11-09	2009-11-10	1
51481	3059	4112343	1979-08-18	1979-08-27	1
14005	828	4237458	1965-06-14	1965-09-12	1
70833	4206	28060	1955-06-08	1955-06-17	1
38205	2270	40481087	2000-02-07	2000-02-21	1
82256	4884	40481087	2010-01-04	2010-01-25	1
36869	2184	4296205	2004-03-21	2004-04-18	1
31387	1855	4266809	2016-11-20	2016-11-21	1
28052	1658	4112343	1913-01-24	1913-02-04	1
28729	1703	4283893	1949-10-13	1950-08-24	1
40573	2414	28060	1921-08-18	1921-08-31	1
47746	2837	40481087	2011-09-05	2011-09-12	1
58340	3458	78272	2014-04-21	2014-05-19	1
40433	2404	4112343	1994-06-14	1994-06-27	1
665	36	40481087	1972-09-19	1972-10-03	1
74231	4412	81151	1989-01-31	1989-02-14	1
2521	148	4112343	2016-10-28	2016-11-04	1
38621	2294	4112343	1980-12-01	1980-12-14	1
57280	3403	4283893	2007-10-30	2007-11-27	1
33718	2004	260139	1988-08-05	1988-08-12	1
7356	432	28060	1939-03-21	1939-03-31	1
5919	349	4112343	1968-07-02	1968-07-13	1
30956	1834	40481087	2016-04-27	2016-05-18	1
75386	4480	81151	1979-06-10	1979-07-01	1
31965	1902	4283893	2016-05-06	2016-06-24	1
30025	1779	260139	2011-01-30	2011-02-06	1
51482	3059	4146173	2005-08-04	2005-10-03	1
14006	828	4294548	1988-09-04	1988-10-16	1
70834	4206	78272	1968-08-23	1968-09-20	1
40760	2427	260139	1994-11-29	1994-12-13	1
82257	4884	4112343	1979-09-08	1979-09-16	1
39621	2349	372328	1972-10-06	1972-12-17	1
36710	2175	257012	1996-09-14	1996-09-15	1
28053	1658	4112343	1918-10-07	1918-10-15	1
28730	1703	40481087	1966-12-04	1966-12-11	1
40574	2414	78272	1975-05-24	1975-06-07	1
47747	2837	40481087	2012-01-17	2012-02-07	1
309	17	257012	1984-09-12	1984-09-13	1
40434	2404	4112343	2016-10-13	2016-10-24	1
666	36	40481087	1974-02-02	1974-02-16	1
74232	4412	4112343	1973-02-13	1973-02-20	1
2522	148	4113008	1980-09-04	1980-09-18	1
38622	2294	4294548	1965-07-06	1965-11-09	1
57281	3403	40481087	1971-12-21	1972-01-11	1
33719	2004	372328	2014-02-28	2015-06-16	1
7357	432	28060	1994-02-20	1994-03-04	1
5920	349	4283893	1966-07-23	1966-08-20	1
33512	1990	28060	1996-05-21	1996-06-01	1
75387	4480	260139	2016-09-19	2016-09-26	1
31966	1902	40481087	1956-10-26	1956-11-16	1
30026	1779	321042	1949-09-15	1949-09-16	1
51483	3059	4155034	2012-06-28	2012-07-19	1
14007	828	40481087	1957-12-28	1958-01-04	1
70835	4206	4048695	1993-04-12	1993-06-13	1
40761	2427	4112343	2000-09-03	2000-09-11	1
82258	4884	4112343	2004-08-22	2004-08-31	1
39622	2349	4109685	1994-05-03	1994-05-17	1
36711	2175	317576	2000-11-09	2000-11-10	1
28054	1658	4112343	1989-09-03	1989-09-16	1
28731	1703	40481087	1970-09-30	1970-10-21	1
40575	2414	260139	1978-07-25	1978-08-08	1
47748	2837	40481087	2018-05-12	2018-05-26	1
310	17	260139	2012-11-25	2012-12-09	1
40435	2404	4156265	1980-06-24	1980-07-15	1
1403	82	40481087	1989-07-31	1989-08-21	1
74233	4412	40481087	1969-03-06	1969-03-13	1
2523	148	40481087	2013-02-09	2013-02-23	1
38623	2294	4296204	1999-06-09	1999-06-23	1
57282	3403	81151	1986-07-21	1986-08-04	1
33720	2004	40481087	1989-07-08	1989-07-22	1
7358	432	28060	2015-12-25	2016-01-02	1
5921	349	40481087	1990-10-06	1990-10-20	1
33513	1990	28060	2002-11-28	2002-12-07	1
75388	4480	378001	1987-03-21	1987-04-20	1
31967	1902	40481087	1986-06-07	1986-06-28	1
30027	1779	372328	1944-10-16	1944-10-30	1
51484	3059	80180	2012-11-29	2012-11-30	1
14008	828	40481087	1966-03-29	1966-04-19	1
70836	4206	4112343	1970-12-12	1970-12-25	1
40762	2427	4283893	2006-01-19	2006-02-02	1
82259	4884	4134304	1989-07-08	1989-10-06	1
39623	2349	4112343	1981-06-08	1981-06-18	1
36712	2175	372328	1977-09-20	1978-01-05	1
28055	1658	4112343	1991-01-13	1991-01-22	1
28732	1703	40481087	1999-06-17	1999-07-01	1
40576	2414	260139	1982-03-07	1982-03-14	1
49236	2915	40481087	1985-08-30	1985-09-20	1
311	17	4029498	1962-12-08	1962-12-09	1
40436	2404	4266809	2008-04-18	2008-04-19	1
1404	82	28060	2006-08-17	2006-08-25	1
74234	4412	40481087	1978-03-05	1978-03-26	1
5521	327	372328	1972-12-22	1973-01-05	1
38624	2294	40481087	2018-10-19	2018-11-09	1
57283	3403	372328	1982-10-19	1983-05-02	1
33721	2004	40481087	2014-12-02	2014-12-16	1
7359	432	260139	1939-01-17	1939-01-24	1
5922	349	40481087	2015-04-26	2015-05-03	1
33514	1990	260139	2014-07-06	2014-07-20	1
75389	4480	4112343	2014-06-24	2014-07-07	1
31968	1902	40481087	1995-01-20	1995-02-10	1
30028	1779	4027663	1968-11-19	1968-11-20	1
51485	3059	372328	1975-03-13	1975-03-27	1
14009	828	40481087	1985-02-10	1985-02-17	1
70837	4206	40481087	1965-05-26	1965-06-09	1
40763	2427	40481087	1965-01-15	1965-01-29	1
82260	4884	40481087	1995-11-02	1995-11-16	1
39624	2349	81151	1973-03-05	1973-04-09	1
36713	2175	4278672	1981-01-02	1981-03-03	1
28056	1658	4142905	1995-04-14	1995-06-13	1
28733	1703	81151	1995-09-02	1995-09-30	1
40577	2414	372328	1924-01-03	1924-03-20	1
49237	2915	40481087	2019-04-16	2019-04-30	1
312	17	4156265	1989-09-27	1989-10-18	1
40437	2404	28060	2003-07-14	2003-07-21	1
1405	82	80180	1995-12-03	1995-12-04	1
74235	4412	40481087	1979-12-21	1980-01-04	1
5522	327	4294548	1982-11-03	1983-03-30	1
38625	2294	28060	1990-10-08	1990-10-17	1
57284	3403	4112343	1980-11-01	1980-11-08	1
33722	2004	80180	2005-12-09	2005-12-10	1
7360	432	378001	1961-02-19	1961-03-21	1
5923	349	80502	2018-04-28	2018-04-29	1
33515	1990	372328	1968-06-15	1968-11-01	1
75390	4480	4113008	1974-08-21	1974-09-04	1
31969	1902	40481087	2008-03-07	2008-03-14	1
30029	1779	4048171	1945-12-02	1945-12-03	1
51486	3059	4112343	1972-08-08	1972-08-20	1
14010	828	381316	2005-06-14	2005-06-15	1
70838	4206	80180	1984-06-12	1984-06-13	1
40764	2427	40481087	1968-10-19	1968-10-26	1
82261	4884	40481087	2008-04-02	2008-04-09	1
39625	2349	81893	2003-11-28	2003-11-29	1
36714	2175	4283893	1996-08-03	1996-09-21	1
28057	1658	4146173	1942-02-04	1942-03-06	1
28734	1703	260139	1949-08-10	1949-08-17	1
40578	2414	378419	1996-08-29	1996-08-30	1
49238	2915	80502	2005-04-03	2005-04-04	1
313	17	4294548	1999-02-06	1999-04-24	1
40438	2404	372328	1968-01-06	1968-05-12	1
1406	82	4029498	1973-03-18	1973-03-19	1
74236	4412	40481087	1996-07-24	1996-07-31	1
5523	327	40481087	1980-03-23	1980-04-13	1
38626	2294	257012	1965-10-19	1965-10-20	1
57285	3403	4296204	2012-10-07	2012-11-11	1
33723	2004	260139	2002-01-04	2002-01-13	1
7361	432	440086	1938-05-31	1940-06-04	1
5924	349	4112343	1964-01-13	1964-01-22	1
33516	1990	4112343	1995-03-12	1995-03-24	1
75391	4480	40481087	1963-09-23	1963-10-14	1
31970	1902	260139	2012-01-29	2012-02-12	1
30030	1779	4084167	1946-12-07	1946-12-07	1
51487	3059	4112343	2001-11-13	2001-11-21	1
14011	828	4109685	1999-10-21	1999-11-04	1
70839	4206	260139	1973-01-29	1973-02-12	1
40765	2427	40481087	2007-05-06	2007-05-13	1
86674	5166	28060	2011-04-23	2011-05-04	1
39626	2349	257012	1992-10-09	1992-10-10	1
36715	2175	40481087	1977-07-29	1977-08-12	1
28058	1658	4283893	1914-11-19	1914-12-24	1
28735	1703	372328	1950-06-04	1950-07-19	1
40579	2414	4112343	1937-09-07	1937-09-17	1
49239	2915	4112343	2016-06-12	2016-06-19	1
314	17	40481087	2015-10-25	2015-11-15	1
40439	2404	4035415	1986-11-11	1986-12-11	1
1407	82	40481087	1961-08-25	1961-09-01	1
74237	4412	0	2010-07-22	2010-07-23	1
5524	327	40481087	2018-02-09	2018-02-23	1
38627	2294	372328	1964-09-05	1964-10-30	1
57286	3403	4310024	2006-05-21	2006-05-22	1
33724	2004	260139	2005-11-13	2005-11-27	1
7362	432	4112343	1957-06-26	1957-07-04	1
5925	349	4112343	1969-02-11	1969-02-18	1
33517	1990	80180	2005-05-07	2005-05-08	1
75392	4480	28060	1995-10-07	1995-10-18	1
31971	1902	4059173	1958-01-13	1958-02-12	1
30031	1779	4084167	1969-04-15	1969-04-15	1
51488	3059	4112343	2007-03-10	2007-03-19	1
14012	828	4112343	1979-06-19	1979-06-28	1
70840	4206	378001	1974-05-22	1974-07-21	1
40766	2427	28060	1978-09-17	1978-09-26	1
86675	5166	80180	1985-08-23	1985-08-24	1
39627	2349	4027663	1997-04-03	1997-04-04	1
36716	2175	40481087	2010-12-14	2010-12-28	1
28059	1658	40481087	1951-05-31	1951-06-07	1
28736	1703	4112343	1951-04-03	1951-04-13	1
40580	2414	4112343	1965-02-06	1965-02-16	1
49240	2915	4146173	1984-08-01	1984-08-31	1
315	17	0	1962-12-08	1962-12-09	1
40440	2404	4146173	2002-06-11	2002-08-10	1
1408	82	40481087	1969-09-24	1969-10-15	1
74238	4412	260139	1979-12-07	1979-12-21	1
5525	327	80180	2010-12-03	2010-12-04	1
38628	2294	440086	1967-11-24	1969-01-10	1
57287	3403	40481087	1994-10-19	1994-11-02	1
33725	2004	372328	1972-02-26	1972-05-09	1
7363	432	4112343	1960-06-20	1960-07-03	1
5926	349	4112343	1975-05-13	1975-05-26	1
33518	1990	260139	1970-05-07	1970-05-14	1
75393	4480	81151	2013-12-29	2014-01-26	1
31972	1902	4112343	1981-10-09	1981-10-19	1
30032	1779	4112343	2011-11-02	2011-11-12	1
51489	3059	4283893	1989-10-03	1989-11-28	1
14013	828	40481087	1968-01-18	1968-02-01	1
70841	4206	440086	1954-09-03	1961-09-11	1
40767	2427	80180	1984-12-23	1984-12-24	1
86676	5166	81151	1989-05-24	1989-06-28	1
39628	2349	4134304	1987-02-09	1987-05-10	1
36717	2175	0	1979-01-29	1979-01-30	1
28060	1658	81151	1990-03-27	1990-04-10	1
28737	1703	4113008	1962-10-20	1962-11-10	1
40581	2414	4112343	1999-11-16	1999-11-27	1
49241	2915	4237458	1954-10-03	1955-01-01	1
316	17	195588	2000-01-08	2000-02-27	1
40441	2404	40481087	1979-02-26	1979-03-12	1
1409	82	40481087	2011-09-30	2011-10-07	1
74239	4412	260139	2016-03-11	2016-03-20	1
5526	327	257012	1982-11-17	1982-11-18	1
38629	2294	4112343	1980-03-26	1980-04-03	1
57288	3403	80180	2008-08-08	2008-08-09	1
33726	2004	4152936	1989-12-28	1990-01-11	1
7364	432	4112343	1985-12-22	1985-12-31	1
5927	349	40481087	1995-05-02	1995-05-16	1
33519	1990	260139	1998-04-10	1998-04-24	1
75394	4480	260139	1965-09-08	1965-09-22	1
31973	1902	4310024	1983-07-16	1983-07-17	1
30033	1779	4218389	2003-12-16	2004-01-13	1
51490	3059	40481087	2017-04-01	2017-04-22	1
14014	828	80180	1992-11-29	1992-11-30	1
71183	4226	260139	1975-04-15	1975-04-22	1
40768	2427	260139	1959-10-01	1959-10-15	1
86677	5166	81151	2008-12-15	2009-01-12	1
39629	2349	4283893	1992-08-28	1992-10-16	1
36718	2175	134438	2009-01-27	2010-01-26	1
28061	1658	81893	1946-02-16	1946-02-17	1
28738	1703	40481087	1953-03-03	1953-03-10	1
40582	2414	4116491	1984-05-07	1984-06-19	1
49242	2915	40481087	1956-09-04	1956-09-11	1
317	17	260139	1966-10-19	1966-10-26	1
40442	2404	40481087	1982-05-01	1982-05-22	1
1410	82	195588	2006-03-10	2006-05-01	1
74240	4412	4112343	2013-05-29	2013-06-07	1
5527	327	4112343	1990-10-20	1990-10-30	1
38630	2294	4112343	1981-05-15	1981-05-26	1
57289	3403	192671	2008-09-05	2008-09-06	1
33727	2004	40481087	1971-09-06	1971-09-20	1
7365	432	80180	1973-01-07	1973-01-08	1
5928	349	40481087	1997-06-11	1997-06-25	1
33520	1990	4035415	2001-03-15	2001-04-14	1
75395	4480	260139	2013-10-15	2013-10-29	1
31974	1902	40481087	2005-04-06	2005-04-13	1
30034	1779	4278672	1976-07-14	1976-10-12	1
51491	3059	372328	1972-07-07	1972-09-24	1
14015	828	4112343	1994-07-28	1994-08-09	1
71184	4226	260139	1983-03-09	1983-03-16	1
40769	2427	372328	1985-10-24	1986-04-29	1
86678	5166	4112343	1963-12-23	1964-01-02	1
39630	2349	28060	1973-05-07	1973-05-20	1
36719	2175	378001	2012-06-09	2012-07-09	1
28062	1658	260139	1952-01-16	1952-01-30	1
28739	1703	40481087	1990-04-08	1990-04-29	1
40583	2414	4296204	1970-09-12	1970-10-17	1
49243	2915	40481087	1993-05-18	1993-06-01	1
318	17	372328	1951-04-10	1951-05-21	1
40443	2404	40481087	1994-08-19	1994-09-09	1
1411	82	260139	2004-04-05	2004-04-19	1
74241	4412	40479422	2000-09-14	2000-11-20	1
5528	327	40481087	2004-04-08	2004-04-15	1
38631	2294	40481087	1963-04-19	1963-05-10	1
57290	3403	30753	2007-10-13	2007-10-14	1
33728	2004	40481087	1976-12-29	1977-01-05	1
7366	432	192671	1973-01-24	1973-01-25	1
5929	349	40481087	2008-09-11	2008-09-25	1
33521	1990	4278672	1975-04-10	1975-07-09	1
75396	4480	378001	1980-07-25	1980-08-24	1
31975	1902	40481087	2012-03-15	2012-03-22	1
30035	1779	40481087	1971-03-01	1971-03-22	1
51492	3059	440448	1990-04-15	1990-04-16	1
14016	828	40479422	1971-04-14	1971-06-20	1
71185	4226	4112343	1987-09-04	1987-09-17	1
40770	2427	4112343	1948-06-21	1948-06-30	1
86679	5166	4134304	1955-02-22	1955-05-23	1
39631	2349	372328	1973-04-16	1973-06-17	1
36720	2175	40481087	1984-06-12	1984-07-03	1
28063	1658	260139	1982-01-12	1982-01-26	1
28740	1703	80180	1992-10-16	1992-10-17	1
40584	2414	40481087	1965-02-09	1965-02-16	1
49244	2915	40481087	2016-03-02	2016-03-23	1
319	17	4112343	1963-12-02	1963-12-12	1
45942	2740	257012	2015-12-23	2015-12-24	1
1412	82	4112343	1970-01-05	1970-01-12	1
74242	4412	40481087	2008-03-27	2008-04-17	1
5529	327	372328	1976-01-20	1977-01-17	1
38632	2294	40481087	1973-01-27	1973-02-03	1
57291	3403	4027663	2000-03-23	2000-03-24	1
34680	2062	81151	1988-02-02	1988-03-08	1
7367	432	313217	2014-06-23	2014-06-24	1
5930	349	40481087	2012-09-11	2012-10-02	1
33522	1990	260139	1980-11-18	1980-12-02	1
75397	4480	4059173	1993-12-14	1994-03-14	1
31976	1902	40481087	2017-12-24	2018-01-07	1
30036	1779	40481087	1985-02-27	1985-03-20	1
51493	3059	4112343	1987-12-15	1987-12-25	1
14214	842	258780	1947-04-12	1947-04-13	1
71186	4226	4112343	1989-12-07	1989-12-16	1
40771	2427	40481087	1958-05-10	1958-05-17	1
86680	5166	4134304	1992-03-14	1992-06-12	1
39632	2349	80180	2004-12-22	2004-12-23	1
36721	2175	40481087	2004-09-30	2004-10-14	1
28064	1658	260139	1984-09-17	1984-10-01	1
28741	1703	260139	1954-05-26	1954-06-04	1
40585	2414	40481087	1968-11-02	1968-11-09	1
49245	2915	28060	2012-07-23	2012-08-01	1
320	17	4112343	1974-05-09	1974-05-22	1
45943	2740	4112343	1990-07-30	1990-08-10	1
1413	82	4112343	1978-03-03	1978-03-13	1
74243	4412	40481087	2011-06-07	2011-06-14	1
5530	327	4218389	1983-10-26	1983-11-16	1
38633	2294	40481087	1983-08-08	1983-08-29	1
57292	3403	4112343	1997-06-15	1997-06-22	1
34681	2062	4112343	1984-08-15	1984-08-27	1
7368	432	381316	1974-12-02	1974-12-03	1
5931	349	80180	1994-02-08	1994-02-09	1
33523	1990	260139	2011-06-28	2011-07-12	1
75398	4480	4112343	1964-03-20	1964-04-02	1
31977	1902	80180	1985-09-03	1985-09-04	1
30037	1779	40481087	2016-01-08	2016-01-15	1
51494	3059	4112343	2009-05-09	2009-05-22	1
14215	842	260139	2009-01-17	2009-01-24	1
71187	4226	40481087	1982-06-19	1982-06-26	1
40772	2427	40481087	2002-05-10	2002-05-31	1
86681	5166	4278672	1966-05-25	1966-08-23	1
39633	2349	192671	2005-02-03	2005-02-04	1
36722	2175	28060	1979-12-12	1979-12-22	1
28065	1658	260139	2000-06-14	2000-06-21	1
28742	1703	260139	1965-03-19	1965-04-02	1
42711	2548	260139	2011-01-10	2011-01-17	1
49246	2915	80180	1981-11-14	1981-11-15	1
321	17	4112343	1984-06-30	1984-07-10	1
45944	2740	40481087	1973-06-22	1973-06-29	1
1414	82	4278672	1973-09-14	1973-11-13	1
74244	4412	80180	2002-09-11	2002-09-12	1
5531	327	40481087	1981-02-12	1981-03-05	1
38634	2294	40481087	2010-06-26	2010-07-03	1
57293	3403	4218389	2005-11-22	2005-12-13	1
34682	2062	4112343	2008-12-21	2008-12-30	1
7369	432	4112343	2013-03-25	2013-04-06	1
5932	349	4112343	1970-08-14	1970-08-21	1
33524	1990	372328	1970-04-25	1970-05-09	1
75399	4480	4112343	1964-10-01	1964-10-09	1
31978	1902	81151	2000-06-01	2000-06-29	1
30038	1779	0	1949-09-15	1949-09-16	1
51495	3059	4156265	2013-05-15	2013-05-29	1
14216	842	317576	2017-11-04	2017-11-05	1
71188	4226	81151	1996-10-20	1996-11-10	1
40773	2427	260139	1968-10-01	1968-10-15	1
39634	2349	260139	2010-03-23	2010-03-30	1
36723	2175	80180	2013-08-07	2013-08-08	1
28066	1658	260139	2016-04-18	2016-04-25	1
28743	1703	260139	1983-09-05	1983-09-12	1
42712	2548	40481087	1986-07-19	1986-08-09	1
49247	2915	134438	1967-05-09	1968-01-06	1
322	17	4283893	1984-08-08	1984-09-19	1
45945	2740	40481087	2000-07-14	2000-08-04	1
1415	82	40481087	2013-09-03	2013-09-24	1
74245	4412	372328	1969-07-20	1970-07-24	1
5532	327	81151	1985-11-05	1985-12-10	1
39451	2341	260139	1953-06-21	1953-07-05	1
58845	3495	260139	1980-07-14	1980-07-28	1
34683	2062	4237458	2006-02-16	2006-05-17	1
7370	432	4283893	1986-05-18	1986-06-15	1
5933	349	40481087	1970-01-10	1970-01-17	1
33525	1990	378001	1992-06-30	1992-08-29	1
75400	4480	4112343	1969-02-28	1969-03-07	1
31979	1902	81893	1984-06-10	1984-06-11	1
30039	1779	80180	1976-11-07	1976-11-08	1
51496	3059	4283893	2012-12-18	2013-02-12	1
14217	842	375671	2015-02-04	2015-03-06	1
71189	4226	257012	1976-09-10	1977-01-14	1
40774	2427	260139	1972-05-11	1972-05-18	1
39635	2349	260139	2016-12-21	2016-12-28	1
36724	2175	195588	1992-01-25	1992-03-13	1
28067	1658	372328	1912-09-22	1912-10-06	1
28744	1703	378001	1976-05-14	1976-07-13	1
42713	2548	40481087	2015-05-01	2015-05-08	1
49248	2915	260139	2007-07-07	2007-07-14	1
323	17	40481087	1973-03-13	1973-03-20	1
45946	2740	40481087	2007-12-01	2007-12-22	1
1416	82	0	1973-03-18	1973-03-19	1
74246	4412	440448	2010-07-22	2010-07-23	1
5533	327	260139	1976-04-07	1976-04-21	1
39452	2341	372328	1953-09-18	1953-12-31	1
58846	3495	4116491	2017-06-03	2017-07-15	1
34684	2062	80180	1984-03-25	1984-03-26	1
7371	432	40481087	1939-11-16	1939-11-30	1
7769	455	133834	1950-05-08	1967-08-07	1
33526	1990	4112343	1975-07-09	1975-07-22	1
75401	4480	4112343	1977-12-24	1978-01-05	1
31980	1902	378001	1992-11-10	1993-01-09	1
30040	1779	81151	1994-02-01	1994-02-22	1
51497	3059	4294548	1974-04-06	1974-05-18	1
14218	842	440086	1917-11-25	1918-03-10	1
71190	4226	260139	1995-12-09	1995-12-16	1
40775	2427	260139	1975-07-21	1975-08-04	1
39636	2349	4112343	2013-12-01	2013-12-13	1
36725	2175	260139	1992-02-06	1992-02-13	1
28068	1658	4112343	1946-11-27	1946-12-04	1
28745	1703	4112343	1961-08-22	1961-09-04	1
42714	2548	28060	1967-12-25	1968-01-06	1
49249	2915	4112343	1952-05-23	1952-06-01	1
324	17	78272	2012-01-19	2012-02-02	1
45947	2740	4113008	2016-02-02	2016-02-16	1
1417	82	260139	2006-03-11	2006-03-18	1
74247	4412	4112343	1994-06-27	1994-07-07	1
5534	327	260139	2000-07-17	2000-07-31	1
39453	2341	378001	1972-12-12	1973-01-11	1
58847	3495	4152936	1975-05-25	1975-06-15	1
34685	2062	257012	2015-07-10	2015-07-11	1
7372	432	40481087	1992-12-18	1992-12-25	1
7770	455	260139	1985-08-10	1985-08-17	1
33527	1990	40481087	1992-06-15	1992-06-22	1
75402	4480	4112343	2002-12-11	2002-12-20	1
31981	1902	4283893	2002-06-10	2002-07-15	1
30041	1779	260139	1945-12-11	1945-12-25	1
51498	3059	40481087	2001-11-04	2001-11-25	1
14219	842	4094814	2010-01-01	2010-04-01	1
71191	4226	372328	1967-07-16	1968-07-14	1
40776	2427	260139	1986-04-23	1986-05-07	1
39637	2349	4112343	2016-09-01	2016-09-11	1
36726	2175	260139	2003-04-16	2003-04-23	1
28069	1658	4112343	1982-07-02	1982-07-11	1
28746	1703	4112343	1976-03-05	1976-03-14	1
42715	2548	28060	2018-01-22	2018-02-04	1
49250	2915	4112343	2005-06-20	2005-06-28	1
325	17	4112343	1958-11-30	1958-12-11	1
45948	2740	4285898	2009-08-22	2009-08-23	1
1418	82	40481087	1982-12-14	1982-12-28	1
74248	4412	4113008	2007-01-18	2007-02-01	1
5535	327	375671	1995-06-21	1995-08-20	1
39454	2341	4112343	2007-03-13	2007-03-25	1
58848	3495	4152936	1995-10-10	1995-10-31	1
34686	2062	313217	2014-11-29	2014-11-30	1
7373	432	40481087	2011-09-29	2011-10-20	1
7771	455	260139	1993-03-10	1993-03-17	1
33528	1990	40481087	1999-01-23	1999-02-06	1
78390	4646	260139	2010-04-22	2010-05-06	1
31982	1902	4294548	2011-11-30	2011-12-07	1
30042	1779	260139	1950-01-13	1950-01-27	1
51499	3059	40481087	2005-08-12	2005-08-19	1
14220	842	4112343	1923-09-26	1923-10-09	1
71192	4226	4112343	1974-08-02	1974-08-09	1
40777	2427	260139	1998-08-29	1998-09-12	1
39638	2349	4155034	1974-02-03	1974-02-17	1
36727	2175	4156265	1990-07-14	1990-08-04	1
28070	1658	4134304	1989-05-01	1989-05-31	1
28747	1703	4112343	1977-08-07	1977-08-14	1
42716	2548	4112343	1982-06-25	1982-07-02	1
49251	2915	4112343	2007-03-07	2007-03-20	1
326	17	4112343	1967-04-07	1967-04-14	1
45949	2740	30753	2009-07-23	2009-07-24	1
1419	82	40481087	2000-11-27	2000-12-18	1
74249	4412	4166224	2010-07-22	2010-07-23	1
5536	327	4113008	2010-09-30	2010-10-21	1
39455	2341	4218389	2014-05-25	2014-06-29	1
58849	3495	40481087	2012-10-02	2012-10-16	1
34687	2062	4218389	1962-01-30	1962-02-20	1
7374	432	81151	1979-06-15	1979-07-20	1
7772	455	260139	2007-11-27	2007-12-11	1
33529	1990	4112343	1967-07-22	1967-08-03	1
78391	4646	313217	2001-10-02	2001-10-03	1
31983	1902	40481087	1964-03-12	1964-03-26	1
30043	1779	260139	1978-07-13	1978-07-27	1
51500	3059	260139	1978-01-09	1978-01-16	1
14221	842	4112343	1940-07-24	1940-08-03	1
71193	4226	40481087	1983-03-29	1983-04-12	1
40778	2427	260139	2004-02-15	2004-02-29	1
39639	2349	4266809	2004-12-22	2004-12-23	1
36728	2175	40481087	1984-03-15	1984-04-05	1
28071	1658	4218389	1918-02-23	1918-03-30	1
28748	1703	4112343	1995-07-28	1995-08-04	1
42717	2548	40481087	2007-08-14	2007-09-04	1
49252	2915	4155034	1955-10-28	1955-11-18	1
327	17	4112343	2011-09-19	2011-09-30	1
45950	2740	192671	2010-05-13	2010-05-14	1
3261	190	28060	1994-07-14	1994-07-23	1
74250	4412	4283893	1991-09-10	1991-10-15	1
5537	327	4134304	1974-10-13	1975-01-11	1
39456	2341	4278672	1954-05-16	1954-08-14	1
58850	3495	28060	1968-06-02	1968-06-14	1
34688	2062	4283893	2015-06-12	2015-07-31	1
7375	432	372328	1934-12-08	1935-05-13	1
7773	455	4112343	1981-12-19	1981-12-28	1
33530	1990	4112343	1968-07-01	1968-07-12	1
78392	4646	378001	1985-11-04	1985-12-04	1
31984	1902	30753	1984-10-08	1984-10-09	1
30044	1779	260139	2009-10-25	2009-11-01	1
51501	3059	4112343	2006-06-02	2006-06-12	1
14222	842	4112343	1955-02-18	1955-03-02	1
71194	4226	40481087	1987-10-24	1987-11-14	1
40779	2427	4112343	2011-05-28	2011-06-05	1
39640	2349	40481087	2000-08-10	2000-08-24	1
36729	2175	40481087	1990-03-09	1990-03-30	1
28072	1658	4285898	1947-02-11	1947-02-12	1
28749	1703	4112343	2016-04-05	2016-04-16	1
42718	2548	80180	1997-11-14	1997-11-15	1
49253	2915	40481087	1947-04-01	1947-04-22	1
328	17	4116491	1994-11-30	1995-01-09	1
45951	2740	260139	1975-11-05	1975-11-12	1
3262	190	257012	1982-11-16	1982-11-17	1
74251	4412	40481087	1966-12-20	1967-01-10	1
5538	327	40481087	2000-11-03	2000-11-17	1
39457	2341	4296205	1994-10-18	1994-11-22	1
58851	3495	260139	2002-12-01	2002-12-08	1
34689	2062	4296205	1989-03-03	1989-03-17	1
7376	432	378001	2001-03-10	2001-05-09	1
7774	455	4112343	1993-11-26	1993-12-05	1
33531	1990	4296205	1978-06-23	1978-07-14	1
78393	4646	40481087	1987-10-03	1987-10-24	1
31985	1902	192671	1985-11-17	1985-11-18	1
30045	1779	4084167	1945-02-13	1945-02-13	1
51502	3059	4134304	2008-09-17	2008-10-17	1
14223	842	4112343	1980-02-21	1980-03-02	1
71195	4226	80180	2002-11-28	2002-11-29	1
40780	2427	4278672	2008-12-20	2009-01-19	1
40310	2395	28060	1972-08-06	1972-08-13	1
36730	2175	40481087	2004-06-09	2004-06-23	1
28073	1658	4294548	1980-12-26	1981-02-27	1
28750	1703	4278672	1954-11-10	1955-02-08	1
42719	2548	260139	1975-11-12	1975-11-19	1
49254	2915	40481087	1999-11-06	1999-11-20	1
329	17	4218389	1969-02-04	1969-03-11	1
45952	2740	260139	2008-08-31	2008-09-14	1
3263	190	378419	2010-01-26	2010-01-27	1
74252	4412	40481087	2000-12-15	2001-01-05	1
8957	525	28060	1952-12-18	1952-12-31	1
39458	2341	40481087	1960-04-21	1960-05-12	1
58852	3495	260139	2008-10-06	2008-10-20	1
34690	2062	40481087	1977-06-08	1977-06-22	1
7377	432	40481087	1931-06-04	1931-06-25	1
7775	455	4166224	1977-01-25	1977-01-26	1
33532	1990	40481087	2017-11-03	2017-11-10	1
78394	4646	28060	1977-01-23	1977-02-02	1
31986	1902	260139	1966-01-03	1966-01-17	1
30046	1779	4112343	1975-11-02	1975-11-11	1
52417	3109	81151	1925-02-05	1925-02-19	1
14224	842	4112343	2004-01-28	2004-02-06	1
71196	4226	261325	2003-12-28	2003-12-29	1
40781	2427	28060	2007-09-06	2007-09-15	1
40311	2395	30753	1995-06-29	1995-06-30	1
36731	2175	40481087	2006-09-09	2006-09-30	1
28074	1658	4296204	1982-05-03	1982-06-07	1
28751	1703	40479422	2019-05-11	2019-05-12	1
42720	2548	260139	1985-04-29	1985-05-13	1
49255	2915	28060	1950-07-18	1950-07-30	1
330	17	4230399	1958-11-29	1959-01-28	1
45953	2740	4112343	1997-02-06	1997-02-14	1
3264	190	4112343	1963-10-10	1963-10-21	1
74253	4412	40481087	2004-05-28	2004-06-11	1
8958	525	80180	1990-03-15	1990-03-16	1
39459	2341	40481087	1975-06-28	1975-07-19	1
58853	3495	372328	1967-02-19	1967-05-24	1
34691	2062	40481087	1999-04-07	1999-04-28	1
7378	432	40481087	1957-02-03	1957-02-24	1
7776	455	4283893	1989-02-19	1989-03-26	1
34909	2076	28060	1982-12-07	1982-12-18	1
78395	4646	257012	1970-11-25	1971-01-13	1
31987	1902	372328	1946-11-12	1947-05-04	1
30047	1779	4112343	1997-10-06	1997-10-14	1
52418	3109	81151	1956-12-03	1956-12-24	1
14225	842	4113008	1970-10-20	1970-11-10	1
71197	4226	372328	1965-08-04	1965-10-24	1
40782	2427	260139	1957-07-24	1957-07-31	1
40312	2395	260139	1990-06-01	1990-06-15	1
36732	2175	372328	1980-08-22	1981-01-08	1
28075	1658	40481087	1929-11-03	1929-11-17	1
28752	1703	40481087	1952-04-21	1952-04-28	1
42721	2548	4112343	2014-03-31	2014-04-09	1
49256	2915	28060	1969-09-16	1969-09-23	1
331	17	4296205	1971-10-27	1971-12-01	1
45954	2740	28060	1988-03-28	1988-04-10	1
3265	190	4112343	1999-10-29	1999-11-10	1
74254	4412	40481087	2010-12-10	2010-12-31	1
8959	525	81151	2000-09-17	2000-10-08	1
39460	2341	28060	1961-05-21	1961-06-02	1
58854	3495	4296204	2014-08-22	2014-09-26	1
34692	2062	257012	1957-07-18	1965-12-31	1
7379	432	40481087	1977-11-05	1977-11-26	1
7777	455	0	1977-01-25	1977-01-26	1
34910	2076	260139	1972-07-02	1972-07-09	1
78396	4646	4283893	1960-03-14	1960-04-11	1
31988	1902	4027663	1974-11-20	1974-11-21	1
30048	1779	4218389	1988-02-12	1988-03-04	1
52419	3109	372328	1920-03-03	1920-05-19	1
14226	842	4237458	1940-08-16	1940-09-15	1
71198	4226	4294548	1976-07-16	1977-01-14	1
40783	2427	4112343	1943-12-06	1943-12-13	1
40313	2395	375671	1975-03-12	1975-04-11	1
36733	2175	440448	1979-01-29	1979-01-30	1
28076	1658	40481087	1943-12-28	1944-01-04	1
29428	1745	78272	1984-08-16	1984-09-13	1
42722	2548	40481087	1966-05-07	1966-05-28	1
49257	2915	78272	1950-12-02	1950-12-23	1
332	17	40481087	2008-07-12	2008-07-26	1
45955	2740	80180	2010-04-19	2010-04-20	1
3266	190	4113008	1971-07-17	1971-08-07	1
74255	4412	28060	1982-10-17	1982-10-25	1
8960	525	257012	1988-07-30	1988-07-31	1
39461	2341	28060	1962-06-28	1962-07-06	1
58855	3495	260139	1979-05-06	1979-05-20	1
34693	2062	260139	1951-12-03	1951-12-10	1
7380	432	40481087	2002-11-29	2002-12-06	1
7778	455	78272	1951-09-23	1951-10-14	1
34911	2076	260139	1987-12-09	1987-12-16	1
78397	4646	40481087	2012-05-26	2012-06-02	1
31989	1902	4112343	1952-02-17	1952-02-28	1
30049	1779	4230399	1953-02-01	1953-05-02	1
52420	3109	381316	1990-02-21	1990-02-22	1
14227	842	4296204	1997-11-30	1998-01-04	1
71199	4226	40481087	2002-03-27	2002-04-17	1
40784	2427	4112343	1959-12-03	1959-12-13	1
40314	2395	4155034	1962-03-29	1962-04-19	1
36734	2175	4112343	2000-11-02	2000-11-10	1
28077	1658	40481087	1981-08-02	1981-08-16	1
29429	1745	260139	2018-03-18	2018-03-25	1
42723	2548	40481087	1980-10-19	1980-11-09	1
49258	2915	81151	1974-01-12	1974-01-26	1
333	17	28060	1960-02-08	1960-02-20	1
45956	2740	4027663	2002-12-02	2002-12-03	1
3267	190	4155034	2011-01-07	2011-01-21	1
74256	4412	372328	1965-11-19	1966-01-07	1
8961	525	260139	2002-02-19	2002-02-26	1
39462	2341	260139	2006-05-28	2006-06-04	1
58856	3495	372328	1966-04-12	1966-05-25	1
34694	2062	4112343	1948-07-09	1948-07-21	1
7381	432	40481087	2018-06-24	2018-07-08	1
7779	455	80180	1986-08-15	1986-08-16	1
34912	2076	260139	1988-03-17	1988-03-31	1
78398	4646	0	1964-07-29	1964-07-30	1
31990	1902	4112343	1960-11-14	1960-11-26	1
30050	1779	40481087	1978-02-08	1978-03-01	1
52421	3109	4112343	1955-05-07	1955-05-19	1
14228	842	40481087	1937-01-20	1937-02-03	1
71200	4226	4112343	1967-06-27	1967-07-08	1
40785	2427	4112343	1974-07-29	1974-08-06	1
40315	2395	4278672	1966-01-28	1966-04-28	1
36735	2175	4112343	2016-02-23	2016-03-02	1
28460	1686	28060	1969-03-11	1969-03-21	1
29430	1745	372328	1980-02-09	1980-03-24	1
42724	2548	4112343	2011-08-02	2011-08-10	1
49259	2915	257012	1974-12-19	1974-12-20	1
334	17	80180	1989-11-21	1989-11-22	1
45957	2740	4059173	1996-10-14	1997-01-12	1
3268	190	40481087	1934-03-25	1934-04-15	1
74257	4412	4112343	1981-12-06	1981-12-19	1
8962	525	378001	1972-04-17	1972-05-17	1
39463	2341	260139	2008-03-26	2008-04-02	1
58857	3495	4112343	1978-01-24	1978-02-04	1
34695	2062	4112343	1965-01-12	1965-01-24	1
7726	454	80180	1970-09-09	1970-09-10	1
7780	455	260139	1951-05-28	1951-06-04	1
34913	2076	4155034	1970-11-08	1970-11-29	1
78399	4646	80180	1986-12-15	1986-12-16	1
31991	1902	40481087	1962-07-24	1962-08-14	1
30051	1779	81151	1955-03-23	1955-04-06	1
52422	3109	40481087	1937-09-22	1937-10-13	1
14229	842	40481087	1952-02-13	1952-02-20	1
71201	4226	4112343	1992-08-04	1992-08-14	1
40786	2427	4112343	2014-03-22	2014-04-01	1
40316	2395	40481087	2019-04-30	2019-05-21	1
36736	2175	4152936	2019-02-03	2019-02-17	1
28461	1686	81151	1978-03-20	1978-04-24	1
29431	1745	4112343	1985-07-28	1985-08-07	1
42725	2548	4218389	1998-03-14	1998-04-18	1
49260	2915	4112343	1949-04-13	1949-04-22	1
335	17	81151	1994-11-21	1994-12-19	1
45958	2740	4112343	1977-04-01	1977-04-13	1
3269	190	40481087	1951-06-23	1951-07-07	1
74258	4412	40481087	1995-07-02	1995-07-23	1
8963	525	4112343	1977-10-31	1977-11-12	1
39464	2341	372328	1955-12-21	1957-01-03	1
58858	3495	4296204	1985-03-08	1985-04-05	1
34696	2062	4283893	1957-05-30	1957-07-25	1
7727	454	260139	1958-01-01	1958-01-08	1
7781	455	378001	1973-04-03	1973-05-03	1
34914	2076	4218389	2017-12-27	2018-01-24	1
78400	4646	81151	2017-10-17	2017-11-07	1
35304	2094	40481087	1945-12-07	1945-12-21	1
30052	1779	4112343	1970-11-14	1970-11-26	1
52423	3109	40481087	1979-02-13	1979-02-20	1
14230	842	260139	2011-07-13	2011-07-20	1
71202	4226	4218389	2017-10-21	2017-11-11	1
40787	2427	4218389	1994-06-09	1994-07-07	1
40317	2395	28060	1975-05-03	1975-05-13	1
36737	2175	40481087	2003-01-27	2003-02-10	1
28462	1686	4283893	2018-02-22	2018-03-08	1
29432	1745	40481087	1993-10-31	1993-11-14	1
42726	2548	40481087	1994-09-04	1994-09-18	1
49261	2915	4112343	1955-03-19	1955-03-31	1
336	17	4112343	1965-07-07	1965-07-15	1
45959	2740	4112343	1978-09-06	1978-09-13	1
3270	190	255848	2016-03-25	2016-03-26	1
76865	4560	30753	2005-10-12	2005-10-13	1
8964	525	40481087	2003-02-10	2003-03-03	1
39465	2341	4112343	2014-08-17	2014-08-28	1
58859	3495	40481087	1971-05-25	1971-06-08	1
34697	2062	4283893	1965-12-17	1965-12-31	1
7728	454	260139	1992-12-17	1992-12-31	1
7782	455	378001	1997-10-24	1997-11-23	1
34915	2076	40481087	1978-09-03	1978-09-10	1
78401	4646	260139	1986-06-11	1986-06-25	1
35305	2094	40481087	1962-12-08	1962-12-29	1
30053	1779	4156265	2002-12-07	2002-12-21	1
52424	3109	78272	1987-09-04	1987-09-25	1
14231	842	439777	1991-11-07	1991-11-08	1
71203	4226	4280726	1964-11-24	1964-11-25	1
40788	2427	40481087	1943-06-14	1943-06-21	1
40318	2395	80180	1996-06-23	1996-06-24	1
38294	2277	260139	1977-10-04	1977-10-18	1
28463	1686	40481087	1990-02-05	1990-02-19	1
29433	1745	28060	1979-08-16	1979-08-27	1
42727	2548	40481087	1995-05-23	1995-05-30	1
49262	2915	4112343	1969-11-25	1969-12-08	1
337	17	40481087	1951-12-13	1951-12-27	1
45960	2740	4294548	2015-11-18	2016-05-11	1
3271	190	260139	1949-12-26	1950-01-09	1
76866	4560	81893	2005-04-15	2005-04-16	1
8965	525	40481087	2007-02-19	2007-02-26	1
39466	2341	40481087	1974-12-17	1974-12-24	1
58860	3495	40481087	1977-06-13	1977-06-27	1
34698	2062	40481087	1954-10-24	1954-11-07	1
7729	454	4112343	1937-07-28	1937-08-09	1
7783	455	4112343	1990-04-18	1990-04-30	1
34916	2076	81893	1998-10-17	1998-10-18	1
78402	4646	440448	1964-07-29	1964-07-30	1
35306	2094	40481087	2012-09-29	2012-10-06	1
30054	1779	40481087	1954-11-26	1954-12-17	1
52425	3109	257012	1985-05-05	1985-05-06	1
14232	842	4112343	1917-09-19	1917-09-26	1
71204	4226	40481087	1977-08-21	1977-09-04	1
40789	2427	40481087	2012-05-21	2012-06-04	1
40319	2395	192671	1996-09-12	1996-09-13	1
38295	2277	260139	1992-07-06	1992-07-20	1
28464	1686	40481087	1994-05-04	1994-05-18	1
29434	1745	80180	2017-05-25	2017-05-26	1
42728	2548	40481087	2001-08-01	2001-08-08	1
49263	2915	4112343	1986-11-13	1986-11-24	1
338	17	40481087	1974-09-16	1974-09-23	1
47600	2833	28060	1940-04-03	1940-04-15	1
3272	190	260139	1979-03-01	1979-03-16	1
76867	4560	4027663	1994-10-25	1994-10-26	1
8966	525	28060	1997-04-03	1997-04-13	1
39467	2341	78272	1969-02-17	1969-03-03	1
58861	3495	40481087	1988-04-24	1988-05-08	1
34699	2062	81151	1964-04-10	1964-04-24	1
7730	454	40481087	1969-11-29	1969-12-06	1
7784	455	4218389	2001-07-05	2001-08-09	1
34917	2076	257012	2016-08-22	2016-08-23	1
78403	4646	4156265	1946-09-16	1946-09-30	1
35307	2094	81151	1966-08-11	1966-08-25	1
30055	1779	260139	1956-03-31	1956-04-07	1
52426	3109	260139	1931-02-05	1931-02-19	1
14233	842	4112343	1933-01-22	1933-01-29	1
71205	4226	40481087	1994-05-17	1994-05-31	1
43748	2609	4156265	1967-08-04	1967-08-25	1
40320	2395	260139	2012-10-19	2012-10-26	1
38296	2277	372328	1970-03-13	1970-08-16	1
28465	1686	40481087	1998-09-23	1998-10-14	1
29435	1745	4112343	2002-09-09	2002-09-22	1
43521	2596	260139	1980-10-21	1980-11-04	1
49264	2915	4112343	2006-08-26	2006-09-04	1
339	17	40481087	1994-04-07	1994-04-28	1
47601	2833	4112343	1947-12-09	1947-12-22	1
3273	190	372328	1930-08-07	1930-10-14	1
76868	4560	4112343	1999-08-30	1999-09-11	1
8967	525	196456	1952-05-22	1952-05-22	1
39468	2341	80180	1986-01-03	1986-01-04	1
58862	3495	40481087	1990-02-02	1990-02-16	1
34700	2062	260139	1947-08-13	1947-08-27	1
7731	454	40481087	2001-08-15	2001-08-22	1
7785	455	4278672	1960-02-11	1960-03-12	1
34918	2076	4237458	1976-11-27	1977-02-25	1
78404	4646	4283893	1970-09-23	1971-01-13	1
35308	2094	81151	2014-08-04	2014-08-18	1
30056	1779	4112343	1965-08-29	1965-09-07	1
52427	3109	260139	1964-06-29	1964-07-06	1
14234	842	4156265	1968-11-15	1968-11-29	1
71206	4226	40481087	2016-11-08	2016-11-29	1
43749	2609	40481087	1993-12-04	1993-12-18	1
40321	2395	372328	1961-08-31	1962-01-19	1
38297	2277	40481087	1965-11-12	1965-11-19	1
28466	1686	40481087	2004-08-19	2004-08-26	1
29436	1745	4278672	1986-06-05	1986-08-04	1
43522	2596	260139	1988-12-07	1988-12-14	1
49265	2915	4294548	1974-11-14	1975-01-16	1
1803	103	81151	1990-08-16	1990-08-30	1
47602	2833	4112343	1972-05-05	1972-05-14	1
3274	190	4218389	2014-12-01	2014-12-22	1
76869	4560	4310024	2004-08-18	2004-08-19	1
8968	525	260139	1994-09-07	1994-09-14	1
39469	2341	260139	2010-02-23	2010-03-02	1
58863	3495	40481087	2003-02-03	2003-02-17	1
34701	2062	372328	1948-04-08	1948-05-22	1
7732	454	30753	1970-01-12	1970-01-13	1
7786	455	40481087	1951-04-22	1951-04-29	1
34919	2076	40481087	2011-09-28	2011-10-12	1
78405	4646	4294548	1979-08-08	1980-01-02	1
35309	2094	372328	1945-02-02	1945-03-18	1
30057	1779	4112343	1997-05-23	1997-06-04	1
52428	3109	260139	1968-07-22	1968-08-05	1
14235	842	4285898	1942-12-09	1942-12-10	1
72942	4340	28060	1978-11-03	1978-11-16	1
43750	2609	260139	1960-07-21	1960-07-28	1
40322	2395	372328	1964-06-07	1965-01-29	1
38298	2277	80180	2001-03-15	2001-03-16	1
28467	1686	257012	1998-06-07	1998-06-08	1
29437	1745	260139	2007-06-19	2007-06-26	1
43523	2596	4112343	1990-04-12	1990-04-22	1
49266	2915	40481087	1946-11-02	1946-11-23	1
1804	103	260139	1974-07-22	1974-07-29	1
47603	2833	40481087	1994-05-15	1994-05-29	1
3275	190	4283893	1982-10-19	1982-12-07	1
76870	4560	40481087	1985-04-10	1985-04-17	1
8969	525	4113008	1955-01-03	1955-01-17	1
39470	2341	313217	2002-03-28	2002-03-29	1
58864	3495	80180	2001-02-27	2001-02-28	1
34702	2062	4109685	1985-04-04	1985-04-18	1
7733	454	372328	1936-01-08	1936-02-08	1
7787	455	28060	1995-04-01	1995-04-14	1
34920	2076	260139	2005-07-10	2005-07-24	1
78406	4646	40481087	1983-10-21	1983-10-28	1
35310	2094	4112343	2004-08-29	2004-09-08	1
30058	1779	40481087	1949-09-27	1949-10-04	1
52429	3109	378001	1934-12-29	1935-02-27	1
14236	842	4294548	1926-03-28	1926-07-11	1
72943	4340	28060	1994-10-07	1994-10-20	1
43751	2609	321042	2018-12-14	2018-12-15	1
40323	2395	375671	1993-07-26	1993-08-25	1
38299	2277	4112343	1970-07-15	1970-07-22	1
28468	1686	260139	1976-11-27	1976-12-04	1
29438	1745	40481087	1986-07-13	1986-08-03	1
43524	2596	4112343	2014-06-17	2014-06-28	1
49267	2915	40481087	1954-10-19	1954-11-09	1
1805	103	4112343	1979-07-11	1979-07-24	1
47604	2833	28060	2001-09-22	2001-09-30	1
3276	190	4112343	1937-05-04	1937-05-17	1
76871	4560	40481087	1996-10-31	1996-11-07	1
8970	525	4283893	1964-04-22	1964-06-03	1
39471	2341	4112343	1959-08-19	1959-08-27	1
58865	3495	372328	1968-01-19	1968-05-22	1
34703	2062	4112343	1953-09-26	1953-10-09	1
7734	454	375671	1985-02-19	1985-04-20	1
7788	455	78272	1954-04-22	1954-05-13	1
34921	2076	4027663	1992-12-22	1992-12-23	1
78407	4646	40481087	1990-07-16	1990-07-30	1
35311	2094	40481087	1946-06-25	1946-07-09	1
30059	1779	40481087	1952-09-24	1952-10-01	1
52430	3109	440086	1925-06-10	1929-08-21	1
14237	842	4310024	1941-07-17	1941-07-18	1
72944	4340	81151	2000-10-07	2000-10-28	1
43752	2609	4112343	1974-12-08	1974-12-19	1
40324	2395	4109685	1989-07-26	1989-08-16	1
38300	2277	40481087	1975-11-02	1975-11-16	1
28469	1686	378001	1999-12-30	2000-02-28	1
29439	1745	40481087	1996-12-25	1997-01-15	1
43525	2596	4266809	2004-06-06	2004-06-07	1
50027	2959	260139	1977-08-19	1977-08-26	1
1806	103	4112343	2000-12-25	2001-01-06	1
47605	2833	80180	1977-05-21	1977-05-22	1
3277	190	4116491	1963-06-30	1963-08-20	1
76872	4560	80180	2007-02-04	2007-02-05	1
8971	525	40481087	1993-04-19	1993-04-26	1
39472	2341	4155034	2005-09-25	2005-10-09	1
58866	3495	4112343	1984-01-05	1984-01-17	1
34704	2062	4218389	1951-04-23	1951-05-28	1
7735	454	378001	1990-01-24	1990-02-23	1
7789	455	78272	2014-06-02	2014-06-16	1
34922	2076	4112343	2009-09-29	2009-10-12	1
78408	4646	257012	1979-11-14	1979-11-15	1
35312	2094	40481087	1950-01-28	1950-02-18	1
30060	1779	40481087	1977-05-25	1977-06-08	1
52431	3109	4043241	1983-09-21	1983-09-22	1
14238	842	40481087	1918-06-18	1918-07-02	1
72945	4340	40481087	2006-07-13	2006-07-20	1
43753	2609	4113008	1961-04-16	1961-05-07	1
40325	2395	4112343	1978-12-25	1979-01-05	1
38301	2277	40481087	2017-09-19	2017-10-10	1
28470	1686	4283893	1998-05-03	1998-07-19	1
29440	1745	4112343	2003-11-19	2003-11-28	1
43526	2596	40481087	1976-08-14	1976-08-21	1
50028	2959	260139	2018-06-03	2018-06-17	1
1807	103	4116491	2000-05-19	2000-06-21	1
47606	2833	81151	1975-12-13	1976-01-10	1
3278	190	4218389	1997-09-19	1997-10-17	1
76873	4560	372328	1969-06-23	1969-10-08	1
8972	525	372328	1950-03-30	1950-06-12	1
39473	2341	40481087	1968-06-05	1968-06-12	1
58867	3495	4152936	1981-05-14	1981-05-28	1
34705	2062	4294548	1950-12-29	1951-01-05	1
7736	454	378419	2013-02-16	2013-02-17	1
7790	455	260139	1966-04-30	1966-05-14	1
34923	2076	4218389	2006-10-21	2006-11-25	1
78409	4646	260139	1945-09-22	1945-09-29	1
35313	2094	40481087	1997-08-20	1997-09-10	1
30061	1779	40481087	1993-09-12	1993-09-26	1
52432	3109	4112343	1939-09-16	1939-09-24	1
14239	842	40481087	1943-11-20	1943-12-04	1
72946	4340	80180	2010-01-31	2010-02-01	1
43754	2609	40481087	1966-07-14	1966-07-28	1
40326	2395	4027663	1987-02-06	1987-02-07	1
38302	2277	260139	2005-10-09	2005-10-23	1
28471	1686	40481087	1993-07-08	1993-07-29	1
29441	1745	40481087	1982-02-07	1982-02-28	1
43527	2596	40481087	1994-01-24	1994-02-14	1
50029	2959	321042	1997-10-07	1997-10-08	1
1808	103	4294548	1981-09-16	1981-11-18	1
47607	2833	260139	1947-06-15	1947-06-22	1
3279	190	40481087	1990-05-08	1990-05-22	1
76874	4560	4112343	1984-06-06	1984-06-15	1
8973	525	4112343	1971-12-08	1971-12-20	1
39474	2341	40481087	2019-04-04	2019-04-11	1
58868	3495	40481087	1981-01-14	1981-02-04	1
34706	2062	40481087	1959-01-23	1959-02-13	1
7737	454	4109685	1991-12-15	1991-12-29	1
7791	455	4112343	1950-12-29	1951-01-11	1
34924	2076	4266809	1999-11-11	1999-11-12	1
78410	4646	260139	1947-07-03	1947-07-17	1
35314	2094	28060	1950-08-08	1950-08-21	1
31653	1878	28060	1987-09-13	1987-09-24	1
52433	3109	40481087	1933-10-27	1933-11-03	1
14240	842	40481087	1950-12-04	1950-12-11	1
72947	4340	81893	2008-08-09	2008-08-10	1
43755	2609	40481087	1986-02-14	1986-03-07	1
40327	2395	4112343	2015-07-27	2015-08-07	1
38303	2277	4278672	1971-04-07	1971-07-06	1
28472	1686	40481087	2018-10-13	2018-10-20	1
29442	1745	40481087	1988-11-29	1988-12-20	1
43528	2596	80180	2004-06-06	2004-06-07	1
50030	2959	4059173	1975-03-31	1975-06-29	1
1809	103	81151	1972-03-02	1972-03-23	1
47608	2833	260139	1980-04-01	1980-04-08	1
3280	190	40481087	1999-03-14	1999-04-04	1
76875	4560	40481087	2018-01-22	2018-01-29	1
8974	525	4283893	1988-06-04	1988-09-03	1
39475	2341	375671	1998-10-02	1998-11-01	1
58869	3495	40481087	1983-03-03	1983-03-17	1
34707	2062	40481087	2019-06-19	2019-06-26	1
7738	454	4112343	1937-05-21	1937-05-28	1
7792	455	4112343	1969-05-10	1969-05-22	1
34925	2076	4283893	2016-07-25	2016-11-07	1
78411	4646	260139	1983-09-17	1983-09-24	1
35315	2094	81893	1983-12-25	1983-12-26	1
31654	1878	372328	1975-12-21	1976-02-21	1
52434	3109	40481087	1948-10-03	1948-10-24	1
14241	842	40481087	1964-10-04	1964-10-25	1
72948	4340	4027663	2001-09-15	2001-09-16	1
43756	2609	372328	1961-11-12	1962-01-26	1
40328	2395	4112343	2015-10-08	2015-10-20	1
38304	2277	4278672	1977-04-05	1977-05-05	1
28473	1686	28060	1991-10-23	1991-11-01	1
29443	1745	40481087	1994-02-20	1994-03-06	1
43529	2596	260139	2018-11-09	2018-11-23	1
50031	2959	4059173	1986-09-29	1986-12-28	1
1810	103	260139	2002-04-30	2002-05-07	1
47609	2833	4112343	1978-06-13	1978-06-21	1
3281	190	80180	1969-01-19	1969-01-20	1
76876	4560	260139	2012-10-07	2012-10-21	1
8975	525	198809	1952-05-22	1952-05-22	1
39476	2341	4116491	1977-03-21	1977-04-24	1
58870	3495	40481087	1996-02-21	1996-03-06	1
36598	2168	80180	1989-10-25	1989-10-26	1
7739	454	4112343	1977-11-09	1977-11-20	1
7793	455	4218389	1952-08-09	1952-08-30	1
34926	2076	4285898	1999-09-12	1999-09-13	1
78412	4646	260139	2001-09-20	2001-10-04	1
35316	2094	260139	1989-12-09	1989-12-16	1
31655	1878	4112343	1996-08-01	1996-08-08	1
52435	3109	80180	1953-10-16	1953-10-17	1
14242	842	40481087	1987-02-02	1987-02-16	1
72949	4340	4112343	1973-06-23	1973-07-01	1
43757	2609	4278672	1960-03-22	1960-04-21	1
40329	2395	4134304	1973-01-21	1973-04-21	1
38305	2277	81151	1987-07-12	1987-08-02	1
28474	1686	80180	1999-04-29	1999-04-30	1
30394	1794	0	1972-02-06	1972-02-07	1
43530	2596	375671	1987-07-02	1987-08-01	1
50032	2959	4084167	1972-05-15	1972-05-15	1
1811	103	260139	2018-12-21	2019-01-04	1
47610	2833	40481087	1986-07-11	1986-07-18	1
3282	190	81151	1969-08-12	1969-08-26	1
76877	4560	4166224	1977-10-30	1977-10-31	1
8976	525	4112343	1967-03-21	1967-04-02	1
39477	2341	4152936	1967-01-08	1967-01-29	1
59623	3537	80180	2002-04-01	2002-04-02	1
36599	2168	260139	1987-03-19	1987-03-26	1
7740	454	4112343	2017-09-04	2017-09-17	1
7794	455	40481087	1950-03-07	1950-03-21	1
34927	2076	40481087	1976-03-31	1976-04-07	1
78413	4646	4112343	1948-11-07	1948-11-17	1
35317	2094	260139	2018-12-17	2018-12-24	1
31656	1878	0	2004-03-09	2004-03-10	1
52436	3109	81151	1971-02-09	1971-03-02	1
14243	842	40481087	2010-01-30	2010-02-20	1
72950	4340	4112343	1985-04-16	1985-04-24	1
43758	2609	40481087	1997-11-04	1997-11-11	1
40330	2395	4285898	1995-10-27	1995-10-28	1
38306	2277	372328	1970-10-15	1971-08-22	1
28475	1686	260139	1980-06-15	1980-06-29	1
30395	1794	260139	1978-07-29	1978-08-05	1
43531	2596	378001	2004-07-02	2004-08-31	1
50033	2959	440086	1978-12-20	1980-12-17	1
1812	103	439777	2002-05-19	2002-05-20	1
47611	2833	372328	1977-08-04	1977-10-24	1
3283	190	4035415	1954-11-29	1955-01-28	1
76878	4560	4237458	1983-07-06	1983-08-05	1
8977	525	4112343	1972-05-21	1972-05-28	1
39478	2341	4283893	2012-12-25	2013-04-30	1
56655	3363	4283893	1973-10-26	1973-12-14	1
36600	2168	378001	1974-06-26	1974-07-26	1
7741	454	4266809	1970-09-09	1970-09-10	1
7795	455	40481087	1970-07-31	1970-08-21	1
34928	2076	40481087	1983-05-23	1983-05-30	1
78414	4646	4283893	1986-11-20	1987-01-29	1
35318	2094	4059173	1948-09-14	1948-10-14	1
31657	1878	80180	2010-07-25	2010-07-26	1
52437	3109	372328	1923-05-10	1924-05-28	1
14244	842	40481087	2013-11-06	2013-11-20	1
72951	4340	4112343	2005-06-05	2005-06-13	1
43759	2609	40481087	2000-08-03	2000-08-10	1
40331	2395	40481087	1963-08-26	1963-09-09	1
38307	2277	40481087	1995-07-13	1995-07-20	1
28476	1686	378001	2016-12-30	2017-01-29	1
30396	1794	372328	1961-09-13	1962-01-13	1
43532	2596	4134304	1974-04-11	1974-05-11	1
50034	2959	4112343	1985-11-04	1985-11-12	1
1813	103	4112343	1974-02-22	1974-03-06	1
47612	2833	378419	2008-02-18	2008-02-19	1
3284	190	4112343	1961-03-13	1961-03-23	1
76879	4560	40481087	1979-10-04	1979-10-18	1
8978	525	4134304	1965-03-25	1965-06-23	1
39479	2341	40481087	1982-04-21	1982-04-28	1
56656	3363	40481087	1968-04-13	1968-04-20	1
36601	2168	4051466	1960-09-19	1976-01-04	1
7742	454	81893	1969-07-16	1969-07-17	1
7796	455	440448	1977-01-25	1977-01-26	1
34929	2076	40481087	1986-08-17	1986-08-31	1
78415	4646	40481087	2000-09-10	2000-09-24	1
35319	2094	4112343	1977-01-02	1977-01-12	1
31658	1878	192671	2010-10-08	2010-10-09	1
52438	3109	4112343	1928-11-18	1928-11-27	1
14245	842	30753	1942-11-09	1942-11-10	1
72952	4340	4218389	1977-04-29	1977-05-20	1
43760	2609	40481087	2010-02-24	2010-03-10	1
40332	2395	40481087	1978-05-28	1978-06-04	1
38308	2277	40481087	2011-01-04	2011-01-18	1
28477	1686	4112343	2002-04-09	2002-04-22	1
30397	1794	440448	1972-02-06	1972-02-07	1
43533	2596	40479422	2017-03-26	2017-06-01	1
50035	2959	78272	2005-01-22	2005-02-05	1
1814	103	4112343	1981-09-24	1981-10-02	1
47613	2833	4112343	1967-07-14	1967-07-27	1
3285	190	4134304	1936-02-07	1936-05-07	1
76880	4560	40481087	1982-11-09	1982-11-16	1
8979	525	4152936	2013-03-04	2013-03-18	1
40195	2387	378001	1994-04-12	1994-05-12	1
56657	3363	40481087	1978-07-29	1978-08-05	1
36602	2168	4156265	1963-12-02	1963-12-16	1
7743	454	195588	1954-04-21	1954-05-23	1
7797	455	4112343	1992-12-19	1992-12-27	1
34930	2076	40481087	1994-12-26	1995-01-16	1
78416	4646	40481087	2003-08-19	2003-09-02	1
35320	2094	4237458	1950-07-06	1950-10-04	1
31659	1878	4112343	1990-03-12	1990-03-21	1
52439	3109	4112343	1930-08-22	1930-08-31	1
14246	842	80180	1943-05-08	1943-05-09	1
72953	4340	4218389	1984-02-13	1984-03-05	1
43761	2609	0	1967-05-02	1967-05-03	1
40333	2395	40481087	1979-01-07	1979-01-28	1
39786	2358	30753	2006-12-21	2006-12-22	1
28478	1686	40481087	1968-03-21	1968-04-11	1
30398	1794	4112343	2000-08-16	2000-08-23	1
43534	2596	260139	1978-04-14	1978-04-28	1
50036	2959	80180	2009-12-27	2009-12-28	1
1815	103	40481087	1976-06-16	1976-07-07	1
47614	2833	4152936	1979-12-20	1980-01-10	1
3286	190	40481087	1975-12-06	1975-12-20	1
76881	4560	40481087	1993-09-02	1993-09-09	1
8980	525	40481087	2002-02-15	2002-03-08	1
40196	2387	80180	2006-04-04	2006-04-05	1
57455	3413	28060	1983-02-09	1983-02-21	1
36603	2168	40481087	1956-12-21	1957-01-04	1
7744	454	260139	1959-06-04	1959-06-11	1
7798	455	40481087	1952-11-25	1952-12-09	1
34931	2076	30753	1999-05-15	1999-05-16	1
83631	4975	28060	1973-10-19	1973-10-30	1
35321	2094	40481087	1958-05-12	1958-05-26	1
31660	1878	4156265	1980-12-04	1980-12-25	1
52440	3109	4112343	1977-12-23	1978-01-04	1
14247	842	260139	1914-08-04	1914-08-18	1
72954	4340	4283893	1984-05-12	1984-08-04	1
43762	2609	0	2018-12-14	2018-12-15	1
40334	2395	40481087	1987-06-20	1987-06-27	1
39787	2358	78272	1984-07-29	1984-08-19	1
28479	1686	372328	1964-08-30	1965-02-21	1
30399	1794	4113008	1990-04-25	1990-05-09	1
43535	2596	260139	1985-06-18	1985-06-25	1
50037	2959	260139	1993-02-24	1993-03-10	1
1816	103	40481087	2014-04-04	2014-04-18	1
47615	2833	40481087	1951-05-01	1951-05-22	1
3287	190	40481087	1999-05-10	1999-05-24	1
76882	4560	40481087	2001-05-07	2001-05-28	1
14122	836	195588	2007-08-27	2007-10-11	1
40197	2387	4294548	1969-04-28	1969-06-30	1
57456	3413	257012	1980-06-11	1980-06-12	1
36604	2168	78272	2016-07-06	2016-07-27	1
7745	454	313217	2005-03-05	2005-03-06	1
7799	455	40481087	1969-01-23	1969-01-30	1
34932	2076	80180	1999-11-11	1999-11-12	1
83632	4975	28060	2011-07-03	2011-07-15	1
35322	2094	40481087	1991-04-25	1991-05-16	1
31661	1878	4283893	1998-02-03	1998-04-15	1
52441	3109	4283893	1985-03-24	1985-07-14	1
14248	842	260139	1938-03-25	1938-04-01	1
72955	4340	4285898	2009-10-03	2009-10-04	1
43763	2609	28060	2013-04-11	2013-04-22	1
40335	2395	40481087	1989-03-26	1989-04-09	1
39788	2358	260139	2016-10-01	2016-10-15	1
28480	1686	40481087	1978-01-24	1978-01-31	1
30400	1794	40481087	1974-05-26	1974-06-02	1
43536	2596	4134304	1983-09-21	1983-12-20	1
50038	2959	4051466	1973-12-28	1993-02-23	1
1817	103	28060	2009-08-26	2009-09-05	1
47616	2833	40481087	1959-09-13	1959-09-27	1
4807	283	28060	1984-02-15	1984-02-25	1
76883	4560	40481087	2011-08-11	2011-08-18	1
14123	836	260139	2001-01-29	2001-02-05	1
40198	2387	4310024	2004-11-10	2004-11-11	1
57457	3413	260139	1982-08-23	1982-08-30	1
36605	2168	81151	1960-08-23	1960-09-27	1
7746	454	372328	1935-07-30	1935-11-09	1
10295	609	0	2014-12-02	2014-12-03	1
34933	2076	260139	1984-04-16	1984-04-23	1
83633	4975	81151	1999-01-01	1999-01-29	1
35323	2094	40481087	2016-07-24	2016-08-07	1
31662	1878	40481087	2007-02-04	2007-02-18	1
52442	3109	40481087	1937-12-20	1938-01-03	1
14249	842	260139	1992-01-28	1992-02-11	1
72956	4340	40481087	1992-02-03	1992-02-17	1
43764	2609	80180	1993-07-12	1993-07-13	1
40336	2395	40481087	2003-01-02	2003-01-16	1
39789	2358	372328	1977-10-04	1978-05-30	1
29697	1760	28060	1993-03-19	1993-03-31	1
30401	1794	40481087	1983-12-18	1983-12-25	1
43537	2596	260139	1967-10-25	1967-11-08	1
50039	2959	0	1997-10-07	1997-10-08	1
1818	103	80180	2008-06-01	2008-06-02	1
47617	2833	40481087	2001-04-28	2001-05-05	1
4808	283	81151	1986-12-29	1987-01-19	1
76884	4560	0	1977-10-30	1977-10-31	1
14124	836	372328	1979-05-31	1979-08-12	1
40199	2387	40481087	1994-11-07	1994-11-28	1
57458	3413	260139	2009-03-12	2009-03-19	1
36606	2168	260139	1995-09-12	1995-09-26	1
7747	454	4027663	1961-02-23	1961-02-24	1
10296	609	260139	1975-12-01	1975-12-15	1
34934	2076	260139	1997-12-23	1998-01-06	1
83634	4975	257012	1968-09-27	1968-09-28	1
35324	2094	80180	1985-08-16	1985-08-17	1
31663	1878	257012	1998-03-10	1998-04-15	1
52443	3109	40481087	1946-02-17	1946-03-10	1
14250	842	372328	1912-03-16	1912-05-04	1
72957	4340	40481087	1997-12-26	1998-01-02	1
43765	2609	260139	2017-03-02	2017-03-09	1
41768	2487	28060	1961-04-17	1961-04-29	1
39790	2358	40481087	1979-09-30	1979-10-21	1
29698	1760	80180	2017-08-23	2017-08-24	1
30402	1794	40481087	2015-11-29	2015-12-13	1
43538	2596	372328	1967-03-28	1967-07-08	1
50040	2959	4084167	1977-09-17	1977-09-17	1
1819	103	260139	1996-09-03	1996-09-10	1
47618	2833	40481087	2008-06-29	2008-07-06	1
4809	283	4112343	1992-04-27	1992-05-08	1
76885	4560	81151	1975-06-22	1975-07-27	1
14125	836	372328	1980-12-06	1981-02-08	1
40200	2387	257012	2009-03-01	2009-03-02	1
57459	3413	4112343	1973-06-23	1973-07-03	1
36607	2168	372328	1962-06-14	1962-08-30	1
7748	454	4056621	1954-04-21	1954-04-22	1
10297	609	4112343	1980-11-21	1980-12-02	1
34935	2076	4278672	1973-01-17	1973-02-16	1
83635	4975	372328	1960-02-04	1960-06-16	2
35325	2094	4027663	1977-12-31	1978-01-01	1
31664	1878	372328	1975-06-14	1975-08-24	1
52444	3109	40481087	1979-10-26	1979-11-16	1
14251	842	372328	1985-08-09	1986-04-12	1
72958	4340	257012	1984-06-16	1984-06-17	1
43766	2609	440086	1967-04-30	1976-05-07	1
41769	2487	260139	1993-09-30	1993-10-07	1
39791	2358	80180	2007-09-17	2007-09-18	1
29699	1760	81151	2005-02-22	2005-03-29	1
30403	1794	4109685	2005-03-21	2005-04-04	1
43539	2596	372328	1968-03-04	1968-04-06	1
50041	2959	40481087	2001-04-19	2001-05-10	1
1820	103	4112343	1981-06-14	1981-06-22	1
47619	2833	134438	1968-10-12	1970-06-04	1
4810	283	40481087	2004-03-06	2004-03-13	1
76886	4560	81151	1976-08-20	1976-09-10	1
14126	836	4112343	2001-12-05	2001-12-15	1
40201	2387	260139	1972-05-08	1972-05-15	1
57460	3413	4112343	1976-07-18	1976-07-29	1
36608	2168	4152936	1962-10-17	1962-11-07	1
7749	454	4112343	1960-12-23	1961-01-03	1
10298	609	4112343	1999-03-15	1999-03-28	1
34936	2076	40481087	1969-10-19	1969-10-26	1
83636	4975	4112343	1973-05-11	1973-05-18	1
35326	2094	4112343	1992-12-21	1992-12-29	1
31665	1878	372328	1980-05-01	1981-02-28	1
52445	3109	255848	1990-07-16	1990-07-17	1
14252	842	4027663	1934-11-21	1934-11-22	1
72959	4340	260139	2002-03-20	2002-03-27	1
43767	2609	440448	1967-05-02	1967-05-03	1
41770	2487	4112343	1966-03-16	1966-03-29	1
39792	2358	192671	2007-10-15	2007-10-16	1
29700	1760	260139	2015-01-02	2015-01-16	1
30404	1794	40481087	2017-05-15	2017-06-05	1
43540	2596	372328	1969-05-31	1969-10-04	1
50042	2959	40481087	2018-11-16	2018-11-23	1
7657	450	260139	1967-10-09	1967-10-16	1
47620	2833	260139	2011-08-28	2011-09-04	1
4811	283	28060	1985-01-23	1985-02-02	1
76887	4560	378001	1994-08-07	1994-09-06	1
14127	836	4134304	1992-03-28	1992-06-26	1
40202	2387	260139	2012-08-30	2012-09-13	1
57461	3413	4112343	1998-06-16	1998-06-26	1
36609	2168	4266809	1989-10-25	1989-10-26	1
7750	454	4134304	2006-02-13	2006-05-14	1
10299	609	28060	2010-01-03	2010-01-11	1
39418	2339	133834	1977-03-06	1977-03-07	1
83637	4975	4112343	1976-10-17	1976-10-25	1
35327	2094	4156265	2002-07-17	2002-08-07	1
31666	1878	440448	2004-03-09	2004-03-10	1
52446	3109	372328	1921-06-13	1921-11-16	1
14253	842	4218389	1948-08-04	1948-09-01	1
72960	4340	378001	1995-10-04	1995-12-03	1
43768	2609	4112343	1989-01-06	1989-01-13	1
41771	2487	4112343	1998-12-22	1999-01-04	1
39793	2358	260139	1986-04-22	1986-05-06	1
29701	1760	4278672	1988-12-18	1989-01-17	1
30405	1794	80180	1996-01-19	1996-01-20	1
43541	2596	4027663	1994-10-22	1994-10-23	1
51627	3065	260139	1976-10-19	1976-11-02	1
7658	450	260139	2008-10-15	2008-10-22	1
47621	2833	4112343	1936-12-09	1936-12-17	1
4812	283	81151	2004-06-18	2004-07-02	1
76888	4560	440448	1977-10-30	1977-10-31	1
14128	836	4152936	1985-03-30	1985-04-13	1
40203	2387	4027663	1997-02-15	1997-02-16	1
57462	3413	4283893	1980-05-14	1980-06-25	1
36610	2168	4285898	1989-06-27	1989-06-28	1
7751	454	4294548	1951-06-30	1951-07-07	1
10300	609	257012	1987-08-26	1987-08-27	1
39419	2339	260139	2013-11-16	2013-11-23	1
83638	4975	40481087	1960-01-11	1960-01-25	1
35328	2094	4266809	1985-08-16	1985-08-17	1
31667	1878	4112343	1992-01-14	1992-01-23	1
52447	3109	4112343	1983-09-08	1983-09-16	1
14254	842	4283893	1961-05-10	1961-09-13	1
72961	4340	4112343	2003-02-07	2003-02-14	1
43769	2609	40481087	1959-11-29	1959-12-13	1
41772	2487	4112343	2009-08-22	2009-08-30	1
39794	2358	375671	2009-12-06	2010-01-05	1
29702	1760	40481087	2002-01-13	2002-01-27	1
30406	1794	372328	1963-06-07	1964-01-18	1
43542	2596	4112343	1979-08-24	1979-09-03	1
51628	3065	260139	1999-02-25	1999-03-11	1
7659	450	4027663	1996-04-01	1996-04-02	1
47622	2833	40481087	1985-12-15	1986-01-05	1
4813	283	4112343	1993-06-03	1993-06-14	1
76889	4560	40481087	1989-01-05	1989-01-19	1
14129	836	257012	1989-01-25	1989-01-26	1
40204	2387	4109685	2002-10-27	2002-11-10	1
57463	3413	40481087	1969-03-20	1969-03-27	1
36611	2168	4310024	1987-10-06	1987-10-07	1
7752	454	40481087	1953-07-05	1953-07-19	1
10301	609	4027663	1993-12-05	1993-12-06	1
39420	2339	4084167	1983-05-27	1983-05-27	1
83639	4975	40481087	1986-03-08	1986-03-15	1
35329	2094	40481087	1977-02-20	1977-03-13	1
31668	1878	4112343	2010-06-28	2010-07-11	1
52448	3109	40481087	1941-10-20	1941-11-10	1
14255	842	4296204	1990-04-29	1990-05-13	1
72962	4340	40481087	2011-03-18	2011-04-08	1
43770	2609	40481087	1967-05-03	1967-05-17	1
41773	2487	4116491	1979-02-24	1979-04-15	1
39795	2358	4027663	1998-06-01	1998-06-02	1
29703	1760	192671	2017-09-23	2017-09-24	1
30407	1794	260139	2014-11-15	2014-11-29	1
43543	2596	4142905	1977-04-25	1977-05-25	1
51629	3065	4112343	1989-10-26	1989-11-05	1
7660	450	4112343	1998-03-30	1998-04-08	1
47623	2833	40481087	2005-10-20	2005-11-03	1
4814	283	40481087	2013-07-29	2013-08-12	1
76890	4560	40481087	2000-02-26	2000-03-04	1
14130	836	260139	1990-06-09	1990-06-16	1
40205	2387	4283893	2009-02-01	2009-05-17	1
57464	3413	40481087	1977-05-22	1977-06-05	1
36612	2168	40481087	1986-10-04	1986-10-18	1
7753	454	40481087	2013-01-29	2013-02-12	1
10302	609	4112343	1974-08-11	1974-08-23	1
39421	2339	40481087	1978-10-29	1978-11-05	1
83640	4975	260139	1983-05-25	1983-06-01	1
35330	2094	40481087	1985-06-05	1985-06-19	1
31669	1878	4166224	2004-03-09	2004-03-10	1
52449	3109	40481087	1944-11-02	1944-11-16	1
14256	842	40481087	1925-06-18	1925-06-25	1
72963	4340	192671	2010-04-28	2010-04-29	1
43771	2609	40481087	1978-10-25	1978-11-15	1
41774	2487	40481087	1978-02-19	1978-03-12	1
39796	2358	4112343	1973-12-25	1974-01-07	1
29704	1760	257012	2018-05-29	2018-06-19	1
30408	1794	372328	1960-11-28	1961-07-15	2
43544	2596	4155034	2018-03-28	2018-04-11	1
51630	3065	4237458	1981-02-23	1981-04-24	1
7661	450	4285898	2004-05-15	2004-05-16	1
49314	2919	0	1965-08-17	1965-08-18	1
4815	283	80180	2018-10-12	2018-10-13	1
77704	4608	80180	1997-03-25	1997-03-26	1
14131	836	372328	1979-12-10	1980-02-10	1
40206	2387	40481087	1994-09-08	1994-09-29	1
57465	3413	40481087	1989-06-14	1989-06-21	1
36613	2168	40481087	1991-08-11	1991-08-18	1
7754	454	260139	1961-08-01	1961-08-08	1
10303	609	4112343	1993-02-13	1993-02-26	1
39422	2339	40481087	2016-01-18	2016-02-01	1
83641	4975	372328	1961-05-12	1961-06-15	1
35331	2094	40481087	2018-11-30	2018-12-07	1
31670	1878	40481087	1996-07-30	1996-08-06	1
52450	3109	40481087	1955-04-26	1955-05-03	1
14257	842	40481087	1942-03-15	1942-03-22	1
72964	4340	372328	1976-04-04	1976-08-27	1
44198	2631	4266809	1992-10-19	1992-10-20	1
41775	2487	260139	1986-05-17	1986-05-24	1
39797	2358	4283893	1987-11-21	1988-01-23	1
29705	1760	4112343	1985-01-21	1985-01-28	1
30409	1794	4112343	1986-12-15	1986-12-24	1
43545	2596	4218389	1969-08-14	1969-09-04	1
51631	3065	4294548	1976-12-21	1977-03-29	1
7662	450	40481087	1978-11-16	1978-11-30	1
49315	2919	80180	1984-03-29	1984-03-30	1
4816	283	81151	2010-10-29	2010-11-12	1
77705	4608	260139	1977-07-04	1977-07-18	1
14132	836	372328	2010-09-04	2013-03-03	1
40207	2387	40481087	2006-09-03	2006-09-10	1
57466	3413	260139	1974-09-13	1974-09-20	1
36614	2168	4027663	1982-09-07	1982-09-08	1
7755	454	260139	1961-09-08	1961-09-22	1
10304	609	4266809	2001-04-22	2001-04-23	1
39423	2339	4112343	1982-08-01	1982-08-11	1
83642	4975	4112343	1992-11-13	1992-11-23	1
35998	2136	80180	2008-01-08	2008-01-09	1
31671	1878	28060	2013-07-12	2013-07-20	1
52451	3109	40481087	1969-01-24	1969-02-07	1
14258	842	81151	1992-02-02	1992-03-01	1
72965	4340	40481087	1973-09-22	1973-09-29	1
44199	2631	40481087	1973-12-20	1974-01-03	1
41776	2487	260139	1989-04-20	1989-05-04	1
39798	2358	40481087	1981-08-03	1981-08-17	1
29706	1760	4112343	2016-04-03	2016-04-10	1
30410	1794	4166224	1972-02-06	1972-02-07	1
43546	2596	40481087	2010-12-23	2011-01-06	1
51632	3065	40481087	1974-12-02	1974-12-23	1
7663	450	378001	2006-07-12	2006-08-11	1
49316	2919	4112343	1983-10-06	1983-10-14	1
4817	283	4237458	1998-04-21	1998-07-20	1
77706	4608	260139	2017-10-10	2017-10-24	1
14133	836	4112343	2008-01-16	2008-01-29	1
40208	2387	81893	2005-01-09	2005-01-10	1
57467	3413	4112343	1988-05-28	1988-06-06	1
36615	2168	4059173	1959-07-30	1959-09-28	1
7756	454	260139	1975-03-28	1975-04-11	1
10305	609	40481087	2005-09-11	2005-09-25	1
39424	2339	4112343	2006-10-06	2006-10-14	1
83643	4975	4112343	1993-08-21	1993-09-02	1
35999	2136	134438	2001-05-31	2002-01-29	1
31672	1878	81151	1976-02-08	1976-02-29	1
52452	3109	40481087	1973-08-22	1973-09-05	1
14259	842	257012	1926-04-18	1926-04-19	1
72966	4340	40481087	2001-11-17	2001-12-01	1
44200	2631	30753	1991-06-27	1991-06-28	1
41777	2487	4112343	1963-08-19	1963-08-28	1
39799	2358	4112343	1982-03-30	1982-04-07	1
29707	1760	4283893	2018-03-13	2018-06-19	1
30411	1794	40481087	1984-12-26	1985-01-02	1
43547	2596	40481087	2016-03-17	2016-03-31	1
51633	3065	40481087	1977-09-03	1977-09-24	1
7664	450	4001336	1968-05-04	1968-07-03	1
49317	2919	28060	2007-12-09	2007-12-20	1
4818	283	260139	1993-05-27	1993-06-10	1
77707	4608	372328	1967-12-08	1968-12-12	1
14134	836	4113008	1987-06-02	1987-06-23	1
40209	2387	375671	2003-09-06	2003-10-06	1
57468	3413	4112343	1999-12-20	1999-12-28	1
36616	2168	4218389	1964-11-10	1964-12-15	1
7757	454	260139	1999-02-06	1999-02-20	1
10306	609	260139	1991-02-01	1991-02-15	1
39425	2339	4112343	1986-02-24	1986-03-06	1
83644	4975	4283893	1968-08-16	1968-12-13	1
36000	2136	260139	1988-01-26	1988-02-02	1
31673	1878	260139	1990-03-27	1990-04-04	1
55070	3263	0	2007-09-11	2007-09-12	1
14260	842	260139	1988-05-10	1988-05-17	1
72967	4340	40481087	2009-11-10	2009-11-17	1
44201	2631	192671	1993-01-08	1993-01-09	1
41778	2487	260139	1965-06-24	1965-07-01	1
39800	2358	40481087	1980-09-24	1980-10-01	1
29708	1760	40481087	1985-08-30	1985-09-06	1
32082	1908	260139	1989-10-27	1989-11-03	1
46111	2750	0	2011-05-25	2011-05-26	1
51634	3065	40481087	1981-03-12	1981-03-26	1
7665	450	4112343	2004-07-22	2004-07-30	1
49318	2919	260139	1951-11-10	1951-11-17	1
4819	283	4051466	1984-09-07	1999-12-21	1
77708	4608	378001	1958-09-26	1958-10-26	1
14135	836	4218389	2008-03-04	2008-04-01	1
40210	2387	4112343	1990-12-30	1991-01-12	1
57469	3413	4237458	2007-04-22	2007-05-22	1
36617	2168	40481087	1976-03-31	1976-04-21	1
7758	454	4109685	1943-03-20	1943-04-03	1
10307	609	260139	2018-03-07	2018-03-15	1
39426	2339	4155034	2016-08-22	2016-09-05	1
83645	4975	40481087	1978-02-01	1978-02-08	1
36001	2136	372328	1971-07-16	1971-11-06	1
31674	1878	4112343	2011-09-07	2011-09-17	1
55071	3263	81893	1982-12-09	1982-12-10	1
14261	842	4001336	1946-09-14	1946-10-14	1
73847	4391	28060	1983-09-19	1983-09-30	1
44202	2631	260139	1991-10-20	1991-11-03	1
41779	2487	260139	2003-12-22	2004-01-05	1
39801	2358	40481087	2002-07-31	2002-08-21	1
29709	1760	372328	1978-06-14	1978-08-27	1
32083	1908	260139	2007-01-14	2007-01-21	1
46112	2750	28060	1928-12-03	1928-12-14	1
51635	3065	40481087	1990-04-09	1990-04-30	1
7666	450	4112343	2017-04-25	2017-05-05	1
49319	2919	260139	1981-01-14	1981-01-21	1
11837	701	28060	1962-05-11	1962-05-24	1
77709	4608	4035415	2008-08-23	2008-09-22	1
14136	836	80180	2016-11-07	2016-11-08	1
40211	2387	40481087	1988-10-25	1988-11-01	1
57470	3413	4278672	1975-08-08	1975-09-07	1
36618	2168	40481087	1987-08-20	1987-08-27	1
7759	454	4112343	1952-02-23	1952-03-06	1
10308	609	4112343	1983-03-24	1983-04-05	1
39427	2339	40481087	2010-12-17	2011-01-07	1
83646	4975	40481087	1983-10-15	1983-10-22	1
36002	2136	40481087	1972-07-15	1972-07-29	1
34795	2070	81151	1993-10-08	1993-10-29	1
55072	3263	260139	2004-06-13	2004-06-20	1
14262	842	40481087	1921-08-23	1921-08-30	1
73848	4391	80180	1978-06-18	1978-06-19	1
44203	2631	372328	1954-09-24	1954-10-17	1
41780	2487	80180	1992-08-09	1992-08-10	1
39802	2358	40481087	2004-11-17	2004-11-24	1
29710	1760	372328	1979-02-23	1979-05-27	1
32084	1908	372328	1974-09-26	1975-05-18	1
46113	2750	28060	2000-09-10	2000-09-19	1
51636	3065	260139	1987-10-01	1987-10-08	1
7667	450	4278672	1981-07-25	1981-09-23	1
49320	2919	317576	2017-12-16	2017-12-17	1
11838	701	257012	2012-01-12	2012-01-13	1
77710	4608	4109685	1964-02-27	1964-03-12	1
14137	836	260139	1983-06-11	1983-06-18	1
41861	2495	260139	2013-12-20	2013-12-27	1
57471	3413	40481087	1977-09-10	1977-10-01	1
36619	2168	40481087	1996-09-28	1996-10-05	1
7760	454	4112343	1980-11-08	1980-11-15	1
10309	609	40481087	1970-01-09	1970-01-23	1
39428	2339	40481087	2017-10-02	2017-10-09	1
83647	4975	80180	2004-01-14	2004-01-15	1
36003	2136	40481087	1983-08-10	1983-08-17	1
34796	2070	260139	2001-05-10	2001-05-24	1
55073	3263	4027663	1975-10-17	1975-10-18	1
14263	842	40481087	1969-03-12	1969-04-02	1
73849	4391	372328	1941-11-04	1942-01-16	1
44204	2631	372328	1955-07-14	1956-04-22	1
41781	2487	140673	2010-02-16	2010-02-17	1
39803	2358	4112343	2006-08-31	2006-09-09	1
29711	1760	4112343	1980-03-09	1980-03-17	1
32085	1908	4112343	1982-06-07	1982-06-17	1
46114	2750	260139	1956-01-05	1956-01-12	1
51637	3065	260139	1995-04-27	1995-05-04	1
7668	450	4294548	1989-05-13	1989-05-27	1
49321	2919	381316	1996-06-15	1996-06-16	1
11839	701	372328	1958-07-27	1958-11-08	1
77711	4608	4116491	1989-12-07	1990-01-19	1
14138	836	4112343	2010-02-21	2010-03-06	1
41862	2495	4112343	2010-10-06	2010-10-16	1
57472	3413	40481087	1979-08-28	1979-09-11	1
36620	2168	28060	1980-08-19	1980-08-28	1
7761	454	4116491	1954-02-25	1954-03-31	1
10310	609	40481087	1973-10-12	1973-10-26	1
39429	2339	40486433	1977-08-28	1993-07-13	1
83648	4975	81893	2002-10-21	2002-10-22	1
36004	2136	40481087	2017-06-28	2017-07-05	1
34797	2070	4048171	1969-11-01	1993-07-12	1
55074	3263	4112343	1987-08-25	1987-09-04	1
14264	842	40481087	1990-01-09	1990-01-16	1
73850	4391	4035415	2012-09-18	2012-10-18	1
44205	2631	4043241	2012-09-30	2012-10-01	1
41782	2487	260139	1980-11-17	1980-12-01	1
39804	2358	40481087	1999-01-02	1999-01-09	1
29712	1760	40481087	1981-03-08	1981-03-15	1
32086	1908	260139	1993-09-15	1993-09-22	1
46115	2750	4112343	1927-07-30	1927-08-10	1
51638	3065	4283893	2004-09-22	2004-11-17	1
7669	450	4310024	2002-01-25	2002-01-26	1
49322	2919	4112343	1975-08-25	1975-09-06	1
11840	701	372328	1959-05-07	1959-08-08	1
77712	4608	4134304	1992-06-20	1992-08-19	1
14139	836	378001	2017-08-12	2017-10-11	1
41863	2495	4283893	1992-06-22	1992-08-10	1
57473	3413	80180	2001-07-07	2001-07-08	1
36621	2168	260139	1967-01-20	1967-02-03	1
7762	454	4283893	1999-02-14	1999-07-18	1
10311	609	40481087	2010-01-08	2010-01-15	1
39430	2339	80180	2006-04-01	2006-04-02	1
83649	4975	4112343	1965-08-10	1965-08-18	1
36005	2136	260139	1983-12-11	1983-12-25	1
34798	2070	4059173	1988-02-07	1988-04-07	1
55075	3263	4112343	1995-11-25	1995-12-05	1
14265	842	40481087	2008-03-20	2008-04-03	1
73851	4391	40481087	1961-10-22	1961-10-29	1
44206	2631	4112343	1960-02-29	1960-03-12	1
41783	2487	260139	2007-12-27	2008-01-03	1
39805	2358	40481087	2011-04-27	2011-05-18	1
29713	1760	40481087	1986-06-10	1986-07-01	1
32087	1908	372328	1971-01-03	1971-02-14	1
46116	2750	4112343	1942-06-18	1942-06-29	1
51639	3065	40481087	1974-03-08	1974-03-29	1
7670	450	40481087	1974-02-08	1974-02-15	1
49323	2919	40481087	1987-12-25	1988-01-15	1
11841	701	40481087	1980-02-08	1980-02-15	1
77713	4608	4283893	1977-03-11	1977-05-06	1
14140	836	4283893	1988-11-09	1989-02-15	1
41864	2495	28060	2013-04-05	2013-04-14	1
57474	3413	4112343	1977-12-24	1978-01-04	1
36622	2168	4048171	1958-09-20	1958-09-21	1
7763	454	4296204	1981-08-11	1981-09-08	1
10312	609	80180	2001-04-22	2001-04-23	1
39431	2339	81151	1995-01-24	1995-02-14	1
83650	4975	4152936	2014-01-08	2014-01-22	1
36006	2136	4112343	1995-10-10	1995-10-18	1
34799	2070	40481087	1975-05-24	1975-06-07	1
55076	3263	40481087	1962-01-29	1962-02-12	1
18869	1136	0	1972-10-07	1972-10-08	1
73852	4391	81151	2011-10-10	2011-10-24	1
44207	2631	4112343	2005-08-27	2005-09-04	1
41784	2487	260139	2013-01-07	2013-01-14	1
41573	2476	80180	1994-01-12	1994-01-13	1
29714	1760	372328	1980-05-21	1980-09-14	1
32088	1908	372328	1980-01-03	1980-06-15	1
46117	2750	4112343	2007-11-28	2007-12-07	1
51640	3065	40481087	2009-05-02	2009-05-09	1
7671	450	40481087	1977-04-06	1977-04-20	1
49324	2919	40481087	2004-11-22	2004-11-29	1
11842	701	40481087	1999-11-11	1999-11-18	1
77714	4608	40479768	1987-10-08	1987-11-14	1
14141	836	40481087	1987-06-26	1987-07-10	1
41865	2495	260139	1985-05-08	1985-05-22	1
57475	3413	40481087	1985-03-08	1985-03-29	1
36623	2168	4112343	1973-07-17	1973-07-25	1
7764	454	40481087	1948-01-28	1948-02-11	1
10313	609	321042	2014-12-02	2014-12-03	1
39432	2339	4059173	1984-12-17	1985-01-16	1
83651	4975	4285898	2003-09-16	2003-09-17	1
36007	2136	4294548	1995-10-21	1995-11-04	1
34800	2070	40481087	1981-07-11	1981-07-18	1
55077	3263	40481087	2007-02-27	2007-03-06	1
18870	1136	81893	2011-05-30	2011-05-31	1
73853	4391	192671	1978-08-14	1978-08-15	1
44208	2631	4296205	1960-07-24	1960-08-21	1
41785	2487	4112343	1995-12-23	1996-01-05	1
41574	2476	81151	1958-09-23	1958-10-28	1
29715	1760	4035415	2006-01-23	2006-02-22	1
32089	1908	4112343	1998-09-22	1998-10-02	1
46118	2750	40481087	1972-01-13	1972-02-03	1
51641	3065	260139	1983-12-03	1983-12-10	1
7672	450	80180	2005-03-10	2005-03-11	1
49325	2919	4112343	1951-04-28	1951-05-09	1
11843	701	80180	1994-10-11	1994-10-12	1
77715	4608	40481087	2000-04-27	2000-05-11	1
14142	836	40481087	1997-02-11	1997-02-25	1
41866	2495	260139	1990-09-28	1990-10-12	1
57476	3413	40481087	2014-09-15	2014-10-06	1
36624	2168	4112343	1993-12-20	1993-12-28	1
7765	454	40481087	1965-10-22	1965-11-12	1
10314	609	4112343	1994-09-22	1994-10-03	1
39433	2339	4112343	1997-08-08	1997-08-21	1
83652	4975	260139	1977-08-04	1977-08-18	1
36008	2136	40481087	2002-03-07	2002-03-14	1
34801	2070	78272	2017-07-09	2017-08-13	1
55078	3263	30753	1983-11-04	1983-11-05	1
18871	1136	260139	1974-08-28	1974-09-11	1
73854	4391	378419	2015-06-26	2015-06-27	1
44209	2631	40481087	1988-06-09	1988-06-23	1
41786	2487	4112343	2000-11-27	2000-12-05	1
41575	2476	81151	1970-02-27	1970-03-20	1
31068	1843	260139	2014-04-03	2014-04-17	1
32090	1908	40481087	1994-05-02	1994-05-09	1
46119	2750	28060	1973-09-25	1973-10-03	1
51642	3065	372328	2018-05-18	2018-05-19	1
7673	450	81151	1983-08-14	1983-09-11	1
49326	2919	4112343	1956-10-10	1956-10-18	1
11844	701	260139	1970-12-22	1970-12-29	1
77716	4608	40481087	2008-09-25	2008-10-02	1
15801	936	192671	2002-05-22	2002-05-23	1
41867	2495	4134304	1987-06-26	1987-08-25	1
57477	3413	78272	2017-02-28	2017-03-14	1
36625	2168	4218389	1988-10-10	1988-10-31	1
7766	454	40481087	1971-08-07	1971-08-21	1
10315	609	4294548	1987-07-22	1987-09-09	1
39434	2339	4294548	1988-02-24	1988-03-09	1
83653	4975	260139	2001-11-25	2001-12-02	1
36009	2136	195588	2013-05-21	2013-07-04	1
34802	2070	80180	2008-07-02	2008-07-03	1
55079	3263	81151	2011-06-03	2011-06-24	1
18872	1136	260139	1995-05-26	1995-06-09	1
73855	4391	4048171	1945-02-13	1960-02-12	1
44210	2631	40481087	2015-10-06	2015-10-13	1
41787	2487	40481087	1997-05-08	1997-05-29	1
41576	2476	260139	1971-04-08	1971-04-22	1
31069	1843	4112343	1986-05-28	1986-06-07	1
32091	1908	40481087	2005-04-20	2005-05-04	1
46120	2750	80180	1963-01-23	1963-01-24	1
51643	3065	375671	2017-10-19	2017-12-18	1
7674	450	81151	2015-03-27	2015-04-10	1
49327	2919	4112343	1976-10-01	1976-10-10	1
11845	701	4112343	1964-04-17	1964-04-26	1
77717	4608	258780	1989-01-26	1989-01-27	1
15802	936	260139	1991-08-19	1991-08-26	1
41868	2495	80180	2015-04-10	2015-04-11	1
57478	3413	40481087	1982-06-23	1982-07-14	1
36626	2168	40481087	2003-08-05	2003-08-19	1
7767	454	40481087	1972-06-24	1972-07-01	1
10316	609	40481087	1974-10-28	1974-11-18	1
40218	2389	30753	2007-12-13	2007-12-14	1
83654	4975	4027663	1993-06-30	1993-07-01	1
36010	2136	372328	1974-01-24	1974-05-18	1
34803	2070	260139	1980-09-04	1980-09-18	1
55080	3263	192671	1985-04-21	1985-04-22	1
18873	1136	260139	2001-08-21	2001-08-28	1
73856	4391	4109685	1952-11-06	1952-11-20	1
44211	2631	260139	1963-04-12	1963-04-19	1
41884	2497	260139	1964-01-20	1964-01-27	1
41577	2476	4112343	1981-12-06	1981-12-16	1
31070	1843	4112343	1994-08-12	1994-08-20	1
32092	1908	40481087	2010-03-18	2010-04-01	1
46121	2750	260139	1935-03-18	1935-03-25	1
51644	3065	4112343	1977-11-13	1977-11-26	1
7675	450	81893	2002-12-21	2002-12-22	1
49328	2919	4230399	2018-03-21	2018-05-20	1
11846	701	4112343	1997-12-14	1997-12-27	1
77718	4608	260139	1956-04-11	1956-04-25	1
15803	936	260139	1992-03-12	1992-03-19	1
41869	2495	81151	1992-09-27	1992-10-11	1
57479	3413	40481087	2006-10-27	2006-11-17	1
38242	2274	78272	2008-07-18	2008-08-01	1
7768	454	40481087	1987-04-20	1987-05-11	1
11048	653	260139	1975-01-21	1975-01-28	1
40219	2389	81151	1974-01-05	1974-01-26	1
83655	4975	4112343	1990-07-15	1990-07-23	1
37510	2228	4112343	2000-03-01	2000-03-12	1
34804	2070	4112343	1986-10-17	1986-10-24	1
55081	3263	378001	1949-07-30	1949-09-28	1
18874	1136	4112343	1980-12-24	1980-12-31	1
73857	4391	28060	1953-11-03	1953-11-10	1
44212	2631	4112343	1962-02-02	1962-02-13	1
41885	2497	372328	1963-03-24	1963-08-08	1
41578	2476	4112343	1982-10-13	1982-10-21	1
31071	1843	4155034	1984-08-03	1984-08-17	1
32093	1908	81151	1987-04-09	1987-04-23	1
46122	2750	260139	2003-01-24	2003-01-31	1
51645	3065	40481087	1985-04-12	1985-04-26	1
7676	450	4112343	2003-03-16	2003-03-25	1
49329	2919	40481087	1952-02-14	1952-02-28	1
11847	701	4112343	1999-10-21	1999-11-02	1
77719	4608	260139	1992-05-15	1992-05-22	1
15804	936	372328	1965-11-01	1966-10-14	1
41870	2495	4112343	1987-05-30	1987-06-08	1
59156	3513	372328	1976-07-26	1976-10-24	1
38243	2274	260139	2003-11-05	2003-11-19	1
9067	534	372328	1983-09-09	1984-06-05	1
11049	653	4112343	1960-07-07	1960-07-20	1
40220	2389	81151	1992-12-31	1993-01-28	1
83656	4975	4218389	1999-11-25	1999-12-23	1
37511	2228	40481087	1964-09-21	1964-09-28	1
34805	2070	4146173	2014-08-24	2014-09-23	1
55082	3263	4112343	1947-09-10	1947-09-21	1
18875	1136	4112343	1993-03-08	1993-03-21	1
73858	4391	30753	1977-09-21	1977-09-22	1
44213	2631	40481087	1983-08-23	1983-08-30	1
41886	2497	378001	1962-09-25	1962-10-25	1
41579	2476	40481087	1974-07-06	1974-07-20	1
31072	1843	4237458	1997-03-17	1997-05-16	1
32094	1908	260139	2014-06-15	2014-06-29	1
46123	2750	317576	2007-09-26	2007-09-27	1
51646	3065	80180	2014-05-26	2014-05-27	1
7677	450	30753	2003-11-16	2003-11-17	1
49330	2919	40481087	2012-09-19	2012-09-26	1
11848	701	4116491	1990-08-23	1990-09-25	1
77720	4608	4001336	2004-01-19	2004-03-19	1
15805	936	4285898	2001-10-08	2001-10-09	1
41871	2495	40481087	1990-11-16	1990-11-23	1
59157	3513	4027663	2000-03-12	2000-03-13	1
38244	2274	4112343	1983-03-10	1983-03-18	1
9068	534	4112343	1993-10-31	1993-11-06	1
11050	653	4112343	1962-04-13	1962-04-21	1
40221	2389	260139	1990-11-08	1990-11-22	1
83657	4975	4296205	1965-03-09	1965-03-30	1
37512	2228	40481087	1999-07-23	1999-08-13	1
34806	2070	40481087	1965-03-02	1965-03-16	1
55083	3263	4112343	1968-08-05	1968-08-18	1
18876	1136	4112343	2014-04-13	2014-04-22	1
73859	4391	81151	1987-02-20	1987-03-20	1
44214	2631	40481087	2010-09-05	2010-09-26	1
41887	2497	4109685	1969-07-20	1969-08-10	1
41580	2476	4112343	1976-05-25	1976-06-02	1
31073	1843	40481087	2002-12-08	2002-12-15	1
32095	1908	4112343	2008-08-13	2008-08-20	1
46124	2750	321042	2011-05-25	2011-05-26	1
51647	3065	257012	1977-01-18	1977-01-19	1
7678	450	372328	1970-06-23	1970-09-14	1
49331	2919	260139	2007-11-03	2007-11-10	1
11849	701	4283893	2011-11-24	2012-02-09	1
77721	4608	4112343	1981-03-01	1981-03-11	1
15806	936	40481087	1992-12-07	1992-12-21	1
41872	2495	40481087	1997-03-23	1997-04-06	1
59158	3513	4112343	1974-01-10	1974-01-17	1
38245	2274	4113008	1976-02-02	1976-02-16	1
9069	534	4112343	2005-11-04	2005-11-12	1
11051	653	4112343	1988-02-29	1988-03-08	1
40222	2389	4112343	1979-06-10	1979-06-22	1
83658	4975	4310024	2002-03-25	2002-03-26	1
37513	2228	40481087	2001-08-10	2001-08-24	1
34807	2070	40481087	2014-10-31	2014-11-14	1
55084	3263	4112343	2009-07-09	2009-07-17	1
18877	1136	378001	1997-11-24	1997-12-24	1
73860	4391	4237458	2016-11-26	2017-02-24	1
44215	2631	40481087	2015-03-11	2015-04-01	1
41888	2497	0	2008-02-28	2008-02-29	1
41581	2476	4152936	1978-08-05	1978-08-19	1
31074	1843	81151	1985-06-13	1985-06-27	1
32096	1908	4142905	2018-03-11	2018-05-10	1
46125	2750	372328	2001-03-29	2001-09-26	1
51648	3065	260139	1989-09-23	1989-09-30	1
10926	648	192671	1971-09-24	1971-09-25	1
49332	2919	261325	2006-09-30	2006-10-01	1
11850	701	4112343	1968-02-07	1968-02-18	1
77722	4608	4112343	1999-02-08	1999-02-16	1
15807	936	30753	2000-12-12	2000-12-13	1
41873	2495	40481087	2002-02-18	2002-03-04	1
59159	3513	4112343	1985-12-04	1985-12-12	1
38246	2274	40481087	1959-04-11	1959-05-02	1
9070	534	40481087	1979-05-13	1979-06-03	1
11052	653	4112343	1998-06-26	1998-07-08	1
40223	2389	4156265	1992-02-21	1992-03-06	1
83659	4975	40481087	1985-04-22	1985-05-06	1
37514	2228	40481087	2016-11-29	2016-12-13	1
34808	2070	192671	2008-08-15	2008-08-16	1
55085	3263	4310024	1982-04-13	1982-04-14	1
18878	1136	4027663	2004-05-06	2004-05-07	1
73861	4391	40481087	1954-08-06	1954-08-27	1
44216	2631	80180	1992-10-19	1992-10-20	1
41889	2497	78272	1990-04-22	1990-05-13	1
41582	2476	40481087	2013-08-07	2013-08-21	1
31075	1843	260139	2012-06-04	2012-06-11	1
32097	1908	40481087	1987-04-18	1987-05-02	1
46126	2750	378001	1974-10-01	1974-11-30	1
51649	3065	260139	1992-09-29	1992-10-13	1
10927	648	260139	1944-03-16	1944-03-30	1
49333	2919	440448	1965-08-17	1965-08-18	1
11851	701	4113008	2015-05-04	2015-05-25	1
77723	4608	40481087	2003-05-04	2003-05-18	1
15808	936	260139	2013-11-15	2013-11-22	1
48865	2896	260139	2013-07-27	2013-08-03	1
59160	3513	4113008	2016-07-08	2016-07-29	1
38247	2274	40481087	1996-06-22	1996-07-06	1
9071	534	40481087	1986-12-12	1986-12-26	1
11053	653	4112343	2008-12-15	2008-12-22	1
40224	2389	40481087	1981-01-06	1981-01-13	1
37515	2228	40481087	2017-09-30	2017-10-21	1
34809	2070	4027663	1996-10-18	1996-10-19	1
55086	3263	40481087	1973-05-28	1973-06-04	1
18879	1136	4112343	1989-11-15	1989-11-23	1
73862	4391	40481087	1991-03-05	1991-03-12	1
44217	2631	4027663	1981-05-05	1981-05-06	1
41890	2497	260139	1983-09-24	1983-10-08	1
41583	2476	4112343	2012-03-21	2012-03-31	1
31076	1843	40481087	1983-11-13	1983-11-20	1
32098	1908	80180	2002-12-16	2002-12-17	1
46127	2750	378419	2008-03-05	2008-03-06	1
51650	3065	372328	1974-10-28	1974-12-05	1
10928	648	260139	1980-04-13	1980-04-27	1
49334	2919	4112343	1949-11-20	1949-12-02	1
11852	701	40481087	1983-06-08	1983-06-22	1
77724	4608	40481087	2015-11-19	2015-12-03	1
15809	936	4112343	1992-03-16	1992-03-29	1
48866	2896	4112343	1984-01-05	1984-01-15	1
59161	3513	4142905	1979-08-10	1979-10-09	1
38248	2274	40481087	2006-10-17	2006-11-07	1
9072	534	195588	1996-06-15	1996-07-28	1
11054	653	4299128	1965-12-23	1966-01-13	1
40225	2389	257012	1986-10-06	1986-10-07	1
37516	2228	78272	2010-04-20	2010-05-18	1
34810	2070	4112343	2016-08-02	2016-08-10	1
55087	3263	40481087	1978-09-12	1978-10-03	1
18880	1136	4112343	2001-10-18	2001-10-31	1
73863	4391	28060	1955-07-06	1955-07-16	1
44218	2631	40481087	1968-12-18	1969-01-08	1
41891	2497	4112343	2000-11-20	2000-12-02	1
41584	2476	40481087	1985-05-29	1985-06-12	1
31077	1843	40481087	1992-11-02	1992-11-09	1
32099	1908	372328	1975-08-16	1976-05-23	1
46128	2750	4109685	1949-05-01	1949-05-15	1
51651	3065	4112343	2001-10-05	2001-10-17	1
10929	648	260139	1991-12-20	1992-01-03	1
49335	2919	4112343	1959-06-07	1959-06-19	1
11853	701	40481087	1994-06-02	1994-06-16	1
77725	4608	40481087	2018-08-26	2018-09-09	1
15810	936	80180	2002-05-06	2002-05-07	1
48867	2896	40481087	1974-08-31	1974-09-14	1
59162	3513	4156265	1985-02-09	1985-02-23	1
38249	2274	40481087	2018-06-17	2018-06-24	1
9073	534	257012	1997-12-20	1997-12-21	1
11055	653	40481087	1987-10-07	1987-10-21	1
40226	2389	378001	1994-01-23	1994-03-24	1
37517	2228	80502	2007-04-21	2007-04-22	1
34811	2070	4112343	2018-02-04	2018-02-11	1
55088	3263	80180	1985-01-27	1985-01-28	1
18881	1136	80180	2013-01-19	2013-01-20	1
73864	4391	260139	1947-12-04	1947-12-18	1
45807	2731	81151	1986-03-21	1986-04-11	1
41892	2497	4112343	2001-04-04	2001-04-13	1
41585	2476	40481087	1989-10-27	1989-11-03	1
31078	1843	80180	2016-10-29	2016-10-30	1
32100	1908	4142905	1998-02-24	1998-05-25	1
46129	2750	4112343	1959-07-16	1959-07-25	1
51652	3065	40479422	1982-05-19	1982-06-25	1
10930	648	260139	1994-11-05	1994-11-12	1
49336	2919	4112343	1969-03-02	1969-03-12	1
11854	701	4296204	2008-06-04	2008-07-09	1
77726	4608	4084167	1967-02-11	1967-02-11	1
15811	936	4113008	1988-03-03	1988-03-17	1
48868	2896	40481087	1981-04-16	1981-04-30	1
59163	3513	4266809	2007-12-01	2007-12-02	1
38250	2274	78272	1960-08-21	1960-09-25	1
9074	534	372328	1980-02-09	1980-05-27	1
11056	653	40481087	1989-01-18	1989-02-08	1
40227	2389	4112343	2013-12-03	2013-12-16	1
37518	2228	28060	1950-12-01	1950-12-09	1
34812	2070	40481087	1969-07-02	1969-07-16	1
55089	3263	257012	1967-09-24	1967-09-25	1
18882	1136	260139	2003-05-22	2003-06-05	1
73865	4391	4027663	1969-01-31	1969-02-01	1
45808	2731	81151	2001-07-19	2001-08-09	1
41893	2497	4310024	2004-06-16	2004-06-17	1
41586	2476	260139	1966-07-15	1966-07-29	1
31079	1843	81151	1992-04-21	1992-05-12	1
32101	1908	40481087	2017-05-29	2017-06-05	1
46130	2750	4112343	2007-09-17	2007-09-28	1
52616	3119	78272	2012-06-16	2012-07-07	1
10931	648	260139	2005-08-27	2005-09-10	1
49337	2919	4112343	1975-04-13	1975-04-23	1
11855	701	40481087	1968-09-11	1968-10-02	1
77727	4608	4112343	1976-06-11	1976-06-23	1
15812	936	4296204	1971-10-01	1971-10-29	1
48869	2896	40486433	1974-03-29	1988-03-27	1
59164	3513	81151	2007-02-12	2007-02-26	1
38251	2274	80180	1987-06-11	1987-06-12	1
9075	534	440086	1988-06-17	1993-07-02	1
11057	653	40481087	2015-12-21	2016-01-11	1
40228	2389	4230399	1975-12-17	1976-01-16	1
37519	2228	80180	1984-08-26	1984-08-27	1
34813	2070	78272	1978-05-16	1978-05-30	1
55090	3263	321042	2007-09-11	2007-09-12	1
18883	1136	260139	2014-07-08	2014-07-22	1
73866	4391	4112343	2013-10-23	2013-11-03	1
45809	2731	195588	2008-06-29	2008-08-05	1
41894	2497	40481087	1963-08-30	1963-09-06	1
41587	2476	260139	2010-06-30	2010-07-07	1
31080	1843	4112343	2002-08-25	2002-09-06	1
34152	2030	4112343	1975-08-01	1975-08-09	1
46131	2750	40481087	1925-07-13	1925-07-27	1
52617	3119	260139	2000-02-02	2000-02-16	1
10932	648	381316	2015-09-25	2015-09-26	1
49338	2919	40481087	1958-12-29	1959-01-19	1
11856	701	40481087	1998-01-04	1998-01-11	1
77728	4608	4112343	2017-10-10	2017-10-23	1
15813	936	40481087	1971-10-09	1971-10-23	1
48870	2896	192671	2002-05-25	2002-05-26	1
59165	3513	195588	2008-03-10	2008-04-23	1
38252	2274	260139	1958-06-29	1958-07-06	1
9076	534	80180	2014-10-29	2014-10-30	1
11058	653	4109685	1971-09-14	1971-10-05	1
40229	2389	4294548	1986-09-22	1987-02-09	1
37520	2228	260139	2001-02-26	2001-03-12	1
34814	2070	260139	2005-09-02	2005-09-09	1
55091	3263	378001	1995-09-11	1995-10-11	1
18884	1136	321042	1972-10-07	1972-10-08	1
73867	4391	4142905	1945-12-13	1946-03-13	1
45810	2731	260139	1990-07-01	1990-07-15	1
41895	2497	40481087	2017-08-15	2017-08-22	1
41588	2476	40481087	2000-01-18	2000-02-08	1
31081	1843	40481087	1997-12-18	1997-12-25	1
34153	2030	4112343	1987-12-20	1987-12-31	1
46132	2750	40481087	1989-01-13	1989-02-03	1
52618	3119	372328	1992-12-03	1993-08-16	1
10933	648	4112343	1976-05-02	1976-05-12	1
49339	2919	40481087	2010-11-06	2010-11-20	1
12060	715	40481087	1984-06-17	1984-07-08	1
77729	4608	40481087	1971-05-29	1971-06-05	1
15814	936	40481087	2000-03-21	2000-04-04	1
48871	2896	260139	1985-06-29	1985-07-06	1
59166	3513	260139	1974-04-10	1974-04-17	1
38253	2274	4112343	2004-08-10	2004-08-22	1
9077	534	4283893	1997-11-01	1998-02-14	1
11059	653	4112343	1979-06-21	1979-07-02	1
40230	2389	40481087	1971-03-28	1971-04-04	1
37521	2228	375671	1975-01-10	1975-03-11	1
34815	2070	372328	1968-02-08	1968-04-01	1
55092	3263	4112343	1999-05-21	1999-06-01	1
18885	1136	4112343	1999-09-19	1999-09-26	1
73868	4391	40481087	1957-08-18	1957-09-08	1
45811	2731	372328	1966-02-24	1966-06-27	1
41896	2497	260139	1971-06-20	1971-06-27	1
42287	2522	30753	1990-11-25	1990-11-26	1
31082	1843	28060	1993-10-02	1993-10-15	1
34154	2030	4112343	2010-08-05	2010-08-16	1
46133	2750	260139	1997-02-03	1997-02-17	1
52619	3119	4109685	1997-09-12	1997-10-03	1
10934	648	4278672	1954-10-22	1954-11-21	1
49947	2955	28060	1974-08-27	1974-09-09	1
12061	715	40481087	1987-10-28	1987-11-11	1
77730	4608	40481087	2009-02-08	2009-02-15	1
15815	936	81151	2008-10-28	2008-11-25	1
48872	2896	81151	1972-11-02	1972-11-30	1
59167	3513	4155034	1992-12-13	1992-12-27	1
38254	2274	4113008	1975-03-25	1975-04-08	1
9078	534	40481087	1978-08-27	1978-09-10	1
11060	653	4112343	1983-01-16	1983-01-23	1
40231	2389	40481087	2017-02-09	2017-02-23	1
37522	2228	4109685	2016-01-17	2016-02-07	1
34816	2070	4112343	1980-03-10	1980-03-19	1
55093	3263	40481087	1955-07-06	1955-07-27	1
18886	1136	30753	2012-03-25	2012-03-26	1
74543	4433	4027663	1973-03-09	1973-03-10	1
45812	2731	4112343	1999-02-17	1999-02-28	1
41897	2497	260139	1988-08-23	1988-08-30	1
42288	2522	260139	1970-06-23	1970-06-30	1
31083	1843	260139	1983-01-13	1983-01-27	1
34155	2030	4134304	1967-01-26	1967-02-25	1
46134	2750	4109685	1980-07-31	1980-08-14	1
52620	3119	4152936	1996-11-01	1996-11-15	1
10935	648	4278672	2000-02-03	2000-03-04	1
49948	2955	28060	2012-07-10	2012-07-19	1
12062	715	40481087	2006-04-28	2006-05-19	1
77731	4608	257012	1977-04-29	1977-04-30	1
15816	936	260139	2010-09-23	2010-09-30	1
48873	2896	260139	1987-05-23	1987-05-30	1
59168	3513	40481087	1975-05-11	1975-06-01	1
38255	2274	4156265	1997-11-22	1997-12-13	1
9079	534	40481087	1980-10-03	1980-10-10	1
11061	653	4112343	2002-10-01	2002-10-14	1
40232	2389	80180	2008-08-09	2008-08-10	1
37523	2228	4112343	1969-06-04	1969-06-11	1
34817	2070	4112343	1988-03-20	1988-03-30	1
55094	3263	28060	1985-04-23	1985-05-03	1
18887	1136	440086	1985-05-11	1985-10-12	1
74544	4433	4112343	2019-03-19	2019-03-31	1
45813	2731	4278672	1970-12-16	1971-01-15	1
41898	2497	313217	2017-08-17	2017-08-18	1
42289	2522	4112343	1979-11-01	1979-11-11	1
31084	1843	260139	1989-06-26	1989-07-03	1
34156	2030	4218389	1970-12-06	1971-01-10	1
46135	2750	4112343	1940-02-16	1940-02-26	1
52621	3119	40481087	1999-06-23	1999-06-30	1
10936	648	4310024	1969-09-03	1969-09-04	1
49949	2955	260139	1983-05-02	1983-05-09	1
12063	715	40481087	2009-03-11	2009-03-25	1
77732	4608	260139	1962-11-18	1962-11-25	1
15817	936	4027663	1992-10-20	1992-10-21	1
48874	2896	372328	1970-10-14	1971-02-28	1
59169	3513	40481087	1998-03-22	1998-04-05	1
38256	2274	40481087	1955-06-15	1955-06-22	1
9080	534	40481087	1982-04-10	1982-05-02	1
11062	653	80180	1990-05-11	1990-05-12	1
40233	2389	81893	2007-05-17	2007-05-18	1
37524	2228	4112343	1980-05-15	1980-05-28	1
34818	2070	4152936	2001-07-19	2001-08-02	1
55095	3263	260139	2011-02-15	2011-02-22	1
18888	1136	4112343	2009-02-22	2009-03-07	1
74545	4433	40481087	1941-06-14	1941-06-21	1
45814	2731	40481087	2014-07-24	2014-07-31	1
41899	2497	372328	1967-08-17	1968-08-15	1
42290	2522	4112343	1986-10-09	1986-10-20	1
31085	1843	4112343	2000-08-22	2000-09-03	1
34157	2030	40481087	2002-12-16	2002-12-23	1
46136	2750	4112343	1971-09-21	1971-10-02	1
52622	3119	40481087	2012-10-09	2012-10-30	1
10937	648	260139	1936-10-27	1936-11-10	1
49950	2955	260139	2015-05-19	2015-06-02	1
12064	715	260139	1992-11-26	1992-12-10	1
77733	4608	4112343	1967-10-13	1967-10-25	1
17203	1032	80180	1989-05-22	1989-05-23	1
48875	2896	4109685	1999-09-24	1999-10-15	1
59170	3513	192671	2008-01-02	2008-01-03	1
38257	2274	40481087	1970-09-06	1970-09-13	1
9081	534	40481087	1987-12-26	1988-01-16	1
11063	653	260139	1971-11-23	1971-12-07	1
40234	2389	260139	1996-06-11	1996-06-18	1
37525	2228	4112343	1980-09-27	1980-10-10	1
38674	2298	80180	2006-01-03	2006-01-04	1
55096	3263	378001	1966-07-15	1966-09-13	1
18889	1136	4230399	2013-02-03	2013-05-04	1
74546	4433	40481087	1982-03-21	1982-04-04	1
45815	2731	260139	1973-05-25	1973-06-01	1
41900	2497	4027663	1995-08-23	1995-08-24	1
42291	2522	4237458	2000-07-24	2000-09-22	1
31086	1843	40481087	1985-08-18	1985-09-01	1
34158	2030	28060	1968-11-20	1968-12-01	1
46137	2750	4112343	1978-11-07	1978-11-20	1
52623	3119	260139	2008-06-27	2008-07-04	1
10938	648	260139	1966-07-29	1966-08-12	1
49951	2955	321042	2017-07-25	2017-07-26	1
12065	715	4152936	2008-06-17	2008-07-01	1
77734	4608	4134304	2010-07-14	2010-10-12	1
17204	1032	260139	1985-08-09	1985-08-23	1
48876	2896	4134304	2014-10-26	2014-12-25	1
59171	3513	260139	1991-02-18	1991-02-25	1
38258	2274	40481087	2010-06-24	2010-07-08	1
9082	534	40481087	1999-09-16	1999-09-30	1
11064	653	375671	2015-10-14	2015-11-13	1
40235	2389	4027663	1999-03-25	1999-03-26	1
37526	2228	4296204	1987-07-06	1987-07-20	1
38675	2298	81151	1982-11-09	1982-12-14	1
55097	3263	4059173	2018-01-18	2018-02-17	1
18890	1136	4237458	1984-11-02	1985-01-31	1
74547	4433	192671	1982-08-13	1982-08-14	1
45816	2731	378001	1991-03-14	1991-05-13	1
41901	2497	4112343	1968-07-27	1968-08-09	1
42292	2522	4266809	1991-01-24	1991-01-25	1
31087	1843	40481087	2005-07-11	2005-07-25	1
34159	2030	80180	1997-11-04	1997-11-05	1
46138	2750	40481087	1962-05-22	1962-05-29	1
52624	3119	4027663	2005-06-09	2005-06-10	1
10939	648	260139	2014-09-30	2014-10-07	1
49952	2955	4112343	1995-05-13	1995-05-24	1
12066	715	40481087	2000-11-10	2000-11-17	1
77735	4608	4299128	2006-12-04	2007-01-01	1
17205	1032	440086	1958-10-12	1969-10-19	1
48877	2896	4218389	2016-01-19	2016-02-09	1
59172	3513	4112343	2010-08-20	2010-09-01	1
38259	2274	28060	1954-10-25	1954-11-06	1
10278	608	81151	2004-10-21	2004-11-04	1
11065	653	4112343	1978-03-13	1978-03-24	1
40236	2389	4112343	2007-10-25	2007-11-04	1
37527	2228	4296205	1952-12-17	1953-01-07	1
38676	2298	372328	1972-02-21	1972-04-06	1
55098	3263	4109685	1962-04-23	1962-05-07	1
18891	1136	4278672	2007-06-05	2007-08-04	1
74548	4433	260139	1993-07-04	1993-07-11	1
45817	2731	4112343	2000-09-24	2000-10-05	1
41902	2497	4152936	2012-06-16	2012-07-07	1
42293	2522	4294548	2014-08-09	2014-08-23	1
31088	1843	40481087	2013-04-23	2013-05-14	1
34160	2030	134438	1983-04-24	1984-04-18	1
46139	2750	40481087	1996-10-31	1996-11-07	1
52625	3119	40481087	1981-08-14	1981-08-21	1
10940	648	372328	1933-06-14	1933-08-25	1
49953	2955	4112343	1997-12-13	1997-12-24	1
12067	715	28060	1997-10-11	1997-10-23	1
77736	4608	40481087	1977-07-13	1977-07-27	1
17206	1032	4112343	1982-12-16	1982-12-23	1
48878	2896	40481087	1987-10-02	1987-10-09	1
59173	3513	80180	2007-12-01	2007-12-02	1
38260	2274	28060	1983-12-14	1983-12-26	1
10279	608	372328	1978-11-08	1978-11-29	1
11066	653	4112343	1989-10-30	1989-11-06	1
40237	2389	40481087	1977-12-07	1977-12-14	1
37528	2228	40481087	1996-01-21	1996-02-04	1
38677	2298	4027663	1995-10-23	1995-10-24	1
55099	3263	4156265	2002-11-03	2002-11-17	1
18892	1136	4285898	2012-09-21	2012-09-22	1
74549	4433	372328	1943-07-25	1944-02-26	1
45818	2731	4112343	2017-01-12	2017-01-23	1
41903	2497	40481087	1983-11-28	1983-12-12	1
42294	2522	40481087	1973-08-02	1973-08-09	1
31448	1861	28060	1990-07-01	1990-07-10	1
34161	2030	260139	2014-03-27	2014-04-10	1
46140	2750	80502	1993-08-11	1993-08-12	1
52626	3119	372328	1978-02-25	1978-05-22	1
10941	648	4059173	2007-07-26	2007-10-24	1
49954	2955	4112343	2003-04-30	2003-05-10	1
12068	715	80180	2017-06-26	2017-06-27	1
77737	4608	40481087	1981-10-12	1981-10-26	1
17207	1032	4112343	1987-10-31	1987-11-07	1
48879	2896	40481087	2001-10-01	2001-10-22	1
59174	3513	195588	2010-04-23	2010-06-08	1
38261	2274	257012	2013-05-22	2013-05-23	1
10280	608	440086	1981-12-17	1982-07-15	1
11067	653	40481087	1989-11-13	1989-12-04	1
40238	2389	40481087	2017-08-27	2017-09-03	1
37529	2228	40481087	2012-01-25	2012-02-01	1
38678	2298	4113008	1973-04-16	1973-04-30	1
55100	3263	4294548	1967-07-23	1967-11-19	1
18893	1136	40481087	2001-08-11	2001-08-25	1
74550	4433	4112343	1950-03-23	1950-04-05	1
45819	2731	4152936	1972-09-06	1972-09-27	1
41904	2497	40481087	2008-01-14	2008-02-04	1
42295	2522	260139	1959-05-08	1959-05-15	1
31449	1861	378001	1990-09-17	1990-11-16	1
34162	2030	4112343	1989-11-24	1989-12-04	1
46141	2750	260139	1983-01-21	1983-02-04	1
52627	3119	4059173	1985-07-03	1985-09-01	1
10942	648	4112343	1942-09-12	1942-09-23	1
49955	2955	4112343	2016-03-31	2016-04-08	1
12069	715	372328	1986-06-29	1986-07-22	1
81555	4844	81151	2011-11-09	2011-11-30	1
17208	1032	4294548	1975-08-19	1975-08-26	1
48880	2896	80180	2002-03-05	2002-03-06	1
59175	3513	4112343	1979-04-24	1979-05-06	1
38262	2274	260139	1954-01-26	1954-02-09	1
10281	608	0	2005-07-13	2005-07-14	1
11068	653	40481087	2008-11-30	2008-12-21	1
43436	2591	260139	1951-04-29	1951-05-13	1
37530	2228	40481087	2014-02-27	2014-03-20	1
38679	2298	4266809	2006-01-03	2006-01-04	1
55101	3263	40481087	1997-04-02	1997-04-16	1
18894	1136	40481087	2007-12-30	2008-01-20	1
74551	4433	4112343	1951-01-01	1951-01-13	1
45820	2731	4155034	1984-06-08	1984-06-29	1
41905	2497	40481087	2011-04-27	2011-05-11	1
42296	2522	4112343	1959-11-05	1959-11-15	1
31450	1861	4156265	2000-02-02	2000-02-23	1
34163	2030	40481087	1982-06-29	1982-07-13	1
46142	2750	4059173	1926-10-29	1927-01-27	1
52628	3119	4156265	1982-01-05	1982-01-19	1
10943	648	4112343	1949-11-02	1949-11-10	1
49956	2955	4156265	2002-11-08	2002-11-22	1
12070	715	40481087	1991-07-31	1991-08-21	1
81556	4844	260139	1970-05-30	1970-06-13	1
17209	1032	40481087	2014-06-19	2014-07-03	1
48881	2896	260139	2017-09-29	2017-10-13	1
59176	3513	4112343	2002-10-17	2002-10-28	1
38263	2274	260139	1967-09-19	1967-10-03	1
10282	608	80180	2012-11-29	2012-11-30	1
11069	653	372328	1954-12-21	1955-01-04	1
43437	2591	372328	1981-11-02	1982-06-23	1
37531	2228	40481087	2015-02-22	2015-03-15	1
38680	2298	260139	1978-02-21	1978-03-07	1
55102	3263	40481087	1999-12-07	1999-12-28	1
19651	1180	81151	1968-01-09	1968-02-06	1
74552	4433	4266809	1982-06-25	1982-06-26	1
45821	2731	40481087	1966-01-20	1966-02-03	1
41906	2497	80180	2006-06-06	2006-06-07	1
42297	2522	4112343	2017-10-08	2017-10-18	1
31451	1861	40481087	1993-08-30	1993-09-20	1
34164	2030	260139	1990-06-22	1990-06-29	1
46143	2750	4112343	1943-12-24	1944-01-04	1
52629	3119	4310024	2013-09-05	2013-09-06	1
10944	648	4294548	1933-03-24	1933-04-21	1
49957	2955	40481087	2017-12-10	2017-12-24	1
12071	715	40481087	1999-08-18	1999-09-08	1
81557	4844	260139	1993-10-19	1993-10-26	1
17210	1032	260139	2010-08-28	2010-09-11	1
48882	2896	4156265	1989-02-04	1989-02-18	1
59177	3513	40481087	1985-10-12	1985-10-19	1
38264	2274	4112343	2009-07-31	2009-08-13	1
10283	608	260139	2004-03-27	2004-04-03	1
11070	653	372328	1957-09-20	1958-01-10	1
43438	2591	4112343	1977-09-28	1977-10-09	1
37532	2228	40481087	2015-11-16	2015-11-30	1
38681	2298	260139	1982-03-11	1982-03-18	1
55103	3263	40481087	2005-08-07	2005-08-28	1
19652	1180	260139	1977-07-31	1977-08-07	1
74553	4433	4294548	1991-01-10	1991-02-14	1
45822	2731	0	2007-07-09	2007-07-10	1
41907	2497	81893	2004-09-14	2004-09-15	1
42298	2522	4285898	1990-12-25	1990-12-26	1
31452	1861	78272	2004-02-02	2004-02-16	1
34165	2030	260139	1995-01-05	1995-01-12	1
46144	2750	4112343	1999-02-05	1999-02-17	1
52630	3119	80180	2015-06-27	2015-06-28	1
10945	648	40481087	1956-10-15	1956-10-22	1
49958	2955	28060	1969-12-29	1970-01-07	1
12072	715	40481087	2015-07-31	2015-08-21	1
81558	4844	4084167	1959-09-24	1959-09-24	1
17211	1032	378001	1954-06-30	1954-07-30	1
50728	3004	80180	1991-05-16	1991-05-17	1
59178	3513	40481087	2016-04-07	2016-04-21	1
38265	2274	4112343	2010-11-08	2010-11-15	1
10284	608	372328	1975-04-13	1975-05-28	1
11071	653	4112343	1959-02-01	1959-02-11	1
43439	2591	4112343	2002-07-01	2002-07-10	1
37533	2228	40481087	2017-04-19	2017-04-26	1
38682	2298	378001	2017-12-24	2018-01-23	1
57862	3436	260139	1969-04-19	1969-05-03	1
19653	1180	260139	1983-04-09	1983-04-16	1
74554	4433	40481087	1994-07-03	1994-07-24	1
45823	2731	80180	2003-07-21	2003-07-22	1
41908	2497	321042	2008-02-28	2008-02-29	1
42299	2522	4296204	2009-07-07	2009-07-21	1
31453	1861	80180	2019-02-02	2019-02-03	1
34166	2030	260139	1995-07-13	1995-07-27	1
46278	2760	28060	1963-05-29	1963-06-11	1
52631	3119	4112343	1984-09-26	1984-10-04	1
10946	648	40481087	2017-08-14	2017-08-21	1
49959	2955	80180	2004-08-04	2004-08-05	1
12073	715	4112343	1984-08-11	1984-08-18	1
81559	4844	4218389	1981-05-15	1981-06-19	1
17212	1032	4112343	1955-05-30	1955-06-07	1
50729	3004	260139	2008-07-17	2008-07-31	1
59179	3513	40481087	2019-02-12	2019-03-05	1
38266	2274	40481087	1975-12-24	1976-01-07	1
10285	608	4155034	1988-04-04	1988-04-18	1
11072	653	4112343	1969-07-16	1969-07-25	1
43440	2591	4155034	1943-06-14	1943-07-05	1
37534	2228	260139	1958-12-17	1958-12-31	1
38683	2298	4112343	2015-10-26	2015-11-03	1
57863	3436	260139	1971-07-30	1971-08-13	1
19654	1180	372328	1956-09-08	1956-12-19	1
74555	4433	40481087	2008-04-16	2008-04-30	1
45824	2731	81151	1975-07-14	1975-08-11	1
41909	2497	4134304	2004-06-28	2004-09-26	1
42300	2522	40481087	1979-08-13	1979-09-03	1
31454	1861	4112343	1981-12-31	1982-01-12	1
34167	2030	4112343	2010-06-21	2010-07-04	1
46279	2760	260139	1993-07-01	1993-07-08	1
52632	3119	40481087	1984-08-11	1984-09-01	1
10947	648	28060	2016-05-28	2016-06-08	1
49960	2955	260139	1975-04-30	1975-05-07	1
12074	715	4152936	2002-09-03	2002-09-17	1
81560	4844	4294548	1993-02-05	1993-03-05	1
17213	1032	4113008	2010-10-03	2010-10-24	1
50730	3004	260139	2018-04-04	2018-04-11	1
61023	3615	81151	1960-09-02	1960-10-07	1
38267	2274	40481087	2009-06-01	2009-06-22	1
10286	608	40481087	1984-06-03	1984-06-10	1
11073	653	4112343	1999-12-31	2000-01-13	1
43441	2591	4283893	1996-01-17	1996-03-20	1
37535	2228	378001	1980-08-11	1980-09-10	1
38684	2298	40481087	1983-03-30	1983-04-20	1
57864	3436	260139	1996-02-07	1996-02-21	1
19655	1180	4112343	1994-09-23	1994-10-01	1
74556	4433	40481087	2019-06-24	2019-06-25	1
45825	2731	81151	1990-03-21	1990-04-18	1
43212	2577	133834	1973-09-16	1973-09-17	1
42301	2522	4109685	1998-06-14	1998-07-05	1
31455	1861	78272	1993-12-30	1994-02-03	1
34168	2030	40481087	1970-06-16	1970-06-23	1
46280	2760	4112343	1987-11-17	1987-11-30	1
52633	3119	40481087	2001-10-25	2001-10-31	1
10948	648	80180	1971-07-25	1971-07-26	1
49961	2955	260139	1980-04-21	1980-04-28	1
17593	1058	133834	1956-01-29	1973-01-02	1
81561	4844	40481087	1976-12-29	1977-01-05	1
17214	1032	4218389	1991-07-19	1991-08-23	1
50731	3004	4112343	1968-12-11	1968-12-19	1
61024	3615	4112343	1965-08-31	1965-09-07	1
38268	2274	372328	1949-07-20	1949-10-09	1
10287	608	28060	1981-04-26	1981-05-03	1
11074	653	4112343	2015-02-21	2015-03-05	1
43442	2591	40481087	1936-09-23	1936-10-07	1
37536	2228	4112343	2000-10-12	2000-10-22	1
38685	2298	40481087	1986-02-01	1986-02-15	1
57865	3436	40481087	2015-10-08	2015-10-22	1
19656	1180	4112343	2008-10-21	2008-10-28	1
74557	4433	80180	1982-06-25	1982-06-26	1
45826	2731	260139	1964-02-22	1964-03-07	1
43213	2577	260139	1992-01-17	1992-01-31	1
42302	2522	4112343	1997-04-26	1997-05-09	1
31456	1861	260139	2015-05-05	2015-05-19	1
34169	2030	40481087	2016-05-19	2016-06-09	1
46281	2760	4266809	2001-05-31	2001-06-01	1
53301	3161	80180	1989-10-23	1989-10-24	1
10949	648	81151	1993-05-05	1993-06-09	1
49962	2955	260139	1985-12-26	1986-01-09	1
17594	1058	260139	1961-12-08	1961-12-22	1
81562	4844	40481087	1978-06-05	1978-06-19	1
17215	1032	4283893	1976-08-25	1976-11-17	1
50732	3004	4112343	2008-01-23	2008-02-02	1
61025	3615	4112343	1967-12-29	1968-01-10	1
38269	2274	4155034	1966-07-26	1966-08-09	1
10288	608	317576	1999-07-21	1999-07-22	1
12972	763	260139	2000-11-17	2000-12-01	1
43443	2591	192671	1974-09-16	1974-09-17	1
37537	2228	4116491	2007-01-17	2007-03-06	1
38686	2298	372328	1973-10-28	1974-04-04	1
57866	3436	260139	1964-08-05	1964-08-12	1
19657	1180	4237458	2010-09-28	2010-11-27	1
74558	4433	81151	1940-02-11	1940-02-25	1
45827	2731	260139	1977-09-16	1977-09-30	1
43214	2577	4048171	1975-05-19	1993-07-17	1
42303	2522	4112343	2015-06-05	2015-06-17	1
31457	1861	372328	1982-03-28	1982-05-08	1
34170	2030	40481087	2018-06-04	2018-06-25	1
46282	2760	40481087	1963-07-04	1963-07-18	1
53302	3161	4109685	1970-07-08	1970-07-29	1
10950	648	260139	1937-02-19	1937-03-05	1
49963	2955	4112343	1995-01-27	1995-02-09	1
17595	1058	260139	1976-09-05	1976-09-19	1
81563	4844	40481087	1978-08-24	1978-09-14	1
17216	1032	40481087	1973-12-11	1973-12-18	1
50733	3004	4296204	1992-10-22	1992-11-05	1
61026	3615	4112343	1994-12-23	1995-01-03	1
38270	2274	4294548	2013-02-27	2013-09-04	1
10289	608	4113008	2008-11-13	2008-11-27	1
12973	763	372328	1966-07-11	1966-08-25	1
43444	2591	372328	1963-11-26	1966-05-25	1
37538	2228	4218389	1962-02-19	1962-03-19	1
38687	2298	4152936	2008-06-30	2008-07-14	1
57867	3436	260139	1979-04-12	1979-04-19	1
19658	1180	40481087	1956-10-16	1956-10-23	1
74559	4433	313217	1993-04-10	1993-04-11	1
45828	2731	260139	1986-09-21	1986-10-05	1
43215	2577	4112343	1975-07-03	1975-07-15	1
42304	2522	4218389	1961-05-26	1961-06-23	1
31458	1861	4112343	2004-11-26	2004-12-09	1
34171	2030	260139	1971-01-07	1971-01-14	1
46283	2760	40481087	1964-07-07	1964-07-28	1
53303	3161	4112343	1953-04-06	1953-04-15	1
10951	648	260139	1951-12-20	1952-01-03	1
49964	2955	4112343	2005-02-01	2005-02-13	1
17596	1058	260139	2003-11-16	2003-11-30	1
81564	4844	40481087	1980-03-16	1980-03-23	1
17217	1032	78272	1994-02-08	1994-03-01	1
50734	3004	40481087	1965-08-07	1965-08-28	1
61027	3615	4294548	2016-08-19	2016-10-14	1
38271	2274	40481087	1952-09-09	1952-09-23	1
10290	608	40481087	2004-03-25	2004-04-08	1
12974	763	378001	2007-04-12	2007-05-12	1
43445	2591	372328	2017-02-19	2017-04-12	1
37539	2228	40481087	2011-09-08	2011-09-22	1
38688	2298	40481087	2008-07-07	2008-07-21	1
57868	3436	260139	1992-07-18	1992-07-25	1
19659	1180	40481087	2017-08-07	2017-08-14	1
74560	4433	4112343	1993-07-10	1993-07-18	1
45829	2731	321042	2007-07-09	2007-07-10	1
43216	2577	4112343	1976-12-19	1976-12-26	1
42305	2522	4310024	1989-10-31	1989-11-01	1
31459	1861	40481087	1992-11-05	1992-11-26	1
34172	2030	260139	1974-04-29	1974-05-13	1
46284	2760	40481087	1966-02-24	1966-03-17	1
53304	3161	4112343	1975-09-18	1975-09-27	1
10952	648	260139	1961-11-25	1961-12-09	1
49965	2955	4218389	1981-12-23	1982-01-27	1
17597	1058	260139	2009-03-09	2009-03-23	1
81565	4844	40481087	2001-12-01	2001-12-08	1
17218	1032	260139	2017-03-07	2017-03-14	1
50735	3004	40481087	1995-10-21	1995-10-28	1
61028	3615	40481087	1954-09-10	1954-10-01	1
38272	2274	40481087	1979-01-27	1979-02-17	1
10291	608	260139	1975-03-16	1975-03-30	1
12975	763	4112343	1973-06-10	1973-06-17	1
43446	2591	4112343	1959-05-25	1959-06-03	1
37786	2242	80180	1964-09-16	1964-09-17	1
38689	2298	28060	1972-02-23	1972-03-01	1
57869	3436	372328	1965-03-31	1965-08-09	1
19660	1180	4112343	2006-10-21	2006-10-29	1
74561	4433	4112343	1997-07-31	1997-08-10	1
45830	2731	372328	1961-07-18	1961-09-18	1
43217	2577	4113008	1986-07-03	1986-07-24	1
42306	2522	40481087	1966-01-05	1966-01-19	1
31460	1861	40481087	2002-02-13	2002-02-27	1
34173	2030	381316	2005-07-24	2005-07-25	1
46285	2760	40481087	1968-05-09	1968-05-16	1
53305	3161	4218389	1963-08-23	1963-09-13	1
10953	648	260139	1984-05-21	1984-05-28	1
49966	2955	40481087	1978-08-16	1978-08-30	1
17598	1058	378001	1961-02-24	1961-04-25	1
81566	4844	40481087	2003-06-09	2003-06-30	1
17219	1032	4112343	2004-12-08	2004-12-19	1
50736	3004	40481087	2016-12-12	2016-12-26	1
61029	3615	260139	1977-06-15	1977-06-29	1
38273	2274	40481087	1980-04-18	1980-05-09	1
10292	608	4112343	1977-10-03	1977-10-12	1
12976	763	4112343	1993-11-13	1993-11-25	1
43447	2591	4112343	1971-11-14	1971-11-26	1
37787	2242	260139	1976-02-23	1976-03-08	1
38690	2298	260139	2018-02-08	2018-02-22	1
57870	3436	4112343	1967-06-03	1967-06-13	1
19661	1180	40481087	1981-04-13	1981-05-04	1
74562	4433	4113008	2002-12-08	2002-12-29	1
45831	2731	4109685	2008-04-04	2008-04-25	1
43218	2577	40481087	1983-04-27	1983-05-04	1
42307	2522	40481087	1970-08-04	1970-08-11	1
31461	1861	40481087	2018-01-09	2018-01-23	1
34174	2030	4112343	1978-12-24	1979-01-04	1
46286	2760	40481087	1980-07-27	1980-08-10	1
53306	3161	4237458	1979-11-09	1980-01-08	1
10954	648	440086	1940-12-14	1950-12-22	1
49967	2955	40481087	1984-12-05	1984-12-26	1
17599	1058	4112343	2003-10-26	2003-11-05	1
81567	4844	40481087	2006-01-05	2006-01-26	1
17220	1032	4113008	1979-03-21	1979-04-11	1
50737	3004	28060	1958-10-12	1958-10-22	1
61030	3615	260139	1997-09-25	1997-10-09	1
38274	2274	40481087	2018-10-27	2018-11-17	1
10293	608	4294548	2001-12-17	2002-01-28	1
12977	763	28060	1991-12-12	1991-12-21	1
43448	2591	4112343	1985-07-31	1985-08-07	1
37788	2242	4109685	1969-02-02	1969-02-16	1
38691	2298	4112343	1992-02-17	1992-02-25	1
57871	3436	4112343	1975-03-16	1975-03-24	1
19662	1180	80180	1990-05-23	1990-05-24	1
74563	4433	4134304	2015-12-12	2016-03-11	1
45832	2731	4112343	1963-05-01	1963-05-10	1
43219	2577	80180	2012-03-18	2012-03-19	1
42308	2522	80180	1991-01-24	1991-01-25	1
31462	1861	378001	1988-08-28	1988-10-27	1
34175	2030	40481087	1989-05-12	1989-05-19	1
46287	2760	40481087	1985-04-22	1985-04-29	1
53307	3161	40481087	1958-07-08	1958-07-22	1
10955	648	4001336	1969-06-10	1969-07-10	1
49968	2955	40481087	1988-08-14	1988-08-21	1
17600	1058	40479422	2004-05-30	2004-07-06	1
81568	4844	40481087	2014-08-18	2014-08-25	1
17221	1032	4218389	1990-07-26	1990-08-23	1
50738	3004	4112343	2004-12-24	2005-01-04	1
61031	3615	378001	1956-08-24	1956-10-23	1
42327	2525	260139	2009-12-26	2010-01-09	1
10294	608	4329847	2005-07-13	2005-07-14	1
12978	763	80180	2002-11-29	2002-11-30	1
43449	2591	4112343	2003-04-07	2003-04-17	1
37789	2242	4112343	1933-12-19	1934-01-01	1
38692	2298	40481087	1983-06-24	1983-07-08	1
57872	3436	4112343	1987-04-06	1987-04-18	1
19663	1180	4218389	1986-12-28	1987-02-01	1
74564	4433	4218389	1981-11-16	1981-12-07	1
45833	2731	4112343	1978-08-22	1978-09-02	1
43220	2577	372328	1976-08-24	1977-01-22	1
42309	2522	4027663	1984-07-04	1984-07-05	1
31463	1861	4113008	1983-10-19	1983-11-09	1
35399	2100	260139	1954-07-12	1954-07-19	1
46288	2760	40481087	1985-09-04	1985-09-11	1
53308	3161	260139	2018-03-22	2018-03-29	1
10956	648	4059173	1939-02-13	1939-05-14	1
49969	2955	40481087	2011-04-23	2011-05-07	1
17601	1058	40481087	1973-05-06	1973-05-20	1
81569	4844	260139	1976-05-14	1976-05-21	1
17222	1032	4278672	1969-08-10	1969-11-08	1
50739	3004	40481087	1982-05-17	1982-06-07	1
61032	3615	4112343	1951-11-22	1951-12-02	1
42328	2525	4112343	1987-06-28	1987-07-06	1
11027	652	81151	1991-05-18	1991-06-08	1
12979	763	81151	1987-06-21	1987-07-05	1
43450	2591	4237458	2004-02-15	2004-05-15	1
37790	2242	4112343	1948-08-18	1948-08-27	1
38693	2298	40481087	1995-11-01	1995-11-08	1
57873	3436	40481087	1970-09-22	1970-10-13	1
19664	1180	40481087	2015-08-27	2015-09-10	1
74565	4433	4285898	1981-09-28	1981-09-29	1
45834	2731	4156265	1977-07-01	1977-07-15	1
43221	2577	378001	2015-02-13	2015-03-15	1
42310	2522	4218389	1985-02-17	1985-03-24	1
31464	1861	4156265	1986-10-24	1986-11-07	1
35400	2100	439777	1990-08-25	1990-08-26	1
46289	2760	40481087	1996-01-24	1996-01-31	1
53309	3161	372328	1951-06-15	1951-08-22	1
10957	648	4112343	1935-10-05	1935-10-15	1
49970	2955	0	2017-07-25	2017-07-26	1
17602	1058	40481087	1999-01-10	1999-01-31	1
81570	4844	260139	1990-01-12	1990-01-19	1
17223	1032	4283893	1997-09-16	1997-12-09	1
50740	3004	260139	2001-12-06	2001-12-20	1
61033	3615	4112343	2017-05-09	2017-05-20	1
42329	2525	4294548	1978-11-04	1979-01-06	1
11028	652	260139	1973-11-07	1973-11-14	1
12980	763	260139	1990-05-17	1990-05-24	1
43451	2591	4294548	1954-12-07	1954-12-14	1
37791	2242	4112343	2010-09-14	2010-09-26	1
41690	2483	261325	1966-05-07	1966-05-08	1
57874	3436	40481087	1983-05-14	1983-06-04	1
19665	1180	260139	1961-03-18	1961-03-25	1
74566	4433	4310024	1980-12-02	1980-12-03	1
45835	2731	260139	1969-02-21	1969-03-07	1
43222	2577	4027663	2003-05-05	2003-05-06	1
43083	2570	372328	2004-03-22	2005-03-31	1
31465	1861	4237458	1995-02-28	1995-04-29	1
35401	2100	4112343	1951-11-17	1951-11-25	1
46290	2760	40481087	1998-10-25	1998-11-15	1
53310	3161	372328	1953-09-19	1953-10-21	1
10958	648	4112343	1946-09-06	1946-09-15	1
49971	2955	260139	1998-01-10	1998-01-17	1
17603	1058	40481087	2010-03-01	2010-03-22	1
81571	4844	260139	2000-09-16	2000-09-30	1
17224	1032	40481087	1953-04-13	1953-05-04	1
50741	3004	372328	1951-01-01	1951-03-13	1
61034	3615	40481087	1963-01-22	1963-02-12	1
42330	2525	40481087	1981-01-31	1981-02-07	1
11029	652	4112343	1984-07-30	1984-08-08	1
12981	763	260139	1990-12-21	1991-01-04	1
43452	2591	4310024	1972-05-02	1972-05-03	1
37792	2242	4294548	2015-05-21	2015-08-27	1
41691	2483	40481087	1952-06-26	1952-07-17	1
57875	3436	40481087	2014-05-19	2014-06-09	1
19666	1180	4112343	2000-03-07	2000-03-16	1
74567	4433	40481087	1970-09-21	1970-10-12	1
45836	2731	260139	2012-11-20	2012-12-04	1
43223	2577	4310024	2010-02-27	2010-02-28	1
43084	2570	378001	1966-11-21	1967-01-20	1
34542	2053	81151	2000-11-13	2000-12-11	1
35402	2100	4112343	2000-11-06	2000-11-13	1
46291	2760	30753	1999-10-09	1999-10-10	1
53311	3161	4112343	2007-07-12	2007-07-19	1
10959	648	4132546	1969-06-10	1969-06-11	1
49972	2955	4112343	1974-02-17	1974-02-25	1
17604	1058	40481087	2010-06-26	2010-07-03	1
81572	4844	260139	2001-09-12	2001-09-19	1
17225	1032	40481087	1980-08-04	1980-08-11	1
50742	3004	378001	1961-04-08	1961-05-08	1
61035	3615	40481087	1980-10-08	1980-10-22	1
42331	2525	40481087	2006-05-29	2006-06-05	1
11030	652	40481087	1986-05-15	1986-05-22	1
12982	763	372328	1970-06-05	1971-03-04	1
43453	2591	40481087	2012-04-23	2012-05-14	1
37793	2242	260139	2001-08-02	2001-08-09	1
41692	2483	40481087	1968-05-03	1968-05-24	1
57876	3436	28060	1987-01-23	1987-02-01	1
19667	1180	4112343	2005-08-19	2005-08-26	1
74568	4433	40481087	1971-10-15	1971-11-05	1
45837	2731	372328	1960-12-08	1961-03-20	1
43224	2577	40481087	2014-10-23	2014-11-13	1
43085	2570	4112343	1975-11-09	1975-11-22	1
34543	2053	260139	1954-09-26	1954-10-03	1
35403	2100	4218389	1960-06-22	1960-07-27	1
46292	2760	81151	1971-10-09	1971-11-06	1
53312	3161	4152936	1960-06-25	1960-07-09	1
10960	648	4218389	1963-07-07	1963-08-11	1
49973	2955	4112343	1976-09-02	1976-09-14	1
17605	1058	80180	1992-12-03	1992-12-04	1
81573	4844	372328	2013-07-26	2014-03-27	1
17226	1032	257012	1976-09-29	1997-12-09	1
50743	3004	4112343	1961-10-08	1961-10-16	1
61036	3615	4116491	1982-08-23	1982-10-14	1
42332	2525	40481087	2015-10-04	2015-10-18	1
11031	652	40481087	1993-09-03	1993-09-17	1
12983	763	375671	2015-03-31	2015-05-30	1
43454	2591	257012	1971-11-06	1971-11-07	1
37794	2242	4112343	1929-09-28	1929-10-07	1
41693	2483	40481087	1985-07-03	1985-07-10	1
57877	3436	78272	1995-09-09	1995-09-30	1
19668	1180	4278672	1963-12-31	1964-03-30	1
74569	4433	40481087	1989-05-04	1989-05-11	1
45838	2731	40481087	1980-11-25	1980-12-02	1
43225	2577	28060	1976-01-15	1976-01-23	1
43086	2570	4278672	1946-09-23	1946-12-22	1
34544	2053	381316	2007-09-20	2007-09-21	1
35404	2100	4278672	2012-08-28	2012-11-26	1
46293	2760	260139	1972-10-07	1972-10-21	1
53313	3161	192671	1990-01-04	1990-01-05	1
10961	648	4278672	2001-02-27	2001-03-29	1
49974	2955	4112343	1991-03-02	1991-03-15	1
17606	1058	260139	1960-07-30	1960-08-13	1
81574	4844	40481087	1984-06-08	1984-06-15	1
17227	1032	260139	1980-10-13	1980-10-20	1
50744	3004	40481087	1955-09-16	1955-09-23	1
61037	3615	4237458	1962-05-30	1962-06-29	1
42333	2525	4155034	1976-01-24	1976-02-14	1
11032	652	80180	2007-01-14	2007-01-15	1
12984	763	4112343	1966-10-13	1966-10-26	1
43455	2591	4027663	1962-06-09	1962-06-10	1
37795	2242	4155034	1996-07-24	1996-08-14	1
41694	2483	28060	1981-04-06	1981-04-16	1
57878	3436	192671	2003-05-03	2003-05-04	1
19669	1180	40481087	1963-08-26	1963-09-09	1
74570	4433	81151	1983-12-27	1984-01-17	1
45839	2731	40481087	1993-08-01	1993-08-22	1
43226	2577	30753	2011-03-24	2011-03-25	1
43087	2570	40481087	1936-07-24	1936-08-07	1
34545	2053	4112343	1983-12-04	1983-12-12	1
35405	2100	40481087	1971-05-04	1971-05-11	1
46294	2760	372328	1961-12-23	1962-03-08	1
53314	3161	260139	1978-05-26	1978-06-09	1
10962	648	4283893	2007-10-25	2007-12-06	1
49975	2955	4112343	2018-10-26	2018-11-04	1
17607	1058	4112343	1962-03-06	1962-03-13	1
81575	4844	40481087	1994-01-07	1994-01-14	1
17228	1032	378001	2004-11-03	2005-01-02	1
50745	3004	40481087	1977-11-23	1977-11-30	1
61038	3615	40481087	1974-03-25	1974-04-08	1
42334	2525	40481087	2011-12-11	2011-12-18	1
11033	652	4116491	1991-02-07	1991-03-19	1
12985	763	4112343	2017-02-25	2017-03-07	1
43456	2591	4112343	1987-01-01	1987-01-08	1
37796	2242	40481087	1958-09-02	1958-09-09	1
41695	2483	80180	1984-08-11	1984-08-12	1
57879	3436	4112343	1963-04-13	1963-04-21	1
19670	1180	40481087	1989-10-27	1989-11-10	1
74571	4433	260139	2008-08-02	2008-08-16	1
45840	2731	40481087	2009-05-08	2009-05-15	1
43227	2577	260139	1988-09-21	1988-10-05	1
43088	2570	40481087	1939-09-26	1939-10-17	1
34546	2053	4218389	1989-09-21	1989-10-12	1
35406	2100	40481087	1982-09-11	1982-09-18	1
46295	2760	4237458	1970-07-16	1970-10-14	1
53315	3161	260139	1990-04-26	1990-05-10	1
10963	648	4285898	1970-10-28	1970-10-29	1
49976	2955	4294548	1979-10-29	1980-02-25	1
17608	1058	4112343	1993-04-01	1993-04-11	1
81576	4844	372328	1960-04-21	1960-05-05	1
17229	1032	4156265	1986-09-01	1986-09-15	1
50746	3004	40481087	1984-09-01	1984-09-15	1
61039	3615	80180	1983-12-11	1983-12-12	1
42335	2525	80180	2017-12-09	2017-12-10	1
11034	652	4296204	1986-08-07	1986-09-11	1
12986	763	4116491	2018-03-05	2018-04-13	1
43457	2591	4112343	1992-08-12	1992-08-19	1
37797	2242	40481087	1977-07-06	1977-07-20	1
41696	2483	81151	1945-12-24	1946-01-07	1
57880	3436	4112343	1968-05-11	1968-05-18	1
19671	1180	40481087	2001-10-13	2001-11-03	1
74572	4433	378001	1953-03-18	1953-05-17	1
45841	2731	40481087	2016-12-25	2017-01-01	1
43228	2577	4084167	1991-02-07	1991-02-07	1
43089	2570	40481087	1951-06-13	1951-06-27	1
34547	2053	4237458	2010-03-24	2010-04-23	1
35407	2100	257012	1953-02-12	1953-04-02	1
46296	2760	4285898	2000-07-05	2000-07-06	1
53316	3161	4146173	1996-03-14	1996-05-13	1
10964	648	40481087	1949-06-08	1949-06-15	1
49977	2955	40481087	2001-02-22	2001-03-08	1
17609	1058	4112343	1999-07-10	1999-07-17	1
81577	4844	4084167	1973-10-17	1973-10-17	1
17230	1032	40481087	1959-08-08	1959-08-29	1
50747	3004	40481087	2006-06-22	2006-06-29	1
61040	3615	260139	1970-07-13	1970-07-20	1
42336	2525	260139	1996-05-09	1996-05-23	1
11035	652	260139	2004-12-02	2004-12-16	1
12987	763	4156265	1995-04-24	1995-05-15	1
43458	2591	4146173	1944-06-29	1944-07-29	1
37798	2242	40481087	1984-03-23	1984-03-30	1
41697	2483	192671	1984-11-07	1984-11-08	1
57881	3436	4296205	1976-04-23	1976-05-21	1
20926	1258	260139	2013-10-18	2013-10-25	1
74573	4433	4112343	1967-05-20	1967-05-27	1
46694	2781	80180	2016-12-29	2016-12-30	1
43229	2577	4156265	2013-02-02	2013-02-23	1
43090	2570	40481087	2004-01-31	2004-02-07	1
34548	2053	40481087	1988-02-14	1988-02-21	1
35408	2100	260139	2015-04-01	2015-04-15	1
46297	2760	4310024	1999-01-12	1999-01-13	1
53317	3161	40481087	1995-01-27	1995-02-10	1
10965	648	40481087	2000-09-09	2000-09-23	1
49978	2955	372328	1974-03-05	1974-07-16	1
17610	1058	4283893	2018-01-26	2018-05-04	1
81578	4844	4084167	1975-03-12	1975-03-12	1
17231	1032	40481087	1971-10-02	1971-10-16	1
50748	3004	28060	1957-08-01	1957-08-14	1
61041	3615	260139	2011-01-02	2011-01-09	1
42337	2525	40481087	1986-08-09	1986-08-23	1
11036	652	372328	1973-10-01	1973-11-20	1
12988	763	40481087	1994-08-09	1994-08-16	1
43459	2591	40481087	2009-06-16	2009-06-30	1
37799	2242	28060	1980-10-22	1980-11-04	1
41698	2483	260139	1946-07-24	1946-07-31	1
57882	3436	40481087	1967-08-24	1967-08-31	1
20927	1258	378001	2018-08-22	2018-10-21	1
74574	4433	4296204	2014-12-26	2015-01-16	1
46695	2781	260139	1985-05-02	1985-05-09	1
43230	2577	4266809	2012-03-18	2012-03-19	1
43091	2570	4112343	1957-05-19	1957-05-31	1
34549	2053	28060	1955-07-25	1955-08-02	1
35409	2100	372328	1947-07-02	1947-08-11	1
46298	2760	40481087	1964-05-19	1964-06-02	1
53318	3161	78272	1957-09-11	1957-10-09	1
10966	648	40481087	2014-07-09	2014-07-23	1
51703	3069	80180	2001-10-25	2001-10-26	1
17611	1058	40481087	2001-06-25	2001-07-02	1
81579	4844	4156265	1960-02-21	1960-03-06	1
19170	1150	80180	1991-10-14	1991-10-15	1
50749	3004	257012	1970-01-30	1970-01-31	1
61042	3615	378001	1993-07-16	1993-09-14	1
42338	2525	372328	1982-04-22	1983-01-07	1
11037	652	4112343	1968-06-15	1968-06-23	1
12989	763	260139	1972-06-10	1972-06-17	1
43460	2591	80180	1974-08-20	1974-08-21	1
37800	2242	257012	2015-07-09	2015-07-10	1
41699	2483	4112343	1980-05-27	1980-06-07	1
57883	3436	80180	2003-02-20	2003-02-21	1
20928	1258	4112343	1973-06-10	1973-06-21	1
74575	4433	40481087	1955-01-16	1955-02-06	1
46696	2781	4113008	1996-01-18	1996-02-01	1
44709	2663	4112343	2011-11-14	2011-11-26	1
43092	2570	4112343	1976-11-20	1976-12-01	1
34550	2053	372328	1954-10-06	1954-12-09	1
35410	2100	378001	1973-05-20	1973-07-19	1
46299	2760	40481087	2011-01-15	2011-01-22	1
53319	3161	372328	1953-03-14	1953-04-22	1
10967	648	28060	2018-05-02	2018-05-15	1
51704	3069	260139	1991-02-12	1991-02-26	1
17612	1058	28060	1959-08-07	1959-08-17	1
81580	4844	4278672	1965-12-05	1966-02-03	1
19171	1150	4112343	1977-05-15	1977-05-27	1
50750	3004	4112343	1976-04-13	1976-04-22	1
61043	3615	4027663	1976-08-24	1976-08-25	1
42339	2525	4112343	1991-06-17	1991-06-25	1
11038	652	4112343	1995-06-16	1995-06-26	1
12990	763	4112343	2018-07-01	2018-07-09	1
43461	2591	80502	2012-03-14	2012-03-15	1
37801	2242	381316	2013-12-21	2013-12-22	1
41700	2483	260139	1962-12-15	1962-12-29	1
57884	3436	81151	1970-03-05	1970-03-26	1
20929	1258	4152936	2006-02-05	2006-02-26	1
74576	4433	40481087	1997-05-17	1997-06-07	1
46697	2781	4294548	1989-04-22	1989-05-06	1
44710	2663	40481087	2005-10-26	2005-11-09	1
43093	2570	4112343	1982-10-02	1982-10-14	1
34551	2053	4112343	1965-12-30	1966-01-12	1
35411	2100	4109685	1959-08-13	1959-08-27	1
46300	2760	372328	1959-11-13	1960-03-03	1
53320	3161	372328	1967-05-11	1967-06-28	1
10968	648	81893	1969-12-02	1969-12-03	1
51705	3069	375671	2008-02-12	2008-04-12	1
17613	1058	81151	1996-07-20	1996-08-10	1
81581	4844	40481087	1997-06-05	1997-06-19	1
19172	1150	4294548	2007-11-19	2007-12-31	1
50751	3004	4283893	1997-04-29	1997-06-10	1
61044	3615	4112343	1960-10-16	1960-10-25	1
42340	2525	4112343	2014-03-28	2014-04-10	1
11039	652	4112343	1998-06-13	1998-06-26	1
12991	763	4278672	1981-08-21	1981-11-19	1
43462	2591	81893	1973-02-26	1973-02-27	1
37802	2242	4278672	1942-05-25	1942-08-23	1
41701	2483	372328	1945-03-29	1945-05-12	1
57885	3436	4112343	2014-08-28	2014-09-06	1
20930	1258	40481087	1982-08-26	1982-09-09	1
74577	4433	40481087	2008-11-03	2008-11-10	1
46698	2781	40481087	1980-05-06	1980-05-27	1
44711	2663	40481087	2015-09-22	2015-10-06	1
43094	2570	40481087	1942-04-12	1942-04-26	1
34552	2053	4283893	1995-03-24	1995-08-11	1
35412	2100	4112343	1977-11-23	1977-12-03	1
46301	2760	378001	2015-06-18	2015-07-18	1
53321	3161	40481087	1953-03-14	1953-03-28	1
10969	648	260139	1938-08-25	1938-09-08	1
51706	3069	4156265	1968-02-11	1968-03-03	1
17614	1058	260139	1986-10-07	1986-10-14	1
81582	4844	40481087	2015-01-01	2015-01-22	1
19173	1150	40481087	1992-09-20	1992-10-11	1
50752	3004	4294548	1969-12-12	1970-04-10	1
61045	3615	4112343	2018-08-15	2018-08-28	1
42341	2525	40481087	1978-04-19	1978-05-03	1
11040	652	40481087	1989-07-11	1989-07-18	1
12992	763	40481087	1982-06-23	1982-07-14	1
43463	2591	260139	1947-04-26	1947-05-10	1
37803	2242	40481087	1934-08-09	1934-08-30	1
41702	2483	439777	1952-03-02	1952-03-03	1
57886	3436	4116491	1997-11-03	1997-12-19	1
20931	1258	40481087	2000-05-14	2000-05-28	1
81785	4855	81151	2018-08-06	2018-08-20	1
46699	2781	40481087	1988-10-10	1988-10-17	1
44712	2663	30753	2001-08-17	2001-08-18	1
43095	2570	40481087	1979-11-10	1979-12-01	1
34553	2053	40481087	1974-01-12	1974-02-02	1
35413	2100	4156265	2014-12-16	2014-12-30	1
46302	2760	4027663	1990-03-20	1990-03-21	1
53322	3161	40481087	1960-10-14	1960-10-21	1
10970	648	4027663	1959-12-10	1959-12-11	1
51707	3069	4283893	1977-09-27	1978-01-24	1
17615	1058	4112343	1969-12-04	1969-12-16	1
81583	4844	80180	2001-01-06	2001-01-07	1
19174	1150	40481087	2006-01-09	2006-01-23	1
50753	3004	4294548	1991-12-14	1992-01-04	1
61046	3615	4152936	2006-10-06	2006-10-27	1
42342	2525	40481087	1983-05-04	1983-05-18	1
11041	652	40481087	2014-01-09	2014-01-16	1
12993	763	28060	1970-01-10	1970-01-23	1
43464	2591	260139	1987-12-17	1987-12-24	1
37804	2242	40481087	2003-06-24	2003-07-15	1
41703	2483	4113008	1961-02-17	1961-03-10	1
57887	3436	40481087	2010-09-16	2010-09-30	1
20932	1258	40481087	2004-07-12	2004-07-26	1
81786	4855	372328	1982-04-30	1982-08-21	1
46700	2781	28060	1987-07-24	1987-08-05	1
44713	2663	81893	2001-05-19	2001-05-20	1
43096	2570	40481087	1980-08-03	1980-08-24	1
34554	2053	28060	1959-09-08	1959-09-16	1
35414	2100	4218389	2009-09-15	2009-10-13	1
46303	2760	4294548	2007-07-07	2007-08-25	1
53323	3161	40481087	2011-04-24	2011-05-08	1
10971	648	4112343	1955-11-10	1955-11-18	1
51708	3069	40479422	1986-08-01	1986-10-07	1
17616	1058	4112343	1992-06-21	1992-07-02	1
81584	4844	260139	1994-06-25	1994-07-09	1
19175	1150	40481087	2014-05-07	2014-05-21	1
50754	3004	40481087	1974-06-26	1974-07-03	1
61047	3615	4218389	2007-11-21	2007-12-19	1
42343	2525	40481087	1996-08-06	1996-08-13	1
11042	652	260139	1971-08-28	1971-09-11	1
12994	763	4294548	1995-05-19	1995-06-09	1
43465	2591	260139	1997-12-12	1997-12-26	1
37805	2242	81151	1939-08-04	1939-09-08	1
41704	2483	40481087	1986-07-13	1986-07-27	1
57888	3436	40481087	2014-10-15	2014-11-05	1
20933	1258	28060	1997-11-30	1997-12-10	1
81787	4855	4112343	1996-10-31	1996-11-07	1
46701	2781	28060	1990-04-22	1990-04-30	1
44714	2663	4112343	1974-10-19	1974-10-29	1
43097	2570	40481087	1985-10-28	1985-11-11	1
34555	2053	257012	1995-05-12	1995-05-13	1
35415	2100	40481087	1990-02-13	1990-02-27	1
46304	2760	40481087	1999-03-23	1999-04-13	1
53324	3161	40481087	2016-11-13	2016-11-27	1
10972	648	4112343	2006-12-03	2006-12-13	1
51709	3069	40481087	1983-04-05	1983-04-19	1
17617	1058	40481087	2007-02-09	2007-02-23	1
81585	4844	4084167	1978-03-27	1978-03-27	1
19176	1150	28060	1959-08-25	1959-09-02	1
50755	3004	40481087	2005-10-03	2005-10-17	1
61048	3615	40481087	1990-07-08	1990-07-29	1
45566	2711	260139	1996-04-09	1996-04-23	1
11043	652	372328	1969-08-06	1970-01-20	1
12995	763	40481087	1983-12-15	1983-12-29	1
43466	2591	260139	2017-11-22	2017-11-29	1
37806	2242	4112343	1954-05-31	1954-06-09	1
41953	2501	372328	1965-06-22	1965-11-01	1
58268	3456	0	1991-12-12	1991-12-13	1
20934	1258	260139	1994-06-06	1994-06-20	1
81788	4855	4116491	2004-09-03	2004-10-08	1
46702	2781	372328	1986-01-26	1986-03-14	1
44715	2663	4142905	1972-03-17	1972-05-16	1
43098	2570	40481087	2005-10-05	2005-10-26	1
34556	2053	372328	1956-06-01	1956-08-02	1
35416	2100	372328	1944-08-01	1944-11-13	1
46305	2760	80180	2001-05-31	2001-06-01	1
54912	3253	28060	1972-04-09	1972-04-22	1
10973	648	40481087	1935-04-20	1935-05-04	1
51710	3069	40481087	2000-12-23	2000-12-30	1
17618	1058	40481087	2007-09-29	2007-10-06	1
81586	4844	40481087	1978-01-06	1978-01-27	1
19177	1150	28060	1973-05-25	1973-06-02	1
52286	3100	81151	1967-11-29	1967-12-13	1
62352	3689	4112343	1987-12-07	1987-12-20	1
45567	2711	372328	1955-09-28	1956-05-28	1
11044	652	378001	2016-11-05	2017-01-04	1
14543	862	28060	1972-05-23	1972-06-02	1
43467	2591	4112343	1970-09-07	1970-09-18	1
37807	2242	4112343	1986-09-07	1986-09-18	1
41954	2501	28060	1974-05-27	1974-06-05	1
58269	3456	78272	1949-10-04	1949-10-18	1
20935	1258	40481087	1982-10-16	1982-10-23	1
81789	4855	4266809	2014-07-23	2014-07-24	1
46703	2781	4027663	2008-03-21	2008-03-22	1
44716	2663	4156265	2018-05-15	2018-06-05	1
43099	2570	40481087	2017-04-14	2017-04-28	1
34557	2053	372328	1957-06-28	1958-01-30	1
35417	2100	375671	1948-05-12	1948-06-11	1
46306	2760	81151	1961-01-06	1961-02-03	1
54913	3253	133834	1972-05-15	1972-05-16	1
10974	648	40481087	1941-09-05	1941-09-12	1
51711	3069	28060	1967-07-30	1967-08-08	1
17619	1058	257012	2018-03-09	2018-03-10	1
81587	4844	40481087	2005-03-28	2005-04-04	1
19178	1150	78272	1982-05-24	1982-06-07	1
52287	3100	260139	1964-09-10	1964-09-24	1
62353	3689	4112343	1992-10-06	1992-10-13	1
45568	2711	4059173	2015-11-03	2016-01-02	1
11045	652	4152936	2003-01-27	2003-02-17	1
14544	862	260139	1987-02-21	1987-03-07	1
43468	2591	4134304	1947-09-12	1947-12-11	1
37808	2242	40481087	1962-04-28	1962-05-19	1
41955	2501	260139	1992-07-17	1992-07-31	1
58270	3456	317576	1989-12-21	1989-12-22	1
20936	1258	80180	2003-11-14	2003-11-15	1
81790	4855	80180	2014-07-23	2014-07-24	1
46704	2781	40481087	2013-02-07	2013-02-21	1
44717	2663	4283893	2014-05-29	2014-07-24	1
43100	2570	80180	1971-03-06	1971-03-07	1
34558	2053	378001	1970-07-03	1970-09-01	1
35418	2100	4112343	1951-09-06	1951-09-14	1
46307	2760	195588	1998-03-18	1998-04-25	1
54914	3253	4237458	1980-04-26	1980-05-26	1
14497	859	80180	1993-06-18	1993-06-19	1
51712	3069	4112343	1966-09-20	1966-10-02	1
17620	1058	372328	1956-07-20	1956-09-01	1
82864	4927	260139	2007-05-22	2007-05-29	1
19179	1150	81151	2008-08-17	2008-09-14	1
52288	3100	260139	1990-06-11	1990-06-18	1
62354	3689	40481087	1978-04-09	1978-04-16	1
45569	2711	4112343	1953-05-15	1953-05-28	1
11046	652	4155034	2017-10-31	2017-11-21	1
14545	862	4035415	1994-02-24	1994-03-26	1
43469	2591	4266809	1974-08-20	1974-08-21	1
41048	2443	28060	1962-12-25	1963-01-04	1
41956	2501	260139	1996-05-27	1996-06-10	1
58271	3456	321042	1991-12-12	1991-12-13	1
20937	1258	81151	1983-05-18	1983-06-08	1
81791	4855	372328	1978-06-07	1978-08-19	1
46705	2781	81151	1988-10-12	1988-10-26	1
44718	2663	40481087	2013-06-06	2013-06-27	1
43101	2570	260139	1936-10-17	1936-10-24	1
34559	2053	4112343	1958-01-19	1958-02-01	1
35419	2100	4112343	1961-01-08	1961-01-17	1
46308	2760	4112343	1971-10-30	1971-11-07	1
66863	3958	80180	2001-11-22	2001-11-23	1
14498	859	81151	1961-02-11	1961-03-11	1
51713	3069	4112343	1997-02-05	1997-02-18	1
17621	1058	4112343	2006-03-25	2006-04-04	1
82865	4927	372328	1977-10-20	1977-12-30	1
19180	1150	372328	1983-03-20	1985-03-27	1
52289	3100	372328	1952-03-31	1952-05-15	1
62355	3689	40481087	1983-08-27	1983-09-03	1
45570	2711	4112343	1998-07-30	1998-08-09	1
11047	652	4156265	1997-04-07	1997-04-28	1
14546	862	4237458	1986-06-06	1986-09-04	1
43470	2591	4285898	1974-05-22	1974-05-23	1
41049	2443	80180	1999-04-09	1999-04-10	1
41957	2501	372328	1962-05-26	1962-11-05	2
58272	3456	372328	1946-10-11	1946-11-14	1
20938	1258	257012	2007-11-02	2007-11-03	1
81792	4855	4112343	1990-08-18	1990-08-31	1
46706	2781	260139	2014-01-18	2014-01-25	1
44719	2663	80809	2007-08-21	2011-05-02	1
43102	2570	381316	1992-11-19	1992-11-20	1
34560	2053	4112343	1966-03-16	1966-03-23	1
35420	2100	4112343	2015-04-11	2015-04-19	1
46309	2760	40481087	1967-12-13	1968-01-03	1
66864	3958	372328	1968-10-31	1969-08-17	1
14499	859	81151	1969-01-28	1969-02-25	1
51714	3069	4113008	1991-06-13	1991-06-27	1
17622	1058	40481087	1956-03-29	1956-04-12	1
82866	4927	4112343	1983-01-23	1983-01-30	1
19181	1150	4112343	1988-01-04	1988-01-11	1
52290	3100	4218389	2007-04-17	2007-05-08	1
62356	3689	40481087	2010-08-15	2010-08-22	1
45571	2711	40481087	2002-03-11	2002-03-18	1
12948	762	28060	2003-08-19	2003-09-01	1
14547	862	40481087	1977-08-01	1977-08-22	1
43471	2591	4294548	1960-04-11	1960-05-09	1
41050	2443	257012	1995-08-07	1995-08-08	1
41958	2501	4112343	2014-07-11	2014-07-19	1
58273	3456	4112343	1982-03-03	1982-03-16	1
20939	1258	260139	1970-05-28	1970-06-11	1
81793	4855	4142905	1987-02-20	1987-03-22	1
46707	2781	4310024	2014-02-13	2014-02-14	1
44720	2663	260139	1965-07-23	1965-07-30	1
43103	2570	4027663	1963-08-15	1963-08-16	1
34561	2053	40481087	1981-03-04	1981-03-25	1
35421	2100	4112343	2015-12-19	2015-12-29	1
46310	2760	40481087	1974-01-23	1974-02-13	1
66865	3958	378001	1964-03-26	1964-05-25	1
14500	859	260139	1976-11-02	1976-11-09	1
51715	3069	4155034	1971-12-13	1971-12-27	1
17623	1058	40481087	1970-10-04	1970-10-11	1
82867	4927	4283893	2004-12-22	2005-05-04	1
19182	1150	4112343	1998-04-03	1998-04-13	1
52291	3100	4310024	1988-06-25	1988-06-26	1
62357	3689	40481087	2011-08-23	2011-08-30	1
45572	2711	80180	1989-09-04	1989-09-05	1
12949	762	80502	2014-09-10	2014-09-11	1
14548	862	28060	1980-10-14	1980-10-23	1
43472	2591	4294548	1971-09-18	1972-07-22	1
41051	2443	260139	1963-10-22	1963-10-28	1
41959	2501	4113008	1995-09-03	1995-09-24	1
58274	3456	4218389	1977-08-22	1977-09-12	1
20940	1258	378001	2011-10-28	2011-11-27	1
81794	4855	40481087	1984-08-09	1984-08-16	1
46708	2781	40481087	1985-08-01	1985-08-22	1
44721	2663	260139	1973-04-20	1973-04-27	1
43104	2570	4112343	1945-04-05	1945-04-12	1
34562	2053	40481087	1984-02-14	1984-02-28	1
35422	2100	4146173	1979-12-22	1980-02-20	1
46311	2760	40481087	1978-01-30	1978-02-20	1
66866	3958	4027663	1992-08-06	1992-08-07	1
14501	859	4112343	1963-10-02	1963-10-15	1
51716	3069	40481087	1995-08-23	1995-09-13	1
17624	1058	40481087	2017-02-04	2017-02-25	1
82868	4927	260139	1990-07-15	1990-07-22	1
19183	1150	40481087	1969-10-05	1969-10-12	1
52292	3100	40481087	2009-10-19	2009-11-09	1
62358	3689	80180	1987-05-11	1987-05-12	1
45573	2711	260139	1952-12-14	1952-12-28	1
12950	762	260139	1959-01-20	1959-02-03	1
14549	862	260139	1995-08-31	1995-09-07	1
43473	2591	40481087	1952-01-25	1952-02-15	1
41052	2443	4027663	1989-12-21	1989-12-22	1
41960	2501	4156265	1962-10-23	1962-11-06	1
58275	3456	40481087	1956-11-04	1956-11-25	1
20941	1258	4112343	2008-11-16	2008-11-28	1
81795	4855	40481087	2017-03-10	2017-03-31	1
46709	2781	40481087	2014-09-19	2014-10-10	1
44722	2663	260139	1980-12-20	1981-01-03	1
43105	2570	4112343	1947-12-29	1948-01-06	1
34563	2053	28060	1971-02-27	1971-03-10	1
35423	2100	4294548	1953-01-22	1953-04-02	1
46312	2760	40481087	1978-08-25	1978-09-01	1
66867	3958	4112343	1983-03-20	1983-03-27	1
14502	859	4278672	1996-05-09	1996-06-08	1
51717	3069	260139	1971-04-28	1971-05-05	1
18405	1108	260139	1978-06-14	1978-06-28	1
82869	4927	260139	2014-11-20	2014-12-04	1
19184	1150	40481087	1975-10-31	1975-11-14	1
52293	3100	30753	1988-11-22	1988-11-23	1
62359	3689	260139	1959-09-10	1959-09-17	1
45574	2711	260139	1966-11-06	1966-11-22	1
12951	762	260139	1980-04-20	1980-04-27	1
14550	862	4112343	1973-01-29	1973-02-06	1
43474	2591	40481087	1956-03-14	1956-03-28	1
41053	2443	4237458	1979-10-26	1979-12-24	1
41961	2501	80180	1995-11-09	1995-11-10	1
58276	3456	40481087	1986-05-12	1986-05-26	1
20942	1258	4278672	1982-03-24	1982-04-23	1
81796	4855	28060	1984-11-03	1984-11-14	1
46710	2781	40481087	1983-08-15	1983-09-05	1
44723	2663	40481087	1989-01-11	1989-02-01	1
43106	2570	4112343	1967-11-09	1967-11-17	1
34564	2053	80180	1993-11-04	1993-11-05	1
35424	2100	40479768	1976-06-03	1976-07-10	1
47810	2843	260139	1961-06-11	1961-06-18	1
66868	3958	4266809	2001-11-22	2001-11-23	1
14503	859	40481087	1988-10-26	1988-11-02	1
51718	3069	372328	1963-04-08	1963-07-24	1
18406	1108	260139	2000-05-12	2000-05-19	1
82870	4927	378001	1991-09-28	1991-11-27	1
19185	1150	40481087	1998-06-20	1998-07-11	1
52294	3100	81893	1988-10-23	1988-10-24	1
62360	3689	260139	2014-07-10	2014-07-17	1
45575	2711	260139	1968-05-27	1968-06-03	1
12952	762	260139	2017-01-23	2017-01-30	1
14551	862	4112343	1986-02-09	1986-02-17	1
43475	2591	40481087	1975-07-16	1975-07-30	1
41054	2443	28060	1980-08-20	1980-08-30	1
41962	2501	81151	1997-06-15	1997-06-29	1
58277	3456	30753	1980-11-20	1980-11-21	1
20943	1258	4283893	2007-08-17	2007-11-09	1
81797	4855	195588	2005-10-08	2005-11-10	1
46711	2781	40481087	2016-04-09	2016-04-30	1
44724	2663	28060	1965-12-21	1966-01-01	1
43107	2570	4152936	1958-08-21	1958-09-04	1
34565	2053	372328	1953-09-30	1953-12-10	1
35425	2100	40481087	1955-02-27	1955-03-06	1
47811	2843	378001	1975-12-20	1976-01-19	1
66869	3958	4285898	2001-06-25	2001-06-26	1
14504	859	40481087	2018-12-17	2018-12-31	1
51719	3069	4109685	1977-05-29	1977-06-19	1
18407	1108	375671	2000-08-05	2000-09-04	1
82871	4927	4109685	2000-10-10	2000-10-24	1
19186	1150	40481087	2010-12-24	2011-01-07	1
52295	3100	260139	1959-12-22	1959-12-29	1
62361	3689	313217	2011-04-04	2011-04-05	1
45576	2711	260139	1980-02-05	1980-02-12	1
12953	762	4112343	1987-11-03	1987-11-12	1
14552	862	4112343	1991-12-20	1992-01-01	1
45233	2693	195588	1983-12-16	1984-01-31	1
41055	2443	28060	1986-03-04	1986-03-13	1
41963	2501	260139	1981-11-14	1981-11-21	1
58278	3456	80180	1982-07-13	1982-07-14	1
20944	1258	40481087	2009-01-07	2009-01-28	1
81798	4855	4310024	2012-11-30	2012-12-01	1
47546	2830	78272	1987-10-03	1987-10-17	1
44725	2663	80180	2002-09-11	2002-09-12	1
43108	2570	4285898	1970-12-06	1970-12-07	1
34566	2053	4112343	1958-06-05	1958-06-12	1
35426	2100	40481087	1957-06-02	1957-06-09	1
47812	2843	439777	2005-07-26	2005-07-27	1
66870	3958	40481087	1969-07-07	1969-07-14	1
14505	859	260139	1970-05-26	1970-06-09	1
51720	3069	4112343	2017-07-07	2017-07-16	1
18408	1108	40481087	1971-03-29	1971-04-12	1
82872	4927	4112343	2002-05-02	2002-05-15	1
19187	1150	260139	1951-12-04	1951-12-18	1
52296	3100	260139	1986-03-03	1986-03-17	1
62362	3689	40481087	1984-08-06	1984-08-27	1
45577	2711	40481087	1993-10-10	1993-10-31	1
12954	762	4112343	1996-05-14	1996-05-25	1
14553	862	4218389	1977-09-23	1977-10-21	1
45234	2693	260139	2014-01-03	2014-01-17	1
41056	2443	372328	1965-05-12	1965-10-29	1
41964	2501	4112343	1991-10-18	1991-10-26	1
58279	3456	260139	1959-01-17	1959-01-24	1
20945	1258	78272	1986-05-23	1986-06-20	1
81799	4855	40481087	2014-03-07	2014-03-21	1
47547	2830	372328	1976-12-29	1977-01-12	1
44726	2663	4027663	1991-08-25	1991-08-26	1
43109	2570	40481087	1970-07-22	1970-08-12	1
34567	2053	4112343	1962-09-04	1962-09-14	1
35427	2100	40481087	1976-02-19	1976-03-11	1
47813	2843	4112343	1959-12-04	1959-12-12	1
66871	3958	30753	2001-03-27	2001-03-28	1
14506	859	260139	2003-06-17	2003-06-24	1
51721	3069	4278672	1969-01-27	1969-03-28	1
18409	1108	40481087	1994-04-16	1994-04-30	1
82873	4927	4296205	1978-05-18	1978-06-08	1
19188	1150	4218389	2010-09-04	2010-10-09	1
52297	3100	372328	1954-06-06	1954-11-11	1
62363	3689	40481087	2007-08-02	2007-08-23	1
45578	2711	40486433	1953-07-02	1953-07-03	1
12955	762	4113008	2007-04-28	2007-05-12	1
14554	862	40481087	2006-07-28	2006-08-18	1
45235	2693	4056621	1983-12-16	1983-12-17	1
41057	2443	375671	1974-09-22	1974-10-22	1
41965	2501	4112343	2010-01-21	2010-01-30	1
58280	3456	372328	1943-07-08	1943-08-19	1
20946	1258	260139	2004-07-11	2004-07-18	1
81800	4855	81893	2012-12-30	2012-12-31	1
47548	2830	4084167	1988-12-02	1988-12-02	1
44727	2663	4112343	2004-08-26	2004-09-07	1
43110	2570	40481087	1984-05-14	1984-05-28	1
34568	2053	40481087	1956-10-23	1956-11-13	1
35428	2100	40481087	2000-05-10	2000-05-24	1
47814	2843	4112343	2008-10-11	2008-10-24	1
66872	3958	192671	2001-12-09	2001-12-10	1
14507	859	4283893	2017-03-15	2017-05-17	1
51722	3069	257012	1977-12-06	1977-12-07	1
18410	1108	78272	1975-07-29	1975-08-26	1
82874	4927	40481087	2005-06-10	2005-07-01	1
19189	1150	40481087	1988-04-30	1988-05-07	1
52298	3100	4027663	1982-11-29	1982-11-30	1
62364	3689	28060	1961-12-01	1961-12-10	1
45579	2711	28060	1957-05-10	1957-05-23	1
12956	762	4146173	1979-10-22	1979-11-21	1
14555	862	28060	1981-02-24	1981-03-05	1
45236	2693	4218389	2006-03-27	2006-04-17	1
41058	2443	4112343	2016-11-02	2016-11-10	1
41966	2501	4156265	2019-06-04	2019-06-18	1
58281	3456	372328	1945-10-07	1945-11-15	1
20947	1258	260139	2015-11-16	2015-11-23	1
81801	4855	192671	2014-08-22	2014-08-23	1
47549	2830	4112343	2008-02-06	2008-02-18	1
44728	2663	4112343	2010-05-10	2010-05-21	1
43111	2570	40481087	1989-01-02	1989-01-09	1
34569	2053	40481087	1961-09-24	1961-10-08	1
35429	2100	28060	1945-10-27	1945-11-05	1
47815	2843	40481087	1981-06-04	1981-06-25	1
66873	3958	260139	1974-02-03	1974-02-10	1
14508	859	40481087	1967-06-16	1967-07-07	1
51723	3069	4155034	1997-04-26	1997-05-10	1
18411	1108	195588	2012-10-13	2012-11-17	1
82875	4927	40481087	2006-04-03	2006-04-10	1
19190	1150	28060	1990-03-02	1990-03-12	1
52299	3100	4152936	1951-10-03	1951-10-24	1
62365	3689	28060	1998-10-16	1998-10-23	1
45580	2711	28060	2018-06-09	2018-06-19	1
12957	762	40481087	1997-10-26	1997-11-02	1
14556	862	257012	1990-09-09	1990-11-18	1
45237	2693	4283893	1972-01-25	1972-04-11	1
41059	2443	4285898	1998-05-14	1998-05-15	1
41967	2501	40481087	2010-01-02	2010-01-23	1
58282	3456	4027663	1972-12-02	1972-12-03	1
20948	1258	372328	1968-11-02	1969-02-17	1
81802	4855	372328	1982-11-19	1983-08-27	1
47550	2830	4112343	2017-12-13	2017-12-22	1
44729	2663	4266809	2002-09-11	2002-09-12	1
43112	2570	40481087	2003-06-19	2003-06-26	1
37224	2207	81151	1981-02-18	1981-03-04	1
35430	2100	80180	1976-01-16	1976-01-17	1
47816	2843	40481087	1983-11-18	1983-12-02	1
66874	3958	260139	2017-06-26	2017-07-10	1
14509	859	40481087	2004-03-18	2004-04-01	1
51724	3069	40481087	2011-07-13	2011-07-20	1
18412	1108	260139	1981-02-19	1981-02-26	1
82876	4927	80180	2017-06-27	2017-06-28	1
19191	1150	78272	1992-03-16	1992-04-13	1
52300	3100	40481087	1995-05-08	1995-05-29	1
62366	3689	81151	1984-09-28	1984-10-26	1
45581	2711	30753	1988-08-10	1988-08-11	1
12958	762	40481087	2004-08-04	2004-08-18	1
14557	862	260139	1973-09-16	1973-09-30	1
45238	2693	28060	1961-04-17	1961-04-24	1
41060	2443	40481087	1965-01-17	1965-02-07	1
41968	2501	40481087	2015-10-02	2015-10-16	1
58283	3456	4112343	1962-12-29	1963-01-11	1
20949	1258	4112343	1991-02-21	1991-03-06	1
81803	4855	375671	1992-05-24	1992-07-23	1
47551	2830	4146173	1989-11-05	1990-01-04	1
44730	2663	40481087	1988-10-28	1988-11-04	1
43113	2570	30753	1970-10-07	1970-10-08	1
37225	2207	260139	1989-01-08	1989-01-22	1
35431	2100	372328	1945-01-12	1945-02-12	1
47817	2843	80180	2000-01-09	2000-01-10	1
66875	3958	4112343	1997-03-16	1997-03-24	1
14510	859	40486433	1959-03-11	1959-03-12	1
52529	3115	28060	1974-03-15	1974-03-26	1
18413	1108	4116491	2011-08-31	2011-10-14	1
82877	4927	257012	2005-01-26	2005-01-27	1
19192	1150	260139	1985-11-17	1985-11-24	1
52301	3100	40481087	2003-01-24	2003-02-14	1
62367	3689	260139	1956-07-28	1956-08-04	1
45582	2711	133834	1950-12-30	1950-12-31	1
12959	762	80180	1996-05-19	1996-05-20	1
14558	862	260139	1977-02-10	1977-02-24	1
45239	2693	195588	1983-10-08	1983-11-11	1
41061	2443	260139	2009-09-05	2009-09-12	1
41969	2501	40481087	2017-07-14	2017-08-04	1
58284	3456	28060	1952-06-07	1952-06-20	1
20950	1258	4116491	1984-03-08	1984-04-11	1
81804	4855	4027663	2003-09-04	2003-09-05	1
47552	2830	40481087	2009-12-19	2009-12-26	1
44731	2663	40481087	1998-03-23	1998-03-30	1
43114	2570	195588	1993-08-21	1993-10-15	1
37226	2207	260139	2010-02-08	2010-02-15	1
35432	2100	4112343	2002-05-09	2002-05-18	1
47818	2843	260139	2001-05-29	2001-06-12	1
66876	3958	4296205	1965-04-20	1965-05-11	1
14511	859	28060	1982-07-09	1982-07-20	1
52530	3115	78272	1968-01-15	1968-02-05	1
18414	1108	4116491	2014-01-23	2014-03-13	1
82878	4927	260139	2016-12-09	2016-12-16	1
19193	1150	260139	2007-11-30	2007-12-14	1
52302	3100	80180	1989-10-18	1989-10-19	1
62368	3689	260139	1963-07-23	1963-08-06	1
45583	2711	4027663	1980-06-18	1980-06-19	1
12960	762	4112343	1994-10-09	1994-10-19	1
14559	862	4230399	1979-09-11	1979-10-11	1
45240	2693	257012	1972-04-04	1972-04-05	1
41062	2443	4043241	2018-01-25	2018-01-26	1
41970	2501	81151	1974-04-07	1974-05-05	1
58285	3456	81893	1980-02-24	1980-02-25	1
20951	1258	40481087	1986-05-14	1986-05-21	1
81805	4855	4112343	2008-03-11	2008-03-22	1
47553	2830	80180	2007-12-22	2007-12-23	1
44732	2663	40481087	2015-11-14	2015-12-05	1
43115	2570	260139	1954-02-23	1954-03-09	1
37227	2207	4112343	2010-09-29	2010-10-12	1
35610	2114	257012	2001-10-27	2001-10-28	1
47819	2843	372328	1962-07-17	1962-12-27	1
66877	3958	40481087	1983-02-07	1983-02-21	1
14512	859	81151	2007-08-10	2007-09-07	1
52531	3115	192671	2006-05-28	2006-05-29	1
18415	1108	28060	1979-07-11	1979-07-23	1
82879	4927	372328	1983-06-02	1983-07-08	1
19194	1150	4237458	1953-12-22	1954-02-20	1
52303	3100	372328	1952-09-12	1952-11-13	1
62369	3689	260139	1975-03-10	1975-03-24	1
45584	2711	4112343	1959-10-13	1959-10-22	1
12961	762	40481087	1971-10-14	1971-11-04	1
14560	862	4278672	2017-08-22	2017-11-20	1
45241	2693	4112343	1959-01-14	1959-01-27	1
41063	2443	4152936	2019-02-02	2019-02-23	1
41971	2501	372328	1966-08-28	1966-11-07	1
58286	3456	260139	1978-11-11	1978-11-25	1
22751	1359	28060	1961-06-02	1961-06-11	1
81806	4855	4285898	2013-11-25	2013-11-26	1
47554	2830	260139	1982-07-02	1982-07-09	1
45328	2699	28060	2007-01-08	2007-01-15	1
43116	2570	4112343	1991-12-29	1992-01-08	1
37228	2207	4112343	2014-11-22	2014-12-03	1
35611	2114	321042	1988-06-15	1988-06-16	1
47820	2843	375671	2006-09-06	2006-10-06	1
66878	3958	81151	1980-06-21	1980-07-05	1
14513	859	260139	1971-07-09	1971-07-23	1
52532	3115	260139	1973-04-27	1973-05-04	1
18416	1108	80180	2013-02-04	2013-02-05	1
82880	4927	4112343	1994-11-29	1994-12-07	1
19195	1150	4294548	2011-11-12	2011-11-19	1
52304	3100	378001	1974-10-07	1974-11-06	1
62370	3689	28060	1988-10-19	1988-10-26	1
45585	2711	4278672	1979-05-25	1979-06-24	1
12962	762	40481087	1974-10-26	1974-11-16	1
14561	862	4283893	1990-08-19	1990-11-18	1
45242	2693	4283893	2011-08-03	2011-09-07	1
41064	2443	4283893	1995-06-12	1995-09-25	1
41972	2501	4109685	1979-05-09	1979-05-30	1
58287	3456	4112343	1950-08-03	1950-08-14	1
22752	1359	255848	2008-09-06	2008-09-07	1
81807	4855	40481087	1986-02-13	1986-02-27	1
47555	2830	317009	2006-08-11	2006-08-12	1
45329	2699	81151	1973-08-03	1973-08-17	1
43117	2570	4112343	1998-11-06	1998-11-15	1
37229	2207	4218389	2011-10-23	2011-11-20	1
35612	2114	4112343	2003-11-08	2003-11-15	1
47821	2843	375671	2010-07-17	2010-09-15	1
66879	3958	81893	2000-05-01	2000-05-02	1
14514	859	372328	1969-01-30	1969-07-07	1
52533	3115	260139	2000-07-06	2000-07-20	1
18417	1108	260139	2014-09-05	2014-09-19	1
82881	4927	40481087	1982-08-01	1982-08-15	1
19196	1150	40481087	1975-07-20	1975-07-27	1
52305	3100	4112343	1954-11-17	1954-11-27	1
62371	3689	4112343	1971-09-23	1971-10-01	1
45586	2711	40481087	1999-10-09	1999-10-30	1
12963	762	40481087	1984-06-14	1984-06-28	1
14562	862	40481087	1994-04-09	1994-04-23	1
45243	2693	40481087	1959-09-18	1959-09-25	1
41065	2443	40481087	1965-09-12	1965-09-19	1
41973	2501	4112343	1987-04-01	1987-04-10	1
58288	3456	4285898	1981-08-17	1981-08-18	1
22753	1359	313217	1987-04-14	1987-04-15	1
81808	4855	40481087	1991-09-06	1991-09-13	1
47556	2830	4283893	1978-05-30	1978-09-05	1
45330	2699	260139	2013-09-05	2013-09-19	1
43118	2570	4113008	2009-06-08	2009-06-22	1
37230	2207	40481087	1998-11-05	1998-11-26	1
35613	2114	4155034	1971-09-23	1971-10-14	1
47822	2843	4278672	1990-12-31	1991-03-31	1
66880	3958	4152936	2000-08-08	2000-08-29	1
14515	859	4051466	1961-03-10	1976-06-21	1
52534	3115	372328	1968-10-26	1969-03-21	1
18418	1108	372328	1971-05-21	1971-07-07	1
87923	5235	80180	1960-05-29	1960-05-30	1
19197	1150	40481087	1984-10-04	1984-10-11	1
52306	3100	4285898	1989-06-20	1989-06-21	1
62372	3689	4112343	2005-06-21	2005-06-28	1
45587	2711	40481087	2000-09-02	2000-09-09	1
12964	762	260139	1996-12-31	1997-01-07	1
14563	862	80180	2004-08-07	2004-08-08	1
45244	2693	40481087	1975-08-29	1975-09-19	1
41066	2443	40481087	1989-09-19	1989-10-03	1
41974	2501	40481087	1989-12-06	1989-12-13	1
58289	3456	40481087	1951-11-01	1951-11-22	1
22754	1359	4112343	1998-02-12	1998-02-21	1
81809	4855	40481087	2005-11-03	2005-11-24	1
47557	2830	40481087	1996-08-12	1996-08-26	1
45331	2699	260139	2018-06-03	2018-06-17	1
43119	2570	4266809	1971-03-06	1971-03-07	1
37231	2207	80180	2013-05-06	2013-05-07	1
35614	2114	40481087	2009-06-30	2009-07-21	1
47823	2843	40481087	1974-08-05	1974-08-12	1
66881	3958	4156265	1996-10-07	1996-10-28	1
14516	859	4112343	1996-09-08	1996-09-21	1
52535	3115	4113008	2009-09-09	2009-09-30	1
18419	1108	4056621	2012-12-08	2012-12-09	1
87924	5235	313217	1981-12-12	1981-12-13	1
19198	1150	40481087	2012-02-25	2012-03-10	1
52307	3100	40481087	1987-03-07	1987-03-14	1
62373	3689	4112343	2016-10-02	2016-10-11	1
45588	2711	40481087	2016-11-08	2016-11-15	1
12965	762	4112343	1979-01-06	1979-01-17	1
14564	862	260139	1997-06-29	1997-07-06	1
45245	2693	80180	1997-05-27	1997-05-28	1
41067	2443	40481087	2014-12-19	2015-01-02	1
41975	2501	40481087	2018-07-06	2018-07-13	1
58290	3456	40481087	1990-02-09	1990-02-16	1
22755	1359	4294548	1947-06-04	1947-06-18	1
81810	4855	40481087	2007-11-23	2007-11-30	1
47558	2830	40481087	2000-10-09	2000-10-30	1
45332	2699	378001	2018-12-06	2019-02-04	1
43120	2570	4278672	2015-05-22	2015-07-21	1
37232	2207	81893	2012-08-09	2012-08-10	1
35615	2114	0	1988-06-15	1988-06-16	1
47824	2843	40481087	2008-04-13	2008-04-20	1
66882	3958	4296205	1993-10-25	1993-11-22	1
14517	859	40481087	1986-07-02	1986-07-16	1
52536	3115	4155034	1973-02-08	1973-03-01	1
18420	1108	4113008	2008-07-24	2008-08-14	1
87925	5235	4109685	1954-01-15	1954-01-29	1
22341	1335	78272	2003-12-19	2004-01-02	1
53621	3178	30753	1993-02-05	1993-02-06	1
62374	3689	4142905	1963-11-17	1964-01-16	1
45589	2711	81893	1988-07-11	1988-07-12	1
12966	762	40481087	1958-07-30	1958-08-20	1
14565	862	4112343	1976-11-21	1976-12-01	1
45246	2693	260139	1967-09-22	1967-10-06	1
41068	2443	28060	1975-06-04	1975-06-17	1
44640	2659	257012	1975-02-16	1975-02-17	1
58291	3456	81151	1978-10-07	1978-10-28	1
22756	1359	40481087	1943-06-06	1943-06-20	1
86448	5150	28060	1952-01-02	1952-01-13	1
47559	2830	28060	1986-01-24	1986-01-31	1
45333	2699	4156265	1989-07-20	1989-08-10	1
43121	2570	40481087	1976-11-13	1976-11-20	1
37233	2207	195588	2002-04-19	2002-06-03	1
35616	2114	80180	2002-07-02	2002-07-03	1
47825	2843	260139	1960-02-29	1960-03-07	1
66883	3958	40481087	1973-08-29	1973-09-19	1
14518	859	257012	2017-05-03	2017-05-04	1
52537	3115	40481087	1988-12-07	1988-12-14	1
18421	1108	4116491	2006-07-21	2006-09-01	1
87926	5235	4112343	1940-10-27	1940-11-08	1
22342	1335	260139	2008-03-27	2008-04-10	1
53622	3178	78272	1962-09-11	1962-10-09	1
62847	3717	440086	1983-05-07	1983-08-06	1
45590	2711	260139	1972-05-18	1972-05-25	1
12967	762	40481087	1962-06-06	1962-06-27	1
14566	862	40481087	2010-05-04	2010-05-25	1
45247	2693	372328	1963-06-20	1963-09-24	1
41069	2443	81893	1997-06-18	1997-06-19	1
44641	2659	4109685	2015-03-12	2015-04-02	1
58292	3456	40481087	1970-08-22	1970-08-29	1
22757	1359	40481087	1974-02-13	1974-03-06	1
86449	5150	78272	1958-12-06	1959-01-03	1
47560	2830	28060	2015-05-16	2015-05-25	1
45334	2699	40481087	1999-10-20	1999-11-10	1
43122	2570	40481087	1990-05-09	1990-05-23	1
37234	2207	260139	2018-10-03	2018-10-17	1
35617	2114	260139	1990-04-18	1990-04-25	1
47826	2843	4112343	1988-04-15	1988-04-28	1
69922	4142	80180	2019-01-21	2019-01-22	1
14519	859	260139	1992-11-11	1992-11-18	1
52538	3115	40481087	1998-11-29	1998-12-20	1
18422	1108	4116491	2012-12-08	2013-01-23	1
87927	5235	4112343	1956-04-20	1956-05-03	1
22343	1335	372328	1979-11-15	1980-01-28	1
53623	3178	80180	1994-07-30	1994-07-31	1
62848	3717	4294548	2006-06-12	2006-06-26	1
45591	2711	4043241	2010-11-15	2010-11-16	1
12968	762	40481087	1976-03-16	1976-04-06	1
15946	946	0	1976-04-04	1976-04-05	1
45248	2693	4112343	2019-02-23	2019-03-03	1
41070	2443	260139	1989-12-11	1989-12-18	1
44642	2659	40481087	1998-05-23	1998-05-30	1
61167	3622	0	1953-04-22	1953-04-23	1
22758	1359	40481087	1981-04-04	1981-04-11	1
86450	5150	80180	1976-07-19	1976-07-20	1
47561	2830	40481087	1978-10-11	1978-10-18	1
45335	2699	80180	2012-02-20	2012-02-21	1
43123	2570	40481087	2010-11-04	2010-11-11	1
37235	2207	372328	1982-01-14	1982-04-01	1
35618	2114	372328	1970-07-06	1971-01-13	1
47827	2843	40481087	2015-11-17	2015-12-01	1
69923	4142	4112343	2007-08-02	2007-08-09	1
14520	859	4218389	2018-03-13	2018-04-10	1
52539	3115	0	1991-01-04	1991-01-05	1
18423	1108	4218389	1980-06-30	1980-07-21	1
87928	5235	4113008	1967-07-20	1967-08-10	1
22344	1335	372328	1984-02-06	1984-07-30	1
53624	3178	192671	1994-10-06	1994-10-07	1
62849	3717	40481087	1991-07-18	1991-08-01	1
45592	2711	4051466	1953-07-02	1969-10-08	1
12969	762	40481087	1977-02-05	1977-02-12	1
15947	946	81151	1969-01-19	1969-02-23	1
45249	2693	4113008	1972-10-30	1972-11-20	1
41071	2443	260139	1994-11-08	1994-11-15	1
44643	2659	80180	2006-07-08	2006-07-09	1
61168	3622	4112343	1932-10-16	1932-10-29	1
22759	1359	40481087	1986-03-20	1986-04-10	1
86451	5150	260139	1973-12-13	1973-12-20	1
47562	2830	40481087	1995-07-30	1995-08-13	1
45336	2699	81151	1978-07-13	1978-08-17	1
45060	2684	78272	1977-02-09	1977-02-23	1
37236	2207	4310024	2011-09-14	2011-09-15	1
35619	2114	4112343	2016-10-11	2016-10-21	1
47828	2843	81151	1964-10-04	1964-10-18	1
69924	4142	4113008	2015-10-19	2015-11-09	1
14521	859	4296204	1979-10-31	1979-12-05	1
52540	3115	372328	1968-04-14	1968-06-28	1
18424	1108	40481087	2013-12-24	2014-01-14	1
87929	5235	4285898	1960-02-29	1960-03-01	1
22345	1335	4112343	1982-02-04	1982-02-16	1
53625	3178	196456	2014-03-13	2014-03-14	1
62850	3717	260139	1977-07-04	1977-07-11	1
45593	2711	4109685	1988-05-07	1988-05-28	1
12970	762	4146173	2001-04-29	2001-05-29	1
15948	946	260139	1970-08-18	1970-08-25	1
45250	2693	40481087	1976-09-22	1976-10-06	1
41072	2443	378001	1964-10-14	1964-12-12	1
44644	2659	260139	1988-03-15	1988-03-22	1
61169	3622	4112343	1969-12-14	1969-12-26	1
22760	1359	28060	1945-04-17	1945-04-24	1
86452	5150	372328	1944-09-15	1945-03-01	1
47563	2830	133834	1974-10-18	1974-10-19	1
45337	2699	260139	1971-10-15	1971-10-29	1
45061	2684	80180	1995-09-27	1995-09-28	1
37237	2207	40481087	1982-10-19	1982-10-26	1
35620	2114	4155034	1974-11-27	1974-12-18	1
47829	2843	81151	2001-07-06	2001-08-03	1
69925	4142	4152936	2013-12-14	2013-12-28	1
14522	859	40481087	1987-02-18	1987-02-25	1
52541	3115	4116491	2006-01-10	2006-03-03	1
20009	1208	372328	1941-03-20	1941-06-03	1
87930	5235	40481087	1933-06-19	1933-07-10	1
22346	1335	4112343	1983-07-14	1983-07-22	1
53626	3178	260139	1999-08-19	1999-09-02	1
62851	3717	4112343	1977-07-05	1977-07-15	1
45594	2711	4112343	2008-02-21	2008-02-29	1
12971	762	4218389	1955-08-08	1955-08-29	1
15949	946	440448	1976-04-04	1976-04-05	1
45251	2693	40481087	1979-12-29	1980-01-05	1
41073	2443	4296205	1992-08-18	1992-09-22	1
44645	2659	260139	2006-07-18	2006-08-01	1
61170	3622	40480160	2008-11-18	2008-12-18	1
22761	1359	80180	1971-05-14	1971-05-15	1
86453	5150	4112343	2004-10-01	2004-10-13	1
47564	2830	257012	1978-07-25	1978-07-26	1
45338	2699	260139	1980-05-13	1980-05-20	1
45062	2684	378001	1962-03-09	1962-05-08	1
37238	2207	40481087	1992-02-14	1992-03-06	1
35621	2114	40481087	1981-12-01	1981-12-15	1
47830	2843	260139	1998-01-06	1998-01-13	1
69926	4142	40481087	2000-12-19	2000-12-26	1
14523	859	40481087	2005-07-01	2005-07-22	1
52542	3115	4278672	1972-01-15	1972-03-15	1
20010	1208	4094814	2009-03-14	2009-03-15	1
87931	5235	40481087	1956-05-11	1956-05-18	1
22347	1335	40481087	1985-03-25	1985-04-01	1
53627	3178	260139	2018-09-04	2018-09-18	1
62852	3717	4112343	1999-09-04	1999-09-13	1
45595	2711	40481087	1975-06-21	1975-06-28	1
14567	863	80180	1964-10-26	1964-10-27	1
15950	946	4027663	1991-03-30	1991-03-31	1
45252	2693	40481087	1991-02-13	1991-02-27	1
44499	2651	28060	1973-11-08	1973-11-17	1
44646	2659	372328	1976-09-13	1976-12-01	1
61171	3622	40481087	1967-01-03	1967-01-17	1
22762	1359	4112343	1975-06-29	1975-07-09	1
86454	5150	4296204	2004-05-20	2004-06-03	1
47565	2830	260139	1992-06-18	1992-07-02	1
45339	2699	4113008	1976-07-02	1976-07-23	1
45063	2684	4112343	2005-11-10	2005-11-19	1
37239	2207	4027663	2006-04-18	2006-04-19	1
35622	2114	78272	1999-12-07	1999-12-28	1
47831	2843	4146173	2016-09-13	2016-10-13	1
69927	4142	40481087	2009-06-06	2009-06-13	1
14524	859	40481087	2015-05-10	2015-05-17	1
52543	3115	30753	2005-11-01	2005-11-02	1
20011	1208	40481087	1968-01-26	1968-02-02	1
87932	5235	40481087	1958-09-10	1958-09-17	1
22348	1335	40481087	2007-01-09	2007-01-23	1
53628	3178	372328	1984-08-07	1985-05-18	1
62853	3717	4112343	2003-11-25	2003-12-04	1
45596	2711	40481087	1982-02-26	1982-03-05	1
14568	863	81151	2003-05-09	2003-06-13	1
15951	946	4112343	1967-10-30	1967-11-12	1
45253	2693	260139	1962-01-27	1962-02-10	1
44500	2651	81151	1951-06-24	1951-07-29	1
44647	2659	4027663	1999-06-20	1999-06-21	1
61172	3622	40481087	1996-06-03	1996-06-10	1
22763	1359	4112343	1993-07-28	1993-08-04	1
86455	5150	40481087	1943-08-01	1943-08-08	1
47566	2830	4084167	1985-11-12	1985-11-12	1
45340	2699	40481087	1977-07-20	1977-07-27	1
45064	2684	4218389	1999-06-28	1999-07-26	1
37240	2207	4112343	1990-07-03	1990-07-14	1
35623	2114	81151	2008-08-12	2008-09-09	1
47832	2843	40481087	1962-12-22	1962-12-29	1
69928	4142	260139	2000-07-05	2000-07-12	1
16057	951	372328	2008-02-24	2008-09-24	1
52544	3115	80180	2006-04-30	2006-05-01	1
20012	1208	40481087	1978-05-05	1978-05-26	1
87933	5235	40481087	1961-10-08	1961-10-15	1
22349	1335	40481087	2014-11-18	2014-12-02	1
53629	3178	40481087	1967-01-25	1967-02-15	1
62854	3717	40481087	1998-11-01	1998-11-15	1
45597	2711	40481087	1992-02-20	1992-03-12	1
14569	863	260139	2018-02-10	2018-02-24	1
15952	946	4285898	2000-11-17	2000-11-18	1
45254	2693	260139	1977-08-27	1977-09-03	1
44501	2651	81151	1957-06-27	1957-07-25	1
44648	2659	4283893	1974-12-29	1975-08-17	1
61173	3622	40481087	2006-07-19	2006-07-26	1
22764	1359	4218389	1949-05-13	1949-06-10	1
86456	5150	40481087	1962-09-22	1962-09-29	1
47567	2830	4112343	1983-06-29	1983-07-06	1
45341	2699	40481087	2010-01-25	2010-02-08	1
45065	2684	4294548	1998-12-13	1999-02-14	1
40053	2380	260139	1960-04-20	1960-05-04	1
35624	2114	81151	2018-01-20	2018-02-10	1
47833	2843	40481087	1975-08-13	1975-08-27	1
69929	4142	40481087	1999-04-16	1999-04-23	1
16058	951	440448	2011-12-20	2011-12-21	1
52545	3115	260139	1987-04-26	1987-05-10	1
20013	1208	40481087	1996-10-10	1996-10-31	1
87934	5235	30753	1959-06-04	1959-06-05	1
22350	1335	80180	2017-06-28	2017-06-29	1
53630	3178	40481087	1974-08-14	1974-08-21	1
62855	3717	40481087	2003-07-29	2003-08-19	1
48335	2866	81893	2004-11-25	2004-11-26	1
14570	863	317576	1961-08-24	1961-08-25	1
15953	946	4310024	1999-06-26	1999-06-27	1
45255	2693	260139	1995-10-15	1995-10-22	1
44502	2651	81151	2000-11-18	2000-12-09	1
44649	2659	40481087	1978-12-08	1978-12-22	1
61174	3622	28060	2012-09-04	2012-09-15	1
22765	1359	40481087	1984-06-29	1984-07-20	1
86457	5150	40481087	1968-07-05	1968-07-26	1
47568	2830	40481087	1974-09-19	1974-10-10	1
45342	2699	40481087	1989-12-27	1990-01-03	1
45066	2684	0	1967-05-21	1967-05-22	1
40054	2380	260139	1994-03-18	1994-03-25	1
35625	2114	372328	1969-12-02	1970-01-07	1
47834	2843	40481087	1990-05-08	1990-05-22	1
69930	4142	40481087	2006-11-23	2006-12-14	1
16059	951	4112343	2015-07-21	2015-07-28	1
52546	3115	4027663	1995-01-13	1995-01-14	1
20014	1208	28060	1945-05-02	1945-05-09	1
87935	5235	260139	1973-10-19	1973-10-26	1
22351	1335	81151	1987-12-03	1987-12-17	1
53631	3178	40481087	1992-01-02	1992-01-23	1
62856	3717	40481087	2014-11-14	2014-12-05	1
48336	2866	192671	2006-01-05	2006-01-06	1
14571	863	372328	1943-08-10	1943-09-16	1
15954	946	40481087	1981-09-18	1981-10-09	1
45256	2693	4283893	1979-01-18	1979-05-24	1
44503	2651	260139	1963-09-17	1963-09-24	1
44650	2659	40481087	1997-04-12	1997-04-19	1
61175	3622	195588	1970-05-12	1970-06-23	1
22766	1359	40481087	1991-09-21	1991-10-12	1
86458	5150	260139	1978-06-24	1978-07-08	1
49572	2936	260139	1963-11-26	1963-12-10	1
45343	2699	40481087	1992-04-29	1992-05-20	1
45067	2684	30753	1995-03-01	1995-03-02	1
40055	2380	260139	2002-09-28	2002-10-12	1
35626	2114	4294548	2001-10-06	2002-03-02	1
47835	2843	40481087	1999-03-11	1999-03-25	1
69931	4142	40481087	2014-06-18	2014-07-02	1
16060	951	4113008	1967-12-30	1968-01-20	1
52547	3115	4109685	1994-10-07	1994-10-28	1
20015	1208	80180	1975-01-31	1975-02-01	1
87936	5235	317576	1925-08-22	1925-08-23	1
22352	1335	81151	1998-05-28	1998-06-18	1
53632	3178	198809	2014-03-13	2014-03-14	1
62857	3717	80180	2014-01-19	2014-01-20	1
48337	2866	261325	1998-04-26	1998-04-27	1
14572	863	4027663	1953-08-10	1953-08-11	1
15955	946	40481087	2000-01-12	2000-01-26	1
45257	2693	40481087	1977-11-09	1977-11-16	1
44504	2651	4218389	1977-07-24	1977-08-21	1
44651	2659	28060	1979-01-03	1979-01-16	1
61176	3622	260139	2019-03-26	2019-04-09	1
22767	1359	260139	1976-08-21	1976-08-28	1
86459	5150	260139	1979-10-03	1979-10-17	1
49573	2936	260139	2008-02-26	2008-03-11	1
45344	2699	40481087	1993-04-24	1993-05-15	1
45068	2684	4027663	1986-02-06	1986-02-07	1
40056	2380	372328	1950-08-25	1950-09-08	1
35627	2114	40481087	1974-07-29	1974-08-19	1
49394	2925	372328	1961-02-03	1961-03-19	1
69932	4142	28060	1992-10-28	1992-11-04	1
16061	951	4218389	2019-01-22	2019-02-26	1
52548	3115	4112343	2001-08-15	2001-08-22	1
20016	1208	4112343	1951-12-06	1951-12-19	1
87937	5235	372328	1922-10-16	1922-12-23	1
22353	1335	4283893	2010-09-07	2010-10-05	1
53633	3178	4112343	1961-12-28	1962-01-04	1
62858	3717	4155034	1992-10-11	1992-10-25	1
48338	2866	4112343	2003-05-16	2003-05-26	1
14573	863	4112343	1945-03-10	1945-03-19	1
15956	946	40481087	2018-04-11	2018-04-18	1
45258	2693	40481087	2000-01-18	2000-01-25	1
44505	2651	4237458	1952-05-24	1952-06-23	1
44652	2659	81893	2005-06-13	2005-06-14	1
61177	3622	372328	1922-12-20	1923-01-31	1
22768	1359	260139	1994-05-06	1994-05-20	1
86460	5150	260139	1998-09-13	1998-09-27	1
49574	2936	4112343	1999-10-14	1999-10-24	1
45345	2699	260139	1980-11-18	1980-11-25	1
45069	2684	4134304	2014-04-08	2014-06-07	1
40057	2380	372328	1952-12-26	1953-05-09	1
35628	2114	40481087	1977-02-09	1977-02-23	1
49395	2925	372328	2001-05-04	2002-01-20	1
69933	4142	4112343	2004-03-08	2004-03-19	1
16062	951	40481087	1978-01-29	1978-02-05	1
52549	3115	40481087	1984-02-19	1984-02-26	1
20017	1208	4155034	1941-09-16	1941-10-07	1
87938	5235	372328	1927-11-25	1928-09-01	1
22354	1335	40481087	1998-01-01	1998-01-08	1
53634	3178	4112343	1977-02-18	1977-02-27	1
62859	3717	28060	1999-06-22	1999-07-02	1
48339	2866	40481087	1976-11-18	1976-12-09	1
14574	863	4112343	1970-11-20	1970-11-28	1
15957	946	28060	2015-02-23	2015-03-07	1
48971	2902	81151	1952-06-03	1952-07-08	1
44506	2651	40481087	1966-11-10	1966-11-24	1
44653	2659	4112343	2005-01-03	2005-01-14	1
61178	3622	372328	1927-09-07	1928-05-09	1
22769	1359	378419	2002-03-12	2002-03-13	1
86461	5150	4112343	1939-12-26	1940-01-04	1
49575	2936	4112343	2000-12-19	2000-12-31	1
45346	2699	4112343	2011-09-25	2011-10-08	1
45070	2684	40481087	1961-03-19	1961-04-02	1
40058	2380	4112343	1981-09-27	1981-10-06	1
35629	2114	40481087	1980-07-16	1980-07-30	1
49396	2925	4112343	2013-07-22	2013-08-04	1
69934	4142	40481087	1993-02-17	1993-03-10	1
16063	951	40481087	2002-05-31	2002-06-21	1
52550	3115	40481087	2001-01-16	2001-02-06	1
20018	1208	4278672	1961-12-21	1962-02-19	1
87939	5235	372328	1940-03-02	1940-08-03	1
22355	1335	40481087	2007-06-27	2007-07-04	1
53635	3178	4112343	1996-05-28	1996-06-07	1
62860	3717	78272	2008-10-31	2008-11-28	1
48340	2866	40481087	2010-04-27	2010-05-04	1
14575	863	4112343	2002-05-17	2002-05-24	1
15958	946	81893	1999-11-23	1999-11-24	1
48972	2902	260139	2005-02-18	2005-03-04	1
44507	2651	40481087	1992-05-26	1992-06-16	1
44654	2659	4152936	1978-08-02	1978-08-23	1
61179	3622	4112343	1975-03-31	1975-04-08	1
22770	1359	4156265	1932-05-28	1932-06-11	1
86462	5150	4155034	1970-11-01	1970-11-15	1
49576	2936	40481087	1970-04-16	1970-04-30	1
45347	2699	4116491	2008-11-07	2008-12-14	1
45071	2684	40481087	1989-01-30	1989-02-13	1
40059	2380	4112343	1989-11-26	1989-12-03	1
35630	2114	40481087	1982-09-17	1982-10-08	1
49397	2925	40481087	2011-06-22	2011-07-13	1
69935	4142	40481087	2013-01-31	2013-02-14	1
16064	951	28060	2004-11-02	2004-11-13	1
52551	3115	40481087	2013-01-11	2013-01-18	1
20019	1208	40481087	1961-09-20	1961-09-27	1
87940	5235	4329847	1982-01-23	1982-01-24	1
22356	1335	40481087	2008-11-03	2008-11-10	1
53636	3178	40481087	1979-09-25	1979-10-02	1
62861	3717	260139	1989-04-10	1989-04-17	1
48341	2866	372328	1967-09-01	1967-10-15	1
14576	863	40481087	1948-01-11	1948-02-01	1
15959	946	260139	1969-03-22	1969-04-05	1
48973	2902	78272	1998-08-06	1998-08-27	1
44508	2651	40481087	2008-09-23	2008-10-07	1
44655	2659	4237458	1979-06-19	1979-09-17	1
61180	3622	4112343	2004-04-02	2004-04-15	1
22771	1359	4294548	1972-01-07	1972-05-19	1
86463	5150	40481087	1962-04-05	1962-04-19	1
49577	2936	40481087	1977-02-27	1977-03-20	1
45348	2699	4294548	1987-01-11	1987-02-15	1
45072	2684	40481087	2001-09-06	2001-09-13	1
40060	2380	40481087	1986-12-09	1986-12-30	1
35631	2114	40481087	2017-12-12	2017-12-26	1
49398	2925	28060	2011-02-17	2011-03-02	1
69936	4142	78272	1998-12-12	1999-01-02	1
16065	951	30753	1985-06-17	1985-06-18	1
52552	3115	28060	1987-03-20	1987-03-28	1
20020	1208	40481087	1962-11-26	1962-12-17	1
87941	5235	40481087	1931-06-08	1931-06-22	1
22357	1335	81151	1990-09-02	1990-10-07	1
53637	3178	40481087	1994-02-21	1994-02-28	1
62862	3717	260139	1989-11-14	1989-11-21	1
48342	2866	372328	1969-08-05	1970-01-11	1
14577	863	40481087	1958-05-18	1958-05-25	1
15960	946	260139	2001-03-21	2001-04-04	1
48974	2902	80180	1991-04-10	1991-04-11	1
44509	2651	40481087	2016-06-03	2016-06-24	1
44656	2659	4237458	2017-02-20	2017-04-21	1
61181	3622	40481087	1970-11-02	1970-11-09	1
22772	1359	4294548	1991-01-20	1991-05-19	1
86464	5150	40481087	2000-08-13	2000-08-20	1
49578	2936	40481087	1993-12-15	1994-01-05	1
45349	2699	40481087	1987-07-24	1987-08-14	1
45073	2684	195588	1995-02-04	1995-03-16	1
40061	2380	260139	2008-12-15	2008-12-29	1
35632	2114	260139	1996-05-06	1996-05-13	1
49399	2925	80180	1998-12-21	1998-12-22	1
69937	4142	260139	2003-08-28	2003-09-11	1
16066	951	260139	1971-11-20	1971-12-04	1
52553	3115	81893	2004-12-06	2004-12-07	1
20021	1208	40481087	1983-05-28	1983-06-11	1
87942	5235	81893	1959-04-05	1959-04-06	1
22358	1335	257012	2010-09-28	2010-09-29	1
53638	3178	81893	1992-03-12	1992-03-13	1
62863	3717	372328	1981-03-13	1981-04-18	1
48343	2866	378001	2002-03-01	2002-04-30	1
14578	863	40481087	1982-05-10	1982-05-31	1
15961	946	4278672	1975-04-23	1975-06-22	1
48975	2902	260139	2017-09-03	2017-09-10	1
44510	2651	28060	2014-07-28	2014-08-06	1
44657	2659	4294548	1979-12-26	1980-03-05	1
61182	3622	40481087	2007-09-24	2007-10-15	1
22773	1359	257012	1972-02-25	1972-02-26	1
86465	5150	81151	1947-08-31	1947-10-05	1
49579	2936	40481087	1995-08-03	1995-08-10	1
45350	2699	40481087	1989-09-09	1989-09-23	1
45074	2684	260139	1985-06-07	1985-06-21	1
40062	2380	378001	1983-09-01	1983-10-01	1
35633	2114	40481087	1973-11-16	1973-11-23	1
49400	2925	260139	1983-02-10	1983-02-17	1
69938	4142	4112343	1988-06-08	1988-06-19	1
16067	951	260139	1990-12-09	1990-12-23	1
52554	3115	257012	2009-07-04	2009-07-05	1
20022	1208	40481087	1985-07-07	1985-07-21	1
87943	5235	4027663	1949-09-09	1949-09-10	1
22359	1335	260139	2017-06-24	2017-07-01	1
53639	3178	260139	1972-04-22	1972-05-06	1
62864	3717	378001	1986-07-15	1986-09-13	1
48344	2866	378001	2005-02-13	2005-04-14	1
14579	863	40481087	1983-10-29	1983-11-12	1
15962	946	40481087	2001-11-21	2001-12-05	1
48976	2902	381316	2011-02-11	2011-02-12	1
44511	2651	81151	2006-07-11	2006-07-25	1
44658	2659	4296204	1977-09-08	1977-10-06	1
61183	3622	28060	1925-09-08	1925-09-20	1
22774	1359	260139	1962-01-22	1962-01-29	1
86466	5150	260139	2011-06-01	2011-06-08	1
49580	2936	260139	1971-03-03	1971-03-10	1
47230	2813	78272	1936-07-16	1936-08-20	1
45075	2684	260139	1991-04-25	1991-05-09	1
40063	2380	4146173	1960-06-03	1960-07-03	1
37416	2222	260139	1967-07-03	1967-07-10	1
49401	2925	4112343	1962-03-01	1962-03-11	1
69939	4142	40481087	2001-08-01	2001-08-22	1
16068	951	4218389	1966-12-14	1967-01-04	1
52555	3115	260139	1968-09-12	1968-09-19	1
20023	1208	40481087	1991-10-25	1991-11-01	1
87944	5235	4112343	1939-03-22	1939-04-02	1
22360	1335	4112343	2010-03-20	2010-03-27	1
53640	3178	313217	2006-09-23	2006-09-24	1
62865	3717	4112343	2010-02-02	2010-02-11	1
48345	2866	4027663	1995-07-31	1995-08-01	1
14580	863	28060	1923-04-14	1923-04-21	1
15963	946	40481087	2009-01-06	2009-01-13	1
48977	2902	4112343	1997-08-01	1997-08-10	1
44512	2651	260139	1951-04-27	1951-05-04	1
44659	2659	4310024	2004-12-15	2004-12-16	1
61184	3622	28060	2002-01-05	2002-01-12	1
22775	1359	4112343	1941-01-13	1941-01-24	1
86467	5150	4112343	1939-04-17	1939-04-26	1
49581	2936	4230399	1975-07-24	1975-09-22	1
47231	2813	257012	2015-02-08	2015-02-09	1
45076	2684	4112343	1986-01-03	1986-01-11	1
40064	2380	40481087	1972-05-29	1972-06-19	1
37417	2222	4112343	1971-09-12	1971-09-22	1
49402	2925	28060	1973-12-09	1973-12-18	1
69940	4142	40481087	2001-11-29	2001-12-13	1
16069	951	40481087	1968-10-10	1968-10-24	1
52556	3115	260139	2008-03-12	2008-03-26	1
20024	1208	40481087	1995-11-19	1995-12-10	1
87945	5235	40481087	1947-02-02	1947-02-23	1
22361	1335	4112343	2010-05-30	2010-06-12	1
53641	3178	372328	1956-12-11	1957-03-02	1
62866	3717	40481087	1981-04-19	1981-05-03	1
48346	2866	4112343	1969-12-22	1969-12-29	1
14581	863	81151	1923-07-09	1923-07-23	1
15964	946	40481087	2018-02-12	2018-03-05	1
48978	2902	40481087	1986-08-22	1986-09-12	1
44513	2651	260139	1956-04-11	1956-04-25	1
44660	2659	40481087	2016-11-30	2016-12-21	1
61185	3622	80502	1982-07-21	1982-07-22	1
22776	1359	4112343	1941-07-26	1941-08-05	1
86468	5150	4112343	1977-09-01	1977-09-08	1
49582	2936	40479768	1989-03-03	1989-05-09	1
47232	2813	4112343	1944-09-17	1944-09-30	1
45077	2684	4112343	1998-11-06	1998-11-16	1
40065	2380	40481087	2007-10-17	2007-10-24	1
37418	2222	4152936	1992-08-19	1992-09-09	1
49403	2925	133834	1963-05-02	1977-03-24	1
71972	4276	260139	1953-01-25	1953-02-01	1
16070	951	40481087	1969-01-31	1969-02-07	1
52557	3115	321042	1991-01-04	1991-01-05	1
20025	1208	40481087	2006-01-20	2006-02-03	1
87946	5235	40481087	1958-06-15	1958-07-06	1
22362	1335	40481087	2003-10-14	2003-10-21	1
53642	3178	4112343	1958-12-04	1958-12-11	1
62867	3717	40481087	2006-11-30	2006-12-21	1
48347	2866	40481087	1982-02-10	1982-03-03	1
14582	863	260139	1932-07-23	1932-07-30	1
15965	946	80180	2001-09-13	2001-09-14	1
48979	2902	257012	1970-09-01	1970-09-02	1
44514	2651	260139	1969-11-20	1969-12-04	1
45411	2703	81151	2006-08-15	2006-08-29	1
61186	3622	260139	1993-07-20	1993-07-27	1
22777	1359	4112343	1982-02-03	1982-02-10	1
86469	5150	4112343	1987-10-17	1987-10-28	1
49583	2936	40481087	1965-02-22	1965-03-08	1
47233	2813	4112343	1954-07-29	1954-08-07	1
45078	2684	4112343	2012-04-18	2012-04-29	1
40066	2380	80180	1987-04-08	1987-04-09	1
37419	2222	40481087	1964-01-28	1964-02-11	1
49404	2925	372328	1980-09-06	1982-03-14	1
71973	4276	260139	2001-02-03	2001-02-17	1
16071	951	0	2011-12-20	2011-12-21	1
52558	3115	4294548	2009-05-02	2009-10-24	1
20026	1208	40481087	2007-05-08	2007-05-15	1
87947	5235	40481087	1970-04-29	1970-05-06	1
22363	1335	260139	1981-07-08	1981-07-15	1
53643	3178	4112343	2003-05-03	2003-05-12	1
64653	3827	372328	1960-10-03	1961-08-11	2
48348	2866	40481087	1994-09-29	1994-10-13	1
14583	863	4109685	1967-08-11	1967-08-25	1
15966	946	4283893	2014-07-17	2014-10-23	1
48980	2902	260139	2000-09-21	2000-10-05	1
44515	2651	372328	1963-03-18	1964-02-19	1
45412	2703	81151	2008-09-17	2008-10-08	1
61187	3622	313217	1999-10-27	1999-10-28	1
22778	1359	4112343	1988-11-09	1988-11-19	1
86470	5150	4112343	2007-01-03	2007-01-12	1
49584	2936	40481087	1972-12-24	1973-01-14	1
47234	2813	4112343	2009-09-20	2009-10-02	1
45079	2684	4112343	2014-12-17	2014-12-29	1
40067	2380	195588	1998-05-15	1998-06-20	1
37420	2222	40481087	1975-09-14	1975-10-05	1
49405	2925	40481087	1981-09-11	1981-09-25	1
71974	4276	4112343	2000-05-21	2000-06-03	1
16072	951	260139	1984-01-20	1984-02-03	1
52559	3115	40481087	1980-08-15	1980-08-29	1
20027	1208	313217	1993-11-09	1993-11-10	1
87948	5235	0	1982-01-23	1982-01-24	1
22364	1335	4112343	1984-12-15	1984-12-27	1
53644	3178	4266809	1994-07-30	1994-07-31	1
64654	3827	4112343	1987-04-17	1987-04-26	1
48349	2866	80180	2005-10-21	2005-10-22	1
14584	863	4218389	1985-03-23	1985-04-13	1
15967	946	40481087	2010-07-12	2010-08-02	1
48981	2902	372328	1947-11-27	1947-12-11	1
44516	2651	40481087	1962-02-04	1962-02-25	1
45413	2703	4027663	2003-02-24	2003-02-25	1
61188	3622	321042	1953-04-22	1953-04-23	1
22779	1359	4294548	1946-11-09	1946-12-28	1
86471	5150	40481087	1976-10-20	1976-11-10	1
49585	2936	40481087	1988-01-23	1988-02-06	1
47235	2813	4218389	1994-02-17	1994-03-10	1
45080	2684	40481087	1996-11-09	1996-11-16	1
40068	2380	4112343	2013-07-03	2013-07-12	1
37421	2222	40481087	1992-01-22	1992-01-29	1
49406	2925	40481087	2017-09-14	2017-10-05	1
71975	4276	4112343	2016-01-15	2016-01-24	1
16073	951	372328	1954-11-17	1954-12-08	1
62589	3700	40481087	2010-07-26	2010-08-16	1
20028	1208	4112343	1954-07-10	1954-07-19	1
87949	5235	372328	1927-01-31	1927-08-27	1
22482	1345	317576	2008-03-25	2008-03-26	1
53645	3178	40481087	1989-03-20	1989-04-10	1
64655	3827	4152936	1977-10-09	1977-10-23	1
48350	2866	4112343	1979-06-24	1979-07-04	1
14585	863	4283893	1963-04-07	1963-04-21	1
15968	946	28060	1979-07-16	1979-07-28	1
48982	2902	372328	1950-05-29	1951-06-15	1
44517	2651	40481087	1975-10-15	1975-10-22	1
45414	2703	4296204	1987-05-24	1987-06-14	1
61189	3622	378001	1984-07-27	1984-08-26	1
22780	1359	4294548	1998-09-12	1998-10-03	1
86472	5150	40481087	2002-04-21	2002-04-28	1
49586	2936	40481087	1997-01-10	1997-01-17	1
47236	2813	4283893	1934-10-02	1934-11-13	1
45081	2684	78272	1969-12-27	1970-01-17	1
40069	2380	40481087	1958-02-10	1958-02-17	1
37422	2222	28060	2008-02-10	2008-02-20	1
49407	2925	28060	1999-11-05	1999-11-13	1
71976	4276	40481087	1958-02-02	1958-02-16	1
16074	951	372328	1957-11-22	1957-12-18	1
62590	3700	0	2011-08-22	2011-08-23	1
20029	1208	372328	1945-08-11	1945-12-11	1
87950	5235	4109685	1930-04-07	1930-04-21	1
22483	1345	372328	1968-06-19	1968-08-20	1
53646	3178	40481087	2007-01-28	2007-02-18	1
64656	3827	4152936	1986-07-08	1986-07-22	1
48351	2866	4112343	1992-05-30	1992-06-10	1
14586	863	40481087	1937-03-03	1937-03-10	1
15969	946	257012	2014-07-31	2014-08-01	1
48983	2902	372328	1953-02-04	1953-06-26	1
44518	2651	40481087	1991-06-05	1991-06-26	1
45415	2703	257012	1974-10-05	1974-10-06	1
61190	3622	4112343	1961-05-15	1961-05-28	1
22781	1359	40481087	1965-10-18	1965-11-01	1
86473	5150	28060	2010-09-24	2010-10-02	1
49587	2936	80180	1999-10-16	1999-10-17	1
47237	2813	4294548	2014-12-21	2015-03-08	1
45082	2684	260139	2014-07-23	2014-08-06	1
40070	2380	40481087	1965-06-15	1965-06-29	1
37423	2222	257012	2001-06-09	2001-06-10	1
49408	2925	260139	2001-04-25	2001-05-09	1
71977	4276	40481087	1967-12-04	1967-12-25	1
16075	951	4112343	1970-10-10	1970-10-20	1
62591	3700	372328	1970-03-13	1970-08-05	1
20030	1208	40481087	1957-05-31	1957-06-07	1
87951	5235	40481087	1957-02-21	1957-03-14	1
22484	1345	80180	2005-04-19	2005-04-20	1
53647	3178	40481087	2007-05-27	2007-06-10	1
64657	3827	80180	2001-08-29	2001-08-30	1
48352	2866	4285898	2005-09-21	2005-09-22	1
14587	863	40481087	1938-07-10	1938-07-24	1
15970	946	260139	1985-08-09	1985-08-23	1
48984	2902	4048171	1950-07-11	1965-07-09	1
44519	2651	80180	1989-07-24	1989-07-25	1
45416	2703	260139	1976-10-19	1976-11-02	1
61191	3622	4278672	1925-02-07	1925-04-08	1
24186	1443	80180	2014-05-31	2014-06-01	1
86474	5150	378001	1975-10-20	1975-11-19	1
49588	2936	81151	1976-08-17	1976-09-07	1
47238	2813	40481087	1946-09-23	1946-10-14	1
45083	2684	321042	1967-05-21	1967-05-22	1
40071	2380	40481087	2014-07-28	2014-08-04	1
37424	2222	260139	1979-05-13	1979-05-20	1
49409	2925	4109685	1963-10-22	1963-11-04	1
71978	4276	40481087	1997-11-22	1997-12-06	1
16076	951	40481087	1979-01-09	1979-01-23	1
62592	3700	4146173	2008-06-12	2008-07-12	1
20031	1208	40481087	1971-12-22	1971-12-29	1
87952	5235	40481087	1966-10-27	1966-11-10	1
22485	1345	80809	2005-03-05	2009-06-12	1
53648	3178	257012	1992-05-18	1992-05-19	1
64658	3827	81151	1998-07-19	1998-08-23	1
48353	2866	40481087	1984-08-25	1984-09-01	1
14588	863	40481087	1978-01-08	1978-01-22	1
15971	946	260139	2003-12-30	2004-01-06	1
48985	2902	28060	1986-03-17	1986-03-28	1
44520	2651	260139	1952-12-26	1953-01-02	1
45417	2703	260139	1986-02-17	1986-03-03	1
61192	3622	80180	1964-11-29	1964-11-30	1
24187	1443	81151	1993-07-19	1993-08-23	1
86475	5150	40481087	1953-04-25	1953-05-16	1
49589	2936	257012	1984-12-20	1984-12-21	1
47239	2813	40481087	1997-09-01	1997-09-22	1
45084	2684	372328	1962-08-06	1963-01-20	1
40072	2380	260139	1950-06-28	1950-07-12	1
37425	2222	4112343	1986-02-09	1986-02-20	1
49410	2925	4149245	2015-03-12	2015-05-18	1
71979	4276	40481087	2006-07-01	2006-07-08	1
16077	951	40481087	1991-09-15	1991-09-22	1
62593	3700	40481087	1987-06-28	1987-07-05	1
20032	1208	40481087	1982-01-10	1982-01-24	1
88695	5279	28060	1949-12-09	1949-12-22	1
22486	1345	260139	2013-10-13	2013-10-20	1
53649	3178	4027663	1986-03-19	1986-03-20	1
64659	3827	260139	1961-07-31	1961-08-07	1
48354	2866	40481087	1985-02-05	1985-02-12	1
14589	863	40481087	1984-03-20	1984-03-27	1
16280	964	80180	2012-08-15	2012-08-16	1
48986	2902	4112343	1954-01-25	1954-02-02	1
44521	2651	260139	2008-09-23	2008-10-07	1
45418	2703	372328	1977-07-15	1977-08-07	1
61193	3622	260139	1948-12-04	1948-12-11	1
24188	1443	372328	1981-06-03	1982-03-05	1
86476	5150	40481087	1953-06-22	1953-07-13	1
49590	2936	378001	1979-09-22	1979-11-21	1
47240	2813	28060	1947-05-21	1947-06-03	1
45085	2684	40481087	1985-10-28	1985-11-11	1
40073	2380	260139	1961-04-30	1961-05-07	1
37426	2222	40481087	1968-12-24	1968-12-31	1
49411	2925	4296205	2007-06-17	2007-07-22	1
71980	4276	28060	2016-09-24	2016-10-07	1
16078	951	40481087	2008-09-25	2008-10-16	1
62594	3700	40481087	1997-10-31	1997-11-14	1
21767	1309	196456	1994-03-21	1994-03-22	1
88696	5279	81151	1969-02-09	1969-03-02	1
22487	1345	4112343	1995-12-10	1995-12-19	1
53650	3178	4112343	1980-06-12	1980-06-20	1
64660	3827	260139	1961-10-07	1961-10-14	1
48355	2866	28060	1970-01-29	1970-02-09	1
14590	863	40481087	1994-02-12	1994-02-19	1
16281	964	372328	1981-04-17	1981-10-25	1
48987	2902	4294548	1970-05-05	1970-09-08	1
44522	2651	372328	1951-05-25	1952-05-14	1
45419	2703	4109685	2015-08-24	2015-09-07	1
61194	3622	260139	2005-01-23	2005-02-06	1
24189	1443	4112343	1990-08-19	1990-08-30	1
88217	5252	78272	1973-09-10	1973-09-24	1
49591	2936	4112343	1978-02-21	1978-03-04	1
47241	2813	260139	1980-06-14	1980-06-21	1
45439	2704	260139	2014-05-02	2014-05-09	1
40074	2380	260139	1969-05-27	1969-06-10	1
37427	2222	80180	2005-11-04	2005-11-05	1
49412	2925	40481087	1979-03-10	1979-03-17	1
71981	4276	80180	1996-10-30	1996-10-31	1
16079	951	80180	1985-10-15	1985-10-16	1
62595	3700	80180	2005-04-13	2005-04-14	1
21768	1309	198809	1994-03-21	1994-03-22	1
88697	5279	260139	1955-11-27	1955-12-11	1
22488	1345	4112343	2016-12-02	2016-12-15	1
53651	3178	4283893	1992-04-27	1992-11-23	1
64661	3827	260139	1963-10-06	1963-10-20	1
48356	2866	81151	2018-10-03	2018-10-31	1
14591	863	372328	1922-07-14	1922-10-26	1
16282	964	4112343	1981-11-13	1981-11-20	1
50707	3002	80180	2012-11-05	2012-11-06	1
44523	2651	4051466	1948-09-24	1966-03-02	1
45420	2703	4156265	2004-10-03	2004-10-24	1
61195	3622	381316	1991-07-03	1991-07-04	1
24190	1443	40481087	1981-03-12	1981-04-02	1
88218	5252	192671	1995-12-19	1995-12-20	1
49592	2936	4112343	2009-08-18	2009-08-26	1
47242	2813	317576	2017-03-03	2017-03-04	1
45440	2704	4109685	1994-12-11	1994-12-25	1
40075	2380	260139	2010-09-23	2010-09-30	1
37428	2222	260139	1973-05-08	1973-05-15	1
49413	2925	40481087	1984-08-15	1984-09-05	1
71982	4276	260139	1964-01-07	1964-01-21	1
16080	951	192671	1985-11-07	1985-11-08	1
62596	3700	440448	2011-08-22	2011-08-23	1
21769	1309	260139	2012-11-07	2012-11-14	1
88698	5279	375671	1958-06-23	1958-07-23	1
22489	1345	40481087	1977-08-13	1977-08-20	1
53652	3178	40481087	1978-10-07	1978-10-21	1
64662	3827	260139	1967-08-03	1967-08-17	1
48357	2866	40481087	1977-02-13	1977-02-27	1
14592	863	372328	1923-01-24	1923-07-26	1
16283	964	4294548	1987-02-03	1987-03-24	1
50708	3002	192671	2013-01-01	2013-01-02	1
44524	2651	4112343	1969-08-19	1969-08-27	1
45421	2703	40481087	1978-08-18	1978-08-25	1
61196	3622	4059173	2008-11-18	2008-12-18	1
24191	1443	40481087	1986-04-10	1986-04-17	1
88219	5252	260139	1961-04-17	1961-04-24	1
49593	2936	4112343	2019-01-08	2019-01-15	1
47243	2813	372328	1937-09-09	1937-12-31	1
45441	2704	4112343	2014-08-05	2014-08-16	1
40076	2380	4112343	1951-11-19	1951-12-02	1
37429	2222	260139	1987-06-07	1987-06-21	1
49414	2925	40481087	1992-06-04	1992-06-25	1
71983	4276	260139	1995-08-07	1995-08-21	1
16081	951	4027663	1978-12-26	1978-12-27	1
62597	3700	4027663	1996-08-23	1996-08-24	1
21770	1309	375671	1956-03-23	1956-04-22	1
88699	5279	375671	1976-02-24	1976-03-25	1
22490	1345	40481087	2011-03-20	2011-04-03	1
56630	3363	28060	1965-08-02	1965-08-15	1
64663	3827	4112343	1969-01-21	1969-02-03	1
48358	2866	40481087	1987-10-09	1987-10-30	1
14593	863	4112343	1942-04-14	1942-04-23	1
16284	964	4296204	1995-02-16	1995-03-02	1
50709	3002	260139	2014-11-27	2014-12-11	1
44525	2651	4278672	1956-04-03	1956-07-02	1
45422	2703	40481087	1998-07-26	1998-08-09	1
61197	3622	4112343	1939-12-24	1940-01-05	1
24192	1443	40481087	1999-06-02	1999-06-23	1
88220	5252	261325	1997-04-08	1997-04-09	1
49594	2936	4112343	2019-06-17	2019-06-18	1
47244	2813	372328	1961-09-26	1962-10-05	1
45442	2704	4112343	2015-08-15	2015-08-27	1
40077	2380	40481087	1953-09-13	1953-09-27	1
37430	2222	4112343	1987-10-16	1987-10-25	1
49744	2945	28060	1992-03-25	1992-04-04	1
71984	4276	260139	2016-11-14	2016-11-21	1
16082	951	4112343	1952-07-04	1952-07-15	1
62598	3700	4112343	1988-11-20	1988-11-30	1
21771	1309	4112343	1973-03-08	1973-03-19	1
88700	5279	378001	2012-05-15	2012-06-14	1
22491	1345	81893	2003-06-29	2003-06-30	1
56631	3363	80180	1995-08-08	1995-08-09	1
64664	3827	4112343	2011-04-05	2011-04-17	1
48359	2866	40481087	2009-07-02	2009-07-23	1
14594	863	4112343	1965-04-05	1965-04-17	1
16285	964	40481087	2015-06-28	2015-07-05	1
50710	3002	4112343	1980-04-28	1980-05-05	1
44526	2651	4296204	1972-11-03	1972-11-17	1
45423	2703	0	1974-03-03	1974-03-04	1
61198	3622	4112343	2000-07-29	2000-08-10	1
24193	1443	40481087	2018-11-04	2018-11-24	1
88221	5252	381316	2018-11-27	2018-11-28	1
49595	2936	40481087	1965-06-15	1965-07-06	1
47245	2813	40481087	1939-10-11	1939-10-25	1
45443	2704	40481087	1985-03-02	1985-03-16	1
40078	2380	40481087	2016-11-28	2016-12-12	1
37431	2222	4155034	2014-02-16	2014-03-02	1
49745	2945	260139	1984-10-10	1984-10-24	1
71985	4276	4142905	2005-05-21	2005-07-20	1
16083	951	4112343	1974-08-02	1974-08-11	1
62599	3700	4134304	1970-06-11	1970-08-10	1
21772	1309	4112343	1989-09-02	1989-09-09	1
88701	5279	4112343	1957-05-17	1957-05-28	1
22492	1345	260139	2015-03-15	2015-03-29	1
56632	3363	257012	2011-09-15	2011-09-16	1
64665	3827	4116491	1998-11-13	1998-12-26	1
51910	3080	260139	1959-11-05	1959-11-19	1
14595	863	4218389	1953-12-24	1954-01-21	1
16286	964	260139	1985-12-04	1985-12-18	1
50711	3002	4112343	2004-02-01	2004-02-11	1
44527	2651	4296204	2017-01-28	2017-03-04	1
45424	2703	28060	1979-09-20	1979-09-28	1
61199	3622	40481087	2004-10-31	2004-11-21	1
24194	1443	257012	1989-07-04	1989-07-05	1
88222	5252	40481087	1986-01-09	1986-01-23	1
49596	2936	40481087	1990-08-31	1990-09-07	1
47246	2813	40481087	1975-06-13	1975-07-04	1
45444	2704	40481087	2015-03-30	2015-04-20	1
42198	2518	0	1986-08-08	1986-08-09	1
37432	2222	40481087	1974-05-09	1974-05-16	1
49746	2945	260139	2007-12-31	2008-01-07	1
71986	4276	4166224	2006-12-14	2006-12-15	1
16084	951	4237458	1995-09-25	1995-11-24	1
62600	3700	4296205	2010-04-03	2010-04-24	1
21773	1309	4113008	2018-07-25	2018-08-08	1
88702	5279	4112343	1968-04-16	1968-04-24	1
22493	1345	372328	1967-11-05	1968-02-20	1
56633	3363	260139	1972-06-10	1972-06-17	1
64666	3827	4218389	1959-08-10	1959-09-14	1
51911	3080	4112343	1978-12-08	1978-12-17	1
14596	863	40481087	1921-09-25	1921-10-16	1
16287	964	4112343	1982-10-18	1982-10-29	1
50712	3002	4294548	1976-03-28	1976-04-18	1
44528	2651	40481087	1999-12-03	1999-12-17	1
45425	2703	80180	2014-04-12	2014-04-13	1
63778	3772	378001	2007-06-26	2007-07-26	1
24195	1443	260139	1983-03-25	1983-04-08	1
88223	5252	40481087	2000-10-04	2000-10-18	1
49597	2936	40481087	2017-05-11	2017-06-01	1
47247	2813	40481087	1976-01-09	1976-01-16	1
45445	2704	40481087	1975-01-04	1975-01-25	1
42199	2518	78272	1992-11-06	1992-12-04	1
37433	2222	40481087	1987-05-04	1987-05-11	1
49747	2945	4112343	1950-05-21	1950-06-03	1
71987	4276	440448	2006-12-14	2006-12-15	1
16085	951	40481087	1988-12-07	1988-12-21	1
62601	3700	40479768	1971-07-06	1971-09-11	1
21774	1309	40481087	1956-08-30	1956-09-06	1
88703	5279	4112343	1973-10-28	1973-11-05	1
22494	1345	4027663	1997-03-07	1997-03-08	1
56634	3363	4112343	1963-03-31	1963-04-12	1
64667	3827	40481087	1961-09-06	1961-09-13	1
51912	3080	4112343	1991-05-16	1991-05-23	1
14597	863	40481087	2003-04-12	2003-05-03	1
16288	964	40481087	2013-10-23	2013-10-30	1
50713	3002	40481087	2007-05-03	2007-05-24	1
44529	2651	40481087	2003-06-07	2003-06-14	1
45426	2703	81151	2014-10-07	2014-10-28	1
63779	3772	40481087	2005-08-25	2005-09-01	1
24196	1443	4218389	1990-11-03	1990-12-01	1
88224	5252	28060	1990-02-15	1990-02-28	1
49598	2936	28060	1967-03-09	1967-03-17	1
47248	2813	40481087	2011-05-18	2011-06-01	1
45446	2704	40481087	1977-03-24	1977-04-14	1
42200	2518	260139	2000-01-22	2000-02-05	1
37434	2222	317576	2012-07-24	2012-07-25	1
49748	2945	4112343	1964-01-21	1964-02-03	1
71988	4276	4112343	1960-02-19	1960-02-28	1
16086	951	40481087	1998-04-24	1998-05-15	1
62602	3700	40481087	1998-07-17	1998-07-24	1
21775	1309	40481087	1992-06-05	1992-06-12	1
88704	5279	4283893	2005-01-15	2005-02-05	1
22495	1345	4152936	1996-06-05	1996-06-26	1
56635	3363	4285898	1995-05-10	1995-05-11	1
64668	3827	40481087	1963-04-11	1963-04-18	1
51913	3080	4112343	1997-05-22	1997-05-29	1
14598	863	40481087	2015-02-06	2015-02-27	1
16289	964	372328	1979-11-07	1980-10-19	1
50714	3002	372328	1974-03-30	1974-06-11	1
44530	2651	260139	1954-02-28	1954-03-14	1
45427	2703	4112343	1977-07-16	1977-07-28	1
63780	3772	80180	2007-10-29	2007-10-30	1
24197	1443	40481087	1997-11-08	1997-11-29	1
88225	5252	80180	1995-11-09	1995-11-10	1
49599	2936	260139	1997-06-22	1997-06-29	1
47249	2813	80180	1967-11-01	1967-11-02	1
45447	2704	40481087	1989-07-28	1989-08-04	1
42201	2518	261325	1980-11-21	1980-11-22	1
37435	2222	372328	1963-12-20	1964-03-03	1
49749	2945	4112343	1998-11-02	1998-11-11	1
71989	4276	4112343	1977-07-30	1977-08-06	1
16087	951	40481087	2013-12-27	2014-01-17	1
62603	3700	40481087	2015-03-15	2015-03-29	1
21776	1309	80180	1995-03-09	1995-03-10	1
88705	5279	40481087	1983-08-16	1983-09-06	1
22496	1345	4278672	1993-07-21	1993-10-19	1
56636	3363	40481087	1996-02-03	1996-02-10	1
64669	3827	4112343	1973-01-17	1973-01-26	1
51914	3080	4113008	2018-10-09	2018-10-30	1
14599	863	313217	1981-01-29	1981-01-30	1
16290	964	4112343	1984-06-23	1984-07-06	1
50715	3002	372328	1977-03-01	1977-06-07	1
44531	2651	4112343	1982-09-04	1982-09-11	1
45428	2703	4218389	1999-08-10	1999-08-31	1
63781	3772	260139	2014-06-28	2014-07-12	1
24198	1443	40481087	2007-07-11	2007-07-18	1
88226	5252	4112343	1978-02-03	1978-02-16	1
49600	2936	4294548	1984-11-15	1985-01-03	1
47250	2813	260139	2002-08-10	2002-08-24	1
45448	2704	378001	1989-01-11	1989-03-12	1
42202	2518	4112343	2013-01-17	2013-01-26	1
37436	2222	4294548	2001-05-19	2001-08-11	1
49750	2945	40481087	1951-11-20	1951-12-04	1
71990	4276	4112343	1997-07-24	1997-08-01	1
22036	1320	260139	1971-10-06	1971-10-13	1
63190	3736	28060	1965-05-16	1965-05-26	1
21777	1309	260139	2017-06-23	2017-07-07	1
88706	5279	40481087	2010-10-04	2010-10-25	1
22497	1345	30753	2003-11-26	2003-11-27	1
56637	3363	40481087	2004-11-30	2004-12-07	1
64670	3827	4112343	2009-04-03	2009-04-11	1
51915	3080	40481087	1943-05-07	1943-05-14	1
14600	863	381316	2004-09-30	2004-10-01	1
16291	964	28060	1980-11-04	1980-11-14	1
50716	3002	78272	1981-12-09	1982-01-13	1
44532	2651	40481087	1995-11-05	1995-11-19	1
45429	2703	4283893	1974-07-06	1974-11-09	1
63782	3772	372328	1970-06-10	1970-07-25	1
24199	1443	78272	2018-10-02	2018-11-05	1
88227	5252	4112343	1992-01-23	1992-01-31	1
49601	2936	40481087	1993-09-27	1993-10-11	1
47251	2813	313217	2013-10-18	2013-10-19	1
45449	2704	4218389	2018-12-19	2019-01-16	1
42203	2518	40481087	1961-09-03	1961-09-24	1
37437	2222	40481087	1980-11-14	1980-11-28	1
49751	2945	40481087	1954-10-27	1954-11-17	1
71991	4276	4112343	2019-02-25	2019-03-04	1
22037	1320	372328	1937-02-15	1937-08-05	1
63191	3736	28060	1968-02-26	1968-03-10	1
21778	1309	372328	1984-04-25	1986-06-11	1
88707	5279	80180	1985-01-02	1985-01-03	1
22498	1345	260139	2001-02-10	2001-02-17	1
56638	3363	40481087	2018-09-03	2018-09-10	1
64671	3827	4142905	2015-08-24	2015-10-23	1
51916	3080	40481087	1958-09-01	1958-09-22	1
14601	863	4152936	1930-02-16	1930-03-09	1
16292	964	260139	1981-04-02	1981-04-16	1
50717	3002	4296204	1975-03-25	1975-04-15	1
45983	2743	192671	1992-04-27	1992-04-28	1
45430	2703	4310024	2012-06-21	2012-06-22	1
63783	3772	40481087	2003-06-10	2003-07-01	1
24200	1443	4109685	2001-05-13	2001-06-03	1
88228	5252	4237458	2005-03-31	2005-06-29	1
54776	3246	80180	2016-12-31	2017-01-01	1
47252	2813	40481087	1937-01-08	1937-01-15	1
45450	2704	40481087	1979-11-06	1979-11-20	1
42204	2518	40481087	1977-11-10	1977-12-01	1
38084	2264	80180	2009-06-15	2009-06-16	1
49752	2945	40481087	1964-09-07	1964-09-21	1
71992	4276	4230399	1977-07-17	1977-10-15	1
22038	1320	4112343	1976-01-25	1976-02-07	1
63192	3736	257012	1999-07-13	1999-07-14	1
21779	1309	4112343	1973-12-18	1973-12-26	1
88708	5279	260139	1965-11-19	1965-11-26	1
22499	1345	4059173	1977-09-13	1977-10-13	1
56639	3363	260139	1985-04-30	1985-05-14	1
64672	3827	40481087	1978-12-30	1979-01-13	1
51917	3080	40481087	2007-05-12	2007-06-02	1
14602	863	4296204	1944-12-20	1945-01-10	1
16293	964	40481087	2009-12-30	2010-01-06	1
50718	3002	40481087	1983-07-18	1983-08-01	1
45984	2743	4027663	1985-03-31	1985-04-01	1
45431	2703	192671	2014-05-11	2014-05-12	1
63784	3772	260139	1984-07-27	1984-08-03	1
24201	1443	4112343	2011-03-14	2011-03-25	1
88229	5252	40481087	1966-02-24	1966-03-10	1
54777	3246	260139	1984-12-14	1984-12-21	1
47253	2813	260139	1940-05-27	1940-06-03	1
45451	2704	80180	2011-05-26	2011-05-27	1
42205	2518	40481087	1978-04-23	1978-05-14	1
38085	2264	372328	1972-06-15	1972-10-15	1
49753	2945	40481087	1979-03-05	1979-03-19	1
71993	4276	0	2006-12-14	2006-12-15	1
22039	1320	4146173	1972-04-01	1972-05-31	1
63193	3736	260139	1969-01-11	1969-01-25	1
21780	1309	4152936	1964-01-11	1964-01-25	1
88709	5279	260139	1974-04-14	1974-04-28	1
22500	1345	4285898	2004-08-22	2004-08-23	1
56640	3363	372328	1951-05-01	1951-06-08	1
64673	3827	40481087	1996-03-20	1996-03-27	1
51918	3080	40481087	2019-03-24	2019-04-14	1
14603	863	40481087	2016-08-29	2016-09-05	1
18659	1124	78272	1992-10-16	1992-10-30	1
50719	3002	40481087	1998-04-22	1998-05-13	1
45985	2743	4285898	1992-01-19	1992-01-20	1
45432	2703	260139	1983-11-04	1983-11-11	1
63785	3772	4084167	1983-01-03	1983-01-03	1
24202	1443	4283893	2012-02-27	2012-04-03	1
88230	5252	40481087	1973-06-08	1973-06-15	1
54778	3246	260139	2013-07-03	2013-07-10	1
47254	2813	4112343	1942-03-18	1942-03-30	1
45452	2704	4112343	1973-07-07	1973-07-15	1
42206	2518	40481087	1987-03-06	1987-03-27	1
38086	2264	4112343	1971-04-05	1971-04-16	1
49754	2945	40481087	1988-10-02	1988-10-23	1
71994	4276	40481087	1973-03-04	1973-03-25	1
22040	1320	40481087	1953-12-01	1953-12-22	1
63194	3736	321042	2006-06-28	2006-06-29	1
21781	1309	40481087	1967-09-06	1967-09-27	1
88710	5279	4112343	1965-02-16	1965-02-28	1
22501	1345	40481087	1967-11-12	1967-11-26	1
56641	3363	4266809	1995-08-08	1995-08-09	1
64674	3827	40481087	2004-03-24	2004-04-14	1
51919	3080	81151	2015-09-27	2015-10-25	1
15972	947	81151	1968-07-21	1968-08-04	1
18660	1124	260139	1938-06-23	1938-06-30	1
50720	3002	40481087	2011-12-27	2012-01-10	1
45986	2743	4296204	1989-05-02	1989-05-16	1
45433	2703	4029498	1974-03-03	1974-03-04	1
63786	3772	4112343	2018-06-01	2018-06-13	1
24203	1443	4294548	1989-06-06	1989-08-15	1
88231	5252	40481087	1978-02-24	1978-03-03	1
54779	3246	4027663	2009-10-14	2009-10-15	1
47255	2813	4142905	2015-07-18	2015-09-16	1
45453	2704	4112343	2002-07-16	2002-07-26	1
42207	2518	40481087	1995-08-06	1995-08-20	1
38087	2264	4112343	1998-11-19	1998-12-01	1
49755	2945	40481087	1992-10-20	1992-11-10	1
71995	4276	40481087	1979-12-28	1980-01-18	1
22041	1320	40481087	1961-02-05	1961-02-12	1
63195	3736	40481087	1963-12-16	1964-01-06	1
21782	1309	28060	1964-05-13	1964-05-21	1
88711	5279	4112343	2016-10-22	2016-11-04	1
22502	1345	40481087	1984-05-24	1984-05-31	1
56642	3363	81151	1964-05-27	1964-06-17	1
66225	3926	80180	1988-01-07	1988-01-08	1
51920	3080	195588	1968-12-05	1969-01-22	1
15973	947	260139	2008-05-02	2008-05-16	1
18661	1124	260139	1958-04-24	1958-05-08	1
50721	3002	372328	1975-04-07	1975-06-10	1
45987	2743	40481087	1965-02-16	1965-02-23	1
45434	2703	4266809	2014-04-12	2014-04-13	1
63787	3772	372328	1974-07-04	1975-02-01	1
24204	1443	40481087	1986-01-13	1986-02-03	1
88232	5252	40481087	1979-03-19	1979-04-09	1
54780	3246	4094814	2017-02-23	2017-02-24	1
47256	2813	40481087	1944-03-09	1944-03-30	1
45454	2704	4112343	2003-12-22	2003-12-29	1
42208	2518	260139	1993-05-25	1993-06-08	1
38088	2264	195588	1989-05-06	1989-06-07	1
49756	2945	40481087	1997-08-23	1997-09-06	1
75627	4491	260139	2001-05-28	2001-06-05	1
22042	1320	80180	1973-08-15	1973-08-16	1
63196	3736	40481087	1964-12-08	1964-12-15	1
21783	1309	260139	1957-02-18	1957-03-04	1
88712	5279	4266809	1985-01-02	1985-01-03	1
28113	1661	81151	1993-06-02	1993-06-16	1
56643	3363	375671	1966-04-08	1966-06-07	1
66226	3926	260139	1962-09-11	1962-09-25	1
51921	3080	257012	1988-11-23	1988-11-24	1
15974	947	40481087	1972-12-03	1972-12-17	1
18662	1124	260139	1998-11-20	1998-12-04	1
50722	3002	4112343	2014-01-22	2014-02-03	1
45988	2743	257012	1980-01-04	1980-01-05	1
45435	2703	4285898	2013-10-14	2013-10-15	1
63788	3772	4278672	1980-07-17	1980-09-15	1
24205	1443	78272	1988-09-24	1988-10-15	1
88233	5252	40481087	2000-01-19	2000-02-02	1
54781	3246	4237458	1984-06-27	1984-08-26	1
47257	2813	40481087	1957-04-28	1957-05-12	1
45455	2704	4116491	2004-08-05	2004-09-21	1
42209	2518	4156265	1973-06-07	1973-06-28	1
38089	2264	4112343	2007-10-03	2007-10-13	1
49757	2945	40481087	1997-10-11	1997-10-18	1
75628	4491	4059173	1992-04-07	1992-06-06	1
22043	1320	81151	1959-10-09	1959-11-06	1
63197	3736	40481087	1972-05-24	1972-06-07	1
21784	1309	260139	1970-08-25	1970-09-01	1
88713	5279	4285898	1984-10-04	1984-10-05	1
28114	1661	81151	2018-01-06	2018-01-20	1
56644	3363	4027663	1985-02-21	1985-02-22	1
66227	3926	260139	1992-12-07	1992-12-14	1
51922	3080	378001	1994-01-29	1994-03-30	1
15975	947	40481087	1993-11-15	1993-12-06	1
18663	1124	381316	1999-08-29	1999-08-30	1
50723	3002	40481087	2008-02-25	2008-03-10	1
45989	2743	260139	1961-08-31	1961-09-14	1
45436	2703	40481087	1975-09-10	1975-09-24	1
63789	3772	40481087	1976-06-15	1976-06-22	1
24206	1443	40481087	2000-10-22	2000-11-04	1
88234	5252	40481087	2011-01-14	2011-01-28	1
54782	3246	78272	2010-01-03	2010-01-31	1
48238	2862	28060	1967-10-28	1967-11-04	1
46848	2790	28060	1967-08-28	1967-09-06	1
42210	2518	40481087	1956-09-10	1956-09-24	1
38090	2264	4112343	2008-01-14	2008-01-21	1
49758	2945	40481087	2002-11-30	2002-12-07	1
75629	4491	4112343	1957-02-18	1957-02-27	1
22044	1320	260139	1990-05-06	1990-05-20	1
63198	3736	40481087	1978-01-06	1978-01-20	1
21785	1309	260139	1993-09-11	1993-09-18	1
88714	5279	40481087	1958-05-30	1958-06-13	1
28115	1661	260139	1963-02-19	1963-02-26	1
56645	3363	4112343	2009-11-25	2009-12-05	1
66228	3926	372328	1948-05-26	1948-09-06	1
51923	3080	4152936	1991-12-20	1992-01-10	1
15976	947	4152936	2009-09-28	2009-10-19	1
18664	1124	4156265	1939-09-15	1939-10-06	1
50959	3020	80180	1996-04-12	1996-04-13	1
45990	2743	372328	1964-02-15	1964-02-29	1
45437	2703	40481087	1984-11-26	1984-12-03	1
64005	3786	28060	2013-05-01	2013-05-12	1
24977	1493	257012	1998-03-06	1998-03-07	1
88235	5252	260139	1961-12-06	1961-12-13	1
54783	3246	192671	2017-02-16	2017-02-17	1
48239	2862	78272	2000-12-25	2001-01-22	1
46849	2790	4001336	1959-12-15	1960-01-14	1
42211	2518	40481087	1964-05-17	1964-05-24	1
38091	2264	40481087	1984-04-28	1984-05-19	1
49759	2945	81151	1974-03-01	1974-04-05	1
75630	4491	4112343	1968-02-11	1968-02-23	1
22045	1320	260139	1992-01-20	1992-01-27	1
63199	3736	40481087	1983-02-01	1983-02-08	1
21786	1309	4112343	1981-12-31	1982-01-08	1
88715	5279	192671	1985-03-02	1985-03-03	1
28116	1661	260139	1994-02-11	1994-02-25	1
56646	3363	4237458	1958-06-28	1958-09-26	1
66229	3926	4112343	1959-08-13	1959-08-22	1
51924	3080	40481087	1959-01-27	1959-02-03	1
15977	947	40481087	1978-09-24	1978-10-01	1
18665	1124	4278672	1945-08-19	1945-10-18	1
50960	3020	260139	1991-12-19	1991-12-26	1
45991	2743	4237458	1977-07-04	1977-10-02	1
45438	2703	40481087	1987-12-25	1988-01-15	1
64006	3786	78272	1998-06-10	1998-07-15	1
24978	1493	260139	2003-12-28	2004-01-11	1
88236	5252	440086	1964-12-01	1965-10-26	1
54784	3246	260139	1982-02-10	1982-02-17	1
48240	2862	4112343	1989-07-29	1989-08-05	1
46850	2790	4112343	1953-05-21	1953-06-01	1
42212	2518	40481087	1978-01-07	1978-01-14	1
38092	2264	40481087	1984-09-23	1984-10-14	1
49760	2945	260139	1964-11-05	1964-11-12	1
75631	4491	4112343	1995-04-18	1995-04-26	1
22046	1320	372328	1939-02-26	1939-08-10	1
63200	3736	40481087	1986-01-02	1986-01-16	1
21787	1309	4112343	1998-07-26	1998-08-02	1
88716	5279	260139	1988-05-15	1988-05-22	1
28117	1661	4027663	1985-06-22	1985-06-23	1
56647	3363	4283893	1956-05-09	1956-06-06	1
66230	3926	4152936	1963-07-14	1963-07-28	1
51925	3080	40481087	1998-08-01	1998-08-22	1
15978	947	40481087	2002-10-28	2002-11-11	1
18666	1124	40481087	1989-10-17	1989-10-24	1
50961	3020	372328	1957-06-01	1957-09-11	1
45992	2743	40481087	1983-03-21	1983-04-04	1
48091	2858	81151	2004-11-29	2004-12-20	1
64007	3786	80180	1995-04-19	1995-04-20	1
24979	1493	260139	2006-08-09	2006-08-16	1
88237	5252	4116491	2015-12-03	2016-01-06	1
54785	3246	260139	2002-10-10	2002-10-17	1
48241	2862	4285898	2005-12-03	2005-12-04	1
46851	2790	4132546	1959-12-15	1959-12-16	1
42213	2518	40481087	1999-09-03	1999-09-10	1
38093	2264	40481087	2002-07-02	2002-07-09	1
49761	2945	260139	1973-11-18	1973-12-02	1
75632	4491	4112343	2003-05-15	2003-05-27	1
22047	1320	4059173	1998-09-12	1998-11-11	1
63201	3736	0	2006-06-28	2006-06-29	1
21788	1309	4156265	1989-12-09	1989-12-23	1
88717	5279	4027663	1977-01-19	1977-01-20	1
28118	1661	4142905	2018-11-16	2019-02-14	1
56648	3363	4283893	2011-08-11	2011-12-01	1
66231	3926	261325	1981-10-12	1981-10-13	1
51926	3080	80180	1981-09-18	1981-09-19	1
15979	947	28060	1974-02-22	1974-03-06	1
18667	1124	40481087	2013-06-29	2013-07-06	1
50962	3020	40481087	2007-04-04	2007-04-11	1
45993	2743	28060	2008-03-19	2008-03-26	1
48092	2858	378001	2005-11-15	2005-12-15	1
64008	3786	260139	2002-07-25	2002-08-08	1
24980	1493	372328	1961-11-28	1962-09-25	1
88238	5252	4155034	1987-10-11	1987-11-01	1
54786	3246	372328	1984-08-15	1984-10-01	1
48242	2862	40481087	1994-11-22	1994-11-29	1
46852	2790	28060	1982-11-18	1982-11-27	1
42214	2518	28060	1993-12-21	1993-12-28	1
38094	2264	372328	1972-03-26	1972-04-16	1
49762	2945	260139	1981-06-25	1981-07-09	1
75633	4491	4296204	1983-04-11	1983-04-25	1
22048	1320	4112343	1983-04-15	1983-04-23	1
63202	3736	260139	1985-07-31	1985-08-07	1
21789	1309	4278672	1958-04-12	1958-06-12	1
88718	5279	4113008	1965-05-17	1965-05-31	1
28119	1661	4296204	1986-06-18	1986-07-09	1
56649	3363	4310024	1993-09-17	1993-09-18	1
66232	3926	372328	1950-05-29	1950-09-04	1
51927	3080	260139	1980-11-29	1980-12-06	1
15980	947	80180	2000-06-08	2000-06-09	1
18668	1124	260139	1975-07-25	1975-08-01	1
50963	3020	260139	1959-02-23	1959-03-02	1
45994	2743	80180	1992-02-18	1992-02-19	1
48093	2858	4112343	1962-11-02	1962-11-11	1
64009	3786	439777	2015-11-25	2015-11-26	1
24981	1493	4109685	1994-04-09	1994-04-23	1
88239	5252	4278672	1969-10-01	1969-12-30	1
54787	3246	440086	1989-10-19	1997-10-27	1
48243	2862	40481087	1998-10-18	1998-11-07	1
46853	2790	78272	1966-07-11	1966-08-08	1
42215	2518	28060	2004-08-06	2004-08-19	1
38095	2264	4112343	1975-04-26	1975-05-09	1
49763	2945	4218389	2010-12-06	2011-01-10	1
75634	4491	81151	1949-11-23	1949-12-14	1
22049	1320	4134304	1993-08-09	1993-10-08	1
63203	3736	4112343	1954-09-20	1954-10-01	1
21790	1309	40481087	1963-02-07	1963-02-21	1
88719	5279	4116491	1990-01-16	1990-03-05	1
28120	1661	40481087	1982-07-09	1982-07-16	1
56650	3363	40481087	1983-05-19	1983-06-02	1
66233	3926	378001	1968-07-31	1968-08-30	1
51928	3080	372328	2007-04-12	2007-09-27	1
15981	947	260139	2002-07-24	2002-07-31	1
18669	1124	260139	1991-05-11	1991-05-25	1
50964	3020	260139	1981-10-29	1981-11-05	1
45995	2743	260139	2004-10-24	2004-10-31	1
48094	2858	4112343	1967-09-18	1967-09-26	1
64010	3786	4112343	1969-05-13	1969-05-20	1
24982	1493	4112343	1982-06-22	1982-07-02	1
88240	5252	40481087	1978-09-04	1978-09-11	1
54788	3246	4112343	1988-01-10	1988-01-22	1
48244	2862	40481087	2010-05-16	2010-05-30	1
46854	2790	80180	1985-08-30	1985-08-31	1
42216	2518	80180	1988-05-29	1988-05-30	1
38096	2264	4112343	1981-05-09	1981-05-21	1
49764	2945	28060	1945-10-19	1945-11-01	1
75635	4491	81893	1983-02-28	1983-03-01	1
22050	1320	40480160	2006-03-04	2006-04-03	1
63204	3736	4112343	1957-02-21	1957-03-06	1
21791	1309	40481087	1980-09-24	1980-10-15	1
88720	5279	40481087	1994-12-14	1995-01-04	1
28121	1661	81893	1993-08-14	1993-08-15	1
56651	3363	30753	1994-07-14	1994-07-15	1
66234	3926	4116491	1991-09-18	1991-11-12	1
51929	3080	439777	1941-12-12	1941-12-13	1
15982	947	4283893	2008-02-22	2008-06-20	1
18670	1124	4218389	2005-03-26	2005-04-23	1
50965	3020	4112343	1959-03-27	1959-04-05	1
45996	2743	4112343	1998-07-31	1998-08-07	1
48095	2858	4218389	1944-09-20	1944-10-18	1
64011	3786	4112343	1979-05-13	1979-05-21	1
24983	1493	4142905	1972-07-03	1972-09-01	1
88241	5252	40481087	2004-04-09	2004-04-30	1
54789	3246	4112343	1997-06-05	1997-06-17	1
48245	2862	260139	1972-05-03	1972-05-10	1
46855	2790	81151	1984-12-01	1985-01-05	1
42217	2518	321042	1986-08-08	1986-08-09	1
38097	2264	4112343	2000-04-28	2000-05-09	1
49765	2945	4109685	1979-12-05	1979-12-19	1
75636	4491	195588	1976-01-06	1976-02-29	1
22051	1320	40481087	1981-01-02	1981-01-23	1
63205	3736	4112343	1967-09-16	1967-09-26	1
21792	1309	40481087	1996-07-29	1996-08-12	1
88721	5279	40481087	2002-03-05	2002-03-26	1
28122	1661	260139	1979-01-05	1979-01-12	1
56652	3363	81151	1956-05-04	1956-06-08	1
66235	3926	40481087	1954-07-15	1954-07-22	1
51930	3080	4112343	1951-09-17	1951-09-29	1
15983	947	40481087	1988-08-15	1988-09-05	1
18671	1124	260139	1951-09-20	1951-10-04	1
50966	3020	4112343	2005-09-05	2005-09-16	1
45997	2743	4116491	1995-03-29	1995-05-19	1
48096	2858	4278672	1925-09-29	1925-10-29	1
64012	3786	4112343	1997-06-28	1997-07-07	1
24984	1493	4283893	1998-01-23	1998-03-13	1
88242	5252	28060	1967-03-19	1967-03-31	1
54790	3246	4218389	1990-04-27	1990-05-18	1
48246	2862	260139	1994-03-16	1994-03-23	1
46856	2790	4059173	2009-04-13	2009-06-12	1
42218	2518	4112343	2010-12-18	2010-12-25	1
38098	2264	40481087	2016-09-02	2016-09-23	1
49766	2945	4112343	1948-10-17	1948-10-24	1
75637	4491	4218389	1975-05-02	1975-05-23	1
22052	1320	80502	1995-06-15	1995-06-16	1
63206	3736	4112343	2002-06-18	2002-07-01	1
21793	1309	40481087	2017-05-03	2017-05-10	1
88722	5279	260139	1954-05-16	1954-05-30	1
28123	1661	4112343	2010-06-03	2010-06-11	1
56653	3363	81151	1969-02-21	1969-03-14	1
66236	3926	40481087	1972-04-14	1972-05-05	1
51931	3080	4112343	1998-03-27	1998-04-08	1
15984	947	28060	1976-06-27	1976-07-10	1
18672	1124	4112343	1950-08-20	1950-09-01	1
50967	3020	40481087	1964-06-02	1964-06-09	1
45998	2743	30753	1991-12-20	1991-12-21	1
48097	2858	4283893	2017-02-19	2017-08-14	1
64013	3786	4113008	1978-02-27	1978-03-13	1
24985	1493	40481087	1993-01-29	1993-02-12	1
88243	5252	260139	1987-01-08	1987-01-15	1
54791	3246	30753	2015-11-07	2015-11-08	1
48247	2862	4310024	2004-06-12	2004-06-13	1
46857	2790	4112343	1958-03-08	1958-03-17	1
42219	2518	4113008	1983-08-05	1983-08-26	1
38099	2264	40481087	1997-09-14	1997-09-21	1
49767	2945	4112343	2002-02-25	2002-03-09	1
75638	4491	40481087	2007-06-03	2007-06-10	1
22053	1320	260139	1946-05-31	1946-06-07	1
63207	3736	4113008	1991-12-31	1992-01-21	1
21794	1309	260139	1987-09-17	1987-09-24	1
88723	5279	260139	1975-08-07	1975-08-21	1
28124	1661	40481087	2000-10-17	2000-11-07	1
56654	3363	192671	1995-10-29	1995-10-30	1
66237	3926	40481087	1987-01-21	1987-02-11	1
51932	3080	4112343	2019-01-19	2019-01-27	1
15985	947	28060	2006-06-06	2006-06-13	1
18673	1124	4112343	1965-03-19	1965-03-30	1
50968	3020	40481087	1972-12-30	1973-01-06	1
45999	2743	81151	1968-02-24	1968-03-23	1
48098	2858	40481087	1947-05-24	1947-05-31	1
64014	3786	40481087	1966-09-30	1966-10-14	1
24986	1493	40481087	2006-08-20	2006-09-03	1
88244	5252	378001	2010-02-03	2010-03-05	1
54792	3246	40481087	1997-12-17	1998-01-07	1
48248	2862	40481087	1977-02-09	1977-02-23	1
46858	2790	4112343	1983-05-28	1983-06-10	1
42220	2518	4278672	1961-01-11	1961-02-10	1
38907	2315	260139	1984-08-23	1984-08-30	1
49768	2945	4156265	1950-08-20	1950-09-03	1
75639	4491	28060	2015-02-09	2015-02-19	1
22054	1320	260139	1985-10-11	1985-10-18	1
63208	3736	40481087	1989-06-08	1989-06-15	1
21795	1309	4112343	1974-01-29	1974-02-11	1
88724	5279	378001	1955-05-10	1955-07-09	1
28125	1661	81151	1981-06-09	1981-07-14	1
66238	3926	28060	1952-07-07	1952-07-16	1
51933	3080	4156265	2002-07-16	2002-08-06	1
15986	947	378001	1984-03-13	1984-05-12	1
18674	1124	4155034	1991-10-01	1991-10-22	1
50969	3020	40481087	1993-08-26	1993-09-09	1
46000	2743	4112343	1973-11-25	1973-12-07	1
48099	2858	40481087	1978-08-09	1978-08-23	1
64015	3786	40481087	1996-08-19	1996-08-26	1
24987	1493	40481087	2014-04-29	2014-05-06	1
88245	5252	4156265	2015-11-04	2015-11-25	1
54793	3246	260139	2009-05-16	2009-05-30	1
48249	2862	80180	2006-04-03	2006-04-04	1
46859	2790	4155034	1999-09-19	1999-10-03	1
42221	2518	4296205	1997-10-09	1997-11-13	1
38908	2315	40481087	1995-10-20	1995-11-10	1
49769	2945	40481087	1954-07-30	1954-08-20	1
75640	4491	80502	2006-07-09	2006-07-10	1
22055	1320	378001	1943-11-11	1943-12-11	1
63209	3736	40481087	2014-10-09	2014-10-30	1
21796	1309	40481087	1984-11-01	1984-11-08	1
88725	5279	378001	1999-03-25	1999-04-24	1
28126	1661	260139	2003-08-16	2003-08-30	1
66239	3926	260139	2005-01-23	2005-02-06	1
51934	3080	4283893	1988-11-02	1988-12-28	1
18682	1125	81151	1956-07-20	1956-08-03	1
18675	1124	40481087	1969-09-12	1969-09-26	1
50970	3020	260139	1969-03-20	1969-03-27	1
46001	2743	4266809	1992-02-18	1992-02-19	1
48100	2858	40481087	1982-05-09	1982-05-23	1
64016	3786	40481087	2002-10-03	2002-10-17	1
24988	1493	40481087	2016-05-31	2016-06-21	1
88246	5252	40481087	2008-02-14	2008-02-21	1
54794	3246	260139	2012-07-29	2012-08-05	1
48250	2862	260139	2016-08-06	2016-08-13	1
46860	2790	40481087	2013-04-22	2013-04-29	1
42222	2518	40481087	1992-08-04	1992-08-18	1
38909	2315	80180	2012-04-11	2012-04-12	1
49770	2945	40481087	1959-05-27	1959-06-03	1
75641	4491	40481087	1984-05-23	1984-06-06	1
22056	1320	378419	2016-10-13	2016-10-14	1
63210	3736	28060	1964-06-09	1964-06-17	1
23216	1387	80180	2008-10-13	2008-10-14	1
88726	5279	4278672	1963-04-28	1963-06-27	1
28127	1661	260139	2016-08-03	2016-08-17	1
66240	3926	4112343	1986-05-15	1986-05-22	1
51935	3080	40481087	1946-02-03	1946-02-10	1
18683	1125	260139	2006-02-24	2006-03-10	1
18676	1124	80180	1968-10-12	1968-10-13	1
50971	3020	372328	1959-01-04	1959-06-10	1
46002	2743	4294548	1979-12-14	1980-02-29	1
48101	2858	40481087	2000-12-08	2000-12-15	1
64017	3786	81151	2017-10-08	2017-11-12	1
24989	1493	378001	1996-03-13	1996-05-12	1
88247	5252	40481087	2012-04-29	2012-05-06	1
54795	3246	372328	1981-05-14	1982-03-29	2
48251	2862	4156265	1999-03-15	1999-04-06	1
46861	2790	40481087	2018-02-08	2018-02-22	1
42223	2518	40481087	2014-10-18	2014-11-01	1
38910	2315	260139	2018-10-30	2018-11-13	1
49771	2945	80180	1981-11-25	1981-11-26	1
75642	4491	30753	1983-08-27	1983-08-28	1
22057	1320	4112343	1979-08-22	1979-09-02	1
63211	3736	28060	1985-04-12	1985-04-24	1
23217	1387	4056621	2013-06-02	2013-06-03	1
88727	5279	40481087	1967-11-01	1967-11-22	1
28128	1661	313217	2007-07-12	2007-07-13	1
66241	3926	4112343	1986-09-23	1986-10-01	1
51936	3080	40481087	2009-03-01	2009-03-08	1
18684	1125	4278672	2014-07-30	2014-08-29	1
18677	1124	81151	1971-10-02	1971-10-16	1
50972	3020	4109685	1963-01-01	1963-01-15	1
46003	2743	4294548	2009-03-04	2009-03-11	1
48102	2858	40481087	2017-10-22	2017-10-29	1
60598	3592	30753	2000-11-09	2000-11-10	1
24990	1493	4059173	1962-10-24	1962-11-23	1
57664	3423	4155034	1989-12-02	1989-12-16	1
54796	3246	4112343	2001-06-30	2001-07-07	1
48252	2862	4218389	1974-12-16	1975-01-20	1
46862	2790	80502	2013-04-11	2013-04-12	1
42224	2518	195588	1976-10-07	1976-11-11	1
38911	2315	4112343	2004-07-09	2004-07-21	1
49772	2945	261325	1967-09-19	1967-09-20	1
75643	4491	80180	1984-07-22	1984-07-23	1
22058	1320	4152936	1947-09-21	1947-10-12	1
63212	3736	80180	1987-07-20	1987-07-21	1
23218	1387	4112343	1995-11-24	1995-12-04	1
88728	5279	40481087	1975-01-19	1975-01-26	1
28129	1661	372328	1957-09-17	1957-12-05	1
66242	3926	4112343	2017-07-10	2017-07-22	1
51937	3080	81151	1950-06-23	1950-07-07	1
18685	1125	40481087	1956-09-25	1956-10-09	1
18678	1124	260139	1940-07-21	1940-07-28	1
50973	3020	4112343	1975-08-27	1975-09-09	1
46004	2743	40481087	1986-12-22	1987-01-12	1
48103	2858	257012	1929-02-22	1929-02-23	1
60599	3592	81151	1973-12-11	1974-01-01	1
24991	1493	40481087	1964-09-03	1964-09-17	1
57665	3423	4285898	2011-07-05	2011-07-06	1
54797	3246	4310024	2014-11-12	2014-11-13	1
48253	2862	40481087	2012-11-21	2012-12-12	1
46863	2790	4112343	1994-01-17	1994-01-27	1
42225	2518	260139	1993-08-09	1993-08-16	1
38912	2315	40481087	1980-04-21	1980-05-05	1
49773	2945	372328	1950-11-18	1951-07-03	1
75644	4491	260139	1984-04-25	1984-05-02	1
22059	1320	4283893	2000-04-03	2000-04-24	1
63213	3736	260139	1962-06-07	1962-06-14	1
23219	1387	40481087	1975-06-04	1975-06-11	1
88729	5279	40481087	1980-05-05	1980-05-26	1
28130	1661	4112343	1994-08-28	1994-09-06	1
66243	3926	4296204	1982-11-13	1982-12-11	1
51938	3080	372328	1944-08-23	1944-11-16	1
18686	1125	40481087	2013-10-19	2013-11-09	1
18679	1124	260139	1954-05-29	1954-06-12	1
50974	3020	258780	2001-01-17	2001-01-18	1
46005	2743	40481087	1995-11-01	1995-11-15	1
48104	2858	260139	1991-02-19	1991-03-05	1
60600	3592	81151	1989-01-12	1989-01-26	1
24992	1493	40481087	1980-07-31	1980-08-07	1
57666	3423	40481087	1977-04-13	1977-04-27	1
54798	3246	40481087	1986-08-21	1986-09-11	1
48254	2862	28060	1968-01-05	1968-01-16	1
46864	2790	4116491	1989-07-15	1989-09-03	1
42226	2518	4116491	1973-08-16	1973-10-08	1
38913	2315	40481087	2004-01-15	2004-01-22	1
49774	2945	372328	1998-06-26	1998-08-04	1
75645	4491	260139	2018-06-08	2018-06-22	1
22060	1320	40480160	1998-09-12	1998-11-11	1
63214	3736	260139	1964-09-13	1964-09-20	1
23220	1387	40481087	1985-08-14	1985-08-21	1
88730	5279	40481087	2005-07-13	2005-07-27	1
28131	1661	4112343	2008-05-29	2008-06-10	1
66244	3926	40479768	1957-05-09	1957-07-15	1
51939	3080	372328	1946-06-09	1946-11-28	1
18687	1125	30753	1985-12-02	1985-12-03	1
18680	1124	4113008	1940-08-31	1940-09-14	1
50975	3020	317576	1961-12-13	1961-12-14	1
46006	2743	40481087	1999-07-06	1999-07-20	1
48105	2858	260139	2010-05-30	2010-06-13	1
60601	3592	257012	1969-10-19	1969-10-20	1
24993	1493	40481087	1990-11-20	1990-12-04	1
57667	3423	40481087	1990-01-29	1990-02-05	1
56267	3339	28060	1960-10-08	1960-10-18	1
48255	2862	30753	2005-09-05	2005-09-06	1
46865	2790	260139	1986-01-28	1986-02-04	1
42227	2518	40481087	1967-08-16	1967-08-30	1
38914	2315	260139	2002-03-31	2002-04-07	1
49775	2945	4112343	1951-07-29	1951-08-09	1
75646	4491	372328	1948-04-02	1948-06-20	1
22061	1320	40481087	1958-10-03	1958-10-10	1
63215	3736	372328	1952-02-29	1952-05-14	1
23221	1387	195588	2013-03-21	2013-07-25	2
1514	90	28060	1963-02-13	1963-02-20	1
28132	1661	40481087	1980-02-24	1980-03-16	1
66245	3926	40481087	1953-10-03	1953-10-10	1
51940	3080	4113008	1966-07-13	1966-08-03	1
18688	1125	4027663	1975-09-16	1975-09-17	1
18681	1124	40481087	1951-06-19	1951-07-10	1
50976	3020	4112343	1974-11-15	1974-11-26	1
47624	2834	372328	1941-10-17	1942-04-04	1
48106	2858	317576	2014-07-09	2014-07-10	1
60602	3592	260139	1986-05-09	1986-05-16	1
24994	1493	80180	1989-11-06	1989-11-07	1
57668	3423	40481087	1994-03-22	1994-04-05	1
56268	3339	80180	1995-11-23	1995-11-24	1
48256	2862	260139	2008-10-08	2008-10-15	1
46866	2790	4278672	1973-07-02	1973-08-01	1
42228	2518	40481087	1994-08-13	1994-09-03	1
38915	2315	40481087	1998-04-03	1998-04-10	1
49776	2945	4112343	1957-12-09	1957-12-21	1
75647	4491	378001	1979-04-02	1979-05-02	1
22062	1320	40481087	1964-08-30	1964-09-20	1
63216	3736	4112343	1959-03-27	1959-04-05	1
23222	1387	4112343	1978-09-15	1978-09-23	1
1515	90	28060	1991-12-05	1991-12-12	1
28133	1661	28060	1977-01-07	1977-01-18	1
66246	3926	40481087	1966-06-19	1966-07-10	1
51941	3080	4237458	2014-10-02	2014-12-01	1
18689	1125	4112343	2009-08-17	2009-08-26	1
22189	1325	28060	2018-05-12	2018-05-21	1
52268	3098	260139	1991-07-21	1991-08-04	1
47625	2834	40481087	1976-08-15	1976-08-29	1
48107	2858	372328	1911-06-15	1911-08-29	1
60603	3592	378001	1972-01-21	1972-03-21	1
24995	1493	260139	2007-04-18	2007-04-25	1
57669	3423	40481087	2016-11-27	2016-12-11	1
56269	3339	4112343	2003-06-27	2003-07-10	1
48257	2862	4027663	1995-08-19	1995-08-20	1
46867	2790	40481087	1992-09-27	1992-10-11	1
42229	2518	40481087	2008-02-01	2008-02-15	1
38916	2315	81151	1984-01-24	1984-02-21	1
49777	2945	4112343	1991-02-13	1991-02-25	1
75648	4491	4027663	1973-01-06	1973-01-07	1
22063	1320	40481087	1990-02-10	1990-02-17	1
63217	3736	4112343	1986-12-01	1986-12-08	1
23223	1387	4296205	2001-12-09	2002-01-06	1
1516	90	257012	1985-08-18	1985-08-25	1
28134	1661	80180	1995-02-05	1995-02-06	1
66247	3926	28060	2012-06-19	2012-07-02	1
51942	3080	40481087	1950-08-23	1950-09-06	1
18690	1125	40481087	1968-10-21	1968-11-04	1
22190	1325	260139	1966-01-03	1966-01-10	1
52269	3098	40481087	2002-07-07	2002-07-28	1
47626	2834	80180	1972-01-06	1972-01-07	1
48108	2858	372328	1979-07-04	1980-03-25	1
60604	3592	4112343	1967-07-31	1967-08-10	1
24996	1493	4112343	1958-08-31	1958-09-10	1
57670	3423	28060	1988-12-04	1988-12-14	1
56270	3339	4112343	2017-07-27	2017-08-09	1
48258	2862	40481087	1980-03-17	1980-04-07	1
46868	2790	40481087	2003-10-22	2003-11-05	1
43027	2566	81151	2000-08-02	2000-09-06	1
38917	2315	372328	1978-08-23	1978-10-07	1
49778	2945	40481087	1957-11-07	1957-11-28	1
75649	4491	4112343	1965-05-17	1965-05-25	1
22064	1320	372328	1939-10-09	1940-08-15	1
63218	3736	40481087	1952-01-05	1952-01-26	1
23224	1387	40481087	2001-09-21	2001-10-05	1
1517	90	4109685	1980-09-19	1980-10-10	1
28135	1661	81151	1963-04-19	1963-05-24	1
66248	3926	4112343	1984-12-10	1984-12-17	1
51943	3080	40481087	1989-04-02	1989-04-23	1
18691	1125	80180	1986-06-30	1986-07-01	1
22191	1325	260139	1970-11-18	1970-12-02	1
52270	3098	80180	1995-12-02	1995-12-03	1
47627	2834	260139	1964-06-02	1964-06-09	1
48109	2858	4112343	1911-12-25	1912-01-04	1
60605	3592	40481087	1973-09-25	1973-10-02	1
24997	1493	4112343	1971-10-03	1971-10-16	1
57671	3423	78272	2004-12-27	2005-01-24	1
56271	3339	40481087	1982-11-30	1982-12-14	1
48259	2862	40481087	1984-11-17	1984-12-08	1
48392	2869	81151	1974-03-04	1974-03-25	1
43028	2566	260139	1946-09-18	1946-09-25	1
38918	2315	372328	1989-10-09	1990-10-06	1
49779	2945	40481087	1964-06-13	1964-07-04	1
75650	4491	4112343	1983-04-09	1983-04-17	1
22065	1320	375671	1935-06-26	1935-08-25	1
63219	3736	40481087	1961-05-17	1961-05-24	1
23225	1387	260139	1989-03-19	1989-03-26	1
1518	90	4112343	1970-01-15	1970-01-28	1
28136	1661	260139	2017-03-31	2017-04-14	1
66249	3926	4218389	1977-02-14	1977-03-14	1
51944	3080	40481087	1995-01-28	1995-02-11	1
18692	1125	260139	1959-11-20	1959-11-27	1
22192	1325	260139	1990-05-03	1990-05-17	1
52271	3098	260139	2016-06-11	2016-06-18	1
47628	2834	372328	1938-07-18	1938-10-01	1
48110	2858	4112343	1957-09-03	1957-09-13	1
60606	3592	40481087	1981-10-26	1981-11-09	1
24998	1493	4294548	1967-06-07	1967-06-28	1
57672	3423	378001	1977-01-04	1977-03-05	1
56272	3339	78272	1961-08-03	1961-09-07	1
48260	2862	40481087	2015-07-10	2015-07-24	1
48393	2869	257012	1993-09-27	1993-09-28	1
43029	2566	372328	1941-02-15	1941-04-01	1
42461	2535	80180	1999-03-13	1999-03-14	1
49780	2945	40481087	1972-07-18	1972-08-01	1
75651	4491	4112343	2005-07-17	2005-07-27	1
22066	1320	4112343	1949-09-14	1949-09-25	1
63220	3736	40481087	1966-10-11	1966-10-18	1
23226	1387	440086	1981-03-29	1987-01-25	1
1519	90	4112343	1992-05-12	1992-05-22	1
28137	1661	372328	1962-03-14	1962-06-21	1
66250	3926	4218389	1991-08-26	1991-09-30	1
51945	3080	40481087	1995-07-20	1995-08-10	1
18693	1125	4296204	1952-09-11	1952-10-09	1
22193	1325	378001	2007-01-11	2007-02-10	1
52272	3098	439777	1958-09-22	1958-09-23	1
47629	2834	4112343	1968-01-14	1968-01-24	1
48111	2858	4112343	2013-07-12	2013-07-24	1
60607	3592	40481087	1984-05-04	1984-05-25	1
24999	1493	40481087	1960-07-11	1960-07-18	1
57673	3423	4112343	1992-10-27	1992-11-05	1
56273	3339	260139	1993-06-17	1993-06-24	1
49014	2904	260139	2005-06-17	2005-06-24	1
48394	2869	4001336	1975-02-18	1975-04-19	1
43030	2566	372328	1942-03-27	1942-09-29	1
42462	2535	257012	2018-01-10	2018-01-11	1
49781	2945	40481087	1991-12-13	1991-12-20	1
75652	4491	4278672	1952-02-02	1952-05-02	1
22067	1320	4112343	1960-08-01	1960-08-13	1
63221	3736	40481087	1974-01-06	1974-01-20	1
23227	1387	40481087	2013-01-14	2013-02-04	1
1520	90	4283893	1965-01-21	1965-02-18	1
28138	1661	4109685	1980-05-24	1980-06-14	1
66251	3926	40481087	1956-04-21	1956-05-05	1
54265	3218	192671	1992-11-29	1992-11-30	1
18694	1125	40481087	1965-03-28	1965-04-04	1
22194	1325	4059173	2011-10-17	2012-01-15	1
52273	3098	4059173	2019-06-23	2019-06-24	1
47630	2834	0	1999-12-04	1999-12-05	1
48112	2858	4113008	1979-07-01	1979-07-15	1
60608	3592	40481087	1987-05-18	1987-06-08	1
25000	1493	40481087	1972-05-16	1972-06-06	1
57674	3423	40481087	1981-02-14	1981-03-07	1
56274	3339	372328	1963-01-25	1963-03-19	1
49015	2904	372328	1973-07-24	1973-10-24	1
48395	2869	4059173	1960-07-31	1960-08-30	1
43031	2566	4059173	2014-01-01	2014-03-02	1
42463	2535	372328	1961-11-05	1961-12-10	1
49782	2945	40481087	2006-04-28	2006-05-12	1
75653	4491	4310024	1982-10-31	1982-11-01	1
22068	1320	4112343	2004-10-02	2004-10-11	1
63222	3736	40481087	1991-02-11	1991-02-18	1
23228	1387	260139	2000-08-26	2000-09-02	1
1521	90	40481087	1961-04-30	1961-05-07	1
28139	1661	4112343	1991-11-03	1991-11-11	1
66252	3926	40481087	1980-12-26	1981-01-16	1
54266	3218	4155034	1997-03-18	1997-04-01	1
18695	1125	40481087	1988-08-27	1988-09-10	1
22195	1325	4112343	1974-03-05	1974-03-13	1
52274	3098	4112343	1963-08-29	1963-09-09	1
47631	2834	4112343	1947-08-02	1947-08-15	1
48113	2858	4134304	1912-03-11	1912-04-10	1
60609	3592	4112343	2017-06-29	2017-07-07	1
25001	1493	40481087	1982-10-03	1982-10-24	1
57675	3423	40481087	2004-02-19	2004-03-11	1
56275	3339	440086	1970-10-10	1977-10-18	1
49016	2904	4112343	1992-06-27	1992-07-07	1
48396	2869	4112343	1999-01-11	1999-01-20	1
43032	2566	40481087	2007-03-17	2007-03-24	1
42464	2535	4112343	1998-12-26	1999-01-08	1
52354	3105	80180	2008-07-05	2008-07-06	1
75654	4491	40481087	1947-04-16	1947-04-30	1
22069	1320	4156265	2019-05-25	2019-06-15	1
63223	3736	40481087	2006-05-11	2006-05-25	1
23229	1387	4278672	1980-08-31	1980-11-29	1
1522	90	40481087	2017-04-18	2017-05-09	1
28140	1661	4237458	1991-06-13	1991-08-12	1
68079	4026	28060	1959-01-22	1959-02-02	1
54267	3218	4266809	1992-10-04	1992-10-05	1
18696	1125	40481087	1993-10-20	1993-10-27	1
22196	1325	40481087	1982-08-22	1982-08-29	1
52275	3098	4112343	1972-02-28	1972-03-12	1
47632	2834	4310024	1970-07-15	1970-07-16	1
48114	2858	4283893	1987-12-27	1988-01-10	1
60610	3592	4116491	2016-01-15	2016-02-25	1
25002	1493	40481087	1999-03-17	1999-03-24	1
57676	3423	40481087	2004-05-16	2004-06-06	1
56276	3339	4113008	1987-06-23	1987-07-07	1
49017	2904	40481087	1976-03-22	1976-04-05	1
48397	2869	4294548	1993-07-12	1993-11-01	1
43033	2566	40481087	2008-06-25	2008-07-02	1
42465	2535	40481087	1994-04-17	1994-05-01	1
52355	3105	81151	2000-10-13	2000-11-03	1
75655	4491	40481087	1992-06-29	1992-07-13	1
22070	1320	4230399	2006-03-04	2006-04-03	1
63224	3736	372328	1954-03-05	1954-05-12	1
23230	1387	40481087	1983-05-06	1983-05-20	1
1523	90	80180	1997-06-02	1997-06-03	1
28141	1661	4310024	1992-09-18	1992-09-19	1
68080	4026	81151	2009-10-07	2009-11-11	1
54268	3218	4283893	1987-07-01	1987-07-15	1
18697	1125	81893	1985-04-06	1985-04-07	1
22197	1325	40481087	2002-02-14	2002-02-28	1
52276	3098	4294548	1984-06-08	1984-06-22	1
47633	2834	40481087	1945-06-17	1945-06-24	1
48115	2858	40481087	1942-05-28	1942-06-18	1
60611	3592	40481087	1992-03-18	1992-03-25	1
25003	1493	260139	1960-09-05	1960-09-12	1
64746	3833	30753	2000-12-12	2000-12-13	1
56277	3339	40481087	1978-09-30	1978-10-14	1
49018	2904	40481087	1986-12-06	1986-12-13	1
48398	2869	40481087	1968-07-13	1968-07-27	1
43034	2566	28060	1947-10-24	1947-10-31	1
42466	2535	40481087	2003-01-21	2003-01-28	1
52356	3105	260139	2016-07-02	2016-07-16	1
78474	4653	28060	1964-09-24	1964-10-04	1
22071	1320	4294548	1938-08-17	1938-09-14	1
63225	3736	4112343	1986-01-22	1986-02-03	1
23231	1387	40481087	1986-01-23	1986-02-06	1
1524	90	4294548	1985-06-30	1985-08-25	1
28142	1661	40481087	2004-04-27	2004-05-11	1
68081	4026	258780	2012-02-05	2012-02-06	1
54269	3218	4310024	1990-07-17	1990-07-18	1
18698	1125	260139	1958-09-11	1958-09-25	1
22198	1325	40481087	2002-08-03	2002-08-24	1
52277	3098	260139	1973-12-04	1973-12-18	1
47634	2834	192671	1972-03-16	1972-03-17	1
48116	2858	40481087	1950-03-20	1950-04-10	1
60612	3592	80180	2001-07-07	2001-07-08	1
25004	1493	381316	2016-03-08	2016-03-09	1
64747	3833	80180	2001-12-07	2001-12-08	1
56278	3339	40481087	1991-05-08	1991-05-22	1
49019	2904	4283893	1972-12-10	1973-04-01	1
48399	2869	40481087	1980-05-29	1980-06-12	1
43035	2566	4112343	1943-09-05	1943-09-14	1
42467	2535	28060	1962-10-08	1962-10-16	1
52357	3105	440086	1984-01-23	1984-06-04	1
78475	4653	372328	1959-06-22	1959-08-02	1
22072	1320	40481087	1942-06-02	1942-06-23	1
63226	3736	4294548	1999-06-15	1999-07-27	1
23693	1415	80180	2002-12-09	2002-12-10	1
1525	90	40481087	1968-06-08	1968-06-29	1
31089	1844	28060	2009-04-21	2009-04-29	1
68082	4026	260139	2003-01-20	2003-01-27	1
54270	3218	40481087	1962-01-06	1962-01-20	1
18699	1125	4134304	1967-01-08	1967-03-09	1
22199	1325	260139	1974-04-24	1974-05-01	1
52278	3098	260139	2012-02-09	2012-02-23	1
47635	2834	260139	1970-06-10	1970-06-24	1
48117	2858	40481087	1964-09-02	1964-09-16	1
60613	3592	260139	1998-11-27	1998-12-11	1
25005	1493	4112343	1957-09-21	1957-10-02	1
64748	3833	81893	2000-09-13	2000-09-14	1
56279	3339	40481087	2011-08-07	2011-08-28	1
49020	2904	40481087	1977-06-06	1977-06-20	1
48400	2869	81151	1951-11-18	1951-12-09	1
43036	2566	4112343	2015-03-21	2015-04-03	1
42468	2535	28060	1972-09-09	1972-09-18	1
52358	3105	4112343	2001-07-15	2001-07-24	1
78476	4653	4112343	1997-04-13	1997-04-25	1
22073	1320	40481087	2018-03-29	2018-04-05	1
63227	3736	40481087	2004-08-08	2004-08-29	1
23694	1415	257012	1976-01-22	1976-01-23	1
1526	90	40481087	1993-02-04	1993-02-18	1
31090	1844	81893	2000-12-22	2000-12-23	1
68083	4026	4027663	1988-01-19	1988-01-20	1
54271	3218	40481087	1980-05-17	1980-05-31	1
18700	1125	4266809	1986-06-30	1986-07-01	1
22200	1325	4112343	1965-09-07	1965-09-16	1
52279	3098	40481087	1988-06-09	1988-06-30	1
47636	2834	260139	1980-07-03	1980-07-17	1
48118	2858	40481087	2005-01-25	2005-02-01	1
60614	3592	4112343	2014-11-03	2014-11-11	1
25006	1493	4112343	2000-02-02	2000-02-15	1
64749	3833	260139	1966-09-24	1966-10-01	1
56280	3339	28060	1969-02-14	1969-02-21	1
49021	2904	40481087	2007-07-01	2007-07-22	1
48401	2869	260139	1968-11-20	1968-11-27	1
43037	2566	4237458	2015-11-22	2016-01-21	1
42469	2535	260139	1979-02-28	1979-03-14	1
52359	3105	4112343	2018-03-31	2018-04-08	1
78477	4653	4283893	1964-07-20	1965-02-22	1
24701	1476	28060	2002-11-07	2002-11-20	1
63228	3736	40481087	2004-11-04	2004-11-11	1
23695	1415	260139	1988-09-15	1988-09-22	1
1527	90	78272	1978-08-26	1978-09-30	1
31091	1844	192671	2002-12-16	2002-12-17	1
68084	4026	4134304	1962-11-01	1962-12-01	1
54272	3218	40481087	2010-04-13	2010-04-27	1
18701	1125	40481087	1964-10-02	1964-10-23	1
22201	1325	4112343	1987-10-02	1987-10-10	1
52280	3098	40481087	1998-03-18	1998-03-25	1
47637	2834	260139	1990-06-26	1990-07-03	1
48119	2858	80180	1953-05-26	1953-05-27	1
60615	3592	4285898	2001-04-08	2001-04-09	1
25007	1493	40481087	1966-12-12	1967-01-02	1
64750	3833	260139	1999-02-14	1999-02-28	1
56281	3339	4059173	1967-08-07	1967-11-05	1
49022	2904	80180	2007-03-27	2007-03-28	1
48402	2869	260139	1970-03-04	1970-03-11	1
43038	2566	4310024	1977-06-11	1977-06-12	1
42470	2535	260139	2003-11-24	2003-12-01	1
52360	3105	4218389	1970-11-22	1970-12-20	1
78478	4653	4283893	1992-08-24	1992-11-02	1
24702	1476	4109685	1955-02-19	1955-03-12	1
63229	3736	40481087	2012-07-29	2012-08-12	1
23696	1415	4283893	1975-12-18	1976-04-29	1
1528	90	81151	2009-06-10	2009-06-24	1
31092	1844	260139	1996-02-08	1996-02-22	1
68085	4026	4310024	1996-07-15	1996-07-16	1
54273	3218	80180	1992-10-04	1992-10-05	1
28298	1674	80180	2012-04-20	2012-04-21	1
22202	1325	4112343	2002-03-12	2002-03-22	1
52281	3098	78272	1994-07-15	1994-08-19	1
47638	2834	317576	1948-05-08	1948-05-09	1
48120	2858	80809	1988-03-02	1988-03-03	1
60616	3592	40481087	1983-03-11	1983-04-01	1
25008	1493	40481087	1969-04-25	1969-05-09	1
64751	3833	372328	2011-04-06	2013-03-27	1
56282	3339	4059173	1999-04-05	1999-07-04	1
49023	2904	195588	2012-05-09	2012-06-20	1
48403	2869	260139	1976-04-27	1976-05-11	1
43039	2566	40481087	1985-12-07	1985-12-14	1
42471	2535	378001	1994-10-03	1994-12-02	1
52361	3105	40481087	2018-06-06	2018-06-13	1
78479	4653	4296204	1960-02-17	1960-03-09	1
24703	1476	4278672	1978-08-22	1978-10-21	1
64556	3822	28060	1958-02-28	1958-03-10	1
23697	1415	4294548	1997-08-20	1997-10-08	1
1529	90	372328	1963-05-12	1963-07-30	1
31093	1844	4027663	1992-03-29	1992-03-30	1
68086	4026	40481087	1960-07-19	1960-08-09	1
54274	3218	372328	1957-10-23	1958-01-05	1
28299	1674	81893	2010-05-01	2010-05-02	1
22203	1325	40481087	1978-12-14	1979-01-04	1
52282	3098	192671	1996-02-18	1996-02-19	1
47639	2834	372328	1938-11-30	1939-04-01	1
48121	2858	260139	1977-03-02	1977-03-16	1
60617	3592	40481087	2018-07-14	2018-07-28	1
25009	1493	40481087	1971-10-03	1971-10-10	1
64752	3833	4155034	2005-10-27	2005-11-10	1
56283	3339	40481087	1971-01-19	1971-02-02	1
49024	2904	28060	2006-05-12	2006-05-24	1
48404	2869	40481087	2004-10-13	2004-10-20	1
43040	2566	40481087	1995-01-31	1995-02-21	1
42472	2535	381316	2000-08-27	2000-08-28	1
52362	3105	372328	1971-12-17	1971-12-31	1
78480	4653	40481087	2019-04-17	2019-05-01	1
24704	1476	4283893	1949-08-23	1949-09-27	1
64557	3822	80180	1986-09-30	1986-10-01	1
23698	1415	40481087	2015-09-03	2015-09-24	1
1530	90	4278672	1975-11-10	1975-12-10	1
31094	1844	40481087	1977-12-08	1977-12-22	1
68087	4026	81151	1977-04-16	1977-05-07	1
54275	3218	372328	1960-10-21	1961-10-08	1
28300	1674	260139	1993-12-29	1994-01-12	1
22204	1325	40481087	1987-11-09	1987-11-23	1
52283	3098	4109685	2009-01-02	2009-01-16	1
47640	2834	4027663	1964-04-17	1964-04-18	1
48122	2858	260139	1982-02-23	1982-03-02	1
60618	3592	260139	2007-04-01	2007-04-15	1
25948	1541	30753	2006-05-13	2006-05-14	1
64753	3833	4266809	2001-12-07	2001-12-08	1
56284	3339	28060	1968-08-09	1968-08-16	1
49025	2904	372328	1973-03-05	1973-04-25	1
48405	2869	78272	1968-12-16	1968-12-30	1
43041	2566	40481087	2016-08-26	2016-09-16	1
42473	2535	4112343	1969-02-15	1969-02-23	1
52363	3105	372328	1972-12-30	1973-07-02	1
78481	4653	80180	2002-10-29	2002-10-30	1
24705	1476	40481087	1945-11-14	1945-12-05	1
64558	3822	192671	1986-11-13	1986-11-14	1
23699	1415	4112343	1969-02-28	1969-03-13	1
1531	90	40481087	1991-06-01	1991-06-08	1
31095	1844	40481087	2009-06-14	2009-06-28	1
68088	4026	4112343	1994-10-11	1994-10-18	1
54276	3218	4027663	1982-10-22	1982-10-23	1
28301	1674	4112343	2011-12-20	2011-12-30	1
22205	1325	40481087	2009-08-26	2009-09-02	1
52284	3098	4112343	1987-09-21	1987-09-29	1
47641	2834	4112343	1965-03-17	1965-03-27	1
48123	2858	4035415	1936-02-04	1936-03-05	1
60619	3592	4027663	1990-01-21	1990-01-22	1
25949	1541	378001	1966-02-12	1966-04-13	1
64754	3833	40481087	1968-09-19	1968-09-26	1
56285	3339	260139	2012-09-13	2012-09-27	1
49026	2904	4112343	1999-05-05	1999-05-16	1
48406	2869	313217	2009-12-15	2009-12-16	1
43042	2566	378001	2003-03-25	2003-04-24	1
42474	2535	4294548	2017-11-08	2018-02-07	1
52364	3105	4155034	2004-07-15	2004-08-05	1
78482	4653	260139	1965-07-22	1965-07-29	1
24706	1476	40481087	1948-11-11	1948-11-18	1
64559	3822	317576	2009-03-23	2009-03-24	1
23700	1415	4218389	2005-05-31	2005-06-28	1
1532	90	260139	1987-06-06	1987-06-20	1
31096	1844	28060	1962-11-18	1962-11-30	1
68089	4026	4112343	2000-04-21	2000-05-03	1
54277	3218	4112343	2017-09-07	2017-09-19	1
28302	1674	4230399	2008-09-07	2008-12-06	1
22206	1325	260139	2009-10-29	2009-11-12	1
52285	3098	40481087	1982-12-24	1983-01-07	1
47642	2834	4112343	1999-10-11	1999-10-21	1
48124	2858	4059173	1986-02-07	1986-04-08	1
60620	3592	4112343	1966-05-23	1966-06-04	1
25950	1541	4027663	1996-04-20	1996-04-21	1
64755	3833	40481087	2001-10-18	2001-11-08	1
56286	3339	372328	1970-02-10	1970-09-01	1
49027	2904	40481087	1987-02-18	1987-03-11	1
48407	2869	4142905	1962-09-19	1962-10-19	1
43043	2566	4218389	2012-01-07	2012-02-11	1
42475	2535	40481087	1981-01-11	1981-01-18	1
52365	3105	40481087	1981-05-03	1981-05-10	1
78483	4653	372328	2002-06-17	2003-03-09	1
24707	1476	40481087	1958-12-14	1958-12-28	1
64560	3822	372328	1947-04-13	1947-09-01	1
23701	1415	40481087	1974-05-07	1974-05-21	1
1533	90	4283893	1970-06-28	1970-08-09	1
31097	1844	28060	1979-10-27	1979-11-06	1
68090	4026	4294548	2019-03-14	2019-06-20	1
54278	3218	40481087	1992-03-27	1992-04-17	1
28303	1674	40481087	1994-03-05	1994-03-19	1
22207	1325	4112343	1999-12-07	1999-12-20	1
53994	3200	28060	2001-01-21	2001-02-03	1
47643	2834	4152936	1985-01-12	1985-02-02	1
48125	2858	4112343	1910-11-20	1910-11-29	1
60621	3592	4142905	1978-09-07	1978-11-06	1
25951	1541	4112343	1998-12-29	1999-01-08	1
64756	3833	40481087	2006-05-23	2006-06-06	1
56287	3339	40481087	1999-09-13	1999-10-04	1
49028	2904	40481087	2008-08-21	2008-09-11	1
48408	2869	4296204	2000-12-03	2000-12-24	1
43044	2566	40481087	1952-03-23	1952-04-06	1
42476	2535	28060	1994-12-04	1994-12-13	1
52366	3105	260139	1981-12-26	1982-01-02	1
78484	4653	4112343	1989-05-11	1989-05-23	1
24708	1476	40481087	1975-10-29	1975-11-12	1
64561	3822	4112343	1959-09-03	1959-09-12	1
23702	1415	40481087	1983-03-29	1983-04-19	1
1534	90	4296204	1965-10-28	1965-12-02	1
31098	1844	30753	2001-08-19	2001-08-20	1
68091	4026	40481087	2008-01-19	2008-02-02	1
54279	3218	40481087	2004-12-12	2005-01-02	1
28304	1674	40481087	2008-09-06	2008-09-20	1
22208	1325	80180	2000-12-19	2000-12-20	1
53995	3200	80180	1985-01-29	1985-01-30	1
47644	2834	4285898	1971-05-11	1971-05-12	1
48126	2858	4112343	1930-08-27	1930-09-05	1
60622	3592	4283893	2006-01-05	2006-02-09	1
25952	1541	4156265	1983-03-13	1983-03-27	1
64757	3833	40481087	1983-11-13	1983-11-20	1
59995	3559	378001	2001-03-20	2001-04-19	1
50815	3010	28060	1984-07-24	1984-08-06	1
48409	2869	40481087	1961-04-06	1961-04-13	1
43045	2566	40481087	1959-05-02	1959-05-23	1
42477	2535	260139	2015-02-02	2015-02-16	1
52367	3105	260139	1990-06-04	1990-06-18	1
78485	4653	4112343	2010-09-23	2010-10-03	1
24709	1476	40481087	1997-07-08	1997-07-15	1
64562	3822	4112343	1978-03-21	1978-04-02	1
23703	1415	28060	1984-05-12	1984-05-19	1
1535	90	40481087	1967-08-16	1967-09-06	1
31099	1844	260139	1994-10-31	1994-11-14	1
68092	4026	30753	1997-07-10	1997-07-11	1
54280	3218	81151	1966-01-09	1966-01-30	1
28305	1674	40481087	2012-11-06	2012-11-27	1
22209	1325	260139	2001-04-06	2001-04-13	1
53996	3200	4112343	1950-01-05	1950-01-16	1
47645	2834	4329847	1999-12-04	1999-12-05	1
48127	2858	4112343	1950-07-26	1950-08-08	1
60623	3592	4294548	1969-09-21	1969-12-07	1
25953	1541	81893	2006-03-14	2006-03-15	1
64758	3833	40481087	1991-04-15	1991-05-06	1
59996	3559	378001	2010-09-29	2010-10-29	1
50816	3010	4112343	1975-11-08	1975-11-20	1
48410	2869	40481087	1983-04-06	1983-04-27	1
43046	2566	40481087	1965-08-25	1965-09-08	1
42478	2535	372328	1961-03-02	1961-04-09	1
52368	3105	4294548	2007-03-06	2007-04-03	1
78486	4653	40481087	1969-05-09	1969-05-30	1
24710	1476	40481087	2000-07-07	2000-07-21	1
64563	3822	28060	1948-01-12	1948-01-24	1
23704	1415	81151	1984-02-07	1984-02-21	1
3066	182	28060	1961-06-16	1961-06-28	1
31100	1844	378001	2004-02-08	2004-04-08	1
68093	4026	134438	1977-01-28	1977-11-26	1
54281	3218	4278672	1994-01-03	1994-04-03	1
28306	1674	260139	1985-01-28	1985-02-04	1
22210	1325	372328	2013-09-22	2013-11-17	1
53997	3200	40481087	2018-10-31	2018-11-07	1
51725	3070	30753	1998-10-07	1998-10-08	1
48128	2858	4112343	1962-04-23	1962-05-04	1
60624	3592	40481087	1965-10-30	1965-11-06	1
25954	1541	260139	1996-01-08	1996-01-22	1
64759	3833	192671	2002-01-27	2002-01-28	1
59997	3559	4109685	1951-06-17	1951-07-01	1
50817	3010	4237458	1980-10-06	1980-12-05	1
48411	2869	80180	1989-02-06	1989-02-07	1
43047	2566	40481087	1980-02-10	1980-03-02	1
42479	2535	4112343	1961-10-29	1961-11-10	1
52369	3105	260139	2007-09-10	2007-09-17	1
78487	4653	40481087	1972-09-17	1972-10-08	1
24711	1476	40481087	2009-10-08	2009-10-22	1
64564	3822	260139	1972-08-31	1972-09-14	1
23705	1415	4112343	1969-08-13	1969-08-26	1
3067	182	260139	1986-09-17	1986-09-24	1
31101	1844	4112343	1964-04-24	1964-05-02	1
68094	4026	260139	1970-11-21	1970-12-05	1
54282	3218	40481087	1993-09-07	1993-09-28	1
28307	1674	4266809	2012-04-20	2012-04-21	1
22211	1325	4109685	1989-12-27	1990-01-10	1
53998	3200	78272	1958-01-21	1958-02-18	1
51726	3070	80180	1999-12-31	2000-01-01	1
48129	2858	4152936	2018-04-12	2018-04-26	1
60625	3592	40481087	1995-06-13	1995-06-27	1
25955	1541	4112343	1964-01-26	1964-02-02	1
64760	3833	372328	1970-10-15	1971-08-04	1
59998	3559	4112343	1969-05-11	1969-05-18	1
50818	3010	40481087	1981-12-20	1982-01-03	1
48412	2869	260139	1991-05-06	1991-05-20	1
43048	2566	40481087	2003-04-16	2003-04-30	1
42480	2535	4112343	1988-08-26	1988-09-03	1
52370	3105	372328	1972-02-29	1972-07-03	1
78488	4653	257012	1964-08-24	1964-08-25	1
24712	1476	80502	2004-12-02	2004-12-03	1
64565	3822	313217	2015-04-27	2015-04-28	1
23706	1415	4278672	2004-06-05	2004-07-05	1
3068	182	260139	2007-10-17	2007-10-31	1
31102	1844	4112343	1999-10-24	1999-11-06	1
68095	4026	260139	1981-07-30	1981-08-06	1
54283	3218	40481087	1998-06-09	1998-06-16	1
28308	1674	40481087	1977-09-11	1977-10-02	1
22212	1325	4112343	2009-11-14	2009-11-24	1
53999	3200	78272	1981-03-19	1981-04-09	1
51727	3070	260139	1986-12-11	1986-12-18	1
48130	2858	4155034	1950-07-19	1950-08-02	1
60626	3592	40481087	2005-11-08	2005-11-29	1
25956	1541	4112343	1966-12-20	1967-01-01	1
64761	3833	4146173	2007-10-01	2007-10-31	1
59999	3559	4112343	2001-03-26	2001-04-08	1
50819	3010	40481087	1989-03-30	1989-04-13	1
48413	2869	372328	1953-11-07	1954-03-30	1
43049	2566	40481087	2015-08-02	2015-08-23	1
42481	2535	4296205	1970-10-11	1970-11-08	1
52371	3105	372328	1975-04-23	1976-01-12	1
78489	4653	4112343	1989-03-01	1989-03-08	1
24713	1476	4051466	1946-09-21	1963-12-21	1
64566	3822	4112343	1953-01-11	1953-01-24	1
23707	1415	40481087	1987-06-05	1987-06-19	1
3069	182	4112343	1988-02-24	1988-03-05	1
31103	1844	40481087	2014-08-09	2014-08-30	1
68096	4026	372328	1961-04-01	1961-07-02	1
54284	3218	260139	1973-09-30	1973-10-07	1
28309	1674	40481087	1986-02-24	1986-03-10	1
22213	1325	40481087	1978-07-03	1978-07-10	1
54000	3200	260139	1961-09-03	1961-09-17	1
51728	3070	4027663	1991-09-19	1991-09-20	1
48131	2858	4278672	1998-01-05	1998-02-04	1
63071	3730	81151	1980-04-14	1980-05-19	1
25957	1541	4112343	1997-10-19	1997-11-01	1
64762	3833	40481087	1968-07-21	1968-08-11	1
60000	3559	4112343	2017-10-13	2017-10-22	1
50820	3010	78272	1972-07-31	1972-08-28	1
48414	2869	4112343	2009-12-25	2010-01-03	1
43050	2566	30753	1978-09-04	1978-09-05	1
42482	2535	40481087	1978-06-10	1978-06-17	1
52372	3105	40481087	1977-08-23	1977-09-13	1
78490	4653	4112343	2004-07-18	2004-07-25	1
24714	1476	4059173	1961-08-21	1961-10-20	1
64567	3822	4112343	1973-11-30	1973-12-10	1
23708	1415	40481087	1994-08-17	1994-08-31	1
3070	182	4283893	1998-12-01	1999-03-23	1
31104	1844	375671	1972-08-26	1972-10-25	1
68097	4026	372328	1962-09-25	1963-01-06	1
54285	3218	4112343	1985-07-02	1985-07-11	1
28310	1674	40481087	2003-12-18	2003-12-25	1
22950	1371	28060	1974-05-30	1974-06-09	1
54001	3200	260139	1983-09-04	1983-09-11	1
51729	3070	4218389	2018-12-28	2019-01-25	1
48132	2858	40481087	1913-03-15	1913-04-05	1
63072	3730	4112343	1954-05-03	1954-05-15	1
25958	1541	40481087	1964-02-01	1964-02-15	1
64763	3833	40481087	1973-03-10	1973-03-31	1
60001	3559	40481087	1969-04-24	1969-05-08	1
50821	3010	80180	2003-12-26	2003-12-27	1
48415	2869	4112343	2018-01-23	2018-01-31	1
43051	2566	78272	1958-11-13	1958-12-11	1
42483	2535	40481087	2015-04-03	2015-04-17	1
52373	3105	40481087	1987-10-13	1987-10-20	1
78491	4653	40481087	1982-12-19	1983-01-09	1
24715	1476	4112343	1961-11-28	1961-12-10	1
64568	3822	40481087	1980-03-07	1980-03-28	1
23709	1415	40481087	2017-11-18	2017-12-09	1
3071	182	40481087	1955-02-07	1955-02-21	1
31105	1844	4285898	2002-04-16	2002-04-17	1
68098	4026	4051466	1960-02-02	1977-05-14	1
54286	3218	4112343	2010-05-03	2010-05-15	1
28311	1674	30753	2010-11-27	2010-11-28	1
22951	1371	28060	2008-11-13	2008-11-21	1
54002	3200	260139	2012-03-13	2012-03-27	1
51730	3070	4285898	1999-07-04	1999-07-05	1
48133	2858	40481087	1959-05-02	1959-05-23	1
63073	3730	4112343	1958-11-23	1958-12-01	1
25959	1541	40481087	1984-09-05	1984-09-12	1
64764	3833	260139	1985-09-23	1985-09-30	1
60002	3559	40481087	2010-08-28	2010-09-18	1
50822	3010	260139	2000-01-07	2000-01-14	1
48416	2869	4134304	2013-01-20	2013-02-19	1
43052	2566	80180	1978-12-03	1978-12-04	1
42484	2535	260139	1998-10-26	1998-11-02	1
52374	3105	40481087	1996-04-11	1996-04-25	1
78492	4653	40481087	1986-05-29	1986-06-19	1
24716	1476	4112343	1992-08-02	1992-08-13	1
64569	3822	4059173	1988-07-09	1988-10-07	1
23710	1415	260139	1995-01-27	1995-02-03	1
3072	182	40481087	1963-02-19	1963-03-05	1
31106	1844	4296204	1986-07-28	1986-08-11	1
68099	4026	4112343	1980-07-14	1980-07-22	1
54287	3218	40481087	1973-06-26	1973-07-17	1
28312	1674	192671	2012-04-27	2012-04-28	1
22952	1371	28060	2009-05-22	2009-05-29	1
54003	3200	372328	1948-04-13	1948-07-29	1
51731	3070	260139	2001-09-04	2001-09-18	1
48134	2858	40481087	1999-02-19	1999-03-12	1
63074	3730	4112343	1983-01-26	1983-02-03	1
25960	1541	80180	2007-02-07	2007-02-08	1
64765	3833	260139	2018-08-18	2018-09-01	1
60003	3559	4112343	1955-11-27	1955-12-09	1
50823	3010	4112343	1975-03-04	1975-03-12	1
48417	2869	40479422	1954-10-24	1954-12-30	1
43053	2566	195588	1982-10-13	1982-11-22	1
42485	2535	40481087	2005-02-24	2005-03-17	1
52375	3105	40481087	2014-10-02	2014-10-16	1
78493	4653	40481087	2003-12-12	2003-12-19	1
24717	1476	40481087	1948-06-30	1948-07-07	1
64570	3822	4112343	1952-01-05	1952-01-15	1
23711	1415	40481087	2001-05-27	2001-06-10	1
3073	182	40481087	1971-04-29	1971-05-13	1
31107	1844	4310024	2000-05-26	2000-05-27	1
68100	4026	28060	2018-04-01	2018-04-13	1
54288	3218	40481087	1993-04-18	1993-05-02	1
28313	1674	260139	1990-06-09	1990-06-16	1
22953	1371	260139	2015-09-29	2015-10-13	1
54004	3200	4112343	2018-11-05	2018-11-12	1
51732	3070	4112343	1969-12-09	1969-12-21	1
48135	2858	40481087	2004-02-02	2004-02-23	1
63075	3730	4116491	2005-05-04	2005-06-05	1
25961	1541	372328	1963-09-26	1964-01-06	1
64766	3833	372328	1967-03-21	1967-04-04	1
60004	3559	4112343	1996-06-08	1996-06-18	1
50824	3010	4112343	2012-05-13	2012-05-24	1
48418	2869	40481087	1972-06-14	1972-07-05	1
43054	2566	4027663	1968-10-16	1968-10-17	1
43859	2615	30753	1986-04-30	1986-05-01	1
53261	3159	80180	2000-01-26	2000-01-27	1
78494	4653	260139	1993-07-04	1993-07-18	1
24718	1476	40481087	1952-03-23	1952-04-06	1
64571	3822	4113008	1964-06-03	1964-06-17	1
26422	1569	28060	1945-06-22	1945-07-03	1
3074	182	40481087	1976-03-23	1976-04-06	1
31108	1844	28060	1976-11-29	1976-12-08	1
68101	4026	80180	1998-02-05	1998-02-06	1
54289	3218	40481087	1997-01-19	1997-02-09	1
28314	1674	260139	2008-09-09	2008-09-16	1
22954	1371	378001	1979-10-03	1979-11-02	1
54005	3200	4230399	2014-09-13	2014-11-12	1
51733	3070	4112343	1978-06-08	1978-06-21	1
48136	2858	40481087	2006-06-03	2006-06-10	1
63076	3730	4237458	2002-07-23	2002-10-21	1
25962	1541	378001	2002-01-16	2002-03-17	1
64767	3833	4027663	1991-10-21	1991-10-22	1
60005	3559	40481087	1952-03-19	1952-03-26	1
50825	3010	40481087	1982-03-10	1982-03-31	1
48419	2869	40481087	1989-03-05	1989-03-26	1
43055	2566	4112343	2002-02-17	2002-02-26	1
43860	2615	80180	1987-01-25	1987-01-26	1
53262	3159	372328	1959-10-23	1959-12-03	1
78495	4653	260139	2011-06-28	2011-07-12	1
24719	1476	40481087	1953-09-05	1953-09-12	1
64572	3822	4146173	1974-03-25	1974-04-24	1
26423	1569	28060	2006-06-15	2006-06-22	1
3075	182	40481087	2018-06-16	2018-06-23	1
31109	1844	80180	2002-10-13	2002-10-14	1
68102	4026	81151	1992-04-18	1992-05-09	1
54290	3218	40481087	2003-04-26	2003-05-17	1
28315	1674	260139	2013-11-01	2013-11-15	1
22955	1371	4059173	1991-08-01	1991-08-31	1
54006	3200	28060	1951-02-12	1951-02-21	1
51734	3070	4112343	2016-06-30	2016-07-13	1
48137	2858	28060	1918-05-20	1918-05-30	1
63077	3730	40481087	1957-10-17	1957-11-07	1
25963	1541	4112343	1989-04-22	1989-05-02	1
64768	3833	4112343	1971-01-02	1971-01-14	1
60006	3559	40481087	1994-01-04	1994-01-25	1
50826	3010	260139	2008-09-30	2008-10-07	1
48420	2869	40481087	2016-08-26	2016-09-09	1
43056	2566	40481087	1945-01-30	1945-02-20	1
43861	2615	260139	1953-10-16	1953-10-30	1
53263	3159	372328	1963-11-12	1964-06-04	1
78496	4653	260139	2016-12-17	2016-12-24	1
24720	1476	40481087	1967-06-19	1967-06-26	1
64573	3822	40481087	1974-11-22	1974-11-29	1
26424	1569	260139	1943-03-03	1943-03-17	1
3076	182	80180	1995-05-17	1995-05-18	1
31110	1844	4051466	1963-04-13	1978-07-26	1
68103	4026	257012	2019-04-25	2019-06-20	1
55687	3300	0	1986-08-06	1986-08-07	1
28316	1674	4112343	2006-01-07	2006-01-16	1
22956	1371	4112343	1978-12-17	1978-12-25	1
54007	3200	28060	1980-01-05	1980-01-15	1
51735	3070	40481087	1969-08-16	1969-08-30	1
48138	2858	4112343	1914-07-26	1914-08-04	1
63078	3730	40481087	1982-01-28	1982-02-04	1
25964	1541	28060	1972-08-04	1972-08-16	1
64769	3833	4142905	1971-04-29	1971-06-28	1
60007	3559	80180	1991-08-06	1991-08-07	1
50827	3010	381316	2015-03-18	2015-03-19	1
48619	2883	260139	1970-01-27	1970-02-03	1
43057	2566	40481087	1957-12-11	1958-01-01	1
43862	2615	260139	1979-12-29	1980-01-05	1
53264	3159	4112343	1970-11-17	1970-11-25	1
78497	4653	4283893	1959-11-27	1960-01-08	1
24721	1476	80180	1980-06-27	1980-06-28	1
64574	3822	378001	1965-07-12	1965-08-11	1
26425	1569	260139	1974-08-15	1974-08-22	1
3077	182	81151	1987-05-29	1987-06-26	1
31111	1844	4266809	2002-10-13	2002-10-14	1
68104	4026	260139	2013-06-05	2013-06-19	1
55688	3300	81151	2009-10-12	2009-10-26	1
28317	1674	40481087	1997-06-08	1997-06-15	1
22957	1371	4112343	1998-10-25	1998-11-04	1
54008	3200	4112343	1993-02-20	1993-03-03	1
51736	3070	40481087	1973-01-18	1973-01-25	1
48139	2858	4112343	2002-10-26	2002-11-04	1
63079	3730	40481087	1993-12-14	1993-12-21	1
25965	1541	4112343	2006-10-29	2006-11-05	1
64770	3833	4278672	1976-04-02	1976-05-02	1
60008	3559	81151	1967-04-08	1967-04-29	1
50828	3010	4112343	1979-02-04	1979-02-17	1
48620	2883	260139	1981-05-08	1981-05-15	1
43058	2566	40481087	1970-09-17	1970-09-24	1
43863	2615	4112343	1984-04-17	1984-04-28	1
53265	3159	4112343	1976-12-08	1976-12-20	1
78498	4653	40481087	1978-07-16	1978-08-06	1
24722	1476	260139	1978-08-18	1978-09-01	1
64575	3822	4112343	1986-02-20	1986-03-02	1
26426	1569	4112343	1965-01-23	1965-02-05	1
3078	182	260139	1984-03-17	1984-03-31	1
31112	1844	4278672	1977-07-15	1977-09-13	1
68105	4026	372328	1960-10-12	1961-01-01	1
55689	3300	440448	1986-08-06	1986-08-07	1
28318	1674	260139	1997-05-07	1997-05-21	1
22958	1371	40481087	1992-12-16	1993-01-06	1
54009	3200	4278672	2013-08-19	2013-11-17	1
51737	3070	40481087	2004-05-02	2004-05-16	1
48140	2858	4283893	1929-01-18	1929-04-26	1
63080	3730	40481087	2004-10-03	2004-10-10	1
25966	1541	4218389	1982-01-19	1982-02-16	1
64771	3833	40481087	1984-03-24	1984-04-14	1
60009	3559	81151	1978-10-26	1978-11-16	1
50829	3010	4218389	1996-08-13	1996-09-10	1
48621	2883	4112343	2003-01-19	2003-02-01	1
44826	2672	28060	2005-06-02	2005-06-10	1
43864	2615	4149245	1987-05-04	1987-07-10	1
53266	3159	4112343	1985-07-07	1985-07-16	1
78499	4653	40481087	1980-01-04	1980-01-25	1
24723	1476	4094814	1956-11-01	1956-12-31	1
64576	3822	4294548	1980-05-06	1980-05-27	1
26427	1569	4116491	1972-08-26	1972-10-15	1
3079	182	4112343	2011-10-01	2011-10-13	1
31113	1844	4283893	1977-09-26	1977-10-31	1
68106	4026	4112343	2019-02-08	2019-02-18	1
55690	3300	40481087	2005-07-22	2005-08-05	1
28319	1674	260139	2004-12-22	2005-01-05	1
22959	1371	78272	1972-02-07	1972-03-13	1
54010	3200	40481087	2002-03-01	2002-03-22	1
51738	3070	192671	2000-01-19	2000-01-20	1
48141	2858	40481087	1943-02-21	1943-03-07	1
63081	3730	0	1994-07-28	1994-07-29	1
25967	1541	40481087	1986-05-10	1986-05-31	1
64772	3833	40481087	2008-10-29	2008-11-05	1
60010	3559	260139	1956-10-20	1956-11-03	1
50830	3010	4278672	1989-05-22	1989-07-21	1
48622	2883	4155034	1966-01-16	1966-01-30	1
44827	2672	195588	1977-11-19	1977-12-29	1
43865	2615	4156265	1956-02-02	1956-02-16	1
53267	3159	40481087	1986-06-06	1986-06-27	1
78500	4653	40481087	2004-07-22	2004-07-29	1
24724	1476	40481087	1970-12-29	1971-01-05	1
64577	3822	4296204	1945-08-21	1945-09-11	1
26428	1569	4283893	1939-05-15	1939-06-26	1
3080	182	4112343	2019-02-04	2019-02-13	1
31114	1844	4296204	1976-06-06	1976-06-20	1
68107	4026	4134304	1970-07-22	1970-08-21	1
55691	3300	28060	1997-04-17	1997-04-28	1
28320	1674	4027663	2004-10-04	2004-10-05	1
22960	1371	372328	1972-07-06	1972-09-19	1
54011	3200	4112343	1963-09-17	1963-09-28	1
51739	3070	372328	1967-12-19	1968-03-03	1
48142	2858	40481087	2003-12-08	2003-12-29	1
63082	3730	80180	1989-08-10	1989-08-11	1
25968	1541	40481087	2004-10-28	2004-11-18	1
66358	3932	28060	1975-09-17	1975-09-24	1
60011	3559	260139	1983-04-29	1983-05-13	1
50831	3010	40481087	2005-11-07	2005-11-14	1
48623	2883	40481087	1965-11-06	1965-11-13	1
44828	2672	260139	1978-07-13	1978-07-20	1
43866	2615	40481087	1987-01-24	1987-01-31	1
53268	3159	40481087	2009-02-03	2009-02-17	1
80678	4791	80180	2004-08-03	2004-08-04	1
24725	1476	257012	1949-09-20	1949-09-21	1
64578	3822	4296204	1969-05-22	1969-06-19	1
26429	1569	4294548	1968-09-29	1968-10-20	1
3081	182	4294548	1955-08-27	1955-11-26	1
31115	1844	40481087	1963-06-24	1963-07-08	1
68108	4026	4237458	1973-04-07	1973-06-06	1
55692	3300	4051466	1985-08-11	2001-11-15	1
28321	1674	4112343	1980-06-23	1980-07-06	1
22961	1371	4109685	1999-06-20	1999-07-04	1
54012	3200	4112343	1992-04-14	1992-04-23	1
51740	3070	4134304	2008-04-24	2008-05-24	1
50529	2992	81151	1971-10-30	1971-11-20	1
63083	3730	321042	1994-07-28	1994-07-29	1
28602	1695	195588	2017-12-17	2018-02-08	1
66359	3932	4142905	1975-06-17	1975-09-15	1
60012	3559	4112343	1959-11-21	1959-11-28	1
50832	3010	28060	1964-12-12	1964-12-22	1
48624	2883	40481087	1998-07-17	1998-08-07	1
44829	2672	260139	1980-04-12	1980-04-26	1
43867	2615	40481087	1997-07-02	1997-07-09	1
53269	3159	78272	2015-06-01	2015-06-29	1
80679	4791	260139	1970-03-12	1970-03-26	1
24726	1476	313217	2003-11-27	2003-11-28	1
64579	3822	40481087	2001-03-15	2001-04-05	1
26430	1569	40481087	1985-11-06	1985-11-13	1
3082	182	40481087	1950-10-15	1950-10-22	1
31116	1844	40481087	1972-07-25	1972-08-15	1
68109	4026	40481087	1980-12-31	1981-01-07	1
55693	3300	4166224	1986-08-06	1986-08-07	1
28322	1674	4112343	2003-04-10	2003-04-20	1
22962	1371	40481087	1990-08-06	1990-08-20	1
54013	3200	40481087	1970-12-23	1971-01-06	1
51741	3070	4146173	1967-08-21	1967-10-27	1
50530	2992	260139	1966-08-29	1966-09-12	1
63084	3730	4116491	2002-03-20	2002-05-05	1
28603	1695	260139	2007-02-27	2007-03-13	1
66360	3932	40481087	2006-08-27	2006-09-17	1
60013	3559	4112343	1978-07-31	1978-08-08	1
50833	3010	81151	1973-07-24	1973-08-14	1
48625	2883	4294548	1966-04-18	1966-05-09	1
44830	2672	378001	1980-04-27	1980-06-26	1
43868	2615	40481087	2015-10-03	2015-10-17	1
53270	3159	381316	2001-05-03	2001-05-04	1
80680	4791	260139	1989-10-27	1989-11-10	1
24727	1476	381316	2011-05-26	2011-05-27	1
64580	3822	40481087	2008-10-31	2008-11-07	1
26431	1569	81151	1973-01-14	1973-02-18	1
3083	182	28060	2003-12-14	2003-12-27	1
33090	1966	28060	1973-04-25	1973-05-02	1
68110	4026	40481087	2004-06-11	2004-07-02	1
55694	3300	40481087	2008-07-29	2008-08-12	1
28323	1674	4152936	1995-12-01	1995-12-15	1
22963	1371	260139	1985-03-02	1985-03-09	1
54014	3200	40481087	1986-12-20	1987-01-10	1
51742	3070	40481087	1983-08-08	1983-08-15	1
50531	2992	372328	1958-03-12	1958-06-27	1
63085	3730	4294548	1984-02-03	1984-06-15	1
28604	1695	375671	1998-07-10	1998-09-08	1
66361	3932	40481087	2011-08-20	2011-09-10	1
60014	3559	4218389	1975-11-13	1975-12-11	1
50834	3010	192671	2004-03-09	2004-03-10	1
48626	2883	40481087	1985-11-22	1985-12-13	1
44831	2672	4027663	1983-11-18	1983-11-19	1
43869	2615	81893	1985-07-04	1985-07-05	1
53271	3159	4112343	1964-06-30	1964-07-07	1
80681	4791	260139	2016-06-04	2016-06-18	1
24728	1476	4112343	1959-10-28	1959-11-05	1
65897	3901	80180	1976-06-26	1976-06-27	1
26432	1569	260139	2005-02-12	2005-02-26	1
3084	182	257012	1999-01-05	1999-03-23	1
33091	1966	78272	1990-12-22	1991-01-12	1
68340	4044	260139	1971-03-18	1971-03-25	1
55695	3300	80180	2016-08-16	2016-08-17	1
28324	1674	4310024	2010-01-01	2010-01-02	1
22964	1371	4134304	1998-04-26	1998-06-25	1
54015	3200	40481087	2015-07-19	2015-08-09	1
51743	3070	40481087	1993-07-30	1993-08-20	1
50532	2992	4059173	2012-05-17	2012-08-15	1
63086	3730	260139	2007-01-24	2007-02-07	1
28605	1695	4056621	2018-03-15	2018-03-16	1
66362	3932	81151	1994-01-08	1994-01-22	1
60015	3559	40481087	2002-09-17	2002-10-01	1
50835	3010	40481087	1996-08-10	1996-08-17	1
48627	2883	80180	2002-06-06	2002-06-07	1
44832	2672	4112343	1964-11-26	1964-12-05	1
43870	2615	4134304	1992-03-15	1992-06-13	1
53272	3159	4112343	2004-01-12	2004-01-24	1
80682	4791	4218389	2007-11-21	2007-12-19	1
24729	1476	4112343	1997-07-22	1997-08-04	1
65898	3901	260139	1993-11-03	1993-11-17	1
26433	1569	4112343	1945-04-09	1945-04-20	1
3085	182	4112343	1976-06-12	1976-06-24	1
33092	1966	81151	1968-04-18	1968-05-02	1
68341	4044	260139	1999-04-29	1999-05-06	1
55696	3300	4112343	1982-10-05	1982-10-18	1
30227	1788	81151	1963-10-06	1963-11-10	1
22965	1371	80180	2008-02-23	2008-02-24	1
56682	3365	78272	1968-03-28	1968-05-02	1
51744	3070	260139	2011-10-07	2011-10-14	1
50533	2992	4112343	1958-03-13	1958-03-23	1
63087	3730	372328	1954-09-28	1954-12-09	1
28606	1695	4112343	1970-11-08	1970-11-21	1
66363	3932	260139	1982-05-12	1982-05-26	1
60016	3559	40481087	2015-01-20	2015-02-03	1
52176	3092	260139	1965-08-05	1965-08-12	1
48628	2883	260139	1994-03-14	1994-03-28	1
44833	2672	4112343	1986-05-17	1986-05-30	1
43871	2615	4294548	1966-08-13	1966-09-10	1
53273	3159	4237458	1994-12-18	1995-02-16	1
80683	4791	40481087	1969-09-19	1969-10-03	1
24730	1476	4112343	2005-06-08	2005-06-19	1
65899	3901	4112343	1947-06-28	1947-07-06	1
26434	1569	4155034	2018-01-28	2018-02-18	1
3086	182	40481087	1960-04-12	1960-04-26	1
33093	1966	81893	1998-12-12	1998-12-13	1
68342	4044	4112343	2003-10-17	2003-10-27	1
55697	3300	4112343	1997-02-02	1997-02-14	1
30228	1788	260139	2007-01-16	2007-01-23	1
22966	1371	4112343	1984-10-27	1984-11-04	1
56683	3365	260139	2012-08-14	2012-08-21	1
51745	3070	4112343	1994-09-29	1994-10-08	1
50534	2992	4112343	2005-01-04	2005-01-12	1
63088	3730	4218389	2019-03-31	2019-04-21	1
28607	1695	4113008	2016-09-15	2016-09-29	1
66364	3932	4112343	2013-11-17	2013-11-24	1
60017	3559	260139	1977-05-22	1977-05-29	1
52177	3092	372328	1961-01-07	1961-07-12	1
48629	2883	4112343	1991-11-04	1991-11-16	1
44834	2672	4112343	1986-08-01	1986-08-09	1
43872	2615	40481087	1963-01-23	1963-02-06	1
53274	3159	40481087	1961-08-19	1961-09-09	1
80684	4791	40481087	1986-10-04	1986-10-18	1
24731	1476	4112343	2005-09-20	2005-09-27	1
65900	3901	4146173	1982-01-01	1982-01-31	1
26435	1569	4296205	2003-12-22	2004-01-12	1
3087	182	40481087	1985-05-24	1985-06-14	1
33094	1966	260139	1978-10-24	1978-11-07	1
68343	4044	40481087	1975-10-21	1975-11-04	1
55698	3300	4112343	2003-07-27	2003-08-07	1
30229	1788	381316	2018-05-24	2018-05-25	1
22967	1371	4112343	2015-03-02	2015-03-15	1
56684	3365	4113008	2017-02-14	2017-03-07	1
51746	3070	4112343	2014-03-30	2014-04-10	1
50535	2992	4146173	1993-07-14	1993-08-13	1
63089	3730	40481087	1965-10-04	1965-10-18	1
28608	1695	4146173	1967-08-22	1967-09-21	1
66365	3932	40481087	2004-01-26	2004-02-02	1
60018	3559	372328	1950-05-23	1950-08-04	1
52178	3092	4112343	1963-10-17	1963-10-24	1
48630	2883	40481087	1969-08-17	1969-08-24	1
44835	2672	4112343	2012-09-19	2012-09-30	1
43873	2615	40481087	1980-02-07	1980-02-21	1
53275	3159	40481087	1966-11-17	1966-11-24	1
80685	4791	40481087	1994-11-12	1994-11-19	1
24732	1476	4152936	1957-10-27	1957-11-10	1
65901	3901	4218389	2012-11-03	2012-12-08	1
26436	1569	40481087	1936-12-12	1936-12-19	1
3088	182	4112343	2008-03-07	2008-03-16	1
33095	1966	260139	2016-07-20	2016-07-27	1
68344	4044	40481087	1975-12-12	1975-12-26	1
55699	3300	40481087	2004-06-08	2004-06-22	1
30230	1788	4112343	2016-12-15	2016-12-22	1
22968	1371	40481087	1974-06-03	1974-06-24	1
56685	3365	40481087	2014-03-18	2014-04-08	1
51747	3070	4283893	1982-06-15	1982-09-07	1
50536	2992	40481087	1976-11-01	1976-11-08	1
63090	3730	257012	1984-03-23	1984-03-24	1
28609	1695	4294548	2009-11-24	2009-12-15	1
66366	3932	40481087	2011-03-02	2011-03-16	1
60019	3559	4278672	1953-06-20	1953-07-20	1
52179	3092	4285898	1994-01-03	1994-01-04	1
48631	2883	40481087	1965-05-27	1965-06-03	1
44836	2672	4146173	1951-11-21	1951-12-21	1
43874	2615	40481087	2006-03-19	2006-04-02	1
53276	3159	40481087	1967-03-02	1967-03-23	1
80686	4791	40481087	1997-08-10	1997-08-24	1
24733	1476	40481087	1958-02-24	1958-03-10	1
65902	3901	40481087	1955-01-22	1955-02-12	1
26437	1569	40481087	1954-10-11	1954-11-01	1
3089	182	40481087	1997-08-17	1997-08-31	1
33096	1966	372328	1965-07-03	1966-04-05	1
68345	4044	40481087	1987-07-03	1987-07-24	1
55700	3300	260139	1983-05-03	1983-05-10	1
30231	1788	4112343	2018-11-13	2018-11-26	1
22969	1371	40481087	2013-10-25	2013-11-08	1
56686	3365	80180	2006-01-23	2006-01-24	1
51748	3070	4310024	1997-01-15	1997-01-16	1
50537	2992	40481087	2009-05-03	2009-05-24	1
63091	3730	4112343	1994-12-06	1994-12-18	1
28610	1695	4116491	2018-03-15	2018-05-08	1
66367	3932	28060	1995-12-08	1995-12-20	1
60020	3559	4278672	1995-09-18	1995-11-17	1
52180	3092	40481087	1967-04-01	1967-04-15	1
48632	2883	40481087	1966-07-15	1966-07-29	1
44837	2672	4218389	1999-11-14	1999-12-12	1
43875	2615	40481087	2010-02-16	2010-02-23	1
53277	3159	40481087	1970-02-14	1970-03-07	1
80687	4791	40481087	2011-12-19	2012-01-02	1
24734	1476	40481087	1967-09-02	1967-09-09	1
65903	3901	40481087	1977-05-18	1977-06-08	1
26438	1569	40481087	1976-12-14	1977-01-04	1
3331	192	260139	2018-09-18	2018-09-25	1
33097	1966	4027663	1990-04-18	1990-04-19	1
68346	4044	80180	1993-06-19	1993-06-20	1
55701	3300	439777	2016-07-27	2016-07-28	1
30232	1788	4294548	1982-12-03	1983-01-07	1
22970	1371	40481087	2015-04-09	2015-04-16	1
56687	3365	372328	2005-08-11	2006-05-26	1
51749	3070	40481087	1981-09-19	1981-10-10	1
50538	2992	28060	1998-07-19	1998-07-28	1
63092	3730	4299128	2011-06-06	2011-07-11	1
28611	1695	40481087	1996-06-12	1996-06-26	1
66368	3932	260139	2018-05-06	2018-05-13	1
60021	3559	40481087	1961-07-14	1961-07-28	1
52181	3092	40481087	2004-08-11	2004-09-01	1
48633	2883	40481087	1979-03-10	1979-03-24	1
44838	2672	4294548	1976-01-26	1976-02-23	1
43876	2615	40481087	2016-11-17	2016-12-08	1
53278	3159	28060	1975-07-03	1975-07-15	1
80688	4791	372328	1969-11-10	1970-03-19	1
24735	1476	40481087	1974-06-24	1974-07-01	1
65904	3901	40481087	2004-09-16	2004-10-07	1
26439	1569	40481087	2012-10-13	2012-10-20	1
3332	192	378001	1979-03-18	1979-05-17	1
33098	1966	4112343	1989-11-06	1989-11-17	1
68347	4044	81151	1997-03-18	1997-04-08	1
55702	3300	4116491	2018-07-27	2018-09-26	1
30233	1788	40481087	1965-11-03	1965-11-24	1
26139	1553	40481087	2007-05-13	2007-05-20	1
56688	3365	40481087	1988-09-14	1988-09-21	1
54877	3250	80180	2002-08-16	2002-08-17	1
50539	2992	81151	2009-04-12	2009-05-03	1
63093	3730	40481087	1987-04-06	1987-04-20	1
28612	1695	28060	2017-10-17	2017-10-26	1
66369	3932	372328	1976-09-09	1977-03-21	1
60022	3559	40481087	2011-07-24	2011-07-31	1
52182	3092	0	1995-09-20	1995-09-21	1
50514	2991	80180	1998-10-16	1998-10-17	1
44839	2672	40481087	1995-06-17	1995-06-24	1
43877	2615	378001	1969-07-07	1969-09-05	1
53279	3159	4237458	1970-06-27	1970-07-27	1
80689	4791	4112343	1982-11-06	1982-11-15	1
24736	1476	40481087	1986-12-21	1986-12-28	1
65905	3901	40481087	2009-10-28	2009-11-11	1
26440	1569	80180	1971-03-15	1971-03-16	1
3333	192	4112343	1944-12-24	1945-01-02	1
33099	1966	80180	2000-04-05	2000-04-06	1
68348	4044	260139	1961-12-25	1962-01-08	1
55703	3300	40481087	1999-11-11	1999-11-25	1
30234	1788	40481087	1985-04-04	1985-04-18	1
26140	1553	260139	1979-11-09	1979-11-16	1
56689	3365	260139	2001-05-06	2001-05-13	1
54878	3250	4112343	1977-06-07	1977-06-17	1
50540	2992	260139	1995-03-19	1995-03-26	1
63094	3730	40481087	1992-01-02	1992-01-16	1
28613	1695	257012	2000-11-08	2000-11-09	1
66370	3932	4112343	1978-11-09	1978-11-21	1
61525	3639	255848	2010-03-27	2010-03-28	1
52183	3092	28060	1970-07-20	1970-08-01	1
50515	2991	260139	1968-02-22	1968-03-07	1
44840	2672	40481087	1996-09-24	1996-10-15	1
43878	2615	4027663	1975-11-09	1975-11-10	1
53280	3159	40481087	1974-11-16	1974-11-30	1
80690	4791	4112343	1994-07-18	1994-07-28	1
26181	1556	4084167	1973-09-25	1973-09-25	1
65906	3901	78272	1939-01-02	1939-01-16	1
26441	1569	80502	2007-03-02	2007-03-03	1
3334	192	4218389	1946-07-04	1946-08-08	1
33100	1966	4116491	1992-04-17	1992-06-07	1
68349	4044	260139	2004-03-12	2004-03-19	1
55704	3300	40481087	2018-08-29	2018-09-05	1
30235	1788	40481087	1991-06-08	1991-06-15	1
26141	1553	260139	1982-10-03	1982-10-17	1
56690	3365	4112343	1993-09-10	1993-09-21	1
54879	3250	40481087	1980-01-23	1980-01-30	1
50541	2992	381316	2011-08-19	2011-08-20	1
65802	3895	260139	1977-02-01	1977-02-15	1
28614	1695	260139	1999-09-01	1999-09-08	1
66371	3932	40481087	2001-02-28	2001-03-07	1
52184	3092	80180	1994-06-02	1994-06-03	1
50516	2991	260139	1990-12-14	1990-12-28	1
44841	2672	40481087	2002-09-22	2002-10-06	1
43879	2615	4112343	1986-03-22	1986-03-31	1
58392	3462	378001	2001-01-28	2001-02-27	1
80691	4791	4237458	2002-04-21	2002-07-20	1
26182	1556	4155034	2011-08-12	2011-08-26	1
65907	3901	260139	1962-04-12	1962-04-19	1
26442	1569	81893	1969-06-23	1969-06-24	1
3335	192	4218389	1996-04-15	1996-05-06	1
33101	1966	4285898	1999-10-08	1999-10-09	1
68350	4044	40481087	1979-02-16	1979-03-02	1
56968	3383	192671	2018-08-30	2018-08-31	1
30236	1788	40481087	1997-03-22	1997-03-29	1
26142	1553	4059173	1968-01-04	1968-04-03	1
56691	3365	4112343	2013-03-14	2013-03-27	1
54880	3250	40481087	2001-12-01	2001-12-08	1
50542	2992	4112343	2002-10-08	2002-10-16	1
65803	3895	4035415	1953-06-30	1953-07-30	1
28615	1695	260139	2016-11-02	2016-11-16	1
66372	3932	80180	2010-11-10	2010-11-11	1
52185	3092	4109685	2011-07-31	2011-08-21	1
50517	2991	4156265	1984-04-27	1984-05-11	1
44842	2672	80180	1995-03-05	1995-03-06	1
43880	2615	4285898	1986-11-26	1986-11-27	1
58393	3462	4112343	1961-11-18	1961-11-25	1
80692	4791	40481087	1984-03-12	1984-03-26	1
26183	1556	40481087	1985-02-19	1985-03-05	1
65908	3901	260139	1990-06-10	1990-06-17	1
26443	1569	260139	2016-06-24	2016-07-08	1
3336	192	40481087	1991-08-12	1991-08-19	1
33102	1966	40481087	2006-05-16	2006-05-30	1
68351	4044	40481087	1984-06-29	1984-07-13	1
56969	3383	372328	1989-05-31	1989-09-21	1
30237	1788	78272	2012-10-19	2012-11-16	1
26143	1553	4294548	1989-11-18	1989-12-09	1
56692	3365	440086	1971-07-16	1973-01-26	1
54881	3250	40481087	2003-01-25	2003-02-15	1
50543	2992	4218389	1979-05-12	1979-06-09	1
65804	3895	4112343	1950-05-10	1950-05-17	1
28616	1695	4218389	2000-06-29	2000-08-03	1
66373	3932	260139	2006-09-27	2006-10-04	1
52186	3092	4112343	1976-06-04	1976-06-12	1
50518	2991	40481087	1967-03-03	1967-03-24	1
44843	2672	372328	1956-05-28	1956-11-11	1
43881	2615	40481087	1964-01-11	1964-01-18	1
58394	3462	4112343	1980-11-09	1980-11-19	1
80693	4791	40481087	1984-10-30	1984-11-06	1
26184	1556	260139	1996-10-26	1996-11-09	1
65909	3901	260139	2010-04-28	2010-05-05	1
26444	1569	372328	1937-11-28	1938-02-11	1
3337	192	28060	1986-03-10	1986-03-23	1
33103	1966	4149245	2010-04-30	2010-07-06	1
68352	4044	81151	1965-08-05	1965-09-02	1
56970	3383	4112343	2016-09-11	2016-09-23	1
30238	1788	257012	1967-03-26	1967-03-27	1
26144	1553	80180	2011-05-18	2011-05-19	1
56693	3365	4112343	1973-11-01	1973-11-14	1
54882	3250	260139	1986-08-15	1986-08-22	1
50544	2992	28060	1968-09-27	1968-10-04	1
65805	3895	40481087	1926-09-25	1926-10-09	1
28617	1695	4283893	2000-10-11	2001-01-31	1
66374	3932	4112343	1981-11-08	1981-11-17	1
52187	3092	4112343	2017-07-08	2017-07-19	1
50519	2991	40481087	1993-02-10	1993-03-03	1
44844	2672	4112343	2008-02-29	2008-03-12	1
43882	2615	40481087	1996-08-16	1996-08-30	1
58395	3462	4112343	1996-08-23	1996-08-30	1
80694	4791	40481087	2003-05-01	2003-05-08	1
26185	1556	4094814	2004-04-20	2004-07-19	1
65910	3901	4109685	1958-08-25	1958-09-08	1
26445	1569	372328	1941-07-29	1941-08-12	1
3338	192	78272	1987-02-04	1987-03-04	1
33104	1966	4218389	2003-06-08	2003-07-06	1
68353	4044	260139	1973-03-09	1973-03-16	1
59624	3537	81151	1978-08-14	1978-09-11	1
30239	1788	372328	1977-09-22	1978-01-12	1
26145	1553	4109685	1978-01-11	1978-02-01	1
56694	3365	4112343	1978-07-23	1978-07-30	1
54883	3250	372328	2009-08-04	2011-02-01	1
50545	2992	80180	1991-12-29	1991-12-30	1
65806	3895	40481087	1947-04-03	1947-04-24	1
28618	1695	4294548	1997-10-24	1997-11-21	1
66375	3932	4142905	1989-01-04	1989-04-04	1
52188	3092	30753	1993-10-05	1993-10-06	1
50520	2991	40481087	2005-02-07	2005-02-14	1
44845	2672	4285898	1994-06-08	1994-06-09	1
43883	2615	260139	1961-04-28	1961-05-05	1
58396	3462	4152936	2018-04-29	2018-05-13	1
80695	4791	40481087	2009-07-13	2009-07-27	1
26186	1556	4112343	1978-09-03	1978-09-16	1
65911	3901	4112343	1941-11-13	1941-11-25	1
26446	1569	372328	1956-01-26	1956-08-31	1
3339	192	80180	1981-10-27	1981-10-28	1
33105	1966	4296204	2019-04-20	2019-05-04	1
68354	4044	4112343	2009-11-26	2009-12-05	1
59625	3537	81893	2000-07-10	2000-07-11	1
30240	1788	378001	2017-10-21	2017-12-20	1
26146	1553	4155034	1990-06-28	1990-07-19	1
56695	3365	4112343	2017-03-09	2017-03-19	1
54884	3250	4283893	1987-09-22	1987-10-27	1
50546	2992	260139	1983-11-09	1983-11-16	1
65807	3895	40481087	1992-03-02	1992-03-16	1
28619	1695	40481087	1971-12-28	1972-01-04	1
66376	3932	4294548	1980-12-24	1981-01-07	1
52189	3092	81151	1956-05-22	1956-06-05	1
50521	2991	40481087	2016-06-22	2016-07-13	1
44846	2672	40481087	1961-03-11	1961-03-25	1
43884	2615	260139	1993-01-28	1993-02-11	1
58397	3462	40481087	1966-10-27	1966-11-17	1
80696	4791	4112343	2015-02-12	2015-02-21	1
26187	1556	4112343	1990-10-29	1990-11-05	1
65912	3901	4112343	1949-09-27	1949-10-06	1
26447	1569	4112343	1986-10-15	1986-10-26	1
3340	192	4112343	1998-02-22	1998-03-02	1
33106	1966	28060	1992-09-19	1992-10-02	1
68355	4044	4112343	2017-10-27	2017-11-08	1
59626	3537	378001	1975-10-29	1975-11-28	1
30241	1788	440086	1971-08-15	1979-08-23	1
26147	1553	40481087	2003-08-04	2003-08-11	1
59446	3529	260139	1993-04-11	1993-04-18	1
54885	3250	40481087	1989-12-20	1989-12-27	1
50547	2992	260139	2000-10-07	2000-10-14	1
65808	3895	40481087	2003-07-08	2003-07-29	1
28620	1695	40481087	1990-03-06	1990-03-27	1
69181	4100	192671	1980-03-19	1980-03-20	1
52190	3092	260139	1982-04-27	1982-05-04	1
50522	2991	260139	1996-04-14	1996-04-21	1
44847	2672	40481087	1975-03-20	1975-03-27	1
43885	2615	4109685	2010-05-10	2010-05-24	1
58398	3462	40481087	1968-11-12	1968-11-19	1
80697	4791	4134304	1968-06-18	1968-07-18	1
26188	1556	40486433	1977-04-04	1993-07-15	1
65913	3901	4113008	2002-02-15	2002-03-01	1
26448	1569	4116491	1976-10-14	1976-12-02	1
3341	192	4112343	2014-02-09	2014-02-21	1
33107	1966	260139	2013-07-12	2013-07-26	1
68356	4044	40481087	1983-12-12	1983-12-26	1
59627	3537	4048171	1963-07-02	1963-07-03	1
30242	1788	4112343	1976-08-17	1976-08-27	1
26148	1553	40481087	2004-10-11	2004-10-18	1
59447	3529	4112343	1957-12-22	1958-01-03	1
54886	3250	260139	1964-05-03	1964-05-10	1
50548	2992	260139	2016-06-30	2016-07-14	1
65809	3895	40481087	2005-09-19	2005-09-26	1
28621	1695	80180	2010-05-03	2010-05-04	1
69182	4100	375671	1951-03-23	1951-04-22	1
52191	3092	321042	1995-09-20	1995-09-21	1
50523	2991	378001	1981-05-13	1981-06-12	1
44848	2672	40481087	2008-12-09	2008-12-16	1
43886	2615	4112343	1980-06-27	1980-07-04	1
58399	3462	40481087	2002-01-02	2002-01-23	1
80698	4791	40481087	1970-12-02	1970-12-16	1
26189	1556	80180	2016-05-07	2016-05-08	1
65914	3901	4218389	1976-01-28	1976-03-03	1
26449	1569	4294548	1979-04-03	1979-04-10	1
3342	192	40481087	1940-06-20	1940-07-11	1
33108	1966	372328	1966-10-02	1967-04-11	1
68357	4044	260139	1975-01-19	1975-02-02	1
59628	3537	4112343	1989-10-30	1989-11-08	1
30243	1788	4112343	1994-03-28	1994-04-06	1
26149	1553	260139	1969-03-30	1969-04-06	1
59448	3529	4218389	1981-02-25	1981-03-25	1
54887	3250	4134304	1973-06-14	1973-09-12	1
50549	2992	372328	1962-12-03	1963-07-12	1
65810	3895	40481087	1944-06-21	1944-07-12	1
28622	1695	192671	2010-07-26	2010-07-27	1
69183	4100	381316	2008-08-27	2008-08-28	1
52192	3092	4027663	1984-07-19	1984-07-20	1
50524	2991	4109685	2018-10-01	2018-10-15	1
44849	2672	81151	2005-08-12	2005-09-02	1
43887	2615	4266809	1987-01-25	1987-01-26	1
58400	3462	40481087	2008-07-27	2008-08-10	1
80699	4791	40481087	2005-03-06	2005-03-27	1
26190	1556	4112343	1981-12-02	1981-12-14	1
65915	3901	78272	1943-01-25	1943-02-15	1
26450	1569	4310024	1968-09-26	1968-09-27	1
3343	192	40481087	1954-04-16	1954-05-07	1
33109	1966	4112343	1991-12-10	1991-12-23	1
68358	4044	260139	2008-06-06	2008-06-13	1
59629	3537	4112343	2001-10-16	2001-10-29	1
30244	1788	4112343	1999-05-13	1999-05-24	1
26150	1553	260139	1977-08-24	1977-08-31	1
59449	3529	4280726	1949-05-02	1993-07-14	1
54888	3250	40481087	1977-10-30	1977-11-13	1
50550	2992	40481087	1969-03-20	1969-04-10	1
65811	3895	40481087	1951-07-10	1951-07-17	1
28623	1695	260139	1986-09-12	1986-09-19	1
69184	4100	40481087	1965-12-12	1965-12-19	1
52193	3092	40481087	1999-10-14	1999-10-28	1
50525	2991	4155034	1989-09-12	1989-10-03	1
44850	2672	4152936	1962-01-27	1962-02-10	1
43888	2615	40481087	1953-04-23	1953-05-07	1
58401	3462	28060	1975-01-27	1975-02-07	1
80700	4791	260139	1981-01-24	1981-01-31	1
26191	1556	4155034	1990-02-19	1990-03-05	1
65916	3901	260139	1942-11-14	1942-11-21	1
26451	1569	40479768	1987-04-06	1987-06-12	1
3344	192	40481087	1967-02-05	1967-02-26	1
33110	1966	4112343	2006-08-24	2006-09-01	1
68359	4044	4218389	2017-01-23	2017-02-27	1
59630	3537	4278672	1980-08-01	1980-08-31	1
30245	1788	4113008	1999-05-26	1999-06-09	1
26151	1553	372328	1967-12-05	1968-02-16	1
59450	3529	4283893	1945-01-28	1945-03-11	1
54889	3250	40481087	2005-04-13	2005-04-27	1
50551	2992	40481087	2014-04-04	2014-04-11	1
65812	3895	40481087	2006-05-02	2006-05-16	1
28624	1695	260139	2001-01-31	2001-02-14	1
69185	4100	40481087	1966-09-20	1966-10-11	1
52194	3092	40481087	2000-01-05	2000-01-26	1
50526	2991	4112343	1966-06-05	1966-06-17	1
44851	2672	4266809	1995-03-05	1995-03-06	1
43889	2615	40481087	1992-06-09	1992-06-30	1
58402	3462	375671	1989-06-30	1989-07-30	1
80701	4791	378001	1970-04-09	1970-05-09	1
26192	1556	40481087	1979-07-03	1979-07-17	1
65917	3901	260139	2017-07-16	2017-07-23	1
26452	1569	40481087	1956-11-25	1956-12-09	1
3345	192	40481087	1978-08-03	1978-08-24	1
33111	1966	4152936	1984-05-08	1984-05-22	1
68360	4044	40481087	2010-07-30	2010-08-13	1
59631	3537	40481087	1985-04-12	1985-04-26	1
30246	1788	40481087	1988-09-05	1988-09-12	1
26152	1553	40481087	2002-06-12	2002-07-03	1
59451	3529	40480160	2017-05-15	2017-08-13	1
54890	3250	28060	1970-01-03	1970-01-14	1
50552	2992	260139	2006-01-02	2006-01-09	1
65813	3895	40481087	2016-09-26	2016-10-17	1
28625	1695	40479768	2003-06-19	2003-07-26	1
69186	4100	257012	2014-05-16	2014-05-17	1
52195	3092	81151	2007-06-08	2007-06-22	1
50527	2991	4112343	1976-07-27	1976-08-07	1
44852	2672	40481087	1985-09-11	1985-10-02	1
43890	2615	40481087	2004-10-06	2004-10-20	1
58403	3462	4112343	1987-08-16	1987-08-27	1
80851	4801	260139	2013-03-04	2013-03-18	1
26193	1556	81151	1989-01-04	1989-01-25	1
65918	3901	4029498	1936-03-18	1936-03-19	1
26453	1569	40481087	1968-02-17	1968-02-24	1
3346	192	40481087	2000-06-07	2000-06-14	1
33112	1966	4218389	1990-01-21	1990-02-25	1
74003	4401	81151	1971-11-20	1971-12-11	1
59632	3537	78272	2015-08-28	2015-09-11	1
30247	1788	40481087	1995-04-02	1995-04-23	1
26153	1553	40481087	2009-12-14	2009-12-21	1
59452	3529	40481087	1965-02-26	1965-03-12	1
54891	3250	81151	2017-04-24	2017-05-22	1
50553	2992	4109685	2007-07-01	2007-07-22	1
65814	3895	80180	1958-05-20	1958-05-21	1
28626	1695	40481087	1970-02-15	1970-03-01	1
69187	4100	260139	1979-06-13	1979-06-27	1
52196	3092	372328	1955-10-25	1956-01-04	1
50528	2991	4112343	1980-07-20	1980-07-30	1
44853	2672	28060	1953-07-15	1953-07-23	1
46653	2779	134438	1994-11-16	1995-10-17	1
58404	3462	4112343	2016-10-18	2016-10-28	1
80852	4801	372328	1972-12-15	1972-12-29	1
26194	1556	4112343	1997-02-04	1997-02-13	1
65919	3901	4112343	1941-06-03	1941-06-15	1
26454	1569	40481087	1980-05-13	1980-05-27	1
3347	192	378001	1976-12-28	1977-01-27	1
33113	1966	4266809	2000-04-05	2000-04-06	1
74004	4401	4051466	1973-01-10	1990-01-20	1
59633	3537	257012	2015-04-13	2015-04-14	1
30248	1788	80180	2004-12-24	2004-12-25	1
30262	1789	81893	2016-05-12	2016-05-13	1
59453	3529	40481087	1976-01-06	1976-01-13	1
54892	3250	40481087	1977-12-19	1977-12-26	1
50554	2992	4112343	1992-11-30	1992-12-13	1
65815	3895	80502	1994-05-20	1994-05-21	1
28627	1695	40481087	1993-08-14	1993-08-21	1
69188	4100	4112343	2009-10-12	2009-10-22	1
52197	3092	4142905	1964-05-24	1964-08-22	1
52075	3087	28060	1943-05-05	1943-05-16	1
44854	2672	30753	1994-04-09	1994-04-10	1
46654	2779	40481087	1990-05-12	1990-06-02	1
58405	3462	4294548	1961-04-29	1961-12-16	1
80853	4801	372328	1975-09-15	1976-07-03	1
26195	1556	4283893	1982-02-09	1982-03-30	1
65920	3901	4112343	2008-09-10	2008-09-18	1
26455	1569	30753	1969-12-20	1969-12-21	1
3348	192	4112343	2015-11-16	2015-11-28	1
33114	1966	40481087	1976-02-11	1976-02-18	1
74005	4401	4112343	2010-11-25	2010-12-07	1
59634	3537	260139	1990-12-22	1990-12-29	1
30249	1788	260139	2010-03-09	2010-03-16	1
30263	1789	260139	2014-11-16	2014-11-30	1
59454	3529	80180	1976-07-07	1976-07-08	1
54893	3250	40481087	1981-07-30	1981-08-20	1
50555	2992	4113008	1981-01-29	1981-02-19	1
65816	3895	260139	1933-09-14	1933-09-28	1
28628	1695	40481087	1999-09-21	1999-10-12	1
69189	4100	4112343	2013-12-31	2014-01-11	1
52198	3092	40481087	1988-12-28	1989-01-04	1
52076	3087	28060	2013-03-21	2013-04-03	1
44855	2672	81893	1993-07-13	1993-07-14	1
46655	2779	80180	2015-04-23	2015-04-24	1
60219	3568	80180	2012-12-04	2012-12-05	1
80854	4801	372328	1997-01-14	1999-10-02	1
26196	1556	4294548	2009-05-25	2009-06-29	1
65921	3901	4296205	1959-08-04	1959-08-25	1
26456	1569	81151	1957-05-17	1957-06-07	1
3349	192	4112343	2018-05-19	2018-05-29	1
36505	2164	260139	1979-05-12	1979-05-26	1
74006	4401	40481087	1990-01-17	1990-01-24	1
59635	3537	260139	1998-10-09	1998-10-23	1
30250	1788	4109685	1990-07-21	1990-08-11	1
30264	1789	4051466	1979-03-05	1994-06-15	1
59455	3529	80502	2004-08-04	2004-08-05	1
54894	3250	40481087	1982-08-23	1982-09-13	1
50556	2992	4218389	1983-01-10	1983-02-07	1
65817	3895	260139	1958-06-26	1958-07-10	1
28629	1695	40481087	2006-10-11	2006-11-01	1
69190	4100	4283893	2014-04-11	2014-09-12	1
52199	3092	40481087	2013-07-24	2013-08-14	1
52077	3087	372328	1941-02-13	1941-06-04	1
44856	2672	260139	1958-08-17	1958-08-31	1
46656	2779	260139	1988-12-11	1988-12-18	1
60220	3568	260139	1976-04-24	1976-05-08	1
80855	4801	4112343	2011-10-04	2011-10-16	1
26197	1556	40481087	1996-12-09	1996-12-23	1
65922	3901	40481087	1939-02-06	1939-02-13	1
26457	1569	260139	2007-06-21	2007-07-05	1
3350	192	4299128	2014-04-02	2014-04-16	1
36506	2164	4112343	1985-05-17	1985-05-30	1
74007	4401	4113008	2017-05-04	2017-05-25	1
59636	3537	260139	2008-06-03	2008-06-10	1
30251	1788	4112343	2002-04-09	2002-04-16	1
30265	1789	4155034	1978-11-08	1978-11-29	1
59456	3529	4112343	1947-08-13	1947-08-21	1
54895	3250	40481087	2002-01-16	2002-01-23	1
50557	2992	40481087	1973-05-25	1973-06-15	1
65818	3895	260139	2004-08-30	2004-09-13	1
29859	1769	260139	2012-08-11	2012-08-18	1
69191	4100	78272	1957-08-23	1957-09-20	1
53425	3170	4094814	1990-04-15	1990-04-16	1
52078	3087	4278672	1996-07-15	1996-10-13	1
44857	2672	260139	1995-12-12	1995-12-26	1
46657	2779	40481087	1992-05-31	1992-06-21	1
60221	3568	260139	1977-07-15	1977-07-22	1
80856	4801	4237458	1983-03-23	1983-06-21	1
26198	1556	40481087	2015-01-07	2015-01-21	1
65923	3901	40481087	1954-06-29	1954-07-20	1
26458	1569	372328	1938-12-08	1939-02-10	1
3351	192	40481087	1947-07-10	1947-07-17	1
36507	2164	4112343	1989-07-12	1989-07-22	1
74008	4401	4116491	2004-12-26	2005-01-30	1
59637	3537	372328	1967-12-21	1968-06-16	1
30252	1788	4112343	2003-10-09	2003-10-21	1
30266	1789	4283893	2016-01-19	2016-03-15	1
59457	3529	4112343	1972-01-04	1972-01-15	1
55139	3268	80180	2009-04-17	2009-04-18	1
50558	2992	40481087	1994-02-15	1994-02-22	1
65819	3895	260139	2008-07-08	2008-07-15	1
29860	1769	40481087	1982-10-30	1982-11-13	1
69192	4100	260139	1947-10-11	1947-10-25	1
53426	3170	4112343	1969-12-25	1970-01-06	1
52079	3087	4296204	1958-08-13	1958-09-03	1
44858	2672	4109685	1972-02-18	1972-03-10	1
46658	2779	40481087	1993-11-18	1993-12-09	1
60222	3568	4230399	2002-07-31	2002-08-30	1
80857	4801	40481087	1971-08-28	1971-09-18	1
27643	1634	81151	1971-02-18	1971-03-11	1
65924	3901	40481087	2005-08-09	2005-08-23	1
26459	1569	4027663	1961-08-29	1961-08-30	1
3352	192	40481087	1986-01-19	1986-02-02	1
36508	2164	4112343	2012-04-07	2012-04-14	1
74009	4401	40481087	1989-01-10	1989-01-17	1
59638	3537	4027663	1992-06-17	1992-06-18	1
30253	1788	4294548	1967-02-26	1967-05-21	1
30267	1789	30753	2016-10-09	2016-10-10	1
59458	3529	4134304	2017-05-15	2017-08-13	1
55140	3268	260139	2014-06-10	2014-06-17	1
50559	2992	40481087	2008-08-15	2008-08-29	1
65820	3895	372328	1925-08-26	1925-11-13	1
29861	1769	81151	1986-05-25	1986-06-22	1
69193	4100	378001	1943-12-30	1944-01-29	1
53427	3170	40481087	1953-03-04	1953-03-25	1
52080	3087	40481087	1982-11-27	1982-12-11	1
44859	2672	40481087	1991-02-09	1991-03-02	1
46659	2779	40481087	2016-05-31	2016-06-07	1
60223	3568	40481087	1987-07-04	1987-07-11	1
80858	4801	40481087	1980-10-09	1980-10-16	1
27644	1634	260139	1985-02-03	1985-02-17	1
65925	3901	40481087	2009-08-10	2009-08-24	1
26460	1569	4112343	1943-06-04	1943-06-16	1
3353	192	78272	1944-04-24	1944-05-15	1
36509	2164	4112343	2012-08-14	2012-08-27	1
74010	4401	40481087	1995-11-29	1995-12-06	1
59639	3537	4084167	1962-06-20	1962-06-20	1
30254	1788	40481087	1982-02-09	1982-03-02	1
30268	1789	80180	2017-01-07	2017-01-08	1
59459	3529	4237458	1951-03-05	1951-05-04	1
55141	3268	4112343	1984-10-02	1984-10-10	1
50885	3014	260139	2000-03-19	2000-03-26	1
65821	3895	4112343	1949-08-28	1949-09-10	1
29862	1769	260139	1978-06-07	1978-06-21	1
69194	4100	40481087	1975-09-03	1975-09-17	1
53428	3170	81151	1958-06-13	1958-06-27	1
52081	3087	40481087	2015-06-06	2015-06-27	1
44860	2672	40481087	2001-05-30	2001-06-20	1
46660	2779	372328	1976-03-18	1976-10-31	1
60224	3568	40481087	2004-08-06	2004-08-27	1
80859	4801	260139	1988-08-24	1988-08-31	1
27645	1634	378419	2013-08-23	2013-08-24	1
65926	3901	40481087	2010-10-12	2010-10-19	1
26461	1569	4149245	1998-12-11	1999-01-17	1
3354	192	260139	1973-10-21	1973-10-28	1
36510	2164	4132546	1983-10-23	1983-10-24	1
74011	4401	40481087	2004-12-17	2004-12-31	1
59640	3537	4112343	1998-06-25	1998-07-02	1
30255	1788	40481087	2006-07-17	2006-08-07	1
30269	1789	133834	1975-10-02	1975-10-03	1
59460	3529	4278672	1949-02-13	1949-05-14	1
55142	3268	4156265	2018-05-21	2018-06-11	1
50886	3014	4112343	1990-11-29	1990-12-09	1
65822	3895	40481087	1938-02-13	1938-02-20	1
29863	1769	260139	2007-12-21	2008-01-04	1
69195	4100	40481087	2007-08-27	2007-09-10	1
53429	3170	81151	1967-10-08	1967-11-12	1
52082	3087	0	2001-02-28	2001-03-01	1
44861	2672	40481087	2012-11-03	2012-11-10	1
46661	2779	372328	2019-05-19	2019-05-20	1
60225	3568	78272	1984-03-16	1984-04-06	1
80860	4801	40481087	1988-05-11	1988-05-25	1
27646	1634	381316	2009-07-03	2009-07-04	1
65927	3901	0	1936-03-18	1936-03-19	1
26462	1569	4285898	1970-05-19	1970-05-20	1
3355	192	260139	2017-07-17	2017-07-24	1
36511	2164	80180	2012-08-05	2012-08-06	1
74012	4401	78272	2012-03-10	2012-03-31	1
59641	3537	4156265	1966-01-30	1966-02-20	1
30256	1788	81151	2008-11-18	2008-12-09	1
30270	1789	260139	1988-04-21	1988-05-05	1
59461	3529	40481087	1949-12-20	1950-01-10	1
55143	3268	4283893	1992-08-14	1992-10-30	1
50887	3014	4283893	1995-11-01	1995-12-06	1
65823	3895	40481087	1952-07-18	1952-08-01	1
29864	1769	378001	1983-06-10	1983-07-10	1
69196	4100	28060	1949-09-01	1949-09-14	1
53430	3170	4112343	1975-10-23	1975-11-04	1
52083	3087	80180	1976-04-05	1976-04-06	1
48839	2895	80180	1997-05-06	1997-05-07	1
46662	2779	4218389	2005-03-16	2005-04-13	1
60226	3568	260139	1986-06-21	1986-07-05	1
80861	4801	40481087	1992-02-13	1992-02-20	1
27647	1634	4112343	1945-11-03	1945-11-15	1
65928	3901	28060	2017-01-23	2017-02-02	1
26463	1569	40481087	1991-07-22	1991-07-29	1
3356	192	372328	1952-04-12	1952-11-12	1
36512	2164	260139	1992-02-07	1992-02-14	1
74013	4401	80180	2009-02-08	2009-02-09	1
59642	3537	40481087	1970-07-16	1970-07-23	1
30257	1788	260139	1991-07-12	1991-07-26	1
30271	1789	260139	2018-06-13	2018-06-27	1
59462	3529	81151	1947-04-11	1947-04-25	1
55144	3268	40481087	2004-01-06	2004-01-20	1
50888	3014	40479422	2013-06-05	2013-08-11	1
65824	3895	40481087	1959-08-31	1959-09-14	1
29865	1769	40481087	2003-03-05	2003-03-19	1
69197	4100	78272	1952-03-17	1952-04-21	1
53431	3170	40481087	1951-01-28	1951-02-04	1
52084	3087	260139	1954-07-07	1954-07-14	1
48840	2895	260139	1962-02-08	1962-02-22	1
46663	2779	4278672	1976-11-13	1977-01-12	1
60227	3568	372328	1970-02-23	1970-05-07	1
80862	4801	40481087	2006-03-15	2006-03-22	1
27648	1634	4112343	2004-12-23	2005-01-04	1
65929	3901	81151	2013-10-04	2013-10-25	1
27462	1623	78272	1955-09-05	1955-09-19	1
3357	192	381316	2014-07-02	2014-07-03	1
36513	2164	260139	2018-12-26	2019-01-09	1
74014	4401	4112343	1974-03-13	1974-03-24	1
59643	3537	40481087	1987-03-24	1987-04-14	1
30258	1788	260139	2011-10-09	2011-10-16	1
30272	1789	4084167	1976-02-22	1976-02-22	1
59463	3529	372328	1944-09-23	1945-01-03	1
55145	3268	40481087	2005-07-18	2005-08-01	1
50889	3014	80180	2012-11-06	2012-11-07	1
65825	3895	40481087	1966-07-14	1966-07-28	1
29866	1769	40481087	2003-09-23	2003-10-07	1
69198	4100	80180	1979-12-21	1979-12-22	1
53432	3170	40481087	1956-07-12	1956-07-19	1
52085	3087	260139	1966-11-25	1966-12-02	1
48841	2895	4112343	1975-06-04	1975-06-11	1
46664	2779	4112343	1996-12-02	1996-12-11	1
60228	3568	4112343	2000-09-01	2000-09-08	1
80863	4801	40481087	2006-04-26	2006-05-03	1
27649	1634	4155034	1981-07-16	1981-08-06	1
65930	3901	380378	1936-03-18	1936-03-19	1
27463	1623	81151	1968-01-14	1968-02-04	1
3358	192	4112343	1953-05-22	1953-05-30	1
36514	2164	372328	1973-08-25	1973-12-07	1
74015	4401	4112343	1993-03-15	1993-03-28	1
59644	3537	81151	1974-12-05	1975-01-02	1
30259	1788	4112343	1976-03-05	1976-03-16	1
30273	1789	4112343	2015-05-23	2015-05-31	1
59464	3529	4112343	1957-05-13	1957-05-24	1
55146	3268	260139	1974-10-15	1974-10-29	1
50890	3014	372328	1974-04-26	1974-06-08	1
65826	3895	40481087	1978-02-23	1978-03-09	1
29867	1769	40481087	2012-12-09	2012-12-16	1
69199	4100	4112343	2003-06-07	2003-06-14	1
53433	3170	40481087	1972-05-06	1972-05-20	1
52086	3087	260139	1984-07-18	1984-07-25	1
48842	2895	4112343	1976-08-08	1976-08-18	1
46665	2779	4278672	2006-02-07	2006-05-08	1
60229	3568	40481087	1988-06-11	1988-07-02	1
80864	4801	40481087	2011-06-14	2011-07-05	1
27650	1634	4278672	1966-12-11	1967-02-09	1
65931	3901	4112343	1939-12-29	1940-01-06	1
27464	1623	257012	1984-07-12	1984-07-13	1
6044	357	81893	1994-04-01	1994-04-02	1
36515	2164	4112343	1974-03-07	1974-03-15	1
74016	4401	260139	2011-05-25	2011-06-08	1
59645	3537	133834	1961-12-29	1978-12-30	1
30260	1788	40481087	2008-08-04	2008-08-18	1
30274	1789	4310024	2015-07-17	2015-07-18	1
59465	3529	4112343	1962-03-14	1962-03-23	1
55147	3268	260139	1988-11-23	1988-12-07	1
50891	3014	378001	1989-01-11	1989-02-10	1
65827	3895	40481087	2003-02-22	2003-03-01	1
29868	1769	372328	1989-03-10	1989-08-16	1
69200	4100	40481087	1978-05-11	1978-05-25	1
53434	3170	40481087	1986-07-14	1986-08-04	1
52087	3087	260139	2002-03-12	2002-03-26	1
48843	2895	40481087	1960-07-14	1960-07-28	1
46666	2779	40481087	1998-07-24	1998-08-07	1
60230	3568	4218389	1975-06-27	1975-08-01	1
80865	4801	80180	2002-08-10	2002-08-11	1
27651	1634	40481087	1995-12-27	1996-01-17	1
65932	3901	4112343	1975-03-26	1975-04-03	1
27465	1623	260139	1958-12-21	1959-01-04	1
6045	357	260139	2000-02-24	2000-03-02	1
36516	2164	4296204	1982-10-07	1982-10-28	1
74017	4401	4112343	2013-01-26	2013-02-02	1
59646	3537	372328	1989-11-23	1992-11-08	1
30261	1788	40481087	2014-06-27	2014-07-04	1
30275	1789	28060	2014-09-10	2014-09-21	1
59466	3529	40481087	1971-02-18	1971-02-25	1
55148	3268	4112343	1991-02-09	1991-02-21	1
50892	3014	40481087	1990-02-20	1990-03-13	1
65828	3895	28060	1946-02-19	1946-03-02	1
29869	1769	4112343	1986-09-26	1986-10-05	1
70892	4210	78272	1990-02-20	1990-03-06	1
53435	3170	80180	1985-08-30	1985-08-31	1
52088	3087	4001336	1991-09-10	1991-10-10	1
48844	2895	40481087	1974-10-02	1974-10-16	1
46667	2779	40481087	2013-11-22	2013-12-06	1
60231	3568	4294548	1978-11-15	1979-02-07	1
80866	4801	378001	1978-07-17	1978-08-16	1
27652	1634	40481087	2002-03-07	2002-03-28	1
65933	3901	4112343	2011-06-09	2011-06-20	1
27466	1623	4112343	1953-11-17	1953-11-29	1
6046	357	375671	1975-03-11	1975-04-10	1
36517	2164	40481087	1976-02-28	1976-03-06	1
74018	4401	40481087	1985-03-16	1985-03-23	1
59647	3537	4283893	2015-01-19	2015-05-25	1
33194	1973	260139	2004-11-04	2004-11-18	1
30276	1789	372328	1977-09-14	1978-02-02	1
59467	3529	375671	2002-10-01	2002-10-31	1
55149	3268	4112343	2003-02-21	2003-03-03	1
50893	3014	40481087	2005-09-24	2005-10-01	1
65829	3895	260139	1963-07-29	1963-08-05	1
29870	1769	40481087	1980-11-27	1980-12-11	1
70893	4210	81151	1979-01-28	1979-02-18	1
53436	3170	260139	1972-12-18	1972-12-25	1
52089	3087	4132546	1991-09-10	1991-09-11	1
48845	2895	134438	1985-12-22	1987-03-22	1
49654	2942	133834	1954-11-28	1970-11-22	1
60232	3568	40481087	1997-09-21	1997-10-05	1
80867	4801	4112343	1997-08-04	1997-08-15	1
27653	1634	28060	1948-08-05	1948-08-18	1
65934	3901	40481087	1965-10-26	1965-11-09	1
27467	1623	40481087	1951-04-08	1951-04-22	1
6047	357	4084167	1955-09-08	1955-09-08	1
36518	2164	40481087	1992-03-17	1992-03-31	1
74019	4401	40481087	1997-02-06	1997-02-20	1
59648	3537	4294548	2012-04-21	2012-05-26	1
33195	1973	378001	1979-05-24	1979-06-23	1
30277	1789	4027663	2007-02-19	2007-02-20	1
59468	3529	378001	1979-04-07	1979-05-07	1
55150	3268	4155034	2013-07-25	2013-08-15	1
50894	3014	40481087	2013-10-25	2013-11-01	1
65830	3895	260139	1974-04-02	1974-04-16	1
29871	1769	40481087	1981-07-16	1981-07-30	1
70894	4210	260139	2007-02-02	2007-02-16	1
53437	3170	260139	1974-04-20	1974-04-27	1
52090	3087	40481087	1963-12-08	1963-12-15	1
48846	2895	260139	1959-12-13	1959-12-20	1
49655	2942	260139	2007-12-09	2007-12-16	1
60233	3568	40481087	2005-10-28	2005-11-11	1
80868	4801	4237458	2016-12-08	2017-02-06	1
27654	1634	260139	1975-03-23	1975-03-30	1
65935	3901	40481087	1978-07-10	1978-07-24	1
27468	1623	80180	1988-12-17	1988-12-18	1
6048	357	4285898	1995-06-25	1995-06-26	1
36519	2164	192671	2012-10-14	2012-10-15	1
74020	4401	40481087	2016-05-07	2016-05-14	1
59649	3537	40481087	1994-01-15	1994-02-05	1
33196	1973	40481087	2014-06-02	2014-06-09	1
30278	1789	4237458	1991-11-21	1992-01-20	1
59469	3529	4112343	1949-01-16	1949-01-24	1
55151	3268	40481087	1975-06-17	1975-07-08	1
50895	3014	257012	1991-02-07	1991-02-08	1
65831	3895	381316	1999-02-12	1999-02-13	1
29872	1769	40481087	2006-10-29	2006-11-12	1
70895	4210	4112343	1999-05-17	1999-05-29	1
53438	3170	260139	1987-10-01	1987-10-15	1
52091	3087	40481087	1972-05-08	1972-05-22	1
48847	2895	4294548	2019-05-26	2019-05-27	1
49656	2942	372328	1954-07-24	1954-10-06	1
60234	3568	28060	1984-01-15	1984-01-28	1
80869	4801	40481087	1982-04-15	1982-05-06	1
27655	1634	372328	1941-01-08	1941-02-14	1
65936	3901	40481087	1992-08-17	1992-08-24	1
27469	1623	317576	2017-07-14	2017-07-15	1
6049	357	40481087	1961-10-03	1961-10-10	1
36520	2164	260139	1978-08-30	1978-09-13	1
74414	4423	4112343	1995-08-09	1995-08-22	1
59650	3537	40481087	2004-11-17	2004-12-01	1
33197	1973	260139	1985-08-24	1985-09-07	1
30279	1789	4285898	2016-11-08	2016-11-09	1
59470	3529	4112343	1989-05-19	1989-05-30	1
55152	3268	81151	1970-07-06	1970-08-10	1
50896	3014	260139	1998-01-21	1998-01-28	1
65832	3895	4112343	1943-02-24	1943-03-05	1
29873	1769	80180	2011-09-06	2011-09-07	1
70896	4210	4218389	1995-10-06	1995-11-10	1
53439	3170	372328	1951-07-20	1951-08-31	1
52092	3087	40481087	1984-11-07	1984-11-21	1
48848	2895	40481087	1994-05-10	1994-05-31	1
49657	2942	372328	1957-09-20	1958-07-09	1
60235	3568	257012	1978-12-13	1978-12-14	1
80870	4801	4112343	1985-06-11	1985-06-19	1
27656	1634	4109685	2017-09-10	2017-09-24	1
65937	3901	40481087	2004-02-28	2004-03-13	1
27470	1623	4112343	1979-01-20	1979-01-31	1
6050	357	40481087	1969-10-02	1969-10-09	1
36521	2164	4001336	1983-10-23	1983-11-22	1
74415	4423	40481087	1991-07-09	1991-07-16	1
59651	3537	40481087	2007-02-27	2007-03-13	1
33198	1973	4112343	1981-05-18	1981-05-26	1
30280	1789	28060	1985-03-07	1985-03-15	1
59471	3529	4146173	1998-12-21	1999-01-20	1
55153	3268	257012	1992-09-11	1992-09-12	1
50897	3014	4294548	1990-12-13	1991-02-21	1
65833	3895	4112343	1946-06-02	1946-06-12	1
29874	1769	40481087	2011-03-28	2011-04-11	1
70897	4210	40481087	1977-07-31	1977-08-14	1
53440	3170	4112343	1960-01-05	1960-01-15	1
52093	3087	40481087	2004-11-07	2004-11-28	1
48849	2895	28060	1967-07-06	1967-07-14	1
49658	2942	4112343	1960-11-21	1960-12-01	1
60236	3568	372328	1971-11-28	1972-05-04	1
80871	4801	4112343	1997-04-21	1997-05-02	1
27657	1634	4112343	1975-09-28	1975-10-08	1
68394	4049	78272	1989-11-01	1989-11-29	1
27471	1623	4112343	1995-12-07	1995-12-14	1
6051	357	40481087	2003-12-16	2004-01-06	1
36522	2164	4156265	2006-09-22	2006-10-13	1
74416	4423	40481087	1992-01-20	1992-02-03	1
62649	3703	81151	1969-12-18	1970-01-08	1
33199	1973	80180	2011-07-17	2011-07-18	1
30281	1789	192671	2017-04-02	2017-04-03	1
59472	3529	40481087	1948-10-30	1948-11-20	1
55154	3268	375671	1977-02-04	1977-04-05	1
50898	3014	40481087	1985-02-01	1985-02-08	1
65834	3895	4112343	1964-08-05	1964-08-14	1
31243	1850	28060	1984-10-06	1984-10-14	1
70898	4210	81151	1976-04-29	1976-05-13	1
53441	3170	4278672	1962-05-07	1962-07-06	1
52094	3087	40481087	2017-11-18	2017-11-25	1
48850	2895	78272	2003-05-25	2003-06-29	1
49659	2942	4112343	2007-07-04	2007-07-13	1
60237	3568	4112343	2016-05-21	2016-06-03	1
80872	4801	4152936	1991-01-10	1991-01-24	1
27658	1634	4112343	1997-08-17	1997-08-30	1
68395	4049	260139	1983-02-10	1983-02-24	1
27472	1623	4294548	1960-10-23	1960-11-13	1
6052	357	28060	1967-06-11	1967-06-21	1
36523	2164	40481087	1973-07-01	1973-07-08	1
74417	4423	260139	2001-10-15	2001-10-29	1
62650	3703	372328	1969-01-22	1969-03-01	1
33200	1973	81151	1978-04-15	1978-04-29	1
30282	1789	40481087	2011-12-22	2012-01-05	1
59473	3529	40481087	2011-02-14	2011-02-21	1
55155	3268	4112343	1974-09-15	1974-09-22	1
50899	3014	40481087	1992-10-20	1992-11-09	1
65835	3895	4112343	1980-09-22	1980-10-02	1
31244	1850	81151	1959-01-24	1959-02-07	1
70899	4210	260139	1991-04-13	1991-04-27	1
53442	3170	40481087	1953-06-30	1953-07-21	1
52095	3087	192671	1976-05-08	1976-05-09	1
48851	2895	81151	2005-05-19	2005-06-02	1
49660	2942	4296204	1965-07-26	1965-08-23	1
61049	3616	81151	2013-05-28	2013-07-02	1
83433	4964	28060	1970-04-20	1970-04-30	1
27659	1634	4296204	2008-01-17	2008-01-31	1
68396	4049	260139	2017-11-13	2017-11-27	1
27473	1623	4294548	1984-06-21	1984-10-11	1
6053	357	80180	1996-04-20	1996-04-21	1
36524	2164	40481087	1984-02-02	1984-02-23	1
74418	4423	40481087	1976-04-26	1976-05-03	1
62651	3703	372328	1970-11-21	1971-05-01	1
33201	1973	4109685	1974-06-21	1974-07-05	1
59474	3529	40481087	2012-03-25	2012-04-08	1
58464	3469	260139	2001-07-18	2001-08-01	1
50900	3014	81151	1984-04-02	1984-05-08	1
65836	3895	4296205	1982-03-30	1982-04-27	1
31245	1850	260139	1999-02-20	1999-02-27	1
70900	4210	4027663	2005-03-28	2005-03-29	1
53443	3170	40481087	1964-12-11	1964-12-18	1
52096	3087	257012	1943-03-27	1943-03-28	1
48852	2895	260139	1984-05-20	1984-05-27	1
49661	2942	4027663	1987-07-21	1987-07-22	1
61050	3616	372328	1960-05-15	1960-08-02	1
83434	4964	28060	2000-05-31	2000-06-12	1
27660	1634	40481087	1948-08-06	1948-08-13	1
68397	4049	4112343	1991-06-14	1991-06-24	1
27474	1623	40481087	1957-08-18	1957-09-01	1
6054	357	80502	2014-12-10	2014-12-11	1
36525	2164	260139	1991-10-01	1991-10-08	1
74419	4423	40481087	1993-08-31	1993-09-14	1
62652	3703	4112343	2006-05-13	2006-05-21	1
33202	1973	4237458	1996-12-20	1997-01-19	1
60893	3609	80180	2018-08-05	2018-08-06	1
58465	3469	372328	2001-11-30	2002-10-02	1
50901	3014	372328	1978-07-17	1979-06-16	1
65837	3895	40481087	1941-02-11	1941-03-04	1
31246	1850	4113008	1976-09-26	1976-10-17	1
70901	4210	4112343	2002-06-16	2002-06-29	1
53444	3170	260139	1968-02-22	1968-03-07	1
52097	3087	260139	1993-10-08	1993-10-15	1
48853	2895	372328	1961-11-01	1961-12-17	1
49662	2942	4112343	1978-08-28	1978-09-06	1
61051	3616	4059173	1975-11-23	1976-02-21	1
83435	4964	260139	1973-11-23	1973-12-07	1
27661	1634	40481087	1996-10-21	1996-10-28	1
68398	4049	4112343	2009-08-01	2009-08-14	1
27475	1623	40481087	1962-02-15	1962-03-01	1
6055	357	260139	1992-03-28	1992-04-04	1
36526	2164	4112343	1973-01-31	1973-02-09	1
74420	4423	80180	2011-03-01	2011-03-02	1
62653	3703	4112343	2010-01-01	2010-01-10	1
33203	1973	40481087	1972-01-12	1972-01-19	1
60894	3609	81151	1983-09-04	1983-09-25	1
58466	3469	4112343	1968-08-20	1968-09-02	1
50902	3014	40481087	1982-12-18	1983-01-08	1
65838	3895	40481087	1976-07-14	1976-07-28	1
31247	1850	40481087	1960-02-26	1960-03-11	1
70902	4210	4112343	2012-02-10	2012-02-22	1
53445	3170	260139	1979-05-15	1979-05-29	1
52098	3087	321042	2001-02-28	2001-03-01	1
48854	2895	372328	1962-04-16	1963-02-24	1
49663	2942	40481087	1962-10-15	1962-11-05	1
61052	3616	40481087	1960-12-16	1961-01-06	1
83436	4964	4112343	1980-05-11	1980-05-21	1
27662	1634	260139	1950-11-07	1950-11-21	1
68399	4049	4294548	2009-04-21	2009-05-12	1
27476	1623	40481087	1993-03-22	1993-03-29	1
6056	357	4027663	1988-10-04	1988-10-05	1
36527	2164	4112343	2011-03-01	2011-03-11	1
74421	4423	372328	1977-07-12	1977-07-26	1
62654	3703	4218389	1973-08-04	1973-09-08	1
33204	1973	260139	1995-09-22	1995-10-06	1
60895	3609	372328	1977-02-16	1977-05-06	1
58467	3469	40481087	1959-09-01	1959-09-15	1
50903	3014	40481087	2017-03-22	2017-04-12	1
65839	3895	40481087	2003-11-03	2003-11-24	1
31248	1850	40481087	1989-04-23	1989-05-07	1
70903	4210	4156265	2017-07-17	2017-07-31	1
53446	3170	372328	1954-09-14	1954-11-26	1
52099	3087	4112343	1992-12-09	1992-12-20	1
48855	2895	372328	1966-04-09	1967-03-19	1
49664	2942	0	2005-07-17	2005-07-18	1
61053	3616	40481087	2002-07-15	2002-07-29	1
83437	4964	4112343	2013-02-07	2013-02-20	1
27663	1634	260139	1992-01-13	1992-01-20	1
68400	4049	40481087	2003-06-06	2003-06-27	1
27477	1623	28060	2017-07-05	2017-07-18	1
6057	357	4059173	1968-04-16	1968-05-16	1
36528	2164	4113008	2014-05-04	2014-05-18	1
74422	4423	372328	1991-05-20	1991-10-04	1
62655	3703	28060	2014-07-22	2014-07-31	1
33205	1973	372328	1974-03-23	1974-05-13	1
60896	3609	4112343	1995-11-21	1995-12-01	1
58468	3469	78272	1969-04-19	1969-05-10	1
52112	3088	28060	1950-08-02	1950-08-15	1
65840	3895	40481087	2019-03-13	2019-04-03	1
31249	1850	28060	1969-05-14	1969-05-24	1
70904	4210	4283893	2001-12-04	2002-01-29	1
53447	3170	4112343	1975-02-10	1975-02-21	1
52100	3087	4112343	2008-05-03	2008-05-13	1
48856	2895	4112343	2007-08-07	2007-08-17	1
49665	2942	28060	2003-01-13	2003-01-24	1
61054	3616	40481087	2016-09-11	2016-10-02	1
83438	4964	4152936	1961-02-07	1961-02-28	1
27664	1634	260139	2006-07-07	2006-07-21	1
68401	4049	40481087	2003-11-30	2003-12-14	1
27478	1623	81151	1952-08-23	1952-09-20	1
6058	357	4112343	1973-05-22	1973-05-31	1
37103	2200	81893	2012-05-26	2012-05-27	1
74423	4423	40481087	1984-10-23	1984-11-06	1
62656	3703	4084167	1985-03-29	1985-03-29	1
33206	1973	4112343	2010-12-21	2010-12-30	1
60897	3609	4112343	2009-05-04	2009-05-14	1
58469	3469	80180	1991-04-15	1991-04-16	1
52113	3088	260139	1964-08-11	1964-08-25	1
67838	4013	372328	1977-07-18	1977-10-23	1
31250	1850	81151	1957-12-09	1957-12-30	1
70905	4210	40481087	1992-06-28	1992-07-19	1
53448	3170	40481087	1965-06-23	1965-07-07	1
52101	3087	4112343	2014-09-28	2014-10-08	1
48857	2895	40481087	1963-02-22	1963-03-01	1
49666	2942	80180	1998-10-01	1998-10-02	1
61055	3616	80180	1991-09-05	1991-09-06	1
83439	4964	40481087	1971-06-24	1971-07-15	1
27665	1634	4294548	1944-05-17	1945-04-04	1
68402	4049	40481087	2012-05-23	2012-06-13	1
27479	1623	260139	2006-08-08	2006-08-22	1
6059	357	40481087	1961-05-13	1961-05-27	1
37104	2200	4112343	1978-05-16	1978-05-28	1
74424	4423	40481087	1996-10-04	1996-10-11	1
62657	3703	4112343	2003-11-08	2003-11-21	1
33207	1973	40481087	1983-03-01	1983-03-08	1
60898	3609	440086	1983-11-27	1992-12-04	1
58470	3469	81151	1991-06-17	1991-07-01	1
52114	3088	4156265	1970-03-16	1970-04-06	1
67839	4013	4112343	1996-05-12	1996-05-22	1
31251	1850	257012	1970-10-27	1971-03-30	1
70906	4210	40481087	1995-09-11	1995-10-02	1
54172	3214	80180	2008-11-27	2008-11-28	1
52102	3087	40481087	1943-09-08	1943-09-15	1
48858	2895	260139	1968-01-29	1968-02-07	1
49667	2942	260139	1992-04-27	1992-05-04	1
61056	3616	372328	1964-02-13	1965-02-16	1
83440	4964	28060	1990-08-29	1990-09-11	1
27666	1634	40481087	1959-03-28	1959-04-04	1
68403	4049	28060	1993-08-15	1993-08-23	1
27480	1623	260139	2009-04-08	2009-04-22	1
6060	357	40481087	1981-09-05	1981-09-12	1
37105	2200	4152936	1978-10-12	1978-10-26	1
74425	4423	40481087	2006-01-31	2006-02-07	1
62658	3703	40481087	1993-06-01	1993-06-15	1
33458	1987	81151	1996-10-24	1996-11-28	1
60899	3609	4027663	2006-11-21	2006-11-22	1
58471	3469	134438	1984-09-30	1987-11-14	1
52115	3088	4218389	1978-10-21	1978-11-18	1
67840	4013	4112343	2011-03-06	2011-03-16	1
31252	1850	4285898	1997-12-24	1997-12-25	1
70907	4210	192671	2017-02-17	2017-02-18	1
54173	3214	260139	2017-05-17	2017-05-24	1
52103	3087	40481087	1978-02-28	1978-03-14	1
48859	2895	260139	1968-06-23	1968-07-07	1
49668	2942	4059173	1968-04-09	1968-06-08	1
61057	3616	4112343	1967-02-09	1967-02-20	1
83441	4964	80180	2000-05-23	2000-05-24	1
27667	1634	80180	1978-12-18	1978-12-19	1
68404	4049	80180	1997-08-13	1997-08-14	1
27481	1623	260139	2019-01-19	2019-02-02	1
6061	357	28060	1992-07-11	1992-07-24	1
37106	2200	4218389	1997-05-10	1997-06-14	1
74426	4423	0	1989-04-21	1989-04-22	1
62659	3703	80180	2010-07-01	2010-07-02	1
33459	1987	81151	2012-04-29	2012-05-20	1
60900	3609	4112343	1987-02-25	1987-03-05	1
58472	3469	372328	1958-06-08	1958-09-17	1
52116	3088	40481087	1953-09-04	1953-09-11	1
67841	4013	80180	2015-04-26	2015-04-27	1
31253	1850	30753	1997-10-25	1997-10-26	1
70908	4210	257012	2002-01-08	2002-01-09	1
54174	3214	440086	1983-02-12	1990-02-20	1
52104	3087	40481087	1998-03-01	1998-03-22	1
48860	2895	260139	2000-03-21	2000-04-04	1
49669	2942	4112343	1975-03-03	1975-03-15	1
61058	3616	4112343	1998-10-19	1998-10-27	1
83442	4964	81151	1965-01-08	1965-01-22	1
27668	1634	257012	1944-08-02	1944-08-03	1
68405	4049	260139	1990-10-27	1990-11-03	1
27482	1623	372328	1956-02-04	1957-01-04	1
6062	357	372328	1956-03-06	1956-03-20	1
37107	2200	4266809	2014-04-16	2014-04-17	1
74427	4423	260139	1998-09-22	1998-09-29	1
62660	3703	260139	2013-08-09	2013-08-16	1
33460	1987	4112343	1952-09-06	1952-09-17	1
60901	3609	4155034	1982-10-18	1982-11-08	1
58473	3469	4109685	1953-08-27	1953-09-10	1
52117	3088	40481087	1998-09-17	1998-10-01	1
67842	4013	372328	1975-11-12	1976-01-25	1
31254	1850	80180	1998-07-22	1998-07-23	1
70909	4210	372328	1986-01-07	1986-02-15	1
54175	3214	4109685	1988-07-02	1988-07-16	1
52105	3087	40481087	2002-10-04	2002-10-11	1
48861	2895	260139	2013-06-10	2013-06-24	1
49670	2942	4134304	1954-05-25	1954-06-24	1
61059	3616	4294548	1961-09-08	1961-12-08	1
83443	4964	40481087	2003-08-27	2003-09-17	1
27669	1634	260139	1956-08-11	1956-08-25	1
68406	4049	372328	1961-07-03	1961-09-12	1
27483	1623	40481087	1953-12-16	1953-12-30	1
6063	357	372328	1977-06-28	1980-06-11	1
37108	2200	4285898	2013-07-20	2013-07-21	1
74428	4423	321042	1989-04-21	1989-04-22	1
62661	3703	4156265	1971-10-30	1971-11-13	1
33461	1987	4112343	2006-04-03	2006-04-15	1
60902	3609	4296205	1986-07-11	1986-07-25	1
58474	3469	4112343	1986-03-06	1986-03-15	1
52118	3088	28060	1940-05-12	1940-05-23	1
67843	4013	372328	1978-12-17	1979-10-28	1
31255	1850	260139	1973-10-17	1973-10-31	1
70910	4210	4059173	1984-12-18	1985-03-18	1
54176	3214	4218389	1976-03-25	1976-04-22	1
52106	3087	40481087	2017-02-22	2017-03-15	1
48862	2895	4296204	2013-01-21	2013-02-04	1
49671	2942	40481087	2018-03-31	2018-04-21	1
61060	3616	4027663	1983-02-19	1983-02-20	1
83444	4964	260139	1966-05-13	1966-05-27	1
27670	1634	313217	2014-08-29	2014-08-30	1
68407	4049	28060	2018-03-01	2018-03-12	1
27484	1623	40481087	1965-08-21	1965-09-11	1
6064	357	4112343	1983-11-16	1983-11-24	1
37109	2200	40481087	2001-09-09	2001-09-23	1
74429	4423	372328	1984-03-21	1984-08-24	1
62662	3703	40481087	2008-01-26	2008-02-02	1
33462	1987	4113008	1993-10-19	1993-11-09	1
60903	3609	40481087	2012-06-16	2012-06-23	1
58475	3469	4134304	1986-02-08	1986-05-09	1
52119	3088	40481087	1982-05-16	1982-06-06	1
67844	4013	378001	2008-02-22	2008-04-22	1
31256	1850	260139	2006-11-29	2006-12-13	1
70911	4210	4310024	2014-12-21	2014-12-22	1
54177	3214	4296205	1991-05-02	1991-05-16	1
52107	3087	260139	1955-12-07	1955-12-21	1
48863	2895	40481087	1962-02-27	1962-03-20	1
49672	2942	260139	1983-05-24	1983-05-31	1
61061	3616	4112343	1969-01-11	1969-01-22	1
83445	4964	4112343	1968-01-16	1968-01-28	1
27671	1634	372328	1939-03-08	1939-05-19	1
68408	4049	80809	1991-03-28	1991-03-29	1
27485	1623	40481087	1973-01-08	1973-01-22	1
6065	357	40481087	1959-06-24	1959-07-15	1
37110	2200	80180	2014-04-16	2014-04-17	1
74430	4423	4112343	2013-06-20	2013-07-02	1
62663	3703	260139	1995-03-09	1995-03-16	1
33463	1987	4237458	1948-04-18	1948-07-17	1
60904	3609	78272	1990-03-06	1990-03-27	1
58476	3469	4296205	1983-02-26	1983-03-26	1
52120	3088	40481087	2004-10-08	2004-10-22	1
67845	4013	260139	1984-06-28	1984-07-05	1
31257	1850	4112343	2005-05-01	2005-05-10	1
70912	4210	40481087	1984-01-30	1984-02-06	1
54178	3214	40481087	1991-11-06	1991-11-13	1
52108	3087	4112343	1968-04-05	1968-04-18	1
48864	2895	40481087	1972-08-17	1972-09-07	1
49673	2942	260139	2012-10-25	2012-11-01	1
61062	3616	4152936	2019-06-01	2019-06-15	1
83446	4964	439777	2016-01-30	2016-01-31	1
27672	1634	4116491	1974-08-31	1974-10-15	1
68409	4049	4113008	1999-06-10	1999-07-01	1
27486	1623	40481087	1983-05-05	1983-05-19	1
6066	357	40481087	1966-04-22	1966-05-13	1
37111	2200	4296204	1982-07-07	1982-07-28	1
74431	4423	4237458	1979-03-04	1979-04-03	1
62664	3703	4059173	1982-01-24	1982-03-25	1
33464	1987	372328	1945-06-03	1945-11-16	1
60905	3609	192671	2018-09-11	2018-09-12	1
58477	3469	40481087	1961-06-14	1961-06-28	1
52121	3088	40481087	2014-01-12	2014-02-02	1
67846	4013	260139	1988-01-10	1988-01-24	1
31258	1850	4283893	1970-09-22	1971-03-30	1
70913	4210	40481087	2006-08-01	2006-08-08	1
54179	3214	192671	2009-01-25	2009-01-26	1
52109	3087	4283893	1943-01-09	1943-04-03	1
49674	2942	313217	2016-09-28	2016-09-29	1
61063	3616	4218389	1997-10-28	1997-11-18	1
83447	4964	4059173	2015-09-27	2015-12-26	1
27673	1634	4146173	1940-08-29	1940-10-28	1
68410	4049	4278672	1979-11-24	1980-02-22	1
27487	1623	40481087	1987-12-30	1988-01-13	1
6067	357	40481087	1970-04-14	1970-04-28	1
37112	2200	4310024	2011-11-28	2011-11-29	1
76140	4523	372328	2017-12-15	2018-02-04	1
62665	3703	4112343	1999-01-17	1999-01-29	1
33465	1987	4156265	2003-07-25	2003-08-15	1
60906	3609	260139	1992-03-01	1992-03-08	1
58478	3469	40481087	1967-11-02	1967-11-23	1
52122	3088	28060	1960-09-08	1960-09-15	1
67847	4013	4112343	1976-09-09	1976-09-21	1
31259	1850	40481087	1993-09-12	1993-09-19	1
70914	4210	80180	2016-12-10	2016-12-11	1
54180	3214	372328	1976-09-14	1977-01-25	1
52110	3087	40481087	1993-12-10	1993-12-17	1
49675	2942	372328	1979-01-20	1981-12-30	1
61064	3616	40481087	1979-11-10	1979-12-01	1
83448	4964	4112343	1966-09-12	1966-09-21	1
27674	1634	40481087	1947-09-28	1947-10-05	1
68411	4049	40481087	1974-05-02	1974-05-16	1
27488	1623	40481087	1999-08-02	1999-08-16	1
6068	357	40481087	1993-07-26	1993-08-02	1
37113	2200	40481087	1978-08-19	1978-09-02	1
76141	4523	378001	1981-11-24	1981-12-24	1
62666	3703	4112343	2016-07-22	2016-07-29	1
33466	1987	4283893	1989-04-10	1989-04-24	1
60907	3609	4112343	2013-02-23	2013-03-03	1
58479	3469	40481087	2016-02-27	2016-03-19	1
52123	3088	439777	1999-03-30	1999-03-31	1
67848	4013	40481087	1984-07-02	1984-07-23	1
31260	1850	192671	1998-09-29	1998-09-30	1
70915	4210	260139	2014-02-24	2014-03-03	1
54181	3214	378001	1985-08-17	1985-10-16	1
52111	3087	40481087	2009-11-07	2009-11-28	1
49676	2942	440448	2005-07-17	2005-07-18	1
61065	3616	40481087	2001-11-03	2001-11-10	1
83449	4964	4112343	1991-12-07	1991-12-14	1
31745	1885	257012	1974-01-05	1974-01-06	1
68412	4049	40481087	2011-06-07	2011-06-21	1
27489	1623	40481087	2015-02-01	2015-02-08	1
6069	357	0	1997-10-04	1997-10-05	1
37114	2200	372328	1978-01-15	1978-05-21	1
76142	4523	4112343	1978-07-01	1978-07-08	1
62667	3703	4113008	1999-07-24	1999-08-07	1
33467	1987	80180	1981-04-25	1981-04-26	1
60908	3609	4266809	2018-08-05	2018-08-06	1
58480	3469	78272	1989-06-22	1989-07-27	1
52124	3088	4112343	1952-01-08	1952-01-21	1
67849	4013	40481087	1984-12-26	1985-01-16	1
31261	1850	260139	1979-10-05	1979-10-19	1
70916	4210	4112343	1978-10-17	1978-10-30	1
54182	3214	4112343	1990-06-11	1990-06-23	1
54315	3221	260139	1977-04-16	1977-04-30	1
49677	2942	4051466	1956-08-04	1972-11-08	1
61066	3616	40481087	2015-03-02	2015-03-16	1
83450	4964	4237458	1978-06-13	1978-08-12	1
31746	1885	260139	2006-11-03	2006-11-17	1
68413	4049	81151	1973-08-29	1973-09-12	1
27490	1623	4112343	2002-05-12	2002-05-22	1
6070	357	440448	1997-10-04	1997-10-05	1
37115	2200	440086	1980-06-08	1985-09-08	1
76143	4523	4156265	2015-11-20	2015-12-04	1
62668	3703	40481087	1973-08-05	1973-08-12	1
33468	1987	4112343	1946-03-17	1946-03-27	1
60909	3609	4296204	1992-01-16	1992-02-06	1
58481	3469	260139	2006-11-11	2006-11-25	1
52125	3088	4112343	1998-05-30	1998-06-10	1
67850	4013	40481087	1989-12-29	1990-01-05	1
31262	1850	372328	1962-05-17	1962-11-30	1
70917	4210	40481087	1978-06-16	1978-06-23	1
54183	3214	4112343	2011-04-06	2011-04-13	1
54316	3221	440086	1970-05-30	1972-01-08	1
49678	2942	4084167	1966-03-23	1966-03-23	1
61067	3616	81893	1990-06-12	1990-06-13	1
83451	4964	40481087	1989-03-21	1989-04-04	1
31747	1885	372328	1976-02-12	1976-08-03	1
68414	4049	4112343	1987-08-19	1987-09-01	1
32349	1924	313217	2019-06-28	2019-06-29	1
6071	357	4112343	1982-12-11	1982-12-18	1
37116	2200	4278672	1991-05-12	1991-08-10	1
76144	4523	4109685	2013-12-09	2013-12-30	1
62669	3703	40481087	1976-08-01	1976-08-22	1
33469	1987	4112343	1968-07-15	1968-07-24	1
60910	3609	40481087	1979-05-12	1979-06-02	1
58482	3469	260139	2015-09-18	2015-10-02	1
52126	3088	80180	1980-08-21	1980-08-22	1
67851	4013	40481087	2002-02-08	2002-03-01	1
31263	1850	4027663	1986-12-07	1986-12-08	1
70918	4210	40481087	2004-08-25	2004-09-01	1
54184	3214	4310024	2007-06-06	2007-06-07	1
54317	3221	40481087	1974-05-13	1974-05-27	1
49679	2942	4112343	1961-06-02	1961-06-10	1
61068	3616	260139	2012-03-15	2012-03-22	1
84075	5000	80180	1973-12-02	1973-12-03	1
31748	1885	372328	1977-08-28	1978-02-07	1
68415	4049	4113008	1974-08-08	1974-08-22	1
32350	1924	4134304	1978-08-26	1978-11-24	1
6072	357	4113008	1961-11-05	1961-11-19	1
37117	2200	260139	1981-09-27	1981-10-11	1
76145	4523	4112343	1979-04-06	1979-04-18	1
62670	3703	40481087	1998-11-21	1998-12-05	1
33470	1987	4112343	1998-12-18	1998-12-31	1
58483	3469	4112343	1956-08-14	1956-08-22	1
52127	3088	260139	1947-12-30	1948-01-06	1
67852	4013	40481087	2005-08-10	2005-08-24	1
31264	1850	4112343	2013-06-01	2013-06-08	1
72726	4328	260139	1993-12-31	1994-01-14	1
54185	3214	81151	2005-10-29	2005-11-26	1
54318	3221	81151	1974-09-01	1974-09-15	1
49680	2942	4112343	2002-03-07	2002-03-18	1
61069	3616	4112343	1970-08-18	1970-08-31	1
84076	5000	260139	2007-06-12	2007-06-26	1
31749	1885	40481087	2009-01-07	2009-01-21	1
68416	4049	40481087	1993-08-09	1993-08-23	1
32351	1924	40481087	1973-09-26	1973-10-10	1
6073	357	4142905	1959-12-16	1960-01-15	1
37118	2200	4027663	2005-06-02	2005-06-03	1
76146	4523	4112343	2012-03-28	2012-04-08	1
63238	3739	28060	2007-02-01	2007-02-12	1
33471	1987	4112343	2001-10-17	2001-10-24	1
58484	3469	372328	1956-11-09	1957-09-11	1
52128	3088	378419	2017-02-10	2017-02-11	1
67853	4013	260139	2008-11-10	2008-11-17	1
31265	1850	4134304	1961-12-23	1962-02-21	1
72727	4328	260139	2015-02-02	2015-02-09	1
54186	3214	260139	2003-12-31	2004-01-07	1
54319	3221	260139	1967-09-09	1967-09-23	1
49681	2942	4112343	2012-10-18	2012-10-30	1
61070	3616	4112343	1982-04-04	1982-04-14	1
84077	5000	372328	1938-09-22	1938-11-29	1
31750	1885	40481087	2015-07-07	2015-07-14	1
68417	4049	40481087	1998-12-01	1998-12-22	1
32352	1924	40481087	2000-06-10	2000-07-01	1
6074	357	4155034	2016-08-23	2016-09-13	1
37119	2200	4112343	1995-09-28	1995-10-09	1
76147	4523	4218389	1984-01-13	1984-02-17	1
63239	3739	80180	2007-02-15	2007-02-16	1
33472	1987	4237458	1967-10-06	1967-12-05	1
58485	3469	4218389	1998-08-30	1998-10-04	1
52129	3088	4109685	1993-03-04	1993-03-25	1
67854	4013	372328	1980-04-25	1980-11-02	1
31266	1850	4155034	1963-01-17	1963-02-07	1
72728	4328	372328	1976-02-02	1976-05-19	1
54187	3214	372328	1975-06-12	1975-07-22	1
54320	3221	260139	1977-02-07	1977-02-14	1
49682	2942	4112343	2015-09-17	2015-09-25	1
61071	3616	4116491	2004-02-14	2004-04-05	1
84078	5000	4027663	1964-08-16	1964-08-17	1
31751	1885	260139	2019-04-01	2019-04-08	1
70637	4197	372328	1985-10-15	1985-12-22	1
32353	1924	78272	1985-10-18	1985-11-01	1
6075	357	4156265	1983-04-28	1983-05-19	1
37120	2200	4112343	2008-03-06	2008-03-14	1
76148	4523	40481087	1985-04-16	1985-04-23	1
63240	3739	4112343	2005-03-26	2005-04-08	1
33473	1987	28060	1947-11-21	1947-11-29	1
58486	3469	40479422	1993-03-22	1993-04-28	1
52130	3088	4113008	1963-06-07	1963-06-21	1
67855	4013	4112343	1989-04-20	1989-05-01	1
31267	1850	40481087	1959-04-09	1959-04-23	1
72729	4328	260139	2003-08-06	2003-08-20	1
54188	3214	4112343	2016-09-14	2016-09-24	1
54321	3221	260139	2001-01-29	2001-02-05	1
49683	2942	40481087	1989-11-21	1989-12-05	1
61072	3616	40481087	1991-06-09	1991-06-30	1
84079	5000	4146173	1991-11-16	1991-12-16	1
31752	1885	4283893	1973-12-01	1974-04-06	1
70638	4197	372328	1986-06-20	1986-08-24	1
32354	1924	80180	2017-03-04	2017-03-05	1
6076	357	4283893	1983-10-09	1984-01-08	1
38427	2286	372328	1973-08-26	1974-01-28	1
76149	4523	40481087	1998-06-21	1998-07-05	1
63241	3739	40481087	1968-04-16	1968-04-23	1
33474	1987	260139	1950-03-11	1950-03-25	1
58487	3469	40481087	2000-01-13	2000-01-20	1
52131	3088	40481087	1955-09-06	1955-09-13	1
67856	4013	4112343	1990-05-29	1990-06-11	1
31268	1850	40481087	1972-06-28	1972-07-19	1
72730	4328	4218389	2007-08-18	2007-09-22	1
54189	3214	40481087	2018-11-27	2018-12-18	1
54322	3221	440448	1967-06-02	1967-06-03	1
49684	2942	40481087	2014-03-07	2014-03-14	1
61073	3616	40481087	2000-07-20	2000-08-03	1
84080	5000	4155034	1947-05-22	1947-06-12	1
31753	1885	4294548	1987-09-12	1987-10-03	1
70639	4197	4149245	2009-12-08	2010-02-13	1
32355	1924	257012	1982-01-02	1982-01-03	1
6077	357	40481087	2016-10-06	2016-10-13	1
38428	2286	4112343	1980-10-17	1980-10-26	1
76150	4523	40481087	2010-07-24	2010-07-31	1
63242	3739	40481087	2014-10-25	2014-11-15	1
33475	1987	372328	1948-06-03	1948-12-03	1
58488	3469	40481087	2010-07-01	2010-07-22	1
52132	3088	40481087	1979-06-17	1979-06-24	1
67857	4013	40481087	2005-04-22	2005-05-06	1
31269	1850	40481087	1974-09-13	1974-10-04	1
72731	4328	4278672	1995-06-22	1995-09-20	1
970	57	260139	1982-01-01	1982-01-08	1
54323	3221	40481087	2003-10-28	2003-11-11	1
51267	3044	4112343	1972-12-04	1972-12-14	1
64060	3788	80180	2006-12-14	2006-12-15	1
84081	5000	4278672	2011-03-06	2011-06-04	1
31754	1885	40481087	2013-03-30	2013-04-13	1
70640	4197	80180	2017-04-30	2017-05-01	1
32356	1924	40481087	1986-05-04	1986-05-25	1
6639	393	257012	2015-11-30	2015-12-01	1
38429	2286	4112343	2012-06-24	2012-07-05	1
76151	4523	80180	2018-01-04	2018-01-05	1
63243	3739	28060	2001-10-28	2001-11-08	1
33476	1987	372328	1964-09-10	1966-06-03	1
60468	3579	321042	2006-05-20	2006-05-21	1
53500	3174	4112343	2001-10-18	2001-10-30	1
67858	4013	40481087	2006-01-27	2006-02-03	1
31270	1850	40481087	1991-03-05	1991-03-19	1
72732	4328	40481087	2006-08-29	2006-09-05	1
971	57	260139	1982-07-09	1982-07-23	1
54324	3221	40481087	2011-06-11	2011-06-18	1
51268	3044	4112343	1991-06-26	1991-07-04	1
64061	3788	4112343	1991-03-16	1991-03-27	1
84082	5000	260139	1953-04-08	1953-04-15	1
31755	1885	80180	2009-11-05	2009-11-06	1
70641	4197	4059173	2007-02-22	2007-04-23	1
32357	1924	4112343	2015-10-27	2015-11-03	1
6640	393	260139	1967-01-28	1967-02-11	1
38430	2286	0	1971-08-31	1971-09-01	1
76152	4523	81151	1994-07-24	1994-08-21	1
63244	3739	28060	2014-12-15	2014-12-27	1
33477	1987	4112343	1944-08-09	1944-08-20	1
60469	3579	4155034	1965-10-26	1965-11-16	1
53501	3174	260139	1989-08-29	1989-09-12	1
67859	4013	40481087	2017-01-14	2017-02-04	1
31271	1850	40481087	1994-11-19	1994-12-10	1
72733	4328	40481087	2016-07-21	2016-07-28	1
972	57	4109685	1971-02-27	1971-03-13	1
54325	3221	28060	1970-02-26	1970-03-07	1
51269	3044	28060	2017-01-30	2017-02-09	1
64062	3788	40481087	1968-05-30	1968-06-06	1
84083	5000	260139	1992-11-06	1992-11-13	1
31756	1885	372328	1978-11-04	1979-02-13	1
70642	4197	40481087	2010-12-22	2011-01-05	1
32358	1924	4283893	1981-12-05	1982-02-20	1
6641	393	40481087	1958-08-08	1958-08-29	1
38431	2286	260139	1969-12-29	1970-01-05	1
76153	4523	4112343	2014-03-02	2014-03-15	1
63245	3739	260139	2005-05-27	2005-06-03	1
33478	1987	4112343	1954-02-12	1954-02-25	1
60470	3579	40479768	1996-04-21	1996-06-27	1
53502	3174	4294548	1998-10-10	1998-12-19	1
69560	4121	81151	1925-11-18	1925-12-09	1
31272	1850	40481087	1995-06-13	1995-06-27	1
72734	4328	80180	2009-07-13	2009-07-14	1
973	57	4112343	1983-12-03	1983-12-10	1
54326	3221	28060	1986-03-01	1986-03-14	1
51270	3044	81151	2013-09-30	2013-11-04	1
64063	3788	28060	1965-02-10	1965-02-21	1
84084	5000	4059173	2000-06-01	2000-07-01	1
31757	1885	4112343	2009-02-19	2009-02-28	1
70643	4197	372328	1988-06-14	1988-08-21	1
32359	1924	40481087	1984-02-17	1984-03-09	1
6642	393	40481087	2008-06-14	2008-06-28	1
38432	2286	372328	1957-11-01	1957-12-09	1
76154	4523	4134304	1989-01-21	1989-02-20	1
63246	3739	440086	1979-08-11	1985-08-19	1
33479	1987	40481087	1951-10-07	1951-10-21	1
60471	3579	80180	1997-09-08	1997-09-09	1
53503	3174	40481087	1992-06-20	1992-07-11	1
69561	4121	4056621	1971-07-20	1971-07-21	1
32859	1952	28060	1996-12-09	1996-12-21	1
72735	4328	195588	1998-05-27	1998-07-19	1
974	57	4112343	2010-07-06	2010-07-16	1
54327	3221	372328	1965-05-21	1965-11-06	1
51271	3044	4218389	1974-08-23	1974-09-13	1
64064	3788	28060	1975-11-25	1975-12-02	1
84085	5000	4112343	1941-04-13	1941-04-26	1
31758	1885	40481087	1976-03-31	1976-04-07	1
70644	4197	4112343	2016-03-10	2016-03-17	1
32360	1924	4112343	1980-02-21	1980-03-01	1
6643	393	30753	1996-07-18	1996-07-19	1
38433	2286	440448	1971-08-31	1971-09-01	1
76155	4523	4152936	2016-11-28	2016-12-19	1
63247	3739	4112343	1973-04-26	1973-05-03	1
34841	2073	30753	2002-05-31	2002-06-01	1
60472	3579	260139	2017-07-22	2017-07-29	1
53504	3174	40481087	1994-03-09	1994-03-30	1
69562	4121	4112343	1923-12-22	1924-01-02	1
32860	1952	4112343	1962-07-04	1962-07-14	1
72736	4328	260139	2016-03-07	2016-03-21	1
975	57	4156265	1976-08-13	1976-09-03	1
54328	3221	372328	1967-01-30	1967-05-06	1
51272	3044	40481087	1974-06-30	1974-07-14	1
64065	3788	28060	1997-11-24	1997-12-07	1
84086	5000	40481087	1947-04-05	1947-04-19	1
31759	1885	40481087	2000-11-29	2000-12-13	1
70645	4197	4134304	1997-03-16	1997-04-15	1
32361	1924	4283893	1990-02-11	1990-05-27	1
6644	393	80180	1997-07-13	1997-07-14	1
38434	2286	4109685	2004-02-24	2004-03-09	1
76156	4523	40481087	2008-07-13	2008-07-27	1
63248	3739	4112343	1973-09-04	1973-09-12	1
34842	2073	260139	1984-12-30	1985-01-06	1
60473	3579	260139	1990-02-19	1990-03-05	1
53505	3174	40481087	2012-10-25	2012-11-15	1
69563	4121	4112343	1952-02-23	1952-03-06	1
32861	1952	4294548	1995-12-06	1996-03-13	1
72737	4328	4112343	1980-05-13	1980-05-21	1
976	57	40481087	2004-04-12	2004-04-26	1
54329	3221	4218389	1992-07-12	1992-08-16	1
51273	3044	40481087	2000-04-03	2000-04-24	1
64066	3788	81151	1974-05-21	1974-06-25	1
84087	5000	40481087	1983-02-05	1983-02-26	1
31760	1885	40481087	2011-08-15	2011-08-29	1
70646	4197	40481087	1988-09-05	1988-09-12	1
34235	2034	28060	2006-06-22	2006-07-04	1
6645	393	192671	1997-10-01	1997-10-02	1
38435	2286	4112343	1972-04-17	1972-04-28	1
76157	4523	260139	1998-11-27	1998-12-04	1
63249	3739	4218389	1968-09-07	1968-09-28	1
34843	2073	260139	1987-09-25	1987-10-02	1
60474	3579	372328	1968-09-10	1968-10-05	1
53506	3174	257012	1998-12-12	1998-12-13	1
69564	4121	4112343	1976-09-21	1976-10-04	1
32862	1952	40481087	1989-05-18	1989-06-01	1
72738	4328	4112343	1990-03-01	1990-03-11	1
977	57	260139	2013-02-24	2013-03-10	1
54330	3221	0	1967-06-02	1967-06-03	1
51274	3044	40481087	2010-03-10	2010-03-24	1
64067	3788	40481087	1990-03-22	1990-03-29	1
84088	5000	40481087	2008-02-04	2008-02-25	1
33533	1991	0	2011-02-21	2011-02-22	1
70647	4197	372328	1990-10-10	1991-09-01	1
34236	2034	30753	1962-12-29	1962-12-30	1
6646	393	4027663	1986-01-02	1986-01-03	1
38436	2286	40481087	2006-09-21	2006-10-12	1
76158	4523	260139	2004-08-06	2004-08-20	1
63250	3739	4237458	2006-06-11	2006-08-10	1
34844	2073	372328	1987-06-21	1987-10-02	1
60475	3579	4112343	1990-10-19	1990-10-28	1
53507	3174	260139	1994-12-23	1995-01-06	1
69565	4121	40481087	1959-01-14	1959-01-28	1
32863	1952	78272	1991-03-24	1991-04-21	1
72739	4328	4294548	2017-05-29	2017-06-12	1
978	57	40481087	1970-12-07	1970-12-14	1
54331	3221	80180	2000-06-11	2000-06-12	1
51275	3044	372328	1969-07-20	1969-09-30	1
64068	3788	78272	2005-07-12	2005-08-02	1
84089	5000	30753	1973-08-04	1973-08-05	1
33534	1991	80180	1977-07-24	1977-07-25	1
70648	4197	381316	2011-02-20	2011-02-21	1
34237	2034	80180	1963-09-25	1963-09-26	1
6647	393	4112343	1993-11-27	1993-12-04	1
38437	2286	40481087	2007-11-13	2007-11-27	1
76159	4523	260139	2017-04-30	2017-05-07	1
63251	3739	28060	1971-01-26	1971-02-03	1
34845	2073	4027663	1996-02-07	1996-02-08	1
60476	3579	4112343	2006-09-07	2006-09-17	1
53508	3174	4112343	1998-05-25	1998-06-05	1
69566	4121	81151	1986-08-29	1986-09-26	1
32864	1952	80502	2015-03-02	2015-03-03	1
72740	4328	40481087	1983-04-04	1983-04-25	1
979	57	40481087	1992-02-27	1992-03-19	1
54332	3221	4112343	1975-12-09	1975-12-20	1
51276	3044	4152936	1998-02-09	1998-02-23	1
64069	3788	260139	1987-04-22	1987-04-29	1
84090	5000	260139	1956-01-12	1956-01-26	1
33535	1991	317576	1993-10-11	1993-10-12	1
74696	4442	80180	2015-04-28	2015-04-29	1
34238	2034	260139	1939-12-22	1939-12-29	1
6648	393	4283893	2015-10-26	2016-02-01	1
38438	2286	40481087	2010-04-21	2010-05-05	1
76160	4523	4112343	1977-10-19	1977-10-30	1
63252	3739	4112343	1983-09-07	1983-09-17	1
34846	2073	4112343	1995-03-29	1995-04-10	1
60477	3579	0	2006-05-20	2006-05-21	1
53509	3174	28060	1991-12-18	1991-12-26	1
69567	4121	261325	1966-05-08	1966-05-09	1
32865	1952	198199	2006-07-20	2006-09-10	1
72741	4328	40481087	2006-02-02	2006-02-23	1
980	57	28060	1976-10-29	1976-11-08	1
54333	3221	4112343	2012-02-27	2012-03-07	1
51277	3044	40481087	1994-09-02	1994-09-23	1
64070	3788	372328	1968-07-21	1968-12-31	1
84091	5000	372328	1940-10-19	1941-01-28	1
33536	1991	4112343	1983-03-28	1983-04-07	1
74697	4442	257012	1985-07-22	1985-07-23	1
34239	2034	4035415	2016-11-04	2017-01-03	1
6649	393	4294548	2004-01-18	2004-02-01	1
38439	2286	28060	1998-01-28	1998-02-06	1
76161	4523	4294548	1999-03-09	1999-08-24	1
63253	3739	28060	2000-09-19	2000-10-01	1
34847	2073	28060	2015-07-08	2015-07-17	1
60478	3579	4113008	2004-11-12	2004-12-03	1
53510	3174	80180	2014-12-19	2014-12-20	1
69568	4121	4059173	1952-05-24	1952-07-23	1
32866	1952	378001	2017-09-22	2017-11-21	1
74192	4411	257012	1966-06-08	1966-06-09	1
981	57	260139	1986-07-31	1986-08-14	1
54334	3221	4142905	1966-03-17	1966-04-16	1
51278	3044	28060	1977-10-21	1977-11-03	1
64071	3788	440086	1975-08-09	1982-08-17	1
84092	5000	378419	2016-08-16	2016-08-17	1
33537	1991	4112343	1991-11-19	1991-11-29	1
74698	4442	81151	1987-02-14	1987-03-07	1
34240	2034	4218389	2006-02-25	2006-03-25	1
6650	393	260139	1998-09-06	1998-09-20	1
38440	2286	78272	1996-01-09	1996-02-06	1
77882	4621	372328	1978-01-17	1978-07-03	1
63254	3739	4112343	1979-07-17	1979-07-28	1
34848	2073	260139	2007-11-18	2007-11-25	1
60479	3579	4152936	1969-12-25	1970-01-08	1
53511	3174	4218389	2000-01-02	2000-02-06	1
69569	4121	4112343	1958-09-04	1958-09-13	1
32867	1952	4112343	1993-05-19	1993-05-28	1
74193	4411	260139	1951-04-24	1951-05-01	1
982	57	4112343	2008-06-04	2008-06-14	1
56835	3376	260139	1979-10-20	1979-10-27	1
51279	3044	80180	2007-09-29	2007-09-30	1
64072	3788	4112343	1974-03-22	1974-04-02	1
84093	5000	4112343	1977-07-04	1977-07-13	1
33538	1991	40481087	1998-01-30	1998-02-13	1
74699	4442	4112343	1999-11-23	1999-11-30	1
34241	2034	4283893	1968-01-10	1968-01-24	1
6651	393	4310024	1994-11-26	1994-11-27	1
38441	2286	80180	1996-10-07	1996-10-08	1
77883	4621	372328	1980-10-22	1981-07-06	1
63255	3739	4112343	2007-07-14	2007-07-23	1
34849	2073	378001	1980-06-06	1980-07-06	1
63629	3761	4112343	1960-12-09	1960-12-20	1
63937	3783	40481087	1953-05-05	1953-05-12	1
69570	4121	4112343	1965-05-11	1965-05-21	1
32868	1952	40481087	1960-06-09	1960-06-16	1
74194	4411	260139	1962-01-16	1962-01-23	1
983	57	40481087	2002-03-05	2002-03-19	1
56836	3376	378001	1980-10-01	1980-10-31	1
51280	3044	372328	1971-01-23	1971-06-29	1
64073	3788	4112343	1985-08-29	1985-09-11	1
84094	5000	4294548	2013-06-03	2013-06-10	1
33539	1991	28060	1987-07-02	1987-07-09	1
74700	4442	4112343	2007-02-22	2007-03-04	1
34242	2034	4294548	1942-05-21	1942-10-15	1
6652	393	40481087	2017-09-28	2017-10-19	1
38442	2286	81151	1967-03-14	1967-04-11	1
77884	4621	4112343	1995-03-20	1995-03-27	1
63256	3739	4278672	2009-08-24	2009-10-23	1
34850	2073	381316	2012-04-13	2012-04-14	1
63630	3761	4112343	2009-08-19	2009-08-28	1
63938	3783	40481087	1972-10-19	1972-10-26	1
69571	4121	4112343	1978-03-31	1978-04-07	1
32869	1952	40481087	1963-10-25	1963-11-08	1
74195	4411	260139	1977-07-15	1977-07-22	1
984	57	40481087	2005-07-27	2005-08-17	1
56837	3376	4112343	1966-08-19	1966-08-31	1
51281	3044	4112343	1995-07-14	1995-07-24	1
64074	3788	28060	2004-03-06	2004-03-14	1
84095	5000	4296204	1943-06-28	1943-07-12	1
33540	1991	372328	1946-04-28	1946-09-16	1
74701	4442	40481087	2005-12-01	2005-12-08	1
34243	2034	40481087	1926-04-10	1926-04-17	1
6653	393	40481087	2018-08-22	2018-09-12	1
38443	2286	372328	1959-03-04	1959-08-10	1
77885	4621	4156265	1978-04-17	1978-05-01	1
73080	4348	4112343	2017-07-29	2017-08-06	1
34851	2073	4112343	1995-09-08	1995-09-17	1
63631	3761	40481087	1959-12-08	1959-12-29	1
63939	3783	40481087	1999-02-28	1999-03-14	1
69572	4121	4299128	1948-05-17	1948-06-14	1
32870	1952	78272	1964-01-10	1964-02-14	1
74196	4411	260139	2002-07-08	2002-07-15	1
985	57	80180	1997-04-01	1997-04-02	1
56838	3376	4112343	1994-12-25	1995-01-07	1
51282	3044	4296205	2012-10-07	2012-11-04	1
64075	3788	260139	1968-12-19	1968-12-26	1
84096	5000	40481087	1938-10-30	1938-11-13	1
33541	1991	4112343	1981-10-22	1981-10-31	1
74702	4442	260139	1994-03-10	1994-03-17	1
34244	2034	40481087	1951-11-24	1951-12-08	1
6654	393	260139	1962-08-13	1962-08-20	1
38444	2286	40481087	1958-12-03	1958-12-24	1
77886	4621	40481087	1995-12-17	1995-12-31	1
73081	4348	40481087	1992-02-12	1992-02-19	1
34852	2073	4218389	1986-09-03	1986-09-24	1
63632	3761	40481087	1973-04-16	1973-04-30	1
63940	3783	40481087	2008-09-27	2008-10-11	1
69573	4121	40481087	1925-09-28	1925-10-19	1
32871	1952	260139	1965-09-04	1965-09-11	1
74197	4411	4112343	1951-10-22	1951-11-02	1
986	57	260139	1992-02-19	1992-02-26	1
56839	3376	40481087	1976-01-15	1976-01-22	1
51283	3044	40481087	2006-09-29	2006-10-20	1
64076	3788	4112343	1965-10-23	1965-11-02	1
84097	5000	40481087	1969-05-29	1969-06-12	1
33542	1991	4112343	1992-08-26	1992-09-03	1
74703	4442	4112343	1993-05-14	1993-05-25	1
34245	2034	40481087	1955-04-27	1955-05-11	1
6655	393	260139	1976-08-01	1976-08-15	1
42955	2561	260139	1984-03-21	1984-04-04	1
77887	4621	4156265	1989-09-30	1989-10-21	1
73082	4348	4051466	1985-10-27	2001-02-07	1
34853	2073	40481087	1969-05-13	1969-05-20	1
63633	3761	80180	1990-11-29	1990-11-30	1
63941	3783	0	1952-04-02	1952-04-03	1
69574	4121	28060	1930-12-30	1931-01-12	1
32872	1952	260139	2001-12-18	2002-01-01	1
74198	4411	4112343	1971-05-10	1971-05-21	1
987	57	440086	1973-06-16	1979-06-25	1
56840	3376	40481087	1990-01-29	1990-02-05	1
64077	3788	4112343	1979-01-19	1979-02-01	1
84098	5000	40481087	2007-07-18	2007-08-01	1
33543	1991	4278672	1958-07-15	1958-10-13	1
74704	4442	4146173	1989-11-21	1990-01-20	1
34246	2034	40481087	1979-12-29	1980-01-19	1
6656	393	375671	1974-06-09	1974-08-08	1
42956	2561	260139	2014-04-22	2014-05-06	1
77888	4621	40481087	1988-01-15	1988-01-22	1
73083	4348	4294548	2015-03-22	2015-04-19	1
34854	2073	40481087	2009-08-22	2009-08-29	1
63634	3761	372328	1957-11-12	1958-03-29	1
63942	3783	80180	1984-04-09	1984-04-10	1
69575	4121	80180	1964-10-19	1964-10-20	1
32873	1952	372328	1959-09-05	1960-07-18	1
74199	4411	4112343	1978-09-14	1978-09-27	1
988	57	4155034	1982-12-31	1983-01-21	1
56841	3376	40481087	1991-12-04	1991-12-25	1
64078	3788	4237458	1967-08-26	1967-09-25	1
84099	5000	81151	1980-08-17	1980-09-14	1
33544	1991	40481087	1954-04-23	1954-05-07	1
74705	4442	4237458	1991-09-12	1991-12-11	1
34247	2034	40481087	2015-01-29	2015-02-05	1
6657	393	4294548	1961-11-20	1962-01-22	1
42957	2561	372328	1980-10-14	1981-10-07	1
77889	4621	40481087	1996-02-04	1996-02-25	1
73084	4348	40481087	1988-04-07	1988-04-28	1
34855	2073	80180	2003-12-22	2003-12-23	1
63635	3761	4112343	1960-07-21	1960-07-28	1
63943	3783	81151	2005-09-21	2005-10-19	1
69576	4121	81151	1979-10-30	1979-12-04	1
32874	1952	4112343	1960-08-04	1960-08-11	1
74200	4411	4112343	2002-01-09	2002-01-19	1
989	57	4155034	2007-01-15	2007-01-29	1
56842	3376	192671	1994-07-02	1994-07-03	1
64079	3788	40481087	1996-04-01	1996-04-15	1
84100	5000	260139	1979-01-28	1979-02-04	1
33545	1991	40481087	1997-03-14	1997-03-28	1
74706	4442	4283893	1999-05-25	1999-09-28	1
34248	2034	81151	1987-01-26	1987-03-02	1
9436	559	28060	1992-04-03	1992-04-16	1
42958	2561	4112343	2007-12-15	2007-12-25	1
77890	4621	40481087	2000-05-11	2000-06-01	1
73085	4348	40481087	1990-04-26	1990-05-17	1
34856	2073	260139	1982-04-07	1982-04-14	1
63636	3761	40481087	1973-02-23	1973-03-09	1
63944	3783	81151	2016-01-25	2016-02-29	1
69577	4121	260139	1926-02-18	1926-03-04	1
32875	1952	4112343	1970-06-05	1970-06-16	1
74201	4411	4266809	1984-01-22	1984-01-23	1
990	57	40481087	1963-11-15	1963-12-06	1
56843	3376	260139	1961-11-11	1961-11-25	1
64080	3788	40481087	2009-12-11	2010-01-01	1
84101	5000	260139	1983-01-28	1983-02-11	1
33546	1991	260139	1954-09-14	1954-09-28	1
74707	4442	4294548	1985-06-24	1985-07-29	1
34249	2034	257012	1942-07-02	1942-07-03	1
9437	559	28060	2005-05-11	2005-05-18	1
42959	2561	4283893	1981-10-10	1981-11-28	1
77891	4621	40481087	2017-10-14	2017-11-04	1
73086	4348	4113008	1995-11-07	1995-11-28	1
34857	2073	4112343	1965-10-06	1965-10-13	1
63637	3761	40481087	1989-09-14	1989-09-21	1
63945	3783	260139	1974-06-22	1974-07-06	1
69578	4121	4112343	1921-01-16	1921-01-23	1
32876	1952	40481087	1961-12-14	1961-12-28	1
74202	4411	40481087	1968-09-28	1968-10-05	1
991	57	40481087	2003-05-21	2003-06-11	1
56844	3376	4112343	2018-07-08	2018-07-18	1
65394	3871	28060	1966-05-25	1966-06-05	1
84102	5000	372328	1941-10-25	1942-01-27	1
33547	1991	260139	1965-12-03	1965-12-10	1
74708	4442	40481087	1984-11-05	1984-11-19	1
34250	2034	260139	1995-07-14	1995-07-21	1
9438	559	440086	1976-10-19	1977-06-28	1
42960	2561	30753	2017-02-09	2017-02-10	1
77892	4621	80180	2012-07-07	2012-07-08	1
73087	4348	40481087	1992-06-27	1992-07-11	1
34858	2073	40481087	1966-12-03	1966-12-17	1
63638	3761	28060	1957-02-16	1957-02-24	1
63946	3783	260139	2006-04-01	2006-04-08	1
69579	4121	4116491	1966-04-07	1966-05-21	1
32877	1952	80180	1989-01-10	1989-01-11	1
74203	4411	40481087	2011-08-24	2011-09-07	1
992	57	40481087	2018-08-15	2018-08-29	1
56845	3376	78272	1982-10-21	1982-11-11	1
65395	3871	260139	1963-09-08	1963-09-15	1
84103	5000	4112343	1944-08-11	1944-08-24	1
33548	1991	260139	1988-08-19	1988-08-26	1
74709	4442	40481087	2016-07-18	2016-08-01	1
34251	2034	260139	2006-05-19	2006-05-26	1
9439	559	4094814	1992-04-09	1992-05-09	1
42961	2561	80180	2017-08-08	2017-08-09	1
77893	4621	81151	2005-05-30	2005-06-27	1
73088	4348	40481087	2019-01-07	2019-01-28	1
34859	2073	40481087	2006-01-10	2006-01-31	1
63639	3761	78272	1958-01-11	1958-02-08	1
63947	3783	372328	1943-06-19	1943-09-10	1
69580	4121	4116491	1971-05-20	1971-09-13	2
32878	1952	81151	1962-01-22	1962-02-19	1
74204	4411	260139	1993-08-16	1993-08-23	1
1329	79	260139	1990-08-05	1990-08-12	1
56846	3376	80180	1994-05-06	1994-05-07	1
65396	3871	260139	2010-12-15	2010-12-22	1
84104	5000	4266809	1973-12-02	1973-12-03	1
33549	1991	4112343	1986-12-18	1986-12-31	1
76403	4534	0	1956-10-23	1956-10-24	1
34252	2034	381316	2018-01-17	2018-01-18	1
9440	559	4112343	1988-11-06	1988-11-18	1
42962	2561	372328	2014-02-16	2014-12-17	1
77894	4621	372328	1978-11-30	1979-01-01	1
73089	4348	80180	2015-01-01	2015-01-02	1
34860	2073	81151	1978-04-27	1978-05-18	1
63640	3761	260139	1991-06-06	1991-06-13	1
63948	3783	4059173	2008-11-02	2008-12-02	1
69581	4121	4294548	1971-07-29	1971-08-26	1
32879	1952	257012	1995-12-27	1995-12-28	1
74205	4411	4112343	1961-03-18	1961-03-30	1
1330	79	4112343	1997-12-20	1998-01-01	1
56847	3376	4112343	1977-04-07	1977-04-14	1
65397	3871	372328	2003-09-24	2004-09-22	1
84105	5000	40481087	1950-12-06	1950-12-27	1
33550	1991	4112343	2008-07-14	2008-07-26	1
76404	4534	317576	2005-03-02	2005-03-03	1
34253	2034	4112343	1924-03-14	1924-03-23	1
9441	559	4112343	2011-02-05	2011-02-14	1
42963	2561	4027663	2007-10-20	2007-10-21	1
77895	4621	375671	1987-08-12	1987-10-11	1
73090	4348	81151	2000-11-01	2000-11-15	1
34861	2073	372328	1973-11-19	1974-03-01	1
63641	3761	4035415	1994-08-28	1994-10-27	1
63949	3783	4084167	1948-09-25	1948-09-25	1
69582	4121	40481087	1931-09-24	1931-10-01	1
32880	1952	4112343	2004-09-14	2004-09-27	1
74206	4411	4112343	2003-05-15	2003-05-28	1
1331	79	4051466	1949-05-02	1965-08-07	1
56848	3376	4112343	1981-03-28	1981-04-05	1
65398	3871	4035415	1994-03-28	1994-05-27	1
84106	5000	40481087	1992-05-15	1992-05-29	1
33551	1991	4155034	1992-12-02	1992-12-16	1
76405	4534	380378	1956-10-23	1956-10-24	1
34254	2034	4112343	1978-12-04	1978-12-13	1
9442	559	40481087	2005-02-21	2005-03-14	1
42964	2561	4294548	1996-11-26	1997-01-14	1
77896	4621	4029498	1976-07-26	1976-07-27	1
73091	4348	260139	1982-11-16	1982-11-23	1
34862	2073	4112343	1983-11-10	1983-11-23	1
63642	3761	4112343	1959-11-14	1959-11-22	1
63950	3783	4112343	2006-01-22	2006-02-02	1
69583	4121	260139	1928-06-23	1928-06-30	1
32881	1952	4218389	2012-08-28	2012-09-18	1
74207	4411	4116491	1990-04-05	1990-05-27	1
1332	79	4112343	1954-01-17	1954-01-26	1
56849	3376	4230399	1964-03-29	1964-06-27	1
65399	3871	4059173	1968-06-12	1968-09-10	1
85916	5118	28060	1968-11-27	1968-12-08	1
33552	1991	4299128	1988-01-14	1988-01-28	1
76406	4534	4112343	1959-12-26	1960-01-02	1
34255	2034	4142905	1996-09-10	1996-10-10	1
9443	559	28060	2009-06-30	2009-07-12	1
42965	2561	40481087	1982-01-05	1982-01-12	1
77897	4621	4112343	1979-10-12	1979-10-25	1
73092	4348	260139	2007-05-17	2007-05-31	1
34863	2073	4112343	2017-02-07	2017-02-16	1
63643	3761	4112343	2003-06-12	2003-06-21	1
63951	3783	4283893	2017-03-09	2017-06-15	1
69584	4121	260139	1934-05-31	1934-06-14	1
32882	1952	4237458	1967-12-25	1968-01-24	1
74208	4411	4134304	1950-01-20	1950-03-21	1
1333	79	4112343	1957-02-13	1957-02-21	1
56850	3376	40481087	1967-08-31	1967-09-21	1
65400	3871	40481087	1985-07-08	1985-07-22	1
85917	5118	260139	2013-08-18	2013-09-01	1
33553	1991	40481087	1994-05-30	1994-06-06	1
76407	4534	4112343	2008-10-13	2008-10-21	1
34256	2034	4283893	1987-06-11	1987-08-27	1
9444	559	260139	1969-06-19	1969-07-03	1
42966	2561	40481087	1996-01-18	1996-01-25	1
77898	4621	4112343	1991-08-25	1991-09-05	1
73093	4348	4112343	2007-07-11	2007-07-21	1
34864	2073	4142905	1979-05-13	1979-06-12	1
63644	3761	4294548	1980-08-27	1980-10-08	1
63952	3783	40481087	2015-02-26	2015-03-12	1
69585	4121	4112343	1923-07-15	1923-07-24	1
32883	1952	40481087	1977-10-03	1977-10-10	1
74209	4411	4134304	1953-10-31	1953-11-30	1
1334	79	80180	1988-12-05	1988-12-06	1
56851	3376	260139	1963-10-23	1963-11-06	1
65401	3871	40481087	1988-11-22	1988-12-13	1
85918	5118	375671	1991-05-05	1991-07-04	1
33554	1991	40481087	1996-03-06	1996-03-13	1
76408	4534	40481087	1993-08-21	1993-08-28	1
34257	2034	40481087	1974-05-25	1974-06-08	1
9445	559	260139	1989-01-26	1989-02-09	1
42967	2561	40481087	2016-03-20	2016-04-03	1
77899	4621	4112343	2008-07-20	2008-08-01	1
73094	4348	40481087	1986-04-05	1986-04-12	1
34865	2073	4310024	2001-03-07	2001-03-08	1
63645	3761	40481087	1987-06-11	1987-06-18	1
63953	3783	28060	1953-05-15	1953-05-28	1
69586	4121	4218389	1933-06-30	1933-08-04	1
32884	1952	40481087	2013-07-19	2013-08-09	1
74210	4411	40481087	1952-06-16	1952-07-07	1
1335	79	4112343	2016-05-14	2016-05-22	1
56852	3376	4278672	2017-10-08	2017-11-07	1
65402	3871	40481087	2004-01-02	2004-01-23	1
85919	5118	4112343	1967-12-19	1968-01-01	1
33555	1991	40481087	2004-01-19	2004-02-09	1
76409	4534	40481087	1994-04-02	1994-04-16	1
34258	2034	40481087	1980-04-26	1980-05-10	1
9446	559	4112343	1973-04-02	1973-04-15	1
42968	2561	372328	1976-11-26	1977-02-02	1
77900	4621	40481087	1978-07-21	1978-07-28	1
76621	4547	80180	1948-08-24	1948-08-25	1
34866	2073	40481087	1997-12-27	1998-01-17	1
63646	3761	40481087	1992-07-15	1992-07-29	1
63954	3783	260139	1982-08-16	1982-08-23	1
71207	4227	372328	1957-08-31	1958-01-19	1
32885	1952	40481087	2018-09-17	2018-10-08	1
74211	4411	40481087	2001-10-31	2001-11-14	1
1336	79	4218389	2016-08-26	2016-09-23	1
56853	3376	4294548	1979-09-12	1979-10-17	1
65403	3871	40481087	2013-10-11	2013-11-01	1
85920	5118	4112343	1989-03-07	1989-03-18	1
33556	1991	78272	1977-01-06	1977-02-10	1
76410	4534	40481087	2008-06-10	2008-06-24	1
34259	2034	40481087	2003-05-03	2003-05-17	1
9447	559	4152936	1974-02-22	1974-03-15	1
42969	2561	4155034	1998-03-27	1998-04-10	1
77901	4621	40481087	2002-04-29	2002-05-13	1
76622	4547	80502	1969-06-29	1969-06-30	1
34867	2073	40481087	2013-12-12	2014-01-02	1
63647	3761	40481087	2007-09-15	2007-09-22	1
63955	3783	4112343	1946-06-05	1946-06-18	1
71208	4227	4112343	2004-06-30	2004-07-11	1
33753	2006	0	2014-01-17	2014-01-18	1
74212	4411	40481087	2008-03-14	2008-04-04	1
1337	79	40481087	1966-10-03	1966-10-24	1
56854	3376	40481087	1961-03-21	1961-03-28	1
65404	3871	80180	1999-10-18	1999-10-19	1
85921	5118	4294548	1979-10-23	1979-12-04	1
33557	1991	81151	1946-11-24	1946-12-15	1
76411	4534	28060	1955-02-03	1955-02-16	1
34260	2034	81893	1962-05-03	1962-05-04	1
9448	559	40481087	1983-03-16	1983-04-06	1
42970	2561	40481087	2005-11-23	2005-12-07	1
77902	4621	40481087	2003-06-15	2003-06-22	1
76623	4547	260139	1943-10-17	1943-10-24	1
39480	2342	372328	1976-05-11	1976-06-25	1
63648	3761	260139	1958-10-10	1958-10-24	1
63956	3783	4112343	1960-11-20	1960-12-03	1
71209	4227	4112343	2012-03-02	2012-03-13	1
33754	2006	78272	2013-04-18	2013-05-09	1
74213	4411	28060	2017-06-15	2017-06-26	1
1338	79	40481087	1967-05-30	1967-06-06	1
59872	3552	257012	1980-11-11	1980-11-12	1
65405	3871	260139	1969-11-20	1969-12-04	1
85922	5118	40481087	1987-11-24	1987-12-08	1
33558	1991	260139	1971-07-01	1971-07-08	1
76412	4534	80180	1985-04-09	1985-04-10	1
34261	2034	260139	1954-12-20	1954-12-27	1
9449	559	40481087	1998-02-07	1998-02-21	1
42971	2561	28060	2018-03-06	2018-03-15	1
77903	4621	0	1976-07-26	1976-07-27	1
76624	4547	372328	1910-04-11	1910-09-25	1
39481	2342	372328	1978-09-13	1979-09-21	1
63649	3761	260139	1981-11-29	1981-12-06	1
63957	3783	4112343	1986-02-07	1986-02-16	1
71210	4227	4296205	1997-08-15	1997-08-29	1
33755	2006	80180	1986-01-28	1986-01-29	1
74214	4411	80180	1984-01-22	1984-01-23	1
1339	79	40481087	1985-03-19	1985-04-02	1
59873	3552	260139	1964-02-14	1964-02-21	1
65406	3871	260139	1991-05-25	1991-06-01	1
85923	5118	40481087	1998-09-02	1998-09-09	1
33559	1991	4329847	2011-02-21	2011-02-22	1
76413	4534	372328	1945-04-19	1945-10-03	1
34262	2034	260139	1996-09-15	1996-09-29	1
9450	559	28060	1973-06-16	1973-06-24	1
42972	2561	257012	1981-11-14	1981-11-15	1
77904	4621	81151	2006-06-22	2006-07-06	1
76625	4547	4112343	1999-10-05	1999-10-17	1
39482	2342	4112343	2007-09-27	2007-10-07	1
63650	3761	260139	1987-05-29	1987-06-12	1
63958	3783	40481087	1960-08-01	1960-08-15	1
71211	4227	40481087	2010-08-04	2010-08-18	1
33756	2006	81151	1955-09-28	1955-10-12	1
74215	4411	81893	1982-05-02	1982-05-03	1
1340	79	40481087	1992-05-05	1992-05-19	1
59874	3552	260139	2002-10-31	2002-11-07	1
65407	3871	4112343	1983-11-04	1983-11-13	1
85924	5118	4084167	1968-10-11	1968-10-11	1
33560	1991	40481087	1964-12-15	1965-01-05	1
76414	4534	372328	1946-10-28	1947-04-02	1
34263	2034	4112343	1941-08-25	1941-09-04	1
9451	559	80180	2011-06-03	2011-06-04	1
42973	2561	4156265	1981-08-02	1981-08-23	1
77905	4621	40481087	2018-01-08	2018-01-15	1
76626	4547	4152936	1918-10-10	1918-10-31	1
39483	2342	40481087	2007-10-19	2007-10-26	1
63651	3761	260139	2002-03-18	2002-04-01	1
63959	3783	40481087	1998-04-21	1998-04-28	1
71212	4227	81151	2007-09-06	2007-10-04	1
33757	2006	260139	1950-03-30	1950-04-13	1
74216	4411	4027663	1975-04-09	1975-04-10	1
1341	79	257012	1996-06-26	1996-07-03	1
59875	3552	260139	2014-01-23	2014-02-06	1
65408	3871	40481087	1976-08-25	1976-09-01	1
85925	5118	40481087	1986-01-06	1986-01-20	1
33561	1991	40481087	1968-09-24	1968-10-08	1
76415	4534	4112343	1951-04-28	1951-05-08	1
34264	2034	4112343	1977-06-01	1977-06-08	1
9452	559	4059173	1981-01-07	1981-03-08	1
42974	2561	40481087	1988-02-17	1988-02-24	1
79753	4731	81893	2007-02-16	2007-02-17	1
76627	4547	4218389	1990-11-22	1990-12-13	1
39484	2342	40481087	2008-05-01	2008-05-22	1
63652	3761	372328	1959-07-22	1960-03-26	2
63960	3783	40481087	2013-04-10	2013-05-01	1
71213	4227	260139	1977-10-17	1977-10-31	1
33758	2006	260139	1967-03-29	1967-04-05	1
74217	4411	4112343	1994-12-04	1994-12-15	1
1342	79	372328	1947-10-17	1948-04-01	1
59876	3552	372328	1957-07-13	1957-10-24	1
65409	3871	40481087	1984-10-20	1984-11-03	1
85926	5118	40481087	1987-02-22	1987-03-01	1
34937	2077	78272	1996-10-21	1996-11-04	1
76416	4534	4112343	1990-08-08	1990-08-18	1
34265	2034	4112343	2012-03-05	2012-03-17	1
9453	559	260139	1973-05-12	1973-05-19	1
42975	2561	40481087	1997-10-17	1997-10-31	1
79754	4731	260139	2005-08-07	2005-08-14	1
76628	4547	4218389	2004-06-02	2004-07-07	1
39485	2342	40481087	2010-03-19	2010-04-09	1
63653	3761	372328	1961-11-16	1962-04-07	1
63961	3783	195588	1999-04-05	1999-05-11	1
71214	4227	260139	1993-10-27	1993-11-03	1
33759	2006	321042	2014-01-17	2014-01-18	1
74218	4411	4283893	2006-12-23	2007-05-12	1
1343	79	372328	1949-08-25	1949-09-29	1
59877	3552	372328	1958-10-19	1959-04-23	1
65410	3871	40481087	1985-12-25	1986-01-01	1
85927	5118	40481087	1987-05-06	1987-05-20	1
34938	2077	260139	1942-06-08	1942-06-22	1
76417	4534	4134304	1996-05-21	1996-07-20	1
34266	2034	4149245	2011-08-26	2011-11-01	1
9454	559	40481087	1986-04-25	1986-05-02	1
42976	2561	40481087	1999-11-27	1999-12-18	1
79755	4731	378001	2010-08-09	2010-10-08	1
76629	4547	4296204	1943-06-06	1943-07-11	1
39486	2342	260139	1976-09-10	1976-09-17	1
63654	3761	4112343	1960-09-27	1960-10-08	1
63962	3783	257012	2017-04-27	2017-04-28	1
71215	4227	321042	2003-04-06	2003-04-07	1
33760	2006	4116491	1993-01-06	1993-02-19	1
74219	4411	81151	2003-03-13	2003-03-27	1
1344	79	4112343	1999-01-28	1999-02-08	1
59878	3552	4112343	1982-08-05	1982-08-16	1
65411	3871	372328	1968-01-14	1968-08-28	1
85928	5118	80180	2008-02-24	2008-02-25	1
34939	2077	4112343	1984-12-22	1984-12-29	1
76418	4534	4146173	1980-02-15	1980-03-16	1
34267	2034	4285898	1963-07-27	1963-07-28	1
9455	559	40481087	2006-05-13	2006-05-20	1
42977	2561	40481087	2005-02-26	2005-03-19	1
79756	4731	4059173	1972-10-27	1973-01-25	1
76630	4547	40480160	1997-09-07	1997-12-06	1
39487	2342	260139	1980-06-29	1980-07-13	1
63655	3761	40481087	2012-01-08	2012-01-15	1
63963	3783	260139	1946-03-06	1946-03-20	1
71216	4227	372328	1960-10-20	1961-01-29	1
33761	2006	40481087	2002-02-17	2002-03-10	1
74220	4411	260139	1946-03-13	1946-03-20	1
1345	79	4113008	1979-02-15	1979-03-08	1
59879	3552	4112343	2009-08-05	2009-08-17	1
65412	3871	40481087	1981-07-15	1981-07-29	1
85929	5118	257012	1979-11-27	1979-11-28	1
34940	2077	4296204	1977-08-16	1977-08-30	1
76419	4534	40481087	1955-01-15	1955-02-05	1
34268	2034	4294548	1994-10-10	1994-11-07	1
10126	601	30753	2009-07-29	2009-07-30	1
44968	2679	80180	2013-01-05	2013-01-06	1
79757	4731	4112343	1979-04-25	1979-05-05	1
76631	4547	40481087	1946-02-25	1946-03-11	1
39488	2342	260139	1985-06-27	1985-07-11	1
63934	3783	260139	1969-03-21	1969-04-04	1
63964	3783	260139	1985-07-21	1985-07-28	1
71217	4227	4112343	1961-05-27	1961-06-03	1
33762	2006	28060	1972-02-28	1972-03-11	1
74221	4411	4112343	1947-01-08	1947-01-15	1
1346	79	4156265	1967-07-05	1967-07-19	1
59880	3552	4146173	1965-07-01	1965-08-07	1
65413	3871	40481087	2018-10-12	2018-10-19	1
85930	5118	372328	1969-09-06	1969-12-24	1
34941	2077	40481087	1944-08-18	1944-08-25	1
76420	4534	40481087	1960-09-02	1960-09-16	1
34269	2034	40481087	1944-06-13	1944-06-27	1
10127	601	4112343	1984-08-09	1984-08-17	1
44969	2679	4109685	2009-12-13	2010-01-03	1
79758	4731	40481087	2013-10-30	2013-11-13	1
76632	4547	4059173	2016-10-02	2016-12-01	1
39489	2342	260139	2012-04-20	2012-04-27	1
63935	3783	4029498	1952-04-02	1952-04-03	1
63965	3783	260139	2003-10-06	2003-10-13	1
71218	4227	4112343	1978-07-08	1978-07-20	1
33763	2006	28060	1980-07-29	1980-08-11	1
74222	4411	4116491	1996-05-25	1996-07-13	1
1347	79	4218389	1987-07-25	1987-08-29	1
59881	3552	40481087	2002-05-16	2002-06-06	1
65414	3871	440086	1969-09-10	1980-09-17	1
85931	5118	378001	2000-11-18	2001-01-17	1
34942	2077	0	2005-08-21	2005-08-22	1
76421	4534	40481087	1960-11-24	1960-12-08	1
34270	2034	40481087	1967-10-12	1967-11-02	1
10128	601	4218389	1996-08-20	1996-09-17	1
44970	2679	4112343	1978-09-29	1978-10-07	1
79759	4731	260139	2014-06-14	2014-06-21	1
76633	4547	4230399	1982-01-17	1982-04-17	1
39490	2342	40481087	2004-04-17	2004-05-01	1
63936	3783	4294548	2011-10-04	2011-11-08	1
63966	3783	4084167	1940-12-01	1940-12-01	1
71219	4227	40481087	1972-07-18	1972-08-01	1
33764	2006	78272	1986-08-30	1986-09-27	1
74223	4411	4278672	2014-11-24	2014-12-24	1
1348	79	4283893	1996-06-05	1996-07-03	1
59882	3552	80180	1992-05-25	1992-05-26	1
65415	3871	40481087	1967-08-24	1967-09-07	1
85932	5118	4112343	1987-09-01	1987-09-12	1
34943	2077	28060	1951-07-09	1951-07-22	1
76422	4534	28060	1953-01-01	1953-01-13	1
34271	2034	40481087	1969-10-20	1969-11-10	1
10129	601	40481087	1996-01-04	1996-01-11	1
44971	2679	78272	1981-11-09	1981-12-14	1
79760	4731	440086	1981-10-30	1983-11-11	1
76634	4547	40480160	1982-01-17	1982-04-17	1
39491	2342	40481087	2013-11-27	2013-12-18	1
63967	3783	4112343	1973-06-01	1973-06-13	1
71220	4227	80180	1988-06-29	1988-06-30	1
33765	2006	372328	1946-02-17	1946-04-26	1
74224	4411	4283893	1953-10-05	1953-11-09	1
1349	79	40481087	1958-09-27	1958-10-18	1
59883	3552	260139	1961-04-24	1961-05-08	1
67141	3973	30753	2002-09-10	2002-09-11	1
85933	5118	4218389	1990-05-19	1990-06-09	1
34944	2077	80180	1972-06-04	1972-06-05	1
76423	4534	260139	1995-01-05	1995-01-12	1
34272	2034	28060	1991-07-28	1991-08-09	1
10130	601	40481087	2011-12-31	2012-01-21	1
44972	2679	81151	2012-02-22	2012-03-21	1
79761	4731	4112343	1972-07-03	1972-07-14	1
76635	4547	40481087	1948-08-16	1948-09-06	1
39492	2342	40481087	2018-08-03	2018-08-10	1
63968	3783	4112343	2001-05-31	2001-06-13	1
71221	4227	372328	1959-04-14	1960-01-24	1
33766	2006	4155034	2008-06-22	2008-07-13	1
74225	4411	4283893	1966-05-11	1966-08-03	1
1350	79	40481087	1963-09-27	1963-10-11	1
59884	3552	260139	2016-08-30	2016-09-06	1
67142	3973	372328	1979-06-28	1979-08-09	1
85934	5118	4218389	1993-05-24	1993-06-28	1
34945	2077	260139	1946-11-09	1946-11-23	1
76424	4534	260139	2003-02-11	2003-02-18	1
34273	2034	78272	1958-02-13	1958-02-27	1
10131	601	81151	1974-10-21	1974-11-25	1
44973	2679	40481087	1998-07-27	1998-08-17	1
79762	4731	4285898	2008-04-11	2008-04-12	1
76636	4547	40481087	1955-12-06	1955-12-20	1
39493	2342	80180	2018-06-25	2018-06-26	1
63969	3783	4112343	2008-07-24	2008-08-04	1
71222	4227	4112343	1960-05-18	1960-05-31	1
33767	2006	4294548	1979-10-29	1979-11-26	1
74226	4411	4285898	1983-06-26	1983-06-27	1
1351	79	40481087	1966-01-05	1966-01-26	1
59885	3552	260139	2018-01-13	2018-01-20	1
67143	3973	440086	1978-07-23	1986-07-31	1
85935	5118	4237458	1977-12-23	1978-02-21	1
34946	2077	260139	1952-02-26	1952-03-11	1
76425	4534	440086	1955-10-24	1956-01-30	1
34274	2034	317576	2004-11-10	2004-11-11	1
10132	601	81151	1985-06-05	1985-06-19	1
44974	2679	78272	1989-08-02	1989-08-30	1
79763	4731	40481087	1992-03-19	1992-03-26	1
76637	4547	40481087	1966-06-30	1966-07-14	1
39494	2342	192671	2018-07-10	2018-07-11	1
63970	3783	40481087	1959-02-17	1959-03-03	1
71223	4227	4112343	1987-05-18	1987-05-28	1
33768	2006	40481087	1947-11-14	1947-11-21	1
74227	4411	4310024	1981-08-05	1981-08-06	1
1352	79	40481087	1981-11-23	1981-11-30	1
59886	3552	4152936	2017-05-04	2017-05-18	1
67144	3973	4027663	1995-07-19	1995-07-20	1
85936	5118	40481087	1989-11-06	1989-11-13	1
34947	2077	321042	2005-08-21	2005-08-22	1
76426	4534	4112343	1980-10-14	1980-10-27	1
34275	2034	4027663	1953-04-10	1953-04-11	1
10133	601	378001	2007-10-20	2007-12-19	1
44975	2679	81151	1982-11-09	1982-12-07	1
79764	4731	372328	1975-01-15	1975-10-07	2
76638	4547	40481087	1978-07-16	1978-07-23	1
39495	2342	4116491	2010-01-08	2010-02-15	1
65207	3860	80180	2007-03-22	2007-03-23	1
71224	4227	0	2003-04-06	2003-04-07	1
33769	2006	40481087	1959-10-22	1959-11-05	1
74228	4411	40481087	1979-02-16	1979-02-23	1
2820	163	80180	2010-04-03	2010-04-04	1
59887	3552	4296205	1979-06-25	1979-07-23	1
67145	3973	4112343	1991-10-07	1991-10-15	1
85937	5118	372328	1982-08-18	1982-12-22	1
34948	2077	4112343	1961-05-31	1961-06-09	1
76427	4534	4329847	2011-11-30	2011-12-01	1
34276	2034	4112343	1983-09-22	1983-10-04	1
10134	601	4027663	2002-11-08	2002-11-09	1
44976	2679	260139	2016-09-07	2016-09-21	1
79765	4731	4112343	1979-10-03	1979-10-11	1
76639	4547	260139	1965-05-27	1965-06-03	1
39496	2342	4156265	1990-01-28	1990-02-18	1
65208	3860	440448	1978-07-08	1978-07-09	1
71225	4227	260139	1992-02-27	1992-03-05	1
33770	2006	28060	1948-02-08	1948-02-19	1
74229	4411	40481087	1980-09-22	1980-10-13	1
2821	163	372328	1968-04-18	1968-06-04	1
59888	3552	40481087	1999-11-02	1999-11-23	1
67146	3973	4112343	2007-07-25	2007-08-03	1
85938	5118	4134304	1980-10-08	1980-12-07	1
34949	2077	4112343	2006-07-10	2006-07-22	1
76428	4534	40481087	1960-02-16	1960-03-01	1
34277	2034	4218389	1999-07-27	1999-08-31	1
10135	601	4112343	1971-10-21	1971-10-31	1
44977	2679	4112343	1985-10-04	1985-10-13	1
79766	4731	4112343	1993-01-04	1993-01-12	1
76640	4547	440086	1915-10-17	1916-06-25	1
39497	2342	81151	2018-11-18	2018-12-23	1
65209	3860	4112343	2004-02-02	2004-02-09	1
71226	4227	260139	2001-06-25	2001-07-02	1
33771	2006	28060	1961-12-11	1961-12-21	1
75990	4513	4112343	1986-01-30	1986-02-09	1
2822	163	4112343	1975-05-16	1975-05-25	1
59889	3552	4283893	1980-09-16	1980-11-18	1
67147	3973	4218389	2009-05-19	2009-06-16	1
85939	5118	40481087	1978-04-01	1978-04-22	1
34950	2077	4278672	2001-06-11	2001-09-09	1
76429	4534	40481087	1987-03-29	1987-04-19	1
34278	2034	4278672	1940-12-14	1941-02-12	1
10136	601	4310024	2008-04-05	2008-04-06	1
44978	2679	4278672	1976-12-05	1977-01-04	1
79767	4731	80180	2008-09-08	2008-09-09	1
76641	4547	4112343	1936-07-10	1936-07-22	1
39498	2342	378001	1979-09-23	1979-10-23	1
65210	3860	260139	1986-09-24	1986-10-01	1
71227	4227	4112343	1986-06-10	1986-06-19	1
33772	2006	81151	2000-09-13	2000-10-04	1
75991	4513	4218389	2003-09-02	2003-10-07	1
2823	163	4112343	2010-07-05	2010-07-15	1
59890	3552	4283893	1984-01-07	1984-05-26	1
67148	3973	40481087	1992-11-17	1992-12-08	1
85940	5118	40481087	2018-12-02	2018-12-23	1
34951	2077	40481087	1934-09-25	1934-10-16	1
76430	4534	0	2011-11-30	2011-12-01	1
34279	2034	4310024	1961-10-05	1961-10-06	1
10137	601	40481087	1996-02-17	1996-02-24	1
44979	2679	4283893	1999-08-17	2000-01-04	1
79768	4731	4027663	2000-10-25	2000-10-26	1
76642	4547	4112343	2010-10-01	2010-10-14	1
39499	2342	40481087	2003-08-25	2003-09-15	1
65211	3860	4112343	1993-10-11	1993-10-24	1
71228	4227	4156265	1969-06-29	1969-07-13	1
33773	2006	81151	2006-06-05	2006-07-03	1
75992	4513	260139	1966-03-01	1966-03-15	1
2824	163	4116491	2007-07-26	2007-08-26	1
59891	3552	40481087	1993-06-15	1993-06-29	1
67149	3973	40481087	2008-09-08	2008-09-29	1
88941	5298	81151	1975-12-21	1976-01-18	1
34952	2077	40481087	1994-09-29	1994-10-13	1
76431	4534	260139	1973-02-22	1973-03-08	1
34280	2034	40481087	1940-06-11	1940-06-25	1
10138	601	28060	2007-06-21	2007-07-04	1
44980	2679	40481087	2013-09-29	2013-10-06	1
79769	4731	4112343	1973-05-12	1973-05-23	1
76643	4547	4155034	1916-10-06	1916-10-20	1
40151	2384	80180	2017-03-04	2017-03-05	1
65212	3860	81151	1980-05-27	1980-07-01	1
71229	4227	40481087	2005-09-15	2005-09-22	1
33774	2006	260139	1959-11-28	1959-12-05	1
75993	4513	260139	1969-02-03	1969-02-10	1
2825	163	40481087	1973-04-28	1973-05-12	1
59892	3552	40481087	1993-09-06	1993-09-27	1
67150	3973	78272	1973-04-14	1973-04-28	1
88942	5298	257012	1962-03-02	1962-03-03	1
34953	2077	40481087	1939-10-25	1939-11-08	1
76432	4534	372328	1949-06-20	1949-10-12	1
34281	2034	40481087	1977-12-25	1978-01-01	1
10139	601	78272	2008-12-13	2009-01-03	1
44981	2679	257012	1999-09-07	1999-09-08	1
79770	4731	4266809	2008-09-08	2008-09-09	1
76644	4547	40481087	1936-01-02	1936-01-23	1
40152	2384	4112343	1989-03-02	1989-03-12	1
65213	3860	81151	1985-12-30	1986-02-03	1
73816	4390	192671	1994-11-21	1994-11-22	1
33775	2006	260139	1993-10-17	1993-10-31	1
75994	4513	260139	1978-12-05	1978-12-19	1
2826	163	40481087	2017-02-22	2017-03-01	1
59893	3552	260139	1978-03-21	1978-03-28	1
67151	3973	80180	2004-03-03	2004-03-04	1
88943	5298	260139	2013-07-29	2013-08-05	1
34954	2077	40481087	1952-06-21	1952-07-12	1
76433	4534	4029498	1956-10-23	1956-10-24	1
34282	2034	40481087	1992-06-10	1992-06-17	1
10140	601	372328	1972-08-02	1972-10-22	1
44982	2679	4283893	1975-08-18	1975-10-20	1
79771	4731	40481087	1982-02-13	1982-03-06	1
76645	4547	40481087	1938-07-16	1938-07-30	1
40153	2384	40481087	1988-02-22	1988-03-07	1
65214	3860	260139	2014-02-07	2014-02-14	1
73817	4390	260139	2006-11-18	2006-12-02	1
33776	2006	4294548	1965-10-08	1965-12-03	1
75995	4513	4112343	1993-11-01	1993-11-12	1
2827	163	192671	2010-04-25	2010-04-26	1
59894	3552	4112343	1997-05-30	1997-06-06	1
67152	3973	260139	1984-09-01	1984-09-08	1
88944	5298	4112343	2001-12-02	2001-12-14	1
34955	2077	40481087	1993-11-10	1993-11-24	1
76434	4534	4112343	1949-07-29	1949-08-05	1
34283	2034	40481087	2006-04-08	2006-04-29	1
10141	601	4112343	1971-01-11	1971-01-23	1
44983	2679	40481087	2010-02-18	2010-03-11	1
79772	4731	40481087	2006-01-20	2006-02-03	1
76646	4547	40481087	1948-02-04	1948-02-11	1
40154	2384	40481087	2010-06-03	2010-06-24	1
65215	3860	4109685	1994-02-21	1994-03-07	1
73818	4390	4132546	1961-12-22	1961-12-23	1
33777	2006	40481087	1949-07-20	1949-08-10	1
75996	4513	40481087	2008-04-15	2008-04-22	1
2828	163	372328	1980-02-02	1980-07-29	1
59895	3552	40481087	1985-03-01	1985-03-22	1
67153	3973	4112343	1976-10-13	1976-10-25	1
88945	5298	4283893	1962-02-09	1962-04-06	1
34956	2077	40481087	1997-02-08	1997-02-22	1
76435	4534	40479768	1998-06-10	1998-08-16	1
34284	2034	40481087	2007-02-28	2007-03-07	1
10142	601	4112343	1983-07-04	1983-07-12	1
45640	2715	0	1989-01-08	1989-01-09	1
80243	4759	28060	1998-06-12	1998-06-23	1
76647	4547	40481087	1970-11-27	1970-12-04	1
40155	2384	28060	1985-02-19	1985-03-04	1
65216	3860	40481087	1977-11-15	1977-11-22	1
73819	4390	4283893	1969-09-01	1969-10-27	1
33778	2006	40481087	1954-08-23	1954-09-13	1
75997	4513	28060	1982-02-07	1982-02-16	1
2829	163	40481087	1989-01-29	1989-02-05	1
61814	3654	30753	2004-08-18	2004-08-19	1
67154	3973	4112343	1977-05-26	1977-06-07	1
88946	5298	40481087	1967-01-25	1967-02-15	1
34957	2077	134438	1958-03-27	1958-11-24	1
76436	4534	40481087	1943-12-02	1943-12-09	1
35177	2088	260139	1922-03-15	1922-03-22	1
10143	601	40481087	2008-03-31	2008-04-14	1
45641	2715	257012	1973-03-14	1973-03-15	1
80244	4759	80180	2018-05-25	2018-05-26	1
76648	4547	40481087	2001-03-02	2001-03-09	1
40156	2384	81893	2015-08-12	2015-08-13	1
65217	3860	40481087	2007-04-22	2007-05-13	1
73820	4390	40481087	1970-05-31	1970-06-21	1
33779	2006	140673	2017-12-31	2018-01-01	1
75998	4513	80180	1995-12-27	1995-12-28	1
2830	163	40481087	2005-12-17	2005-12-24	1
61815	3654	257012	1971-10-25	1971-10-26	1
67155	3973	4310024	2002-02-12	2002-02-13	1
88947	5298	40481087	1980-04-06	1980-04-20	1
34958	2077	378419	2004-07-25	2004-07-26	1
76563	4544	260139	1942-03-14	1942-03-28	1
35178	2088	260139	1932-12-07	1932-12-14	1
10144	601	78272	1980-09-15	1980-09-29	1
45642	2715	4059173	1990-09-30	1990-12-29	1
80245	4759	81151	2005-01-07	2005-02-04	1
76649	4547	78272	1983-03-13	1983-04-03	1
40157	2384	4116491	2013-02-13	2013-04-01	1
65218	3860	0	1978-07-08	1978-07-09	1
73821	4390	40481087	1999-05-17	1999-06-07	1
33780	2006	378001	1947-12-09	1948-02-07	1
75999	4513	81151	1966-09-25	1966-10-16	1
2831	163	81151	1973-03-23	1973-04-06	1
61816	3654	4027663	1998-06-26	1998-06-27	1
67156	3973	40481087	1978-06-10	1978-06-17	1
88948	5298	40481087	1993-04-10	1993-05-01	1
34959	2077	381316	1981-08-23	1981-08-24	1
76564	4544	317576	1989-10-24	1989-10-25	1
35179	2088	260139	1973-04-21	1973-04-28	1
10145	601	80180	2010-06-24	2010-06-25	1
45643	2715	40481087	1997-10-02	1997-10-16	1
80246	4759	260139	2000-08-10	2000-08-24	1
76650	4547	260139	1994-02-02	1994-02-09	1
40158	2384	40481087	1986-11-15	1986-11-22	1
65219	3860	28060	1984-12-03	1984-12-10	1
73822	4390	80180	1994-10-15	1994-10-16	1
33781	2006	4112343	1999-08-03	1999-08-13	1
76000	4513	260139	1986-12-14	1986-12-28	1
2832	163	260139	1975-07-12	1975-07-26	1
61817	3654	40481087	1998-07-07	1998-07-28	1
67157	3973	40481087	1989-11-07	1989-11-28	1
88949	5298	78272	2003-11-27	2003-12-11	1
34960	2077	4048695	1988-05-04	1988-07-05	1
76565	4544	372328	1943-09-03	1944-06-20	1
35180	2088	4027663	1933-09-16	1933-09-17	1
10146	601	260139	2017-03-10	2017-03-24	1
45644	2715	28060	1974-10-01	1974-10-11	1
80247	4759	372328	1980-05-29	1980-08-12	1
76651	4547	4112343	1928-03-09	1928-03-21	1
40159	2384	40481087	2000-09-09	2000-09-16	1
65220	3860	28060	1986-09-04	1986-09-17	1
73823	4390	81151	1966-05-30	1966-06-20	1
33782	2006	4112343	2010-01-19	2010-01-27	1
76001	4513	372328	1967-05-23	1968-03-20	1
2833	163	260139	2001-04-28	2001-05-12	1
61818	3654	40481087	2007-03-20	2007-04-03	1
67158	3973	40481087	1995-01-06	1995-01-27	1
88950	5298	80180	1973-12-06	1973-12-07	1
34961	2077	4112343	1941-04-16	1941-04-28	1
76566	4544	375671	1986-09-01	1986-10-31	1
35181	2088	4112343	1934-12-07	1934-12-16	1
10147	601	4113008	1979-01-03	1979-01-24	1
45645	2715	78272	1970-07-21	1970-08-25	1
80248	4759	380378	2012-11-06	2012-11-07	1
76652	4547	4112343	1951-09-03	1951-09-12	1
40160	2384	78272	2005-10-12	2005-10-26	1
65221	3860	81151	1985-02-05	1985-03-05	1
73824	4390	81151	2009-04-22	2009-05-20	1
33783	2006	40481087	1965-06-13	1965-07-04	1
76002	4513	4112343	1994-05-14	1994-05-22	1
2834	163	4112343	1997-10-28	1997-11-08	1
61819	3654	28060	1983-02-13	1983-02-25	1
67159	3973	40481087	1995-03-03	1995-03-10	1
88951	5298	260139	1942-03-20	1942-04-03	1
34962	2077	4112343	1970-05-25	1970-06-07	1
76567	4544	4027663	1972-10-15	1972-10-16	1
35182	2088	4113008	1955-09-21	1955-10-12	1
11719	693	80180	1995-08-14	1995-08-15	1
45646	2715	372328	1966-11-09	1966-12-29	1
80249	4759	4029498	2008-11-08	2008-11-09	1
76653	4547	4112343	1968-02-16	1968-02-27	1
40161	2384	4027663	2010-02-14	2010-02-15	1
65222	3860	4112343	2004-03-13	2004-03-23	1
73825	4390	260139	1985-09-13	1985-09-27	1
33784	2006	40481087	1985-01-03	1985-01-10	1
76003	4513	4230399	1976-03-27	1976-04-26	1
2835	163	40481087	1979-11-12	1979-11-26	1
61820	3654	4294548	1971-09-06	1971-11-21	1
67160	3973	40481087	1998-06-29	1998-07-13	1
88952	5298	260139	1993-03-07	1993-03-14	1
34963	2077	4156265	1962-08-21	1962-09-04	1
76568	4544	4142905	1949-10-31	1949-12-30	1
35183	2088	4113008	2002-10-24	2002-11-14	1
11720	693	260139	1965-05-20	1965-05-27	1
45647	2715	440448	1989-01-08	1989-01-09	1
80250	4759	4112343	1997-07-05	1997-07-13	1
76654	4547	4112343	1976-11-13	1976-11-22	1
40162	2384	4113008	2008-09-10	2008-09-24	1
65223	3860	4112343	2012-04-12	2012-04-20	1
73826	4390	260139	1994-06-10	1994-06-24	1
34644	2060	28060	1993-09-10	1993-09-20	1
76004	4513	4278672	1978-01-16	1978-04-16	1
2836	163	40481087	1981-08-23	1981-08-30	1
61821	3654	4296204	2016-10-18	2016-11-21	1
67161	3973	260139	1996-11-15	1996-11-29	1
88953	5298	378419	2011-07-24	2011-07-25	1
34964	2077	40481087	2012-01-14	2012-02-04	1
76569	4544	40481087	1993-11-29	1993-12-13	1
35184	2088	4285898	1944-12-02	1944-12-03	1
11721	693	375671	1988-07-03	1988-08-02	1
45648	2715	4059173	1982-05-15	1982-07-14	1
80251	4759	4113008	2017-01-02	2017-01-16	1
76655	4547	4112343	1990-11-11	1990-11-19	1
40163	2384	4266809	2017-03-04	2017-03-05	1
65224	3860	4112343	2013-09-16	2013-09-26	1
73827	4390	260139	1997-02-21	1997-02-28	1
34645	2060	195588	1996-11-25	1997-01-03	1
76005	4513	4278672	2004-08-02	2004-10-01	1
2837	163	260139	2006-09-02	2006-09-16	1
61822	3654	80180	2004-10-17	2004-10-18	1
67162	3973	313217	2018-08-30	2018-08-31	1
88954	5298	4294548	1970-10-03	1971-01-23	1
36368	2155	80502	2007-04-25	2007-04-26	1
76570	4544	80180	1984-04-25	1984-04-26	1
35185	2088	40481087	1938-03-10	1938-03-24	1
11722	693	4112343	1954-09-15	1954-09-28	1
45649	2715	4084167	1974-01-31	1974-01-31	1
80252	4759	4142905	1989-06-16	1989-09-14	1
76656	4547	4112343	2008-03-04	2008-03-13	1
40164	2384	4278672	1997-05-13	1997-08-11	1
65225	3860	4294548	2001-07-26	2001-08-16	1
73828	4390	372328	1963-07-28	1963-12-06	1
34646	2060	260139	1969-07-15	1969-07-22	1
76006	4513	40481087	2018-05-22	2018-06-05	1
2838	163	4109685	1979-06-04	1979-06-25	1
61823	3654	260139	1975-01-14	1975-01-21	1
67163	3973	4112343	2019-02-15	2019-02-28	1
88955	5298	40481087	1971-07-27	1971-08-17	1
36369	2155	81151	1986-12-24	1987-01-28	1
76571	4544	260139	1955-09-17	1955-09-24	1
35186	2088	40481087	1972-06-12	1972-06-19	1
11723	693	4112343	1966-04-01	1966-04-14	1
45650	2715	4218389	1971-08-20	1971-09-10	1
80253	4759	28060	1986-06-30	1986-07-10	1
76657	4547	4113008	1933-09-12	1933-09-26	1
40165	2384	81151	1998-08-06	1998-08-20	1
65226	3860	40481087	2018-11-16	2018-11-30	1
73829	4390	4001336	1961-12-22	1962-02-20	1
34647	2060	260139	2004-08-10	2004-08-17	1
76007	4513	28060	2014-07-07	2014-07-20	1
2839	163	4116491	2001-06-19	2001-07-27	1
61824	3654	260139	1977-11-23	1977-12-07	1
67164	3973	40481087	1980-07-12	1980-07-19	1
88956	5298	260139	1943-01-26	1943-02-09	1
36370	2155	260139	1979-07-25	1979-08-08	1
76572	4544	4310024	1981-06-10	1981-06-11	1
35187	2088	80180	1945-03-02	1945-03-03	1
11724	693	40481087	1980-03-19	1980-04-02	1
45651	2715	40481087	1978-07-17	1978-08-07	1
80254	4759	260139	1979-02-06	1979-02-13	1
76658	4547	4278672	1997-09-07	1997-12-06	1
40166	2384	260139	2003-10-11	2003-10-18	1
66463	3938	260139	1929-11-14	1929-11-21	1
73830	4390	4294548	1962-12-23	1963-02-10	1
34648	2060	4112343	1988-01-12	1988-01-20	1
76008	4513	40481087	1972-08-02	1972-08-16	1
2840	163	4152936	1999-08-30	1999-09-13	1
61825	3654	372328	1973-11-18	1973-12-02	1
67165	3973	40481087	2007-04-03	2007-04-10	1
88957	5298	4109685	1991-08-11	1991-09-01	1
36371	2155	260139	1993-07-19	1993-08-02	1
76573	4544	4329847	1994-02-01	1994-02-02	1
35188	2088	80502	1989-07-25	1989-07-26	1
11725	693	40481087	2018-05-29	2018-06-05	1
45652	2715	40481087	2003-08-24	2003-09-07	1
80255	4759	260139	1987-03-05	1987-03-12	1
76659	4547	40480160	2016-10-02	2016-12-01	1
40167	2384	4112343	1988-02-19	1988-03-03	1
66464	3938	378001	1952-03-11	1952-05-11	1
73831	4390	40481087	1974-07-06	1974-07-20	1
34649	2060	40481087	1996-05-18	1996-06-01	1
76009	4513	40481087	2009-04-24	2009-05-01	1
2841	163	4156265	1984-04-29	1984-05-20	1
61826	3654	4155034	1973-05-23	1973-06-06	1
67166	3973	81893	2002-04-13	2002-04-14	1
88958	5298	4112343	1954-03-19	1954-03-30	1
36372	2155	260139	1999-02-02	1999-02-16	1
76574	4544	40481087	1953-09-09	1953-09-16	1
35189	2088	81893	1943-05-12	1943-05-13	1
11726	693	28060	2005-05-31	2005-06-13	1
45653	2715	0	2017-11-23	2017-11-24	1
80256	4759	378001	1997-04-19	1997-05-19	1
76660	4547	40481087	1977-06-08	1977-06-15	1
40168	2384	4112343	2004-01-24	2004-02-05	1
66465	3938	4112343	1952-05-24	1952-06-01	1
73832	4390	40481087	2004-05-17	2004-05-24	1
34650	2060	40481087	2008-07-05	2008-07-19	1
77809	4615	4112343	1969-04-07	1969-04-16	1
2842	163	4237458	1975-04-26	1975-07-25	1
61827	3654	260139	1985-04-06	1985-04-20	1
67167	3973	378001	1993-09-10	1993-11-09	1
88959	5298	4113008	1986-07-24	1986-08-07	1
36373	2155	260139	2000-04-17	2000-05-01	1
76575	4544	40481087	1964-09-23	1964-10-14	1
35190	2088	260139	1915-12-29	1916-01-05	1
11727	693	4112343	1992-10-25	1992-11-03	1
45654	2715	80180	1999-05-25	1999-05-26	1
80257	4759	4218389	1980-12-25	1981-01-29	1
76661	4547	40481087	2001-07-14	2001-07-28	1
40169	2384	4218389	2018-01-05	2018-02-02	1
66466	3938	40481087	1920-09-05	1920-09-26	1
73833	4390	372328	1962-08-19	1962-11-30	1
34651	2060	260139	1998-12-19	1999-01-02	1
77810	4615	4112343	1994-03-01	1994-03-14	1
2843	163	40481087	2011-01-02	2011-01-16	1
61828	3654	260139	1994-02-07	1994-02-21	1
67168	3973	4059173	2005-07-09	2005-10-07	1
88960	5298	4283893	2007-12-20	2008-02-28	1
36374	2155	260139	2003-05-23	2003-06-06	1
76576	4544	40481087	1968-12-27	1969-01-03	1
35191	2088	4112343	2009-05-11	2009-05-19	1
11728	693	4283893	1962-11-05	1962-12-10	1
45655	2715	260139	1966-06-14	1966-06-28	1
80258	4759	4237458	1979-12-01	1980-02-29	1
79412	4709	81151	2008-06-08	2008-06-29	1
40170	2384	4310024	2015-07-13	2015-07-14	1
66467	3938	78272	1984-09-20	1984-10-18	1
73834	4390	4112343	2000-09-30	2000-10-07	1
34652	2060	260139	2008-06-29	2008-07-13	1
77811	4615	4112343	2009-05-16	2009-05-27	1
3712	213	81151	1993-06-27	1993-08-01	1
61829	3654	4001336	1974-07-01	1974-07-31	1
67169	3973	4112343	1987-12-13	1987-12-26	1
88961	5298	40481087	1941-12-28	1942-01-18	1
36375	2155	4134304	1996-01-11	1996-02-10	1
76577	4544	0	1994-02-01	1994-02-02	1
35192	2088	4113008	1921-09-14	1921-09-28	1
11729	693	40479768	1999-09-04	1999-10-11	1
45656	2715	260139	1997-03-18	1997-03-25	1
80259	4759	4237458	1985-05-08	1985-06-07	1
79413	4709	257012	1989-02-28	1989-03-01	1
40171	2384	40481087	2014-07-11	2014-07-25	1
66468	3938	80180	1949-06-06	1949-06-07	1
73835	4390	4112343	2009-02-11	2009-02-24	1
34653	2060	40481087	1977-12-12	1977-12-26	1
77812	4615	40481087	1955-08-26	1955-09-16	1
3713	213	260139	2013-10-01	2013-10-15	1
61830	3654	4112343	1971-10-31	1971-11-10	1
67170	3973	4112343	2012-08-07	2012-08-18	1
88962	5298	40481087	1963-11-21	1963-12-05	1
36376	2155	40481087	1953-02-17	1953-02-24	1
76578	4544	81893	1982-03-07	1982-03-08	1
35193	2088	4310024	1943-02-11	1943-02-12	1
11730	693	40481087	1987-02-23	1987-03-02	1
45657	2715	4112343	1975-07-11	1975-07-24	1
80260	4759	4156265	1992-06-30	1992-07-14	1
79414	4709	260139	2000-11-20	2000-12-04	1
43357	2586	378001	2007-11-15	2007-12-15	1
66469	3938	80502	1990-08-15	1990-08-16	1
73836	4390	4112343	2012-02-13	2012-02-25	1
34654	2060	40481087	1984-09-24	1984-10-01	1
77813	4615	260139	1973-06-04	1973-06-18	1
3714	213	4112343	2017-03-16	2017-03-25	1
61831	3654	4112343	2004-06-07	2004-06-17	1
67171	3973	4296204	1970-05-16	1970-05-30	1
88963	5298	40481087	1974-04-11	1974-05-02	1
36377	2155	28060	1979-09-19	1979-10-02	1
76579	4544	192671	1984-06-02	1984-06-03	1
35194	2088	40481087	1908-10-30	1908-11-20	1
11731	693	81151	1955-01-11	1955-02-15	1
45658	2715	4112343	2006-09-28	2006-10-11	1
80261	4759	4283893	1988-07-22	1988-11-11	1
79415	4709	4112343	1965-04-23	1965-05-01	1
43358	2586	4112343	1983-05-11	1983-05-22	1
66470	3938	195588	1938-03-15	1938-05-10	1
73837	4390	4218389	1986-01-27	1986-02-17	1
34655	2060	40481087	1999-01-26	1999-02-16	1
77814	4615	260139	2002-08-11	2002-08-25	1
3715	213	4152936	2015-11-04	2015-11-25	1
61832	3654	4112343	2016-01-16	2016-01-27	1
69967	4145	134438	2006-07-06	2008-04-02	1
88964	5298	40481087	1988-03-15	1988-03-29	1
36378	2155	381316	2006-02-08	2006-02-09	1
76580	4544	260139	1949-06-20	1949-07-04	1
35195	2088	40481087	1913-04-04	1913-04-18	1
11732	693	192671	1995-09-01	1995-09-02	1
45659	2715	40481087	2006-01-03	2006-01-17	1
80262	4759	40481087	2014-09-24	2014-10-08	1
79416	4709	4113008	1962-03-07	1962-03-21	1
43359	2586	28060	1972-09-09	1972-09-21	1
66471	3938	260139	1926-07-06	1926-07-13	1
73838	4390	81151	2001-05-29	2001-07-03	1
34656	2060	378001	2008-11-07	2008-12-07	1
77815	4615	372328	1957-04-09	1958-03-26	2
3716	213	4266809	2003-09-09	2003-09-10	1
61833	3654	4132546	1974-07-01	1974-07-02	1
69968	4145	372328	1975-05-03	1975-06-15	1
88965	5298	260139	1963-10-10	1963-10-24	1
36379	2155	4112343	1986-01-02	1986-01-14	1
76581	4544	372328	1944-09-18	1945-06-26	1
35196	2088	40481087	1931-07-03	1931-07-10	1
11733	693	372328	1951-11-28	1952-03-11	1
45660	2715	317576	1979-04-26	1979-04-27	1
80263	4759	0	2008-11-08	2008-11-09	1
79417	4709	4294548	1988-12-06	1989-06-06	1
43360	2586	260139	1983-12-11	1983-12-25	1
66472	3938	372328	1969-07-11	1970-04-21	1
73839	4390	260139	1962-11-19	1962-12-03	1
34657	2060	4112343	1980-11-21	1980-12-02	1
77816	4615	372328	2000-09-15	2002-02-13	1
3717	213	40481087	1968-12-30	1969-01-06	1
61834	3654	40481087	1981-01-07	1981-01-28	1
69969	4145	4109685	2012-09-15	2012-09-29	1
88966	5298	4112343	1999-07-04	1999-07-14	1
36380	2155	4112343	2000-10-14	2000-10-24	1
76582	4544	4155034	1970-07-13	1970-07-27	1
35197	2088	40481087	1935-02-09	1935-02-16	1
11734	693	378001	1951-11-28	1952-01-27	1
45661	2715	4112343	2003-08-28	2003-09-10	1
80264	4759	28060	1992-05-21	1992-05-29	1
79418	4709	40481087	2007-03-20	2007-03-27	1
43361	2586	260139	2014-09-19	2014-09-26	1
66473	3938	40481087	1943-11-01	1943-11-08	1
73840	4390	260139	2004-12-20	2004-12-27	1
34658	2060	4112343	1996-09-07	1996-09-15	1
77817	4615	4112343	1995-09-25	1995-10-08	1
3718	213	28060	1967-12-01	1967-12-12	1
63488	3754	28060	1970-11-18	1970-11-26	1
69970	4145	4112343	1983-08-23	1983-08-30	1
88967	5298	40481087	1963-07-05	1963-07-19	1
36381	2155	40481087	1932-12-30	1933-01-06	1
76583	4544	40481087	1942-12-16	1942-12-30	1
35198	2088	40481087	1998-05-22	1998-06-12	1
11735	693	4113008	1966-09-13	1966-09-27	1
45662	2715	4294548	1973-02-14	1973-06-06	1
80265	4759	257012	1988-08-19	1988-08-20	1
79419	4709	260139	1984-09-09	1984-09-23	1
43362	2586	440086	1981-06-27	1984-04-21	1
66474	3938	40481087	1994-02-06	1994-02-27	1
73841	4390	372328	1970-11-29	1971-01-15	1
34659	2060	40481087	1973-05-21	1973-05-28	1
77818	4615	4116491	1988-04-11	1988-05-22	1
3719	213	192671	2003-10-18	2003-10-19	1
63489	3754	80180	2005-03-10	2005-03-11	1
69971	4145	260139	1993-11-25	1993-12-09	1
89286	5316	0	1984-01-02	1984-01-03	1
36382	2155	40481087	1940-12-02	1940-12-16	1
76584	4544	30753	1982-10-03	1982-10-04	1
35199	2088	40481087	2007-01-31	2007-02-07	1
11736	693	4142905	1968-09-16	1968-11-15	1
45663	2715	4329847	2017-11-23	2017-11-24	1
80266	4759	260139	2007-06-08	2007-06-15	1
79420	4709	40481087	1997-01-30	1997-02-13	1
43363	2586	4112343	1995-08-31	1995-09-12	1
66475	3938	260139	1915-01-26	1915-02-02	1
73842	4390	4112343	2002-12-30	2003-01-10	1
34660	2060	40481087	1986-03-31	1986-04-21	1
77819	4615	40481087	2006-07-29	2006-08-19	1
3720	213	260139	2004-06-16	2004-06-23	1
63490	3754	81151	1968-03-24	1968-04-21	1
69972	4145	260139	2017-07-22	2017-08-05	1
89287	5316	134438	1980-08-21	1981-11-14	1
36383	2155	40481087	1970-06-02	1970-06-16	1
76585	4544	195588	1961-10-18	1961-11-28	1
35200	2088	28060	1941-04-17	1941-04-24	1
11737	693	4296204	1962-02-22	1962-03-08	1
48525	2878	28060	1986-08-08	1986-08-16	1
80267	4759	4112343	1990-09-21	1990-09-28	1
79421	4709	40481087	2008-10-26	2008-11-02	1
43364	2586	4112343	2004-07-28	2004-08-07	1
66476	3938	378001	1937-06-29	1937-07-29	1
73843	4390	4112343	2014-03-18	2014-03-30	1
34661	2060	28060	1964-11-02	1964-11-14	1
77820	4615	78272	1969-12-02	1969-12-30	1
3721	213	260139	2016-06-09	2016-06-23	1
63491	3754	81151	2019-05-15	2019-05-29	1
69973	4145	4059173	1992-04-03	1992-06-02	1
89288	5316	192671	1995-08-02	1995-08-03	1
36384	2155	40481087	2004-04-07	2004-04-21	1
76586	4544	260139	1953-04-21	1953-04-28	1
35201	2088	192671	1945-04-25	1945-04-26	1
11738	693	40481087	1989-01-28	1989-02-18	1
48526	2878	260139	2000-07-20	2000-08-03	1
80268	4759	4283893	2011-06-26	2012-04-01	1
79422	4709	260139	1993-08-23	1993-09-06	1
43365	2586	40481087	1993-07-25	1993-08-01	1
66477	3938	381316	1976-10-20	1976-10-21	1
73844	4390	4113008	1973-02-13	1973-03-06	1
34662	2060	80180	2009-09-08	2009-09-09	1
77821	4615	81151	2011-04-24	2011-05-22	1
3722	213	372328	1970-11-11	1971-04-05	1
63492	3754	260139	1995-11-25	1995-12-02	1
69974	4145	40481087	1986-06-03	1986-06-10	1
89289	5316	260139	2014-12-10	2014-12-24	1
36385	2155	40481087	2006-02-17	2006-03-03	1
76587	4544	378001	1981-10-27	1981-12-26	1
35202	2088	260139	1909-09-18	1909-10-02	1
11739	693	40481087	1998-04-07	1998-04-21	1
48527	2878	372328	1982-05-16	1982-08-01	1
80269	4759	40481087	1992-10-30	1992-11-13	1
79423	4709	4112343	2001-10-21	2001-10-30	1
43366	2586	28060	1973-11-18	1973-11-27	1
66478	3938	4112343	1916-06-20	1916-07-03	1
73845	4390	40481087	1967-03-27	1967-04-10	1
34663	2060	260139	1964-02-04	1964-02-18	1
77822	4615	372328	1984-01-09	1986-10-29	1
3723	213	4112343	2001-12-09	2001-12-20	1
63493	3754	4027663	1992-12-28	1992-12-29	1
69975	4145	80180	2009-07-18	2009-07-19	1
89290	5316	4112343	1987-09-13	1987-09-22	1
36386	2155	260139	1935-05-28	1935-06-04	1
76588	4544	4112343	1984-04-02	1984-04-14	1
35203	2088	260139	1983-06-11	1983-06-25	1
11740	693	40481087	2007-06-11	2007-06-18	1
48528	2878	4112343	2002-12-30	2003-01-10	1
80270	4759	40481087	2009-03-25	2009-04-01	1
79424	4709	40481087	1984-05-15	1984-05-22	1
43367	2586	78272	1979-01-04	1979-01-18	1
66479	3938	4112343	1922-02-05	1922-02-15	1
73846	4390	40481087	2002-08-29	2002-09-19	1
34664	2060	372328	1968-06-10	1968-11-20	1
77823	4615	4112343	1991-04-03	1991-04-15	1
3724	213	4285898	2003-01-12	2003-01-13	1
63494	3754	4112343	2000-09-20	2000-10-03	1
69976	4145	40481087	1979-12-16	1979-12-30	1
89291	5316	40481087	1999-04-06	1999-04-20	1
36387	2155	260139	1985-10-10	1985-10-17	1
81886	4860	81151	2016-06-02	2016-07-07	1
35204	2088	372328	1910-02-14	1910-06-28	1
11741	693	78272	1959-05-25	1959-06-08	1
48529	2878	40481087	2018-06-23	2018-07-07	1
82933	4932	260139	1967-02-18	1967-03-04	1
79425	4709	40481087	1992-05-30	1992-06-20	1
43368	2586	80180	2007-09-04	2007-09-05	1
66480	3938	4112343	1997-08-08	1997-08-18	1
74523	4432	80180	1997-02-05	1997-02-06	1
34665	2060	4112343	1985-03-14	1985-03-26	1
77824	4615	4112343	2003-01-02	2003-01-15	1
3725	213	40481087	1989-03-17	1989-04-07	1
63495	3754	40481087	1966-01-18	1966-01-25	1
69977	4145	40481087	1995-06-29	1995-07-13	1
89292	5316	40481087	2011-08-22	2011-08-29	1
36388	2155	260139	2005-04-06	2005-04-20	1
81887	4860	134438	1999-10-01	2000-10-25	1
35205	2088	372328	1912-11-14	1913-07-01	1
11742	693	260139	1975-10-15	1975-10-23	1
48530	2878	4112343	1998-05-13	1998-05-23	1
82934	4932	260139	2002-10-12	2002-10-26	1
79426	4709	40481087	2007-01-29	2007-02-12	1
43369	2586	81893	2005-09-14	2005-09-15	1
66481	3938	40481087	1971-02-12	1971-03-05	1
74524	4432	81151	2014-06-27	2014-07-25	1
34666	2060	4112343	1992-05-01	1992-05-14	1
77825	4615	4112343	2019-02-08	2019-02-20	1
3726	213	40481087	2009-06-23	2009-07-14	1
63496	3754	40481087	1967-02-24	1967-03-03	1
69978	4145	40481087	2000-02-23	2000-03-08	1
89293	5316	28060	1963-06-28	1963-07-08	1
36389	2155	4109685	2003-06-03	2003-06-17	1
81888	4860	260139	2006-09-28	2006-10-05	1
35206	2088	4059173	1911-09-07	1911-12-06	1
11743	693	260139	2018-01-11	2018-01-25	1
48531	2878	4112343	2003-12-10	2003-12-17	1
82935	4932	260139	2016-09-09	2016-09-16	1
79427	4709	40481087	2018-09-18	2018-10-09	1
43370	2586	192671	2007-11-24	2007-11-25	1
66482	3938	40481087	1977-10-09	1977-10-16	1
74525	4432	260139	1966-01-11	1966-01-25	1
34667	2060	40481087	1981-01-14	1981-02-04	1
77826	4615	80180	1995-05-30	1995-05-31	1
3727	213	40481087	2012-11-30	2012-12-21	1
63497	3754	40481087	1971-03-19	1971-04-02	1
69979	4145	4112343	1994-02-05	1994-02-17	1
89294	5316	372328	1957-08-15	1957-10-28	1
36390	2155	4112343	1987-06-12	1987-06-24	1
81889	4860	4237458	1995-08-01	1995-08-31	1
35207	2088	4112343	2013-06-30	2013-07-09	1
11744	693	4112343	2007-10-04	2007-10-13	1
48532	2878	4218389	1993-07-08	1993-08-05	1
82936	4932	4112343	1985-03-04	1985-03-16	1
79428	4709	80180	1998-08-15	1998-08-16	1
43371	2586	4027663	1996-06-23	1996-06-24	1
66483	3938	40481087	1990-07-15	1990-07-22	1
74526	4432	4218389	1995-08-03	1995-08-31	1
34668	2060	40481087	1995-02-09	1995-02-16	1
77827	4615	260139	1963-08-08	1963-08-15	1
3728	213	40481087	2013-03-27	2013-04-03	1
63498	3754	40481087	1977-11-27	1977-12-11	1
69980	4145	4112343	2010-05-28	2010-06-10	1
89295	5316	372328	1960-11-16	1961-07-31	1
36391	2155	40481087	1928-07-10	1928-07-17	1
81890	4860	40481087	1986-08-26	1986-09-16	1
35208	2088	4237458	1969-03-02	1969-05-01	1
11745	693	4278672	1984-05-25	1984-06-24	1
48533	2878	40481087	1997-01-06	1997-01-13	1
82937	4932	4112343	2008-01-11	2008-01-21	1
79429	4709	372328	1956-06-06	1956-08-13	1
43372	2586	4112343	1989-07-22	1989-07-30	1
66484	3938	260139	1956-02-04	1956-02-11	1
74527	4432	40481087	1965-03-10	1965-03-24	1
38206	2272	28060	2001-03-14	2001-03-26	1
77828	4615	260139	2004-12-25	2005-01-08	1
3729	213	0	1977-04-29	1977-04-30	1
63499	3754	40481087	1995-04-20	1995-04-27	1
70276	4167	440086	1992-09-16	1996-09-25	1
89296	5316	4027663	1984-08-13	1984-08-14	1
36392	2155	40481087	1938-12-15	1939-01-05	1
81891	4860	40481087	2006-09-07	2006-09-21	1
35209	2088	4283893	1974-06-15	1974-08-10	1
11746	693	40481087	1980-11-06	1980-11-20	1
48534	2878	40481087	2004-05-24	2004-06-07	1
82938	4932	4112343	2019-04-24	2019-05-06	1
79430	4709	372328	1961-11-15	1962-04-23	1
43373	2586	4112343	2013-07-22	2013-07-31	1
66485	3938	378419	1993-09-01	1993-09-02	1
74528	4432	81151	2004-08-13	2004-09-17	1
38207	2272	4059173	1982-09-16	1982-12-15	1
77829	4615	4112343	1977-03-07	1977-03-16	1
3730	213	80180	2003-09-09	2003-09-10	1
63500	3754	40481087	2017-01-29	2017-02-05	1
70277	4167	4112343	1981-11-18	1981-11-29	1
89297	5316	4218389	1998-10-14	1998-11-04	1
36393	2155	40481087	1994-05-17	1994-05-24	1
81892	4860	40481087	2006-12-25	2007-01-15	1
35210	2088	4296205	1977-03-18	1977-04-08	1
13313	784	260139	1970-12-22	1970-12-29	1
48535	2878	40481087	2012-11-12	2012-12-03	1
82939	4932	81893	1994-07-03	1994-07-04	1
79431	4709	4112343	1969-12-10	1969-12-20	1
43374	2586	4266809	2007-09-04	2007-09-05	1
66486	3938	4112343	1946-12-09	1946-12-19	1
74529	4432	257012	1990-08-30	1990-08-31	1
38208	2272	40481087	1987-01-02	1987-01-23	1
77830	4615	4112343	1995-02-10	1995-02-23	1
3731	213	440448	1977-04-29	1977-04-30	1
63501	3754	28060	1963-02-18	1963-03-03	1
70278	4167	40481087	1983-03-27	1983-04-17	1
89298	5316	40481087	1957-05-23	1957-06-13	1
36394	2155	80180	1970-07-16	1970-07-17	1
81893	4860	78272	1999-07-11	1999-08-01	1
35211	2088	40480160	1992-06-18	1992-09-16	1
13314	784	4112343	1959-10-01	1959-10-10	1
48536	2878	80180	2019-04-02	2019-04-03	1
82940	4932	260139	2010-10-22	2010-10-29	1
79432	4709	4112343	1981-09-21	1981-10-04	1
43375	2586	4296204	1980-01-13	1980-02-10	1
66487	3938	40481087	1961-11-11	1961-11-25	1
74530	4432	260139	1978-09-03	1978-09-17	1
38209	2272	28060	2013-11-17	2013-11-27	1
77831	4615	4112343	1998-01-28	1998-02-10	1
3732	213	4112343	1986-09-05	1986-09-17	1
63502	3754	81893	2003-01-20	2003-01-21	1
70279	4167	40481087	2013-02-26	2013-03-05	1
89299	5316	28060	2016-06-22	2016-06-30	1
36395	2155	4112343	1961-08-11	1961-08-21	1
81894	4860	260139	2015-11-12	2015-11-21	1
35212	2088	40481087	1914-01-20	1914-01-27	1
13315	784	4112343	1972-09-03	1972-09-11	1
48537	2878	260139	1999-12-14	1999-12-21	1
82941	4932	4027663	1987-11-07	1987-11-08	1
79433	4709	4152936	1983-03-31	1983-04-21	1
43376	2586	40481087	1995-06-28	1995-07-12	1
67280	3982	257012	1965-12-17	1965-12-18	1
74531	4432	4112343	1959-03-21	1959-04-03	1
38210	2272	80180	2015-12-12	2015-12-13	1
77832	4615	4112343	2002-06-21	2002-07-02	1
3733	213	4112343	1990-01-31	1990-02-08	1
63503	3754	4112343	1973-07-17	1973-07-28	1
70280	4167	40481087	2018-06-13	2018-06-20	1
89300	5316	80180	1995-05-23	1995-05-24	1
36396	2155	4112343	2006-05-29	2006-06-10	1
81895	4860	40481087	2013-03-19	2013-04-02	1
35213	2088	40481087	1933-12-01	1933-12-08	1
13316	784	4112343	2007-01-24	2007-01-31	1
48538	2878	4027663	2011-08-17	2011-08-18	1
82942	4932	4112343	1995-09-21	1995-10-03	1
79434	4709	40481087	2018-12-15	2018-12-22	1
43377	2586	40486433	1973-07-06	1973-07-07	1
67281	3982	260139	1952-08-18	1952-09-01	1
74532	4432	4112343	2019-01-02	2019-01-10	1
38211	2272	81151	1996-09-02	1996-10-07	1
77833	4615	40481087	2017-08-30	2017-09-06	1
3734	213	40481087	1983-09-29	1983-10-06	1
63504	3754	4149245	2017-05-18	2017-06-24	1
70281	4167	378001	1983-09-08	1983-11-07	1
89301	5316	4112343	1966-01-25	1966-02-04	1
38484	2289	257012	1953-01-26	1953-01-27	1
81896	4860	80180	2011-10-11	2011-10-12	1
35214	2088	40481087	1951-06-23	1951-07-07	1
13317	784	4294548	2016-11-19	2016-12-17	1
48539	2878	40481087	1997-03-20	1997-04-10	1
82943	4932	40481087	1996-07-16	1996-08-06	1
79942	4745	260139	1981-11-27	1981-12-04	1
45140	2688	80180	2001-08-25	2001-08-26	1
67282	3982	260139	2015-01-17	2015-01-24	1
74533	4432	40481087	1977-11-21	1977-12-05	1
38212	2272	4112343	2010-02-10	2010-02-17	1
81528	4843	28060	1981-12-22	1981-12-29	1
3735	213	40481087	1995-12-11	1995-12-25	1
63505	3754	4266809	2005-03-10	2005-03-11	1
70282	4167	4280726	1982-09-26	1982-09-27	1
89302	5316	4155034	1966-09-27	1966-10-18	1
38485	2289	380378	1959-03-19	1959-03-20	1
81897	4860	260139	1988-05-27	1988-06-03	1
35215	2088	40481087	1967-01-20	1967-02-03	1
13318	784	260139	1991-06-29	1991-07-13	1
48540	2878	40481087	1998-11-09	1998-11-16	1
82944	4932	40481087	2008-09-19	2008-10-03	1
79943	4745	440086	1985-03-30	1993-04-07	1
45141	2688	260139	1964-06-12	1964-06-26	1
67283	3982	378001	1979-05-10	1979-07-09	1
74534	4432	4294548	1990-07-05	1990-09-06	1
38213	2272	4278672	1987-11-19	1988-02-17	1
81529	4843	372328	1964-02-10	1964-06-23	1
3736	213	40481087	2003-02-24	2003-03-03	1
63506	3754	40481087	1996-03-23	1996-03-30	1
70283	4167	4296204	2016-08-15	2016-09-19	1
89303	5316	4310024	1992-07-07	1992-07-08	1
38486	2289	4156265	2000-07-28	2000-08-18	1
81898	4860	372328	1979-10-24	1979-12-07	1
35216	2088	40481087	1981-05-14	1981-05-28	1
13319	784	260139	1967-11-18	1967-11-25	1
48541	2878	28060	1986-10-16	1986-10-29	1
82945	4932	80180	1996-02-23	1996-02-24	1
79944	4745	40481087	1983-03-30	1983-04-06	1
45142	2688	260139	2008-12-27	2009-01-10	1
67284	3982	4112343	1950-04-13	1950-04-26	1
74535	4432	4296205	1959-05-16	1959-06-13	1
38214	2272	40481087	2010-07-20	2010-07-27	1
81530	4843	4112343	2019-02-27	2019-03-12	1
3737	213	4027663	1992-04-24	1992-04-25	1
63507	3754	28060	1965-05-25	1965-06-01	1
70284	4167	4296205	1979-10-15	1979-10-29	1
89304	5316	28060	1957-07-17	1957-07-28	1
38487	2289	4294548	1952-12-15	1953-03-02	1
81899	4860	4112343	1995-12-03	1995-12-14	1
35217	2088	40481087	1981-12-29	1982-01-05	1
13320	784	260139	1979-01-17	1979-01-24	1
48542	2878	81151	1984-03-06	1984-03-27	1
82946	4932	260139	1990-09-06	1990-09-20	1
79945	4745	81151	1995-10-03	1995-10-31	1
45143	2688	4112343	2005-04-21	2005-05-03	1
67285	3982	4112343	1964-03-15	1964-03-26	1
74536	4432	40481087	1986-04-28	1986-05-19	1
38215	2272	81893	2014-07-20	2014-07-21	1
81531	4843	4218389	1980-05-16	1980-06-13	1
3738	213	4112343	2014-06-17	2014-06-28	1
63508	3754	372328	1961-04-25	1961-06-13	1
70285	4167	40481087	1981-04-14	1981-04-28	1
89305	5316	81893	1993-06-02	1993-06-03	1
38488	2289	40481087	1951-04-02	1951-04-16	1
81900	4860	4112343	1997-10-05	1997-10-16	1
35218	2088	40481087	1994-05-01	1994-05-08	1
13321	784	4112343	1997-04-05	1997-04-12	1
48543	2878	192671	2019-04-10	2019-04-11	1
82947	4932	4112343	1983-09-01	1983-09-10	1
79946	4745	4294548	2017-03-29	2017-05-17	1
45144	2688	4112343	2014-09-14	2014-09-24	1
67286	3982	4112343	1987-06-04	1987-06-14	1
74537	4432	40481087	2019-05-13	2019-06-03	1
38216	2272	4310024	2014-02-20	2014-02-21	1
81532	4843	40481087	1974-11-30	1974-12-14	1
3739	213	4155034	1988-05-10	1988-05-24	1
63509	3754	372328	1964-12-24	1965-06-01	1
70286	4167	40481087	1988-08-24	1988-09-14	1
89306	5316	260139	2011-08-04	2011-08-18	1
38489	2289	40481087	1990-09-15	1990-10-06	1
81901	4860	192671	2011-11-04	2011-11-05	1
35219	2088	30753	1944-02-06	1944-02-07	1
13322	784	4283893	1992-04-08	1992-04-29	1
48544	2878	4112343	1981-09-21	1981-09-30	1
82948	4932	40481087	1973-12-25	1974-01-08	1
79947	4745	40481087	1996-09-03	1996-09-10	1
45145	2688	4112343	2017-08-13	2017-08-20	1
67287	3982	4156265	1995-09-13	1995-10-04	1
74538	4432	260139	1970-03-11	1970-03-18	1
38217	2272	28060	2010-06-20	2010-07-02	1
81533	4843	40481087	2009-08-13	2009-09-03	1
3740	213	4310024	2001-08-20	2001-08-21	1
63510	3754	378001	1989-05-15	1989-07-14	1
70287	4167	40481087	1993-11-23	1993-12-07	1
89307	5316	321042	1984-01-02	1984-01-03	1
38490	2289	78272	2018-07-15	2018-08-19	1
81902	4860	260139	1980-06-21	1980-07-05	1
35220	2088	81151	1974-01-05	1974-02-02	1
13323	784	4294548	1959-12-04	1960-01-22	1
48545	2878	4112343	1996-10-08	1996-10-17	1
82949	4932	40481087	2007-03-08	2007-03-22	1
79948	4745	40481087	2017-06-23	2017-06-30	1
45146	2688	4294548	2010-12-16	2010-12-23	1
67288	3982	28060	1965-02-20	1965-02-27	1
74539	4432	260139	1994-08-09	1994-08-16	1
38218	2272	30753	2015-02-15	2015-02-16	1
81534	4843	28060	2001-02-18	2001-02-27	1
3741	213	40481087	2004-11-01	2004-11-08	1
63511	3754	4156265	1986-07-16	1986-07-30	1
70288	4167	28060	1983-10-24	1983-11-02	1
89308	5316	372328	1958-10-23	1959-01-26	1
38491	2289	80180	1985-10-08	1985-10-09	1
81903	4860	378001	1983-09-03	1983-11-02	1
35221	2088	258780	1967-11-14	1967-11-15	1
13324	784	40481087	1992-07-03	1992-07-24	1
48546	2878	4112343	2016-11-10	2016-11-20	1
79949	4745	80180	2016-10-08	2016-10-09	1
45147	2688	40481087	2015-12-03	2015-12-17	1
67289	3982	81151	2010-06-17	2010-07-15	1
74540	4432	4112343	1959-10-01	1959-10-11	1
38219	2272	260139	1994-09-14	1994-09-21	1
81535	4843	260139	1963-03-18	1963-03-25	1
4451	262	80180	1999-12-13	1999-12-14	1
63512	3754	40481087	1964-05-01	1964-05-22	1
70289	4167	28060	1990-07-02	1990-07-10	1
89309	5316	4113008	1993-03-30	1993-04-13	1
38492	2289	260139	2019-06-02	2019-06-16	1
81904	4860	40481087	2017-10-16	2017-10-30	1
35222	2088	260139	1930-05-09	1930-05-16	1
13325	784	40481087	2008-02-10	2008-03-02	1
48547	2878	4152936	1994-06-01	1994-06-22	1
79950	4745	257012	2017-05-10	2017-05-11	1
45148	2688	81151	1975-09-09	1975-10-14	1
67290	3982	260139	1940-08-03	1940-08-17	1
74541	4432	40481087	1959-11-21	1959-11-28	1
38220	2272	4027663	2006-11-24	2006-11-25	1
81536	4843	260139	2009-06-13	2009-06-20	1
4452	262	257012	1982-04-28	1982-04-29	1
63513	3754	40481087	2013-04-27	2013-05-11	1
70290	4167	260139	2002-01-13	2002-01-20	1
89310	5316	4266809	1995-05-23	1995-05-24	1
38493	2289	4112343	1972-07-01	1972-07-09	1
84727	5045	28060	1965-07-25	1965-08-03	1
35223	2088	260139	1938-12-28	1939-01-04	1
13326	784	80180	2000-09-13	2000-09-14	1
48548	2878	4266809	2019-04-02	2019-04-03	1
79951	4745	260139	1988-02-23	1988-03-01	1
45149	2688	40481087	1973-05-15	1973-05-22	1
67291	3982	378419	2011-11-11	2011-11-12	1
74542	4432	40481087	2012-10-17	2012-11-07	1
38221	2272	40481087	1990-12-09	1990-12-23	1
81537	4843	4001336	1979-03-23	1979-05-22	1
4453	262	4027663	1990-07-28	1990-07-29	1
63514	3754	28060	1990-03-03	1990-03-14	1
70291	4167	260139	2016-01-12	2016-01-19	1
38494	2289	40481087	1994-01-24	1994-02-07	1
84728	5045	28060	1974-09-16	1974-09-24	1
35224	2088	260139	1972-07-10	1972-07-24	1
13327	784	260139	2002-09-27	2002-10-04	1
48549	2878	40481087	2005-10-06	2005-10-13	1
79952	4745	4048171	1978-04-08	1978-04-09	1
45150	2688	40481087	2001-09-21	2001-10-05	1
67292	3982	381316	2018-04-27	2018-04-28	1
78179	4634	28060	1975-10-15	1975-10-22	1
38222	2272	40481087	2016-02-04	2016-02-25	1
81538	4843	4027663	1987-02-14	1987-02-15	1
4454	262	4112343	1985-01-10	1985-01-22	1
63515	3754	4112343	1966-06-28	1966-07-10	1
70292	4167	372328	1981-05-21	1981-08-26	1
38495	2289	0	1958-10-30	1958-10-31	1
84729	5045	4296204	1981-04-26	1981-05-24	1
35225	2088	4109685	1923-10-18	1923-11-08	1
13328	784	4035415	1982-04-01	1982-05-01	1
48550	2878	40481087	2015-12-23	2015-12-30	1
79953	4745	40481087	1984-06-07	1984-06-21	1
45151	2688	260139	1970-01-27	1970-02-10	1
67293	3982	4112343	1988-02-11	1988-02-22	1
78180	4634	28060	1989-06-30	1989-07-09	1
39976	2373	81151	1973-02-23	1973-03-09	1
81539	4843	4266809	1997-11-28	1997-11-29	1
4455	262	4285898	1999-03-18	1999-03-19	1
63516	3754	4218389	1961-09-22	1961-10-27	1
70293	4167	378001	1999-07-16	1999-08-15	1
38496	2289	80502	2009-12-29	2009-12-30	1
84730	5045	260139	1989-12-29	1990-01-12	1
35226	2088	4109685	2012-05-25	2012-06-15	1
13329	784	4113008	1992-08-06	1992-08-27	1
50319	2980	80180	2007-11-25	2007-11-26	1
79954	4745	40481087	1985-11-22	1985-12-06	1
45152	2688	372328	1963-01-17	1963-02-24	1
67294	3982	80180	1977-11-21	1977-11-22	1
78181	4634	80180	1997-10-20	1997-10-21	1
39977	2373	260139	2017-07-16	2017-07-30	1
81540	4843	40481087	1980-02-21	1980-03-13	1
4456	262	4310024	1998-02-21	1998-02-22	1
63517	3754	40481087	1963-06-20	1963-06-27	1
70294	4167	4266809	2015-11-30	2015-12-01	1
38497	2289	81151	1975-08-13	1975-09-17	1
84731	5045	40481087	1986-01-21	1986-02-11	1
35227	2088	4112343	1942-01-22	1942-02-01	1
13330	784	40481087	2011-08-19	2011-09-09	1
50320	2980	257012	1974-07-15	1974-07-16	1
79955	4745	40481087	2009-08-12	2009-09-02	1
45153	2688	372328	1964-08-17	1964-12-27	1
67295	3982	260139	1942-03-06	1942-03-13	1
78182	4634	372328	1964-09-11	1964-10-15	1
39978	2373	4112343	1988-07-17	1988-07-24	1
81541	4843	28060	1965-09-04	1965-09-13	1
4457	262	40481087	1986-12-25	1987-01-08	1
63518	3754	40481087	1971-08-09	1971-08-23	1
70295	4167	4285898	2015-06-03	2015-06-04	1
38498	2289	81151	1996-05-29	1996-06-19	1
84732	5045	40481087	2004-01-13	2004-01-20	1
35228	2088	4116491	1951-09-12	1951-11-01	1
14757	870	260139	2008-03-10	2008-03-24	1
50321	2980	4112343	1977-02-21	1977-03-02	1
79956	4745	81151	1981-12-26	1982-01-16	1
45154	2688	378001	2013-03-28	2013-04-27	1
67296	3982	260139	1956-02-23	1956-03-08	1
78183	4634	372328	1967-07-02	1967-10-19	1
39979	2373	40481087	2008-04-17	2008-05-08	1
81542	4843	30753	1996-11-03	1996-11-04	1
4458	262	40481087	1987-04-14	1987-04-21	1
63519	3754	40481087	1995-12-31	1996-01-14	1
70296	4167	80180	2015-11-30	2015-12-01	1
38499	2289	260139	1955-11-01	1955-11-15	1
84733	5045	28060	1963-08-19	1963-09-01	1
35229	2088	4230399	1992-06-18	1992-09-16	1
14758	870	4112343	2013-04-29	2013-05-06	1
50322	2980	4112343	2014-06-17	2014-06-25	1
79957	4745	260139	2011-09-28	2011-10-12	1
45155	2688	4112343	1974-11-16	1974-11-27	1
67297	3982	260139	1984-05-16	1984-05-30	1
78184	4634	4112343	1988-04-20	1988-05-03	1
39980	2373	4112343	1962-07-03	1962-07-13	1
81543	4843	257012	1986-12-08	1987-01-05	1
4459	262	28060	1974-10-24	1974-11-01	1
63520	3754	40481087	2011-01-18	2011-02-01	1
70297	4167	260139	1992-12-06	1992-12-13	1
38500	2289	260139	1977-04-29	1977-05-06	1
84734	5045	81151	1979-05-23	1979-06-06	1
35230	2088	40481087	1982-11-09	1982-11-23	1
14759	870	4134304	1971-10-06	1971-11-05	1
50323	2980	4294548	1974-05-13	1975-05-12	1
79958	4745	4112343	2018-03-18	2018-03-27	1
45156	2688	40481087	1987-07-06	1987-07-13	1
67298	3982	260139	2007-12-10	2007-12-24	1
78185	4634	4155034	1989-09-17	1989-10-01	1
39981	2373	4112343	1970-05-01	1970-05-08	1
81544	4843	260139	1988-08-13	1988-08-20	1
4460	262	30753	1998-11-18	1998-11-19	1
63521	3754	40481087	2011-10-05	2011-10-26	1
70298	4167	372328	1979-08-16	1979-11-28	1
38501	2289	260139	1991-04-03	1991-04-17	1
84735	5045	4112343	1993-12-16	1993-12-28	1
35231	2088	40481087	1990-01-22	1990-02-12	1
14760	870	4294548	2000-09-14	2001-04-26	1
50324	2980	40481087	2008-05-06	2008-05-13	1
79959	4745	4296205	1982-11-12	1982-12-10	1
45157	2688	78272	1973-06-23	1973-07-21	1
67299	3982	4112343	2016-06-26	2016-07-09	1
78186	4634	81151	1996-04-27	1996-05-25	1
39982	2373	4294548	1978-08-10	1978-08-31	1
81545	4843	4134304	1984-06-22	1984-09-20	1
4461	262	4112343	1966-09-24	1966-10-03	1
64335	3804	372328	1964-05-10	1964-11-12	1
70299	4167	4027663	2006-09-13	2006-09-14	1
38502	2289	372328	1953-06-13	1953-09-08	1
84736	5045	4112343	1997-01-12	1997-01-19	1
37468	2226	28060	1993-11-06	1993-11-19	1
14761	870	40481087	1974-01-06	1974-01-27	1
50325	2980	40481087	2009-08-15	2009-08-22	1
79960	4745	40481087	1989-01-28	1989-02-04	1
45158	2688	378001	1963-09-14	1963-10-14	1
67300	3982	4283893	1965-11-26	1966-02-11	1
78187	4634	4112343	2008-04-14	2008-04-23	1
39983	2373	4294548	1992-10-08	1992-12-03	1
81546	4843	4285898	1997-07-31	1997-08-01	1
4462	262	40481087	2012-06-13	2012-07-04	1
64336	3804	4266809	2003-04-16	2003-04-17	1
70300	4167	4112343	1980-12-11	1980-12-19	1
38503	2289	372328	1963-01-19	1963-12-24	1
84737	5045	40481087	1982-01-13	1982-02-03	1
37469	2226	30753	1977-07-08	1977-07-09	1
14762	870	28060	2011-11-23	2011-12-04	1
50326	2980	40481087	2016-03-26	2016-04-09	1
84743	5046	80180	1995-09-22	1995-09-23	1
45159	2688	4112343	1984-12-08	1984-12-21	1
67301	3982	40481087	1976-01-29	1976-02-05	1
78188	4634	4112343	2015-05-03	2015-05-14	1
39984	2373	40481087	1984-04-03	1984-04-17	1
81547	4843	40481087	1967-03-01	1967-03-08	1
4463	262	192671	1999-12-29	1999-12-30	1
64337	3804	4278672	1962-09-18	1962-10-18	1
70301	4167	40481087	1999-08-17	1999-08-31	1
38504	2289	440086	1963-10-29	1967-11-07	1
84738	5045	28060	1999-12-08	1999-12-20	1
37470	2226	260139	1957-08-11	1957-08-25	1
14763	870	257012	1968-09-17	1968-09-18	1
50327	2980	260139	1993-01-11	1993-01-18	1
84744	5046	260139	2009-05-18	2009-06-01	1
45160	2688	4112343	1985-04-24	1985-05-02	1
67302	3982	40481087	1987-12-10	1987-12-31	1
78189	4634	4283893	1972-05-23	1972-06-13	1
39985	2373	134438	1978-01-20	1980-11-05	1
81548	4843	80180	1997-11-28	1997-11-29	1
4464	262	440086	1978-07-31	1982-08-09	1
64338	3804	80180	2003-04-16	2003-04-17	1
72574	4317	260139	1970-12-03	1970-12-17	1
38505	2289	4112343	1953-02-28	1953-03-10	1
84739	5045	80180	1995-05-14	1995-05-15	1
37471	2226	372328	1943-05-31	1943-07-02	1
14764	870	260139	1962-09-24	1962-10-01	1
50328	2980	260139	2013-01-03	2013-01-17	1
84745	5046	4112343	1994-04-20	1994-05-03	1
45161	2688	40481087	1971-11-08	1971-11-15	1
67303	3982	195588	1968-11-03	1968-12-06	1
78190	4634	40481087	1964-09-03	1964-09-24	1
39986	2373	260139	1956-09-16	1956-09-30	1
81549	4843	260139	1984-05-05	1984-05-19	1
4465	262	4059173	1967-03-21	1967-06-19	1
64339	3804	81151	2018-04-23	2018-05-28	1
72575	4317	260139	2007-11-25	2007-12-09	1
38506	2289	4112343	2013-08-07	2013-08-15	1
84740	5045	260139	1967-04-28	1967-05-12	1
37472	2226	28060	2003-11-10	2003-11-17	1
14765	870	260139	1975-10-08	1975-10-15	1
50329	2980	372328	1975-12-10	1976-07-18	1
84746	5046	4112343	2002-07-24	2002-08-03	1
45162	2688	40481087	1984-10-29	1984-11-12	1
67304	3982	260139	1986-09-22	1986-09-29	1
78191	4634	40481087	2009-06-06	2009-06-27	1
39987	2373	260139	1961-04-08	1961-04-22	1
81550	4843	375671	1997-07-14	1997-08-13	1
4466	262	4266809	1999-12-13	1999-12-14	1
64340	3804	260139	1991-06-19	1991-07-03	1
72576	4317	317576	2018-11-01	2018-11-02	1
38507	2289	4155034	1971-11-18	1971-12-02	1
84741	5045	260139	1985-02-08	1985-02-22	1
37473	2226	81151	2008-11-23	2008-12-14	1
14766	870	372328	1963-07-20	1963-11-12	1
50330	2980	40481087	1979-04-28	1979-05-05	1
84747	5046	4266809	1995-09-22	1995-09-23	1
45163	2688	40481087	1989-10-05	1989-10-19	1
67305	3982	372328	1988-11-18	1989-10-13	1
78192	4634	28060	1976-09-17	1976-09-27	1
39988	2373	260139	1992-12-01	1992-12-15	1
81551	4843	378001	2001-08-22	2001-09-21	1
4467	262	375671	1972-03-24	1972-04-23	1
64341	3804	4027663	1993-11-24	1993-11-25	1
72577	4317	4230399	1998-11-05	1999-02-03	1
38508	2289	4294548	1972-11-10	1973-05-11	1
84742	5045	40481087	1988-10-05	1988-10-26	1
37474	2226	260139	1945-05-08	1945-05-15	1
14767	870	40481087	1986-04-02	1986-04-23	1
50331	2980	78272	1973-12-08	1974-01-12	1
84748	5046	4310024	1993-08-03	1993-08-04	1
45164	2688	40481087	2007-06-12	2007-06-26	1
67306	3982	40481087	1963-07-12	1963-08-02	1
78193	4634	28060	2012-03-06	2012-03-15	1
39989	2373	372328	1956-09-15	1956-09-29	1
81552	4843	4278672	1974-06-17	1974-08-16	1
4468	262	4156265	2005-05-30	2005-06-13	1
64342	3804	4237458	2000-01-28	2000-02-27	1
72578	4317	40481087	1996-03-23	1996-04-13	1
38509	2289	40481087	1968-06-19	1968-06-26	1
37475	2226	372328	1942-09-20	1943-01-01	1
14768	870	78272	1978-02-01	1978-02-15	1
50332	2980	260139	1983-05-22	1983-05-29	1
84749	5046	40481087	1991-10-27	1991-11-02	1
47139	2806	78272	1964-07-08	1964-08-12	1
67307	3982	40481087	2008-10-16	2008-11-06	1
78194	4634	260139	2002-03-15	2002-03-29	1
39990	2373	4112343	1957-06-14	1957-06-26	1
81553	4843	4283893	1986-09-15	1987-01-05	1
4469	262	4283893	1982-04-07	1982-06-02	1
64343	3804	4283893	2007-09-11	2007-10-02	1
72579	4317	40481087	2002-10-16	2002-10-23	1
38510	2289	40481087	2002-07-01	2002-07-15	1
37476	2226	4112343	1965-11-17	1965-11-29	1
14769	870	78272	1979-02-10	1979-03-17	1
50333	2980	40481087	1984-04-16	1984-05-07	1
84750	5046	81893	1994-04-30	1994-05-01	1
47140	2806	4112343	1955-08-08	1955-08-16	1
71662	4256	81893	1991-02-18	1991-02-19	1
78195	4634	372328	1963-07-06	1963-10-17	1
39991	2373	4112343	1965-11-26	1965-12-09	1
81554	4843	40481087	1974-09-02	1974-09-23	1
4470	262	4294548	2016-12-16	2016-12-30	1
64344	3804	40481087	1968-05-24	1968-06-14	1
72580	4317	4112343	1953-02-05	1953-02-15	1
38511	2289	28060	1950-04-04	1950-04-12	1
37477	2226	4112343	1966-12-27	1967-01-08	1
14770	870	80180	1998-08-20	1998-08-21	1
50334	2980	40481087	1998-01-02	1998-01-09	1
84751	5046	4112343	2015-07-26	2015-08-05	1
47141	2806	40479422	1983-03-06	1983-05-12	1
71663	4256	4112343	1961-11-01	1961-11-14	1
78196	4634	4112343	1980-11-17	1980-11-27	1
39992	2373	4283893	1970-08-11	1970-09-29	1
83076	4942	28060	1960-03-29	1960-04-10	1
4471	262	40481087	1980-10-16	1980-11-06	1
64345	3804	40481087	1989-06-19	1989-07-03	1
72581	4317	4112343	1955-02-06	1955-02-18	1
38512	2289	81151	1957-04-23	1957-05-14	1
37478	2226	4112343	1994-08-17	1994-08-28	1
14771	870	81151	2002-11-11	2002-12-02	1
50335	2980	40481087	2004-12-11	2004-12-18	1
84752	5046	40481087	2008-04-14	2008-04-28	1
47142	2806	40481087	1990-08-13	1990-09-03	1
71664	4256	4156265	1974-09-10	1974-10-01	1
78197	4634	4112343	1970-03-03	1970-03-12	1
39993	2373	40481087	2011-11-24	2011-12-15	1
83077	4942	260139	1986-12-08	1986-12-15	1
4472	262	40481087	1986-01-19	1986-02-09	1
64346	3804	40481087	1999-08-11	1999-08-18	1
72582	4317	4112343	1966-05-23	1966-05-30	1
38513	2289	4029498	1958-10-30	1958-10-31	1
37479	2226	4285898	1977-09-06	1977-09-07	1
14772	870	260139	1979-05-19	1979-05-26	1
50336	2980	81151	1980-02-10	1980-02-24	1
84753	5046	81151	1971-09-03	1971-10-08	1
47143	2806	372328	1958-05-20	1959-04-02	1
71665	4256	40479768	2009-12-26	2010-02-01	1
78198	4634	4112343	1976-11-27	1976-12-06	1
39994	2373	80180	1997-10-25	1997-10-26	1
83078	4942	317576	1982-10-14	1982-10-15	1
4473	262	40481087	1986-06-14	1986-06-21	1
64347	3804	30753	2002-09-18	2002-09-19	1
72583	4317	4237458	1961-11-19	1961-12-19	1
38514	2289	4059173	1964-11-24	1965-01-23	1
37480	2226	40481087	1949-01-23	1949-01-30	1
14773	870	372328	2006-08-01	2006-09-12	1
50337	2980	372328	1974-06-06	1974-11-24	1
84754	5046	81151	2000-05-06	2000-05-20	1
47144	2806	4134304	1982-01-10	1982-04-10	1
71666	4256	40481087	1988-04-01	1988-04-15	1
78199	4634	4112343	2006-02-12	2006-02-23	1
39995	2373	257012	1970-09-08	1992-12-03	1
83079	4942	4059173	1955-02-23	1955-04-24	1
4474	262	40481087	1996-11-06	1996-11-27	1
64348	3804	81893	2002-03-22	2002-03-23	1
72584	4317	40481087	1965-01-26	1965-02-02	1
38515	2289	4113008	1961-11-19	1961-12-10	1
37481	2226	40481087	2011-12-20	2011-12-27	1
14774	870	4112343	2014-07-03	2014-07-10	1
50338	2980	372328	1975-02-22	1975-07-13	1
84755	5046	372328	1959-08-07	1959-12-21	1
47145	2806	4278672	2009-05-25	2009-07-24	1
71667	4256	198809	1963-11-14	1963-11-14	1
78200	4634	40481087	2015-08-01	2015-08-22	1
39996	2373	260139	1996-06-12	1996-06-26	1
83080	4942	4109685	1981-12-08	1981-12-29	1
6263	368	28060	1990-09-29	1990-10-06	1
64349	3804	192671	2003-07-05	2003-07-06	1
72585	4317	40481087	1973-10-15	1973-10-22	1
38516	2289	4283893	2010-03-11	2010-04-29	1
37482	2226	28060	1949-08-17	1949-08-27	1
14775	870	4230399	1993-04-02	1993-07-01	1
50339	2980	4218389	1981-02-18	1981-03-18	1
84756	5046	372328	1961-12-10	1962-12-24	1
47146	2806	4294548	1988-11-27	1989-03-12	1
71668	4256	260139	1985-11-21	1985-11-28	1
79838	4736	260139	1987-10-29	1987-11-05	1
39997	2373	4059173	1969-08-13	1969-09-12	1
83081	4942	4266809	1986-12-07	1986-12-08	1
6264	368	80180	2004-11-16	2004-11-17	1
64350	3804	378001	2007-11-17	2007-12-17	1
72586	4317	40481087	1989-11-03	1989-11-17	1
38517	2289	40481087	1985-04-16	1985-05-07	1
37483	2226	4027663	1968-01-17	1968-01-18	1
14776	870	4294548	1968-08-27	1968-12-24	1
50340	2980	40486433	1973-12-25	1990-12-23	1
84757	5046	4027663	1984-01-07	1984-01-08	1
47147	2806	80180	1996-03-21	1996-03-22	1
71669	4256	372328	1954-10-25	1955-03-13	1
79839	4736	372328	1976-11-06	1977-08-05	1
39998	2373	4112343	1967-06-05	1967-06-12	1
83082	4942	4294548	1966-07-12	1966-09-20	1
6265	368	260139	2008-10-22	2008-11-05	1
64351	3804	40481087	1983-10-01	1983-10-15	1
72587	4317	260139	1977-11-23	1977-11-30	1
43414	2590	81893	2000-08-02	2000-08-03	1
37484	2226	4112343	1950-03-29	1950-04-08	1
14777	870	40481087	2015-03-19	2015-04-09	1
51042	3026	28060	2004-08-09	2004-08-21	1
84758	5046	4155034	2012-11-12	2012-12-03	1
47148	2806	260139	1985-02-28	1985-03-14	1
71670	4256	375671	1959-05-02	1959-06-01	1
79840	4736	4112343	1998-08-12	1998-08-24	1
39999	2373	4112343	1972-01-30	1972-02-09	1
83083	4942	4294548	1971-07-01	1971-08-12	1
6266	368	4112343	2003-03-04	2003-03-14	1
64352	3804	40481087	1986-04-10	1986-05-01	1
72588	4317	260139	1980-05-20	1980-06-03	1
43415	2590	30753	2001-06-28	2001-06-29	1
37485	2226	4112343	1982-02-21	1982-03-05	1
14778	870	28060	1970-04-17	1970-04-30	1
51043	3026	80180	1996-04-27	1996-04-28	1
84759	5046	4285898	1995-03-25	1995-03-26	1
47149	2806	4113008	1957-09-22	1957-10-13	1
71671	4256	4112343	1997-09-22	1997-09-30	1
79841	4736	260139	1982-08-17	1982-08-24	1
40000	2373	4142905	1957-10-10	1958-01-08	1
83084	4942	40481087	1961-05-11	1961-05-18	1
6267	368	28060	2008-04-30	2008-05-07	1
64353	3804	78272	1971-08-02	1971-08-23	1
72589	4317	260139	2012-03-19	2012-04-02	1
43416	2590	80180	2002-09-21	2002-09-22	1
37486	2226	4112343	2001-05-08	2001-05-20	1
14779	870	260139	1977-09-15	1977-09-22	1
51044	3026	257012	1998-01-14	1998-01-15	1
84760	5046	40481087	1971-04-10	1971-04-17	1
47150	2806	40481087	1975-11-18	1975-12-09	1
71672	4256	40481087	1971-12-04	1971-12-18	1
79842	4736	4112343	2016-10-22	2016-11-01	1
40001	2373	4218389	1959-12-29	1960-02-02	1
83085	4942	80180	1986-12-07	1986-12-08	1
6268	368	81151	1982-03-12	1982-03-26	1
64354	3804	4112343	2001-05-30	2001-06-09	1
72590	4317	372328	1947-09-04	1947-10-16	1
43417	2590	372328	1963-04-14	1963-06-25	1
37487	2226	4310024	1976-10-11	1976-10-12	1
14780	870	372328	1965-12-01	1966-11-29	1
51045	3026	260139	1971-01-22	1971-02-05	1
84761	5046	28060	2006-01-16	2006-01-29	1
47151	2806	40481087	2011-10-09	2011-10-23	1
71673	4256	40481087	1992-01-04	1992-01-11	1
79843	4736	4237458	2009-01-25	2009-03-26	1
40002	2373	40481087	1976-08-07	1976-08-14	1
83086	4942	260139	1989-12-16	1989-12-23	1
6269	368	4112343	2008-03-20	2008-03-29	1
64355	3804	4296204	1978-11-14	1978-12-19	1
72591	4317	4112343	1971-03-06	1971-03-16	1
43418	2590	372328	1968-06-28	1968-10-01	1
37488	2226	40481087	2002-03-19	2002-04-02	1
14781	870	4112343	2001-01-20	2001-02-01	1
51046	3026	378001	1999-06-15	1999-08-14	1
84762	5046	30753	1994-08-28	1994-08-29	1
47152	2806	40481087	2013-07-22	2013-08-05	1
71674	4256	80180	1992-06-12	1992-06-13	1
79844	4736	40481087	2019-06-14	2019-06-15	1
40003	2373	40481087	1979-07-02	1979-07-23	1
83087	4942	381316	2006-08-03	2006-08-04	1
6270	368	40481087	1987-08-22	1987-09-05	1
64356	3804	40481087	1962-01-27	1962-02-17	1
72592	4317	4112343	1987-07-02	1987-07-13	1
43419	2590	4027663	1992-10-08	1992-10-09	1
37489	2226	40481087	2002-06-10	2002-07-01	1
14782	870	4112343	2006-09-05	2006-09-16	1
51047	3026	28060	2018-08-26	2018-09-06	1
84763	5046	4112343	1968-12-20	1968-12-29	1
47153	2806	80502	2013-06-13	2013-06-14	1
71675	4256	257012	1997-05-20	1997-05-21	1
79845	4736	80180	2013-08-21	2013-08-22	1
40004	2373	40481087	2003-10-14	2003-11-04	1
83088	4942	4112343	2001-09-03	2001-09-12	1
6271	368	40481087	1997-11-16	1997-11-23	1
64357	3804	40481087	1994-04-16	1994-04-30	1
72593	4317	40481087	1967-09-25	1967-10-09	1
43420	2590	4310024	2000-05-04	2000-05-05	1
37490	2226	28060	1999-03-09	1999-03-19	1
14783	870	40481087	2011-12-05	2011-12-26	1
51048	3026	260139	2010-03-28	2010-04-04	1
84764	5046	4112343	2012-10-26	2012-11-04	1
47154	2806	257012	1989-01-29	1989-01-30	1
71676	4256	260139	1991-06-01	1991-06-15	1
79846	4736	260139	1974-11-05	1974-11-19	1
45527	2709	80180	1984-01-14	1984-01-15	1
83089	4942	4146173	1964-09-17	1964-11-16	1
6272	368	40481087	2004-12-21	2005-01-11	1
66915	3961	381316	2014-10-28	2014-10-29	1
72594	4317	80180	1988-08-14	1988-08-15	1
43421	2590	78272	1966-06-27	1966-07-25	1
37491	2226	80180	1978-02-03	1978-02-04	1
15290	906	40481087	2006-02-24	2006-03-03	1
51049	3026	4112343	2011-12-17	2011-12-29	1
84765	5046	4296204	1992-08-18	1992-09-15	1
47155	2806	317576	1985-03-07	1985-03-08	1
71677	4256	372328	1957-08-29	1957-09-12	1
79847	4736	260139	1994-09-30	1994-10-14	1
45528	2709	260139	1943-12-17	1943-12-24	1
83090	4942	40481087	1961-07-23	1961-07-30	1
7022	412	30753	1992-08-28	1992-08-29	1
66916	3961	4109685	1975-10-31	1975-11-21	1
72595	4317	4112343	1981-08-22	1981-08-29	1
43422	2590	78272	1990-10-04	1990-11-01	1
37492	2226	81893	1976-11-10	1976-11-11	1
15291	906	372328	1974-01-19	1974-02-02	1
51050	3026	4278672	2017-05-11	2017-08-09	1
84766	5046	40481087	1984-02-14	1984-02-28	1
47156	2806	4112343	1972-02-19	1972-03-02	1
71678	4256	4027663	1980-09-28	1980-09-29	1
79848	4736	4112343	1973-01-15	1973-01-23	1
45529	2709	372328	1943-12-15	1945-01-02	1
83091	4942	30753	1985-11-12	1985-11-13	1
7023	412	381316	2004-06-18	2004-06-19	1
66917	3961	40481087	1985-05-03	1985-05-24	1
72596	4317	4278672	1954-01-30	1954-04-30	1
43423	2590	81151	1979-01-18	1979-02-22	1
37493	2226	260139	1945-08-29	1945-09-12	1
15292	906	4059173	2011-10-07	2012-01-05	1
51051	3026	4294548	2003-07-10	2003-09-04	1
84913	5056	81151	2013-09-30	2013-10-14	1
47157	2806	4116491	1987-04-08	1987-05-19	1
71679	4256	4112343	2008-11-02	2008-11-14	1
79849	4736	4152936	1981-04-01	1981-04-15	1
45530	2709	4112343	1950-12-09	1950-12-17	1
83092	4942	313217	2004-04-29	2004-04-30	1
7024	412	4112343	1981-06-18	1981-06-26	1
66918	3961	40481087	2007-03-29	2007-04-05	1
72597	4317	4278672	1964-10-04	1964-11-03	1
43424	2590	4112343	1965-06-05	1965-06-15	1
37494	2226	260139	1971-02-23	1971-03-02	1
15293	906	4112343	1976-03-10	1976-03-19	1
51052	3026	40481087	1999-12-05	1999-12-19	1
84914	5056	81893	1978-09-07	1978-09-08	1
47158	2806	40481087	1962-12-04	1962-12-25	1
71680	4256	4112343	2013-06-22	2013-07-01	1
79850	4736	40481087	1985-01-02	1985-01-16	1
45531	2709	4112343	2008-01-31	2008-02-12	1
83093	4942	378001	1961-01-06	1961-03-07	1
7025	412	4113008	1965-06-30	1965-07-21	1
66919	3961	80180	2011-09-15	2011-09-16	1
72598	4317	40481087	1949-12-01	1949-12-08	1
43425	2590	4134304	1967-06-20	1967-08-19	1
37495	2226	260139	1988-09-30	1988-10-07	1
15294	906	80180	2011-09-07	2011-09-08	1
51053	3026	260139	1995-11-03	1995-11-17	1
84915	5056	257012	1985-01-31	1985-05-30	1
47159	2806	40481087	1968-11-02	1968-11-16	1
71681	4256	4310024	1990-07-23	1990-07-24	1
79851	4736	40481087	2001-07-29	2001-08-12	1
45532	2709	4134304	1984-03-03	1984-06-01	1
83094	4942	4112343	1973-03-04	1973-03-16	1
7026	412	40481087	1986-12-23	1987-01-06	1
66920	3961	192671	2011-11-24	2011-11-25	1
73361	4366	28060	1983-09-25	1983-10-02	1
43426	2590	4294548	1991-01-20	1991-06-23	1
37496	2226	372328	1947-02-11	1947-09-26	1
15295	906	260139	1991-05-21	1991-05-28	1
51054	3026	4112343	1984-02-06	1984-02-18	1
84916	5056	260139	1967-04-25	1967-05-02	1
47160	2806	40481087	1978-02-03	1978-02-17	1
71682	4256	40481087	1974-08-12	1974-08-19	1
79852	4736	260139	1979-11-23	1979-11-30	1
45533	2709	4278672	1944-11-07	1944-12-07	1
83095	4942	4116491	2003-04-17	2003-06-03	1
7027	412	257012	1975-02-23	1975-02-24	1
66921	3961	4112343	1977-05-19	1977-05-31	1
73362	4366	80180	2015-06-16	2015-06-17	1
43427	2590	40481087	1963-05-20	1963-06-10	1
37497	2226	378001	2010-12-04	2011-02-02	1
15296	906	372328	1974-05-03	1974-08-06	1
51055	3026	4112343	1987-09-04	1987-09-12	1
84917	5056	4094814	1973-08-31	1973-09-30	1
47161	2806	40481087	2001-09-11	2001-09-25	1
71683	4256	40481087	1980-04-27	1980-05-04	1
79853	4736	372328	1974-11-04	1975-05-16	1
45534	2709	40481087	1947-05-07	1947-05-28	1
83096	4942	4156265	1957-03-14	1957-03-28	1
7028	412	260139	1982-11-09	1982-11-23	1
66922	3961	4112343	2000-12-23	2001-01-03	1
73363	4366	260139	1985-09-24	1985-10-01	1
43428	2590	40481087	1964-07-12	1964-07-19	1
37498	2226	4112343	2014-07-26	2014-08-02	1
15297	906	378001	1985-01-21	1985-02-20	1
51056	3026	4278672	1971-07-28	1971-10-26	1
84918	5056	4112343	1983-08-29	1983-09-07	1
48026	2853	28060	1965-07-10	1965-07-23	1
71684	4256	28060	1956-12-14	1956-12-26	1
79854	4736	40479422	2002-08-23	2002-10-29	1
45535	2709	40481087	1953-05-23	1953-06-13	1
83097	4942	4218389	1985-09-09	1985-09-30	1
7029	412	372328	1953-08-13	1953-10-23	1
66923	3961	4112343	2016-06-17	2016-06-25	1
73364	4366	372328	1984-09-01	1985-01-01	1
43429	2590	40481087	1965-01-24	1965-01-31	1
37499	2226	4113008	2001-06-12	2001-07-03	1
15298	906	4294548	1983-04-23	1983-06-18	1
51057	3026	40481087	1975-03-01	1975-03-15	1
84919	5056	4218389	1955-08-08	1955-09-05	1
48027	2853	80180	1999-06-13	1999-06-14	1
71685	4256	196456	1963-11-14	1963-11-14	1
79855	4736	40481087	1974-10-10	1974-10-31	1
45536	2709	40481087	1974-05-24	1974-05-31	1
83098	4942	81151	1994-10-13	1994-11-03	1
7030	412	372328	1955-03-17	1955-04-22	1
66924	3961	4296205	1990-06-05	1990-07-10	1
73365	4366	372328	1998-10-20	1999-03-23	1
43430	2590	40481087	1998-04-26	1998-05-10	1
37500	2226	40481087	1992-03-20	1992-04-03	1
15299	906	40481087	1977-01-12	1977-01-19	1
51058	3026	40481087	1975-05-20	1975-06-10	1
84920	5056	4278672	2005-10-12	2006-01-10	1
48028	2853	4112343	1995-11-27	1995-12-06	1
71686	4256	260139	1958-03-09	1958-03-16	1
79856	4736	40481087	1976-07-27	1976-08-10	1
45537	2709	40481087	2003-04-23	2003-05-07	1
83099	4942	81151	1998-04-16	1998-05-21	1
7031	412	372328	1957-10-10	1958-04-25	1
66925	3961	40481087	1999-11-13	1999-12-04	1
73366	4366	375671	1995-08-20	1995-10-19	1
43431	2590	40481087	2011-01-11	2011-01-25	1
37835	2244	0	1964-07-23	1964-07-24	1
15300	906	28060	1979-01-07	1979-01-15	1
51059	3026	28060	1971-12-26	1972-01-07	1
84921	5056	40481087	1949-12-06	1949-12-20	1
48029	2853	4112343	2014-11-28	2014-12-10	1
71687	4256	4112343	1983-07-24	1983-08-03	1
85063	5065	28060	2000-07-31	2000-08-10	1
45538	2709	40481087	2017-10-30	2017-11-13	1
83100	4942	81893	1985-05-16	1985-05-17	1
7032	412	4237458	1963-03-13	1963-06-11	1
66926	3961	40481087	2005-11-06	2005-11-27	1
73367	4366	4051466	1984-05-11	2001-04-03	1
43432	2590	78272	1980-02-17	1980-03-09	1
37836	2244	28060	1956-09-07	1956-09-15	1
15301	906	4112343	1981-04-07	1981-04-15	1
51060	3026	260139	1955-03-25	1955-04-08	1
84922	5056	40481087	1952-06-12	1952-06-26	1
48030	2853	4294548	1982-10-28	1982-12-02	1
71688	4256	4134304	1961-04-21	1961-06-20	1
85064	5065	4112343	1984-05-16	1984-05-27	1
45539	2709	28060	1973-01-01	1973-01-14	1
83101	4942	257012	1958-05-05	1958-05-06	1
7033	412	40481087	1956-10-31	1956-11-07	1
66927	3961	260139	1973-03-09	1973-03-16	1
73368	4366	40481087	2008-06-14	2008-06-21	1
43433	2590	260139	1994-01-03	1994-01-10	1
37837	2244	78272	1972-04-15	1972-05-06	1
15302	906	4116491	2017-02-17	2017-04-05	1
51061	3026	260139	1966-06-09	1966-06-16	1
84923	5056	40481087	1995-01-14	1995-01-21	1
48031	2853	40481087	1994-01-20	1994-01-27	1
71689	4256	4266809	1992-06-12	1992-06-13	1
85065	5065	28060	1993-01-26	1993-02-04	1
45540	2709	28060	2008-03-14	2008-03-21	1
83102	4942	372328	1954-11-25	1955-01-06	1
7034	412	40481087	1975-10-06	1975-10-20	1
66928	3961	372328	1983-02-10	1985-03-05	2
73369	4366	40486433	1983-05-12	2000-05-09	1
43434	2590	260139	2000-12-06	2000-12-13	1
37838	2244	80180	1993-09-27	1993-09-28	1
15303	906	4155034	1986-12-12	1986-12-26	1
51062	3026	372328	1958-07-06	1958-11-30	1
84924	5056	40481087	2010-11-14	2010-11-28	1
48032	2853	81151	1982-07-03	1982-07-24	1
71690	4256	4283893	1997-04-22	1997-06-03	1
85066	5065	260139	2002-01-06	2002-01-13	1
45541	2709	81151	1942-12-20	1943-01-17	1
83103	4942	4027663	1979-04-23	1979-04-24	1
7035	412	40481087	1992-01-15	1992-01-22	1
66929	3961	4112343	1989-06-28	1989-07-08	1
73370	4366	260139	1996-11-12	1996-11-26	1
43435	2590	4218389	1981-01-03	1981-01-24	1
37839	2244	260139	1962-02-08	1962-02-22	1
15304	906	4218389	2001-10-08	2001-10-29	1
51063	3026	4109685	1980-05-11	1980-05-25	1
84925	5056	260139	2004-02-12	2004-02-19	1
48033	2853	260139	1995-03-24	1995-04-07	1
71691	4256	40481087	2011-12-26	2012-01-02	1
85067	5065	372328	1971-06-01	1971-07-20	1
45542	2709	192671	1984-04-03	1984-04-04	1
83104	4942	4109685	1972-11-04	1972-11-25	1
7036	412	78272	1961-04-17	1961-05-22	1
66930	3961	4149245	1974-10-29	1974-12-05	1
73371	4366	4112343	1991-11-23	1991-12-04	1
45214	2692	317576	1995-12-11	1995-12-12	1
37840	2244	260139	1976-01-16	1976-01-23	1
15305	906	40481087	2013-01-02	2013-01-16	1
51064	3026	4112343	1992-02-19	1992-02-27	1
84926	5056	4027663	1969-02-16	1969-02-17	1
48034	2853	4059173	1962-08-26	1962-09-25	1
75115	4467	80180	1987-07-09	1987-07-10	1
85068	5065	378001	1988-09-29	1988-11-28	1
45543	2709	260139	2013-10-12	2013-10-26	1
83105	4942	4112343	1979-04-15	1979-04-28	1
7037	412	80180	1993-09-22	1993-09-23	1
66931	3961	4155034	2018-12-10	2018-12-31	1
73372	4366	4155034	2000-09-27	2000-10-11	1
45215	2692	372328	1950-07-04	1950-10-23	1
37841	2244	440448	1964-07-23	1964-07-24	1
18528	1116	28060	1972-12-04	1972-12-16	1
51065	3026	4112343	1996-05-10	1996-05-19	1
84927	5056	4116491	1993-02-10	1993-03-15	1
48035	2853	4112343	1974-01-09	1974-01-20	1
75116	4467	81151	1973-02-19	1973-03-26	1
85069	5065	4112343	1970-12-04	1970-12-15	1
45544	2709	260139	2019-03-15	2019-03-22	1
83106	4942	4283893	1958-04-14	1958-07-21	1
7038	412	260139	1960-01-11	1960-01-18	1
66932	3961	372328	1975-02-26	1975-07-22	1
73373	4366	40481087	1983-09-24	1983-10-08	1
45216	2692	4109685	1996-02-17	1996-03-09	1
37842	2244	4112343	1987-01-21	1987-02-02	1
18529	1116	81151	1993-03-23	1993-04-06	1
51066	3026	4294548	1997-12-10	1998-02-04	1
84928	5056	4230399	1950-09-03	1950-10-03	1
48036	2853	4112343	1994-11-17	1994-11-28	1
75117	4467	81893	1986-01-15	1986-01-16	1
85070	5065	4329847	2005-03-15	2005-03-16	1
45545	2709	4112343	2003-04-11	2003-04-24	1
83107	4942	4310024	1984-12-17	1984-12-18	1
7039	412	260139	1964-06-27	1964-07-04	1
66933	3961	4112343	1998-02-23	1998-03-07	1
73374	4366	260139	1982-05-02	1982-05-16	1
45217	2692	4283893	1992-09-23	1992-10-28	1
37843	2244	4152936	1993-01-16	1993-02-06	1
18530	1116	4112343	2006-10-23	2006-11-05	1
51067	3026	40479768	2019-05-31	2019-06-01	1
84929	5056	40481087	1952-09-02	1952-09-23	1
48037	2853	4112343	2010-10-21	2010-11-03	1
75118	4467	260139	1991-05-03	1991-05-17	1
85071	5065	40481087	1969-04-21	1969-05-05	1
45546	2709	4155034	1970-09-22	1970-10-13	1
83108	4942	40481087	1992-11-24	1992-12-15	1
7040	412	260139	2004-02-18	2004-03-03	1
66934	3961	40481087	1984-09-15	1984-09-29	1
73375	4366	4218389	1999-01-01	1999-02-05	1
45218	2692	40481087	1972-05-18	1972-06-01	1
37844	2244	4294548	1968-02-10	1968-02-24	1
18531	1116	4146173	2015-12-07	2016-02-05	1
51068	3026	40481087	1965-06-08	1965-06-22	1
84930	5056	40481087	1974-09-01	1974-09-15	1
48038	2853	4155034	1980-05-23	1980-06-13	1
75119	4467	4094814	1979-10-21	1979-12-20	1
85072	5065	40481087	1969-10-09	1969-10-16	1
45547	2709	40481087	1952-04-08	1952-04-22	1
85224	5076	80180	1976-04-17	1976-04-18	1
7041	412	372328	1955-08-20	1955-10-21	1
66935	3961	40481087	2004-09-16	2004-10-07	1
73376	4366	40481087	1991-02-06	1991-02-13	1
45219	2692	80180	1986-01-21	1986-01-22	1
37845	2244	313217	2017-10-13	2017-10-14	1
18532	1116	40481087	2003-10-12	2003-10-26	1
51069	3026	40481087	1972-12-19	1973-01-02	1
84931	5056	40481087	1996-11-16	1996-11-23	1
48039	2853	40481087	1968-03-04	1968-03-18	1
75120	4467	4296204	1966-08-27	1966-09-24	1
85073	5065	40481087	1971-07-03	1971-07-24	1
45548	2709	40481087	1999-01-24	1999-02-07	1
85225	5076	260139	1942-02-16	1942-02-23	1
7042	412	4112343	1999-11-20	1999-12-03	1
67416	3989	80502	2018-01-29	2018-01-30	1
73377	4366	40481087	2007-12-21	2008-01-11	1
45220	2692	260139	1982-10-16	1982-10-30	1
37846	2244	4112343	2006-05-09	2006-05-20	1
18533	1116	260139	1997-09-25	1997-10-02	1
51070	3026	40481087	1987-02-14	1987-02-28	1
84932	5056	260139	1991-02-26	1991-03-05	1
48040	2853	40481087	1983-05-10	1983-05-31	1
75121	4467	260139	1980-07-26	1980-08-09	1
85074	5065	40481087	1983-07-30	1983-08-06	1
45549	2709	40481087	2013-03-20	2013-04-03	1
85226	5076	372328	1952-08-02	1952-09-16	1
7043	412	40481087	1983-08-17	1983-08-24	1
67417	3989	81893	1963-02-21	1963-02-22	1
73378	4366	81151	2003-09-26	2003-10-24	1
45221	2692	4329847	1998-06-29	1998-06-30	1
37847	2244	4134304	1966-08-15	1966-09-14	1
18534	1116	40481087	1980-09-12	1980-09-19	1
51814	3076	81151	2010-12-07	2011-01-04	1
84933	5056	381316	2003-05-22	2003-05-23	1
48041	2853	40481087	1993-02-12	1993-02-19	1
75122	4467	372328	1957-04-27	1957-06-13	1
85075	5065	80180	2002-02-23	2002-02-24	1
45550	2709	28060	1953-08-04	1953-08-13	1
85227	5076	4048171	1940-03-14	1940-03-15	1
7044	412	40481087	1984-04-26	1984-05-10	1
67418	3989	260139	1959-01-20	1959-02-03	1
73379	4366	372328	1983-01-25	1983-02-08	1
45222	2692	40481087	1967-06-15	1967-07-06	1
37848	2244	4112343	1979-08-05	1979-08-17	1
18535	1116	40481087	1995-12-08	1995-12-15	1
51815	3076	4109685	2012-11-24	2012-12-15	1
84934	5056	4112343	1967-05-25	1967-06-06	1
48042	2853	257012	1982-11-18	1982-11-19	1
75123	4467	4027663	1976-06-21	1976-06-22	1
85076	5065	317576	2004-03-02	2004-03-03	1
45551	2709	260139	2002-11-16	2002-11-30	1
85228	5076	4112343	1970-12-29	1971-01-10	1
7045	412	81151	1958-03-20	1958-04-03	1
67419	3989	260139	1971-01-14	1971-01-21	1
73380	4366	372328	1984-01-04	1984-07-03	1
45223	2692	40481087	1970-08-28	1970-09-18	1
37849	2244	4112343	1983-07-29	1983-08-08	1
18536	1116	40481087	1999-03-07	1999-03-28	1
51816	3076	4113008	2004-09-18	2004-10-09	1
84935	5056	4112343	1981-04-27	1981-05-10	1
48043	2853	260139	1964-08-16	1964-08-30	1
75124	4467	4112343	1952-05-25	1952-06-06	1
85077	5065	4112343	1973-07-05	1973-07-12	1
45552	2709	378419	2012-01-17	2012-01-18	1
85229	5076	4112343	1980-12-19	1981-01-01	1
7046	412	4027663	1982-05-08	1982-05-09	1
67420	3989	260139	1999-01-26	1999-02-09	1
73381	4366	4059173	1996-11-12	1997-01-11	1
45224	2692	40481087	1994-10-27	1994-11-17	1
37850	2244	40481087	1967-12-15	1968-01-05	1
18537	1116	40481087	2010-07-28	2010-08-18	1
51817	3076	4142905	2017-10-20	2017-11-19	1
84936	5056	4112343	2004-11-25	2004-12-03	1
48044	2853	260139	1973-04-13	1973-04-20	1
75125	4467	4112343	1989-10-08	1989-10-18	1
85078	5065	4112343	1984-11-26	1984-12-08	1
45553	2709	4237458	2017-10-06	2017-12-05	1
85230	5076	4112343	1999-11-27	1999-12-07	1
7047	412	4283893	1975-02-09	1975-03-02	1
67421	3989	372328	1928-10-27	1928-12-10	1
73382	4366	40481087	1983-02-02	1983-02-23	1
45225	2692	0	1998-06-29	1998-06-30	1
37851	2244	40481087	1995-01-26	1995-02-02	1
18538	1116	80180	2007-01-19	2007-01-20	1
51818	3076	4278672	1967-07-27	1967-08-26	1
84937	5056	40481087	1938-09-01	1938-09-08	1
48045	2853	260139	1988-06-02	1988-06-09	1
75126	4467	4116491	1987-06-19	1987-08-02	1
85079	5065	0	2005-03-15	2005-03-16	1
45554	2709	40481087	1958-03-27	1958-04-10	1
85231	5076	4112343	2003-10-19	2003-10-31	1
7048	412	4285898	1993-07-24	1993-07-25	1
67422	3989	4112343	1939-10-28	1939-11-04	1
73383	4366	40481087	1983-06-30	1983-07-21	1
45226	2692	4001336	1960-08-24	1960-10-23	1
37852	2244	372328	1954-07-19	1954-10-01	1
18539	1116	81151	1969-10-20	1969-11-24	1
51819	3076	0	1952-11-26	1952-11-27	1
84938	5056	40481087	1945-03-12	1945-03-26	1
48046	2853	4112343	1963-07-26	1963-08-04	1
75127	4467	40481087	1952-10-27	1952-11-03	1
85080	5065	260139	1984-06-23	1984-07-07	1
45555	2709	40481087	1975-04-04	1975-04-25	1
85232	5076	4156265	1947-11-21	1947-12-12	1
7049	412	40481087	1984-09-14	1984-09-28	1
67423	3989	40481087	1932-06-15	1932-06-29	1
73384	4366	40481087	2018-10-06	2018-10-13	1
45227	2692	4112343	1958-04-26	1958-05-04	1
37853	2244	4112343	1972-11-24	1972-12-05	1
18540	1116	372328	1967-02-03	1967-02-17	1
51820	3076	80180	1989-02-06	1989-02-07	1
84939	5056	40481087	1971-07-21	1971-07-28	1
48047	2853	4112343	2014-09-17	2014-09-25	1
75128	4467	40481087	2001-05-30	2001-06-20	1
85081	5065	260139	1989-02-04	1989-02-11	1
45556	2709	40481087	2017-02-17	2017-02-24	1
85233	5076	40481087	1974-09-21	1974-10-12	1
7050	412	40481087	1997-02-01	1997-02-08	1
67424	3989	40481087	1943-12-04	1943-12-25	1
75203	4472	80180	1975-03-19	1975-03-20	1
45228	2692	4113008	1959-07-17	1959-07-31	1
37854	2244	4112343	1995-11-21	1995-12-02	1
18541	1116	372328	1970-07-01	1970-11-20	1
51821	3076	81151	1993-05-23	1993-06-27	1
84940	5056	40481087	2000-08-09	2000-08-30	1
48048	2853	40481087	1974-09-21	1974-10-05	1
75129	4467	40481087	2007-03-15	2007-03-29	1
85082	5065	40481087	1970-10-17	1970-10-31	1
48281	2864	257012	1994-07-31	1994-08-01	1
85234	5076	260139	1951-09-04	1951-09-18	1
9911	588	80180	2019-06-08	2019-06-09	1
67425	3989	40481087	1967-04-10	1967-05-01	1
75204	4472	260139	1960-09-16	1960-09-30	1
45229	2692	40481087	1948-02-24	1948-03-02	1
37855	2244	4166224	1964-07-23	1964-07-24	1
18542	1116	4278672	1996-02-20	1996-04-20	1
51822	3076	372328	1952-05-16	1952-11-05	1
84941	5056	30753	1979-04-05	1979-04-06	1
48049	2853	40481087	2008-06-18	2008-07-02	1
75130	4467	4156265	2016-01-10	2016-01-31	1
86477	5151	28060	1958-11-23	1958-12-02	1
48282	2864	260139	1969-08-27	1969-09-10	1
85235	5076	260139	1988-03-13	1988-03-27	1
9912	588	4112343	2016-02-13	2016-02-26	1
67426	3989	40481087	2014-12-24	2015-01-14	1
75205	4472	260139	1987-02-03	1987-02-17	1
45230	2692	40481087	1956-02-15	1956-03-07	1
37856	2244	4237458	1975-03-22	1975-05-21	1
18543	1116	40481087	1966-05-17	1966-05-24	1
51823	3076	4146173	1983-02-15	1983-03-17	1
84942	5056	78272	1945-12-14	1945-12-28	1
48050	2853	28060	1964-08-29	1964-09-09	1
75131	4467	40481087	1973-02-13	1973-02-27	1
86478	5151	28060	1964-12-13	1964-12-21	1
48283	2864	4112343	2013-05-04	2013-05-11	1
85236	5076	4059173	2005-09-02	2005-11-01	1
9913	588	40481087	1985-02-12	1985-02-26	1
67427	3989	192671	1965-02-06	1965-02-07	1
75206	4472	317576	2010-04-24	2010-04-25	1
45231	2692	4112343	1974-07-13	1974-07-25	1
37857	2244	40481087	1991-07-02	1991-07-09	1
18544	1116	40481087	2004-08-29	2004-09-19	1
51824	3076	40481087	1959-12-15	1959-12-29	1
84943	5056	80180	1979-07-04	1979-07-05	1
48051	2853	4112343	1993-02-13	1993-02-22	1
75132	4467	40481087	1979-03-04	1979-03-25	1
86479	5151	28060	1995-03-11	1995-03-21	1
48284	2864	40481087	1956-06-17	1956-06-24	1
85237	5076	4296205	2004-10-02	2004-11-06	1
9914	588	260139	1981-11-26	1981-12-10	1
67428	3989	260139	1994-02-13	1994-02-20	1
75207	4472	378001	1941-04-11	1941-06-10	1
45232	2692	40481087	1952-01-18	1952-02-01	1
37858	2244	40481087	2003-12-22	2004-01-05	1
18545	1116	40481087	2016-07-25	2016-08-01	1
51825	3076	4113008	1997-03-08	1997-03-29	1
84944	5056	260139	1989-10-05	1989-10-19	1
48052	2853	40481087	1978-07-22	1978-08-12	1
75133	4467	40481087	1989-10-04	1989-10-25	1
86480	5151	80180	1997-12-12	1997-12-13	1
48285	2864	40481087	1977-04-29	1977-05-06	1
85238	5076	40481087	1989-12-18	1989-12-25	1
9915	588	260139	2016-03-02	2016-03-16	1
67429	3989	378419	2017-01-23	2017-01-24	1
75208	4472	4112343	1958-09-25	1958-10-05	1
47062	2802	28060	1953-09-01	1953-09-14	1
37859	2244	40481087	2014-03-18	2014-04-08	1
20265	1222	257012	1987-10-27	1987-10-28	1
51826	3076	40481087	1958-10-21	1958-11-11	1
84945	5056	260139	2000-09-14	2000-09-28	1
48053	2853	40481087	2009-03-06	2009-03-20	1
75134	4467	30753	1986-03-16	1986-03-17	1
86481	5151	134438	1988-11-01	1991-08-18	1
48286	2864	40481087	1987-10-15	1987-10-22	1
85239	5076	40481087	1997-11-18	1997-11-25	1
9916	588	439777	1984-01-28	1984-01-29	1
67430	3989	4285898	1964-09-13	1964-09-14	1
75209	4472	4278672	2005-11-13	2006-01-12	1
47063	2802	4112343	1955-06-07	1955-06-17	1
39146	2327	80180	1999-11-25	1999-11-26	1
20266	1222	260139	1969-06-04	1969-06-11	1
51827	3076	78272	1974-03-22	1974-04-12	1
84946	5056	372328	1939-02-19	1939-06-01	1
48932	2899	80180	1990-09-04	1990-09-05	1
75135	4467	81151	1959-02-07	1959-03-07	1
86482	5151	317576	2017-01-27	2017-01-28	1
48287	2864	40481087	2014-10-19	2014-10-26	1
85240	5076	30753	1974-09-25	1974-09-26	1
9917	588	4112343	1995-03-20	1995-04-01	1
67431	3989	40481087	1982-05-26	1982-06-02	1
75210	4472	40481087	1965-01-05	1965-01-12	1
47064	2802	4283893	1975-01-19	1975-05-25	1
39147	2327	260139	1970-11-08	1970-11-15	1
20267	1222	260139	1988-12-27	1989-01-03	1
51828	3076	260139	1983-06-05	1983-06-12	1
84947	5056	372328	1942-11-12	1942-12-03	1
48933	2899	80502	2009-10-22	2009-10-23	1
75136	4467	4109685	1956-05-02	1956-05-23	1
86483	5151	4112343	1980-04-05	1980-04-14	1
48288	2864	28060	1941-02-17	1941-02-28	1
85241	5076	260139	2003-01-09	2003-01-23	1
9918	588	4218389	2008-12-02	2008-12-23	1
67432	3989	28060	1996-11-05	1996-11-16	1
75211	4472	40481087	1974-04-10	1974-05-01	1
47065	2802	4296204	1973-06-18	1973-07-02	1
39148	2327	4112343	1974-04-18	1974-05-01	1
20268	1222	4112343	1988-10-06	1988-10-19	1
51829	3076	321042	1952-11-26	1952-11-27	1
84948	5056	378419	2012-08-23	2012-08-24	1
48934	2899	81151	1967-08-21	1967-09-25	1
75137	4467	4112343	1965-10-27	1965-11-09	1
86484	5151	4112343	2001-05-22	2001-06-01	1
48289	2864	28060	1947-02-15	1947-02-25	1
85242	5076	372328	1938-06-06	1938-08-16	1
9919	588	260139	2010-05-07	2010-05-14	1
67433	3989	30753	1963-11-18	1963-11-19	1
75212	4472	28060	1938-10-26	1938-11-07	1
47066	2802	40481087	1983-10-16	1983-10-30	1
39149	2327	4112343	1979-05-15	1979-05-26	1
20269	1222	4112343	2018-11-19	2018-12-01	1
51830	3076	4113008	1978-04-21	1978-05-12	1
84949	5056	4112343	1996-10-30	1996-11-06	1
48935	2899	260139	1960-08-29	1960-09-12	1
75138	4467	4112343	2010-12-29	2011-01-05	1
86485	5151	4112343	2014-02-25	2014-03-07	1
48290	2864	260139	1954-09-06	1954-09-13	1
85243	5076	440086	1946-03-06	1947-06-25	1
9920	588	40481087	1990-04-09	1990-04-30	1
67434	3989	195588	1954-09-26	1954-11-08	1
75213	4472	81151	1955-09-25	1955-10-16	1
47067	2802	0	1997-12-13	1997-12-14	1
39150	2327	4112343	1993-12-18	1993-12-30	1
20270	1222	4156265	1960-05-21	1960-06-11	1
51831	3076	40481087	1970-04-13	1970-04-20	1
84950	5056	4237458	1982-04-16	1982-07-15	1
48936	2899	260139	1967-07-17	1967-07-31	1
75139	4467	40481087	1955-01-28	1955-02-11	1
86486	5151	4296204	2005-10-31	2005-11-14	1
48291	2864	260139	1990-06-10	1990-06-17	1
85244	5076	4027663	1967-03-01	1967-03-02	1
9921	588	40481087	1998-12-22	1998-12-29	1
67435	3989	4112343	1935-02-09	1935-02-18	1
75214	4472	260139	1940-05-18	1940-05-25	1
47068	2802	28060	1940-10-02	1940-10-11	1
39151	2327	4113008	1995-04-19	1995-05-03	1
20271	1222	4283893	1987-10-06	1987-12-29	1
51832	3076	40481087	1996-09-09	1996-09-16	1
84951	5056	4294548	1984-12-27	1985-05-30	1
48937	2899	260139	2017-08-27	2017-09-10	1
75140	4467	40481087	1955-12-15	1956-01-05	1
86487	5151	40481087	1963-12-02	1963-12-09	1
48292	2864	260139	2015-04-07	2015-04-14	1
85245	5076	4152936	1983-04-05	1983-04-26	1
9922	588	40481087	2009-03-12	2009-03-26	1
67436	3989	4112343	1972-06-18	1972-06-29	1
75215	4472	260139	1967-03-12	1967-03-19	1
47069	2802	80180	1983-01-17	1983-01-18	1
39152	2327	4134304	1958-10-11	1959-01-09	1
20272	1222	40481087	1954-02-28	1954-03-07	1
54480	3230	260139	1987-11-05	1987-11-12	1
84952	5056	4310024	1977-12-11	1977-12-12	1
48938	2899	4112343	1973-01-15	1973-01-27	1
75141	4467	40481087	2004-02-10	2004-02-24	1
86488	5151	40481087	1966-02-02	1966-02-16	1
48293	2864	4059173	1949-08-02	1949-10-31	1
85246	5076	4296205	1975-11-15	1975-12-13	1
9923	588	372328	1981-02-27	1981-05-06	1
67437	3989	4112343	1981-12-11	1981-12-23	1
75216	4472	4112343	1978-06-18	1978-06-27	1
47070	2802	372328	1943-02-16	1943-03-27	1
39153	2327	4155034	1967-12-23	1968-01-13	1
20273	1222	40481087	1954-11-09	1954-11-16	1
54481	3230	260139	1993-03-05	1993-03-19	1
84953	5056	40481087	1972-03-01	1972-03-08	1
48939	2899	4112343	2012-05-30	2012-06-10	1
78670	4665	40481087	2015-03-14	2015-04-04	1
86489	5151	40481087	1967-03-18	1967-03-25	1
48294	2864	4112343	1942-12-22	1943-01-03	1
85247	5076	40481087	1984-12-23	1985-01-06	1
9924	588	375671	1990-07-10	1990-08-09	1
67438	3989	4294548	1993-04-12	1993-05-17	1
75217	4472	40481087	1978-11-11	1978-11-25	1
47071	2802	372328	1952-08-06	1952-10-18	1
39154	2327	40481087	1992-04-17	1992-05-01	1
20274	1222	40481087	1954-12-21	1954-12-28	1
54482	3230	4112343	1969-03-30	1969-04-07	1
84954	5056	40481087	2011-07-31	2011-08-14	1
48940	2899	40481087	1964-05-30	1964-06-20	1
78671	4665	40481087	2016-08-05	2016-08-19	1
86490	5151	260139	1983-10-14	1983-10-21	1
48295	2864	4112343	1994-09-27	1994-10-08	1
85248	5076	40481087	2012-03-18	2012-04-08	1
9925	588	40481087	1986-07-29	1986-08-19	1
67439	3989	4310024	1963-01-22	1963-01-23	1
75218	4472	40481087	2013-08-10	2013-08-31	1
47072	2802	4155034	1993-01-02	1993-01-16	1
39155	2327	28060	1960-06-06	1960-06-13	1
20275	1222	28060	2017-08-10	2017-08-22	1
54483	3230	4283893	2002-09-03	2002-11-05	1
86277	5142	4230399	2014-06-18	2014-08-17	1
48941	2899	40481087	1970-04-16	1970-04-23	1
78672	4665	260139	1988-09-09	1988-09-16	1
86491	5151	372328	1957-12-27	1958-01-10	1
48296	2864	4112343	2014-06-06	2014-06-19	1
85249	5076	78272	1946-09-22	1946-10-27	1
11351	672	80180	1989-04-13	1989-04-14	1
67440	3989	40481087	1941-03-22	1941-04-12	1
75219	4472	260139	2009-01-28	2009-02-04	1
47073	2802	260139	1961-03-24	1961-04-07	1
39156	2327	28060	2019-04-20	2019-04-30	1
20276	1222	80180	1995-10-30	1995-10-31	1
54484	3230	372328	1957-08-13	1958-01-29	1
86278	5142	4296205	1978-01-23	1978-02-27	1
48942	2899	260139	2013-10-24	2013-11-07	1
78673	4665	381316	2009-01-31	2009-02-01	1
86492	5151	4112343	1961-11-18	1961-11-28	1
48297	2864	4294548	1994-06-26	1995-01-08	1
85250	5076	260139	2009-04-02	2009-04-09	1
11352	672	260139	1967-03-26	1967-04-09	1
67441	3989	40481087	1961-03-21	1961-04-04	1
75220	4472	372328	1936-07-06	1936-09-19	1
47074	2802	260139	1971-05-16	1971-05-23	1
39157	2327	4109685	1996-04-27	1996-05-11	1
20277	1222	372328	1958-10-29	1959-08-12	1
54485	3230	4027663	1987-08-16	1987-08-17	1
86279	5142	40481087	2015-09-22	2015-10-06	1
48943	2899	372328	1950-03-23	1950-05-04	1
78674	4665	4112343	1986-12-03	1986-12-13	1
86493	5151	4113008	2000-11-05	2000-11-26	1
48298	2864	40481087	1958-01-23	1958-01-30	1
85251	5076	4112343	1966-10-09	1966-10-18	1
11353	672	4109685	1983-02-04	1983-02-25	1
67442	3989	40481087	1974-05-16	1974-05-30	1
75221	4472	372328	1938-02-11	1938-03-19	1
47075	2802	317576	1987-06-27	1987-06-28	1
39158	2327	4112343	1976-07-20	1976-07-28	1
20278	1222	4112343	2004-01-01	2004-01-08	1
54486	3230	4142905	1991-10-03	1991-12-02	1
86280	5142	0	2012-04-03	2012-04-04	1
48944	2899	372328	1953-01-18	1953-07-30	1
78675	4665	4112343	1988-09-07	1988-09-16	1
86494	5151	40481087	1961-03-20	1961-04-10	1
48299	2864	40481087	1983-08-21	1983-08-28	1
85252	5076	4266809	1976-04-17	1976-04-18	1
11354	672	4112343	1982-05-24	1982-05-31	1
67443	3989	40481087	1994-04-20	1994-05-04	1
75222	4472	4329847	2015-10-03	2015-10-04	1
47076	2802	4112343	1944-04-11	1944-04-20	1
39159	2327	4112343	1983-05-06	1983-05-13	1
20279	1222	260139	1990-01-29	1990-02-05	1
54487	3230	4152936	1961-08-22	1961-09-12	1
86281	5142	28060	1973-08-06	1973-08-17	1
48945	2899	4112343	1981-12-15	1981-12-23	1
78676	4665	4285898	2015-10-01	2015-10-02	1
86495	5151	40481087	1970-12-12	1971-01-02	1
48300	2864	40481087	1999-05-11	1999-05-18	1
85253	5076	4283893	1957-08-02	1957-09-13	1
11355	672	4112343	1996-09-28	1996-10-09	1
67444	3989	40481087	1995-06-06	1995-06-13	1
75223	4472	40481087	1969-03-16	1969-03-23	1
47077	2802	4112343	1957-10-05	1957-10-14	1
39160	2327	4109685	2001-05-15	2001-06-05	1
20280	1222	4112343	2007-07-22	2007-08-01	1
54488	3230	40481087	1962-02-25	1962-03-04	1
86282	5142	260139	1963-11-12	1963-11-26	1
48946	2899	4237458	1979-01-25	1979-02-24	1
78677	4665	40481087	1983-01-15	1983-01-22	1
86496	5151	78272	1957-11-27	1957-12-11	1
48301	2864	40481087	2012-05-17	2012-05-24	1
85254	5076	4285898	1975-08-21	1975-08-22	1
11356	672	4294548	2005-07-23	2005-08-20	1
67445	3989	40481087	1997-03-13	1997-03-20	1
75224	4472	40481087	2009-06-16	2009-06-23	1
47078	2802	4112343	1984-07-12	1984-07-19	1
39161	2327	4112343	1965-12-17	1965-12-30	1
20281	1222	4278672	1971-08-13	1971-11-11	1
54489	3230	40481087	1977-05-21	1977-06-11	1
86283	5142	260139	1972-07-25	1972-08-01	1
48947	2899	28060	1955-12-06	1955-12-15	1
78678	4665	40481087	2001-03-26	2001-04-02	1
86497	5151	81151	1969-09-09	1969-10-14	1
48302	2864	78272	1951-08-22	1951-09-19	1
85255	5076	40481087	1950-12-09	1950-12-30	1
11357	672	40481087	1985-05-16	1985-05-23	1
67446	3989	80180	1965-01-11	1965-01-12	1
75225	4472	0	2015-10-03	2015-10-04	1
47079	2802	4134304	1965-01-01	1965-04-01	1
39162	2327	4116491	2012-10-02	2012-11-11	1
20282	1222	40481087	1957-04-21	1957-05-12	1
54490	3230	257012	2002-10-08	2002-10-09	1
86284	5142	317576	1995-09-12	1995-09-13	1
48948	2899	260139	1972-12-09	1972-12-16	1
78679	4665	80180	2015-11-30	2015-12-01	1
86498	5151	372328	1959-01-05	1959-04-10	1
48303	2864	260139	1998-09-01	1998-09-08	1
87953	5236	260139	1986-03-22	1986-04-05	1
11358	672	40481087	1993-04-13	1993-05-04	1
67447	3989	81151	1975-03-25	1975-04-22	1
75226	4472	372328	1940-02-07	1940-03-23	1
47080	2802	4218389	1944-03-12	1944-04-09	1
39163	2327	4296204	1985-10-10	1985-11-07	1
20283	1222	40481087	1983-05-03	1983-05-24	1
54491	3230	260139	2018-04-02	2018-04-16	1
86285	5142	4112343	1947-06-10	1947-06-22	1
48949	2899	4112343	2004-02-28	2004-03-11	1
78680	4665	4112343	1982-08-11	1982-08-23	1
86499	5151	440086	1965-10-31	1974-11-08	1
48304	2864	260139	2005-01-03	2005-01-17	1
87954	5236	40481087	1992-06-15	1992-06-22	1
11359	672	260139	1956-10-25	1956-11-01	1
67448	3989	260139	1974-12-02	1974-12-16	1
75227	4472	4109685	2000-12-18	2001-01-08	1
47081	2802	4296205	1949-12-09	1949-12-30	1
39164	2327	40481087	1967-05-04	1967-05-18	1
20284	1222	40481087	2002-09-18	2002-09-25	1
54492	3230	4109685	2006-02-16	2006-03-02	1
86286	5142	4296204	1970-09-04	1970-09-18	1
48950	2899	4152936	2004-03-14	2004-04-04	1
78681	4665	4112343	2018-03-30	2018-04-06	1
86500	5151	4001336	1991-01-27	1991-02-26	1
48305	2864	4112343	1963-05-26	1963-06-08	1
87955	5236	4112343	1985-06-06	1985-06-15	1
11360	672	40481087	2016-05-29	2016-06-05	1
67449	3989	260139	1978-04-09	1978-04-23	1
75228	4472	4112343	1964-05-08	1964-05-19	1
47082	2802	4329847	1997-12-13	1997-12-14	1
39165	2327	40481087	1969-05-12	1969-05-26	1
20285	1222	40481087	2013-09-06	2013-09-20	1
54493	3230	4112343	1966-12-28	1967-01-07	1
86287	5142	78272	1976-04-19	1976-05-03	1
48951	2899	40481087	1969-11-27	1969-12-11	1
78682	4665	4296204	2003-08-20	2003-09-03	1
86501	5151	4132546	1991-01-27	1991-01-28	1
48306	2864	4112343	2015-06-15	2015-06-23	1
87956	5236	40481087	2015-09-12	2015-10-03	1
11361	672	260139	1975-11-17	1975-11-24	1
67450	3989	260139	1981-01-13	1981-01-20	1
75229	4472	4112343	1971-05-14	1971-05-24	1
47083	2802	40481087	1948-01-27	1948-02-03	1
39166	2327	40481087	1986-07-04	1986-07-11	1
20286	1222	260139	1975-06-12	1975-06-19	1
54494	3230	4112343	2009-02-07	2009-02-20	1
86288	5142	80180	1985-03-19	1985-03-20	1
48952	2899	40481087	2011-11-23	2011-12-14	1
78683	4665	4310024	2014-10-06	2014-10-07	1
86502	5151	40481087	2011-02-19	2011-03-05	1
48307	2864	40481087	1980-05-26	1980-06-02	1
87957	5236	40481087	2018-08-27	2018-09-10	1
11362	672	260139	2004-11-15	2004-11-22	1
67451	3989	4027663	1955-09-26	1955-09-27	1
75230	4472	4112343	2005-04-09	2005-04-21	1
47084	2802	40481087	1960-11-14	1960-11-21	1
39167	2327	40481087	1992-07-06	1992-07-13	1
20287	1222	4112343	1968-04-13	1968-04-22	1
54495	3230	40481087	2005-03-31	2005-04-14	1
86289	5142	81893	1983-03-30	1983-03-31	1
48953	2899	40481087	2019-04-11	2019-04-18	1
78684	4665	40481087	2006-01-15	2006-01-22	1
86503	5151	40481087	2015-01-20	2015-01-27	1
48308	2864	40481087	2017-12-15	2018-01-05	1
87958	5236	78272	2005-09-28	2005-10-19	1
11363	672	4112343	1972-12-01	1972-12-10	1
67452	3989	4059173	2003-11-21	2004-02-19	1
75231	4472	4283893	1956-08-28	1956-11-13	1
47085	2802	81151	1951-11-20	1951-12-11	1
39168	2327	40481087	1995-02-03	1995-02-10	1
20288	1222	4155034	2017-12-09	2017-12-30	1
54496	3230	80180	1997-08-03	1997-08-04	1
86290	5142	260139	1999-03-30	1999-04-13	1
48954	2899	4112343	1951-09-17	1951-09-27	1
78685	4665	78272	2005-09-22	2005-10-27	1
86504	5151	81151	1989-03-17	1989-04-07	1
48309	2864	28060	1955-02-25	1955-03-07	1
87959	5236	260139	2008-08-18	2008-09-01	1
11364	672	40481087	1980-10-09	1980-10-30	1
67453	3989	4112343	1928-08-29	1928-09-09	1
75232	4472	40481087	1966-07-14	1966-07-21	1
47086	2802	257012	1975-03-02	1975-03-03	1
41097	2445	81151	1928-08-28	1928-09-18	1
20289	1222	40481087	1986-02-15	1986-03-08	1
54497	3230	4278672	1967-02-11	1967-05-12	1
86291	5142	440086	1953-07-15	1953-11-25	1
48955	2899	40481087	1950-12-27	1951-01-03	1
78686	4665	81893	2015-05-04	2015-05-05	1
86505	5151	260139	2007-03-21	2007-04-04	1
48310	2864	80180	1976-04-02	1976-04-03	1
87960	5236	372328	1976-10-09	1977-02-23	1
11365	672	40481087	2002-05-25	2002-06-01	1
67454	3989	4112343	1948-01-25	1948-02-05	1
75233	4472	40481087	1970-12-22	1971-01-05	1
47087	2802	260139	1947-01-28	1947-02-04	1
41098	2445	260139	1981-09-08	1981-09-15	1
23067	1379	78272	1986-07-31	1986-09-04	1
54498	3230	4296204	1962-09-07	1962-10-05	1
86292	5142	4027663	1973-07-10	1973-07-11	1
50768	3007	78272	1969-04-09	1969-05-14	1
78687	4665	4027663	2009-08-08	2009-08-09	1
86506	5151	260139	2015-11-26	2015-12-03	1
48311	2864	195588	1961-04-21	1961-06-14	1
87961	5236	4112343	1982-07-11	1982-07-20	1
11366	672	40481087	2017-07-07	2017-07-21	1
67455	3989	4112343	1951-04-21	1951-04-29	1
75234	4472	40481087	1971-11-09	1971-11-16	1
47088	2802	440086	1948-09-07	1956-09-15	1
41099	2445	4112343	1953-02-11	1953-02-21	1
23068	1379	321042	1987-09-05	1987-09-06	1
54499	3230	40481087	2000-07-16	2000-08-06	1
86293	5142	4059173	2013-07-23	2013-08-22	1
50769	3007	78272	2006-09-18	2006-10-02	1
78688	4665	4112343	2010-10-23	2010-11-05	1
86507	5151	378001	1964-09-05	1964-11-04	1
48312	2864	260139	2012-03-19	2012-04-02	1
87962	5236	4155034	1982-10-08	1982-10-29	1
11367	672	260139	1965-04-19	1965-05-03	1
67456	3989	4112343	1951-10-27	1951-11-05	1
75235	4472	40481087	1986-02-24	1986-03-10	1
47089	2802	4109685	1981-11-17	1981-12-01	1
41100	2445	40479422	1979-09-17	1979-11-23	1
23069	1379	378001	1977-03-20	1977-04-19	1
55750	3304	28060	1985-10-13	1985-10-21	1
86294	5142	4112343	2014-11-14	2014-11-22	1
50770	3007	80180	2007-08-28	2007-08-29	1
80425	4771	28060	1962-07-15	1962-07-28	1
86508	5151	4112343	1992-01-15	1992-01-22	1
48313	2864	260139	2013-05-05	2013-05-19	1
87963	5236	4230399	1986-07-10	1986-10-08	1
11368	672	260139	1972-11-15	1972-11-29	1
67457	3989	4112343	2003-01-18	2003-01-26	1
75780	4500	260139	1989-10-17	1989-10-24	1
47090	2802	4112343	1941-03-13	1941-03-25	1
41101	2445	40481087	1951-02-24	1951-03-10	1
23070	1379	4112343	1985-02-11	1985-02-22	1
55751	3304	260139	1997-06-06	1997-06-13	1
86295	5142	4112343	2018-06-05	2018-06-15	1
50771	3007	4112343	1968-07-02	1968-07-13	1
80426	4771	4296205	1984-08-05	1984-09-02	1
86509	5151	4156265	1987-04-13	1987-04-27	1
48314	2864	372328	1945-02-24	1945-04-12	1
87964	5236	40481087	1993-02-26	1993-03-05	1
11369	672	4112343	1995-04-27	1995-05-05	1
67458	3989	4112343	2006-11-08	2006-11-17	1
75781	4500	372328	1961-11-12	1961-12-20	1
47091	2802	4112343	1963-09-15	1963-09-28	1
41102	2445	40481087	1962-06-18	1962-07-09	1
23071	1379	4112343	2002-07-05	2002-07-14	1
55752	3304	4152936	1986-05-29	1986-06-19	1
86296	5142	4237458	1965-07-02	1965-09-30	1
50772	3007	4112343	1977-02-09	1977-02-22	1
80427	4771	28060	1956-12-05	1956-12-12	1
86510	5151	40481087	1973-12-24	1973-12-31	1
48315	2864	4112343	1947-03-29	1947-04-06	1
87965	5236	80180	2009-05-19	2009-05-20	1
11370	672	4149245	2000-02-17	2000-04-24	1
67459	3989	40481087	1957-04-20	1957-05-04	1
75782	4500	4084167	1962-08-09	1962-08-09	1
47092	2802	40481087	1949-02-04	1949-02-25	1
41103	2445	78272	1965-12-24	1966-01-14	1
23072	1379	40481087	1991-10-12	1991-10-19	1
55753	3304	40481087	1992-03-24	1992-03-31	1
86297	5142	40481087	1964-08-25	1964-09-08	1
50773	3007	4112343	1978-03-22	1978-04-03	1
80428	4771	80180	1994-09-29	1994-09-30	1
86511	5151	40481087	1986-02-01	1986-02-08	1
48316	2864	40481087	1947-09-21	1947-09-28	1
87966	5236	260139	2004-11-28	2004-12-05	1
11371	672	4156265	1985-03-16	1985-04-06	1
67460	3989	40481087	1969-10-24	1969-10-31	1
75783	4500	4112343	2004-06-17	2004-06-26	1
47093	2802	40481087	1949-10-01	1949-10-08	1
41104	2445	81151	1969-01-28	1969-02-11	1
23073	1379	40481087	2002-09-30	2002-10-14	1
55754	3304	40481087	1997-09-09	1997-09-23	1
86298	5142	40481087	1966-10-06	1966-10-13	1
50774	3007	4112343	2000-04-19	2000-04-30	1
80429	4771	4116491	1981-02-14	1981-04-08	1
86512	5151	40481087	2000-05-01	2000-05-15	1
48317	2864	40481087	1995-09-14	1995-09-21	1
87967	5236	260139	2017-10-12	2017-10-19	1
11372	672	40481087	1966-01-10	1966-01-17	1
68641	4067	0	1971-03-27	1971-03-28	1
75784	4500	4112343	2008-07-16	2008-07-29	1
47094	2802	40481087	1961-11-24	1961-12-01	1
41105	2445	260139	1955-11-07	1955-11-21	1
23074	1379	0	1987-09-05	1987-09-06	1
55755	3304	40481087	2012-03-19	2012-04-02	1
86299	5142	40481087	1981-11-28	1981-12-19	1
50775	3007	4155034	1989-11-25	1989-12-16	1
80430	4771	40481087	1976-05-06	1976-05-20	1
86513	5151	40481087	2002-09-08	2002-09-29	1
48648	2886	260139	1963-10-03	1963-10-10	1
87968	5236	440086	1984-03-06	1985-01-15	1
11373	672	40481087	1989-07-06	1989-07-27	1
68642	4067	378001	1991-11-28	1991-12-28	1
75785	4500	40481087	1997-06-27	1997-07-04	1
47095	2802	40481087	1964-11-23	1964-12-07	1
41106	2445	372328	1928-10-27	1928-12-10	1
23075	1379	260139	1973-02-06	1973-02-13	1
55756	3304	80180	2001-05-19	2001-05-20	1
86300	5142	40481087	1994-07-22	1994-08-05	1
50776	3007	4230399	1979-07-21	1979-09-19	1
80431	4771	40481087	1977-05-23	1977-06-06	1
88248	5253	195588	1994-11-30	1995-01-26	1
48649	2886	372328	1952-08-02	1952-11-17	1
87969	5236	4218389	2015-01-30	2015-03-06	1
12251	726	40481087	1982-05-25	1982-06-01	1
68643	4067	380378	1971-03-27	1971-03-28	1
75786	4500	78272	2011-06-19	2011-07-24	1
47963	2849	28060	1927-04-08	1927-04-17	1
41107	2445	4043241	1990-11-05	1990-11-06	1
23076	1379	261325	1997-04-12	1997-04-13	1
55757	3304	192671	2001-06-08	2001-06-09	1
86301	5142	40481087	2017-12-31	2018-01-07	1
50777	3007	40481087	1998-01-21	1998-01-28	1
80432	4771	40481087	1992-05-23	1992-06-06	1
88249	5253	372328	1961-01-12	1961-11-25	1
48650	2886	4112343	1983-01-06	1983-01-19	1
87970	5236	40481087	1986-06-25	1986-07-16	1
12252	726	260139	1988-06-24	1988-07-01	1
68644	4067	4112343	1981-06-20	1981-07-02	1
75787	4500	4029498	1961-09-13	1961-09-14	1
47964	2849	81151	1984-10-26	1984-11-09	1
41108	2445	4112343	1935-08-19	1935-08-27	1
23077	1379	4112343	1961-06-11	1961-06-24	1
55758	3304	40481087	2009-07-01	2009-07-08	1
86302	5142	192671	1985-05-16	1985-05-17	1
50778	3007	40481087	2004-01-05	2004-01-19	1
80433	4771	40481087	2003-08-13	2003-09-03	1
88250	5253	4059173	1979-05-08	1979-08-06	1
48651	2886	4112343	2004-06-24	2004-07-05	1
87971	5236	40481087	1987-04-21	1987-05-05	1
12253	726	372328	1954-04-27	1954-08-08	1
68645	4067	4112343	2013-07-26	2013-08-06	1
75788	4500	4109685	2003-12-16	2004-01-06	1
47965	2849	4112343	1951-01-28	1951-02-04	1
41109	2445	40481087	1964-09-01	1964-09-15	1
23078	1379	4112343	1964-09-09	1964-09-18	1
55759	3304	40481087	2010-01-13	2010-01-20	1
86303	5142	260139	1988-07-10	1988-07-17	1
50779	3007	40481087	2006-12-12	2007-01-02	1
80434	4771	81151	1971-06-17	1971-07-15	1
88251	5253	4112343	1976-02-28	1976-03-07	1
48652	2886	4283893	1981-09-13	1981-10-04	1
88546	5272	28060	1921-01-12	1921-01-20	1
12254	726	260139	1984-08-18	1984-08-25	1
68646	4067	4112343	2015-08-27	2015-09-06	1
75789	4500	4109685	2007-07-19	2007-08-09	1
47966	2849	4134304	1964-05-14	1964-06-13	1
41110	2445	28060	1933-02-22	1933-03-01	1
23079	1379	4113008	1968-08-29	1968-09-19	1
55760	3304	28060	1998-11-27	1998-12-08	1
86304	5142	4310024	1982-06-03	1982-06-04	1
50780	3007	0	1998-05-18	1998-05-19	1
80435	4771	372328	1958-08-24	1958-12-27	1
88252	5253	4237458	1971-04-20	1971-05-20	1
48653	2886	40481087	1979-09-11	1979-09-18	1
88547	5272	28060	1957-05-24	1957-05-31	1
12255	726	260139	2013-05-23	2013-06-06	1
68647	4067	4142905	1983-01-14	1983-04-14	1
75790	4500	4112343	1968-09-08	1968-09-21	1
47967	2849	40481087	2000-05-27	2000-06-17	1
41111	2445	80180	1964-03-12	1964-03-13	1
23080	1379	40481087	1982-01-05	1982-01-26	1
55761	3304	260139	1984-10-17	1984-10-31	1
86305	5142	4329847	2012-04-03	2012-04-04	1
50781	3007	4112343	1970-05-07	1970-05-15	1
80436	4771	4112343	1963-04-26	1963-05-07	1
88253	5253	40481087	1972-12-06	1972-12-20	1
48654	2886	40481087	1999-02-27	1999-03-06	1
88548	5272	260139	1949-04-29	1949-05-13	1
12256	726	4109685	2004-09-01	2004-09-22	1
68648	4067	28060	1972-05-24	1972-06-03	1
75791	4500	4112343	2006-08-28	2006-09-08	1
47968	2849	81151	1937-08-13	1937-09-03	1
41112	2445	378001	1967-01-09	1967-03-10	1
23081	1379	260139	2000-07-23	2000-08-06	1
55762	3304	260139	1990-08-03	1990-08-10	1
86306	5142	40481087	1953-11-07	1953-11-14	1
50782	3007	4112343	1987-05-18	1987-05-27	1
80437	4771	40481087	1966-08-13	1966-08-20	1
88254	5253	40481087	2001-03-20	2001-04-10	1
48655	2886	40481087	2002-02-23	2002-03-09	1
88549	5272	4294548	1965-11-10	1965-12-01	1
12257	726	40481087	1981-05-11	1981-05-25	1
68649	4067	4029498	1971-03-27	1971-03-28	1
75792	4500	4112343	2008-06-02	2008-06-15	1
47969	2849	260139	1928-09-27	1928-10-04	1
41113	2445	4112343	1940-06-02	1940-06-15	1
23082	1379	4109685	1969-08-15	1969-08-29	1
55763	3304	260139	2012-05-14	2012-05-28	1
50783	3007	40481087	1984-10-13	1984-10-27	1
80438	4771	4112343	1981-10-03	1981-10-13	1
88255	5253	40481087	2016-05-07	2016-05-14	1
48656	2886	80180	1983-04-22	1983-04-23	1
88550	5272	40481087	1950-10-09	1950-10-30	1
12258	726	40481087	1986-12-12	1986-12-19	1
68650	4067	4112343	2005-08-09	2005-08-21	1
75793	4500	40481087	2001-06-18	2001-07-09	1
47970	2849	372328	1921-09-22	1922-01-30	1
41114	2445	4112343	1988-04-19	1988-04-26	1
23083	1379	4112343	1994-11-03	1994-11-12	1
55764	3304	4156265	1964-11-29	1964-12-20	1
50784	3007	40481087	2010-08-21	2010-09-04	1
80439	4771	4112343	2015-12-16	2015-12-23	1
88256	5253	81151	2011-01-18	2011-02-01	1
48657	2886	257012	1974-09-18	1974-09-19	1
88551	5272	28060	1966-12-25	1967-01-01	1
12259	726	40481087	2018-07-13	2018-07-20	1
68651	4067	4112343	2016-08-03	2016-08-16	1
75794	4500	40481087	2014-12-24	2014-12-31	1
47971	2849	4134304	1987-09-25	1987-12-24	1
41115	2445	40481087	1972-09-12	1972-09-26	1
23084	1379	4237458	1970-07-25	1970-08-24	1
55765	3304	4237458	1975-06-26	1975-07-26	1
50785	3007	28060	2016-12-03	2016-12-15	1
80440	4771	4294548	1957-07-08	1957-07-22	1
88257	5253	260139	1991-03-13	1991-03-20	1
48658	2886	260139	1956-12-10	1956-12-24	1
88552	5272	260139	1969-04-10	1969-04-17	1
12260	726	80180	1991-06-12	1991-06-13	1
68652	4067	4152936	1977-06-23	1977-07-14	1
75795	4500	0	1961-09-13	1961-09-14	1
47972	2849	4294548	1987-02-05	1987-09-24	1
41116	2445	40481087	1973-11-29	1973-12-20	1
23085	1379	80180	1998-11-20	1998-11-21	1
55766	3304	40481087	1973-12-18	1974-01-08	1
50786	3007	260139	1983-01-28	1983-02-04	1
80441	4771	40481087	2006-06-28	2006-07-12	1
88258	5253	260139	1991-10-18	1991-10-25	1
48659	2886	4059173	1963-06-06	1963-08-05	1
88553	5272	260139	2009-01-04	2009-01-11	1
12261	726	4112343	1978-06-24	1978-07-04	1
68653	4067	40481087	2001-04-15	2001-04-29	1
75796	4500	80180	1997-05-22	1997-05-23	1
47973	2849	40481087	1951-02-25	1951-03-18	1
41117	2445	4112343	1931-11-14	1931-11-26	1
23086	1379	260139	2001-02-03	2001-02-17	1
55767	3304	40481087	1981-12-04	1981-12-25	1
50787	3007	4294548	1981-01-13	1981-04-28	1
83660	4976	140673	1983-10-26	1983-10-27	1
88259	5253	4027663	1987-12-02	1987-12-03	1
48660	2886	4112343	1991-12-06	1991-12-15	1
88554	5272	260139	2015-07-29	2015-08-05	1
12262	726	4134304	1969-02-07	1969-05-08	1
68654	4067	40481087	2002-08-29	2002-09-12	1
75797	4500	4112343	2014-03-03	2014-03-12	1
47974	2849	40481087	1966-06-17	1966-07-08	1
41118	2445	4155034	1955-10-27	1955-11-17	1
23087	1379	372328	1979-04-04	1982-03-27	1
55768	3304	28060	1989-03-05	1989-03-16	1
50788	3007	40481087	1970-04-13	1970-04-20	1
83661	4976	260139	1913-03-14	1913-03-21	1
88260	5253	4112343	1974-07-24	1974-08-06	1
48661	2886	4112343	2003-05-20	2003-05-30	1
88555	5272	260139	2016-11-13	2016-11-20	1
14960	883	4112343	1993-01-03	1993-01-14	1
68655	4067	40481087	2010-02-10	2010-02-17	1
75798	4500	4155034	1984-03-16	1984-03-30	1
47975	2849	40481087	2011-07-29	2011-08-19	1
41119	2445	40481087	1947-04-26	1947-05-10	1
23088	1379	4109685	1987-08-30	1987-09-13	1
55769	3304	372328	1963-09-06	1963-12-18	1
50789	3007	40481087	1970-06-26	1970-07-03	1
83662	4976	4084167	1931-07-06	1931-07-06	1
88261	5253	4112343	1990-11-03	1990-11-14	1
48662	2886	4112343	2011-03-04	2011-03-12	1
88556	5272	4112343	1926-12-05	1926-12-15	1
14961	883	4112343	2005-04-26	2005-05-07	1
68656	4067	40481087	2010-09-20	2010-09-27	1
75799	4500	4278672	2010-04-25	2010-07-24	1
47976	2849	80180	1959-04-16	1959-04-17	1
41120	2445	40481087	1983-06-09	1983-06-23	1
23089	1379	4112343	1972-01-11	1972-01-18	1
55770	3304	4059173	1977-07-15	1977-10-13	1
50790	3007	40481087	1992-10-22	1992-11-12	1
83663	4976	40481087	1952-10-10	1952-10-31	1
88262	5253	40481087	1984-08-17	1984-09-07	1
48663	2886	4296205	2001-11-27	2002-01-01	1
88557	5272	4112343	1950-12-18	1950-12-26	1
14962	883	4116491	2006-06-04	2006-07-24	1
68657	4067	28060	1987-01-04	1987-01-15	1
75800	4500	40481087	1979-11-08	1979-11-22	1
47977	2849	257012	1987-03-12	1987-03-13	1
42857	2555	260139	2013-08-10	2013-08-24	1
23090	1379	4134304	1962-10-30	1962-11-29	1
55771	3304	40481087	1988-04-29	1988-05-06	1
50791	3007	40481087	2011-04-08	2011-04-15	1
83664	4976	40481087	1971-10-02	1971-10-23	1
88263	5253	40481087	1993-09-09	1993-09-23	1
48664	2886	260139	1983-11-26	1983-12-10	1
88558	5272	4112343	2014-01-27	2014-02-03	1
14963	883	40481087	1987-12-24	1987-12-31	1
68658	4067	80180	2007-07-01	2007-07-02	1
75801	4500	40481087	2003-11-05	2003-11-12	1
47978	2849	260139	1933-01-13	1933-01-20	1
42858	2555	372328	1950-06-07	1950-08-17	1
23091	1379	4152936	1998-02-17	1998-03-10	1
58753	3489	372328	1977-12-22	1978-10-14	1
50792	3007	40481087	2016-01-26	2016-02-02	1
83665	4976	40481087	1994-04-24	1994-05-15	1
88264	5253	40481087	2009-03-08	2009-03-15	1
48665	2886	372328	1953-02-15	1953-05-18	1
88559	5272	40481087	1932-11-29	1932-12-06	1
14964	883	80180	2003-02-25	2003-02-26	1
68659	4067	260139	2012-08-19	2012-09-02	1
75802	4500	40481087	2005-12-09	2005-12-16	1
47979	2849	260139	1972-12-13	1972-12-20	1
42859	2555	372328	1955-09-04	1956-02-22	1
23092	1379	40481087	1967-04-12	1967-04-19	1
58754	3489	40481087	1991-12-13	1991-12-27	1
50793	3007	28060	1967-11-20	1967-12-01	1
83666	4976	28060	1913-01-15	1913-01-25	1
88265	5253	80180	1996-01-14	1996-01-15	1
48666	2886	440086	1959-12-09	1960-10-26	1
88560	5272	40481087	1982-04-04	1982-04-11	1
14965	883	195588	2007-07-24	2007-09-06	1
68660	4067	4112343	2008-06-09	2008-06-19	1
75803	4500	40481087	2012-03-20	2012-04-03	1
47980	2849	4059173	2017-10-17	2018-01-15	1
42860	2555	4112343	1958-02-26	1958-03-06	1
23093	1379	40481087	2007-02-26	2007-03-05	1
58755	3489	80180	2012-08-09	2012-08-10	1
50794	3007	257012	1981-03-31	1981-04-01	1
83667	4976	28060	1970-08-16	1970-08-28	1
88266	5253	257012	1968-03-22	1968-03-23	1
48667	2886	4112343	1959-12-28	1960-01-06	1
88561	5272	40481087	1989-03-10	1989-03-17	1
14966	883	260139	1987-01-24	1987-01-31	1
68661	4067	378001	1980-05-29	1980-07-28	1
75804	4500	40481087	2017-10-23	2017-11-06	1
47981	2849	4112343	1925-02-05	1925-02-14	1
42861	2555	4112343	1976-05-02	1976-05-09	1
25706	1529	28060	1994-02-21	1994-02-28	1
58756	3489	372328	1975-05-16	1975-10-04	1
50795	3007	260139	1999-06-20	1999-06-27	1
83668	4976	195588	1941-11-05	1941-12-26	1
88267	5253	258780	1983-04-23	1983-04-24	1
48668	2886	4112343	2017-11-06	2017-11-13	1
88562	5272	80502	1977-02-09	1977-02-10	1
14967	883	372328	1965-11-21	1966-05-26	1
68662	4067	40481087	1984-10-22	1984-11-05	1
75805	4500	28060	2006-07-18	2006-07-27	1
47982	2849	4112343	1939-04-16	1939-04-28	1
42862	2555	4112343	1978-06-02	1978-06-09	1
25707	1529	260139	1979-02-05	1979-02-19	1
58757	3489	4283893	1973-01-31	1973-03-28	1
50796	3007	372328	1967-01-20	1967-05-03	1
83669	4976	255848	1996-03-24	1996-03-25	1
88268	5253	260139	1980-04-13	1980-04-20	1
48669	2886	40481087	1999-04-14	1999-05-05	1
88563	5272	257012	1971-08-20	1971-08-21	1
14968	883	4059173	1970-01-29	1970-02-28	1
69708	4129	28060	1950-11-14	1950-11-23	1
75806	4500	372328	1974-12-12	1975-10-15	1
47983	2849	4112343	1993-04-08	1993-04-21	1
42863	2555	4112343	1985-10-30	1985-11-08	1
25708	1529	260139	1996-12-19	1997-01-02	1
58758	3489	40481087	1998-05-30	1998-06-20	1
50797	3007	440448	1998-05-18	1998-05-19	1
83670	4976	260139	1920-11-10	1920-11-17	1
88269	5253	4112343	1993-01-03	1993-01-14	1
48670	2886	40481087	2011-07-26	2011-08-09	1
88564	5272	260139	1972-01-04	1972-01-18	1
14969	883	4112343	2003-08-24	2003-08-31	1
69709	4129	4112343	1977-04-19	1977-04-26	1
75807	4500	375671	1995-10-29	1995-11-28	1
47984	2849	4237458	2004-04-28	2004-06-27	1
42864	2555	4112343	2016-08-11	2016-08-18	1
25709	1529	372328	1963-02-27	1963-06-10	1
58759	3489	40481087	2005-04-23	2005-05-07	1
50798	3007	40481087	1983-05-26	1983-06-16	1
83671	4976	260139	1982-09-21	1982-10-05	1
88270	5253	4294548	1968-02-16	1968-04-26	1
48671	2886	260139	1985-08-03	1985-08-10	1
88565	5272	260139	2001-03-22	2001-04-05	1
14970	883	4113008	2008-03-24	2008-04-07	1
69710	4129	4112343	1978-04-24	1978-05-07	1
75808	4500	4048171	1963-09-20	1963-09-21	1
47985	2849	40481087	1976-01-23	1976-02-13	1
42865	2555	4156265	1995-04-08	1995-04-22	1
25710	1529	372328	1968-02-07	1968-06-17	1
58760	3489	257012	1973-02-21	1973-02-22	1
50917	3017	80180	1991-04-30	1991-05-01	1
83672	4976	4113008	1995-01-25	1995-02-15	1
88271	5253	40481087	1964-02-17	1964-03-02	1
48672	2886	4051466	1954-12-17	1970-03-30	1
88566	5272	378001	1919-06-04	1919-07-04	1
14971	883	40481087	1982-01-02	1982-01-16	1
69711	4129	4283893	1969-01-18	1969-03-01	1
75809	4500	40481087	1977-10-26	1977-11-09	1
47986	2849	81151	1933-11-18	1933-12-02	1
42866	2555	40481087	1972-07-23	1972-07-30	1
25711	1529	372328	1978-10-23	1979-08-20	1
58761	3489	260139	1985-01-25	1985-02-08	1
50918	3017	4112343	1960-10-02	1960-10-12	1
83673	4976	4278672	1917-08-16	1917-11-14	1
88272	5253	40481087	1988-07-24	1988-07-31	1
48673	2886	4109685	1965-05-26	1965-06-09	1
88567	5272	4112343	1929-06-03	1929-06-10	1
14972	883	40481087	2006-07-16	2006-07-23	1
69712	4129	40481087	1948-09-01	1948-09-15	1
77196	4578	80180	2000-04-05	2000-04-06	1
47987	2849	260139	1921-07-26	1921-08-09	1
42867	2555	40481087	1998-12-21	1999-01-04	1
25712	1529	4059173	1967-07-06	1967-09-04	1
58762	3489	4155034	2012-10-28	2012-11-11	1
50919	3017	4112343	1969-07-31	1969-08-09	1
83674	4976	4296205	1952-10-09	1952-11-06	1
88273	5253	78272	1997-07-02	1997-07-30	1
48674	2886	4283893	1974-07-17	1974-10-02	1
88568	5272	4112343	1959-06-24	1959-07-02	1
14973	883	28060	1969-04-07	1969-04-15	1
69713	4129	40481087	1995-08-15	1995-08-29	1
77197	4578	260139	1970-11-21	1970-11-28	1
47988	2849	4059173	2003-05-04	2003-07-03	1
42868	2555	372328	1953-11-10	1954-02-10	1
25713	1529	40481087	1978-05-17	1978-05-31	1
58763	3489	40481087	2013-10-31	2013-11-14	1
50920	3017	4112343	2005-05-05	2005-05-15	1
83675	4976	40481087	1916-10-22	1916-11-12	1
88274	5253	260139	1974-09-03	1974-09-10	1
48675	2886	40481087	1986-01-20	1986-01-27	1
88569	5272	40481087	1962-07-06	1962-07-20	1
14974	883	81151	1975-09-30	1975-10-14	1
69714	4129	40481087	2013-06-07	2013-06-14	1
77198	4578	4109685	1981-10-20	1981-11-10	1
47989	2849	4112343	1968-05-08	1968-05-17	1
42869	2555	4283893	1986-11-02	1987-01-25	1
25714	1529	28060	1968-05-03	1968-05-12	1
58764	3489	260139	2009-09-07	2009-09-21	1
50921	3017	4283893	1973-12-08	1974-02-16	1
83676	4976	40481087	1920-04-01	1920-04-15	1
88275	5253	4112343	1956-03-13	1956-03-26	1
50411	2986	80180	1980-05-24	1980-05-25	1
88570	5272	40481087	1978-07-04	1978-07-18	1
14975	883	260139	2008-06-28	2008-07-05	1
69715	4129	4112343	1989-11-07	1989-11-15	1
77199	4578	4112343	1985-10-22	1985-11-01	1
47990	2849	4112343	2003-03-02	2003-03-09	1
42870	2555	40481087	1971-10-13	1971-10-20	1
25715	1529	260139	2001-06-10	2001-06-24	1
58765	3489	4116491	1990-10-24	1990-12-02	1
50922	3017	4283893	1974-06-22	1974-07-20	1
83677	4976	40481087	1962-04-19	1962-05-03	1
88276	5253	4112343	1981-04-11	1981-04-21	1
50412	2986	40481087	1966-01-10	1966-01-17	1
88571	5272	80180	1952-05-31	1952-06-01	1
14976	883	40481087	1999-11-07	1999-11-14	1
69716	4129	4112343	2018-11-16	2018-11-26	1
77200	4578	4310024	1998-08-14	1998-08-15	1
47991	2849	4146173	2011-03-23	2011-05-22	1
42871	2555	40481087	1985-02-18	1985-03-04	1
25716	1529	40481087	2009-07-03	2009-07-24	1
58766	3489	40481087	1987-12-15	1987-12-29	1
50923	3017	40481087	1985-11-16	1985-11-23	1
83678	4976	80180	1953-12-22	1953-12-23	1
88277	5253	4266809	1996-01-14	1996-01-15	1
50413	2986	257012	2018-02-20	2018-04-24	1
88572	5272	260139	2013-02-17	2013-03-03	1
14977	883	28060	1969-09-14	1969-09-23	1
69717	4129	4113008	1992-04-05	1992-04-26	1
77201	4578	40481087	1999-12-16	1999-12-30	1
47992	2849	40481087	1954-01-06	1954-01-13	1
42872	2555	40481087	1988-08-23	1988-09-06	1
25717	1529	40481087	2018-03-15	2018-04-05	1
58767	3489	40481087	2004-03-29	2004-04-05	1
50924	3017	40481087	1999-09-16	1999-09-30	1
83679	4976	81151	1936-09-05	1936-09-19	1
88278	5253	4285898	1995-02-18	1995-02-19	1
50414	2986	260139	1958-08-29	1958-09-12	1
88573	5272	4112343	1918-05-14	1918-05-26	1
14978	883	260139	1968-05-11	1968-05-18	1
69718	4129	40481087	1961-07-18	1961-08-01	1
77202	4578	40481087	2015-11-11	2015-12-02	1
47993	2849	40481087	1978-04-11	1978-05-02	1
42873	2555	40481087	2015-01-13	2015-02-03	1
25718	1529	4134304	1974-10-02	1974-12-31	1
58768	3489	40481087	2005-02-07	2005-02-14	1
50925	3017	40481087	2007-02-28	2007-03-07	1
83680	4976	260139	1956-11-20	1956-12-04	1
88279	5253	4310024	1993-03-30	1993-03-31	1
50415	2986	260139	1978-12-06	1978-12-13	1
88574	5272	4112343	1923-09-09	1923-09-18	1
14979	883	260139	1986-03-20	1986-03-27	1
69719	4129	40481087	1962-01-04	1962-01-25	1
77203	4578	30753	1999-04-11	1999-04-12	1
47994	2849	40481087	1985-07-31	1985-08-07	1
42874	2555	260139	2004-09-22	2004-09-29	1
25719	1529	4218389	1993-02-24	1993-03-31	1
59735	3543	195588	2018-08-15	2018-09-20	1
50926	3017	257012	1974-01-05	1974-01-06	1
83681	4976	260139	1987-01-10	1987-01-24	1
88280	5253	40481087	1956-10-13	1956-10-20	1
50416	2986	4112343	1946-02-06	1946-02-17	1
88575	5272	4294548	1971-06-18	1971-10-01	1
14980	883	4112343	1972-09-10	1972-09-18	1
69720	4129	40481087	1983-06-23	1983-07-14	1
77204	4578	260139	1998-06-05	1998-06-19	1
48988	2903	0	1975-09-13	1975-09-14	1
42875	2555	372328	1953-04-02	1953-08-13	1
25720	1529	4294548	1991-09-18	1991-10-09	1
59736	3543	4149245	1978-07-14	1978-09-19	1
50927	3017	372328	1958-04-13	1958-07-25	1
83682	4976	375671	1981-03-09	1981-05-08	1
88281	5253	40481087	1976-02-10	1976-02-24	1
50417	2986	4112343	1999-03-10	1999-03-23	1
88576	5272	40481087	1929-09-17	1929-10-08	1
18210	1097	28060	1972-09-22	1972-09-30	1
69721	4129	40481087	2008-05-14	2008-05-28	1
77205	4578	260139	1998-09-19	1998-10-03	1
48989	2903	4112343	1978-02-11	1978-02-22	1
42876	2555	4112343	2000-11-21	2000-12-04	1
25721	1529	40481087	2001-07-26	2001-08-09	1
59737	3543	372328	1960-05-05	1960-06-21	1
50928	3017	40481087	1973-04-30	1973-05-07	1
83683	4976	375671	1987-10-04	1987-12-03	1
88282	5253	40481087	1986-10-05	1986-10-26	1
50418	2986	4294548	2017-07-24	2017-08-28	1
88577	5272	40481087	1967-01-31	1967-02-14	1
18211	1097	81151	2012-02-24	2012-03-09	1
69722	4129	28060	1955-03-05	1955-03-15	1
77206	4578	260139	2008-08-25	2008-09-08	1
48990	2903	4112343	1990-09-19	1990-09-27	1
42877	2555	4296204	1971-04-08	1971-05-14	1
25722	1529	40481087	2017-04-20	2017-05-11	1
59738	3543	4116491	2013-07-01	2013-08-16	1
50929	3017	260139	2000-11-08	2000-11-15	1
83684	4976	378419	1986-07-15	1986-07-16	1
88283	5253	40481087	2009-12-17	2009-12-31	1
50419	2986	40481087	1995-12-21	1996-01-11	1
88578	5272	40481087	1968-08-16	1968-08-23	1
18212	1097	40481087	2016-04-21	2016-05-12	1
69723	4129	80180	1983-10-05	1983-10-06	1
77207	4578	372328	1967-04-09	1967-04-30	1
48991	2903	4112343	2016-08-07	2016-08-14	1
42878	2555	40481087	1977-12-07	1977-12-21	1
25723	1529	78272	1968-06-30	1968-08-04	1
59739	3543	40481087	1987-04-26	1987-05-03	1
50930	3017	4294548	1977-09-07	1978-01-25	1
83685	4976	381316	1984-06-12	1984-06-13	1
50420	2986	140673	2015-09-23	2015-09-24	1
88579	5272	40481087	2004-03-06	2004-03-13	1
18213	1097	80180	2004-05-07	2004-05-08	1
69724	4129	4278672	1988-08-24	1988-10-23	1
77208	4578	4027663	1993-05-17	1993-05-18	1
48992	2903	4116491	1998-09-06	1998-10-15	1
42879	2555	40481087	2011-04-07	2011-04-28	1
25724	1529	80180	2000-07-12	2000-07-13	1
59740	3543	78272	1994-09-25	1994-10-30	1
50931	3017	40481087	1975-03-23	1975-04-13	1
83686	4976	439777	1976-10-27	1976-10-28	1
50421	2986	261325	1988-10-25	1988-10-26	1
88580	5272	40481087	2012-02-08	2012-02-15	1
18214	1097	260139	1978-07-10	1978-07-24	1
69725	4129	40481087	1967-04-06	1967-04-20	1
77209	4578	4112343	1967-09-08	1967-09-17	1
48993	2903	4116491	2009-11-15	2009-12-30	1
42880	2555	28060	2011-06-26	2011-07-08	1
25725	1529	81151	2013-04-15	2013-05-20	1
59741	3543	260139	1975-05-19	1975-06-02	1
50932	3017	40481087	1984-03-29	1984-04-19	1
83687	4976	4112343	1956-09-17	1956-09-27	1
50422	2986	40481087	1954-03-30	1954-04-06	1
18215	1097	260139	2001-12-28	2002-01-04	1
69726	4129	40481087	2008-02-29	2008-03-07	1
77210	4578	4218389	1967-01-09	1967-02-06	1
48994	2903	40481087	2001-07-21	2001-08-11	1
42881	2555	80180	1990-11-13	1990-11-14	1
25726	1529	260139	2010-04-19	2010-05-03	1
59742	3543	375671	1966-12-14	1967-01-13	1
50933	3017	40481087	2004-03-16	2004-04-06	1
83688	4976	4112343	1979-12-10	1979-12-22	1
50423	2986	40481087	1967-02-20	1967-02-27	1
18216	1097	4296204	1976-06-18	1976-07-02	1
72096	4283	28060	1990-09-11	1990-09-24	1
77211	4578	4266809	2000-04-05	2000-04-06	1
48995	2903	40481087	2005-12-27	2006-01-10	1
42882	2555	257012	1986-12-28	1986-12-29	1
25727	1529	372328	1966-04-25	1967-06-12	2
59743	3543	40481087	2004-04-02	2004-04-23	1
50934	3017	260139	1966-03-03	1966-03-10	1
83689	4976	4218389	1913-12-07	1914-01-04	1
50424	2986	40481087	1972-04-04	1972-04-18	1
18217	1097	40481087	1978-01-15	1978-02-05	1
72097	4283	80180	1990-12-15	1990-12-16	1
77212	4578	40481087	1964-09-30	1964-10-14	1
48996	2903	372328	1974-09-06	1975-04-27	1
42883	2555	4112343	2009-09-21	2009-10-03	1
25728	1529	4112343	1976-07-31	1976-08-10	1
59744	3543	40481087	2016-09-25	2016-10-16	1
50935	3017	260139	2003-03-28	2003-04-11	1
83690	4976	40481087	1914-03-15	1914-03-29	1
50425	2986	0	1946-03-12	1946-03-13	1
18218	1097	198199	2008-03-17	2008-05-01	1
72098	4283	81893	1988-09-26	1988-09-27	1
77213	4578	40481087	1993-02-27	1993-03-13	1
48997	2903	4112343	2014-09-04	2014-09-14	1
42884	2555	4156265	1969-04-28	1969-05-19	1
25729	1529	4112343	1993-09-12	1993-09-21	1
59745	3543	80180	1993-10-24	1993-10-25	1
50936	3017	4112343	1973-08-21	1973-09-02	1
83691	4976	40481087	1935-09-29	1935-10-20	1
50426	2986	28060	1949-10-12	1949-10-24	1
18219	1097	4112343	1986-06-23	1986-07-01	1
72099	4283	4310024	1988-01-30	1988-01-31	1
77214	4578	192671	2000-04-25	2000-04-26	1
48998	2903	4116491	2004-10-13	2004-11-16	1
42885	2555	40481087	1959-10-23	1959-11-05	1
25730	1529	40481087	1990-10-02	1990-10-16	1
59746	3543	317576	1992-09-29	1992-09-30	1
50937	3017	4112343	1999-03-22	1999-04-03	1
83692	4976	40481087	1938-12-09	1938-12-16	1
50427	2986	260139	2018-06-05	2018-06-19	1
18220	1097	381316	2016-09-15	2016-09-16	1
72100	4283	40481087	1970-10-05	1970-10-26	1
77215	4578	4112343	1975-01-10	1975-01-20	1
48999	2903	40481087	1983-07-30	1983-08-06	1
43661	2603	378001	1961-04-20	1961-05-20	1
26588	1577	80180	1962-03-29	1962-03-30	1
59747	3543	4112343	1975-05-19	1975-06-01	1
50938	3017	4112343	2011-10-14	2011-10-22	1
83693	4976	40481087	1991-09-14	1991-09-28	1
50428	2986	321042	1946-03-12	1946-03-13	1
18221	1097	4112343	1969-09-25	1969-10-06	1
72101	4283	260139	1967-03-09	1967-03-16	1
77216	4578	4134304	1973-06-04	1973-07-04	1
49000	2903	81151	2013-12-12	2014-01-02	1
43662	2603	4237458	1983-01-30	1983-04-30	1
26589	1577	196456	1997-01-31	1997-01-31	1
59748	3543	4112343	1981-12-28	1982-01-08	1
50939	3017	4116491	2002-08-05	2002-09-23	1
83694	4976	260139	1981-06-05	1981-06-19	1
50429	2986	4112343	1948-05-10	1948-05-17	1
18222	1097	40481087	1999-06-23	1999-07-14	1
72102	4283	4146173	1955-11-19	1956-01-25	1
77217	4578	4134304	1979-02-03	1979-05-04	1
49001	2903	260139	1973-04-10	1973-04-24	1
43663	2603	40481087	1961-05-29	1961-06-19	1
26590	1577	4112343	1965-04-19	1965-04-27	1
59749	3543	4112343	2008-12-19	2008-12-27	1
50940	3017	4237458	1960-07-01	1960-09-29	1
83695	4976	372328	1937-10-02	1938-01-25	1
50430	2986	4112343	2002-01-07	2002-01-16	1
18223	1097	40481087	2004-01-25	2004-02-15	1
72103	4283	4230399	1956-12-20	1957-03-20	1
77218	4578	40481087	1980-03-03	1980-03-10	1
49002	2903	372328	1965-12-03	1966-02-20	1
43664	2603	40481087	1962-02-20	1962-03-06	1
26591	1577	4112343	1969-04-07	1969-04-15	1
59750	3543	4152936	1961-04-30	1961-05-14	1
52329	3103	381316	2018-05-16	2018-05-17	1
83696	4976	4112343	1928-06-06	1928-06-15	1
50431	2986	4112343	2013-07-21	2013-07-29	1
19756	1189	28060	2004-01-29	2004-02-11	1
72104	4283	40481087	1978-05-22	1978-06-12	1
77219	4578	40481087	1986-07-09	1986-07-30	1
49003	2903	372328	1980-03-01	1981-03-08	1
43665	2603	140673	2014-05-12	2014-05-13	1
26592	1577	195588	1955-02-09	1955-03-29	1
59751	3543	40481087	1959-01-18	1959-02-01	1
52330	3103	40481087	2000-08-19	2000-09-09	1
83697	4976	4152936	1950-12-05	1950-12-19	1
50432	2986	4156265	1974-12-02	1974-12-23	1
19757	1189	28060	2010-11-17	2010-11-24	1
72105	4283	40481087	2001-11-15	2001-11-29	1
77220	4578	40481087	1990-12-14	1991-01-04	1
49004	2903	4112343	1971-07-07	1971-07-14	1
43666	2603	372328	1960-10-22	1961-02-01	1
26593	1577	260139	2003-05-15	2003-05-22	1
59752	3543	40481087	1974-06-18	1974-06-25	1
52331	3103	40481087	2009-04-09	2009-04-30	1
83698	4976	40481087	1967-08-10	1967-08-17	1
50433	2986	4294548	2017-12-05	2018-04-24	1
19758	1189	4112343	2005-07-06	2005-07-15	1
72106	4283	28060	1970-09-15	1970-09-25	1
77221	4578	4112343	1978-02-04	1978-02-17	1
49005	2903	4112343	2003-11-20	2003-11-27	1
43667	2603	4113008	2012-03-28	2012-04-18	1
26594	1577	4059173	1991-01-16	1991-03-17	1
59753	3543	40481087	1993-10-07	1993-10-21	1
52332	3103	80180	2019-01-20	2019-01-21	1
87126	5194	4112343	1953-08-03	1953-08-11	1
50434	2986	40481087	1971-09-10	1971-10-01	1
19759	1189	40481087	1968-02-29	1968-03-14	1
72107	4283	192671	1991-03-03	1991-03-04	1
77222	4578	4112343	1979-08-15	1979-08-23	1
49006	2903	40481087	1989-04-13	1989-04-20	1
43668	2603	40481087	1996-06-08	1996-06-29	1
26595	1577	4112343	2007-01-10	2007-01-22	1
62498	3697	81151	2017-01-09	2017-02-13	1
52333	3103	260139	1984-10-08	1984-10-22	1
87127	5194	4112343	1975-06-03	1975-06-12	1
51980	3082	257012	1998-04-05	1998-04-06	1
19760	1189	40481087	1980-11-09	1980-11-23	1
72108	4283	257012	2001-04-19	2001-04-20	1
77223	4578	4112343	1993-04-26	1993-05-06	1
49007	2903	80180	2000-05-23	2000-05-24	1
43669	2603	80180	1996-09-03	1996-09-04	1
26596	1577	4230399	2017-01-20	2017-04-20	1
62499	3697	195588	1978-05-02	1978-06-27	1
52334	3103	260139	2015-06-19	2015-06-26	1
87128	5194	40481087	1950-01-03	1950-01-17	1
51981	3082	260139	1997-05-19	1997-05-26	1
19761	1189	40481087	2010-10-30	2010-11-13	1
72109	4283	260139	1981-12-29	1982-01-12	1
77224	4578	4112343	1998-12-07	1998-12-19	1
49008	2903	260139	1966-06-02	1966-06-16	1
43670	2603	4112343	1988-05-02	1988-05-11	1
26597	1577	40481087	1947-12-23	1948-01-13	1
62500	3697	260139	1986-09-10	1986-09-17	1
52335	3103	372328	1978-11-06	1978-11-20	1
87129	5194	40481087	1966-05-29	1966-06-12	1
51982	3082	260139	2001-11-03	2001-11-10	1
19762	1189	81151	1980-03-07	1980-03-28	1
72110	4283	4027663	1982-04-06	1982-04-07	1
77225	4578	4112343	2005-11-14	2005-11-24	1
49009	2903	260139	1979-01-26	1979-02-02	1
43671	2603	4218389	1975-05-07	1975-06-11	1
26598	1577	40481087	2015-03-08	2015-03-29	1
62501	3697	260139	1987-04-16	1987-04-23	1
52336	3103	372328	2011-01-23	2012-01-10	1
87130	5194	40481087	1990-01-30	1990-02-06	1
51983	3082	321042	1988-05-04	1988-05-05	1
19763	1189	4112343	1970-12-29	1971-01-08	1
72111	4283	4059173	1953-10-30	1954-01-28	1
77226	4578	40481087	1982-01-05	1982-01-26	1
49010	2903	260139	2011-03-11	2011-03-25	1
43672	2603	4294548	2019-05-13	2019-06-03	1
26599	1577	28060	2006-06-02	2006-06-11	1
62502	3697	372328	1957-01-21	1957-03-09	1
52337	3103	4001336	1993-08-11	1993-09-10	1
87131	5194	78272	2003-11-03	2003-12-01	1
51984	3082	4112343	1977-08-04	1977-08-15	1
19764	1189	40481087	1981-01-01	1981-01-08	1
72112	4283	4294548	2001-03-15	2001-08-09	1
77227	4578	40481087	2019-02-21	2019-02-28	1
49011	2903	440448	1975-09-13	1975-09-14	1
43673	2603	40481087	1968-03-10	1968-03-31	1
26600	1577	80502	1992-07-03	1992-07-04	1
62503	3697	372328	1982-07-26	1982-09-25	1
52338	3103	4113008	1983-03-15	1983-04-05	1
87132	5194	81151	1969-03-22	1969-04-05	1
51985	3082	4112343	1982-10-19	1982-10-27	1
19765	1189	4112343	2001-12-28	2002-01-05	1
72113	4283	40481087	1985-12-07	1985-12-28	1
78889	4676	80180	2018-09-11	2018-09-12	1
49012	2903	4109685	1973-08-23	1973-09-13	1
43674	2603	40481087	2008-01-05	2008-01-12	1
26601	1577	260139	1989-10-14	1989-10-28	1
62504	3697	4112343	2002-06-29	2002-07-08	1
52339	3103	4132546	1993-08-11	1993-08-12	1
87133	5194	260139	1958-05-30	1958-06-06	1
51986	3082	40481087	1979-05-15	1979-05-29	1
19766	1189	4237458	1964-09-27	1964-11-26	1
72114	4283	40481087	2009-04-28	2009-05-05	1
78890	4676	195588	1996-07-28	1996-09-01	1
49013	2903	40481087	1979-12-26	1980-01-09	1
43675	2603	28060	1965-09-16	1965-09-28	1
26602	1577	372328	1926-07-19	1927-01-28	1
62505	3697	4116491	1974-03-18	1974-05-03	1
52340	3103	40481087	2001-11-11	2001-11-18	1
87134	5194	260139	2009-01-27	2009-02-03	1
51987	3082	40481087	1989-03-13	1989-03-20	1
19767	1189	40481087	1967-09-18	1967-09-25	1
72115	4283	30753	1989-05-24	1989-05-25	1
78891	4676	40481087	1983-11-18	1983-12-09	1
53704	3181	260139	1966-12-25	1967-01-01	1
43676	2603	28060	1988-10-12	1988-10-22	1
26603	1577	4112343	1922-10-16	1922-10-29	1
62506	3697	40481087	1959-08-28	1959-09-18	1
52341	3103	40481087	2003-10-19	2003-11-01	1
87135	5194	372328	1950-10-29	1951-06-07	1
51988	3082	40481087	2009-05-24	2009-05-31	1
19768	1189	40481087	1969-09-12	1969-10-03	1
72116	4283	81151	1973-10-22	1973-11-19	1
78892	4676	40481087	1996-03-10	1996-03-24	1
53705	3181	4051466	1953-09-20	1970-12-22	1
43677	2603	260139	1980-02-11	1980-02-25	1
26604	1577	4113008	2013-12-16	2014-01-06	1
62507	3697	40481087	1960-11-17	1960-12-01	1
52342	3103	372328	1982-05-04	1982-05-26	1
87136	5194	4112343	1981-12-08	1981-12-21	1
51989	3082	378001	1979-02-06	1979-04-07	1
19769	1189	40481087	2012-11-07	2012-11-28	1
72117	4283	260139	1964-11-03	1964-11-17	1
78893	4676	81151	2002-11-04	2002-11-25	1
53706	3181	4059173	2018-11-15	2019-02-13	1
43678	2603	372328	1962-11-23	1963-04-24	1
26605	1577	40480160	2017-01-20	2017-04-20	1
62508	3697	30753	1993-03-08	1993-03-09	1
52343	3103	40481087	2005-10-27	2005-11-16	1
87137	5194	4112343	2012-10-11	2012-10-19	1
51990	3082	4109685	1970-10-07	1970-10-21	1
19770	1189	80180	2005-05-10	2005-05-11	1
72118	4283	4059173	1959-02-08	1959-05-09	1
78894	4676	4112343	1995-11-22	1995-12-04	1
53707	3181	4112343	1985-06-30	1985-07-12	1
43679	2603	4112343	1962-04-19	1962-05-02	1
26606	1577	40481087	1931-04-07	1931-04-21	1
62509	3697	80180	1993-06-06	1993-06-07	1
52344	3103	40481087	2013-01-13	2013-01-27	1
87138	5194	40481087	1972-03-21	1972-03-28	1
51991	3082	4112343	1987-02-06	1987-02-14	1
19771	1189	372328	1968-11-05	1969-11-17	1
72119	4283	4112343	1959-02-04	1959-02-11	1
78895	4676	4278672	1981-08-21	1981-09-20	1
53708	3181	4113008	1982-04-25	1982-05-16	1
43680	2603	40481087	1982-01-25	1982-02-15	1
26607	1577	40481087	1941-05-07	1941-05-21	1
62510	3697	81151	2009-07-15	2009-07-29	1
52345	3103	40481087	2018-10-07	2018-10-28	1
87139	5194	28060	1948-12-15	1948-12-24	1
51992	3082	4134304	1980-03-02	1980-05-31	1
19772	1189	4142905	1975-07-02	1975-08-01	1
72120	4283	4112343	1996-01-27	1996-02-08	1
78896	4676	40481087	2013-03-03	2013-03-17	1
53709	3181	4294548	2001-06-06	2001-09-05	1
43681	2603	40481087	1991-09-04	1991-09-25	1
26608	1577	40481087	1954-09-17	1954-09-24	1
62511	3697	4027663	1985-03-15	1985-03-16	1
52346	3103	4278672	1987-12-10	1988-01-09	1
87140	5194	80180	1982-08-26	1982-08-27	1
51993	3082	4134304	1998-03-28	1998-04-27	1
19773	1189	4146173	2018-01-08	2018-03-09	1
72121	4283	4278672	1961-06-27	1961-07-27	1
78897	4676	372328	1981-11-19	1982-01-07	1
53710	3181	40481087	1953-12-07	1953-12-21	1
43682	2603	40481087	2013-12-20	2014-01-03	1
26609	1577	198809	1997-01-31	1997-01-31	1
62512	3697	4112343	1996-11-17	1996-11-24	1
53565	3177	30753	1949-01-02	1949-01-03	1
87141	5194	192671	1982-09-26	1982-09-27	1
51994	3082	40481087	1976-09-13	1976-09-20	1
19774	1189	40481087	1974-05-18	1974-06-08	1
72122	4283	40481087	1954-01-05	1954-01-26	1
78898	4676	439777	1983-08-01	1983-08-02	1
53711	3181	40481087	1956-04-17	1956-04-24	1
47701	2836	80180	2019-01-10	2019-01-11	1
26610	1577	260139	1972-08-25	1972-09-08	1
62513	3697	4266809	1993-06-06	1993-06-07	1
53566	3177	81151	1924-12-04	1924-12-18	1
87142	5194	260139	1946-06-17	1946-06-24	1
51995	3082	40481087	2007-10-04	2007-10-25	1
19775	1189	40481087	1996-06-26	1996-07-10	1
73676	4382	28060	1974-10-07	1974-10-15	1
78899	4676	4112343	1993-03-24	1993-04-05	1
53712	3181	40481087	1968-12-26	1969-01-09	1
47702	2836	81151	1998-09-09	1998-10-14	1
26611	1577	260139	1990-06-07	1990-06-21	1
62514	3697	4283893	1981-10-23	1981-12-11	1
53567	3177	260139	1920-02-01	1920-02-08	1
87143	5194	260139	2000-05-08	2000-05-15	1
51996	3082	40481087	2008-02-29	2008-03-21	1
19776	1189	40481087	2014-08-29	2014-09-12	1
73677	4382	28060	2016-04-07	2016-04-18	1
78900	4676	4218389	1997-12-25	1998-01-29	1
53713	3181	40481087	1999-06-21	1999-07-12	1
47703	2836	192671	2019-03-21	2019-03-22	1
26612	1577	372328	1925-07-01	1925-07-24	1
62515	3697	40481087	1981-07-11	1981-07-18	1
53568	3177	260139	1946-07-10	1946-07-17	1
87144	5194	372328	1946-05-17	1946-08-29	1
51997	3082	80180	2004-03-12	2004-03-13	1
20515	1235	0	2009-05-19	2009-05-20	1
73678	4382	78272	1975-12-20	1976-01-10	1
78901	4676	260139	2014-10-29	2014-11-12	1
53714	3181	28060	1984-07-23	1984-08-03	1
47704	2836	195588	2010-11-22	2011-01-12	1
26613	1577	378001	1996-08-17	1996-09-16	1
62516	3697	78272	2015-02-28	2015-03-21	1
53569	3177	260139	2008-06-05	2008-06-19	1
87145	5194	372328	1949-10-21	1950-06-01	1
51998	3082	4112343	2006-05-07	2006-05-15	1
20516	1235	81151	1981-04-08	1981-04-22	1
73679	4382	260139	1967-01-22	1967-01-29	1
78902	4676	372328	1982-11-03	1983-01-06	1
53715	3181	80180	1987-11-19	1987-11-20	1
47705	2836	257012	1995-10-14	1995-10-15	1
26614	1577	40481087	2010-02-10	2010-02-24	1
62517	3697	260139	1960-07-05	1960-07-19	1
53570	3177	321042	2003-01-08	2003-01-09	1
87146	5194	4112343	1946-06-18	1946-06-28	1
51999	3082	40481087	1983-10-14	1983-11-04	1
20517	1235	40481087	1997-07-21	1997-08-04	1
73680	4382	260139	2010-08-13	2010-08-20	1
78903	4676	378001	2000-01-19	2000-02-18	1
53716	3181	261325	2000-09-22	2000-09-23	1
47706	2836	260139	1994-12-19	1994-12-26	1
28908	1715	260139	2015-01-08	2015-01-15	1
62518	3697	4112343	1971-05-23	1971-05-30	1
53571	3177	4059173	1993-10-04	1993-11-03	1
87147	5194	4112343	1969-12-19	1969-12-29	1
52000	3082	0	1988-05-04	1988-05-05	1
20518	1235	40481087	1998-10-04	1998-10-25	1
73681	4382	4112343	1967-08-31	1967-09-11	1
78904	4676	4112343	2015-03-26	2015-04-07	1
53717	3181	4112343	1989-11-21	1989-12-04	1
47707	2836	4112343	2011-02-05	2011-02-16	1
28909	1715	372328	1972-09-20	1973-03-17	1
62519	3697	4149245	1955-02-01	1955-03-10	1
53572	3177	4112343	1948-02-12	1948-02-25	1
87148	5194	81151	1952-01-16	1952-02-20	1
52001	3082	372328	1967-12-22	1968-01-05	1
20519	1235	40481087	2000-03-24	2000-04-07	1
73682	4382	40481087	1991-11-07	1991-11-21	1
80491	4776	80180	2001-01-17	2001-01-18	1
53718	3181	40481087	1974-07-17	1974-08-07	1
47708	2836	4116491	2007-08-26	2007-10-05	1
28910	1715	4112343	1960-04-21	1960-04-30	1
62520	3697	40481087	1964-03-23	1964-04-06	1
53573	3177	4112343	2006-02-24	2006-03-05	1
87149	5194	372328	1948-10-17	1948-11-25	1
52002	3082	4294548	1998-03-08	1998-04-19	1
20520	1235	28060	2005-02-20	2005-03-04	1
73683	4382	260139	1955-08-17	1955-08-31	1
80492	4776	260139	1981-12-10	1981-12-24	1
53719	3181	40481087	1976-12-01	1976-12-22	1
47709	2836	4116491	2008-10-04	2008-11-22	1
28911	1715	78272	1984-09-24	1984-10-08	1
62521	3697	40481087	2011-04-10	2011-04-24	1
53574	3177	4152936	1959-04-24	1959-05-15	1
87150	5194	4084167	1953-04-10	1953-04-10	1
53931	3196	192671	2008-07-06	2008-07-07	1
20521	1235	80180	2010-09-04	2010-09-05	1
73684	4382	4109685	2017-03-03	2017-03-17	1
80493	4776	4112343	1988-10-21	1988-11-03	1
53720	3181	40481087	2004-08-27	2004-09-10	1
47710	2836	40481087	2002-04-13	2002-05-04	1
28912	1715	260139	1998-09-04	1998-09-18	1
62522	3697	4094814	2002-08-21	2002-10-20	1
53575	3177	4230399	2002-07-19	2002-08-18	1
87151	5194	4112343	2013-05-21	2013-06-02	1
464	28	80180	2015-05-10	2015-05-11	1
20522	1235	78272	2004-01-13	2004-02-10	1
73685	4382	4155034	2000-06-16	2000-06-30	1
80494	4776	4112343	1999-02-11	1999-02-20	1
53721	3181	78272	1964-11-04	1964-11-25	1
47711	2836	40481087	2014-08-20	2014-08-27	1
28913	1715	372328	1959-04-09	1959-05-02	1
62523	3697	4112343	1953-07-12	1953-07-24	1
53576	3177	4283893	1968-05-21	1969-01-14	1
87152	5194	40481087	2010-06-26	2010-07-10	1
465	28	4112343	1991-11-29	1991-12-12	1
20523	1235	81151	1980-02-29	1980-03-14	1
73686	4382	4310024	1991-08-17	1991-08-18	1
80495	4776	40481087	1960-06-25	1960-07-16	1
53722	3181	372328	1951-10-14	1951-12-21	1
47712	2836	28060	2001-02-02	2001-02-13	1
28914	1715	4112343	1958-03-19	1958-03-31	1
62524	3697	4152936	1988-10-12	1988-11-02	1
53577	3177	40480160	1985-12-15	1986-03-15	1
89487	5328	260139	1929-01-18	1929-01-25	1
466	28	372328	1979-11-30	1980-02-06	1
20524	1235	440448	2009-05-19	2009-05-20	1
73687	4382	40481087	1962-01-16	1962-02-06	1
80496	4776	40481087	2018-09-12	2018-09-26	1
53723	3181	4084167	1959-05-05	1959-05-06	1
47713	2836	4294548	1999-10-14	1999-11-18	1
28915	1715	4218389	2019-03-12	2019-04-16	1
62525	3697	40481087	1957-10-25	1957-11-01	1
53578	3177	40481087	1922-12-05	1922-12-19	1
89488	5328	372328	1910-02-26	1910-06-08	1
467	28	4112343	1983-05-15	1983-05-27	1
20525	1235	4109685	1992-12-20	1993-01-10	1
73688	4382	40481087	1994-09-03	1994-09-17	1
80497	4776	260139	2008-04-23	2008-05-07	1
53724	3181	4218389	1989-04-09	1989-04-30	1
47714	2836	40481087	2012-02-17	2012-02-24	1
28916	1715	4296204	1996-02-08	1996-03-14	1
62526	3697	40481087	1988-10-11	1988-11-01	1
53579	3177	4035415	1964-02-18	1964-03-19	1
89489	5328	4113008	1995-09-13	1995-09-27	1
468	28	4112343	1985-03-19	1985-04-01	1
20526	1235	4146173	1985-04-01	1985-05-01	1
73689	4382	28060	1984-12-22	1985-01-02	1
80498	4776	372328	1964-12-22	1965-03-07	1
53725	3181	40481087	1981-12-02	1981-12-16	1
47715	2836	40481087	2018-01-14	2018-01-28	1
28917	1715	40481087	2018-07-01	2018-07-08	1
62527	3697	40481087	2005-07-14	2005-08-04	1
53580	3177	4109685	1934-10-27	1934-11-17	1
89490	5328	4278672	1955-02-03	1955-05-04	1
469	28	4156265	1991-06-30	1991-07-21	1
20527	1235	40481087	1978-02-15	1978-03-08	1
73690	4382	257012	2008-05-11	2008-05-12	1
80499	4776	40481087	1965-09-27	1965-10-04	1
53726	3181	40481087	1989-12-10	1989-12-31	1
47716	2836	81151	1991-11-24	1991-12-15	1
28918	1715	80180	1999-05-29	1999-05-30	1
65841	3896	381316	2010-06-18	2010-06-19	1
89491	5328	40481087	1917-09-22	1917-10-13	1
470	28	40481087	2009-03-22	2009-03-29	1
20528	1235	40481087	2008-12-27	2009-01-10	1
73691	4382	4027663	1983-12-22	1983-12-23	1
80500	4776	260139	1965-02-21	1965-03-07	1
53727	3181	192671	1987-12-16	1987-12-17	1
47717	2836	440086	1993-08-29	1998-09-07	1
28919	1715	260139	1970-06-20	1970-06-27	1
65842	3896	4283893	2014-06-25	2014-10-08	1
89492	5328	40481087	1938-09-11	1938-10-02	1
471	28	40481087	1982-05-27	1982-06-03	1
20529	1235	40481087	2011-06-07	2011-06-28	1
73692	4382	4051466	1955-01-05	1972-04-05	1
80501	4776	313217	2011-04-24	2011-04-25	1
53728	3181	257012	2001-07-11	2001-07-12	1
47718	2836	4218389	2012-01-04	2012-02-08	1
28920	1715	260139	1994-03-06	1994-03-13	1
65843	3896	40481087	2007-04-16	2007-04-30	1
89493	5328	40481087	1992-02-13	1992-02-27	1
472	28	4112343	1995-02-27	1995-03-11	1
20530	1235	28060	2011-01-06	2011-01-16	1
73693	4382	4112343	2007-06-10	2007-06-23	1
80502	4776	81151	1974-06-03	1974-07-08	1
53729	3181	260139	1977-11-06	1977-11-20	1
47719	2836	4278672	1984-02-13	1984-04-13	1
28921	1715	260139	2019-06-27	2019-06-28	1
65844	3896	28060	1987-02-21	1987-03-02	1
89494	5328	78272	1962-01-27	1962-02-17	1
5804	341	4112343	1986-09-17	1986-09-25	1
20531	1235	4166224	2009-05-19	2009-05-20	1
73694	4382	4283893	2008-04-13	2008-07-06	1
80503	4776	40481087	1986-11-22	1986-12-06	1
53730	3181	260139	1994-12-27	1995-01-10	1
47720	2836	4294548	1995-08-19	1995-10-28	1
28922	1715	4112343	2006-03-15	2006-03-24	1
65845	3896	80180	2018-11-11	2018-11-12	1
89495	5328	80180	1945-04-08	1945-04-09	1
5805	341	4112343	1986-11-26	1986-12-08	1
20532	1235	4283893	1988-07-20	1988-08-31	1
73695	4382	40481087	1992-07-23	1992-08-06	1
80504	4776	40481087	2001-01-30	2001-02-06	1
53731	3181	4155034	2001-05-27	2001-06-17	1
47721	2836	28060	1985-08-09	1985-08-22	1
28923	1715	134438	1988-11-24	1989-12-19	1
65846	3896	257012	2014-07-16	2014-07-17	1
89496	5328	80502	2000-01-26	2000-01-27	1
5806	341	40481087	2002-11-09	2002-11-30	1
21285	1280	260139	1955-07-15	1955-07-29	1
73696	4382	80180	1994-05-03	1994-05-04	1
80505	4776	40481087	2005-12-20	2006-01-10	1
53732	3181	4280726	1956-09-19	1956-09-20	1
47722	2836	28060	2009-06-04	2009-06-12	1
28924	1715	260139	1964-01-15	1964-01-22	1
65847	3896	260139	2000-10-31	2000-11-07	1
89497	5328	81151	1975-03-11	1975-04-01	1
5807	341	40481087	2018-11-30	2018-12-07	1
21286	1280	372328	1978-03-28	1979-01-03	1
73697	4382	260139	1965-06-16	1965-06-30	1
83843	4987	198199	2014-09-08	2014-11-01	1
54016	3201	4112343	1959-06-02	1959-06-15	1
47723	2836	4113008	1986-02-02	1986-02-23	1
28925	1715	378001	1987-03-27	1987-05-26	1
65848	3896	372328	1978-08-03	1978-09-15	1
89498	5328	260139	1939-02-03	1939-02-17	1
5808	341	260139	2000-05-10	2000-05-17	1
21287	1280	4112343	1974-07-02	1974-07-09	1
73698	4382	260139	1968-06-13	1968-06-20	1
83844	4987	257012	1969-03-14	1969-03-15	1
54017	3201	4134304	1953-06-19	1953-07-19	1
49211	2914	192671	1997-05-23	1997-05-24	1
28926	1715	4112343	2003-09-14	2003-09-24	1
65849	3896	40481087	1995-01-08	1995-01-15	1
89499	5328	260139	1969-05-03	1969-05-10	1
5809	341	4112343	1969-10-24	1969-11-03	1
21288	1280	4112343	2014-07-15	2014-07-25	1
73699	4382	4112343	1963-05-10	1963-05-23	1
83845	4987	260139	2013-07-05	2013-07-12	1
54018	3201	4156265	1964-09-19	1964-10-03	1
49212	2914	321042	1986-09-06	1986-09-07	1
28927	1715	4218389	2010-09-27	2010-10-25	1
65850	3896	40481087	2007-08-03	2007-08-24	1
89500	5328	260139	1974-08-13	1974-08-27	1
5810	341	4156265	1989-04-10	1989-05-01	1
21289	1280	4146173	1976-02-26	1976-04-03	1
73700	4382	4152936	1985-12-18	1986-01-01	1
83846	4987	372328	1962-10-06	1963-02-26	1
54019	3201	4285898	1975-09-29	1975-09-30	1
49213	2914	439777	1956-09-30	1956-10-01	1
28928	1715	40481087	2008-09-26	2008-10-17	1
65851	3896	81151	1987-09-06	1987-10-11	1
89501	5328	260139	1988-09-05	1988-09-12	1
5811	341	40481087	2011-10-19	2011-11-09	1
21290	1280	4296204	1964-08-24	1964-09-28	1
73701	4382	4156265	1964-10-27	1964-11-17	1
83847	4987	4027663	1990-09-14	1990-09-15	1
54020	3201	4310024	1974-01-07	1974-01-08	1
49214	2914	4112343	1960-05-10	1960-05-18	1
28929	1715	40481087	2010-07-17	2010-08-07	1
65852	3896	260139	1990-12-29	1991-01-12	1
89502	5328	372328	1913-08-21	1914-09-09	1
5812	341	40481087	2014-11-01	2014-11-15	1
21291	1280	40481087	1958-01-04	1958-01-25	1
74955	4456	28060	1999-11-03	1999-11-11	1
83848	4987	4112343	1960-05-20	1960-06-02	1
54021	3201	40481087	1980-07-18	1980-07-25	1
49215	2914	4296204	1960-05-07	1960-05-28	1
29230	1733	192671	2016-02-01	2016-02-02	1
65853	3896	4112343	1988-03-28	1988-04-05	1
89503	5328	4116491	1969-10-15	1969-12-01	1
5813	341	80180	1995-08-27	1995-08-28	1
21292	1280	40481087	1984-07-31	1984-08-07	1
74956	4456	260139	1967-02-09	1967-02-23	1
83849	4987	4112343	1985-08-07	1985-08-19	1
54022	3201	78272	1941-04-25	1941-05-23	1
49216	2914	80180	1997-03-09	1997-03-10	1
29231	1733	257012	1998-04-20	1998-04-21	1
65854	3896	4112343	2006-10-09	2006-10-21	1
89504	5328	4218389	1921-07-26	1921-08-30	1
5814	341	261325	2017-08-28	2017-08-29	1
21293	1280	40481087	1996-11-22	1996-12-13	1
74957	4456	260139	1976-01-24	1976-02-07	1
83850	4987	4113008	1970-01-27	1970-02-17	1
54023	3201	195588	1968-08-11	1968-09-15	1
49217	2914	81893	1995-06-18	1995-06-19	1
29232	1733	260139	2001-03-06	2001-03-13	1
65855	3896	4218389	1985-01-28	1985-02-18	1
89505	5328	28060	1954-08-04	1954-08-14	1
5815	341	378001	1997-09-16	1997-10-16	1
21294	1280	28060	2016-12-14	2016-12-23	1
74958	4456	260139	1999-12-09	1999-12-16	1
83851	4987	4285898	1997-01-05	1997-01-06	1
54024	3201	4112343	1956-11-04	1956-11-11	1
49218	2914	260139	1977-12-19	1977-12-26	1
29233	1733	260139	2002-04-08	2002-04-15	1
65856	3896	40481087	1996-02-16	1996-03-08	1
89506	5328	81151	1914-05-06	1914-06-03	1
5816	341	40481087	1970-07-19	1970-08-02	1
21295	1280	260139	2011-12-13	2011-12-20	1
74959	4456	260139	2010-03-31	2010-04-14	1
83852	4987	30753	1996-06-09	1996-06-10	1
54025	3201	30753	1975-06-01	1975-06-02	1
49219	2914	260139	2008-06-05	2008-06-19	1
29234	1733	40481087	2003-05-16	2003-06-06	1
65857	3896	4112343	1990-01-26	1990-02-03	1
89507	5328	257012	2019-05-09	2019-05-10	1
5817	341	40481087	1990-09-14	1990-10-05	1
21296	1280	4112343	1952-03-03	1952-03-10	1
74960	4456	4283893	2009-07-30	2009-09-17	1
83853	4987	80180	1997-06-04	1997-06-05	1
54026	3201	372328	1941-03-26	1941-07-30	1
49220	2914	4112343	1999-01-20	1999-02-01	1
29235	1733	28060	2005-03-16	2005-03-26	1
1264	74	28060	1979-04-16	1979-04-27	1
89508	5328	260139	1981-09-19	1981-10-03	1
5818	341	260139	1990-06-06	1990-06-13	1
21297	1280	4112343	1958-08-10	1958-08-21	1
74961	4456	40481087	1976-04-30	1976-05-21	1
83854	4987	260139	2004-06-29	2004-07-13	1
54027	3201	381316	1984-12-26	1984-12-27	1
49221	2914	4283893	1956-09-04	1956-10-16	1
29236	1733	4027663	2006-02-12	2006-02-13	1
1265	74	28060	1995-09-11	1995-09-19	1
89509	5328	4112343	1981-05-26	1981-06-02	1
5819	341	372328	1963-03-28	1963-06-17	1
21298	1280	4112343	1990-04-05	1990-04-18	1
74962	4456	80180	1998-03-07	1998-03-08	1
83855	4987	260139	2007-01-30	2007-02-06	1
54028	3201	4027663	1967-08-12	1967-08-13	1
49222	2914	0	1986-09-06	1986-09-07	1
29237	1733	4296204	1986-09-20	1986-10-18	1
1266	74	80180	2015-08-12	2015-08-13	1
89510	5328	4116491	1966-09-15	1966-10-16	1
5820	341	4112343	1978-10-19	1978-10-26	1
21299	1280	4116491	2012-07-02	2012-08-18	1
74963	4456	260139	1969-05-13	1969-05-20	1
83856	4987	4109685	1980-05-25	1980-06-08	1
54029	3201	4113008	1973-04-19	1973-05-10	1
49223	2914	372328	1959-09-01	1960-09-10	1
29238	1733	80180	2015-11-27	2015-11-28	1
1267	74	375671	1987-04-16	1987-05-16	1
89511	5328	4283893	2019-02-07	2019-02-08	1
5821	341	40481087	1969-02-03	1969-02-17	1
21300	1280	40481087	1956-11-11	1956-12-02	1
74964	4456	375671	1968-04-03	1968-05-03	1
83857	4987	4112343	1967-05-09	1967-05-16	1
54030	3201	4218389	1981-02-27	1981-03-27	1
49224	2914	4027663	1986-09-23	1986-09-24	1
29239	1733	372328	1983-03-10	1983-07-27	1
1268	74	4112343	1981-03-19	1981-03-29	1
89512	5328	40481087	1921-10-31	1921-11-14	1
5822	341	40481087	1984-08-27	1984-09-10	1
21301	1280	40481087	1993-04-26	1993-05-03	1
74965	4456	4059173	1965-06-18	1965-08-17	1
83858	4987	4112343	1990-11-25	1990-12-04	1
54031	3201	4266809	1976-07-25	1976-07-26	1
49225	2914	40481087	1965-11-07	1965-11-21	1
29240	1733	4294548	1998-03-30	1998-08-03	1
1269	74	40481087	1998-04-14	1998-05-05	1
89513	5328	40481087	1929-08-10	1929-08-24	1
12754	755	28060	1975-06-02	1975-06-10	1
21302	1280	80809	1994-06-23	1998-12-29	1
74966	4456	4112343	1982-09-19	1982-09-30	1
83859	4987	4266809	1997-06-04	1997-06-05	1
54032	3201	40481087	1949-10-17	1949-10-24	1
49226	2914	30753	1996-05-13	1996-05-14	1
29241	1733	4310024	2013-06-10	2013-06-11	1
1270	74	40481087	2006-10-23	2006-11-06	1
89514	5328	40481087	1941-12-23	1941-12-30	1
12755	755	260139	1979-12-15	1979-12-22	1
21303	1280	260139	1964-03-16	1964-03-23	1
74967	4456	4112343	2004-07-19	2004-07-26	1
83860	4987	40481087	1970-06-22	1970-06-29	1
54033	3201	80180	1976-07-25	1976-07-26	1
49227	2914	260139	1962-09-26	1962-10-10	1
29242	1733	40481087	2000-04-01	2000-04-22	1
1271	74	30753	2013-11-20	2013-11-21	1
89515	5328	28060	1923-05-07	1923-05-18	1
12756	755	260139	1989-02-12	1989-02-26	1
21304	1280	260139	1970-06-04	1970-06-18	1
74968	4456	4116491	2008-05-13	2008-07-02	1
83861	4987	40481087	1972-11-22	1972-11-29	1
54034	3201	260139	1958-08-25	1958-09-01	1
49228	2914	260139	1972-12-25	1973-01-08	1
29243	1733	40481087	2011-12-30	2012-01-13	1
1272	74	260139	1998-12-02	1998-12-16	1
89516	5328	28060	2019-06-17	2019-06-18	1
12757	755	260139	2011-04-01	2011-04-15	1
21305	1280	260139	1975-12-23	1976-01-06	1
74969	4456	40481087	1986-07-04	1986-07-25	1
83862	4987	40481087	1998-12-01	1998-12-22	1
54035	3201	4112343	1971-10-14	1971-10-25	1
49229	2914	260139	1985-07-28	1985-08-04	1
29244	1733	4112343	2008-02-11	2008-02-18	1
1273	74	4027663	2005-12-27	2005-12-28	1
89517	5328	260139	1934-03-01	1934-03-08	1
12758	755	4116491	1995-06-23	1995-07-27	1
21306	1280	440086	1964-06-30	1965-08-31	1
74970	4456	40481087	2018-04-11	2018-04-25	1
83863	4987	378001	1986-02-07	1986-03-09	1
56658	3364	28060	1982-12-05	1982-12-18	1
49230	2914	372328	1958-06-17	1958-09-06	1
29245	1733	4218389	1999-04-20	1999-05-18	1
1274	74	4112343	1989-01-29	1989-02-10	1
89518	5328	260139	1975-12-26	1976-01-09	1
12759	755	4230399	2018-10-14	2019-01-12	1
21307	1280	4112343	1974-11-08	1974-11-16	1
74971	4456	260139	1971-06-11	1971-06-18	1
83864	4987	4112343	1970-07-31	1970-08-11	1
56659	3364	28060	2013-10-18	2013-10-30	1
49231	2914	4112343	1991-01-07	1991-01-17	1
29246	1733	40479422	1989-08-03	1989-10-09	1
1275	74	4266809	2015-08-12	2015-08-13	1
89519	5328	260139	1993-12-17	1993-12-24	1
12760	755	40481087	1947-12-07	1947-12-14	1
21308	1280	4112343	1975-12-15	1975-12-23	1
74972	4456	260139	2003-04-30	2003-05-14	1
83865	4987	4112343	1979-05-29	1979-06-08	1
56660	3364	81893	2007-04-13	2007-04-14	1
49232	2914	4112343	1992-10-09	1992-10-20	1
29247	1733	40481087	2014-02-10	2014-02-17	1
1276	74	28060	1986-02-04	1986-02-11	1
89520	5328	260139	2002-11-18	2002-11-25	1
12761	755	40481087	1996-02-29	1996-03-14	1
21309	1280	4112343	1989-02-26	1989-03-07	1
74973	4456	40481087	1990-05-14	1990-06-04	1
83866	4987	4218389	2016-05-28	2016-06-25	1
56661	3364	372328	1981-10-02	1982-06-10	1
49233	2914	4112343	2019-04-19	2019-04-27	1
30656	1814	260139	1991-05-30	1991-06-06	1
1277	74	260139	1973-09-28	1973-10-12	1
89521	5328	4112343	1922-03-29	1922-04-11	1
12762	755	80180	1991-08-08	1991-08-09	1
21310	1280	4218389	1975-03-05	1975-04-02	1
75461	4484	260139	1976-09-11	1976-09-25	1
83867	4987	40481087	2018-10-17	2018-11-07	1
56662	3364	4027663	2001-06-18	2001-06-19	1
49234	2914	4113008	1991-03-17	1991-04-07	1
30657	1814	260139	1940-12-17	1940-12-24	1
1278	74	372328	2017-08-20	2018-07-25	1
89522	5328	40481087	1920-01-10	1920-01-31	1
12763	755	81151	1950-07-19	1950-08-23	1
21311	1280	4283893	1977-10-07	1977-10-28	1
75462	4484	260139	2011-09-09	2011-09-16	1
83868	4987	28060	1960-12-31	1961-01-07	1
56663	3364	4112343	1980-03-06	1980-03-19	1
49235	2914	4116491	1979-09-25	1979-11-17	1
30658	1814	378001	1968-07-22	1968-09-20	1
1279	74	4152936	2013-08-27	2013-09-10	1
89523	5328	40481087	1953-10-05	1953-10-26	1
12764	755	81151	2010-12-27	2011-01-10	1
21312	1280	40481087	1987-05-03	1987-05-24	1
75463	4484	372328	1958-01-02	1958-08-07	1
83869	4987	78272	2019-06-10	2019-06-11	1
56664	3364	4112343	1993-10-10	1993-10-21	1
51593	3064	81151	1949-02-17	1949-03-03	1
30659	1814	440086	1952-04-17	1958-04-26	1
1280	74	40481087	1979-11-30	1979-12-14	1
89524	5328	40481087	1994-02-22	1994-03-15	1
12765	755	81151	2013-02-28	2013-03-14	1
21313	1280	40481087	1992-02-04	1992-02-25	1
75464	4484	372328	2019-05-11	2019-06-20	1
83870	4987	4112343	2005-07-21	2005-08-02	1
56665	3364	4310024	2007-02-12	2007-02-13	1
51594	3064	372328	1941-04-25	1941-09-18	1
30660	1814	4112343	1958-06-16	1958-06-25	1
1281	74	40481087	2016-12-18	2017-01-01	1
12766	755	4237458	1970-08-08	1970-11-06	1
21314	1280	40481087	2009-05-16	2009-05-30	1
75465	4484	375671	1952-07-09	1952-09-07	1
83871	4987	4112343	2008-09-16	2008-09-25	1
56666	3364	40481087	1982-03-04	1982-03-11	1
51595	3064	440086	1949-09-29	1951-05-17	1
30661	1814	4134304	2009-12-12	2010-02-10	1
1282	74	195588	2003-12-28	2004-02-06	1
12767	755	4278672	1981-07-02	1981-08-01	1
21315	1280	28060	1984-12-07	1984-12-16	1
75466	4484	378001	1972-05-30	1972-06-29	1
83872	4987	4283893	1969-02-07	1969-05-23	1
56667	3364	80180	2009-02-01	2009-02-02	1
51596	3064	4112343	1938-09-19	1938-09-27	1
30662	1814	4237458	1953-07-11	1953-09-09	1
1283	74	260139	2012-07-01	2012-07-15	1
12768	755	4294548	1965-07-21	1965-08-04	1
21316	1280	80180	1988-03-11	1988-03-12	1
75467	4484	4112343	1977-04-20	1977-04-27	1
83873	4987	4296204	2002-03-15	2002-04-12	1
56668	3364	134438	2000-06-25	2001-07-21	1
51597	3064	4112343	2006-06-06	2006-06-15	1
30663	1814	4266809	1981-10-22	1981-10-23	1
1284	74	372328	1977-07-07	1977-10-19	1
12769	755	40481087	1967-06-30	1967-07-14	1
21317	1280	372328	1956-07-07	1956-07-21	1
75468	4484	4112343	1986-03-14	1986-03-26	1
83874	4987	4310024	1995-10-13	1995-10-14	1
56669	3364	4230399	1994-12-01	1995-03-01	1
51598	3064	4112343	2017-10-03	2017-10-10	1
30664	1814	40481087	1973-02-01	1973-02-15	1
1285	74	4112343	1978-03-07	1978-03-18	1
12770	755	40481087	1997-07-08	1997-07-29	1
21318	1280	4109685	2017-04-28	2017-05-12	1
75469	4484	4112343	2000-05-10	2000-05-17	1
83875	4987	40481087	1981-12-19	1981-12-26	1
56670	3364	4285898	2008-07-06	2008-07-07	1
51599	3064	4285898	1975-04-16	1975-04-17	1
30665	1814	28060	2018-02-25	2018-03-06	1
1286	74	4283893	2005-05-07	2005-08-20	1
12771	755	40481087	1998-01-04	1998-01-18	1
21319	1280	40481087	1971-04-26	1971-05-03	1
75470	4484	4112343	2003-05-18	2003-05-31	1
83876	4987	40481087	1995-10-22	1995-11-12	1
56671	3364	4296204	1986-06-02	1986-06-16	1
51600	3064	40481087	2009-03-02	2009-03-16	1
30666	1814	80180	1981-10-22	1981-10-23	1
6942	409	4084167	1951-12-30	1951-12-30	1
12772	755	40481087	1999-04-21	1999-05-12	1
21320	1280	40481087	1972-06-03	1972-06-17	1
75471	4484	28060	2001-01-15	2001-01-24	1
83877	4987	40481087	1996-02-18	1996-03-10	1
56672	3364	40481087	1985-05-02	1985-05-23	1
51601	3064	81151	1936-08-28	1936-10-02	1
30667	1814	134438	1971-04-20	1974-07-06	1
6943	409	4112343	2015-06-11	2015-06-19	1
12773	755	40481087	2015-02-17	2015-03-03	1
21321	1280	40481087	1974-01-13	1974-01-20	1
75472	4484	313217	2017-06-08	2017-06-09	1
84287	5015	260139	1977-11-16	1977-11-30	1
56673	3364	40481087	2017-03-09	2017-03-16	1
51602	3064	81151	1947-01-08	1947-01-29	1
30668	1814	196456	2018-04-03	2018-04-03	1
6944	409	4116491	1991-09-26	1991-11-08	1
12774	755	28060	1975-12-08	1975-12-15	1
25410	1516	81893	1977-02-22	1977-02-23	1
75473	4484	372328	1954-06-29	1954-07-22	1
84288	5015	4112343	1993-05-06	1993-05-14	1
56674	3364	78272	2012-07-29	2012-08-26	1
51603	3064	81151	1997-01-30	1997-03-06	1
30669	1814	372328	1941-09-12	1941-09-26	1
6945	409	4280726	1955-10-12	1993-07-16	1
12775	755	81151	1979-06-22	1979-07-13	1
25411	1516	257012	1949-08-20	1949-08-21	1
75474	4484	4112343	1992-09-05	1992-09-18	1
84289	5015	4112343	2008-08-10	2008-08-18	1
56675	3364	372328	1980-08-02	1981-06-04	1
51604	3064	192671	1975-06-26	1975-06-27	1
30670	1814	372328	1945-02-07	1945-03-31	1
6946	409	4296204	1995-09-10	1995-10-01	1
12776	755	4112343	2006-02-22	2006-03-04	1
25412	1516	4109685	1966-12-23	1967-01-06	1
75475	4484	40481087	1972-02-12	1972-02-19	1
84290	5015	4155034	1982-05-22	1982-06-12	1
56676	3364	4116491	2007-06-17	2007-07-18	1
51605	3064	378001	1944-03-24	1944-05-23	1
30671	1814	4218389	2000-05-05	2000-06-02	1
6947	409	81151	2013-02-19	2013-03-19	1
12777	755	40481087	1993-01-18	1993-02-08	1
25413	1516	4294548	1949-07-02	1949-09-24	1
75476	4484	80180	1986-07-26	1986-07-27	1
84291	5015	4237458	1970-11-21	1971-02-19	1
56677	3364	40481087	2003-01-26	2003-02-02	1
51606	3064	4027663	1965-09-25	1965-09-26	1
30672	1814	4310024	1979-03-07	1979-03-08	1
6948	409	260139	2011-11-17	2011-11-24	1
12778	755	40481087	1996-04-22	1996-05-06	1
25414	1516	40481087	1992-10-05	1992-10-19	1
75477	4484	81151	1966-09-24	1966-10-29	1
84292	5015	40481087	1968-05-12	1968-05-26	1
56678	3364	40481087	2012-08-19	2012-08-26	1
51607	3064	4113008	1990-07-01	1990-07-15	1
30673	1814	40481087	1984-11-22	1984-11-29	1
6949	409	4059173	1980-10-28	1981-01-26	1
12779	755	40481087	2010-05-23	2010-06-06	1
25415	1516	40481087	2003-06-20	2003-07-04	1
75478	4484	260139	1951-11-14	1951-11-21	1
84293	5015	40481087	2017-12-23	2017-12-30	1
56679	3364	260139	1983-09-17	1983-10-01	1
51608	3064	40481087	1937-01-04	1937-01-18	1
30674	1814	40481087	1990-01-07	1990-01-28	1
6950	409	4294548	1994-12-06	1994-12-13	1
12780	755	28060	1953-04-08	1953-04-19	1
25416	1516	0	1956-01-01	1956-01-02	1
75479	4484	4112343	1960-09-26	1960-10-03	1
84294	5015	260139	1991-02-06	1991-02-13	1
56680	3364	4112343	1988-01-24	1988-02-06	1
51609	3064	40481087	1957-01-09	1957-01-23	1
30675	1814	40481087	2000-10-11	2000-11-01	1
6951	409	28060	1968-12-03	1968-12-15	1
12781	755	260139	2004-04-16	2004-04-30	1
25417	1516	378001	1952-01-20	1952-02-19	1
75480	4484	4112343	1989-04-13	1989-04-21	1
84295	5015	372328	1968-04-05	1968-05-13	1
56681	3364	4112343	2011-09-19	2011-09-28	1
51610	3064	40481087	1972-08-11	1972-09-01	1
30676	1814	40481087	2002-10-27	2002-11-10	1
6952	409	4112343	1999-04-11	1999-04-24	1
12782	755	372328	1950-08-18	1950-12-09	1
25418	1516	440448	1956-01-01	1956-01-02	1
75481	4484	4112343	2009-12-27	2010-01-03	1
84296	5015	378001	1985-02-26	1985-04-27	1
57405	3410	28060	1970-10-14	1970-10-23	1
51611	3064	80180	1975-05-16	1975-05-17	1
30677	1814	40481087	2004-07-08	2004-07-22	1
6953	409	4134304	1955-10-10	1955-11-09	1
12783	755	4112343	1965-10-14	1965-10-21	1
25419	1516	4112343	1944-02-15	1944-02-22	1
75482	4484	4112343	2012-02-25	2012-03-03	1
84297	5015	4155034	2010-09-25	2010-10-16	1
57406	3410	81151	1978-02-06	1978-03-06	1
51612	3064	260139	1993-12-29	1994-01-12	1
30678	1814	198809	2018-04-03	2018-04-03	1
6954	409	4156265	2007-01-31	2007-02-21	1
12784	755	4112343	1981-08-18	1981-08-28	1
25420	1516	4112343	1945-12-15	1945-12-28	1
75483	4484	4296205	2003-02-17	2003-03-03	1
84298	5015	40481087	1977-08-11	1977-08-18	1
57407	3410	372328	1966-09-13	1967-03-22	1
51613	3064	260139	1995-01-03	1995-01-10	1
30679	1814	257012	1958-08-31	1958-09-28	1
6955	409	40481087	1966-03-25	1966-04-01	1
12785	755	4112343	2014-01-24	2014-01-31	1
25421	1516	4112343	1958-04-09	1958-04-22	1
75484	4484	40481087	1952-04-19	1952-04-26	1
84299	5015	40481087	2014-03-14	2014-04-04	1
57408	3410	4112343	1967-03-02	1967-03-14	1
51614	3064	372328	1938-08-18	1938-09-08	1
30680	1814	260139	1964-08-21	1964-09-04	1
6956	409	40481087	1997-03-09	1997-03-23	1
12786	755	4278672	2016-01-28	2016-03-28	1
25422	1516	4112343	1971-02-28	1971-03-12	1
75485	4484	40481087	1952-07-04	1952-07-25	1
84300	5015	80180	2006-08-14	2006-08-15	1
57409	3410	4112343	2017-10-11	2017-10-21	1
51615	3064	4152936	1962-05-24	1962-06-07	1
30681	1814	372328	1945-07-29	1946-04-06	1
6957	409	28060	2006-12-14	2006-12-21	1
12787	755	40481087	1965-12-09	1965-12-30	1
25423	1516	4149245	1960-08-05	1960-10-11	1
75486	4484	40481087	1997-02-11	1997-02-25	1
84301	5015	372328	1983-05-10	1984-03-19	1
57410	3410	4116491	1995-04-08	1995-05-29	1
51616	3064	4152936	1980-05-03	1980-05-24	1
30682	1814	4027663	1970-04-13	1970-04-14	1
6958	409	80180	1993-01-13	1993-01-14	1
12788	755	40481087	1978-02-24	1978-03-17	1
25424	1516	4152936	2000-04-24	2000-05-08	1
75487	4484	40481087	2007-04-05	2007-04-19	1
84302	5015	4112343	1994-09-07	1994-09-19	1
57411	3410	40481087	1979-06-03	1979-06-24	1
51617	3064	4266809	1975-05-16	1975-05-17	1
30683	1814	4112343	1990-11-05	1990-11-18	1
6959	409	4237458	1965-05-20	1965-06-19	1
12789	755	40481087	1988-05-01	1988-05-08	1
25425	1516	4156265	1967-12-02	1967-12-23	1
75488	4484	40481087	2013-03-25	2013-04-15	1
84303	5015	4152936	2002-05-19	2002-06-09	1
57412	3410	40481087	1984-06-02	1984-06-09	1
51618	3064	4278672	1971-10-18	1971-12-17	1
30684	1814	4237458	1949-09-30	1949-11-29	1
6960	409	40481087	1973-05-03	1973-05-24	1
13534	800	378001	1962-03-19	1962-04-18	1
25426	1516	4310024	1977-01-23	1977-01-24	1
75489	4484	260139	1986-03-23	1986-04-06	1
84304	5015	40481087	1970-03-25	1970-04-15	1
57413	3410	80180	2002-06-20	2002-06-21	1
51619	3064	40481087	1947-10-31	1947-11-21	1
30685	1814	4283893	1958-07-20	1958-09-28	1
6961	409	40481087	2013-06-04	2013-06-18	1
13535	800	4112343	1982-07-01	1982-07-09	1
25427	1516	40481087	1948-10-05	1948-10-26	1
75490	4484	372328	1960-12-24	1961-10-12	1
84305	5015	28060	1969-04-02	1969-04-10	1
57414	3410	260139	2007-02-01	2007-02-08	1
51620	3064	40481087	1992-07-21	1992-08-04	1
30686	1814	40481087	1969-04-11	1969-04-18	1
8480	495	28060	1979-01-18	1979-01-25	1
13536	800	4155034	1996-07-30	1996-08-20	1
25428	1516	40481087	1975-03-18	1975-03-25	1
75491	4484	4112343	1963-09-21	1963-09-28	1
84306	5015	372328	1971-02-27	1971-07-12	1
57415	3410	372328	1964-08-13	1964-09-23	1
51621	3064	40481087	1999-03-06	1999-03-20	1
35005	2080	28060	1984-01-20	1984-01-29	1
8481	495	4112343	1979-07-25	1979-08-01	1
13537	800	40481087	2003-08-19	2003-09-09	1
25429	1516	40481087	1993-09-19	1993-10-03	1
75492	4484	40481087	1962-02-12	1962-02-26	1
84307	5015	4113008	1991-04-26	1991-05-17	1
57416	3410	4112343	1993-08-06	1993-08-17	1
51622	3064	81893	1974-09-18	1974-09-19	1
35006	2080	4112343	2019-01-15	2019-01-26	1
8482	495	4283893	1988-11-02	1989-03-01	1
13538	800	80180	1994-07-09	1994-07-10	1
25430	1516	81151	1968-10-18	1968-11-08	1
75493	4484	40481087	1970-08-22	1970-09-12	1
86958	5185	28060	1949-10-25	1949-11-07	1
57417	3410	4156265	1965-05-10	1965-05-31	1
51623	3064	375671	1984-01-04	1984-02-03	1
35007	2080	4155034	2009-08-24	2009-09-07	1
8483	495	40481087	1990-05-03	1990-05-17	1
13539	800	81151	1984-02-22	1984-03-28	1
25431	1516	260139	1984-04-18	1984-05-02	1
75494	4484	40481087	1992-04-09	1992-04-30	1
86959	5185	372328	2009-09-06	2009-12-07	1
57418	3410	40481087	1979-04-05	1979-04-26	1
51624	3064	4112343	2015-11-27	2015-12-09	1
35008	2080	4283893	2000-07-05	2000-09-20	1
8484	495	40481087	2018-09-27	2018-10-18	1
13540	800	260139	1973-06-21	1973-06-28	1
25432	1516	260139	1988-11-02	1988-11-09	1
75495	4484	40481087	2005-02-18	2005-03-11	1
86960	5185	378419	2009-12-07	2009-12-08	1
57419	3410	40481087	2009-03-06	2009-03-27	1
51625	3064	4218389	1993-03-01	1993-03-22	1
35009	2080	40481087	1984-03-24	1984-04-07	1
8485	495	260139	1998-12-08	1998-12-22	1
13541	800	375671	1979-04-19	1979-05-19	1
25433	1516	378419	2007-04-23	2007-04-24	1
78305	4642	260139	1965-10-05	1965-10-12	1
86961	5185	4112343	2011-07-04	2011-07-13	1
57420	3410	28060	1980-07-03	1980-07-14	1
51626	3064	40481087	1985-08-01	1985-08-22	1
35010	2080	40481087	1990-01-13	1990-01-20	1
8486	495	372328	1969-08-11	1969-10-25	1
13542	800	4112343	2008-08-25	2008-09-04	1
25434	1516	4027663	1968-12-26	1968-12-27	1
78306	4642	260139	1984-09-09	1984-09-23	1
86962	5185	40481087	2012-12-13	2012-12-27	1
57421	3410	81151	1973-03-20	1973-04-03	1
52597	3118	80180	1985-12-21	1985-12-22	1
35011	2080	40481087	2006-11-08	2006-11-29	1
8487	495	375671	1998-02-01	1998-03-03	1
13543	800	40481087	1998-06-04	1998-06-11	1
25435	1516	4112343	1982-06-15	1982-06-22	1
78307	4642	4084167	1957-06-05	1957-06-06	1
86963	5185	260139	1993-01-01	1993-01-15	1
57422	3410	260139	2018-03-14	2018-03-21	1
52598	3118	372328	1949-11-30	1950-02-12	1
35012	2080	81151	2000-11-11	2000-12-09	1
8488	495	4112343	1978-03-13	1978-03-22	1
13544	800	28060	2013-03-15	2013-03-23	1
25436	1516	4283893	1991-10-24	1991-12-05	1
78308	4642	4112343	1960-10-16	1960-10-25	1
86964	5185	321042	1961-11-13	1961-11-14	1
57423	3410	4112343	1969-04-05	1969-04-18	1
52599	3118	372328	1952-07-05	1952-09-07	1
35013	2080	257012	2000-07-26	2000-07-27	1
8489	495	40481087	1982-04-25	1982-05-16	1
13545	800	4112343	1965-02-04	1965-02-14	1
25437	1516	40481087	1953-07-14	1953-08-04	1
78309	4642	4112343	2008-01-18	2008-01-28	1
86965	5185	4112343	1950-07-09	1950-07-17	1
57424	3410	40481087	1985-11-06	1985-11-20	1
52600	3118	372328	1953-12-01	1954-09-19	1
35014	2080	4112343	2008-11-14	2008-11-22	1
8490	495	81151	1971-03-04	1971-03-25	1
13546	800	4112343	1979-02-05	1979-02-13	1
25438	1516	40481087	1975-12-26	1976-01-09	1
78310	4642	40481087	1991-10-14	1991-11-04	1
86966	5185	4112343	1955-03-26	1955-04-04	1
57425	3410	40481087	1996-05-03	1996-05-17	1
52601	3118	4230399	1964-04-06	1964-06-05	1
35015	2080	4237458	1989-02-21	1989-05-22	1
8491	495	257012	1989-01-04	1989-01-05	1
13547	800	4134304	1980-03-14	1980-05-13	1
25439	1516	40481087	2005-07-31	2005-08-21	1
78311	4642	40481087	2000-07-07	2000-07-14	1
86967	5185	4112343	1964-11-16	1964-11-24	1
57426	3410	40481087	1999-04-08	1999-04-22	1
52602	3118	40481087	1966-05-09	1966-05-16	1
35016	2080	4278672	1993-03-23	1993-06-21	1
8492	495	4027663	1994-05-12	1994-05-13	1
13548	800	372328	1958-05-09	1959-05-10	1
25440	1516	28060	1959-04-21	1959-04-29	1
78312	4642	133834	1955-10-18	1970-01-02	1
86968	5185	4112343	1999-10-06	1999-10-18	1
59268	3518	0	2016-03-17	2016-03-18	1
54840	3249	80180	2002-02-18	2002-02-19	1
35017	2080	40481087	2001-05-24	2001-05-31	1
8493	495	4112343	1975-03-15	1975-03-26	1
13549	800	372328	1970-06-11	1970-07-12	1
25441	1516	80180	1979-07-12	1979-07-13	1
78313	4642	260139	1962-05-08	1962-05-22	1
86969	5185	4112343	2010-05-25	2010-06-07	1
59269	3518	81151	1981-09-29	1981-11-03	1
54841	3249	260139	2001-08-10	2001-08-17	1
35018	2080	80180	2019-05-20	2019-05-21	1
8494	495	4112343	1991-12-28	1992-01-07	1
13550	800	4149245	1994-06-04	1994-08-10	1
25442	1516	80502	1998-03-02	1998-03-03	1
78314	4642	372328	1956-12-04	1957-11-05	1
86970	5185	4112343	2015-04-07	2015-04-19	1
59270	3518	260139	2006-11-16	2006-11-23	1
54842	3249	372328	1973-06-16	1973-08-26	1
35019	2080	4051466	1982-10-18	1999-01-25	1
8495	495	4112343	2009-05-25	2009-06-05	1
13551	800	4296204	2010-02-08	2010-03-01	1
25443	1516	255848	2015-06-10	2015-06-11	1
78315	4642	40481087	1965-11-22	1965-12-13	1
86971	5185	4156265	1949-08-01	1949-08-15	1
59271	3518	260139	2018-08-24	2018-08-31	1
54843	3249	4112343	2012-12-22	2013-01-03	1
35020	2080	260139	2009-04-09	2009-04-23	1
8496	495	4266809	2005-06-28	2005-06-29	1
13552	800	40481087	1970-12-08	1970-12-22	1
25444	1516	260139	1952-10-17	1952-10-24	1
78316	4642	40481087	1988-02-05	1988-02-26	1
86972	5185	40481087	1943-05-15	1943-05-22	1
59272	3518	4112343	1983-02-12	1983-02-21	1
54844	3249	40481087	1967-11-09	1967-11-30	1
35021	2080	4109685	1992-02-06	1992-02-27	1
8497	495	40481087	1980-07-20	1980-07-27	1
13553	800	40481087	2004-09-10	2004-09-17	1
25445	1516	260139	1979-05-07	1979-05-14	1
78317	4642	40481087	1994-07-27	1994-08-10	1
86973	5185	40481087	1943-11-27	1943-12-04	1
59273	3518	40479422	1978-09-08	1978-10-15	1
54845	3249	40481087	1984-10-13	1984-10-20	1
35022	2080	4112343	1985-12-21	1986-01-02	1
8498	495	40481087	1990-11-20	1990-11-27	1
13554	800	40481087	2014-01-07	2014-01-14	1
25446	1516	4035415	1982-09-26	1982-10-26	1
78318	4642	372328	1958-10-01	1958-11-11	1
86974	5185	40481087	1950-09-05	1950-09-19	1
59274	3518	260139	2014-06-29	2014-07-06	1
54846	3249	40481087	2006-05-06	2006-05-20	1
35023	2080	4112343	1990-06-12	1990-06-19	1
8499	495	80180	2005-06-28	2005-06-29	1
16101	954	195588	1997-04-08	1997-05-20	1
25447	1516	4112343	1938-04-07	1938-04-16	1
78319	4642	40481087	1994-09-18	1994-10-02	1
86975	5185	40481087	1957-06-21	1957-06-28	1
59275	3518	440448	2016-03-17	2016-03-18	1
54847	3249	40481087	2015-09-06	2015-09-13	1
35024	2080	4112343	2013-11-27	2013-12-08	1
8500	495	81893	2004-04-04	2004-04-05	1
16102	954	4113008	2007-04-08	2007-04-29	1
25448	1516	4112343	1948-06-17	1948-06-28	1
78320	4642	40481087	2016-07-18	2016-08-01	1
86976	5185	40481087	1973-10-14	1973-11-04	1
59276	3518	4112343	1963-02-05	1963-02-15	1
54848	3249	372328	1959-06-12	1959-12-20	1
35938	2134	260139	1955-04-15	1955-04-22	1
8501	495	260139	2006-01-22	2006-01-29	1
16103	954	28060	1978-03-06	1978-03-14	1
25449	1516	4156265	1961-08-07	1961-08-21	1
78321	4642	80180	1991-11-06	1991-11-07	1
86977	5185	28060	2014-10-27	2014-11-04	1
59277	3518	4112343	1984-03-20	1984-03-31	1
54849	3249	372328	1972-03-16	1972-08-20	1
35939	2134	440448	1997-09-01	1997-09-02	1
8502	495	4112343	1998-04-09	1998-04-21	1
16104	954	80180	2015-12-15	2015-12-16	1
25450	1516	40481087	1948-03-16	1948-03-30	1
78322	4642	81151	1979-02-07	1979-03-14	1
86978	5185	80180	1968-09-20	1968-09-21	1
59278	3518	40481087	1961-10-16	1961-11-06	1
54850	3249	440086	1967-07-12	1967-08-09	1
35940	2134	4112343	1993-10-04	1993-10-15	1
8503	495	4152936	2001-10-13	2001-11-03	1
16105	954	81151	1976-03-04	1976-04-01	1
25451	1516	40481087	1955-08-31	1955-09-21	1
78323	4642	4084167	1953-08-22	1953-08-23	1
86979	5185	255848	2019-02-18	2019-02-19	1
59279	3518	40481087	2006-10-20	2006-11-10	1
54851	3249	4059173	1999-09-14	1999-10-14	1
35941	2134	40481087	1959-08-26	1959-09-16	1
8504	495	40481087	1987-11-22	1987-11-29	1
16106	954	4112343	2006-03-24	2006-04-06	1
25452	1516	40481087	1966-02-03	1966-02-10	1
78324	4642	4112343	1971-07-04	1971-07-12	1
86980	5185	257012	1969-06-04	1969-06-05	1
59280	3518	28060	1987-05-16	1987-05-26	1
54852	3249	4112343	1958-03-12	1958-03-22	1
35942	2134	40481087	1980-11-10	1980-11-24	1
8505	495	40481087	2017-04-16	2017-04-30	1
16107	954	28060	1994-04-14	1994-04-25	1
25453	1516	40481087	1972-12-14	1972-12-21	1
78325	4642	4112343	1985-12-27	1986-01-09	1
86981	5185	260139	1965-09-17	1965-09-24	1
59281	3518	78272	1967-06-12	1967-07-10	1
54853	3249	4112343	1963-03-05	1963-03-15	1
35943	2134	40481087	1982-04-24	1982-05-15	1
11451	677	4109685	2016-11-11	2016-11-25	1
16108	954	260139	1978-12-21	1978-12-28	1
28697	1702	80180	2008-10-07	2008-10-08	1
78326	4642	40481087	1976-07-25	1976-08-01	1
86982	5185	260139	2012-03-23	2012-03-30	1
59282	3518	80180	1994-03-12	1994-03-13	1
54854	3249	4112343	1983-02-22	1983-03-01	1
35944	2134	40481087	2007-09-20	2007-10-04	1
11452	677	4112343	2018-01-01	2018-01-10	1
16109	954	372328	1974-05-14	1974-07-21	1
28698	1702	372328	1965-11-26	1966-01-09	1
78327	4642	40481087	2009-10-03	2009-10-17	1
86983	5185	4112343	1983-01-22	1983-01-30	1
59283	3518	4112343	1982-10-05	1982-10-14	1
54855	3249	4112343	1990-04-27	1990-05-09	1
35945	2134	0	1997-09-01	1997-09-02	1
11453	677	4156265	1982-01-23	1982-02-13	1
16110	954	372328	1976-03-12	1976-09-19	1
28699	1702	4112343	1967-04-22	1967-05-03	1
80702	4792	80180	1988-10-27	1988-10-28	1
86984	5185	4142905	2010-09-22	2010-11-21	1
59284	3518	4310024	1992-04-21	1992-04-22	1
54856	3249	4142905	2008-02-29	2008-03-30	1
35946	2134	260139	2013-11-14	2013-11-21	1
11454	677	40481087	1968-12-13	1969-01-03	1
16111	954	372328	1979-11-03	1980-03-30	1
28700	1702	4112343	1975-11-30	1975-12-12	1
80703	4792	260139	1962-10-30	1962-11-06	1
86985	5185	4149245	2000-01-04	2000-03-11	1
59285	3518	40481087	1970-02-16	1970-03-09	1
54857	3249	4156265	1988-07-01	1988-07-15	1
35947	2134	381316	2017-04-02	2017-04-03	1
11455	677	40481087	1992-10-19	1992-11-02	1
16112	954	4112343	1984-03-16	1984-03-23	1
28701	1702	4112343	1978-05-03	1978-05-14	1
80704	4792	4035415	1988-01-01	1988-01-31	1
86986	5185	4237458	1989-01-01	1989-04-01	1
59286	3518	40481087	1995-11-24	1995-12-08	1
54858	3249	40481087	1960-10-01	1960-10-15	1
35948	2134	4112343	1983-08-18	1983-08-27	1
11456	677	80180	1997-01-09	1997-01-10	1
16113	954	40481087	1975-11-12	1975-11-26	1
28702	1702	4112343	1983-12-14	1983-12-21	1
80705	4792	4112343	2012-04-26	2012-05-06	1
86987	5185	4283893	1969-04-23	1969-07-30	1
59287	3518	81151	1968-08-03	1968-08-17	1
54859	3249	40481087	1964-03-07	1964-03-21	1
35949	2134	4112343	2007-04-09	2007-04-21	1
11457	677	372328	1965-03-13	1965-05-07	1
16114	954	40481087	1980-04-12	1980-04-26	1
28703	1702	4155034	2016-08-22	2016-09-05	1
80706	4792	4116491	1981-04-21	1981-05-29	1
86988	5185	40481087	1992-10-31	1992-11-21	1
59288	3518	4027663	1987-03-24	1987-03-25	1
54860	3249	40481087	1974-03-06	1974-03-13	1
35950	2134	4285898	1987-12-21	1987-12-22	1
11458	677	4112343	1962-01-31	1962-02-11	1
16115	954	40481087	1989-04-15	1989-04-29	1
28704	1702	40481087	1973-01-17	1973-02-07	1
80707	4792	4283893	1956-03-24	1956-05-12	1
86989	5185	40481087	1996-01-11	1996-01-25	1
59289	3518	4152936	1974-11-14	1974-11-28	1
54861	3249	40481087	1974-09-17	1974-10-08	1
35951	2134	40481087	1983-10-12	1983-11-02	1
11459	677	40481087	1965-08-11	1965-08-25	1
16116	954	40481087	2005-11-06	2005-11-20	1
28705	1702	378001	1967-11-16	1967-12-16	1
80708	4792	40481087	1993-11-16	1993-11-30	1
86990	5185	40481087	2002-12-24	2002-12-31	1
59290	3518	4266809	1994-03-12	1994-03-13	1
54862	3249	28060	2000-06-19	2000-06-27	1
35952	2134	40481087	1991-08-29	1991-09-05	1
11460	677	4218389	1977-09-11	1977-10-16	1
16117	954	81151	1997-11-28	1997-12-26	1
28706	1702	4112343	1967-10-03	1967-10-16	1
80709	4792	40481087	2013-09-08	2013-09-22	1
86991	5185	0	1961-11-13	1961-11-14	1
59291	3518	4285898	1993-10-13	1993-10-14	1
54863	3249	28060	2008-02-04	2008-02-15	1
35953	2134	260139	1978-08-21	1978-09-04	1
11461	677	40481087	1975-05-02	1975-05-23	1
16118	954	372328	1981-09-21	1982-04-11	1
28707	1702	4112343	1973-05-04	1973-05-11	1
80710	4792	28060	1951-06-17	1951-06-25	1
86992	5185	28060	1936-05-13	1936-05-21	1
59292	3518	40481087	1968-05-08	1968-05-22	1
54864	3249	81151	1998-08-22	1998-09-19	1
35954	2134	260139	2014-09-19	2014-10-03	1
11462	677	40481087	1987-05-28	1987-06-11	1
16119	954	4112343	1975-04-11	1975-04-19	1
28708	1702	4112343	2015-04-04	2015-04-13	1
80711	4792	260139	1996-10-09	1996-10-16	1
86993	5185	28060	1948-06-19	1948-07-01	1
59293	3518	40481087	1977-12-06	1977-12-20	1
54865	3249	372328	1957-08-13	1957-10-20	1
35955	2134	372328	1951-07-03	1951-08-19	1
11463	677	40481087	1988-01-14	1988-02-04	1
16120	954	4112343	1985-12-15	1985-12-26	1
28709	1702	40481087	1968-03-23	1968-04-06	1
80712	4792	260139	2000-12-10	2000-12-17	1
86994	5185	260139	1955-03-05	1955-03-12	1
59426	3528	0	1958-11-03	1958-11-04	1
54866	3249	375671	1983-07-28	1983-08-27	1
35956	2134	378001	1981-03-27	1981-04-26	1
11464	677	28060	1972-03-22	1972-03-31	1
16121	954	4112343	2017-02-10	2017-02-19	1
28710	1702	40481087	1980-12-05	1980-12-19	1
80713	4792	4059173	1969-03-11	1969-04-10	1
86995	5185	372328	1938-06-30	1938-09-19	1
59427	3528	80180	1998-03-13	1998-03-14	1
54867	3249	4112343	1966-04-02	1966-04-10	1
35957	2134	378001	1989-01-14	1989-02-13	1
11465	677	78272	1967-03-03	1967-04-07	1
16122	954	4155034	1983-01-25	1983-02-15	1
28711	1702	28060	1970-08-05	1970-08-15	1
80714	4792	4112343	1978-11-17	1978-11-24	1
86996	5185	4149245	2002-11-26	2003-01-02	1
59428	3528	4059173	2015-05-04	2015-06-03	1
54868	3249	4112343	1967-02-06	1967-02-13	1
35958	2134	4027663	1980-09-03	1980-09-04	1
11466	677	40481087	1964-09-22	1964-10-06	1
16432	972	28060	1987-08-11	1987-08-21	1
28712	1702	260139	1967-09-20	1967-10-04	1
80715	4792	4283893	2004-01-05	2004-02-02	1
86997	5185	4152936	1956-07-09	1956-07-23	1
59429	3528	4112343	1963-10-12	1963-10-23	1
54869	3249	4112343	2004-09-08	2004-09-19	1
35959	2134	4112343	2010-02-05	2010-02-17	1
11467	677	40481087	1970-03-07	1970-03-21	1
16433	972	4048695	2016-01-10	2016-03-11	1
28713	1702	260139	2003-09-25	2003-10-04	1
80716	4792	40481087	1989-06-25	1989-07-16	1
86998	5185	40481087	1936-01-20	1936-02-03	1
59430	3528	4112343	1991-10-16	1991-10-23	1
54870	3249	40481087	1978-09-22	1978-10-06	1
35960	2134	4146173	2006-03-14	2006-05-13	1
12203	723	30753	2004-06-22	2004-06-23	1
16434	972	40481087	2005-04-12	2005-04-26	1
28714	1702	4112343	2011-04-01	2011-04-14	1
80717	4792	40481087	1992-11-06	1992-11-13	1
86999	5185	40481087	1939-03-25	1939-04-01	1
59431	3528	40481087	2005-05-29	2005-06-05	1
54871	3249	40481087	1997-12-16	1997-12-23	1
35961	2134	4310024	1986-04-30	1986-05-01	1
12204	723	78272	1961-10-06	1961-10-20	1
16435	972	28060	2012-03-07	2012-03-20	1
28715	1702	4112343	2013-03-05	2013-03-14	1
80718	4792	40481087	1997-04-20	1997-05-04	1
87000	5185	40481087	1965-05-23	1965-06-06	1
59432	3528	40481087	2014-08-23	2014-09-06	1
54872	3249	40481087	2001-07-12	2001-07-26	1
35962	2134	40481087	1959-12-20	1960-01-10	1
12205	723	195588	1997-11-01	1997-12-10	1
16436	972	260139	2008-09-20	2008-10-04	1
28716	1702	40481087	1996-10-06	1996-10-13	1
80719	4792	40481087	2007-11-09	2007-11-30	1
87001	5185	40481087	2013-02-04	2013-02-25	1
59433	3528	260139	1961-12-19	1962-01-02	1
54873	3249	40481087	2016-01-19	2016-02-02	1
35963	2134	40481087	1960-11-25	1960-12-16	1
12206	723	260139	1969-07-28	1969-08-04	1
16437	972	372328	1971-04-25	1971-05-09	1
28717	1702	4109685	1976-09-30	1976-10-21	1
80720	4792	257012	1956-04-28	1956-04-29	1
87002	5185	40481087	2014-07-27	2014-08-03	1
54874	3249	260139	1962-09-17	1962-09-24	1
35964	2134	40481087	1963-02-09	1963-03-02	1
12207	723	4112343	2018-02-20	2018-03-05	1
16438	972	4112343	1998-12-23	1999-01-04	1
28718	1702	4142905	1979-07-08	1979-10-06	1
80721	4792	4112343	1993-08-23	1993-08-31	1
87003	5185	40481087	2019-02-17	2019-02-18	1
54875	3249	375671	2005-12-11	2006-01-10	1
35965	2134	30753	1987-03-26	1987-03-27	1
12208	723	4142905	1966-12-23	1967-03-23	1
16439	972	4142905	1974-01-20	1974-04-20	1
28719	1702	40481087	2000-05-04	2000-05-18	1
80722	4792	4294548	1953-08-10	1953-08-31	1
54673	3240	80180	1981-08-07	1981-08-08	1
54876	3249	4112343	1959-12-13	1959-12-20	1
35966	2134	80180	1988-02-19	1988-02-20	1
12209	723	40481087	1966-10-17	1966-10-31	1
16440	972	40481087	2014-09-15	2014-10-06	1
29411	1744	260139	1999-01-09	1999-01-23	1
80723	4792	81151	1990-09-17	1990-10-22	1
54674	3240	260139	1990-12-30	1991-01-06	1
58489	3470	4152936	1971-10-28	1971-11-11	1
35967	2134	81893	1986-11-26	1986-11-27	1
12210	723	260139	1990-10-25	1990-11-01	1
16441	972	372328	1967-01-27	1967-05-10	1
29412	1744	4109685	2007-07-04	2007-07-18	1
80724	4792	195588	1979-03-14	1979-04-22	1
54675	3240	260139	1992-10-28	1992-11-11	1
58490	3470	40481087	1981-12-05	1981-12-12	1
35968	2134	260139	1997-02-08	1997-02-22	1
12211	723	4027663	1993-11-02	1993-11-03	1
16442	972	372328	1968-07-03	1968-11-06	1
29413	1744	4156265	1990-07-12	1990-08-02	1
80725	4792	260139	1950-05-21	1950-06-04	1
54676	3240	372328	1948-06-28	1948-12-29	1
58491	3470	28060	1962-06-19	1962-06-28	1
35969	2134	4218389	2000-08-14	2000-09-11	1
12212	723	4112343	2014-02-25	2014-03-09	1
16443	972	375671	2017-02-04	2017-03-06	1
29414	1744	40481087	1997-03-08	1997-03-22	1
80726	4792	260139	2013-11-10	2013-11-17	1
54677	3240	4059173	1951-05-27	1951-08-25	1
58492	3470	78272	2013-01-23	2013-02-06	1
35970	2134	4266809	1988-02-19	1988-02-20	1
12213	723	4230399	2013-12-21	2014-02-19	1
16444	972	40481087	1970-04-03	1970-04-10	1
29415	1744	40481087	2011-05-13	2011-06-03	1
80727	4792	381316	1974-11-05	1974-11-06	1
54678	3240	4112343	2006-07-19	2006-07-31	1
58493	3470	260139	1980-10-18	1980-11-01	1
35971	2134	40481087	1960-02-15	1960-02-22	1
12214	723	4285898	2004-08-21	2004-08-22	1
16445	972	40481087	2015-12-07	2015-12-28	1
29416	1744	80180	2010-08-06	2010-08-07	1
80728	4792	4112343	1978-05-07	1978-05-17	1
54679	3240	78272	2015-07-07	2015-07-21	1
58494	3470	260139	2008-12-20	2008-12-27	1
35972	2134	40481087	1967-03-16	1967-03-23	1
12215	723	28060	2011-08-17	2011-08-29	1
16446	972	28060	1999-07-04	1999-07-13	1
29417	1744	260139	1980-05-06	1980-05-13	1
80729	4792	4112343	1988-06-06	1988-06-18	1
54680	3240	257012	1949-04-17	1949-04-18	1
58495	3470	4112343	1999-08-16	1999-08-26	1
35973	2134	40481087	1967-07-29	1967-08-12	1
12216	723	80180	2005-01-18	2005-01-19	1
16447	972	80180	2002-06-12	2002-06-13	1
29418	1744	4112343	2006-11-13	2006-11-22	1
80730	4792	4152936	2017-04-03	2017-04-24	1
54681	3240	260139	2006-07-10	2006-07-24	1
58496	3470	4112343	2012-08-01	2012-08-10	1
40476	2409	4112343	1992-12-30	1993-01-07	1
12217	723	81151	1990-09-02	1990-09-23	1
16448	972	381316	2019-01-30	2019-01-31	1
29419	1744	4237458	2010-06-02	2010-08-01	1
80731	4792	40481087	2005-11-28	2005-12-12	1
54682	3240	372328	1947-09-15	1947-12-31	1
58497	3470	4113008	1988-09-12	1988-10-03	1
40477	2409	4116491	2007-09-24	2007-11-11	1
12218	723	260139	2017-08-12	2017-08-26	1
16449	972	40481087	1969-08-23	1969-08-30	1
29420	1744	40481087	1992-10-04	1992-10-25	1
81071	4814	80502	2016-08-15	2016-08-16	1
54683	3240	378001	1967-03-18	1967-05-17	1
58498	3470	40481087	1957-04-23	1957-05-07	1
40478	2409	28060	2017-04-10	2017-04-22	1
12219	723	4112343	2011-10-29	2011-11-05	1
16450	972	40481087	1999-06-14	1999-07-05	1
29421	1744	260139	1993-02-15	1993-03-01	1
81072	4814	81151	1953-09-28	1953-10-26	1
54684	3240	381316	2008-10-08	2008-10-09	1
58499	3470	40481087	1978-08-04	1978-08-18	1
40479	2409	81151	1989-07-05	1989-07-19	1
12220	723	4113008	1984-10-19	1984-11-02	1
18781	1132	80180	1993-09-11	1993-09-12	1
29422	1744	260139	2014-10-20	2014-11-03	1
81073	4814	4109685	1946-01-03	1946-01-17	1
54685	3240	4112343	1975-05-06	1975-05-17	1
58500	3470	28060	1967-05-06	1967-05-19	1
40480	2409	195588	2013-11-09	2013-12-23	1
12221	723	4266809	2005-01-18	2005-01-19	1
18782	1132	4112343	1959-05-05	1959-05-15	1
29423	1744	4112343	2016-12-03	2016-12-16	1
81074	4814	40481087	1995-07-20	1995-08-10	1
54686	3240	40481087	1962-04-23	1962-04-30	1
58501	3470	80180	1999-02-08	1999-02-09	1
40481	2409	40481087	1983-07-12	1983-07-19	1
12222	723	40481087	2001-06-06	2001-06-27	1
18783	1132	40481087	1968-07-19	1968-08-09	1
29424	1744	4237458	1981-09-27	1981-10-27	1
81075	4814	40481087	2002-05-12	2002-05-26	1
54687	3240	40481087	1970-12-14	1971-01-04	1
58502	3470	260139	2009-03-29	2009-04-05	1
40482	2409	260139	2002-12-16	2002-12-23	1
15021	886	28060	1992-07-06	1992-07-18	1
18784	1132	30753	1992-04-19	1992-04-20	1
29425	1744	28060	1994-05-24	1994-06-05	1
81076	4814	80180	1981-10-17	1981-10-18	1
54688	3240	40481087	1979-08-24	1979-09-07	1
58503	3470	378001	2008-02-19	2008-03-20	1
40483	2409	260139	2013-06-27	2013-07-04	1
15022	886	81151	1989-01-03	1989-01-17	1
18785	1132	260139	1998-03-10	1998-03-17	1
29426	1744	260139	1999-08-10	1999-08-24	1
81077	4814	260139	2000-05-07	2000-05-14	1
54689	3240	28060	1970-12-16	1970-12-25	1
58504	3470	4112343	2001-01-20	2001-01-28	1
40484	2409	4112343	1996-09-19	1996-09-28	1
15023	886	4112343	1984-09-30	1984-10-12	1
18786	1132	260139	2010-04-24	2010-05-01	1
29427	1744	4112343	1996-06-27	1996-07-07	1
81078	4814	372328	1960-05-04	1961-06-19	1
54690	3240	81151	1976-08-11	1976-09-08	1
58505	3470	4155034	1991-10-18	1991-11-08	1
40485	2409	4112343	2001-03-10	2001-03-18	1
15024	886	4112343	1998-04-17	1998-04-28	1
18787	1132	372328	1983-03-04	1984-07-16	1
32687	1945	28060	2007-10-22	2007-11-01	1
81079	4814	4296204	2010-12-13	2010-12-27	1
54691	3240	260139	2010-09-09	2010-09-16	1
58506	3470	4283893	1975-11-05	1976-02-11	1
40486	2409	4237458	2011-01-25	2011-04-25	1
15025	886	40481087	1988-08-17	1988-09-07	1
18788	1132	378001	1964-07-12	1964-08-11	1
32688	1945	80180	2007-06-08	2007-06-09	1
81080	4814	40481087	1939-08-01	1939-08-15	1
54692	3240	4109685	1963-02-23	1963-03-09	1
58507	3470	4294548	1986-07-25	1986-10-03	1
40487	2409	4278672	1986-07-21	1986-10-19	1
15026	886	40481087	1991-11-30	1991-12-14	1
18789	1132	4027663	1982-04-27	1982-04-28	1
32689	1945	40481087	2008-08-24	2008-08-31	1
81081	4814	40481087	1942-01-06	1942-01-27	1
54693	3240	4283893	1976-08-13	1976-11-05	1
58508	3470	257012	1976-01-14	1976-01-15	1
40488	2409	80180	2018-10-06	2018-10-07	1
15027	886	260139	1995-11-29	1995-12-06	1
18790	1132	4112343	1990-12-02	1990-12-11	1
32690	1945	40481087	2013-01-12	2013-02-02	1
81082	4814	28060	1936-12-11	1936-12-18	1
54694	3240	4296204	2000-02-05	2000-02-26	1
58509	3470	260139	1969-04-12	1969-04-19	1
40489	2409	260139	1993-11-12	1993-11-26	1
15028	886	260139	2016-02-17	2016-02-26	1
18791	1132	4112343	2016-02-14	2016-02-21	1
32691	1945	372328	1972-08-02	1972-11-04	1
81083	4814	4112343	1947-06-29	1947-07-06	1
54695	3240	40481087	1969-03-03	1969-03-17	1
58510	3470	4112343	1979-12-16	1979-12-28	1
40490	2409	260139	2008-06-14	2008-06-21	1
15029	886	372328	1985-09-21	1986-03-11	1
18792	1132	4116491	1984-04-26	1984-06-16	1
32692	1945	4112343	2007-06-09	2007-06-21	1
81084	4814	4112343	1955-12-25	1956-01-06	1
54696	3240	40481087	1977-01-13	1977-01-27	1
58511	3470	4149245	1998-08-03	1998-10-09	1
40491	2409	4048695	2019-04-13	2019-06-14	1
15030	886	40481087	2019-06-15	2019-06-16	1
18793	1132	40479768	1963-04-12	1963-06-18	1
32693	1945	4113008	1985-01-13	1985-02-03	1
81085	4814	4112343	1965-04-21	1965-05-01	1
54697	3240	40481087	2006-11-21	2006-11-28	1
60397	3576	257012	2013-02-24	2013-02-25	1
40492	2409	4112343	1982-02-16	1982-02-24	1
15031	886	80180	2018-06-15	2018-06-16	1
18794	1132	40481087	2015-10-27	2015-11-03	1
32694	1945	40481087	1973-07-21	1973-08-11	1
81086	4814	4112343	1981-11-05	1981-11-17	1
54698	3240	372328	1951-01-18	1952-01-09	1
60398	3576	260139	1992-03-25	1992-04-01	1
40493	2409	4112343	2016-01-02	2016-01-14	1
15032	886	260139	1998-11-19	1998-12-03	1
18795	1132	260139	1972-08-23	1972-08-30	1
32695	1945	40481087	1979-12-13	1980-01-03	1
81087	4814	4152936	1970-07-29	1970-08-19	1
54699	3240	4112343	2005-05-11	2005-05-24	1
60399	3576	4109685	1991-04-04	1991-04-25	1
40494	2409	40481087	1984-03-22	1984-04-05	1
15033	886	378001	1993-07-25	1993-08-24	1
18796	1132	260139	2002-01-27	2002-02-03	1
32696	1945	40481087	2000-10-11	2000-10-31	1
81088	4814	4218389	1998-12-18	1999-01-15	1
54700	3240	4152936	1969-05-06	1969-05-20	1
60400	3576	4112343	1978-07-13	1978-07-24	1
40940	2437	260139	1995-05-13	1995-05-20	1
15034	886	4112343	1994-03-13	1994-03-24	1
18797	1132	4059173	1968-09-19	1968-11-18	1
32697	1945	372328	1971-05-28	1971-08-08	1
81089	4814	4237458	1939-04-26	1939-05-26	1
54701	3240	4283893	1949-03-13	1949-10-09	1
60401	3576	4142905	1972-10-10	1972-11-09	1
40941	2437	4027663	1988-07-31	1988-08-01	1
15035	886	4112343	1998-02-02	1998-02-15	1
18798	1132	4146173	1978-03-01	1978-04-30	1
32698	1945	372328	1983-09-09	1983-12-24	1
81090	4814	40481087	1952-03-10	1952-03-31	1
54702	3240	40481087	1959-05-27	1959-06-03	1
60402	3576	40481087	1988-01-18	1988-02-01	1
40942	2437	4112343	1967-10-09	1967-10-21	1
15036	886	40481087	1999-02-11	1999-02-25	1
18799	1132	4285898	1993-02-13	1993-02-14	1
32699	1945	4278672	1972-11-17	1973-01-16	1
81091	4814	28060	1944-07-28	1944-08-09	1
54703	3240	40481087	1975-04-21	1975-05-12	1
60403	3576	40481087	1989-09-01	1989-09-08	1
40943	2437	4112343	1998-10-10	1998-10-19	1
15037	886	40481087	2007-06-21	2007-07-12	1
18800	1132	40481087	2017-04-02	2017-04-23	1
32700	1945	4294548	1995-02-19	1995-03-12	1
81092	4814	78272	1940-03-21	1940-04-04	1
55567	3294	80180	1985-11-23	1985-11-24	1
60404	3576	80180	2000-05-21	2000-05-22	1
40944	2437	4112343	2003-09-26	2003-10-09	1
15038	886	40481087	1986-06-25	1986-07-02	1
18801	1132	372328	1957-04-13	1958-04-14	1
32701	1945	40481087	2004-11-15	2004-12-06	1
81093	4814	81151	1946-11-13	1946-12-04	1
55568	3294	4283893	1995-08-26	1995-11-04	1
60405	3576	372328	1969-07-28	1969-12-20	1
40945	2437	4112343	2008-11-14	2008-11-24	1
15039	886	40481087	1987-02-04	1987-02-18	1
18802	1132	4112343	1997-02-09	1997-02-20	1
32702	1945	4112343	1976-07-01	1976-07-12	1
81094	4814	372328	1940-04-20	1940-09-16	1
55569	3294	40481087	1974-06-12	1974-07-03	1
60406	3576	4035415	2010-11-11	2010-12-11	1
40946	2437	40481087	1964-07-23	1964-08-13	1
16871	1004	80180	2001-01-19	2001-01-20	1
18803	1132	40481087	1963-07-19	1963-08-09	1
32703	1945	4112343	2003-08-21	2003-08-28	1
81095	4814	4112343	1942-03-26	1942-04-07	1
55570	3294	40481087	1976-08-24	1976-08-31	1
60407	3576	4112343	1984-02-26	1984-03-05	1
40947	2437	40481087	1973-01-25	1973-02-08	1
16872	1004	81893	1999-07-29	1999-07-30	1
18804	1132	40481087	1976-09-05	1976-09-26	1
32704	1945	40481087	2000-01-23	2000-02-06	1
81096	4814	4218389	1995-12-06	1996-01-03	1
55571	3294	40481087	2003-05-25	2003-06-01	1
60408	3576	40481087	1995-08-17	1995-08-24	1
40948	2437	372328	1964-08-21	1965-01-11	1
16873	1004	260139	1970-12-30	1971-01-06	1
18805	1132	40481087	2007-01-26	2007-02-02	1
35634	2115	257012	2007-06-16	2007-06-17	1
83548	4971	260139	1968-03-06	1968-03-20	1
55572	3294	40481087	2018-12-27	2019-01-10	1
60409	3576	40481087	2011-05-16	2011-05-30	1
40949	2437	4156265	1962-08-02	1962-08-16	1
16874	1004	4266809	2001-01-19	2001-01-20	1
21964	1317	28060	1995-08-03	1995-08-10	1
35635	2115	260139	1971-09-05	1971-09-19	1
83549	4971	260139	1974-10-04	1974-10-18	1
55573	3294	260139	2008-09-09	2008-09-16	1
60410	3576	40481087	2017-07-30	2017-08-20	1
40950	2437	30753	1997-10-22	1997-10-23	1
16875	1004	40481087	1986-03-31	1986-04-21	1
21965	1317	258780	1996-05-24	1996-05-25	1
35636	2115	378001	1988-12-21	1989-02-19	1
83550	4971	378001	1945-03-24	1945-04-23	1
55574	3294	4112343	1981-01-19	1981-02-01	1
60411	3576	260139	1978-12-26	1979-01-02	1
40951	2437	80180	1998-10-17	1998-10-18	1
16876	1004	260139	1974-02-02	1974-02-16	1
21966	1317	260139	1964-04-14	1964-04-21	1
35637	2115	4059173	1989-12-16	1990-03-16	1
83551	4971	4109685	1936-06-25	1936-07-09	1
55575	3294	4112343	2003-08-31	2003-09-08	1
60412	3576	260139	1994-11-19	1994-11-26	1
40952	2437	81151	1977-10-26	1977-11-30	1
16877	1004	260139	1986-12-13	1986-12-20	1
21967	1317	260139	1992-05-05	1992-05-12	1
35638	2115	4296204	1968-02-21	1968-03-27	1
83552	4971	4112343	1982-07-22	1982-08-03	1
55576	3294	4134304	2017-08-20	2017-09-19	1
60413	3576	40481087	1976-05-27	1976-06-17	1
40953	2437	81151	2018-04-04	2018-05-02	1
16878	1004	4112343	1981-02-02	1981-02-09	1
21968	1317	4001336	2006-02-24	2006-04-25	1
35639	2115	28060	2010-08-12	2010-08-25	1
83553	4971	4116491	1992-08-20	1992-10-13	1
55577	3294	0	1977-10-13	1977-10-14	1
60414	3576	40481087	1983-08-17	1983-09-07	1
40954	2437	81893	1997-07-24	1997-07-25	1
16879	1004	4112343	1999-11-04	1999-11-15	1
21969	1317	4112343	2011-09-13	2011-09-20	1
35640	2115	80180	2004-06-01	2004-06-02	1
83554	4971	4134304	2000-11-12	2000-12-12	1
55578	3294	440448	1977-10-13	1977-10-14	1
60415	3576	40481087	1987-02-26	1987-03-19	1
40955	2437	4112343	1991-04-07	1991-04-17	1
16880	1004	4112343	2014-04-01	2014-04-10	1
21970	1317	4155034	1999-01-18	1999-02-01	1
35641	2115	260139	1972-10-20	1972-11-03	1
83555	4971	40481087	1938-03-25	1938-04-01	1
55579	3294	4112343	1971-08-25	1971-09-05	1
60416	3576	260139	1967-11-08	1967-11-22	1
40956	2437	4266809	1998-10-17	1998-10-18	1
16881	1004	40481087	1971-12-29	1972-01-05	1
21971	1317	40481087	1952-12-08	1952-12-15	1
35642	2115	4113008	1970-12-12	1970-12-26	1
83556	4971	40481087	1979-08-11	1979-09-01	1
55580	3294	4112343	1997-11-18	1997-11-29	1
60417	3576	260139	2005-11-12	2005-11-19	1
40957	2437	4278672	1963-08-11	1963-09-10	1
16882	1004	28060	1977-09-10	1977-09-20	1
21972	1317	40481087	1969-12-16	1969-12-30	1
35643	2115	4230399	2011-04-02	2011-06-01	1
83557	4971	80180	1978-02-10	1978-02-11	1
55581	3294	4112343	2015-04-10	2015-04-18	1
60418	3576	4294548	2013-01-27	2013-07-14	1
40958	2437	4296205	2001-11-24	2001-12-29	1
16883	1004	260139	1997-05-27	1997-06-10	1
21973	1317	40481087	1983-12-03	1983-12-10	1
35644	2115	4283893	1989-06-07	1989-07-26	1
83558	4971	80502	2015-02-24	2015-02-25	1
55582	3294	4283893	1992-10-14	1992-11-04	1
60419	3576	40481087	1996-01-26	1996-02-02	1
40959	2437	40481087	1972-11-04	1972-11-18	1
16884	1004	372328	1965-06-27	1965-09-16	1
21974	1317	40481087	1986-07-04	1986-07-18	1
35645	2115	40479422	2004-08-29	2004-10-05	1
83559	4971	260139	2000-05-27	2000-06-03	1
55583	3294	28060	1993-09-29	1993-10-09	1
60420	3576	40481087	1997-10-29	1997-11-19	1
40960	2437	40481087	1983-12-18	1984-01-01	1
16885	1004	4116491	2011-09-29	2011-11-01	1
21975	1317	40481087	1986-12-21	1987-01-04	1
35646	2115	260139	2016-09-21	2016-10-05	1
83560	4971	440086	1946-09-01	1950-12-10	1
55584	3294	81151	2010-06-30	2010-07-28	1
61236	3624	78272	1958-07-01	1958-07-29	1
40961	2437	28060	1971-06-06	1971-06-17	1
16886	1004	4152936	2016-09-27	2016-10-11	1
21976	1317	40481087	2010-08-28	2010-09-18	1
35647	2115	372328	1975-09-12	1975-11-17	1
83561	4971	4112343	1954-07-07	1954-07-18	1
55585	3294	260139	2015-08-13	2015-08-27	1
61237	3624	260139	2001-03-22	2001-03-29	1
40962	2437	40481087	1963-03-08	1963-03-22	1
16887	1004	4285898	2000-08-22	2000-08-23	1
21977	1317	28060	1964-10-04	1964-10-13	1
35648	2115	4116491	1986-09-19	1986-10-29	1
83562	4971	4112343	1985-05-30	1985-06-07	1
55586	3294	378001	2014-07-07	2014-09-05	1
61238	3624	372328	1946-12-31	1947-03-13	1
40963	2437	40481087	1978-04-21	1978-05-12	1
16888	1004	28060	1964-07-06	1964-07-16	1
21978	1317	80180	1989-11-19	1989-11-20	1
35649	2115	40481087	1970-08-16	1970-09-06	1
83563	4971	4112343	1993-11-11	1993-11-24	1
55587	3294	40481087	1952-03-15	1952-03-22	1
61239	3624	4283893	1953-10-01	1953-12-03	1
46019	2745	40481087	1985-02-11	1985-02-18	1
16889	1004	260139	2003-10-29	2003-11-05	1
21979	1317	81151	1952-11-03	1952-12-08	1
35650	2115	4294548	2007-04-21	2007-08-11	1
83564	4971	4112343	1995-08-18	1995-08-29	1
55588	3294	40481087	1969-05-27	1969-06-03	1
61240	3624	40481087	1948-10-30	1948-11-20	1
46020	2745	80180	2012-12-25	2012-12-26	1
16890	1004	4027663	1993-10-03	1993-10-04	1
21980	1317	372328	1952-12-03	1953-01-16	1
35651	2115	40481087	1964-08-18	1964-09-08	1
83565	4971	4112343	2001-08-01	2001-08-09	1
55589	3294	40481087	1975-10-02	1975-10-23	1
61241	3624	40481087	1967-09-29	1967-10-20	1
46021	2745	4152936	2003-12-28	2004-01-18	1
17965	1082	28060	1966-02-25	1966-03-10	1
21981	1317	4156265	1971-02-23	1971-03-16	1
35652	2115	40481087	1992-12-16	1992-12-30	1
83566	4971	4112343	2008-10-04	2008-10-16	1
55590	3294	40481087	1997-09-02	1997-09-16	1
61242	3624	40481087	1982-07-08	1982-07-22	1
46022	2745	28060	1972-06-17	1972-06-30	1
17966	1082	80180	1989-09-30	1989-10-01	1
21982	1317	4296205	1963-03-16	1963-04-06	1
38100	2265	257012	1997-06-04	1997-06-05	1
83567	4971	4134304	2004-01-26	2004-02-25	1
55591	3294	40481087	2006-10-18	2006-10-25	1
61243	3624	80180	1982-08-14	1982-08-15	1
46023	2745	28060	1988-11-04	1988-11-13	1
17967	1082	260139	1962-10-24	1962-11-07	1
21983	1317	40481087	1954-12-10	1954-12-17	1
38101	2265	4109685	1978-10-26	1978-11-09	1
83568	4971	40481087	1943-04-10	1943-04-17	1
59896	3553	81151	1934-07-20	1934-08-24	1
61244	3624	81151	1963-11-30	1963-12-14	1
46024	2745	78272	2004-12-13	2005-01-10	1
17968	1082	4001336	1960-11-21	1961-01-20	1
21984	1317	40481087	1977-09-25	1977-10-09	1
38102	2265	4112343	1971-08-06	1971-08-13	1
83569	4971	40481087	1993-02-28	1993-03-21	1
59897	3553	192671	1966-11-08	1966-11-09	1
61245	3624	260139	1957-03-10	1957-03-17	1
46025	2745	260139	1977-01-20	1977-01-27	1
17969	1082	4112343	1975-01-04	1975-01-13	1
21985	1317	317576	2009-12-25	2009-12-26	1
38103	2265	4283893	1997-03-26	1997-08-13	1
83570	4971	40481087	1997-02-26	1997-03-19	1
59898	3553	255848	2012-09-20	2012-09-21	1
61246	3624	372328	1950-08-31	1951-06-14	1
46026	2745	260139	1995-06-24	1995-07-01	1
17970	1082	4112343	2004-06-24	2004-07-05	1
21986	1317	40481087	1967-10-31	1967-11-21	1
38104	2265	40481087	1967-06-04	1967-06-18	1
83571	4971	78272	1983-11-28	1983-12-12	1
59899	3553	4112343	1952-12-19	1953-01-01	1
61247	3624	4112343	1963-11-21	1963-11-28	1
46027	2745	4112343	1992-09-24	1992-10-03	1
17971	1082	40481087	1986-04-17	1986-04-24	1
21987	1317	40481087	1968-12-21	1969-01-11	1
38105	2265	40481087	1985-10-28	1985-11-18	1
83572	4971	81151	1971-07-06	1971-08-03	1
59900	3553	4112343	1973-08-14	1973-08-26	1
61248	3624	4112343	2003-08-02	2003-08-11	1
46028	2745	4112343	2004-11-02	2004-11-10	1
17972	1082	40481087	1995-05-13	1995-06-03	1
21988	1317	40481087	1998-08-16	1998-08-23	1
38106	2265	40481087	2017-10-19	2017-10-26	1
83573	4971	260139	1979-01-09	1979-01-16	1
59901	3553	40481087	2007-05-12	2007-05-26	1
61249	3624	4112343	2016-08-27	2016-09-06	1
46029	2745	4156265	2017-09-09	2017-09-30	1
17973	1082	260139	1961-09-04	1961-09-11	1
21989	1317	257012	1997-06-29	1997-06-30	1
38107	2265	260139	1986-05-23	1986-05-30	1
83574	4971	317576	1995-11-07	1995-11-08	1
59902	3553	28060	1984-08-13	1984-08-25	1
61250	3624	4155034	2008-05-26	2008-06-16	1
46030	2745	40481087	2005-10-06	2005-10-13	1
17974	1082	439777	2006-08-07	2006-08-08	1
21990	1317	260139	1957-10-09	1957-10-16	1
38108	2265	40481087	2002-07-26	2002-08-02	1
83575	4971	381316	2007-09-04	2007-09-05	1
59903	3553	4112343	1937-06-08	1937-06-20	1
61251	3624	4218389	1984-12-07	1984-12-28	1
46031	2745	40481087	2011-05-21	2011-06-04	1
17975	1082	4027663	1982-08-13	1982-08-14	1
21991	1317	4059173	1982-09-14	1982-10-14	1
38109	2265	80180	2002-05-28	2002-05-29	1
83576	4971	4112343	1941-02-01	1941-02-14	1
59904	3553	4112343	1951-01-04	1951-01-12	1
61252	3624	40481087	1989-06-23	1989-07-07	1
46032	2745	4296205	2007-08-28	2007-10-02	1
17976	1082	4112343	1971-01-15	1971-01-23	1
21992	1317	4112343	2001-09-10	2001-09-17	1
38110	2265	192671	2002-06-16	2002-06-17	1
83577	4971	4112343	1986-04-07	1986-04-18	1
59905	3553	4112343	1962-02-02	1962-02-11	1
61253	3624	40481087	1994-09-16	1994-10-07	1
46033	2745	40481087	1993-07-11	1993-08-01	1
17977	1082	30753	1989-08-01	1989-08-02	1
21993	1317	4112343	2005-12-26	2006-01-08	1
38111	2265	260139	1964-06-12	1964-06-26	1
83578	4971	4283893	2018-03-22	2018-06-07	1
59906	3553	40481087	1941-03-23	1941-04-13	1
61254	3624	372328	1948-08-04	1948-12-09	1
46400	2767	260139	1942-08-06	1942-08-20	1
17978	1082	260139	1959-09-29	1959-10-13	1
21994	1317	4283893	1997-05-18	1998-02-08	1
38112	2265	260139	1975-09-26	1975-10-10	1
83579	4971	40481087	2005-12-11	2005-12-18	1
59907	3553	40481087	1955-04-07	1955-04-28	1
61255	3624	4112343	1961-01-19	1961-02-01	1
46401	2767	260139	1957-11-11	1957-11-18	1
17979	1082	260139	1989-12-16	1989-12-30	1
21995	1317	40481087	1953-10-16	1953-11-06	1
38113	2265	260139	1996-06-07	1996-06-14	1
83580	4971	260139	1964-08-29	1964-09-12	1
59908	3553	40481087	1978-12-19	1979-01-02	1
61256	3624	4112343	2004-12-06	2004-12-13	1
46402	2767	4134304	1971-04-05	1971-05-05	1
17980	1082	372328	1955-12-18	1956-01-28	1
21996	1317	40481087	1958-04-06	1958-04-20	1
38114	2265	4048171	1967-02-23	1982-02-21	1
83581	4971	261325	1999-11-30	1999-12-01	1
59909	3553	80180	1966-09-20	1966-09-21	1
61257	3624	4296205	1981-02-12	1981-02-26	1
46403	2767	80180	1970-10-17	1970-10-18	1
17981	1082	372328	1956-08-25	1956-10-27	1
21997	1317	40481087	1962-03-09	1962-03-23	1
38115	2265	4112343	1979-04-05	1979-04-13	1
83582	4971	372328	1991-08-06	1991-10-15	1
59910	3553	260139	1952-11-12	1952-11-26	1
61258	3624	78272	2011-06-01	2011-06-22	1
46404	2767	260139	1947-03-31	1947-04-07	1
17982	1082	4109685	2018-07-20	2018-08-10	1
21998	1317	40481087	1978-07-13	1978-07-27	1
38116	2265	4112343	2015-10-02	2015-10-14	1
83583	4971	4112343	1983-10-29	1983-11-05	1
59911	3553	372328	1944-08-26	1944-12-09	1
61259	3624	260139	1983-08-02	1983-08-09	1
46405	2767	260139	1961-08-01	1961-08-15	1
17983	1082	4112343	1978-10-28	1978-11-04	1
30092	1781	260139	1966-02-09	1966-02-23	1
38117	2265	40481087	1975-09-09	1975-09-16	1
83584	4971	4237458	1940-04-19	1940-05-19	1
59912	3553	439777	1982-10-26	1982-10-27	1
61260	3624	378001	1969-07-15	1969-08-14	1
46406	2767	4112343	1943-04-14	1943-04-22	1
17984	1082	4112343	1979-08-02	1979-08-10	1
30093	1781	260139	2002-10-04	2002-10-11	1
38885	2314	260139	1964-01-02	1964-01-16	1
83585	4971	40481087	1947-04-02	1947-04-23	1
59913	3553	4027663	1958-11-01	1958-11-02	1
61261	3624	4112343	2012-12-03	2012-12-13	1
46407	2767	4149245	1975-01-12	1975-02-18	1
17985	1082	134438	1988-08-18	1989-06-18	1
30094	1781	378001	1947-05-10	1947-06-09	1
38886	2314	260139	1991-12-04	1991-12-18	1
83586	4971	40481087	1994-11-16	1994-11-30	1
59914	3553	4112343	1952-02-07	1952-02-19	1
61262	3624	40481087	2013-11-03	2013-11-24	1
46408	2767	40481087	1974-02-24	1974-03-10	1
17986	1082	260139	2005-12-20	2005-12-27	1
30095	1781	439777	2000-05-26	2000-05-27	1
38887	2314	372328	1989-12-01	1991-07-13	1
84045	4999	80180	1991-06-28	1991-06-29	1
59915	3553	4112343	1983-08-08	1983-08-18	1
61263	3624	40481087	2018-04-10	2018-05-01	1
46409	2767	40481087	1975-05-13	1975-06-03	1
17987	1082	372328	1958-04-20	1958-07-26	1
30096	1781	4112343	2014-05-12	2014-05-19	1
38888	2314	440086	1963-07-04	1964-06-11	1
84046	4999	257012	1990-08-01	1990-08-02	1
59916	3553	40481087	1976-08-12	1976-08-26	1
62202	3678	81893	2016-01-07	2016-01-08	1
46410	2767	40481087	1988-02-17	1988-02-24	1
17988	1082	372328	2011-02-18	2012-02-04	1
30097	1781	40481087	1957-09-10	1957-10-01	1
38889	2314	4112343	1982-09-25	1982-10-08	1
84047	4999	260139	1978-12-25	1979-01-08	1
59917	3553	40481087	1997-01-05	1997-01-12	1
62203	3678	4059173	2009-10-30	2009-11-29	1
46411	2767	80502	1996-06-05	1996-06-06	1
17989	1082	4112343	1985-04-13	1985-04-22	1
30098	1781	40481087	1984-06-19	1984-06-26	1
38890	2314	4112343	2004-12-12	2004-12-21	1
84048	4999	260139	1988-08-31	1988-09-07	1
59918	3553	28060	1937-11-21	1937-11-30	1
62204	3678	4112343	1997-11-28	1997-12-07	1
46412	2767	196456	1939-05-23	1939-05-24	1
17990	1082	4112343	1997-09-18	1997-09-27	1
30099	1781	40481087	2017-04-17	2017-05-01	1
38891	2314	40481087	1975-04-09	1975-04-16	1
84049	4999	260139	2001-09-19	2001-09-26	1
59919	3553	260139	1942-09-08	1942-09-15	1
62205	3678	40481087	2018-03-10	2018-03-17	1
46413	2767	198809	1939-05-23	1939-05-24	1
17991	1082	4132546	1960-11-21	1960-11-22	1
30100	1781	28060	1941-08-11	1941-08-19	1
38892	2314	28060	2016-03-25	2016-04-02	1
84050	4999	378001	1969-11-10	1969-12-10	1
59920	3553	260139	1948-05-01	1948-05-15	1
62206	3678	80180	2017-07-30	2017-07-31	1
46414	2767	260139	1967-03-01	1967-03-15	1
17992	1082	4278672	1962-11-11	1962-12-11	1
30101	1781	80502	2011-12-06	2011-12-07	1
38893	2314	4109685	1972-04-08	1972-04-22	1
84051	4999	40481087	2009-04-06	2009-04-27	1
59921	3553	260139	1973-09-24	1973-10-01	1
62207	3678	260139	2008-10-01	2008-10-08	1
46415	2767	260139	1984-03-28	1984-04-04	1
17993	1082	40481087	2015-03-29	2015-04-19	1
30102	1781	260139	1999-10-11	1999-10-25	1
38894	2314	40481087	1986-05-25	1986-06-01	1
84052	4999	313217	2018-01-21	2018-01-22	1
59922	3553	260139	1977-05-13	1977-05-20	1
62208	3678	372328	1978-06-15	1978-10-30	1
46416	2767	260139	2002-12-27	2003-01-10	1
18275	1100	257012	1987-09-27	1987-09-28	1
30103	1781	372328	1942-02-05	1942-04-21	1
38895	2314	40481087	2017-10-23	2017-11-13	1
84053	4999	4294548	1990-06-20	1990-08-15	1
59923	3553	260139	1990-03-05	1990-03-19	1
62209	3678	4310024	2015-02-11	2015-02-12	1
46417	2767	378419	2019-04-10	2019-04-11	1
18276	1100	4112343	1997-10-12	1997-10-25	1
30104	1781	4112343	1994-08-10	1994-08-21	1
38896	2314	81151	1962-12-13	1962-12-27	1
84054	4999	40481087	1971-08-17	1971-08-24	1
59924	3553	378419	2006-06-24	2006-06-25	1
62210	3678	28060	1982-03-27	1982-04-06	1
46418	2767	4112343	1940-04-18	1940-04-27	1
18277	1100	40481087	1994-08-17	1994-08-31	1
30105	1781	4152936	1957-01-17	1957-01-31	1
38897	2314	81151	1979-08-14	1979-09-04	1
84055	4999	40481087	1981-06-10	1981-07-01	1
59925	3553	4112343	1945-03-24	1945-04-02	1
62211	3678	260139	1985-09-23	1985-09-30	1
46419	2767	4156265	2004-01-17	2004-01-31	1
18278	1100	40479768	2010-11-15	2010-12-22	1
30106	1781	4294548	1995-06-19	1995-07-03	1
38898	2314	260139	1986-05-21	1986-06-04	1
84056	4999	40481087	1993-04-10	1993-04-24	1
59926	3553	4112343	1959-10-01	1959-10-13	1
62212	3678	260139	2016-02-16	2016-02-23	1
46420	2767	40481087	1964-04-17	1964-05-08	1
18279	1100	40481087	2009-05-20	2009-05-27	1
30107	1781	40481087	1977-11-20	1977-12-04	1
38899	2314	372328	1952-10-29	1952-12-13	1
84057	4999	40481087	2008-09-17	2008-10-01	1
59927	3553	4266809	1966-09-20	1966-09-21	1
62213	3678	4142905	2018-03-17	2018-06-15	1
46421	2767	439777	1951-04-05	1951-04-06	1
18280	1100	78272	1995-04-24	1995-05-08	1
30108	1781	40481087	1991-01-22	1991-02-05	1
38900	2314	378001	2014-09-28	2014-10-28	1
84058	4999	28060	1968-05-20	1968-06-02	1
59928	3553	4310024	1965-03-29	1965-03-30	1
62214	3678	40481087	1995-03-23	1995-04-13	1
46422	2767	4218389	1973-02-23	1973-03-23	1
18281	1100	4237458	2004-02-20	2004-04-20	1
30109	1781	40481087	2004-07-12	2004-07-19	1
38901	2314	4149245	1961-01-15	1961-02-21	1
84059	4999	372328	1971-10-01	1971-12-26	1
59929	3553	40481087	2001-03-30	2001-04-06	1
62215	3678	40481087	1998-09-29	1998-10-13	1
46423	2767	40481087	1976-08-04	1976-08-11	1
18282	1100	4283893	1987-08-09	1987-11-15	1
30110	1781	80180	1975-09-15	1975-09-16	1
38902	2314	4237458	1958-03-02	1958-05-31	1
84060	4999	375671	2002-04-21	2002-06-20	1
61412	3633	4109685	1975-02-12	1975-02-26	1
62216	3678	260139	1980-06-06	1980-06-20	1
46424	2767	40481087	2000-08-26	2000-09-02	1
18283	1100	80180	2019-05-08	2019-05-09	1
30111	1781	260139	2009-11-17	2009-12-01	1
38903	2314	40481087	2005-08-28	2005-09-18	1
84061	4999	4112343	1996-08-07	1996-08-19	1
61413	3633	4230399	1979-10-03	1980-01-01	1
62217	3678	372328	1986-08-19	1987-05-04	1
47836	2844	80502	2018-07-02	2018-07-03	1
18284	1100	4113008	2011-11-17	2011-12-08	1
30112	1781	4156265	2009-11-24	2009-12-08	1
38904	2314	80180	1987-08-17	1987-08-18	1
84062	4999	4112343	2003-01-19	2003-01-27	1
61414	3633	40481087	1984-06-24	1984-07-15	1
62218	3678	372328	1988-12-24	1989-05-15	1
47837	2844	260139	1951-08-22	1951-08-29	1
18285	1100	4142905	1996-03-03	1996-05-02	1
30113	1781	4294548	1952-03-24	1952-03-31	1
38905	2314	372328	1956-06-25	1957-06-22	1
84063	4999	4116491	2007-11-06	2007-12-19	1
61415	3633	40481087	2001-01-13	2001-01-20	1
62219	3678	4027663	2007-11-15	2007-11-16	1
47838	2844	4112343	1981-05-15	1981-05-22	1
20593	1238	257012	1997-10-06	1997-10-07	1
30114	1781	40481087	1950-09-09	1950-09-23	1
38906	2314	4218389	1984-04-10	1984-05-08	1
84064	4999	4283893	1993-08-31	1993-09-21	1
61416	3633	40481087	2005-02-07	2005-02-28	1
62220	3678	4112343	1992-12-13	1992-12-22	1
47839	2844	4112343	2000-11-30	2000-12-08	1
20594	1238	372328	1957-10-28	1958-04-15	1
30115	1781	40481087	1983-02-13	1983-02-20	1
40790	2428	260139	2008-02-28	2008-03-06	1
84065	4999	40481087	1962-04-28	1962-05-19	1
61417	3633	4112343	1985-04-04	1985-04-11	1
62221	3678	4112343	2004-04-08	2004-04-15	1
47840	2844	4112343	2006-07-11	2006-07-23	1
20595	1238	4112343	1956-09-05	1956-09-18	1
30116	1781	40481087	2001-08-08	2001-08-22	1
40791	2428	40481087	2010-09-11	2010-09-18	1
84066	4999	40481087	1970-08-09	1970-08-16	1
61418	3633	40481087	1987-05-08	1987-05-15	1
62222	3678	4112343	2013-04-29	2013-05-11	1
47841	2844	4310024	1990-04-27	1990-04-28	1
20596	1238	40481087	1965-03-27	1965-04-10	1
30117	1781	260139	1961-01-27	1961-02-03	1
40792	2428	372328	1975-02-20	1975-06-03	1
84067	4999	40481087	2000-09-03	2000-09-24	1
61419	3633	40481087	2005-12-31	2006-01-07	1
62223	3678	4112343	2014-09-07	2014-09-15	1
47842	2844	40481087	1955-08-08	1955-08-22	1
20597	1238	4266809	1997-09-13	1997-09-14	1
30118	1781	372328	1944-01-11	1944-04-18	1
40793	2428	4112343	1989-04-21	1989-05-03	1
84068	4999	40481087	2007-01-14	2007-01-21	1
61420	3633	40481087	2012-07-10	2012-07-24	1
62224	3678	4285898	2016-11-02	2016-11-03	1
47843	2844	40481087	1987-10-15	1987-11-05	1
20598	1238	4294548	1997-08-18	1997-10-13	1
30119	1781	378001	1979-12-02	1980-01-01	1
40794	2428	4112343	1993-09-13	1993-09-25	1
84069	4999	378001	1999-07-06	1999-09-04	1
61421	3633	40481087	2016-02-13	2016-03-05	1
69063	4091	0	2017-09-10	2017-09-11	1
47844	2844	40481087	2002-01-28	2002-02-04	1
20599	1238	40481087	2013-09-26	2013-10-10	1
30120	1781	4112343	1961-11-03	1961-11-15	1
40795	2428	195588	2002-06-18	2002-08-10	1
84070	4999	4283893	2003-06-17	2003-09-23	1
61422	3633	28060	1982-06-08	1982-06-15	1
69064	4091	78272	1982-02-24	1982-03-10	1
47845	2844	40481087	2015-10-16	2015-10-30	1
20600	1238	28060	2002-05-05	2002-05-16	1
30121	1781	4112343	1962-03-16	1962-03-27	1
40796	2428	4294548	1987-06-06	1987-06-13	1
84071	4999	40481087	1963-05-21	1963-06-11	1
61423	3633	80180	2017-05-02	2017-05-03	1
69065	4091	260139	1999-05-22	1999-05-29	1
47846	2844	28060	1967-02-14	1967-02-27	1
20601	1238	4027663	1989-10-30	1989-10-31	1
30122	1781	40481087	1950-01-30	1950-02-06	1
40797	2428	40481087	1975-10-25	1975-11-15	1
84072	4999	40481087	1992-08-13	1992-09-03	1
61424	3633	378001	2004-10-21	2004-11-20	1
69066	4091	4112343	1979-12-19	1979-12-31	1
47847	2844	260139	1959-09-19	1959-09-26	1
20602	1238	4112343	1976-06-06	1976-06-18	1
30123	1781	40481087	1990-03-06	1990-03-20	1
40798	2428	40481087	1985-05-31	1985-06-07	1
84073	4999	40481087	1995-05-20	1995-05-27	1
61425	3633	4112343	2013-02-28	2013-03-11	1
69067	4091	4112343	2010-05-20	2010-06-02	1
47848	2844	260139	1978-08-03	1978-08-10	1
20603	1238	4112343	2007-07-20	2007-07-28	1
33331	1980	260139	2006-01-23	2006-02-06	1
40799	2428	40481087	2007-08-29	2007-09-19	1
84074	4999	40481087	2004-10-26	2004-11-16	1
61426	3633	40481087	1993-08-18	1993-09-01	1
69068	4091	4112343	2016-04-05	2016-04-18	1
47849	2844	4027663	1982-02-28	1982-03-01	1
20604	1238	4237458	2004-06-05	2004-09-03	1
33332	1980	4109685	1983-04-16	1983-04-30	1
40800	2428	80180	2015-10-08	2015-10-09	1
87297	5201	80180	2015-02-10	2015-02-11	1
61427	3633	372328	1973-09-20	1973-11-04	1
69069	4091	4152936	2015-03-31	2015-04-21	1
47850	2844	4112343	2000-10-20	2000-10-28	1
20605	1238	4310024	1995-03-28	1995-03-29	1
33333	1980	4142905	1988-07-02	1988-08-01	1
40801	2428	4112343	1984-08-03	1984-08-12	1
87298	5201	4112343	2005-05-16	2005-05-23	1
61428	3633	4112343	2012-02-21	2012-03-04	1
69070	4091	4294548	1983-12-10	1984-01-07	1
47851	2844	40480160	2019-04-25	2019-05-25	1
20606	1238	40481087	1964-02-02	1964-02-23	1
33334	1980	40481087	1984-01-06	1984-01-20	1
40802	2428	4142905	1984-01-18	1984-02-17	1
87299	5201	40481087	1984-07-29	1984-08-05	1
61429	3633	40481087	1983-01-09	1983-01-23	1
69071	4091	28060	1974-04-07	1974-04-18	1
47852	2844	40481087	1959-12-08	1959-12-22	1
20607	1238	80180	1997-09-13	1997-09-14	1
33335	1980	80180	2013-06-22	2013-06-23	1
40803	2428	4156265	1977-04-10	1977-04-24	1
87300	5201	40481087	2015-05-13	2015-06-03	1
61430	3633	40481087	1995-07-31	1995-08-07	1
69072	4091	260139	1970-05-16	1970-05-30	1
47853	2844	40481087	1975-07-08	1975-07-15	1
20608	1238	4149245	1982-08-18	1982-09-24	1
33336	1980	81151	2014-05-31	2014-06-14	1
40804	2428	4294548	1987-03-08	1987-03-29	1
87301	5201	198199	2015-03-27	2015-05-19	1
61835	3655	260139	1940-10-04	1940-10-18	1
69073	4091	372328	1970-09-11	1970-11-22	1
47854	2844	81893	1990-11-23	1990-11-24	1
20609	1238	4296204	1985-07-10	1985-08-14	1
33337	1980	257012	1990-04-25	1990-04-26	1
40805	2428	4296204	1996-04-14	1996-05-19	1
87302	5201	260139	1979-05-02	1979-05-16	1
61836	3655	372328	1936-05-26	1936-07-09	1
69074	4091	4116491	1987-11-21	1988-01-10	1
47855	2844	260139	1953-02-07	1953-02-21	1
20610	1238	40481087	1981-10-18	1981-11-01	1
33338	1980	260139	1972-10-12	1972-10-19	1
40806	2428	40481087	2002-01-31	2002-02-21	1
87303	5201	260139	1982-01-26	1982-02-02	1
61837	3655	4112343	1949-05-12	1949-05-19	1
69075	4091	40481087	2010-12-22	2011-01-12	1
47856	2844	260139	1967-05-24	1967-05-31	1
21411	1285	81151	1962-01-09	1962-02-13	1
33339	1980	378001	2007-02-07	2007-04-08	1
41141	2448	81893	1998-09-30	1998-10-01	1
87304	5201	260139	2001-10-21	2001-10-28	1
61838	3655	4112343	1989-07-02	1989-07-13	1
69076	4091	257012	1983-12-31	1984-01-01	1
47857	2844	260139	1986-09-07	1986-09-14	1
21412	1285	4112343	1972-06-19	1972-06-28	1
33340	1980	4112343	2007-06-05	2007-06-16	1
41142	2448	440448	2003-07-07	2003-07-08	1
87305	5201	40481087	1995-12-24	1996-01-14	1
61839	3655	4283893	2003-07-04	2003-09-05	1
69077	4091	260139	1990-11-09	1990-11-23	1
47858	2844	4059173	1960-10-31	1961-01-29	1
21413	1285	4112343	1993-02-23	1993-03-03	1
33341	1980	4294548	1990-03-28	1990-05-16	1
41143	2448	4027663	1991-07-09	1991-07-10	1
87306	5201	372328	1979-06-29	1979-08-08	1
61840	3655	4329847	2010-12-16	2010-12-17	1
69078	4091	260139	1994-03-08	1994-03-15	1
47859	2844	4112343	1949-11-01	1949-11-14	1
21414	1285	40481087	1958-12-31	1959-01-21	1
33342	1980	260139	1984-08-31	1984-09-14	1
41144	2448	4112343	1974-01-06	1974-01-19	1
87307	5201	4112343	1987-11-05	1987-11-16	1
61841	3655	40481087	1942-07-14	1942-07-21	1
69079	4091	4027663	1997-11-18	1997-11-19	1
47860	2844	4112343	1988-03-28	1988-04-09	1
21415	1285	40481087	1983-06-23	1983-07-07	1
33343	1980	439777	1999-09-04	1999-09-05	1
41145	2448	40481087	1988-04-02	1988-04-23	1
87308	5201	40481087	1980-12-28	1981-01-11	1
61842	3655	40481087	1979-11-23	1979-11-30	1
69080	4091	4112343	2000-01-30	2000-02-08	1
47861	2844	4112343	1995-08-05	1995-08-15	1
21416	1285	40481087	2013-08-26	2013-09-16	1
33344	1980	4112343	1991-02-15	1991-02-25	1
41146	2448	40481087	2011-10-04	2011-10-11	1
87309	5201	40481087	1989-03-17	1989-03-24	1
61843	3655	40481087	1980-06-05	1980-06-26	1
69081	4091	4113008	2012-09-28	2012-10-12	1
47862	2844	4112343	2002-02-04	2002-02-17	1
21417	1285	80180	1990-11-28	1990-11-29	1
33345	1980	40481087	1975-08-02	1975-08-16	1
41147	2448	0	2003-07-07	2003-07-08	1
87310	5201	372328	1980-04-04	1980-08-06	1
61844	3655	0	2010-12-16	2010-12-17	1
69082	4091	4266809	2009-05-29	2009-05-30	1
47863	2844	4112343	2002-09-19	2002-09-27	1
21418	1285	40481087	1986-07-30	1986-08-20	1
33346	1980	40486433	1975-09-17	1993-07-18	1
41148	2448	192671	2000-08-10	2000-08-11	1
87311	5201	4112343	1980-10-25	1980-11-07	1
61845	3655	81151	1997-08-04	1997-08-25	1
69083	4091	28060	1980-03-04	1980-03-11	1
47864	2844	40481087	1981-03-21	1981-04-11	1
21419	1285	260139	2014-03-08	2014-03-22	1
33347	1980	28060	1976-11-19	1976-11-28	1
41149	2448	260139	1979-12-26	1980-01-02	1
89124	5309	257012	1961-11-03	1961-11-04	1
61846	3655	381316	2001-12-13	2001-12-14	1
69084	4091	80180	2009-05-29	2009-05-30	1
47865	2844	80180	1992-01-17	1992-01-18	1
21420	1285	378001	1980-11-05	1981-01-04	1
33348	1980	260139	1975-07-07	1975-07-21	1
41150	2448	4112343	2000-03-30	2000-04-11	1
89125	5309	260139	1989-04-07	1989-04-21	1
61847	3655	260139	1972-01-15	1972-01-22	1
69085	4091	81151	1978-04-02	1978-04-16	1
47866	2844	257012	2006-11-30	2006-12-01	1
21421	1285	4218389	1991-08-01	1991-08-22	1
33349	1980	260139	1985-03-22	1985-04-05	1
41151	2448	4266809	2000-05-22	2000-05-23	1
89126	5309	317576	1988-12-26	1988-12-27	1
61848	3655	40481087	1937-12-21	1937-12-28	1
69086	4091	81893	2007-03-11	2007-03-12	1
47867	2844	260139	1964-11-11	1964-11-25	1
21422	1285	40481087	2008-11-30	2008-12-14	1
33350	1980	4059173	1982-03-22	1982-06-20	1
41152	2448	4283893	1990-07-19	1990-09-06	1
89127	5309	4112343	2003-10-19	2003-10-26	1
61849	3655	40481087	1951-01-13	1951-01-27	1
69087	4091	192671	2009-06-12	2009-06-13	1
47868	2844	4112343	1982-08-19	1982-08-26	1
21423	1285	313217	2014-05-19	2014-05-20	1
33351	1980	4156265	2005-04-04	2005-04-18	1
41153	2448	40481087	1973-01-23	1973-02-13	1
89128	5309	4134304	1967-10-28	1968-01-26	1
61850	3655	40481087	1972-01-20	1972-01-27	1
69088	4091	321042	2017-09-10	2017-09-11	1
47869	2844	4230399	2019-04-25	2019-05-25	1
21424	1285	4112343	1973-12-23	1974-01-03	1
34725	2064	80180	2017-06-16	2017-06-17	1
41154	2448	40481087	2006-03-22	2006-03-29	1
89129	5309	4156265	1986-04-21	1986-05-05	1
61851	3655	40481087	1987-08-13	1987-08-20	1
69089	4091	4112343	1973-05-29	1973-06-07	1
47870	2844	4266809	1992-01-17	1992-01-18	1
21425	1285	4142905	1996-04-27	1996-06-26	1
34726	2064	4278672	1982-04-06	1982-07-05	1
41155	2448	257012	1990-08-23	1990-08-24	1
89130	5309	4278672	1962-01-22	1962-03-23	1
61852	3655	28060	1948-11-02	1948-11-11	1
70062	4153	81151	1981-01-18	1981-02-08	1
47871	2844	4283893	2006-10-19	2007-02-22	1
21426	1285	4296205	1989-08-20	1989-09-10	1
34727	2064	40481087	2010-12-11	2011-01-01	1
41156	2448	439777	1991-07-09	1991-07-10	1
89131	5309	4278672	2018-06-16	2018-09-14	1
61853	3655	80180	1975-12-08	1975-12-09	1
70063	4153	192671	2001-10-30	2001-10-31	1
47872	2844	40481087	1976-07-14	1976-07-21	1
21427	1285	40481087	2016-10-08	2016-10-29	1
34728	2064	78272	1989-02-28	1989-03-21	1
41157	2448	4112343	1996-02-06	1996-02-17	1
89132	5309	40481087	1952-08-09	1952-08-16	1
61854	3655	257012	2003-07-18	2003-09-05	1
70064	4153	378001	2007-06-29	2007-07-29	1
47873	2844	40481087	1979-10-09	1979-10-23	1
24101	1439	28060	1985-01-05	1985-01-12	1
34729	2064	260139	1996-06-30	1996-07-07	1
41158	2448	4116491	1998-07-07	1998-08-21	1
89133	5309	40481087	1978-05-19	1978-06-02	1
61855	3655	260139	2002-02-02	2002-02-16	1
70065	4153	4112343	1991-12-04	1991-12-13	1
49857	2950	28060	1983-08-12	1983-08-19	1
24102	1439	372328	1982-06-09	1982-06-23	1
34730	2064	260139	2008-11-02	2008-11-16	1
41159	2448	28060	1978-05-31	1978-06-07	1
89134	5309	40481087	1988-12-21	1989-01-04	1
61856	3655	317576	2006-08-31	2006-09-01	1
70066	4153	4134304	2005-05-10	2005-07-09	1
49858	2950	378001	2003-05-05	2003-07-04	1
24103	1439	4059173	1991-10-29	1992-01-27	1
34731	2064	4112343	2000-09-02	2000-09-12	1
41160	2448	80180	2000-05-22	2000-05-23	1
89135	5309	195588	1977-01-22	1977-03-04	1
61857	3655	4112343	1945-01-11	1945-01-19	1
70067	4153	4149245	1999-11-01	1999-12-08	1
49859	2950	4112343	1948-11-15	1948-11-23	1
24104	1439	40481087	1984-09-06	1984-09-20	1
34732	2064	4152936	2008-11-06	2008-11-20	1
41161	2448	260139	1981-08-24	1981-08-31	1
89136	5309	4112343	1980-01-21	1980-01-29	1
61858	3655	4112343	1972-08-17	1972-08-27	1
70068	4153	40481087	1965-11-15	1965-12-06	1
49860	2950	4112343	1949-01-26	1949-02-08	1
24105	1439	40481087	1996-10-25	1996-11-08	1
34733	2064	260139	1993-10-06	1993-10-13	1
41162	2448	4112343	1964-08-16	1964-08-23	1
89137	5309	40481087	1978-10-05	1978-10-19	1
61859	3655	4112343	1997-03-06	1997-03-19	1
70069	4153	81893	1999-10-31	1999-11-01	1
49861	2950	4112343	1959-09-01	1959-09-13	1
24106	1439	257012	1998-06-08	1998-06-09	1
34734	2064	40481087	2019-06-25	2019-06-26	1
41163	2448	40481087	1970-11-16	1970-11-30	1
89138	5309	40481087	1993-03-20	1993-04-10	1
61860	3655	4112343	1999-10-07	1999-10-19	1
70070	4153	260139	1975-12-26	1976-01-09	1
49862	2950	4156265	1949-11-29	1949-12-13	1
24107	1439	260139	2019-05-12	2019-05-26	1
36235	2150	81151	1990-04-02	1990-04-30	1
42449	2534	260139	2017-07-30	2017-08-06	1
89139	5309	78272	1964-11-07	1964-12-12	1
61861	3655	4112343	2008-03-09	2008-03-20	1
70071	4153	40481087	1967-05-08	1967-05-29	1
49863	2950	40481087	1944-09-04	1944-09-18	1
24108	1439	378001	1986-09-25	1986-11-24	1
36236	2150	260139	1968-02-25	1968-03-03	1
42450	2534	28060	2008-08-16	2008-08-23	1
89140	5309	260139	1974-08-23	1974-09-06	1
61862	3655	40481087	1937-06-27	1937-07-18	1
70072	4153	40481087	2008-01-18	2008-01-25	1
49864	2950	40481087	1994-02-24	1994-03-03	1
24109	1439	260139	1978-03-13	1978-03-27	1
36237	2150	372328	1951-07-14	1951-12-28	1
42451	2534	134438	1994-07-27	1995-05-23	1
89141	5309	372328	1953-04-18	1953-07-06	1
61863	3655	40481087	1956-10-03	1956-10-10	1
70073	4153	80180	2001-09-20	2001-09-21	1
49865	2950	40481087	2001-04-29	2001-05-20	1
24110	1439	260139	2003-07-20	2003-07-27	1
36238	2150	372328	1952-12-22	1953-06-26	1
42452	2534	40481087	2012-01-22	2012-02-12	1
89142	5309	4152936	1957-05-04	1957-05-18	1
61864	3655	40481087	1960-01-30	1960-02-13	1
70074	4153	260139	2015-03-20	2015-04-03	1
49866	2950	40481087	2010-05-19	2010-05-26	1
24111	1439	260139	2006-08-30	2006-09-13	1
36239	2150	372328	1995-09-14	1996-02-09	1
42453	2534	80180	2011-04-02	2011-04-03	1
89143	5309	4283893	1961-08-25	1962-03-09	1
61865	3655	40481087	1983-11-13	1983-11-27	1
70075	4153	260139	2018-01-21	2018-01-28	1
49867	2950	28060	1993-01-13	1993-01-20	1
24112	1439	372328	1979-09-16	1979-12-22	1
36240	2150	4112343	1977-04-07	1977-04-19	1
42454	2534	372328	1974-10-13	1974-12-31	1
89144	5309	40481087	1952-02-29	1952-03-07	1
66888	3960	192671	1997-06-12	1997-06-13	1
70076	4153	372328	1967-01-02	1967-01-16	1
49868	2950	378419	2011-10-03	2011-10-04	1
24113	1439	4283893	1998-05-11	1999-01-11	1
36241	2150	4134304	1958-04-08	1958-06-07	1
42455	2534	372328	1984-10-09	1985-08-20	1
89145	5309	40481087	1953-09-16	1953-09-30	1
66889	3960	260139	1963-01-08	1963-01-15	1
70077	4153	4310024	1999-08-02	1999-08-03	1
49869	2950	4113008	1955-04-16	1955-05-07	1
24114	1439	40481087	1980-10-05	1980-10-19	1
36242	2150	40481087	1976-08-10	1976-08-24	1
42456	2534	40481087	1993-06-03	1993-06-24	1
89146	5309	40481087	1980-09-15	1980-09-29	1
66890	3960	4001336	1997-02-16	1997-04-17	1
70078	4153	40481087	1979-06-02	1979-06-09	1
49870	2950	4116491	1964-10-06	1964-12-01	1
24115	1439	40481087	2007-03-07	2007-03-14	1
36243	2150	30753	1985-06-30	1985-07-01	1
42457	2534	81151	2001-05-24	2001-06-21	1
89147	5309	80180	1993-05-08	1993-05-09	1
66891	3960	4218389	1972-12-26	1973-01-23	1
70079	4153	30753	2000-08-26	2000-08-27	1
49871	2950	4134304	1982-04-15	1982-06-14	1
24116	1439	40481087	2008-12-09	2008-12-16	1
36244	2150	260139	1966-07-14	1966-07-28	1
42458	2534	4278672	1974-06-15	1974-08-14	1
89148	5309	260139	1954-04-14	1954-04-21	1
66892	3960	4266809	1997-05-21	1997-05-22	1
70080	4153	260139	1975-09-19	1975-09-26	1
49872	2950	4155034	1983-06-09	1983-06-23	1
24117	1439	80180	2018-12-26	2018-12-27	1
36245	2150	260139	1969-08-06	1969-08-13	1
42459	2534	40481087	1979-04-27	1979-05-11	1
89149	5309	260139	1966-04-20	1966-05-04	1
66893	3960	4283893	1963-03-27	1963-04-17	1
70081	4153	372328	1973-05-14	1974-02-14	1
49873	2950	40481087	1955-10-29	1955-11-12	1
24118	1439	260139	1979-07-20	1979-08-03	1
36246	2150	4027663	1978-01-13	1978-01-14	1
42460	2534	40481087	1980-06-11	1980-07-02	1
89150	5309	4112343	1954-02-15	1954-02-26	1
66894	3960	40481087	1970-09-07	1970-09-21	1
70082	4153	4027663	1993-02-04	1993-02-05	1
49874	2950	40481087	1959-04-01	1959-04-15	1
24119	1439	372328	1978-12-06	1978-12-20	1
36247	2150	4109685	1965-12-18	1966-01-08	1
44076	2624	81151	2018-12-26	2019-01-09	1
89151	5309	4112343	1976-09-29	1976-10-06	1
66895	3960	78272	1966-10-01	1966-10-29	1
70083	4153	4112343	1980-01-27	1980-02-03	1
49875	2950	40481087	1987-12-12	1987-12-19	1
25362	1513	0	1981-05-23	1981-05-24	1
36248	2150	4112343	1973-09-09	1973-09-22	1
44077	2624	372328	1972-08-10	1972-12-14	1
89152	5309	4112343	1996-01-06	1996-01-13	1
66896	3960	372328	1958-04-16	1958-05-24	1
70084	4153	4146173	1990-06-21	1990-07-21	1
49876	2950	40481087	2007-10-16	2007-10-30	1
25363	1513	80180	2011-01-01	2011-01-02	1
36249	2150	4112343	1980-10-04	1980-10-12	1
44078	2624	439777	1996-12-27	1996-12-28	1
89153	5309	4112343	1998-01-06	1998-01-15	1
66897	3960	4285898	1996-09-23	1996-09-24	1
70085	4153	40481087	1968-07-01	1968-07-22	1
49877	2950	40481087	2014-06-13	2014-07-04	1
25364	1513	372328	1972-07-21	1973-01-28	1
36250	2150	4134304	2005-11-07	2006-02-05	1
44079	2624	440086	1975-01-02	1977-06-09	1
89154	5309	4146173	1969-11-16	1970-01-15	1
66898	3960	40481087	1969-12-20	1970-01-03	1
70086	4153	40481087	2004-01-05	2004-01-12	1
49878	2950	81151	1986-09-05	1986-10-10	1
25365	1513	4112343	1985-05-25	1985-06-02	1
36251	2150	4146173	1976-07-14	1976-08-13	1
44080	2624	4112343	2012-09-11	2012-09-24	1
89155	5309	40479768	1955-08-06	1955-09-12	1
66899	3960	40481087	1987-08-10	1987-08-31	1
70087	4153	40481087	2005-01-14	2005-01-28	1
49879	2950	372328	1936-08-09	1936-10-19	1
25366	1513	4112343	2010-06-12	2010-06-19	1
36252	2150	4294548	1981-09-24	1981-10-01	1
44081	2624	4155034	1973-08-05	1973-08-26	1
89156	5309	40481087	1996-01-31	1996-02-14	1
66900	3960	40481087	1999-01-09	1999-01-16	1
72468	4309	80180	1994-01-16	1994-01-17	1
49880	2950	4112343	1936-07-11	1936-07-18	1
25367	1513	195588	2007-05-17	2007-06-17	1
36253	2150	4310024	1983-12-08	1983-12-09	1
44082	2624	4218389	2015-09-15	2015-10-13	1
89157	5309	40481087	2009-05-14	2009-05-28	1
66901	3960	40481087	2018-11-26	2018-12-03	1
72469	4309	260139	1963-01-20	1963-02-03	1
49881	2950	4112343	1952-11-23	1952-12-03	1
25368	1513	380378	1981-05-23	1981-05-24	1
36254	2150	40481087	1950-07-26	1950-08-09	1
44083	2624	40481087	1992-06-06	1992-06-27	1
60422	3577	80180	1996-05-09	1996-05-10	1
66902	3960	260139	1961-07-31	1961-08-14	1
72470	4309	378001	1988-09-02	1988-10-02	1
49882	2950	4112343	1991-11-06	1991-11-17	1
25369	1513	4029498	1981-05-23	1981-05-24	1
36255	2150	40481087	2004-09-06	2004-09-13	1
44084	2624	30753	2005-10-21	2005-10-22	1
60423	3577	260139	2013-08-28	2013-09-04	1
66903	3960	4027663	1987-02-08	1987-02-09	1
72471	4309	4027663	1985-07-27	1985-07-28	1
49883	2950	4112343	2011-09-15	2011-09-28	1
25370	1513	4112343	1993-02-21	1993-03-02	1
36256	2150	81893	1984-11-02	1984-11-03	1
44085	2624	372328	1993-08-26	1996-03-14	1
60424	3577	378001	1979-09-21	1979-10-21	1
66904	3960	4116491	1981-02-09	1981-03-17	1
72472	4309	4285898	1993-10-18	1993-10-19	1
49884	2950	4218389	1999-04-05	1999-04-26	1
25371	1513	4112343	2007-07-04	2007-07-11	1
36257	2150	260139	1954-12-27	1955-01-10	1
44086	2624	4112343	2002-10-06	2002-10-16	1
60425	3577	378001	2007-12-23	2008-01-22	1
66905	3960	40481087	2009-10-29	2009-11-12	1
72473	4309	40481087	1968-05-27	1968-06-03	1
49885	2950	4218389	2005-06-23	2005-07-28	1
25372	1513	40481087	2004-03-18	2004-04-01	1
36258	2150	4112343	2017-08-30	2017-09-10	1
44087	2624	4112343	2009-09-11	2009-09-24	1
60426	3577	4112343	2012-03-13	2012-03-23	1
66906	3960	40481087	2018-09-04	2018-09-18	1
72474	4309	40481087	1969-11-30	1969-12-07	1
49886	2950	40481087	1977-12-15	1977-12-29	1
25373	1513	28060	1975-09-30	1975-10-12	1
36259	2150	4142905	2003-10-19	2003-11-18	1
44088	2624	4116491	1990-12-29	1991-02-12	1
60427	3577	4112343	2015-02-18	2015-03-01	1
66907	3960	28060	1980-04-23	1980-05-06	1
72475	4309	372328	1954-12-02	1955-01-12	1
49887	2950	40481087	2007-12-08	2007-12-22	1
25374	1513	28060	2009-11-28	2009-12-10	1
36260	2150	4283893	1962-07-15	1962-08-05	1
44089	2624	40481087	1984-02-29	1984-03-14	1
60428	3577	40481087	1977-09-15	1977-10-06	1
66908	3960	80180	1997-05-21	1997-05-22	1
72476	4309	4218389	1967-10-25	1967-11-22	1
49888	2950	80180	1978-04-26	1978-04-27	1
25375	1513	260139	1968-07-26	1968-08-09	1
36261	2150	4285898	1985-10-28	1985-10-29	1
44090	2624	40481087	2017-07-01	2017-07-22	1
60429	3577	372328	1963-03-30	1963-08-05	1
66909	3960	260139	1966-09-30	1966-10-14	1
72477	4309	4266809	1994-01-16	1994-01-17	1
49889	2950	4237458	2014-02-11	2014-04-12	1
25376	1513	372328	1969-12-17	1970-05-03	1
36262	2150	40481087	1961-11-28	1961-12-12	1
44091	2624	260139	2007-03-11	2007-03-18	1
60430	3577	372328	1966-05-21	1967-02-13	1
66910	3960	260139	1970-11-28	1970-12-12	1
72478	4309	40481087	1971-04-07	1971-04-28	1
49890	2950	40481087	1943-03-15	1943-04-05	1
25377	1513	440086	1979-05-24	1980-08-14	1
36263	2150	40481087	1964-02-01	1964-02-08	1
44092	2624	40481087	2006-02-16	2006-02-23	1
60431	3577	4283893	2007-06-26	2007-11-20	1
66911	3960	260139	1983-04-08	1983-04-15	1
72479	4309	260139	2018-12-28	2019-01-04	1
49891	2950	40481087	1995-01-05	1995-01-26	1
25378	1513	4109685	2010-03-31	2010-04-14	1
36264	2150	40481087	1977-03-30	1977-04-13	1
44093	2624	80180	2006-06-18	2006-06-19	1
60432	3577	40481087	1977-11-14	1977-11-21	1
66912	3960	4112343	2014-02-10	2014-02-19	1
72480	4309	372328	1963-09-27	1964-02-05	1
49892	2950	40481087	2006-11-28	2006-12-12	1
25379	1513	40481087	1986-01-17	1986-01-31	1
36265	2150	28060	1953-07-04	1953-07-12	1
44094	2624	4027663	1998-12-27	1998-12-28	1
60433	3577	257012	2007-08-21	2007-08-22	1
66913	3960	4310024	1994-11-03	1994-11-04	1
72481	4309	372328	1970-11-30	1971-03-17	1
51418	3056	372328	1959-01-31	1959-06-05	1
25380	1513	40481087	1999-06-01	1999-06-08	1
36266	2150	80180	1986-02-25	1986-02-26	1
44095	2624	4310024	2005-04-24	2005-04-25	1
60434	3577	260139	2011-03-08	2011-03-15	1
66914	3960	40481087	1978-12-13	1978-12-20	1
72482	4309	4218389	1994-08-02	1994-09-06	1
51419	3056	4001336	2010-03-04	2010-05-03	1
25381	1513	40481087	2001-09-03	2001-09-24	1
36267	2150	260139	1989-06-30	1989-07-07	1
44096	2624	40481087	1976-01-28	1976-02-04	1
60435	3577	4027663	1989-02-20	1989-02-21	1
72074	4282	372328	1966-10-03	1966-12-14	1
72483	4309	40481087	1961-07-03	1961-07-24	1
51420	3056	4112343	1988-09-18	1988-09-26	1
25382	1513	40481087	2011-03-27	2011-04-17	1
36268	2150	260139	2013-03-28	2013-04-04	1
44097	2624	40481087	1993-01-28	1993-02-18	1
60436	3577	4134304	1993-04-10	1993-06-09	1
72075	4282	381316	2007-10-10	2007-10-11	1
72484	4309	40481087	1987-06-11	1987-06-18	1
51421	3056	40481087	1996-07-17	1996-08-07	1
25383	1513	40481087	2017-06-21	2017-07-12	1
36269	2150	4112343	1966-11-03	1966-11-14	1
45842	2732	78272	1978-12-18	1979-01-08	1
60437	3577	40481087	1963-06-25	1963-07-02	1
72076	4282	40481087	1998-07-26	1998-08-02	1
72485	4309	28060	1990-12-12	1990-12-22	1
51422	3056	28060	1964-02-22	1964-03-02	1
25384	1513	78272	1995-12-01	1995-12-15	1
36270	2150	4156265	1961-02-21	1961-03-14	1
45843	2732	4112343	2013-11-16	2013-11-28	1
60438	3577	40481087	1993-10-07	1993-10-28	1
72077	4282	372328	1983-12-24	1984-10-24	1
72486	4309	30753	1993-05-21	1993-05-22	1
51423	3056	260139	1960-05-12	1960-05-19	1
25385	1513	375671	1977-04-09	1977-05-09	1
36271	2150	4218389	2008-01-26	2008-02-16	1
45844	2732	40481087	1988-10-28	1988-11-11	1
60439	3577	40481087	2013-03-02	2013-03-09	1
72078	4282	440448	1978-04-05	1978-04-06	1
72487	4309	260139	1981-08-05	1981-08-12	1
51424	3056	4051466	1960-01-04	1976-04-10	1
25386	1513	4112343	1970-07-16	1970-07-26	1
36272	2150	4299128	2017-02-28	2017-03-28	1
45845	2732	78272	1987-07-23	1987-08-06	1
60440	3577	40481087	2017-08-23	2017-08-30	1
72079	4282	4116491	2008-03-26	2008-05-03	1
72488	4309	378001	2015-12-15	2016-02-13	1
51425	3056	4112343	1972-11-18	1972-11-25	1
25387	1513	4112343	1996-05-17	1996-05-30	1
36273	2150	40481087	1961-02-17	1961-02-24	1
45846	2732	260139	1972-07-23	1972-07-30	1
60441	3577	372328	1961-05-28	1961-08-07	1
72080	4282	4166224	1978-04-05	1978-04-06	1
72489	4309	4112343	1985-08-24	1985-09-05	1
51426	3056	4112343	1977-09-01	1977-09-14	1
25388	1513	4283893	1973-02-04	1973-04-08	1
36900	2186	378001	1992-11-14	1993-01-13	1
45847	2732	4048171	1973-08-13	1993-07-15	1
60442	3577	4059173	1978-05-29	1978-08-27	1
72081	4282	4278672	1970-02-14	1970-03-16	1
72490	4309	40481087	1996-03-11	1996-03-18	1
51427	3056	4112343	2004-11-16	2004-11-28	1
25389	1513	4294548	1986-08-07	1986-10-02	1
36901	2186	4109685	1987-10-28	1987-11-11	1
45848	2732	40481087	2003-02-23	2003-03-16	1
60443	3577	4112343	1993-07-13	1993-07-20	1
72082	4282	40481087	1985-09-30	1985-10-07	1
72491	4309	40481087	2004-11-08	2004-11-29	1
51428	3056	4156265	1981-02-20	1981-03-06	1
25390	1513	40481087	1975-02-06	1975-02-20	1
36902	2186	4112343	1981-11-09	1981-11-16	1
45849	2732	40481087	2008-07-23	2008-08-06	1
60444	3577	4266809	1996-05-09	1996-05-10	1
72083	4282	40481087	1989-11-22	1989-12-06	1
72492	4309	40481087	2016-06-07	2016-06-14	1
51429	3056	40481087	1987-01-13	1987-01-27	1
25391	1513	40481087	1984-09-05	1984-09-19	1
36903	2186	4230399	2019-01-09	2019-04-09	1
45850	2732	4116491	1992-08-01	1992-09-01	1
60445	3577	4310024	1994-05-20	1994-05-21	1
72084	4282	40481087	2012-05-25	2012-06-01	1
77309	4586	81893	1990-04-13	1990-04-14	1
51430	3056	40481087	2008-11-10	2008-12-01	1
25392	1513	40481087	2007-05-21	2007-06-11	1
36904	2186	40481087	1975-10-01	1975-10-15	1
45851	2732	4294548	1978-06-26	1978-07-17	1
60446	3577	40481087	1971-07-29	1971-08-19	1
72085	4282	0	1978-04-05	1978-04-06	1
77310	4586	4112343	1995-03-21	1995-04-03	1
51431	3056	260139	1983-08-03	1983-08-17	1
26864	1593	260139	2014-09-22	2014-09-29	1
36905	2186	40481087	2002-06-03	2002-06-24	1
45852	2732	28060	2014-01-30	2014-02-10	1
60447	3577	40481087	1973-08-16	1973-08-30	1
72086	4282	260139	2014-10-30	2014-11-06	1
77311	4586	40481087	1982-12-31	1983-01-14	1
51432	3056	260139	1991-01-26	1991-02-02	1
26865	1593	378001	1952-07-06	1952-08-05	1
36906	2186	260139	1987-02-26	1987-03-12	1
45853	2732	78272	1980-02-02	1980-03-01	1
61264	3625	257012	1975-04-28	1975-04-29	1
72087	4282	372328	1969-02-01	1969-03-12	1
77312	4586	40481087	1997-01-20	1997-01-27	1
51433	3056	372328	1962-11-16	1962-12-14	1
26866	1593	4116491	1981-09-29	1981-11-07	1
36907	2186	260139	2013-05-30	2013-06-13	1
45854	2732	80180	2004-03-21	2004-03-22	1
61265	3625	260139	1964-10-15	1964-10-29	1
72088	4282	4112343	1997-11-06	1997-11-15	1
77313	4586	40481087	2014-03-30	2014-04-06	1
51434	3056	4112343	2000-03-28	2000-04-08	1
26867	1593	40481087	1950-09-14	1950-09-28	1
36908	2186	40486433	1975-02-15	1992-02-13	1
45855	2732	372328	1981-12-02	1982-09-02	1
61266	3625	372328	1954-11-20	1954-12-21	1
72089	4282	80180	2004-10-13	2004-10-14	1
77314	4586	80180	1992-06-01	1992-06-02	1
51435	3056	4112343	2016-12-28	2017-01-10	1
26868	1593	40481087	1983-06-22	1983-07-06	1
36909	2186	28060	1974-10-02	1974-10-14	1
45856	2732	40481087	1975-03-14	1975-04-04	1
61267	3625	4001336	2016-04-22	2016-05-22	1
72090	4282	260139	1977-09-06	1977-09-13	1
77315	4586	4112343	1992-04-26	1992-05-04	1
51436	3056	40481087	1966-12-12	1966-12-19	1
26869	1593	260139	1976-08-03	1976-08-10	1
36910	2186	80180	2014-10-16	2014-10-17	1
45857	2732	40481087	2001-07-14	2001-07-28	1
61268	3625	4112343	1960-10-08	1960-10-19	1
72091	4282	4112343	1975-06-20	1975-07-02	1
77316	4586	4112343	2003-08-22	2003-08-30	1
51437	3056	40481087	1974-04-13	1974-04-27	1
26870	1593	372328	1938-02-11	1938-03-17	1
36911	2186	372328	1974-06-03	1974-07-18	1
45858	2732	40481087	2016-01-02	2016-01-16	1
61269	3625	4112343	1962-05-26	1962-06-02	1
72092	4282	40481087	1967-03-10	1967-03-31	1
77317	4586	40481087	1983-02-19	1983-02-26	1
51438	3056	80180	1997-05-12	1997-05-13	1
26871	1593	372328	1976-02-04	1976-08-12	1
36912	2186	372328	1975-12-14	1976-01-15	1
46637	2778	4112343	1977-07-23	1977-08-01	1
61270	3625	40481087	1964-05-07	1964-05-28	1
72093	4282	40481087	1991-04-08	1991-04-29	1
77318	4586	30753	1991-02-07	1991-02-08	1
51439	3056	372328	1958-01-22	1958-03-07	1
26872	1593	381316	2009-10-01	2009-10-02	1
36913	2186	4027663	2006-01-31	2006-02-01	1
46638	2778	4112343	1994-05-06	1994-05-15	1
61271	3625	40481087	1986-04-20	1986-04-27	1
72094	4282	40481087	2013-10-31	2013-11-14	1
77319	4586	81151	1989-04-08	1989-04-29	1
51440	3056	40481087	1968-12-17	1968-12-31	1
26873	1593	4112343	1944-10-03	1944-10-13	1
36914	2186	4152936	1996-02-27	1996-03-19	1
46639	2778	80180	2011-07-27	2011-07-28	1
61272	3625	40481087	2010-10-20	2010-11-03	1
72095	4282	40481087	2015-04-14	2015-04-28	1
77320	4586	81151	2003-08-14	2003-09-04	1
51441	3056	40481087	1981-02-28	1981-03-21	1
26874	1593	4112343	2006-02-06	2006-02-13	1
36915	2186	4152936	2003-09-09	2003-09-30	1
46640	2778	4048171	1979-10-30	1995-10-28	1
61273	3625	40481087	2016-07-12	2016-07-19	1
73702	4383	260139	1976-03-30	1976-04-06	1
77321	4586	260139	1968-05-29	1968-06-05	1
51442	3056	40481087	1983-09-16	1983-09-23	1
26875	1593	4152936	1953-06-01	1953-06-15	1
36916	2186	30753	2013-10-21	2013-10-22	1
46641	2778	4112343	2013-07-17	2013-07-29	1
61274	3625	80502	2013-09-10	2013-09-11	1
73703	4383	4112343	1975-05-18	1975-05-26	1
77322	4586	378001	1969-02-22	1969-04-23	1
55012	3260	80180	1998-06-07	1998-06-08	1
26876	1593	4285898	1975-04-19	1975-04-20	1
36917	2186	372328	1975-05-14	1975-07-17	1
46642	2778	40481087	1977-10-25	1977-11-08	1
61275	3625	81151	1955-03-06	1955-04-10	1
73704	4383	4218389	2004-05-21	2004-06-11	1
77323	4586	4027663	1983-10-22	1983-10-23	1
55013	3260	260139	1983-02-02	1983-02-09	1
26877	1593	4296204	1961-12-30	1962-01-13	1
36918	2186	4285898	2014-04-19	2014-04-20	1
46643	2778	40481087	1996-02-09	1996-03-01	1
61276	3625	260139	1991-09-10	1991-09-24	1
73705	4383	40481087	1970-10-13	1970-10-27	1
77324	4586	4116491	1989-10-20	1989-12-01	1
55014	3260	372328	1962-01-22	1962-03-10	1
26878	1593	40481087	1940-08-18	1940-09-08	1
36919	2186	4296204	1986-10-28	1986-12-02	1
46644	2778	40481087	1998-11-21	1998-12-05	1
61277	3625	4112343	1981-04-08	1981-04-18	1
73706	4383	40481087	1996-11-19	1996-12-03	1
77325	4586	257012	1964-05-22	1964-08-28	1
55015	3260	4112343	1987-10-21	1987-10-30	1
26879	1593	40481087	2014-06-28	2014-07-12	1
38708	2300	80180	1990-07-30	1990-07-31	1
46645	2778	81151	1986-10-01	1986-10-22	1
61278	3625	4113008	1960-01-14	1960-02-04	1
73707	4383	40481087	2002-05-04	2002-05-18	1
77326	4586	4283893	1964-03-27	1964-08-28	1
55016	3260	4112343	1999-02-03	1999-02-16	1
26880	1593	28060	1946-11-03	1946-11-15	1
38709	2300	260139	1991-05-09	1991-05-16	1
46646	2778	260139	1978-07-17	1978-07-24	1
61279	3625	4132546	2016-04-22	2016-04-23	1
73708	4383	28060	1981-07-27	1981-08-03	1
77327	4586	40481087	1961-02-11	1961-03-04	1
55017	3260	4112343	2010-02-02	2010-02-11	1
26881	1593	4109685	1968-10-22	1968-11-12	1
38710	2300	4029498	1950-01-26	1950-01-27	1
46647	2778	4112343	1998-03-29	1998-04-06	1
61280	3625	4294548	1998-10-29	1999-01-14	1
73709	4383	80180	2008-06-24	2008-06-25	1
77328	4586	40481087	2013-01-08	2013-01-29	1
55018	3260	4152936	1968-11-05	1968-11-26	1
26882	1593	4112343	1955-02-04	1955-02-11	1
38711	2300	4112343	1953-09-08	1953-09-16	1
46648	2778	28060	2017-09-07	2017-09-15	1
61281	3625	40481087	1954-10-14	1954-10-21	1
73710	4383	260139	1990-12-20	1991-01-03	1
78689	4666	4146173	2001-11-03	2002-01-02	1
55019	3260	4156265	1983-09-09	1983-09-23	1
26883	1593	4112343	1959-06-22	1959-07-03	1
38712	2300	4112343	1975-04-26	1975-05-05	1
46649	2778	260139	2011-04-12	2011-04-19	1
61282	3625	28060	1965-10-18	1965-10-30	1
73711	4383	40481087	1977-10-28	1977-11-11	1
78690	4666	4296204	2016-09-29	2016-10-20	1
55020	3260	40481087	1970-08-14	1970-08-21	1
26884	1593	4112343	2014-08-02	2014-08-09	1
38713	2300	4112343	1977-05-26	1977-06-05	1
46650	2778	378001	2014-12-24	2015-02-22	1
61283	3625	140673	2010-06-30	2010-07-01	1
73712	4383	40481087	1998-05-02	1998-05-16	1
78691	4666	80180	2015-04-09	2015-04-10	1
55021	3260	40481087	2002-08-09	2002-08-30	1
26885	1593	4142905	1941-08-05	1941-10-04	1
38714	2300	4152936	1960-12-29	1961-01-12	1
46651	2778	40481087	2004-01-14	2004-02-04	1
61284	3625	260139	1987-04-26	1987-05-03	1
73713	4383	372328	1969-09-12	1969-10-25	1
78692	4666	260139	2003-06-16	2003-06-23	1
55022	3260	40481087	2008-08-03	2008-08-10	1
26886	1593	4155034	1970-09-03	1970-09-17	1
38715	2300	4296204	1993-02-28	1993-03-28	1
46652	2778	40481087	2009-07-15	2009-07-29	1
61285	3625	313217	2012-09-04	2012-09-05	1
73714	4383	4112343	1983-06-27	1983-07-10	1
78693	4666	372328	1978-04-03	1978-06-19	1
55023	3260	81893	1996-08-16	1996-08-17	1
26887	1593	4266809	1975-08-17	1975-08-18	1
38716	2300	40481087	1959-02-14	1959-03-07	1
47436	2825	78272	1993-06-19	1993-07-10	1
61286	3625	4112343	1962-04-15	1962-04-22	1
73715	4383	4112343	1984-10-05	1984-10-15	1
78694	4666	4112343	2005-07-13	2005-07-23	1
55024	3260	260139	1998-02-07	1998-02-21	1
26888	1593	4296204	1964-12-28	1965-01-11	1
38717	2300	260139	1957-09-18	1957-10-02	1
47437	2825	260139	1970-04-30	1970-05-07	1
61287	3625	4112343	1970-01-10	1970-01-18	1
73716	4383	4112343	1991-09-11	1991-09-24	1
78695	4666	4156265	2015-08-22	2015-09-05	1
55025	3260	4027663	1989-03-26	1989-03-27	1
26889	1593	40481087	1945-11-17	1945-12-01	1
38718	2300	260139	1974-11-08	1974-11-15	1
47438	2825	375671	2014-05-21	2014-07-20	1
61288	3625	4283893	1991-02-05	1991-04-02	1
73717	4383	4134304	1975-06-04	1975-09-02	1
78696	4666	4294548	1993-05-19	1993-05-26	1
55026	3260	4112343	1974-07-21	1974-07-28	1
26890	1593	40481087	1975-02-24	1975-03-10	1
38719	2300	261325	1972-12-07	1972-12-08	1
47439	2825	4109685	1975-09-08	1975-09-22	1
61289	3625	80180	1997-07-18	1997-07-19	1
73718	4383	4218389	1992-07-18	1992-08-22	1
78697	4666	40481087	1993-08-29	1993-09-19	1
55027	3260	4113008	2013-06-08	2013-06-22	1
26891	1593	40481087	1983-05-04	1983-05-18	1
38720	2300	4294548	1987-01-08	1987-01-29	1
47440	2825	4112343	1938-10-15	1938-10-24	1
61290	3625	81151	2011-08-26	2011-09-16	1
73719	4383	4296205	2008-01-22	2008-02-26	1
78698	4666	40481087	2009-10-01	2009-10-22	1
55028	3260	4294548	2016-10-05	2016-11-16	1
26892	1593	28060	1935-06-12	1935-06-21	1
38721	2300	40481087	1969-02-20	1969-03-13	1
47441	2825	4296204	1946-03-09	1946-04-13	1
61291	3625	260139	1979-10-20	1979-11-03	1
73720	4383	40481087	1977-01-02	1977-01-23	1
78699	4666	372328	1981-02-03	1981-07-06	1
55029	3260	4310024	1995-12-20	1995-12-21	1
26893	1593	80180	1975-08-17	1975-08-18	1
38722	2300	372328	2017-07-03	2018-04-05	1
47442	2825	80180	1964-03-06	1964-03-07	1
61292	3625	372328	1954-06-09	1954-09-21	1
73721	4383	40481087	2014-06-12	2014-07-03	1
78700	4666	4142905	1978-11-04	1979-01-03	1
55030	3260	40481087	1977-09-16	1977-09-30	1
26894	1593	81151	1945-03-17	1945-04-14	1
38723	2300	4112343	1966-03-29	1966-04-11	1
47443	2825	260139	1991-10-16	1991-10-30	1
61293	3625	372328	1957-11-05	1958-06-24	1
73722	4383	40481087	2015-07-03	2015-07-24	1
78701	4666	78272	1976-11-09	1976-12-14	1
55031	3260	40481087	1980-02-26	1980-03-11	1
26895	1593	372328	1936-10-30	1937-03-18	1
38724	2300	4112343	1990-03-30	1990-04-07	1
47444	2825	372328	1927-09-12	1927-11-29	1
61294	3625	439777	1997-07-03	1997-07-04	1
73723	4383	78272	1990-10-13	1990-10-27	1
78702	4666	260139	1984-03-03	1984-03-10	1
55032	3260	40481087	1999-11-04	1999-11-18	1
26896	1593	372328	1940-01-06	1940-09-26	1
38725	2300	4112343	2001-04-12	2001-04-25	1
47445	2825	4112343	1999-07-19	1999-07-31	1
61295	3625	4112343	1979-12-29	1980-01-10	1
73724	4383	260139	1971-02-06	1971-02-13	1
81210	4822	372328	1949-06-07	1949-09-07	1
55033	3260	78272	1964-11-28	1964-12-26	1
26897	1593	372328	1944-01-09	1944-10-19	1
38726	2300	4112343	2003-01-18	2003-01-31	1
47446	2825	4218389	1927-03-16	1927-04-13	1
61296	3625	4113008	2000-07-03	2000-07-24	1
73725	4383	260139	2000-03-12	2000-03-19	1
81211	4822	372328	1952-04-02	1952-09-10	1
55034	3260	81151	1961-04-27	1961-05-18	1
26898	1593	439777	1973-10-01	1973-10-02	1
38727	2300	4112343	2010-09-25	2010-10-06	1
47447	2825	40481087	1926-01-15	1926-01-29	1
61297	3625	4237458	1968-07-21	1968-08-20	1
73726	4383	4155034	1970-09-07	1970-09-28	1
81212	4822	439777	1993-09-12	1993-09-13	1
55035	3260	4112343	2003-03-31	2003-04-08	1
26899	1593	4027663	1964-10-03	1964-10-04	1
38728	2300	4112343	2015-08-12	2015-08-21	1
47448	2825	40481087	1968-11-27	1968-12-11	1
61298	3625	4294548	1975-03-10	1975-05-12	1
73727	4383	4294548	1983-06-20	1983-07-25	1
81213	4822	4113008	1967-08-29	1967-09-12	1
55036	3260	4218389	1996-09-14	1996-10-05	1
26900	1593	4035415	1957-02-24	1957-03-26	1
38729	2300	4237458	1955-12-26	1956-03-25	1
47449	2825	40481087	1972-10-26	1972-11-16	1
65237	3862	4112343	1976-05-31	1976-06-11	1
73728	4383	40481087	2002-09-23	2002-10-07	1
81214	4822	4116491	1989-09-13	1989-11-04	1
1052	63	81151	1966-03-12	1966-04-16	1
26901	1593	4112343	1998-04-10	1998-04-18	1
38730	2300	40481087	1984-11-26	1984-12-10	1
47450	2825	78272	1931-01-22	1931-02-26	1
65238	3862	40481087	1967-12-04	1967-12-18	1
73729	4383	40481087	2004-01-08	2004-01-29	1
81215	4822	4294548	1956-02-18	1956-03-31	1
1053	63	372328	1956-10-10	1956-11-21	1
26902	1593	40481087	2019-01-23	2019-01-30	1
38731	2300	40481087	2001-01-24	2001-01-31	1
47451	2825	4112343	1960-07-02	1960-07-11	1
65239	3862	40481087	1974-04-02	1974-04-09	1
73730	4383	40481087	2016-08-25	2016-09-15	1
81216	4822	40481087	1958-07-26	1958-08-16	1
1054	63	40481087	1995-11-20	1995-11-27	1
28645	1699	81893	2001-10-21	2001-10-22	1
38732	2300	40481087	2015-06-25	2015-07-16	1
47452	2825	4112343	2005-08-01	2005-08-13	1
65240	3862	40481087	1977-02-28	1977-03-07	1
74974	4457	28060	2003-11-02	2003-11-09	1
81217	4822	40481087	2013-04-04	2013-04-11	1
1055	63	80180	1992-07-28	1992-07-29	1
28646	1699	260139	1973-02-26	1973-03-12	1
38733	2300	0	1950-01-26	1950-01-27	1
47453	2825	4278672	2007-12-24	2008-01-23	1
65241	3862	4112343	1998-04-20	1998-04-29	1
74975	4457	4155034	1994-02-11	1994-02-25	1
81218	4822	80180	1987-07-31	1987-08-01	1
1056	63	372328	1978-03-31	1980-12-24	1
28647	1699	4027663	1996-03-26	1996-03-27	1
38734	2300	4112343	1957-09-28	1957-10-10	1
47454	2825	40481087	1948-04-08	1948-04-15	1
65242	3862	4113008	2013-11-19	2013-12-03	1
74976	4457	4237458	2006-07-22	2006-08-21	1
81219	4822	260139	1947-10-26	1947-11-02	1
1057	63	4112343	1973-08-27	1973-09-08	1
28648	1699	4059173	1979-01-25	1979-04-25	1
38735	2300	4155034	2010-08-01	2010-08-22	1
47455	2825	40481087	2018-05-23	2018-06-06	1
65243	3862	4156265	2011-04-13	2011-05-04	1
74977	4457	40481087	1999-11-16	1999-11-23	1
81220	4822	261325	2003-10-29	2003-10-30	1
1058	63	40481087	1976-02-29	1976-03-14	1
28649	1699	4112343	1977-06-03	1977-06-16	1
38736	2300	4218389	1970-12-21	1971-01-25	1
47456	2825	260139	2017-02-20	2017-03-06	1
65244	3862	4283893	1987-08-20	1987-11-19	1
74978	4457	4112343	2015-09-11	2015-09-19	1
81221	4822	372328	1950-11-01	1951-09-05	2
1059	63	78272	1956-12-08	1956-12-29	1
28650	1699	4112343	1981-12-23	1982-01-02	1
38737	2300	4218389	2004-09-26	2004-10-31	1
47457	2825	4142905	1991-03-02	1991-05-31	1
65245	3862	40481087	1979-03-06	1979-03-27	1
74979	4457	40481087	1985-01-06	1985-01-27	1
81222	4822	4156265	1951-08-04	1951-08-25	1
1060	63	260139	1990-09-14	1990-09-21	1
28651	1699	40481087	1973-07-02	1973-07-23	1
38738	2300	4218389	2018-03-13	2018-04-17	1
47458	2825	40481087	1925-11-30	1925-12-07	1
65246	3862	40481087	1996-06-12	1996-06-26	1
74980	4457	40481087	2016-03-24	2016-04-07	1
81223	4822	4156265	1966-08-20	1966-09-03	1
1061	63	260139	1994-05-03	1994-05-10	1
28652	1699	40481087	1992-08-14	1992-08-28	1
39646	2351	28060	1959-07-22	1959-07-30	1
47459	2825	40481087	1951-09-05	1951-09-19	1
65247	3862	40481087	2005-07-20	2005-08-03	1
74981	4457	28060	1994-06-10	1994-06-20	1
81224	4822	28060	1953-12-23	1954-01-03	1
1062	63	4059173	2008-02-19	2008-05-20	1
28653	1699	40481087	1998-06-10	1998-07-01	1
39647	2351	80180	1990-11-24	1990-11-25	1
47460	2825	40481087	1995-09-22	1995-10-06	1
65248	3862	40481087	2018-01-22	2018-02-05	1
74982	4457	4112343	1985-06-01	1985-06-11	1
81225	4822	81151	1952-07-20	1952-08-03	1
1063	63	4112343	2012-11-27	2012-12-07	1
28654	1699	40481087	2000-12-23	2000-12-30	1
39648	2351	4059173	1958-02-23	1958-05-24	1
47461	2825	40481087	2009-12-29	2010-01-12	1
65249	3862	80180	1995-06-11	1995-06-12	1
74983	4457	4112343	1991-09-10	1991-09-23	1
81226	4822	260139	1966-08-25	1966-09-01	1
1064	63	4134304	1973-12-05	1974-01-04	1
28655	1699	40481087	2004-02-21	2004-03-13	1
39649	2351	4112343	1959-01-07	1959-01-20	1
47462	2825	40481087	2010-07-20	2010-07-27	1
65250	3862	260139	1995-04-20	1995-05-04	1
74984	4457	4237458	1999-09-27	1999-11-26	1
81227	4822	260139	2018-06-01	2018-06-15	1
1065	63	4294548	1962-07-17	1962-08-07	1
28656	1699	28060	1969-10-18	1969-10-29	1
39650	2351	4296205	1949-05-13	1949-06-10	1
49685	2943	260139	1971-01-28	1971-02-04	1
65251	3862	372328	1957-12-22	1958-01-05	1
74985	4457	40481087	2009-07-09	2009-07-23	1
81228	4822	40481087	1966-08-23	1966-08-30	1
1066	63	40481087	1963-07-12	1963-07-19	1
28657	1699	4112343	2011-03-03	2011-03-15	1
39651	2351	40481087	1965-10-17	1965-11-07	1
49686	2943	4112343	1915-09-28	1915-10-09	1
65252	3862	4294548	1968-12-10	1969-08-19	1
74986	4457	80180	2016-08-19	2016-08-20	1
81229	4822	372328	1949-02-15	1949-03-09	1
1067	63	40481087	1965-07-16	1965-08-06	1
28658	1699	40481087	1980-09-22	1980-10-13	1
39652	2351	40481087	1970-11-18	1970-12-02	1
49687	2943	4112343	1931-03-20	1931-03-28	1
65253	3862	40481087	1958-04-28	1958-05-19	1
74987	4457	372328	1987-07-18	1988-04-19	1
81230	4822	4112343	2018-07-27	2018-08-03	1
1068	63	40481087	1987-11-20	1987-11-27	1
28659	1699	30753	2002-08-17	2002-08-18	1
39653	2351	378419	2018-06-02	2018-06-03	1
49688	2943	4112343	1989-02-19	1989-03-01	1
65254	3862	40481087	1968-08-19	1968-09-02	1
75496	4485	81151	2008-10-21	2008-11-04	1
81231	4822	40481087	1961-06-07	1961-06-14	1
1069	63	40481087	1998-09-22	1998-09-29	1
28660	1699	78272	1982-04-09	1982-05-07	1
39654	2351	4112343	1962-02-15	1962-02-25	1
49689	2943	4112343	2018-05-30	2018-06-09	1
65255	3862	40481087	2009-05-23	2009-05-30	1
75497	4485	257012	2019-04-28	2019-04-29	1
81232	4822	40481087	2014-05-12	2014-05-26	1
1070	63	40481087	2002-05-16	2002-06-06	1
28661	1699	80180	2003-11-10	2003-11-11	1
39655	2351	4237458	1993-07-22	1993-10-20	1
49690	2943	40481087	1938-01-09	1938-01-16	1
65256	3862	257012	1969-04-01	1969-04-02	1
75498	4485	260139	2002-08-22	2002-08-29	1
83738	4979	28060	1986-04-05	1986-04-14	1
1071	63	28060	1960-11-18	1960-11-30	1
28662	1699	260139	1991-06-20	1991-07-04	1
39656	2351	40481087	1999-01-02	1999-01-09	1
49691	2943	40481087	1952-07-30	1952-08-20	1
65257	3862	260139	1977-05-12	1977-05-19	1
75499	4485	4266809	1994-10-16	1994-10-17	1
83739	4979	192671	2014-10-22	2014-10-23	1
1072	63	81151	2000-10-15	2000-10-29	1
28663	1699	260139	1995-02-05	1995-02-20	1
39657	2351	40481087	2011-10-12	2011-10-19	1
49692	2943	40481087	1972-08-12	1972-08-19	1
65258	3862	375671	2008-04-28	2008-05-28	1
75500	4485	4283893	2019-03-24	2019-06-02	1
83740	4979	4112343	1995-07-27	1995-08-05	1
1073	63	260139	1995-11-01	1995-11-15	1
28664	1699	4094814	2005-07-26	2005-09-24	1
39658	2351	40481087	2018-05-23	2018-06-06	1
49693	2943	40481087	2002-05-11	2002-06-01	1
65259	3862	4112343	1973-07-03	1973-07-15	1
75501	4485	40481087	1990-08-21	1990-09-04	1
83741	4979	4142905	1978-03-15	1978-06-13	1
1074	63	260139	2000-11-22	2000-11-29	1
28665	1699	4156265	2011-03-27	2011-04-10	1
39659	2351	28060	1998-02-27	1998-03-11	1
49694	2943	80180	1952-11-08	1952-11-09	1
65260	3862	4283893	1996-09-02	1996-09-30	1
75502	4485	80180	1994-10-16	1994-10-17	1
83742	4979	40481087	2001-09-27	2001-10-04	1
1075	63	4112343	1980-03-05	1980-03-18	1
28666	1699	40481087	2016-07-16	2016-07-23	1
39660	2351	260139	1958-07-26	1958-08-09	1
49695	2943	260139	1977-08-02	1977-08-16	1
65261	3862	4294548	1995-10-14	1996-03-09	1
75503	4485	192671	1994-12-14	1994-12-15	1
83743	4979	80180	2014-08-28	2014-08-29	1
1076	63	40481087	1968-02-27	1968-03-05	1
28667	1699	372328	1967-08-26	1967-09-09	1
39661	2351	4059173	1964-03-07	1964-05-06	1
49696	2943	4112343	1982-12-09	1982-12-20	1
66427	3936	4112343	1977-08-18	1977-08-30	1
75504	4485	260139	1963-02-08	1963-02-22	1
83744	4979	4112343	2008-04-30	2008-05-11	1
1077	63	40481087	1973-03-18	1973-04-08	1
28668	1699	4112343	1973-02-12	1973-02-21	1
39662	2351	4112343	1982-10-09	1982-10-17	1
49697	2943	4112343	2000-02-06	2000-02-18	1
66428	3936	4112343	1987-10-17	1987-10-25	1
75505	4485	40481087	1970-10-26	1970-11-16	1
83745	4979	4112343	2017-04-25	2017-05-08	1
1078	63	40481087	1973-12-13	1974-01-03	1
28669	1699	4112343	2011-06-14	2011-06-25	1
39663	2351	40481087	1984-01-30	1984-02-13	1
49698	2943	4142905	2008-02-08	2008-05-08	1
66429	3936	4294548	1963-01-18	1963-02-22	1
75506	4485	40481087	1994-12-18	1995-01-01	1
83746	4979	4294548	1976-09-27	1976-10-11	1
2868	165	80180	2006-10-21	2006-10-22	1
28670	1699	4152936	2004-06-10	2004-07-01	1
39664	2351	40481087	2000-08-10	2000-08-31	1
49699	2943	4156265	1936-08-16	1936-09-06	1
66430	3936	40481087	1995-06-23	1995-07-14	1
75507	4485	30753	1993-08-22	1993-08-23	1
83747	4979	40481087	1982-08-16	1982-08-23	1
2869	165	4146173	2016-03-30	2016-05-29	1
28671	1699	4237458	1968-12-18	1969-02-16	1
39665	2351	81151	2009-11-25	2009-12-09	1
49700	2943	4156265	1946-10-14	1946-11-04	1
66431	3936	40481087	2003-07-08	2003-07-29	1
75508	4485	378001	1952-09-01	1952-10-01	1
83748	4979	40481087	1990-08-17	1990-09-07	1
2870	165	4294548	2018-02-23	2018-07-27	1
28672	1699	40481087	1991-08-24	1991-09-14	1
39666	2351	81151	2011-09-30	2011-10-14	1
49701	2943	4218389	1995-12-15	1996-01-12	1
66432	3936	378001	2014-10-17	2014-12-16	1
75509	4485	4027663	1982-10-04	1982-10-05	1
83749	4979	40481087	1999-05-20	1999-06-03	1
2871	165	257012	2018-05-04	2018-05-05	1
28673	1699	40481087	1996-11-14	1996-11-28	1
39667	2351	372328	1950-12-04	1950-12-18	1
49702	2943	4294548	1916-09-12	1916-10-24	1
66433	3936	4035415	2006-11-28	2007-01-27	1
75510	4485	4112343	1958-10-04	1958-10-11	1
83750	4979	260139	1978-07-14	1978-07-28	1
2872	165	4112343	2002-09-14	2002-09-22	1
28674	1699	40481087	1998-04-29	1998-05-06	1
39668	2351	4109685	1963-02-27	1963-03-13	1
49703	2943	40481087	1915-02-01	1915-02-15	1
66434	3936	4112343	2000-12-18	2000-12-29	1
75511	4485	40481087	1972-04-14	1972-04-28	1
83751	4979	372328	1986-02-01	1986-02-28	1
2873	165	40481087	1998-08-09	1998-08-16	1
34061	2026	378001	2019-04-19	2019-06-18	1
39669	2351	4112343	1953-05-26	1953-06-03	1
49704	2943	40481087	1984-11-22	1984-11-29	1
66435	3936	4218389	1962-02-01	1962-02-22	1
75512	4485	40481087	2012-12-06	2012-12-20	1
83752	4979	4113008	1996-01-10	1996-01-24	1
2874	165	195588	2005-06-03	2005-07-19	1
34062	2026	4112343	1984-11-07	1984-11-19	1
39670	2351	4112343	2013-10-22	2013-11-04	1
49705	2943	78272	1970-05-02	1970-05-30	1
66436	3936	40481087	1989-02-26	1989-03-19	1
75513	4485	81893	1992-12-25	1992-12-26	1
83753	4979	40481087	1997-08-06	1997-08-20	1
2875	165	260139	1983-05-26	1983-06-09	1
34063	2026	4116491	1974-01-05	1974-03-04	1
39671	2351	4155034	1968-03-16	1968-03-30	1
49706	2943	260139	1917-09-15	1917-09-29	1
66437	3936	40481087	2010-09-27	2010-10-11	1
75514	4485	260139	1994-07-20	1994-08-03	1
83754	4979	40481087	2014-03-08	2014-03-15	1
2876	165	260139	1992-09-23	1992-09-30	1
34064	2026	40481087	1954-10-05	1954-10-19	1
39672	2351	4218389	1978-09-04	1978-10-09	1
49707	2943	260139	1994-05-30	1994-06-06	1
66438	3936	28060	1968-11-23	1968-12-02	1
75515	4485	372328	1951-07-09	1951-09-20	1
84388	5023	78272	2017-11-15	2017-12-13	1
2877	165	260139	2012-11-18	2012-11-25	1
34065	2026	40481087	1983-07-31	1983-08-14	1
39673	2351	4278672	1966-03-27	1966-04-26	1
49708	2943	260139	2003-03-23	2003-04-06	1
66439	3936	78272	1960-02-28	1960-03-13	1
75516	4485	4112343	1990-07-26	1990-08-02	1
84389	5023	260139	1994-09-12	1994-09-26	1
2878	165	4156265	1991-02-26	1991-03-12	1
34066	2026	28060	1960-03-23	1960-04-03	1
39674	2351	40481087	1961-04-15	1961-05-06	1
49709	2943	4112343	2005-03-26	2005-04-07	1
66440	3936	372328	1958-08-07	1958-11-17	1
75517	4485	4113008	2003-05-07	2003-05-21	1
84390	5023	372328	1972-10-05	1972-11-12	1
2879	165	40481087	1969-03-14	1969-04-04	1
34067	2026	4112343	1955-10-05	1955-10-13	1
39675	2351	40481087	1977-04-06	1977-04-27	1
49710	2943	4134304	1997-02-05	1997-03-07	1
66441	3936	4112343	1990-12-12	1990-12-24	1
75518	4485	40481087	1959-09-04	1959-09-18	1
84391	5023	40481087	1984-05-14	1984-05-28	1
2880	165	40481087	2012-12-08	2012-12-15	1
34068	2026	4116491	1975-03-04	1975-04-12	1
39676	2351	40481087	1998-03-10	1998-03-31	1
49711	2943	4142905	1929-09-22	1929-10-22	1
66442	3936	4112343	2012-08-13	2012-08-24	1
75519	4485	40481087	1979-01-31	1979-02-14	1
84392	5023	378001	1974-07-27	1974-09-25	1
2881	165	40481087	2018-09-01	2018-09-22	1
34069	2026	40481087	1956-04-18	1956-05-02	1
41712	2485	372328	1914-11-02	1914-12-09	1
49712	2943	40481087	1993-10-19	1993-10-26	1
66443	3936	40481087	1976-10-17	1976-10-24	1
77480	4595	28060	1970-07-13	1970-07-22	1
84393	5023	40481087	2007-07-02	2007-07-23	1
2882	165	372328	1972-08-20	1973-05-23	1
34070	2026	40481087	1972-01-17	1972-01-24	1
41713	2485	4027663	1944-06-24	1944-06-25	1
49713	2943	372328	1915-07-26	1915-08-09	1
66444	3936	28060	1991-05-27	1991-06-08	1
77481	4595	260139	1976-03-02	1976-03-16	1
84394	5023	260139	2003-02-01	2003-02-15	1
2883	165	4035415	2013-04-15	2013-06-14	1
34071	2026	40481087	2000-07-23	2000-08-06	1
41714	2485	4112343	1925-11-30	1925-12-07	1
49714	2943	4109685	1917-03-17	1917-03-31	1
66445	3936	80180	1997-12-15	1997-12-16	1
77482	4595	260139	1986-04-01	1986-04-08	1
84395	5023	4112343	2010-01-20	2010-01-27	1
2884	165	4112343	2010-11-11	2010-11-19	1
34072	2026	40481087	2007-02-08	2007-02-15	1
41715	2485	4112343	1937-04-10	1937-04-23	1
49715	2943	4112343	1972-09-21	1972-09-29	1
66446	3936	257012	1963-02-08	1963-02-09	1
77483	4595	372328	1965-03-28	1965-06-18	1
84396	5023	40481087	2011-11-05	2011-11-26	1
2885	165	4112343	2014-04-06	2014-04-19	1
34073	2026	40481087	2018-07-23	2018-07-30	1
41716	2485	4112343	1950-03-31	1950-04-13	1
49716	2943	4278672	1931-08-13	1931-10-12	1
66447	3936	372328	1959-01-16	1959-02-16	1
77484	4595	4112343	1992-11-20	1992-11-28	1
84397	5023	80180	2015-06-12	2015-06-13	1
2886	165	4152936	1974-02-11	1974-02-25	1
34074	2026	80180	1995-07-14	1995-07-15	1
41717	2485	4112343	1991-03-04	1991-03-14	1
49717	2943	4296205	1920-02-14	1920-03-13	1
66448	3936	4112343	1959-06-04	1959-06-13	1
77485	4595	4149245	1996-02-14	1996-03-22	1
84398	5023	4051466	1974-08-13	1991-11-13	1
3669	211	0	1967-10-12	1967-10-13	1
34075	2026	260139	2009-02-11	2009-02-25	1
41718	2485	4112343	2006-10-06	2006-10-18	1
49718	2943	40481087	1946-03-14	1946-03-28	1
66449	3936	4112343	1987-08-09	1987-08-17	1
77486	4595	40481087	1967-06-23	1967-07-14	1
84399	5023	4149245	1994-04-13	1994-05-20	1
3670	211	260139	1969-08-03	1969-08-10	1
34076	2026	40481087	2016-03-07	2016-03-28	1
41719	2485	4113008	2015-12-23	2016-01-13	1
49719	2943	40481087	2000-10-25	2000-11-08	1
66450	3936	4112343	2004-03-17	2004-03-25	1
77487	4595	40481087	1971-05-01	1971-05-08	1
85589	5097	260139	2009-01-11	2009-01-18	1
3671	211	40481087	1984-12-11	1984-12-25	1
34077	2026	4112343	1954-05-02	1954-05-09	1
41720	2485	4283893	2002-11-08	2003-01-31	1
52670	3123	81151	1988-09-06	1988-09-27	1
66451	3936	40481087	1967-12-07	1967-12-28	1
77488	4595	40481087	2015-06-14	2015-06-28	1
85590	5097	40481087	1973-02-02	1973-02-16	1
3672	211	40481087	2016-11-27	2016-12-11	1
34078	2026	4112343	1975-06-17	1975-06-26	1
41721	2485	40481087	1981-02-06	1981-02-27	1
52671	3123	372328	1982-12-26	1983-03-09	1
67258	3980	4109685	1977-07-13	1977-08-03	1
77489	4595	4112343	1975-11-23	1975-12-04	1
85591	5097	40481087	1987-12-06	1987-12-27	1
3673	211	80180	2009-02-13	2009-02-14	1
34079	2026	4112343	2012-02-28	2012-03-07	1
41722	2485	40481087	2005-07-26	2005-08-16	1
52672	3123	4112343	2013-07-31	2013-08-09	1
67259	3980	28060	2016-08-27	2016-09-07	1
77490	4595	4112343	1981-05-11	1981-05-21	1
85592	5097	40481087	2007-04-30	2007-05-21	1
3674	211	372328	1973-02-12	1973-08-23	1
34080	2026	4278672	2016-05-04	2016-06-03	1
41723	2485	80180	1953-03-09	1953-03-10	1
52673	3123	4237458	2005-11-02	2005-12-02	1
67260	3980	4112343	1981-12-20	1982-01-02	1
77491	4595	4112343	2016-01-28	2016-02-10	1
85593	5097	134438	1992-06-26	1993-04-28	1
3675	211	4029498	1967-10-12	1967-10-13	1
37364	2218	260139	2005-06-02	2005-06-09	1
41724	2485	81151	1983-12-22	1984-01-12	1
52674	3123	40481087	2017-06-14	2017-06-28	1
67261	3980	4112343	2001-08-01	2001-08-12	1
77492	4595	4152936	2017-01-31	2017-02-14	1
85594	5097	260139	1983-05-05	1983-05-19	1
3676	211	4112343	1997-08-05	1997-08-16	1
37365	2218	4084167	1994-01-01	1994-01-01	1
41725	2485	372328	1999-10-14	2000-10-25	1
52675	3123	133834	1978-05-09	1995-09-07	1
67262	3980	4134304	1986-04-18	1986-05-18	1
77493	4595	40481087	2003-10-26	2003-11-08	1
85595	5097	4112343	2017-10-16	2017-10-26	1
3677	211	4112343	1998-05-14	1998-05-26	1
37366	2218	80180	2011-08-03	2011-08-04	1
41726	2485	4112343	1987-08-06	1987-08-18	1
52676	3123	260139	1989-10-03	1989-10-17	1
67263	3980	40481087	1988-06-22	1988-07-13	1
77494	4595	80180	2001-11-14	2001-11-15	1
85596	5097	40481087	1996-02-11	1996-02-18	1
3678	211	4266809	2009-02-13	2009-02-14	1
37367	2218	195588	2016-06-25	2016-07-30	1
41727	2485	4112343	2012-05-21	2012-05-31	1
52677	3123	260139	2016-10-06	2016-10-13	1
67264	3980	40481087	2017-05-25	2017-06-15	1
77495	4595	260139	1991-04-09	1991-04-23	1
85597	5097	372328	1969-11-24	1970-06-01	1
3679	211	81893	2007-01-25	2007-01-26	1
37368	2218	40481087	1982-12-17	1982-12-24	1
41728	2485	4266809	1953-03-09	1953-03-10	1
52678	3123	378001	1996-04-23	1996-06-22	1
67265	3980	372328	1980-02-28	1980-10-12	1
77496	4595	378001	1968-08-10	1968-09-09	1
85598	5097	80180	2005-08-05	2005-08-06	1
3680	211	260139	2006-11-25	2006-12-09	1
37369	2218	40481087	1997-05-18	1997-05-25	1
41729	2485	40481087	1933-08-23	1933-09-13	1
52679	3123	4218389	1993-07-03	1993-08-07	1
67266	3980	4112343	1988-06-02	1988-06-09	1
77497	4595	4112343	1966-03-25	1966-04-03	1
85599	5097	81151	1979-02-23	1979-03-16	1
3681	211	4027663	2000-10-03	2000-10-04	1
37370	2218	40481087	1999-10-09	1999-10-16	1
41730	2485	40481087	1988-04-30	1988-05-07	1
52680	3123	40481087	2004-04-04	2004-04-25	1
67267	3980	4116491	1992-10-22	1992-11-26	1
77498	4595	4146173	2010-05-09	2010-06-08	1
85600	5097	372328	1968-01-22	1968-03-04	1
3682	211	4112343	1976-07-15	1976-07-23	1
37371	2218	28060	1988-01-18	1988-01-31	1
41731	2485	40481087	1994-05-08	1994-05-15	1
52681	3123	80180	2018-04-12	2018-04-13	1
67268	3980	40481087	1986-05-04	1986-05-25	1
77499	4595	4278672	1974-08-09	1974-11-06	1
85601	5097	372328	1972-09-18	1973-06-11	1
3683	211	4112343	2016-02-22	2016-03-04	1
37372	2218	257012	1978-10-10	1978-10-11	1
41732	2485	40481087	2010-03-31	2010-04-14	1
52682	3123	4112343	2015-01-03	2015-01-10	1
67269	3980	40481087	2000-03-16	2000-04-06	1
78328	4643	260139	1916-04-19	1916-04-26	1
85602	5097	4112343	2004-11-12	2004-11-22	1
3684	211	4156265	2003-03-07	2003-03-28	1
37373	2218	372328	1980-12-08	1981-04-28	1
41733	2485	78272	2004-08-24	2004-09-21	1
52683	3123	4294548	1981-02-22	1981-03-01	1
67270	3980	40481087	2002-10-28	2002-11-04	1
78329	4643	378419	1992-04-25	1992-04-26	1
85603	5097	40481087	1993-10-01	1993-10-15	1
3685	211	40481087	1973-02-21	1973-03-07	1
37374	2218	4084167	1989-03-26	1989-03-26	1
41734	2485	192671	1953-04-30	1953-05-01	1
52684	3123	40481087	2010-02-01	2010-02-08	1
67271	3980	80180	2015-02-04	2015-02-05	1
78330	4643	4112343	1920-01-05	1920-01-15	1
85604	5097	40481087	2019-05-23	2019-06-13	1
3686	211	134438	1996-10-11	1997-10-06	1
37375	2218	4109685	1986-09-08	1986-09-29	1
41735	2485	260139	1920-04-28	1920-05-12	1
52685	3123	40481087	2011-06-08	2011-06-15	1
67272	3980	40481087	1995-11-13	1995-12-04	1
78331	4643	4112343	1958-01-24	1958-02-03	1
87107	5193	80180	2001-08-05	2001-08-06	1
3687	211	4112343	1972-11-16	1972-11-29	1
37376	2218	4112343	1978-12-22	1979-01-01	1
41736	2485	260139	1924-07-25	1924-08-01	1
52686	3123	40481087	2015-10-27	2015-11-17	1
67273	3980	40481087	1997-02-02	1997-02-23	1
78332	4643	40481087	1922-07-17	1922-07-24	1
87108	5193	372328	1964-06-05	1964-07-30	1
3688	211	40481087	1993-08-18	1993-08-25	1
37377	2218	4116491	2015-05-14	2015-06-26	1
41737	2485	4059173	1990-03-11	1990-06-09	1
52687	3123	260139	2005-01-28	2005-02-04	1
69025	4090	28060	1991-04-02	1991-04-12	1
78333	4643	40481087	1951-03-31	1951-04-07	1
87109	5193	381316	2010-06-10	2010-06-11	1
6350	374	260139	1986-04-06	1986-04-20	1
37378	2218	40481087	2013-09-10	2013-09-24	1
41738	2485	4112343	1940-02-10	1940-02-20	1
52688	3123	372328	1979-07-26	1979-12-12	1
69026	4090	80180	1984-06-30	1984-07-01	1
78334	4643	40481087	1993-11-29	1993-12-06	1
87110	5193	4112343	1975-06-06	1975-06-14	1
6351	374	260139	1991-03-05	1991-03-19	1
37379	2218	372328	1984-02-12	1984-05-08	1
41739	2485	4112343	1976-08-24	1976-09-01	1
52689	3123	378001	2011-12-01	2011-12-31	1
69027	4090	260139	1952-02-01	1952-02-08	1
78335	4643	78272	1958-02-27	1958-03-27	1
87111	5193	4134304	1965-07-30	1965-09-28	1
6352	374	28060	2015-10-17	2015-10-27	1
37380	2218	378001	1993-12-21	1994-01-20	1
41740	2485	4146173	1938-06-21	1938-08-20	1
52690	3123	4048171	1979-07-13	1979-07-14	1
69028	4090	372328	1944-07-10	1944-08-28	1
78336	4643	257012	1945-12-01	1945-12-02	1
87112	5193	40481087	1971-06-05	1971-06-19	1
6353	374	81151	1993-11-24	1993-12-29	1
37381	2218	4283893	1978-09-26	1978-10-31	1
41741	2485	30753	1952-05-13	1952-05-14	1
52691	3123	4084167	1978-02-01	1978-02-02	1
69029	4090	378001	1953-10-21	1953-12-20	1
78337	4643	260139	1913-05-27	1913-06-03	1
87113	5193	40481087	2018-03-10	2018-03-24	1
6354	374	260139	2004-07-10	2004-07-17	1
37382	2218	40481087	1997-11-29	1997-12-13	1
41742	2485	80502	2003-11-12	2003-11-13	1
52692	3123	40481087	1984-10-17	1984-11-07	1
69030	4090	440086	1954-03-20	1960-03-28	1
78338	4643	378001	1916-04-08	1916-06-07	1
87114	5193	313217	2015-09-24	2015-09-25	1
6355	374	4112343	1986-01-06	1986-01-15	1
38969	2319	28060	1964-05-17	1964-05-28	1
41743	2485	372328	1913-08-31	1913-10-08	1
52982	3141	0	1978-02-06	1978-02-07	1
69031	4090	4285898	1984-04-01	1984-04-02	1
78339	4643	378001	1970-10-20	1970-12-19	1
87115	5193	4112343	1983-07-05	1983-07-13	1
6356	374	4112343	2007-02-11	2007-02-19	1
38970	2319	28060	1968-09-02	1968-09-09	1
41744	2485	4112343	1959-11-24	1959-12-03	1
52983	3141	81151	1985-08-20	1985-09-03	1
69032	4090	40481087	1985-07-06	1985-07-20	1
78340	4643	4059173	1946-05-01	1946-05-31	1
87116	5193	4112343	2009-03-01	2009-03-09	1
6357	374	40481087	1987-08-05	1987-08-19	1
38971	2319	80502	2017-10-14	2017-10-15	1
41745	2485	4112343	1972-04-02	1972-04-13	1
52984	3141	260139	1984-08-02	1984-08-09	1
69033	4090	78272	1964-03-04	1964-03-25	1
78341	4643	4112343	1909-09-15	1909-09-27	1
87117	5193	81151	2008-10-12	2008-11-02	1
6358	374	80180	2015-07-17	2015-07-18	1
38972	2319	140673	2015-01-29	2015-01-30	1
41746	2485	4112343	1999-09-29	1999-10-11	1
52985	3141	4112343	2018-02-26	2018-03-05	1
69034	4090	317576	2015-08-03	2015-08-04	1
78342	4643	4112343	1979-06-27	1979-07-08	1
87118	5193	4146173	1974-02-13	1974-04-14	1
6359	374	192671	2015-09-06	2015-09-07	1
38973	2319	257012	2003-11-29	2003-11-30	1
41747	2485	40481087	1971-08-31	1971-09-07	1
52986	3141	4113008	1998-05-28	1998-06-11	1
69035	4090	4112343	1971-12-18	1971-12-28	1
78343	4643	4156265	1912-12-27	1913-01-10	1
87119	5193	40481087	1963-06-18	1963-07-09	1
6360	374	440086	1992-11-04	1997-11-13	1
38974	2319	4112343	1966-10-03	1966-10-12	1
41748	2485	40481087	1976-10-18	1976-11-08	1
52987	3141	80180	2010-09-15	2010-09-16	1
69036	4090	4112343	1986-10-12	1986-10-24	1
78344	4643	4283893	1945-10-27	1945-12-22	1
87120	5193	40481087	1983-09-21	1983-10-05	1
6361	374	4112343	2010-04-05	2010-04-13	1
38975	2319	4142905	1983-09-07	1983-10-07	1
41749	2485	40481087	1979-06-04	1979-06-11	1
52988	3141	192671	2010-11-18	2010-11-19	1
69037	4090	4113008	2011-08-14	2011-08-28	1
78345	4643	40481087	1958-08-11	1958-08-25	1
87121	5193	28060	1965-09-29	1965-10-09	1
6362	374	4218389	1995-01-23	1995-02-20	1
38976	2319	4146173	2018-07-26	2018-08-25	1
41750	2485	40481087	1992-09-18	1992-10-09	1
52989	3141	260139	1987-09-11	1987-09-18	1
69038	4090	4266809	1984-06-30	1984-07-01	1
78346	4643	28060	1994-06-20	1994-07-02	1
87122	5193	4112343	1974-03-29	1974-04-08	1
6363	374	40481087	2002-08-29	2002-09-05	1
38977	2319	4156265	1967-06-14	1967-07-05	1
43246	2579	0	2008-04-07	2008-04-08	1
52990	3141	4166224	1978-02-06	1978-02-07	1
69039	4090	4278672	1957-03-11	1957-06-09	1
78347	4643	80180	1944-06-22	1944-06-23	1
87123	5193	4294548	2002-08-26	2002-09-09	1
6364	374	28060	2002-07-24	2002-08-03	1
38978	2319	40481087	1963-01-10	1963-01-24	1
43247	2579	28060	1956-05-01	1956-05-14	1
52991	3141	40481087	2010-08-06	2010-08-27	1
69040	4090	40481087	1955-09-17	1955-10-01	1
78348	4643	260139	1937-10-04	1937-10-11	1
87124	5193	40481087	1986-05-31	1986-06-14	1
6365	374	40481087	2001-06-12	2001-06-26	1
38979	2319	40481087	1983-10-31	1983-11-21	1
43248	2579	4116491	1981-04-13	1981-05-14	1
52992	3141	81151	1981-11-11	1981-12-09	1
69041	4090	40481087	1975-07-01	1975-07-08	1
78349	4643	260139	1956-02-06	1956-02-13	1
87125	5193	40481087	2004-12-06	2004-12-13	1
6962	410	260139	1999-10-03	1999-10-17	1
38980	2319	40481087	1989-01-11	1989-02-01	1
43249	2579	4278672	1961-08-31	1961-09-30	1
52993	3141	260139	1979-08-25	1979-09-08	1
69042	4090	40481087	2013-01-06	2013-01-13	1
78350	4643	260139	1963-01-12	1963-01-19	1
88797	5285	28060	1971-10-26	1971-11-06	1
6963	410	260139	2004-08-30	2004-09-13	1
38981	2319	40481087	2011-09-09	2011-09-16	1
43250	2579	192671	1992-06-03	1992-06-04	1
52994	3141	378001	2012-08-26	2012-09-25	1
69043	4090	0	2015-03-23	2015-03-24	1
78351	4643	4112343	1945-12-01	1945-12-14	1
88798	5285	260139	1968-12-20	1968-12-27	1
6964	410	4112343	1972-10-15	1972-10-23	1
38982	2319	28060	2001-12-25	2002-01-01	1
43251	2579	260139	1961-05-05	1961-05-12	1
52995	3141	4112343	2010-11-13	2010-11-23	1
69044	4090	81151	1968-01-04	1968-02-01	1
78352	4643	4112343	1953-02-06	1953-02-16	1
88799	5285	378419	2016-05-29	2016-05-30	1
6965	410	4116491	1995-08-21	1995-09-28	1
38983	2319	80180	1990-02-24	1990-02-25	1
43252	2579	378001	1998-09-16	1998-10-16	1
52996	3141	40481087	1976-11-16	1976-11-23	1
69045	4090	81893	1983-05-07	1983-05-08	1
78353	4643	4112343	1961-05-22	1961-05-29	1
88800	5285	4112343	1995-01-15	1995-01-25	1
6966	410	4134304	2019-02-06	2019-03-08	1
38984	2319	372328	1948-11-06	1949-01-22	1
43253	2579	381316	1978-07-02	1978-07-03	1
52997	3141	375671	1975-12-13	1976-01-12	1
69046	4090	260139	1988-06-21	1988-06-28	1
78354	4643	4142905	1985-02-03	1985-03-05	1
88801	5285	40481087	1982-11-21	1982-11-28	1
6967	410	40481087	1982-11-05	1982-11-12	1
38985	2319	4084167	1947-08-14	1947-08-14	1
43254	2579	4112343	1968-12-24	1969-01-06	1
52998	3141	440448	1978-02-06	1978-02-07	1
69047	4090	372328	1944-10-27	1945-02-26	1
78355	4643	4155034	1914-02-04	1914-02-18	1
88802	5285	40481087	2004-07-22	2004-07-29	1
6968	410	40481087	1996-03-02	1996-03-16	1
38986	2319	4109685	1986-10-21	1986-11-11	1
43255	2579	40481087	2008-02-10	2008-03-02	1
52999	3141	4112343	2014-11-03	2014-11-12	1
69048	4090	4027663	1975-03-15	1975-03-16	1
78356	4643	4278672	1940-08-30	1940-11-28	1
88803	5285	80180	1980-12-16	1980-12-17	1
6969	410	40481087	2005-12-03	2005-12-17	1
38987	2319	4112343	1964-11-25	1964-12-08	1
43256	2579	40481087	2017-06-21	2017-06-28	1
53000	3141	40481087	2012-04-26	2012-05-03	1
69049	4090	4278672	1949-09-12	1949-12-11	1
78357	4643	4283893	1955-12-19	1956-01-16	1
88804	5285	260139	2009-09-03	2009-09-10	1
6970	410	40481087	2006-04-23	2006-05-14	1
38988	2319	4112343	2019-03-05	2019-03-14	1
43257	2579	260139	2006-01-14	2006-01-28	1
54704	3241	30753	1997-11-11	1997-11-12	1
69050	4090	40481087	1968-09-01	1968-09-22	1
78358	4643	40481087	1962-03-15	1962-04-05	1
88805	5285	372328	1943-06-04	1943-08-15	1
6971	410	28060	1957-07-24	1957-08-03	1
38989	2319	40481087	1956-01-05	1956-01-26	1
43258	2579	372328	1953-11-11	1954-03-28	1
54705	3241	80180	1998-08-08	1998-08-09	1
69051	4090	40481087	1973-04-26	1973-05-03	1
78359	4643	40481087	1968-06-10	1968-06-17	1
88806	5285	4112343	1984-02-02	1984-02-10	1
6972	410	78272	1950-08-27	1950-10-01	1
38990	2319	40481087	1964-06-26	1964-07-10	1
43259	2579	440448	2008-04-07	2008-04-08	1
54706	3241	4134304	1970-02-11	1970-04-12	1
69052	4090	40481087	1984-11-25	1984-12-02	1
78360	4643	40481087	1981-02-15	1981-03-01	1
88807	5285	4329847	2008-07-06	2008-07-07	1
6973	410	80180	1986-12-16	1986-12-17	1
38991	2319	40481087	1979-06-06	1979-06-27	1
43260	2579	4027663	1985-04-12	1985-04-13	1
54707	3241	4294548	1973-08-23	1973-09-06	1
69053	4090	40481087	2007-11-22	2007-12-06	1
78361	4643	4278672	1978-12-07	1979-02-05	1
88808	5285	40481087	1943-07-13	1943-08-03	1
6974	410	260139	2010-09-26	2010-10-10	1
38992	2319	81151	1980-11-23	1980-12-21	1
43261	2579	4116491	1987-05-13	1987-06-24	1
54708	3241	40481087	1973-05-02	1973-05-16	1
69054	4090	40481087	2009-11-30	2009-12-14	1
78362	4643	40481087	1927-07-07	1927-07-28	1
88809	5285	40481087	1993-05-09	1993-05-30	1
6975	410	372328	1951-04-24	1951-08-09	1
38993	2319	260139	1971-06-11	1971-06-18	1
43262	2579	4146173	1978-03-05	1978-04-04	1
54709	3241	40481087	1977-11-22	1977-11-29	1
69055	4090	313217	2017-08-14	2017-08-15	1
78363	4643	40481087	1941-11-20	1941-12-11	1
88810	5285	40481087	2012-08-24	2012-09-07	1
6976	410	4112343	1996-12-16	1996-12-23	1
38994	2319	260139	1995-06-21	1995-06-28	1
43263	2579	4285898	1991-11-02	1991-11-03	1
54710	3241	40481087	1986-09-30	1986-10-21	1
69056	4090	321042	2015-03-23	2015-03-24	1
78364	4643	40481087	1996-06-02	1996-06-23	1
88811	5285	28060	1950-09-27	1950-10-04	1
6977	410	4155034	1990-04-04	1990-04-25	1
38995	2319	378001	1953-09-25	1953-10-25	1
43264	2579	40481087	1972-07-18	1972-08-01	1
54711	3241	40481087	2002-08-02	2002-08-09	1
69057	4090	378001	2003-04-28	2003-05-28	1
81097	4815	28060	1970-12-31	1971-01-08	1
88812	5285	30753	1979-11-22	1979-11-23	1
6978	410	40481087	1974-03-01	1974-03-15	1
38996	2319	4112343	1984-02-06	1984-02-18	1
43265	2579	40481087	1990-06-05	1990-06-12	1
54712	3241	28060	1980-09-29	1980-10-11	1
69058	4090	40479768	1955-01-14	1955-03-22	1
81098	4815	81151	2010-11-28	2011-01-02	1
88813	5285	78272	1970-04-13	1970-04-27	1
6979	410	0	1951-09-02	1951-09-03	1
38997	2319	4112343	1988-04-29	1988-05-06	1
43266	2579	40481087	2001-10-16	2001-10-23	1
54713	3241	257012	2013-01-15	2013-01-16	1
69059	4090	40481087	1969-03-27	1969-04-10	1
81099	4815	4112343	1992-03-21	1992-04-03	1
88814	5285	317576	2007-02-25	2007-02-26	1
6980	410	260139	1975-02-18	1975-02-25	1
38998	2319	4113008	1949-03-06	1949-03-20	1
43267	2579	28060	1962-11-13	1962-11-25	1
54714	3241	260139	1966-02-04	1966-02-18	1
69060	4090	40481087	1991-03-28	1991-04-11	1
81100	4815	40481087	1993-04-10	1993-04-17	1
88815	5285	4027663	1973-11-28	1973-11-29	1
6981	410	440448	1951-09-02	1951-09-03	1
38999	2319	4280726	1952-02-21	1952-02-22	1
43268	2579	80180	1992-04-30	1992-05-01	1
54715	3241	260139	2003-10-11	2003-10-25	1
69061	4090	40481087	1993-03-10	1993-03-31	1
81101	4815	40481087	2004-01-28	2004-02-11	1
88816	5285	4112343	2015-05-13	2015-05-24	1
6982	410	4112343	1990-05-08	1990-05-21	1
39000	2319	4294548	2003-10-25	2004-04-10	1
43269	2579	260139	1996-10-06	1996-10-13	1
54716	3241	260139	2013-08-02	2013-08-09	1
69062	4090	40481087	2000-01-03	2000-01-24	1
81102	4815	80180	2008-09-06	2008-09-07	1
88817	5285	4113008	1985-05-08	1985-05-22	1
6983	410	40481087	1957-09-28	1957-10-19	1
39001	2319	40481087	1966-07-07	1966-07-21	1
43270	2579	260139	2000-03-31	2000-04-14	1
54717	3241	4112343	1964-07-15	1964-07-23	1
72435	4308	4112343	1941-11-07	1941-11-16	1
81103	4815	260139	2003-01-13	2003-01-20	1
88818	5285	40481087	1944-05-06	1944-05-20	1
6984	410	40481087	1975-09-15	1975-10-06	1
39002	2319	40481087	1976-08-03	1976-08-10	1
43271	2579	4266809	1992-04-30	1992-05-01	1
54718	3241	4283893	2012-12-18	2013-02-05	1
72436	4308	4112343	1962-05-03	1962-05-16	1
81104	4815	4112343	1997-02-26	1997-03-05	1
88819	5285	40481087	2002-08-16	2002-08-23	1
6985	410	40481087	1988-05-20	1988-06-03	1
39003	2319	40481087	1977-11-24	1977-12-08	1
43272	2579	40481087	1967-12-07	1967-12-21	1
54719	3241	4285898	1998-07-09	1998-07-10	1
72437	4308	4278672	1925-05-06	1925-08-04	1
81105	4815	40481087	2010-09-13	2010-10-04	1
88820	5285	40481087	2013-09-08	2013-09-29	1
6986	410	40481087	2010-05-31	2010-06-14	1
39004	2319	40481087	1979-09-30	1979-10-14	1
43273	2579	40481087	1970-12-14	1970-12-21	1
54720	3241	40481087	1979-05-02	1979-05-23	1
72438	4308	40481087	1987-08-20	1987-08-27	1
81106	4815	372328	1971-08-27	1972-02-10	1
88821	5285	40481087	2014-10-31	2014-11-21	1
6987	410	260139	1982-10-17	1982-10-31	1
39005	2319	40481087	1984-01-25	1984-02-01	1
43274	2579	40481087	1982-01-19	1982-02-09	1
54721	3241	40481087	1999-12-20	2000-01-10	1
72439	4308	40481087	1988-05-29	1988-06-05	1
81107	4815	378001	1995-05-21	1995-07-20	1
88822	5285	0	2008-07-06	2008-07-07	1
6988	410	4112343	1975-09-12	1975-09-23	1
39006	2319	260139	1980-10-11	1980-10-18	1
43275	2579	40481087	1999-08-30	1999-09-20	1
54722	3241	78272	1976-09-07	1976-10-12	1
72440	4308	28060	1938-04-16	1938-04-26	1
81108	4815	4112343	1995-08-19	1995-09-01	1
88823	5285	140673	2011-11-19	2011-11-20	1
6989	410	4112343	2001-11-01	2001-11-13	1
39007	2319	372328	1949-08-20	1950-01-21	1
43276	2579	40481087	2006-11-01	2006-11-08	1
54723	3241	260139	1992-09-10	1992-09-24	1
72441	4308	80180	1947-12-31	1948-01-01	1
81109	4815	4112343	2001-10-12	2001-10-22	1
88824	5285	192671	1981-02-06	1981-02-07	1
6990	410	4156265	2004-08-09	2004-08-23	1
39008	2319	4112343	1977-03-29	1977-04-11	1
44674	2661	4051466	1967-09-18	1983-12-25	1
54724	3241	375671	1995-11-02	1996-01-01	1
72442	4308	255848	1992-11-10	1992-11-11	1
81110	4815	4237458	1988-08-25	1988-10-24	1
88825	5285	260139	2007-09-05	2007-09-12	1
8445	492	260139	2006-09-02	2006-09-09	1
39009	2319	40481087	1958-09-17	1958-09-24	1
44675	2661	4084167	1976-06-10	1976-06-11	1
54725	3241	378001	2007-02-02	2007-03-04	1
72443	4308	260139	1992-08-29	1992-09-05	1
81111	4815	40481087	2007-08-01	2007-08-22	1
88826	5285	4112343	1959-07-20	1959-07-30	1
8446	492	260139	2016-03-31	2016-04-14	1
39010	2319	40481087	1977-07-12	1977-07-19	1
44676	2661	4296204	1969-06-17	1969-07-08	1
54726	3241	381316	1990-08-16	1990-08-17	1
72444	4308	4051466	1915-08-28	1931-12-04	1
81112	4815	260139	2012-06-02	2012-06-09	1
88827	5285	40481087	1947-10-07	1947-10-21	1
8447	492	4059173	2014-08-07	2014-09-06	1
39011	2319	40481087	2018-08-19	2018-09-09	1
44677	2661	40481087	1967-12-04	1967-12-25	1
54727	3241	4112343	1986-05-15	1986-05-25	1
72445	4308	40481087	1957-02-08	1957-03-01	1
81113	4815	4109685	1985-09-26	1985-10-10	1
89576	5331	80180	2004-09-03	2004-09-04	1
8448	492	4112343	1948-02-07	1948-02-15	1
40732	2425	81151	1962-01-08	1962-01-29	1
44678	2661	40481087	1970-06-17	1970-07-08	1
54728	3241	4134304	1987-03-19	1987-04-18	1
72446	4308	40481087	1962-02-08	1962-02-15	1
81114	4815	4156265	1982-10-28	1982-11-11	1
89577	5331	260139	1989-10-13	1989-10-27	1
8449	492	4112343	1964-08-17	1964-08-27	1
40733	2425	81151	2003-01-08	2003-01-22	1
44679	2661	40481087	2008-01-27	2008-02-17	1
54729	3241	4237458	1965-03-09	1965-06-07	1
72447	4308	40481087	1978-11-24	1978-12-15	1
83520	4970	260139	1934-04-13	1934-04-20	1
89578	5331	260139	1998-03-02	1998-03-16	1
8450	492	4296205	1952-08-13	1952-09-17	1
40734	2425	81893	1993-06-04	1993-06-05	1
44680	2661	40481087	2016-08-08	2016-08-29	1
54730	3241	40481087	1976-05-31	1976-06-21	1
72448	4308	28060	1916-12-29	1917-01-05	1
83521	4970	372328	1928-10-18	1929-03-20	1
89579	5331	4112343	1965-11-18	1965-11-25	1
8451	492	40481087	1950-07-30	1950-08-06	1
40735	2425	260139	1971-06-21	1971-07-05	1
44681	2661	80180	2005-01-19	2005-01-20	1
54731	3241	40481087	1982-10-05	1982-10-12	1
72449	4308	260139	1956-11-14	1956-11-21	1
83522	4970	378419	1995-11-29	1995-11-30	1
89580	5331	40481087	1973-02-13	1973-02-20	1
8452	492	40481087	1961-06-26	1961-07-03	1
40736	2425	4027663	1986-02-11	1986-02-12	1
44682	2661	260139	1989-10-31	1989-11-07	1
54732	3241	40481087	2006-05-25	2006-06-15	1
72450	4308	260139	1973-01-20	1973-01-29	1
83523	4970	4112343	1952-03-02	1952-03-12	1
89581	5331	40481087	2007-07-19	2007-08-02	1
8453	492	28060	1954-03-18	1954-03-29	1
40737	2425	4112343	1977-04-12	1977-04-21	1
44683	2661	4112343	2009-07-05	2009-07-16	1
54733	3241	192671	1998-09-14	1998-09-15	1
72451	4308	378419	1986-04-16	1986-04-17	1
83524	4970	4112343	1962-03-02	1962-03-14	1
89582	5331	4134304	1970-03-26	1970-05-25	1
8454	492	28060	1961-03-23	1961-04-02	1
40738	2425	4285898	1994-06-29	1994-06-30	1
44684	2661	40481087	1991-09-30	1991-10-21	1
54734	3241	4027663	1991-03-23	1991-03-24	1
72452	4308	40481087	1923-12-03	1923-12-24	1
83525	4970	4278672	1962-06-27	1962-07-27	1
89583	5331	40481087	1993-07-14	1993-07-28	1
8455	492	372328	2010-07-16	2010-10-01	1
40739	2425	40481087	1968-02-06	1968-02-13	1
44685	2661	4112343	1966-02-07	1966-02-20	1
54735	3241	4112343	1988-08-15	1988-08-26	1
72453	4308	40481087	1943-01-08	1943-01-15	1
83526	4970	40481087	1926-02-28	1926-03-21	1
89584	5331	4296205	2017-02-17	2017-03-24	1
8456	492	439777	1979-12-05	1979-12-06	1
40740	2425	40481087	1982-02-26	1982-03-12	1
44686	2661	4112343	1990-08-19	1990-08-28	1
54736	3241	40481087	1982-03-13	1982-04-03	1
72454	4308	78272	1921-10-03	1921-10-24	1
83527	4970	40481087	1926-05-27	1926-06-03	1
89585	5331	40481087	1982-02-11	1982-02-18	1
8457	492	4112343	2016-06-10	2016-06-21	1
40741	2425	40481087	2017-01-15	2017-02-05	1
44687	2661	4112343	2007-10-29	2007-11-09	1
54737	3241	40481087	2019-06-10	2019-06-11	1
72455	4308	195588	1958-09-22	1958-11-12	1
83528	4970	40481087	1948-10-23	1948-11-13	1
89586	5331	40481087	1984-08-11	1984-08-25	1
8458	492	40481087	1956-03-14	1956-04-04	1
40742	2425	80180	1994-07-29	1994-07-30	1
44688	2661	4283893	1981-01-17	1981-03-21	1
55592	3295	80180	1983-03-22	1983-03-23	1
72456	4308	260139	1913-11-15	1913-11-22	1
83529	4970	40481087	1995-12-09	1995-12-16	1
89587	5331	40481087	2001-07-21	2001-08-11	1
8459	492	40481087	1988-11-06	1988-11-20	1
40743	2425	4112343	1971-09-29	1971-10-08	1
44689	2661	40481087	1998-11-19	1998-12-10	1
55593	3295	378001	1951-01-24	1951-02-23	1
72457	4308	260139	1988-07-10	1988-07-24	1
83530	4970	80180	1958-11-25	1958-11-26	1
89588	5331	260139	2017-08-19	2017-08-26	1
8460	492	80180	1986-06-16	1986-06-17	1
40744	2425	4112343	2004-12-10	2004-12-18	1
44690	2661	257012	1981-02-07	1981-02-08	1
55594	3295	4112343	1981-11-04	1981-11-16	1
72458	4308	372328	1912-10-20	1912-11-27	1
83531	4970	81151	1987-01-17	1987-02-21	1
89589	5331	4112343	1977-03-30	1977-04-06	1
8461	492	372328	1950-05-17	1951-11-23	2
40745	2425	4134304	1968-04-27	1968-06-26	1
44691	2661	260139	2015-11-02	2015-11-09	1
55595	3295	4112343	2003-06-03	2003-06-11	1
72459	4308	372328	1913-10-23	1914-01-28	1
83532	4970	260139	1964-06-21	1964-06-28	1
89590	5331	4112343	1983-06-06	1983-06-19	1
8462	492	4156265	1968-07-25	1968-08-08	1
40746	2425	4294548	1964-03-03	1964-05-26	1
44692	2661	4048171	1968-09-17	1993-07-16	1
55596	3295	4113008	1964-11-25	1964-12-16	1
72460	4308	4116491	1953-08-11	1953-09-23	1
83533	4970	4112343	1926-09-30	1926-10-11	1
89591	5331	4112343	2015-04-06	2015-04-19	1
8463	492	40481087	1993-12-29	1994-01-05	1
40747	2425	40481087	1967-11-16	1967-11-30	1
44693	2661	4109685	2006-12-21	2007-01-04	1
55597	3295	4278672	1952-01-19	1952-02-18	1
72461	4308	4296205	1981-10-09	1981-11-06	1
83534	4970	4112343	1959-01-06	1959-01-19	1
89592	5331	40481087	1983-08-20	1983-09-10	1
8464	492	260139	1954-10-03	1954-10-17	1
40748	2425	40481087	1977-04-02	1977-04-23	1
44694	2661	4112343	1966-08-21	1966-08-29	1
55598	3295	4285898	1982-06-25	1982-06-26	1
72462	4308	40481087	1916-05-09	1916-05-23	1
83535	4970	4112343	1959-07-21	1959-07-28	1
3820	222	30753	1987-04-28	1987-04-29	1
8465	492	372328	1949-09-28	1949-11-18	1
40749	2425	28060	1961-10-13	1961-10-20	1
44695	2661	4112343	1974-10-19	1974-10-28	1
55599	3295	40481087	1944-08-06	1944-08-20	1
72463	4308	40481087	1919-06-12	1919-06-19	1
83536	4970	4112343	1960-05-25	1960-06-07	1
3821	222	260139	1965-10-31	1965-11-07	1
8466	492	4112343	2016-03-31	2016-04-10	1
40750	2425	81151	1991-04-27	1991-05-11	1
44696	2661	4112343	1976-10-21	1976-10-30	1
55600	3295	40481087	1998-12-20	1998-12-27	1
72464	4308	40481087	1925-10-20	1925-11-10	1
83537	4970	40481087	1953-05-26	1953-06-09	1
3822	222	372328	1954-11-16	1955-02-18	1
8467	492	4116491	1982-12-04	1983-01-10	1
40751	2425	257012	1964-05-05	1964-05-06	1
44697	2661	40481087	1983-12-13	1984-01-03	1
55601	3295	260139	1944-06-01	1944-06-08	1
72465	4308	40481087	1938-10-11	1938-10-25	1
83538	4970	40481087	1978-06-05	1978-06-19	1
3823	222	4112343	1957-10-15	1957-10-28	1
8468	492	40481087	1958-12-27	1959-01-03	1
40752	2425	260139	2008-09-20	2008-10-04	1
45284	2697	80180	1975-12-26	1975-12-27	1
55602	3295	260139	1956-04-07	1956-04-14	1
72466	4308	40481087	1981-10-07	1981-10-28	1
83539	4970	260139	1962-08-31	1962-09-14	1
3824	222	4112343	1967-01-19	1967-01-30	1
8469	492	40481087	1968-12-01	1968-12-15	1
40753	2425	372328	1965-02-21	1966-02-03	1
45285	2697	321042	2005-09-08	2005-09-09	1
55603	3295	4112343	2007-08-06	2007-08-16	1
72467	4308	40481087	1983-07-26	1983-08-02	1
83540	4970	260139	1983-01-21	1983-01-28	1
3825	222	4112343	1967-11-30	1967-12-07	1
8470	492	40481087	1988-06-12	1988-07-03	1
40754	2425	4059173	1966-01-08	1966-04-08	1
45286	2697	4109685	1941-02-07	1941-02-28	1
55604	3295	40481087	1965-12-18	1966-01-01	1
73252	4359	260139	1970-10-17	1970-10-24	1
83541	4970	4296204	1934-10-17	1934-11-21	1
3826	222	4112343	1993-01-09	1993-01-21	1
9643	572	80180	1992-04-01	1992-04-02	1
40755	2425	4112343	1994-08-22	1994-08-31	1
45287	2697	4283893	1944-06-29	1944-08-03	1
55605	3295	40481087	2010-06-10	2010-07-01	1
73253	4359	4112343	1947-02-22	1947-03-05	1
83542	4970	40481087	1925-02-13	1925-02-27	1
3827	222	40481087	1958-03-20	1958-04-03	1
9644	572	372328	1956-01-22	1956-03-30	1
40756	2425	4266809	1994-07-29	1994-07-30	1
45288	2697	40481087	1947-02-25	1947-03-11	1
55606	3295	28060	1978-11-10	1978-11-18	1
73254	4359	4218389	1987-04-02	1987-04-30	1
83543	4970	40481087	1947-04-09	1947-04-23	1
3828	222	40481087	1966-01-26	1966-02-16	1
9645	572	4112343	1999-12-11	1999-12-19	1
40757	2425	4294548	1978-06-25	1978-10-08	1
45289	2697	40481087	1955-02-21	1955-03-07	1
55607	3295	81151	1957-12-18	1958-01-01	1
73255	4359	78272	1959-12-13	1960-01-10	1
83544	4970	40481087	1980-04-18	1980-04-25	1
3829	222	40481087	1994-02-09	1994-02-23	1
9646	572	4278672	1976-11-21	1977-01-20	1
43799	2611	40481087	1955-02-03	1955-02-24	1
45290	2697	40481087	1960-03-14	1960-03-21	1
55608	3295	260139	1960-05-24	1960-06-07	1
73256	4359	80180	1985-02-14	1985-02-15	1
83545	4970	134438	1946-04-19	1947-06-14	1
3830	222	192671	1988-03-28	1988-03-29	1
9647	572	30753	1991-01-07	1991-01-08	1
43800	2611	40481087	1955-08-03	1955-08-10	1
45291	2697	40481087	1980-07-22	1980-08-05	1
55609	3295	313217	1990-10-08	1990-10-09	1
73257	4359	81151	2013-07-12	2013-08-09	1
83546	4970	260139	1927-02-27	1927-03-13	1
3831	222	195588	2008-08-30	2008-10-07	1
9648	572	372328	1959-03-02	1959-10-09	1
43801	2611	40481087	1981-08-29	1981-09-19	1
45292	2697	40481087	1987-10-18	1987-11-08	1
55610	3295	4027663	1972-05-03	1972-05-04	1
73258	4359	260139	1991-02-08	1991-02-15	1
83547	4970	40481087	1932-03-08	1932-03-22	1
3832	222	257012	1973-08-24	1973-08-25	1
9649	572	4285898	1991-09-04	1991-09-05	1
43802	2611	40481087	2018-12-03	2018-12-24	1
45293	2697	260139	2001-06-15	2001-06-22	1
55611	3295	4112343	1975-04-20	1975-04-29	1
73259	4359	372328	1943-09-08	1943-10-20	1
84020	4998	133834	1965-05-14	1965-05-15	1
3833	222	4027663	1979-09-07	1979-09-08	1
9650	572	40481087	1964-04-05	1964-04-19	1
43803	2611	260139	1955-06-29	1955-07-13	1
45294	2697	260139	2004-03-20	2004-04-03	1
55612	3295	4266809	1983-03-22	1983-03-23	1
73260	4359	372328	1952-07-04	1953-02-18	1
84021	4998	260139	1967-02-27	1967-03-13	1
3834	222	4134304	1958-05-10	1958-06-09	1
9651	572	40481087	2007-04-06	2007-04-13	1
43804	2611	4113008	2016-08-27	2016-09-17	1
45295	2697	372328	1933-07-19	1933-09-28	1
55613	3295	40481087	1947-03-13	1947-03-20	1
73261	4359	4112343	1988-03-06	1988-03-18	1
84022	4998	372328	1966-03-03	1966-03-17	1
3835	222	4218389	1966-11-15	1966-12-20	1
9652	572	81151	2001-02-13	2001-03-20	1
43805	2611	40481087	2013-08-17	2013-09-07	1
45296	2697	440086	1944-04-17	1951-04-26	1
55614	3295	30753	1982-05-26	1982-05-27	1
73262	4359	4113008	1979-06-29	1979-07-13	1
84023	4998	4027663	1995-10-02	1995-10-03	1
3836	222	4266809	1988-02-22	1988-02-23	1
9653	572	260139	1961-10-12	1961-10-26	1
43806	2611	28060	1974-07-14	1974-07-27	1
45297	2697	4112343	1947-07-09	1947-07-20	1
55615	3295	260139	1997-11-01	1997-11-15	1
73263	4359	4294548	1968-07-09	1968-08-20	1
84024	4998	4048171	1968-10-15	1968-10-16	1
3837	222	40481087	1988-04-26	1988-05-10	1
9654	572	260139	2008-09-26	2008-10-10	1
43807	2611	28060	2002-03-15	2002-03-28	1
45298	2697	4218389	1994-11-17	1994-12-22	1
55616	3295	372328	1944-03-31	1944-04-14	1
73264	4359	40481087	1959-09-21	1959-10-05	1
84025	4998	4112343	1975-01-19	1975-01-31	1
3838	222	372328	1953-09-03	1954-02-19	1
9655	572	372328	1958-04-19	1958-10-03	1
43808	2611	78272	1977-12-28	1978-01-18	1
45299	2697	4283893	1983-06-30	1983-12-01	1
55617	3295	4112343	1986-09-22	1986-09-29	1
73265	4359	40481087	1986-03-28	1986-04-11	1
84026	4998	40481087	1970-11-11	1970-12-02	1
3839	222	4112343	1995-07-14	1995-07-25	1
9656	572	378001	2015-07-26	2015-08-25	1
43809	2611	40481087	1987-06-25	1987-07-16	1
45300	2697	40481087	1999-08-11	1999-08-18	1
55618	3295	4112343	2005-03-03	2005-03-16	1
73266	4359	257012	1968-08-13	1968-08-14	1
84027	4998	40481087	2000-10-13	2000-10-27	1
3840	222	4112343	2015-12-11	2015-12-18	1
9657	572	40481087	2014-05-11	2014-05-18	1
43810	2611	40481087	2015-07-04	2015-07-18	1
45301	2697	40481087	2002-02-11	2002-02-25	1
55619	3295	4134304	2009-02-23	2009-03-25	1
73267	4359	260139	2016-01-31	2016-02-14	1
84028	4998	40481087	2001-08-30	2001-09-13	1
3841	222	4113008	2014-07-18	2014-08-01	1
9658	572	28060	1954-05-24	1954-06-05	1
43811	2611	40481087	2017-06-15	2017-07-06	1
45302	2697	0	2005-09-08	2005-09-09	1
55620	3295	4294548	1996-01-27	1996-07-27	1
73268	4359	4112343	1959-01-15	1959-01-26	1
84029	4998	28060	1993-02-08	1993-02-17	1
3842	222	4218389	1960-04-29	1960-05-20	1
9659	572	28060	1961-11-29	1961-12-06	1
43812	2611	28060	2008-08-26	2008-09-08	1
45303	2697	28060	2003-12-31	2004-01-08	1
55621	3295	40481087	1971-04-14	1971-04-28	1
73269	4359	4237458	2012-06-17	2012-08-16	1
84030	4998	4285898	2002-10-20	2002-10-21	1
3843	222	40479422	2003-09-07	2003-11-13	1
9660	572	28060	1975-01-29	1975-02-06	1
43813	2611	80180	1990-06-29	1990-06-30	1
45304	2697	257012	1944-07-20	1944-07-21	1
55622	3295	40481087	1978-08-25	1978-09-01	1
73270	4359	40481087	1966-02-07	1966-02-14	1
84031	4998	4310024	2000-10-30	2000-10-31	1
3844	222	40481087	1966-04-24	1966-05-08	1
9661	572	81151	2003-11-05	2003-11-26	1
43814	2611	260139	1961-07-04	1961-07-18	1
45305	2697	317576	1981-05-14	1981-05-15	1
55623	3295	40481087	1982-05-21	1982-06-04	1
73271	4359	40481087	1999-11-23	1999-11-30	1
84032	4998	40481087	1967-06-03	1967-06-24	1
3845	222	40481087	1991-04-04	1991-04-18	1
9662	572	372328	1954-01-21	1954-04-02	1
43815	2611	4112343	1953-11-06	1953-11-17	1
45306	2697	372328	1936-07-14	1936-09-24	1
55624	3295	40481087	1997-03-31	1997-04-21	1
73272	4359	80502	2013-09-04	2013-09-05	1
84033	4998	28060	2008-04-13	2008-04-25	1
3846	222	28060	1974-03-09	1974-03-19	1
9663	572	4027663	1981-10-16	1981-10-17	1
43816	2611	4112343	1954-12-14	1954-12-21	1
45307	2697	40481087	1947-05-19	1947-05-26	1
55625	3295	40481087	1999-05-02	1999-05-16	1
73273	4359	260139	1999-06-11	1999-06-18	1
84034	4998	80180	2003-08-16	2003-08-17	1
3847	222	80180	1988-02-22	1988-02-23	1
9664	572	4112343	1992-09-06	1992-09-14	1
43817	2611	4112343	1985-05-03	1985-05-13	1
45308	2697	40481087	1956-04-05	1956-04-26	1
55626	3295	40481087	1999-06-23	1999-06-30	1
73274	4359	372328	1985-04-01	1986-11-19	1
84035	4998	81151	2007-03-28	2007-04-18	1
3848	222	4112343	1960-12-13	1960-12-20	1
9665	572	4112343	2010-05-27	2010-06-03	1
43818	2611	4112343	2009-08-06	2009-08-14	1
45309	2697	40481087	1974-02-26	1974-03-19	1
55627	3295	40481087	2006-07-31	2006-08-21	1
73275	4359	4112343	1950-01-20	1950-01-30	1
84036	4998	4051466	1968-10-15	1984-06-01	1
3849	222	4283893	1973-07-06	1973-09-07	1
9666	572	4310024	1989-11-13	1989-11-14	1
43819	2611	40481087	1988-02-17	1988-03-09	1
45310	2697	28060	1947-12-21	1947-12-30	1
532	32	30753	1986-07-08	1986-07-09	1
73276	4359	4112343	1963-01-06	1963-01-15	1
84037	4998	40481087	1973-12-25	1974-01-08	1
3850	222	4285898	1987-05-28	1987-05-29	1
9667	572	40481087	1969-04-02	1969-04-09	1
43820	2611	40481087	1994-07-12	1994-07-19	1
45311	2697	28060	1978-03-07	1978-03-16	1
533	32	81893	1985-09-11	1985-09-12	1
73277	4359	4112343	2006-06-14	2006-06-26	1
84038	4998	40481087	1975-04-12	1975-04-19	1
3851	222	4310024	1986-01-03	1986-01-04	1
9668	572	40481087	1973-06-26	1973-07-03	1
50155	2966	80180	2001-02-19	2001-02-20	1
45312	2697	192671	1976-01-06	1976-01-07	1
534	32	257012	1967-03-05	1967-03-06	1
73278	4359	4112343	2017-09-28	2017-10-05	1
84039	4998	260139	1992-05-02	1992-05-16	1
3852	222	40481087	2004-11-04	2004-11-25	1
9669	572	40481087	1982-03-27	1982-04-10	1
50156	2966	260139	2016-11-23	2016-12-07	1
45313	2697	260139	1941-10-07	1941-10-21	1
535	32	260139	1966-02-08	1966-02-22	1
73279	4359	40481087	1987-06-13	1987-06-20	1
84040	4998	4112343	1983-01-20	1983-01-30	1
6433	379	80180	2014-01-28	2014-01-29	1
12138	720	195588	1998-08-21	1998-09-24	1
50157	2966	4109685	1989-01-07	1989-01-21	1
45314	2697	4112343	1952-02-11	1952-02-19	1
536	32	260139	1998-10-02	1998-10-09	1
73280	4359	40481087	2010-07-11	2010-07-25	1
84041	4998	4112343	1995-07-10	1995-07-18	1
6434	379	257012	2000-05-17	2000-05-18	1
12139	720	257012	1966-06-22	1966-06-23	1
50158	2966	4296205	1963-10-02	1963-10-16	1
45315	2697	40481087	1969-02-09	1969-02-16	1
537	32	260139	2002-07-21	2002-07-28	1
75081	4465	260139	1986-09-17	1986-09-24	1
84042	4998	40481087	2008-12-14	2008-12-28	1
6435	379	4283893	2000-03-08	2000-06-07	1
12140	720	260139	2013-03-17	2013-03-31	1
50159	2966	40481087	2007-10-24	2007-11-07	1
45316	2697	40481087	1991-07-28	1991-08-18	1
538	32	372328	2003-07-09	2003-11-12	1
75082	4465	257012	1994-03-11	1994-03-12	1
84043	4998	40481087	2013-09-11	2013-09-25	1
6436	379	40481087	1985-03-28	1985-04-18	1
12141	720	4027663	1991-08-23	1991-08-24	1
50160	2966	40481087	2015-11-26	2015-12-10	1
47264	2815	260139	1992-04-10	1992-04-17	1
539	32	4043241	2006-08-30	2006-08-31	1
75083	4465	4294548	1994-01-28	1994-05-27	1
84044	4998	40481087	2015-03-25	2015-04-01	1
6437	379	372328	1980-01-02	1980-03-08	1
12142	720	4112343	2010-05-28	2010-06-06	1
50161	2966	257012	2014-12-03	2014-12-04	1
47265	2815	260139	2002-03-23	2002-04-06	1
540	32	4112343	1962-10-29	1962-11-07	1
75084	4465	40481087	2011-10-27	2011-11-17	1
85701	5104	4112343	2009-06-08	2009-06-19	1
6438	379	4112343	2001-07-08	2001-07-21	1
12143	720	4112343	2019-05-21	2019-05-31	1
50162	2966	4294548	2014-11-05	2015-07-22	1
47266	2815	372328	1964-08-04	1964-08-18	1
541	32	4112343	1982-07-26	1982-08-08	1
75085	4465	40481087	2016-09-29	2016-10-06	1
85702	5104	4278672	1987-04-08	1987-07-07	1
6439	379	4230399	1977-02-16	1977-03-18	1
12144	720	4278672	1968-08-08	1968-10-07	1
50163	2966	40481087	1991-10-25	1991-11-08	1
47267	2815	4112343	1987-08-12	1987-08-25	1
542	32	4152936	1956-03-20	1956-04-10	1
75086	4465	80180	2010-09-04	2010-09-05	1
85703	5104	372328	1980-06-29	1980-11-08	2
6440	379	40481087	1994-07-08	1994-07-29	1
12145	720	40481087	1972-02-18	1972-02-25	1
50164	2966	40481087	2018-02-05	2018-02-26	1
47268	2815	4112343	1994-01-24	1994-02-06	1
543	32	4152936	1991-03-22	1991-04-12	1
75087	4465	372328	1976-01-11	1976-07-02	1
85704	5104	4027663	2009-11-23	2009-11-24	1
6441	379	40481087	2019-03-06	2019-03-13	1
12146	720	40481087	1975-05-18	1975-06-01	1
50165	2966	40481087	2018-11-02	2018-11-23	1
47269	2815	4112343	1999-02-23	1999-03-06	1
544	32	4278672	1951-07-17	1951-09-15	1
75088	4465	4112343	2009-01-31	2009-02-10	1
85705	5104	40481087	1991-09-09	1991-09-23	1
6442	379	260139	2016-07-28	2016-08-04	1
12147	720	40481087	1989-07-22	1989-08-12	1
50166	2966	317576	2013-11-23	2013-11-24	1
47270	2815	4278672	1996-01-17	1996-04-16	1
545	32	40481087	1985-06-19	1985-06-26	1
75089	4465	40481087	1986-04-13	1986-05-04	1
85706	5104	4112343	2005-06-19	2005-06-26	1
6443	379	4112343	1992-10-11	1992-10-20	1
12148	720	40481087	1998-02-05	1998-02-26	1
50167	2966	4218389	1976-11-06	1976-12-11	1
47271	2815	40481087	1970-09-22	1970-10-13	1
546	32	80809	2000-10-12	2004-09-21	1
75090	4465	4059173	1987-05-04	1987-06-03	1
85707	5104	4112343	2013-08-30	2013-09-07	1
6444	379	260139	1985-06-06	1985-06-13	1
12149	720	40481087	2005-01-12	2005-01-19	1
50168	2966	40481087	1968-04-15	1968-04-22	1
47272	2815	40481087	1984-05-15	1984-06-05	1
547	32	260139	1986-07-05	1986-07-19	1
75091	4465	4112343	2006-03-08	2006-03-15	1
85708	5104	40481087	1994-09-10	1994-10-01	1
6445	379	260139	2014-06-12	2014-06-26	1
12150	720	81151	1997-02-28	1997-03-14	1
50169	2966	192671	2001-02-25	2001-02-26	1
47273	2815	40481087	2006-09-14	2006-09-28	1
548	32	372328	1947-08-07	1947-10-01	1
75092	4465	4218389	1977-07-04	1977-07-25	1
85709	5104	40481087	2011-06-12	2011-06-26	1
6446	379	375671	1985-12-01	1985-12-31	1
12151	720	4156265	1975-05-04	1975-05-25	1
50170	2966	4112343	1983-12-17	1983-12-29	1
47274	2815	260139	2006-01-24	2006-02-07	1
549	32	4112343	1987-03-31	1987-04-09	1
75093	4465	40481087	1978-06-08	1978-06-15	1
85710	5104	40481087	2011-11-29	2011-12-20	1
6447	379	378001	1997-08-30	1997-09-29	1
12152	720	4283893	1966-03-30	1966-11-09	1
50171	2966	4112343	2005-07-08	2005-07-20	1
47275	2815	4112343	1969-09-20	1969-10-02	1
550	32	81151	1955-04-27	1955-05-25	1
75094	4465	40481087	2001-05-26	2001-06-16	1
85711	5104	80180	2017-06-15	2017-06-16	1
6448	379	4112343	1984-09-09	1984-09-20	1
12153	720	28060	2001-09-13	2001-09-23	1
50172	2966	4296204	2002-06-12	2002-07-17	1
47276	2815	4112343	1986-07-06	1986-07-16	1
551	32	260139	1944-06-24	1944-07-01	1
75939	4509	260139	1970-04-16	1970-04-23	1
85712	5104	192671	2017-06-24	2017-06-25	1
6449	379	40481087	1982-09-27	1982-10-04	1
12154	720	192671	2000-11-02	2000-11-03	1
51222	3040	260139	1985-06-17	1985-07-01	1
47277	2815	40481087	1968-06-22	1968-06-29	1
552	32	4027663	1977-10-18	1977-10-19	1
75940	4509	260139	2005-02-19	2005-03-05	1
85713	5104	440086	1991-11-28	1994-05-06	1
12387	733	192671	1980-07-22	1980-07-23	1
12155	720	4112343	2005-07-08	2005-07-21	1
51223	3040	260139	1987-04-24	1987-05-01	1
47278	2815	40481087	1973-03-06	1973-03-27	1
553	32	4112343	1947-08-08	1947-08-15	1
75941	4509	4027663	1997-08-21	1997-08-22	1
85714	5104	4113008	1986-05-29	1986-06-12	1
12388	733	4112343	1956-04-29	1956-05-09	1
12156	720	40481087	2002-06-12	2002-06-19	1
51224	3040	260139	2011-10-02	2011-10-09	1
47279	2815	4112343	1965-08-02	1965-08-10	1
554	32	4112343	1984-07-29	1984-08-11	1
75942	4509	4278672	1978-02-02	1978-04-03	1
85715	5104	4296205	1988-07-31	1988-08-21	1
12389	733	4112343	1978-06-15	1978-06-27	1
12157	720	80180	2000-09-04	2000-09-05	1
51225	3040	440086	1984-02-21	1990-03-01	1
47280	2815	4112343	1998-07-16	1998-07-26	1
555	32	4112343	1998-04-12	1998-04-23	1
75943	4509	4285898	2006-09-08	2006-09-09	1
85716	5104	40481087	1994-01-15	1994-02-05	1
12390	733	4112343	1994-02-16	1994-02-27	1
12158	720	81893	1998-06-17	1998-06-18	1
51226	3040	4112343	2000-05-15	2000-05-26	1
47281	2815	40481087	1977-06-10	1977-07-01	1
556	32	4146173	1979-04-24	1979-06-23	1
75944	4509	40481087	1979-09-20	1979-10-04	1
87275	5200	80180	1989-01-25	1989-01-26	1
12391	733	40481087	1976-05-22	1976-06-05	1
12159	720	4112343	1986-11-05	1986-11-16	1
51227	3040	4294548	1978-10-13	1978-10-27	1
47282	2815	40481087	1977-10-05	1977-10-12	1
557	32	40481087	1991-06-01	1991-06-15	1
75945	4509	80180	2006-11-07	2006-11-08	1
87276	5200	4112343	1978-12-28	1979-01-09	1
12392	733	40481087	1978-04-02	1978-04-23	1
12160	720	4112343	1992-06-18	1992-06-30	1
51228	3040	40481087	1972-10-27	1972-11-03	1
47283	2815	78272	2000-02-25	2000-03-31	1
558	32	80180	1987-04-04	1987-04-05	1
75946	4509	192671	2007-01-25	2007-01-26	1
87277	5200	4156265	1974-05-21	1974-06-11	1
12393	733	80180	1980-05-07	1980-05-08	1
12161	720	4310024	1998-01-18	1998-01-19	1
51229	3040	40481087	1980-01-26	1980-02-09	1
47284	2815	80180	1998-12-24	1998-12-25	1
559	32	192671	1987-06-09	1987-06-10	1
75947	4509	4112343	1986-05-23	1986-06-04	1
87278	5200	134438	1982-08-17	1983-09-15	1
12394	733	81151	1948-07-29	1948-08-26	1
13075	771	28060	1975-05-28	1975-06-06	1
51230	3040	40481087	1993-12-12	1993-12-26	1
47285	2815	260139	1993-06-12	1993-06-26	1
560	32	4113008	1959-04-25	1959-05-09	1
75948	4509	4156265	1991-11-21	1991-12-05	1
87279	5200	372328	1960-06-21	1960-07-27	1
12395	733	372328	2016-05-03	2016-08-18	1
13076	771	4059173	1980-10-17	1980-12-16	1
51231	3040	260139	2010-07-01	2010-07-08	1
47286	2815	4116491	1998-09-05	1998-10-12	1
561	32	4283893	1967-01-29	1967-07-02	1
75949	4509	40481087	2010-05-23	2010-06-13	1
87280	5200	4112343	1978-02-19	1978-02-27	1
12396	733	4112343	1947-09-28	1947-10-10	1
13077	771	4112343	1993-12-31	1994-01-08	1
51232	3040	40481087	1973-05-08	1973-05-22	1
47287	2815	4296204	1973-02-18	1973-03-18	1
562	32	40481087	1979-12-05	1979-12-12	1
75950	4509	261325	1990-04-10	1990-04-11	1
87281	5200	4283893	1991-04-15	1991-07-22	1
12397	733	28060	1944-09-19	1944-09-30	1
13078	771	4218389	1999-09-08	1999-10-13	1
51233	3040	40481087	1973-08-26	1973-09-02	1
48179	2860	195588	2001-11-25	2001-12-31	1
563	32	40481087	2005-08-07	2005-08-21	1
75951	4509	4146173	2003-09-03	2003-10-03	1
87282	5200	40481087	2019-04-20	2019-05-04	1
12398	733	28060	1944-12-31	1945-01-08	1
13079	771	40481087	1961-10-14	1961-10-28	1
51234	3040	40481087	2011-01-05	2011-01-19	1
48180	2860	4112343	1944-12-03	1944-12-13	1
564	32	40481087	2011-05-28	2011-06-11	1
75952	4509	4266809	2006-11-07	2006-11-08	1
87283	5200	81151	1960-08-20	1960-09-03	1
12399	733	81151	1992-01-08	1992-02-05	1
13080	771	40481087	2000-10-12	2000-11-02	1
51235	3040	80180	2010-09-27	2010-09-28	1
48181	2860	28060	1949-10-21	1949-11-02	1
1469	86	28060	1953-05-03	1953-05-15	1
75953	4509	4278672	1968-09-22	1968-11-21	1
87284	5200	260139	1961-04-18	1961-05-02	1
12400	733	4237458	1959-08-29	1959-11-27	1
13081	771	40481087	1961-04-05	1961-04-12	1
51236	3040	4112343	1990-08-22	1990-09-03	1
48182	2860	260139	1952-02-24	1952-03-02	1
1470	86	4152936	2001-04-20	2001-05-11	1
75954	4509	40481087	1978-02-07	1978-02-21	1
87285	5200	260139	1968-05-24	1968-06-07	1
12401	733	40479768	2003-09-05	2003-11-11	1
13082	771	40481087	1962-05-04	1962-05-25	1
51237	3040	40481087	1985-05-22	1985-06-05	1
48183	2860	4059173	1945-05-29	1945-08-27	1
1471	86	40481087	1952-04-12	1952-04-19	1
75955	4509	81893	2005-09-13	2005-09-14	1
87286	5200	372328	2005-07-31	2005-08-14	1
12402	733	40481087	1961-04-29	1961-05-06	1
13083	771	40481087	1974-01-29	1974-02-05	1
51238	3040	40481087	1988-05-26	1988-06-02	1
48184	2860	4112343	1980-02-13	1980-02-21	1
1472	86	40481087	2013-12-18	2014-01-08	1
75956	4509	372328	1977-01-08	1977-05-31	1
87287	5200	4112343	1982-06-25	1982-07-05	1
12403	733	260139	1999-05-04	1999-05-11	1
13084	771	40481087	1979-03-20	1979-04-03	1
51239	3040	40481087	2017-08-24	2017-09-14	1
48185	2860	4283893	1968-09-11	1968-11-27	1
1473	86	28060	1995-11-29	1995-12-07	1
75957	4509	4112343	1994-05-27	1994-06-08	1
87288	5200	4112343	2010-06-09	2010-06-21	1
12404	733	4112343	1993-04-11	1993-04-21	1
13085	771	40481087	1990-12-04	1990-12-25	1
51240	3040	4059173	1976-08-31	1976-11-29	1
48186	2860	40481087	1968-06-21	1968-07-05	1
1474	86	81151	1952-04-03	1952-05-02	1
75958	4509	4310024	2005-01-16	2005-01-17	1
87289	5200	40481087	1980-05-16	1980-06-06	1
12405	733	40481087	2000-10-29	2000-11-19	1
13086	771	260139	1965-04-08	1965-04-15	1
51241	3040	40481087	2019-03-16	2019-04-06	1
48187	2860	80809	2006-10-01	2006-10-02	1
1475	86	4112343	1955-06-05	1955-06-13	1
75959	4509	40481087	1978-09-25	1978-10-16	1
87290	5200	40481087	1996-08-29	1996-09-19	1
13265	782	81151	1914-08-22	1914-09-19	1
13087	771	4112343	1967-05-29	1967-06-05	1
54761	3244	260139	1996-09-10	1996-09-17	1
48188	2860	260139	2004-09-01	2004-09-08	1
1476	86	4112343	2010-11-21	2010-12-02	1
75960	4509	40481087	2003-11-04	2003-11-18	1
87291	5200	78272	1972-07-02	1972-07-30	1
13266	782	260139	1911-12-17	1911-12-31	1
13088	771	40481087	1968-01-18	1968-01-25	1
54762	3244	260139	2007-09-26	2007-10-03	1
48189	2860	4283893	2006-09-01	2006-09-22	1
1477	86	80180	1988-09-02	1988-09-03	1
77329	4587	4112343	1976-11-17	1976-11-24	1
87292	5200	257012	1991-06-17	1991-06-18	1
13267	782	260139	1921-11-16	1921-11-30	1
13089	771	80180	1998-05-19	1998-05-20	1
54763	3244	4112343	2001-05-05	2001-05-12	1
48190	2860	40481087	1952-10-28	1952-11-04	1
1478	86	81151	2014-12-28	2015-01-25	1
77330	4587	4134304	1940-01-17	1940-04-16	1
87293	5200	260139	1966-02-08	1966-02-15	1
13268	782	260139	1950-01-17	1950-01-24	1
13090	771	378001	2010-07-17	2010-08-16	1
54764	3244	80180	2013-07-27	2013-07-28	1
48191	2860	40481087	1972-10-16	1972-10-30	1
1479	86	260139	1952-07-05	1952-07-19	1
77331	4587	4283893	1989-01-05	1989-02-16	1
87294	5200	260139	1995-01-27	1995-02-03	1
13269	782	4112343	1960-10-28	1960-11-08	1
13091	771	4048695	1971-12-02	1972-01-03	1
54765	3244	134438	1991-04-21	1993-03-14	1
48192	2860	40481087	1991-05-30	1991-06-20	1
1480	86	260139	1957-02-23	1957-03-02	1
77332	4587	40479768	1960-04-01	1960-06-07	1
87295	5200	4156265	1982-03-31	1982-04-21	1
13270	782	4149245	1954-06-12	1954-08-18	1
13092	771	4059173	1975-12-13	1976-03-12	1
54766	3244	4112343	1986-01-13	1986-01-23	1
48193	2860	28060	1953-11-14	1953-11-21	1
1481	86	260139	1977-12-14	1977-12-28	1
77333	4587	40481087	1945-05-20	1945-05-27	1
87296	5200	40481087	1997-12-18	1998-01-01	1
13271	782	4155034	1978-12-24	1979-01-07	1
13093	771	40481087	1964-06-22	1964-06-29	1
54767	3244	4112343	2013-06-10	2013-06-22	1
48194	2860	80180	1982-05-25	1982-05-26	1
1482	86	317576	2013-04-30	2013-05-01	1
77334	4587	40481087	1991-01-16	1991-02-06	1
89377	5322	28060	1994-02-18	1994-03-02	1
13272	782	40481087	1961-01-25	1961-02-15	1
13094	771	40481087	1982-06-21	1982-07-12	1
54768	3244	4116491	2013-04-08	2013-05-27	1
48195	2860	257012	1968-10-09	1968-11-27	1
1483	86	4109685	1961-03-15	1961-04-05	1
77335	4587	372328	1936-02-07	1936-03-21	1
89378	5322	81151	2000-09-29	2000-10-27	1
13273	782	40481087	1972-06-25	1972-07-02	1
15004	885	440448	2012-04-05	2012-04-06	1
54769	3244	4152936	1974-04-13	1974-05-04	1
48196	2860	260139	1976-06-27	1976-07-13	1
1484	86	40481087	1954-08-13	1954-08-20	1
77336	4587	378419	2015-01-31	2015-02-01	1
89379	5322	257012	1985-11-07	1985-11-08	1
13274	782	257012	1943-10-01	1943-10-02	1
15005	885	4112343	1976-10-18	1976-10-28	1
54770	3244	40481087	1977-03-06	1977-03-27	1
48197	2860	372328	1946-01-24	1946-06-14	1
1485	86	40481087	1967-05-22	1967-06-05	1
77337	4587	4113008	2004-04-17	2004-05-08	1
89380	5322	372328	1947-06-21	1947-10-01	1
13275	782	4134304	1990-05-09	1990-07-08	1
15006	885	81151	1983-03-02	1983-03-23	1
54771	3244	81151	1980-04-02	1980-04-23	1
48198	2860	372328	1955-09-25	1955-12-02	1
1486	86	40481087	1973-01-10	1973-01-17	1
77338	4587	40481087	1942-05-23	1942-05-30	1
89381	5322	4112343	1973-04-22	1973-04-29	1
13276	782	4155034	1977-11-15	1977-11-29	1
15007	885	372328	1976-07-06	1976-09-19	1
54772	3244	260139	1985-09-14	1985-09-28	1
48199	2860	4112343	1977-03-21	1977-03-29	1
1487	86	28060	1990-03-14	1990-03-27	1
77339	4587	40481087	1976-10-17	1976-10-31	1
89382	5322	40481087	1970-04-12	1970-04-19	1
13277	782	4294548	1953-07-17	1953-09-25	1
15008	885	440086	1987-04-10	1989-02-17	1
54773	3244	4218389	1997-05-24	1997-06-28	1
48200	2860	4112343	2013-06-28	2013-07-06	1
1488	86	81151	1965-11-10	1965-11-24	1
77340	4587	40481087	2010-03-03	2010-03-24	1
89383	5322	81151	1985-11-26	1985-12-17	1
13278	782	28060	1938-09-27	1938-10-10	1
15009	885	4113008	2002-07-11	2002-07-25	1
54774	3244	40481087	2016-05-10	2016-05-17	1
48201	2860	4116491	1996-10-03	1996-11-26	1
1489	86	40481087	2016-12-28	2017-01-18	1
77341	4587	80180	1968-04-24	1968-04-25	1
89384	5322	260139	1989-04-21	1989-04-28	1
13279	782	260139	1963-11-14	1963-11-28	1
15010	885	4237458	1992-12-30	1993-02-28	1
55488	3290	4027663	1997-03-26	1997-03-27	1
48202	2860	4134304	2001-11-01	2001-12-01	1
3159	186	28060	1984-11-15	1984-11-23	1
77342	4587	260139	2003-07-02	2003-07-16	1
89385	5322	4084167	1963-06-27	1963-06-27	1
13280	782	378419	1994-05-15	1994-05-16	1
15011	885	28060	1984-03-22	1984-04-04	1
55489	3290	4294548	1971-07-28	1971-08-04	1
48203	2860	40481087	1999-09-11	1999-10-02	1
3160	186	378001	1998-04-03	1998-05-04	1
77343	4587	317576	2003-07-12	2003-07-13	1
89386	5322	4112343	1978-03-05	1978-03-12	1
13281	782	4112343	1963-08-28	1963-09-07	1
15012	885	372328	1979-12-03	1980-03-23	1
55490	3290	4310024	2002-05-24	2002-05-25	1
48204	2860	40481087	2014-01-20	2014-01-27	1
3161	186	4109685	2005-02-25	2005-03-18	1
77344	4587	4112343	1953-08-07	1953-08-19	1
89387	5322	4237458	2014-03-18	2014-05-17	1
13282	782	4294548	1943-09-10	1943-10-08	1
15013	885	372328	1993-12-10	1994-05-29	1
55491	3290	40481087	1981-02-03	1981-02-10	1
49059	2906	28060	1947-07-11	1947-07-24	1
3162	186	195588	2012-11-10	2012-12-29	1
77345	4587	40481087	1952-10-25	1952-11-15	1
89388	5322	40481087	1970-06-25	1970-07-16	1
13283	782	4296204	1913-07-07	1913-07-28	1
15014	885	40481087	1988-12-18	1989-01-01	1
55492	3290	40481087	1990-12-10	1990-12-17	1
49060	2906	78272	1982-04-30	1982-05-14	1
3163	186	260139	1995-06-21	1995-06-28	1
77346	4587	40481087	2013-01-13	2013-01-20	1
89389	5322	40481087	1976-09-26	1976-10-10	1
13284	782	40480160	1990-05-09	1990-07-08	1
15015	885	0	2012-04-05	2012-04-06	1
55493	3290	40481087	2011-03-10	2011-03-31	1
49061	2906	260139	1977-01-15	1977-01-22	1
3164	186	4112343	2012-11-28	2012-12-09	1
77347	4587	260139	1967-02-25	1967-03-04	1
89390	5322	40481087	1993-01-27	1993-02-10	1
13285	782	40481087	1918-08-19	1918-09-02	1
15016	885	80180	2018-11-23	2018-11-24	1
55494	3290	192671	2004-06-29	2004-06-30	1
49062	2906	372328	1929-12-26	1930-03-29	1
3165	186	4134304	1981-09-30	1981-10-29	1
77348	4587	381316	2017-11-18	2017-11-19	1
89391	5322	40486433	1950-01-28	1950-01-29	1
13286	782	40481087	1997-12-24	1998-01-07	1
15017	885	4112343	1976-01-09	1976-01-19	1
55495	3290	4112343	1987-12-10	1987-12-17	1
49063	2906	372328	2009-09-30	2010-06-19	1
3166	186	80180	2010-07-05	2010-07-06	1
77349	4587	4059173	2011-09-29	2011-11-28	1
89392	5322	28060	2009-07-14	2009-07-24	1
13287	782	80180	1944-10-27	1944-10-28	1
15018	885	4112343	2013-01-06	2013-01-17	1
55496	3290	40481087	1972-01-10	1972-01-17	1
49064	2906	4112343	1924-06-13	1924-06-25	1
3167	186	372328	2009-07-05	2010-12-12	1
77350	4587	4112343	1978-07-20	1978-07-29	1
89393	5322	133834	1947-02-28	1964-10-12	1
13288	782	80502	1982-03-07	1982-03-08	1
15019	885	40481087	1978-07-31	1978-08-07	1
55497	3290	40481087	1984-08-18	1984-08-25	1
49065	2906	4112343	1931-12-20	1931-12-30	1
3168	186	4048171	1973-11-27	1973-11-28	1
77351	4587	4112343	2004-10-12	2004-10-23	1
89394	5322	260139	1964-02-24	1964-03-09	1
13289	782	81151	1949-12-14	1950-01-04	1
15020	885	40481087	2015-07-20	2015-07-27	1
55498	3290	40481087	1998-12-10	1998-12-24	1
49066	2906	4294548	1992-11-24	1993-05-18	1
3169	186	4084167	1972-11-15	1972-11-16	1
77352	4587	4134304	2018-04-25	2018-06-24	1
89395	5322	372328	1949-01-23	1949-06-29	1
13290	782	260139	1913-03-27	1913-04-03	1
15530	921	313217	2016-06-21	2016-06-22	1
55499	3290	78272	1991-01-07	1991-02-11	1
49067	2906	40481087	1968-03-20	1968-03-27	1
3170	186	4084167	1975-01-08	1975-01-09	1
77353	4587	40481087	1937-11-03	1937-11-10	1
89396	5322	4051466	1951-01-28	1966-05-12	1
13291	782	4112343	1945-06-09	1945-06-19	1
15531	921	378001	2002-10-02	2002-12-01	1
55500	3290	257012	1974-12-19	1974-12-20	1
49068	2906	40481087	1985-05-31	1985-06-14	1
3171	186	40481087	1973-01-22	1973-02-05	1
77354	4587	40481087	1940-02-05	1940-02-26	1
89397	5322	4283893	1985-08-29	1985-12-26	1
13292	782	4112343	1949-07-30	1949-08-09	1
15532	921	4094814	1989-01-22	1989-02-21	1
55501	3290	260139	1970-03-29	1970-04-05	1
49069	2906	40481087	1986-04-15	1986-04-22	1
3172	186	40481087	1976-05-28	1976-06-04	1
77355	4587	40481087	2012-07-18	2012-08-08	1
89398	5322	4294548	1974-01-05	1974-02-02	1
13293	782	4112343	1951-12-28	1952-01-10	1
15533	921	4112343	2009-08-05	2009-08-16	1
55502	3290	260139	1990-01-10	1990-01-24	1
49070	2906	80502	2014-07-12	2014-07-13	1
3173	186	40481087	2001-12-01	2001-12-22	1
77356	4587	40481087	2018-05-31	2018-06-14	1
89399	5322	40480160	2014-03-18	2014-05-17	1
13294	782	4283893	1955-10-21	1956-07-13	1
15534	921	4155034	1968-05-11	1968-05-25	1
55503	3290	375671	2006-05-07	2006-07-06	1
49071	2906	192671	1965-07-06	1965-07-07	1
3174	186	40481087	2012-12-01	2012-12-08	1
79028	4685	28060	1953-10-01	1953-10-09	1
89400	5322	40481087	1967-03-14	1967-03-21	1
13295	782	40481087	1941-10-06	1941-10-13	1
15535	921	40481087	1989-09-26	1989-10-17	1
55504	3290	4155034	1997-12-06	1997-12-20	1
49072	2906	195588	1982-05-20	1982-06-20	1
3175	186	133834	1972-06-26	1989-04-24	1
79029	4685	78272	1955-06-08	1955-07-06	1
89401	5322	40481087	2014-06-28	2014-07-12	1
13296	782	40481087	1951-03-09	1951-03-23	1
15536	921	40481087	1998-08-07	1998-08-14	1
55505	3290	4283893	1974-12-05	1975-08-28	1
49073	2906	372328	1924-11-08	1924-12-20	1
3176	186	260139	1991-01-11	1991-01-25	1
79030	4685	81893	1971-03-25	1971-03-26	1
89402	5322	78272	1962-02-02	1962-03-02	1
13297	782	40481087	1999-01-07	1999-01-28	1
15537	921	40481087	2001-01-06	2001-01-13	1
55506	3290	40481087	1982-09-12	1982-09-19	1
49074	2906	4035415	1956-11-23	1957-01-22	1
3177	186	4084167	1991-07-18	1991-07-18	1
79031	4685	372328	1940-04-01	1940-05-13	1
89403	5322	80180	1982-06-02	1982-06-03	1
16744	994	28060	2007-02-06	2007-02-15	1
15538	921	81151	1971-01-10	1971-02-07	1
55507	3290	40481087	2003-01-09	2003-01-16	1
49075	2906	4155034	1940-05-09	1940-05-30	1
3178	186	4112343	1998-06-18	1998-06-29	1
79032	4685	372328	1974-09-24	1976-12-06	1
89404	5322	80502	2007-05-09	2007-05-10	1
16745	994	4112343	1961-07-12	1961-07-21	1
15539	921	40481087	2015-03-29	2015-04-12	1
55508	3290	28060	1979-09-09	1979-09-22	1
49076	2906	40481087	1949-06-25	1949-07-02	1
3179	186	4112343	2012-10-17	2012-10-27	1
79033	4685	4112343	1948-07-18	1948-07-30	1
89405	5322	372328	1949-08-28	1950-01-18	1
16746	994	4112343	1992-09-07	1992-09-20	1
15540	921	81151	2007-07-08	2007-08-12	1
55509	3290	28060	1998-06-26	1998-07-04	1
49077	2906	40481087	2018-04-10	2018-04-17	1
3180	186	4112343	2019-03-12	2019-03-21	1
79034	4685	40481087	1973-11-15	1973-12-06	1
89406	5322	4112343	1949-07-12	1949-07-24	1
16747	994	40481087	2011-08-16	2011-08-23	1
15541	921	4156265	1981-04-13	1981-05-04	1
55510	3290	80180	2004-06-12	2004-06-13	1
49078	2906	28060	2004-06-10	2004-06-18	1
3181	186	40481087	1982-05-10	1982-05-17	1
79035	4685	260139	1967-05-12	1967-05-19	1
16748	994	260139	1969-10-29	1969-11-05	1
15542	921	4296204	2011-07-22	2011-08-26	1
55511	3290	260139	1985-01-18	1985-02-01	1
49079	2906	78272	1958-11-13	1958-12-18	1
3182	186	40481087	1989-12-14	1989-12-28	1
79036	4685	372328	1957-12-10	1958-11-17	1
16749	994	260139	2002-06-16	2002-06-30	1
15543	921	40481087	1974-02-14	1974-02-21	1
55512	3290	4112343	2011-07-28	2011-08-08	1
49080	2906	81151	2014-02-25	2014-03-18	1
4875	287	28060	2003-02-16	2003-02-25	1
79037	4685	4112343	1949-04-28	1949-05-10	1
16750	994	4027663	1990-07-14	1990-07-15	1
15544	921	40481087	2002-02-12	2002-02-26	1
55513	3290	4266809	2004-06-12	2004-06-13	1
49081	2906	195588	1979-03-30	1979-05-21	1
4876	287	378001	1990-06-30	1990-08-29	1
79038	4685	4134304	1975-01-22	1975-04-22	1
16751	994	40481087	1965-11-26	1965-12-03	1
15545	921	80180	2004-04-02	2004-04-03	1
55514	3290	4296204	2017-12-05	2017-12-19	1
49082	2906	257012	1993-03-02	1993-03-03	1
4877	287	4027663	2002-03-08	2002-03-09	1
79039	4685	4310024	1971-01-24	1971-01-25	1
16752	994	40481087	1968-03-28	1968-04-18	1
15546	921	260139	2004-02-04	2004-02-18	1
55515	3290	40481087	1973-08-14	1973-09-04	1
49083	2906	260139	1970-03-14	1970-03-21	1
4878	287	4112343	1994-05-09	1994-05-19	1
79040	4685	40481087	1945-04-11	1945-05-02	1
16753	994	40481087	1982-12-07	1982-12-21	1
15547	921	4109685	1999-12-26	2000-01-16	1
55516	3290	40481087	1989-10-03	1989-10-10	1
49084	2906	260139	1977-03-24	1977-04-07	1
4879	287	30753	2012-03-31	2012-04-01	1
79041	4685	40481087	1967-12-07	1967-12-14	1
16754	994	372328	1962-08-05	1962-12-26	1
15548	921	4134304	1983-03-25	1983-06-23	1
55517	3290	40481087	2015-04-14	2015-04-21	1
49085	2906	4152936	1971-03-15	1971-03-29	1
4880	287	4112343	1978-01-04	1978-01-17	1
79042	4685	80180	1971-11-20	1971-11-21	1
16755	994	4112343	2008-10-11	2008-10-19	1
15549	921	4296204	1972-03-03	1972-03-31	1
55518	3290	40481087	2018-11-07	2018-11-28	1
49086	2906	4156265	1936-08-14	1936-08-28	1
4881	287	4112343	2013-12-31	2014-01-10	1
79043	4685	81151	1950-07-13	1950-08-03	1
16756	994	80180	1998-10-30	1998-10-31	1
15550	921	40481087	1977-06-11	1977-06-25	1
56237	3337	260139	2010-07-24	2010-07-31	1
49087	2906	40481087	1925-12-08	1925-12-22	1
4882	287	4294548	2018-05-15	2018-05-29	1
79044	4685	381316	1992-05-25	1992-05-26	1
16757	994	378001	1993-02-23	1993-04-24	1
17945	1081	80180	2001-03-24	2001-03-25	1
56238	3337	321042	1983-12-05	1983-12-06	1
49088	2906	40481087	1951-07-27	1951-08-10	1
4883	287	40481087	2013-04-29	2013-05-20	1
79045	4685	4112343	1944-06-13	1944-06-20	1
16758	994	40481087	1999-12-31	2000-01-07	1
17946	1081	4112343	1995-09-30	1995-10-10	1
56239	3337	378001	1992-09-06	1992-11-05	1
49089	2906	28060	1962-10-04	1962-10-16	1
4884	287	40481087	2014-01-22	2014-01-29	1
79046	4685	4112343	1957-11-19	1957-12-01	1
17863	1076	80180	2013-08-19	2013-08-20	1
17947	1081	40481087	1965-06-01	1965-06-15	1
56240	3337	4112343	1972-03-28	1972-04-10	1
49090	2906	80180	1965-06-11	1965-06-12	1
4885	287	28060	1993-07-01	1993-07-09	1
79047	4685	4112343	1961-02-17	1961-02-25	1
17864	1076	260139	1974-05-07	1974-05-14	1
17948	1081	40481087	1984-05-20	1984-05-27	1
56241	3337	40481087	1986-03-23	1986-04-06	1
49091	2906	372328	1925-05-19	1925-06-20	1
4886	287	81893	2011-09-03	2011-09-04	1
79048	4685	4218389	1941-09-23	1941-10-28	1
17865	1076	260139	1976-04-10	1976-04-17	1
17949	1081	40481087	1997-09-05	1997-09-19	1
56242	3337	0	1983-12-05	1983-12-06	1
49092	2906	378419	2009-06-13	2009-06-14	1
4887	287	260139	2002-05-07	2002-05-21	1
79049	4685	4285898	1971-08-22	1971-08-23	1
17866	1076	372328	1976-01-26	1976-04-16	1
17950	1081	28060	2003-07-01	2003-07-09	1
56243	3337	260139	2019-06-10	2019-06-17	1
49093	2906	4112343	2009-03-26	2009-04-08	1
4888	287	4266809	2013-04-25	2013-04-26	1
79050	4685	40481087	1957-08-31	1957-09-21	1
17867	1076	4112343	2005-05-08	2005-05-16	1
17951	1081	260139	1985-01-19	1985-02-02	1
56244	3337	4112343	1991-08-31	1991-09-12	1
49094	2906	4146173	1929-01-16	1929-03-24	1
4889	287	40481087	1994-08-02	1994-08-09	1
79051	4685	28060	1944-08-21	1944-09-03	1
17868	1076	4112343	2009-06-26	2009-07-04	1
17952	1081	260139	2001-06-26	2001-07-03	1
56245	3337	4237458	1977-08-26	1977-09-25	1
49095	2906	4156265	1941-05-25	1941-06-15	1
4890	287	40481087	2011-06-20	2011-07-04	1
79052	4685	28060	1952-01-28	1952-02-06	1
17869	1076	4278672	1980-10-01	1980-12-30	1
17953	1081	40481087	2004-07-21	2004-07-28	1
56246	3337	40481087	1981-02-13	1981-03-06	1
49096	2906	4278672	1934-08-25	1934-10-24	1
4891	287	80180	2013-04-25	2013-04-26	1
79053	4685	195588	1974-08-26	1974-10-19	1
17870	1076	40481087	1984-09-27	1984-10-04	1
17954	1081	28060	2018-04-25	2018-05-07	1
56247	3337	80180	2007-02-15	2007-02-16	1
49097	2906	4294548	1999-08-24	1999-10-12	1
4892	287	81151	1995-03-05	1995-03-19	1
79054	4685	4027663	1964-08-28	1964-08-29	1
17871	1076	40481087	1994-07-19	1994-08-09	1
17955	1081	4112343	1962-09-14	1962-09-27	1
56248	3337	260139	1982-07-03	1982-07-17	1
49098	2906	40481087	1938-04-26	1938-05-17	1
4893	287	260139	1976-10-13	1976-10-20	1
79055	4685	40481087	1947-05-30	1947-06-20	1
17872	1076	28060	1981-05-31	1981-06-11	1
17956	1081	4112343	1964-09-17	1964-09-26	1
56249	3337	260139	1991-08-29	1991-09-12	1
49099	2906	40481087	1971-09-15	1971-09-22	1
4894	287	260139	2014-08-28	2014-09-04	1
79056	4685	40481087	1970-03-09	1970-03-30	1
17873	1076	40481087	1975-01-08	1975-01-29	1
17957	1081	40481087	1981-02-23	1981-03-02	1
56250	3337	40481087	2007-11-17	2007-12-01	1
49100	2906	40481087	1982-05-05	1982-05-12	1
4895	287	372328	1977-10-06	1978-01-15	1
84358	5022	260139	1987-08-29	1987-09-12	1
17874	1076	40481087	1975-11-01	1975-11-08	1
17958	1081	40481087	1981-12-05	1981-12-26	1
56251	3337	40481087	1984-07-23	1984-07-30	1
53400	3168	28060	1988-09-07	1988-09-18	1
4896	287	4112343	1997-02-03	1997-02-16	1
84359	5022	4112343	1975-04-25	1975-05-02	1
17875	1076	40481087	1990-10-11	1990-11-01	1
17959	1081	40481087	1993-01-15	1993-01-22	1
56252	3337	40481087	1985-02-04	1985-02-18	1
53401	3168	4112343	1997-02-06	1997-02-15	1
4897	287	40481087	1989-12-09	1989-12-16	1
84360	5022	4112343	2000-11-16	2000-11-28	1
17876	1076	40481087	2003-01-02	2003-01-23	1
17960	1081	257012	1980-01-04	1980-01-05	1
56253	3337	40481087	2007-05-23	2007-06-13	1
53402	3168	80180	2015-09-27	2015-09-28	1
8534	499	4084167	1959-10-21	1959-10-21	1
84361	5022	40481087	1998-01-01	1998-01-08	1
17877	1076	40481087	2008-04-01	2008-04-15	1
17961	1081	260139	1963-03-10	1963-03-17	1
58251	3455	0	1991-05-21	1991-05-22	1
53403	3168	81151	2007-10-22	2007-11-19	1
8535	499	4113008	1987-02-26	1987-03-12	1
84362	5022	40481087	2000-07-27	2000-08-10	1
17878	1076	192671	2013-09-07	2013-09-08	1
17962	1081	260139	1977-12-09	1977-12-23	1
58252	3455	4296205	2012-08-08	2012-08-29	1
53404	3168	260139	2003-10-17	2003-10-24	1
8536	499	40481087	2001-05-25	2001-06-15	1
84363	5022	40481087	2003-01-06	2003-01-20	1
17879	1076	4134304	1981-12-25	1982-02-23	1
17963	1081	4112343	1984-07-15	1984-07-26	1
58253	3455	40481087	1979-08-08	1979-08-29	1
53405	3168	260139	2012-06-09	2012-06-16	1
8537	499	80180	1997-08-02	1997-08-03	1
84364	5022	40481087	2003-07-24	2003-08-14	1
23794	1425	28060	1945-11-04	1945-11-16	1
17964	1081	4283893	1979-12-07	1980-02-22	1
58254	3455	40481087	1989-11-13	1989-12-04	1
53406	3168	4142905	1981-12-09	1982-01-08	1
8538	499	260139	1976-06-19	1976-07-03	1
84365	5022	40481087	2013-01-20	2013-01-27	1
23795	1425	372328	1937-01-19	1937-02-02	1
20574	1237	260139	1971-02-18	1971-02-25	1
58255	3455	40481087	2009-11-28	2009-12-12	1
53407	3168	4230399	2008-10-14	2009-01-12	1
8539	499	260139	1989-08-29	1989-09-12	1
84366	5022	80180	2005-06-05	2005-06-06	1
23796	1425	4146173	1993-06-27	1993-08-26	1
20575	1237	378001	1990-12-31	1991-03-01	1
58256	3455	28060	1983-01-15	1983-01-26	1
53408	3168	40481087	2003-05-24	2003-05-31	1
8540	499	260139	1997-03-17	1997-03-31	1
84367	5022	81151	1974-04-29	1974-05-27	1
23797	1425	40481087	1950-09-11	1950-10-02	1
20576	1237	4112343	1948-12-17	1948-12-25	1
58257	3455	81151	2017-09-02	2017-10-07	1
53409	3168	81151	2003-02-17	2003-03-17	1
8541	499	260139	2009-12-25	2010-01-01	1
84368	5022	4027663	1994-12-25	1994-12-26	1
23798	1425	40481087	2018-04-09	2018-04-23	1
20577	1237	4152936	1981-09-05	1981-09-19	1
58258	3455	372328	1971-03-17	1971-05-03	1
53410	3168	4059173	1987-03-13	1987-06-11	1
8542	499	4051466	1962-04-30	1978-08-07	1
84369	5022	4109685	1986-01-24	1986-02-07	1
23799	1425	80180	1977-01-04	1977-01-05	1
20578	1237	4278672	1950-02-20	1950-04-21	1
58259	3455	4278672	2014-08-19	2014-09-18	1
53411	3168	4278672	2010-12-03	2011-03-03	1
8543	499	4112343	2000-05-22	2000-06-02	1
84370	5022	4112343	2006-12-29	2007-01-08	1
23800	1425	260139	1946-08-01	1946-08-15	1
20579	1237	260139	1971-01-11	1971-01-18	1
58260	3455	40481087	1971-02-21	1971-03-14	1
53412	3168	40481087	2015-10-30	2015-11-13	1
8544	499	4112343	2002-04-27	2002-05-10	1
84371	5022	40481087	1979-01-10	1979-01-17	1
23801	1425	260139	1961-10-23	1961-11-06	1
20580	1237	260139	1979-07-15	1979-07-29	1
58261	3455	80180	2009-11-02	2009-11-03	1
53413	3168	40481087	2018-07-05	2018-07-26	1
8545	499	4112343	2006-04-20	2006-04-28	1
84372	5022	40481087	1984-10-26	1984-11-16	1
23802	1425	260139	1996-04-17	1996-04-24	1
20581	1237	4112343	1956-05-04	1956-05-15	1
58262	3455	260139	2000-05-15	2000-05-29	1
54145	3212	80180	2018-05-10	2018-05-11	1
8546	499	4280726	1963-04-30	1993-07-16	1
84373	5022	40481087	1991-02-22	1991-03-15	1
23803	1425	372328	1939-10-20	1940-11-05	1
20582	1237	4152936	1948-05-17	1948-05-31	1
58263	3455	4029498	1991-05-21	1991-05-22	1
54146	3212	440086	1992-07-25	1999-08-03	1
8547	499	133834	1959-10-28	1976-10-03	1
84374	5022	40481087	1999-12-04	1999-12-25	1
23804	1425	4109685	1947-08-09	1947-08-23	1
20583	1237	40481087	1989-04-18	1989-05-02	1
58264	3455	4112343	1991-03-17	1991-03-26	1
54147	3212	4218389	1996-05-15	1996-06-19	1
8548	499	260139	1963-10-01	1963-10-15	1
84375	5022	260139	1978-01-10	1978-01-17	1
23805	1425	4112343	1990-02-08	1990-02-19	1
20584	1237	0	1950-09-30	1950-10-01	1
58265	3455	4112343	2008-06-10	2008-06-19	1
54148	3212	78272	2006-10-25	2006-11-22	1
8549	499	260139	1973-05-20	1973-06-03	1
84376	5022	378001	1995-01-12	1995-03-13	1
23806	1425	4294548	1995-12-09	1995-12-30	1
20585	1237	28060	1949-06-25	1949-07-08	1
58266	3455	4116491	1998-05-19	1998-07-18	1
54149	3212	260139	2000-12-10	2000-12-24	1
8550	499	4084167	1972-03-18	1972-03-19	1
84377	5022	4112343	1984-04-16	1984-04-26	1
23807	1425	40479768	1954-06-17	1954-08-23	1
20586	1237	260139	1951-08-01	1951-08-15	1
58267	3455	4112343	2006-03-11	2006-03-19	1
54150	3212	4112343	2006-08-18	2006-08-27	1
8551	499	40481087	1960-10-22	1960-10-29	1
84378	5022	4116491	1992-12-25	1993-01-28	1
23808	1425	40481087	1967-06-11	1967-07-02	1
20587	1237	440448	1950-09-30	1950-10-01	1
61479	3637	4310024	1998-06-06	1998-06-07	1
54151	3212	4112343	2015-11-10	2015-11-19	1
8552	499	40481087	1995-10-13	1995-11-03	1
84379	5022	40481087	1997-11-16	1997-11-23	1
23809	1425	40481087	1969-07-29	1969-08-05	1
20588	1237	4112343	1963-07-09	1963-07-19	1
61480	3637	40481087	1964-01-04	1964-01-11	1
54152	3212	4294548	2012-05-23	2012-06-20	1
8553	499	372328	1961-12-09	1962-03-30	1
84380	5022	81151	2010-01-23	2010-02-27	1
23810	1425	40481087	1976-09-05	1976-09-26	1
20589	1237	4112343	1967-09-28	1967-10-11	1
61481	3637	40481087	1971-07-10	1971-07-24	1
54153	3212	198809	2018-07-21	2018-07-21	1
8554	499	40481087	1962-08-27	1962-09-17	1
84381	5022	192671	2005-06-19	2005-06-20	1
23811	1425	4152936	1938-06-13	1938-06-27	1
20590	1237	80180	1983-10-06	1983-10-07	1
61482	3637	40481087	1978-12-27	1979-01-17	1
54154	3212	260139	1988-07-09	1988-07-16	1
8555	499	40481087	1963-09-20	1963-10-11	1
84382	5022	372328	1972-09-06	1972-12-11	1
23812	1425	40481087	1989-06-28	1989-07-05	1
20591	1237	258780	1989-04-23	1989-04-24	1
61483	3637	81893	1999-04-02	1999-04-03	1
54155	3212	260139	2009-04-30	2009-05-14	1
8556	499	40481087	1972-11-27	1972-12-04	1
84383	5022	4059173	1977-07-10	1977-09-08	1
23813	1425	81151	1987-09-29	1987-10-27	1
20592	1237	372328	1947-04-23	1947-09-07	1
61484	3637	40481087	1974-02-05	1974-02-12	1
54156	3212	4116491	2016-07-19	2016-09-09	1
8557	499	40481087	1998-05-28	1998-06-04	1
84384	5022	4112343	1991-06-22	1991-07-05	1
23814	1425	375671	1967-03-18	1967-04-17	1
27316	1612	381316	2014-04-16	2014-04-17	1
61485	3637	40481087	1994-03-27	1994-04-03	1
54157	3212	40481087	2006-07-07	2006-07-28	1
8558	499	40481087	2011-05-29	2011-06-05	1
84385	5022	4155034	1992-01-07	1992-01-28	1
23815	1425	4112343	1946-03-19	1946-03-28	1
27317	1612	4112343	2014-08-24	2014-09-04	1
61486	3637	40481087	2014-05-25	2014-06-08	1
54158	3212	81151	1986-08-31	1986-10-05	1
10043	597	28060	1962-06-14	1962-06-26	1
84386	5022	4230399	1984-05-04	1984-06-03	1
23816	1425	40481087	1937-04-26	1937-05-17	1
27318	1612	4113008	1971-05-20	1971-06-03	1
61487	3637	40481087	2019-01-21	2019-02-11	1
54159	3212	196456	2018-07-21	2018-07-21	1
10044	597	28060	1963-03-26	1963-04-04	1
84387	5022	40481087	2007-01-31	2007-02-14	1
25319	1511	80180	2010-01-29	2010-01-30	1
27319	1612	40481087	1964-05-01	1964-05-22	1
61488	3637	30753	2000-01-27	2000-01-28	1
54160	3212	260139	1987-05-30	1987-06-13	1
10045	597	30753	1986-03-23	1986-03-24	1
85572	5096	81151	2019-03-11	2019-04-15	1
25320	1511	260139	2009-04-27	2009-05-11	1
27320	1612	40481087	1989-08-07	1989-08-21	1
61489	3637	260139	1973-04-09	1973-04-16	1
54161	3212	260139	1991-09-30	1991-10-14	1
10046	597	81151	1967-09-14	1967-09-28	1
85573	5096	260139	1993-11-07	1993-11-21	1
25321	1511	4218389	2000-09-09	2000-10-14	1
27321	1612	40481087	1996-04-23	1996-05-07	1
61490	3637	260139	2018-08-04	2018-08-18	1
54162	3212	260139	1992-11-08	1992-11-22	1
10047	597	4027663	1980-04-28	1980-04-29	1
85574	5096	4112343	1968-10-06	1968-10-18	1
25322	1511	4230399	1974-11-04	1974-12-04	1
27322	1612	80180	2003-05-07	2003-05-08	1
61491	3637	372328	1964-11-21	1965-07-06	1
54163	3212	260139	1995-09-18	1995-10-02	1
10048	597	40481087	2016-01-05	2016-01-19	1
85575	5096	257012	1981-10-24	1981-10-25	1
25323	1511	40481087	1992-06-21	1992-06-28	1
27323	1612	372328	1966-11-11	1967-01-03	1
61492	3637	4027663	1989-07-13	1989-07-14	1
54164	3212	40481087	1988-12-25	1989-01-01	1
10049	597	28060	2003-06-21	2003-06-29	1
85576	5096	260139	1971-03-25	1971-04-08	1
25324	1511	0	2010-04-15	2010-04-16	1
27324	1612	4112343	1969-09-29	1969-10-06	1
61493	3637	4112343	1966-10-16	1966-10-27	1
54165	3212	40481087	2009-05-19	2009-06-02	1
10050	597	192671	1987-04-14	1987-04-15	1
85577	5096	260139	1985-01-30	1985-02-13	1
25325	1511	260139	2014-07-23	2014-07-30	1
27325	1612	4112343	2011-08-28	2011-09-08	1
61494	3637	4112343	1993-07-25	1993-08-04	1
57648	3423	81151	1979-12-20	1980-01-03	1
10051	597	260139	1966-10-06	1966-10-13	1
85578	5096	372328	1972-11-12	1973-04-12	1
25326	1511	4112343	1970-03-02	1970-03-09	1
27326	1612	40481087	1969-12-29	1970-01-19	1
61495	3637	40481087	1973-04-20	1973-05-04	1
57649	3423	440448	2007-03-14	2007-03-15	1
10052	597	260139	2003-09-08	2003-09-22	1
85579	5096	4112343	1980-08-17	1980-08-30	1
25327	1511	4218389	2003-06-01	2003-07-06	1
27327	1612	40481087	1998-09-15	1998-09-29	1
61496	3637	40481087	1990-01-25	1990-02-08	1
57650	3423	4112343	1998-11-19	1998-11-29	1
10053	597	4296205	2012-07-27	2012-08-17	1
85580	5096	4112343	2014-10-03	2014-10-13	1
25328	1511	40481087	1986-01-12	1986-02-02	1
27328	1612	40481087	2002-06-28	2002-07-05	1
61497	3637	40481087	2003-09-20	2003-10-11	1
57651	3423	4156265	1986-10-28	1986-11-18	1
10054	597	40481087	2012-06-10	2012-06-17	1
85581	5096	4146173	1975-11-27	1976-01-26	1
25329	1511	40481087	2000-07-24	2000-08-07	1
27329	1612	40481087	2016-01-26	2016-02-09	1
61498	3637	28060	1970-11-09	1970-11-19	1
57652	3423	40481087	1984-06-15	1984-06-22	1
10055	597	80180	1987-01-17	1987-01-18	1
85582	5096	4283893	1981-10-03	1981-12-19	1
25330	1511	40481087	2005-09-19	2005-10-03	1
27330	1612	260139	1965-09-19	1965-09-26	1
61499	3637	80180	2001-01-21	2001-01-22	1
57653	3423	40481087	2007-09-25	2007-10-02	1
10056	597	81151	2001-11-26	2001-12-31	1
85583	5096	40481087	1991-09-05	1991-09-19	1
25331	1511	260139	1966-01-22	1966-02-05	1
27331	1612	4296204	1982-01-19	1982-02-02	1
57654	3423	260139	2010-10-25	2010-11-01	1
10057	597	81151	2005-10-11	2005-11-01	1
85584	5096	260139	2000-09-02	2000-09-16	1
25332	1511	378001	1979-09-09	1979-10-09	1
27332	1612	40481087	2001-10-18	2001-10-25	1
57655	3423	4027663	2005-03-13	2005-03-14	1
10058	597	260139	1977-07-02	1977-07-16	1
85585	5096	372328	2001-02-14	2002-11-28	1
25333	1511	4109685	1981-08-29	1981-09-19	1
27333	1612	4051466	1966-08-06	1982-12-14	1
57656	3423	4112343	2011-09-24	2011-10-06	1
10059	597	4112343	2016-03-24	2016-04-02	1
85586	5096	40481087	2012-05-10	2012-05-17	1
25334	1511	4166224	2010-04-15	2010-04-16	1
27334	1612	4152936	1976-02-06	1976-02-20	1
57657	3423	40481087	1981-12-09	1981-12-23	1
10060	597	4116491	2006-04-22	2006-06-08	1
85587	5096	80180	2008-08-20	2008-08-21	1
25335	1511	260139	2007-01-28	2007-02-04	1
27335	1612	40481087	1980-11-28	1980-12-12	1
57658	3423	40481087	2010-05-27	2010-06-10	1
10061	597	4155034	1984-06-30	1984-07-14	1
85588	5096	260139	1989-04-29	1989-05-13	1
25336	1511	372328	1968-08-07	1969-01-26	1
27336	1612	40481087	1997-02-06	1997-02-13	1
57659	3423	40481087	2012-12-05	2012-12-12	1
10062	597	4310024	1985-05-27	1985-05-28	1
88778	5284	80180	2008-07-29	2008-07-30	1
25337	1511	440448	2010-04-15	2010-04-16	1
57660	3423	0	2007-03-14	2007-03-15	1
10063	597	28060	1970-06-30	1970-07-13	1
88779	5284	260139	1969-11-08	1969-11-15	1
25338	1511	4112343	1972-04-01	1972-04-13	1
57661	3423	28060	1993-08-03	1993-08-15	1
10064	597	81151	1985-08-08	1985-08-22	1
88780	5284	260139	1971-07-24	1971-07-31	1
25339	1511	4112343	2002-07-08	2002-07-18	1
57662	3423	80180	2012-01-31	2012-02-01	1
10065	597	260139	1964-11-29	1964-12-06	1
88781	5284	260139	2010-08-07	2010-08-21	1
25340	1511	4116491	2006-04-15	2006-06-04	1
57663	3423	260139	1992-04-16	1992-04-30	1
10066	597	260139	1993-09-05	1993-09-19	1
88782	5284	4299128	2002-05-17	2002-05-31	1
25341	1511	4142905	2012-12-15	2013-02-13	1
10067	597	260139	2015-07-27	2015-08-03	1
88783	5284	40481087	2003-07-14	2003-08-04	1
25342	1511	40481087	1991-06-13	1991-06-20	1
10068	597	40481087	1954-10-30	1954-11-06	1
88784	5284	40481087	2006-08-24	2006-09-14	1
28821	1709	80180	1978-02-26	1978-02-27	1
11777	697	378001	2016-05-30	2016-07-29	1
88785	5284	28060	1973-12-19	1974-01-01	1
28822	1709	4112343	1955-04-28	1955-05-06	1
11778	697	4152936	1973-08-30	1973-09-13	1
88786	5284	372328	1969-03-11	1969-07-30	1
28823	1709	4112343	1978-03-19	1978-03-27	1
11779	697	40481087	2000-05-22	2000-06-05	1
88787	5284	440086	1980-08-20	1981-02-25	1
28824	1709	4112343	1990-08-23	1990-09-03	1
11780	697	260139	1989-03-28	1989-04-04	1
88788	5284	4112343	2007-05-11	2007-05-19	1
28825	1709	4112343	2017-04-15	2017-04-27	1
11781	697	260139	2012-04-22	2012-04-29	1
88789	5284	4237458	1997-04-13	1997-07-12	1
28826	1709	4296204	1943-11-12	1943-12-10	1
11782	697	260139	2015-10-13	2015-10-27	1
88790	5284	40481087	1978-11-28	1978-12-19	1
28827	1709	40481087	1948-02-25	1948-03-10	1
11783	697	4283893	2015-07-05	2015-09-13	1
88791	5284	40481087	1990-08-25	1990-09-15	1
28828	1709	40481087	1953-07-31	1953-08-14	1
11784	697	4294548	1977-03-21	1977-05-09	1
88792	5284	378001	1979-04-18	1979-06-17	1
28829	1709	40481087	1967-03-02	1967-03-09	1
11785	697	40481087	1983-01-17	1983-01-31	1
88793	5284	4112343	1991-10-02	1991-10-15	1
28830	1709	40481087	1974-09-04	1974-09-25	1
11786	697	40481087	1987-01-18	1987-02-01	1
88794	5284	4112343	1993-07-10	1993-07-22	1
28831	1709	80502	2017-02-04	2017-02-05	1
11787	697	40481087	1988-07-01	1988-07-15	1
88795	5284	40481087	2005-10-01	2005-10-22	1
28832	1709	81151	1953-10-16	1953-11-20	1
11788	697	40481087	2011-03-15	2011-03-22	1
88796	5284	40486433	1971-08-30	1985-08-28	1
28833	1709	81151	2002-01-21	2002-02-18	1
11789	697	80180	2000-03-21	2000-03-22	1
52594	3117	4310024	2007-01-20	2007-01-21	1
28834	1709	372328	1939-03-22	1939-08-26	1
11790	697	260139	1973-08-01	1973-08-15	1
52595	3117	40481087	1982-11-19	1982-11-26	1
28835	1709	378001	1986-02-14	1986-04-15	1
11791	697	260139	1995-12-10	1995-12-17	1
52596	3117	40481087	2000-10-01	2000-10-08	1
28836	1709	4112343	1955-09-05	1955-09-16	1
11792	697	4112343	2002-10-09	2002-10-19	1
57716	3428	257012	1987-06-12	1987-06-13	1
28837	1709	40481087	1966-08-15	1966-08-29	1
11793	697	4134304	2001-08-17	2001-10-16	1
57717	3428	4043241	2017-05-31	2017-06-01	1
28838	1709	372328	1940-04-22	1940-08-24	1
11794	697	40481087	2017-11-07	2017-11-28	1
57718	3428	4112343	1970-06-05	1970-06-15	1
28839	1709	4109685	1959-10-20	1959-11-03	1
11795	697	40481087	2019-05-01	2019-05-22	1
57719	3428	4112343	2007-05-15	2007-05-28	1
28840	1709	4112343	2014-08-15	2014-08-28	1
11796	697	28060	1979-11-29	1979-12-07	1
57720	3428	4294548	2015-03-21	2015-06-27	1
28841	1709	4283893	1947-04-03	1947-04-24	1
11797	697	257012	2015-08-02	2015-08-03	1
57721	3428	260139	1976-12-20	1976-12-27	1
28842	1709	4296204	2004-04-08	2004-05-06	1
11798	697	260139	1986-04-16	1986-04-23	1
57722	3428	4112343	2009-10-15	2009-10-28	1
28843	1709	40481087	1952-03-26	1952-04-02	1
11799	697	260139	2016-06-24	2016-07-08	1
57723	3428	4283893	1987-05-15	1987-07-10	1
28844	1709	260139	1970-04-25	1970-05-02	1
12117	719	4059173	2016-08-19	2016-11-17	1
57724	3428	40481087	1975-02-19	1975-03-12	1
28845	1709	260139	1989-05-23	1989-06-06	1
12118	719	4112343	2012-10-24	2012-11-01	1
57725	3428	40481087	1998-01-21	1998-02-11	1
28846	1709	372328	1937-09-14	1937-11-27	1
12119	719	4152936	2010-09-06	2010-09-20	1
57726	3428	80180	2006-09-02	2006-09-03	1
28847	1709	4001336	1976-05-07	1976-06-06	1
12120	719	40481087	2019-02-23	2019-03-02	1
57727	3428	260139	1973-03-20	1973-04-03	1
28848	1709	4035415	1949-11-06	1949-12-06	1
12121	719	260139	2005-05-31	2005-06-07	1
57728	3428	260139	1978-07-22	1978-08-05	1
28849	1709	4112343	1955-03-18	1955-03-27	1
12122	719	372328	1983-07-19	1983-10-21	1
57729	3428	260139	2003-10-25	2003-11-08	1
28850	1709	4112343	1957-05-09	1957-05-22	1
12123	719	40481087	1992-08-21	1992-09-11	1
57730	3428	4112343	1999-04-17	1999-04-26	1
28851	1709	4112343	1971-03-13	1971-03-25	1
12124	719	40481087	2004-11-12	2004-12-03	1
57731	3428	4152936	2010-06-03	2010-06-24	1
28852	1709	4112343	2005-12-16	2005-12-29	1
12125	719	28060	1992-05-17	1992-05-28	1
57732	3428	4237458	2004-06-04	2004-08-03	1
28853	1709	4149245	1951-10-27	1951-11-26	1
12126	719	81151	1983-08-31	1983-09-28	1
57733	3428	40481087	1966-10-28	1966-11-04	1
28854	1709	4218389	1948-10-14	1948-11-11	1
12127	719	260139	1992-06-16	1992-06-30	1
57734	3428	40481087	1967-05-11	1967-05-25	1
28855	1709	4218389	2017-10-25	2017-11-22	1
12128	719	4112343	2007-04-13	2007-04-22	1
57735	3428	40481087	2019-03-16	2019-04-06	1
28856	1709	40481087	1989-10-14	1989-10-21	1
12129	719	4112343	2017-12-06	2017-12-19	1
58425	3464	195588	2005-05-08	2005-06-11	1
28857	1709	40481087	2004-10-07	2004-10-14	1
12130	719	4116491	2009-12-30	2010-02-13	1
58426	3464	4059173	1997-04-15	1997-05-15	1
29616	1755	78272	1969-04-28	1969-05-26	1
12131	719	4116491	2016-02-12	2016-04-02	1
58427	3464	134438	2009-05-14	2010-04-15	1
29617	1755	80180	2002-02-21	2002-02-22	1
12132	719	80180	2014-08-23	2014-08-24	1
58428	3464	40481087	1984-06-01	1984-06-08	1
29618	1755	260139	1961-10-06	1961-10-20	1
12133	719	372328	1982-06-07	1982-10-22	1
58429	3464	40481087	1998-11-29	1998-12-20	1
29619	1755	40481087	1966-10-13	1966-10-27	1
12134	719	4059173	2009-09-11	2009-10-11	1
58430	3464	40481087	2008-02-09	2008-02-16	1
29620	1755	260139	1969-09-03	1969-09-10	1
12135	719	4116491	2003-11-09	2004-01-01	1
58431	3464	40481087	2016-02-23	2016-03-01	1
29621	1755	260139	2006-05-27	2006-06-10	1
12136	719	4283893	2010-03-15	2010-04-12	1
58432	3464	192671	2017-07-22	2017-07-23	1
29622	1755	321042	2015-08-26	2015-08-27	1
12137	719	40481087	2012-01-10	2012-01-24	1
58433	3464	4134304	2004-01-09	2004-04-08	1
29623	1755	4218389	2001-11-25	2001-12-30	1
15213	902	28060	2006-04-11	2006-04-19	1
58434	3464	40481087	2014-12-16	2014-12-23	1
29624	1755	4296204	1967-05-11	1967-06-08	1
15214	902	40481087	1981-10-26	1981-11-02	1
58435	3464	80180	2017-04-25	2017-04-26	1
29625	1755	0	2015-08-26	2015-08-27	1
15215	902	260139	1973-12-30	1974-01-06	1
58436	3464	372328	1981-04-09	1981-07-22	1
29626	1755	4112343	1963-11-24	1963-12-01	1
15216	902	317576	2011-05-21	2011-05-22	1
58437	3464	4112343	1983-08-30	1983-09-11	1
29627	1755	4112343	1984-10-13	1984-10-25	1
15217	902	4152936	1965-03-10	1965-03-31	1
60518	3582	192671	2001-10-27	2001-10-28	1
29628	1755	4112343	1999-03-15	1999-03-24	1
15218	902	4294548	2014-01-01	2014-01-22	1
60519	3582	260139	1999-10-11	1999-10-18	1
29629	1755	4113008	2008-07-26	2008-08-09	1
15219	902	40481087	1957-05-14	1957-05-28	1
60520	3582	260139	2017-02-14	2017-02-28	1
29630	1755	4155034	2018-10-16	2018-10-30	1
15220	902	40481087	1969-03-11	1969-03-25	1
60521	3582	378001	2003-01-19	2003-02-18	1
29631	1755	4218389	1960-07-11	1960-08-15	1
15221	902	78272	1990-12-15	1991-01-05	1
60522	3582	4059173	2011-12-03	2012-02-01	1
29632	1755	28060	2000-04-21	2000-04-29	1
15222	902	260139	1960-08-05	1960-08-12	1
60523	3582	4112343	1998-03-17	1998-03-29	1
29633	1755	260139	1990-08-22	1990-09-05	1
15223	902	372328	1952-05-17	1952-08-02	1
60524	3582	4283893	1958-02-21	1958-03-28	1
29634	1755	260139	2010-04-21	2010-05-05	1
15224	902	372328	1990-12-11	1992-09-05	1
60525	3582	40481087	1960-11-20	1960-12-04	1
29635	1755	4156265	1995-12-06	1995-12-27	1
15225	902	4112343	1955-03-06	1955-03-16	1
60526	3582	40481087	2006-07-14	2006-07-21	1
29636	1755	40481087	1975-04-19	1975-05-03	1
15226	902	4112343	1969-09-13	1969-09-20	1
60527	3582	81893	1999-09-09	1999-09-10	1
32244	1918	28060	1998-01-15	1998-01-28	1
15227	902	40481087	1999-11-04	1999-11-11	1
60528	3582	4237458	2014-12-17	2015-03-17	1
32245	1918	81151	1973-09-27	1973-11-01	1
15228	902	80180	1991-09-05	1991-09-06	1
60529	3582	4266809	2001-07-30	2001-07-31	1
32246	1918	4112343	1977-08-05	1977-08-14	1
15229	902	257012	1963-02-06	1963-02-07	1
60530	3582	4278672	1989-09-01	1989-10-01	1
32247	1918	4155034	2018-08-21	2018-09-11	1
15230	902	260139	1970-05-23	1970-06-06	1
60531	3582	28060	1997-01-08	1997-01-19	1
32248	1918	4296204	1969-07-06	1969-07-20	1
15231	902	4112343	1957-07-06	1957-07-15	1
60532	3582	30753	2000-02-06	2000-02-07	1
32249	1918	40481087	1974-05-17	1974-06-07	1
15232	902	4230399	1968-01-15	1968-02-14	1
60533	3582	80180	2001-07-30	2001-07-31	1
32250	1918	28060	1976-05-02	1976-05-09	1
15233	902	4283893	1963-01-02	1963-04-17	1
60534	3582	4027663	1990-05-19	1990-05-20	1
32251	1918	260139	1982-01-30	1982-02-13	1
15234	902	40481087	1956-12-01	1956-12-08	1
60535	3582	4112343	1983-04-08	1983-04-18	1
32252	1918	260139	1985-04-29	1985-05-13	1
15235	902	40481087	1964-06-15	1964-06-29	1
60536	3582	40481087	1965-02-17	1965-03-10	1
32253	1918	440086	1977-08-08	1979-07-16	1
15236	902	40481087	2009-01-01	2009-01-22	1
60537	3582	40481087	1970-09-10	1970-10-01	1
32254	1918	4296204	1980-04-28	1980-05-12	1
17660	1062	28060	1994-02-18	1994-02-28	1
60538	3582	40481087	1987-08-12	1987-08-19	1
32255	1918	40481087	1982-02-02	1982-02-16	1
17661	1062	260139	1973-03-16	1973-03-23	1
60539	3582	40481087	2007-08-20	2007-09-10	1
32256	1918	372328	1969-10-04	1969-10-18	1
17662	1062	260139	1981-05-11	1981-05-18	1
60540	3582	78272	2000-03-07	2000-04-04	1
32257	1918	372328	1984-06-01	1984-09-22	1
17663	1062	40481087	1988-05-27	1988-06-17	1
60541	3582	261325	1993-08-15	1993-08-16	1
32258	1918	4112343	2005-05-23	2005-06-01	1
17664	1062	372328	1971-10-28	1972-04-30	1
60542	3582	4294548	1969-07-24	1969-08-07	1
32259	1918	4112343	2010-10-06	2010-10-13	1
17665	1062	4035415	2005-09-04	2005-10-04	1
60543	3582	40481087	2001-05-15	2001-06-05	1
32260	1918	80180	2004-11-19	2004-11-20	1
17666	1062	4112343	1967-01-18	1967-01-29	1
61378	3630	40481087	1968-07-08	1968-07-15	1
32261	1918	260139	2002-05-25	2002-06-01	1
17667	1062	4112343	1994-07-30	1994-08-12	1
61379	3630	40481087	1970-08-11	1970-08-25	1
32262	1918	4112343	1986-09-30	1986-10-13	1
17668	1062	4296205	1972-01-26	1972-03-01	1
61380	3630	4112343	1980-02-21	1980-03-03	1
32263	1918	4112343	2017-01-13	2017-01-22	1
17669	1062	40479422	1969-02-03	1969-04-11	1
61381	3630	4142905	1979-05-07	1979-08-05	1
32264	1918	4142905	1987-09-03	1987-12-02	1
17670	1062	40481087	1975-09-05	1975-09-12	1
61382	3630	80180	1992-05-23	1992-05-24	1
33944	2020	378001	2005-08-28	2005-10-27	1
17671	1062	80180	2000-08-29	2000-08-30	1
61383	3630	4156265	1986-06-29	1986-07-13	1
33945	2020	4112343	1974-05-15	1974-05-24	1
17672	1062	260139	1992-08-22	1992-09-05	1
61384	3630	4294548	1996-01-09	1996-01-23	1
33946	2020	4112343	1999-11-27	1999-12-07	1
17673	1062	372328	1966-12-16	1967-01-22	1
61385	3630	40481087	1979-10-14	1979-10-28	1
33947	2020	80180	2006-05-10	2006-05-11	1
17674	1062	40481087	2018-01-15	2018-01-22	1
61386	3630	40481087	2017-04-08	2017-04-15	1
33948	2020	372328	1973-07-17	1973-10-06	1
17675	1062	260139	1983-09-16	1983-09-23	1
61387	3630	28060	1965-05-30	1965-06-07	1
33949	2020	40481087	1981-10-11	1981-10-25	1
17676	1062	4112343	1967-05-31	1967-06-08	1
61388	3630	260139	1964-06-25	1964-07-09	1
33950	2020	40481087	1994-09-23	1994-10-14	1
17677	1062	4237458	1979-05-24	1979-06-23	1
61389	3630	260139	2015-09-15	2015-09-22	1
33951	2020	40481087	2003-01-07	2003-01-21	1
17678	1062	40481087	1987-11-16	1987-11-23	1
61390	3630	372328	1956-06-06	1956-06-20	1
33952	2020	28060	1983-12-06	1983-12-19	1
17679	1062	40481087	2014-02-08	2014-03-01	1
61391	3630	372328	1959-04-06	1960-03-23	1
33953	2020	372328	1976-09-20	1976-10-16	1
20337	1226	78272	2014-09-05	2014-09-26	1
61392	3630	4112343	1963-09-30	1963-10-07	1
33954	2020	40481087	1997-04-10	1997-05-01	1
20338	1226	260139	1989-07-19	1989-08-02	1
61393	3630	4278672	2009-02-12	2009-03-14	1
33955	2020	81151	2012-07-22	2012-08-19	1
20339	1226	40481087	2001-12-10	2001-12-17	1
61394	3630	40481087	1986-07-31	1986-08-21	1
33956	2020	134438	2000-10-30	2002-10-20	1
20340	1226	260139	1995-09-18	1995-09-25	1
62110	3672	0	1986-03-13	1986-03-14	1
33957	2020	4112343	2015-05-20	2015-05-31	1
20341	1226	440086	1990-04-04	1991-06-26	1
62111	3672	257012	2003-06-29	2003-06-30	1
33958	2020	40481087	2002-10-10	2002-10-31	1
20342	1226	4112343	1993-07-28	1993-08-08	1
62112	3672	260139	1979-06-23	1979-07-07	1
37976	2258	4112343	2007-12-31	2008-01-10	1
20343	1226	4112343	1990-08-31	1990-09-08	1
62113	3672	440448	1986-03-13	1986-03-14	1
37977	2258	4296204	1985-03-16	1985-04-06	1
20344	1226	40481087	1985-06-16	1985-06-30	1
62114	3672	40481087	1985-08-11	1985-08-25	1
37978	2258	40481087	1960-09-30	1960-10-14	1
20345	1226	80180	2013-08-21	2013-08-22	1
62115	3672	260139	1982-08-27	1982-09-10	1
37979	2258	40481087	1974-09-20	1974-10-04	1
20346	1226	4112343	1986-10-06	1986-10-18	1
62116	3672	4112343	1975-08-27	1975-09-03	1
37980	2258	40481087	1983-06-12	1983-07-03	1
20347	1226	40481087	2006-06-03	2006-06-17	1
62117	3672	4278672	1976-01-09	1976-02-08	1
37981	2258	40481087	1995-12-14	1995-12-21	1
20348	1226	40481087	2014-12-11	2015-01-01	1
62118	3672	4283893	2003-05-18	2004-05-23	1
37982	2258	40481087	2001-06-30	2001-07-07	1
21694	1305	80180	2000-10-18	2000-10-19	1
62119	3672	40481087	1969-09-21	1969-09-28	1
37983	2258	28060	1968-04-01	1968-04-09	1
21695	1305	260139	1976-05-02	1976-05-16	1
62120	3672	80180	2002-02-21	2002-02-22	1
37984	2258	80180	1995-01-30	1995-01-31	1
21696	1305	40481087	1983-05-03	1983-05-17	1
62121	3672	260139	2009-03-09	2009-03-16	1
37985	2258	81151	1981-03-09	1981-04-06	1
21697	1305	40481087	2000-10-19	2000-11-09	1
62122	3672	4112343	2008-01-17	2008-01-27	1
37986	2258	260139	2003-11-11	2003-11-25	1
21698	1305	40481087	2007-10-09	2007-10-16	1
62123	3672	40481087	1976-09-29	1976-10-20	1
37987	2258	372328	1959-11-30	1960-03-24	1
21699	1305	378001	2004-04-01	2004-05-01	1
62124	3672	40481087	2000-03-15	2000-03-29	1
37988	2258	4112343	1960-11-26	1960-12-06	1
21700	1305	440086	1976-07-06	1976-08-10	1
62125	3672	28060	1967-09-26	1967-10-07	1
37989	2258	4112343	1972-11-16	1972-11-26	1
21701	1305	40481087	1973-01-02	1973-01-16	1
62126	3672	260139	1986-02-07	1986-02-21	1
37990	2258	4112343	2008-04-13	2008-04-21	1
21702	1305	40481087	2008-05-21	2008-06-11	1
62127	3672	372328	1965-06-05	1965-08-23	1
37991	2258	40481087	1961-05-20	1961-06-10	1
21703	1305	260139	1969-06-14	1969-06-28	1
62128	3672	4027663	1993-03-10	1993-03-11	1
37992	2258	40481087	1969-10-31	1969-11-07	1
21704	1305	4218389	1967-05-25	1967-06-15	1
62129	3672	40481087	2011-07-24	2011-07-31	1
37993	2258	40481087	1982-10-29	1982-11-05	1
21705	1305	28060	1966-03-02	1966-03-09	1
63870	3778	80180	2000-01-14	2000-01-15	1
37994	2258	4112343	1991-02-05	1991-02-13	1
21706	1305	372328	1964-12-06	1965-03-18	1
63871	3778	372328	1965-11-28	1965-12-12	1
37995	2258	40481087	1991-05-28	1991-06-18	1
21707	1305	372328	1967-01-07	1967-06-15	1
63872	3778	4027663	1990-09-28	1990-09-29	1
37996	2258	40481087	1993-06-12	1993-06-19	1
23291	1391	28060	1951-09-14	1951-09-27	1
63873	3778	4112343	1995-08-07	1995-08-15	1
37997	2258	260139	1979-07-19	1979-07-26	1
23292	1391	4112343	1954-08-14	1954-08-21	1
63874	3778	4112343	1999-06-11	1999-06-22	1
37998	2258	372328	1961-08-16	1961-12-07	1
23293	1391	4112343	1987-07-02	1987-07-10	1
63875	3778	4285898	1999-12-15	1999-12-16	1
37999	2258	4112343	1987-06-14	1987-06-23	1
23294	1391	4116491	1959-12-23	1960-02-06	1
63876	3778	40481087	2008-01-15	2008-01-22	1
38000	2258	4112343	1999-04-06	1999-04-15	1
23295	1391	4155034	1999-04-14	1999-04-28	1
63877	3778	40481087	2017-03-12	2017-03-19	1
38001	2258	4134304	1977-11-25	1978-02-23	1
23296	1391	40481087	1932-05-13	1932-06-03	1
63878	3778	260139	2003-01-15	2003-01-22	1
38002	2258	40481087	1988-09-13	1988-10-04	1
23297	1391	40481087	1938-10-06	1938-10-13	1
63879	3778	4155034	2003-12-09	2003-12-23	1
40688	2423	378001	2018-04-17	2018-05-17	1
23298	1391	40481087	1952-11-02	1952-11-09	1
63880	3778	4266809	2000-01-14	2000-01-15	1
40689	2423	4112343	2019-05-27	2019-06-04	1
23299	1391	40481087	1966-09-16	1966-10-07	1
63881	3778	4310024	1997-12-25	1997-12-26	1
40690	2423	28060	1967-12-08	1967-12-16	1
23300	1391	28060	1936-02-09	1936-02-18	1
63882	3778	40481087	1966-04-06	1966-04-27	1
40691	2423	80502	2016-12-19	2016-12-20	1
23301	1391	28060	1937-10-14	1937-10-24	1
63883	3778	40481087	1997-01-12	1997-02-02	1
40692	2423	195588	1996-10-12	1996-11-23	1
23302	1391	81151	1928-09-06	1928-10-04	1
63884	3778	30753	1999-02-18	1999-02-19	1
40693	2423	260139	1970-01-14	1970-01-28	1
23303	1391	372328	1924-07-29	1924-09-09	1
63885	3778	4112343	1988-06-03	1988-06-11	1
40694	2423	40481087	1959-04-08	1959-04-15	1
23304	1391	372328	1927-09-24	1928-08-28	1
63886	3778	4112343	1997-03-10	1997-03-21	1
40695	2423	40481087	1960-03-17	1960-03-24	1
23305	1391	378001	1960-09-05	1960-10-05	1
63887	3778	40481087	1972-08-31	1972-09-14	1
40696	2423	40481087	1971-06-04	1971-06-25	1
23306	1391	4112343	1927-08-14	1927-08-23	1
65128	3857	260139	1960-06-10	1960-06-17	1
40697	2423	40481087	1974-02-18	1974-03-04	1
23307	1391	4112343	1961-01-19	1961-02-01	1
65129	3857	4112343	1974-12-08	1974-12-20	1
40698	2423	80180	1997-09-02	1997-09-03	1
23308	1391	4112343	1969-11-17	1969-11-29	1
65130	3857	4112343	1978-07-04	1978-07-13	1
40699	2423	260139	2005-10-02	2005-10-09	1
23309	1391	4218389	1947-03-20	1947-04-17	1
65131	3857	4112343	1992-05-04	1992-05-13	1
40700	2423	375671	2004-01-31	2004-03-01	1
23310	1391	4278672	1997-12-20	1998-03-20	1
65132	3857	4112343	1998-06-26	1998-07-04	1
40701	2423	4112343	1981-07-07	1981-07-14	1
23311	1391	40481087	1931-12-03	1931-12-10	1
65133	3857	81151	1960-03-29	1960-04-26	1
40702	2423	4134304	1997-06-29	1997-09-27	1
23312	1391	40481087	1965-10-09	1965-10-16	1
65134	3857	260139	1972-05-25	1972-06-08	1
40703	2423	4218389	1992-11-01	1992-11-22	1
23313	1391	40481087	1995-02-04	1995-02-25	1
65135	3857	260139	1997-03-22	1997-04-05	1
40704	2423	40481087	1978-06-20	1978-07-04	1
23314	1391	80180	1962-09-13	1962-09-14	1
65136	3857	4112343	1980-06-04	1980-06-12	1
40705	2423	81151	1962-05-24	1962-06-14	1
23315	1391	260139	1954-01-25	1954-02-01	1
65137	3857	4112343	1982-03-05	1982-03-17	1
40706	2423	81151	1987-11-30	1987-12-28	1
23316	1391	378419	1993-10-19	1993-10-20	1
65138	3857	4112343	1996-06-25	1996-07-05	1
40707	2423	378001	1989-12-17	1990-01-16	1
23317	1391	440086	1935-12-29	1942-01-06	1
65139	3857	4112343	2002-01-18	2002-01-26	1
40708	2423	4112343	1964-03-15	1964-03-24	1
23318	1391	4134304	1980-11-19	1981-01-18	1
65140	3857	4283893	1948-07-02	1949-02-04	1
40709	2423	40479768	1998-09-22	1998-11-28	1
23319	1391	40481087	1928-06-16	1928-06-30	1
65141	3857	40481087	1967-11-15	1967-11-29	1
40710	2423	40481087	1957-08-26	1957-09-09	1
23320	1391	40481087	1930-09-27	1930-10-04	1
65142	3857	40481087	1990-04-14	1990-05-05	1
40711	2423	40481087	1979-01-08	1979-01-22	1
23321	1391	40481087	1947-04-02	1947-04-09	1
65143	3857	78272	1956-07-20	1956-08-17	1
40712	2423	40481087	1990-06-29	1990-07-06	1
23322	1391	40481087	1954-09-09	1954-09-30	1
65144	3857	80180	1978-01-15	1978-01-16	1
41301	2459	28060	1984-06-15	1984-06-25	1
23323	1391	40481087	1978-04-12	1978-04-19	1
65145	3857	261325	1969-03-11	1969-03-12	1
41302	2459	260139	2015-03-23	2015-04-06	1
23324	1391	40481087	1980-10-09	1980-10-30	1
65146	3857	372328	1945-12-24	1946-06-11	1
41303	2459	4112343	2019-04-21	2019-04-28	1
23325	1391	40481087	1989-12-21	1990-01-04	1
65147	3857	4112343	1986-09-24	1986-10-01	1
41304	2459	4283893	1980-11-05	1980-12-24	1
23326	1391	40481087	1992-03-29	1992-04-12	1
65148	3857	40481087	1944-02-12	1944-02-19	1
41305	2459	40481087	2003-07-05	2003-07-19	1
23327	1391	80502	1994-10-25	1994-10-26	1
65149	3857	40481087	1956-09-01	1956-09-15	1
41306	2459	28060	1977-07-19	1977-07-29	1
23328	1391	81151	1933-05-11	1933-06-01	1
65150	3857	40481087	1964-10-08	1964-10-22	1
41307	2459	372328	1980-06-30	1981-06-01	1
23329	1391	260139	1961-02-02	1961-02-16	1
65151	3857	40481087	1971-05-19	1971-05-26	1
41308	2459	4112343	2006-02-15	2006-02-25	1
23330	1391	372328	1968-05-30	1970-01-20	1
65152	3857	40481087	1987-03-09	1987-03-23	1
41309	2459	40481087	2007-06-07	2007-06-28	1
23331	1391	4283893	1940-10-10	1940-11-28	1
65153	3857	40481087	1996-10-07	1996-10-14	1
41310	2459	40481087	2013-03-25	2013-04-15	1
23332	1391	40480160	1997-12-20	1998-03-20	1
65154	3857	28060	1954-10-11	1954-10-21	1
41311	2459	260139	2006-06-16	2006-06-23	1
23333	1391	40481087	1933-03-09	1933-03-30	1
65155	3857	257012	1948-07-30	1948-07-31	1
41312	2459	260139	2008-09-06	2008-09-13	1
23334	1391	40481087	1947-12-14	1947-12-21	1
65156	3857	260139	2015-07-09	2015-07-16	1
41313	2459	4112343	1994-08-04	1994-08-16	1
23335	1391	40481087	1978-07-25	1978-08-15	1
65157	3857	4109685	1944-11-29	1944-12-20	1
41314	2459	28060	1984-03-09	1984-03-16	1
23618	1411	372328	1966-09-26	1966-11-08	1
65158	3857	40481087	2001-08-24	2001-08-31	1
41315	2459	80180	2015-08-31	2015-09-01	1
23619	1411	4112343	1999-02-12	1999-02-24	1
66565	3943	78272	1961-09-24	1961-10-15	1
41316	2459	4027663	2008-06-13	2008-06-14	1
23620	1411	4294548	1995-04-24	1995-07-17	1
66566	3943	260139	2013-05-20	2013-05-27	1
41317	2459	4112343	1978-08-25	1978-09-05	1
23621	1411	4294548	2000-05-26	2000-07-28	1
66567	3943	4112343	1977-08-31	1977-09-11	1
41318	2459	4278672	1993-04-23	1993-05-23	1
23622	1411	40481087	1979-05-27	1979-06-17	1
66568	3943	4112343	2005-11-22	2005-11-29	1
41319	2459	40481087	2012-10-07	2012-10-21	1
23623	1411	40481087	1982-01-09	1982-01-30	1
66569	3943	4134304	2018-07-23	2018-10-21	1
42567	2541	260139	1989-04-28	1989-05-05	1
23624	1411	40481087	2003-03-23	2003-04-13	1
66570	3943	40481087	1984-02-17	1984-03-02	1
42568	2541	260139	2007-09-27	2007-10-11	1
23625	1411	40481087	2003-05-20	2003-06-10	1
66571	3943	40481087	1992-04-27	1992-05-18	1
42569	2541	260139	2011-08-08	2011-08-15	1
23626	1411	4112343	1967-05-27	1967-06-09	1
66572	3943	40481087	2013-11-16	2013-11-30	1
42570	2541	4112343	2017-05-05	2017-05-18	1
23627	1411	4237458	1972-04-27	1972-07-26	1
66573	3943	28060	1954-12-02	1954-12-15	1
42571	2541	4237458	2003-11-06	2003-12-06	1
23628	1411	4310024	2000-12-21	2000-12-22	1
66574	3943	80180	1990-07-24	1990-07-25	1
42572	2541	40481087	1990-01-31	1990-02-07	1
23629	1411	40481087	1969-02-19	1969-03-12	1
66575	3943	4112343	1960-03-19	1960-03-31	1
42573	2541	40481087	1993-07-27	1993-08-03	1
23630	1411	257012	1995-05-22	1995-05-23	1
66576	3943	40481087	1966-03-11	1966-03-18	1
42574	2541	40481087	2017-05-08	2017-05-29	1
23631	1411	372328	1968-07-30	1968-11-05	1
66577	3943	40481087	1976-05-31	1976-06-07	1
42575	2541	80180	2017-12-07	2017-12-08	1
23632	1411	4027663	1995-11-23	1995-11-24	1
66578	3943	40481087	1978-08-31	1978-09-07	1
42576	2541	372328	1977-06-20	1977-09-05	1
23633	1411	4266809	2002-11-11	2002-11-12	1
66579	3943	40481087	2016-04-27	2016-05-18	1
42577	2541	4112343	2000-06-05	2000-06-18	1
23634	1411	4285898	2002-08-13	2002-08-14	1
66580	3943	372328	1956-05-23	1957-01-24	1
42578	2541	4218389	1991-08-06	1991-08-27	1
23635	1411	30753	2001-11-16	2001-11-17	1
66581	3943	4112343	1977-12-14	1977-12-24	1
42579	2541	40481087	1988-02-29	1988-03-07	1
23636	1411	80180	2002-11-11	2002-11-12	1
66582	3943	4112343	1983-11-26	1983-12-05	1
42580	2541	192671	2017-12-17	2017-12-18	1
23637	1411	196456	1999-11-23	1999-11-23	1
66583	3943	4112343	2005-04-16	2005-04-23	1
42581	2541	381316	1998-08-10	1998-08-11	1
23638	1411	198809	1999-11-23	1999-11-23	1
66584	3943	40481087	2004-02-22	2004-03-07	1
42582	2541	81151	1997-01-27	1997-02-10	1
23639	1411	4112343	1978-12-11	1978-12-19	1
66585	3943	260139	1962-08-21	1962-08-28	1
42583	2541	260139	1987-03-01	1987-03-08	1
23640	1411	4112343	1981-06-08	1981-06-15	1
66586	3943	260139	1985-03-01	1985-03-15	1
42584	2541	260139	1994-04-11	1994-04-18	1
23641	1411	4149245	1996-03-22	1996-04-28	1
66587	3943	4142905	1986-02-11	1986-03-13	1
42585	2541	260139	1999-02-23	1999-03-09	1
23642	1411	4283893	2009-03-18	2009-05-06	1
66588	3943	4218389	1968-03-12	1968-04-09	1
42586	2541	4112343	1984-10-13	1984-10-26	1
23643	1411	40481087	1982-07-04	1982-07-25	1
66589	3943	40479768	1973-03-14	1973-04-20	1
42587	2541	4112343	2014-05-08	2014-05-20	1
25623	1525	372328	1965-12-18	1966-01-01	1
66590	3943	40481087	2005-06-05	2005-06-26	1
42588	2541	40481087	1981-06-05	1981-06-26	1
25624	1525	4109685	2013-02-09	2013-02-23	1
66591	3943	40481087	2012-02-27	2012-03-19	1
44008	2621	30753	1993-07-07	1993-07-08	1
25625	1525	4112343	2009-01-07	2009-01-17	1
70148	4159	257012	1991-05-06	1991-05-07	1
44009	2621	80180	1994-07-02	1994-07-03	1
25626	1525	4283893	1989-08-17	1989-09-14	1
70149	4159	4112343	1987-01-30	1987-02-11	1
44010	2621	378001	1957-07-21	1957-09-19	1
25627	1525	4285898	1998-02-13	1998-02-14	1
70150	4159	4112343	2005-11-04	2005-11-11	1
44011	2621	4112343	1957-01-24	1957-02-06	1
25628	1525	40481087	1984-01-26	1984-02-02	1
70151	4159	4116491	2015-01-13	2015-03-07	1
44012	2621	4218389	1989-04-28	1989-06-02	1
25629	1525	40481087	2015-03-08	2015-03-29	1
70152	4159	4116491	2017-04-24	2017-06-07	1
44013	2621	4285898	1994-04-03	1994-04-04	1
25630	1525	80180	1998-10-11	1998-10-12	1
70153	4159	4156265	2000-09-01	2000-09-22	1
44014	2621	28060	1994-11-17	1994-11-26	1
25631	1525	372328	1966-09-28	1967-01-05	1
70154	4159	4283893	1989-07-07	1989-08-18	1
44015	2621	260139	1966-11-03	1966-11-10	1
25632	1525	4112343	1968-12-03	1968-12-10	1
70155	4159	80180	1991-10-06	1991-10-07	1
44016	2621	4112343	1961-01-03	1961-01-11	1
25633	1525	4112343	2012-10-29	2012-11-11	1
70156	4159	81151	2006-06-23	2006-07-14	1
44017	2621	4112343	2006-11-13	2006-11-25	1
25634	1525	4237458	1993-08-23	1993-11-21	1
70157	4159	40481087	2014-07-01	2014-07-22	1
44018	2621	4156265	1983-07-08	1983-07-29	1
25635	1525	4294548	1969-02-07	1969-05-09	1
70158	4159	78272	1991-08-22	1991-09-19	1
44019	2621	4266809	1994-07-02	1994-07-03	1
25636	1525	40481087	2013-02-16	2013-03-09	1
70159	4159	195588	2016-03-06	2016-04-24	1
44020	2621	4310024	1992-03-14	1992-03-15	1
25637	1525	81893	1997-09-16	1997-09-17	1
70160	4159	4283893	1991-03-18	1991-08-12	1
44021	2621	40481087	1964-05-14	1964-06-04	1
25638	1525	192671	1998-12-22	1998-12-23	1
70161	4159	40481087	1967-02-04	1967-02-25	1
44022	2621	40481087	1980-07-29	1980-08-05	1
25639	1525	260139	1977-07-20	1977-07-27	1
70162	4159	40481087	1994-08-03	1994-08-17	1
44023	2621	78272	1969-09-21	1969-10-19	1
25640	1525	4027663	1990-07-25	1990-07-26	1
70163	4159	28060	1977-01-09	1977-01-21	1
44024	2621	260139	1984-07-12	1984-07-26	1
25641	1525	4112343	1976-01-05	1976-01-17	1
70164	4159	260139	1967-04-02	1967-04-09	1
44025	2621	4027663	1986-08-18	1986-08-19	1
25642	1525	4112343	1999-02-19	1999-02-26	1
70165	4159	378001	1975-12-14	1976-01-13	1
44026	2621	4112343	2009-03-15	2009-03-23	1
25643	1525	40481087	1985-05-04	1985-05-18	1
70166	4159	4059173	1972-10-30	1973-01-28	1
44027	2621	4149245	1999-06-10	1999-08-16	1
25644	1525	40481087	1990-04-20	1990-04-27	1
70167	4159	4296204	2012-01-14	2012-02-11	1
44028	2621	4155034	1966-09-16	1966-10-07	1
25645	1525	40481087	1994-09-10	1994-09-17	1
70168	4159	40481087	2008-07-09	2008-07-23	1
44029	2621	4156265	1964-10-12	1964-10-26	1
25646	1525	40481087	2005-05-30	2005-06-20	1
71748	4261	28060	1928-08-10	1928-08-17	1
44030	2621	4294548	2009-03-20	2009-04-03	1
25647	1525	30753	1997-11-15	1997-11-16	1
71749	4261	80180	1954-09-25	1954-09-26	1
44031	2621	40481087	1990-03-11	1990-03-25	1
25648	1525	257012	1969-03-07	1969-05-09	1
71750	4261	260139	1998-03-14	1998-03-21	1
44032	2621	28060	1957-12-04	1957-12-17	1
25649	1525	4310024	1996-11-20	1996-11-21	1
71751	4261	313217	2010-01-24	2010-01-25	1
44033	2621	260139	1986-01-29	1986-02-12	1
25650	1525	40481087	1987-08-15	1987-08-22	1
71752	4261	4112343	1979-04-21	1979-04-28	1
44034	2621	260139	2004-01-26	2004-02-09	1
25651	1525	40481087	1992-07-22	1992-08-12	1
71753	4261	4112343	2016-11-08	2016-11-21	1
44035	2621	4112343	1999-04-08	1999-04-21	1
29136	1727	28060	1954-02-05	1954-02-13	1
71754	4261	40481087	1987-03-05	1987-03-19	1
44036	2621	40481087	1958-10-21	1958-11-04	1
29137	1727	198809	1982-03-24	1982-03-25	1
71755	4261	80502	1982-05-09	1982-05-10	1
44037	2621	40481087	1977-03-05	1977-03-12	1
29138	1727	4112343	1970-03-21	1970-04-02	1
71756	4261	81151	1957-08-05	1957-08-26	1
44038	2621	40481087	1986-11-07	1986-11-21	1
29139	1727	4112343	1985-01-17	1985-01-24	1
71757	4261	260139	1983-03-14	1983-03-21	1
44039	2621	40481087	1987-04-26	1987-05-17	1
29140	1727	4278672	1977-02-22	1977-03-24	1
71758	4261	4112343	1937-11-13	1937-11-23	1
47313	2818	81151	1977-09-01	1977-09-22	1
29141	1727	4283893	1973-06-26	1973-07-17	1
71759	4261	4113008	1995-10-27	1995-11-10	1
47314	2818	260139	1971-07-18	1971-07-25	1
29142	1727	40481087	1952-11-15	1952-11-22	1
71760	4261	4218389	1974-01-29	1974-02-19	1
47315	2818	260139	1978-08-04	1978-08-11	1
29143	1727	40481087	2009-03-27	2009-04-03	1
71761	4261	40481087	1938-08-17	1938-09-07	1
47316	2818	4112343	1977-04-16	1977-04-27	1
29144	1727	80180	1991-12-10	1991-12-11	1
71762	4261	40481087	1977-10-30	1977-11-06	1
47317	2818	4112343	1985-12-24	1986-01-02	1
29145	1727	195588	2000-03-17	2000-04-18	1
71763	4261	40481087	1979-12-04	1979-12-11	1
47318	2818	4296204	1969-11-23	1969-12-28	1
29146	1727	196456	1982-03-24	1982-03-25	1
71764	4261	40481087	1980-03-16	1980-03-23	1
47319	2818	260139	1975-03-07	1975-03-14	1
29147	1727	258780	1999-03-31	1999-04-01	1
71765	4261	260139	1962-07-19	1962-08-02	1
47320	2818	260139	2014-03-16	2014-03-23	1
29148	1727	372328	1950-07-24	1950-09-07	1
71766	4261	372328	1927-03-16	1928-02-26	1
47321	2818	372328	1971-08-04	1972-07-31	1
29149	1727	4112343	1955-02-12	1955-02-22	1
71767	4261	4112343	1932-10-28	1932-11-06	1
47322	2818	4109685	1989-04-06	1989-04-27	1
29150	1727	4112343	1997-04-26	1997-05-07	1
71768	4261	4155034	1999-11-19	1999-12-10	1
47323	2818	4112343	1980-01-15	1980-01-24	1
29151	1727	4116491	2002-04-18	2002-06-04	1
71769	4261	40481087	1925-09-29	1925-10-20	1
47324	2818	4112343	2002-07-08	2002-07-21	1
29152	1727	4152936	1991-06-10	1991-07-01	1
71770	4261	40481087	1958-07-16	1958-08-06	1
47325	2818	4112343	2010-03-13	2010-03-20	1
29153	1727	4155034	1952-03-14	1952-04-04	1
71771	4261	28060	1995-11-03	1995-11-15	1
47326	2818	4112343	2010-10-20	2010-10-28	1
29154	1727	4156265	2012-11-06	2012-11-27	1
71772	4261	260139	1929-09-02	1929-09-09	1
47327	2818	4112343	2017-02-24	2017-03-08	1
29155	1727	40481087	1969-09-03	1969-09-10	1
71773	4261	260139	1998-11-12	1998-11-19	1
47328	2818	4296204	1971-11-18	1971-12-02	1
29156	1727	40481087	1995-10-29	1995-11-04	1
71774	4261	378001	1993-08-08	1993-10-07	1
47329	2818	40481087	1987-12-10	1987-12-31	1
29157	1727	40481087	2008-01-05	2008-01-26	1
71775	4261	4112343	2008-05-13	2008-05-21	1
47330	2818	40481087	2000-02-04	2000-02-18	1
29158	1727	40481087	2017-06-11	2017-06-25	1
71776	4261	4294548	1944-07-16	1944-08-20	1
47331	2818	260139	1997-10-01	1997-10-15	1
29159	1727	260139	2004-09-10	2004-09-24	1
71777	4261	40481087	1932-06-22	1932-07-13	1
47332	2818	372328	1970-02-21	1970-05-11	1
29160	1727	4112343	1961-10-23	1961-11-01	1
71778	4261	40481087	1986-09-24	1986-10-01	1
47333	2818	80180	2009-11-03	2009-11-04	1
29161	1727	40481087	1970-04-13	1970-05-05	1
73141	4352	260139	2018-08-14	2018-08-21	1
47334	2818	260139	2004-04-30	2004-05-14	1
29162	1727	40481087	2008-07-01	2008-07-22	1
73142	4352	372328	1952-04-26	1952-07-03	1
47335	2818	4155034	1985-07-12	1985-07-26	1
29163	1727	40481087	2017-03-30	2017-04-06	1
73143	4352	4027663	1980-07-21	1980-07-22	1
47336	2818	40481087	1986-08-05	1986-08-12	1
29279	1737	260139	1912-10-17	1912-10-24	1
73144	4352	4112343	1973-07-06	1973-07-14	1
52757	3128	28060	2011-01-10	2011-01-21	1
29280	1737	260139	1941-08-31	1941-09-14	1
73145	4352	4112343	2003-11-29	2003-12-10	1
52758	3128	4084167	1974-02-19	1974-02-19	1
29281	1737	260139	1972-05-02	1972-05-09	1
73146	4352	4112343	2005-06-04	2005-06-15	1
52759	3128	40481087	1984-03-23	1984-04-06	1
29282	1737	260139	1993-03-21	1993-04-04	1
73147	4352	80180	1987-04-11	1987-04-12	1
52760	3128	40481087	1990-05-11	1990-06-01	1
29283	1737	4112343	2012-11-29	2012-12-06	1
73148	4352	81151	2015-08-07	2015-08-28	1
52761	3128	81151	2007-03-19	2007-04-09	1
29284	1737	40481087	1962-06-09	1962-06-16	1
73149	4352	257012	2009-03-07	2009-03-08	1
52762	3128	375671	1988-08-25	1988-09-24	1
29285	1737	28060	1922-12-08	1922-12-20	1
73150	4352	260139	2006-03-27	2006-04-03	1
52763	3128	4237458	1985-08-11	1985-11-09	1
29286	1737	78272	1958-10-18	1958-11-22	1
73151	4352	372328	1949-02-24	1949-04-07	1
52764	3128	133834	1973-07-31	1990-11-29	1
29287	1737	317576	1970-11-13	1970-11-14	1
73152	4352	4059173	1956-03-19	1956-06-17	1
52765	3128	4218389	2009-05-28	2009-06-25	1
29288	1737	4112343	1993-03-31	1993-04-09	1
73153	4352	4112343	1985-01-15	1985-01-25	1
52766	3128	40479768	1984-09-08	1984-10-15	1
29289	1737	4283893	2005-01-22	2006-01-14	1
73154	4352	4266809	1987-04-11	1987-04-12	1
52767	3128	40481087	1977-06-09	1977-06-23	1
29290	1737	80180	1950-07-04	1950-07-05	1
73155	4352	4283893	2009-02-14	2009-04-18	1
52768	3128	80180	2010-11-02	2010-11-03	1
29291	1737	257012	2005-03-26	2005-03-27	1
73156	4352	40481087	1979-03-17	1979-03-24	1
52769	3128	4048171	1978-07-30	1978-07-31	1
29292	1737	260139	2001-02-01	2001-02-15	1
73157	4352	40481087	1990-05-27	1990-06-17	1
52770	3128	4051466	1976-07-30	1992-11-04	1
29293	1737	378001	1937-10-10	1937-11-09	1
73158	4352	40481087	2016-01-21	2016-01-28	1
52771	3128	4152936	1982-09-05	1982-09-19	1
29294	1737	381316	2013-10-11	2013-10-12	1
73159	4352	28060	2003-04-22	2003-05-01	1
53138	3150	28060	1947-01-01	1947-01-11	1
29295	1737	4112343	1918-08-19	1918-08-27	1
73160	4352	260139	1985-04-17	1985-05-01	1
53139	3150	260139	1945-07-25	1945-08-08	1
29296	1737	4112343	1956-02-12	1956-02-20	1
73161	4352	372328	1949-08-05	1949-10-06	1
53140	3150	4112343	1946-04-23	1946-05-05	1
29297	1737	4112343	1973-06-21	1973-06-29	1
73162	4352	372328	1950-04-04	1950-07-06	1
53141	3150	4146173	1940-04-21	1940-05-21	1
29298	1737	4142905	2000-10-12	2000-11-11	1
73163	4352	4112343	1973-01-21	1973-02-02	1
53142	3150	4237458	1957-01-22	1957-02-21	1
29299	1737	40481087	1929-06-27	1929-07-04	1
73164	4352	40481087	1958-11-10	1958-11-24	1
53143	3150	40481087	1955-08-09	1955-08-30	1
29300	1737	40481087	1935-07-12	1935-08-02	1
73165	4352	40481087	1982-05-13	1982-06-03	1
53144	3150	30753	1974-11-09	1974-11-10	1
29301	1737	40481087	1939-10-18	1939-11-01	1
73166	4352	4146173	1951-06-14	1951-07-14	1
53145	3150	372328	1939-11-23	1940-01-04	1
29302	1737	40481087	1997-04-22	1997-05-13	1
73167	4352	4278672	1965-11-27	1966-01-26	1
53146	3150	4112343	1980-06-18	1980-06-30	1
29303	1737	40481087	2004-12-11	2004-12-18	1
73168	4352	4285898	1987-03-12	1987-03-13	1
53147	3150	40481087	1957-08-26	1957-09-16	1
29304	1737	78272	1923-01-22	1923-02-26	1
75159	4470	260139	1996-11-30	1996-12-07	1
53148	3150	40481087	1976-07-16	1976-08-06	1
29305	1737	81151	1952-12-20	1953-01-17	1
75160	4470	260139	2003-02-15	2003-03-01	1
53149	3150	28060	1950-07-25	1950-08-06	1
29306	1737	192671	1950-09-18	1950-09-19	1
75161	4470	4294548	2000-11-14	2001-03-20	1
53150	3150	260139	1955-01-20	1955-01-27	1
29307	1737	375671	1996-09-03	1996-10-03	1
75162	4470	4294548	2005-09-04	2005-10-16	1
53151	3150	4112343	1967-08-10	1967-08-23	1
29308	1737	4112343	1935-08-15	1935-08-28	1
75163	4470	40481087	1996-05-25	1996-06-01	1
53152	3150	4285898	1975-01-08	1975-01-09	1
29309	1737	4112343	1988-10-10	1988-10-22	1
75164	4470	81151	1992-05-23	1992-06-13	1
53153	3150	0	1983-05-06	1983-05-07	1
29310	1737	40481087	2008-07-11	2008-07-25	1
75165	4470	372328	1973-06-10	1973-12-16	1
53154	3150	80180	1975-06-07	1975-06-08	1
31930	1900	28060	2012-03-12	2012-03-23	1
75166	4470	440086	1985-01-05	1990-01-14	1
53155	3150	81893	1974-03-14	1974-03-15	1
31931	1900	257012	2002-11-08	2002-11-09	1
75167	4470	4112343	1982-09-15	1982-09-23	1
53156	3150	260139	1955-12-24	1956-01-07	1
31932	1900	260139	1971-12-26	1972-01-09	1
75168	4470	40481087	1984-05-04	1984-05-25	1
53157	3150	4027663	1968-04-19	1968-04-20	1
31933	1900	260139	1980-01-04	1980-01-11	1
75169	4470	0	2010-12-31	2011-01-01	1
54564	3234	28060	1976-09-20	1976-10-02	1
31934	1900	260139	2017-08-26	2017-09-02	1
75170	4470	260139	2011-03-29	2011-04-12	1
54565	3234	372328	1952-12-16	1953-10-12	1
31935	1900	40481087	1965-08-04	1965-08-25	1
75171	4470	4112343	1999-07-08	1999-07-16	1
54566	3234	40481087	2000-03-11	2000-03-18	1
31936	1900	4112343	1964-02-07	1964-02-19	1
75172	4470	4146173	1994-06-03	1994-07-03	1
54567	3234	40481087	2009-01-24	2009-02-14	1
31937	1900	4112343	1969-07-09	1969-07-22	1
75173	4470	40481087	1990-04-15	1990-04-29	1
54568	3234	0	2010-01-18	2010-01-19	1
31938	1900	4112343	2006-11-29	2006-12-06	1
75174	4470	40481087	1996-04-05	1996-04-19	1
54569	3234	4112343	1975-11-12	1975-11-23	1
31939	1900	40481087	1978-07-10	1978-07-24	1
75175	4470	80180	2012-09-20	2012-09-21	1
54570	3234	4112343	1987-10-09	1987-10-22	1
31940	1900	40481087	1979-05-25	1979-06-01	1
75176	4470	257012	2001-03-13	2001-03-14	1
54571	3234	40481087	1957-09-14	1957-10-05	1
31941	1900	40481087	1985-02-01	1985-02-08	1
75177	4470	260139	2007-04-24	2007-05-01	1
54572	3234	40481087	1992-12-04	1992-12-11	1
31942	1900	40481087	2003-01-21	2003-01-28	1
75178	4470	260139	2017-08-09	2017-08-16	1
54573	3234	372328	1949-06-19	1949-10-03	1
31943	1900	192671	1996-01-04	1996-01-05	1
75179	4470	372328	1972-02-08	1972-04-16	1
54574	3234	4112343	1972-07-21	1972-07-29	1
31944	1900	4112343	1966-09-10	1966-09-19	1
75180	4470	440448	2010-12-31	2011-01-01	1
54575	3234	4218389	1980-04-06	1980-04-28	1
31945	1900	4112343	1990-01-16	1990-01-26	1
75181	4470	4112343	1997-11-04	1997-11-11	1
54576	3234	4283893	2004-04-02	2004-05-15	1
31946	1900	4294548	2002-10-11	2002-11-15	1
75182	4470	4112343	2015-10-21	2015-11-02	1
54577	3234	4294548	1953-11-30	1953-12-14	1
31947	1900	40481087	1979-12-18	1979-12-25	1
75183	4470	40481087	1976-10-22	1976-11-05	1
54578	3234	4329847	2010-01-18	2010-01-19	1
31948	1900	40481087	1986-12-08	1986-12-29	1
75184	4470	40481087	1979-12-28	1980-01-18	1
54579	3234	40481087	1954-04-22	1954-05-07	1
31949	1900	40481087	2008-02-10	2008-02-17	1
75185	4470	40481087	1988-07-11	1988-07-18	1
54580	3234	40481087	1988-03-02	1988-03-23	1
31950	1900	40481087	2011-04-08	2011-04-15	1
75186	4470	40481087	2007-11-14	2007-12-05	1
54581	3234	80180	1990-02-03	1990-02-04	1
31951	1900	28060	1980-08-27	1980-09-04	1
75903	4506	40481087	1964-06-04	1964-06-11	1
54582	3234	260139	1977-06-24	1977-07-08	1
31952	1900	80180	1995-11-18	1995-11-19	1
75904	4506	40481087	1976-11-14	1976-12-05	1
54583	3234	260139	2005-10-27	2005-11-02	1
31953	1900	40481087	1971-05-03	1971-05-10	1
75905	4506	40481087	1983-12-21	1984-01-04	1
54584	3234	317576	1955-05-03	1955-05-04	1
31954	1900	40481087	1979-11-04	1979-11-11	1
75906	4506	260139	1964-09-20	1964-10-04	1
54585	3234	4112343	2002-03-07	2002-03-17	1
36023	2138	0	1976-10-06	1976-10-07	1
75907	4506	4112343	2017-08-04	2017-08-11	1
54586	3234	40481087	1955-05-09	1955-05-23	1
36024	2138	260139	1999-12-27	2000-01-03	1
75908	4506	80180	1992-02-28	1992-02-29	1
56205	3335	80180	2011-01-01	2011-01-02	1
36025	2138	440448	1976-10-06	1976-10-07	1
75909	4506	257012	1982-02-28	1982-03-01	1
56206	3335	4112343	2008-08-30	2008-09-08	1
36026	2138	4112343	1958-07-24	1958-08-03	1
75910	4506	260139	1978-11-21	1978-11-28	1
56207	3335	4142905	1987-07-04	1987-08-03	1
36027	2138	4112343	1968-10-25	1968-11-02	1
75911	4506	4134304	1955-11-14	1956-01-13	1
56208	3335	4283893	1990-01-11	1990-02-22	1
36028	2138	4146173	2009-11-02	2010-01-01	1
75912	4506	40481087	2009-07-26	2009-08-09	1
56209	3335	40481087	1980-09-15	1980-10-06	1
36029	2138	4152936	2012-08-18	2012-09-08	1
75913	4506	40481087	2018-05-29	2018-06-05	1
56210	3335	81151	1984-01-23	1984-02-20	1
36030	2138	40481087	1961-06-27	1961-07-11	1
75914	4506	260139	1960-02-22	1960-03-07	1
56211	3335	257012	1990-02-01	1990-02-02	1
36031	2138	40481087	1987-11-01	1987-11-22	1
75915	4506	260139	1980-03-20	1980-04-03	1
56212	3335	375671	1999-09-29	1999-11-28	1
36032	2138	40481087	1989-06-21	1989-07-12	1
75916	4506	372328	1959-01-27	1959-12-10	1
56213	3335	40481087	2007-04-27	2007-05-04	1
36033	2138	28060	2015-07-14	2015-07-25	1
75917	4506	4112343	1980-05-08	1980-05-19	1
56214	3335	81151	2005-03-31	2005-04-28	1
36034	2138	80180	1990-04-24	1990-04-25	1
75918	4506	4230399	2001-10-13	2001-12-12	1
56215	3335	260139	1975-05-12	1975-05-26	1
36035	2138	260139	1994-09-16	1994-09-23	1
75919	4506	4283893	1981-10-18	1982-06-20	1
56216	3335	260139	2014-05-27	2014-06-03	1
36036	2138	4146173	1997-12-07	1998-02-05	1
78719	4668	375671	1984-05-08	1984-07-07	1
56217	3335	4283893	1977-10-04	1977-10-25	1
36037	2138	4155034	1995-03-09	1995-03-23	1
78720	4668	4112343	1989-03-25	1989-04-06	1
56218	3335	378001	1973-03-21	1973-05-20	1
36038	2138	40481087	1994-04-30	1994-05-21	1
78721	4668	40481087	1962-06-08	1962-06-29	1
56219	3335	440086	1979-03-25	1979-09-02	1
36039	2138	192671	1990-07-14	1990-07-15	1
56220	3335	4059173	1986-04-10	1986-06-09	1
36040	2138	260139	1972-12-05	1972-12-12	1
56221	3335	4112343	2002-12-17	2002-12-28	1
36041	2138	260139	1992-10-30	1992-11-06	1
56222	3335	4296205	2013-02-15	2013-03-01	1
36042	2138	372328	2002-02-14	2004-01-18	1
56223	3335	40481087	1985-08-20	1985-08-27	1
36043	2138	4027663	1979-10-04	1979-10-05	1
56224	3335	40481087	1997-11-18	1997-12-09	1
36044	2138	40481087	1955-10-13	1955-10-20	1
61948	3661	81893	2014-04-29	2014-04-30	1
36045	2138	40481087	1982-06-30	1982-07-21	1
61949	3661	195588	2008-02-05	2008-03-19	1
36046	2138	40481087	1997-11-07	1997-11-28	1
61950	3661	195588	2011-03-19	2011-05-10	1
36047	2138	81151	2007-10-16	2007-11-13	1
61951	3661	4027663	2007-02-05	2007-02-06	1
36048	2138	372328	1957-02-26	1957-03-12	1
61952	3661	4112343	1992-08-09	1992-08-19	1
36049	2138	4112343	1964-09-03	1964-09-12	1
61953	3661	4285898	2015-03-25	2015-03-26	1
36050	2138	4112343	1972-05-19	1972-05-28	1
61954	3661	40481087	1982-09-18	1982-10-02	1
36051	2138	4134304	1966-09-07	1966-11-06	1
61955	3661	40481087	1984-03-30	1984-04-13	1
36052	2138	4237458	1959-08-15	1959-11-13	1
61956	3661	40481087	2013-08-18	2013-08-25	1
36053	2138	4285898	1989-11-25	1989-11-26	1
61957	3661	28060	1986-07-04	1986-07-11	1
36054	2138	4294548	1993-01-29	1993-02-26	1
61958	3661	30753	2014-12-25	2014-12-26	1
36055	2138	40481087	2018-05-20	2018-05-27	1
61959	3661	40481087	1994-03-27	1994-04-17	1
37561	2230	81893	2007-12-05	2007-12-06	1
61960	3661	257012	1995-11-06	1995-11-07	1
37562	2230	4027663	2000-05-10	2000-05-11	1
61961	3661	260139	1980-08-02	1980-08-16	1
37563	2230	4266809	2009-01-28	2009-01-29	1
61962	3661	80180	2016-02-18	2016-02-19	1
37564	2230	40481087	1975-11-01	1975-11-08	1
61963	3661	260139	1988-01-13	1988-01-27	1
37565	2230	40481087	1984-06-24	1984-07-01	1
61964	3661	4051466	1982-02-18	1997-06-01	1
37566	2230	40481087	1999-07-19	1999-08-09	1
61965	3661	4112343	2002-08-29	2002-09-09	1
37567	2230	260139	1976-09-29	1976-10-13	1
61966	3661	4294548	1995-10-16	1995-11-13	1
37568	2230	372328	1976-05-01	1976-10-28	1
61967	3661	40481087	1981-02-03	1981-02-17	1
37569	2230	4112343	1997-04-30	1997-05-10	1
63327	3745	0	1935-03-13	1935-03-14	1
37570	2230	4112343	2008-09-13	2008-09-20	1
63328	3745	260139	1944-02-28	1944-03-13	1
37571	2230	4237458	1985-06-13	1985-07-13	1
63329	3745	261325	1992-05-20	1992-05-21	1
37572	2230	4296204	2009-10-05	2009-11-02	1
63330	3745	372328	2012-06-10	2012-09-12	1
37573	2230	40481087	1981-08-17	1981-08-31	1
63331	3745	378001	1953-08-13	1953-10-12	1
37574	2230	80180	2009-01-28	2009-01-29	1
63332	3745	440448	1935-03-13	1935-03-14	1
37575	2230	260139	2002-04-16	2002-04-30	1
63333	3745	4084167	1931-03-07	1931-03-07	1
37576	2230	378001	1980-11-06	1980-12-06	1
63334	3745	4112343	1941-07-30	1941-08-11	1
37577	2230	40481087	1973-11-18	1973-12-02	1
63335	3745	4296205	1932-03-01	1932-04-05	1
37578	2230	4112343	1993-12-02	1993-12-14	1
63336	3745	40481087	1972-12-13	1972-12-20	1
37579	2230	40481087	2003-12-23	2004-01-13	1
63337	3745	40481087	2008-08-31	2008-09-14	1
37760	2240	80180	2000-04-04	2000-04-05	1
63338	3745	40481087	2014-04-21	2014-05-12	1
37761	2240	4112343	2016-12-05	2016-12-12	1
63339	3745	80180	1973-03-21	1973-03-22	1
37762	2240	4134304	1987-07-01	1987-09-29	1
63340	3745	4112343	1934-06-22	1934-07-04	1
37763	2240	40481087	1965-09-03	1965-09-17	1
63341	3745	4230399	2018-05-16	2018-08-14	1
37764	2240	40481087	1973-02-06	1973-02-13	1
63342	3745	40480160	2018-05-16	2018-08-14	1
37765	2240	40481087	2014-03-31	2014-04-07	1
63343	3745	40481087	1957-07-23	1957-07-30	1
37766	2240	260139	2004-09-16	2004-09-23	1
63344	3745	40481087	1985-01-21	1985-01-28	1
37767	2240	4112343	2012-09-16	2012-09-26	1
63345	3745	260139	2003-12-03	2003-12-17	1
37768	2240	40481087	2011-01-01	2011-01-08	1
63346	3745	4059173	1933-03-01	1933-03-31	1
37769	2240	440086	1965-03-24	1965-11-03	1
63347	3745	4084167	1935-05-19	1935-05-19	1
37770	2240	4112343	1988-12-09	1988-12-20	1
63348	3745	4112343	1955-12-29	1956-01-09	1
37771	2240	4112343	2006-10-23	2006-11-05	1
63349	3745	4294548	1986-03-02	1986-03-23	1
37772	2240	40481087	1959-10-21	1959-10-28	1
63350	3745	40479768	1997-02-23	1997-04-01	1
37773	2240	40481087	1967-07-18	1967-08-01	1
63351	3745	40481087	1950-10-29	1950-11-19	1
37774	2240	28060	2004-06-01	2004-06-09	1
63352	3745	78272	2013-04-07	2013-05-12	1
37775	2240	4112343	2005-04-06	2005-04-16	1
63353	3745	80502	1990-05-09	1990-05-10	1
37776	2240	4112343	2005-09-14	2005-09-27	1
63354	3745	260139	1984-05-13	1984-05-20	1
37777	2240	4112343	2008-12-28	2009-01-04	1
63355	3745	372328	1930-06-10	1930-08-20	1
37778	2240	4155034	1966-10-05	1966-10-19	1
63356	3745	40481087	1969-07-04	1969-07-25	1
37779	2240	40481087	1997-11-13	1997-12-04	1
64260	3799	28060	1984-03-09	1984-03-18	1
42923	2559	372328	1958-07-15	1958-10-25	1
64261	3799	81151	1980-07-08	1980-07-22	1
42924	2559	4027663	1983-02-09	1983-02-10	1
64262	3799	257012	2003-12-06	2003-12-07	1
42925	2559	4218389	1988-10-05	1988-11-09	1
64263	3799	260139	2007-07-12	2007-07-26	1
42926	2559	40481087	1979-12-27	1980-01-17	1
64264	3799	372328	1972-09-18	1972-10-31	1
42927	2559	260139	1960-12-02	1960-12-09	1
64265	3799	4283893	2003-10-04	2003-12-20	1
42928	2559	372328	1960-06-16	1960-07-23	1
64266	3799	40481087	1974-01-16	1974-01-23	1
42929	2559	372328	1961-07-18	1961-12-09	1
64267	3799	40481087	2016-02-06	2016-02-20	1
42930	2559	4112343	1996-03-15	1996-03-28	1
64268	3799	28060	1978-03-22	1978-03-29	1
42931	2559	40481087	1977-11-23	1977-11-30	1
64269	3799	28060	1983-09-01	1983-09-08	1
42932	2559	40481087	1986-04-21	1986-05-05	1
64270	3799	80180	2006-04-08	2006-04-09	1
42933	2559	40481087	1987-11-04	1987-11-18	1
64271	3799	260139	1981-11-19	1981-11-26	1
42934	2559	40481087	2003-05-06	2003-05-13	1
64272	3799	372328	1976-02-13	1976-07-27	1
42935	2559	40481087	2003-09-17	2003-10-08	1
64273	3799	4112343	1999-10-29	1999-11-06	1
42936	2559	40481087	2008-12-15	2008-12-29	1
64274	3799	4112343	2013-12-26	2014-01-04	1
42937	2559	40481087	2018-02-16	2018-03-02	1
64275	3799	4237458	2000-04-22	2000-07-21	1
42938	2559	260139	1986-03-13	1986-03-20	1
64276	3799	40481087	1978-10-05	1978-10-19	1
42939	2559	372328	1962-10-05	1962-12-15	1
64277	3799	40481087	1987-08-30	1987-09-20	1
42940	2559	4112343	2004-06-18	2004-06-30	1
64278	3799	372328	1989-09-17	1990-09-25	1
42941	2559	40481087	2018-07-09	2018-07-30	1
64279	3799	4155034	1982-08-11	1982-08-25	1
42942	2559	80180	1990-03-29	1990-03-30	1
64280	3799	40481087	1984-07-27	1984-08-10	1
42943	2559	260139	1970-02-21	1970-03-07	1
64281	3799	40481087	2007-04-10	2007-04-17	1
42944	2559	260139	1980-02-19	1980-02-26	1
64282	3799	260139	1973-10-15	1973-10-22	1
42945	2559	4109685	2012-05-07	2012-05-21	1
64283	3799	260139	1985-03-19	1985-04-02	1
42946	2559	4112343	1962-06-25	1962-07-02	1
64284	3799	375671	2011-06-24	2011-07-24	1
42947	2559	4112343	1965-10-15	1965-10-25	1
64928	3844	4112343	1966-06-01	1966-06-11	1
42948	2559	4112343	1968-01-15	1968-01-26	1
64929	3844	4294548	1993-04-03	1993-07-31	1
42949	2559	4112343	1982-08-12	1982-08-24	1
64930	3844	40481087	1981-06-09	1981-06-16	1
42950	2559	4218389	2014-01-11	2014-02-01	1
64931	3844	40481087	2017-08-19	2017-08-26	1
42951	2559	4285898	1989-09-30	1989-10-01	1
64932	3844	260139	1975-07-01	1975-07-15	1
42952	2559	4310024	1988-08-06	1988-08-07	1
64933	3844	378001	1955-08-14	1955-09-13	1
42953	2559	40481087	1976-09-17	1976-09-24	1
64934	3844	440086	1964-08-26	1970-09-04	1
44463	2649	4112343	1963-01-16	1963-01-27	1
64935	3844	4112343	1965-10-22	1965-11-02	1
44464	2649	40481087	1957-08-09	1957-08-23	1
64936	3844	4112343	1990-10-20	1990-10-27	1
44465	2649	40481087	1958-07-28	1958-08-18	1
64937	3844	40481087	1960-01-27	1960-02-03	1
44466	2649	40481087	1984-02-10	1984-02-24	1
64938	3844	40481087	2004-05-09	2004-05-30	1
44467	2649	80180	1993-01-15	1993-01-16	1
64939	3844	28060	1990-03-09	1990-03-20	1
44468	2649	81151	1986-08-03	1986-08-31	1
64940	3844	80180	1991-02-06	1991-02-07	1
44469	2649	81893	1992-01-21	1992-01-22	1
64941	3844	257012	1993-05-01	1993-07-31	1
44470	2649	260139	1964-02-29	1964-03-07	1
64942	3844	260139	1981-04-01	1981-04-08	1
44471	2649	260139	2017-06-15	2017-06-22	1
64943	3844	4155034	1985-09-03	1985-09-24	1
44472	2649	4112343	1960-06-19	1960-06-29	1
64944	3844	4218389	1965-02-22	1965-03-22	1
44473	2649	4112343	1982-04-20	1982-04-30	1
64945	3844	40481087	1962-03-30	1962-04-20	1
44474	2649	4112343	2012-03-19	2012-03-31	1
64946	3844	4112343	2000-12-04	2000-12-13	1
44475	2649	40481087	2002-06-24	2002-07-01	1
64947	3844	4278672	1970-03-26	1970-06-24	1
44476	2649	192671	1993-02-14	1993-02-15	1
64948	3844	40481087	1958-11-04	1958-11-25	1
44477	2649	4112343	1993-03-05	1993-03-16	1
64949	3844	40481087	1967-05-02	1967-05-16	1
44478	2649	4112343	1998-09-18	1998-09-27	1
64950	3844	40481087	1984-09-03	1984-09-10	1
44479	2649	4113008	1962-05-08	1962-05-22	1
64951	3844	40481087	2007-03-25	2007-04-08	1
44480	2649	40481087	1983-07-17	1983-08-07	1
67612	3998	28060	2005-05-13	2005-05-26	1
44481	2649	40481087	1999-08-12	1999-09-02	1
67613	3998	78272	1978-10-25	1978-11-08	1
44482	2649	40481087	2009-04-01	2009-04-08	1
67614	3998	260139	1964-02-15	1964-02-22	1
44483	2649	78272	1972-12-23	1973-01-13	1
67615	3998	4134304	1972-10-28	1973-01-26	1
44484	2649	81151	2005-04-23	2005-05-21	1
67616	3998	4237458	2016-10-24	2016-12-23	1
44485	2649	81151	2011-02-19	2011-03-12	1
67617	3998	40481087	1991-05-25	1991-06-15	1
44486	2649	260139	2002-11-15	2002-11-29	1
67618	3998	40481087	1999-12-19	2000-01-09	1
44487	2649	4027663	1982-05-28	1982-05-29	1
67619	3998	80180	1986-06-22	1986-06-23	1
44488	2649	4218389	1971-01-05	1971-02-02	1
67620	3998	81151	1974-12-17	1975-01-14	1
47577	2832	4048695	2017-12-08	2018-02-08	1
67621	3998	260139	1975-03-07	1975-03-14	1
47578	2832	4112343	2014-03-07	2014-03-14	1
67622	3998	260139	1990-02-05	1990-02-12	1
47579	2832	4146173	1990-10-31	1990-12-30	1
67623	3998	260139	2006-07-10	2006-07-17	1
47580	2832	40481087	1976-05-24	1976-06-07	1
47581	2832	40481087	1986-11-30	1986-12-21	1
47582	2832	257012	2015-08-10	2015-08-11	1
47583	2832	372328	1988-10-11	1990-04-22	1
47584	2832	4283893	1996-08-18	1996-09-15	1
47585	2832	4142905	2003-04-26	2003-07-25	1
47586	2832	4294548	2015-07-13	2015-08-31	1
47587	2832	40481087	1977-08-06	1977-08-13	1
47588	2832	40481087	1999-07-08	1999-07-29	1
47589	2832	40481087	2011-03-05	2011-03-19	1
47590	2832	80180	2000-06-25	2000-06-26	1
47591	2832	134438	1994-02-14	1994-10-15	1
47592	2832	195588	2008-02-04	2008-03-28	1
47593	2832	260139	2000-04-13	2000-04-27	1
47594	2832	4112343	1988-04-15	1988-04-24	1
47595	2832	4112343	1989-11-17	1989-11-28	1
47596	2832	4112343	2003-03-23	2003-03-31	1
47597	2832	4283893	2014-06-06	2014-08-08	1
47598	2832	40481087	1989-03-19	1989-04-02	1
47599	2832	40481087	1995-04-10	1995-04-17	1
52501	3114	80180	1983-02-21	1983-02-22	1
52502	3114	257012	1957-05-05	1957-05-06	1
52503	3114	260139	1953-09-12	1953-09-26	1
52504	3114	372328	1950-12-04	1951-08-29	1
52505	3114	4027663	1972-09-11	1972-09-12	1
52506	3114	4112343	1960-02-07	1960-02-17	1
52507	3114	4112343	1966-10-26	1966-11-07	1
52508	3114	4237458	1961-02-01	1961-05-02	1
52509	3114	40481087	1960-06-17	1960-06-24	1
52510	3114	40481087	1973-05-26	1973-06-09	1
52511	3114	40481087	1976-10-27	1976-11-10	1
52512	3114	4112343	1958-01-19	1958-02-01	1
52513	3114	40481087	1950-05-08	1950-05-15	1
52514	3114	40481087	1979-10-04	1979-10-25	1
52515	3114	372328	1946-10-18	1946-12-25	1
52516	3114	4112343	1958-04-03	1958-04-15	1
52517	3114	4112343	1963-12-31	1964-01-09	1
52518	3114	4112343	1979-07-05	1979-07-14	1
52519	3114	4112343	1980-09-07	1980-09-16	1
52520	3114	4112343	1988-07-09	1988-07-19	1
52521	3114	4112343	1990-06-10	1990-06-23	1
52522	3114	4134304	2013-02-19	2013-05-20	1
52523	3114	4134304	2016-04-04	2016-05-04	1
52524	3114	4294548	1957-04-14	1957-06-30	1
52525	3114	4152936	1980-07-21	1980-08-11	1
52526	3114	4285898	1982-06-26	1982-06-27	1
52527	3114	4310024	1980-04-07	1980-04-08	1
52528	3114	40481087	1957-11-02	1957-11-23	1
54804	3248	196456	2016-06-26	2016-06-26	1
54805	3248	372328	1948-02-12	1948-06-18	1
54806	3248	4112343	1963-05-07	1963-05-15	1
54807	3248	4112343	1964-12-09	1964-12-20	1
54808	3248	4112343	2011-04-27	2011-05-06	1
54809	3248	4112343	2017-03-08	2017-03-15	1
54810	3248	40481087	1956-08-13	1956-08-27	1
54811	3248	30753	1981-12-26	1981-12-27	1
54812	3248	78272	1946-06-08	1946-06-22	1
54813	3248	198809	2016-06-26	2016-06-26	1
54814	3248	260139	1986-11-06	1986-11-20	1
54815	3248	260139	2004-02-29	2004-03-07	1
54816	3248	372328	1946-07-08	1946-09-20	1
54817	3248	4048695	2014-10-12	2014-12-13	1
54818	3248	4109685	1968-09-29	1968-10-13	1
54819	3248	4112343	1959-04-19	1959-04-26	1
54820	3248	4116491	1989-07-02	1989-08-22	1
54821	3248	40481087	1954-07-05	1954-07-19	1
54822	3248	40481087	1986-02-12	1986-02-19	1
54823	3248	28060	1958-09-07	1958-09-18	1
54824	3248	28060	2007-04-03	2007-04-15	1
54825	3248	313217	2007-03-30	2007-03-31	1
54826	3248	4027663	1972-07-06	1972-07-07	1
54827	3248	4112343	1975-06-27	1975-07-04	1
54828	3248	4112343	2002-07-13	2002-07-24	1
54829	3248	4218389	1961-05-04	1961-06-08	1
54830	3248	40481087	1984-08-21	1984-09-11	1
54831	3248	40481087	1999-05-13	1999-05-27	1
54832	3248	80180	1983-04-20	1983-04-21	1
54833	3248	4112343	1951-08-12	1951-08-19	1
54834	3248	4112343	1954-03-08	1954-03-21	1
54835	3248	4112343	1955-08-14	1955-08-23	1
54836	3248	40481087	1967-04-09	1967-04-16	1
54837	3248	40481087	1991-11-28	1991-12-12	1
54838	3248	40481087	2000-04-26	2000-05-17	1
54839	3248	40481087	2018-03-21	2018-04-11	1
55161	3270	28060	1983-05-16	1983-05-26	1
55162	3270	28060	1985-01-02	1985-01-10	1
55163	3270	80180	2005-10-03	2005-10-04	1
55164	3270	81893	2004-04-11	2004-04-12	1
55165	3270	440086	1981-03-23	1987-06-01	1
55166	3270	4112343	1976-04-25	1976-05-07	1
55167	3270	40481087	1990-10-13	1990-10-20	1
55168	3270	4027663	1996-03-19	1996-03-20	1
55169	3270	4112343	1984-01-24	1984-02-05	1
55170	3270	4218389	1995-06-13	1995-07-18	1
55171	3270	28060	2006-12-20	2007-01-02	1
55172	3270	4112343	1981-01-14	1981-01-25	1
55173	3270	4278672	1976-02-23	1976-04-23	1
55174	3270	40481087	2016-06-11	2016-06-25	1
55175	3270	260139	2019-05-09	2019-05-16	1
55176	3270	372328	1974-11-30	1975-03-06	1
57694	3427	28060	1974-07-24	1974-07-31	1
57695	3427	260139	1973-12-27	1974-01-03	1
57696	3427	260139	1976-12-20	1977-01-03	1
57697	3427	260139	1993-08-15	1993-08-29	1
57698	3427	375671	1974-03-02	1974-04-01	1
57699	3427	4112343	2005-04-21	2005-04-28	1
57700	3427	4278672	2013-01-04	2013-04-04	1
57701	3427	40481087	1968-09-01	1968-09-22	1
57702	3427	78272	2008-04-02	2008-04-30	1
57703	3427	80180	2000-11-13	2000-11-14	1
57704	3427	260139	2014-04-28	2014-05-12	1
57705	3427	372328	1970-06-09	1971-03-17	1
57706	3427	440086	1975-04-04	1984-04-11	1
57707	3427	4283893	2012-07-02	2012-09-03	1
57708	3427	40481087	1995-09-04	1995-09-11	1
57709	3427	40481087	1995-10-16	1995-10-23	1
57710	3427	4299128	2018-08-06	2018-08-20	1
57711	3427	257012	2012-07-23	2012-07-24	1
57712	3427	372328	1967-01-01	1967-03-15	1
57713	3427	372328	1969-11-29	1970-03-11	1
57714	3427	40479422	1970-02-14	1970-04-22	1
57715	3427	40481087	1986-01-27	1986-02-17	1
60421	3577	28060	2014-05-14	2014-05-23	1
52384	3106	260139	1973-12-23	1973-12-30	1
52385	3106	372328	1952-01-01	1952-06-16	1
52386	3106	4283893	1982-07-07	1982-08-04	1
52387	3106	40481087	1968-04-28	1968-05-12	1
52388	3106	40481087	2006-05-20	2006-05-27	1
52389	3106	78272	1951-07-05	1951-08-02	1
52390	3106	260139	2008-05-15	2008-05-22	1
52391	3106	40481087	1966-08-23	1966-08-30	1
52392	3106	40481087	1996-05-29	1996-06-05	1
55270	3278	30753	1993-01-05	1993-01-06	1
55271	3278	4218389	1986-11-12	1986-12-03	1
55272	3278	4237458	1977-02-02	1977-03-04	1
55273	3278	40481087	2004-08-22	2004-09-05	1
55274	3278	40481087	2016-12-08	2016-12-29	1
55275	3278	4112343	1966-03-21	1966-03-31	1
55276	3278	4112343	2012-04-13	2012-04-25	1
55277	3278	4112343	2018-12-02	2018-12-13	1
55278	3278	81151	1970-07-25	1970-08-08	1
55279	3278	192671	1994-02-17	1994-02-18	1
55280	3278	372328	2001-09-10	2002-04-29	1
55281	3278	4027663	1986-04-12	1986-04-13	1
55282	3278	4152936	2015-10-07	2015-10-21	1
55283	3278	78272	2011-02-25	2011-04-01	1
55284	3278	80180	1994-01-30	1994-01-31	1
55285	3278	81893	1992-11-06	1992-11-07	1
55286	3278	260139	1988-08-20	1988-09-03	1
55287	3278	4112343	1976-10-05	1976-10-18	1
55288	3278	4112343	2017-07-02	2017-07-09	1
55289	3278	4134304	1969-05-01	1969-07-30	1
55290	3278	4310024	1992-09-07	1992-09-08	1
55291	3278	40481087	2003-10-07	2003-10-21	1
57839	3435	4113008	2014-04-27	2014-05-18	1
57840	3435	4134304	2018-04-27	2018-05-27	1
57841	3435	4278672	2009-04-23	2009-07-22	1
57842	3435	40481087	2008-10-10	2008-10-31	1
57843	3435	40481087	2010-01-16	2010-02-06	1
57844	3435	4112343	2002-12-17	2002-12-24	1
57845	3435	4112343	2014-09-26	2014-10-07	1
57846	3435	4218389	1983-11-08	1983-12-06	1
57847	3435	40481087	2017-12-14	2017-12-28	1
57848	3435	81151	1977-05-15	1977-06-12	1
57849	3435	260139	1989-08-23	1989-09-06	1
57850	3435	4112343	1994-02-18	1994-03-02	1
57851	3435	40481087	1979-06-10	1979-06-24	1
57852	3435	40481087	1991-11-26	1991-12-03	1
57853	3435	40481087	2004-11-02	2004-11-23	1
57854	3435	40481087	2009-06-05	2009-06-12	1
57855	3435	40481087	2011-06-07	2011-06-14	1
57856	3435	80180	2016-06-29	2016-06-30	1
57857	3435	260139	1985-09-01	1985-09-15	1
57858	3435	372328	1978-04-10	1978-09-30	1
57859	3435	372328	1979-12-24	1980-04-05	1
57860	3435	4278672	2019-05-22	2019-05-23	1
57861	3435	40481087	1987-05-22	1987-06-12	1
60238	3569	381316	1987-07-14	1987-07-15	1
60239	3569	4283893	2008-08-06	2008-10-22	1
60240	3569	4294548	2005-11-30	2006-04-12	1
60241	3569	40481087	1967-07-11	1967-07-25	1
60242	3569	192671	1999-10-03	1999-10-04	1
60243	3569	4112343	1999-08-12	1999-08-24	1
60244	3569	4113008	1966-01-26	1966-02-16	1
60245	3569	40481087	1964-11-09	1964-11-16	1
60246	3569	80180	1999-09-10	1999-09-11	1
60247	3569	260139	1972-07-25	1972-08-01	1
60248	3569	260139	2005-07-04	2005-07-11	1
60249	3569	260139	2015-08-13	2015-08-27	1
60250	3569	4027663	1990-10-27	1990-10-28	1
60251	3569	4112343	1979-09-18	1979-09-25	1
60252	3569	4112343	2006-11-17	2006-11-24	1
60253	3569	4285898	1999-03-14	1999-03-15	1
60254	3569	40481087	1982-10-12	1982-10-26	1
60255	3569	30753	1998-05-18	1998-05-19	1
60256	3569	80502	2018-12-11	2018-12-12	1
60257	3569	257012	2006-01-04	2006-01-05	1
60258	3569	260139	1977-01-14	1977-01-28	1
60259	3569	260139	1995-06-02	1995-06-16	1
60260	3569	260139	2011-07-15	2011-07-22	1
60261	3569	378001	1959-10-30	1959-12-29	1
60262	3569	4310024	1997-05-23	1997-05-24	1
63763	3771	257012	2008-05-04	2008-05-05	1
63764	3771	28060	1972-05-19	1972-05-26	1
63765	3771	28060	1981-04-13	1981-04-21	1
63766	3771	4218389	1989-06-18	1989-07-23	1
63767	3771	40481087	1982-03-12	1982-03-19	1
63768	3771	81151	1970-12-20	1971-01-24	1
63769	3771	260139	2000-03-20	2000-03-27	1
63770	3771	4112343	2007-11-03	2007-11-10	1
63771	3771	78272	1966-11-13	1966-12-11	1
63772	3771	80180	1996-09-11	1996-09-12	1
63773	3771	4112343	2009-08-03	2009-08-11	1
63774	3771	4283893	2008-03-30	2008-05-18	1
63775	3771	40481087	1967-06-18	1967-06-25	1
63776	3771	40481087	1978-05-04	1978-05-25	1
63777	3771	40481087	1983-01-21	1983-02-04	1
64081	3789	78272	2014-12-05	2015-01-09	1
64082	3789	260139	1971-10-21	1971-10-28	1
64083	3789	372328	1945-08-11	1945-10-25	1
64084	3789	378001	1966-02-22	1966-04-23	1
64085	3789	4112343	2017-01-09	2017-01-20	1
64086	3789	4278672	1963-04-09	1963-05-09	1
64087	3789	40481087	2016-12-29	2017-01-19	1
64088	3789	372328	1976-04-15	1977-12-08	1
64089	3789	4112343	1953-08-12	1953-08-21	1
64090	3789	4112343	1975-11-10	1975-11-17	1
64091	3789	4112343	1999-12-14	1999-12-25	1
64092	3789	40481087	1945-09-16	1945-09-23	1
64093	3789	40481087	1951-04-30	1951-05-21	1
64094	3789	4112343	1965-03-22	1965-04-04	1
64095	3789	4218389	1970-10-29	1970-11-26	1
64096	3789	40481087	1962-06-08	1962-06-29	1
64097	3789	40481087	1962-12-31	1963-01-21	1
64098	3789	40481087	1986-07-23	1986-08-13	1
64099	3789	40481087	1997-08-18	1997-09-01	1
64100	3789	80180	1977-03-01	1977-03-02	1
64101	3789	260139	1949-05-24	1949-05-31	1
64102	3789	260139	1950-09-02	1950-09-09	1
64103	3789	260139	1974-11-30	1974-12-14	1
64104	3789	260139	2006-06-10	2006-06-24	1
64105	3789	4112343	1953-07-04	1953-07-12	1
64106	3789	4112343	2002-02-16	2002-02-24	1
64107	3789	4116491	1994-05-06	1994-06-15	1
64108	3789	4134304	2010-07-29	2010-08-28	1
64109	3789	40481087	1953-10-12	1953-10-19	1
64110	3789	40481087	1958-07-02	1958-07-23	1
64111	3789	40481087	1974-06-30	1974-07-21	1
64112	3789	40481087	1988-03-11	1988-04-01	1
67117	3972	30753	1998-09-28	1998-09-29	1
67118	3972	78272	1971-10-05	1971-11-09	1
67119	3972	4027663	1990-01-03	1990-01-04	1
67120	3972	78272	1972-12-03	1973-01-07	1
67121	3972	260139	2018-05-27	2018-06-10	1
67122	3972	378001	1974-01-02	1974-02-01	1
67123	3972	4112343	1974-05-25	1974-06-02	1
67124	3972	40481087	2007-11-01	2007-11-15	1
67125	3972	81893	1998-03-02	1998-03-03	1
67126	3972	192671	1999-08-15	1999-08-16	1
67127	3972	260139	1960-04-06	1960-04-13	1
67128	3972	260139	2014-01-09	2014-01-16	1
67129	3972	4278672	1967-10-26	1967-12-25	1
67130	3972	4296204	2016-03-22	2016-04-19	1
67131	3972	40481087	1971-07-03	1971-07-17	1
67132	3972	28060	1962-04-29	1962-05-10	1
67133	3972	28060	1979-07-09	1979-07-19	1
67134	3972	80180	1999-07-25	1999-07-26	1
67135	3972	4112343	1964-07-30	1964-08-12	1
67136	3972	4112343	1997-01-16	1997-01-27	1
67137	3972	4112343	2012-12-05	2012-12-14	1
67138	3972	4112343	2013-06-14	2013-06-25	1
67139	3972	40481087	1962-04-02	1962-04-16	1
67140	3972	40481087	1973-05-12	1973-05-26	1
75236	4473	81151	1997-08-07	1997-09-04	1
75237	4473	372328	1991-02-27	1993-09-26	1
75238	4473	4112343	1987-01-27	1987-02-04	1
75239	4473	4116491	1999-07-18	1999-09-04	1
75240	4473	81151	2004-06-29	2004-08-03	1
75241	4473	260139	1996-04-15	1996-04-29	1
75242	4473	378001	2001-06-15	2001-07-15	1
75243	4473	4112343	2002-07-03	2002-07-13	1
75244	4473	4112343	2018-10-20	2018-10-28	1
75245	4473	40481087	1977-04-29	1977-05-20	1
75246	4473	40481087	1996-07-27	1996-08-17	1
75247	4473	28060	1981-09-15	1981-09-23	1
75248	4473	372328	1973-04-15	1973-07-01	1
75249	4473	40481087	1990-11-04	1990-11-18	1
75250	4473	40481087	2005-06-09	2005-06-16	1
75251	4473	40481087	2018-10-12	2018-10-26	1
75252	4473	80180	2012-06-29	2012-06-30	1
75253	4473	375671	1981-09-30	1981-11-29	1
75254	4473	4112343	1979-02-14	1979-02-24	1
75255	4473	4112343	1993-06-05	1993-06-16	1
75256	4473	40481087	1978-12-17	1978-12-24	1
75257	4473	40481087	1979-06-28	1979-07-05	1
75258	4473	40481087	1984-11-14	1984-11-28	1
75810	4501	260139	1979-11-25	1979-12-09	1
75811	4501	260139	1983-01-31	1983-02-07	1
75812	4501	372328	1976-03-14	1976-05-06	1
75813	4501	4112343	1973-11-29	1973-12-09	1
75814	4501	40481087	1991-03-05	1991-03-12	1
75815	4501	40481087	2018-10-07	2018-10-28	1
75816	4501	28060	1986-05-09	1986-05-22	1
75817	4501	80180	2014-11-10	2014-11-11	1
75818	4501	134438	2002-11-30	2003-07-28	1
75819	4501	40481087	1987-09-22	1987-10-13	1
75820	4501	40481087	1993-09-04	1993-09-11	1
75821	4501	4112343	2011-01-13	2011-01-21	1
77228	4579	260139	1969-07-05	1969-07-19	1
77229	4579	260139	2001-02-28	2001-03-14	1
77230	4579	372328	1999-05-14	2000-03-03	1
77231	4579	4112343	1976-05-11	1976-05-23	1
77232	4579	4112343	2016-10-04	2016-10-13	1
77233	4579	80180	2008-03-20	2008-03-21	1
77234	4579	257012	2011-03-07	2011-04-04	1
77235	4579	260139	1976-11-12	1976-11-19	1
77236	4579	260139	1985-09-18	1985-09-25	1
77237	4579	40481087	1985-09-04	1985-09-11	1
77238	4579	40481087	2014-12-20	2015-01-03	1
77239	4579	28060	1973-04-15	1973-04-24	1
77240	4579	260139	2010-06-10	2010-06-24	1
77241	4579	4218389	2009-01-04	2009-02-08	1
77242	4579	40481087	1973-09-16	1973-09-30	1
77243	4579	40481087	1991-02-21	1991-02-28	1
77244	4579	260139	1982-07-18	1982-08-01	1
77245	4579	372328	1969-10-01	1970-01-16	1
77246	4579	4112343	1997-03-08	1997-03-17	1
77247	4579	4278672	1977-11-18	1978-02-16	1
77248	4579	4294548	2010-12-20	2011-04-04	1
78905	4677	260139	1967-12-23	1967-12-30	1
78906	4677	260139	1984-12-13	1984-12-27	1
78907	4677	4112343	1971-08-29	1971-09-07	1
78908	4677	4112343	1983-11-06	1983-11-13	1
78909	4677	4112343	2011-06-04	2011-06-14	1
78910	4677	4218389	1977-04-14	1977-05-19	1
78911	4677	4294548	1966-07-05	1966-08-02	1
78912	4677	40481087	1958-01-18	1958-02-08	1
78913	4677	40481087	1998-02-22	1998-03-08	1
78914	4677	4112343	2002-01-10	2002-01-21	1
78915	4677	4112343	2016-11-30	2016-12-13	1
78916	4677	4113008	1993-10-13	1993-11-03	1
78917	4677	4296205	2000-06-29	2000-07-27	1
78918	4677	28060	2016-04-22	2016-05-03	1
78919	4677	80180	1996-09-19	1996-09-20	1
78920	4677	81151	1966-03-01	1966-03-29	1
78921	4677	81151	1983-10-15	1983-11-05	1
78922	4677	378001	2008-02-16	2008-03-17	1
78923	4677	4112343	1964-01-14	1964-01-26	1
78924	4677	4112343	1965-10-18	1965-10-26	1
78925	4677	40481087	1978-05-08	1978-05-29	1
78926	4677	40481087	2001-02-26	2001-03-12	1
78927	4677	40481087	2016-05-13	2016-05-27	1
78928	4677	260139	1981-03-02	1981-03-16	1
78929	4677	372328	2017-03-03	2017-03-24	1
78930	4677	4112343	2017-05-16	2017-05-24	1
78931	4677	4156265	1973-07-20	1973-08-03	1
78932	4677	40481087	2008-08-11	2008-08-18	1
80506	4777	28060	1964-03-14	1964-03-27	1
80507	4777	260139	2004-08-21	2004-08-28	1
80508	4777	81151	2004-03-17	2004-04-07	1
80509	4777	260139	1983-06-02	1983-06-09	1
80510	4777	4112343	1981-11-12	1981-11-25	1
80511	4777	4112343	1990-06-15	1990-06-25	1
80512	4777	40481087	1977-04-27	1977-05-18	1
80513	4777	40481087	2001-01-19	2001-01-26	1
80514	4777	80180	1992-10-16	1992-10-17	1
80515	4777	372328	1959-01-08	1959-04-21	1
80516	4777	4109685	1979-09-04	1979-09-25	1
80517	4777	4142905	1974-11-29	1975-02-27	1
80518	4777	4283893	2010-06-17	2010-07-15	1
80519	4777	260139	1978-05-29	1978-06-12	1
80520	4777	260139	1990-10-18	1990-11-01	1
80521	4777	4112343	1964-07-29	1964-08-10	1
80522	4777	4112343	1967-12-26	1968-01-06	1
80523	4777	4112343	1970-05-29	1970-06-11	1
80524	4777	4116491	1982-05-07	1982-06-30	1
80525	4777	4296204	1971-04-05	1971-04-19	1
80526	4777	40481087	1963-07-24	1963-07-31	1
81373	4831	28060	1966-08-14	1966-08-27	1
81374	4831	28060	1980-07-31	1980-08-09	1
81375	4831	28060	2007-10-01	2007-10-12	1
81376	4831	80180	2002-08-05	2002-08-06	1
81377	4831	81151	2015-05-24	2015-06-07	1
81378	4831	372328	1964-09-08	1964-10-01	1
81379	4831	372328	1965-11-25	1966-04-07	1
81380	4831	4112343	1973-02-25	1973-03-06	1
81381	4831	40481087	1981-01-08	1981-01-15	1
81382	4831	40481087	2016-04-21	2016-04-28	1
81383	4831	378001	1975-01-19	1975-02-18	1
81384	4831	4112343	1999-09-03	1999-09-10	1
81385	4831	40481087	1962-09-25	1962-10-09	1
81386	4831	81151	2019-02-16	2019-03-02	1
81387	4831	260139	1991-12-18	1992-01-01	1
81388	4831	260139	2015-01-15	2015-01-22	1
81389	4831	4112343	1962-03-25	1962-04-04	1
81390	4831	40481087	1988-11-24	1988-12-08	1
81391	4831	81151	1971-04-05	1971-05-10	1
81392	4831	4296204	2009-10-17	2009-11-21	1
81393	4831	40481087	1983-01-13	1983-01-20	1
82132	4876	80180	2013-08-28	2013-08-29	1
82133	4876	260139	1994-12-23	1995-01-06	1
82134	4876	4035415	2018-01-19	2018-03-20	1
82135	4876	4112343	1985-10-21	1985-10-30	1
82136	4876	40481087	1991-11-21	1991-12-12	1
82137	4876	28060	1977-11-24	1977-12-01	1
82138	4876	4112343	1987-04-24	1987-05-06	1
82139	4876	4112343	1997-08-13	1997-08-24	1
82140	4876	40481087	1988-01-20	1988-02-03	1
82141	4876	40481087	2006-03-31	2006-04-07	1
82142	4876	372328	1987-12-28	1988-01-30	1
82143	4876	4112343	2009-09-22	2009-10-03	1
82144	4876	40481087	2012-01-12	2012-01-19	1
82145	4876	40481087	1986-10-12	1986-10-19	1
82146	4876	40481087	2004-06-12	2004-07-03	1
83812	4986	80180	1981-12-06	1981-12-07	1
83813	4986	313217	2001-04-29	2001-04-30	1
83814	4986	4112343	2009-03-03	2009-03-10	1
83815	4986	4218389	1979-03-13	1979-04-10	1
83816	4986	40481087	1968-04-29	1968-05-06	1
83817	4986	40481087	1969-11-06	1969-11-13	1
83818	4986	40481087	1983-08-17	1983-08-24	1
83819	4986	40481087	2017-08-14	2017-08-28	1
83820	4986	28060	1959-04-20	1959-04-30	1
83821	4986	195588	2000-04-10	2000-05-29	1
83822	4986	260139	1983-06-09	1983-06-16	1
83823	4986	260139	1989-03-20	1989-04-03	1
83824	4986	440086	1960-04-20	1968-04-28	1
83825	4986	4112343	1990-03-05	1990-03-12	1
83826	4986	260139	1955-12-25	1956-01-01	1
83827	4986	4112343	1976-09-30	1976-10-12	1
83828	4986	4112343	2018-03-10	2018-03-21	1
83829	4986	40481087	1956-12-25	1957-01-01	1
83830	4986	40481087	1959-03-27	1959-04-10	1
83831	4986	40481087	1970-06-13	1970-07-04	1
83832	4986	40481087	1971-06-06	1971-06-13	1
83833	4986	260139	1959-07-23	1959-08-06	1
83834	4986	372328	1951-08-16	1951-09-30	1
83835	4986	372328	1952-10-24	1953-03-29	1
83836	4986	381316	1983-09-11	1983-09-12	1
83837	4986	4109685	1965-03-05	1965-03-26	1
83838	4986	4112343	1958-01-14	1958-01-23	1
83839	4986	4112343	2017-12-24	2018-01-06	1
83840	4986	40481087	1969-12-19	1970-01-09	1
83841	4986	40481087	2005-02-07	2005-02-21	1
83842	4986	40481087	2015-08-04	2015-08-18	1
84250	5014	4112343	1956-12-15	1956-12-22	1
84251	5014	4112343	1960-01-09	1960-01-21	1
84252	5014	4285898	1948-05-22	1948-05-23	1
84253	5014	4294548	1935-02-18	1935-06-03	1
84254	5014	40479422	1943-02-24	1943-05-02	1
84255	5014	40481087	1960-11-10	1960-11-24	1
84256	5014	40481087	1978-10-19	1978-10-26	1
84257	5014	28060	1916-09-24	1916-10-05	1
84258	5014	257012	1935-04-08	1935-06-03	1
84259	5014	258780	1985-10-22	1985-10-23	1
84260	5014	260139	1949-05-05	1949-05-19	1
84261	5014	4027663	1937-11-06	1937-11-07	1
84262	5014	4112343	1965-06-26	1965-07-09	1
84263	5014	4146173	1973-12-25	1974-01-24	1
84264	5014	40481087	1932-10-05	1932-10-26	1
84265	5014	30753	1947-07-27	1947-07-28	1
84266	5014	81151	1953-09-06	1953-10-11	1
84267	5014	192671	1949-01-08	1949-01-09	1
84268	5014	260139	1925-10-29	1925-11-05	1
84269	5014	381316	1996-05-28	1996-05-29	1
84270	5014	4112343	1981-08-17	1981-08-25	1
84271	5014	4296205	1936-01-11	1936-02-01	1
84272	5014	40481087	1930-06-20	1930-07-11	1
84273	5014	40481087	1958-12-06	1958-12-13	1
84274	5014	40481087	1968-04-22	1968-05-06	1
84275	5014	28060	1921-09-11	1921-09-19	1
84276	5014	28060	1927-11-20	1927-12-03	1
84277	5014	80180	1948-10-19	1948-10-20	1
84278	5014	81893	1947-01-28	1947-01-29	1
84279	5014	260139	1915-11-29	1915-12-06	1
84280	5014	260139	1987-04-19	1987-04-26	1
84281	5014	372328	1917-01-20	1917-10-23	1
84282	5014	4112343	1928-02-04	1928-02-14	1
84283	5014	4134304	1938-02-20	1938-03-22	1
84284	5014	4266809	1948-10-19	1948-10-20	1
84285	5014	40481087	1947-06-07	1947-06-28	1
84286	5014	40481087	1995-11-05	1995-11-19	1
86821	5174	30753	1980-02-12	1980-02-13	1
86822	5174	260139	1960-10-26	1960-11-09	1
86823	5174	4237458	1944-12-20	1945-02-18	1
86824	5174	4266809	1981-01-07	1981-01-08	1
86825	5174	4283893	1986-06-20	1986-07-04	1
86826	5174	4294548	1960-08-17	1960-09-28	1
86827	5174	40480160	2003-05-13	2003-06-12	1
86828	5174	40481087	1937-08-02	1937-08-16	1
86829	5174	28060	1947-01-07	1947-01-17	1
86830	5174	80502	1997-03-27	1997-03-28	1
86831	5174	81151	1939-01-18	1939-02-22	1
86832	5174	260139	2010-08-20	2010-09-03	1
86833	5174	372328	1938-08-21	1939-01-05	1
86834	5174	4027663	1971-01-20	1971-01-21	1
86835	5174	4112343	1955-09-04	1955-09-12	1
86836	5174	4116491	1966-01-21	1966-02-27	1
86837	5174	4285898	1980-06-11	1980-06-12	1
86838	5174	40481087	1948-07-25	1948-08-15	1
86839	5174	78272	1962-08-02	1962-08-16	1
86840	5174	81151	1940-12-13	1941-01-10	1
86841	5174	378001	1971-05-01	1971-05-31	1
86842	5174	4112343	2000-06-18	2000-06-25	1
86843	5174	4112343	2015-07-11	2015-07-24	1
86844	5174	4310024	1979-09-15	1979-09-16	1
86845	5174	40481087	1989-12-21	1990-01-11	1
86846	5174	40481087	1998-07-07	1998-07-28	1
86847	5174	40481087	2007-06-18	2007-07-09	1
86848	5174	80180	1981-01-07	1981-01-08	1
86849	5174	81893	1979-10-15	1979-10-16	1
86850	5174	260139	1978-11-19	1978-11-26	1
86851	5174	4059173	1947-02-08	1947-03-10	1
86852	5174	4109685	1954-09-29	1954-10-13	1
86853	5174	4278672	2003-05-13	2003-06-12	1
86940	5184	80180	2001-05-01	2001-05-02	1
86941	5184	260139	1984-01-07	1984-01-21	1
86942	5184	4112343	1973-02-03	1973-02-13	1
86943	5184	4112343	2003-12-29	2004-01-06	1
86944	5184	4134304	1965-05-15	1965-06-14	1
86945	5184	40481087	2001-11-05	2001-11-19	1
86946	5184	260139	2010-02-18	2010-03-04	1
86947	5184	372328	1969-03-16	1969-05-30	1
86948	5184	4112343	1998-10-14	1998-10-23	1
86949	5184	40481087	1965-09-17	1965-10-08	1
86950	5184	372328	1967-01-05	1967-05-26	1
86951	5184	378001	1985-08-03	1985-10-02	1
86952	5184	4112343	1990-01-19	1990-01-28	1
86953	5184	80809	2017-06-06	2017-06-07	1
86954	5184	81151	1973-12-29	1974-02-02	1
86955	5184	81151	1990-08-07	1990-09-11	1
86956	5184	40481087	1973-08-04	1973-08-25	1
86957	5184	40481087	2002-03-26	2002-04-09	1
\.


--
-- TOC entry 3891 (class 0 OID 3185499)
-- Dependencies: 213
-- Data for Name: condition_occurrence; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".condition_occurrence (condition_occurrence_id, person_id, condition_concept_id, condition_start_date, condition_start_datetime, condition_end_date, condition_end_datetime, condition_type_concept_id, stop_reason, provider_id, visit_occurrence_id, visit_detail_id, condition_source_value, condition_source_concept_id, condition_status_source_value, condition_status_concept_id) FROM stdin;
4483	263	4112343	2015-10-02	2015-10-02 00:00:00	2015-10-14	2015-10-14 00:00:00	32020		\N	17479	0	195662009	4112343		0
4657	273	192671	2011-10-10	2011-10-10 00:00:00	\N	\N	32020		\N	18192	0	K92.2	35208414		0
4815	283	28060	1984-02-15	1984-02-15 00:00:00	1984-02-25	1984-02-25 00:00:00	32020		\N	18859	0	43878008	28060		0
4981	293	378001	2005-11-07	2005-11-07 00:00:00	2005-12-07	2005-12-07 00:00:00	32020		\N	19515	0	62106007	378001		0
5153	304	257012	1974-07-30	1974-07-30 00:00:00	1974-11-05	1974-11-05 00:00:00	32020		\N	20239	0	40055000	257012		0
5313	312	4134304	1991-05-14	1991-05-14 00:00:00	1991-06-13	1991-06-13 00:00:00	32020		\N	20658	0	263102004	4134304		0
5513	326	28060	1979-09-23	1979-09-23 00:00:00	1979-10-06	1979-10-06 00:00:00	32020		\N	21553	0	43878008	28060		0
5655	334	40481087	1999-07-12	1999-07-12 00:00:00	1999-07-19	1999-07-19 00:00:00	32020		\N	22124	0	444814009	40481087		0
5811	341	40481087	1990-09-14	1990-09-14 00:00:00	1990-10-05	1990-10-05 00:00:00	32020		\N	22784	0	444814009	40481087		0
5977	351	40481087	1986-02-24	1986-02-24 00:00:00	1986-03-17	1986-03-17 00:00:00	32020		\N	23405	0	444814009	40481087		0
6143	362	4113008	1998-07-03	1998-07-03 00:00:00	1998-07-17	1998-07-17 00:00:00	32020		\N	24055	0	284549007	4113008		0
6309	370	372328	1970-03-15	1970-03-15 00:00:00	1970-04-23	1970-04-23 00:00:00	32020		\N	24601	0	65363002	372328		0
6500	384	40481087	1962-09-23	1962-09-23 00:00:00	1962-10-07	1962-10-07 00:00:00	32020		\N	25351	0	444814009	40481087		0
6641	392	260139	1979-02-14	1979-02-14 00:00:00	1979-02-28	1979-02-28 00:00:00	32020		\N	25716	0	10509002	260139		0
6815	403	40481087	1935-08-08	1935-08-08 00:00:00	1935-08-22	1935-08-22 00:00:00	32020		\N	26490	0	444814009	40481087		0
6973	410	40481087	2006-04-23	2006-04-23 00:00:00	2006-05-14	2006-05-14 00:00:00	32020		\N	27232	0	444814009	40481087		0
7139	419	78272	1924-12-23	1924-12-23 00:00:00	1925-01-13	1925-01-13 00:00:00	32020		\N	27709	0	70704007	78272		0
7305	430	40481087	1998-08-08	1998-08-08 00:00:00	1998-08-29	1998-08-29 00:00:00	32020		\N	28496	0	444814009	40481087		0
7471	439	4112343	1990-03-20	1990-03-20 00:00:00	1990-04-02	1990-04-02 00:00:00	32020		\N	29157	0	195662009	4112343		0
7645	449	4112343	1999-12-12	1999-12-12 00:00:00	1999-12-23	1999-12-23 00:00:00	32020		\N	29963	0	195662009	4112343		0
7803	455	78272	1951-09-23	1951-09-23 00:00:00	1951-10-14	1951-10-14 00:00:00	32020		\N	30454	0	70704007	78272		0
7992	469	260139	2004-10-20	2004-10-20 00:00:00	2004-10-27	2004-10-27 00:00:00	32020		\N	31328	0	10509002	260139		0
8158	479	257012	1982-02-25	1982-02-25 00:00:00	\N	\N	32020		\N	31935	0	40055000	257012		0
8301	484	80180	1974-06-18	1974-06-18 00:00:00	\N	\N	32020		\N	32392	0	396275006	80180		0
8467	492	4116491	1982-12-04	1982-12-04 00:00:00	1983-01-10	1983-01-10 00:00:00	32020		\N	32982	0	301011002	4116491		0
8647	505	378001	2011-06-20	2011-06-20 00:00:00	2011-07-20	2011-07-20 00:00:00	32020		\N	33784	0	62106007	378001		0
8799	515	4112343	1961-11-14	1961-11-14 00:00:00	1961-11-26	1961-11-26 00:00:00	32020		\N	34413	0	195662009	4112343		0
8967	525	378001	1972-04-17	1972-04-17 00:00:00	1972-05-17	1972-05-17 00:00:00	32020		\N	34961	0	62106007	378001		0
9132	539	4029498	1933-03-26	1933-03-26 00:00:00	\N	\N	32020		\N	35823	0	128613002	4029498		0
9297	549	40481087	1999-12-30	1999-12-30 00:00:00	2000-01-20	2000-01-20 00:00:00	32020		\N	36359	0	444814009	40481087		0
9463	559	40481087	1983-03-16	1983-03-16 00:00:00	1983-04-06	1983-04-06 00:00:00	32020		\N	37099	0	444814009	40481087		0
9630	571	40481087	1995-09-17	1995-09-17 00:00:00	1995-10-01	1995-10-01 00:00:00	32020		\N	37843	0	444814009	40481087		0
9795	579	28060	1970-06-02	1970-06-02 00:00:00	1970-06-10	1970-06-10 00:00:00	32020		\N	38356	0	43878008	28060		0
9972	592	260139	1975-08-01	1975-08-01 00:00:00	1975-08-08	1975-08-08 00:00:00	32020		\N	39127	0	10509002	260139		0
10127	600	4294548	1978-04-15	1978-04-15 00:00:00	1978-05-27	1978-05-27 00:00:00	32020		\N	39572	0	75498004	4294548		0
10294	608	260139	2004-03-27	2004-03-27 00:00:00	2004-04-03	2004-04-03 00:00:00	32020		\N	40383	0	10509002	260139		0
10459	615	40481087	1947-08-07	1947-08-07 00:00:00	1947-08-14	1947-08-14 00:00:00	32020		\N	40928	0	444814009	40481087		0
1	1	40479768	1981-08-10	1981-08-10 00:00:00	1981-09-16	1981-09-16 00:00:00	32020		\N	82	0	444470001	40479768		0
167	7	4156265	1972-07-09	1972-07-09 00:00:00	1972-07-23	1972-07-23 00:00:00	32020		\N	630	0	370247008	4156265		0
333	17	4112343	1963-12-02	1963-12-02 00:00:00	1963-12-12	1963-12-12 00:00:00	32020		\N	1333	0	195662009	4112343		0
499	30	4112343	1993-03-19	1993-03-19 00:00:00	1993-03-31	1993-03-31 00:00:00	32020		\N	2104	0	195662009	4112343		0
665	36	260139	2008-06-08	2008-06-08 00:00:00	2008-06-22	2008-06-22 00:00:00	32020		\N	2632	0	10509002	260139		0
831	43	40481087	1957-01-22	1957-01-22 00:00:00	1957-01-29	1957-01-29 00:00:00	32020		\N	3189	0	444814009	40481087		0
1021	61	192671	2005-09-15	2005-09-15 00:00:00	\N	\N	32020		\N	4183	0	K92.2	35208414		0
1167	69	80180	1984-08-02	1984-08-02 00:00:00	\N	\N	32020		\N	4674	0	396275006	80180		0
1329	78	372328	1967-07-04	1967-07-04 00:00:00	1967-09-14	1967-09-14 00:00:00	32020		\N	5156	0	65363002	372328		0
1517	90	4112343	1970-01-15	1970-01-15 00:00:00	1970-01-28	1970-01-28 00:00:00	32020		\N	5987	0	195662009	4112343		0
1661	96	4296205	1979-07-12	1979-07-12 00:00:00	1979-08-02	1979-08-02 00:00:00	32020		\N	6507	0	403191005	4296205		0
1827	105	40481087	1976-08-04	1976-08-04 00:00:00	1976-08-11	1976-08-11 00:00:00	32020		\N	7136	0	444814009	40481087		0
1993	116	4112343	1959-06-11	1959-06-11 00:00:00	1959-06-18	1959-06-18 00:00:00	32020		\N	7706	0	195662009	4112343		0
2175	126	40481087	2016-04-14	2016-04-14 00:00:00	2016-04-28	2016-04-28 00:00:00	32020		\N	8419	0	444814009	40481087		0
2325	137	4112343	2005-11-15	2005-11-15 00:00:00	2005-11-28	2005-11-28 00:00:00	32020		\N	9231	0	195662009	4112343		0
2491	145	40481087	1962-02-22	1962-02-22 00:00:00	1962-03-08	1962-03-08 00:00:00	32020		\N	9716	0	444814009	40481087		0
2657	155	260139	2014-04-02	2014-04-02 00:00:00	2014-04-16	2014-04-16 00:00:00	32020		\N	10556	0	10509002	260139		0
2823	162	260139	1984-06-15	1984-06-15 00:00:00	1984-06-22	1984-06-22 00:00:00	32020		\N	11165	0	10509002	260139		0
2997	176	4112343	1986-10-08	1986-10-08 00:00:00	1986-10-15	1986-10-15 00:00:00	32020		\N	11898	0	195662009	4112343		0
3155	185	40481087	1952-07-11	1952-07-11 00:00:00	1952-07-25	1952-07-25 00:00:00	32020		\N	12555	0	444814009	40481087		0
3321	191	40481087	1988-08-12	1988-08-12 00:00:00	1988-08-26	1988-08-26 00:00:00	32020		\N	13142	0	444814009	40481087		0
3487	199	4112343	1947-12-01	1947-12-01 00:00:00	1947-12-09	1947-12-09 00:00:00	32020		\N	13636	0	195662009	4112343		0
3653	209	40481087	1987-03-30	1987-03-30 00:00:00	1987-04-13	1987-04-13 00:00:00	32020		\N	14283	0	444814009	40481087		0
3819	220	40481087	2016-05-21	2016-05-21 00:00:00	2016-06-04	2016-06-04 00:00:00	32020		\N	14856	0	444814009	40481087		0
3988	232	40481087	1948-12-17	1948-12-17 00:00:00	1948-12-31	1948-12-31 00:00:00	32020		\N	15630	0	444814009	40481087		0
4175	244	40481087	1934-03-31	1934-03-31 00:00:00	1934-04-07	1934-04-07 00:00:00	32020		\N	16280	0	444814009	40481087		0
4317	248	260139	1990-12-21	1990-12-21 00:00:00	1990-12-28	1990-12-28 00:00:00	32020		\N	16688	0	10509002	260139		0
4484	263	40481087	2002-01-21	2002-01-21 00:00:00	2002-02-11	2002-02-11 00:00:00	32020		\N	17447	0	444814009	40481087		0
4658	273	40481087	1996-07-06	1996-07-06 00:00:00	1996-07-27	1996-07-27 00:00:00	32020		\N	18279	0	444814009	40481087		0
4816	283	4237458	1998-04-21	1998-04-21 00:00:00	1998-07-20	1998-07-20 00:00:00	32020		\N	18881	0	58150001	4237458		0
4982	293	80180	2006-12-22	2006-12-22 00:00:00	\N	\N	32020		\N	19524	0	396275006	80180		0
5154	304	4112343	1966-03-29	1966-03-29 00:00:00	1966-04-09	1966-04-09 00:00:00	32020		\N	20247	0	195662009	4112343		0
5314	312	257012	2000-07-17	2000-07-17 00:00:00	\N	\N	32020		\N	20673	0	40055000	257012		0
5514	326	4112343	1985-03-11	1985-03-11 00:00:00	1985-03-20	1985-03-20 00:00:00	32020		\N	21554	0	195662009	4112343		0
5656	334	28060	1974-09-05	1974-09-05 00:00:00	1974-09-15	1974-09-15 00:00:00	32020		\N	22147	0	43878008	28060		0
5812	341	260139	2000-05-10	2000-05-10 00:00:00	2000-05-17	2000-05-17 00:00:00	32020		\N	22806	0	10509002	260139		0
5978	351	192671	2018-06-28	2018-06-28 00:00:00	\N	\N	32020		\N	23432	0	K92.2	35208414		0
6144	362	4237458	1995-09-17	1995-09-17 00:00:00	1995-11-16	1995-11-16 00:00:00	32020		\N	24054	0	58150001	4237458		0
6310	370	4112343	1965-12-21	1965-12-21 00:00:00	1966-01-03	1966-01-03 00:00:00	32020		\N	24594	0	195662009	4112343		0
6501	384	4116491	2018-07-03	2018-07-03 00:00:00	2018-08-16	2018-08-16 00:00:00	32020		\N	25340	0	301011002	4116491		0
6642	392	260139	2019-01-31	2019-01-31 00:00:00	2019-02-14	2019-02-14 00:00:00	32020		\N	25718	0	10509002	260139		0
6816	403	4112343	1992-03-25	1992-03-25 00:00:00	1992-04-07	1992-04-07 00:00:00	32020		\N	26437	0	195662009	4112343		0
6974	410	440448	1951-09-02	1951-09-02 00:00:00	\N	\N	32020		\N	27156	0	74400008	440448		0
7140	419	40481087	1991-10-23	1991-10-23 00:00:00	1991-10-30	1991-10-30 00:00:00	32020		\N	27729	0	444814009	40481087		0
7306	430	372328	1931-09-18	1931-09-18 00:00:00	1931-11-28	1931-11-28 00:00:00	32020		\N	28464	0	65363002	372328		0
7472	439	4112343	2008-04-01	2008-04-01 00:00:00	2008-04-10	2008-04-10 00:00:00	32020		\N	29159	0	195662009	4112343		0
7646	449	257012	2000-02-08	2000-02-08 00:00:00	\N	\N	32020		\N	29964	0	40055000	257012		0
7804	455	4112343	1969-05-10	1969-05-10 00:00:00	1969-05-22	1969-05-22 00:00:00	32020		\N	30377	0	195662009	4112343		0
7993	469	372328	1939-03-03	1939-03-03 00:00:00	1939-05-06	1939-05-06 00:00:00	32020		\N	31264	0	65363002	372328		0
8159	479	260139	2018-09-21	2018-09-21 00:00:00	2018-10-05	2018-10-05 00:00:00	32020		\N	31908	0	10509002	260139		0
8302	484	81893	1973-10-21	1973-10-21 00:00:00	\N	\N	32020		\N	32392	0	64766004	81893		0
8468	492	4156265	1968-07-25	1968-07-25 00:00:00	1968-08-08	1968-08-08 00:00:00	32020		\N	32905	0	370247008	4156265		0
8648	505	378001	1976-01-08	1976-01-08 00:00:00	1976-03-08	1976-03-08 00:00:00	32020		\N	33827	0	62106007	378001		0
8800	515	140673	2009-03-05	2009-03-05 00:00:00	\N	\N	32020		\N	34416	0	40930008	140673		0
8968	525	260139	2002-02-19	2002-02-19 00:00:00	2002-02-26	2002-02-26 00:00:00	32020		\N	34969	0	10509002	260139		0
9133	539	321042	1972-01-02	1972-01-02 00:00:00	\N	\N	32020		\N	35857	0	410429000	321042		0
9298	549	40481087	1973-07-17	1973-07-17 00:00:00	1973-07-31	1973-07-31 00:00:00	32020		\N	36352	0	444814009	40481087		0
9464	559	28060	1992-04-03	1992-04-03 00:00:00	1992-04-16	1992-04-16 00:00:00	32020		\N	37055	0	43878008	28060		0
9631	571	40481087	1955-08-02	1955-08-02 00:00:00	1955-08-16	1955-08-16 00:00:00	32020		\N	37824	0	444814009	40481087		0
9796	579	40481087	1988-07-11	1988-07-11 00:00:00	1988-08-01	1988-08-01 00:00:00	32020		\N	38292	0	444814009	40481087		0
9973	592	40481087	1993-08-30	1993-08-30 00:00:00	1993-09-13	1993-09-13 00:00:00	32020		\N	39129	0	444814009	40481087		0
10128	600	4027663	1978-12-31	1978-12-31 00:00:00	\N	\N	32020		\N	39572	0	13200003	4027663		0
10295	608	440086	1981-12-17	1981-12-17 00:00:00	1982-07-15	1982-07-15 00:00:00	32020		\N	40403	0	192127007	440086		0
10460	615	4112343	1987-11-17	1987-11-17 00:00:00	1987-11-27	1987-11-27 00:00:00	32020		\N	40914	0	195662009	4112343		0
2	1	378001	2008-05-18	2008-05-18 00:00:00	2008-07-17	2008-07-17 00:00:00	32020		\N	84	0	62106007	378001		0
168	7	40481087	1993-03-06	1993-03-06 00:00:00	1993-03-27	1993-03-27 00:00:00	32020		\N	599	0	444814009	40481087		0
334	17	40481087	1994-04-07	1994-04-07 00:00:00	1994-04-28	1994-04-28 00:00:00	32020		\N	1308	0	444814009	40481087		0
500	30	4283893	2014-02-17	2014-02-17 00:00:00	2014-04-28	2014-04-28 00:00:00	32020		\N	2131	0	36971009	4283893		0
666	36	80180	1993-05-30	1993-05-30 00:00:00	\N	\N	32020		\N	2560	0	396275006	80180		0
890	49	321042	2003-07-12	2003-07-12 00:00:00	\N	\N	32020		\N	3529	0	410429000	321042		0
1022	61	40481087	1981-05-22	1981-05-22 00:00:00	1981-06-12	1981-06-12 00:00:00	32020		\N	4124	0	444814009	40481087		0
1168	69	40481087	1981-05-02	1981-05-02 00:00:00	1981-05-16	1981-05-16 00:00:00	32020		\N	4619	0	444814009	40481087		0
1330	78	4112343	2003-07-14	2003-07-14 00:00:00	2003-07-23	2003-07-23 00:00:00	32020		\N	5204	0	195662009	4112343		0
1518	90	40481087	1993-02-04	1993-02-04 00:00:00	1993-02-18	1993-02-18 00:00:00	32020		\N	6020	0	444814009	40481087		0
1662	97	378419	2015-08-10	2015-08-10 00:00:00	\N	\N	32020		\N	6613	0	26929004	378419		0
1828	105	317576	2000-06-09	2000-06-09 00:00:00	\N	\N	32020		\N	7109	0	53741008	317576		0
1994	116	4237458	1964-06-16	1964-06-16 00:00:00	1964-09-14	1964-09-14 00:00:00	32020		\N	7653	0	58150001	4237458		0
2176	126	81151	1985-08-30	1985-08-30 00:00:00	1985-10-04	1985-10-04 00:00:00	32020		\N	8447	0	44465007	81151		0
2326	137	78272	1974-03-16	1974-03-16 00:00:00	1974-04-06	1974-04-06 00:00:00	32020		\N	9119	0	70704007	78272		0
2516	148	4218389	2000-08-09	2000-08-09 00:00:00	2000-09-13	2000-09-13 00:00:00	32020		\N	9978	0	39848009	4218389		0
2658	155	40481087	1994-03-30	1994-03-30 00:00:00	1994-04-13	1994-04-13 00:00:00	32020		\N	10519	0	444814009	40481087		0
2824	162	40481087	1941-04-16	1941-04-16 00:00:00	1941-04-30	1941-04-30 00:00:00	32020		\N	11158	0	444814009	40481087		0
2998	176	4149245	1975-05-16	1975-05-16 00:00:00	1975-07-22	1975-07-22 00:00:00	32020		\N	11929	0	30832001	4149245		0
3156	185	258780	2013-05-26	2013-05-26 00:00:00	\N	\N	32020		\N	12564	0	185086009	258780		0
3322	191	260139	1981-11-29	1981-11-29 00:00:00	1981-12-06	1981-12-06 00:00:00	32020		\N	13067	0	10509002	260139		0
3488	199	4112343	1951-05-26	1951-05-26 00:00:00	1951-06-02	1951-06-02 00:00:00	32020		\N	13676	0	195662009	4112343		0
3654	209	40481087	1988-11-09	1988-11-09 00:00:00	1988-11-16	1988-11-16 00:00:00	32020		\N	14265	0	444814009	40481087		0
3820	220	372328	1993-02-11	1993-02-11 00:00:00	1993-07-28	1993-07-28 00:00:00	32020		\N	14796	0	65363002	372328		0
3989	232	4112343	2018-11-23	2018-11-23 00:00:00	2018-12-03	2018-12-03 00:00:00	32020		\N	15626	0	195662009	4112343		0
4176	244	4294548	1932-12-08	1932-12-08 00:00:00	1932-12-29	1932-12-29 00:00:00	32020		\N	16340	0	75498004	4294548		0
4318	248	40481087	1998-12-28	1998-12-28 00:00:00	1999-01-18	1999-01-18 00:00:00	32020		\N	16707	0	444814009	40481087		0
4485	263	4059173	2010-11-05	2010-11-05 00:00:00	2011-01-04	2011-01-04 00:00:00	32020		\N	17423	0	16114001	4059173		0
4659	273	40481087	2002-08-02	2002-08-02 00:00:00	2002-08-09	2002-08-09 00:00:00	32020		\N	18262	0	444814009	40481087		0
4817	283	40481087	2004-03-06	2004-03-06 00:00:00	2004-03-13	2004-03-13 00:00:00	32020		\N	18830	0	444814009	40481087		0
4988	295	28060	1964-03-21	1964-03-21 00:00:00	1964-04-03	1964-04-03 00:00:00	32020		\N	19629	0	43878008	28060		0
5155	304	260139	2003-09-03	2003-09-03 00:00:00	2003-09-10	2003-09-10 00:00:00	32020		\N	20252	0	10509002	260139		0
5315	312	4112343	2003-03-12	2003-03-12 00:00:00	2003-03-21	2003-03-21 00:00:00	32020		\N	20714	0	195662009	4112343		0
5515	326	4112343	1972-02-22	1972-02-22 00:00:00	1972-02-29	1972-02-29 00:00:00	32020		\N	21542	0	195662009	4112343		0
5657	334	372328	1937-03-26	1937-03-26 00:00:00	1937-05-12	1937-05-12 00:00:00	32020		\N	22212	0	65363002	372328		0
5813	341	4156265	1989-04-10	1989-04-10 00:00:00	1989-05-01	1989-05-01 00:00:00	32020		\N	22742	0	370247008	4156265		0
5979	351	440448	2016-11-21	2016-11-21 00:00:00	\N	\N	32020		\N	23369	0	74400008	440448		0
6145	362	4155034	1991-07-26	1991-07-26 00:00:00	1991-08-09	1991-08-09 00:00:00	32020		\N	24053	0	283371005	4155034		0
6311	370	372328	1965-08-19	1965-08-19 00:00:00	1965-10-07	1965-10-07 00:00:00	32020		\N	24620	0	65363002	372328		0
6502	384	81151	1962-04-20	1962-04-20 00:00:00	1962-05-25	1962-05-25 00:00:00	32020		\N	25352	0	44465007	81151		0
6643	392	40481087	2003-05-23	2003-05-23 00:00:00	2003-06-06	2003-06-06 00:00:00	32020		\N	25706	0	444814009	40481087		0
6817	403	4112343	2016-08-15	2016-08-15 00:00:00	2016-08-23	2016-08-23 00:00:00	32020		\N	26495	0	195662009	4112343		0
6975	410	260139	1982-10-17	1982-10-17 00:00:00	1982-10-31	1982-10-31 00:00:00	32020		\N	27198	0	10509002	260139		0
7141	419	4027663	1944-07-21	1944-07-21 00:00:00	\N	\N	32020		\N	27744	0	13200003	4027663		0
7307	430	4237458	1938-10-11	1938-10-11 00:00:00	1938-12-10	1938-12-10 00:00:00	32020		\N	28537	0	58150001	4237458		0
7473	439	40481087	2000-10-27	2000-10-27 00:00:00	2000-11-17	2000-11-17 00:00:00	32020		\N	29106	0	444814009	40481087		0
7647	449	260139	1985-08-17	1985-08-17 00:00:00	1985-08-31	1985-08-31 00:00:00	32020		\N	29863	0	10509002	260139		0
7805	455	4112343	1993-11-26	1993-11-26 00:00:00	1993-12-05	1993-12-05 00:00:00	32020		\N	30460	0	195662009	4112343		0
7994	469	372328	1938-03-06	1938-03-06 00:00:00	1938-05-07	1938-05-07 00:00:00	32020		\N	31242	0	65363002	372328		0
8160	479	4152936	2011-11-15	2011-11-15 00:00:00	2011-11-29	2011-11-29 00:00:00	32020		\N	31962	0	283385000	4152936		0
8303	484	30753	1974-04-19	1974-04-19 00:00:00	\N	\N	32020		\N	32392	0	16761005	30753		0
8469	492	439777	1979-12-05	1979-12-05 00:00:00	\N	\N	32020		\N	32984	0	271737000	439777		0
8649	505	40481087	1995-04-17	1995-04-17 00:00:00	1995-04-24	1995-04-24 00:00:00	32020		\N	33769	0	444814009	40481087		0
8801	515	4218389	1985-04-07	1985-04-07 00:00:00	1985-05-05	1985-05-05 00:00:00	32020		\N	34390	0	39848009	4218389		0
8969	525	4112343	1967-03-21	1967-03-21 00:00:00	1967-04-02	1967-04-02 00:00:00	32020		\N	35041	0	195662009	4112343		0
9135	539	4116491	1984-03-13	1984-03-13 00:00:00	1984-04-30	1984-04-30 00:00:00	32020		\N	35835	0	301011002	4116491		0
9299	549	4146173	2008-05-03	2008-05-03 00:00:00	2008-07-02	2008-07-02 00:00:00	32020		\N	36366	0	307731004	4146173		0
9465	559	4059173	1981-01-07	1981-01-07 00:00:00	1981-03-08	1981-03-08 00:00:00	32020		\N	37097	0	16114001	4059173		0
9632	571	40481087	1968-06-18	1968-06-18 00:00:00	1968-07-02	1968-07-02 00:00:00	32020		\N	37826	0	444814009	40481087		0
9797	579	4112343	1984-06-13	1984-06-13 00:00:00	1984-06-23	1984-06-23 00:00:00	32020		\N	38367	0	195662009	4112343		0
9974	592	40481087	1995-03-14	1995-03-14 00:00:00	1995-03-28	1995-03-28 00:00:00	32020		\N	39112	0	444814009	40481087		0
10129	600	4230399	2002-01-20	2002-01-20 00:00:00	2002-04-20	2002-04-20 00:00:00	32020		\N	39650	0	359817006	4230399		0
10296	608	260139	1975-03-16	1975-03-16 00:00:00	1975-03-30	1975-03-30 00:00:00	32020		\N	40411	0	10509002	260139		0
10461	615	4113008	1991-05-06	1991-05-06 00:00:00	1991-05-20	1991-05-20 00:00:00	32020		\N	41043	0	284549007	4113008		0
3	1	4112343	1971-01-24	1971-01-24 00:00:00	1971-02-02	1971-02-02 00:00:00	32020		\N	42	0	195662009	4112343		0
180	9	4152936	2011-01-10	2011-01-10 00:00:00	2011-01-31	2011-01-31 00:00:00	32020		\N	865	0	283385000	4152936		0
335	17	195588	2000-01-08	2000-01-08 00:00:00	2000-02-27	2000-02-27 00:00:00	32020		\N	1310	0	38822007	195588		0
501	30	260139	2004-11-26	2004-11-26 00:00:00	2004-12-05	2004-12-05 00:00:00	32020		\N	2077	0	10509002	260139		0
667	36	4112343	2004-04-22	2004-04-22 00:00:00	2004-05-03	2004-05-03 00:00:00	32020		\N	2561	0	195662009	4112343		0
892	49	81151	1983-04-09	1983-04-09 00:00:00	1983-05-07	1983-05-07 00:00:00	32020		\N	3527	0	44465007	81151		0
1023	61	40481087	1980-09-09	1980-09-09 00:00:00	1980-09-16	1980-09-16 00:00:00	32020		\N	4139	0	444814009	40481087		0
1169	69	40481087	2006-04-03	2006-04-03 00:00:00	2006-04-24	2006-04-24 00:00:00	32020		\N	4680	0	444814009	40481087		0
1331	79	4218389	2016-08-26	2016-08-26 00:00:00	2016-09-23	2016-09-23 00:00:00	32020		\N	5273	0	39848009	4218389		0
1519	90	28060	1991-12-05	1991-12-05 00:00:00	1991-12-12	1991-12-12 00:00:00	32020		\N	6006	0	43878008	28060		0
1663	97	78272	1986-11-30	1986-11-30 00:00:00	1987-01-04	1987-01-04 00:00:00	32020		\N	6643	0	70704007	78272		0
1829	105	4112343	1986-09-30	1986-09-30 00:00:00	1986-10-10	1986-10-10 00:00:00	32020		\N	7100	0	195662009	4112343		0
1995	116	28060	2004-10-03	2004-10-03 00:00:00	2004-10-14	2004-10-14 00:00:00	32020		\N	7723	0	43878008	28060		0
2177	126	4112343	2004-02-27	2004-02-27 00:00:00	2004-03-05	2004-03-05 00:00:00	32020		\N	8462	0	195662009	4112343		0
2327	137	40481087	2011-04-18	2011-04-18 00:00:00	2011-04-25	2011-04-25 00:00:00	32020		\N	9184	0	444814009	40481087		0
2517	148	4230399	1993-06-12	1993-06-12 00:00:00	1993-08-11	1993-08-11 00:00:00	32020		\N	9981	0	359817006	4230399		0
2659	155	40481087	1994-05-22	1994-05-22 00:00:00	1994-05-29	1994-05-29 00:00:00	32020		\N	10553	0	444814009	40481087		0
2825	163	260139	2001-04-28	2001-04-28 00:00:00	2001-05-12	2001-05-12 00:00:00	32020		\N	11197	0	10509002	260139		0
2999	176	40481087	1974-02-13	1974-02-13 00:00:00	1974-02-20	1974-02-20 00:00:00	32020		\N	11897	0	444814009	40481087		0
3157	185	260139	2018-05-23	2018-05-23 00:00:00	2018-05-30	2018-05-30 00:00:00	32020		\N	12570	0	10509002	260139		0
3323	191	4296205	2000-06-04	2000-06-04 00:00:00	2000-06-25	2000-06-25 00:00:00	32020		\N	13044	0	403191005	4296205		0
3489	199	40481087	1995-02-05	1995-02-05 00:00:00	1995-02-12	1995-02-12 00:00:00	32020		\N	13673	0	444814009	40481087		0
3655	209	4112343	1954-09-18	1954-09-18 00:00:00	1954-09-26	1954-09-26 00:00:00	32020		\N	14257	0	195662009	4112343		0
3821	220	40481087	1988-02-09	1988-02-09 00:00:00	1988-02-16	1988-02-16 00:00:00	32020		\N	14813	0	444814009	40481087		0
3990	232	78272	1947-08-18	1947-08-18 00:00:00	1947-09-01	1947-09-01 00:00:00	32020		\N	15644	0	70704007	78272		0
4177	244	40481087	1964-07-22	1964-07-22 00:00:00	1964-07-29	1964-07-29 00:00:00	32020		\N	16265	0	444814009	40481087		0
4319	249	4116491	2017-08-13	2017-08-13 00:00:00	2017-09-17	2017-09-17 00:00:00	32020		\N	16758	0	301011002	4116491		0
4486	263	4152936	2013-08-21	2013-08-21 00:00:00	2013-09-11	2013-09-11 00:00:00	32020		\N	17424	0	283385000	4152936		0
4660	273	4112343	1983-09-19	1983-09-19 00:00:00	1983-10-01	1983-10-01 00:00:00	32020		\N	18266	0	195662009	4112343		0
4818	283	81151	2010-10-29	2010-10-29 00:00:00	2010-11-12	2010-11-12 00:00:00	32020		\N	18885	0	44465007	81151		0
4989	295	40481087	1985-03-11	1985-03-11 00:00:00	1985-03-18	1985-03-18 00:00:00	32020		\N	19594	0	444814009	40481087		0
5156	304	40481087	1984-01-14	1984-01-14 00:00:00	1984-01-28	1984-01-28 00:00:00	32020		\N	20250	0	444814009	40481087		0
5316	312	40481087	1974-12-18	1974-12-18 00:00:00	1975-01-01	1975-01-01 00:00:00	32020		\N	20661	0	444814009	40481087		0
5516	326	40481087	1970-12-05	1970-12-05 00:00:00	1970-12-19	1970-12-19 00:00:00	32020		\N	21541	0	444814009	40481087		0
5658	334	260139	1963-11-22	1963-11-22 00:00:00	1963-12-06	1963-12-06 00:00:00	32020		\N	22122	0	10509002	260139		0
5814	341	4112343	1986-09-17	1986-09-17 00:00:00	1986-09-25	1986-09-25 00:00:00	32020		\N	22762	0	195662009	4112343		0
5980	351	40481087	1984-08-03	1984-08-03 00:00:00	1984-08-24	1984-08-24 00:00:00	32020		\N	23410	0	444814009	40481087		0
6146	362	81893	2016-12-08	2016-12-08 00:00:00	\N	\N	32020		\N	24041	0	64766004	81893		0
6312	370	4296205	1979-08-09	1979-08-09 00:00:00	1979-09-13	1979-09-13 00:00:00	32020		\N	24584	0	403191005	4296205		0
6503	384	40481087	1979-04-13	1979-04-13 00:00:00	1979-04-27	1979-04-27 00:00:00	32020		\N	25332	0	444814009	40481087		0
6644	392	40481087	2014-05-16	2014-05-16 00:00:00	2014-05-23	2014-05-23 00:00:00	32020		\N	25715	0	444814009	40481087		0
6818	403	313217	1992-12-28	1992-12-28 00:00:00	\N	\N	32020		\N	26487	0	49436004	313217		0
6976	410	4116491	1995-08-21	1995-08-21 00:00:00	1995-09-28	1995-09-28 00:00:00	32020		\N	27193	0	301011002	4116491		0
7142	419	260139	1952-02-13	1952-02-13 00:00:00	1952-02-27	1952-02-27 00:00:00	32020		\N	27753	0	10509002	260139		0
7308	430	4035415	1997-12-05	1997-12-05 00:00:00	1998-01-04	1998-01-04 00:00:00	32020		\N	28540	0	239720000	4035415		0
7474	439	4112343	1979-09-03	1979-09-03 00:00:00	1979-09-13	1979-09-13 00:00:00	32020		\N	29155	0	195662009	4112343		0
7648	449	260139	1975-02-09	1975-02-09 00:00:00	1975-02-23	1975-02-23 00:00:00	32020		\N	29902	0	10509002	260139		0
7806	455	4218389	2001-07-05	2001-07-05 00:00:00	2001-08-09	2001-08-09 00:00:00	32020		\N	30471	0	39848009	4218389		0
7995	469	260139	1946-07-06	1946-07-06 00:00:00	1946-07-13	1946-07-13 00:00:00	32020		\N	31273	0	10509002	260139		0
8161	479	372328	1959-11-11	1959-11-11 00:00:00	1962-04-29	1962-04-29 00:00:00	32020		\N	31884	0	65363002	372328		0
8304	484	4283893	1990-04-14	1990-04-14 00:00:00	1990-05-12	1990-05-12 00:00:00	32020		\N	32316	0	36971009	4283893		0
8470	492	40481087	1958-12-27	1958-12-27 00:00:00	1959-01-03	1959-01-03 00:00:00	32020		\N	32980	0	444814009	40481087		0
8650	505	81151	1993-08-04	1993-08-04 00:00:00	1993-09-08	1993-09-08 00:00:00	32020		\N	33830	0	44465007	81151		0
8802	515	4112343	2005-06-12	2005-06-12 00:00:00	2005-06-23	2005-06-23 00:00:00	32020		\N	34415	0	195662009	4112343		0
8970	525	257012	1988-07-30	1988-07-30 00:00:00	\N	\N	32020		\N	35042	0	40055000	257012		0
9136	539	40481087	1969-08-09	1969-08-09 00:00:00	1969-08-16	1969-08-16 00:00:00	32020		\N	35771	0	444814009	40481087		0
9300	549	81151	1977-03-12	1977-03-12 00:00:00	1977-04-16	1977-04-16 00:00:00	32020		\N	36423	0	44465007	81151		0
9466	559	4094814	1992-04-09	1992-04-09 00:00:00	1992-05-09	1992-05-09 00:00:00	32020		\N	37098	0	262574004	4094814		0
9633	571	260139	2014-05-27	2014-05-27 00:00:00	2014-06-03	2014-06-03 00:00:00	32020		\N	37828	0	10509002	260139		0
9798	579	192671	1999-11-06	1999-11-06 00:00:00	\N	\N	32020		\N	38298	0	K92.2	35208414		0
9975	592	28060	1975-11-29	1975-11-29 00:00:00	1975-12-09	1975-12-09 00:00:00	32020		\N	39111	0	43878008	28060		0
10130	600	40481087	1977-04-11	1977-04-11 00:00:00	1977-05-02	1977-05-02 00:00:00	32020		\N	39570	0	444814009	40481087		0
10297	608	372328	1978-11-08	1978-11-08 00:00:00	1978-11-29	1978-11-29 00:00:00	32020		\N	40405	0	65363002	372328		0
10462	615	28060	1929-07-17	1929-07-17 00:00:00	1929-07-26	1929-07-26 00:00:00	32020		\N	40994	0	43878008	28060		0
4	1	4112343	2017-05-12	2017-05-12 00:00:00	2017-05-20	2017-05-20 00:00:00	32020		\N	64	0	195662009	4112343		0
181	9	28060	1987-08-13	1987-08-13 00:00:00	1987-08-24	1987-08-24 00:00:00	32020		\N	813	0	43878008	28060		0
336	17	4112343	1965-07-07	1965-07-07 00:00:00	1965-07-15	1965-07-15 00:00:00	32020		\N	1322	0	195662009	4112343		0
502	30	78272	2002-05-11	2002-05-11 00:00:00	2002-06-08	2002-06-08 00:00:00	32020		\N	2077	0	70704007	78272		0
676	38	4283893	2003-03-04	2003-03-04 00:00:00	2003-07-29	2003-07-29 00:00:00	32020		\N	2736	0	36971009	4283893		0
893	49	372328	1978-09-12	1978-09-12 00:00:00	1979-03-24	1979-03-24 00:00:00	32020		\N	3535	0	65363002	372328		0
1024	61	4084167	1978-07-29	1978-07-29 00:00:00	1978-07-29	1978-07-29 00:00:00	32020		\N	4159	0	241929008	4084167		0
1170	69	78272	1988-02-24	1988-02-24 00:00:00	1988-03-16	1988-03-16 00:00:00	32020		\N	4709	0	70704007	78272		0
1332	79	257012	1996-06-26	1996-06-26 00:00:00	1996-07-03	1996-07-03 00:00:00	32020		\N	5283	0	40055000	257012		0
1520	90	80180	1997-06-02	1997-06-02 00:00:00	\N	\N	32020		\N	6044	0	396275006	80180		0
1664	97	4116491	1972-12-20	1972-12-20 00:00:00	1973-02-04	1973-02-04 00:00:00	32020		\N	6565	0	301011002	4116491		0
1830	105	40481087	2000-06-27	2000-06-27 00:00:00	2000-07-18	2000-07-18 00:00:00	32020		\N	7111	0	444814009	40481087		0
1996	116	4283893	1977-06-13	1977-06-13 00:00:00	1977-07-25	1977-07-25 00:00:00	32020		\N	7707	0	36971009	4283893		0
2178	126	40481087	1969-01-10	1969-01-10 00:00:00	1969-01-17	1969-01-17 00:00:00	32020		\N	8417	0	444814009	40481087		0
2328	137	4230399	1996-10-07	1996-10-07 00:00:00	1997-01-05	1997-01-05 00:00:00	32020		\N	9122	0	359817006	4230399		0
2518	148	4113008	1980-09-04	1980-09-04 00:00:00	1980-09-18	1980-09-18 00:00:00	32020		\N	9980	0	284549007	4113008		0
2660	155	372328	1958-12-12	1958-12-12 00:00:00	1959-04-17	1959-04-17 00:00:00	32020		\N	10558	0	65363002	372328		0
2826	163	80180	2010-04-03	2010-04-03 00:00:00	\N	\N	32020		\N	11212	0	396275006	80180		0
3000	176	40481087	2004-10-28	2004-10-28 00:00:00	2004-11-04	2004-11-04 00:00:00	32020		\N	11902	0	444814009	40481087		0
3158	185	372328	1947-04-07	1947-04-07 00:00:00	1947-07-20	1947-07-20 00:00:00	32020		\N	12528	0	65363002	372328		0
3324	191	4283893	1981-05-13	1981-05-13 00:00:00	1981-08-12	1981-08-12 00:00:00	32020		\N	13141	0	36971009	4283893		0
3490	199	4116491	2003-04-01	2003-04-01 00:00:00	2003-05-13	2003-05-13 00:00:00	32020		\N	13648	0	301011002	4116491		0
3656	209	4112343	1951-04-26	1951-04-26 00:00:00	1951-05-03	1951-05-03 00:00:00	32020		\N	14229	0	195662009	4112343		0
3822	220	4112343	2011-06-06	2011-06-06 00:00:00	2011-06-17	2011-06-17 00:00:00	32020		\N	14815	0	195662009	4112343		0
3991	232	40481087	1992-04-22	1992-04-22 00:00:00	1992-05-06	1992-05-06 00:00:00	32020		\N	15600	0	444814009	40481087		0
4178	244	378001	1944-10-29	1944-10-29 00:00:00	1944-11-28	1944-11-28 00:00:00	32020		\N	16318	0	62106007	378001		0
4320	249	40481087	2019-04-25	2019-04-25 00:00:00	2019-05-16	2019-05-16 00:00:00	32020		\N	16759	0	444814009	40481087		0
4487	263	4112343	2014-07-28	2014-07-28 00:00:00	2014-08-05	2014-08-05 00:00:00	32020		\N	17478	0	195662009	4112343		0
4661	273	260139	2014-03-27	2014-03-27 00:00:00	2014-04-10	2014-04-10 00:00:00	32020		\N	18224	0	10509002	260139		0
4819	283	4112343	1993-06-03	1993-06-03 00:00:00	1993-06-14	1993-06-14 00:00:00	32020		\N	18861	0	195662009	4112343		0
4990	295	40481087	2013-08-13	2013-08-13 00:00:00	2013-09-03	2013-09-03 00:00:00	32020		\N	19596	0	444814009	40481087		0
5157	304	260139	1959-05-24	1959-05-24 00:00:00	1959-06-07	1959-06-07 00:00:00	32020		\N	20215	0	10509002	260139		0
5317	312	4027663	2006-01-15	2006-01-15 00:00:00	\N	\N	32020		\N	20697	0	13200003	4027663		0
5517	326	260139	1973-05-18	1973-05-18 00:00:00	1973-06-01	1973-06-01 00:00:00	32020		\N	21530	0	10509002	260139		0
5659	334	40481087	1994-09-13	1994-09-13 00:00:00	1994-09-27	1994-09-27 00:00:00	32020		\N	22167	0	444814009	40481087		0
5815	341	4112343	1969-10-24	1969-10-24 00:00:00	1969-11-03	1969-11-03 00:00:00	32020		\N	22761	0	195662009	4112343		0
5981	351	4285898	2017-10-10	2017-10-10 00:00:00	\N	\N	32020		\N	23368	0	68496003	4285898		0
6147	362	4266809	2017-08-05	2017-08-05 00:00:00	\N	\N	32020		\N	24041	0	397881000	4266809		0
6313	370	4112343	1975-07-12	1975-07-12 00:00:00	1975-07-25	1975-07-25 00:00:00	32020		\N	24598	0	195662009	4112343		0
6504	384	4112343	1965-10-03	1965-10-03 00:00:00	1965-10-10	1965-10-10 00:00:00	32020		\N	25291	0	195662009	4112343		0
6645	393	257012	2015-11-30	2015-11-30 00:00:00	\N	\N	32020		\N	25810	0	40055000	257012		0
6819	403	28060	1934-03-27	1934-03-27 00:00:00	1934-04-03	1934-04-03 00:00:00	32020		\N	26432	0	43878008	28060		0
6977	410	372328	1951-04-24	1951-04-24 00:00:00	1951-08-09	1951-08-09 00:00:00	32020		\N	27221	0	65363002	372328		0
7143	419	40481087	1938-08-06	1938-08-06 00:00:00	1938-08-20	1938-08-20 00:00:00	32020		\N	27751	0	444814009	40481087		0
7309	430	80502	2011-11-19	2011-11-19 00:00:00	\N	\N	32020		\N	28547	0	64859006	80502		0
7475	439	4112343	2009-04-06	2009-04-06 00:00:00	2009-04-17	2009-04-17 00:00:00	32020		\N	29116	0	195662009	4112343		0
7649	449	4116491	1996-10-19	1996-10-19 00:00:00	1996-12-08	1996-12-08 00:00:00	32020		\N	29917	0	301011002	4116491		0
7818	457	40481087	1971-03-22	1971-03-22 00:00:00	1971-04-05	1971-04-05 00:00:00	32020		\N	30557	0	444814009	40481087		0
7996	469	4112343	1936-11-28	1936-11-28 00:00:00	1936-12-10	1936-12-10 00:00:00	32020		\N	31243	0	195662009	4112343		0
8162	479	40481087	2007-07-04	2007-07-04 00:00:00	2007-07-11	2007-07-11 00:00:00	32020		\N	31907	0	444814009	40481087		0
8305	484	4278672	1997-03-15	1997-03-15 00:00:00	1997-05-14	1997-05-14 00:00:00	32020		\N	32401	0	65966004	4278672		0
8471	492	4059173	2014-08-07	2014-08-07 00:00:00	2014-09-06	2014-09-06 00:00:00	32020		\N	32906	0	16114001	4059173		0
8651	505	372328	1969-03-31	1969-03-31 00:00:00	1969-05-13	1969-05-13 00:00:00	32020		\N	33763	0	65363002	372328		0
8803	515	4285898	1980-05-01	1980-05-01 00:00:00	\N	\N	32020		\N	34360	0	68496003	4285898		0
8971	525	4112343	1977-10-31	1977-10-31 00:00:00	1977-11-12	1977-11-12 00:00:00	32020		\N	34973	0	195662009	4112343		0
9137	539	260139	1981-06-10	1981-06-10 00:00:00	1981-06-17	1981-06-17 00:00:00	32020		\N	35795	0	10509002	260139		0
9301	549	192671	1987-12-28	1987-12-28 00:00:00	\N	\N	32020		\N	36419	0	K92.2	35208414		0
9482	563	40481087	1971-01-27	1971-01-27 00:00:00	1971-02-10	1971-02-10 00:00:00	32020		\N	37196	0	444814009	40481087		0
9634	571	40481087	1996-08-31	1996-08-31 00:00:00	1996-09-07	1996-09-07 00:00:00	32020		\N	37827	0	444814009	40481087		0
9799	579	40481087	1988-02-26	1988-02-26 00:00:00	1988-03-04	1988-03-04 00:00:00	32020		\N	38358	0	444814009	40481087		0
9976	592	40481087	1983-03-27	1983-03-27 00:00:00	1983-04-17	1983-04-17 00:00:00	32020		\N	39128	0	444814009	40481087		0
10131	600	80180	1987-08-21	1987-08-21 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
10298	608	4294548	2001-12-17	2001-12-17 00:00:00	2002-01-28	2002-01-28 00:00:00	32020		\N	40363	0	75498004	4294548		0
10463	615	4155034	1999-03-30	1999-03-30 00:00:00	1999-04-13	1999-04-13 00:00:00	32020		\N	41046	0	283371005	4155034		0
5	1	28060	1953-02-06	1953-02-06 00:00:00	1953-02-16	1953-02-16 00:00:00	32020		\N	41	0	43878008	28060		0
182	9	40481087	1985-07-06	1985-07-06 00:00:00	1985-07-13	1985-07-13 00:00:00	32020		\N	709	0	444814009	40481087		0
337	17	40481087	1951-12-13	1951-12-13 00:00:00	1951-12-27	1951-12-27 00:00:00	32020		\N	1332	0	444814009	40481087		0
503	30	372328	1974-11-09	1974-11-09 00:00:00	1975-07-26	1975-07-26 00:00:00	32020		\N	2116	0	65363002	372328		0
677	38	260139	1999-12-24	1999-12-24 00:00:00	2000-01-07	2000-01-07 00:00:00	32020		\N	2735	0	10509002	260139		0
894	49	40481087	1985-03-31	1985-03-31 00:00:00	1985-04-14	1985-04-14 00:00:00	32020		\N	3574	0	444814009	40481087		0
1025	61	28060	1990-05-10	1990-05-10 00:00:00	1990-05-20	1990-05-20 00:00:00	32020		\N	4140	0	43878008	28060		0
1171	69	260139	1955-12-24	1955-12-24 00:00:00	1956-01-07	1956-01-07 00:00:00	32020		\N	4694	0	10509002	260139		0
1333	79	260139	1990-08-05	1990-08-05 00:00:00	1990-08-12	1990-08-12 00:00:00	32020		\N	5260	0	10509002	260139		0
1521	90	4112343	1992-05-12	1992-05-12 00:00:00	1992-05-22	1992-05-22 00:00:00	32020		\N	6050	0	195662009	4112343		0
1665	97	4027663	1974-07-11	1974-07-11 00:00:00	\N	\N	32020		\N	6565	0	13200003	4027663		0
1831	105	372328	1979-07-28	1979-07-28 00:00:00	1980-04-25	1980-04-25 00:00:00	32020		\N	7144	0	65363002	372328		0
1997	116	192671	1970-03-12	1970-03-12 00:00:00	\N	\N	32020		\N	7655	0	K92.2	35208414		0
2179	126	40481087	1955-09-06	1955-09-06 00:00:00	1955-09-20	1955-09-20 00:00:00	32020		\N	8429	0	444814009	40481087		0
2329	137	4112343	2011-01-02	2011-01-02 00:00:00	2011-01-15	2011-01-15 00:00:00	32020		\N	9163	0	195662009	4112343		0
2519	148	440086	1987-10-13	1987-10-13 00:00:00	1996-10-20	1996-10-20 00:00:00	32020		\N	10017	0	192127007	440086		0
2661	155	80180	1990-09-20	1990-09-20 00:00:00	\N	\N	32020		\N	10605	0	396275006	80180		0
2827	163	4152936	1999-08-30	1999-08-30 00:00:00	1999-09-13	1999-09-13 00:00:00	32020		\N	11237	0	283385000	4152936		0
3001	176	260139	1966-08-19	1966-08-19 00:00:00	1966-08-26	1966-08-26 00:00:00	32020		\N	11896	0	10509002	260139		0
3159	185	372328	1950-11-06	1950-11-06 00:00:00	1951-04-22	1951-04-22 00:00:00	32020		\N	12551	0	65363002	372328		0
3325	191	260139	1968-09-30	1968-09-30 00:00:00	1968-10-07	1968-10-07 00:00:00	32020		\N	13073	0	10509002	260139		0
3491	199	372328	1942-04-27	1942-04-27 00:00:00	1942-06-10	1942-06-10 00:00:00	32020		\N	13657	0	65363002	372328		0
3657	209	4116491	1985-02-14	1985-02-14 00:00:00	1985-04-09	1985-04-09 00:00:00	32020		\N	14282	0	301011002	4116491		0
3823	220	372328	1986-12-17	1986-12-17 00:00:00	1987-08-12	1987-08-12 00:00:00	32020		\N	14816	0	65363002	372328		0
3992	232	378001	1962-04-27	1962-04-27 00:00:00	1962-05-27	1962-05-27 00:00:00	32020		\N	15615	0	62106007	378001		0
4179	244	40481087	1983-09-19	1983-09-19 00:00:00	1983-10-10	1983-10-10 00:00:00	32020		\N	16297	0	444814009	40481087		0
4321	249	4155034	2004-11-19	2004-11-19 00:00:00	2004-12-10	2004-12-10 00:00:00	32020		\N	16780	0	283371005	4155034		0
4488	263	257012	1965-02-08	1965-02-08 00:00:00	\N	\N	32020		\N	17445	0	40055000	257012		0
4662	273	4230399	2001-09-27	2001-09-27 00:00:00	2001-11-26	2001-11-26 00:00:00	32020		\N	18287	0	359817006	4230399		0
4820	283	40481087	2013-07-29	2013-07-29 00:00:00	2013-08-12	2013-08-12 00:00:00	32020		\N	18831	0	444814009	40481087		0
4991	295	4027663	1983-06-07	1983-06-07 00:00:00	\N	\N	32020		\N	19615	0	13200003	4027663		0
5158	304	40479422	2017-12-07	2017-12-07 00:00:00	2018-01-13	2018-01-13 00:00:00	32020		\N	20257	0	444448004	40479422		0
5336	316	40479768	1975-12-14	1975-12-14 00:00:00	1976-02-19	1976-02-19 00:00:00	32020		\N	20889	0	444470001	40479768		0
5518	326	30753	2003-07-13	2003-07-13 00:00:00	\N	\N	32020		\N	21557	0	16761005	30753		0
5660	334	4112343	2008-07-04	2008-07-04 00:00:00	2008-07-11	2008-07-11 00:00:00	32020		\N	22185	0	195662009	4112343		0
5816	341	372328	1963-03-28	1963-03-28 00:00:00	1963-06-17	1963-06-17 00:00:00	32020		\N	22787	0	65363002	372328		0
5983	351	40481087	1997-10-24	1997-10-24 00:00:00	1997-10-31	1997-10-31 00:00:00	32020		\N	23341	0	444814009	40481087		0
6148	362	4310024	2016-11-08	2016-11-08 00:00:00	\N	\N	32020		\N	24041	0	424802006	4310024		0
6314	370	4113008	1970-10-20	1970-10-20 00:00:00	1970-11-10	1970-11-10 00:00:00	32020		\N	24582	0	284549007	4113008		0
6505	384	4113008	2003-07-03	2003-07-03 00:00:00	2003-07-17	2003-07-17 00:00:00	32020		\N	25354	0	284549007	4113008		0
6646	393	260139	1962-08-13	1962-08-13 00:00:00	1962-08-20	1962-08-20 00:00:00	32020		\N	25760	0	10509002	260139		0
6820	403	4230399	1968-08-29	1968-08-29 00:00:00	1968-11-27	1968-11-27 00:00:00	32020		\N	26463	0	359817006	4230399		0
6978	410	40481087	1975-09-15	1975-09-15 00:00:00	1975-10-06	1975-10-06 00:00:00	32020		\N	27173	0	444814009	40481087		0
7144	419	260139	1922-10-31	1922-10-31 00:00:00	1922-11-07	1922-11-07 00:00:00	32020		\N	27750	0	10509002	260139		0
7310	430	4237458	1941-10-25	1941-10-25 00:00:00	1941-11-24	1941-11-24 00:00:00	32020		\N	28538	0	58150001	4237458		0
7476	439	4112343	1988-03-16	1988-03-16 00:00:00	1988-03-28	1988-03-28 00:00:00	32020		\N	29156	0	195662009	4112343		0
7650	449	260139	2001-06-27	2001-06-27 00:00:00	2001-07-11	2001-07-11 00:00:00	32020		\N	29913	0	10509002	260139		0
7819	457	4283893	1958-07-01	1958-07-01 00:00:00	1958-10-21	1958-10-21 00:00:00	32020		\N	30529	0	36971009	4283893		0
7997	469	40481087	1955-07-27	1955-07-27 00:00:00	1955-08-10	1955-08-10 00:00:00	32020		\N	31310	0	444814009	40481087		0
8163	479	260139	2004-11-03	2004-11-03 00:00:00	2004-11-10	2004-11-10 00:00:00	32020		\N	31882	0	10509002	260139		0
8306	484	40481087	2005-09-27	2005-09-27 00:00:00	2005-10-18	2005-10-18 00:00:00	32020		\N	32318	0	444814009	40481087		0
8472	492	40481087	1956-03-14	1956-03-14 00:00:00	1956-04-04	1956-04-04 00:00:00	32020		\N	32936	0	444814009	40481087		0
8652	505	260139	2019-02-26	2019-02-26 00:00:00	2019-03-07	2019-03-07 00:00:00	32020		\N	33782	0	10509002	260139		0
8804	515	4112343	1969-01-21	1969-01-21 00:00:00	1969-02-03	1969-02-03 00:00:00	32020		\N	34324	0	195662009	4112343		0
8972	525	4152936	2013-03-04	2013-03-04 00:00:00	2013-03-18	2013-03-18 00:00:00	32020		\N	34963	0	283385000	4152936		0
9138	539	4112343	1990-02-06	1990-02-06 00:00:00	1990-02-17	1990-02-17 00:00:00	32020		\N	35837	0	195662009	4112343		0
9302	549	4155034	2011-04-18	2011-04-18 00:00:00	2011-05-09	2011-05-09 00:00:00	32020		\N	36424	0	283371005	4155034		0
9483	563	40481087	1978-04-13	1978-04-13 00:00:00	1978-04-20	1978-04-20 00:00:00	32020		\N	37274	0	444814009	40481087		0
9635	571	4142905	1968-02-09	1968-02-09 00:00:00	1968-05-09	1968-05-09 00:00:00	32020		\N	37833	0	33737001	4142905		0
9800	579	40481087	2009-07-13	2009-07-13 00:00:00	2009-07-27	2009-07-27 00:00:00	32020		\N	38302	0	444814009	40481087		0
9977	592	40481087	2012-11-11	2012-11-11 00:00:00	2012-11-18	2012-11-18 00:00:00	32020		\N	39083	0	444814009	40481087		0
10132	600	4285898	1987-06-22	1987-06-22 00:00:00	\N	\N	32020		\N	\N	0	68496003	4285898		0
10299	608	4155034	1988-04-04	1988-04-04 00:00:00	1988-04-18	1988-04-18 00:00:00	32020		\N	40407	0	283371005	4155034		0
10464	615	40481087	1917-07-19	1917-07-19 00:00:00	1917-07-26	1917-07-26 00:00:00	32020		\N	40864	0	444814009	40481087		0
6	1	40481087	2012-02-14	2012-02-14 00:00:00	2012-02-28	2012-02-28 00:00:00	32020		\N	25	0	444814009	40481087		0
183	9	40481087	1996-04-18	1996-04-18 00:00:00	1996-05-09	1996-05-09 00:00:00	32020		\N	855	0	444814009	40481087		0
338	17	260139	2012-11-25	2012-11-25 00:00:00	2012-12-09	2012-12-09 00:00:00	32020		\N	1326	0	10509002	260139		0
504	30	40481087	1977-02-17	1977-02-17 00:00:00	1977-03-10	1977-03-10 00:00:00	32020		\N	2045	0	444814009	40481087		0
678	38	40481087	2017-05-25	2017-05-25 00:00:00	2017-06-08	2017-06-08 00:00:00	32020		\N	2738	0	444814009	40481087		0
895	49	4112343	1988-02-03	1988-02-03 00:00:00	1988-02-13	1988-02-13 00:00:00	32020		\N	3515	0	195662009	4112343		0
1026	61	40481087	1974-10-22	1974-10-22 00:00:00	1974-11-05	1974-11-05 00:00:00	32020		\N	4096	0	444814009	40481087		0
1172	69	40481087	1989-10-02	1989-10-02 00:00:00	1989-10-09	1989-10-09 00:00:00	32020		\N	4700	0	444814009	40481087		0
1334	79	40481087	1981-11-23	1981-11-23 00:00:00	1981-11-30	1981-11-30 00:00:00	32020		\N	5281	0	444814009	40481087		0
1522	90	372328	1963-05-12	1963-05-12 00:00:00	1963-07-30	1963-07-30 00:00:00	32020		\N	5985	0	65363002	372328		0
1666	97	4112343	1948-07-17	1948-07-17 00:00:00	1948-07-26	1948-07-26 00:00:00	32020		\N	6663	0	195662009	4112343		0
1832	105	40481087	2001-11-17	2001-11-17 00:00:00	2001-11-24	2001-11-24 00:00:00	32020		\N	7112	0	444814009	40481087		0
1998	116	40481087	1983-12-27	1983-12-27 00:00:00	1984-01-10	1984-01-10 00:00:00	32020		\N	7666	0	444814009	40481087		0
2180	126	40481087	1991-07-07	1991-07-07 00:00:00	1991-07-21	1991-07-21 00:00:00	32020		\N	8430	0	444814009	40481087		0
2330	137	28060	1978-11-04	1978-11-04 00:00:00	1978-11-13	1978-11-13 00:00:00	32020		\N	9124	0	43878008	28060		0
2520	148	4296204	2007-05-10	2007-05-10 00:00:00	2007-06-07	2007-06-07 00:00:00	32020		\N	9979	0	403190006	4296204		0
2662	155	40481087	1961-09-03	1961-09-03 00:00:00	1961-09-17	1961-09-17 00:00:00	32020		\N	10615	0	444814009	40481087		0
2828	163	4109685	1979-06-04	1979-06-04 00:00:00	1979-06-25	1979-06-25 00:00:00	32020		\N	11235	0	284551006	4109685		0
3002	176	78272	1971-07-22	1971-07-22 00:00:00	1971-08-05	1971-08-05 00:00:00	32020		\N	11928	0	70704007	78272		0
3160	185	372328	1948-01-16	1948-01-16 00:00:00	1948-04-18	1948-04-18 00:00:00	32020		\N	12550	0	65363002	372328		0
3326	191	4112343	1987-07-25	1987-07-25 00:00:00	1987-08-04	1987-08-04 00:00:00	32020		\N	13025	0	195662009	4112343		0
3492	199	260139	2010-02-04	2010-02-04 00:00:00	2010-02-18	2010-02-18 00:00:00	32020		\N	13694	0	10509002	260139		0
3658	209	4112343	1974-12-29	1974-12-29 00:00:00	1975-01-06	1975-01-06 00:00:00	32020		\N	14263	0	195662009	4112343		0
3825	222	40481087	1966-04-24	1966-04-24 00:00:00	1966-05-08	1966-05-08 00:00:00	32020		\N	14914	0	444814009	40481087		0
3993	232	4112343	1947-11-01	1947-11-01 00:00:00	1947-11-09	1947-11-09 00:00:00	32020		\N	15539	0	195662009	4112343		0
4180	244	260139	1974-10-16	1974-10-16 00:00:00	1974-10-30	1974-10-30 00:00:00	32020		\N	16284	0	10509002	260139		0
4322	249	28060	2013-07-21	2013-07-21 00:00:00	2013-08-01	2013-08-01 00:00:00	32020		\N	16757	0	43878008	28060		0
4489	263	81151	1958-03-31	1958-03-31 00:00:00	1958-04-14	1958-04-14 00:00:00	32020		\N	17421	0	44465007	81151		0
4663	273	133834	1980-03-28	1980-03-28 00:00:00	1993-01-19	1993-01-19 00:00:00	32020		\N	18213	0	24079001	133834		0
4821	283	260139	1993-05-27	1993-05-27 00:00:00	1993-06-10	1993-06-10 00:00:00	32020		\N	18826	0	10509002	260139		0
4992	295	40481087	2018-04-17	2018-04-17 00:00:00	2018-05-08	2018-05-08 00:00:00	32020		\N	19626	0	444814009	40481087		0
5159	304	28060	2018-12-27	2018-12-27 00:00:00	2019-01-03	2019-01-03 00:00:00	32020		\N	20204	0	43878008	28060		0
5337	316	40481087	1980-11-28	1980-11-28 00:00:00	1980-12-12	1980-12-12 00:00:00	32020		\N	20964	0	444814009	40481087		0
5519	326	80180	2004-03-09	2004-03-09 00:00:00	\N	\N	32020		\N	21557	0	396275006	80180		0
5661	334	260139	1944-09-16	1944-09-16 00:00:00	1944-09-23	1944-09-23 00:00:00	32020		\N	22164	0	10509002	260139		0
5817	341	260139	1990-06-06	1990-06-06 00:00:00	1990-06-13	1990-06-13 00:00:00	32020		\N	22763	0	10509002	260139		0
5984	351	260139	1982-10-05	1982-10-05 00:00:00	1982-10-12	1982-10-12 00:00:00	32020		\N	23409	0	10509002	260139		0
6149	362	80180	2017-08-05	2017-08-05 00:00:00	\N	\N	32020		\N	24041	0	396275006	80180		0
6315	370	40481087	1971-03-04	1971-03-04 00:00:00	1971-03-25	1971-03-25 00:00:00	32020		\N	24597	0	444814009	40481087		0
6506	384	4112343	1991-07-03	1991-07-03 00:00:00	1991-07-11	1991-07-11 00:00:00	32020		\N	25310	0	195662009	4112343		0
6647	393	30753	1996-07-18	1996-07-18 00:00:00	\N	\N	32020		\N	25803	0	16761005	30753		0
6821	403	4134304	1988-08-14	1988-08-14 00:00:00	1988-09-13	1988-09-13 00:00:00	32020		\N	26464	0	263102004	4134304		0
6979	410	40481087	2005-12-03	2005-12-03 00:00:00	2005-12-17	2005-12-17 00:00:00	32020		\N	27196	0	444814009	40481087		0
7145	419	4294548	1959-07-24	1959-07-24 00:00:00	1959-10-23	1959-10-23 00:00:00	32020		\N	27755	0	75498004	4294548		0
7311	430	4109685	2009-09-03	2009-09-03 00:00:00	2009-09-24	2009-09-24 00:00:00	32020		\N	28543	0	284551006	4109685		0
7477	439	40481087	1986-07-23	1986-07-23 00:00:00	1986-08-13	1986-08-13 00:00:00	32020		\N	29114	0	444814009	40481087		0
7651	449	80180	1993-08-11	1993-08-11 00:00:00	\N	\N	32020		\N	29911	0	396275006	80180		0
7820	457	28060	2016-05-17	2016-05-17 00:00:00	2016-05-30	2016-05-30 00:00:00	32020		\N	30560	0	43878008	28060		0
7998	469	378001	1988-01-10	1988-01-10 00:00:00	1988-02-09	1988-02-09 00:00:00	32020		\N	31365	0	62106007	378001		0
8164	479	40481087	2004-08-27	2004-08-27 00:00:00	2004-09-10	2004-09-10 00:00:00	32020		\N	31906	0	444814009	40481087		0
8307	484	372328	1943-04-08	1943-04-08 00:00:00	1943-12-20	1943-12-20 00:00:00	32020		\N	32314	0	65363002	372328		0
8473	492	40481087	1950-07-30	1950-07-30 00:00:00	1950-08-06	1950-08-06 00:00:00	32020		\N	32978	0	444814009	40481087		0
8653	505	4156265	1971-03-21	1971-03-21 00:00:00	1971-04-04	1971-04-04 00:00:00	32020		\N	33826	0	370247008	4156265		0
8805	515	40479422	1976-11-13	1976-11-13 00:00:00	1976-12-20	1976-12-20 00:00:00	32020		\N	34389	0	444448004	40479422		0
8973	525	4113008	1955-01-03	1955-01-03 00:00:00	1955-01-17	1955-01-17 00:00:00	32020		\N	34959	0	284549007	4113008		0
9139	539	40481087	1953-11-12	1953-11-12 00:00:00	1953-11-19	1953-11-19 00:00:00	32020		\N	35834	0	444814009	40481087		0
9303	549	40481087	1989-02-03	1989-02-03 00:00:00	1989-02-17	1989-02-17 00:00:00	32020		\N	36363	0	444814009	40481087		0
9484	563	372328	1964-06-11	1964-06-11 00:00:00	1964-07-19	1964-07-19 00:00:00	32020		\N	37287	0	65363002	372328		0
9636	571	439777	1956-08-29	1956-08-29 00:00:00	\N	\N	32020		\N	37797	0	271737000	439777		0
9801	579	78272	1993-08-31	1993-08-31 00:00:00	1993-09-28	1993-09-28 00:00:00	32020		\N	38336	0	70704007	78272		0
9978	592	40481087	2005-10-06	2005-10-06 00:00:00	2005-10-13	2005-10-13 00:00:00	32020		\N	39113	0	444814009	40481087		0
10133	600	30753	1987-04-23	1987-04-23 00:00:00	\N	\N	32020		\N	\N	0	16761005	30753		0
10300	608	80180	2012-11-29	2012-11-29 00:00:00	\N	\N	32020		\N	40360	0	396275006	80180		0
10465	615	4134304	1995-01-29	1995-01-29 00:00:00	1995-04-29	1995-04-29 00:00:00	32020		\N	41044	0	263102004	4134304		0
7	1	4112343	2008-01-16	2008-01-16 00:00:00	2008-01-26	2008-01-26 00:00:00	32020		\N	76	0	195662009	4112343		0
184	9	4112343	2000-05-28	2000-05-28 00:00:00	2000-06-06	2000-06-06 00:00:00	32020		\N	856	0	195662009	4112343		0
339	17	260139	1966-10-19	1966-10-19 00:00:00	1966-10-26	1966-10-26 00:00:00	32020		\N	1323	0	10509002	260139		0
505	30	4237458	1977-08-29	1977-08-29 00:00:00	1977-09-28	1977-09-28 00:00:00	32020		\N	2125	0	58150001	4237458		0
679	38	4027663	1997-02-01	1997-02-01 00:00:00	\N	\N	32020		\N	2694	0	13200003	4027663		0
896	49	40481087	1994-08-29	1994-08-29 00:00:00	1994-09-19	1994-09-19 00:00:00	32020		\N	3575	0	444814009	40481087		0
1027	61	372328	1969-12-23	1969-12-23 00:00:00	1970-06-28	1970-06-28 00:00:00	32020		\N	4081	0	65363002	372328		0
1173	69	40481087	1981-09-20	1981-09-20 00:00:00	1981-10-11	1981-10-11 00:00:00	32020		\N	4620	0	444814009	40481087		0
1335	79	4112343	1997-12-20	1997-12-20 00:00:00	1998-01-01	1998-01-01 00:00:00	32020		\N	5284	0	195662009	4112343		0
1523	90	257012	1985-08-18	1985-08-18 00:00:00	1985-08-25	1985-08-25 00:00:00	32020		\N	5990	0	40055000	257012		0
1667	97	260139	2001-05-15	2001-05-15 00:00:00	2001-05-29	2001-05-29 00:00:00	32020		\N	6619	0	10509002	260139		0
1833	105	40481087	1996-08-17	1996-08-17 00:00:00	1996-09-07	1996-09-07 00:00:00	32020		\N	7137	0	444814009	40481087		0
1999	116	378419	2000-12-03	2000-12-03 00:00:00	\N	\N	32020		\N	7736	0	26929004	378419		0
2181	126	260139	1978-11-07	1978-11-07 00:00:00	1978-11-14	1978-11-14 00:00:00	32020		\N	8460	0	10509002	260139		0
2331	137	40481087	1983-07-17	1983-07-17 00:00:00	1983-08-07	1983-08-07 00:00:00	32020		\N	9125	0	444814009	40481087		0
2521	148	4112343	1991-09-09	1991-09-09 00:00:00	1991-09-22	1991-09-22 00:00:00	32020		\N	10008	0	195662009	4112343		0
2663	155	4294548	2016-01-23	2016-01-23 00:00:00	2016-03-12	2016-03-12 00:00:00	32020		\N	10579	0	75498004	4294548		0
2829	163	40481087	1973-04-28	1973-04-28 00:00:00	1973-05-12	1973-05-12 00:00:00	32020		\N	11176	0	444814009	40481087		0
3003	176	4112343	2005-01-25	2005-01-25 00:00:00	2005-02-06	2005-02-06 00:00:00	32020		\N	11894	0	195662009	4112343		0
3161	185	40481087	1989-10-10	1989-10-10 00:00:00	1989-10-31	1989-10-31 00:00:00	32020		\N	12557	0	444814009	40481087		0
3327	191	260139	1946-04-17	1946-04-17 00:00:00	1946-05-01	1946-05-01 00:00:00	32020		\N	13062	0	10509002	260139		0
3493	199	80180	1983-04-07	1983-04-07 00:00:00	\N	\N	32020		\N	13665	0	396275006	80180		0
3659	209	40481087	2009-07-24	2009-07-24 00:00:00	2009-08-14	2009-08-14 00:00:00	32020		\N	14213	0	444814009	40481087		0
3826	222	40481087	1958-03-20	1958-03-20 00:00:00	1958-04-03	1958-04-03 00:00:00	32020		\N	14889	0	444814009	40481087		0
3994	232	378001	2002-11-14	2002-11-14 00:00:00	2003-01-13	2003-01-13 00:00:00	32020		\N	15619	0	62106007	378001		0
4181	244	372328	1938-02-09	1938-02-09 00:00:00	1938-04-11	1938-04-11 00:00:00	32020		\N	16359	0	65363002	372328		0
4323	249	40481087	2001-11-27	2001-11-27 00:00:00	2001-12-18	2001-12-18 00:00:00	32020		\N	16747	0	444814009	40481087		0
4490	263	372328	1960-02-12	1960-02-12 00:00:00	1960-06-05	1960-06-05 00:00:00	32020		\N	17481	0	65363002	372328		0
4664	273	4112343	2005-09-26	2005-09-26 00:00:00	2005-10-09	2005-10-09 00:00:00	32020		\N	18242	0	195662009	4112343		0
4822	283	28060	1985-01-23	1985-01-23 00:00:00	1985-02-02	1985-02-02 00:00:00	32020		\N	18835	0	43878008	28060		0
4993	295	40481087	1990-10-22	1990-10-22 00:00:00	1990-11-05	1990-11-05 00:00:00	32020		\N	19595	0	444814009	40481087		0
5160	304	28060	2005-09-14	2005-09-14 00:00:00	2005-09-23	2005-09-23 00:00:00	32020		\N	20254	0	43878008	28060		0
5338	316	4155034	2014-02-20	2014-02-20 00:00:00	2014-03-06	2014-03-06 00:00:00	32020		\N	20985	0	283371005	4155034		0
5520	326	81893	2002-08-17	2002-08-17 00:00:00	\N	\N	32020		\N	21557	0	64766004	81893		0
5662	334	372328	1939-04-02	1939-04-02 00:00:00	1939-05-10	1939-05-10 00:00:00	32020		\N	22187	0	65363002	372328		0
5818	341	40481087	2002-11-09	2002-11-09 00:00:00	2002-11-30	2002-11-30 00:00:00	32020		\N	22755	0	444814009	40481087		0
5985	351	260139	2017-11-17	2017-11-17 00:00:00	2017-12-01	2017-12-01 00:00:00	32020		\N	23416	0	10509002	260139		0
6150	362	372328	1982-07-15	1982-07-15 00:00:00	1982-08-31	1982-08-31 00:00:00	32020		\N	24056	0	65363002	372328		0
6316	370	40481087	1985-07-17	1985-07-17 00:00:00	1985-07-24	1985-07-24 00:00:00	32020		\N	24630	0	444814009	40481087		0
6507	384	4112343	1971-05-14	1971-05-14 00:00:00	1971-05-25	1971-05-25 00:00:00	32020		\N	25308	0	195662009	4112343		0
6648	393	4027663	1986-01-02	1986-01-02 00:00:00	\N	\N	32020		\N	25766	0	13200003	4027663		0
6822	403	4112343	2004-02-07	2004-02-07 00:00:00	2004-02-16	2004-02-16 00:00:00	32020		\N	26501	0	195662009	4112343		0
6980	410	40481087	2010-05-31	2010-05-31 00:00:00	2010-06-14	2010-06-14 00:00:00	32020		\N	27175	0	444814009	40481087		0
7146	419	260139	1987-03-08	1987-03-08 00:00:00	1987-03-22	1987-03-22 00:00:00	32020		\N	27759	0	10509002	260139		0
7312	430	40481087	1948-06-27	1948-06-27 00:00:00	1948-07-18	1948-07-18 00:00:00	32020		\N	28516	0	444814009	40481087		0
7478	439	260139	1987-08-17	1987-08-17 00:00:00	1987-08-24	1987-08-24 00:00:00	32020		\N	29103	0	10509002	260139		0
7652	449	260139	1981-07-23	1981-07-23 00:00:00	1981-08-06	1981-08-06 00:00:00	32020		\N	29874	0	10509002	260139		0
7821	457	81151	1989-03-27	1989-03-27 00:00:00	1989-04-17	1989-04-17 00:00:00	32020		\N	30591	0	44465007	81151		0
7999	469	440086	1944-11-27	1944-11-27 00:00:00	1951-04-09	1951-04-09 00:00:00	32020		\N	31245	0	192127007	440086		0
8165	479	40481087	1943-11-09	1943-11-09 00:00:00	1943-11-16	1943-11-16 00:00:00	32020		\N	31903	0	444814009	40481087		0
8308	484	40481087	1953-04-18	1953-04-18 00:00:00	1953-05-09	1953-05-09 00:00:00	32020		\N	32395	0	444814009	40481087		0
8474	492	372328	1950-12-17	1950-12-17 00:00:00	1951-11-23	1951-11-23 00:00:00	32020		\N	32987	0	65363002	372328		0
8654	505	81893	2000-05-22	2000-05-22 00:00:00	\N	\N	32020		\N	33790	0	64766004	81893		0
8806	515	4112343	1989-11-18	1989-11-18 00:00:00	1989-11-30	1989-11-30 00:00:00	32020		\N	34333	0	195662009	4112343		0
8974	525	4283893	1988-06-04	1988-06-04 00:00:00	1988-09-03	1988-09-03 00:00:00	32020		\N	34966	0	36971009	4283893		0
9140	539	4112343	1989-11-26	1989-11-26 00:00:00	1989-12-05	1989-12-05 00:00:00	32020		\N	35785	0	195662009	4112343		0
9304	549	40481087	1979-12-03	1979-12-03 00:00:00	1979-12-17	1979-12-17 00:00:00	32020		\N	36356	0	444814009	40481087		0
9485	563	381316	2005-03-13	2005-03-13 00:00:00	\N	\N	32020		\N	37311	0	230690007	381316		0
9637	571	4113008	1958-06-10	1958-06-10 00:00:00	1958-07-01	1958-07-01 00:00:00	32020		\N	37832	0	284549007	4113008		0
9802	579	4112343	1961-07-22	1961-07-22 00:00:00	1961-08-04	1961-08-04 00:00:00	32020		\N	38288	0	195662009	4112343		0
9979	592	80180	2007-03-09	2007-03-09 00:00:00	\N	\N	32020		\N	39113	0	396275006	80180		0
10134	600	40481087	1992-02-10	1992-02-10 00:00:00	1992-02-17	1992-02-17 00:00:00	32020		\N	39641	0	444814009	40481087		0
10301	608	40481087	1984-06-03	1984-06-03 00:00:00	1984-06-10	1984-06-10 00:00:00	32020		\N	40382	0	444814009	40481087		0
10466	615	4116491	1958-01-10	1958-01-10 00:00:00	1958-02-27	1958-02-27 00:00:00	32020		\N	40996	0	301011002	4116491		0
8	1	4296205	1978-06-22	1978-06-22 00:00:00	1978-07-27	1978-07-27 00:00:00	32020		\N	81	0	403191005	4296205		0
185	9	40481087	2012-12-17	2012-12-17 00:00:00	2013-01-07	2013-01-07 00:00:00	32020		\N	826	0	444814009	40481087		0
340	18	4059173	1995-06-25	1995-06-25 00:00:00	1995-09-23	1995-09-23 00:00:00	32020		\N	1383	0	16114001	4059173		0
506	30	40481087	1998-11-23	1998-11-23 00:00:00	1998-11-30	1998-11-30 00:00:00	32020		\N	2098	0	444814009	40481087		0
680	38	4283893	1973-09-30	1973-09-30 00:00:00	1973-10-14	1973-10-14 00:00:00	32020		\N	2723	0	36971009	4283893		0
897	49	372328	1976-11-13	1976-11-13 00:00:00	1977-09-17	1977-09-17 00:00:00	32020		\N	3577	0	65363002	372328		0
1028	61	40481087	2018-08-05	2018-08-05 00:00:00	2018-08-26	2018-08-26 00:00:00	32020		\N	4128	0	444814009	40481087		0
1174	69	40481087	1999-09-22	1999-09-22 00:00:00	1999-10-06	1999-10-06 00:00:00	32020		\N	4688	0	444814009	40481087		0
1336	79	4218389	1987-07-25	1987-07-25 00:00:00	1987-08-29	1987-08-29 00:00:00	32020		\N	5267	0	39848009	4218389		0
1524	90	78272	1978-08-26	1978-08-26 00:00:00	1978-09-30	1978-09-30 00:00:00	32020		\N	5998	0	70704007	78272		0
1668	97	260139	1999-07-06	1999-07-06 00:00:00	1999-07-20	1999-07-20 00:00:00	32020		\N	6567	0	10509002	260139		0
1834	105	4152936	1982-02-12	1982-02-12 00:00:00	1982-02-26	1982-02-26 00:00:00	32020		\N	7145	0	283385000	4152936		0
2000	116	80180	1970-02-14	1970-02-14 00:00:00	\N	\N	32020		\N	7687	0	396275006	80180		0
2182	126	4112343	1947-10-22	1947-10-22 00:00:00	1947-10-30	1947-10-30 00:00:00	32020		\N	8428	0	195662009	4112343		0
2332	137	134438	2002-06-29	2002-06-29 00:00:00	2003-02-25	2003-02-25 00:00:00	32020		\N	9251	0	40275004	134438		0
2522	148	80180	2012-12-25	2012-12-25 00:00:00	\N	\N	32020		\N	10026	0	396275006	80180		0
2664	155	81151	2011-05-22	2011-05-22 00:00:00	2011-06-19	2011-06-19 00:00:00	32020		\N	10530	0	44465007	81151		0
2830	163	40481087	2005-12-17	2005-12-17 00:00:00	2005-12-24	2005-12-24 00:00:00	32020		\N	11179	0	444814009	40481087		0
3004	176	40481087	1972-09-05	1972-09-05 00:00:00	1972-09-12	1972-09-12 00:00:00	32020		\N	11880	0	444814009	40481087		0
3162	185	260139	1977-04-30	1977-04-30 00:00:00	1977-05-14	1977-05-14 00:00:00	32020		\N	12525	0	10509002	260139		0
3328	191	40481087	1923-07-11	1923-07-11 00:00:00	1923-07-25	1923-07-25 00:00:00	32020		\N	13060	0	444814009	40481087		0
3494	199	4294548	2007-09-08	2007-09-08 00:00:00	2007-09-22	2007-09-22 00:00:00	32020		\N	13654	0	75498004	4294548		0
3660	209	381316	1992-07-31	1992-07-31 00:00:00	\N	\N	32020		\N	14215	0	230690007	381316		0
3827	222	195588	2008-08-30	2008-08-30 00:00:00	2008-10-07	2008-10-07 00:00:00	32020		\N	14952	0	38822007	195588		0
3995	232	40479768	1959-02-05	1959-02-05 00:00:00	1959-04-13	1959-04-13 00:00:00	32020		\N	15614	0	444470001	40479768		0
4182	244	4310024	1964-05-17	1964-05-17 00:00:00	\N	\N	32020		\N	16300	0	424802006	4310024		0
4324	249	40481087	1987-01-31	1987-01-31 00:00:00	1987-02-07	1987-02-07 00:00:00	32020		\N	16766	0	444814009	40481087		0
4491	263	80180	1991-03-28	1991-03-28 00:00:00	\N	\N	32020		\N	17501	0	396275006	80180		0
4665	273	40481087	2014-11-03	2014-11-03 00:00:00	2014-11-17	2014-11-17 00:00:00	32020		\N	18265	0	444814009	40481087		0
4823	283	81151	1986-12-29	1986-12-29 00:00:00	1987-01-19	1987-01-19 00:00:00	32020		\N	18879	0	44465007	81151		0
4994	295	372328	1953-05-25	1953-05-25 00:00:00	1954-05-26	1954-05-26 00:00:00	32020		\N	19603	0	65363002	372328		0
5161	304	4142905	1957-04-02	1957-04-02 00:00:00	1957-07-01	1957-07-01 00:00:00	32020		\N	20210	0	33737001	4142905		0
5339	316	40481087	2004-04-28	2004-04-28 00:00:00	2004-05-19	2004-05-19 00:00:00	32020		\N	20895	0	444814009	40481087		0
5521	326	4134304	1980-01-10	1980-01-10 00:00:00	1980-04-09	1980-04-09 00:00:00	32020		\N	21528	0	263102004	4134304		0
5663	334	4027663	1962-05-29	1962-05-29 00:00:00	\N	\N	32020		\N	22223	0	13200003	4027663		0
5819	341	40481087	1969-02-03	1969-02-03 00:00:00	1969-02-17	1969-02-17 00:00:00	32020		\N	22753	0	444814009	40481087		0
5986	351	4296204	1985-10-18	1985-10-18 00:00:00	1985-11-01	1985-11-01 00:00:00	32020		\N	23421	0	403190006	4296204		0
6151	362	4027663	2008-04-14	2008-04-14 00:00:00	\N	\N	32020		\N	24031	0	13200003	4027663		0
6317	370	40481087	2005-07-10	2005-07-10 00:00:00	2005-07-24	2005-07-24 00:00:00	32020		\N	24600	0	444814009	40481087		0
6508	384	4112343	2012-10-29	2012-10-29 00:00:00	2012-11-10	2012-11-10 00:00:00	32020		\N	25339	0	195662009	4112343		0
6649	393	80180	1997-07-13	1997-07-13 00:00:00	\N	\N	32020		\N	25804	0	396275006	80180		0
6823	403	40481087	1950-11-06	1950-11-06 00:00:00	1950-11-13	1950-11-13 00:00:00	32020		\N	26492	0	444814009	40481087		0
6981	410	40481087	1996-03-02	1996-03-02 00:00:00	1996-03-16	1996-03-16 00:00:00	32020		\N	27217	0	444814009	40481087		0
7147	419	378419	1990-04-01	1990-04-01 00:00:00	\N	\N	32020		\N	27773	0	26929004	378419		0
7313	430	378419	2005-07-16	2005-07-16 00:00:00	\N	\N	32020		\N	28450	0	26929004	378419		0
7479	440	40481087	1999-10-31	1999-10-31 00:00:00	1999-11-14	1999-11-14 00:00:00	32020		\N	29184	0	444814009	40481087		0
7653	449	40481087	1981-06-11	1981-06-11 00:00:00	1981-06-25	1981-06-25 00:00:00	32020		\N	29873	0	444814009	40481087		0
7822	457	4112343	1964-12-22	1964-12-22 00:00:00	1965-01-03	1965-01-03 00:00:00	32020		\N	30556	0	195662009	4112343		0
8000	469	4237458	2014-12-19	2014-12-19 00:00:00	2015-03-19	2015-03-19 00:00:00	32020		\N	31366	0	58150001	4237458		0
8166	479	4112343	1975-12-26	1975-12-26 00:00:00	1976-01-07	1976-01-07 00:00:00	32020		\N	31919	0	195662009	4112343		0
8309	484	40481087	1945-08-01	1945-08-01 00:00:00	1945-08-22	1945-08-22 00:00:00	32020		\N	32343	0	444814009	40481087		0
8475	492	40481087	1988-11-06	1988-11-06 00:00:00	1988-11-20	1988-11-20 00:00:00	32020		\N	32918	0	444814009	40481087		0
8655	505	4027663	1993-05-29	1993-05-29 00:00:00	\N	\N	32020		\N	33755	0	13200003	4027663		0
8807	515	260139	1971-09-12	1971-09-12 00:00:00	1971-09-26	1971-09-26 00:00:00	32020		\N	34325	0	10509002	260139		0
8975	525	80180	1990-03-15	1990-03-15 00:00:00	\N	\N	32020		\N	34988	0	396275006	80180		0
9141	539	260139	1989-01-16	1989-01-16 00:00:00	1989-01-23	1989-01-23 00:00:00	32020		\N	35836	0	10509002	260139		0
9305	549	372328	1953-05-26	1953-05-26 00:00:00	1953-07-08	1953-07-08 00:00:00	32020		\N	36400	0	65363002	372328		0
9486	563	40481087	1998-04-22	1998-04-22 00:00:00	1998-05-06	1998-05-06 00:00:00	32020		\N	37208	0	444814009	40481087		0
9638	571	40481087	1999-11-28	1999-11-28 00:00:00	1999-12-19	1999-12-19 00:00:00	32020		\N	37809	0	444814009	40481087		0
9803	579	40481087	1974-04-21	1974-04-21 00:00:00	1974-05-05	1974-05-05 00:00:00	32020		\N	38300	0	444814009	40481087		0
10031	596	4113008	1962-10-01	1962-10-01 00:00:00	1962-10-15	1962-10-15 00:00:00	32020		\N	39324	0	284549007	4113008		0
10135	600	260139	1987-04-09	1987-04-09 00:00:00	1987-04-16	1987-04-16 00:00:00	32020		\N	39573	0	10509002	260139		0
10302	608	4112343	1977-10-03	1977-10-03 00:00:00	1977-10-12	1977-10-12 00:00:00	32020		\N	40412	0	195662009	4112343		0
10467	615	40481087	1997-03-29	1997-03-29 00:00:00	1997-04-19	1997-04-19 00:00:00	32020		\N	40903	0	444814009	40481087		0
9	1	4112343	1961-07-05	1961-07-05 00:00:00	1961-07-14	1961-07-14 00:00:00	32020		\N	22	0	195662009	4112343		0
186	9	4051466	1982-07-26	1982-07-26 00:00:00	1997-11-11	1997-11-11 00:00:00	32020		\N	708	0	233678006	4051466		0
341	18	40481087	1976-12-13	1976-12-13 00:00:00	1976-12-20	1976-12-20 00:00:00	32020		\N	1405	0	444814009	40481087		0
507	30	4112343	2017-03-11	2017-03-11 00:00:00	2017-03-24	2017-03-24 00:00:00	32020		\N	2133	0	195662009	4112343		0
681	38	260139	1981-09-29	1981-09-29 00:00:00	1981-10-13	1981-10-13 00:00:00	32020		\N	2725	0	10509002	260139		0
898	49	40481087	1977-02-16	1977-02-16 00:00:00	1977-03-09	1977-03-09 00:00:00	32020		\N	3572	0	444814009	40481087		0
1029	61	372328	1968-08-18	1968-08-18 00:00:00	1968-09-29	1968-09-29 00:00:00	32020		\N	4080	0	65363002	372328		0
1175	69	4112343	2000-09-25	2000-09-25 00:00:00	2000-10-02	2000-10-02 00:00:00	32020		\N	4616	0	195662009	4112343		0
1337	79	40481087	1966-10-03	1966-10-03 00:00:00	1966-10-24	1966-10-24 00:00:00	32020		\N	5300	0	444814009	40481087		0
1525	90	4296204	1965-10-28	1965-10-28 00:00:00	1965-12-02	1965-12-02 00:00:00	32020		\N	5996	0	403190006	4296204		0
1669	97	4156265	1996-09-16	1996-09-16 00:00:00	1996-10-07	1996-10-07 00:00:00	32020		\N	6647	0	370247008	4156265		0
1835	105	4112343	1979-03-03	1979-03-03 00:00:00	1979-03-10	1979-03-10 00:00:00	32020		\N	7143	0	195662009	4112343		0
2001	116	40481087	1963-08-11	1963-08-11 00:00:00	1963-08-18	1963-08-18 00:00:00	32020		\N	7676	0	444814009	40481087		0
2183	126	4112343	2016-09-30	2016-09-30 00:00:00	2016-10-08	2016-10-08 00:00:00	32020		\N	8414	0	195662009	4112343		0
2333	137	4237458	1984-08-11	1984-08-11 00:00:00	1984-09-10	1984-09-10 00:00:00	32020		\N	9121	0	58150001	4237458		0
2523	148	4112343	2016-10-28	2016-10-28 00:00:00	2016-11-04	2016-11-04 00:00:00	32020		\N	9990	0	195662009	4112343		0
2665	155	40481087	1987-03-23	1987-03-23 00:00:00	1987-03-30	1987-03-30 00:00:00	32020		\N	10590	0	444814009	40481087		0
2831	163	192671	2010-04-25	2010-04-25 00:00:00	\N	\N	32020		\N	11188	0	K92.2	35208414		0
3005	176	4112343	1986-08-26	1986-08-26 00:00:00	1986-09-07	1986-09-07 00:00:00	32020		\N	11881	0	195662009	4112343		0
3163	185	40481087	1996-06-05	1996-06-05 00:00:00	1996-06-19	1996-06-19 00:00:00	32020		\N	12568	0	444814009	40481087		0
3329	191	40481087	1921-06-04	1921-06-04 00:00:00	1921-06-11	1921-06-11 00:00:00	32020		\N	13058	0	444814009	40481087		0
3495	199	372328	1945-12-21	1945-12-21 00:00:00	1946-03-13	1946-03-13 00:00:00	32020		\N	13696	0	65363002	372328		0
3661	209	372328	1992-04-18	1992-04-18 00:00:00	1993-03-05	1993-03-05 00:00:00	32020		\N	14215	0	65363002	372328		0
3828	222	4112343	2015-12-11	2015-12-11 00:00:00	2015-12-18	2015-12-18 00:00:00	32020		\N	14886	0	195662009	4112343		0
3996	232	40481087	1967-05-25	1967-05-25 00:00:00	1967-06-01	1967-06-01 00:00:00	32020		\N	15597	0	444814009	40481087		0
4183	244	378001	1979-02-28	1979-02-28 00:00:00	1979-04-29	1979-04-29 00:00:00	32020		\N	16319	0	62106007	378001		0
4325	249	80180	2016-12-06	2016-12-06 00:00:00	\N	\N	32020		\N	16737	0	396275006	80180		0
4492	263	260139	1955-02-16	1955-02-16 00:00:00	1955-03-02	1955-03-02 00:00:00	32020		\N	17425	0	10509002	260139		0
4666	273	28060	1976-02-14	1976-02-14 00:00:00	1976-02-27	1976-02-27 00:00:00	32020		\N	18223	0	43878008	28060		0
4824	283	80180	2018-10-12	2018-10-12 00:00:00	\N	\N	32020		\N	18837	0	396275006	80180		0
4995	295	4112343	1992-05-22	1992-05-22 00:00:00	1992-06-04	1992-06-04 00:00:00	32020		\N	19601	0	195662009	4112343		0
5162	304	192671	1998-05-03	1998-05-03 00:00:00	\N	\N	32020		\N	20213	0	K92.2	35208414		0
5340	316	40481087	1934-10-28	1934-10-28 00:00:00	1934-11-04	1934-11-04 00:00:00	32020		\N	20958	0	444814009	40481087		0
5522	326	192671	2004-04-10	2004-04-10 00:00:00	\N	\N	32020		\N	21527	0	K92.2	35208414		0
5664	334	372328	1983-08-17	1983-08-17 00:00:00	1985-05-15	1985-05-15 00:00:00	32020		\N	22213	0	65363002	372328		0
5820	341	40481087	2014-11-01	2014-11-01 00:00:00	2014-11-15	2014-11-15 00:00:00	32020		\N	22786	0	444814009	40481087		0
5987	351	4112343	2002-04-07	2002-04-07 00:00:00	2002-04-18	2002-04-18 00:00:00	32020		\N	23407	0	195662009	4112343		0
6152	362	260139	1996-12-14	1996-12-14 00:00:00	1996-12-28	1996-12-28 00:00:00	32020		\N	24018	0	10509002	260139		0
6318	370	4112343	1974-02-05	1974-02-05 00:00:00	1974-02-13	1974-02-13 00:00:00	32020		\N	24636	0	195662009	4112343		0
6509	384	260139	2008-02-10	2008-02-10 00:00:00	2008-02-17	2008-02-17 00:00:00	32020		\N	25348	0	10509002	260139		0
6650	393	4294548	2004-01-18	2004-01-18 00:00:00	2004-02-01	2004-02-01 00:00:00	32020		\N	25775	0	75498004	4294548		0
6824	403	260139	1951-12-16	1951-12-16 00:00:00	1952-01-01	1952-01-01 00:00:00	32020		\N	26492	0	10509002	260139		0
6982	410	4112343	1996-12-16	1996-12-16 00:00:00	1996-12-23	1996-12-23 00:00:00	32020		\N	27218	0	195662009	4112343		0
7148	419	4278672	1969-07-21	1969-07-21 00:00:00	1969-08-20	1969-08-20 00:00:00	32020		\N	27711	0	65966004	4278672		0
7314	430	81151	1973-03-11	1973-03-11 00:00:00	1973-04-15	1973-04-15 00:00:00	32020		\N	28539	0	44465007	81151		0
7480	440	260139	1983-09-18	1983-09-18 00:00:00	1983-09-25	1983-09-25 00:00:00	32020		\N	29203	0	10509002	260139		0
7654	449	261325	1991-08-29	1991-08-29 00:00:00	\N	\N	32020		\N	29866	0	87433001	261325		0
7823	457	260139	1954-04-01	1954-04-01 00:00:00	1954-04-15	1954-04-15 00:00:00	32020		\N	30528	0	10509002	260139		0
8001	469	40481087	1963-02-17	1963-02-17 00:00:00	1963-02-24	1963-02-24 00:00:00	32020		\N	31250	0	444814009	40481087		0
8167	479	260139	1964-03-23	1964-03-23 00:00:00	1964-04-06	1964-04-06 00:00:00	32020		\N	31877	0	10509002	260139		0
8310	484	4112343	1965-05-29	1965-05-29 00:00:00	1965-06-09	1965-06-09 00:00:00	32020		\N	32377	0	195662009	4112343		0
8476	492	260139	1954-10-03	1954-10-03 00:00:00	1954-10-17	1954-10-17 00:00:00	32020		\N	32949	0	10509002	260139		0
8656	505	4296204	1987-11-06	1987-11-06 00:00:00	1987-12-04	1987-12-04 00:00:00	32020		\N	33829	0	403190006	4296204		0
8808	515	4027663	1972-03-14	1972-03-14 00:00:00	\N	\N	32020		\N	34325	0	13200003	4027663		0
8976	525	40481087	2007-02-19	2007-02-19 00:00:00	2007-02-26	2007-02-26 00:00:00	32020		\N	34974	0	444814009	40481087		0
9142	539	4113008	1971-04-04	1971-04-04 00:00:00	1971-04-18	1971-04-18 00:00:00	32020		\N	35826	0	284549007	4113008		0
9306	549	80180	1987-12-04	1987-12-04 00:00:00	\N	\N	32020		\N	36387	0	396275006	80180		0
9487	563	134438	1985-04-14	1985-04-14 00:00:00	1986-03-15	1986-03-15 00:00:00	32020		\N	37275	0	40275004	134438		0
9639	571	40481087	1974-10-21	1974-10-21 00:00:00	1974-10-28	1974-10-28 00:00:00	32020		\N	37769	0	444814009	40481087		0
9804	579	28060	1996-09-21	1996-09-21 00:00:00	1996-10-01	1996-10-01 00:00:00	32020		\N	38301	0	43878008	28060		0
10032	596	28060	1972-01-09	1972-01-09 00:00:00	1972-01-17	1972-01-17 00:00:00	32020		\N	39383	0	43878008	28060		0
10136	600	4112343	2008-01-30	2008-01-30 00:00:00	2008-02-10	2008-02-10 00:00:00	32020		\N	39621	0	195662009	4112343		0
10303	608	28060	1981-04-26	1981-04-26 00:00:00	1981-05-03	1981-05-03 00:00:00	32020		\N	40378	0	43878008	28060		0
10468	615	4155034	1996-04-23	1996-04-23 00:00:00	1996-05-14	1996-05-14 00:00:00	32020		\N	41045	0	283371005	4155034		0
10	1	260139	1971-01-04	1971-01-04 00:00:00	1971-01-18	1971-01-18 00:00:00	32020		\N	23	0	10509002	260139		0
187	9	80180	2014-08-05	2014-08-05 00:00:00	\N	\N	32020		\N	771	0	396275006	80180		0
342	18	4218389	2016-01-06	2016-01-06 00:00:00	2016-02-03	2016-02-03 00:00:00	32020		\N	1380	0	39848009	4218389		0
508	30	260139	1998-04-21	1998-04-21 00:00:00	1998-05-05	1998-05-05 00:00:00	32020		\N	2129	0	10509002	260139		0
682	38	378001	1981-04-07	1981-04-07 00:00:00	1981-05-07	1981-05-07 00:00:00	32020		\N	2749	0	62106007	378001		0
899	49	260139	1997-05-30	1997-05-30 00:00:00	1997-06-13	1997-06-13 00:00:00	32020		\N	3562	0	10509002	260139		0
1030	61	4112343	2012-08-23	2012-08-23 00:00:00	2012-09-03	2012-09-03 00:00:00	32020		\N	4078	0	195662009	4112343		0
1176	69	4112343	1948-04-06	1948-04-06 00:00:00	1948-04-18	1948-04-18 00:00:00	32020		\N	4692	0	195662009	4112343		0
1338	79	40481087	1985-03-19	1985-03-19 00:00:00	1985-04-02	1985-04-02 00:00:00	32020		\N	5244	0	444814009	40481087		0
1526	90	4283893	1965-01-21	1965-01-21 00:00:00	1965-02-18	1965-02-18 00:00:00	32020		\N	6005	0	36971009	4283893		0
1670	97	40481087	1952-12-28	1952-12-28 00:00:00	1953-01-11	1953-01-11 00:00:00	32020		\N	6583	0	444814009	40481087		0
1836	105	40481087	1975-03-28	1975-03-28 00:00:00	1975-04-04	1975-04-04 00:00:00	32020		\N	7142	0	444814009	40481087		0
2002	116	4142905	1944-10-08	1944-10-08 00:00:00	1944-12-07	1944-12-07 00:00:00	32020		\N	7651	0	33737001	4142905		0
2184	126	40481087	1955-04-16	1955-04-16 00:00:00	1955-04-30	1955-04-30 00:00:00	32020		\N	8446	0	444814009	40481087		0
2334	137	4112343	1989-04-01	1989-04-01 00:00:00	1989-04-08	1989-04-08 00:00:00	32020		\N	9133	0	195662009	4112343		0
2524	148	40481087	2013-02-09	2013-02-09 00:00:00	2013-02-23	2013-02-23 00:00:00	32020		\N	10009	0	444814009	40481087		0
2666	156	40481087	1981-12-11	1981-12-11 00:00:00	1981-12-18	1981-12-18 00:00:00	32020		\N	10693	0	444814009	40481087		0
2832	163	40481087	2011-01-02	2011-01-02 00:00:00	2011-01-16	2011-01-16 00:00:00	32020		\N	11193	0	444814009	40481087		0
3006	176	260139	1986-08-20	1986-08-20 00:00:00	1986-09-03	1986-09-03 00:00:00	32020		\N	11905	0	10509002	260139		0
3164	186	4112343	2012-11-28	2012-11-28 00:00:00	2012-12-09	2012-12-09 00:00:00	32020		\N	12599	0	195662009	4112343		0
3330	191	260139	1967-06-30	1967-06-30 00:00:00	1967-07-07	1967-07-07 00:00:00	32020		\N	13066	0	10509002	260139		0
3496	199	40481087	2013-10-25	2013-10-25 00:00:00	2013-11-15	2013-11-15 00:00:00	32020		\N	13695	0	444814009	40481087		0
3662	209	440086	1962-02-20	1962-02-20 00:00:00	1962-06-19	1962-06-19 00:00:00	32020		\N	14260	0	192127007	440086		0
3829	222	4113008	2014-07-18	2014-07-18 00:00:00	2014-08-01	2014-08-01 00:00:00	32020		\N	14935	0	284549007	4113008		0
3997	232	40481087	1969-04-26	1969-04-26 00:00:00	1969-05-10	1969-05-10 00:00:00	32020		\N	15632	0	444814009	40481087		0
4184	244	28060	1949-10-27	1949-10-27 00:00:00	1949-11-09	1949-11-09 00:00:00	32020		\N	16295	0	43878008	28060		0
4326	249	260139	2011-01-19	2011-01-19 00:00:00	2011-01-26	2011-01-26 00:00:00	32020		\N	16768	0	10509002	260139		0
4493	263	4112343	2002-12-16	2002-12-16 00:00:00	2002-12-24	2002-12-24 00:00:00	32020		\N	17470	0	195662009	4112343		0
4667	273	378001	2013-12-23	2013-12-23 00:00:00	2014-02-21	2014-02-21 00:00:00	32020		\N	18324	0	62106007	378001		0
4830	285	40481087	1984-08-16	1984-08-16 00:00:00	1984-09-06	1984-09-06 00:00:00	32020		\N	19005	0	444814009	40481087		0
4996	295	260139	1980-07-18	1980-07-18 00:00:00	1980-07-25	1980-07-25 00:00:00	32020		\N	19592	0	10509002	260139		0
5163	304	4294548	1964-05-24	1964-05-24 00:00:00	1964-06-14	1964-06-14 00:00:00	32020		\N	20274	0	75498004	4294548		0
5341	316	4142905	2007-10-25	2007-10-25 00:00:00	2007-11-24	2007-11-24 00:00:00	32020		\N	20983	0	33737001	4142905		0
5523	326	4027663	1996-05-25	1996-05-25 00:00:00	\N	\N	32020		\N	21568	0	13200003	4027663		0
5665	334	255848	2017-11-04	2017-11-04 00:00:00	\N	\N	32020		\N	22119	0	233604007	255848		0
5821	341	261325	2017-08-28	2017-08-28 00:00:00	\N	\N	32020		\N	22799	0	87433001	261325		0
5988	351	260139	1991-11-26	1991-11-26 00:00:00	1991-12-10	1991-12-10 00:00:00	32020		\N	23406	0	10509002	260139		0
6153	362	260139	1981-08-21	1981-08-21 00:00:00	1981-09-04	1981-09-04 00:00:00	32020		\N	24017	0	10509002	260139		0
6319	371	40481087	1987-04-11	1987-04-11 00:00:00	1987-04-18	1987-04-18 00:00:00	32020		\N	24694	0	444814009	40481087		0
6510	384	40481087	2010-09-11	2010-09-11 00:00:00	2010-09-25	2010-09-25 00:00:00	32020		\N	25311	0	444814009	40481087		0
6651	393	260139	1998-09-06	1998-09-06 00:00:00	1998-09-20	1998-09-20 00:00:00	32020		\N	25774	0	10509002	260139		0
6825	403	28060	1936-08-22	1936-08-22 00:00:00	1936-09-04	1936-09-04 00:00:00	32020		\N	26532	0	43878008	28060		0
6983	410	260139	1975-02-18	1975-02-18 00:00:00	1975-02-25	1975-02-25 00:00:00	32020		\N	27197	0	10509002	260139		0
7149	419	255848	1995-12-01	1995-12-01 00:00:00	\N	\N	32020		\N	27713	0	233604007	255848		0
7315	430	255848	2012-10-07	2012-10-07 00:00:00	\N	\N	32020		\N	28548	0	233604007	255848		0
7481	440	260139	1994-03-07	1994-03-07 00:00:00	1994-03-21	1994-03-21 00:00:00	32020		\N	29204	0	10509002	260139		0
7655	449	4283893	1999-11-09	1999-11-09 00:00:00	2000-02-29	2000-02-29 00:00:00	32020		\N	29982	0	36971009	4283893		0
7824	457	440086	1960-08-11	1960-08-11 00:00:00	1969-08-19	1969-08-19 00:00:00	32020		\N	30568	0	192127007	440086		0
8002	469	40481087	2006-05-31	2006-05-31 00:00:00	2006-06-21	2006-06-21 00:00:00	32020		\N	31329	0	444814009	40481087		0
8168	479	372328	1957-04-13	1957-04-13 00:00:00	1958-04-20	1958-04-20 00:00:00	32020		\N	31883	0	65363002	372328		0
8311	484	4112343	1994-01-26	1994-01-26 00:00:00	1994-02-04	1994-02-04 00:00:00	32020		\N	32366	0	195662009	4112343		0
8477	492	4112343	2016-03-31	2016-03-31 00:00:00	2016-04-10	2016-04-10 00:00:00	32020		\N	32954	0	195662009	4112343		0
8657	505	372328	1972-04-27	1972-04-27 00:00:00	1973-05-15	1973-05-15 00:00:00	32020		\N	33792	0	65363002	372328		0
8809	515	40481087	1949-09-12	1949-09-12 00:00:00	1949-10-03	1949-10-03 00:00:00	32020		\N	34327	0	444814009	40481087		0
8977	525	81151	2000-09-17	2000-09-17 00:00:00	2000-10-08	2000-10-08 00:00:00	32020		\N	34962	0	44465007	81151		0
9143	539	372328	1933-07-24	1933-07-24 00:00:00	1933-09-03	1933-09-03 00:00:00	32020		\N	35788	0	65363002	372328		0
9307	549	4116491	1986-07-22	1986-07-22 00:00:00	1986-09-14	1986-09-14 00:00:00	32020		\N	36358	0	301011002	4116491		0
9488	563	28060	1969-08-15	1969-08-15 00:00:00	1969-08-22	1969-08-22 00:00:00	32020		\N	37195	0	43878008	28060		0
9640	571	4112343	2018-07-09	2018-07-09 00:00:00	2018-07-19	2018-07-19 00:00:00	32020		\N	37829	0	195662009	4112343		0
9805	579	81151	1998-12-06	1998-12-06 00:00:00	1999-01-03	1999-01-03 00:00:00	32020		\N	38338	0	44465007	81151		0
10033	596	40481087	1956-10-25	1956-10-25 00:00:00	1956-11-01	1956-11-01 00:00:00	32020		\N	39308	0	444814009	40481087		0
10137	600	378001	1962-07-23	1962-07-23 00:00:00	1962-08-22	1962-08-22 00:00:00	32020		\N	39645	0	62106007	378001		0
10304	608	317576	1999-07-21	1999-07-21 00:00:00	\N	\N	32020		\N	40356	0	53741008	317576		0
10469	615	40481087	2017-03-07	2017-03-07 00:00:00	2017-03-14	2017-03-14 00:00:00	32020		\N	40988	0	444814009	40481087		0
11	1	4156265	1982-09-11	1982-09-11 00:00:00	1982-10-02	1982-10-02 00:00:00	32020		\N	83	0	370247008	4156265		0
188	9	40486433	1983-07-26	1983-07-26 00:00:00	1997-07-24	1997-07-24 00:00:00	32020		\N	706	0	446096008	40486433		0
343	18	40481087	2004-08-16	2004-08-16 00:00:00	2004-09-06	2004-09-06 00:00:00	32020		\N	1416	0	444814009	40481087		0
509	30	78272	1972-07-05	1972-07-05 00:00:00	1972-07-26	1972-07-26 00:00:00	32020		\N	2123	0	70704007	78272		0
683	38	40481087	2018-01-09	2018-01-09 00:00:00	2018-01-23	2018-01-23 00:00:00	32020		\N	2710	0	444814009	40481087		0
900	49	260139	2010-04-20	2010-04-20 00:00:00	2010-05-04	2010-05-04 00:00:00	32020		\N	3534	0	10509002	260139		0
1031	61	4048171	1972-01-27	1972-01-27 00:00:00	\N	\N	32020		\N	4095	0	232353008	4048171		0
1177	69	375671	2013-07-17	2013-07-17 00:00:00	2013-08-16	2013-08-16 00:00:00	32020		\N	4711	0	62564004	375671		0
1339	79	372328	1947-10-17	1947-10-17 00:00:00	1948-04-01	1948-04-01 00:00:00	32020		\N	5352	0	65363002	372328		0
1527	90	4109685	1980-09-19	1980-09-19 00:00:00	1980-10-10	1980-10-10 00:00:00	32020		\N	5999	0	284551006	4109685		0
1671	97	4112343	1963-04-13	1963-04-13 00:00:00	1963-04-20	1963-04-20 00:00:00	32020		\N	6576	0	195662009	4112343		0
1837	105	4113008	1985-10-08	1985-10-08 00:00:00	1985-10-22	1985-10-22 00:00:00	32020		\N	7146	0	284549007	4113008		0
2003	116	260139	1952-11-22	1952-11-22 00:00:00	1952-12-06	1952-12-06 00:00:00	32020		\N	7656	0	10509002	260139		0
2185	126	40481087	1989-05-26	1989-05-26 00:00:00	1989-06-09	1989-06-09 00:00:00	32020		\N	8418	0	444814009	40481087		0
2335	137	40481087	2017-07-31	2017-07-31 00:00:00	2017-08-07	2017-08-07 00:00:00	32020		\N	9252	0	444814009	40481087		0
2525	148	260139	2008-09-09	2008-09-09 00:00:00	2008-09-23	2008-09-23 00:00:00	32020		\N	10019	0	10509002	260139		0
2667	156	4112343	2000-05-09	2000-05-09 00:00:00	2000-05-16	2000-05-16 00:00:00	32020		\N	10695	0	195662009	4112343		0
2833	163	4116491	2001-06-19	2001-06-19 00:00:00	2001-07-27	2001-07-27 00:00:00	32020		\N	11178	0	301011002	4116491		0
3007	176	4112343	1982-07-10	1982-07-10 00:00:00	1982-07-17	1982-07-17 00:00:00	32020		\N	11892	0	195662009	4112343		0
3165	186	133834	1972-06-26	1972-06-26 00:00:00	1989-04-24	1989-04-24 00:00:00	32020		\N	12612	0	24079001	133834		0
3331	191	40481087	1999-09-17	1999-09-17 00:00:00	1999-09-24	1999-09-24 00:00:00	32020		\N	13028	0	444814009	40481087		0
3497	199	4112343	1977-07-24	1977-07-24 00:00:00	1977-08-06	1977-08-06 00:00:00	32020		\N	13679	0	195662009	4112343		0
3674	211	40481087	1984-12-11	1984-12-11 00:00:00	1984-12-25	1984-12-25 00:00:00	32020		\N	14375	0	444814009	40481087		0
3830	222	4112343	1967-01-19	1967-01-19 00:00:00	1967-01-30	1967-01-30 00:00:00	32020		\N	14950	0	195662009	4112343		0
3998	232	4296205	1953-08-30	1953-08-30 00:00:00	1953-09-20	1953-09-20 00:00:00	32020		\N	15645	0	403191005	4296205		0
4185	244	40481087	1980-01-11	1980-01-11 00:00:00	1980-02-01	1980-02-01 00:00:00	32020		\N	16344	0	444814009	40481087		0
4327	249	4112343	1992-02-29	1992-02-29 00:00:00	1992-03-10	1992-03-10 00:00:00	32020		\N	16767	0	195662009	4112343		0
4494	263	4294548	1964-12-28	1964-12-28 00:00:00	1965-03-01	1965-03-01 00:00:00	32020		\N	17444	0	75498004	4294548		0
4668	273	40481087	2003-11-11	2003-11-11 00:00:00	2003-11-25	2003-11-25 00:00:00	32020		\N	18264	0	444814009	40481087		0
4831	285	192671	2006-08-16	2006-08-16 00:00:00	\N	\N	32020		\N	19002	0	K92.2	35208414		0
4997	295	40481087	1987-04-14	1987-04-14 00:00:00	1987-05-05	1987-05-05 00:00:00	32020		\N	19634	0	444814009	40481087		0
5164	304	260139	2018-05-26	2018-05-26 00:00:00	2018-06-09	2018-06-09 00:00:00	32020		\N	20255	0	10509002	260139		0
5342	316	80180	1962-09-12	1962-09-12 00:00:00	\N	\N	32020		\N	20909	0	396275006	80180		0
5524	326	372328	1973-03-17	1973-03-17 00:00:00	1973-05-07	1973-05-07 00:00:00	32020		\N	21555	0	65363002	372328		0
5666	334	40481087	1987-12-18	1987-12-18 00:00:00	1987-12-25	1987-12-25 00:00:00	32020		\N	22149	0	444814009	40481087		0
5822	341	40481087	2018-11-30	2018-11-30 00:00:00	2018-12-07	2018-12-07 00:00:00	32020		\N	22765	0	444814009	40481087		0
5989	351	4112343	1978-12-27	1978-12-27 00:00:00	1979-01-07	1979-01-07 00:00:00	32020		\N	23404	0	195662009	4112343		0
6154	362	28060	1991-10-30	1991-10-30 00:00:00	1991-11-12	1991-11-12 00:00:00	32020		\N	24024	0	43878008	28060		0
6320	371	260139	1968-08-30	1968-08-30 00:00:00	1968-09-13	1968-09-13 00:00:00	32020		\N	24671	0	10509002	260139		0
6511	384	80180	1996-05-11	1996-05-11 00:00:00	\N	\N	32020		\N	25285	0	396275006	80180		0
6652	393	4283893	2015-10-26	2015-10-26 00:00:00	2016-02-01	2016-02-01 00:00:00	32020		\N	25776	0	36971009	4283893		0
6826	403	4134304	1946-03-28	1946-03-28 00:00:00	1946-05-27	1946-05-27 00:00:00	32020		\N	26462	0	263102004	4134304		0
6984	410	4155034	1990-04-04	1990-04-04 00:00:00	1990-04-25	1990-04-25 00:00:00	32020		\N	27157	0	283371005	4155034		0
7150	419	40481087	1942-03-10	1942-03-10 00:00:00	1942-03-24	1942-03-24 00:00:00	32020		\N	27785	0	444814009	40481087		0
7316	430	4112343	1991-05-06	1991-05-06 00:00:00	1991-05-15	1991-05-15 00:00:00	32020		\N	28495	0	195662009	4112343		0
7482	440	81151	1975-11-28	1975-11-28 00:00:00	1975-12-26	1975-12-26 00:00:00	32020		\N	29169	0	44465007	81151		0
7656	449	440448	1968-10-27	1968-10-27 00:00:00	\N	\N	32020		\N	29986	0	74400008	440448		0
7825	457	4278672	2009-05-14	2009-05-14 00:00:00	2009-07-13	2009-07-13 00:00:00	32020		\N	30594	0	65966004	4278672		0
8003	469	260139	1955-07-02	1955-07-02 00:00:00	1955-07-09	1955-07-09 00:00:00	32020		\N	31309	0	10509002	260139		0
8169	479	260139	1949-02-17	1949-02-17 00:00:00	1949-03-03	1949-03-03 00:00:00	32020		\N	31875	0	10509002	260139		0
8312	484	4112343	2007-10-19	2007-10-19 00:00:00	2007-10-31	2007-10-31 00:00:00	32020		\N	32319	0	195662009	4112343		0
8478	492	4112343	1964-08-17	1964-08-17 00:00:00	1964-08-27	1964-08-27 00:00:00	32020		\N	32981	0	195662009	4112343		0
8658	505	439777	1995-05-29	1995-05-29 00:00:00	\N	\N	32020		\N	33760	0	271737000	439777		0
8810	515	40481087	1977-02-27	1977-02-27 00:00:00	1977-03-20	1977-03-20 00:00:00	32020		\N	34326	0	444814009	40481087		0
8978	525	4112343	1971-12-08	1971-12-08 00:00:00	1971-12-20	1971-12-20 00:00:00	32020		\N	35012	0	195662009	4112343		0
9144	539	4149245	1955-12-26	1955-12-26 00:00:00	1956-03-02	1956-03-02 00:00:00	32020		\N	35824	0	30832001	4149245		0
9308	549	40481087	2004-12-30	2004-12-30 00:00:00	2005-01-20	2005-01-20 00:00:00	32020		\N	36374	0	444814009	40481087		0
9489	563	40481087	1964-08-16	1964-08-16 00:00:00	1964-08-30	1964-08-30 00:00:00	32020		\N	37194	0	444814009	40481087		0
9641	571	260139	2005-08-03	2005-08-03 00:00:00	2005-08-10	2005-08-10 00:00:00	32020		\N	37844	0	10509002	260139		0
9806	579	80180	1999-08-30	1999-08-30 00:00:00	\N	\N	32020		\N	38338	0	396275006	80180		0
10034	596	40481087	1950-12-10	1950-12-10 00:00:00	1950-12-17	1950-12-17 00:00:00	32020		\N	39350	0	444814009	40481087		0
10138	601	4027663	2002-11-08	2002-11-08 00:00:00	\N	\N	32020		\N	39715	0	13200003	4027663		0
10305	608	4113008	2008-11-13	2008-11-13 00:00:00	2008-11-27	2008-11-27 00:00:00	32020		\N	40410	0	284549007	4113008		0
10470	616	4112343	2018-10-13	2018-10-13 00:00:00	2018-10-26	2018-10-26 00:00:00	32020		\N	41073	0	195662009	4112343		0
12	1	260139	1976-10-20	1976-10-20 00:00:00	1976-11-03	1976-11-03 00:00:00	32020		\N	1	0	10509002	260139		0
189	9	78272	1990-09-15	1990-09-15 00:00:00	1990-09-29	1990-09-29 00:00:00	32020		\N	761	0	70704007	78272		0
344	18	4116491	1997-11-09	1997-11-09 00:00:00	1998-01-09	1998-01-09 00:00:00	32020		\N	1395	0	301011002	4116491		0
510	30	378001	2000-03-22	2000-03-22 00:00:00	2000-04-21	2000-04-21 00:00:00	32020		\N	2076	0	62106007	378001		0
684	38	81151	1967-10-27	1967-10-27 00:00:00	1967-11-17	1967-11-17 00:00:00	32020		\N	2748	0	44465007	81151		0
901	49	4001336	2005-03-26	2005-03-26 00:00:00	2005-05-25	2005-05-25 00:00:00	32020		\N	3530	0	110030002	4001336		0
1032	61	4051466	1971-01-27	1971-01-27 00:00:00	1987-05-07	1987-05-07 00:00:00	32020		\N	4151	0	233678006	4051466		0
1178	69	4112343	1972-06-12	1972-06-12 00:00:00	1972-06-22	1972-06-22 00:00:00	32020		\N	4695	0	195662009	4112343		0
1340	79	4283893	1996-06-05	1996-06-05 00:00:00	1996-07-03	1996-07-03 00:00:00	32020		\N	5246	0	36971009	4283893		0
1528	90	4278672	1975-11-10	1975-11-10 00:00:00	1975-12-10	1975-12-10 00:00:00	32020		\N	5997	0	65966004	4278672		0
1672	97	40481087	1992-08-27	1992-08-27 00:00:00	1992-09-03	1992-09-03 00:00:00	32020		\N	6618	0	444814009	40481087		0
1838	105	80180	2003-07-17	2003-07-17 00:00:00	\N	\N	32020		\N	7110	0	396275006	80180		0
2004	116	40481087	1939-04-12	1939-04-12 00:00:00	1939-04-19	1939-04-19 00:00:00	32020		\N	7704	0	444814009	40481087		0
2186	126	4283893	1994-01-13	1994-01-13 00:00:00	1994-02-10	1994-02-10 00:00:00	32020		\N	8413	0	36971009	4283893		0
2336	137	4109685	2007-04-13	2007-04-13 00:00:00	2007-04-27	2007-04-27 00:00:00	32020		\N	9123	0	284551006	4109685		0
2526	148	40481087	1989-07-26	1989-07-26 00:00:00	1989-08-09	1989-08-09 00:00:00	32020		\N	10018	0	444814009	40481087		0
2668	156	4112343	1983-12-26	1983-12-26 00:00:00	1984-01-02	1984-01-02 00:00:00	32020		\N	10694	0	195662009	4112343		0
2834	163	4116491	2007-07-26	2007-07-26 00:00:00	2007-08-26	2007-08-26 00:00:00	32020		\N	11192	0	301011002	4116491		0
3008	176	4109685	1990-08-02	1990-08-02 00:00:00	1990-08-23	1990-08-23 00:00:00	32020		\N	11931	0	284551006	4109685		0
3166	186	378001	1998-04-03	1998-04-03 00:00:00	1998-05-04	1998-05-04 00:00:00	32020		\N	12651	0	62106007	378001		0
3332	191	4112343	1964-02-27	1964-02-27 00:00:00	1964-03-11	1964-03-11 00:00:00	32020		\N	13072	0	195662009	4112343		0
3498	199	4112343	1952-12-24	1952-12-24 00:00:00	1952-12-31	1952-12-31 00:00:00	32020		\N	13677	0	195662009	4112343		0
3675	211	80180	2009-02-13	2009-02-13 00:00:00	\N	\N	32020		\N	14402	0	396275006	80180		0
3831	222	4112343	1993-01-09	1993-01-09 00:00:00	1993-01-21	1993-01-21 00:00:00	32020		\N	14895	0	195662009	4112343		0
3999	232	260139	1977-04-14	1977-04-14 00:00:00	1977-04-28	1977-04-28 00:00:00	32020		\N	15635	0	10509002	260139		0
4186	244	81893	1965-02-11	1965-02-11 00:00:00	\N	\N	32020		\N	16283	0	64766004	81893		0
4328	249	4156265	2005-11-05	2005-11-05 00:00:00	2005-11-26	2005-11-26 00:00:00	32020		\N	16781	0	370247008	4156265		0
4495	263	4218389	1979-02-23	1979-02-23 00:00:00	1979-03-23	1979-03-23 00:00:00	32020		\N	17422	0	39848009	4218389		0
4669	273	80180	2011-09-25	2011-09-25 00:00:00	\N	\N	32020		\N	18233	0	396275006	80180		0
4832	285	375671	1979-06-07	1979-06-07 00:00:00	1979-08-06	1979-08-06 00:00:00	32020		\N	19034	0	62564004	375671		0
4998	295	4134304	1951-04-06	1951-04-06 00:00:00	1951-06-05	1951-06-05 00:00:00	32020		\N	19643	0	263102004	4134304		0
5165	304	81151	1968-10-01	1968-10-01 00:00:00	1968-11-05	1968-11-05 00:00:00	32020		\N	20211	0	44465007	81151		0
5343	316	28060	2019-03-13	2019-03-13 00:00:00	2019-03-24	2019-03-24 00:00:00	32020		\N	20965	0	43878008	28060		0
5525	326	81151	1995-06-20	1995-06-20 00:00:00	1995-07-11	1995-07-11 00:00:00	32020		\N	21529	0	44465007	81151		0
5667	334	260139	1970-04-21	1970-04-21 00:00:00	1970-05-05	1970-05-05 00:00:00	32020		\N	22123	0	10509002	260139		0
5823	341	40481087	2011-10-19	2011-10-19 00:00:00	2011-11-09	2011-11-09 00:00:00	32020		\N	22785	0	444814009	40481087		0
5990	351	260139	1985-02-28	1985-02-28 00:00:00	1985-03-14	1985-03-14 00:00:00	32020		\N	23411	0	10509002	260139		0
6155	362	40481087	1990-09-07	1990-09-07 00:00:00	1990-09-28	1990-09-28 00:00:00	32020		\N	24023	0	444814009	40481087		0
6321	371	4112343	1981-05-22	1981-05-22 00:00:00	1981-06-04	1981-06-04 00:00:00	32020		\N	24663	0	195662009	4112343		0
6512	384	4112343	1991-04-22	1991-04-22 00:00:00	1991-05-03	1991-05-03 00:00:00	32020		\N	25292	0	195662009	4112343		0
6653	393	4294548	1961-11-20	1961-11-20 00:00:00	1962-01-22	1962-01-22 00:00:00	32020		\N	25763	0	75498004	4294548		0
6827	403	372328	1924-02-29	1924-02-29 00:00:00	1924-08-04	1924-08-04 00:00:00	32020		\N	26411	0	65363002	372328		0
6985	410	80180	1986-12-16	1986-12-16 00:00:00	\N	\N	32020		\N	27241	0	396275006	80180		0
7157	421	80180	2001-04-28	2001-04-28 00:00:00	\N	\N	32020		\N	27874	0	396275006	80180		0
7317	430	260139	1954-10-11	1954-10-11 00:00:00	1954-10-18	1954-10-18 00:00:00	32020		\N	28431	0	10509002	260139		0
7483	440	40481087	2005-01-21	2005-01-21 00:00:00	2005-02-04	2005-02-04 00:00:00	32020		\N	29185	0	444814009	40481087		0
7657	449	40481087	1992-11-29	1992-11-29 00:00:00	1992-12-20	1992-12-20 00:00:00	32020		\N	29933	0	444814009	40481087		0
7826	457	260139	2007-03-10	2007-03-10 00:00:00	2007-03-17	2007-03-17 00:00:00	32020		\N	30604	0	10509002	260139		0
8004	469	375671	1960-12-18	1960-12-18 00:00:00	1961-01-17	1961-01-17 00:00:00	32020		\N	31363	0	62564004	375671		0
8170	479	4134304	2016-09-03	2016-09-03 00:00:00	2016-10-03	2016-10-03 00:00:00	32020		\N	31963	0	263102004	4134304		0
8313	484	4112343	1991-06-26	1991-06-26 00:00:00	1991-07-09	1991-07-09 00:00:00	32020		\N	32365	0	195662009	4112343		0
8479	492	28060	1961-03-23	1961-03-23 00:00:00	1961-04-02	1961-04-02 00:00:00	32020		\N	32937	0	43878008	28060		0
8659	505	4112343	1982-04-07	1982-04-07 00:00:00	1982-04-20	1982-04-20 00:00:00	32020		\N	33815	0	195662009	4112343		0
8811	515	40481087	2019-04-20	2019-04-20 00:00:00	2019-05-04	2019-05-04 00:00:00	32020		\N	34329	0	444814009	40481087		0
8979	525	4112343	1972-05-21	1972-05-21 00:00:00	1972-05-28	1972-05-28 00:00:00	32020		\N	34972	0	195662009	4112343		0
9145	539	40481087	1959-10-09	1959-10-09 00:00:00	1959-10-23	1959-10-23 00:00:00	32020		\N	35813	0	444814009	40481087		0
9309	549	40481087	2014-08-08	2014-08-08 00:00:00	2014-08-29	2014-08-29 00:00:00	32020		\N	36368	0	444814009	40481087		0
9490	563	28060	1974-10-28	1974-10-28 00:00:00	1974-11-05	1974-11-05 00:00:00	32020		\N	37293	0	43878008	28060		0
9642	571	40481087	2013-04-06	2013-04-06 00:00:00	2013-04-13	2013-04-13 00:00:00	32020		\N	37811	0	444814009	40481087		0
9807	579	4294548	1964-02-10	1964-02-10 00:00:00	1964-06-08	1964-06-08 00:00:00	32020		\N	38299	0	75498004	4294548		0
10035	596	40481087	1994-05-30	1994-05-30 00:00:00	1994-06-06	1994-06-06 00:00:00	32020		\N	39329	0	444814009	40481087		0
10139	601	81151	1985-06-05	1985-06-05 00:00:00	1985-06-19	1985-06-19 00:00:00	32020		\N	39684	0	44465007	81151		0
10306	608	372328	1975-04-13	1975-04-13 00:00:00	1975-05-28	1975-05-28 00:00:00	32020		\N	40384	0	65363002	372328		0
10471	616	372328	1961-06-21	1961-06-21 00:00:00	1961-12-09	1961-12-09 00:00:00	32020		\N	41127	0	65363002	372328		0
13	1	4278672	1958-03-11	1958-03-11 00:00:00	1958-06-09	1958-06-09 00:00:00	32020		\N	79	0	65966004	4278672		0
190	9	4156265	2008-06-10	2008-06-10 00:00:00	2008-06-24	2008-06-24 00:00:00	32020		\N	864	0	370247008	4156265		0
345	18	40481087	2000-03-27	2000-03-27 00:00:00	2000-04-03	2000-04-03 00:00:00	32020		\N	1407	0	444814009	40481087		0
511	30	133834	1971-01-19	1971-01-19 00:00:00	1988-03-21	1988-03-21 00:00:00	32020		\N	2126	0	24079001	133834		0
685	38	4112343	1967-10-01	1967-10-01 00:00:00	1967-10-11	1967-10-11 00:00:00	32020		\N	2722	0	195662009	4112343		0
902	49	4112343	1973-03-08	1973-03-08 00:00:00	1973-03-20	1973-03-20 00:00:00	32020		\N	3531	0	195662009	4112343		0
1033	61	28060	1977-12-03	1977-12-03 00:00:00	1977-12-12	1977-12-12 00:00:00	32020		\N	4121	0	43878008	28060		0
1179	69	4109685	1949-05-28	1949-05-28 00:00:00	1949-06-18	1949-06-18 00:00:00	32020		\N	4708	0	284551006	4109685		0
1341	79	80180	1988-12-05	1988-12-05 00:00:00	\N	\N	32020		\N	5306	0	396275006	80180		0
1529	90	4294548	1985-06-30	1985-06-30 00:00:00	1985-08-25	1985-08-25 00:00:00	32020		\N	5984	0	75498004	4294548		0
1673	97	78272	2002-07-08	2002-07-08 00:00:00	2002-07-29	2002-07-29 00:00:00	32020		\N	6648	0	70704007	78272		0
1839	105	40481087	1978-12-08	1978-12-08 00:00:00	1978-12-15	1978-12-15 00:00:00	32020		\N	7099	0	444814009	40481087		0
2005	117	4112343	2008-03-21	2008-03-21 00:00:00	2008-04-03	2008-04-03 00:00:00	32020		\N	7759	0	195662009	4112343		0
2187	126	40481087	1973-11-27	1973-11-27 00:00:00	1973-12-04	1973-12-04 00:00:00	32020		\N	8410	0	444814009	40481087		0
2337	137	372328	1972-08-23	1972-08-23 00:00:00	1972-09-06	1972-09-06 00:00:00	32020		\N	9232	0	65363002	372328		0
2527	148	78272	1995-06-02	1995-06-02 00:00:00	1995-07-07	1995-07-07 00:00:00	32020		\N	9982	0	70704007	78272		0
2669	156	40481087	2013-04-22	2013-04-22 00:00:00	2013-05-13	2013-05-13 00:00:00	32020		\N	10684	0	444814009	40481087		0
2835	163	81151	1973-03-23	1973-03-23 00:00:00	1973-04-06	1973-04-06 00:00:00	32020		\N	11238	0	44465007	81151		0
3009	176	28060	2003-12-19	2003-12-19 00:00:00	2003-12-28	2003-12-28 00:00:00	32020		\N	11906	0	43878008	28060		0
3167	186	4109685	2005-02-25	2005-02-25 00:00:00	2005-03-18	2005-03-18 00:00:00	32020		\N	12652	0	284551006	4109685		0
3333	191	40481087	1997-10-13	1997-10-13 00:00:00	1997-10-20	1997-10-20 00:00:00	32020		\N	13026	0	444814009	40481087		0
3499	199	4112343	2009-11-10	2009-11-10 00:00:00	2009-11-22	2009-11-22 00:00:00	32020		\N	13655	0	195662009	4112343		0
3676	211	4266809	2009-02-13	2009-02-13 00:00:00	\N	\N	32020		\N	14402	0	397881000	4266809		0
3832	222	40481087	1966-01-26	1966-01-26 00:00:00	1966-02-16	1966-02-16 00:00:00	32020		\N	14891	0	444814009	40481087		0
4000	232	28060	1945-10-29	1945-10-29 00:00:00	1945-11-10	1945-11-10 00:00:00	32020		\N	15538	0	43878008	28060		0
4187	244	40481087	1965-02-01	1965-02-01 00:00:00	1965-02-22	1965-02-22 00:00:00	32020		\N	16283	0	444814009	40481087		0
4329	250	260139	1995-01-25	1995-01-25 00:00:00	1995-02-08	1995-02-08 00:00:00	32020		\N	16804	0	10509002	260139		0
4496	263	40481087	1981-01-11	1981-01-11 00:00:00	1981-02-01	1981-02-01 00:00:00	32020		\N	17436	0	444814009	40481087		0
4670	273	372328	1981-05-15	1981-05-15 00:00:00	1981-08-30	1981-08-30 00:00:00	32020		\N	18297	0	65363002	372328		0
4833	285	4296204	2010-06-15	2010-06-15 00:00:00	2010-07-20	2010-07-20 00:00:00	32020		\N	19036	0	403190006	4296204		0
4999	295	40481087	1990-06-27	1990-06-27 00:00:00	1990-07-18	1990-07-18 00:00:00	32020		\N	19624	0	444814009	40481087		0
5166	304	4285898	1997-05-22	1997-05-22 00:00:00	\N	\N	32020		\N	20203	0	68496003	4285898		0
5344	316	257012	1934-04-19	1934-04-19 00:00:00	\N	\N	32020		\N	20954	0	40055000	257012		0
5526	327	375671	1995-06-21	1995-06-21 00:00:00	1995-08-20	1995-08-20 00:00:00	32020		\N	21620	0	62564004	375671		0
5668	334	4112343	1945-09-29	1945-09-29 00:00:00	1945-10-07	1945-10-07 00:00:00	32020		\N	22143	0	195662009	4112343		0
5824	341	40481087	1984-08-27	1984-08-27 00:00:00	1984-09-10	1984-09-10 00:00:00	32020		\N	22754	0	444814009	40481087		0
5991	352	260139	1991-09-11	1991-09-11 00:00:00	1991-09-18	1991-09-18 00:00:00	32020		\N	23437	0	10509002	260139		0
6156	362	81151	1989-10-06	1989-10-06 00:00:00	1989-11-03	1989-11-03 00:00:00	32020		\N	24052	0	44465007	81151		0
6322	371	192671	2008-05-27	2008-05-27 00:00:00	\N	\N	32020		\N	24680	0	K92.2	35208414		0
6513	384	4112343	1975-03-07	1975-03-07 00:00:00	1975-03-15	1975-03-15 00:00:00	32020		\N	25337	0	195662009	4112343		0
6654	393	4310024	1994-11-26	1994-11-26 00:00:00	\N	\N	32020		\N	25803	0	424802006	4310024		0
6828	403	81151	2018-01-30	2018-01-30 00:00:00	2018-02-13	2018-02-13 00:00:00	32020		\N	26467	0	44465007	81151		0
6986	410	40481087	1957-09-28	1957-09-28 00:00:00	1957-10-19	1957-10-19 00:00:00	32020		\N	27171	0	444814009	40481087		0
7158	421	4112343	1996-05-22	1996-05-22 00:00:00	1996-06-02	1996-06-02 00:00:00	32020		\N	27882	0	195662009	4112343		0
7318	430	28060	1965-05-23	1965-05-23 00:00:00	1965-06-05	1965-06-05 00:00:00	32020		\N	28457	0	43878008	28060		0
7484	440	40481087	1988-06-01	1988-06-01 00:00:00	1988-06-22	1988-06-22 00:00:00	32020		\N	29182	0	444814009	40481087		0
7659	449	40481087	1994-09-20	1994-09-20 00:00:00	1994-09-27	1994-09-27 00:00:00	32020		\N	29901	0	444814009	40481087		0
7827	457	4059173	1958-08-07	1958-08-07 00:00:00	1958-10-06	1958-10-06 00:00:00	32020		\N	30590	0	16114001	4059173		0
8005	469	40481087	1989-01-04	1989-01-04 00:00:00	1989-01-18	1989-01-18 00:00:00	32020		\N	31253	0	444814009	40481087		0
8171	479	4156265	1955-12-27	1955-12-27 00:00:00	1956-01-17	1956-01-17 00:00:00	32020		\N	31853	0	370247008	4156265		0
8314	484	4109685	2012-06-24	2012-06-24 00:00:00	2012-07-08	2012-07-08 00:00:00	32020		\N	32403	0	284551006	4109685		0
8480	492	260139	2016-03-31	2016-03-31 00:00:00	2016-04-14	2016-04-14 00:00:00	32020		\N	32954	0	10509002	260139		0
8660	505	4116491	1998-05-28	1998-05-28 00:00:00	1998-07-05	1998-07-05 00:00:00	32020		\N	33761	0	301011002	4116491		0
8812	515	40481087	2012-01-13	2012-01-13 00:00:00	2012-02-03	2012-02-03 00:00:00	32020		\N	34369	0	444814009	40481087		0
8980	525	40481087	2003-02-10	2003-02-10 00:00:00	2003-03-03	2003-03-03 00:00:00	32020		\N	35044	0	444814009	40481087		0
9146	539	260139	1957-03-08	1957-03-08 00:00:00	1957-03-15	1957-03-15 00:00:00	32020		\N	35770	0	10509002	260139		0
9310	549	257012	1954-08-30	1954-08-30 00:00:00	\N	\N	32020		\N	36349	0	40055000	257012		0
9491	563	4112343	2002-03-14	2002-03-14 00:00:00	2002-03-21	2002-03-21 00:00:00	32020		\N	37253	0	195662009	4112343		0
9643	571	80180	1992-01-03	1992-01-03 00:00:00	\N	\N	32020		\N	37806	0	396275006	80180		0
9808	579	28060	1973-09-23	1973-09-23 00:00:00	1973-10-05	1973-10-05 00:00:00	32020		\N	38290	0	43878008	28060		0
10036	596	4112343	1951-01-03	1951-01-03 00:00:00	1951-01-15	1951-01-15 00:00:00	32020		\N	39373	0	195662009	4112343		0
10140	601	260139	2017-03-10	2017-03-10 00:00:00	2017-03-24	2017-03-24 00:00:00	32020		\N	39695	0	10509002	260139		0
10307	609	260139	1975-12-01	1975-12-01 00:00:00	1975-12-15	1975-12-15 00:00:00	32020		\N	40414	0	10509002	260139		0
10472	616	4296204	1983-03-03	1983-03-03 00:00:00	1983-03-24	1983-03-24 00:00:00	32020		\N	41089	0	403190006	4296204		0
14	1	40481087	2000-10-31	2000-10-31 00:00:00	2000-11-07	2000-11-07 00:00:00	32020		\N	24	0	444814009	40481087		0
191	9	4112343	1982-05-01	1982-05-01 00:00:00	1982-05-09	1982-05-09 00:00:00	32020		\N	835	0	195662009	4112343		0
346	18	80180	2009-03-21	2009-03-21 00:00:00	\N	\N	32020		\N	1449	0	396275006	80180		0
512	30	40481087	2006-10-10	2006-10-10 00:00:00	2006-10-31	2006-10-31 00:00:00	32020		\N	2047	0	444814009	40481087		0
686	38	260139	1966-08-05	1966-08-05 00:00:00	1966-08-19	1966-08-19 00:00:00	32020		\N	2745	0	10509002	260139		0
903	49	4237458	1980-02-26	1980-02-26 00:00:00	1980-05-26	1980-05-26 00:00:00	32020		\N	3525	0	58150001	4237458		0
1034	61	78272	1988-10-12	1988-10-12 00:00:00	1988-11-09	1988-11-09 00:00:00	32020		\N	4162	0	70704007	78272		0
1180	69	40481087	1968-08-17	1968-08-17 00:00:00	1968-08-24	1968-08-24 00:00:00	32020		\N	4698	0	444814009	40481087		0
1342	79	40481087	1966-01-05	1966-01-05 00:00:00	1966-01-26	1966-01-26 00:00:00	32020		\N	5299	0	444814009	40481087		0
1530	90	260139	1987-06-06	1987-06-06 00:00:00	1987-06-20	1987-06-20 00:00:00	32020		\N	6049	0	10509002	260139		0
1674	97	4296204	2015-03-23	2015-03-23 00:00:00	2015-04-06	2015-04-06 00:00:00	32020		\N	6649	0	403190006	4296204		0
1841	105	4329847	2005-11-11	2005-11-11 00:00:00	\N	\N	32020		\N	7147	0	22298006	4329847		0
2006	117	4112343	2000-09-03	2000-09-03 00:00:00	2000-09-12	2000-09-12 00:00:00	32020		\N	7776	0	195662009	4112343		0
2188	126	372328	1950-04-06	1950-04-06 00:00:00	1950-06-26	1950-06-26 00:00:00	32020		\N	8415	0	65363002	372328		0
2338	137	4084167	1981-11-07	1981-11-07 00:00:00	1981-11-08	1981-11-08 00:00:00	32020		\N	9120	0	241929008	4084167		0
2528	148	4112343	2011-08-09	2011-08-09 00:00:00	2011-08-22	2011-08-22 00:00:00	32020		\N	10020	0	195662009	4112343		0
2670	156	40481087	2008-09-01	2008-09-01 00:00:00	2008-09-22	2008-09-22 00:00:00	32020		\N	10674	0	444814009	40481087		0
2836	163	260139	1975-07-12	1975-07-12 00:00:00	1975-07-26	1975-07-26 00:00:00	32020		\N	11224	0	10509002	260139		0
3010	176	40481087	1969-02-09	1969-02-09 00:00:00	1969-02-16	1969-02-16 00:00:00	32020		\N	11879	0	444814009	40481087		0
3168	186	40481087	2001-12-01	2001-12-01 00:00:00	2001-12-22	2001-12-22 00:00:00	32020		\N	12598	0	444814009	40481087		0
3334	191	378419	1997-10-14	1997-10-14 00:00:00	\N	\N	32020		\N	13026	0	26929004	378419		0
3500	199	260139	1951-01-12	1951-01-12 00:00:00	1951-01-19	1951-01-19 00:00:00	32020		\N	13637	0	10509002	260139		0
3677	211	4156265	2003-03-07	2003-03-07 00:00:00	2003-03-28	2003-03-28 00:00:00	32020		\N	14406	0	370247008	4156265		0
3833	222	4112343	1995-07-14	1995-07-14 00:00:00	1995-07-25	1995-07-25 00:00:00	32020		\N	14915	0	195662009	4112343		0
4001	232	40481087	1980-04-17	1980-04-17 00:00:00	1980-04-24	1980-04-24 00:00:00	32020		\N	15563	0	444814009	40481087		0
4188	244	80180	1966-06-06	1966-06-06 00:00:00	\N	\N	32020		\N	16283	0	396275006	80180		0
4330	250	372328	1980-10-26	1980-10-26 00:00:00	1981-02-04	1981-02-04 00:00:00	32020		\N	16817	0	65363002	372328		0
4497	263	4027663	1981-06-13	1981-06-13 00:00:00	\N	\N	32020		\N	17436	0	13200003	4027663		0
4671	273	260139	2003-01-08	2003-01-08 00:00:00	2003-01-22	2003-01-22 00:00:00	32020		\N	18296	0	10509002	260139		0
4834	285	81893	2005-02-05	2005-02-05 00:00:00	\N	\N	32020		\N	19031	0	64766004	81893		0
5000	295	4059173	2015-11-24	2015-11-24 00:00:00	2016-02-22	2016-02-22 00:00:00	32020		\N	19645	0	16114001	4059173		0
5167	304	4310024	1996-11-23	1996-11-23 00:00:00	\N	\N	32020		\N	20203	0	424802006	4310024		0
5345	316	40481087	1998-07-06	1998-07-06 00:00:00	1998-07-20	1998-07-20 00:00:00	32020		\N	20869	0	444814009	40481087		0
5527	327	4112343	1990-10-20	1990-10-20 00:00:00	1990-10-30	1990-10-30 00:00:00	32020		\N	21594	0	195662009	4112343		0
5669	334	4285898	1972-02-21	1972-02-21 00:00:00	\N	\N	32020		\N	22179	0	68496003	4285898		0
5825	341	40481087	1970-07-19	1970-07-19 00:00:00	1970-08-02	1970-08-02 00:00:00	32020		\N	22772	0	444814009	40481087		0
5992	352	372328	1980-11-13	1980-11-13 00:00:00	1980-12-22	1980-12-22 00:00:00	32020		\N	23451	0	65363002	372328		0
6157	362	28060	2009-10-09	2009-10-09 00:00:00	2009-10-22	2009-10-22 00:00:00	32020		\N	24019	0	43878008	28060		0
6323	371	260139	1991-12-10	1991-12-10 00:00:00	1991-12-24	1991-12-24 00:00:00	32020		\N	24673	0	10509002	260139		0
6514	384	40481087	1978-05-29	1978-05-29 00:00:00	1978-06-12	1978-06-12 00:00:00	32020		\N	25338	0	444814009	40481087		0
6655	393	260139	1976-08-01	1976-08-01 00:00:00	1976-08-15	1976-08-15 00:00:00	32020		\N	25762	0	10509002	260139		0
6829	403	372328	1922-07-27	1922-07-27 00:00:00	1922-11-06	1922-11-06 00:00:00	32020		\N	26516	0	65363002	372328		0
6987	410	4112343	2001-11-01	2001-11-01 00:00:00	2001-11-13	2001-11-13 00:00:00	32020		\N	27174	0	195662009	4112343		0
7159	421	40481087	1990-02-27	1990-02-27 00:00:00	1990-03-13	1990-03-13 00:00:00	32020		\N	27881	0	444814009	40481087		0
7319	430	80180	1972-10-27	1972-10-27 00:00:00	\N	\N	32020		\N	28433	0	396275006	80180		0
7485	440	80180	2009-02-17	2009-02-17 00:00:00	\N	\N	32020		\N	29179	0	396275006	80180		0
7660	449	260139	2001-02-19	2001-02-19 00:00:00	2001-02-26	2001-02-26 00:00:00	32020		\N	29918	0	10509002	260139		0
7828	457	80180	1986-03-28	1986-03-28 00:00:00	\N	\N	32020		\N	30582	0	396275006	80180		0
8006	469	40481087	2000-03-21	2000-03-21 00:00:00	2000-03-28	2000-03-28 00:00:00	32020		\N	31327	0	444814009	40481087		0
8172	479	260139	1984-08-09	1984-08-09 00:00:00	1984-08-23	1984-08-23 00:00:00	32020		\N	31936	0	10509002	260139		0
8315	484	78272	1953-08-12	1953-08-12 00:00:00	1953-09-02	1953-09-02 00:00:00	32020		\N	32400	0	70704007	78272		0
8490	495	4112343	1998-04-09	1998-04-09 00:00:00	1998-04-21	1998-04-21 00:00:00	32020		\N	33055	0	195662009	4112343		0
8661	505	80180	2001-11-13	2001-11-13 00:00:00	\N	\N	32020		\N	33842	0	396275006	80180		0
8813	515	257012	1958-07-31	1958-07-31 00:00:00	\N	\N	32020		\N	34322	0	40055000	257012		0
8981	525	40481087	1993-04-19	1993-04-19 00:00:00	1993-04-26	1993-04-26 00:00:00	32020		\N	35003	0	444814009	40481087		0
9147	539	4218389	1970-05-18	1970-05-18 00:00:00	1970-06-08	1970-06-08 00:00:00	32020		\N	35825	0	39848009	4218389		0
9311	549	195588	1989-09-13	1989-09-13 00:00:00	1989-10-26	1989-10-26 00:00:00	32020		\N	36364	0	38822007	195588		0
9492	563	80180	2003-01-18	2003-01-18 00:00:00	\N	\N	32020		\N	37253	0	396275006	80180		0
9644	571	260139	1980-05-17	1980-05-17 00:00:00	1980-05-31	1980-05-31 00:00:00	32020		\N	37773	0	10509002	260139		0
9809	580	40481087	1929-03-05	1929-03-05 00:00:00	1929-03-12	1929-03-12 00:00:00	32020		\N	38374	0	444814009	40481087		0
10037	596	40481087	1965-06-17	1965-06-17 00:00:00	1965-06-24	1965-06-24 00:00:00	32020		\N	39382	0	444814009	40481087		0
10141	601	372328	1972-08-02	1972-08-02 00:00:00	1972-10-22	1972-10-22 00:00:00	32020		\N	39743	0	65363002	372328		0
10308	609	40481087	2005-09-11	2005-09-11 00:00:00	2005-09-25	2005-09-25 00:00:00	32020		\N	40434	0	444814009	40481087		0
10473	616	28060	1977-08-11	1977-08-11 00:00:00	1977-08-23	1977-08-23 00:00:00	32020		\N	41112	0	43878008	28060		0
15	1	4112343	1991-01-31	1991-01-31 00:00:00	1991-02-10	1991-02-10 00:00:00	32020		\N	45	0	195662009	4112343		0
192	9	40481087	2013-10-10	2013-10-10 00:00:00	2013-10-24	2013-10-24 00:00:00	32020		\N	764	0	444814009	40481087		0
347	18	4112343	2012-11-15	2012-11-15 00:00:00	2012-11-27	2012-11-27 00:00:00	32020		\N	1396	0	195662009	4112343		0
513	30	80180	2009-03-23	2009-03-23 00:00:00	\N	\N	32020		\N	2047	0	396275006	80180		0
687	38	372328	1966-10-02	1966-10-02 00:00:00	1967-02-14	1967-02-14 00:00:00	32020		\N	2685	0	65363002	372328		0
904	49	80180	2009-06-13	2009-06-13 00:00:00	\N	\N	32020		\N	3548	0	396275006	80180		0
1035	61	4084167	1977-03-04	1977-03-04 00:00:00	1977-03-04	1977-03-04 00:00:00	32020		\N	4182	0	241929008	4084167		0
1181	69	40481087	1986-10-21	1986-10-21 00:00:00	1986-11-11	1986-11-11 00:00:00	32020		\N	4621	0	444814009	40481087		0
1343	79	372328	1949-08-25	1949-08-25 00:00:00	1949-09-29	1949-09-29 00:00:00	32020		\N	5287	0	65363002	372328		0
1531	90	81151	2009-06-10	2009-06-10 00:00:00	2009-06-24	2009-06-24 00:00:00	32020		\N	6000	0	44465007	81151		0
1675	97	195588	1966-09-06	1966-09-06 00:00:00	1966-10-11	1966-10-11 00:00:00	32020		\N	6586	0	38822007	195588		0
1864	110	40481087	1980-02-01	1980-02-01 00:00:00	1980-02-15	1980-02-15 00:00:00	32020		\N	7316	0	444814009	40481087		0
2007	117	4237458	1982-09-22	1982-09-22 00:00:00	1982-10-22	1982-10-22 00:00:00	32020		\N	7803	0	58150001	4237458		0
2189	126	28060	1952-08-16	1952-08-16 00:00:00	1952-08-25	1952-08-25 00:00:00	32020		\N	8408	0	43878008	28060		0
2339	137	4027663	1996-06-23	1996-06-23 00:00:00	\N	\N	32020		\N	9149	0	13200003	4027663		0
2529	149	4112343	2005-06-20	2005-06-20 00:00:00	2005-07-01	2005-07-01 00:00:00	32020		\N	10050	0	195662009	4112343		0
2671	156	40481087	2009-02-26	2009-02-26 00:00:00	2009-03-05	2009-03-05 00:00:00	32020		\N	10683	0	444814009	40481087		0
2837	163	4237458	1975-04-26	1975-04-26 00:00:00	1975-07-25	1975-07-25 00:00:00	32020		\N	11234	0	58150001	4237458		0
3011	176	4112343	1969-01-07	1969-01-07 00:00:00	1969-01-17	1969-01-17 00:00:00	32020		\N	11891	0	195662009	4112343		0
3169	186	40481087	2012-12-01	2012-12-01 00:00:00	2012-12-08	2012-12-08 00:00:00	32020		\N	12599	0	444814009	40481087		0
3335	191	40481087	1965-03-08	1965-03-08 00:00:00	1965-03-15	1965-03-15 00:00:00	32020		\N	13098	0	444814009	40481087		0
3501	199	4112343	1957-07-11	1957-07-11 00:00:00	1957-07-24	1957-07-24 00:00:00	32020		\N	13672	0	195662009	4112343		0
3678	211	40481087	1993-08-18	1993-08-18 00:00:00	1993-08-25	1993-08-25 00:00:00	32020		\N	14389	0	444814009	40481087		0
3834	222	4266809	1988-02-22	1988-02-22 00:00:00	\N	\N	32020		\N	14926	0	397881000	4266809		0
4002	232	81893	1980-11-17	1980-11-17 00:00:00	\N	\N	32020		\N	15563	0	64766004	81893		0
4189	244	4285898	1966-03-08	1966-03-08 00:00:00	\N	\N	32020		\N	16283	0	68496003	4285898		0
4331	250	4155034	1975-01-09	1975-01-09 00:00:00	1975-01-30	1975-01-30 00:00:00	32020		\N	16792	0	283371005	4155034		0
4498	263	372328	1957-06-04	1957-06-04 00:00:00	1957-11-24	1957-11-24 00:00:00	32020		\N	17480	0	65363002	372328		0
4672	273	40486433	1979-09-20	1979-09-20 00:00:00	\N	\N	32020		\N	18212	0	446096008	40486433		0
4835	285	80180	2006-07-30	2006-07-30 00:00:00	\N	\N	32020		\N	19031	0	396275006	80180		0
5001	295	30753	1992-03-26	1992-03-26 00:00:00	\N	\N	32020		\N	19584	0	16761005	30753		0
5168	304	30753	1997-04-22	1997-04-22 00:00:00	\N	\N	32020		\N	20203	0	16761005	30753		0
5346	316	260139	1963-06-01	1963-06-01 00:00:00	1963-06-15	1963-06-15 00:00:00	32020		\N	20956	0	10509002	260139		0
5528	327	40481087	2004-04-08	2004-04-08 00:00:00	2004-04-15	2004-04-15 00:00:00	32020		\N	21606	0	444814009	40481087		0
5670	334	40481087	1938-02-25	1938-02-25 00:00:00	1938-03-11	1938-03-11 00:00:00	32020		\N	22120	0	444814009	40481087		0
5826	341	4112343	1986-11-26	1986-11-26 00:00:00	1986-12-08	1986-12-08 00:00:00	32020		\N	22783	0	195662009	4112343		0
5993	352	260139	1981-09-26	1981-09-26 00:00:00	1981-10-10	1981-10-10 00:00:00	32020		\N	23436	0	10509002	260139		0
6158	363	4112343	2012-04-29	2012-04-29 00:00:00	2012-05-12	2012-05-12 00:00:00	32020		\N	24100	0	195662009	4112343		0
6324	371	4112343	1970-08-23	1970-08-23 00:00:00	1970-09-02	1970-09-02 00:00:00	32020		\N	24672	0	195662009	4112343		0
6515	384	4112343	2004-03-06	2004-03-06 00:00:00	2004-03-13	2004-03-13 00:00:00	32020		\N	25347	0	195662009	4112343		0
6656	393	192671	1997-10-01	1997-10-01 00:00:00	\N	\N	32020		\N	25772	0	K92.2	35208414		0
6830	403	4109685	2019-01-09	2019-01-09 00:00:00	2019-01-23	2019-01-23 00:00:00	32020		\N	26468	0	284551006	4109685		0
6988	410	260139	2010-09-26	2010-09-26 00:00:00	2010-10-10	2010-10-10 00:00:00	32020		\N	27219	0	10509002	260139		0
7160	421	192671	2001-07-24	2001-07-24 00:00:00	\N	\N	32020		\N	27844	0	K92.2	35208414		0
7320	430	40481087	1972-04-13	1972-04-13 00:00:00	1972-04-27	1972-04-27 00:00:00	32020		\N	28433	0	444814009	40481087		0
7486	440	40481087	1982-02-01	1982-02-01 00:00:00	1982-02-08	1982-02-08 00:00:00	32020		\N	29191	0	444814009	40481087		0
7661	449	372328	1976-03-03	1976-03-03 00:00:00	1977-03-10	1977-03-10 00:00:00	32020		\N	29953	0	65363002	372328		0
7829	457	257012	1958-08-12	1958-08-12 00:00:00	\N	\N	32020		\N	30532	0	40055000	257012		0
8007	469	4027663	1967-11-22	1967-11-22 00:00:00	\N	\N	32020		\N	31294	0	13200003	4027663		0
8173	479	40481087	1977-12-14	1977-12-14 00:00:00	1977-12-28	1977-12-28 00:00:00	32020		\N	31868	0	444814009	40481087		0
8316	484	40481087	1954-07-10	1954-07-10 00:00:00	1954-07-17	1954-07-17 00:00:00	32020		\N	32308	0	444814009	40481087		0
8491	495	40481087	1982-04-25	1982-04-25 00:00:00	1982-05-16	1982-05-16 00:00:00	32020		\N	33079	0	444814009	40481087		0
8662	505	4266809	2001-11-13	2001-11-13 00:00:00	\N	\N	32020		\N	33842	0	397881000	4266809		0
8814	515	40481087	1956-12-04	1956-12-04 00:00:00	1956-12-25	1956-12-25 00:00:00	32020		\N	34321	0	444814009	40481087		0
8982	525	372328	1950-03-30	1950-03-30 00:00:00	1950-06-12	1950-06-12 00:00:00	32020		\N	34975	0	65363002	372328		0
9148	539	192671	1969-01-18	1969-01-18 00:00:00	\N	\N	32020		\N	35793	0	K92.2	35208414		0
9312	549	4283893	1954-07-26	1954-07-26 00:00:00	1955-06-13	1955-06-13 00:00:00	32020		\N	36348	0	36971009	4283893		0
9493	563	440086	1973-04-10	1973-04-10 00:00:00	1982-04-18	1982-04-18 00:00:00	32020		\N	37292	0	192127007	440086		0
9645	571	4112343	2004-01-24	2004-01-24 00:00:00	2004-02-06	2004-02-06 00:00:00	32020		\N	37774	0	195662009	4112343		0
9810	580	4112343	2017-05-27	2017-05-27 00:00:00	2017-06-06	2017-06-06 00:00:00	32020		\N	38460	0	195662009	4112343		0
10038	596	255848	2005-06-13	2005-06-13 00:00:00	\N	\N	32020		\N	39389	0	233604007	255848		0
10142	601	30753	2009-07-29	2009-07-29 00:00:00	\N	\N	32020		\N	39687	0	16761005	30753		0
10309	609	260139	2018-03-07	2018-03-07 00:00:00	2018-03-15	2018-03-15 00:00:00	32020		\N	40451	0	10509002	260139		0
10474	616	40481087	1985-03-16	1985-03-16 00:00:00	1985-04-06	1985-04-06 00:00:00	32020		\N	41115	0	444814009	40481087		0
16	1	4112343	1975-10-12	1975-10-12 00:00:00	1975-10-19	1975-10-19 00:00:00	32020		\N	43	0	195662009	4112343		0
193	9	260139	1985-06-15	1985-06-15 00:00:00	1985-06-29	1985-06-29 00:00:00	32020		\N	723	0	10509002	260139		0
348	18	40481087	1973-09-25	1973-09-25 00:00:00	1973-10-09	1973-10-09 00:00:00	32020		\N	1414	0	444814009	40481087		0
514	30	4112343	1998-02-04	1998-02-04 00:00:00	1998-02-17	1998-02-17 00:00:00	32020		\N	2097	0	195662009	4112343		0
688	38	40481087	1993-03-10	1993-03-10 00:00:00	1993-03-17	1993-03-17 00:00:00	32020		\N	2726	0	444814009	40481087		0
905	49	260139	1978-03-10	1978-03-10 00:00:00	1978-03-24	1978-03-24 00:00:00	32020		\N	3540	0	10509002	260139		0
1036	61	4112343	2015-12-20	2015-12-20 00:00:00	2015-12-28	2015-12-28 00:00:00	32020		\N	4100	0	195662009	4112343		0
1182	69	40481087	1976-03-21	1976-03-21 00:00:00	1976-04-04	1976-04-04 00:00:00	32020		\N	4699	0	444814009	40481087		0
1344	79	4051466	1949-05-02	1949-05-02 00:00:00	1965-08-07	1965-08-07 00:00:00	32020		\N	5251	0	233678006	4051466		0
1532	90	40481087	1968-06-08	1968-06-08 00:00:00	1968-06-29	1968-06-29 00:00:00	32020		\N	5982	0	444814009	40481087		0
1676	97	4056621	1966-09-06	1966-09-06 00:00:00	\N	\N	32020		\N	6586	0	197927001	4056621		0
1865	110	40481087	2004-05-31	2004-05-31 00:00:00	2004-06-21	2004-06-21 00:00:00	32020		\N	7310	0	444814009	40481087		0
2008	117	260139	1974-07-08	1974-07-08 00:00:00	1974-07-15	1974-07-15 00:00:00	32020		\N	7757	0	10509002	260139		0
2190	126	40481087	1976-04-29	1976-04-29 00:00:00	1976-05-06	1976-05-06 00:00:00	32020		\N	8411	0	444814009	40481087		0
2340	137	4112343	1995-06-18	1995-06-18 00:00:00	1995-06-29	1995-06-29 00:00:00	32020		\N	9149	0	195662009	4112343		0
2530	149	4152936	1958-07-21	1958-07-21 00:00:00	1958-08-11	1958-08-11 00:00:00	32020		\N	10103	0	283385000	4152936		0
2672	156	378001	1988-03-03	1988-03-03 00:00:00	1988-04-02	1988-04-02 00:00:00	32020		\N	10697	0	62106007	378001		0
2838	163	4112343	1997-10-28	1997-10-28 00:00:00	1997-11-08	1997-11-08 00:00:00	32020		\N	11177	0	195662009	4112343		0
3012	176	40481087	1989-04-30	1989-04-30 00:00:00	1989-05-14	1989-05-14 00:00:00	32020		\N	11900	0	444814009	40481087		0
3170	186	4048171	1973-11-27	1973-11-27 00:00:00	\N	\N	32020		\N	12613	0	232353008	4048171		0
3336	192	260139	1973-10-21	1973-10-21 00:00:00	1973-10-28	1973-10-28 00:00:00	32020		\N	13205	0	10509002	260139		0
3502	199	40481087	1996-03-13	1996-03-13 00:00:00	1996-04-03	1996-04-03 00:00:00	32020		\N	13639	0	444814009	40481087		0
3679	211	40481087	2016-11-27	2016-11-27 00:00:00	2016-12-11	2016-12-11 00:00:00	32020		\N	14391	0	444814009	40481087		0
3835	222	4285898	1987-05-28	1987-05-28 00:00:00	\N	\N	32020		\N	14926	0	68496003	4285898		0
4003	232	372328	1948-11-10	1948-11-10 00:00:00	1949-10-12	1949-10-12 00:00:00	32020		\N	15567	0	65363002	372328		0
4190	244	30753	1965-11-08	1965-11-08 00:00:00	\N	\N	32020		\N	16283	0	16761005	30753		0
4332	250	372328	1975-12-05	1975-12-05 00:00:00	1976-01-21	1976-01-21 00:00:00	32020		\N	16784	0	65363002	372328		0
4499	263	4112343	1960-10-20	1960-10-20 00:00:00	1960-10-30	1960-10-30 00:00:00	32020		\N	17443	0	195662009	4112343		0
4673	273	4112343	2004-11-20	2004-11-20 00:00:00	2004-11-27	2004-11-27 00:00:00	32020		\N	18280	0	195662009	4112343		0
4836	285	372328	2009-08-28	2009-08-28 00:00:00	2010-05-31	2010-05-31 00:00:00	32020		\N	18985	0	65363002	372328		0
5002	295	81893	1991-10-28	1991-10-28 00:00:00	\N	\N	32020		\N	19584	0	64766004	81893		0
5169	304	40481087	1997-12-24	1997-12-24 00:00:00	1998-01-14	1998-01-14 00:00:00	32020		\N	20251	0	444814009	40481087		0
5347	316	260139	1932-12-04	1932-12-04 00:00:00	1932-12-18	1932-12-18 00:00:00	32020		\N	20953	0	10509002	260139		0
5529	327	4134304	1974-10-13	1974-10-13 00:00:00	1975-01-11	1975-01-11 00:00:00	32020		\N	21617	0	263102004	4134304		0
5671	334	378419	2010-07-14	2010-07-14 00:00:00	\N	\N	32020		\N	22169	0	26929004	378419		0
5827	341	378001	1997-09-16	1997-09-16 00:00:00	1997-10-16	1997-10-16 00:00:00	32020		\N	22743	0	62106007	378001		0
5994	352	260139	2007-04-18	2007-04-18 00:00:00	2007-04-25	2007-04-25 00:00:00	32020		\N	23443	0	10509002	260139		0
6159	363	372328	1968-08-15	1968-08-15 00:00:00	1969-06-17	1969-06-17 00:00:00	32020		\N	24101	0	65363002	372328		0
6325	371	28060	1982-04-02	1982-04-02 00:00:00	1982-04-09	1982-04-09 00:00:00	32020		\N	24664	0	43878008	28060		0
6516	384	4156265	1967-12-25	1967-12-25 00:00:00	1968-01-08	1968-01-08 00:00:00	32020		\N	25353	0	370247008	4156265		0
6657	393	4112343	1993-11-27	1993-11-27 00:00:00	1993-12-04	1993-12-04 00:00:00	32020		\N	25764	0	195662009	4112343		0
6831	403	260139	1992-11-09	1992-11-09 00:00:00	1992-11-23	1992-11-23 00:00:00	32020		\N	26499	0	10509002	260139		0
6989	410	40481087	1982-11-05	1982-11-05 00:00:00	1982-11-12	1982-11-12 00:00:00	32020		\N	27190	0	444814009	40481087		0
7161	421	4296204	1972-03-10	1972-03-10 00:00:00	1972-03-31	1972-03-31 00:00:00	32020		\N	27877	0	403190006	4296204		0
7321	430	4112343	1992-11-08	1992-11-08 00:00:00	1992-11-17	1992-11-17 00:00:00	32020		\N	28435	0	195662009	4112343		0
7487	440	4112343	1995-12-17	1995-12-17 00:00:00	1995-12-28	1995-12-28 00:00:00	32020		\N	29183	0	195662009	4112343		0
7662	449	134438	1984-10-29	1984-10-29 00:00:00	1986-01-27	1986-01-27 00:00:00	32020		\N	29903	0	40275004	134438		0
7830	457	4218389	1996-09-07	1996-09-07 00:00:00	1996-10-12	1996-10-12 00:00:00	32020		\N	30592	0	39848009	4218389		0
8008	469	313217	2013-09-28	2013-09-28 00:00:00	\N	\N	32020		\N	31312	0	49436004	313217		0
8174	479	80180	1979-12-01	1979-12-01 00:00:00	\N	\N	32020		\N	31868	0	396275006	80180		0
8317	484	4112343	1944-01-21	1944-01-21 00:00:00	1944-02-01	1944-02-01 00:00:00	32020		\N	32306	0	195662009	4112343		0
8492	495	40481087	2017-04-16	2017-04-16 00:00:00	2017-04-30	2017-04-30 00:00:00	32020		\N	33057	0	444814009	40481087		0
8663	505	4285898	2001-06-16	2001-06-16 00:00:00	\N	\N	32020		\N	33842	0	68496003	4285898		0
8815	515	372328	1943-04-25	1943-04-25 00:00:00	1943-08-28	1943-08-28 00:00:00	32020		\N	34336	0	65363002	372328		0
8983	525	28060	1952-12-18	1952-12-18 00:00:00	1952-12-31	1952-12-31 00:00:00	32020		\N	34965	0	43878008	28060		0
9149	539	260139	1972-12-15	1972-12-15 00:00:00	1972-12-22	1972-12-22 00:00:00	32020		\N	35772	0	10509002	260139		0
9313	549	81151	1962-07-08	1962-07-08 00:00:00	1962-07-29	1962-07-29 00:00:00	32020		\N	36422	0	44465007	81151		0
9494	563	4109685	1978-01-11	1978-01-11 00:00:00	1978-02-01	1978-02-01 00:00:00	32020		\N	37271	0	284551006	4109685		0
9646	571	40481087	2009-09-06	2009-09-06 00:00:00	2009-09-13	2009-09-13 00:00:00	32020		\N	37810	0	444814009	40481087		0
9811	580	81151	1946-02-07	1946-02-07 00:00:00	1946-02-28	1946-02-28 00:00:00	32020		\N	38401	0	44465007	81151		0
10039	596	40481087	1995-12-04	1995-12-04 00:00:00	1995-12-25	1995-12-25 00:00:00	32020		\N	39330	0	444814009	40481087		0
10143	601	78272	2008-12-13	2008-12-13 00:00:00	2009-01-03	2009-01-03 00:00:00	32020		\N	39687	0	70704007	78272		0
10310	609	40481087	1970-01-09	1970-01-09 00:00:00	1970-01-23	1970-01-23 00:00:00	32020		\N	40439	0	444814009	40481087		0
10475	616	260139	2003-07-12	2003-07-12 00:00:00	2003-07-26	2003-07-26 00:00:00	32020		\N	41071	0	10509002	260139		0
17	1	80180	1982-08-12	1982-08-12 00:00:00	\N	\N	32020		\N	85	0	396275006	80180		0
194	9	40481087	2016-07-19	2016-07-19 00:00:00	2016-08-02	2016-08-02 00:00:00	32020		\N	859	0	444814009	40481087		0
349	18	4278672	1998-10-07	1998-10-07 00:00:00	1999-01-05	1999-01-05 00:00:00	32020		\N	1379	0	65966004	4278672		0
515	30	40481087	1999-03-09	1999-03-09 00:00:00	1999-03-16	1999-03-16 00:00:00	32020		\N	2099	0	444814009	40481087		0
689	38	40481087	1965-08-17	1965-08-17 00:00:00	1965-09-07	1965-09-07 00:00:00	32020		\N	2721	0	444814009	40481087		0
906	49	260139	1979-12-21	1979-12-21 00:00:00	1980-01-04	1980-01-04 00:00:00	32020		\N	3514	0	10509002	260139		0
1037	61	4296204	1974-03-20	1974-03-20 00:00:00	1974-04-24	1974-04-24 00:00:00	32020		\N	4181	0	403190006	4296204		0
1183	69	40481087	1957-12-01	1957-12-01 00:00:00	1957-12-08	1957-12-08 00:00:00	32020		\N	4686	0	444814009	40481087		0
1345	79	4112343	2016-05-14	2016-05-14 00:00:00	2016-05-22	2016-05-22 00:00:00	32020		\N	5329	0	195662009	4112343		0
1533	90	28060	1963-02-13	1963-02-13 00:00:00	1963-02-20	1963-02-20 00:00:00	32020		\N	6016	0	43878008	28060		0
1677	97	257012	1982-02-02	1982-02-02 00:00:00	\N	\N	32020		\N	6616	0	40055000	257012		0
1866	110	4116491	1998-02-09	1998-02-09 00:00:00	1998-03-20	1998-03-20 00:00:00	32020		\N	7293	0	301011002	4116491		0
2009	117	40481087	1981-09-24	1981-09-24 00:00:00	1981-10-08	1981-10-08 00:00:00	32020		\N	7758	0	444814009	40481087		0
2191	126	4156265	2010-05-26	2010-05-26 00:00:00	2010-06-16	2010-06-16 00:00:00	32020		\N	8449	0	370247008	4156265		0
2341	137	40481087	1997-03-06	1997-03-06 00:00:00	1997-03-27	1997-03-27 00:00:00	32020		\N	9250	0	444814009	40481087		0
2531	149	260139	1947-01-21	1947-01-21 00:00:00	1947-01-28	1947-01-28 00:00:00	32020		\N	10070	0	10509002	260139		0
2673	156	40481087	2003-09-01	2003-09-01 00:00:00	2003-09-22	2003-09-22 00:00:00	32020		\N	10682	0	444814009	40481087		0
2839	163	40481087	1989-01-29	1989-01-29 00:00:00	1989-02-05	1989-02-05 00:00:00	32020		\N	11196	0	444814009	40481087		0
3013	176	260139	2013-07-21	2013-07-21 00:00:00	2013-07-28	2013-07-28 00:00:00	32020		\N	11907	0	10509002	260139		0
3171	186	372328	2009-07-05	2009-07-05 00:00:00	2010-12-12	2010-12-12 00:00:00	32020		\N	12600	0	65363002	372328		0
3337	192	4112343	1998-02-22	1998-02-22 00:00:00	1998-03-02	1998-03-02 00:00:00	32020		\N	13186	0	195662009	4112343		0
3503	199	4156265	1965-01-26	1965-01-26 00:00:00	1965-02-16	1965-02-16 00:00:00	32020		\N	13644	0	370247008	4156265		0
3680	211	260139	2006-11-25	2006-11-25 00:00:00	2006-12-09	2006-12-09 00:00:00	32020		\N	14354	0	10509002	260139		0
3836	222	80180	1988-02-22	1988-02-22 00:00:00	\N	\N	32020		\N	14926	0	396275006	80180		0
4004	232	4156265	1958-02-26	1958-02-26 00:00:00	1958-03-12	1958-03-12 00:00:00	32020		\N	15613	0	370247008	4156265		0
4191	244	4266809	1966-06-06	1966-06-06 00:00:00	\N	\N	32020		\N	16283	0	397881000	4266809		0
4333	250	40481087	1980-03-19	1980-03-19 00:00:00	1980-04-09	1980-04-09 00:00:00	32020		\N	16782	0	444814009	40481087		0
4500	263	40481087	1958-09-02	1958-09-02 00:00:00	1958-09-09	1958-09-09 00:00:00	32020		\N	17441	0	444814009	40481087		0
4674	273	40481087	2006-05-19	2006-05-19 00:00:00	2006-06-09	2006-06-09 00:00:00	32020		\N	18243	0	444814009	40481087		0
4837	285	4310024	2004-03-12	2004-03-12 00:00:00	\N	\N	32020		\N	19020	0	424802006	4310024		0
5003	295	40481087	1964-09-01	1964-09-01 00:00:00	1964-09-08	1964-09-08 00:00:00	32020		\N	19630	0	444814009	40481087		0
5170	304	4266809	1998-03-18	1998-03-18 00:00:00	\N	\N	32020		\N	20251	0	397881000	4266809		0
5348	316	4142905	2012-02-01	2012-02-01 00:00:00	2012-05-01	2012-05-01 00:00:00	32020		\N	20984	0	33737001	4142905		0
5530	327	40481087	2018-02-09	2018-02-09 00:00:00	2018-02-23	2018-02-23 00:00:00	32020		\N	21576	0	444814009	40481087		0
5672	334	40480160	2009-09-12	2009-09-12 00:00:00	2009-10-12	2009-10-12 00:00:00	32020		\N	22117	0	443165006	40480160		0
5833	343	4112343	1998-01-22	1998-01-22 00:00:00	1998-02-04	1998-02-04 00:00:00	32020		\N	22954	0	195662009	4112343		0
5995	352	4266809	2012-08-28	2012-08-28 00:00:00	\N	\N	32020		\N	23465	0	397881000	4266809		0
6160	363	78272	1965-08-01	1965-08-01 00:00:00	1965-09-05	1965-09-05 00:00:00	32020		\N	24068	0	70704007	78272		0
6326	371	4112343	2018-08-29	2018-08-29 00:00:00	2018-09-10	2018-09-10 00:00:00	32020		\N	24666	0	195662009	4112343		0
6517	384	260139	2014-04-18	2014-04-18 00:00:00	2014-05-02	2014-05-02 00:00:00	32020		\N	25349	0	10509002	260139		0
6658	393	40481087	2017-09-28	2017-09-28 00:00:00	2017-10-19	2017-10-19 00:00:00	32020		\N	25811	0	444814009	40481087		0
6832	403	260139	1929-02-11	1929-02-11 00:00:00	1929-02-18	1929-02-18 00:00:00	32020		\N	26538	0	10509002	260139		0
6990	410	78272	1950-08-27	1950-08-27 00:00:00	1950-10-01	1950-10-01 00:00:00	32020		\N	27155	0	70704007	78272		0
7162	421	40481087	1995-02-21	1995-02-21 00:00:00	1995-02-28	1995-02-28 00:00:00	32020		\N	27846	0	444814009	40481087		0
7322	430	4112343	2008-04-30	2008-04-30 00:00:00	2008-05-11	2008-05-11 00:00:00	32020		\N	28475	0	195662009	4112343		0
7488	440	378001	2009-08-29	2009-08-29 00:00:00	2009-10-28	2009-10-28 00:00:00	32020		\N	29170	0	62106007	378001		0
7663	449	4112343	1980-09-09	1980-09-09 00:00:00	1980-09-21	1980-09-21 00:00:00	32020		\N	29862	0	195662009	4112343		0
7831	457	40481087	1962-02-07	1962-02-07 00:00:00	1962-02-28	1962-02-28 00:00:00	32020		\N	30534	0	444814009	40481087		0
8009	469	40481087	1987-02-23	1987-02-23 00:00:00	1987-03-09	1987-03-09 00:00:00	32020		\N	31252	0	444814009	40481087		0
8175	479	4146173	1949-07-31	1949-07-31 00:00:00	1949-09-29	1949-09-29 00:00:00	32020		\N	31876	0	307731004	4146173		0
8318	484	260139	1958-03-21	1958-03-21 00:00:00	1958-04-04	1958-04-04 00:00:00	32020		\N	32307	0	10509002	260139		0
8493	495	40481087	1987-11-22	1987-11-22 00:00:00	1987-11-29	1987-11-29 00:00:00	32020		\N	33080	0	444814009	40481087		0
8664	505	81151	1996-10-22	1996-10-22 00:00:00	1996-11-05	1996-11-05 00:00:00	32020		\N	33783	0	44465007	81151		0
8843	518	40481087	2018-02-25	2018-02-25 00:00:00	2018-03-11	2018-03-11 00:00:00	32020		\N	34591	0	444814009	40481087		0
8984	525	4283893	1964-04-22	1964-04-22 00:00:00	1964-06-03	1964-06-03 00:00:00	32020		\N	35010	0	36971009	4283893		0
9150	539	372328	1934-06-30	1934-06-30 00:00:00	1934-09-02	1934-09-02 00:00:00	32020		\N	35789	0	65363002	372328		0
9314	550	40481087	1946-04-10	1946-04-10 00:00:00	1946-05-01	1946-05-01 00:00:00	32020		\N	36451	0	444814009	40481087		0
9495	563	40481087	1985-11-05	1985-11-05 00:00:00	1985-11-26	1985-11-26 00:00:00	32020		\N	37295	0	444814009	40481087		0
9647	571	4294548	2012-01-06	2012-01-06 00:00:00	2012-02-03	2012-02-03 00:00:00	32020		\N	37776	0	75498004	4294548		0
9812	580	80180	1962-07-16	1962-07-16 00:00:00	\N	\N	32020		\N	38419	0	396275006	80180		0
10040	596	28060	1952-07-09	1952-07-09 00:00:00	1952-07-20	1952-07-20 00:00:00	32020		\N	39374	0	43878008	28060		0
10144	601	4113008	1979-01-03	1979-01-03 00:00:00	1979-01-24	1979-01-24 00:00:00	32020		\N	39682	0	284549007	4113008		0
10311	609	4112343	1980-11-21	1980-11-21 00:00:00	1980-12-02	1980-12-02 00:00:00	32020		\N	40416	0	195662009	4112343		0
10476	616	28060	2006-06-24	2006-06-24 00:00:00	2006-07-04	2006-07-04 00:00:00	32020		\N	41120	0	43878008	28060		0
18	1	4285898	1981-12-15	1981-12-15 00:00:00	\N	\N	32020		\N	85	0	68496003	4285898		0
195	9	4113008	2012-12-21	2012-12-21 00:00:00	2013-01-11	2013-01-11 00:00:00	32020		\N	866	0	284549007	4113008		0
350	18	40481087	2006-12-04	2006-12-04 00:00:00	2006-12-11	2006-12-11 00:00:00	32020		\N	1390	0	444814009	40481087		0
516	30	4116491	1999-08-08	1999-08-08 00:00:00	1999-09-12	1999-09-12 00:00:00	32020		\N	2105	0	301011002	4116491		0
690	38	260139	2016-01-01	2016-01-01 00:00:00	2016-01-08	2016-01-08 00:00:00	32020		\N	2709	0	10509002	260139		0
907	49	4294548	2011-11-25	2011-11-25 00:00:00	2011-12-09	2011-12-09 00:00:00	32020		\N	3576	0	75498004	4294548		0
1038	61	81151	1983-12-03	1983-12-03 00:00:00	1984-01-07	1984-01-07 00:00:00	32020		\N	4160	0	44465007	81151		0
1184	69	260139	1975-02-28	1975-02-28 00:00:00	1975-03-14	1975-03-14 00:00:00	32020		\N	4687	0	10509002	260139		0
1346	79	4112343	1954-01-17	1954-01-17 00:00:00	1954-01-26	1954-01-26 00:00:00	32020		\N	5254	0	195662009	4112343		0
1534	90	40481087	2017-04-18	2017-04-18 00:00:00	2017-05-09	2017-05-09 00:00:00	32020		\N	6021	0	444814009	40481087		0
1678	97	40481087	1989-10-21	1989-10-21 00:00:00	1989-11-04	1989-11-04 00:00:00	32020		\N	6617	0	444814009	40481087		0
1867	110	4218389	2013-09-01	2013-09-01 00:00:00	2013-10-06	2013-10-06 00:00:00	32020		\N	7309	0	39848009	4218389		0
2010	117	260139	2002-03-21	2002-03-21 00:00:00	2002-03-28	2002-03-28 00:00:00	32020		\N	7806	0	10509002	260139		0
2192	126	40481087	1998-10-25	1998-10-25 00:00:00	1998-11-08	1998-11-08 00:00:00	32020		\N	8431	0	444814009	40481087		0
2342	137	4112343	1977-09-28	1977-09-28 00:00:00	1977-10-09	1977-10-09 00:00:00	32020		\N	9131	0	195662009	4112343		0
2532	149	260139	2011-09-15	2011-09-15 00:00:00	2011-09-29	2011-09-29 00:00:00	32020		\N	10051	0	10509002	260139		0
2674	156	81151	2013-08-19	2013-08-19 00:00:00	2013-09-02	2013-09-02 00:00:00	32020		\N	10698	0	44465007	81151		0
2840	163	4156265	1984-04-29	1984-04-29 00:00:00	1984-05-20	1984-05-20 00:00:00	32020		\N	11236	0	370247008	4156265		0
3014	176	80180	2003-03-06	2003-03-06 00:00:00	\N	\N	32020		\N	11924	0	396275006	80180		0
3172	186	80180	2010-07-05	2010-07-05 00:00:00	\N	\N	32020		\N	12600	0	396275006	80180		0
3338	192	40481087	1978-08-03	1978-08-03 00:00:00	1978-08-24	1978-08-24 00:00:00	32020		\N	13231	0	444814009	40481087		0
3504	199	28060	1993-08-14	1993-08-14 00:00:00	1993-08-24	1993-08-24 00:00:00	32020		\N	13647	0	43878008	28060		0
3681	211	81893	2007-01-25	2007-01-25 00:00:00	\N	\N	32020		\N	14370	0	64766004	81893		0
3837	222	30753	1987-04-28	1987-04-28 00:00:00	\N	\N	32020		\N	14926	0	16761005	30753		0
4005	232	40481087	1987-07-26	1987-07-26 00:00:00	1987-08-09	1987-08-09 00:00:00	32020		\N	15599	0	444814009	40481087		0
4192	244	4112343	1946-06-05	1946-06-05 00:00:00	1946-06-14	1946-06-14 00:00:00	32020		\N	16294	0	195662009	4112343		0
4334	250	4112343	1983-02-12	1983-02-12 00:00:00	1983-02-20	1983-02-20 00:00:00	32020		\N	16783	0	195662009	4112343		0
4501	263	4112343	1991-04-25	1991-04-25 00:00:00	1991-05-03	1991-05-03 00:00:00	32020		\N	17437	0	195662009	4112343		0
4675	273	260139	1980-11-17	1980-11-17 00:00:00	1980-11-24	1980-11-24 00:00:00	32020		\N	18194	0	10509002	260139		0
4838	285	4027663	1995-05-19	1995-05-19 00:00:00	\N	\N	32020		\N	18983	0	13200003	4027663		0
5004	295	28060	1959-09-04	1959-09-04 00:00:00	1959-09-13	1959-09-13 00:00:00	32020		\N	19621	0	43878008	28060		0
5171	304	80180	1998-03-18	1998-03-18 00:00:00	\N	\N	32020		\N	20251	0	396275006	80180		0
5349	316	40481087	1928-02-07	1928-02-07 00:00:00	1928-02-14	1928-02-14 00:00:00	32020		\N	20957	0	444814009	40481087		0
5531	327	4113008	2010-09-30	2010-09-30 00:00:00	2010-10-21	2010-10-21 00:00:00	32020		\N	21621	0	284549007	4113008		0
5673	334	4278672	2009-09-12	2009-09-12 00:00:00	2009-10-12	2009-10-12 00:00:00	32020		\N	22117	0	65966004	4278672		0
5834	343	4027663	1998-01-24	1998-01-24 00:00:00	\N	\N	32020		\N	22954	0	13200003	4027663		0
5996	352	4285898	2012-01-31	2012-01-31 00:00:00	\N	\N	32020		\N	23465	0	68496003	4285898		0
6161	363	40481087	1967-04-13	1967-04-13 00:00:00	1967-05-04	1967-05-04 00:00:00	32020		\N	24103	0	444814009	40481087		0
6327	371	80180	2008-05-11	2008-05-11 00:00:00	\N	\N	32020		\N	24691	0	396275006	80180		0
6518	384	40481087	1971-08-15	1971-08-15 00:00:00	1971-08-29	1971-08-29 00:00:00	32020		\N	25309	0	444814009	40481087		0
6659	393	260139	1967-01-28	1967-01-28 00:00:00	1967-02-11	1967-02-11 00:00:00	32020		\N	25761	0	10509002	260139		0
6833	403	4112343	1960-10-13	1960-10-13 00:00:00	1960-10-22	1960-10-22 00:00:00	32020		\N	26434	0	195662009	4112343		0
6991	410	260139	1999-10-03	1999-10-03 00:00:00	1999-10-17	1999-10-17 00:00:00	32020		\N	27194	0	10509002	260139		0
7163	421	4296204	1999-07-09	1999-07-09 00:00:00	1999-07-30	1999-07-30 00:00:00	32020		\N	27879	0	403190006	4296204		0
7323	430	40481087	1991-05-24	1991-05-24 00:00:00	1991-06-07	1991-06-07 00:00:00	32020		\N	28518	0	444814009	40481087		0
7489	440	372328	2006-01-06	2006-01-06 00:00:00	2006-03-29	2006-03-29 00:00:00	32020		\N	29205	0	65363002	372328		0
7664	450	4112343	2003-03-16	2003-03-16 00:00:00	2003-03-25	2003-03-25 00:00:00	32020		\N	30007	0	195662009	4112343		0
7832	457	4112343	1961-03-27	1961-03-27 00:00:00	1961-04-08	1961-04-08 00:00:00	32020		\N	30569	0	195662009	4112343		0
8010	469	4152936	1969-07-04	1969-07-04 00:00:00	1969-07-18	1969-07-18 00:00:00	32020		\N	31364	0	283385000	4152936		0
8176	479	40481087	1993-04-24	1993-04-24 00:00:00	1993-05-08	1993-05-08 00:00:00	32020		\N	31869	0	444814009	40481087		0
8319	484	4112343	2010-06-05	2010-06-05 00:00:00	2010-06-16	2010-06-16 00:00:00	32020		\N	32381	0	195662009	4112343		0
8494	495	4112343	1991-12-28	1991-12-28 00:00:00	1992-01-07	1992-01-07 00:00:00	32020		\N	33054	0	195662009	4112343		0
8665	505	40486433	1970-06-11	1970-06-11 00:00:00	\N	\N	32020		\N	33735	0	446096008	40486433		0
8844	518	372328	1974-10-02	1974-10-02 00:00:00	1975-06-10	1975-06-10 00:00:00	32020		\N	34616	0	65363002	372328		0
8985	525	260139	1994-09-07	1994-09-07 00:00:00	1994-09-14	1994-09-14 00:00:00	32020		\N	34967	0	10509002	260139		0
9151	539	40481087	1954-11-20	1954-11-20 00:00:00	1954-11-27	1954-11-27 00:00:00	32020		\N	35769	0	444814009	40481087		0
9315	550	260139	1963-09-30	1963-09-30 00:00:00	1963-10-07	1963-10-07 00:00:00	32020		\N	36454	0	10509002	260139		0
9496	563	4155034	1986-02-19	1986-02-19 00:00:00	1986-03-12	1986-03-12 00:00:00	32020		\N	37272	0	283371005	4155034		0
9648	571	40481087	1980-02-08	1980-02-08 00:00:00	1980-02-29	1980-02-29 00:00:00	32020		\N	37772	0	444814009	40481087		0
9813	580	4156265	2005-10-14	2005-10-14 00:00:00	2005-11-04	2005-11-04 00:00:00	32020		\N	38454	0	370247008	4156265		0
10041	596	4043241	2001-03-06	2001-03-06 00:00:00	\N	\N	32020		\N	39323	0	230265002	4043241		0
10145	601	378001	2007-10-20	2007-10-20 00:00:00	2007-12-19	2007-12-19 00:00:00	32020		\N	39686	0	62106007	378001		0
10312	609	4294548	1987-07-22	1987-07-22 00:00:00	1987-09-09	1987-09-09 00:00:00	32020		\N	40430	0	75498004	4294548		0
10478	616	4112343	2014-01-27	2014-01-27 00:00:00	2014-02-05	2014-02-05 00:00:00	32020		\N	41138	0	195662009	4112343		0
19	1	40481087	1996-08-25	1996-08-25 00:00:00	1996-09-15	1996-09-15 00:00:00	32020		\N	75	0	444814009	40481087		0
196	9	40481087	1987-07-09	1987-07-09 00:00:00	1987-07-30	1987-07-30 00:00:00	32020		\N	710	0	444814009	40481087		0
351	18	78272	1983-05-31	1983-05-31 00:00:00	1983-06-28	1983-06-28 00:00:00	32020		\N	1382	0	70704007	78272		0
517	30	4084167	1971-02-11	1971-02-11 00:00:00	1971-02-11	1971-02-11 00:00:00	32020		\N	2122	0	241929008	4084167		0
691	38	257012	2003-05-20	2003-05-20 00:00:00	\N	\N	32020		\N	2737	0	40055000	257012		0
908	49	4112343	2011-06-14	2011-06-14 00:00:00	2011-06-22	2011-06-22 00:00:00	32020		\N	3565	0	195662009	4112343		0
1039	61	4296204	2009-08-21	2009-08-21 00:00:00	2009-09-25	2009-09-25 00:00:00	32020		\N	4166	0	403190006	4296204		0
1185	69	40481087	2002-10-29	2002-10-29 00:00:00	2002-11-12	2002-11-12 00:00:00	32020		\N	4702	0	444814009	40481087		0
1347	79	40481087	1963-09-27	1963-09-27 00:00:00	1963-10-11	1963-10-11 00:00:00	32020		\N	5298	0	444814009	40481087		0
1535	90	4283893	1970-06-28	1970-06-28 00:00:00	1970-08-09	1970-08-09 00:00:00	32020		\N	5988	0	36971009	4283893		0
1679	97	258780	1980-07-28	1980-07-28 00:00:00	\N	\N	32020		\N	6606	0	185086009	258780		0
1868	110	4218389	2009-08-18	2009-08-18 00:00:00	2009-09-22	2009-09-22 00:00:00	32020		\N	7308	0	39848009	4218389		0
2011	117	372328	1979-09-08	1979-09-08 00:00:00	1980-08-16	1980-08-16 00:00:00	32020		\N	7781	0	65363002	372328		0
2193	126	378001	2000-06-17	2000-06-17 00:00:00	2000-07-17	2000-07-17 00:00:00	32020		\N	8448	0	62106007	378001		0
2343	137	4112343	2011-03-17	2011-03-17 00:00:00	2011-03-28	2011-03-28 00:00:00	32020		\N	9164	0	195662009	4112343		0
2533	149	40481087	1955-02-15	1955-02-15 00:00:00	1955-03-08	1955-03-08 00:00:00	32020		\N	10071	0	444814009	40481087		0
2675	156	260139	1982-07-05	1982-07-05 00:00:00	1982-07-12	1982-07-12 00:00:00	32020		\N	10653	0	10509002	260139		0
2841	163	260139	2006-09-02	2006-09-02 00:00:00	2006-09-16	2006-09-16 00:00:00	32020		\N	11214	0	10509002	260139		0
3015	176	40481087	1987-08-19	1987-08-19 00:00:00	1987-09-02	1987-09-02 00:00:00	32020		\N	11899	0	444814009	40481087		0
3173	186	4112343	2019-03-12	2019-03-12 00:00:00	2019-03-21	2019-03-21 00:00:00	32020		\N	12610	0	195662009	4112343		0
3339	192	4218389	1996-04-15	1996-04-15 00:00:00	1996-05-06	1996-05-06 00:00:00	32020		\N	13219	0	39848009	4218389		0
3505	199	4278672	2007-07-06	2007-07-06 00:00:00	2007-08-05	2007-08-05 00:00:00	32020		\N	13646	0	65966004	4278672		0
3682	211	4027663	2000-10-03	2000-10-03 00:00:00	\N	\N	32020		\N	14385	0	13200003	4027663		0
3838	222	40479422	2003-09-07	2003-09-07 00:00:00	2003-11-13	2003-11-13 00:00:00	32020		\N	14934	0	444448004	40479422		0
4006	232	40481087	2005-03-23	2005-03-23 00:00:00	2005-04-13	2005-04-13 00:00:00	32020		\N	15566	0	444814009	40481087		0
4193	244	40481087	1984-06-13	1984-06-13 00:00:00	1984-07-04	1984-07-04 00:00:00	32020		\N	16285	0	444814009	40481087		0
4335	250	80180	2008-12-26	2008-12-26 00:00:00	\N	\N	32020		\N	16801	0	396275006	80180		0
4502	263	40481087	1963-04-25	1963-04-25 00:00:00	1963-05-02	1963-05-02 00:00:00	32020		\N	17434	0	444814009	40481087		0
4676	273	40481087	1987-01-11	1987-01-11 00:00:00	1987-01-18	1987-01-18 00:00:00	32020		\N	18195	0	444814009	40481087		0
4839	285	28060	1971-08-20	1971-08-20 00:00:00	1971-09-01	1971-09-01 00:00:00	32020		\N	19003	0	43878008	28060		0
5005	295	4142905	2017-02-16	2017-02-16 00:00:00	2017-05-17	2017-05-17 00:00:00	32020		\N	19646	0	33737001	4142905		0
5172	304	4112343	1960-11-16	1960-11-16 00:00:00	1960-11-24	1960-11-24 00:00:00	32020		\N	20245	0	195662009	4112343		0
5350	316	4155034	1987-03-23	1987-03-23 00:00:00	1987-04-13	1987-04-13 00:00:00	32020		\N	20890	0	283371005	4155034		0
5532	327	80180	2010-12-03	2010-12-03 00:00:00	\N	\N	32020		\N	21621	0	396275006	80180		0
5674	334	28060	1940-02-13	1940-02-13 00:00:00	1940-02-25	1940-02-25 00:00:00	32020		\N	22141	0	43878008	28060		0
5835	343	40481087	1996-03-21	1996-03-21 00:00:00	1996-04-04	1996-04-04 00:00:00	32020		\N	22953	0	444814009	40481087		0
5997	352	80180	2012-08-28	2012-08-28 00:00:00	\N	\N	32020		\N	23465	0	396275006	80180		0
6162	363	260139	1977-05-01	1977-05-01 00:00:00	1977-05-15	1977-05-15 00:00:00	32020		\N	24097	0	10509002	260139		0
6328	371	195588	2000-01-24	2000-01-24 00:00:00	2000-03-06	2000-03-06 00:00:00	32020		\N	24665	0	38822007	195588		0
6519	384	195588	2013-05-17	2013-05-17 00:00:00	2013-07-04	2013-07-04 00:00:00	32020		\N	25293	0	38822007	195588		0
6660	393	40481087	2008-06-14	2008-06-14 00:00:00	2008-06-28	2008-06-28 00:00:00	32020		\N	25809	0	444814009	40481087		0
6834	403	28060	1932-12-16	1932-12-16 00:00:00	1932-12-28	1932-12-28 00:00:00	32020		\N	26431	0	43878008	28060		0
6992	410	4134304	2019-02-06	2019-02-06 00:00:00	2019-03-08	2019-03-08 00:00:00	32020		\N	27159	0	263102004	4134304		0
7164	421	40481087	2009-03-22	2009-03-22 00:00:00	2009-04-12	2009-04-12 00:00:00	32020		\N	27892	0	444814009	40481087		0
7324	430	260139	1940-11-30	1940-11-30 00:00:00	1940-12-14	1940-12-14 00:00:00	32020		\N	28515	0	10509002	260139		0
7490	440	40481087	2016-08-11	2016-08-11 00:00:00	2016-08-25	2016-08-25 00:00:00	32020		\N	29192	0	444814009	40481087		0
7665	450	81893	2002-12-21	2002-12-21 00:00:00	\N	\N	32020		\N	30035	0	64766004	81893		0
7833	457	40481087	2003-02-24	2003-02-24 00:00:00	2003-03-17	2003-03-17 00:00:00	32020		\N	30555	0	444814009	40481087		0
8011	469	372328	1937-04-04	1937-04-04 00:00:00	1937-05-08	1937-05-08 00:00:00	32020		\N	31255	0	65363002	372328		0
8177	479	40481087	2003-12-19	2003-12-19 00:00:00	2003-12-26	2003-12-26 00:00:00	32020		\N	31870	0	444814009	40481087		0
8320	484	4027663	1964-12-27	1964-12-27 00:00:00	\N	\N	32020		\N	32389	0	13200003	4027663		0
8495	495	4152936	2001-10-13	2001-10-13 00:00:00	2001-11-03	2001-11-03 00:00:00	32020		\N	33107	0	283385000	4152936		0
8666	505	372328	1983-10-20	1983-10-20 00:00:00	1984-05-01	1984-05-01 00:00:00	32020		\N	33740	0	65363002	372328		0
8845	518	40481087	1982-09-25	1982-09-25 00:00:00	1982-10-09	1982-10-09 00:00:00	32020		\N	34588	0	444814009	40481087		0
8986	525	28060	1997-04-03	1997-04-03 00:00:00	1997-04-13	1997-04-13 00:00:00	32020		\N	34968	0	43878008	28060		0
9152	539	80180	1968-12-02	1968-12-02 00:00:00	\N	\N	32020		\N	35805	0	396275006	80180		0
9316	550	80502	1980-03-26	1980-03-26 00:00:00	\N	\N	32020		\N	36459	0	64859006	80502		0
9497	563	4155034	1969-04-16	1969-04-16 00:00:00	1969-05-07	1969-05-07 00:00:00	32020		\N	37269	0	283371005	4155034		0
9649	571	40481087	1970-03-31	1970-03-31 00:00:00	1970-04-07	1970-04-07 00:00:00	32020		\N	37768	0	444814009	40481087		0
9814	580	4152936	1929-06-24	1929-06-24 00:00:00	1929-07-08	1929-07-08 00:00:00	32020		\N	38399	0	283385000	4152936		0
10042	596	4112343	1979-01-12	1979-01-12 00:00:00	1979-01-24	1979-01-24 00:00:00	32020		\N	39352	0	195662009	4112343		0
10146	601	4112343	1983-07-04	1983-07-04 00:00:00	1983-07-12	1983-07-12 00:00:00	32020		\N	39758	0	195662009	4112343		0
10313	609	4112343	1994-09-22	1994-09-22 00:00:00	1994-10-03	1994-10-03 00:00:00	32020		\N	40432	0	195662009	4112343		0
10479	616	81151	1969-07-09	1969-07-09 00:00:00	1969-08-13	1969-08-13 00:00:00	32020		\N	41087	0	44465007	81151		0
20	1	372328	1980-03-15	1980-03-15 00:00:00	1983-02-03	1983-02-03 00:00:00	32020		\N	3	0	65363002	372328		0
197	9	4112343	2003-10-23	2003-10-23 00:00:00	2003-11-04	2003-11-04 00:00:00	32020		\N	798	0	195662009	4112343		0
352	18	4112343	1991-08-01	1991-08-01 00:00:00	1991-08-10	1991-08-10 00:00:00	32020		\N	1387	0	195662009	4112343		0
518	30	40481087	2012-01-10	2012-01-10 00:00:00	2012-01-31	2012-01-31 00:00:00	32020		\N	2048	0	444814009	40481087		0
692	38	4112343	2005-06-06	2005-06-06 00:00:00	2005-06-14	2005-06-14 00:00:00	32020		\N	2720	0	195662009	4112343		0
909	49	40481087	1987-02-10	1987-02-10 00:00:00	1987-03-03	1987-03-03 00:00:00	32020		\N	3533	0	444814009	40481087		0
1040	61	80180	2005-08-29	2005-08-29 00:00:00	\N	\N	32020		\N	4136	0	396275006	80180		0
1186	69	260139	2000-11-15	2000-11-15 00:00:00	2000-11-22	2000-11-22 00:00:00	32020		\N	4701	0	10509002	260139		0
1348	79	4112343	1999-01-28	1999-01-28 00:00:00	1999-02-08	1999-02-08 00:00:00	32020		\N	5347	0	195662009	4112343		0
1536	90	40481087	1961-04-30	1961-04-30 00:00:00	1961-05-07	1961-05-07 00:00:00	32020		\N	5981	0	444814009	40481087		0
1680	97	4285898	1985-08-27	1985-08-27 00:00:00	\N	\N	32020		\N	6624	0	68496003	4285898		0
1869	110	372328	1979-08-28	1979-08-28 00:00:00	1980-01-20	1980-01-20 00:00:00	32020		\N	7296	0	65363002	372328		0
2012	117	4112343	2017-11-23	2017-11-23 00:00:00	2017-12-03	2017-12-03 00:00:00	32020		\N	7761	0	195662009	4112343		0
2194	126	372328	1951-04-24	1951-04-24 00:00:00	1951-06-25	1951-06-25 00:00:00	32020		\N	8416	0	65363002	372328		0
2344	137	40481087	1989-05-16	1989-05-16 00:00:00	1989-05-23	1989-05-23 00:00:00	32020		\N	9134	0	444814009	40481087		0
2534	149	80180	1982-10-23	1982-10-23 00:00:00	\N	\N	32020		\N	10074	0	396275006	80180		0
2676	156	80180	2019-01-30	2019-01-30 00:00:00	\N	\N	32020		\N	10692	0	396275006	80180		0
2842	163	40481087	1981-08-23	1981-08-23 00:00:00	1981-08-30	1981-08-30 00:00:00	32020		\N	11191	0	444814009	40481087		0
3016	176	4048695	1996-04-23	1996-04-23 00:00:00	1996-05-25	1996-05-25 00:00:00	32020		\N	11932	0	15724005	4048695		0
3174	186	4084167	1972-11-15	1972-11-15 00:00:00	1972-11-16	1972-11-16 00:00:00	32020		\N	12647	0	241929008	4084167		0
3340	192	40481087	1954-04-16	1954-04-16 00:00:00	1954-05-07	1954-05-07 00:00:00	32020		\N	13185	0	444814009	40481087		0
3506	199	4112343	1958-02-20	1958-02-20 00:00:00	1958-03-03	1958-03-03 00:00:00	32020		\N	13638	0	195662009	4112343		0
3683	211	4029498	1967-10-12	1967-10-12 00:00:00	\N	\N	32020		\N	14405	0	128613002	4029498		0
3839	222	4027663	1979-09-07	1979-09-07 00:00:00	\N	\N	32020		\N	14948	0	13200003	4027663		0
4007	232	28060	2007-11-11	2007-11-11 00:00:00	2007-11-20	2007-11-20 00:00:00	32020		\N	15601	0	43878008	28060		0
4194	244	40481087	1988-01-22	1988-01-22 00:00:00	1988-02-05	1988-02-05 00:00:00	32020		\N	16346	0	444814009	40481087		0
4336	250	260139	2002-08-13	2002-08-13 00:00:00	2002-08-27	2002-08-27 00:00:00	32020		\N	16805	0	10509002	260139		0
4503	264	372328	1954-08-10	1954-08-10 00:00:00	1954-12-31	1954-12-31 00:00:00	32020		\N	17515	0	65363002	372328		0
4677	273	28060	2002-07-25	2002-07-25 00:00:00	2002-08-02	2002-08-02 00:00:00	32020		\N	18295	0	43878008	28060		0
4840	285	40481087	2012-08-19	2012-08-19 00:00:00	2012-08-26	2012-08-26 00:00:00	32020		\N	18927	0	444814009	40481087		0
5006	295	80180	1993-06-19	1993-06-19 00:00:00	\N	\N	32020		\N	19602	0	396275006	80180		0
5173	304	81151	2004-03-22	2004-03-22 00:00:00	2004-04-19	2004-04-19 00:00:00	32020		\N	20256	0	44465007	81151		0
5351	316	260139	2016-03-26	2016-03-26 00:00:00	2016-04-02	2016-04-02 00:00:00	32020		\N	20866	0	10509002	260139		0
5533	327	81151	1985-11-05	1985-11-05 00:00:00	1985-12-10	1985-12-10 00:00:00	32020		\N	21619	0	44465007	81151		0
5675	334	81151	1937-07-24	1937-07-24 00:00:00	1937-08-28	1937-08-28 00:00:00	32020		\N	22112	0	44465007	81151		0
5836	343	4294548	1980-01-17	1980-01-17 00:00:00	1980-01-31	1980-01-31 00:00:00	32020		\N	22854	0	75498004	4294548		0
5998	352	4113008	2002-01-27	2002-01-27 00:00:00	2002-02-17	2002-02-17 00:00:00	32020		\N	23435	0	284549007	4113008		0
6163	363	4156265	2000-03-08	2000-03-08 00:00:00	2000-03-29	2000-03-29 00:00:00	32020		\N	24071	0	370247008	4156265		0
6329	371	40481087	1975-06-20	1975-06-20 00:00:00	1975-07-04	1975-07-04 00:00:00	32020		\N	24662	0	444814009	40481087		0
6520	384	372328	1961-08-23	1961-08-23 00:00:00	1961-11-06	1961-11-06 00:00:00	32020		\N	25294	0	65363002	372328		0
6661	393	375671	1974-06-09	1974-06-09 00:00:00	1974-08-08	1974-08-08 00:00:00	32020		\N	25771	0	62564004	375671		0
6835	403	40481087	2011-05-24	2011-05-24 00:00:00	2011-05-31	2011-05-31 00:00:00	32020		\N	26438	0	444814009	40481087		0
6993	410	40481087	1988-05-20	1988-05-20 00:00:00	1988-06-03	1988-06-03 00:00:00	32020		\N	27191	0	444814009	40481087		0
7165	421	40481087	1980-11-30	1980-11-30 00:00:00	1980-12-07	1980-12-07 00:00:00	32020		\N	27845	0	444814009	40481087		0
7325	430	40481087	1960-03-07	1960-03-07 00:00:00	1960-03-21	1960-03-21 00:00:00	32020		\N	28437	0	444814009	40481087		0
7491	440	40481087	2005-09-08	2005-09-08 00:00:00	2005-09-29	2005-09-29 00:00:00	32020		\N	29199	0	444814009	40481087		0
7666	450	4310024	2002-01-25	2002-01-25 00:00:00	\N	\N	32020		\N	30035	0	424802006	4310024		0
7834	457	372328	1969-08-09	1969-08-09 00:00:00	1970-03-31	1970-03-31 00:00:00	32020		\N	30535	0	65363002	372328		0
8012	469	4310024	1974-07-18	1974-07-18 00:00:00	\N	\N	32020		\N	31296	0	424802006	4310024		0
8178	479	260139	1944-02-29	1944-02-29 00:00:00	1944-03-14	1944-03-14 00:00:00	32020		\N	31904	0	10509002	260139		0
8321	484	257012	1962-12-19	1962-12-19 00:00:00	\N	\N	32020		\N	32309	0	40055000	257012		0
8496	495	28060	1979-01-18	1979-01-18 00:00:00	1979-01-25	1979-01-25 00:00:00	32020		\N	33063	0	43878008	28060		0
8667	505	4084167	1983-09-14	1983-09-14 00:00:00	1983-09-14	1983-09-14 00:00:00	32020		\N	33828	0	241929008	4084167		0
8846	518	4112343	1981-03-07	1981-03-07 00:00:00	1981-03-19	1981-03-19 00:00:00	32020		\N	34619	0	195662009	4112343		0
8987	525	40481087	2002-02-15	2002-02-15 00:00:00	2002-03-08	2002-03-08 00:00:00	32020		\N	35043	0	444814009	40481087		0
9153	539	372328	1935-08-28	1935-08-28 00:00:00	1936-03-01	1936-03-01 00:00:00	32020		\N	35790	0	65363002	372328		0
9317	550	378001	1956-10-26	1956-10-26 00:00:00	1956-11-25	1956-11-25 00:00:00	32020		\N	36447	0	62106007	378001		0
9498	563	40481087	1967-03-23	1967-03-23 00:00:00	1967-04-13	1967-04-13 00:00:00	32020		\N	37273	0	444814009	40481087		0
9650	571	40481087	1966-01-04	1966-01-04 00:00:00	1966-01-25	1966-01-25 00:00:00	32020		\N	37771	0	444814009	40481087		0
9815	580	81151	1930-06-03	1930-06-03 00:00:00	1930-07-01	1930-07-01 00:00:00	32020		\N	38400	0	44465007	81151		0
10043	596	4156265	1979-12-15	1979-12-15 00:00:00	1980-01-05	1980-01-05 00:00:00	32020		\N	39325	0	370247008	4156265		0
10147	601	4112343	1984-08-09	1984-08-09 00:00:00	1984-08-17	1984-08-17 00:00:00	32020		\N	39656	0	195662009	4112343		0
10314	609	28060	2010-01-03	2010-01-03 00:00:00	2010-01-11	2010-01-11 00:00:00	32020		\N	40458	0	43878008	28060		0
10480	616	80180	2000-12-08	2000-12-08 00:00:00	\N	\N	32020		\N	41137	0	396275006	80180		0
21	1	81893	1981-05-19	1981-05-19 00:00:00	\N	\N	32020		\N	3	0	64766004	81893		0
198	9	28060	1996-02-09	1996-02-09 00:00:00	1996-02-17	1996-02-17 00:00:00	32020		\N	846	0	43878008	28060		0
353	18	4112343	1969-10-31	1969-10-31 00:00:00	1969-11-08	1969-11-08 00:00:00	32020		\N	1386	0	195662009	4112343		0
533	32	260139	1944-06-24	1944-06-24 00:00:00	1944-07-01	1944-07-01 00:00:00	32020		\N	2260	0	10509002	260139		0
693	38	80180	2006-05-20	2006-05-20 00:00:00	\N	\N	32020		\N	2720	0	396275006	80180		0
910	49	40481087	1979-09-30	1979-09-30 00:00:00	1979-10-21	1979-10-21 00:00:00	32020		\N	3532	0	444814009	40481087		0
1054	63	4112343	1980-03-05	1980-03-05 00:00:00	1980-03-18	1980-03-18 00:00:00	32020		\N	4282	0	195662009	4112343		0
1187	69	4294548	1952-04-20	1952-04-20 00:00:00	1952-10-19	1952-10-19 00:00:00	32020		\N	4693	0	75498004	4294548		0
1349	79	40481087	1967-05-30	1967-05-30 00:00:00	1967-06-06	1967-06-06 00:00:00	32020		\N	5243	0	444814009	40481087		0
1537	90	40481087	1991-06-01	1991-06-01 00:00:00	1991-06-08	1991-06-08 00:00:00	32020		\N	6019	0	444814009	40481087		0
1681	97	80180	1986-03-25	1986-03-25 00:00:00	\N	\N	32020		\N	6624	0	396275006	80180		0
1870	110	40481087	2012-11-12	2012-11-12 00:00:00	2012-11-26	2012-11-26 00:00:00	32020		\N	7324	0	444814009	40481087		0
2013	117	260139	2015-01-21	2015-01-21 00:00:00	2015-01-28	2015-01-28 00:00:00	32020		\N	7778	0	10509002	260139		0
2195	126	4112343	1950-09-16	1950-09-16 00:00:00	1950-09-25	1950-09-25 00:00:00	32020		\N	8407	0	195662009	4112343		0
2345	137	4084167	1972-10-22	1972-10-22 00:00:00	1972-10-23	1972-10-23 00:00:00	32020		\N	9118	0	241929008	4084167		0
2535	149	4112343	1960-05-28	1960-05-28 00:00:00	1960-06-04	1960-06-04 00:00:00	32020		\N	10072	0	195662009	4112343		0
2677	156	260139	2005-06-23	2005-06-23 00:00:00	2005-06-30	2005-06-30 00:00:00	32020		\N	10673	0	10509002	260139		0
2843	163	372328	1968-04-18	1968-04-18 00:00:00	1968-06-04	1968-06-04 00:00:00	32020		\N	11180	0	65363002	372328		0
3017	177	4113008	2007-09-15	2007-09-15 00:00:00	2007-10-06	2007-10-06 00:00:00	32020		\N	11969	0	284549007	4113008		0
3175	186	260139	1995-06-21	1995-06-21 00:00:00	1995-06-28	1995-06-28 00:00:00	32020		\N	12627	0	10509002	260139		0
3341	192	4112343	2014-02-09	2014-02-09 00:00:00	2014-02-21	2014-02-21 00:00:00	32020		\N	13150	0	195662009	4112343		0
3507	199	260139	1954-01-27	1954-01-27 00:00:00	1954-02-10	1954-02-10 00:00:00	32020		\N	13678	0	10509002	260139		0
3685	211	40481087	1973-02-21	1973-02-21 00:00:00	1973-03-07	1973-03-07 00:00:00	32020		\N	14373	0	444814009	40481087		0
3840	222	40481087	1988-04-26	1988-04-26 00:00:00	1988-05-10	1988-05-10 00:00:00	32020		\N	14893	0	444814009	40481087		0
4008	232	40481087	1975-05-18	1975-05-18 00:00:00	1975-06-08	1975-06-08 00:00:00	32020		\N	15562	0	444814009	40481087		0
4195	244	4112343	1956-01-11	1956-01-11 00:00:00	1956-01-18	1956-01-18 00:00:00	32020		\N	16343	0	195662009	4112343		0
4337	250	40481087	2005-01-03	2005-01-03 00:00:00	2005-01-17	2005-01-17 00:00:00	32020		\N	16806	0	444814009	40481087		0
4504	264	80180	1984-04-04	1984-04-04 00:00:00	\N	\N	32020		\N	17547	0	396275006	80180		0
4678	273	81151	2019-02-25	2019-02-25 00:00:00	2019-04-01	2019-04-01 00:00:00	32020		\N	18325	0	44465007	81151		0
4841	285	4112343	1996-04-23	1996-04-23 00:00:00	1996-05-06	1996-05-06 00:00:00	32020		\N	19021	0	195662009	4112343		0
5007	295	40481087	1992-07-06	1992-07-06 00:00:00	1992-07-27	1992-07-27 00:00:00	32020		\N	19602	0	444814009	40481087		0
5174	304	4027663	1987-04-30	1987-04-30 00:00:00	\N	\N	32020		\N	20268	0	13200003	4027663		0
5352	316	4112343	1990-11-29	1990-11-29 00:00:00	1990-12-07	1990-12-07 00:00:00	32020		\N	20868	0	195662009	4112343		0
5534	327	40481087	1980-03-23	1980-03-23 00:00:00	1980-04-13	1980-04-13 00:00:00	32020		\N	21571	0	444814009	40481087		0
5676	334	4218389	1979-02-19	1979-02-19 00:00:00	1979-03-26	1979-03-26 00:00:00	32020		\N	22113	0	39848009	4218389		0
5837	343	4294548	1987-10-19	1987-10-19 00:00:00	1987-12-07	1987-12-07 00:00:00	32020		\N	22938	0	75498004	4294548		0
5999	352	78272	1988-08-17	1988-08-17 00:00:00	1988-09-07	1988-09-07 00:00:00	32020		\N	23434	0	70704007	78272		0
6164	363	80180	2001-01-09	2001-01-09 00:00:00	\N	\N	32020		\N	24071	0	396275006	80180		0
6330	371	40481087	1971-02-21	1971-02-21 00:00:00	1971-03-07	1971-03-07 00:00:00	32020		\N	24692	0	444814009	40481087		0
6521	384	40481087	1980-11-24	1980-11-24 00:00:00	1980-12-08	1980-12-08 00:00:00	32020		\N	25346	0	444814009	40481087		0
6662	393	40481087	2018-08-22	2018-08-22 00:00:00	2018-09-12	2018-09-12 00:00:00	32020		\N	25812	0	444814009	40481087		0
6836	403	4112343	1975-02-26	1975-02-26 00:00:00	1975-03-10	1975-03-10 00:00:00	32020		\N	26496	0	195662009	4112343		0
6994	410	4112343	1972-10-15	1972-10-15 00:00:00	1972-10-23	1972-10-23 00:00:00	32020		\N	27189	0	195662009	4112343		0
7166	421	4112343	1970-03-23	1970-03-23 00:00:00	1970-04-04	1970-04-04 00:00:00	32020		\N	27884	0	195662009	4112343		0
7326	431	260139	1992-05-11	1992-05-11 00:00:00	1992-05-18	1992-05-18 00:00:00	32020		\N	28622	0	10509002	260139		0
7492	440	372328	1974-06-06	1974-06-06 00:00:00	1974-11-20	1974-11-20 00:00:00	32020		\N	29200	0	65363002	372328		0
7667	450	81151	1983-08-14	1983-08-14 00:00:00	1983-09-11	1983-09-11 00:00:00	32020		\N	30054	0	44465007	81151		0
7835	457	4116491	2009-08-13	2009-08-13 00:00:00	2009-09-17	2009-09-17 00:00:00	32020		\N	30605	0	301011002	4116491		0
8013	469	40481087	1999-04-13	1999-04-13 00:00:00	1999-04-20	1999-04-20 00:00:00	32020		\N	31262	0	444814009	40481087		0
8179	479	260139	2009-06-18	2009-06-18 00:00:00	2009-07-02	2009-07-02 00:00:00	32020		\N	31937	0	10509002	260139		0
8322	484	4278672	1947-10-13	1947-10-13 00:00:00	1948-01-11	1948-01-11 00:00:00	32020		\N	32399	0	65966004	4278672		0
8497	495	40481087	1980-07-20	1980-07-20 00:00:00	1980-07-27	1980-07-27 00:00:00	32020		\N	33064	0	444814009	40481087		0
8668	505	28060	1979-05-10	1979-05-10 00:00:00	1979-05-20	1979-05-20 00:00:00	32020		\N	33736	0	43878008	28060		0
8847	518	372328	1973-01-27	1973-01-27 00:00:00	1973-06-05	1973-06-05 00:00:00	32020		\N	34620	0	65363002	372328		0
8988	525	198809	1952-05-22	1952-05-22 00:00:00	1952-05-22	1952-05-22 00:00:00	32020		\N	34958	0	65275009	198809		0
9154	539	4112343	1989-07-18	1989-07-18 00:00:00	1989-07-26	1989-07-26 00:00:00	32020		\N	35796	0	195662009	4112343		0
9318	550	4112343	1965-09-13	1965-09-13 00:00:00	1965-09-20	1965-09-20 00:00:00	32020		\N	36490	0	195662009	4112343		0
9499	563	40481087	1993-02-25	1993-02-25 00:00:00	1993-03-11	1993-03-11 00:00:00	32020		\N	37285	0	444814009	40481087		0
9651	571	4283893	1956-04-19	1956-04-19 00:00:00	1956-08-16	1956-08-16 00:00:00	32020		\N	37770	0	36971009	4283893		0
9816	580	40481087	2016-08-10	2016-08-10 00:00:00	2016-08-24	2016-08-24 00:00:00	32020		\N	38409	0	444814009	40481087		0
10044	596	40481087	1978-12-21	1978-12-21 00:00:00	1979-01-11	1979-01-11 00:00:00	32020		\N	39384	0	444814009	40481087		0
10148	601	40481087	1996-01-04	1996-01-04 00:00:00	1996-01-11	1996-01-11 00:00:00	32020		\N	39756	0	444814009	40481087		0
10315	609	4112343	1993-02-13	1993-02-13 00:00:00	1993-02-26	1993-02-26 00:00:00	32020		\N	40441	0	195662009	4112343		0
10481	616	40481087	1999-03-01	1999-03-01 00:00:00	1999-03-08	1999-03-08 00:00:00	32020		\N	41137	0	444814009	40481087		0
22	1	40481087	1967-05-30	1967-05-30 00:00:00	1967-06-20	1967-06-20 00:00:00	32020		\N	74	0	444814009	40481087		0
199	9	372328	1982-04-30	1982-04-30 00:00:00	1982-06-24	1982-06-24 00:00:00	32020		\N	711	0	65363002	372328		0
354	18	40481087	2011-10-24	2011-10-24 00:00:00	2011-11-07	2011-11-07 00:00:00	32020		\N	1417	0	444814009	40481087		0
534	32	260139	1966-02-08	1966-02-08 00:00:00	1966-02-22	1966-02-22 00:00:00	32020		\N	2243	0	10509002	260139		0
694	38	195588	2004-01-31	2004-01-31 00:00:00	2004-03-02	2004-03-02 00:00:00	32020		\N	2727	0	38822007	195588		0
911	49	81151	1982-04-16	1982-04-16 00:00:00	1982-05-14	1982-05-14 00:00:00	32020		\N	3526	0	44465007	81151		0
1055	63	40481087	1968-02-27	1968-02-27 00:00:00	1968-03-05	1968-03-05 00:00:00	32020		\N	4301	0	444814009	40481087		0
1188	69	4294548	1977-10-05	1977-10-05 00:00:00	1977-10-26	1977-10-26 00:00:00	32020		\N	4696	0	75498004	4294548		0
1350	79	40481087	1958-09-27	1958-09-27 00:00:00	1958-10-18	1958-10-18 00:00:00	32020		\N	5255	0	444814009	40481087		0
1538	90	40481087	1967-08-16	1967-08-16 00:00:00	1967-09-06	1967-09-06 00:00:00	32020		\N	6017	0	444814009	40481087		0
1682	97	4266809	1986-03-25	1986-03-25 00:00:00	\N	\N	32020		\N	6624	0	397881000	4266809		0
1871	110	28060	1984-04-06	1984-04-06 00:00:00	1984-04-17	1984-04-17 00:00:00	32020		\N	7317	0	43878008	28060		0
2014	117	40481087	1970-04-06	1970-04-06 00:00:00	1970-04-20	1970-04-20 00:00:00	32020		\N	7801	0	444814009	40481087		0
2196	126	372328	1950-11-23	1950-11-23 00:00:00	1950-12-25	1950-12-25 00:00:00	32020		\N	8420	0	65363002	372328		0
2346	137	4112343	2003-10-17	2003-10-17 00:00:00	2003-10-26	2003-10-26 00:00:00	32020		\N	9150	0	195662009	4112343		0
2536	149	28060	1971-07-10	1971-07-10 00:00:00	1971-07-17	1971-07-17 00:00:00	32020		\N	10048	0	43878008	28060		0
2678	156	4283893	1990-12-10	1990-12-10 00:00:00	1991-01-28	1991-01-28 00:00:00	32020		\N	10654	0	36971009	4283893		0
2844	163	4112343	1975-05-16	1975-05-16 00:00:00	1975-05-25	1975-05-25 00:00:00	32020		\N	11189	0	195662009	4112343		0
3018	177	40481087	1991-11-12	1991-11-12 00:00:00	1991-11-19	1991-11-19 00:00:00	32020		\N	11971	0	444814009	40481087		0
3176	186	195588	2012-11-10	2012-11-10 00:00:00	2012-12-29	2012-12-29 00:00:00	32020		\N	12599	0	38822007	195588		0
3342	192	4112343	1944-12-24	1944-12-24 00:00:00	1945-01-02	1945-01-02 00:00:00	32020		\N	13180	0	195662009	4112343		0
3508	199	378001	1999-10-16	1999-10-16 00:00:00	1999-12-15	1999-12-15 00:00:00	32020		\N	13645	0	62106007	378001		0
3686	211	372328	1973-02-12	1973-02-12 00:00:00	1973-08-23	1973-08-23 00:00:00	32020		\N	14355	0	65363002	372328		0
3841	222	372328	1954-11-16	1954-11-16 00:00:00	1955-02-18	1955-02-18 00:00:00	32020		\N	14939	0	65363002	372328		0
4009	232	4059173	1983-05-07	1983-05-07 00:00:00	1983-07-06	1983-07-06 00:00:00	32020		\N	15617	0	16114001	4059173		0
4196	244	4112343	1995-09-17	1995-09-17 00:00:00	1995-09-24	1995-09-24 00:00:00	32020		\N	16287	0	195662009	4112343		0
4338	250	4112343	1977-03-02	1977-03-02 00:00:00	1977-03-14	1977-03-14 00:00:00	32020		\N	16797	0	195662009	4112343		0
4505	264	4156265	1975-10-15	1975-10-15 00:00:00	1975-11-05	1975-11-05 00:00:00	32020		\N	17536	0	370247008	4156265		0
4679	273	4084167	1981-04-15	1981-04-15 00:00:00	1981-04-15	1981-04-15 00:00:00	32020		\N	18286	0	241929008	4084167		0
4842	285	260139	1984-11-09	1984-11-09 00:00:00	1984-11-23	1984-11-23 00:00:00	32020		\N	18918	0	10509002	260139		0
5008	295	28060	1951-12-03	1951-12-03 00:00:00	1951-12-13	1951-12-13 00:00:00	32020		\N	19628	0	43878008	28060		0
5175	304	4112343	2009-11-04	2009-11-04 00:00:00	2009-11-13	2009-11-13 00:00:00	32020		\N	20258	0	195662009	4112343		0
5353	316	78272	1929-03-24	1929-03-24 00:00:00	1929-04-28	1929-04-28 00:00:00	32020		\N	20887	0	70704007	78272		0
5535	327	260139	1976-04-07	1976-04-07 00:00:00	1976-04-21	1976-04-21 00:00:00	32020		\N	21570	0	10509002	260139		0
5677	334	40481087	1985-07-18	1985-07-18 00:00:00	1985-07-25	1985-07-25 00:00:00	32020		\N	22129	0	444814009	40481087		0
5838	343	4142905	1987-06-01	1987-06-01 00:00:00	1987-08-30	1987-08-30 00:00:00	32020		\N	22850	0	33737001	4142905		0
6000	352	372328	1988-12-04	1988-12-04 00:00:00	1989-08-07	1989-08-07 00:00:00	32020		\N	23452	0	65363002	372328		0
6165	363	4218389	1990-08-25	1990-08-25 00:00:00	1990-09-22	1990-09-22 00:00:00	32020		\N	24069	0	39848009	4218389		0
6331	371	28060	1980-04-13	1980-04-13 00:00:00	1980-04-23	1980-04-23 00:00:00	32020		\N	24693	0	43878008	28060		0
6522	384	40481087	1965-06-02	1965-06-02 00:00:00	1965-06-09	1965-06-09 00:00:00	32020		\N	25307	0	444814009	40481087		0
6663	393	40481087	1958-08-08	1958-08-08 00:00:00	1958-08-29	1958-08-29 00:00:00	32020		\N	25799	0	444814009	40481087		0
6837	403	4112343	1940-05-18	1940-05-18 00:00:00	1940-05-30	1940-05-30 00:00:00	32020		\N	26491	0	195662009	4112343		0
6996	410	4112343	1975-09-12	1975-09-12 00:00:00	1975-09-23	1975-09-23 00:00:00	32020		\N	27172	0	195662009	4112343		0
7167	421	4059173	1977-09-02	1977-09-02 00:00:00	1977-10-02	1977-10-02 00:00:00	32020		\N	27878	0	16114001	4059173		0
7327	431	4112343	1960-09-09	1960-09-09 00:00:00	1960-09-19	1960-09-19 00:00:00	32020		\N	28552	0	195662009	4112343		0
7493	440	40481087	1983-03-14	1983-03-14 00:00:00	1983-03-21	1983-03-21 00:00:00	32020		\N	29171	0	444814009	40481087		0
7668	450	260139	2008-10-15	2008-10-15 00:00:00	2008-10-22	2008-10-22 00:00:00	32020		\N	30008	0	10509002	260139		0
7836	457	40479422	1998-07-04	1998-07-04 00:00:00	1998-08-10	1998-08-10 00:00:00	32020		\N	30593	0	444448004	40479422		0
8014	469	260139	2010-08-28	2010-08-28 00:00:00	2010-09-11	2010-09-11 00:00:00	32020		\N	31254	0	10509002	260139		0
8180	479	440086	1952-10-18	1952-10-18 00:00:00	1957-10-27	1957-10-27 00:00:00	32020		\N	31916	0	192127007	440086		0
8333	486	4283893	1975-02-24	1975-02-24 00:00:00	1975-05-19	1975-05-19 00:00:00	32020		\N	32457	0	36971009	4283893		0
8498	495	4283893	1988-11-02	1988-11-02 00:00:00	1989-03-01	1989-03-01 00:00:00	32020		\N	33073	0	36971009	4283893		0
8669	505	260139	2013-11-06	2013-11-06 00:00:00	2013-11-20	2013-11-20 00:00:00	32020		\N	33791	0	10509002	260139		0
8848	518	372328	1974-04-01	1974-04-01 00:00:00	1974-06-04	1974-06-04 00:00:00	32020		\N	34601	0	65363002	372328		0
8989	525	196456	1952-05-22	1952-05-22 00:00:00	1952-05-22	1952-05-22 00:00:00	32020		\N	34958	0	235919008	196456		0
9155	539	4329847	1999-07-25	1999-07-25 00:00:00	\N	\N	32020		\N	35858	0	22298006	4329847		0
9319	550	40481087	1969-07-30	1969-07-30 00:00:00	1969-08-20	1969-08-20 00:00:00	32020		\N	36455	0	444814009	40481087		0
9500	563	40481087	1980-05-16	1980-05-16 00:00:00	1980-05-30	1980-05-30 00:00:00	32020		\N	37294	0	444814009	40481087		0
9652	571	4112343	1958-04-14	1958-04-14 00:00:00	1958-04-24	1958-04-24 00:00:00	32020		\N	37825	0	195662009	4112343		0
9817	580	40481087	1996-11-10	1996-11-10 00:00:00	1996-11-17	1996-11-17 00:00:00	32020		\N	38408	0	444814009	40481087		0
10045	596	372328	1950-10-18	1950-10-18 00:00:00	1951-01-23	1951-01-23 00:00:00	32020		\N	39311	0	65363002	372328		0
10149	601	28060	2007-06-21	2007-06-21 00:00:00	2007-07-04	2007-07-04 00:00:00	32020		\N	39742	0	43878008	28060		0
10316	609	4027663	1993-12-05	1993-12-05 00:00:00	\N	\N	32020		\N	40441	0	13200003	4027663		0
10482	616	40481087	2010-08-12	2010-08-12 00:00:00	2010-08-26	2010-08-26 00:00:00	32020		\N	41117	0	444814009	40481087		0
23	1	40481087	2018-01-04	2018-01-04 00:00:00	2018-01-11	2018-01-11 00:00:00	32020		\N	2	0	444814009	40481087		0
200	9	40481087	1980-11-14	1980-11-14 00:00:00	1980-11-21	1980-11-21 00:00:00	32020		\N	722	0	444814009	40481087		0
355	18	40481087	2012-03-14	2012-03-14 00:00:00	2012-04-04	2012-04-04 00:00:00	32020		\N	1408	0	444814009	40481087		0
535	32	40481087	1979-12-05	1979-12-05 00:00:00	1979-12-12	1979-12-12 00:00:00	32020		\N	2258	0	444814009	40481087		0
695	38	81893	2005-01-25	2005-01-25 00:00:00	\N	\N	32020		\N	2727	0	64766004	81893		0
912	49	4296205	1992-12-15	1992-12-15 00:00:00	1992-12-29	1992-12-29 00:00:00	32020		\N	3528	0	403191005	4296205		0
1056	63	260139	1995-11-01	1995-11-01 00:00:00	1995-11-15	1995-11-15 00:00:00	32020		\N	4283	0	10509002	260139		0
1189	69	40481087	2004-09-28	2004-09-28 00:00:00	2004-10-12	2004-10-12 00:00:00	32020		\N	4622	0	444814009	40481087		0
1351	79	4156265	1967-07-05	1967-07-05 00:00:00	1967-07-19	1967-07-19 00:00:00	32020		\N	5263	0	370247008	4156265		0
1586	94	4112343	1972-01-19	1972-01-19 00:00:00	1972-01-28	1972-01-28 00:00:00	32020		\N	6343	0	195662009	4112343		0
1683	97	4112343	1945-07-22	1945-07-22 00:00:00	1945-08-01	1945-08-01 00:00:00	32020		\N	6650	0	195662009	4112343		0
1872	110	4112343	2012-12-17	2012-12-17 00:00:00	2012-12-25	2012-12-25 00:00:00	32020		\N	7325	0	195662009	4112343		0
2015	117	4112343	2016-09-16	2016-09-16 00:00:00	2016-09-26	2016-09-26 00:00:00	32020		\N	7786	0	195662009	4112343		0
2197	126	40481087	1961-07-28	1961-07-28 00:00:00	1961-08-11	1961-08-11 00:00:00	32020		\N	8409	0	444814009	40481087		0
2347	137	81893	2004-03-18	2004-03-18 00:00:00	\N	\N	32020		\N	9150	0	64766004	81893		0
2537	149	260139	1960-02-21	1960-02-21 00:00:00	1960-03-06	1960-03-06 00:00:00	32020		\N	10029	0	10509002	260139		0
2679	156	372328	1980-02-14	1980-02-14 00:00:00	1980-03-30	1980-03-30 00:00:00	32020		\N	10675	0	65363002	372328		0
2845	163	372328	1980-02-02	1980-02-02 00:00:00	1980-07-29	1980-07-29 00:00:00	32020		\N	11215	0	65363002	372328		0
3019	177	81151	1973-10-15	1973-10-15 00:00:00	1973-11-04	1973-11-04 00:00:00	32020		\N	11954	0	44465007	81151		0
3177	186	28060	1984-11-15	1984-11-15 00:00:00	1984-11-23	1984-11-23 00:00:00	32020		\N	12607	0	43878008	28060		0
3343	192	40481087	2000-06-07	2000-06-07 00:00:00	2000-06-14	2000-06-14 00:00:00	32020		\N	13208	0	444814009	40481087		0
3509	199	40481087	1945-07-14	1945-07-14 00:00:00	1945-07-21	1945-07-21 00:00:00	32020		\N	13671	0	444814009	40481087		0
3687	211	4112343	1972-11-16	1972-11-16 00:00:00	1972-11-29	1972-11-29 00:00:00	32020		\N	14372	0	195662009	4112343		0
3842	222	4112343	1960-12-13	1960-12-13 00:00:00	1960-12-20	1960-12-20 00:00:00	32020		\N	14890	0	195662009	4112343		0
4010	232	40481087	2014-09-27	2014-09-27 00:00:00	2014-10-18	2014-10-18 00:00:00	32020		\N	15550	0	444814009	40481087		0
4197	244	40481087	1937-10-26	1937-10-26 00:00:00	1937-11-02	1937-11-02 00:00:00	32020		\N	16281	0	444814009	40481087		0
4339	250	4218389	1983-02-17	1983-02-17 00:00:00	1983-03-10	1983-03-10 00:00:00	32020		\N	16793	0	39848009	4218389		0
4506	264	81151	1977-07-27	1977-07-27 00:00:00	1977-08-24	1977-08-24 00:00:00	32020		\N	17585	0	44465007	81151		0
4680	273	40481087	1975-10-21	1975-10-21 00:00:00	1975-11-04	1975-11-04 00:00:00	32020		\N	18222	0	444814009	40481087		0
4843	285	78272	1982-09-19	1982-09-19 00:00:00	1982-10-10	1982-10-10 00:00:00	32020		\N	19035	0	70704007	78272		0
5009	295	78272	1984-04-12	1984-04-12 00:00:00	1984-05-10	1984-05-10 00:00:00	32020		\N	19644	0	70704007	78272		0
5176	304	40481087	1972-12-19	1972-12-19 00:00:00	1972-12-26	1972-12-26 00:00:00	32020		\N	20217	0	444814009	40481087		0
5354	316	4152936	1932-05-12	1932-05-12 00:00:00	1932-06-02	1932-06-02 00:00:00	32020		\N	20888	0	283385000	4152936		0
5536	327	260139	2000-07-17	2000-07-17 00:00:00	2000-07-31	2000-07-31 00:00:00	32020		\N	21574	0	10509002	260139		0
5678	334	260139	1992-03-25	1992-03-25 00:00:00	1992-04-08	1992-04-08 00:00:00	32020		\N	22131	0	10509002	260139		0
5839	343	40481087	2007-08-11	2007-08-11 00:00:00	2007-08-25	2007-08-25 00:00:00	32020		\N	22862	0	444814009	40481087		0
6001	352	81151	1987-06-26	1987-06-26 00:00:00	1987-07-24	1987-07-24 00:00:00	32020		\N	23433	0	44465007	81151		0
6166	363	372328	2016-10-08	2016-10-08 00:00:00	2017-07-25	2017-07-25 00:00:00	32020		\N	24127	0	65363002	372328		0
6332	372	4134304	2017-11-27	2017-11-27 00:00:00	2017-12-27	2017-12-27 00:00:00	32020		\N	24790	0	263102004	4134304		0
6523	384	260139	1966-04-30	1966-04-30 00:00:00	1966-05-14	1966-05-14 00:00:00	32020		\N	25336	0	10509002	260139		0
6664	394	260139	1953-03-10	1953-03-10 00:00:00	1953-03-24	1953-03-24 00:00:00	32020		\N	25894	0	10509002	260139		0
6838	403	40481087	1984-12-23	1984-12-23 00:00:00	1985-01-13	1985-01-13 00:00:00	32020		\N	26493	0	444814009	40481087		0
6997	411	260139	2005-10-13	2005-10-13 00:00:00	2005-10-27	2005-10-27 00:00:00	32020		\N	27337	0	10509002	260139		0
7168	421	372328	1966-07-11	1966-07-11 00:00:00	1966-08-24	1966-08-24 00:00:00	32020		\N	27883	0	65363002	372328		0
7328	431	4112343	1985-05-01	1985-05-01 00:00:00	1985-05-10	1985-05-10 00:00:00	32020		\N	28614	0	195662009	4112343		0
7494	440	28060	1997-03-23	1997-03-23 00:00:00	1997-04-01	1997-04-01 00:00:00	32020		\N	29198	0	43878008	28060		0
7669	450	4294548	1989-05-13	1989-05-13 00:00:00	1989-05-27	1989-05-27 00:00:00	32020		\N	30021	0	75498004	4294548		0
7837	457	4112343	2008-11-17	2008-11-17 00:00:00	2008-11-24	2008-11-24 00:00:00	32020		\N	30570	0	195662009	4112343		0
8015	469	372328	1936-03-29	1936-03-29 00:00:00	1936-05-09	1936-05-09 00:00:00	32020		\N	31330	0	65363002	372328		0
8181	479	4283893	1982-01-14	1982-01-14 00:00:00	1982-05-27	1982-05-27 00:00:00	32020		\N	31934	0	36971009	4283893		0
8334	486	40481087	2010-01-23	2010-01-23 00:00:00	2010-02-13	2010-02-13 00:00:00	32020		\N	32524	0	444814009	40481087		0
2754	160	4310024	2004-06-11	2004-06-11 00:00:00	\N	\N	32020		\N	11023	0	424802006	4310024		0
8499	495	40481087	1990-11-20	1990-11-20 00:00:00	1990-11-27	1990-11-27 00:00:00	32020		\N	33081	0	444814009	40481087		0
8670	505	40481087	1989-01-21	1989-01-21 00:00:00	1989-02-11	1989-02-11 00:00:00	32020		\N	33816	0	444814009	40481087		0
8849	518	4134304	1977-04-24	1977-04-24 00:00:00	1977-05-24	1977-05-24 00:00:00	32020		\N	34592	0	263102004	4134304		0
8990	525	4134304	1965-03-25	1965-03-25 00:00:00	1965-06-23	1965-06-23 00:00:00	32020		\N	34960	0	263102004	4134304		0
9157	539	40481087	1990-12-19	1990-12-19 00:00:00	1991-01-02	1991-01-02 00:00:00	32020		\N	35817	0	444814009	40481087		0
9320	550	378419	1996-10-16	1996-10-16 00:00:00	\N	\N	32020		\N	36499	0	26929004	378419		0
9501	563	81151	1970-04-02	1970-04-02 00:00:00	1970-04-23	1970-04-23 00:00:00	32020		\N	37270	0	44465007	81151		0
9653	571	257012	1956-06-07	1956-06-07 00:00:00	\N	\N	32020		\N	37796	0	40055000	257012		0
9818	580	372328	1930-03-05	1930-03-05 00:00:00	1930-08-31	1930-08-31 00:00:00	32020		\N	38471	0	65363002	372328		0
10046	596	40481087	2003-03-27	2003-03-27 00:00:00	2003-04-10	2003-04-10 00:00:00	32020		\N	39331	0	444814009	40481087		0
10150	601	40481087	2011-12-31	2011-12-31 00:00:00	2012-01-21	2012-01-21 00:00:00	32020		\N	39694	0	444814009	40481087		0
10317	609	260139	1991-02-01	1991-02-01 00:00:00	1991-02-15	1991-02-15 00:00:00	32020		\N	40417	0	10509002	260139		0
10483	616	440448	1962-01-03	1962-01-03 00:00:00	\N	\N	32020		\N	41086	0	74400008	440448		0
24	1	81151	1970-12-03	1970-12-03 00:00:00	1970-12-31	1970-12-31 00:00:00	32020		\N	80	0	44465007	81151		0
201	9	40481087	2005-04-30	2005-04-30 00:00:00	2005-05-21	2005-05-21 00:00:00	32020		\N	849	0	444814009	40481087		0
356	18	40481087	2018-11-05	2018-11-05 00:00:00	2018-11-19	2018-11-19 00:00:00	32020		\N	1397	0	444814009	40481087		0
536	32	4027663	1977-10-18	1977-10-18 00:00:00	\N	\N	32020		\N	2210	0	13200003	4027663		0
696	38	4112343	1988-03-28	1988-03-28 00:00:00	1988-04-04	1988-04-04 00:00:00	32020		\N	2719	0	195662009	4112343		0
913	49	40481087	2006-03-26	2006-03-26 00:00:00	2006-04-16	2006-04-16 00:00:00	32020		\N	3564	0	444814009	40481087		0
1057	63	40481087	1965-07-16	1965-07-16 00:00:00	1965-08-06	1965-08-06 00:00:00	32020		\N	4281	0	444814009	40481087		0
1190	69	40481087	2003-03-17	2003-03-17 00:00:00	2003-03-31	2003-03-31 00:00:00	32020		\N	4617	0	444814009	40481087		0
1352	79	4113008	1979-02-15	1979-02-15 00:00:00	1979-03-08	1979-03-08 00:00:00	32020		\N	5265	0	284549007	4113008		0
1587	94	260139	1960-10-04	1960-10-04 00:00:00	1960-10-18	1960-10-18 00:00:00	32020		\N	6315	0	10509002	260139		0
1684	97	81151	1995-08-25	1995-08-25 00:00:00	1995-09-22	1995-09-22 00:00:00	32020		\N	6646	0	44465007	81151		0
1873	110	260139	2001-04-06	2001-04-06 00:00:00	2001-04-13	2001-04-13 00:00:00	32020		\N	7323	0	10509002	260139		0
2016	117	4112343	2006-04-18	2006-04-18 00:00:00	2006-04-29	2006-04-29 00:00:00	32020		\N	7777	0	195662009	4112343		0
2198	126	40481087	1983-09-02	1983-09-02 00:00:00	1983-09-16	1983-09-16 00:00:00	32020		\N	8412	0	444814009	40481087		0
2348	137	30753	2005-02-11	2005-02-11 00:00:00	\N	\N	32020		\N	9150	0	16761005	30753		0
2538	149	4029498	1948-08-17	1948-08-17 00:00:00	\N	\N	32020		\N	10102	0	128613002	4029498		0
2701	158	260139	1954-07-13	1954-07-13 00:00:00	1954-07-20	1954-07-20 00:00:00	32020		\N	10819	0	10509002	260139		0
2846	163	40481087	1979-11-12	1979-11-12 00:00:00	1979-11-26	1979-11-26 00:00:00	32020		\N	11225	0	444814009	40481087		0
3020	177	4112343	1983-12-27	1983-12-27 00:00:00	1984-01-04	1984-01-04 00:00:00	32020		\N	12005	0	195662009	4112343		0
3178	186	40481087	1976-05-28	1976-05-28 00:00:00	1976-06-04	1976-06-04 00:00:00	32020		\N	12623	0	444814009	40481087		0
3344	192	40481087	1940-06-20	1940-06-20 00:00:00	1940-07-11	1940-07-11 00:00:00	32020		\N	13179	0	444814009	40481087		0
3510	199	40481087	1945-02-18	1945-02-18 00:00:00	1945-03-11	1945-03-11 00:00:00	32020		\N	13675	0	444814009	40481087		0
3688	211	4112343	1998-05-14	1998-05-14 00:00:00	1998-05-26	1998-05-26 00:00:00	32020		\N	14353	0	195662009	4112343		0
3843	222	4112343	1957-10-15	1957-10-15 00:00:00	1957-10-28	1957-10-28 00:00:00	32020		\N	14882	0	195662009	4112343		0
4011	232	440448	1963-10-30	1963-10-30 00:00:00	\N	\N	32020		\N	15616	0	74400008	440448		0
4198	244	4294548	1996-10-18	1996-10-18 00:00:00	1996-12-06	1996-12-06 00:00:00	32020		\N	16308	0	75498004	4294548		0
4340	250	4112343	1987-08-02	1987-08-02 00:00:00	1987-08-15	1987-08-15 00:00:00	32020		\N	16796	0	195662009	4112343		0
4507	264	40481087	1977-01-27	1977-01-27 00:00:00	1977-02-17	1977-02-17 00:00:00	32020		\N	17592	0	444814009	40481087		0
4681	273	4059173	2002-11-21	2002-11-21 00:00:00	2002-12-21	2002-12-21 00:00:00	32020		\N	18289	0	16114001	4059173		0
4844	286	40481087	1943-10-23	1943-10-23 00:00:00	1943-10-30	1943-10-30 00:00:00	32020		\N	19083	0	444814009	40481087		0
5010	295	260139	1984-10-04	1984-10-04 00:00:00	1984-10-18	1984-10-18 00:00:00	32020		\N	19593	0	10509002	260139		0
5177	304	40481087	1982-03-03	1982-03-03 00:00:00	1982-03-17	1982-03-17 00:00:00	32020		\N	20240	0	444814009	40481087		0
5355	316	4283893	1934-03-22	1934-03-22 00:00:00	1934-04-26	1934-04-26 00:00:00	32020		\N	20893	0	36971009	4283893		0
5537	327	40481087	2000-11-03	2000-11-03 00:00:00	2000-11-17	2000-11-17 00:00:00	32020		\N	21575	0	444814009	40481087		0
5679	334	40481087	1955-05-18	1955-05-18 00:00:00	1955-06-08	1955-06-08 00:00:00	32020		\N	22144	0	444814009	40481087		0
5840	343	40481087	2004-05-01	2004-05-01 00:00:00	2004-05-22	2004-05-22 00:00:00	32020		\N	22955	0	444814009	40481087		0
6002	352	372328	1978-06-13	1978-06-13 00:00:00	1978-09-25	1978-09-25 00:00:00	32020		\N	23450	0	65363002	372328		0
6167	363	4112343	1974-06-19	1974-06-19 00:00:00	1974-07-02	1974-07-02 00:00:00	32020		\N	24096	0	195662009	4112343		0
6333	372	4152936	1968-02-06	1968-02-06 00:00:00	1968-02-27	1968-02-27 00:00:00	32020		\N	24786	0	283385000	4152936		0
6552	387	80180	2016-07-06	2016-07-06 00:00:00	\N	\N	32020		\N	25471	0	396275006	80180		0
6665	394	260139	1982-01-22	1982-01-22 00:00:00	1982-01-29	1982-01-29 00:00:00	32020		\N	25897	0	10509002	260139		0
6839	403	260139	1926-02-07	1926-02-07 00:00:00	1926-02-21	1926-02-21 00:00:00	32020		\N	26529	0	10509002	260139		0
6998	411	4112343	1975-05-27	1975-05-27 00:00:00	1975-06-03	1975-06-03 00:00:00	32020		\N	27310	0	195662009	4112343		0
7169	422	4237458	1967-01-28	1967-01-28 00:00:00	1967-04-28	1967-04-28 00:00:00	32020		\N	27940	0	58150001	4237458		0
7329	431	40481087	1951-11-16	1951-11-16 00:00:00	1951-11-23	1951-11-23 00:00:00	32020		\N	28549	0	444814009	40481087		0
7504	442	40481087	2007-12-05	2007-12-05 00:00:00	2007-12-19	2007-12-19 00:00:00	32020		\N	29345	0	444814009	40481087		0
7670	450	4001336	1968-05-04	1968-05-04 00:00:00	1968-07-03	1968-07-03 00:00:00	32020		\N	30052	0	110030002	4001336		0
7838	457	260139	2003-03-01	2003-03-01 00:00:00	2003-03-15	2003-03-15 00:00:00	32020		\N	30558	0	10509002	260139		0
8016	469	40481087	1956-11-08	1956-11-08 00:00:00	1956-11-15	1956-11-15 00:00:00	32020		\N	31325	0	444814009	40481087		0
8182	479	375671	1969-09-26	1969-09-26 00:00:00	1969-10-26	1969-10-26 00:00:00	32020		\N	31961	0	62564004	375671		0
8335	486	4027663	1987-10-28	1987-10-28 00:00:00	\N	\N	32020		\N	32506	0	13200003	4027663		0
8500	495	375671	1998-02-01	1998-02-01 00:00:00	1998-03-03	1998-03-03 00:00:00	32020		\N	33106	0	62564004	375671		0
8671	505	40481087	2013-12-22	2013-12-22 00:00:00	2014-01-05	2014-01-05 00:00:00	32020		\N	33757	0	444814009	40481087		0
8850	518	40481087	1971-05-03	1971-05-03 00:00:00	1971-05-17	1971-05-17 00:00:00	32020		\N	34611	0	444814009	40481087		0
8991	526	4112343	1986-04-08	1986-04-08 00:00:00	1986-04-15	1986-04-15 00:00:00	32020		\N	35095	0	195662009	4112343		0
9158	539	40481087	1976-11-12	1976-11-12 00:00:00	1976-11-19	1976-11-19 00:00:00	32020		\N	35814	0	444814009	40481087		0
9321	550	260139	1994-09-24	1994-09-24 00:00:00	1994-10-08	1994-10-08 00:00:00	32020		\N	36492	0	10509002	260139		0
9502	564	4112343	2005-07-11	2005-07-11 00:00:00	2005-07-23	2005-07-23 00:00:00	32020		\N	37367	0	195662009	4112343		0
9654	571	4112343	2009-12-09	2009-12-09 00:00:00	2009-12-19	2009-12-19 00:00:00	32020		\N	37775	0	195662009	4112343		0
9819	580	4294548	1953-09-29	1953-09-29 00:00:00	1953-10-27	1953-10-27 00:00:00	32020		\N	38444	0	75498004	4294548		0
10047	596	28060	1981-12-12	1981-12-12 00:00:00	1981-12-22	1981-12-22 00:00:00	32020		\N	39375	0	43878008	28060		0
10151	601	4112343	1971-10-21	1971-10-21 00:00:00	1971-10-31	1971-10-31 00:00:00	32020		\N	39717	0	195662009	4112343		0
10318	609	40481087	1974-10-28	1974-10-28 00:00:00	1974-11-18	1974-11-18 00:00:00	32020		\N	40456	0	444814009	40481087		0
10484	616	4166224	1962-01-03	1962-01-03 00:00:00	\N	\N	32020		\N	41086	0	47693006	4166224		0
25	1	317576	2006-03-09	2006-03-09 00:00:00	\N	\N	32020		\N	59	0	53741008	317576		0
202	9	40481087	1990-10-20	1990-10-20 00:00:00	1990-11-10	1990-11-10 00:00:00	32020		\N	805	0	444814009	40481087		0
357	18	4112343	1992-01-21	1992-01-21 00:00:00	1992-02-03	1992-02-03 00:00:00	32020		\N	1406	0	195662009	4112343		0
537	32	260139	1986-07-05	1986-07-05 00:00:00	1986-07-19	1986-07-19 00:00:00	32020		\N	2270	0	10509002	260139		0
710	40	81151	2003-08-18	2003-08-18 00:00:00	2003-09-01	2003-09-01 00:00:00	32020		\N	2865	0	44465007	81151		0
921	53	40481087	1991-10-29	1991-10-29 00:00:00	1991-11-12	1991-11-12 00:00:00	32020		\N	3696	0	444814009	40481087		0
1058	63	260139	1994-05-03	1994-05-03 00:00:00	1994-05-10	1994-05-10 00:00:00	32020		\N	4245	0	10509002	260139		0
1191	69	40481087	1979-01-27	1979-01-27 00:00:00	1979-02-03	1979-02-03 00:00:00	32020		\N	4697	0	444814009	40481087		0
1353	79	4112343	1957-02-13	1957-02-13 00:00:00	1957-02-21	1957-02-21 00:00:00	32020		\N	5276	0	195662009	4112343		0
1588	94	4294548	1976-03-31	1976-03-31 00:00:00	1976-08-18	1976-08-18 00:00:00	32020		\N	6344	0	75498004	4294548		0
1685	97	378001	1993-09-04	1993-09-04 00:00:00	1993-11-03	1993-11-03 00:00:00	32020		\N	6645	0	62106007	378001		0
1874	110	80180	2018-08-23	2018-08-23 00:00:00	\N	\N	32020		\N	7350	0	396275006	80180		0
2017	117	4112343	2011-12-26	2011-12-26 00:00:00	2012-01-08	2012-01-08 00:00:00	32020		\N	7760	0	195662009	4112343		0
2199	126	80180	1989-09-03	1989-09-03 00:00:00	\N	\N	32020		\N	8478	0	396275006	80180		0
2349	137	4310024	2003-10-20	2003-10-20 00:00:00	\N	\N	32020		\N	9150	0	424802006	4310024		0
2540	149	40481087	1985-09-03	1985-09-03 00:00:00	1985-09-17	1985-09-17 00:00:00	32020		\N	10033	0	444814009	40481087		0
2702	158	4155034	1975-02-09	1975-02-09 00:00:00	1975-02-23	1975-02-23 00:00:00	32020		\N	10851	0	283371005	4155034		0
2847	163	4112343	2010-07-05	2010-07-05 00:00:00	2010-07-15	2010-07-15 00:00:00	32020		\N	11198	0	195662009	4112343		0
3021	177	4112343	1969-04-28	1969-04-28 00:00:00	1969-05-11	1969-05-11 00:00:00	32020		\N	12004	0	195662009	4112343		0
3179	186	40481087	1973-01-22	1973-01-22 00:00:00	1973-02-05	1973-02-05 00:00:00	32020		\N	12621	0	444814009	40481087		0
3345	192	28060	1986-03-10	1986-03-10 00:00:00	1986-03-23	1986-03-23 00:00:00	32020		\N	13149	0	43878008	28060		0
3511	199	4112343	2018-12-06	2018-12-06 00:00:00	2018-12-14	2018-12-14 00:00:00	32020		\N	13656	0	195662009	4112343		0
3689	211	4112343	2016-02-22	2016-02-22 00:00:00	2016-03-04	2016-03-04 00:00:00	32020		\N	14376	0	195662009	4112343		0
3844	222	40481087	1991-04-04	1991-04-04 00:00:00	1991-04-18	1991-04-18 00:00:00	32020		\N	14894	0	444814009	40481087		0
4012	232	40481087	2014-08-01	2014-08-01 00:00:00	2014-08-22	2014-08-22 00:00:00	32020		\N	15624	0	444814009	40481087		0
4199	244	260139	1954-03-09	1954-03-09 00:00:00	1954-03-16	1954-03-16 00:00:00	32020		\N	16263	0	10509002	260139		0
4341	250	4112343	1996-11-28	1996-11-28 00:00:00	1996-12-09	1996-12-09 00:00:00	32020		\N	16816	0	195662009	4112343		0
4508	264	4113008	1995-06-05	1995-06-05 00:00:00	1995-06-19	1995-06-19 00:00:00	32020		\N	17587	0	284549007	4113008		0
4695	276	4112343	2009-04-03	2009-04-03 00:00:00	2009-04-14	2009-04-14 00:00:00	32020		\N	18409	0	195662009	4112343		0
4845	286	40481087	1973-06-12	1973-06-12 00:00:00	1973-06-26	1973-06-26 00:00:00	32020		\N	19084	0	444814009	40481087		0
5011	295	40481087	1973-09-28	1973-09-28 00:00:00	1973-10-05	1973-10-05 00:00:00	32020		\N	19622	0	444814009	40481087		0
5178	304	4294548	1967-07-08	1967-07-08 00:00:00	1967-08-12	1967-08-12 00:00:00	32020		\N	20248	0	75498004	4294548		0
5356	316	372328	1927-10-01	1927-10-01 00:00:00	1927-11-08	1927-11-08 00:00:00	32020		\N	20877	0	65363002	372328		0
5538	327	4294548	1982-11-03	1982-11-03 00:00:00	1983-03-30	1983-03-30 00:00:00	32020		\N	21572	0	75498004	4294548		0
5680	334	80502	2005-06-15	2005-06-15 00:00:00	\N	\N	32020		\N	22137	0	64859006	80502		0
5841	343	30753	2004-06-16	2004-06-16 00:00:00	\N	\N	32020		\N	22955	0	16761005	30753		0
6003	352	4283893	1984-02-21	1984-02-21 00:00:00	1984-04-24	1984-04-24 00:00:00	32020		\N	23478	0	36971009	4283893		0
6168	363	260139	1995-10-16	1995-10-16 00:00:00	1995-10-23	1995-10-23 00:00:00	32020		\N	24075	0	10509002	260139		0
6334	372	40481087	1962-05-17	1962-05-17 00:00:00	1962-06-07	1962-06-07 00:00:00	32020		\N	24712	0	444814009	40481087		0
6553	387	40481087	1984-08-04	1984-08-04 00:00:00	1984-08-11	1984-08-11 00:00:00	32020		\N	25472	0	444814009	40481087		0
6666	394	40481087	1956-01-27	1956-01-27 00:00:00	1956-02-10	1956-02-10 00:00:00	32020		\N	25837	0	444814009	40481087		0
6840	403	4112343	1974-09-12	1974-09-12 00:00:00	1974-09-25	1974-09-25 00:00:00	32020		\N	26534	0	195662009	4112343		0
6999	411	4156265	1981-10-23	1981-10-23 00:00:00	1981-11-13	1981-11-13 00:00:00	32020		\N	27404	0	370247008	4156265		0
7170	422	4112343	1964-07-15	1964-07-15 00:00:00	1964-07-25	1964-07-25 00:00:00	32020		\N	27966	0	195662009	4112343		0
7330	431	260139	1989-05-04	1989-05-04 00:00:00	1989-05-18	1989-05-18 00:00:00	32020		\N	28597	0	10509002	260139		0
7505	442	372328	1952-02-28	1952-02-28 00:00:00	1952-08-02	1952-08-02 00:00:00	32020		\N	29347	0	65363002	372328		0
7671	450	30753	2003-11-16	2003-11-16 00:00:00	\N	\N	32020		\N	30029	0	16761005	30753		0
7839	457	40481087	1957-04-21	1957-04-21 00:00:00	1957-04-28	1957-04-28 00:00:00	32020		\N	30566	0	444814009	40481087		0
8017	469	195588	1975-11-20	1975-11-20 00:00:00	1976-01-13	1976-01-13 00:00:00	32020		\N	31251	0	38822007	195588		0
8183	479	40481087	1988-12-30	1988-12-30 00:00:00	1989-01-06	1989-01-06 00:00:00	32020		\N	31879	0	444814009	40481087		0
8336	486	4112343	1986-09-21	1986-09-21 00:00:00	1986-09-29	1986-09-29 00:00:00	32020		\N	32506	0	195662009	4112343		0
8501	495	40481087	1990-05-03	1990-05-03 00:00:00	1990-05-17	1990-05-17 00:00:00	32020		\N	33053	0	444814009	40481087		0
8678	507	40481087	2009-09-08	2009-09-08 00:00:00	2009-09-15	2009-09-15 00:00:00	32020		\N	33981	0	444814009	40481087		0
8851	518	81151	1995-10-17	1995-10-17 00:00:00	1995-10-31	1995-10-31 00:00:00	32020		\N	34594	0	44465007	81151		0
8992	526	4294548	2002-07-14	2002-07-14 00:00:00	2002-10-27	2002-10-27 00:00:00	32020		\N	35053	0	75498004	4294548		0
9159	539	317576	1982-11-28	1982-11-28 00:00:00	\N	\N	32020		\N	35855	0	53741008	317576		0
9322	550	4113008	1962-07-27	1962-07-27 00:00:00	1962-08-17	1962-08-17 00:00:00	32020		\N	36448	0	284549007	4113008		0
9503	564	40481087	1984-09-21	1984-09-21 00:00:00	1984-09-28	1984-09-28 00:00:00	32020		\N	37331	0	444814009	40481087		0
9655	572	40481087	2014-05-11	2014-05-11 00:00:00	2014-05-18	2014-05-18 00:00:00	32020		\N	37872	0	444814009	40481087		0
9820	580	40481087	1979-03-26	1979-03-26 00:00:00	1979-04-16	1979-04-16 00:00:00	32020		\N	38445	0	444814009	40481087		0
10048	596	4155034	2000-05-03	2000-05-03 00:00:00	2000-05-17	2000-05-17 00:00:00	32020		\N	39327	0	283371005	4155034		0
10152	601	40481087	2008-03-31	2008-03-31 00:00:00	2008-04-14	2008-04-14 00:00:00	32020		\N	39721	0	444814009	40481087		0
10319	609	4112343	1974-08-11	1974-08-11 00:00:00	1974-08-23	1974-08-23 00:00:00	32020		\N	40415	0	195662009	4112343		0
10485	616	40481087	1965-03-11	1965-03-11 00:00:00	1965-03-25	1965-03-25 00:00:00	32020		\N	41118	0	444814009	40481087		0
26	1	4027663	1975-01-21	1975-01-21 00:00:00	\N	\N	32020		\N	13	0	13200003	4027663		0
203	9	4109685	2003-02-23	2003-02-23 00:00:00	2003-03-09	2003-03-09 00:00:00	32020		\N	863	0	284551006	4109685		0
358	18	4112343	1991-09-13	1991-09-13 00:00:00	1991-09-22	1991-09-22 00:00:00	32020		\N	1394	0	195662009	4112343		0
538	32	4152936	1991-03-22	1991-03-22 00:00:00	1991-04-12	1991-04-12 00:00:00	32020		\N	2281	0	283385000	4152936		0
711	40	4134304	1967-08-13	1967-08-13 00:00:00	1967-09-12	1967-09-12 00:00:00	32020		\N	2863	0	263102004	4134304		0
922	53	40481087	1982-08-31	1982-08-31 00:00:00	1982-09-07	1982-09-07 00:00:00	32020		\N	3695	0	444814009	40481087		0
1059	63	80180	1992-07-28	1992-07-28 00:00:00	\N	\N	32020		\N	4244	0	396275006	80180		0
1192	69	4112343	2019-01-30	2019-01-30 00:00:00	2019-02-06	2019-02-06 00:00:00	32020		\N	4703	0	195662009	4112343		0
1354	79	40481087	1992-05-05	1992-05-05 00:00:00	1992-05-19	1992-05-19 00:00:00	32020		\N	5308	0	444814009	40481087		0
1589	94	260139	1972-04-27	1972-04-27 00:00:00	1972-05-11	1972-05-11 00:00:00	32020		\N	6354	0	10509002	260139		0
1686	97	40481087	1980-10-16	1980-10-16 00:00:00	1980-10-30	1980-10-30 00:00:00	32020		\N	6566	0	444814009	40481087		0
1875	110	4296204	2003-07-23	2003-07-23 00:00:00	2003-08-20	2003-08-20 00:00:00	32020		\N	7307	0	403190006	4296204		0
2018	117	80180	2009-01-13	2009-01-13 00:00:00	\N	\N	32020		\N	7814	0	396275006	80180		0
2225	129	4113008	1989-02-11	1989-02-11 00:00:00	1989-03-04	1989-03-04 00:00:00	32020		\N	8705	0	284549007	4113008		0
2350	137	80180	2005-04-12	2005-04-12 00:00:00	\N	\N	32020		\N	9150	0	396275006	80180		0
2541	149	260139	1975-05-25	1975-05-25 00:00:00	1975-06-01	1975-06-01 00:00:00	32020		\N	10038	0	10509002	260139		0
2703	158	4112343	1955-05-05	1955-05-05 00:00:00	1955-05-17	1955-05-17 00:00:00	32020		\N	10820	0	195662009	4112343		0
2848	163	40481087	2017-02-22	2017-02-22 00:00:00	2017-03-01	2017-03-01 00:00:00	32020		\N	11194	0	444814009	40481087		0
3022	177	4116491	2016-04-12	2016-04-12 00:00:00	2016-06-04	2016-06-04 00:00:00	32020		\N	11960	0	301011002	4116491		0
3180	186	40481087	1982-05-10	1982-05-10 00:00:00	1982-05-17	1982-05-17 00:00:00	32020		\N	12614	0	444814009	40481087		0
3346	192	40481087	1947-07-10	1947-07-10 00:00:00	1947-07-17	1947-07-17 00:00:00	32020		\N	13200	0	444814009	40481087		0
3529	202	260139	1948-12-18	1948-12-18 00:00:00	1949-01-01	1949-01-01 00:00:00	32020		\N	13840	0	10509002	260139		0
3690	211	260139	1969-08-03	1969-08-03 00:00:00	1969-08-10	1969-08-10 00:00:00	32020		\N	14388	0	10509002	260139		0
3845	222	257012	1973-08-24	1973-08-24 00:00:00	\N	\N	32020		\N	14892	0	40055000	257012		0
4013	232	40481087	1998-09-05	1998-09-05 00:00:00	1998-09-19	1998-09-19 00:00:00	32020		\N	15623	0	444814009	40481087		0
4200	244	4027663	1955-02-19	1955-02-19 00:00:00	\N	\N	32020		\N	16263	0	13200003	4027663		0
4342	250	260139	2018-06-05	2018-06-05 00:00:00	2018-06-19	2018-06-19 00:00:00	32020		\N	16794	0	10509002	260139		0
4509	264	78272	1972-10-09	1972-10-09 00:00:00	1972-10-30	1972-10-30 00:00:00	32020		\N	17535	0	70704007	78272		0
4696	276	378001	1988-12-08	1988-12-08 00:00:00	1989-02-06	1989-02-06 00:00:00	32020		\N	18390	0	62106007	378001		0
4846	286	4112343	1997-05-28	1997-05-28 00:00:00	1997-06-04	1997-06-04 00:00:00	32020		\N	19140	0	195662009	4112343		0
5012	295	260139	1973-12-07	1973-12-07 00:00:00	1973-12-21	1973-12-21 00:00:00	32020		\N	19623	0	10509002	260139		0
5179	304	40481087	2003-11-19	2003-11-19 00:00:00	2003-12-10	2003-12-10 00:00:00	32020		\N	20253	0	444814009	40481087		0
5357	316	317576	1976-07-06	1976-07-06 00:00:00	\N	\N	32020		\N	20912	0	53741008	317576		0
5539	327	40481087	1981-02-12	1981-02-12 00:00:00	1981-03-05	1981-03-05 00:00:00	32020		\N	21615	0	444814009	40481087		0
5681	334	4112343	1986-05-16	1986-05-16 00:00:00	1986-05-29	1986-05-29 00:00:00	32020		\N	22130	0	195662009	4112343		0
5842	343	80180	2005-09-09	2005-09-09 00:00:00	\N	\N	32020		\N	22955	0	396275006	80180		0
6004	352	4310024	2010-09-08	2010-09-08 00:00:00	\N	\N	32020		\N	23464	0	424802006	4310024		0
6169	363	4283893	1973-10-06	1973-10-06 00:00:00	1974-03-16	1974-03-16 00:00:00	32020		\N	24082	0	36971009	4283893		0
6335	372	80180	2004-10-14	2004-10-14 00:00:00	\N	\N	32020		\N	24728	0	396275006	80180		0
6554	387	260139	1975-08-22	1975-08-22 00:00:00	1975-09-05	1975-09-05 00:00:00	32020		\N	25447	0	10509002	260139		0
6667	394	4112343	1941-01-09	1941-01-09 00:00:00	1941-01-21	1941-01-21 00:00:00	32020		\N	25916	0	195662009	4112343		0
6841	403	4283893	1935-01-09	1935-01-09 00:00:00	1935-03-06	1935-03-06 00:00:00	32020		\N	26531	0	36971009	4283893		0
7000	411	40481087	1996-06-21	1996-06-21 00:00:00	1996-07-12	1996-07-12 00:00:00	32020		\N	27323	0	444814009	40481087		0
7171	422	257012	2015-01-31	2015-01-31 00:00:00	\N	\N	32020		\N	27941	0	40055000	257012		0
7331	431	4112343	1975-09-30	1975-09-30 00:00:00	1975-10-08	1975-10-08 00:00:00	32020		\N	28584	0	195662009	4112343		0
7506	442	260139	2011-05-28	2011-05-28 00:00:00	2011-06-11	2011-06-11 00:00:00	32020		\N	29392	0	10509002	260139		0
7672	450	4285898	2004-05-15	2004-05-15 00:00:00	\N	\N	32020		\N	30029	0	68496003	4285898		0
7840	458	4112343	1978-03-31	1978-03-31 00:00:00	1978-04-07	1978-04-07 00:00:00	32020		\N	30629	0	195662009	4112343		0
8018	469	4285898	1977-01-03	1977-01-03 00:00:00	\N	\N	32020		\N	31251	0	68496003	4285898		0
8184	479	260139	1989-05-11	1989-05-11 00:00:00	1989-05-25	1989-05-25 00:00:00	32020		\N	31880	0	10509002	260139		0
8337	486	257012	1975-04-07	1975-04-07 00:00:00	\N	\N	32020		\N	32458	0	40055000	257012		0
8502	495	4112343	1975-03-15	1975-03-15 00:00:00	1975-03-26	1975-03-26 00:00:00	32020		\N	33094	0	195662009	4112343		0
8679	507	260139	1994-08-04	1994-08-04 00:00:00	1994-08-18	1994-08-18 00:00:00	32020		\N	33978	0	10509002	260139		0
8852	518	372328	1971-01-26	1971-01-26 00:00:00	1971-03-09	1971-03-09 00:00:00	32020		\N	34596	0	65363002	372328		0
8993	526	4116491	2004-04-25	2004-04-25 00:00:00	2004-06-04	2004-06-04 00:00:00	32020		\N	35097	0	301011002	4116491		0
9160	539	40481087	1984-02-02	1984-02-02 00:00:00	1984-02-16	1984-02-16 00:00:00	32020		\N	35816	0	444814009	40481087		0
9323	550	255848	2002-06-17	2002-06-17 00:00:00	\N	\N	32020		\N	36450	0	233604007	255848		0
9504	564	40481087	1975-04-28	1975-04-28 00:00:00	1975-05-19	1975-05-19 00:00:00	32020		\N	37365	0	444814009	40481087		0
9656	572	378001	2015-07-26	2015-07-26 00:00:00	2015-08-25	2015-08-25 00:00:00	32020		\N	37859	0	62106007	378001		0
9821	580	40481087	1974-09-08	1974-09-08 00:00:00	1974-09-29	1974-09-29 00:00:00	32020		\N	38459	0	444814009	40481087		0
10049	596	4113008	1982-09-21	1982-09-21 00:00:00	1982-10-05	1982-10-05 00:00:00	32020		\N	39326	0	284549007	4113008		0
10153	601	4310024	2008-04-05	2008-04-05 00:00:00	\N	\N	32020		\N	39721	0	424802006	4310024		0
10320	609	40481087	1973-10-12	1973-10-12 00:00:00	1973-10-26	1973-10-26 00:00:00	32020		\N	40440	0	444814009	40481087		0
10486	616	40481087	2019-04-20	2019-04-20 00:00:00	2019-05-11	2019-05-11 00:00:00	32020		\N	41139	0	444814009	40481087		0
27	2	4237458	1934-01-19	1934-01-19 00:00:00	1934-03-20	1934-03-20 00:00:00	32020		\N	112	0	58150001	4237458		0
215	11	260139	2008-02-20	2008-02-20 00:00:00	2008-03-05	2008-03-05 00:00:00	32020		\N	906	0	10509002	260139		0
359	18	28060	1979-05-24	1979-05-24 00:00:00	1979-06-01	1979-06-01 00:00:00	32020		\N	1385	0	43878008	28060		0
539	32	4278672	1951-07-17	1951-07-17 00:00:00	1951-09-15	1951-09-15 00:00:00	32020		\N	2234	0	65966004	4278672		0
712	40	40481087	1998-02-16	1998-02-16 00:00:00	1998-03-09	1998-03-09 00:00:00	32020		\N	2872	0	444814009	40481087		0
923	53	78272	1965-05-01	1965-05-01 00:00:00	1965-05-22	1965-05-22 00:00:00	32020		\N	3631	0	70704007	78272		0
1060	63	260139	1990-09-14	1990-09-14 00:00:00	1990-09-21	1990-09-21 00:00:00	32020		\N	4244	0	10509002	260139		0
1193	69	4155034	1997-12-24	1997-12-24 00:00:00	1998-01-07	1998-01-07 00:00:00	32020		\N	4710	0	283371005	4155034		0
1355	80	81893	1972-09-26	1972-09-26 00:00:00	\N	\N	32020		\N	5403	0	64766004	81893		0
1590	94	260139	1982-07-03	1982-07-03 00:00:00	1982-07-10	1982-07-10 00:00:00	32020		\N	6340	0	10509002	260139		0
1687	97	81151	1992-09-04	1992-09-04 00:00:00	1992-10-09	1992-10-09 00:00:00	32020		\N	6644	0	44465007	81151		0
1876	110	40481087	2000-06-06	2000-06-06 00:00:00	2000-06-13	2000-06-13 00:00:00	32020		\N	7294	0	444814009	40481087		0
2019	117	4112343	1969-10-03	1969-10-03 00:00:00	1969-10-15	1969-10-15 00:00:00	32020		\N	7774	0	195662009	4112343		0
2226	129	4112343	1987-01-20	1987-01-20 00:00:00	1987-02-01	1987-02-01 00:00:00	32020		\N	8706	0	195662009	4112343		0
2351	137	4266809	2005-04-12	2005-04-12 00:00:00	\N	\N	32020		\N	9150	0	397881000	4266809		0
2542	149	40481087	2004-10-13	2004-10-13 00:00:00	2004-10-27	2004-10-27 00:00:00	32020		\N	10034	0	444814009	40481087		0
2704	158	4112343	2001-03-30	2001-03-30 00:00:00	2001-04-09	2001-04-09 00:00:00	32020		\N	10796	0	195662009	4112343		0
2849	164	378001	1979-03-26	1979-03-26 00:00:00	1979-04-25	1979-04-25 00:00:00	32020		\N	11279	0	62106007	378001		0
3023	177	372328	1969-12-04	1969-12-04 00:00:00	1970-11-08	1970-11-08 00:00:00	32020		\N	11956	0	65363002	372328		0
3181	186	4112343	1998-06-18	1998-06-18 00:00:00	1998-06-29	1998-06-29 00:00:00	32020		\N	12597	0	195662009	4112343		0
3347	192	4218389	1946-07-04	1946-07-04 00:00:00	1946-08-08	1946-08-08 00:00:00	32020		\N	13215	0	39848009	4218389		0
3530	202	40481087	1963-07-07	1963-07-07 00:00:00	1963-07-28	1963-07-28 00:00:00	32020		\N	13885	0	444814009	40481087		0
3691	211	4112343	1976-07-15	1976-07-15 00:00:00	1976-07-23	1976-07-23 00:00:00	32020		\N	14374	0	195662009	4112343		0
3846	222	4134304	1958-05-10	1958-05-10 00:00:00	1958-06-09	1958-06-09 00:00:00	32020		\N	14931	0	263102004	4134304		0
4014	232	4027663	1970-10-26	1970-10-26 00:00:00	\N	\N	32020		\N	15540	0	13200003	4027663		0
4201	244	40481087	1992-09-18	1992-09-18 00:00:00	1992-10-02	1992-10-02 00:00:00	32020		\N	16357	0	444814009	40481087		0
4356	254	40481087	1999-12-27	1999-12-27 00:00:00	2000-01-10	2000-01-10 00:00:00	32020		\N	16925	0	444814009	40481087		0
4510	264	372328	1987-03-26	1987-03-26 00:00:00	1987-07-10	1987-07-10 00:00:00	32020		\N	17574	0	65363002	372328		0
4697	276	4112343	1984-04-16	1984-04-16 00:00:00	1984-04-29	1984-04-29 00:00:00	32020		\N	18417	0	195662009	4112343		0
4847	286	4112343	1973-10-03	1973-10-03 00:00:00	1973-10-12	1973-10-12 00:00:00	32020		\N	19085	0	195662009	4112343		0
5013	295	28060	1975-08-06	1975-08-06 00:00:00	1975-08-18	1975-08-18 00:00:00	32020		\N	19631	0	43878008	28060		0
5180	304	260139	2010-04-21	2010-04-21 00:00:00	2010-04-28	2010-04-28 00:00:00	32020		\N	20276	0	10509002	260139		0
5358	316	260139	1956-11-04	1956-11-04 00:00:00	1956-11-18	1956-11-18 00:00:00	32020		\N	20955	0	10509002	260139		0
5540	327	372328	1976-01-20	1976-01-20 00:00:00	1977-01-17	1977-01-17 00:00:00	32020		\N	21622	0	65363002	372328		0
5682	334	260139	1962-11-12	1962-11-12 00:00:00	1962-11-26	1962-11-26 00:00:00	32020		\N	22145	0	10509002	260139		0
5843	343	4266809	2005-09-09	2005-09-09 00:00:00	\N	\N	32020		\N	22955	0	397881000	4266809		0
6005	352	4027663	2005-07-11	2005-07-11 00:00:00	\N	\N	32020		\N	23462	0	13200003	4027663		0
6170	363	4112343	2013-01-09	2013-01-09 00:00:00	2013-01-19	2013-01-19 00:00:00	32020		\N	24077	0	195662009	4112343		0
6336	372	40481087	2003-07-07	2003-07-07 00:00:00	2003-07-21	2003-07-21 00:00:00	32020		\N	24749	0	444814009	40481087		0
6555	387	4218389	2011-03-27	2011-03-27 00:00:00	2011-05-01	2011-05-01 00:00:00	32020		\N	25459	0	39848009	4218389		0
6668	394	4112343	1926-01-16	1926-01-16 00:00:00	1926-01-24	1926-01-24 00:00:00	32020		\N	25874	0	195662009	4112343		0
6842	403	439777	1999-02-08	1999-02-08 00:00:00	\N	\N	32020		\N	26500	0	271737000	439777		0
7001	411	4112343	1982-03-01	1982-03-01 00:00:00	1982-03-09	1982-03-09 00:00:00	32020		\N	27270	0	195662009	4112343		0
7172	422	80180	2000-12-20	2000-12-20 00:00:00	\N	\N	32020		\N	27927	0	396275006	80180		0
7332	431	4112343	1978-08-26	1978-08-26 00:00:00	1978-09-02	1978-09-02 00:00:00	32020		\N	28620	0	195662009	4112343		0
7507	442	80180	1985-09-02	1985-09-02 00:00:00	\N	\N	32020		\N	29303	0	396275006	80180		0
7673	450	40481087	1978-11-16	1978-11-16 00:00:00	1978-11-30	1978-11-30 00:00:00	32020		\N	30043	0	444814009	40481087		0
7841	458	4112343	1974-04-09	1974-04-09 00:00:00	1974-04-20	1974-04-20 00:00:00	32020		\N	30614	0	195662009	4112343		0
8019	469	80180	1977-02-02	1977-02-02 00:00:00	\N	\N	32020		\N	31251	0	396275006	80180		0
8185	479	4294548	1966-04-24	1966-04-24 00:00:00	1966-07-10	1966-07-10 00:00:00	32020		\N	31905	0	75498004	4294548		0
8338	486	4146173	2008-06-24	2008-06-24 00:00:00	2008-08-23	2008-08-23 00:00:00	32020		\N	32522	0	307731004	4146173		0
8503	495	4112343	1979-07-25	1979-07-25 00:00:00	1979-08-01	1979-08-01 00:00:00	32020		\N	33040	0	195662009	4112343		0
8680	507	40481087	1962-08-20	1962-08-20 00:00:00	1962-09-10	1962-09-10 00:00:00	32020		\N	33967	0	444814009	40481087		0
8853	518	4237458	2013-07-28	2013-07-28 00:00:00	2013-08-27	2013-08-27 00:00:00	32020		\N	34595	0	58150001	4237458		0
8994	526	4056621	2004-04-25	2004-04-25 00:00:00	\N	\N	32020		\N	35097	0	197927001	4056621		0
9161	539	4112343	1980-12-18	1980-12-18 00:00:00	1980-12-31	1980-12-31 00:00:00	32020		\N	35815	0	195662009	4112343		0
9324	550	4134304	1920-12-13	1920-12-13 00:00:00	1921-03-13	1921-03-13 00:00:00	32020		\N	36445	0	263102004	4134304		0
9505	564	4056621	1991-12-22	1991-12-22 00:00:00	\N	\N	32020		\N	37383	0	197927001	4056621		0
9657	572	40481087	1969-04-02	1969-04-02 00:00:00	1969-04-09	1969-04-09 00:00:00	32020		\N	37894	0	444814009	40481087		0
9822	580	40481087	1940-01-11	1940-01-11 00:00:00	1940-01-18	1940-01-18 00:00:00	32020		\N	38403	0	444814009	40481087		0
10050	596	80180	1984-02-28	1984-02-28 00:00:00	\N	\N	32020		\N	39326	0	396275006	80180		0
10154	601	81151	1974-10-21	1974-10-21 00:00:00	1974-11-25	1974-11-25 00:00:00	32020		\N	39681	0	44465007	81151		0
10321	609	4112343	1983-03-24	1983-03-24 00:00:00	1983-04-05	1983-04-05 00:00:00	32020		\N	40429	0	195662009	4112343		0
10487	616	4155034	2004-07-01	2004-07-01 00:00:00	2004-07-22	2004-07-22 00:00:00	32020		\N	41090	0	283371005	4155034		0
28	2	4146173	1960-08-14	1960-08-14 00:00:00	1960-09-13	1960-09-13 00:00:00	32020		\N	138	0	307731004	4146173		0
216	11	4134304	1998-04-02	1998-04-02 00:00:00	1998-07-01	1998-07-01 00:00:00	32020		\N	993	0	263102004	4134304		0
360	18	40481087	1967-07-16	1967-07-16 00:00:00	1967-07-23	1967-07-23 00:00:00	32020		\N	1404	0	444814009	40481087		0
540	32	80809	2000-10-12	2000-10-12 00:00:00	2004-09-21	2004-09-21 00:00:00	32020		\N	2271	0	69896004	80809		0
713	40	40481087	1998-10-12	1998-10-12 00:00:00	1998-10-26	1998-10-26 00:00:00	32020		\N	2873	0	444814009	40481087		0
924	53	40481087	2001-05-31	2001-05-31 00:00:00	2001-06-14	2001-06-14 00:00:00	32020		\N	3638	0	444814009	40481087		0
1061	63	40481087	1995-11-20	1995-11-20 00:00:00	1995-11-27	1995-11-27 00:00:00	32020		\N	4239	0	444814009	40481087		0
1194	69	40481087	2005-02-16	2005-02-16 00:00:00	2005-03-02	2005-03-02 00:00:00	32020		\N	4623	0	444814009	40481087		0
1356	80	4285898	1974-06-18	1974-06-18 00:00:00	\N	\N	32020		\N	5403	0	68496003	4285898		0
1591	94	4296204	1998-07-23	1998-07-23 00:00:00	1998-08-27	1998-08-27 00:00:00	32020		\N	6301	0	403190006	4296204		0
1688	97	140673	2008-07-02	2008-07-02 00:00:00	\N	\N	32020		\N	6587	0	40930008	140673		0
1877	110	260139	2015-02-10	2015-02-10 00:00:00	2015-02-17	2015-02-17 00:00:00	32020		\N	7311	0	10509002	260139		0
2020	117	4112343	2011-02-19	2011-02-19 00:00:00	2011-02-28	2011-02-28 00:00:00	32020		\N	7780	0	195662009	4112343		0
2227	129	4112343	2004-10-04	2004-10-04 00:00:00	2004-10-13	2004-10-13 00:00:00	32020		\N	8712	0	195662009	4112343		0
2352	137	40481087	1991-06-20	1991-06-20 00:00:00	1991-06-27	1991-06-27 00:00:00	32020		\N	9205	0	444814009	40481087		0
2543	149	372328	1942-06-15	1942-06-15 00:00:00	1942-07-28	1942-07-28 00:00:00	32020		\N	10052	0	65363002	372328		0
2705	158	260139	1995-03-23	1995-03-23 00:00:00	1995-04-06	1995-04-06 00:00:00	32020		\N	10823	0	10509002	260139		0
2850	164	260139	1979-11-22	1979-11-22 00:00:00	1979-11-29	1979-11-29 00:00:00	32020		\N	11285	0	10509002	260139		0
3024	177	381316	2009-11-08	2009-11-08 00:00:00	\N	\N	32020		\N	11982	0	230690007	381316		0
3182	186	260139	1991-01-11	1991-01-11 00:00:00	1991-01-25	1991-01-25 00:00:00	32020		\N	12637	0	10509002	260139		0
3348	192	40481087	1991-08-12	1991-08-12 00:00:00	1991-08-19	1991-08-19 00:00:00	32020		\N	13232	0	444814009	40481087		0
3531	202	381316	1997-10-25	1997-10-25 00:00:00	\N	\N	32020		\N	13877	0	230690007	381316		0
3692	211	4112343	1997-08-05	1997-08-05 00:00:00	1997-08-16	1997-08-16 00:00:00	32020		\N	14396	0	195662009	4112343		0
3847	222	40481087	1994-02-09	1994-02-09 00:00:00	1994-02-23	1994-02-23 00:00:00	32020		\N	14938	0	444814009	40481087		0
4015	232	40481087	1996-09-18	1996-09-18 00:00:00	1996-09-25	1996-09-25 00:00:00	32020		\N	15621	0	444814009	40481087		0
4202	244	28060	1972-11-04	1972-11-04 00:00:00	1972-11-12	1972-11-12 00:00:00	32020		\N	16266	0	43878008	28060		0
4357	254	4146173	1981-01-12	1981-01-12 00:00:00	1981-02-11	1981-02-11 00:00:00	32020		\N	16964	0	307731004	4146173		0
4511	264	40481087	2004-06-30	2004-06-30 00:00:00	2004-07-14	2004-07-14 00:00:00	32020		\N	17540	0	444814009	40481087		0
4698	276	4112343	1978-11-02	1978-11-02 00:00:00	1978-11-12	1978-11-12 00:00:00	32020		\N	18415	0	195662009	4112343		0
4848	286	4134304	2016-05-08	2016-05-08 00:00:00	2016-08-06	2016-08-06 00:00:00	32020		\N	19046	0	263102004	4134304		0
5014	295	40481087	2013-02-16	2013-02-16 00:00:00	2013-03-09	2013-03-09 00:00:00	32020		\N	19625	0	444814009	40481087		0
5181	304	4109685	1978-01-17	1978-01-17 00:00:00	1978-02-07	1978-02-07 00:00:00	32020		\N	20212	0	284551006	4109685		0
5359	316	40481087	1979-09-09	1979-09-09 00:00:00	1979-09-30	1979-09-30 00:00:00	32020		\N	20963	0	444814009	40481087		0
5541	327	4218389	1983-10-26	1983-10-26 00:00:00	1983-11-16	1983-11-16 00:00:00	32020		\N	21618	0	39848009	4218389		0
5683	334	4146173	1985-12-17	1985-12-17 00:00:00	1986-01-16	1986-01-16 00:00:00	32020		\N	22165	0	307731004	4146173		0
5844	343	4285898	2004-11-13	2004-11-13 00:00:00	\N	\N	32020		\N	22955	0	68496003	4285898		0
6006	352	40481087	2006-10-02	2006-10-02 00:00:00	2006-10-16	2006-10-16 00:00:00	32020		\N	23439	0	444814009	40481087		0
6171	363	4112343	2002-01-07	2002-01-07 00:00:00	2002-01-19	2002-01-19 00:00:00	32020		\N	24076	0	195662009	4112343		0
6337	372	134438	1985-05-14	1985-05-14 00:00:00	1986-06-09	1986-06-09 00:00:00	32020		\N	24757	0	40275004	134438		0
6556	387	4112343	1976-04-21	1976-04-21 00:00:00	1976-04-30	1976-04-30 00:00:00	32020		\N	25503	0	195662009	4112343		0
6669	394	40481087	1993-08-30	1993-08-30 00:00:00	1993-09-06	1993-09-06 00:00:00	32020		\N	25898	0	444814009	40481087		0
6843	403	40481087	2008-12-14	2008-12-14 00:00:00	2008-12-28	2008-12-28 00:00:00	32020		\N	26515	0	444814009	40481087		0
7002	411	40481087	2002-01-18	2002-01-18 00:00:00	2002-02-08	2002-02-08 00:00:00	32020		\N	27264	0	444814009	40481087		0
7173	422	4112343	1972-09-25	1972-09-25 00:00:00	1972-10-04	1972-10-04 00:00:00	32020		\N	27948	0	195662009	4112343		0
7333	431	4112343	1964-09-30	1964-09-30 00:00:00	1964-10-11	1964-10-11 00:00:00	32020		\N	28613	0	195662009	4112343		0
7508	442	4112343	1970-12-23	1970-12-23 00:00:00	1971-01-04	1971-01-04 00:00:00	32020		\N	29335	0	195662009	4112343		0
7674	450	4027663	1996-04-01	1996-04-01 00:00:00	\N	\N	32020		\N	30033	0	13200003	4027663		0
7842	458	4112343	1986-05-18	1986-05-18 00:00:00	1986-05-29	1986-05-29 00:00:00	32020		\N	30666	0	195662009	4112343		0
8020	469	30753	1976-05-08	1976-05-08 00:00:00	\N	\N	32020		\N	31251	0	16761005	30753		0
8186	479	372328	1943-01-04	1943-01-04 00:00:00	1943-03-28	1943-03-28 00:00:00	32020		\N	31872	0	65363002	372328		0
8339	486	80180	1999-03-14	1999-03-14 00:00:00	\N	\N	32020		\N	32508	0	396275006	80180		0
8504	495	257012	1989-01-04	1989-01-04 00:00:00	\N	\N	32020		\N	33041	0	40055000	257012		0
8681	507	255848	2016-04-18	2016-04-18 00:00:00	\N	\N	32020		\N	33973	0	233604007	255848		0
8854	518	28060	1982-05-14	1982-05-14 00:00:00	1982-05-22	1982-05-22 00:00:00	32020		\N	34613	0	43878008	28060		0
8995	526	40481087	2008-10-16	2008-10-16 00:00:00	2008-10-23	2008-10-23 00:00:00	32020		\N	35098	0	444814009	40481087		0
9202	545	378001	1976-10-10	1976-10-10 00:00:00	1976-12-09	1976-12-09 00:00:00	32020		\N	36144	0	62106007	378001		0
9325	550	4112343	1977-02-20	1977-02-20 00:00:00	1977-03-03	1977-03-03 00:00:00	32020		\N	36519	0	195662009	4112343		0
9506	564	4116491	1991-12-22	1991-12-22 00:00:00	1992-01-28	1992-01-28 00:00:00	32020		\N	37383	0	301011002	4116491		0
9658	572	4027663	1981-10-16	1981-10-16 00:00:00	\N	\N	32020		\N	37886	0	13200003	4027663		0
9823	580	81151	2011-08-05	2011-08-05 00:00:00	2011-08-19	2011-08-19 00:00:00	32020		\N	38455	0	44465007	81151		0
10051	596	372328	1949-02-11	1949-02-11 00:00:00	1949-04-26	1949-04-26 00:00:00	32020		\N	39310	0	65363002	372328		0
10155	601	80180	2010-06-24	2010-06-24 00:00:00	\N	\N	32020		\N	39679	0	396275006	80180		0
10322	609	321042	2014-12-02	2014-12-02 00:00:00	\N	\N	32020		\N	40413	0	410429000	321042		0
10488	616	4059173	1959-11-29	1959-11-29 00:00:00	1960-02-27	1960-02-27 00:00:00	32020		\N	41085	0	16114001	4059173		0
29	2	40481087	1922-05-27	1922-05-27 00:00:00	1922-06-03	1922-06-03 00:00:00	32020		\N	182	0	444814009	40481087		0
217	11	40481087	1974-01-21	1974-01-21 00:00:00	1974-01-28	1974-01-28 00:00:00	32020		\N	962	0	444814009	40481087		0
361	18	4156265	1970-09-22	1970-09-22 00:00:00	1970-10-06	1970-10-06 00:00:00	32020		\N	1381	0	370247008	4156265		0
541	32	40481087	2005-08-07	2005-08-07 00:00:00	2005-08-21	2005-08-21 00:00:00	32020		\N	2262	0	444814009	40481087		0
714	40	40481087	1982-03-24	1982-03-24 00:00:00	1982-04-14	1982-04-14 00:00:00	32020		\N	2801	0	444814009	40481087		0
925	53	28060	1967-11-29	1967-11-29 00:00:00	1967-12-09	1967-12-09 00:00:00	32020		\N	3660	0	43878008	28060		0
1062	63	260139	2000-11-22	2000-11-22 00:00:00	2000-11-29	2000-11-29 00:00:00	32020		\N	4284	0	10509002	260139		0
1195	69	372328	1947-11-05	1947-11-05 00:00:00	1948-10-06	1948-10-06 00:00:00	32020		\N	4618	0	65363002	372328		0
1357	80	40481087	2017-04-12	2017-04-12 00:00:00	2017-05-03	2017-05-03 00:00:00	32020		\N	5384	0	444814009	40481087		0
1592	94	4296205	1983-07-14	1983-07-14 00:00:00	1983-08-11	1983-08-11 00:00:00	32020		\N	6300	0	403191005	4296205		0
1689	97	81893	1984-01-05	1984-01-05 00:00:00	\N	\N	32020		\N	6607	0	64766004	81893		0
1878	110	40481087	2013-07-29	2013-07-29 00:00:00	2013-08-12	2013-08-12 00:00:00	32020		\N	7337	0	444814009	40481087		0
2021	117	40481087	1995-01-07	1995-01-07 00:00:00	1995-01-28	1995-01-28 00:00:00	32020		\N	7775	0	444814009	40481087		0
2228	129	40481087	2008-05-13	2008-05-13 00:00:00	2008-06-03	2008-06-03 00:00:00	32020		\N	8708	0	444814009	40481087		0
2353	137	28060	1985-11-10	1985-11-10 00:00:00	1985-11-17	1985-11-17 00:00:00	32020		\N	9196	0	43878008	28060		0
2544	149	260139	1999-03-29	1999-03-29 00:00:00	1999-04-05	1999-04-05 00:00:00	32020		\N	10049	0	10509002	260139		0
2706	158	40481087	1952-10-31	1952-10-31 00:00:00	1952-11-21	1952-11-21 00:00:00	32020		\N	10764	0	444814009	40481087		0
2851	164	372328	1967-12-24	1967-12-24 00:00:00	1968-06-10	1968-06-10 00:00:00	32020		\N	11290	0	65363002	372328		0
3025	177	40481087	1985-12-29	1985-12-29 00:00:00	1986-01-05	1986-01-05 00:00:00	32020		\N	11959	0	444814009	40481087		0
3183	186	4084167	1991-07-18	1991-07-18 00:00:00	1991-07-18	1991-07-18 00:00:00	32020		\N	12650	0	241929008	4084167		0
3349	192	78272	1987-02-04	1987-02-04 00:00:00	1987-03-04	1987-03-04 00:00:00	32020		\N	13218	0	70704007	78272		0
3532	202	260139	2013-06-10	2013-06-10 00:00:00	2013-06-17	2013-06-17 00:00:00	32020		\N	13888	0	10509002	260139		0
3693	211	134438	1996-10-11	1996-10-11 00:00:00	1997-10-06	1997-10-06 00:00:00	32020		\N	14390	0	40275004	134438		0
3848	222	260139	1965-10-31	1965-10-31 00:00:00	1965-11-07	1965-11-07 00:00:00	32020		\N	14936	0	10509002	260139		0
4016	232	4112343	1981-03-17	1981-03-17 00:00:00	1981-03-30	1981-03-30 00:00:00	32020		\N	15636	0	195662009	4112343		0
4203	244	260139	1993-07-02	1993-07-02 00:00:00	1993-07-09	1993-07-09 00:00:00	32020		\N	16286	0	10509002	260139		0
4358	254	40481087	1977-07-28	1977-07-28 00:00:00	1977-08-18	1977-08-18 00:00:00	32020		\N	16924	0	444814009	40481087		0
4512	264	40481087	1965-06-01	1965-06-01 00:00:00	1965-06-08	1965-06-08 00:00:00	32020		\N	17511	0	444814009	40481087		0
4699	276	40481087	2001-10-03	2001-10-03 00:00:00	2001-10-24	2001-10-24 00:00:00	32020		\N	18432	0	444814009	40481087		0
4849	286	40481087	1968-09-09	1968-09-09 00:00:00	1968-09-30	1968-09-30 00:00:00	32020		\N	19053	0	444814009	40481087		0
5015	295	260139	1990-04-02	1990-04-02 00:00:00	1990-04-09	1990-04-09 00:00:00	32020		\N	19632	0	10509002	260139		0
5182	304	260139	1965-10-31	1965-10-31 00:00:00	1965-11-14	1965-11-14 00:00:00	32020		\N	20216	0	10509002	260139		0
5360	316	4112343	1939-09-14	1939-09-14 00:00:00	1939-09-27	1939-09-27 00:00:00	32020		\N	20894	0	195662009	4112343		0
5542	327	372328	1972-12-22	1972-12-22 00:00:00	1973-01-05	1973-01-05 00:00:00	32020		\N	21595	0	65363002	372328		0
5684	334	40480160	2005-09-03	2005-09-03 00:00:00	2005-11-02	2005-11-02 00:00:00	32020		\N	22115	0	443165006	40480160		0
5845	343	40481087	2010-10-14	2010-10-14 00:00:00	2010-10-21	2010-10-21 00:00:00	32020		\N	22863	0	444814009	40481087		0
6007	352	372328	1983-03-12	1983-03-12 00:00:00	1983-07-04	1983-07-04 00:00:00	32020		\N	23440	0	65363002	372328		0
6172	363	40481087	2008-04-18	2008-04-18 00:00:00	2008-05-02	2008-05-02 00:00:00	32020		\N	24105	0	444814009	40481087		0
6338	372	378001	2001-05-25	2001-05-25 00:00:00	2001-06-24	2001-06-24 00:00:00	32020		\N	24789	0	62106007	378001		0
6557	387	40481087	1984-01-15	1984-01-15 00:00:00	1984-01-29	1984-01-29 00:00:00	32020		\N	25489	0	444814009	40481087		0
6670	394	40481087	1926-11-03	1926-11-03 00:00:00	1926-11-24	1926-11-24 00:00:00	32020		\N	25836	0	444814009	40481087		0
6844	403	375671	1941-10-20	1941-10-20 00:00:00	1941-11-19	1941-11-19 00:00:00	32020		\N	26537	0	62564004	375671		0
7003	411	260139	1982-06-01	1982-06-01 00:00:00	1982-06-15	1982-06-15 00:00:00	32020		\N	27255	0	10509002	260139		0
7174	422	4112343	1993-01-29	1993-01-29 00:00:00	1993-02-08	1993-02-08 00:00:00	32020		\N	27909	0	195662009	4112343		0
7334	431	40481087	1996-07-09	1996-07-09 00:00:00	1996-07-23	1996-07-23 00:00:00	32020		\N	28624	0	444814009	40481087		0
7509	442	260139	1974-12-18	1974-12-18 00:00:00	1974-12-25	1974-12-25 00:00:00	32020		\N	29293	0	10509002	260139		0
7675	450	4112343	2017-04-25	2017-04-25 00:00:00	2017-05-05	2017-05-05 00:00:00	32020		\N	30009	0	195662009	4112343		0
7843	458	40481087	2015-08-31	2015-08-31 00:00:00	2015-09-14	2015-09-14 00:00:00	32020		\N	30651	0	444814009	40481087		0
8021	469	40481087	1938-03-28	1938-03-28 00:00:00	1938-04-18	1938-04-18 00:00:00	32020		\N	31244	0	444814009	40481087		0
8187	479	4155034	1967-12-15	1967-12-15 00:00:00	1968-01-05	1968-01-05 00:00:00	32020		\N	31854	0	283371005	4155034		0
8340	486	4285898	1998-11-14	1998-11-14 00:00:00	\N	\N	32020		\N	32508	0	68496003	4285898		0
8505	495	40481087	2018-09-27	2018-09-27 00:00:00	2018-10-18	2018-10-18 00:00:00	32020		\N	33084	0	444814009	40481087		0
8682	507	378419	2010-09-17	2010-09-17 00:00:00	\N	\N	32020		\N	33959	0	26929004	378419		0
8855	518	375671	1989-10-18	1989-10-18 00:00:00	1989-11-17	1989-11-17 00:00:00	32020		\N	34593	0	62564004	375671		0
8996	526	40481087	2000-10-29	2000-10-29 00:00:00	2000-11-12	2000-11-12 00:00:00	32020		\N	35052	0	444814009	40481087		0
9203	545	4116491	2017-09-27	2017-09-27 00:00:00	2017-11-15	2017-11-15 00:00:00	32020		\N	36049	0	301011002	4116491		0
9326	550	4112343	2001-05-29	2001-05-29 00:00:00	2001-06-06	2001-06-06 00:00:00	32020		\N	36456	0	195662009	4112343		0
9507	564	4152936	1996-06-21	1996-06-21 00:00:00	1996-07-12	1996-07-12 00:00:00	32020		\N	37341	0	283385000	4152936		0
9659	572	28060	1954-05-24	1954-05-24 00:00:00	1954-06-05	1954-06-05 00:00:00	32020		\N	37893	0	43878008	28060		0
9824	580	40481087	1956-10-16	1956-10-16 00:00:00	1956-10-23	1956-10-23 00:00:00	32020		\N	38377	0	444814009	40481087		0
10052	596	4278672	1953-09-18	1953-09-18 00:00:00	1953-11-17	1953-11-17 00:00:00	32020		\N	39390	0	65966004	4278672		0
10156	601	4112343	1971-01-11	1971-01-11 00:00:00	1971-01-23	1971-01-23 00:00:00	32020		\N	39731	0	195662009	4112343		0
10324	609	40481087	2010-01-08	2010-01-08 00:00:00	2010-01-15	2010-01-15 00:00:00	32020		\N	40442	0	444814009	40481087		0
10489	616	4112343	1974-12-11	1974-12-11 00:00:00	1974-12-23	1974-12-23 00:00:00	32020		\N	41111	0	195662009	4112343		0
30	2	4112343	1985-07-26	1985-07-26 00:00:00	1985-08-06	1985-08-06 00:00:00	32020		\N	141	0	195662009	4112343		0
218	11	4112343	1963-06-13	1963-06-13 00:00:00	1963-06-21	1963-06-21 00:00:00	32020		\N	970	0	195662009	4112343		0
362	18	40481087	1974-06-13	1974-06-13 00:00:00	1974-06-20	1974-06-20 00:00:00	32020		\N	1384	0	444814009	40481087		0
542	32	40481087	1991-06-01	1991-06-01 00:00:00	1991-06-15	1991-06-15 00:00:00	32020		\N	2199	0	444814009	40481087		0
715	40	4112343	2016-02-23	2016-02-23 00:00:00	2016-03-04	2016-03-04 00:00:00	32020		\N	2886	0	195662009	4112343		0
926	53	4112343	1977-05-23	1977-05-23 00:00:00	1977-05-31	1977-05-31 00:00:00	32020		\N	3661	0	195662009	4112343		0
1063	63	4294548	1962-07-17	1962-07-17 00:00:00	1962-08-07	1962-08-07 00:00:00	32020		\N	4241	0	75498004	4294548		0
1196	70	260139	2007-12-03	2007-12-03 00:00:00	2007-12-10	2007-12-10 00:00:00	32020		\N	4745	0	10509002	260139		0
1358	80	4112343	1947-12-16	1947-12-16 00:00:00	1947-12-28	1947-12-28 00:00:00	32020		\N	5437	0	195662009	4112343		0
1593	94	260139	2015-11-30	2015-11-30 00:00:00	2015-12-14	2015-12-14 00:00:00	32020		\N	6347	0	10509002	260139		0
1690	97	4310024	1983-10-07	1983-10-07 00:00:00	\N	\N	32020		\N	6607	0	424802006	4310024		0
1879	111	4112343	1979-07-28	1979-07-28 00:00:00	1979-08-10	1979-08-10 00:00:00	32020		\N	7414	0	195662009	4112343		0
2022	117	260139	1984-11-29	1984-11-29 00:00:00	1984-12-06	1984-12-06 00:00:00	32020		\N	7779	0	10509002	260139		0
2229	129	4112343	1996-12-23	1996-12-23 00:00:00	1997-01-03	1997-01-03 00:00:00	32020		\N	8675	0	195662009	4112343		0
2354	137	40481087	1978-10-30	1978-10-30 00:00:00	1978-11-06	1978-11-06 00:00:00	32020		\N	9129	0	444814009	40481087		0
2545	149	28060	1943-11-08	1943-11-08 00:00:00	1943-11-21	1943-11-21 00:00:00	32020		\N	10031	0	43878008	28060		0
2707	158	40481087	1948-07-05	1948-07-05 00:00:00	1948-07-19	1948-07-19 00:00:00	32020		\N	10840	0	444814009	40481087		0
2852	164	4112343	2000-05-30	2000-05-30 00:00:00	2000-06-08	2000-06-08 00:00:00	32020		\N	11246	0	195662009	4112343		0
3026	177	40481087	1976-05-07	1976-05-07 00:00:00	1976-05-14	1976-05-14 00:00:00	32020		\N	11970	0	444814009	40481087		0
3184	186	4134304	1981-09-30	1981-09-30 00:00:00	1981-10-29	1981-10-29 00:00:00	32020		\N	12649	0	263102004	4134304		0
3350	192	381316	2014-07-02	2014-07-02 00:00:00	\N	\N	32020		\N	13209	0	230690007	381316		0
3533	202	78272	1940-05-02	1940-05-02 00:00:00	1940-05-23	1940-05-23 00:00:00	32020		\N	13879	0	70704007	78272		0
3694	212	260139	1980-08-27	1980-08-27 00:00:00	1980-09-03	1980-09-03 00:00:00	32020		\N	14466	0	10509002	260139		0
3849	222	4310024	1986-01-03	1986-01-03 00:00:00	\N	\N	32020		\N	14925	0	424802006	4310024		0
4017	232	4285898	1982-01-11	1982-01-11 00:00:00	\N	\N	32020		\N	15636	0	68496003	4285898		0
4204	244	260139	1926-12-20	1926-12-20 00:00:00	1926-12-27	1926-12-27 00:00:00	32020		\N	16262	0	10509002	260139		0
4359	254	4283893	1993-03-08	1993-03-08 00:00:00	1993-04-05	1993-04-05 00:00:00	32020		\N	16908	0	36971009	4283893		0
4513	264	40481087	1980-09-08	1980-09-08 00:00:00	1980-09-22	1980-09-22 00:00:00	32020		\N	17572	0	444814009	40481087		0
4700	276	4112343	1993-10-12	1993-10-12 00:00:00	1993-10-20	1993-10-20 00:00:00	32020		\N	18408	0	195662009	4112343		0
4850	286	40481087	2011-01-06	2011-01-06 00:00:00	2011-01-27	2011-01-27 00:00:00	32020		\N	19095	0	444814009	40481087		0
5036	297	260139	2010-02-12	2010-02-12 00:00:00	2010-02-19	2010-02-19 00:00:00	32020		\N	19789	0	10509002	260139		0
5183	304	4283893	1974-06-25	1974-06-25 00:00:00	1974-11-05	1974-11-05 00:00:00	32020		\N	20218	0	36971009	4283893		0
5361	316	4112343	1936-07-19	1936-07-19 00:00:00	1936-07-30	1936-07-30 00:00:00	32020		\N	20959	0	195662009	4112343		0
5543	327	257012	1982-11-17	1982-11-17 00:00:00	\N	\N	32020		\N	21605	0	40055000	257012		0
5685	334	4278672	2005-09-03	2005-09-03 00:00:00	2005-11-02	2005-11-02 00:00:00	32020		\N	22115	0	65966004	4278672		0
5846	343	192671	2005-11-12	2005-11-12 00:00:00	\N	\N	32020		\N	22971	0	K92.2	35208414		0
6008	352	4112343	1994-08-31	1994-08-31 00:00:00	1994-09-09	1994-09-09 00:00:00	32020		\N	23438	0	195662009	4112343		0
6173	363	40481087	1980-05-19	1980-05-19 00:00:00	1980-06-09	1980-06-09 00:00:00	32020		\N	24125	0	444814009	40481087		0
6339	372	260139	1980-02-05	1980-02-05 00:00:00	1980-02-12	1980-02-12 00:00:00	32020		\N	24756	0	10509002	260139		0
6558	387	372328	1977-12-22	1977-12-22 00:00:00	1978-08-11	1978-08-11 00:00:00	32020		\N	25492	0	65363002	372328		0
6671	394	4113008	1938-07-25	1938-07-25 00:00:00	1938-08-08	1938-08-08 00:00:00	32020		\N	25913	0	284549007	4113008		0
6845	403	40481087	1964-10-05	1964-10-05 00:00:00	1964-10-19	1964-10-19 00:00:00	32020		\N	26513	0	444814009	40481087		0
7004	411	4112343	2001-02-24	2001-02-24 00:00:00	2001-03-08	2001-03-08 00:00:00	32020		\N	27263	0	195662009	4112343		0
7175	422	40481087	1974-01-23	1974-01-23 00:00:00	1974-02-06	1974-02-06 00:00:00	32020		\N	27930	0	444814009	40481087		0
7335	431	4059173	1999-01-22	1999-01-22 00:00:00	1999-04-22	1999-04-22 00:00:00	32020		\N	28596	0	16114001	4059173		0
7510	442	4112343	1981-03-15	1981-03-15 00:00:00	1981-03-28	1981-03-28 00:00:00	32020		\N	29280	0	195662009	4112343		0
7676	450	40481087	1977-04-06	1977-04-06 00:00:00	1977-04-20	1977-04-20 00:00:00	32020		\N	29998	0	444814009	40481087		0
7844	458	80180	2007-06-21	2007-06-21 00:00:00	\N	\N	32020		\N	30661	0	396275006	80180		0
8022	469	372328	1937-06-07	1937-06-07 00:00:00	1937-11-06	1937-11-06 00:00:00	32020		\N	31256	0	65363002	372328		0
8188	479	4112343	1960-06-06	1960-06-06 00:00:00	1960-06-15	1960-06-15 00:00:00	32020		\N	31917	0	195662009	4112343		0
8341	486	4116491	1998-02-11	1998-02-11 00:00:00	1998-04-05	1998-04-05 00:00:00	32020		\N	32508	0	301011002	4116491		0
8506	495	260139	2006-01-22	2006-01-22 00:00:00	2006-01-29	2006-01-29 00:00:00	32020		\N	33042	0	10509002	260139		0
8683	507	80180	1977-10-03	1977-10-03 00:00:00	\N	\N	32020		\N	33914	0	396275006	80180		0
8856	518	40481087	1996-06-06	1996-06-06 00:00:00	1996-06-13	1996-06-13 00:00:00	32020		\N	34614	0	444814009	40481087		0
8997	526	80180	2002-04-12	2002-04-12 00:00:00	\N	\N	32020		\N	35052	0	396275006	80180		0
9204	545	195588	2017-12-13	2017-12-13 00:00:00	2018-01-22	2018-01-22 00:00:00	32020		\N	36120	0	38822007	195588		0
9327	550	260139	1974-10-25	1974-10-25 00:00:00	1974-11-08	1974-11-08 00:00:00	32020		\N	36491	0	10509002	260139		0
9508	564	195588	1991-10-11	1991-10-11 00:00:00	1991-11-17	1991-11-17 00:00:00	32020		\N	37366	0	38822007	195588		0
9660	572	40481087	2007-04-06	2007-04-06 00:00:00	2007-04-13	2007-04-13 00:00:00	32020		\N	37876	0	444814009	40481087		0
9825	580	378001	2017-04-19	2017-04-19 00:00:00	2017-06-18	2017-06-18 00:00:00	32020		\N	38456	0	62106007	378001		0
10053	596	40481087	1961-07-16	1961-07-16 00:00:00	1961-07-30	1961-07-30 00:00:00	32020		\N	39309	0	444814009	40481087		0
10157	601	4218389	1996-08-20	1996-08-20 00:00:00	1996-09-17	1996-09-17 00:00:00	32020		\N	39685	0	39848009	4218389		0
10325	609	4112343	1999-03-15	1999-03-15 00:00:00	1999-03-28	1999-03-28 00:00:00	32020		\N	40433	0	195662009	4112343		0
10490	616	192671	2001-03-05	2001-03-05 00:00:00	\N	\N	32020		\N	41110	0	K92.2	35208414		0
31	2	4109685	1952-07-13	1952-07-13 00:00:00	1952-07-27	1952-07-27 00:00:00	32020		\N	113	0	284551006	4109685		0
219	11	40481087	1998-02-01	1998-02-01 00:00:00	1998-02-22	1998-02-22 00:00:00	32020		\N	955	0	444814009	40481087		0
363	19	260139	1997-08-25	1997-08-25 00:00:00	1997-09-01	1997-09-01 00:00:00	32020		\N	1507	0	10509002	260139		0
543	32	81893	1985-09-11	1985-09-11 00:00:00	\N	\N	32020		\N	2240	0	64766004	81893		0
716	40	260139	1985-05-29	1985-05-29 00:00:00	1985-06-12	1985-06-12 00:00:00	32020		\N	2871	0	10509002	260139		0
927	53	4278672	1974-05-05	1974-05-05 00:00:00	1974-06-04	1974-06-04 00:00:00	32020		\N	3633	0	65966004	4278672		0
1064	63	28060	1960-11-18	1960-11-18 00:00:00	1960-11-30	1960-11-30 00:00:00	32020		\N	4300	0	43878008	28060		0
1197	70	4112343	1983-05-06	1983-05-06 00:00:00	1983-05-19	1983-05-19 00:00:00	32020		\N	4726	0	195662009	4112343		0
1359	80	80180	1974-09-16	1974-09-16 00:00:00	\N	\N	32020		\N	5404	0	396275006	80180		0
1594	94	260139	1958-02-27	1958-02-27 00:00:00	1958-03-13	1958-03-13 00:00:00	32020		\N	6352	0	10509002	260139		0
1691	97	30753	1984-11-30	1984-11-30 00:00:00	\N	\N	32020		\N	6607	0	16761005	30753		0
1880	111	4112343	1994-09-21	1994-09-21 00:00:00	1994-09-30	1994-09-30 00:00:00	32020		\N	7364	0	195662009	4112343		0
2036	119	195588	2008-12-13	2008-12-13 00:00:00	2009-02-07	2009-02-07 00:00:00	32020		\N	7927	0	38822007	195588		0
2230	129	40481087	1996-06-02	1996-06-02 00:00:00	1996-06-09	1996-06-09 00:00:00	32020		\N	8671	0	444814009	40481087		0
2371	140	378001	1982-02-16	1982-02-16 00:00:00	1982-03-18	1982-03-18 00:00:00	32020		\N	9416	0	62106007	378001		0
2546	149	192671	1982-12-09	1982-12-09 00:00:00	\N	\N	32020		\N	10104	0	K92.2	35208414		0
2708	158	78272	1950-02-17	1950-02-17 00:00:00	1950-03-10	1950-03-10 00:00:00	32020		\N	10848	0	70704007	78272		0
2853	164	40481087	1996-07-11	1996-07-11 00:00:00	1996-08-01	1996-08-01 00:00:00	32020		\N	11288	0	444814009	40481087		0
3027	177	28060	1969-03-13	1969-03-13 00:00:00	1969-03-24	1969-03-24 00:00:00	32020		\N	12003	0	43878008	28060		0
3185	186	4084167	1975-01-08	1975-01-08 00:00:00	1975-01-09	1975-01-09 00:00:00	32020		\N	12648	0	241929008	4084167		0
3351	192	78272	1944-04-24	1944-04-24 00:00:00	1944-05-15	1944-05-15 00:00:00	32020		\N	13214	0	70704007	78272		0
3534	202	28060	1989-07-02	1989-07-02 00:00:00	1989-07-13	1989-07-13 00:00:00	32020		\N	13843	0	43878008	28060		0
3695	212	372328	1975-02-23	1975-02-23 00:00:00	1976-03-06	1976-03-06 00:00:00	32020		\N	14429	0	65363002	372328		0
3850	222	4218389	1966-11-15	1966-11-15 00:00:00	1966-12-20	1966-12-20 00:00:00	32020		\N	14933	0	39848009	4218389		0
4018	232	80180	1982-12-07	1982-12-07 00:00:00	\N	\N	32020		\N	15636	0	396275006	80180		0
4205	244	260139	1946-01-29	1946-01-29 00:00:00	1946-02-05	1946-02-05 00:00:00	32020		\N	16282	0	10509002	260139		0
4360	254	40481087	1988-07-26	1988-07-26 00:00:00	1988-08-09	1988-08-09 00:00:00	32020		\N	16960	0	444814009	40481087		0
4514	264	81151	1952-06-21	1952-06-21 00:00:00	1952-07-19	1952-07-19 00:00:00	32020		\N	17533	0	44465007	81151		0
4701	276	78272	2011-08-10	2011-08-10 00:00:00	2011-08-24	2011-08-24 00:00:00	32020		\N	18391	0	70704007	78272		0
4851	286	4142905	2006-10-16	2006-10-16 00:00:00	2006-12-15	2006-12-15 00:00:00	32020		\N	19043	0	33737001	4142905		0
5037	297	40481087	1974-12-27	1974-12-27 00:00:00	1975-01-10	1975-01-10 00:00:00	32020		\N	19794	0	444814009	40481087		0
5184	304	40481087	1957-06-07	1957-06-07 00:00:00	1957-06-21	1957-06-21 00:00:00	32020		\N	20214	0	444814009	40481087		0
5362	316	40481087	1958-12-27	1958-12-27 00:00:00	1959-01-03	1959-01-03 00:00:00	32020		\N	20961	0	444814009	40481087		0
5544	328	40481087	1991-07-14	1991-07-14 00:00:00	1991-08-04	1991-08-04 00:00:00	32020		\N	21672	0	444814009	40481087		0
5686	334	40481087	1994-01-31	1994-01-31 00:00:00	1994-02-07	1994-02-07 00:00:00	32020		\N	22166	0	444814009	40481087		0
5847	343	4084167	1971-02-25	1971-02-25 00:00:00	1971-02-25	1971-02-25 00:00:00	32020		\N	22848	0	241929008	4084167		0
6009	352	257012	1984-04-03	1984-04-03 00:00:00	\N	\N	32020		\N	23442	0	40055000	257012		0
6174	363	40481087	2003-09-12	2003-09-12 00:00:00	2003-10-03	2003-10-03 00:00:00	32020		\N	24098	0	444814009	40481087		0
6340	372	260139	2004-04-14	2004-04-14 00:00:00	2004-04-28	2004-04-28 00:00:00	32020		\N	24717	0	10509002	260139		0
6559	387	372328	1976-01-18	1976-01-18 00:00:00	1976-02-01	1976-02-01 00:00:00	32020		\N	25491	0	65363002	372328		0
6672	394	40481087	1985-08-20	1985-08-20 00:00:00	1985-09-03	1985-09-03 00:00:00	32020		\N	25891	0	444814009	40481087		0
6846	403	40481087	1931-07-14	1931-07-14 00:00:00	1931-07-21	1931-07-21 00:00:00	32020		\N	26539	0	444814009	40481087		0
7005	411	4237458	1980-08-29	1980-08-29 00:00:00	1980-09-28	1980-09-28 00:00:00	32020		\N	27403	0	58150001	4237458		0
7176	422	4112343	1967-07-13	1967-07-13 00:00:00	1967-07-22	1967-07-22 00:00:00	32020		\N	27952	0	195662009	4112343		0
7336	431	4152936	1985-09-18	1985-09-18 00:00:00	1985-10-02	1985-10-02 00:00:00	32020		\N	28595	0	283385000	4152936		0
7511	442	4112343	1947-09-24	1947-09-24 00:00:00	1947-10-06	1947-10-06 00:00:00	32020		\N	29290	0	195662009	4112343		0
7677	450	378001	2006-07-12	2006-07-12 00:00:00	2006-08-11	2006-08-11 00:00:00	32020		\N	30055	0	62106007	378001		0
7845	458	28060	1978-05-10	1978-05-10 00:00:00	1978-05-18	1978-05-18 00:00:00	32020		\N	30664	0	43878008	28060		0
8023	469	4112343	1951-05-27	1951-05-27 00:00:00	1951-06-07	1951-06-07 00:00:00	32020		\N	31324	0	195662009	4112343		0
8189	479	4112343	2004-07-10	2004-07-10 00:00:00	2004-07-21	2004-07-21 00:00:00	32020		\N	31881	0	195662009	4112343		0
8342	486	30753	1998-06-17	1998-06-17 00:00:00	\N	\N	32020		\N	32508	0	16761005	30753		0
8507	495	4112343	1978-03-13	1978-03-13 00:00:00	1978-03-22	1978-03-22 00:00:00	32020		\N	33078	0	195662009	4112343		0
8684	507	260139	1999-07-24	1999-07-24 00:00:00	1999-08-07	1999-08-07 00:00:00	32020		\N	33900	0	10509002	260139		0
8857	518	192671	2007-05-21	2007-05-21 00:00:00	\N	\N	32020		\N	34628	0	K92.2	35208414		0
8998	526	40481087	2006-05-10	2006-05-10 00:00:00	2006-05-24	2006-05-24 00:00:00	32020		\N	35066	0	444814009	40481087		0
9205	545	4056621	2017-12-13	2017-12-13 00:00:00	\N	\N	32020		\N	36120	0	197927001	4056621		0
9328	550	260139	1975-12-14	1975-12-14 00:00:00	1975-12-28	1975-12-28 00:00:00	32020		\N	36518	0	10509002	260139		0
9509	564	4155034	2007-09-04	2007-09-04 00:00:00	2007-09-25	2007-09-25 00:00:00	32020		\N	37343	0	283371005	4155034		0
9661	572	4310024	1989-11-13	1989-11-13 00:00:00	\N	\N	32020		\N	37863	0	424802006	4310024		0
9826	580	260139	2017-04-29	2017-04-29 00:00:00	2017-05-13	2017-05-13 00:00:00	32020		\N	38390	0	10509002	260139		0
10054	596	260139	1958-02-26	1958-02-26 00:00:00	1958-03-12	1958-03-12 00:00:00	32020		\N	39351	0	10509002	260139		0
10158	601	40481087	1996-02-17	1996-02-17 00:00:00	1996-02-24	1996-02-24 00:00:00	32020		\N	39741	0	444814009	40481087		0
10326	609	4266809	2001-04-22	2001-04-22 00:00:00	\N	\N	32020		\N	40433	0	397881000	4266809		0
10491	616	40481087	1990-09-12	1990-09-12 00:00:00	1990-09-19	1990-09-19 00:00:00	32020		\N	41119	0	444814009	40481087		0
32	2	40481087	1967-12-27	1967-12-27 00:00:00	1968-01-03	1968-01-03 00:00:00	32020		\N	104	0	444814009	40481087		0
220	11	4112343	1970-06-01	1970-06-01 00:00:00	1970-06-13	1970-06-13 00:00:00	32020		\N	971	0	195662009	4112343		0
364	19	40481087	1978-02-13	1978-02-13 00:00:00	1978-02-20	1978-02-20 00:00:00	32020		\N	1451	0	444814009	40481087		0
544	32	30753	1986-07-08	1986-07-08 00:00:00	\N	\N	32020		\N	2240	0	16761005	30753		0
717	40	78272	1994-11-19	1994-11-19 00:00:00	1994-12-03	1994-12-03 00:00:00	32020		\N	2864	0	70704007	78272		0
928	53	372328	1967-01-02	1967-01-02 00:00:00	1967-04-19	1967-04-19 00:00:00	32020		\N	3698	0	65363002	372328		0
1065	63	40481087	1998-09-22	1998-09-22 00:00:00	1998-09-29	1998-09-29 00:00:00	32020		\N	4303	0	444814009	40481087		0
1198	70	80180	1983-06-27	1983-06-27 00:00:00	\N	\N	32020		\N	4726	0	396275006	80180		0
1360	80	260139	2018-04-03	2018-04-03 00:00:00	2018-04-10	2018-04-10 00:00:00	32020		\N	5465	0	10509002	260139		0
1595	94	257012	1976-06-09	1976-06-09 00:00:00	\N	\N	32020		\N	6355	0	40055000	257012		0
1692	97	260139	1966-04-21	1966-04-21 00:00:00	1966-04-28	1966-04-28 00:00:00	32020		\N	6584	0	10509002	260139		0
1881	111	40481087	2012-06-07	2012-06-07 00:00:00	2012-06-28	2012-06-28 00:00:00	32020		\N	7375	0	444814009	40481087		0
2037	119	4112343	1958-11-08	1958-11-08 00:00:00	1958-11-18	1958-11-18 00:00:00	32020		\N	7882	0	195662009	4112343		0
2231	129	260139	1994-08-25	1994-08-25 00:00:00	1994-09-08	1994-09-08 00:00:00	32020		\N	8707	0	10509002	260139		0
2372	140	40481087	1970-02-05	1970-02-05 00:00:00	1970-02-12	1970-02-12 00:00:00	32020		\N	9350	0	444814009	40481087		0
2547	149	4146173	1957-04-27	1957-04-27 00:00:00	1957-06-26	1957-06-26 00:00:00	32020		\N	10032	0	307731004	4146173		0
2709	158	40481087	1949-10-20	1949-10-20 00:00:00	1949-11-10	1949-11-10 00:00:00	32020		\N	10842	0	444814009	40481087		0
2854	164	80180	2009-02-11	2009-02-11 00:00:00	\N	\N	32020		\N	11276	0	396275006	80180		0
3028	177	4112343	1991-10-28	1991-10-28 00:00:00	1991-11-09	1991-11-09 00:00:00	32020		\N	11993	0	195662009	4112343		0
3186	186	40481087	1989-12-14	1989-12-14 00:00:00	1989-12-28	1989-12-28 00:00:00	32020		\N	12615	0	444814009	40481087		0
3352	192	4112343	2015-11-16	2015-11-16 00:00:00	2015-11-28	2015-11-28 00:00:00	32020		\N	13233	0	195662009	4112343		0
3535	202	260139	1964-03-11	1964-03-11 00:00:00	1964-03-18	1964-03-18 00:00:00	32020		\N	13842	0	10509002	260139		0
3697	212	4029498	2012-03-10	2012-03-10 00:00:00	\N	\N	32020		\N	14440	0	128613002	4029498		0
3851	222	4112343	1967-11-30	1967-11-30 00:00:00	1967-12-07	1967-12-07 00:00:00	32020		\N	14883	0	195662009	4112343		0
4019	232	40481087	1964-07-19	1964-07-19 00:00:00	1964-08-02	1964-08-02 00:00:00	32020		\N	15634	0	444814009	40481087		0
4206	244	4112343	1934-03-29	1934-03-29 00:00:00	1934-04-08	1934-04-08 00:00:00	32020		\N	16341	0	195662009	4112343		0
4361	254	260139	1962-10-29	1962-10-29 00:00:00	1962-11-12	1962-11-12 00:00:00	32020		\N	16955	0	10509002	260139		0
4515	264	40481087	1967-10-02	1967-10-02 00:00:00	1967-10-16	1967-10-16 00:00:00	32020		\N	17538	0	444814009	40481087		0
4702	276	80180	2013-01-16	2013-01-16 00:00:00	\N	\N	32020		\N	18391	0	396275006	80180		0
4852	286	378001	1977-12-05	1977-12-05 00:00:00	1978-01-04	1978-01-04 00:00:00	32020		\N	19039	0	62106007	378001		0
5038	297	4112343	1960-03-20	1960-03-20 00:00:00	1960-04-02	1960-04-02 00:00:00	32020		\N	19788	0	195662009	4112343		0
5191	307	4142905	1994-08-08	1994-08-08 00:00:00	1994-10-07	1994-10-07 00:00:00	32020		\N	20397	0	33737001	4142905		0
5363	316	40481087	1952-12-01	1952-12-01 00:00:00	1952-12-22	1952-12-22 00:00:00	32020		\N	20960	0	444814009	40481087		0
5545	328	439777	2004-10-22	2004-10-22 00:00:00	\N	\N	32020		\N	21677	0	271737000	439777		0
5687	334	4112343	1965-01-13	1965-01-13 00:00:00	1965-01-23	1965-01-23 00:00:00	32020		\N	22146	0	195662009	4112343		0
5848	343	40481087	2016-09-24	2016-09-24 00:00:00	2016-10-08	2016-10-08 00:00:00	32020		\N	22872	0	444814009	40481087		0
6010	352	260139	1996-10-03	1996-10-03 00:00:00	1996-10-10	1996-10-10 00:00:00	32020		\N	23479	0	10509002	260139		0
6175	363	257012	1973-12-29	1973-12-29 00:00:00	\N	\N	32020		\N	24083	0	40055000	257012		0
6341	372	4112343	1973-02-09	1973-02-09 00:00:00	1973-02-22	1973-02-22 00:00:00	32020		\N	24764	0	195662009	4112343		0
6560	387	260139	1980-04-16	1980-04-16 00:00:00	1980-04-23	1980-04-23 00:00:00	32020		\N	25488	0	10509002	260139		0
6673	394	4134304	1922-03-21	1922-03-21 00:00:00	1922-06-19	1922-06-19 00:00:00	32020		\N	25926	0	263102004	4134304		0
6847	403	28060	1926-03-10	1926-03-10 00:00:00	1926-03-22	1926-03-22 00:00:00	32020		\N	26489	0	43878008	28060		0
7006	411	4048171	1961-02-27	1961-02-27 00:00:00	1993-07-17	1993-07-17 00:00:00	32020		\N	27318	0	232353008	4048171		0
7177	422	40481087	1965-05-31	1965-05-31 00:00:00	1965-06-07	1965-06-07 00:00:00	32020		\N	27946	0	444814009	40481087		0
7337	431	40481087	1972-06-30	1972-06-30 00:00:00	1972-07-07	1972-07-07 00:00:00	32020		\N	28554	0	444814009	40481087		0
7512	442	192671	1985-09-10	1985-09-10 00:00:00	\N	\N	32020		\N	29414	0	K92.2	35208414		0
7678	450	4112343	2004-07-22	2004-07-22 00:00:00	2004-07-30	2004-07-30 00:00:00	32020		\N	30022	0	195662009	4112343		0
7846	458	4035415	2010-06-25	2010-06-25 00:00:00	2010-07-25	2010-07-25 00:00:00	32020		\N	30615	0	239720000	4035415		0
8024	469	40481087	1990-04-18	1990-04-18 00:00:00	1990-04-25	1990-04-25 00:00:00	32020		\N	31326	0	444814009	40481087		0
8190	480	260139	1941-11-25	1941-11-25 00:00:00	1941-12-02	1941-12-02 00:00:00	32020		\N	32084	0	10509002	260139		0
8343	486	4266809	1999-03-14	1999-03-14 00:00:00	\N	\N	32020		\N	32508	0	397881000	4266809		0
8508	495	260139	1998-12-08	1998-12-08 00:00:00	1998-12-22	1998-12-22 00:00:00	32020		\N	33083	0	10509002	260139		0
8685	507	378001	1967-02-02	1967-02-02 00:00:00	1967-03-04	1967-03-04 00:00:00	32020		\N	33957	0	62106007	378001		0
8858	518	260139	2015-03-07	2015-03-07 00:00:00	2015-03-21	2015-03-21 00:00:00	32020		\N	34590	0	10509002	260139		0
8999	526	40481087	2009-06-28	2009-06-28 00:00:00	2009-07-19	2009-07-19 00:00:00	32020		\N	35069	0	444814009	40481087		0
9206	545	4278672	2015-10-16	2015-10-16 00:00:00	2016-01-14	2016-01-14 00:00:00	32020		\N	36146	0	65966004	4278672		0
9329	550	260139	1966-08-23	1966-08-23 00:00:00	1966-09-06	1966-09-06 00:00:00	32020		\N	36439	0	10509002	260139		0
9510	564	80180	1995-10-30	1995-10-30 00:00:00	\N	\N	32020		\N	37325	0	396275006	80180		0
9662	572	30753	1991-01-07	1991-01-07 00:00:00	\N	\N	32020		\N	37863	0	16761005	30753		0
9827	580	4152936	1958-04-26	1958-04-26 00:00:00	1958-05-10	1958-05-10 00:00:00	32020		\N	38402	0	283385000	4152936		0
10055	597	30753	1986-03-23	1986-03-23 00:00:00	\N	\N	32020		\N	39458	0	16761005	30753		0
10159	601	78272	1980-09-15	1980-09-15 00:00:00	1980-09-29	1980-09-29 00:00:00	32020		\N	39683	0	70704007	78272		0
10327	609	80180	2001-04-22	2001-04-22 00:00:00	\N	\N	32020		\N	40433	0	396275006	80180		0
10492	616	260139	2012-11-14	2012-11-14 00:00:00	2012-11-21	2012-11-21 00:00:00	32020		\N	41072	0	10509002	260139		0
33	2	255848	2008-03-15	2008-03-15 00:00:00	\N	\N	32020		\N	148	0	233604007	255848		0
221	11	40481087	2012-08-12	2012-08-12 00:00:00	2012-08-19	2012-08-19 00:00:00	32020		\N	907	0	444814009	40481087		0
365	19	4112343	2014-09-11	2014-09-11 00:00:00	2014-09-22	2014-09-22 00:00:00	32020		\N	1487	0	195662009	4112343		0
545	32	4146173	1979-04-24	1979-04-24 00:00:00	1979-06-23	1979-06-23 00:00:00	32020		\N	2257	0	307731004	4146173		0
718	40	4112343	1974-12-21	1974-12-21 00:00:00	1974-12-29	1974-12-29 00:00:00	32020		\N	2879	0	195662009	4112343		0
929	53	257012	2011-10-06	2011-10-06 00:00:00	\N	\N	32020		\N	3644	0	40055000	257012		0
1066	63	4112343	1973-08-27	1973-08-27 00:00:00	1973-09-08	1973-09-08 00:00:00	32020		\N	4242	0	195662009	4112343		0
1199	70	4112343	1958-10-31	1958-10-31 00:00:00	1958-11-13	1958-11-13 00:00:00	32020		\N	4770	0	195662009	4112343		0
1361	80	192671	1974-10-27	1974-10-27 00:00:00	\N	\N	32020		\N	5360	0	K92.2	35208414		0
1596	94	40481087	2010-10-12	2010-10-12 00:00:00	2010-10-19	2010-10-19 00:00:00	32020		\N	6371	0	444814009	40481087		0
1693	97	40481087	2006-05-29	2006-05-29 00:00:00	2006-06-05	2006-06-05 00:00:00	32020		\N	6568	0	444814009	40481087		0
1882	111	4116491	1994-04-27	1994-04-27 00:00:00	1994-06-01	1994-06-01 00:00:00	32020		\N	7373	0	301011002	4116491		0
2038	119	40481087	2000-01-23	2000-01-23 00:00:00	2000-02-13	2000-02-13 00:00:00	32020		\N	7887	0	444814009	40481087		0
2232	129	4112343	2010-08-14	2010-08-14 00:00:00	2010-08-27	2010-08-27 00:00:00	32020		\N	8713	0	195662009	4112343		0
2373	140	28060	1972-08-22	1972-08-22 00:00:00	1972-09-04	1972-09-04 00:00:00	32020		\N	9406	0	43878008	28060		0
2548	149	4112343	2016-12-02	2016-12-02 00:00:00	2016-12-15	2016-12-15 00:00:00	32020		\N	10030	0	195662009	4112343		0
2710	158	81151	1961-12-28	1961-12-28 00:00:00	1962-01-18	1962-01-18 00:00:00	32020		\N	10850	0	44465007	81151		0
2855	164	40481087	1990-05-13	1990-05-13 00:00:00	1990-05-27	1990-05-27 00:00:00	32020		\N	11245	0	444814009	40481087		0
3029	177	80180	2000-05-31	2000-05-31 00:00:00	\N	\N	32020		\N	11990	0	396275006	80180		0
3187	186	4112343	2012-10-17	2012-10-17 00:00:00	2012-10-27	2012-10-27 00:00:00	32020		\N	12638	0	195662009	4112343		0
3353	192	4299128	2014-04-02	2014-04-02 00:00:00	2014-04-16	2014-04-16 00:00:00	32020		\N	13220	0	403192003	4299128		0
3536	202	40481087	1995-02-26	1995-02-26 00:00:00	1995-03-05	1995-03-05 00:00:00	32020		\N	13811	0	444814009	40481087		0
3698	212	380378	2014-11-01	2014-11-01 00:00:00	\N	\N	32020		\N	14441	0	84757009	380378		0
3852	222	28060	1974-03-09	1974-03-09 00:00:00	1974-03-19	1974-03-19 00:00:00	32020		\N	14884	0	43878008	28060		0
4020	232	4296205	1988-11-06	1988-11-06 00:00:00	1988-11-27	1988-11-27 00:00:00	32020		\N	15618	0	403191005	4296205		0
4207	244	378001	1985-09-24	1985-09-24 00:00:00	1985-11-23	1985-11-23 00:00:00	32020		\N	16320	0	62106007	378001		0
4362	254	40481087	1991-11-29	1991-11-29 00:00:00	1991-12-06	1991-12-06 00:00:00	32020		\N	16966	0	444814009	40481087		0
4516	264	40481087	1962-11-01	1962-11-01 00:00:00	1962-11-08	1962-11-08 00:00:00	32020		\N	17591	0	444814009	40481087		0
4703	276	4112343	2006-03-05	2006-03-05 00:00:00	2006-03-17	2006-03-17 00:00:00	32020		\N	18418	0	195662009	4112343		0
4853	286	78272	2008-01-09	2008-01-09 00:00:00	2008-02-06	2008-02-06 00:00:00	32020		\N	19044	0	70704007	78272		0
5039	297	4112343	1967-12-17	1967-12-17 00:00:00	1967-12-30	1967-12-30 00:00:00	32020		\N	19805	0	195662009	4112343		0
5192	307	4218389	1991-06-20	1991-06-20 00:00:00	1991-07-25	1991-07-25 00:00:00	32020		\N	20383	0	39848009	4218389		0
5364	316	40481087	1983-09-07	1983-09-07 00:00:00	1983-09-14	1983-09-14 00:00:00	32020		\N	20867	0	444814009	40481087		0
5546	328	4112343	1989-04-05	1989-04-05 00:00:00	1989-04-15	1989-04-15 00:00:00	32020		\N	21642	0	195662009	4112343		0
5688	334	195588	1964-05-28	1964-05-28 00:00:00	1964-07-20	1964-07-20 00:00:00	32020		\N	22142	0	38822007	195588		0
5849	343	260139	1988-11-25	1988-11-25 00:00:00	1988-12-09	1988-12-09 00:00:00	32020		\N	22920	0	10509002	260139		0
6011	352	4112343	1992-12-27	1992-12-27 00:00:00	1993-01-05	1993-01-05 00:00:00	32020		\N	23449	0	195662009	4112343		0
6176	363	40481087	1981-11-06	1981-11-06 00:00:00	1981-11-27	1981-11-27 00:00:00	32020		\N	24126	0	444814009	40481087		0
6342	372	40481087	1969-10-05	1969-10-05 00:00:00	1969-10-19	1969-10-19 00:00:00	32020		\N	24754	0	444814009	40481087		0
6561	387	4059173	1974-08-26	1974-08-26 00:00:00	1974-10-25	1974-10-25 00:00:00	32020		\N	25455	0	16114001	4059173		0
6674	394	4283893	1961-09-20	1961-09-20 00:00:00	1961-10-25	1961-10-25 00:00:00	32020		\N	25838	0	36971009	4283893		0
6848	403	4156265	1939-10-10	1939-10-10 00:00:00	1939-10-31	1939-10-31 00:00:00	32020		\N	26536	0	370247008	4156265		0
7007	411	40481087	1995-03-29	1995-03-29 00:00:00	1995-04-19	1995-04-19 00:00:00	32020		\N	27262	0	444814009	40481087		0
7178	422	28060	2016-04-28	2016-04-28 00:00:00	2016-05-11	2016-05-11 00:00:00	32020		\N	27942	0	43878008	28060		0
7338	431	195588	1987-12-22	1987-12-22 00:00:00	1988-01-22	1988-01-22 00:00:00	32020		\N	28586	0	38822007	195588		0
7513	442	81151	2010-02-24	2010-02-24 00:00:00	2010-03-24	2010-03-24 00:00:00	32020		\N	29289	0	44465007	81151		0
7679	450	80180	2005-03-10	2005-03-10 00:00:00	\N	\N	32020		\N	30022	0	396275006	80180		0
7847	458	372328	1975-07-11	1975-07-11 00:00:00	1975-08-17	1975-08-17 00:00:00	32020		\N	30652	0	65363002	372328		0
8025	470	80180	1989-06-26	1989-06-26 00:00:00	\N	\N	32020		\N	31402	0	396275006	80180		0
8191	480	260139	1984-03-03	1984-03-03 00:00:00	1984-03-17	1984-03-17 00:00:00	32020		\N	31995	0	10509002	260139		0
8344	486	40481087	1999-11-30	1999-11-30 00:00:00	1999-12-21	1999-12-21 00:00:00	32020		\N	32463	0	444814009	40481087		0
8509	495	4112343	2009-05-25	2009-05-25 00:00:00	2009-06-05	2009-06-05 00:00:00	32020		\N	33074	0	195662009	4112343		0
8686	507	4112343	1961-01-09	1961-01-09 00:00:00	1961-01-22	1961-01-22 00:00:00	32020		\N	33966	0	195662009	4112343		0
8859	518	4027663	1999-06-23	1999-06-23 00:00:00	\N	\N	32020		\N	34645	0	13200003	4027663		0
9000	526	4116491	2004-02-16	2004-02-16 00:00:00	2004-03-28	2004-03-28 00:00:00	32020		\N	35068	0	301011002	4116491		0
9207	545	40481087	1996-12-15	1996-12-15 00:00:00	1997-01-05	1997-01-05 00:00:00	32020		\N	36082	0	444814009	40481087		0
9330	550	40481087	1954-11-20	1954-11-20 00:00:00	1954-12-11	1954-12-11 00:00:00	32020		\N	36452	0	444814009	40481087		0
9511	564	40481087	2012-08-09	2012-08-09 00:00:00	2012-08-23	2012-08-23 00:00:00	32020		\N	37368	0	444814009	40481087		0
9663	572	372328	1954-01-21	1954-01-21 00:00:00	1954-04-02	1954-04-02 00:00:00	32020		\N	37878	0	65363002	372328		0
9828	580	40481087	1975-10-01	1975-10-01 00:00:00	1975-10-08	1975-10-08 00:00:00	32020		\N	38378	0	444814009	40481087		0
10056	597	81151	1985-08-08	1985-08-08 00:00:00	1985-08-22	1985-08-22 00:00:00	32020		\N	39458	0	44465007	81151		0
10174	603	372328	1985-05-31	1985-05-31 00:00:00	1986-11-14	1986-11-14 00:00:00	32020		\N	39979	0	65363002	372328		0
10328	609	257012	1987-08-26	1987-08-26 00:00:00	\N	\N	32020		\N	40457	0	40055000	257012		0
10493	616	375671	1981-04-12	1981-04-12 00:00:00	1981-05-12	1981-05-12 00:00:00	32020		\N	41088	0	62564004	375671		0
34	2	40481087	1926-09-15	1926-09-15 00:00:00	1926-10-06	1926-10-06 00:00:00	32020		\N	150	0	444814009	40481087		0
222	11	78272	1989-09-22	1989-09-22 00:00:00	1989-10-13	1989-10-13 00:00:00	32020		\N	990	0	70704007	78272		0
366	19	80180	1985-05-16	1985-05-16 00:00:00	\N	\N	32020		\N	1541	0	396275006	80180		0
546	32	40481087	2011-05-28	2011-05-28 00:00:00	2011-06-11	2011-06-11 00:00:00	32020		\N	2248	0	444814009	40481087		0
719	40	260139	2002-03-21	2002-03-21 00:00:00	2002-03-28	2002-03-28 00:00:00	32020		\N	2874	0	10509002	260139		0
930	53	4112343	1980-02-19	1980-02-19 00:00:00	1980-02-27	1980-02-27 00:00:00	32020		\N	3662	0	195662009	4112343		0
1067	63	81151	2000-10-15	2000-10-15 00:00:00	2000-10-29	2000-10-29 00:00:00	32020		\N	4298	0	44465007	81151		0
1200	70	4112343	1968-11-28	1968-11-28 00:00:00	1968-12-05	1968-12-05 00:00:00	32020		\N	4718	0	195662009	4112343		0
1362	80	4027663	1964-11-02	1964-11-02 00:00:00	\N	\N	32020		\N	5425	0	13200003	4027663		0
1597	94	28060	1955-10-12	1955-10-12 00:00:00	1955-10-19	1955-10-19 00:00:00	32020		\N	6314	0	43878008	28060		0
1694	97	4294548	1981-12-29	1981-12-29 00:00:00	1982-02-23	1982-02-23 00:00:00	32020		\N	6651	0	75498004	4294548		0
1883	111	372328	1985-12-26	1985-12-26 00:00:00	1986-05-16	1986-05-16 00:00:00	32020		\N	7365	0	65363002	372328		0
2039	119	40481087	1980-08-09	1980-08-09 00:00:00	1980-08-30	1980-08-30 00:00:00	32020		\N	7886	0	444814009	40481087		0
2233	129	40481087	1992-12-21	1992-12-21 00:00:00	1993-01-11	1993-01-11 00:00:00	32020		\N	8684	0	444814009	40481087		0
2374	140	80180	2003-11-14	2003-11-14 00:00:00	\N	\N	32020		\N	9338	0	396275006	80180		0
2565	152	81151	2017-02-26	2017-02-26 00:00:00	2017-03-19	2017-03-19 00:00:00	32020		\N	10295	0	44465007	81151		0
2711	158	4112343	1975-11-01	1975-11-01 00:00:00	1975-11-10	1975-11-10 00:00:00	32020		\N	10794	0	195662009	4112343		0
2856	164	40481087	1991-10-20	1991-10-20 00:00:00	1991-10-27	1991-10-27 00:00:00	32020		\N	11303	0	444814009	40481087		0
3030	177	40481087	2012-11-04	2012-11-04 00:00:00	2012-11-11	2012-11-11 00:00:00	32020		\N	11972	0	444814009	40481087		0
3188	187	40481087	1987-09-06	1987-09-06 00:00:00	1987-09-27	1987-09-27 00:00:00	32020		\N	12743	0	444814009	40481087		0
3354	192	4112343	2018-05-19	2018-05-19 00:00:00	2018-05-29	2018-05-29 00:00:00	32020		\N	13210	0	195662009	4112343		0
3537	202	4155034	1971-07-29	1971-07-29 00:00:00	1971-08-12	1971-08-12 00:00:00	32020		\N	13907	0	283371005	4155034		0
3699	212	40481087	1975-04-23	1975-04-23 00:00:00	1975-05-07	1975-05-07 00:00:00	32020		\N	14462	0	444814009	40481087		0
3853	222	4283893	1973-07-06	1973-07-06 00:00:00	1973-09-07	1973-09-07 00:00:00	32020		\N	14937	0	36971009	4283893		0
4021	232	260139	2007-08-30	2007-08-30 00:00:00	2007-09-07	2007-09-07 00:00:00	32020		\N	15639	0	10509002	260139		0
4208	244	378419	1990-01-22	1990-01-22 00:00:00	\N	\N	32020		\N	16306	0	26929004	378419		0
4363	254	4155034	1992-12-10	1992-12-10 00:00:00	1992-12-31	1992-12-31 00:00:00	32020		\N	16919	0	283371005	4155034		0
4517	264	4112343	1970-09-22	1970-09-22 00:00:00	1970-09-29	1970-09-29 00:00:00	32020		\N	17539	0	195662009	4112343		0
4704	276	260139	1983-04-11	1983-04-11 00:00:00	1983-04-18	1983-04-18 00:00:00	32020		\N	18442	0	10509002	260139		0
4854	286	40481087	1964-08-18	1964-08-18 00:00:00	1964-08-25	1964-08-25 00:00:00	32020		\N	19091	0	444814009	40481087		0
5040	297	4112343	1952-02-15	1952-02-15 00:00:00	1952-02-28	1952-02-28 00:00:00	32020		\N	19787	0	195662009	4112343		0
5193	307	4109685	1990-08-03	1990-08-03 00:00:00	1990-08-24	1990-08-24 00:00:00	32020		\N	20382	0	284551006	4109685		0
5365	316	260139	1996-05-08	1996-05-08 00:00:00	1996-05-15	1996-05-15 00:00:00	32020		\N	20862	0	10509002	260139		0
5547	328	260139	1985-04-27	1985-04-27 00:00:00	1985-05-11	1985-05-11 00:00:00	32020		\N	21641	0	10509002	260139		0
5689	334	260139	2012-11-25	2012-11-25 00:00:00	2012-12-02	2012-12-02 00:00:00	32020		\N	22210	0	10509002	260139		0
5850	343	440086	1984-01-28	1984-01-28 00:00:00	1988-02-06	1988-02-06 00:00:00	32020		\N	22855	0	192127007	440086		0
6012	352	40481087	2010-10-01	2010-10-01 00:00:00	2010-10-08	2010-10-08 00:00:00	32020		\N	23444	0	444814009	40481087		0
6177	363	4237458	2005-07-01	2005-07-01 00:00:00	2005-07-31	2005-07-31 00:00:00	32020		\N	24072	0	58150001	4237458		0
6343	372	81151	1999-05-15	1999-05-15 00:00:00	1999-06-05	1999-06-05 00:00:00	32020		\N	24788	0	44465007	81151		0
6562	387	4134304	1998-04-04	1998-04-04 00:00:00	1998-07-03	1998-07-03 00:00:00	32020		\N	25458	0	263102004	4134304		0
6675	394	4112343	1978-08-11	1978-08-11 00:00:00	1978-08-24	1978-08-24 00:00:00	32020		\N	25896	0	195662009	4112343		0
6849	403	28060	1983-01-31	1983-01-31 00:00:00	1983-02-08	1983-02-08 00:00:00	32020		\N	26436	0	43878008	28060		0
7008	411	4112343	1971-10-05	1971-10-05 00:00:00	1971-10-14	1971-10-14 00:00:00	32020		\N	27308	0	195662009	4112343		0
7179	422	4112343	2011-03-04	2011-03-04 00:00:00	2011-03-12	2011-03-12 00:00:00	32020		\N	27932	0	195662009	4112343		0
7339	431	40481087	1965-02-23	1965-02-23 00:00:00	1965-03-16	1965-03-16 00:00:00	32020		\N	28567	0	444814009	40481087		0
7514	442	40481087	1978-10-02	1978-10-02 00:00:00	1978-10-23	1978-10-23 00:00:00	32020		\N	29336	0	444814009	40481087		0
7680	450	4112343	1998-03-30	1998-03-30 00:00:00	1998-04-08	1998-04-08 00:00:00	32020		\N	29995	0	195662009	4112343		0
7848	458	40481087	1999-05-01	1999-05-01 00:00:00	1999-05-22	1999-05-22 00:00:00	32020		\N	30639	0	444814009	40481087		0
8026	470	4112343	1964-05-05	1964-05-05 00:00:00	1964-05-12	1964-05-12 00:00:00	32020		\N	31405	0	195662009	4112343		0
8192	480	40481087	1946-10-06	1946-10-06 00:00:00	1946-10-20	1946-10-20 00:00:00	32020		\N	32124	0	444814009	40481087		0
8345	486	40481087	1997-10-20	1997-10-20 00:00:00	1997-11-03	1997-11-03 00:00:00	32020		\N	32462	0	444814009	40481087		0
8510	495	4027663	1994-05-12	1994-05-12 00:00:00	\N	\N	32020		\N	33068	0	13200003	4027663		0
8687	507	28060	1949-01-27	1949-01-27 00:00:00	1949-02-09	1949-02-09 00:00:00	32020		\N	33946	0	43878008	28060		0
8860	518	4310024	2006-05-17	2006-05-17 00:00:00	\N	\N	32020		\N	34647	0	424802006	4310024		0
9001	526	40481087	2003-10-27	2003-10-27 00:00:00	2003-11-17	2003-11-17 00:00:00	32020		\N	35065	0	444814009	40481087		0
9208	545	4112343	1974-08-27	1974-08-27 00:00:00	1974-09-04	1974-09-04 00:00:00	32020		\N	36133	0	195662009	4112343		0
9331	550	80180	1956-07-02	1956-07-02 00:00:00	\N	\N	32020		\N	36452	0	396275006	80180		0
9512	564	28060	1960-01-01	1960-01-01 00:00:00	1960-01-10	1960-01-10 00:00:00	32020		\N	37356	0	43878008	28060		0
9664	572	260139	1961-10-12	1961-10-12 00:00:00	1961-10-26	1961-10-26 00:00:00	32020		\N	37848	0	10509002	260139		0
9829	580	40481087	1933-03-29	1933-03-29 00:00:00	1933-04-12	1933-04-12 00:00:00	32020		\N	38375	0	444814009	40481087		0
10057	597	260139	2015-07-27	2015-07-27 00:00:00	2015-08-03	2015-08-03 00:00:00	32020		\N	39426	0	10509002	260139		0
10175	603	40481087	1966-01-23	1966-01-23 00:00:00	1966-02-06	1966-02-06 00:00:00	32020		\N	39955	0	444814009	40481087		0
10329	610	40481087	1997-09-18	1997-09-18 00:00:00	1997-10-09	1997-10-09 00:00:00	32020		\N	40592	0	444814009	40481087		0
10494	616	40481087	1997-09-18	1997-09-18 00:00:00	1997-10-02	1997-10-02 00:00:00	32020		\N	41116	0	444814009	40481087		0
35	2	260139	1955-10-22	1955-10-22 00:00:00	1955-10-29	1955-10-29 00:00:00	32020		\N	103	0	10509002	260139		0
223	11	4112343	2003-12-07	2003-12-07 00:00:00	2003-12-17	2003-12-17 00:00:00	32020		\N	966	0	195662009	4112343		0
367	19	40481087	1997-10-14	1997-10-14 00:00:00	1997-10-28	1997-10-28 00:00:00	32020		\N	1511	0	444814009	40481087		0
547	32	4112343	1962-10-29	1962-10-29 00:00:00	1962-11-07	1962-11-07 00:00:00	32020		\N	2255	0	195662009	4112343		0
720	40	4278672	1961-03-17	1961-03-17 00:00:00	1961-06-15	1961-06-15 00:00:00	32020		\N	2862	0	65966004	4278672		0
931	53	40481087	1978-01-24	1978-01-24 00:00:00	1978-02-14	1978-02-14 00:00:00	32020		\N	3637	0	444814009	40481087		0
1068	63	4134304	1973-12-05	1973-12-05 00:00:00	1974-01-04	1974-01-04 00:00:00	32020		\N	4297	0	263102004	4134304		0
1201	70	260139	1960-01-10	1960-01-10 00:00:00	1960-01-24	1960-01-24 00:00:00	32020		\N	4715	0	10509002	260139		0
1363	80	40481087	1955-06-17	1955-06-17 00:00:00	1955-07-08	1955-07-08 00:00:00	32020		\N	5463	0	444814009	40481087		0
1598	94	40481087	1979-10-11	1979-10-11 00:00:00	1979-10-18	1979-10-18 00:00:00	32020		\N	6339	0	444814009	40481087		0
1695	97	40481087	1959-10-15	1959-10-15 00:00:00	1959-11-05	1959-11-05 00:00:00	32020		\N	6664	0	444814009	40481087		0
1884	111	40481087	2011-06-30	2011-06-30 00:00:00	2011-07-07	2011-07-07 00:00:00	32020		\N	7351	0	444814009	40481087		0
2040	119	4059173	1967-05-28	1967-05-28 00:00:00	1967-07-27	1967-07-27 00:00:00	32020		\N	7923	0	16114001	4059173		0
2234	129	4152936	1983-04-23	1983-04-23 00:00:00	1983-05-14	1983-05-14 00:00:00	32020		\N	8704	0	283385000	4152936		0
2375	140	4296204	1970-05-31	1970-05-31 00:00:00	1970-06-21	1970-06-21 00:00:00	32020		\N	9414	0	403190006	4296204		0
2566	152	4112343	1970-06-28	1970-06-28 00:00:00	1970-07-08	1970-07-08 00:00:00	32020		\N	10275	0	195662009	4112343		0
2712	158	260139	1967-10-12	1967-10-12 00:00:00	1967-10-19	1967-10-19 00:00:00	32020		\N	10821	0	10509002	260139		0
2857	164	4112343	1990-03-26	1990-03-26 00:00:00	1990-04-06	1990-04-06 00:00:00	32020		\N	11244	0	195662009	4112343		0
3031	177	40479422	2002-05-07	2002-05-07 00:00:00	2002-07-13	2002-07-13 00:00:00	32020		\N	11955	0	444448004	40479422		0
3189	187	81151	1977-03-20	1977-03-20 00:00:00	1977-04-25	1977-04-25 00:00:00	32020		\N	12735	0	44465007	81151		0
3355	192	80180	1981-10-27	1981-10-27 00:00:00	\N	\N	32020		\N	13174	0	396275006	80180		0
3538	202	378419	2016-01-02	2016-01-02 00:00:00	\N	\N	32020		\N	13860	0	26929004	378419		0
3700	212	372328	1980-04-14	1980-04-14 00:00:00	1980-09-06	1980-09-06 00:00:00	32020		\N	14415	0	65363002	372328		0
3854	222	4218389	1960-04-29	1960-04-29 00:00:00	1960-05-20	1960-05-20 00:00:00	32020		\N	14932	0	39848009	4218389		0
4022	232	40481087	1998-05-25	1998-05-25 00:00:00	1998-06-01	1998-06-01 00:00:00	32020		\N	15622	0	444814009	40481087		0
4209	244	372328	1926-05-07	1926-05-07 00:00:00	1927-02-07	1927-02-07 00:00:00	32020		\N	16358	0	65363002	372328		0
4364	254	375671	1965-03-07	1965-03-07 00:00:00	1965-05-06	1965-05-06 00:00:00	32020		\N	16918	0	62564004	375671		0
4518	264	78272	1984-09-16	1984-09-16 00:00:00	1984-09-30	1984-09-30 00:00:00	32020		\N	17586	0	70704007	78272		0
4705	276	40481087	1986-03-22	1986-03-22 00:00:00	1986-03-29	1986-03-29 00:00:00	32020		\N	18443	0	444814009	40481087		0
4855	286	4112343	1973-02-19	1973-02-19 00:00:00	1973-03-04	1973-03-04 00:00:00	32020		\N	19092	0	195662009	4112343		0
5041	297	260139	1999-11-21	1999-11-21 00:00:00	1999-12-05	1999-12-05 00:00:00	32020		\N	19771	0	10509002	260139		0
5194	307	80180	2009-09-29	2009-09-29 00:00:00	\N	\N	32020		\N	20364	0	396275006	80180		0
5366	316	40481087	1935-08-06	1935-08-06 00:00:00	1935-08-27	1935-08-27 00:00:00	32020		\N	20860	0	444814009	40481087		0
5548	328	260139	2014-03-31	2014-03-31 00:00:00	2014-04-07	2014-04-07 00:00:00	32020		\N	21666	0	10509002	260139		0
5690	334	4266809	1972-10-18	1972-10-18 00:00:00	\N	\N	32020		\N	22127	0	397881000	4266809		0
5851	343	4112343	1987-09-02	1987-09-02 00:00:00	1987-09-13	1987-09-13 00:00:00	32020		\N	22919	0	195662009	4112343		0
6013	352	81893	2011-01-06	2011-01-06 00:00:00	\N	\N	32020		\N	23444	0	64766004	81893		0
6178	363	40481087	1965-06-09	1965-06-09 00:00:00	1965-06-16	1965-06-16 00:00:00	32020		\N	24073	0	444814009	40481087		0
6344	372	378001	1973-06-30	1973-06-30 00:00:00	1973-07-30	1973-07-30 00:00:00	32020		\N	24787	0	62106007	378001		0
6563	387	81151	1991-08-25	1991-08-25 00:00:00	1991-09-08	1991-09-08 00:00:00	32020		\N	25457	0	44465007	81151		0
6676	394	4112343	1922-12-20	1922-12-20 00:00:00	1922-12-31	1922-12-31 00:00:00	32020		\N	25835	0	195662009	4112343		0
6850	403	40481087	1984-04-14	1984-04-14 00:00:00	1984-04-21	1984-04-21 00:00:00	32020		\N	26497	0	444814009	40481087		0
7009	411	260139	1970-08-03	1970-08-03 00:00:00	1970-08-17	1970-08-17 00:00:00	32020		\N	27267	0	10509002	260139		0
7180	422	80502	2019-04-27	2019-04-27 00:00:00	\N	\N	32020		\N	27964	0	64859006	80502		0
7340	431	4112343	1970-02-13	1970-02-13 00:00:00	1970-02-26	1970-02-26 00:00:00	32020		\N	28553	0	195662009	4112343		0
7515	442	4112343	2007-02-27	2007-02-27 00:00:00	2007-03-11	2007-03-11 00:00:00	32020		\N	29369	0	195662009	4112343		0
7681	450	260139	1967-10-09	1967-10-09 00:00:00	1967-10-16	1967-10-16 00:00:00	32020		\N	30005	0	10509002	260139		0
7849	458	439777	2012-08-03	2012-08-03 00:00:00	\N	\N	32020		\N	30640	0	271737000	439777		0
8027	470	372328	1955-11-07	1955-11-07 00:00:00	1955-12-20	1955-12-20 00:00:00	32020		\N	31410	0	65363002	372328		0
8193	480	317576	2016-10-05	2016-10-05 00:00:00	\N	\N	32020		\N	32082	0	53741008	317576		0
8346	486	40481087	1988-10-12	1988-10-12 00:00:00	1988-10-26	1988-10-26 00:00:00	32020		\N	32507	0	444814009	40481087		0
8511	495	81151	1971-03-04	1971-03-04 00:00:00	1971-03-25	1971-03-25 00:00:00	32020		\N	33105	0	44465007	81151		0
8688	507	40481087	1981-03-29	1981-03-29 00:00:00	1981-04-19	1981-04-19 00:00:00	32020		\N	33906	0	444814009	40481087		0
8861	518	4285898	2006-12-13	2006-12-13 00:00:00	\N	\N	32020		\N	34647	0	68496003	4285898		0
9002	526	260139	1988-04-06	1988-04-06 00:00:00	1988-04-13	1988-04-13 00:00:00	32020		\N	35048	0	10509002	260139		0
9209	545	4027663	1997-10-02	1997-10-02 00:00:00	\N	\N	32020		\N	36119	0	13200003	4027663		0
9332	550	4116491	1957-11-09	1957-11-09 00:00:00	1957-12-16	1957-12-16 00:00:00	32020		\N	36533	0	301011002	4116491		0
9513	564	78272	1980-06-10	1980-06-10 00:00:00	1980-07-15	1980-07-15 00:00:00	32020		\N	37340	0	70704007	78272		0
9665	572	40481087	1973-06-26	1973-06-26 00:00:00	1973-07-03	1973-07-03 00:00:00	32020		\N	37895	0	444814009	40481087		0
9830	580	40481087	1943-02-10	1943-02-10 00:00:00	1943-02-17	1943-02-17 00:00:00	32020		\N	38376	0	444814009	40481087		0
10058	597	260139	1966-10-06	1966-10-06 00:00:00	1966-10-13	1966-10-13 00:00:00	32020		\N	39423	0	10509002	260139		0
10176	603	260139	2014-03-12	2014-03-12 00:00:00	2014-03-26	2014-03-26 00:00:00	32020		\N	40035	0	10509002	260139		0
10330	610	4155034	1989-12-02	1989-12-02 00:00:00	1989-12-23	1989-12-23 00:00:00	32020		\N	40480	0	283371005	4155034		0
10530	621	40481087	2001-06-18	2001-06-18 00:00:00	2001-07-02	2001-07-02 00:00:00	32020		\N	41365	0	444814009	40481087		0
36	2	4112343	1969-09-18	1969-09-18 00:00:00	1969-09-28	1969-09-28 00:00:00	32020		\N	139	0	195662009	4112343		0
224	11	40481087	1987-09-24	1987-09-24 00:00:00	1987-10-01	1987-10-01 00:00:00	32020		\N	922	0	444814009	40481087		0
368	19	4059173	1981-11-08	1981-11-08 00:00:00	1981-12-08	1981-12-08 00:00:00	32020		\N	1544	0	16114001	4059173		0
548	32	260139	1998-10-02	1998-10-02 00:00:00	1998-10-09	1998-10-09 00:00:00	32020		\N	2200	0	10509002	260139		0
721	40	4112343	1959-07-30	1959-07-30 00:00:00	1959-08-09	1959-08-09 00:00:00	32020		\N	2876	0	195662009	4112343		0
932	53	40481087	2008-02-14	2008-02-14 00:00:00	2008-02-21	2008-02-21 00:00:00	32020		\N	3643	0	444814009	40481087		0
1069	63	40481087	1963-07-12	1963-07-12 00:00:00	1963-07-19	1963-07-19 00:00:00	32020		\N	4280	0	444814009	40481087		0
1202	70	378001	2009-04-21	2009-04-21 00:00:00	2009-05-21	2009-05-21 00:00:00	32020		\N	4713	0	62106007	378001		0
1364	80	260139	2013-12-29	2013-12-29 00:00:00	2014-01-12	2014-01-12 00:00:00	32020		\N	5441	0	10509002	260139		0
1599	94	40481087	1989-10-13	1989-10-13 00:00:00	1989-10-27	1989-10-27 00:00:00	32020		\N	6303	0	444814009	40481087		0
1696	97	40481087	1969-05-21	1969-05-21 00:00:00	1969-06-11	1969-06-11 00:00:00	32020		\N	6615	0	444814009	40481087		0
1885	111	372328	1977-05-21	1977-05-21 00:00:00	1977-10-07	1977-10-07 00:00:00	32020		\N	7352	0	65363002	372328		0
2041	119	40481087	1991-04-11	1991-04-11 00:00:00	1991-05-02	1991-05-02 00:00:00	32020		\N	7898	0	444814009	40481087		0
2235	129	4283893	2010-08-30	2010-08-30 00:00:00	2010-10-04	2010-10-04 00:00:00	32020		\N	8714	0	36971009	4283893		0
2376	140	40481087	1989-01-09	1989-01-09 00:00:00	1989-01-30	1989-01-30 00:00:00	32020		\N	9395	0	444814009	40481087		0
2567	152	4278672	2000-10-23	2000-10-23 00:00:00	2000-11-22	2000-11-22 00:00:00	32020		\N	10294	0	65966004	4278672		0
2713	158	4218389	2001-10-18	2001-10-18 00:00:00	2001-11-08	2001-11-08 00:00:00	32020		\N	10792	0	39848009	4218389		0
2858	164	192671	2009-02-26	2009-02-26 00:00:00	\N	\N	32020		\N	11282	0	K92.2	35208414		0
3032	177	372328	2011-12-03	2011-12-03 00:00:00	2012-05-14	2012-05-14 00:00:00	32020		\N	11994	0	65363002	372328		0
3190	187	4113008	1957-04-20	1957-04-20 00:00:00	1957-05-05	1957-05-05 00:00:00	32020		\N	12733	0	284549007	4113008		0
3356	192	260139	2018-09-18	2018-09-18 00:00:00	2018-09-25	2018-09-25 00:00:00	32020		\N	13211	0	10509002	260139		0
3539	202	260139	1998-01-30	1998-01-30 00:00:00	1998-02-06	1998-02-06 00:00:00	32020		\N	13886	0	10509002	260139		0
3701	212	4113008	1978-11-04	1978-11-04 00:00:00	1978-11-18	1978-11-18 00:00:00	32020		\N	14437	0	284549007	4113008		0
3855	222	192671	1988-03-28	1988-03-28 00:00:00	\N	\N	32020		\N	14930	0	K92.2	35208414		0
4023	232	4278672	2016-03-05	2016-03-05 00:00:00	2016-06-03	2016-06-03 00:00:00	32020		\N	15620	0	65966004	4278672		0
4210	244	260139	1923-06-23	1923-06-23 00:00:00	1923-06-30	1923-06-30 00:00:00	32020		\N	16293	0	10509002	260139		0
4365	254	4112343	1954-12-01	1954-12-01 00:00:00	1954-12-08	1954-12-08 00:00:00	32020		\N	16906	0	195662009	4112343		0
4519	264	260139	1995-04-03	1995-04-03 00:00:00	1995-04-10	1995-04-10 00:00:00	32020		\N	17594	0	10509002	260139		0
4706	276	4278672	1978-06-04	1978-06-04 00:00:00	1978-07-04	1978-07-04 00:00:00	32020		\N	18389	0	65966004	4278672		0
4856	286	372328	1929-01-30	1929-01-30 00:00:00	1929-04-27	1929-04-27 00:00:00	32020		\N	19141	0	65363002	372328		0
5042	297	40481087	2009-02-06	2009-02-06 00:00:00	2009-02-27	2009-02-27 00:00:00	32020		\N	19781	0	444814009	40481087		0
5195	307	40481087	2016-01-21	2016-01-21 00:00:00	2016-01-28	2016-01-28 00:00:00	32020		\N	20369	0	444814009	40481087		0
5367	316	4278672	2006-08-31	2006-08-31 00:00:00	2006-10-30	2006-10-30 00:00:00	32020		\N	20891	0	65966004	4278672		0
5549	328	4266809	2014-04-13	2014-04-13 00:00:00	\N	\N	32020		\N	21666	0	397881000	4266809		0
5691	334	80180	1972-10-18	1972-10-18 00:00:00	\N	\N	32020		\N	22127	0	396275006	80180		0
5852	343	40481087	1989-05-08	1989-05-08 00:00:00	1989-05-22	1989-05-22 00:00:00	32020		\N	22921	0	444814009	40481087		0
6019	354	372328	1957-12-25	1957-12-25 00:00:00	1958-06-12	1958-06-12 00:00:00	32020		\N	23528	0	65363002	372328		0
6179	363	81151	1996-01-24	1996-01-24 00:00:00	1996-02-28	1996-02-28 00:00:00	32020		\N	24070	0	44465007	81151		0
6345	372	195588	1984-05-07	1984-05-07 00:00:00	1984-06-10	1984-06-10 00:00:00	32020		\N	24745	0	38822007	195588		0
6564	387	40481087	2011-09-22	2011-09-22 00:00:00	2011-09-29	2011-09-29 00:00:00	32020		\N	25505	0	444814009	40481087		0
6677	394	4294548	1981-04-06	1981-04-06 00:00:00	1981-05-04	1981-05-04 00:00:00	32020		\N	25890	0	75498004	4294548		0
6851	403	40481087	1963-02-15	1963-02-15 00:00:00	1963-03-08	1963-03-08 00:00:00	32020		\N	26435	0	444814009	40481087		0
7010	411	260139	2012-03-25	2012-03-25 00:00:00	2012-04-01	2012-04-01 00:00:00	32020		\N	27338	0	10509002	260139		0
7181	422	40481087	1959-10-16	1959-10-16 00:00:00	1959-10-23	1959-10-23 00:00:00	32020		\N	27949	0	444814009	40481087		0
7341	431	378001	1958-07-07	1958-07-07 00:00:00	1958-08-06	1958-08-06 00:00:00	32020		\N	28593	0	62106007	378001		0
7516	442	257012	2013-04-19	2013-04-19 00:00:00	\N	\N	32020		\N	29418	0	40055000	257012		0
7682	450	4278672	1981-07-25	1981-07-25 00:00:00	1981-09-23	1981-09-23 00:00:00	32020		\N	30053	0	65966004	4278672		0
7850	458	260139	2002-06-23	2002-06-23 00:00:00	2002-07-07	2002-07-07 00:00:00	32020		\N	30649	0	10509002	260139		0
8028	470	372328	1959-03-14	1959-03-14 00:00:00	1959-12-22	1959-12-22 00:00:00	32020		\N	31422	0	65363002	372328		0
8194	480	40481087	1997-04-18	1997-04-18 00:00:00	1997-04-25	1997-04-25 00:00:00	32020		\N	32028	0	444814009	40481087		0
8347	486	195588	1996-10-25	1996-10-25 00:00:00	1996-12-08	1996-12-08 00:00:00	32020		\N	32461	0	38822007	195588		0
8512	495	80180	2005-06-28	2005-06-28 00:00:00	\N	\N	32020		\N	33101	0	396275006	80180		0
8689	507	313217	1990-08-31	1990-08-31 00:00:00	\N	\N	32020		\N	33931	0	49436004	313217		0
8862	518	80180	2007-05-12	2007-05-12 00:00:00	\N	\N	32020		\N	34647	0	396275006	80180		0
9003	526	4109685	2008-09-05	2008-09-05 00:00:00	2008-09-19	2008-09-19 00:00:00	32020		\N	35104	0	284551006	4109685		0
9210	545	4310024	2003-02-28	2003-02-28 00:00:00	\N	\N	32020		\N	36095	0	424802006	4310024		0
9333	550	81151	1950-06-09	1950-06-09 00:00:00	1950-06-30	1950-06-30 00:00:00	32020		\N	36446	0	44465007	81151		0
9514	564	40481087	2013-08-05	2013-08-05 00:00:00	2013-08-26	2013-08-26 00:00:00	32020		\N	37334	0	444814009	40481087		0
9666	572	372328	1958-04-19	1958-04-19 00:00:00	1958-10-03	1958-10-03 00:00:00	32020		\N	37907	0	65363002	372328		0
9831	580	40481087	1958-03-24	1958-03-24 00:00:00	1958-03-31	1958-03-31 00:00:00	32020		\N	38457	0	444814009	40481087		0
10059	597	40481087	2016-01-05	2016-01-05 00:00:00	2016-01-19	2016-01-19 00:00:00	32020		\N	39474	0	444814009	40481087		0
10177	603	78272	1964-11-22	1964-11-22 00:00:00	1964-12-20	1964-12-20 00:00:00	32020		\N	39930	0	70704007	78272		0
10331	610	4155034	1995-08-24	1995-08-24 00:00:00	1995-09-14	1995-09-14 00:00:00	32020		\N	40481	0	283371005	4155034		0
10531	621	4059173	1919-04-17	1919-04-17 00:00:00	1919-05-17	1919-05-17 00:00:00	32020		\N	41485	0	16114001	4059173		0
37	2	258780	1989-09-26	1989-09-26 00:00:00	\N	\N	32020		\N	132	0	185086009	258780		0
225	11	4278672	1987-10-03	1987-10-03 00:00:00	1987-11-02	1987-11-02 00:00:00	32020		\N	989	0	65966004	4278672		0
369	19	260139	1977-09-01	1977-09-01 00:00:00	1977-09-08	1977-09-08 00:00:00	32020		\N	1510	0	10509002	260139		0
549	32	192671	1987-06-09	1987-06-09 00:00:00	\N	\N	32020		\N	2282	0	K92.2	35208414		0
722	40	40481087	1970-02-10	1970-02-10 00:00:00	1970-02-17	1970-02-17 00:00:00	32020		\N	2800	0	444814009	40481087		0
933	53	40481087	1965-03-07	1965-03-07 00:00:00	1965-03-28	1965-03-28 00:00:00	32020		\N	3635	0	444814009	40481087		0
1070	63	4112343	2012-11-27	2012-11-27 00:00:00	2012-12-07	2012-12-07 00:00:00	32020		\N	4285	0	195662009	4112343		0
1203	70	4112343	1978-01-19	1978-01-19 00:00:00	1978-01-28	1978-01-28 00:00:00	32020		\N	4719	0	195662009	4112343		0
1365	80	4112343	1975-12-30	1975-12-30 00:00:00	1976-01-12	1976-01-12 00:00:00	32020		\N	5400	0	195662009	4112343		0
1600	94	4112343	1963-11-21	1963-11-21 00:00:00	1963-11-29	1963-11-29 00:00:00	32020		\N	6338	0	195662009	4112343		0
1697	97	195588	1966-07-13	1966-07-13 00:00:00	1966-08-16	1966-08-16 00:00:00	32020		\N	6585	0	38822007	195588		0
1886	111	28060	1979-01-13	1979-01-13 00:00:00	1979-01-25	1979-01-25 00:00:00	32020		\N	7413	0	43878008	28060		0
2042	119	40481087	1968-04-07	1968-04-07 00:00:00	1968-04-21	1968-04-21 00:00:00	32020		\N	7884	0	444814009	40481087		0
2236	129	80180	2014-03-21	2014-03-21 00:00:00	\N	\N	32020		\N	8669	0	396275006	80180		0
2377	140	81151	2015-11-09	2015-11-09 00:00:00	2015-11-23	2015-11-23 00:00:00	32020		\N	9349	0	44465007	81151		0
2568	152	4112343	1976-04-11	1976-04-11 00:00:00	1976-04-18	1976-04-18 00:00:00	32020		\N	10241	0	195662009	4112343		0
2714	158	80180	1983-11-11	1983-11-11 00:00:00	\N	\N	32020		\N	10795	0	396275006	80180		0
2859	164	78272	2000-10-31	2000-10-31 00:00:00	2000-11-28	2000-11-28 00:00:00	32020		\N	11280	0	70704007	78272		0
3046	180	80180	2012-09-29	2012-09-29 00:00:00	\N	\N	32020		\N	12180	0	396275006	80180		0
3191	187	4112343	1962-02-08	1962-02-08 00:00:00	1962-02-16	1962-02-16 00:00:00	32020		\N	12712	0	195662009	4112343		0
3357	192	4112343	1953-05-22	1953-05-22 00:00:00	1953-05-30	1953-05-30 00:00:00	32020		\N	13204	0	195662009	4112343		0
3540	202	81151	1951-09-28	1951-09-28 00:00:00	1951-10-12	1951-10-12 00:00:00	32020		\N	13906	0	44465007	81151		0
3702	212	4116491	2015-03-10	2015-03-10 00:00:00	2015-04-29	2015-04-29 00:00:00	32020		\N	14463	0	301011002	4116491		0
3856	222	372328	1953-09-03	1953-09-03 00:00:00	1954-02-19	1954-02-19 00:00:00	32020		\N	14916	0	65363002	372328		0
4046	235	40481087	1987-04-11	1987-04-11 00:00:00	1987-05-02	1987-05-02 00:00:00	32020		\N	15779	0	444814009	40481087		0
4211	244	4112343	1961-06-24	1961-06-24 00:00:00	1961-07-03	1961-07-03 00:00:00	32020		\N	16264	0	195662009	4112343		0
4366	254	40481087	2003-05-01	2003-05-01 00:00:00	2003-05-15	2003-05-15 00:00:00	32020		\N	16936	0	444814009	40481087		0
4520	264	4112343	1955-12-04	1955-12-04 00:00:00	1955-12-14	1955-12-14 00:00:00	32020		\N	17551	0	195662009	4112343		0
4707	276	4112343	1998-05-31	1998-05-31 00:00:00	1998-06-13	1998-06-13 00:00:00	32020		\N	18431	0	195662009	4112343		0
4857	286	4113008	2013-07-09	2013-07-09 00:00:00	2013-07-23	2013-07-23 00:00:00	32020		\N	19045	0	284549007	4113008		0
5043	297	40481087	1956-06-16	1956-06-16 00:00:00	1956-06-30	1956-06-30 00:00:00	32020		\N	19768	0	444814009	40481087		0
5196	307	260139	2019-03-03	2019-03-03 00:00:00	2019-03-17	2019-03-17 00:00:00	32020		\N	20387	0	10509002	260139		0
5368	316	40481087	2006-05-14	2006-05-14 00:00:00	2006-05-28	2006-05-28 00:00:00	32020		\N	20870	0	444814009	40481087		0
5550	328	80180	2014-04-13	2014-04-13 00:00:00	\N	\N	32020		\N	21666	0	396275006	80180		0
5692	334	40481087	1972-04-15	1972-04-15 00:00:00	1972-04-22	1972-04-22 00:00:00	32020		\N	22127	0	444814009	40481087		0
5853	343	40481087	2017-06-10	2017-06-10 00:00:00	2017-06-24	2017-06-24 00:00:00	32020		\N	22964	0	444814009	40481087		0
6020	354	260139	2001-10-18	2001-10-18 00:00:00	2001-10-25	2001-10-25 00:00:00	32020		\N	23520	0	10509002	260139		0
6180	364	4112343	1988-04-23	1988-04-23 00:00:00	1988-05-04	1988-05-04 00:00:00	32020		\N	24177	0	195662009	4112343		0
6346	372	4112343	1966-08-18	1966-08-18 00:00:00	1966-08-31	1966-08-31 00:00:00	32020		\N	24753	0	195662009	4112343		0
6565	387	81151	1987-07-19	1987-07-19 00:00:00	1987-08-16	1987-08-16 00:00:00	32020		\N	25456	0	44465007	81151		0
6678	394	40481087	1976-06-17	1976-06-17 00:00:00	1976-06-24	1976-06-24 00:00:00	32020		\N	25889	0	444814009	40481087		0
6852	403	260139	1935-01-04	1935-01-04 00:00:00	1935-01-11	1935-01-11 00:00:00	32020		\N	26510	0	10509002	260139		0
7011	411	260139	1972-08-14	1972-08-14 00:00:00	1972-08-21	1972-08-21 00:00:00	32020		\N	27268	0	10509002	260139		0
7182	422	192671	2001-03-04	2001-03-04 00:00:00	\N	\N	32020		\N	27965	0	K92.2	35208414		0
7342	431	4112343	2004-08-14	2004-08-14 00:00:00	2004-08-25	2004-08-25 00:00:00	32020		\N	28616	0	195662009	4112343		0
7517	442	4109685	1989-12-08	1989-12-08 00:00:00	1989-12-22	1989-12-22 00:00:00	32020		\N	29286	0	284551006	4109685		0
7683	450	40481087	1974-02-08	1974-02-08 00:00:00	1974-02-15	1974-02-15 00:00:00	32020		\N	30006	0	444814009	40481087		0
7851	458	260139	1974-02-06	1974-02-06 00:00:00	1974-02-13	1974-02-13 00:00:00	32020		\N	30616	0	10509002	260139		0
8029	470	4109685	1961-08-07	1961-08-07 00:00:00	1961-08-28	1961-08-28 00:00:00	32020		\N	31390	0	284551006	4109685		0
8195	480	372328	1937-10-16	1937-10-16 00:00:00	1938-01-26	1938-01-26 00:00:00	32020		\N	32034	0	65363002	372328		0
8348	486	4112343	1982-08-27	1982-08-27 00:00:00	1982-09-09	1982-09-09 00:00:00	32020		\N	32460	0	195662009	4112343		0
8513	495	81893	2004-04-04	2004-04-04 00:00:00	\N	\N	32020		\N	33101	0	64766004	81893		0
8690	507	192671	1977-10-29	1977-10-29 00:00:00	\N	\N	32020		\N	33974	0	K92.2	35208414		0
8863	518	81893	2006-07-16	2006-07-16 00:00:00	\N	\N	32020		\N	34647	0	64766004	81893		0
9004	526	40481087	1985-10-25	1985-10-25 00:00:00	1985-11-15	1985-11-15 00:00:00	32020		\N	35051	0	444814009	40481087		0
9211	545	40481087	2013-11-13	2013-11-13 00:00:00	2013-11-27	2013-11-27 00:00:00	32020		\N	36048	0	444814009	40481087		0
9334	550	28060	1927-03-16	1927-03-16 00:00:00	1927-03-25	1927-03-25 00:00:00	32020		\N	36489	0	43878008	28060		0
9515	564	81151	2006-08-19	2006-08-19 00:00:00	2006-09-09	2006-09-09 00:00:00	32020		\N	37342	0	44465007	81151		0
9667	572	40481087	1982-03-27	1982-03-27 00:00:00	1982-04-10	1982-04-10 00:00:00	32020		\N	37874	0	444814009	40481087		0
9832	580	260139	1964-05-17	1964-05-17 00:00:00	1964-05-31	1964-05-31 00:00:00	32020		\N	38458	0	10509002	260139		0
10060	597	81151	2005-10-11	2005-10-11 00:00:00	2005-11-01	2005-11-01 00:00:00	32020		\N	39460	0	44465007	81151		0
10178	603	40481087	1987-12-17	1987-12-17 00:00:00	1987-12-24	1987-12-24 00:00:00	32020		\N	39958	0	444814009	40481087		0
10332	610	4116491	2013-08-17	2013-08-17 00:00:00	2013-09-22	2013-09-22 00:00:00	32020		\N	40542	0	301011002	4116491		0
10532	621	257012	1929-04-11	1929-04-11 00:00:00	\N	\N	32020		\N	41468	0	40055000	257012		0
38	2	372328	1921-06-04	1921-06-04 00:00:00	1921-08-09	1921-08-09 00:00:00	32020		\N	145	0	65363002	372328		0
226	11	40481087	1994-07-31	1994-07-31 00:00:00	1994-08-14	1994-08-14 00:00:00	32020		\N	964	0	444814009	40481087		0
370	19	40481087	2011-02-25	2011-02-25 00:00:00	2011-03-18	2011-03-18 00:00:00	32020		\N	1499	0	444814009	40481087		0
550	32	372328	1947-08-07	1947-08-07 00:00:00	1947-10-01	1947-10-01 00:00:00	32020		\N	2274	0	65363002	372328		0
723	40	4112343	2003-02-05	2003-02-05 00:00:00	2003-02-18	2003-02-18 00:00:00	32020		\N	2802	0	195662009	4112343		0
934	53	78272	1976-01-25	1976-01-25 00:00:00	1976-02-29	1976-02-29 00:00:00	32020		\N	3634	0	70704007	78272		0
1071	63	40481087	1987-11-20	1987-11-20 00:00:00	1987-11-27	1987-11-27 00:00:00	32020		\N	4243	0	444814009	40481087		0
1204	70	4112343	1968-09-18	1968-09-18 00:00:00	1968-09-26	1968-09-26 00:00:00	32020		\N	4724	0	195662009	4112343		0
1366	80	40481087	1949-11-11	1949-11-11 00:00:00	1949-11-18	1949-11-18 00:00:00	32020		\N	5461	0	444814009	40481087		0
1601	94	4146173	2000-05-18	2000-05-18 00:00:00	2000-06-17	2000-06-17 00:00:00	32020		\N	6357	0	307731004	4146173		0
1698	97	40481087	1950-04-20	1950-04-20 00:00:00	1950-05-04	1950-05-04 00:00:00	32020		\N	6582	0	444814009	40481087		0
1887	111	40481087	1976-05-03	1976-05-03 00:00:00	1976-05-10	1976-05-10 00:00:00	32020		\N	7369	0	444814009	40481087		0
2043	119	40481087	2010-04-24	2010-04-24 00:00:00	2010-05-15	2010-05-15 00:00:00	32020		\N	7899	0	444814009	40481087		0
2237	129	4112343	2002-09-07	2002-09-07 00:00:00	2002-09-14	2002-09-14 00:00:00	32020		\N	8672	0	195662009	4112343		0
2378	140	40481087	1994-05-10	1994-05-10 00:00:00	1994-05-31	1994-05-31 00:00:00	32020		\N	9396	0	444814009	40481087		0
2569	152	4056621	2010-12-25	2010-12-25 00:00:00	\N	\N	32020		\N	10246	0	197927001	4056621		0
2715	158	40481087	1983-04-18	1983-04-18 00:00:00	1983-05-09	1983-05-09 00:00:00	32020		\N	10795	0	444814009	40481087		0
2860	164	40481087	2007-01-04	2007-01-04 00:00:00	2007-01-18	2007-01-18 00:00:00	32020		\N	11305	0	444814009	40481087		0
3047	180	4112343	1985-09-28	1985-09-28 00:00:00	1985-10-08	1985-10-08 00:00:00	32020		\N	12121	0	195662009	4112343		0
3192	187	4112343	1990-06-29	1990-06-29 00:00:00	1990-07-08	1990-07-08 00:00:00	32020		\N	12696	0	195662009	4112343		0
3358	192	260139	2017-07-17	2017-07-17 00:00:00	2017-07-24	2017-07-24 00:00:00	32020		\N	13187	0	10509002	260139		0
3541	202	4112343	2005-04-26	2005-04-26 00:00:00	2005-05-07	2005-05-07 00:00:00	32020		\N	13850	0	195662009	4112343		0
3703	212	28060	1993-12-15	1993-12-15 00:00:00	1993-12-22	1993-12-22 00:00:00	32020		\N	14468	0	43878008	28060		0
3857	222	40481087	2004-11-04	2004-11-04 00:00:00	2004-11-25	2004-11-25 00:00:00	32020		\N	14951	0	444814009	40481087		0
4047	235	40481087	2008-07-13	2008-07-13 00:00:00	2008-07-27	2008-07-27 00:00:00	32020		\N	15784	0	444814009	40481087		0
4212	245	40481087	1987-03-04	1987-03-04 00:00:00	1987-03-25	1987-03-25 00:00:00	32020		\N	16440	0	444814009	40481087		0
4367	254	260139	1953-07-09	1953-07-09 00:00:00	1953-07-16	1953-07-16 00:00:00	32020		\N	16920	0	10509002	260139		0
4521	264	372328	1955-11-26	1955-11-26 00:00:00	1956-07-06	1956-07-06 00:00:00	32020		\N	17568	0	65363002	372328		0
4708	276	260139	1983-08-18	1983-08-18 00:00:00	1983-08-25	1983-08-25 00:00:00	32020		\N	18406	0	10509002	260139		0
4858	286	260139	1943-01-01	1943-01-01 00:00:00	1943-01-08	1943-01-08 00:00:00	32020		\N	19052	0	10509002	260139		0
5044	297	28060	1970-10-27	1970-10-27 00:00:00	1970-11-07	1970-11-07 00:00:00	32020		\N	19778	0	43878008	28060		0
5197	307	40481087	2008-04-02	2008-04-02 00:00:00	2008-04-23	2008-04-23 00:00:00	32020		\N	20385	0	444814009	40481087		0
5369	316	260139	2007-11-23	2007-11-23 00:00:00	2007-12-07	2007-12-07 00:00:00	32020		\N	20864	0	10509002	260139		0
5551	328	372328	1981-12-12	1981-12-12 00:00:00	1982-04-04	1982-04-04 00:00:00	32020		\N	21644	0	65363002	372328		0
5693	334	4230399	2006-08-29	2006-08-29 00:00:00	2006-09-28	2006-09-28 00:00:00	32020		\N	22116	0	359817006	4230399		0
5854	343	4048171	1972-02-07	1972-02-07 00:00:00	\N	\N	32020		\N	22852	0	232353008	4048171		0
6021	354	80180	1989-12-12	1989-12-12 00:00:00	\N	\N	32020		\N	23515	0	396275006	80180		0
6181	364	260139	1988-05-05	1988-05-05 00:00:00	1988-05-12	1988-05-12 00:00:00	32020		\N	24201	0	10509002	260139		0
6347	372	260139	1996-03-30	1996-03-30 00:00:00	1996-04-13	1996-04-13 00:00:00	32020		\N	24716	0	10509002	260139		0
6566	387	40481087	1999-10-29	1999-10-29 00:00:00	1999-11-19	1999-11-19 00:00:00	32020		\N	25473	0	444814009	40481087		0
6679	394	4112343	1987-05-11	1987-05-11 00:00:00	1987-05-20	1987-05-20 00:00:00	32020		\N	25917	0	195662009	4112343		0
6853	403	372328	1925-05-01	1925-05-01 00:00:00	1925-08-03	1925-08-03 00:00:00	32020		\N	26517	0	65363002	372328		0
7012	411	378001	2005-05-11	2005-05-11 00:00:00	2005-07-10	2005-07-10 00:00:00	32020		\N	27406	0	62106007	378001		0
7183	422	4112343	1984-02-07	1984-02-07 00:00:00	1984-02-14	1984-02-14 00:00:00	32020		\N	27967	0	195662009	4112343		0
7343	431	40481087	1954-11-13	1954-11-13 00:00:00	1954-11-27	1954-11-27 00:00:00	32020		\N	28550	0	444814009	40481087		0
7518	442	40481087	1998-07-06	1998-07-06 00:00:00	1998-07-20	1998-07-20 00:00:00	32020		\N	29417	0	444814009	40481087		0
7684	450	81151	2015-03-27	2015-03-27 00:00:00	2015-04-10	2015-04-10 00:00:00	32020		\N	30056	0	44465007	81151		0
7852	458	4116491	2009-08-04	2009-08-04 00:00:00	2009-09-16	2009-09-16 00:00:00	32020		\N	30630	0	301011002	4116491		0
8030	470	372328	1958-03-09	1958-03-09 00:00:00	1958-06-17	1958-06-17 00:00:00	32020		\N	31415	0	65363002	372328		0
8196	480	28060	1980-02-29	1980-02-29 00:00:00	1980-03-07	1980-03-07 00:00:00	32020		\N	32070	0	43878008	28060		0
8349	486	40481087	1989-08-01	1989-08-01 00:00:00	1989-08-15	1989-08-15 00:00:00	32020		\N	32480	0	444814009	40481087		0
8514	495	4266809	2005-06-28	2005-06-28 00:00:00	\N	\N	32020		\N	33101	0	397881000	4266809		0
8691	507	40481087	2001-03-13	2001-03-13 00:00:00	2001-04-03	2001-04-03 00:00:00	32020		\N	33979	0	444814009	40481087		0
8864	520	257012	1983-08-30	1983-08-30 00:00:00	1983-10-25	1983-10-25 00:00:00	32020		\N	34665	0	40055000	257012		0
9006	526	81151	1998-11-29	1998-11-29 00:00:00	1998-12-27	1998-12-27 00:00:00	32020		\N	35105	0	44465007	81151		0
9212	545	440086	1980-10-06	1980-10-06 00:00:00	1989-10-14	1989-10-14 00:00:00	32020		\N	36027	0	192127007	440086		0
9335	550	4112343	1964-09-10	1964-09-10 00:00:00	1964-09-17	1964-09-17 00:00:00	32020		\N	36534	0	195662009	4112343		0
9516	564	40481087	1971-12-31	1971-12-31 00:00:00	1972-01-07	1972-01-07 00:00:00	32020		\N	37361	0	444814009	40481087		0
9668	572	4112343	1992-09-06	1992-09-06 00:00:00	1992-09-14	1992-09-14 00:00:00	32020		\N	37869	0	195662009	4112343		0
9833	580	4113008	1994-07-30	1994-07-30 00:00:00	1994-08-13	1994-08-13 00:00:00	32020		\N	38453	0	284549007	4113008		0
10061	597	40481087	1954-10-30	1954-10-30 00:00:00	1954-11-06	1954-11-06 00:00:00	32020		\N	39471	0	444814009	40481087		0
10179	603	260139	2002-06-04	2002-06-04 00:00:00	2002-06-11	2002-06-11 00:00:00	32020		\N	40005	0	10509002	260139		0
10333	610	257012	1965-08-16	1965-08-16 00:00:00	\N	\N	32020		\N	40473	0	40055000	257012		0
10533	621	40481087	1918-07-30	1918-07-30 00:00:00	1918-08-13	1918-08-13 00:00:00	32020		\N	41429	0	444814009	40481087		0
39	2	4278672	1924-01-12	1924-01-12 00:00:00	1924-04-11	1924-04-11 00:00:00	32020		\N	111	0	65966004	4278672		0
227	11	4112343	1971-08-08	1971-08-08 00:00:00	1971-08-16	1971-08-16 00:00:00	32020		\N	945	0	195662009	4112343		0
371	19	4112343	2010-01-09	2010-01-09 00:00:00	2010-01-22	2010-01-22 00:00:00	32020		\N	1513	0	195662009	4112343		0
551	32	4113008	1959-04-25	1959-04-25 00:00:00	1959-05-09	1959-05-09 00:00:00	32020		\N	2237	0	284549007	4113008		0
724	40	80180	1993-07-12	1993-07-12 00:00:00	\N	\N	32020		\N	2850	0	396275006	80180		0
935	53	4230399	1988-02-26	1988-02-26 00:00:00	1988-04-26	1988-04-26 00:00:00	32020		\N	3684	0	359817006	4230399		0
1072	63	4059173	2008-02-19	2008-02-19 00:00:00	2008-05-20	2008-05-20 00:00:00	32020		\N	4299	0	16114001	4059173		0
1205	70	4285898	1983-03-29	1983-03-29 00:00:00	\N	\N	32020		\N	4767	0	68496003	4285898		0
1367	80	81151	1938-08-01	1938-08-01 00:00:00	1938-08-22	1938-08-22 00:00:00	32020		\N	5432	0	44465007	81151		0
1602	94	80180	1988-06-07	1988-06-07 00:00:00	\N	\N	32020		\N	6321	0	396275006	80180		0
1699	97	4112343	1943-09-19	1943-09-19 00:00:00	1943-09-27	1943-09-27 00:00:00	32020		\N	6575	0	195662009	4112343		0
1888	111	4112343	2011-12-18	2011-12-18 00:00:00	2011-12-30	2011-12-30 00:00:00	32020		\N	7371	0	195662009	4112343		0
2044	119	4112343	1956-03-29	1956-03-29 00:00:00	1956-04-09	1956-04-09 00:00:00	32020		\N	7863	0	195662009	4112343		0
2238	129	4112343	1993-08-01	1993-08-01 00:00:00	1993-08-09	1993-08-09 00:00:00	32020		\N	8674	0	195662009	4112343		0
2379	140	40481087	1981-10-03	1981-10-03 00:00:00	1981-10-10	1981-10-10 00:00:00	32020		\N	9407	0	444814009	40481087		0
2570	152	195588	2010-12-25	2010-12-25 00:00:00	2011-02-09	2011-02-09 00:00:00	32020		\N	10246	0	38822007	195588		0
2716	158	4156265	1992-06-23	1992-06-23 00:00:00	1992-07-07	1992-07-07 00:00:00	32020		\N	10791	0	370247008	4156265		0
2861	164	4112343	2011-12-23	2011-12-23 00:00:00	2012-01-03	2012-01-03 00:00:00	32020		\N	11284	0	195662009	4112343		0
3048	180	40481087	1990-12-15	1990-12-15 00:00:00	1990-12-29	1990-12-29 00:00:00	32020		\N	12133	0	444814009	40481087		0
3193	187	260139	1965-10-07	1965-10-07 00:00:00	1965-10-21	1965-10-21 00:00:00	32020		\N	12701	0	10509002	260139		0
3359	192	378001	1976-12-28	1976-12-28 00:00:00	1977-01-27	1977-01-27 00:00:00	32020		\N	13216	0	62106007	378001		0
3542	202	40481087	2010-03-04	2010-03-04 00:00:00	2010-03-25	2010-03-25 00:00:00	32020		\N	13851	0	444814009	40481087		0
3704	212	40481087	2009-09-13	2009-09-13 00:00:00	2009-09-27	2009-09-27 00:00:00	32020		\N	14469	0	444814009	40481087		0
3872	224	260139	2008-02-27	2008-02-27 00:00:00	2008-03-12	2008-03-12 00:00:00	32020		\N	15039	0	10509002	260139		0
4049	235	4029498	1992-05-08	1992-05-08 00:00:00	\N	\N	32020		\N	15757	0	128613002	4029498		0
4213	245	40481087	2004-05-16	2004-05-16 00:00:00	2004-06-06	2004-06-06 00:00:00	32020		\N	16455	0	444814009	40481087		0
4368	254	40481087	1969-03-23	1969-03-23 00:00:00	1969-04-06	1969-04-06 00:00:00	32020		\N	16923	0	444814009	40481087		0
4522	264	40481087	1988-07-01	1988-07-01 00:00:00	1988-07-15	1988-07-15 00:00:00	32020		\N	17573	0	444814009	40481087		0
4709	276	40481087	1981-11-21	1981-11-21 00:00:00	1981-12-05	1981-12-05 00:00:00	32020		\N	18416	0	444814009	40481087		0
4859	286	4283893	1936-08-13	1936-08-13 00:00:00	1936-10-22	1936-10-22 00:00:00	32020		\N	19051	0	36971009	4283893		0
5045	297	4112343	1963-07-18	1963-07-18 00:00:00	1963-07-31	1963-07-31 00:00:00	32020		\N	19804	0	195662009	4112343		0
5198	307	257012	2016-10-09	2016-10-09 00:00:00	\N	\N	32020		\N	20336	0	40055000	257012		0
5370	316	260139	2010-01-19	2010-01-19 00:00:00	2010-01-26	2010-01-26 00:00:00	32020		\N	20896	0	10509002	260139		0
5552	328	260139	2004-08-12	2004-08-12 00:00:00	2004-08-19	2004-08-19 00:00:00	32020		\N	21665	0	10509002	260139		0
5694	334	40480160	2006-08-29	2006-08-29 00:00:00	2006-09-28	2006-09-28 00:00:00	32020		\N	22116	0	443165006	40480160		0
5855	343	4112343	2013-02-17	2013-02-17 00:00:00	2013-02-26	2013-02-26 00:00:00	32020		\N	22963	0	195662009	4112343		0
6022	354	40481087	2017-06-09	2017-06-09 00:00:00	2017-06-16	2017-06-16 00:00:00	32020		\N	23550	0	444814009	40481087		0
6182	364	192671	1983-08-31	1983-08-31 00:00:00	\N	\N	32020		\N	24176	0	K92.2	35208414		0
6348	372	40481087	1996-04-16	1996-04-16 00:00:00	1996-05-07	1996-05-07 00:00:00	32020		\N	24747	0	444814009	40481087		0
6567	387	28060	1979-05-18	1979-05-18 00:00:00	1979-05-31	1979-05-31 00:00:00	32020		\N	25487	0	43878008	28060		0
6680	394	260139	1997-01-28	1997-01-28 00:00:00	1997-02-04	1997-02-04 00:00:00	32020		\N	25839	0	10509002	260139		0
6854	403	80180	1962-01-03	1962-01-03 00:00:00	\N	\N	32020		\N	26421	0	396275006	80180		0
7013	411	4112343	1989-08-30	1989-08-30 00:00:00	1989-09-08	1989-09-08 00:00:00	32020		\N	27311	0	195662009	4112343		0
7184	422	372328	1983-01-04	1983-01-04 00:00:00	1984-02-18	1984-02-18 00:00:00	32020		\N	27957	0	65363002	372328		0
7344	431	4112343	1995-06-19	1995-06-19 00:00:00	1995-06-30	1995-06-30 00:00:00	32020		\N	28623	0	195662009	4112343		0
7519	442	4283893	1951-01-11	1951-01-11 00:00:00	1951-02-01	1951-02-01 00:00:00	32020		\N	29292	0	36971009	4283893		0
7685	450	372328	1970-06-23	1970-06-23 00:00:00	1970-09-14	1970-09-14 00:00:00	32020		\N	30038	0	65363002	372328		0
7853	458	40481087	2014-05-09	2014-05-09 00:00:00	2014-05-30	2014-05-30 00:00:00	32020		\N	30650	0	444814009	40481087		0
8031	470	40481087	1956-11-07	1956-11-07 00:00:00	1956-11-21	1956-11-21 00:00:00	32020		\N	31386	0	444814009	40481087		0
8197	480	4112343	1998-01-04	1998-01-04 00:00:00	1998-01-12	1998-01-12 00:00:00	32020		\N	32091	0	195662009	4112343		0
8350	486	81893	1997-09-20	1997-09-20 00:00:00	\N	\N	32020		\N	32481	0	64766004	81893		0
8515	495	372328	1969-08-11	1969-08-11 00:00:00	1969-10-25	1969-10-25 00:00:00	32020		\N	33058	0	65363002	372328		0
8692	507	4155034	1994-05-11	1994-05-11 00:00:00	1994-05-25	1994-05-25 00:00:00	32020		\N	33958	0	283371005	4155034		0
8865	520	260139	1993-09-23	1993-09-23 00:00:00	1993-10-07	1993-10-07 00:00:00	32020		\N	34671	0	10509002	260139		0
9007	526	40481087	1990-03-30	1990-03-30 00:00:00	1990-04-20	1990-04-20 00:00:00	32020		\N	35049	0	444814009	40481087		0
9213	545	4155034	2018-09-30	2018-09-30 00:00:00	2018-10-21	2018-10-21 00:00:00	32020		\N	36147	0	283371005	4155034		0
9336	550	4278672	1977-07-29	1977-07-29 00:00:00	1977-09-27	1977-09-27 00:00:00	32020		\N	36449	0	65966004	4278672		0
9517	564	372328	1956-07-16	1956-07-16 00:00:00	1956-09-27	1956-09-27 00:00:00	32020		\N	37384	0	65363002	372328		0
9669	572	260139	2008-09-26	2008-09-26 00:00:00	2008-10-10	2008-10-10 00:00:00	32020		\N	37870	0	10509002	260139		0
9834	580	372328	1928-01-01	1928-01-01 00:00:00	1928-01-15	1928-01-15 00:00:00	32020		\N	38470	0	65363002	372328		0
10062	597	28060	1970-06-30	1970-06-30 00:00:00	1970-07-13	1970-07-13 00:00:00	32020		\N	39446	0	43878008	28060		0
10180	603	372328	1959-08-21	1959-08-21 00:00:00	1960-02-12	1960-02-12 00:00:00	32020		\N	40008	0	65363002	372328		0
10334	610	4155034	1963-08-25	1963-08-25 00:00:00	1963-09-08	1963-09-08 00:00:00	32020		\N	40587	0	283371005	4155034		0
10534	621	4294548	1976-06-14	1976-06-14 00:00:00	1976-08-23	1976-08-23 00:00:00	32020		\N	41432	0	75498004	4294548		0
40	2	4112343	1984-08-14	1984-08-14 00:00:00	1984-08-27	1984-08-27 00:00:00	32020		\N	91	0	195662009	4112343		0
228	11	40481087	1964-03-16	1964-03-16 00:00:00	1964-03-23	1964-03-23 00:00:00	32020		\N	921	0	444814009	40481087		0
372	19	4230399	2003-07-16	2003-07-16 00:00:00	2003-08-15	2003-08-15 00:00:00	32020		\N	1545	0	359817006	4230399		0
552	32	40481087	1985-06-19	1985-06-19 00:00:00	1985-06-26	1985-06-26 00:00:00	32020		\N	2245	0	444814009	40481087		0
725	40	260139	1972-02-28	1972-02-28 00:00:00	1972-03-06	1972-03-06 00:00:00	32020		\N	2868	0	10509002	260139		0
936	53	4283893	2011-08-11	2011-08-11 00:00:00	2011-12-01	2011-12-01 00:00:00	32020		\N	3639	0	36971009	4283893		0
1073	63	81151	1966-03-12	1966-03-12 00:00:00	1966-04-16	1966-04-16 00:00:00	32020		\N	4296	0	44465007	81151		0
1206	70	81893	1982-10-30	1982-10-30 00:00:00	\N	\N	32020		\N	4767	0	64766004	81893		0
1368	80	81151	2018-03-14	2018-03-14 00:00:00	2018-04-11	2018-04-11 00:00:00	32020		\N	5435	0	44465007	81151		0
1603	94	372328	1954-05-17	1954-05-17 00:00:00	1954-09-03	1954-09-03 00:00:00	32020		\N	6359	0	65363002	372328		0
1700	97	40481087	1971-07-07	1971-07-07 00:00:00	1971-07-28	1971-07-28 00:00:00	32020		\N	6666	0	444814009	40481087		0
1889	111	80180	2012-02-07	2012-02-07 00:00:00	\N	\N	32020		\N	7371	0	396275006	80180		0
2045	119	81151	2008-12-18	2008-12-18 00:00:00	2009-01-08	2009-01-08 00:00:00	32020		\N	7924	0	44465007	81151		0
2239	129	28060	1986-10-07	1986-10-07 00:00:00	1986-10-18	1986-10-18 00:00:00	32020		\N	8673	0	43878008	28060		0
2380	140	260139	1986-12-05	1986-12-05 00:00:00	1986-12-19	1986-12-19 00:00:00	32020		\N	9408	0	10509002	260139		0
2571	152	4237458	1992-02-17	1992-02-17 00:00:00	1992-03-18	1992-03-18 00:00:00	32020		\N	10292	0	58150001	4237458		0
2717	158	260139	2014-03-29	2014-03-29 00:00:00	2014-04-05	2014-04-05 00:00:00	32020		\N	10846	0	10509002	260139		0
2862	164	4283893	1972-01-08	1972-01-08 00:00:00	1972-02-19	1972-02-19 00:00:00	32020		\N	11293	0	36971009	4283893		0
3049	180	4112343	1999-04-13	1999-04-13 00:00:00	1999-04-25	1999-04-25 00:00:00	32020		\N	12091	0	195662009	4112343		0
3194	187	40481087	1985-11-24	1985-11-24 00:00:00	1985-12-15	1985-12-15 00:00:00	32020		\N	12668	0	444814009	40481087		0
3360	192	40481087	1986-01-19	1986-01-19 00:00:00	1986-02-02	1986-02-02 00:00:00	32020		\N	13207	0	444814009	40481087		0
3543	202	257012	1962-12-27	1962-12-27 00:00:00	1963-01-03	1963-01-03 00:00:00	32020		\N	13841	0	40055000	257012		0
3705	212	28060	1972-09-07	1972-09-07 00:00:00	1972-09-18	1972-09-18 00:00:00	32020		\N	14465	0	43878008	28060		0
3873	224	28060	1959-07-04	1959-07-04 00:00:00	1959-07-17	1959-07-17 00:00:00	32020		\N	15084	0	43878008	28060		0
4050	235	4294548	1988-10-08	1988-10-08 00:00:00	1988-11-05	1988-11-05 00:00:00	32020		\N	15780	0	75498004	4294548		0
4214	245	40481087	1944-05-14	1944-05-14 00:00:00	1944-06-04	1944-06-04 00:00:00	32020		\N	16475	0	444814009	40481087		0
4369	254	28060	1986-06-08	1986-06-08 00:00:00	1986-06-18	1986-06-18 00:00:00	32020		\N	16965	0	43878008	28060		0
4523	264	4112343	1961-09-12	1961-09-12 00:00:00	1961-09-24	1961-09-24 00:00:00	32020		\N	17510	0	195662009	4112343		0
4710	276	40481087	2008-01-26	2008-01-26 00:00:00	2008-02-16	2008-02-16 00:00:00	32020		\N	18444	0	444814009	40481087		0
4860	286	40481087	1934-12-09	1934-12-09 00:00:00	1934-12-16	1934-12-16 00:00:00	32020		\N	19090	0	444814009	40481087		0
5046	297	40481087	2000-08-04	2000-08-04 00:00:00	2000-08-18	2000-08-18 00:00:00	32020		\N	19772	0	444814009	40481087		0
5199	307	372328	1979-10-27	1979-10-27 00:00:00	1980-11-08	1980-11-08 00:00:00	32020		\N	20337	0	65363002	372328		0
5371	316	40481087	2014-12-19	2014-12-19 00:00:00	2015-01-09	2015-01-09 00:00:00	32020		\N	20865	0	444814009	40481087		0
5553	328	40481087	1999-12-25	1999-12-25 00:00:00	2000-01-08	2000-01-08 00:00:00	32020		\N	21663	0	444814009	40481087		0
5695	334	4218389	1982-02-08	1982-02-08 00:00:00	1982-03-08	1982-03-08 00:00:00	32020		\N	22114	0	39848009	4218389		0
5856	343	260139	1981-10-01	1981-10-01 00:00:00	1981-10-08	1981-10-08 00:00:00	32020		\N	22917	0	10509002	260139		0
6023	354	4218389	2008-06-12	2008-06-12 00:00:00	2008-07-03	2008-07-03 00:00:00	32020		\N	23547	0	39848009	4218389		0
6183	364	40481087	2013-11-03	2013-11-03 00:00:00	2013-11-17	2013-11-17 00:00:00	32020		\N	24159	0	444814009	40481087		0
6349	372	4134304	1962-05-08	1962-05-08 00:00:00	1962-07-07	1962-07-07 00:00:00	32020		\N	24785	0	263102004	4134304		0
6568	387	4112343	2014-01-29	2014-01-29 00:00:00	2014-02-09	2014-02-09 00:00:00	32020		\N	25490	0	195662009	4112343		0
6681	394	80180	1957-06-10	1957-06-10 00:00:00	\N	\N	32020		\N	25848	0	396275006	80180		0
6855	403	81151	1996-08-02	1996-08-02 00:00:00	1996-08-23	1996-08-23 00:00:00	32020		\N	26466	0	44465007	81151		0
7014	411	28060	1963-11-28	1963-11-28 00:00:00	1963-12-05	1963-12-05 00:00:00	32020		\N	27364	0	43878008	28060		0
7185	422	4116491	1984-02-07	1984-02-07 00:00:00	1984-04-01	1984-04-01 00:00:00	32020		\N	27967	0	301011002	4116491		0
7345	431	81151	1967-01-21	1967-01-21 00:00:00	1967-02-25	1967-02-25 00:00:00	32020		\N	28594	0	44465007	81151		0
7520	442	378419	2016-07-02	2016-07-02 00:00:00	\N	\N	32020		\N	29276	0	26929004	378419		0
7689	452	80180	2002-04-15	2002-04-15 00:00:00	\N	\N	32020		\N	30079	0	396275006	80180		0
7854	458	372328	1973-03-11	1973-03-11 00:00:00	1973-04-22	1973-04-22 00:00:00	32020		\N	30617	0	65363002	372328		0
8032	470	40481087	1971-12-10	1971-12-10 00:00:00	1971-12-31	1971-12-31 00:00:00	32020		\N	31419	0	444814009	40481087		0
8198	480	80180	1983-06-22	1983-06-22 00:00:00	\N	\N	32020		\N	32010	0	396275006	80180		0
8351	486	4310024	1997-08-21	1997-08-21 00:00:00	\N	\N	32020		\N	32481	0	424802006	4310024		0
8531	498	4112343	2016-06-12	2016-06-12 00:00:00	2016-06-24	2016-06-24 00:00:00	32020		\N	33292	0	195662009	4112343		0
8693	507	260139	1944-01-21	1944-01-21 00:00:00	1944-01-28	1944-01-28 00:00:00	32020		\N	33961	0	10509002	260139		0
8866	520	40481087	1970-02-03	1970-02-03 00:00:00	1970-02-17	1970-02-17 00:00:00	32020		\N	34667	0	444814009	40481087		0
9008	526	4166224	2008-02-16	2008-02-16 00:00:00	\N	\N	32020		\N	35106	0	47693006	4166224		0
9214	545	4112343	1981-01-31	1981-01-31 00:00:00	1981-02-10	1981-02-10 00:00:00	32020		\N	36134	0	195662009	4112343		0
9337	550	40481087	1999-02-22	1999-02-22 00:00:00	1999-03-01	1999-03-01 00:00:00	32020		\N	36441	0	444814009	40481087		0
9518	564	40481087	2012-12-26	2012-12-26 00:00:00	2013-01-02	2013-01-02 00:00:00	32020		\N	37333	0	444814009	40481087		0
9670	572	40481087	1964-04-05	1964-04-05 00:00:00	1964-04-19	1964-04-19 00:00:00	32020		\N	37917	0	444814009	40481087		0
9835	580	260139	1942-08-16	1942-08-16 00:00:00	1942-08-23	1942-08-23 00:00:00	32020		\N	38404	0	10509002	260139		0
10063	597	192671	1987-04-14	1987-04-14 00:00:00	\N	\N	32020		\N	39475	0	K92.2	35208414		0
10181	603	260139	1979-04-09	1979-04-09 00:00:00	1979-04-23	1979-04-23 00:00:00	32020		\N	39987	0	10509002	260139		0
10335	610	4278672	2008-12-04	2008-12-04 00:00:00	2009-02-02	2009-02-02 00:00:00	32020		\N	40482	0	65966004	4278672		0
10535	621	4112343	1919-05-05	1919-05-05 00:00:00	1919-05-13	1919-05-13 00:00:00	32020		\N	41413	0	195662009	4112343		0
41	2	378419	2000-07-25	2000-07-25 00:00:00	\N	\N	32020		\N	186	0	26929004	378419		0
229	11	80180	1987-06-15	1987-06-15 00:00:00	\N	\N	32020		\N	933	0	396275006	80180		0
373	19	140673	2004-01-17	2004-01-17 00:00:00	\N	\N	32020		\N	1497	0	40930008	140673		0
553	32	4283893	1967-01-29	1967-01-29 00:00:00	1967-07-02	1967-07-02 00:00:00	32020		\N	2268	0	36971009	4283893		0
726	40	28060	1983-09-01	1983-09-01 00:00:00	1983-09-14	1983-09-14 00:00:00	32020		\N	2870	0	43878008	28060		0
937	53	4001336	1966-06-16	1966-06-16 00:00:00	1966-08-15	1966-08-15 00:00:00	32020		\N	3632	0	110030002	4001336		0
1074	63	372328	1978-03-31	1978-03-31 00:00:00	1980-12-24	1980-12-24 00:00:00	32020		\N	4306	0	65363002	372328		0
1207	70	372328	1982-08-17	1982-08-17 00:00:00	1984-02-05	1984-02-05 00:00:00	32020		\N	4767	0	65363002	372328		0
1369	80	40481087	1959-05-23	1959-05-23 00:00:00	1959-05-30	1959-05-30 00:00:00	32020		\N	5464	0	444814009	40481087		0
1604	94	40481087	2009-01-24	2009-01-24 00:00:00	2009-02-14	2009-02-14 00:00:00	32020		\N	6304	0	444814009	40481087		0
1701	97	4116491	1966-11-01	1966-11-01 00:00:00	1966-12-22	1966-12-22 00:00:00	32020		\N	6614	0	301011002	4116491		0
1890	111	4112343	1994-12-30	1994-12-30 00:00:00	1995-01-12	1995-01-12 00:00:00	32020		\N	7374	0	195662009	4112343		0
2046	119	4112343	1991-02-10	1991-02-10 00:00:00	1991-02-17	1991-02-17 00:00:00	32020		\N	7867	0	195662009	4112343		0
2240	129	40481087	1989-10-09	1989-10-09 00:00:00	1989-10-30	1989-10-30 00:00:00	32020		\N	8683	0	444814009	40481087		0
2381	140	40481087	1999-08-11	1999-08-11 00:00:00	1999-08-18	1999-08-18 00:00:00	32020		\N	9369	0	444814009	40481087		0
2572	152	4294548	1986-08-10	1986-08-10 00:00:00	1987-01-11	1987-01-11 00:00:00	32020		\N	10228	0	75498004	4294548		0
2718	158	4296204	1952-01-29	1952-01-29 00:00:00	1952-02-19	1952-02-19 00:00:00	32020		\N	10849	0	403190006	4296204		0
2863	164	4109685	2018-09-25	2018-09-25 00:00:00	2018-10-09	2018-10-09 00:00:00	32020		\N	11281	0	284551006	4109685		0
3050	180	40481087	2007-12-01	2007-12-01 00:00:00	2007-12-15	2007-12-15 00:00:00	32020		\N	12149	0	444814009	40481087		0
3195	187	40481087	1962-04-07	1962-04-07 00:00:00	1962-04-14	1962-04-14 00:00:00	32020		\N	12713	0	444814009	40481087		0
3361	192	378001	1979-03-18	1979-03-18 00:00:00	1979-05-17	1979-05-17 00:00:00	32020		\N	13217	0	62106007	378001		0
3544	202	192671	1982-05-16	1982-05-16 00:00:00	\N	\N	32020		\N	13878	0	K92.2	35208414		0
3706	212	40481087	1973-10-02	1973-10-02 00:00:00	1973-10-23	1973-10-23 00:00:00	32020		\N	14411	0	444814009	40481087		0
3874	224	375671	1954-12-09	1954-12-09 00:00:00	1955-01-08	1955-01-08 00:00:00	32020		\N	15089	0	62564004	375671		0
4051	235	28060	1988-12-02	1988-12-02 00:00:00	1988-12-14	1988-12-14 00:00:00	32020		\N	15781	0	43878008	28060		0
4215	245	4296205	1942-04-03	1942-04-03 00:00:00	1942-05-01	1942-05-01 00:00:00	32020		\N	16442	0	403191005	4296205		0
4370	254	40481087	1975-07-13	1975-07-13 00:00:00	1975-08-03	1975-08-03 00:00:00	32020		\N	16957	0	444814009	40481087		0
4524	264	260139	1958-05-23	1958-05-23 00:00:00	1958-05-30	1958-05-30 00:00:00	32020		\N	17508	0	10509002	260139		0
4711	276	40481087	1991-01-09	1991-01-09 00:00:00	1991-01-23	1991-01-23 00:00:00	32020		\N	18430	0	444814009	40481087		0
4861	286	28060	1934-02-04	1934-02-04 00:00:00	1934-02-17	1934-02-17 00:00:00	32020		\N	19089	0	43878008	28060		0
5047	297	40481087	1964-10-23	1964-10-23 00:00:00	1964-11-13	1964-11-13 00:00:00	32020		\N	19776	0	444814009	40481087		0
5200	307	40481087	1979-11-02	1979-11-02 00:00:00	1979-11-09	1979-11-09 00:00:00	32020		\N	20368	0	444814009	40481087		0
5372	316	260139	1937-10-24	1937-10-24 00:00:00	1937-11-07	1937-11-07 00:00:00	32020		\N	20861	0	10509002	260139		0
5554	328	40481087	1984-08-05	1984-08-05 00:00:00	1984-08-19	1984-08-19 00:00:00	32020		\N	21670	0	444814009	40481087		0
5696	334	260139	1982-08-25	1982-08-25 00:00:00	1982-09-02	1982-09-02 00:00:00	32020		\N	22114	0	10509002	260139		0
5857	343	81893	2003-09-20	2003-09-20 00:00:00	\N	\N	32020		\N	22937	0	64766004	81893		0
6024	354	40481087	1992-09-24	1992-09-24 00:00:00	1992-10-01	1992-10-01 00:00:00	32020		\N	23525	0	444814009	40481087		0
6184	364	372328	1947-10-20	1947-10-20 00:00:00	1948-01-25	1948-01-25 00:00:00	32020		\N	24136	0	65363002	372328		0
6350	372	40481087	1993-11-05	1993-11-05 00:00:00	1993-11-19	1993-11-19 00:00:00	32020		\N	24758	0	444814009	40481087		0
6569	388	372328	1956-08-04	1956-08-04 00:00:00	1957-01-22	1957-01-22 00:00:00	32020		\N	25555	0	65363002	372328		0
6682	394	260139	1962-11-14	1962-11-14 00:00:00	1962-11-21	1962-11-21 00:00:00	32020		\N	25887	0	10509002	260139		0
6856	403	4155034	1929-07-20	1929-07-20 00:00:00	1929-08-03	1929-08-03 00:00:00	32020		\N	26535	0	283371005	4155034		0
7015	411	260139	1973-11-17	1973-11-17 00:00:00	1973-12-01	1973-12-01 00:00:00	32020		\N	27309	0	10509002	260139		0
7186	422	4112343	2011-05-15	2011-05-15 00:00:00	2011-05-23	2011-05-23 00:00:00	32020		\N	27954	0	195662009	4112343		0
7346	431	40481087	1985-06-22	1985-06-22 00:00:00	1985-06-29	1985-06-29 00:00:00	32020		\N	28585	0	444814009	40481087		0
7521	442	4218389	1951-06-03	1951-06-03 00:00:00	1951-07-01	1951-07-01 00:00:00	32020		\N	29285	0	39848009	4218389		0
7690	452	4112343	2002-02-24	2002-02-24 00:00:00	2002-03-04	2002-03-04 00:00:00	32020		\N	30079	0	195662009	4112343		0
7855	458	260139	1991-12-12	1991-12-12 00:00:00	1991-12-19	1991-12-19 00:00:00	32020		\N	30648	0	10509002	260139		0
8033	470	40481087	2008-12-11	2008-12-11 00:00:00	2009-01-01	2009-01-01 00:00:00	32020		\N	31420	0	444814009	40481087		0
8199	480	40481087	2003-03-01	2003-03-01 00:00:00	2003-03-08	2003-03-08 00:00:00	32020		\N	32031	0	444814009	40481087		0
8352	486	4056621	1997-01-05	1997-01-05 00:00:00	\N	\N	32020		\N	32481	0	197927001	4056621		0
8532	498	372328	1974-08-02	1974-08-02 00:00:00	1974-10-31	1974-10-31 00:00:00	32020		\N	33293	0	65363002	372328		0
8694	507	372328	1943-06-24	1943-06-24 00:00:00	1943-07-30	1943-07-30 00:00:00	32020		\N	33903	0	65363002	372328		0
8867	520	40481087	2010-03-15	2010-03-15 00:00:00	2010-03-29	2010-03-29 00:00:00	32020		\N	34675	0	444814009	40481087		0
9009	526	440448	2008-02-16	2008-02-16 00:00:00	\N	\N	32020		\N	35106	0	74400008	440448		0
9215	545	81893	2003-11-25	2003-11-25 00:00:00	\N	\N	32020		\N	36096	0	64766004	81893		0
9338	550	260139	1983-06-20	1983-06-20 00:00:00	1983-06-27	1983-06-27 00:00:00	32020		\N	36536	0	10509002	260139		0
9519	564	40481087	1984-12-04	1984-12-04 00:00:00	1984-12-25	1984-12-25 00:00:00	32020		\N	37332	0	444814009	40481087		0
9671	572	372328	1956-01-22	1956-01-22 00:00:00	1956-03-30	1956-03-30 00:00:00	32020		\N	37873	0	65363002	372328		0
9836	580	4112343	1930-12-17	1930-12-17 00:00:00	1930-12-26	1930-12-26 00:00:00	32020		\N	38443	0	195662009	4112343		0
10064	597	4027663	1980-04-28	1980-04-28 00:00:00	\N	\N	32020		\N	39436	0	13200003	4027663		0
10182	603	40481087	2009-04-07	2009-04-07 00:00:00	2009-04-21	2009-04-21 00:00:00	32020		\N	40007	0	444814009	40481087		0
10336	610	4112343	1991-10-14	1991-10-14 00:00:00	1991-10-21	1991-10-21 00:00:00	32020		\N	40536	0	195662009	4112343		0
10536	621	4112343	1931-10-15	1931-10-15 00:00:00	1931-10-28	1931-10-28 00:00:00	32020		\N	41414	0	195662009	4112343		0
42	2	260139	1980-07-25	1980-07-25 00:00:00	1980-08-10	1980-08-10 00:00:00	32020		\N	191	0	10509002	260139		0
230	11	40481087	1970-07-28	1970-07-28 00:00:00	1970-08-04	1970-08-04 00:00:00	32020		\N	944	0	444814009	40481087		0
374	19	313217	2011-04-10	2011-04-10 00:00:00	\N	\N	32020		\N	1471	0	49436004	313217		0
554	32	4112343	1982-07-26	1982-07-26 00:00:00	1982-08-08	1982-08-08 00:00:00	32020		\N	2259	0	195662009	4112343		0
727	40	372328	1952-11-29	1952-11-29 00:00:00	1953-02-11	1953-02-11 00:00:00	32020		\N	2880	0	65363002	372328		0
938	53	4112343	1964-10-06	1964-10-06 00:00:00	1964-10-13	1964-10-13 00:00:00	32020		\N	3658	0	195662009	4112343		0
1075	63	78272	1956-12-08	1956-12-08 00:00:00	1956-12-29	1956-12-29 00:00:00	32020		\N	4295	0	70704007	78272		0
1208	70	30753	1982-11-29	1982-11-29 00:00:00	\N	\N	32020		\N	4767	0	16761005	30753		0
1370	80	40481087	1946-10-31	1946-10-31 00:00:00	1946-11-21	1946-11-21 00:00:00	32020		\N	5398	0	444814009	40481087		0
1605	94	260139	1994-10-24	1994-10-24 00:00:00	1994-11-07	1994-11-07 00:00:00	32020		\N	6369	0	10509002	260139		0
1702	97	4059173	1959-09-23	1959-09-23 00:00:00	1959-11-22	1959-11-22 00:00:00	32020		\N	6642	0	16114001	4059173		0
1891	111	40481087	1980-09-21	1980-09-21 00:00:00	1980-10-05	1980-10-05 00:00:00	32020		\N	7415	0	444814009	40481087		0
2047	119	372328	2015-02-15	2015-02-15 00:00:00	2016-02-23	2016-02-23 00:00:00	32020		\N	7872	0	65363002	372328		0
2241	129	372328	1975-08-03	1975-08-03 00:00:00	1975-09-15	1975-09-15 00:00:00	32020		\N	8715	0	65363002	372328		0
2382	140	81151	1992-03-25	1992-03-25 00:00:00	1992-04-22	1992-04-22 00:00:00	32020		\N	9417	0	44465007	81151		0
2573	152	4112343	1998-10-22	1998-10-22 00:00:00	1998-10-31	1998-10-31 00:00:00	32020		\N	10252	0	195662009	4112343		0
2719	158	4278672	1948-10-25	1948-10-25 00:00:00	1949-01-23	1949-01-23 00:00:00	32020		\N	10847	0	65966004	4278672		0
2864	164	40481087	1990-07-01	1990-07-01 00:00:00	1990-07-22	1990-07-22 00:00:00	32020		\N	11296	0	444814009	40481087		0
3051	180	372328	1977-12-17	1977-12-17 00:00:00	1978-03-30	1978-03-30 00:00:00	32020		\N	12093	0	65363002	372328		0
3196	187	40481087	1967-12-03	1967-12-03 00:00:00	1967-12-24	1967-12-24 00:00:00	32020		\N	12715	0	444814009	40481087		0
3362	192	40481087	1967-02-05	1967-02-05 00:00:00	1967-02-26	1967-02-26 00:00:00	32020		\N	13147	0	444814009	40481087		0
3545	202	81151	1942-04-13	1942-04-13 00:00:00	1942-05-18	1942-05-18 00:00:00	32020		\N	13880	0	44465007	81151		0
3707	212	40481087	1970-05-25	1970-05-25 00:00:00	1970-06-15	1970-06-15 00:00:00	32020		\N	14464	0	444814009	40481087		0
3875	224	260139	1985-12-28	1985-12-28 00:00:00	1986-01-11	1986-01-11 00:00:00	32020		\N	15037	0	10509002	260139		0
4052	235	4278672	2000-10-03	2000-10-03 00:00:00	2000-11-02	2000-11-02 00:00:00	32020		\N	15759	0	65966004	4278672		0
4216	245	81151	2004-12-20	2004-12-20 00:00:00	2005-01-03	2005-01-03 00:00:00	32020		\N	16404	0	44465007	81151		0
4371	254	80180	1985-06-05	1985-06-05 00:00:00	\N	\N	32020		\N	16972	0	396275006	80180		0
4525	264	4156265	2007-06-16	2007-06-16 00:00:00	2007-07-07	2007-07-07 00:00:00	32020		\N	17588	0	370247008	4156265		0
4712	277	40481087	2001-12-17	2001-12-17 00:00:00	2001-12-24	2001-12-24 00:00:00	32020		\N	18492	0	444814009	40481087		0
4862	286	40481087	1993-08-19	1993-08-19 00:00:00	1993-09-02	1993-09-02 00:00:00	32020		\N	19087	0	444814009	40481087		0
5048	297	40481087	1954-03-10	1954-03-10 00:00:00	1954-03-24	1954-03-24 00:00:00	32020		\N	19767	0	444814009	40481087		0
5201	307	81151	1983-08-05	1983-08-05 00:00:00	1983-08-26	1983-08-26 00:00:00	32020		\N	20380	0	44465007	81151		0
5373	316	40481087	1966-08-03	1966-08-03 00:00:00	1966-08-10	1966-08-10 00:00:00	32020		\N	20962	0	444814009	40481087		0
5555	328	4027663	2007-10-22	2007-10-22 00:00:00	\N	\N	32020		\N	21640	0	13200003	4027663		0
5697	334	40481087	2006-04-22	2006-04-22 00:00:00	2006-04-29	2006-04-29 00:00:00	32020		\N	22132	0	444814009	40481087		0
5858	343	4310024	2003-03-24	2003-03-24 00:00:00	\N	\N	32020		\N	22937	0	424802006	4310024		0
6025	354	4296204	1989-10-29	1989-10-29 00:00:00	1989-11-19	1989-11-19 00:00:00	32020		\N	23546	0	403190006	4296204		0
6185	364	372328	1950-02-13	1950-02-13 00:00:00	1950-07-30	1950-07-30 00:00:00	32020		\N	24203	0	65363002	372328		0
6351	372	4112343	1969-07-18	1969-07-18 00:00:00	1969-07-26	1969-07-26 00:00:00	32020		\N	24713	0	195662009	4112343		0
6570	388	4283893	1955-07-20	1955-07-20 00:00:00	1956-01-18	1956-01-18 00:00:00	32020		\N	25562	0	36971009	4283893		0
6683	394	4112343	1955-02-10	1955-02-10 00:00:00	1955-02-18	1955-02-18 00:00:00	32020		\N	25886	0	195662009	4112343		0
6857	403	257012	1935-01-23	1935-01-23 00:00:00	\N	\N	32020		\N	26433	0	40055000	257012		0
7016	411	40481087	2002-07-13	2002-07-13 00:00:00	2002-08-03	2002-08-03 00:00:00	32020		\N	27335	0	444814009	40481087		0
7187	422	40481087	1994-07-28	1994-07-28 00:00:00	1994-08-18	1994-08-18 00:00:00	32020		\N	27931	0	444814009	40481087		0
7347	431	40481087	1984-08-12	1984-08-12 00:00:00	1984-08-19	1984-08-19 00:00:00	32020		\N	28621	0	444814009	40481087		0
7522	442	4294548	2013-03-29	2013-03-29 00:00:00	2013-06-07	2013-06-07 00:00:00	32020		\N	29346	0	75498004	4294548		0
7691	452	4112343	1989-02-02	1989-02-02 00:00:00	1989-02-11	1989-02-11 00:00:00	32020		\N	30137	0	195662009	4112343		0
7856	458	4112343	1981-01-04	1981-01-04 00:00:00	1981-01-11	1981-01-11 00:00:00	32020		\N	30665	0	195662009	4112343		0
8034	470	4294548	1956-05-11	1956-05-11 00:00:00	1956-06-01	1956-06-01 00:00:00	32020		\N	31385	0	75498004	4294548		0
8200	480	260139	1995-02-13	1995-02-13 00:00:00	1995-02-27	1995-02-27 00:00:00	32020		\N	31982	0	10509002	260139		0
8353	486	195588	1997-01-05	1997-01-05 00:00:00	1997-02-11	1997-02-11 00:00:00	32020		\N	32481	0	38822007	195588		0
8533	498	4112343	1972-06-14	1972-06-14 00:00:00	1972-06-22	1972-06-22 00:00:00	32020		\N	33245	0	195662009	4112343		0
8695	507	40481087	1963-07-13	1963-07-13 00:00:00	1963-07-27	1963-07-27 00:00:00	32020		\N	33948	0	444814009	40481087		0
8868	520	80502	2011-01-06	2011-01-06 00:00:00	\N	\N	32020		\N	34741	0	64859006	80502		0
9010	526	260139	2018-04-14	2018-04-14 00:00:00	2018-04-21	2018-04-21 00:00:00	32020		\N	35099	0	10509002	260139		0
9216	545	4266809	2004-05-23	2004-05-23 00:00:00	\N	\N	32020		\N	36096	0	397881000	4266809		0
9342	552	4112343	1980-12-18	1980-12-18 00:00:00	1980-12-27	1980-12-27 00:00:00	32020		\N	36662	0	195662009	4112343		0
9520	564	4112343	1968-09-27	1968-09-27 00:00:00	1968-10-07	1968-10-07 00:00:00	32020		\N	37312	0	195662009	4112343		0
9672	572	81151	2003-11-05	2003-11-05 00:00:00	2003-11-26	2003-11-26 00:00:00	32020		\N	37862	0	44465007	81151		0
9837	580	80502	1997-10-05	1997-10-05 00:00:00	\N	\N	32020		\N	38467	0	64859006	80502		0
10065	597	28060	1962-06-14	1962-06-14 00:00:00	1962-06-26	1962-06-26 00:00:00	32020		\N	39422	0	43878008	28060		0
10183	603	4112343	1978-01-15	1978-01-15 00:00:00	1978-01-28	1978-01-28 00:00:00	32020		\N	39941	0	195662009	4112343		0
10337	610	260139	1993-05-21	1993-05-21 00:00:00	1993-06-04	1993-06-04 00:00:00	32020		\N	40590	0	10509002	260139		0
10537	621	40481087	1997-01-04	1997-01-04 00:00:00	1997-01-18	1997-01-18 00:00:00	32020		\N	41364	0	444814009	40481087		0
43	2	40481087	1955-01-16	1955-01-16 00:00:00	1955-01-30	1955-01-30 00:00:00	32020		\N	154	0	444814009	40481087		0
231	11	4218389	1994-05-20	1994-05-20 00:00:00	1994-06-24	1994-06-24 00:00:00	32020		\N	991	0	39848009	4218389		0
375	19	40481087	1956-12-24	1956-12-24 00:00:00	1956-12-31	1956-12-31 00:00:00	32020		\N	1450	0	444814009	40481087		0
555	32	4112343	1947-08-08	1947-08-08 00:00:00	1947-08-15	1947-08-15 00:00:00	32020		\N	2267	0	195662009	4112343		0
728	40	260139	1964-12-28	1964-12-28 00:00:00	1965-01-04	1965-01-04 00:00:00	32020		\N	2799	0	10509002	260139		0
939	53	372328	1962-12-13	1962-12-13 00:00:00	1963-01-23	1963-01-23 00:00:00	32020		\N	3697	0	65363002	372328		0
1076	63	372328	1956-10-10	1956-10-10 00:00:00	1956-11-21	1956-11-21 00:00:00	32020		\N	4305	0	65363002	372328		0
1209	70	4112343	1964-02-18	1964-02-18 00:00:00	1964-02-27	1964-02-27 00:00:00	32020		\N	4723	0	195662009	4112343		0
1371	80	28060	1951-03-25	1951-03-25 00:00:00	1951-04-06	1951-04-06 00:00:00	32020		\N	5439	0	43878008	28060		0
1606	94	381316	2005-01-28	2005-01-28 00:00:00	\N	\N	32020		\N	6358	0	230690007	381316		0
1709	99	28060	1967-10-11	1967-10-11 00:00:00	1967-10-19	1967-10-19 00:00:00	32020		\N	6718	0	43878008	28060		0
1892	111	378001	1977-03-22	1977-03-22 00:00:00	1977-04-21	1977-04-21 00:00:00	32020		\N	7412	0	62106007	378001		0
2048	119	40481087	1973-11-30	1973-11-30 00:00:00	1973-12-21	1973-12-21 00:00:00	32020		\N	7885	0	444814009	40481087		0
2242	129	40481087	1984-02-24	1984-02-24 00:00:00	1984-03-02	1984-03-02 00:00:00	32020		\N	8670	0	444814009	40481087		0
2383	140	4112343	1998-05-07	1998-05-07 00:00:00	1998-05-18	1998-05-18 00:00:00	32020		\N	9379	0	195662009	4112343		0
2574	152	80180	2000-03-11	2000-03-11 00:00:00	\N	\N	32020		\N	10252	0	396275006	80180		0
2720	158	260139	1953-08-31	1953-08-31 00:00:00	1953-09-14	1953-09-14 00:00:00	32020		\N	10844	0	10509002	260139		0
2865	164	40481087	2000-11-17	2000-11-17 00:00:00	2000-12-01	2000-12-01 00:00:00	32020		\N	11304	0	444814009	40481087		0
3052	180	40481087	2010-08-06	2010-08-06 00:00:00	2010-08-13	2010-08-13 00:00:00	32020		\N	12160	0	444814009	40481087		0
3197	187	4237458	2012-04-15	2012-04-15 00:00:00	2012-07-14	2012-07-14 00:00:00	32020		\N	12739	0	58150001	4237458		0
3363	192	372328	1952-04-12	1952-04-12 00:00:00	1952-11-12	1952-11-12 00:00:00	32020		\N	13188	0	65363002	372328		0
3546	202	40481087	1953-12-24	1953-12-24 00:00:00	1954-01-14	1954-01-14 00:00:00	32020		\N	13845	0	444814009	40481087		0
3708	212	80180	2012-12-30	2012-12-30 00:00:00	\N	\N	32020		\N	14452	0	396275006	80180		0
3876	224	4112343	1992-02-07	1992-02-07 00:00:00	1992-02-14	1992-02-14 00:00:00	32020		\N	15086	0	195662009	4112343		0
4053	235	40481087	1984-03-14	1984-03-14 00:00:00	1984-03-21	1984-03-21 00:00:00	32020		\N	15769	0	444814009	40481087		0
4217	245	80502	2006-07-16	2006-07-16 00:00:00	\N	\N	32020		\N	16382	0	64859006	80502		0
4372	254	381316	2006-05-05	2006-05-05 00:00:00	\N	\N	32020		\N	16975	0	230690007	381316		0
4526	264	40481087	1987-05-26	1987-05-26 00:00:00	1987-06-02	1987-06-02 00:00:00	32020		\N	17552	0	444814009	40481087		0
4713	277	381316	2005-11-29	2005-11-29 00:00:00	\N	\N	32020		\N	18469	0	230690007	381316		0
4863	286	260139	1995-12-27	1995-12-27 00:00:00	1996-01-10	1996-01-10 00:00:00	32020		\N	19054	0	10509002	260139		0
5049	297	4112343	2015-09-16	2015-09-16 00:00:00	2015-09-29	2015-09-29 00:00:00	32020		\N	19782	0	195662009	4112343		0
5202	307	40481087	2006-09-27	2006-09-27 00:00:00	2006-10-04	2006-10-04 00:00:00	32020		\N	20384	0	444814009	40481087		0
5393	318	4112343	2007-08-02	2007-08-02 00:00:00	2007-08-11	2007-08-11 00:00:00	32020		\N	21081	0	195662009	4112343		0
5556	328	4112343	1995-09-12	1995-09-12 00:00:00	1995-09-23	1995-09-23 00:00:00	32020		\N	21662	0	195662009	4112343		0
5698	334	4112343	1958-08-02	1958-08-02 00:00:00	1958-08-14	1958-08-14 00:00:00	32020		\N	22121	0	195662009	4112343		0
5859	343	4116491	1999-01-24	1999-01-24 00:00:00	1999-03-12	1999-03-12 00:00:00	32020		\N	22887	0	301011002	4116491		0
6026	354	40481087	2018-07-20	2018-07-20 00:00:00	2018-08-03	2018-08-03 00:00:00	32020		\N	23534	0	444814009	40481087		0
6186	364	4156265	1961-03-10	1961-03-10 00:00:00	1961-03-31	1961-03-31 00:00:00	32020		\N	24210	0	370247008	4156265		0
6352	372	40481087	1972-12-10	1972-12-10 00:00:00	1972-12-17	1972-12-17 00:00:00	32020		\N	24774	0	444814009	40481087		0
6571	388	4218389	1969-09-16	1969-09-16 00:00:00	1969-10-14	1969-10-14 00:00:00	32020		\N	25583	0	39848009	4218389		0
6684	394	317576	1978-06-05	1978-06-05 00:00:00	\N	\N	32020		\N	25853	0	53741008	317576		0
6858	403	4294548	1928-05-03	1928-05-03 00:00:00	1928-05-24	1928-05-24 00:00:00	32020		\N	26530	0	75498004	4294548		0
7017	411	40481087	1991-11-18	1991-11-18 00:00:00	1991-12-09	1991-12-09 00:00:00	32020		\N	27290	0	444814009	40481087		0
7188	422	4283893	2014-12-06	2014-12-06 00:00:00	2015-02-28	2015-02-28 00:00:00	32020		\N	27911	0	36971009	4283893		0
7348	431	80180	1985-01-06	1985-01-06 00:00:00	\N	\N	32020		\N	28621	0	396275006	80180		0
7523	442	81151	1997-05-28	1997-05-28 00:00:00	1997-07-02	1997-07-02 00:00:00	32020		\N	29288	0	44465007	81151		0
7692	452	40481087	1973-02-26	1973-02-26 00:00:00	1973-03-12	1973-03-12 00:00:00	32020		\N	30125	0	444814009	40481087		0
7857	459	4027663	1998-08-24	1998-08-24 00:00:00	\N	\N	32020		\N	30680	0	13200003	4027663		0
8035	470	40481087	1996-04-19	1996-04-19 00:00:00	1996-05-10	1996-05-10 00:00:00	32020		\N	31408	0	444814009	40481087		0
8201	480	80502	1998-03-18	1998-03-18 00:00:00	\N	\N	32020		\N	32119	0	64859006	80502		0
8354	486	40481087	2009-09-04	2009-09-04 00:00:00	2009-09-18	2009-09-18 00:00:00	32020		\N	32523	0	444814009	40481087		0
8534	498	40481087	1982-02-20	1982-02-20 00:00:00	1982-03-06	1982-03-06 00:00:00	32020		\N	33278	0	444814009	40481087		0
8696	507	4152936	1946-11-05	1946-11-05 00:00:00	1946-11-19	1946-11-19 00:00:00	32020		\N	33956	0	283385000	4152936		0
8869	520	260139	1958-03-04	1958-03-04 00:00:00	1958-03-11	1958-03-11 00:00:00	32020		\N	34666	0	10509002	260139		0
9011	526	260139	1973-07-15	1973-07-15 00:00:00	1973-07-22	1973-07-22 00:00:00	32020		\N	35046	0	10509002	260139		0
9217	545	80180	2004-05-23	2004-05-23 00:00:00	\N	\N	32020		\N	36096	0	396275006	80180		0
9343	552	40481087	2001-04-06	2001-04-06 00:00:00	2001-04-13	2001-04-13 00:00:00	32020		\N	36645	0	444814009	40481087		0
9521	564	40481087	2015-01-25	2015-01-25 00:00:00	2015-02-01	2015-02-01 00:00:00	32020		\N	37362	0	444814009	40481087		0
9673	572	372328	1959-03-02	1959-03-02 00:00:00	1959-10-09	1959-10-09 00:00:00	32020		\N	37919	0	65363002	372328		0
9838	580	40481087	1983-04-04	1983-04-04 00:00:00	1983-04-18	1983-04-18 00:00:00	32020		\N	38407	0	444814009	40481087		0
10066	597	4296205	2012-07-27	2012-07-27 00:00:00	2012-08-17	2012-08-17 00:00:00	32020		\N	39461	0	403191005	4296205		0
10184	603	80180	1995-12-15	1995-12-15 00:00:00	\N	\N	32020		\N	39949	0	396275006	80180		0
10338	610	28060	1966-09-09	1966-09-09 00:00:00	1966-09-18	1966-09-18 00:00:00	32020		\N	40474	0	43878008	28060		0
10538	621	313217	2015-03-18	2015-03-18 00:00:00	\N	\N	32020		\N	41407	0	49436004	313217		0
44	2	40481087	1953-05-14	1953-05-14 00:00:00	1953-05-21	1953-05-21 00:00:00	32020		\N	126	0	444814009	40481087		0
232	11	28060	1966-04-08	1966-04-08 00:00:00	1966-04-19	1966-04-19 00:00:00	32020		\N	953	0	43878008	28060		0
376	19	40481087	1970-03-31	1970-03-31 00:00:00	1970-04-21	1970-04-21 00:00:00	32020		\N	1509	0	444814009	40481087		0
556	32	80180	1987-04-04	1987-04-04 00:00:00	\N	\N	32020		\N	2198	0	396275006	80180		0
729	40	40481087	1952-10-07	1952-10-07 00:00:00	1952-10-28	1952-10-28 00:00:00	32020		\N	2836	0	444814009	40481087		0
940	53	372328	1967-09-16	1967-09-16 00:00:00	1968-04-24	1968-04-24 00:00:00	32020		\N	3699	0	65363002	372328		0
1077	63	40481087	2002-05-16	2002-05-16 00:00:00	2002-06-06	2002-06-06 00:00:00	32020		\N	4240	0	444814009	40481087		0
1210	70	4283893	2010-01-19	2010-01-19 00:00:00	2010-02-09	2010-02-09 00:00:00	32020		\N	4721	0	36971009	4283893		0
1372	80	260139	2008-06-03	2008-06-03 00:00:00	2008-06-17	2008-06-17 00:00:00	32020		\N	5413	0	10509002	260139		0
1607	94	4112343	2004-12-08	2004-12-08 00:00:00	2004-12-17	2004-12-17 00:00:00	32020		\N	6358	0	195662009	4112343		0
1710	99	40481087	2012-01-12	2012-01-12 00:00:00	2012-01-19	2012-01-19 00:00:00	32020		\N	6734	0	444814009	40481087		0
1893	111	4113008	2018-08-28	2018-08-28 00:00:00	2018-09-18	2018-09-18 00:00:00	32020		\N	7418	0	284549007	4113008		0
2049	119	40481087	1976-05-18	1976-05-18 00:00:00	1976-05-25	1976-05-25 00:00:00	32020		\N	7866	0	444814009	40481087		0
2282	133	28060	2002-11-06	2002-11-06 00:00:00	2002-11-13	2002-11-13 00:00:00	32020		\N	8969	0	43878008	28060		0
2384	140	81151	1976-05-20	1976-05-20 00:00:00	1976-06-17	1976-06-17 00:00:00	32020		\N	9415	0	44465007	81151		0
2575	152	260139	2010-09-23	2010-09-23 00:00:00	2010-09-30	2010-09-30 00:00:00	32020		\N	10268	0	10509002	260139		0
2721	158	40481087	1992-03-31	1992-03-31 00:00:00	1992-04-21	1992-04-21 00:00:00	32020		\N	10845	0	444814009	40481087		0
2866	164	40481087	1984-10-19	1984-10-19 00:00:00	1984-11-02	1984-11-02 00:00:00	32020		\N	11286	0	444814009	40481087		0
3053	180	40486433	1980-04-27	1980-04-27 00:00:00	1996-04-25	1996-04-25 00:00:00	32020		\N	12107	0	446096008	40486433		0
3198	187	4059173	1948-04-07	1948-04-07 00:00:00	1948-05-08	1948-05-08 00:00:00	32020		\N	12732	0	16114001	4059173		0
3380	194	260139	2013-06-27	2013-06-27 00:00:00	2013-07-04	2013-07-04 00:00:00	32020		\N	13332	0	10509002	260139		0
3547	202	81151	2008-09-26	2008-09-26 00:00:00	2008-10-24	2008-10-24 00:00:00	32020		\N	13908	0	44465007	81151		0
3709	212	4113008	2007-04-20	2007-04-20 00:00:00	2007-05-11	2007-05-11 00:00:00	32020		\N	14438	0	284549007	4113008		0
3877	224	4112343	1963-08-29	1963-08-29 00:00:00	1963-09-11	1963-09-11 00:00:00	32020		\N	15085	0	195662009	4112343		0
4054	235	4112343	1988-10-19	1988-10-19 00:00:00	1988-10-30	1988-10-30 00:00:00	32020		\N	15770	0	195662009	4112343		0
4218	245	40481087	1981-12-03	1981-12-03 00:00:00	1981-12-24	1981-12-24 00:00:00	32020		\N	16478	0	444814009	40481087		0
4373	254	260139	1988-05-28	1988-05-28 00:00:00	1988-06-04	1988-06-04 00:00:00	32020		\N	16907	0	10509002	260139		0
4527	264	4296204	2008-07-31	2008-07-31 00:00:00	2008-08-21	2008-08-21 00:00:00	32020		\N	17589	0	403190006	4296204		0
4714	277	4112343	1983-10-28	1983-10-28 00:00:00	1983-11-05	1983-11-05 00:00:00	32020		\N	18499	0	195662009	4112343		0
4864	286	40479422	1978-12-30	1978-12-30 00:00:00	1979-02-05	1979-02-05 00:00:00	32020		\N	19040	0	444448004	40479422		0
5050	297	4112343	1965-05-23	1965-05-23 00:00:00	1965-05-30	1965-05-30 00:00:00	32020		\N	19777	0	195662009	4112343		0
5203	307	4278672	2004-12-13	2004-12-13 00:00:00	2005-01-12	2005-01-12 00:00:00	32020		\N	20398	0	65966004	4278672		0
5394	318	4112343	1977-01-25	1977-01-25 00:00:00	1977-02-06	1977-02-06 00:00:00	32020		\N	21111	0	195662009	4112343		0
5557	328	195588	2011-12-14	2011-12-14 00:00:00	2012-01-22	2012-01-22 00:00:00	32020		\N	21678	0	38822007	195588		0
5699	335	4155034	1982-03-24	1982-03-24 00:00:00	1982-04-14	1982-04-14 00:00:00	32020		\N	22294	0	283371005	4155034		0
5860	343	260139	1994-04-13	1994-04-13 00:00:00	1994-04-27	1994-04-27 00:00:00	32020		\N	22871	0	10509002	260139		0
6027	354	261325	1996-01-05	1996-01-05 00:00:00	\N	\N	32020		\N	23586	0	87433001	261325		0
6187	364	4112343	1987-02-19	1987-02-19 00:00:00	1987-02-27	1987-02-27 00:00:00	32020		\N	24158	0	195662009	4112343		0
6353	372	260139	1994-11-27	1994-11-27 00:00:00	1994-12-04	1994-12-04 00:00:00	32020		\N	24715	0	10509002	260139		0
6572	388	260139	1994-08-16	1994-08-16 00:00:00	1994-08-30	1994-08-30 00:00:00	32020		\N	25526	0	10509002	260139		0
6685	394	4112343	1966-01-23	1966-01-23 00:00:00	1966-01-31	1966-01-31 00:00:00	32020		\N	25888	0	195662009	4112343		0
6859	403	4278672	1991-08-29	1991-08-29 00:00:00	1991-10-28	1991-10-28 00:00:00	32020		\N	26465	0	65966004	4278672		0
7018	411	378001	1995-06-03	1995-06-03 00:00:00	1995-08-02	1995-08-02 00:00:00	32020		\N	27405	0	62106007	378001		0
7189	422	4112343	1997-08-19	1997-08-19 00:00:00	1997-08-31	1997-08-31 00:00:00	32020		\N	27968	0	195662009	4112343		0
7349	431	4112343	2017-12-17	2017-12-17 00:00:00	2017-12-29	2017-12-29 00:00:00	32020		\N	28587	0	195662009	4112343		0
7524	442	40481087	1992-04-19	1992-04-19 00:00:00	1992-05-03	1992-05-03 00:00:00	32020		\N	29409	0	444814009	40481087		0
7693	452	260139	2017-10-27	2017-10-27 00:00:00	2017-11-10	2017-11-10 00:00:00	32020		\N	30127	0	10509002	260139		0
7858	459	4112343	1998-07-16	1998-07-16 00:00:00	1998-07-25	1998-07-25 00:00:00	32020		\N	30680	0	195662009	4112343		0
8036	470	260139	2009-04-29	2009-04-29 00:00:00	2009-05-06	2009-05-06 00:00:00	32020		\N	31413	0	10509002	260139		0
8202	480	134438	1971-05-18	1971-05-18 00:00:00	1972-08-11	1972-08-11 00:00:00	32020		\N	32128	0	40275004	134438		0
8355	486	4112343	1979-05-29	1979-05-29 00:00:00	1979-06-10	1979-06-10 00:00:00	32020		\N	32459	0	195662009	4112343		0
8535	498	40481087	1987-10-28	1987-10-28 00:00:00	1987-11-11	1987-11-11 00:00:00	32020		\N	33260	0	444814009	40481087		0
8697	507	40481087	2008-06-02	2008-06-02 00:00:00	2008-06-09	2008-06-09 00:00:00	32020		\N	33980	0	444814009	40481087		0
8870	520	4294548	1983-08-02	1983-08-02 00:00:00	1983-10-25	1983-10-25 00:00:00	32020		\N	34698	0	75498004	4294548		0
9012	526	40481087	1976-07-02	1976-07-02 00:00:00	1976-07-09	1976-07-09 00:00:00	32020		\N	35047	0	444814009	40481087		0
9218	545	4084167	1974-06-25	1974-06-25 00:00:00	1974-06-25	1974-06-25 00:00:00	32020		\N	36142	0	241929008	4084167		0
9344	552	40481087	1952-05-17	1952-05-17 00:00:00	1952-05-31	1952-05-31 00:00:00	32020		\N	36640	0	444814009	40481087		0
9522	564	258780	1990-08-16	1990-08-16 00:00:00	\N	\N	32020		\N	37378	0	185086009	258780		0
9674	572	81151	2001-02-13	2001-02-13 00:00:00	2001-03-20	2001-03-20 00:00:00	32020		\N	37861	0	44465007	81151		0
9839	580	260139	1991-08-25	1991-08-25 00:00:00	1991-09-08	1991-09-08 00:00:00	32020		\N	38389	0	10509002	260139		0
10067	597	260139	1993-09-05	1993-09-05 00:00:00	1993-09-19	1993-09-19 00:00:00	32020		\N	39424	0	10509002	260139		0
10185	603	4112343	2008-11-18	2008-11-18 00:00:00	2008-11-25	2008-11-25 00:00:00	32020		\N	39967	0	195662009	4112343		0
10339	610	4134304	1976-10-11	1976-10-11 00:00:00	1976-12-10	1976-12-10 00:00:00	32020		\N	40479	0	263102004	4134304		0
10539	621	4112343	1945-05-29	1945-05-29 00:00:00	1945-06-09	1945-06-09 00:00:00	32020		\N	41449	0	195662009	4112343		0
45	2	260139	1931-09-03	1931-09-03 00:00:00	1931-09-17	1931-09-17 00:00:00	32020		\N	123	0	10509002	260139		0
233	11	260139	1966-10-25	1966-10-25 00:00:00	1966-11-08	1966-11-08 00:00:00	32020		\N	943	0	10509002	260139		0
377	19	28060	2000-05-15	2000-05-15 00:00:00	2000-05-27	2000-05-27 00:00:00	32020		\N	1453	0	43878008	28060		0
557	32	4112343	1984-07-29	1984-07-29 00:00:00	1984-08-11	1984-08-11 00:00:00	32020		\N	2261	0	195662009	4112343		0
730	40	40481087	2006-04-24	2006-04-24 00:00:00	2006-05-15	2006-05-15 00:00:00	32020		\N	2834	0	444814009	40481087		0
941	53	260139	1992-11-06	1992-11-06 00:00:00	1992-11-20	1992-11-20 00:00:00	32020		\N	3654	0	10509002	260139		0
1078	63	40481087	1973-03-18	1973-03-18 00:00:00	1973-04-08	1973-04-08 00:00:00	32020		\N	4236	0	444814009	40481087		0
1211	70	260139	1981-06-02	1981-06-02 00:00:00	1981-06-16	1981-06-16 00:00:00	32020		\N	4725	0	10509002	260139		0
1373	80	4112343	1985-05-27	1985-05-27 00:00:00	1985-06-04	1985-06-04 00:00:00	32020		\N	5381	0	195662009	4112343		0
1608	94	40481087	1988-11-02	1988-11-02 00:00:00	1988-11-09	1988-11-09 00:00:00	32020		\N	6302	0	444814009	40481087		0
1711	99	81151	1959-08-21	1959-08-21 00:00:00	1959-09-18	1959-09-18 00:00:00	32020		\N	6759	0	44465007	81151		0
1894	111	4155034	1981-01-30	1981-01-30 00:00:00	1981-02-13	1981-02-13 00:00:00	32020		\N	7417	0	283371005	4155034		0
2050	119	80180	1995-05-01	1995-05-01 00:00:00	\N	\N	32020		\N	7880	0	396275006	80180		0
2283	133	30753	2018-03-01	2018-03-01 00:00:00	\N	\N	32020		\N	8972	0	16761005	30753		0
2385	140	4112343	1999-08-12	1999-08-12 00:00:00	1999-08-23	1999-08-23 00:00:00	32020		\N	9354	0	195662009	4112343		0
2576	152	40481087	1992-01-10	1992-01-10 00:00:00	1992-01-31	1992-01-31 00:00:00	32020		\N	10251	0	444814009	40481087		0
2722	158	40481087	2017-08-17	2017-08-17 00:00:00	2017-09-07	2017-09-07 00:00:00	32020		\N	10798	0	444814009	40481087		0
2867	164	372328	1971-04-26	1971-04-26 00:00:00	1971-12-20	1971-12-20 00:00:00	32020		\N	11306	0	65363002	372328		0
3054	180	4112343	2015-03-05	2015-03-05 00:00:00	2015-03-14	2015-03-14 00:00:00	32020		\N	12150	0	195662009	4112343		0
3199	187	372328	1947-04-13	1947-04-13 00:00:00	1947-06-30	1947-06-30 00:00:00	32020		\N	12705	0	65363002	372328		0
3381	194	372328	1981-06-13	1981-06-13 00:00:00	1981-08-27	1981-08-27 00:00:00	32020		\N	13319	0	65363002	372328		0
3548	202	260139	2014-11-18	2014-11-18 00:00:00	2014-12-02	2014-12-02 00:00:00	32020		\N	13889	0	10509002	260139		0
3710	212	260139	1996-06-13	1996-06-13 00:00:00	1996-06-20	1996-06-20 00:00:00	32020		\N	14412	0	10509002	260139		0
3878	224	4112343	1966-05-29	1966-05-29 00:00:00	1966-06-05	1966-06-05 00:00:00	32020		\N	15021	0	195662009	4112343		0
4055	235	380378	1992-09-25	1992-09-25 00:00:00	\N	\N	32020		\N	15758	0	84757009	380378		0
4219	245	4112343	2005-06-16	2005-06-16 00:00:00	2005-06-23	2005-06-23 00:00:00	32020		\N	16428	0	195662009	4112343		0
4374	254	40481087	1967-07-02	1967-07-02 00:00:00	1967-07-23	1967-07-23 00:00:00	32020		\N	16922	0	444814009	40481087		0
4528	264	4112343	1977-02-28	1977-02-28 00:00:00	1977-03-13	1977-03-13 00:00:00	32020		\N	17593	0	195662009	4112343		0
4715	277	4112343	2009-10-22	2009-10-22 00:00:00	2009-10-31	2009-10-31 00:00:00	32020		\N	18493	0	195662009	4112343		0
4865	286	80180	1970-08-08	1970-08-08 00:00:00	\N	\N	32020		\N	19115	0	396275006	80180		0
5051	297	40481087	2018-11-26	2018-11-26 00:00:00	2018-12-17	2018-12-17 00:00:00	32020		\N	19798	0	444814009	40481087		0
5204	307	81893	2007-10-10	2007-10-10 00:00:00	\N	\N	32020		\N	20335	0	64766004	81893		0
5395	318	78272	1962-04-08	1962-04-08 00:00:00	1962-04-29	1962-04-29 00:00:00	32020		\N	21115	0	70704007	78272		0
5558	328	30753	2013-08-16	2013-08-16 00:00:00	\N	\N	32020		\N	21678	0	16761005	30753		0
5700	335	260139	1986-03-21	1986-03-21 00:00:00	1986-03-28	1986-03-28 00:00:00	32020		\N	22261	0	10509002	260139		0
5861	343	372328	1971-11-22	1971-11-22 00:00:00	1972-01-08	1972-01-08 00:00:00	32020		\N	22873	0	65363002	372328		0
6028	354	40481087	2011-09-08	2011-09-08 00:00:00	2011-09-22	2011-09-22 00:00:00	32020		\N	23521	0	444814009	40481087		0
6188	364	40481087	2000-11-07	2000-11-07 00:00:00	2000-11-28	2000-11-28 00:00:00	32020		\N	24202	0	444814009	40481087		0
6354	372	4035415	2018-12-22	2018-12-22 00:00:00	2019-02-20	2019-02-20 00:00:00	32020		\N	24791	0	239720000	4035415		0
6573	388	81151	1965-06-18	1965-06-18 00:00:00	1965-07-09	1965-07-09 00:00:00	32020		\N	25580	0	44465007	81151		0
6686	394	40481087	1993-12-14	1993-12-14 00:00:00	1994-01-04	1994-01-04 00:00:00	32020		\N	25899	0	444814009	40481087		0
6860	404	40481087	1996-10-17	1996-10-17 00:00:00	1996-10-24	1996-10-24 00:00:00	32020		\N	26608	0	444814009	40481087		0
7019	411	40481087	2017-09-20	2017-09-20 00:00:00	2017-10-04	2017-10-04 00:00:00	32020		\N	27339	0	444814009	40481087		0
7190	422	4116491	1982-01-04	1982-01-04 00:00:00	1982-02-07	1982-02-07 00:00:00	32020		\N	27953	0	301011002	4116491		0
7350	431	40481087	1963-05-19	1963-05-19 00:00:00	1963-05-26	1963-05-26 00:00:00	32020		\N	28565	0	444814009	40481087		0
7525	442	260139	1971-07-06	1971-07-06 00:00:00	1971-07-20	1971-07-20 00:00:00	32020		\N	29312	0	10509002	260139		0
7694	452	81151	1964-10-26	1964-10-26 00:00:00	1964-11-30	1964-11-30 00:00:00	32020		\N	30148	0	44465007	81151		0
7859	459	260139	1985-02-15	1985-02-15 00:00:00	1985-02-22	1985-02-22 00:00:00	32020		\N	30672	0	10509002	260139		0
8037	470	4112343	1989-01-14	1989-01-14 00:00:00	1989-01-25	1989-01-25 00:00:00	32020		\N	31407	0	195662009	4112343		0
8203	480	81151	1960-07-08	1960-07-08 00:00:00	1960-07-22	1960-07-22 00:00:00	32020		\N	31966	0	44465007	81151		0
8356	486	378001	1978-07-02	1978-07-02 00:00:00	1978-08-31	1978-08-31 00:00:00	32020		\N	32521	0	62106007	378001		0
8536	498	4112343	1998-02-07	1998-02-07 00:00:00	1998-02-16	1998-02-16 00:00:00	32020		\N	33261	0	195662009	4112343		0
8713	510	80180	2008-01-10	2008-01-10 00:00:00	\N	\N	32020		\N	34092	0	396275006	80180		0
8871	520	4112343	1977-03-20	1977-03-20 00:00:00	1977-03-30	1977-03-30 00:00:00	32020		\N	34669	0	195662009	4112343		0
9013	526	257012	2002-08-04	2002-08-04 00:00:00	\N	\N	32020		\N	35096	0	40055000	257012		0
9219	545	4112343	1983-06-04	1983-06-04 00:00:00	1983-06-12	1983-06-12 00:00:00	32020		\N	36051	0	195662009	4112343		0
9345	552	4112343	2014-02-21	2014-02-21 00:00:00	2014-03-03	2014-03-03 00:00:00	32020		\N	36646	0	195662009	4112343		0
9523	564	4112343	1970-07-01	1970-07-01 00:00:00	1970-07-11	1970-07-11 00:00:00	32020		\N	37313	0	195662009	4112343		0
9675	572	4285898	1991-09-04	1991-09-04 00:00:00	\N	\N	32020		\N	37887	0	68496003	4285898		0
9840	580	260139	1980-12-01	1980-12-01 00:00:00	1980-12-15	1980-12-15 00:00:00	32020		\N	38406	0	10509002	260139		0
10068	597	260139	1964-11-29	1964-11-29 00:00:00	1964-12-06	1964-12-06 00:00:00	32020		\N	39417	0	10509002	260139		0
10186	603	4278672	1983-09-12	1983-09-12 00:00:00	1983-12-11	1983-12-11 00:00:00	32020		\N	39931	0	65966004	4278672		0
10340	610	40481087	1997-01-05	1997-01-05 00:00:00	1997-01-12	1997-01-12 00:00:00	32020		\N	40555	0	444814009	40481087		0
10540	621	80502	2003-01-08	2003-01-08 00:00:00	\N	\N	32020		\N	41389	0	64859006	80502		0
46	2	40481087	2002-01-01	2002-01-01 00:00:00	2002-01-08	2002-01-08 00:00:00	32020		\N	109	0	444814009	40481087		0
234	11	4112343	1955-10-23	1955-10-23 00:00:00	1955-11-05	1955-11-05 00:00:00	32020		\N	978	0	195662009	4112343		0
378	19	4112343	2010-08-23	2010-08-23 00:00:00	2010-08-31	2010-08-31 00:00:00	32020		\N	1498	0	195662009	4112343		0
558	32	372328	2003-07-09	2003-07-09 00:00:00	2003-11-12	2003-11-12 00:00:00	32020		\N	2202	0	65363002	372328		0
731	40	381316	2006-11-29	2006-11-29 00:00:00	\N	\N	32020		\N	2834	0	230690007	381316		0
942	53	4112343	1998-03-27	1998-03-27 00:00:00	1998-04-08	1998-04-08 00:00:00	32020		\N	3663	0	195662009	4112343		0
1079	63	40481087	1973-12-13	1973-12-13 00:00:00	1974-01-03	1974-01-03 00:00:00	32020		\N	4237	0	444814009	40481087		0
1212	70	28060	2019-04-24	2019-04-24 00:00:00	2019-05-03	2019-05-03 00:00:00	32020		\N	4766	0	43878008	28060		0
9601	569	80180	1956-03-02	1956-03-02 00:00:00	\N	\N	32020		\N	37677	0	396275006	80180		0
1374	80	40481087	1955-04-18	1955-04-18 00:00:00	1955-05-09	1955-05-09 00:00:00	32020		\N	5399	0	444814009	40481087		0
1609	94	40481087	1983-07-06	1983-07-06 00:00:00	1983-07-27	1983-07-27 00:00:00	32020		\N	6356	0	444814009	40481087		0
1712	99	4218389	1960-10-12	1960-10-12 00:00:00	1960-11-02	1960-11-02 00:00:00	32020		\N	6760	0	39848009	4218389		0
1895	111	372328	1978-01-05	1978-01-05 00:00:00	1978-04-07	1978-04-07 00:00:00	32020		\N	7376	0	65363002	372328		0
2051	119	4112343	1962-09-30	1962-09-30 00:00:00	1962-10-08	1962-10-08 00:00:00	32020		\N	7895	0	195662009	4112343		0
2284	133	4285898	2018-10-27	2018-10-27 00:00:00	\N	\N	32020		\N	8972	0	68496003	4285898		0
2386	140	40481087	1974-01-27	1974-01-27 00:00:00	1974-02-03	1974-02-03 00:00:00	32020		\N	9351	0	444814009	40481087		0
2577	152	257012	1986-09-28	1986-09-28 00:00:00	1987-01-11	1987-01-11 00:00:00	32020		\N	10279	0	40055000	257012		0
2723	158	40481087	1976-08-24	1976-08-24 00:00:00	1976-09-14	1976-09-14 00:00:00	32020		\N	10822	0	444814009	40481087		0
2868	164	260139	1986-07-27	1986-07-27 00:00:00	1986-08-10	1986-08-10 00:00:00	32020		\N	11287	0	10509002	260139		0
3055	180	4116491	1997-04-16	1997-04-16 00:00:00	1997-05-25	1997-05-25 00:00:00	32020		\N	12148	0	301011002	4116491		0
3200	187	4112343	2002-12-01	2002-12-01 00:00:00	2002-12-09	2002-12-09 00:00:00	32020		\N	12746	0	195662009	4112343		0
3382	194	40481087	2015-01-07	2015-01-07 00:00:00	2015-01-28	2015-01-28 00:00:00	32020		\N	13333	0	444814009	40481087		0
3549	202	40481087	2004-08-20	2004-08-20 00:00:00	2004-08-27	2004-08-27 00:00:00	32020		\N	13887	0	444814009	40481087		0
3711	212	4112343	2015-12-30	2015-12-30 00:00:00	2016-01-12	2016-01-12 00:00:00	32020		\N	14414	0	195662009	4112343		0
3879	224	192671	1977-03-03	1977-03-03 00:00:00	\N	\N	32020		\N	15092	0	K92.2	35208414		0
4056	235	40481087	1982-05-12	1982-05-12 00:00:00	1982-05-19	1982-05-19 00:00:00	32020		\N	15768	0	444814009	40481087		0
4220	245	40481087	1972-10-24	1972-10-24 00:00:00	1972-11-07	1972-11-07 00:00:00	32020		\N	16438	0	444814009	40481087		0
4375	254	40481087	1987-12-30	1987-12-30 00:00:00	1988-01-20	1988-01-20 00:00:00	32020		\N	16959	0	444814009	40481087		0
4529	264	260139	2010-11-12	2010-11-12 00:00:00	2010-11-26	2010-11-26 00:00:00	32020		\N	17567	0	10509002	260139		0
4716	277	260139	1986-11-20	1986-11-20 00:00:00	1986-11-27	1986-11-27 00:00:00	32020		\N	18458	0	10509002	260139		0
4866	286	260139	1982-03-16	1982-03-16 00:00:00	1982-03-30	1982-03-30 00:00:00	32020		\N	19120	0	10509002	260139		0
5052	297	80180	1993-08-25	1993-08-25 00:00:00	\N	\N	32020		\N	19806	0	396275006	80180		0
5205	307	4112343	2007-03-13	2007-03-13 00:00:00	2007-03-22	2007-03-22 00:00:00	32020		\N	20335	0	195662009	4112343		0
5396	318	40481087	1979-04-25	1979-04-25 00:00:00	1979-05-16	1979-05-16 00:00:00	32020		\N	21112	0	444814009	40481087		0
5559	328	4310024	2012-11-19	2012-11-19 00:00:00	\N	\N	32020		\N	21678	0	424802006	4310024		0
5701	335	4112343	2014-06-06	2014-06-06 00:00:00	2014-06-16	2014-06-16 00:00:00	32020		\N	22282	0	195662009	4112343		0
5862	343	40481087	1981-03-31	1981-03-31 00:00:00	1981-04-14	1981-04-14 00:00:00	32020		\N	22900	0	444814009	40481087		0
6029	354	4112343	1993-10-18	1993-10-18 00:00:00	1993-10-31	1993-10-31 00:00:00	32020		\N	23526	0	195662009	4112343		0
6189	364	40481087	1986-12-05	1986-12-05 00:00:00	1986-12-12	1986-12-12 00:00:00	32020		\N	24200	0	444814009	40481087		0
6355	374	4112343	2010-04-05	2010-04-05 00:00:00	2010-04-13	2010-04-13 00:00:00	32020		\N	24800	0	195662009	4112343		0
6574	388	40481087	1986-08-06	1986-08-06 00:00:00	1986-08-27	1986-08-27 00:00:00	32020		\N	25569	0	444814009	40481087		0
6687	394	4329847	1989-03-27	1989-03-27 00:00:00	\N	\N	32020		\N	25914	0	22298006	4329847		0
6861	404	4156265	2007-12-24	2007-12-24 00:00:00	2008-01-07	2008-01-07 00:00:00	32020		\N	26663	0	370247008	4156265		0
7020	411	80180	2003-03-02	2003-03-02 00:00:00	\N	\N	32020		\N	27379	0	396275006	80180		0
7191	422	40481087	1967-03-05	1967-03-05 00:00:00	1967-03-26	1967-03-26 00:00:00	32020		\N	27947	0	444814009	40481087		0
7351	431	4112343	1951-07-18	1951-07-18 00:00:00	1951-07-28	1951-07-28 00:00:00	32020		\N	28612	0	195662009	4112343		0
7526	442	260139	1964-02-27	1964-02-27 00:00:00	1964-03-12	1964-03-12 00:00:00	32020		\N	29311	0	10509002	260139		0
7695	452	28060	1973-03-17	1973-03-17 00:00:00	1973-03-24	1973-03-24 00:00:00	32020		\N	30085	0	43878008	28060		0
7860	459	78272	1975-05-07	1975-05-07 00:00:00	1975-06-11	1975-06-11 00:00:00	32020		\N	30710	0	70704007	78272		0
8038	470	40481087	1995-10-29	1995-10-29 00:00:00	1995-11-12	1995-11-12 00:00:00	32020		\N	31451	0	444814009	40481087		0
8204	480	260139	2002-08-20	2002-08-20 00:00:00	2002-09-03	2002-09-03 00:00:00	32020		\N	32030	0	10509002	260139		0
8357	486	4112343	2004-03-29	2004-03-29 00:00:00	2004-04-11	2004-04-11 00:00:00	32020		\N	32472	0	195662009	4112343		0
8537	498	80180	2010-06-09	2010-06-09 00:00:00	\N	\N	32020		\N	33268	0	396275006	80180		0
8714	510	81893	2007-05-15	2007-05-15 00:00:00	\N	\N	32020		\N	34092	0	64766004	81893		0
8872	520	80180	1988-05-18	1988-05-18 00:00:00	\N	\N	32020		\N	34728	0	396275006	80180		0
9014	526	372328	1977-01-23	1977-01-23 00:00:00	1978-02-08	1978-02-08 00:00:00	32020		\N	35100	0	65363002	372328		0
9220	545	40481087	2008-08-13	2008-08-13 00:00:00	2008-09-03	2008-09-03 00:00:00	32020		\N	36065	0	444814009	40481087		0
9346	552	80180	1986-05-27	1986-05-27 00:00:00	\N	\N	32020		\N	36574	0	396275006	80180		0
9524	564	40481087	1984-08-07	1984-08-07 00:00:00	1984-08-14	1984-08-14 00:00:00	32020		\N	37330	0	444814009	40481087		0
9676	572	80180	1992-04-01	1992-04-01 00:00:00	\N	\N	32020		\N	37887	0	396275006	80180		0
9846	582	4027663	1993-02-23	1993-02-23 00:00:00	\N	\N	32020		\N	38532	0	13200003	4027663		0
10069	597	4116491	2006-04-22	2006-04-22 00:00:00	2006-06-08	2006-06-08 00:00:00	32020		\N	39441	0	301011002	4116491		0
10187	603	4112343	2010-05-05	2010-05-05 00:00:00	2010-05-18	2010-05-18 00:00:00	32020		\N	40033	0	195662009	4112343		0
10341	610	40481087	1963-08-04	1963-08-04 00:00:00	1963-08-25	1963-08-25 00:00:00	32020		\N	40503	0	444814009	40481087		0
10541	621	40481087	1995-01-23	1995-01-23 00:00:00	1995-02-06	1995-02-06 00:00:00	32020		\N	41435	0	444814009	40481087		0
47	2	313217	2007-09-04	2007-09-04 00:00:00	\N	\N	32020		\N	137	0	49436004	313217		0
235	11	4218389	1996-04-14	1996-04-14 00:00:00	1996-05-12	1996-05-12 00:00:00	32020		\N	992	0	39848009	4218389		0
379	19	378001	1949-11-26	1949-11-26 00:00:00	1949-12-26	1949-12-26 00:00:00	32020		\N	1543	0	62106007	378001		0
559	32	4043241	2006-08-30	2006-08-30 00:00:00	\N	\N	32020		\N	2220	0	230265002	4043241		0
732	40	4112343	1977-12-15	1977-12-15 00:00:00	1977-12-28	1977-12-28 00:00:00	32020		\N	2833	0	195662009	4112343		0
943	53	80180	1999-12-24	1999-12-24 00:00:00	\N	\N	32020		\N	3670	0	396275006	80180		0
1080	63	40481087	1976-02-29	1976-02-29 00:00:00	1976-03-14	1976-03-14 00:00:00	32020		\N	4302	0	444814009	40481087		0
1213	70	4027663	1976-04-04	1976-04-04 00:00:00	\N	\N	32020		\N	4750	0	13200003	4027663		0
1375	80	260139	1975-10-16	1975-10-16 00:00:00	1975-10-23	1975-10-23 00:00:00	32020		\N	5440	0	10509002	260139		0
1610	94	28060	1959-12-30	1959-12-30 00:00:00	1960-01-10	1960-01-10 00:00:00	32020		\N	6353	0	43878008	28060		0
1713	99	40481087	1960-03-25	1960-03-25 00:00:00	1960-04-08	1960-04-08 00:00:00	32020		\N	6771	0	444814009	40481087		0
1896	111	40481087	1997-09-13	1997-09-13 00:00:00	1997-10-04	1997-10-04 00:00:00	32020		\N	7370	0	444814009	40481087		0
2052	119	4116491	2012-02-07	2012-02-07 00:00:00	2012-04-08	2012-04-08 00:00:00	32020		\N	7869	0	301011002	4116491		0
2285	133	80180	2019-03-26	2019-03-26 00:00:00	\N	\N	32020		\N	8972	0	396275006	80180		0
2387	140	28060	1974-06-30	1974-06-30 00:00:00	1974-07-08	1974-07-08 00:00:00	32020		\N	9352	0	43878008	28060		0
2578	152	372328	1969-03-19	1969-03-19 00:00:00	1969-04-02	1969-04-02 00:00:00	32020		\N	10232	0	65363002	372328		0
2724	158	28060	1952-05-08	1952-05-08 00:00:00	1952-05-16	1952-05-16 00:00:00	32020		\N	10818	0	43878008	28060		0
2869	164	4112343	1997-05-03	1997-05-03 00:00:00	1997-05-12	1997-05-12 00:00:00	32020		\N	11289	0	195662009	4112343		0
3056	180	260139	1999-06-27	1999-06-27 00:00:00	1999-07-04	1999-07-04 00:00:00	32020		\N	12189	0	10509002	260139		0
3201	187	40481087	1953-02-18	1953-02-18 00:00:00	1953-03-04	1953-03-04 00:00:00	32020		\N	12694	0	444814009	40481087		0
3383	194	4278672	1990-03-12	1990-03-12 00:00:00	1990-04-11	1990-04-11 00:00:00	32020		\N	13307	0	65966004	4278672		0
3550	202	4027663	1970-09-02	1970-09-02 00:00:00	\N	\N	32020		\N	13871	0	13200003	4027663		0
3712	212	40481087	2016-04-02	2016-04-02 00:00:00	2016-04-09	2016-04-09 00:00:00	32020		\N	14427	0	444814009	40481087		0
3880	224	81151	1969-11-25	1969-11-25 00:00:00	1969-12-16	1969-12-16 00:00:00	32020		\N	15091	0	44465007	81151		0
4057	235	28060	1991-04-04	1991-04-04 00:00:00	1991-04-16	1991-04-16 00:00:00	32020		\N	15782	0	43878008	28060		0
4221	245	4296204	2013-09-09	2013-09-09 00:00:00	2013-09-30	2013-09-30 00:00:00	32020		\N	16406	0	403190006	4296204		0
4376	254	260139	2000-10-07	2000-10-07 00:00:00	2000-10-21	2000-10-21 00:00:00	32020		\N	16968	0	10509002	260139		0
4530	264	28060	1958-05-04	1958-05-04 00:00:00	1958-05-13	1958-05-13 00:00:00	32020		\N	17507	0	43878008	28060		0
4717	277	372328	1966-09-16	1966-09-16 00:00:00	1966-11-08	1966-11-08 00:00:00	32020		\N	18500	0	65363002	372328		0
4867	286	4112343	1969-03-18	1969-03-18 00:00:00	1969-03-30	1969-03-30 00:00:00	32020		\N	19117	0	195662009	4112343		0
5053	297	260139	1953-01-09	1953-01-09 00:00:00	1953-01-23	1953-01-23 00:00:00	32020		\N	19786	0	10509002	260139		0
5206	307	4310024	2007-07-12	2007-07-12 00:00:00	\N	\N	32020		\N	20335	0	424802006	4310024		0
5397	318	260139	2004-07-05	2004-07-05 00:00:00	2004-07-19	2004-07-19 00:00:00	32020		\N	21113	0	10509002	260139		0
5560	328	4116491	2005-10-22	2005-10-22 00:00:00	2005-12-15	2005-12-15 00:00:00	32020		\N	21643	0	301011002	4116491		0
5702	335	4296204	2012-07-26	2012-07-26 00:00:00	2012-08-23	2012-08-23 00:00:00	32020		\N	22296	0	403190006	4296204		0
5863	343	40481087	1970-12-05	1970-12-05 00:00:00	1970-12-26	1970-12-26 00:00:00	32020		\N	22941	0	444814009	40481087		0
6030	354	40481087	2005-11-18	2005-11-18 00:00:00	2005-12-02	2005-12-02 00:00:00	32020		\N	23532	0	444814009	40481087		0
6190	364	40481087	1975-04-22	1975-04-22 00:00:00	1975-04-29	1975-04-29 00:00:00	32020		\N	24218	0	444814009	40481087		0
6356	374	4112343	2007-02-11	2007-02-11 00:00:00	2007-02-19	2007-02-19 00:00:00	32020		\N	24799	0	195662009	4112343		0
6575	388	80180	1988-10-25	1988-10-25 00:00:00	\N	\N	32020		\N	25569	0	396275006	80180		0
6689	394	4112343	1967-09-27	1967-09-27 00:00:00	1967-10-05	1967-10-05 00:00:00	32020		\N	25895	0	195662009	4112343		0
6862	404	4294548	1963-12-31	1963-12-31 00:00:00	1964-03-10	1964-03-10 00:00:00	32020		\N	26575	0	75498004	4294548		0
7021	411	4112343	2007-12-03	2007-12-03 00:00:00	2007-12-10	2007-12-10 00:00:00	32020		\N	27272	0	195662009	4112343		0
7192	422	260139	1976-12-08	1976-12-08 00:00:00	1976-12-22	1976-12-22 00:00:00	32020		\N	27951	0	10509002	260139		0
7352	431	260139	1964-11-03	1964-11-03 00:00:00	1964-11-10	1964-11-10 00:00:00	32020		\N	28566	0	10509002	260139		0
7527	442	4112343	2015-09-29	2015-09-29 00:00:00	2015-10-09	2015-10-09 00:00:00	32020		\N	29370	0	195662009	4112343		0
7696	452	4112343	1993-06-21	1993-06-21 00:00:00	1993-06-29	1993-06-29 00:00:00	32020		\N	30138	0	195662009	4112343		0
7861	459	4112343	1998-08-25	1998-08-25 00:00:00	1998-09-01	1998-09-01 00:00:00	32020		\N	30706	0	195662009	4112343		0
8039	470	40481087	1993-08-14	1993-08-14 00:00:00	1993-09-04	1993-09-04 00:00:00	32020		\N	31450	0	444814009	40481087		0
8205	480	4112343	1945-06-20	1945-06-20 00:00:00	1945-07-01	1945-07-01 00:00:00	32020		\N	32123	0	195662009	4112343		0
8358	486	40481087	1993-10-28	1993-10-28 00:00:00	1993-11-04	1993-11-04 00:00:00	32020		\N	32479	0	444814009	40481087		0
8538	498	40481087	1982-11-09	1982-11-09 00:00:00	1982-11-16	1982-11-16 00:00:00	32020		\N	33291	0	444814009	40481087		0
8715	510	4266809	2008-01-10	2008-01-10 00:00:00	\N	\N	32020		\N	34092	0	397881000	4266809		0
8873	520	40481087	1987-08-27	1987-08-27 00:00:00	1987-09-17	1987-09-17 00:00:00	32020		\N	34728	0	444814009	40481087		0
9023	528	40481087	1981-04-16	1981-04-16 00:00:00	1981-05-07	1981-05-07 00:00:00	32020		\N	35208	0	444814009	40481087		0
9221	545	4112343	2007-05-09	2007-05-09 00:00:00	2007-05-20	2007-05-20 00:00:00	32020		\N	36063	0	195662009	4112343		0
9347	552	30753	1985-12-28	1985-12-28 00:00:00	\N	\N	32020		\N	36574	0	16761005	30753		0
9525	565	28060	1963-02-24	1963-02-24 00:00:00	1963-03-08	1963-03-08 00:00:00	32020		\N	37460	0	43878008	28060		0
9677	572	4112343	2010-05-27	2010-05-27 00:00:00	2010-06-03	2010-06-03 00:00:00	32020		\N	37877	0	195662009	4112343		0
9847	582	81151	1986-03-17	1986-03-17 00:00:00	1986-04-21	1986-04-21 00:00:00	32020		\N	38555	0	44465007	81151		0
10070	597	4112343	2016-03-24	2016-03-24 00:00:00	2016-04-02	2016-04-02 00:00:00	32020		\N	39442	0	195662009	4112343		0
10188	603	40481087	1986-08-11	1986-08-11 00:00:00	1986-08-18	1986-08-18 00:00:00	32020		\N	39909	0	444814009	40481087		0
10342	610	4112343	1987-08-22	1987-08-22 00:00:00	1987-09-04	1987-09-04 00:00:00	32020		\N	40507	0	195662009	4112343		0
10542	621	378001	1967-08-01	1967-08-01 00:00:00	1967-08-31	1967-08-31 00:00:00	32020		\N	41487	0	62106007	378001		0
48	2	40481087	1957-09-24	1957-09-24 00:00:00	1957-10-15	1957-10-15 00:00:00	32020		\N	168	0	444814009	40481087		0
236	11	4112343	1956-11-02	1956-11-02 00:00:00	1956-11-12	1956-11-12 00:00:00	32020		\N	979	0	195662009	4112343		0
380	19	260139	2017-05-07	2017-05-07 00:00:00	2017-05-21	2017-05-21 00:00:00	32020		\N	1483	0	10509002	260139		0
560	32	260139	2002-07-21	2002-07-21 00:00:00	2002-07-28	2002-07-28 00:00:00	32020		\N	2201	0	10509002	260139		0
733	40	40481087	2018-01-20	2018-01-20 00:00:00	2018-02-03	2018-02-03 00:00:00	32020		\N	2887	0	444814009	40481087		0
971	57	40481087	2004-04-12	2004-04-12 00:00:00	2004-04-26	2004-04-26 00:00:00	32020		\N	3829	0	444814009	40481087		0
1081	64	78272	2012-04-11	2012-04-11 00:00:00	2012-05-09	2012-05-09 00:00:00	32020		\N	4328	0	70704007	78272		0
1214	70	28060	1993-04-29	1993-04-29 00:00:00	1993-05-07	1993-05-07 00:00:00	32020		\N	4763	0	43878008	28060		0
1376	80	28060	1950-03-20	1950-03-20 00:00:00	1950-03-29	1950-03-29 00:00:00	32020		\N	5462	0	43878008	28060		0
1611	94	372328	1978-01-30	1978-01-30 00:00:00	1978-05-12	1978-05-12 00:00:00	32020		\N	6348	0	65363002	372328		0
1714	99	4113008	2004-07-28	2004-07-28 00:00:00	2004-08-18	2004-08-18 00:00:00	32020		\N	6731	0	284549007	4113008		0
1922	114	257012	2009-06-25	2009-06-25 00:00:00	\N	\N	32020		\N	7512	0	40055000	257012		0
2053	119	4112343	1957-02-04	1957-02-04 00:00:00	1957-02-13	1957-02-13 00:00:00	32020		\N	7864	0	195662009	4112343		0
2286	133	260139	2010-08-11	2010-08-11 00:00:00	2010-08-25	2010-08-25 00:00:00	32020		\N	8959	0	10509002	260139		0
2388	140	4152936	1995-01-07	1995-01-07 00:00:00	1995-01-28	1995-01-28 00:00:00	32020		\N	9348	0	283385000	4152936		0
2579	152	198809	1973-12-15	1973-12-15 00:00:00	1973-12-15	1973-12-15 00:00:00	32020		\N	10291	0	65275009	198809		0
2725	158	40481087	1973-09-11	1973-09-11 00:00:00	1973-10-02	1973-10-02 00:00:00	32020		\N	10793	0	444814009	40481087		0
2870	164	4112343	2005-10-13	2005-10-13 00:00:00	2005-10-24	2005-10-24 00:00:00	32020		\N	11283	0	195662009	4112343		0
3057	180	28060	1980-01-07	1980-01-07 00:00:00	1980-01-16	1980-01-16 00:00:00	32020		\N	12151	0	43878008	28060		0
3202	187	80180	1984-11-29	1984-11-29 00:00:00	\N	\N	32020		\N	12684	0	396275006	80180		0
3384	194	28060	1991-11-11	1991-11-11 00:00:00	1991-11-19	1991-11-19 00:00:00	32020		\N	13301	0	43878008	28060		0
3551	202	81893	1980-08-25	1980-08-25 00:00:00	\N	\N	32020		\N	13822	0	64766004	81893		0
3713	212	260139	2012-07-28	2012-07-28 00:00:00	2012-08-11	2012-08-11 00:00:00	32020		\N	14413	0	10509002	260139		0
3881	224	4278672	2009-07-24	2009-07-24 00:00:00	2009-08-23	2009-08-23 00:00:00	32020		\N	15110	0	65966004	4278672		0
4058	235	28060	1991-10-15	1991-10-15 00:00:00	1991-10-27	1991-10-27 00:00:00	32020		\N	15771	0	43878008	28060		0
4222	245	40481087	1987-07-29	1987-07-29 00:00:00	1987-08-05	1987-08-05 00:00:00	32020		\N	16426	0	444814009	40481087		0
4377	254	40481087	1993-07-12	1993-07-12 00:00:00	1993-07-26	1993-07-26 00:00:00	32020		\N	16967	0	444814009	40481087		0
4531	264	4112343	1969-06-18	1969-06-18 00:00:00	1969-06-25	1969-06-25 00:00:00	32020		\N	17512	0	195662009	4112343		0
4718	277	260139	1976-01-29	1976-01-29 00:00:00	1976-02-05	1976-02-05 00:00:00	32020		\N	18491	0	10509002	260139		0
4868	286	4112343	1969-07-02	1969-07-02 00:00:00	1969-07-09	1969-07-09 00:00:00	32020		\N	19118	0	195662009	4112343		0
5054	297	40481087	2010-07-28	2010-07-28 00:00:00	2010-08-18	2010-08-18 00:00:00	32020		\N	19796	0	444814009	40481087		0
5207	307	40481087	1996-12-14	1996-12-14 00:00:00	1996-12-28	1996-12-28 00:00:00	32020		\N	20342	0	444814009	40481087		0
5398	318	440086	1966-05-01	1966-05-01 00:00:00	1966-09-04	1966-09-04 00:00:00	32020		\N	21093	0	192127007	440086		0
5561	328	40481087	2001-11-07	2001-11-07 00:00:00	2001-11-14	2001-11-14 00:00:00	32020		\N	21673	0	444814009	40481087		0
5703	335	257012	1966-02-14	1966-02-14 00:00:00	\N	\N	32020		\N	22276	0	40055000	257012		0
5864	343	4084167	1972-10-19	1972-10-19 00:00:00	1972-10-19	1972-10-19 00:00:00	32020		\N	22849	0	241929008	4084167		0
6031	354	260139	1973-03-24	1973-03-24 00:00:00	1973-04-07	1973-04-07 00:00:00	32020		\N	23518	0	10509002	260139		0
6191	364	80180	1983-08-07	1983-08-07 00:00:00	\N	\N	32020		\N	24157	0	396275006	80180		0
6357	374	40481087	2001-06-12	2001-06-12 00:00:00	2001-06-26	2001-06-26 00:00:00	32020		\N	24813	0	444814009	40481087		0
6576	388	378001	1968-07-23	1968-07-23 00:00:00	1968-09-21	1968-09-21 00:00:00	32020		\N	25582	0	62106007	378001		0
6690	394	40481087	1924-08-16	1924-08-16 00:00:00	1924-09-06	1924-09-06 00:00:00	32020		\N	25893	0	444814009	40481087		0
6863	404	4027663	1990-06-07	1990-06-07 00:00:00	\N	\N	32020		\N	26670	0	13200003	4027663		0
7022	411	28060	1964-01-07	1964-01-07 00:00:00	1964-01-14	1964-01-14 00:00:00	32020		\N	27319	0	43878008	28060		0
7193	422	28060	2009-07-02	2009-07-02 00:00:00	2009-07-11	2009-07-11 00:00:00	32020		\N	27910	0	43878008	28060		0
7353	431	40481087	1970-11-22	1970-11-22 00:00:00	1970-11-29	1970-11-29 00:00:00	32020		\N	28568	0	444814009	40481087		0
7528	442	4113008	1992-08-08	1992-08-08 00:00:00	1992-08-22	1992-08-22 00:00:00	32020		\N	29287	0	284549007	4113008		0
7697	452	78272	1973-09-14	1973-09-14 00:00:00	1973-10-05	1973-10-05 00:00:00	32020		\N	30149	0	70704007	78272		0
7862	459	378001	1983-11-26	1983-11-26 00:00:00	1983-12-26	1983-12-26 00:00:00	32020		\N	30711	0	62106007	378001		0
8040	470	260139	2013-01-27	2013-01-27 00:00:00	2013-02-10	2013-02-10 00:00:00	32020		\N	31409	0	10509002	260139		0
8206	480	260139	2004-04-11	2004-04-11 00:00:00	2004-04-25	2004-04-25 00:00:00	32020		\N	32110	0	10509002	260139		0
8359	487	40481087	1989-05-08	1989-05-08 00:00:00	1989-05-15	1989-05-15 00:00:00	32020		\N	32548	0	444814009	40481087		0
8539	498	40481087	1978-02-20	1978-02-20 00:00:00	1978-03-06	1978-03-06 00:00:00	32020		\N	33270	0	444814009	40481087		0
8716	510	378001	1977-03-03	1977-03-03 00:00:00	1977-04-02	1977-04-02 00:00:00	32020		\N	34080	0	62106007	378001		0
8874	520	40481087	1983-12-02	1983-12-02 00:00:00	1983-12-09	1983-12-09 00:00:00	32020		\N	34700	0	444814009	40481087		0
9024	528	4112343	2011-09-28	2011-09-28 00:00:00	2011-10-07	2011-10-07 00:00:00	32020		\N	35159	0	195662009	4112343		0
9222	545	375671	1998-05-18	1998-05-18 00:00:00	1998-06-17	1998-06-17 00:00:00	32020		\N	36145	0	62564004	375671		0
9348	552	4134304	1962-01-23	1962-01-23 00:00:00	1962-03-24	1962-03-24 00:00:00	32020		\N	36594	0	263102004	4134304		0
9526	565	4218389	1965-06-12	1965-06-12 00:00:00	1965-07-17	1965-07-17 00:00:00	32020		\N	37448	0	39848009	4218389		0
9678	572	28060	1975-01-29	1975-01-29 00:00:00	1975-02-06	1975-02-06 00:00:00	32020		\N	37868	0	43878008	28060		0
9848	582	40481087	1996-11-05	1996-11-05 00:00:00	1996-11-19	1996-11-19 00:00:00	32020		\N	38590	0	444814009	40481087		0
10071	597	81151	1967-09-14	1967-09-14 00:00:00	1967-09-28	1967-09-28 00:00:00	32020		\N	39456	0	44465007	81151		0
10189	603	40481087	2010-05-21	2010-05-21 00:00:00	2010-05-28	2010-05-28 00:00:00	32020		\N	40034	0	444814009	40481087		0
10343	610	4218389	1973-11-28	1973-11-28 00:00:00	1973-12-26	1973-12-26 00:00:00	32020		\N	40477	0	39848009	4218389		0
10543	621	80180	1953-11-29	1953-11-29 00:00:00	\N	\N	32020		\N	41372	0	396275006	80180		0
49	2	4112343	1963-02-05	1963-02-05 00:00:00	1963-02-18	1963-02-18 00:00:00	32020		\N	128	0	195662009	4112343		0
237	11	4283893	2019-04-21	2019-04-21 00:00:00	\N	\N	32020		\N	947	0	36971009	4283893		0
381	19	40481087	2018-08-13	2018-08-13 00:00:00	2018-08-20	2018-08-20 00:00:00	32020		\N	1455	0	444814009	40481087		0
561	32	4112343	1998-04-12	1998-04-12 00:00:00	1998-04-23	1998-04-23 00:00:00	32020		\N	2246	0	195662009	4112343		0
734	40	4294548	1960-10-25	1960-10-25 00:00:00	1960-12-20	1960-12-20 00:00:00	32020		\N	2877	0	75498004	4294548		0
972	57	28060	1976-10-29	1976-10-29 00:00:00	1976-11-08	1976-11-08 00:00:00	32020		\N	3823	0	43878008	28060		0
1082	64	4155034	2000-08-07	2000-08-07 00:00:00	2000-08-21	2000-08-21 00:00:00	32020		\N	4329	0	283371005	4155034		0
1215	70	40481087	1995-02-02	1995-02-02 00:00:00	1995-02-23	1995-02-23 00:00:00	32020		\N	4772	0	444814009	40481087		0
1377	80	28060	1986-08-29	1986-08-29 00:00:00	1986-09-09	1986-09-09 00:00:00	32020		\N	5382	0	43878008	28060		0
1612	95	4109685	1990-09-19	1990-09-19 00:00:00	1990-10-03	1990-10-03 00:00:00	32020		\N	6465	0	284551006	4109685		0
1715	99	28060	1972-01-30	1972-01-30 00:00:00	1972-02-11	1972-02-11 00:00:00	32020		\N	6772	0	43878008	28060		0
1923	114	28060	1974-12-31	1974-12-31 00:00:00	1975-01-08	1975-01-08 00:00:00	32020		\N	7529	0	43878008	28060		0
2054	119	40481087	1960-08-27	1960-08-27 00:00:00	1960-09-10	1960-09-10 00:00:00	32020		\N	7883	0	444814009	40481087		0
2287	133	40481087	2001-05-08	2001-05-08 00:00:00	2001-05-22	2001-05-22 00:00:00	32020		\N	8988	0	444814009	40481087		0
2389	141	378001	2016-08-06	2016-08-06 00:00:00	2016-09-05	2016-09-05 00:00:00	32020		\N	9486	0	62106007	378001		0
2580	152	196456	1973-12-15	1973-12-15 00:00:00	1973-12-15	1973-12-15 00:00:00	32020		\N	10291	0	235919008	196456		0
2726	159	4112343	1999-03-17	1999-03-17 00:00:00	1999-03-28	1999-03-28 00:00:00	32020		\N	10904	0	195662009	4112343		0
2871	164	4112343	1989-12-14	1989-12-14 00:00:00	1989-12-24	1989-12-24 00:00:00	32020		\N	11295	0	195662009	4112343		0
3058	180	40481087	2000-11-14	2000-11-14 00:00:00	2000-11-28	2000-11-28 00:00:00	32020		\N	12092	0	444814009	40481087		0
3203	187	40481087	1966-09-26	1966-09-26 00:00:00	1966-10-03	1966-10-03 00:00:00	32020		\N	12714	0	444814009	40481087		0
3385	194	40481087	2008-11-24	2008-11-24 00:00:00	2008-12-08	2008-12-08 00:00:00	32020		\N	13328	0	444814009	40481087		0
3552	202	80180	1982-02-16	1982-02-16 00:00:00	\N	\N	32020		\N	13822	0	396275006	80180		0
3714	212	78272	2011-01-20	2011-01-20 00:00:00	2011-02-03	2011-02-03 00:00:00	32020		\N	14439	0	70704007	78272		0
3882	224	4218389	1959-09-14	1959-09-14 00:00:00	1959-10-19	1959-10-19 00:00:00	32020		\N	15090	0	39848009	4218389		0
4059	235	40481087	1998-04-23	1998-04-23 00:00:00	1998-05-14	1998-05-14 00:00:00	32020		\N	15745	0	444814009	40481087		0
4223	245	40481087	2006-08-02	2006-08-02 00:00:00	2006-08-09	2006-08-09 00:00:00	32020		\N	16486	0	444814009	40481087		0
4378	254	4112343	1971-07-15	1971-07-15 00:00:00	1971-07-23	1971-07-23 00:00:00	32020		\N	16956	0	195662009	4112343		0
4532	264	40481087	2006-04-10	2006-04-10 00:00:00	2006-05-01	2006-05-01 00:00:00	32020		\N	17553	0	444814009	40481087		0
4719	277	28060	1964-03-02	1964-03-02 00:00:00	1964-03-10	1964-03-10 00:00:00	32020		\N	18490	0	43878008	28060		0
4869	286	4155034	2019-05-23	2019-05-23 00:00:00	2019-06-13	2019-06-13 00:00:00	32020		\N	19048	0	283371005	4155034		0
5055	297	28060	1989-07-20	1989-07-20 00:00:00	1989-08-02	1989-08-02 00:00:00	32020		\N	19779	0	43878008	28060		0
5208	307	4112343	2005-05-08	2005-05-08 00:00:00	2005-05-21	2005-05-21 00:00:00	32020		\N	20378	0	195662009	4112343		0
5399	318	4112343	2000-12-06	2000-12-06 00:00:00	2000-12-18	2000-12-18 00:00:00	32020		\N	21049	0	195662009	4112343		0
5562	328	4112343	2002-11-16	2002-11-16 00:00:00	2002-11-26	2002-11-26 00:00:00	32020		\N	21664	0	195662009	4112343		0
5704	335	78272	1973-03-27	1973-03-27 00:00:00	1973-04-10	1973-04-10 00:00:00	32020		\N	22293	0	70704007	78272		0
5885	347	4112343	1998-12-27	1998-12-27 00:00:00	1999-01-08	1999-01-08 00:00:00	32020		\N	23099	0	195662009	4112343		0
6032	354	4112343	2004-07-09	2004-07-09 00:00:00	2004-07-17	2004-07-17 00:00:00	32020		\N	23527	0	195662009	4112343		0
6192	364	4112343	1981-04-08	1981-04-08 00:00:00	1981-04-20	1981-04-20 00:00:00	32020		\N	24157	0	195662009	4112343		0
6358	374	260139	2004-07-10	2004-07-10 00:00:00	2004-07-17	2004-07-17 00:00:00	32020		\N	24842	0	10509002	260139		0
6577	388	372328	1957-08-20	1957-08-20 00:00:00	1958-01-21	1958-01-21 00:00:00	32020		\N	25528	0	65363002	372328		0
6691	395	372328	1964-11-08	1964-11-08 00:00:00	1965-01-26	1965-01-26 00:00:00	32020		\N	25977	0	65363002	372328		0
6864	404	81151	1962-06-04	1962-06-04 00:00:00	1962-07-09	1962-07-09 00:00:00	32020		\N	26661	0	44465007	81151		0
7023	411	260139	1961-02-11	1961-02-11 00:00:00	1961-02-25	1961-02-25 00:00:00	32020		\N	27317	0	10509002	260139		0
7237	426	28060	1967-12-05	1967-12-05 00:00:00	1967-12-15	1967-12-15 00:00:00	32020		\N	28257	0	43878008	28060		0
7354	432	257012	1986-06-08	1986-06-08 00:00:00	\N	\N	32020		\N	28755	0	40055000	257012		0
7529	442	40481087	1977-05-21	1977-05-21 00:00:00	1977-06-04	1977-06-04 00:00:00	32020		\N	29279	0	444814009	40481087		0
7698	452	260139	2008-12-14	2008-12-14 00:00:00	2008-12-21	2008-12-21 00:00:00	32020		\N	30106	0	10509002	260139		0
7863	459	40481087	1980-02-19	1980-02-19 00:00:00	1980-03-11	1980-03-11 00:00:00	32020		\N	30677	0	444814009	40481087		0
8041	470	81151	1967-03-30	1967-03-30 00:00:00	1967-04-13	1967-04-13 00:00:00	32020		\N	31391	0	44465007	81151		0
8207	480	4109685	1961-06-17	1961-06-17 00:00:00	1961-07-08	1961-07-08 00:00:00	32020		\N	31967	0	284551006	4109685		0
8360	487	4152936	1998-10-23	1998-10-23 00:00:00	1998-11-06	1998-11-06 00:00:00	32020		\N	32528	0	283385000	4152936		0
8540	498	260139	1972-04-16	1972-04-16 00:00:00	1972-04-30	1972-04-30 00:00:00	32020		\N	33290	0	10509002	260139		0
8717	510	260139	1979-11-19	1979-11-19 00:00:00	1979-12-03	1979-12-03 00:00:00	32020		\N	34109	0	10509002	260139		0
8875	520	4113008	1972-03-05	1972-03-05 00:00:00	1972-03-19	1972-03-19 00:00:00	32020		\N	34743	0	284549007	4113008		0
9025	528	260139	1971-08-25	1971-08-25 00:00:00	1971-09-08	1971-09-08 00:00:00	32020		\N	35152	0	10509002	260139		0
9223	545	81151	1974-10-23	1974-10-23 00:00:00	1974-11-20	1974-11-20 00:00:00	32020		\N	36143	0	44465007	81151		0
9349	552	4112343	1958-05-10	1958-05-10 00:00:00	1958-05-22	1958-05-22 00:00:00	32020		\N	36565	0	195662009	4112343		0
9527	565	40481087	1967-04-10	1967-04-10 00:00:00	1967-05-01	1967-05-01 00:00:00	32020		\N	37463	0	444814009	40481087		0
9679	572	4278672	1976-11-21	1976-11-21 00:00:00	1977-01-20	1977-01-20 00:00:00	32020		\N	37860	0	65966004	4278672		0
9849	582	4059173	1961-01-22	1961-01-22 00:00:00	1961-04-22	1961-04-22 00:00:00	32020		\N	38553	0	16114001	4059173		0
10072	597	81151	2001-11-26	2001-11-26 00:00:00	2001-12-31	2001-12-31 00:00:00	32020		\N	39459	0	44465007	81151		0
10190	603	260139	1983-11-03	1983-11-03 00:00:00	1983-11-10	1983-11-10 00:00:00	32020		\N	39942	0	10509002	260139		0
10344	610	40481087	1967-08-19	1967-08-19 00:00:00	1967-09-02	1967-09-02 00:00:00	32020		\N	40475	0	444814009	40481087		0
10544	621	40481087	2004-11-04	2004-11-04 00:00:00	2004-11-11	2004-11-11 00:00:00	32020		\N	41436	0	444814009	40481087		0
50	2	4156265	1977-04-08	1977-04-08 00:00:00	1977-04-22	1977-04-22 00:00:00	32020		\N	115	0	370247008	4156265		0
238	11	4112343	1980-12-27	1980-12-27 00:00:00	1981-01-04	1981-01-04 00:00:00	32020		\N	963	0	195662009	4112343		0
382	19	4112343	1974-10-19	1974-10-19 00:00:00	1974-10-26	1974-10-26 00:00:00	32020		\N	1482	0	195662009	4112343		0
562	32	4152936	1956-03-20	1956-03-20 00:00:00	1956-04-10	1956-04-10 00:00:00	32020		\N	2236	0	283385000	4152936		0
735	40	4237458	2018-06-14	2018-06-14 00:00:00	2018-07-14	2018-07-14 00:00:00	32020		\N	2866	0	58150001	4237458		0
973	57	4109685	1971-02-27	1971-02-27 00:00:00	1971-03-13	1971-03-13 00:00:00	32020		\N	3819	0	284551006	4109685		0
1083	64	4112343	1982-02-15	1982-02-15 00:00:00	1982-02-27	1982-02-27 00:00:00	32020		\N	4368	0	195662009	4112343		0
1216	70	4112343	1967-11-09	1967-11-09 00:00:00	1967-11-20	1967-11-20 00:00:00	32020		\N	4717	0	195662009	4112343		0
1378	80	40481087	1950-03-24	1950-03-24 00:00:00	1950-04-07	1950-04-07 00:00:00	32020		\N	5438	0	444814009	40481087		0
1613	95	40481087	2018-07-22	2018-07-22 00:00:00	2018-07-29	2018-07-29 00:00:00	32020		\N	6459	0	444814009	40481087		0
1716	99	4112343	1992-04-11	1992-04-11 00:00:00	1992-04-22	1992-04-22 00:00:00	32020		\N	6720	0	195662009	4112343		0
1924	114	439777	2006-03-05	2006-03-05 00:00:00	\N	\N	32020		\N	7511	0	271737000	439777		0
2055	119	40481087	1974-08-27	1974-08-27 00:00:00	1974-09-17	1974-09-17 00:00:00	32020		\N	7865	0	444814009	40481087		0
2288	133	378001	2009-10-14	2009-10-14 00:00:00	2009-11-13	2009-11-13 00:00:00	32020		\N	8961	0	62106007	378001		0
2390	141	372328	1987-01-13	1987-01-13 00:00:00	1987-02-03	1987-02-03 00:00:00	32020		\N	9469	0	65363002	372328		0
2581	152	40481087	2007-01-10	2007-01-10 00:00:00	2007-01-24	2007-01-24 00:00:00	32020		\N	10281	0	444814009	40481087		0
2727	159	40481087	2011-04-26	2011-04-26 00:00:00	2011-05-03	2011-05-03 00:00:00	32020		\N	10864	0	444814009	40481087		0
2872	164	28060	1966-06-05	1966-06-05 00:00:00	1966-06-15	1966-06-15 00:00:00	32020		\N	11243	0	43878008	28060		0
3059	180	4112343	1999-02-28	1999-02-28 00:00:00	1999-03-10	1999-03-10 00:00:00	32020		\N	12188	0	195662009	4112343		0
3204	187	378001	1974-06-05	1974-06-05 00:00:00	1974-08-04	1974-08-04 00:00:00	32020		\N	12734	0	62106007	378001		0
3386	194	40481087	2005-12-13	2005-12-13 00:00:00	2005-12-20	2005-12-20 00:00:00	32020		\N	13341	0	444814009	40481087		0
3553	202	4266809	1982-02-16	1982-02-16 00:00:00	\N	\N	32020		\N	13822	0	397881000	4266809		0
3715	212	372328	1996-04-15	1996-04-15 00:00:00	1996-06-22	1996-06-22 00:00:00	32020		\N	14417	0	65363002	372328		0
3883	224	4112343	1945-05-02	1945-05-02 00:00:00	1945-05-14	1945-05-14 00:00:00	32020		\N	15043	0	195662009	4112343		0
4060	235	4283893	1988-06-30	1988-06-30 00:00:00	1988-08-04	1988-08-04 00:00:00	32020		\N	15737	0	36971009	4283893		0
4224	245	260139	1991-04-10	1991-04-10 00:00:00	1991-04-17	1991-04-17 00:00:00	32020		\N	16480	0	10509002	260139		0
4416	260	40481087	2016-07-15	2016-07-15 00:00:00	2016-07-29	2016-07-29 00:00:00	32020		\N	17187	0	444814009	40481087		0
4533	264	260139	1978-06-15	1978-06-15 00:00:00	1978-06-29	1978-06-29 00:00:00	32020		\N	17514	0	10509002	260139		0
4720	277	81151	1987-09-26	1987-09-26 00:00:00	1987-10-17	1987-10-17 00:00:00	32020		\N	18498	0	44465007	81151		0
4870	286	4112343	1994-09-25	1994-09-25 00:00:00	1994-10-08	1994-10-08 00:00:00	32020		\N	19094	0	195662009	4112343		0
5056	297	195588	1995-06-06	1995-06-06 00:00:00	1995-07-09	1995-07-09 00:00:00	32020		\N	19770	0	38822007	195588		0
5209	307	81151	1987-10-04	1987-10-04 00:00:00	1987-10-18	1987-10-18 00:00:00	32020		\N	20381	0	44465007	81151		0
5400	318	78272	1956-12-14	1956-12-14 00:00:00	1957-01-04	1957-01-04 00:00:00	32020		\N	21114	0	70704007	78272		0
5563	328	40481087	1991-03-23	1991-03-23 00:00:00	1991-04-06	1991-04-06 00:00:00	32020		\N	21671	0	444814009	40481087		0
5705	335	4112343	1973-10-24	1973-10-24 00:00:00	1973-11-04	1973-11-04 00:00:00	32020		\N	22277	0	195662009	4112343		0
5886	347	4112343	1991-05-29	1991-05-29 00:00:00	1991-06-05	1991-06-05 00:00:00	32020		\N	23066	0	195662009	4112343		0
6033	354	40481087	1992-05-30	1992-05-30 00:00:00	1992-06-20	1992-06-20 00:00:00	32020		\N	23519	0	444814009	40481087		0
6193	364	40481087	1961-05-18	1961-05-18 00:00:00	1961-06-01	1961-06-01 00:00:00	32020		\N	24150	0	444814009	40481087		0
6359	374	440086	1992-11-04	1992-11-04 00:00:00	1997-11-13	1997-11-13 00:00:00	32020		\N	24798	0	192127007	440086		0
6578	388	4155034	2000-04-04	2000-04-04 00:00:00	2000-04-18	2000-04-18 00:00:00	32020		\N	25585	0	283371005	4155034		0
6692	395	40481087	1969-04-08	1969-04-08 00:00:00	1969-04-15	1969-04-15 00:00:00	32020		\N	25952	0	444814009	40481087		0
6865	404	260139	2001-11-07	2001-11-07 00:00:00	2001-11-21	2001-11-21 00:00:00	32020		\N	26609	0	10509002	260139		0
7024	411	40481087	1968-06-11	1968-06-11 00:00:00	1968-06-25	1968-06-25 00:00:00	32020		\N	27253	0	444814009	40481087		0
7238	426	4283893	1989-04-30	1989-04-30 00:00:00	1989-06-11	1989-06-11 00:00:00	32020		\N	28287	0	36971009	4283893		0
7355	432	28060	2015-12-25	2015-12-25 00:00:00	2016-01-02	2016-01-02 00:00:00	32020		\N	28772	0	43878008	28060		0
7530	442	134438	1980-08-21	1980-08-21 00:00:00	1981-05-21	1981-05-21 00:00:00	32020		\N	29294	0	40275004	134438		0
7699	452	372328	1965-12-31	1965-12-31 00:00:00	1966-02-11	1966-02-11 00:00:00	32020		\N	30087	0	65363002	372328		0
7864	459	4278672	2013-12-16	2013-12-16 00:00:00	2014-02-14	2014-02-14 00:00:00	32020		\N	30714	0	65966004	4278672		0
8042	470	4112343	1960-02-15	1960-02-15 00:00:00	1960-02-22	1960-02-22 00:00:00	32020		\N	31412	0	195662009	4112343		0
8208	480	40481087	1949-12-12	1949-12-12 00:00:00	1949-12-26	1949-12-26 00:00:00	32020		\N	32125	0	444814009	40481087		0
8361	487	372328	1971-03-14	1971-03-14 00:00:00	1971-05-05	1971-05-05 00:00:00	32020		\N	32534	0	65363002	372328		0
8541	498	78272	1977-08-16	1977-08-16 00:00:00	1977-09-20	1977-09-20 00:00:00	32020		\N	33246	0	70704007	78272		0
8718	510	260139	2006-08-03	2006-08-03 00:00:00	2006-08-17	2006-08-17 00:00:00	32020		\N	34077	0	10509002	260139		0
8876	520	78272	1965-09-26	1965-09-26 00:00:00	1965-10-17	1965-10-17 00:00:00	32020		\N	34750	0	70704007	78272		0
9026	528	40481087	1979-11-26	1979-11-26 00:00:00	1979-12-17	1979-12-17 00:00:00	32020		\N	35207	0	444814009	40481087		0
9224	545	40481087	1972-05-11	1972-05-11 00:00:00	1972-05-18	1972-05-18 00:00:00	32020		\N	36037	0	444814009	40481087		0
9350	552	40481087	1962-04-18	1962-04-18 00:00:00	1962-05-09	1962-05-09 00:00:00	32020		\N	36567	0	444814009	40481087		0
9528	565	40481087	1970-04-24	1970-04-24 00:00:00	1970-05-15	1970-05-15 00:00:00	32020		\N	37461	0	444814009	40481087		0
9680	572	28060	1961-11-29	1961-11-29 00:00:00	1961-12-06	1961-12-06 00:00:00	32020		\N	37871	0	43878008	28060		0
9850	582	378001	2009-03-21	2009-03-21 00:00:00	2009-04-20	2009-04-20 00:00:00	32020		\N	38556	0	62106007	378001		0
10073	597	28060	1963-03-26	1963-03-26 00:00:00	1963-04-04	1963-04-04 00:00:00	32020		\N	39472	0	43878008	28060		0
10191	603	4155034	2015-09-29	2015-09-29 00:00:00	2015-10-20	2015-10-20 00:00:00	32020		\N	39933	0	283371005	4155034		0
10345	610	4116491	2015-09-22	2015-09-22 00:00:00	2015-11-01	2015-11-01 00:00:00	32020		\N	40615	0	301011002	4116491		0
10545	621	4112343	1973-08-19	1973-08-19 00:00:00	1973-08-29	1973-08-29 00:00:00	32020		\N	41362	0	195662009	4112343		0
51	2	4112343	2001-02-03	2001-02-03 00:00:00	2001-02-10	2001-02-10 00:00:00	32020		\N	143	0	195662009	4112343		0
239	11	4134304	1966-08-24	1966-08-24 00:00:00	1966-09-23	1966-09-23 00:00:00	32020		\N	988	0	263102004	4134304		0
383	19	260139	2007-04-21	2007-04-21 00:00:00	2007-04-28	2007-04-28 00:00:00	32020		\N	1454	0	10509002	260139		0
563	32	257012	1967-03-05	1967-03-05 00:00:00	\N	\N	32020		\N	2269	0	40055000	257012		0
736	40	40481087	1982-12-18	1982-12-18 00:00:00	1983-01-01	1983-01-01 00:00:00	32020		\N	2869	0	444814009	40481087		0
974	57	40481087	2003-05-21	2003-05-21 00:00:00	2003-06-11	2003-06-11 00:00:00	32020		\N	3871	0	444814009	40481087		0
1084	64	40481087	1993-07-05	1993-07-05 00:00:00	1993-07-26	1993-07-26 00:00:00	32020		\N	4321	0	444814009	40481087		0
1217	70	378001	1984-07-01	1984-07-01 00:00:00	1984-07-31	1984-07-31 00:00:00	32020		\N	4712	0	62106007	378001		0
1379	80	260139	1937-07-09	1937-07-09 00:00:00	1937-07-16	1937-07-16 00:00:00	32020		\N	5460	0	10509002	260139		0
1614	95	260139	1979-02-24	1979-02-24 00:00:00	1979-03-03	1979-03-03 00:00:00	32020		\N	6419	0	10509002	260139		0
1717	99	40481087	1979-11-05	1979-11-05 00:00:00	1979-11-19	1979-11-19 00:00:00	32020		\N	6695	0	444814009	40481087		0
1925	114	260139	1999-11-18	1999-11-18 00:00:00	1999-12-02	1999-12-02 00:00:00	32020		\N	7517	0	10509002	260139		0
2056	119	4283893	2018-03-12	2018-03-12 00:00:00	2018-04-09	2018-04-09 00:00:00	32020		\N	7900	0	36971009	4283893		0
2289	133	192671	2019-04-05	2019-04-05 00:00:00	\N	\N	32020		\N	8962	0	K92.2	35208414		0
2391	141	40481087	1994-07-10	1994-07-10 00:00:00	1994-07-31	1994-07-31 00:00:00	32020		\N	9458	0	444814009	40481087		0
2582	152	260139	1976-09-10	1976-09-10 00:00:00	1976-09-17	1976-09-17 00:00:00	32020		\N	10278	0	10509002	260139		0
2728	159	28060	1968-08-29	1968-08-29 00:00:00	1968-09-05	1968-09-05 00:00:00	32020		\N	10855	0	43878008	28060		0
2873	165	4156265	1991-02-26	1991-02-26 00:00:00	1991-03-12	1991-03-12 00:00:00	32020		\N	11328	0	370247008	4156265		0
3060	180	4134304	1979-03-12	1979-03-12 00:00:00	1979-04-11	1979-04-11 00:00:00	32020		\N	12196	0	263102004	4134304		0
3205	187	81151	1999-04-21	1999-04-21 00:00:00	1999-05-26	1999-05-26 00:00:00	32020		\N	12737	0	44465007	81151		0
3387	194	257012	2010-11-27	2010-11-27 00:00:00	\N	\N	32020		\N	13303	0	40055000	257012		0
3554	202	40481087	1956-03-10	1956-03-10 00:00:00	1956-03-24	1956-03-24 00:00:00	32020		\N	13846	0	444814009	40481087		0
3716	212	4112343	1984-12-18	1984-12-18 00:00:00	1984-12-30	1984-12-30 00:00:00	32020		\N	14467	0	195662009	4112343		0
3884	224	257012	1990-11-07	1990-11-07 00:00:00	\N	\N	32020		\N	15046	0	40055000	257012		0
4061	235	40481087	1998-06-21	1998-06-21 00:00:00	1998-06-28	1998-06-28 00:00:00	32020		\N	15738	0	444814009	40481087		0
4225	245	80180	1954-06-24	1954-06-24 00:00:00	\N	\N	32020		\N	16476	0	396275006	80180		0
4417	260	4027663	2000-07-04	2000-07-04 00:00:00	\N	\N	32020		\N	17270	0	13200003	4027663		0
4534	264	4149245	1969-10-18	1969-10-18 00:00:00	1969-11-24	1969-11-24 00:00:00	32020		\N	17534	0	30832001	4149245		0
4721	277	4112343	1965-07-05	1965-07-05 00:00:00	1965-07-18	1965-07-18 00:00:00	32020		\N	18457	0	195662009	4112343		0
4871	286	4134304	2017-06-02	2017-06-02 00:00:00	2017-08-31	2017-08-31 00:00:00	32020		\N	19047	0	263102004	4134304		0
5057	297	4218389	1986-07-13	1986-07-13 00:00:00	1986-08-17	1986-08-17 00:00:00	32020		\N	19839	0	39848009	4218389		0
5210	307	4283893	2016-07-31	2016-07-31 00:00:00	2016-11-06	2016-11-06 00:00:00	32020		\N	20386	0	36971009	4283893		0
5401	318	4112343	2005-11-26	2005-11-26 00:00:00	2005-12-08	2005-12-08 00:00:00	32020		\N	21058	0	195662009	4112343		0
5581	331	4218389	2002-06-19	2002-06-19 00:00:00	2002-07-24	2002-07-24 00:00:00	32020		\N	21812	0	39848009	4218389		0
5706	335	4109685	1990-07-01	1990-07-01 00:00:00	1990-07-22	1990-07-22 00:00:00	32020		\N	22295	0	284551006	4109685		0
5887	347	4218389	2015-07-20	2015-07-20 00:00:00	2015-08-17	2015-08-17 00:00:00	32020		\N	23114	0	39848009	4218389		0
6034	354	40481087	2002-02-18	2002-02-18 00:00:00	2002-03-04	2002-03-04 00:00:00	32020		\N	23531	0	444814009	40481087		0
6194	364	40481087	2004-01-19	2004-01-19 00:00:00	2004-01-26	2004-01-26 00:00:00	32020		\N	24132	0	444814009	40481087		0
6360	374	28060	2002-07-24	2002-07-24 00:00:00	2002-08-03	2002-08-03 00:00:00	32020		\N	24839	0	43878008	28060		0
6579	388	4112343	1975-04-14	1975-04-14 00:00:00	1975-04-26	1975-04-26 00:00:00	32020		\N	25567	0	195662009	4112343		0
6693	395	80180	1998-04-27	1998-04-27 00:00:00	\N	\N	32020		\N	25932	0	396275006	80180		0
6866	404	40481087	2001-01-07	2001-01-07 00:00:00	2001-01-21	2001-01-21 00:00:00	32020		\N	26699	0	444814009	40481087		0
7025	411	28060	1995-11-07	1995-11-07 00:00:00	1995-11-19	1995-11-19 00:00:00	32020		\N	27336	0	43878008	28060		0
7239	426	260139	1981-03-26	1981-03-26 00:00:00	1981-04-09	1981-04-09 00:00:00	32020		\N	28275	0	10509002	260139		0
7356	432	4155034	1989-12-24	1989-12-24 00:00:00	1990-01-07	1990-01-07 00:00:00	32020		\N	28715	0	283371005	4155034		0
7531	442	4112343	1998-12-26	1998-12-26 00:00:00	1999-01-07	1999-01-07 00:00:00	32020		\N	29368	0	195662009	4112343		0
7700	452	4112343	1998-09-02	1998-09-02 00:00:00	1998-09-11	1998-09-11 00:00:00	32020		\N	30126	0	195662009	4112343		0
7865	459	372328	1975-01-07	1975-01-07 00:00:00	1975-08-11	1975-08-11 00:00:00	32020		\N	30682	0	65363002	372328		0
8043	470	4112343	2017-10-26	2017-10-26 00:00:00	2017-11-03	2017-11-03 00:00:00	32020		\N	31421	0	195662009	4112343		0
8209	480	260139	1944-07-20	1944-07-20 00:00:00	1944-07-27	1944-07-27 00:00:00	32020		\N	32019	0	10509002	260139		0
8362	487	260139	2007-05-27	2007-05-27 00:00:00	2007-06-03	2007-06-03 00:00:00	32020		\N	32543	0	10509002	260139		0
8542	498	260139	1988-02-06	1988-02-06 00:00:00	1988-02-13	1988-02-13 00:00:00	32020		\N	33271	0	10509002	260139		0
8719	510	4112343	1979-11-02	1979-11-02 00:00:00	1979-11-14	1979-11-14 00:00:00	32020		\N	34074	0	195662009	4112343		0
8877	520	372328	1983-02-19	1983-02-19 00:00:00	1985-06-06	1985-06-06 00:00:00	32020		\N	34673	0	65363002	372328		0
9027	528	4112343	1977-05-28	1977-05-28 00:00:00	1977-06-09	1977-06-09 00:00:00	32020		\N	35223	0	195662009	4112343		0
9225	545	4112343	2007-09-21	2007-09-21 00:00:00	2007-10-01	2007-10-01 00:00:00	32020		\N	36064	0	195662009	4112343		0
9351	552	40481087	1964-08-03	1964-08-03 00:00:00	1964-08-24	1964-08-24 00:00:00	32020		\N	36621	0	444814009	40481087		0
9529	565	260139	1980-07-14	1980-07-14 00:00:00	1980-07-28	1980-07-28 00:00:00	32020		\N	37405	0	10509002	260139		0
9681	572	4112343	1999-12-11	1999-12-11 00:00:00	1999-12-19	1999-12-19 00:00:00	32020		\N	37875	0	195662009	4112343		0
9851	582	40481087	2018-12-14	2018-12-14 00:00:00	2018-12-21	2018-12-21 00:00:00	32020		\N	38591	0	444814009	40481087		0
10074	597	4155034	1984-06-30	1984-06-30 00:00:00	1984-07-14	1984-07-14 00:00:00	32020		\N	39457	0	283371005	4155034		0
10192	603	40481087	1961-04-21	1961-04-21 00:00:00	1961-05-12	1961-05-12 00:00:00	32020		\N	39954	0	444814009	40481087		0
10346	610	4283893	1965-06-21	1965-06-21 00:00:00	1965-09-20	1965-09-20 00:00:00	32020		\N	40527	0	36971009	4283893		0
10546	621	4112343	1929-04-14	1929-04-14 00:00:00	1929-04-26	1929-04-26 00:00:00	32020		\N	41469	0	195662009	4112343		0
52	2	4112343	1995-04-18	1995-04-18 00:00:00	1995-04-25	1995-04-25 00:00:00	32020		\N	92	0	195662009	4112343		0
240	11	40481087	1991-07-17	1991-07-17 00:00:00	1991-08-07	1991-08-07 00:00:00	32020		\N	954	0	444814009	40481087		0
418	23	40481087	2009-05-25	2009-05-25 00:00:00	2009-06-01	2009-06-01 00:00:00	32020		\N	1792	0	444814009	40481087		0
564	32	81151	1955-04-27	1955-04-27 00:00:00	1955-05-25	1955-05-25 00:00:00	32020		\N	2235	0	44465007	81151		0
737	40	372328	1961-03-31	1961-03-31 00:00:00	1961-12-27	1961-12-27 00:00:00	32020		\N	2888	0	65363002	372328		0
975	57	4155034	2007-01-15	2007-01-15 00:00:00	2007-01-29	2007-01-29 00:00:00	32020		\N	3890	0	283371005	4155034		0
1085	64	260139	1985-02-28	1985-02-28 00:00:00	1985-03-14	1985-03-14 00:00:00	32020		\N	4319	0	10509002	260139		0
1218	70	4283893	1998-05-16	1998-05-16 00:00:00	1998-08-29	1998-08-29 00:00:00	32020		\N	4727	0	36971009	4283893		0
1380	80	260139	1953-02-24	1953-02-24 00:00:00	1953-03-10	1953-03-10 00:00:00	32020		\N	5380	0	10509002	260139		0
1615	95	378001	2007-05-05	2007-05-05 00:00:00	2007-07-04	2007-07-04 00:00:00	32020		\N	6467	0	62106007	378001		0
1718	99	260139	1980-11-30	1980-11-30 00:00:00	1980-12-14	1980-12-14 00:00:00	32020		\N	6777	0	10509002	260139		0
1926	114	40481087	2012-01-23	2012-01-23 00:00:00	2012-02-06	2012-02-06 00:00:00	32020		\N	7506	0	444814009	40481087		0
2057	119	40481087	2000-03-19	2000-03-19 00:00:00	2000-04-09	2000-04-09 00:00:00	32020		\N	7926	0	444814009	40481087		0
2290	133	28060	1990-05-31	1990-05-31 00:00:00	1990-06-10	1990-06-10 00:00:00	32020		\N	8958	0	43878008	28060		0
2392	141	28060	1993-09-22	1993-09-22 00:00:00	1993-10-04	1993-10-04 00:00:00	32020		\N	9449	0	43878008	28060		0
2583	152	40481087	2007-05-01	2007-05-01 00:00:00	2007-05-22	2007-05-22 00:00:00	32020		\N	10245	0	444814009	40481087		0
2729	159	4112343	1994-08-19	1994-08-19 00:00:00	1994-08-27	1994-08-27 00:00:00	32020		\N	10893	0	195662009	4112343		0
2874	165	80180	2006-10-21	2006-10-21 00:00:00	\N	\N	32020		\N	11345	0	396275006	80180		0
3061	180	28060	1983-09-28	1983-09-28 00:00:00	1983-10-06	1983-10-06 00:00:00	32020		\N	12163	0	43878008	28060		0
3206	187	4109685	1980-01-09	1980-01-09 00:00:00	1980-01-30	1980-01-30 00:00:00	32020		\N	12736	0	284551006	4109685		0
3388	194	4109685	1988-05-07	1988-05-07 00:00:00	1988-05-21	1988-05-21 00:00:00	32020		\N	13306	0	284551006	4109685		0
3555	202	40481087	1944-07-17	1944-07-17 00:00:00	1944-08-07	1944-08-07 00:00:00	32020		\N	13808	0	444814009	40481087		0
3717	213	40481087	2004-11-01	2004-11-01 00:00:00	2004-11-08	2004-11-08 00:00:00	32020		\N	14525	0	444814009	40481087		0
3885	224	4152936	1992-02-19	1992-02-19 00:00:00	1992-03-11	1992-03-11 00:00:00	32020		\N	15108	0	283385000	4152936		0
4062	235	372328	1985-05-13	1985-05-13 00:00:00	1986-04-21	1986-04-21 00:00:00	32020		\N	15746	0	65363002	372328		0
4226	245	4112343	1953-09-03	1953-09-03 00:00:00	1953-09-12	1953-09-12 00:00:00	32020		\N	16476	0	195662009	4112343		0
4418	260	4112343	1991-01-31	1991-01-31 00:00:00	1991-02-10	1991-02-10 00:00:00	32020		\N	17228	0	195662009	4112343		0
4535	264	4112343	1958-09-13	1958-09-13 00:00:00	1958-09-25	1958-09-25 00:00:00	32020		\N	17509	0	195662009	4112343		0
4722	277	260139	2010-12-09	2010-12-09 00:00:00	2010-12-16	2010-12-16 00:00:00	32020		\N	18505	0	10509002	260139		0
4872	286	40479768	1976-10-04	1976-10-04 00:00:00	1976-11-10	1976-11-10 00:00:00	32020		\N	19038	0	444470001	40479768		0
5058	297	40481087	2014-01-08	2014-01-08 00:00:00	2014-01-15	2014-01-15 00:00:00	32020		\N	19797	0	444814009	40481087		0
5211	307	260139	1990-08-02	1990-08-02 00:00:00	1990-08-16	1990-08-16 00:00:00	32020		\N	20334	0	10509002	260139		0
5402	318	80180	1994-12-10	1994-12-10 00:00:00	\N	\N	32020		\N	21080	0	396275006	80180		0
5582	331	40481087	1937-06-27	1937-06-27 00:00:00	1937-07-18	1937-07-18 00:00:00	32020		\N	21814	0	444814009	40481087		0
5707	335	40481087	1975-11-20	1975-11-20 00:00:00	1975-12-11	1975-12-11 00:00:00	32020		\N	22281	0	444814009	40481087		0
5888	347	40481087	1992-12-24	1992-12-24 00:00:00	1993-01-07	1993-01-07 00:00:00	32020		\N	23067	0	444814009	40481087		0
6035	354	4113008	1968-12-27	1968-12-27 00:00:00	1969-01-17	1969-01-17 00:00:00	32020		\N	23545	0	284549007	4113008		0
6195	364	40481087	2012-11-15	2012-11-15 00:00:00	2012-11-29	2012-11-29 00:00:00	32020		\N	24133	0	444814009	40481087		0
6361	374	260139	1991-03-05	1991-03-05 00:00:00	1991-03-19	1991-03-19 00:00:00	32020		\N	24822	0	10509002	260139		0
6580	388	40481087	1967-07-07	1967-07-07 00:00:00	1967-07-14	1967-07-14 00:00:00	32020		\N	25552	0	444814009	40481087		0
6694	395	4283893	1998-04-22	1998-04-22 00:00:00	1998-08-19	1998-08-19 00:00:00	32020		\N	25932	0	36971009	4283893		0
6867	404	4285898	2001-01-25	2001-01-25 00:00:00	\N	\N	32020		\N	26699	0	68496003	4285898		0
7026	411	260139	1981-12-24	1981-12-24 00:00:00	1981-12-31	1981-12-31 00:00:00	32020		\N	27269	0	10509002	260139		0
7240	426	80180	2011-01-22	2011-01-22 00:00:00	\N	\N	32020		\N	28273	0	396275006	80180		0
7357	432	4112343	2013-03-25	2013-03-25 00:00:00	2013-04-06	2013-04-06 00:00:00	32020		\N	28771	0	195662009	4112343		0
7532	442	28060	1955-06-29	1955-06-29 00:00:00	1955-07-11	1955-07-11 00:00:00	32020		\N	29310	0	43878008	28060		0
7701	452	40481087	2000-10-08	2000-10-08 00:00:00	2000-10-29	2000-10-29 00:00:00	32020		\N	30104	0	444814009	40481087		0
7866	459	4112343	1995-05-03	1995-05-03 00:00:00	1995-05-14	1995-05-14 00:00:00	32020		\N	30679	0	195662009	4112343		0
8044	470	40481087	2013-08-13	2013-08-13 00:00:00	2013-08-20	2013-08-20 00:00:00	32020		\N	31414	0	444814009	40481087		0
14133	834	4027663	1989-07-01	1989-07-01 00:00:00	\N	\N	32020		\N	55192	0	13200003	4027663		0
8210	480	260139	2010-09-15	2010-09-15 00:00:00	2010-09-22	2010-09-22 00:00:00	32020		\N	32092	0	10509002	260139		0
8363	487	4112343	2015-02-12	2015-02-12 00:00:00	2015-02-19	2015-02-19 00:00:00	32020		\N	32545	0	195662009	4112343		0
8543	498	4155034	2007-05-16	2007-05-16 00:00:00	2007-06-06	2007-06-06 00:00:00	32020		\N	33247	0	283371005	4155034		0
8720	510	440086	1975-09-30	1975-09-30 00:00:00	1983-10-08	1983-10-08 00:00:00	32020		\N	34072	0	192127007	440086		0
8878	520	40481087	1990-02-10	1990-02-10 00:00:00	1990-03-03	1990-03-03 00:00:00	32020		\N	34729	0	444814009	40481087		0
9028	528	40481087	1986-10-15	1986-10-15 00:00:00	1986-11-05	1986-11-05 00:00:00	32020		\N	35154	0	444814009	40481087		0
9226	546	4112343	1977-07-18	1977-07-18 00:00:00	1977-07-25	1977-07-25 00:00:00	32020		\N	36177	0	195662009	4112343		0
9352	552	375671	2014-06-10	2014-06-10 00:00:00	2014-07-10	2014-07-10 00:00:00	32020		\N	36613	0	62564004	375671		0
9530	565	40481087	2017-04-22	2017-04-22 00:00:00	2017-04-29	2017-04-29 00:00:00	32020		\N	37406	0	444814009	40481087		0
9682	573	378001	2016-05-30	2016-05-30 00:00:00	2016-07-29	2016-07-29 00:00:00	32020		\N	37984	0	62106007	378001		0
9852	582	4112343	1966-08-26	1966-08-26 00:00:00	1966-09-04	1966-09-04 00:00:00	32020		\N	38536	0	195662009	4112343		0
10075	597	4310024	1985-05-27	1985-05-27 00:00:00	\N	\N	32020		\N	39457	0	424802006	4310024		0
10193	603	4112343	2009-05-26	2009-05-26 00:00:00	2009-06-06	2009-06-06 00:00:00	32020		\N	40032	0	195662009	4112343		0
10347	610	372328	1977-10-10	1977-10-10 00:00:00	1977-12-22	1977-12-22 00:00:00	32020		\N	40569	0	65363002	372328		0
10547	621	40481087	1979-08-15	1979-08-15 00:00:00	1979-09-05	1979-09-05 00:00:00	32020		\N	41434	0	444814009	40481087		0
53	2	40481087	1942-09-17	1942-09-17 00:00:00	1942-10-01	1942-10-01 00:00:00	32020		\N	177	0	444814009	40481087		0
241	11	378001	2000-04-21	2000-04-21 00:00:00	2000-05-21	2000-05-21 00:00:00	32020		\N	994	0	62106007	378001		0
419	23	4296204	1997-02-04	1997-02-04 00:00:00	1997-03-04	1997-03-04 00:00:00	32020		\N	1776	0	403190006	4296204		0
565	32	4112343	1987-03-31	1987-03-31 00:00:00	1987-04-09	1987-04-09 00:00:00	32020		\N	2198	0	195662009	4112343		0
738	40	4112343	2007-05-31	2007-05-31 00:00:00	2007-06-08	2007-06-08 00:00:00	32020		\N	2835	0	195662009	4112343		0
976	57	40481087	2018-08-15	2018-08-15 00:00:00	2018-08-29	2018-08-29 00:00:00	32020		\N	3873	0	444814009	40481087		0
1086	64	4112343	1989-12-01	1989-12-01 00:00:00	1989-12-09	1989-12-09 00:00:00	32020		\N	4332	0	195662009	4112343		0
1219	70	372328	1952-05-20	1952-05-20 00:00:00	1953-03-22	1953-03-22 00:00:00	32020		\N	4731	0	65363002	372328		0
1381	80	40481087	1942-01-20	1942-01-20 00:00:00	1942-01-27	1942-01-27 00:00:00	32020		\N	5436	0	444814009	40481087		0
1616	95	260139	1973-11-04	1973-11-04 00:00:00	1973-11-11	1973-11-11 00:00:00	32020		\N	6456	0	10509002	260139		0
1720	99	372328	1959-06-22	1959-06-22 00:00:00	1959-10-03	1959-10-03 00:00:00	32020		\N	6700	0	65363002	372328		0
1927	114	381316	2004-11-22	2004-11-22 00:00:00	\N	\N	32020		\N	7548	0	230690007	381316		0
2058	119	40481087	1956-02-01	1956-02-01 00:00:00	1956-02-15	1956-02-15 00:00:00	32020		\N	7925	0	444814009	40481087		0
2291	133	4027663	2008-12-08	2008-12-08 00:00:00	\N	\N	32020		\N	8974	0	13200003	4027663		0
2393	141	78272	2013-09-23	2013-09-23 00:00:00	2013-10-21	2013-10-21 00:00:00	32020		\N	9485	0	70704007	78272		0
2584	152	40481087	1976-03-30	1976-03-30 00:00:00	1976-04-06	1976-04-06 00:00:00	32020		\N	10227	0	444814009	40481087		0
2730	159	40479422	1997-12-23	1997-12-23 00:00:00	1998-02-28	1998-02-28 00:00:00	32020		\N	10922	0	444448004	40479422		0
2875	165	4294548	2018-02-23	2018-02-23 00:00:00	2018-07-27	2018-07-27 00:00:00	32020		\N	11354	0	75498004	4294548		0
3062	180	372328	1981-11-09	1981-11-09 00:00:00	1982-04-01	1982-04-01 00:00:00	32020		\N	12161	0	65363002	372328		0
3207	187	4112343	1996-04-08	1996-04-08 00:00:00	1996-04-19	1996-04-19 00:00:00	32020		\N	12744	0	195662009	4112343		0
3389	194	4218389	2010-07-25	2010-07-25 00:00:00	2010-08-22	2010-08-22 00:00:00	32020		\N	13308	0	39848009	4218389		0
3556	202	4112343	2002-05-19	2002-05-19 00:00:00	2002-05-26	2002-05-26 00:00:00	32020		\N	13844	0	195662009	4112343		0
3718	213	40481087	2012-11-30	2012-11-30 00:00:00	2012-12-21	2012-12-21 00:00:00	32020		\N	14502	0	444814009	40481087		0
3886	224	40481087	1944-06-09	1944-06-09 00:00:00	1944-06-23	1944-06-23 00:00:00	32020		\N	15042	0	444814009	40481087		0
4063	235	28060	1986-04-19	1986-04-19 00:00:00	1986-04-30	1986-04-30 00:00:00	32020		\N	15778	0	43878008	28060		0
4227	245	260139	1961-07-08	1961-07-08 00:00:00	1961-07-15	1961-07-15 00:00:00	32020		\N	16425	0	10509002	260139		0
4419	260	257012	1982-04-13	1982-04-13 00:00:00	\N	\N	32020		\N	17157	0	40055000	257012		0
4536	264	317576	2005-09-02	2005-09-02 00:00:00	\N	\N	32020		\N	17530	0	53741008	317576		0
4723	277	80180	2001-01-05	2001-01-05 00:00:00	\N	\N	32020		\N	18462	0	396275006	80180		0
4873	286	260139	1928-08-05	1928-08-05 00:00:00	1928-08-19	1928-08-19 00:00:00	32020		\N	19050	0	10509002	260139		0
5059	297	4112343	1976-12-09	1976-12-09 00:00:00	1976-12-21	1976-12-21 00:00:00	32020		\N	19795	0	195662009	4112343		0
5212	307	28060	1981-02-02	1981-02-02 00:00:00	1981-02-12	1981-02-12 00:00:00	32020		\N	20333	0	43878008	28060		0
5403	318	4294548	1959-06-09	1959-06-09 00:00:00	1959-12-01	1959-12-01 00:00:00	32020		\N	21047	0	75498004	4294548		0
5583	331	4294548	1993-10-28	1993-10-28 00:00:00	1994-01-06	1994-01-06 00:00:00	32020		\N	21861	0	75498004	4294548		0
5708	335	260139	1986-10-25	1986-10-25 00:00:00	1986-11-08	1986-11-08 00:00:00	32020		\N	22279	0	10509002	260139		0
5889	347	4237458	1982-10-11	1982-10-11 00:00:00	1982-11-10	1982-11-10 00:00:00	32020		\N	23113	0	58150001	4237458		0
6036	354	260139	1957-06-30	1957-06-30 00:00:00	1957-07-14	1957-07-14 00:00:00	32020		\N	23530	0	10509002	260139		0
6196	364	40481087	1969-04-25	1969-04-25 00:00:00	1969-05-16	1969-05-16 00:00:00	32020		\N	24216	0	444814009	40481087		0
6362	374	4112343	1986-01-06	1986-01-06 00:00:00	1986-01-15	1986-01-15 00:00:00	32020		\N	24811	0	195662009	4112343		0
6581	388	378001	1974-07-20	1974-07-20 00:00:00	1974-08-19	1974-08-19 00:00:00	32020		\N	25584	0	62106007	378001		0
6695	395	40481087	1993-08-27	1993-08-27 00:00:00	1993-09-10	1993-09-10 00:00:00	32020		\N	25989	0	444814009	40481087		0
6868	404	40481087	1968-09-22	1968-09-22 00:00:00	1968-09-29	1968-09-29 00:00:00	32020		\N	26627	0	444814009	40481087		0
7027	411	40481087	1968-09-28	1968-09-28 00:00:00	1968-10-12	1968-10-12 00:00:00	32020		\N	27307	0	444814009	40481087		0
7241	426	40481087	1990-06-14	1990-06-14 00:00:00	1990-07-05	1990-07-05 00:00:00	32020		\N	28276	0	444814009	40481087		0
7358	432	80180	1973-01-07	1973-01-07 00:00:00	\N	\N	32020		\N	28766	0	396275006	80180		0
7533	443	260139	1993-07-27	1993-07-27 00:00:00	1993-08-03	1993-08-03 00:00:00	32020		\N	29476	0	10509002	260139		0
7702	452	40481087	1965-03-31	1965-03-31 00:00:00	1965-04-14	1965-04-14 00:00:00	32020		\N	30084	0	444814009	40481087		0
7867	459	40481087	2016-06-21	2016-06-21 00:00:00	2016-07-12	2016-07-12 00:00:00	32020		\N	30719	0	444814009	40481087		0
8045	470	40481087	1966-09-07	1966-09-07 00:00:00	1966-09-28	1966-09-28 00:00:00	32020		\N	31406	0	444814009	40481087		0
8211	480	28060	2000-02-04	2000-02-04 00:00:00	2000-02-13	2000-02-13 00:00:00	32020		\N	32029	0	43878008	28060		0
8364	487	4112343	2008-02-26	2008-02-26 00:00:00	2008-03-04	2008-03-04 00:00:00	32020		\N	32553	0	195662009	4112343		0
8544	499	40481087	2011-05-29	2011-05-29 00:00:00	2011-06-05	2011-06-05 00:00:00	32020		\N	33373	0	444814009	40481087		0
8721	510	40481087	1975-06-17	1975-06-17 00:00:00	1975-07-08	1975-07-08 00:00:00	32020		\N	34068	0	444814009	40481087		0
8879	520	4112343	1961-02-16	1961-02-16 00:00:00	1961-02-28	1961-02-28 00:00:00	32020		\N	34725	0	195662009	4112343		0
9029	528	4112343	2007-12-03	2007-12-03 00:00:00	2007-12-15	2007-12-15 00:00:00	32020		\N	35158	0	195662009	4112343		0
9227	546	4112343	1966-03-21	1966-03-21 00:00:00	1966-03-31	1966-03-31 00:00:00	32020		\N	36199	0	195662009	4112343		0
9353	552	40481087	2007-10-25	2007-10-25 00:00:00	2007-11-08	2007-11-08 00:00:00	32020		\N	36584	0	444814009	40481087		0
9531	565	372328	1963-05-15	1963-05-15 00:00:00	1964-03-11	1964-03-11 00:00:00	32020		\N	37407	0	65363002	372328		0
9683	573	4112343	2008-04-19	2008-04-19 00:00:00	2008-04-27	2008-04-27 00:00:00	32020		\N	38002	0	195662009	4112343		0
9853	582	40481087	1989-09-27	1989-09-27 00:00:00	1989-10-04	1989-10-04 00:00:00	32020		\N	38531	0	444814009	40481087		0
10076	597	28060	2003-06-21	2003-06-21 00:00:00	2003-06-29	2003-06-29 00:00:00	32020		\N	39447	0	43878008	28060		0
10194	603	40481087	1984-03-02	1984-03-02 00:00:00	1984-03-16	1984-03-16 00:00:00	32020		\N	39957	0	444814009	40481087		0
10348	610	28060	1973-08-27	1973-08-27 00:00:00	1973-09-03	1973-09-03 00:00:00	32020		\N	40578	0	43878008	28060		0
10548	621	4112343	1918-09-22	1918-09-22 00:00:00	1918-10-05	1918-10-05 00:00:00	32020		\N	41360	0	195662009	4112343		0
54	2	40481087	1968-10-07	1968-10-07 00:00:00	1968-10-21	1968-10-21 00:00:00	32020		\N	180	0	444814009	40481087		0
242	11	381316	2002-05-28	2002-05-28 00:00:00	\N	\N	32020		\N	973	0	230690007	381316		0
420	23	260139	1991-10-01	1991-10-01 00:00:00	1991-10-08	1991-10-08 00:00:00	32020		\N	1791	0	10509002	260139		0
599	35	40481087	1993-11-27	1993-11-27 00:00:00	1993-12-11	1993-12-11 00:00:00	32020		\N	2431	0	444814009	40481087		0
739	40	257012	1960-11-29	1960-11-29 00:00:00	\N	\N	32020		\N	2878	0	40055000	257012		0
977	57	40481087	2002-03-05	2002-03-05 00:00:00	2002-03-19	2002-03-19 00:00:00	32020		\N	3846	0	444814009	40481087		0
1087	64	4112343	1995-07-13	1995-07-13 00:00:00	1995-07-21	1995-07-21 00:00:00	32020		\N	4333	0	195662009	4112343		0
1220	70	4283893	1999-08-31	1999-08-31 00:00:00	2000-03-14	2000-03-14 00:00:00	32020		\N	4728	0	36971009	4283893		0
1382	80	81151	1988-09-12	1988-09-12 00:00:00	1988-10-17	1988-10-17 00:00:00	32020		\N	5434	0	44465007	81151		0
1617	95	40481087	1988-03-09	1988-03-09 00:00:00	1988-03-23	1988-03-23 00:00:00	32020		\N	6399	0	444814009	40481087		0
1721	99	260139	2015-03-28	2015-03-28 00:00:00	2015-04-04	2015-04-04 00:00:00	32020		\N	6773	0	10509002	260139		0
1928	114	81151	1973-04-07	1973-04-07 00:00:00	1973-05-05	1973-05-05 00:00:00	32020		\N	7504	0	44465007	81151		0
2059	119	40481087	1987-10-29	1987-10-29 00:00:00	1987-11-19	1987-11-19 00:00:00	32020		\N	7897	0	444814009	40481087		0
2292	133	372328	1988-11-03	1988-11-03 00:00:00	1988-12-12	1988-12-12 00:00:00	32020		\N	8994	0	65363002	372328		0
2394	141	80180	2015-11-12	2015-11-12 00:00:00	\N	\N	32020		\N	9485	0	396275006	80180		0
2585	152	4152936	1995-03-03	1995-03-03 00:00:00	1995-03-24	1995-03-24 00:00:00	32020		\N	10293	0	283385000	4152936		0
2731	159	4112343	1971-05-24	1971-05-24 00:00:00	1971-06-05	1971-06-05 00:00:00	32020		\N	10891	0	195662009	4112343		0
2876	165	4112343	2010-11-11	2010-11-11 00:00:00	2010-11-19	2010-11-19 00:00:00	32020		\N	11342	0	195662009	4112343		0
3063	181	198199	1996-09-10	1996-09-10 00:00:00	1996-10-16	1996-10-16 00:00:00	32020		\N	12234	0	45816000	198199		0
3208	187	40481087	2010-01-06	2010-01-06 00:00:00	2010-01-27	2010-01-27 00:00:00	32020		\N	12747	0	444814009	40481087		0
3390	194	4112343	1995-01-06	1995-01-06 00:00:00	1995-01-16	1995-01-16 00:00:00	32020		\N	13340	0	195662009	4112343		0
3557	202	40481087	1990-04-09	1990-04-09 00:00:00	1990-04-16	1990-04-16 00:00:00	32020		\N	13810	0	444814009	40481087		0
3719	213	40481087	2009-06-23	2009-06-23 00:00:00	2009-07-14	2009-07-14 00:00:00	32020		\N	14512	0	444814009	40481087		0
3887	224	4112343	2008-11-18	2008-11-18 00:00:00	2008-11-29	2008-11-29 00:00:00	32020		\N	15022	0	195662009	4112343		0
4064	235	80180	2016-05-17	2016-05-17 00:00:00	\N	\N	32020		\N	15766	0	396275006	80180		0
4228	245	4230399	2015-09-20	2015-09-20 00:00:00	2015-10-20	2015-10-20 00:00:00	32020		\N	16407	0	359817006	4230399		0
4420	260	4310024	2008-05-28	2008-05-28 00:00:00	\N	\N	32020		\N	17273	0	424802006	4310024		0
4538	264	4329847	2011-11-11	2011-11-11 00:00:00	\N	\N	32020		\N	17590	0	22298006	4329847		0
4724	277	4112343	1981-06-27	1981-06-27 00:00:00	1981-07-06	1981-07-06 00:00:00	32020		\N	18481	0	195662009	4112343		0
4874	286	260139	1934-05-22	1934-05-22 00:00:00	1934-05-29	1934-05-29 00:00:00	32020		\N	19082	0	10509002	260139		0
5060	297	4112343	1970-05-20	1970-05-20 00:00:00	1970-05-29	1970-05-29 00:00:00	32020		\N	19769	0	195662009	4112343		0
5213	307	40481087	2000-07-15	2000-07-15 00:00:00	2000-07-22	2000-07-22 00:00:00	32020		\N	20376	0	444814009	40481087		0
5404	318	372328	1955-01-24	1955-01-24 00:00:00	1955-04-11	1955-04-11 00:00:00	32020		\N	21071	0	65363002	372328		0
5584	331	40481087	1963-05-04	1963-05-04 00:00:00	1963-05-18	1963-05-18 00:00:00	32020		\N	21769	0	444814009	40481087		0
5709	335	40481087	2017-03-29	2017-03-29 00:00:00	2017-04-12	2017-04-12 00:00:00	32020		\N	22243	0	444814009	40481087		0
5890	347	40481087	2000-10-02	2000-10-02 00:00:00	2000-10-16	2000-10-16 00:00:00	32020		\N	23090	0	444814009	40481087		0
6037	354	378001	1967-11-03	1967-11-03 00:00:00	1968-01-02	1968-01-02 00:00:00	32020		\N	23544	0	62106007	378001		0
6197	364	4112343	1973-02-08	1973-02-08 00:00:00	1973-02-17	1973-02-17 00:00:00	32020		\N	24217	0	195662009	4112343		0
6363	374	40481087	2002-08-29	2002-08-29 00:00:00	2002-09-05	2002-09-05 00:00:00	32020		\N	24814	0	444814009	40481087		0
6582	388	4112343	1999-09-04	1999-09-04 00:00:00	1999-09-15	1999-09-15 00:00:00	32020		\N	25570	0	195662009	4112343		0
6696	395	28060	1983-12-16	1983-12-16 00:00:00	1983-12-26	1983-12-26 00:00:00	32020		\N	25954	0	43878008	28060		0
6869	404	81893	2000-07-29	2000-07-29 00:00:00	\N	\N	32020		\N	26691	0	64766004	81893		0
7028	412	40481087	1983-08-17	1983-08-17 00:00:00	1983-08-24	1983-08-24 00:00:00	32020		\N	27464	0	444814009	40481087		0
7242	426	378001	2009-01-27	2009-01-27 00:00:00	2009-03-28	2009-03-28 00:00:00	32020		\N	28314	0	62106007	378001		0
7359	432	40481087	1998-11-29	1998-11-29 00:00:00	1998-12-13	1998-12-13 00:00:00	32020		\N	28726	0	444814009	40481087		0
7534	443	372328	1973-02-07	1973-02-07 00:00:00	1973-11-26	1973-11-26 00:00:00	32020		\N	29442	0	65363002	372328		0
7703	452	4035415	2013-06-07	2013-06-07 00:00:00	2013-08-06	2013-08-06 00:00:00	32020		\N	30150	0	239720000	4035415		0
7868	459	4112343	1995-06-15	1995-06-15 00:00:00	1995-06-28	1995-06-28 00:00:00	32020		\N	30676	0	195662009	4112343		0
8046	470	4112343	1965-10-06	1965-10-06 00:00:00	1965-10-15	1965-10-15 00:00:00	32020		\N	31418	0	195662009	4112343		0
8212	480	378001	1968-04-02	1968-04-02 00:00:00	1968-06-01	1968-06-01 00:00:00	32020		\N	31968	0	62106007	378001		0
8365	487	260139	1988-08-10	1988-08-10 00:00:00	1988-08-24	1988-08-24 00:00:00	32020		\N	32568	0	10509002	260139		0
8545	499	40481087	1963-09-20	1963-09-20 00:00:00	1963-10-11	1963-10-11 00:00:00	32020		\N	33448	0	444814009	40481087		0
8722	510	4112343	2001-11-08	2001-11-08 00:00:00	2001-11-21	2001-11-21 00:00:00	32020		\N	34076	0	195662009	4112343		0
8880	520	260139	1975-06-30	1975-06-30 00:00:00	1975-07-07	1975-07-07 00:00:00	32020		\N	34726	0	10509002	260139		0
9030	528	372328	1960-07-22	1960-07-22 00:00:00	1960-08-05	1960-08-05 00:00:00	32020		\N	35160	0	65363002	372328		0
9228	546	4112343	1968-08-19	1968-08-19 00:00:00	1968-09-01	1968-09-01 00:00:00	32020		\N	36176	0	195662009	4112343		0
9354	552	372328	1954-10-21	1954-10-21 00:00:00	1955-03-01	1955-03-01 00:00:00	32020		\N	36626	0	65363002	372328		0
9532	565	260139	1967-12-12	1967-12-12 00:00:00	1967-12-19	1967-12-19 00:00:00	32020		\N	37435	0	10509002	260139		0
9684	573	260139	1977-03-25	1977-03-25 00:00:00	1977-04-01	1977-04-01 00:00:00	32020		\N	37930	0	10509002	260139		0
9854	582	372328	1977-06-08	1977-06-08 00:00:00	1977-10-26	1977-10-26 00:00:00	32020		\N	38533	0	65363002	372328		0
10077	597	40481087	2012-06-10	2012-06-10 00:00:00	2012-06-17	2012-06-17 00:00:00	32020		\N	39448	0	444814009	40481087		0
10195	603	40481087	1978-01-13	1978-01-13 00:00:00	1978-01-27	1978-01-27 00:00:00	32020		\N	39936	0	444814009	40481087		0
10349	610	260139	1998-01-28	1998-01-28 00:00:00	1998-02-11	1998-02-11 00:00:00	32020		\N	40567	0	10509002	260139		0
10549	621	40481087	1951-01-31	1951-01-31 00:00:00	1951-02-21	1951-02-21 00:00:00	32020		\N	41451	0	444814009	40481087		0
55	2	4112343	1960-10-31	1960-10-31 00:00:00	1960-11-13	1960-11-13 00:00:00	32020		\N	179	0	195662009	4112343		0
243	11	372328	1960-06-26	1960-06-26 00:00:00	1960-11-22	1960-11-22 00:00:00	32020		\N	924	0	65363002	372328		0
421	23	260139	2011-11-24	2011-11-24 00:00:00	2011-12-01	2011-12-01 00:00:00	32020		\N	1804	0	10509002	260139		0
600	35	40481087	2017-12-14	2017-12-14 00:00:00	2017-12-28	2017-12-28 00:00:00	32020		\N	2463	0	444814009	40481087		0
740	41	4152936	1979-12-21	1979-12-21 00:00:00	1980-01-11	1980-01-11 00:00:00	32020		\N	2899	0	283385000	4152936		0
978	57	260139	1986-07-31	1986-07-31 00:00:00	1986-08-14	1986-08-14 00:00:00	32020		\N	3868	0	10509002	260139		0
1088	64	40481087	1975-07-25	1975-07-25 00:00:00	1975-08-08	1975-08-08 00:00:00	32020		\N	4367	0	444814009	40481087		0
1221	70	4112343	1948-08-11	1948-08-11 00:00:00	1948-08-22	1948-08-22 00:00:00	32020		\N	4762	0	195662009	4112343		0
1383	80	40481087	1981-11-05	1981-11-05 00:00:00	1981-11-12	1981-11-12 00:00:00	32020		\N	5401	0	444814009	40481087		0
1618	95	40481087	1978-04-18	1978-04-18 00:00:00	1978-04-25	1978-04-25 00:00:00	32020		\N	6418	0	444814009	40481087		0
1722	99	4283893	1998-10-04	1998-10-04 00:00:00	1998-11-15	1998-11-15 00:00:00	32020		\N	6778	0	36971009	4283893		0
1929	114	4283893	2009-04-23	2009-04-23 00:00:00	2009-08-27	2009-08-27 00:00:00	32020		\N	7551	0	36971009	4283893		0
2060	120	4112343	2019-05-30	2019-05-30 00:00:00	2019-06-08	2019-06-08 00:00:00	32020		\N	8008	0	195662009	4112343		0
2298	135	4237458	1988-12-10	1988-12-10 00:00:00	1989-03-10	1989-03-10 00:00:00	32020		\N	9020	0	58150001	4237458		0
2395	141	4142905	1995-07-30	1995-07-30 00:00:00	1995-09-28	1995-09-28 00:00:00	32020		\N	9484	0	33737001	4142905		0
2586	152	40481087	1993-05-31	1993-05-31 00:00:00	1993-06-14	1993-06-14 00:00:00	32020		\N	10244	0	444814009	40481087		0
2732	159	40481087	1998-06-18	1998-06-18 00:00:00	1998-06-25	1998-06-25 00:00:00	32020		\N	10862	0	444814009	40481087		0
2877	165	40481087	1998-08-09	1998-08-09 00:00:00	1998-08-16	1998-08-16 00:00:00	32020		\N	11314	0	444814009	40481087		0
3064	181	4112343	2008-05-11	2008-05-11 00:00:00	2008-05-18	2008-05-18 00:00:00	32020		\N	12238	0	195662009	4112343		0
3209	187	4112343	2006-12-22	2006-12-22 00:00:00	2006-12-30	2006-12-30 00:00:00	32020		\N	12670	0	195662009	4112343		0
3391	194	28060	1986-06-18	1986-06-18 00:00:00	1986-06-25	1986-06-25 00:00:00	32020		\N	13329	0	43878008	28060		0
3558	202	28060	2002-11-23	2002-11-23 00:00:00	2002-12-06	2002-12-06 00:00:00	32020		\N	13812	0	43878008	28060		0
3720	213	4155034	1988-05-10	1988-05-10 00:00:00	1988-05-24	1988-05-24 00:00:00	32020		\N	14535	0	283371005	4155034		0
3888	224	372328	1944-11-01	1944-11-01 00:00:00	1945-04-03	1945-04-03 00:00:00	32020		\N	15040	0	65363002	372328		0
4065	235	260139	2008-06-02	2008-06-02 00:00:00	2008-06-16	2008-06-16 00:00:00	32020		\N	15740	0	10509002	260139		0
4229	245	40480160	2015-09-20	2015-09-20 00:00:00	2015-10-20	2015-10-20 00:00:00	32020		\N	16407	0	443165006	40480160		0
4421	260	372328	1969-10-10	1969-10-10 00:00:00	1969-12-20	1969-12-20 00:00:00	32020		\N	17182	0	65363002	372328		0
4539	264	192671	1984-06-22	1984-06-22 00:00:00	\N	\N	32020		\N	17584	0	K92.2	35208414		0
4732	279	4112343	2006-05-10	2006-05-10 00:00:00	2006-05-21	2006-05-21 00:00:00	32020		\N	18623	0	195662009	4112343		0
4875	286	4152936	1975-10-26	1975-10-26 00:00:00	1975-11-09	1975-11-09 00:00:00	32020		\N	19037	0	283385000	4152936		0
5061	297	40481087	2005-08-29	2005-08-29 00:00:00	2005-09-19	2005-09-19 00:00:00	32020		\N	19780	0	444814009	40481087		0
5214	307	4027663	2002-06-13	2002-06-13 00:00:00	\N	\N	32020		\N	20376	0	13200003	4027663		0
5405	318	4094814	2011-02-11	2011-02-11 00:00:00	2011-05-12	2011-05-12 00:00:00	32020		\N	21116	0	262574004	4094814		0
5585	331	4112343	1957-12-21	1957-12-21 00:00:00	1957-12-30	1957-12-30 00:00:00	32020		\N	21768	0	195662009	4112343		0
5710	335	260139	1974-07-22	1974-07-22 00:00:00	1974-08-05	1974-08-05 00:00:00	32020		\N	22271	0	10509002	260139		0
5891	347	4112343	2015-03-03	2015-03-03 00:00:00	2015-03-15	2015-03-15 00:00:00	32020		\N	23091	0	195662009	4112343		0
6038	354	4218389	2012-04-13	2012-04-13 00:00:00	2012-05-18	2012-05-18 00:00:00	32020		\N	23548	0	39848009	4218389		0
6198	364	260139	2016-09-10	2016-09-10 00:00:00	2016-09-24	2016-09-24 00:00:00	32020		\N	24135	0	10509002	260139		0
6364	374	4218389	1995-01-23	1995-01-23 00:00:00	1995-02-20	1995-02-20 00:00:00	32020		\N	24848	0	39848009	4218389		0
6583	388	375671	1966-08-03	1966-08-03 00:00:00	1966-09-02	1966-09-02 00:00:00	32020		\N	25581	0	62564004	375671		0
6697	395	4112343	2014-06-05	2014-06-05 00:00:00	2014-06-16	2014-06-16 00:00:00	32020		\N	25955	0	195662009	4112343		0
6870	404	30753	2000-08-28	2000-08-28 00:00:00	\N	\N	32020		\N	26691	0	16761005	30753		0
7029	412	40481087	1984-09-14	1984-09-14 00:00:00	1984-09-28	1984-09-28 00:00:00	32020		\N	27427	0	444814009	40481087		0
7243	426	40481087	1980-03-07	1980-03-07 00:00:00	1980-03-14	1980-03-14 00:00:00	32020		\N	28266	0	444814009	40481087		0
7360	432	4112343	1957-06-26	1957-06-26 00:00:00	1957-07-04	1957-07-04 00:00:00	32020		\N	28722	0	195662009	4112343		0
7535	443	375671	2005-01-23	2005-01-23 00:00:00	2005-02-22	2005-02-22 00:00:00	32020		\N	29429	0	62564004	375671		0
7704	452	260139	2017-02-21	2017-02-21 00:00:00	2017-02-28	2017-02-28 00:00:00	32020		\N	30107	0	10509002	260139		0
7869	459	80180	2008-07-12	2008-07-12 00:00:00	\N	\N	32020		\N	30702	0	396275006	80180		0
8047	471	4112343	2012-02-29	2012-02-29 00:00:00	2012-03-07	2012-03-07 00:00:00	32020		\N	31467	0	195662009	4112343		0
8213	480	4112343	2017-06-17	2017-06-17 00:00:00	2017-06-26	2017-06-26 00:00:00	32020		\N	32093	0	195662009	4112343		0
8366	487	4112343	2003-07-08	2003-07-08 00:00:00	2003-07-21	2003-07-21 00:00:00	32020		\N	32552	0	195662009	4112343		0
8546	499	4112343	2006-04-20	2006-04-20 00:00:00	2006-04-28	2006-04-28 00:00:00	32020		\N	33304	0	195662009	4112343		0
8723	510	257012	1988-09-20	1988-09-20 00:00:00	\N	\N	32020		\N	34075	0	40055000	257012		0
8881	520	81151	1951-11-04	1951-11-04 00:00:00	1951-11-18	1951-11-18 00:00:00	32020		\N	34748	0	44465007	81151		0
9031	528	40481087	1962-02-19	1962-02-19 00:00:00	1962-02-26	1962-02-26 00:00:00	32020		\N	35151	0	444814009	40481087		0
9229	546	30753	1980-11-29	1980-11-29 00:00:00	\N	\N	32020		\N	36200	0	16761005	30753		0
9355	552	40481087	1967-06-17	1967-06-17 00:00:00	1967-07-08	1967-07-08 00:00:00	32020		\N	36622	0	444814009	40481087		0
9533	565	40481087	1999-08-15	1999-08-15 00:00:00	1999-08-29	1999-08-29 00:00:00	32020		\N	37440	0	444814009	40481087		0
9685	573	40481087	1968-03-22	1968-03-22 00:00:00	1968-04-05	1968-04-05 00:00:00	32020		\N	37953	0	444814009	40481087		0
9855	582	40481087	2004-02-19	2004-02-19 00:00:00	2004-02-26	2004-02-26 00:00:00	32020		\N	38581	0	444814009	40481087		0
10078	597	260139	2003-09-08	2003-09-08 00:00:00	2003-09-22	2003-09-22 00:00:00	32020		\N	39473	0	10509002	260139		0
10196	603	260139	1973-05-10	1973-05-10 00:00:00	1973-05-24	1973-05-24 00:00:00	32020		\N	39956	0	10509002	260139		0
10350	610	40481087	2011-02-04	2011-02-04 00:00:00	2011-02-11	2011-02-11 00:00:00	32020		\N	40568	0	444814009	40481087		0
10550	621	381316	1995-11-29	1995-11-29 00:00:00	\N	\N	32020		\N	41422	0	230690007	381316		0
56	2	4112343	1999-12-01	1999-12-01 00:00:00	1999-12-08	1999-12-08 00:00:00	32020		\N	108	0	195662009	4112343		0
244	12	40481087	1990-11-10	1990-11-10 00:00:00	1990-11-24	1990-11-24 00:00:00	32020		\N	1042	0	444814009	40481087		0
422	23	80180	2012-05-11	2012-05-11 00:00:00	\N	\N	32020		\N	1804	0	396275006	80180		0
601	35	372328	1964-07-10	1964-07-10 00:00:00	1965-03-02	1965-03-02 00:00:00	32020		\N	2410	0	65363002	372328		0
741	41	81151	1990-01-18	1990-01-18 00:00:00	1990-02-22	1990-02-22 00:00:00	32020		\N	2891	0	44465007	81151		0
979	57	260139	1992-02-19	1992-02-19 00:00:00	1992-02-26	1992-02-26 00:00:00	32020		\N	3850	0	10509002	260139		0
1089	64	378001	2005-06-17	2005-06-17 00:00:00	2005-07-17	2005-07-17 00:00:00	32020		\N	4327	0	62106007	378001		0
1222	70	40481087	2005-02-23	2005-02-23 00:00:00	2005-03-09	2005-03-09 00:00:00	32020		\N	4765	0	444814009	40481087		0
1384	80	4112343	2003-09-14	2003-09-14 00:00:00	2003-09-21	2003-09-21 00:00:00	32020		\N	5412	0	195662009	4112343		0
1619	95	81151	2002-08-01	2002-08-01 00:00:00	2002-08-29	2002-08-29 00:00:00	32020		\N	6466	0	44465007	81151		0
1723	99	192671	2000-03-11	2000-03-11 00:00:00	\N	\N	32020		\N	6727	0	K92.2	35208414		0
1930	114	40481087	2014-05-31	2014-05-31 00:00:00	2014-06-14	2014-06-14 00:00:00	32020		\N	7518	0	444814009	40481087		0
2061	120	4146173	2004-01-12	2004-01-12 00:00:00	2004-03-12	2004-03-12 00:00:00	32020		\N	8007	0	307731004	4146173		0
2299	135	4112343	1973-07-07	1973-07-07 00:00:00	1973-07-15	1973-07-15 00:00:00	32020		\N	9080	0	195662009	4112343		0
2396	141	4294548	2018-09-11	2018-09-11 00:00:00	2019-01-15	2019-01-15 00:00:00	32020		\N	9462	0	75498004	4294548		0
2587	152	40481087	1989-12-05	1989-12-05 00:00:00	1989-12-12	1989-12-12 00:00:00	32020		\N	10230	0	444814009	40481087		0
2733	159	4112343	2007-03-17	2007-03-17 00:00:00	2007-03-25	2007-03-25 00:00:00	32020		\N	10863	0	195662009	4112343		0
2878	165	4035415	2013-04-15	2013-04-15 00:00:00	2013-06-14	2013-06-14 00:00:00	32020		\N	11329	0	239720000	4035415		0
3065	181	80180	2010-08-28	2010-08-28 00:00:00	\N	\N	32020		\N	12238	0	396275006	80180		0
3210	187	4112343	1951-12-22	1951-12-22 00:00:00	1951-12-29	1951-12-29 00:00:00	32020		\N	12693	0	195662009	4112343		0
3392	194	4112343	1998-06-01	1998-06-01 00:00:00	1998-06-12	1998-06-12 00:00:00	32020		\N	13302	0	195662009	4112343		0
3559	202	4218389	2015-10-18	2015-10-18 00:00:00	2015-11-15	2015-11-15 00:00:00	32020		\N	13909	0	39848009	4218389		0
3721	213	40481087	1983-09-29	1983-09-29 00:00:00	1983-10-06	1983-10-06 00:00:00	32020		\N	14499	0	444814009	40481087		0
3889	224	40481087	2013-08-22	2013-08-22 00:00:00	2013-08-29	2013-08-29 00:00:00	32020		\N	15023	0	444814009	40481087		0
4066	235	372328	1984-07-24	1984-07-24 00:00:00	1984-10-15	1984-10-15 00:00:00	32020		\N	15785	0	65363002	372328		0
4230	245	260139	2014-07-23	2014-07-23 00:00:00	2014-07-30	2014-07-30 00:00:00	32020		\N	16495	0	10509002	260139		0
4422	260	378001	1972-05-11	1972-05-11 00:00:00	1972-07-10	1972-07-10 00:00:00	32020		\N	17265	0	62106007	378001		0
4540	264	40481087	1970-08-10	1970-08-10 00:00:00	1970-08-24	1970-08-24 00:00:00	32020		\N	17513	0	444814009	40481087		0
4733	279	378001	2009-12-09	2009-12-09 00:00:00	2010-02-07	2010-02-07 00:00:00	32020		\N	18612	0	62106007	378001		0
4876	286	378001	1994-03-23	1994-03-23 00:00:00	1994-04-22	1994-04-22 00:00:00	32020		\N	19042	0	62106007	378001		0
5062	297	4218389	2011-04-08	2011-04-08 00:00:00	2011-05-13	2011-05-13 00:00:00	32020		\N	19840	0	39848009	4218389		0
5215	307	81151	1981-08-17	1981-08-17 00:00:00	1981-09-14	1981-09-14 00:00:00	32020		\N	20379	0	44465007	81151		0
5406	318	260139	1974-03-07	1974-03-07 00:00:00	1974-03-21	1974-03-21 00:00:00	32020		\N	21057	0	10509002	260139		0
5586	331	40481087	1944-08-19	1944-08-19 00:00:00	1944-09-02	1944-09-02 00:00:00	32020		\N	21856	0	444814009	40481087		0
5711	335	260139	2005-12-15	2005-12-15 00:00:00	2005-12-22	2005-12-22 00:00:00	32020		\N	22280	0	10509002	260139		0
5892	347	258780	1996-11-03	1996-11-03 00:00:00	\N	\N	32020		\N	23107	0	185086009	258780		0
6039	354	4294548	2013-08-18	2013-08-18 00:00:00	2013-08-25	2013-08-25 00:00:00	32020		\N	23522	0	75498004	4294548		0
6199	364	260139	2014-09-05	2014-09-05 00:00:00	2014-09-12	2014-09-12 00:00:00	32020		\N	24134	0	10509002	260139		0
6365	374	192671	2015-09-06	2015-09-06 00:00:00	\N	\N	32020		\N	24837	0	K92.2	35208414		0
6584	388	257012	1955-10-19	1955-10-19 00:00:00	\N	\N	32020		\N	25577	0	40055000	257012		0
6698	395	4112343	1975-02-14	1975-02-14 00:00:00	1975-02-27	1975-02-27 00:00:00	32020		\N	25948	0	195662009	4112343		0
6871	404	40481087	2016-05-01	2016-05-01 00:00:00	2016-05-15	2016-05-15 00:00:00	32020		\N	26611	0	444814009	40481087		0
7030	412	4112343	1999-11-20	1999-11-20 00:00:00	1999-12-03	1999-12-03 00:00:00	32020		\N	27465	0	195662009	4112343		0
7244	426	40481087	1988-08-20	1988-08-20 00:00:00	1988-08-27	1988-08-27 00:00:00	32020		\N	28268	0	444814009	40481087		0
7361	432	192671	1973-01-24	1973-01-24 00:00:00	\N	\N	32020		\N	28717	0	K92.2	35208414		0
7536	443	378001	2015-06-15	2015-06-15 00:00:00	2015-08-14	2015-08-14 00:00:00	32020		\N	29433	0	62106007	378001		0
7705	452	260139	1976-03-28	1976-03-28 00:00:00	1976-04-04	1976-04-04 00:00:00	32020		\N	30136	0	10509002	260139		0
7870	459	81151	1987-12-05	1987-12-05 00:00:00	1988-01-02	1988-01-02 00:00:00	32020		\N	30713	0	44465007	81151		0
8048	471	257012	1995-08-19	1995-08-19 00:00:00	\N	\N	32020		\N	31466	0	40055000	257012		0
8214	480	4218389	1943-10-15	1943-10-15 00:00:00	1943-11-05	1943-11-05 00:00:00	32020		\N	31964	0	39848009	4218389		0
8367	487	40481087	1989-10-18	1989-10-18 00:00:00	1989-11-01	1989-11-01 00:00:00	32020		\N	32569	0	444814009	40481087		0
8547	499	260139	1976-06-19	1976-06-19 00:00:00	1976-07-03	1976-07-03 00:00:00	32020		\N	33456	0	10509002	260139		0
8724	510	40481087	1988-03-06	1988-03-06 00:00:00	1988-03-13	1988-03-13 00:00:00	32020		\N	34111	0	444814009	40481087		0
8882	520	81151	1997-02-25	1997-02-25 00:00:00	1997-03-11	1997-03-11 00:00:00	32020		\N	34746	0	44465007	81151		0
9032	528	378001	1976-12-25	1976-12-25 00:00:00	1977-01-24	1977-01-24 00:00:00	32020		\N	35210	0	62106007	378001		0
9230	546	81893	1980-07-02	1980-07-02 00:00:00	\N	\N	32020		\N	36200	0	64766004	81893		0
9356	552	40481087	1951-12-23	1951-12-23 00:00:00	1952-01-13	1952-01-13 00:00:00	32020		\N	36563	0	444814009	40481087		0
9534	565	372328	1958-10-31	1958-10-31 00:00:00	1958-12-31	1958-12-31 00:00:00	32020		\N	37441	0	65363002	372328		0
9686	573	260139	1992-07-07	1992-07-07 00:00:00	1992-07-14	1992-07-14 00:00:00	32020		\N	37999	0	10509002	260139		0
9856	582	260139	1996-10-02	1996-10-02 00:00:00	1996-10-09	1996-10-09 00:00:00	32020		\N	38579	0	10509002	260139		0
10079	597	80180	1987-01-17	1987-01-17 00:00:00	\N	\N	32020		\N	39396	0	396275006	80180		0
10197	603	40481087	1986-05-13	1986-05-13 00:00:00	1986-06-03	1986-06-03 00:00:00	32020		\N	39908	0	444814009	40481087		0
10351	610	4152936	1965-06-29	1965-06-29 00:00:00	1965-07-13	1965-07-13 00:00:00	32020		\N	40476	0	283385000	4152936		0
10551	621	40481087	2017-11-24	2017-11-24 00:00:00	2017-12-08	2017-12-08 00:00:00	32020		\N	41438	0	444814009	40481087		0
57	2	260139	1996-10-01	1996-10-01 00:00:00	1996-10-08	1996-10-08 00:00:00	32020		\N	209	0	10509002	260139		0
245	12	260139	1974-08-01	1974-08-01 00:00:00	1974-08-08	1974-08-08 00:00:00	32020		\N	1029	0	10509002	260139		0
423	23	4266809	2012-05-11	2012-05-11 00:00:00	\N	\N	32020		\N	1804	0	397881000	4266809		0
602	35	372328	1960-06-20	1960-06-20 00:00:00	1960-08-30	1960-08-30 00:00:00	32020		\N	2409	0	65363002	372328		0
742	41	4283893	1999-12-02	1999-12-02 00:00:00	2000-03-02	2000-03-02 00:00:00	32020		\N	2941	0	36971009	4283893		0
980	57	40481087	1970-12-07	1970-12-07 00:00:00	1970-12-14	1970-12-14 00:00:00	32020		\N	3844	0	444814009	40481087		0
1090	64	372328	1976-06-14	1976-06-14 00:00:00	1976-09-29	1976-09-29 00:00:00	32020		\N	4324	0	65363002	372328		0
1223	70	40481087	1949-06-14	1949-06-14 00:00:00	1949-06-28	1949-06-28 00:00:00	32020		\N	4714	0	444814009	40481087		0
1385	80	81151	1953-12-31	1953-12-31 00:00:00	1954-01-14	1954-01-14 00:00:00	32020		\N	5433	0	44465007	81151		0
1620	95	372328	1962-04-05	1962-04-05 00:00:00	1962-08-09	1962-08-09 00:00:00	32020		\N	6400	0	65363002	372328		0
1724	99	4278672	2011-09-11	2011-09-11 00:00:00	2011-10-11	2011-10-11 00:00:00	32020		\N	6732	0	65966004	4278672		0
1931	114	28060	1976-01-17	1976-01-17 00:00:00	1976-01-28	1976-01-28 00:00:00	32020		\N	7530	0	43878008	28060		0
2062	120	260139	2000-11-08	2000-11-08 00:00:00	2000-11-22	2000-11-22 00:00:00	32020		\N	8006	0	10509002	260139		0
2300	135	260139	2000-11-10	2000-11-10 00:00:00	2000-11-24	2000-11-24 00:00:00	32020		\N	9033	0	10509002	260139		0
2397	141	372328	1987-10-31	1987-10-31 00:00:00	1988-09-27	1988-09-27 00:00:00	32020		\N	9443	0	65363002	372328		0
2588	152	40481087	1976-10-11	1976-10-11 00:00:00	1976-10-25	1976-10-25 00:00:00	32020		\N	10242	0	444814009	40481087		0
2734	159	260139	1997-08-18	1997-08-18 00:00:00	1997-08-25	1997-08-25 00:00:00	32020		\N	10859	0	10509002	260139		0
2879	165	40481087	2018-09-01	2018-09-01 00:00:00	2018-09-22	2018-09-22 00:00:00	32020		\N	11355	0	444814009	40481087		0
3066	181	372328	1975-02-08	1975-02-08 00:00:00	1975-02-22	1975-02-22 00:00:00	32020		\N	12246	0	65363002	372328		0
3211	187	40481087	1959-08-06	1959-08-06 00:00:00	1959-08-13	1959-08-13 00:00:00	32020		\N	12695	0	444814009	40481087		0
3393	194	40481087	2008-03-17	2008-03-17 00:00:00	2008-03-24	2008-03-24 00:00:00	32020		\N	13330	0	444814009	40481087		0
3560	202	4112343	1980-07-03	1980-07-03 00:00:00	1980-07-16	1980-07-16 00:00:00	32020		\N	13848	0	195662009	4112343		0
3722	213	4310024	2001-08-20	2001-08-20 00:00:00	\N	\N	32020		\N	14519	0	424802006	4310024		0
3890	224	40481087	1972-07-24	1972-07-24 00:00:00	1972-08-14	1972-08-14 00:00:00	32020		\N	15045	0	444814009	40481087		0
4067	235	260139	2000-05-02	2000-05-02 00:00:00	2000-05-09	2000-05-09 00:00:00	32020		\N	15783	0	10509002	260139		0
4231	245	260139	2012-11-23	2012-11-23 00:00:00	2012-11-30	2012-11-30 00:00:00	32020		\N	16456	0	10509002	260139		0
4423	260	260139	1979-09-06	1979-09-06 00:00:00	1979-09-13	1979-09-13 00:00:00	32020		\N	17156	0	10509002	260139		0
4548	266	372328	1971-09-17	1971-09-17 00:00:00	1972-04-17	1972-04-17 00:00:00	32020		\N	17737	0	65363002	372328		0
4734	279	260139	1967-03-18	1967-03-18 00:00:00	1967-04-01	1967-04-01 00:00:00	32020		\N	18616	0	10509002	260139		0
4877	286	260139	1973-07-19	1973-07-19 00:00:00	1973-07-26	1973-07-26 00:00:00	32020		\N	19119	0	10509002	260139		0
5063	298	40481087	2007-05-12	2007-05-12 00:00:00	2007-05-19	2007-05-19 00:00:00	32020		\N	19872	0	444814009	40481087		0
5216	307	4112343	1969-09-20	1969-09-20 00:00:00	1969-09-29	1969-09-29 00:00:00	32020		\N	20367	0	195662009	4112343		0
5407	318	80502	2013-09-02	2013-09-02 00:00:00	\N	\N	32020		\N	21064	0	64859006	80502		0
5587	331	40481087	1951-04-08	1951-04-08 00:00:00	1951-04-29	1951-04-29 00:00:00	32020		\N	21858	0	444814009	40481087		0
5712	335	80180	2003-04-29	2003-04-29 00:00:00	\N	\N	32020		\N	22253	0	396275006	80180		0
5893	347	260139	1975-08-21	1975-08-21 00:00:00	1975-09-04	1975-09-04 00:00:00	32020		\N	23064	0	10509002	260139		0
6040	354	195588	1980-12-29	1980-12-29 00:00:00	1981-02-03	1981-02-03 00:00:00	32020		\N	23514	0	38822007	195588		0
6200	364	4134304	2018-07-05	2018-07-05 00:00:00	2018-08-04	2018-08-04 00:00:00	32020		\N	24213	0	263102004	4134304		0
6366	374	28060	2015-10-17	2015-10-17 00:00:00	2015-10-27	2015-10-27 00:00:00	32020		\N	24843	0	43878008	28060		0
6585	388	4112343	1968-12-31	1968-12-31 00:00:00	1969-01-12	1969-01-12 00:00:00	32020		\N	25553	0	195662009	4112343		0
6699	395	4112343	1989-01-16	1989-01-16 00:00:00	1989-01-29	1989-01-29 00:00:00	32020		\N	25988	0	195662009	4112343		0
6872	404	81151	1983-01-20	1983-01-20 00:00:00	1983-02-03	1983-02-03 00:00:00	32020		\N	26662	0	44465007	81151		0
7031	412	40481087	1992-01-15	1992-01-15 00:00:00	1992-01-22	1992-01-22 00:00:00	32020		\N	27451	0	444814009	40481087		0
7245	426	40481087	2017-09-18	2017-09-18 00:00:00	2017-10-09	2017-10-09 00:00:00	32020		\N	28278	0	444814009	40481087		0
7362	432	40481087	2018-06-24	2018-06-24 00:00:00	2018-07-08	2018-07-08 00:00:00	32020		\N	28670	0	444814009	40481087		0
7537	443	4278672	2013-05-26	2013-05-26 00:00:00	2013-06-25	2013-06-25 00:00:00	32020		\N	29432	0	65966004	4278672		0
7706	452	28060	2003-08-28	2003-08-28 00:00:00	2003-09-06	2003-09-06 00:00:00	32020		\N	30105	0	43878008	28060		0
7871	459	40481087	2012-10-25	2012-10-25 00:00:00	2012-11-01	2012-11-01 00:00:00	32020		\N	30681	0	444814009	40481087		0
8049	471	321042	1990-04-06	1990-04-06 00:00:00	\N	\N	32020		\N	31462	0	410429000	321042		0
8215	480	40481087	1958-01-30	1958-01-30 00:00:00	1958-02-13	1958-02-13 00:00:00	32020		\N	32021	0	444814009	40481087		0
8368	487	81151	2015-02-24	2015-02-24 00:00:00	2015-03-10	2015-03-10 00:00:00	32020		\N	32530	0	44465007	81151		0
8548	499	40481087	1960-10-22	1960-10-22 00:00:00	1960-10-29	1960-10-29 00:00:00	32020		\N	33411	0	444814009	40481087		0
8725	510	375671	1966-08-28	1966-08-28 00:00:00	1966-09-27	1966-09-27 00:00:00	32020		\N	34079	0	62564004	375671		0
8883	520	4109685	2001-12-15	2001-12-15 00:00:00	2001-12-29	2001-12-29 00:00:00	32020		\N	34747	0	284551006	4109685		0
9033	528	40481087	1975-03-07	1975-03-07 00:00:00	1975-03-14	1975-03-14 00:00:00	32020		\N	35222	0	444814009	40481087		0
9231	546	260139	1990-04-22	1990-04-22 00:00:00	1990-04-29	1990-04-29 00:00:00	32020		\N	36243	0	10509002	260139		0
9357	552	40481087	2015-08-31	2015-08-31 00:00:00	2015-09-07	2015-09-07 00:00:00	32020		\N	36647	0	444814009	40481087		0
9535	565	40481087	1993-03-10	1993-03-10 00:00:00	1993-03-17	1993-03-17 00:00:00	32020		\N	37451	0	444814009	40481087		0
9687	573	40481087	2015-11-27	2015-11-27 00:00:00	2015-12-04	2015-12-04 00:00:00	32020		\N	37975	0	444814009	40481087		0
9857	582	4112343	1978-08-03	1978-08-03 00:00:00	1978-08-10	1978-08-10 00:00:00	32020		\N	38578	0	195662009	4112343		0
10080	597	260139	1977-07-02	1977-07-02 00:00:00	1977-07-16	1977-07-16 00:00:00	32020		\N	39418	0	10509002	260139		0
10198	603	4112343	1962-04-25	1962-04-25 00:00:00	1962-05-07	1962-05-07 00:00:00	32020		\N	39935	0	195662009	4112343		0
10352	610	40481087	1968-10-02	1968-10-02 00:00:00	1968-10-16	1968-10-16 00:00:00	32020		\N	40577	0	444814009	40481087		0
10552	621	4112343	1939-11-17	1939-11-17 00:00:00	1939-11-26	1939-11-26 00:00:00	32020		\N	41470	0	195662009	4112343		0
58	2	4296204	1974-03-04	1974-03-04 00:00:00	1974-03-25	1974-03-25 00:00:00	32020		\N	114	0	403190006	4296204		0
246	12	4310024	2006-06-18	2006-06-18 00:00:00	\N	\N	32020		\N	1049	0	424802006	4310024		0
424	23	372328	2016-01-21	2016-01-21 00:00:00	2018-09-13	2018-09-13 00:00:00	32020		\N	1805	0	65363002	372328		0
603	35	4283893	1989-03-09	1989-03-09 00:00:00	1989-05-25	1989-05-25 00:00:00	32020		\N	2399	0	36971009	4283893		0
743	41	4051466	1975-06-02	1975-06-02 00:00:00	1992-08-31	1992-08-31 00:00:00	32020		\N	2934	0	233678006	4051466		0
981	57	4156265	1976-08-13	1976-08-13 00:00:00	1976-09-03	1976-09-03 00:00:00	32020		\N	3820	0	370247008	4156265		0
1091	64	40481087	1980-02-22	1980-02-22 00:00:00	1980-03-07	1980-03-07 00:00:00	32020		\N	4331	0	444814009	40481087		0
1224	70	260139	1962-07-17	1962-07-17 00:00:00	1962-07-31	1962-07-31 00:00:00	32020		\N	4716	0	10509002	260139		0
1386	80	40481087	1945-03-19	1945-03-19 00:00:00	1945-04-02	1945-04-02 00:00:00	32020		\N	5397	0	444814009	40481087		0
1621	95	4113008	1968-12-29	1968-12-29 00:00:00	1969-01-12	1969-01-12 00:00:00	32020		\N	6463	0	284549007	4113008		0
1725	99	4237458	2015-09-20	2015-09-20 00:00:00	2015-12-19	2015-12-19 00:00:00	32020		\N	6733	0	58150001	4237458		0
1932	114	40481087	2018-08-29	2018-08-29 00:00:00	2018-09-19	2018-09-19 00:00:00	32020		\N	7507	0	444814009	40481087		0
2063	120	4112343	1988-04-28	1988-04-28 00:00:00	1988-05-08	1988-05-08 00:00:00	32020		\N	7974	0	195662009	4112343		0
2301	135	40481087	2018-11-13	2018-11-13 00:00:00	2018-11-27	2018-11-27 00:00:00	32020		\N	9040	0	444814009	40481087		0
2398	141	40481087	2012-05-18	2012-05-18 00:00:00	2012-06-01	2012-06-01 00:00:00	32020		\N	9440	0	444814009	40481087		0
2589	152	28060	2017-01-26	2017-01-26 00:00:00	2017-02-05	2017-02-05 00:00:00	32020		\N	10270	0	43878008	28060		0
2735	159	372328	1955-08-12	1955-08-12 00:00:00	1955-12-27	1955-12-27 00:00:00	32020		\N	10860	0	65363002	372328		0
2880	165	260139	1983-05-26	1983-05-26 00:00:00	1983-06-09	1983-06-09 00:00:00	32020		\N	11371	0	10509002	260139		0
3067	181	4112343	2006-10-08	2006-10-08 00:00:00	2006-10-18	2006-10-18 00:00:00	32020		\N	12205	0	195662009	4112343		0
3212	187	4112343	2000-10-27	2000-10-27 00:00:00	2000-11-08	2000-11-08 00:00:00	32020		\N	12704	0	195662009	4112343		0
3394	194	4112343	1990-01-07	1990-01-07 00:00:00	1990-01-19	1990-01-19 00:00:00	32020		\N	13339	0	195662009	4112343		0
3561	202	40481087	1965-05-27	1965-05-27 00:00:00	1965-06-10	1965-06-10 00:00:00	32020		\N	13809	0	444814009	40481087		0
3723	213	372328	1970-11-11	1970-11-11 00:00:00	1971-04-05	1971-04-05 00:00:00	32020		\N	14513	0	65363002	372328		0
3891	224	4142905	2010-06-19	2010-06-19 00:00:00	2010-07-19	2010-07-19 00:00:00	32020		\N	15111	0	33737001	4142905		0
4068	235	4296204	1984-06-24	1984-06-24 00:00:00	1984-07-29	1984-07-29 00:00:00	32020		\N	15756	0	403190006	4296204		0
4232	245	40481087	1969-01-29	1969-01-29 00:00:00	1969-02-05	1969-02-05 00:00:00	32020		\N	16484	0	444814009	40481087		0
4424	260	4112343	1992-02-08	1992-02-08 00:00:00	1992-02-19	1992-02-19 00:00:00	32020		\N	17255	0	195662009	4112343		0
4549	266	4084167	1984-12-25	1984-12-25 00:00:00	1984-12-25	1984-12-25 00:00:00	32020		\N	17691	0	241929008	4084167		0
4735	279	372328	1952-08-26	1952-08-26 00:00:00	1952-11-07	1952-11-07 00:00:00	32020		\N	18625	0	65363002	372328		0
4878	286	372328	1929-06-26	1929-06-26 00:00:00	1929-07-27	1929-07-27 00:00:00	32020		\N	19072	0	65363002	372328		0
5064	298	4112343	2018-09-02	2018-09-02 00:00:00	2018-09-14	2018-09-14 00:00:00	32020		\N	19887	0	195662009	4112343		0
5217	308	4296204	1976-01-21	1976-01-21 00:00:00	1976-02-11	1976-02-11 00:00:00	32020		\N	20400	0	403190006	4296204		0
5408	318	4112343	1973-10-03	1973-10-03 00:00:00	1973-10-10	1973-10-10 00:00:00	32020		\N	21094	0	195662009	4112343		0
5588	331	40481087	1965-09-26	1965-09-26 00:00:00	1965-10-10	1965-10-10 00:00:00	32020		\N	21859	0	444814009	40481087		0
5713	335	260139	1978-04-23	1978-04-23 00:00:00	1978-04-30	1978-04-30 00:00:00	32020		\N	22278	0	10509002	260139		0
5894	347	4112343	2002-11-22	2002-11-22 00:00:00	2002-12-03	2002-12-03 00:00:00	32020		\N	23100	0	195662009	4112343		0
6041	354	40481087	2014-01-30	2014-01-30 00:00:00	2014-02-20	2014-02-20 00:00:00	32020		\N	23533	0	444814009	40481087		0
6201	364	260139	1948-01-20	1948-01-20 00:00:00	1948-02-03	1948-02-03 00:00:00	32020		\N	24214	0	10509002	260139		0
6367	374	260139	1986-04-06	1986-04-06 00:00:00	1986-04-20	1986-04-20 00:00:00	32020		\N	24812	0	10509002	260139		0
6586	388	40481087	1960-11-27	1960-11-27 00:00:00	1960-12-04	1960-12-04 00:00:00	32020		\N	25565	0	444814009	40481087		0
6700	395	372328	1961-11-07	1961-11-07 00:00:00	1962-01-23	1962-01-23 00:00:00	32020		\N	25991	0	65363002	372328		0
6873	404	260139	2007-01-21	2007-01-21 00:00:00	2007-01-28	2007-01-28 00:00:00	32020		\N	26593	0	10509002	260139		0
7032	412	80180	1993-09-22	1993-09-22 00:00:00	\N	\N	32020		\N	27451	0	396275006	80180		0
7246	426	372328	1966-02-12	1966-02-12 00:00:00	1966-04-21	1966-04-21 00:00:00	32020		\N	28279	0	65363002	372328		0
7363	432	40481087	1957-08-01	1957-08-01 00:00:00	1957-08-15	1957-08-15 00:00:00	32020		\N	28752	0	444814009	40481087		0
7538	443	40481087	1981-12-17	1981-12-17 00:00:00	1982-01-07	1982-01-07 00:00:00	32020		\N	29484	0	444814009	40481087		0
7707	452	4112343	2019-04-17	2019-04-17 00:00:00	2019-04-27	2019-04-27 00:00:00	32020		\N	30128	0	195662009	4112343		0
7872	459	81893	2007-07-18	2007-07-18 00:00:00	\N	\N	32020		\N	30701	0	64766004	81893		0
8051	471	4113008	2017-09-10	2017-09-10 00:00:00	2017-10-01	2017-10-01 00:00:00	32020		\N	31464	0	284549007	4113008		0
8216	480	40481087	1950-05-01	1950-05-01 00:00:00	1950-05-15	1950-05-15 00:00:00	32020		\N	32085	0	444814009	40481087		0
8369	487	4112343	1984-09-20	1984-09-20 00:00:00	1984-09-30	1984-09-30 00:00:00	32020		\N	32541	0	195662009	4112343		0
8549	499	260139	1997-03-17	1997-03-17 00:00:00	1997-03-31	1997-03-31 00:00:00	32020		\N	33336	0	10509002	260139		0
8726	510	372328	1966-08-28	1966-08-28 00:00:00	1966-12-10	1966-12-10 00:00:00	32020		\N	34116	0	65363002	372328		0
8884	520	40481087	1997-07-21	1997-07-21 00:00:00	1997-08-11	1997-08-11 00:00:00	32020		\N	34730	0	444814009	40481087		0
9034	528	40481087	2016-07-08	2016-07-08 00:00:00	2016-07-29	2016-07-29 00:00:00	32020		\N	35209	0	444814009	40481087		0
9232	546	28060	1986-03-11	1986-03-11 00:00:00	1986-03-24	1986-03-24 00:00:00	32020		\N	36178	0	43878008	28060		0
9358	552	40481087	2013-04-15	2013-04-15 00:00:00	2013-05-06	2013-05-06 00:00:00	32020		\N	36585	0	444814009	40481087		0
9536	565	260139	1962-10-07	1962-10-07 00:00:00	1962-10-21	1962-10-21 00:00:00	32020		\N	37434	0	10509002	260139		0
9688	573	4112343	1998-10-28	1998-10-28 00:00:00	1998-11-06	1998-11-06 00:00:00	32020		\N	38001	0	195662009	4112343		0
9858	582	81151	1965-11-27	1965-11-27 00:00:00	1966-01-01	1966-01-01 00:00:00	32020		\N	38554	0	44465007	81151		0
10081	598	4266809	2009-10-26	2009-10-26 00:00:00	\N	\N	32020		\N	39500	0	397881000	4266809		0
10199	603	4296204	2008-04-03	2008-04-03 00:00:00	2008-05-08	2008-05-08 00:00:00	32020		\N	39932	0	403190006	4296204		0
10353	610	4112343	1972-11-19	1972-11-19 00:00:00	1972-11-26	1972-11-26 00:00:00	32020		\N	40528	0	195662009	4112343		0
10553	621	78272	1922-12-27	1922-12-27 00:00:00	1923-01-24	1923-01-24 00:00:00	32020		\N	41486	0	70704007	78272		0
59	2	4142905	1993-03-29	1993-03-29 00:00:00	1993-05-28	1993-05-28 00:00:00	32020		\N	117	0	33737001	4142905		0
247	12	4285898	2007-05-14	2007-05-14 00:00:00	\N	\N	32020		\N	1049	0	68496003	4285898		0
425	23	4155034	1986-04-28	1986-04-28 00:00:00	1986-05-19	1986-05-19 00:00:00	32020		\N	1774	0	283371005	4155034		0
604	35	4283893	1995-08-11	1995-08-11 00:00:00	1995-09-15	1995-09-15 00:00:00	32020		\N	2433	0	36971009	4283893		0
744	41	4112343	1999-09-18	1999-09-18 00:00:00	1999-09-30	1999-09-30 00:00:00	32020		\N	2990	0	195662009	4112343		0
982	57	80180	1997-04-01	1997-04-01 00:00:00	\N	\N	32020		\N	3838	0	396275006	80180		0
1092	64	4294548	2017-05-21	2017-05-21 00:00:00	2017-06-11	2017-06-11 00:00:00	32020		\N	4323	0	75498004	4294548		0
1225	70	257012	1998-07-11	1998-07-11 00:00:00	\N	\N	32020		\N	4773	0	40055000	257012		0
1387	80	40481087	2010-03-20	2010-03-20 00:00:00	2010-04-10	2010-04-10 00:00:00	32020		\N	5383	0	444814009	40481087		0
1622	95	4278672	1969-12-08	1969-12-08 00:00:00	1970-03-08	1970-03-08 00:00:00	32020		\N	6464	0	65966004	4278672		0
1726	99	80180	2000-01-03	2000-01-03 00:00:00	\N	\N	32020		\N	6747	0	396275006	80180		0
1933	114	260139	2018-08-24	2018-08-24 00:00:00	2018-09-07	2018-09-07 00:00:00	32020		\N	7519	0	10509002	260139		0
2064	120	4237458	1992-11-10	1992-11-10 00:00:00	1993-02-08	1993-02-08 00:00:00	32020		\N	7970	0	58150001	4237458		0
2302	135	81151	1980-01-29	1980-01-29 00:00:00	1980-02-26	1980-02-26 00:00:00	32020		\N	9019	0	44465007	81151		0
2399	141	40481087	2013-04-17	2013-04-17 00:00:00	2013-05-01	2013-05-01 00:00:00	32020		\N	9460	0	444814009	40481087		0
2590	152	4116491	2010-10-20	2010-10-20 00:00:00	2010-11-20	2010-11-20 00:00:00	32020		\N	10253	0	301011002	4116491		0
2736	159	40481087	1980-03-08	1980-03-08 00:00:00	1980-03-29	1980-03-29 00:00:00	32020		\N	10857	0	444814009	40481087		0
2881	165	4152936	1974-02-11	1974-02-11 00:00:00	1974-02-25	1974-02-25 00:00:00	32020		\N	11327	0	283385000	4152936		0
3068	181	4112343	1994-07-01	1994-07-01 00:00:00	1994-07-09	1994-07-09 00:00:00	32020		\N	12204	0	195662009	4112343		0
3213	187	4027663	1977-07-15	1977-07-15 00:00:00	\N	\N	32020		\N	12702	0	13200003	4027663		0
3395	194	80180	2015-01-31	2015-01-31 00:00:00	\N	\N	32020		\N	13317	0	396275006	80180		0
3562	202	4294548	1962-09-27	1962-09-27 00:00:00	1963-01-03	1963-01-03 00:00:00	32020		\N	13895	0	75498004	4294548		0
3724	213	4152936	2015-11-04	2015-11-04 00:00:00	2015-11-25	2015-11-25 00:00:00	32020		\N	14497	0	283385000	4152936		0
3892	224	40481087	1944-09-28	1944-09-28 00:00:00	1944-10-12	1944-10-12 00:00:00	32020		\N	15083	0	444814009	40481087		0
4069	236	28060	1981-11-22	1981-11-22 00:00:00	1981-12-04	1981-12-04 00:00:00	32020		\N	15925	0	43878008	28060		0
4233	245	4283893	1922-06-23	1922-06-23 00:00:00	1922-07-14	1922-07-14 00:00:00	32020		\N	16421	0	36971009	4283893		0
4425	260	4059173	2015-04-08	2015-04-08 00:00:00	2015-07-07	2015-07-07 00:00:00	32020		\N	17175	0	16114001	4059173		0
4550	266	4237458	1967-05-27	1967-05-27 00:00:00	1967-07-26	1967-07-26 00:00:00	32020		\N	17638	0	58150001	4237458		0
4736	279	260139	1998-04-05	1998-04-05 00:00:00	1998-04-19	1998-04-19 00:00:00	32020		\N	18594	0	10509002	260139		0
4879	286	4296204	1993-01-22	1993-01-22 00:00:00	1993-02-26	1993-02-26 00:00:00	32020		\N	19041	0	403190006	4296204		0
5065	298	40481087	2010-11-07	2010-11-07 00:00:00	2010-11-28	2010-11-28 00:00:00	32020		\N	19921	0	444814009	40481087		0
5218	308	260139	1963-01-11	1963-01-11 00:00:00	1963-01-18	1963-01-18 00:00:00	32020		\N	20421	0	10509002	260139		0
5409	318	4112343	1960-06-27	1960-06-27 00:00:00	1960-07-09	1960-07-09 00:00:00	32020		\N	21092	0	195662009	4112343		0
5589	331	4112343	2001-02-28	2001-02-28 00:00:00	2001-03-07	2001-03-07 00:00:00	32020		\N	21862	0	195662009	4112343		0
5714	335	40481087	2006-11-03	2006-11-03 00:00:00	2006-11-17	2006-11-17 00:00:00	32020		\N	22272	0	444814009	40481087		0
5895	347	80180	2011-12-28	2011-12-28 00:00:00	\N	\N	32020		\N	23111	0	396275006	80180		0
6049	357	40481087	1961-10-03	1961-10-03 00:00:00	1961-10-10	1961-10-10 00:00:00	32020		\N	23642	0	444814009	40481087		0
6202	364	4109685	1991-08-21	1991-08-21 00:00:00	1991-09-04	1991-09-04 00:00:00	32020		\N	24211	0	284551006	4109685		0
6368	374	81151	1993-11-24	1993-11-24 00:00:00	1993-12-29	1993-12-29 00:00:00	32020		\N	24847	0	44465007	81151		0
6587	388	40481087	1981-06-07	1981-06-07 00:00:00	1981-06-28	1981-06-28 00:00:00	32020		\N	25568	0	444814009	40481087		0
6701	395	4109685	1964-12-21	1964-12-21 00:00:00	1965-01-11	1965-01-11 00:00:00	32020		\N	25937	0	284551006	4109685		0
6874	404	260139	1965-03-22	1965-03-22 00:00:00	1965-04-05	1965-04-05 00:00:00	32020		\N	26576	0	10509002	260139		0
7033	412	4285898	1993-07-24	1993-07-24 00:00:00	\N	\N	32020		\N	27451	0	68496003	4285898		0
7248	426	260139	1988-01-08	1988-01-08 00:00:00	1988-01-15	1988-01-15 00:00:00	32020		\N	28267	0	10509002	260139		0
7364	432	40481087	1931-06-04	1931-06-04 00:00:00	1931-06-25	1931-06-25 00:00:00	32020		\N	28745	0	444814009	40481087		0
7539	443	40481087	2017-04-02	2017-04-02 00:00:00	2017-04-23	2017-04-23 00:00:00	32020		\N	29436	0	444814009	40481087		0
7708	452	40481087	1970-09-21	1970-09-21 00:00:00	1970-10-05	1970-10-05 00:00:00	32020		\N	30135	0	444814009	40481087		0
7873	459	4310024	2006-11-20	2006-11-20 00:00:00	\N	\N	32020		\N	30701	0	424802006	4310024		0
8052	471	260139	1997-10-28	1997-10-28 00:00:00	1997-11-11	1997-11-11 00:00:00	32020		\N	31481	0	10509002	260139		0
8217	480	260139	1994-11-07	1994-11-07 00:00:00	1994-11-14	1994-11-14 00:00:00	32020		\N	32027	0	10509002	260139		0
8370	487	372328	1969-03-29	1969-03-29 00:00:00	1969-04-23	1969-04-23 00:00:00	32020		\N	32601	0	65363002	372328		0
8550	499	4051466	1962-04-30	1962-04-30 00:00:00	1978-08-07	1978-08-07 00:00:00	32020		\N	33344	0	233678006	4051466		0
8727	510	4218389	1984-12-23	1984-12-23 00:00:00	1985-01-20	1985-01-20 00:00:00	32020		\N	34082	0	39848009	4218389		0
8885	520	4113008	1969-04-29	1969-04-29 00:00:00	1969-05-20	1969-05-20 00:00:00	32020		\N	34742	0	284549007	4113008		0
9035	528	40481087	1963-01-30	1963-01-30 00:00:00	1963-02-13	1963-02-13 00:00:00	32020		\N	35206	0	444814009	40481087		0
9233	546	4112343	2011-03-15	2011-03-15 00:00:00	2011-03-28	2011-03-28 00:00:00	32020		\N	36157	0	195662009	4112343		0
9359	552	78272	1966-01-02	1966-01-02 00:00:00	1966-01-23	1966-01-23 00:00:00	32020		\N	36612	0	70704007	78272		0
9537	565	372328	1958-07-19	1958-07-19 00:00:00	1958-10-01	1958-10-01 00:00:00	32020		\N	37419	0	65363002	372328		0
9689	573	4112343	2008-08-28	2008-08-28 00:00:00	2008-09-08	2008-09-08 00:00:00	32020		\N	37957	0	195662009	4112343		0
9859	582	372328	1959-07-02	1959-07-02 00:00:00	1959-08-12	1959-08-12 00:00:00	32020		\N	38592	0	65363002	372328		0
10082	598	80180	2009-10-26	2009-10-26 00:00:00	\N	\N	32020		\N	39500	0	396275006	80180		0
10200	603	28060	1960-11-17	1960-11-17 00:00:00	1960-11-30	1960-11-30 00:00:00	32020		\N	39934	0	43878008	28060		0
10354	610	4048171	1967-09-05	1967-09-05 00:00:00	1981-09-03	1981-09-03 00:00:00	32020		\N	40509	0	232353008	4048171		0
10554	621	40481087	2002-02-04	2002-02-04 00:00:00	2002-02-11	2002-02-11 00:00:00	32020		\N	41366	0	444814009	40481087		0
60	2	260139	1994-06-05	1994-06-05 00:00:00	1994-06-19	1994-06-19 00:00:00	32020		\N	106	0	10509002	260139		0
248	12	40481087	1996-03-24	1996-03-24 00:00:00	1996-04-14	1996-04-14 00:00:00	32020		\N	1003	0	444814009	40481087		0
426	23	4113008	1988-05-08	1988-05-08 00:00:00	1988-05-22	1988-05-22 00:00:00	32020		\N	1775	0	284549007	4113008		0
605	35	4112343	2002-04-14	2002-04-14 00:00:00	2002-04-21	2002-04-21 00:00:00	32020		\N	2448	0	195662009	4112343		0
745	41	40481087	1984-10-06	1984-10-06 00:00:00	1984-10-13	1984-10-13 00:00:00	32020		\N	2907	0	444814009	40481087		0
983	57	40481087	1992-02-27	1992-02-27 00:00:00	1992-03-19	1992-03-19 00:00:00	32020		\N	3869	0	444814009	40481087		0
1093	64	40481087	1998-01-18	1998-01-18 00:00:00	1998-01-25	1998-01-25 00:00:00	32020		\N	4322	0	444814009	40481087		0
1231	72	260139	1985-05-26	1985-05-26 00:00:00	1985-06-02	1985-06-02 00:00:00	32020		\N	4835	0	10509002	260139		0
1388	81	4112343	1964-09-18	1964-09-18 00:00:00	1964-09-29	1964-09-29 00:00:00	32020		\N	5487	0	195662009	4112343		0
1623	95	28060	1965-11-18	1965-11-18 00:00:00	1965-11-25	1965-11-25 00:00:00	32020		\N	6453	0	43878008	28060		0
1727	99	257012	1998-11-08	1998-11-08 00:00:00	\N	\N	32020		\N	6697	0	40055000	257012		0
1934	114	28060	1975-10-07	1975-10-07 00:00:00	1975-10-18	1975-10-18 00:00:00	32020		\N	7527	0	43878008	28060		0
2065	120	4155034	2016-03-30	2016-03-30 00:00:00	2016-04-13	2016-04-13 00:00:00	32020		\N	7972	0	283371005	4155034		0
2303	135	40481087	1997-08-23	1997-08-23 00:00:00	1997-09-06	1997-09-06 00:00:00	32020		\N	9082	0	444814009	40481087		0
2400	141	257012	2018-09-25	2018-09-25 00:00:00	\N	\N	32020		\N	9451	0	40055000	257012		0
2591	152	40481087	2012-01-31	2012-01-31 00:00:00	2012-02-14	2012-02-14 00:00:00	32020		\N	10269	0	444814009	40481087		0
2737	159	4112343	1968-04-20	1968-04-20 00:00:00	1968-04-30	1968-04-30 00:00:00	32020		\N	10926	0	195662009	4112343		0
2882	165	4146173	2016-03-30	2016-03-30 00:00:00	2016-05-29	2016-05-29 00:00:00	32020		\N	11344	0	307731004	4146173		0
3069	181	40481087	1997-03-22	1997-03-22 00:00:00	1997-03-29	1997-03-29 00:00:00	32020		\N	12237	0	444814009	40481087		0
3214	187	4112343	1977-06-01	1977-06-01 00:00:00	1977-06-12	1977-06-12 00:00:00	32020		\N	12702	0	195662009	4112343		0
3396	194	4283893	2010-11-06	2010-11-06 00:00:00	2011-01-22	2011-01-22 00:00:00	32020		\N	13331	0	36971009	4283893		0
3563	202	4112343	1990-07-09	1990-07-09 00:00:00	1990-07-17	1990-07-17 00:00:00	32020		\N	13849	0	195662009	4112343		0
3725	213	40481087	2013-03-27	2013-03-27 00:00:00	2013-04-03	2013-04-03 00:00:00	32020		\N	14478	0	444814009	40481087		0
3893	224	80180	1977-02-21	1977-02-21 00:00:00	\N	\N	32020		\N	15100	0	396275006	80180		0
4070	236	372328	1952-09-25	1952-09-25 00:00:00	1953-02-26	1953-02-26 00:00:00	32020		\N	15834	0	65363002	372328		0
4234	245	4112343	1966-02-10	1966-02-10 00:00:00	1966-02-23	1966-02-23 00:00:00	32020		\N	16437	0	195662009	4112343		0
4426	260	40479422	1990-08-10	1990-08-10 00:00:00	1990-09-16	1990-09-16 00:00:00	32020		\N	17267	0	444448004	40479422		0
4551	266	378001	1985-03-23	1985-03-23 00:00:00	1985-04-22	1985-04-22 00:00:00	32020		\N	17692	0	62106007	378001		0
4737	279	4294548	2001-12-13	2001-12-13 00:00:00	2001-12-27	2001-12-27 00:00:00	32020		\N	18642	0	75498004	4294548		0
4880	287	4112343	1994-05-09	1994-05-09 00:00:00	1994-05-19	1994-05-19 00:00:00	32020		\N	19189	0	195662009	4112343		0
5066	298	78272	1968-05-05	1968-05-05 00:00:00	1968-06-09	1968-06-09 00:00:00	32020		\N	19882	0	70704007	78272		0
5219	308	4112343	1966-04-01	1966-04-01 00:00:00	1966-04-14	1966-04-14 00:00:00	32020		\N	20422	0	195662009	4112343		0
5410	318	260139	1961-04-23	1961-04-23 00:00:00	1961-05-07	1961-05-07 00:00:00	32020		\N	21055	0	10509002	260139		0
5590	331	40479422	1942-09-22	1942-09-22 00:00:00	1942-10-29	1942-10-29 00:00:00	32020		\N	21807	0	444448004	40479422		0
5715	335	4294548	1966-01-10	1966-01-10 00:00:00	1966-03-07	1966-03-07 00:00:00	32020		\N	22270	0	75498004	4294548		0
5896	347	40481087	2014-06-14	2014-06-14 00:00:00	2014-06-21	2014-06-21 00:00:00	32020		\N	23101	0	444814009	40481087		0
6050	357	40481087	1981-09-05	1981-09-05 00:00:00	1981-09-12	1981-09-12 00:00:00	32020		\N	23653	0	444814009	40481087		0
6203	364	40481087	1971-06-14	1971-06-14 00:00:00	1971-07-05	1971-07-05 00:00:00	32020		\N	24156	0	444814009	40481087		0
6369	374	80180	2015-07-17	2015-07-17 00:00:00	\N	\N	32020		\N	24836	0	396275006	80180		0
6588	388	40481087	2008-11-21	2008-11-21 00:00:00	2008-11-28	2008-11-28 00:00:00	32020		\N	25593	0	444814009	40481087		0
6702	395	4112343	1995-06-28	1995-06-28 00:00:00	1995-07-11	1995-07-11 00:00:00	32020		\N	25949	0	195662009	4112343		0
6875	404	4048171	1965-06-20	1965-06-20 00:00:00	\N	\N	32020		\N	26673	0	232353008	4048171		0
7034	412	30753	1992-08-28	1992-08-28 00:00:00	\N	\N	32020		\N	27451	0	16761005	30753		0
7249	426	4112343	1975-05-06	1975-05-06 00:00:00	1975-05-13	1975-05-13 00:00:00	32020		\N	28265	0	195662009	4112343		0
7365	432	80502	2001-04-09	2001-04-09 00:00:00	\N	\N	32020		\N	28696	0	64859006	80502		0
7540	443	40481087	1977-10-05	1977-10-05 00:00:00	1977-10-19	1977-10-19 00:00:00	32020		\N	29474	0	444814009	40481087		0
7709	452	372328	1963-01-05	1963-01-05 00:00:00	1963-02-15	1963-02-15 00:00:00	32020		\N	30108	0	65363002	372328		0
7874	459	4035415	1984-12-20	1984-12-20 00:00:00	1985-01-19	1985-01-19 00:00:00	32020		\N	30712	0	239720000	4035415		0
8053	471	4283893	1995-07-15	1995-07-15 00:00:00	1995-10-21	1995-10-21 00:00:00	32020		\N	31465	0	36971009	4283893		0
8218	480	81151	1994-11-12	1994-11-12 00:00:00	1994-11-26	1994-11-26 00:00:00	32020		\N	31969	0	44465007	81151		0
8371	487	40481087	2005-04-25	2005-04-25 00:00:00	2005-05-02	2005-05-02 00:00:00	32020		\N	32533	0	444814009	40481087		0
8551	499	40481087	1972-11-27	1972-11-27 00:00:00	1972-12-04	1972-12-04 00:00:00	32020		\N	33361	0	444814009	40481087		0
8728	510	4048695	1983-09-28	1983-09-28 00:00:00	1983-11-29	1983-11-29 00:00:00	32020		\N	34081	0	15724005	4048695		0
8886	520	4116491	1974-11-03	1974-11-03 00:00:00	1974-12-24	1974-12-24 00:00:00	32020		\N	34696	0	301011002	4116491		0
9036	528	4278672	2002-04-13	2002-04-13 00:00:00	2002-07-12	2002-07-12 00:00:00	32020		\N	35211	0	65966004	4278672		0
9234	546	40481087	1955-11-21	1955-11-21 00:00:00	1955-11-28	1955-11-28 00:00:00	32020		\N	36193	0	444814009	40481087		0
9360	552	257012	1975-04-30	1975-04-30 00:00:00	\N	\N	32020		\N	36642	0	40055000	257012		0
9538	565	40481087	1993-10-18	1993-10-18 00:00:00	1993-11-08	1993-11-08 00:00:00	32020		\N	37439	0	444814009	40481087		0
9690	573	4155034	1988-08-13	1988-08-13 00:00:00	1988-08-27	1988-08-27 00:00:00	32020		\N	37986	0	283371005	4155034		0
9860	582	260139	2008-03-23	2008-03-23 00:00:00	2008-03-30	2008-03-30 00:00:00	32020		\N	38582	0	10509002	260139		0
10083	598	4112343	2000-05-07	2000-05-07 00:00:00	2000-05-18	2000-05-18 00:00:00	32020		\N	39503	0	195662009	4112343		0
10216	605	260139	1972-04-09	1972-04-09 00:00:00	1972-04-23	1972-04-23 00:00:00	32020		\N	40116	0	10509002	260139		0
10355	610	80180	2004-12-07	2004-12-07 00:00:00	\N	\N	32020		\N	40622	0	396275006	80180		0
10555	621	78272	2017-05-01	2017-05-01 00:00:00	2017-05-15	2017-05-15 00:00:00	32020		\N	41418	0	70704007	78272		0
61	2	4059173	1990-04-14	1990-04-14 00:00:00	1990-07-13	1990-07-13 00:00:00	32020		\N	116	0	16114001	4059173		0
249	12	4278672	1970-09-20	1970-09-20 00:00:00	1970-10-20	1970-10-20 00:00:00	32020		\N	995	0	65966004	4278672		0
427	23	81893	2010-05-22	2010-05-22 00:00:00	\N	\N	32020		\N	1801	0	64766004	81893		0
606	35	260139	2007-02-25	2007-02-25 00:00:00	2007-03-04	2007-03-04 00:00:00	32020		\N	2436	0	10509002	260139		0
746	41	260139	1999-03-22	1999-03-22 00:00:00	1999-04-05	1999-04-05 00:00:00	32020		\N	2937	0	10509002	260139		0
984	57	4155034	1982-12-31	1982-12-31 00:00:00	1983-01-21	1983-01-21 00:00:00	32020		\N	3821	0	283371005	4155034		0
1094	64	4112343	1985-11-12	1985-11-12 00:00:00	1985-11-20	1985-11-20 00:00:00	32020		\N	4320	0	195662009	4112343		0
1232	72	4230399	1969-09-30	1969-09-30 00:00:00	1969-10-30	1969-10-30 00:00:00	32020		\N	4856	0	359817006	4230399		0
1389	81	4142905	1963-09-11	1963-09-11 00:00:00	1963-12-10	1963-12-10 00:00:00	32020		\N	5507	0	33737001	4142905		0
1624	95	40481087	1994-11-25	1994-11-25 00:00:00	1994-12-16	1994-12-16 00:00:00	32020		\N	6457	0	444814009	40481087		0
1728	99	439777	2016-10-10	2016-10-10 00:00:00	\N	\N	32020		\N	6774	0	271737000	439777		0
1935	114	372328	1977-06-15	1977-06-15 00:00:00	1977-10-24	1977-10-24 00:00:00	32020		\N	7552	0	65363002	372328		0
2066	120	80180	2017-03-18	2017-03-18 00:00:00	\N	\N	32020		\N	7972	0	396275006	80180		0
2304	135	4218389	2001-01-06	2001-01-06 00:00:00	2001-02-03	2001-02-03 00:00:00	32020		\N	9021	0	39848009	4218389		0
2401	141	40481087	2008-10-21	2008-10-21 00:00:00	2008-11-04	2008-11-04 00:00:00	32020		\N	9439	0	444814009	40481087		0
2592	152	40481087	2018-05-18	2018-05-18 00:00:00	2018-05-25	2018-05-25 00:00:00	32020		\N	10231	0	444814009	40481087		0
2738	159	81151	1976-05-19	1976-05-19 00:00:00	1976-06-16	1976-06-16 00:00:00	32020		\N	10920	0	44465007	81151		0
2883	165	4112343	2002-09-14	2002-09-14 00:00:00	2002-09-22	2002-09-22 00:00:00	32020		\N	11340	0	195662009	4112343		0
3070	181	260139	1984-09-19	1984-09-19 00:00:00	1984-10-03	1984-10-03 00:00:00	32020		\N	12203	0	10509002	260139		0
3215	187	4296204	2001-04-15	2001-04-15 00:00:00	2001-05-13	2001-05-13 00:00:00	32020		\N	12738	0	403190006	4296204		0
3397	195	4218389	1977-11-23	1977-11-23 00:00:00	1977-12-28	1977-12-28 00:00:00	32020		\N	13421	0	39848009	4218389		0
3606	207	260139	2009-03-23	2009-03-23 00:00:00	2009-03-30	2009-03-30 00:00:00	32020		\N	14149	0	10509002	260139		0
3726	213	440448	1977-04-29	1977-04-29 00:00:00	\N	\N	32020		\N	14534	0	74400008	440448		0
3894	224	4294548	1990-10-17	1990-10-17 00:00:00	1991-03-13	1991-03-13 00:00:00	32020		\N	15038	0	75498004	4294548		0
4071	236	4112343	1955-02-01	1955-02-01 00:00:00	1955-02-08	1955-02-08 00:00:00	32020		\N	15940	0	195662009	4112343		0
4235	245	372328	1917-03-15	1917-03-15 00:00:00	1917-05-27	1917-05-27 00:00:00	32020		\N	16488	0	65363002	372328		0
4427	260	372328	1971-03-15	1971-03-15 00:00:00	1971-06-19	1971-06-19 00:00:00	32020		\N	17183	0	65363002	372328		0
4552	266	40481087	1980-03-10	1980-03-10 00:00:00	1980-03-24	1980-03-24 00:00:00	32020		\N	17672	0	444814009	40481087		0
4738	279	40481087	2009-05-24	2009-05-24 00:00:00	2009-06-07	2009-06-07 00:00:00	32020		\N	18643	0	444814009	40481087		0
4881	287	81151	1995-03-05	1995-03-05 00:00:00	1995-03-19	1995-03-19 00:00:00	32020		\N	19218	0	44465007	81151		0
5067	298	40481087	1953-08-09	1953-08-09 00:00:00	1953-08-16	1953-08-16 00:00:00	32020		\N	19897	0	444814009	40481087		0
5220	308	40481087	1975-11-29	1975-11-29 00:00:00	1975-12-13	1975-12-13 00:00:00	32020		\N	20468	0	444814009	40481087		0
5411	318	4112343	2010-04-01	2010-04-01 00:00:00	2010-04-14	2010-04-14 00:00:00	32020		\N	21050	0	195662009	4112343		0
5591	331	40481087	1968-07-03	1968-07-03 00:00:00	1968-07-17	1968-07-17 00:00:00	32020		\N	21816	0	444814009	40481087		0
5729	337	80180	1997-07-30	1997-07-30 00:00:00	\N	\N	32020		\N	22410	0	396275006	80180		0
5897	348	4059173	1984-10-08	1984-10-08 00:00:00	1985-01-06	1985-01-06 00:00:00	32020		\N	23115	0	16114001	4059173		0
6051	357	260139	1992-03-28	1992-03-28 00:00:00	1992-04-04	1992-04-04 00:00:00	32020		\N	23764	0	10509002	260139		0
6204	364	260139	1951-05-12	1951-05-12 00:00:00	1951-05-19	1951-05-19 00:00:00	32020		\N	24215	0	10509002	260139		0
6370	374	40481087	1987-08-05	1987-08-05 00:00:00	1987-08-19	1987-08-19 00:00:00	32020		\N	24838	0	444814009	40481087		0
6589	388	40481087	2007-07-16	2007-07-16 00:00:00	2007-07-23	2007-07-23 00:00:00	32020		\N	25527	0	444814009	40481087		0
6703	395	257012	1998-06-03	1998-06-03 00:00:00	\N	\N	32020		\N	25990	0	40055000	257012		0
6876	404	40481087	1977-02-14	1977-02-14 00:00:00	1977-02-21	1977-02-21 00:00:00	32020		\N	26679	0	444814009	40481087		0
7035	412	260139	1982-11-09	1982-11-09 00:00:00	1982-11-23	1982-11-23 00:00:00	32020		\N	27426	0	10509002	260139		0
7250	426	134438	1984-01-16	1984-01-16 00:00:00	1984-10-12	1984-10-12 00:00:00	32020		\N	28286	0	40275004	134438		0
7366	432	4112343	1985-12-22	1985-12-22 00:00:00	1985-12-31	1985-12-31 00:00:00	32020		\N	28724	0	195662009	4112343		0
7541	443	4278672	1984-03-02	1984-03-02 00:00:00	1984-04-01	1984-04-01 00:00:00	32020		\N	29426	0	65966004	4278672		0
7710	452	372328	1967-08-05	1967-08-05 00:00:00	1968-08-23	1968-08-23 00:00:00	32020		\N	30088	0	65363002	372328		0
7875	459	4112343	1985-11-11	1985-11-11 00:00:00	1985-11-19	1985-11-19 00:00:00	32020		\N	30678	0	195662009	4112343		0
8054	471	4218389	1992-03-27	1992-03-27 00:00:00	1992-04-24	1992-04-24 00:00:00	32020		\N	31463	0	39848009	4218389		0
8219	480	4059173	1954-02-10	1954-02-10 00:00:00	1954-03-12	1954-03-12 00:00:00	32020		\N	31965	0	16114001	4059173		0
8372	487	4112343	1994-09-10	1994-09-10 00:00:00	1994-09-19	1994-09-19 00:00:00	32020		\N	32597	0	195662009	4112343		0
8552	499	40481087	1962-08-27	1962-08-27 00:00:00	1962-09-17	1962-09-17 00:00:00	32020		\N	33345	0	444814009	40481087		0
8729	510	40479422	2005-06-04	2005-06-04 00:00:00	2005-08-10	2005-08-10 00:00:00	32020		\N	34083	0	444448004	40479422		0
8887	520	40481087	1956-04-20	1956-04-20 00:00:00	1956-05-11	1956-05-11 00:00:00	32020		\N	34662	0	444814009	40481087		0
9037	528	80180	2002-07-02	2002-07-02 00:00:00	\N	\N	32020		\N	35211	0	396275006	80180		0
9235	546	4156265	2004-11-23	2004-11-23 00:00:00	2004-12-14	2004-12-14 00:00:00	32020		\N	36153	0	370247008	4156265		0
9361	552	4112343	1958-11-20	1958-11-20 00:00:00	1958-12-02	1958-12-02 00:00:00	32020		\N	36579	0	195662009	4112343		0
9539	565	80180	1994-09-28	1994-09-28 00:00:00	\N	\N	32020		\N	37439	0	396275006	80180		0
9691	573	40481087	1992-12-12	1992-12-12 00:00:00	1992-12-19	1992-12-19 00:00:00	32020		\N	38000	0	444814009	40481087		0
9861	582	4112343	1971-12-23	1971-12-23 00:00:00	1972-01-03	1972-01-03 00:00:00	32020		\N	38589	0	195662009	4112343		0
10084	598	40481087	1983-10-09	1983-10-09 00:00:00	1983-10-30	1983-10-30 00:00:00	32020		\N	39510	0	444814009	40481087		0
10217	605	4112343	1957-07-12	1957-07-12 00:00:00	1957-07-24	1957-07-24 00:00:00	32020		\N	40119	0	195662009	4112343		0
10356	610	378001	1974-11-21	1974-11-21 00:00:00	1974-12-21	1974-12-21 00:00:00	32020		\N	40478	0	62106007	378001		0
10556	621	28060	1966-05-15	1966-05-15 00:00:00	1966-05-24	1966-05-24 00:00:00	32020		\N	41417	0	43878008	28060		0
62	2	195588	1952-05-24	1952-05-24 00:00:00	1952-07-08	1952-07-08 00:00:00	32020		\N	153	0	38822007	195588		0
250	12	4116491	2002-01-20	2002-01-20 00:00:00	2002-03-13	2002-03-13 00:00:00	32020		\N	1056	0	301011002	4116491		0
428	23	30753	2010-11-18	2010-11-18 00:00:00	\N	\N	32020		\N	1801	0	16761005	30753		0
607	35	40481087	2002-07-03	2002-07-03 00:00:00	2002-07-17	2002-07-17 00:00:00	32020		\N	2407	0	444814009	40481087		0
747	41	40481087	1982-04-24	1982-04-24 00:00:00	1982-05-15	1982-05-15 00:00:00	32020		\N	2902	0	444814009	40481087		0
985	57	4112343	2010-07-06	2010-07-06 00:00:00	2010-07-16	2010-07-16 00:00:00	32020		\N	3851	0	195662009	4112343		0
1095	64	80180	2009-03-03	2009-03-03 00:00:00	\N	\N	32020		\N	4347	0	396275006	80180		0
1233	72	4112343	1992-10-01	1992-10-01 00:00:00	1992-10-14	1992-10-14 00:00:00	32020		\N	4919	0	195662009	4112343		0
1390	81	40481087	1956-08-27	1956-08-27 00:00:00	1956-09-03	1956-09-03 00:00:00	32020		\N	5497	0	444814009	40481087		0
1625	95	40481087	2002-03-18	2002-03-18 00:00:00	2002-04-08	2002-04-08 00:00:00	32020		\N	6458	0	444814009	40481087		0
1729	99	372328	1994-04-02	1994-04-02 00:00:00	1995-12-23	1995-12-23 00:00:00	32020		\N	6701	0	65363002	372328		0
1936	114	4116491	1999-03-07	1999-03-07 00:00:00	1999-04-11	1999-04-11 00:00:00	32020		\N	7531	0	301011002	4116491		0
2067	120	4218389	2007-07-25	2007-07-25 00:00:00	2007-08-15	2007-08-15 00:00:00	32020		\N	7971	0	39848009	4218389		0
2305	135	40481087	2001-11-20	2001-11-20 00:00:00	2001-12-04	2001-12-04 00:00:00	32020		\N	9061	0	444814009	40481087		0
2402	141	40481087	2010-12-03	2010-12-03 00:00:00	2010-12-17	2010-12-17 00:00:00	32020		\N	9468	0	444814009	40481087		0
2593	152	4112343	1969-09-16	1969-09-16 00:00:00	1969-09-28	1969-09-28 00:00:00	32020		\N	10226	0	195662009	4112343		0
2739	159	372328	1959-07-09	1959-07-09 00:00:00	1959-12-22	1959-12-22 00:00:00	32020		\N	10865	0	65363002	372328		0
2884	165	260139	2012-11-18	2012-11-18 00:00:00	2012-11-25	2012-11-25 00:00:00	32020		\N	11316	0	10509002	260139		0
3071	182	260139	2007-10-17	2007-10-17 00:00:00	2007-10-31	2007-10-31 00:00:00	32020		\N	12298	0	10509002	260139		0
3216	187	40481087	1986-03-21	1986-03-21 00:00:00	1986-04-04	1986-04-04 00:00:00	32020		\N	12703	0	444814009	40481087		0
3398	195	28060	1965-12-07	1965-12-07 00:00:00	1965-12-16	1965-12-16 00:00:00	32020		\N	13352	0	43878008	28060		0
3607	207	4059173	2009-07-25	2009-07-25 00:00:00	2009-09-23	2009-09-23 00:00:00	32020		\N	14132	0	16114001	4059173		0
3728	213	40481087	1995-12-11	1995-12-11 00:00:00	1995-12-25	1995-12-25 00:00:00	32020		\N	14500	0	444814009	40481087		0
3895	224	372328	1946-05-28	1946-05-28 00:00:00	1946-10-01	1946-10-01 00:00:00	32020		\N	15028	0	65363002	372328		0
4072	236	4112343	1987-09-29	1987-09-29 00:00:00	1987-10-11	1987-10-11 00:00:00	32020		\N	15927	0	195662009	4112343		0
4236	245	40481087	1923-01-15	1923-01-15 00:00:00	1923-01-29	1923-01-29 00:00:00	32020		\N	16435	0	444814009	40481087		0
4428	260	40481087	1991-05-31	1991-05-31 00:00:00	1991-06-21	1991-06-21 00:00:00	32020		\N	17246	0	444814009	40481087		0
4553	266	372328	1967-06-26	1967-06-26 00:00:00	1967-07-10	1967-07-10 00:00:00	32020		\N	17684	0	65363002	372328		0
4739	279	81151	1968-10-01	1968-10-01 00:00:00	1968-10-15	1968-10-15 00:00:00	32020		\N	18635	0	44465007	81151		0
4882	287	372328	1977-10-06	1977-10-06 00:00:00	1978-01-15	1978-01-15 00:00:00	32020		\N	19184	0	65363002	372328		0
5068	298	4218389	1954-12-24	1954-12-24 00:00:00	1955-01-14	1955-01-14 00:00:00	32020		\N	19881	0	39848009	4218389		0
5221	308	40481087	1999-09-07	1999-09-07 00:00:00	1999-09-28	1999-09-28 00:00:00	32020		\N	20402	0	444814009	40481087		0
5412	318	257012	1959-07-07	1959-07-07 00:00:00	\N	\N	32020		\N	21091	0	40055000	257012		0
5592	331	260139	1998-05-31	1998-05-31 00:00:00	1998-06-07	1998-06-07 00:00:00	32020		\N	21823	0	10509002	260139		0
5730	337	40481087	1964-03-09	1964-03-09 00:00:00	1964-03-16	1964-03-16 00:00:00	32020		\N	22445	0	444814009	40481087		0
5898	348	372328	1979-08-25	1979-08-25 00:00:00	1980-07-07	1980-07-07 00:00:00	32020		\N	23133	0	65363002	372328		0
6052	357	4283893	1983-10-09	1983-10-09 00:00:00	1984-01-08	1984-01-08 00:00:00	32020		\N	23665	0	36971009	4283893		0
6205	364	4218389	2017-08-18	2017-08-18 00:00:00	2017-09-08	2017-09-08 00:00:00	32020		\N	24212	0	39848009	4218389		0
6377	376	4218389	2017-04-20	2017-04-20 00:00:00	2017-05-25	2017-05-25 00:00:00	32020		\N	24943	0	39848009	4218389		0
6590	388	4112343	1966-12-03	1966-12-03 00:00:00	1966-12-10	1966-12-10 00:00:00	32020		\N	25591	0	195662009	4112343		0
6704	395	40481087	2003-03-03	2003-03-03 00:00:00	2003-03-10	2003-03-10 00:00:00	32020		\N	25951	0	444814009	40481087		0
6877	404	40481087	2008-07-22	2008-07-22 00:00:00	2008-08-05	2008-08-05 00:00:00	32020		\N	26610	0	444814009	40481087		0
7036	412	4112343	1981-06-18	1981-06-18 00:00:00	1981-06-26	1981-06-26 00:00:00	32020		\N	27463	0	195662009	4112343		0
7251	426	4112343	1969-12-05	1969-12-05 00:00:00	1969-12-18	1969-12-18 00:00:00	32020		\N	28249	0	195662009	4112343		0
7367	432	378001	1961-02-19	1961-02-19 00:00:00	1961-03-21	1961-03-21 00:00:00	32020		\N	28713	0	62106007	378001		0
7542	443	40481087	1977-12-25	1977-12-25 00:00:00	1978-01-01	1978-01-01 00:00:00	32020		\N	29483	0	444814009	40481087		0
7711	452	372328	2009-08-18	2009-08-18 00:00:00	2010-12-24	2010-12-24 00:00:00	32020		\N	30109	0	65363002	372328		0
7892	461	4027663	1973-07-21	1973-07-21 00:00:00	\N	\N	32020		\N	30855	0	13200003	4027663		0
8055	471	80180	2016-12-16	2016-12-16 00:00:00	\N	\N	32020		\N	31478	0	396275006	80180		0
8220	480	260139	1958-10-13	1958-10-13 00:00:00	1958-10-20	1958-10-20 00:00:00	32020		\N	31986	0	10509002	260139		0
8373	487	257012	2007-07-01	2007-07-01 00:00:00	\N	\N	32020		\N	32544	0	40055000	257012		0
8553	499	4084167	1959-10-21	1959-10-21 00:00:00	1959-10-21	1959-10-21 00:00:00	32020		\N	33413	0	241929008	4084167		0
8730	510	372328	1969-09-28	1969-09-28 00:00:00	1970-09-12	1970-09-12 00:00:00	32020		\N	34095	0	65363002	372328		0
8888	520	78272	1978-01-17	1978-01-17 00:00:00	1978-02-14	1978-02-14 00:00:00	32020		\N	34744	0	70704007	78272		0
9038	528	40481087	1995-03-31	1995-03-31 00:00:00	1995-04-21	1995-04-21 00:00:00	32020		\N	35224	0	444814009	40481087		0
9236	546	40481087	1948-03-21	1948-03-21 00:00:00	1948-04-11	1948-04-11 00:00:00	32020		\N	36191	0	444814009	40481087		0
9362	552	260139	1969-07-17	1969-07-17 00:00:00	1969-07-31	1969-07-31 00:00:00	32020		\N	36623	0	10509002	260139		0
9540	565	28060	1974-01-13	1974-01-13 00:00:00	1974-01-25	1974-01-25 00:00:00	32020		\N	37437	0	43878008	28060		0
9692	573	4112343	1963-08-24	1963-08-24 00:00:00	1963-09-05	1963-09-05 00:00:00	32020		\N	37968	0	195662009	4112343		0
9862	582	378001	1992-12-15	1992-12-15 00:00:00	1993-01-14	1993-01-14 00:00:00	32020		\N	38598	0	62106007	378001		0
10085	598	81151	2014-01-07	2014-01-07 00:00:00	2014-02-04	2014-02-04 00:00:00	32020		\N	39478	0	44465007	81151		0
10218	605	40481087	1960-08-29	1960-08-29 00:00:00	1960-09-19	1960-09-19 00:00:00	32020		\N	40181	0	444814009	40481087		0
10357	610	4112343	1996-12-26	1996-12-26 00:00:00	1997-01-03	1997-01-03 00:00:00	32020		\N	40554	0	195662009	4112343		0
10557	621	40481087	2013-09-01	2013-09-01 00:00:00	2013-09-08	2013-09-08 00:00:00	32020		\N	41437	0	444814009	40481087		0
63	2	80180	1956-12-04	1956-12-04 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
251	12	4152936	1980-01-31	1980-01-31 00:00:00	1980-02-21	1980-02-21 00:00:00	32020		\N	996	0	283385000	4152936		0
429	23	4285898	2011-08-15	2011-08-15 00:00:00	\N	\N	32020		\N	1801	0	68496003	4285898		0
608	35	4285898	1997-04-02	1997-04-02 00:00:00	\N	\N	32020		\N	2406	0	68496003	4285898		0
748	41	28060	1983-01-01	1983-01-01 00:00:00	1983-01-11	1983-01-11 00:00:00	32020		\N	2923	0	43878008	28060		0
986	57	40481087	1963-11-15	1963-11-15 00:00:00	1963-12-06	1963-12-06 00:00:00	32020		\N	3822	0	444814009	40481087		0
1096	64	4109685	2003-10-05	2003-10-05 00:00:00	2003-10-26	2003-10-26 00:00:00	32020		\N	4330	0	284551006	4109685		0
1234	72	4112343	1968-02-12	1968-02-12 00:00:00	1968-02-23	1968-02-23 00:00:00	32020		\N	4916	0	195662009	4112343		0
1391	81	4112343	1967-05-19	1967-05-19 00:00:00	1967-06-01	1967-06-01 00:00:00	32020		\N	5482	0	195662009	4112343		0
1626	95	80180	1993-06-06	1993-06-06 00:00:00	\N	\N	32020		\N	6425	0	396275006	80180		0
1730	99	40481087	1962-05-04	1962-05-04 00:00:00	1962-05-11	1962-05-11 00:00:00	32020		\N	6717	0	444814009	40481087		0
1937	114	40481087	1991-10-06	1991-10-06 00:00:00	1991-10-20	1991-10-20 00:00:00	32020		\N	7528	0	444814009	40481087		0
2068	120	40481087	1999-05-28	1999-05-28 00:00:00	1999-06-18	1999-06-18 00:00:00	32020		\N	8005	0	444814009	40481087		0
2306	135	192671	2010-02-01	2010-02-01 00:00:00	\N	\N	32020		\N	9022	0	K92.2	35208414		0
2403	141	40481087	1990-03-05	1990-03-05 00:00:00	1990-03-26	1990-03-26 00:00:00	32020		\N	9438	0	444814009	40481087		0
2594	152	40481087	1971-09-10	1971-09-10 00:00:00	1971-09-17	1971-09-17 00:00:00	32020		\N	10276	0	444814009	40481087		0
2740	159	317576	1985-03-19	1985-03-19 00:00:00	\N	\N	32020		\N	10901	0	53741008	317576		0
2885	165	257012	2018-05-04	2018-05-04 00:00:00	\N	\N	32020		\N	11372	0	40055000	257012		0
3072	182	81151	1987-05-29	1987-05-29 00:00:00	1987-06-26	1987-06-26 00:00:00	32020		\N	12325	0	44465007	81151		0
3217	187	40481087	1954-10-04	1954-10-04 00:00:00	1954-10-25	1954-10-25 00:00:00	32020		\N	12700	0	444814009	40481087		0
3399	195	40481087	1989-12-19	1989-12-19 00:00:00	1990-01-02	1990-01-02 00:00:00	32020		\N	13418	0	444814009	40481087		0
3608	207	80180	1975-07-29	1975-07-29 00:00:00	\N	\N	32020		\N	14137	0	396275006	80180		0
3729	213	260139	2013-10-01	2013-10-01 00:00:00	2013-10-15	2013-10-15 00:00:00	32020		\N	14503	0	10509002	260139		0
3896	224	4112343	1975-02-19	1975-02-19 00:00:00	1975-03-04	1975-03-04 00:00:00	32020		\N	15036	0	195662009	4112343		0
4073	236	4027663	1979-03-15	1979-03-15 00:00:00	\N	\N	32020		\N	15833	0	13200003	4027663		0
4237	245	81151	1996-07-21	1996-07-21 00:00:00	1996-08-04	1996-08-04 00:00:00	32020		\N	16403	0	44465007	81151		0
4429	260	260139	1979-02-22	1979-02-22 00:00:00	1979-03-08	1979-03-08 00:00:00	32020		\N	17155	0	10509002	260139		0
4554	266	4146173	1993-11-06	1993-11-06 00:00:00	1993-12-06	1993-12-06 00:00:00	32020		\N	17682	0	307731004	4146173		0
4740	279	260139	2014-10-24	2014-10-24 00:00:00	2014-10-31	2014-10-31 00:00:00	32020		\N	18644	0	10509002	260139		0
4883	287	4112343	1997-02-03	1997-02-03 00:00:00	1997-02-16	1997-02-16 00:00:00	32020		\N	19190	0	195662009	4112343		0
5069	298	260139	1959-03-05	1959-03-05 00:00:00	1959-03-19	1959-03-19 00:00:00	32020		\N	19898	0	10509002	260139		0
5222	308	4112343	1980-11-29	1980-11-29 00:00:00	1980-12-06	1980-12-06 00:00:00	32020		\N	20401	0	195662009	4112343		0
5413	318	40481087	1958-03-17	1958-03-17 00:00:00	1958-04-07	1958-04-07 00:00:00	32020		\N	21108	0	444814009	40481087		0
5593	331	196456	1997-04-18	1997-04-18 00:00:00	1997-04-18	1997-04-18 00:00:00	32020		\N	21811	0	235919008	196456		0
5731	337	40481087	1985-02-22	1985-02-22 00:00:00	1985-03-01	1985-03-01 00:00:00	32020		\N	22454	0	444814009	40481087		0
5899	348	4112343	1978-05-16	1978-05-16 00:00:00	1978-05-26	1978-05-26 00:00:00	32020		\N	23143	0	195662009	4112343		0
6053	357	40481087	1959-06-24	1959-06-24 00:00:00	1959-07-15	1959-07-15 00:00:00	32020		\N	23641	0	444814009	40481087		0
6215	366	4294548	1931-01-17	1931-01-17 00:00:00	1931-02-21	1931-02-21 00:00:00	32020		\N	24272	0	75498004	4294548		0
6378	376	30753	1998-11-09	1998-11-09 00:00:00	\N	\N	32020		\N	24951	0	16761005	30753		0
6592	388	380378	2017-08-29	2017-08-29 00:00:00	\N	\N	32020		\N	25587	0	84757009	380378		0
6705	395	4112343	2017-04-05	2017-04-05 00:00:00	2017-04-17	2017-04-17 00:00:00	32020		\N	25976	0	195662009	4112343		0
6878	404	260139	2011-11-10	2011-11-10 00:00:00	2011-11-17	2011-11-17 00:00:00	32020		\N	26594	0	10509002	260139		0
7037	412	257012	1975-02-23	1975-02-23 00:00:00	\N	\N	32020		\N	27461	0	40055000	257012		0
7252	426	372328	1969-09-02	1969-09-02 00:00:00	1969-12-18	1969-12-18 00:00:00	32020		\N	28258	0	65363002	372328		0
7368	432	372328	1934-12-08	1934-12-08 00:00:00	1935-05-13	1935-05-13 00:00:00	32020		\N	28758	0	65363002	372328		0
7543	443	80180	2005-09-29	2005-09-29 00:00:00	\N	\N	32020		\N	29477	0	396275006	80180		0
7712	452	40481087	1976-02-04	1976-02-04 00:00:00	1976-02-11	1976-02-11 00:00:00	32020		\N	30086	0	444814009	40481087		0
7893	461	260139	1955-04-24	1955-04-24 00:00:00	1955-05-01	1955-05-01 00:00:00	32020		\N	30807	0	10509002	260139		0
8056	471	4112343	2000-03-18	2000-03-18 00:00:00	2000-03-31	2000-03-31 00:00:00	32020		\N	31497	0	195662009	4112343		0
8221	480	260139	1975-09-23	1975-09-23 00:00:00	1975-10-07	1975-10-07 00:00:00	32020		\N	32022	0	10509002	260139		0
8374	487	40481087	1989-12-10	1989-12-10 00:00:00	1989-12-31	1989-12-31 00:00:00	32020		\N	32594	0	444814009	40481087		0
8554	499	4280726	1963-04-30	1963-04-30 00:00:00	1993-07-16	1993-07-16 00:00:00	32020		\N	33357	0	367498001	4280726		0
8731	510	372328	1967-06-08	1967-06-08 00:00:00	1967-09-09	1967-09-09 00:00:00	32020		\N	34113	0	65363002	372328		0
8889	520	260139	1983-06-21	1983-06-21 00:00:00	1983-06-28	1983-06-28 00:00:00	32020		\N	34697	0	10509002	260139		0
9039	528	40481087	1969-04-18	1969-04-18 00:00:00	1969-05-02	1969-05-02 00:00:00	32020		\N	35217	0	444814009	40481087		0
9237	546	257012	1947-07-08	1947-07-08 00:00:00	\N	\N	32020		\N	36210	0	40055000	257012		0
9363	552	40481087	2006-07-18	2006-07-18 00:00:00	2006-07-25	2006-07-25 00:00:00	32020		\N	36663	0	444814009	40481087		0
9541	565	40481087	1982-08-31	1982-08-31 00:00:00	1982-09-14	1982-09-14 00:00:00	32020		\N	37438	0	444814009	40481087		0
9693	573	40481087	1980-08-23	1980-08-23 00:00:00	1980-09-13	1980-09-13 00:00:00	32020		\N	37997	0	444814009	40481087		0
9863	582	28060	2014-04-02	2014-04-02 00:00:00	2014-04-14	2014-04-14 00:00:00	32020		\N	38583	0	43878008	28060		0
10086	598	81893	2007-10-07	2007-10-07 00:00:00	\N	\N	32020		\N	39490	0	64766004	81893		0
10219	605	4112343	1995-11-26	1995-11-26 00:00:00	1995-12-09	1995-12-09 00:00:00	32020		\N	40128	0	195662009	4112343		0
10358	610	4112343	2013-01-13	2013-01-13 00:00:00	2013-01-24	2013-01-24 00:00:00	32020		\N	40524	0	195662009	4112343		0
10558	621	40481087	1962-07-01	1962-07-01 00:00:00	1962-07-08	1962-07-08 00:00:00	32020		\N	41416	0	444814009	40481087		0
64	2	372328	1920-07-01	1920-07-01 00:00:00	1920-09-07	1920-09-07 00:00:00	32020		\N	161	0	65363002	372328		0
252	12	81151	1997-02-26	1997-02-26 00:00:00	1997-03-19	1997-03-19 00:00:00	32020		\N	1014	0	44465007	81151		0
430	23	40481087	1991-08-08	1991-08-08 00:00:00	1991-08-22	1991-08-22 00:00:00	32020		\N	1803	0	444814009	40481087		0
609	35	80180	1997-05-02	1997-05-02 00:00:00	\N	\N	32020		\N	2406	0	396275006	80180		0
749	41	260139	1974-10-19	1974-10-19 00:00:00	1974-10-26	1974-10-26 00:00:00	32020		\N	2901	0	10509002	260139		0
987	57	260139	1982-07-09	1982-07-09 00:00:00	1982-07-23	1982-07-23 00:00:00	32020		\N	3849	0	10509002	260139		0
1097	64	40481087	1994-12-23	1994-12-23 00:00:00	1994-12-30	1994-12-30 00:00:00	32020		\N	4348	0	444814009	40481087		0
1235	72	40481087	1952-04-20	1952-04-20 00:00:00	1952-05-11	1952-05-11 00:00:00	32020		\N	4882	0	444814009	40481087		0
1392	81	28060	2005-08-09	2005-08-09 00:00:00	2005-08-17	2005-08-17 00:00:00	32020		\N	5489	0	43878008	28060		0
1627	95	81893	1991-10-15	1991-10-15 00:00:00	\N	\N	32020		\N	6425	0	64766004	81893		0
1731	99	4112343	1974-05-02	1974-05-02 00:00:00	1974-05-15	1974-05-15 00:00:00	32020		\N	6776	0	195662009	4112343		0
1938	114	4156265	1988-08-14	1988-08-14 00:00:00	1988-08-28	1988-08-28 00:00:00	32020		\N	7505	0	370247008	4156265		0
2069	120	372328	1978-06-06	1978-06-06 00:00:00	1978-09-16	1978-09-16 00:00:00	32020		\N	8003	0	65363002	372328		0
2307	135	260139	2017-11-14	2017-11-14 00:00:00	2017-11-21	2017-11-21 00:00:00	32020		\N	9062	0	10509002	260139		0
2404	141	260139	1987-03-16	1987-03-16 00:00:00	1987-03-30	1987-03-30 00:00:00	32020		\N	9437	0	10509002	260139		0
2595	153	4283893	2008-02-17	2008-02-17 00:00:00	2008-04-06	2008-04-06 00:00:00	32020		\N	10398	0	36971009	4283893		0
2741	159	4112343	1997-12-11	1997-12-11 00:00:00	1997-12-21	1997-12-21 00:00:00	32020		\N	10928	0	195662009	4112343		0
2886	165	260139	1992-09-23	1992-09-23 00:00:00	1992-09-30	1992-09-30 00:00:00	32020		\N	11313	0	10509002	260139		0
3073	182	40481087	1985-05-24	1985-05-24 00:00:00	1985-06-14	1985-06-14 00:00:00	32020		\N	12250	0	444814009	40481087		0
3218	187	260139	1999-07-27	1999-07-27 00:00:00	1999-08-03	1999-08-03 00:00:00	32020		\N	12745	0	10509002	260139		0
3400	195	28060	2014-10-15	2014-10-15 00:00:00	2014-10-25	2014-10-25 00:00:00	32020		\N	13393	0	43878008	28060		0
3609	207	80502	2011-04-10	2011-04-10 00:00:00	\N	\N	32020		\N	14096	0	64859006	80502		0
3730	213	4112343	2014-06-17	2014-06-17 00:00:00	2014-06-28	2014-06-28 00:00:00	32020		\N	14526	0	195662009	4112343		0
3898	224	4029498	1954-10-10	1954-10-10 00:00:00	\N	\N	32020		\N	15088	0	128613002	4029498		0
4074	236	40481087	1957-05-28	1957-05-28 00:00:00	1957-06-04	1957-06-04 00:00:00	32020		\N	15921	0	444814009	40481087		0
4238	245	40481087	2007-01-13	2007-01-13 00:00:00	2007-01-27	2007-01-27 00:00:00	32020		\N	16487	0	444814009	40481087		0
4430	260	4112343	1986-05-18	1986-05-18 00:00:00	1986-05-25	1986-05-25 00:00:00	32020		\N	17198	0	195662009	4112343		0
4555	266	40481087	1979-01-31	1979-01-31 00:00:00	1979-02-07	1979-02-07 00:00:00	32020		\N	17742	0	444814009	40481087		0
4741	279	260139	1958-10-25	1958-10-25 00:00:00	1958-11-01	1958-11-01 00:00:00	32020		\N	18652	0	10509002	260139		0
4884	287	4294548	2018-05-15	2018-05-15 00:00:00	2018-05-29	2018-05-29 00:00:00	32020		\N	19192	0	75498004	4294548		0
5070	298	28060	1952-10-08	1952-10-08 00:00:00	1952-10-20	1952-10-20 00:00:00	32020		\N	19896	0	43878008	28060		0
5223	308	40481087	2013-11-01	2013-11-01 00:00:00	2013-11-15	2013-11-15 00:00:00	32020		\N	20426	0	444814009	40481087		0
5421	320	260139	1961-02-23	1961-02-23 00:00:00	1961-03-09	1961-03-09 00:00:00	32020		\N	21228	0	10509002	260139		0
5594	331	198809	1997-04-18	1997-04-18 00:00:00	1997-04-18	1997-04-18 00:00:00	32020		\N	21811	0	65275009	198809		0
5732	337	440086	1973-09-19	1973-09-19 00:00:00	1977-09-28	1977-09-28 00:00:00	32020		\N	22453	0	192127007	440086		0
5900	348	40481087	1984-10-29	1984-10-29 00:00:00	1984-11-12	1984-11-12 00:00:00	32020		\N	23144	0	444814009	40481087		0
6054	357	40481087	1993-07-26	1993-07-26 00:00:00	1993-08-02	1993-08-02 00:00:00	32020		\N	23745	0	444814009	40481087		0
6216	366	260139	1961-10-03	1961-10-03 00:00:00	1961-10-17	1961-10-17 00:00:00	32020		\N	24385	0	10509002	260139		0
6379	376	80180	1999-07-07	1999-07-07 00:00:00	\N	\N	32020		\N	24951	0	396275006	80180		0
6593	388	4029498	2017-08-29	2017-08-29 00:00:00	\N	\N	32020		\N	25587	0	128613002	4029498		0
6706	395	4112343	1971-10-20	1971-10-20 00:00:00	1971-10-30	1971-10-30 00:00:00	32020		\N	25986	0	195662009	4112343		0
6879	404	440086	1970-06-12	1970-06-12 00:00:00	1971-11-05	1971-11-05 00:00:00	32020		\N	26675	0	192127007	440086		0
7038	412	40481087	1997-02-01	1997-02-01 00:00:00	1997-02-08	1997-02-08 00:00:00	32020		\N	27452	0	444814009	40481087		0
7253	426	40481087	1981-12-12	1981-12-12 00:00:00	1981-12-19	1981-12-19 00:00:00	32020		\N	28285	0	444814009	40481087		0
7369	432	260139	1939-01-17	1939-01-17 00:00:00	1939-01-24	1939-01-24 00:00:00	32020		\N	28741	0	10509002	260139		0
7544	443	4230399	2012-05-01	2012-05-01 00:00:00	2012-06-30	2012-06-30 00:00:00	32020		\N	29431	0	359817006	4230399		0
7713	453	4112343	1977-05-22	1977-05-22 00:00:00	1977-05-30	1977-05-30 00:00:00	32020		\N	30220	0	195662009	4112343		0
7894	461	372328	1954-05-11	1954-05-11 00:00:00	1954-07-20	1954-07-20 00:00:00	32020		\N	30783	0	65363002	372328		0
8057	472	80180	2018-10-06	2018-10-06 00:00:00	\N	\N	32020		\N	31528	0	396275006	80180		0
8222	480	28060	1939-11-08	1939-11-08 00:00:00	1939-11-17	1939-11-17 00:00:00	32020		\N	32083	0	43878008	28060		0
8375	487	40481087	2003-08-12	2003-08-12 00:00:00	2003-08-26	2003-08-26 00:00:00	32020		\N	32598	0	444814009	40481087		0
8555	499	80180	1997-08-02	1997-08-02 00:00:00	\N	\N	32020		\N	33302	0	396275006	80180		0
8732	510	4112343	2001-06-24	2001-06-24 00:00:00	2001-07-07	2001-07-07 00:00:00	32020		\N	34094	0	195662009	4112343		0
8890	520	40481087	1976-09-22	1976-09-22 00:00:00	1976-09-29	1976-09-29 00:00:00	32020		\N	34727	0	444814009	40481087		0
9040	528	195588	1981-05-23	1981-05-23 00:00:00	1981-06-25	1981-06-25 00:00:00	32020		\N	35218	0	38822007	195588		0
9238	546	4278672	1944-12-08	1944-12-08 00:00:00	1945-02-06	1945-02-06 00:00:00	32020		\N	36148	0	65966004	4278672		0
9364	552	4237458	2015-06-05	2015-06-05 00:00:00	2015-09-03	2015-09-03 00:00:00	32020		\N	36614	0	58150001	4237458		0
9542	565	260139	1960-12-07	1960-12-07 00:00:00	1960-12-14	1960-12-14 00:00:00	32020		\N	37459	0	10509002	260139		0
9694	573	40481087	1991-03-26	1991-03-26 00:00:00	1991-04-16	1991-04-16 00:00:00	32020		\N	37998	0	444814009	40481087		0
9864	582	192671	2005-04-04	2005-04-04 00:00:00	\N	\N	32020		\N	38558	0	K92.2	35208414		0
10087	598	4310024	2006-11-11	2006-11-11 00:00:00	\N	\N	32020		\N	39490	0	424802006	4310024		0
10220	605	378001	1977-01-26	1977-01-26 00:00:00	1977-03-27	1977-03-27 00:00:00	32020		\N	40161	0	62106007	378001		0
10359	610	260139	2010-08-22	2010-08-22 00:00:00	2010-09-05	2010-09-05 00:00:00	32020		\N	40614	0	10509002	260139		0
10559	621	40481087	1997-03-28	1997-03-28 00:00:00	1997-04-04	1997-04-04 00:00:00	32020		\N	41477	0	444814009	40481087		0
8618	502	80180	1979-08-26	1979-08-26 00:00:00	\N	\N	32020		\N	33582	0	396275006	80180		0
65	2	260139	1996-04-10	1996-04-10 00:00:00	1996-04-24	1996-04-24 00:00:00	32020		\N	107	0	10509002	260139		0
253	12	78272	1988-01-10	1988-01-10 00:00:00	1988-02-14	1988-02-14 00:00:00	32020		\N	1013	0	70704007	78272		0
431	23	4112343	2013-12-06	2013-12-06 00:00:00	2013-12-18	2013-12-18 00:00:00	32020		\N	1786	0	195662009	4112343		0
610	35	4266809	1997-05-02	1997-05-02 00:00:00	\N	\N	32020		\N	2406	0	397881000	4266809		0
750	41	4112343	1975-04-03	1975-04-03 00:00:00	1975-04-10	1975-04-10 00:00:00	32020		\N	2977	0	195662009	4112343		0
988	57	4112343	1983-12-03	1983-12-03 00:00:00	1983-12-10	1983-12-10 00:00:00	32020		\N	3870	0	195662009	4112343		0
1098	65	40481087	1969-05-25	1969-05-25 00:00:00	1969-06-01	1969-06-01 00:00:00	32020		\N	4394	0	444814009	40481087		0
1236	72	40481087	1990-11-15	1990-11-15 00:00:00	1990-11-29	1990-11-29 00:00:00	32020		\N	4861	0	444814009	40481087		0
1393	81	40481087	1963-03-06	1963-03-06 00:00:00	1963-03-13	1963-03-13 00:00:00	32020		\N	5527	0	444814009	40481087		0
1628	95	4027663	1983-08-23	1983-08-23 00:00:00	\N	\N	32020		\N	6438	0	13200003	4027663		0
1732	99	40481087	1995-03-05	1995-03-05 00:00:00	1995-03-19	1995-03-19 00:00:00	32020		\N	6696	0	444814009	40481087		0
1939	114	260139	2009-11-30	2009-11-30 00:00:00	2009-12-07	2009-12-07 00:00:00	32020		\N	7513	0	10509002	260139		0
2070	120	40481087	1983-06-16	1983-06-16 00:00:00	1983-07-07	1983-07-07 00:00:00	32020		\N	8004	0	444814009	40481087		0
2308	135	30753	2009-03-02	2009-03-02 00:00:00	\N	\N	32020		\N	9077	0	16761005	30753		0
2405	141	4112343	1991-01-26	1991-01-26 00:00:00	1991-02-02	1991-02-02 00:00:00	32020		\N	9448	0	195662009	4112343		0
2596	153	40481087	1950-11-20	1950-11-20 00:00:00	1950-12-11	1950-12-11 00:00:00	32020		\N	10347	0	444814009	40481087		0
2742	159	40481087	1992-11-27	1992-11-27 00:00:00	1992-12-11	1992-12-11 00:00:00	32020		\N	10892	0	444814009	40481087		0
2887	165	40481087	1969-03-14	1969-03-14 00:00:00	1969-04-04	1969-04-04 00:00:00	32020		\N	11370	0	444814009	40481087		0
3074	182	40481087	1997-08-17	1997-08-17 00:00:00	1997-08-31	1997-08-31 00:00:00	32020		\N	12279	0	444814009	40481087		0
3219	187	372328	1947-09-28	1947-09-28 00:00:00	1947-12-28	1947-12-28 00:00:00	32020		\N	12706	0	65363002	372328		0
3401	195	4294548	1998-10-18	1998-10-18 00:00:00	1998-12-06	1998-12-06 00:00:00	32020		\N	13356	0	75498004	4294548		0
3610	207	4112343	2010-06-11	2010-06-11 00:00:00	2010-06-20	2010-06-20 00:00:00	32020		\N	14105	0	195662009	4112343		0
3731	213	40481087	1968-12-30	1968-12-30 00:00:00	1969-01-06	1969-01-06 00:00:00	32020		\N	14510	0	444814009	40481087		0
3899	224	140673	2016-09-24	2016-09-24 00:00:00	\N	\N	32020		\N	15027	0	40930008	140673		0
4075	236	260139	1978-01-01	1978-01-01 00:00:00	1978-01-08	1978-01-08 00:00:00	32020		\N	15902	0	10509002	260139		0
4239	245	260139	1917-05-16	1917-05-16 00:00:00	1917-05-30	1917-05-30 00:00:00	32020		\N	16420	0	10509002	260139		0
4431	260	372328	1974-03-05	1974-03-05 00:00:00	1974-06-22	1974-06-22 00:00:00	32020		\N	17184	0	65363002	372328		0
4556	266	40481087	2004-02-23	2004-02-23 00:00:00	2004-03-15	2004-03-15 00:00:00	32020		\N	17733	0	444814009	40481087		0
4742	279	260139	1997-03-03	1997-03-03 00:00:00	1997-03-10	1997-03-10 00:00:00	32020		\N	18593	0	10509002	260139		0
4885	287	40481087	1994-08-02	1994-08-02 00:00:00	1994-08-09	1994-08-09 00:00:00	32020		\N	19181	0	444814009	40481087		0
5071	298	4152936	2010-06-18	2010-06-18 00:00:00	2010-07-02	2010-07-02 00:00:00	32020		\N	19885	0	283385000	4152936		0
5224	308	81151	1962-02-05	1962-02-05 00:00:00	1962-03-05	1962-03-05 00:00:00	32020		\N	20399	0	44465007	81151		0
5422	320	4218389	1968-07-27	1968-07-27 00:00:00	1968-08-31	1968-08-31 00:00:00	32020		\N	21234	0	39848009	4218389		0
5595	331	40481087	1963-11-20	1963-11-20 00:00:00	1963-11-27	1963-11-27 00:00:00	32020		\N	21819	0	444814009	40481087		0
5733	337	40481087	1978-12-05	1978-12-05 00:00:00	1978-12-19	1978-12-19 00:00:00	32020		\N	22458	0	444814009	40481087		0
5901	348	40481087	1978-05-10	1978-05-10 00:00:00	1978-05-17	1978-05-17 00:00:00	32020		\N	23130	0	444814009	40481087		0
6055	357	81893	1994-04-01	1994-04-01 00:00:00	\N	\N	32020		\N	23745	0	64766004	81893		0
6217	366	28060	2011-12-23	2011-12-23 00:00:00	2012-01-04	2012-01-04 00:00:00	32020		\N	24346	0	43878008	28060		0
6380	376	4285898	1998-12-09	1998-12-09 00:00:00	\N	\N	32020		\N	24951	0	68496003	4285898		0
6594	388	4112343	1962-12-12	1962-12-12 00:00:00	1962-12-20	1962-12-20 00:00:00	32020		\N	25590	0	195662009	4112343		0
6707	395	260139	1982-02-22	1982-02-22 00:00:00	1982-03-08	1982-03-08 00:00:00	32020		\N	25953	0	10509002	260139		0
6880	404	40481087	1969-11-02	1969-11-02 00:00:00	1969-11-16	1969-11-16 00:00:00	32020		\N	26664	0	444814009	40481087		0
7039	412	372328	1955-03-17	1955-03-17 00:00:00	1955-04-22	1955-04-22 00:00:00	32020		\N	27472	0	65363002	372328		0
7254	426	4112343	1971-06-14	1971-06-14 00:00:00	1971-06-22	1971-06-22 00:00:00	32020		\N	28250	0	195662009	4112343		0
7370	432	28060	1994-02-20	1994-02-20 00:00:00	1994-03-04	1994-03-04 00:00:00	32020		\N	28737	0	43878008	28060		0
7545	443	372328	1970-01-10	1970-01-10 00:00:00	1970-02-23	1970-02-23 00:00:00	32020		\N	29453	0	65363002	372328		0
7714	453	260139	2014-04-18	2014-04-18 00:00:00	2014-04-25	2014-04-25 00:00:00	32020		\N	30187	0	10509002	260139		0
7895	461	4155034	2001-02-19	2001-02-19 00:00:00	2001-03-05	2001-03-05 00:00:00	32020		\N	30858	0	283371005	4155034		0
8058	472	40481087	2018-07-10	2018-07-10 00:00:00	2018-07-24	2018-07-24 00:00:00	32020		\N	31528	0	444814009	40481087		0
8223	480	4296204	1995-11-21	1995-11-21 00:00:00	1995-12-05	1995-12-05 00:00:00	32020		\N	31970	0	403190006	4296204		0
8376	487	40481087	2018-07-30	2018-07-30 00:00:00	2018-08-20	2018-08-20 00:00:00	32020		\N	32555	0	444814009	40481087		0
8556	499	260139	1973-05-20	1973-05-20 00:00:00	1973-06-03	1973-06-03 00:00:00	32020		\N	33318	0	10509002	260139		0
8733	510	260139	1984-09-27	1984-09-27 00:00:00	1984-10-11	1984-10-11 00:00:00	32020		\N	34070	0	10509002	260139		0
8891	520	40481087	1990-12-05	1990-12-05 00:00:00	1990-12-19	1990-12-19 00:00:00	32020		\N	34674	0	444814009	40481087		0
9056	533	40481087	2000-07-01	2000-07-01 00:00:00	2000-07-22	2000-07-22 00:00:00	32020		\N	35489	0	444814009	40481087		0
9239	546	260139	2004-01-21	2004-01-21 00:00:00	2004-01-28	2004-01-28 00:00:00	32020		\N	36245	0	10509002	260139		0
9365	552	40481087	1986-12-06	1986-12-06 00:00:00	1986-12-13	1986-12-13 00:00:00	32020		\N	36644	0	444814009	40481087		0
9543	565	40481087	1981-07-07	1981-07-07 00:00:00	1981-07-28	1981-07-28 00:00:00	32020		\N	37449	0	444814009	40481087		0
9695	573	81151	2013-07-17	2013-07-17 00:00:00	2013-08-14	2013-08-14 00:00:00	32020		\N	37983	0	44465007	81151		0
9865	582	4112343	1998-05-29	1998-05-29 00:00:00	1998-06-08	1998-06-08 00:00:00	32020		\N	38580	0	195662009	4112343		0
10088	598	4112343	2001-11-10	2001-11-10 00:00:00	2001-11-18	2001-11-18 00:00:00	32020		\N	39476	0	195662009	4112343		0
10221	605	40481087	1975-05-10	1975-05-10 00:00:00	1975-05-24	1975-05-24 00:00:00	32020		\N	40154	0	444814009	40481087		0
10360	610	40481087	1969-01-20	1969-01-20 00:00:00	1969-01-27	1969-01-27 00:00:00	32020		\N	40493	0	444814009	40481087		0
10560	621	40481087	1966-02-23	1966-02-23 00:00:00	1966-03-02	1966-03-02 00:00:00	32020		\N	41471	0	444814009	40481087		0
66	3	4112343	2004-01-18	2004-01-18 00:00:00	2004-01-26	2004-01-26 00:00:00	32020		\N	229	0	195662009	4112343		0
254	12	260139	1974-10-08	1974-10-08 00:00:00	1974-10-15	1974-10-15 00:00:00	32020		\N	1041	0	10509002	260139		0
432	23	4027663	2003-09-01	2003-09-01 00:00:00	\N	\N	32020		\N	1798	0	13200003	4027663		0
611	35	4116491	1997-03-13	1997-03-13 00:00:00	1997-04-29	1997-04-29 00:00:00	32020		\N	2406	0	301011002	4116491		0
751	41	372328	1978-05-30	1978-05-30 00:00:00	1978-11-04	1978-11-04 00:00:00	32020		\N	2946	0	65363002	372328		0
989	57	40481087	2005-07-27	2005-07-27 00:00:00	2005-08-17	2005-08-17 00:00:00	32020		\N	3847	0	444814009	40481087		0
1099	65	28060	2004-11-06	2004-11-06 00:00:00	2004-11-14	2004-11-14 00:00:00	32020		\N	4404	0	43878008	28060		0
1237	72	4112343	1965-10-10	1965-10-10 00:00:00	1965-10-21	1965-10-21 00:00:00	32020		\N	4915	0	195662009	4112343		0
1394	81	4112343	2003-06-11	2003-06-11 00:00:00	2003-06-20	2003-06-20 00:00:00	32020		\N	5486	0	195662009	4112343		0
1629	95	4156265	2013-06-02	2013-06-02 00:00:00	2013-06-23	2013-06-23 00:00:00	32020		\N	6468	0	370247008	4156265		0
1733	99	440448	1996-10-17	1996-10-17 00:00:00	\N	\N	32020		\N	6729	0	74400008	440448		0
1940	114	80180	2017-04-16	2017-04-16 00:00:00	\N	\N	32020		\N	7563	0	396275006	80180		0
2071	120	372328	1978-12-15	1978-12-15 00:00:00	1979-03-17	1979-03-17 00:00:00	32020		\N	7976	0	65363002	372328		0
2309	135	4310024	2008-09-03	2008-09-03 00:00:00	\N	\N	32020		\N	9077	0	424802006	4310024		0
2406	141	4132546	1985-03-24	1985-03-24 00:00:00	\N	\N	32020		\N	9483	0	275272006	4166590		0
2597	153	4109685	1970-02-09	1970-02-09 00:00:00	1970-02-23	1970-02-23 00:00:00	32020		\N	10318	0	284551006	4109685		0
2743	159	4218389	1962-04-07	1962-04-07 00:00:00	1962-04-28	1962-04-28 00:00:00	32020		\N	10918	0	39848009	4218389		0
2888	165	195588	2005-06-03	2005-06-03 00:00:00	2005-07-19	2005-07-19 00:00:00	32020		\N	11315	0	38822007	195588		0
3075	182	28060	1961-06-16	1961-06-16 00:00:00	1961-06-28	1961-06-28 00:00:00	32020		\N	12313	0	43878008	28060		0
3220	187	192671	1985-02-08	1985-02-08 00:00:00	\N	\N	32020		\N	12671	0	K92.2	35208414		0
3402	195	4134304	1997-08-15	1997-08-15 00:00:00	1997-11-13	1997-11-13 00:00:00	32020		\N	13422	0	263102004	4134304		0
3611	207	4112343	1973-09-10	1973-09-10 00:00:00	1973-09-23	1973-09-23 00:00:00	32020		\N	14113	0	195662009	4112343		0
3732	213	260139	2016-06-09	2016-06-09 00:00:00	2016-06-23	2016-06-23 00:00:00	32020		\N	14527	0	10509002	260139		0
3900	224	4109685	1996-02-19	1996-02-19 00:00:00	1996-03-04	1996-03-04 00:00:00	32020		\N	15109	0	284551006	4109685		0
4076	236	4112343	1983-02-11	1983-02-11 00:00:00	1983-02-19	1983-02-19 00:00:00	32020		\N	15903	0	195662009	4112343		0
4240	245	4230399	1984-02-25	1984-02-25 00:00:00	1984-04-25	1984-04-25 00:00:00	32020		\N	16402	0	359817006	4230399		0
4432	260	192671	2010-04-04	2010-04-04 00:00:00	\N	\N	32020		\N	17268	0	K92.2	35208414		0
4557	266	40481087	2016-10-08	2016-10-08 00:00:00	2016-10-15	2016-10-15 00:00:00	32020		\N	17735	0	444814009	40481087		0
4743	279	40481087	1996-10-19	1996-10-19 00:00:00	1996-11-02	1996-11-02 00:00:00	32020		\N	18592	0	444814009	40481087		0
4886	287	28060	1993-07-01	1993-07-01 00:00:00	1993-07-09	1993-07-09 00:00:00	32020		\N	19188	0	43878008	28060		0
5072	298	80180	1990-02-18	1990-02-18 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
5225	308	40481087	2004-12-16	2004-12-16 00:00:00	2004-12-23	2004-12-23 00:00:00	32020		\N	20424	0	444814009	40481087		0
5423	320	28060	1981-11-19	1981-11-19 00:00:00	1981-11-29	1981-11-29 00:00:00	32020		\N	21227	0	43878008	28060		0
5596	331	4294548	1983-10-23	1983-10-23 00:00:00	1984-01-22	1984-01-22 00:00:00	32020		\N	21821	0	75498004	4294548		0
5734	337	372328	1963-04-16	1963-04-16 00:00:00	1963-08-28	1963-08-28 00:00:00	32020		\N	22460	0	65363002	372328		0
5902	348	4237458	1990-01-10	1990-01-10 00:00:00	1990-04-10	1990-04-10 00:00:00	32020		\N	23116	0	58150001	4237458		0
6056	357	4113008	1961-11-05	1961-11-05 00:00:00	1961-11-19	1961-11-19 00:00:00	32020		\N	23635	0	284549007	4113008		0
6218	366	40481087	1980-01-24	1980-01-24 00:00:00	1980-02-07	1980-02-07 00:00:00	32020		\N	24275	0	444814009	40481087		0
6381	376	4112343	1983-11-27	1983-11-27 00:00:00	1983-12-06	1983-12-06 00:00:00	32020		\N	24903	0	195662009	4112343		0
6595	388	40486433	1956-09-20	1956-09-20 00:00:00	1973-09-18	1973-09-18 00:00:00	32020		\N	25578	0	446096008	40486433		0
6708	395	4112343	2019-03-09	2019-03-09 00:00:00	2019-03-19	2019-03-19 00:00:00	32020		\N	25956	0	195662009	4112343		0
6881	404	40481087	2018-02-11	2018-02-11 00:00:00	2018-02-18	2018-02-18 00:00:00	32020		\N	26595	0	444814009	40481087		0
7040	412	260139	1964-06-27	1964-06-27 00:00:00	1964-07-04	1964-07-04 00:00:00	32020		\N	27425	0	10509002	260139		0
7255	426	260139	2015-12-05	2015-12-05 00:00:00	2015-12-12	2015-12-12 00:00:00	32020		\N	28288	0	10509002	260139		0
7371	432	40481087	1992-12-18	1992-12-18 00:00:00	1992-12-25	1992-12-25 00:00:00	32020		\N	28725	0	444814009	40481087		0
7546	443	81151	1983-02-01	1983-02-01 00:00:00	1983-03-08	1983-03-08 00:00:00	32020		\N	29425	0	44465007	81151		0
7715	453	372328	1976-03-28	1976-03-28 00:00:00	1976-04-30	1976-04-30 00:00:00	32020		\N	30199	0	65363002	372328		0
7896	461	4112343	1966-08-01	1966-08-01 00:00:00	1966-08-11	1966-08-11 00:00:00	32020		\N	30826	0	195662009	4112343		0
8059	472	4112343	1996-09-20	1996-09-20 00:00:00	1996-10-01	1996-10-01 00:00:00	32020		\N	31514	0	195662009	4112343		0
8224	480	40481087	2003-12-09	2003-12-09 00:00:00	2003-12-30	2003-12-30 00:00:00	32020		\N	32032	0	444814009	40481087		0
8377	487	78272	2009-11-08	2009-11-08 00:00:00	2009-11-22	2009-11-22 00:00:00	32020		\N	32529	0	70704007	78272		0
8557	499	4084167	1972-03-18	1972-03-18 00:00:00	1972-03-19	1972-03-19 00:00:00	32020		\N	33417	0	241929008	4084167		0
8734	510	4027663	1999-09-24	1999-09-24 00:00:00	\N	\N	32020		\N	34103	0	13200003	4027663		0
8892	520	28060	1971-07-08	1971-07-08 00:00:00	1971-07-17	1971-07-17 00:00:00	32020		\N	34668	0	43878008	28060		0
9057	533	4112343	2015-07-22	2015-07-22 00:00:00	2015-07-30	2015-07-30 00:00:00	32020		\N	35374	0	195662009	4112343		0
9240	546	40481087	1991-09-22	1991-09-22 00:00:00	1991-09-29	1991-09-29 00:00:00	32020		\N	36201	0	444814009	40481087		0
9366	552	378001	1964-01-13	1964-01-13 00:00:00	1964-02-12	1964-02-12 00:00:00	32020		\N	36595	0	62106007	378001		0
9544	565	40481087	2002-10-17	2002-10-17 00:00:00	2002-10-31	2002-10-31 00:00:00	32020		\N	37418	0	444814009	40481087		0
9696	573	80180	1996-01-10	1996-01-10 00:00:00	\N	\N	32020		\N	37944	0	396275006	80180		0
9866	582	4285898	2004-04-11	2004-04-11 00:00:00	\N	\N	32020		\N	38572	0	68496003	4285898		0
10089	598	40481087	1988-10-11	1988-10-11 00:00:00	1988-10-18	1988-10-18 00:00:00	32020		\N	39479	0	444814009	40481087		0
10222	605	4048171	1959-06-22	1959-06-22 00:00:00	\N	\N	32020		\N	40114	0	232353008	4048171		0
10378	613	4116491	1988-12-25	1988-12-25 00:00:00	1989-02-05	1989-02-05 00:00:00	32020		\N	40729	0	301011002	4116491		0
10561	621	4112343	2013-07-24	2013-07-24 00:00:00	2013-08-04	2013-08-04 00:00:00	32020		\N	41460	0	195662009	4112343		0
67	3	317576	2012-09-24	2012-09-24 00:00:00	\N	\N	32020		\N	277	0	53741008	317576		0
255	12	40481087	1980-07-07	1980-07-07 00:00:00	1980-07-28	1980-07-28 00:00:00	32020		\N	1055	0	444814009	40481087		0
465	28	40481087	1982-05-27	1982-05-27 00:00:00	1982-06-03	1982-06-03 00:00:00	32020		\N	1980	0	444814009	40481087		0
612	35	257012	1989-04-06	1989-04-06 00:00:00	\N	\N	32020		\N	2427	0	40055000	257012		0
752	41	4296204	1999-07-05	1999-07-05 00:00:00	1999-07-19	1999-07-19 00:00:00	32020		\N	2893	0	403190006	4296204		0
990	57	440086	1973-06-16	1973-06-16 00:00:00	1979-06-25	1979-06-25 00:00:00	32020		\N	3845	0	192127007	440086		0
1100	65	4112343	1982-06-11	1982-06-11 00:00:00	1982-06-19	1982-06-19 00:00:00	32020		\N	4395	0	195662009	4112343		0
1238	72	4112343	1994-03-12	1994-03-12 00:00:00	1994-03-19	1994-03-19 00:00:00	32020		\N	4920	0	195662009	4112343		0
1395	81	40481087	1995-08-28	1995-08-28 00:00:00	1995-09-11	1995-09-11 00:00:00	32020		\N	5485	0	444814009	40481087		0
1630	95	372328	1962-10-08	1962-10-08 00:00:00	1963-08-15	1963-08-15 00:00:00	32020		\N	6404	0	65363002	372328		0
1734	99	4035415	1968-10-21	1968-10-21 00:00:00	1968-11-20	1968-11-20 00:00:00	32020		\N	6728	0	239720000	4035415		0
1941	115	4027663	1988-10-24	1988-10-24 00:00:00	\N	\N	32020		\N	7589	0	13200003	4027663		0
2072	120	4283893	1997-03-02	1997-03-02 00:00:00	1997-03-30	1997-03-30 00:00:00	32020		\N	7955	0	36971009	4283893		0
2310	135	4027663	2000-06-07	2000-06-07 00:00:00	\N	\N	32020		\N	9027	0	13200003	4027663		0
2407	141	4001336	1985-03-24	1985-03-24 00:00:00	1985-05-23	1985-05-23 00:00:00	32020		\N	9483	0	110030002	4001336		0
2598	153	40481087	2001-11-28	2001-11-28 00:00:00	2001-12-12	2001-12-12 00:00:00	32020		\N	10397	0	444814009	40481087		0
2744	159	78272	1963-05-23	1963-05-23 00:00:00	1963-06-27	1963-06-27 00:00:00	32020		\N	10919	0	70704007	78272		0
2889	165	40481087	2012-12-08	2012-12-08 00:00:00	2012-12-15	2012-12-15 00:00:00	32020		\N	11343	0	444814009	40481087		0
3076	182	40481087	1971-04-29	1971-04-29 00:00:00	1971-05-13	1971-05-13 00:00:00	32020		\N	12315	0	444814009	40481087		0
3221	187	4112343	1979-03-17	1979-03-17 00:00:00	1979-03-26	1979-03-26 00:00:00	32020		\N	12742	0	195662009	4112343		0
3403	195	260139	1974-04-01	1974-04-01 00:00:00	1974-04-15	1974-04-15 00:00:00	32020		\N	13400	0	10509002	260139		0
3612	207	81151	1961-08-31	1961-08-31 00:00:00	1961-10-05	1961-10-05 00:00:00	32020		\N	14131	0	44465007	81151		0
3733	213	4027663	1992-04-24	1992-04-24 00:00:00	\N	\N	32020		\N	14518	0	13200003	4027663		0
3901	224	40481087	1953-10-03	1953-10-03 00:00:00	1953-10-24	1953-10-24 00:00:00	32020		\N	15020	0	444814009	40481087		0
4077	236	4112343	1988-02-10	1988-02-10 00:00:00	1988-02-18	1988-02-18 00:00:00	32020		\N	15952	0	195662009	4112343		0
4241	245	28060	1987-10-18	1987-10-18 00:00:00	1987-10-31	1987-10-31 00:00:00	32020		\N	16427	0	43878008	28060		0
4433	260	40481087	1975-05-16	1975-05-16 00:00:00	1975-05-30	1975-05-30 00:00:00	32020		\N	17153	0	444814009	40481087		0
4558	266	4084167	1973-02-24	1973-02-24 00:00:00	1973-02-24	1973-02-24 00:00:00	32020		\N	17690	0	241929008	4084167		0
4744	279	4112343	1992-03-07	1992-03-07 00:00:00	1992-03-17	1992-03-17 00:00:00	32020		\N	18654	0	195662009	4112343		0
4887	287	4027663	2002-03-08	2002-03-08 00:00:00	\N	\N	32020		\N	19176	0	13200003	4027663		0
5073	298	40481087	2013-06-22	2013-06-22 00:00:00	2013-07-13	2013-07-13 00:00:00	32020		\N	19922	0	444814009	40481087		0
5226	308	260139	1964-11-09	1964-11-09 00:00:00	1964-11-16	1964-11-16 00:00:00	32020		\N	20457	0	10509002	260139		0
5424	320	260139	1984-10-10	1984-10-10 00:00:00	1984-10-17	1984-10-17 00:00:00	32020		\N	21230	0	10509002	260139		0
5597	331	40481087	2009-12-21	2009-12-21 00:00:00	2010-01-11	2010-01-11 00:00:00	32020		\N	21825	0	444814009	40481087		0
5735	337	372328	1960-01-21	1960-01-21 00:00:00	1960-03-02	1960-03-02 00:00:00	32020		\N	22424	0	65363002	372328		0
5903	348	28060	1986-03-16	1986-03-16 00:00:00	1986-03-27	1986-03-27 00:00:00	32020		\N	23141	0	43878008	28060		0
6057	357	440448	1997-10-04	1997-10-04 00:00:00	\N	\N	32020		\N	23639	0	74400008	440448		0
6219	366	372328	1912-01-15	1912-01-15 00:00:00	1912-04-28	1912-04-28 00:00:00	32020		\N	24312	0	65363002	372328		0
6382	376	40481087	1969-04-29	1969-04-29 00:00:00	1969-05-20	1969-05-20 00:00:00	32020		\N	24920	0	444814009	40481087		0
6596	388	4112343	1976-09-18	1976-09-18 00:00:00	1976-09-30	1976-09-30 00:00:00	32020		\N	25554	0	195662009	4112343		0
6709	395	4294548	1977-01-11	1977-01-11 00:00:00	1977-02-15	1977-02-15 00:00:00	32020		\N	25931	0	75498004	4294548		0
6882	404	260139	1988-02-10	1988-02-10 00:00:00	1988-02-17	1988-02-17 00:00:00	32020		\N	26680	0	10509002	260139		0
7041	412	81151	1958-03-20	1958-03-20 00:00:00	1958-04-03	1958-04-03 00:00:00	32020		\N	27407	0	44465007	81151		0
7256	426	40481087	2000-08-18	2000-08-18 00:00:00	2000-09-08	2000-09-08 00:00:00	32020		\N	28277	0	444814009	40481087		0
7372	432	81151	1979-06-15	1979-06-15 00:00:00	1979-07-20	1979-07-20 00:00:00	32020		\N	28714	0	44465007	81151		0
7547	443	28060	2015-03-01	2015-03-01 00:00:00	2015-03-13	2015-03-13 00:00:00	32020		\N	29478	0	43878008	28060		0
7716	453	40481087	1995-08-12	1995-08-12 00:00:00	1995-09-02	1995-09-02 00:00:00	32020		\N	30197	0	444814009	40481087		0
7897	461	4112343	2015-11-05	2015-11-05 00:00:00	2015-11-13	2015-11-13 00:00:00	32020		\N	30818	0	195662009	4112343		0
8060	472	260139	1979-04-10	1979-04-10 00:00:00	1979-04-17	1979-04-17 00:00:00	32020		\N	31535	0	10509002	260139		0
8225	480	40481087	1964-09-16	1964-09-16 00:00:00	1964-09-30	1964-09-30 00:00:00	32020		\N	32127	0	444814009	40481087		0
8378	487	40481087	2010-09-18	2010-09-18 00:00:00	2010-10-02	2010-10-02 00:00:00	32020		\N	32554	0	444814009	40481087		0
8558	499	372328	1961-12-09	1961-12-09 00:00:00	1962-03-30	1962-03-30 00:00:00	32020		\N	33401	0	65363002	372328		0
8735	510	4112343	1979-07-22	1979-07-22 00:00:00	1979-08-03	1979-08-03 00:00:00	32020		\N	34073	0	195662009	4112343		0
8893	520	40481087	1969-10-06	1969-10-06 00:00:00	1969-10-27	1969-10-27 00:00:00	32020		\N	34694	0	444814009	40481087		0
9058	533	4218389	1997-02-03	1997-02-03 00:00:00	1997-03-03	1997-03-03 00:00:00	32020		\N	35371	0	39848009	4218389		0
9241	546	439777	1987-11-03	1987-11-03 00:00:00	\N	\N	32020		\N	36155	0	271737000	439777		0
9367	552	4116491	1982-09-10	1982-09-10 00:00:00	1982-10-21	1982-10-21 00:00:00	32020		\N	36582	0	301011002	4116491		0
9545	565	40481087	1991-03-08	1991-03-08 00:00:00	1991-03-15	1991-03-15 00:00:00	32020		\N	37450	0	444814009	40481087		0
9697	573	40481087	1979-11-11	1979-11-11 00:00:00	1979-11-18	1979-11-18 00:00:00	32020		\N	37955	0	444814009	40481087		0
9867	582	80180	2005-02-05	2005-02-05 00:00:00	\N	\N	32020		\N	38572	0	396275006	80180		0
10090	598	81151	1987-02-14	1987-02-14 00:00:00	1987-02-28	1987-02-28 00:00:00	32020		\N	39477	0	44465007	81151		0
10223	605	40481087	1972-05-25	1972-05-25 00:00:00	1972-06-15	1972-06-15 00:00:00	32020		\N	40182	0	444814009	40481087		0
10379	613	192671	1977-02-09	1977-02-09 00:00:00	\N	\N	32020		\N	40694	0	K92.2	35208414		0
10562	621	28060	1926-04-21	1926-04-21 00:00:00	1926-04-29	1926-04-29 00:00:00	32020		\N	41447	0	43878008	28060		0
68	3	80502	1986-04-28	1986-04-28 00:00:00	\N	\N	32020		\N	253	0	64859006	80502		0
256	12	28060	1972-05-13	1972-05-13 00:00:00	1972-05-22	1972-05-22 00:00:00	32020		\N	1028	0	43878008	28060		0
466	28	4112343	1995-02-27	1995-02-27 00:00:00	1995-03-11	1995-03-11 00:00:00	32020		\N	1963	0	195662009	4112343		0
613	35	4112343	1992-04-15	1992-04-15 00:00:00	1992-04-23	1992-04-23 00:00:00	32020		\N	2429	0	195662009	4112343		0
753	41	40481087	1976-03-17	1976-03-17 00:00:00	1976-03-24	1976-03-24 00:00:00	32020		\N	2936	0	444814009	40481087		0
991	57	260139	1982-01-01	1982-01-01 00:00:00	1982-01-08	1982-01-08 00:00:00	32020		\N	3824	0	10509002	260139		0
1101	65	4283893	1996-05-19	1996-05-19 00:00:00	1996-07-28	1996-07-28 00:00:00	32020		\N	4396	0	36971009	4283893		0
1239	72	4112343	1989-10-02	1989-10-02 00:00:00	1989-10-13	1989-10-13 00:00:00	32020		\N	4918	0	195662009	4112343		0
1396	81	4112343	1963-09-14	1963-09-14 00:00:00	1963-09-21	1963-09-21 00:00:00	32020		\N	5529	0	195662009	4112343		0
1631	95	40481087	1968-08-24	1968-08-24 00:00:00	1968-08-31	1968-08-31 00:00:00	32020		\N	6417	0	444814009	40481087		0
1735	99	78272	2001-01-01	2001-01-01 00:00:00	2001-01-15	2001-01-15 00:00:00	32020		\N	6730	0	70704007	78272		0
1942	115	80180	2001-04-04	2001-04-04 00:00:00	\N	\N	32020		\N	7591	0	396275006	80180		0
2073	120	4112343	1981-08-22	1981-08-22 00:00:00	1981-09-01	1981-09-01 00:00:00	32020		\N	8001	0	195662009	4112343		0
2311	135	260139	2010-10-21	2010-10-21 00:00:00	2010-10-28	2010-10-28 00:00:00	32020		\N	9083	0	10509002	260139		0
2408	141	40481087	2012-11-05	2012-11-05 00:00:00	2012-11-12	2012-11-12 00:00:00	32020		\N	9459	0	444814009	40481087		0
2599	153	440086	1957-06-06	1957-06-06 00:00:00	1960-01-14	1960-01-14 00:00:00	32020		\N	10366	0	192127007	440086		0
2745	159	28060	1957-12-02	1957-12-02 00:00:00	1957-12-12	1957-12-12 00:00:00	32020		\N	10925	0	43878008	28060		0
2890	165	372328	1972-08-20	1972-08-20 00:00:00	1973-05-23	1973-05-23 00:00:00	32020		\N	11356	0	65363002	372328		0
3077	182	260139	1986-09-17	1986-09-17 00:00:00	1986-09-24	1986-09-24 00:00:00	32020		\N	12295	0	10509002	260139		0
3222	187	4112343	1978-11-05	1978-11-05 00:00:00	1978-11-16	1978-11-16 00:00:00	32020		\N	12741	0	195662009	4112343		0
3404	195	440086	1969-03-14	1969-03-14 00:00:00	1970-02-13	1970-02-13 00:00:00	32020		\N	13396	0	192127007	440086		0
3613	207	260139	1963-02-23	1963-02-23 00:00:00	1963-03-09	1963-03-09 00:00:00	32020		\N	14112	0	10509002	260139		0
3734	213	4112343	1990-01-31	1990-01-31 00:00:00	1990-02-08	1990-02-08 00:00:00	32020		\N	14518	0	195662009	4112343		0
3902	224	378001	2015-03-25	2015-03-25 00:00:00	2015-05-24	2015-05-24 00:00:00	32020		\N	15112	0	62106007	378001		0
4078	236	30753	1989-12-02	1989-12-02 00:00:00	\N	\N	32020		\N	15952	0	16761005	30753		0
4242	245	4112343	2002-10-14	2002-10-14 00:00:00	2002-10-26	2002-10-26 00:00:00	32020		\N	16485	0	195662009	4112343		0
4434	260	40481087	1974-12-20	1974-12-20 00:00:00	1975-01-10	1975-01-10 00:00:00	32020		\N	17197	0	444814009	40481087		0
4559	266	40481087	2011-03-11	2011-03-11 00:00:00	2011-04-01	2011-04-01 00:00:00	32020		\N	17660	0	444814009	40481087		0
4745	279	4112343	2000-01-19	2000-01-19 00:00:00	2000-01-27	2000-01-27 00:00:00	32020		\N	18641	0	195662009	4112343		0
4888	287	4112343	1978-01-04	1978-01-04 00:00:00	1978-01-17	1978-01-17 00:00:00	32020		\N	19177	0	195662009	4112343		0
5074	298	260139	1996-07-18	1996-07-18 00:00:00	1996-07-25	1996-07-25 00:00:00	32020		\N	19886	0	10509002	260139		0
5227	308	372328	1964-11-21	1964-11-21 00:00:00	1965-11-23	1965-11-23 00:00:00	32020		\N	20427	0	65363002	372328		0
5425	320	40481087	1956-08-25	1956-08-25 00:00:00	1956-09-15	1956-09-15 00:00:00	32020		\N	21206	0	444814009	40481087		0
5598	331	260139	2006-11-20	2006-11-20 00:00:00	2006-12-04	2006-12-04 00:00:00	32020		\N	21784	0	10509002	260139		0
5736	337	28060	1980-11-02	1980-11-02 00:00:00	1980-11-11	1980-11-11 00:00:00	32020		\N	22446	0	43878008	28060		0
5904	348	260139	2003-11-29	2003-11-29 00:00:00	2003-12-06	2003-12-06 00:00:00	32020		\N	23146	0	10509002	260139		0
6058	357	4155034	2016-08-23	2016-08-23 00:00:00	2016-09-13	2016-09-13 00:00:00	32020		\N	23640	0	283371005	4155034		0
6220	366	40481087	1959-06-15	1959-06-15 00:00:00	1959-06-22	1959-06-22 00:00:00	32020		\N	24273	0	444814009	40481087		0
6383	376	4112343	1998-08-19	1998-08-19 00:00:00	1998-08-28	1998-08-28 00:00:00	32020		\N	24919	0	195662009	4112343		0
6597	388	4112343	1956-04-07	1956-04-07 00:00:00	1956-04-15	1956-04-15 00:00:00	32020		\N	25524	0	195662009	4112343		0
6710	395	4112343	1984-12-24	1984-12-24 00:00:00	1985-01-04	1985-01-04 00:00:00	32020		\N	25987	0	195662009	4112343		0
6883	404	4112343	2002-01-06	2002-01-06 00:00:00	2002-01-14	2002-01-14 00:00:00	32020		\N	26592	0	195662009	4112343		0
7042	412	381316	2004-06-18	2004-06-18 00:00:00	\N	\N	32020		\N	27423	0	230690007	381316		0
7257	426	440448	2007-01-04	2007-01-04 00:00:00	\N	\N	32020		\N	28313	0	74400008	440448		0
7373	432	4283893	1986-05-18	1986-05-18 00:00:00	1986-06-15	1986-06-15 00:00:00	32020		\N	28669	0	36971009	4283893		0
7548	443	4155034	2006-03-19	2006-03-19 00:00:00	2006-04-03	2006-04-03 00:00:00	32020		\N	29430	0	283371005	4155034		0
7717	453	4027663	1997-05-08	1997-05-08 00:00:00	\N	\N	32020		\N	30214	0	13200003	4027663		0
7898	461	40481087	2000-09-07	2000-09-07 00:00:00	2000-09-28	2000-09-28 00:00:00	32020		\N	30814	0	444814009	40481087		0
8061	472	134438	1998-01-26	1998-01-26 00:00:00	1998-09-27	1998-09-27 00:00:00	32020		\N	31525	0	40275004	134438		0
8226	480	40481087	1953-08-03	1953-08-03 00:00:00	1953-08-17	1953-08-17 00:00:00	32020		\N	32126	0	444814009	40481087		0
8379	487	4294548	1993-11-10	1993-11-10 00:00:00	1994-04-06	1994-04-06 00:00:00	32020		\N	32531	0	75498004	4294548		0
8559	499	133834	1959-10-28	1959-10-28 00:00:00	1976-10-03	1976-10-03 00:00:00	32020		\N	33410	0	24079001	133834		0
8736	510	260139	2012-07-27	2012-07-27 00:00:00	2012-08-03	2012-08-03 00:00:00	32020		\N	34115	0	10509002	260139		0
8894	520	28060	2012-06-28	2012-06-28 00:00:00	2012-07-11	2012-07-11 00:00:00	32020		\N	34731	0	43878008	28060		0
9059	533	4155034	1988-08-05	1988-08-05 00:00:00	1988-08-19	1988-08-19 00:00:00	32020		\N	35370	0	283371005	4155034		0
9242	546	40481087	1995-02-17	1995-02-17 00:00:00	1995-03-03	1995-03-03 00:00:00	32020		\N	36202	0	444814009	40481087		0
9368	552	4112343	1963-04-12	1963-04-12 00:00:00	1963-04-19	1963-04-19 00:00:00	32020		\N	36580	0	195662009	4112343		0
9546	565	40481087	1973-10-05	1973-10-05 00:00:00	1973-10-12	1973-10-12 00:00:00	32020		\N	37436	0	444814009	40481087		0
9698	573	260139	2014-08-08	2014-08-08 00:00:00	2014-08-22	2014-08-22 00:00:00	32020		\N	37974	0	10509002	260139		0
9868	582	4266809	2005-02-05	2005-02-05 00:00:00	\N	\N	32020		\N	38572	0	397881000	4266809		0
10091	598	4027663	2001-09-13	2001-09-13 00:00:00	\N	\N	32020		\N	39488	0	13200003	4027663		0
10224	605	372328	1970-01-31	1970-01-31 00:00:00	1970-05-29	1970-05-29 00:00:00	32020		\N	40180	0	65363002	372328		0
10380	613	40481087	2002-02-12	2002-02-12 00:00:00	2002-03-05	2002-03-05 00:00:00	32020		\N	40730	0	444814009	40481087		0
10563	621	40481087	1942-05-06	1942-05-06 00:00:00	1942-05-13	1942-05-13 00:00:00	32020		\N	41430	0	444814009	40481087		0
69	3	192671	1958-01-29	1958-01-29 00:00:00	\N	\N	32020		\N	311	0	K92.2	35208414		0
257	12	40481087	1968-01-13	1968-01-13 00:00:00	1968-01-20	1968-01-20 00:00:00	32020		\N	1015	0	444814009	40481087		0
467	28	40481087	2009-03-22	2009-03-22 00:00:00	2009-03-29	2009-03-29 00:00:00	32020		\N	1957	0	444814009	40481087		0
614	35	260139	1978-11-14	1978-11-14 00:00:00	1978-11-28	1978-11-28 00:00:00	32020		\N	2403	0	10509002	260139		0
754	41	257012	2000-01-27	2000-01-27 00:00:00	\N	\N	32020		\N	2952	0	40055000	257012		0
992	57	260139	2013-02-24	2013-02-24 00:00:00	2013-03-10	2013-03-10 00:00:00	32020		\N	3852	0	10509002	260139		0
1102	65	4237458	2018-07-31	2018-07-31 00:00:00	2018-09-29	2018-09-29 00:00:00	32020		\N	4446	0	58150001	4237458		0
1240	72	80180	1984-12-26	1984-12-26 00:00:00	\N	\N	32020		\N	4894	0	396275006	80180		0
1397	81	440448	1984-03-15	1984-03-15 00:00:00	\N	\N	32020		\N	5508	0	74400008	440448		0
1632	95	4112343	1969-11-06	1969-11-06 00:00:00	1969-11-15	1969-11-15 00:00:00	32020		\N	6454	0	195662009	4112343		0
1736	99	40481087	1976-09-30	1976-09-30 00:00:00	1976-10-14	1976-10-14 00:00:00	32020		\N	6707	0	444814009	40481087		0
1943	115	4266809	2001-04-04	2001-04-04 00:00:00	\N	\N	32020		\N	7591	0	397881000	4266809		0
2074	120	4283893	1986-12-24	1986-12-24 00:00:00	1987-02-18	1987-02-18 00:00:00	32020		\N	7973	0	36971009	4283893		0
2312	135	260139	2016-05-15	2016-05-15 00:00:00	2016-05-22	2016-05-22 00:00:00	32020		\N	9034	0	10509002	260139		0
2426	143	40481087	1965-01-09	1965-01-09 00:00:00	1965-01-30	1965-01-30 00:00:00	32020		\N	9567	0	444814009	40481087		0
2600	153	4310024	1981-12-27	1981-12-27 00:00:00	\N	\N	32020		\N	10313	0	424802006	4310024		0
2746	159	80180	1989-08-28	1989-08-28 00:00:00	\N	\N	32020		\N	10902	0	396275006	80180		0
2891	165	4112343	2014-04-06	2014-04-06 00:00:00	2014-04-19	2014-04-19 00:00:00	32020		\N	11341	0	195662009	4112343		0
3078	182	4112343	2019-02-04	2019-02-04 00:00:00	2019-02-13	2019-02-13 00:00:00	32020		\N	12253	0	195662009	4112343		0
3223	187	40481087	2013-10-17	2013-10-17 00:00:00	2013-11-06	2013-11-06 00:00:00	32020		\N	12672	0	444814009	40481087		0
3405	195	4112343	2014-12-25	2014-12-25 00:00:00	2015-01-01	2015-01-01 00:00:00	32020		\N	13394	0	195662009	4112343		0
3614	207	372328	1945-10-08	1945-10-08 00:00:00	1946-09-08	1946-09-08 00:00:00	32020		\N	14108	0	65363002	372328		0
3735	213	260139	2004-06-16	2004-06-16 00:00:00	2004-06-23	2004-06-23 00:00:00	32020		\N	14524	0	10509002	260139		0
3903	225	40481087	1991-05-18	1991-05-18 00:00:00	1991-05-25	1991-05-25 00:00:00	32020		\N	15240	0	444814009	40481087		0
4079	236	4310024	1988-11-07	1988-11-07 00:00:00	\N	\N	32020		\N	15952	0	424802006	4310024		0
4243	245	372328	1920-06-10	1920-06-10 00:00:00	1921-05-29	1921-05-29 00:00:00	32020		\N	16430	0	65363002	372328		0
4435	260	78272	1986-04-28	1986-04-28 00:00:00	1986-06-02	1986-06-02 00:00:00	32020		\N	17266	0	70704007	78272		0
4560	266	375671	1986-05-17	1986-05-17 00:00:00	1986-06-16	1986-06-16 00:00:00	32020		\N	17693	0	62564004	375671		0
4746	279	4112343	1964-07-07	1964-07-07 00:00:00	1964-07-19	1964-07-19 00:00:00	32020		\N	18653	0	195662009	4112343		0
4889	287	40481087	2011-06-20	2011-06-20 00:00:00	2011-07-04	2011-07-04 00:00:00	32020		\N	19182	0	444814009	40481087		0
5075	298	40481087	2014-03-17	2014-03-17 00:00:00	2014-03-31	2014-03-31 00:00:00	32020		\N	19949	0	444814009	40481087		0
5228	308	4112343	2012-01-25	2012-01-25 00:00:00	2012-02-05	2012-02-05 00:00:00	32020		\N	20425	0	195662009	4112343		0
5426	320	260139	1971-09-14	1971-09-14 00:00:00	1971-09-21	1971-09-21 00:00:00	32020		\N	21229	0	10509002	260139		0
5599	331	4112343	2009-12-22	2009-12-22 00:00:00	2009-12-30	2009-12-30 00:00:00	32020		\N	21785	0	195662009	4112343		0
5737	337	4156265	2018-11-01	2018-11-01 00:00:00	2018-11-22	2018-11-22 00:00:00	32020		\N	22416	0	370247008	4156265		0
5905	348	260139	1994-12-16	1994-12-16 00:00:00	1994-12-30	1994-12-30 00:00:00	32020		\N	23142	0	10509002	260139		0
6059	357	40481087	1961-05-13	1961-05-13 00:00:00	1961-05-27	1961-05-27 00:00:00	32020		\N	23739	0	444814009	40481087		0
6221	366	195588	1951-02-09	1951-02-09 00:00:00	1951-03-13	1951-03-13 00:00:00	32020		\N	24269	0	38822007	195588		0
6384	376	4112343	1991-04-02	1991-04-02 00:00:00	1991-04-13	1991-04-13 00:00:00	32020		\N	24917	0	195662009	4112343		0
6598	388	4155034	2006-02-16	2006-02-16 00:00:00	2006-03-02	2006-03-02 00:00:00	32020		\N	25586	0	283371005	4155034		0
6712	395	4029498	1972-02-13	1972-02-13 00:00:00	\N	\N	32020		\N	25938	0	128613002	4029498		0
6884	404	80180	2001-12-21	2001-12-21 00:00:00	\N	\N	32020		\N	26552	0	396275006	80180		0
7043	412	372328	1955-08-20	1955-08-20 00:00:00	1955-10-21	1955-10-21 00:00:00	32020		\N	27429	0	65363002	372328		0
7288	430	4146173	1964-10-24	1964-10-24 00:00:00	1964-12-23	1964-12-23 00:00:00	32020		\N	28432	0	307731004	4146173		0
7374	432	40481087	1939-11-16	1939-11-16 00:00:00	1939-11-30	1939-11-30 00:00:00	32020		\N	28732	0	444814009	40481087		0
7549	443	4218389	1985-03-27	1985-03-27 00:00:00	1985-04-24	1985-04-24 00:00:00	32020		\N	29427	0	39848009	4218389		0
7718	453	81893	2003-04-02	2003-04-02 00:00:00	\N	\N	32020		\N	30216	0	64766004	81893		0
7899	461	28060	1958-03-06	1958-03-06 00:00:00	1958-03-15	1958-03-15 00:00:00	32020		\N	30828	0	43878008	28060		0
8062	472	28060	1983-12-16	1983-12-16 00:00:00	1983-12-25	1983-12-25 00:00:00	32020		\N	31513	0	43878008	28060		0
8227	480	260139	2010-05-02	2010-05-02 00:00:00	2010-05-16	2010-05-16 00:00:00	32020		\N	32033	0	10509002	260139		0
8380	487	260139	1995-11-29	1995-11-29 00:00:00	1995-12-13	1995-12-13 00:00:00	32020		\N	32532	0	10509002	260139		0
8560	499	260139	1963-10-01	1963-10-01 00:00:00	1963-10-15	1963-10-15 00:00:00	32020		\N	33358	0	10509002	260139		0
8737	510	4218389	2012-02-05	2012-02-05 00:00:00	2012-02-26	2012-02-26 00:00:00	32020		\N	34084	0	39848009	4218389		0
8895	520	4109685	1980-12-30	1980-12-30 00:00:00	1981-01-20	1981-01-20 00:00:00	32020		\N	34745	0	284551006	4109685		0
9060	533	4048171	1966-08-07	1966-08-07 00:00:00	1981-08-05	1981-08-05 00:00:00	32020		\N	35425	0	232353008	4048171		0
9243	546	4027663	1972-11-06	1972-11-06 00:00:00	\N	\N	32020		\N	36252	0	13200003	4027663		0
9369	552	4027663	1977-09-11	1977-09-11 00:00:00	\N	\N	32020		\N	36568	0	13200003	4027663		0
9547	565	372328	1962-06-13	1962-06-13 00:00:00	1962-10-17	1962-10-17 00:00:00	32020		\N	37424	0	65363002	372328		0
9699	573	260139	1964-03-10	1964-03-10 00:00:00	1964-03-24	1964-03-24 00:00:00	32020		\N	37969	0	10509002	260139		0
9869	582	4112343	2004-04-11	2004-04-11 00:00:00	2004-04-21	2004-04-21 00:00:00	32020		\N	38572	0	195662009	4112343		0
10092	598	192671	2010-01-22	2010-01-22 00:00:00	\N	\N	32020		\N	39523	0	K92.2	35208414		0
10225	605	78272	2015-04-19	2015-04-19 00:00:00	2015-05-10	2015-05-10 00:00:00	32020		\N	40165	0	70704007	78272		0
10381	613	40481087	1986-03-30	1986-03-30 00:00:00	1986-04-06	1986-04-06 00:00:00	32020		\N	40707	0	444814009	40481087		0
10564	621	40481087	1946-10-27	1946-10-27 00:00:00	1946-11-17	1946-11-17 00:00:00	32020		\N	41415	0	444814009	40481087		0
70	3	4112343	1959-09-17	1959-09-17 00:00:00	1959-09-26	1959-09-26 00:00:00	32020		\N	263	0	195662009	4112343		0
258	12	28060	1995-10-22	1995-10-22 00:00:00	1995-10-29	1995-10-29 00:00:00	32020		\N	1017	0	43878008	28060		0
468	28	4112343	1991-11-29	1991-11-29 00:00:00	1991-12-12	1991-12-12 00:00:00	32020		\N	1956	0	195662009	4112343		0
615	35	40481087	2002-01-18	2002-01-18 00:00:00	2002-01-25	2002-01-25 00:00:00	32020		\N	2434	0	444814009	40481087		0
755	41	4280726	1977-06-01	1977-06-01 00:00:00	\N	\N	32020		\N	2919	0	367498001	4280726		0
993	57	4112343	2008-06-04	2008-06-04 00:00:00	2008-06-14	2008-06-14 00:00:00	32020		\N	3872	0	195662009	4112343		0
1103	65	260139	2005-09-21	2005-09-21 00:00:00	2005-10-05	2005-10-05 00:00:00	32020		\N	4397	0	10509002	260139		0
1241	72	40481087	2005-06-20	2005-06-20 00:00:00	2005-07-11	2005-07-11 00:00:00	32020		\N	4862	0	444814009	40481087		0
1399	81	40481087	1995-03-01	1995-03-01 00:00:00	1995-03-22	1995-03-22 00:00:00	32020		\N	5484	0	444814009	40481087		0
1633	95	40481087	1964-05-01	1964-05-01 00:00:00	1964-05-08	1964-05-08 00:00:00	32020		\N	6396	0	444814009	40481087		0
1737	99	4112343	2008-06-28	2008-06-28 00:00:00	2008-07-08	2008-07-08 00:00:00	32020		\N	6721	0	195662009	4112343		0
1944	115	257012	1962-09-22	1962-09-22 00:00:00	\N	\N	32020		\N	7593	0	40055000	257012		0
2075	120	81151	1979-12-28	1979-12-28 00:00:00	1980-01-18	1980-01-18 00:00:00	32020		\N	7968	0	44465007	81151		0
2313	135	80180	2009-11-27	2009-11-27 00:00:00	\N	\N	32020		\N	9078	0	396275006	80180		0
2427	143	80180	1999-01-17	1999-01-17 00:00:00	\N	\N	32020		\N	9593	0	396275006	80180		0
2601	153	81893	1982-03-27	1982-03-27 00:00:00	\N	\N	32020		\N	10313	0	64766004	81893		0
2747	159	4142905	1984-04-05	1984-04-05 00:00:00	1984-06-04	1984-06-04 00:00:00	32020		\N	10921	0	33737001	4142905		0
2926	170	40481087	1979-03-29	1979-03-29 00:00:00	1979-04-19	1979-04-19 00:00:00	32020		\N	11568	0	444814009	40481087		0
3079	182	40481087	1976-03-23	1976-03-23 00:00:00	1976-04-06	1976-04-06 00:00:00	32020		\N	12316	0	444814009	40481087		0
3224	188	4146173	1985-11-01	1985-11-01 00:00:00	1985-12-01	1985-12-01 00:00:00	32020		\N	12772	0	307731004	4146173		0
3406	195	4112343	2004-05-29	2004-05-29 00:00:00	2004-06-05	2004-06-05 00:00:00	32020		\N	13392	0	195662009	4112343		0
3615	207	4112343	2008-04-06	2008-04-06 00:00:00	2008-04-18	2008-04-18 00:00:00	32020		\N	14100	0	195662009	4112343		0
3736	213	28060	1967-12-01	1967-12-01 00:00:00	1967-12-12	1967-12-12 00:00:00	32020		\N	14498	0	43878008	28060		0
3904	225	4048171	1969-01-10	1969-01-10 00:00:00	1984-01-09	1984-01-09 00:00:00	32020		\N	15175	0	232353008	4048171		0
4080	236	260139	1985-05-02	1985-05-02 00:00:00	1985-05-09	1985-05-09 00:00:00	32020		\N	15881	0	10509002	260139		0
4244	245	40481087	1951-11-04	1951-11-04 00:00:00	1951-11-11	1951-11-11 00:00:00	32020		\N	16436	0	444814009	40481087		0
4436	260	4048171	1972-07-18	1972-07-18 00:00:00	1988-07-16	1988-07-16 00:00:00	32020		\N	17154	0	232353008	4048171		0
4561	266	4112343	1973-12-25	1973-12-25 00:00:00	1974-01-02	1974-01-02 00:00:00	32020		\N	17650	0	195662009	4112343		0
4747	279	260139	1965-12-05	1965-12-05 00:00:00	1965-12-12	1965-12-12 00:00:00	32020		\N	18633	0	10509002	260139		0
4890	287	81893	2011-09-03	2011-09-03 00:00:00	\N	\N	32020		\N	19182	0	64766004	81893		0
5076	298	260139	1967-02-24	1967-02-24 00:00:00	1967-03-10	1967-03-10 00:00:00	32020		\N	19894	0	10509002	260139		0
5229	308	40481087	1977-02-13	1977-02-13 00:00:00	1977-02-27	1977-02-27 00:00:00	32020		\N	20458	0	444814009	40481087		0
5427	320	40481087	2008-01-21	2008-01-21 00:00:00	2008-02-11	2008-02-11 00:00:00	32020		\N	21189	0	444814009	40481087		0
5600	331	4218389	1956-03-24	1956-03-24 00:00:00	1956-04-21	1956-04-21 00:00:00	32020		\N	21810	0	39848009	4218389		0
5738	337	4059173	1962-06-09	1962-06-09 00:00:00	1962-09-07	1962-09-07 00:00:00	32020		\N	22471	0	16114001	4059173		0
5906	348	4152936	2015-11-21	2015-11-21 00:00:00	2015-12-05	2015-12-05 00:00:00	32020		\N	23119	0	283385000	4152936		0
6060	357	375671	1975-03-11	1975-03-11 00:00:00	1975-04-10	1975-04-10 00:00:00	32020		\N	23637	0	62564004	375671		0
6222	366	4283893	1914-09-05	1914-09-05 00:00:00	1914-11-28	1914-11-28 00:00:00	32020		\N	24264	0	36971009	4283893		0
6385	376	4278672	1965-04-06	1965-04-06 00:00:00	1965-07-05	1965-07-05 00:00:00	32020		\N	24938	0	65966004	4278672		0
6602	390	40481087	1988-07-31	1988-07-31 00:00:00	1988-08-21	1988-08-21 00:00:00	32020		\N	25653	0	444814009	40481087		0
6725	398	40481087	1954-05-01	1954-05-01 00:00:00	1954-05-08	1954-05-08 00:00:00	32020		\N	26093	0	444814009	40481087		0
6885	404	4266809	2001-12-21	2001-12-21 00:00:00	\N	\N	32020		\N	26552	0	397881000	4266809		0
7044	412	4027663	1982-05-08	1982-05-08 00:00:00	\N	\N	32020		\N	27416	0	13200003	4027663		0
7289	430	40481087	2001-10-30	2001-10-30 00:00:00	2001-11-13	2001-11-13 00:00:00	32020		\N	28497	0	444814009	40481087		0
7375	432	40481087	2002-11-29	2002-11-29 00:00:00	2002-12-06	2002-12-06 00:00:00	32020		\N	28756	0	444814009	40481087		0
7550	443	40481087	2008-12-22	2008-12-22 00:00:00	2009-01-05	2009-01-05 00:00:00	32020		\N	29473	0	444814009	40481087		0
7719	453	30753	2003-06-01	2003-06-01 00:00:00	\N	\N	32020		\N	30216	0	16761005	30753		0
7900	461	80180	1985-01-04	1985-01-04 00:00:00	\N	\N	32020		\N	30839	0	396275006	80180		0
8063	472	4112343	2014-04-01	2014-04-01 00:00:00	2014-04-13	2014-04-13 00:00:00	32020		\N	31527	0	195662009	4112343		0
8228	480	260139	2013-09-12	2013-09-12 00:00:00	2013-09-19	2013-09-19 00:00:00	32020		\N	31984	0	10509002	260139		0
8381	487	4283893	2007-04-29	2007-04-29 00:00:00	2007-08-26	2007-08-26 00:00:00	32020		\N	32599	0	36971009	4283893		0
8561	499	4112343	2002-04-27	2002-04-27 00:00:00	2002-05-10	2002-05-10 00:00:00	32020		\N	33396	0	195662009	4112343		0
8738	510	4283893	1988-07-19	1988-07-19 00:00:00	1988-09-27	1988-09-27 00:00:00	32020		\N	34112	0	36971009	4283893		0
8896	520	4113008	1953-12-07	1953-12-07 00:00:00	1953-12-28	1953-12-28 00:00:00	32020		\N	34749	0	284549007	4113008		0
9061	533	372328	1968-02-01	1968-02-01 00:00:00	1968-07-17	1968-07-17 00:00:00	32020		\N	35448	0	65363002	372328		0
9244	546	4134304	2010-05-17	2010-05-17 00:00:00	2010-06-16	2010-06-16 00:00:00	32020		\N	36154	0	263102004	4134304		0
9370	552	40481087	1977-05-30	1977-05-30 00:00:00	1977-06-20	1977-06-20 00:00:00	32020		\N	36568	0	444814009	40481087		0
9579	569	40481087	1923-01-05	1923-01-05 00:00:00	1923-01-19	1923-01-19 00:00:00	32020		\N	37691	0	444814009	40481087		0
9700	573	28060	1974-01-22	1974-01-22 00:00:00	1974-02-03	1974-02-03 00:00:00	32020		\N	37970	0	43878008	28060		0
9870	582	4142905	2016-09-10	2016-09-10 00:00:00	2016-10-10	2016-10-10 00:00:00	32020		\N	38557	0	33737001	4142905		0
10093	598	372328	1977-01-07	1977-01-07 00:00:00	1977-02-25	1977-02-25 00:00:00	32020		\N	39504	0	65363002	372328		0
10226	605	4112343	2000-10-28	2000-10-28 00:00:00	2000-11-09	2000-11-09 00:00:00	32020		\N	40187	0	195662009	4112343		0
10382	613	4112343	1973-09-26	1973-09-26 00:00:00	1973-10-05	1973-10-05 00:00:00	32020		\N	40728	0	195662009	4112343		0
10565	621	4112343	1947-06-30	1947-06-30 00:00:00	1947-07-10	1947-07-10 00:00:00	32020		\N	41450	0	195662009	4112343		0
71	3	40480160	2010-08-27	2010-08-27 00:00:00	2010-10-26	2010-10-26 00:00:00	32020		\N	314	0	443165006	40480160		0
259	12	80180	2008-04-08	2008-04-08 00:00:00	\N	\N	32020		\N	1039	0	396275006	80180		0
469	28	4112343	1983-05-15	1983-05-15 00:00:00	1983-05-27	1983-05-27 00:00:00	32020		\N	1978	0	195662009	4112343		0
616	35	4112343	2011-01-05	2011-01-05 00:00:00	2011-01-18	2011-01-18 00:00:00	32020		\N	2449	0	195662009	4112343		0
756	41	4112343	1974-08-20	1974-08-20 00:00:00	1974-09-02	1974-09-02 00:00:00	32020		\N	2906	0	195662009	4112343		0
11463	677	40481087	1965-08-11	1965-08-11 00:00:00	1965-08-25	1965-08-25 00:00:00	32020		\N	44784	0	444814009	40481087		0
1104	65	40481087	1968-07-29	1968-07-29 00:00:00	1968-08-19	1968-08-19 00:00:00	32020		\N	4417	0	444814009	40481087		0
1242	72	4156265	1964-11-11	1964-11-11 00:00:00	1964-11-25	1964-11-25 00:00:00	32020		\N	4855	0	370247008	4156265		0
1400	81	4112343	1993-07-18	1993-07-18 00:00:00	1993-07-31	1993-07-31 00:00:00	32020		\N	5483	0	195662009	4112343		0
1634	96	381316	1989-09-16	1989-09-16 00:00:00	\N	\N	32020		\N	6493	0	230690007	381316		0
1738	99	261325	1995-12-23	1995-12-23 00:00:00	\N	\N	32020		\N	6764	0	87433001	261325		0
1945	115	28060	1983-11-08	1983-11-08 00:00:00	1983-11-15	1983-11-15 00:00:00	32020		\N	7615	0	43878008	28060		0
2076	120	378001	1983-01-02	1983-01-02 00:00:00	1983-03-03	1983-03-03 00:00:00	32020		\N	7969	0	62106007	378001		0
2314	135	4266809	2009-11-27	2009-11-27 00:00:00	\N	\N	32020		\N	9078	0	397881000	4266809		0
2428	143	260139	1982-10-29	1982-10-29 00:00:00	1982-11-12	1982-11-12 00:00:00	32020		\N	9549	0	10509002	260139		0
2602	153	28060	1943-09-11	1943-09-11 00:00:00	1943-09-18	1943-09-18 00:00:00	32020		\N	10334	0	43878008	28060		0
2748	159	78272	2013-11-06	2013-11-06 00:00:00	2013-12-11	2013-12-11 00:00:00	32020		\N	10923	0	70704007	78272		0
2927	170	4116491	1996-01-29	1996-01-29 00:00:00	1996-03-18	1996-03-18 00:00:00	32020		\N	11577	0	301011002	4116491		0
3080	182	4112343	2011-10-01	2011-10-01 00:00:00	2011-10-13	2011-10-13 00:00:00	32020		\N	12252	0	195662009	4112343		0
3225	188	4027663	1991-11-11	1991-11-11 00:00:00	\N	\N	32020		\N	12806	0	13200003	4027663		0
3407	195	40481087	2016-09-01	2016-09-01 00:00:00	2016-09-15	2016-09-15 00:00:00	32020		\N	13359	0	444814009	40481087		0
3616	207	28060	2018-08-09	2018-08-09 00:00:00	2018-08-16	2018-08-16 00:00:00	32020		\N	14106	0	43878008	28060		0
3737	213	40481087	1989-03-17	1989-03-17 00:00:00	1989-04-07	1989-04-07 00:00:00	32020		\N	14517	0	444814009	40481087		0
3905	225	260139	2010-08-28	2010-08-28 00:00:00	2010-09-11	2010-09-11 00:00:00	32020		\N	15184	0	10509002	260139		0
4081	236	40481087	1994-03-27	1994-03-27 00:00:00	1994-04-10	1994-04-10 00:00:00	32020		\N	15908	0	444814009	40481087		0
4245	245	4296205	2005-10-30	2005-10-30 00:00:00	2005-11-20	2005-11-20 00:00:00	32020		\N	16405	0	403191005	4296205		0
4437	260	4266809	2010-03-19	2010-03-19 00:00:00	\N	\N	32020		\N	17209	0	397881000	4266809		0
4562	266	4230399	2018-09-26	2018-09-26 00:00:00	2018-11-25	2018-11-25 00:00:00	32020		\N	17694	0	359817006	4230399		0
4748	279	40481087	2018-09-16	2018-09-16 00:00:00	2018-09-30	2018-09-30 00:00:00	32020		\N	18656	0	444814009	40481087		0
4891	287	30753	2012-03-31	2012-03-31 00:00:00	\N	\N	32020		\N	19182	0	16761005	30753		0
5077	298	372328	1955-09-03	1955-09-03 00:00:00	1956-02-07	1956-02-07 00:00:00	32020		\N	19873	0	65363002	372328		0
5230	308	40481087	2004-07-30	2004-07-30 00:00:00	2004-08-13	2004-08-13 00:00:00	32020		\N	20470	0	444814009	40481087		0
5428	320	192671	1995-10-19	1995-10-19 00:00:00	\N	\N	32020		\N	21180	0	K92.2	35208414		0
5601	331	81151	1948-08-28	1948-08-28 00:00:00	1948-10-02	1948-10-02 00:00:00	32020		\N	21809	0	44465007	81151		0
5739	337	260139	1986-02-04	1986-02-04 00:00:00	1986-02-18	1986-02-18 00:00:00	32020		\N	22455	0	10509002	260139		0
5907	348	80180	2010-07-09	2010-07-09 00:00:00	\N	\N	32020		\N	23152	0	396275006	80180		0
6061	357	40481087	2003-12-16	2003-12-16 00:00:00	2004-01-06	2004-01-06 00:00:00	32020		\N	23622	0	444814009	40481087		0
6223	366	4149245	1954-11-21	1954-11-21 00:00:00	1954-12-28	1954-12-28 00:00:00	32020		\N	24353	0	30832001	4149245		0
6386	376	81151	2014-04-01	2014-04-01 00:00:00	2014-05-06	2014-05-06 00:00:00	32020		\N	24942	0	44465007	81151		0
6603	390	40481087	1992-05-04	1992-05-04 00:00:00	1992-05-18	1992-05-18 00:00:00	32020		\N	25613	0	444814009	40481087		0
6726	398	260139	1925-02-26	1925-02-26 00:00:00	1925-03-05	1925-03-05 00:00:00	32020		\N	26067	0	10509002	260139		0
6887	406	40481087	2004-12-21	2004-12-21 00:00:00	2005-01-11	2005-01-11 00:00:00	32020		\N	26772	0	444814009	40481087		0
7045	412	260139	1960-01-11	1960-01-11 00:00:00	1960-01-18	1960-01-18 00:00:00	32020		\N	27424	0	10509002	260139		0
7290	430	40481087	1954-07-22	1954-07-22 00:00:00	1954-07-29	1954-07-29 00:00:00	32020		\N	28455	0	444814009	40481087		0
7376	432	40481087	2011-09-29	2011-09-29 00:00:00	2011-10-20	2011-10-20 00:00:00	32020		\N	28757	0	444814009	40481087		0
7551	443	260139	1980-11-15	1980-11-15 00:00:00	1980-11-29	1980-11-29 00:00:00	32020		\N	29475	0	10509002	260139		0
7720	453	4112343	2017-05-19	2017-05-19 00:00:00	2017-05-29	2017-05-29 00:00:00	32020		\N	30250	0	195662009	4112343		0
7901	461	28060	1954-07-15	1954-07-15 00:00:00	1954-07-24	1954-07-24 00:00:00	32020		\N	30806	0	43878008	28060		0
8064	472	4134304	2003-06-16	2003-06-16 00:00:00	2003-08-15	2003-08-15 00:00:00	32020		\N	31547	0	263102004	4134304		0
8248	482	260139	1991-05-09	1991-05-09 00:00:00	1991-05-23	1991-05-23 00:00:00	32020		\N	32200	0	10509002	260139		0
8382	487	40481087	2000-05-09	2000-05-09 00:00:00	2000-05-23	2000-05-23 00:00:00	32020		\N	32542	0	444814009	40481087		0
8562	499	4113008	1987-02-26	1987-02-26 00:00:00	1987-03-12	1987-03-12 00:00:00	32020		\N	33418	0	284549007	4113008		0
8742	512	260139	1963-10-02	1963-10-02 00:00:00	1963-10-16	1963-10-16 00:00:00	32020		\N	34200	0	10509002	260139		0
8897	520	260139	1964-07-08	1964-07-08 00:00:00	1964-07-15	1964-07-15 00:00:00	32020		\N	34663	0	10509002	260139		0
9062	533	4155034	1971-04-16	1971-04-16 00:00:00	1971-05-07	1971-05-07 00:00:00	32020		\N	35368	0	283371005	4155034		0
9245	546	260139	1946-02-03	1946-02-03 00:00:00	1946-02-10	1946-02-10 00:00:00	32020		\N	36207	0	10509002	260139		0
9371	552	28060	1955-04-15	1955-04-15 00:00:00	1955-04-22	1955-04-22 00:00:00	32020		\N	36641	0	43878008	28060		0
9580	569	40481087	2014-11-02	2014-11-02 00:00:00	2014-11-16	2014-11-16 00:00:00	32020		\N	37591	0	444814009	40481087		0
9701	573	260139	1971-04-08	1971-04-08 00:00:00	1971-04-22	1971-04-22 00:00:00	32020		\N	37954	0	10509002	260139		0
9871	582	40481087	1966-10-30	1966-10-30 00:00:00	1966-11-20	1966-11-20 00:00:00	32020		\N	38530	0	444814009	40481087		0
10094	598	260139	2014-10-21	2014-10-21 00:00:00	2014-10-28	2014-10-28 00:00:00	32020		\N	39480	0	10509002	260139		0
10227	605	260139	1987-03-09	1987-03-09 00:00:00	1987-03-16	1987-03-16 00:00:00	32020		\N	40184	0	10509002	260139		0
10383	613	40481087	1978-06-13	1978-06-13 00:00:00	1978-07-04	1978-07-04 00:00:00	32020		\N	40718	0	444814009	40481087		0
10566	621	372328	1915-11-04	1915-11-04 00:00:00	1916-01-26	1916-01-26 00:00:00	32020		\N	41367	0	65363002	372328		0
72	3	4278672	2010-08-27	2010-08-27 00:00:00	2010-10-26	2010-10-26 00:00:00	32020		\N	314	0	65966004	4278672		0
260	12	4266809	2008-04-08	2008-04-08 00:00:00	\N	\N	32020		\N	1039	0	397881000	4266809		0
470	28	4112343	1985-03-19	1985-03-19 00:00:00	1985-04-01	1985-04-01 00:00:00	32020		\N	1955	0	195662009	4112343		0
617	35	4027663	1990-03-15	1990-03-15 00:00:00	\N	\N	32020		\N	2446	0	13200003	4027663		0
757	41	260139	1989-09-24	1989-09-24 00:00:00	1989-10-08	1989-10-08 00:00:00	32020		\N	2940	0	10509002	260139		0
11464	677	4156265	1982-01-23	1982-01-23 00:00:00	1982-02-13	1982-02-13 00:00:00	32020		\N	44812	0	370247008	4156265		0
1105	65	260139	2001-09-15	2001-09-15 00:00:00	2001-09-22	2001-09-22 00:00:00	32020		\N	4421	0	10509002	260139		0
1243	72	4218389	1979-07-10	1979-07-10 00:00:00	1979-08-07	1979-08-07 00:00:00	32020		\N	4857	0	39848009	4218389		0
1401	81	40481087	1983-02-16	1983-02-16 00:00:00	1983-03-02	1983-03-02 00:00:00	32020		\N	5488	0	444814009	40481087		0
1635	96	4112343	1951-05-16	1951-05-16 00:00:00	1951-05-25	1951-05-25 00:00:00	32020		\N	6511	0	195662009	4112343		0
1753	101	4112343	1982-02-08	1982-02-08 00:00:00	1982-02-19	1982-02-19 00:00:00	32020		\N	6854	0	195662009	4112343		0
1946	115	4112343	2019-04-20	2019-04-20 00:00:00	2019-04-29	2019-04-29 00:00:00	32020		\N	7622	0	195662009	4112343		0
2102	123	317576	2006-08-23	2006-08-23 00:00:00	\N	\N	32020		\N	\N	0	53741008	317576		0
2315	135	40481087	1997-06-28	1997-06-28 00:00:00	1997-07-19	1997-07-19 00:00:00	32020		\N	9039	0	444814009	40481087		0
2429	143	40481087	2016-01-12	2016-01-12 00:00:00	2016-01-19	2016-01-19 00:00:00	32020		\N	9585	0	444814009	40481087		0
2603	153	378001	1978-04-26	1978-04-26 00:00:00	1978-06-25	1978-06-25 00:00:00	32020		\N	10320	0	62106007	378001		0
2749	159	4112343	1990-06-29	1990-06-29 00:00:00	1990-07-10	1990-07-10 00:00:00	32020		\N	10927	0	195662009	4112343		0
2928	170	4296204	2004-01-31	2004-01-31 00:00:00	2004-03-06	2004-03-06 00:00:00	32020		\N	11567	0	403190006	4296204		0
3081	182	40481087	1955-02-07	1955-02-07 00:00:00	1955-02-21	1955-02-21 00:00:00	32020		\N	12317	0	444814009	40481087		0
3226	188	260139	2012-04-08	2012-04-08 00:00:00	2012-04-22	2012-04-22 00:00:00	32020		\N	12828	0	10509002	260139		0
3408	195	40481087	1986-01-16	1986-01-16 00:00:00	1986-02-06	1986-02-06 00:00:00	32020		\N	13391	0	444814009	40481087		0
3617	207	372328	1941-03-19	1941-03-19 00:00:00	1941-06-01	1941-06-01 00:00:00	32020		\N	14107	0	65363002	372328		0
3738	213	4112343	1986-09-05	1986-09-05 00:00:00	1986-09-17	1986-09-17 00:00:00	32020		\N	14511	0	195662009	4112343		0
3906	225	4278672	1966-10-24	1966-10-24 00:00:00	1966-11-23	1966-11-23 00:00:00	32020		\N	15148	0	65966004	4278672		0
4082	236	4113008	1987-03-13	1987-03-13 00:00:00	1987-03-27	1987-03-27 00:00:00	32020		\N	15916	0	284549007	4113008		0
4246	245	40481087	1952-04-15	1952-04-15 00:00:00	1952-04-22	1952-04-22 00:00:00	32020		\N	16423	0	444814009	40481087		0
4438	260	80180	2010-03-19	2010-03-19 00:00:00	\N	\N	32020		\N	17209	0	396275006	80180		0
4563	266	4283893	2003-07-31	2003-07-31 00:00:00	2003-08-21	2003-08-21 00:00:00	32020		\N	17683	0	36971009	4283893		0
4749	279	40481087	1970-08-11	1970-08-11 00:00:00	1970-09-01	1970-09-01 00:00:00	32020		\N	18634	0	444814009	40481087		0
4892	287	378001	1990-06-30	1990-06-30 00:00:00	1990-08-29	1990-08-29 00:00:00	32020		\N	19217	0	62106007	378001		0
5078	298	260139	2004-11-11	2004-11-11 00:00:00	2004-11-18	2004-11-18 00:00:00	32020		\N	19871	0	10509002	260139		0
5231	308	40481087	2006-10-23	2006-10-23 00:00:00	2006-10-30	2006-10-30 00:00:00	32020		\N	20413	0	444814009	40481087		0
5429	320	4218389	1998-06-14	1998-06-14 00:00:00	1998-07-12	1998-07-12 00:00:00	32020		\N	21238	0	39848009	4218389		0
5602	331	378001	1946-09-08	1946-09-08 00:00:00	1946-11-07	1946-11-07 00:00:00	32020		\N	21808	0	62106007	378001		0
5740	337	260139	1991-08-06	1991-08-06 00:00:00	1991-08-13	1991-08-13 00:00:00	32020		\N	22422	0	10509002	260139		0
5908	348	40481087	2001-05-22	2001-05-22 00:00:00	2001-06-12	2001-06-12 00:00:00	32020		\N	23120	0	444814009	40481087		0
6062	357	4059173	1968-04-16	1968-04-16 00:00:00	1968-05-16	1968-05-16 00:00:00	32020		\N	23636	0	16114001	4059173		0
6224	366	260139	1983-02-22	1983-02-22 00:00:00	1983-03-08	1983-03-08 00:00:00	32020		\N	24342	0	10509002	260139		0
6387	376	4112343	2013-01-12	2013-01-12 00:00:00	2013-01-25	2013-01-25 00:00:00	32020		\N	24887	0	195662009	4112343		0
6604	390	28060	1988-06-10	1988-06-10 00:00:00	1988-06-23	1988-06-23 00:00:00	32020		\N	25605	0	43878008	28060		0
6727	398	4296205	1957-04-20	1957-04-20 00:00:00	1957-05-18	1957-05-18 00:00:00	32020		\N	26069	0	403191005	4296205		0
6888	406	40481087	1969-05-24	1969-05-24 00:00:00	1969-05-31	1969-05-31 00:00:00	32020		\N	26809	0	444814009	40481087		0
7046	412	4237458	1963-03-13	1963-03-13 00:00:00	1963-06-11	1963-06-11 00:00:00	32020		\N	27409	0	58150001	4237458		0
7291	430	372328	1933-06-20	1933-06-20 00:00:00	1933-11-25	1933-11-25 00:00:00	32020		\N	28477	0	65363002	372328		0
7377	432	440086	1938-05-31	1938-05-31 00:00:00	1940-06-04	1940-06-04 00:00:00	32020		\N	28644	0	192127007	440086		0
7552	443	28060	1979-09-24	1979-09-24 00:00:00	1979-10-03	1979-10-03 00:00:00	32020		\N	29434	0	43878008	28060		0
7721	453	4112343	2000-01-03	2000-01-03 00:00:00	2000-01-16	2000-01-16 00:00:00	32020		\N	30249	0	195662009	4112343		0
7902	461	4112343	1950-12-17	1950-12-17 00:00:00	1950-12-29	1950-12-29 00:00:00	32020		\N	30825	0	195662009	4112343		0
8065	472	4296205	1992-06-29	1992-06-29 00:00:00	1992-07-13	1992-07-13 00:00:00	32020		\N	31546	0	403191005	4296205		0
8249	482	4112343	1974-06-01	1974-06-01 00:00:00	1974-06-11	1974-06-11 00:00:00	32020		\N	32231	0	195662009	4112343		0
8383	487	4283893	1983-10-21	1983-10-21 00:00:00	1983-12-02	1983-12-02 00:00:00	32020		\N	32604	0	36971009	4283893		0
8563	499	260139	1989-08-29	1989-08-29 00:00:00	1989-09-12	1989-09-12 00:00:00	32020		\N	33320	0	10509002	260139		0
13479	795	4027663	1970-08-11	1970-08-11 00:00:00	\N	\N	32020		\N	52760	0	13200003	4027663		0
8743	512	40481087	1960-12-15	1960-12-15 00:00:00	1960-12-29	1960-12-29 00:00:00	32020		\N	34187	0	444814009	40481087		0
8898	520	40481087	1974-03-07	1974-03-07 00:00:00	1974-03-28	1974-03-28 00:00:00	32020		\N	34695	0	444814009	40481087		0
9063	533	4283893	1999-06-23	1999-06-23 00:00:00	1999-07-28	1999-07-28 00:00:00	32020		\N	35496	0	36971009	4283893		0
9246	546	4278672	1953-10-22	1953-10-22 00:00:00	1954-01-20	1954-01-20 00:00:00	32020		\N	36150	0	65966004	4278672		0
9372	552	4283893	1975-04-02	1975-04-02 00:00:00	1975-07-02	1975-07-02 00:00:00	32020		\N	36581	0	36971009	4283893		0
9581	569	260139	1964-05-21	1964-05-21 00:00:00	1964-06-04	1964-06-04 00:00:00	32020		\N	37694	0	10509002	260139		0
9702	573	4152936	1974-04-15	1974-04-15 00:00:00	1974-04-29	1974-04-29 00:00:00	32020		\N	37985	0	283385000	4152936		0
9872	582	4112343	1971-11-09	1971-11-09 00:00:00	1971-11-21	1971-11-21 00:00:00	32020		\N	38570	0	195662009	4112343		0
10104	600	4116491	1984-12-29	1984-12-29 00:00:00	1985-02-03	1985-02-03 00:00:00	32020		\N	39628	0	301011002	4116491		0
10228	605	4156265	1997-05-02	1997-05-02 00:00:00	1997-05-23	1997-05-23 00:00:00	32020		\N	40163	0	370247008	4156265		0
10384	613	80502	2016-05-27	2016-05-27 00:00:00	\N	\N	32020		\N	40683	0	64859006	80502		0
10567	621	4112343	1978-12-14	1978-12-14 00:00:00	1978-12-22	1978-12-22 00:00:00	32020		\N	41459	0	195662009	4112343		0
73	3	372328	2015-08-21	2015-08-21 00:00:00	2015-10-12	2015-10-12 00:00:00	32020		\N	299	0	65363002	372328		0
261	12	4134304	1986-11-16	1986-11-16 00:00:00	1986-12-16	1986-12-16 00:00:00	32020		\N	997	0	263102004	4134304		0
471	28	4156265	1991-06-30	1991-06-30 00:00:00	1991-07-21	1991-07-21 00:00:00	32020		\N	1992	0	370247008	4156265		0
618	35	40481087	1984-02-18	1984-02-18 00:00:00	1984-02-25	1984-02-25 00:00:00	32020		\N	2404	0	444814009	40481087		0
758	41	40481087	1977-10-21	1977-10-21 00:00:00	1977-11-11	1977-11-11 00:00:00	32020		\N	2978	0	444814009	40481087		0
11465	677	40481087	1975-05-02	1975-05-02 00:00:00	1975-05-23	1975-05-23 00:00:00	32020		\N	44785	0	444814009	40481087		0
1106	65	257012	1996-07-07	1996-07-07 00:00:00	\N	\N	32020		\N	4377	0	40055000	257012		0
1244	72	40481087	2003-05-06	2003-05-06 00:00:00	2003-05-27	2003-05-27 00:00:00	32020		\N	4921	0	444814009	40481087		0
1402	81	40481087	1986-05-21	1986-05-21 00:00:00	1986-06-11	1986-06-11 00:00:00	32020		\N	5519	0	444814009	40481087		0
1636	96	40481087	1933-11-16	1933-11-16 00:00:00	1933-12-07	1933-12-07 00:00:00	32020		\N	6549	0	444814009	40481087		0
1754	101	4218389	2000-06-24	2000-06-24 00:00:00	2000-07-29	2000-07-29 00:00:00	32020		\N	6901	0	39848009	4218389		0
1947	115	4112343	2011-04-10	2011-04-10 00:00:00	2011-04-19	2011-04-19 00:00:00	32020		\N	7578	0	195662009	4112343		0
2103	123	372328	1956-01-11	1956-01-11 00:00:00	1956-03-28	1956-03-28 00:00:00	32020		\N	8125	0	65363002	372328		0
2316	135	4218389	2005-11-09	2005-11-09 00:00:00	2005-12-07	2005-12-07 00:00:00	32020		\N	9023	0	39848009	4218389		0
2430	143	40481087	2006-05-01	2006-05-01 00:00:00	2006-05-22	2006-05-22 00:00:00	32020		\N	9584	0	444814009	40481087		0
2604	153	4230399	1990-01-23	1990-01-23 00:00:00	1990-02-22	1990-02-22 00:00:00	32020		\N	10332	0	359817006	4230399		0
2750	159	260139	1971-12-17	1971-12-17 00:00:00	1971-12-31	1971-12-31 00:00:00	32020		\N	10856	0	10509002	260139		0
2929	170	372328	1971-12-31	1971-12-31 00:00:00	1972-04-13	1972-04-13 00:00:00	32020		\N	11536	0	65363002	372328		0
3082	182	260139	1984-03-17	1984-03-17 00:00:00	1984-03-31	1984-03-31 00:00:00	32020		\N	12277	0	10509002	260139		0
3227	188	78272	1986-10-27	1986-10-27 00:00:00	1986-11-10	1986-11-10 00:00:00	32020		\N	12784	0	70704007	78272		0
3409	195	260139	1970-01-14	1970-01-14 00:00:00	1970-01-21	1970-01-21 00:00:00	32020		\N	13417	0	10509002	260139		0
3618	207	4146173	1981-03-24	1981-03-24 00:00:00	1981-05-23	1981-05-23 00:00:00	32020		\N	14148	0	307731004	4146173		0
3739	213	81151	1993-06-27	1993-06-27 00:00:00	1993-08-01	1993-08-01 00:00:00	32020		\N	14536	0	44465007	81151		0
3907	225	4112343	1971-03-06	1971-03-06 00:00:00	1971-03-15	1971-03-15 00:00:00	32020		\N	15208	0	195662009	4112343		0
4083	236	372328	1951-09-18	1951-09-18 00:00:00	1951-11-29	1951-11-29 00:00:00	32020		\N	15919	0	65363002	372328		0
4247	245	40481087	1960-11-15	1960-11-15 00:00:00	1960-12-06	1960-12-06 00:00:00	32020		\N	16424	0	444814009	40481087		0
4439	260	4283893	1982-03-02	1982-03-02 00:00:00	1982-08-10	1982-08-10 00:00:00	32020		\N	17211	0	36971009	4283893		0
4564	266	40481087	2008-04-29	2008-04-29 00:00:00	2008-05-20	2008-05-20 00:00:00	32020		\N	17734	0	444814009	40481087		0
4750	279	375671	1992-12-08	1992-12-08 00:00:00	1993-02-06	1993-02-06 00:00:00	32020		\N	18636	0	62564004	375671		0
4893	287	40481087	1989-12-09	1989-12-09 00:00:00	1989-12-16	1989-12-16 00:00:00	32020		\N	19186	0	444814009	40481087		0
5079	298	78272	1982-07-26	1982-07-26 00:00:00	1982-08-23	1982-08-23 00:00:00	32020		\N	19883	0	70704007	78272		0
5232	308	260139	2016-11-25	2016-11-25 00:00:00	2016-12-09	2016-12-09 00:00:00	32020		\N	20414	0	10509002	260139		0
5430	320	195588	1977-02-13	1977-02-13 00:00:00	1977-04-08	1977-04-08 00:00:00	32020		\N	21187	0	38822007	195588		0
5603	331	260139	2004-03-27	2004-03-27 00:00:00	2004-04-03	2004-04-03 00:00:00	32020		\N	21824	0	10509002	260139		0
5741	337	40481087	1990-01-09	1990-01-09 00:00:00	1990-01-23	1990-01-23 00:00:00	32020		\N	22456	0	444814009	40481087		0
5909	348	40481087	1984-03-21	1984-03-21 00:00:00	1984-03-28	1984-03-28 00:00:00	32020		\N	23155	0	444814009	40481087		0
6063	357	4156265	1983-04-28	1983-04-28 00:00:00	1983-05-19	1983-05-19 00:00:00	32020		\N	23638	0	370247008	4156265		0
6225	366	260139	1966-10-18	1966-10-18 00:00:00	1966-11-01	1966-11-01 00:00:00	32020		\N	24321	0	10509002	260139		0
6388	376	4142905	1969-02-14	1969-02-14 00:00:00	1969-05-15	1969-05-15 00:00:00	32020		\N	24939	0	33737001	4142905		0
6605	390	260139	1989-10-20	1989-10-20 00:00:00	1989-10-27	1989-10-27 00:00:00	32020		\N	25654	0	10509002	260139		0
6728	398	4112343	1964-11-12	1964-11-12 00:00:00	1964-11-19	1964-11-19 00:00:00	32020		\N	26057	0	195662009	4112343		0
6889	406	260139	2014-10-08	2014-10-08 00:00:00	2014-10-22	2014-10-22 00:00:00	32020		\N	26857	0	10509002	260139		0
7047	412	4113008	1965-06-30	1965-06-30 00:00:00	1965-07-21	1965-07-21 00:00:00	32020		\N	27410	0	284549007	4113008		0
7292	430	195588	1978-06-08	1978-06-08 00:00:00	1978-07-28	1978-07-28 00:00:00	32020		\N	28517	0	38822007	195588		0
7378	432	381316	1974-12-02	1974-12-02 00:00:00	\N	\N	32020		\N	28689	0	230690007	381316		0
7553	443	40481087	1971-09-11	1971-09-11 00:00:00	1971-10-02	1971-10-02 00:00:00	32020		\N	29461	0	444814009	40481087		0
7722	453	40481087	1982-09-16	1982-09-16 00:00:00	1982-09-30	1982-09-30 00:00:00	32020		\N	30158	0	444814009	40481087		0
7903	461	40481087	1994-08-01	1994-08-01 00:00:00	1994-08-15	1994-08-15 00:00:00	32020		\N	30817	0	444814009	40481087		0
8066	472	40481087	2002-02-14	2002-02-14 00:00:00	2002-02-28	2002-02-28 00:00:00	32020		\N	31516	0	444814009	40481087		0
8250	482	4116491	1991-10-18	1991-10-18 00:00:00	1991-11-23	1991-11-23 00:00:00	32020		\N	32214	0	301011002	4116491		0
8384	487	40481087	1985-10-28	1985-10-28 00:00:00	1985-11-18	1985-11-18 00:00:00	32020		\N	32547	0	444814009	40481087		0
8564	499	4112343	2000-05-22	2000-05-22 00:00:00	2000-06-02	2000-06-02 00:00:00	32020		\N	33303	0	195662009	4112343		0
8744	512	260139	2001-09-12	2001-09-12 00:00:00	2001-09-26	2001-09-26 00:00:00	32020		\N	34205	0	10509002	260139		0
19450	1169	4112343	1955-01-12	1955-01-12 00:00:00	1955-01-25	1955-01-25 00:00:00	32020		\N	76967	0	195662009	4112343		0
9064	533	28060	1984-05-08	1984-05-08 00:00:00	1984-05-17	1984-05-17 00:00:00	32020		\N	35427	0	43878008	28060		0
9247	546	40481087	1953-05-21	1953-05-21 00:00:00	1953-05-28	1953-05-28 00:00:00	32020		\N	36175	0	444814009	40481087		0
9373	552	4112343	2012-12-12	2012-12-12 00:00:00	2012-12-24	2012-12-24 00:00:00	32020		\N	36664	0	195662009	4112343		0
9582	569	40481087	2006-09-29	2006-09-29 00:00:00	2006-10-20	2006-10-20 00:00:00	32020		\N	37590	0	444814009	40481087		0
9703	573	4112343	2009-06-09	2009-06-09 00:00:00	2009-06-16	2009-06-16 00:00:00	32020		\N	37973	0	195662009	4112343		0
9873	582	4310024	2002-06-21	2002-06-21 00:00:00	\N	\N	32020		\N	38540	0	424802006	4310024		0
10105	600	260139	1960-06-04	1960-06-04 00:00:00	1960-06-11	1960-06-11 00:00:00	32020		\N	39625	0	10509002	260139		0
10229	605	134438	1990-06-14	1990-06-14 00:00:00	1991-09-07	1991-09-07 00:00:00	32020		\N	40155	0	40275004	134438		0
10385	613	372328	1937-10-05	1937-10-05 00:00:00	1937-10-19	1937-10-19 00:00:00	32020		\N	40751	0	65363002	372328		0
10568	621	4283893	1929-02-21	1929-02-21 00:00:00	1929-06-06	1929-06-06 00:00:00	32020		\N	41448	0	36971009	4283893		0
74	3	378001	2017-02-21	2017-02-21 00:00:00	2017-03-23	2017-03-23 00:00:00	32020		\N	315	0	62106007	378001		0
262	12	40481087	1993-01-18	1993-01-18 00:00:00	1993-02-01	1993-02-01 00:00:00	32020		\N	1043	0	444814009	40481087		0
472	28	372328	1979-11-30	1979-11-30 00:00:00	1980-02-06	1980-02-06 00:00:00	32020		\N	1958	0	65363002	372328		0
619	35	4134304	1993-04-28	1993-04-28 00:00:00	1993-05-28	1993-05-28 00:00:00	32020		\N	2393	0	263102004	4134304		0
759	41	4112343	2006-02-27	2006-02-27 00:00:00	2006-03-11	2006-03-11 00:00:00	32020		\N	2911	0	195662009	4112343		0
11466	677	40481087	1987-05-28	1987-05-28 00:00:00	1987-06-11	1987-06-11 00:00:00	32020		\N	44807	0	444814009	40481087		0
1107	65	260139	1996-10-25	1996-10-25 00:00:00	1996-11-08	1996-11-08 00:00:00	32020		\N	4419	0	10509002	260139		0
1245	72	40481087	1957-11-19	1957-11-19 00:00:00	1957-11-26	1957-11-26 00:00:00	32020		\N	4833	0	444814009	40481087		0
1403	81	80180	1997-04-30	1997-04-30 00:00:00	\N	\N	32020		\N	5477	0	396275006	80180		0
1637	96	260139	1944-09-01	1944-09-01 00:00:00	1944-09-15	1944-09-15 00:00:00	32020		\N	6544	0	10509002	260139		0
1755	101	28060	2007-01-22	2007-01-22 00:00:00	2007-02-01	2007-02-01 00:00:00	32020		\N	6913	0	43878008	28060		0
1948	115	260139	1997-10-13	1997-10-13 00:00:00	1997-10-27	1997-10-27 00:00:00	32020		\N	7575	0	10509002	260139		0
2104	123	260139	1954-01-10	1954-01-10 00:00:00	1954-01-24	1954-01-24 00:00:00	32020		\N	8149	0	10509002	260139		0
2317	135	40481087	1991-01-09	1991-01-09 00:00:00	1991-01-23	1991-01-23 00:00:00	32020		\N	9038	0	444814009	40481087		0
2431	143	40481087	2007-12-18	2007-12-18 00:00:00	2008-01-08	2008-01-08 00:00:00	32020		\N	9574	0	444814009	40481087		0
2605	153	80180	1984-05-15	1984-05-15 00:00:00	\N	\N	32020		\N	10414	0	396275006	80180		0
2751	160	4294548	1985-11-20	1985-11-20 00:00:00	1986-05-14	1986-05-14 00:00:00	32020		\N	10961	0	75498004	4294548		0
2930	170	4112343	1992-09-06	1992-09-06 00:00:00	1992-09-15	1992-09-15 00:00:00	32020		\N	11533	0	195662009	4112343		0
3083	182	257012	1999-01-05	1999-01-05 00:00:00	1999-03-23	1999-03-23 00:00:00	32020		\N	12297	0	40055000	257012		0
3228	188	40481087	1967-08-03	1967-08-03 00:00:00	1967-08-10	1967-08-10 00:00:00	32020		\N	12771	0	444814009	40481087		0
3410	195	372328	1961-09-27	1961-09-27 00:00:00	1962-02-19	1962-02-19 00:00:00	32020		\N	13377	0	65363002	372328		0
3619	207	4112343	1940-12-20	1940-12-20 00:00:00	1940-12-31	1940-12-31 00:00:00	32020		\N	14115	0	195662009	4112343		0
3740	213	4266809	2003-09-09	2003-09-09 00:00:00	\N	\N	32020		\N	14501	0	397881000	4266809		0
3908	225	4112343	1974-07-29	1974-07-29 00:00:00	1974-08-08	1974-08-08 00:00:00	32020		\N	15163	0	195662009	4112343		0
4084	236	4134304	1983-12-29	1983-12-29 00:00:00	1984-03-28	1984-03-28 00:00:00	32020		\N	15915	0	263102004	4134304		0
4248	245	4283893	1978-01-18	1978-01-18 00:00:00	1978-03-15	1978-03-15 00:00:00	32020		\N	16439	0	36971009	4283893		0
4440	260	81151	1971-06-02	1971-06-02 00:00:00	1971-06-16	1971-06-16 00:00:00	32020		\N	17264	0	44465007	81151		0
4565	266	80180	2006-10-04	2006-10-04 00:00:00	\N	\N	32020		\N	17634	0	396275006	80180		0
4751	279	4112343	1953-10-21	1953-10-21 00:00:00	1953-10-29	1953-10-29 00:00:00	32020		\N	18614	0	195662009	4112343		0
4894	287	80180	2013-04-25	2013-04-25 00:00:00	\N	\N	32020		\N	19209	0	396275006	80180		0
5080	298	40481087	1966-08-08	1966-08-08 00:00:00	1966-08-22	1966-08-22 00:00:00	32020		\N	19917	0	444814009	40481087		0
5233	308	260139	1996-04-04	1996-04-04 00:00:00	1996-04-18	1996-04-18 00:00:00	32020		\N	20423	0	10509002	260139		0
5431	320	372328	1957-11-10	1957-11-10 00:00:00	1958-01-26	1958-01-26 00:00:00	32020		\N	21224	0	65363002	372328		0
5604	331	4112343	1993-01-28	1993-01-28 00:00:00	1993-02-06	1993-02-06 00:00:00	32020		\N	21860	0	195662009	4112343		0
5742	337	40481087	2012-12-30	2012-12-30 00:00:00	2013-01-13	2013-01-13 00:00:00	32020		\N	22448	0	444814009	40481087		0
5910	348	4296205	1994-03-25	1994-03-25 00:00:00	1994-04-15	1994-04-15 00:00:00	32020		\N	23118	0	403191005	4296205		0
6064	357	4112343	1983-11-16	1983-11-16 00:00:00	1983-11-24	1983-11-24 00:00:00	32020		\N	23703	0	195662009	4112343		0
6226	366	80180	1944-08-29	1944-08-29 00:00:00	\N	\N	32020		\N	24337	0	396275006	80180		0
6389	376	40481087	2001-05-06	2001-05-06 00:00:00	2001-05-20	2001-05-20 00:00:00	32020		\N	24905	0	444814009	40481087		0
6606	390	40481087	2003-11-22	2003-11-22 00:00:00	2003-12-06	2003-12-06 00:00:00	32020		\N	25606	0	444814009	40481087		0
6729	398	78272	1966-08-29	1966-08-29 00:00:00	1966-09-26	1966-09-26 00:00:00	32020		\N	26070	0	70704007	78272		0
6890	406	260139	2007-07-22	2007-07-22 00:00:00	2007-08-05	2007-08-05 00:00:00	32020		\N	26746	0	10509002	260139		0
7048	412	40481087	1975-10-06	1975-10-06 00:00:00	1975-10-20	1975-10-20 00:00:00	32020		\N	27462	0	444814009	40481087		0
7293	430	4001336	2006-09-19	2006-09-19 00:00:00	2006-10-19	2006-10-19 00:00:00	32020		\N	28542	0	110030002	4001336		0
7379	432	40481087	1957-02-03	1957-02-03 00:00:00	1957-02-24	1957-02-24 00:00:00	32020		\N	28735	0	444814009	40481087		0
7554	443	4113008	1991-06-23	1991-06-23 00:00:00	1991-07-07	1991-07-07 00:00:00	32020		\N	29428	0	284549007	4113008		0
7723	453	372328	1971-10-07	1971-10-07 00:00:00	1971-10-21	1971-10-21 00:00:00	32020		\N	30221	0	65363002	372328		0
7904	461	260139	1953-03-27	1953-03-27 00:00:00	1953-04-03	1953-04-03 00:00:00	32020		\N	30779	0	10509002	260139		0
8079	474	260139	2017-09-04	2017-09-04 00:00:00	2017-09-18	2017-09-18 00:00:00	32020		\N	31604	0	10509002	260139		0
8251	482	4112343	1990-03-18	1990-03-18 00:00:00	1990-03-25	1990-03-25 00:00:00	32020		\N	32217	0	195662009	4112343		0
8385	487	80180	2000-01-26	2000-01-26 00:00:00	\N	\N	32020		\N	32612	0	396275006	80180		0
8565	499	40481087	1998-05-28	1998-05-28 00:00:00	1998-06-04	1998-06-04 00:00:00	32020		\N	33337	0	444814009	40481087		0
8745	512	80180	1993-02-24	1993-02-24 00:00:00	\N	\N	32020		\N	34194	0	396275006	80180		0
19451	1169	78272	1952-02-08	1952-02-08 00:00:00	1952-03-07	1952-03-07 00:00:00	32020		\N	76984	0	70704007	78272		0
9065	533	4112343	2007-11-14	2007-11-14 00:00:00	2007-11-27	2007-11-27 00:00:00	32020		\N	35498	0	195662009	4112343		0
9248	546	4134304	1961-10-10	1961-10-10 00:00:00	1962-01-08	1962-01-08 00:00:00	32020		\N	36151	0	263102004	4134304		0
9374	552	372328	1952-03-16	1952-03-16 00:00:00	1952-06-03	1952-06-03 00:00:00	32020		\N	36650	0	65363002	372328		0
9583	569	4283893	2015-01-21	2015-01-21 00:00:00	2015-04-08	2015-04-08 00:00:00	32020		\N	37646	0	36971009	4283893		0
9704	573	28060	1960-03-03	1960-03-03 00:00:00	1960-03-11	1960-03-11 00:00:00	32020		\N	37967	0	43878008	28060		0
9874	582	260139	1973-09-17	1973-09-17 00:00:00	1973-10-01	1973-10-01 00:00:00	32020		\N	38571	0	10509002	260139		0
10106	600	81151	1994-11-07	1994-11-07 00:00:00	1994-11-28	1994-11-28 00:00:00	32020		\N	39648	0	44465007	81151		0
10230	605	4112343	1979-04-13	1979-04-13 00:00:00	1979-04-20	1979-04-20 00:00:00	32020		\N	40126	0	195662009	4112343		0
10386	613	40481087	1965-11-08	1965-11-08 00:00:00	1965-11-29	1965-11-29 00:00:00	32020		\N	40725	0	444814009	40481087		0
10569	621	4112343	1974-09-25	1974-09-25 00:00:00	1974-10-02	1974-10-02 00:00:00	32020		\N	41363	0	195662009	4112343		0
75	3	4278672	1986-10-04	1986-10-04 00:00:00	1986-12-03	1986-12-03 00:00:00	32020		\N	348	0	65966004	4278672		0
263	12	40481087	2013-02-12	2013-02-12 00:00:00	2013-03-05	2013-03-05 00:00:00	32020		\N	1021	0	444814009	40481087		0
473	28	80180	2015-05-10	2015-05-10 00:00:00	\N	\N	32020		\N	1995	0	396275006	80180		0
620	35	40481087	1970-02-01	1970-02-01 00:00:00	1970-02-15	1970-02-15 00:00:00	32020		\N	2395	0	444814009	40481087		0
760	41	80180	2008-07-31	2008-07-31 00:00:00	\N	\N	32020		\N	2911	0	396275006	80180		0
11467	677	40481087	1968-12-13	1968-12-13 00:00:00	1969-01-03	1969-01-03 00:00:00	32020		\N	44805	0	444814009	40481087		0
1108	65	40481087	1998-03-29	1998-03-29 00:00:00	1998-04-05	1998-04-05 00:00:00	32020		\N	4420	0	444814009	40481087		0
1246	72	78272	2008-06-19	2008-06-19 00:00:00	2008-07-17	2008-07-17 00:00:00	32020		\N	4859	0	70704007	78272		0
1404	81	40481087	1969-02-15	1969-02-15 00:00:00	1969-02-22	1969-02-22 00:00:00	32020		\N	5498	0	444814009	40481087		0
1638	96	260139	1962-05-22	1962-05-22 00:00:00	1962-05-29	1962-05-29 00:00:00	32020		\N	6551	0	10509002	260139		0
1756	101	260139	1932-04-23	1932-04-23 00:00:00	1932-05-07	1932-05-07 00:00:00	32020		\N	6910	0	10509002	260139		0
1949	115	40481087	1984-04-01	1984-04-01 00:00:00	1984-04-22	1984-04-22 00:00:00	32020		\N	7569	0	444814009	40481087		0
2105	123	40481087	2005-01-23	2005-01-23 00:00:00	2005-01-30	2005-01-30 00:00:00	32020		\N	8124	0	444814009	40481087		0
2323	137	40481087	1983-04-21	1983-04-21 00:00:00	1983-05-12	1983-05-12 00:00:00	32020		\N	9132	0	444814009	40481087		0
2432	143	28060	1979-05-20	1979-05-20 00:00:00	1979-05-29	1979-05-29 00:00:00	32020		\N	9568	0	43878008	28060		0
2606	153	4112343	1945-08-10	1945-08-10 00:00:00	1945-08-19	1945-08-19 00:00:00	32020		\N	10321	0	195662009	4112343		0
2752	160	260139	2019-04-02	2019-04-02 00:00:00	2019-04-16	2019-04-16 00:00:00	32020		\N	10966	0	10509002	260139		0
2931	170	4152936	1994-06-03	1994-06-03 00:00:00	1994-06-24	1994-06-24 00:00:00	32020		\N	11580	0	283385000	4152936		0
3084	182	4112343	1976-06-12	1976-06-12 00:00:00	1976-06-24	1976-06-24 00:00:00	32020		\N	12283	0	195662009	4112343		0
3229	188	260139	1988-10-22	1988-10-22 00:00:00	1988-10-29	1988-10-29 00:00:00	32020		\N	12773	0	10509002	260139		0
3411	195	40481087	1966-05-11	1966-05-11 00:00:00	1966-05-25	1966-05-25 00:00:00	32020		\N	13387	0	444814009	40481087		0
3620	207	4112343	1986-05-21	1986-05-21 00:00:00	1986-05-28	1986-05-28 00:00:00	32020		\N	14098	0	195662009	4112343		0
3741	213	40481087	2003-02-24	2003-02-24 00:00:00	2003-03-03	2003-03-03 00:00:00	32020		\N	14501	0	444814009	40481087		0
3909	225	81151	1973-08-09	1973-08-09 00:00:00	1973-08-30	1973-08-30 00:00:00	32020		\N	15150	0	44465007	81151		0
4085	236	40481087	1974-06-12	1974-06-12 00:00:00	1974-07-03	1974-07-03 00:00:00	32020		\N	15923	0	444814009	40481087		0
4249	245	378001	1922-04-18	1922-04-18 00:00:00	1922-06-17	1922-06-17 00:00:00	32020		\N	16441	0	62106007	378001		0
4456	262	4156265	2005-05-30	2005-05-30 00:00:00	2005-06-13	2005-06-13 00:00:00	32020		\N	17412	0	370247008	4156265		0
4566	266	28060	1999-04-22	1999-04-22 00:00:00	1999-05-05	1999-05-05 00:00:00	32020		\N	17659	0	43878008	28060		0
4752	279	40481087	1974-02-21	1974-02-21 00:00:00	1974-03-14	1974-03-14 00:00:00	32020		\N	18617	0	444814009	40481087		0
4895	287	40481087	2013-04-29	2013-04-29 00:00:00	2013-05-20	2013-05-20 00:00:00	32020		\N	19209	0	444814009	40481087		0
5081	298	372328	1974-09-30	1974-09-30 00:00:00	1976-07-27	1976-07-27 00:00:00	32020		\N	19924	0	65363002	372328		0
5234	308	80180	1999-02-26	1999-02-26 00:00:00	\N	\N	32020		\N	20423	0	396275006	80180		0
5432	320	28060	2008-10-09	2008-10-09 00:00:00	2008-10-22	2008-10-22 00:00:00	32020		\N	21239	0	43878008	28060		0
5605	331	372328	1936-10-23	1936-10-23 00:00:00	1937-04-08	1937-04-08 00:00:00	32020		\N	21786	0	65363002	372328		0
5743	337	78272	2013-10-23	2013-10-23 00:00:00	2013-11-27	2013-11-27 00:00:00	32020		\N	22415	0	70704007	78272		0
5911	348	78272	1991-05-05	1991-05-05 00:00:00	1991-06-09	1991-06-09 00:00:00	32020		\N	23117	0	70704007	78272		0
6065	357	40481087	1969-10-02	1969-10-02 00:00:00	1969-10-09	1969-10-09 00:00:00	32020		\N	23683	0	444814009	40481087		0
6227	366	30753	1943-12-03	1943-12-03 00:00:00	\N	\N	32020		\N	24337	0	16761005	30753		0
6390	376	28060	1972-01-01	1972-01-01 00:00:00	1972-01-13	1972-01-13 00:00:00	32020		\N	24901	0	43878008	28060		0
6607	390	40481087	1978-04-29	1978-04-29 00:00:00	1978-05-20	1978-05-20 00:00:00	32020		\N	25652	0	444814009	40481087		0
6730	398	4218389	1941-08-30	1941-08-30 00:00:00	1941-09-20	1941-09-20 00:00:00	32020		\N	26105	0	39848009	4218389		0
6891	406	260139	2011-05-23	2011-05-23 00:00:00	2011-05-30	2011-05-30 00:00:00	32020		\N	26856	0	10509002	260139		0
7049	412	40481087	1956-10-31	1956-10-31 00:00:00	1956-11-07	1956-11-07 00:00:00	32020		\N	27436	0	444814009	40481087		0
7294	430	4132546	2006-09-19	2006-09-19 00:00:00	\N	\N	32020		\N	28542	0	275272006	4166590		0
7380	432	4112343	1960-06-20	1960-06-20 00:00:00	1960-07-03	1960-07-03 00:00:00	32020		\N	28754	0	195662009	4112343		0
7555	443	4112343	2016-11-06	2016-11-06 00:00:00	2016-11-13	2016-11-13 00:00:00	32020		\N	29452	0	195662009	4112343		0
7724	453	4112343	1975-04-23	1975-04-23 00:00:00	1975-05-02	1975-05-02 00:00:00	32020		\N	30179	0	195662009	4112343		0
7905	461	381316	1998-01-06	1998-01-06 00:00:00	\N	\N	32020		\N	30785	0	230690007	381316		0
8080	474	4266809	2005-08-17	2005-08-17 00:00:00	\N	\N	32020		\N	31662	0	397881000	4266809		0
8252	482	81893	2006-12-08	2006-12-08 00:00:00	\N	\N	32020		\N	32212	0	64766004	81893		0
8386	487	28060	2013-10-06	2013-10-06 00:00:00	2013-10-16	2013-10-16 00:00:00	32020		\N	32600	0	43878008	28060		0
8566	499	260139	2009-12-25	2009-12-25 00:00:00	2010-01-01	2010-01-01 00:00:00	32020		\N	33400	0	10509002	260139		0
8746	512	40481087	1956-08-12	1956-08-12 00:00:00	1956-09-02	1956-09-02 00:00:00	32020		\N	34174	0	444814009	40481087		0
19452	1169	260139	1944-04-13	1944-04-13 00:00:00	1944-04-20	1944-04-20 00:00:00	32020		\N	77029	0	10509002	260139		0
9066	533	4112343	1999-01-02	1999-01-02 00:00:00	1999-01-12	1999-01-12 00:00:00	32020		\N	35445	0	195662009	4112343		0
9249	546	80180	1981-05-28	1981-05-28 00:00:00	\N	\N	32020		\N	36230	0	396275006	80180		0
9375	552	28060	1954-02-08	1954-02-08 00:00:00	1954-02-18	1954-02-18 00:00:00	32020		\N	36564	0	43878008	28060		0
9584	569	4116491	1935-04-22	1935-04-22 00:00:00	1935-06-02	1935-06-02 00:00:00	32020		\N	37635	0	301011002	4116491		0
9705	573	260139	1982-10-31	1982-10-31 00:00:00	1982-11-07	1982-11-07 00:00:00	32020		\N	37971	0	10509002	260139		0
9908	587	40481087	1986-06-17	1986-06-17 00:00:00	1986-07-08	1986-07-08 00:00:00	32020		\N	38889	0	444814009	40481087		0
10107	600	28060	1983-08-17	1983-08-17 00:00:00	1983-08-29	1983-08-29 00:00:00	32020		\N	39640	0	43878008	28060		0
10231	605	4112343	2000-08-15	2000-08-15 00:00:00	2000-08-27	2000-08-27 00:00:00	32020		\N	40186	0	195662009	4112343		0
10387	613	260139	2015-05-15	2015-05-15 00:00:00	2015-05-29	2015-05-29 00:00:00	32020		\N	40709	0	10509002	260139		0
10570	621	81151	1982-12-10	1982-12-10 00:00:00	1982-12-31	1982-12-31 00:00:00	32020		\N	41488	0	44465007	81151		0
76	3	40480160	1986-10-04	1986-10-04 00:00:00	1986-12-03	1986-12-03 00:00:00	32020		\N	348	0	443165006	40480160		0
264	12	372328	1967-10-23	1967-10-23 00:00:00	1968-01-10	1968-01-10 00:00:00	32020		\N	1060	0	65363002	372328		0
488	30	4134304	1975-06-11	1975-06-11 00:00:00	1975-08-10	1975-08-10 00:00:00	32020		\N	2124	0	263102004	4134304		0
621	35	40481087	1973-02-07	1973-02-07 00:00:00	1973-02-21	1973-02-21 00:00:00	32020		\N	2396	0	444814009	40481087		0
761	41	4084167	1976-02-10	1976-02-10 00:00:00	1976-02-10	1976-02-10 00:00:00	32020		\N	2898	0	241929008	4084167		0
11468	677	40481087	1988-01-14	1988-01-14 00:00:00	1988-02-04	1988-02-04 00:00:00	32020		\N	44842	0	444814009	40481087		0
1109	65	4112343	2011-09-21	2011-09-21 00:00:00	2011-10-04	2011-10-04 00:00:00	32020		\N	4405	0	195662009	4112343		0
1247	72	40481087	1986-05-25	1986-05-25 00:00:00	1986-06-01	1986-06-01 00:00:00	32020		\N	4917	0	444814009	40481087		0
1405	82	40481087	2011-09-30	2011-09-30 00:00:00	2011-10-07	2011-10-07 00:00:00	32020		\N	5578	0	444814009	40481087		0
1639	96	4134304	1942-02-26	1942-02-26 00:00:00	1942-04-27	1942-04-27 00:00:00	32020		\N	6504	0	263102004	4134304		0
1757	101	78272	2016-05-11	2016-05-11 00:00:00	2016-06-15	2016-06-15 00:00:00	32020		\N	6945	0	70704007	78272		0
1950	115	258780	2019-03-03	2019-03-03 00:00:00	\N	\N	32020		\N	7602	0	185086009	258780		0
2106	123	28060	1960-10-20	1960-10-20 00:00:00	1960-11-01	1960-11-01 00:00:00	32020		\N	8120	0	43878008	28060		0
2324	137	4112343	1990-07-04	1990-07-04 00:00:00	1990-07-12	1990-07-12 00:00:00	32020		\N	9216	0	195662009	4112343		0
2433	143	40481087	1991-11-17	1991-11-17 00:00:00	1991-12-08	1991-12-08 00:00:00	32020		\N	9550	0	444814009	40481087		0
2607	153	4109685	1972-10-10	1972-10-10 00:00:00	1972-10-24	1972-10-24 00:00:00	32020		\N	10319	0	284551006	4109685		0
2753	160	4294548	1969-01-24	1969-01-24 00:00:00	1969-02-21	1969-02-21 00:00:00	32020		\N	10943	0	75498004	4294548		0
2932	170	4112343	1983-06-16	1983-06-16 00:00:00	1983-06-25	1983-06-25 00:00:00	32020		\N	11531	0	195662009	4112343		0
3085	182	4294548	1955-08-27	1955-08-27 00:00:00	1955-11-26	1955-11-26 00:00:00	32020		\N	12281	0	75498004	4294548		0
3230	188	4113008	1975-09-11	1975-09-11 00:00:00	1975-09-25	1975-09-25 00:00:00	32020		\N	12783	0	284549007	4113008		0
3412	195	81151	1959-01-11	1959-01-11 00:00:00	1959-02-01	1959-02-01 00:00:00	32020		\N	13420	0	44465007	81151		0
3621	207	40481087	1969-02-27	1969-02-27 00:00:00	1969-03-20	1969-03-20 00:00:00	32020		\N	14114	0	444814009	40481087		0
3742	213	80180	2003-09-09	2003-09-09 00:00:00	\N	\N	32020		\N	14501	0	396275006	80180		0
3910	225	4132546	2006-03-29	2006-03-29 00:00:00	\N	\N	32020		\N	15145	0	275272006	4166590		0
4086	236	192671	1990-12-21	1990-12-21 00:00:00	\N	\N	32020		\N	15938	0	K92.2	35208414		0
4250	245	4112343	1971-04-02	1971-04-02 00:00:00	1971-04-12	1971-04-12 00:00:00	32020		\N	16477	0	195662009	4112343		0
4457	262	257012	1982-04-28	1982-04-28 00:00:00	\N	\N	32020		\N	17407	0	40055000	257012		0
4570	268	260139	1990-03-23	1990-03-23 00:00:00	1990-03-30	1990-03-30 00:00:00	32020		\N	17795	0	10509002	260139		0
4753	279	40481087	1956-04-14	1956-04-14 00:00:00	1956-04-21	1956-04-21 00:00:00	32020		\N	18615	0	444814009	40481087		0
4896	287	4266809	2013-04-25	2013-04-25 00:00:00	\N	\N	32020		\N	19209	0	397881000	4266809		0
5082	298	4112343	1981-12-03	1981-12-03 00:00:00	1981-12-13	1981-12-13 00:00:00	32020		\N	19947	0	195662009	4112343		0
5235	308	260139	1961-08-11	1961-08-11 00:00:00	1961-08-18	1961-08-18 00:00:00	32020		\N	20455	0	10509002	260139		0
5433	320	4218389	1973-02-06	1973-02-06 00:00:00	1973-02-27	1973-02-27 00:00:00	32020		\N	21235	0	39848009	4218389		0
5606	331	80180	1974-11-08	1974-11-08 00:00:00	\N	\N	32020		\N	21787	0	396275006	80180		0
5744	337	4112343	2010-01-09	2010-01-09 00:00:00	2010-01-22	2010-01-22 00:00:00	32020		\N	22447	0	195662009	4112343		0
5912	348	40481087	1977-05-25	1977-05-25 00:00:00	1977-06-08	1977-06-08 00:00:00	32020		\N	23140	0	444814009	40481087		0
6066	357	4142905	1959-12-16	1959-12-16 00:00:00	1960-01-15	1960-01-15 00:00:00	32020		\N	23634	0	33737001	4142905		0
6228	366	81893	1943-04-07	1943-04-07 00:00:00	\N	\N	32020		\N	24337	0	64766004	81893		0
6391	376	4112343	1976-09-19	1976-09-19 00:00:00	1976-09-30	1976-09-30 00:00:00	32020		\N	24916	0	195662009	4112343		0
6608	390	40481087	2017-09-30	2017-09-30 00:00:00	2017-10-14	2017-10-14 00:00:00	32020		\N	25607	0	444814009	40481087		0
6731	398	80180	1962-03-08	1962-03-08 00:00:00	\N	\N	32020		\N	26095	0	396275006	80180		0
6892	406	40481087	1962-06-27	1962-06-27 00:00:00	1962-07-04	1962-07-04 00:00:00	32020		\N	26808	0	444814009	40481087		0
7050	412	40481087	1984-04-26	1984-04-26 00:00:00	1984-05-10	1984-05-10 00:00:00	32020		\N	27470	0	444814009	40481087		0
7295	430	140673	1990-06-05	1990-06-05 00:00:00	\N	\N	32020		\N	28434	0	40930008	140673		0
7381	432	40481087	1953-03-12	1953-03-12 00:00:00	1953-03-19	1953-03-19 00:00:00	32020		\N	28734	0	444814009	40481087		0
7567	445	4112343	1936-02-28	1936-02-28 00:00:00	1936-03-10	1936-03-10 00:00:00	32020		\N	29570	0	195662009	4112343		0
7725	453	440086	1981-05-12	1981-05-12 00:00:00	1985-07-09	1985-07-09 00:00:00	32020		\N	30181	0	192127007	440086		0
7906	461	4146173	2005-02-12	2005-02-12 00:00:00	2005-04-13	2005-04-13 00:00:00	32020		\N	30831	0	307731004	4146173		0
8081	474	80180	2005-08-17	2005-08-17 00:00:00	\N	\N	32020		\N	31662	0	396275006	80180		0
8253	482	4266809	2008-09-28	2008-09-28 00:00:00	\N	\N	32020		\N	32212	0	397881000	4266809		0
8387	487	40481087	1991-12-28	1991-12-28 00:00:00	1992-01-11	1992-01-11 00:00:00	32020		\N	32595	0	444814009	40481087		0
8567	499	40481087	1995-10-13	1995-10-13 00:00:00	1995-11-03	1995-11-03 00:00:00	32020		\N	33474	0	444814009	40481087		0
8747	512	4278672	1967-03-11	1967-03-11 00:00:00	1967-04-10	1967-04-10 00:00:00	32020		\N	34168	0	65966004	4278672		0
19453	1169	78272	1936-10-08	1936-10-08 00:00:00	1936-10-29	1936-10-29 00:00:00	32020		\N	76983	0	70704007	78272		0
9067	533	40481087	2005-04-05	2005-04-05 00:00:00	2005-04-19	2005-04-19 00:00:00	32020		\N	35447	0	444814009	40481087		0
9250	546	4266809	1981-05-28	1981-05-28 00:00:00	\N	\N	32020		\N	36230	0	397881000	4266809		0
9376	552	40481087	2002-09-10	2002-09-10 00:00:00	2002-10-01	2002-10-01 00:00:00	32020		\N	36625	0	444814009	40481087		0
9585	569	40481087	1977-05-15	1977-05-15 00:00:00	1977-05-22	1977-05-22 00:00:00	32020		\N	37584	0	444814009	40481087		0
9706	573	4112343	1965-07-27	1965-07-27 00:00:00	1965-08-06	1965-08-06 00:00:00	32020		\N	37956	0	195662009	4112343		0
9909	587	260139	1980-11-07	1980-11-07 00:00:00	1980-11-14	1980-11-14 00:00:00	32020		\N	38900	0	10509002	260139		0
10108	600	4112343	1967-06-30	1967-06-30 00:00:00	1967-07-08	1967-07-08 00:00:00	32020		\N	39569	0	195662009	4112343		0
10232	605	378001	2000-03-08	2000-03-08 00:00:00	2000-05-07	2000-05-07 00:00:00	32020		\N	40164	0	62106007	378001		0
10388	613	195588	1995-02-04	1995-02-04 00:00:00	1995-03-27	1995-03-27 00:00:00	32020		\N	40762	0	38822007	195588		0
10571	621	28060	1926-02-09	1926-02-09 00:00:00	1926-02-17	1926-02-17 00:00:00	32020		\N	41446	0	43878008	28060		0
77	3	40481087	1980-05-12	1980-05-12 00:00:00	1980-05-19	1980-05-19 00:00:00	32020		\N	221	0	444814009	40481087		0
265	12	4294548	1997-01-16	1997-01-16 00:00:00	1997-01-30	1997-01-30 00:00:00	32020		\N	1020	0	75498004	4294548		0
489	30	40486433	1973-08-21	1973-08-21 00:00:00	\N	\N	32020		\N	2044	0	446096008	40486433		0
622	35	28060	1996-07-02	1996-07-02 00:00:00	1996-07-10	1996-07-10 00:00:00	32020		\N	2405	0	43878008	28060		0
762	41	4112343	2012-01-12	2012-01-12 00:00:00	2012-01-25	2012-01-25 00:00:00	32020		\N	2944	0	195662009	4112343		0
11469	677	40481087	1992-10-19	1992-10-19 00:00:00	1992-11-02	1992-11-02 00:00:00	32020		\N	44830	0	444814009	40481087		0
1110	65	4112343	1991-07-04	1991-07-04 00:00:00	1991-07-17	1991-07-17 00:00:00	32020		\N	4403	0	195662009	4112343		0
1248	72	378001	1959-02-11	1959-02-11 00:00:00	1959-04-12	1959-04-12 00:00:00	32020		\N	4854	0	62106007	378001		0
1406	82	40481087	2000-11-27	2000-11-27 00:00:00	2000-12-18	2000-12-18 00:00:00	32020		\N	5576	0	444814009	40481087		0
1640	96	78272	1996-10-01	1996-10-01 00:00:00	1996-10-15	1996-10-15 00:00:00	32020		\N	6508	0	70704007	78272		0
1758	101	40481087	1991-01-07	1991-01-07 00:00:00	1991-01-28	1991-01-28 00:00:00	32020		\N	6936	0	444814009	40481087		0
1951	115	4283893	1995-06-30	1995-06-30 00:00:00	1995-07-28	1995-07-28 00:00:00	32020		\N	7574	0	36971009	4283893		0
2107	123	4112343	2001-05-17	2001-05-17 00:00:00	2001-05-28	2001-05-28 00:00:00	32020		\N	8156	0	195662009	4112343		0
12783	755	260139	1989-02-12	1989-02-12 00:00:00	1989-02-26	1989-02-26 00:00:00	32020		\N	50040	0	10509002	260139		0
2434	143	260139	2000-08-16	2000-08-16 00:00:00	2000-08-23	2000-08-23 00:00:00	32020		\N	9573	0	10509002	260139		0
2608	153	40481087	1951-07-17	1951-07-17 00:00:00	1951-08-07	1951-08-07 00:00:00	32020		\N	10374	0	444814009	40481087		0
2933	170	4112343	2002-05-14	2002-05-14 00:00:00	2002-05-26	2002-05-26 00:00:00	32020		\N	11578	0	195662009	4112343		0
3086	182	40481087	1950-10-15	1950-10-15 00:00:00	1950-10-22	1950-10-22 00:00:00	32020		\N	12291	0	444814009	40481087		0
3231	188	30753	1998-08-01	1998-08-01 00:00:00	\N	\N	32020		\N	12794	0	16761005	30753		0
3413	195	40481087	1987-10-08	1987-10-08 00:00:00	1987-10-22	1987-10-22 00:00:00	32020		\N	13355	0	444814009	40481087		0
3622	207	40481087	1994-12-08	1994-12-08 00:00:00	1994-12-15	1994-12-15 00:00:00	32020		\N	14099	0	444814009	40481087		0
3743	213	4112343	2017-03-16	2017-03-16 00:00:00	2017-03-25	2017-03-25 00:00:00	32020		\N	14528	0	195662009	4112343		0
3911	225	4001336	2006-03-29	2006-03-29 00:00:00	2006-04-28	2006-04-28 00:00:00	32020		\N	15145	0	110030002	4001336		0
4087	236	378001	1953-12-06	1953-12-06 00:00:00	1954-01-05	1954-01-05 00:00:00	32020		\N	15914	0	62106007	378001		0
4251	245	81151	1968-06-13	1968-06-13 00:00:00	1968-07-18	1968-07-18 00:00:00	32020		\N	16443	0	44465007	81151		0
4458	262	4059173	1967-03-21	1967-03-21 00:00:00	1967-06-19	1967-06-19 00:00:00	32020		\N	17354	0	16114001	4059173		0
4571	268	40481087	2019-05-23	2019-05-23 00:00:00	2019-05-30	2019-05-30 00:00:00	32020		\N	17783	0	444814009	40481087		0
4754	279	4112343	1972-06-08	1972-06-08 00:00:00	1972-06-18	1972-06-18 00:00:00	32020		\N	18638	0	195662009	4112343		0
4897	287	260139	1976-10-13	1976-10-13 00:00:00	1976-10-20	1976-10-20 00:00:00	32020		\N	19187	0	10509002	260139		0
5083	298	260139	1989-11-18	1989-11-18 00:00:00	1989-11-25	1989-11-25 00:00:00	32020		\N	19918	0	10509002	260139		0
5236	308	260139	2006-04-07	2006-04-07 00:00:00	2006-04-21	2006-04-21 00:00:00	32020		\N	20412	0	10509002	260139		0
5434	320	4112343	1958-10-08	1958-10-08 00:00:00	1958-10-19	1958-10-19 00:00:00	32020		\N	21221	0	195662009	4112343		0
5607	331	40481087	1992-06-15	1992-06-15 00:00:00	1992-06-29	1992-06-29 00:00:00	32020		\N	21818	0	444814009	40481087		0
5745	337	4109685	1965-09-21	1965-09-21 00:00:00	1965-10-05	1965-10-05 00:00:00	32020		\N	22414	0	284551006	4109685		0
5913	348	372328	1977-08-16	1977-08-16 00:00:00	1978-01-02	1978-01-02 00:00:00	32020		\N	23132	0	65363002	372328		0
6067	357	40481087	1970-04-14	1970-04-14 00:00:00	1970-04-28	1970-04-28 00:00:00	32020		\N	23741	0	444814009	40481087		0
6229	366	4310024	1942-10-09	1942-10-09 00:00:00	\N	\N	32020		\N	24337	0	424802006	4310024		0
6392	376	40481087	1966-09-07	1966-09-07 00:00:00	1966-09-14	1966-09-14 00:00:00	32020		\N	24897	0	444814009	40481087		0
6609	390	40481087	1980-09-12	1980-09-12 00:00:00	1980-10-03	1980-10-03 00:00:00	32020		\N	25617	0	444814009	40481087		0
6733	398	4329847	1967-02-11	1967-02-11 00:00:00	\N	\N	32020		\N	26071	0	22298006	4329847		0
6893	406	40481087	1955-06-08	1955-06-08 00:00:00	1955-06-22	1955-06-22 00:00:00	32020		\N	26718	0	444814009	40481087		0
7051	412	260139	2004-02-18	2004-02-18 00:00:00	2004-03-03	2004-03-03 00:00:00	32020		\N	27453	0	10509002	260139		0
7296	430	4112343	1989-04-04	1989-04-04 00:00:00	1989-04-13	1989-04-13 00:00:00	32020		\N	28439	0	195662009	4112343		0
7382	432	28060	1939-03-21	1939-03-21 00:00:00	1939-03-31	1939-03-31 00:00:00	32020		\N	28747	0	43878008	28060		0
7568	445	78272	1935-06-02	1935-06-02 00:00:00	1935-06-30	1935-06-30 00:00:00	32020		\N	29637	0	70704007	78272		0
7726	453	80180	2004-05-26	2004-05-26 00:00:00	\N	\N	32020		\N	30198	0	396275006	80180		0
7907	461	40481087	2011-01-12	2011-01-12 00:00:00	2011-02-02	2011-02-02 00:00:00	32020		\N	30795	0	444814009	40481087		0
8082	474	4285898	2004-11-20	2004-11-20 00:00:00	\N	\N	32020		\N	31662	0	68496003	4285898		0
8254	482	4285898	2007-12-03	2007-12-03 00:00:00	\N	\N	32020		\N	32212	0	68496003	4285898		0
8388	487	28060	1972-08-12	1972-08-12 00:00:00	1972-08-22	1972-08-22 00:00:00	32020		\N	32603	0	43878008	28060		0
8568	499	40481087	2001-05-25	2001-05-25 00:00:00	2001-06-15	2001-06-15 00:00:00	32020		\N	33395	0	444814009	40481087		0
8748	512	40481087	1999-02-11	1999-02-11 00:00:00	1999-02-25	1999-02-25 00:00:00	32020		\N	34176	0	444814009	40481087		0
19454	1169	317576	2014-09-22	2014-09-22 00:00:00	\N	\N	32020		\N	77060	0	53741008	317576		0
9068	533	257012	1999-07-21	1999-07-21 00:00:00	1999-07-28	1999-07-28 00:00:00	32020		\N	35446	0	40055000	257012		0
9251	546	4112343	2014-06-14	2014-06-14 00:00:00	2014-06-27	2014-06-27 00:00:00	32020		\N	36181	0	195662009	4112343		0
9377	552	260139	1991-08-31	1991-08-31 00:00:00	1991-09-14	1991-09-14 00:00:00	32020		\N	36583	0	10509002	260139		0
9586	569	260139	1956-06-10	1956-06-10 00:00:00	1956-06-17	1956-06-17 00:00:00	32020		\N	37693	0	10509002	260139		0
9721	576	4296204	1969-04-17	1969-04-17 00:00:00	1969-05-01	1969-05-01 00:00:00	32020		\N	38063	0	403190006	4296204		0
9910	587	372328	1983-10-22	1983-10-22 00:00:00	1984-03-07	1984-03-07 00:00:00	32020		\N	38867	0	65363002	372328		0
10109	600	40481087	2018-04-09	2018-04-09 00:00:00	2018-04-23	2018-04-23 00:00:00	32020		\N	39574	0	444814009	40481087		0
10233	605	80180	1995-02-21	1995-02-21 00:00:00	\N	\N	32020		\N	40122	0	396275006	80180		0
10389	613	4112343	1949-08-07	1949-08-07 00:00:00	1949-08-18	1949-08-18 00:00:00	32020		\N	40758	0	195662009	4112343		0
10572	621	4112343	1952-12-12	1952-12-12 00:00:00	1952-12-21	1952-12-21 00:00:00	32020		\N	41452	0	195662009	4112343		0
78	3	40481087	2018-10-22	2018-10-22 00:00:00	2018-11-12	2018-11-12 00:00:00	32020		\N	298	0	444814009	40481087		0
266	12	4027663	1997-01-21	1997-01-21 00:00:00	\N	\N	32020		\N	1020	0	13200003	4027663		0
490	30	4112343	1992-02-15	1992-02-15 00:00:00	1992-02-22	1992-02-22 00:00:00	32020		\N	2103	0	195662009	4112343		0
623	35	81893	1996-11-03	1996-11-03 00:00:00	\N	\N	32020		\N	2405	0	64766004	81893		0
763	41	260139	1984-11-04	1984-11-04 00:00:00	1984-11-18	1984-11-18 00:00:00	32020		\N	2903	0	10509002	260139		0
11470	677	4109685	2016-11-11	2016-11-11 00:00:00	2016-11-25	2016-11-25 00:00:00	32020		\N	44813	0	284551006	4109685		0
1111	65	4116491	2016-03-18	2016-03-18 00:00:00	2016-05-16	2016-05-16 00:00:00	32020		\N	4378	0	301011002	4116491		0
1249	72	4294548	2000-07-17	2000-07-17 00:00:00	2000-10-09	2000-10-09 00:00:00	32020		\N	4885	0	75498004	4294548		0
1407	82	195588	2006-03-10	2006-03-10 00:00:00	2006-05-01	2006-05-01 00:00:00	32020		\N	5553	0	38822007	195588		0
1641	96	40481087	1971-09-23	1971-09-23 00:00:00	1971-10-07	1971-10-07 00:00:00	32020		\N	6531	0	444814009	40481087		0
1759	101	4059173	2017-07-10	2017-07-10 00:00:00	2017-10-08	2017-10-08 00:00:00	32020		\N	6946	0	16114001	4059173		0
1952	115	40481087	1969-04-11	1969-04-11 00:00:00	1969-04-18	1969-04-18 00:00:00	32020		\N	7613	0	444814009	40481087		0
2109	123	321042	2013-07-10	2013-07-10 00:00:00	\N	\N	32020		\N	8146	0	410429000	321042		0
12784	755	40481087	1978-02-24	1978-02-24 00:00:00	1978-03-17	1978-03-17 00:00:00	32020		\N	50062	0	444814009	40481087		0
2435	143	372328	1965-11-26	1965-11-26 00:00:00	1966-01-09	1966-01-09 00:00:00	32020		\N	9575	0	65363002	372328		0
2609	153	195588	1997-05-27	1997-05-27 00:00:00	1997-07-10	1997-07-10 00:00:00	32020		\N	10387	0	38822007	195588		0
2755	160	80180	2006-02-01	2006-02-01 00:00:00	\N	\N	32020		\N	10999	0	396275006	80180		0
2934	170	4001336	2003-01-06	2003-01-06 00:00:00	2003-03-07	2003-03-07 00:00:00	32020		\N	11566	0	110030002	4001336		0
3087	182	40481087	1960-04-12	1960-04-12 00:00:00	1960-04-26	1960-04-26 00:00:00	32020		\N	12282	0	444814009	40481087		0
3232	188	81893	1998-05-03	1998-05-03 00:00:00	\N	\N	32020		\N	12794	0	64766004	81893		0
3414	195	4112343	1987-10-12	1987-10-12 00:00:00	1987-10-23	1987-10-23 00:00:00	32020		\N	13401	0	195662009	4112343		0
3623	207	40481087	1986-03-28	1986-03-28 00:00:00	1986-04-18	1986-04-18 00:00:00	32020		\N	14103	0	444814009	40481087		0
3744	213	192671	2003-10-18	2003-10-18 00:00:00	\N	\N	32020		\N	14546	0	K92.2	35208414		0
3912	225	4134304	1975-06-21	1975-06-21 00:00:00	1975-07-21	1975-07-21 00:00:00	32020		\N	15151	0	263102004	4134304		0
4088	236	372328	1956-06-10	1956-06-10 00:00:00	1957-03-07	1957-03-07 00:00:00	32020		\N	15911	0	65363002	372328		0
4252	246	40481087	2004-08-25	2004-08-25 00:00:00	2004-09-08	2004-09-08 00:00:00	32020		\N	16527	0	444814009	40481087		0
4459	262	4283893	1982-04-07	1982-04-07 00:00:00	1982-06-02	1982-06-02 00:00:00	32020		\N	17362	0	36971009	4283893		0
4572	268	40481087	2016-08-08	2016-08-08 00:00:00	2016-08-29	2016-08-29 00:00:00	32020		\N	17801	0	444814009	40481087		0
4755	279	372328	1954-03-02	1954-03-02 00:00:00	1954-05-07	1954-05-07 00:00:00	32020		\N	18626	0	65363002	372328		0
4898	287	28060	2003-02-16	2003-02-16 00:00:00	2003-02-25	2003-02-25 00:00:00	32020		\N	19208	0	43878008	28060		0
5084	298	40481087	1964-07-23	1964-07-23 00:00:00	1964-08-13	1964-08-13 00:00:00	32020		\N	19945	0	444814009	40481087		0
5237	308	28060	1963-12-30	1963-12-30 00:00:00	1964-01-08	1964-01-08 00:00:00	32020		\N	20456	0	43878008	28060		0
5435	320	40481087	1973-04-26	1973-04-26 00:00:00	1973-05-03	1973-05-03 00:00:00	32020		\N	21223	0	444814009	40481087		0
5608	331	40481087	1966-10-14	1966-10-14 00:00:00	1966-11-04	1966-11-04 00:00:00	32020		\N	21770	0	444814009	40481087		0
5746	338	40481087	1998-11-28	1998-11-28 00:00:00	1998-12-05	1998-12-05 00:00:00	32020		\N	22527	0	444814009	40481087		0
5914	349	40481087	1970-01-10	1970-01-10 00:00:00	1970-01-17	1970-01-17 00:00:00	32020		\N	23171	0	444814009	40481087		0
6068	357	4285898	1995-06-25	1995-06-25 00:00:00	\N	\N	32020		\N	23772	0	68496003	4285898		0
6230	366	40481087	1993-08-04	1993-08-04 00:00:00	1993-08-18	1993-08-18 00:00:00	32020		\N	24277	0	444814009	40481087		0
6393	376	4116491	1996-04-18	1996-04-18 00:00:00	1996-05-20	1996-05-20 00:00:00	32020		\N	24923	0	301011002	4116491		0
6610	390	4116491	2016-01-26	2016-01-26 00:00:00	2016-02-29	2016-02-29 00:00:00	32020		\N	25632	0	301011002	4116491		0
6734	398	28060	1940-04-08	1940-04-08 00:00:00	1940-04-18	1940-04-18 00:00:00	32020		\N	26068	0	43878008	28060		0
6894	406	134438	1974-02-20	1974-02-20 00:00:00	1975-02-17	1975-02-17 00:00:00	32020		\N	26756	0	40275004	134438		0
7052	412	4283893	1975-02-09	1975-02-09 00:00:00	1975-03-02	1975-03-02 00:00:00	32020		\N	27450	0	36971009	4283893		0
7297	430	260139	2006-02-15	2006-02-15 00:00:00	2006-02-22	2006-02-22 00:00:00	32020		\N	28441	0	10509002	260139		0
7383	432	40481087	1977-11-05	1977-11-05 00:00:00	1977-11-26	1977-11-26 00:00:00	32020		\N	28723	0	444814009	40481087		0
7569	445	380378	1925-12-18	1925-12-18 00:00:00	\N	\N	32020		\N	29636	0	84757009	380378		0
7727	453	40481087	1979-02-06	1979-02-06 00:00:00	1979-02-27	1979-02-27 00:00:00	32020		\N	30180	0	444814009	40481087		0
7908	461	40481087	1971-08-05	1971-08-05 00:00:00	1971-08-26	1971-08-26 00:00:00	32020		\N	30830	0	444814009	40481087		0
8083	474	40481087	2008-11-20	2008-11-20 00:00:00	2008-12-04	2008-12-04 00:00:00	32020		\N	31603	0	444814009	40481087		0
8255	482	80180	2008-09-28	2008-09-28 00:00:00	\N	\N	32020		\N	32212	0	396275006	80180		0
8389	487	257012	1994-01-19	1994-01-19 00:00:00	1994-04-06	1994-04-06 00:00:00	32020		\N	32549	0	40055000	257012		0
8569	500	372328	1962-07-28	1962-07-28 00:00:00	1962-08-28	1962-08-28 00:00:00	32020		\N	33527	0	65363002	372328		0
8749	512	4112343	1960-05-03	1960-05-03 00:00:00	1960-05-11	1960-05-11 00:00:00	32020		\N	34198	0	195662009	4112343		0
19455	1169	4329847	2018-08-20	2018-08-20 00:00:00	\N	\N	32020		\N	76991	0	22298006	4329847		0
9069	533	260139	1980-03-30	1980-03-30 00:00:00	1980-04-06	1980-04-06 00:00:00	32020		\N	35426	0	10509002	260139		0
9252	546	4294548	2001-06-07	2001-06-07 00:00:00	2001-07-05	2001-07-05 00:00:00	32020		\N	36244	0	75498004	4294548		0
9429	558	40481087	2012-04-15	2012-04-15 00:00:00	2012-05-06	2012-05-06 00:00:00	32020		\N	36997	0	444814009	40481087		0
9587	569	257012	2015-04-01	2015-04-01 00:00:00	\N	\N	32020		\N	37587	0	40055000	257012		0
9722	576	4112343	1979-01-22	1979-01-22 00:00:00	1979-02-03	1979-02-03 00:00:00	32020		\N	38071	0	195662009	4112343		0
9911	587	4112343	2004-05-08	2004-05-08 00:00:00	2004-05-16	2004-05-16 00:00:00	32020		\N	38865	0	195662009	4112343		0
10110	600	4152936	2012-08-25	2012-08-25 00:00:00	2012-09-15	2012-09-15 00:00:00	32020		\N	39651	0	283385000	4152936		0
10234	605	4109685	1982-11-26	1982-11-26 00:00:00	1982-12-17	1982-12-17 00:00:00	32020		\N	40162	0	284551006	4109685		0
10390	613	40481087	1966-12-31	1966-12-31 00:00:00	1967-01-14	1967-01-14 00:00:00	32020		\N	40726	0	444814009	40481087		0
10609	624	81151	1965-07-15	1965-07-15 00:00:00	1965-08-12	1965-08-12 00:00:00	32020		\N	41691	0	44465007	81151		0
79	3	260139	1969-03-17	1969-03-17 00:00:00	1969-03-24	1969-03-24 00:00:00	32020		\N	220	0	10509002	260139		0
267	12	372328	1964-08-22	1964-08-22 00:00:00	1965-01-06	1965-01-06 00:00:00	32020		\N	1059	0	65363002	372328		0
491	30	4112343	1990-09-13	1990-09-13 00:00:00	1990-09-21	1990-09-21 00:00:00	32020		\N	2046	0	195662009	4112343		0
624	35	40481087	1965-12-27	1965-12-27 00:00:00	1966-01-17	1966-01-17 00:00:00	32020		\N	2394	0	444814009	40481087		0
764	41	40481087	2009-09-18	2009-09-18 00:00:00	2009-10-09	2009-10-09 00:00:00	32020		\N	2993	0	444814009	40481087		0
11471	677	78272	1967-03-03	1967-03-03 00:00:00	1967-04-07	1967-04-07 00:00:00	32020		\N	44810	0	70704007	78272		0
1112	65	4112343	2005-12-10	2005-12-10 00:00:00	2005-12-19	2005-12-19 00:00:00	32020		\N	4398	0	195662009	4112343		0
1250	72	40481087	1952-02-23	1952-02-23 00:00:00	1952-03-15	1952-03-15 00:00:00	32020		\N	4860	0	444814009	40481087		0
1408	82	40481087	1982-12-14	1982-12-14 00:00:00	1982-12-28	1982-12-28 00:00:00	32020		\N	5605	0	444814009	40481087		0
1642	96	4329847	1997-01-25	1997-01-25 00:00:00	\N	\N	32020		\N	6509	0	22298006	4329847		0
1760	101	40481087	1935-03-09	1935-03-09 00:00:00	1935-03-23	1935-03-23 00:00:00	32020		\N	6911	0	444814009	40481087		0
1953	115	4112343	2004-10-27	2004-10-27 00:00:00	2004-11-09	2004-11-09 00:00:00	32020		\N	7596	0	195662009	4112343		0
2110	123	4149245	1962-07-08	1962-07-08 00:00:00	1962-09-13	1962-09-13 00:00:00	32020		\N	8165	0	30832001	4149245		0
12785	755	4278672	1981-07-02	1981-07-02 00:00:00	1981-08-01	1981-08-01 00:00:00	32020		\N	50009	0	65966004	4278672		0
2436	143	4112343	1990-02-20	1990-02-20 00:00:00	1990-03-03	1990-03-03 00:00:00	32020		\N	9547	0	195662009	4112343		0
2610	153	28060	1948-05-09	1948-05-09 00:00:00	1948-05-19	1948-05-19 00:00:00	32020		\N	10346	0	43878008	28060		0
2756	160	28060	2016-09-06	2016-09-06 00:00:00	2016-09-19	2016-09-19 00:00:00	32020		\N	10965	0	43878008	28060		0
2935	170	80180	2009-04-15	2009-04-15 00:00:00	\N	\N	32020		\N	11546	0	396275006	80180		0
3088	182	40481087	1963-02-19	1963-02-19 00:00:00	1963-03-05	1963-03-05 00:00:00	32020		\N	12314	0	444814009	40481087		0
3233	188	40481087	1997-04-13	1997-04-13 00:00:00	1997-04-27	1997-04-27 00:00:00	32020		\N	12794	0	444814009	40481087		0
3415	195	257012	1998-11-22	1998-11-22 00:00:00	\N	\N	32020		\N	13357	0	40055000	257012		0
3624	207	260139	1996-10-25	1996-10-25 00:00:00	1996-11-01	1996-11-01 00:00:00	32020		\N	14104	0	10509002	260139		0
3745	213	4112343	2001-12-09	2001-12-09 00:00:00	2001-12-20	2001-12-20 00:00:00	32020		\N	14477	0	195662009	4112343		0
3913	225	4218389	1971-09-28	1971-09-28 00:00:00	1971-10-19	1971-10-19 00:00:00	32020		\N	15149	0	39848009	4218389		0
4089	236	4112343	2003-07-30	2003-07-30 00:00:00	2003-08-07	2003-08-07 00:00:00	32020		\N	15909	0	195662009	4112343		0
4253	246	40481087	1993-06-26	1993-06-26 00:00:00	1993-07-03	1993-07-03 00:00:00	32020		\N	16505	0	444814009	40481087		0
4460	262	375671	1972-03-24	1972-03-24 00:00:00	1972-04-23	1972-04-23 00:00:00	32020		\N	17411	0	62564004	375671		0
4573	268	4112343	2004-12-04	2004-12-04 00:00:00	2004-12-13	2004-12-13 00:00:00	32020		\N	17782	0	195662009	4112343		0
4756	279	372328	1956-07-25	1956-07-25 00:00:00	1956-11-09	1956-11-09 00:00:00	32020		\N	18657	0	65363002	372328		0
4899	287	4112343	2013-12-31	2013-12-31 00:00:00	2014-01-10	2014-01-10 00:00:00	32020		\N	19210	0	195662009	4112343		0
5085	298	260139	1973-07-16	1973-07-16 00:00:00	1973-07-30	1973-07-30 00:00:00	32020		\N	19946	0	10509002	260139		0
5238	308	40481087	2004-04-10	2004-04-10 00:00:00	2004-04-24	2004-04-24 00:00:00	32020		\N	20403	0	444814009	40481087		0
5436	320	4237458	1959-11-30	1959-11-30 00:00:00	1960-01-29	1960-01-29 00:00:00	32020		\N	21231	0	58150001	4237458		0
5609	331	4112343	2017-02-24	2017-02-24 00:00:00	2017-03-08	2017-03-08 00:00:00	32020		\N	21826	0	195662009	4112343		0
5747	338	260139	1995-06-01	1995-06-01 00:00:00	1995-06-15	1995-06-15 00:00:00	32020		\N	22526	0	10509002	260139		0
5915	349	4112343	1975-05-13	1975-05-13 00:00:00	1975-05-26	1975-05-26 00:00:00	32020		\N	23206	0	195662009	4112343		0
6069	357	80180	1996-04-20	1996-04-20 00:00:00	\N	\N	32020		\N	23772	0	396275006	80180		0
6231	366	40481087	1919-09-20	1919-09-20 00:00:00	1919-09-27	1919-09-27 00:00:00	32020		\N	24267	0	444814009	40481087		0
6394	376	4310024	1997-12-14	1997-12-14 00:00:00	\N	\N	32020		\N	24923	0	424802006	4310024		0
6611	390	80180	2016-05-15	2016-05-15 00:00:00	\N	\N	32020		\N	25632	0	396275006	80180		0
6735	398	317576	1947-12-06	1947-12-06 00:00:00	\N	\N	32020		\N	26073	0	53741008	317576		0
6895	406	4112343	1994-07-26	1994-07-26 00:00:00	1994-08-02	1994-08-02 00:00:00	32020		\N	26769	0	195662009	4112343		0
7053	412	40481087	1986-12-23	1986-12-23 00:00:00	1987-01-06	1987-01-06 00:00:00	32020		\N	27471	0	444814009	40481087		0
7298	430	260139	1949-12-15	1949-12-15 00:00:00	1949-12-29	1949-12-29 00:00:00	32020		\N	28430	0	10509002	260139		0
7384	432	40481087	1943-03-21	1943-03-21 00:00:00	1943-03-28	1943-03-28 00:00:00	32020		\N	28751	0	444814009	40481087		0
7570	445	4112343	1954-01-20	1954-01-20 00:00:00	1954-01-31	1954-01-31 00:00:00	32020		\N	29587	0	195662009	4112343		0
7728	453	81151	1971-04-10	1971-04-10 00:00:00	1971-05-08	1971-05-08 00:00:00	32020		\N	30151	0	44465007	81151		0
7909	461	80502	2018-12-18	2018-12-18 00:00:00	\N	\N	32020		\N	30847	0	64859006	80502		0
8084	474	40481087	1978-11-15	1978-11-15 00:00:00	1978-12-06	1978-12-06 00:00:00	32020		\N	31627	0	444814009	40481087		0
8256	482	30753	2007-03-08	2007-03-08 00:00:00	\N	\N	32020		\N	32212	0	16761005	30753		0
8390	487	378001	1985-04-04	1985-04-04 00:00:00	1985-06-03	1985-06-03 00:00:00	32020		\N	32527	0	62106007	378001		0
8570	500	40481087	2005-12-17	2005-12-17 00:00:00	2006-01-07	2006-01-07 00:00:00	32020		\N	33523	0	444814009	40481087		0
8750	512	40479768	1970-01-24	1970-01-24 00:00:00	1970-03-02	1970-03-02 00:00:00	32020		\N	34170	0	444470001	40479768		0
19457	1169	4155034	1982-01-30	1982-01-30 00:00:00	1982-02-13	1982-02-13 00:00:00	32020		\N	76988	0	283371005	4155034		0
9070	533	40481087	1975-12-29	1975-12-29 00:00:00	1976-01-05	1976-01-05 00:00:00	32020		\N	35392	0	444814009	40481087		0
9253	546	40481087	1975-12-18	1975-12-18 00:00:00	1976-01-08	1976-01-08 00:00:00	32020		\N	36195	0	444814009	40481087		0
9430	558	40481087	1966-04-13	1966-04-13 00:00:00	1966-04-27	1966-04-27 00:00:00	32020		\N	37033	0	444814009	40481087		0
9588	569	40481087	1989-01-26	1989-01-26 00:00:00	1989-02-09	1989-02-09 00:00:00	32020		\N	37695	0	444814009	40481087		0
9723	576	80180	2001-12-10	2001-12-10 00:00:00	\N	\N	32020		\N	38101	0	396275006	80180		0
9912	587	40481087	2011-04-14	2011-04-14 00:00:00	2011-04-28	2011-04-28 00:00:00	32020		\N	38866	0	444814009	40481087		0
10111	600	260139	1978-03-30	1978-03-30 00:00:00	1978-04-13	1978-04-13 00:00:00	32020		\N	39571	0	10509002	260139		0
10235	605	372328	1961-08-30	1961-08-30 00:00:00	1962-04-13	1962-04-13 00:00:00	32020		\N	40188	0	65363002	372328		0
10391	613	40481087	1998-08-12	1998-08-12 00:00:00	1998-08-26	1998-08-26 00:00:00	32020		\N	40763	0	444814009	40481087		0
10610	624	260139	1969-10-17	1969-10-17 00:00:00	1969-10-24	1969-10-24 00:00:00	32020		\N	41636	0	10509002	260139		0
80	3	4266809	1957-12-08	1957-12-08 00:00:00	\N	\N	32020		\N	345	0	397881000	4266809		0
268	12	440086	1973-01-27	1973-01-27 00:00:00	1981-02-04	1981-02-04 00:00:00	32020		\N	1054	0	192127007	440086		0
492	30	372328	1972-04-06	1972-04-06 00:00:00	1972-07-22	1972-07-22 00:00:00	32020		\N	2115	0	65363002	372328		0
625	35	28060	2011-02-21	2011-02-21 00:00:00	2011-02-28	2011-02-28 00:00:00	32020		\N	2408	0	43878008	28060		0
765	42	4112343	1940-10-20	1940-10-20 00:00:00	1940-11-01	1940-11-01 00:00:00	32020		\N	3051	0	195662009	4112343		0
11472	677	4112343	1962-01-31	1962-01-31 00:00:00	1962-02-11	1962-02-11 00:00:00	32020		\N	44783	0	195662009	4112343		0
1113	65	40481087	1991-07-03	1991-07-03 00:00:00	1991-07-10	1991-07-10 00:00:00	32020		\N	4418	0	444814009	40481087		0
1251	72	78272	1985-10-04	1985-10-04 00:00:00	1985-10-18	1985-10-18 00:00:00	32020		\N	4858	0	70704007	78272		0
1409	82	4112343	1970-01-05	1970-01-05 00:00:00	1970-01-12	1970-01-12 00:00:00	32020		\N	5538	0	195662009	4112343		0
1644	96	4112343	1927-08-26	1927-08-26 00:00:00	1927-09-03	1927-09-03 00:00:00	32020		\N	6547	0	195662009	4112343		0
1761	101	260139	1955-02-17	1955-02-17 00:00:00	1955-02-24	1955-02-24 00:00:00	32020		\N	6934	0	10509002	260139		0
1954	115	40481087	1964-04-27	1964-04-27 00:00:00	1964-05-18	1964-05-18 00:00:00	32020		\N	7572	0	444814009	40481087		0
2111	123	4112343	1988-07-21	1988-07-21 00:00:00	1988-07-28	1988-07-28 00:00:00	32020		\N	8155	0	195662009	4112343		0
12786	755	4230399	2018-10-14	2018-10-14 00:00:00	2019-01-12	2019-01-12 00:00:00	32020		\N	50013	0	359817006	4230399		0
2437	143	4278672	1981-04-27	1981-04-27 00:00:00	1981-05-27	1981-05-27 00:00:00	32020		\N	9610	0	65966004	4278672		0
2611	153	260139	1996-10-22	1996-10-22 00:00:00	1996-11-05	1996-11-05 00:00:00	32020		\N	10396	0	10509002	260139		0
2757	160	4116491	1992-07-19	1992-07-19 00:00:00	1992-09-16	1992-09-16 00:00:00	32020		\N	10941	0	301011002	4116491		0
2936	170	4112343	1973-01-26	1973-01-26 00:00:00	1973-02-05	1973-02-05 00:00:00	32020		\N	11522	0	195662009	4112343		0
3089	182	4112343	2008-03-07	2008-03-07 00:00:00	2008-03-16	2008-03-16 00:00:00	32020		\N	12320	0	195662009	4112343		0
3234	188	28060	1967-10-25	1967-10-25 00:00:00	1967-11-07	1967-11-07 00:00:00	32020		\N	12824	0	43878008	28060		0
3416	195	80180	1993-09-24	1993-09-24 00:00:00	\N	\N	32020		\N	13374	0	396275006	80180		0
3637	209	4112343	1993-07-04	1993-07-04 00:00:00	1993-07-17	1993-07-17 00:00:00	32020		\N	14210	0	195662009	4112343		0
3746	213	4285898	2003-01-12	2003-01-12 00:00:00	\N	\N	32020		\N	14477	0	68496003	4285898		0
3914	225	40481087	1971-11-07	1971-11-07 00:00:00	1971-11-21	1971-11-21 00:00:00	32020		\N	15204	0	444814009	40481087		0
4090	236	4112343	1982-11-01	1982-11-01 00:00:00	1982-11-10	1982-11-10 00:00:00	32020		\N	15926	0	195662009	4112343		0
4254	246	378001	1963-10-06	1963-10-06 00:00:00	1963-12-05	1963-12-05 00:00:00	32020		\N	16584	0	62106007	378001		0
4461	262	40481087	1986-06-14	1986-06-14 00:00:00	1986-06-21	1986-06-21 00:00:00	32020		\N	17414	0	444814009	40481087		0
4574	268	4299128	1977-05-29	1977-05-29 00:00:00	1977-06-19	1977-06-19 00:00:00	32020		\N	17797	0	403192003	4299128		0
4757	279	80180	1991-05-09	1991-05-09 00:00:00	\N	\N	32020		\N	18607	0	396275006	80180		0
4900	287	260139	2002-05-07	2002-05-07 00:00:00	2002-05-21	2002-05-21 00:00:00	32020		\N	19207	0	10509002	260139		0
5086	298	40481087	1956-07-09	1956-07-09 00:00:00	1956-07-30	1956-07-30 00:00:00	32020		\N	19916	0	444814009	40481087		0
5239	308	40481087	1967-02-15	1967-02-15 00:00:00	1967-03-08	1967-03-08 00:00:00	32020		\N	20411	0	444814009	40481087		0
5437	320	4152936	2004-08-09	2004-08-09 00:00:00	2004-08-23	2004-08-23 00:00:00	32020		\N	21179	0	283385000	4152936		0
5610	331	257012	1983-12-11	1983-12-11 00:00:00	\N	\N	32020		\N	21817	0	40055000	257012		0
5748	338	40481087	1981-12-06	1981-12-06 00:00:00	1981-12-20	1981-12-20 00:00:00	32020		\N	22595	0	444814009	40481087		0
5916	349	40481087	2015-04-26	2015-04-26 00:00:00	2015-05-03	2015-05-03 00:00:00	32020		\N	23202	0	444814009	40481087		0
6070	357	80502	2014-12-10	2014-12-10 00:00:00	\N	\N	32020		\N	23753	0	64859006	80502		0
6232	366	4112343	1995-07-26	1995-07-26 00:00:00	1995-08-04	1995-08-04 00:00:00	32020		\N	24325	0	195662009	4112343		0
6395	376	4112343	1995-10-23	1995-10-23 00:00:00	1995-10-30	1995-10-30 00:00:00	32020		\N	24918	0	195662009	4112343		0
6612	390	260139	1998-08-21	1998-08-21 00:00:00	1998-09-04	1998-09-04 00:00:00	32020		\N	25618	0	10509002	260139		0
6736	398	4152936	1955-07-09	1955-07-09 00:00:00	1955-07-30	1955-07-30 00:00:00	32020		\N	26106	0	283385000	4152936		0
6896	406	40481087	1995-11-23	1995-11-23 00:00:00	1995-11-30	1995-11-30 00:00:00	32020		\N	26770	0	444814009	40481087		0
7054	412	78272	1961-04-17	1961-04-17 00:00:00	1961-05-22	1961-05-22 00:00:00	32020		\N	27408	0	70704007	78272		0
7299	430	40481087	1998-10-04	1998-10-04 00:00:00	1998-10-11	1998-10-11 00:00:00	32020		\N	28436	0	444814009	40481087		0
7385	432	378001	2001-03-10	2001-03-10 00:00:00	2001-05-09	2001-05-09 00:00:00	32020		\N	28716	0	62106007	378001		0
7572	445	4029498	1925-09-18	1925-09-18 00:00:00	\N	\N	32020		\N	29635	0	128613002	4029498		0
7729	453	81151	1992-04-17	1992-04-17 00:00:00	1992-05-08	1992-05-08 00:00:00	32020		\N	30152	0	44465007	81151		0
7910	461	4299128	2017-05-10	2017-05-10 00:00:00	2017-06-14	2017-06-14 00:00:00	32020		\N	30859	0	403192003	4299128		0
8085	474	257012	1977-12-12	1977-12-12 00:00:00	\N	\N	32020		\N	31600	0	40055000	257012		0
8257	482	78272	1988-05-28	1988-05-28 00:00:00	1988-07-02	1988-07-02 00:00:00	32020		\N	32230	0	70704007	78272		0
8391	487	260139	1972-09-11	1972-09-11 00:00:00	1972-09-25	1972-09-25 00:00:00	32020		\N	32567	0	10509002	260139		0
8571	500	192671	1998-12-03	1998-12-03 00:00:00	\N	\N	32020		\N	33504	0	K92.2	35208414		0
8751	512	4278672	1969-01-29	1969-01-29 00:00:00	1969-02-28	1969-02-28 00:00:00	32020		\N	34169	0	65966004	4278672		0
19458	1169	260139	1937-12-03	1937-12-03 00:00:00	1937-12-17	1937-12-17 00:00:00	32020		\N	77028	0	10509002	260139		0
9071	533	40481087	1989-11-28	1989-11-28 00:00:00	1989-12-05	1989-12-05 00:00:00	32020		\N	35419	0	444814009	40481087		0
9254	546	378001	1978-12-10	1978-12-10 00:00:00	1979-02-08	1979-02-08 00:00:00	32020		\N	36152	0	62106007	378001		0
9431	558	80180	2002-03-13	2002-03-13 00:00:00	\N	\N	32020		\N	37039	0	396275006	80180		0
9589	569	260139	1947-10-05	1947-10-05 00:00:00	1947-10-19	1947-10-19 00:00:00	32020		\N	37692	0	10509002	260139		0
9724	576	260139	2015-06-01	2015-06-01 00:00:00	2015-06-08	2015-06-08 00:00:00	32020		\N	38103	0	10509002	260139		0
9913	587	4266809	2015-06-01	2015-06-01 00:00:00	\N	\N	32020		\N	38909	0	397881000	4266809		0
10112	600	4112343	1980-09-17	1980-09-17 00:00:00	1980-09-29	1980-09-29 00:00:00	32020		\N	39639	0	195662009	4112343		0
10236	605	260139	2013-06-09	2013-06-09 00:00:00	2013-06-16	2013-06-16 00:00:00	32020		\N	40178	0	10509002	260139		0
10392	613	260139	2007-08-07	2007-08-07 00:00:00	2007-08-21	2007-08-21 00:00:00	32020		\N	40749	0	10509002	260139		0
10611	624	40481087	2010-04-19	2010-04-19 00:00:00	2010-05-03	2010-05-03 00:00:00	32020		\N	41655	0	444814009	40481087		0
81	3	80180	1957-12-08	1957-12-08 00:00:00	\N	\N	32020		\N	345	0	396275006	80180		0
269	12	40481087	1969-12-19	1969-12-19 00:00:00	1969-12-26	1969-12-26 00:00:00	32020		\N	1053	0	444814009	40481087		0
493	30	4112343	1988-03-14	1988-03-14 00:00:00	1988-03-24	1988-03-24 00:00:00	32020		\N	2102	0	195662009	4112343		0
626	35	40481087	1990-10-23	1990-10-23 00:00:00	1990-11-06	1990-11-06 00:00:00	32020		\N	2428	0	444814009	40481087		0
766	42	4112343	1981-10-29	1981-10-29 00:00:00	1981-11-11	1981-11-11 00:00:00	32020		\N	3135	0	195662009	4112343		0
11473	677	28060	1972-03-22	1972-03-22 00:00:00	1972-03-31	1972-03-31 00:00:00	32020		\N	44806	0	43878008	28060		0
1114	65	372328	1969-06-18	1969-06-18 00:00:00	1969-09-05	1969-09-05 00:00:00	32020		\N	4380	0	65363002	372328		0
1252	72	40481087	1979-01-10	1979-01-10 00:00:00	1979-01-24	1979-01-24 00:00:00	32020		\N	4884	0	444814009	40481087		0
1410	82	40481087	1961-08-25	1961-08-25 00:00:00	1961-09-01	1961-09-01 00:00:00	32020		\N	5602	0	444814009	40481087		0
1645	96	4112343	1947-09-22	1947-09-22 00:00:00	1947-10-03	1947-10-03 00:00:00	32020		\N	6550	0	195662009	4112343		0
1762	101	4112343	1930-05-06	1930-05-06 00:00:00	1930-05-18	1930-05-18 00:00:00	32020		\N	6833	0	195662009	4112343		0
1955	115	4112343	1965-09-15	1965-09-15 00:00:00	1965-09-26	1965-09-26 00:00:00	32020		\N	7564	0	195662009	4112343		0
2112	123	40481087	2012-10-16	2012-10-16 00:00:00	2012-10-23	2012-10-23 00:00:00	32020		\N	8132	0	444814009	40481087		0
12787	755	40481087	1988-05-01	1988-05-01 00:00:00	1988-05-08	1988-05-08 00:00:00	32020		\N	50047	0	444814009	40481087		0
2438	143	372328	2001-04-05	2001-04-05 00:00:00	2002-03-10	2002-03-10 00:00:00	32020		\N	9586	0	65363002	372328		0
2612	153	40481087	2001-10-03	2001-10-03 00:00:00	2001-10-24	2001-10-24 00:00:00	32020		\N	10327	0	444814009	40481087		0
2758	160	28060	1961-10-28	1961-10-28 00:00:00	1961-11-08	1961-11-08 00:00:00	32020		\N	10977	0	43878008	28060		0
2937	170	260139	2014-01-21	2014-01-21 00:00:00	2014-02-04	2014-02-04 00:00:00	32020		\N	11524	0	10509002	260139		0
3090	182	28060	2003-12-14	2003-12-14 00:00:00	2003-12-27	2003-12-27 00:00:00	32020		\N	12319	0	43878008	28060		0
3235	188	372328	1968-08-18	1968-08-18 00:00:00	1968-11-03	1968-11-03 00:00:00	32020		\N	12829	0	65363002	372328		0
3417	195	4112343	1976-11-22	1976-11-22 00:00:00	1976-12-05	1976-12-05 00:00:00	32020		\N	13390	0	195662009	4112343		0
3638	209	40481087	1971-02-15	1971-02-15 00:00:00	1971-02-22	1971-02-22 00:00:00	32020		\N	14248	0	444814009	40481087		0
3765	217	4112343	1979-05-18	1979-05-18 00:00:00	1979-05-27	1979-05-27 00:00:00	32020		\N	14643	0	195662009	4112343		0
3915	225	4155034	1978-04-06	1978-04-06 00:00:00	1978-04-20	1978-04-20 00:00:00	32020		\N	15143	0	283371005	4155034		0
4091	236	4109685	2009-01-21	2009-01-21 00:00:00	2009-02-11	2009-02-11 00:00:00	32020		\N	15918	0	284551006	4109685		0
4255	246	4155034	1975-02-03	1975-02-03 00:00:00	1975-02-24	1975-02-24 00:00:00	32020		\N	16545	0	283371005	4155034		0
4462	262	40481087	1986-12-25	1986-12-25 00:00:00	1987-01-08	1987-01-08 00:00:00	32020		\N	17389	0	444814009	40481087		0
4575	268	440448	1989-02-16	1989-02-16 00:00:00	\N	\N	32020		\N	17798	0	74400008	440448		0
4758	279	260139	1992-02-12	1992-02-12 00:00:00	1992-02-26	1992-02-26 00:00:00	32020		\N	18639	0	10509002	260139		0
4901	287	260139	2014-08-28	2014-08-28 00:00:00	2014-09-04	2014-09-04 00:00:00	32020		\N	19191	0	10509002	260139		0
5087	298	4155034	2000-12-16	2000-12-16 00:00:00	2001-01-06	2001-01-06 00:00:00	32020		\N	19884	0	283371005	4155034		0
5244	310	4112343	1976-11-25	1976-11-25 00:00:00	1976-12-02	1976-12-02 00:00:00	32020		\N	20505	0	195662009	4112343		0
5438	320	4218389	1961-11-03	1961-11-03 00:00:00	1961-12-01	1961-12-01 00:00:00	32020		\N	21233	0	39848009	4218389		0
5611	331	4112343	2018-11-30	2018-11-30 00:00:00	2018-12-10	2018-12-10 00:00:00	32020		\N	21863	0	195662009	4112343		0
5749	338	40481087	2016-02-22	2016-02-22 00:00:00	2016-03-07	2016-03-07 00:00:00	32020		\N	22500	0	444814009	40481087		0
5917	349	4112343	1959-07-26	1959-07-26 00:00:00	1959-08-05	1959-08-05 00:00:00	32020		\N	23195	0	195662009	4112343		0
6071	357	372328	1977-06-28	1977-06-28 00:00:00	1980-06-11	1980-06-11 00:00:00	32020		\N	23675	0	65363002	372328		0
6233	366	4283893	2009-12-13	2009-12-13 00:00:00	2010-10-31	2010-10-31 00:00:00	32020		\N	24310	0	36971009	4283893		0
6396	376	40481087	1967-02-17	1967-02-17 00:00:00	1967-03-03	1967-03-03 00:00:00	32020		\N	24914	0	444814009	40481087		0
6613	390	4112343	1977-03-29	1977-03-29 00:00:00	1977-04-05	1977-04-05 00:00:00	32020		\N	25616	0	195662009	4112343		0
6737	398	260139	1927-08-23	1927-08-23 00:00:00	1927-08-30	1927-08-30 00:00:00	32020		\N	26053	0	10509002	260139		0
6897	406	40481087	2000-02-16	2000-02-16 00:00:00	2000-03-08	2000-03-08 00:00:00	32020		\N	26771	0	444814009	40481087		0
7055	412	372328	1957-10-10	1957-10-10 00:00:00	1958-04-25	1958-04-25 00:00:00	32020		\N	27473	0	65363002	372328		0
7300	430	260139	1986-01-05	1986-01-05 00:00:00	1986-01-19	1986-01-19 00:00:00	32020		\N	28458	0	10509002	260139		0
7386	432	4001336	1958-02-05	1958-02-05 00:00:00	1958-03-07	1958-03-07 00:00:00	32020		\N	28712	0	110030002	4001336		0
7573	445	257012	1963-10-24	1963-10-24 00:00:00	\N	\N	32020		\N	29605	0	40055000	257012		0
7730	453	4296205	2004-02-05	2004-02-05 00:00:00	2004-03-04	2004-03-04 00:00:00	32020		\N	30240	0	403191005	4296205		0
7911	461	40481087	2000-01-25	2000-01-25 00:00:00	2000-02-01	2000-02-01 00:00:00	32020		\N	30781	0	444814009	40481087		0
8086	474	81151	1982-12-02	1982-12-02 00:00:00	1982-12-16	1982-12-16 00:00:00	32020		\N	31642	0	44465007	81151		0
8258	482	4112343	1979-08-02	1979-08-02 00:00:00	1979-08-09	1979-08-09 00:00:00	32020		\N	32256	0	195662009	4112343		0
8392	488	4278672	1966-06-30	1966-06-30 00:00:00	1966-07-30	1966-07-30 00:00:00	32020		\N	32697	0	65966004	4278672		0
8572	500	4027663	1986-09-13	1986-09-13 00:00:00	\N	\N	32020		\N	33511	0	13200003	4027663		0
8752	512	4112343	1973-08-15	1973-08-15 00:00:00	1973-08-28	1973-08-28 00:00:00	32020		\N	34204	0	195662009	4112343		0
19459	1169	40481087	1997-06-11	1997-06-11 00:00:00	1997-06-25	1997-06-25 00:00:00	32020		\N	77004	0	444814009	40481087		0
9072	533	4116491	1991-07-25	1991-07-25 00:00:00	1991-09-07	1991-09-07 00:00:00	32020		\N	35473	0	301011002	4116491		0
9255	546	40481087	1960-10-08	1960-10-08 00:00:00	1960-10-29	1960-10-29 00:00:00	32020		\N	36194	0	444814009	40481087		0
9432	558	4113008	2000-11-01	2000-11-01 00:00:00	2000-11-22	2000-11-22 00:00:00	32020		\N	36976	0	284549007	4113008		0
9590	569	78272	1916-09-03	1916-09-03 00:00:00	1916-09-24	1916-09-24 00:00:00	32020		\N	37659	0	70704007	78272		0
9725	576	40481087	1991-12-27	1991-12-27 00:00:00	1992-01-03	1992-01-03 00:00:00	32020		\N	38100	0	444814009	40481087		0
9914	587	4310024	2013-06-11	2013-06-11 00:00:00	\N	\N	32020		\N	38909	0	424802006	4310024		0
10113	600	78272	1973-06-25	1973-06-25 00:00:00	1973-07-09	1973-07-09 00:00:00	32020		\N	39646	0	70704007	78272		0
10237	605	372328	1957-01-11	1957-01-11 00:00:00	1957-02-22	1957-02-22 00:00:00	32020		\N	40179	0	65363002	372328		0
10393	613	4112343	1978-07-12	1978-07-12 00:00:00	1978-07-20	1978-07-20 00:00:00	32020		\N	40719	0	195662009	4112343		0
10612	624	40481087	2012-06-15	2012-06-15 00:00:00	2012-07-06	2012-07-06 00:00:00	32020		\N	41665	0	444814009	40481087		0
82	3	81893	1956-06-16	1956-06-16 00:00:00	\N	\N	32020		\N	282	0	64766004	81893		0
270	12	372328	1970-08-27	1970-08-27 00:00:00	1971-01-27	1971-01-27 00:00:00	32020		\N	1006	0	65363002	372328		0
494	30	260139	2018-04-23	2018-04-23 00:00:00	2018-04-30	2018-04-30 00:00:00	32020		\N	2114	0	10509002	260139		0
627	35	260139	2014-07-26	2014-07-26 00:00:00	2014-08-02	2014-08-02 00:00:00	32020		\N	2450	0	10509002	260139		0
767	42	372328	1914-07-09	1914-07-09 00:00:00	1914-10-13	1914-10-13 00:00:00	32020		\N	3138	0	65363002	372328		0
11474	677	40481087	1964-09-22	1964-09-22 00:00:00	1964-10-06	1964-10-06 00:00:00	32020		\N	44840	0	444814009	40481087		0
1115	65	40481087	1988-02-29	1988-02-29 00:00:00	1988-03-14	1988-03-14 00:00:00	32020		\N	4402	0	444814009	40481087		0
1253	72	4294548	2018-03-12	2018-03-12 00:00:00	2018-04-09	2018-04-09 00:00:00	32020		\N	4922	0	75498004	4294548		0
1411	82	40481087	2013-09-03	2013-09-03 00:00:00	2013-09-24	2013-09-24 00:00:00	32020		\N	5554	0	444814009	40481087		0
1646	96	4112343	1985-08-26	1985-08-26 00:00:00	1985-09-05	1985-09-05 00:00:00	32020		\N	6470	0	195662009	4112343		0
1763	101	4237458	2014-07-21	2014-07-21 00:00:00	2014-08-20	2014-08-20 00:00:00	32020		\N	6944	0	58150001	4237458		0
1956	115	4116491	1975-10-28	1975-10-28 00:00:00	1975-12-05	1975-12-05 00:00:00	32020		\N	7566	0	301011002	4116491		0
2113	123	260139	1972-02-13	1972-02-13 00:00:00	1972-02-20	1972-02-20 00:00:00	32020		\N	8122	0	10509002	260139		0
12788	755	40481087	1993-01-18	1993-01-18 00:00:00	1993-02-08	1993-02-08 00:00:00	32020		\N	50041	0	444814009	40481087		0
2439	143	4218389	1979-06-16	1979-06-16 00:00:00	1979-07-07	1979-07-07 00:00:00	32020		\N	9609	0	39848009	4218389		0
2613	153	40481087	2013-08-16	2013-08-16 00:00:00	2013-08-30	2013-08-30 00:00:00	32020		\N	10328	0	444814009	40481087		0
2759	160	257012	1985-12-11	1985-12-11 00:00:00	\N	\N	32020		\N	10946	0	40055000	257012		0
2938	170	4112343	2001-03-06	2001-03-06 00:00:00	2001-03-17	2001-03-17 00:00:00	32020		\N	11523	0	195662009	4112343		0
3091	182	40481087	2018-06-16	2018-06-16 00:00:00	2018-06-23	2018-06-23 00:00:00	32020		\N	12326	0	444814009	40481087		0
3236	188	192671	2000-02-09	2000-02-09 00:00:00	\N	\N	32020		\N	12813	0	K92.2	35208414		0
3418	195	40481087	2005-06-11	2005-06-11 00:00:00	2005-06-25	2005-06-25 00:00:00	32020		\N	13358	0	444814009	40481087		0
3639	209	4112343	1990-02-05	1990-02-05 00:00:00	1990-02-18	1990-02-18 00:00:00	32020		\N	14231	0	195662009	4112343		0
3766	217	4112343	2017-10-24	2017-10-24 00:00:00	2017-11-05	2017-11-05 00:00:00	32020		\N	14652	0	195662009	4112343		0
3916	225	28060	2013-09-25	2013-09-25 00:00:00	2013-10-02	2013-10-02 00:00:00	32020		\N	15199	0	43878008	28060		0
4092	236	372328	1952-01-28	1952-01-28 00:00:00	1952-02-28	1952-02-28 00:00:00	32020		\N	15853	0	65363002	372328		0
4256	246	81151	1980-06-27	1980-06-27 00:00:00	1980-07-11	1980-07-11 00:00:00	32020		\N	16546	0	44465007	81151		0
4463	262	440086	1978-07-31	1978-07-31 00:00:00	1982-08-09	1982-08-09 00:00:00	32020		\N	17361	0	192127007	440086		0
4576	268	4166224	1989-02-16	1989-02-16 00:00:00	\N	\N	32020		\N	17798	0	47693006	4166224		0
4759	279	40481087	2015-09-10	2015-09-10 00:00:00	2015-09-24	2015-09-24 00:00:00	32020		\N	18645	0	444814009	40481087		0
4902	287	40481087	2014-01-22	2014-01-22 00:00:00	2014-01-29	2014-01-29 00:00:00	32020		\N	19183	0	444814009	40481087		0
5088	298	40481087	1996-04-24	1996-04-24 00:00:00	1996-05-01	1996-05-01 00:00:00	32020		\N	19919	0	444814009	40481087		0
5245	310	40481087	1969-09-24	1969-09-24 00:00:00	1969-10-08	1969-10-08 00:00:00	32020		\N	20503	0	444814009	40481087		0
5439	320	40481087	1979-11-03	1979-11-03 00:00:00	1979-11-10	1979-11-10 00:00:00	32020		\N	21188	0	444814009	40481087		0
5612	331	40481087	1969-08-18	1969-08-18 00:00:00	1969-09-01	1969-09-01 00:00:00	32020		\N	21820	0	444814009	40481087		0
5750	338	40481087	2008-04-22	2008-04-22 00:00:00	2008-05-13	2008-05-13 00:00:00	32020		\N	22542	0	444814009	40481087		0
5918	349	4113008	2014-05-18	2014-05-18 00:00:00	2014-06-08	2014-06-08 00:00:00	32020		\N	23240	0	284549007	4113008		0
6072	357	4084167	1955-09-08	1955-09-08 00:00:00	1955-09-08	1955-09-08 00:00:00	32020		\N	23633	0	241929008	4084167		0
6234	366	260139	1965-07-10	1965-07-10 00:00:00	1965-07-17	1965-07-17 00:00:00	32020		\N	24274	0	10509002	260139		0
6397	376	40481087	1982-05-31	1982-05-31 00:00:00	1982-06-21	1982-06-21 00:00:00	32020		\N	24898	0	444814009	40481087		0
6614	390	4113008	1980-04-09	1980-04-09 00:00:00	1980-04-23	1980-04-23 00:00:00	32020		\N	25651	0	284549007	4113008		0
6738	398	260139	1948-02-13	1948-02-13 00:00:00	1948-02-27	1948-02-27 00:00:00	32020		\N	26085	0	10509002	260139		0
6898	406	40481087	1959-05-31	1959-05-31 00:00:00	1959-06-07	1959-06-07 00:00:00	32020		\N	26755	0	444814009	40481087		0
7056	412	372328	1953-08-13	1953-08-13 00:00:00	1953-10-23	1953-10-23 00:00:00	32020		\N	27466	0	65363002	372328		0
7301	430	40481087	1964-03-05	1964-03-05 00:00:00	1964-03-19	1964-03-19 00:00:00	32020		\N	28438	0	444814009	40481087		0
7387	432	313217	2014-06-23	2014-06-23 00:00:00	\N	\N	32020		\N	28655	0	49436004	313217		0
7574	445	40481087	1946-09-13	1946-09-13 00:00:00	1946-09-20	1946-09-20 00:00:00	32020		\N	29585	0	444814009	40481087		0
7731	453	40481087	1987-08-12	1987-08-12 00:00:00	1987-08-19	1987-08-19 00:00:00	32020		\N	30248	0	444814009	40481087		0
7912	461	260139	1951-12-10	1951-12-10 00:00:00	1951-12-24	1951-12-24 00:00:00	32020		\N	30805	0	10509002	260139		0
8087	474	4027663	1996-12-07	1996-12-07 00:00:00	\N	\N	32020		\N	31622	0	13200003	4027663		0
8259	482	4152936	2013-12-18	2013-12-18 00:00:00	2014-01-01	2014-01-01 00:00:00	32020		\N	32258	0	283385000	4152936		0
8393	488	260139	2002-04-01	2002-04-01 00:00:00	2002-04-15	2002-04-15 00:00:00	32020		\N	32651	0	10509002	260139		0
8573	500	4155034	1974-06-23	1974-06-23 00:00:00	1974-07-07	1974-07-07 00:00:00	32020		\N	33548	0	283371005	4155034		0
8753	512	4112343	1970-09-17	1970-09-17 00:00:00	1970-09-27	1970-09-27 00:00:00	32020		\N	34202	0	195662009	4112343		0
19460	1169	40481087	1960-03-28	1960-03-28 00:00:00	1960-04-18	1960-04-18 00:00:00	32020		\N	76968	0	444814009	40481087		0
9073	533	4112343	2002-12-26	2002-12-26 00:00:00	2003-01-05	2003-01-05 00:00:00	32020		\N	35497	0	195662009	4112343		0
9256	546	260139	1950-12-28	1950-12-28 00:00:00	1951-01-04	1951-01-04 00:00:00	32020		\N	36197	0	10509002	260139		0
9433	558	4296204	2002-12-12	2002-12-12 00:00:00	2003-01-09	2003-01-09 00:00:00	32020		\N	36977	0	403190006	4296204		0
9591	569	378001	1953-11-05	1953-11-05 00:00:00	1953-12-05	1953-12-05 00:00:00	32020		\N	37662	0	62106007	378001		0
9726	576	372328	1971-06-06	1971-06-06 00:00:00	1971-08-11	1971-08-11 00:00:00	32020		\N	38105	0	65363002	372328		0
9915	587	80180	2015-06-01	2015-06-01 00:00:00	\N	\N	32020		\N	38909	0	396275006	80180		0
10115	600	321042	1997-02-19	1997-02-19 00:00:00	\N	\N	32020		\N	39649	0	410429000	321042		0
10238	605	4146173	1993-06-22	1993-06-22 00:00:00	1993-07-22	1993-07-22 00:00:00	32020		\N	40127	0	307731004	4146173		0
10394	613	28060	1970-01-03	1970-01-03 00:00:00	1970-01-11	1970-01-11 00:00:00	32020		\N	40727	0	43878008	28060		0
10613	624	81151	2014-08-30	2014-08-30 00:00:00	2014-09-20	2014-09-20 00:00:00	32020		\N	41696	0	44465007	81151		0
83	3	40481087	1971-05-25	1971-05-25 00:00:00	1971-06-01	1971-06-01 00:00:00	32020		\N	363	0	444814009	40481087		0
271	12	260139	1986-10-23	1986-10-23 00:00:00	1986-10-30	1986-10-30 00:00:00	32020		\N	1019	0	10509002	260139		0
495	30	4109685	1980-06-14	1980-06-14 00:00:00	1980-07-05	1980-07-05 00:00:00	32020		\N	2075	0	284551006	4109685		0
628	35	4310024	1995-12-09	1995-12-09 00:00:00	\N	\N	32020		\N	2447	0	424802006	4310024		0
768	42	78272	1922-01-28	1922-01-28 00:00:00	1922-02-18	1922-02-18 00:00:00	32020		\N	3110	0	70704007	78272		0
11475	677	80180	1997-01-09	1997-01-09 00:00:00	\N	\N	32020		\N	44801	0	396275006	80180		0
1116	65	80180	2009-06-03	2009-06-03 00:00:00	\N	\N	32020		\N	4444	0	396275006	80180		0
1266	74	195588	2003-12-28	2003-12-28 00:00:00	2004-02-06	2004-02-06 00:00:00	32020		\N	4999	0	38822007	195588		0
1412	82	28060	2006-08-17	2006-08-17 00:00:00	2006-08-25	2006-08-25 00:00:00	32020		\N	5577	0	43878008	28060		0
1647	96	378001	1962-05-12	1962-05-12 00:00:00	1962-06-11	1962-06-11 00:00:00	32020		\N	6506	0	62106007	378001		0
1764	101	260139	1973-02-28	1973-02-28 00:00:00	1973-03-07	1973-03-07 00:00:00	32020		\N	6836	0	10509002	260139		0
1957	115	40481087	1968-07-03	1968-07-03 00:00:00	1968-07-10	1968-07-10 00:00:00	32020		\N	7565	0	444814009	40481087		0
2114	123	40481087	1957-07-09	1957-07-09 00:00:00	1957-07-23	1957-07-23 00:00:00	32020		\N	8150	0	444814009	40481087		0
12789	755	4278672	2016-01-28	2016-01-28 00:00:00	2016-03-28	2016-03-28 00:00:00	32020		\N	50012	0	65966004	4278672		0
2440	143	40481087	2014-09-03	2014-09-03 00:00:00	2014-09-10	2014-09-10 00:00:00	32020		\N	9551	0	444814009	40481087		0
2614	153	40481087	1948-04-22	1948-04-22 00:00:00	1948-04-29	1948-04-29 00:00:00	32020		\N	10365	0	444814009	40481087		0
2760	160	192671	2006-02-19	2006-02-19 00:00:00	\N	\N	32020		\N	11002	0	K92.2	35208414		0
2939	170	81151	1998-04-04	1998-04-04 00:00:00	1998-05-02	1998-05-02 00:00:00	32020		\N	11581	0	44465007	81151		0
3092	182	4283893	1998-12-01	1998-12-01 00:00:00	1999-03-23	1999-03-23 00:00:00	32020		\N	12296	0	36971009	4283893		0
3237	188	28060	2018-04-17	2018-04-17 00:00:00	2018-04-28	2018-04-28 00:00:00	32020		\N	12788	0	43878008	28060		0
3419	195	40481087	1998-02-28	1998-02-28 00:00:00	1998-03-14	1998-03-14 00:00:00	32020		\N	13402	0	444814009	40481087		0
3640	209	40481087	2000-08-20	2000-08-20 00:00:00	2000-09-10	2000-09-10 00:00:00	32020		\N	14266	0	444814009	40481087		0
3767	217	260139	2016-03-06	2016-03-06 00:00:00	2016-03-13	2016-03-13 00:00:00	32020		\N	14655	0	10509002	260139		0
3917	225	40481087	2014-06-14	2014-06-14 00:00:00	2014-06-21	2014-06-21 00:00:00	32020		\N	15250	0	444814009	40481087		0
4093	236	81151	2000-06-16	2000-06-16 00:00:00	2000-07-07	2000-07-07 00:00:00	32020		\N	15917	0	44465007	81151		0
4257	246	4112343	1984-12-03	1984-12-03 00:00:00	1984-12-16	1984-12-16 00:00:00	32020		\N	16589	0	195662009	4112343		0
4464	262	40481087	1980-10-16	1980-10-16 00:00:00	1980-11-06	1980-11-06 00:00:00	32020		\N	17406	0	444814009	40481087		0
4577	268	4112343	1979-07-06	1979-07-06 00:00:00	1979-07-17	1979-07-17 00:00:00	32020		\N	17833	0	195662009	4112343		0
4760	279	4294548	2002-12-29	2002-12-29 00:00:00	2003-01-19	2003-01-19 00:00:00	32020		\N	18595	0	75498004	4294548		0
4908	289	372328	1961-01-04	1961-01-04 00:00:00	1961-02-20	1961-02-20 00:00:00	32020		\N	19312	0	65363002	372328		0
5089	298	4112343	1975-08-24	1975-08-24 00:00:00	1975-09-03	1975-09-03 00:00:00	32020		\N	19895	0	195662009	4112343		0
5246	310	372328	1951-09-06	1951-09-06 00:00:00	1951-11-24	1951-11-24 00:00:00	32020		\N	20525	0	65363002	372328		0
5440	320	40481087	1960-05-05	1960-05-05 00:00:00	1960-05-26	1960-05-26 00:00:00	32020		\N	21222	0	444814009	40481087		0
5613	331	260139	1968-01-10	1968-01-10 00:00:00	1968-01-24	1968-01-24 00:00:00	32020		\N	21782	0	10509002	260139		0
5751	338	4084167	1975-09-04	1975-09-04 00:00:00	1975-09-04	1975-09-04 00:00:00	32020		\N	22598	0	241929008	4084167		0
5919	349	40481087	2008-09-11	2008-09-11 00:00:00	2008-09-25	2008-09-25 00:00:00	32020		\N	23182	0	444814009	40481087		0
6073	357	4112343	1982-12-11	1982-12-11 00:00:00	1982-12-18	1982-12-18 00:00:00	32020		\N	23664	0	195662009	4112343		0
6235	366	260139	1999-07-03	1999-07-03 00:00:00	1999-07-10	1999-07-10 00:00:00	32020		\N	24297	0	10509002	260139		0
6398	376	4155034	1977-12-29	1977-12-29 00:00:00	1978-01-12	1978-01-12 00:00:00	32020		\N	24940	0	283371005	4155034		0
6615	390	40481087	1989-12-19	1989-12-19 00:00:00	1990-01-09	1990-01-09 00:00:00	32020		\N	25612	0	444814009	40481087		0
6739	398	40481087	1957-05-31	1957-05-31 00:00:00	1957-06-07	1957-06-07 00:00:00	32020		\N	26055	0	444814009	40481087		0
6899	406	4112343	1984-09-29	1984-09-29 00:00:00	1984-10-12	1984-10-12 00:00:00	32020		\N	26811	0	195662009	4112343		0
7078	418	81151	1999-09-07	1999-09-07 00:00:00	1999-09-21	1999-09-21 00:00:00	32020		\N	27665	0	44465007	81151		0
7302	430	40481087	1937-03-27	1937-03-27 00:00:00	1937-04-17	1937-04-17 00:00:00	32020		\N	28452	0	444814009	40481087		0
7416	437	81151	1960-11-25	1960-11-25 00:00:00	1960-12-09	1960-12-09 00:00:00	32020		\N	29050	0	44465007	81151		0
7575	445	4283893	1963-09-12	1963-09-12 00:00:00	1963-10-31	1963-10-31 00:00:00	32020		\N	29588	0	36971009	4283893		0
7732	453	260139	1977-02-09	1977-02-09 00:00:00	1977-02-23	1977-02-23 00:00:00	32020		\N	30208	0	10509002	260139		0
7913	461	260139	1993-02-07	1993-02-07 00:00:00	1993-02-14	1993-02-14 00:00:00	32020		\N	30816	0	10509002	260139		0
8088	474	372328	1974-02-21	1974-02-21 00:00:00	1974-11-24	1974-11-24 00:00:00	32020		\N	31611	0	65363002	372328		0
8260	482	260139	1985-07-03	1985-07-03 00:00:00	1985-07-10	1985-07-10 00:00:00	32020		\N	32257	0	10509002	260139		0
8394	488	40481087	2002-08-07	2002-08-07 00:00:00	2002-08-14	2002-08-14 00:00:00	32020		\N	32675	0	444814009	40481087		0
8574	500	4112343	1983-04-26	1983-04-26 00:00:00	1983-05-07	1983-05-07 00:00:00	32020		\N	33489	0	195662009	4112343		0
8754	512	372328	1994-12-14	1994-12-14 00:00:00	1996-03-01	1996-03-01 00:00:00	32020		\N	34166	0	65363002	372328		0
19461	1169	4112343	2003-04-08	2003-04-08 00:00:00	2003-04-19	2003-04-19 00:00:00	32020		\N	77005	0	195662009	4112343		0
9074	533	80180	2003-11-14	2003-11-14 00:00:00	\N	\N	32020		\N	35497	0	396275006	80180		0
9257	546	4283893	1947-06-03	1947-06-03 00:00:00	1947-09-16	1947-09-16 00:00:00	32020		\N	36209	0	36971009	4283893		0
9434	558	4296204	1985-04-26	1985-04-26 00:00:00	1985-05-24	1985-05-24 00:00:00	32020		\N	37008	0	403190006	4296204		0
9592	569	40481087	1961-12-21	1961-12-21 00:00:00	1962-01-04	1962-01-04 00:00:00	32020		\N	37666	0	444814009	40481087		0
9727	576	440086	1973-08-29	1973-08-29 00:00:00	1974-07-03	1974-07-03 00:00:00	32020		\N	38094	0	192127007	440086		0
9916	587	30753	2014-03-08	2014-03-08 00:00:00	\N	\N	32020		\N	38909	0	16761005	30753		0
10116	600	4152936	1984-09-09	1984-09-09 00:00:00	1984-09-30	1984-09-30 00:00:00	32020		\N	39647	0	283385000	4152936		0
10239	605	4112343	1968-02-28	1968-02-28 00:00:00	1968-03-09	1968-03-09 00:00:00	32020		\N	40153	0	195662009	4112343		0
10395	613	40481087	1953-11-06	1953-11-06 00:00:00	1953-11-27	1953-11-27 00:00:00	32020		\N	40759	0	444814009	40481087		0
10614	624	40481087	1992-11-06	1992-11-06 00:00:00	1992-11-13	1992-11-13 00:00:00	32020		\N	41662	0	444814009	40481087		0
84	3	4218389	1923-12-22	1923-12-22 00:00:00	1924-01-12	1924-01-12 00:00:00	32020		\N	342	0	39848009	4218389		0
272	12	40481087	1977-09-24	1977-09-24 00:00:00	1977-10-15	1977-10-15 00:00:00	32020		\N	1018	0	444814009	40481087		0
496	30	40481087	2012-06-08	2012-06-08 00:00:00	2012-06-22	2012-06-22 00:00:00	32020		\N	2107	0	444814009	40481087		0
629	35	4237458	1984-05-15	1984-05-15 00:00:00	1984-06-14	1984-06-14 00:00:00	32020		\N	2392	0	58150001	4237458		0
769	42	260139	1985-02-03	1985-02-03 00:00:00	1985-02-17	1985-02-17 00:00:00	32020		\N	3066	0	10509002	260139		0
11476	677	4112343	2018-01-01	2018-01-01 00:00:00	2018-01-10	2018-01-10 00:00:00	32020		\N	44822	0	195662009	4112343		0
1117	65	40481087	2015-02-11	2015-02-11 00:00:00	2015-03-04	2015-03-04 00:00:00	32020		\N	4423	0	444814009	40481087		0
1267	74	260139	1998-12-02	1998-12-02 00:00:00	1998-12-16	1998-12-16 00:00:00	32020		\N	4988	0	10509002	260139		0
1413	82	260139	2006-03-11	2006-03-11 00:00:00	2006-03-18	2006-03-18 00:00:00	32020		\N	5569	0	10509002	260139		0
1648	96	4112343	1925-08-26	1925-08-26 00:00:00	1925-09-02	1925-09-02 00:00:00	32020		\N	6540	0	195662009	4112343		0
1765	101	40479768	1978-10-27	1978-10-27 00:00:00	1979-01-02	1979-01-02 00:00:00	32020		\N	6898	0	444470001	40479768		0
1958	115	4218389	1962-08-17	1962-08-17 00:00:00	1962-09-14	1962-09-14 00:00:00	32020		\N	7635	0	39848009	4218389		0
2115	123	4112343	1988-11-28	1988-11-28 00:00:00	1988-12-07	1988-12-07 00:00:00	32020		\N	8107	0	195662009	4112343		0
12790	755	4112343	2006-02-22	2006-02-22 00:00:00	2006-03-04	2006-03-04 00:00:00	32020		\N	50056	0	195662009	4112343		0
2441	143	40481087	2014-04-13	2014-04-13 00:00:00	2014-04-27	2014-04-27 00:00:00	32020		\N	9570	0	444814009	40481087		0
2615	153	28060	1951-07-07	1951-07-07 00:00:00	1951-07-15	1951-07-15 00:00:00	32020		\N	10405	0	43878008	28060		0
2761	160	40481087	1973-02-27	1973-02-27 00:00:00	1973-03-06	1973-03-06 00:00:00	32020		\N	10937	0	444814009	40481087		0
2940	170	40481087	1984-01-30	1984-01-30 00:00:00	1984-02-13	1984-02-13 00:00:00	32020		\N	11532	0	444814009	40481087		0
3093	182	80180	1995-05-17	1995-05-17 00:00:00	\N	\N	32020		\N	12332	0	396275006	80180		0
3238	188	260139	1986-03-28	1986-03-28 00:00:00	1986-04-04	1986-04-04 00:00:00	32020		\N	12825	0	10509002	260139		0
3420	196	4237458	1966-06-15	1966-06-15 00:00:00	1966-08-14	1966-08-14 00:00:00	32020		\N	13449	0	58150001	4237458		0
3641	209	40481087	2009-05-02	2009-05-02 00:00:00	2009-05-16	2009-05-16 00:00:00	32020		\N	14237	0	444814009	40481087		0
3768	217	260139	1997-09-04	1997-09-04 00:00:00	1997-09-11	1997-09-11 00:00:00	32020		\N	14649	0	10509002	260139		0
3918	225	81151	1965-11-30	1965-11-30 00:00:00	1965-12-28	1965-12-28 00:00:00	32020		\N	15147	0	44465007	81151		0
4094	236	257012	2004-07-12	2004-07-12 00:00:00	\N	\N	32020		\N	15852	0	40055000	257012		0
4258	246	28060	1964-09-13	1964-09-13 00:00:00	1964-09-26	1964-09-26 00:00:00	32020		\N	16521	0	43878008	28060		0
4465	262	40481087	1986-01-19	1986-01-19 00:00:00	1986-02-09	1986-02-09 00:00:00	32020		\N	17388	0	444814009	40481087		0
4578	268	28060	1969-10-12	1969-10-12 00:00:00	1969-10-22	1969-10-22 00:00:00	32020		\N	17832	0	43878008	28060		0
4761	279	260139	1971-02-06	1971-02-06 00:00:00	1971-02-13	1971-02-13 00:00:00	32020		\N	18637	0	10509002	260139		0
4909	289	4134304	1970-09-15	1970-09-15 00:00:00	1970-12-13	1970-12-13 00:00:00	32020		\N	19328	0	263102004	4134304		0
5090	298	260139	2008-02-02	2008-02-02 00:00:00	2008-02-16	2008-02-16 00:00:00	32020		\N	19920	0	10509002	260139		0
5247	310	40481087	1968-11-29	1968-11-29 00:00:00	1968-12-20	1968-12-20 00:00:00	32020		\N	20502	0	444814009	40481087		0
5441	320	40479422	1974-02-22	1974-02-22 00:00:00	1974-04-30	1974-04-30 00:00:00	32020		\N	21236	0	444448004	40479422		0
5614	331	260139	1999-12-31	1999-12-31 00:00:00	2000-01-14	2000-01-14 00:00:00	32020		\N	21783	0	10509002	260139		0
5752	338	4112343	2016-05-08	2016-05-08 00:00:00	2016-05-15	2016-05-15 00:00:00	32020		\N	22585	0	195662009	4112343		0
5920	349	40481087	1995-05-02	1995-05-02 00:00:00	1995-05-16	1995-05-16 00:00:00	32020		\N	23244	0	444814009	40481087		0
6074	357	4027663	1988-10-04	1988-10-04 00:00:00	\N	\N	32020		\N	23647	0	13200003	4027663		0
6236	366	40481087	1937-07-15	1937-07-15 00:00:00	1937-07-29	1937-07-29 00:00:00	32020		\N	24381	0	444814009	40481087		0
6399	376	40481087	1974-10-26	1974-10-26 00:00:00	1974-11-02	1974-11-02 00:00:00	32020		\N	24915	0	444814009	40481087		0
6616	390	260139	2015-05-20	2015-05-20 00:00:00	2015-05-27	2015-05-27 00:00:00	32020		\N	25631	0	10509002	260139		0
6740	398	372328	1925-12-22	1925-12-22 00:00:00	1926-02-06	1926-02-06 00:00:00	32020		\N	26087	0	65363002	372328		0
6900	406	40481087	2008-10-29	2008-10-29 00:00:00	2008-11-19	2008-11-19 00:00:00	32020		\N	26773	0	444814009	40481087		0
7079	418	40481087	2002-10-22	2002-10-22 00:00:00	2002-11-12	2002-11-12 00:00:00	32020		\N	27614	0	444814009	40481087		0
7303	430	40481087	2008-10-12	2008-10-12 00:00:00	2008-10-26	2008-10-26 00:00:00	32020		\N	28443	0	444814009	40481087		0
7417	437	78272	2010-05-19	2010-05-19 00:00:00	2010-06-16	2010-06-16 00:00:00	32020		\N	29053	0	70704007	78272		0
7576	445	260139	1947-09-13	1947-09-13 00:00:00	1947-09-27	1947-09-27 00:00:00	32020		\N	29602	0	10509002	260139		0
7733	454	4112343	1937-07-28	1937-07-28 00:00:00	1937-08-09	1937-08-09 00:00:00	32020		\N	30319	0	195662009	4112343		0
7914	461	260139	2011-03-11	2011-03-11 00:00:00	2011-03-18	2011-03-18 00:00:00	32020		\N	30796	0	10509002	260139		0
8089	474	4156265	1990-09-05	1990-09-05 00:00:00	1990-09-26	1990-09-26 00:00:00	32020		\N	31643	0	370247008	4156265		0
8261	482	4112343	2009-04-18	2009-04-18 00:00:00	2009-04-29	2009-04-29 00:00:00	32020		\N	32232	0	195662009	4112343		0
8395	488	4112343	1976-04-22	1976-04-22 00:00:00	1976-05-05	1976-05-05 00:00:00	32020		\N	32623	0	195662009	4112343		0
8575	500	4142905	2013-03-19	2013-03-19 00:00:00	2013-05-18	2013-05-18 00:00:00	32020		\N	33550	0	33737001	4142905		0
8755	512	40481087	2006-01-17	2006-01-17 00:00:00	2006-01-24	2006-01-24 00:00:00	32020		\N	34178	0	444814009	40481087		0
19462	1169	260139	1944-09-09	1944-09-09 00:00:00	1944-09-23	1944-09-23 00:00:00	32020		\N	76958	0	10509002	260139		0
9075	533	260139	1981-05-29	1981-05-29 00:00:00	1981-06-12	1981-06-12 00:00:00	32020		\N	35398	0	10509002	260139		0
9258	546	4059173	1946-11-28	1946-11-28 00:00:00	1946-12-28	1946-12-28 00:00:00	32020		\N	36149	0	16114001	4059173		0
9435	558	192671	2002-03-22	2002-03-22 00:00:00	\N	\N	32020		\N	37006	0	K92.2	35208414		0
9593	569	4112343	1993-04-14	1993-04-14 00:00:00	1993-04-24	1993-04-24 00:00:00	32020		\N	37639	0	195662009	4112343		0
9728	576	40481087	2013-03-09	2013-03-09 00:00:00	2013-03-23	2013-03-23 00:00:00	32020		\N	38130	0	444814009	40481087		0
9917	587	4027663	2008-03-14	2008-03-14 00:00:00	\N	\N	32020		\N	38907	0	13200003	4027663		0
10117	600	4112343	1974-01-06	1974-01-06 00:00:00	1974-01-19	1974-01-19 00:00:00	32020		\N	39626	0	195662009	4112343		0
10240	605	260139	1961-03-22	1961-03-22 00:00:00	1961-04-05	1961-04-05 00:00:00	32020		\N	40115	0	10509002	260139		0
10396	613	40481087	1956-01-17	1956-01-17 00:00:00	1956-01-24	1956-01-24 00:00:00	32020		\N	40733	0	444814009	40481087		0
10615	624	257012	1945-04-24	1945-04-24 00:00:00	\N	\N	32020		\N	41634	0	40055000	257012		0
85	3	440448	1972-12-20	1972-12-20 00:00:00	\N	\N	32020		\N	347	0	74400008	440448		0
290	16	40481087	1985-08-05	1985-08-05 00:00:00	1985-08-26	1985-08-26 00:00:00	32020		\N	1260	0	444814009	40481087		0
497	30	260139	2013-12-06	2013-12-06 00:00:00	2013-12-14	2013-12-14 00:00:00	32020		\N	2107	0	10509002	260139		0
630	35	40481087	1983-12-01	1983-12-01 00:00:00	1983-12-15	1983-12-15 00:00:00	32020		\N	2397	0	444814009	40481087		0
770	42	40481087	1994-03-26	1994-03-26 00:00:00	1994-04-16	1994-04-16 00:00:00	32020		\N	3058	0	444814009	40481087		0
11477	677	4218389	1977-09-11	1977-09-11 00:00:00	1977-10-16	1977-10-16 00:00:00	32020		\N	44811	0	39848009	4218389		0
1118	65	260139	2009-05-28	2009-05-28 00:00:00	2009-06-04	2009-06-04 00:00:00	32020		\N	4422	0	10509002	260139		0
1268	74	80180	2015-08-12	2015-08-12 00:00:00	\N	\N	32020		\N	4987	0	396275006	80180		0
1414	82	4278672	1973-09-14	1973-09-14 00:00:00	1973-11-13	1973-11-13 00:00:00	32020		\N	5568	0	65966004	4278672		0
1649	96	261325	1951-05-26	1951-05-26 00:00:00	\N	\N	32020		\N	6487	0	87433001	261325		0
1766	101	40481087	1940-06-18	1940-06-18 00:00:00	1940-07-02	1940-07-02 00:00:00	32020		\N	6912	0	444814009	40481087		0
1959	115	81151	2011-04-14	2011-04-14 00:00:00	2011-04-28	2011-04-28 00:00:00	32020		\N	7638	0	44465007	81151		0
2116	123	28060	1998-11-18	1998-11-18 00:00:00	1998-11-25	1998-11-25 00:00:00	32020		\N	8109	0	43878008	28060		0
12791	755	40481087	1996-04-22	1996-04-22 00:00:00	1996-05-06	1996-05-06 00:00:00	32020		\N	50048	0	444814009	40481087		0
2442	143	4112343	1988-06-14	1988-06-14 00:00:00	1988-06-27	1988-06-27 00:00:00	32020		\N	9569	0	195662009	4112343		0
2616	153	4112343	1961-07-23	1961-07-23 00:00:00	1961-07-30	1961-07-30 00:00:00	32020		\N	10385	0	195662009	4112343		0
2762	160	195588	1992-10-21	1992-10-21 00:00:00	1992-12-08	1992-12-08 00:00:00	32020		\N	10948	0	38822007	195588		0
2941	170	28060	2003-12-21	2003-12-21 00:00:00	2004-01-02	2004-01-02 00:00:00	32020		\N	11535	0	43878008	28060		0
3094	182	4112343	1988-02-24	1988-02-24 00:00:00	1988-03-05	1988-03-05 00:00:00	32020		\N	12278	0	195662009	4112343		0
3239	188	260139	1981-09-10	1981-09-10 00:00:00	1981-09-17	1981-09-17 00:00:00	32020		\N	12786	0	10509002	260139		0
3421	196	257012	1958-02-07	1958-02-07 00:00:00	\N	\N	32020		\N	13486	0	40055000	257012		0
3642	209	4112343	1960-02-28	1960-02-28 00:00:00	1960-03-07	1960-03-07 00:00:00	32020		\N	14259	0	195662009	4112343		0
3769	217	4112343	1986-11-14	1986-11-14 00:00:00	1986-11-21	1986-11-21 00:00:00	32020		\N	14680	0	195662009	4112343		0
3919	225	40481087	2005-04-02	2005-04-02 00:00:00	2005-04-23	2005-04-23 00:00:00	32020		\N	15174	0	444814009	40481087		0
4095	236	4266809	1990-10-28	1990-10-28 00:00:00	\N	\N	32020		\N	15956	0	397881000	4266809		0
4259	246	260139	2003-05-23	2003-05-23 00:00:00	2003-06-06	2003-06-06 00:00:00	32020		\N	16506	0	10509002	260139		0
4466	262	192671	1999-12-29	1999-12-29 00:00:00	\N	\N	32020		\N	17410	0	K92.2	35208414		0
4579	268	80180	2004-01-28	2004-01-28 00:00:00	\N	\N	32020		\N	17835	0	396275006	80180		0
4762	279	4112343	2001-10-22	2001-10-22 00:00:00	2001-10-31	2001-10-31 00:00:00	32020		\N	18622	0	195662009	4112343		0
4910	289	372328	1964-11-09	1964-11-09 00:00:00	1965-03-01	1965-03-01 00:00:00	32020		\N	19285	0	65363002	372328		0
5091	298	372328	1953-01-03	1953-01-03 00:00:00	1953-03-17	1953-03-17 00:00:00	32020		\N	19923	0	65363002	372328		0
5248	310	40481087	1957-10-31	1957-10-31 00:00:00	1957-11-21	1957-11-21 00:00:00	32020		\N	20558	0	444814009	40481087		0
5442	320	4152936	1960-12-24	1960-12-24 00:00:00	1961-01-07	1961-01-07 00:00:00	32020		\N	21232	0	283385000	4152936		0
5615	331	4112343	1944-01-19	1944-01-19 00:00:00	1944-01-31	1944-01-31 00:00:00	32020		\N	21815	0	195662009	4112343		0
5753	338	4112343	1968-06-16	1968-06-16 00:00:00	1968-06-26	1968-06-26 00:00:00	32020		\N	22565	0	195662009	4112343		0
5921	349	81151	2001-09-09	2001-09-09 00:00:00	2001-09-23	2001-09-23 00:00:00	32020		\N	23242	0	44465007	81151		0
6075	357	372328	1956-03-06	1956-03-06 00:00:00	1956-03-20	1956-03-20 00:00:00	32020		\N	23623	0	65363002	372328		0
6237	366	40481087	1933-01-18	1933-01-18 00:00:00	1933-02-08	1933-02-08 00:00:00	32020		\N	24280	0	444814009	40481087		0
6400	376	260139	1986-12-31	1986-12-31 00:00:00	1987-01-14	1987-01-14 00:00:00	32020		\N	24922	0	10509002	260139		0
6628	392	192671	2012-05-14	2012-05-14 00:00:00	\N	\N	32020		\N	25743	0	K92.2	35208414		0
6741	399	4112343	1962-02-22	1962-02-22 00:00:00	1962-03-04	1962-03-04 00:00:00	32020		\N	26161	0	195662009	4112343		0
6901	406	40481087	1971-03-01	1971-03-01 00:00:00	1971-03-15	1971-03-15 00:00:00	32020		\N	26719	0	444814009	40481087		0
7080	418	40481087	2001-02-08	2001-02-08 00:00:00	2001-02-22	2001-02-22 00:00:00	32020		\N	27601	0	444814009	40481087		0
7304	430	40481087	2002-06-19	2002-06-19 00:00:00	2002-07-10	2002-07-10 00:00:00	32020		\N	28440	0	444814009	40481087		0
7418	437	4112343	2007-06-03	2007-06-03 00:00:00	2007-06-11	2007-06-11 00:00:00	32020		\N	28977	0	195662009	4112343		0
7577	445	260139	1931-03-13	1931-03-13 00:00:00	1931-03-27	1931-03-27 00:00:00	32020		\N	29555	0	10509002	260139		0
7734	454	4112343	1980-11-08	1980-11-08 00:00:00	1980-11-15	1980-11-15 00:00:00	32020		\N	30268	0	195662009	4112343		0
7915	461	4310024	1983-05-15	1983-05-15 00:00:00	\N	\N	32020		\N	30838	0	424802006	4310024		0
8090	474	4294548	1975-07-21	1975-07-21 00:00:00	1975-08-11	1975-08-11 00:00:00	32020		\N	31644	0	75498004	4294548		0
8262	482	4113008	1980-09-25	1980-09-25 00:00:00	1980-10-16	1980-10-16 00:00:00	32020		\N	32228	0	284549007	4113008		0
8396	488	372328	1956-06-22	1956-06-22 00:00:00	1956-09-07	1956-09-07 00:00:00	32020		\N	32622	0	65363002	372328		0
8576	500	78272	1965-06-21	1965-06-21 00:00:00	1965-07-05	1965-07-05 00:00:00	32020		\N	33545	0	70704007	78272		0
8756	512	40481087	1972-11-02	1972-11-02 00:00:00	1972-11-23	1972-11-23 00:00:00	32020		\N	34203	0	444814009	40481087		0
19463	1169	4112343	2001-03-06	2001-03-06 00:00:00	2001-03-15	2001-03-15 00:00:00	32020		\N	77032	0	195662009	4112343		0
9076	533	4142905	1979-07-24	1979-07-24 00:00:00	1979-08-23	1979-08-23 00:00:00	32020		\N	35369	0	33737001	4142905		0
9259	546	4116491	1982-11-04	1982-11-04 00:00:00	1982-12-07	1982-12-07 00:00:00	32020		\N	36196	0	301011002	4116491		0
9436	558	40481087	2014-08-03	2014-08-03 00:00:00	2014-08-17	2014-08-17 00:00:00	32020		\N	37028	0	444814009	40481087		0
9594	569	40481087	2008-06-16	2008-06-16 00:00:00	2008-06-30	2008-06-30 00:00:00	32020		\N	37644	0	444814009	40481087		0
9729	576	40486433	1971-09-06	1971-09-06 00:00:00	\N	\N	32020		\N	38093	0	446096008	40486433		0
9918	587	4112343	2009-06-23	2009-06-23 00:00:00	2009-06-30	2009-06-30 00:00:00	32020		\N	38891	0	195662009	4112343		0
10118	600	440086	1968-01-03	1968-01-03 00:00:00	1972-01-12	1972-01-12 00:00:00	32020		\N	39617	0	192127007	440086		0
10241	606	372328	1975-07-12	1975-07-12 00:00:00	1975-10-22	1975-10-22 00:00:00	32020		\N	40254	0	65363002	372328		0
10397	613	4112343	1994-10-26	1994-10-26 00:00:00	1994-11-06	1994-11-06 00:00:00	32020		\N	40737	0	195662009	4112343		0
10616	624	40481087	2012-03-18	2012-03-18 00:00:00	2012-04-08	2012-04-08 00:00:00	32020		\N	41674	0	444814009	40481087		0
86	3	4166224	1972-12-20	1972-12-20 00:00:00	\N	\N	32020		\N	347	0	47693006	4166224		0
291	16	260139	1994-01-01	1994-01-01 00:00:00	1994-01-08	1994-01-08 00:00:00	32020		\N	1202	0	10509002	260139		0
498	30	40481087	2018-04-13	2018-04-13 00:00:00	2018-04-27	2018-04-27 00:00:00	32020		\N	2113	0	444814009	40481087		0
631	35	40481087	2006-10-29	2006-10-29 00:00:00	2006-11-05	2006-11-05 00:00:00	32020		\N	2435	0	444814009	40481087		0
771	42	134438	1935-11-03	1935-11-03 00:00:00	1936-09-28	1936-09-28 00:00:00	32020		\N	3061	0	40275004	134438		0
11478	677	372328	1965-03-13	1965-03-13 00:00:00	1965-05-07	1965-05-07 00:00:00	32020		\N	44825	0	65363002	372328		0
1119	66	4112343	1968-04-18	1968-04-18 00:00:00	1968-04-27	1968-04-27 00:00:00	32020		\N	4474	0	195662009	4112343		0
1269	74	4266809	2015-08-12	2015-08-12 00:00:00	\N	\N	32020		\N	4987	0	397881000	4266809		0
1415	82	260139	2004-04-05	2004-04-05 00:00:00	2004-04-19	2004-04-19 00:00:00	32020		\N	5539	0	10509002	260139		0
1650	96	40481087	1968-06-15	1968-06-15 00:00:00	1968-07-06	1968-07-06 00:00:00	32020		\N	6530	0	444814009	40481087		0
1767	101	4152936	1986-12-21	1986-12-21 00:00:00	1987-01-04	1987-01-04 00:00:00	32020		\N	6900	0	283385000	4152936		0
3146	185	317576	1996-02-18	1996-02-18 00:00:00	\N	\N	32020		\N	12572	0	53741008	317576		0
1960	115	372328	1960-12-25	1960-12-25 00:00:00	1961-01-08	1961-01-08 00:00:00	32020		\N	7623	0	65363002	372328		0
2117	123	40481087	2012-03-30	2012-03-30 00:00:00	2012-04-13	2012-04-13 00:00:00	32020		\N	8110	0	444814009	40481087		0
12792	755	40481087	1997-07-08	1997-07-08 00:00:00	1997-07-29	1997-07-29 00:00:00	32020		\N	50066	0	444814009	40481087		0
2443	143	4218389	2004-08-24	2004-08-24 00:00:00	2004-09-28	2004-09-28 00:00:00	32020		\N	9611	0	39848009	4218389		0
2617	153	40481087	1996-08-17	1996-08-17 00:00:00	1996-08-24	1996-08-24 00:00:00	32020		\N	10326	0	444814009	40481087		0
2763	160	4056621	1992-10-21	1992-10-21 00:00:00	\N	\N	32020		\N	10948	0	197927001	4056621		0
2942	170	40481087	1991-07-14	1991-07-14 00:00:00	1991-08-04	1991-08-04 00:00:00	32020		\N	11569	0	444814009	40481087		0
3095	183	40481087	1975-06-29	1975-06-29 00:00:00	1975-07-06	1975-07-06 00:00:00	32020		\N	12358	0	444814009	40481087		0
3240	188	81151	2011-10-30	2011-10-30 00:00:00	2011-11-20	2011-11-20 00:00:00	32020		\N	12785	0	44465007	81151		0
3422	196	4218389	1984-04-16	1984-04-16 00:00:00	1984-05-14	1984-05-14 00:00:00	32020		\N	13451	0	39848009	4218389		0
3643	209	4296205	2003-01-21	2003-01-21 00:00:00	2003-02-04	2003-02-04 00:00:00	32020		\N	14268	0	403191005	4296205		0
3770	217	40481087	1994-05-21	1994-05-21 00:00:00	1994-06-11	1994-06-11 00:00:00	32020		\N	14648	0	444814009	40481087		0
3920	225	80180	2005-07-13	2005-07-13 00:00:00	\N	\N	32020		\N	15174	0	396275006	80180		0
4096	236	80180	1990-10-28	1990-10-28 00:00:00	\N	\N	32020		\N	15956	0	396275006	80180		0
4260	246	4112343	1970-11-26	1970-11-26 00:00:00	1970-12-03	1970-12-03 00:00:00	32020		\N	16523	0	195662009	4112343		0
4467	262	4112343	1985-01-10	1985-01-10 00:00:00	1985-01-22	1985-01-22 00:00:00	32020		\N	17363	0	195662009	4112343		0
4580	268	4112343	2007-08-03	2007-08-03 00:00:00	2007-08-11	2007-08-11 00:00:00	32020		\N	17780	0	195662009	4112343		0
4763	279	40481087	1957-12-20	1957-12-20 00:00:00	1958-01-10	1958-01-10 00:00:00	32020		\N	18632	0	444814009	40481087		0
4911	289	40481087	2015-06-13	2015-06-13 00:00:00	2015-06-27	2015-06-27 00:00:00	32020		\N	19284	0	444814009	40481087		0
5092	298	4296205	2014-02-11	2014-02-11 00:00:00	2014-03-04	2014-03-04 00:00:00	32020		\N	19915	0	403191005	4296205		0
5249	310	260139	1952-02-04	1952-02-04 00:00:00	1952-02-18	1952-02-18 00:00:00	32020		\N	20500	0	10509002	260139		0
5443	320	4152936	1995-08-08	1995-08-08 00:00:00	1995-08-29	1995-08-29 00:00:00	32020		\N	21237	0	283385000	4152936		0
5616	332	260139	2019-03-30	2019-03-30 00:00:00	2019-04-13	2019-04-13 00:00:00	32020		\N	21938	0	10509002	260139		0
5754	338	40481087	2014-02-18	2014-02-18 00:00:00	2014-02-25	2014-02-25 00:00:00	32020		\N	22584	0	444814009	40481087		0
5922	349	4237458	1969-08-28	1969-08-28 00:00:00	1969-10-27	1969-10-27 00:00:00	32020		\N	23241	0	58150001	4237458		0
6076	357	28060	1967-06-11	1967-06-11 00:00:00	1967-06-21	1967-06-21 00:00:00	32020		\N	23735	0	43878008	28060		0
6238	366	260139	1970-11-13	1970-11-13 00:00:00	1970-11-20	1970-11-20 00:00:00	32020		\N	24307	0	10509002	260139		0
6401	376	260139	1973-05-26	1973-05-26 00:00:00	1973-06-02	1973-06-02 00:00:00	32020		\N	24902	0	10509002	260139		0
6629	392	4283893	2000-03-03	2000-03-03 00:00:00	2000-03-31	2000-03-31 00:00:00	32020		\N	25705	0	36971009	4283893		0
6742	399	4112343	1955-09-02	1955-09-02 00:00:00	1955-09-14	1955-09-14 00:00:00	32020		\N	26250	0	195662009	4112343		0
6902	406	40481087	1965-04-26	1965-04-26 00:00:00	1965-05-10	1965-05-10 00:00:00	32020		\N	26828	0	444814009	40481087		0
7081	418	40481087	1997-12-23	1997-12-23 00:00:00	1998-01-06	1998-01-06 00:00:00	32020		\N	27613	0	444814009	40481087		0
17766	1070	40481087	1977-02-14	1977-02-14 00:00:00	1977-02-21	1977-02-21 00:00:00	32020		\N	70060	0	444814009	40481087		0
7419	437	40481087	1962-10-19	1962-10-19 00:00:00	1962-11-09	1962-11-09 00:00:00	32020		\N	29011	0	444814009	40481087		0
7578	445	40481087	1990-12-12	1990-12-12 00:00:00	1990-12-19	1990-12-19 00:00:00	32020		\N	29625	0	444814009	40481087		0
7735	454	4116491	1954-02-25	1954-02-25 00:00:00	1954-03-31	1954-03-31 00:00:00	32020		\N	30279	0	301011002	4116491		0
7916	461	81893	1983-10-12	1983-10-12 00:00:00	\N	\N	32020		\N	30838	0	64766004	81893		0
8091	474	4152936	1976-05-11	1976-05-11 00:00:00	1976-06-01	1976-06-01 00:00:00	32020		\N	31640	0	283385000	4152936		0
8263	482	4278672	1971-11-12	1971-11-12 00:00:00	1972-02-10	1972-02-10 00:00:00	32020		\N	32227	0	65966004	4278672		0
8397	488	40481087	2013-11-23	2013-11-23 00:00:00	2013-12-14	2013-12-14 00:00:00	32020		\N	32652	0	444814009	40481087		0
8577	500	80180	1998-09-25	1998-09-25 00:00:00	\N	\N	32020		\N	33498	0	396275006	80180		0
8757	512	4155034	2013-07-14	2013-07-14 00:00:00	2013-07-28	2013-07-28 00:00:00	32020		\N	34171	0	283371005	4155034		0
19464	1169	321042	2012-02-20	2012-02-20 00:00:00	\N	\N	32020		\N	76990	0	410429000	321042		0
9077	533	4278672	1963-06-27	1963-06-27 00:00:00	1963-08-26	1963-08-26 00:00:00	32020		\N	35367	0	65966004	4278672		0
9260	546	260139	2001-01-03	2001-01-03 00:00:00	2001-01-17	2001-01-17 00:00:00	32020		\N	36179	0	10509002	260139		0
9437	558	4278672	1977-11-04	1977-11-04 00:00:00	1978-02-02	1978-02-02 00:00:00	32020		\N	37007	0	65966004	4278672		0
9595	569	381316	1998-02-21	1998-02-21 00:00:00	\N	\N	32020		\N	37710	0	230690007	381316		0
9730	576	28060	1997-07-31	1997-07-31 00:00:00	1997-08-13	1997-08-13 00:00:00	32020		\N	38073	0	43878008	28060		0
9919	587	257012	1994-06-23	1994-06-23 00:00:00	\N	\N	32020		\N	38870	0	40055000	257012		0
10119	600	4237458	1956-02-25	1956-02-25 00:00:00	1956-03-26	1956-03-26 00:00:00	32020		\N	39644	0	58150001	4237458		0
10242	606	4112343	1992-03-28	1992-03-28 00:00:00	1992-04-04	1992-04-04 00:00:00	32020		\N	40261	0	195662009	4112343		0
10398	613	4001336	1954-08-07	1954-08-07 00:00:00	1954-10-06	1954-10-06 00:00:00	32020		\N	40777	0	110030002	4001336		0
10617	624	4109685	1973-04-23	1973-04-23 00:00:00	1973-05-07	1973-05-07 00:00:00	32020		\N	41693	0	284551006	4109685		0
87	3	40481087	1934-06-02	1934-06-02 00:00:00	1934-06-09	1934-06-09 00:00:00	32020		\N	259	0	444814009	40481087		0
292	16	40481087	2005-12-03	2005-12-03 00:00:00	2005-12-17	2005-12-17 00:00:00	32020		\N	1203	0	444814009	40481087		0
10957	648	4218389	1963-07-07	1963-07-07 00:00:00	1963-08-11	1963-08-11 00:00:00	32020		\N	42962	0	39848009	4218389		0
632	35	192671	1997-07-25	1997-07-25 00:00:00	\N	\N	32020		\N	2415	0	K92.2	35208414		0
772	42	80180	1950-05-16	1950-05-16 00:00:00	\N	\N	32020		\N	3015	0	396275006	80180		0
11479	677	40481087	1970-03-07	1970-03-07 00:00:00	1970-03-21	1970-03-21 00:00:00	32020		\N	44841	0	444814009	40481087		0
1120	66	40481087	2017-05-31	2017-05-31 00:00:00	2017-06-07	2017-06-07 00:00:00	32020		\N	4484	0	444814009	40481087		0
1270	74	372328	1977-07-07	1977-07-07 00:00:00	1977-10-19	1977-10-19 00:00:00	32020		\N	5016	0	65363002	372328		0
1416	82	40481087	1989-07-31	1989-07-31 00:00:00	1989-08-21	1989-08-21 00:00:00	32020		\N	5572	0	444814009	40481087		0
1651	96	260139	1940-05-16	1940-05-16 00:00:00	1940-05-30	1940-05-30 00:00:00	32020		\N	6510	0	10509002	260139		0
1768	101	4218389	1955-06-20	1955-06-20 00:00:00	1955-07-25	1955-07-25 00:00:00	32020		\N	6895	0	39848009	4218389		0
1961	115	192671	2001-04-15	2001-04-15 00:00:00	\N	\N	32020		\N	7634	0	K92.2	35208414		0
2118	123	40481087	1991-03-09	1991-03-09 00:00:00	1991-03-30	1991-03-30 00:00:00	32020		\N	8108	0	444814009	40481087		0
12793	755	40481087	2010-05-23	2010-05-23 00:00:00	2010-06-06	2010-06-06 00:00:00	32020		\N	50049	0	444814009	40481087		0
2444	143	378001	1975-09-05	1975-09-05 00:00:00	1975-11-04	1975-11-04 00:00:00	32020		\N	9608	0	62106007	378001		0
2618	153	260139	1944-06-06	1944-06-06 00:00:00	1944-06-20	1944-06-20 00:00:00	32020		\N	10404	0	10509002	260139		0
2764	160	81893	2004-11-08	2004-11-08 00:00:00	\N	\N	32020		\N	10951	0	64766004	81893		0
2943	171	40481087	1988-05-31	1988-05-31 00:00:00	1988-06-14	1988-06-14 00:00:00	32020		\N	11617	0	444814009	40481087		0
3096	183	4112343	2007-04-16	2007-04-16 00:00:00	2007-04-24	2007-04-24 00:00:00	32020		\N	12361	0	195662009	4112343		0
3241	188	4112343	1999-01-26	1999-01-26 00:00:00	1999-02-08	1999-02-08 00:00:00	32020		\N	12787	0	195662009	4112343		0
3423	196	4278672	1957-06-02	1957-06-02 00:00:00	1957-08-01	1957-08-01 00:00:00	32020		\N	13448	0	65966004	4278672		0
3644	209	40481087	1999-10-28	1999-10-28 00:00:00	1999-11-18	1999-11-18 00:00:00	32020		\N	14211	0	444814009	40481087		0
3771	217	4112343	2011-01-04	2011-01-04 00:00:00	2011-01-15	2011-01-15 00:00:00	32020		\N	14639	0	195662009	4112343		0
3921	225	4283893	1992-08-25	1992-08-25 00:00:00	1992-09-29	1992-09-29 00:00:00	32020		\N	15195	0	36971009	4283893		0
4097	236	4285898	1990-04-01	1990-04-01 00:00:00	\N	\N	32020		\N	15929	0	68496003	4285898		0
4261	246	4310024	1998-03-16	1998-03-16 00:00:00	\N	\N	32020		\N	16604	0	424802006	4310024		0
4468	262	40481087	2012-06-13	2012-06-13 00:00:00	2012-07-04	2012-07-04 00:00:00	32020		\N	17408	0	444814009	40481087		0
4581	268	372328	1967-11-18	1967-11-18 00:00:00	1968-01-30	1968-01-30 00:00:00	32020		\N	17784	0	65363002	372328		0
4764	279	28060	1993-06-13	1993-06-13 00:00:00	1993-06-20	1993-06-20 00:00:00	32020		\N	18655	0	43878008	28060		0
4912	289	40481087	1991-07-13	1991-07-13 00:00:00	1991-07-27	1991-07-27 00:00:00	32020		\N	19307	0	444814009	40481087		0
5093	298	317576	2019-02-12	2019-02-12 00:00:00	\N	\N	32020		\N	19944	0	53741008	317576		0
5250	310	40481087	1985-10-19	1985-10-19 00:00:00	1985-11-02	1985-11-02 00:00:00	32020		\N	20560	0	444814009	40481087		0
5444	320	80180	1995-08-28	1995-08-28 00:00:00	\N	\N	32020		\N	21237	0	396275006	80180		0
5617	332	78272	1980-08-27	1980-08-27 00:00:00	1980-09-24	1980-09-24 00:00:00	32020		\N	21909	0	70704007	78272		0
5755	338	40486433	1971-04-25	1971-04-25 00:00:00	1986-04-23	1986-04-23 00:00:00	32020		\N	22593	0	446096008	40486433		0
5923	349	4112343	1974-04-04	1974-04-04 00:00:00	1974-04-17	1974-04-17 00:00:00	32020		\N	23198	0	195662009	4112343		0
6077	357	40481087	1966-04-22	1966-04-22 00:00:00	1966-05-13	1966-05-13 00:00:00	32020		\N	23734	0	444814009	40481087		0
6239	366	4112343	1988-01-21	1988-01-21 00:00:00	1988-02-01	1988-02-01 00:00:00	32020		\N	24324	0	195662009	4112343		0
6402	376	40481087	1991-07-12	1991-07-12 00:00:00	1991-07-19	1991-07-19 00:00:00	32020		\N	24904	0	444814009	40481087		0
6630	392	28060	1985-12-11	1985-12-11 00:00:00	1985-12-19	1985-12-19 00:00:00	32020		\N	25714	0	43878008	28060		0
6743	399	4112343	1998-10-01	1998-10-01 00:00:00	1998-10-08	1998-10-08 00:00:00	32020		\N	26140	0	195662009	4112343		0
6903	406	81151	2010-10-26	2010-10-26 00:00:00	2010-11-30	2010-11-30 00:00:00	32020		\N	26816	0	44465007	81151		0
7082	418	372328	1964-01-20	1964-01-20 00:00:00	1964-09-14	1964-09-14 00:00:00	32020		\N	27637	0	65363002	372328		0
17767	1070	4112343	1988-08-14	1988-08-14 00:00:00	1988-08-27	1988-08-27 00:00:00	32020		\N	70075	0	195662009	4112343		0
7420	437	40481087	1976-01-04	1976-01-04 00:00:00	1976-01-25	1976-01-25 00:00:00	32020		\N	29026	0	444814009	40481087		0
7579	445	255848	1996-05-26	1996-05-26 00:00:00	\N	\N	32020		\N	29639	0	233604007	255848		0
7736	454	4109685	1943-03-20	1943-03-20 00:00:00	1943-04-03	1943-04-03 00:00:00	32020		\N	30271	0	284551006	4109685		0
7917	461	28060	1969-06-28	1969-06-28 00:00:00	1969-07-06	1969-07-06 00:00:00	32020		\N	30829	0	43878008	28060		0
8092	474	78272	1978-03-23	1978-03-23 00:00:00	1978-04-27	1978-04-27 00:00:00	32020		\N	31641	0	70704007	78272		0
8264	482	81151	1983-06-03	1983-06-03 00:00:00	1983-06-24	1983-06-24 00:00:00	32020		\N	32229	0	44465007	81151		0
8398	488	4112343	1970-04-02	1970-04-02 00:00:00	1970-04-10	1970-04-10 00:00:00	32020		\N	32692	0	195662009	4112343		0
8578	500	4285898	1998-08-26	1998-08-26 00:00:00	\N	\N	32020		\N	33498	0	68496003	4285898		0
8758	512	4112343	1958-03-04	1958-03-04 00:00:00	1958-03-13	1958-03-13 00:00:00	32020		\N	34175	0	195662009	4112343		0
19466	1169	195588	1989-09-30	1989-09-30 00:00:00	1989-11-18	1989-11-18 00:00:00	32020		\N	76962	0	38822007	195588		0
9078	534	40481087	1982-04-10	1982-04-10 00:00:00	1982-05-02	1982-05-02 00:00:00	32020		\N	35591	0	444814009	40481087		0
9290	549	260139	1989-05-19	1989-05-19 00:00:00	1989-06-02	1989-06-02 00:00:00	32020		\N	36372	0	10509002	260139		0
9438	558	4112343	1983-09-02	1983-09-02 00:00:00	1983-09-14	1983-09-14 00:00:00	32020		\N	36985	0	195662009	4112343		0
9596	569	40480160	1999-10-05	1999-10-05 00:00:00	1999-12-04	1999-12-04 00:00:00	32020		\N	37722	0	443165006	40480160		0
9731	576	4112343	1971-06-24	1971-06-24 00:00:00	1971-07-01	1971-07-01 00:00:00	32020		\N	38092	0	195662009	4112343		0
9920	587	372328	1994-08-12	1994-08-12 00:00:00	1995-05-10	1995-05-10 00:00:00	32020		\N	38872	0	65363002	372328		0
10120	600	4112343	2006-01-31	2006-01-31 00:00:00	2006-02-07	2006-02-07 00:00:00	32020		\N	39620	0	195662009	4112343		0
10243	606	195588	1997-02-06	1997-02-06 00:00:00	1997-03-10	1997-03-10 00:00:00	32020		\N	40252	0	38822007	195588		0
10399	613	4155034	2002-04-18	2002-04-18 00:00:00	2002-05-02	2002-05-02 00:00:00	32020		\N	40695	0	283371005	4155034		0
10618	624	4294548	2010-09-07	2010-09-07 00:00:00	2010-10-19	2010-10-19 00:00:00	32020		\N	41684	0	75498004	4294548		0
88	3	260139	1956-12-15	1956-12-15 00:00:00	1956-12-22	1956-12-22 00:00:00	32020		\N	262	0	10509002	260139		0
293	16	4029498	1983-10-10	1983-10-10 00:00:00	\N	\N	32020		\N	1163	0	128613002	4029498		0
10958	648	80180	1971-07-25	1971-07-25 00:00:00	\N	\N	32020		\N	42865	0	396275006	80180		0
633	35	4112343	1988-06-24	1988-06-24 00:00:00	1988-07-02	1988-07-02 00:00:00	32020		\N	2426	0	195662009	4112343		0
773	42	4112343	1950-04-16	1950-04-16 00:00:00	1950-04-29	1950-04-29 00:00:00	32020		\N	3015	0	195662009	4112343		0
11493	679	4283893	1973-09-06	1973-09-06 00:00:00	1973-10-11	1973-10-11 00:00:00	32020		\N	44916	0	36971009	4283893		0
1121	66	40481087	1983-04-04	1983-04-04 00:00:00	1983-04-11	1983-04-11 00:00:00	32020		\N	4504	0	444814009	40481087		0
1271	74	40481087	1998-04-14	1998-04-14 00:00:00	1998-05-05	1998-05-05 00:00:00	32020		\N	5004	0	444814009	40481087		0
1418	82	4029498	1973-03-18	1973-03-18 00:00:00	\N	\N	32020		\N	5570	0	128613002	4029498		0
1652	96	372328	1942-12-23	1942-12-23 00:00:00	1943-05-01	1943-05-01 00:00:00	32020		\N	6532	0	65363002	372328		0
1769	101	4218389	1965-04-17	1965-04-17 00:00:00	1965-05-08	1965-05-08 00:00:00	32020		\N	6897	0	39848009	4218389		0
1962	115	4237458	2006-06-09	2006-06-09 00:00:00	2006-07-09	2006-07-09 00:00:00	32020		\N	7637	0	58150001	4237458		0
2119	123	4283893	1985-10-13	1985-10-13 00:00:00	1985-12-01	1985-12-01 00:00:00	32020		\N	8153	0	36971009	4283893		0
12794	755	81151	2010-12-27	2010-12-27 00:00:00	2011-01-10	2011-01-10 00:00:00	32020		\N	50010	0	44465007	81151		0
2445	144	4112343	1997-10-22	1997-10-22 00:00:00	1997-11-04	1997-11-04 00:00:00	32020		\N	9620	0	195662009	4112343		0
2619	153	4027663	1975-06-02	1975-06-02 00:00:00	\N	\N	32020		\N	10381	0	13200003	4027663		0
2765	160	30753	2005-03-08	2005-03-08 00:00:00	\N	\N	32020		\N	10951	0	16761005	30753		0
2944	171	4156265	2000-03-04	2000-03-04 00:00:00	2000-03-18	2000-03-18 00:00:00	32020		\N	11611	0	370247008	4156265		0
3097	183	80180	2017-03-02	2017-03-02 00:00:00	\N	\N	32020		\N	12389	0	396275006	80180		0
3242	188	4112343	2011-02-09	2011-02-09 00:00:00	2011-02-20	2011-02-20 00:00:00	32020		\N	12827	0	195662009	4112343		0
3424	196	81893	1998-11-29	1998-11-29 00:00:00	\N	\N	32020		\N	13502	0	64766004	81893		0
3645	209	4294548	1981-01-07	1981-01-07 00:00:00	1981-01-21	1981-01-21 00:00:00	32020		\N	14264	0	75498004	4294548		0
3772	217	40481087	1997-12-30	1997-12-30 00:00:00	1998-01-20	1998-01-20 00:00:00	32020		\N	14681	0	444814009	40481087		0
3922	225	4218389	1981-05-04	1981-05-04 00:00:00	1981-06-08	1981-06-08 00:00:00	32020		\N	15144	0	39848009	4218389		0
4098	236	4283893	2004-04-26	2004-04-26 00:00:00	2004-10-04	2004-10-04 00:00:00	32020		\N	15851	0	36971009	4283893		0
4262	246	260139	1970-03-05	1970-03-05 00:00:00	1970-03-12	1970-03-12 00:00:00	32020		\N	16577	0	10509002	260139		0
4469	262	4027663	1990-07-28	1990-07-28 00:00:00	\N	\N	32020		\N	17355	0	13200003	4027663		0
4583	268	40481087	2001-10-28	2001-10-28 00:00:00	2001-11-18	2001-11-18 00:00:00	32020		\N	17800	0	444814009	40481087		0
4765	279	4155034	2012-02-27	2012-02-27 00:00:00	2012-03-19	2012-03-19 00:00:00	32020		\N	18613	0	283371005	4155034		0
4913	289	80180	1992-12-22	1992-12-22 00:00:00	\N	\N	32020		\N	19307	0	396275006	80180		0
5094	299	4112343	1965-10-29	1965-10-29 00:00:00	1965-11-11	1965-11-11 00:00:00	32020		\N	20022	0	195662009	4112343		0
5251	310	40481087	1988-01-30	1988-01-30 00:00:00	1988-02-20	1988-02-20 00:00:00	32020		\N	20573	0	444814009	40481087		0
5445	320	261325	1990-06-17	1990-06-17 00:00:00	\N	\N	32020		\N	21203	0	87433001	261325		0
5618	332	78272	1979-09-18	1979-09-18 00:00:00	1979-10-02	1979-10-02 00:00:00	32020		\N	21908	0	70704007	78272		0
5756	338	81151	1969-02-07	1969-02-07 00:00:00	1969-03-07	1969-03-07 00:00:00	32020		\N	22597	0	44465007	81151		0
5924	349	40481087	2001-08-08	2001-08-08 00:00:00	2001-08-29	2001-08-29 00:00:00	32020		\N	23200	0	444814009	40481087		0
6079	357	260139	2000-02-24	2000-02-24 00:00:00	2000-03-02	2000-03-02 00:00:00	32020		\N	23699	0	10509002	260139		0
6240	366	40481087	1954-06-11	1954-06-11 00:00:00	1954-07-02	1954-07-02 00:00:00	32020		\N	24270	0	444814009	40481087		0
6403	376	40481087	2007-05-27	2007-05-27 00:00:00	2007-06-03	2007-06-03 00:00:00	32020		\N	24899	0	444814009	40481087		0
6631	392	80180	2012-03-16	2012-03-16 00:00:00	\N	\N	32020		\N	25750	0	396275006	80180		0
6744	399	372328	1957-03-23	1957-03-23 00:00:00	1957-09-08	1957-09-08 00:00:00	32020		\N	26141	0	65363002	372328		0
6904	406	80180	1996-06-27	1996-06-27 00:00:00	\N	\N	32020		\N	26865	0	396275006	80180		0
7083	418	78272	1958-07-20	1958-07-20 00:00:00	1958-08-03	1958-08-03 00:00:00	32020		\N	27667	0	70704007	78272		0
17768	1070	192671	2009-10-30	2009-10-30 00:00:00	\N	\N	32020		\N	70098	0	K92.2	35208414		0
7421	437	4112343	1994-02-04	1994-02-04 00:00:00	1994-02-13	1994-02-13 00:00:00	32020		\N	29029	0	195662009	4112343		0
7580	445	40481087	1926-06-28	1926-06-28 00:00:00	1926-07-12	1926-07-12 00:00:00	32020		\N	29554	0	444814009	40481087		0
7737	454	378419	2013-02-16	2013-02-16 00:00:00	\N	\N	32020		\N	30331	0	26929004	378419		0
7918	461	4112343	1988-05-31	1988-05-31 00:00:00	1988-06-11	1988-06-11 00:00:00	32020		\N	30780	0	195662009	4112343		0
8093	474	40481087	2008-05-11	2008-05-11 00:00:00	2008-05-18	2008-05-18 00:00:00	32020		\N	31602	0	444814009	40481087		0
8265	482	372328	1979-04-10	1979-04-10 00:00:00	1979-11-01	1979-11-01 00:00:00	32020		\N	32216	0	65363002	372328		0
8399	488	4112343	1971-04-07	1971-04-07 00:00:00	1971-04-15	1971-04-15 00:00:00	32020		\N	32619	0	195662009	4112343		0
8579	500	40481087	2017-04-17	2017-04-17 00:00:00	2017-05-01	2017-05-01 00:00:00	32020		\N	33525	0	444814009	40481087		0
8759	512	81151	1956-03-10	1956-03-10 00:00:00	1956-04-07	1956-04-07 00:00:00	32020		\N	34167	0	44465007	81151		0
19467	1169	81151	2009-02-21	2009-02-21 00:00:00	2009-03-07	2009-03-07 00:00:00	32020		\N	76989	0	44465007	81151		0
9079	534	40481087	1987-12-26	1987-12-26 00:00:00	1988-01-16	1988-01-16 00:00:00	32020		\N	35606	0	444814009	40481087		0
9291	549	4112343	1985-12-22	1985-12-22 00:00:00	1985-12-31	1985-12-31 00:00:00	32020		\N	36357	0	195662009	4112343		0
9439	558	440086	1968-11-01	1968-11-01 00:00:00	1970-09-25	1970-09-25 00:00:00	32020		\N	37009	0	192127007	440086		0
9597	569	4278672	1999-10-05	1999-10-05 00:00:00	1999-12-04	1999-12-04 00:00:00	32020		\N	37722	0	65966004	4278672		0
9732	576	28060	1969-03-22	1969-03-22 00:00:00	1969-04-03	1969-04-03 00:00:00	32020		\N	38095	0	43878008	28060		0
9921	587	260139	1983-02-17	1983-02-17 00:00:00	1983-02-24	1983-02-24 00:00:00	32020		\N	38901	0	10509002	260139		0
10121	600	40481087	1986-03-23	1986-03-23 00:00:00	1986-04-06	1986-04-06 00:00:00	32020		\N	39618	0	444814009	40481087		0
10244	606	4142905	1992-01-19	1992-01-19 00:00:00	1992-03-19	1992-03-19 00:00:00	32020		\N	40238	0	33737001	4142905		0
10400	613	40481087	2014-12-04	2014-12-04 00:00:00	2014-12-11	2014-12-11 00:00:00	32020		\N	40750	0	444814009	40481087		0
10619	624	260139	1966-07-22	1966-07-22 00:00:00	1966-08-05	1966-08-05 00:00:00	32020		\N	41621	0	10509002	260139		0
89	3	40481087	1964-03-28	1964-03-28 00:00:00	1964-04-11	1964-04-11 00:00:00	32020		\N	264	0	444814009	40481087		0
295	16	372328	1972-04-10	1972-04-10 00:00:00	1972-06-21	1972-06-21 00:00:00	32020		\N	1196	0	65363002	372328		0
10959	648	4285898	1970-10-28	1970-10-28 00:00:00	\N	\N	32020		\N	42865	0	68496003	4285898		0
634	36	260139	2012-06-04	2012-06-04 00:00:00	2012-06-11	2012-06-11 00:00:00	32020		\N	2543	0	10509002	260139		0
774	42	40481087	1926-05-12	1926-05-12 00:00:00	1926-05-19	1926-05-19 00:00:00	32020		\N	3014	0	444814009	40481087		0
11494	679	28060	1984-10-27	1984-10-27 00:00:00	1984-11-09	1984-11-09 00:00:00	32020		\N	44938	0	43878008	28060		0
1122	66	80180	1996-03-09	1996-03-09 00:00:00	\N	\N	32020		\N	4503	0	396275006	80180		0
1272	74	4112343	1981-03-19	1981-03-19 00:00:00	1981-03-29	1981-03-29 00:00:00	32020		\N	5011	0	195662009	4112343		0
1419	82	80180	1995-12-03	1995-12-03 00:00:00	\N	\N	32020		\N	5597	0	396275006	80180		0
1653	96	4237458	1931-07-24	1931-07-24 00:00:00	1931-08-23	1931-08-23 00:00:00	32020		\N	6502	0	58150001	4237458		0
1770	101	4112343	1942-01-31	1942-01-31 00:00:00	1942-02-07	1942-02-07 00:00:00	32020		\N	6905	0	195662009	4112343		0
1963	115	4112343	1980-11-08	1980-11-08 00:00:00	1980-11-20	1980-11-20 00:00:00	32020		\N	7568	0	195662009	4112343		0
2120	123	4112343	1967-06-30	1967-06-30 00:00:00	1967-07-08	1967-07-08 00:00:00	32020		\N	8151	0	195662009	4112343		0
12795	755	40481087	1965-12-09	1965-12-09 00:00:00	1965-12-30	1965-12-30 00:00:00	32020		\N	50101	0	444814009	40481087		0
2446	144	40481087	1999-06-05	1999-06-05 00:00:00	1999-06-12	1999-06-12 00:00:00	32020		\N	9621	0	444814009	40481087		0
2620	153	4112343	1975-03-03	1975-03-03 00:00:00	1975-03-10	1975-03-10 00:00:00	32020		\N	10381	0	195662009	4112343		0
2766	160	260139	2004-10-01	2004-10-01 00:00:00	2004-10-08	2004-10-08 00:00:00	32020		\N	10951	0	10509002	260139		0
2945	171	4134304	1979-09-10	1979-09-10 00:00:00	1979-10-10	1979-10-10 00:00:00	32020		\N	11608	0	263102004	4134304		0
3098	183	260139	1983-01-26	1983-01-26 00:00:00	1983-02-09	1983-02-09 00:00:00	32020		\N	12373	0	10509002	260139		0
3243	188	40481087	1999-05-26	1999-05-26 00:00:00	1999-06-09	1999-06-09 00:00:00	32020		\N	12826	0	444814009	40481087		0
3425	196	260139	1959-10-22	1959-10-22 00:00:00	1959-10-29	1959-10-29 00:00:00	32020		\N	13440	0	10509002	260139		0
3646	209	4112343	1964-10-14	1964-10-14 00:00:00	1964-10-21	1964-10-21 00:00:00	32020		\N	14262	0	195662009	4112343		0
3773	217	4112343	1997-08-29	1997-08-29 00:00:00	1997-09-10	1997-09-10 00:00:00	32020		\N	14645	0	195662009	4112343		0
3923	225	260139	1973-10-21	1973-10-21 00:00:00	1973-10-28	1973-10-28 00:00:00	32020		\N	15176	0	10509002	260139		0
4110	239	80180	1992-04-26	1992-04-26 00:00:00	\N	\N	32020		\N	16036	0	396275006	80180		0
4263	246	4051466	1963-12-02	1963-12-02 00:00:00	1979-03-14	1979-03-14 00:00:00	32020		\N	16519	0	233678006	4051466		0
4470	262	28060	1974-10-24	1974-10-24 00:00:00	1974-11-01	1974-11-01 00:00:00	32020		\N	17413	0	43878008	28060		0
4584	268	378001	1992-05-01	1992-05-01 00:00:00	1992-05-31	1992-05-31 00:00:00	32020		\N	17799	0	62106007	378001		0
4766	280	4109685	1946-10-16	1946-10-16 00:00:00	1946-10-30	1946-10-30 00:00:00	32020		\N	18702	0	284551006	4109685		0
4914	289	378001	1987-02-17	1987-02-17 00:00:00	1987-03-19	1987-03-19 00:00:00	32020		\N	19329	0	62106007	378001		0
5095	299	260139	2019-01-12	2019-01-12 00:00:00	2019-01-19	2019-01-19 00:00:00	32020		\N	19995	0	10509002	260139		0
5252	310	40481087	1982-05-10	1982-05-10 00:00:00	1982-05-31	1982-05-31 00:00:00	32020		\N	20506	0	444814009	40481087		0
5446	321	28060	1989-08-17	1989-08-17 00:00:00	1989-08-27	1989-08-27 00:00:00	32020		\N	21272	0	43878008	28060		0
5619	332	4051466	1965-06-20	1965-06-20 00:00:00	1982-09-22	1982-09-22 00:00:00	32020		\N	22030	0	233678006	4051466		0
5757	338	40481087	1974-09-29	1974-09-29 00:00:00	1974-10-06	1974-10-06 00:00:00	32020		\N	22594	0	444814009	40481087		0
5925	349	4112343	1969-02-11	1969-02-11 00:00:00	1969-02-18	1969-02-18 00:00:00	32020		\N	23180	0	195662009	4112343		0
6080	357	4112343	1973-05-22	1973-05-22 00:00:00	1973-05-31	1973-05-31 00:00:00	32020		\N	23737	0	195662009	4112343		0
6241	366	40481087	1974-01-10	1974-01-10 00:00:00	1974-01-17	1974-01-17 00:00:00	32020		\N	24322	0	444814009	40481087		0
6404	376	372328	1964-03-12	1964-03-12 00:00:00	1964-04-02	1964-04-02 00:00:00	32020		\N	24906	0	65363002	372328		0
6632	392	40481087	1989-01-01	1989-01-01 00:00:00	1989-01-22	1989-01-22 00:00:00	32020		\N	25739	0	444814009	40481087		0
6745	399	4230399	1969-02-23	1969-02-23 00:00:00	1969-03-25	1969-03-25 00:00:00	32020		\N	26235	0	359817006	4230399		0
6905	406	40481087	1958-10-10	1958-10-10 00:00:00	1958-10-24	1958-10-24 00:00:00	32020		\N	26827	0	444814009	40481087		0
7084	418	375671	1991-03-23	1991-03-23 00:00:00	1991-05-22	1991-05-22 00:00:00	32020		\N	27664	0	62564004	375671		0
17769	1070	260139	2017-06-26	2017-06-26 00:00:00	2017-07-03	2017-07-03 00:00:00	32020		\N	70049	0	10509002	260139		0
7422	437	40481087	1997-08-15	1997-08-15 00:00:00	1997-08-29	1997-08-29 00:00:00	32020		\N	29031	0	444814009	40481087		0
7581	445	81893	1952-08-07	1952-08-07 00:00:00	\N	\N	32020		\N	29638	0	64766004	81893		0
7738	454	4134304	2006-02-13	2006-02-13 00:00:00	2006-05-14	2006-05-14 00:00:00	32020		\N	30276	0	263102004	4134304		0
7919	461	372328	1950-06-17	1950-06-17 00:00:00	1950-07-01	1950-07-01 00:00:00	32020		\N	30833	0	65363002	372328		0
8094	474	4294548	1976-03-17	1976-03-17 00:00:00	1976-03-24	1976-03-24 00:00:00	32020		\N	31626	0	75498004	4294548		0
8266	482	372328	1974-08-28	1974-08-28 00:00:00	1974-10-03	1974-10-03 00:00:00	32020		\N	32218	0	65363002	372328		0
8400	488	260139	2015-08-18	2015-08-18 00:00:00	2015-09-01	2015-09-01 00:00:00	32020		\N	32654	0	10509002	260139		0
8580	500	4155034	1962-09-14	1962-09-14 00:00:00	1962-10-05	1962-10-05 00:00:00	32020		\N	33503	0	283371005	4155034		0
8760	512	40481087	2004-08-02	2004-08-02 00:00:00	2004-08-16	2004-08-16 00:00:00	32020		\N	34177	0	444814009	40481087		0
19468	1169	4218389	1980-02-05	1980-02-05 00:00:00	1980-03-11	1980-03-11 00:00:00	32020		\N	76987	0	39848009	4218389		0
9080	534	372328	1983-09-09	1983-09-09 00:00:00	1984-06-05	1984-06-05 00:00:00	32020		\N	35582	0	65363002	372328		0
9292	549	260139	2014-08-31	2014-08-31 00:00:00	2014-09-14	2014-09-14 00:00:00	32020		\N	36399	0	10509002	260139		0
9440	558	378001	1998-10-13	1998-10-13 00:00:00	1998-11-12	1998-11-12 00:00:00	32020		\N	36975	0	62106007	378001		0
9598	569	28060	1922-01-07	1922-01-07 00:00:00	1922-01-18	1922-01-18 00:00:00	32020		\N	37690	0	43878008	28060		0
9733	576	4237458	2001-07-01	2001-07-01 00:00:00	2001-09-29	2001-09-29 00:00:00	32020		\N	38066	0	58150001	4237458		0
9922	587	4283893	1994-06-02	1994-06-02 00:00:00	1994-07-07	1994-07-07 00:00:00	32020		\N	38864	0	36971009	4283893		0
10122	600	4310024	1986-08-26	1986-08-26 00:00:00	\N	\N	32020		\N	39618	0	424802006	4310024		0
10245	606	28060	2008-04-12	2008-04-12 00:00:00	2008-04-25	2008-04-25 00:00:00	32020		\N	40217	0	43878008	28060		0
10401	613	4155034	1992-08-17	1992-08-17 00:00:00	1992-09-07	1992-09-07 00:00:00	32020		\N	40778	0	283371005	4155034		0
10620	624	4134304	2019-05-27	2019-05-27 00:00:00	\N	\N	32020		\N	41697	0	263102004	4134304		0
90	3	4156265	1967-05-26	1967-05-26 00:00:00	1967-06-16	1967-06-16 00:00:00	32020		\N	346	0	370247008	4156265		0
296	16	372328	1974-06-11	1974-06-11 00:00:00	1974-09-18	1974-09-18 00:00:00	32020		\N	1174	0	65363002	372328		0
10960	648	4310024	1969-09-03	1969-09-03 00:00:00	\N	\N	32020		\N	42865	0	424802006	4310024		0
635	36	372328	1961-10-17	1961-10-17 00:00:00	1962-03-27	1962-03-27 00:00:00	32020		\N	2564	0	65363002	372328		0
775	42	4059173	1930-10-04	1930-10-04 00:00:00	1931-01-02	1931-01-02 00:00:00	32020		\N	3111	0	16114001	4059173		0
11495	679	30753	2007-11-20	2007-11-20 00:00:00	\N	\N	32020		\N	44907	0	16761005	30753		0
1123	66	4152936	1979-03-30	1979-03-30 00:00:00	1979-04-20	1979-04-20 00:00:00	32020		\N	4448	0	283385000	4152936		0
1273	74	28060	1979-04-16	1979-04-16 00:00:00	1979-04-27	1979-04-27 00:00:00	32020		\N	5009	0	43878008	28060		0
1420	82	40481087	1969-09-24	1969-09-24 00:00:00	1969-10-15	1969-10-15 00:00:00	32020		\N	5537	0	444814009	40481087		0
1654	96	378001	1932-08-17	1932-08-17 00:00:00	1932-10-16	1932-10-16 00:00:00	32020		\N	6503	0	62106007	378001		0
1771	101	4218389	2007-07-23	2007-07-23 00:00:00	2007-08-27	2007-08-27 00:00:00	32020		\N	6903	0	39848009	4218389		0
1964	115	4296204	1978-05-23	1978-05-23 00:00:00	1978-06-06	1978-06-06 00:00:00	32020		\N	7636	0	403190006	4296204		0
2121	123	378001	1984-12-16	1984-12-16 00:00:00	1985-01-15	1985-01-15 00:00:00	32020		\N	8145	0	62106007	378001		0
12796	755	260139	2011-04-01	2011-04-01 00:00:00	2011-04-15	2011-04-15 00:00:00	32020		\N	50057	0	10509002	260139		0
2447	144	40481087	1979-09-04	1979-09-04 00:00:00	1979-09-25	1979-09-25 00:00:00	32020		\N	9629	0	444814009	40481087		0
2621	153	4112343	1966-04-09	1966-04-09 00:00:00	1966-04-17	1966-04-17 00:00:00	32020		\N	10395	0	195662009	4112343		0
2767	160	372328	1964-03-13	1964-03-13 00:00:00	1964-07-02	1964-07-02 00:00:00	32020		\N	10967	0	65363002	372328		0
2946	171	28060	1991-11-02	1991-11-02 00:00:00	1991-11-10	1991-11-10 00:00:00	32020		\N	11626	0	43878008	28060		0
3099	183	372328	1979-02-25	1979-02-25 00:00:00	1979-10-04	1979-10-04 00:00:00	32020		\N	12394	0	65363002	372328		0
3244	188	80180	1999-11-24	1999-11-24 00:00:00	\N	\N	32020		\N	12826	0	396275006	80180		0
3426	196	40481087	1966-10-19	1966-10-19 00:00:00	1966-11-09	1966-11-09 00:00:00	32020		\N	13445	0	444814009	40481087		0
3647	209	372328	2016-05-03	2016-05-03 00:00:00	2016-05-17	2016-05-17 00:00:00	32020		\N	14232	0	65363002	372328		0
3774	217	4218389	2013-06-15	2013-06-15 00:00:00	2013-07-13	2013-07-13 00:00:00	32020		\N	14642	0	39848009	4218389		0
3924	225	40481087	2018-11-04	2018-11-04 00:00:00	2018-11-25	2018-11-25 00:00:00	32020		\N	15251	0	444814009	40481087		0
4111	239	4112343	1991-11-09	1991-11-09 00:00:00	1991-11-21	1991-11-21 00:00:00	32020		\N	16036	0	195662009	4112343		0
4264	246	4112343	1972-04-28	1972-04-28 00:00:00	1972-05-06	1972-05-06 00:00:00	32020		\N	16588	0	195662009	4112343		0
4471	262	40481087	1987-04-14	1987-04-14 00:00:00	1987-04-21	1987-04-21 00:00:00	32020		\N	17390	0	444814009	40481087		0
4602	270	40481087	1980-12-18	1980-12-18 00:00:00	1981-01-08	1981-01-08 00:00:00	32020		\N	17952	0	444814009	40481087		0
4767	280	40481087	1982-03-22	1982-03-22 00:00:00	1982-03-29	1982-03-29 00:00:00	32020		\N	18688	0	444814009	40481087		0
4915	289	40481087	1990-06-22	1990-06-22 00:00:00	1990-07-13	1990-07-13 00:00:00	32020		\N	19282	0	444814009	40481087		0
5096	299	40481087	2000-10-24	2000-10-24 00:00:00	2000-11-14	2000-11-14 00:00:00	32020		\N	20010	0	444814009	40481087		0
5253	310	4027663	1974-06-12	1974-06-12 00:00:00	\N	\N	32020		\N	20559	0	13200003	4027663		0
5447	321	40481087	2019-01-21	2019-01-21 00:00:00	2019-02-11	2019-02-11 00:00:00	32020		\N	21277	0	444814009	40481087		0
5620	332	4112343	1986-06-27	1986-06-27 00:00:00	1986-07-05	1986-07-05 00:00:00	32020		\N	21996	0	195662009	4112343		0
5758	338	4027663	1992-04-12	1992-04-12 00:00:00	\N	\N	32020		\N	22514	0	13200003	4027663		0
5926	349	80180	1994-02-08	1994-02-08 00:00:00	\N	\N	32020		\N	23221	0	396275006	80180		0
6081	357	28060	1992-07-11	1992-07-11 00:00:00	1992-07-24	1992-07-24 00:00:00	32020		\N	23725	0	43878008	28060		0
6242	366	381316	1974-03-03	1974-03-03 00:00:00	\N	\N	32020		\N	24322	0	230690007	381316		0
6405	376	4296204	2012-02-13	2012-02-13 00:00:00	2012-03-12	2012-03-12 00:00:00	32020		\N	24941	0	403190006	4296204		0
6633	392	40481087	2015-10-22	2015-10-22 00:00:00	2015-11-05	2015-11-05 00:00:00	32020		\N	25753	0	444814009	40481087		0
6746	399	4112343	1967-12-05	1967-12-05 00:00:00	1967-12-18	1967-12-18 00:00:00	32020		\N	26172	0	195662009	4112343		0
6906	406	40481087	1995-03-14	1995-03-14 00:00:00	1995-03-21	1995-03-21 00:00:00	32020		\N	26855	0	444814009	40481087		0
7085	418	4155034	1981-10-20	1981-10-20 00:00:00	1981-11-10	1981-11-10 00:00:00	32020		\N	27663	0	283371005	4155034		0
17770	1070	260139	1982-06-05	1982-06-05 00:00:00	1982-06-19	1982-06-19 00:00:00	32020		\N	70074	0	10509002	260139		0
7423	437	195588	1978-02-04	1978-02-04 00:00:00	1978-03-15	1978-03-15 00:00:00	32020		\N	28974	0	38822007	195588		0
7582	445	30753	1952-12-05	1952-12-05 00:00:00	\N	\N	32020		\N	29638	0	16761005	30753		0
7739	454	40481087	1953-07-05	1953-07-05 00:00:00	1953-07-19	1953-07-19 00:00:00	32020		\N	30346	0	444814009	40481087		0
7920	461	4112343	1992-03-26	1992-03-26 00:00:00	1992-04-07	1992-04-07 00:00:00	32020		\N	30815	0	195662009	4112343		0
8095	474	81893	2003-08-28	2003-08-28 00:00:00	\N	\N	32020		\N	31654	0	64766004	81893		0
8267	482	4027663	1997-10-16	1997-10-16 00:00:00	\N	\N	32020		\N	32209	0	13200003	4027663		0
8401	488	4152936	2001-10-24	2001-10-24 00:00:00	2001-11-07	2001-11-07 00:00:00	32020		\N	32701	0	283385000	4152936		0
8581	500	4296204	1981-12-27	1981-12-27 00:00:00	1982-01-31	1982-01-31 00:00:00	32020		\N	33549	0	403190006	4296204		0
8761	512	372328	1960-02-05	1960-02-05 00:00:00	1961-02-10	1961-02-10 00:00:00	32020		\N	34211	0	65363002	372328		0
19469	1169	40481087	1956-09-15	1956-09-15 00:00:00	1956-10-06	1956-10-06 00:00:00	32020		\N	76960	0	444814009	40481087		0
9081	534	40481087	1979-05-13	1979-05-13 00:00:00	1979-06-03	1979-06-03 00:00:00	32020		\N	35555	0	444814009	40481087		0
9293	549	40481087	1996-10-16	1996-10-16 00:00:00	1996-11-06	1996-11-06 00:00:00	32020		\N	36373	0	444814009	40481087		0
9441	558	4112343	1977-07-08	1977-07-08 00:00:00	1977-07-17	1977-07-17 00:00:00	32020		\N	37026	0	195662009	4112343		0
9599	569	40481087	1964-03-29	1964-03-29 00:00:00	1964-04-19	1964-04-19 00:00:00	32020		\N	37667	0	444814009	40481087		0
9734	576	40481087	1994-09-24	1994-09-24 00:00:00	1994-10-15	1994-10-15 00:00:00	32020		\N	38072	0	444814009	40481087		0
9923	588	40481087	1990-04-09	1990-04-09 00:00:00	1990-04-30	1990-04-30 00:00:00	32020		\N	38931	0	444814009	40481087		0
10123	600	81893	1986-12-24	1986-12-24 00:00:00	\N	\N	32020		\N	39618	0	64766004	81893		0
10246	606	4112343	1975-12-11	1975-12-11 00:00:00	1975-12-20	1975-12-20 00:00:00	32020		\N	40200	0	195662009	4112343		0
10402	613	80180	1977-01-23	1977-01-23 00:00:00	\N	\N	32020		\N	40685	0	396275006	80180		0
10621	624	40481087	1998-02-21	1998-02-21 00:00:00	1998-02-28	1998-02-28 00:00:00	32020		\N	41653	0	444814009	40481087		0
91	3	4112343	1991-12-11	1991-12-11 00:00:00	1991-12-18	1991-12-18 00:00:00	32020		\N	350	0	195662009	4112343		0
297	16	260139	1985-03-05	1985-03-05 00:00:00	1985-03-12	1985-03-12 00:00:00	32020		\N	1276	0	10509002	260139		0
10961	648	81893	1969-12-02	1969-12-02 00:00:00	\N	\N	32020		\N	42865	0	64766004	81893		0
636	36	378001	1976-11-29	1976-11-29 00:00:00	1977-01-28	1977-01-28 00:00:00	32020		\N	2614	0	62106007	378001		0
776	42	40481087	1997-03-06	1997-03-06 00:00:00	1997-03-13	1997-03-13 00:00:00	32020		\N	3017	0	444814009	40481087		0
11496	679	40481087	2007-11-16	2007-11-16 00:00:00	2007-12-07	2007-12-07 00:00:00	32020		\N	44907	0	444814009	40481087		0
1124	66	4027663	1985-06-20	1985-06-20 00:00:00	\N	\N	32020		\N	4469	0	13200003	4027663		0
1274	74	260139	2012-07-01	2012-07-01 00:00:00	2012-07-15	2012-07-15 00:00:00	32020		\N	4990	0	10509002	260139		0
1421	82	4112343	1978-03-03	1978-03-03 00:00:00	1978-03-13	1978-03-13 00:00:00	32020		\N	5604	0	195662009	4112343		0
1655	96	317576	1984-02-18	1984-02-18 00:00:00	\N	\N	32020		\N	6514	0	53741008	317576		0
1772	101	4296205	1960-04-29	1960-04-29 00:00:00	1960-05-13	1960-05-13 00:00:00	32020		\N	6896	0	403191005	4296205		0
1965	115	372328	1961-07-07	1961-07-07 00:00:00	1961-10-08	1961-10-08 00:00:00	32020		\N	7579	0	65363002	372328		0
2122	123	40481087	1965-08-16	1965-08-16 00:00:00	1965-08-30	1965-08-30 00:00:00	32020		\N	8121	0	444814009	40481087		0
12797	755	28060	1975-12-08	1975-12-08 00:00:00	1975-12-15	1975-12-15 00:00:00	32020		\N	50054	0	43878008	28060		0
2448	144	40481087	2010-10-13	2010-10-13 00:00:00	2010-11-03	2010-11-03 00:00:00	32020		\N	9663	0	444814009	40481087		0
2622	153	4152936	2011-02-02	2011-02-02 00:00:00	2011-02-16	2011-02-16 00:00:00	32020		\N	10333	0	283385000	4152936		0
2768	160	28060	1998-05-31	1998-05-31 00:00:00	1998-06-11	1998-06-11 00:00:00	32020		\N	10980	0	43878008	28060		0
2947	171	80180	2007-12-21	2007-12-21 00:00:00	\N	\N	32020		\N	11605	0	396275006	80180		0
3100	183	4112343	1984-08-01	1984-08-01 00:00:00	1984-08-13	1984-08-13 00:00:00	32020		\N	12408	0	195662009	4112343		0
3245	189	40481087	1997-09-20	1997-09-20 00:00:00	1997-10-11	1997-10-11 00:00:00	32020		\N	12880	0	444814009	40481087		0
3427	196	4285898	1999-10-25	1999-10-25 00:00:00	\N	\N	32020		\N	13502	0	68496003	4285898		0
3648	209	4112343	1976-05-02	1976-05-02 00:00:00	1976-05-15	1976-05-15 00:00:00	32020		\N	14281	0	195662009	4112343		0
3775	217	4112343	2017-03-15	2017-03-15 00:00:00	2017-03-27	2017-03-27 00:00:00	32020		\N	14670	0	195662009	4112343		0
3925	225	195588	1986-12-30	1986-12-30 00:00:00	1987-02-14	1987-02-14 00:00:00	32020		\N	15205	0	38822007	195588		0
4112	239	4266809	1992-04-26	1992-04-26 00:00:00	\N	\N	32020		\N	16036	0	397881000	4266809		0
4265	246	4027663	1990-11-18	1990-11-18 00:00:00	\N	\N	32020		\N	16540	0	13200003	4027663		0
4472	262	4294548	2016-12-16	2016-12-16 00:00:00	2016-12-30	2016-12-30 00:00:00	32020		\N	17364	0	75498004	4294548		0
4603	270	260139	1966-08-23	1966-08-23 00:00:00	1966-08-30	1966-08-30 00:00:00	32020		\N	17951	0	10509002	260139		0
4768	280	192671	1975-02-02	1975-02-02 00:00:00	\N	\N	32020		\N	18671	0	K92.2	35208414		0
4916	289	40481087	2010-11-15	2010-11-15 00:00:00	2010-11-29	2010-11-29 00:00:00	32020		\N	19309	0	444814009	40481087		0
5097	299	313217	2018-06-30	2018-06-30 00:00:00	\N	\N	32020		\N	19986	0	49436004	313217		0
5254	310	4283893	1973-10-26	1973-10-26 00:00:00	1973-11-23	1973-11-23 00:00:00	32020		\N	20559	0	36971009	4283893		0
5448	321	40481087	1999-11-09	1999-11-09 00:00:00	1999-11-23	1999-11-23 00:00:00	32020		\N	21307	0	444814009	40481087		0
5621	332	260139	1978-04-12	1978-04-12 00:00:00	1978-04-19	1978-04-19 00:00:00	32020		\N	21994	0	10509002	260139		0
5759	338	378001	1987-07-31	1987-07-31 00:00:00	1987-09-29	1987-09-29 00:00:00	32020		\N	22599	0	62106007	378001		0
5927	349	4112343	1968-07-02	1968-07-02 00:00:00	1968-07-13	1968-07-13 00:00:00	32020		\N	23204	0	195662009	4112343		0
6082	357	40481087	2016-10-06	2016-10-06 00:00:00	2016-10-13	2016-10-13 00:00:00	32020		\N	23700	0	444814009	40481087		0
6243	366	260139	1987-01-14	1987-01-14 00:00:00	1987-01-28	1987-01-28 00:00:00	32020		\N	24323	0	10509002	260139		0
6406	376	4027663	1988-04-20	1988-04-20 00:00:00	\N	\N	32020		\N	24895	0	13200003	4027663		0
6634	392	4112343	1991-02-24	1991-02-24 00:00:00	1991-03-07	1991-03-07 00:00:00	32020		\N	25740	0	195662009	4112343		0
6747	399	4109685	1986-06-15	1986-06-15 00:00:00	1986-07-06	1986-07-06 00:00:00	32020		\N	26238	0	284551006	4109685		0
6907	406	4112343	1955-01-08	1955-01-08 00:00:00	1955-01-17	1955-01-17 00:00:00	32020		\N	26717	0	195662009	4112343		0
7086	418	40481087	2018-01-03	2018-01-03 00:00:00	2018-01-10	2018-01-10 00:00:00	32020		\N	27617	0	444814009	40481087		0
17771	1070	4112343	2000-06-29	2000-06-29 00:00:00	2000-07-10	2000-07-10 00:00:00	32020		\N	70076	0	195662009	4112343		0
7424	437	4027663	1978-02-04	1978-02-04 00:00:00	\N	\N	32020		\N	28974	0	13200003	4027663		0
7583	445	4310024	1952-02-09	1952-02-09 00:00:00	\N	\N	32020		\N	29638	0	424802006	4310024		0
7740	454	260139	1961-08-01	1961-08-01 00:00:00	1961-08-08	1961-08-08 00:00:00	32020		\N	30348	0	10509002	260139		0
7921	462	372328	1979-10-01	1979-10-01 00:00:00	1980-02-21	1980-02-21 00:00:00	32020		\N	30886	0	65363002	372328		0
8096	474	28060	2002-03-03	2002-03-03 00:00:00	2002-03-13	2002-03-13 00:00:00	32020		\N	31654	0	43878008	28060		0
8268	482	40481087	2000-06-20	2000-06-20 00:00:00	2000-07-04	2000-07-04 00:00:00	32020		\N	32215	0	444814009	40481087		0
8402	488	4112343	1962-07-31	1962-07-31 00:00:00	1962-08-09	1962-08-09 00:00:00	32020		\N	32681	0	195662009	4112343		0
8582	500	81151	1971-04-19	1971-04-19 00:00:00	1971-05-10	1971-05-10 00:00:00	32020		\N	33547	0	44465007	81151		0
8762	512	372328	1955-08-13	1955-08-13 00:00:00	1956-01-27	1956-01-27 00:00:00	32020		\N	34221	0	65363002	372328		0
19470	1169	40481087	1952-02-26	1952-02-26 00:00:00	1952-03-04	1952-03-04 00:00:00	32020		\N	76966	0	444814009	40481087		0
9082	534	195588	1996-06-15	1996-06-15 00:00:00	1996-07-28	1996-07-28 00:00:00	32020		\N	35514	0	38822007	195588		0
9294	549	4112343	2004-04-26	2004-04-26 00:00:00	2004-05-08	2004-05-08 00:00:00	32020		\N	36365	0	195662009	4112343		0
9442	558	4113008	2003-11-05	2003-11-05 00:00:00	2003-11-26	2003-11-26 00:00:00	32020		\N	36978	0	284549007	4113008		0
9600	569	4112343	2007-12-09	2007-12-09 00:00:00	2007-12-20	2007-12-20 00:00:00	32020		\N	37643	0	195662009	4112343		0
9735	576	4113008	1997-04-18	1997-04-18 00:00:00	1997-05-09	1997-05-09 00:00:00	32020		\N	38065	0	284549007	4113008		0
9924	588	40481087	1998-12-22	1998-12-22 00:00:00	1998-12-29	1998-12-29 00:00:00	32020		\N	38922	0	444814009	40481087		0
10124	600	372328	1954-03-07	1954-03-07 00:00:00	1954-04-14	1954-04-14 00:00:00	32020		\N	39642	0	65363002	372328		0
10247	606	260139	2004-02-20	2004-02-20 00:00:00	2004-02-27	2004-02-27 00:00:00	32020		\N	40243	0	10509002	260139		0
10403	613	4116491	1987-11-02	1987-11-02 00:00:00	1987-12-26	1987-12-26 00:00:00	32020		\N	40735	0	301011002	4116491		0
10622	624	4112343	1994-02-18	1994-02-18 00:00:00	1994-03-01	1994-03-01 00:00:00	32020		\N	41663	0	195662009	4112343		0
92	3	4294548	1967-09-30	1967-09-30 00:00:00	1967-11-04	1967-11-04 00:00:00	32020		\N	362	0	75498004	4294548		0
298	16	4134304	2004-01-21	2004-01-21 00:00:00	2004-03-21	2004-03-21 00:00:00	32020		\N	1165	0	263102004	4134304		0
10962	648	381316	2015-09-25	2015-09-25 00:00:00	\N	\N	32020		\N	42861	0	230690007	381316		0
637	36	28060	2006-11-22	2006-11-22 00:00:00	2006-11-30	2006-11-30 00:00:00	32020		\N	2562	0	43878008	28060		0
777	42	4112343	1988-10-15	1988-10-15 00:00:00	1988-10-26	1988-10-26 00:00:00	32020		\N	3068	0	195662009	4112343		0
11497	679	80180	2009-02-12	2009-02-12 00:00:00	\N	\N	32020		\N	44907	0	396275006	80180		0
1125	66	40481087	2012-08-27	2012-08-27 00:00:00	2012-09-17	2012-09-17 00:00:00	32020		\N	4458	0	444814009	40481087		0
1275	74	260139	1973-09-28	1973-09-28 00:00:00	1973-10-12	1973-10-12 00:00:00	32020		\N	5003	0	10509002	260139		0
1431	84	4112343	2008-09-03	2008-09-03 00:00:00	2008-09-15	2008-09-15 00:00:00	32020		\N	5657	0	195662009	4112343		0
1656	96	40481087	1970-04-05	1970-04-05 00:00:00	1970-04-26	1970-04-26 00:00:00	32020		\N	6545	0	444814009	40481087		0
1774	101	321042	2001-01-12	2001-01-12 00:00:00	\N	\N	32020		\N	6902	0	410429000	321042		0
1966	115	260139	2001-06-30	2001-06-30 00:00:00	2001-07-14	2001-07-14 00:00:00	32020		\N	7576	0	10509002	260139		0
2123	123	257012	1985-11-24	1985-11-24 00:00:00	\N	\N	32020		\N	8154	0	40055000	257012		0
12798	755	40481087	1996-02-29	1996-02-29 00:00:00	1996-03-14	1996-03-14 00:00:00	32020		\N	50065	0	444814009	40481087		0
2449	144	40481087	1990-04-03	1990-04-03 00:00:00	1990-04-17	1990-04-17 00:00:00	32020		\N	9631	0	444814009	40481087		0
2623	153	81151	1956-08-30	1956-08-30 00:00:00	1956-09-20	1956-09-20 00:00:00	32020		\N	10317	0	44465007	81151		0
2769	160	81151	1976-02-09	1976-02-09 00:00:00	1976-03-08	1976-03-08 00:00:00	32020		\N	10974	0	44465007	81151		0
2948	171	4310024	2006-06-30	2006-06-30 00:00:00	\N	\N	32020		\N	11605	0	424802006	4310024		0
3101	183	4112343	1975-11-22	1975-11-22 00:00:00	1975-12-02	1975-12-02 00:00:00	32020		\N	12390	0	195662009	4112343		0
3246	189	40481087	1972-06-02	1972-06-02 00:00:00	1972-06-09	1972-06-09 00:00:00	32020		\N	12893	0	444814009	40481087		0
3428	196	80180	2000-09-19	2000-09-19 00:00:00	\N	\N	32020		\N	13502	0	396275006	80180		0
3650	209	321042	1976-12-31	1976-12-31 00:00:00	\N	\N	32020		\N	14267	0	410429000	321042		0
3776	217	80180	2017-07-11	2017-07-11 00:00:00	\N	\N	32020		\N	14670	0	396275006	80180		0
3926	225	4113008	2016-12-01	2016-12-01 00:00:00	2016-12-22	2016-12-22 00:00:00	32020		\N	15146	0	284549007	4113008		0
4113	239	4027663	1979-10-17	1979-10-17 00:00:00	\N	\N	32020		\N	16097	0	13200003	4027663		0
4266	246	40481087	1962-08-19	1962-08-19 00:00:00	1962-09-02	1962-09-02 00:00:00	32020		\N	16587	0	444814009	40481087		0
4473	262	4310024	1998-02-21	1998-02-21 00:00:00	\N	\N	32020		\N	17391	0	424802006	4310024		0
4604	270	4113008	1982-04-13	1982-04-13 00:00:00	1982-05-04	1982-05-04 00:00:00	32020		\N	18023	0	284549007	4113008		0
4769	280	40481087	2012-12-08	2012-12-08 00:00:00	2012-12-29	2012-12-29 00:00:00	32020		\N	18735	0	444814009	40481087		0
4917	289	4112343	1996-08-04	1996-08-04 00:00:00	1996-08-14	1996-08-14 00:00:00	32020		\N	19261	0	195662009	4112343		0
5098	299	40481087	2010-07-14	2010-07-14 00:00:00	2010-07-21	2010-07-21 00:00:00	32020		\N	20028	0	444814009	40481087		0
5255	310	4112343	2002-09-17	2002-09-17 00:00:00	2002-09-24	2002-09-24 00:00:00	32020		\N	20509	0	195662009	4112343		0
5449	321	4112343	1997-10-01	1997-10-01 00:00:00	1997-10-10	1997-10-10 00:00:00	32020		\N	21274	0	195662009	4112343		0
5622	332	4112343	1994-08-17	1994-08-17 00:00:00	1994-08-29	1994-08-29 00:00:00	32020		\N	21922	0	195662009	4112343		0
5760	338	4285898	2001-07-04	2001-07-04 00:00:00	\N	\N	32020		\N	22478	0	68496003	4285898		0
5928	349	80502	2018-04-28	2018-04-28 00:00:00	\N	\N	32020		\N	23211	0	64859006	80502		0
6083	358	4112343	1948-02-13	1948-02-13 00:00:00	1948-02-22	1948-02-22 00:00:00	32020		\N	23846	0	195662009	4112343		0
6244	366	4296205	1923-01-17	1923-01-17 00:00:00	1923-02-07	1923-02-07 00:00:00	32020		\N	24352	0	403191005	4296205		0
6407	377	40481087	2014-07-27	2014-07-27 00:00:00	2014-08-17	2014-08-17 00:00:00	32020		\N	24977	0	444814009	40481087		0
6635	392	4112343	1997-01-06	1997-01-06 00:00:00	1997-01-19	1997-01-19 00:00:00	32020		\N	25741	0	195662009	4112343		0
6748	399	40481087	2000-10-18	2000-10-18 00:00:00	2000-11-08	2000-11-08 00:00:00	32020		\N	26125	0	444814009	40481087		0
6908	406	40481087	1990-02-08	1990-02-08 00:00:00	1990-03-01	1990-03-01 00:00:00	32020		\N	26813	0	444814009	40481087		0
7087	418	260139	1999-04-26	1999-04-26 00:00:00	1999-05-10	1999-05-10 00:00:00	32020		\N	27643	0	10509002	260139		0
17772	1070	80180	2009-09-14	2009-09-14 00:00:00	\N	\N	32020		\N	70091	0	396275006	80180		0
7425	437	40481087	2018-05-17	2018-05-17 00:00:00	2018-05-24	2018-05-24 00:00:00	32020		\N	29032	0	444814009	40481087		0
7584	445	81151	1951-08-05	1951-08-05 00:00:00	1951-08-19	1951-08-19 00:00:00	32020		\N	29638	0	44465007	81151		0
7741	454	260139	1975-03-28	1975-03-28 00:00:00	1975-04-11	1975-04-11 00:00:00	32020		\N	30283	0	10509002	260139		0
7922	462	260139	1986-09-16	1986-09-16 00:00:00	1986-09-23	1986-09-23 00:00:00	32020		\N	30890	0	10509002	260139		0
8097	474	4310024	2002-10-02	2002-10-02 00:00:00	\N	\N	32020		\N	31654	0	424802006	4310024		0
8269	482	4112343	1979-03-21	1979-03-21 00:00:00	1979-04-02	1979-04-02 00:00:00	32020		\N	32199	0	195662009	4112343		0
8403	488	40481087	2000-01-07	2000-01-07 00:00:00	2000-01-14	2000-01-14 00:00:00	32020		\N	32695	0	444814009	40481087		0
8583	500	28060	1967-05-23	1967-05-23 00:00:00	1967-06-03	1967-06-03 00:00:00	32020		\N	33538	0	43878008	28060		0
8763	512	260139	2013-06-07	2013-06-07 00:00:00	2013-06-14	2013-06-14 00:00:00	32020		\N	34220	0	10509002	260139		0
19471	1169	4112343	1952-02-18	1952-02-18 00:00:00	1952-02-26	1952-02-26 00:00:00	32020		\N	76959	0	195662009	4112343		0
9083	534	40481087	1986-12-12	1986-12-12 00:00:00	1986-12-26	1986-12-26 00:00:00	32020		\N	35528	0	444814009	40481087		0
9295	549	4112343	2010-05-09	2010-05-09 00:00:00	2010-05-19	2010-05-19 00:00:00	32020		\N	36367	0	195662009	4112343		0
9443	558	4112343	1981-11-27	1981-11-27 00:00:00	1981-12-07	1981-12-07 00:00:00	32020		\N	36971	0	195662009	4112343		0
9736	576	81151	1999-06-28	1999-06-28 00:00:00	1999-07-12	1999-07-12 00:00:00	32020		\N	38087	0	44465007	81151		0
9925	588	4112343	2016-02-13	2016-02-13 00:00:00	2016-02-26	2016-02-26 00:00:00	32020		\N	38936	0	195662009	4112343		0
10125	600	40479768	2018-07-16	2018-07-16 00:00:00	2018-09-21	2018-09-21 00:00:00	32020		\N	39652	0	444470001	40479768		0
10248	606	80180	2010-07-28	2010-07-28 00:00:00	\N	\N	32020		\N	40263	0	396275006	80180		0
10404	613	40481087	1969-11-08	1969-11-08 00:00:00	1969-11-22	1969-11-22 00:00:00	32020		\N	40734	0	444814009	40481087		0
10623	624	81151	1968-07-27	1968-07-27 00:00:00	1968-08-17	1968-08-17 00:00:00	32020		\N	41692	0	44465007	81151		0
93	3	4112343	2008-10-05	2008-10-05 00:00:00	2008-10-13	2008-10-13 00:00:00	32020		\N	230	0	195662009	4112343		0
299	16	80180	2013-03-21	2013-03-21 00:00:00	\N	\N	32020		\N	1264	0	396275006	80180		0
10963	648	440086	1940-12-14	1940-12-14 00:00:00	1950-12-22	1950-12-22 00:00:00	32020		\N	42841	0	192127007	440086		0
638	36	40481087	1970-05-22	1970-05-22 00:00:00	1970-06-05	1970-06-05 00:00:00	32020		\N	2487	0	444814009	40481087		0
778	42	260139	1989-05-16	1989-05-16 00:00:00	1989-05-23	1989-05-23 00:00:00	32020		\N	3057	0	10509002	260139		0
11498	679	4285898	2008-08-16	2008-08-16 00:00:00	\N	\N	32020		\N	44907	0	68496003	4285898		0
1126	66	260139	2000-09-27	2000-09-27 00:00:00	2000-10-04	2000-10-04 00:00:00	32020		\N	4506	0	10509002	260139		0
1276	74	4112343	1989-01-29	1989-01-29 00:00:00	1989-02-10	1989-02-10 00:00:00	32020		\N	5012	0	195662009	4112343		0
1432	84	260139	1996-11-08	1996-11-08 00:00:00	1996-11-22	1996-11-22 00:00:00	32020		\N	5652	0	10509002	260139		0
1657	96	40481087	1994-03-17	1994-03-17 00:00:00	1994-03-31	1994-03-31 00:00:00	32020		\N	6552	0	444814009	40481087		0
1775	101	372328	1988-11-23	1988-11-23 00:00:00	1989-06-02	1989-06-02 00:00:00	32020		\N	6840	0	65363002	372328		0
1967	115	40481087	1982-09-27	1982-09-27 00:00:00	1982-10-04	1982-10-04 00:00:00	32020		\N	7595	0	444814009	40481087		0
2124	123	4112343	2011-04-10	2011-04-10 00:00:00	2011-04-17	2011-04-17 00:00:00	32020		\N	8157	0	195662009	4112343		0
12799	755	4112343	2014-01-24	2014-01-24 00:00:00	2014-01-31	2014-01-31 00:00:00	32020		\N	50069	0	195662009	4112343		0
2450	144	40481087	1987-01-22	1987-01-22 00:00:00	1987-01-29	1987-01-29 00:00:00	32020		\N	9614	0	444814009	40481087		0
2624	153	40481087	1985-11-15	1985-11-15 00:00:00	1985-12-06	1985-12-06 00:00:00	32020		\N	10324	0	444814009	40481087		0
2770	160	439777	2000-07-17	2000-07-17 00:00:00	\N	\N	32020		\N	11003	0	271737000	439777		0
2949	171	4112343	1991-05-26	1991-05-26 00:00:00	1991-06-02	1991-06-02 00:00:00	32020		\N	11625	0	195662009	4112343		0
3102	183	372328	1978-08-04	1978-08-04 00:00:00	1978-09-28	1978-09-28 00:00:00	32020		\N	12393	0	65363002	372328		0
3247	189	40481087	2004-02-07	2004-02-07 00:00:00	2004-02-28	2004-02-28 00:00:00	32020		\N	12897	0	444814009	40481087		0
3429	196	372328	1957-10-17	1957-10-17 00:00:00	1958-03-22	1958-03-22 00:00:00	32020		\N	13489	0	65363002	372328		0
3651	209	260139	1958-10-15	1958-10-15 00:00:00	1958-10-22	1958-10-22 00:00:00	32020		\N	14258	0	10509002	260139		0
3777	217	40481087	1998-10-23	1998-10-23 00:00:00	1998-10-30	1998-10-30 00:00:00	32020		\N	14650	0	444814009	40481087		0
3927	225	4112343	2012-07-21	2012-07-21 00:00:00	2012-07-29	2012-07-29 00:00:00	32020		\N	15198	0	195662009	4112343		0
4114	239	40481087	2001-08-19	2001-08-19 00:00:00	2001-09-09	2001-09-09 00:00:00	32020		\N	16018	0	444814009	40481087		0
4267	246	81151	1981-06-06	1981-06-06 00:00:00	1981-06-27	1981-06-27 00:00:00	32020		\N	16547	0	44465007	81151		0
4474	262	40481087	1996-11-06	1996-11-06 00:00:00	1996-11-27	1996-11-27 00:00:00	32020		\N	17391	0	444814009	40481087		0
4605	270	4112343	1976-09-10	1976-09-10 00:00:00	1976-09-19	1976-09-19 00:00:00	32020		\N	17958	0	195662009	4112343		0
4770	280	4109685	1988-05-20	1988-05-20 00:00:00	1988-06-10	1988-06-10 00:00:00	32020		\N	18706	0	284551006	4109685		0
4918	289	260139	2010-10-17	2010-10-17 00:00:00	2010-10-31	2010-10-31 00:00:00	32020		\N	19283	0	10509002	260139		0
5099	299	81151	2015-07-29	2015-07-29 00:00:00	2015-08-26	2015-08-26 00:00:00	32020		\N	20004	0	44465007	81151		0
5256	310	4152936	2002-07-15	2002-07-15 00:00:00	2002-08-05	2002-08-05 00:00:00	32020		\N	20498	0	283385000	4152936		0
5450	321	260139	1991-12-29	1991-12-29 00:00:00	1992-01-12	1992-01-12 00:00:00	32020		\N	21258	0	10509002	260139		0
5623	332	4283893	2004-12-19	2004-12-19 00:00:00	2005-01-30	2005-01-30 00:00:00	32020		\N	21888	0	36971009	4283893		0
5761	338	80180	2001-08-03	2001-08-03 00:00:00	\N	\N	32020		\N	22478	0	396275006	80180		0
5929	349	40481087	2004-04-21	2004-04-21 00:00:00	2004-04-28	2004-04-28 00:00:00	32020		\N	23246	0	444814009	40481087		0
6084	358	378001	1964-08-16	1964-08-16 00:00:00	1964-10-15	1964-10-15 00:00:00	32020		\N	23861	0	62106007	378001		0
6245	366	40481087	1934-06-09	1934-06-09 00:00:00	1934-06-23	1934-06-23 00:00:00	32020		\N	24268	0	444814009	40481087		0
6408	377	321042	1996-11-07	1996-11-07 00:00:00	\N	\N	32020		\N	24997	0	410429000	321042		0
6636	392	78272	1988-02-26	1988-02-26 00:00:00	1988-03-11	1988-03-11 00:00:00	32020		\N	25745	0	70704007	78272		0
6749	399	4112343	1994-12-09	1994-12-09 00:00:00	1994-12-20	1994-12-20 00:00:00	32020		\N	26124	0	195662009	4112343		0
6909	406	375671	1992-03-04	1992-03-04 00:00:00	1992-04-03	1992-04-03 00:00:00	32020		\N	26815	0	62564004	375671		0
7088	418	4059173	1961-05-17	1961-05-17 00:00:00	1961-08-15	1961-08-15 00:00:00	32020		\N	27669	0	16114001	4059173		0
17773	1070	40481087	2018-12-30	2018-12-30 00:00:00	2019-01-06	2019-01-06 00:00:00	32020		\N	70066	0	444814009	40481087		0
7426	437	40481087	1965-03-03	1965-03-03 00:00:00	1965-03-24	1965-03-24 00:00:00	32020		\N	29010	0	444814009	40481087		0
7585	445	378419	1990-07-27	1990-07-27 00:00:00	\N	\N	32020		\N	29601	0	26929004	378419		0
7742	454	372328	1935-07-30	1935-07-30 00:00:00	1935-11-09	1935-11-09 00:00:00	32020		\N	30304	0	65363002	372328		0
7923	462	372328	1992-06-17	1992-06-17 00:00:00	1992-10-29	1992-10-29 00:00:00	32020		\N	30909	0	65363002	372328		0
8098	474	4112343	1993-05-23	1993-05-23 00:00:00	1993-06-05	1993-06-05 00:00:00	32020		\N	31610	0	195662009	4112343		0
8285	484	40481087	1983-01-16	1983-01-16 00:00:00	1983-01-23	1983-01-23 00:00:00	32020		\N	32315	0	444814009	40481087		0
8404	488	28060	1958-06-13	1958-06-13 00:00:00	1958-06-25	1958-06-25 00:00:00	32020		\N	32615	0	43878008	28060		0
8584	500	372328	1962-03-18	1962-03-18 00:00:00	1962-05-29	1962-05-29 00:00:00	32020		\N	33526	0	65363002	372328		0
8764	512	4112343	1998-12-16	1998-12-16 00:00:00	1998-12-27	1998-12-27 00:00:00	32020		\N	34164	0	195662009	4112343		0
19472	1169	4294548	1980-11-23	1980-11-23 00:00:00	1980-11-30	1980-11-30 00:00:00	32020		\N	77031	0	75498004	4294548		0
9084	534	440086	1988-06-17	1988-06-17 00:00:00	1993-07-02	1993-07-02 00:00:00	32020		\N	35592	0	192127007	440086		0
9296	549	28060	1958-09-01	1958-09-01 00:00:00	1958-09-12	1958-09-12 00:00:00	32020		\N	36355	0	43878008	28060		0
9444	558	40481087	1978-11-25	1978-11-25 00:00:00	1978-12-02	1978-12-02 00:00:00	32020		\N	36984	0	444814009	40481087		0
9602	569	4142905	1976-04-08	1976-04-08 00:00:00	1976-07-07	1976-07-07 00:00:00	32020		\N	37663	0	33737001	4142905		0
9737	576	40481087	2012-12-16	2012-12-16 00:00:00	2012-12-30	2012-12-30 00:00:00	32020		\N	38129	0	444814009	40481087		0
9926	588	80180	2019-06-08	2019-06-08 00:00:00	\N	\N	32020		\N	38960	0	396275006	80180		0
10126	600	40481087	1977-08-06	1977-08-06 00:00:00	1977-08-13	1977-08-13 00:00:00	32020		\N	39627	0	444814009	40481087		0
10249	606	40481087	2010-02-24	2010-02-24 00:00:00	2010-03-03	2010-03-03 00:00:00	32020		\N	40263	0	444814009	40481087		0
10405	613	4112343	1997-07-27	1997-07-27 00:00:00	1997-08-09	1997-08-09 00:00:00	32020		\N	40748	0	195662009	4112343		0
10624	624	40481087	2009-08-06	2009-08-06 00:00:00	2009-08-13	2009-08-13 00:00:00	32020		\N	41664	0	444814009	40481087		0
94	3	4027663	1946-12-26	1946-12-26 00:00:00	\N	\N	32020		\N	244	0	13200003	4027663		0
300	16	4155034	1975-05-25	1975-05-25 00:00:00	1975-06-08	1975-06-08 00:00:00	32020		\N	1162	0	283371005	4155034		0
10964	648	4027663	1959-12-10	1959-12-10 00:00:00	\N	\N	32020		\N	42876	0	13200003	4027663		0
639	36	40479422	2001-03-23	2001-03-23 00:00:00	2001-04-29	2001-04-29 00:00:00	32020		\N	2611	0	444448004	40479422		0
779	42	260139	1999-11-17	1999-11-17 00:00:00	1999-11-24	1999-11-24 00:00:00	32020		\N	3059	0	10509002	260139		0
11499	679	4027663	1999-04-01	1999-04-01 00:00:00	\N	\N	32020		\N	44918	0	13200003	4027663		0
1127	66	4155034	1959-04-23	1959-04-23 00:00:00	1959-05-14	1959-05-14 00:00:00	32020		\N	4447	0	283371005	4155034		0
1277	74	40481087	1979-11-30	1979-11-30 00:00:00	1979-12-14	1979-12-14 00:00:00	32020		\N	5010	0	444814009	40481087		0
1433	84	40481087	2007-02-05	2007-02-05 00:00:00	2007-02-12	2007-02-12 00:00:00	32020		\N	5673	0	444814009	40481087		0
1658	96	260139	1935-03-06	1935-03-06 00:00:00	1935-03-13	1935-03-13 00:00:00	32020		\N	6542	0	10509002	260139		0
1776	101	28060	1983-04-17	1983-04-17 00:00:00	1983-04-25	1983-04-25 00:00:00	32020		\N	6907	0	43878008	28060		0
1968	115	4116491	1976-01-02	1976-01-02 00:00:00	1976-03-02	1976-03-02 00:00:00	32020		\N	7573	0	301011002	4116491		0
2125	123	80180	1986-03-24	1986-03-24 00:00:00	\N	\N	32020		\N	8143	0	396275006	80180		0
12800	755	28060	1953-04-08	1953-04-08 00:00:00	1953-04-19	1953-04-19 00:00:00	32020		\N	50091	0	43878008	28060		0
2451	144	260139	2010-07-21	2010-07-21 00:00:00	2010-07-28	2010-07-28 00:00:00	32020		\N	9662	0	10509002	260139		0
2625	153	372328	1943-10-08	1943-10-08 00:00:00	1943-11-25	1943-11-25 00:00:00	32020		\N	10336	0	65363002	372328		0
2771	160	260139	2003-06-06	2003-06-06 00:00:00	2003-06-13	2003-06-13 00:00:00	32020		\N	11004	0	10509002	260139		0
2950	171	4156265	1983-06-21	1983-06-21 00:00:00	1983-07-12	1983-07-12 00:00:00	32020		\N	11609	0	370247008	4156265		0
3103	183	28060	1988-07-27	1988-07-27 00:00:00	1988-08-07	1988-08-07 00:00:00	32020		\N	12409	0	43878008	28060		0
3248	189	40481087	1986-11-24	1986-11-24 00:00:00	1986-12-08	1986-12-08 00:00:00	32020		\N	12838	0	444814009	40481087		0
3430	196	4112343	1991-02-05	1991-02-05 00:00:00	1991-02-16	1991-02-16 00:00:00	32020		\N	13518	0	195662009	4112343		0
3652	209	80180	1988-07-08	1988-07-08 00:00:00	\N	\N	32020		\N	14284	0	396275006	80180		0
3778	217	40481087	1990-02-15	1990-02-15 00:00:00	1990-03-08	1990-03-08 00:00:00	32020		\N	14638	0	444814009	40481087		0
3943	227	378001	1999-04-23	1999-04-23 00:00:00	1999-06-22	1999-06-22 00:00:00	32020		\N	15307	0	62106007	378001		0
4115	239	260139	1988-09-01	1988-09-01 00:00:00	1988-09-08	1988-09-08 00:00:00	32020		\N	16059	0	10509002	260139		0
4268	246	78272	2018-03-15	2018-03-15 00:00:00	2018-04-05	2018-04-05 00:00:00	32020		\N	16551	0	70704007	78272		0
4475	262	4285898	1999-03-18	1999-03-18 00:00:00	\N	\N	32020		\N	17391	0	68496003	4285898		0
4606	270	372328	1958-12-01	1958-12-01 00:00:00	1959-01-13	1959-01-13 00:00:00	32020		\N	17991	0	65363002	372328		0
4771	280	260139	1981-01-08	1981-01-08 00:00:00	1981-01-15	1981-01-15 00:00:00	32020		\N	18716	0	10509002	260139		0
4919	289	28060	2005-08-13	2005-08-13 00:00:00	2005-08-23	2005-08-23 00:00:00	32020		\N	19295	0	43878008	28060		0
5100	299	378001	1995-06-14	1995-06-14 00:00:00	1995-07-14	1995-07-14 00:00:00	32020		\N	20003	0	62106007	378001		0
5257	310	28060	1998-01-28	1998-01-28 00:00:00	1998-02-08	1998-02-08 00:00:00	32020		\N	20508	0	43878008	28060		0
5451	321	4112343	1965-12-07	1965-12-07 00:00:00	1965-12-17	1965-12-17 00:00:00	32020		\N	21304	0	195662009	4112343		0
5624	332	378001	1988-06-14	1988-06-14 00:00:00	1988-07-14	1988-07-14 00:00:00	32020		\N	21911	0	62106007	378001		0
5762	338	4112343	2016-07-16	2016-07-16 00:00:00	2016-07-27	2016-07-27 00:00:00	32020		\N	22501	0	195662009	4112343		0
5930	349	40481087	1997-06-11	1997-06-11 00:00:00	1997-06-25	1997-06-25 00:00:00	32020		\N	23245	0	444814009	40481087		0
6085	358	40481087	1969-10-26	1969-10-26 00:00:00	1969-11-09	1969-11-09 00:00:00	32020		\N	23793	0	444814009	40481087		0
6246	366	4027663	1936-02-13	1936-02-13 00:00:00	\N	\N	32020		\N	24268	0	13200003	4027663		0
6410	377	78272	1995-07-13	1995-07-13 00:00:00	1995-08-17	1995-08-17 00:00:00	32020		\N	24996	0	70704007	78272		0
6637	392	4237458	1978-03-20	1978-03-20 00:00:00	1978-04-19	1978-04-19 00:00:00	32020		\N	25744	0	58150001	4237458		0
6750	399	4280726	1958-04-09	1958-04-09 00:00:00	\N	\N	32020		\N	26107	0	367498001	4280726		0
6910	406	372328	1952-09-16	1952-09-16 00:00:00	1952-10-28	1952-10-28 00:00:00	32020		\N	26797	0	65363002	372328		0
7089	418	4294548	1973-04-22	1973-04-22 00:00:00	1973-04-29	1973-04-29 00:00:00	32020		\N	27608	0	75498004	4294548		0
17774	1070	260139	2007-02-11	2007-02-11 00:00:00	2007-02-18	2007-02-18 00:00:00	32020		\N	70048	0	10509002	260139		0
7427	437	372328	1947-06-07	1947-06-07 00:00:00	1947-07-22	1947-07-22 00:00:00	32020		\N	28982	0	65363002	372328		0
7586	445	40481087	1911-10-27	1911-10-27 00:00:00	1911-11-10	1911-11-10 00:00:00	32020		\N	29640	0	444814009	40481087		0
7743	454	4109685	1991-12-15	1991-12-15 00:00:00	1991-12-29	1991-12-29 00:00:00	32020		\N	30275	0	284551006	4109685		0
7924	462	4112343	2000-11-25	2000-11-25 00:00:00	2000-12-06	2000-12-06 00:00:00	32020		\N	30868	0	195662009	4112343		0
8099	474	4112343	1980-08-02	1980-08-02 00:00:00	1980-08-14	1980-08-14 00:00:00	32020		\N	31601	0	195662009	4112343		0
8286	484	28060	1940-01-27	1940-01-27 00:00:00	1940-02-08	1940-02-08 00:00:00	32020		\N	32305	0	43878008	28060		0
8405	488	260139	1988-01-17	1988-01-17 00:00:00	1988-01-31	1988-01-31 00:00:00	32020		\N	32624	0	10509002	260139		0
8585	500	40481087	1972-12-26	1972-12-26 00:00:00	1973-01-09	1973-01-09 00:00:00	32020		\N	33487	0	444814009	40481087		0
8784	515	4294548	1998-11-16	1998-11-16 00:00:00	1998-11-30	1998-11-30 00:00:00	32020		\N	34328	0	75498004	4294548		0
19473	1169	4112343	1975-09-09	1975-09-09 00:00:00	1975-09-18	1975-09-18 00:00:00	32020		\N	76961	0	195662009	4112343		0
9085	534	40481087	1978-08-27	1978-08-27 00:00:00	1978-09-10	1978-09-10 00:00:00	32020		\N	35526	0	444814009	40481087		0
19769	1188	40481087	1992-03-08	1992-03-08 00:00:00	1992-03-15	1992-03-15 00:00:00	32020		\N	78282	0	444814009	40481087		0
9445	558	260139	1974-09-22	1974-09-22 00:00:00	1974-10-06	1974-10-06 00:00:00	32020		\N	36995	0	10509002	260139		0
9603	569	260139	1912-10-25	1912-10-25 00:00:00	1912-11-01	1912-11-01 00:00:00	32020		\N	37689	0	10509002	260139		0
9738	576	260139	2013-09-24	2013-09-24 00:00:00	2013-10-08	2013-10-08 00:00:00	32020		\N	38131	0	10509002	260139		0
9927	588	260139	1981-11-26	1981-11-26 00:00:00	1981-12-10	1981-12-10 00:00:00	32020		\N	38916	0	10509002	260139		0
20585	1236	4278672	2005-12-08	2005-12-08 00:00:00	2006-01-07	2006-01-07 00:00:00	32020		\N	81489	0	65966004	4278672		0
10250	606	260139	1978-07-27	1978-07-27 00:00:00	1978-08-03	1978-08-03 00:00:00	32020		\N	40260	0	10509002	260139		0
10406	613	40481087	1989-04-15	1989-04-15 00:00:00	1989-04-22	1989-04-22 00:00:00	32020		\N	40736	0	444814009	40481087		0
21083	1266	4294548	2013-05-30	2013-05-30 00:00:00	2013-08-22	2013-08-22 00:00:00	32020		\N	83443	0	75498004	4294548		0
95	3	4059173	1950-01-25	1950-01-25 00:00:00	1950-02-24	1950-02-24 00:00:00	32020		\N	344	0	16114001	4059173		0
301	16	40481087	1986-09-29	1986-09-29 00:00:00	1986-10-20	1986-10-20 00:00:00	32020		\N	1230	0	444814009	40481087		0
10965	648	260139	1938-08-25	1938-08-25 00:00:00	1938-09-08	1938-09-08 00:00:00	32020		\N	42840	0	10509002	260139		0
640	36	4155034	2011-07-06	2011-07-06 00:00:00	2011-07-27	2011-07-27 00:00:00	32020		\N	2612	0	283371005	4155034		0
780	42	28060	1985-05-25	1985-05-25 00:00:00	1985-06-01	1985-06-01 00:00:00	32020		\N	2998	0	43878008	28060		0
11500	679	40481087	1998-12-17	1998-12-17 00:00:00	1998-12-31	1998-12-31 00:00:00	32020		\N	44918	0	444814009	40481087		0
1128	66	372328	1975-09-26	1975-09-26 00:00:00	1976-05-14	1976-05-14 00:00:00	32020		\N	4478	0	65363002	372328		0
1278	74	40481087	2006-10-23	2006-10-23 00:00:00	2006-11-06	2006-11-06 00:00:00	32020		\N	4989	0	444814009	40481087		0
1434	84	40481087	2001-11-07	2001-11-07 00:00:00	2001-11-28	2001-11-28 00:00:00	32020		\N	5654	0	444814009	40481087		0
1659	96	4116491	1985-12-26	1985-12-26 00:00:00	1986-02-12	1986-02-12 00:00:00	32020		\N	6471	0	301011002	4116491		0
1777	101	40481087	2001-11-07	2001-11-07 00:00:00	2001-11-28	2001-11-28 00:00:00	32020		\N	6909	0	444814009	40481087		0
1969	115	4056621	1976-01-02	1976-01-02 00:00:00	\N	\N	32020		\N	7573	0	197927001	4056621		0
2126	123	40481087	1986-01-05	1986-01-05 00:00:00	1986-01-26	1986-01-26 00:00:00	32020		\N	8143	0	444814009	40481087		0
12801	755	260139	2004-04-16	2004-04-16 00:00:00	2004-04-30	2004-04-30 00:00:00	32020		\N	50068	0	10509002	260139		0
2452	144	260139	1984-01-21	1984-01-21 00:00:00	1984-01-28	1984-01-28 00:00:00	32020		\N	9630	0	10509002	260139		0
2626	154	40481087	1977-09-11	1977-09-11 00:00:00	1977-10-02	1977-10-02 00:00:00	32020		\N	10432	0	444814009	40481087		0
2772	160	40481087	1970-08-20	1970-08-20 00:00:00	1970-09-03	1970-09-03 00:00:00	32020		\N	10936	0	444814009	40481087		0
2951	171	40481087	1975-03-11	1975-03-11 00:00:00	1975-04-01	1975-04-01 00:00:00	32020		\N	11583	0	444814009	40481087		0
3104	183	40481087	1992-11-12	1992-11-12 00:00:00	1992-11-26	1992-11-26 00:00:00	32020		\N	12410	0	444814009	40481087		0
3249	189	260139	2003-07-16	2003-07-16 00:00:00	2003-07-30	2003-07-30 00:00:00	32020		\N	12895	0	10509002	260139		0
3431	196	4027663	1988-10-07	1988-10-07 00:00:00	\N	\N	32020		\N	13517	0	13200003	4027663		0
14111	834	260139	1977-09-18	1977-09-18 00:00:00	1977-09-25	1977-09-25 00:00:00	32020		\N	55209	0	10509002	260139		0
3779	217	40481087	2002-02-16	2002-02-16 00:00:00	2002-03-02	2002-03-02 00:00:00	32020		\N	14651	0	444814009	40481087		0
3944	227	4112343	1972-03-17	1972-03-17 00:00:00	1972-03-29	1972-03-29 00:00:00	32020		\N	15364	0	195662009	4112343		0
4116	239	260139	2003-11-21	2003-11-21 00:00:00	2003-12-05	2003-12-05 00:00:00	32020		\N	16037	0	10509002	260139		0
4269	246	260139	2011-08-12	2011-08-12 00:00:00	2011-08-26	2011-08-26 00:00:00	32020		\N	16582	0	10509002	260139		0
4476	262	30753	1998-11-18	1998-11-18 00:00:00	\N	\N	32020		\N	17391	0	16761005	30753		0
4607	270	40481087	1995-10-02	1995-10-02 00:00:00	1995-10-09	1995-10-09 00:00:00	32020		\N	17954	0	444814009	40481087		0
4772	280	260139	2009-01-03	2009-01-03 00:00:00	2009-01-10	2009-01-10 00:00:00	32020		\N	18744	0	10509002	260139		0
4920	289	40481087	2007-07-08	2007-07-08 00:00:00	2007-07-29	2007-07-29 00:00:00	32020		\N	19265	0	444814009	40481087		0
5101	299	4294548	1971-02-11	1971-02-11 00:00:00	1971-03-04	1971-03-04 00:00:00	32020		\N	20009	0	75498004	4294548		0
5258	310	4134304	1961-11-26	1961-11-26 00:00:00	1962-02-24	1962-02-24 00:00:00	32020		\N	20496	0	263102004	4134304		0
5452	321	4112343	1965-09-25	1965-09-25 00:00:00	1965-10-07	1965-10-07 00:00:00	32020		\N	21270	0	195662009	4112343		0
5625	332	260139	1982-09-26	1982-09-26 00:00:00	1982-10-10	1982-10-10 00:00:00	32020		\N	22014	0	10509002	260139		0
5763	338	4112343	2006-02-20	2006-02-20 00:00:00	2006-03-01	2006-03-01 00:00:00	32020		\N	22528	0	195662009	4112343		0
5931	349	4283893	1966-07-23	1966-07-23 00:00:00	1966-08-20	1966-08-20 00:00:00	32020		\N	23197	0	36971009	4283893		0
6086	358	81893	1975-06-10	1975-06-10 00:00:00	\N	\N	32020		\N	23786	0	64766004	81893		0
6247	366	4218389	1995-08-25	1995-08-25 00:00:00	1995-09-29	1995-09-29 00:00:00	32020		\N	24354	0	39848009	4218389		0
6411	377	4112343	1985-02-01	1985-02-01 00:00:00	1985-02-14	1985-02-14 00:00:00	32020		\N	25010	0	195662009	4112343		0
6638	392	4112343	1997-09-18	1997-09-18 00:00:00	1997-09-30	1997-09-30 00:00:00	32020		\N	25717	0	195662009	4112343		0
6751	399	4237458	1980-07-16	1980-07-16 00:00:00	1980-09-14	1980-09-14 00:00:00	32020		\N	26237	0	58150001	4237458		0
6911	406	4156265	1987-06-15	1987-06-15 00:00:00	1987-06-29	1987-06-29 00:00:00	32020		\N	26814	0	370247008	4156265		0
7090	418	40481087	1975-01-28	1975-01-28 00:00:00	1975-02-11	1975-02-11 00:00:00	32020		\N	27609	0	444814009	40481087		0
17775	1070	40481087	2011-04-29	2011-04-29 00:00:00	2011-05-06	2011-05-06 00:00:00	32020		\N	70065	0	444814009	40481087		0
7428	437	40481087	1962-02-09	1962-02-09 00:00:00	1962-02-16	1962-02-16 00:00:00	32020		\N	28991	0	444814009	40481087		0
7587	445	40481087	1990-07-29	1990-07-29 00:00:00	1990-08-05	1990-08-05 00:00:00	32020		\N	29591	0	444814009	40481087		0
7744	454	4112343	1952-02-23	1952-02-23 00:00:00	1952-03-06	1952-03-06 00:00:00	32020		\N	30345	0	195662009	4112343		0
7925	462	260139	2002-02-03	2002-02-03 00:00:00	2002-02-10	2002-02-10 00:00:00	32020		\N	30884	0	10509002	260139		0
8100	474	28060	1982-12-04	1982-12-04 00:00:00	1982-12-16	1982-12-16 00:00:00	32020		\N	31646	0	43878008	28060		0
8287	484	192671	1974-08-11	1974-08-11 00:00:00	\N	\N	32020		\N	32404	0	K92.2	35208414		0
8406	488	4112343	2016-02-02	2016-02-02 00:00:00	2016-02-11	2016-02-11 00:00:00	32020		\N	32621	0	195662009	4112343		0
8586	500	40481087	2000-11-28	2000-11-28 00:00:00	2000-12-05	2000-12-05 00:00:00	32020		\N	33515	0	444814009	40481087		0
8785	515	381316	2014-05-24	2014-05-24 00:00:00	\N	\N	32020		\N	34401	0	230690007	381316		0
19474	1169	80180	1975-12-23	1975-12-23 00:00:00	\N	\N	32020		\N	76961	0	396275006	80180		0
9086	534	372328	1980-02-09	1980-02-09 00:00:00	1980-05-27	1980-05-27 00:00:00	32020		\N	35581	0	65363002	372328		0
19770	1188	40481087	1998-01-31	1998-01-31 00:00:00	1998-02-21	1998-02-21 00:00:00	32020		\N	78260	0	444814009	40481087		0
9446	558	381316	2003-09-04	2003-09-04 00:00:00	\N	\N	32020		\N	36972	0	230690007	381316		0
9604	569	4112343	1958-01-24	1958-01-24 00:00:00	1958-02-01	1958-02-01 00:00:00	32020		\N	37665	0	195662009	4112343		0
9739	576	40481087	2015-12-17	2015-12-17 00:00:00	2015-12-31	2015-12-31 00:00:00	32020		\N	38104	0	444814009	40481087		0
9928	588	40481087	1985-02-12	1985-02-12 00:00:00	1985-02-26	1985-02-26 00:00:00	32020		\N	38921	0	444814009	40481087		0
20586	1236	40481087	1957-05-11	1957-05-11 00:00:00	1957-05-25	1957-05-25 00:00:00	32020		\N	81463	0	444814009	40481087		0
10251	606	378001	1996-11-23	1996-11-23 00:00:00	1997-01-22	1997-01-22 00:00:00	32020		\N	40239	0	62106007	378001		0
10407	613	4283893	1987-02-07	1987-02-07 00:00:00	1987-06-20	1987-06-20 00:00:00	32020		\N	40761	0	36971009	4283893		0
21084	1266	40481087	2014-02-24	2014-02-24 00:00:00	2014-03-03	2014-03-03 00:00:00	32020		\N	83444	0	444814009	40481087		0
96	3	378001	1938-11-24	1938-11-24 00:00:00	1939-01-23	1939-01-23 00:00:00	32020		\N	343	0	62106007	378001		0
302	16	4112343	1976-09-20	1976-09-20 00:00:00	1976-10-02	1976-10-02 00:00:00	32020		\N	1275	0	195662009	4112343		0
10966	648	81151	1993-05-05	1993-05-05 00:00:00	1993-06-09	1993-06-09 00:00:00	32020		\N	42964	0	44465007	81151		0
641	36	40481087	1988-03-23	1988-03-23 00:00:00	1988-03-30	1988-03-30 00:00:00	32020		\N	2517	0	444814009	40481087		0
781	42	40481087	1980-08-10	1980-08-10 00:00:00	1980-08-17	1980-08-17 00:00:00	32020		\N	3056	0	444814009	40481087		0
11501	679	260139	2011-06-11	2011-06-11 00:00:00	2011-06-18	2011-06-18 00:00:00	32020		\N	44940	0	10509002	260139		0
1129	66	260139	1972-04-16	1972-04-16 00:00:00	1972-04-30	1972-04-30 00:00:00	32020		\N	4475	0	10509002	260139		0
1279	74	28060	1986-02-04	1986-02-04 00:00:00	1986-02-11	1986-02-11 00:00:00	32020		\N	5013	0	43878008	28060		0
1435	84	4112343	1974-05-16	1974-05-16 00:00:00	1974-05-26	1974-05-26 00:00:00	32020		\N	5679	0	195662009	4112343		0
1660	96	80180	1963-04-02	1963-04-02 00:00:00	\N	\N	32020		\N	6469	0	396275006	80180		0
1778	101	260139	1989-05-22	1989-05-22 00:00:00	1989-06-05	1989-06-05 00:00:00	32020		\N	6908	0	10509002	260139		0
1970	115	4294548	1962-08-25	1962-08-25 00:00:00	1962-09-29	1962-09-29 00:00:00	32020		\N	7571	0	75498004	4294548		0
2127	123	40481087	1958-09-25	1958-09-25 00:00:00	1958-10-16	1958-10-16 00:00:00	32020		\N	8142	0	444814009	40481087		0
12802	755	28060	1975-06-02	1975-06-02 00:00:00	1975-06-10	1975-06-10 00:00:00	32020		\N	50045	0	43878008	28060		0
2453	144	40481087	2009-11-21	2009-11-21 00:00:00	2009-12-12	2009-12-12 00:00:00	32020		\N	9632	0	444814009	40481087		0
2627	154	4112343	1979-07-02	1979-07-02 00:00:00	1979-07-09	1979-07-09 00:00:00	32020		\N	10433	0	195662009	4112343		0
2773	160	260139	1973-02-10	1973-02-10 00:00:00	1973-02-17	1973-02-17 00:00:00	32020		\N	10944	0	10509002	260139		0
2952	171	260139	1981-10-30	1981-10-30 00:00:00	1981-11-06	1981-11-06 00:00:00	32020		\N	11585	0	10509002	260139		0
3105	183	40481087	2006-07-11	2006-07-11 00:00:00	2006-07-18	2006-07-18 00:00:00	32020		\N	12411	0	444814009	40481087		0
3250	189	4112343	1977-08-28	1977-08-28 00:00:00	1977-09-05	1977-09-05 00:00:00	32020		\N	12879	0	195662009	4112343		0
3432	196	4116491	1988-10-07	1988-10-07 00:00:00	1988-11-07	1988-11-07 00:00:00	32020		\N	13517	0	301011002	4116491		0
14112	834	4218389	1983-01-04	1983-01-04 00:00:00	1983-01-25	1983-01-25 00:00:00	32020		\N	55251	0	39848009	4218389		0
3780	217	40481087	1981-11-09	1981-11-09 00:00:00	1981-11-23	1981-11-23 00:00:00	32020		\N	14644	0	444814009	40481087		0
3945	227	80180	2009-11-01	2009-11-01 00:00:00	\N	\N	32020		\N	15346	0	396275006	80180		0
4117	239	260139	1964-01-20	1964-01-20 00:00:00	1964-02-03	1964-02-03 00:00:00	32020		\N	16057	0	10509002	260139		0
4270	246	4112343	1962-11-12	1962-11-12 00:00:00	1962-11-22	1962-11-22 00:00:00	32020		\N	16518	0	195662009	4112343		0
4477	262	4112343	1966-09-24	1966-09-24 00:00:00	1966-10-03	1966-10-03 00:00:00	32020		\N	17360	0	195662009	4112343		0
4608	270	40481087	2015-09-30	2015-09-30 00:00:00	2015-10-07	2015-10-07 00:00:00	32020		\N	18015	0	444814009	40481087		0
4773	280	40481087	1986-10-29	1986-10-29 00:00:00	1986-11-05	1986-11-05 00:00:00	32020		\N	18765	0	444814009	40481087		0
4921	289	40481087	2005-02-19	2005-02-19 00:00:00	2005-03-12	2005-03-12 00:00:00	32020		\N	19308	0	444814009	40481087		0
5102	299	192671	2000-10-07	2000-10-07 00:00:00	\N	\N	32020		\N	20029	0	K92.2	35208414		0
5259	310	4283893	1952-08-08	1952-08-08 00:00:00	1953-01-16	1953-01-16 00:00:00	32020		\N	20501	0	36971009	4283893		0
5453	321	40481087	1991-04-21	1991-04-21 00:00:00	1991-05-12	1991-05-12 00:00:00	32020		\N	21273	0	444814009	40481087		0
5626	332	260139	1969-02-14	1969-02-14 00:00:00	1969-02-21	1969-02-21 00:00:00	32020		\N	21936	0	10509002	260139		0
5764	338	260139	1974-06-13	1974-06-13 00:00:00	1974-06-20	1974-06-20 00:00:00	32020		\N	22602	0	10509002	260139		0
5932	349	4112343	1970-08-14	1970-08-14 00:00:00	1970-08-21	1970-08-21 00:00:00	32020		\N	23181	0	195662009	4112343		0
6087	358	260139	1976-02-16	1976-02-16 00:00:00	1976-03-01	1976-03-01 00:00:00	32020		\N	23794	0	10509002	260139		0
6248	366	40481087	1912-07-19	1912-07-19 00:00:00	1912-08-09	1912-08-09 00:00:00	32020		\N	24296	0	444814009	40481087		0
6412	377	40481087	2015-11-15	2015-11-15 00:00:00	2015-11-29	2015-11-29 00:00:00	32020		\N	25014	0	444814009	40481087		0
6639	392	40481087	1978-05-24	1978-05-24 00:00:00	1978-05-31	1978-05-31 00:00:00	32020		\N	25738	0	444814009	40481087		0
6752	399	40481087	1955-06-08	1955-06-08 00:00:00	1955-06-22	1955-06-22 00:00:00	32020		\N	26159	0	444814009	40481087		0
6912	406	260139	1966-02-06	1966-02-06 00:00:00	1966-02-20	1966-02-20 00:00:00	32020		\N	26829	0	10509002	260139		0
7091	418	40481087	1999-05-07	1999-05-07 00:00:00	1999-05-14	1999-05-14 00:00:00	32020		\N	27633	0	444814009	40481087		0
17776	1070	260139	1979-11-27	1979-11-27 00:00:00	1979-12-11	1979-12-11 00:00:00	32020		\N	70061	0	10509002	260139		0
7429	437	260139	2002-09-23	2002-09-23 00:00:00	2002-10-07	2002-10-07 00:00:00	32020		\N	28993	0	10509002	260139		0
7588	445	40481087	1966-09-11	1966-09-11 00:00:00	1966-09-18	1966-09-18 00:00:00	32020		\N	29590	0	444814009	40481087		0
7745	454	4283893	1999-02-14	1999-02-14 00:00:00	1999-07-18	1999-07-18 00:00:00	32020		\N	30269	0	36971009	4283893		0
7926	462	40481087	1989-02-01	1989-02-01 00:00:00	1989-02-15	1989-02-15 00:00:00	32020		\N	30867	0	444814009	40481087		0
8101	474	4294548	1977-10-24	1977-10-24 00:00:00	1978-02-13	1978-02-13 00:00:00	32020		\N	31645	0	75498004	4294548		0
8288	484	372328	1939-08-26	1939-08-26 00:00:00	1939-12-11	1939-12-11 00:00:00	32020		\N	32367	0	65363002	372328		0
8407	488	4134304	1969-08-13	1969-08-13 00:00:00	1969-09-12	1969-09-12 00:00:00	32020		\N	32698	0	263102004	4134304		0
8587	500	81893	1997-05-03	1997-05-03 00:00:00	\N	\N	32020		\N	33497	0	64766004	81893		0
8786	515	4112343	1955-10-07	1955-10-07 00:00:00	1955-10-15	1955-10-15 00:00:00	32020		\N	34348	0	195662009	4112343		0
19475	1169	40481087	1979-08-05	1979-08-05 00:00:00	1979-08-26	1979-08-26 00:00:00	32020		\N	77030	0	444814009	40481087		0
9087	534	80180	2014-10-29	2014-10-29 00:00:00	\N	\N	32020		\N	35604	0	396275006	80180		0
19771	1188	4142905	1983-09-17	1983-09-17 00:00:00	1983-11-16	1983-11-16 00:00:00	32020		\N	78276	0	33737001	4142905		0
9447	559	40481087	2005-02-21	2005-02-21 00:00:00	2005-03-14	2005-03-14 00:00:00	32020		\N	37069	0	444814009	40481087		0
9605	569	4112343	2017-12-12	2017-12-12 00:00:00	2017-12-24	2017-12-24 00:00:00	32020		\N	37588	0	195662009	4112343		0
9740	576	4109685	1982-06-22	1982-06-22 00:00:00	1982-07-06	1982-07-06 00:00:00	32020		\N	38064	0	284551006	4109685		0
9929	588	4112343	1995-03-20	1995-03-20 00:00:00	1995-04-01	1995-04-01 00:00:00	32020		\N	38933	0	195662009	4112343		0
20587	1236	4294548	1922-03-26	1922-03-26 00:00:00	1922-04-02	1922-04-02 00:00:00	32020		\N	81461	0	75498004	4294548		0
10252	606	78272	1987-06-09	1987-06-09 00:00:00	1987-07-14	1987-07-14 00:00:00	32020		\N	40215	0	70704007	78272		0
10408	613	260139	1951-07-25	1951-07-25 00:00:00	1951-08-01	1951-08-01 00:00:00	32020		\N	40717	0	10509002	260139		0
21085	1266	4294548	1993-04-20	1993-04-20 00:00:00	1993-07-20	1993-07-20 00:00:00	32020		\N	83488	0	75498004	4294548		0
97	3	40481087	1972-12-27	1972-12-27 00:00:00	1973-01-10	1973-01-10 00:00:00	32020		\N	291	0	444814009	40481087		0
303	16	40481087	1987-04-25	1987-04-25 00:00:00	1987-05-16	1987-05-16 00:00:00	32020		\N	1240	0	444814009	40481087		0
10967	648	4001336	1969-06-10	1969-06-10 00:00:00	1969-07-10	1969-07-10 00:00:00	32020		\N	42963	0	110030002	4001336		0
642	36	40481087	1959-01-28	1959-01-28 00:00:00	1959-02-18	1959-02-18 00:00:00	32020		\N	2483	0	444814009	40481087		0
782	42	40481087	2010-02-24	2010-02-24 00:00:00	2010-03-03	2010-03-03 00:00:00	32020		\N	3046	0	444814009	40481087		0
11502	679	40481087	1980-07-04	1980-07-04 00:00:00	1980-07-18	1980-07-18 00:00:00	32020		\N	44906	0	444814009	40481087		0
1130	66	4156265	1981-03-10	1981-03-10 00:00:00	1981-03-31	1981-03-31 00:00:00	32020		\N	4449	0	370247008	4156265		0
1280	74	4283893	2005-05-07	2005-05-07 00:00:00	2005-08-20	2005-08-20 00:00:00	32020		\N	5015	0	36971009	4283893		0
1436	84	4112343	1999-07-10	1999-07-10 00:00:00	1999-07-19	1999-07-19 00:00:00	32020		\N	5653	0	195662009	4112343		0
12119	718	40479422	1970-03-28	1970-03-28 00:00:00	1970-05-04	1970-05-04 00:00:00	32020		\N	47524	0	444448004	40479422		0
1779	101	260139	1962-04-19	1962-04-19 00:00:00	1962-04-26	1962-04-26 00:00:00	32020		\N	6835	0	10509002	260139		0
1971	115	4112343	1961-05-26	1961-05-26 00:00:00	1961-06-06	1961-06-06 00:00:00	32020		\N	7570	0	195662009	4112343		0
2128	123	40481087	1978-11-21	1978-11-21 00:00:00	1978-12-12	1978-12-12 00:00:00	32020		\N	8106	0	444814009	40481087		0
12803	756	260139	1981-04-01	1981-04-01 00:00:00	1981-04-08	1981-04-08 00:00:00	32020		\N	50131	0	10509002	260139		0
2454	144	40481087	1986-01-28	1986-01-28 00:00:00	1986-02-18	1986-02-18 00:00:00	32020		\N	9661	0	444814009	40481087		0
2628	154	4294548	1980-08-26	1980-08-26 00:00:00	1980-10-14	1980-10-14 00:00:00	32020		\N	10434	0	75498004	4294548		0
2774	160	4237458	2016-08-05	2016-08-05 00:00:00	2016-09-04	2016-09-04 00:00:00	32020		\N	10976	0	58150001	4237458		0
2953	171	4112343	1996-08-17	1996-08-17 00:00:00	1996-08-28	1996-08-28 00:00:00	32020		\N	11595	0	195662009	4112343		0
3106	183	260139	1976-02-18	1976-02-18 00:00:00	1976-02-25	1976-02-25 00:00:00	32020		\N	12349	0	10509002	260139		0
3251	189	4237458	1970-01-08	1970-01-08 00:00:00	1970-02-07	1970-02-07 00:00:00	32020		\N	12888	0	58150001	4237458		0
3433	196	4156265	1985-03-10	1985-03-10 00:00:00	1985-03-31	1985-03-31 00:00:00	32020		\N	13526	0	370247008	4156265		0
3290	190	378419	2010-01-26	2010-01-26 00:00:00	\N	\N	32020		\N	12931	0	26929004	378419		0
14113	834	40481087	2012-03-16	2012-03-16 00:00:00	2012-04-06	2012-04-06 00:00:00	32020		\N	55213	0	444814009	40481087		0
3781	217	81151	1993-09-30	1993-09-30 00:00:00	1993-10-28	1993-10-28 00:00:00	32020		\N	14640	0	44465007	81151		0
3946	227	4283893	1985-12-21	1985-12-21 00:00:00	1986-01-11	1986-01-11 00:00:00	32020		\N	15348	0	36971009	4283893		0
4118	239	40481087	1958-11-28	1958-11-28 00:00:00	1958-12-19	1958-12-19 00:00:00	32020		\N	16017	0	444814009	40481087		0
4271	246	30753	1999-05-10	1999-05-10 00:00:00	\N	\N	32020		\N	16565	0	16761005	30753		0
4478	262	80180	1999-12-13	1999-12-13 00:00:00	\N	\N	32020		\N	17358	0	396275006	80180		0
4609	270	81151	1985-06-17	1985-06-17 00:00:00	1985-07-08	1985-07-08 00:00:00	32020		\N	18024	0	44465007	81151		0
4774	280	4134304	2010-10-11	2010-10-11 00:00:00	2011-01-09	2011-01-09 00:00:00	32020		\N	18708	0	263102004	4134304		0
4922	289	4112343	1972-02-26	1972-02-26 00:00:00	1972-03-10	1972-03-10 00:00:00	32020		\N	19281	0	195662009	4112343		0
5103	299	260139	2017-06-06	2017-06-06 00:00:00	2017-06-20	2017-06-20 00:00:00	32020		\N	19994	0	10509002	260139		0
5260	310	4112343	1997-02-19	1997-02-19 00:00:00	1997-02-28	1997-02-28 00:00:00	32020		\N	20510	0	195662009	4112343		0
5454	321	4112343	1994-02-04	1994-02-04 00:00:00	1994-02-15	1994-02-15 00:00:00	32020		\N	21308	0	195662009	4112343		0
5627	332	260139	2005-10-28	2005-10-28 00:00:00	2005-11-04	2005-11-04 00:00:00	32020		\N	21958	0	10509002	260139		0
5765	338	28060	1979-03-05	1979-03-05 00:00:00	1979-03-13	1979-03-13 00:00:00	32020		\N	22566	0	43878008	28060		0
5933	349	260139	1994-01-21	1994-01-21 00:00:00	1994-02-04	1994-02-04 00:00:00	32020		\N	23207	0	10509002	260139		0
6088	358	40481087	1953-10-21	1953-10-21 00:00:00	1953-11-11	1953-11-11 00:00:00	32020		\N	23789	0	444814009	40481087		0
6249	366	40481087	1952-11-25	1952-11-25 00:00:00	1952-12-09	1952-12-09 00:00:00	32020		\N	24341	0	444814009	40481087		0
6413	377	40481087	2018-10-22	2018-10-22 00:00:00	2018-11-12	2018-11-12 00:00:00	32020		\N	25011	0	444814009	40481087		0
6640	392	40481087	1984-09-04	1984-09-04 00:00:00	1984-09-18	1984-09-18 00:00:00	32020		\N	25713	0	444814009	40481087		0
6753	399	28060	1979-09-17	1979-09-17 00:00:00	1979-09-27	1979-09-27 00:00:00	32020		\N	26253	0	43878008	28060		0
6913	406	4112343	2016-03-13	2016-03-13 00:00:00	2016-03-23	2016-03-23 00:00:00	32020		\N	26727	0	195662009	4112343		0
7092	418	4142905	2004-06-26	2004-06-26 00:00:00	2004-08-25	2004-08-25 00:00:00	32020		\N	27666	0	33737001	4142905		0
17777	1070	81151	1976-09-12	1976-09-12 00:00:00	1976-10-03	1976-10-03 00:00:00	32020		\N	70097	0	44465007	81151		0
7430	437	40481087	1959-11-10	1959-11-10 00:00:00	1959-11-17	1959-11-17 00:00:00	32020		\N	29009	0	444814009	40481087		0
7589	445	4283893	1916-10-23	1916-10-23 00:00:00	1916-11-20	1916-11-20 00:00:00	32020		\N	29645	0	36971009	4283893		0
7746	454	313217	2005-03-05	2005-03-05 00:00:00	\N	\N	32020		\N	30329	0	49436004	313217		0
7927	462	40481087	2001-01-10	2001-01-10 00:00:00	2001-01-24	2001-01-24 00:00:00	32020		\N	30883	0	444814009	40481087		0
8102	474	28060	1976-02-14	1976-02-14 00:00:00	1976-02-22	1976-02-22 00:00:00	32020		\N	31608	0	43878008	28060		0
8289	484	40481087	1984-10-21	1984-10-21 00:00:00	1984-11-04	1984-11-04 00:00:00	32020		\N	32379	0	444814009	40481087		0
8408	488	4278672	1977-02-02	1977-02-02 00:00:00	1977-04-03	1977-04-03 00:00:00	32020		\N	32699	0	65966004	4278672		0
8588	500	260139	1966-06-27	1966-06-27 00:00:00	1966-07-04	1966-07-04 00:00:00	32020		\N	33486	0	10509002	260139		0
8787	515	372328	1942-08-14	1942-08-14 00:00:00	1942-08-28	1942-08-28 00:00:00	32020		\N	34335	0	65363002	372328		0
19476	1169	4296205	1971-05-18	1971-05-18 00:00:00	1971-06-22	1971-06-22 00:00:00	32020		\N	76986	0	403191005	4296205		0
9088	534	4112343	1993-10-31	1993-10-31 00:00:00	1993-11-06	1993-11-06 00:00:00	32020		\N	35513	0	195662009	4112343		0
19772	1188	40481087	1995-12-01	1995-12-01 00:00:00	1995-12-08	1995-12-08 00:00:00	32020		\N	78283	0	444814009	40481087		0
9448	559	80180	2011-06-03	2011-06-03 00:00:00	\N	\N	32020		\N	37058	0	396275006	80180		0
9606	569	4112343	1923-05-15	1923-05-15 00:00:00	1923-05-26	1923-05-26 00:00:00	32020		\N	37664	0	195662009	4112343		0
9741	576	4084167	2000-10-31	2000-10-31 00:00:00	2000-10-31	2000-10-31 00:00:00	32020		\N	38088	0	241929008	4084167		0
9930	588	439777	1984-01-28	1984-01-28 00:00:00	\N	\N	32020		\N	38930	0	271737000	439777		0
20588	1236	40481087	1936-01-25	1936-01-25 00:00:00	1936-02-15	1936-02-15 00:00:00	32020		\N	81421	0	444814009	40481087		0
10253	606	378001	1976-01-08	1976-01-08 00:00:00	1976-02-07	1976-02-07 00:00:00	32020		\N	40214	0	62106007	378001		0
10409	613	40481087	1954-10-28	1954-10-28 00:00:00	1954-11-18	1954-11-18 00:00:00	32020		\N	40724	0	444814009	40481087		0
21086	1266	81151	1984-06-08	1984-06-08 00:00:00	1984-07-13	1984-07-13 00:00:00	32020		\N	83455	0	44465007	81151		0
98	3	260139	1948-06-14	1948-06-14 00:00:00	1948-06-21	1948-06-21 00:00:00	32020		\N	359	0	10509002	260139		0
304	16	4112343	2015-02-13	2015-02-13 00:00:00	2015-02-26	2015-02-26 00:00:00	32020		\N	1188	0	195662009	4112343		0
10968	648	4132546	1969-06-10	1969-06-10 00:00:00	\N	\N	32020		\N	42963	0	275272006	4166590		0
643	36	4283893	1971-04-07	1971-04-07 00:00:00	1971-05-19	1971-05-19 00:00:00	32020		\N	2514	0	36971009	4283893		0
783	42	4112343	1939-04-12	1939-04-12 00:00:00	1939-04-25	1939-04-25 00:00:00	32020		\N	3063	0	195662009	4112343		0
11503	679	40481087	2003-12-10	2003-12-10 00:00:00	2003-12-31	2003-12-31 00:00:00	32020		\N	44919	0	444814009	40481087		0
1131	66	40481087	1988-12-17	1988-12-17 00:00:00	1988-12-24	1988-12-24 00:00:00	32020		\N	4477	0	444814009	40481087		0
1281	74	4027663	2005-12-27	2005-12-27 00:00:00	\N	\N	32020		\N	5015	0	13200003	4027663		0
1437	84	260139	1995-08-01	1995-08-01 00:00:00	1995-08-15	1995-08-15 00:00:00	32020		\N	5671	0	10509002	260139		0
12120	718	378001	2014-02-01	2014-02-01 00:00:00	2014-03-03	2014-03-03 00:00:00	32020		\N	47528	0	62106007	378001		0
1780	101	80180	1965-05-28	1965-05-28 00:00:00	\N	\N	32020		\N	6864	0	396275006	80180		0
1972	115	4112343	2015-01-29	2015-01-29 00:00:00	2015-02-09	2015-02-09 00:00:00	32020		\N	7577	0	195662009	4112343		0
2129	123	260139	2006-08-17	2006-08-17 00:00:00	2006-08-24	2006-08-24 00:00:00	32020		\N	8144	0	10509002	260139		0
12804	756	4112343	2015-08-06	2015-08-06 00:00:00	2015-08-16	2015-08-16 00:00:00	32020		\N	50121	0	195662009	4112343		0
2455	144	372328	1977-02-07	1977-02-07 00:00:00	1977-05-27	1977-05-27 00:00:00	32020		\N	9634	0	65363002	372328		0
2629	154	40481087	1984-10-30	1984-10-30 00:00:00	1984-11-20	1984-11-20 00:00:00	32020		\N	10452	0	444814009	40481087		0
2775	160	40481087	1984-02-16	1984-02-16 00:00:00	1984-02-23	1984-02-23 00:00:00	32020		\N	10938	0	444814009	40481087		0
2954	171	4112343	1972-03-22	1972-03-22 00:00:00	1972-04-03	1972-04-03 00:00:00	32020		\N	11582	0	195662009	4112343		0
3107	183	40481087	2019-03-16	2019-03-16 00:00:00	2019-04-06	2019-04-06 00:00:00	32020		\N	12339	0	444814009	40481087		0
3252	189	4112343	1963-08-01	1963-08-01 00:00:00	1963-08-11	1963-08-11 00:00:00	32020		\N	12878	0	195662009	4112343		0
3434	196	372328	1956-04-08	1956-04-08 00:00:00	1956-09-22	1956-09-22 00:00:00	32020		\N	13521	0	65363002	372328		0
14114	834	4112343	1971-10-30	1971-10-30 00:00:00	1971-11-12	1971-11-12 00:00:00	32020		\N	55208	0	195662009	4112343		0
3782	217	28060	1979-12-27	1979-12-27 00:00:00	1980-01-04	1980-01-04 00:00:00	32020		\N	14636	0	43878008	28060		0
3947	227	28060	1999-08-07	1999-08-07 00:00:00	1999-08-14	1999-08-14 00:00:00	32020		\N	15316	0	43878008	28060		0
4119	239	4237458	1956-12-31	1956-12-31 00:00:00	1957-03-31	1957-03-31 00:00:00	32020		\N	16049	0	58150001	4237458		0
4272	246	261325	1998-09-03	1998-09-03 00:00:00	\N	\N	32020		\N	16565	0	87433001	261325		0
4479	262	4266809	1999-12-13	1999-12-13 00:00:00	\N	\N	32020		\N	17358	0	397881000	4266809		0
4610	270	40481087	2000-08-21	2000-08-21 00:00:00	2000-08-28	2000-08-28 00:00:00	32020		\N	17962	0	444814009	40481087		0
4775	280	4294548	1995-11-27	1995-11-27 00:00:00	1996-01-01	1996-01-01 00:00:00	32020		\N	18689	0	75498004	4294548		0
4923	289	40481087	1961-12-06	1961-12-06 00:00:00	1961-12-13	1961-12-13 00:00:00	32020		\N	19279	0	444814009	40481087		0
5104	299	40481087	2006-01-24	2006-01-24 00:00:00	2006-02-14	2006-02-14 00:00:00	32020		\N	20011	0	444814009	40481087		0
5261	310	257012	1952-10-31	1952-10-31 00:00:00	\N	\N	32020		\N	20520	0	40055000	257012		0
5455	321	4294548	1998-10-26	1998-10-26 00:00:00	1998-11-09	1998-11-09 00:00:00	32020		\N	21309	0	75498004	4294548		0
5628	332	4112343	1991-12-20	1991-12-20 00:00:00	1991-12-29	1991-12-29 00:00:00	32020		\N	22040	0	195662009	4112343		0
5766	338	260139	2003-10-21	2003-10-21 00:00:00	2003-11-04	2003-11-04 00:00:00	32020		\N	22541	0	10509002	260139		0
5934	349	40481087	2016-04-04	2016-04-04 00:00:00	2016-04-11	2016-04-11 00:00:00	32020		\N	23203	0	444814009	40481087		0
6089	358	28060	1982-02-27	1982-02-27 00:00:00	1982-03-10	1982-03-10 00:00:00	32020		\N	23828	0	43878008	28060		0
6250	366	4112343	2009-08-23	2009-08-23 00:00:00	2009-09-03	2009-09-03 00:00:00	32020		\N	24343	0	195662009	4112343		0
6414	377	80180	2003-02-13	2003-02-13 00:00:00	\N	\N	32020		\N	25013	0	396275006	80180		0
17099	1022	260139	1970-03-31	1970-03-31 00:00:00	1970-04-07	1970-04-07 00:00:00	32020		\N	67269	0	10509002	260139		0
6754	399	40481087	2001-11-11	2001-11-11 00:00:00	2001-11-25	2001-11-25 00:00:00	32020		\N	26126	0	444814009	40481087		0
6914	406	4112343	1959-12-25	1959-12-25 00:00:00	1960-01-05	1960-01-05 00:00:00	32020		\N	26807	0	195662009	4112343		0
7093	418	4283893	1971-07-14	1971-07-14 00:00:00	1971-12-22	1971-12-22 00:00:00	32020		\N	27682	0	36971009	4283893		0
17778	1070	260139	1987-01-02	1987-01-02 00:00:00	1987-01-16	1987-01-16 00:00:00	32020		\N	70062	0	10509002	260139		0
7431	437	4112343	2005-01-28	2005-01-28 00:00:00	2005-02-10	2005-02-10 00:00:00	32020		\N	28981	0	195662009	4112343		0
7590	445	4112343	1929-08-21	1929-08-21 00:00:00	1929-09-01	1929-09-01 00:00:00	32020		\N	29647	0	195662009	4112343		0
7747	454	40481087	1987-04-20	1987-04-20 00:00:00	1987-05-11	1987-05-11 00:00:00	32020		\N	30323	0	444814009	40481087		0
7928	462	40481087	2008-11-21	2008-11-21 00:00:00	2008-11-28	2008-11-28 00:00:00	32020		\N	30885	0	444814009	40481087		0
8103	474	4112343	2015-05-05	2015-05-05 00:00:00	2015-05-14	2015-05-14 00:00:00	32020		\N	31628	0	195662009	4112343		0
8290	484	372328	1942-11-25	1942-11-25 00:00:00	1942-12-09	1942-12-09 00:00:00	32020		\N	32320	0	65363002	372328		0
8409	488	4112343	1995-03-29	1995-03-29 00:00:00	1995-04-09	1995-04-09 00:00:00	32020		\N	32620	0	195662009	4112343		0
8589	500	40481087	1991-11-26	1991-11-26 00:00:00	1991-12-10	1991-12-10 00:00:00	32020		\N	33522	0	444814009	40481087		0
8788	515	4283893	1958-06-26	1958-06-26 00:00:00	1958-09-11	1958-09-11 00:00:00	32020		\N	34349	0	36971009	4283893		0
19477	1169	40481087	1975-05-05	1975-05-05 00:00:00	1975-05-19	1975-05-19 00:00:00	32020		\N	77003	0	444814009	40481087		0
9089	534	40481087	1980-10-03	1980-10-03 00:00:00	1980-10-10	1980-10-10 00:00:00	32020		\N	35527	0	444814009	40481087		0
19773	1188	80180	2013-03-13	2013-03-13 00:00:00	\N	\N	32020		\N	78294	0	396275006	80180		0
9449	559	4112343	2011-02-05	2011-02-05 00:00:00	2011-02-14	2011-02-14 00:00:00	32020		\N	37058	0	195662009	4112343		0
9607	569	40481087	1971-10-18	1971-10-18 00:00:00	1971-11-08	1971-11-08 00:00:00	32020		\N	37638	0	444814009	40481087		0
9752	578	40481087	2011-12-20	2011-12-20 00:00:00	2011-12-27	2011-12-27 00:00:00	32020		\N	38220	0	444814009	40481087		0
9931	588	260139	2010-05-07	2010-05-07 00:00:00	2010-05-14	2010-05-14 00:00:00	32020		\N	38935	0	10509002	260139		0
20589	1236	40481087	1984-10-20	1984-10-20 00:00:00	1984-11-03	1984-11-03 00:00:00	32020		\N	81470	0	444814009	40481087		0
10254	606	40481087	1985-08-23	1985-08-23 00:00:00	1985-08-30	1985-08-30 00:00:00	32020		\N	40251	0	444814009	40481087		0
10410	613	4230399	2007-03-07	2007-03-07 00:00:00	2007-05-06	2007-05-06 00:00:00	32020		\N	40696	0	359817006	4230399		0
21087	1266	40481087	1967-08-14	1967-08-14 00:00:00	1967-09-04	1967-09-04 00:00:00	32020		\N	83464	0	444814009	40481087		0
99	3	4218389	1987-11-28	1987-11-28 00:00:00	1987-12-26	1987-12-26 00:00:00	32020		\N	313	0	39848009	4218389		0
305	16	81151	2014-06-27	2014-06-27 00:00:00	2014-07-25	2014-07-25 00:00:00	32020		\N	1166	0	44465007	81151		0
10969	648	260139	1966-07-29	1966-07-29 00:00:00	1966-08-12	1966-08-12 00:00:00	32020		\N	42950	0	10509002	260139		0
644	36	4116491	2014-10-07	2014-10-07 00:00:00	2014-11-24	2014-11-24 00:00:00	32020		\N	2563	0	301011002	4116491		0
784	42	260139	1980-06-21	1980-06-21 00:00:00	1980-06-28	1980-06-28 00:00:00	32020		\N	2996	0	10509002	260139		0
11504	679	4112343	1981-12-28	1981-12-28 00:00:00	1982-01-09	1982-01-09 00:00:00	32020		\N	44955	0	195662009	4112343		0
1132	66	40481087	1978-08-17	1978-08-17 00:00:00	1978-09-07	1978-09-07 00:00:00	32020		\N	4457	0	444814009	40481087		0
1282	74	40481087	2016-12-18	2016-12-18 00:00:00	2017-01-01	2017-01-01 00:00:00	32020		\N	5000	0	444814009	40481087		0
1438	84	40481087	1993-10-08	1993-10-08 00:00:00	1993-10-22	1993-10-22 00:00:00	32020		\N	5670	0	444814009	40481087		0
12121	718	260139	2000-04-22	2000-04-22 00:00:00	2000-05-06	2000-05-06 00:00:00	32020		\N	47460	0	10509002	260139		0
1781	101	40481087	1938-04-15	1938-04-15 00:00:00	1938-04-22	1938-04-22 00:00:00	32020		\N	6853	0	444814009	40481087		0
1973	115	40481087	1973-08-02	1973-08-02 00:00:00	1973-08-09	1973-08-09 00:00:00	32020		\N	7614	0	444814009	40481087		0
2130	123	40481087	1970-07-12	1970-07-12 00:00:00	1970-07-26	1970-07-26 00:00:00	32020		\N	8152	0	444814009	40481087		0
12805	756	4296204	1996-08-26	1996-08-26 00:00:00	1996-09-23	1996-09-23 00:00:00	32020		\N	50105	0	403190006	4296204		0
2456	144	195588	2010-12-11	2010-12-11 00:00:00	2011-01-11	2011-01-11 00:00:00	32020		\N	9633	0	38822007	195588		0
2630	154	40481087	2000-10-13	2000-10-13 00:00:00	2000-11-03	2000-11-03 00:00:00	32020		\N	10455	0	444814009	40481087		0
2776	160	4027663	1995-07-19	1995-07-19 00:00:00	\N	\N	32020		\N	11020	0	13200003	4027663		0
2955	171	4109685	1994-05-15	1994-05-15 00:00:00	1994-06-05	1994-06-05 00:00:00	32020		\N	11610	0	284551006	4109685		0
3108	183	440086	1982-10-22	1982-10-22 00:00:00	1984-03-16	1984-03-16 00:00:00	32020		\N	12371	0	192127007	440086		0
3253	189	372328	1959-04-06	1959-04-06 00:00:00	1959-07-19	1959-07-19 00:00:00	32020		\N	12840	0	65363002	372328		0
3435	196	378001	1986-01-25	1986-01-25 00:00:00	1986-03-26	1986-03-26 00:00:00	32020		\N	13527	0	62106007	378001		0
14115	834	372328	1957-06-12	1957-06-12 00:00:00	1957-08-12	1957-08-12 00:00:00	32020		\N	55184	0	65363002	372328		0
3783	217	40481087	1982-05-28	1982-05-28 00:00:00	1982-06-18	1982-06-18 00:00:00	32020		\N	14647	0	444814009	40481087		0
3948	227	4112343	2006-12-14	2006-12-14 00:00:00	2006-12-25	2006-12-25 00:00:00	32020		\N	15317	0	195662009	4112343		0
4120	239	4113008	1966-08-25	1966-08-25 00:00:00	1966-09-15	1966-09-15 00:00:00	32020		\N	16051	0	284549007	4113008		0
4273	246	80180	2000-06-03	2000-06-03 00:00:00	\N	\N	32020		\N	16565	0	396275006	80180		0
4480	263	260139	1988-09-04	1988-09-04 00:00:00	1988-09-11	1988-09-11 00:00:00	32020		\N	17442	0	10509002	260139		0
4611	270	321042	2012-06-05	2012-06-05 00:00:00	\N	\N	32020		\N	18027	0	410429000	321042		0
4776	280	40481087	1947-03-20	1947-03-20 00:00:00	1947-04-10	1947-04-10 00:00:00	32020		\N	18715	0	444814009	40481087		0
4924	289	260139	2014-08-19	2014-08-19 00:00:00	2014-08-26	2014-08-26 00:00:00	32020		\N	19310	0	10509002	260139		0
5105	299	80180	2000-07-22	2000-07-22 00:00:00	\N	\N	32020		\N	19989	0	396275006	80180		0
5262	310	40481087	1983-01-04	1983-01-04 00:00:00	1983-01-25	1983-01-25 00:00:00	32020		\N	20524	0	444814009	40481087		0
5456	321	440086	1975-11-09	1975-11-09 00:00:00	1979-11-18	1979-11-18 00:00:00	32020		\N	21305	0	192127007	440086		0
5629	332	4112343	2007-05-26	2007-05-26 00:00:00	2007-06-04	2007-06-04 00:00:00	32020		\N	21959	0	195662009	4112343		0
5767	338	40481087	1967-08-24	1967-08-24 00:00:00	1967-08-31	1967-08-31 00:00:00	32020		\N	22592	0	444814009	40481087		0
5935	349	40481087	2012-09-11	2012-09-11 00:00:00	2012-10-02	2012-10-02 00:00:00	32020		\N	23201	0	444814009	40481087		0
6090	358	4112343	1982-10-08	1982-10-08 00:00:00	1982-10-15	1982-10-15 00:00:00	32020		\N	23795	0	195662009	4112343		0
6251	366	40481087	1929-07-13	1929-07-13 00:00:00	1929-07-20	1929-07-20 00:00:00	32020		\N	24279	0	444814009	40481087		0
6415	377	40481087	2000-12-20	2000-12-20 00:00:00	2001-01-10	2001-01-10 00:00:00	32020		\N	25013	0	444814009	40481087		0
17100	1022	4112343	1968-01-25	1968-01-25 00:00:00	1968-02-06	1968-02-06 00:00:00	32020		\N	67222	0	195662009	4112343		0
6755	399	260139	2016-12-01	2016-12-01 00:00:00	2016-12-15	2016-12-15 00:00:00	32020		\N	26156	0	10509002	260139		0
6927	408	4084167	1962-02-02	1962-02-02 00:00:00	1962-02-03	1962-02-03 00:00:00	32020		\N	26972	0	241929008	4084167		0
7094	418	80180	1996-02-01	1996-02-01 00:00:00	\N	\N	32020		\N	27600	0	396275006	80180		0
17789	1072	40481087	1993-10-09	1993-10-09 00:00:00	1993-10-30	1993-10-30 00:00:00	32020		\N	70277	0	444814009	40481087		0
7432	437	260139	1950-01-23	1950-01-23 00:00:00	1950-02-06	1950-02-06 00:00:00	32020		\N	28965	0	10509002	260139		0
7591	445	4112343	1956-06-21	1956-06-21 00:00:00	1956-06-28	1956-06-28 00:00:00	32020		\N	29603	0	195662009	4112343		0
7748	454	81893	1969-07-16	1969-07-16 00:00:00	\N	\N	32020		\N	30373	0	64766004	81893		0
7929	462	80180	2014-08-28	2014-08-28 00:00:00	\N	\N	32020		\N	30908	0	396275006	80180		0
8104	474	4112343	1998-04-12	1998-04-12 00:00:00	1998-04-21	1998-04-21 00:00:00	32020		\N	31653	0	195662009	4112343		0
8291	484	4283893	1962-11-28	1962-11-28 00:00:00	1962-12-26	1962-12-26 00:00:00	32020		\N	32376	0	36971009	4283893		0
8410	488	80180	1993-12-10	1993-12-10 00:00:00	\N	\N	32020		\N	32645	0	396275006	80180		0
8590	500	40481087	1983-12-19	1983-12-19 00:00:00	1984-01-02	1984-01-02 00:00:00	32020		\N	33539	0	444814009	40481087		0
8789	515	4266809	1981-03-27	1981-03-27 00:00:00	\N	\N	32020		\N	34359	0	397881000	4266809		0
19478	1169	81151	1961-10-16	1961-10-16 00:00:00	1961-11-06	1961-11-06 00:00:00	32020		\N	76985	0	44465007	81151		0
9090	534	40481087	1999-09-16	1999-09-16 00:00:00	1999-09-30	1999-09-30 00:00:00	32020		\N	35506	0	444814009	40481087		0
19774	1188	28060	1987-09-29	1987-09-29 00:00:00	1987-10-06	1987-10-06 00:00:00	32020		\N	78259	0	43878008	28060		0
9450	559	28060	2005-05-11	2005-05-11 00:00:00	2005-05-18	2005-05-18 00:00:00	32020		\N	37111	0	43878008	28060		0
9608	569	4296205	2009-01-29	2009-01-29 00:00:00	2009-02-12	2009-02-12 00:00:00	32020		\N	37724	0	403191005	4296205		0
9753	578	4283893	2018-04-19	2018-04-19 00:00:00	2018-05-17	2018-05-17 00:00:00	32020		\N	38200	0	36971009	4283893		0
9932	588	260139	2016-03-02	2016-03-02 00:00:00	2016-03-16	2016-03-16 00:00:00	32020		\N	38918	0	10509002	260139		0
20590	1236	4112343	1966-11-06	1966-11-06 00:00:00	1966-11-15	1966-11-15 00:00:00	32020		\N	81422	0	195662009	4112343		0
10255	606	372328	1976-06-18	1976-06-18 00:00:00	1976-07-21	1976-07-21 00:00:00	32020		\N	40218	0	65363002	372328		0
10411	613	40481087	1945-10-30	1945-10-30 00:00:00	1945-11-13	1945-11-13 00:00:00	32020		\N	40732	0	444814009	40481087		0
21088	1266	260139	1974-09-09	1974-09-09 00:00:00	1974-09-23	1974-09-23 00:00:00	32020		\N	83480	0	10509002	260139		0
101	3	40481087	1956-12-15	1956-12-15 00:00:00	1956-12-29	1956-12-29 00:00:00	32020		\N	262	0	444814009	40481087		0
306	16	40481087	1990-04-06	1990-04-06 00:00:00	1990-04-20	1990-04-20 00:00:00	32020		\N	1280	0	444814009	40481087		0
10970	648	4278672	2000-02-03	2000-02-03 00:00:00	2000-03-04	2000-03-04 00:00:00	32020		\N	42965	0	65966004	4278672		0
645	36	4156265	1964-10-19	1964-10-19 00:00:00	1964-11-02	1964-11-02 00:00:00	32020		\N	2613	0	370247008	4156265		0
785	42	4059173	1970-06-04	1970-06-04 00:00:00	1970-07-04	1970-07-04 00:00:00	32020		\N	3106	0	16114001	4059173		0
11505	679	40481087	1983-03-12	1983-03-12 00:00:00	1983-04-02	1983-04-02 00:00:00	32020		\N	44917	0	444814009	40481087		0
1133	66	4112343	1967-09-10	1967-09-10 00:00:00	1967-09-19	1967-09-19 00:00:00	32020		\N	4456	0	195662009	4112343		0
1283	74	4112343	1978-03-07	1978-03-07 00:00:00	1978-03-18	1978-03-18 00:00:00	32020		\N	5008	0	195662009	4112343		0
1439	84	4112343	1974-06-28	1974-06-28 00:00:00	1974-07-10	1974-07-10 00:00:00	32020		\N	5649	0	195662009	4112343		0
12122	718	4218389	2007-06-10	2007-06-10 00:00:00	2007-07-08	2007-07-08 00:00:00	32020		\N	47527	0	39848009	4218389		0
1782	101	260139	1984-09-07	1984-09-07 00:00:00	1984-09-14	1984-09-14 00:00:00	32020		\N	6837	0	10509002	260139		0
1974	116	4112343	1934-07-25	1934-07-25 00:00:00	1934-08-07	1934-08-07 00:00:00	32020		\N	7712	0	195662009	4112343		0
2131	123	260139	1952-02-03	1952-02-03 00:00:00	1952-02-10	1952-02-10 00:00:00	32020		\N	8148	0	10509002	260139		0
12806	756	4109685	1992-10-25	1992-10-25 00:00:00	1992-11-08	1992-11-08 00:00:00	32020		\N	50103	0	284551006	4109685		0
2457	144	80180	2011-12-01	2011-12-01 00:00:00	\N	\N	32020		\N	9633	0	396275006	80180		0
2631	154	4027663	2001-11-14	2001-11-14 00:00:00	\N	\N	32020		\N	10455	0	13200003	4027663		0
2777	160	260139	1980-01-14	1980-01-14 00:00:00	1980-01-28	1980-01-28 00:00:00	32020		\N	10945	0	10509002	260139		0
2956	171	4112343	2005-06-13	2005-06-13 00:00:00	2005-06-20	2005-06-20 00:00:00	32020		\N	11618	0	195662009	4112343		0
3109	183	28060	1996-11-26	1996-11-26 00:00:00	1996-12-07	1996-12-07 00:00:00	32020		\N	12338	0	43878008	28060		0
3254	189	378001	2003-08-25	2003-08-25 00:00:00	2003-10-24	2003-10-24 00:00:00	32020		\N	12891	0	62106007	378001		0
3436	196	40481087	1977-04-13	1977-04-13 00:00:00	1977-04-27	1977-04-27 00:00:00	32020		\N	13487	0	444814009	40481087		0
14116	834	260139	1989-11-09	1989-11-09 00:00:00	1989-11-23	1989-11-23 00:00:00	32020		\N	55176	0	10509002	260139		0
3784	217	372328	1979-08-15	1979-08-15 00:00:00	1980-03-18	1980-03-18 00:00:00	32020		\N	14686	0	65363002	372328		0
3949	227	372328	1974-04-04	1974-04-04 00:00:00	1974-08-23	1974-08-23 00:00:00	32020		\N	15320	0	65363002	372328		0
4121	239	317576	2012-01-12	2012-01-12 00:00:00	\N	\N	32020		\N	16025	0	53741008	317576		0
4274	246	4285898	1999-07-09	1999-07-09 00:00:00	\N	\N	32020		\N	16565	0	68496003	4285898		0
4481	263	4112343	1997-08-01	1997-08-01 00:00:00	1997-08-12	1997-08-12 00:00:00	32020		\N	17468	0	195662009	4112343		0
4613	270	4112343	1968-07-15	1968-07-15 00:00:00	1968-07-22	1968-07-22 00:00:00	32020		\N	18013	0	195662009	4112343		0
4777	280	40481087	1960-12-06	1960-12-06 00:00:00	1960-12-27	1960-12-27 00:00:00	32020		\N	18673	0	444814009	40481087		0
4925	289	78272	2000-02-09	2000-02-09 00:00:00	2000-03-08	2000-03-08 00:00:00	32020		\N	19330	0	70704007	78272		0
5106	299	28060	1967-04-09	1967-04-09 00:00:00	1967-04-17	1967-04-17 00:00:00	32020		\N	20023	0	43878008	28060		0
5263	310	4266809	1984-02-25	1984-02-25 00:00:00	\N	\N	32020		\N	20524	0	397881000	4266809		0
5457	321	81151	1996-06-30	1996-06-30 00:00:00	1996-07-21	1996-07-21 00:00:00	32020		\N	21322	0	44465007	81151		0
5630	332	4294548	1990-04-08	1990-04-08 00:00:00	1990-04-29	1990-04-29 00:00:00	32020		\N	22056	0	75498004	4294548		0
5768	338	260139	2008-11-01	2008-11-01 00:00:00	2008-11-15	2008-11-15 00:00:00	32020		\N	22543	0	10509002	260139		0
5936	349	40481087	1990-10-06	1990-10-06 00:00:00	1990-10-20	1990-10-20 00:00:00	32020		\N	23199	0	444814009	40481087		0
6091	358	4112343	1955-07-17	1955-07-17 00:00:00	1955-07-25	1955-07-25 00:00:00	32020		\N	23778	0	195662009	4112343		0
6252	366	40481087	2003-07-06	2003-07-06 00:00:00	2003-07-13	2003-07-13 00:00:00	32020		\N	24309	0	444814009	40481087		0
6416	377	4112343	1975-05-11	1975-05-11 00:00:00	1975-05-22	1975-05-22 00:00:00	32020		\N	25009	0	195662009	4112343		0
17101	1022	4112343	1985-02-23	1985-02-23 00:00:00	1985-03-07	1985-03-07 00:00:00	32020		\N	67270	0	195662009	4112343		0
6756	399	4113008	1972-03-09	1972-03-09 00:00:00	1972-03-30	1972-03-30 00:00:00	32020		\N	26236	0	284549007	4113008		0
6928	408	260139	2011-09-27	2011-09-27 00:00:00	2011-10-04	2011-10-04 00:00:00	32020		\N	26993	0	10509002	260139		0
7095	418	28060	1996-01-06	1996-01-06 00:00:00	1996-01-17	1996-01-17 00:00:00	32020		\N	27600	0	43878008	28060		0
17790	1072	260139	1996-12-03	1996-12-03 00:00:00	1996-12-17	1996-12-17 00:00:00	32020		\N	70261	0	10509002	260139		0
7433	437	4294548	1995-01-10	1995-01-10 00:00:00	1995-02-21	1995-02-21 00:00:00	32020		\N	29030	0	75498004	4294548		0
7592	445	4027663	1943-09-14	1943-09-14 00:00:00	\N	\N	32020		\N	29580	0	13200003	4027663		0
7749	454	40481087	1972-06-24	1972-06-24 00:00:00	1972-07-01	1972-07-01 00:00:00	32020		\N	30267	0	444814009	40481087		0
7930	462	4112343	2013-12-30	2013-12-30 00:00:00	2014-01-07	2014-01-07 00:00:00	32020		\N	30908	0	195662009	4112343		0
8105	474	372328	1975-03-24	1975-03-24 00:00:00	1975-11-30	1975-11-30 00:00:00	32020		\N	31655	0	65363002	372328		0
8292	484	40481087	1957-12-03	1957-12-03 00:00:00	1957-12-17	1957-12-17 00:00:00	32020		\N	32346	0	444814009	40481087		0
8411	488	28060	1958-10-24	1958-10-24 00:00:00	1958-11-05	1958-11-05 00:00:00	32020		\N	32671	0	43878008	28060		0
8591	500	4112343	1977-01-13	1977-01-13 00:00:00	1977-01-26	1977-01-26 00:00:00	32020		\N	33520	0	195662009	4112343		0
8790	515	80180	1981-03-27	1981-03-27 00:00:00	\N	\N	32020		\N	34359	0	396275006	80180		0
19479	1169	40481087	2015-06-30	2015-06-30 00:00:00	2015-07-07	2015-07-07 00:00:00	32020		\N	77006	0	444814009	40481087		0
9091	534	257012	1997-12-20	1997-12-20 00:00:00	\N	\N	32020		\N	35568	0	40055000	257012		0
19775	1188	4296204	2015-12-28	2015-12-28 00:00:00	2016-01-18	2016-01-18 00:00:00	32020		\N	78303	0	403190006	4296204		0
9451	559	260139	1973-05-12	1973-05-12 00:00:00	1973-05-19	1973-05-19 00:00:00	32020		\N	37073	0	10509002	260139		0
9609	569	4283893	1994-03-24	1994-03-24 00:00:00	1994-04-21	1994-04-21 00:00:00	32020		\N	37640	0	36971009	4283893		0
9754	578	28060	1979-05-31	1979-05-31 00:00:00	1979-06-08	1979-06-08 00:00:00	32020		\N	38278	0	43878008	28060		0
9933	588	372328	1981-02-27	1981-02-27 00:00:00	1981-05-06	1981-05-06 00:00:00	32020		\N	38923	0	65363002	372328		0
20591	1236	4112343	1938-08-26	1938-08-26 00:00:00	1938-09-02	1938-09-02 00:00:00	32020		\N	81444	0	195662009	4112343		0
10256	606	40481087	2008-05-08	2008-05-08 00:00:00	2008-05-29	2008-05-29 00:00:00	32020		\N	40244	0	444814009	40481087		0
10412	614	4218389	1971-08-20	1971-08-20 00:00:00	1971-09-10	1971-09-10 00:00:00	32020		\N	40848	0	39848009	4218389		0
21089	1266	260139	2000-06-26	2000-06-26 00:00:00	2000-07-03	2000-07-03 00:00:00	32020		\N	83470	0	10509002	260139		0
102	3	40481087	1985-03-22	1985-03-22 00:00:00	1985-03-29	1985-03-29 00:00:00	32020		\N	319	0	444814009	40481087		0
307	16	40481087	2009-11-05	2009-11-05 00:00:00	2009-11-12	2009-11-12 00:00:00	32020		\N	1204	0	444814009	40481087		0
10971	648	4112343	1955-11-10	1955-11-10 00:00:00	1955-11-18	1955-11-18 00:00:00	32020		\N	42949	0	195662009	4112343		0
646	36	40481087	1982-01-11	1982-01-11 00:00:00	1982-01-18	1982-01-18 00:00:00	32020		\N	2522	0	444814009	40481087		0
787	42	260139	1937-09-07	1937-09-07 00:00:00	1937-09-14	1937-09-14 00:00:00	32020		\N	3062	0	10509002	260139		0
11506	679	81893	2007-03-25	2007-03-25 00:00:00	\N	\N	32020		\N	44935	0	64766004	81893		0
1134	66	40481087	1978-11-11	1978-11-11 00:00:00	1978-11-18	1978-11-18 00:00:00	32020		\N	4476	0	444814009	40481087		0
1284	74	375671	1987-04-16	1987-04-16 00:00:00	1987-05-16	1987-05-16 00:00:00	32020		\N	4980	0	62564004	375671		0
1440	84	260139	1976-07-02	1976-07-02 00:00:00	1976-07-16	1976-07-16 00:00:00	32020		\N	5669	0	10509002	260139		0
12123	718	40481087	1991-04-20	1991-04-20 00:00:00	1991-05-11	1991-05-11 00:00:00	32020		\N	47496	0	444814009	40481087		0
1783	101	40481087	1968-08-09	1968-08-09 00:00:00	1968-08-30	1968-08-30 00:00:00	32020		\N	6935	0	444814009	40481087		0
1975	116	40481087	1956-08-19	1956-08-19 00:00:00	1956-09-09	1956-09-09 00:00:00	32020		\N	7675	0	444814009	40481087		0
2132	123	40481087	1951-08-14	1951-08-14 00:00:00	1951-09-04	1951-09-04 00:00:00	32020		\N	8147	0	444814009	40481087		0
12807	756	260139	1973-08-23	1973-08-23 00:00:00	1973-08-30	1973-08-30 00:00:00	32020		\N	50118	0	10509002	260139		0
2458	144	4112343	2000-09-23	2000-09-23 00:00:00	2000-10-06	2000-10-06 00:00:00	32020		\N	9622	0	195662009	4112343		0
2632	154	80180	2012-03-06	2012-03-06 00:00:00	\N	\N	32020		\N	10429	0	396275006	80180		0
2778	160	260139	1990-01-13	1990-01-13 00:00:00	1990-01-27	1990-01-27 00:00:00	32020		\N	10947	0	10509002	260139		0
2957	171	260139	2001-01-03	2001-01-03 00:00:00	2001-01-17	2001-01-17 00:00:00	32020		\N	11621	0	10509002	260139		0
3110	183	4112343	1978-05-23	1978-05-23 00:00:00	1978-06-01	1978-06-01 00:00:00	32020		\N	12370	0	195662009	4112343		0
3255	189	4112343	2014-03-07	2014-03-07 00:00:00	2014-03-14	2014-03-14 00:00:00	32020		\N	12898	0	195662009	4112343		0
3437	196	4283893	1958-01-03	1958-01-03 00:00:00	1958-03-28	1958-03-28 00:00:00	32020		\N	13485	0	36971009	4283893		0
14117	834	40481087	1980-02-03	1980-02-03 00:00:00	1980-02-17	1980-02-17 00:00:00	32020		\N	55175	0	444814009	40481087		0
3785	217	4112343	1980-08-04	1980-08-04 00:00:00	1980-08-16	1980-08-16 00:00:00	32020		\N	14646	0	195662009	4112343		0
3950	227	4112343	2010-08-23	2010-08-23 00:00:00	2010-09-01	2010-09-01 00:00:00	32020		\N	15329	0	195662009	4112343		0
4122	239	260139	1984-10-23	1984-10-23 00:00:00	1984-10-30	1984-10-30 00:00:00	32020		\N	16028	0	10509002	260139		0
4275	246	4266809	2000-06-03	2000-06-03 00:00:00	\N	\N	32020		\N	16565	0	397881000	4266809		0
4482	263	313217	2016-08-28	2016-08-28 00:00:00	\N	\N	32020		\N	17499	0	49436004	313217		0
4614	270	81151	1995-08-15	1995-08-15 00:00:00	1995-09-05	1995-09-05 00:00:00	32020		\N	18025	0	44465007	81151		0
4778	280	4134304	1949-11-13	1949-11-13 00:00:00	1950-01-12	1950-01-12 00:00:00	32020		\N	18703	0	263102004	4134304		0
4926	289	4112343	1962-10-29	1962-10-29 00:00:00	1962-11-11	1962-11-11 00:00:00	32020		\N	19305	0	195662009	4112343		0
5107	299	260139	2011-11-27	2011-11-27 00:00:00	2011-12-04	2011-12-04 00:00:00	32020		\N	19993	0	10509002	260139		0
5264	310	80180	1984-02-25	1984-02-25 00:00:00	\N	\N	32020		\N	20524	0	396275006	80180		0
5458	321	81151	1983-11-22	1983-11-22 00:00:00	1983-12-06	1983-12-06 00:00:00	32020		\N	21321	0	44465007	81151		0
5631	332	80180	2007-05-19	2007-05-19 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
5769	339	440086	1992-08-11	1992-08-11 00:00:00	2000-08-19	2000-08-19 00:00:00	32020		\N	22664	0	192127007	440086		0
5937	349	40481087	1991-12-23	1991-12-23 00:00:00	1992-01-13	1992-01-13 00:00:00	32020		\N	23172	0	444814009	40481087		0
6092	358	80180	1976-10-02	1976-10-02 00:00:00	\N	\N	32020		\N	23820	0	396275006	80180		0
6253	366	40481087	2018-11-24	2018-11-24 00:00:00	2018-12-08	2018-12-08 00:00:00	32020		\N	24311	0	444814009	40481087		0
6417	377	4113008	1977-08-04	1977-08-04 00:00:00	1977-08-25	1977-08-25 00:00:00	32020		\N	24966	0	284549007	4113008		0
17102	1022	80180	2006-07-09	2006-07-09 00:00:00	\N	\N	32020		\N	67215	0	396275006	80180		0
6757	399	81151	1999-03-30	1999-03-30 00:00:00	1999-05-04	1999-05-04 00:00:00	32020		\N	26239	0	44465007	81151		0
6929	408	80180	2004-07-16	2004-07-16 00:00:00	\N	\N	32020		\N	26961	0	396275006	80180		0
7096	418	4112343	1983-01-01	1983-01-01 00:00:00	1983-01-12	1983-01-12 00:00:00	32020		\N	27610	0	195662009	4112343		0
17791	1072	4112343	1979-07-24	1979-07-24 00:00:00	1979-08-02	1979-08-02 00:00:00	32020		\N	70240	0	195662009	4112343		0
7434	437	30753	1986-03-29	1986-03-29 00:00:00	\N	\N	32020		\N	29008	0	16761005	30753		0
7593	445	40481087	1922-12-18	1922-12-18 00:00:00	1923-01-08	1923-01-08 00:00:00	32020		\N	29553	0	444814009	40481087		0
7750	454	40481087	2001-08-15	2001-08-15 00:00:00	2001-08-22	2001-08-22 00:00:00	32020		\N	30289	0	444814009	40481087		0
7931	462	40481087	1992-07-06	1992-07-06 00:00:00	1992-07-20	1992-07-20 00:00:00	32020		\N	30881	0	444814009	40481087		0
8117	476	4112343	2015-02-11	2015-02-11 00:00:00	2015-02-21	2015-02-21 00:00:00	32020		\N	31751	0	195662009	4112343		0
8293	484	40481087	2011-03-29	2011-03-29 00:00:00	2011-04-12	2011-04-12 00:00:00	32020		\N	32313	0	444814009	40481087		0
8412	488	4112343	1995-09-08	1995-09-08 00:00:00	1995-09-16	1995-09-16 00:00:00	32020		\N	32625	0	195662009	4112343		0
8592	500	4112343	2009-07-03	2009-07-03 00:00:00	2009-07-14	2009-07-14 00:00:00	32020		\N	33516	0	195662009	4112343		0
8791	515	4059173	2012-08-02	2012-08-02 00:00:00	2012-10-31	2012-10-31 00:00:00	32020		\N	34392	0	16114001	4059173		0
19511	1173	40481087	1995-07-09	1995-07-09 00:00:00	1995-07-23	1995-07-23 00:00:00	32020		\N	77209	0	444814009	40481087		0
9092	534	4112343	2005-11-04	2005-11-04 00:00:00	2005-11-12	2005-11-12 00:00:00	32020		\N	35570	0	195662009	4112343		0
19776	1188	40481087	2015-05-02	2015-05-02 00:00:00	2015-05-09	2015-05-09 00:00:00	32020		\N	78261	0	444814009	40481087		0
9452	559	28060	1973-06-16	1973-06-16 00:00:00	1973-06-24	1973-06-24 00:00:00	32020		\N	37074	0	43878008	28060		0
9610	569	80502	1993-03-20	1993-03-20 00:00:00	\N	\N	32020		\N	37682	0	64859006	80502		0
9755	578	40481087	1990-07-23	1990-07-23 00:00:00	1990-08-06	1990-08-06 00:00:00	32020		\N	38279	0	444814009	40481087		0
9934	588	375671	1990-07-10	1990-07-10 00:00:00	1990-08-09	1990-08-09 00:00:00	32020		\N	38937	0	62564004	375671		0
20592	1236	28060	1933-12-04	1933-12-04 00:00:00	1933-12-16	1933-12-16 00:00:00	32020		\N	81363	0	43878008	28060		0
10257	606	4296205	2013-12-24	2013-12-24 00:00:00	2014-01-07	2014-01-07 00:00:00	32020		\N	40240	0	403191005	4296205		0
10413	614	4142905	1970-04-27	1970-04-27 00:00:00	1970-07-26	1970-07-26 00:00:00	32020		\N	40847	0	33737001	4142905		0
21090	1266	260139	1994-11-16	1994-11-16 00:00:00	1994-11-23	1994-11-23 00:00:00	32020		\N	83489	0	10509002	260139		0
103	3	40481087	1981-12-15	1981-12-15 00:00:00	1981-12-29	1981-12-29 00:00:00	32020		\N	349	0	444814009	40481087		0
308	16	4155034	1989-06-24	1989-06-24 00:00:00	1989-07-08	1989-07-08 00:00:00	32020		\N	1164	0	283371005	4155034		0
10972	648	260139	1961-11-25	1961-11-25 00:00:00	1961-12-09	1961-12-09 00:00:00	32020		\N	42847	0	10509002	260139		0
647	36	260139	1988-10-26	1988-10-26 00:00:00	1988-11-09	1988-11-09 00:00:00	32020		\N	2490	0	10509002	260139		0
788	42	4112343	1913-07-15	1913-07-15 00:00:00	1913-07-26	1913-07-26 00:00:00	32020		\N	3060	0	195662009	4112343		0
11507	679	260139	2007-11-01	2007-11-01 00:00:00	2007-11-15	2007-11-15 00:00:00	32020		\N	44956	0	10509002	260139		0
1135	66	4112343	1971-07-14	1971-07-14 00:00:00	1971-07-22	1971-07-22 00:00:00	32020		\N	4512	0	195662009	4112343		0
1285	74	4152936	2013-08-27	2013-08-27 00:00:00	2013-09-10	2013-09-10 00:00:00	32020		\N	4981	0	283385000	4152936		0
1441	84	372328	1977-02-10	1977-02-10 00:00:00	1977-07-07	1977-07-07 00:00:00	32020		\N	5659	0	65363002	372328		0
12124	718	80180	2005-09-29	2005-09-29 00:00:00	\N	\N	32020		\N	47531	0	396275006	80180		0
1784	101	4278672	2011-05-08	2011-05-08 00:00:00	2011-08-06	2011-08-06 00:00:00	32020		\N	6943	0	65966004	4278672		0
1976	116	78272	1936-02-18	1936-02-18 00:00:00	1936-03-24	1936-03-24 00:00:00	32020		\N	7650	0	70704007	78272		0
2133	123	4283893	1974-10-10	1974-10-10 00:00:00	1974-11-07	1974-11-07 00:00:00	32020		\N	8105	0	36971009	4283893		0
12808	756	81893	1999-01-18	1999-01-18 00:00:00	\N	\N	32020		\N	50166	0	64766004	81893		0
2459	144	260139	1980-10-21	1980-10-21 00:00:00	1980-11-04	1980-11-04 00:00:00	32020		\N	9613	0	10509002	260139		0
2633	154	4310024	2011-01-11	2011-01-11 00:00:00	\N	\N	32020		\N	10429	0	424802006	4310024		0
2779	160	260139	1966-01-03	1966-01-03 00:00:00	1966-01-17	1966-01-17 00:00:00	32020		\N	10960	0	10509002	260139		0
2958	171	4027663	2001-03-02	2001-03-02 00:00:00	\N	\N	32020		\N	11621	0	13200003	4027663		0
3111	183	4294548	2009-09-07	2009-09-07 00:00:00	2009-09-28	2009-09-28 00:00:00	32020		\N	12412	0	75498004	4294548		0
3256	189	40481087	1975-06-02	1975-06-02 00:00:00	1975-06-16	1975-06-16 00:00:00	32020		\N	12837	0	444814009	40481087		0
3438	196	40481087	2008-09-28	2008-09-28 00:00:00	2008-10-12	2008-10-12 00:00:00	32020		\N	13462	0	444814009	40481087		0
14118	834	4109685	2012-11-18	2012-11-18 00:00:00	2012-12-02	2012-12-02 00:00:00	32020		\N	55252	0	284551006	4109685		0
3786	217	260139	1981-05-08	1981-05-08 00:00:00	1981-05-22	1981-05-22 00:00:00	32020		\N	14637	0	10509002	260139		0
3951	227	40481087	2017-07-21	2017-07-21 00:00:00	2017-07-28	2017-07-28 00:00:00	32020		\N	15319	0	444814009	40481087		0
4123	239	4155034	1970-07-26	1970-07-26 00:00:00	1970-08-09	1970-08-09 00:00:00	32020		\N	16052	0	283371005	4155034		0
4276	246	4142905	1961-11-15	1961-11-15 00:00:00	1962-01-14	1962-01-14 00:00:00	32020		\N	16583	0	33737001	4142905		0
14956	882	4112343	1965-06-07	1965-06-07 00:00:00	1965-06-20	1965-06-20 00:00:00	32020		\N	58725	0	195662009	4112343		0
4615	270	375671	1999-08-15	1999-08-15 00:00:00	1999-09-14	1999-09-14 00:00:00	32020		\N	18026	0	62564004	375671		0
4779	280	40481087	1979-05-14	1979-05-14 00:00:00	1979-05-28	1979-05-28 00:00:00	32020		\N	18712	0	444814009	40481087		0
4927	289	4112343	2016-06-30	2016-06-30 00:00:00	2016-07-11	2016-07-11 00:00:00	32020		\N	19311	0	195662009	4112343		0
5108	299	28060	1962-04-09	1962-04-09 00:00:00	1962-04-17	1962-04-17 00:00:00	32020		\N	20012	0	43878008	28060		0
5265	310	40481087	1976-03-20	1976-03-20 00:00:00	1976-04-03	1976-04-03 00:00:00	32020		\N	20523	0	444814009	40481087		0
5459	321	260139	1968-08-08	1968-08-08 00:00:00	1968-08-22	1968-08-22 00:00:00	32020		\N	21290	0	10509002	260139		0
5632	332	40481087	2010-02-11	2010-02-11 00:00:00	2010-02-18	2010-02-18 00:00:00	32020		\N	21948	0	444814009	40481087		0
5770	339	260139	1993-05-19	1993-05-19 00:00:00	1993-06-02	1993-06-02 00:00:00	32020		\N	22637	0	10509002	260139		0
5938	349	4112343	1964-01-13	1964-01-13 00:00:00	1964-01-22	1964-01-22 00:00:00	32020		\N	23196	0	195662009	4112343		0
6093	358	4112343	1996-11-13	1996-11-13 00:00:00	1996-11-24	1996-11-24 00:00:00	32020		\N	23808	0	195662009	4112343		0
6254	366	4283893	1916-08-25	1916-08-25 00:00:00	1916-10-27	1916-10-27 00:00:00	32020		\N	24266	0	36971009	4283893		0
6418	377	260139	2010-07-19	2010-07-19 00:00:00	2010-07-26	2010-07-26 00:00:00	32020		\N	24976	0	10509002	260139		0
17103	1022	4112343	1965-06-26	1965-06-26 00:00:00	1965-07-08	1965-07-08 00:00:00	32020		\N	67268	0	195662009	4112343		0
6758	399	40481087	1993-11-21	1993-11-21 00:00:00	1993-12-05	1993-12-05 00:00:00	32020		\N	26153	0	444814009	40481087		0
6930	408	40481087	2013-11-06	2013-11-06 00:00:00	2013-11-27	2013-11-27 00:00:00	32020		\N	26994	0	444814009	40481087		0
7097	418	40481087	2011-11-21	2011-11-21 00:00:00	2011-11-28	2011-11-28 00:00:00	32020		\N	27636	0	444814009	40481087		0
17792	1072	40481087	1980-03-12	1980-03-12 00:00:00	1980-04-02	1980-04-02 00:00:00	32020		\N	70241	0	444814009	40481087		0
7435	437	80180	1987-07-22	1987-07-22 00:00:00	\N	\N	32020		\N	29008	0	396275006	80180		0
7594	445	260139	1950-12-23	1950-12-23 00:00:00	1950-12-30	1950-12-30 00:00:00	32020		\N	29604	0	10509002	260139		0
7751	454	378001	1990-01-24	1990-01-24 00:00:00	1990-02-23	1990-02-23 00:00:00	32020		\N	30274	0	62106007	378001		0
7932	462	195588	1999-09-11	1999-09-11 00:00:00	1999-10-21	1999-10-21 00:00:00	32020		\N	30907	0	38822007	195588		0
8118	476	4218389	1992-06-27	1992-06-27 00:00:00	1992-08-01	1992-08-01 00:00:00	32020		\N	31753	0	39848009	4218389		0
8294	484	28060	1947-08-16	1947-08-16 00:00:00	1947-08-29	1947-08-29 00:00:00	32020		\N	32344	0	43878008	28060		0
8413	488	260139	1962-09-21	1962-09-21 00:00:00	1962-09-28	1962-09-28 00:00:00	32020		\N	32616	0	10509002	260139		0
8593	500	81151	1968-06-19	1968-06-19 00:00:00	1968-07-03	1968-07-03 00:00:00	32020		\N	33546	0	44465007	81151		0
8792	515	40481087	1959-01-14	1959-01-14 00:00:00	1959-01-28	1959-01-28 00:00:00	32020		\N	34323	0	444814009	40481087		0
19512	1173	40481087	2012-08-16	2012-08-16 00:00:00	2012-08-30	2012-08-30 00:00:00	32020		\N	77272	0	444814009	40481087		0
9093	534	4283893	1997-11-01	1997-11-01 00:00:00	1998-02-14	1998-02-14 00:00:00	32020		\N	35533	0	36971009	4283893		0
19777	1189	40481087	1967-09-18	1967-09-18 00:00:00	1967-09-25	1967-09-25 00:00:00	32020		\N	78350	0	444814009	40481087		0
9453	559	40481087	1986-04-25	1986-04-25 00:00:00	1986-05-02	1986-05-02 00:00:00	32020		\N	37048	0	444814009	40481087		0
9611	569	81151	2011-01-03	2011-01-03 00:00:00	2011-02-07	2011-02-07 00:00:00	32020		\N	37725	0	44465007	81151		0
9756	578	4112343	1996-10-07	1996-10-07 00:00:00	1996-10-16	1996-10-16 00:00:00	32020		\N	38216	0	195662009	4112343		0
9935	588	40481087	2009-03-12	2009-03-12 00:00:00	2009-03-26	2009-03-26 00:00:00	32020		\N	38934	0	444814009	40481087		0
20593	1236	4155034	1978-11-02	1978-11-02 00:00:00	1978-11-16	1978-11-16 00:00:00	32020		\N	81485	0	283371005	4155034		0
10258	606	40481087	1999-03-28	1999-03-28 00:00:00	1999-04-18	1999-04-18 00:00:00	32020		\N	40242	0	444814009	40481087		0
10414	614	40481087	1977-01-22	1977-01-22 00:00:00	1977-01-29	1977-01-29 00:00:00	32020		\N	40856	0	444814009	40481087		0
21091	1266	80180	2004-12-20	2004-12-20 00:00:00	\N	\N	32020		\N	83461	0	396275006	80180		0
104	3	40481087	1920-09-16	1920-09-16 00:00:00	1920-10-07	1920-10-07 00:00:00	32020		\N	321	0	444814009	40481087		0
309	17	4294548	1999-02-06	1999-02-06 00:00:00	1999-04-24	1999-04-24 00:00:00	32020		\N	1290	0	75498004	4294548		0
10973	648	40481087	2017-08-14	2017-08-14 00:00:00	2017-08-21	2017-08-21 00:00:00	32020		\N	42916	0	444814009	40481087		0
648	36	260139	1974-05-20	1974-05-20 00:00:00	1974-05-27	1974-05-27 00:00:00	32020		\N	2488	0	10509002	260139		0
789	42	260139	1953-06-19	1953-06-19 00:00:00	1953-07-03	1953-07-03 00:00:00	32020		\N	3016	0	10509002	260139		0
11508	679	260139	1996-08-01	1996-08-01 00:00:00	1996-08-15	1996-08-15 00:00:00	32020		\N	44939	0	10509002	260139		0
1136	66	260139	1998-04-18	1998-04-18 00:00:00	1998-05-02	1998-05-02 00:00:00	32020		\N	4505	0	10509002	260139		0
1286	74	30753	2013-11-20	2013-11-20 00:00:00	\N	\N	32020		\N	4981	0	16761005	30753		0
1442	84	257012	2013-11-24	2013-11-24 00:00:00	\N	\N	32020		\N	5674	0	40055000	257012		0
12125	718	40481087	1968-02-22	1968-02-22 00:00:00	1968-02-29	1968-02-29 00:00:00	32020		\N	47478	0	444814009	40481087		0
1785	101	313217	2010-06-25	2010-06-25 00:00:00	\N	\N	32020		\N	6852	0	49436004	313217		0
1977	116	28060	1934-05-10	1934-05-10 00:00:00	1934-05-23	1934-05-23 00:00:00	32020		\N	7649	0	43878008	28060		0
2134	124	4112343	1994-10-14	1994-10-14 00:00:00	1994-10-27	1994-10-27 00:00:00	32020		\N	8242	0	195662009	4112343		0
12809	756	4310024	1998-02-22	1998-02-22 00:00:00	\N	\N	32020		\N	50166	0	424802006	4310024		0
2460	144	40481087	1989-06-25	1989-06-25 00:00:00	1989-07-02	1989-07-02 00:00:00	32020		\N	9637	0	444814009	40481087		0
2634	154	30753	2011-06-10	2011-06-10 00:00:00	\N	\N	32020		\N	10429	0	16761005	30753		0
2780	160	4146173	1965-05-07	1965-05-07 00:00:00	1965-07-06	1965-07-06 00:00:00	32020		\N	10959	0	307731004	4146173		0
2966	173	4112343	1986-09-15	1986-09-15 00:00:00	1986-09-22	1986-09-22 00:00:00	32020		\N	11768	0	195662009	4112343		0
3112	183	440448	1986-10-22	1986-10-22 00:00:00	\N	\N	32020		\N	12348	0	74400008	440448		0
3257	189	4112343	1959-10-06	1959-10-06 00:00:00	1959-10-19	1959-10-19 00:00:00	32020		\N	12861	0	195662009	4112343		0
3439	196	260139	1967-07-29	1967-07-29 00:00:00	1967-08-05	1967-08-05 00:00:00	32020		\N	13441	0	10509002	260139		0
14119	834	40481087	2017-09-16	2017-09-16 00:00:00	2017-10-07	2017-10-07 00:00:00	32020		\N	55182	0	444814009	40481087		0
3787	217	260139	2010-09-16	2010-09-16 00:00:00	2010-09-30	2010-09-30 00:00:00	32020		\N	14685	0	10509002	260139		0
3952	227	4296205	2014-07-03	2014-07-03 00:00:00	2014-07-31	2014-07-31 00:00:00	32020		\N	15313	0	403191005	4296205		0
4125	239	4329847	2012-07-05	2012-07-05 00:00:00	\N	\N	32020		\N	16054	0	22298006	4329847		0
4277	246	4296205	1974-03-12	1974-03-12 00:00:00	1974-04-09	1974-04-09 00:00:00	32020		\N	16586	0	403191005	4296205		0
14957	882	40481087	1970-12-31	1970-12-31 00:00:00	1971-01-21	1971-01-21 00:00:00	32020		\N	58677	0	444814009	40481087		0
4616	270	4112343	1993-08-24	1993-08-24 00:00:00	1993-09-02	1993-09-02 00:00:00	32020		\N	17960	0	195662009	4112343		0
4780	280	4112343	1962-08-09	1962-08-09 00:00:00	1962-08-22	1962-08-22 00:00:00	32020		\N	18674	0	195662009	4112343		0
4928	289	372328	1962-11-12	1962-11-12 00:00:00	1963-02-18	1963-02-18 00:00:00	32020		\N	19262	0	65363002	372328		0
5109	299	40481087	2008-06-09	2008-06-09 00:00:00	2008-06-16	2008-06-16 00:00:00	32020		\N	20027	0	444814009	40481087		0
5266	310	4310024	1981-09-08	1981-09-08 00:00:00	\N	\N	32020		\N	20497	0	424802006	4310024		0
5460	321	260139	1973-04-13	1973-04-13 00:00:00	1973-04-27	1973-04-27 00:00:00	32020		\N	21271	0	10509002	260139		0
5633	332	4142905	1972-08-25	1972-08-25 00:00:00	1972-10-24	1972-10-24 00:00:00	32020		\N	21905	0	33737001	4142905		0
5771	339	260139	1996-02-28	1996-02-28 00:00:00	1996-03-06	1996-03-06 00:00:00	32020		\N	22638	0	10509002	260139		0
5939	350	196456	1995-09-11	1995-09-11 00:00:00	1995-09-11	1995-09-11 00:00:00	32020		\N	23293	0	235919008	196456		0
6094	358	40481087	1965-12-25	1965-12-25 00:00:00	1966-01-08	1966-01-08 00:00:00	32020		\N	23792	0	444814009	40481087		0
6255	366	257012	1914-10-17	1914-10-17 00:00:00	\N	\N	32020		\N	24265	0	40055000	257012		0
6419	377	260139	1998-06-06	1998-06-06 00:00:00	1998-06-20	1998-06-20 00:00:00	32020		\N	24958	0	10509002	260139		0
17104	1022	260139	1982-01-05	1982-01-05 00:00:00	1982-01-19	1982-01-19 00:00:00	32020		\N	67253	0	10509002	260139		0
6759	399	40481087	1989-11-25	1989-11-25 00:00:00	1989-12-09	1989-12-09 00:00:00	32020		\N	26197	0	444814009	40481087		0
6931	408	40481087	1997-02-18	1997-02-18 00:00:00	1997-03-04	1997-03-04 00:00:00	32020		\N	26989	0	444814009	40481087		0
7098	418	257012	1971-07-28	1971-07-28 00:00:00	\N	\N	32020		\N	27675	0	40055000	257012		0
17793	1072	260139	1979-01-12	1979-01-12 00:00:00	1979-01-26	1979-01-26 00:00:00	32020		\N	70248	0	10509002	260139		0
7436	437	378001	1961-10-05	1961-10-05 00:00:00	1961-11-04	1961-11-04 00:00:00	32020		\N	29051	0	62106007	378001		0
7595	445	4112343	1944-12-25	1944-12-25 00:00:00	1945-01-03	1945-01-03 00:00:00	32020		\N	29571	0	195662009	4112343		0
7752	454	260139	1958-01-01	1958-01-01 00:00:00	1958-01-08	1958-01-08 00:00:00	32020		\N	30347	0	10509002	260139		0
7933	462	260139	1981-06-23	1981-06-23 00:00:00	1981-07-07	1981-07-07 00:00:00	32020		\N	30880	0	10509002	260139		0
8119	476	4112343	1990-06-01	1990-06-01 00:00:00	1990-06-11	1990-06-11 00:00:00	32020		\N	31739	0	195662009	4112343		0
8295	484	28060	2001-11-07	2001-11-07 00:00:00	2001-11-17	2001-11-17 00:00:00	32020		\N	32317	0	43878008	28060		0
8414	488	40481087	2014-06-17	2014-06-17 00:00:00	2014-06-24	2014-06-24 00:00:00	32020		\N	32653	0	444814009	40481087		0
8594	500	372328	1963-04-25	1963-04-25 00:00:00	1963-08-27	1963-08-27 00:00:00	32020		\N	33540	0	65363002	372328		0
8793	515	4294548	1977-06-26	1977-06-26 00:00:00	1977-07-31	1977-07-31 00:00:00	32020		\N	34379	0	75498004	4294548		0
19513	1173	40481087	1997-06-19	1997-06-19 00:00:00	1997-06-26	1997-06-26 00:00:00	32020		\N	77239	0	444814009	40481087		0
9127	539	4116491	1990-04-29	1990-04-29 00:00:00	1990-06-16	1990-06-16 00:00:00	32020		\N	35786	0	301011002	4116491		0
19778	1189	40481087	2012-11-07	2012-11-07 00:00:00	2012-11-28	2012-11-28 00:00:00	32020		\N	78354	0	444814009	40481087		0
9454	559	40481087	1998-02-07	1998-02-07 00:00:00	1998-02-21	1998-02-21 00:00:00	32020		\N	37110	0	444814009	40481087		0
9612	569	40481087	1994-08-28	1994-08-28 00:00:00	1994-09-11	1994-09-11 00:00:00	32020		\N	37641	0	444814009	40481087		0
9757	578	4237458	1970-01-15	1970-01-15 00:00:00	1970-04-15	1970-04-15 00:00:00	32020		\N	38193	0	58150001	4237458		0
9936	588	40481087	1986-07-29	1986-07-29 00:00:00	1986-08-19	1986-08-19 00:00:00	32020		\N	38917	0	444814009	40481087		0
20594	1236	4112343	2002-12-20	2002-12-20 00:00:00	2003-01-02	2003-01-02 00:00:00	32020		\N	81365	0	195662009	4112343		0
10259	607	40481087	1987-05-05	1987-05-05 00:00:00	1987-05-19	1987-05-19 00:00:00	32020		\N	40339	0	444814009	40481087		0
10415	614	4112343	1984-10-03	1984-10-03 00:00:00	1984-10-16	1984-10-16 00:00:00	32020		\N	40791	0	195662009	4112343		0
21092	1266	28060	1980-07-31	1980-07-31 00:00:00	1980-08-09	1980-08-09 00:00:00	32020		\N	83485	0	43878008	28060		0
105	3	313217	2001-07-23	2001-07-23 00:00:00	\N	\N	32020		\N	258	0	49436004	313217		0
310	17	40481087	1973-03-13	1973-03-13 00:00:00	1973-03-20	1973-03-20 00:00:00	32020		\N	1307	0	444814009	40481087		0
10974	648	40481087	1935-04-20	1935-04-20 00:00:00	1935-05-04	1935-05-04 00:00:00	32020		\N	42945	0	444814009	40481087		0
649	36	40481087	1969-05-04	1969-05-04 00:00:00	1969-05-18	1969-05-18 00:00:00	32020		\N	2505	0	444814009	40481087		0
790	42	260139	1992-04-09	1992-04-09 00:00:00	1992-04-16	1992-04-16 00:00:00	32020		\N	3069	0	10509002	260139		0
11509	679	40481087	1975-11-05	1975-11-05 00:00:00	1975-11-19	1975-11-19 00:00:00	32020		\N	44926	0	444814009	40481087		0
1137	66	4035415	2016-02-26	2016-02-26 00:00:00	2016-03-27	2016-03-27 00:00:00	32020		\N	4450	0	239720000	4035415		0
1287	74	28060	1995-09-11	1995-09-11 00:00:00	1995-09-19	1995-09-19 00:00:00	32020		\N	4998	0	43878008	28060		0
1443	84	40481087	1996-12-14	1996-12-14 00:00:00	1996-12-28	1996-12-28 00:00:00	32020		\N	5672	0	444814009	40481087		0
12126	718	321042	1974-10-19	1974-10-19 00:00:00	\N	\N	32020		\N	47525	0	410429000	321042		0
1786	101	40481087	2008-07-30	2008-07-30 00:00:00	2008-08-06	2008-08-06 00:00:00	32020		\N	6855	0	444814009	40481087		0
1978	116	28060	1937-07-25	1937-07-25 00:00:00	1937-08-01	1937-08-01 00:00:00	32020		\N	7702	0	43878008	28060		0
2135	124	40481087	1984-09-07	1984-09-07 00:00:00	1984-09-14	1984-09-14 00:00:00	32020		\N	8224	0	444814009	40481087		0
12810	756	30753	1999-11-14	1999-11-14 00:00:00	\N	\N	32020		\N	50166	0	16761005	30753		0
2461	144	81151	1978-10-30	1978-10-30 00:00:00	1978-11-20	1978-11-20 00:00:00	32020		\N	9612	0	44465007	81151		0
2635	154	4285898	2011-09-08	2011-09-08 00:00:00	\N	\N	32020		\N	10429	0	68496003	4285898		0
2781	160	195588	1997-12-07	1997-12-07 00:00:00	1998-01-17	1998-01-17 00:00:00	32020		\N	10950	0	38822007	195588		0
2967	173	40481087	1975-05-23	1975-05-23 00:00:00	1975-06-13	1975-06-13 00:00:00	32020		\N	11782	0	444814009	40481087		0
3113	183	40481087	1998-11-01	1998-11-01 00:00:00	1998-11-15	1998-11-15 00:00:00	32020		\N	12360	0	444814009	40481087		0
3258	189	4155034	1992-06-02	1992-06-02 00:00:00	1992-06-23	1992-06-23 00:00:00	32020		\N	12890	0	283371005	4155034		0
3440	196	81151	1970-12-21	1970-12-21 00:00:00	1971-01-25	1971-01-25 00:00:00	32020		\N	13450	0	44465007	81151		0
14120	834	40481087	1990-10-28	1990-10-28 00:00:00	1990-11-18	1990-11-18 00:00:00	32020		\N	55177	0	444814009	40481087		0
3789	219	380378	1975-05-24	1975-05-24 00:00:00	\N	\N	32020		\N	14751	0	84757009	380378		0
3953	227	81151	2019-05-06	2019-05-06 00:00:00	2019-05-27	2019-05-27 00:00:00	32020		\N	15314	0	44465007	81151		0
4126	239	4112343	1970-06-17	1970-06-17 00:00:00	1970-06-29	1970-06-29 00:00:00	32020		\N	16035	0	195662009	4112343		0
4278	246	40481087	2001-03-31	2001-03-31 00:00:00	2001-04-07	2001-04-07 00:00:00	32020		\N	16606	0	444814009	40481087		0
14958	882	381316	2016-12-10	2016-12-10 00:00:00	\N	\N	32020		\N	58720	0	230690007	381316		0
4617	270	81893	1994-02-20	1994-02-20 00:00:00	\N	\N	32020		\N	17960	0	64766004	81893		0
4781	280	260139	1992-09-21	1992-09-21 00:00:00	1992-09-28	1992-09-28 00:00:00	32020		\N	18734	0	10509002	260139		0
4929	289	4112343	2000-04-27	2000-04-27 00:00:00	2000-05-07	2000-05-07 00:00:00	32020		\N	19255	0	195662009	4112343		0
5110	299	260139	1975-01-31	1975-01-31 00:00:00	1975-02-07	1975-02-07 00:00:00	32020		\N	20024	0	10509002	260139		0
5267	310	4152936	1981-06-14	1981-06-14 00:00:00	1981-07-05	1981-07-05 00:00:00	32020		\N	20497	0	283385000	4152936		0
5461	321	378001	2001-02-25	2001-02-25 00:00:00	2001-03-27	2001-03-27 00:00:00	32020		\N	21323	0	62106007	378001		0
5634	332	4112343	1969-06-15	1969-06-15 00:00:00	1969-06-25	1969-06-25 00:00:00	32020		\N	21993	0	195662009	4112343		0
5772	339	40481087	2005-12-23	2005-12-23 00:00:00	2006-01-13	2006-01-13 00:00:00	32020		\N	22639	0	444814009	40481087		0
5940	350	198809	1995-09-11	1995-09-11 00:00:00	1995-09-11	1995-09-11 00:00:00	32020		\N	23293	0	65275009	198809		0
6095	358	4027663	1967-12-19	1967-12-19 00:00:00	\N	\N	32020		\N	23792	0	13200003	4027663		0
6256	366	192671	1944-10-06	1944-10-06 00:00:00	\N	\N	32020		\N	24351	0	K92.2	35208414		0
6420	377	40481087	1999-10-30	1999-10-30 00:00:00	1999-11-20	1999-11-20 00:00:00	32020		\N	25021	0	444814009	40481087		0
17105	1022	378001	2008-09-27	2008-09-27 00:00:00	2008-11-26	2008-11-26 00:00:00	32020		\N	67210	0	62106007	378001		0
6760	399	40481087	1973-09-23	1973-09-23 00:00:00	1973-10-14	1973-10-14 00:00:00	32020		\N	26252	0	444814009	40481087		0
6932	408	4112343	1967-11-17	1967-11-17 00:00:00	1967-11-24	1967-11-24 00:00:00	32020		\N	26940	0	195662009	4112343		0
7099	418	260139	2016-04-03	2016-04-03 00:00:00	2016-04-17	2016-04-17 00:00:00	32020		\N	27616	0	10509002	260139		0
17794	1072	40481087	1975-02-14	1975-02-14 00:00:00	1975-02-28	1975-02-28 00:00:00	32020		\N	70257	0	444814009	40481087		0
7437	437	4112343	2003-09-26	2003-09-26 00:00:00	2003-10-05	2003-10-05 00:00:00	32020		\N	28976	0	195662009	4112343		0
7596	445	4112343	1996-01-29	1996-01-29 00:00:00	1996-02-09	1996-02-09 00:00:00	32020		\N	29558	0	195662009	4112343		0
7753	454	40481087	1965-10-22	1965-10-22 00:00:00	1965-11-12	1965-11-12 00:00:00	32020		\N	30282	0	444814009	40481087		0
7934	462	4112343	1999-02-20	1999-02-20 00:00:00	1999-03-03	1999-03-03 00:00:00	32020		\N	30892	0	195662009	4112343		0
8120	476	260139	2002-02-11	2002-02-11 00:00:00	2002-02-25	2002-02-25 00:00:00	32020		\N	31740	0	10509002	260139		0
8296	484	4112343	2010-02-21	2010-02-21 00:00:00	2010-03-03	2010-03-03 00:00:00	32020		\N	32312	0	195662009	4112343		0
8415	488	378001	1995-05-29	1995-05-29 00:00:00	1995-06-28	1995-06-28 00:00:00	32020		\N	32700	0	62106007	378001		0
8595	500	4112343	1991-03-30	1991-03-30 00:00:00	1991-04-08	1991-04-08 00:00:00	32020		\N	33521	0	195662009	4112343		0
8794	515	78272	2001-01-11	2001-01-11 00:00:00	2001-02-01	2001-02-01 00:00:00	32020		\N	34391	0	70704007	78272		0
19514	1173	28060	1951-03-11	1951-03-11 00:00:00	1951-03-22	1951-03-22 00:00:00	32020		\N	77206	0	43878008	28060		0
9128	539	40481087	1982-05-31	1982-05-31 00:00:00	1982-06-07	1982-06-07 00:00:00	32020		\N	35783	0	444814009	40481087		0
19779	1189	40481087	1968-02-29	1968-02-29 00:00:00	1968-03-14	1968-03-14 00:00:00	32020		\N	78351	0	444814009	40481087		0
9455	559	4112343	1988-11-06	1988-11-06 00:00:00	1988-11-18	1988-11-18 00:00:00	32020		\N	37109	0	195662009	4112343		0
9613	569	40481087	1996-02-11	1996-02-11 00:00:00	1996-02-18	1996-02-18 00:00:00	32020		\N	37585	0	444814009	40481087		0
9758	578	40481087	2016-03-11	2016-03-11 00:00:00	2016-03-25	2016-03-25 00:00:00	32020		\N	38280	0	444814009	40481087		0
9937	588	4218389	2008-12-02	2008-12-02 00:00:00	2008-12-23	2008-12-23 00:00:00	32020		\N	38938	0	39848009	4218389		0
20595	1237	372328	1947-04-23	1947-04-23 00:00:00	1947-09-07	1947-09-07 00:00:00	32020		\N	81513	0	65363002	372328		0
10260	607	40481087	2016-03-11	2016-03-11 00:00:00	2016-03-18	2016-03-18 00:00:00	32020		\N	40282	0	444814009	40481087		0
10416	614	78272	1981-04-20	1981-04-20 00:00:00	1981-05-18	1981-05-18 00:00:00	32020		\N	40849	0	70704007	78272		0
21093	1266	260139	2004-12-11	2004-12-11 00:00:00	2004-12-18	2004-12-18 00:00:00	32020		\N	83503	0	10509002	260139		0
106	3	40481087	2016-01-23	2016-01-23 00:00:00	2016-01-30	2016-01-30 00:00:00	32020		\N	297	0	444814009	40481087		0
311	17	4112343	1984-06-30	1984-06-30 00:00:00	1984-07-10	1984-07-10 00:00:00	32020		\N	1287	0	195662009	4112343		0
10975	648	40481087	1956-10-15	1956-10-15 00:00:00	1956-10-22	1956-10-22 00:00:00	32020		\N	42846	0	444814009	40481087		0
650	36	4112343	1962-10-18	1962-10-18 00:00:00	1962-10-29	1962-10-29 00:00:00	32020		\N	2503	0	195662009	4112343		0
791	42	40481087	1985-10-25	1985-10-25 00:00:00	1985-11-01	1985-11-01 00:00:00	32020		\N	3067	0	444814009	40481087		0
11510	679	28060	1978-05-10	1978-05-10 00:00:00	1978-05-17	1978-05-17 00:00:00	32020		\N	44937	0	43878008	28060		0
1138	67	260139	1992-08-09	1992-08-09 00:00:00	1992-08-23	1992-08-23 00:00:00	32020		\N	4525	0	10509002	260139		0
1288	74	372328	2017-08-20	2017-08-20 00:00:00	2018-07-25	2018-07-25 00:00:00	32020		\N	4993	0	65363002	372328		0
1444	84	28060	1982-07-13	1982-07-13 00:00:00	1982-07-26	1982-07-26 00:00:00	32020		\N	5666	0	43878008	28060		0
12128	718	40481087	1992-11-07	1992-11-07 00:00:00	1992-11-14	1992-11-14 00:00:00	32020		\N	47512	0	444814009	40481087		0
1787	101	40481087	2017-08-24	2017-08-24 00:00:00	2017-09-14	2017-09-14 00:00:00	32020		\N	6838	0	444814009	40481087		0
1979	116	260139	1938-03-10	1938-03-10 00:00:00	1938-03-24	1938-03-24 00:00:00	32020		\N	7703	0	10509002	260139		0
2136	124	4112343	2011-01-16	2011-01-16 00:00:00	2011-01-23	2011-01-23 00:00:00	32020		\N	8283	0	195662009	4112343		0
12811	756	4112343	1971-07-07	1971-07-07 00:00:00	1971-07-16	1971-07-16 00:00:00	32020		\N	50117	0	195662009	4112343		0
2462	145	40481087	1973-10-14	1973-10-14 00:00:00	1973-10-28	1973-10-28 00:00:00	32020		\N	9806	0	444814009	40481087		0
2636	154	40481087	1998-12-11	1998-12-11 00:00:00	1999-01-01	1999-01-01 00:00:00	32020		\N	10453	0	444814009	40481087		0
2782	160	40481087	2003-05-23	2003-05-23 00:00:00	2003-06-06	2003-06-06 00:00:00	32020		\N	10964	0	444814009	40481087		0
2968	173	260139	2011-07-10	2011-07-10 00:00:00	2011-07-24	2011-07-24 00:00:00	32020		\N	11766	0	10509002	260139		0
3114	183	4134304	1981-05-04	1981-05-04 00:00:00	1981-08-02	1981-08-02 00:00:00	32020		\N	12347	0	263102004	4134304		0
3259	189	40481087	1998-03-17	1998-03-17 00:00:00	1998-03-31	1998-03-31 00:00:00	32020		\N	12894	0	444814009	40481087		0
3441	196	40481087	1972-04-19	1972-04-19 00:00:00	1972-05-03	1972-05-03 00:00:00	32020		\N	13442	0	444814009	40481087		0
14121	834	4278672	1963-05-04	1963-05-04 00:00:00	1963-08-02	1963-08-02 00:00:00	32020		\N	55205	0	65966004	4278672		0
3790	219	4051466	1971-04-06	1971-04-06 00:00:00	1987-07-11	1987-07-11 00:00:00	32020		\N	14767	0	233678006	4051466		0
3954	227	40481087	1989-09-27	1989-09-27 00:00:00	1989-10-11	1989-10-11 00:00:00	32020		\N	15327	0	444814009	40481087		0
4127	239	40481087	1951-11-13	1951-11-13 00:00:00	1951-11-27	1951-11-27 00:00:00	32020		\N	16026	0	444814009	40481087		0
4279	246	4112343	1986-08-10	1986-08-10 00:00:00	1986-08-21	1986-08-21 00:00:00	32020		\N	16580	0	195662009	4112343		0
14959	882	28060	1957-06-07	1957-06-07 00:00:00	1957-06-16	1957-06-16 00:00:00	32020		\N	58675	0	43878008	28060		0
4618	270	40481087	2006-04-07	2006-04-07 00:00:00	2006-04-14	2006-04-14 00:00:00	32020		\N	17956	0	444814009	40481087		0
4782	280	4146173	1991-01-26	1991-01-26 00:00:00	1991-04-03	1991-04-03 00:00:00	32020		\N	18766	0	307731004	4146173		0
4957	292	40481087	2006-07-17	2006-07-17 00:00:00	2006-07-24	2006-07-24 00:00:00	32020		\N	19455	0	444814009	40481087		0
5111	299	40481087	1978-12-28	1978-12-28 00:00:00	1979-01-11	1979-01-11 00:00:00	32020		\N	20007	0	444814009	40481087		0
5268	310	81893	1982-01-06	1982-01-06 00:00:00	\N	\N	32020		\N	20497	0	64766004	81893		0
5462	321	80180	2003-06-20	2003-06-20 00:00:00	\N	\N	32020		\N	21268	0	396275006	80180		0
5635	332	4112343	1988-03-27	1988-03-27 00:00:00	1988-04-05	1988-04-05 00:00:00	32020		\N	21998	0	195662009	4112343		0
5773	339	372328	1987-11-09	1987-11-09 00:00:00	1988-07-30	1988-07-30 00:00:00	32020		\N	22628	0	65363002	372328		0
5941	350	81151	1984-02-23	1984-02-23 00:00:00	1984-03-29	1984-03-29 00:00:00	32020		\N	23291	0	44465007	81151		0
6096	358	40481087	1943-08-16	1943-08-16 00:00:00	1943-09-06	1943-09-06 00:00:00	32020		\N	23845	0	444814009	40481087		0
6257	366	4218389	1996-08-24	1996-08-24 00:00:00	1996-09-14	1996-09-14 00:00:00	32020		\N	24355	0	39848009	4218389		0
6421	377	4218389	1987-02-04	1987-02-04 00:00:00	1987-02-25	1987-02-25 00:00:00	32020		\N	24967	0	39848009	4218389		0
17123	1024	260139	1995-02-21	1995-02-21 00:00:00	1995-03-07	1995-03-07 00:00:00	32020		\N	67475	0	10509002	260139		0
6761	399	257012	1992-07-02	1992-07-02 00:00:00	\N	\N	32020		\N	26186	0	40055000	257012		0
6933	408	40481087	1972-04-01	1972-04-01 00:00:00	1972-04-22	1972-04-22 00:00:00	32020		\N	26975	0	444814009	40481087		0
7100	418	40481087	1962-05-09	1962-05-09 00:00:00	1962-05-23	1962-05-23 00:00:00	32020		\N	27605	0	444814009	40481087		0
17795	1072	80180	2000-07-28	2000-07-28 00:00:00	\N	\N	32020		\N	70236	0	396275006	80180		0
7438	437	40481087	1985-10-16	1985-10-16 00:00:00	1985-10-30	1985-10-30 00:00:00	32020		\N	29028	0	444814009	40481087		0
7597	445	4112343	1978-03-07	1978-03-07 00:00:00	1978-03-19	1978-03-19 00:00:00	32020		\N	29557	0	195662009	4112343		0
7754	454	372328	1936-01-08	1936-01-08 00:00:00	1936-02-08	1936-02-08 00:00:00	32020		\N	30292	0	65363002	372328		0
7935	462	40481087	1988-11-21	1988-11-21 00:00:00	1988-11-28	1988-11-28 00:00:00	32020		\N	30891	0	444814009	40481087		0
8121	476	80180	2002-07-29	2002-07-29 00:00:00	\N	\N	32020		\N	31740	0	396275006	80180		0
8297	484	4134304	2011-03-02	2011-03-02 00:00:00	2011-05-31	2011-05-31 00:00:00	32020		\N	32402	0	263102004	4134304		0
8416	488	4283893	1990-10-23	1990-10-23 00:00:00	1990-11-20	1990-11-20 00:00:00	32020		\N	32694	0	36971009	4283893		0
8602	502	40481087	1947-10-17	1947-10-17 00:00:00	1947-10-31	1947-10-31 00:00:00	32020		\N	33597	0	444814009	40481087		0
8795	515	260139	1966-05-11	1966-05-11 00:00:00	1966-05-25	1966-05-25 00:00:00	32020		\N	34414	0	10509002	260139		0
19515	1173	40481087	1960-02-12	1960-02-12 00:00:00	1960-03-04	1960-03-04 00:00:00	32020		\N	77234	0	444814009	40481087		0
9129	539	260139	1986-08-11	1986-08-11 00:00:00	1986-08-25	1986-08-25 00:00:00	32020		\N	35784	0	10509002	260139		0
19780	1189	40481087	1969-09-12	1969-09-12 00:00:00	1969-10-03	1969-10-03 00:00:00	32020		\N	78314	0	444814009	40481087		0
9456	559	40481087	2006-05-13	2006-05-13 00:00:00	2006-05-20	2006-05-20 00:00:00	32020		\N	37056	0	444814009	40481087		0
9614	569	4294548	1935-11-20	1935-11-20 00:00:00	1936-04-01	1936-04-01 00:00:00	32020		\N	37636	0	75498004	4294548		0
9759	578	133834	1967-09-05	1967-09-05 00:00:00	1984-06-07	1984-06-07 00:00:00	32020		\N	38277	0	24079001	133834		0
20419	1228	195588	2016-08-08	2016-08-08 00:00:00	2016-09-08	2016-09-08 00:00:00	32020		\N	80919	0	38822007	195588		0
20596	1237	378001	1990-12-31	1990-12-31 00:00:00	1991-03-01	1991-03-01 00:00:00	32020		\N	81521	0	62106007	378001		0
10261	607	4027663	1979-12-08	1979-12-08 00:00:00	\N	\N	32020		\N	40267	0	13200003	4027663		0
10417	614	40481087	1991-04-19	1991-04-19 00:00:00	1991-04-26	1991-04-26 00:00:00	32020		\N	40858	0	444814009	40481087		0
21094	1266	4294548	1969-05-05	1969-05-05 00:00:00	1969-06-23	1969-06-23 00:00:00	32020		\N	83465	0	75498004	4294548		0
114	5	4059173	2012-10-08	2012-10-08 00:00:00	2012-12-07	2012-12-07 00:00:00	32020		\N	493	0	16114001	4059173		0
312	17	257012	1984-09-12	1984-09-12 00:00:00	\N	\N	32020		\N	1289	0	40055000	257012		0
10976	648	40481087	1941-09-05	1941-09-05 00:00:00	1941-09-12	1941-09-12 00:00:00	32020		\N	42901	0	444814009	40481087		0
651	36	40481087	1991-10-16	1991-10-16 00:00:00	1991-10-30	1991-10-30 00:00:00	32020		\N	2646	0	444814009	40481087		0
792	42	4283893	1969-11-21	1969-11-21 00:00:00	1970-01-30	1970-01-30 00:00:00	32020		\N	3133	0	36971009	4283893		0
11511	680	40479422	2012-07-17	2012-07-17 00:00:00	2012-08-23	2012-08-23 00:00:00	32020		\N	45095	0	444448004	40479422		0
1139	67	260139	1996-10-05	1996-10-05 00:00:00	1996-10-12	1996-10-12 00:00:00	32020		\N	4566	0	10509002	260139		0
1313	78	372328	1968-03-13	1968-03-13 00:00:00	1968-06-13	1968-06-13 00:00:00	32020		\N	5183	0	65363002	372328		0
1445	84	372328	1979-09-25	1979-09-25 00:00:00	1980-01-17	1980-01-17 00:00:00	32020		\N	5660	0	65363002	372328		0
12129	718	4112343	1978-08-10	1978-08-10 00:00:00	1978-08-21	1978-08-21 00:00:00	32020		\N	47499	0	195662009	4112343		0
1788	101	28060	1995-03-25	1995-03-25 00:00:00	1995-04-06	1995-04-06 00:00:00	32020		\N	6937	0	43878008	28060		0
1980	116	4109685	2002-04-19	2002-04-19 00:00:00	2002-05-03	2002-05-03 00:00:00	32020		\N	7692	0	284551006	4109685		0
2137	124	4112343	1992-04-07	1992-04-07 00:00:00	1992-04-15	1992-04-15 00:00:00	32020		\N	8299	0	195662009	4112343		0
12812	756	40479768	1995-08-25	1995-08-25 00:00:00	1995-10-01	1995-10-01 00:00:00	32020		\N	50104	0	444470001	40479768		0
2463	145	4112343	1952-09-28	1952-09-28 00:00:00	1952-10-11	1952-10-11 00:00:00	32020		\N	9683	0	195662009	4112343		0
2637	154	4112343	1994-03-05	1994-03-05 00:00:00	1994-03-14	1994-03-14 00:00:00	32020		\N	10500	0	195662009	4112343		0
2783	161	40481087	1985-09-19	1985-09-19 00:00:00	1985-10-10	1985-10-10 00:00:00	32020		\N	11031	0	444814009	40481087		0
2969	173	372328	1971-01-08	1971-01-08 00:00:00	1971-02-28	1971-02-28 00:00:00	32020		\N	11770	0	65363002	372328		0
3115	183	4155034	1975-10-19	1975-10-19 00:00:00	1975-11-02	1975-11-02 00:00:00	32020		\N	12346	0	283371005	4155034		0
3260	189	260139	2012-09-24	2012-09-24 00:00:00	2012-10-08	2012-10-08 00:00:00	32020		\N	12839	0	10509002	260139		0
3442	196	4146173	1958-08-26	1958-08-26 00:00:00	1958-09-25	1958-09-25 00:00:00	32020		\N	13444	0	307731004	4146173		0
14122	834	40481087	1997-07-17	1997-07-17 00:00:00	1997-08-07	1997-08-07 00:00:00	32020		\N	55219	0	444814009	40481087		0
3791	219	4152936	1974-11-24	1974-11-24 00:00:00	1974-12-08	1974-12-08 00:00:00	32020		\N	14750	0	283385000	4152936		0
3955	227	260139	2005-10-20	2005-10-20 00:00:00	2005-10-27	2005-10-27 00:00:00	32020		\N	15349	0	10509002	260139		0
4128	239	40481087	1976-01-12	1976-01-12 00:00:00	1976-01-26	1976-01-26 00:00:00	32020		\N	16027	0	444814009	40481087		0
4280	246	378001	2002-11-04	2002-11-04 00:00:00	2003-01-03	2003-01-03 00:00:00	32020		\N	16550	0	62106007	378001		0
14960	882	80180	1987-12-03	1987-12-03 00:00:00	\N	\N	32020		\N	58729	0	396275006	80180		0
4619	270	4113008	1965-07-27	1965-07-27 00:00:00	1965-08-10	1965-08-10 00:00:00	32020		\N	18022	0	284549007	4113008		0
4783	280	260139	1947-08-13	1947-08-13 00:00:00	1947-08-27	1947-08-27 00:00:00	32020		\N	18710	0	10509002	260139		0
4958	292	40481087	2004-10-02	2004-10-02 00:00:00	2004-10-16	2004-10-16 00:00:00	32020		\N	19433	0	444814009	40481087		0
5112	299	40481087	2007-05-16	2007-05-16 00:00:00	2007-06-06	2007-06-06 00:00:00	32020		\N	20017	0	444814009	40481087		0
5269	310	4155034	2014-03-05	2014-03-05 00:00:00	2014-03-26	2014-03-26 00:00:00	32020		\N	20499	0	283371005	4155034		0
5463	321	40481087	1964-09-06	1964-09-06 00:00:00	1964-09-13	1964-09-13 00:00:00	32020		\N	21255	0	444814009	40481087		0
5636	332	40481087	1966-06-29	1966-06-29 00:00:00	1966-07-06	1966-07-06 00:00:00	32020		\N	21935	0	444814009	40481087		0
5774	339	4112343	1997-03-25	1997-03-25 00:00:00	1997-04-05	1997-04-05 00:00:00	32020		\N	22622	0	195662009	4112343		0
5942	350	4112343	1980-06-10	1980-06-10 00:00:00	1980-06-18	1980-06-18 00:00:00	32020		\N	23325	0	195662009	4112343		0
6097	358	381316	2012-07-31	2012-07-31 00:00:00	\N	\N	32020		\N	23860	0	230690007	381316		0
6258	366	4134304	1998-11-03	1998-11-03 00:00:00	1999-02-01	1999-02-01 00:00:00	32020		\N	24356	0	263102004	4134304		0
6422	377	40481087	1974-05-19	1974-05-19 00:00:00	1974-06-09	1974-06-09 00:00:00	32020		\N	25008	0	444814009	40481087		0
17124	1024	40481087	1970-04-28	1970-04-28 00:00:00	1970-05-05	1970-05-05 00:00:00	32020		\N	67467	0	444814009	40481087		0
6762	399	40481087	1985-11-16	1985-11-16 00:00:00	1985-12-07	1985-12-07 00:00:00	32020		\N	26130	0	444814009	40481087		0
6934	408	81151	2013-01-05	2013-01-05 00:00:00	2013-02-02	2013-02-02 00:00:00	32020		\N	26973	0	44465007	81151		0
7101	418	81151	1959-08-28	1959-08-28 00:00:00	1959-09-25	1959-09-25 00:00:00	32020		\N	27668	0	44465007	81151		0
17796	1072	4283893	2015-12-20	2015-12-20 00:00:00	2016-04-10	2016-04-10 00:00:00	32020		\N	70279	0	36971009	4283893		0
7439	437	4310024	1985-10-30	1985-10-30 00:00:00	\N	\N	32020		\N	29028	0	424802006	4310024		0
7598	445	40481087	1920-11-06	1920-11-06 00:00:00	1920-11-20	1920-11-20 00:00:00	32020		\N	29646	0	444814009	40481087		0
7755	454	260139	1992-12-17	1992-12-17 00:00:00	1992-12-31	1992-12-31 00:00:00	32020		\N	30352	0	10509002	260139		0
7936	462	40481087	1996-11-03	1996-11-03 00:00:00	1996-11-24	1996-11-24 00:00:00	32020		\N	30882	0	444814009	40481087		0
8122	476	40481087	2018-12-27	2018-12-27 00:00:00	2019-01-10	2019-01-10 00:00:00	32020		\N	31736	0	444814009	40481087		0
8298	484	4112343	1999-08-08	1999-08-08 00:00:00	1999-08-19	1999-08-19 00:00:00	32020		\N	32311	0	195662009	4112343		0
8417	488	40481087	1965-05-14	1965-05-14 00:00:00	1965-05-28	1965-05-28 00:00:00	32020		\N	32673	0	444814009	40481087		0
8603	502	260139	1955-03-31	1955-03-31 00:00:00	1955-04-07	1955-04-07 00:00:00	32020		\N	33598	0	10509002	260139		0
8796	515	317576	1996-11-23	1996-11-23 00:00:00	\N	\N	32020		\N	34396	0	53741008	317576		0
19516	1173	4027663	1975-09-04	1975-09-04 00:00:00	\N	\N	32020		\N	77287	0	13200003	4027663		0
9130	539	260139	1950-11-24	1950-11-24 00:00:00	1950-12-08	1950-12-08 00:00:00	32020		\N	35794	0	10509002	260139		0
19781	1189	4112343	2005-07-06	2005-07-06 00:00:00	2005-07-15	2005-07-15 00:00:00	32020		\N	78305	0	195662009	4112343		0
9457	559	4112343	1973-04-02	1973-04-02 00:00:00	1973-04-15	1973-04-15 00:00:00	32020		\N	37046	0	195662009	4112343		0
9615	569	4113008	2006-04-01	2006-04-01 00:00:00	2006-04-15	2006-04-15 00:00:00	32020		\N	37723	0	284549007	4113008		0
9760	578	40486433	1971-06-06	1971-06-06 00:00:00	\N	\N	32020		\N	38266	0	446096008	40486433		0
20420	1228	4237458	2003-09-30	2003-09-30 00:00:00	2003-11-29	2003-11-29 00:00:00	32020		\N	80896	0	58150001	4237458		0
20597	1237	80180	1983-10-06	1983-10-06 00:00:00	\N	\N	32020		\N	81508	0	396275006	80180		0
10262	607	4112343	1971-05-27	1971-05-27 00:00:00	1971-06-03	1971-06-03 00:00:00	32020		\N	40324	0	195662009	4112343		0
10418	614	260139	1990-12-09	1990-12-09 00:00:00	1990-12-16	1990-12-16 00:00:00	32020		\N	40857	0	10509002	260139		0
21095	1266	40481087	1979-07-26	1979-07-26 00:00:00	1979-08-09	1979-08-09 00:00:00	32020		\N	83467	0	444814009	40481087		0
115	5	260139	2015-08-10	2015-08-10 00:00:00	2015-08-17	2015-08-17 00:00:00	32020		\N	527	0	10509002	260139		0
313	17	4116491	1994-11-30	1994-11-30 00:00:00	1995-01-09	1995-01-09 00:00:00	32020		\N	1299	0	301011002	4116491		0
10977	648	260139	1944-03-16	1944-03-16 00:00:00	1944-03-30	1944-03-30 00:00:00	32020		\N	42913	0	10509002	260139		0
652	36	260139	1996-04-28	1996-04-28 00:00:00	1996-05-13	1996-05-13 00:00:00	32020		\N	2606	0	10509002	260139		0
793	42	440448	1933-10-29	1933-10-29 00:00:00	\N	\N	32020		\N	3112	0	74400008	440448		0
11512	680	260139	2010-12-16	2010-12-16 00:00:00	2010-12-23	2010-12-23 00:00:00	32020		\N	45077	0	10509002	260139		0
1140	67	260139	1988-10-07	1988-10-07 00:00:00	1988-10-21	1988-10-21 00:00:00	32020		\N	4521	0	10509002	260139		0
1314	78	4112343	1967-02-07	1967-02-07 00:00:00	1967-02-16	1967-02-16 00:00:00	32020		\N	5155	0	195662009	4112343		0
1446	84	40486433	1979-03-20	1979-03-20 00:00:00	\N	\N	32020		\N	5664	0	446096008	40486433		0
12130	719	28060	1992-05-17	1992-05-17 00:00:00	1992-05-28	1992-05-28 00:00:00	32020		\N	47567	0	43878008	28060		0
1789	101	4112343	2003-08-25	2003-08-25 00:00:00	2003-09-07	2003-09-07 00:00:00	32020		\N	6938	0	195662009	4112343		0
1981	116	4152936	2001-03-04	2001-03-04 00:00:00	2001-03-25	2001-03-25 00:00:00	32020		\N	7654	0	283385000	4152936		0
2138	124	40481087	2013-06-12	2013-06-12 00:00:00	2013-06-19	2013-06-19 00:00:00	32020		\N	8284	0	444814009	40481087		0
12813	756	372328	1968-04-04	1968-04-04 00:00:00	1968-07-10	1968-07-10 00:00:00	32020		\N	50143	0	65363002	372328		0
2464	145	28060	1991-08-21	1991-08-21 00:00:00	1991-08-31	1991-08-31 00:00:00	32020		\N	9747	0	43878008	28060		0
2638	154	40481087	2000-07-31	2000-07-31 00:00:00	2000-08-07	2000-08-07 00:00:00	32020		\N	10454	0	444814009	40481087		0
2784	161	40481087	2012-02-11	2012-02-11 00:00:00	2012-02-25	2012-02-25 00:00:00	32020		\N	11029	0	444814009	40481087		0
2970	173	260139	2002-04-06	2002-04-06 00:00:00	2002-04-20	2002-04-20 00:00:00	32020		\N	11742	0	10509002	260139		0
3117	184	4294548	2006-05-05	2006-05-05 00:00:00	2006-07-14	2006-07-14 00:00:00	32020		\N	12434	0	75498004	4294548		0
3261	189	4112343	2003-03-27	2003-03-27 00:00:00	2003-04-03	2003-04-03 00:00:00	32020		\N	12881	0	195662009	4112343		0
3443	196	40481087	2013-07-25	2013-07-25 00:00:00	2013-08-08	2013-08-08 00:00:00	32020		\N	13475	0	444814009	40481087		0
14123	834	372328	1956-08-08	1956-08-08 00:00:00	1956-10-15	1956-10-15 00:00:00	32020		\N	55183	0	65363002	372328		0
3792	219	40481087	1973-02-09	1973-02-09 00:00:00	1973-02-16	1973-02-16 00:00:00	32020		\N	14769	0	444814009	40481087		0
3956	227	4278672	1980-07-01	1980-07-01 00:00:00	1980-09-29	1980-09-29 00:00:00	32020		\N	15306	0	65966004	4278672		0
4129	239	372328	1963-10-21	1963-10-21 00:00:00	1964-01-23	1964-01-23 00:00:00	32020		\N	16020	0	65363002	372328		0
4298	248	375671	1988-06-08	1988-06-08 00:00:00	1988-07-08	1988-07-08 00:00:00	32020		\N	16665	0	62564004	375671		0
14961	882	260139	1987-10-18	1987-10-18 00:00:00	1987-10-25	1987-10-25 00:00:00	32020		\N	58729	0	10509002	260139		0
4620	270	4294548	1964-10-31	1964-10-31 00:00:00	1964-11-07	1964-11-07 00:00:00	32020		\N	18012	0	75498004	4294548		0
4784	280	4329847	2019-05-31	2019-05-31 00:00:00	\N	\N	32020		\N	18709	0	22298006	4329847		0
4959	292	4112343	2015-07-30	2015-07-30 00:00:00	2015-08-08	2015-08-08 00:00:00	32020		\N	19456	0	195662009	4112343		0
5113	299	40481087	1964-05-06	1964-05-06 00:00:00	1964-05-13	1964-05-13 00:00:00	32020		\N	20016	0	444814009	40481087		0
5270	310	4155034	1955-02-17	1955-02-17 00:00:00	1955-03-03	1955-03-03 00:00:00	32020		\N	20495	0	283371005	4155034		0
5464	321	4134304	1966-08-18	1966-08-18 00:00:00	1966-10-17	1966-10-17 00:00:00	32020		\N	21318	0	263102004	4134304		0
5637	332	40481087	1964-05-18	1964-05-18 00:00:00	1964-06-01	1964-06-01 00:00:00	32020		\N	21991	0	444814009	40481087		0
5775	339	40481087	2008-07-06	2008-07-06 00:00:00	2008-07-27	2008-07-27 00:00:00	32020		\N	22609	0	444814009	40481087		0
5943	350	4112343	1971-10-25	1971-10-25 00:00:00	1971-11-06	1971-11-06 00:00:00	32020		\N	23323	0	195662009	4112343		0
6098	358	40481087	1952-11-26	1952-11-26 00:00:00	1952-12-17	1952-12-17 00:00:00	32020		\N	23847	0	444814009	40481087		0
6259	366	4112343	1981-06-14	1981-06-14 00:00:00	1981-06-22	1981-06-22 00:00:00	32020		\N	24276	0	195662009	4112343		0
6423	377	28060	1970-09-18	1970-09-18 00:00:00	1970-09-30	1970-09-30 00:00:00	32020		\N	24955	0	43878008	28060		0
17125	1024	260139	1987-07-21	1987-07-21 00:00:00	1987-08-04	1987-08-04 00:00:00	32020		\N	67400	0	10509002	260139		0
6763	399	4294548	2018-04-22	2018-04-22 00:00:00	2018-05-20	2018-05-20 00:00:00	32020		\N	26261	0	75498004	4294548		0
6935	408	260139	2011-06-03	2011-06-03 00:00:00	2011-06-10	2011-06-10 00:00:00	32020		\N	26992	0	10509002	260139		0
7102	418	260139	1990-10-01	1990-10-01 00:00:00	1990-10-08	1990-10-08 00:00:00	32020		\N	27632	0	10509002	260139		0
17797	1072	4113008	2019-04-20	2019-04-20 00:00:00	2019-05-04	2019-05-04 00:00:00	32020		\N	70289	0	284549007	4113008		0
7440	437	81893	1985-12-29	1985-12-29 00:00:00	\N	\N	32020		\N	29028	0	64766004	81893		0
7599	445	260139	1968-03-15	1968-03-15 00:00:00	1968-03-22	1968-03-22 00:00:00	32020		\N	29606	0	10509002	260139		0
7756	454	260139	1959-06-04	1959-06-04 00:00:00	1959-06-11	1959-06-11 00:00:00	32020		\N	30320	0	10509002	260139		0
7937	462	260139	2009-12-01	2009-12-01 00:00:00	2009-12-08	2009-12-08 00:00:00	32020		\N	30869	0	10509002	260139		0
8123	476	40481087	1970-04-10	1970-04-10 00:00:00	1970-05-01	1970-05-01 00:00:00	32020		\N	31737	0	444814009	40481087		0
8299	484	40481087	1962-06-01	1962-06-01 00:00:00	1962-06-22	1962-06-22 00:00:00	32020		\N	32375	0	444814009	40481087		0
8418	488	4112343	1960-07-31	1960-07-31 00:00:00	1960-08-08	1960-08-08 00:00:00	32020		\N	32672	0	195662009	4112343		0
8604	502	40481087	2011-10-10	2011-10-10 00:00:00	2011-10-17	2011-10-17 00:00:00	32020		\N	33599	0	444814009	40481087		0
8797	515	40481087	2009-11-09	2009-11-09 00:00:00	2009-11-16	2009-11-16 00:00:00	32020		\N	34334	0	444814009	40481087		0
19517	1173	40481087	1984-12-24	1984-12-24 00:00:00	1985-01-14	1985-01-14 00:00:00	32020		\N	77238	0	444814009	40481087		0
19589	1175	372328	1981-07-14	1981-07-14 00:00:00	1982-08-08	1982-08-08 00:00:00	32020		\N	77532	0	65363002	372328		0
19782	1189	40481087	1996-06-26	1996-06-26 00:00:00	1996-07-10	1996-07-10 00:00:00	32020		\N	78318	0	444814009	40481087		0
9458	559	440086	1976-10-19	1976-10-19 00:00:00	1977-06-28	1977-06-28 00:00:00	32020		\N	37075	0	192127007	440086		0
9616	569	81151	1939-09-24	1939-09-24 00:00:00	1939-10-29	1939-10-29 00:00:00	32020		\N	37660	0	44465007	81151		0
9761	578	257012	2018-05-10	2018-05-10 00:00:00	\N	\N	32020		\N	38221	0	40055000	257012		0
20421	1228	40481087	2007-09-15	2007-09-15 00:00:00	2007-09-29	2007-09-29 00:00:00	32020		\N	80877	0	444814009	40481087		0
20598	1237	4152936	1981-09-05	1981-09-05 00:00:00	1981-09-19	1981-09-19 00:00:00	32020		\N	81520	0	283385000	4152936		0
10263	607	4112343	1973-08-24	1973-08-24 00:00:00	1973-09-01	1973-09-01 00:00:00	32020		\N	40325	0	195662009	4112343		0
10419	614	4155034	1986-12-18	1986-12-18 00:00:00	1987-01-08	1987-01-08 00:00:00	32020		\N	40850	0	283371005	4155034		0
21096	1266	40481087	1978-06-15	1978-06-15 00:00:00	1978-06-22	1978-06-22 00:00:00	32020		\N	83482	0	444814009	40481087		0
116	5	260139	2012-10-16	2012-10-16 00:00:00	2012-10-23	2012-10-23 00:00:00	32020		\N	525	0	10509002	260139		0
314	17	40481087	1974-09-16	1974-09-16 00:00:00	1974-09-23	1974-09-23 00:00:00	32020		\N	1324	0	444814009	40481087		0
10978	648	4112343	2006-12-03	2006-12-03 00:00:00	2006-12-13	2006-12-13 00:00:00	32020		\N	42906	0	195662009	4112343		0
653	36	375671	1982-10-29	1982-10-29 00:00:00	1982-12-28	1982-12-28 00:00:00	32020		\N	2610	0	62564004	375671		0
794	42	40481087	2008-02-22	2008-02-22 00:00:00	2008-02-29	2008-02-29 00:00:00	32020		\N	3137	0	444814009	40481087		0
11513	680	81151	1971-03-22	1971-03-22 00:00:00	1971-04-05	1971-04-05 00:00:00	32020		\N	45091	0	44465007	81151		0
1141	67	4112343	1975-02-12	1975-02-12 00:00:00	1975-02-23	1975-02-23 00:00:00	32020		\N	4564	0	195662009	4112343		0
1315	78	40481087	2004-03-27	2004-03-27 00:00:00	2004-04-03	2004-04-03 00:00:00	32020		\N	5205	0	444814009	40481087		0
1447	84	4283893	2013-09-15	2013-09-15 00:00:00	2013-12-08	2013-12-08 00:00:00	32020		\N	5658	0	36971009	4283893		0
12131	719	4112343	2017-12-06	2017-12-06 00:00:00	2017-12-19	2017-12-19 00:00:00	32020		\N	47606	0	195662009	4112343		0
1790	101	4112343	1940-11-22	1940-11-22 00:00:00	1940-12-03	1940-12-03 00:00:00	32020		\N	6834	0	195662009	4112343		0
1982	116	4112343	1989-11-11	1989-11-11 00:00:00	1989-11-19	1989-11-19 00:00:00	32020		\N	7679	0	195662009	4112343		0
2139	124	40481087	2004-02-10	2004-02-10 00:00:00	2004-02-24	2004-02-24 00:00:00	32020		\N	8278	0	444814009	40481087		0
12814	756	4278672	1972-12-25	1972-12-25 00:00:00	1973-01-24	1973-01-24 00:00:00	32020		\N	50171	0	65966004	4278672		0
2465	145	4112343	1951-12-19	1951-12-19 00:00:00	1951-12-29	1951-12-29 00:00:00	32020		\N	9713	0	195662009	4112343		0
2639	154	4112343	1989-01-20	1989-01-20 00:00:00	1989-01-29	1989-01-29 00:00:00	32020		\N	10499	0	195662009	4112343		0
2785	161	372328	1991-05-16	1991-05-16 00:00:00	1991-12-29	1991-12-29 00:00:00	32020		\N	11033	0	65363002	372328		0
2971	173	4112343	1996-06-19	1996-06-19 00:00:00	1996-06-28	1996-06-28 00:00:00	32020		\N	11769	0	195662009	4112343		0
3118	184	4152936	2017-10-03	2017-10-03 00:00:00	2017-10-17	2017-10-17 00:00:00	32020		\N	12505	0	283385000	4152936		0
3262	189	4155034	1984-11-20	1984-11-20 00:00:00	1984-12-11	1984-12-11 00:00:00	32020		\N	12889	0	283371005	4155034		0
3444	196	260139	2008-08-31	2008-08-31 00:00:00	2008-09-14	2008-09-14 00:00:00	32020		\N	13520	0	10509002	260139		0
14124	834	4294548	1992-03-20	1992-03-20 00:00:00	1992-06-05	1992-06-05 00:00:00	32020		\N	55241	0	75498004	4294548		0
3793	219	4112343	1997-06-11	1997-06-11 00:00:00	1997-06-20	1997-06-20 00:00:00	32020		\N	14736	0	195662009	4112343		0
3957	227	4112343	2008-10-17	2008-10-17 00:00:00	2008-10-28	2008-10-28 00:00:00	32020		\N	15328	0	195662009	4112343		0
4130	239	81893	1990-08-05	1990-08-05 00:00:00	\N	\N	32020		\N	16047	0	64766004	81893		0
4299	248	40481087	1997-11-13	1997-11-13 00:00:00	1997-11-27	1997-11-27 00:00:00	32020		\N	16689	0	444814009	40481087		0
14962	882	40481087	1976-04-29	1976-04-29 00:00:00	1976-05-13	1976-05-13 00:00:00	32020		\N	58759	0	444814009	40481087		0
4621	270	4112343	2019-03-07	2019-03-07 00:00:00	2019-03-16	2019-03-16 00:00:00	32020		\N	17957	0	195662009	4112343		0
5974	351	80180	2018-06-07	2018-06-07 00:00:00	\N	\N	32020		\N	23348	0	396275006	80180		0
4786	280	78272	1976-06-24	1976-06-24 00:00:00	1976-07-22	1976-07-22 00:00:00	32020		\N	18705	0	70704007	78272		0
4960	292	375671	1980-01-21	1980-01-21 00:00:00	1980-02-20	1980-02-20 00:00:00	32020		\N	19458	0	62564004	375671		0
5114	299	40481087	1983-11-24	1983-11-24 00:00:00	1983-12-15	1983-12-15 00:00:00	32020		\N	20025	0	444814009	40481087		0
5271	310	40481087	1989-02-23	1989-02-23 00:00:00	1989-03-02	1989-03-02 00:00:00	32020		\N	20507	0	444814009	40481087		0
5465	321	4152936	1967-11-11	1967-11-11 00:00:00	1967-11-25	1967-11-25 00:00:00	32020		\N	21319	0	283385000	4152936		0
5638	332	260139	1993-12-29	1993-12-29 00:00:00	1994-01-12	1994-01-12 00:00:00	32020		\N	21921	0	10509002	260139		0
5776	339	372328	1984-10-02	1984-10-02 00:00:00	1985-01-19	1985-01-19 00:00:00	32020		\N	22611	0	65363002	372328		0
5944	350	317576	1991-11-08	1991-11-08 00:00:00	\N	\N	32020		\N	23322	0	53741008	317576		0
6099	358	40481087	1980-06-19	1980-06-19 00:00:00	1980-07-10	1980-07-10 00:00:00	32020		\N	23852	0	444814009	40481087		0
6260	366	40481087	1948-11-06	1948-11-06 00:00:00	1948-11-20	1948-11-20 00:00:00	32020		\N	24382	0	444814009	40481087		0
6424	377	40481087	2013-09-10	2013-09-10 00:00:00	2013-09-24	2013-09-24 00:00:00	32020		\N	25022	0	444814009	40481087		0
17126	1024	260139	1981-12-17	1981-12-17 00:00:00	1981-12-24	1981-12-24 00:00:00	32020		\N	67469	0	10509002	260139		0
6764	399	40481087	2014-05-28	2014-05-28 00:00:00	2014-06-04	2014-06-04 00:00:00	32020		\N	26127	0	444814009	40481087		0
6936	408	4112343	1991-08-24	1991-08-24 00:00:00	1991-09-04	1991-09-04 00:00:00	32020		\N	26988	0	195662009	4112343		0
7103	418	40481087	2010-05-11	2010-05-11 00:00:00	2010-05-25	2010-05-25 00:00:00	32020		\N	27635	0	444814009	40481087		0
17798	1072	257012	2016-01-31	2016-01-31 00:00:00	\N	\N	32020		\N	70280	0	40055000	257012		0
7441	437	40481087	1987-12-27	1987-12-27 00:00:00	1988-01-10	1988-01-10 00:00:00	32020		\N	28992	0	444814009	40481087		0
7600	445	4112343	1993-09-29	1993-09-29 00:00:00	1993-10-08	1993-10-08 00:00:00	32020		\N	29627	0	195662009	4112343		0
7757	454	40481087	2013-01-29	2013-01-29 00:00:00	2013-02-12	2013-02-12 00:00:00	32020		\N	30287	0	444814009	40481087		0
7942	464	40481087	1983-04-26	1983-04-26 00:00:00	1983-05-03	1983-05-03 00:00:00	32020		\N	30982	0	444814009	40481087		0
8124	476	40481087	2007-12-21	2007-12-21 00:00:00	2007-12-28	2007-12-28 00:00:00	32020		\N	31749	0	444814009	40481087		0
8300	484	260139	1976-06-12	1976-06-12 00:00:00	1976-06-26	1976-06-26 00:00:00	32020		\N	32378	0	10509002	260139		0
8419	489	4146173	2008-03-21	2008-03-21 00:00:00	2008-04-20	2008-04-20 00:00:00	32020		\N	32804	0	307731004	4146173		0
8605	502	40481087	1959-09-04	1959-09-04 00:00:00	1959-09-25	1959-09-25 00:00:00	32020		\N	33610	0	444814009	40481087		0
8798	515	40481087	2016-04-20	2016-04-20 00:00:00	2016-04-27	2016-04-27 00:00:00	32020		\N	34417	0	444814009	40481087		0
19518	1173	40481087	1994-10-19	1994-10-19 00:00:00	1994-11-02	1994-11-02 00:00:00	32020		\N	77208	0	444814009	40481087		0
19590	1175	260139	1953-09-20	1953-09-20 00:00:00	1953-09-27	1953-09-27 00:00:00	32020		\N	77415	0	10509002	260139		0
19783	1189	4112343	2001-12-28	2001-12-28 00:00:00	2002-01-05	2002-01-05 00:00:00	32020		\N	78319	0	195662009	4112343		0
9459	559	260139	1969-06-19	1969-06-19 00:00:00	1969-07-03	1969-07-03 00:00:00	32020		\N	37050	0	10509002	260139		0
9617	569	4112343	2017-10-01	2017-10-01 00:00:00	2017-10-12	2017-10-12 00:00:00	32020		\N	37592	0	195662009	4112343		0
9762	578	40481087	2010-11-06	2010-11-06 00:00:00	2010-11-20	2010-11-20 00:00:00	32020		\N	38254	0	444814009	40481087		0
20422	1228	257012	2008-06-15	2008-06-15 00:00:00	\N	\N	32020		\N	80930	0	40055000	257012		0
20599	1237	260139	1971-01-11	1971-01-11 00:00:00	1971-01-18	1971-01-18 00:00:00	32020		\N	81545	0	10509002	260139		0
10264	607	40481087	1978-02-04	1978-02-04 00:00:00	1978-02-25	1978-02-25 00:00:00	32020		\N	40338	0	444814009	40481087		0
10420	614	378001	2000-03-28	2000-03-28 00:00:00	2000-04-27	2000-04-27 00:00:00	32020		\N	40853	0	62106007	378001		0
21097	1266	4134304	1971-03-19	1971-03-19 00:00:00	1971-04-18	1971-04-18 00:00:00	32020		\N	83453	0	263102004	4134304		0
117	5	260139	1974-05-11	1974-05-11 00:00:00	1974-05-18	1974-05-18 00:00:00	32020		\N	477	0	10509002	260139		0
315	17	28060	1960-02-08	1960-02-08 00:00:00	1960-02-20	1960-02-20 00:00:00	32020		\N	1321	0	43878008	28060		0
10979	648	28060	2018-05-02	2018-05-02 00:00:00	2018-05-15	2018-05-15 00:00:00	32020		\N	42955	0	43878008	28060		0
654	36	4294548	2010-10-25	2010-10-25 00:00:00	2010-11-29	2010-11-29 00:00:00	32020		\N	2542	0	75498004	4294548		0
795	42	257012	1969-12-05	1969-12-05 00:00:00	\N	\N	32020		\N	3065	0	40055000	257012		0
11514	680	28060	1994-05-17	1994-05-17 00:00:00	1994-05-30	1994-05-30 00:00:00	32020		\N	45041	0	43878008	28060		0
1142	67	28060	2017-07-12	2017-07-12 00:00:00	2017-07-22	2017-07-22 00:00:00	32020		\N	4528	0	43878008	28060		0
1316	78	4112343	1997-10-20	1997-10-20 00:00:00	1997-10-28	1997-10-28 00:00:00	32020		\N	5179	0	195662009	4112343		0
1448	84	28060	1974-11-10	1974-11-10 00:00:00	1974-11-21	1974-11-21 00:00:00	32020		\N	5650	0	43878008	28060		0
12132	719	40481087	2004-11-12	2004-11-12 00:00:00	2004-12-03	2004-12-03 00:00:00	32020		\N	47605	0	444814009	40481087		0
1791	101	40481087	1931-08-01	1931-08-01 00:00:00	1931-08-22	1931-08-22 00:00:00	32020		\N	6904	0	444814009	40481087		0
1983	116	260139	1980-01-25	1980-01-25 00:00:00	1980-02-01	1980-02-01 00:00:00	32020		\N	7678	0	10509002	260139		0
2140	124	80180	2016-12-17	2016-12-17 00:00:00	\N	\N	32020		\N	8230	0	396275006	80180		0
12815	756	40481087	1990-01-21	1990-01-21 00:00:00	1990-02-04	1990-02-04 00:00:00	32020		\N	50155	0	444814009	40481087		0
2466	145	372328	1953-04-01	1953-04-01 00:00:00	1953-11-10	1953-11-10 00:00:00	32020		\N	9776	0	65363002	372328		0
2640	154	260139	1985-03-29	1985-03-29 00:00:00	1985-04-05	1985-04-05 00:00:00	32020		\N	10495	0	10509002	260139		0
2786	161	4142905	1990-07-20	1990-07-20 00:00:00	1990-10-18	1990-10-18 00:00:00	32020		\N	11056	0	33737001	4142905		0
2972	173	40481087	1995-09-05	1995-09-05 00:00:00	1995-09-19	1995-09-19 00:00:00	32020		\N	11765	0	444814009	40481087		0
3119	184	40481087	1953-05-28	1953-05-28 00:00:00	1953-06-11	1953-06-11 00:00:00	32020		\N	12471	0	444814009	40481087		0
3263	189	80180	1992-03-18	1992-03-18 00:00:00	\N	\N	32020		\N	12867	0	396275006	80180		0
3445	196	40481087	2007-09-19	2007-09-19 00:00:00	2007-09-26	2007-09-26 00:00:00	32020		\N	13519	0	444814009	40481087		0
14125	834	4112343	1977-12-14	1977-12-14 00:00:00	1977-12-22	1977-12-22 00:00:00	32020		\N	55239	0	195662009	4112343		0
3794	219	4278672	1985-06-18	1985-06-18 00:00:00	1985-07-18	1985-07-18 00:00:00	32020		\N	14756	0	65966004	4278672		0
3958	227	40481087	1972-03-20	1972-03-20 00:00:00	1972-03-27	1972-03-27 00:00:00	32020		\N	15315	0	444814009	40481087		0
4131	239	4310024	1989-09-09	1989-09-09 00:00:00	\N	\N	32020		\N	16047	0	424802006	4310024		0
4300	248	4134304	1982-11-07	1982-11-07 00:00:00	1982-12-07	1982-12-07 00:00:00	32020		\N	16664	0	263102004	4134304		0
14963	882	260139	2018-09-03	2018-09-03 00:00:00	2018-09-17	2018-09-17 00:00:00	32020		\N	58761	0	10509002	260139		0
4622	270	260139	1990-06-27	1990-06-27 00:00:00	1990-07-04	1990-07-04 00:00:00	32020		\N	17959	0	10509002	260139		0
4787	280	317576	2015-02-27	2015-02-27 00:00:00	\N	\N	32020		\N	18701	0	53741008	317576		0
4961	292	260139	1985-01-26	1985-01-26 00:00:00	1985-02-09	1985-02-09 00:00:00	32020		\N	19469	0	10509002	260139		0
5115	299	261325	2013-12-21	2013-12-21 00:00:00	\N	\N	32020		\N	19991	0	87433001	261325		0
5272	310	260139	1972-09-08	1972-09-08 00:00:00	1972-09-15	1972-09-15 00:00:00	32020		\N	20504	0	10509002	260139		0
5466	321	40481087	1991-08-19	1991-08-19 00:00:00	1991-08-26	1991-08-26 00:00:00	32020		\N	21257	0	444814009	40481087		0
5639	332	4084167	1979-09-18	1979-09-18 00:00:00	1979-09-18	1979-09-18 00:00:00	32020		\N	21908	0	241929008	4084167		0
5777	339	4112343	2002-11-08	2002-11-08 00:00:00	2002-11-18	2002-11-18 00:00:00	32020		\N	22624	0	195662009	4112343		0
5945	350	4112343	2017-05-10	2017-05-10 00:00:00	2017-05-22	2017-05-22 00:00:00	32020		\N	23313	0	195662009	4112343		0
6100	358	40481087	1971-06-10	1971-06-10 00:00:00	1971-07-01	1971-07-01 00:00:00	32020		\N	23851	0	444814009	40481087		0
6261	366	260139	1949-05-31	1949-05-31 00:00:00	1949-06-07	1949-06-07 00:00:00	32020		\N	24383	0	10509002	260139		0
6425	377	78272	1971-10-09	1971-10-09 00:00:00	1971-11-13	1971-11-13 00:00:00	32020		\N	24964	0	70704007	78272		0
17127	1024	4134304	1952-02-02	1952-02-02 00:00:00	1952-03-03	1952-03-03 00:00:00	32020		\N	67436	0	263102004	4134304		0
6765	399	81151	1960-01-07	1960-01-07 00:00:00	1960-02-11	1960-02-11 00:00:00	32020		\N	26233	0	44465007	81151		0
6937	408	260139	2003-04-27	2003-04-27 00:00:00	2003-05-04	2003-05-04 00:00:00	32020		\N	26990	0	10509002	260139		0
7104	418	81151	1971-08-23	1971-08-23 00:00:00	1971-09-13	1971-09-13 00:00:00	32020		\N	27672	0	44465007	81151		0
17799	1072	4112343	2003-12-25	2003-12-25 00:00:00	2004-01-06	2004-01-06 00:00:00	32020		\N	70244	0	195662009	4112343		0
7442	437	40481087	1981-11-03	1981-11-03 00:00:00	1981-11-10	1981-11-10 00:00:00	32020		\N	29027	0	444814009	40481087		0
7601	445	40481087	1975-03-10	1975-03-10 00:00:00	1975-03-31	1975-03-31 00:00:00	32020		\N	29607	0	444814009	40481087		0
7758	454	4266809	1970-09-09	1970-09-09 00:00:00	\N	\N	32020		\N	30266	0	397881000	4266809		0
7943	464	40481087	1996-01-03	1996-01-03 00:00:00	1996-01-10	1996-01-10 00:00:00	32020		\N	30983	0	444814009	40481087		0
8125	476	4112343	1968-06-14	1968-06-14 00:00:00	1968-06-23	1968-06-23 00:00:00	32020		\N	31747	0	195662009	4112343		0
18759	1128	372328	1970-05-17	1970-05-17 00:00:00	1970-07-03	1970-07-03 00:00:00	32020		\N	74334	0	65363002	372328		0
8420	489	4112343	2010-06-28	2010-06-28 00:00:00	2010-07-06	2010-07-06 00:00:00	32020		\N	32805	0	195662009	4112343		0
8606	502	372328	1977-02-02	1977-02-02 00:00:00	1978-06-24	1978-06-24 00:00:00	32020		\N	33614	0	65363002	372328		0
19257	1154	40481087	2002-10-05	2002-10-05 00:00:00	2002-10-19	2002-10-19 00:00:00	32020		\N	76219	0	444814009	40481087		0
19519	1173	40481087	2006-03-19	2006-03-19 00:00:00	2006-04-02	2006-04-02 00:00:00	32020		\N	77270	0	444814009	40481087		0
19591	1175	372328	1943-06-02	1943-06-02 00:00:00	1943-07-04	1943-07-04 00:00:00	32020		\N	77543	0	65363002	372328		0
19784	1189	40481087	1974-05-18	1974-05-18 00:00:00	1974-06-08	1974-06-08 00:00:00	32020		\N	78315	0	444814009	40481087		0
9460	559	28060	2009-06-30	2009-06-30 00:00:00	2009-07-12	2009-07-12 00:00:00	32020		\N	37057	0	43878008	28060		0
9618	569	260139	2012-03-31	2012-03-31 00:00:00	2012-04-07	2012-04-07 00:00:00	32020		\N	37586	0	10509002	260139		0
9763	578	78272	2001-12-19	2001-12-19 00:00:00	2002-01-16	2002-01-16 00:00:00	32020		\N	38259	0	70704007	78272		0
20423	1228	260139	1989-03-06	1989-03-06 00:00:00	1989-03-20	1989-03-20 00:00:00	32020		\N	80918	0	10509002	260139		0
20600	1237	260139	1979-07-15	1979-07-15 00:00:00	1979-07-29	1979-07-29 00:00:00	32020		\N	81523	0	10509002	260139		0
10265	607	260139	2018-01-26	2018-01-26 00:00:00	2018-02-09	2018-02-09 00:00:00	32020		\N	40271	0	10509002	260139		0
10421	614	40481087	1971-05-01	1971-05-01 00:00:00	1971-05-15	1971-05-15 00:00:00	32020		\N	40819	0	444814009	40481087		0
21098	1266	257012	1980-02-02	1980-02-02 00:00:00	\N	\N	32020		\N	83484	0	40055000	257012		0
118	5	257012	1991-12-12	1991-12-12 00:00:00	\N	\N	32020		\N	422	0	40055000	257012		0
316	17	4112343	1958-11-30	1958-11-30 00:00:00	1958-12-11	1958-12-11 00:00:00	32020		\N	1285	0	195662009	4112343		0
10980	648	4059173	2007-07-26	2007-07-26 00:00:00	2007-10-24	2007-10-24 00:00:00	32020		\N	42967	0	16114001	4059173		0
655	36	257012	2010-11-22	2010-11-22 00:00:00	\N	\N	32020		\N	2633	0	40055000	257012		0
796	42	4218389	1935-09-08	1935-09-08 00:00:00	1935-10-06	1935-10-06 00:00:00	32020		\N	3105	0	39848009	4218389		0
11515	680	4112343	1999-07-21	1999-07-21 00:00:00	1999-08-01	1999-08-01 00:00:00	32020		\N	45082	0	195662009	4112343		0
1143	67	40481087	2004-09-07	2004-09-07 00:00:00	2004-09-14	2004-09-14 00:00:00	32020		\N	4527	0	444814009	40481087		0
1317	78	4237458	1978-09-25	1978-09-25 00:00:00	1978-11-24	1978-11-24 00:00:00	32020		\N	5163	0	58150001	4237458		0
1449	84	80180	2014-03-29	2014-03-29 00:00:00	\N	\N	32020		\N	5705	0	396275006	80180		0
12133	719	372328	1982-06-07	1982-06-07 00:00:00	1982-10-22	1982-10-22 00:00:00	32020		\N	47572	0	65363002	372328		0
1792	101	260139	1945-06-01	1945-06-01 00:00:00	1945-06-08	1945-06-08 00:00:00	32020		\N	6933	0	10509002	260139		0
1984	116	372328	1927-07-05	1927-07-05 00:00:00	1927-10-16	1927-10-16 00:00:00	32020		\N	7667	0	65363002	372328		0
2141	124	133834	1987-12-22	1987-12-22 00:00:00	\N	\N	32020		\N	8323	0	24079001	133834		0
12816	756	40481087	1987-06-21	1987-06-21 00:00:00	1987-06-28	1987-06-28 00:00:00	32020		\N	50154	0	444814009	40481087		0
2467	145	4149245	1981-07-06	1981-07-06 00:00:00	1981-08-05	1981-08-05 00:00:00	32020		\N	9800	0	30832001	4149245		0
2641	154	260139	2017-07-15	2017-07-15 00:00:00	2017-07-22	2017-07-22 00:00:00	32020		\N	10473	0	10509002	260139		0
2787	161	260139	1978-02-24	1978-02-24 00:00:00	1978-03-10	1978-03-10 00:00:00	32020		\N	11045	0	10509002	260139		0
2973	173	260139	2001-02-02	2001-02-02 00:00:00	2001-02-09	2001-02-09 00:00:00	32020		\N	11741	0	10509002	260139		0
3120	184	80180	1987-01-03	1987-01-03 00:00:00	\N	\N	32020		\N	12467	0	396275006	80180		0
3264	189	440086	1972-05-07	1972-05-07 00:00:00	1976-05-16	1976-05-16 00:00:00	32020		\N	12892	0	192127007	440086		0
3446	196	4112343	1997-12-14	1997-12-14 00:00:00	1997-12-27	1997-12-27 00:00:00	32020		\N	13446	0	195662009	4112343		0
14126	834	81151	1967-09-15	1967-09-15 00:00:00	1967-10-20	1967-10-20 00:00:00	32020		\N	55249	0	44465007	81151		0
3795	219	40481087	1988-01-05	1988-01-05 00:00:00	1988-01-26	1988-01-26 00:00:00	32020		\N	14770	0	444814009	40481087		0
3959	227	4112343	2003-07-25	2003-07-25 00:00:00	2003-08-01	2003-08-01 00:00:00	32020		\N	15367	0	195662009	4112343		0
4132	239	81151	1963-12-25	1963-12-25 00:00:00	1964-01-08	1964-01-08 00:00:00	32020		\N	16050	0	44465007	81151		0
4301	248	4112343	2013-01-16	2013-01-16 00:00:00	2013-01-24	2013-01-24 00:00:00	32020		\N	16681	0	195662009	4112343		0
14964	882	40481087	1966-10-04	1966-10-04 00:00:00	1966-10-18	1966-10-18 00:00:00	32020		\N	58676	0	444814009	40481087		0
4623	270	4310024	1993-06-25	1993-06-25 00:00:00	\N	\N	32020		\N	17959	0	424802006	4310024		0
4788	280	4294548	1980-01-02	1980-01-02 00:00:00	1980-03-26	1980-03-26 00:00:00	32020		\N	18687	0	75498004	4294548		0
4962	292	40481087	2012-04-29	2012-04-29 00:00:00	2012-05-06	2012-05-06 00:00:00	32020		\N	19459	0	444814009	40481087		0
5116	300	81151	2004-02-05	2004-02-05 00:00:00	2004-03-04	2004-03-04 00:00:00	32020		\N	20040	0	44465007	81151		0
5273	311	4112343	2016-07-22	2016-07-22 00:00:00	2016-08-02	2016-08-02 00:00:00	32020		\N	20619	0	195662009	4112343		0
5467	321	372328	1962-05-11	1962-05-11 00:00:00	1962-07-22	1962-07-22 00:00:00	32020		\N	21278	0	65363002	372328		0
16103	951	28060	2004-11-02	2004-11-02 00:00:00	2004-11-13	2004-11-13 00:00:00	32020		\N	63212	0	43878008	28060		0
5778	339	372328	1985-09-16	1985-09-16 00:00:00	1986-01-18	1986-01-18 00:00:00	32020		\N	22627	0	65363002	372328		0
5946	350	40481087	2006-06-06	2006-06-06 00:00:00	2006-06-27	2006-06-27 00:00:00	32020		\N	23302	0	444814009	40481087		0
6101	358	28060	2009-03-23	2009-03-23 00:00:00	2009-04-03	2009-04-03 00:00:00	32020		\N	23854	0	43878008	28060		0
6262	366	40481087	1952-02-08	1952-02-08 00:00:00	1952-02-22	1952-02-22 00:00:00	32020		\N	24384	0	444814009	40481087		0
6426	377	4112343	1999-04-04	1999-04-04 00:00:00	1999-04-14	1999-04-14 00:00:00	32020		\N	25020	0	195662009	4112343		0
17128	1024	28060	1999-01-30	1999-01-30 00:00:00	1999-02-11	1999-02-11 00:00:00	32020		\N	67476	0	43878008	28060		0
6766	399	40481087	1977-04-02	1977-04-02 00:00:00	1977-04-23	1977-04-23 00:00:00	32020		\N	26174	0	444814009	40481087		0
6938	408	260139	1994-06-16	1994-06-16 00:00:00	1994-06-30	1994-06-30 00:00:00	32020		\N	26928	0	10509002	260139		0
7105	418	4112343	2011-07-30	2011-07-30 00:00:00	2011-08-11	2011-08-11 00:00:00	32020		\N	27615	0	195662009	4112343		0
17800	1072	28060	1987-07-22	1987-07-22 00:00:00	1987-07-29	1987-07-29 00:00:00	32020		\N	70250	0	43878008	28060		0
7443	437	40481087	1983-06-09	1983-06-09 00:00:00	1983-06-23	1983-06-23 00:00:00	32020		\N	29012	0	444814009	40481087		0
7602	445	4266809	1953-11-30	1953-11-30 00:00:00	\N	\N	32020		\N	29586	0	397881000	4266809		0
7759	454	30753	1970-01-12	1970-01-12 00:00:00	\N	\N	32020		\N	30266	0	16761005	30753		0
7944	464	40481087	2008-06-10	2008-06-10 00:00:00	2008-06-17	2008-06-17 00:00:00	32020		\N	30990	0	444814009	40481087		0
8126	476	260139	1977-05-28	1977-05-28 00:00:00	1977-06-11	1977-06-11 00:00:00	32020		\N	31735	0	10509002	260139		0
18760	1128	81151	2016-03-16	2016-03-16 00:00:00	2016-04-13	2016-04-13 00:00:00	32020		\N	74346	0	44465007	81151		0
8421	489	4237458	1999-09-07	1999-09-07 00:00:00	1999-10-07	1999-10-07 00:00:00	32020		\N	32705	0	58150001	4237458		0
8607	502	4112343	2007-08-24	2007-08-24 00:00:00	2007-09-04	2007-09-04 00:00:00	32020		\N	33586	0	195662009	4112343		0
19258	1154	40481087	2019-02-02	2019-02-02 00:00:00	2019-02-16	2019-02-16 00:00:00	32020		\N	76222	0	444814009	40481087		0
19520	1173	40481087	1952-11-05	1952-11-05 00:00:00	1952-11-12	1952-11-12 00:00:00	32020		\N	77220	0	444814009	40481087		0
19592	1175	440086	1953-07-25	1953-07-25 00:00:00	1953-12-26	1953-12-26 00:00:00	32020		\N	77548	0	192127007	440086		0
19785	1189	80180	2005-05-10	2005-05-10 00:00:00	\N	\N	32020		\N	78320	0	396275006	80180		0
9461	559	4152936	1974-02-22	1974-02-22 00:00:00	1974-03-15	1974-03-15 00:00:00	32020		\N	37096	0	283385000	4152936		0
9619	569	4155034	1949-02-08	1949-02-08 00:00:00	1949-03-01	1949-03-01 00:00:00	32020		\N	37661	0	283371005	4155034		0
9764	578	81151	1979-10-25	1979-10-25 00:00:00	1979-11-15	1979-11-15 00:00:00	32020		\N	38195	0	44465007	81151		0
20424	1228	40481087	2019-01-05	2019-01-05 00:00:00	2019-01-26	2019-01-26 00:00:00	32020		\N	80904	0	444814009	40481087		0
20601	1237	4112343	1948-12-17	1948-12-17 00:00:00	1948-12-25	1948-12-25 00:00:00	32020		\N	81511	0	195662009	4112343		0
10266	607	260139	1977-11-04	1977-11-04 00:00:00	1977-11-11	1977-11-11 00:00:00	32020		\N	40326	0	10509002	260139		0
10422	614	78272	1992-05-11	1992-05-11 00:00:00	1992-06-08	1992-06-08 00:00:00	32020		\N	40852	0	70704007	78272		0
21099	1266	40481087	1983-04-22	1983-04-22 00:00:00	1983-05-13	1983-05-13 00:00:00	32020		\N	83433	0	444814009	40481087		0
119	5	260139	2003-09-10	2003-09-10 00:00:00	2003-09-17	2003-09-17 00:00:00	32020		\N	506	0	10509002	260139		0
317	17	372328	1951-04-10	1951-04-10 00:00:00	1951-05-21	1951-05-21 00:00:00	32020		\N	1311	0	65363002	372328		0
10981	648	4294548	1933-03-24	1933-03-24 00:00:00	1933-04-21	1933-04-21 00:00:00	32020		\N	42912	0	75498004	4294548		0
656	36	372328	1963-07-20	1963-07-20 00:00:00	1963-10-01	1963-10-01 00:00:00	32020		\N	2635	0	65363002	372328		0
797	42	260139	2006-03-04	2006-03-04 00:00:00	2006-03-11	2006-03-11 00:00:00	32020		\N	3136	0	10509002	260139		0
11516	680	40481087	1980-07-25	1980-07-25 00:00:00	1980-08-01	1980-08-01 00:00:00	32020		\N	45002	0	444814009	40481087		0
1144	67	378001	1980-07-27	1980-07-27 00:00:00	1980-08-26	1980-08-26 00:00:00	32020		\N	4569	0	62106007	378001		0
1318	78	40481087	2002-02-24	2002-02-24 00:00:00	2002-03-03	2002-03-03 00:00:00	32020		\N	5166	0	444814009	40481087		0
1450	84	4112343	1984-06-19	1984-06-19 00:00:00	1984-06-27	1984-06-27 00:00:00	32020		\N	5667	0	195662009	4112343		0
12134	719	4116491	2003-11-09	2003-11-09 00:00:00	2004-01-01	2004-01-01 00:00:00	32020		\N	47604	0	301011002	4116491		0
1793	101	4029498	1986-11-04	1986-11-04 00:00:00	\N	\N	32020		\N	6899	0	128613002	4029498		0
1985	116	260139	1994-11-27	1994-11-27 00:00:00	1994-12-11	1994-12-11 00:00:00	32020		\N	7657	0	10509002	260139		0
2142	124	4112343	1997-09-12	1997-09-12 00:00:00	1997-09-25	1997-09-25 00:00:00	32020		\N	8322	0	195662009	4112343		0
12817	756	372328	1985-04-12	1985-04-12 00:00:00	1985-04-26	1985-04-26 00:00:00	32020		\N	50109	0	65363002	372328		0
2468	145	4237458	2003-05-17	2003-05-17 00:00:00	2003-08-15	2003-08-15 00:00:00	32020		\N	9805	0	58150001	4237458		0
2642	154	260139	1990-01-14	1990-01-14 00:00:00	1990-01-28	1990-01-28 00:00:00	32020		\N	10472	0	10509002	260139		0
2788	161	260139	2016-01-19	2016-01-19 00:00:00	2016-01-26	2016-01-26 00:00:00	32020		\N	11048	0	10509002	260139		0
2974	173	80180	2003-07-04	2003-07-04 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
3121	184	28060	1949-04-14	1949-04-14 00:00:00	1949-04-27	1949-04-27 00:00:00	32020		\N	12428	0	43878008	28060		0
3265	189	372328	1961-11-05	1961-11-05 00:00:00	1962-04-15	1962-04-15 00:00:00	32020		\N	12882	0	65363002	372328		0
3447	196	4112343	2009-01-30	2009-01-30 00:00:00	2009-02-07	2009-02-07 00:00:00	32020		\N	13447	0	195662009	4112343		0
14127	834	40481087	1957-08-08	1957-08-08 00:00:00	1957-08-22	1957-08-22 00:00:00	32020		\N	55210	0	444814009	40481087		0
3796	219	4029498	1974-03-29	1974-03-29 00:00:00	\N	\N	32020		\N	14749	0	128613002	4029498		0
3960	227	375671	1979-05-08	1979-05-08 00:00:00	1979-06-07	1979-06-07 00:00:00	32020		\N	15305	0	62564004	375671		0
4133	239	4237458	2012-03-01	2012-03-01 00:00:00	2012-04-30	2012-04-30 00:00:00	32020		\N	16053	0	58150001	4237458		0
4302	248	4059173	2009-05-19	2009-05-19 00:00:00	2009-06-18	2009-06-18 00:00:00	32020		\N	16667	0	16114001	4059173		0
14965	882	260139	1975-03-17	1975-03-17 00:00:00	1975-03-24	1975-03-24 00:00:00	32020		\N	58726	0	10509002	260139		0
4624	270	4027663	1985-01-28	1985-01-28 00:00:00	\N	\N	32020		\N	17953	0	13200003	4027663		0
4789	280	40481087	1984-07-21	1984-07-21 00:00:00	1984-08-04	1984-08-04 00:00:00	32020		\N	18713	0	444814009	40481087		0
4963	292	4112343	1984-08-28	1984-08-28 00:00:00	1984-09-08	1984-09-08 00:00:00	32020		\N	19468	0	195662009	4112343		0
5117	300	260139	1973-02-19	1973-02-19 00:00:00	1973-03-05	1973-03-05 00:00:00	32020		\N	20070	0	10509002	260139		0
5274	311	40481087	2007-12-22	2007-12-22 00:00:00	2008-01-05	2008-01-05 00:00:00	32020		\N	20587	0	444814009	40481087		0
5468	321	40481087	1990-05-06	1990-05-06 00:00:00	1990-05-20	1990-05-20 00:00:00	32020		\N	21306	0	444814009	40481087		0
16104	951	192671	1985-11-07	1985-11-07 00:00:00	\N	\N	32020		\N	63225	0	K92.2	35208414		0
5779	339	4294548	2017-09-04	2017-09-04 00:00:00	2017-10-16	2017-10-16 00:00:00	32020		\N	22625	0	75498004	4294548		0
5947	350	4112343	1991-11-03	1991-11-03 00:00:00	1991-11-10	1991-11-10 00:00:00	32020		\N	23332	0	195662009	4112343		0
6102	358	4112343	1960-12-27	1960-12-27 00:00:00	1961-01-03	1961-01-03 00:00:00	32020		\N	23848	0	195662009	4112343		0
6268	368	28060	2008-04-30	2008-04-30 00:00:00	2008-05-07	2008-05-07 00:00:00	32020		\N	24516	0	43878008	28060		0
6427	377	4296205	1974-08-29	1974-08-29 00:00:00	1974-09-19	1974-09-19 00:00:00	32020		\N	24965	0	403191005	4296205		0
17129	1024	4059173	2012-08-16	2012-08-16 00:00:00	2012-09-15	2012-09-15 00:00:00	32020		\N	67441	0	16114001	4059173		0
6767	399	80180	1997-05-07	1997-05-07 00:00:00	\N	\N	32020		\N	26231	0	396275006	80180		0
6939	408	195588	1985-06-01	1985-06-01 00:00:00	1985-07-12	1985-07-12 00:00:00	32020		\N	26964	0	38822007	195588		0
7106	418	4278672	1967-09-13	1967-09-13 00:00:00	1967-12-12	1967-12-12 00:00:00	32020		\N	27671	0	65966004	4278672		0
17801	1072	378001	1997-05-15	1997-05-15 00:00:00	1997-06-14	1997-06-14 00:00:00	32020		\N	70288	0	62106007	378001		0
7444	437	4278672	2017-11-06	2017-11-06 00:00:00	2018-01-05	2018-01-05 00:00:00	32020		\N	29054	0	65966004	4278672		0
7603	445	40481087	1953-10-19	1953-10-19 00:00:00	1953-10-26	1953-10-26 00:00:00	32020		\N	29586	0	444814009	40481087		0
7760	454	80180	1970-09-09	1970-09-09 00:00:00	\N	\N	32020		\N	30266	0	396275006	80180		0
7945	464	4112343	1986-05-05	1986-05-05 00:00:00	1986-05-13	1986-05-13 00:00:00	32020		\N	30973	0	195662009	4112343		0
8127	476	4156265	1983-05-25	1983-05-25 00:00:00	1983-06-15	1983-06-15 00:00:00	32020		\N	31752	0	370247008	4156265		0
18761	1128	28060	1987-01-21	1987-01-21 00:00:00	1987-02-03	1987-02-03 00:00:00	32020		\N	74316	0	43878008	28060		0
8422	489	4084167	1977-10-19	1977-10-19 00:00:00	1977-10-19	1977-10-19 00:00:00	32020		\N	32703	0	241929008	4084167		0
8608	502	81151	2009-03-30	2009-03-30 00:00:00	2009-05-04	2009-05-04 00:00:00	32020		\N	33651	0	44465007	81151		0
19259	1154	4109685	2009-11-01	2009-11-01 00:00:00	2009-11-22	2009-11-22 00:00:00	32020		\N	76275	0	284551006	4109685		0
19521	1173	372328	1959-05-17	1959-05-17 00:00:00	1959-08-24	1959-08-24 00:00:00	32020		\N	77249	0	65363002	372328		0
19593	1175	40481087	1953-05-07	1953-05-07 00:00:00	1953-05-28	1953-05-28 00:00:00	32020		\N	77410	0	444814009	40481087		0
19786	1189	28060	2004-01-29	2004-01-29 00:00:00	2004-02-11	2004-02-11 00:00:00	32020		\N	78320	0	43878008	28060		0
9462	559	260139	1989-01-26	1989-01-26 00:00:00	1989-02-09	1989-02-09 00:00:00	32020		\N	37100	0	10509002	260139		0
9620	569	4112343	1981-01-03	1981-01-03 00:00:00	1981-01-13	1981-01-13 00:00:00	32020		\N	37668	0	195662009	4112343		0
9765	578	4084167	1967-12-27	1967-12-27 00:00:00	1967-12-27	1967-12-27 00:00:00	32020		\N	38192	0	241929008	4084167		0
20425	1228	440448	2016-06-26	2016-06-26 00:00:00	\N	\N	32020		\N	80897	0	74400008	440448		0
20602	1237	4112343	1967-09-28	1967-09-28 00:00:00	1967-10-11	1967-10-11 00:00:00	32020		\N	81544	0	195662009	4112343		0
10267	607	80180	1991-02-23	1991-02-23 00:00:00	\N	\N	32020		\N	40309	0	396275006	80180		0
10423	614	40481087	2016-09-16	2016-09-16 00:00:00	2016-10-07	2016-10-07 00:00:00	32020		\N	40799	0	444814009	40481087		0
21100	1266	4294548	1980-01-12	1980-01-12 00:00:00	1980-03-01	1980-03-01 00:00:00	32020		\N	83468	0	75498004	4294548		0
120	5	4294548	1991-11-21	1991-11-21 00:00:00	1993-01-28	1993-01-28 00:00:00	32020		\N	516	0	75498004	4294548		0
318	17	78272	2012-01-19	2012-01-19 00:00:00	2012-02-02	2012-02-02 00:00:00	32020		\N	1376	0	70704007	78272		0
10982	648	4112343	1935-10-05	1935-10-05 00:00:00	1935-10-15	1935-10-15 00:00:00	32020		\N	42899	0	195662009	4112343		0
657	36	133834	1960-06-19	1960-06-19 00:00:00	\N	\N	32020		\N	2484	0	24079001	133834		0
798	42	40481087	1960-02-29	1960-02-29 00:00:00	1960-03-07	1960-03-07 00:00:00	32020		\N	3064	0	444814009	40481087		0
11517	680	4112343	1995-02-26	1995-02-26 00:00:00	1995-03-10	1995-03-10 00:00:00	32020		\N	45009	0	195662009	4112343		0
1145	67	40481087	1985-02-04	1985-02-04 00:00:00	1985-02-25	1985-02-25 00:00:00	32020		\N	4538	0	444814009	40481087		0
1319	78	80180	2003-02-15	2003-02-15 00:00:00	\N	\N	32020		\N	5166	0	396275006	80180		0
1451	84	372328	1975-04-08	1975-04-08 00:00:00	1975-05-22	1975-05-22 00:00:00	32020		\N	5675	0	65363002	372328		0
12135	719	260139	2005-05-31	2005-05-31 00:00:00	2005-06-07	2005-06-07 00:00:00	32020		\N	47568	0	10509002	260139		0
1795	102	78272	1991-08-20	1991-08-20 00:00:00	1991-09-24	1991-09-24 00:00:00	32020		\N	6979	0	70704007	78272		0
1986	116	4112343	1931-10-13	1931-10-13 00:00:00	1931-10-21	1931-10-21 00:00:00	32020		\N	7674	0	195662009	4112343		0
2143	124	372328	1985-05-30	1985-05-30 00:00:00	1985-08-13	1985-08-13 00:00:00	32020		\N	8208	0	65363002	372328		0
12818	756	81151	1982-09-04	1982-09-04 00:00:00	1982-09-18	1982-09-18 00:00:00	32020		\N	50173	0	44465007	81151		0
2469	145	260139	1957-12-15	1957-12-15 00:00:00	1957-12-22	1957-12-22 00:00:00	32020		\N	9766	0	10509002	260139		0
2643	154	257012	1980-09-23	1980-09-23 00:00:00	\N	\N	32020		\N	10494	0	40055000	257012		0
2789	161	40481087	2000-02-28	2000-02-28 00:00:00	2000-03-06	2000-03-06 00:00:00	32020		\N	11032	0	444814009	40481087		0
2975	173	40481087	2005-08-02	2005-08-02 00:00:00	2005-08-16	2005-08-16 00:00:00	32020		\N	11743	0	444814009	40481087		0
3122	184	4112343	2012-08-19	2012-08-19 00:00:00	2012-08-28	2012-08-28 00:00:00	32020		\N	12476	0	195662009	4112343		0
3266	190	4134304	1936-02-07	1936-02-07 00:00:00	1936-05-07	1936-05-07 00:00:00	32020		\N	12909	0	263102004	4134304		0
3448	196	40481087	2007-04-29	2007-04-29 00:00:00	2007-05-13	2007-05-13 00:00:00	32020		\N	13488	0	444814009	40481087		0
14128	834	4310024	1995-04-26	1995-04-26 00:00:00	\N	\N	32020		\N	55165	0	424802006	4310024		0
3798	219	78272	1979-07-15	1979-07-15 00:00:00	1979-08-19	1979-08-19 00:00:00	32020		\N	14755	0	70704007	78272		0
14446	855	40481087	1973-04-05	1973-04-05 00:00:00	1973-04-26	1973-04-26 00:00:00	32020		\N	56480	0	444814009	40481087		0
4134	239	4285898	1991-07-31	1991-07-31 00:00:00	\N	\N	32020		\N	16064	0	68496003	4285898		0
4303	248	134438	1990-08-04	1990-08-04 00:00:00	1991-08-29	1991-08-29 00:00:00	32020		\N	16705	0	40275004	134438		0
14966	882	28060	1971-01-24	1971-01-24 00:00:00	1971-02-05	1971-02-05 00:00:00	32020		\N	58758	0	43878008	28060		0
4625	270	40481087	1984-06-29	1984-06-29 00:00:00	1984-07-06	1984-07-06 00:00:00	32020		\N	17953	0	444814009	40481087		0
4790	280	4112343	1997-11-09	1997-11-09 00:00:00	1997-11-19	1997-11-19 00:00:00	32020		\N	18690	0	195662009	4112343		0
4964	292	260139	1996-07-17	1996-07-17 00:00:00	1996-07-31	1996-07-31 00:00:00	32020		\N	19470	0	10509002	260139		0
5118	300	4112343	2007-12-20	2007-12-20 00:00:00	2008-01-02	2008-01-02 00:00:00	32020		\N	20055	0	195662009	4112343		0
5275	311	4112343	1980-09-10	1980-09-10 00:00:00	1980-09-23	1980-09-23 00:00:00	32020		\N	20583	0	195662009	4112343		0
5469	321	4156265	1978-03-02	1978-03-02 00:00:00	1978-03-23	1978-03-23 00:00:00	32020		\N	21320	0	370247008	4156265		0
16105	951	372328	2008-02-24	2008-02-24 00:00:00	2008-09-24	2008-09-24 00:00:00	32020		\N	63142	0	65363002	372328		0
5780	339	257012	1995-01-23	1995-01-23 00:00:00	\N	\N	32020		\N	22617	0	40055000	257012		0
5948	350	80180	2004-08-22	2004-08-22 00:00:00	\N	\N	32020		\N	23278	0	396275006	80180		0
6103	358	40481087	1964-06-21	1964-06-21 00:00:00	1964-06-28	1964-06-28 00:00:00	32020		\N	23849	0	444814009	40481087		0
6269	368	4112343	2008-03-20	2008-03-20 00:00:00	2008-03-29	2008-03-29 00:00:00	32020		\N	24477	0	195662009	4112343		0
6428	377	260139	1979-01-02	1979-01-02 00:00:00	1979-01-16	1979-01-16 00:00:00	32020		\N	25012	0	10509002	260139		0
17130	1024	40481087	1979-08-04	1979-08-04 00:00:00	1979-08-18	1979-08-18 00:00:00	32020		\N	67399	0	444814009	40481087		0
6768	399	4112343	2001-01-28	2001-01-28 00:00:00	2001-02-04	2001-02-04 00:00:00	32020		\N	26155	0	195662009	4112343		0
6940	408	4146173	2001-05-08	2001-05-08 00:00:00	2001-06-07	2001-06-07 00:00:00	32020		\N	26976	0	307731004	4146173		0
7107	418	4112343	1958-01-24	1958-01-24 00:00:00	1958-02-01	1958-02-01 00:00:00	32020		\N	27681	0	195662009	4112343		0
17802	1072	4059173	1979-05-29	1979-05-29 00:00:00	1979-06-28	1979-06-28 00:00:00	32020		\N	70286	0	16114001	4059173		0
7445	437	372328	1951-08-30	1951-08-30 00:00:00	1952-01-29	1952-01-29 00:00:00	32020		\N	29013	0	65363002	372328		0
7604	445	80180	1953-11-30	1953-11-30 00:00:00	\N	\N	32020		\N	29586	0	396275006	80180		0
7761	454	40481087	1969-11-29	1969-11-29 00:00:00	1969-12-06	1969-12-06 00:00:00	32020		\N	30266	0	444814009	40481087		0
7946	464	81151	2016-06-24	2016-06-24 00:00:00	2016-07-15	2016-07-15 00:00:00	32020		\N	30964	0	44465007	81151		0
8128	476	260139	1985-07-31	1985-07-31 00:00:00	1985-08-14	1985-08-14 00:00:00	32020		\N	31738	0	10509002	260139		0
18762	1128	40481087	1973-08-04	1973-08-04 00:00:00	1973-08-18	1973-08-18 00:00:00	32020		\N	74347	0	444814009	40481087		0
8423	489	4084167	1976-10-23	1976-10-23 00:00:00	1976-10-23	1976-10-23 00:00:00	32020		\N	32702	0	241929008	4084167		0
8609	502	260139	1979-06-01	1979-06-01 00:00:00	1979-06-08	1979-06-08 00:00:00	32020		\N	33634	0	10509002	260139		0
19260	1154	4283893	1974-08-18	1974-08-18 00:00:00	1974-09-15	1974-09-15 00:00:00	32020		\N	76270	0	36971009	4283893		0
19522	1173	40481087	1965-04-03	1965-04-03 00:00:00	1965-04-17	1965-04-17 00:00:00	32020		\N	77267	0	444814009	40481087		0
19594	1175	40481087	1989-07-23	1989-07-23 00:00:00	1989-08-06	1989-08-06 00:00:00	32020		\N	77417	0	444814009	40481087		0
19787	1189	40481087	2010-10-30	2010-10-30 00:00:00	2010-11-13	2010-11-13 00:00:00	32020		\N	78353	0	444814009	40481087		0
19927	1201	40481087	1994-05-21	1994-05-21 00:00:00	1994-05-28	1994-05-28 00:00:00	32020		\N	78983	0	444814009	40481087		0
9621	569	195588	1941-05-31	1941-05-31 00:00:00	1941-07-13	1941-07-13 00:00:00	32020		\N	37582	0	38822007	195588		0
9766	578	40481087	2010-05-13	2010-05-13 00:00:00	2010-06-03	2010-06-03 00:00:00	32020		\N	38270	0	444814009	40481087		0
20426	1228	40481087	1999-08-31	1999-08-31 00:00:00	1999-09-21	1999-09-21 00:00:00	32020		\N	80876	0	444814009	40481087		0
20604	1237	440448	1950-09-30	1950-09-30 00:00:00	\N	\N	32020		\N	81519	0	74400008	440448		0
10268	607	4142905	1954-07-27	1954-07-27 00:00:00	1954-08-26	1954-08-26 00:00:00	32020		\N	40297	0	33737001	4142905		0
10424	614	372328	1963-10-31	1963-10-31 00:00:00	1963-12-08	1963-12-08 00:00:00	32020		\N	40822	0	65363002	372328		0
21101	1266	378001	1976-03-22	1976-03-22 00:00:00	1976-05-21	1976-05-21 00:00:00	32020		\N	83454	0	62106007	378001		0
121	5	378001	1971-08-08	1971-08-08 00:00:00	1971-09-07	1971-09-07 00:00:00	32020		\N	491	0	62106007	378001		0
319	17	40481087	2008-07-12	2008-07-12 00:00:00	2008-07-26	2008-07-26 00:00:00	32020		\N	1325	0	444814009	40481087		0
10983	648	260139	2005-08-27	2005-08-27 00:00:00	2005-09-10	2005-09-10 00:00:00	32020		\N	42905	0	10509002	260139		0
658	36	28060	1959-11-18	1959-11-18 00:00:00	1959-11-29	1959-11-29 00:00:00	32020		\N	2512	0	43878008	28060		0
799	42	4156265	1974-06-13	1974-06-13 00:00:00	1974-06-27	1974-06-27 00:00:00	32020		\N	3107	0	370247008	4156265		0
11518	680	4048171	1971-10-01	1971-10-01 00:00:00	1993-07-12	1993-07-12 00:00:00	32020		\N	44999	0	232353008	4048171		0
1146	67	40481087	1986-09-23	1986-09-23 00:00:00	1986-09-30	1986-09-30 00:00:00	32020		\N	4565	0	444814009	40481087		0
1320	78	372328	1967-11-13	1967-11-13 00:00:00	1967-12-14	1967-12-14 00:00:00	32020		\N	5157	0	65363002	372328		0
1471	86	4109685	1961-03-15	1961-03-15 00:00:00	1961-04-05	1961-04-05 00:00:00	32020		\N	5791	0	284551006	4109685		0
12136	719	4116491	2016-02-12	2016-02-12 00:00:00	2016-04-02	2016-04-02 00:00:00	32020		\N	47583	0	301011002	4116491		0
1796	102	40481087	2004-07-22	2004-07-22 00:00:00	2004-08-12	2004-08-12 00:00:00	32020		\N	6969	0	444814009	40481087		0
1987	116	4218389	1959-07-22	1959-07-22 00:00:00	1959-08-12	1959-08-12 00:00:00	32020		\N	7652	0	39848009	4218389		0
2144	124	4048171	1987-03-12	1987-03-12 00:00:00	2003-03-10	2003-03-10 00:00:00	32020		\N	8314	0	232353008	4048171		0
12819	756	4112343	1981-05-25	1981-05-25 00:00:00	1981-06-02	1981-06-02 00:00:00	32020		\N	50119	0	195662009	4112343		0
2470	145	40481087	1993-10-31	1993-10-31 00:00:00	1993-11-07	1993-11-07 00:00:00	32020		\N	9722	0	444814009	40481087		0
2644	154	4218389	1979-05-29	1979-05-29 00:00:00	1979-07-03	1979-07-03 00:00:00	32020		\N	10471	0	39848009	4218389		0
2790	161	40481087	1988-11-29	1988-11-29 00:00:00	1988-12-20	1988-12-20 00:00:00	32020		\N	11028	0	444814009	40481087		0
2976	173	4142905	1977-11-02	1977-11-02 00:00:00	1978-01-01	1978-01-01 00:00:00	32020		\N	11763	0	33737001	4142905		0
3123	184	40481087	1965-11-11	1965-11-11 00:00:00	1965-11-18	1965-11-18 00:00:00	32020		\N	12473	0	444814009	40481087		0
3267	190	40481087	1951-06-23	1951-06-23 00:00:00	1951-07-07	1951-07-07 00:00:00	32020		\N	12980	0	444814009	40481087		0
3449	197	40481087	1976-07-04	1976-07-04 00:00:00	1976-07-11	1976-07-11 00:00:00	32020		\N	13594	0	444814009	40481087		0
14129	834	81893	1995-08-24	1995-08-24 00:00:00	\N	\N	32020		\N	55165	0	64766004	81893		0
3799	219	78272	1987-08-07	1987-08-07 00:00:00	1987-09-11	1987-09-11 00:00:00	32020		\N	14757	0	70704007	78272		0
14447	855	375671	1968-09-05	1968-09-05 00:00:00	1968-10-05	1968-10-05 00:00:00	32020		\N	56515	0	62564004	375671		0
4135	239	40481087	1950-07-08	1950-07-08 00:00:00	1950-07-15	1950-07-15 00:00:00	32020		\N	16055	0	444814009	40481087		0
4304	248	260139	1996-04-16	1996-04-16 00:00:00	1996-04-23	1996-04-23 00:00:00	32020		\N	16706	0	10509002	260139		0
14967	882	372328	1945-04-22	1945-04-22 00:00:00	1945-06-02	1945-06-02 00:00:00	32020		\N	58749	0	65363002	372328		0
4626	270	30753	1994-08-19	1994-08-19 00:00:00	\N	\N	32020		\N	17961	0	16761005	30753		0
4791	280	4112343	1982-10-09	1982-10-09 00:00:00	1982-10-16	1982-10-16 00:00:00	32020		\N	18764	0	195662009	4112343		0
4965	292	40481087	2016-08-22	2016-08-22 00:00:00	2016-09-05	2016-09-05 00:00:00	32020		\N	19461	0	444814009	40481087		0
5119	300	40481087	1980-07-17	1980-07-17 00:00:00	1980-07-31	1980-07-31 00:00:00	32020		\N	20071	0	444814009	40481087		0
5276	311	4112343	2005-10-23	2005-10-23 00:00:00	2005-11-02	2005-11-02 00:00:00	32020		\N	20603	0	195662009	4112343		0
5470	321	4112343	1998-10-08	1998-10-08 00:00:00	1998-10-19	1998-10-19 00:00:00	32020		\N	21291	0	195662009	4112343		0
16119	954	372328	1976-03-12	1976-03-12 00:00:00	1976-09-19	1976-09-19 00:00:00	32020		\N	63386	0	65363002	372328		0
5781	339	4296205	1990-02-03	1990-02-03 00:00:00	1990-03-03	1990-03-03 00:00:00	32020		\N	22608	0	403191005	4296205		0
5949	350	4237458	1970-11-03	1970-11-03 00:00:00	1971-02-01	1971-02-01 00:00:00	32020		\N	23290	0	58150001	4237458		0
6104	358	28060	1988-08-16	1988-08-16 00:00:00	1988-08-26	1988-08-26 00:00:00	32020		\N	23791	0	43878008	28060		0
6270	368	40481087	1997-11-16	1997-11-16 00:00:00	1997-11-23	1997-11-23 00:00:00	32020		\N	24519	0	444814009	40481087		0
6429	377	4294548	1994-09-30	1994-09-30 00:00:00	1994-10-21	1994-10-21 00:00:00	32020		\N	24969	0	75498004	4294548		0
17131	1024	4109685	1979-04-11	1979-04-11 00:00:00	1979-05-02	1979-05-02 00:00:00	32020		\N	67437	0	284551006	4109685		0
6769	399	4059173	1968-03-30	1968-03-30 00:00:00	1968-04-29	1968-04-29 00:00:00	32020		\N	26234	0	16114001	4059173		0
6941	408	40481087	1991-02-20	1991-02-20 00:00:00	1991-03-13	1991-03-13 00:00:00	32020		\N	26965	0	444814009	40481087		0
7108	418	4112343	1963-11-04	1963-11-04 00:00:00	1963-11-11	1963-11-11 00:00:00	32020		\N	27595	0	195662009	4112343		0
17803	1072	4112343	2002-05-21	2002-05-21 00:00:00	2002-05-30	2002-05-30 00:00:00	32020		\N	70278	0	195662009	4112343		0
7446	437	4296204	2007-07-06	2007-07-06 00:00:00	2007-08-03	2007-08-03 00:00:00	32020		\N	29052	0	403190006	4296204		0
7605	445	40481087	1964-12-01	1964-12-01 00:00:00	1964-12-15	1964-12-15 00:00:00	32020		\N	29589	0	444814009	40481087		0
7762	454	260139	1961-09-08	1961-09-08 00:00:00	1961-09-22	1961-09-22 00:00:00	32020		\N	30349	0	10509002	260139		0
7947	464	40481087	2018-12-01	2018-12-01 00:00:00	2018-12-22	2018-12-22 00:00:00	32020		\N	30974	0	444814009	40481087		0
8129	476	40481087	2013-12-01	2013-12-01 00:00:00	2013-12-15	2013-12-15 00:00:00	32020		\N	31750	0	444814009	40481087		0
18763	1128	4310024	2005-01-13	2005-01-13 00:00:00	\N	\N	32020		\N	74333	0	424802006	4310024		0
8424	489	40481087	1981-03-20	1981-03-20 00:00:00	1981-04-10	1981-04-10 00:00:00	32020		\N	32752	0	444814009	40481087		0
8610	502	313217	2011-04-02	2011-04-02 00:00:00	\N	\N	32020		\N	33622	0	49436004	313217		0
19261	1154	40481087	1995-12-28	1995-12-28 00:00:00	1996-01-04	1996-01-04 00:00:00	32020		\N	76218	0	444814009	40481087		0
19523	1173	260139	1994-08-27	1994-08-27 00:00:00	1994-09-03	1994-09-03 00:00:00	32020		\N	77269	0	10509002	260139		0
19595	1175	4218389	1945-12-29	1945-12-29 00:00:00	1946-01-19	1946-01-19 00:00:00	32020		\N	77418	0	39848009	4218389		0
19788	1189	4146173	2018-01-08	2018-01-08 00:00:00	2018-03-09	2018-03-09 00:00:00	32020		\N	78322	0	307731004	4146173		0
19928	1201	4112343	2000-11-01	2000-11-01 00:00:00	2000-11-10	2000-11-10 00:00:00	32020		\N	78998	0	195662009	4112343		0
9622	569	372328	1915-02-11	1915-02-11 00:00:00	1915-04-03	1915-04-03 00:00:00	32020		\N	37593	0	65363002	372328		0
9767	578	372328	1970-05-22	1970-05-22 00:00:00	1970-08-26	1970-08-26 00:00:00	32020		\N	38222	0	65363002	372328		0
20427	1228	4146173	1985-11-12	1985-11-12 00:00:00	1985-12-12	1985-12-12 00:00:00	32020		\N	80875	0	307731004	4146173		0
20605	1237	40481087	1989-04-18	1989-04-18 00:00:00	1989-05-02	1989-05-02 00:00:00	32020		\N	81500	0	444814009	40481087		0
10269	607	40481087	1969-08-16	1969-08-16 00:00:00	1969-08-23	1969-08-23 00:00:00	32020		\N	40323	0	444814009	40481087		0
10425	614	40481087	1984-11-23	1984-11-23 00:00:00	1984-12-14	1984-12-14 00:00:00	32020		\N	40792	0	444814009	40481087		0
21102	1266	78272	1991-02-07	1991-02-07 00:00:00	1991-03-14	1991-03-14 00:00:00	32020		\N	83456	0	70704007	78272		0
122	5	40479768	1990-03-31	1990-03-31 00:00:00	1990-06-06	1990-06-06 00:00:00	32020		\N	492	0	444470001	40479768		0
320	17	81151	1994-11-21	1994-11-21 00:00:00	1994-12-19	1994-12-19 00:00:00	32020		\N	1375	0	44465007	81151		0
10984	648	28060	2016-05-28	2016-05-28 00:00:00	2016-06-08	2016-06-08 00:00:00	32020		\N	42915	0	43878008	28060		0
659	36	313217	2018-01-09	2018-01-09 00:00:00	\N	\N	32020		\N	2600	0	49436004	313217		0
800	42	260139	1938-11-10	1938-11-10 00:00:00	1938-11-24	1938-11-24 00:00:00	32020		\N	2995	0	10509002	260139		0
11519	680	4146173	1998-10-24	1998-10-24 00:00:00	1998-11-23	1998-11-23 00:00:00	32020		\N	45010	0	307731004	4146173		0
1147	67	260139	1980-01-31	1980-01-31 00:00:00	1980-02-14	1980-02-14 00:00:00	32020		\N	4537	0	10509002	260139		0
1321	78	4112343	2003-08-23	2003-08-23 00:00:00	2003-09-01	2003-09-01 00:00:00	32020		\N	5181	0	195662009	4112343		0
1472	86	81151	1965-11-10	1965-11-10 00:00:00	1965-11-24	1965-11-24 00:00:00	32020		\N	5792	0	44465007	81151		0
12137	719	4112343	2007-04-13	2007-04-13 00:00:00	2007-04-22	2007-04-22 00:00:00	32020		\N	47559	0	195662009	4112343		0
1797	102	260139	2010-03-10	2010-03-10 00:00:00	2010-03-24	2010-03-24 00:00:00	32020		\N	7012	0	10509002	260139		0
1988	116	257012	1977-07-11	1977-07-11 00:00:00	\N	\N	32020		\N	7677	0	40055000	257012		0
2145	124	4112343	1992-02-26	1992-02-26 00:00:00	1992-03-06	1992-03-06 00:00:00	32020		\N	8316	0	195662009	4112343		0
12820	756	260139	2005-01-04	2005-01-04 00:00:00	2005-01-11	2005-01-11 00:00:00	32020		\N	50156	0	10509002	260139		0
2471	145	40481087	1985-12-30	1985-12-30 00:00:00	1986-01-06	1986-01-06 00:00:00	32020		\N	9809	0	444814009	40481087		0
2645	154	40481087	1988-11-04	1988-11-04 00:00:00	1988-11-25	1988-11-25 00:00:00	32020		\N	10498	0	444814009	40481087		0
2791	161	4035415	2016-07-13	2016-07-13 00:00:00	2016-09-11	2016-09-11 00:00:00	32020		\N	11060	0	239720000	4035415		0
2977	173	260139	1985-07-03	1985-07-03 00:00:00	1985-07-17	1985-07-17 00:00:00	32020		\N	11740	0	10509002	260139		0
3124	184	28060	1950-02-25	1950-02-25 00:00:00	1950-03-10	1950-03-10 00:00:00	32020		\N	12432	0	43878008	28060		0
3268	190	255848	2016-03-25	2016-03-25 00:00:00	\N	\N	32020		\N	13015	0	233604007	255848		0
3450	197	4156265	1982-07-12	1982-07-12 00:00:00	1982-08-02	1982-08-02 00:00:00	32020		\N	13531	0	370247008	4156265		0
14130	834	4283893	2008-05-29	2008-05-29 00:00:00	2009-03-26	2009-03-26 00:00:00	32020		\N	55178	0	36971009	4283893		0
3800	219	80180	2005-11-01	2005-11-01 00:00:00	\N	\N	32020		\N	14791	0	396275006	80180		0
14448	855	40481087	1982-11-13	1982-11-13 00:00:00	1982-11-27	1982-11-27 00:00:00	32020		\N	56494	0	444814009	40481087		0
4136	239	4112343	2009-07-22	2009-07-22 00:00:00	2009-07-30	2009-07-30 00:00:00	32020		\N	16060	0	195662009	4112343		0
4305	248	372328	1995-09-21	1995-09-21 00:00:00	1996-04-23	1996-04-23 00:00:00	32020		\N	16682	0	65363002	372328		0
14968	882	4112343	2007-05-01	2007-05-01 00:00:00	2007-05-11	2007-05-11 00:00:00	32020		\N	58678	0	195662009	4112343		0
4627	270	80180	1995-05-16	1995-05-16 00:00:00	\N	\N	32020		\N	17961	0	396275006	80180		0
4792	280	81151	1993-11-18	1993-11-18 00:00:00	1993-12-09	1993-12-09 00:00:00	32020		\N	18707	0	44465007	81151		0
4966	292	80180	2017-01-16	2017-01-16 00:00:00	\N	\N	32020		\N	19461	0	396275006	80180		0
5120	300	260139	2007-08-21	2007-08-21 00:00:00	2007-08-28	2007-08-28 00:00:00	32020		\N	20076	0	10509002	260139		0
5277	311	28060	1991-03-31	1991-03-31 00:00:00	1991-04-07	1991-04-07 00:00:00	32020		\N	20630	0	43878008	28060		0
15964	946	40481087	2009-01-06	2009-01-06 00:00:00	2009-01-13	2009-01-13 00:00:00	32020		\N	62777	0	444814009	40481087		0
16120	954	4112343	1985-12-15	1985-12-15 00:00:00	1985-12-26	1985-12-26 00:00:00	32020		\N	63382	0	195662009	4112343		0
5782	339	40481087	2000-04-23	2000-04-23 00:00:00	2000-05-14	2000-05-14 00:00:00	32020		\N	22623	0	444814009	40481087		0
5950	350	4112343	1970-12-16	1970-12-16 00:00:00	1970-12-27	1970-12-27 00:00:00	32020		\N	23324	0	195662009	4112343		0
6105	358	260139	1957-03-27	1957-03-27 00:00:00	1957-04-03	1957-04-03 00:00:00	32020		\N	23807	0	10509002	260139		0
6271	368	80180	2004-11-16	2004-11-16 00:00:00	\N	\N	32020		\N	24483	0	396275006	80180		0
6430	377	192671	2003-04-02	2003-04-02 00:00:00	\N	\N	32020		\N	24968	0	K92.2	35208414		0
17132	1024	40481087	1997-03-16	1997-03-16 00:00:00	1997-04-06	1997-04-06 00:00:00	32020		\N	67470	0	444814009	40481087		0
6770	399	4283893	1998-07-21	1998-07-21 00:00:00	1998-09-22	1998-09-22 00:00:00	32020		\N	26154	0	36971009	4283893		0
6942	408	40481087	1969-04-01	1969-04-01 00:00:00	1969-04-22	1969-04-22 00:00:00	32020		\N	26941	0	444814009	40481087		0
7109	418	40481087	1992-05-23	1992-05-23 00:00:00	1992-06-13	1992-06-13 00:00:00	32020		\N	27612	0	444814009	40481087		0
17804	1072	81151	1968-03-08	1968-03-08 00:00:00	1968-04-05	1968-04-05 00:00:00	32020		\N	70284	0	44465007	81151		0
7455	439	4113008	2002-10-18	2002-10-18 00:00:00	2002-11-08	2002-11-08 00:00:00	32020		\N	29154	0	284549007	4113008		0
7606	445	372328	1917-06-22	1917-06-22 00:00:00	1917-09-07	1917-09-07 00:00:00	32020		\N	29594	0	65363002	372328		0
7763	454	4056621	1954-04-21	1954-04-21 00:00:00	\N	\N	32020		\N	30280	0	197927001	4056621		0
7948	464	80180	2014-10-23	2014-10-23 00:00:00	\N	\N	32020		\N	30972	0	396275006	80180		0
8130	476	4112343	2006-05-21	2006-05-21 00:00:00	2006-05-28	2006-05-28 00:00:00	32020		\N	31748	0	195662009	4112343		0
18764	1128	81893	2005-06-12	2005-06-12 00:00:00	\N	\N	32020		\N	74333	0	64766004	81893		0
8425	489	40481087	1987-04-29	1987-04-29 00:00:00	1987-05-06	1987-05-06 00:00:00	32020		\N	32757	0	444814009	40481087		0
8611	502	4112343	1990-12-06	1990-12-06 00:00:00	1990-12-19	1990-12-19 00:00:00	32020		\N	33583	0	195662009	4112343		0
19262	1154	4084167	1971-03-05	1971-03-05 00:00:00	1971-03-05	1971-03-05 00:00:00	32020		\N	76271	0	241929008	4084167		0
19524	1173	4296204	1982-09-22	1982-09-22 00:00:00	1982-10-06	1982-10-06 00:00:00	32020		\N	77275	0	403190006	4296204		0
19596	1175	80180	1974-05-06	1974-05-06 00:00:00	\N	\N	32020		\N	77565	0	396275006	80180		0
19789	1189	40481087	1981-01-01	1981-01-01 00:00:00	1981-01-08	1981-01-08 00:00:00	32020		\N	78317	0	444814009	40481087		0
19929	1201	81893	2006-05-31	2006-05-31 00:00:00	\N	\N	32020		\N	\N	0	64766004	81893		0
20087	1211	440448	1971-10-23	1971-10-23 00:00:00	\N	\N	32020		\N	79565	0	74400008	440448		0
9768	578	40481087	1975-06-27	1975-06-27 00:00:00	1975-07-04	1975-07-04 00:00:00	32020		\N	38262	0	444814009	40481087		0
20428	1228	372328	2016-03-27	2016-03-27 00:00:00	2016-07-09	2016-07-09 00:00:00	32020		\N	80932	0	65363002	372328		0
20606	1237	258780	1989-04-23	1989-04-23 00:00:00	\N	\N	32020		\N	81500	0	185086009	258780		0
10270	607	40481087	1977-04-18	1977-04-18 00:00:00	1977-05-02	1977-05-02 00:00:00	32020		\N	40337	0	444814009	40481087		0
10426	614	260139	1994-05-31	1994-05-31 00:00:00	1994-06-07	1994-06-07 00:00:00	32020		\N	40859	0	10509002	260139		0
21103	1266	40481087	1989-06-19	1989-06-19 00:00:00	1989-07-03	1989-07-03 00:00:00	32020		\N	83486	0	444814009	40481087		0
123	5	4112343	1977-06-08	1977-06-08 00:00:00	1977-06-18	1977-06-18 00:00:00	32020		\N	521	0	195662009	4112343		0
321	17	40481087	2015-10-25	2015-10-25 00:00:00	2015-11-15	2015-11-15 00:00:00	32020		\N	1300	0	444814009	40481087		0
10985	648	192671	1971-09-24	1971-09-24 00:00:00	\N	\N	32020		\N	42969	0	K92.2	35208414		0
660	36	260139	2001-06-17	2001-06-17 00:00:00	2001-07-01	2001-07-01 00:00:00	32020		\N	2631	0	10509002	260139		0
801	42	40481087	1978-02-26	1978-02-26 00:00:00	1978-03-19	1978-03-19 00:00:00	32020		\N	3055	0	444814009	40481087		0
11520	680	4112343	1986-11-30	1986-11-30 00:00:00	1986-12-10	1986-12-10 00:00:00	32020		\N	45017	0	195662009	4112343		0
1148	67	4112343	1972-11-10	1972-11-10 00:00:00	1972-11-20	1972-11-20 00:00:00	32020		\N	4535	0	195662009	4112343		0
1322	78	40481087	1991-10-05	1991-10-05 00:00:00	1991-10-12	1991-10-12 00:00:00	32020		\N	5165	0	444814009	40481087		0
1473	86	40481087	2013-12-18	2013-12-18 00:00:00	2014-01-08	2014-01-08 00:00:00	32020		\N	5806	0	444814009	40481087		0
12138	719	40481087	2012-01-10	2012-01-10 00:00:00	2012-01-24	2012-01-24 00:00:00	32020		\N	47593	0	444814009	40481087		0
1798	102	4296205	1994-06-10	1994-06-10 00:00:00	1994-07-15	1994-07-15 00:00:00	32020		\N	6980	0	403191005	4296205		0
1989	116	40481087	2006-03-04	2006-03-04 00:00:00	2006-03-18	2006-03-18 00:00:00	32020		\N	7724	0	444814009	40481087		0
2146	124	4237458	1993-11-13	1993-11-13 00:00:00	1994-01-12	1994-01-12 00:00:00	32020		\N	8288	0	58150001	4237458		0
12821	756	4112343	1967-03-01	1967-03-01 00:00:00	1967-03-14	1967-03-14 00:00:00	32020		\N	50129	0	195662009	4112343		0
2472	145	4155034	1979-10-24	1979-10-24 00:00:00	1979-11-14	1979-11-14 00:00:00	32020		\N	9799	0	283371005	4155034		0
2646	155	40481087	2005-06-20	2005-06-20 00:00:00	2005-07-11	2005-07-11 00:00:00	32020		\N	10520	0	444814009	40481087		0
2792	161	4112343	2012-05-26	2012-05-26 00:00:00	2012-06-02	2012-06-02 00:00:00	32020		\N	11047	0	195662009	4112343		0
2978	173	28060	1968-04-27	1968-04-27 00:00:00	1968-05-04	1968-05-04 00:00:00	32020		\N	11764	0	43878008	28060		0
3125	184	260139	1983-12-02	1983-12-02 00:00:00	1983-12-09	1983-12-09 00:00:00	32020		\N	12431	0	10509002	260139		0
3269	190	260139	1949-12-26	1949-12-26 00:00:00	1950-01-09	1950-01-09 00:00:00	32020		\N	12913	0	10509002	260139		0
3451	197	4112343	2012-07-29	2012-07-29 00:00:00	2012-08-09	2012-08-09 00:00:00	32020		\N	13539	0	195662009	4112343		0
14131	834	40481087	2018-02-09	2018-02-09 00:00:00	2018-02-23	2018-02-23 00:00:00	32020		\N	55214	0	444814009	40481087		0
3801	219	4112343	2018-06-03	2018-06-03 00:00:00	2018-06-12	2018-06-12 00:00:00	32020		\N	14730	0	195662009	4112343		0
14449	855	30753	1998-10-09	1998-10-09 00:00:00	\N	\N	32020		\N	56469	0	16761005	30753		0
4137	239	81151	1947-07-17	1947-07-17 00:00:00	1947-08-21	1947-08-21 00:00:00	32020		\N	16048	0	44465007	81151		0
4306	248	40481087	2016-04-25	2016-04-25 00:00:00	2016-05-09	2016-05-09 00:00:00	32020		\N	16691	0	444814009	40481087		0
14969	882	40479768	2015-05-18	2015-05-18 00:00:00	2015-07-24	2015-07-24 00:00:00	32020		\N	58724	0	444470001	40479768		0
4628	270	4266809	1995-05-16	1995-05-16 00:00:00	\N	\N	32020		\N	17961	0	397881000	4266809		0
4793	280	28060	1949-04-06	1949-04-06 00:00:00	1949-04-18	1949-04-18 00:00:00	32020		\N	18718	0	43878008	28060		0
4967	292	372328	1978-07-30	1978-07-30 00:00:00	1978-11-18	1978-11-18 00:00:00	32020		\N	19463	0	65363002	372328		0
5121	300	4112343	1988-07-10	1988-07-10 00:00:00	1988-07-17	1988-07-17 00:00:00	32020		\N	20075	0	195662009	4112343		0
5278	311	4152936	1978-05-22	1978-05-22 00:00:00	1978-06-12	1978-06-12 00:00:00	32020		\N	20650	0	283385000	4152936		0
15965	946	4283893	2014-07-17	2014-07-17 00:00:00	2014-10-23	2014-10-23 00:00:00	32020		\N	62778	0	36971009	4283893		0
16121	954	372328	1981-09-21	1981-09-21 00:00:00	1982-04-11	1982-04-11 00:00:00	32020		\N	63372	0	65363002	372328		0
5783	339	4237458	1994-08-09	1994-08-09 00:00:00	1994-09-08	1994-09-08 00:00:00	32020		\N	22663	0	58150001	4237458		0
5951	350	4112343	1968-07-16	1968-07-16 00:00:00	1968-07-27	1968-07-27 00:00:00	32020		\N	23298	0	195662009	4112343		0
6106	358	372328	1944-12-29	1944-12-29 00:00:00	1945-12-11	1945-12-11 00:00:00	32020		\N	23779	0	65363002	372328		0
6272	368	4112343	2003-03-04	2003-03-04 00:00:00	2003-03-14	2003-03-14 00:00:00	32020		\N	24483	0	195662009	4112343		0
6431	377	40481087	1971-12-15	1971-12-15 00:00:00	1971-12-22	1971-12-22 00:00:00	32020		\N	24956	0	444814009	40481087		0
17133	1024	4296205	2004-08-23	2004-08-23 00:00:00	2004-09-27	2004-09-27 00:00:00	32020		\N	67440	0	403191005	4296205		0
6771	399	260139	1959-09-11	1959-09-11 00:00:00	1959-09-25	1959-09-25 00:00:00	32020		\N	26118	0	10509002	260139		0
6943	408	40481087	2005-12-22	2005-12-22 00:00:00	2006-01-12	2006-01-12 00:00:00	32020		\N	26991	0	444814009	40481087		0
7110	418	40481087	1976-05-12	1976-05-12 00:00:00	1976-05-26	1976-05-26 00:00:00	32020		\N	27599	0	444814009	40481087		0
17805	1072	4112343	2008-08-16	2008-08-16 00:00:00	2008-08-27	2008-08-27 00:00:00	32020		\N	70263	0	195662009	4112343		0
7456	439	260139	1980-10-14	1980-10-14 00:00:00	1980-10-21	1980-10-21 00:00:00	32020		\N	29162	0	10509002	260139		0
7607	445	40481087	1979-06-14	1979-06-14 00:00:00	1979-06-21	1979-06-21 00:00:00	32020		\N	29624	0	444814009	40481087		0
7764	454	195588	1954-04-21	1954-04-21 00:00:00	1954-05-23	1954-05-23 00:00:00	32020		\N	30280	0	38822007	195588		0
18427	1108	4116491	2012-12-08	2012-12-08 00:00:00	2013-01-23	2013-01-23 00:00:00	32020		\N	72941	0	301011002	4116491		0
8131	476	372328	1972-06-21	1972-06-21 00:00:00	1972-08-26	1972-08-26 00:00:00	32020		\N	31709	0	65363002	372328		0
18765	1128	40481087	2004-12-23	2004-12-23 00:00:00	2005-01-13	2005-01-13 00:00:00	32020		\N	74333	0	444814009	40481087		0
8426	489	4266809	2016-09-03	2016-09-03 00:00:00	\N	\N	32020		\N	32770	0	397881000	4266809		0
8612	502	4112343	2015-08-06	2015-08-06 00:00:00	2015-08-19	2015-08-19 00:00:00	32020		\N	33612	0	195662009	4112343		0
19263	1154	40481087	2017-11-17	2017-11-17 00:00:00	2017-12-01	2017-12-01 00:00:00	32020		\N	76267	0	444814009	40481087		0
19525	1173	40481087	1991-08-16	1991-08-16 00:00:00	1991-08-30	1991-08-30 00:00:00	32020		\N	77247	0	444814009	40481087		0
19597	1175	260139	1981-05-16	1981-05-16 00:00:00	1981-05-30	1981-05-30 00:00:00	32020		\N	77409	0	10509002	260139		0
19790	1189	4237458	1964-09-27	1964-09-27 00:00:00	1964-11-26	1964-11-26 00:00:00	32020		\N	78324	0	58150001	4237458		0
19930	1201	40481087	1983-01-22	1983-01-22 00:00:00	1983-02-12	1983-02-12 00:00:00	32020		\N	79018	0	444814009	40481087		0
20088	1211	40481087	1972-06-14	1972-06-14 00:00:00	1972-07-05	1972-07-05 00:00:00	32020		\N	79557	0	444814009	40481087		0
9769	578	378001	1976-11-09	1976-11-09 00:00:00	1977-01-08	1977-01-08 00:00:00	32020		\N	38194	0	62106007	378001		0
20429	1228	4280726	1979-07-12	1979-07-12 00:00:00	\N	\N	32020		\N	80916	0	367498001	4280726		0
20607	1237	4278672	1950-02-20	1950-02-20 00:00:00	1950-04-21	1950-04-21 00:00:00	32020		\N	81518	0	65966004	4278672		0
10271	607	40481087	1980-11-17	1980-11-17 00:00:00	1980-12-01	1980-12-01 00:00:00	32020		\N	40319	0	444814009	40481087		0
10427	614	4134304	1968-05-07	1968-05-07 00:00:00	1968-06-06	1968-06-06 00:00:00	32020		\N	40846	0	263102004	4134304		0
21104	1266	40481087	2006-11-14	2006-11-14 00:00:00	2006-11-28	2006-11-28 00:00:00	32020		\N	83504	0	444814009	40481087		0
124	5	28060	1980-08-05	1980-08-05 00:00:00	1980-08-18	1980-08-18 00:00:00	32020		\N	478	0	43878008	28060		0
322	17	4029498	1962-12-08	1962-12-08 00:00:00	\N	\N	32020		\N	1378	0	128613002	4029498		0
10986	648	372328	1933-06-14	1933-06-14 00:00:00	1933-08-25	1933-08-25 00:00:00	32020		\N	42917	0	65363002	372328		0
661	36	372328	1959-04-19	1959-04-19 00:00:00	1959-06-30	1959-06-30 00:00:00	32020		\N	2544	0	65363002	372328		0
802	42	4112343	2009-12-06	2009-12-06 00:00:00	2009-12-15	2009-12-15 00:00:00	32020		\N	2999	0	195662009	4112343		0
11521	680	4283893	1995-05-26	1995-05-26 00:00:00	1995-08-11	1995-08-11 00:00:00	32020		\N	45075	0	36971009	4283893		0
1149	67	40481087	2018-06-07	2018-06-07 00:00:00	2018-06-21	2018-06-21 00:00:00	32020		\N	4523	0	444814009	40481087		0
1323	78	4112343	1998-02-28	1998-02-28 00:00:00	1998-03-08	1998-03-08 00:00:00	32020		\N	5180	0	195662009	4112343		0
1474	86	4112343	2010-11-21	2010-11-21 00:00:00	2010-12-02	2010-12-02 00:00:00	32020		\N	5770	0	195662009	4112343		0
12139	719	4116491	2009-12-30	2009-12-30 00:00:00	2010-02-13	2010-02-13 00:00:00	32020		\N	47570	0	301011002	4116491		0
1799	102	4218389	1983-06-28	1983-06-28 00:00:00	1983-08-02	1983-08-02 00:00:00	32020		\N	6978	0	39848009	4218389		0
1990	116	4294548	1994-04-25	1994-04-25 00:00:00	1994-05-30	1994-05-30 00:00:00	32020		\N	7680	0	75498004	4294548		0
2147	124	78272	2001-05-06	2001-05-06 00:00:00	2001-06-03	2001-06-03 00:00:00	32020		\N	8291	0	70704007	78272		0
12822	756	40481087	1983-06-19	1983-06-19 00:00:00	1983-07-03	1983-07-03 00:00:00	32020		\N	50141	0	444814009	40481087		0
2473	145	4113008	1984-04-12	1984-04-12 00:00:00	1984-04-26	1984-04-26 00:00:00	32020		\N	9802	0	284549007	4113008		0
2647	155	260139	2005-07-09	2005-07-09 00:00:00	2005-07-16	2005-07-16 00:00:00	32020		\N	10535	0	10509002	260139		0
2793	161	80180	2011-01-01	2011-01-01 00:00:00	\N	\N	32020		\N	11057	0	396275006	80180		0
2979	173	4112343	1994-11-11	1994-11-11 00:00:00	1994-11-24	1994-11-24 00:00:00	32020		\N	11790	0	195662009	4112343		0
3126	184	4156265	1984-07-07	1984-07-07 00:00:00	1984-07-28	1984-07-28 00:00:00	32020		\N	12503	0	370247008	4156265		0
3270	190	4112343	1961-03-13	1961-03-13 00:00:00	1961-03-23	1961-03-23 00:00:00	32020		\N	12981	0	195662009	4112343		0
3452	197	40481087	2002-02-14	2002-02-14 00:00:00	2002-02-28	2002-02-28 00:00:00	32020		\N	13571	0	444814009	40481087		0
14132	834	80180	1996-08-18	1996-08-18 00:00:00	\N	\N	32020		\N	55166	0	396275006	80180		0
3802	219	4112343	1970-08-19	1970-08-19 00:00:00	1970-08-28	1970-08-28 00:00:00	32020		\N	14707	0	195662009	4112343		0
14450	855	4112343	1997-03-27	1997-03-27 00:00:00	1997-04-06	1997-04-06 00:00:00	32020		\N	56469	0	195662009	4112343		0
4138	239	40481087	1964-10-26	1964-10-26 00:00:00	1964-11-02	1964-11-02 00:00:00	32020		\N	16058	0	444814009	40481087		0
4307	248	4237458	1990-04-29	1990-04-29 00:00:00	1990-07-28	1990-07-28 00:00:00	32020		\N	16666	0	58150001	4237458		0
14970	882	4112343	1950-11-24	1950-11-24 00:00:00	1950-12-07	1950-12-07 00:00:00	32020		\N	58674	0	195662009	4112343		0
4629	270	40481087	1994-06-19	1994-06-19 00:00:00	1994-07-03	1994-07-03 00:00:00	32020		\N	17961	0	444814009	40481087		0
4794	280	260139	2014-02-15	2014-02-15 00:00:00	2014-03-01	2014-03-01 00:00:00	32020		\N	18767	0	10509002	260139		0
4968	292	4112343	2017-10-30	2017-10-30 00:00:00	2017-11-06	2017-11-06 00:00:00	32020		\N	19462	0	195662009	4112343		0
5122	300	372328	1973-04-18	1973-04-18 00:00:00	1973-06-08	1973-06-08 00:00:00	32020		\N	20056	0	65363002	372328		0
5279	311	40481087	2008-08-09	2008-08-09 00:00:00	2008-08-23	2008-08-23 00:00:00	32020		\N	20589	0	444814009	40481087		0
15966	946	40481087	1981-09-18	1981-09-18 00:00:00	1981-10-09	1981-10-09 00:00:00	32020		\N	62775	0	444814009	40481087		0
16122	954	40481087	2005-11-06	2005-11-06 00:00:00	2005-11-20	2005-11-20 00:00:00	32020		\N	63383	0	444814009	40481087		0
5784	339	260139	2008-12-13	2008-12-13 00:00:00	2008-12-27	2008-12-27 00:00:00	32020		\N	22640	0	10509002	260139		0
5952	350	195588	1982-09-12	1982-09-12 00:00:00	1982-11-04	1982-11-04 00:00:00	32020		\N	23279	0	38822007	195588		0
6107	358	40481087	2004-06-09	2004-06-09 00:00:00	2004-06-23	2004-06-23 00:00:00	32020		\N	23853	0	444814009	40481087		0
6273	368	40481087	1987-08-22	1987-08-22 00:00:00	1987-09-05	1987-09-05 00:00:00	32020		\N	24482	0	444814009	40481087		0
6439	379	260139	2014-06-12	2014-06-12 00:00:00	2014-06-26	2014-06-26 00:00:00	32020		\N	25059	0	10509002	260139		0
17134	1024	260139	1992-02-10	1992-02-10 00:00:00	1992-02-24	1992-02-24 00:00:00	32020		\N	67444	0	10509002	260139		0
6772	399	4294548	1992-06-04	1992-06-04 00:00:00	1993-05-20	1993-05-20 00:00:00	32020		\N	26109	0	75498004	4294548		0
6944	408	28060	2010-06-29	2010-06-29 00:00:00	2010-07-11	2010-07-11 00:00:00	32020		\N	26968	0	43878008	28060		0
7111	418	378001	1964-06-30	1964-06-30 00:00:00	1964-08-29	1964-08-29 00:00:00	32020		\N	27670	0	62106007	378001		0
17806	1072	81151	1972-02-14	1972-02-14 00:00:00	1972-03-06	1972-03-06 00:00:00	32020		\N	70285	0	44465007	81151		0
7457	439	260139	2007-08-11	2007-08-11 00:00:00	2007-08-18	2007-08-18 00:00:00	32020		\N	29115	0	10509002	260139		0
7608	445	40481087	1939-02-10	1939-02-10 00:00:00	1939-02-17	1939-02-17 00:00:00	32020		\N	29556	0	444814009	40481087		0
7765	454	260139	1999-02-06	1999-02-06 00:00:00	1999-02-20	1999-02-20 00:00:00	32020		\N	30285	0	10509002	260139		0
18428	1108	4056621	2012-12-08	2012-12-08 00:00:00	\N	\N	32020		\N	72941	0	197927001	4056621		0
8132	476	40481087	1977-11-29	1977-11-29 00:00:00	1977-12-20	1977-12-20 00:00:00	32020		\N	31708	0	444814009	40481087		0
18766	1128	40481087	2014-02-07	2014-02-07 00:00:00	2014-02-14	2014-02-14 00:00:00	32020		\N	74351	0	444814009	40481087		0
8427	489	80180	2016-09-03	2016-09-03 00:00:00	\N	\N	32020		\N	32770	0	396275006	80180		0
8613	502	4112343	1960-11-01	1960-11-01 00:00:00	1960-11-11	1960-11-11 00:00:00	32020		\N	33611	0	195662009	4112343		0
19264	1154	80180	2006-07-14	2006-07-14 00:00:00	\N	\N	32020		\N	76262	0	396275006	80180		0
19526	1173	260139	1989-08-06	1989-08-06 00:00:00	1989-08-20	1989-08-20 00:00:00	32020		\N	77268	0	10509002	260139		0
19598	1175	28060	1949-01-15	1949-01-15 00:00:00	1949-01-24	1949-01-24 00:00:00	32020		\N	77546	0	43878008	28060		0
19791	1189	28060	2010-11-17	2010-11-17 00:00:00	2010-11-24	2010-11-24 00:00:00	32020		\N	78306	0	43878008	28060		0
19931	1201	260139	2005-12-13	2005-12-13 00:00:00	2005-12-20	2005-12-20 00:00:00	32020		\N	79020	0	10509002	260139		0
20089	1211	4116491	2007-10-12	2007-10-12 00:00:00	2007-12-11	2007-12-11 00:00:00	32020		\N	79664	0	301011002	4116491		0
9770	578	40481087	2005-12-22	2005-12-22 00:00:00	2006-01-05	2006-01-05 00:00:00	32020		\N	38272	0	444814009	40481087		0
20430	1229	260139	2001-04-17	2001-04-17 00:00:00	2001-04-24	2001-04-24 00:00:00	32020		\N	80982	0	10509002	260139		0
20608	1237	260139	1951-08-01	1951-08-01 00:00:00	1951-08-15	1951-08-15 00:00:00	32020		\N	81497	0	10509002	260139		0
10272	607	40481087	1993-07-24	1993-07-24 00:00:00	1993-08-14	1993-08-14 00:00:00	32020		\N	40329	0	444814009	40481087		0
10428	614	80180	2000-06-08	2000-06-08 00:00:00	\N	\N	32020		\N	40821	0	396275006	80180		0
21105	1266	4294548	1982-09-22	1982-09-22 00:00:00	1983-02-16	1983-02-16 00:00:00	32020		\N	83442	0	75498004	4294548		0
125	5	375671	2016-06-19	2016-06-19 00:00:00	2016-07-19	2016-07-19 00:00:00	32020		\N	494	0	62564004	375671		0
324	17	4112343	2011-09-19	2011-09-19 00:00:00	2011-09-30	2011-09-30 00:00:00	32020		\N	1316	0	195662009	4112343		0
10987	649	28060	1985-05-25	1985-05-25 00:00:00	1985-06-04	1985-06-04 00:00:00	32020		\N	43033	0	43878008	28060		0
662	36	260139	1966-07-12	1966-07-12 00:00:00	1966-07-26	1966-07-26 00:00:00	32020		\N	2486	0	10509002	260139		0
803	42	381316	1993-10-19	1993-10-19 00:00:00	\N	\N	32020		\N	3104	0	230690007	381316		0
11522	680	40481087	1989-04-23	1989-04-23 00:00:00	1989-04-30	1989-04-30 00:00:00	32020		\N	45004	0	444814009	40481087		0
1150	67	372328	1976-01-04	1976-01-04 00:00:00	1976-10-03	1976-10-03 00:00:00	32020		\N	4559	0	65363002	372328		0
1324	78	260139	1991-10-28	1991-10-28 00:00:00	1991-11-04	1991-11-04 00:00:00	32020		\N	5203	0	10509002	260139		0
1475	86	80180	1988-09-02	1988-09-02 00:00:00	\N	\N	32020		\N	5841	0	396275006	80180		0
12140	719	4152936	2010-09-06	2010-09-06 00:00:00	2010-09-20	2010-09-20 00:00:00	32020		\N	47565	0	283385000	4152936		0
1800	102	4112343	2014-08-02	2014-08-02 00:00:00	2014-08-12	2014-08-12 00:00:00	32020		\N	6970	0	195662009	4112343		0
1991	116	372328	1929-05-08	1929-05-08 00:00:00	1929-10-13	1929-10-13 00:00:00	32020		\N	7725	0	65363002	372328		0
2148	124	260139	1998-03-11	1998-03-11 00:00:00	1998-03-25	1998-03-25 00:00:00	32020		\N	8306	0	10509002	260139		0
12823	756	4112343	1969-02-03	1969-02-03 00:00:00	1969-02-15	1969-02-15 00:00:00	32020		\N	50174	0	195662009	4112343		0
2474	145	4051466	1952-12-06	1952-12-06 00:00:00	1968-03-21	1968-03-21 00:00:00	32020		\N	9764	0	233678006	4051466		0
2648	155	4112343	2018-12-06	2018-12-06 00:00:00	2018-12-19	2018-12-19 00:00:00	32020		\N	10557	0	195662009	4112343		0
2794	161	4152936	2009-06-10	2009-06-10 00:00:00	2009-07-01	2009-07-01 00:00:00	32020		\N	11057	0	283385000	4152936		0
2980	173	28060	1976-10-23	1976-10-23 00:00:00	1976-11-03	1976-11-03 00:00:00	32020		\N	11749	0	43878008	28060		0
3127	184	260139	2019-03-06	2019-03-06 00:00:00	2019-03-13	2019-03-13 00:00:00	32020		\N	12435	0	10509002	260139		0
3271	190	40481087	1999-05-10	1999-05-10 00:00:00	1999-05-24	1999-05-24 00:00:00	32020		\N	12967	0	444814009	40481087		0
3453	197	4294548	2012-10-19	2012-10-19 00:00:00	2012-11-23	2012-11-23 00:00:00	32020		\N	13586	0	75498004	4294548		0
3803	219	260139	1975-10-06	1975-10-06 00:00:00	1975-10-20	1975-10-20 00:00:00	32020		\N	14733	0	10509002	260139		0
14451	855	81893	1998-05-12	1998-05-12 00:00:00	\N	\N	32020		\N	56469	0	64766004	81893		0
14609	863	317576	1961-08-24	1961-08-24 00:00:00	\N	\N	32020		\N	57211	0	53741008	317576		0
4308	248	40481087	1979-02-01	1979-02-01 00:00:00	1979-02-15	1979-02-15 00:00:00	32020		\N	16723	0	444814009	40481087		0
14971	882	78272	1993-11-06	1993-11-06 00:00:00	1993-11-27	1993-11-27 00:00:00	32020		\N	58721	0	70704007	78272		0
4630	270	4285898	1995-02-15	1995-02-15 00:00:00	\N	\N	32020		\N	17961	0	68496003	4285898		0
4795	280	260139	2017-08-17	2017-08-17 00:00:00	2017-08-31	2017-08-31 00:00:00	32020		\N	18768	0	10509002	260139		0
4969	292	81151	1988-07-07	1988-07-07 00:00:00	1988-08-04	1988-08-04 00:00:00	32020		\N	19452	0	44465007	81151		0
5123	300	260139	2005-06-16	2005-06-16 00:00:00	2005-06-30	2005-06-30 00:00:00	32020		\N	20072	0	10509002	260139		0
5280	311	78272	2014-02-17	2014-02-17 00:00:00	2014-03-03	2014-03-03 00:00:00	32020		\N	20655	0	70704007	78272		0
15967	946	81893	1999-11-23	1999-11-23 00:00:00	\N	\N	32020		\N	62798	0	64766004	81893		0
16123	954	81151	1976-03-04	1976-03-04 00:00:00	1976-04-01	1976-04-01 00:00:00	32020		\N	63395	0	44465007	81151		0
5785	339	4112343	1993-04-22	1993-04-22 00:00:00	1993-05-03	1993-05-03 00:00:00	32020		\N	22619	0	195662009	4112343		0
5953	350	378001	2005-08-11	2005-08-11 00:00:00	2005-10-10	2005-10-10 00:00:00	32020		\N	23296	0	62106007	378001		0
6108	358	4112343	1978-03-08	1978-03-08 00:00:00	1978-03-16	1978-03-16 00:00:00	32020		\N	23790	0	195662009	4112343		0
6274	368	260139	2008-10-22	2008-10-22 00:00:00	2008-11-05	2008-11-05 00:00:00	32020		\N	24485	0	10509002	260139		0
6440	379	378001	1997-08-30	1997-08-30 00:00:00	1997-09-29	1997-09-29 00:00:00	32020		\N	25067	0	62106007	378001		0
17135	1024	317576	2016-05-29	2016-05-29 00:00:00	\N	\N	32020		\N	67432	0	53741008	317576		0
6773	399	4112343	1960-01-22	1960-01-22 00:00:00	1960-01-30	1960-01-30 00:00:00	32020		\N	26251	0	195662009	4112343		0
6945	408	28060	1964-08-22	1964-08-22 00:00:00	1964-09-02	1964-09-02 00:00:00	32020		\N	26985	0	43878008	28060		0
7112	418	40481087	1984-10-19	1984-10-19 00:00:00	1984-10-26	1984-10-26 00:00:00	32020		\N	27683	0	444814009	40481087		0
17807	1072	40481087	2015-10-21	2015-10-21 00:00:00	2015-11-11	2015-11-11 00:00:00	32020		\N	70265	0	444814009	40481087		0
7458	439	4134304	1993-04-08	1993-04-08 00:00:00	1993-06-07	1993-06-07 00:00:00	32020		\N	29153	0	263102004	4134304		0
7609	445	81151	1915-09-01	1915-09-01 00:00:00	1915-09-15	1915-09-15 00:00:00	32020		\N	29634	0	44465007	81151		0
7766	454	375671	1985-02-19	1985-02-19 00:00:00	1985-04-20	1985-04-20 00:00:00	32020		\N	30273	0	62564004	375671		0
18429	1108	4116491	2006-07-21	2006-07-21 00:00:00	2006-09-01	2006-09-01 00:00:00	32020		\N	72969	0	301011002	4116491		0
18593	1117	40481087	1988-03-27	1988-03-27 00:00:00	1988-04-03	1988-04-03 00:00:00	32020		\N	73572	0	444814009	40481087		0
18767	1128	372328	1971-07-28	1971-07-28 00:00:00	1971-12-31	1971-12-31 00:00:00	32020		\N	74335	0	65363002	372328		0
8428	489	4112343	1993-10-12	1993-10-12 00:00:00	1993-10-23	1993-10-23 00:00:00	32020		\N	32788	0	195662009	4112343		0
8614	502	4142905	2000-10-13	2000-10-13 00:00:00	2001-01-11	2001-01-11 00:00:00	32020		\N	33650	0	33737001	4142905		0
19265	1154	4112343	1981-02-14	1981-02-14 00:00:00	1981-02-23	1981-02-23 00:00:00	32020		\N	76279	0	195662009	4112343		0
19527	1173	260139	1957-08-06	1957-08-06 00:00:00	1957-08-20	1957-08-20 00:00:00	32020		\N	77221	0	10509002	260139		0
19599	1176	40481087	1993-09-15	1993-09-15 00:00:00	1993-10-06	1993-10-06 00:00:00	32020		\N	77695	0	444814009	40481087		0
19792	1189	4142905	1975-07-02	1975-07-02 00:00:00	1975-08-01	1975-08-01 00:00:00	32020		\N	78325	0	33737001	4142905		0
19932	1201	80180	2007-10-23	2007-10-23 00:00:00	\N	\N	32020		\N	79006	0	396275006	80180		0
20090	1211	40481087	1993-06-13	1993-06-13 00:00:00	1993-07-04	1993-07-04 00:00:00	32020		\N	79658	0	444814009	40481087		0
9771	578	260139	2009-07-22	2009-07-22 00:00:00	2009-07-29	2009-07-29 00:00:00	32020		\N	38275	0	10509002	260139		0
20431	1229	40481087	2019-06-24	2019-06-24 00:00:00	\N	\N	32020		\N	80985	0	444814009	40481087		0
20609	1237	4152936	1948-05-17	1948-05-17 00:00:00	1948-05-31	1948-05-31 00:00:00	32020		\N	81517	0	283385000	4152936		0
10273	607	40481087	1952-01-18	1952-01-18 00:00:00	1952-02-08	1952-02-08 00:00:00	32020		\N	40320	0	444814009	40481087		0
10429	614	378001	1990-06-21	1990-06-21 00:00:00	1990-08-20	1990-08-20 00:00:00	32020		\N	40851	0	62106007	378001		0
21106	1266	4112343	2018-10-21	2018-10-21 00:00:00	2018-10-30	2018-10-30 00:00:00	32020		\N	83445	0	195662009	4112343		0
126	5	40481087	2016-07-22	2016-07-22 00:00:00	2016-07-29	2016-07-29 00:00:00	32020		\N	528	0	444814009	40481087		0
325	17	4230399	1958-11-29	1958-11-29 00:00:00	1959-01-28	1959-01-28 00:00:00	32020		\N	1377	0	359817006	4230399		0
10988	649	260139	2010-03-23	2010-03-23 00:00:00	2010-04-06	2010-04-06 00:00:00	32020		\N	42993	0	10509002	260139		0
663	36	40481087	1974-02-02	1974-02-02 00:00:00	1974-02-16	1974-02-16 00:00:00	32020		\N	2507	0	444814009	40481087		0
804	42	40481087	1980-12-24	1980-12-24 00:00:00	1981-01-14	1981-01-14 00:00:00	32020		\N	2997	0	444814009	40481087		0
11523	680	372328	1969-08-23	1969-08-23 00:00:00	1970-03-02	1970-03-02 00:00:00	32020		\N	45046	0	65363002	372328		0
1151	67	4112343	2010-01-07	2010-01-07 00:00:00	2010-01-18	2010-01-18 00:00:00	32020		\N	4568	0	195662009	4112343		0
1325	78	28060	1985-05-13	1985-05-13 00:00:00	1985-05-23	1985-05-23 00:00:00	32020		\N	5178	0	43878008	28060		0
1476	86	28060	1953-05-03	1953-05-03 00:00:00	1953-05-15	1953-05-15 00:00:00	32020		\N	5769	0	43878008	28060		0
12141	719	260139	1992-06-16	1992-06-16 00:00:00	1992-06-30	1992-06-30 00:00:00	32020		\N	47558	0	10509002	260139		0
1801	102	40481087	2016-11-15	2016-11-15 00:00:00	2016-12-06	2016-12-06 00:00:00	32020		\N	7013	0	444814009	40481087		0
1992	116	40481087	1943-10-30	1943-10-30 00:00:00	1943-11-20	1943-11-20 00:00:00	32020		\N	7664	0	444814009	40481087		0
2149	124	4112343	1994-02-06	1994-02-06 00:00:00	1994-02-13	1994-02-13 00:00:00	32020		\N	8324	0	195662009	4112343		0
12824	756	40481087	2011-03-16	2011-03-16 00:00:00	2011-03-23	2011-03-23 00:00:00	32020		\N	50120	0	444814009	40481087		0
2475	145	372328	1950-10-21	1950-10-21 00:00:00	1950-11-04	1950-11-04 00:00:00	32020		\N	9775	0	65363002	372328		0
2649	155	40486433	1959-05-13	1959-05-13 00:00:00	1973-05-11	1973-05-11 00:00:00	32020		\N	10589	0	446096008	40486433		0
2795	161	40481087	2018-06-18	2018-06-18 00:00:00	2018-07-09	2018-07-09 00:00:00	32020		\N	11062	0	444814009	40481087		0
2981	173	260139	1983-11-03	1983-11-03 00:00:00	1983-11-10	1983-11-10 00:00:00	32020		\N	11767	0	10509002	260139		0
3128	184	80502	2016-08-01	2016-08-01 00:00:00	\N	\N	32020		\N	12437	0	64859006	80502		0
3272	190	4112343	1999-10-29	1999-10-29 00:00:00	1999-11-10	1999-11-10 00:00:00	32020		\N	12970	0	195662009	4112343		0
3454	197	81151	1969-02-03	1969-02-03 00:00:00	1969-03-03	1969-03-03 00:00:00	32020		\N	13528	0	44465007	81151		0
14134	834	4294548	1998-04-10	1998-04-10 00:00:00	1998-06-12	1998-06-12 00:00:00	32020		\N	55220	0	75498004	4294548		0
3804	219	260139	1968-08-28	1968-08-28 00:00:00	1968-09-11	1968-09-11 00:00:00	32020		\N	14766	0	10509002	260139		0
14452	855	195588	1993-11-14	1993-11-14 00:00:00	1994-01-02	1994-01-02 00:00:00	32020		\N	56462	0	38822007	195588		0
14610	863	40481087	2003-04-12	2003-04-12 00:00:00	2003-05-03	2003-05-03 00:00:00	32020		\N	57151	0	444814009	40481087		0
4309	248	40481087	2012-01-18	2012-01-18 00:00:00	2012-01-25	2012-01-25 00:00:00	32020		\N	16708	0	444814009	40481087		0
14972	882	4146173	1980-12-14	1980-12-14 00:00:00	1981-02-12	1981-02-12 00:00:00	32020		\N	58760	0	307731004	4146173		0
4631	270	40481087	1962-06-21	1962-06-21 00:00:00	1962-07-05	1962-07-05 00:00:00	32020		\N	17990	0	444814009	40481087		0
4796	280	40481087	1968-02-26	1968-02-26 00:00:00	1968-03-04	1968-03-04 00:00:00	32020		\N	18675	0	444814009	40481087		0
4970	292	40481087	1979-04-05	1979-04-05 00:00:00	1979-04-12	1979-04-12 00:00:00	32020		\N	19453	0	444814009	40481087		0
5124	300	80180	2009-11-30	2009-11-30 00:00:00	\N	\N	32020		\N	20038	0	396275006	80180		0
5281	311	28060	2016-01-11	2016-01-11 00:00:00	2016-01-22	2016-01-22 00:00:00	32020		\N	20618	0	43878008	28060		0
15968	946	4310024	1999-06-26	1999-06-26 00:00:00	\N	\N	32020		\N	62798	0	424802006	4310024		0
16124	954	260139	1978-12-21	1978-12-21 00:00:00	1978-12-28	1978-12-28 00:00:00	32020		\N	63369	0	10509002	260139		0
5786	339	4112343	1996-12-16	1996-12-16 00:00:00	1996-12-23	1996-12-23 00:00:00	32020		\N	22621	0	195662009	4112343		0
5954	350	4152936	1965-05-19	1965-05-19 00:00:00	1965-06-02	1965-06-02 00:00:00	32020		\N	23289	0	283385000	4152936		0
6109	359	257012	1991-09-14	1991-09-14 00:00:00	\N	\N	32020		\N	23865	0	40055000	257012		0
6275	368	28060	1990-09-29	1990-09-29 00:00:00	1990-10-06	1990-10-06 00:00:00	32020		\N	24515	0	43878008	28060		0
6441	379	372328	1980-01-02	1980-01-02 00:00:00	1980-03-08	1980-03-08 00:00:00	32020		\N	25076	0	65363002	372328		0
17136	1024	260139	1971-03-15	1971-03-15 00:00:00	1971-03-29	1971-03-29 00:00:00	32020		\N	67468	0	10509002	260139		0
17265	1033	40481087	1978-03-06	1978-03-06 00:00:00	1978-03-13	1978-03-13 00:00:00	32020		\N	67986	0	444814009	40481087		0
6946	408	40481087	1970-04-26	1970-04-26 00:00:00	1970-05-03	1970-05-03 00:00:00	32020		\N	26986	0	444814009	40481087		0
7113	419	4112343	1950-05-16	1950-05-16 00:00:00	1950-05-24	1950-05-24 00:00:00	32020		\N	27688	0	195662009	4112343		0
17808	1072	81151	1990-10-28	1990-10-28 00:00:00	1990-11-18	1990-11-18 00:00:00	32020		\N	70287	0	44465007	81151		0
7459	439	40481087	2009-07-05	2009-07-05 00:00:00	2009-07-19	2009-07-19 00:00:00	32020		\N	29117	0	444814009	40481087		0
18095	1086	80180	2004-07-21	2004-07-21 00:00:00	\N	\N	32020		\N	71339	0	396275006	80180		0
7767	454	4294548	1951-06-30	1951-06-30 00:00:00	1951-07-07	1951-07-07 00:00:00	32020		\N	30344	0	75498004	4294548		0
18430	1108	195588	2012-10-13	2012-10-13 00:00:00	2012-11-17	2012-11-17 00:00:00	32020		\N	72986	0	38822007	195588		0
18594	1117	40481087	1945-01-22	1945-01-22 00:00:00	1945-02-05	1945-02-05 00:00:00	32020		\N	73620	0	444814009	40481087		0
18768	1128	4294548	2009-05-01	2009-05-01 00:00:00	2009-05-29	2009-05-29 00:00:00	32020		\N	74317	0	75498004	4294548		0
8429	489	4027663	2004-05-24	2004-05-24 00:00:00	\N	\N	32020		\N	32777	0	13200003	4027663		0
8615	502	40481087	1974-08-05	1974-08-05 00:00:00	1974-08-12	1974-08-12 00:00:00	32020		\N	33633	0	444814009	40481087		0
19266	1154	4112343	1991-07-03	1991-07-03 00:00:00	1991-07-15	1991-07-15 00:00:00	32020		\N	76216	0	195662009	4112343		0
19528	1173	40481087	1968-12-05	1968-12-05 00:00:00	1968-12-12	1968-12-12 00:00:00	32020		\N	77222	0	444814009	40481087		0
19600	1176	372328	1964-10-08	1964-10-08 00:00:00	1965-03-26	1965-03-26 00:00:00	32020		\N	77705	0	65363002	372328		0
19793	1189	4112343	1970-12-29	1970-12-29 00:00:00	1971-01-08	1971-01-08 00:00:00	32020		\N	78348	0	195662009	4112343		0
19933	1201	78272	1979-03-09	1979-03-09 00:00:00	1979-03-30	1979-03-30 00:00:00	32020		\N	78980	0	70704007	78272		0
20091	1211	40481087	2004-02-24	2004-02-24 00:00:00	2004-03-09	2004-03-09 00:00:00	32020		\N	79515	0	444814009	40481087		0
9772	578	80180	2001-12-08	2001-12-08 00:00:00	\N	\N	32020		\N	38209	0	396275006	80180		0
20432	1229	260139	1957-07-29	1957-07-29 00:00:00	1957-08-05	1957-08-05 00:00:00	32020		\N	81006	0	10509002	260139		0
20610	1237	28060	1949-06-25	1949-06-25 00:00:00	1949-07-08	1949-07-08 00:00:00	32020		\N	81512	0	43878008	28060		0
10274	607	4112343	1986-02-24	1986-02-24 00:00:00	1986-03-09	1986-03-09 00:00:00	32020		\N	40328	0	195662009	4112343		0
10430	614	372328	1964-06-05	1964-06-05 00:00:00	1964-08-09	1964-08-09 00:00:00	32020		\N	40823	0	65363002	372328		0
21107	1266	260139	1992-07-21	1992-07-21 00:00:00	1992-08-04	1992-08-04 00:00:00	32020		\N	83487	0	10509002	260139		0
127	5	40481087	1977-08-14	1977-08-14 00:00:00	1977-08-28	1977-08-28 00:00:00	32020		\N	522	0	444814009	40481087		0
326	17	80180	1989-11-21	1989-11-21 00:00:00	\N	\N	32020		\N	1374	0	396275006	80180		0
10989	649	4027663	1998-02-05	1998-02-05 00:00:00	\N	\N	32020		\N	43005	0	13200003	4027663		0
664	36	40481087	1972-09-19	1972-09-19 00:00:00	1972-10-03	1972-10-03 00:00:00	32020		\N	2506	0	444814009	40481087		0
805	42	40481087	1968-06-01	1968-06-01 00:00:00	1968-06-22	1968-06-22 00:00:00	32020		\N	3053	0	444814009	40481087		0
11524	680	375671	1979-10-20	1979-10-20 00:00:00	1979-12-19	1979-12-19 00:00:00	32020		\N	45092	0	62564004	375671		0
1152	67	40481087	1977-12-17	1977-12-17 00:00:00	1978-01-07	1978-01-07 00:00:00	32020		\N	4536	0	444814009	40481087		0
1326	78	4112343	2014-09-07	2014-09-07 00:00:00	2014-09-18	2014-09-18 00:00:00	32020		\N	5182	0	195662009	4112343		0
1477	86	260139	1977-12-14	1977-12-14 00:00:00	1977-12-28	1977-12-28 00:00:00	32020		\N	5805	0	10509002	260139		0
12142	719	4059173	2016-08-19	2016-08-19 00:00:00	2016-11-17	2016-11-17 00:00:00	32020		\N	47566	0	16114001	4059173		0
1802	102	257012	1989-09-04	1989-09-04 00:00:00	1989-10-02	1989-10-02 00:00:00	32020		\N	7011	0	40055000	257012		0
12451	736	4294548	1997-12-03	1997-12-03 00:00:00	1997-12-17	1997-12-17 00:00:00	32020		\N	48840	0	75498004	4294548		0
2150	124	261325	2011-03-22	2011-03-22 00:00:00	\N	\N	32020		\N	8272	0	87433001	261325		0
12825	756	4027663	1991-07-29	1991-07-29 00:00:00	\N	\N	32020		\N	50164	0	13200003	4027663		0
2476	145	80180	1990-10-06	1990-10-06 00:00:00	\N	\N	32020		\N	9746	0	396275006	80180		0
2650	155	4112343	1971-05-11	1971-05-11 00:00:00	1971-05-23	1971-05-23 00:00:00	32020		\N	10627	0	195662009	4112343		0
2796	161	4113008	2011-07-21	2011-07-21 00:00:00	2011-08-11	2011-08-11 00:00:00	32020		\N	11058	0	284549007	4113008		0
13447	793	375671	1984-10-07	1984-10-07 00:00:00	1984-11-06	1984-11-06 00:00:00	32020		\N	52611	0	62564004	375671		0
3129	184	40481087	2015-12-02	2015-12-02 00:00:00	2015-12-09	2015-12-09 00:00:00	32020		\N	12421	0	444814009	40481087		0
3273	190	257012	1982-11-16	1982-11-16 00:00:00	\N	\N	32020		\N	13014	0	40055000	257012		0
3455	197	260139	1984-08-24	1984-08-24 00:00:00	1984-09-07	1984-09-07 00:00:00	32020		\N	13536	0	10509002	260139		0
14135	834	257012	1992-04-24	1992-04-24 00:00:00	\N	\N	32020		\N	55242	0	40055000	257012		0
3805	219	260139	1991-11-27	1991-11-27 00:00:00	1991-12-11	1991-12-11 00:00:00	32020		\N	14727	0	10509002	260139		0
14453	855	4152936	1967-07-29	1967-07-29 00:00:00	1967-08-12	1967-08-12 00:00:00	32020		\N	56514	0	283385000	4152936		0
14611	863	40481087	1978-01-08	1978-01-08 00:00:00	1978-01-22	1978-01-22 00:00:00	32020		\N	57141	0	444814009	40481087		0
4310	248	260139	1981-02-16	1981-02-16 00:00:00	1981-03-02	1981-03-02 00:00:00	32020		\N	16677	0	10509002	260139		0
14973	882	40481087	1987-05-23	1987-05-23 00:00:00	1987-06-13	1987-06-13 00:00:00	32020		\N	58728	0	444814009	40481087		0
4632	270	4112343	2007-09-22	2007-09-22 00:00:00	2007-10-03	2007-10-03 00:00:00	32020		\N	18014	0	195662009	4112343		0
4797	280	4142905	1962-03-10	1962-03-10 00:00:00	1962-04-09	1962-04-09 00:00:00	32020		\N	18704	0	33737001	4142905		0
4971	293	81151	2018-03-04	2018-03-04 00:00:00	2018-03-25	2018-03-25 00:00:00	32020		\N	19516	0	44465007	81151		0
5125	300	40481087	1995-01-20	1995-01-20 00:00:00	1995-01-27	1995-01-27 00:00:00	32020		\N	20053	0	444814009	40481087		0
5282	311	260139	1993-11-10	1993-11-10 00:00:00	1993-11-17	1993-11-17 00:00:00	32020		\N	20637	0	10509002	260139		0
15969	946	28060	2015-02-23	2015-02-23 00:00:00	2015-03-07	2015-03-07 00:00:00	32020		\N	62815	0	43878008	28060		0
16125	954	81151	1997-11-28	1997-11-28 00:00:00	1997-12-26	1997-12-26 00:00:00	32020		\N	63418	0	44465007	81151		0
5787	339	80180	2019-06-21	2019-06-21 00:00:00	\N	\N	32020		\N	22635	0	396275006	80180		0
5955	350	260139	2008-11-01	2008-11-01 00:00:00	2008-11-08	2008-11-08 00:00:00	32020		\N	23259	0	10509002	260139		0
6110	359	80180	2014-10-28	2014-10-28 00:00:00	\N	\N	32020		\N	23924	0	396275006	80180		0
6276	368	40481087	2004-12-21	2004-12-21 00:00:00	2005-01-11	2005-01-11 00:00:00	32020		\N	24484	0	444814009	40481087		0
6442	379	40481087	1982-09-27	1982-09-27 00:00:00	1982-10-04	1982-10-04 00:00:00	32020		\N	25062	0	444814009	40481087		0
17137	1024	40481087	1972-12-26	1972-12-26 00:00:00	1973-01-02	1973-01-02 00:00:00	32020		\N	67435	0	444814009	40481087		0
17266	1033	28060	1984-01-28	1984-01-28 00:00:00	1984-02-06	1984-02-06 00:00:00	32020		\N	67972	0	43878008	28060		0
6947	408	4296204	2014-12-24	2014-12-24 00:00:00	2015-01-28	2015-01-28 00:00:00	32020		\N	26974	0	403190006	4296204		0
7114	419	257012	1959-09-18	1959-09-18 00:00:00	\N	\N	32020		\N	27787	0	40055000	257012		0
17809	1072	260139	1990-10-20	1990-10-20 00:00:00	1990-10-27	1990-10-27 00:00:00	32020		\N	70258	0	10509002	260139		0
7460	439	4146173	2013-08-12	2013-08-12 00:00:00	2013-09-11	2013-09-11 00:00:00	32020		\N	29107	0	307731004	4146173		0
18096	1086	4285898	2004-04-22	2004-04-22 00:00:00	\N	\N	32020		\N	71339	0	68496003	4285898		0
7768	454	4112343	2017-09-04	2017-09-04 00:00:00	2017-09-17	2017-09-17 00:00:00	32020		\N	30291	0	195662009	4112343		0
18431	1108	260139	2014-09-05	2014-09-05 00:00:00	2014-09-19	2014-09-19 00:00:00	32020		\N	72944	0	10509002	260139		0
18595	1118	4310024	2011-12-01	2011-12-01 00:00:00	\N	\N	32020		\N	73734	0	424802006	4310024		0
18769	1128	260139	1979-04-29	1979-04-29 00:00:00	1979-05-13	1979-05-13 00:00:00	32020		\N	74329	0	10509002	260139		0
8430	489	78272	1987-04-29	1987-04-29 00:00:00	1987-05-13	1987-05-13 00:00:00	32020		\N	32704	0	70704007	78272		0
8616	502	4155034	1953-10-06	1953-10-06 00:00:00	1953-10-20	1953-10-20 00:00:00	32020		\N	33649	0	283371005	4155034		0
19267	1154	4134304	2002-05-21	2002-05-21 00:00:00	2002-08-19	2002-08-19 00:00:00	32020		\N	76272	0	263102004	4134304		0
19529	1173	4146173	1969-11-29	1969-11-29 00:00:00	1969-12-29	1969-12-29 00:00:00	32020		\N	77207	0	307731004	4146173		0
19601	1176	4027663	1989-10-12	1989-10-12 00:00:00	\N	\N	32020		\N	77601	0	13200003	4027663		0
19794	1189	372328	1968-11-05	1968-11-05 00:00:00	1969-11-17	1969-11-17 00:00:00	32020		\N	78355	0	65363002	372328		0
19934	1201	372328	1976-01-24	1976-01-24 00:00:00	1976-03-17	1976-03-17 00:00:00	32020		\N	79021	0	65363002	372328		0
20092	1211	4109685	1980-10-07	1980-10-07 00:00:00	1980-10-21	1980-10-21 00:00:00	32020		\N	79570	0	284551006	4109685		0
9773	578	28060	1996-12-18	1996-12-18 00:00:00	1996-12-28	1996-12-28 00:00:00	32020		\N	38269	0	43878008	28060		0
20433	1229	40481087	1955-12-12	1955-12-12 00:00:00	1956-01-02	1956-01-02 00:00:00	32020		\N	80976	0	444814009	40481087		0
20611	1237	260139	1971-02-18	1971-02-18 00:00:00	1971-02-25	1971-02-25 00:00:00	32020		\N	81522	0	10509002	260139		0
10275	607	40481087	2014-06-01	2014-06-01 00:00:00	2014-06-15	2014-06-15 00:00:00	32020		\N	40281	0	444814009	40481087		0
10431	614	4112343	1967-06-16	1967-06-16 00:00:00	1967-06-24	1967-06-24 00:00:00	32020		\N	40855	0	195662009	4112343		0
21108	1267	4116491	1996-04-27	1996-04-27 00:00:00	1996-06-03	1996-06-03 00:00:00	32020		\N	83575	0	301011002	4116491		0
128	5	40481087	1989-10-02	1989-10-02 00:00:00	1989-10-23	1989-10-23 00:00:00	32020		\N	407	0	444814009	40481087		0
327	17	4156265	1989-09-27	1989-09-27 00:00:00	1989-10-18	1989-10-18 00:00:00	32020		\N	1374	0	370247008	4156265		0
10990	649	4112343	1987-06-26	1987-06-26 00:00:00	1987-07-09	1987-07-09 00:00:00	32020		\N	43035	0	195662009	4112343		0
11123	656	4266809	2008-04-07	2008-04-07 00:00:00	\N	\N	32020		\N	43457	0	397881000	4266809		0
806	42	4112343	1962-12-24	1962-12-24 00:00:00	1963-01-03	1963-01-03 00:00:00	32020		\N	3052	0	195662009	4112343		0
11525	680	4218389	2008-09-01	2008-09-01 00:00:00	2008-10-06	2008-10-06 00:00:00	32020		\N	45094	0	39848009	4218389		0
1153	67	372328	1973-03-06	1973-03-06 00:00:00	1973-03-20	1973-03-20 00:00:00	32020		\N	4516	0	65363002	372328		0
1327	78	260139	2009-04-14	2009-04-14 00:00:00	2009-04-21	2009-04-21 00:00:00	32020		\N	5193	0	10509002	260139		0
1478	86	40481087	1954-08-13	1954-08-13 00:00:00	1954-08-20	1954-08-20 00:00:00	32020		\N	5802	0	444814009	40481087		0
12143	719	81151	1983-08-31	1983-08-31 00:00:00	1983-09-28	1983-09-28 00:00:00	32020		\N	47563	0	44465007	81151		0
1803	102	4283893	1989-07-03	1989-07-03 00:00:00	1989-10-02	1989-10-02 00:00:00	32020		\N	6998	0	36971009	4283893		0
12452	736	40481087	2010-08-02	2010-08-02 00:00:00	2010-08-23	2010-08-23 00:00:00	32020		\N	48805	0	444814009	40481087		0
2151	124	40481087	2013-09-24	2013-09-24 00:00:00	2013-10-01	2013-10-01 00:00:00	32020		\N	8333	0	444814009	40481087		0
12826	756	80180	2001-02-06	2001-02-06 00:00:00	\N	\N	32020		\N	50107	0	396275006	80180		0
2477	145	40481087	1954-02-11	1954-02-11 00:00:00	1954-02-25	1954-02-25 00:00:00	32020		\N	9684	0	444814009	40481087		0
2651	155	40481087	1980-06-15	1980-06-15 00:00:00	1980-06-22	1980-06-22 00:00:00	32020		\N	10628	0	444814009	40481087		0
2797	161	4109685	2018-07-03	2018-07-03 00:00:00	2018-07-17	2018-07-17 00:00:00	32020		\N	11061	0	284551006	4109685		0
13448	793	40481087	1974-08-06	1974-08-06 00:00:00	1974-08-20	1974-08-20 00:00:00	32020		\N	52613	0	444814009	40481087		0
3130	184	257012	2006-05-26	2006-05-26 00:00:00	\N	\N	32020		\N	12419	0	40055000	257012		0
3274	190	4218389	1997-09-19	1997-09-19 00:00:00	1997-10-17	1997-10-17 00:00:00	32020		\N	12999	0	39848009	4218389		0
3456	197	4027663	1989-09-11	1989-09-11 00:00:00	\N	\N	32020		\N	13584	0	13200003	4027663		0
14139	836	257012	1989-01-25	1989-01-25 00:00:00	\N	\N	32020		\N	55293	0	40055000	257012		0
3806	220	260139	1984-11-21	1984-11-21 00:00:00	1984-11-28	1984-11-28 00:00:00	32020		\N	14863	0	10509002	260139		0
14454	855	378001	1958-09-14	1958-09-14 00:00:00	1958-10-14	1958-10-14 00:00:00	32020		\N	56513	0	62106007	378001		0
14612	863	4112343	1970-11-20	1970-11-20 00:00:00	1970-11-28	1970-11-28 00:00:00	32020		\N	57140	0	195662009	4112343		0
4311	248	378001	2016-11-08	2016-11-08 00:00:00	2016-12-08	2016-12-08 00:00:00	32020		\N	16668	0	62106007	378001		0
14974	882	4149245	2013-06-20	2013-06-20 00:00:00	2013-08-26	2013-08-26 00:00:00	32020		\N	58723	0	30832001	4149245		0
15107	890	4112343	1988-04-03	1988-04-03 00:00:00	1988-04-15	1988-04-15 00:00:00	32020		\N	59336	0	195662009	4112343		0
4798	280	80180	1975-01-07	1975-01-07 00:00:00	\N	\N	32020		\N	18681	0	396275006	80180		0
4972	293	260139	1975-01-20	1975-01-20 00:00:00	1975-02-03	1975-02-03 00:00:00	32020		\N	19533	0	10509002	260139		0
5126	300	4112343	2002-11-03	2002-11-03 00:00:00	2002-11-15	2002-11-15 00:00:00	32020		\N	20054	0	195662009	4112343		0
5283	311	4152936	2004-08-24	2004-08-24 00:00:00	2004-09-07	2004-09-07 00:00:00	32020		\N	20654	0	283385000	4152936		0
15970	946	4278672	1975-04-23	1975-04-23 00:00:00	1975-06-22	1975-06-22 00:00:00	32020		\N	62809	0	65966004	4278672		0
16126	954	28060	1994-04-14	1994-04-14 00:00:00	1994-04-25	1994-04-25 00:00:00	32020		\N	63376	0	43878008	28060		0
5788	339	40481087	2016-08-19	2016-08-19 00:00:00	2016-09-02	2016-09-02 00:00:00	32020		\N	22610	0	444814009	40481087		0
5956	350	28060	1994-03-03	1994-03-03 00:00:00	1994-03-11	1994-03-11 00:00:00	32020		\N	23326	0	43878008	28060		0
6111	359	4112343	2008-03-06	2008-03-06 00:00:00	2008-03-19	2008-03-19 00:00:00	32020		\N	23870	0	195662009	4112343		0
6277	368	81151	1982-03-12	1982-03-12 00:00:00	1982-03-26	1982-03-26 00:00:00	32020		\N	24497	0	44465007	81151		0
6443	379	257012	2000-05-17	2000-05-17 00:00:00	\N	\N	32020		\N	25108	0	40055000	257012		0
17138	1024	40481087	1954-12-24	1954-12-24 00:00:00	1954-12-31	1954-12-31 00:00:00	32020		\N	67434	0	444814009	40481087		0
17267	1033	40481087	1981-01-28	1981-01-28 00:00:00	1981-02-11	1981-02-11 00:00:00	32020		\N	68010	0	444814009	40481087		0
6948	409	4116491	1991-09-26	1991-09-26 00:00:00	1991-11-08	1991-11-08 00:00:00	32020		\N	27100	0	301011002	4116491		0
7115	419	4112343	1928-09-11	1928-09-11 00:00:00	1928-09-19	1928-09-19 00:00:00	32020		\N	27686	0	195662009	4112343		0
17810	1072	4294548	1988-07-09	1988-07-09 00:00:00	1988-07-30	1988-07-30 00:00:00	32020		\N	70276	0	75498004	4294548		0
20263	1219	313217	2007-12-10	2007-12-10 00:00:00	\N	\N	32020		\N	80264	0	49436004	313217		0
7461	439	372328	1982-06-26	1982-06-26 00:00:00	1983-05-05	1983-05-05 00:00:00	32020		\N	29118	0	65363002	372328		0
18097	1086	4310024	2002-07-02	2002-07-02 00:00:00	\N	\N	32020		\N	71336	0	424802006	4310024		0
7769	454	40481087	1948-01-28	1948-01-28 00:00:00	1948-02-11	1948-02-11 00:00:00	32020		\N	30278	0	444814009	40481087		0
18432	1108	4116491	2011-08-31	2011-08-31 00:00:00	2011-10-14	2011-10-14 00:00:00	32020		\N	72970	0	301011002	4116491		0
18596	1118	81893	2012-01-30	2012-01-30 00:00:00	\N	\N	32020		\N	73734	0	64766004	81893		0
18770	1128	4294548	1991-08-23	1991-08-23 00:00:00	1991-09-06	1991-09-06 00:00:00	32020		\N	74330	0	75498004	4294548		0
8431	489	4218389	2000-08-02	2000-08-02 00:00:00	2000-08-30	2000-08-30 00:00:00	32020		\N	32706	0	39848009	4218389		0
8617	502	40481087	1979-08-25	1979-08-25 00:00:00	1979-09-01	1979-09-01 00:00:00	32020		\N	33582	0	444814009	40481087		0
19268	1154	40481087	1971-04-10	1971-04-10 00:00:00	1971-05-01	1971-05-01 00:00:00	32020		\N	76277	0	444814009	40481087		0
19530	1173	40481087	2009-07-20	2009-07-20 00:00:00	2009-07-27	2009-07-27 00:00:00	32020		\N	77210	0	444814009	40481087		0
19602	1176	4112343	1988-01-24	1988-01-24 00:00:00	1988-02-01	1988-02-01 00:00:00	32020		\N	77601	0	195662009	4112343		0
19795	1189	81151	1980-03-07	1980-03-07 00:00:00	1980-03-28	1980-03-28 00:00:00	32020		\N	78326	0	44465007	81151		0
19935	1201	4152936	1995-11-01	1995-11-01 00:00:00	1995-11-15	1995-11-15 00:00:00	32020		\N	78981	0	283385000	4152936		0
20093	1211	40481087	1994-03-06	1994-03-06 00:00:00	1994-03-27	1994-03-27 00:00:00	32020		\N	79626	0	444814009	40481087		0
9774	578	40481087	2009-02-27	2009-02-27 00:00:00	2009-03-13	2009-03-13 00:00:00	32020		\N	38274	0	444814009	40481087		0
20434	1229	40481087	2001-09-04	2001-09-04 00:00:00	2001-09-18	2001-09-18 00:00:00	32020		\N	80978	0	444814009	40481087		0
20612	1237	4112343	1963-07-09	1963-07-09 00:00:00	1963-07-19	1963-07-19 00:00:00	32020		\N	81499	0	195662009	4112343		0
10276	607	28060	1984-09-05	1984-09-05 00:00:00	1984-09-16	1984-09-16 00:00:00	32020		\N	40269	0	43878008	28060		0
10432	614	4112343	1984-05-26	1984-05-26 00:00:00	1984-06-04	1984-06-04 00:00:00	32020		\N	40820	0	195662009	4112343		0
21109	1267	4059173	1955-02-06	1955-02-06 00:00:00	1955-03-08	1955-03-08 00:00:00	32020		\N	83565	0	16114001	4059173		0
129	5	4048171	1973-07-30	1973-07-30 00:00:00	1987-07-29	1987-07-29 00:00:00	32020		\N	402	0	232353008	4048171		0
328	17	4296205	1971-10-27	1971-10-27 00:00:00	1971-12-01	1971-12-01 00:00:00	32020		\N	1373	0	403191005	4296205		0
10991	649	260139	1973-08-16	1973-08-16 00:00:00	1973-08-23	1973-08-23 00:00:00	32020		\N	42990	0	10509002	260139		0
11124	656	28060	1971-06-06	1971-06-06 00:00:00	1971-06-19	1971-06-19 00:00:00	32020		\N	43433	0	43878008	28060		0
807	43	4112343	1993-05-16	1993-05-16 00:00:00	1993-05-27	1993-05-27 00:00:00	32020		\N	3146	0	195662009	4112343		0
11526	680	4112343	1983-07-06	1983-07-06 00:00:00	1983-07-18	1983-07-18 00:00:00	32020		\N	45003	0	195662009	4112343		0
1154	67	4112343	2006-07-13	2006-07-13 00:00:00	2006-07-25	2006-07-25 00:00:00	32020		\N	4540	0	195662009	4112343		0
1328	78	4156265	1968-11-25	1968-11-25 00:00:00	1968-12-16	1968-12-16 00:00:00	32020		\N	5162	0	370247008	4156265		0
1479	86	81151	2014-12-28	2014-12-28 00:00:00	2015-01-25	2015-01-25 00:00:00	32020		\N	5767	0	44465007	81151		0
12144	719	80180	2014-08-23	2014-08-23 00:00:00	\N	\N	32020		\N	47556	0	396275006	80180		0
1804	102	4112343	1991-03-22	1991-03-22 00:00:00	1991-04-03	1991-04-03 00:00:00	32020		\N	6962	0	195662009	4112343		0
12453	736	440086	1985-01-02	1985-01-02 00:00:00	1986-11-05	1986-11-05 00:00:00	32020		\N	48786	0	192127007	440086		0
2152	124	372328	1989-09-12	1989-09-12 00:00:00	1990-02-19	1990-02-19 00:00:00	32020		\N	8259	0	65363002	372328		0
12827	756	40481087	2000-04-20	2000-04-20 00:00:00	2000-05-04	2000-05-04 00:00:00	32020		\N	50107	0	444814009	40481087		0
2478	145	4156265	1982-06-01	1982-06-01 00:00:00	1982-06-22	1982-06-22 00:00:00	32020		\N	9801	0	370247008	4156265		0
2652	155	4156265	1985-09-21	1985-09-21 00:00:00	1985-10-05	1985-10-05 00:00:00	32020		\N	10528	0	370247008	4156265		0
2798	161	4218389	2013-07-31	2013-07-31 00:00:00	2013-08-28	2013-08-28 00:00:00	32020		\N	11059	0	39848009	4218389		0
13449	793	260139	2017-11-18	2017-11-18 00:00:00	2017-11-25	2017-11-25 00:00:00	32020		\N	52618	0	10509002	260139		0
3131	184	4112343	1972-10-07	1972-10-07 00:00:00	1972-10-16	1972-10-16 00:00:00	32020		\N	12474	0	195662009	4112343		0
3275	190	4116491	1963-06-30	1963-06-30 00:00:00	1963-08-20	1963-08-20 00:00:00	32020		\N	13013	0	301011002	4116491		0
3457	197	40481087	1988-03-20	1988-03-20 00:00:00	1988-04-10	1988-04-10 00:00:00	32020		\N	13584	0	444814009	40481087		0
14140	836	372328	1979-12-10	1979-12-10 00:00:00	1980-02-10	1980-02-10 00:00:00	32020		\N	55329	0	65363002	372328		0
3807	220	4109685	1985-03-19	1985-03-19 00:00:00	1985-04-09	1985-04-09 00:00:00	32020		\N	14836	0	284551006	4109685		0
14455	855	372328	1958-03-18	1958-03-18 00:00:00	1958-05-02	1958-05-02 00:00:00	32020		\N	56503	0	65363002	372328		0
14613	863	4112343	2002-05-17	2002-05-17 00:00:00	2002-05-24	2002-05-24 00:00:00	32020		\N	57142	0	195662009	4112343		0
4312	248	4112343	1983-12-06	1983-12-06 00:00:00	1983-12-18	1983-12-18 00:00:00	32020		\N	16687	0	195662009	4112343		0
14975	882	440086	1955-12-21	1955-12-21 00:00:00	1962-12-29	1962-12-29 00:00:00	32020		\N	58748	0	192127007	440086		0
15108	890	28060	1963-09-08	1963-09-08 00:00:00	1963-09-19	1963-09-19 00:00:00	32020		\N	59329	0	43878008	28060		0
4799	280	4112343	1997-06-01	1997-06-01 00:00:00	1997-06-11	1997-06-11 00:00:00	32020		\N	18714	0	195662009	4112343		0
4973	293	260139	1983-08-22	1983-08-22 00:00:00	1983-08-29	1983-08-29 00:00:00	32020		\N	19534	0	10509002	260139		0
5127	300	4112343	1982-08-31	1982-08-31 00:00:00	1982-09-09	1982-09-09 00:00:00	32020		\N	20074	0	195662009	4112343		0
5284	311	4237458	1987-09-23	1987-09-23 00:00:00	1987-12-22	1987-12-22 00:00:00	32020		\N	20651	0	58150001	4237458		0
15971	946	4285898	2000-11-17	2000-11-17 00:00:00	\N	\N	32020		\N	62825	0	68496003	4285898		0
16127	954	4112343	1984-03-16	1984-03-16 00:00:00	1984-03-23	1984-03-23 00:00:00	32020		\N	63370	0	195662009	4112343		0
5789	339	4283893	1994-10-17	1994-10-17 00:00:00	1995-02-13	1995-02-13 00:00:00	32020		\N	22620	0	36971009	4283893		0
5957	350	4155034	1999-05-10	1999-05-10 00:00:00	1999-05-24	1999-05-24 00:00:00	32020		\N	23294	0	283371005	4155034		0
6112	359	4112343	1992-02-15	1992-02-15 00:00:00	1992-02-25	1992-02-25 00:00:00	32020		\N	23867	0	195662009	4112343		0
6278	369	81151	1993-11-19	1993-11-19 00:00:00	1993-12-03	1993-12-03 00:00:00	32020		\N	24578	0	44465007	81151		0
6444	379	4112343	1984-09-09	1984-09-09 00:00:00	1984-09-20	1984-09-20 00:00:00	32020		\N	25063	0	195662009	4112343		0
17139	1024	40481087	1995-09-25	1995-09-25 00:00:00	1995-10-16	1995-10-16 00:00:00	32020		\N	67401	0	444814009	40481087		0
17268	1033	40481087	2015-01-10	2015-01-10 00:00:00	2015-01-17	2015-01-17 00:00:00	32020		\N	68014	0	444814009	40481087		0
6949	409	4084167	1951-12-30	1951-12-30 00:00:00	1951-12-30	1951-12-30 00:00:00	32020		\N	27031	0	241929008	4084167		0
7116	419	81151	1988-12-08	1988-12-08 00:00:00	1989-01-12	1989-01-12 00:00:00	32020		\N	27760	0	44465007	81151		0
17811	1072	40481087	1996-10-22	1996-10-22 00:00:00	1996-10-29	1996-10-29 00:00:00	32020		\N	70260	0	444814009	40481087		0
7462	439	40481087	1990-01-03	1990-01-03 00:00:00	1990-01-17	1990-01-17 00:00:00	32020		\N	29165	0	444814009	40481087		0
18098	1086	30753	2003-11-24	2003-11-24 00:00:00	\N	\N	32020		\N	71336	0	16761005	30753		0
7770	454	4112343	1937-05-21	1937-05-21 00:00:00	1937-05-28	1937-05-28 00:00:00	32020		\N	30288	0	195662009	4112343		0
18433	1108	28060	1979-07-11	1979-07-11 00:00:00	1979-07-23	1979-07-23 00:00:00	32020		\N	72946	0	43878008	28060		0
18597	1118	372328	1975-11-30	1975-11-30 00:00:00	1976-01-18	1976-01-18 00:00:00	32020		\N	73688	0	65363002	372328		0
18782	1131	372328	1967-07-15	1967-07-15 00:00:00	1968-01-17	1968-01-17 00:00:00	32020		\N	74426	0	65363002	372328		0
8432	489	4112343	1976-12-26	1976-12-26 00:00:00	1977-01-06	1977-01-06 00:00:00	32020		\N	32717	0	195662009	4112343		0
19269	1154	4116491	1995-08-31	1995-08-31 00:00:00	1995-10-19	1995-10-19 00:00:00	32020		\N	76217	0	301011002	4116491		0
19531	1173	4237458	1949-03-19	1949-03-19 00:00:00	1949-04-18	1949-04-18 00:00:00	32020		\N	77274	0	58150001	4237458		0
19603	1176	40481087	2011-05-07	2011-05-07 00:00:00	2011-05-14	2011-05-14 00:00:00	32020		\N	77679	0	444814009	40481087		0
19796	1189	40481087	2014-08-29	2014-08-29 00:00:00	2014-09-12	2014-09-12 00:00:00	32020		\N	78321	0	444814009	40481087		0
19936	1201	192671	2008-01-19	2008-01-19 00:00:00	\N	\N	32020		\N	79031	0	K92.2	35208414		0
20094	1211	40481087	1977-05-08	1977-05-08 00:00:00	1977-05-29	1977-05-29 00:00:00	32020		\N	79597	0	444814009	40481087		0
9775	578	372328	1968-11-21	1968-11-21 00:00:00	1969-02-26	1969-02-26 00:00:00	32020		\N	38281	0	65363002	372328		0
20435	1229	134438	1980-05-15	1980-05-15 00:00:00	1981-01-10	1981-01-10 00:00:00	32020		\N	81012	0	40275004	134438		0
20613	1237	4112343	1956-05-04	1956-05-04 00:00:00	1956-05-15	1956-05-15 00:00:00	32020		\N	81498	0	195662009	4112343		0
10277	607	4278672	1957-06-11	1957-06-11 00:00:00	1957-09-09	1957-09-09 00:00:00	32020		\N	40298	0	65966004	4278672		0
10433	615	260139	1914-01-03	1914-01-03 00:00:00	1914-01-17	1914-01-17 00:00:00	32020		\N	41002	0	10509002	260139		0
21110	1267	28060	2016-01-21	2016-01-21 00:00:00	2016-02-02	2016-02-02 00:00:00	32020		\N	83552	0	43878008	28060		0
130	5	260139	1971-03-12	1971-03-12 00:00:00	1971-03-26	1971-03-26 00:00:00	32020		\N	401	0	10509002	260139		0
329	17	4283893	1984-08-08	1984-08-08 00:00:00	1984-09-19	1984-09-19 00:00:00	32020		\N	1288	0	36971009	4283893		0
10992	649	372328	1970-07-02	1970-07-02 00:00:00	1970-07-16	1970-07-16 00:00:00	32020		\N	43025	0	65363002	372328		0
11125	656	4027663	1995-12-27	1995-12-27 00:00:00	\N	\N	32020		\N	43441	0	13200003	4027663		0
808	43	80180	1997-03-22	1997-03-22 00:00:00	\N	\N	32020		\N	3184	0	396275006	80180		0
11527	680	260139	1989-03-19	1989-03-19 00:00:00	1989-04-02	1989-04-02 00:00:00	32020		\N	44995	0	10509002	260139		0
1155	67	40481087	1997-05-11	1997-05-11 00:00:00	1997-05-18	1997-05-18 00:00:00	32020		\N	4567	0	444814009	40481087		0
11790	697	40481087	2000-05-22	2000-05-22 00:00:00	2000-06-05	2000-06-05 00:00:00	32020		\N	46122	0	444814009	40481087		0
1480	86	40481087	1973-01-10	1973-01-10 00:00:00	1973-01-17	1973-01-17 00:00:00	32020		\N	5794	0	444814009	40481087		0
12145	719	4059173	2009-09-11	2009-09-11 00:00:00	2009-10-11	2009-10-11 00:00:00	32020		\N	47564	0	16114001	4059173		0
1805	102	372328	1974-01-16	1974-01-16 00:00:00	1974-06-02	1974-06-02 00:00:00	32020		\N	6971	0	65363002	372328		0
12454	736	260139	2002-08-21	2002-08-21 00:00:00	2002-09-04	2002-09-04 00:00:00	32020		\N	48842	0	10509002	260139		0
2153	124	260139	1990-02-03	1990-02-03 00:00:00	1990-02-10	1990-02-10 00:00:00	32020		\N	8226	0	10509002	260139		0
12828	756	40481087	2013-08-14	2013-08-14 00:00:00	2013-08-28	2013-08-28 00:00:00	32020		\N	50108	0	444814009	40481087		0
2479	145	4035415	1973-01-28	1973-01-28 00:00:00	1973-03-29	1973-03-29 00:00:00	32020		\N	9798	0	239720000	4035415		0
2653	155	40481087	2003-07-19	2003-07-19 00:00:00	2003-07-26	2003-07-26 00:00:00	32020		\N	10555	0	444814009	40481087		0
2799	161	40481087	1989-02-25	1989-02-25 00:00:00	1989-03-18	1989-03-18 00:00:00	32020		\N	11046	0	444814009	40481087		0
13450	793	4112343	1980-03-06	1980-03-06 00:00:00	1980-03-15	1980-03-15 00:00:00	32020		\N	52623	0	195662009	4112343		0
3132	184	4112343	1950-06-12	1950-06-12 00:00:00	1950-06-20	1950-06-20 00:00:00	32020		\N	12496	0	195662009	4112343		0
3276	190	40481087	1975-12-06	1975-12-06 00:00:00	1975-12-20	1975-12-20 00:00:00	32020		\N	12914	0	444814009	40481087		0
3458	197	28060	2015-02-26	2015-02-26 00:00:00	2015-03-07	2015-03-07 00:00:00	32020		\N	13548	0	43878008	28060		0
14141	836	372328	1980-12-06	1980-12-06 00:00:00	1981-02-08	1981-02-08 00:00:00	32020		\N	55312	0	65363002	372328		0
3808	220	260139	1990-01-12	1990-01-12 00:00:00	1990-01-26	1990-01-26 00:00:00	32020		\N	14864	0	10509002	260139		0
14456	855	40481087	1988-02-05	1988-02-05 00:00:00	1988-02-26	1988-02-26 00:00:00	32020		\N	56460	0	444814009	40481087		0
14614	863	313217	1981-01-29	1981-01-29 00:00:00	\N	\N	32020		\N	57216	0	49436004	313217		0
4313	248	80180	2012-12-09	2012-12-09 00:00:00	\N	\N	32020		\N	16680	0	396275006	80180		0
14976	882	81151	2002-02-13	2002-02-13 00:00:00	2002-03-20	2002-03-20 00:00:00	32020		\N	58722	0	44465007	81151		0
15109	890	40481087	1974-01-05	1974-01-05 00:00:00	1974-01-19	1974-01-19 00:00:00	32020		\N	59333	0	444814009	40481087		0
4812	283	4112343	1992-04-27	1992-04-27 00:00:00	1992-05-08	1992-05-08 00:00:00	32020		\N	18825	0	195662009	4112343		0
4974	293	4112343	1971-10-10	1971-10-10 00:00:00	1971-10-23	1971-10-23 00:00:00	32020		\N	19504	0	195662009	4112343		0
15605	924	4112343	2011-04-30	2011-04-30 00:00:00	2011-05-07	2011-05-07 00:00:00	32020		\N	61530	0	195662009	4112343		0
5285	311	4094814	1993-08-22	1993-08-22 00:00:00	1993-09-21	1993-09-21 00:00:00	32020		\N	20652	0	262574004	4094814		0
15972	946	260139	1969-03-22	1969-03-22 00:00:00	1969-04-05	1969-04-05 00:00:00	32020		\N	62773	0	10509002	260139		0
16128	954	4112343	2006-03-24	2006-03-24 00:00:00	2006-04-06	2006-04-06 00:00:00	32020		\N	63384	0	195662009	4112343		0
5790	340	4112343	1963-07-21	1963-07-21 00:00:00	1963-07-29	1963-07-29 00:00:00	32020		\N	22685	0	195662009	4112343		0
5958	350	40481087	1962-01-13	1962-01-13 00:00:00	1962-01-20	1962-01-20 00:00:00	32020		\N	23328	0	444814009	40481087		0
6113	359	4112343	1978-09-18	1978-09-18 00:00:00	1978-09-30	1978-09-30 00:00:00	32020		\N	23873	0	195662009	4112343		0
6279	369	40481087	1986-07-03	1986-07-03 00:00:00	1986-07-10	1986-07-10 00:00:00	32020		\N	24555	0	444814009	40481087		0
6445	379	260139	2016-07-28	2016-07-28 00:00:00	2016-08-04	2016-08-04 00:00:00	32020		\N	25060	0	10509002	260139		0
17140	1024	4218389	1991-10-10	1991-10-10 00:00:00	1991-10-31	1991-10-31 00:00:00	32020		\N	67439	0	39848009	4218389		0
17269	1033	40481087	2013-12-02	2013-12-02 00:00:00	2013-12-09	2013-12-09 00:00:00	32020		\N	68017	0	444814009	40481087		0
6950	409	40481087	2013-06-04	2013-06-04 00:00:00	2013-06-18	2013-06-18 00:00:00	32020		\N	27018	0	444814009	40481087		0
7117	419	4152936	1923-11-15	1923-11-15 00:00:00	1923-11-29	1923-11-29 00:00:00	32020		\N	27708	0	283385000	4152936		0
17812	1072	260139	2009-04-14	2009-04-14 00:00:00	2009-04-21	2009-04-21 00:00:00	32020		\N	70264	0	10509002	260139		0
7463	439	4142905	1983-05-31	1983-05-31 00:00:00	1983-06-30	1983-06-30 00:00:00	32020		\N	29151	0	33737001	4142905		0
18102	1088	4112343	2008-10-31	2008-10-31 00:00:00	2008-11-12	2008-11-12 00:00:00	32020		\N	71410	0	195662009	4112343		0
7771	454	40481087	1971-08-07	1971-08-07 00:00:00	1971-08-21	1971-08-21 00:00:00	32020		\N	30321	0	444814009	40481087		0
18434	1108	4116491	2014-01-23	2014-01-23 00:00:00	2014-03-13	2014-03-13 00:00:00	32020		\N	72942	0	301011002	4116491		0
18598	1118	4029498	1983-08-10	1983-08-10 00:00:00	\N	\N	32020		\N	73703	0	128613002	4029498		0
18783	1131	4112343	1984-03-16	1984-03-16 00:00:00	1984-03-27	1984-03-27 00:00:00	32020		\N	74443	0	195662009	4112343		0
8433	489	40481087	1989-01-30	1989-01-30 00:00:00	1989-02-13	1989-02-13 00:00:00	32020		\N	32816	0	444814009	40481087		0
8619	502	40481087	1968-04-17	1968-04-17 00:00:00	1968-05-01	1968-05-01 00:00:00	32020		\N	33581	0	444814009	40481087		0
19270	1154	372328	1971-10-31	1971-10-31 00:00:00	1971-11-14	1971-11-14 00:00:00	32020		\N	76289	0	65363002	372328		0
19532	1173	40481087	2013-04-04	2013-04-04 00:00:00	2013-04-18	2013-04-18 00:00:00	32020		\N	77240	0	444814009	40481087		0
19604	1176	4084167	1981-09-13	1981-09-13 00:00:00	1981-09-13	1981-09-13 00:00:00	32020		\N	77645	0	241929008	4084167		0
19797	1189	40481087	1980-11-09	1980-11-09 00:00:00	1980-11-23	1980-11-23 00:00:00	32020		\N	78352	0	444814009	40481087		0
19937	1201	260139	1987-06-26	1987-06-26 00:00:00	1987-07-10	1987-07-10 00:00:00	32020		\N	79019	0	10509002	260139		0
20095	1211	4156265	2004-04-02	2004-04-02 00:00:00	2004-04-16	2004-04-16 00:00:00	32020		\N	79575	0	370247008	4156265		0
9776	578	4112343	2008-02-01	2008-02-01 00:00:00	2008-02-14	2008-02-14 00:00:00	32020		\N	38273	0	195662009	4112343		0
20436	1229	440086	1966-05-12	1966-05-12 00:00:00	1972-05-20	1972-05-20 00:00:00	32020		\N	80977	0	192127007	440086		0
20614	1238	4149245	1982-08-18	1982-08-18 00:00:00	1982-09-24	1982-09-24 00:00:00	32020		\N	81582	0	30832001	4149245		0
10278	607	4112343	1956-03-22	1956-03-22 00:00:00	1956-04-02	1956-04-02 00:00:00	32020		\N	40317	0	195662009	4112343		0
10434	615	4112343	1942-07-22	1942-07-22 00:00:00	1942-08-02	1942-08-02 00:00:00	32020		\N	40865	0	195662009	4112343		0
21111	1267	4112343	1954-10-26	1954-10-26 00:00:00	1954-11-02	1954-11-02 00:00:00	32020		\N	83516	0	195662009	4112343		0
131	5	4112343	1983-08-04	1983-08-04 00:00:00	1983-08-12	1983-08-12 00:00:00	32020		\N	406	0	195662009	4112343		0
330	17	4112343	1967-04-07	1967-04-07 00:00:00	1967-04-14	1967-04-14 00:00:00	32020		\N	1286	0	195662009	4112343		0
10993	649	4142905	1978-04-26	1978-04-26 00:00:00	1978-06-25	1978-06-25 00:00:00	32020		\N	42979	0	33737001	4142905		0
11126	656	40481087	1964-07-11	1964-07-11 00:00:00	1964-07-25	1964-07-25 00:00:00	32020		\N	43458	0	444814009	40481087		0
809	43	28060	1959-08-08	1959-08-08 00:00:00	1959-08-19	1959-08-19 00:00:00	32020		\N	3183	0	43878008	28060		0
11528	680	260139	1986-06-18	1986-06-18 00:00:00	1986-07-02	1986-07-02 00:00:00	32020		\N	44959	0	10509002	260139		0
1156	67	40481087	2011-05-18	2011-05-18 00:00:00	2011-06-08	2011-06-08 00:00:00	32020		\N	4522	0	444814009	40481087		0
11791	697	257012	2015-08-02	2015-08-02 00:00:00	\N	\N	32020		\N	46128	0	40055000	257012		0
1481	86	40481087	2016-12-28	2016-12-28 00:00:00	2017-01-18	2017-01-18 00:00:00	32020		\N	5829	0	444814009	40481087		0
12146	719	4283893	2010-03-15	2010-03-15 00:00:00	2010-04-12	2010-04-12 00:00:00	32020		\N	47560	0	36971009	4283893		0
1806	102	80180	2008-12-03	2008-12-03 00:00:00	\N	\N	32020		\N	6990	0	396275006	80180		0
12455	736	260139	1982-10-06	1982-10-06 00:00:00	1982-10-20	1982-10-20 00:00:00	32020		\N	48785	0	10509002	260139		0
2154	124	4051466	1986-03-12	1986-03-12 00:00:00	2003-06-13	2003-06-13 00:00:00	32020		\N	8294	0	233678006	4051466		0
12829	756	372328	1966-08-29	1966-08-29 00:00:00	1966-10-12	1966-10-12 00:00:00	32020		\N	50122	0	65363002	372328		0
2480	145	195588	1983-03-08	1983-03-08 00:00:00	1983-04-10	1983-04-10 00:00:00	32020		\N	9808	0	38822007	195588		0
2654	155	4112343	1988-04-08	1988-04-08 00:00:00	1988-04-16	1988-04-16 00:00:00	32020		\N	10617	0	195662009	4112343		0
2800	161	40481087	2015-04-16	2015-04-16 00:00:00	2015-04-30	2015-04-30 00:00:00	32020		\N	11030	0	444814009	40481087		0
13451	793	260139	1983-11-04	1983-11-04 00:00:00	1983-11-11	1983-11-11 00:00:00	32020		\N	52616	0	10509002	260139		0
3133	184	40481087	2004-12-19	2004-12-19 00:00:00	2005-01-02	2005-01-02 00:00:00	32020		\N	12497	0	444814009	40481087		0
3277	190	4218389	2014-12-01	2014-12-01 00:00:00	2014-12-22	2014-12-22 00:00:00	32020		\N	13001	0	39848009	4218389		0
3459	197	4283893	1978-09-07	1978-09-07 00:00:00	1978-11-09	1978-11-09 00:00:00	32020		\N	13538	0	36971009	4283893		0
14142	836	260139	2001-01-29	2001-01-29 00:00:00	2001-02-05	2001-02-05 00:00:00	32020		\N	55310	0	10509002	260139		0
3809	220	4112343	1986-07-23	1986-07-23 00:00:00	1986-08-03	1986-08-03 00:00:00	32020		\N	14808	0	195662009	4112343		0
14457	855	372328	1962-03-18	1962-03-18 00:00:00	1962-11-09	1962-11-09 00:00:00	32020		\N	56495	0	65363002	372328		0
14615	863	4112343	1965-04-05	1965-04-05 00:00:00	1965-04-17	1965-04-17 00:00:00	32020		\N	57150	0	195662009	4112343		0
4314	248	40481087	2012-03-01	2012-03-01 00:00:00	2012-03-08	2012-03-08 00:00:00	32020		\N	16680	0	444814009	40481087		0
14977	882	372328	1946-10-25	1946-10-25 00:00:00	1946-11-30	1946-11-30 00:00:00	32020		\N	58679	0	65363002	372328		0
15110	890	192671	1997-11-11	1997-11-11 00:00:00	\N	\N	32020		\N	59289	0	K92.2	35208414		0
4813	283	81151	2004-06-18	2004-06-18 00:00:00	2004-07-02	2004-07-02 00:00:00	32020		\N	18883	0	44465007	81151		0
4975	293	40481087	2004-03-12	2004-03-12 00:00:00	2004-03-26	2004-03-26 00:00:00	32020		\N	19487	0	444814009	40481087		0
15606	924	4112343	1963-07-31	1963-07-31 00:00:00	1963-08-09	1963-08-09 00:00:00	32020		\N	61560	0	195662009	4112343		0
5286	311	40481087	1986-01-17	1986-01-17 00:00:00	1986-02-07	1986-02-07 00:00:00	32020		\N	20627	0	444814009	40481087		0
15973	946	40481087	2000-01-12	2000-01-12 00:00:00	2000-01-26	2000-01-26 00:00:00	32020		\N	62800	0	444814009	40481087		0
16129	954	4112343	2017-02-10	2017-02-10 00:00:00	2017-02-19	2017-02-19 00:00:00	32020		\N	63417	0	195662009	4112343		0
5791	340	40481087	1977-12-08	1977-12-08 00:00:00	1977-12-29	1977-12-29 00:00:00	32020		\N	22681	0	444814009	40481087		0
5959	350	4112343	1989-02-04	1989-02-04 00:00:00	1989-02-13	1989-02-13 00:00:00	32020		\N	23331	0	195662009	4112343		0
6114	359	4146173	1994-03-25	1994-03-25 00:00:00	1994-05-24	1994-05-24 00:00:00	32020		\N	23877	0	307731004	4146173		0
6280	369	378001	1988-01-20	1988-01-20 00:00:00	1988-03-20	1988-03-20 00:00:00	32020		\N	24577	0	62106007	378001		0
6446	379	4283893	2000-03-08	2000-03-08 00:00:00	2000-06-07	2000-06-07 00:00:00	32020		\N	25058	0	36971009	4283893		0
17141	1024	81151	1982-03-17	1982-03-17 00:00:00	1982-03-31	1982-03-31 00:00:00	32020		\N	67438	0	44465007	81151		0
17270	1033	40481087	1991-11-25	1991-11-25 00:00:00	1991-12-02	1991-12-02 00:00:00	32020		\N	68013	0	444814009	40481087		0
6951	409	4294548	1994-12-06	1994-12-06 00:00:00	1994-12-13	1994-12-13 00:00:00	32020		\N	27045	0	75498004	4294548		0
7118	419	40481087	1965-05-29	1965-05-29 00:00:00	1965-06-05	1965-06-05 00:00:00	32020		\N	27810	0	444814009	40481087		0
17813	1072	40481087	1994-12-02	1994-12-02 00:00:00	1994-12-09	1994-12-09 00:00:00	32020		\N	70242	0	444814009	40481087		0
7464	439	372328	1980-06-15	1980-06-15 00:00:00	1980-09-04	1980-09-04 00:00:00	32020		\N	29108	0	65363002	372328		0
18103	1088	4112343	2008-02-25	2008-02-25 00:00:00	2008-03-04	2008-03-04 00:00:00	32020		\N	71418	0	195662009	4112343		0
7772	454	4296204	1981-08-11	1981-08-11 00:00:00	1981-09-08	1981-09-08 00:00:00	32020		\N	30272	0	403190006	4296204		0
18435	1108	40481087	1971-03-29	1971-03-29 00:00:00	1971-04-12	1971-04-12 00:00:00	32020		\N	72939	0	444814009	40481087		0
18600	1118	195588	2000-10-04	2000-10-04 00:00:00	2000-11-15	2000-11-15 00:00:00	32020		\N	73706	0	38822007	195588		0
18784	1131	40481087	2013-06-05	2013-06-05 00:00:00	2013-06-12	2013-06-12 00:00:00	32020		\N	74437	0	444814009	40481087		0
8434	489	40481087	2009-01-08	2009-01-08 00:00:00	2009-01-15	2009-01-15 00:00:00	32020		\N	32709	0	444814009	40481087		0
8620	502	4112343	2016-10-15	2016-10-15 00:00:00	2016-10-24	2016-10-24 00:00:00	32020		\N	33636	0	195662009	4112343		0
19271	1154	257012	2008-02-04	2008-02-04 00:00:00	\N	\N	32020		\N	76287	0	40055000	257012		0
19533	1173	40481087	2009-01-23	2009-01-23 00:00:00	2009-02-13	2009-02-13 00:00:00	32020		\N	77271	0	444814009	40481087		0
19605	1176	4048171	1966-10-25	1966-10-25 00:00:00	\N	\N	32020		\N	77649	0	232353008	4048171		0
19819	1193	4112343	1977-05-16	1977-05-16 00:00:00	1977-05-25	1977-05-25 00:00:00	32020		\N	78631	0	195662009	4112343		0
19938	1201	372328	1977-04-11	1977-04-11 00:00:00	1977-09-21	1977-09-21 00:00:00	32020		\N	79029	0	65363002	372328		0
20096	1211	80180	2004-12-31	2004-12-31 00:00:00	\N	\N	32020		\N	79575	0	396275006	80180		0
9777	578	4155034	2005-10-27	2005-10-27 00:00:00	2005-11-10	2005-11-10 00:00:00	32020		\N	38260	0	283371005	4155034		0
20437	1229	4112343	1986-12-11	1986-12-11 00:00:00	1986-12-23	1986-12-23 00:00:00	32020		\N	81014	0	195662009	4112343		0
20615	1238	4027663	1989-10-30	1989-10-30 00:00:00	\N	\N	32020		\N	81623	0	13200003	4027663		0
10279	607	28060	1984-10-20	1984-10-20 00:00:00	1984-10-30	1984-10-30 00:00:00	32020		\N	40327	0	43878008	28060		0
10435	615	28060	1911-07-20	1911-07-20 00:00:00	1911-07-31	1911-07-31 00:00:00	32020		\N	40862	0	43878008	28060		0
21112	1267	4112343	2012-12-20	2012-12-20 00:00:00	2013-01-02	2013-01-02 00:00:00	32020		\N	83523	0	195662009	4112343		0
132	5	40481087	2012-01-31	2012-01-31 00:00:00	2012-02-07	2012-02-07 00:00:00	32020		\N	445	0	444814009	40481087		0
331	17	4218389	1969-02-04	1969-02-04 00:00:00	1969-03-11	1969-03-11 00:00:00	32020		\N	1372	0	39848009	4218389		0
10994	649	4218389	1974-03-13	1974-03-13 00:00:00	1974-04-17	1974-04-17 00:00:00	32020		\N	42978	0	39848009	4218389		0
11127	656	4285898	2007-06-12	2007-06-12 00:00:00	\N	\N	32020		\N	43457	0	68496003	4285898		0
810	43	40481087	2010-01-06	2010-01-06 00:00:00	2010-01-27	2010-01-27 00:00:00	32020		\N	3148	0	444814009	40481087		0
11529	680	4112343	2016-10-04	2016-10-04 00:00:00	2016-10-17	2016-10-17 00:00:00	32020		\N	45083	0	195662009	4112343		0
1157	67	80180	2011-08-29	2011-08-29 00:00:00	\N	\N	32020		\N	4522	0	396275006	80180		0
11792	697	40481087	2017-11-07	2017-11-07 00:00:00	2017-11-28	2017-11-28 00:00:00	32020		\N	46113	0	444814009	40481087		0
1482	86	260139	1952-07-05	1952-07-05 00:00:00	1952-07-19	1952-07-19 00:00:00	32020		\N	5768	0	10509002	260139		0
12147	719	372328	1983-07-19	1983-07-19 00:00:00	1983-10-21	1983-10-21 00:00:00	32020		\N	47584	0	65363002	372328		0
1807	103	4116491	2000-05-19	2000-05-19 00:00:00	2000-06-21	2000-06-21 00:00:00	32020		\N	7025	0	301011002	4116491		0
12456	736	4112343	1979-05-24	1979-05-24 00:00:00	1979-05-31	1979-05-31 00:00:00	32020		\N	48784	0	195662009	4112343		0
2155	124	372328	1988-03-29	1988-03-29 00:00:00	1989-02-13	1989-02-13 00:00:00	32020		\N	8209	0	65363002	372328		0
12830	756	40481087	1979-04-28	1979-04-28 00:00:00	1979-05-05	1979-05-05 00:00:00	32020		\N	50130	0	444814009	40481087		0
2481	145	40481087	1979-06-05	1979-06-05 00:00:00	1979-06-26	1979-06-26 00:00:00	32020		\N	9807	0	444814009	40481087		0
2655	155	4146173	1995-11-12	1995-11-12 00:00:00	1995-12-12	1995-12-12 00:00:00	32020		\N	10578	0	307731004	4146173		0
2801	162	40481087	1945-11-09	1945-11-09 00:00:00	1945-11-16	1945-11-16 00:00:00	32020		\N	11094	0	444814009	40481087		0
13452	793	40481087	2009-10-24	2009-10-24 00:00:00	2009-11-14	2009-11-14 00:00:00	32020		\N	52604	0	444814009	40481087		0
3134	184	260139	1964-01-25	1964-01-25 00:00:00	1964-02-08	1964-02-08 00:00:00	32020		\N	12472	0	10509002	260139		0
3278	190	4112343	1937-05-04	1937-05-04 00:00:00	1937-05-17	1937-05-17 00:00:00	32020		\N	13012	0	195662009	4112343		0
3460	197	40481087	2010-12-15	2010-12-15 00:00:00	2010-12-22	2010-12-22 00:00:00	32020		\N	13573	0	444814009	40481087		0
14143	836	4112343	2008-01-16	2008-01-16 00:00:00	2008-01-29	2008-01-29 00:00:00	32020		\N	55314	0	195662009	4112343		0
3810	220	260139	1998-06-15	1998-06-15 00:00:00	1998-06-29	1998-06-29 00:00:00	32020		\N	14814	0	10509002	260139		0
14458	855	40481087	1991-02-19	1991-02-19 00:00:00	1991-03-05	1991-03-05 00:00:00	32020		\N	56461	0	444814009	40481087		0
14616	863	4152936	1930-02-16	1930-02-16 00:00:00	1930-03-09	1930-03-09 00:00:00	32020		\N	57206	0	283385000	4152936		0
4315	248	260139	1984-01-18	1984-01-18 00:00:00	1984-01-25	1984-01-25 00:00:00	32020		\N	16724	0	10509002	260139		0
14978	883	40481087	1987-12-24	1987-12-24 00:00:00	1987-12-31	1987-12-31 00:00:00	32020		\N	58811	0	444814009	40481087		0
15111	890	80180	1997-09-06	1997-09-06 00:00:00	\N	\N	32020		\N	59366	0	396275006	80180		0
4814	283	4051466	1984-09-07	1984-09-07 00:00:00	1999-12-21	1999-12-21 00:00:00	32020		\N	18834	0	233678006	4051466		0
4976	293	440448	2005-10-04	2005-10-04 00:00:00	\N	\N	32020		\N	19514	0	74400008	440448		0
15607	924	4296205	1977-02-15	1977-02-15 00:00:00	1977-03-08	1977-03-08 00:00:00	32020		\N	61539	0	403191005	4296205		0
5287	311	260139	2008-01-04	2008-01-04 00:00:00	2008-01-18	2008-01-18 00:00:00	32020		\N	20588	0	10509002	260139		0
15974	946	40481087	2018-02-12	2018-02-12 00:00:00	2018-03-05	2018-03-05 00:00:00	32020		\N	62806	0	444814009	40481087		0
16130	954	372328	1974-05-14	1974-05-14 00:00:00	1974-07-21	1974-07-21 00:00:00	32020		\N	63385	0	65363002	372328		0
5792	340	40481087	2014-01-11	2014-01-11 00:00:00	2014-01-25	2014-01-25 00:00:00	32020		\N	22713	0	444814009	40481087		0
5960	350	4112343	1962-10-05	1962-10-05 00:00:00	1962-10-12	1962-10-12 00:00:00	32020		\N	23297	0	195662009	4112343		0
6115	359	28060	1990-06-12	1990-06-12 00:00:00	1990-06-23	1990-06-23 00:00:00	32020		\N	23874	0	43878008	28060		0
6281	369	4109685	1997-02-15	1997-02-15 00:00:00	1997-03-01	1997-03-01 00:00:00	32020		\N	24579	0	284551006	4109685		0
6447	379	260139	1985-06-06	1985-06-06 00:00:00	1985-06-13	1985-06-13 00:00:00	32020		\N	25064	0	10509002	260139		0
17142	1024	80180	1983-01-05	1983-01-05 00:00:00	\N	\N	32020		\N	67438	0	396275006	80180		0
17271	1033	4112343	1993-06-21	1993-06-21 00:00:00	1993-06-29	1993-06-29 00:00:00	32020		\N	67988	0	195662009	4112343		0
6952	409	4280726	1955-10-12	1955-10-12 00:00:00	1993-07-16	1993-07-16 00:00:00	32020		\N	27087	0	367498001	4280726		0
7119	419	80502	1992-04-12	1992-04-12 00:00:00	\N	\N	32020		\N	27774	0	64859006	80502		0
17814	1072	40481087	1999-03-26	1999-03-26 00:00:00	1999-04-09	1999-04-09 00:00:00	32020		\N	70243	0	444814009	40481087		0
7465	439	40481087	2007-09-18	2007-09-18 00:00:00	2007-10-09	2007-10-09 00:00:00	32020		\N	29158	0	444814009	40481087		0
18104	1088	4113008	1976-04-10	1976-04-10 00:00:00	1976-05-01	1976-05-01 00:00:00	32020		\N	71422	0	284549007	4113008		0
7773	454	4112343	1960-12-23	1960-12-23 00:00:00	1961-01-03	1961-01-03 00:00:00	32020		\N	30281	0	195662009	4112343		0
18436	1108	4218389	1980-06-30	1980-06-30 00:00:00	1980-07-21	1980-07-21 00:00:00	32020		\N	72996	0	39848009	4218389		0
18601	1118	4056621	2000-10-04	2000-10-04 00:00:00	\N	\N	32020		\N	73706	0	197927001	4056621		0
18785	1131	4112343	2010-08-25	2010-08-25 00:00:00	2010-09-07	2010-09-07 00:00:00	32020		\N	74436	0	195662009	4112343		0
8435	489	40481087	1978-07-20	1978-07-20 00:00:00	1978-07-27	1978-07-27 00:00:00	32020		\N	32743	0	444814009	40481087		0
8621	502	321042	2016-03-05	2016-03-05 00:00:00	\N	\N	32020		\N	33579	0	410429000	321042		0
19272	1154	4112343	2013-08-28	2013-08-28 00:00:00	2013-09-08	2013-09-08 00:00:00	32020		\N	76243	0	195662009	4112343		0
19534	1173	78272	1987-06-12	1987-06-12 00:00:00	1987-07-03	1987-07-03 00:00:00	32020		\N	77276	0	70704007	78272		0
19606	1176	40481087	2009-06-23	2009-06-23 00:00:00	2009-07-07	2009-07-07 00:00:00	32020		\N	77711	0	444814009	40481087		0
19820	1193	81151	1955-08-09	1955-08-09 00:00:00	1955-09-13	1955-09-13 00:00:00	32020		\N	78619	0	44465007	81151		0
19939	1201	4112343	1976-08-24	1976-08-24 00:00:00	1976-09-05	1976-09-05 00:00:00	32020		\N	79028	0	195662009	4112343		0
20097	1211	4112343	2007-03-31	2007-03-31 00:00:00	2007-04-08	2007-04-08 00:00:00	32020		\N	79545	0	195662009	4112343		0
9778	578	260139	1996-10-06	1996-10-06 00:00:00	1996-10-20	1996-10-20 00:00:00	32020		\N	38268	0	10509002	260139		0
20438	1229	4112343	1954-12-15	1954-12-15 00:00:00	1954-12-28	1954-12-28 00:00:00	32020		\N	81005	0	195662009	4112343		0
20616	1238	4112343	2007-07-20	2007-07-20 00:00:00	2007-07-28	2007-07-28 00:00:00	32020		\N	81574	0	195662009	4112343		0
10280	607	372328	1960-03-27	1960-03-27 00:00:00	1960-12-23	1960-12-23 00:00:00	32020		\N	40272	0	65363002	372328		0
10436	615	40481087	1931-08-18	1931-08-18 00:00:00	1931-08-25	1931-08-25 00:00:00	32020		\N	40910	0	444814009	40481087		0
21113	1267	260139	1990-01-25	1990-01-25 00:00:00	1990-02-08	1990-02-08 00:00:00	32020		\N	83519	0	10509002	260139		0
133	5	260139	2012-02-10	2012-02-10 00:00:00	2012-02-17	2012-02-17 00:00:00	32020		\N	508	0	10509002	260139		0
332	17	4112343	1974-05-09	1974-05-09 00:00:00	1974-05-22	1974-05-22 00:00:00	32020		\N	1298	0	195662009	4112343		0
10995	649	4278672	1972-11-18	1972-11-18 00:00:00	1973-02-16	1973-02-16 00:00:00	32020		\N	42974	0	65966004	4278672		0
11128	656	80180	2008-04-07	2008-04-07 00:00:00	\N	\N	32020		\N	43457	0	396275006	80180		0
811	43	4112343	2007-10-28	2007-10-28 00:00:00	2007-11-10	2007-11-10 00:00:00	32020		\N	3174	0	195662009	4112343		0
11530	680	40481087	2017-08-24	2017-08-24 00:00:00	2017-09-07	2017-09-07 00:00:00	32020		\N	45011	0	444814009	40481087		0
1158	67	378001	1996-10-31	1996-10-31 00:00:00	1996-12-30	1996-12-30 00:00:00	32020		\N	4570	0	62106007	378001		0
11793	697	378001	2016-05-30	2016-05-30 00:00:00	2016-07-29	2016-07-29 00:00:00	32020		\N	46163	0	62106007	378001		0
1483	86	28060	1990-03-14	1990-03-14 00:00:00	1990-03-27	1990-03-27 00:00:00	32020		\N	5795	0	43878008	28060		0
12148	719	4112343	2012-10-24	2012-10-24 00:00:00	2012-11-01	2012-11-01 00:00:00	32020		\N	47561	0	195662009	4112343		0
1808	103	4294548	1981-09-16	1981-09-16 00:00:00	1981-11-18	1981-11-18 00:00:00	32020		\N	7024	0	75498004	4294548		0
12457	736	4155034	2010-07-15	2010-07-15 00:00:00	2010-08-05	2010-08-05 00:00:00	32020		\N	48814	0	283371005	4155034		0
12627	747	40481087	1982-11-08	1982-11-08 00:00:00	1982-11-15	1982-11-15 00:00:00	32020		\N	49455	0	444814009	40481087		0
12831	756	4237458	1974-02-18	1974-02-18 00:00:00	1974-05-19	1974-05-19 00:00:00	32020		\N	50172	0	58150001	4237458		0
2482	145	260139	1995-02-02	1995-02-02 00:00:00	1995-02-16	1995-02-16 00:00:00	32020		\N	9726	0	10509002	260139		0
2656	155	4112343	1976-07-26	1976-07-26 00:00:00	1976-08-05	1976-08-05 00:00:00	32020		\N	10616	0	195662009	4112343		0
2802	162	80180	1972-04-07	1972-04-07 00:00:00	\N	\N	32020		\N	11136	0	396275006	80180		0
13453	793	80180	2010-05-14	2010-05-14 00:00:00	\N	\N	32020		\N	52604	0	396275006	80180		0
3135	184	40481087	1990-03-15	1990-03-15 00:00:00	1990-03-29	1990-03-29 00:00:00	32020		\N	12475	0	444814009	40481087		0
3279	190	81151	1969-08-12	1969-08-12 00:00:00	1969-08-26	1969-08-26 00:00:00	32020		\N	12911	0	44465007	81151		0
3461	197	40481087	2013-12-24	2013-12-24 00:00:00	2014-01-14	2014-01-14 00:00:00	32020		\N	13574	0	444814009	40481087		0
14144	836	40481087	1997-02-11	1997-02-11 00:00:00	1997-02-25	1997-02-25 00:00:00	32020		\N	55305	0	444814009	40481087		0
3811	220	260139	2019-01-11	2019-01-11 00:00:00	2019-01-25	2019-01-25 00:00:00	32020		\N	14809	0	10509002	260139		0
14459	855	260139	1980-10-08	1980-10-08 00:00:00	1980-10-22	1980-10-22 00:00:00	32020		\N	56483	0	10509002	260139		0
14617	863	40481087	1948-01-11	1948-01-11 00:00:00	1948-02-01	1948-02-01 00:00:00	32020		\N	57166	0	444814009	40481087		0
4316	248	372328	1975-06-17	1975-06-17 00:00:00	1975-07-08	1975-07-08 00:00:00	32020		\N	16710	0	65363002	372328		0
14979	883	260139	1968-05-11	1968-05-11 00:00:00	1968-05-18	1968-05-18 00:00:00	32020		\N	58792	0	10509002	260139		0
15112	890	4142905	1982-06-25	1982-06-25 00:00:00	1982-07-25	1982-07-25 00:00:00	32020		\N	59328	0	33737001	4142905		0
15280	905	4027663	1999-09-14	1999-09-14 00:00:00	\N	\N	32020		\N	60151	0	13200003	4027663		0
4977	293	4294548	2014-09-05	2014-09-05 00:00:00	2014-09-12	2014-09-12 00:00:00	32020		\N	19526	0	75498004	4294548		0
15608	924	40481087	1968-12-22	1968-12-22 00:00:00	1969-01-12	1969-01-12 00:00:00	32020		\N	61503	0	444814009	40481087		0
5288	311	40481087	2016-10-23	2016-10-23 00:00:00	2016-10-30	2016-10-30 00:00:00	32020		\N	20620	0	444814009	40481087		0
15975	946	40481087	2001-11-21	2001-11-21 00:00:00	2001-12-05	2001-12-05 00:00:00	32020		\N	62813	0	444814009	40481087		0
16131	954	4112343	1975-04-11	1975-04-11 00:00:00	1975-04-19	1975-04-19 00:00:00	32020		\N	63378	0	195662009	4112343		0
5793	340	4112343	1998-03-01	1998-03-01 00:00:00	1998-03-12	1998-03-12 00:00:00	32020		\N	22671	0	195662009	4112343		0
5961	350	4112343	1972-07-07	1972-07-07 00:00:00	1972-07-19	1972-07-19 00:00:00	32020		\N	23299	0	195662009	4112343		0
6116	359	260139	1992-06-05	1992-06-05 00:00:00	1992-06-19	1992-06-19 00:00:00	32020		\N	23909	0	10509002	260139		0
6282	369	4283893	1991-06-21	1991-06-21 00:00:00	1991-10-18	1991-10-18 00:00:00	32020		\N	24565	0	36971009	4283893		0
6448	379	40481087	1985-03-28	1985-03-28 00:00:00	1985-04-18	1985-04-18 00:00:00	32020		\N	25074	0	444814009	40481087		0
17143	1024	261325	2019-06-16	2019-06-16 00:00:00	\N	\N	32020		\N	67448	0	87433001	261325		0
17288	1036	4112343	2013-07-17	2013-07-17 00:00:00	2013-07-26	2013-07-26 00:00:00	32020		\N	68121	0	195662009	4112343		0
6953	409	80180	1993-01-13	1993-01-13 00:00:00	\N	\N	32020		\N	27129	0	396275006	80180		0
7120	419	4237458	1991-07-01	1991-07-01 00:00:00	1991-07-31	1991-07-31 00:00:00	32020		\N	27761	0	58150001	4237458		0
17815	1072	40481087	1972-11-21	1972-11-21 00:00:00	1972-11-28	1972-11-28 00:00:00	32020		\N	70245	0	444814009	40481087		0
7466	439	378001	1992-01-14	1992-01-14 00:00:00	1992-03-14	1992-03-14 00:00:00	32020		\N	29152	0	62106007	378001		0
18105	1088	4146173	1995-12-07	1995-12-07 00:00:00	1996-01-13	1996-01-13 00:00:00	32020		\N	71417	0	307731004	4146173		0
7774	454	4027663	1961-02-23	1961-02-23 00:00:00	\N	\N	32020		\N	30281	0	13200003	4027663		0
18437	1108	372328	1971-05-21	1971-05-21 00:00:00	1971-07-07	1971-07-07 00:00:00	32020		\N	72971	0	65363002	372328		0
18602	1118	195588	2000-08-05	2000-08-05 00:00:00	2000-09-13	2000-09-13 00:00:00	32020		\N	73682	0	38822007	195588		0
18786	1131	40481087	2009-04-06	2009-04-06 00:00:00	2009-04-20	2009-04-20 00:00:00	32020		\N	74447	0	444814009	40481087		0
8436	489	372328	1975-11-28	1975-11-28 00:00:00	1976-02-08	1976-02-08 00:00:00	32020		\N	32739	0	65363002	372328		0
8623	502	40481087	2001-05-13	2001-05-13 00:00:00	2001-05-27	2001-05-27 00:00:00	32020		\N	33585	0	444814009	40481087		0
19273	1154	40481087	2010-06-28	2010-06-28 00:00:00	2010-07-19	2010-07-19 00:00:00	32020		\N	76266	0	444814009	40481087		0
19535	1173	4266809	1986-01-19	1986-01-19 00:00:00	\N	\N	32020		\N	77259	0	397881000	4266809		0
19607	1176	372328	1966-12-16	1966-12-16 00:00:00	1967-09-29	1967-09-29 00:00:00	32020		\N	77713	0	65363002	372328		0
19821	1193	4112343	1992-09-14	1992-09-14 00:00:00	1992-09-26	1992-09-26 00:00:00	32020		\N	78668	0	195662009	4112343		0
19940	1201	4113008	2013-06-13	2013-06-13 00:00:00	2013-06-27	2013-06-27 00:00:00	32020		\N	78982	0	284549007	4113008		0
20099	1211	81151	2009-07-19	2009-07-19 00:00:00	2009-08-02	2009-08-02 00:00:00	32020		\N	79577	0	44465007	81151		0
9779	578	260139	1969-02-21	1969-02-21 00:00:00	1969-02-28	1969-02-28 00:00:00	32020		\N	38265	0	10509002	260139		0
20439	1229	40481087	2016-02-12	2016-02-12 00:00:00	2016-03-04	2016-03-04 00:00:00	32020		\N	80984	0	444814009	40481087		0
20617	1238	40481087	1965-03-27	1965-03-27 00:00:00	1965-04-10	1965-04-10 00:00:00	32020		\N	81610	0	444814009	40481087		0
10281	607	81893	1990-01-29	1990-01-29 00:00:00	\N	\N	32020		\N	40340	0	64766004	81893		0
10437	615	260139	1982-05-22	1982-05-22 00:00:00	1982-06-05	1982-06-05 00:00:00	32020		\N	40913	0	10509002	260139		0
21114	1267	260139	1960-12-17	1960-12-17 00:00:00	1960-12-31	1960-12-31 00:00:00	32020		\N	83560	0	10509002	260139		0
134	5	40481087	2007-11-11	2007-11-11 00:00:00	2007-11-18	2007-11-18 00:00:00	32020		\N	507	0	444814009	40481087		0
10791	640	260139	1974-01-11	1974-01-11 00:00:00	1974-01-18	1974-01-18 00:00:00	32020		\N	42351	0	10509002	260139		0
10996	649	4294548	2011-04-15	2011-04-15 00:00:00	2011-10-07	2011-10-07 00:00:00	32020		\N	43036	0	75498004	4294548		0
11129	656	30753	2006-07-17	2006-07-17 00:00:00	\N	\N	32020		\N	43457	0	16761005	30753		0
812	43	260139	1978-12-23	1978-12-23 00:00:00	1979-01-06	1979-01-06 00:00:00	32020		\N	3159	0	10509002	260139		0
11531	680	81151	1968-08-20	1968-08-20 00:00:00	1968-09-03	1968-09-03 00:00:00	32020		\N	45090	0	44465007	81151		0
1159	67	40481087	2000-07-09	2000-07-09 00:00:00	2000-07-23	2000-07-23 00:00:00	32020		\N	4539	0	444814009	40481087		0
11794	697	40481087	1983-01-17	1983-01-17 00:00:00	1983-01-31	1983-01-31 00:00:00	32020		\N	46101	0	444814009	40481087		0
1484	86	40481087	1967-05-22	1967-05-22 00:00:00	1967-06-05	1967-06-05 00:00:00	32020		\N	5828	0	444814009	40481087		0
12149	719	40481087	1992-08-21	1992-08-21 00:00:00	1992-09-11	1992-09-11 00:00:00	32020		\N	47603	0	444814009	40481087		0
1809	103	260139	2018-12-21	2018-12-21 00:00:00	2019-01-04	2019-01-04 00:00:00	32020		\N	7049	0	10509002	260139		0
12458	736	260139	1976-08-14	1976-08-14 00:00:00	1976-08-28	1976-08-28 00:00:00	32020		\N	48792	0	10509002	260139		0
12628	747	4218389	2008-06-08	2008-06-08 00:00:00	2008-07-06	2008-07-06 00:00:00	32020		\N	49478	0	39848009	4218389		0
12832	757	4218389	1974-02-24	1974-02-24 00:00:00	1974-03-17	1974-03-17 00:00:00	32020		\N	50287	0	39848009	4218389		0
2483	145	378001	2004-08-09	2004-08-09 00:00:00	2004-09-08	2004-09-08 00:00:00	32020		\N	9794	0	62106007	378001		0
13135	774	372328	1983-03-27	1983-03-27 00:00:00	1983-09-05	1983-09-05 00:00:00	32020		\N	51351	0	65363002	372328		0
2803	162	260139	2013-12-31	2013-12-31 00:00:00	2014-01-07	2014-01-07 00:00:00	32020		\N	11096	0	10509002	260139		0
13454	793	260139	1992-07-02	1992-07-02 00:00:00	1992-07-09	1992-07-09 00:00:00	32020		\N	52617	0	10509002	260139		0
3136	184	4237458	1991-03-24	1991-03-24 00:00:00	1991-05-23	1991-05-23 00:00:00	32020		\N	12504	0	58150001	4237458		0
3280	190	80180	1969-01-19	1969-01-19 00:00:00	\N	\N	32020		\N	12937	0	396275006	80180		0
3462	197	40481087	1972-08-24	1972-08-24 00:00:00	1972-09-14	1972-09-14 00:00:00	32020		\N	13535	0	444814009	40481087		0
14145	836	4283893	1988-11-09	1988-11-09 00:00:00	1989-02-15	1989-02-15 00:00:00	32020		\N	55292	0	36971009	4283893		0
3812	220	4112343	1997-07-08	1997-07-08 00:00:00	1997-07-16	1997-07-16 00:00:00	32020		\N	14855	0	195662009	4112343		0
14460	855	4027663	1990-11-15	1990-11-15 00:00:00	\N	\N	32020		\N	56501	0	13200003	4027663		0
14618	863	4283893	1963-04-07	1963-04-07 00:00:00	1963-04-21	1963-04-21 00:00:00	32020		\N	57175	0	36971009	4283893		0
14775	870	4112343	2006-09-05	2006-09-05 00:00:00	2006-09-16	2006-09-16 00:00:00	32020		\N	57864	0	195662009	4112343		0
14980	883	260139	1987-01-24	1987-01-24 00:00:00	1987-01-31	1987-01-31 00:00:00	32020		\N	58810	0	10509002	260139		0
15113	890	4237458	1961-06-17	1961-06-17 00:00:00	1961-08-16	1961-08-16 00:00:00	32020		\N	59325	0	58150001	4237458		0
15281	905	4294548	1998-12-30	1998-12-30 00:00:00	1999-01-13	1999-01-13 00:00:00	32020		\N	60151	0	75498004	4294548		0
4979	293	4294548	1995-08-08	1995-08-08 00:00:00	1995-08-22	1995-08-22 00:00:00	32020		\N	19486	0	75498004	4294548		0
15609	924	4059173	2013-09-29	2013-09-29 00:00:00	2013-12-27	2013-12-27 00:00:00	32020		\N	61543	0	16114001	4059173		0
5289	311	40481087	2010-09-13	2010-09-13 00:00:00	2010-09-20	2010-09-20 00:00:00	32020		\N	20590	0	444814009	40481087		0
15976	946	80180	2001-09-13	2001-09-13 00:00:00	\N	\N	32020		\N	62769	0	396275006	80180		0
16132	954	80180	2015-12-15	2015-12-15 00:00:00	\N	\N	32020		\N	63415	0	396275006	80180		0
5794	340	40481087	1975-09-22	1975-09-22 00:00:00	1975-10-13	1975-10-13 00:00:00	32020		\N	22686	0	444814009	40481087		0
5962	350	378001	1986-12-14	1986-12-14 00:00:00	1987-01-13	1987-01-13 00:00:00	32020		\N	23292	0	62106007	378001		0
6117	359	28060	1982-07-13	1982-07-13 00:00:00	1982-07-23	1982-07-23 00:00:00	32020		\N	23887	0	43878008	28060		0
6283	369	40481087	1984-02-16	1984-02-16 00:00:00	1984-03-08	1984-03-08 00:00:00	32020		\N	24527	0	444814009	40481087		0
6449	379	375671	1985-12-01	1985-12-01 00:00:00	1985-12-31	1985-12-31 00:00:00	32020		\N	25066	0	62564004	375671		0
17144	1024	4112343	2008-05-28	2008-05-28 00:00:00	2008-06-10	2008-06-10 00:00:00	32020		\N	67477	0	195662009	4112343		0
17289	1036	40481087	1969-12-12	1969-12-12 00:00:00	1969-12-19	1969-12-19 00:00:00	32020		\N	68191	0	444814009	40481087		0
6954	409	4156265	2007-01-31	2007-01-31 00:00:00	2007-02-21	2007-02-21 00:00:00	32020		\N	27153	0	370247008	4156265		0
7121	419	4237458	1964-09-15	1964-09-15 00:00:00	1964-11-14	1964-11-14 00:00:00	32020		\N	27710	0	58150001	4237458		0
17816	1072	40481087	1973-08-03	1973-08-03 00:00:00	1973-08-17	1973-08-17 00:00:00	32020		\N	70239	0	444814009	40481087		0
7467	439	4112343	1979-07-24	1979-07-24 00:00:00	1979-08-02	1979-08-02 00:00:00	32020		\N	29102	0	195662009	4112343		0
18106	1088	260139	2001-01-18	2001-01-18 00:00:00	2001-01-25	2001-01-25 00:00:00	32020		\N	71463	0	10509002	260139		0
7775	454	4112343	1977-11-09	1977-11-09 00:00:00	1977-11-20	1977-11-20 00:00:00	32020		\N	30350	0	195662009	4112343		0
18438	1108	260139	2000-05-12	2000-05-12 00:00:00	2000-05-19	2000-05-19 00:00:00	32020		\N	72985	0	10509002	260139		0
18603	1118	40481087	2007-10-03	2007-10-03 00:00:00	2007-10-17	2007-10-17 00:00:00	32020		\N	73707	0	444814009	40481087		0
18787	1131	372328	1966-04-08	1966-04-08 00:00:00	1966-07-20	1966-07-20 00:00:00	32020		\N	74449	0	65363002	372328		0
8437	489	40481087	1981-12-13	1981-12-13 00:00:00	1981-12-20	1981-12-20 00:00:00	32020		\N	32755	0	444814009	40481087		0
8624	502	260139	2017-06-20	2017-06-20 00:00:00	2017-06-27	2017-06-27 00:00:00	32020		\N	33613	0	10509002	260139		0
19274	1154	378001	2004-05-10	2004-05-10 00:00:00	2004-07-09	2004-07-09 00:00:00	32020		\N	76273	0	62106007	378001		0
19536	1173	80180	1986-01-19	1986-01-19 00:00:00	\N	\N	32020		\N	77259	0	396275006	80180		0
19608	1176	4112343	1965-10-05	1965-10-05 00:00:00	1965-10-18	1965-10-18 00:00:00	32020		\N	77648	0	195662009	4112343		0
19822	1193	81151	1964-03-20	1964-03-20 00:00:00	1964-04-17	1964-04-17 00:00:00	32020		\N	78621	0	44465007	81151		0
19941	1201	4310024	2005-11-02	2005-11-02 00:00:00	\N	\N	32020		\N	78999	0	424802006	4310024		0
20100	1211	4051466	1966-10-29	1966-10-29 00:00:00	1983-02-10	1983-02-10 00:00:00	32020		\N	79536	0	233678006	4051466		0
9780	579	4146173	2016-06-07	2016-06-07 00:00:00	2016-08-06	2016-08-06 00:00:00	32020		\N	38308	0	307731004	4146173		0
20440	1229	78272	2012-06-09	2012-06-09 00:00:00	2012-06-23	2012-06-23 00:00:00	32020		\N	80981	0	70704007	78272		0
20618	1238	4296204	1985-07-10	1985-07-10 00:00:00	1985-08-14	1985-08-14 00:00:00	32020		\N	81583	0	403190006	4296204		0
10282	607	30753	1990-05-29	1990-05-29 00:00:00	\N	\N	32020		\N	40340	0	16761005	30753		0
10438	615	40481087	1996-07-17	1996-07-17 00:00:00	1996-07-24	1996-07-24 00:00:00	32020		\N	40986	0	444814009	40481087		0
21115	1267	4113008	1968-03-29	1968-03-29 00:00:00	1968-04-19	1968-04-19 00:00:00	32020		\N	83566	0	284549007	4113008		0
135	5	4283893	1996-04-19	1996-04-19 00:00:00	1996-05-03	1996-05-03 00:00:00	32020		\N	444	0	36971009	4283893		0
10792	640	40481087	1982-10-01	1982-10-01 00:00:00	1982-10-08	1982-10-08 00:00:00	32020		\N	42376	0	444814009	40481087		0
10997	649	80180	2007-05-29	2007-05-29 00:00:00	\N	\N	32020		\N	43008	0	396275006	80180		0
11130	656	40481087	1969-11-01	1969-11-01 00:00:00	1969-11-08	1969-11-08 00:00:00	32020		\N	43442	0	444814009	40481087		0
813	43	4112343	1996-07-14	1996-07-14 00:00:00	1996-07-24	1996-07-24 00:00:00	32020		\N	3173	0	195662009	4112343		0
11532	680	28060	1991-06-20	1991-06-20 00:00:00	1991-07-01	1991-07-01 00:00:00	32020		\N	45024	0	43878008	28060		0
11621	686	40481087	1969-10-26	1969-10-26 00:00:00	1969-11-02	1969-11-02 00:00:00	32020		\N	45418	0	444814009	40481087		0
11795	697	260139	1989-03-28	1989-03-28 00:00:00	1989-04-04	1989-04-04 00:00:00	32020		\N	46109	0	10509002	260139		0
1485	86	28060	1995-11-29	1995-11-29 00:00:00	1995-12-07	1995-12-07 00:00:00	32020		\N	5796	0	43878008	28060		0
12150	719	40481087	2019-02-23	2019-02-23 00:00:00	2019-03-02	2019-03-02 00:00:00	32020		\N	47571	0	444814009	40481087		0
1810	103	439777	2002-05-19	2002-05-19 00:00:00	\N	\N	32020		\N	7047	0	271737000	439777		0
12459	736	81893	2008-03-22	2008-03-22 00:00:00	\N	\N	32020		\N	48857	0	64766004	81893		0
12629	747	81151	1985-12-24	1985-12-24 00:00:00	1986-01-14	1986-01-14 00:00:00	32020		\N	49476	0	44465007	81151		0
12833	757	4283893	1932-06-11	1932-06-11 00:00:00	1932-08-06	1932-08-06 00:00:00	32020		\N	50260	0	36971009	4283893		0
2484	145	372328	1952-02-27	1952-02-27 00:00:00	1952-05-06	1952-05-06 00:00:00	32020		\N	9793	0	65363002	372328		0
13136	774	195588	2003-07-16	2003-07-16 00:00:00	2003-09-08	2003-09-08 00:00:00	32020		\N	51373	0	38822007	195588		0
2804	162	80502	2009-10-20	2009-10-20 00:00:00	\N	\N	32020		\N	11146	0	64859006	80502		0
13455	793	40481087	1977-03-11	1977-03-11 00:00:00	1977-03-18	1977-03-18 00:00:00	32020		\N	52614	0	444814009	40481087		0
3137	184	40481087	1980-12-05	1980-12-05 00:00:00	1980-12-26	1980-12-26 00:00:00	32020		\N	12430	0	444814009	40481087		0
3281	190	28060	1994-07-14	1994-07-14 00:00:00	1994-07-23	1994-07-23 00:00:00	32020		\N	12966	0	43878008	28060		0
3463	197	4094814	1992-05-25	1992-05-25 00:00:00	1992-06-24	1992-06-24 00:00:00	32020		\N	13533	0	262574004	4094814		0
14146	836	195588	2007-08-27	2007-08-27 00:00:00	2007-10-11	2007-10-11 00:00:00	32020		\N	55297	0	38822007	195588		0
3813	220	80180	2019-05-15	2019-05-15 00:00:00	\N	\N	32020		\N	14842	0	396275006	80180		0
14461	855	260139	1968-12-22	1968-12-22 00:00:00	1968-12-29	1968-12-29 00:00:00	32020		\N	56479	0	10509002	260139		0
14619	863	4296204	1944-12-20	1944-12-20 00:00:00	1945-01-10	1945-01-10 00:00:00	32020		\N	57176	0	403190006	4296204		0
14776	870	260139	1975-10-08	1975-10-08 00:00:00	1975-10-15	1975-10-15 00:00:00	32020		\N	57908	0	10509002	260139		0
14981	883	4112343	2003-08-24	2003-08-24 00:00:00	2003-08-31	2003-08-31 00:00:00	32020		\N	58773	0	195662009	4112343		0
15114	890	40481087	1969-06-03	1969-06-03 00:00:00	1969-06-24	1969-06-24 00:00:00	32020		\N	59320	0	444814009	40481087		0
15282	905	40481087	1980-06-24	1980-06-24 00:00:00	1980-07-15	1980-07-15 00:00:00	32020		\N	60213	0	444814009	40481087		0
4980	293	4237458	1978-04-03	1978-04-03 00:00:00	1978-07-02	1978-07-02 00:00:00	32020		\N	19513	0	58150001	4237458		0
15610	924	80180	2004-10-07	2004-10-07 00:00:00	\N	\N	32020		\N	61566	0	396275006	80180		0
5290	311	378001	1995-10-11	1995-10-11 00:00:00	1995-12-10	1995-12-10 00:00:00	32020		\N	20653	0	62106007	378001		0
15977	946	260139	1970-08-18	1970-08-18 00:00:00	1970-08-25	1970-08-25 00:00:00	32020		\N	62774	0	10509002	260139		0
16133	954	372328	1979-11-03	1979-11-03 00:00:00	1980-03-30	1980-03-30 00:00:00	32020		\N	63371	0	65363002	372328		0
5795	340	260139	1996-02-26	1996-02-26 00:00:00	1996-03-11	1996-03-11 00:00:00	32020		\N	22712	0	10509002	260139		0
5963	350	4112343	1997-04-28	1997-04-28 00:00:00	1997-05-10	1997-05-10 00:00:00	32020		\N	23301	0	195662009	4112343		0
6118	359	40481087	2006-09-10	2006-09-10 00:00:00	2006-10-01	2006-10-01 00:00:00	32020		\N	23869	0	444814009	40481087		0
6284	369	40481087	2006-04-08	2006-04-08 00:00:00	2006-04-29	2006-04-29 00:00:00	32020		\N	24524	0	444814009	40481087		0
6450	379	40481087	1994-07-08	1994-07-08 00:00:00	1994-07-29	1994-07-29 00:00:00	32020		\N	25106	0	444814009	40481087		0
17145	1024	40481087	1965-02-14	1965-02-14 00:00:00	1965-02-28	1965-02-28 00:00:00	32020		\N	67465	0	444814009	40481087		0
17290	1036	4142905	1978-12-17	1978-12-17 00:00:00	1979-01-16	1979-01-16 00:00:00	32020		\N	68135	0	33737001	4142905		0
6955	409	28060	1968-12-03	1968-12-03 00:00:00	1968-12-15	1968-12-15 00:00:00	32020		\N	27071	0	43878008	28060		0
7122	419	4285898	1954-01-10	1954-01-10 00:00:00	\N	\N	32020		\N	27746	0	68496003	4285898		0
17817	1072	40481087	1987-07-31	1987-07-31 00:00:00	1987-08-07	1987-08-07 00:00:00	32020		\N	70275	0	444814009	40481087		0
7468	439	28060	1981-07-07	1981-07-07 00:00:00	1981-07-19	1981-07-19 00:00:00	32020		\N	29163	0	43878008	28060		0
18107	1088	260139	1996-10-10	1996-10-10 00:00:00	1996-10-24	1996-10-24 00:00:00	32020		\N	71462	0	10509002	260139		0
7776	455	4112343	1992-12-19	1992-12-19 00:00:00	1992-12-27	1992-12-27 00:00:00	32020		\N	30379	0	195662009	4112343		0
18439	1108	4113008	2008-07-24	2008-07-24 00:00:00	2008-08-14	2008-08-14 00:00:00	32020		\N	72947	0	284549007	4113008		0
18604	1118	40481087	2014-02-19	2014-02-19 00:00:00	2014-03-12	2014-03-12 00:00:00	32020		\N	73694	0	444814009	40481087		0
18788	1131	4112343	2012-03-04	2012-03-04 00:00:00	2012-03-15	2012-03-15 00:00:00	32020		\N	74425	0	195662009	4112343		0
8454	492	28060	1954-03-18	1954-03-18 00:00:00	1954-03-29	1954-03-29 00:00:00	32020		\N	32979	0	43878008	28060		0
8625	502	4112343	2011-11-15	2011-11-15 00:00:00	2011-11-22	2011-11-22 00:00:00	32020		\N	33635	0	195662009	4112343		0
19275	1154	4112343	2011-11-29	2011-11-29 00:00:00	2011-12-06	2011-12-06 00:00:00	32020		\N	76221	0	195662009	4112343		0
19537	1173	40481087	1965-02-11	1965-02-11 00:00:00	1965-02-25	1965-02-25 00:00:00	32020		\N	77266	0	444814009	40481087		0
19609	1176	78272	1976-05-13	1976-05-13 00:00:00	1976-06-17	1976-06-17 00:00:00	32020		\N	77644	0	70704007	78272		0
19823	1193	81151	1980-12-03	1980-12-03 00:00:00	1980-12-17	1980-12-17 00:00:00	32020		\N	78625	0	44465007	81151		0
19942	1201	40481087	2005-04-05	2005-04-05 00:00:00	2005-04-12	2005-04-12 00:00:00	32020		\N	78999	0	444814009	40481087		0
20101	1211	78272	2013-08-02	2013-08-02 00:00:00	2013-09-06	2013-09-06 00:00:00	32020		\N	79678	0	70704007	78272		0
9781	579	257012	1964-04-20	1964-04-20 00:00:00	\N	\N	32020		\N	38289	0	40055000	257012		0
20441	1229	4116491	1977-05-09	1977-05-09 00:00:00	1977-06-18	1977-06-18 00:00:00	32020		\N	81011	0	301011002	4116491		0
20619	1238	4294548	1997-08-18	1997-08-18 00:00:00	1997-10-13	1997-10-13 00:00:00	32020		\N	81580	0	75498004	4294548		0
10283	607	372328	1989-05-25	1989-05-25 00:00:00	1990-12-21	1990-12-21 00:00:00	32020		\N	40340	0	65363002	372328		0
10439	615	40481087	1962-07-03	1962-07-03 00:00:00	1962-07-10	1962-07-10 00:00:00	32020		\N	40997	0	444814009	40481087		0
21116	1267	260139	1959-05-13	1959-05-13 00:00:00	1959-05-20	1959-05-20 00:00:00	32020		\N	83595	0	10509002	260139		0
136	5	80180	2009-05-30	2009-05-30 00:00:00	\N	\N	32020		\N	466	0	396275006	80180		0
10793	640	4112343	1982-04-16	1982-04-16 00:00:00	1982-04-26	1982-04-26 00:00:00	32020		\N	42369	0	195662009	4112343		0
10998	649	4266809	2007-05-29	2007-05-29 00:00:00	\N	\N	32020		\N	43008	0	397881000	4266809		0
11131	656	4156265	2012-05-24	2012-05-24 00:00:00	2012-06-07	2012-06-07 00:00:00	32020		\N	43427	0	370247008	4156265		0
814	43	260139	1979-10-19	1979-10-19 00:00:00	1979-11-02	1979-11-02 00:00:00	32020		\N	3144	0	10509002	260139		0
11533	680	260139	2001-03-01	2001-03-01 00:00:00	2001-03-15	2001-03-15 00:00:00	32020		\N	45044	0	10509002	260139		0
11622	686	4027663	1970-10-07	1970-10-07 00:00:00	\N	\N	32020		\N	45418	0	13200003	4027663		0
11796	697	40481087	2011-03-15	2011-03-15 00:00:00	2011-03-22	2011-03-22 00:00:00	32020		\N	46123	0	444814009	40481087		0
1486	86	4112343	1955-06-05	1955-06-05 00:00:00	1955-06-13	1955-06-13 00:00:00	32020		\N	5803	0	195662009	4112343		0
12151	720	4112343	1986-11-05	1986-11-05 00:00:00	1986-11-16	1986-11-16 00:00:00	32020		\N	47631	0	195662009	4112343		0
1811	103	40481087	1976-06-16	1976-06-16 00:00:00	1976-07-07	1976-07-07 00:00:00	32020		\N	7023	0	444814009	40481087		0
12460	736	4310024	2007-09-24	2007-09-24 00:00:00	\N	\N	32020		\N	48857	0	424802006	4310024		0
12630	747	40481087	1976-02-21	1976-02-21 00:00:00	1976-03-13	1976-03-13 00:00:00	32020		\N	49462	0	444814009	40481087		0
12834	757	80180	1949-11-14	1949-11-14 00:00:00	\N	\N	32020		\N	50285	0	396275006	80180		0
2485	145	4116491	1980-01-14	1980-01-14 00:00:00	1980-03-08	1980-03-08 00:00:00	32020		\N	9785	0	301011002	4116491		0
13137	774	260139	1994-12-22	1994-12-22 00:00:00	1994-12-29	1994-12-29 00:00:00	32020		\N	51372	0	10509002	260139		0
2805	162	4112343	1968-10-18	1968-10-18 00:00:00	1968-10-26	1968-10-26 00:00:00	32020		\N	11107	0	195662009	4112343		0
13471	795	40481087	1965-02-16	1965-02-16 00:00:00	1965-03-02	1965-03-02 00:00:00	32020		\N	52749	0	444814009	40481087		0
3138	184	40481087	1955-12-05	1955-12-05 00:00:00	1955-12-26	1955-12-26 00:00:00	32020		\N	12482	0	444814009	40481087		0
3282	190	40481087	1999-03-14	1999-03-14 00:00:00	1999-04-04	1999-04-04 00:00:00	32020		\N	13002	0	444814009	40481087		0
3464	197	260139	1968-09-08	1968-09-08 00:00:00	1968-09-15	1968-09-15 00:00:00	32020		\N	13534	0	10509002	260139		0
14147	836	372328	1979-05-31	1979-05-31 00:00:00	1979-08-12	1979-08-12 00:00:00	32020		\N	55311	0	65363002	372328		0
3814	220	260139	1993-07-20	1993-07-20 00:00:00	1993-08-03	1993-08-03 00:00:00	32020		\N	14853	0	10509002	260139		0
14462	855	372328	1959-04-27	1959-04-27 00:00:00	1959-10-30	1959-10-30 00:00:00	32020		\N	56504	0	65363002	372328		0
14620	863	28060	1923-04-14	1923-04-14 00:00:00	1923-04-21	1923-04-21 00:00:00	32020		\N	57160	0	43878008	28060		0
14777	870	260139	1962-09-24	1962-09-24 00:00:00	1962-10-01	1962-10-01 00:00:00	32020		\N	57905	0	10509002	260139		0
14982	883	80180	2003-02-25	2003-02-25 00:00:00	\N	\N	32020		\N	58809	0	396275006	80180		0
15115	890	40481087	1967-12-21	1967-12-21 00:00:00	1968-01-04	1968-01-04 00:00:00	32020		\N	59319	0	444814009	40481087		0
15283	905	40481087	1973-06-05	1973-06-05 00:00:00	1973-06-26	1973-06-26 00:00:00	32020		\N	60199	0	444814009	40481087		0
15439	915	4283893	1965-09-24	1965-09-24 00:00:00	1965-10-29	1965-10-29 00:00:00	32020		\N	60791	0	36971009	4283893		0
15611	924	40481087	1964-10-29	1964-10-29 00:00:00	1964-11-19	1964-11-19 00:00:00	32020		\N	61545	0	444814009	40481087		0
5291	311	260139	1986-09-09	1986-09-09 00:00:00	1986-09-16	1986-09-16 00:00:00	32020		\N	20628	0	10509002	260139		0
15978	946	28060	1979-07-16	1979-07-16 00:00:00	1979-07-28	1979-07-28 00:00:00	32020		\N	62804	0	43878008	28060		0
16134	954	195588	1997-04-08	1997-04-08 00:00:00	1997-05-20	1997-05-20 00:00:00	32020		\N	63377	0	38822007	195588		0
5796	340	40481087	1987-08-12	1987-08-12 00:00:00	1987-08-19	1987-08-19 00:00:00	32020		\N	22670	0	444814009	40481087		0
5964	350	28060	2019-04-15	2019-04-15 00:00:00	2019-04-23	2019-04-23 00:00:00	32020		\N	23260	0	43878008	28060		0
6119	359	4283893	1991-08-17	1991-08-17 00:00:00	1992-04-04	1992-04-04 00:00:00	32020		\N	23875	0	36971009	4283893		0
6285	369	260139	1990-05-11	1990-05-11 00:00:00	1990-05-25	1990-05-25 00:00:00	32020		\N	24535	0	10509002	260139		0
6451	379	80180	2014-01-28	2014-01-28 00:00:00	\N	\N	32020		\N	25082	0	396275006	80180		0
17146	1024	40481087	2014-05-15	2014-05-15 00:00:00	2014-05-29	2014-05-29 00:00:00	32020		\N	67472	0	444814009	40481087		0
17291	1036	4152936	2000-06-24	2000-06-24 00:00:00	2000-07-15	2000-07-15 00:00:00	32020		\N	68137	0	283385000	4152936		0
6956	409	40481087	1997-03-09	1997-03-09 00:00:00	1997-03-23	1997-03-23 00:00:00	32020		\N	27010	0	444814009	40481087		0
7123	419	4310024	1953-01-15	1953-01-15 00:00:00	\N	\N	32020		\N	27746	0	424802006	4310024		0
17818	1072	4112343	1977-11-20	1977-11-20 00:00:00	1977-11-28	1977-11-28 00:00:00	32020		\N	70247	0	195662009	4112343		0
7469	439	80180	2013-05-08	2013-05-08 00:00:00	\N	\N	32020		\N	29148	0	396275006	80180		0
18108	1088	4266809	2011-07-11	2011-07-11 00:00:00	\N	\N	32020		\N	71411	0	397881000	4266809		0
7777	455	78272	1954-04-22	1954-04-22 00:00:00	1954-05-13	1954-05-13 00:00:00	32020		\N	30466	0	70704007	78272		0
18440	1108	260139	1981-02-19	1981-02-19 00:00:00	1981-02-26	1981-02-26 00:00:00	32020		\N	72938	0	10509002	260139		0
18605	1118	30753	2012-10-26	2012-10-26 00:00:00	\N	\N	32020		\N	73687	0	16761005	30753		0
18789	1131	4142905	1979-01-30	1979-01-30 00:00:00	1979-04-30	1979-04-30 00:00:00	32020		\N	74478	0	33737001	4142905		0
8455	492	80180	1986-06-16	1986-06-16 00:00:00	\N	\N	32020		\N	32912	0	396275006	80180		0
19091	1145	28060	2018-09-01	2018-09-01 00:00:00	2018-09-10	2018-09-10 00:00:00	32020		\N	75546	0	43878008	28060		0
19276	1155	260139	1990-01-04	1990-01-04 00:00:00	1990-01-11	1990-01-11 00:00:00	32020		\N	76329	0	10509002	260139		0
19538	1173	372328	1946-06-03	1946-06-03 00:00:00	1946-08-19	1946-08-19 00:00:00	32020		\N	77212	0	65363002	372328		0
19610	1176	260139	1971-02-06	1971-02-06 00:00:00	1971-02-20	1971-02-20 00:00:00	32020		\N	77651	0	10509002	260139		0
19824	1193	4112343	1954-03-23	1954-03-23 00:00:00	1954-04-03	1954-04-03 00:00:00	32020		\N	78596	0	195662009	4112343		0
19943	1201	4027663	2000-10-04	2000-10-04 00:00:00	\N	\N	32020		\N	79003	0	13200003	4027663		0
20102	1211	260139	1967-01-07	1967-01-07 00:00:00	1967-01-14	1967-01-14 00:00:00	32020		\N	79516	0	10509002	260139		0
9782	579	81151	2005-10-28	2005-10-28 00:00:00	2005-12-02	2005-12-02 00:00:00	32020		\N	38339	0	44465007	81151		0
20442	1229	260139	2001-08-24	2001-08-24 00:00:00	2001-09-07	2001-09-07 00:00:00	32020		\N	81008	0	10509002	260139		0
20620	1238	4266809	1997-09-13	1997-09-13 00:00:00	\N	\N	32020		\N	81580	0	397881000	4266809		0
10284	607	4112343	1964-09-18	1964-09-18 00:00:00	1964-09-27	1964-09-27 00:00:00	32020		\N	40322	0	195662009	4112343		0
10440	615	80502	2000-09-09	2000-09-09 00:00:00	\N	\N	32020		\N	40882	0	64859006	80502		0
21117	1267	4283893	1973-03-30	1973-03-30 00:00:00	1973-06-08	1973-06-08 00:00:00	32020		\N	83597	0	36971009	4283893		0
137	6	4112343	1993-09-27	1993-09-27 00:00:00	1993-10-04	1993-10-04 00:00:00	32020		\N	565	0	195662009	4112343		0
10794	640	40481087	1984-07-06	1984-07-06 00:00:00	1984-07-27	1984-07-27 00:00:00	32020		\N	42343	0	444814009	40481087		0
10999	649	40481087	1986-03-04	1986-03-04 00:00:00	1986-03-18	1986-03-18 00:00:00	32020		\N	43034	0	444814009	40481087		0
11132	656	4112343	2012-07-04	2012-07-04 00:00:00	2012-07-12	2012-07-12 00:00:00	32020		\N	43447	0	195662009	4112343		0
815	43	4112343	2018-07-19	2018-07-19 00:00:00	2018-07-30	2018-07-30 00:00:00	32020		\N	3149	0	195662009	4112343		0
11534	680	257012	1995-07-07	1995-07-07 00:00:00	\N	\N	32020		\N	45076	0	40055000	257012		0
11623	686	30753	1980-01-27	1980-01-27 00:00:00	\N	\N	32020		\N	45407	0	16761005	30753		0
11797	697	260139	1995-12-10	1995-12-10 00:00:00	1995-12-17	1995-12-17 00:00:00	32020		\N	46126	0	10509002	260139		0
1487	86	81151	1952-04-03	1952-04-03 00:00:00	1952-05-02	1952-05-02 00:00:00	32020		\N	5790	0	44465007	81151		0
12152	720	257012	1966-06-22	1966-06-22 00:00:00	\N	\N	32020		\N	47613	0	40055000	257012		0
1812	103	4112343	2000-12-25	2000-12-25 00:00:00	2001-01-06	2001-01-06 00:00:00	32020		\N	7062	0	195662009	4112343		0
12461	736	4112343	1977-10-17	1977-10-17 00:00:00	1977-10-30	1977-10-30 00:00:00	32020		\N	48777	0	195662009	4112343		0
12631	747	40481087	1967-11-07	1967-11-07 00:00:00	1967-11-28	1967-11-28 00:00:00	32020		\N	49442	0	444814009	40481087		0
12835	757	4112343	1921-08-05	1921-08-05 00:00:00	1921-08-12	1921-08-12 00:00:00	32020		\N	50204	0	195662009	4112343		0
2486	145	260139	1969-05-17	1969-05-17 00:00:00	1969-05-31	1969-05-31 00:00:00	32020		\N	9673	0	10509002	260139		0
13138	774	4112343	2010-11-15	2010-11-15 00:00:00	2010-11-22	2010-11-22 00:00:00	32020		\N	51394	0	195662009	4112343		0
2806	162	40481087	1944-03-20	1944-03-20 00:00:00	1944-04-10	1944-04-10 00:00:00	32020		\N	11105	0	444814009	40481087		0
13472	795	4116491	1973-08-10	1973-08-10 00:00:00	1973-09-19	1973-09-19 00:00:00	32020		\N	52707	0	301011002	4116491		0
3139	184	28060	1966-10-28	1966-10-28 00:00:00	1966-11-05	1966-11-05 00:00:00	32020		\N	12433	0	43878008	28060		0
3283	190	372328	1930-08-07	1930-08-07 00:00:00	1930-10-14	1930-10-14 00:00:00	32020		\N	12972	0	65363002	372328		0
3465	197	81151	1973-01-11	1973-01-11 00:00:00	1973-02-08	1973-02-08 00:00:00	32020		\N	13529	0	44465007	81151		0
14148	836	40481087	1987-06-26	1987-06-26 00:00:00	1987-07-10	1987-07-10 00:00:00	32020		\N	55304	0	444814009	40481087		0
3815	220	372328	1982-10-31	1982-10-31 00:00:00	1982-12-08	1982-12-08 00:00:00	32020		\N	14795	0	65363002	372328		0
14463	855	40481087	1957-12-25	1957-12-25 00:00:00	1958-01-15	1958-01-15 00:00:00	32020		\N	56459	0	444814009	40481087		0
14621	864	260139	1960-03-18	1960-03-18 00:00:00	1960-03-25	1960-03-25 00:00:00	32020		\N	57261	0	10509002	260139		0
14778	870	372328	1965-12-01	1965-12-01 00:00:00	1966-11-29	1966-11-29 00:00:00	32020		\N	57867	0	65363002	372328		0
14983	883	40481087	1999-11-07	1999-11-07 00:00:00	1999-11-14	1999-11-14 00:00:00	32020		\N	58815	0	444814009	40481087		0
15116	890	378001	1968-04-11	1968-04-11 00:00:00	1968-06-10	1968-06-10 00:00:00	32020		\N	59326	0	62106007	378001		0
15284	905	28060	1972-01-18	1972-01-18 00:00:00	1972-01-29	1972-01-29 00:00:00	32020		\N	60198	0	43878008	28060		0
15440	915	40481087	1964-08-10	1964-08-10 00:00:00	1964-08-24	1964-08-24 00:00:00	32020		\N	60834	0	444814009	40481087		0
15612	924	40481087	1980-02-11	1980-02-11 00:00:00	1980-03-03	1980-03-03 00:00:00	32020		\N	61569	0	444814009	40481087		0
5292	311	440086	1984-07-24	1984-07-24 00:00:00	1985-07-09	1985-07-09 00:00:00	32020		\N	20631	0	192127007	440086		0
15979	946	257012	2014-07-31	2014-07-31 00:00:00	\N	\N	32020		\N	62805	0	40055000	257012		0
16135	954	4113008	2007-04-08	2007-04-08 00:00:00	2007-04-29	2007-04-29 00:00:00	32020		\N	63419	0	284549007	4113008		0
5797	340	40481087	2006-11-05	2006-11-05 00:00:00	2006-11-12	2006-11-12 00:00:00	32020		\N	22683	0	444814009	40481087		0
5965	350	372328	1961-12-06	1961-12-06 00:00:00	1962-02-23	1962-02-23 00:00:00	32020		\N	23327	0	65363002	372328		0
6120	359	78272	1983-09-21	1983-09-21 00:00:00	1983-10-19	1983-10-19 00:00:00	32020		\N	23882	0	70704007	78272		0
6286	369	260139	2009-03-22	2009-03-22 00:00:00	2009-03-29	2009-03-29 00:00:00	32020		\N	24529	0	10509002	260139		0
6452	379	4230399	1977-02-16	1977-02-16 00:00:00	1977-03-18	1977-03-18 00:00:00	32020		\N	25065	0	359817006	4230399		0
17147	1024	40481087	1987-11-13	1987-11-13 00:00:00	1987-11-27	1987-11-27 00:00:00	32020		\N	67443	0	444814009	40481087		0
17292	1036	4237458	1983-10-22	1983-10-22 00:00:00	1984-01-20	1984-01-20 00:00:00	32020		\N	68136	0	58150001	4237458		0
6957	409	4237458	1965-05-20	1965-05-20 00:00:00	1965-06-19	1965-06-19 00:00:00	32020		\N	27150	0	58150001	4237458		0
7124	419	30753	1953-05-15	1953-05-15 00:00:00	\N	\N	32020		\N	27746	0	16761005	30753		0
17819	1072	40481087	1995-02-15	1995-02-15 00:00:00	1995-02-22	1995-02-22 00:00:00	32020		\N	70251	0	444814009	40481087		0
7470	439	372328	2002-12-21	2002-12-21 00:00:00	2005-10-27	2005-10-27 00:00:00	32020		\N	29166	0	65363002	372328		0
18109	1088	40481087	2011-04-09	2011-04-09 00:00:00	2011-04-23	2011-04-23 00:00:00	32020		\N	71411	0	444814009	40481087		0
7778	455	40481087	1970-07-31	1970-07-31 00:00:00	1970-08-21	1970-08-21 00:00:00	32020		\N	30378	0	444814009	40481087		0
18441	1108	260139	1978-06-14	1978-06-14 00:00:00	1978-06-28	1978-06-28 00:00:00	32020		\N	72945	0	10509002	260139		0
18606	1118	40481087	2019-06-21	2019-06-21 00:00:00	\N	\N	32020		\N	73751	0	444814009	40481087		0
18790	1131	134438	1997-08-10	1997-08-10 00:00:00	1998-08-05	1998-08-05 00:00:00	32020		\N	74446	0	40275004	134438		0
8456	492	4296205	1952-08-13	1952-08-13 00:00:00	1952-09-17	1952-09-17 00:00:00	32020		\N	32985	0	403191005	4296205		0
19092	1145	81151	1961-10-22	1961-10-22 00:00:00	1961-11-26	1961-11-26 00:00:00	32020		\N	75555	0	44465007	81151		0
19277	1155	4134304	1981-03-04	1981-03-04 00:00:00	1981-04-03	1981-04-03 00:00:00	32020		\N	76312	0	263102004	4134304		0
19539	1173	40481087	2018-04-28	2018-04-28 00:00:00	2018-05-05	2018-05-05 00:00:00	32020		\N	77211	0	444814009	40481087		0
19611	1176	260139	1981-07-29	1981-07-29 00:00:00	1981-08-12	1981-08-12 00:00:00	32020		\N	77652	0	10509002	260139		0
19825	1193	260139	1975-04-15	1975-04-15 00:00:00	1975-04-29	1975-04-29 00:00:00	32020		\N	78641	0	10509002	260139		0
19944	1202	40481087	1998-11-15	1998-11-15 00:00:00	1998-12-06	1998-12-06 00:00:00	32020		\N	79072	0	444814009	40481087		0
20103	1211	4112343	2008-12-02	2008-12-02 00:00:00	2008-12-09	2008-12-09 00:00:00	32020		\N	79630	0	195662009	4112343		0
9783	579	81151	1994-07-25	1994-07-25 00:00:00	1994-08-29	1994-08-29 00:00:00	32020		\N	38337	0	44465007	81151		0
20443	1229	40481087	1957-08-31	1957-08-31 00:00:00	1957-09-07	1957-09-07 00:00:00	32020		\N	81009	0	444814009	40481087		0
20621	1238	80180	1997-09-13	1997-09-13 00:00:00	\N	\N	32020		\N	81580	0	396275006	80180		0
10285	607	28060	2009-05-09	2009-05-09 00:00:00	2009-05-21	2009-05-21 00:00:00	32020		\N	40270	0	43878008	28060		0
10441	615	4112343	1946-06-14	1946-06-14 00:00:00	1946-06-21	1946-06-21 00:00:00	32020		\N	40911	0	195662009	4112343		0
21118	1267	4112343	1961-06-29	1961-06-29 00:00:00	1961-07-10	1961-07-10 00:00:00	32020		\N	83514	0	195662009	4112343		0
138	6	372328	1966-10-03	1966-10-03 00:00:00	1966-12-06	1966-12-06 00:00:00	32020		\N	583	0	65363002	372328		0
10795	640	4112343	2006-06-20	2006-06-20 00:00:00	2006-07-01	2006-07-01 00:00:00	32020		\N	42402	0	195662009	4112343		0
11000	649	4112343	2013-10-24	2013-10-24 00:00:00	2013-10-31	2013-10-31 00:00:00	32020		\N	42980	0	195662009	4112343		0
11133	656	40481087	1992-07-03	1992-07-03 00:00:00	1992-07-17	1992-07-17 00:00:00	32020		\N	43494	0	444814009	40481087		0
816	43	378001	1984-07-23	1984-07-23 00:00:00	1984-08-22	1984-08-22 00:00:00	32020		\N	3153	0	62106007	378001		0
11535	680	40481087	1994-11-07	1994-11-07 00:00:00	1994-11-21	1994-11-21 00:00:00	32020		\N	45042	0	444814009	40481087		0
11624	686	4285898	1980-10-24	1980-10-24 00:00:00	\N	\N	32020		\N	45407	0	68496003	4285898		0
11798	697	4283893	2015-07-05	2015-07-05 00:00:00	2015-09-13	2015-09-13 00:00:00	32020		\N	46136	0	36971009	4283893		0
1488	86	40481087	1952-04-12	1952-04-12 00:00:00	1952-04-19	1952-04-19 00:00:00	32020		\N	5827	0	444814009	40481087		0
12153	720	81151	1997-02-28	1997-02-28 00:00:00	1997-03-14	1997-03-14 00:00:00	32020		\N	47659	0	44465007	81151		0
1813	103	260139	2002-04-30	2002-04-30 00:00:00	2002-05-07	2002-05-07 00:00:00	32020		\N	7046	0	10509002	260139		0
12462	736	80180	2009-10-13	2009-10-13 00:00:00	\N	\N	32020		\N	48844	0	396275006	80180		0
12632	747	40481087	1996-07-07	1996-07-07 00:00:00	1996-07-21	1996-07-21 00:00:00	32020		\N	49489	0	444814009	40481087		0
12836	757	255848	1998-10-17	1998-10-17 00:00:00	\N	\N	32020		\N	50187	0	233604007	255848		0
2487	145	81151	1955-06-27	1955-06-27 00:00:00	1955-08-01	1955-08-01 00:00:00	32020		\N	9811	0	44465007	81151		0
13139	774	4283893	1992-04-22	1992-04-22 00:00:00	1992-05-27	1992-05-27 00:00:00	32020		\N	51349	0	36971009	4283893		0
2807	162	40481087	1998-08-13	1998-08-13 00:00:00	1998-08-20	1998-08-20 00:00:00	32020		\N	11108	0	444814009	40481087		0
13473	795	4112343	1954-02-18	1954-02-18 00:00:00	1954-02-27	1954-02-27 00:00:00	32020		\N	52774	0	195662009	4112343		0
3140	185	4112343	1962-08-29	1962-08-29 00:00:00	1962-09-05	1962-09-05 00:00:00	32020		\N	12567	0	195662009	4112343		0
3284	190	40481087	1990-05-08	1990-05-08 00:00:00	1990-05-22	1990-05-22 00:00:00	32020		\N	12983	0	444814009	40481087		0
3466	197	4109685	1975-10-26	1975-10-26 00:00:00	1975-11-16	1975-11-16 00:00:00	32020		\N	13530	0	284551006	4109685		0
14149	836	4113008	1987-06-02	1987-06-02 00:00:00	1987-06-23	1987-06-23 00:00:00	32020		\N	55324	0	284549007	4113008		0
3816	220	28060	1985-08-17	1985-08-17 00:00:00	1985-08-24	1985-08-24 00:00:00	32020		\N	14812	0	43878008	28060		0
14464	855	4266809	1999-03-08	1999-03-08 00:00:00	\N	\N	32020		\N	56512	0	397881000	4266809		0
14622	864	40481087	1936-09-05	1936-09-05 00:00:00	1936-09-12	1936-09-12 00:00:00	32020		\N	57260	0	444814009	40481087		0
14779	870	4294548	1968-08-27	1968-08-27 00:00:00	1968-12-24	1968-12-24 00:00:00	32020		\N	57903	0	75498004	4294548		0
14984	883	40481087	1982-01-02	1982-01-02 00:00:00	1982-01-16	1982-01-16 00:00:00	32020		\N	58794	0	444814009	40481087		0
15117	890	28060	2015-05-25	2015-05-25 00:00:00	2015-06-04	2015-06-04 00:00:00	32020		\N	59305	0	43878008	28060		0
15285	905	260139	2018-09-22	2018-09-22 00:00:00	2018-09-29	2018-09-29 00:00:00	32020		\N	60157	0	10509002	260139		0
15441	915	78272	2012-08-03	2012-08-03 00:00:00	2012-08-17	2012-08-17 00:00:00	32020		\N	60787	0	70704007	78272		0
15613	924	4112343	1992-08-12	1992-08-12 00:00:00	1992-08-22	1992-08-22 00:00:00	32020		\N	61529	0	195662009	4112343		0
5293	311	80180	2011-10-06	2011-10-06 00:00:00	\N	\N	32020		\N	20647	0	396275006	80180		0
15980	946	40481087	2018-04-11	2018-04-11 00:00:00	2018-04-18	2018-04-18 00:00:00	32020		\N	62802	0	444814009	40481087		0
16136	954	40481087	1975-11-12	1975-11-12 00:00:00	1975-11-26	1975-11-26 00:00:00	32020		\N	63379	0	444814009	40481087		0
5798	340	40481087	1962-03-29	1962-03-29 00:00:00	1962-04-19	1962-04-19 00:00:00	32020		\N	22684	0	444814009	40481087		0
5966	350	81151	2003-01-03	2003-01-03 00:00:00	2003-01-24	2003-01-24 00:00:00	32020		\N	23295	0	44465007	81151		0
6121	359	260139	1986-09-06	1986-09-06 00:00:00	1986-09-13	1986-09-13 00:00:00	32020		\N	23888	0	10509002	260139		0
6287	369	40481087	2018-07-18	2018-07-18 00:00:00	2018-08-08	2018-08-08 00:00:00	32020		\N	24567	0	444814009	40481087		0
6453	379	4112343	2001-07-08	2001-07-08 00:00:00	2001-07-21	2001-07-21 00:00:00	32020		\N	25075	0	195662009	4112343		0
17148	1024	260139	1955-07-17	1955-07-17 00:00:00	1955-07-31	1955-07-31 00:00:00	32020		\N	67398	0	10509002	260139		0
17293	1036	40481087	2007-11-27	2007-11-27 00:00:00	2007-12-18	2007-12-18 00:00:00	32020		\N	68186	0	444814009	40481087		0
6958	409	4134304	1955-10-10	1955-10-10 00:00:00	1955-11-09	1955-11-09 00:00:00	32020		\N	27149	0	263102004	4134304		0
7125	419	372328	1913-10-17	1913-10-17 00:00:00	1914-01-04	1914-01-04 00:00:00	32020		\N	27762	0	65363002	372328		0
17820	1072	40481087	1974-01-22	1974-01-22 00:00:00	1974-02-12	1974-02-12 00:00:00	32020		\N	70246	0	444814009	40481087		0
17931	1079	40481087	1999-12-28	1999-12-28 00:00:00	2000-01-18	2000-01-18 00:00:00	32020		\N	70713	0	444814009	40481087		0
18110	1088	80180	2011-07-11	2011-07-11 00:00:00	\N	\N	32020		\N	71411	0	396275006	80180		0
7779	455	378001	1973-04-03	1973-04-03 00:00:00	1973-05-03	1973-05-03 00:00:00	32020		\N	30468	0	62106007	378001		0
18442	1108	375671	2000-08-05	2000-08-05 00:00:00	2000-09-04	2000-09-04 00:00:00	32020		\N	72997	0	62564004	375671		0
18607	1118	28060	1994-03-29	1994-03-29 00:00:00	1994-04-06	1994-04-06 00:00:00	32020		\N	73677	0	43878008	28060		0
18791	1131	40481087	1973-06-21	1973-06-21 00:00:00	1973-07-05	1973-07-05 00:00:00	32020		\N	74435	0	444814009	40481087		0
8457	492	40481087	1993-12-29	1993-12-29 00:00:00	1994-01-05	1994-01-05 00:00:00	32020		\N	32940	0	444814009	40481087		0
19093	1145	4152936	2006-08-02	2006-08-02 00:00:00	2006-08-16	2006-08-16 00:00:00	32020		\N	75557	0	283385000	4152936		0
19278	1155	40481087	1974-07-16	1974-07-16 00:00:00	1974-08-06	1974-08-06 00:00:00	32020		\N	76298	0	444814009	40481087		0
19540	1173	372328	1947-06-15	1947-06-15 00:00:00	1947-08-18	1947-08-18 00:00:00	32020		\N	77248	0	65363002	372328		0
19612	1176	4084167	1963-10-14	1963-10-14 00:00:00	1963-10-14	1963-10-14 00:00:00	32020		\N	77642	0	241929008	4084167		0
19826	1193	378001	1975-01-04	1975-01-04 00:00:00	1975-02-03	1975-02-03 00:00:00	32020		\N	78623	0	62106007	378001		0
19945	1202	40481087	1986-11-09	1986-11-09 00:00:00	1986-11-16	1986-11-16 00:00:00	32020		\N	79059	0	444814009	40481087		0
20104	1211	260139	1984-11-26	1984-11-26 00:00:00	1984-12-10	1984-12-10 00:00:00	32020		\N	79543	0	10509002	260139		0
9784	579	260139	1994-03-30	1994-03-30 00:00:00	1994-04-06	1994-04-06 00:00:00	32020		\N	38293	0	10509002	260139		0
20444	1229	375671	1976-07-18	1976-07-18 00:00:00	1976-09-16	1976-09-16 00:00:00	32020		\N	80980	0	62564004	375671		0
20622	1238	257012	1997-10-06	1997-10-06 00:00:00	\N	\N	32020		\N	81585	0	40055000	257012		0
10286	607	81151	2016-12-28	2016-12-28 00:00:00	2017-01-25	2017-01-25 00:00:00	32020		\N	40300	0	44465007	81151		0
10442	615	80180	1941-12-05	1941-12-05 00:00:00	\N	\N	32020		\N	40873	0	396275006	80180		0
21119	1267	260139	1955-10-21	1955-10-21 00:00:00	1955-10-28	1955-10-28 00:00:00	32020		\N	83517	0	10509002	260139		0
139	6	372328	1969-12-20	1969-12-20 00:00:00	1970-12-22	1970-12-22 00:00:00	32020		\N	573	0	65363002	372328		0
10796	640	40481087	1998-05-02	1998-05-02 00:00:00	1998-05-16	1998-05-16 00:00:00	32020		\N	42378	0	444814009	40481087		0
11002	649	321042	2011-01-25	2011-01-25 00:00:00	\N	\N	32020		\N	42970	0	410429000	321042		0
11134	656	4146173	2011-03-24	2011-03-24 00:00:00	2011-04-30	2011-04-30 00:00:00	32020		\N	43496	0	307731004	4146173		0
817	43	4116491	1991-12-09	1991-12-09 00:00:00	1992-01-14	1992-01-14 00:00:00	32020		\N	3145	0	301011002	4116491		0
11536	680	372328	1967-10-25	1967-10-25 00:00:00	1968-01-01	1968-01-01 00:00:00	32020		\N	45045	0	65363002	372328		0
11625	686	80180	1980-12-22	1980-12-22 00:00:00	\N	\N	32020		\N	45407	0	396275006	80180		0
11799	697	260139	2012-04-22	2012-04-22 00:00:00	2012-04-29	2012-04-29 00:00:00	32020		\N	46111	0	10509002	260139		0
1489	86	317576	2013-04-30	2013-04-30 00:00:00	\N	\N	32020		\N	5814	0	53741008	317576		0
12154	720	4310024	1998-01-18	1998-01-18 00:00:00	\N	\N	32020		\N	47659	0	424802006	4310024		0
1814	103	28060	2009-08-26	2009-08-26 00:00:00	2009-09-05	2009-09-05 00:00:00	32020		\N	7035	0	43878008	28060		0
12463	736	4266809	2009-10-13	2009-10-13 00:00:00	\N	\N	32020		\N	48844	0	397881000	4266809		0
12633	747	40481087	1993-01-10	1993-01-10 00:00:00	1993-01-17	1993-01-17 00:00:00	32020		\N	49456	0	444814009	40481087		0
12837	757	260139	1990-05-21	1990-05-21 00:00:00	1990-05-28	1990-05-28 00:00:00	32020		\N	50183	0	10509002	260139		0
2488	145	195588	1973-11-24	1973-11-24 00:00:00	1974-01-15	1974-01-15 00:00:00	32020		\N	9718	0	38822007	195588		0
13140	774	4113008	1985-08-14	1985-08-14 00:00:00	1985-08-28	1985-08-28 00:00:00	32020		\N	51390	0	284549007	4113008		0
2808	162	260139	1964-11-06	1964-11-06 00:00:00	1964-11-20	1964-11-20 00:00:00	32020		\N	11161	0	10509002	260139		0
13474	795	40481087	1951-05-09	1951-05-09 00:00:00	1951-05-23	1951-05-23 00:00:00	32020		\N	52720	0	444814009	40481087		0
3141	185	4152936	1982-05-03	1982-05-03 00:00:00	1982-05-17	1982-05-17 00:00:00	32020		\N	12520	0	283385000	4152936		0
3285	190	4035415	1954-11-29	1954-11-29 00:00:00	1955-01-28	1955-01-28 00:00:00	32020		\N	12910	0	239720000	4035415		0
3467	197	4112343	1963-09-05	1963-09-05 00:00:00	1963-09-13	1963-09-13 00:00:00	32020		\N	13568	0	195662009	4112343		0
14150	836	4112343	2010-02-21	2010-02-21 00:00:00	2010-03-06	2010-03-06 00:00:00	32020		\N	55298	0	195662009	4112343		0
3817	220	40481087	1997-05-05	1997-05-05 00:00:00	1997-05-26	1997-05-26 00:00:00	32020		\N	14854	0	444814009	40481087		0
14465	855	80180	1999-03-08	1999-03-08 00:00:00	\N	\N	32020		\N	56512	0	396275006	80180		0
14623	864	4218389	1997-08-03	1997-08-03 00:00:00	1997-08-31	1997-08-31 00:00:00	32020		\N	57325	0	39848009	4218389		0
14780	870	78272	1979-02-10	1979-02-10 00:00:00	1979-03-17	1979-03-17 00:00:00	32020		\N	57893	0	70704007	78272		0
14985	883	28060	1969-09-14	1969-09-14 00:00:00	1969-09-23	1969-09-23 00:00:00	32020		\N	58791	0	43878008	28060		0
15118	890	4112343	1964-10-15	1964-10-15 00:00:00	1964-10-23	1964-10-23 00:00:00	32020		\N	59317	0	195662009	4112343		0
15286	905	260139	1973-01-30	1973-01-30 00:00:00	1973-02-13	1973-02-13 00:00:00	32020		\N	60148	0	10509002	260139		0
15442	915	260139	1969-08-06	1969-08-06 00:00:00	1969-08-13	1969-08-13 00:00:00	32020		\N	60860	0	10509002	260139		0
15614	924	40481087	1971-04-08	1971-04-08 00:00:00	1971-04-22	1971-04-22 00:00:00	32020		\N	61546	0	444814009	40481087		0
5294	311	40481087	2010-02-22	2010-02-22 00:00:00	2010-03-08	2010-03-08 00:00:00	32020		\N	20617	0	444814009	40481087		0
15981	946	4112343	1967-10-30	1967-10-30 00:00:00	1967-11-12	1967-11-12 00:00:00	32020		\N	62768	0	195662009	4112343		0
16137	954	28060	1978-03-06	1978-03-06 00:00:00	1978-03-14	1978-03-14 00:00:00	32020		\N	63380	0	43878008	28060		0
5799	340	4112343	2010-12-05	2010-12-05 00:00:00	2010-12-13	2010-12-13 00:00:00	32020		\N	22673	0	195662009	4112343		0
5967	350	4112343	2009-11-07	2009-11-07 00:00:00	2009-11-17	2009-11-17 00:00:00	32020		\N	23303	0	195662009	4112343		0
6122	359	40481087	2006-03-31	2006-03-31 00:00:00	2006-04-07	2006-04-07 00:00:00	32020		\N	23878	0	444814009	40481087		0
6288	369	40481087	2012-05-05	2012-05-05 00:00:00	2012-05-12	2012-05-12 00:00:00	32020		\N	24566	0	444814009	40481087		0
6454	379	4112343	1992-10-11	1992-10-11 00:00:00	1992-10-20	1992-10-20 00:00:00	32020		\N	25068	0	195662009	4112343		0
17149	1024	40481087	1966-02-02	1966-02-02 00:00:00	1966-02-09	1966-02-09 00:00:00	32020		\N	67466	0	444814009	40481087		0
17294	1036	372328	1970-11-29	1970-11-29 00:00:00	1971-02-12	1971-02-12 00:00:00	32020		\N	68189	0	65363002	372328		0
6959	409	260139	2011-11-17	2011-11-17 00:00:00	2011-11-24	2011-11-24 00:00:00	32020		\N	27012	0	10509002	260139		0
7126	419	40481087	1966-07-09	1966-07-09 00:00:00	1966-07-30	1966-07-30 00:00:00	32020		\N	27757	0	444814009	40481087		0
17821	1072	4112343	1994-07-23	1994-07-23 00:00:00	1994-07-31	1994-07-31 00:00:00	32020		\N	70259	0	195662009	4112343		0
17932	1079	4294548	1964-08-09	1964-08-09 00:00:00	1964-09-27	1964-09-27 00:00:00	32020		\N	70747	0	75498004	4294548		0
18111	1088	40481087	1981-04-23	1981-04-23 00:00:00	1981-05-07	1981-05-07 00:00:00	32020		\N	71446	0	444814009	40481087		0
7781	455	260139	2007-11-27	2007-11-27 00:00:00	2007-12-11	2007-12-11 00:00:00	32020		\N	30381	0	10509002	260139		0
18443	1108	40481087	1994-04-16	1994-04-16 00:00:00	1994-04-30	1994-04-30 00:00:00	32020		\N	72967	0	444814009	40481087		0
18608	1118	4051466	1976-08-18	1976-08-18 00:00:00	1992-11-22	1992-11-22 00:00:00	32020		\N	73680	0	233678006	4051466		0
18792	1131	4112343	1991-09-21	1991-09-21 00:00:00	1991-10-02	1991-10-02 00:00:00	32020		\N	74445	0	195662009	4112343		0
8458	492	4112343	2016-06-10	2016-06-10 00:00:00	2016-06-21	2016-06-21 00:00:00	32020		\N	32986	0	195662009	4112343		0
19094	1145	40481087	1979-02-24	1979-02-24 00:00:00	1979-03-17	1979-03-17 00:00:00	32020		\N	75632	0	444814009	40481087		0
19279	1155	4112343	2016-01-03	2016-01-03 00:00:00	2016-01-16	2016-01-16 00:00:00	32020		\N	76377	0	195662009	4112343		0
19541	1173	4218389	1993-02-01	1993-02-01 00:00:00	1993-02-22	1993-02-22 00:00:00	32020		\N	77236	0	39848009	4218389		0
19613	1176	4084167	1999-11-13	1999-11-13 00:00:00	1999-11-13	1999-11-13 00:00:00	32020		\N	77647	0	241929008	4084167		0
19827	1193	4142905	1951-11-14	1951-11-14 00:00:00	1952-01-13	1952-01-13 00:00:00	32020		\N	78617	0	33737001	4142905		0
19946	1202	4112343	2004-02-22	2004-02-22 00:00:00	2004-02-29	2004-02-29 00:00:00	32020		\N	79081	0	195662009	4112343		0
20105	1211	40481087	2013-11-25	2013-11-25 00:00:00	2013-12-09	2013-12-09 00:00:00	32020		\N	79634	0	444814009	40481087		0
9785	579	4294548	2012-05-17	2012-05-17 00:00:00	2012-08-23	2012-08-23 00:00:00	32020		\N	38294	0	75498004	4294548		0
20445	1229	40481087	1983-06-02	1983-06-02 00:00:00	1983-06-23	1983-06-23 00:00:00	32020		\N	80956	0	444814009	40481087		0
20623	1238	4310024	1995-03-28	1995-03-28 00:00:00	\N	\N	32020		\N	81600	0	424802006	4310024		0
10287	607	260139	2009-09-09	2009-09-09 00:00:00	2009-09-16	2009-09-16 00:00:00	32020		\N	40280	0	10509002	260139		0
10443	615	4112343	1913-12-21	1913-12-21 00:00:00	1914-01-03	1914-01-03 00:00:00	32020		\N	41001	0	195662009	4112343		0
21120	1267	4294548	1996-09-13	1996-09-13 00:00:00	1996-11-08	1996-11-08 00:00:00	32020		\N	83550	0	75498004	4294548		0
141	6	4029498	2003-12-21	2003-12-21 00:00:00	\N	\N	32020		\N	559	0	128613002	4029498		0
10797	640	260139	1960-03-26	1960-03-26 00:00:00	1960-04-02	1960-04-02 00:00:00	32020		\N	42368	0	10509002	260139		0
11003	649	257012	2011-04-29	2011-04-29 00:00:00	\N	\N	32020		\N	43017	0	40055000	257012		0
11135	656	40481087	1999-08-03	1999-08-03 00:00:00	1999-08-17	1999-08-17 00:00:00	32020		\N	43495	0	444814009	40481087		0
818	43	28060	1961-02-11	1961-02-11 00:00:00	1961-02-18	1961-02-18 00:00:00	32020		\N	3190	0	43878008	28060		0
11537	680	80180	2002-10-01	2002-10-01 00:00:00	\N	\N	32020		\N	45064	0	396275006	80180		0
11626	686	4266809	1980-12-22	1980-12-22 00:00:00	\N	\N	32020		\N	45407	0	397881000	4266809		0
11800	697	260139	1986-04-16	1986-04-16 00:00:00	1986-04-23	1986-04-23 00:00:00	32020		\N	46121	0	10509002	260139		0
1490	86	260139	1957-02-23	1957-02-23 00:00:00	1957-03-02	1957-03-02 00:00:00	32020		\N	5804	0	10509002	260139		0
12155	720	192671	2000-11-02	2000-11-02 00:00:00	\N	\N	32020		\N	47660	0	K92.2	35208414		0
1815	103	260139	1996-09-03	1996-09-03 00:00:00	1996-09-10	1996-09-10 00:00:00	32020		\N	7034	0	10509002	260139		0
12464	736	40481087	2009-08-09	2009-08-09 00:00:00	2009-08-30	2009-08-30 00:00:00	32020		\N	48844	0	444814009	40481087		0
12634	747	40481087	2012-02-19	2012-02-19 00:00:00	2012-03-11	2012-03-11 00:00:00	32020		\N	49472	0	444814009	40481087		0
12838	757	260139	1935-05-24	1935-05-24 00:00:00	1935-06-07	1935-06-07 00:00:00	32020		\N	50182	0	10509002	260139		0
2489	145	40481087	1997-08-26	1997-08-26 00:00:00	1997-09-02	1997-09-02 00:00:00	32020		\N	9787	0	444814009	40481087		0
13141	774	257012	1992-05-13	1992-05-13 00:00:00	\N	\N	32020		\N	51371	0	40055000	257012		0
2809	162	4112343	1951-06-19	1951-06-19 00:00:00	1951-06-30	1951-06-30 00:00:00	32020		\N	11083	0	195662009	4112343		0
13475	795	260139	1984-02-16	1984-02-16 00:00:00	1984-03-01	1984-03-01 00:00:00	32020		\N	52743	0	10509002	260139		0
3142	185	4112343	1948-10-01	1948-10-01 00:00:00	1948-10-10	1948-10-10 00:00:00	32020		\N	12566	0	195662009	4112343		0
3286	190	4112343	1963-10-10	1963-10-10 00:00:00	1963-10-21	1963-10-21 00:00:00	32020		\N	12982	0	195662009	4112343		0
3468	197	80180	1996-07-31	1996-07-31 00:00:00	\N	\N	32020		\N	13564	0	396275006	80180		0
14151	836	372328	2010-09-04	2010-09-04 00:00:00	2013-03-03	2013-03-03 00:00:00	32020		\N	55332	0	65363002	372328		0
3818	220	4218389	1991-12-04	1991-12-04 00:00:00	1991-12-25	1991-12-25 00:00:00	32020		\N	14837	0	39848009	4218389		0
14466	855	4285898	1999-01-07	1999-01-07 00:00:00	\N	\N	32020		\N	56512	0	68496003	4285898		0
14624	864	4296205	1935-12-21	1935-12-21 00:00:00	1936-01-25	1936-01-25 00:00:00	32020		\N	57278	0	403191005	4296205		0
14781	870	81151	2002-11-11	2002-11-11 00:00:00	2002-12-02	2002-12-02 00:00:00	32020		\N	57851	0	44465007	81151		0
14986	883	4112343	1993-01-03	1993-01-03 00:00:00	1993-01-14	1993-01-14 00:00:00	32020		\N	58822	0	195662009	4112343		0
15119	890	40481087	1986-08-21	1986-08-21 00:00:00	1986-09-04	1986-09-04 00:00:00	32020		\N	59335	0	444814009	40481087		0
15287	905	40481087	1995-11-25	1995-11-25 00:00:00	1995-12-09	1995-12-09 00:00:00	32020		\N	60150	0	444814009	40481087		0
15443	915	4134304	1961-01-19	1961-01-19 00:00:00	1961-03-20	1961-03-20 00:00:00	32020		\N	60784	0	263102004	4134304		0
15615	924	260139	1968-02-04	1968-02-04 00:00:00	1968-02-11	1968-02-11 00:00:00	32020		\N	61527	0	10509002	260139		0
5295	311	81151	2016-09-18	2016-09-18 00:00:00	2016-10-23	2016-10-23 00:00:00	32020		\N	20656	0	44465007	81151		0
15982	946	260139	2001-03-21	2001-03-21 00:00:00	2001-04-04	2001-04-04 00:00:00	32020		\N	62801	0	10509002	260139		0
16138	954	40481087	1980-04-12	1980-04-12 00:00:00	1980-04-26	1980-04-26 00:00:00	32020		\N	63381	0	444814009	40481087		0
5800	340	81151	1963-11-14	1963-11-14 00:00:00	1963-12-19	1963-12-19 00:00:00	32020		\N	22668	0	44465007	81151		0
5968	351	4112343	2014-12-15	2014-12-15 00:00:00	2014-12-26	2014-12-26 00:00:00	32020		\N	23343	0	195662009	4112343		0
6123	359	260139	1988-01-08	1988-01-08 00:00:00	1988-01-22	1988-01-22 00:00:00	32020		\N	23889	0	10509002	260139		0
6289	369	4156265	2013-03-07	2013-03-07 00:00:00	2013-03-28	2013-03-28 00:00:00	32020		\N	24580	0	370247008	4156265		0
6455	379	40481087	2019-03-06	2019-03-06 00:00:00	2019-03-13	2019-03-13 00:00:00	32020		\N	25061	0	444814009	40481087		0
17150	1025	378001	1952-01-24	1952-01-24 00:00:00	1952-02-23	1952-02-23 00:00:00	32020		\N	67582	0	62106007	378001		0
17295	1036	4134304	2006-10-12	2006-10-12 00:00:00	2006-11-11	2006-11-11 00:00:00	32020		\N	68138	0	263102004	4134304		0
6960	409	40481087	1973-05-03	1973-05-03 00:00:00	1973-05-24	1973-05-24 00:00:00	32020		\N	27108	0	444814009	40481087		0
7127	419	28060	1941-06-17	1941-06-17 00:00:00	1941-06-29	1941-06-29 00:00:00	32020		\N	27687	0	43878008	28060		0
17822	1072	372328	1966-02-01	1966-02-01 00:00:00	1966-08-03	1966-08-03 00:00:00	32020		\N	70281	0	65363002	372328		0
17933	1079	80180	1993-11-26	1993-11-26 00:00:00	\N	\N	32020		\N	70781	0	396275006	80180		0
18112	1088	4112343	2005-08-24	2005-08-24 00:00:00	2005-09-04	2005-09-04 00:00:00	32020		\N	71447	0	195662009	4112343		0
7782	455	40481087	1952-11-25	1952-11-25 00:00:00	1952-12-09	1952-12-09 00:00:00	32020		\N	30404	0	444814009	40481087		0
18444	1108	78272	1975-07-29	1975-07-29 00:00:00	1975-08-26	1975-08-26 00:00:00	32020		\N	72995	0	70704007	78272		0
18609	1118	4218389	2001-02-21	2001-02-21 00:00:00	2001-03-21	2001-03-21 00:00:00	32020		\N	73717	0	39848009	4218389		0
18793	1131	40481087	2013-11-18	2013-11-18 00:00:00	2013-12-02	2013-12-02 00:00:00	32020		\N	74448	0	444814009	40481087		0
8459	492	40481087	1988-06-12	1988-06-12 00:00:00	1988-07-03	1988-07-03 00:00:00	32020		\N	32952	0	444814009	40481087		0
19095	1145	4283893	1944-08-10	1944-08-10 00:00:00	1944-09-07	1944-09-07 00:00:00	32020		\N	75539	0	36971009	4283893		0
19280	1155	4112343	1984-10-03	1984-10-03 00:00:00	1984-10-10	1984-10-10 00:00:00	32020		\N	76314	0	195662009	4112343		0
19542	1174	40481087	1970-09-15	1970-09-15 00:00:00	1970-10-06	1970-10-06 00:00:00	32020		\N	77342	0	444814009	40481087		0
19614	1176	40481087	1998-05-31	1998-05-31 00:00:00	1998-06-14	1998-06-14 00:00:00	32020		\N	77697	0	444814009	40481087		0
19828	1193	4218389	1959-05-25	1959-05-25 00:00:00	1959-06-15	1959-06-15 00:00:00	32020		\N	78620	0	39848009	4218389		0
19947	1202	40481087	1997-09-07	1997-09-07 00:00:00	1997-09-14	1997-09-14 00:00:00	32020		\N	79071	0	444814009	40481087		0
20106	1211	28060	1978-01-22	1978-01-22 00:00:00	1978-01-29	1978-01-29 00:00:00	32020		\N	79539	0	43878008	28060		0
9786	579	4112343	1997-07-02	1997-07-02 00:00:00	1997-07-09	1997-07-09 00:00:00	32020		\N	38359	0	195662009	4112343		0
20446	1229	260139	2005-07-29	2005-07-29 00:00:00	2005-08-12	2005-08-12 00:00:00	32020		\N	80958	0	10509002	260139		0
20624	1238	40481087	1964-02-02	1964-02-02 00:00:00	1964-02-23	1964-02-23 00:00:00	32020		\N	81595	0	444814009	40481087		0
10288	607	4134304	2001-07-20	2001-07-20 00:00:00	2001-09-18	2001-09-18 00:00:00	32020		\N	40299	0	263102004	4134304		0
10444	615	4237458	2003-02-21	2003-02-21 00:00:00	2003-03-23	2003-03-23 00:00:00	32020		\N	41047	0	58150001	4237458		0
21121	1267	4112343	1999-01-05	1999-01-05 00:00:00	1999-01-18	1999-01-18 00:00:00	32020		\N	83576	0	195662009	4112343		0
142	6	4112343	2001-09-24	2001-09-24 00:00:00	2001-10-07	2001-10-07 00:00:00	32020		\N	582	0	195662009	4112343		0
10798	640	40481087	1951-02-16	1951-02-16 00:00:00	1951-02-23	1951-02-23 00:00:00	32020		\N	42341	0	444814009	40481087		0
11004	649	28060	1975-09-19	1975-09-19 00:00:00	1975-10-02	1975-10-02 00:00:00	32020		\N	43016	0	43878008	28060		0
11136	656	4218389	1999-09-27	1999-09-27 00:00:00	1999-11-01	1999-11-01 00:00:00	32020		\N	43425	0	39848009	4218389		0
819	43	4059173	1987-03-10	1987-03-10 00:00:00	1987-04-09	1987-04-09 00:00:00	32020		\N	3154	0	16114001	4059173		0
11538	680	78272	1987-08-09	1987-08-09 00:00:00	1987-08-23	1987-08-23 00:00:00	32020		\N	45093	0	70704007	78272		0
11627	686	4112343	1960-08-28	1960-08-28 00:00:00	1960-09-05	1960-09-05 00:00:00	32020		\N	45395	0	195662009	4112343		0
11801	697	260139	1973-08-01	1973-08-01 00:00:00	1973-08-15	1973-08-15 00:00:00	32020		\N	46125	0	10509002	260139		0
1491	86	4152936	2001-04-20	2001-04-20 00:00:00	2001-05-11	2001-05-11 00:00:00	32020		\N	5793	0	283385000	4152936		0
12156	720	4027663	1991-08-23	1991-08-23 00:00:00	\N	\N	32020		\N	47652	0	13200003	4027663		0
1816	103	81151	1972-03-02	1972-03-02 00:00:00	1972-03-23	1972-03-23 00:00:00	32020		\N	7068	0	44465007	81151		0
12465	736	4285898	2009-08-14	2009-08-14 00:00:00	\N	\N	32020		\N	48844	0	68496003	4285898		0
12635	747	40481087	1993-03-27	1993-03-27 00:00:00	1993-04-17	1993-04-17 00:00:00	32020		\N	49488	0	444814009	40481087		0
12839	757	4283893	1925-01-11	1925-01-11 00:00:00	1925-03-15	1925-03-15 00:00:00	32020		\N	50179	0	36971009	4283893		0
2490	145	260139	1977-12-17	1977-12-17 00:00:00	1977-12-31	1977-12-31 00:00:00	32020		\N	9784	0	10509002	260139		0
13142	774	40481087	2017-06-22	2017-06-22 00:00:00	2017-07-06	2017-07-06 00:00:00	32020		\N	51396	0	444814009	40481087		0
2810	162	260139	1979-07-29	1979-07-29 00:00:00	1979-08-05	1979-08-05 00:00:00	32020		\N	11162	0	10509002	260139		0
13476	795	28060	1968-03-16	1968-03-16 00:00:00	1968-03-23	1968-03-23 00:00:00	32020		\N	52706	0	43878008	28060		0
3143	185	78272	2015-02-21	2015-02-21 00:00:00	2015-03-28	2015-03-28 00:00:00	32020		\N	12522	0	70704007	78272		0
3287	190	260139	1979-03-01	1979-03-01 00:00:00	1979-03-16	1979-03-16 00:00:00	32020		\N	12939	0	10509002	260139		0
3469	197	81893	1995-10-05	1995-10-05 00:00:00	\N	\N	32020		\N	13564	0	64766004	81893		0
14152	836	260139	1990-06-09	1990-06-09 00:00:00	1990-06-16	1990-06-16 00:00:00	32020		\N	55295	0	10509002	260139		0
14277	842	260139	1914-08-04	1914-08-04 00:00:00	1914-08-18	1914-08-18 00:00:00	32020		\N	55676	0	10509002	260139		0
14467	855	4094814	2001-04-15	2001-04-15 00:00:00	\N	\N	32020		\N	56516	0	262574004	4094814		0
14625	864	260139	1925-11-10	1925-11-10 00:00:00	1925-11-17	1925-11-17 00:00:00	32020		\N	57293	0	10509002	260139		0
14782	870	4294548	2000-09-14	2000-09-14 00:00:00	2001-04-26	2001-04-26 00:00:00	32020		\N	57871	0	75498004	4294548		0
14987	883	260139	2008-06-28	2008-06-28 00:00:00	2008-07-05	2008-07-05 00:00:00	32020		\N	58777	0	10509002	260139		0
15120	890	4112343	1979-02-11	1979-02-11 00:00:00	1979-02-19	1979-02-19 00:00:00	32020		\N	59303	0	195662009	4112343		0
15288	905	40481087	2010-04-20	2010-04-20 00:00:00	2010-04-27	2010-04-27 00:00:00	32020		\N	60172	0	444814009	40481087		0
15444	915	28060	2010-06-28	2010-06-28 00:00:00	2010-07-06	2010-07-06 00:00:00	32020		\N	60828	0	43878008	28060		0
15616	924	4156265	1987-06-15	1987-06-15 00:00:00	1987-06-29	1987-06-29 00:00:00	32020		\N	61540	0	370247008	4156265		0
5296	312	4152936	2012-03-24	2012-03-24 00:00:00	2012-04-07	2012-04-07 00:00:00	32020		\N	20659	0	283385000	4152936		0
15983	946	81151	1969-01-19	1969-01-19 00:00:00	1969-02-23	1969-02-23 00:00:00	32020		\N	62808	0	44465007	81151		0
16139	954	40481087	1989-04-15	1989-04-15 00:00:00	1989-04-29	1989-04-29 00:00:00	32020		\N	63416	0	444814009	40481087		0
5801	340	40481087	1974-05-16	1974-05-16 00:00:00	1974-05-23	1974-05-23 00:00:00	32020		\N	22722	0	444814009	40481087		0
5969	351	40481087	2001-09-16	2001-09-16 00:00:00	2001-09-23	2001-09-23 00:00:00	32020		\N	23342	0	444814009	40481087		0
16634	986	4112343	1940-01-03	1940-01-03 00:00:00	1940-01-11	1940-01-11 00:00:00	32020		\N	65448	0	195662009	4112343		0
6290	369	372328	1982-03-22	1982-03-22 00:00:00	1982-06-05	1982-06-05 00:00:00	32020		\N	24534	0	65363002	372328		0
6456	380	372328	1974-02-14	1974-02-14 00:00:00	1974-04-19	1974-04-19 00:00:00	32020		\N	25146	0	65363002	372328		0
17151	1025	4294548	1968-09-05	1968-09-05 00:00:00	1968-10-03	1968-10-03 00:00:00	32020		\N	67547	0	75498004	4294548		0
17296	1036	4294548	2000-11-11	2000-11-11 00:00:00	2000-11-25	2000-11-25 00:00:00	32020		\N	68172	0	75498004	4294548		0
6961	409	4112343	2015-06-11	2015-06-11 00:00:00	2015-06-19	2015-06-19 00:00:00	32020		\N	27013	0	195662009	4112343		0
7128	419	372328	1916-06-22	1916-06-22 00:00:00	1916-07-23	1916-07-23 00:00:00	32020		\N	27763	0	65363002	372328		0
17823	1072	40481087	1980-11-06	1980-11-06 00:00:00	1980-11-27	1980-11-27 00:00:00	32020		\N	70274	0	444814009	40481087		0
17934	1079	4155034	1988-01-25	1988-01-25 00:00:00	1988-02-15	1988-02-15 00:00:00	32020		\N	70770	0	283371005	4155034		0
18113	1088	78272	1989-03-15	1989-03-15 00:00:00	1989-04-12	1989-04-12 00:00:00	32020		\N	71424	0	70704007	78272		0
7783	455	4283893	1989-02-19	1989-02-19 00:00:00	1989-03-26	1989-03-26 00:00:00	32020		\N	30408	0	36971009	4283893		0
18448	1110	4156265	2009-08-20	2009-08-20 00:00:00	2009-09-03	2009-09-03 00:00:00	32020		\N	73083	0	370247008	4156265		0
18610	1118	81151	1996-07-26	1996-07-26 00:00:00	1996-08-16	1996-08-16 00:00:00	32020		\N	73704	0	44465007	81151		0
18794	1131	4218389	1989-05-07	1989-05-07 00:00:00	1989-06-04	1989-06-04 00:00:00	32020		\N	74479	0	39848009	4218389		0
8460	492	372328	2010-07-16	2010-07-16 00:00:00	2010-10-01	2010-10-01 00:00:00	32020		\N	32944	0	65363002	372328		0
19096	1145	257012	2017-01-05	2017-01-05 00:00:00	\N	\N	32020		\N	75545	0	40055000	257012		0
19281	1155	260139	1990-05-13	1990-05-13 00:00:00	1990-05-20	1990-05-20 00:00:00	32020		\N	76387	0	10509002	260139		0
19543	1174	40481087	1980-06-20	1980-06-20 00:00:00	1980-07-04	1980-07-04 00:00:00	32020		\N	77306	0	444814009	40481087		0
19615	1176	4285898	1998-10-30	1998-10-30 00:00:00	\N	\N	32020		\N	77697	0	68496003	4285898		0
19829	1193	40481087	2004-04-07	2004-04-07 00:00:00	2004-04-28	2004-04-28 00:00:00	32020		\N	78633	0	444814009	40481087		0
19948	1202	4112343	2006-03-23	2006-03-23 00:00:00	2006-04-01	2006-04-01 00:00:00	32020		\N	79067	0	195662009	4112343		0
20107	1211	81151	1990-04-02	1990-04-02 00:00:00	1990-04-16	1990-04-16 00:00:00	32020		\N	79573	0	44465007	81151		0
9787	579	372328	1963-11-07	1963-11-07 00:00:00	1964-02-26	1964-02-26 00:00:00	32020		\N	38303	0	65363002	372328		0
20447	1229	40481087	2011-05-10	2011-05-10 00:00:00	2011-05-31	2011-05-31 00:00:00	32020		\N	80959	0	444814009	40481087		0
20625	1238	40481087	2013-09-26	2013-09-26 00:00:00	2013-10-10	2013-10-10 00:00:00	32020		\N	81581	0	444814009	40481087		0
10289	607	260139	1964-12-03	1964-12-03 00:00:00	1964-12-10	1964-12-10 00:00:00	32020		\N	40279	0	10509002	260139		0
10445	615	40480160	2003-02-21	2003-02-21 00:00:00	2003-03-23	2003-03-23 00:00:00	32020		\N	41047	0	443165006	40480160		0
21122	1267	257012	1973-05-04	1973-05-04 00:00:00	\N	\N	32020		\N	83598	0	40055000	257012		0
143	6	81151	1980-01-11	1980-01-11 00:00:00	1980-02-15	1980-02-15 00:00:00	32020		\N	557	0	44465007	81151		0
10799	640	78272	2002-10-02	2002-10-02 00:00:00	2002-10-23	2002-10-23 00:00:00	32020		\N	42330	0	70704007	78272		0
11005	649	28060	1979-09-12	1979-09-12 00:00:00	1979-09-22	1979-09-22 00:00:00	32020		\N	43032	0	43878008	28060		0
11137	656	4112343	1980-01-13	1980-01-13 00:00:00	1980-01-23	1980-01-23 00:00:00	32020		\N	43462	0	195662009	4112343		0
820	43	40481087	1997-12-03	1997-12-03 00:00:00	1997-12-17	1997-12-17 00:00:00	32020		\N	3166	0	444814009	40481087		0
11555	682	4112343	1981-09-04	1981-09-04 00:00:00	1981-09-15	1981-09-15 00:00:00	32020		\N	45156	0	195662009	4112343		0
11628	686	40481087	1994-12-22	1994-12-22 00:00:00	1994-12-29	1994-12-29 00:00:00	32020		\N	45398	0	444814009	40481087		0
11802	697	4152936	1973-08-30	1973-08-30 00:00:00	1973-09-13	1973-09-13 00:00:00	32020		\N	46161	0	283385000	4152936		0
11977	709	372328	1949-10-01	1949-10-01 00:00:00	1949-12-11	1949-12-11 00:00:00	32020		\N	46977	0	65363002	372328		0
12157	720	4112343	2019-05-21	2019-05-21 00:00:00	2019-05-31	2019-05-31 00:00:00	32020		\N	47620	0	195662009	4112343		0
1817	103	81151	1990-08-16	1990-08-16 00:00:00	1990-08-30	1990-08-30 00:00:00	32020		\N	7069	0	44465007	81151		0
12466	736	4294548	2008-04-29	2008-04-29 00:00:00	2008-06-10	2008-06-10 00:00:00	32020		\N	48812	0	75498004	4294548		0
12636	747	4112343	1968-11-05	1968-11-05 00:00:00	1968-11-15	1968-11-15 00:00:00	32020		\N	49468	0	195662009	4112343		0
12840	757	375671	1991-01-06	1991-01-06 00:00:00	1991-03-07	1991-03-07 00:00:00	32020		\N	50291	0	62564004	375671		0
12949	761	40481087	2010-09-23	2010-09-23 00:00:00	2010-10-07	2010-10-07 00:00:00	32020		\N	50531	0	444814009	40481087		0
13143	774	4278672	2006-11-05	2006-11-05 00:00:00	2006-12-05	2006-12-05 00:00:00	32020		\N	51391	0	65966004	4278672		0
2811	162	4112343	2016-09-25	2016-09-25 00:00:00	2016-10-05	2016-10-05 00:00:00	32020		\N	11115	0	195662009	4112343		0
13477	795	28060	2018-12-17	2018-12-17 00:00:00	2018-12-26	2018-12-26 00:00:00	32020		\N	52745	0	43878008	28060		0
3144	185	4296204	1986-02-25	1986-02-25 00:00:00	1986-03-25	1986-03-25 00:00:00	32020		\N	12521	0	403190006	4296204		0
3288	190	40481087	1934-03-25	1934-03-25 00:00:00	1934-04-15	1934-04-15 00:00:00	32020		\N	12962	0	444814009	40481087		0
3470	197	4266809	1996-07-31	1996-07-31 00:00:00	\N	\N	32020		\N	13564	0	397881000	4266809		0
14153	836	260139	1983-06-11	1983-06-11 00:00:00	1983-06-18	1983-06-18 00:00:00	32020		\N	55328	0	10509002	260139		0
14278	842	260139	1992-01-28	1992-01-28 00:00:00	1992-02-11	1992-02-11 00:00:00	32020		\N	55646	0	10509002	260139		0
14468	856	4112343	1982-04-24	1982-04-24 00:00:00	1982-05-05	1982-05-05 00:00:00	32020		\N	56526	0	195662009	4112343		0
14626	864	378419	1996-08-05	1996-08-05 00:00:00	\N	\N	32020		\N	57256	0	26929004	378419		0
14783	870	4134304	1971-10-06	1971-10-06 00:00:00	1971-11-05	1971-11-05 00:00:00	32020		\N	57891	0	263102004	4134304		0
14988	883	81151	1975-09-30	1975-09-30 00:00:00	1975-10-14	1975-10-14 00:00:00	32020		\N	58779	0	44465007	81151		0
15121	890	260139	1992-03-05	1992-03-05 00:00:00	1992-03-19	1992-03-19 00:00:00	32020		\N	59324	0	10509002	260139		0
15289	905	380378	1977-04-30	1977-04-30 00:00:00	\N	\N	32020		\N	60192	0	84757009	380378		0
15445	915	80180	1995-08-04	1995-08-04 00:00:00	\N	\N	32020		\N	60795	0	396275006	80180		0
15617	924	4296205	1998-04-01	1998-04-01 00:00:00	1998-05-07	1998-05-07 00:00:00	32020		\N	61541	0	403191005	4296205		0
5297	312	260139	1972-05-24	1972-05-24 00:00:00	1972-05-31	1972-05-31 00:00:00	32020		\N	20660	0	10509002	260139		0
15984	946	4027663	1991-03-30	1991-03-30 00:00:00	\N	\N	32020		\N	62824	0	13200003	4027663		0
16140	954	4155034	1983-01-25	1983-01-25 00:00:00	1983-02-15	1983-02-15 00:00:00	32020		\N	63396	0	283371005	4155034		0
5802	340	40481087	1967-01-02	1967-01-02 00:00:00	1967-01-16	1967-01-16 00:00:00	32020		\N	22690	0	444814009	40481087		0
5970	351	4112343	2000-05-02	2000-05-02 00:00:00	2000-05-15	2000-05-15 00:00:00	32020		\N	23431	0	195662009	4112343		0
16635	986	260139	1968-03-23	1968-03-23 00:00:00	1968-04-06	1968-04-06 00:00:00	32020		\N	65509	0	10509002	260139		0
6291	369	4134304	1982-01-21	1982-01-21 00:00:00	1982-03-22	1982-03-22 00:00:00	32020		\N	24554	0	263102004	4134304		0
6457	380	40481087	1985-08-06	1985-08-06 00:00:00	1985-08-20	1985-08-20 00:00:00	32020		\N	25128	0	444814009	40481087		0
17152	1025	4299128	1945-02-24	1945-02-24 00:00:00	1945-03-31	1945-03-31 00:00:00	32020		\N	67581	0	403192003	4299128		0
17297	1036	372328	1972-01-08	1972-01-08 00:00:00	1972-02-11	1972-02-11 00:00:00	32020		\N	68190	0	65363002	372328		0
6962	409	28060	2006-12-14	2006-12-14 00:00:00	2006-12-21	2006-12-21 00:00:00	32020		\N	27011	0	43878008	28060		0
7129	419	40481087	1945-11-09	1945-11-09 00:00:00	1945-11-30	1945-11-30 00:00:00	32020		\N	27786	0	444814009	40481087		0
17824	1072	372328	1961-08-12	1961-08-12 00:00:00	1961-10-25	1961-10-25 00:00:00	32020		\N	70212	0	65363002	372328		0
17935	1079	40481087	2011-07-06	2011-07-06 00:00:00	2011-07-13	2011-07-13 00:00:00	32020		\N	70758	0	444814009	40481087		0
18114	1088	28060	1975-08-18	1975-08-18 00:00:00	1975-08-26	1975-08-26 00:00:00	32020		\N	71451	0	43878008	28060		0
7784	455	260139	1993-03-10	1993-03-10 00:00:00	1993-03-17	1993-03-17 00:00:00	32020		\N	30459	0	10509002	260139		0
18449	1110	40481087	2016-08-31	2016-08-31 00:00:00	2016-09-21	2016-09-21 00:00:00	32020		\N	73121	0	444814009	40481087		0
18611	1118	40481087	1980-10-11	1980-10-11 00:00:00	1980-10-18	1980-10-18 00:00:00	32020		\N	73670	0	444814009	40481087		0
18795	1131	260139	1988-01-22	1988-01-22 00:00:00	1988-02-05	1988-02-05 00:00:00	32020		\N	74444	0	10509002	260139		0
8461	492	372328	1950-05-17	1950-05-17 00:00:00	1950-11-17	1950-11-17 00:00:00	32020		\N	32983	0	65363002	372328		0
19097	1145	372328	1941-04-21	1941-04-21 00:00:00	1941-07-30	1941-07-30 00:00:00	32020		\N	75547	0	65363002	372328		0
19282	1155	4112343	2015-11-22	2015-11-22 00:00:00	2015-11-30	2015-11-30 00:00:00	32020		\N	76391	0	195662009	4112343		0
19544	1174	40479422	1963-02-23	1963-02-23 00:00:00	1963-05-02	1963-05-02 00:00:00	32020		\N	77373	0	444448004	40479422		0
19616	1176	80180	1999-04-28	1999-04-28 00:00:00	\N	\N	32020		\N	77697	0	396275006	80180		0
19830	1193	40481087	2008-03-14	2008-03-14 00:00:00	2008-03-21	2008-03-21 00:00:00	32020		\N	78645	0	444814009	40481087		0
19949	1202	260139	1993-01-01	1993-01-01 00:00:00	1993-01-08	1993-01-08 00:00:00	32020		\N	79066	0	10509002	260139		0
20108	1211	4112343	1966-09-11	1966-09-11 00:00:00	1966-09-21	1966-09-21 00:00:00	32020		\N	79535	0	195662009	4112343		0
9788	579	40481087	2015-11-12	2015-11-12 00:00:00	2015-12-03	2015-12-03 00:00:00	32020		\N	38351	0	444814009	40481087		0
20448	1229	40481087	1984-02-23	1984-02-23 00:00:00	1984-03-01	1984-03-01 00:00:00	32020		\N	81013	0	444814009	40481087		0
20626	1238	372328	1957-10-28	1957-10-28 00:00:00	1958-04-15	1958-04-15 00:00:00	32020		\N	81586	0	65363002	372328		0
10290	608	81151	2004-10-21	2004-10-21 00:00:00	2004-11-04	2004-11-04 00:00:00	32020		\N	40408	0	44465007	81151		0
10446	615	81151	1965-05-01	1965-05-01 00:00:00	1965-05-22	1965-05-22 00:00:00	32020		\N	41042	0	44465007	81151		0
21123	1267	81151	1954-02-27	1954-02-27 00:00:00	1954-03-13	1954-03-13 00:00:00	32020		\N	83564	0	44465007	81151		0
144	6	372328	1965-06-23	1965-06-23 00:00:00	1965-12-07	1965-12-07 00:00:00	32020		\N	544	0	65363002	372328		0
10800	640	81151	1962-09-11	1962-09-11 00:00:00	1962-10-02	1962-10-02 00:00:00	32020		\N	42329	0	44465007	81151		0
11006	649	4112343	1972-05-26	1972-05-26 00:00:00	1972-06-02	1972-06-02 00:00:00	32020		\N	43015	0	195662009	4112343		0
11138	656	40481087	2004-08-28	2004-08-28 00:00:00	2004-09-04	2004-09-04 00:00:00	32020		\N	43463	0	444814009	40481087		0
821	43	4112343	1967-07-18	1967-07-18 00:00:00	1967-07-30	1967-07-30 00:00:00	32020		\N	3143	0	195662009	4112343		0
11556	682	4112343	2005-09-09	2005-09-09 00:00:00	2005-09-22	2005-09-22 00:00:00	32020		\N	45165	0	195662009	4112343		0
11629	686	40481087	1946-10-13	1946-10-13 00:00:00	1946-11-03	1946-11-03 00:00:00	32020		\N	45402	0	444814009	40481087		0
11803	697	40481087	1988-07-01	1988-07-01 00:00:00	1988-07-15	1988-07-15 00:00:00	32020		\N	46103	0	444814009	40481087		0
11978	709	260139	1953-04-14	1953-04-14 00:00:00	1953-04-21	1953-04-21 00:00:00	32020		\N	46959	0	10509002	260139		0
12158	720	4112343	2010-05-28	2010-05-28 00:00:00	2010-06-06	2010-06-06 00:00:00	32020		\N	47633	0	195662009	4112343		0
1818	103	4112343	1981-06-14	1981-06-14 00:00:00	1981-06-22	1981-06-22 00:00:00	32020		\N	7045	0	195662009	4112343		0
12467	738	40481087	1983-04-16	1983-04-16 00:00:00	1983-04-23	1983-04-23 00:00:00	32020		\N	48865	0	444814009	40481087		0
12637	747	28060	2005-07-07	2005-07-07 00:00:00	2005-07-19	2005-07-19 00:00:00	32020		\N	49490	0	43878008	28060		0
12841	757	313217	1976-01-11	1976-01-11 00:00:00	\N	\N	32020		\N	50264	0	49436004	313217		0
12950	761	4152936	1994-04-25	1994-04-25 00:00:00	1994-05-16	1994-05-16 00:00:00	32020		\N	50523	0	283385000	4152936		0
13144	774	40481087	2006-03-23	2006-03-23 00:00:00	2006-03-30	2006-03-30 00:00:00	32020		\N	51377	0	444814009	40481087		0
2812	162	4283893	1981-10-28	1981-10-28 00:00:00	1981-12-02	1981-12-02 00:00:00	32020		\N	11164	0	36971009	4283893		0
13478	795	378001	1993-05-13	1993-05-13 00:00:00	1993-06-12	1993-06-12 00:00:00	32020		\N	52732	0	62106007	378001		0
3145	185	4112343	2009-10-19	2009-10-19 00:00:00	2009-11-01	2009-11-01 00:00:00	32020		\N	12549	0	195662009	4112343		0
3289	190	4155034	2011-01-07	2011-01-07 00:00:00	2011-01-21	2011-01-21 00:00:00	32020		\N	13000	0	283371005	4155034		0
3471	197	30753	1995-11-04	1995-11-04 00:00:00	\N	\N	32020		\N	13564	0	16761005	30753		0
14154	836	4134304	1992-03-28	1992-03-28 00:00:00	1992-06-26	1992-06-26 00:00:00	32020		\N	55325	0	263102004	4134304		0
14279	842	40481087	1990-01-09	1990-01-09 00:00:00	1990-01-16	1990-01-16 00:00:00	32020		\N	55715	0	444814009	40481087		0
14469	856	372328	1971-10-16	1971-10-16 00:00:00	1971-11-19	1971-11-19 00:00:00	32020		\N	56541	0	65363002	372328		0
14627	864	260139	1930-05-07	1930-05-07 00:00:00	1930-05-21	1930-05-21 00:00:00	32020		\N	57294	0	10509002	260139		0
14784	870	4112343	2014-07-03	2014-07-03 00:00:00	2014-07-10	2014-07-10 00:00:00	32020		\N	57914	0	195662009	4112343		0
14989	883	4113008	2008-03-24	2008-03-24 00:00:00	2008-04-07	2008-04-07 00:00:00	32020		\N	58780	0	284549007	4113008		0
15122	890	260139	2012-09-04	2012-09-04 00:00:00	2012-09-18	2012-09-18 00:00:00	32020		\N	59304	0	10509002	260139		0
15290	905	4112343	2010-01-10	2010-01-10 00:00:00	2010-01-22	2010-01-22 00:00:00	32020		\N	60200	0	195662009	4112343		0
15446	915	372328	1965-05-28	1965-05-28 00:00:00	1965-12-11	1965-12-11 00:00:00	32020		\N	60843	0	65363002	372328		0
15618	924	375671	2017-10-08	2017-10-08 00:00:00	2017-11-06	2017-11-06 00:00:00	32020		\N	61544	0	62564004	375671		0
5298	312	40481087	2013-05-04	2013-05-04 00:00:00	2013-05-11	2013-05-11 00:00:00	32020		\N	20694	0	444814009	40481087		0
15985	946	260139	2003-12-30	2003-12-30 00:00:00	2004-01-06	2004-01-06 00:00:00	32020		\N	62776	0	10509002	260139		0
16146	956	372328	1950-08-29	1950-08-29 00:00:00	1951-07-25	1951-07-25 00:00:00	32020		\N	63544	0	65363002	372328		0
5803	340	40481087	1981-11-14	1981-11-14 00:00:00	1981-12-05	1981-12-05 00:00:00	32020		\N	22711	0	444814009	40481087		0
5971	351	40481087	2008-01-27	2008-01-27 00:00:00	2008-02-03	2008-02-03 00:00:00	32020		\N	23408	0	444814009	40481087		0
16636	986	40481087	1969-04-07	1969-04-07 00:00:00	1969-04-28	1969-04-28 00:00:00	32020		\N	65451	0	444814009	40481087		0
6292	369	260139	2014-09-18	2014-09-18 00:00:00	2014-10-02	2014-10-02 00:00:00	32020		\N	24525	0	10509002	260139		0
6458	380	260139	2013-07-12	2013-07-12 00:00:00	2013-07-26	2013-07-26 00:00:00	32020		\N	25154	0	10509002	260139		0
17153	1025	4112343	2013-02-11	2013-02-11 00:00:00	2013-02-24	2013-02-24 00:00:00	32020		\N	67565	0	195662009	4112343		0
17298	1036	4048171	1974-09-11	1974-09-11 00:00:00	\N	\N	32020		\N	68163	0	232353008	4048171		0
6963	409	4296204	1995-09-10	1995-09-10 00:00:00	1995-10-01	1995-10-01 00:00:00	32020		\N	27152	0	403190006	4296204		0
7130	419	4155034	1915-06-09	1915-06-09 00:00:00	1915-06-30	1915-06-30 00:00:00	32020		\N	27707	0	283371005	4155034		0
17825	1073	260139	1983-05-07	1983-05-07 00:00:00	1983-05-21	1983-05-21 00:00:00	32020		\N	70409	0	10509002	260139		0
17936	1079	260139	2004-12-07	2004-12-07 00:00:00	2004-12-14	2004-12-14 00:00:00	32020		\N	70714	0	10509002	260139		0
18115	1088	260139	1985-06-23	1985-06-23 00:00:00	1985-06-30	1985-06-30 00:00:00	32020		\N	71461	0	10509002	260139		0
7785	455	4112343	1950-12-29	1950-12-29 00:00:00	1951-01-11	1951-01-11 00:00:00	32020		\N	30403	0	195662009	4112343		0
18450	1110	257012	1998-07-08	1998-07-08 00:00:00	\N	\N	32020		\N	73071	0	40055000	257012		0
18612	1118	4266809	2014-05-19	2014-05-19 00:00:00	\N	\N	32020		\N	73745	0	397881000	4266809		0
18796	1131	4112343	1974-10-25	1974-10-25 00:00:00	1974-11-03	1974-11-03 00:00:00	32020		\N	74452	0	195662009	4112343		0
8462	492	372328	1949-09-28	1949-09-28 00:00:00	1949-11-18	1949-11-18 00:00:00	32020		\N	32942	0	65363002	372328		0
19098	1145	4230399	1977-02-05	1977-02-05 00:00:00	1977-04-06	1977-04-06 00:00:00	32020		\N	75556	0	359817006	4230399		0
19283	1155	260139	1972-10-19	1972-10-19 00:00:00	1972-10-26	1972-10-26 00:00:00	32020		\N	76324	0	10509002	260139		0
19545	1174	81151	1957-09-02	1957-09-02 00:00:00	1957-09-23	1957-09-23 00:00:00	32020		\N	77372	0	44465007	81151		0
19617	1176	4266809	1999-04-28	1999-04-28 00:00:00	\N	\N	32020		\N	77697	0	397881000	4266809		0
19831	1193	78272	2017-08-01	2017-08-01 00:00:00	2017-08-15	2017-08-15 00:00:00	32020		\N	78628	0	70704007	78272		0
19950	1202	4112343	2015-01-29	2015-01-29 00:00:00	2015-02-11	2015-02-11 00:00:00	32020		\N	79082	0	195662009	4112343		0
20109	1211	40481087	1975-02-28	1975-02-28 00:00:00	1975-03-14	1975-03-14 00:00:00	32020		\N	79596	0	444814009	40481087		0
9789	579	40481087	1971-08-09	1971-08-09 00:00:00	1971-08-30	1971-08-30 00:00:00	32020		\N	38366	0	444814009	40481087		0
20449	1229	40481087	2004-03-03	2004-03-03 00:00:00	2004-03-10	2004-03-10 00:00:00	32020		\N	80983	0	444814009	40481087		0
20627	1238	4112343	1976-06-06	1976-06-06 00:00:00	1976-06-18	1976-06-18 00:00:00	32020		\N	81596	0	195662009	4112343		0
10291	608	40481087	2004-03-25	2004-03-25 00:00:00	2004-04-08	2004-04-08 00:00:00	32020		\N	40364	0	444814009	40481087		0
10447	615	372328	1915-03-27	1915-03-27 00:00:00	1916-01-29	1916-01-29 00:00:00	32020		\N	40863	0	65363002	372328		0
21124	1267	40481087	1979-11-29	1979-11-29 00:00:00	1979-12-06	1979-12-06 00:00:00	32020		\N	83586	0	444814009	40481087		0
145	6	4109685	2004-05-09	2004-05-09 00:00:00	2004-05-23	2004-05-23 00:00:00	32020		\N	561	0	284551006	4109685		0
10801	640	260139	1967-07-04	1967-07-04 00:00:00	1967-07-18	1967-07-18 00:00:00	32020		\N	42375	0	10509002	260139		0
11007	649	40481087	1985-04-19	1985-04-19 00:00:00	1985-05-03	1985-05-03 00:00:00	32020		\N	42992	0	444814009	40481087		0
11139	656	40481087	1984-08-30	1984-08-30 00:00:00	1984-09-06	1984-09-06 00:00:00	32020		\N	43493	0	444814009	40481087		0
822	43	40481087	1962-06-11	1962-06-11 00:00:00	1962-06-18	1962-06-18 00:00:00	32020		\N	3191	0	444814009	40481087		0
11557	682	378001	2000-06-25	2000-06-25 00:00:00	2000-07-25	2000-07-25 00:00:00	32020		\N	45166	0	62106007	378001		0
11630	686	40481087	1961-12-21	1961-12-21 00:00:00	1961-12-28	1961-12-28 00:00:00	32020		\N	45381	0	444814009	40481087		0
11804	697	4112343	2002-10-09	2002-10-09 00:00:00	2002-10-19	2002-10-19 00:00:00	32020		\N	46110	0	195662009	4112343		0
11979	709	257012	1969-09-02	1969-09-02 00:00:00	\N	\N	32020		\N	46958	0	40055000	257012		0
12159	720	4156265	1975-05-04	1975-05-04 00:00:00	1975-05-25	1975-05-25 00:00:00	32020		\N	47658	0	370247008	4156265		0
1819	103	80180	2008-06-01	2008-06-01 00:00:00	\N	\N	32020		\N	7066	0	396275006	80180		0
12468	738	4156265	1983-03-10	1983-03-10 00:00:00	1983-03-31	1983-03-31 00:00:00	32020		\N	48889	0	370247008	4156265		0
12638	747	378001	1978-02-04	1978-02-04 00:00:00	1978-03-06	1978-03-06 00:00:00	32020		\N	49475	0	62106007	378001		0
12842	757	28060	1986-03-23	1986-03-23 00:00:00	1986-04-05	1986-04-05 00:00:00	32020		\N	50239	0	43878008	28060		0
12951	761	80180	2015-05-30	2015-05-30 00:00:00	\N	\N	32020		\N	50562	0	396275006	80180		0
13145	774	40481087	1971-05-06	1971-05-06 00:00:00	1971-05-20	1971-05-20 00:00:00	32020		\N	51359	0	444814009	40481087		0
2813	162	4112343	1980-07-26	1980-07-26 00:00:00	1980-08-03	1980-08-03 00:00:00	32020		\N	11163	0	195662009	4112343		0
3472	197	40481087	1983-06-25	1983-06-25 00:00:00	1983-07-09	1983-07-09 00:00:00	32020		\N	13569	0	444814009	40481087		0
14155	836	4152936	1985-03-30	1985-03-30 00:00:00	1985-04-13	1985-04-13 00:00:00	32020		\N	55323	0	283385000	4152936		0
14280	842	260139	1938-03-25	1938-03-25 00:00:00	1938-04-01	1938-04-01 00:00:00	32020		\N	55655	0	10509002	260139		0
14470	856	40481087	1972-11-13	1972-11-13 00:00:00	1972-12-04	1972-12-04 00:00:00	32020		\N	56564	0	444814009	40481087		0
14628	864	4112343	1956-11-27	1956-11-27 00:00:00	1956-12-09	1956-12-09 00:00:00	32020		\N	57299	0	195662009	4112343		0
14785	870	260139	2008-03-10	2008-03-10 00:00:00	2008-03-24	2008-03-24 00:00:00	32020		\N	57854	0	10509002	260139		0
14990	883	40481087	2006-07-16	2006-07-16 00:00:00	2006-07-23	2006-07-23 00:00:00	32020		\N	58774	0	444814009	40481087		0
15123	890	81151	1992-10-30	1992-10-30 00:00:00	1992-11-20	1992-11-20 00:00:00	32020		\N	59288	0	44465007	81151		0
15291	905	81151	1979-02-26	1979-02-26 00:00:00	1979-03-12	1979-03-12 00:00:00	32020		\N	60193	0	44465007	81151		0
15447	915	78272	2000-04-24	2000-04-24 00:00:00	2000-05-08	2000-05-08 00:00:00	32020		\N	60786	0	70704007	78272		0
15619	924	372328	1969-06-28	1969-06-28 00:00:00	1970-05-24	1970-05-24 00:00:00	32020		\N	61531	0	65363002	372328		0
5299	312	80180	2017-03-28	2017-03-28 00:00:00	\N	\N	32020		\N	20700	0	396275006	80180		0
15986	946	440448	1976-04-04	1976-04-04 00:00:00	\N	\N	32020		\N	62810	0	74400008	440448		0
16147	956	80180	1975-10-13	1975-10-13 00:00:00	\N	\N	32020		\N	63476	0	396275006	80180		0
5804	340	4237458	2001-05-03	2001-05-03 00:00:00	2001-06-02	2001-06-02 00:00:00	32020		\N	22669	0	58150001	4237458		0
5972	351	4027663	2010-11-21	2010-11-21 00:00:00	\N	\N	32020		\N	23355	0	13200003	4027663		0
16637	986	260139	1932-02-09	1932-02-09 00:00:00	1932-02-16	1932-02-16 00:00:00	32020		\N	65477	0	10509002	260139		0
6293	369	40481087	1990-10-26	1990-10-26 00:00:00	1990-11-16	1990-11-16 00:00:00	32020		\N	24564	0	444814009	40481087		0
6459	380	4112343	1996-06-04	1996-06-04 00:00:00	1996-06-14	1996-06-14 00:00:00	32020		\N	25117	0	195662009	4112343		0
17154	1025	40481087	2004-03-07	2004-03-07 00:00:00	2004-03-28	2004-03-28 00:00:00	32020		\N	67572	0	444814009	40481087		0
17299	1036	260139	1998-03-20	1998-03-20 00:00:00	1998-03-27	1998-03-27 00:00:00	32020		\N	68118	0	10509002	260139		0
6964	409	4059173	1980-10-28	1980-10-28 00:00:00	1981-01-26	1981-01-26 00:00:00	32020		\N	27151	0	16114001	4059173		0
7131	419	40481087	1994-12-20	1994-12-20 00:00:00	1995-01-10	1995-01-10 00:00:00	32020		\N	27789	0	444814009	40481087		0
17826	1073	40481087	1942-06-30	1942-06-30 00:00:00	1942-07-14	1942-07-14 00:00:00	32020		\N	70306	0	444814009	40481087		0
17937	1079	4116491	2016-04-16	2016-04-16 00:00:00	2016-05-21	2016-05-21 00:00:00	32020		\N	70717	0	301011002	4116491		0
18116	1088	192671	2011-09-10	2011-09-10 00:00:00	\N	\N	32020		\N	71436	0	K92.2	35208414		0
7786	455	40481087	1969-01-23	1969-01-23 00:00:00	1969-01-30	1969-01-30 00:00:00	32020		\N	30457	0	444814009	40481087		0
18451	1110	4283893	1998-05-27	1998-05-27 00:00:00	1998-08-05	1998-08-05 00:00:00	32020		\N	73040	0	36971009	4283893		0
18613	1118	80180	2014-05-19	2014-05-19 00:00:00	\N	\N	32020		\N	73745	0	396275006	80180		0
18797	1131	260139	1982-03-16	1982-03-16 00:00:00	1982-03-23	1982-03-23 00:00:00	32020		\N	74454	0	10509002	260139		0
8463	492	40481087	1968-12-01	1968-12-01 00:00:00	1968-12-15	1968-12-15 00:00:00	32020		\N	32951	0	444814009	40481087		0
19099	1145	4112343	2002-09-11	2002-09-11 00:00:00	2002-09-23	2002-09-23 00:00:00	32020		\N	75570	0	195662009	4112343		0
19284	1155	4294548	2010-10-22	2010-10-22 00:00:00	2011-04-01	2011-04-01 00:00:00	32020		\N	76388	0	75498004	4294548		0
19546	1174	4112343	1944-08-22	1944-08-22 00:00:00	1944-09-04	1944-09-04 00:00:00	32020		\N	77326	0	195662009	4112343		0
19618	1176	40481087	1995-02-05	1995-02-05 00:00:00	1995-02-19	1995-02-19 00:00:00	32020		\N	77696	0	444814009	40481087		0
19832	1193	260139	1998-06-07	1998-06-07 00:00:00	1998-06-21	1998-06-21 00:00:00	32020		\N	78632	0	10509002	260139		0
19951	1202	80180	2016-11-14	2016-11-14 00:00:00	\N	\N	32020		\N	79082	0	396275006	80180		0
20151	1214	4152936	1979-04-03	1979-04-03 00:00:00	1979-04-24	1979-04-24 00:00:00	32020		\N	80007	0	283385000	4152936		0
9790	579	260139	2014-09-12	2014-09-12 00:00:00	2014-09-26	2014-09-26 00:00:00	32020		\N	38326	0	10509002	260139		0
20450	1229	378001	1966-04-12	1966-04-12 00:00:00	1966-05-12	1966-05-12 00:00:00	32020		\N	80979	0	62106007	378001		0
20628	1238	40481087	1981-10-18	1981-10-18 00:00:00	1981-11-01	1981-11-01 00:00:00	32020		\N	81597	0	444814009	40481087		0
10292	608	4329847	2005-07-13	2005-07-13 00:00:00	\N	\N	32020		\N	40409	0	22298006	4329847		0
10448	615	40481087	2015-08-16	2015-08-16 00:00:00	2015-09-06	2015-09-06 00:00:00	32020		\N	40987	0	444814009	40481087		0
21125	1267	80180	1990-05-14	1990-05-14 00:00:00	\N	\N	32020		\N	83601	0	396275006	80180		0
146	6	40481087	1976-11-20	1976-11-20 00:00:00	1976-12-04	1976-12-04 00:00:00	32020		\N	564	0	444814009	40481087		0
10802	640	80180	1992-11-07	1992-11-07 00:00:00	\N	\N	32020		\N	42388	0	396275006	80180		0
11010	651	4116491	2014-06-16	2014-06-16 00:00:00	2014-08-05	2014-08-05 00:00:00	32020		\N	43098	0	301011002	4116491		0
11140	656	4112343	1979-10-06	1979-10-06 00:00:00	1979-10-13	1979-10-13 00:00:00	32020		\N	43473	0	195662009	4112343		0
823	43	4218389	1999-07-10	1999-07-10 00:00:00	1999-08-14	1999-08-14 00:00:00	32020		\N	3157	0	39848009	4218389		0
11558	682	40481087	2015-10-27	2015-10-27 00:00:00	2015-11-03	2015-11-03 00:00:00	32020		\N	45190	0	444814009	40481087		0
11631	686	372328	1951-01-03	1951-01-03 00:00:00	1951-09-29	1951-09-29 00:00:00	32020		\N	45385	0	65363002	372328		0
11805	697	80180	2000-03-21	2000-03-21 00:00:00	\N	\N	32020		\N	46146	0	396275006	80180		0
11980	709	4112343	1971-05-26	1971-05-26 00:00:00	1971-06-06	1971-06-06 00:00:00	32020		\N	46930	0	195662009	4112343		0
12160	720	4112343	1992-06-18	1992-06-18 00:00:00	1992-06-30	1992-06-30 00:00:00	32020		\N	47617	0	195662009	4112343		0
1820	103	4112343	1979-07-11	1979-07-11 00:00:00	1979-07-24	1979-07-24 00:00:00	32020		\N	7044	0	195662009	4112343		0
12469	738	80180	2014-01-11	2014-01-11 00:00:00	\N	\N	32020		\N	48880	0	396275006	80180		0
12639	747	4112343	1965-05-16	1965-05-16 00:00:00	1965-05-24	1965-05-24 00:00:00	32020		\N	49467	0	195662009	4112343		0
12843	757	40481087	1916-10-05	1916-10-05 00:00:00	1916-10-19	1916-10-19 00:00:00	32020		\N	50233	0	444814009	40481087		0
12952	761	4051466	1980-12-21	1980-12-21 00:00:00	1998-06-05	1998-06-05 00:00:00	32020		\N	50564	0	233678006	4051466		0
13146	774	40481087	1982-08-29	1982-08-29 00:00:00	1982-09-12	1982-09-12 00:00:00	32020		\N	51393	0	444814009	40481087		0
2814	162	260139	2001-06-25	2001-06-25 00:00:00	2001-07-02	2001-07-02 00:00:00	32020		\N	11166	0	10509002	260139		0
13480	795	40481087	1978-01-29	1978-01-29 00:00:00	1978-02-12	1978-02-12 00:00:00	32020		\N	52750	0	444814009	40481087		0
3147	185	40481087	2014-08-04	2014-08-04 00:00:00	2014-08-18	2014-08-18 00:00:00	32020		\N	12569	0	444814009	40481087		0
3291	190	4283893	1982-10-19	1982-10-19 00:00:00	1982-12-07	1982-12-07 00:00:00	32020		\N	12965	0	36971009	4283893		0
3473	197	81151	1985-09-15	1985-09-15 00:00:00	1985-09-29	1985-09-29 00:00:00	32020		\N	13532	0	44465007	81151		0
14156	836	378001	2017-08-12	2017-08-12 00:00:00	2017-10-11	2017-10-11 00:00:00	32020		\N	55327	0	62106007	378001		0
14281	842	4112343	1940-07-24	1940-07-24 00:00:00	1940-08-03	1940-08-03 00:00:00	32020		\N	55642	0	195662009	4112343		0
14471	856	4230399	2015-05-18	2015-05-18 00:00:00	2015-07-17	2015-07-17 00:00:00	32020		\N	56577	0	359817006	4230399		0
14629	864	80180	1958-05-04	1958-05-04 00:00:00	\N	\N	32020		\N	57299	0	396275006	80180		0
14786	870	40481087	1986-04-02	1986-04-02 00:00:00	1986-04-23	1986-04-23 00:00:00	32020		\N	57870	0	444814009	40481087		0
14991	883	195588	2007-07-24	2007-07-24 00:00:00	2007-09-06	2007-09-06 00:00:00	32020		\N	58776	0	38822007	195588		0
15124	890	440086	1970-05-26	1970-05-26 00:00:00	1971-01-12	1971-01-12 00:00:00	32020		\N	59321	0	192127007	440086		0
15292	905	4112343	1969-06-19	1969-06-19 00:00:00	1969-06-30	1969-06-30 00:00:00	32020		\N	60212	0	195662009	4112343		0
15448	915	40481087	2004-02-24	2004-02-24 00:00:00	2004-03-16	2004-03-16 00:00:00	32020		\N	60838	0	444814009	40481087		0
15620	924	4112343	1978-11-21	1978-11-21 00:00:00	1978-12-04	1978-12-04 00:00:00	32020		\N	61505	0	195662009	4112343		0
5300	312	4266809	2017-03-28	2017-03-28 00:00:00	\N	\N	32020		\N	20700	0	397881000	4266809		0
15988	946	40481087	2010-07-12	2010-07-12 00:00:00	2010-08-02	2010-08-02 00:00:00	32020		\N	62814	0	444814009	40481087		0
16148	956	260139	2001-03-24	2001-03-24 00:00:00	2001-04-07	2001-04-07 00:00:00	32020		\N	63543	0	10509002	260139		0
5805	340	375671	2005-03-13	2005-03-13 00:00:00	2005-04-12	2005-04-12 00:00:00	32020		\N	22740	0	62564004	375671		0
5973	351	4266809	2018-06-07	2018-06-07 00:00:00	\N	\N	32020		\N	23348	0	397881000	4266809		0
16638	986	372328	1918-10-18	1918-10-18 00:00:00	1919-04-05	1919-04-05 00:00:00	32020		\N	65445	0	65363002	372328		0
6294	369	80180	2016-10-14	2016-10-14 00:00:00	\N	\N	32020		\N	24542	0	396275006	80180		0
6460	380	40481087	2016-06-28	2016-06-28 00:00:00	2016-07-05	2016-07-05 00:00:00	32020		\N	25144	0	444814009	40481087		0
17155	1025	40481087	2017-11-15	2017-11-15 00:00:00	2017-12-06	2017-12-06 00:00:00	32020		\N	67511	0	444814009	40481087		0
17300	1036	260139	1995-07-26	1995-07-26 00:00:00	1995-08-02	1995-08-02 00:00:00	32020		\N	68147	0	10509002	260139		0
6965	409	81151	2013-02-19	2013-02-19 00:00:00	2013-03-19	2013-03-19 00:00:00	32020		\N	27154	0	44465007	81151		0
7132	419	40481087	1954-03-25	1954-03-25 00:00:00	1954-04-15	1954-04-15 00:00:00	32020		\N	27754	0	444814009	40481087		0
17827	1073	4112343	1972-01-22	1972-01-22 00:00:00	1972-01-31	1972-01-31 00:00:00	32020		\N	70388	0	195662009	4112343		0
17938	1079	4112343	1988-03-27	1988-03-27 00:00:00	1988-04-07	1988-04-07 00:00:00	32020		\N	70712	0	195662009	4112343		0
18117	1088	4112343	2005-07-08	2005-07-08 00:00:00	2005-07-21	2005-07-21 00:00:00	32020		\N	71408	0	195662009	4112343		0
7787	455	40481087	1951-04-22	1951-04-22 00:00:00	1951-04-29	1951-04-29 00:00:00	32020		\N	30376	0	444814009	40481087		0
18452	1110	40481087	2008-07-30	2008-07-30 00:00:00	2008-08-06	2008-08-06 00:00:00	32020		\N	73043	0	444814009	40481087		0
18614	1118	4048171	1978-08-18	1978-08-18 00:00:00	\N	\N	32020		\N	73726	0	232353008	4048171		0
18798	1131	40481087	1968-02-05	1968-02-05 00:00:00	1968-02-12	1968-02-12 00:00:00	32020		\N	74434	0	444814009	40481087		0
8464	492	260139	2006-09-02	2006-09-02 00:00:00	2006-09-09	2006-09-09 00:00:00	32020		\N	32941	0	10509002	260139		0
19100	1145	4112343	1967-08-17	1967-08-17 00:00:00	1967-08-26	1967-08-26 00:00:00	32020		\N	75629	0	195662009	4112343		0
19285	1155	4112343	1983-09-28	1983-09-28 00:00:00	1983-10-06	1983-10-06 00:00:00	32020		\N	76301	0	195662009	4112343		0
19547	1174	80180	1974-01-25	1974-01-25 00:00:00	\N	\N	32020		\N	77328	0	396275006	80180		0
19619	1176	4237458	1991-03-01	1991-03-01 00:00:00	1991-04-30	1991-04-30 00:00:00	32020		\N	77646	0	58150001	4237458		0
19833	1193	4112343	1974-01-21	1974-01-21 00:00:00	1974-01-28	1974-01-28 00:00:00	32020		\N	78629	0	195662009	4112343		0
19952	1202	40481087	1999-03-11	1999-03-11 00:00:00	1999-03-25	1999-03-25 00:00:00	32020		\N	79080	0	444814009	40481087		0
20152	1214	4112343	1947-02-14	1947-02-14 00:00:00	1947-02-21	1947-02-21 00:00:00	32020		\N	79994	0	195662009	4112343		0
9791	579	4112343	1966-09-11	1966-09-11 00:00:00	1966-09-18	1966-09-18 00:00:00	32020		\N	38365	0	195662009	4112343		0
20451	1229	80180	1990-09-18	1990-09-18 00:00:00	\N	\N	32020		\N	80946	0	396275006	80180		0
20629	1238	4112343	1956-09-05	1956-09-05 00:00:00	1956-09-18	1956-09-18 00:00:00	32020		\N	81573	0	195662009	4112343		0
20751	1246	4152936	1961-11-16	1961-11-16 00:00:00	1961-12-07	1961-12-07 00:00:00	32020		\N	82051	0	283385000	4152936		0
10449	615	378001	1915-01-26	1915-01-26 00:00:00	1915-03-27	1915-03-27 00:00:00	32020		\N	41039	0	62106007	378001		0
21126	1267	40481087	1960-06-01	1960-06-01 00:00:00	1960-06-08	1960-06-08 00:00:00	32020		\N	83596	0	444814009	40481087		0
147	6	4152936	1967-12-10	1967-12-10 00:00:00	1967-12-31	1967-12-31 00:00:00	32020		\N	554	0	283385000	4152936		0
10803	640	40481087	1999-06-15	1999-06-15 00:00:00	1999-07-06	1999-07-06 00:00:00	32020		\N	42353	0	444814009	40481087		0
11011	651	198199	2011-04-27	2011-04-27 00:00:00	2011-06-17	2011-06-17 00:00:00	32020		\N	43085	0	45816000	198199		0
11141	656	260139	2011-05-28	2011-05-28 00:00:00	2011-06-04	2011-06-04 00:00:00	32020		\N	43474	0	10509002	260139		0
824	43	4109685	1994-11-12	1994-11-12 00:00:00	1994-12-03	1994-12-03 00:00:00	32020		\N	3156	0	284551006	4109685		0
11559	682	40481087	2004-11-04	2004-11-04 00:00:00	2004-11-18	2004-11-18 00:00:00	32020		\N	45164	0	444814009	40481087		0
11632	686	4296204	1963-07-11	1963-07-11 00:00:00	1963-08-15	1963-08-15 00:00:00	32020		\N	45424	0	403190006	4296204		0
11806	697	4134304	2001-08-17	2001-08-17 00:00:00	2001-10-16	2001-10-16 00:00:00	32020		\N	46162	0	263102004	4134304		0
11981	709	28060	1995-06-19	1995-06-19 00:00:00	1995-07-02	1995-07-02 00:00:00	32020		\N	46933	0	43878008	28060		0
12161	720	4112343	2005-07-08	2005-07-08 00:00:00	2005-07-21	2005-07-21 00:00:00	32020		\N	47669	0	195662009	4112343		0
1821	103	4112343	1981-09-24	1981-09-24 00:00:00	1981-10-02	1981-10-02 00:00:00	32020		\N	7061	0	195662009	4112343		0
12470	738	40481087	2016-03-09	2016-03-09 00:00:00	2016-03-23	2016-03-23 00:00:00	32020		\N	48904	0	444814009	40481087		0
12640	747	80180	1996-01-31	1996-01-31 00:00:00	\N	\N	32020		\N	49464	0	396275006	80180		0
12844	757	4112343	1925-04-27	1925-04-27 00:00:00	1925-05-06	1925-05-06 00:00:00	32020		\N	50181	0	195662009	4112343		0
12953	761	260139	1991-04-19	1991-04-19 00:00:00	1991-05-03	1991-05-03 00:00:00	32020		\N	50546	0	10509002	260139		0
13147	774	4112343	1969-12-08	1969-12-08 00:00:00	1969-12-16	1969-12-16 00:00:00	32020		\N	51392	0	195662009	4112343		0
2815	162	40481087	1964-08-13	1964-08-13 00:00:00	1964-08-20	1964-08-20 00:00:00	32020		\N	11106	0	444814009	40481087		0
13481	795	4218389	1946-07-28	1946-07-28 00:00:00	1946-08-18	1946-08-18 00:00:00	32020		\N	52731	0	39848009	4218389		0
3148	185	4134304	1958-08-07	1958-08-07 00:00:00	1958-11-05	1958-11-05 00:00:00	32020		\N	12506	0	263102004	4134304		0
3292	190	4113008	1971-07-17	1971-07-17 00:00:00	1971-08-07	1971-08-07 00:00:00	32020		\N	12912	0	284549007	4113008		0
3474	197	40481087	1998-07-13	1998-07-13 00:00:00	1998-07-27	1998-07-27 00:00:00	32020		\N	13585	0	444814009	40481087		0
14157	836	80180	2016-11-07	2016-11-07 00:00:00	\N	\N	32020		\N	55351	0	396275006	80180		0
14282	842	375671	2015-02-04	2015-02-04 00:00:00	2015-03-06	2015-03-06 00:00:00	32020		\N	55707	0	62564004	375671		0
14472	856	4146173	1979-05-29	1979-05-29 00:00:00	1979-06-28	1979-06-28 00:00:00	32020		\N	56524	0	307731004	4146173		0
14630	864	78272	1923-12-19	1923-12-19 00:00:00	1924-01-23	1924-01-23 00:00:00	32020		\N	57277	0	70704007	78272		0
14787	870	372328	2006-08-01	2006-08-01 00:00:00	2006-09-12	2006-09-12 00:00:00	32020		\N	57887	0	65363002	372328		0
14992	883	4059173	1970-01-29	1970-01-29 00:00:00	1970-02-28	1970-02-28 00:00:00	32020		\N	58778	0	16114001	4059173		0
15125	890	40481087	2006-02-28	2006-02-28 00:00:00	2006-03-21	2006-03-21 00:00:00	32020		\N	59309	0	444814009	40481087		0
15293	905	372328	1974-06-17	1974-06-17 00:00:00	1975-03-01	1975-03-01 00:00:00	32020		\N	60216	0	65363002	372328		0
15449	915	40481087	1987-07-27	1987-07-27 00:00:00	1987-08-17	1987-08-17 00:00:00	32020		\N	60841	0	444814009	40481087		0
15621	924	78272	2008-03-15	2008-03-15 00:00:00	2008-03-29	2008-03-29 00:00:00	32020		\N	61542	0	70704007	78272		0
5301	312	4230399	1977-04-27	1977-04-27 00:00:00	1977-07-26	1977-07-26 00:00:00	32020		\N	20657	0	359817006	4230399		0
15989	946	260139	1985-08-09	1985-08-09 00:00:00	1985-08-23	1985-08-23 00:00:00	32020		\N	62812	0	10509002	260139		0
16149	956	4112343	1958-03-01	1958-03-01 00:00:00	1958-03-08	1958-03-08 00:00:00	32020		\N	63539	0	195662009	4112343		0
5806	340	40481087	1993-07-25	1993-07-25 00:00:00	1993-08-08	1993-08-08 00:00:00	32020		\N	22688	0	444814009	40481087		0
16639	986	40481087	1921-08-12	1921-08-12 00:00:00	1921-08-26	1921-08-26 00:00:00	32020		\N	65476	0	444814009	40481087		0
6295	370	80180	2000-01-08	2000-01-08 00:00:00	\N	\N	32020		\N	24599	0	396275006	80180		0
6461	380	260139	2009-08-25	2009-08-25 00:00:00	2009-09-08	2009-09-08 00:00:00	32020		\N	25153	0	10509002	260139		0
17156	1025	133834	1940-09-27	1940-09-27 00:00:00	1958-02-25	1958-02-25 00:00:00	32020		\N	67544	0	24079001	133834		0
17301	1036	260139	1981-12-03	1981-12-03 00:00:00	1981-12-10	1981-12-10 00:00:00	32020		\N	68150	0	10509002	260139		0
6966	409	4112343	1999-04-11	1999-04-11 00:00:00	1999-04-24	1999-04-24 00:00:00	32020		\N	27131	0	195662009	4112343		0
7133	419	80180	1954-08-08	1954-08-08 00:00:00	\N	\N	32020		\N	27754	0	396275006	80180		0
17828	1073	81893	1972-01-13	1972-01-13 00:00:00	\N	\N	32020		\N	70393	0	64766004	81893		0
17939	1079	40481087	2004-09-02	2004-09-02 00:00:00	2004-09-23	2004-09-23 00:00:00	32020		\N	70731	0	444814009	40481087		0
18118	1088	260139	1987-10-20	1987-10-20 00:00:00	1987-10-27	1987-10-27 00:00:00	32020		\N	71406	0	10509002	260139		0
7788	455	4218389	1952-08-09	1952-08-09 00:00:00	1952-08-30	1952-08-30 00:00:00	32020		\N	30455	0	39848009	4218389		0
18453	1110	40481087	1984-10-06	1984-10-06 00:00:00	1984-10-20	1984-10-20 00:00:00	32020		\N	73026	0	444814009	40481087		0
18615	1118	4027663	2006-08-04	2006-08-04 00:00:00	\N	\N	32020		\N	73693	0	13200003	4027663		0
18799	1131	260139	2016-04-05	2016-04-05 00:00:00	2016-04-12	2016-04-12 00:00:00	32020		\N	74438	0	10509002	260139		0
8465	492	40481087	1961-06-26	1961-06-26 00:00:00	1961-07-03	1961-07-03 00:00:00	32020		\N	32950	0	444814009	40481087		0
19101	1145	40481087	1989-03-15	1989-03-15 00:00:00	1989-03-29	1989-03-29 00:00:00	32020		\N	75575	0	444814009	40481087		0
19286	1155	372328	1989-04-08	1989-04-08 00:00:00	1990-01-15	1990-01-15 00:00:00	32020		\N	76369	0	65363002	372328		0
19548	1174	4112343	1971-08-26	1971-08-26 00:00:00	1971-09-07	1971-09-07 00:00:00	32020		\N	77328	0	195662009	4112343		0
19620	1176	4112343	2011-10-30	2011-10-30 00:00:00	2011-11-07	2011-11-07 00:00:00	32020		\N	77699	0	195662009	4112343		0
19834	1193	80180	1987-03-15	1987-03-15 00:00:00	\N	\N	32020		\N	78643	0	396275006	80180		0
19953	1202	4112343	1982-12-27	1982-12-27 00:00:00	1983-01-09	1983-01-09 00:00:00	32020		\N	79065	0	195662009	4112343		0
20153	1214	260139	1978-05-31	1978-05-31 00:00:00	1978-06-14	1978-06-14 00:00:00	32020		\N	79991	0	10509002	260139		0
9792	579	260139	2008-08-22	2008-08-22 00:00:00	2008-09-05	2008-09-05 00:00:00	32020		\N	38350	0	10509002	260139		0
20452	1229	40481087	1961-05-28	1961-05-28 00:00:00	1961-06-18	1961-06-18 00:00:00	32020		\N	81010	0	444814009	40481087		0
20630	1238	4237458	2004-06-05	2004-06-05 00:00:00	2004-09-03	2004-09-03 00:00:00	32020		\N	81584	0	58150001	4237458		0
20752	1246	4112343	1954-05-28	1954-05-28 00:00:00	1954-06-08	1954-06-08 00:00:00	32020		\N	82112	0	195662009	4112343		0
10450	615	260139	1920-07-16	1920-07-16 00:00:00	1920-07-30	1920-07-30 00:00:00	32020		\N	40933	0	10509002	260139		0
21127	1267	4112343	1969-12-26	1969-12-26 00:00:00	1970-01-05	1970-01-05 00:00:00	32020		\N	83561	0	195662009	4112343		0
148	6	40481087	1997-04-26	1997-04-26 00:00:00	1997-05-03	1997-05-03 00:00:00	32020		\N	540	0	444814009	40481087		0
10804	640	260139	1992-04-24	1992-04-24 00:00:00	1992-05-01	1992-05-01 00:00:00	32020		\N	42370	0	10509002	260139		0
11012	651	4285898	2011-09-14	2011-09-14 00:00:00	\N	\N	32020		\N	43085	0	68496003	4285898		0
11142	656	4112343	1972-09-14	1972-09-14 00:00:00	1972-09-26	1972-09-26 00:00:00	32020		\N	43436	0	195662009	4112343		0
825	43	4112343	2018-11-30	2018-11-30 00:00:00	2018-12-12	2018-12-12 00:00:00	32020		\N	3175	0	195662009	4112343		0
11560	682	80180	2008-06-26	2008-06-26 00:00:00	\N	\N	32020		\N	45184	0	396275006	80180		0
11633	686	4112343	1979-06-05	1979-06-05 00:00:00	1979-06-15	1979-06-15 00:00:00	32020		\N	45379	0	195662009	4112343		0
11807	697	4294548	1977-03-21	1977-03-21 00:00:00	1977-05-09	1977-05-09 00:00:00	32020		\N	46119	0	75498004	4294548		0
11982	709	4294548	1991-11-17	1991-11-17 00:00:00	1991-12-08	1991-12-08 00:00:00	32020		\N	46932	0	75498004	4294548		0
12162	720	40481087	2002-06-12	2002-06-12 00:00:00	2002-06-19	2002-06-19 00:00:00	32020		\N	47677	0	444814009	40481087		0
1822	103	40481087	2014-04-04	2014-04-04 00:00:00	2014-04-18	2014-04-18 00:00:00	32020		\N	7048	0	444814009	40481087		0
12471	738	372328	1981-08-17	1981-08-17 00:00:00	1981-12-08	1981-12-08 00:00:00	32020		\N	48902	0	65363002	372328		0
12641	747	4109685	2003-07-14	2003-07-14 00:00:00	2003-08-04	2003-08-04 00:00:00	32020		\N	49477	0	284551006	4109685		0
12845	757	378419	1989-05-07	1989-05-07 00:00:00	\N	\N	32020		\N	50266	0	26929004	378419		0
12954	761	40481087	1982-12-15	1982-12-15 00:00:00	1982-12-22	1982-12-22 00:00:00	32020		\N	50590	0	444814009	40481087		0
13148	774	80180	2008-04-30	2008-04-30 00:00:00	\N	\N	32020		\N	51378	0	396275006	80180		0
2816	162	4218389	2007-09-05	2007-09-05 00:00:00	2007-09-26	2007-09-26 00:00:00	32020		\N	11093	0	39848009	4218389		0
13482	795	28060	2018-09-09	2018-09-09 00:00:00	2018-09-16	2018-09-16 00:00:00	32020		\N	52777	0	43878008	28060		0
3149	185	372328	1948-08-16	1948-08-16 00:00:00	1948-10-17	1948-10-17 00:00:00	32020		\N	12571	0	65363002	372328		0
3293	191	4116491	1958-05-23	1958-05-23 00:00:00	1958-06-26	1958-06-26 00:00:00	32020		\N	13022	0	301011002	4116491		0
3475	197	40481087	2004-11-19	2004-11-19 00:00:00	2004-12-10	2004-12-10 00:00:00	32020		\N	13572	0	444814009	40481087		0
14158	836	4218389	2008-03-04	2008-03-04 00:00:00	2008-04-01	2008-04-01 00:00:00	32020		\N	55326	0	39848009	4218389		0
14283	843	80180	2017-09-04	2017-09-04 00:00:00	\N	\N	32020		\N	55866	0	396275006	80180		0
14473	856	40479422	1971-11-30	1971-11-30 00:00:00	1972-01-06	1972-01-06 00:00:00	32020		\N	56517	0	444448004	40479422		0
14631	864	40481087	2002-07-24	2002-07-24 00:00:00	2002-08-14	2002-08-14 00:00:00	32020		\N	57285	0	444814009	40481087		0
14788	870	4230399	1993-04-02	1993-04-02 00:00:00	1993-07-01	1993-07-01 00:00:00	32020		\N	57849	0	359817006	4230399		0
14993	883	28060	1969-04-07	1969-04-07 00:00:00	1969-04-15	1969-04-15 00:00:00	32020		\N	58793	0	43878008	28060		0
15126	890	4218389	1975-03-06	1975-03-06 00:00:00	1975-04-03	1975-04-03 00:00:00	32020		\N	59327	0	39848009	4218389		0
15294	905	4296204	2007-11-01	2007-11-01 00:00:00	2007-12-06	2007-12-06 00:00:00	32020		\N	60195	0	403190006	4296204		0
15450	915	28060	2015-08-24	2015-08-24 00:00:00	2015-09-05	2015-09-05 00:00:00	32020		\N	60829	0	43878008	28060		0
15622	924	4112343	1984-12-04	1984-12-04 00:00:00	1984-12-17	1984-12-17 00:00:00	32020		\N	61547	0	195662009	4112343		0
5302	312	4112343	2018-03-06	2018-03-06 00:00:00	2018-03-19	2018-03-19 00:00:00	32020		\N	20695	0	195662009	4112343		0
15990	947	81151	1968-07-21	1968-07-21 00:00:00	1968-08-04	1968-08-04 00:00:00	32020		\N	62862	0	44465007	81151		0
16150	956	4237458	1948-01-19	1948-01-19 00:00:00	1948-04-18	1948-04-18 00:00:00	32020		\N	63550	0	58150001	4237458		0
5807	340	80180	1995-06-24	1995-06-24 00:00:00	\N	\N	32020		\N	22688	0	396275006	80180		0
5975	351	28060	1986-04-04	1986-04-04 00:00:00	1986-04-13	1986-04-13 00:00:00	32020		\N	23340	0	43878008	28060		0
16640	986	81151	1924-09-07	1924-09-07 00:00:00	1924-10-05	1924-10-05 00:00:00	32020		\N	65517	0	44465007	81151		0
6296	370	4112343	1999-05-05	1999-05-05 00:00:00	1999-05-17	1999-05-17 00:00:00	32020		\N	24599	0	195662009	4112343		0
6462	380	28060	1996-07-16	1996-07-16 00:00:00	1996-07-27	1996-07-27 00:00:00	32020		\N	25118	0	43878008	28060		0
17157	1025	80180	1974-04-05	1974-04-05 00:00:00	\N	\N	32020		\N	67559	0	396275006	80180		0
17302	1036	4112343	1975-09-07	1975-09-07 00:00:00	1975-09-20	1975-09-20 00:00:00	32020		\N	68095	0	195662009	4112343		0
6967	409	40481087	1966-03-25	1966-03-25 00:00:00	1966-04-01	1966-04-01 00:00:00	32020		\N	27090	0	444814009	40481087		0
7134	419	381316	1994-07-31	1994-07-31 00:00:00	\N	\N	32020		\N	27775	0	230690007	381316		0
17829	1073	80502	1996-08-29	1996-08-29 00:00:00	\N	\N	32020		\N	70353	0	64859006	80502		0
17940	1079	195588	2010-03-07	2010-03-07 00:00:00	2010-04-18	2010-04-18 00:00:00	32020		\N	70737	0	38822007	195588		0
18119	1088	40481087	1985-07-24	1985-07-24 00:00:00	1985-08-14	1985-08-14 00:00:00	32020		\N	71452	0	444814009	40481087		0
7789	455	40481087	1950-03-07	1950-03-07 00:00:00	1950-03-21	1950-03-21 00:00:00	32020		\N	30416	0	444814009	40481087		0
18454	1110	260139	2010-09-10	2010-09-10 00:00:00	2010-09-24	2010-09-24 00:00:00	32020		\N	73120	0	10509002	260139		0
18616	1118	192671	2014-07-07	2014-07-07 00:00:00	\N	\N	32020		\N	73715	0	K92.2	35208414		0
18800	1131	260139	1995-10-14	1995-10-14 00:00:00	1995-10-21	1995-10-21 00:00:00	32020		\N	74424	0	10509002	260139		0
8466	492	4112343	1948-02-07	1948-02-07 00:00:00	1948-02-15	1948-02-15 00:00:00	32020		\N	32935	0	195662009	4112343		0
19102	1145	4112343	2004-05-19	2004-05-19 00:00:00	2004-05-26	2004-05-26 00:00:00	32020		\N	75635	0	195662009	4112343		0
19287	1155	257012	1979-07-07	1979-07-07 00:00:00	2011-04-01	2011-04-01 00:00:00	32020		\N	76303	0	40055000	257012		0
19549	1174	372328	1944-04-17	1944-04-17 00:00:00	1944-12-24	1944-12-24 00:00:00	32020		\N	77349	0	65363002	372328		0
19621	1176	40481087	1974-07-25	1974-07-25 00:00:00	1974-08-08	1974-08-08 00:00:00	32020		\N	77626	0	444814009	40481087		0
19835	1193	4112343	1987-01-05	1987-01-05 00:00:00	1987-01-13	1987-01-13 00:00:00	32020		\N	78643	0	195662009	4112343		0
19954	1202	40481087	2005-06-30	2005-06-30 00:00:00	2005-07-14	2005-07-14 00:00:00	32020		\N	79073	0	444814009	40481087		0
20154	1214	260139	1985-06-06	1985-06-06 00:00:00	1985-06-20	1985-06-20 00:00:00	32020		\N	79900	0	10509002	260139		0
9793	579	40481087	1986-02-08	1986-02-08 00:00:00	1986-03-01	1986-03-01 00:00:00	32020		\N	38291	0	444814009	40481087		0
20453	1229	40481087	2003-01-19	2003-01-19 00:00:00	2003-02-02	2003-02-02 00:00:00	32020		\N	80957	0	444814009	40481087		0
20631	1238	28060	2002-05-05	2002-05-05 00:00:00	2002-05-16	2002-05-16 00:00:00	32020		\N	81612	0	43878008	28060		0
20753	1246	4027663	1969-08-11	1969-08-11 00:00:00	\N	\N	32020		\N	82031	0	13200003	4027663		0
10451	615	260139	1933-06-28	1933-06-28 00:00:00	1933-07-05	1933-07-05 00:00:00	32020		\N	40995	0	10509002	260139		0
21128	1267	4112343	2005-09-14	2005-09-14 00:00:00	2005-09-24	2005-09-24 00:00:00	32020		\N	83522	0	195662009	4112343		0
149	6	4237458	1976-05-01	1976-05-01 00:00:00	1976-06-30	1976-06-30 00:00:00	32020		\N	556	0	58150001	4237458		0
10805	640	40481087	1954-08-13	1954-08-13 00:00:00	1954-08-27	1954-08-27 00:00:00	32020		\N	42350	0	444814009	40481087		0
11013	651	40481087	1987-07-04	1987-07-04 00:00:00	1987-07-18	1987-07-18 00:00:00	32020		\N	43106	0	444814009	40481087		0
11143	656	4109685	2004-10-05	2004-10-05 00:00:00	2004-10-26	2004-10-26 00:00:00	32020		\N	43426	0	284551006	4109685		0
826	43	40481087	1991-08-15	1991-08-15 00:00:00	1991-08-29	1991-08-29 00:00:00	32020		\N	3193	0	444814009	40481087		0
11561	682	40481087	2002-12-16	2002-12-16 00:00:00	2003-01-06	2003-01-06 00:00:00	32020		\N	45189	0	444814009	40481087		0
11634	686	40481087	2012-04-08	2012-04-08 00:00:00	2012-04-29	2012-04-29 00:00:00	32020		\N	45384	0	444814009	40481087		0
11808	697	40481087	1987-01-18	1987-01-18 00:00:00	1987-02-01	1987-02-01 00:00:00	32020		\N	46102	0	444814009	40481087		0
11983	709	28060	1967-11-09	1967-11-09 00:00:00	1967-11-22	1967-11-22 00:00:00	32020		\N	46924	0	43878008	28060		0
12163	720	80180	2000-09-04	2000-09-04 00:00:00	\N	\N	32020		\N	47649	0	396275006	80180		0
1823	103	4112343	1974-02-22	1974-02-22 00:00:00	1974-03-06	1974-03-06 00:00:00	32020		\N	7033	0	195662009	4112343		0
12472	738	4112343	2018-10-07	2018-10-07 00:00:00	2018-10-18	2018-10-18 00:00:00	32020		\N	48888	0	195662009	4112343		0
12642	747	260139	1994-06-11	1994-06-11 00:00:00	1994-06-18	1994-06-18 00:00:00	32020		\N	49471	0	10509002	260139		0
12846	757	257012	1925-01-25	1925-01-25 00:00:00	\N	\N	32020		\N	50205	0	40055000	257012		0
12955	761	81893	2014-03-06	2014-03-06 00:00:00	\N	\N	32020		\N	50601	0	64766004	81893		0
13149	774	192671	2008-06-22	2008-06-22 00:00:00	\N	\N	32020		\N	51374	0	K92.2	35208414		0
2817	162	4155034	2005-10-31	2005-10-31 00:00:00	2005-11-14	2005-11-14 00:00:00	32020		\N	11092	0	283371005	4155034		0
13483	795	192671	1982-09-03	1982-09-03 00:00:00	\N	\N	32020		\N	52798	0	K92.2	35208414		0
3150	185	40481087	1988-01-23	1988-01-23 00:00:00	1988-02-13	1988-02-13 00:00:00	32020		\N	12527	0	444814009	40481087		0
3294	191	80180	1960-04-07	1960-04-07 00:00:00	\N	\N	32020		\N	13022	0	396275006	80180		0
3476	197	40481087	1991-11-27	1991-11-27 00:00:00	1991-12-11	1991-12-11 00:00:00	32020		\N	13537	0	444814009	40481087		0
14159	836	4112343	2001-12-05	2001-12-05 00:00:00	2001-12-15	2001-12-15 00:00:00	32020		\N	55313	0	195662009	4112343		0
14284	843	372328	1984-11-03	1984-11-03 00:00:00	1985-04-06	1985-04-06 00:00:00	32020		\N	55814	0	65363002	372328		0
14474	856	372328	1982-01-25	1982-01-25 00:00:00	1982-07-09	1982-07-09 00:00:00	32020		\N	56567	0	65363002	372328		0
14632	864	4112343	1947-11-26	1947-11-26 00:00:00	1947-12-03	1947-12-03 00:00:00	32020		\N	57262	0	195662009	4112343		0
14789	870	372328	1963-07-20	1963-07-20 00:00:00	1963-11-12	1963-11-12 00:00:00	32020		\N	57866	0	65363002	372328		0
14994	883	4116491	2006-06-04	2006-06-04 00:00:00	2006-07-24	2006-07-24 00:00:00	32020		\N	58774	0	301011002	4116491		0
15127	890	40481087	1971-04-24	1971-04-24 00:00:00	1971-05-15	1971-05-15 00:00:00	32020		\N	59332	0	444814009	40481087		0
15295	905	4266809	2009-04-29	2009-04-29 00:00:00	\N	\N	32020		\N	60196	0	397881000	4266809		0
15451	915	4112343	2009-10-22	2009-10-22 00:00:00	2009-10-30	2009-10-30 00:00:00	32020		\N	60865	0	195662009	4112343		0
15623	924	28060	1995-08-11	1995-08-11 00:00:00	1995-08-20	1995-08-20 00:00:00	32020		\N	61548	0	43878008	28060		0
5303	312	4112343	1975-01-12	1975-01-12 00:00:00	1975-01-19	1975-01-19 00:00:00	32020		\N	20670	0	195662009	4112343		0
15991	947	80180	2000-06-08	2000-06-08 00:00:00	\N	\N	32020		\N	62858	0	396275006	80180		0
16151	956	40481087	1961-07-20	1961-07-20 00:00:00	1961-08-03	1961-08-03 00:00:00	32020		\N	63540	0	444814009	40481087		0
5808	340	81151	2007-10-29	2007-10-29 00:00:00	2007-11-26	2007-11-26 00:00:00	32020		\N	22741	0	44465007	81151		0
5976	351	4310024	2016-09-15	2016-09-15 00:00:00	\N	\N	32020		\N	23357	0	424802006	4310024		0
16641	986	40481087	1942-07-10	1942-07-10 00:00:00	1942-07-31	1942-07-31 00:00:00	32020		\N	65449	0	444814009	40481087		0
6297	370	4296205	1967-12-07	1967-12-07 00:00:00	1968-01-04	1968-01-04 00:00:00	32020		\N	24581	0	403191005	4296205		0
6463	380	372328	1972-01-11	1972-01-11 00:00:00	1972-02-18	1972-02-18 00:00:00	32020		\N	25145	0	65363002	372328		0
17158	1025	260139	1987-10-21	1987-10-21 00:00:00	1987-10-28	1987-10-28 00:00:00	32020		\N	67510	0	10509002	260139		0
17303	1036	80180	2011-05-13	2011-05-13 00:00:00	\N	\N	32020		\N	68188	0	396275006	80180		0
6968	410	4156265	2004-08-09	2004-08-09 00:00:00	2004-08-23	2004-08-23 00:00:00	32020		\N	27158	0	370247008	4156265		0
7135	419	4112343	1915-01-11	1915-01-11 00:00:00	1915-01-20	1915-01-20 00:00:00	32020		\N	27749	0	195662009	4112343		0
17830	1073	28060	1980-03-23	1980-03-23 00:00:00	1980-04-02	1980-04-02 00:00:00	32020		\N	70311	0	43878008	28060		0
17941	1079	372328	1964-01-03	1964-01-03 00:00:00	1964-02-23	1964-02-23 00:00:00	32020		\N	70734	0	65363002	372328		0
18120	1088	195588	2006-07-22	2006-07-22 00:00:00	2006-09-08	2006-09-08 00:00:00	32020		\N	71409	0	38822007	195588		0
7790	455	4112343	1990-04-18	1990-04-18 00:00:00	1990-04-30	1990-04-30 00:00:00	32020		\N	30458	0	195662009	4112343		0
18455	1110	260139	2002-08-27	2002-08-27 00:00:00	2002-09-10	2002-09-10 00:00:00	32020		\N	73078	0	10509002	260139		0
18617	1118	372328	1990-06-03	1990-06-03 00:00:00	1990-12-16	1990-12-16 00:00:00	32020		\N	73752	0	65363002	372328		0
18801	1131	80180	2004-12-14	2004-12-14 00:00:00	\N	\N	32020		\N	74473	0	396275006	80180		0
18925	1137	317576	1983-08-12	1983-08-12 00:00:00	\N	\N	32020		\N	74923	0	53741008	317576		0
19103	1145	372328	1938-11-22	1938-11-22 00:00:00	1939-02-01	1939-02-01 00:00:00	32020		\N	75578	0	65363002	372328		0
19288	1155	4112343	1996-08-25	1996-08-25 00:00:00	1996-09-01	1996-09-01 00:00:00	32020		\N	76316	0	195662009	4112343		0
19550	1174	4283893	1976-11-03	1976-11-03 00:00:00	1976-12-01	1976-12-01 00:00:00	32020		\N	77305	0	36971009	4283893		0
19622	1176	81893	1997-07-07	1997-07-07 00:00:00	\N	\N	32020		\N	77635	0	64766004	81893		0
19836	1193	28060	1953-03-12	1953-03-12 00:00:00	1953-03-25	1953-03-25 00:00:00	32020		\N	78595	0	43878008	28060		0
19955	1202	40481087	2008-08-03	2008-08-03 00:00:00	2008-08-17	2008-08-17 00:00:00	32020		\N	79045	0	444814009	40481087		0
20155	1214	28060	2008-01-30	2008-01-30 00:00:00	2008-02-08	2008-02-08 00:00:00	32020		\N	79908	0	43878008	28060		0
9794	579	40481087	2006-07-03	2006-07-03 00:00:00	2006-07-24	2006-07-24 00:00:00	32020		\N	38368	0	444814009	40481087		0
20466	1231	4112343	1960-01-25	1960-01-25 00:00:00	1960-02-06	1960-02-06 00:00:00	32020		\N	81068	0	195662009	4112343		0
20632	1239	4112343	1994-01-30	1994-01-30 00:00:00	1994-02-07	1994-02-07 00:00:00	32020		\N	81661	0	195662009	4112343		0
20754	1246	372328	2011-03-12	2011-03-12 00:00:00	2011-10-28	2011-10-28 00:00:00	32020		\N	82016	0	65363002	372328		0
10452	615	4112343	2003-03-11	2003-03-11 00:00:00	2003-03-23	2003-03-23 00:00:00	32020		\N	40961	0	195662009	4112343		0
21129	1267	378001	1987-11-06	1987-11-06 00:00:00	1987-12-06	1987-12-06 00:00:00	32020		\N	83567	0	62106007	378001		0
150	6	4152936	1971-08-12	1971-08-12 00:00:00	1971-08-26	1971-08-26 00:00:00	32020		\N	555	0	283385000	4152936		0
10806	640	4278672	1957-04-10	1957-04-10 00:00:00	1957-07-09	1957-07-09 00:00:00	32020		\N	42328	0	65966004	4278672		0
11015	651	321042	1999-01-28	1999-01-28 00:00:00	\N	\N	32020		\N	43079	0	410429000	321042		0
11145	656	40481087	1999-05-20	1999-05-20 00:00:00	1999-05-27	1999-05-27 00:00:00	32020		\N	43446	0	444814009	40481087		0
827	43	40481087	1976-08-10	1976-08-10 00:00:00	1976-08-24	1976-08-24 00:00:00	32020		\N	3158	0	444814009	40481087		0
11562	682	4112343	2018-03-21	2018-03-21 00:00:00	2018-03-28	2018-03-28 00:00:00	32020		\N	45158	0	195662009	4112343		0
11635	686	4059173	1954-02-27	1954-02-27 00:00:00	1954-03-29	1954-03-29 00:00:00	32020		\N	45423	0	16114001	4059173		0
11809	697	40481087	2019-05-01	2019-05-01 00:00:00	2019-05-22	2019-05-22 00:00:00	32020		\N	46152	0	444814009	40481087		0
11984	709	4109685	1972-03-04	1972-03-04 00:00:00	1972-03-25	1972-03-25 00:00:00	32020		\N	46974	0	284551006	4109685		0
12164	720	40481087	1989-07-22	1989-07-22 00:00:00	1989-08-12	1989-08-12 00:00:00	32020		\N	47632	0	444814009	40481087		0
1824	103	260139	1974-07-22	1974-07-22 00:00:00	1974-07-29	1974-07-29 00:00:00	32020		\N	7043	0	10509002	260139		0
12473	738	260139	1988-04-22	1988-04-22 00:00:00	1988-05-06	1988-05-06 00:00:00	32020		\N	48887	0	10509002	260139		0
12643	747	40481087	1982-09-13	1982-09-13 00:00:00	1982-10-04	1982-10-04 00:00:00	32020		\N	49444	0	444814009	40481087		0
12847	757	4116491	1943-12-20	1943-12-20 00:00:00	1944-01-21	1944-01-21 00:00:00	32020		\N	50188	0	301011002	4116491		0
12956	761	260139	2007-11-08	2007-11-08 00:00:00	2007-11-15	2007-11-15 00:00:00	32020		\N	50627	0	10509002	260139		0
13150	774	4001336	1980-09-09	1980-09-09 00:00:00	1980-10-09	1980-10-09 00:00:00	32020		\N	51389	0	110030002	4001336		0
2818	162	372328	1940-07-14	1940-07-14 00:00:00	1940-10-29	1940-10-29 00:00:00	32020		\N	11084	0	65363002	372328		0
13484	795	378001	1998-03-18	1998-03-18 00:00:00	1998-05-17	1998-05-17 00:00:00	32020		\N	52733	0	62106007	378001		0
3151	185	40481087	2008-03-24	2008-03-24 00:00:00	2008-03-31	2008-03-31 00:00:00	32020		\N	12558	0	444814009	40481087		0
3295	191	4156265	1983-10-06	1983-10-06 00:00:00	1983-10-27	1983-10-27 00:00:00	32020		\N	13040	0	370247008	4156265		0
3477	197	257012	1978-09-28	1978-09-28 00:00:00	\N	\N	32020		\N	13595	0	40055000	257012		0
14203	841	4112343	2006-01-18	2006-01-18 00:00:00	2006-01-29	2006-01-29 00:00:00	32020		\N	55516	0	195662009	4112343		0
14285	843	40481087	1993-01-08	1993-01-08 00:00:00	1993-01-22	1993-01-22 00:00:00	32020		\N	55806	0	444814009	40481087		0
14475	856	40481087	1992-10-27	1992-10-27 00:00:00	1992-11-03	1992-11-03 00:00:00	32020		\N	56537	0	444814009	40481087		0
14633	864	40481087	1999-06-17	1999-06-17 00:00:00	1999-07-01	1999-07-01 00:00:00	32020		\N	57282	0	444814009	40481087		0
14790	870	40481087	2011-12-05	2011-12-05 00:00:00	2011-12-26	2011-12-26 00:00:00	32020		\N	57912	0	444814009	40481087		0
14995	883	4112343	1972-09-10	1972-09-10 00:00:00	1972-09-18	1972-09-18 00:00:00	32020		\N	58813	0	195662009	4112343		0
15149	893	4283893	1995-03-25	1995-03-25 00:00:00	1995-04-15	1995-04-15 00:00:00	32020		\N	59493	0	36971009	4283893		0
15296	905	4218389	2008-10-01	2008-10-01 00:00:00	2008-10-22	2008-10-22 00:00:00	32020		\N	60196	0	39848009	4218389		0
15452	915	4112343	1977-01-11	1977-01-11 00:00:00	1977-01-21	1977-01-21 00:00:00	32020		\N	60862	0	195662009	4112343		0
15624	924	40481087	1968-05-08	1968-05-08 00:00:00	1968-05-22	1968-05-22 00:00:00	32020		\N	61528	0	444814009	40481087		0
5304	312	260139	2006-12-03	2006-12-03 00:00:00	2006-12-10	2006-12-10 00:00:00	32020		\N	20675	0	10509002	260139		0
15992	947	4152936	2009-09-28	2009-09-28 00:00:00	2009-10-19	2009-10-19 00:00:00	32020		\N	62864	0	283385000	4152936		0
16152	956	4218389	1956-02-18	1956-02-18 00:00:00	1956-03-24	1956-03-24 00:00:00	32020		\N	63554	0	39848009	4218389		0
5809	341	4112343	1978-10-19	1978-10-19 00:00:00	1978-10-26	1978-10-26 00:00:00	32020		\N	22805	0	195662009	4112343		0
16435	971	40481087	1997-07-12	1997-07-12 00:00:00	1997-08-02	1997-08-02 00:00:00	32020		\N	64605	0	444814009	40481087		0
16642	986	28060	1926-11-20	1926-11-20 00:00:00	1926-11-29	1926-11-29 00:00:00	32020		\N	65458	0	43878008	28060		0
6298	370	4278672	1994-01-27	1994-01-27 00:00:00	1994-02-26	1994-02-26 00:00:00	32020		\N	24585	0	65966004	4278672		0
6464	380	440086	1983-11-09	1983-11-09 00:00:00	1984-03-21	1984-03-21 00:00:00	32020		\N	25126	0	192127007	440086		0
17159	1025	260139	2018-03-20	2018-03-20 00:00:00	2018-04-03	2018-04-03 00:00:00	32020		\N	67512	0	10509002	260139		0
17304	1036	4112343	1981-03-23	1981-03-23 00:00:00	1981-04-04	1981-04-04 00:00:00	32020		\N	68096	0	195662009	4112343		0
6969	410	40481087	1974-03-01	1974-03-01 00:00:00	1974-03-15	1974-03-15 00:00:00	32020		\N	27224	0	444814009	40481087		0
7136	419	4142905	1979-12-26	1979-12-26 00:00:00	1980-03-25	1980-03-25 00:00:00	32020		\N	27712	0	33737001	4142905		0
17831	1073	4278672	2017-02-14	2017-02-14 00:00:00	2017-04-15	2017-04-15 00:00:00	32020		\N	70305	0	65966004	4278672		0
17942	1079	40481087	1997-09-27	1997-09-27 00:00:00	1997-10-04	1997-10-04 00:00:00	32020		\N	70730	0	444814009	40481087		0
18121	1088	372328	1973-10-23	1973-10-23 00:00:00	1974-01-06	1974-01-06 00:00:00	32020		\N	71416	0	65363002	372328		0
7791	455	260139	1951-05-28	1951-05-28 00:00:00	1951-06-04	1951-06-04 00:00:00	32020		\N	30398	0	10509002	260139		0
18456	1110	40481087	2006-09-27	2006-09-27 00:00:00	2006-10-04	2006-10-04 00:00:00	32020		\N	73111	0	444814009	40481087		0
18618	1118	4155034	1980-06-06	1980-06-06 00:00:00	1980-06-20	1980-06-20 00:00:00	32020		\N	73702	0	283371005	4155034		0
18802	1132	260139	2002-01-27	2002-01-27 00:00:00	2002-02-03	2002-02-03 00:00:00	32020		\N	74537	0	10509002	260139		0
18926	1137	40481087	1957-12-16	1957-12-16 00:00:00	1957-12-30	1957-12-30 00:00:00	32020		\N	74959	0	444814009	40481087		0
19104	1145	4283893	2016-09-29	2016-09-29 00:00:00	2017-03-30	2017-03-30 00:00:00	32020		\N	75659	0	36971009	4283893		0
19289	1155	260139	2010-10-29	2010-10-29 00:00:00	2010-11-05	2010-11-05 00:00:00	32020		\N	76366	0	10509002	260139		0
19551	1174	40481087	1976-09-13	1976-09-13 00:00:00	1976-09-27	1976-09-27 00:00:00	32020		\N	77361	0	444814009	40481087		0
19623	1176	4310024	1996-12-09	1996-12-09 00:00:00	\N	\N	32020		\N	77635	0	424802006	4310024		0
19837	1193	4112343	2006-06-17	2006-06-17 00:00:00	2006-06-24	2006-06-24 00:00:00	32020		\N	78644	0	195662009	4112343		0
19956	1202	40481087	1993-08-16	1993-08-16 00:00:00	1993-08-30	1993-08-30 00:00:00	32020		\N	79069	0	444814009	40481087		0
20156	1214	40481087	1959-03-05	1959-03-05 00:00:00	1959-03-19	1959-03-19 00:00:00	32020		\N	79997	0	444814009	40481087		0
11223	662	4266809	2001-05-29	2001-05-29 00:00:00	\N	\N	32020		\N	43759	0	397881000	4266809		0
20253	1219	260139	1947-08-20	1947-08-20 00:00:00	1947-08-27	1947-08-27 00:00:00	32020		\N	80284	0	10509002	260139		0
20467	1231	4134304	1949-11-14	1949-11-14 00:00:00	1950-01-13	1950-01-13 00:00:00	32020		\N	81113	0	263102004	4134304		0
20633	1239	28060	1987-10-23	1987-10-23 00:00:00	1987-11-02	1987-11-02 00:00:00	32020		\N	81669	0	43878008	28060		0
20755	1246	40481087	1987-09-03	1987-09-03 00:00:00	1987-09-10	1987-09-10 00:00:00	32020		\N	82116	0	444814009	40481087		0
10453	615	40481087	1978-12-19	1978-12-19 00:00:00	1979-01-09	1979-01-09 00:00:00	32020		\N	40912	0	444814009	40481087		0
21130	1267	4113008	2009-05-14	2009-05-14 00:00:00	2009-05-28	2009-05-28 00:00:00	32020		\N	83535	0	284549007	4113008		0
151	6	4218389	2005-06-17	2005-06-17 00:00:00	2005-07-22	2005-07-22 00:00:00	32020		\N	562	0	39848009	4218389		0
10807	640	40481087	1960-05-02	1960-05-02 00:00:00	1960-05-23	1960-05-23 00:00:00	32020		\N	42374	0	444814009	40481087		0
11016	651	192671	2012-06-08	2012-06-08 00:00:00	\N	\N	32020		\N	43127	0	K92.2	35208414		0
11146	656	440086	1971-01-02	1971-01-02 00:00:00	1971-11-06	1971-11-06 00:00:00	32020		\N	43443	0	192127007	440086		0
828	43	4156265	1990-03-24	1990-03-24 00:00:00	1990-04-07	1990-04-07 00:00:00	32020		\N	3155	0	370247008	4156265		0
11563	682	40481087	1975-11-28	1975-11-28 00:00:00	1975-12-12	1975-12-12 00:00:00	32020		\N	45162	0	444814009	40481087		0
11636	687	372328	1968-01-16	1968-01-16 00:00:00	1968-03-30	1968-03-30 00:00:00	32020		\N	45534	0	65363002	372328		0
11810	697	260139	2015-10-13	2015-10-13 00:00:00	2015-10-27	2015-10-27 00:00:00	32020		\N	46137	0	10509002	260139		0
11985	709	4112343	1968-02-24	1968-02-24 00:00:00	1968-03-08	1968-03-08 00:00:00	32020		\N	46957	0	195662009	4112343		0
12165	720	40481087	2005-01-12	2005-01-12 00:00:00	2005-01-19	2005-01-19 00:00:00	32020		\N	47668	0	444814009	40481087		0
12285	727	40481087	1998-10-19	1998-10-19 00:00:00	1998-11-02	1998-11-02 00:00:00	32020		\N	48164	0	444814009	40481087		0
12474	738	260139	2000-08-29	2000-08-29 00:00:00	2000-09-05	2000-09-05 00:00:00	32020		\N	48892	0	10509002	260139		0
12644	747	40481087	1992-08-29	1992-08-29 00:00:00	1992-09-05	1992-09-05 00:00:00	32020		\N	49470	0	444814009	40481087		0
12848	757	260139	1940-10-09	1940-10-09 00:00:00	1940-10-23	1940-10-23 00:00:00	32020		\N	50207	0	10509002	260139		0
12957	761	4283893	1996-08-06	1996-08-06 00:00:00	1996-09-03	1996-09-03 00:00:00	32020		\N	50612	0	36971009	4283893		0
13151	774	40481087	2012-05-05	2012-05-05 00:00:00	2012-05-12	2012-05-12 00:00:00	32020		\N	51361	0	444814009	40481087		0
2819	162	372328	1978-03-14	1978-03-14 00:00:00	1978-11-28	1978-11-28 00:00:00	32020		\N	11167	0	65363002	372328		0
13485	795	40481087	2011-07-23	2011-07-23 00:00:00	2011-07-30	2011-07-30 00:00:00	32020		\N	52753	0	444814009	40481087		0
3152	185	40481087	1947-04-12	1947-04-12 00:00:00	1947-05-03	1947-05-03 00:00:00	32020		\N	12523	0	444814009	40481087		0
3296	191	40481087	1956-10-24	1956-10-24 00:00:00	1956-11-14	1956-11-14 00:00:00	32020		\N	13064	0	444814009	40481087		0
3486	199	4112343	2001-02-17	2001-02-17 00:00:00	2001-02-24	2001-02-24 00:00:00	32020		\N	13674	0	195662009	4112343		0
14204	841	40486433	1954-01-22	1954-01-22 00:00:00	\N	\N	32020		\N	55559	0	446096008	40486433		0
14286	843	372328	1983-11-22	1983-11-22 00:00:00	1984-04-07	1984-04-07 00:00:00	32020		\N	55852	0	65363002	372328		0
14476	856	40481087	1998-01-15	1998-01-15 00:00:00	1998-02-05	1998-02-05 00:00:00	32020		\N	56538	0	444814009	40481087		0
14634	864	40481087	1950-04-10	1950-04-10 00:00:00	1950-04-24	1950-04-24 00:00:00	32020		\N	57298	0	444814009	40481087		0
14791	870	260139	1979-05-19	1979-05-19 00:00:00	1979-05-26	1979-05-26 00:00:00	32020		\N	57863	0	10509002	260139		0
14996	883	372328	1965-11-21	1965-11-21 00:00:00	1966-05-26	1966-05-26 00:00:00	32020		\N	58816	0	65363002	372328		0
15150	893	40481087	2018-02-11	2018-02-11 00:00:00	2018-03-04	2018-03-04 00:00:00	32020		\N	59456	0	444814009	40481087		0
15297	905	80180	2009-04-29	2009-04-29 00:00:00	\N	\N	32020		\N	60196	0	396275006	80180		0
15453	915	4112343	1979-10-10	1979-10-10 00:00:00	1979-10-20	1979-10-20 00:00:00	32020		\N	60840	0	195662009	4112343		0
15625	924	4112343	2018-06-03	2018-06-03 00:00:00	2018-06-10	2018-06-10 00:00:00	32020		\N	61517	0	195662009	4112343		0
5305	312	81893	2015-08-06	2015-08-06 00:00:00	\N	\N	32020		\N	20669	0	64766004	81893		0
15993	947	40481087	1972-12-03	1972-12-03 00:00:00	1972-12-17	1972-12-17 00:00:00	32020		\N	62869	0	444814009	40481087		0
16153	956	40481087	1936-08-18	1936-08-18 00:00:00	1936-08-25	1936-08-25 00:00:00	32020		\N	63441	0	444814009	40481087		0
5810	341	80180	1995-08-27	1995-08-27 00:00:00	\N	\N	32020		\N	22800	0	396275006	80180		0
16436	971	4112343	1991-04-18	1991-04-18 00:00:00	1991-05-01	1991-05-01 00:00:00	32020		\N	64610	0	195662009	4112343		0
16643	986	81151	1919-12-12	1919-12-12 00:00:00	1920-01-02	1920-01-02 00:00:00	32020		\N	65516	0	44465007	81151		0
6299	370	4112343	1969-02-18	1969-02-18 00:00:00	1969-02-27	1969-02-27 00:00:00	32020		\N	24588	0	195662009	4112343		0
6465	380	40481087	1998-04-22	1998-04-22 00:00:00	1998-04-29	1998-04-29 00:00:00	32020		\N	25143	0	444814009	40481087		0
17160	1025	40481087	2015-01-09	2015-01-09 00:00:00	2015-01-23	2015-01-23 00:00:00	32020		\N	67566	0	444814009	40481087		0
17305	1036	4051466	1971-09-12	1971-09-12 00:00:00	1988-12-13	1988-12-13 00:00:00	32020		\N	68092	0	233678006	4051466		0
6970	410	28060	1957-07-24	1957-07-24 00:00:00	1957-08-03	1957-08-03 00:00:00	32020		\N	27188	0	43878008	28060		0
7137	419	40481087	1916-05-13	1916-05-13 00:00:00	1916-05-27	1916-05-27 00:00:00	32020		\N	27807	0	444814009	40481087		0
17832	1073	40480160	2017-02-14	2017-02-14 00:00:00	2017-04-15	2017-04-15 00:00:00	32020		\N	70305	0	443165006	40480160		0
17943	1079	40481087	2010-12-26	2010-12-26 00:00:00	2011-01-02	2011-01-02 00:00:00	32020		\N	70715	0	444814009	40481087		0
18122	1088	4156265	1988-01-29	1988-01-29 00:00:00	1988-02-19	1988-02-19 00:00:00	32020		\N	71423	0	370247008	4156265		0
7792	455	4278672	1960-02-11	1960-02-11 00:00:00	1960-03-12	1960-03-12 00:00:00	32020		\N	30467	0	65966004	4278672		0
18457	1110	260139	1988-10-11	1988-10-11 00:00:00	1988-10-18	1988-10-18 00:00:00	32020		\N	73100	0	10509002	260139		0
18619	1118	4116491	2003-11-15	2003-11-15 00:00:00	2004-01-12	2004-01-12 00:00:00	32020		\N	73675	0	301011002	4116491		0
18803	1132	4116491	1984-04-26	1984-04-26 00:00:00	1984-06-16	1984-06-16 00:00:00	32020		\N	74493	0	301011002	4116491		0
18927	1137	4112343	1996-06-03	1996-06-03 00:00:00	1996-06-15	1996-06-15 00:00:00	32020		\N	74908	0	195662009	4112343		0
19105	1145	4294548	1952-12-30	1952-12-30 00:00:00	1953-05-12	1953-05-12 00:00:00	32020		\N	75583	0	75498004	4294548		0
19290	1155	260139	1981-03-09	1981-03-09 00:00:00	1981-03-23	1981-03-23 00:00:00	32020		\N	76305	0	10509002	260139		0
19552	1174	40481087	2016-05-05	2016-05-05 00:00:00	2016-05-12	2016-05-12 00:00:00	32020		\N	77348	0	444814009	40481087		0
19624	1176	40481087	1996-05-21	1996-05-21 00:00:00	1996-06-04	1996-06-04 00:00:00	32020		\N	77635	0	444814009	40481087		0
19838	1193	40481087	1957-10-22	1957-10-22 00:00:00	1957-11-12	1957-11-12 00:00:00	32020		\N	78640	0	444814009	40481087		0
19957	1202	40481087	1994-11-02	1994-11-02 00:00:00	1994-11-16	1994-11-16 00:00:00	32020		\N	79058	0	444814009	40481087		0
20157	1214	40481087	1983-01-22	1983-01-22 00:00:00	1983-02-12	1983-02-12 00:00:00	32020		\N	79992	0	444814009	40481087		0
20254	1219	4296204	1968-03-01	1968-03-01 00:00:00	1968-04-05	1968-04-05 00:00:00	32020		\N	80255	0	403190006	4296204		0
20468	1231	40481087	1968-08-05	1968-08-05 00:00:00	1968-08-19	1968-08-19 00:00:00	32020		\N	81070	0	444814009	40481087		0
20634	1239	78272	1991-09-24	1991-09-24 00:00:00	1991-10-08	1991-10-08 00:00:00	32020		\N	81674	0	70704007	78272		0
20756	1246	260139	1943-11-22	1943-11-22 00:00:00	1943-11-29	1943-11-29 00:00:00	32020		\N	82068	0	10509002	260139		0
10454	615	4112343	2004-06-18	2004-06-18 00:00:00	2004-06-27	2004-06-27 00:00:00	32020		\N	40905	0	195662009	4112343		0
21131	1267	260139	1969-10-18	1969-10-18 00:00:00	1969-11-01	1969-11-01 00:00:00	32020		\N	83515	0	10509002	260139		0
152	6	80180	2005-07-13	2005-07-13 00:00:00	\N	\N	32020		\N	562	0	396275006	80180		0
10808	640	40481087	1997-12-20	1997-12-20 00:00:00	1997-12-27	1997-12-27 00:00:00	32020		\N	42371	0	444814009	40481087		0
11017	651	40481087	1994-03-19	1994-03-19 00:00:00	1994-03-26	1994-03-26 00:00:00	32020		\N	43108	0	444814009	40481087		0
11147	656	40481087	1966-10-22	1966-10-22 00:00:00	1966-11-12	1966-11-12 00:00:00	32020		\N	43489	0	444814009	40481087		0
829	43	40481087	2003-06-28	2003-06-28 00:00:00	2003-07-05	2003-07-05 00:00:00	32020		\N	3147	0	444814009	40481087		0
11564	682	4109685	1983-04-12	1983-04-12 00:00:00	1983-04-26	1983-04-26 00:00:00	32020		\N	45199	0	284551006	4109685		0
11637	687	81151	1993-04-04	1993-04-04 00:00:00	1993-04-18	1993-04-18 00:00:00	32020		\N	45492	0	44465007	81151		0
11811	697	28060	1979-11-29	1979-11-29 00:00:00	1979-12-07	1979-12-07 00:00:00	32020		\N	46120	0	43878008	28060		0
11986	709	260139	1987-06-05	1987-06-05 00:00:00	1987-06-19	1987-06-19 00:00:00	32020		\N	46931	0	10509002	260139		0
12166	720	40481087	1998-02-05	1998-02-05 00:00:00	1998-02-26	1998-02-26 00:00:00	32020		\N	47676	0	444814009	40481087		0
12286	727	28060	1920-02-06	1920-02-06 00:00:00	1920-02-17	1920-02-17 00:00:00	32020		\N	48175	0	43878008	28060		0
12475	738	260139	1990-07-04	1990-07-04 00:00:00	1990-07-18	1990-07-18 00:00:00	32020		\N	48867	0	10509002	260139		0
12645	747	40481087	2002-01-27	2002-01-27 00:00:00	2002-02-03	2002-02-03 00:00:00	32020		\N	49445	0	444814009	40481087		0
12849	757	192671	1950-01-22	1950-01-22 00:00:00	\N	\N	32020		\N	50186	0	K92.2	35208414		0
12958	761	28060	1987-01-04	1987-01-04 00:00:00	1987-01-13	1987-01-13 00:00:00	32020		\N	50568	0	43878008	28060		0
13152	774	260139	1991-04-16	1991-04-16 00:00:00	1991-04-23	1991-04-23 00:00:00	32020		\N	51376	0	10509002	260139		0
2820	162	40481087	1957-10-20	1957-10-20 00:00:00	1957-11-10	1957-11-10 00:00:00	32020		\N	11160	0	444814009	40481087		0
13486	795	40481087	2015-10-15	2015-10-15 00:00:00	2015-10-22	2015-10-22 00:00:00	32020		\N	52776	0	444814009	40481087		0
3153	185	80180	1986-01-22	1986-01-22 00:00:00	\N	\N	32020		\N	12536	0	396275006	80180		0
3297	191	40479768	1929-09-12	1929-09-12 00:00:00	1929-11-18	1929-11-18 00:00:00	32020		\N	13038	0	444470001	40479768		0
13945	823	4237458	2011-07-23	2011-07-23 00:00:00	2011-09-21	2011-09-21 00:00:00	32020		\N	54557	0	58150001	4237458		0
14205	841	40481087	1982-06-20	1982-06-20 00:00:00	1982-07-11	1982-07-11 00:00:00	32020		\N	55525	0	444814009	40481087		0
14287	843	28060	1984-02-24	1984-02-24 00:00:00	1984-03-05	1984-03-05 00:00:00	32020		\N	55805	0	43878008	28060		0
14477	856	40481087	2002-07-23	2002-07-23 00:00:00	2002-07-30	2002-07-30 00:00:00	32020		\N	56527	0	444814009	40481087		0
14635	864	378001	1979-11-15	1979-11-15 00:00:00	1980-01-14	1980-01-14 00:00:00	32020		\N	57323	0	62106007	378001		0
14792	870	80180	1998-08-20	1998-08-20 00:00:00	\N	\N	32020		\N	57897	0	396275006	80180		0
14997	883	260139	1986-03-20	1986-03-20 00:00:00	1986-03-27	1986-03-27 00:00:00	32020		\N	58814	0	10509002	260139		0
15151	893	372328	1954-09-16	1954-09-16 00:00:00	1954-11-29	1954-11-29 00:00:00	32020		\N	59457	0	65363002	372328		0
15298	905	4152936	1988-02-23	1988-02-23 00:00:00	1988-03-15	1988-03-15 00:00:00	32020		\N	60194	0	283385000	4152936		0
15454	915	40481087	2005-09-15	2005-09-15 00:00:00	2005-10-06	2005-10-06 00:00:00	32020		\N	60839	0	444814009	40481087		0
15626	924	40481087	2002-11-08	2002-11-08 00:00:00	2002-11-29	2002-11-29 00:00:00	32020		\N	61549	0	444814009	40481087		0
5306	312	4310024	2014-10-10	2014-10-10 00:00:00	\N	\N	32020		\N	20669	0	424802006	4310024		0
15994	947	40481087	1978-09-24	1978-09-24 00:00:00	1978-10-01	1978-10-01 00:00:00	32020		\N	62870	0	444814009	40481087		0
16154	956	28060	1941-11-04	1941-11-04 00:00:00	1941-11-14	1941-11-14 00:00:00	32020		\N	63504	0	43878008	28060		0
16269	962	81893	1993-09-25	1993-09-25 00:00:00	\N	\N	32020		\N	64054	0	64766004	81893		0
16437	971	260139	2010-01-26	2010-01-26 00:00:00	2010-02-02	2010-02-02 00:00:00	32020		\N	64587	0	10509002	260139		0
16644	986	28060	1967-05-23	1967-05-23 00:00:00	1967-06-04	1967-06-04 00:00:00	32020		\N	65508	0	43878008	28060		0
6300	370	40481087	2004-04-24	2004-04-24 00:00:00	2004-05-08	2004-05-08 00:00:00	32020		\N	24631	0	444814009	40481087		0
6466	380	4237458	1986-08-25	1986-08-25 00:00:00	1986-10-24	1986-10-24 00:00:00	32020		\N	25137	0	58150001	4237458		0
17161	1025	78272	1968-03-30	1968-03-30 00:00:00	1968-04-27	1968-04-27 00:00:00	32020		\N	67584	0	70704007	78272		0
17328	1039	81151	1977-08-17	1977-08-17 00:00:00	1977-09-07	1977-09-07 00:00:00	32020		\N	68330	0	44465007	81151		0
6971	410	260139	2004-08-30	2004-08-30 00:00:00	2004-09-13	2004-09-13 00:00:00	32020		\N	27195	0	10509002	260139		0
7138	419	260139	1943-02-22	1943-02-22 00:00:00	1943-03-01	1943-03-01 00:00:00	32020		\N	27752	0	10509002	260139		0
17833	1073	40481087	2005-04-14	2005-04-14 00:00:00	2005-04-21	2005-04-21 00:00:00	32020		\N	70424	0	444814009	40481087		0
17944	1079	40481087	2014-12-31	2014-12-31 00:00:00	2015-01-21	2015-01-21 00:00:00	32020		\N	70733	0	444814009	40481087		0
18123	1088	4027663	2002-07-23	2002-07-23 00:00:00	\N	\N	32020		\N	71431	0	13200003	4027663		0
7793	455	4112343	1981-12-19	1981-12-19 00:00:00	1981-12-28	1981-12-28 00:00:00	32020		\N	30407	0	195662009	4112343		0
18458	1110	80180	2014-11-27	2014-11-27 00:00:00	\N	\N	32020		\N	73136	0	396275006	80180		0
18624	1120	372328	1958-10-28	1958-10-28 00:00:00	1959-02-09	1959-02-09 00:00:00	32020		\N	73800	0	65363002	372328		0
18804	1132	372328	1957-04-13	1957-04-13 00:00:00	1958-04-14	1958-04-14 00:00:00	32020		\N	74512	0	65363002	372328		0
18928	1137	260139	1974-07-27	1974-07-27 00:00:00	1974-08-03	1974-08-03 00:00:00	32020		\N	74881	0	10509002	260139		0
19106	1145	40481087	1976-05-31	1976-05-31 00:00:00	1976-06-21	1976-06-21 00:00:00	32020		\N	75631	0	444814009	40481087		0
19291	1155	40481087	1980-06-08	1980-06-08 00:00:00	1980-06-22	1980-06-22 00:00:00	32020		\N	76328	0	444814009	40481087		0
19553	1174	4112343	2013-06-08	2013-06-08 00:00:00	2013-06-20	2013-06-20 00:00:00	32020		\N	77364	0	195662009	4112343		0
19625	1176	260139	2002-02-24	2002-02-24 00:00:00	2002-03-03	2002-03-03 00:00:00	32020		\N	77636	0	10509002	260139		0
19839	1193	4296204	1984-10-27	1984-10-27 00:00:00	1984-12-01	1984-12-01 00:00:00	32020		\N	78626	0	403190006	4296204		0
19958	1202	78272	2012-07-18	2012-07-18 00:00:00	2012-08-22	2012-08-22 00:00:00	32020		\N	79090	0	70704007	78272		0
20158	1214	40481087	2008-12-20	2008-12-20 00:00:00	2009-01-03	2009-01-03 00:00:00	32020		\N	79924	0	444814009	40481087		0
20255	1219	4112343	1992-10-03	1992-10-03 00:00:00	1992-10-13	1992-10-13 00:00:00	32020		\N	80238	0	195662009	4112343		0
20469	1231	81151	1992-07-26	1992-07-26 00:00:00	1992-08-16	1992-08-16 00:00:00	32020		\N	81118	0	44465007	81151		0
20635	1239	4218389	1980-06-02	1980-06-02 00:00:00	1980-06-23	1980-06-23 00:00:00	32020		\N	81673	0	39848009	4218389		0
20757	1246	260139	1983-08-04	1983-08-04 00:00:00	1983-08-11	1983-08-11 00:00:00	32020		\N	82114	0	10509002	260139		0
10455	615	81151	1944-11-19	1944-11-19 00:00:00	1944-12-17	1944-12-17 00:00:00	32020		\N	41041	0	44465007	81151		0
21132	1267	40481087	2012-08-22	2012-08-22 00:00:00	2012-09-05	2012-09-05 00:00:00	32020		\N	83551	0	444814009	40481087		0
153	6	40481087	1967-05-19	1967-05-19 00:00:00	1967-06-02	1967-06-02 00:00:00	32020		\N	563	0	444814009	40481087		0
10818	642	372328	1935-12-25	1935-12-25 00:00:00	1936-03-08	1936-03-08 00:00:00	32020		\N	42465	0	65363002	372328		0
11018	651	260139	1997-01-22	1997-01-22 00:00:00	1997-02-05	1997-02-05 00:00:00	32020		\N	43101	0	10509002	260139		0
11148	656	40481087	1989-09-18	1989-09-18 00:00:00	1989-10-09	1989-10-09 00:00:00	32020		\N	43445	0	444814009	40481087		0
830	43	372328	1957-03-17	1957-03-17 00:00:00	1957-05-27	1957-05-27 00:00:00	32020		\N	3176	0	65363002	372328		0
11565	682	78272	1972-10-08	1972-10-08 00:00:00	1972-11-05	1972-11-05 00:00:00	32020		\N	45198	0	70704007	78272		0
11638	687	80180	2001-04-07	2001-04-07 00:00:00	\N	\N	32020		\N	45563	0	396275006	80180		0
11812	697	260139	2016-06-24	2016-06-24 00:00:00	2016-07-08	2016-07-08 00:00:00	32020		\N	46124	0	10509002	260139		0
11987	709	40481087	1957-01-13	1957-01-13 00:00:00	1957-02-03	1957-02-03 00:00:00	32020		\N	46923	0	444814009	40481087		0
12167	720	81893	1998-06-17	1998-06-17 00:00:00	\N	\N	32020		\N	47676	0	64766004	81893		0
12287	727	4112343	1934-05-07	1934-05-07 00:00:00	1934-05-16	1934-05-16 00:00:00	32020		\N	48250	0	195662009	4112343		0
12476	738	4112343	2007-02-28	2007-02-28 00:00:00	2007-03-07	2007-03-07 00:00:00	32020		\N	48903	0	195662009	4112343		0
12678	752	260139	1997-10-20	1997-10-20 00:00:00	1997-11-03	1997-11-03 00:00:00	32020		\N	49735	0	10509002	260139		0
12850	757	40481087	1981-04-24	1981-04-24 00:00:00	1981-05-15	1981-05-15 00:00:00	32020		\N	50193	0	444814009	40481087		0
12959	761	260139	2015-03-29	2015-03-29 00:00:00	2015-04-12	2015-04-12 00:00:00	32020		\N	50532	0	10509002	260139		0
13153	774	40481087	1984-09-09	1984-09-09 00:00:00	1984-09-23	1984-09-23 00:00:00	32020		\N	51360	0	444814009	40481087		0
2821	162	4112343	1957-02-02	1957-02-02 00:00:00	1957-02-14	1957-02-14 00:00:00	32020		\N	11159	0	195662009	4112343		0
13487	795	4109685	2000-11-02	2000-11-02 00:00:00	2000-11-16	2000-11-16 00:00:00	32020		\N	52734	0	284551006	4109685		0
3154	185	28060	1982-09-24	1982-09-24 00:00:00	1982-10-07	1982-10-07 00:00:00	32020		\N	12526	0	43878008	28060		0
3298	191	4112343	1957-04-03	1957-04-03 00:00:00	1957-04-16	1957-04-16 00:00:00	32020		\N	13021	0	195662009	4112343		0
13946	823	375671	1998-01-02	1998-01-02 00:00:00	1998-03-03	1998-03-03 00:00:00	32020		\N	54547	0	62564004	375671		0
14206	841	375671	1989-06-21	1989-06-21 00:00:00	1989-08-20	1989-08-20 00:00:00	32020		\N	55571	0	62564004	375671		0
14288	843	28060	1996-02-15	1996-02-15 00:00:00	1996-02-28	1996-02-28 00:00:00	32020		\N	55870	0	43878008	28060		0
14478	856	4112343	2005-04-06	2005-04-06 00:00:00	2005-04-15	2005-04-15 00:00:00	32020		\N	56539	0	195662009	4112343		0
14636	864	40481087	1923-11-25	1923-11-25 00:00:00	1923-12-09	1923-12-09 00:00:00	32020		\N	57292	0	444814009	40481087		0
14793	870	260139	1977-09-15	1977-09-15 00:00:00	1977-09-22	1977-09-22 00:00:00	32020		\N	57885	0	10509002	260139		0
14998	883	4112343	2005-04-26	2005-04-26 00:00:00	2005-05-07	2005-05-07 00:00:00	32020		\N	58795	0	195662009	4112343		0
15152	893	4112343	2004-03-20	2004-03-20 00:00:00	2004-04-01	2004-04-01 00:00:00	32020		\N	59478	0	195662009	4112343		0
15299	905	372328	1989-01-16	1989-01-16 00:00:00	1991-05-18	1991-05-18 00:00:00	32020		\N	60217	0	65363002	372328		0
15455	915	372328	1971-10-11	1971-10-11 00:00:00	1972-09-02	1972-09-02 00:00:00	32020		\N	60844	0	65363002	372328		0
15627	924	40481087	2009-09-30	2009-09-30 00:00:00	2009-10-21	2009-10-21 00:00:00	32020		\N	61562	0	444814009	40481087		0
5307	312	40481087	2010-05-11	2010-05-11 00:00:00	2010-06-01	2010-06-01 00:00:00	32020		\N	20692	0	444814009	40481087		0
15995	947	28060	1974-02-22	1974-02-22 00:00:00	1974-03-06	1974-03-06 00:00:00	32020		\N	62894	0	43878008	28060		0
16155	956	4109685	1969-10-12	1969-10-12 00:00:00	1969-10-26	1969-10-26 00:00:00	32020		\N	63457	0	284551006	4109685		0
16270	962	30753	1993-10-25	1993-10-25 00:00:00	\N	\N	32020		\N	64054	0	16761005	30753		0
16438	971	4146173	1954-10-17	1954-10-17 00:00:00	1954-11-16	1954-11-16 00:00:00	32020		\N	64604	0	307731004	4146173		0
16645	986	4112343	1978-03-12	1978-03-12 00:00:00	1978-03-20	1978-03-20 00:00:00	32020		\N	65452	0	195662009	4112343		0
6301	370	78272	1971-10-06	1971-10-06 00:00:00	1971-10-20	1971-10-20 00:00:00	32020		\N	24583	0	70704007	78272		0
6467	380	80180	2012-06-14	2012-06-14 00:00:00	\N	\N	32020		\N	25134	0	396275006	80180		0
17162	1025	81151	1941-04-18	1941-04-18 00:00:00	1941-05-16	1941-05-16 00:00:00	32020		\N	67580	0	44465007	81151		0
17329	1039	4237458	1978-10-02	1978-10-02 00:00:00	1978-12-01	1978-12-01 00:00:00	32020		\N	68331	0	58150001	4237458		0
6972	410	4112343	1990-05-08	1990-05-08 00:00:00	1990-05-21	1990-05-21 00:00:00	32020		\N	27192	0	195662009	4112343		0
17597	1057	4283893	2016-03-01	2016-03-01 00:00:00	2016-06-07	2016-06-07 00:00:00	32020		\N	69276	0	36971009	4283893		0
17834	1073	440086	1944-06-23	1944-06-23 00:00:00	1945-12-21	1945-12-21 00:00:00	32020		\N	70417	0	192127007	440086		0
17945	1079	4156265	2002-04-02	2002-04-02 00:00:00	2002-04-23	2002-04-23 00:00:00	32020		\N	70771	0	370247008	4156265		0
18124	1088	28060	1984-09-10	1984-09-10 00:00:00	1984-09-23	1984-09-23 00:00:00	32020		\N	71460	0	43878008	28060		0
7794	455	133834	1950-05-08	1950-05-08 00:00:00	1967-08-07	1967-08-07 00:00:00	32020		\N	30402	0	24079001	133834		0
18459	1110	4278672	1992-10-18	1992-10-18 00:00:00	1992-12-17	1992-12-17 00:00:00	32020		\N	73082	0	65966004	4278672		0
18625	1120	4116491	2014-11-18	2014-11-18 00:00:00	2015-01-08	2015-01-08 00:00:00	32020		\N	73790	0	301011002	4116491		0
18805	1132	30753	1992-04-19	1992-04-19 00:00:00	\N	\N	32020		\N	74544	0	16761005	30753		0
18929	1137	40481087	1996-06-01	1996-06-01 00:00:00	1996-06-22	1996-06-22 00:00:00	32020		\N	74884	0	444814009	40481087		0
19107	1145	260139	2002-06-08	2002-06-08 00:00:00	2002-06-15	2002-06-15 00:00:00	32020		\N	75639	0	10509002	260139		0
19292	1155	40481087	1994-06-13	1994-06-13 00:00:00	1994-06-27	1994-06-27 00:00:00	32020		\N	76364	0	444814009	40481087		0
19554	1174	40481087	1952-06-15	1952-06-15 00:00:00	1952-06-29	1952-06-29 00:00:00	32020		\N	77390	0	444814009	40481087		0
19626	1176	40481087	2014-09-02	2014-09-02 00:00:00	2014-09-09	2014-09-09 00:00:00	32020		\N	77721	0	444814009	40481087		0
19840	1193	4142905	1976-01-29	1976-01-29 00:00:00	1976-02-28	1976-02-28 00:00:00	32020		\N	78624	0	33737001	4142905		0
19959	1202	4112343	2013-02-24	2013-02-24 00:00:00	2013-03-07	2013-03-07 00:00:00	32020		\N	79074	0	195662009	4112343		0
20159	1214	40481087	1996-03-28	1996-03-28 00:00:00	1996-04-04	1996-04-04 00:00:00	32020		\N	79907	0	444814009	40481087		0
20256	1219	4112343	1951-05-14	1951-05-14 00:00:00	1951-05-27	1951-05-27 00:00:00	32020		\N	80234	0	195662009	4112343		0
20470	1231	260139	1977-02-04	1977-02-04 00:00:00	1977-02-18	1977-02-18 00:00:00	32020		\N	81083	0	10509002	260139		0
20636	1239	439777	1980-06-22	1980-06-22 00:00:00	\N	\N	32020		\N	81638	0	271737000	439777		0
20758	1246	378419	2012-11-02	2012-11-02 00:00:00	\N	\N	32020		\N	82087	0	26929004	378419		0
10456	615	4084167	1926-12-24	1926-12-24 00:00:00	1926-12-24	1926-12-24 00:00:00	32020		\N	41040	0	241929008	4084167		0
21133	1267	375671	1953-03-04	1953-03-04 00:00:00	1953-05-03	1953-05-03 00:00:00	32020		\N	83563	0	62564004	375671		0
154	6	378001	1984-01-25	1984-01-25 00:00:00	1984-03-25	1984-03-25 00:00:00	32020		\N	558	0	62106007	378001		0
10819	642	372328	1940-07-24	1940-07-24 00:00:00	1940-12-15	1940-12-15 00:00:00	32020		\N	42527	0	65363002	372328		0
11019	651	40481087	1997-10-31	1997-10-31 00:00:00	1997-11-14	1997-11-14 00:00:00	32020		\N	43083	0	444814009	40481087		0
11149	656	40481087	1967-05-18	1967-05-18 00:00:00	1967-06-08	1967-06-08 00:00:00	32020		\N	43459	0	444814009	40481087		0
11311	669	4112343	1977-12-03	1977-12-03 00:00:00	1977-12-14	1977-12-14 00:00:00	32020		\N	44142	0	195662009	4112343		0
11566	682	372328	1974-10-15	1974-10-15 00:00:00	1975-10-29	1975-10-29 00:00:00	32020		\N	45148	0	65363002	372328		0
11639	687	4051466	1970-01-27	1970-01-27 00:00:00	1986-05-08	1986-05-08 00:00:00	32020		\N	45459	0	233678006	4051466		0
11831	700	4155034	2008-09-05	2008-09-05 00:00:00	2008-09-26	2008-09-26 00:00:00	32020		\N	46232	0	283371005	4155034		0
11988	709	260139	1977-09-16	1977-09-16 00:00:00	1977-09-23	1977-09-23 00:00:00	32020		\N	46925	0	10509002	260139		0
12168	720	28060	2001-09-13	2001-09-13 00:00:00	2001-09-23	2001-09-23 00:00:00	32020		\N	47618	0	43878008	28060		0
12288	727	40481087	1952-05-16	1952-05-16 00:00:00	1952-05-30	1952-05-30 00:00:00	32020		\N	48252	0	444814009	40481087		0
12477	738	4112343	1986-08-22	1986-08-22 00:00:00	1986-09-04	1986-09-04 00:00:00	32020		\N	48866	0	195662009	4112343		0
12679	752	80180	1991-03-19	1991-03-19 00:00:00	\N	\N	32020		\N	49714	0	396275006	80180		0
12851	757	4112343	1964-01-04	1964-01-04 00:00:00	1964-01-15	1964-01-15 00:00:00	32020		\N	50192	0	195662009	4112343		0
12960	761	40481087	1982-08-05	1982-08-05 00:00:00	1982-08-12	1982-08-12 00:00:00	32020		\N	50565	0	444814009	40481087		0
13154	774	260139	2017-05-15	2017-05-15 00:00:00	2017-05-29	2017-05-29 00:00:00	32020		\N	51395	0	10509002	260139		0
2822	162	4116491	1976-11-12	1976-11-12 00:00:00	1976-12-20	1976-12-20 00:00:00	32020		\N	11095	0	301011002	4116491		0
13488	795	4285898	1981-09-27	1981-09-27 00:00:00	\N	\N	32020		\N	52792	0	68496003	4285898		0
13642	806	80180	1997-12-05	1997-12-05 00:00:00	\N	\N	32020		\N	53497	0	396275006	80180		0
3299	191	4059173	1994-05-07	1994-05-07 00:00:00	1994-08-05	1994-08-05 00:00:00	32020		\N	13042	0	16114001	4059173		0
13947	823	78272	1949-10-25	1949-10-25 00:00:00	1949-11-15	1949-11-15 00:00:00	32020		\N	54544	0	70704007	78272		0
14207	841	40481087	1955-12-31	1955-12-31 00:00:00	1956-01-21	1956-01-21 00:00:00	32020		\N	55512	0	444814009	40481087		0
14289	843	260139	1983-07-26	1983-07-26 00:00:00	1983-08-02	1983-08-02 00:00:00	32020		\N	55787	0	10509002	260139		0
14479	856	80180	2006-02-24	2006-02-24 00:00:00	\N	\N	32020		\N	56539	0	396275006	80180		0
14637	864	40481087	1992-07-11	1992-07-11 00:00:00	1992-08-01	1992-08-01 00:00:00	32020		\N	57300	0	444814009	40481087		0
14794	870	78272	1978-02-01	1978-02-01 00:00:00	1978-02-15	1978-02-15 00:00:00	32020		\N	57892	0	70704007	78272		0
14999	884	81151	1982-09-17	1982-09-17 00:00:00	1982-10-22	1982-10-22 00:00:00	32020		\N	58928	0	44465007	81151		0
15153	893	40481087	1994-02-15	1994-02-15 00:00:00	1994-02-22	1994-02-22 00:00:00	32020		\N	59453	0	444814009	40481087		0
15300	905	372328	1972-02-03	1972-02-03 00:00:00	1972-02-26	1972-02-26 00:00:00	32020		\N	60158	0	65363002	372328		0
15456	915	4156265	2018-03-19	2018-03-19 00:00:00	2018-04-02	2018-04-02 00:00:00	32020		\N	60788	0	370247008	4156265		0
15628	924	4294548	2018-09-11	2018-09-11 00:00:00	2018-09-18	2018-09-18 00:00:00	32020		\N	61518	0	75498004	4294548		0
5308	312	372328	1985-01-15	1985-01-15 00:00:00	1985-01-29	1985-01-29 00:00:00	32020		\N	20662	0	65363002	372328		0
15996	947	40481087	1993-11-15	1993-11-15 00:00:00	1993-12-06	1993-12-06 00:00:00	32020		\N	62871	0	444814009	40481087		0
16156	956	40481087	1936-02-07	1936-02-07 00:00:00	1936-02-14	1936-02-14 00:00:00	32020		\N	63440	0	444814009	40481087		0
16271	962	40481087	1979-03-11	1979-03-11 00:00:00	1979-03-18	1979-03-18 00:00:00	32020		\N	64027	0	444814009	40481087		0
16439	971	372328	1946-01-02	1946-01-02 00:00:00	1946-04-19	1946-04-19 00:00:00	32020		\N	64588	0	65363002	372328		0
16646	986	378419	1990-09-22	1990-09-22 00:00:00	\N	\N	32020		\N	65493	0	26929004	378419		0
6302	370	4112343	2014-07-31	2014-07-31 00:00:00	2014-08-11	2014-08-11 00:00:00	32020		\N	24633	0	195662009	4112343		0
6468	380	4112343	2008-08-24	2008-08-24 00:00:00	2008-09-04	2008-09-04 00:00:00	32020		\N	25131	0	195662009	4112343		0
17163	1025	260139	1958-03-10	1958-03-10 00:00:00	1958-03-17	1958-03-17 00:00:00	32020		\N	67541	0	10509002	260139		0
17330	1039	260139	1995-06-15	1995-06-15 00:00:00	1995-06-29	1995-06-29 00:00:00	32020		\N	68340	0	10509002	260139		0
17467	1051	4283893	2012-02-03	2012-02-03 00:00:00	2012-10-19	2012-10-19 00:00:00	32020		\N	68944	0	36971009	4283893		0
17598	1057	257012	2016-04-19	2016-04-19 00:00:00	\N	\N	32020		\N	69292	0	40055000	257012		0
17835	1073	40481087	2008-11-08	2008-11-08 00:00:00	2008-11-22	2008-11-22 00:00:00	32020		\N	70391	0	444814009	40481087		0
17946	1079	81151	1962-02-12	1962-02-12 00:00:00	1962-02-26	1962-02-26 00:00:00	32020		\N	70768	0	44465007	81151		0
18138	1091	28060	2017-02-26	2017-02-26 00:00:00	2017-03-08	2017-03-08 00:00:00	32020		\N	71650	0	43878008	28060		0
7795	455	260139	1966-04-30	1966-04-30 00:00:00	1966-05-14	1966-05-14 00:00:00	32020		\N	30456	0	10509002	260139		0
18460	1110	40481087	1991-10-15	1991-10-15 00:00:00	1991-10-22	1991-10-22 00:00:00	32020		\N	73027	0	444814009	40481087		0
18626	1120	4116491	2016-01-08	2016-01-08 00:00:00	2016-02-24	2016-02-24 00:00:00	32020		\N	73799	0	301011002	4116491		0
18806	1132	4285898	1993-02-13	1993-02-13 00:00:00	\N	\N	32020		\N	74544	0	68496003	4285898		0
18930	1137	40481087	1984-02-25	1984-02-25 00:00:00	1984-03-03	1984-03-03 00:00:00	32020		\N	74982	0	444814009	40481087		0
19108	1145	40481087	1998-01-27	1998-01-27 00:00:00	1998-02-17	1998-02-17 00:00:00	32020		\N	75634	0	444814009	40481087		0
19293	1155	4112343	1995-10-15	1995-10-15 00:00:00	1995-10-27	1995-10-27 00:00:00	32020		\N	76315	0	195662009	4112343		0
19555	1174	40481087	2015-08-19	2015-08-19 00:00:00	2015-09-02	2015-09-02 00:00:00	32020		\N	77347	0	444814009	40481087		0
19627	1176	40481087	2005-04-15	2005-04-15 00:00:00	2005-05-06	2005-05-06 00:00:00	32020		\N	77690	0	444814009	40481087		0
19841	1193	78272	1953-09-04	1953-09-04 00:00:00	1953-09-18	1953-09-18 00:00:00	32020		\N	78618	0	70704007	78272		0
19960	1202	4112343	1992-08-07	1992-08-07 00:00:00	1992-08-19	1992-08-19 00:00:00	32020		\N	79070	0	195662009	4112343		0
20160	1214	4294548	1997-06-02	1997-06-02 00:00:00	1997-06-16	1997-06-16 00:00:00	32020		\N	79903	0	75498004	4294548		0
20257	1219	4112343	1952-09-20	1952-09-20 00:00:00	1952-10-03	1952-10-03 00:00:00	32020		\N	80235	0	195662009	4112343		0
20471	1231	4112343	2018-09-23	2018-09-23 00:00:00	2018-10-04	2018-10-04 00:00:00	32020		\N	81111	0	195662009	4112343		0
20637	1239	4294548	1972-08-22	1972-08-22 00:00:00	1972-09-19	1972-09-19 00:00:00	32020		\N	81668	0	75498004	4294548		0
20759	1246	40481087	2006-07-08	2006-07-08 00:00:00	2006-07-22	2006-07-22 00:00:00	32020		\N	82015	0	444814009	40481087		0
10457	615	40481087	2009-10-20	2009-10-20 00:00:00	2009-11-10	2009-11-10 00:00:00	32020		\N	40919	0	444814009	40481087		0
21134	1267	260139	2004-02-26	2004-02-26 00:00:00	2004-03-11	2004-03-11 00:00:00	32020		\N	83521	0	10509002	260139		0
155	7	4237458	1974-08-12	1974-08-12 00:00:00	1974-09-11	1974-09-11 00:00:00	32020		\N	631	0	58150001	4237458		0
10820	642	260139	1950-06-06	1950-06-06 00:00:00	1950-06-13	1950-06-13 00:00:00	32020		\N	42518	0	10509002	260139		0
11020	651	4283893	1981-07-21	1981-07-21 00:00:00	1981-11-10	1981-11-10 00:00:00	32020		\N	43082	0	36971009	4283893		0
11150	656	440448	1996-12-28	1996-12-28 00:00:00	\N	\N	32020		\N	43424	0	74400008	440448		0
11312	669	258780	2018-11-21	2018-11-21 00:00:00	\N	\N	32020		\N	44192	0	185086009	258780		0
11567	682	372328	1972-07-10	1972-07-10 00:00:00	1972-10-25	1972-10-25 00:00:00	32020		\N	45159	0	65363002	372328		0
11640	687	4237458	1984-07-20	1984-07-20 00:00:00	1984-09-18	1984-09-18 00:00:00	32020		\N	45490	0	58150001	4237458		0
11832	700	260139	2003-05-06	2003-05-06 00:00:00	2003-05-13	2003-05-13 00:00:00	32020		\N	46241	0	10509002	260139		0
11989	709	4112343	1979-02-26	1979-02-26 00:00:00	1979-03-06	1979-03-06 00:00:00	32020		\N	46976	0	195662009	4112343		0
12169	720	195588	1998-08-21	1998-08-21 00:00:00	1998-09-24	1998-09-24 00:00:00	32020		\N	47667	0	38822007	195588		0
12289	727	4152936	2013-10-24	2013-10-24 00:00:00	2013-11-07	2013-11-07 00:00:00	32020		\N	48221	0	283385000	4152936		0
12478	738	260139	1978-08-04	1978-08-04 00:00:00	1978-08-18	1978-08-18 00:00:00	32020		\N	48864	0	10509002	260139		0
12680	752	4112343	1960-06-03	1960-06-03 00:00:00	1960-06-12	1960-06-12 00:00:00	32020		\N	49654	0	195662009	4112343		0
12852	757	4218389	1940-10-22	1940-10-22 00:00:00	1940-11-19	1940-11-19 00:00:00	32020		\N	50286	0	39848009	4218389		0
12961	761	40481087	2006-01-21	2006-01-21 00:00:00	2006-02-11	2006-02-11 00:00:00	32020		\N	50530	0	444814009	40481087		0
13155	775	40481087	1941-04-09	1941-04-09 00:00:00	1941-04-16	1941-04-16 00:00:00	32020		\N	51452	0	444814009	40481087		0
13281	782	4112343	1960-10-28	1960-10-28 00:00:00	1960-11-08	1960-11-08 00:00:00	32020		\N	51981	0	195662009	4112343		0
13489	795	80180	1982-08-23	1982-08-23 00:00:00	\N	\N	32020		\N	52792	0	396275006	80180		0
13643	806	4112343	2010-11-09	2010-11-09 00:00:00	2010-11-21	2010-11-21 00:00:00	32020		\N	53516	0	195662009	4112343		0
3300	191	260139	2002-03-09	2002-03-09 00:00:00	2002-03-16	2002-03-16 00:00:00	32020		\N	13143	0	10509002	260139		0
13948	823	40481087	1995-04-06	1995-04-06 00:00:00	1995-04-13	1995-04-13 00:00:00	32020		\N	54587	0	444814009	40481087		0
14208	841	4112343	1958-05-17	1958-05-17 00:00:00	1958-05-27	1958-05-27 00:00:00	32020		\N	55513	0	195662009	4112343		0
14290	843	378001	2009-07-08	2009-07-08 00:00:00	2009-09-06	2009-09-06 00:00:00	32020		\N	55770	0	62106007	378001		0
14480	856	78272	1984-12-28	1984-12-28 00:00:00	1985-01-25	1985-01-25 00:00:00	32020		\N	56518	0	70704007	78272		0
14638	864	40481087	1925-04-08	1925-04-08 00:00:00	1925-04-29	1925-04-29 00:00:00	32020		\N	57259	0	444814009	40481087		0
14795	870	257012	1968-09-17	1968-09-17 00:00:00	\N	\N	32020		\N	57906	0	40055000	257012		0
15000	884	260139	2006-07-11	2006-07-11 00:00:00	2006-07-25	2006-07-25 00:00:00	32020		\N	58919	0	10509002	260139		0
15154	893	4112343	1964-08-26	1964-08-26 00:00:00	1964-09-04	1964-09-04 00:00:00	32020		\N	59473	0	195662009	4112343		0
15301	905	4296204	2019-03-29	2019-03-29 00:00:00	2019-04-26	2019-04-26 00:00:00	32020		\N	60197	0	403190006	4296204		0
15457	915	4112343	1989-01-02	1989-01-02 00:00:00	1989-01-10	1989-01-10 00:00:00	32020		\N	60837	0	195662009	4112343		0
15629	925	4237458	2018-02-01	2018-02-01 00:00:00	2018-03-03	2018-03-03 00:00:00	32020		\N	61642	0	58150001	4237458		0
5309	312	260139	2009-05-30	2009-05-30 00:00:00	2009-06-06	2009-06-06 00:00:00	32020		\N	20676	0	10509002	260139		0
15997	947	260139	2002-07-24	2002-07-24 00:00:00	2002-07-31	2002-07-31 00:00:00	32020		\N	62845	0	10509002	260139		0
16157	956	40481087	2009-01-15	2009-01-15 00:00:00	2009-01-29	2009-01-29 00:00:00	32020		\N	63445	0	444814009	40481087		0
16272	962	40481087	1975-02-04	1975-02-04 00:00:00	1975-02-25	1975-02-25 00:00:00	32020		\N	64082	0	444814009	40481087		0
16440	971	80180	1980-09-15	1980-09-15 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
16647	986	40481087	1953-03-11	1953-03-11 00:00:00	1953-04-01	1953-04-01 00:00:00	32020		\N	65450	0	444814009	40481087		0
6303	370	40481087	1968-07-04	1968-07-04 00:00:00	1968-07-11	1968-07-11 00:00:00	32020		\N	24596	0	444814009	40481087		0
6469	380	372328	1973-03-14	1973-03-14 00:00:00	1973-04-20	1973-04-20 00:00:00	32020		\N	25129	0	65363002	372328		0
17164	1025	40481087	1956-10-04	1956-10-04 00:00:00	1956-10-18	1956-10-18 00:00:00	32020		\N	67545	0	444814009	40481087		0
17331	1039	372328	1965-04-28	1965-04-28 00:00:00	1966-03-05	1966-03-05 00:00:00	32020		\N	68342	0	65363002	372328		0
17468	1051	40481087	1982-03-27	1982-03-27 00:00:00	1982-04-10	1982-04-10 00:00:00	32020		\N	68879	0	444814009	40481087		0
17599	1057	81151	1991-10-25	1991-10-25 00:00:00	1991-11-15	1991-11-15 00:00:00	32020		\N	69303	0	44465007	81151		0
17836	1073	4152936	1953-10-24	1953-10-24 00:00:00	1953-11-07	1953-11-07 00:00:00	32020		\N	70301	0	283385000	4152936		0
17947	1079	40481087	1983-05-30	1983-05-30 00:00:00	1983-06-06	1983-06-06 00:00:00	32020		\N	70711	0	444814009	40481087		0
18139	1091	40481087	1975-04-20	1975-04-20 00:00:00	1975-05-04	1975-05-04 00:00:00	32020		\N	71676	0	444814009	40481087		0
7796	455	378001	1997-10-24	1997-10-24 00:00:00	1997-11-23	1997-11-23 00:00:00	32020		\N	30470	0	62106007	378001		0
18461	1110	4084167	1983-04-09	1983-04-09 00:00:00	1983-04-09	1983-04-09 00:00:00	32020		\N	73118	0	241929008	4084167		0
18627	1120	4112343	1966-03-23	1966-03-23 00:00:00	1966-04-01	1966-04-01 00:00:00	32020		\N	73786	0	195662009	4112343		0
18807	1132	260139	1972-08-23	1972-08-23 00:00:00	1972-08-30	1972-08-30 00:00:00	32020		\N	74491	0	10509002	260139		0
18931	1137	40481087	1987-04-07	1987-04-07 00:00:00	1987-04-14	1987-04-14 00:00:00	32020		\N	74883	0	444814009	40481087		0
19109	1145	260139	1948-12-30	1948-12-30 00:00:00	1949-01-06	1949-01-06 00:00:00	32020		\N	75540	0	10509002	260139		0
19294	1155	40481087	2002-03-25	2002-03-25 00:00:00	2002-04-01	2002-04-01 00:00:00	32020		\N	76330	0	444814009	40481087		0
19556	1174	4155034	1941-11-03	1941-11-03 00:00:00	1941-11-24	1941-11-24 00:00:00	32020		\N	77371	0	283371005	4155034		0
19628	1176	40481087	1992-10-08	1992-10-08 00:00:00	1992-10-15	1992-10-15 00:00:00	32020		\N	77686	0	444814009	40481087		0
19842	1193	81151	2000-02-11	2000-02-11 00:00:00	2000-03-03	2000-03-03 00:00:00	32020		\N	78627	0	44465007	81151		0
19961	1202	4112343	1989-12-07	1989-12-07 00:00:00	1989-12-19	1989-12-19 00:00:00	32020		\N	79060	0	195662009	4112343		0
20161	1214	80180	1978-01-07	1978-01-07 00:00:00	\N	\N	32020		\N	79979	0	396275006	80180		0
20258	1219	40481087	2008-04-23	2008-04-23 00:00:00	2008-05-14	2008-05-14 00:00:00	32020		\N	80239	0	444814009	40481087		0
20472	1231	4142905	2000-11-01	2000-11-01 00:00:00	2001-01-30	2001-01-30 00:00:00	32020		\N	81119	0	33737001	4142905		0
20638	1239	372328	1972-11-11	1972-11-11 00:00:00	1972-11-25	1972-11-25 00:00:00	32020		\N	81676	0	65363002	372328		0
20760	1246	260139	1971-09-30	1971-09-30 00:00:00	1971-10-07	1971-10-07 00:00:00	32020		\N	82041	0	10509002	260139		0
10458	615	4296204	2019-06-27	2019-06-27 00:00:00	\N	\N	32020		\N	41048	0	403190006	4296204		0
21135	1267	260139	1981-01-17	1981-01-17 00:00:00	1981-01-31	1981-01-31 00:00:00	32020		\N	83599	0	10509002	260139		0
156	7	78272	1969-10-02	1969-10-02 00:00:00	1969-10-23	1969-10-23 00:00:00	32020		\N	635	0	70704007	78272		0
10821	642	28060	1972-01-28	1972-01-28 00:00:00	1972-02-07	1972-02-07 00:00:00	32020		\N	42537	0	43878008	28060		0
11021	651	80180	2012-04-11	2012-04-11 00:00:00	\N	\N	32020		\N	43096	0	396275006	80180		0
11196	662	4112343	1999-12-22	1999-12-22 00:00:00	2000-01-02	2000-01-02 00:00:00	32020		\N	43700	0	195662009	4112343		0
11313	669	40481087	1972-02-27	1972-02-27 00:00:00	1972-03-05	1972-03-05 00:00:00	32020		\N	44162	0	444814009	40481087		0
11568	682	4112343	1994-03-28	1994-03-28 00:00:00	1994-04-08	1994-04-08 00:00:00	32020		\N	45157	0	195662009	4112343		0
11641	687	4112343	1968-03-18	1968-03-18 00:00:00	1968-03-26	1968-03-26 00:00:00	32020		\N	45509	0	195662009	4112343		0
11833	700	4066995	1997-06-04	1997-06-04 00:00:00	1997-07-05	1997-07-05 00:00:00	32020		\N	46231	0	1734006	4066995		0
11990	709	260139	1973-11-24	1973-11-24 00:00:00	1973-12-08	1973-12-08 00:00:00	32020		\N	46964	0	10509002	260139		0
12170	720	40481087	1972-02-18	1972-02-18 00:00:00	1972-02-25	1972-02-25 00:00:00	32020		\N	47656	0	444814009	40481087		0
12290	727	4112343	2007-12-20	2007-12-20 00:00:00	2007-12-28	2007-12-28 00:00:00	32020		\N	48177	0	195662009	4112343		0
12479	738	4109685	1990-08-21	1990-08-21 00:00:00	1990-09-04	1990-09-04 00:00:00	32020		\N	48890	0	284551006	4109685		0
12681	752	40481087	1982-05-05	1982-05-05 00:00:00	1982-05-19	1982-05-19 00:00:00	32020		\N	49733	0	444814009	40481087		0
12853	757	81151	1988-10-13	1988-10-13 00:00:00	1988-11-17	1988-11-17 00:00:00	32020		\N	50289	0	44465007	81151		0
12962	762	28060	2003-08-19	2003-08-19 00:00:00	2003-09-01	2003-09-01 00:00:00	32020		\N	50710	0	43878008	28060		0
13156	775	4283893	1962-09-02	1962-09-02 00:00:00	1962-09-16	1962-09-16 00:00:00	32020		\N	51418	0	36971009	4283893		0
13282	782	260139	1963-11-14	1963-11-14 00:00:00	1963-11-28	1963-11-28 00:00:00	32020		\N	51982	0	10509002	260139		0
13490	795	4266809	1982-08-23	1982-08-23 00:00:00	\N	\N	32020		\N	52792	0	397881000	4266809		0
13644	806	4112343	1960-07-13	1960-07-13 00:00:00	1960-07-21	1960-07-21 00:00:00	32020		\N	53501	0	195662009	4112343		0
3301	191	28060	1924-12-24	1924-12-24 00:00:00	1925-01-06	1925-01-06 00:00:00	32020		\N	13055	0	43878008	28060		0
13949	823	40480160	2013-07-12	2013-07-12 00:00:00	2013-09-10	2013-09-10 00:00:00	32020		\N	54558	0	443165006	40480160		0
14209	841	40481087	1997-04-07	1997-04-07 00:00:00	1997-04-28	1997-04-28 00:00:00	32020		\N	55575	0	444814009	40481087		0
14291	843	4112343	1986-12-23	1986-12-23 00:00:00	1986-12-30	1986-12-30 00:00:00	32020		\N	55788	0	195662009	4112343		0
14481	856	40481087	1971-08-07	1971-08-07 00:00:00	1971-08-14	1971-08-14 00:00:00	32020		\N	56552	0	444814009	40481087		0
14639	864	4112343	1973-01-01	1973-01-01 00:00:00	1973-01-13	1973-01-13 00:00:00	32020		\N	57312	0	195662009	4112343		0
14796	870	28060	1970-04-17	1970-04-17 00:00:00	1970-04-30	1970-04-30 00:00:00	32020		\N	57904	0	43878008	28060		0
15001	884	260139	2013-11-26	2013-11-26 00:00:00	2013-12-03	2013-12-03 00:00:00	32020		\N	58932	0	10509002	260139		0
15155	893	192671	1993-11-09	1993-11-09 00:00:00	\N	\N	32020		\N	59484	0	K92.2	35208414		0
15302	905	4283893	1982-12-10	1982-12-10 00:00:00	1982-12-24	1982-12-24 00:00:00	32020		\N	60214	0	36971009	4283893		0
15458	915	40481087	2008-06-27	2008-06-27 00:00:00	2008-07-18	2008-07-18 00:00:00	32020		\N	60864	0	444814009	40481087		0
15630	925	260139	2007-04-30	2007-04-30 00:00:00	2007-05-14	2007-05-14 00:00:00	32020		\N	61586	0	10509002	260139		0
5310	312	4294548	2000-06-26	2000-06-26 00:00:00	2000-10-23	2000-10-23 00:00:00	32020		\N	20712	0	75498004	4294548		0
15998	947	260139	2008-05-02	2008-05-02 00:00:00	2008-05-16	2008-05-16 00:00:00	32020		\N	62872	0	10509002	260139		0
16158	956	40481087	2017-06-18	2017-06-18 00:00:00	2017-07-09	2017-07-09 00:00:00	32020		\N	63518	0	444814009	40481087		0
16273	962	4134304	1964-03-27	1964-03-27 00:00:00	1964-04-26	1964-04-26 00:00:00	32020		\N	64026	0	263102004	4134304		0
16441	971	378001	2005-07-24	2005-07-24 00:00:00	2005-08-23	2005-08-23 00:00:00	32020		\N	64583	0	62106007	378001		0
16648	986	40481087	1982-06-10	1982-06-10 00:00:00	1982-06-17	1982-06-17 00:00:00	32020		\N	65429	0	444814009	40481087		0
6304	370	40481087	1966-09-18	1966-09-18 00:00:00	1966-09-25	1966-09-25 00:00:00	32020		\N	24587	0	444814009	40481087		0
16977	1015	40481087	2009-12-29	2009-12-29 00:00:00	2010-01-05	2010-01-05 00:00:00	32020		\N	66837	0	444814009	40481087		0
17165	1025	260139	1956-09-28	1956-09-28 00:00:00	1956-10-05	1956-10-05 00:00:00	32020		\N	67570	0	10509002	260139		0
17332	1039	40481087	1991-06-01	1991-06-01 00:00:00	1991-06-15	1991-06-15 00:00:00	32020		\N	68339	0	444814009	40481087		0
17469	1051	80180	2001-03-17	2001-03-17 00:00:00	\N	\N	32020		\N	68950	0	396275006	80180		0
17600	1057	40481087	2012-01-01	2012-01-01 00:00:00	2012-01-15	2012-01-15 00:00:00	32020		\N	69311	0	444814009	40481087		0
17837	1073	80180	1974-04-02	1974-04-02 00:00:00	\N	\N	32020		\N	70394	0	396275006	80180		0
17948	1079	28060	1970-10-15	1970-10-15 00:00:00	1970-10-27	1970-10-27 00:00:00	32020		\N	70757	0	43878008	28060		0
18140	1091	4112343	1976-07-29	1976-07-29 00:00:00	1976-08-10	1976-08-10 00:00:00	32020		\N	71677	0	195662009	4112343		0
7797	455	260139	1985-08-10	1985-08-10 00:00:00	1985-08-17	1985-08-17 00:00:00	32020		\N	30399	0	10509002	260139		0
18462	1110	40481087	2001-05-29	2001-05-29 00:00:00	2001-06-19	2001-06-19 00:00:00	32020		\N	73110	0	444814009	40481087		0
18628	1120	4112343	1989-11-22	1989-11-22 00:00:00	1989-12-04	1989-12-04 00:00:00	32020		\N	73861	0	195662009	4112343		0
18808	1132	40479768	1963-04-12	1963-04-12 00:00:00	1963-06-18	1963-06-18 00:00:00	32020		\N	74510	0	444470001	40479768		0
18932	1137	40481087	1969-06-24	1969-06-24 00:00:00	1969-07-15	1969-07-15 00:00:00	32020		\N	74980	0	444814009	40481087		0
19110	1145	260139	1968-11-28	1968-11-28 00:00:00	1968-12-05	1968-12-05 00:00:00	32020		\N	75630	0	10509002	260139		0
19295	1155	260139	2007-10-19	2007-10-19 00:00:00	2007-11-02	2007-11-02 00:00:00	32020		\N	76331	0	10509002	260139		0
19557	1174	260139	2016-05-29	2016-05-29 00:00:00	2016-06-12	2016-06-12 00:00:00	32020		\N	77365	0	10509002	260139		0
19629	1176	4296204	1967-08-24	1967-08-24 00:00:00	1967-09-28	1967-09-28 00:00:00	32020		\N	77643	0	403190006	4296204		0
19843	1193	260139	1979-12-05	1979-12-05 00:00:00	1979-12-12	1979-12-12 00:00:00	32020		\N	78667	0	10509002	260139		0
19962	1202	4116491	2013-06-28	2013-06-28 00:00:00	2013-08-21	2013-08-21 00:00:00	32020		\N	79068	0	301011002	4116491		0
20162	1214	260139	1954-02-17	1954-02-17 00:00:00	1954-03-03	1954-03-03 00:00:00	32020		\N	79947	0	10509002	260139		0
20259	1219	4112343	1989-03-07	1989-03-07 00:00:00	1989-03-20	1989-03-20 00:00:00	32020		\N	80212	0	195662009	4112343		0
20473	1231	260139	1960-07-15	1960-07-15 00:00:00	1960-07-29	1960-07-29 00:00:00	32020		\N	81153	0	10509002	260139		0
20639	1239	257012	1987-10-05	1987-10-05 00:00:00	\N	\N	32020		\N	81660	0	40055000	257012		0
20761	1246	372328	1939-04-16	1939-04-16 00:00:00	1939-07-28	1939-07-28 00:00:00	32020		\N	82155	0	65363002	372328		0
20928	1257	4112343	1973-05-29	1973-05-29 00:00:00	1973-06-10	1973-06-10 00:00:00	32020		\N	82802	0	195662009	4112343		0
21136	1267	40481087	1961-01-13	1961-01-13 00:00:00	1961-01-27	1961-01-27 00:00:00	32020		\N	83513	0	444814009	40481087		0
157	7	260139	2001-07-18	2001-07-18 00:00:00	2001-08-01	2001-08-01 00:00:00	32020		\N	625	0	10509002	260139		0
10822	642	260139	1995-12-03	1995-12-03 00:00:00	1995-12-10	1995-12-10 00:00:00	32020		\N	42540	0	10509002	260139		0
11022	651	4266809	2012-04-11	2012-04-11 00:00:00	\N	\N	32020		\N	43096	0	397881000	4266809		0
11197	662	40481087	1979-09-01	1979-09-01 00:00:00	1979-09-15	1979-09-15 00:00:00	32020		\N	43742	0	444814009	40481087		0
11314	669	4112343	2014-10-28	2014-10-28 00:00:00	2014-11-04	2014-11-04 00:00:00	32020		\N	44182	0	195662009	4112343		0
11569	682	40481087	1988-09-09	1988-09-09 00:00:00	1988-09-23	1988-09-23 00:00:00	32020		\N	45147	0	444814009	40481087		0
11642	687	260139	1974-12-12	1974-12-12 00:00:00	1974-12-26	1974-12-26 00:00:00	32020		\N	45460	0	10509002	260139		0
11834	700	44782520	1997-06-04	1997-06-04 00:00:00	\N	\N	32020		\N	46231	0	698754002	44782520		0
11991	709	80180	1988-07-13	1988-07-13 00:00:00	\N	\N	32020		\N	46927	0	396275006	80180		0
12171	720	4283893	1966-03-30	1966-03-30 00:00:00	1966-11-09	1966-11-09 00:00:00	32020		\N	47673	0	36971009	4283893		0
12291	727	40481087	1930-01-04	1930-01-04 00:00:00	1930-01-25	1930-01-25 00:00:00	32020		\N	48249	0	444814009	40481087		0
12480	738	28060	1989-08-21	1989-08-21 00:00:00	1989-08-28	1989-08-28 00:00:00	32020		\N	48891	0	43878008	28060		0
12682	752	260139	1952-12-09	1952-12-09 00:00:00	1952-12-23	1952-12-23 00:00:00	32020		\N	49701	0	10509002	260139		0
12854	757	4027663	1939-11-02	1939-11-02 00:00:00	\N	\N	32020		\N	50281	0	13200003	4027663		0
12963	762	4113008	2007-04-28	2007-04-28 00:00:00	2007-05-12	2007-05-12 00:00:00	32020		\N	50731	0	284549007	4113008		0
13157	775	4296204	2000-02-20	2000-02-20 00:00:00	2000-03-19	2000-03-19 00:00:00	32020		\N	51451	0	403190006	4296204		0
13283	782	40481087	1951-03-09	1951-03-09 00:00:00	1951-03-23	1951-03-23 00:00:00	32020		\N	51993	0	444814009	40481087		0
13491	795	30753	1980-12-01	1980-12-01 00:00:00	\N	\N	32020		\N	52792	0	16761005	30753		0
13645	806	260139	1983-09-05	1983-09-05 00:00:00	1983-09-12	1983-09-12 00:00:00	32020		\N	53502	0	10509002	260139		0
3302	191	4283893	1922-11-09	1922-11-09 00:00:00	1923-03-08	1923-03-08 00:00:00	32020		\N	13096	0	36971009	4283893		0
13950	823	4230399	2013-07-12	2013-07-12 00:00:00	2013-09-10	2013-09-10 00:00:00	32020		\N	54558	0	359817006	4230399		0
14211	841	40481087	1997-09-04	1997-09-04 00:00:00	1997-09-25	1997-09-25 00:00:00	32020		\N	55564	0	444814009	40481087		0
14292	843	4112343	2016-04-17	2016-04-17 00:00:00	2016-04-30	2016-04-30 00:00:00	32020		\N	55855	0	195662009	4112343		0
14482	856	4059173	2011-09-06	2011-09-06 00:00:00	2011-10-06	2011-10-06 00:00:00	32020		\N	56576	0	16114001	4059173		0
14640	864	81151	1963-09-26	1963-09-26 00:00:00	1963-10-10	1963-10-10 00:00:00	32020		\N	57322	0	44465007	81151		0
14797	870	4112343	2013-04-29	2013-04-29 00:00:00	2013-05-06	2013-05-06 00:00:00	32020		\N	57913	0	195662009	4112343		0
15002	884	40481087	2007-11-27	2007-11-27 00:00:00	2007-12-18	2007-12-18 00:00:00	32020		\N	58855	0	444814009	40481087		0
15156	893	4218389	1996-01-30	1996-01-30 00:00:00	1996-02-20	1996-02-20 00:00:00	32020		\N	59535	0	39848009	4218389		0
15303	905	372328	1972-06-25	1972-06-25 00:00:00	1972-08-26	1972-08-26 00:00:00	32020		\N	60173	0	65363002	372328		0
15467	917	40481087	1966-08-04	1966-08-04 00:00:00	1966-08-25	1966-08-25 00:00:00	32020		\N	60951	0	444814009	40481087		0
15631	925	40481087	2002-11-09	2002-11-09 00:00:00	2002-11-30	2002-11-30 00:00:00	32020		\N	61617	0	444814009	40481087		0
5311	312	4112343	1997-02-25	1997-02-25 00:00:00	1997-03-09	1997-03-09 00:00:00	32020		\N	20691	0	195662009	4112343		0
15999	947	28060	1976-06-27	1976-06-27 00:00:00	1976-07-10	1976-07-10 00:00:00	32020		\N	62900	0	43878008	28060		0
16159	956	4230399	1950-04-08	1950-04-08 00:00:00	1950-06-07	1950-06-07 00:00:00	32020		\N	63551	0	359817006	4230399		0
16274	962	40481087	1951-08-15	1951-08-15 00:00:00	1951-09-05	1951-09-05 00:00:00	32020		\N	64020	0	444814009	40481087		0
16442	971	4112343	1960-11-04	1960-11-04 00:00:00	1960-11-13	1960-11-13 00:00:00	32020		\N	64589	0	195662009	4112343		0
16649	986	260139	1977-07-02	1977-07-02 00:00:00	1977-07-09	1977-07-09 00:00:00	32020		\N	65443	0	10509002	260139		0
6305	370	260139	2004-09-25	2004-09-25 00:00:00	2004-10-02	2004-10-02 00:00:00	32020		\N	24632	0	10509002	260139		0
16979	1015	321042	1973-07-23	1973-07-23 00:00:00	\N	\N	32020		\N	66813	0	410429000	321042		0
17166	1025	40481087	1968-07-15	1968-07-15 00:00:00	1968-07-29	1968-07-29 00:00:00	32020		\N	67546	0	444814009	40481087		0
17333	1039	40481087	1982-09-30	1982-09-30 00:00:00	1982-10-07	1982-10-07 00:00:00	32020		\N	68382	0	444814009	40481087		0
17470	1051	4112343	1973-09-08	1973-09-08 00:00:00	1973-09-21	1973-09-21 00:00:00	32020		\N	68865	0	195662009	4112343		0
17601	1057	4027663	1995-07-12	1995-07-12 00:00:00	\N	\N	32020		\N	69317	0	13200003	4027663		0
17838	1073	4266809	1974-04-02	1974-04-02 00:00:00	\N	\N	32020		\N	70394	0	397881000	4266809		0
17949	1079	4112343	1962-07-16	1962-07-16 00:00:00	1962-07-26	1962-07-26 00:00:00	32020		\N	70746	0	195662009	4112343		0
18141	1091	40481087	2005-11-14	2005-11-14 00:00:00	2005-12-05	2005-12-05 00:00:00	32020		\N	71701	0	444814009	40481087		0
7798	455	4166224	1977-01-25	1977-01-25 00:00:00	\N	\N	32020		\N	30469	0	47693006	4166224		0
18463	1110	4112343	2003-07-07	2003-07-07 00:00:00	2003-07-17	2003-07-17 00:00:00	32020		\N	73119	0	195662009	4112343		0
18629	1120	40481087	1962-04-09	1962-04-09 00:00:00	1962-04-16	1962-04-16 00:00:00	32020		\N	73845	0	444814009	40481087		0
18809	1132	4027663	1982-04-27	1982-04-27 00:00:00	\N	\N	32020		\N	74565	0	13200003	4027663		0
18933	1137	192671	1992-01-13	1992-01-13 00:00:00	\N	\N	32020		\N	74979	0	K92.2	35208414		0
19111	1145	40481087	1981-12-08	1981-12-08 00:00:00	1981-12-15	1981-12-15 00:00:00	32020		\N	75574	0	444814009	40481087		0
19296	1155	260139	1974-02-19	1974-02-19 00:00:00	1974-03-05	1974-03-05 00:00:00	32020		\N	76325	0	10509002	260139		0
19558	1174	28060	1946-03-28	1946-03-28 00:00:00	1946-04-05	1946-04-05 00:00:00	32020		\N	77341	0	43878008	28060		0
19630	1177	40481087	1983-05-18	1983-05-18 00:00:00	1983-06-08	1983-06-08 00:00:00	32020		\N	77776	0	444814009	40481087		0
19844	1193	260139	2008-07-08	2008-07-08 00:00:00	2008-07-15	2008-07-15 00:00:00	32020		\N	78606	0	10509002	260139		0
19963	1202	260139	2019-05-23	2019-05-23 00:00:00	2019-06-06	2019-06-06 00:00:00	32020		\N	79083	0	10509002	260139		0
20163	1214	4112343	1942-12-27	1942-12-27 00:00:00	1943-01-03	1943-01-03 00:00:00	32020		\N	79993	0	195662009	4112343		0
20260	1219	40481087	1995-09-01	1995-09-01 00:00:00	1995-09-22	1995-09-22 00:00:00	32020		\N	80267	0	444814009	40481087		0
20474	1231	80180	1978-01-21	1978-01-21 00:00:00	\N	\N	32020		\N	81084	0	396275006	80180		0
20640	1239	80180	2006-02-26	2006-02-26 00:00:00	\N	\N	32020		\N	81656	0	396275006	80180		0
20762	1246	260139	1950-06-13	1950-06-13 00:00:00	1950-06-20	1950-06-20 00:00:00	32020		\N	82099	0	10509002	260139		0
20929	1257	260139	1980-10-20	1980-10-20 00:00:00	1980-10-27	1980-10-27 00:00:00	32020		\N	82836	0	10509002	260139		0
21137	1267	40481087	1978-01-22	1978-01-22 00:00:00	1978-01-29	1978-01-29 00:00:00	32020		\N	83518	0	444814009	40481087		0
158	7	80180	2008-10-17	2008-10-17 00:00:00	\N	\N	32020		\N	624	0	396275006	80180		0
10823	642	372328	1936-06-06	1936-06-06 00:00:00	1936-12-06	1936-12-06 00:00:00	32020		\N	42466	0	65363002	372328		0
11023	651	4035415	1987-08-11	1987-08-11 00:00:00	1987-09-10	1987-09-10 00:00:00	32020		\N	43078	0	239720000	4035415		0
11198	662	378001	2011-07-13	2011-07-13 00:00:00	2011-09-11	2011-09-11 00:00:00	32020		\N	43753	0	62106007	378001		0
11315	669	372328	1996-01-13	1996-01-13 00:00:00	1997-12-10	1997-12-10 00:00:00	32020		\N	44196	0	65363002	372328		0
11570	682	260139	1982-02-20	1982-02-20 00:00:00	1982-03-06	1982-03-06 00:00:00	32020		\N	45187	0	10509002	260139		0
11643	687	40481087	2015-02-16	2015-02-16 00:00:00	2015-03-02	2015-03-02 00:00:00	32020		\N	45521	0	444814009	40481087		0
11835	700	4283893	1983-05-26	1983-05-26 00:00:00	1983-06-30	1983-06-30 00:00:00	32020		\N	46267	0	36971009	4283893		0
11992	709	40481087	1951-10-30	1951-10-30 00:00:00	1951-11-06	1951-11-06 00:00:00	32020		\N	46922	0	444814009	40481087		0
12172	720	4278672	1968-08-08	1968-08-08 00:00:00	1968-10-07	1968-10-07 00:00:00	32020		\N	47657	0	65966004	4278672		0
12292	727	40481087	1932-08-08	1932-08-08 00:00:00	1932-08-22	1932-08-22 00:00:00	32020		\N	48143	0	444814009	40481087		0
12481	739	4112343	1971-11-28	1971-11-28 00:00:00	1971-12-06	1971-12-06 00:00:00	32020		\N	48937	0	195662009	4112343		0
12683	752	260139	2014-02-27	2014-02-27 00:00:00	2014-03-06	2014-03-06 00:00:00	32020		\N	49643	0	10509002	260139		0
12855	757	40481087	1951-02-07	1951-02-07 00:00:00	1951-02-28	1951-02-28 00:00:00	32020		\N	50190	0	444814009	40481087		0
12964	762	40481087	1962-06-06	1962-06-06 00:00:00	1962-06-27	1962-06-27 00:00:00	32020		\N	50675	0	444814009	40481087		0
13158	775	4112343	2002-01-11	2002-01-11 00:00:00	2002-01-18	2002-01-18 00:00:00	32020		\N	51407	0	195662009	4112343		0
13284	782	28060	1938-09-27	1938-09-27 00:00:00	1938-10-10	1938-10-10 00:00:00	32020		\N	51991	0	43878008	28060		0
13492	795	40481087	2006-01-23	2006-01-23 00:00:00	2006-02-13	2006-02-13 00:00:00	32020		\N	52712	0	444814009	40481087		0
13646	806	257012	1991-08-02	1991-08-02 00:00:00	2002-11-26	2002-11-26 00:00:00	32020		\N	53482	0	40055000	257012		0
3303	191	378001	1926-01-31	1926-01-31 00:00:00	1926-04-01	1926-04-01 00:00:00	32020		\N	13037	0	62106007	378001		0
13951	823	4112343	1969-02-14	1969-02-14 00:00:00	1969-02-24	1969-02-24 00:00:00	32020		\N	54530	0	195662009	4112343		0
14212	841	40481087	1965-05-21	1965-05-21 00:00:00	1965-06-11	1965-06-11 00:00:00	32020		\N	55514	0	444814009	40481087		0
14293	844	378001	1967-04-18	1967-04-18 00:00:00	1967-06-17	1967-06-17 00:00:00	32020		\N	56000	0	62106007	378001		0
14483	856	372328	1989-01-03	1989-01-03 00:00:00	1991-08-16	1991-08-16 00:00:00	32020		\N	56568	0	65363002	372328		0
14641	864	4112343	1974-10-07	1974-10-07 00:00:00	1974-10-17	1974-10-17 00:00:00	32020		\N	57234	0	195662009	4112343		0
14798	870	4112343	2001-01-20	2001-01-20 00:00:00	2001-02-01	2001-02-01 00:00:00	32020		\N	57852	0	195662009	4112343		0
15003	884	260139	1985-08-21	1985-08-21 00:00:00	1985-08-28	1985-08-28 00:00:00	32020		\N	58839	0	10509002	260139		0
15157	893	4296204	1967-01-11	1967-01-11 00:00:00	1967-02-01	1967-02-01 00:00:00	32020		\N	59534	0	403190006	4296204		0
15304	905	4029498	1974-09-20	1974-09-20 00:00:00	\N	\N	32020		\N	60191	0	128613002	4029498		0
15468	917	40481087	1975-10-20	1975-10-20 00:00:00	1975-11-10	1975-11-10 00:00:00	32020		\N	60938	0	444814009	40481087		0
15632	925	80180	2005-01-09	2005-01-09 00:00:00	\N	\N	32020		\N	61595	0	396275006	80180		0
5312	312	40481087	2012-04-26	2012-04-26 00:00:00	2012-05-03	2012-05-03 00:00:00	32020		\N	20693	0	444814009	40481087		0
16000	947	40481087	1988-08-15	1988-08-15 00:00:00	1988-09-05	1988-09-05 00:00:00	32020		\N	62844	0	444814009	40481087		0
16160	956	4112343	2004-07-22	2004-07-22 00:00:00	2004-08-04	2004-08-04 00:00:00	32020		\N	63516	0	195662009	4112343		0
16275	962	4294548	1965-09-05	1965-09-05 00:00:00	1966-01-16	1966-01-16 00:00:00	32020		\N	64022	0	75498004	4294548		0
16443	971	4112343	1947-04-01	1947-04-01 00:00:00	1947-04-13	1947-04-13 00:00:00	32020		\N	64584	0	195662009	4112343		0
16650	986	40481087	1967-02-24	1967-02-24 00:00:00	1967-03-10	1967-03-10 00:00:00	32020		\N	65428	0	444814009	40481087		0
6306	370	4112343	1977-04-19	1977-04-19 00:00:00	1977-04-28	1977-04-28 00:00:00	32020		\N	24637	0	195662009	4112343		0
16980	1015	4152936	2003-07-25	2003-07-25 00:00:00	2003-08-08	2003-08-08 00:00:00	32020		\N	66816	0	283385000	4152936		0
17167	1025	4112343	1968-05-30	1968-05-30 00:00:00	1968-06-06	1968-06-06 00:00:00	32020		\N	67542	0	195662009	4112343		0
17334	1039	40481087	2012-12-14	2012-12-14 00:00:00	2012-12-21	2012-12-21 00:00:00	32020		\N	68376	0	444814009	40481087		0
17471	1051	4084167	1966-03-06	1966-03-06 00:00:00	1966-03-06	1966-03-06 00:00:00	32020		\N	68869	0	241929008	4084167		0
17602	1057	260139	2011-04-29	2011-04-29 00:00:00	2011-05-06	2011-05-06 00:00:00	32020		\N	69310	0	10509002	260139		0
17839	1073	4285898	1973-10-04	1973-10-04 00:00:00	\N	\N	32020		\N	70394	0	68496003	4285898		0
17950	1079	81151	1983-02-06	1983-02-06 00:00:00	1983-02-20	1983-02-20 00:00:00	32020		\N	70769	0	44465007	81151		0
18142	1091	4048171	1961-06-13	1961-06-13 00:00:00	1975-06-12	1975-06-12 00:00:00	32020		\N	71728	0	232353008	4048171		0
7799	455	440448	1977-01-25	1977-01-25 00:00:00	\N	\N	32020		\N	30469	0	74400008	440448		0
18464	1110	4112343	1994-03-14	1994-03-14 00:00:00	1994-03-22	1994-03-22 00:00:00	32020		\N	73028	0	195662009	4112343		0
18630	1120	40481087	1989-07-08	1989-07-08 00:00:00	1989-07-15	1989-07-15 00:00:00	32020		\N	73796	0	444814009	40481087		0
18810	1132	40481087	1963-07-19	1963-07-19 00:00:00	1963-08-09	1963-08-09 00:00:00	32020		\N	74506	0	444814009	40481087		0
18934	1137	4134304	1957-01-06	1957-01-06 00:00:00	1957-04-06	1957-04-06 00:00:00	32020		\N	74974	0	263102004	4134304		0
19112	1145	4112343	2016-05-04	2016-05-04 00:00:00	2016-05-13	2016-05-13 00:00:00	32020		\N	75658	0	195662009	4112343		0
19297	1155	80180	2007-10-29	2007-10-29 00:00:00	\N	\N	32020		\N	76385	0	396275006	80180		0
19559	1174	40481087	1996-06-15	1996-06-15 00:00:00	1996-06-29	1996-06-29 00:00:00	32020		\N	77346	0	444814009	40481087		0
19631	1177	28060	1978-04-23	1978-04-23 00:00:00	1978-05-02	1978-05-02 00:00:00	32020		\N	77737	0	43878008	28060		0
19845	1193	4146173	1950-08-21	1950-08-21 00:00:00	1950-10-20	1950-10-20 00:00:00	32020		\N	78639	0	307731004	4146173		0
19977	1205	260139	1975-07-20	1975-07-20 00:00:00	1975-08-03	1975-08-03 00:00:00	32020		\N	79199	0	10509002	260139		0
20164	1214	40481087	1970-06-16	1970-06-16 00:00:00	1970-06-23	1970-06-23 00:00:00	32020		\N	79975	0	444814009	40481087		0
20261	1219	4112343	1956-01-17	1956-01-17 00:00:00	1956-01-27	1956-01-27 00:00:00	32020		\N	80285	0	195662009	4112343		0
20475	1231	40481087	1977-05-09	1977-05-09 00:00:00	1977-05-16	1977-05-16 00:00:00	32020		\N	81084	0	444814009	40481087		0
20641	1239	372328	1975-11-10	1975-11-10 00:00:00	1976-06-10	1976-06-10 00:00:00	32020		\N	81671	0	65363002	372328		0
20763	1246	40481087	1957-09-26	1957-09-26 00:00:00	1957-10-03	1957-10-03 00:00:00	32020		\N	82060	0	444814009	40481087		0
20930	1257	440448	1976-10-28	1976-10-28 00:00:00	\N	\N	32020		\N	82841	0	74400008	440448		0
21138	1267	4134304	1995-02-27	1995-02-27 00:00:00	1995-03-29	1995-03-29 00:00:00	32020		\N	83568	0	263102004	4134304		0
159	7	372328	1968-12-06	1968-12-06 00:00:00	1969-02-12	1969-02-12 00:00:00	32020		\N	606	0	65363002	372328		0
10824	642	4112343	1999-05-19	1999-05-19 00:00:00	1999-06-01	1999-06-01 00:00:00	32020		\N	42490	0	195662009	4112343		0
11024	651	257012	1981-11-03	1981-11-03 00:00:00	\N	\N	32020		\N	43103	0	40055000	257012		0
11199	662	4155034	1993-10-01	1993-10-01 00:00:00	1993-10-15	1993-10-15 00:00:00	32020		\N	43752	0	283371005	4155034		0
11316	669	40481087	1980-11-26	1980-11-26 00:00:00	1980-12-10	1980-12-10 00:00:00	32020		\N	44143	0	444814009	40481087		0
11571	682	4112343	1975-12-24	1975-12-24 00:00:00	1976-01-02	1976-01-02 00:00:00	32020		\N	45146	0	195662009	4112343		0
11644	687	40486433	1969-01-27	1969-01-27 00:00:00	\N	\N	32020		\N	45510	0	446096008	40486433		0
11836	700	372328	1980-12-30	1980-12-30 00:00:00	1981-05-20	1981-05-20 00:00:00	32020		\N	46268	0	65363002	372328		0
11994	709	4329847	2005-08-28	2005-08-28 00:00:00	\N	\N	32020		\N	46975	0	22298006	4329847		0
12173	720	40481087	1975-05-18	1975-05-18 00:00:00	1975-06-01	1975-06-01 00:00:00	32020		\N	47616	0	444814009	40481087		0
12293	727	40481087	1940-12-16	1940-12-16 00:00:00	1941-01-06	1941-01-06 00:00:00	32020		\N	48241	0	444814009	40481087		0
12482	739	260139	1937-06-17	1937-06-17 00:00:00	1937-07-01	1937-07-01 00:00:00	32020		\N	48977	0	10509002	260139		0
12684	752	4112343	2016-02-13	2016-02-13 00:00:00	2016-02-23	2016-02-23 00:00:00	32020		\N	49644	0	195662009	4112343		0
12856	757	4146173	1917-09-23	1917-09-23 00:00:00	1917-10-23	1917-10-23 00:00:00	32020		\N	50178	0	307731004	4146173		0
12965	762	4112343	1987-11-03	1987-11-03 00:00:00	1987-11-12	1987-11-12 00:00:00	32020		\N	50664	0	195662009	4112343		0
13159	775	40481087	1973-06-16	1973-06-16 00:00:00	1973-06-23	1973-06-23 00:00:00	32020		\N	51454	0	444814009	40481087		0
13285	782	81151	1914-08-22	1914-08-22 00:00:00	1914-09-19	1914-09-19 00:00:00	32020		\N	52016	0	44465007	81151		0
13493	795	260139	1978-02-20	1978-02-20 00:00:00	1978-02-27	1978-02-27 00:00:00	32020		\N	52751	0	10509002	260139		0
13647	806	260139	2009-01-18	2009-01-18 00:00:00	2009-01-25	2009-01-25 00:00:00	32020		\N	53505	0	10509002	260139		0
3304	191	381316	1969-11-04	1969-11-04 00:00:00	\N	\N	32020		\N	13121	0	230690007	381316		0
13952	823	40481087	1955-04-23	1955-04-23 00:00:00	1955-05-14	1955-05-14 00:00:00	32020		\N	54586	0	444814009	40481087		0
14213	841	40481087	1965-03-09	1965-03-09 00:00:00	1965-03-16	1965-03-16 00:00:00	32020		\N	55519	0	444814009	40481087		0
14294	844	40481087	2017-03-30	2017-03-30 00:00:00	2017-04-20	2017-04-20 00:00:00	32020		\N	55876	0	444814009	40481087		0
14484	856	372328	1970-10-06	1970-10-06 00:00:00	1970-11-20	1970-11-20 00:00:00	32020		\N	56566	0	65363002	372328		0
14642	864	40481087	1998-11-04	1998-11-04 00:00:00	1998-11-11	1998-11-11 00:00:00	32020		\N	57301	0	444814009	40481087		0
14799	870	40481087	2015-03-19	2015-03-19 00:00:00	2015-04-09	2015-04-09 00:00:00	32020		\N	57865	0	444814009	40481087		0
15004	884	4112343	1981-10-16	1981-10-16 00:00:00	1981-10-23	1981-10-23 00:00:00	32020		\N	58940	0	195662009	4112343		0
15158	893	260139	2001-01-22	2001-01-22 00:00:00	2001-01-29	2001-01-29 00:00:00	32020		\N	59477	0	10509002	260139		0
15306	905	4278672	1974-03-24	1974-03-24 00:00:00	1974-06-22	1974-06-22 00:00:00	32020		\N	60190	0	65966004	4278672		0
15469	917	4112343	1978-12-25	1978-12-25 00:00:00	1979-01-04	1979-01-04 00:00:00	32020		\N	61072	0	195662009	4112343		0
15633	925	378001	1971-11-14	1971-11-14 00:00:00	1971-12-14	1971-12-14 00:00:00	32020		\N	61599	0	62106007	378001		0
15771	933	81151	1991-08-19	1991-08-19 00:00:00	1991-09-16	1991-09-16 00:00:00	32020		\N	62060	0	44465007	81151		0
16001	947	378001	1984-03-13	1984-03-13 00:00:00	1984-05-12	1984-05-12 00:00:00	32020		\N	62863	0	62106007	378001		0
16161	956	80502	2006-05-03	2006-05-03 00:00:00	\N	\N	32020		\N	63525	0	64859006	80502		0
16276	962	4112343	2006-02-18	2006-02-18 00:00:00	2006-02-27	2006-02-27 00:00:00	32020		\N	64060	0	195662009	4112343		0
16444	971	28060	1966-08-18	1966-08-18 00:00:00	1966-08-28	1966-08-28 00:00:00	32020		\N	64607	0	43878008	28060		0
16651	986	260139	1971-09-24	1971-09-24 00:00:00	1971-10-01	1971-10-01 00:00:00	32020		\N	65479	0	10509002	260139		0
6307	370	40481087	1967-08-27	1967-08-27 00:00:00	1967-09-03	1967-09-03 00:00:00	32020		\N	24595	0	444814009	40481087		0
16981	1015	40481087	2015-12-12	2015-12-12 00:00:00	2016-01-02	2016-01-02 00:00:00	32020		\N	66807	0	444814009	40481087		0
17168	1025	40481087	1958-08-17	1958-08-17 00:00:00	1958-08-31	1958-08-31 00:00:00	32020		\N	67571	0	444814009	40481087		0
17335	1039	4218389	2001-09-08	2001-09-08 00:00:00	2001-10-06	2001-10-06 00:00:00	32020		\N	68333	0	39848009	4218389		0
17472	1051	257012	2012-03-23	2012-03-23 00:00:00	\N	\N	32020		\N	68886	0	40055000	257012		0
17603	1057	81151	1963-03-12	1963-03-12 00:00:00	1963-03-26	1963-03-26 00:00:00	32020		\N	69301	0	44465007	81151		0
17840	1073	260139	1949-07-18	1949-07-18 00:00:00	1949-07-25	1949-07-25 00:00:00	32020		\N	70421	0	10509002	260139		0
17951	1079	140673	2016-03-05	2016-03-05 00:00:00	\N	\N	32020		\N	70716	0	40930008	140673		0
18143	1091	28060	2007-11-20	2007-11-20 00:00:00	2007-12-01	2007-12-01 00:00:00	32020		\N	71702	0	43878008	28060		0
7800	455	28060	1995-04-01	1995-04-01 00:00:00	1995-04-14	1995-04-14 00:00:00	32020		\N	30461	0	43878008	28060		0
18465	1110	81151	2019-01-14	2019-01-14 00:00:00	2019-01-28	2019-01-28 00:00:00	32020		\N	73084	0	44465007	81151		0
18631	1120	4112343	2013-08-12	2013-08-12 00:00:00	2013-08-22	2013-08-22 00:00:00	32020		\N	73831	0	195662009	4112343		0
18811	1132	4112343	1997-02-09	1997-02-09 00:00:00	1997-02-20	1997-02-20 00:00:00	32020		\N	74508	0	195662009	4112343		0
18935	1137	40481087	1957-02-19	1957-02-19 00:00:00	1957-03-12	1957-03-12 00:00:00	32020		\N	74904	0	444814009	40481087		0
19113	1145	40481087	1942-05-11	1942-05-11 00:00:00	1942-05-18	1942-05-18 00:00:00	32020		\N	75562	0	444814009	40481087		0
19298	1155	40481087	2017-01-04	2017-01-04 00:00:00	2017-01-18	2017-01-18 00:00:00	32020		\N	76368	0	444814009	40481087		0
19560	1174	4112343	1987-11-09	1987-11-09 00:00:00	1987-11-18	1987-11-18 00:00:00	32020		\N	77307	0	195662009	4112343		0
19632	1177	4113008	1966-04-13	1966-04-13 00:00:00	1966-05-04	1966-05-04 00:00:00	32020		\N	77755	0	284549007	4113008		0
19846	1193	260139	1968-01-20	1968-01-20 00:00:00	1968-02-03	1968-02-03 00:00:00	32020		\N	78597	0	10509002	260139		0
19978	1205	80180	2002-01-29	2002-01-29 00:00:00	\N	\N	32020		\N	79171	0	396275006	80180		0
20165	1214	372328	1940-03-27	1940-03-27 00:00:00	1940-06-06	1940-06-06 00:00:00	32020		\N	79928	0	65363002	372328		0
20262	1219	40481087	1980-05-11	1980-05-11 00:00:00	1980-05-25	1980-05-25 00:00:00	32020		\N	80288	0	444814009	40481087		0
20476	1231	4152936	1986-10-05	1986-10-05 00:00:00	1986-10-26	1986-10-26 00:00:00	32020		\N	81117	0	283385000	4152936		0
20642	1239	40481087	1974-12-16	1974-12-16 00:00:00	1975-01-06	1975-01-06 00:00:00	32020		\N	81637	0	444814009	40481087		0
20764	1246	40481087	1945-03-24	1945-03-24 00:00:00	1945-04-07	1945-04-07 00:00:00	32020		\N	82057	0	444814009	40481087		0
20931	1257	317576	2016-11-12	2016-11-12 00:00:00	\N	\N	32020		\N	82829	0	53741008	317576		0
21177	1271	4156265	1978-12-20	1978-12-20 00:00:00	1979-01-10	1979-01-10 00:00:00	32020		\N	83820	0	370247008	4156265		0
160	7	40481087	1990-12-27	1990-12-27 00:00:00	1991-01-10	1991-01-10 00:00:00	32020		\N	598	0	444814009	40481087		0
10825	642	40481087	2012-10-25	2012-10-25 00:00:00	2012-11-08	2012-11-08 00:00:00	32020		\N	42495	0	444814009	40481087		0
11025	651	4112343	1985-09-07	1985-09-07 00:00:00	1985-09-15	1985-09-15 00:00:00	32020		\N	43105	0	195662009	4112343		0
11200	662	4112343	1986-01-08	1986-01-08 00:00:00	1986-01-19	1986-01-19 00:00:00	32020		\N	43699	0	195662009	4112343		0
11317	669	81151	1985-06-09	1985-06-09 00:00:00	1985-06-23	1985-06-23 00:00:00	32020		\N	44155	0	44465007	81151		0
11572	682	4112343	1983-04-12	1983-04-12 00:00:00	1983-04-22	1983-04-22 00:00:00	32020		\N	45163	0	195662009	4112343		0
11645	687	4283893	2011-10-20	2011-10-20 00:00:00	2011-11-03	2011-11-03 00:00:00	32020		\N	45520	0	36971009	4283893		0
11837	700	4112343	1979-03-13	1979-03-13 00:00:00	1979-03-24	1979-03-24 00:00:00	32020		\N	46240	0	195662009	4112343		0
11995	709	4283893	1969-07-08	1969-07-08 00:00:00	1969-10-14	1969-10-14 00:00:00	32020		\N	46955	0	36971009	4283893		0
12174	720	260139	2013-03-17	2013-03-17 00:00:00	2013-03-31	2013-03-31 00:00:00	32020		\N	47619	0	10509002	260139		0
12294	727	372328	1914-08-23	1914-08-23 00:00:00	1914-10-09	1914-10-09 00:00:00	32020		\N	48180	0	65363002	372328		0
12483	739	378001	1918-09-18	1918-09-18 00:00:00	1918-11-17	1918-11-17 00:00:00	32020		\N	48968	0	62106007	378001		0
12685	752	40481087	1994-02-14	1994-02-14 00:00:00	1994-02-28	1994-02-28 00:00:00	32020		\N	49679	0	444814009	40481087		0
12857	757	4116491	1941-11-01	1941-11-01 00:00:00	1941-12-20	1941-12-20 00:00:00	32020		\N	50237	0	301011002	4116491		0
12966	762	4218389	1955-08-08	1955-08-08 00:00:00	1955-08-29	1955-08-29 00:00:00	32020		\N	50730	0	39848009	4218389		0
13160	775	372328	1940-03-10	1940-03-10 00:00:00	1940-04-24	1940-04-24 00:00:00	32020		\N	51408	0	65363002	372328		0
13286	782	4294548	1953-07-17	1953-07-17 00:00:00	1953-09-25	1953-09-25 00:00:00	32020		\N	51994	0	75498004	4294548		0
13494	795	260139	1965-06-20	1965-06-20 00:00:00	1965-06-27	1965-06-27 00:00:00	32020		\N	52736	0	10509002	260139		0
13648	806	4027663	1986-12-23	1986-12-23 00:00:00	\N	\N	32020		\N	53529	0	13200003	4027663		0
3305	191	4218389	1987-08-07	1987-08-07 00:00:00	1987-09-11	1987-09-11 00:00:00	32020		\N	13041	0	39848009	4218389		0
13953	823	40481087	1980-05-24	1980-05-24 00:00:00	1980-06-14	1980-06-14 00:00:00	32020		\N	54512	0	444814009	40481087		0
14214	841	4310024	1989-11-02	1989-11-02 00:00:00	\N	\N	32020		\N	55527	0	424802006	4310024		0
14295	844	40481087	1980-05-25	1980-05-25 00:00:00	1980-06-01	1980-06-01 00:00:00	32020		\N	55952	0	444814009	40481087		0
14485	856	28060	1981-03-15	1981-03-15 00:00:00	1981-03-26	1981-03-26 00:00:00	32020		\N	56525	0	43878008	28060		0
14643	864	372328	1923-08-21	1923-08-21 00:00:00	1924-02-04	1924-02-04 00:00:00	32020		\N	57303	0	65363002	372328		0
14800	870	40481087	1974-01-06	1974-01-06 00:00:00	1974-01-27	1974-01-27 00:00:00	32020		\N	57869	0	444814009	40481087		0
15005	884	78272	1991-08-27	1991-08-27 00:00:00	1991-09-17	1991-09-17 00:00:00	32020		\N	58951	0	70704007	78272		0
15159	893	195588	1981-09-14	1981-09-14 00:00:00	1981-11-02	1981-11-02 00:00:00	32020		\N	59492	0	38822007	195588		0
15307	905	260139	1997-10-07	1997-10-07 00:00:00	1997-10-21	1997-10-21 00:00:00	32020		\N	60215	0	10509002	260139		0
15470	917	4112343	2015-06-26	2015-06-26 00:00:00	2015-07-03	2015-07-03 00:00:00	32020		\N	61060	0	195662009	4112343		0
15634	925	260139	1982-01-21	1982-01-21 00:00:00	1982-02-04	1982-02-04 00:00:00	32020		\N	61603	0	10509002	260139		0
15772	933	81151	1986-11-15	1986-11-15 00:00:00	1986-12-13	1986-12-13 00:00:00	32020		\N	62059	0	44465007	81151		0
16002	947	40481087	2002-10-28	2002-10-28 00:00:00	2002-11-11	2002-11-11 00:00:00	32020		\N	62895	0	444814009	40481087		0
16162	956	372328	1936-06-29	1936-06-29 00:00:00	1936-08-12	1936-08-12 00:00:00	32020		\N	63468	0	65363002	372328		0
16277	962	257012	1965-09-19	1965-09-19 00:00:00	\N	\N	32020		\N	64019	0	40055000	257012		0
16445	971	4109685	1994-03-03	1994-03-03 00:00:00	1994-03-24	1994-03-24 00:00:00	32020		\N	64582	0	284551006	4109685		0
16652	986	4112343	1992-11-03	1992-11-03 00:00:00	1992-11-11	1992-11-11 00:00:00	32020		\N	65430	0	195662009	4112343		0
6308	370	4218389	2002-10-12	2002-10-12 00:00:00	2002-11-02	2002-11-02 00:00:00	32020		\N	24586	0	39848009	4218389		0
16982	1015	4156265	1957-11-04	1957-11-04 00:00:00	1957-11-18	1957-11-18 00:00:00	32020		\N	66812	0	370247008	4156265		0
17222	1032	4113008	2010-10-03	2010-10-03 00:00:00	2010-10-24	2010-10-24 00:00:00	32020		\N	67956	0	284549007	4113008		0
17336	1039	40481087	2010-10-26	2010-10-26 00:00:00	2010-11-16	2010-11-16 00:00:00	32020		\N	68385	0	444814009	40481087		0
17473	1051	40481087	2017-09-10	2017-09-10 00:00:00	2017-09-24	2017-09-24 00:00:00	32020		\N	68910	0	444814009	40481087		0
17604	1057	260139	2007-03-13	2007-03-13 00:00:00	2007-03-20	2007-03-20 00:00:00	32020		\N	69324	0	10509002	260139		0
17841	1073	372328	1936-11-22	1936-11-22 00:00:00	1937-03-04	1937-03-04 00:00:00	32020		\N	70392	0	65363002	372328		0
17952	1079	260139	1988-07-26	1988-07-26 00:00:00	1988-08-02	1988-08-02 00:00:00	32020		\N	70736	0	10509002	260139		0
18144	1091	40481087	2002-07-13	2002-07-13 00:00:00	2002-07-27	2002-07-27 00:00:00	32020		\N	71700	0	444814009	40481087		0
7801	455	80180	1986-08-15	1986-08-15 00:00:00	\N	\N	32020		\N	30427	0	396275006	80180		0
18466	1110	40481087	1988-10-08	1988-10-08 00:00:00	1988-10-22	1988-10-22 00:00:00	32020		\N	73050	0	444814009	40481087		0
18632	1120	4283893	1958-06-07	1958-06-07 00:00:00	1958-08-23	1958-08-23 00:00:00	32020		\N	73787	0	36971009	4283893		0
18812	1132	40481087	1976-09-05	1976-09-05 00:00:00	1976-09-26	1976-09-26 00:00:00	32020		\N	74507	0	444814009	40481087		0
18936	1137	260139	1959-03-14	1959-03-14 00:00:00	1959-03-22	1959-03-22 00:00:00	32020		\N	74963	0	10509002	260139		0
19114	1146	28060	1978-11-15	1978-11-15 00:00:00	1978-11-27	1978-11-27 00:00:00	32020		\N	75718	0	43878008	28060		0
19299	1155	40481087	1980-08-26	1980-08-26 00:00:00	1980-09-16	1980-09-16 00:00:00	32020		\N	76300	0	444814009	40481087		0
19561	1174	260139	1951-09-15	1951-09-15 00:00:00	1951-09-22	1951-09-22 00:00:00	32020		\N	77327	0	10509002	260139		0
19633	1177	40481087	1989-09-02	1989-09-02 00:00:00	1989-09-16	1989-09-16 00:00:00	32020		\N	77762	0	444814009	40481087		0
19847	1193	81151	1965-05-12	1965-05-12 00:00:00	1965-05-26	1965-05-26 00:00:00	32020		\N	78622	0	44465007	81151		0
19979	1205	40481087	2016-08-17	2016-08-17 00:00:00	2016-09-07	2016-09-07 00:00:00	32020		\N	79146	0	444814009	40481087		0
20166	1214	4155034	1969-10-01	1969-10-01 00:00:00	1969-10-22	1969-10-22 00:00:00	32020		\N	80006	0	283371005	4155034		0
20477	1231	260139	1957-07-07	1957-07-07 00:00:00	1957-07-21	1957-07-21 00:00:00	32020		\N	81105	0	10509002	260139		0
20643	1239	40481087	1982-03-07	1982-03-07 00:00:00	1982-03-14	1982-03-14 00:00:00	32020		\N	81639	0	444814009	40481087		0
20765	1246	81151	1972-01-14	1972-01-14 00:00:00	1972-01-28	1972-01-28 00:00:00	32020		\N	82053	0	44465007	81151		0
20932	1257	260139	1987-06-19	1987-06-19 00:00:00	1987-07-03	1987-07-03 00:00:00	32020		\N	82845	0	10509002	260139		0
21178	1271	81893	2009-01-22	2009-01-22 00:00:00	\N	\N	32020		\N	83830	0	64766004	81893		0
161	7	40481087	1985-10-14	1985-10-14 00:00:00	1985-11-04	1985-11-04 00:00:00	32020		\N	611	0	444814009	40481087		0
10826	642	4113008	2017-01-08	2017-01-08 00:00:00	2017-01-22	2017-01-22 00:00:00	32020		\N	42575	0	284549007	4113008		0
11026	651	40481087	1995-02-28	1995-02-28 00:00:00	1995-03-07	1995-03-07 00:00:00	32020		\N	43100	0	444814009	40481087		0
11201	662	28060	1964-01-07	1964-01-07 00:00:00	1964-01-20	1964-01-20 00:00:00	32020		\N	43749	0	43878008	28060		0
11318	669	40481087	2014-06-12	2014-06-12 00:00:00	2014-07-03	2014-07-03 00:00:00	32020		\N	44181	0	444814009	40481087		0
11581	685	40481087	1987-08-12	1987-08-12 00:00:00	1987-09-02	1987-09-02 00:00:00	32020		\N	45301	0	444814009	40481087		0
11646	687	260139	1983-12-21	1983-12-21 00:00:00	1984-01-04	1984-01-04 00:00:00	32020		\N	45530	0	10509002	260139		0
11838	700	4113008	2017-06-11	2017-06-11 00:00:00	2017-07-02	2017-07-02 00:00:00	32020		\N	46233	0	284549007	4113008		0
11996	709	260139	1961-03-12	1961-03-12 00:00:00	1961-03-26	1961-03-26 00:00:00	32020		\N	46954	0	10509002	260139		0
12196	722	4112343	1980-05-30	1980-05-30 00:00:00	1980-06-11	1980-06-11 00:00:00	32020		\N	47742	0	195662009	4112343		0
12295	727	260139	1951-08-04	1951-08-04 00:00:00	1951-08-11	1951-08-11 00:00:00	32020		\N	48251	0	10509002	260139		0
12484	739	40481087	1967-11-29	1967-11-29 00:00:00	1967-12-06	1967-12-06 00:00:00	32020		\N	48974	0	444814009	40481087		0
12686	752	4112343	2014-05-08	2014-05-08 00:00:00	2014-05-21	2014-05-21 00:00:00	32020		\N	49722	0	195662009	4112343		0
12858	757	40481087	1934-02-03	1934-02-03 00:00:00	1934-02-10	1934-02-10 00:00:00	32020		\N	50236	0	444814009	40481087		0
12967	762	4146173	1979-10-22	1979-10-22 00:00:00	1979-11-21	1979-11-21 00:00:00	32020		\N	50662	0	307731004	4146173		0
13161	775	260139	1959-07-01	1959-07-01 00:00:00	1959-07-08	1959-07-08 00:00:00	32020		\N	51417	0	10509002	260139		0
13287	782	40481087	1972-06-25	1972-06-25 00:00:00	1972-07-02	1972-07-02 00:00:00	32020		\N	51970	0	444814009	40481087		0
13495	795	372328	1937-04-16	1937-04-16 00:00:00	1937-07-28	1937-07-28 00:00:00	32020		\N	52754	0	65363002	372328		0
13649	806	4218389	2012-03-23	2012-03-23 00:00:00	2012-04-27	2012-04-27 00:00:00	32020		\N	53471	0	39848009	4218389		0
3306	191	261325	1989-09-19	1989-09-19 00:00:00	\N	\N	32020		\N	13126	0	87433001	261325		0
13954	823	4112343	1950-02-25	1950-02-25 00:00:00	1950-03-05	1950-03-05 00:00:00	32020		\N	54561	0	195662009	4112343		0
14215	841	40481087	1976-01-23	1976-01-23 00:00:00	1976-02-13	1976-02-13 00:00:00	32020		\N	55562	0	444814009	40481087		0
14296	844	372328	1967-12-14	1967-12-14 00:00:00	1968-02-24	1968-02-24 00:00:00	32020		\N	55969	0	65363002	372328		0
14486	857	372328	1955-02-04	1955-02-04 00:00:00	1955-08-07	1955-08-07 00:00:00	32020		\N	56593	0	65363002	372328		0
14644	864	28060	1967-12-16	1967-12-16 00:00:00	1967-12-25	1967-12-25 00:00:00	32020		\N	57232	0	43878008	28060		0
14801	871	4027663	1993-01-11	1993-01-11 00:00:00	\N	\N	32020		\N	57970	0	13200003	4027663		0
15006	884	40486433	1982-09-12	1982-09-12 00:00:00	\N	\N	32020		\N	58943	0	446096008	40486433		0
15160	893	80180	1993-09-26	1993-09-26 00:00:00	\N	\N	32020		\N	59516	0	396275006	80180		0
15308	906	4112343	1981-04-07	1981-04-07 00:00:00	1981-04-15	1981-04-15 00:00:00	32020		\N	60263	0	195662009	4112343		0
15471	917	372328	1967-11-10	1967-11-10 00:00:00	1968-04-25	1968-04-25 00:00:00	32020		\N	61048	0	65363002	372328		0
15635	925	258780	2009-05-15	2009-05-15 00:00:00	\N	\N	32020		\N	61615	0	185086009	258780		0
15773	933	4152936	1983-10-11	1983-10-11 00:00:00	1983-11-01	1983-11-01 00:00:00	32020		\N	62058	0	283385000	4152936		0
16003	947	4283893	2008-02-22	2008-02-22 00:00:00	2008-06-20	2008-06-20 00:00:00	32020		\N	62887	0	36971009	4283893		0
16163	956	4112343	1942-11-11	1942-11-11 00:00:00	1942-11-18	1942-11-18 00:00:00	32020		\N	63494	0	195662009	4112343		0
16278	962	28060	1994-03-02	1994-03-02 00:00:00	1994-03-10	1994-03-10 00:00:00	32020		\N	64028	0	43878008	28060		0
16446	971	4112343	1981-07-24	1981-07-24 00:00:00	1981-08-05	1981-08-05 00:00:00	32020		\N	64593	0	195662009	4112343		0
16653	986	260139	1965-06-18	1965-06-18 00:00:00	1965-07-02	1965-07-02 00:00:00	32020		\N	65507	0	10509002	260139		0
16767	994	372328	1962-08-05	1962-08-05 00:00:00	1962-12-26	1962-12-26 00:00:00	32020		\N	65914	0	65363002	372328		0
16983	1015	4112343	1982-08-12	1982-08-12 00:00:00	1982-08-20	1982-08-20 00:00:00	32020		\N	66818	0	195662009	4112343		0
17223	1032	40481087	1980-08-04	1980-08-04 00:00:00	1980-08-11	1980-08-11 00:00:00	32020		\N	67884	0	444814009	40481087		0
17337	1039	40481087	2011-03-24	2011-03-24 00:00:00	2011-03-31	2011-03-31 00:00:00	32020		\N	68397	0	444814009	40481087		0
17474	1051	4112343	1998-06-24	1998-06-24 00:00:00	1998-07-05	1998-07-05 00:00:00	32020		\N	68877	0	195662009	4112343		0
17605	1057	4310024	2001-09-08	2001-09-08 00:00:00	\N	\N	32020		\N	69318	0	424802006	4310024		0
17842	1073	40481087	1944-11-25	1944-11-25 00:00:00	1944-12-16	1944-12-16 00:00:00	32020		\N	70384	0	444814009	40481087		0
17965	1081	40481087	1997-09-05	1997-09-05 00:00:00	1997-09-19	1997-09-19 00:00:00	32020		\N	70864	0	444814009	40481087		0
18145	1091	4027663	1988-05-30	1988-05-30 00:00:00	\N	\N	32020		\N	71744	0	13200003	4027663		0
7802	455	78272	2014-06-02	2014-06-02 00:00:00	2014-06-16	2014-06-16 00:00:00	32020		\N	30472	0	70704007	78272		0
18470	1112	40481087	2011-11-04	2011-11-04 00:00:00	2011-11-18	2011-11-18 00:00:00	32020		\N	73214	0	444814009	40481087		0
18633	1120	4112343	2018-04-29	2018-04-29 00:00:00	2018-05-06	2018-05-06 00:00:00	32020		\N	73862	0	195662009	4112343		0
18813	1132	378001	1964-07-12	1964-07-12 00:00:00	1964-08-11	1964-08-11 00:00:00	32020		\N	74532	0	62106007	378001		0
18937	1137	378001	1956-02-11	1956-02-11 00:00:00	1956-03-12	1956-03-12 00:00:00	32020		\N	74973	0	62106007	378001		0
19115	1146	4112343	2004-08-21	2004-08-21 00:00:00	2004-09-03	2004-09-03 00:00:00	32020		\N	75671	0	195662009	4112343		0
19300	1155	4294548	1979-05-19	1979-05-19 00:00:00	1979-08-04	1979-08-04 00:00:00	32020		\N	76327	0	75498004	4294548		0
19562	1174	40481087	1996-09-05	1996-09-05 00:00:00	1996-09-19	1996-09-19 00:00:00	32020		\N	77363	0	444814009	40481087		0
19634	1177	260139	1998-06-24	1998-06-24 00:00:00	1998-07-08	1998-07-08 00:00:00	32020		\N	77799	0	10509002	260139		0
19848	1193	40481087	1976-11-09	1976-11-09 00:00:00	1976-11-23	1976-11-23 00:00:00	32020		\N	78605	0	444814009	40481087		0
19980	1205	40481087	2013-12-04	2013-12-04 00:00:00	2013-12-25	2013-12-25 00:00:00	32020		\N	79202	0	444814009	40481087		0
20167	1214	40481087	1997-02-05	1997-02-05 00:00:00	1997-02-26	1997-02-26 00:00:00	32020		\N	79889	0	444814009	40481087		0
20264	1219	378419	2014-01-13	2014-01-13 00:00:00	\N	\N	32020		\N	80233	0	26929004	378419		0
20478	1231	4112343	1958-05-09	1958-05-09 00:00:00	1958-05-18	1958-05-18 00:00:00	32020		\N	81060	0	195662009	4112343		0
20644	1239	28060	1983-06-03	1983-06-03 00:00:00	1983-06-12	1983-06-12 00:00:00	32020		\N	81640	0	43878008	28060		0
20766	1246	260139	1947-11-06	1947-11-06 00:00:00	1947-11-20	1947-11-20 00:00:00	32020		\N	82058	0	10509002	260139		0
20933	1257	40481087	2011-03-13	2011-03-13 00:00:00	2011-03-27	2011-03-27 00:00:00	32020		\N	82804	0	444814009	40481087		0
21179	1271	81151	1969-10-24	1969-10-24 00:00:00	1969-11-07	1969-11-07 00:00:00	32020		\N	83819	0	44465007	81151		0
162	7	81151	1985-05-16	1985-05-16 00:00:00	1985-06-13	1985-06-13 00:00:00	32020		\N	632	0	44465007	81151		0
10827	642	4152936	1967-07-31	1967-07-31 00:00:00	1967-08-21	1967-08-21 00:00:00	32020		\N	42463	0	283385000	4152936		0
11027	651	40481087	2012-06-29	2012-06-29 00:00:00	2012-07-20	2012-07-20 00:00:00	32020		\N	43109	0	444814009	40481087		0
11202	662	372328	1977-09-13	1977-09-13 00:00:00	1977-11-08	1977-11-08 00:00:00	32020		\N	43745	0	65363002	372328		0
11319	669	28060	2008-04-22	2008-04-22 00:00:00	2008-04-30	2008-04-30 00:00:00	32020		\N	44180	0	43878008	28060		0
11582	685	40481087	1979-06-04	1979-06-04 00:00:00	1979-06-18	1979-06-18 00:00:00	32020		\N	45263	0	444814009	40481087		0
11647	687	40481087	1996-02-26	1996-02-26 00:00:00	1996-03-04	1996-03-04 00:00:00	32020		\N	45580	0	444814009	40481087		0
11839	700	80180	2014-12-27	2014-12-27 00:00:00	\N	\N	32020		\N	46261	0	396275006	80180		0
11997	709	317576	1999-07-04	1999-07-04 00:00:00	\N	\N	32020		\N	46961	0	53741008	317576		0
12197	722	40481087	2000-08-16	2000-08-16 00:00:00	2000-08-30	2000-08-30 00:00:00	32020		\N	47752	0	444814009	40481087		0
12296	727	372328	1915-04-07	1915-04-07 00:00:00	1915-10-08	1915-10-08 00:00:00	32020		\N	48169	0	65363002	372328		0
12485	739	4134304	1975-08-20	1975-08-20 00:00:00	1975-09-19	1975-09-19 00:00:00	32020		\N	48930	0	263102004	4134304		0
12687	752	372328	1950-02-13	1950-02-13 00:00:00	1950-04-16	1950-04-16 00:00:00	32020		\N	49706	0	65363002	372328		0
12859	757	40481087	1998-09-07	1998-09-07 00:00:00	1998-09-28	1998-09-28 00:00:00	32020		\N	50195	0	444814009	40481087		0
12968	762	40481087	1974-10-26	1974-10-26 00:00:00	1974-11-16	1974-11-16 00:00:00	32020		\N	50656	0	444814009	40481087		0
13162	775	4112343	2005-02-05	2005-02-05 00:00:00	2005-02-15	2005-02-15 00:00:00	32020		\N	51423	0	195662009	4112343		0
13288	782	260139	1950-01-17	1950-01-17 00:00:00	1950-01-24	1950-01-24 00:00:00	32020		\N	52024	0	10509002	260139		0
13496	795	260139	1988-06-08	1988-06-08 00:00:00	1988-06-15	1988-06-15 00:00:00	32020		\N	52710	0	10509002	260139		0
13650	806	260139	1971-02-17	1971-02-17 00:00:00	1971-03-03	1971-03-03 00:00:00	32020		\N	53507	0	10509002	260139		0
3307	191	4059173	1924-02-11	1924-02-11 00:00:00	1924-03-12	1924-03-12 00:00:00	32020		\N	13036	0	16114001	4059173		0
13955	823	40481087	1952-11-15	1952-11-15 00:00:00	1952-11-29	1952-11-29 00:00:00	32020		\N	54528	0	444814009	40481087		0
14216	841	4084167	1966-01-02	1966-01-02 00:00:00	1966-01-02	1966-01-02 00:00:00	32020		\N	55509	0	241929008	4084167		0
14297	844	81893	2000-07-08	2000-07-08 00:00:00	\N	\N	32020		\N	56010	0	64766004	81893		0
14487	857	257012	1981-03-30	1981-03-30 00:00:00	\N	\N	32020		\N	56629	0	40055000	257012		0
14645	864	28060	1935-03-08	1935-03-08 00:00:00	1935-03-20	1935-03-20 00:00:00	32020		\N	57273	0	43878008	28060		0
14802	871	80180	2003-12-30	2003-12-30 00:00:00	\N	\N	32020		\N	57959	0	396275006	80180		0
15007	884	4155034	1984-09-11	1984-09-11 00:00:00	1984-10-02	1984-10-02 00:00:00	32020		\N	58949	0	283371005	4155034		0
15161	893	40481087	1998-03-07	1998-03-07 00:00:00	1998-03-21	1998-03-21 00:00:00	32020		\N	59454	0	444814009	40481087		0
15309	906	4112343	1976-03-10	1976-03-10 00:00:00	1976-03-19	1976-03-19 00:00:00	32020		\N	60242	0	195662009	4112343		0
15472	917	260139	2004-01-19	2004-01-19 00:00:00	2004-02-02	2004-02-02 00:00:00	32020		\N	60941	0	10509002	260139		0
15636	925	257012	2014-08-09	2014-08-09 00:00:00	\N	\N	32020		\N	61629	0	40055000	257012		0
15774	933	372328	1977-08-18	1977-08-18 00:00:00	1977-09-01	1977-09-01 00:00:00	32020		\N	62064	0	65363002	372328		0
16004	947	28060	2006-06-06	2006-06-06 00:00:00	2006-06-13	2006-06-13 00:00:00	32020		\N	62846	0	43878008	28060		0
16164	956	4112343	1996-04-25	1996-04-25 00:00:00	1996-05-02	1996-05-02 00:00:00	32020		\N	63449	0	195662009	4112343		0
16279	962	4112343	1955-09-30	1955-09-30 00:00:00	1955-10-10	1955-10-10 00:00:00	32020		\N	64021	0	195662009	4112343		0
16447	971	260139	1979-07-02	1979-07-02 00:00:00	1979-07-09	1979-07-09 00:00:00	32020		\N	64609	0	10509002	260139		0
16654	986	257012	1932-01-30	1932-01-30 00:00:00	\N	\N	32020		\N	65410	0	40055000	257012		0
16768	994	260139	2002-06-16	2002-06-16 00:00:00	2002-06-30	2002-06-30 00:00:00	32020		\N	65894	0	10509002	260139		0
16984	1015	440448	1984-10-19	1984-10-19 00:00:00	\N	\N	32020		\N	66815	0	74400008	440448		0
17224	1032	80180	1989-05-22	1989-05-22 00:00:00	\N	\N	32020		\N	67922	0	396275006	80180		0
17338	1039	80180	2003-03-29	2003-03-29 00:00:00	\N	\N	32020		\N	68374	0	396275006	80180		0
17475	1051	4051466	1969-02-15	1969-02-15 00:00:00	1984-05-27	1984-05-27 00:00:00	32020		\N	68872	0	233678006	4051466		0
17606	1057	40481087	1981-04-02	1981-04-02 00:00:00	1981-04-16	1981-04-16 00:00:00	32020		\N	69274	0	444814009	40481087		0
17843	1073	40481087	1978-03-10	1978-03-10 00:00:00	1978-03-17	1978-03-17 00:00:00	32020		\N	70389	0	444814009	40481087		0
17966	1081	4112343	1962-09-14	1962-09-14 00:00:00	1962-09-27	1962-09-27 00:00:00	32020		\N	70861	0	195662009	4112343		0
18146	1091	4113008	1998-07-27	1998-07-27 00:00:00	1998-08-10	1998-08-10 00:00:00	32020		\N	71726	0	284549007	4113008		0
18261	1098	4152936	1982-02-26	1982-02-26 00:00:00	1982-03-19	1982-03-19 00:00:00	32020		\N	72030	0	283385000	4152936		0
18471	1112	4112343	2004-08-18	2004-08-18 00:00:00	2004-08-30	2004-08-30 00:00:00	32020		\N	73169	0	195662009	4112343		0
18634	1120	4112343	1979-11-01	1979-11-01 00:00:00	1979-11-11	1979-11-11 00:00:00	32020		\N	73789	0	195662009	4112343		0
18814	1132	372328	1983-03-04	1983-03-04 00:00:00	1984-07-16	1984-07-16 00:00:00	32020		\N	74497	0	65363002	372328		0
18938	1137	4001336	1962-10-07	1962-10-07 00:00:00	1962-12-06	1962-12-06 00:00:00	32020		\N	74975	0	110030002	4001336		0
19116	1146	40481087	1994-09-08	1994-09-08 00:00:00	1994-09-15	1994-09-15 00:00:00	32020		\N	75745	0	444814009	40481087		0
19301	1155	4112343	1980-08-05	1980-08-05 00:00:00	1980-08-13	1980-08-13 00:00:00	32020		\N	76304	0	195662009	4112343		0
19563	1174	4116491	1967-01-06	1967-01-06 00:00:00	1967-02-14	1967-02-14 00:00:00	32020		\N	77304	0	301011002	4116491		0
19635	1177	4112343	2006-03-19	2006-03-19 00:00:00	2006-04-01	2006-04-01 00:00:00	32020		\N	77800	0	195662009	4112343		0
19849	1194	257012	1963-03-08	1963-03-08 00:00:00	\N	\N	32020		\N	78689	0	40055000	257012		0
19981	1205	40481087	2017-09-11	2017-09-11 00:00:00	2017-10-02	2017-10-02 00:00:00	32020		\N	79150	0	444814009	40481087		0
20168	1214	4112343	1941-03-26	1941-03-26 00:00:00	1941-04-04	1941-04-04 00:00:00	32020		\N	79974	0	195662009	4112343		0
20265	1219	40481087	1973-01-18	1973-01-18 00:00:00	1973-02-08	1973-02-08 00:00:00	32020		\N	80287	0	444814009	40481087		0
20479	1231	28060	1989-06-27	1989-06-27 00:00:00	1989-07-04	1989-07-04 00:00:00	32020		\N	81096	0	43878008	28060		0
20645	1239	4112343	1982-04-26	1982-04-26 00:00:00	1982-05-05	1982-05-05 00:00:00	32020		\N	81645	0	195662009	4112343		0
20767	1246	260139	1945-05-23	1945-05-23 00:00:00	1945-06-06	1945-06-06 00:00:00	32020		\N	82038	0	10509002	260139		0
20935	1257	260139	1977-02-20	1977-02-20 00:00:00	1977-02-27	1977-02-27 00:00:00	32020		\N	82807	0	10509002	260139		0
21180	1271	260139	1991-07-23	1991-07-23 00:00:00	1991-07-30	1991-07-30 00:00:00	32020		\N	83801	0	10509002	260139		0
163	7	4112343	1997-04-12	1997-04-12 00:00:00	1997-04-20	1997-04-20 00:00:00	32020		\N	601	0	195662009	4112343		0
10828	642	40481087	1955-06-09	1955-06-09 00:00:00	1955-06-16	1955-06-16 00:00:00	32020		\N	42486	0	444814009	40481087		0
11028	651	40481087	2011-11-06	2011-11-06 00:00:00	2011-11-27	2011-11-27 00:00:00	32020		\N	43086	0	444814009	40481087		0
11203	662	4283893	2017-06-16	2017-06-16 00:00:00	2017-07-28	2017-07-28 00:00:00	32020		\N	43734	0	36971009	4283893		0
11320	669	40481087	2007-09-29	2007-09-29 00:00:00	2007-10-13	2007-10-13 00:00:00	32020		\N	44179	0	444814009	40481087		0
11583	685	4266809	2000-06-18	2000-06-18 00:00:00	\N	\N	32020		\N	45324	0	397881000	4266809		0
11648	687	440448	1992-01-17	1992-01-17 00:00:00	\N	\N	32020		\N	45491	0	74400008	440448		0
11840	700	28060	1991-11-20	1991-11-20 00:00:00	1991-12-01	1991-12-01 00:00:00	32020		\N	46286	0	43878008	28060		0
11998	709	4112343	1982-01-20	1982-01-20 00:00:00	1982-01-27	1982-01-27 00:00:00	32020		\N	46965	0	195662009	4112343		0
12198	722	40481087	2017-12-09	2017-12-09 00:00:00	2017-12-16	2017-12-16 00:00:00	32020		\N	47744	0	444814009	40481087		0
12297	727	260139	1949-09-20	1949-09-20 00:00:00	1949-09-27	1949-09-27 00:00:00	32020		\N	48242	0	10509002	260139		0
12486	739	4116491	1964-06-23	1964-06-23 00:00:00	1964-08-02	1964-08-02 00:00:00	32020		\N	48978	0	301011002	4116491		0
12688	752	321042	1979-02-04	1979-02-04 00:00:00	\N	\N	32020		\N	49640	0	410429000	321042		0
12860	757	40481087	1987-04-22	1987-04-22 00:00:00	1987-04-29	1987-04-29 00:00:00	32020		\N	50240	0	444814009	40481087		0
12969	762	260139	1996-12-31	1996-12-31 00:00:00	1997-01-07	1997-01-07 00:00:00	32020		\N	50658	0	10509002	260139		0
13163	775	40481087	2004-06-14	2004-06-14 00:00:00	2004-06-28	2004-06-28 00:00:00	32020		\N	51488	0	444814009	40481087		0
13289	782	260139	1921-11-16	1921-11-16 00:00:00	1921-11-30	1921-11-30 00:00:00	32020		\N	52052	0	10509002	260139		0
13497	795	4112343	2001-09-30	2001-09-30 00:00:00	2001-10-07	2001-10-07 00:00:00	32020		\N	52775	0	195662009	4112343		0
13651	806	4294548	1991-07-05	1991-07-05 00:00:00	1991-09-13	1991-09-13 00:00:00	32020		\N	53508	0	75498004	4294548		0
3308	191	4134304	1939-03-31	1939-03-31 00:00:00	1939-04-30	1939-04-30 00:00:00	32020		\N	13039	0	263102004	4134304		0
13956	823	40481087	1966-04-24	1966-04-24 00:00:00	1966-05-08	1966-05-08 00:00:00	32020		\N	54549	0	444814009	40481087		0
14217	841	260139	1966-08-31	1966-08-31 00:00:00	1966-09-07	1966-09-07 00:00:00	32020		\N	55561	0	10509002	260139		0
14298	844	30753	2001-02-03	2001-02-03 00:00:00	\N	\N	32020		\N	56010	0	16761005	30753		0
14488	857	80180	1985-10-15	1985-10-15 00:00:00	\N	\N	32020		\N	56591	0	396275006	80180		0
14646	864	4155034	1939-10-06	1939-10-06 00:00:00	1939-10-27	1939-10-27 00:00:00	32020		\N	57279	0	283371005	4155034		0
14803	871	81151	2002-10-20	2002-10-20 00:00:00	2002-11-03	2002-11-03 00:00:00	32020		\N	57959	0	44465007	81151		0
15008	884	40481087	2011-04-10	2011-04-10 00:00:00	2011-04-24	2011-04-24 00:00:00	32020		\N	58912	0	444814009	40481087		0
15162	893	257012	1976-05-01	1976-05-01 00:00:00	\N	\N	32020		\N	59491	0	40055000	257012		0
15310	906	80180	2011-09-07	2011-09-07 00:00:00	\N	\N	32020		\N	60269	0	396275006	80180		0
15473	917	372328	1965-05-05	1965-05-05 00:00:00	1965-10-21	1965-10-21 00:00:00	32020		\N	60929	0	65363002	372328		0
15637	925	81151	2008-07-02	2008-07-02 00:00:00	2008-07-23	2008-07-23 00:00:00	32020		\N	61641	0	44465007	81151		0
15775	933	372328	1974-03-20	1974-03-20 00:00:00	1974-09-03	1974-09-03 00:00:00	32020		\N	62074	0	65363002	372328		0
16005	948	4294548	2003-10-09	2003-10-09 00:00:00	2003-10-23	2003-10-23 00:00:00	32020		\N	62919	0	75498004	4294548		0
16165	956	4112343	1964-11-12	1964-11-12 00:00:00	1964-11-22	1964-11-22 00:00:00	32020		\N	63541	0	195662009	4112343		0
16280	962	260139	2016-05-20	2016-05-20 00:00:00	2016-05-27	2016-05-27 00:00:00	32020		\N	64100	0	10509002	260139		0
16448	971	4112343	1966-11-29	1966-11-29 00:00:00	1966-12-08	1966-12-08 00:00:00	32020		\N	64608	0	195662009	4112343		0
16655	986	4283893	1932-01-09	1932-01-09 00:00:00	1932-06-25	1932-06-25 00:00:00	32020		\N	65413	0	36971009	4283893		0
16769	994	260139	1969-10-29	1969-10-29 00:00:00	1969-11-05	1969-11-05 00:00:00	32020		\N	65891	0	10509002	260139		0
16985	1015	4112343	1959-06-01	1959-06-01 00:00:00	1959-06-10	1959-06-10 00:00:00	32020		\N	66817	0	195662009	4112343		0
17225	1032	260139	1985-08-09	1985-08-09 00:00:00	1985-08-23	1985-08-23 00:00:00	32020		\N	67907	0	10509002	260139		0
17339	1039	4294548	2005-11-06	2005-11-06 00:00:00	2006-03-12	2006-03-12 00:00:00	32020		\N	68341	0	75498004	4294548		0
17476	1051	4109685	1988-08-07	1988-08-07 00:00:00	1988-08-21	1988-08-21 00:00:00	32020		\N	68936	0	284551006	4109685		0
17607	1057	40481087	1982-07-15	1982-07-15 00:00:00	1982-07-29	1982-07-29 00:00:00	32020		\N	69290	0	444814009	40481087		0
17844	1073	4230399	2010-08-20	2010-08-20 00:00:00	2010-09-19	2010-09-19 00:00:00	32020		\N	70304	0	359817006	4230399		0
17967	1081	40481087	1984-05-20	1984-05-20 00:00:00	1984-05-27	1984-05-27 00:00:00	32020		\N	70835	0	444814009	40481087		0
18147	1091	260139	1971-01-22	1971-01-22 00:00:00	1971-01-29	1971-01-29 00:00:00	32020		\N	71675	0	10509002	260139		0
18262	1098	260139	1956-11-05	1956-11-05 00:00:00	1956-11-12	1956-11-12 00:00:00	32020		\N	72041	0	10509002	260139		0
18472	1112	260139	2000-06-11	2000-06-11 00:00:00	2000-06-18	2000-06-18 00:00:00	32020		\N	73206	0	10509002	260139		0
18635	1120	40481087	1994-01-26	1994-01-26 00:00:00	1994-02-16	1994-02-16 00:00:00	32020		\N	73797	0	444814009	40481087		0
18815	1132	4059173	1968-09-19	1968-09-19 00:00:00	1968-11-18	1968-11-18 00:00:00	32020		\N	74563	0	16114001	4059173		0
18939	1137	4132546	1962-10-07	1962-10-07 00:00:00	\N	\N	32020		\N	74975	0	275272006	4166590		0
19117	1146	4112343	1967-03-05	1967-03-05 00:00:00	1967-03-12	1967-03-12 00:00:00	32020		\N	75688	0	195662009	4112343		0
19302	1155	4112343	1975-12-03	1975-12-03 00:00:00	1975-12-14	1975-12-14 00:00:00	32020		\N	76326	0	195662009	4112343		0
19564	1174	4112343	1978-10-31	1978-10-31 00:00:00	1978-11-12	1978-11-12 00:00:00	32020		\N	77343	0	195662009	4112343		0
19636	1177	4155034	2000-07-04	2000-07-04 00:00:00	2000-07-25	2000-07-25 00:00:00	32020		\N	77756	0	283371005	4155034		0
19850	1194	260139	2003-06-30	2003-06-30 00:00:00	2003-07-14	2003-07-14 00:00:00	32020		\N	78712	0	10509002	260139		0
19982	1205	40481087	2009-12-10	2009-12-10 00:00:00	2009-12-17	2009-12-17 00:00:00	32020		\N	79201	0	444814009	40481087		0
20169	1214	28060	1967-09-19	1967-09-19 00:00:00	1967-09-29	1967-09-29 00:00:00	32020		\N	79999	0	43878008	28060		0
20266	1219	40481087	1968-10-22	1968-10-22 00:00:00	1968-11-05	1968-11-05 00:00:00	32020		\N	80286	0	444814009	40481087		0
20480	1231	378001	1979-12-10	1979-12-10 00:00:00	1980-01-09	1980-01-09 00:00:00	32020		\N	81116	0	62106007	378001		0
20646	1239	258780	2012-07-05	2012-07-05 00:00:00	\N	\N	32020		\N	81682	0	185086009	258780		0
20768	1246	4035415	1974-09-14	1974-09-14 00:00:00	1974-11-13	1974-11-13 00:00:00	32020		\N	82054	0	239720000	4035415		0
20936	1257	40481087	2004-04-04	2004-04-04 00:00:00	2004-04-11	2004-04-11 00:00:00	32020		\N	82846	0	444814009	40481087		0
21181	1271	260139	1968-09-01	1968-09-01 00:00:00	1968-09-15	1968-09-15 00:00:00	32020		\N	83804	0	10509002	260139		0
164	7	40481087	1986-08-06	1986-08-06 00:00:00	1986-08-13	1986-08-13 00:00:00	32020		\N	612	0	444814009	40481087		0
10829	642	372328	1992-04-16	1992-04-16 00:00:00	1992-07-26	1992-07-26 00:00:00	32020		\N	42497	0	65363002	372328		0
11029	651	372328	1983-04-04	1983-04-04 00:00:00	1983-04-18	1983-04-18 00:00:00	32020		\N	43087	0	65363002	372328		0
11204	662	260139	1976-01-01	1976-01-01 00:00:00	1976-01-15	1976-01-15 00:00:00	32020		\N	43697	0	10509002	260139		0
11321	669	4112343	2004-10-27	2004-10-27 00:00:00	2004-11-06	2004-11-06 00:00:00	32020		\N	44169	0	195662009	4112343		0
11584	685	80180	2000-06-18	2000-06-18 00:00:00	\N	\N	32020		\N	45324	0	396275006	80180		0
11649	687	372328	1971-11-13	1971-11-13 00:00:00	1972-01-01	1972-01-01 00:00:00	32020		\N	45523	0	65363002	372328		0
11841	700	40481087	2010-11-24	2010-11-24 00:00:00	2010-12-01	2010-12-01 00:00:00	32020		\N	46263	0	444814009	40481087		0
11999	709	4112343	1950-09-27	1950-09-27 00:00:00	1950-10-08	1950-10-08 00:00:00	32020		\N	46956	0	195662009	4112343		0
12199	722	4237458	1989-07-26	1989-07-26 00:00:00	1989-08-25	1989-08-25 00:00:00	32020		\N	47801	0	58150001	4237458		0
12298	727	378419	2008-02-01	2008-02-01 00:00:00	\N	\N	32020		\N	48191	0	26929004	378419		0
12487	739	260139	1923-06-26	1923-06-26 00:00:00	1923-07-03	1923-07-03 00:00:00	32020		\N	48971	0	10509002	260139		0
12690	752	260139	1994-05-03	1994-05-03 00:00:00	1994-05-17	1994-05-17 00:00:00	32020		\N	49734	0	10509002	260139		0
12861	757	28060	1928-05-07	1928-05-07 00:00:00	1928-05-14	1928-05-14 00:00:00	32020		\N	50235	0	43878008	28060		0
12970	762	260139	1959-01-20	1959-01-20 00:00:00	1959-02-03	1959-02-03 00:00:00	32020		\N	50654	0	10509002	260139		0
13164	775	195588	1966-11-09	1966-11-09 00:00:00	1966-12-20	1966-12-20 00:00:00	32020		\N	51420	0	38822007	195588		0
13290	782	40481087	1918-08-19	1918-08-19 00:00:00	1918-09-02	1918-09-02 00:00:00	32020		\N	52009	0	444814009	40481087		0
13498	795	260139	1980-06-21	1980-06-21 00:00:00	1980-06-28	1980-06-28 00:00:00	32020		\N	52752	0	10509002	260139		0
13652	806	4152936	1967-03-06	1967-03-06 00:00:00	1967-03-20	1967-03-20 00:00:00	32020		\N	53469	0	283385000	4152936		0
3309	191	40481087	1971-02-21	1971-02-21 00:00:00	1971-02-28	1971-02-28 00:00:00	32020		\N	13074	0	444814009	40481087		0
13957	823	4112343	1954-12-22	1954-12-22 00:00:00	1954-12-29	1954-12-29 00:00:00	32020		\N	54585	0	195662009	4112343		0
14218	841	4296205	1972-11-26	1972-11-26 00:00:00	1972-12-17	1972-12-17 00:00:00	32020		\N	55570	0	403191005	4296205		0
14299	844	260139	1993-10-01	1993-10-01 00:00:00	1993-10-17	1993-10-17 00:00:00	32020		\N	55919	0	10509002	260139		0
14489	857	4294548	1985-09-29	1985-09-29 00:00:00	1986-01-26	1986-01-26 00:00:00	32020		\N	56591	0	75498004	4294548		0
14647	864	4112343	1927-12-01	1927-12-01 00:00:00	1927-12-13	1927-12-13 00:00:00	32020		\N	57272	0	195662009	4112343		0
14804	871	4266809	2003-12-30	2003-12-30 00:00:00	\N	\N	32020		\N	57959	0	397881000	4266809		0
15009	884	372328	1979-04-29	1979-04-29 00:00:00	1979-08-14	1979-08-14 00:00:00	32020		\N	58920	0	65363002	372328		0
15163	893	4112343	1971-06-04	1971-06-04 00:00:00	1971-06-11	1971-06-11 00:00:00	32020		\N	59489	0	195662009	4112343		0
15311	906	4059173	2011-10-07	2011-10-07 00:00:00	2012-01-05	2012-01-05 00:00:00	32020		\N	60236	0	16114001	4059173		0
15474	917	40481087	1990-04-01	1990-04-01 00:00:00	1990-04-22	1990-04-22 00:00:00	32020		\N	61076	0	444814009	40481087		0
15638	925	40481087	2006-03-19	2006-03-19 00:00:00	2006-04-02	2006-04-02 00:00:00	32020		\N	61604	0	444814009	40481087		0
15776	933	80180	2011-07-09	2011-07-09 00:00:00	\N	\N	32020		\N	62093	0	396275006	80180		0
16006	948	4059173	1967-05-12	1967-05-12 00:00:00	1967-08-10	1967-08-10 00:00:00	32020		\N	62961	0	16114001	4059173		0
16166	956	40481087	2010-08-27	2010-08-27 00:00:00	2010-09-03	2010-09-03 00:00:00	32020		\N	63517	0	444814009	40481087		0
16281	962	4112343	1951-02-09	1951-02-09 00:00:00	1951-02-22	1951-02-22 00:00:00	32020		\N	64085	0	195662009	4112343		0
16449	971	4112343	2008-03-03	2008-03-03 00:00:00	2008-03-16	2008-03-16 00:00:00	32020		\N	64586	0	195662009	4112343		0
16656	986	255848	1996-08-21	1996-08-21 00:00:00	\N	\N	32020		\N	65475	0	233604007	255848		0
16770	994	40481087	2011-08-16	2011-08-16 00:00:00	2011-08-23	2011-08-23 00:00:00	32020		\N	65895	0	444814009	40481087		0
16986	1015	40481087	2004-03-30	2004-03-30 00:00:00	2004-04-20	2004-04-20 00:00:00	32020		\N	66825	0	444814009	40481087		0
17226	1032	378001	1954-06-30	1954-06-30 00:00:00	1954-07-30	1954-07-30 00:00:00	32020		\N	67948	0	62106007	378001		0
17340	1039	4296204	2002-09-01	2002-09-01 00:00:00	2002-09-15	2002-09-15 00:00:00	32020		\N	68334	0	403190006	4296204		0
17477	1051	195588	2000-02-01	2000-02-01 00:00:00	2000-03-28	2000-03-28 00:00:00	32020		\N	68885	0	38822007	195588		0
17608	1057	4112343	1971-08-01	1971-08-01 00:00:00	1971-08-08	1971-08-08 00:00:00	32020		\N	69322	0	195662009	4112343		0
17845	1073	40480160	2010-08-20	2010-08-20 00:00:00	2010-09-19	2010-09-19 00:00:00	32020		\N	70304	0	443165006	40480160		0
17968	1081	260139	1985-01-19	1985-01-19 00:00:00	1985-02-02	1985-02-02 00:00:00	32020		\N	70844	0	10509002	260139		0
18148	1091	4152936	2016-04-07	2016-04-07 00:00:00	2016-04-28	2016-04-28 00:00:00	32020		\N	71727	0	283385000	4152936		0
18263	1098	40481087	1998-03-07	1998-03-07 00:00:00	1998-03-28	1998-03-28 00:00:00	32020		\N	72027	0	444814009	40481087		0
18473	1112	260139	2012-07-05	2012-07-05 00:00:00	2012-07-12	2012-07-12 00:00:00	32020		\N	73215	0	10509002	260139		0
18636	1120	40481087	2011-01-23	2011-01-23 00:00:00	2011-02-13	2011-02-13 00:00:00	32020		\N	73828	0	444814009	40481087		0
18816	1132	4146173	1978-03-01	1978-03-01 00:00:00	1978-04-30	1978-04-30 00:00:00	32020		\N	74535	0	307731004	4146173		0
18940	1137	260139	2010-05-15	2010-05-15 00:00:00	2010-05-22	2010-05-22 00:00:00	32020		\N	74886	0	10509002	260139		0
19118	1146	80180	1998-04-25	1998-04-25 00:00:00	\N	\N	32020		\N	75708	0	396275006	80180		0
19303	1155	40481087	2010-08-26	2010-08-26 00:00:00	2010-09-16	2010-09-16 00:00:00	32020		\N	76365	0	444814009	40481087		0
19565	1174	4112343	1981-10-31	1981-10-31 00:00:00	1981-11-09	1981-11-09 00:00:00	32020		\N	77344	0	195662009	4112343		0
19637	1177	40481087	1974-08-05	1974-08-05 00:00:00	1974-08-26	1974-08-26 00:00:00	32020		\N	77760	0	444814009	40481087		0
19851	1194	4109685	1978-09-15	1978-09-15 00:00:00	1978-10-06	1978-10-06 00:00:00	32020		\N	78687	0	284551006	4109685		0
19983	1205	260139	2016-10-06	2016-10-06 00:00:00	2016-10-13	2016-10-13 00:00:00	32020		\N	79203	0	10509002	260139		0
20170	1214	40481087	2018-12-17	2018-12-17 00:00:00	2018-12-31	2018-12-31 00:00:00	32020		\N	79890	0	444814009	40481087		0
20267	1219	40481087	1981-05-26	1981-05-26 00:00:00	1981-06-16	1981-06-16 00:00:00	32020		\N	80237	0	444814009	40481087		0
20481	1231	4112343	1952-10-12	1952-10-12 00:00:00	1952-10-21	1952-10-21 00:00:00	32020		\N	81059	0	195662009	4112343		0
20647	1239	40481087	2017-09-11	2017-09-11 00:00:00	2017-10-02	2017-10-02 00:00:00	32020		\N	81670	0	444814009	40481087		0
20769	1246	4059173	1969-09-26	1969-09-26 00:00:00	1969-11-25	1969-11-25 00:00:00	32020		\N	82052	0	16114001	4059173		0
20937	1257	80180	2010-03-08	2010-03-08 00:00:00	\N	\N	32020		\N	82816	0	396275006	80180		0
21182	1271	4112343	2013-05-05	2013-05-05 00:00:00	2013-05-16	2013-05-16 00:00:00	32020		\N	83841	0	195662009	4112343		0
165	7	4001336	2000-10-22	2000-10-22 00:00:00	2000-12-21	2000-12-21 00:00:00	32020		\N	633	0	110030002	4001336		0
10830	642	40481087	1994-05-01	1994-05-01 00:00:00	1994-05-08	1994-05-08 00:00:00	32020		\N	42489	0	444814009	40481087		0
11030	651	40481087	1984-08-02	1984-08-02 00:00:00	1984-08-09	1984-08-09 00:00:00	32020		\N	43099	0	444814009	40481087		0
11205	662	40481087	2001-06-21	2001-06-21 00:00:00	2001-06-28	2001-06-28 00:00:00	32020		\N	43701	0	444814009	40481087		0
11322	669	80180	2004-10-07	2004-10-07 00:00:00	\N	\N	32020		\N	44202	0	396275006	80180		0
11585	685	40481087	2016-01-11	2016-01-11 00:00:00	2016-01-25	2016-01-25 00:00:00	32020		\N	45279	0	444814009	40481087		0
11650	687	40481087	2018-03-02	2018-03-02 00:00:00	2018-03-23	2018-03-23 00:00:00	32020		\N	45470	0	444814009	40481087		0
11842	700	40481087	2004-12-16	2004-12-16 00:00:00	2004-12-30	2004-12-30 00:00:00	32020		\N	46289	0	444814009	40481087		0
12000	709	40481087	1986-04-24	1986-04-24 00:00:00	1986-05-08	1986-05-08 00:00:00	32020		\N	46966	0	444814009	40481087		0
12200	722	4112343	1974-07-16	1974-07-16 00:00:00	1974-07-29	1974-07-29 00:00:00	32020		\N	47772	0	195662009	4112343		0
12299	727	40481087	1984-05-31	1984-05-31 00:00:00	1984-06-14	1984-06-14 00:00:00	32020		\N	48254	0	444814009	40481087		0
12488	739	4237458	1991-08-15	1991-08-15 00:00:00	1991-10-14	1991-10-14 00:00:00	32020		\N	48934	0	58150001	4237458		0
12691	752	4112343	1985-11-21	1985-11-21 00:00:00	1985-12-04	1985-12-04 00:00:00	32020		\N	49655	0	195662009	4112343		0
12862	757	4112343	1961-02-06	1961-02-06 00:00:00	1961-02-15	1961-02-15 00:00:00	32020		\N	50238	0	195662009	4112343		0
12971	762	4112343	1994-10-09	1994-10-09 00:00:00	1994-10-19	1994-10-19 00:00:00	32020		\N	50665	0	195662009	4112343		0
13165	775	4149245	2016-05-24	2016-05-24 00:00:00	2016-06-30	2016-06-30 00:00:00	32020		\N	51435	0	30832001	4149245		0
13291	782	40481087	1941-10-06	1941-10-06 00:00:00	1941-10-13	1941-10-13 00:00:00	32020		\N	51980	0	444814009	40481087		0
13499	795	80502	2006-11-01	2006-11-01 00:00:00	\N	\N	32020		\N	52769	0	64859006	80502		0
13653	806	372328	1962-01-03	1962-01-03 00:00:00	1962-12-16	1962-12-16 00:00:00	32020		\N	53512	0	65363002	372328		0
3310	191	4112343	1977-07-04	1977-07-04 00:00:00	1977-07-13	1977-07-13 00:00:00	32020		\N	13024	0	195662009	4112343		0
13958	823	4112343	2017-11-19	2017-11-19 00:00:00	2017-11-27	2017-11-27 00:00:00	32020		\N	54533	0	195662009	4112343		0
14219	841	40481087	1984-02-10	1984-02-10 00:00:00	1984-02-17	1984-02-17 00:00:00	32020		\N	55526	0	444814009	40481087		0
14300	844	4112343	1992-01-28	1992-01-28 00:00:00	1992-02-09	1992-02-09 00:00:00	32020		\N	55893	0	195662009	4112343		0
14490	857	4112343	1976-07-19	1976-07-19 00:00:00	1976-07-30	1976-07-30 00:00:00	32020		\N	56659	0	195662009	4112343		0
14648	864	28060	1947-07-19	1947-07-19 00:00:00	1947-07-26	1947-07-26 00:00:00	32020		\N	57296	0	43878008	28060		0
14805	871	30753	2002-12-05	2002-12-05 00:00:00	\N	\N	32020		\N	57959	0	16761005	30753		0
15010	884	321042	2005-05-24	2005-05-24 00:00:00	\N	\N	32020		\N	58952	0	410429000	321042		0
15164	893	4296204	2012-06-25	2012-06-25 00:00:00	2012-07-09	2012-07-09 00:00:00	32020		\N	59536	0	403190006	4296204		0
15312	906	4116491	2017-02-17	2017-02-17 00:00:00	2017-04-05	2017-04-05 00:00:00	32020		\N	60224	0	301011002	4116491		0
15475	917	260139	1996-11-18	1996-11-18 00:00:00	1996-12-02	1996-12-02 00:00:00	32020		\N	60928	0	10509002	260139		0
15639	925	4283893	2014-06-28	2014-06-28 00:00:00	2015-02-14	2015-02-14 00:00:00	32020		\N	61628	0	36971009	4283893		0
15777	933	40481087	2009-10-17	2009-10-17 00:00:00	2009-10-24	2009-10-24 00:00:00	32020		\N	62071	0	444814009	40481087		0
16007	948	28060	1993-06-19	1993-06-19 00:00:00	1993-06-26	1993-06-26 00:00:00	32020		\N	62954	0	43878008	28060		0
16167	956	4152936	1952-05-27	1952-05-27 00:00:00	1952-06-17	1952-06-17 00:00:00	32020		\N	63552	0	283385000	4152936		0
16282	962	4296205	1962-02-01	1962-02-01 00:00:00	1962-03-08	1962-03-08 00:00:00	32020		\N	64025	0	403191005	4296205		0
16450	972	40481087	2015-12-07	2015-12-07 00:00:00	2015-12-28	2015-12-28 00:00:00	32020		\N	64676	0	444814009	40481087		0
16657	986	40481087	1975-06-05	1975-06-05 00:00:00	1975-06-12	1975-06-12 00:00:00	32020		\N	65442	0	444814009	40481087		0
16771	994	4112343	1992-09-07	1992-09-07 00:00:00	1992-09-20	1992-09-20 00:00:00	32020		\N	65908	0	195662009	4112343		0
16987	1015	260139	1979-12-29	1979-12-29 00:00:00	1980-01-05	1980-01-05 00:00:00	32020		\N	66766	0	10509002	260139		0
17227	1032	4294548	1975-08-19	1975-08-19 00:00:00	1975-08-26	1975-08-26 00:00:00	32020		\N	67957	0	75498004	4294548		0
17341	1039	40481087	2012-01-30	2012-01-30 00:00:00	2012-02-13	2012-02-13 00:00:00	32020		\N	68398	0	444814009	40481087		0
17478	1051	4112343	2013-11-28	2013-11-28 00:00:00	2013-12-08	2013-12-08 00:00:00	32020		\N	68909	0	195662009	4112343		0
17609	1057	40481087	1976-01-31	1976-01-31 00:00:00	1976-02-21	1976-02-21 00:00:00	32020		\N	69273	0	444814009	40481087		0
17846	1073	40481087	2000-04-25	2000-04-25 00:00:00	2000-05-02	2000-05-02 00:00:00	32020		\N	70423	0	444814009	40481087		0
17969	1081	40481087	1981-12-05	1981-12-05 00:00:00	1981-12-26	1981-12-26 00:00:00	32020		\N	70843	0	444814009	40481087		0
18149	1091	260139	1989-02-04	1989-02-04 00:00:00	1989-02-18	1989-02-18 00:00:00	32020		\N	71681	0	10509002	260139		0
18264	1098	40481087	2000-07-22	2000-07-22 00:00:00	2000-07-29	2000-07-29 00:00:00	32020		\N	72036	0	444814009	40481087		0
18474	1112	192671	2007-08-17	2007-08-17 00:00:00	\N	\N	32020		\N	73223	0	K92.2	35208414		0
18637	1120	372328	1961-08-27	1961-08-27 00:00:00	1961-11-06	1961-11-06 00:00:00	32020		\N	73848	0	65363002	372328		0
18817	1132	40481087	1968-07-19	1968-07-19 00:00:00	1968-08-09	1968-08-09 00:00:00	32020		\N	74533	0	444814009	40481087		0
18941	1137	378001	1965-10-21	1965-10-21 00:00:00	1965-12-20	1965-12-20 00:00:00	32020		\N	74976	0	62106007	378001		0
19119	1146	260139	2011-10-08	2011-10-08 00:00:00	2011-10-15	2011-10-15 00:00:00	32020		\N	75721	0	10509002	260139		0
19304	1155	372328	1967-10-14	1967-10-14 00:00:00	1968-01-29	1968-01-29 00:00:00	32020		\N	76319	0	65363002	372328		0
19566	1174	4156265	2003-01-31	2003-01-31 00:00:00	2003-02-21	2003-02-21 00:00:00	32020		\N	77374	0	370247008	4156265		0
19638	1177	40481087	2008-01-30	2008-01-30 00:00:00	2008-02-20	2008-02-20 00:00:00	32020		\N	77764	0	444814009	40481087		0
19852	1194	4112343	2011-01-13	2011-01-13 00:00:00	2011-01-23	2011-01-23 00:00:00	32020		\N	78733	0	195662009	4112343		0
19984	1205	4142905	1976-07-22	1976-07-22 00:00:00	1976-08-21	1976-08-21 00:00:00	32020		\N	79174	0	33737001	4142905		0
20171	1214	372328	1942-03-28	1942-03-28 00:00:00	1942-10-01	1942-10-01 00:00:00	32020		\N	79891	0	65363002	372328		0
20268	1219	260139	2013-10-08	2013-10-08 00:00:00	2013-10-15	2013-10-15 00:00:00	32020		\N	80213	0	10509002	260139		0
20482	1231	260139	1982-01-07	1982-01-07 00:00:00	1982-01-14	1982-01-14 00:00:00	32020		\N	81095	0	10509002	260139		0
20648	1239	260139	2015-10-20	2015-10-20 00:00:00	2015-10-27	2015-10-27 00:00:00	32020		\N	81642	0	10509002	260139		0
20770	1246	40481087	1945-06-11	1945-06-11 00:00:00	1945-06-25	1945-06-25 00:00:00	32020		\N	82039	0	444814009	40481087		0
20938	1257	192671	2010-04-21	2010-04-21 00:00:00	\N	\N	32020		\N	82801	0	K92.2	35208414		0
21183	1271	80180	2010-10-14	2010-10-14 00:00:00	\N	\N	32020		\N	83838	0	396275006	80180		0
166	7	4132546	2000-10-22	2000-10-22 00:00:00	\N	\N	32020		\N	633	0	275272006	4166590		0
10831	642	4285898	1970-08-13	1970-08-13 00:00:00	\N	\N	32020		\N	42554	0	68496003	4285898		0
11031	651	40481087	2006-04-08	2006-04-08 00:00:00	2006-04-29	2006-04-29 00:00:00	32020		\N	43097	0	444814009	40481087		0
11206	662	4027663	1993-09-13	1993-09-13 00:00:00	\N	\N	32020		\N	43731	0	13200003	4027663		0
11323	669	260139	2018-11-07	2018-11-07 00:00:00	2018-11-14	2018-11-14 00:00:00	32020		\N	44170	0	10509002	260139		0
11586	685	4112343	1988-01-31	1988-01-31 00:00:00	1988-02-13	1988-02-13 00:00:00	32020		\N	45278	0	195662009	4112343		0
11651	687	4112343	1975-11-18	1975-11-18 00:00:00	1975-11-27	1975-11-27 00:00:00	32020		\N	45573	0	195662009	4112343		0
11843	700	439777	2011-06-06	2011-06-06 00:00:00	\N	\N	32020		\N	46242	0	271737000	439777		0
12001	709	40481087	1993-03-08	1993-03-08 00:00:00	1993-03-29	1993-03-29 00:00:00	32020		\N	46926	0	444814009	40481087		0
12201	722	40481087	1975-11-11	1975-11-11 00:00:00	1975-11-18	1975-11-18 00:00:00	32020		\N	47763	0	444814009	40481087		0
12300	727	80180	1947-05-12	1947-05-12 00:00:00	\N	\N	32020		\N	48139	0	396275006	80180		0
12489	739	4112343	1949-10-08	1949-10-08 00:00:00	1949-10-21	1949-10-21 00:00:00	32020		\N	48973	0	195662009	4112343		0
12692	752	28060	1983-11-22	1983-11-22 00:00:00	1983-11-30	1983-11-30 00:00:00	32020		\N	49678	0	43878008	28060		0
12863	757	4112343	1942-02-03	1942-02-03 00:00:00	1942-02-12	1942-02-12 00:00:00	32020		\N	50208	0	195662009	4112343		0
12972	762	40481087	1958-07-30	1958-07-30 00:00:00	1958-08-20	1958-08-20 00:00:00	32020		\N	50674	0	444814009	40481087		0
13166	775	40481087	1971-04-07	1971-04-07 00:00:00	1971-04-21	1971-04-21 00:00:00	32020		\N	51421	0	444814009	40481087		0
13292	782	4112343	1945-06-09	1945-06-09 00:00:00	1945-06-19	1945-06-19 00:00:00	32020		\N	52023	0	195662009	4112343		0
13500	795	28060	1950-05-25	1950-05-25 00:00:00	1950-06-05	1950-06-05 00:00:00	32020		\N	52773	0	43878008	28060		0
13654	806	4134304	2010-01-03	2010-01-03 00:00:00	2010-04-03	2010-04-03 00:00:00	32020		\N	53470	0	263102004	4134304		0
3311	191	40481087	1992-09-13	1992-09-13 00:00:00	1992-10-04	1992-10-04 00:00:00	32020		\N	13068	0	444814009	40481087		0
13959	823	260139	1970-05-08	1970-05-08 00:00:00	1970-05-15	1970-05-15 00:00:00	32020		\N	54550	0	10509002	260139		0
14220	841	40481087	1988-05-03	1988-05-03 00:00:00	1988-05-17	1988-05-17 00:00:00	32020		\N	55573	0	444814009	40481087		0
14301	844	4027663	1994-04-16	1994-04-16 00:00:00	\N	\N	32020		\N	55873	0	13200003	4027663		0
14491	857	4294548	1992-09-14	1992-09-14 00:00:00	1992-10-12	1992-10-12 00:00:00	32020		\N	56664	0	75498004	4294548		0
14649	864	40481087	1973-06-28	1973-06-28 00:00:00	1973-07-12	1973-07-12 00:00:00	32020		\N	57233	0	444814009	40481087		0
14806	871	4113008	1975-10-28	1975-10-28 00:00:00	1975-11-11	1975-11-11 00:00:00	32020		\N	57956	0	284549007	4113008		0
15012	884	133834	1981-01-25	1981-01-25 00:00:00	\N	\N	32020		\N	58938	0	24079001	133834		0
15165	893	40481087	1959-10-24	1959-10-24 00:00:00	1959-11-14	1959-11-14 00:00:00	32020		\N	59474	0	444814009	40481087		0
15313	906	40481087	1977-01-12	1977-01-12 00:00:00	1977-01-19	1977-01-19 00:00:00	32020		\N	60243	0	444814009	40481087		0
15476	917	40481087	1967-03-02	1967-03-02 00:00:00	1967-03-09	1967-03-09 00:00:00	32020		\N	61084	0	444814009	40481087		0
15640	925	372328	1973-07-27	1973-07-27 00:00:00	1973-11-09	1973-11-09 00:00:00	32020		\N	61606	0	65363002	372328		0
15778	933	81151	1975-04-14	1975-04-14 00:00:00	1975-05-05	1975-05-05 00:00:00	32020		\N	62056	0	44465007	81151		0
16008	948	4283893	1972-01-16	1972-01-16 00:00:00	1972-05-21	1972-05-21 00:00:00	32020		\N	62930	0	36971009	4283893		0
16168	956	40481087	1945-03-03	1945-03-03 00:00:00	1945-03-10	1945-03-10 00:00:00	32020		\N	63538	0	444814009	40481087		0
16283	962	260139	1982-09-25	1982-09-25 00:00:00	1982-10-09	1982-10-09 00:00:00	32020		\N	64088	0	10509002	260139		0
16451	972	260139	2008-09-20	2008-09-20 00:00:00	2008-10-04	2008-10-04 00:00:00	32020		\N	64723	0	10509002	260139		0
16658	986	4112343	1923-07-28	1923-07-28 00:00:00	1923-08-05	1923-08-05 00:00:00	32020		\N	65457	0	195662009	4112343		0
16772	994	40481087	1982-12-07	1982-12-07 00:00:00	1982-12-21	1982-12-21 00:00:00	32020		\N	65893	0	444814009	40481087		0
16988	1015	4146173	1995-11-04	1995-11-04 00:00:00	1996-01-03	1996-01-03 00:00:00	32020		\N	66824	0	307731004	4146173		0
17228	1032	4112343	2004-12-08	2004-12-08 00:00:00	2004-12-19	2004-12-19 00:00:00	32020		\N	67931	0	195662009	4112343		0
17342	1039	4112343	2012-06-03	2012-06-03 00:00:00	2012-06-12	2012-06-12 00:00:00	32020		\N	68399	0	195662009	4112343		0
17479	1051	4112343	1969-03-21	1969-03-21 00:00:00	1969-03-29	1969-03-29 00:00:00	32020		\N	68863	0	195662009	4112343		0
17610	1057	80180	2003-11-27	2003-11-27 00:00:00	\N	\N	32020		\N	69306	0	396275006	80180		0
17847	1073	260139	1966-11-24	1966-11-24 00:00:00	1966-12-01	1966-12-01 00:00:00	32020		\N	70408	0	10509002	260139		0
17970	1081	28060	2003-07-01	2003-07-01 00:00:00	2003-07-09	2003-07-09 00:00:00	32020		\N	70837	0	43878008	28060		0
18150	1091	260139	1973-12-25	1973-12-25 00:00:00	1974-01-08	1974-01-08 00:00:00	32020		\N	71679	0	10509002	260139		0
18265	1098	81151	1961-09-09	1961-09-09 00:00:00	1961-09-30	1961-09-30 00:00:00	32020		\N	72028	0	44465007	81151		0
18475	1112	81151	1971-03-03	1971-03-03 00:00:00	1971-04-07	1971-04-07 00:00:00	32020		\N	73185	0	44465007	81151		0
18638	1120	40481087	1963-10-17	1963-10-17 00:00:00	1963-11-07	1963-11-07 00:00:00	32020		\N	73846	0	444814009	40481087		0
18818	1132	40481087	2017-04-02	2017-04-02 00:00:00	2017-04-23	2017-04-23 00:00:00	32020		\N	74496	0	444814009	40481087		0
18942	1137	4218389	1952-08-09	1952-08-09 00:00:00	1952-08-30	1952-08-30 00:00:00	32020		\N	74972	0	39848009	4218389		0
19120	1146	4152936	1965-06-12	1965-06-12 00:00:00	1965-07-03	1965-07-03 00:00:00	32020		\N	75738	0	283385000	4152936		0
19305	1155	28060	1976-08-14	1976-08-14 00:00:00	1976-08-22	1976-08-22 00:00:00	32020		\N	76302	0	43878008	28060		0
19567	1174	40481087	1968-11-07	1968-11-07 00:00:00	1968-11-14	1968-11-14 00:00:00	32020		\N	77391	0	444814009	40481087		0
19639	1177	40481087	2012-11-02	2012-11-02 00:00:00	2012-11-16	2012-11-16 00:00:00	32020		\N	77788	0	444814009	40481087		0
19853	1194	4112343	1971-06-19	1971-06-19 00:00:00	1971-06-29	1971-06-29 00:00:00	32020		\N	78726	0	195662009	4112343		0
19985	1205	40481087	1990-04-08	1990-04-08 00:00:00	1990-04-15	1990-04-15 00:00:00	32020		\N	79149	0	444814009	40481087		0
20172	1214	4152936	1945-10-27	1945-10-27 00:00:00	1945-11-17	1945-11-17 00:00:00	32020		\N	80002	0	283385000	4152936		0
20269	1219	40481087	1954-08-18	1954-08-18 00:00:00	1954-09-01	1954-09-01 00:00:00	32020		\N	80236	0	444814009	40481087		0
20483	1231	28060	1958-06-21	1958-06-21 00:00:00	1958-07-02	1958-07-02 00:00:00	32020		\N	81152	0	43878008	28060		0
20649	1239	4283893	1987-08-24	1987-08-24 00:00:00	1987-10-12	1987-10-12 00:00:00	32020		\N	81641	0	36971009	4283893		0
20771	1246	4134304	2005-07-24	2005-07-24 00:00:00	2005-08-23	2005-08-23 00:00:00	32020		\N	82056	0	263102004	4134304		0
20939	1257	4283893	2015-02-01	2015-02-01 00:00:00	2015-03-29	2015-03-29 00:00:00	32020		\N	82831	0	36971009	4283893		0
21184	1271	40481087	2011-07-07	2011-07-07 00:00:00	2011-07-14	2011-07-14 00:00:00	32020		\N	83824	0	444814009	40481087		0
10625	624	80180	1978-04-30	1978-04-30 00:00:00	\N	\N	32020		\N	41721	0	396275006	80180		0
10832	642	4266809	1971-06-09	1971-06-09 00:00:00	\N	\N	32020		\N	42554	0	397881000	4266809		0
11032	651	28060	1988-11-29	1988-11-29 00:00:00	1988-12-06	1988-12-06 00:00:00	32020		\N	43107	0	43878008	28060		0
11207	662	40481087	1993-08-17	1993-08-17 00:00:00	1993-08-24	1993-08-24 00:00:00	32020		\N	43731	0	444814009	40481087		0
11324	669	4112343	1972-03-22	1972-03-22 00:00:00	1972-04-01	1972-04-01 00:00:00	32020		\N	44164	0	195662009	4112343		0
11587	685	4296204	2005-05-23	2005-05-23 00:00:00	2005-06-13	2005-06-13 00:00:00	32020		\N	45307	0	403190006	4296204		0
11652	687	372328	1968-06-28	1968-06-28 00:00:00	1968-12-28	1968-12-28 00:00:00	32020		\N	45535	0	65363002	372328		0
11844	700	40481087	2008-05-19	2008-05-19 00:00:00	2008-06-02	2008-06-02 00:00:00	32020		\N	46262	0	444814009	40481087		0
12002	710	372328	1962-11-21	1962-11-21 00:00:00	1963-03-26	1963-03-26 00:00:00	32020		\N	47006	0	65363002	372328		0
12202	722	40481087	1970-11-10	1970-11-10 00:00:00	1970-12-01	1970-12-01 00:00:00	32020		\N	47741	0	444814009	40481087		0
12301	727	260139	1927-04-03	1927-04-03 00:00:00	1927-04-17	1927-04-17 00:00:00	32020		\N	48239	0	10509002	260139		0
12490	739	4296204	1988-10-15	1988-10-15 00:00:00	1988-10-29	1988-10-29 00:00:00	32020		\N	48933	0	403190006	4296204		0
12693	752	40481087	1988-05-26	1988-05-26 00:00:00	1988-06-09	1988-06-09 00:00:00	32020		\N	49718	0	444814009	40481087		0
12864	757	40481087	1956-11-05	1956-11-05 00:00:00	1956-11-26	1956-11-26 00:00:00	32020		\N	50191	0	444814009	40481087		0
12973	762	260139	2017-01-23	2017-01-23 00:00:00	2017-01-30	2017-01-30 00:00:00	32020		\N	50678	0	10509002	260139		0
13167	775	4142905	1947-05-03	1947-05-03 00:00:00	1947-06-02	1947-06-02 00:00:00	32020		\N	51447	0	33737001	4142905		0
13293	782	4155034	1978-12-24	1978-12-24 00:00:00	1979-01-07	1979-01-07 00:00:00	32020		\N	52020	0	283371005	4155034		0
13501	795	260139	1987-07-23	1987-07-23 00:00:00	1987-07-30	1987-07-30 00:00:00	32020		\N	52709	0	10509002	260139		0
13655	806	40481087	2011-03-23	2011-03-23 00:00:00	2011-04-06	2011-04-06 00:00:00	32020		\N	53511	0	444814009	40481087		0
3312	191	260139	1957-10-12	1957-10-12 00:00:00	1957-10-19	1957-10-19 00:00:00	32020		\N	13065	0	10509002	260139		0
13960	825	372328	1971-03-22	1971-03-22 00:00:00	1971-06-19	1971-06-19 00:00:00	32020		\N	54679	0	65363002	372328		0
14221	841	30753	1990-04-01	1990-04-01 00:00:00	\N	\N	32020		\N	55574	0	16761005	30753		0
14302	844	4112343	2008-03-01	2008-03-01 00:00:00	2008-03-12	2008-03-12 00:00:00	32020		\N	55874	0	195662009	4112343		0
14492	857	258780	1990-03-11	1990-03-11 00:00:00	\N	\N	32020		\N	56584	0	185086009	258780		0
14650	864	255848	2011-03-20	2011-03-20 00:00:00	\N	\N	32020		\N	57281	0	233604007	255848		0
14807	871	260139	1971-09-20	1971-09-20 00:00:00	1971-10-04	1971-10-04 00:00:00	32020		\N	57915	0	10509002	260139		0
15013	884	260139	2017-06-16	2017-06-16 00:00:00	2017-06-23	2017-06-23 00:00:00	32020		\N	58913	0	10509002	260139		0
15166	893	260139	1963-08-31	1963-08-31 00:00:00	1963-09-07	1963-09-07 00:00:00	32020		\N	59488	0	10509002	260139		0
15314	906	40481087	2013-01-02	2013-01-02 00:00:00	2013-01-16	2013-01-16 00:00:00	32020		\N	60223	0	444814009	40481087		0
15477	917	4094814	2005-11-06	2005-11-06 00:00:00	2006-02-04	2006-02-04 00:00:00	32020		\N	61083	0	262574004	4094814		0
15641	925	372328	1971-05-18	1971-05-18 00:00:00	1971-11-05	1971-11-05 00:00:00	32020		\N	61638	0	65363002	372328		0
15779	933	4218389	1981-09-30	1981-09-30 00:00:00	1981-10-21	1981-10-21 00:00:00	32020		\N	62057	0	39848009	4218389		0
16009	948	4112343	1989-12-27	1989-12-27 00:00:00	1990-01-04	1990-01-04 00:00:00	32020		\N	62970	0	195662009	4112343		0
16169	956	78272	1944-12-14	1944-12-14 00:00:00	1945-01-04	1945-01-04 00:00:00	32020		\N	63549	0	70704007	78272		0
16284	962	40481087	2005-01-06	2005-01-06 00:00:00	2005-01-20	2005-01-20 00:00:00	32020		\N	64059	0	444814009	40481087		0
16452	972	80180	2002-06-12	2002-06-12 00:00:00	\N	\N	32020		\N	64678	0	396275006	80180		0
16659	986	260139	1934-05-27	1934-05-27 00:00:00	1934-06-03	1934-06-03 00:00:00	32020		\N	65447	0	10509002	260139		0
16773	994	40481087	1968-03-28	1968-03-28 00:00:00	1968-04-18	1968-04-18 00:00:00	32020		\N	65907	0	444814009	40481087		0
16989	1015	260139	1994-11-25	1994-11-25 00:00:00	1994-12-09	1994-12-09 00:00:00	32020		\N	66820	0	10509002	260139		0
17229	1032	40481087	1959-08-08	1959-08-08 00:00:00	1959-08-29	1959-08-29 00:00:00	32020		\N	67903	0	444814009	40481087		0
17343	1039	40479422	1996-09-27	1996-09-27 00:00:00	1996-12-03	1996-12-03 00:00:00	32020		\N	68332	0	444448004	40479422		0
17480	1051	372328	1970-01-14	1970-01-14 00:00:00	1971-01-26	1971-01-26 00:00:00	32020		\N	68911	0	65363002	372328		0
17611	1057	4059173	1989-01-08	1989-01-08 00:00:00	1989-02-07	1989-02-07 00:00:00	32020		\N	69302	0	16114001	4059173		0
17848	1073	40481087	1995-12-21	1995-12-21 00:00:00	1996-01-11	1996-01-11 00:00:00	32020		\N	70313	0	444814009	40481087		0
17971	1081	40481087	1981-02-23	1981-02-23 00:00:00	1981-03-02	1981-03-02 00:00:00	32020		\N	70834	0	444814009	40481087		0
18151	1091	4112343	1990-12-10	1990-12-10 00:00:00	1990-12-18	1990-12-18 00:00:00	32020		\N	71733	0	195662009	4112343		0
18266	1098	4112343	1976-12-10	1976-12-10 00:00:00	1976-12-23	1976-12-23 00:00:00	32020		\N	72034	0	195662009	4112343		0
18476	1112	40481087	2005-06-21	2005-06-21 00:00:00	2005-07-12	2005-07-12 00:00:00	32020		\N	73188	0	444814009	40481087		0
18639	1120	4278672	1987-10-26	1987-10-26 00:00:00	1988-01-24	1988-01-24 00:00:00	32020		\N	73812	0	65966004	4278672		0
18819	1132	40481087	2015-10-27	2015-10-27 00:00:00	2015-11-03	2015-11-03 00:00:00	32020		\N	74509	0	444814009	40481087		0
18943	1137	80180	1991-10-24	1991-10-24 00:00:00	\N	\N	32020		\N	74966	0	396275006	80180		0
19121	1146	372328	1959-12-11	1959-12-11 00:00:00	1960-03-24	1960-03-24 00:00:00	32020		\N	75748	0	65363002	372328		0
19322	1158	372328	1980-11-27	1980-11-27 00:00:00	1981-01-11	1981-01-11 00:00:00	32020		\N	76524	0	65363002	372328		0
19568	1174	40481087	1992-12-03	1992-12-03 00:00:00	1992-12-24	1992-12-24 00:00:00	32020		\N	77345	0	444814009	40481087		0
19640	1177	4112343	1978-01-11	1978-01-11 00:00:00	1978-01-20	1978-01-20 00:00:00	32020		\N	77775	0	195662009	4112343		0
19854	1194	4237458	1995-07-09	1995-07-09 00:00:00	1995-10-07	1995-10-07 00:00:00	32020		\N	78688	0	58150001	4237458		0
19986	1205	4116491	1981-10-16	1981-10-16 00:00:00	1981-12-03	1981-12-03 00:00:00	32020		\N	79145	0	301011002	4116491		0
20173	1214	40481087	1964-01-27	1964-01-27 00:00:00	1964-02-17	1964-02-17 00:00:00	32020		\N	79899	0	444814009	40481087		0
20270	1219	80180	1978-12-24	1978-12-24 00:00:00	\N	\N	32020		\N	80256	0	396275006	80180		0
20484	1231	40481087	1965-03-30	1965-03-30 00:00:00	1965-04-13	1965-04-13 00:00:00	32020		\N	81106	0	444814009	40481087		0
20650	1239	260139	2010-02-27	2010-02-27 00:00:00	2010-03-13	2010-03-13 00:00:00	32020		\N	81646	0	10509002	260139		0
20772	1246	4237458	1947-07-03	1947-07-03 00:00:00	1947-09-01	1947-09-01 00:00:00	32020		\N	82134	0	58150001	4237458		0
20940	1257	372328	1977-04-05	1977-04-05 00:00:00	1978-03-04	1978-03-04 00:00:00	32020		\N	82809	0	65363002	372328		0
21185	1271	40481087	2009-06-18	2009-06-18 00:00:00	2009-07-09	2009-07-09 00:00:00	32020		\N	83840	0	444814009	40481087		0
10626	624	4142905	1957-01-30	1957-01-30 00:00:00	1957-03-31	1957-03-31 00:00:00	32020		\N	41689	0	33737001	4142905		0
10833	642	80180	1971-06-09	1971-06-09 00:00:00	\N	\N	32020		\N	42554	0	396275006	80180		0
11033	651	81893	2010-04-22	2010-04-22 00:00:00	\N	\N	32020		\N	43084	0	64766004	81893		0
11208	662	40481087	1975-05-26	1975-05-26 00:00:00	1975-06-16	1975-06-16 00:00:00	32020		\N	43741	0	444814009	40481087		0
11325	669	260139	2007-05-31	2007-05-31 00:00:00	2007-06-14	2007-06-14 00:00:00	32020		\N	44193	0	10509002	260139		0
11588	685	78272	1980-04-15	1980-04-15 00:00:00	1980-05-20	1980-05-20 00:00:00	32020		\N	45304	0	70704007	78272		0
11653	687	4237458	1981-07-06	1981-07-06 00:00:00	1981-10-04	1981-10-04 00:00:00	32020		\N	45488	0	58150001	4237458		0
11845	700	40481087	2000-10-17	2000-10-17 00:00:00	2000-10-31	2000-10-31 00:00:00	32020		\N	46235	0	444814009	40481087		0
12003	710	40481087	1980-02-18	1980-02-18 00:00:00	1980-03-10	1980-03-10 00:00:00	32020		\N	47002	0	444814009	40481087		0
12203	722	40481087	2006-07-27	2006-07-27 00:00:00	2006-08-03	2006-08-03 00:00:00	32020		\N	47775	0	444814009	40481087		0
12302	727	81151	1944-05-17	1944-05-17 00:00:00	1944-06-07	1944-06-07 00:00:00	32020		\N	48205	0	44465007	81151		0
12491	739	4146173	1930-08-16	1930-08-16 00:00:00	1930-10-15	1930-10-15 00:00:00	32020		\N	48976	0	307731004	4146173		0
12694	752	40481087	2001-01-20	2001-01-20 00:00:00	2001-02-03	2001-02-03 00:00:00	32020		\N	49736	0	444814009	40481087		0
12865	757	28060	1926-05-05	1926-05-05 00:00:00	1926-05-15	1926-05-15 00:00:00	32020		\N	50234	0	43878008	28060		0
12974	762	80502	2014-09-10	2014-09-10 00:00:00	\N	\N	32020		\N	50729	0	64859006	80502		0
13168	775	81151	1955-04-19	1955-04-19 00:00:00	1955-05-17	1955-05-17 00:00:00	32020		\N	51449	0	44465007	81151		0
13294	782	4112343	1963-08-28	1963-08-28 00:00:00	1963-09-07	1963-09-07 00:00:00	32020		\N	51966	0	195662009	4112343		0
13502	795	28060	1940-03-02	1940-03-02 00:00:00	1940-03-14	1940-03-14 00:00:00	32020		\N	52704	0	43878008	28060		0
13656	806	40481087	2000-05-22	2000-05-22 00:00:00	2000-06-05	2000-06-05 00:00:00	32020		\N	53483	0	444814009	40481087		0
3313	191	40481087	1931-03-10	1931-03-10 00:00:00	1931-03-17	1931-03-17 00:00:00	32020		\N	13061	0	444814009	40481087		0
13961	825	40481087	2018-04-05	2018-04-05 00:00:00	2018-04-12	2018-04-12 00:00:00	32020		\N	54644	0	444814009	40481087		0
14222	841	80180	1991-05-26	1991-05-26 00:00:00	\N	\N	32020		\N	55515	0	396275006	80180		0
14303	844	4112343	1978-05-30	1978-05-30 00:00:00	1978-06-07	1978-06-07 00:00:00	32020		\N	55951	0	195662009	4112343		0
14493	857	40481087	1988-10-21	1988-10-21 00:00:00	1988-10-28	1988-10-28 00:00:00	32020		\N	56582	0	444814009	40481087		0
14651	864	260139	2002-07-14	2002-07-14 00:00:00	2002-07-21	2002-07-21 00:00:00	32020		\N	57302	0	10509002	260139		0
14808	871	4112343	1986-06-18	1986-06-18 00:00:00	1986-06-29	1986-06-29 00:00:00	32020		\N	57917	0	195662009	4112343		0
15014	884	80180	2017-09-16	2017-09-16 00:00:00	\N	\N	32020		\N	58968	0	396275006	80180		0
15167	893	40481087	2014-08-01	2014-08-01 00:00:00	2014-08-22	2014-08-22 00:00:00	32020		\N	59494	0	444814009	40481087		0
15315	906	40481087	2006-02-24	2006-02-24 00:00:00	2006-03-03	2006-03-03 00:00:00	32020		\N	60253	0	444814009	40481087		0
15478	917	4146173	1976-08-05	1976-08-05 00:00:00	1976-10-04	1976-10-04 00:00:00	32020		\N	60999	0	307731004	4146173		0
15642	925	4142905	1999-04-21	1999-04-21 00:00:00	1999-07-20	1999-07-20 00:00:00	32020		\N	61600	0	33737001	4142905		0
15794	935	4296204	1976-11-05	1976-11-05 00:00:00	1976-11-19	1976-11-19 00:00:00	32020		\N	62227	0	403190006	4296204		0
16010	948	40479422	1964-05-20	1964-05-20 00:00:00	1964-07-26	1964-07-26 00:00:00	32020		\N	62960	0	444448004	40479422		0
16170	956	260139	1949-08-29	1949-08-29 00:00:00	1949-09-12	1949-09-12 00:00:00	32020		\N	63491	0	10509002	260139		0
16285	962	4310024	1992-11-29	1992-11-29 00:00:00	\N	\N	32020		\N	64092	0	424802006	4310024		0
16453	972	372328	1967-01-27	1967-01-27 00:00:00	1967-05-10	1967-05-10 00:00:00	32020		\N	64713	0	65363002	372328		0
16660	986	4112343	1934-06-21	1934-06-21 00:00:00	1934-07-02	1934-07-02 00:00:00	32020		\N	65506	0	195662009	4112343		0
16774	994	4112343	2008-10-11	2008-10-11 00:00:00	2008-10-19	2008-10-19 00:00:00	32020		\N	65913	0	195662009	4112343		0
16990	1015	80180	1988-06-04	1988-06-04 00:00:00	\N	\N	32020		\N	66786	0	396275006	80180		0
17230	1032	257012	1976-09-29	1976-09-29 00:00:00	1997-12-09	1997-12-09 00:00:00	32020		\N	67904	0	40055000	257012		0
17344	1039	40481087	1980-02-01	1980-02-01 00:00:00	1980-02-08	1980-02-08 00:00:00	32020		\N	68396	0	444814009	40481087		0
17481	1051	4112343	1975-10-15	1975-10-15 00:00:00	1975-10-24	1975-10-24 00:00:00	32020		\N	68861	0	195662009	4112343		0
17612	1058	40481087	1956-03-29	1956-03-29 00:00:00	1956-04-12	1956-04-12 00:00:00	32020		\N	69380	0	444814009	40481087		0
17849	1073	4112343	1986-02-19	1986-02-19 00:00:00	1986-03-03	1986-03-03 00:00:00	32020		\N	70312	0	195662009	4112343		0
17972	1081	4112343	1984-07-15	1984-07-15 00:00:00	1984-07-26	1984-07-26 00:00:00	32020		\N	70863	0	195662009	4112343		0
18152	1091	260139	1985-04-18	1985-04-18 00:00:00	1985-04-25	1985-04-25 00:00:00	32020		\N	71680	0	10509002	260139		0
18267	1098	4112343	2006-11-04	2006-11-04 00:00:00	2006-11-11	2006-11-11 00:00:00	32020		\N	72067	0	195662009	4112343		0
18477	1112	260139	1990-11-05	1990-11-05 00:00:00	1990-11-12	1990-11-12 00:00:00	32020		\N	73168	0	10509002	260139		0
18640	1120	4112343	2012-12-04	2012-12-04 00:00:00	2012-12-11	2012-12-11 00:00:00	32020		\N	73829	0	195662009	4112343		0
18820	1132	260139	2010-04-24	2010-04-24 00:00:00	2010-05-01	2010-05-01 00:00:00	32020		\N	74495	0	10509002	260139		0
18944	1137	81151	1989-10-02	1989-10-02 00:00:00	1989-10-23	1989-10-23 00:00:00	32020		\N	74935	0	44465007	81151		0
19122	1146	40481087	2006-11-15	2006-11-15 00:00:00	2006-11-29	2006-11-29 00:00:00	32020		\N	75672	0	444814009	40481087		0
19323	1158	192671	2016-12-27	2016-12-27 00:00:00	\N	\N	32020		\N	76534	0	K92.2	35208414		0
19569	1174	372328	1943-07-27	1943-07-27 00:00:00	1943-12-19	1943-12-19 00:00:00	32020		\N	77366	0	65363002	372328		0
19641	1177	260139	1989-05-13	1989-05-13 00:00:00	1989-05-27	1989-05-27 00:00:00	32020		\N	77761	0	10509002	260139		0
19855	1194	372328	1962-08-10	1962-08-10 00:00:00	1962-08-24	1962-08-24 00:00:00	32020		\N	78691	0	65363002	372328		0
19987	1205	4112343	2001-07-27	2001-07-27 00:00:00	2001-08-03	2001-08-03 00:00:00	32020		\N	79212	0	195662009	4112343		0
20174	1214	260139	1993-05-19	1993-05-19 00:00:00	1993-06-02	1993-06-02 00:00:00	32020		\N	79906	0	10509002	260139		0
20271	1219	81151	1978-08-11	1978-08-11 00:00:00	1978-08-25	1978-08-25 00:00:00	32020		\N	80256	0	44465007	81151		0
20485	1231	4112343	2015-03-31	2015-03-31 00:00:00	2015-04-08	2015-04-08 00:00:00	32020		\N	81097	0	195662009	4112343		0
20651	1239	40481087	2018-10-03	2018-10-03 00:00:00	2018-10-17	2018-10-17 00:00:00	32020		\N	81675	0	444814009	40481087		0
20773	1246	4112343	1991-09-22	1991-09-22 00:00:00	1991-09-30	1991-09-30 00:00:00	32020		\N	82023	0	195662009	4112343		0
20941	1257	4112343	2018-05-30	2018-05-30 00:00:00	2018-06-11	2018-06-11 00:00:00	32020		\N	82806	0	195662009	4112343		0
21186	1271	4285898	2010-01-17	2010-01-17 00:00:00	\N	\N	32020		\N	83840	0	68496003	4285898		0
10627	624	4294548	1945-03-13	1945-03-13 00:00:00	1945-05-08	1945-05-08 00:00:00	32020		\N	41633	0	75498004	4294548		0
10834	642	4294548	1973-08-19	1973-08-19 00:00:00	1973-09-16	1973-09-16 00:00:00	32020		\N	42524	0	75498004	4294548		0
11034	651	260139	2013-11-22	2013-11-22 00:00:00	2013-12-06	2013-12-06 00:00:00	32020		\N	43110	0	10509002	260139		0
11209	662	40481087	1970-09-21	1970-09-21 00:00:00	1970-10-12	1970-10-12 00:00:00	32020		\N	43719	0	444814009	40481087		0
11326	669	4294548	2012-02-25	2012-02-25 00:00:00	2012-03-17	2012-03-17 00:00:00	32020		\N	44194	0	75498004	4294548		0
11589	685	440086	1974-02-05	1974-02-05 00:00:00	1978-04-25	1978-04-25 00:00:00	32020		\N	45308	0	192127007	440086		0
11654	687	40481087	1982-10-08	1982-10-08 00:00:00	1982-10-29	1982-10-29 00:00:00	32020		\N	45576	0	444814009	40481087		0
11846	700	40481087	1998-08-29	1998-08-29 00:00:00	1998-09-05	1998-09-05 00:00:00	32020		\N	46287	0	444814009	40481087		0
12004	710	40481087	1967-03-23	1967-03-23 00:00:00	1967-03-30	1967-03-30 00:00:00	32020		\N	47043	0	444814009	40481087		0
12204	722	4112343	1980-09-10	1980-09-10 00:00:00	1980-09-17	1980-09-17 00:00:00	32020		\N	47746	0	195662009	4112343		0
12303	727	80502	1993-04-23	1993-04-23 00:00:00	\N	\N	32020		\N	48159	0	64859006	80502		0
12492	739	260139	1927-10-11	1927-10-11 00:00:00	1927-10-25	1927-10-25 00:00:00	32020		\N	48972	0	10509002	260139		0
12695	752	260139	2017-12-01	2017-12-01 00:00:00	2017-12-15	2017-12-15 00:00:00	32020		\N	49683	0	10509002	260139		0
12866	757	4113008	1978-09-22	1978-09-22 00:00:00	1978-10-06	1978-10-06 00:00:00	32020		\N	50288	0	284549007	4113008		0
12975	762	40481087	2004-08-04	2004-08-04 00:00:00	2004-08-18	2004-08-18 00:00:00	32020		\N	50685	0	444814009	40481087		0
13169	775	260139	1962-07-23	1962-07-23 00:00:00	1962-08-06	1962-08-06 00:00:00	32020		\N	51453	0	10509002	260139		0
13295	782	260139	1911-12-17	1911-12-17 00:00:00	1911-12-31	1911-12-31 00:00:00	32020		\N	51989	0	10509002	260139		0
13503	795	195588	1979-09-18	1979-09-18 00:00:00	1979-11-08	1979-11-08 00:00:00	32020		\N	52708	0	38822007	195588		0
13657	806	30753	1996-02-14	1996-02-14 00:00:00	\N	\N	32020		\N	53496	0	16761005	30753		0
3314	191	4112343	1953-05-13	1953-05-13 00:00:00	1953-05-23	1953-05-23 00:00:00	32020		\N	13063	0	195662009	4112343		0
13962	825	260139	1988-02-06	1988-02-06 00:00:00	1988-02-13	1988-02-13 00:00:00	32020		\N	54665	0	10509002	260139		0
14223	841	192671	1991-06-27	1991-06-27 00:00:00	\N	\N	32020		\N	55547	0	K92.2	35208414		0
14304	844	28060	1972-05-22	1972-05-22 00:00:00	1972-05-29	1972-05-29 00:00:00	32020		\N	55888	0	43878008	28060		0
14494	857	4113008	1979-02-09	1979-02-09 00:00:00	1979-02-23	1979-02-23 00:00:00	32020		\N	56578	0	284549007	4113008		0
14652	864	317576	2003-07-28	2003-07-28 00:00:00	\N	\N	32020		\N	57248	0	53741008	317576		0
14809	871	40481087	2005-12-21	2005-12-21 00:00:00	2006-01-11	2006-01-11 00:00:00	32020		\N	57942	0	444814009	40481087		0
15015	884	4237458	2007-02-25	2007-02-25 00:00:00	2007-05-26	2007-05-26 00:00:00	32020		\N	58953	0	58150001	4237458		0
15168	893	40481087	1958-10-01	1958-10-01 00:00:00	1958-10-22	1958-10-22 00:00:00	32020		\N	59472	0	444814009	40481087		0
15316	906	4218389	2001-10-08	2001-10-08 00:00:00	2001-10-29	2001-10-29 00:00:00	32020		\N	60235	0	39848009	4218389		0
15479	917	440086	1973-05-13	1973-05-13 00:00:00	1976-10-17	1976-10-17 00:00:00	32020		\N	60953	0	192127007	440086		0
15643	925	4278672	2005-06-18	2005-06-18 00:00:00	2005-08-17	2005-08-17 00:00:00	32020		\N	61601	0	65966004	4278672		0
15795	935	378001	1932-05-30	1932-05-30 00:00:00	1932-06-29	1932-06-29 00:00:00	32020		\N	62224	0	62106007	378001		0
16011	948	40481087	1984-10-04	1984-10-04 00:00:00	1984-10-18	1984-10-18 00:00:00	32020		\N	62917	0	444814009	40481087		0
16171	956	260139	2014-09-28	2014-09-28 00:00:00	2014-10-05	2014-10-05 00:00:00	32020		\N	63446	0	10509002	260139		0
16286	962	4146173	1973-07-08	1973-07-08 00:00:00	1973-09-06	1973-09-06 00:00:00	32020		\N	64037	0	307731004	4146173		0
16454	972	40481087	2005-04-12	2005-04-12 00:00:00	2005-04-26	2005-04-26 00:00:00	32020		\N	64675	0	444814009	40481087		0
16661	986	80180	1951-11-04	1951-11-04 00:00:00	\N	\N	32020		\N	65469	0	396275006	80180		0
16775	994	378001	1993-02-23	1993-02-23 00:00:00	1993-04-24	1993-04-24 00:00:00	32020		\N	65927	0	62106007	378001		0
16991	1015	40481087	1984-07-23	1984-07-23 00:00:00	1984-08-06	1984-08-06 00:00:00	32020		\N	66767	0	444814009	40481087		0
17231	1032	260139	1980-10-13	1980-10-13 00:00:00	1980-10-20	1980-10-20 00:00:00	32020		\N	67885	0	10509002	260139		0
17345	1039	40481087	1982-06-06	1982-06-06 00:00:00	1982-06-27	1982-06-27 00:00:00	32020		\N	68338	0	444814009	40481087		0
17482	1051	40481087	1975-09-20	1975-09-20 00:00:00	1975-10-04	1975-10-04 00:00:00	32020		\N	68866	0	444814009	40481087		0
17613	1058	40481087	2007-09-29	2007-09-29 00:00:00	2007-10-06	2007-10-06 00:00:00	32020		\N	69429	0	444814009	40481087		0
17850	1073	78272	2004-06-17	2004-06-17 00:00:00	2004-07-22	2004-07-22 00:00:00	32020		\N	70303	0	70704007	78272		0
17973	1081	4112343	1995-09-30	1995-09-30 00:00:00	1995-10-10	1995-10-10 00:00:00	32020		\N	70836	0	195662009	4112343		0
18153	1091	40481087	1999-10-31	1999-10-31 00:00:00	1999-11-21	1999-11-21 00:00:00	32020		\N	71699	0	444814009	40481087		0
18268	1099	372328	1977-05-09	1977-05-09 00:00:00	1977-06-04	1977-06-04 00:00:00	32020		\N	72191	0	65363002	372328		0
18478	1112	4283893	2011-02-05	2011-02-05 00:00:00	2011-04-02	2011-04-02 00:00:00	32020		\N	73170	0	36971009	4283893		0
18641	1120	4283893	1968-08-19	1968-08-19 00:00:00	1968-11-18	1968-11-18 00:00:00	32020		\N	73858	0	36971009	4283893		0
18821	1132	4112343	2016-02-14	2016-02-14 00:00:00	2016-02-21	2016-02-21 00:00:00	32020		\N	74539	0	195662009	4112343		0
18945	1137	40481087	1984-09-07	1984-09-07 00:00:00	1984-09-14	1984-09-14 00:00:00	32020		\N	74940	0	444814009	40481087		0
19123	1146	28060	2001-12-10	2001-12-10 00:00:00	2001-12-22	2001-12-22 00:00:00	32020		\N	75719	0	43878008	28060		0
19324	1158	40481087	1995-10-13	1995-10-13 00:00:00	1995-10-20	1995-10-20 00:00:00	32020		\N	76488	0	444814009	40481087		0
19570	1175	28060	1965-04-01	1965-04-01 00:00:00	1965-04-09	1965-04-09 00:00:00	32020		\N	77431	0	43878008	28060		0
19642	1177	40481087	2005-12-15	2005-12-15 00:00:00	2006-01-05	2006-01-05 00:00:00	32020		\N	77777	0	444814009	40481087		0
19856	1194	260139	1999-03-30	1999-03-30 00:00:00	1999-04-13	1999-04-13 00:00:00	32020		\N	78695	0	10509002	260139		0
19988	1205	81151	1974-08-04	1974-08-04 00:00:00	1974-09-01	1974-09-01 00:00:00	32020		\N	79173	0	44465007	81151		0
20175	1214	28060	2018-04-05	2018-04-05 00:00:00	2018-04-15	2018-04-15 00:00:00	32020		\N	79927	0	43878008	28060		0
20272	1219	4112343	1942-11-14	1942-11-14 00:00:00	1942-11-25	1942-11-25 00:00:00	32020		\N	80208	0	195662009	4112343		0
20486	1231	4112343	2009-08-18	2009-08-18 00:00:00	2009-08-25	2009-08-25 00:00:00	32020		\N	81110	0	195662009	4112343		0
20667	1242	4112343	1986-05-19	1986-05-19 00:00:00	1986-05-28	1986-05-28 00:00:00	32020		\N	81794	0	195662009	4112343		0
20774	1246	260139	2005-04-12	2005-04-12 00:00:00	2005-04-19	2005-04-19 00:00:00	32020		\N	82091	0	10509002	260139		0
20942	1257	40481087	1977-09-09	1977-09-09 00:00:00	1977-09-16	1977-09-16 00:00:00	32020		\N	82844	0	444814009	40481087		0
21187	1271	4112343	1991-09-17	1991-09-17 00:00:00	1991-09-27	1991-09-27 00:00:00	32020		\N	83839	0	195662009	4112343		0
10628	624	4218389	1964-07-22	1964-07-22 00:00:00	1964-08-19	1964-08-19 00:00:00	32020		\N	41690	0	39848009	4218389		0
10835	642	4152936	1949-12-11	1949-12-11 00:00:00	1950-01-01	1950-01-01 00:00:00	32020		\N	42462	0	283385000	4152936		0
11035	651	4027663	2002-04-29	2002-04-29 00:00:00	\N	\N	32020		\N	43092	0	13200003	4027663		0
11210	662	4296205	1971-04-27	1971-04-27 00:00:00	1971-05-25	1971-05-25 00:00:00	32020		\N	43750	0	403191005	4296205		0
11327	669	260139	2002-10-16	2002-10-16 00:00:00	2002-10-23	2002-10-23 00:00:00	32020		\N	44178	0	10509002	260139		0
11590	685	81151	1977-07-09	1977-07-09 00:00:00	1977-07-30	1977-07-30 00:00:00	32020		\N	45303	0	44465007	81151		0
11655	687	4218389	2013-09-02	2013-09-02 00:00:00	2013-09-30	2013-09-30 00:00:00	32020		\N	45497	0	39848009	4218389		0
11847	700	40481087	1993-01-28	1993-01-28 00:00:00	1993-02-18	1993-02-18 00:00:00	32020		\N	46254	0	444814009	40481087		0
12005	710	40481087	1968-05-31	1968-05-31 00:00:00	1968-06-14	1968-06-14 00:00:00	32020		\N	47035	0	444814009	40481087		0
12205	722	260139	1975-08-19	1975-08-19 00:00:00	1975-08-26	1975-08-26 00:00:00	32020		\N	47762	0	10509002	260139		0
12304	727	40481087	1960-01-25	1960-01-25 00:00:00	1960-02-08	1960-02-08 00:00:00	32020		\N	48243	0	444814009	40481087		0
12493	739	40481087	1916-11-06	1916-11-06 00:00:00	1916-11-27	1916-11-27 00:00:00	32020		\N	48970	0	444814009	40481087		0
12696	752	4152936	1979-10-18	1979-10-18 00:00:00	1979-11-08	1979-11-08 00:00:00	32020		\N	49641	0	283385000	4152936		0
12867	757	81893	1948-05-23	1948-05-23 00:00:00	\N	\N	32020		\N	50189	0	64766004	81893		0
12976	762	40481087	1971-10-14	1971-10-14 00:00:00	1971-11-04	1971-11-04 00:00:00	32020		\N	50655	0	444814009	40481087		0
13170	775	378001	1956-05-11	1956-05-11 00:00:00	1956-06-10	1956-06-10 00:00:00	32020		\N	51450	0	62106007	378001		0
13296	782	4112343	1949-07-30	1949-07-30 00:00:00	1949-08-09	1949-08-09 00:00:00	32020		\N	52053	0	195662009	4112343		0
13504	795	81893	1980-04-05	1980-04-05 00:00:00	\N	\N	32020		\N	52708	0	64766004	81893		0
13658	806	81151	1962-07-02	1962-07-02 00:00:00	1962-07-30	1962-07-30 00:00:00	32020		\N	53468	0	44465007	81151		0
3315	191	257012	1923-02-08	1923-02-08 00:00:00	\N	\N	32020		\N	13059	0	40055000	257012		0
13963	825	40481087	2018-09-14	2018-09-14 00:00:00	2018-09-21	2018-09-21 00:00:00	32020		\N	54695	0	444814009	40481087		0
14224	841	133834	1955-07-06	1955-07-06 00:00:00	1969-06-30	1969-06-30 00:00:00	32020		\N	55560	0	24079001	133834		0
14305	844	40481087	1992-01-24	1992-01-24 00:00:00	1992-02-14	1992-02-14 00:00:00	32020		\N	55999	0	444814009	40481087		0
14495	857	40481087	1997-08-22	1997-08-22 00:00:00	1997-08-29	1997-08-29 00:00:00	32020		\N	56608	0	444814009	40481087		0
14653	864	4278672	2001-07-11	2001-07-11 00:00:00	2001-09-09	2001-09-09 00:00:00	32020		\N	57326	0	65966004	4278672		0
14810	871	372328	1968-12-03	1968-12-03 00:00:00	1968-12-24	1968-12-24 00:00:00	32020		\N	57935	0	65363002	372328		0
15016	884	40479768	2011-12-29	2011-12-29 00:00:00	2012-02-04	2012-02-04 00:00:00	32020		\N	58955	0	444470001	40479768		0
15169	893	40481087	1987-10-28	1987-10-28 00:00:00	1987-11-11	1987-11-11 00:00:00	32020		\N	59452	0	444814009	40481087		0
15317	906	260139	1991-05-21	1991-05-21 00:00:00	1991-05-28	1991-05-28 00:00:00	32020		\N	60264	0	10509002	260139		0
15480	917	260139	1981-02-11	1981-02-11 00:00:00	1981-02-25	1981-02-25 00:00:00	32020		\N	61016	0	10509002	260139		0
15644	925	28060	1999-09-22	1999-09-22 00:00:00	1999-10-04	1999-10-04 00:00:00	32020		\N	61602	0	43878008	28060		0
15796	935	28060	1946-02-19	1946-02-19 00:00:00	1946-02-26	1946-02-26 00:00:00	32020		\N	62217	0	43878008	28060		0
16012	948	4237458	1972-05-15	1972-05-15 00:00:00	1972-07-14	1972-07-14 00:00:00	32020		\N	62962	0	58150001	4237458		0
16172	956	260139	2004-01-31	2004-01-31 00:00:00	2004-02-14	2004-02-14 00:00:00	32020		\N	63515	0	10509002	260139		0
16287	962	260139	1989-09-15	1989-09-15 00:00:00	1989-09-29	1989-09-29 00:00:00	32020		\N	64084	0	10509002	260139		0
16455	972	28060	1999-07-04	1999-07-04 00:00:00	1999-07-13	1999-07-13 00:00:00	32020		\N	64708	0	43878008	28060		0
16662	987	4134304	2002-10-27	2002-10-27 00:00:00	2003-01-25	2003-01-25 00:00:00	32020		\N	65523	0	263102004	4134304		0
16776	994	4027663	1990-07-14	1990-07-14 00:00:00	\N	\N	32020		\N	65871	0	13200003	4027663		0
16992	1015	4218389	1983-02-05	1983-02-05 00:00:00	1983-03-12	1983-03-12 00:00:00	32020		\N	66814	0	39848009	4218389		0
17232	1032	4218389	1991-07-19	1991-07-19 00:00:00	1991-08-23	1991-08-23 00:00:00	32020		\N	67953	0	39848009	4218389		0
17346	1039	4296204	2008-08-14	2008-08-14 00:00:00	2008-09-18	2008-09-18 00:00:00	32020		\N	68335	0	403190006	4296204		0
17483	1051	40481087	2013-09-21	2013-09-21 00:00:00	2013-09-28	2013-09-28 00:00:00	32020		\N	68954	0	444814009	40481087		0
17614	1058	40481087	1970-10-04	1970-10-04 00:00:00	1970-10-11	1970-10-11 00:00:00	32020		\N	69476	0	444814009	40481087		0
17851	1073	4027663	1964-06-18	1964-06-18 00:00:00	\N	\N	32020		\N	70407	0	13200003	4027663		0
17974	1081	260139	1977-12-09	1977-12-09 00:00:00	1977-12-23	1977-12-23 00:00:00	32020		\N	70862	0	10509002	260139		0
18154	1091	81893	1996-03-24	1996-03-24 00:00:00	\N	\N	32020		\N	71713	0	64766004	81893		0
18269	1099	4112343	1982-12-14	1982-12-14 00:00:00	1982-12-22	1982-12-22 00:00:00	32020		\N	72243	0	195662009	4112343		0
18479	1112	40481087	2008-11-02	2008-11-02 00:00:00	2008-11-09	2008-11-09 00:00:00	32020		\N	73207	0	444814009	40481087		0
18642	1120	40481087	1994-09-22	1994-09-22 00:00:00	1994-09-29	1994-09-29 00:00:00	32020		\N	73847	0	444814009	40481087		0
18822	1132	40481087	2007-01-26	2007-01-26 00:00:00	2007-02-02	2007-02-02 00:00:00	32020		\N	74538	0	444814009	40481087		0
18946	1137	4112343	1973-11-19	1973-11-19 00:00:00	1973-11-28	1973-11-28 00:00:00	32020		\N	74880	0	195662009	4112343		0
19124	1146	4112343	2003-11-15	2003-11-15 00:00:00	2003-11-23	2003-11-23 00:00:00	32020		\N	75747	0	195662009	4112343		0
19325	1158	40481087	2005-09-04	2005-09-04 00:00:00	2005-09-18	2005-09-18 00:00:00	32020		\N	76521	0	444814009	40481087		0
19571	1175	40481087	1947-01-29	1947-01-29 00:00:00	1947-02-19	1947-02-19 00:00:00	32020		\N	77413	0	444814009	40481087		0
19643	1177	40481087	2014-09-14	2014-09-14 00:00:00	2014-09-28	2014-09-28 00:00:00	32020		\N	77789	0	444814009	40481087		0
19857	1194	28060	1963-11-15	1963-11-15 00:00:00	1963-11-25	1963-11-25 00:00:00	32020		\N	78725	0	43878008	28060		0
19989	1205	372328	1965-08-05	1965-08-05 00:00:00	1966-01-06	1966-01-06 00:00:00	32020		\N	79148	0	65363002	372328		0
20176	1214	81151	1947-10-08	1947-10-08 00:00:00	1947-11-05	1947-11-05 00:00:00	32020		\N	80003	0	44465007	81151		0
20273	1219	40481087	1987-04-23	1987-04-23 00:00:00	1987-05-07	1987-05-07 00:00:00	32020		\N	80211	0	444814009	40481087		0
20487	1231	28060	1946-12-01	1946-12-01 00:00:00	1946-12-09	1946-12-09 00:00:00	32020		\N	81150	0	43878008	28060		0
20668	1242	40481087	2003-04-07	2003-04-07 00:00:00	2003-04-28	2003-04-28 00:00:00	32020		\N	81758	0	444814009	40481087		0
20775	1246	4152936	1994-03-03	1994-03-03 00:00:00	1994-03-24	1994-03-24 00:00:00	32020		\N	82055	0	283385000	4152936		0
20943	1257	40481087	2014-03-19	2014-03-19 00:00:00	2014-04-02	2014-04-02 00:00:00	32020		\N	82805	0	444814009	40481087		0
21188	1271	192671	2010-11-13	2010-11-13 00:00:00	\N	\N	32020		\N	83822	0	K92.2	35208414		0
10629	624	378001	2005-01-19	2005-01-19 00:00:00	2005-02-18	2005-02-18 00:00:00	32020		\N	41694	0	62106007	378001		0
10836	642	4278672	2017-11-18	2017-11-18 00:00:00	2017-12-18	2017-12-18 00:00:00	32020		\N	42576	0	65966004	4278672		0
11036	651	4112343	1983-09-05	1983-09-05 00:00:00	1983-09-17	1983-09-17 00:00:00	32020		\N	43104	0	195662009	4112343		0
11211	662	260139	1989-03-01	1989-03-01 00:00:00	1989-03-15	1989-03-15 00:00:00	32020		\N	43743	0	10509002	260139		0
11328	669	4116491	1995-09-25	1995-09-25 00:00:00	1995-11-14	1995-11-14 00:00:00	32020		\N	44168	0	301011002	4116491		0
11591	685	40481087	1968-05-04	1968-05-04 00:00:00	1968-05-25	1968-05-25 00:00:00	32020		\N	45330	0	444814009	40481087		0
11657	687	4084167	1969-06-09	1969-06-09 00:00:00	1969-06-09	1969-06-09 00:00:00	32020		\N	45482	0	241929008	4084167		0
11848	700	40481087	1991-09-24	1991-09-24 00:00:00	1991-10-01	1991-10-01 00:00:00	32020		\N	46253	0	444814009	40481087		0
12006	710	372328	1964-01-20	1964-01-20 00:00:00	1964-03-24	1964-03-24 00:00:00	32020		\N	47046	0	65363002	372328		0
12206	722	40481087	1995-11-14	1995-11-14 00:00:00	1995-12-05	1995-12-05 00:00:00	32020		\N	47765	0	444814009	40481087		0
12305	727	40481087	2008-07-24	2008-07-24 00:00:00	2008-07-31	2008-07-31 00:00:00	32020		\N	48167	0	444814009	40481087		0
12494	739	40481087	1981-09-22	1981-09-22 00:00:00	1981-10-06	1981-10-06 00:00:00	32020		\N	48939	0	444814009	40481087		0
12697	752	4112343	1962-06-04	1962-06-04 00:00:00	1962-06-13	1962-06-13 00:00:00	32020		\N	49703	0	195662009	4112343		0
12868	757	40481087	1947-08-08	1947-08-08 00:00:00	1947-08-22	1947-08-22 00:00:00	32020		\N	50189	0	444814009	40481087		0
12977	762	4146173	2001-04-29	2001-04-29 00:00:00	2001-05-29	2001-05-29 00:00:00	32020		\N	50677	0	307731004	4146173		0
13171	775	4112343	1987-06-14	1987-06-14 00:00:00	1987-06-27	1987-06-27 00:00:00	32020		\N	51422	0	195662009	4112343		0
13297	782	4149245	1954-06-12	1954-06-12 00:00:00	1954-08-18	1954-08-18 00:00:00	32020		\N	52018	0	30832001	4149245		0
13505	795	4112343	1956-10-18	1956-10-18 00:00:00	1956-10-28	1956-10-28 00:00:00	32020		\N	52748	0	195662009	4112343		0
13659	806	40481087	1996-04-24	1996-04-24 00:00:00	1996-05-08	1996-05-08 00:00:00	32020		\N	53510	0	444814009	40481087		0
3316	191	40481087	1941-12-28	1941-12-28 00:00:00	1942-01-04	1942-01-04 00:00:00	32020		\N	13020	0	444814009	40481087		0
13964	825	80180	2011-02-14	2011-02-14 00:00:00	\N	\N	32020		\N	54662	0	396275006	80180		0
14225	841	81151	2017-08-23	2017-08-23 00:00:00	2017-09-20	2017-09-20 00:00:00	32020		\N	55511	0	44465007	81151		0
14306	844	4152936	1995-04-21	1995-04-21 00:00:00	1995-05-12	1995-05-12 00:00:00	32020		\N	56004	0	283385000	4152936		0
14496	857	4146173	1975-05-31	1975-05-31 00:00:00	1975-06-30	1975-06-30 00:00:00	32020		\N	56636	0	307731004	4146173		0
14654	864	4296205	1946-08-21	1946-08-21 00:00:00	1946-09-25	1946-09-25 00:00:00	32020		\N	57280	0	403191005	4296205		0
14811	871	4112343	1971-01-24	1971-01-24 00:00:00	1971-02-06	1971-02-06 00:00:00	32020		\N	57930	0	195662009	4112343		0
15017	884	4230399	1989-06-08	1989-06-08 00:00:00	1989-09-06	1989-09-06 00:00:00	32020		\N	58950	0	359817006	4230399		0
15170	893	40481087	1963-04-05	1963-04-05 00:00:00	1963-04-19	1963-04-19 00:00:00	32020		\N	59487	0	444814009	40481087		0
15318	906	378001	1985-01-21	1985-01-21 00:00:00	1985-02-20	1985-02-20 00:00:00	32020		\N	60233	0	62106007	378001		0
15481	917	80180	2005-03-31	2005-03-31 00:00:00	\N	\N	32020		\N	60985	0	396275006	80180		0
15676	929	260139	1963-08-24	1963-08-24 00:00:00	1963-09-07	1963-09-07 00:00:00	32020		\N	61808	0	10509002	260139		0
15797	935	30753	1971-08-29	1971-08-29 00:00:00	\N	\N	32020		\N	62190	0	16761005	30753		0
16013	948	80180	1998-03-03	1998-03-03 00:00:00	\N	\N	32020		\N	62912	0	396275006	80180		0
16173	956	4116491	1980-05-24	1980-05-24 00:00:00	1980-07-01	1980-07-01 00:00:00	32020		\N	63444	0	301011002	4116491		0
16298	964	4112343	1984-06-23	1984-06-23 00:00:00	1984-07-06	1984-07-06 00:00:00	32020		\N	64184	0	195662009	4112343		0
16456	972	4048695	2016-01-10	2016-01-10 00:00:00	2016-03-11	2016-03-11 00:00:00	32020		\N	64719	0	15724005	4048695		0
16663	987	260139	1959-08-12	1959-08-12 00:00:00	1959-08-19	1959-08-19 00:00:00	32020		\N	65580	0	10509002	260139		0
16777	994	40481087	1999-12-31	1999-12-31 00:00:00	2000-01-07	2000-01-07 00:00:00	32020		\N	65885	0	444814009	40481087		0
16994	1015	4112343	2009-10-29	2009-10-29 00:00:00	2009-11-10	2009-11-10 00:00:00	32020		\N	66836	0	195662009	4112343		0
17233	1032	260139	2010-08-28	2010-08-28 00:00:00	2010-09-11	2010-09-11 00:00:00	32020		\N	67932	0	10509002	260139		0
17347	1039	372328	1964-09-24	1964-09-24 00:00:00	1965-02-27	1965-02-27 00:00:00	32020		\N	68400	0	65363002	372328		0
17484	1051	260139	2010-03-11	2010-03-11 00:00:00	2010-03-25	2010-03-25 00:00:00	32020		\N	68943	0	10509002	260139		0
17615	1058	260139	1976-09-05	1976-09-05 00:00:00	1976-09-19	1976-09-19 00:00:00	32020		\N	69482	0	10509002	260139		0
17852	1073	40481087	1962-09-16	1962-09-16 00:00:00	1962-09-23	1962-09-23 00:00:00	32020		\N	70407	0	444814009	40481087		0
17975	1081	80180	2001-03-24	2001-03-24 00:00:00	\N	\N	32020		\N	70895	0	396275006	80180		0
18155	1091	4310024	1995-11-25	1995-11-25 00:00:00	\N	\N	32020		\N	71713	0	424802006	4310024		0
18270	1099	40481087	1963-11-11	1963-11-11 00:00:00	1963-12-02	1963-12-02 00:00:00	32020		\N	72140	0	444814009	40481087		0
18480	1112	372328	1967-01-09	1967-01-09 00:00:00	1967-04-02	1967-04-02 00:00:00	32020		\N	73209	0	65363002	372328		0
18643	1120	4278672	1971-12-19	1971-12-19 00:00:00	1972-01-18	1972-01-18 00:00:00	32020		\N	73810	0	65966004	4278672		0
18823	1132	4112343	1959-05-05	1959-05-05 00:00:00	1959-05-15	1959-05-15 00:00:00	32020		\N	74505	0	195662009	4112343		0
18947	1137	4043241	2007-10-19	2007-10-19 00:00:00	\N	\N	32020		\N	74969	0	230265002	4043241		0
19125	1146	28060	1990-12-26	1990-12-26 00:00:00	1991-01-03	1991-01-03 00:00:00	32020		\N	75670	0	43878008	28060		0
19326	1158	80180	2016-12-13	2016-12-13 00:00:00	\N	\N	32020		\N	76518	0	396275006	80180		0
19572	1175	40481087	1950-05-09	1950-05-09 00:00:00	1950-05-16	1950-05-16 00:00:00	32020		\N	77547	0	444814009	40481087		0
19644	1177	40481087	1992-11-07	1992-11-07 00:00:00	1992-11-14	1992-11-14 00:00:00	32020		\N	77763	0	444814009	40481087		0
19858	1194	28060	1972-05-25	1972-05-25 00:00:00	1972-06-03	1972-06-03 00:00:00	32020		\N	78727	0	43878008	28060		0
19990	1205	28060	1963-04-07	1963-04-07 00:00:00	1963-04-17	1963-04-17 00:00:00	32020		\N	79183	0	43878008	28060		0
20177	1214	260139	1944-02-07	1944-02-07 00:00:00	1944-02-14	1944-02-14 00:00:00	32020		\N	79946	0	10509002	260139		0
20286	1222	4112343	1988-10-06	1988-10-06 00:00:00	1988-10-19	1988-10-19 00:00:00	32020		\N	80434	0	195662009	4112343		0
20488	1231	195588	1965-01-04	1965-01-04 00:00:00	1965-02-27	1965-02-27 00:00:00	32020		\N	81069	0	38822007	195588		0
20669	1242	4285898	2000-04-24	2000-04-24 00:00:00	\N	\N	32020		\N	81808	0	68496003	4285898		0
20776	1246	4112343	1957-03-26	1957-03-26 00:00:00	1957-04-07	1957-04-07 00:00:00	32020		\N	82040	0	195662009	4112343		0
20944	1257	375671	1983-10-01	1983-10-01 00:00:00	1983-11-30	1983-11-30 00:00:00	32020		\N	82842	0	62564004	375671		0
21189	1271	40481087	2015-11-26	2015-11-26 00:00:00	2015-12-03	2015-12-03 00:00:00	32020		\N	83842	0	444814009	40481087		0
10630	624	4278672	1947-01-23	1947-01-23 00:00:00	1947-04-23	1947-04-23 00:00:00	32020		\N	41688	0	65966004	4278672		0
10837	642	4112343	1944-10-11	1944-10-11 00:00:00	1944-10-20	1944-10-20 00:00:00	32020		\N	42522	0	195662009	4112343		0
11037	651	378001	2009-05-31	2009-05-31 00:00:00	2009-07-30	2009-07-30 00:00:00	32020		\N	43081	0	62106007	378001		0
11212	662	4112343	1997-03-26	1997-03-26 00:00:00	1997-04-03	1997-04-03 00:00:00	32020		\N	43685	0	195662009	4112343		0
11329	669	260139	1974-04-09	1974-04-09 00:00:00	1974-04-16	1974-04-16 00:00:00	32020		\N	44141	0	10509002	260139		0
11592	685	378001	1983-02-04	1983-02-04 00:00:00	1983-04-05	1983-04-05 00:00:00	32020		\N	45305	0	62106007	378001		0
11658	687	4294548	2017-09-24	2017-09-24 00:00:00	2017-12-24	2017-12-24 00:00:00	32020		\N	45522	0	75498004	4294548		0
11849	700	40481087	2000-03-07	2000-03-07 00:00:00	2000-03-14	2000-03-14 00:00:00	32020		\N	46288	0	444814009	40481087		0
12007	710	439777	1964-04-17	1964-04-17 00:00:00	\N	\N	32020		\N	47041	0	271737000	439777		0
12207	722	40481087	1981-02-25	1981-02-25 00:00:00	1981-03-04	1981-03-04 00:00:00	32020		\N	47773	0	444814009	40481087		0
12306	727	260139	1917-04-10	1917-04-10 00:00:00	1917-04-24	1917-04-24 00:00:00	32020		\N	48174	0	10509002	260139		0
12495	739	372328	1910-09-30	1910-09-30 00:00:00	1910-12-14	1910-12-14 00:00:00	32020		\N	48929	0	65363002	372328		0
12698	752	260139	2008-10-10	2008-10-10 00:00:00	2008-10-24	2008-10-24 00:00:00	32020		\N	49680	0	10509002	260139		0
12869	757	4285898	1949-02-17	1949-02-17 00:00:00	\N	\N	32020		\N	50189	0	68496003	4285898		0
12978	762	40481087	1984-06-14	1984-06-14 00:00:00	1984-06-28	1984-06-28 00:00:00	32020		\N	50663	0	444814009	40481087		0
13172	775	40481087	2010-08-03	2010-08-03 00:00:00	2010-08-10	2010-08-10 00:00:00	32020		\N	51424	0	444814009	40481087		0
13298	782	80502	1982-03-07	1982-03-07 00:00:00	\N	\N	32020		\N	52050	0	64859006	80502		0
13506	795	4112343	1961-11-05	1961-11-05 00:00:00	1961-11-16	1961-11-16 00:00:00	32020		\N	52705	0	195662009	4112343		0
13660	806	4294548	2002-10-22	2002-10-22 00:00:00	2002-11-26	2002-11-26 00:00:00	32020		\N	53514	0	75498004	4294548		0
3317	191	260139	1991-07-25	1991-07-25 00:00:00	1991-08-01	1991-08-01 00:00:00	32020		\N	13100	0	10509002	260139		0
13965	825	40481087	1976-05-18	1976-05-18 00:00:00	1976-06-08	1976-06-08 00:00:00	32020		\N	54627	0	444814009	40481087		0
14226	841	40481087	1994-06-23	1994-06-23 00:00:00	1994-07-14	1994-07-14 00:00:00	32020		\N	55563	0	444814009	40481087		0
14307	844	4218389	2002-03-06	2002-03-06 00:00:00	2002-04-10	2002-04-10 00:00:00	32020		\N	56005	0	39848009	4218389		0
14497	857	321042	1983-09-18	1983-09-18 00:00:00	\N	\N	32020		\N	56579	0	410429000	321042		0
14655	864	4112343	1949-08-25	1949-08-25 00:00:00	1949-09-02	1949-09-02 00:00:00	32020		\N	57297	0	195662009	4112343		0
14812	871	440086	1978-01-15	1978-01-15 00:00:00	1984-01-24	1984-01-24 00:00:00	32020		\N	57931	0	192127007	440086		0
15018	884	260139	1981-04-19	1981-04-19 00:00:00	1981-04-26	1981-04-26 00:00:00	32020		\N	58939	0	10509002	260139		0
15171	893	4294548	1976-03-20	1976-03-20 00:00:00	1976-06-19	1976-06-19 00:00:00	32020		\N	59490	0	75498004	4294548		0
15319	906	4155034	1986-12-12	1986-12-12 00:00:00	1986-12-26	1986-12-26 00:00:00	32020		\N	60234	0	283371005	4155034		0
15482	917	40481087	1976-10-12	1976-10-12 00:00:00	1976-11-02	1976-11-02 00:00:00	32020		\N	61001	0	444814009	40481087		0
15677	929	40481087	1998-07-31	1998-07-31 00:00:00	1998-08-21	1998-08-21 00:00:00	32020		\N	61760	0	444814009	40481087		0
15798	935	4310024	1971-05-01	1971-05-01 00:00:00	\N	\N	32020		\N	62190	0	424802006	4310024		0
16014	948	81893	1997-07-06	1997-07-06 00:00:00	\N	\N	32020		\N	62912	0	64766004	81893		0
16174	956	40481087	1996-06-08	1996-06-08 00:00:00	1996-06-15	1996-06-15 00:00:00	32020		\N	63542	0	444814009	40481087		0
16299	964	40481087	2013-10-23	2013-10-23 00:00:00	2013-10-30	2013-10-30 00:00:00	32020		\N	64185	0	444814009	40481087		0
16457	972	40481087	1969-08-23	1969-08-23 00:00:00	1969-08-30	1969-08-30 00:00:00	32020		\N	64706	0	444814009	40481087		0
16664	987	40481087	2009-09-07	2009-09-07 00:00:00	2009-09-21	2009-09-21 00:00:00	32020		\N	65563	0	444814009	40481087		0
16831	1000	4285898	2007-06-26	2007-06-26 00:00:00	\N	\N	32020		\N	66185	0	68496003	4285898		0
16995	1015	260139	1984-11-21	1984-11-21 00:00:00	1984-11-28	1984-11-28 00:00:00	32020		\N	66819	0	10509002	260139		0
17234	1032	440086	1958-10-12	1958-10-12 00:00:00	1969-10-19	1969-10-19 00:00:00	32020		\N	67928	0	192127007	440086		0
17348	1039	40481087	1973-03-20	1973-03-20 00:00:00	1973-04-03	1973-04-03 00:00:00	32020		\N	68372	0	444814009	40481087		0
17485	1051	4059173	1975-06-17	1975-06-17 00:00:00	1975-07-17	1975-07-17 00:00:00	32020		\N	68870	0	16114001	4059173		0
17616	1058	4112343	1993-04-01	1993-04-01 00:00:00	1993-04-11	1993-04-11 00:00:00	32020		\N	69424	0	195662009	4112343		0
17853	1073	40481087	1942-11-20	1942-11-20 00:00:00	1942-11-27	1942-11-27 00:00:00	32020		\N	70321	0	444814009	40481087		0
17976	1081	260139	2001-06-26	2001-06-26 00:00:00	2001-07-03	2001-07-03 00:00:00	32020		\N	70845	0	10509002	260139		0
18156	1091	260139	1966-05-18	1966-05-18 00:00:00	1966-05-25	1966-05-25 00:00:00	32020		\N	71593	0	10509002	260139		0
18271	1099	4112343	1993-04-30	1993-04-30 00:00:00	1993-05-07	1993-05-07 00:00:00	32020		\N	72206	0	195662009	4112343		0
18481	1112	4112343	1988-05-05	1988-05-05 00:00:00	1988-05-13	1988-05-13 00:00:00	32020		\N	73167	0	195662009	4112343		0
18644	1120	40481087	2005-03-13	2005-03-13 00:00:00	2005-03-20	2005-03-20 00:00:00	32020		\N	73798	0	444814009	40481087		0
18824	1132	260139	1998-03-10	1998-03-10 00:00:00	1998-03-17	1998-03-17 00:00:00	32020		\N	74494	0	10509002	260139		0
18948	1137	40481087	1998-10-31	1998-10-31 00:00:00	1998-11-07	1998-11-07 00:00:00	32020		\N	74909	0	444814009	40481087		0
19126	1146	81151	1971-11-20	1971-11-20 00:00:00	1971-12-18	1971-12-18 00:00:00	32020		\N	75741	0	44465007	81151		0
19327	1158	4112343	2015-02-15	2015-02-15 00:00:00	2015-02-27	2015-02-27 00:00:00	32020		\N	76523	0	195662009	4112343		0
19573	1175	4048171	1943-08-04	1943-08-04 00:00:00	1959-08-02	1959-08-02 00:00:00	32020		\N	77406	0	232353008	4048171		0
19645	1177	4112343	1980-07-22	1980-07-22 00:00:00	1980-08-01	1980-08-01 00:00:00	32020		\N	77731	0	195662009	4112343		0
19859	1194	4294548	1963-02-15	1963-02-15 00:00:00	1963-08-16	1963-08-16 00:00:00	32020		\N	78723	0	75498004	4294548		0
19991	1205	40481087	1961-05-19	1961-05-19 00:00:00	1961-06-02	1961-06-02 00:00:00	32020		\N	79182	0	444814009	40481087		0
20178	1214	40481087	1955-03-14	1955-03-14 00:00:00	1955-03-21	1955-03-21 00:00:00	32020		\N	79996	0	444814009	40481087		0
20287	1222	40481087	2002-09-18	2002-09-18 00:00:00	2002-09-25	2002-09-25 00:00:00	32020		\N	80404	0	444814009	40481087		0
20489	1231	81151	1972-03-18	1972-03-18 00:00:00	1972-04-22	1972-04-22 00:00:00	32020		\N	81114	0	44465007	81151		0
20670	1242	80180	2000-10-21	2000-10-21 00:00:00	\N	\N	32020		\N	81808	0	396275006	80180		0
20801	1249	4112343	2018-11-23	2018-11-23 00:00:00	2018-12-03	2018-12-03 00:00:00	32020		\N	82300	0	195662009	4112343		0
20945	1257	260139	1973-12-24	1973-12-24 00:00:00	1974-01-07	1974-01-07 00:00:00	32020		\N	82803	0	10509002	260139		0
21190	1271	28060	1979-04-06	1979-04-06 00:00:00	1979-04-19	1979-04-19 00:00:00	32020		\N	83823	0	43878008	28060		0
10631	624	40481087	2013-02-07	2013-02-07 00:00:00	2013-02-14	2013-02-14 00:00:00	32020		\N	41657	0	444814009	40481087		0
10838	642	4112343	2013-01-20	2013-01-20 00:00:00	2013-01-31	2013-01-31 00:00:00	32020		\N	42525	0	195662009	4112343		0
11038	651	4152936	2007-08-26	2007-08-26 00:00:00	2007-09-09	2007-09-09 00:00:00	32020		\N	43080	0	283385000	4152936		0
11213	662	40481087	1982-09-06	1982-09-06 00:00:00	1982-09-13	1982-09-13 00:00:00	32020		\N	43698	0	444814009	40481087		0
11330	669	4109685	1998-06-15	1998-06-15 00:00:00	1998-07-06	1998-07-06 00:00:00	32020		\N	44156	0	284551006	4109685		0
11593	685	372328	1966-03-09	1966-03-09 00:00:00	1966-05-16	1966-05-16 00:00:00	32020		\N	45359	0	65363002	372328		0
11659	687	4112343	1992-08-30	1992-08-30 00:00:00	1992-09-10	1992-09-10 00:00:00	32020		\N	45463	0	195662009	4112343		0
11850	701	80180	1994-10-11	1994-10-11 00:00:00	\N	\N	32020		\N	46310	0	396275006	80180		0
12008	710	4112343	1980-07-07	1980-07-07 00:00:00	1980-07-18	1980-07-18 00:00:00	32020		\N	47025	0	195662009	4112343		0
12208	722	4152936	2011-11-28	2011-11-28 00:00:00	2011-12-19	2011-12-19 00:00:00	32020		\N	47802	0	283385000	4152936		0
12307	727	40481087	1931-07-25	1931-07-25 00:00:00	1931-08-08	1931-08-08 00:00:00	32020		\N	48240	0	444814009	40481087		0
12496	739	372328	1914-04-27	1914-04-27 00:00:00	1914-06-17	1914-06-17 00:00:00	32020		\N	48943	0	65363002	372328		0
12699	752	260139	2014-05-07	2014-05-07 00:00:00	2014-05-21	2014-05-21 00:00:00	32020		\N	49739	0	10509002	260139		0
12870	757	4310024	1947-08-27	1947-08-27 00:00:00	\N	\N	32020		\N	50189	0	424802006	4310024		0
12979	762	4112343	1996-05-14	1996-05-14 00:00:00	1996-05-25	1996-05-25 00:00:00	32020		\N	50657	0	195662009	4112343		0
13173	775	80180	1976-05-25	1976-05-25 00:00:00	\N	\N	32020		\N	51462	0	396275006	80180		0
13299	782	4296204	1913-07-07	1913-07-07 00:00:00	1913-07-28	1913-07-28 00:00:00	32020		\N	52015	0	403190006	4296204		0
13507	795	40481087	1951-09-29	1951-09-29 00:00:00	1951-10-20	1951-10-20 00:00:00	32020		\N	52735	0	444814009	40481087		0
13661	806	4112343	1999-02-28	1999-02-28 00:00:00	1999-03-10	1999-03-10 00:00:00	32020		\N	53503	0	195662009	4112343		0
3318	191	40481087	1924-10-26	1924-10-26 00:00:00	1924-11-02	1924-11-02 00:00:00	32020		\N	13017	0	444814009	40481087		0
13966	825	378001	1972-06-03	1972-06-03 00:00:00	1972-07-03	1972-07-03 00:00:00	32020		\N	54651	0	62106007	378001		0
14227	841	378001	1990-08-15	1990-08-15 00:00:00	1990-10-14	1990-10-14 00:00:00	32020		\N	55510	0	62106007	378001		0
14308	844	80180	2002-09-26	2002-09-26 00:00:00	\N	\N	32020		\N	56005	0	396275006	80180		0
14499	857	4112343	1960-02-02	1960-02-02 00:00:00	1960-02-12	1960-02-12 00:00:00	32020		\N	56634	0	195662009	4112343		0
14656	864	81151	1988-09-28	1988-09-28 00:00:00	1988-10-19	1988-10-19 00:00:00	32020		\N	57324	0	44465007	81151		0
14813	871	378001	1981-08-11	1981-08-11 00:00:00	1981-10-10	1981-10-10 00:00:00	32020		\N	57957	0	62106007	378001		0
15019	884	81151	2008-03-21	2008-03-21 00:00:00	2008-04-18	2008-04-18 00:00:00	32020		\N	58954	0	44465007	81151		0
15179	895	40481087	1991-10-05	1991-10-05 00:00:00	1991-10-19	1991-10-19 00:00:00	32020		\N	59699	0	444814009	40481087		0
15320	906	372328	1974-01-19	1974-01-19 00:00:00	1974-02-02	1974-02-02 00:00:00	32020		\N	60274	0	65363002	372328		0
15483	917	40481087	1970-06-26	1970-06-26 00:00:00	1970-07-10	1970-07-10 00:00:00	32020		\N	60915	0	444814009	40481087		0
15678	929	378001	1988-09-03	1988-09-03 00:00:00	1988-10-03	1988-10-03 00:00:00	32020		\N	61757	0	62106007	378001		0
15799	935	381316	1994-05-25	1994-05-25 00:00:00	\N	\N	32020		\N	62162	0	230690007	381316		0
16015	948	372328	1964-05-13	1964-05-13 00:00:00	1964-09-04	1964-09-04 00:00:00	32020		\N	62922	0	65363002	372328		0
16175	956	40481087	1940-01-14	1940-01-14 00:00:00	1940-01-21	1940-01-21 00:00:00	32020		\N	63488	0	444814009	40481087		0
16300	964	372328	1979-11-07	1979-11-07 00:00:00	1980-10-19	1980-10-19 00:00:00	32020		\N	64186	0	65363002	372328		0
16458	972	372328	1971-04-25	1971-04-25 00:00:00	1971-05-09	1971-05-09 00:00:00	32020		\N	64663	0	65363002	372328		0
16665	987	80180	1988-01-09	1988-01-09 00:00:00	\N	\N	32020		\N	65546	0	396275006	80180		0
16832	1000	4310024	2006-03-03	2006-03-03 00:00:00	\N	\N	32020		\N	66185	0	424802006	4310024		0
16996	1015	260139	1976-07-29	1976-07-29 00:00:00	1976-08-05	1976-08-05 00:00:00	32020		\N	66823	0	10509002	260139		0
17235	1032	40481087	1953-04-13	1953-04-13 00:00:00	1953-05-04	1953-05-04 00:00:00	32020		\N	67901	0	444814009	40481087		0
17349	1039	4112343	2003-08-05	2003-08-05 00:00:00	2003-08-16	2003-08-16 00:00:00	32020		\N	68375	0	195662009	4112343		0
17486	1051	40486433	1970-02-15	1970-02-15 00:00:00	\N	\N	32020		\N	68864	0	446096008	40486433		0
17617	1058	260139	2003-11-16	2003-11-16 00:00:00	2003-11-30	2003-11-30 00:00:00	32020		\N	69343	0	10509002	260139		0
17854	1073	28060	1996-08-08	1996-08-08 00:00:00	1996-08-16	1996-08-16 00:00:00	32020		\N	70422	0	43878008	28060		0
17977	1081	40481087	1993-01-15	1993-01-15 00:00:00	1993-01-22	1993-01-22 00:00:00	32020		\N	70883	0	444814009	40481087		0
18157	1091	40481087	1972-03-13	1972-03-13 00:00:00	1972-03-27	1972-03-27 00:00:00	32020		\N	71729	0	444814009	40481087		0
18272	1099	372328	1957-06-28	1957-06-28 00:00:00	1958-04-19	1958-04-19 00:00:00	32020		\N	72144	0	65363002	372328		0
18482	1112	4155034	1968-07-02	1968-07-02 00:00:00	1968-07-16	1968-07-16 00:00:00	32020		\N	73184	0	283371005	4155034		0
18645	1120	40481087	2013-02-10	2013-02-10 00:00:00	2013-03-03	2013-03-03 00:00:00	32020		\N	73830	0	444814009	40481087		0
18825	1132	4112343	1990-12-02	1990-12-02 00:00:00	1990-12-11	1990-12-11 00:00:00	32020		\N	74536	0	195662009	4112343		0
18949	1138	440086	1994-01-27	1994-01-27 00:00:00	1998-02-26	1998-02-26 00:00:00	32020		\N	75067	0	192127007	440086		0
19127	1146	40481087	1970-03-29	1970-03-29 00:00:00	1970-04-12	1970-04-12 00:00:00	32020		\N	75742	0	444814009	40481087		0
19328	1158	81151	2017-02-14	2017-02-14 00:00:00	2017-03-14	2017-03-14 00:00:00	32020		\N	76474	0	44465007	81151		0
19574	1175	4112343	2000-05-08	2000-05-08 00:00:00	2000-05-18	2000-05-18 00:00:00	32020		\N	77539	0	195662009	4112343		0
19646	1177	80180	2004-01-04	2004-01-04 00:00:00	\N	\N	32020		\N	77741	0	396275006	80180		0
19860	1194	372328	1963-10-18	1963-10-18 00:00:00	1964-01-20	1964-01-20 00:00:00	32020		\N	78692	0	65363002	372328		0
19992	1205	260139	1964-12-26	1964-12-26 00:00:00	1965-01-09	1965-01-09 00:00:00	32020		\N	79184	0	10509002	260139		0
20179	1214	4112343	1952-09-25	1952-09-25 00:00:00	1952-10-03	1952-10-03 00:00:00	32020		\N	79995	0	195662009	4112343		0
20288	1222	260139	1990-01-29	1990-01-29 00:00:00	1990-02-05	1990-02-05 00:00:00	32020		\N	80371	0	10509002	260139		0
20490	1231	28060	1955-04-11	1955-04-11 00:00:00	1955-04-20	1955-04-20 00:00:00	32020		\N	81151	0	43878008	28060		0
20671	1242	4310024	1999-09-27	1999-09-27 00:00:00	\N	\N	32020		\N	81808	0	424802006	4310024		0
20802	1249	40481087	1981-07-14	1981-07-14 00:00:00	1981-08-04	1981-08-04 00:00:00	32020		\N	82276	0	444814009	40481087		0
20946	1257	28060	1976-02-28	1976-02-28 00:00:00	1976-03-09	1976-03-09 00:00:00	32020		\N	82843	0	43878008	28060		0
21191	1271	4027663	1998-12-31	1998-12-31 00:00:00	\N	\N	32020		\N	83856	0	13200003	4027663		0
10632	624	4237458	2011-07-17	2011-07-17 00:00:00	2011-09-15	2011-09-15 00:00:00	32020		\N	41695	0	58150001	4237458		0
10839	642	4027663	1962-12-23	1962-12-23 00:00:00	\N	\N	32020		\N	42551	0	13200003	4027663		0
11039	652	372328	1973-10-01	1973-10-01 00:00:00	1973-11-20	1973-11-20 00:00:00	32020		\N	43163	0	65363002	372328		0
11214	662	4112343	1979-03-05	1979-03-05 00:00:00	1979-03-12	1979-03-12 00:00:00	32020		\N	43720	0	195662009	4112343		0
11331	670	372328	1976-04-03	1976-04-03 00:00:00	1976-10-09	1976-10-09 00:00:00	32020		\N	44206	0	65363002	372328		0
11594	685	372328	1968-02-05	1968-02-05 00:00:00	1968-07-15	1968-07-15 00:00:00	32020		\N	45334	0	65363002	372328		0
11660	687	260139	1981-03-18	1981-03-18 00:00:00	1981-03-25	1981-03-25 00:00:00	32020		\N	45575	0	10509002	260139		0
11851	701	40481087	1994-06-02	1994-06-02 00:00:00	1994-06-16	1994-06-16 00:00:00	32020		\N	46310	0	444814009	40481087		0
12009	710	260139	1992-07-05	1992-07-05 00:00:00	1992-07-12	1992-07-12 00:00:00	32020		\N	47026	0	10509002	260139		0
12209	722	80180	2010-04-17	2010-04-17 00:00:00	\N	\N	32020		\N	47789	0	396275006	80180		0
12308	727	40481087	1928-06-15	1928-06-15 00:00:00	1928-07-06	1928-07-06 00:00:00	32020		\N	48176	0	444814009	40481087		0
12497	739	40481087	1969-08-04	1969-08-04 00:00:00	1969-08-11	1969-08-11 00:00:00	32020		\N	48926	0	444814009	40481087		0
12700	752	40481087	1970-07-15	1970-07-15 00:00:00	1970-07-29	1970-07-29 00:00:00	32020		\N	49705	0	444814009	40481087		0
12871	758	372328	1977-03-29	1977-03-29 00:00:00	1978-03-05	1978-03-05 00:00:00	32020		\N	50302	0	65363002	372328		0
12980	762	80180	1996-05-19	1996-05-19 00:00:00	\N	\N	32020		\N	50657	0	396275006	80180		0
13174	775	260139	2012-09-06	2012-09-06 00:00:00	2012-09-20	2012-09-20 00:00:00	32020		\N	51411	0	10509002	260139		0
13300	782	40480160	1990-05-09	1990-05-09 00:00:00	1990-07-08	1990-07-08 00:00:00	32020		\N	52021	0	443165006	40480160		0
13550	800	4155034	1996-07-30	1996-07-30 00:00:00	1996-08-20	1996-08-20 00:00:00	32020		\N	53094	0	283371005	4155034		0
13662	806	40481087	2002-05-03	2002-05-03 00:00:00	2002-05-17	2002-05-17 00:00:00	32020		\N	53504	0	444814009	40481087		0
3319	191	4112343	1962-05-24	1962-05-24 00:00:00	1962-06-03	1962-06-03 00:00:00	32020		\N	13023	0	195662009	4112343		0
13967	825	378001	1982-10-09	1982-10-09 00:00:00	1982-11-08	1982-11-08 00:00:00	32020		\N	54652	0	62106007	378001		0
14228	841	440448	1961-01-14	1961-01-14 00:00:00	\N	\N	32020		\N	55508	0	74400008	440448		0
14309	844	4266809	2002-09-26	2002-09-26 00:00:00	\N	\N	32020		\N	56005	0	397881000	4266809		0
14500	857	40481087	2002-09-08	2002-09-08 00:00:00	2002-09-15	2002-09-15 00:00:00	32020		\N	56644	0	444814009	40481087		0
14657	865	40481087	2017-07-08	2017-07-08 00:00:00	2017-07-22	2017-07-22 00:00:00	32020		\N	57402	0	444814009	40481087		0
14814	871	40481087	1979-04-13	1979-04-13 00:00:00	1979-04-20	1979-04-20 00:00:00	32020		\N	57932	0	444814009	40481087		0
15020	884	4149245	1981-08-16	1981-08-16 00:00:00	1981-10-22	1981-10-22 00:00:00	32020		\N	58927	0	30832001	4149245		0
15180	895	440086	1967-02-03	1967-02-03 00:00:00	1970-02-27	1970-02-27 00:00:00	32020		\N	59642	0	192127007	440086		0
15321	906	372328	1974-05-03	1974-05-03 00:00:00	1974-08-06	1974-08-06 00:00:00	32020		\N	60225	0	65363002	372328		0
15484	917	260139	1990-04-16	1990-04-16 00:00:00	1990-04-23	1990-04-23 00:00:00	32020		\N	60981	0	10509002	260139		0
15679	929	40481087	1945-07-23	1945-07-23 00:00:00	1945-07-30	1945-07-30 00:00:00	32020		\N	61822	0	444814009	40481087		0
15800	935	40481087	1939-03-01	1939-03-01 00:00:00	1939-03-08	1939-03-08 00:00:00	32020		\N	62164	0	444814009	40481087		0
16016	948	40481087	1999-04-06	1999-04-06 00:00:00	1999-04-27	1999-04-27 00:00:00	32020		\N	62971	0	444814009	40481087		0
16176	956	4218389	1955-02-02	1955-02-02 00:00:00	1955-02-23	1955-02-23 00:00:00	32020		\N	63553	0	39848009	4218389		0
16301	964	372328	1981-04-17	1981-04-17 00:00:00	1981-10-25	1981-10-25 00:00:00	32020		\N	64187	0	65363002	372328		0
16459	972	28060	2012-03-07	2012-03-07 00:00:00	2012-03-20	2012-03-20 00:00:00	32020		\N	64709	0	43878008	28060		0
16666	987	192671	1988-02-16	1988-02-16 00:00:00	\N	\N	32020		\N	65549	0	K92.2	35208414		0
16833	1000	40481087	1980-10-04	1980-10-04 00:00:00	1980-10-18	1980-10-18 00:00:00	32020		\N	66188	0	444814009	40481087		0
16997	1015	260139	2012-10-31	2012-10-31 00:00:00	2012-11-07	2012-11-07 00:00:00	32020		\N	66795	0	10509002	260139		0
17236	1032	40481087	1973-12-11	1973-12-11 00:00:00	1973-12-18	1973-12-18 00:00:00	32020		\N	67930	0	444814009	40481087		0
17350	1039	257012	2006-01-15	2006-01-15 00:00:00	\N	\N	32020		\N	68383	0	40055000	257012		0
17487	1051	4112343	1978-06-14	1978-06-14 00:00:00	1978-06-25	1978-06-25 00:00:00	32020		\N	68854	0	195662009	4112343		0
17618	1058	4112343	1969-12-04	1969-12-04 00:00:00	1969-12-16	1969-12-16 00:00:00	32020		\N	69445	0	195662009	4112343		0
17855	1073	40481087	1951-08-17	1951-08-17 00:00:00	1951-09-07	1951-09-07 00:00:00	32020		\N	70406	0	444814009	40481087		0
17978	1081	4112343	1964-09-17	1964-09-17 00:00:00	1964-09-26	1964-09-26 00:00:00	32020		\N	70831	0	195662009	4112343		0
18158	1091	40481087	1956-07-12	1956-07-12 00:00:00	1956-07-26	1956-07-26 00:00:00	32020		\N	71691	0	444814009	40481087		0
18273	1099	40481087	1955-04-05	1955-04-05 00:00:00	1955-04-19	1955-04-19 00:00:00	32020		\N	72153	0	444814009	40481087		0
18483	1112	80180	2007-06-03	2007-06-03 00:00:00	\N	\N	32020		\N	73229	0	396275006	80180		0
18646	1120	375671	1984-10-11	1984-10-11 00:00:00	1984-12-10	1984-12-10 00:00:00	32020		\N	73811	0	62564004	375671		0
18826	1132	80180	1993-09-11	1993-09-11 00:00:00	\N	\N	32020		\N	74569	0	396275006	80180		0
18950	1138	40481087	2015-02-12	2015-02-12 00:00:00	2015-02-26	2015-02-26 00:00:00	32020		\N	75136	0	444814009	40481087		0
19128	1146	4237458	2001-09-11	2001-09-11 00:00:00	2001-10-11	2001-10-11 00:00:00	32020		\N	75753	0	58150001	4237458		0
19329	1158	372328	1983-01-31	1983-01-31 00:00:00	1983-07-10	1983-07-10 00:00:00	32020		\N	76480	0	65363002	372328		0
19575	1175	4112343	2001-03-28	2001-03-28 00:00:00	2001-04-08	2001-04-08 00:00:00	32020		\N	77540	0	195662009	4112343		0
19647	1177	372328	1968-10-12	1968-10-12 00:00:00	1969-04-14	1969-04-14 00:00:00	32020		\N	77734	0	65363002	372328		0
19861	1194	40481087	1990-12-31	1990-12-31 00:00:00	1991-01-14	1991-01-14 00:00:00	32020		\N	78728	0	444814009	40481087		0
19993	1205	372328	1961-03-15	1961-03-15 00:00:00	1961-03-29	1961-03-29 00:00:00	32020		\N	79147	0	65363002	372328		0
20180	1214	4113008	2012-05-14	2012-05-14 00:00:00	2012-06-04	2012-06-04 00:00:00	32020		\N	79990	0	284549007	4113008		0
20289	1222	40481087	1986-02-15	1986-02-15 00:00:00	1986-03-08	1986-03-08 00:00:00	32020		\N	80428	0	444814009	40481087		0
20491	1231	4112343	1990-12-28	1990-12-28 00:00:00	1991-01-06	1991-01-06 00:00:00	32020		\N	81121	0	195662009	4112343		0
20672	1242	30753	2000-03-25	2000-03-25 00:00:00	\N	\N	32020		\N	81808	0	16761005	30753		0
20803	1249	260139	2000-06-24	2000-06-24 00:00:00	2000-07-01	2000-07-01 00:00:00	32020		\N	82310	0	10509002	260139		0
20947	1258	378001	2011-10-28	2011-10-28 00:00:00	2011-11-27	2011-11-27 00:00:00	32020		\N	82900	0	62106007	378001		0
21192	1271	40481087	1971-01-24	1971-01-24 00:00:00	1971-01-31	1971-01-31 00:00:00	32020		\N	83803	0	444814009	40481087		0
10633	624	4294548	1980-06-09	1980-06-09 00:00:00	1981-03-02	1981-03-02 00:00:00	32020		\N	41637	0	75498004	4294548		0
10840	642	4237458	1935-10-26	1935-10-26 00:00:00	1936-01-24	1936-01-24 00:00:00	32020		\N	42461	0	58150001	4237458		0
11040	652	4112343	1998-06-13	1998-06-13 00:00:00	1998-06-26	1998-06-26 00:00:00	32020		\N	43162	0	195662009	4112343		0
11215	662	317576	1995-03-21	1995-03-21 00:00:00	\N	\N	32020		\N	43693	0	53741008	317576		0
11332	670	4027663	2007-10-26	2007-10-26 00:00:00	\N	\N	32020		\N	44251	0	13200003	4027663		0
11595	685	4027663	1992-02-01	1992-02-01 00:00:00	\N	\N	32020		\N	45321	0	13200003	4027663		0
11661	687	40481087	2014-03-01	2014-03-01 00:00:00	2014-03-15	2014-03-15 00:00:00	32020		\N	45557	0	444814009	40481087		0
11852	701	4113008	2015-05-04	2015-05-04 00:00:00	2015-05-25	2015-05-25 00:00:00	32020		\N	46365	0	284549007	4113008		0
12010	710	372328	1974-10-28	1974-10-28 00:00:00	1975-07-15	1975-07-15 00:00:00	32020		\N	46986	0	65363002	372328		0
12210	722	40481087	2005-04-12	2005-04-12 00:00:00	2005-04-26	2005-04-26 00:00:00	32020		\N	47743	0	444814009	40481087		0
12309	727	40481087	1994-12-25	1994-12-25 00:00:00	1995-01-01	1995-01-01 00:00:00	32020		\N	48246	0	444814009	40481087		0
12498	739	4237458	1978-05-06	1978-05-06 00:00:00	1978-07-05	1978-07-05 00:00:00	32020		\N	48931	0	58150001	4237458		0
12701	752	4152936	2000-01-22	2000-01-22 00:00:00	2000-02-05	2000-02-05 00:00:00	32020		\N	49642	0	283385000	4152936		0
12872	758	260139	2000-07-12	2000-07-12 00:00:00	2000-07-19	2000-07-19 00:00:00	32020		\N	50314	0	10509002	260139		0
12981	762	40481087	1977-02-05	1977-02-05 00:00:00	1977-02-12	1977-02-12 00:00:00	32020		\N	50671	0	444814009	40481087		0
13175	775	4112343	2010-09-19	2010-09-19 00:00:00	2010-09-27	2010-09-27 00:00:00	32020		\N	51439	0	195662009	4112343		0
13301	782	4134304	1990-05-09	1990-05-09 00:00:00	1990-07-08	1990-07-08 00:00:00	32020		\N	52021	0	263102004	4134304		0
13551	800	4112343	1982-07-01	1982-07-01 00:00:00	1982-07-09	1982-07-09 00:00:00	32020		\N	53111	0	195662009	4112343		0
13663	807	40481087	1961-09-29	1961-09-29 00:00:00	1961-10-13	1961-10-13 00:00:00	32020		\N	53573	0	444814009	40481087		0
3320	191	4112343	1923-05-19	1923-05-19 00:00:00	1923-05-30	1923-05-30 00:00:00	32020		\N	13054	0	195662009	4112343		0
13968	825	372328	1971-08-18	1971-08-18 00:00:00	1971-09-18	1971-09-18 00:00:00	32020		\N	54668	0	65363002	372328		0
14229	841	4294548	2018-03-16	2018-03-16 00:00:00	2018-03-23	2018-03-23 00:00:00	32020		\N	55549	0	75498004	4294548		0
14310	844	40481087	1989-06-19	1989-06-19 00:00:00	1989-07-03	1989-07-03 00:00:00	32020		\N	56011	0	444814009	40481087		0
14501	857	260139	2000-02-27	2000-02-27 00:00:00	2000-03-05	2000-03-05 00:00:00	32020		\N	56609	0	10509002	260139		0
14658	865	4027663	1970-04-16	1970-04-16 00:00:00	\N	\N	32020		\N	57433	0	13200003	4027663		0
12506	739	80180	1947-12-15	1947-12-15 00:00:00	\N	\N	32020		\N	48924	0	396275006	80180		0
14815	871	40481087	2018-12-06	2018-12-06 00:00:00	2018-12-20	2018-12-20 00:00:00	32020		\N	57934	0	444814009	40481087		0
15021	884	40481087	1996-10-02	1996-10-02 00:00:00	1996-10-16	1996-10-16 00:00:00	32020		\N	58864	0	444814009	40481087		0
15181	895	4112343	2005-10-10	2005-10-10 00:00:00	2005-10-18	2005-10-18 00:00:00	32020		\N	59684	0	195662009	4112343		0
15322	906	28060	1979-01-07	1979-01-07 00:00:00	1979-01-15	1979-01-15 00:00:00	32020		\N	60271	0	43878008	28060		0
15485	917	4296205	1977-07-31	1977-07-31 00:00:00	1977-09-04	1977-09-04 00:00:00	32020		\N	60913	0	403191005	4296205		0
15680	929	78272	1992-09-12	1992-09-12 00:00:00	1992-09-26	1992-09-26 00:00:00	32020		\N	61758	0	70704007	78272		0
15801	935	4283893	1992-08-28	1992-08-28 00:00:00	1992-10-30	1992-10-30 00:00:00	32020		\N	62201	0	36971009	4283893		0
16017	948	4218389	1978-03-15	1978-03-15 00:00:00	1978-04-05	1978-04-05 00:00:00	32020		\N	62963	0	39848009	4218389		0
16177	956	4112343	1961-10-20	1961-10-20 00:00:00	1961-10-27	1961-10-27 00:00:00	32020		\N	63447	0	195662009	4112343		0
16302	964	4112343	1981-11-13	1981-11-13 00:00:00	1981-11-20	1981-11-20 00:00:00	32020		\N	64202	0	195662009	4112343		0
16460	972	4112343	1998-12-23	1998-12-23 00:00:00	1999-01-04	1999-01-04 00:00:00	32020		\N	64707	0	195662009	4112343		0
16667	987	4113008	2004-02-19	2004-02-19 00:00:00	2004-03-11	2004-03-11 00:00:00	32020		\N	65579	0	284549007	4113008		0
16834	1000	4059173	1972-08-23	1972-08-23 00:00:00	1972-11-21	1972-11-21 00:00:00	32020		\N	66137	0	16114001	4059173		0
16998	1015	260139	2010-06-30	2010-06-30 00:00:00	2010-07-07	2010-07-07 00:00:00	32020		\N	66838	0	10509002	260139		0
17237	1032	4218389	1990-07-26	1990-07-26 00:00:00	1990-08-23	1990-08-23 00:00:00	32020		\N	67952	0	39848009	4218389		0
17406	1046	260139	1980-09-19	1980-09-19 00:00:00	1980-09-26	1980-09-26 00:00:00	32020		\N	68674	0	10509002	260139		0
17488	1051	260139	1982-02-12	1982-02-12 00:00:00	1982-02-19	1982-02-19 00:00:00	32020		\N	68875	0	10509002	260139		0
17619	1058	40481087	1999-01-10	1999-01-10 00:00:00	1999-01-31	1999-01-31 00:00:00	32020		\N	69341	0	444814009	40481087		0
17856	1073	4112343	1983-06-20	1983-06-20 00:00:00	1983-07-01	1983-07-01 00:00:00	32020		\N	70390	0	195662009	4112343		0
17979	1081	40481087	2004-07-21	2004-07-21 00:00:00	2004-07-28	2004-07-28 00:00:00	32020		\N	70846	0	444814009	40481087		0
18159	1091	4112343	1972-11-07	1972-11-07 00:00:00	1972-11-16	1972-11-16 00:00:00	32020		\N	71595	0	195662009	4112343		0
18274	1099	372328	1953-01-07	1953-01-07 00:00:00	1953-03-21	1953-03-21 00:00:00	32020		\N	72190	0	65363002	372328		0
18484	1112	4112343	1982-01-23	1982-01-23 00:00:00	1982-02-03	1982-02-03 00:00:00	32020		\N	73166	0	195662009	4112343		0
18647	1120	28060	1972-07-30	1972-07-30 00:00:00	1972-08-06	1972-08-06 00:00:00	32020		\N	73788	0	43878008	28060		0
18827	1133	40481087	2002-08-26	2002-08-26 00:00:00	2002-09-09	2002-09-09 00:00:00	32020		\N	74575	0	444814009	40481087		0
18951	1138	80180	2016-03-12	2016-03-12 00:00:00	\N	\N	32020		\N	75136	0	396275006	80180		0
19129	1146	372328	1961-05-18	1961-05-18 00:00:00	1961-06-22	1961-06-22 00:00:00	32020		\N	75749	0	65363002	372328		0
19330	1158	4112343	1979-10-07	1979-10-07 00:00:00	1979-10-20	1979-10-20 00:00:00	32020		\N	76519	0	195662009	4112343		0
19576	1175	4112343	2002-01-06	2002-01-06 00:00:00	2002-01-17	2002-01-17 00:00:00	32020		\N	77512	0	195662009	4112343		0
19648	1177	4109685	2016-01-03	2016-01-03 00:00:00	2016-01-24	2016-01-24 00:00:00	32020		\N	77757	0	284551006	4109685		0
19862	1194	4112343	1960-10-23	1960-10-23 00:00:00	1960-10-30	1960-10-30 00:00:00	32020		\N	78685	0	195662009	4112343		0
19994	1206	372328	1969-05-01	1969-05-01 00:00:00	1970-01-26	1970-01-26 00:00:00	32020		\N	79234	0	65363002	372328		0
20181	1214	40481087	1992-03-03	1992-03-03 00:00:00	1992-03-17	1992-03-17 00:00:00	32020		\N	79976	0	444814009	40481087		0
20290	1222	40481087	1957-04-21	1957-04-21 00:00:00	1957-05-12	1957-05-12 00:00:00	32020		\N	80360	0	444814009	40481087		0
20492	1231	4112343	1978-04-15	1978-04-15 00:00:00	1978-04-24	1978-04-24 00:00:00	32020		\N	81120	0	195662009	4112343		0
20673	1242	40481087	2015-03-02	2015-03-02 00:00:00	2015-03-23	2015-03-23 00:00:00	32020		\N	81799	0	444814009	40481087		0
20804	1249	28060	1979-01-17	1979-01-17 00:00:00	1979-01-25	1979-01-25 00:00:00	32020		\N	82275	0	43878008	28060		0
20948	1258	260139	2013-10-18	2013-10-18 00:00:00	2013-10-25	2013-10-25 00:00:00	32020		\N	82891	0	10509002	260139		0
21193	1271	4112343	2014-04-15	2014-04-15 00:00:00	2014-04-26	2014-04-26 00:00:00	32020		\N	83806	0	195662009	4112343		0
10634	624	260139	1961-11-07	1961-11-07 00:00:00	1961-11-14	1961-11-14 00:00:00	32020		\N	41682	0	10509002	260139		0
10841	642	78272	1993-10-01	1993-10-01 00:00:00	1993-10-15	1993-10-15 00:00:00	32020		\N	42572	0	70704007	78272		0
11041	652	260139	1971-08-28	1971-08-28 00:00:00	1971-09-11	1971-09-11 00:00:00	32020		\N	43187	0	10509002	260139		0
11216	662	81893	1999-07-09	1999-07-09 00:00:00	\N	\N	32020		\N	43694	0	64766004	81893		0
11333	670	4112343	1980-07-13	1980-07-13 00:00:00	1980-07-25	1980-07-25 00:00:00	32020		\N	44239	0	195662009	4112343		0
11596	685	40481087	1986-08-18	1986-08-18 00:00:00	1986-09-08	1986-09-08 00:00:00	32020		\N	45265	0	444814009	40481087		0
11662	687	133834	1967-11-24	1967-11-24 00:00:00	1984-03-05	1984-03-05 00:00:00	32020		\N	45527	0	24079001	133834		0
11853	701	4296204	2008-06-04	2008-06-04 00:00:00	2008-07-09	2008-07-09 00:00:00	32020		\N	46364	0	403190006	4296204		0
12011	710	372328	1961-10-15	1961-10-15 00:00:00	1961-12-26	1961-12-26 00:00:00	32020		\N	47005	0	65363002	372328		0
12211	722	260139	1969-07-12	1969-07-12 00:00:00	1969-07-19	1969-07-19 00:00:00	32020		\N	47800	0	10509002	260139		0
12310	727	40480160	1998-01-16	1998-01-16 00:00:00	1998-04-16	1998-04-16 00:00:00	32020		\N	48220	0	443165006	40480160		0
12499	739	4278672	1935-06-21	1935-06-21 00:00:00	1935-09-19	1935-09-19 00:00:00	32020		\N	48969	0	65966004	4278672		0
12702	752	4237458	1951-10-15	1951-10-15 00:00:00	1952-01-13	1952-01-13 00:00:00	32020		\N	49639	0	58150001	4237458		0
12873	758	80180	2012-10-31	2012-10-31 00:00:00	\N	\N	32020		\N	50337	0	396275006	80180		0
12982	762	40481087	1997-10-26	1997-10-26 00:00:00	1997-11-02	1997-11-02 00:00:00	32020		\N	50659	0	444814009	40481087		0
13176	775	81151	1948-03-28	1948-03-28 00:00:00	1948-04-25	1948-04-25 00:00:00	32020		\N	51448	0	44465007	81151		0
13302	782	4283893	1955-10-21	1955-10-21 00:00:00	1956-07-13	1956-07-13 00:00:00	32020		\N	51995	0	36971009	4283893		0
13552	800	372328	1958-05-09	1958-05-09 00:00:00	1959-05-10	1959-05-10 00:00:00	32020		\N	53167	0	65363002	372328		0
13664	807	4218389	2014-10-15	2014-10-15 00:00:00	2014-11-19	2014-11-19 00:00:00	32020		\N	53547	0	39848009	4218389		0
13779	814	40481087	1986-03-09	1986-03-09 00:00:00	1986-03-23	1986-03-23 00:00:00	32020		\N	53990	0	444814009	40481087		0
13969	825	260139	1971-03-12	1971-03-12 00:00:00	1971-03-26	1971-03-26 00:00:00	32020		\N	54689	0	10509002	260139		0
14230	841	4027663	1982-01-08	1982-01-08 00:00:00	\N	\N	32020		\N	55596	0	13200003	4027663		0
14311	844	260139	1966-11-20	1966-11-20 00:00:00	1966-11-27	1966-11-27 00:00:00	32020		\N	55935	0	10509002	260139		0
14502	857	4283893	1981-02-23	1981-02-23 00:00:00	1981-06-15	1981-06-15 00:00:00	32020		\N	56661	0	36971009	4283893		0
14659	865	4112343	1987-04-22	1987-04-22 00:00:00	1987-05-03	1987-05-03 00:00:00	32020		\N	57395	0	195662009	4112343		0
14816	871	40481087	1995-01-03	1995-01-03 00:00:00	1995-01-10	1995-01-10 00:00:00	32020		\N	57926	0	444814009	40481087		0
15022	885	80180	2018-11-23	2018-11-23 00:00:00	\N	\N	32020		\N	58979	0	396275006	80180		0
15182	895	80180	2005-12-10	2005-12-10 00:00:00	\N	\N	32020		\N	59684	0	396275006	80180		0
15323	906	4294548	1983-04-23	1983-04-23 00:00:00	1983-06-18	1983-06-18 00:00:00	32020		\N	60272	0	75498004	4294548		0
15486	917	40481087	2006-09-02	2006-09-02 00:00:00	2006-09-09	2006-09-09 00:00:00	32020		\N	60942	0	444814009	40481087		0
15681	929	372328	1997-07-09	1997-07-09 00:00:00	1998-01-12	1998-01-12 00:00:00	32020		\N	61763	0	65363002	372328		0
15802	935	440086	1938-03-10	1938-03-10 00:00:00	1948-03-17	1948-03-17 00:00:00	32020		\N	62196	0	192127007	440086		0
16018	948	40481087	1991-07-18	1991-07-18 00:00:00	1991-08-08	1991-08-08 00:00:00	32020		\N	62942	0	444814009	40481087		0
16178	956	40481087	2012-06-29	2012-06-29 00:00:00	2012-07-06	2012-07-06 00:00:00	32020		\N	63452	0	444814009	40481087		0
16303	964	80180	2012-08-15	2012-08-15 00:00:00	\N	\N	32020		\N	64164	0	396275006	80180		0
16461	972	372328	1968-07-03	1968-07-03 00:00:00	1968-11-06	1968-11-06 00:00:00	32020		\N	64715	0	65363002	372328		0
16668	987	260139	2003-03-18	2003-03-18 00:00:00	2003-03-25	2003-03-25 00:00:00	32020		\N	65585	0	10509002	260139		0
16835	1000	372328	1965-01-02	1965-01-02 00:00:00	1965-02-16	1965-02-16 00:00:00	32020		\N	66144	0	65363002	372328		0
16999	1016	260139	2013-06-02	2013-06-02 00:00:00	2013-06-16	2013-06-16 00:00:00	32020		\N	66901	0	10509002	260139		0
17238	1032	4112343	1987-10-31	1987-10-31 00:00:00	1987-11-07	1987-11-07 00:00:00	32020		\N	67908	0	195662009	4112343		0
17407	1046	4152936	1992-02-28	1992-02-28 00:00:00	1992-03-20	1992-03-20 00:00:00	32020		\N	68699	0	283385000	4152936		0
17489	1051	40481087	1980-08-14	1980-08-14 00:00:00	1980-08-28	1980-08-28 00:00:00	32020		\N	68939	0	444814009	40481087		0
17620	1058	40481087	2017-02-04	2017-02-04 00:00:00	2017-02-25	2017-02-25 00:00:00	32020		\N	69345	0	444814009	40481087		0
17857	1073	260139	2006-01-23	2006-01-23 00:00:00	2006-02-01	2006-02-01 00:00:00	32020		\N	70374	0	10509002	260139		0
17980	1081	28060	2018-04-25	2018-04-25 00:00:00	2018-05-07	2018-05-07 00:00:00	32020		\N	70847	0	43878008	28060		0
18160	1091	28060	1987-01-16	1987-01-16 00:00:00	1987-01-29	1987-01-29 00:00:00	32020		\N	71596	0	43878008	28060		0
18275	1099	378001	1967-07-23	1967-07-23 00:00:00	1967-09-21	1967-09-21 00:00:00	32020		\N	72223	0	62106007	378001		0
18485	1112	4283893	1992-12-17	1992-12-17 00:00:00	1993-02-18	1993-02-18 00:00:00	32020		\N	73187	0	36971009	4283893		0
18648	1120	80180	1997-03-07	1997-03-07 00:00:00	\N	\N	32020		\N	73863	0	396275006	80180		0
18828	1133	260139	1973-03-30	1973-03-30 00:00:00	1973-04-06	1973-04-06 00:00:00	32020		\N	74587	0	10509002	260139		0
18952	1138	81151	1984-02-09	1984-02-09 00:00:00	1984-03-15	1984-03-15 00:00:00	32020		\N	75130	0	44465007	81151		0
19130	1146	260139	1990-11-30	1990-11-30 00:00:00	1990-12-14	1990-12-14 00:00:00	32020		\N	75744	0	10509002	260139		0
19331	1158	257012	2010-07-18	2010-07-18 00:00:00	\N	\N	32020		\N	76492	0	40055000	257012		0
19577	1175	28060	1942-07-20	1942-07-20 00:00:00	1942-08-02	1942-08-02 00:00:00	32020		\N	77544	0	43878008	28060		0
19649	1177	40481087	1984-09-09	1984-09-09 00:00:00	1984-09-23	1984-09-23 00:00:00	32020		\N	77732	0	444814009	40481087		0
19863	1194	80180	2001-05-27	2001-05-27 00:00:00	\N	\N	32020		\N	78675	0	396275006	80180		0
19995	1206	260139	2001-02-12	2001-02-12 00:00:00	2001-02-19	2001-02-19 00:00:00	32020		\N	79238	0	10509002	260139		0
20182	1214	4112343	2009-12-31	2009-12-31 00:00:00	2010-01-13	2010-01-13 00:00:00	32020		\N	79926	0	195662009	4112343		0
20291	1222	4112343	2007-07-22	2007-07-22 00:00:00	2007-08-01	2007-08-01 00:00:00	32020		\N	80436	0	195662009	4112343		0
20493	1231	28060	2002-05-13	2002-05-13 00:00:00	2002-05-23	2002-05-23 00:00:00	32020		\N	81109	0	43878008	28060		0
20674	1242	40481087	1977-12-06	1977-12-06 00:00:00	1977-12-27	1977-12-27 00:00:00	32020		\N	81822	0	444814009	40481087		0
20805	1249	28060	1971-12-09	1971-12-09 00:00:00	1971-12-21	1971-12-21 00:00:00	32020		\N	82296	0	43878008	28060		0
20949	1258	4152936	2006-02-05	2006-02-05 00:00:00	2006-02-26	2006-02-26 00:00:00	32020		\N	82899	0	283385000	4152936		0
21194	1271	260139	1986-02-10	1986-02-10 00:00:00	1986-02-17	1986-02-17 00:00:00	32020		\N	83805	0	10509002	260139		0
10635	624	260139	2019-05-16	2019-05-16 00:00:00	2019-05-23	2019-05-23 00:00:00	32020		\N	41666	0	10509002	260139		0
10842	642	260139	1944-03-14	1944-03-14 00:00:00	1944-03-28	1944-03-28 00:00:00	32020		\N	42517	0	10509002	260139		0
11042	652	4156265	1997-04-07	1997-04-07 00:00:00	1997-04-28	1997-04-28 00:00:00	32020		\N	43186	0	370247008	4156265		0
11217	662	372328	1961-02-17	1961-02-17 00:00:00	1961-05-31	1961-05-31 00:00:00	32020		\N	43702	0	65363002	372328		0
11334	670	260139	1984-10-02	1984-10-02 00:00:00	1984-10-09	1984-10-09 00:00:00	32020		\N	44222	0	10509002	260139		0
11597	685	4112343	1982-05-18	1982-05-18 00:00:00	1982-05-30	1982-05-30 00:00:00	32020		\N	45300	0	195662009	4112343		0
11663	687	4084167	1977-05-03	1977-05-03 00:00:00	1977-05-03	1977-05-03 00:00:00	32020		\N	45487	0	241929008	4084167		0
11854	701	28060	1962-05-11	1962-05-11 00:00:00	1962-05-24	1962-05-24 00:00:00	32020		\N	46318	0	43878008	28060		0
12012	710	80180	2004-04-27	2004-04-27 00:00:00	\N	\N	32020		\N	47055	0	396275006	80180		0
12212	722	4146173	1996-02-20	1996-02-20 00:00:00	1996-04-20	1996-04-20 00:00:00	32020		\N	47748	0	307731004	4146173		0
12311	727	4134304	1998-01-16	1998-01-16 00:00:00	1998-04-16	1998-04-16 00:00:00	32020		\N	48220	0	263102004	4134304		0
12500	739	4283893	1978-03-05	1978-03-05 00:00:00	1978-04-02	1978-04-02 00:00:00	32020		\N	48979	0	36971009	4283893		0
12703	752	40481087	1950-04-29	1950-04-29 00:00:00	1950-05-20	1950-05-20 00:00:00	32020		\N	49716	0	444814009	40481087		0
12874	758	4109685	2000-07-15	2000-07-15 00:00:00	2000-08-05	2000-08-05 00:00:00	32020		\N	50357	0	284551006	4109685		0
12983	762	260139	1980-04-20	1980-04-20 00:00:00	1980-04-27	1980-04-27 00:00:00	32020		\N	50673	0	10509002	260139		0
13177	775	4112343	1964-02-04	1964-02-04 00:00:00	1964-02-13	1964-02-13 00:00:00	32020		\N	51419	0	195662009	4112343		0
13303	782	4294548	1943-09-10	1943-09-10 00:00:00	1943-10-08	1943-10-08 00:00:00	32020		\N	51992	0	75498004	4294548		0
13553	800	40481087	1998-06-04	1998-06-04 00:00:00	1998-06-11	1998-06-11 00:00:00	32020		\N	53130	0	444814009	40481087		0
13665	807	4112343	1971-03-06	1971-03-06 00:00:00	1971-03-19	1971-03-19 00:00:00	32020		\N	53623	0	195662009	4112343		0
13806	817	372328	1958-02-10	1958-02-10 00:00:00	1958-04-24	1958-04-24 00:00:00	32020		\N	54152	0	65363002	372328		0
13970	825	4112343	1994-06-22	1994-06-22 00:00:00	1994-07-05	1994-07-05 00:00:00	32020		\N	54641	0	195662009	4112343		0
14231	842	4112343	1923-09-26	1923-09-26 00:00:00	1923-10-09	1923-10-09 00:00:00	32020		\N	55633	0	195662009	4112343		0
14312	844	4048171	1970-04-29	1970-04-29 00:00:00	1993-07-17	1993-07-17 00:00:00	32020		\N	55950	0	232353008	4048171		0
14503	857	40481087	1979-12-11	1979-12-11 00:00:00	1979-12-25	1979-12-25 00:00:00	32020		\N	56660	0	444814009	40481087		0
14660	865	4112343	2002-10-13	2002-10-13 00:00:00	2002-10-20	2002-10-20 00:00:00	32020		\N	57401	0	195662009	4112343		0
14817	871	4237458	1967-11-09	1967-11-09 00:00:00	1968-01-08	1968-01-08 00:00:00	32020		\N	57955	0	58150001	4237458		0
15023	885	40481087	2015-07-20	2015-07-20 00:00:00	2015-07-27	2015-07-27 00:00:00	32020		\N	59018	0	444814009	40481087		0
15183	895	372328	1963-12-16	1963-12-16 00:00:00	1964-01-10	1964-01-10 00:00:00	32020		\N	59701	0	65363002	372328		0
15363	911	80180	2015-06-16	2015-06-16 00:00:00	\N	\N	32020		\N	60518	0	396275006	80180		0
15487	918	321042	2016-05-20	2016-05-20 00:00:00	\N	\N	32020		\N	61206	0	410429000	321042		0
15682	929	40481087	1993-02-12	1993-02-12 00:00:00	1993-02-19	1993-02-19 00:00:00	32020		\N	61826	0	444814009	40481087		0
15803	935	313217	1990-05-09	1990-05-09 00:00:00	\N	\N	32020		\N	62238	0	49436004	313217		0
16019	948	4027663	1991-09-11	1991-09-11 00:00:00	\N	\N	32020		\N	62942	0	13200003	4027663		0
16179	956	260139	1945-04-15	1945-04-15 00:00:00	1945-04-22	1945-04-22 00:00:00	32020		\N	63489	0	10509002	260139		0
16304	964	4112343	1982-10-18	1982-10-18 00:00:00	1982-10-29	1982-10-29 00:00:00	32020		\N	64192	0	195662009	4112343		0
16462	972	40481087	1970-04-03	1970-04-03 00:00:00	1970-04-10	1970-04-10 00:00:00	32020		\N	64673	0	444814009	40481087		0
16669	987	260139	2018-05-15	2018-05-15 00:00:00	2018-05-29	2018-05-29 00:00:00	32020		\N	65602	0	10509002	260139		0
16836	1000	4278672	1976-02-18	1976-02-18 00:00:00	1976-03-19	1976-03-19 00:00:00	32020		\N	66139	0	65966004	4278672		0
17000	1016	40481087	2013-03-30	2013-03-30 00:00:00	2013-04-20	2013-04-20 00:00:00	32020		\N	66900	0	444814009	40481087		0
17239	1032	4283893	1976-08-25	1976-08-25 00:00:00	1976-11-17	1976-11-17 00:00:00	32020		\N	67883	0	36971009	4283893		0
17408	1046	4112343	1980-02-07	1980-02-07 00:00:00	1980-02-16	1980-02-16 00:00:00	32020		\N	68673	0	195662009	4112343		0
17490	1051	4112343	1990-09-22	1990-09-22 00:00:00	1990-10-03	1990-10-03 00:00:00	32020		\N	68880	0	195662009	4112343		0
17621	1058	4112343	1992-06-21	1992-06-21 00:00:00	1992-07-02	1992-07-02 00:00:00	32020		\N	69473	0	195662009	4112343		0
17858	1073	4218389	1964-10-10	1964-10-10 00:00:00	1964-11-14	1964-11-14 00:00:00	32020		\N	70302	0	39848009	4218389		0
17981	1081	4283893	1979-12-07	1979-12-07 00:00:00	1980-02-22	1980-02-22 00:00:00	32020		\N	70833	0	36971009	4283893		0
18161	1091	40481087	2010-08-19	2010-08-19 00:00:00	2010-09-09	2010-09-09 00:00:00	32020		\N	71704	0	444814009	40481087		0
18276	1099	4283893	1967-09-20	1967-09-20 00:00:00	1967-11-15	1967-11-15 00:00:00	32020		\N	72107	0	36971009	4283893		0
18486	1112	378001	2013-01-26	2013-01-26 00:00:00	2013-03-27	2013-03-27 00:00:00	32020		\N	73186	0	62106007	378001		0
18650	1122	4156265	1991-09-07	1991-09-07 00:00:00	1991-09-28	1991-09-28 00:00:00	32020		\N	73964	0	370247008	4156265		0
18829	1133	40481087	1994-07-23	1994-07-23 00:00:00	1994-08-06	1994-08-06 00:00:00	32020		\N	74628	0	444814009	40481087		0
18953	1138	4112343	1994-12-15	1994-12-15 00:00:00	1994-12-25	1994-12-25 00:00:00	32020		\N	75014	0	195662009	4112343		0
19131	1146	4112343	1977-02-07	1977-02-07 00:00:00	1977-02-19	1977-02-19 00:00:00	32020		\N	75716	0	195662009	4112343		0
19332	1158	4112343	1998-02-15	1998-02-15 00:00:00	1998-02-22	1998-02-22 00:00:00	32020		\N	76505	0	195662009	4112343		0
19578	1175	4059173	1967-02-28	1967-02-28 00:00:00	1967-04-29	1967-04-29 00:00:00	32020		\N	77419	0	16114001	4059173		0
19650	1177	40481087	1985-05-29	1985-05-29 00:00:00	1985-06-19	1985-06-19 00:00:00	32020		\N	77798	0	444814009	40481087		0
19893	1197	257012	2005-01-24	2005-01-24 00:00:00	\N	\N	32020		\N	78845	0	40055000	257012		0
19996	1206	4294548	1965-01-10	1965-01-10 00:00:00	1965-01-17	1965-01-17 00:00:00	32020		\N	79252	0	75498004	4294548		0
20183	1214	378001	2009-07-29	2009-07-29 00:00:00	2009-08-28	2009-08-28 00:00:00	32020		\N	79989	0	62106007	378001		0
20292	1222	4278672	1971-08-13	1971-08-13 00:00:00	1971-11-11	1971-11-11 00:00:00	32020		\N	80424	0	65966004	4278672		0
20494	1231	78272	1975-03-09	1975-03-09 00:00:00	1975-04-06	1975-04-06 00:00:00	32020		\N	81115	0	70704007	78272		0
20675	1242	40481087	1974-04-07	1974-04-07 00:00:00	1974-04-21	1974-04-21 00:00:00	32020		\N	81792	0	444814009	40481087		0
20806	1249	40481087	1998-12-10	1998-12-10 00:00:00	1998-12-24	1998-12-24 00:00:00	32020		\N	82297	0	444814009	40481087		0
20950	1258	260139	2015-11-16	2015-11-16 00:00:00	2015-11-23	2015-11-23 00:00:00	32020		\N	82880	0	10509002	260139		0
21195	1272	40481087	2001-12-24	2001-12-24 00:00:00	2001-12-31	2001-12-31 00:00:00	32020		\N	83911	0	444814009	40481087		0
10636	624	4112343	1996-08-21	1996-08-21 00:00:00	1996-09-02	1996-09-02 00:00:00	32020		\N	41652	0	195662009	4112343		0
10843	642	40481087	1983-02-01	1983-02-01 00:00:00	1983-02-22	1983-02-22 00:00:00	32020		\N	42538	0	444814009	40481087		0
11043	652	40481087	1989-07-11	1989-07-11 00:00:00	1989-07-18	1989-07-18 00:00:00	32020		\N	43142	0	444814009	40481087		0
11218	662	40481087	1962-06-21	1962-06-21 00:00:00	1962-07-12	1962-07-12 00:00:00	32020		\N	43718	0	444814009	40481087		0
11335	670	4112343	1976-04-22	1976-04-22 00:00:00	1976-05-02	1976-05-02 00:00:00	32020		\N	44238	0	195662009	4112343		0
11598	685	78272	1991-03-24	1991-03-24 00:00:00	1991-04-07	1991-04-07 00:00:00	32020		\N	45306	0	70704007	78272		0
11664	687	4048695	2003-10-23	2003-10-23 00:00:00	2003-12-24	2003-12-24 00:00:00	32020		\N	45495	0	15724005	4048695		0
11855	701	40481087	1998-01-04	1998-01-04 00:00:00	1998-01-11	1998-01-11 00:00:00	32020		\N	46322	0	444814009	40481087		0
12013	710	260139	1985-01-21	1985-01-21 00:00:00	1985-01-28	1985-01-28 00:00:00	32020		\N	47003	0	10509002	260139		0
12213	722	4112343	1997-08-21	1997-08-21 00:00:00	1997-09-01	1997-09-01 00:00:00	32020		\N	47766	0	195662009	4112343		0
12312	728	28060	1966-04-10	1966-04-10 00:00:00	1966-04-20	1966-04-20 00:00:00	32020		\N	48331	0	43878008	28060		0
12501	739	81151	1987-10-16	1987-10-16 00:00:00	1987-11-20	1987-11-20 00:00:00	32020		\N	48932	0	44465007	81151		0
12704	752	40481087	1967-07-16	1967-07-16 00:00:00	1967-07-23	1967-07-23 00:00:00	32020		\N	49677	0	444814009	40481087		0
12875	758	260139	2000-05-04	2000-05-04 00:00:00	2000-05-11	2000-05-11 00:00:00	32020		\N	50316	0	10509002	260139		0
12984	762	4112343	1979-01-06	1979-01-06 00:00:00	1979-01-17	1979-01-17 00:00:00	32020		\N	50661	0	195662009	4112343		0
13178	775	4294548	1974-04-27	1974-04-27 00:00:00	1974-05-18	1974-05-18 00:00:00	32020		\N	51437	0	75498004	4294548		0
13304	782	40481087	1997-12-24	1997-12-24 00:00:00	1998-01-07	1998-01-07 00:00:00	32020		\N	51984	0	444814009	40481087		0
13554	800	372328	1970-06-11	1970-06-11 00:00:00	1970-07-12	1970-07-12 00:00:00	32020		\N	53112	0	65363002	372328		0
13666	807	40481087	2009-12-05	2009-12-05 00:00:00	2009-12-12	2009-12-12 00:00:00	32020		\N	53575	0	444814009	40481087		0
13807	817	40479768	2012-12-26	2012-12-26 00:00:00	2013-02-01	2013-02-01 00:00:00	32020		\N	54111	0	444470001	40479768		0
13971	825	4109685	2013-08-02	2013-08-02 00:00:00	2013-08-23	2013-08-23 00:00:00	32020		\N	54655	0	284551006	4109685		0
14232	842	81151	1992-02-02	1992-02-02 00:00:00	1992-03-01	1992-03-01 00:00:00	32020		\N	55661	0	44465007	81151		0
14313	844	4134304	1982-01-29	1982-01-29 00:00:00	1982-04-29	1982-04-29 00:00:00	32020		\N	56003	0	263102004	4134304		0
14504	857	195588	1981-02-23	1981-02-23 00:00:00	1981-04-13	1981-04-13 00:00:00	32020		\N	56661	0	38822007	195588		0
14661	865	4146173	2006-01-08	2006-01-08 00:00:00	2006-02-07	2006-02-07 00:00:00	32020		\N	57396	0	307731004	4146173		0
14818	871	4035415	2001-10-25	2001-10-25 00:00:00	2001-11-24	2001-11-24 00:00:00	32020		\N	57958	0	239720000	4035415		0
15024	885	372328	1979-12-03	1979-12-03 00:00:00	1980-03-23	1980-03-23 00:00:00	32020		\N	59019	0	65363002	372328		0
15184	895	40481087	1995-07-07	1995-07-07 00:00:00	1995-07-28	1995-07-28 00:00:00	32020		\N	59673	0	444814009	40481087		0
15364	911	4084167	1984-05-24	1984-05-24 00:00:00	1984-05-24	1984-05-24 00:00:00	32020		\N	60479	0	241929008	4084167		0
15489	918	40481087	2012-08-08	2012-08-08 00:00:00	2012-08-29	2012-08-29 00:00:00	32020		\N	61124	0	444814009	40481087		0
15683	929	317576	1990-12-03	1990-12-03 00:00:00	\N	\N	32020		\N	61800	0	53741008	317576		0
15804	935	40481087	1945-09-05	1945-09-05 00:00:00	1945-09-26	1945-09-26 00:00:00	32020		\N	62216	0	444814009	40481087		0
16020	948	40481087	1983-11-26	1983-11-26 00:00:00	1983-12-03	1983-12-03 00:00:00	32020		\N	62967	0	444814009	40481087		0
16180	956	4112343	1983-06-18	1983-06-18 00:00:00	1983-07-01	1983-07-01 00:00:00	32020		\N	63448	0	195662009	4112343		0
16305	964	260139	1981-04-02	1981-04-02 00:00:00	1981-04-16	1981-04-16 00:00:00	32020		\N	64201	0	10509002	260139		0
16463	972	381316	2019-01-30	2019-01-30 00:00:00	\N	\N	32020		\N	64683	0	230690007	381316		0
16670	987	260139	1984-01-13	1984-01-13 00:00:00	1984-01-20	1984-01-20 00:00:00	32020		\N	65584	0	10509002	260139		0
16837	1000	40481087	1990-07-03	1990-07-03 00:00:00	1990-07-24	1990-07-24 00:00:00	32020		\N	66189	0	444814009	40481087		0
17001	1016	260139	2009-06-15	2009-06-15 00:00:00	2009-06-22	2009-06-22 00:00:00	32020		\N	66908	0	10509002	260139		0
17240	1032	260139	2017-03-07	2017-03-07 00:00:00	2017-03-14	2017-03-14 00:00:00	32020		\N	67934	0	10509002	260139		0
17409	1046	28060	1984-08-25	1984-08-25 00:00:00	1984-09-04	1984-09-04 00:00:00	32020		\N	68649	0	43878008	28060		0
17491	1051	40481087	2014-01-02	2014-01-02 00:00:00	2014-01-23	2014-01-23 00:00:00	32020		\N	68955	0	444814009	40481087		0
17622	1058	260139	1986-10-07	1986-10-07 00:00:00	1986-10-14	1986-10-14 00:00:00	32020		\N	69383	0	10509002	260139		0
17859	1073	4278672	1950-09-10	1950-09-10 00:00:00	1950-10-10	1950-10-10 00:00:00	32020		\N	70300	0	65966004	4278672		0
17982	1081	257012	1980-01-04	1980-01-04 00:00:00	\N	\N	32020		\N	70882	0	40055000	257012		0
30058	1779	321042	1949-09-15	1949-09-15 00:00:00	\N	\N	32020		\N	119064	0	410429000	321042		0
18162	1091	4112343	1961-12-12	1961-12-12 00:00:00	1961-12-21	1961-12-21 00:00:00	32020		\N	71688	0	195662009	4112343		0
18277	1099	80180	1990-07-27	1990-07-27 00:00:00	\N	\N	32020		\N	72245	0	396275006	80180		0
18487	1112	40481087	1969-10-03	1969-10-03 00:00:00	1969-10-10	1969-10-10 00:00:00	32020		\N	73213	0	444814009	40481087		0
18651	1122	4134304	1992-07-24	1992-07-24 00:00:00	1992-09-22	1992-09-22 00:00:00	32020		\N	73965	0	263102004	4134304		0
18830	1133	4266809	2000-07-20	2000-07-20 00:00:00	\N	\N	32020		\N	74630	0	397881000	4266809		0
18954	1138	4112343	1994-04-04	1994-04-04 00:00:00	1994-04-16	1994-04-16 00:00:00	32020		\N	75068	0	195662009	4112343		0
19132	1146	40481087	1960-03-17	1960-03-17 00:00:00	1960-03-31	1960-03-31 00:00:00	32020		\N	75668	0	444814009	40481087		0
19333	1158	40481087	1991-12-08	1991-12-08 00:00:00	1991-12-15	1991-12-15 00:00:00	32020		\N	76514	0	444814009	40481087		0
19579	1175	4112343	2011-01-01	2011-01-01 00:00:00	2011-01-12	2011-01-12 00:00:00	32020		\N	77541	0	195662009	4112343		0
19651	1177	40481087	2015-05-01	2015-05-01 00:00:00	2015-05-22	2015-05-22 00:00:00	32020		\N	77733	0	444814009	40481087		0
19894	1197	4112343	2016-04-26	2016-04-26 00:00:00	2016-05-06	2016-05-06 00:00:00	32020		\N	78846	0	195662009	4112343		0
19997	1206	372328	1965-07-17	1965-07-17 00:00:00	1966-01-17	1966-01-17 00:00:00	32020		\N	79250	0	65363002	372328		0
20184	1214	40481087	1983-09-19	1983-09-19 00:00:00	1983-10-10	1983-10-10 00:00:00	32020		\N	80000	0	444814009	40481087		0
20293	1222	4156265	1960-05-21	1960-05-21 00:00:00	1960-06-11	1960-06-11 00:00:00	32020		\N	80423	0	370247008	4156265		0
20495	1231	28060	1970-09-15	1970-09-15 00:00:00	1970-09-22	1970-09-22 00:00:00	32020		\N	81071	0	43878008	28060		0
20676	1242	81151	1969-10-14	1969-10-14 00:00:00	1969-11-11	1969-11-11 00:00:00	32020		\N	81768	0	44465007	81151		0
20807	1249	81151	2018-03-03	2018-03-03 00:00:00	2018-04-07	2018-04-07 00:00:00	32020		\N	82294	0	44465007	81151		0
20951	1258	378001	2018-08-22	2018-08-22 00:00:00	2018-10-21	2018-10-21 00:00:00	32020		\N	82901	0	62106007	378001		0
21197	1272	321042	1991-08-30	1991-08-30 00:00:00	\N	\N	32020		\N	83860	0	410429000	321042		0
10637	625	257012	2001-04-02	2001-04-02 00:00:00	2001-08-13	2001-08-13 00:00:00	32020		\N	41776	0	40055000	257012		0
10844	642	4218389	2006-01-10	2006-01-10 00:00:00	2006-02-14	2006-02-14 00:00:00	32020		\N	42573	0	39848009	4218389		0
11044	652	4112343	1995-06-16	1995-06-16 00:00:00	1995-06-26	1995-06-26 00:00:00	32020		\N	43161	0	195662009	4112343		0
11219	662	4218389	1992-10-01	1992-10-01 00:00:00	1992-11-04	1992-11-04 00:00:00	32020		\N	43751	0	39848009	4218389		0
11336	670	4112343	2012-03-25	2012-03-25 00:00:00	2012-04-01	2012-04-01 00:00:00	32020		\N	44204	0	195662009	4112343		0
11599	685	30753	1998-12-26	1998-12-26 00:00:00	\N	\N	32020		\N	45323	0	16761005	30753		0
11669	689	40481087	1982-09-26	1982-09-26 00:00:00	1982-10-10	1982-10-10 00:00:00	32020		\N	45635	0	444814009	40481087		0
11856	701	4112343	1964-04-17	1964-04-17 00:00:00	1964-04-26	1964-04-26 00:00:00	32020		\N	46319	0	195662009	4112343		0
12014	710	4112343	1962-05-15	1962-05-15 00:00:00	1962-05-27	1962-05-27 00:00:00	32020		\N	47040	0	195662009	4112343		0
12214	722	40481087	1990-05-25	1990-05-25 00:00:00	1990-06-08	1990-06-08 00:00:00	32020		\N	47764	0	444814009	40481087		0
12313	728	80180	1990-03-04	1990-03-04 00:00:00	\N	\N	32020		\N	48281	0	396275006	80180		0
12502	739	4112343	1992-09-01	1992-09-01 00:00:00	1992-09-14	1992-09-14 00:00:00	32020		\N	48952	0	195662009	4112343		0
12705	752	260139	1957-01-16	1957-01-16 00:00:00	1957-01-30	1957-01-30 00:00:00	32020		\N	49653	0	10509002	260139		0
12876	758	260139	2006-05-03	2006-05-03 00:00:00	2006-05-10	2006-05-10 00:00:00	32020		\N	50338	0	10509002	260139		0
12985	762	40481087	1976-03-16	1976-03-16 00:00:00	1976-04-06	1976-04-06 00:00:00	32020		\N	50676	0	444814009	40481087		0
13179	775	381316	2017-03-15	2017-03-15 00:00:00	\N	\N	32020		\N	51455	0	230690007	381316		0
13305	782	4155034	1977-11-15	1977-11-15 00:00:00	1977-11-29	1977-11-29 00:00:00	32020		\N	52019	0	283371005	4155034		0
13555	800	4296204	2010-02-08	2010-02-08 00:00:00	2010-03-01	2010-03-01 00:00:00	32020		\N	53095	0	403190006	4296204		0
13667	807	40481087	1996-06-03	1996-06-03 00:00:00	1996-06-10	1996-06-10 00:00:00	32020		\N	53626	0	444814009	40481087		0
13808	817	260139	1971-11-01	1971-11-01 00:00:00	1971-11-08	1971-11-08 00:00:00	32020		\N	54091	0	10509002	260139		0
13972	825	439777	1970-09-12	1970-09-12 00:00:00	\N	\N	32020		\N	54664	0	271737000	439777		0
14233	842	40481087	1987-02-02	1987-02-02 00:00:00	1987-02-16	1987-02-16 00:00:00	32020		\N	55645	0	444814009	40481087		0
14314	844	40481087	1978-12-19	1978-12-19 00:00:00	1978-12-26	1978-12-26 00:00:00	32020		\N	55938	0	444814009	40481087		0
14505	857	40481087	2005-09-05	2005-09-05 00:00:00	2005-09-12	2005-09-12 00:00:00	32020		\N	56665	0	444814009	40481087		0
14662	865	28060	1955-12-10	1955-12-10 00:00:00	1955-12-23	1955-12-23 00:00:00	32020		\N	57359	0	43878008	28060		0
14819	871	40481087	1966-12-20	1966-12-20 00:00:00	1967-01-10	1967-01-10 00:00:00	32020		\N	57925	0	444814009	40481087		0
15025	885	372328	1976-07-06	1976-07-06 00:00:00	1976-09-19	1976-09-19 00:00:00	32020		\N	58990	0	65363002	372328		0
15185	895	317576	1980-02-29	1980-02-29 00:00:00	\N	\N	32020		\N	59740	0	53741008	317576		0
15365	911	260139	1986-01-16	1986-01-16 00:00:00	1986-01-30	1986-01-30 00:00:00	32020		\N	60490	0	10509002	260139		0
15490	918	4112343	1959-10-09	1959-10-09 00:00:00	1959-10-18	1959-10-18 00:00:00	32020		\N	61137	0	195662009	4112343		0
15684	929	260139	1967-11-16	1967-11-16 00:00:00	1967-11-30	1967-11-30 00:00:00	32020		\N	61840	0	10509002	260139		0
15805	935	40481087	1946-01-03	1946-01-03 00:00:00	1946-01-10	1946-01-10 00:00:00	32020		\N	62198	0	444814009	40481087		0
16021	948	4112343	2015-12-30	2015-12-30 00:00:00	2016-01-11	2016-01-11 00:00:00	32020		\N	62920	0	195662009	4112343		0
16189	958	40481087	1985-09-18	1985-09-18 00:00:00	1985-10-02	1985-10-02 00:00:00	32020		\N	63610	0	444814009	40481087		0
16306	964	28060	1980-11-04	1980-11-04 00:00:00	1980-11-14	1980-11-14 00:00:00	32020		\N	64183	0	43878008	28060		0
16464	972	4142905	1974-01-20	1974-01-20 00:00:00	1974-04-20	1974-04-20 00:00:00	32020		\N	64718	0	33737001	4142905		0
16671	987	80502	2013-10-27	2013-10-27 00:00:00	\N	\N	32020		\N	65571	0	64859006	80502		0
16838	1000	4294548	1964-08-14	1964-08-14 00:00:00	1965-03-19	1965-03-19 00:00:00	32020		\N	66190	0	75498004	4294548		0
17002	1016	80180	2010-01-24	2010-01-24 00:00:00	\N	\N	32020		\N	66916	0	396275006	80180		0
17241	1032	4112343	1955-05-30	1955-05-30 00:00:00	1955-06-07	1955-06-07 00:00:00	32020		\N	67898	0	195662009	4112343		0
17410	1046	40481087	2019-04-17	2019-04-17 00:00:00	2019-04-24	2019-04-24 00:00:00	32020		\N	68662	0	444814009	40481087		0
17492	1051	4112343	2010-03-07	2010-03-07 00:00:00	2010-03-18	2010-03-18 00:00:00	32020		\N	68878	0	195662009	4112343		0
17623	1058	4112343	2003-10-26	2003-10-26 00:00:00	2003-11-05	2003-11-05 00:00:00	32020		\N	69420	0	195662009	4112343		0
17883	1076	40481087	1975-01-08	1975-01-08 00:00:00	1975-01-29	1975-01-29 00:00:00	32020		\N	70530	0	444814009	40481087		0
17983	1081	260139	1963-03-10	1963-03-10 00:00:00	1963-03-17	1963-03-17 00:00:00	32020		\N	70860	0	10509002	260139		0
18163	1091	40481087	2016-09-15	2016-09-15 00:00:00	2016-09-29	2016-09-29 00:00:00	32020		\N	71649	0	444814009	40481087		0
18278	1099	4266809	1990-07-27	1990-07-27 00:00:00	\N	\N	32020		\N	72245	0	397881000	4266809		0
18488	1113	28060	1986-10-11	1986-10-11 00:00:00	1986-10-19	1986-10-19 00:00:00	32020		\N	73256	0	43878008	28060		0
18652	1122	40481087	2007-09-04	2007-09-04 00:00:00	2007-09-11	2007-09-11 00:00:00	32020		\N	73890	0	444814009	40481087		0
18831	1133	80180	2000-07-20	2000-07-20 00:00:00	\N	\N	32020		\N	74630	0	396275006	80180		0
18955	1138	28060	1981-07-26	1981-07-26 00:00:00	1981-08-08	1981-08-08 00:00:00	32020		\N	75059	0	43878008	28060		0
19133	1146	195588	1986-01-08	1986-01-08 00:00:00	1986-02-15	1986-02-15 00:00:00	32020		\N	75743	0	38822007	195588		0
19334	1158	40481087	1994-08-07	1994-08-07 00:00:00	1994-08-14	1994-08-14 00:00:00	32020		\N	76526	0	444814009	40481087		0
19580	1175	4112343	2001-01-15	2001-01-15 00:00:00	2001-01-26	2001-01-26 00:00:00	32020		\N	77511	0	195662009	4112343		0
19652	1177	372328	1964-01-24	1964-01-24 00:00:00	1964-04-06	1964-04-06 00:00:00	32020		\N	77801	0	65363002	372328		0
19895	1197	4218389	1988-10-30	1988-10-30 00:00:00	1988-11-27	1988-11-27 00:00:00	32020		\N	78849	0	39848009	4218389		0
19998	1206	40481087	2008-07-29	2008-07-29 00:00:00	2008-08-19	2008-08-19 00:00:00	32020		\N	79233	0	444814009	40481087		0
20185	1214	4109685	1987-02-11	1987-02-11 00:00:00	1987-02-25	1987-02-25 00:00:00	32020		\N	79988	0	284551006	4109685		0
20294	1222	28060	2017-08-10	2017-08-10 00:00:00	2017-08-22	2017-08-22 00:00:00	32020		\N	80405	0	43878008	28060		0
20496	1231	260139	1968-04-21	1968-04-21 00:00:00	1968-05-06	1968-05-06 00:00:00	32020		\N	81107	0	10509002	260139		0
20677	1242	78272	2014-07-02	2014-07-02 00:00:00	2014-07-23	2014-07-23 00:00:00	32020		\N	81770	0	70704007	78272		0
20808	1249	260139	2017-07-03	2017-07-03 00:00:00	2017-07-17	2017-07-17 00:00:00	32020		\N	82299	0	10509002	260139		0
20952	1258	257012	2007-11-02	2007-11-02 00:00:00	\N	\N	32020		\N	82879	0	40055000	257012		0
21198	1272	40481087	2018-07-07	2018-07-07 00:00:00	2018-07-21	2018-07-21 00:00:00	32020		\N	83941	0	444814009	40481087		0
10638	625	4134304	1974-12-25	1974-12-25 00:00:00	1975-01-24	1975-01-24 00:00:00	32020		\N	41733	0	263102004	4134304		0
10845	642	4113008	2010-12-20	2010-12-20 00:00:00	2011-01-10	2011-01-10 00:00:00	32020		\N	42574	0	284549007	4113008		0
11045	652	4112343	1968-06-15	1968-06-15 00:00:00	1968-06-23	1968-06-23 00:00:00	32020		\N	43141	0	195662009	4112343		0
11221	662	4329847	2012-06-06	2012-06-06 00:00:00	\N	\N	32020		\N	43754	0	22298006	4329847		0
11337	670	40481087	1983-08-22	1983-08-22 00:00:00	1983-09-05	1983-09-05 00:00:00	32020		\N	44254	0	444814009	40481087		0
11600	685	4285898	1999-10-22	1999-10-22 00:00:00	\N	\N	32020		\N	45323	0	68496003	4285898		0
11670	689	4112343	1991-02-18	1991-02-18 00:00:00	1991-03-01	1991-03-01 00:00:00	32020		\N	45610	0	195662009	4112343		0
11857	701	40481087	1983-06-08	1983-06-08 00:00:00	1983-06-22	1983-06-22 00:00:00	32020		\N	46321	0	444814009	40481087		0
12015	710	4112343	1969-10-21	1969-10-21 00:00:00	1969-10-31	1969-10-31 00:00:00	32020		\N	47036	0	195662009	4112343		0
12215	722	4112343	2007-12-10	2007-12-10 00:00:00	2007-12-19	2007-12-19 00:00:00	32020		\N	47790	0	195662009	4112343		0
12314	728	440086	1964-01-20	1964-01-20 00:00:00	1964-12-21	1964-12-21 00:00:00	32020		\N	48348	0	192127007	440086		0
12503	739	40481087	1927-06-10	1927-06-10 00:00:00	1927-06-24	1927-06-24 00:00:00	32020		\N	48975	0	444814009	40481087		0
12706	752	40481087	1994-04-08	1994-04-08 00:00:00	1994-04-22	1994-04-22 00:00:00	32020		\N	49719	0	444814009	40481087		0
12877	758	40481087	2000-10-27	2000-10-27 00:00:00	2000-11-10	2000-11-10 00:00:00	32020		\N	50317	0	444814009	40481087		0
12986	763	378001	2007-04-12	2007-04-12 00:00:00	2007-05-12	2007-05-12 00:00:00	32020		\N	50735	0	62106007	378001		0
13180	775	260139	1982-09-05	1982-09-05 00:00:00	1982-09-12	1982-09-12 00:00:00	32020		\N	51487	0	10509002	260139		0
13306	782	80180	1944-10-27	1944-10-27 00:00:00	\N	\N	32020		\N	52022	0	396275006	80180		0
13556	800	4149245	1994-06-04	1994-06-04 00:00:00	1994-08-10	1994-08-10 00:00:00	32020		\N	53093	0	30832001	4149245		0
13668	807	80180	1994-09-22	1994-09-22 00:00:00	\N	\N	32020		\N	53550	0	396275006	80180		0
13809	817	40481087	2018-07-07	2018-07-07 00:00:00	2018-07-28	2018-07-28 00:00:00	32020		\N	54138	0	444814009	40481087		0
13973	825	40481087	1999-08-14	1999-08-14 00:00:00	1999-08-28	1999-08-28 00:00:00	32020		\N	54630	0	444814009	40481087		0
14234	842	30753	1942-11-09	1942-11-09 00:00:00	\N	\N	32020		\N	55602	0	16761005	30753		0
14315	844	260139	1989-04-02	1989-04-02 00:00:00	1989-04-16	1989-04-16 00:00:00	32020		\N	55926	0	10509002	260139		0
14506	857	28060	1954-07-22	1954-07-22 00:00:00	1954-07-30	1954-07-30 00:00:00	32020		\N	56628	0	43878008	28060		0
14663	865	4285898	1980-03-04	1980-03-04 00:00:00	\N	\N	32020		\N	57362	0	68496003	4285898		0
14820	871	40481087	2014-09-28	2014-09-28 00:00:00	2014-10-19	2014-10-19 00:00:00	32020		\N	57943	0	444814009	40481087		0
15026	885	440086	1987-04-10	1987-04-10 00:00:00	1989-02-17	1989-02-17 00:00:00	32020		\N	58972	0	192127007	440086		0
15186	895	260139	1989-12-28	1989-12-28 00:00:00	1990-01-04	1990-01-04 00:00:00	32020		\N	59698	0	10509002	260139		0
15366	911	4280726	1979-03-14	1979-03-14 00:00:00	\N	\N	32020		\N	60460	0	367498001	4280726		0
15491	918	40481087	1967-08-06	1967-08-06 00:00:00	1967-08-13	1967-08-13 00:00:00	32020		\N	61130	0	444814009	40481087		0
15685	929	28060	1965-10-04	1965-10-04 00:00:00	1965-10-17	1965-10-17 00:00:00	32020		\N	61824	0	43878008	28060		0
15806	935	4134304	1936-04-09	1936-04-09 00:00:00	1936-07-08	1936-07-08 00:00:00	32020		\N	62225	0	263102004	4134304		0
16022	948	28060	1980-08-08	1980-08-08 00:00:00	1980-08-15	1980-08-15 00:00:00	32020		\N	62966	0	43878008	28060		0
16190	958	4152936	2012-10-04	2012-10-04 00:00:00	2012-10-18	2012-10-18 00:00:00	32020		\N	63599	0	283385000	4152936		0
16307	964	4296204	1995-02-16	1995-02-16 00:00:00	1995-03-02	1995-03-02 00:00:00	32020		\N	64149	0	403190006	4296204		0
16465	972	40481087	1999-06-14	1999-06-14 00:00:00	1999-07-05	1999-07-05 00:00:00	32020		\N	64722	0	444814009	40481087		0
16672	987	372328	1954-06-26	1954-06-26 00:00:00	1954-08-08	1954-08-08 00:00:00	32020		\N	65537	0	65363002	372328		0
16839	1000	4113008	2011-06-12	2011-06-12 00:00:00	2011-06-26	2011-06-26 00:00:00	32020		\N	66141	0	284549007	4113008		0
17003	1016	28060	1996-03-16	1996-03-16 00:00:00	1996-03-23	1996-03-23 00:00:00	32020		\N	66897	0	43878008	28060		0
17242	1032	78272	1994-02-08	1994-02-08 00:00:00	1994-03-01	1994-03-01 00:00:00	32020		\N	67954	0	70704007	78272		0
17411	1046	4218389	1996-03-29	1996-03-29 00:00:00	1996-04-26	1996-04-26 00:00:00	32020		\N	68700	0	39848009	4218389		0
17493	1051	40481087	2005-08-16	2005-08-16 00:00:00	2005-08-30	2005-08-30 00:00:00	32020		\N	68942	0	444814009	40481087		0
17624	1058	40481087	2010-06-26	2010-06-26 00:00:00	2010-07-03	2010-07-03 00:00:00	32020		\N	69395	0	444814009	40481087		0
17884	1076	4112343	2005-05-08	2005-05-08 00:00:00	2005-05-16	2005-05-16 00:00:00	32020		\N	70549	0	195662009	4112343		0
17984	1081	40481087	1965-06-01	1965-06-01 00:00:00	1965-06-15	1965-06-15 00:00:00	32020		\N	70832	0	444814009	40481087		0
18164	1091	28060	1967-09-23	1967-09-23 00:00:00	1967-10-02	1967-10-02 00:00:00	32020		\N	71678	0	43878008	28060		0
18279	1099	81151	1983-08-24	1983-08-24 00:00:00	1983-09-14	1983-09-14 00:00:00	32020		\N	72159	0	44465007	81151		0
18489	1113	372328	1974-08-10	1974-08-10 00:00:00	1974-10-22	1974-10-22 00:00:00	32020		\N	73259	0	65363002	372328		0
18653	1122	40481087	2004-08-22	2004-08-22 00:00:00	2004-09-12	2004-09-12 00:00:00	32020		\N	73889	0	444814009	40481087		0
18832	1133	4027663	1991-07-03	1991-07-03 00:00:00	\N	\N	32020		\N	74625	0	13200003	4027663		0
18956	1138	40481087	2019-03-12	2019-03-12 00:00:00	2019-04-02	2019-04-02 00:00:00	32020		\N	75093	0	444814009	40481087		0
19134	1146	4237458	1970-11-25	1970-11-25 00:00:00	1971-01-24	1971-01-24 00:00:00	32020		\N	75740	0	58150001	4237458		0
19335	1158	4112343	2010-01-07	2010-01-07 00:00:00	2010-01-15	2010-01-15 00:00:00	32020		\N	76508	0	195662009	4112343		0
19581	1175	4152936	1979-06-25	1979-06-25 00:00:00	1979-07-09	1979-07-09 00:00:00	32020		\N	77420	0	283385000	4152936		0
19672	1180	40481087	2015-08-27	2015-08-27 00:00:00	2015-09-10	2015-09-10 00:00:00	32020		\N	77888	0	444814009	40481087		0
19896	1197	4112343	1982-12-25	1982-12-25 00:00:00	1983-01-04	1983-01-04 00:00:00	32020		\N	78866	0	195662009	4112343		0
19999	1206	4027663	1992-02-03	1992-02-03 00:00:00	\N	\N	32020		\N	79261	0	13200003	4027663		0
20186	1214	40481087	1964-03-26	1964-03-26 00:00:00	1964-04-09	1964-04-09 00:00:00	32020		\N	79998	0	444814009	40481087		0
20295	1222	40481087	1954-11-09	1954-11-09 00:00:00	1954-11-16	1954-11-16 00:00:00	32020		\N	80431	0	444814009	40481087		0
20497	1232	4134304	1971-10-09	1971-10-09 00:00:00	1971-11-08	1971-11-08 00:00:00	32020		\N	81184	0	263102004	4134304		0
20678	1242	40481087	1981-02-14	1981-02-14 00:00:00	1981-02-28	1981-02-28 00:00:00	32020		\N	81798	0	444814009	40481087		0
20809	1249	4059173	1984-09-27	1984-09-27 00:00:00	1984-12-26	1984-12-26 00:00:00	32020		\N	82291	0	16114001	4059173		0
20953	1258	40481087	1982-08-26	1982-08-26 00:00:00	1982-09-09	1982-09-09 00:00:00	32020		\N	82904	0	444814009	40481087		0
21199	1272	4112343	2010-01-13	2010-01-13 00:00:00	2010-01-26	2010-01-26 00:00:00	32020		\N	83953	0	195662009	4112343		0
10639	625	40481087	1988-02-21	1988-02-21 00:00:00	1988-03-13	1988-03-13 00:00:00	32020		\N	41775	0	444814009	40481087		0
10846	642	313217	2007-09-09	2007-09-09 00:00:00	\N	\N	32020		\N	42481	0	49436004	313217		0
11046	652	4152936	2003-01-27	2003-01-27 00:00:00	2003-02-17	2003-02-17 00:00:00	32020		\N	43128	0	283385000	4152936		0
11222	662	80180	2001-05-29	2001-05-29 00:00:00	\N	\N	32020		\N	43759	0	396275006	80180		0
11338	670	260139	1977-09-15	1977-09-15 00:00:00	1977-09-22	1977-09-22 00:00:00	32020		\N	44220	0	10509002	260139		0
11601	685	378001	1971-10-09	1971-10-09 00:00:00	1971-12-08	1971-12-08 00:00:00	32020		\N	45302	0	62106007	378001		0
11671	689	40481087	2007-04-22	2007-04-22 00:00:00	2007-05-13	2007-05-13 00:00:00	32020		\N	45693	0	444814009	40481087		0
11858	701	4112343	1968-02-07	1968-02-07 00:00:00	1968-02-18	1968-02-18 00:00:00	32020		\N	46320	0	195662009	4112343		0
12016	710	4156265	1992-04-05	1992-04-05 00:00:00	1992-04-26	1992-04-26 00:00:00	32020		\N	46997	0	370247008	4156265		0
12216	723	4142905	1966-12-23	1966-12-23 00:00:00	1967-03-23	1967-03-23 00:00:00	32020		\N	47804	0	33737001	4142905		0
12315	728	372328	1959-12-27	1959-12-27 00:00:00	1961-01-07	1961-01-07 00:00:00	32020		\N	48359	0	65363002	372328		0
12504	739	378419	1987-12-16	1987-12-16 00:00:00	\N	\N	32020		\N	48966	0	26929004	378419		0
12707	752	40481087	1953-06-10	1953-06-10 00:00:00	1953-06-24	1953-06-24 00:00:00	32020		\N	49702	0	444814009	40481087		0
12878	758	4112343	1985-12-03	1985-12-03 00:00:00	1985-12-11	1985-12-11 00:00:00	32020		\N	50326	0	195662009	4112343		0
12987	763	81151	1987-06-21	1987-06-21 00:00:00	1987-07-05	1987-07-05 00:00:00	32020		\N	50733	0	44465007	81151		0
13181	775	4112343	2013-10-15	2013-10-15 00:00:00	2013-10-27	2013-10-27 00:00:00	32020		\N	51440	0	195662009	4112343		0
13307	782	257012	1943-10-01	1943-10-01 00:00:00	\N	\N	32020		\N	52022	0	40055000	257012		0
13557	800	4134304	1980-03-14	1980-03-14 00:00:00	1980-05-13	1980-05-13 00:00:00	32020		\N	53091	0	263102004	4134304		0
13669	807	4112343	1957-10-14	1957-10-14 00:00:00	1957-10-27	1957-10-27 00:00:00	32020		\N	53572	0	195662009	4112343		0
13810	817	192671	1999-09-20	1999-09-20 00:00:00	\N	\N	32020		\N	54143	0	K92.2	35208414		0
13974	825	260139	1997-09-22	1997-09-22 00:00:00	1997-09-29	1997-09-29 00:00:00	32020		\N	54629	0	10509002	260139		0
14235	842	40481087	1942-03-15	1942-03-15 00:00:00	1942-03-22	1942-03-22 00:00:00	32020		\N	55602	0	444814009	40481087		0
14316	844	4084167	1980-05-09	1980-05-09 00:00:00	1980-05-09	1980-05-09 00:00:00	32020		\N	56002	0	241929008	4084167		0
14507	857	260139	1967-04-14	1967-04-14 00:00:00	1967-04-21	1967-04-21 00:00:00	32020		\N	56635	0	10509002	260139		0
14664	865	80180	1980-06-02	1980-06-02 00:00:00	\N	\N	32020		\N	57362	0	396275006	80180		0
14821	871	40481087	2011-03-22	2011-03-22 00:00:00	2011-04-12	2011-04-12 00:00:00	32020		\N	57918	0	444814009	40481087		0
15027	885	440448	2012-04-05	2012-04-05 00:00:00	\N	\N	32020		\N	59030	0	74400008	440448		0
15187	895	28060	2007-08-11	2007-08-11 00:00:00	2007-08-22	2007-08-22 00:00:00	32020		\N	59674	0	43878008	28060		0
15367	911	4112343	1984-04-10	1984-04-10 00:00:00	1984-04-18	1984-04-18 00:00:00	32020		\N	60527	0	195662009	4112343		0
15492	918	40481087	2003-05-15	2003-05-15 00:00:00	2003-05-22	2003-05-22 00:00:00	32020		\N	61138	0	444814009	40481087		0
15686	929	4112343	1956-07-24	1956-07-24 00:00:00	1956-08-03	1956-08-03 00:00:00	32020		\N	61806	0	195662009	4112343		0
15807	935	80180	1972-06-24	1972-06-24 00:00:00	\N	\N	32020		\N	62234	0	396275006	80180		0
16023	948	40481087	1959-01-26	1959-01-26 00:00:00	1959-02-16	1959-02-16 00:00:00	32020		\N	62941	0	444814009	40481087		0
16191	958	4048695	1982-11-26	1982-11-26 00:00:00	1983-01-26	1983-01-26 00:00:00	32020		\N	63597	0	15724005	4048695		0
16308	964	260139	1985-12-04	1985-12-04 00:00:00	1985-12-18	1985-12-18 00:00:00	32020		\N	64166	0	10509002	260139		0
16466	972	28060	1987-08-11	1987-08-11 00:00:00	1987-08-21	1987-08-21 00:00:00	32020		\N	64721	0	43878008	28060		0
16673	987	4112343	1956-04-20	1956-04-20 00:00:00	1956-05-03	1956-05-03 00:00:00	32020		\N	65599	0	195662009	4112343		0
16840	1000	4296204	1973-12-16	1973-12-16 00:00:00	1973-12-30	1973-12-30 00:00:00	32020		\N	66138	0	403190006	4296204		0
17004	1016	4112343	2011-11-16	2011-11-16 00:00:00	2011-11-29	2011-11-29 00:00:00	32020		\N	66920	0	195662009	4112343		0
17243	1032	4112343	1982-12-16	1982-12-16 00:00:00	1982-12-23	1982-12-23 00:00:00	32020		\N	67886	0	195662009	4112343		0
17412	1046	4112343	2002-12-31	2002-12-31 00:00:00	2003-01-08	2003-01-08 00:00:00	32020		\N	68661	0	195662009	4112343		0
17494	1051	4113008	1991-08-06	1991-08-06 00:00:00	1991-08-20	1991-08-20 00:00:00	32020		\N	68937	0	284549007	4113008		0
17625	1058	28060	1959-08-07	1959-08-07 00:00:00	1959-08-17	1959-08-17 00:00:00	32020		\N	69480	0	43878008	28060		0
17885	1076	372328	1976-01-26	1976-01-26 00:00:00	1976-04-16	1976-04-16 00:00:00	32020		\N	70568	0	65363002	372328		0
17985	1082	260139	2005-12-20	2005-12-20 00:00:00	2005-12-27	2005-12-27 00:00:00	32020		\N	70966	0	10509002	260139		0
18165	1091	4116491	1999-05-28	1999-05-28 00:00:00	1999-07-03	1999-07-03 00:00:00	32020		\N	71627	0	301011002	4116491		0
18280	1099	260139	2007-05-23	2007-05-23 00:00:00	2007-06-06	2007-06-06 00:00:00	32020		\N	72189	0	10509002	260139		0
18490	1113	40481087	1977-02-23	1977-02-23 00:00:00	1977-03-16	1977-03-16 00:00:00	32020		\N	73287	0	444814009	40481087		0
18654	1122	372328	1985-11-23	1985-11-23 00:00:00	1986-09-29	1986-09-29 00:00:00	32020		\N	73899	0	65363002	372328		0
18833	1133	4283893	1987-07-20	1987-07-20 00:00:00	1987-08-24	1987-08-24 00:00:00	32020		\N	74588	0	36971009	4283893		0
18957	1138	40481087	1987-09-25	1987-09-25 00:00:00	1987-10-09	1987-10-09 00:00:00	32020		\N	75069	0	444814009	40481087		0
19135	1146	4218389	1969-12-09	1969-12-09 00:00:00	1969-12-30	1969-12-30 00:00:00	32020		\N	75739	0	39848009	4218389		0
19336	1158	40481087	2007-08-17	2007-08-17 00:00:00	2007-08-31	2007-08-31 00:00:00	32020		\N	76506	0	444814009	40481087		0
19582	1175	40481087	2004-03-26	2004-03-26 00:00:00	2004-04-16	2004-04-16 00:00:00	32020		\N	77513	0	444814009	40481087		0
19673	1180	4112343	2006-10-21	2006-10-21 00:00:00	2006-10-29	2006-10-29 00:00:00	32020		\N	77887	0	195662009	4112343		0
19897	1197	80180	2015-05-16	2015-05-16 00:00:00	\N	\N	32020		\N	78863	0	396275006	80180		0
20000	1206	4113008	1991-03-04	1991-03-04 00:00:00	1991-03-18	1991-03-18 00:00:00	32020		\N	79261	0	284549007	4113008		0
20187	1214	4218389	1968-09-15	1968-09-15 00:00:00	1968-10-06	1968-10-06 00:00:00	32020		\N	80005	0	39848009	4218389		0
20296	1222	40481087	1983-05-03	1983-05-03 00:00:00	1983-05-24	1983-05-24 00:00:00	32020		\N	80414	0	444814009	40481087		0
20498	1232	28060	2001-09-28	2001-09-28 00:00:00	2001-10-10	2001-10-10 00:00:00	32020		\N	81222	0	43878008	28060		0
20679	1242	260139	1979-02-14	1979-02-14 00:00:00	1979-02-21	1979-02-21 00:00:00	32020		\N	81793	0	10509002	260139		0
20810	1249	28060	2004-04-29	2004-04-29 00:00:00	2004-05-06	2004-05-06 00:00:00	32020		\N	82298	0	43878008	28060		0
20954	1258	78272	1986-05-23	1986-05-23 00:00:00	1986-06-20	1986-06-20 00:00:00	32020		\N	82849	0	70704007	78272		0
21200	1272	372328	1982-06-30	1982-06-30 00:00:00	1982-08-20	1982-08-20 00:00:00	32020		\N	83912	0	65363002	372328		0
10640	625	80180	2014-02-13	2014-02-13 00:00:00	\N	\N	32020		\N	41787	0	396275006	80180		0
10847	642	372328	1938-04-30	1938-04-30 00:00:00	1938-06-05	1938-06-05 00:00:00	32020		\N	42496	0	65363002	372328		0
11047	652	260139	2004-12-02	2004-12-02 00:00:00	2004-12-16	2004-12-16 00:00:00	32020		\N	43182	0	10509002	260139		0
11339	670	4112343	2018-09-13	2018-09-13 00:00:00	2018-09-23	2018-09-23 00:00:00	32020		\N	44227	0	195662009	4112343		0
11602	686	40481087	1968-01-19	1968-01-19 00:00:00	1968-01-26	1968-01-26 00:00:00	32020		\N	45383	0	444814009	40481087		0
11672	689	40481087	2000-11-13	2000-11-13 00:00:00	2000-11-27	2000-11-27 00:00:00	32020		\N	45646	0	444814009	40481087		0
11859	701	40481087	1999-11-11	1999-11-11 00:00:00	1999-11-18	1999-11-18 00:00:00	32020		\N	46305	0	444814009	40481087		0
12017	710	40481087	2005-04-27	2005-04-27 00:00:00	2005-05-04	2005-05-04 00:00:00	32020		\N	47044	0	444814009	40481087		0
12217	723	40481087	2001-06-06	2001-06-06 00:00:00	2001-06-27	2001-06-27 00:00:00	32020		\N	47844	0	444814009	40481087		0
12316	728	4152936	1960-11-21	1960-11-21 00:00:00	1960-12-05	1960-12-05 00:00:00	32020		\N	48311	0	283385000	4152936		0
12505	739	4112343	1981-11-14	1981-11-14 00:00:00	1981-11-24	1981-11-24 00:00:00	32020		\N	48951	0	195662009	4112343		0
12708	752	260139	1971-07-25	1971-07-25 00:00:00	1971-08-01	1971-08-01 00:00:00	32020		\N	49717	0	10509002	260139		0
12879	758	40481087	1973-05-01	1973-05-01 00:00:00	1973-05-15	1973-05-15 00:00:00	32020		\N	50324	0	444814009	40481087		0
12988	763	372328	1970-06-05	1970-06-05 00:00:00	1971-03-04	1971-03-04 00:00:00	32020		\N	50737	0	65363002	372328		0
13182	776	4283893	1997-10-26	1997-10-26 00:00:00	1997-11-09	1997-11-09 00:00:00	32020		\N	51561	0	36971009	4283893		0
13308	782	40481087	1961-01-25	1961-01-25 00:00:00	1961-02-15	1961-02-15 00:00:00	32020		\N	51965	0	444814009	40481087		0
13558	800	40481087	1970-12-08	1970-12-08 00:00:00	1970-12-22	1970-12-22 00:00:00	32020		\N	53107	0	444814009	40481087		0
13670	807	81151	1964-09-04	1964-09-04 00:00:00	1964-10-02	1964-10-02 00:00:00	32020		\N	53633	0	44465007	81151		0
13811	817	4112343	1967-05-25	1967-05-25 00:00:00	1967-06-05	1967-06-05 00:00:00	32020		\N	54144	0	195662009	4112343		0
13975	825	372328	1972-08-13	1972-08-13 00:00:00	1972-10-21	1972-10-21 00:00:00	32020		\N	54646	0	65363002	372328		0
14236	842	4285898	1942-12-09	1942-12-09 00:00:00	\N	\N	32020		\N	55602	0	68496003	4285898		0
14317	844	4294548	2018-03-21	2018-03-21 00:00:00	2018-04-04	2018-04-04 00:00:00	32020		\N	55968	0	75498004	4294548		0
14508	857	372328	1954-02-20	1954-02-20 00:00:00	1954-08-08	1954-08-08 00:00:00	32020		\N	56610	0	65363002	372328		0
14665	865	4310024	1978-11-10	1978-11-10 00:00:00	\N	\N	32020		\N	57362	0	424802006	4310024		0
14822	871	260139	2001-09-03	2001-09-03 00:00:00	2001-09-10	2001-09-10 00:00:00	32020		\N	57933	0	10509002	260139		0
15028	885	81151	1983-03-02	1983-03-02 00:00:00	1983-03-23	1983-03-23 00:00:00	32020		\N	58980	0	44465007	81151		0
15188	895	81151	1971-11-18	1971-11-18 00:00:00	1971-12-02	1971-12-02 00:00:00	32020		\N	59678	0	44465007	81151		0
15368	911	40481087	2016-08-24	2016-08-24 00:00:00	2016-09-14	2016-09-14 00:00:00	32020		\N	60511	0	444814009	40481087		0
15493	918	4155034	1995-03-04	1995-03-04 00:00:00	1995-03-25	1995-03-25 00:00:00	32020		\N	61203	0	283371005	4155034		0
15687	929	80180	1961-08-13	1961-08-13 00:00:00	\N	\N	32020		\N	61866	0	396275006	80180		0
15808	935	4266809	1972-06-24	1972-06-24 00:00:00	\N	\N	32020		\N	62234	0	397881000	4266809		0
16024	948	40481087	2010-06-27	2010-06-27 00:00:00	2010-07-11	2010-07-11 00:00:00	32020		\N	62955	0	444814009	40481087		0
16192	958	80180	1993-08-15	1993-08-15 00:00:00	\N	\N	32020		\N	63619	0	396275006	80180		0
16309	964	40481087	2009-12-30	2009-12-30 00:00:00	2010-01-06	2010-01-06 00:00:00	32020		\N	64193	0	444814009	40481087		0
16467	972	375671	2017-02-04	2017-02-04 00:00:00	2017-03-06	2017-03-06 00:00:00	32020		\N	64720	0	62564004	375671		0
16674	987	4112343	2011-07-28	2011-07-28 00:00:00	2011-08-04	2011-08-04 00:00:00	32020		\N	65586	0	195662009	4112343		0
16841	1000	260139	1970-09-04	1970-09-04 00:00:00	1970-09-18	1970-09-18 00:00:00	32020		\N	66197	0	10509002	260139		0
17005	1016	40481087	1975-12-03	1975-12-03 00:00:00	1975-12-10	1975-12-10 00:00:00	32020		\N	66887	0	444814009	40481087		0
17244	1032	4156265	1986-09-01	1986-09-01 00:00:00	1986-09-15	1986-09-15 00:00:00	32020		\N	67951	0	370247008	4156265		0
17413	1046	4112343	1972-11-03	1972-11-03 00:00:00	1972-11-11	1972-11-11 00:00:00	32020		\N	68701	0	195662009	4112343		0
17502	1053	372328	1978-08-31	1978-08-31 00:00:00	1979-02-23	1979-02-23 00:00:00	32020		\N	69028	0	65363002	372328		0
17626	1058	80180	1992-12-03	1992-12-03 00:00:00	\N	\N	32020		\N	69417	0	396275006	80180		0
17886	1076	28060	1981-05-31	1981-05-31 00:00:00	1981-06-11	1981-06-11 00:00:00	32020		\N	70546	0	43878008	28060		0
17986	1082	4112343	1985-04-13	1985-04-13 00:00:00	1985-04-22	1985-04-22 00:00:00	32020		\N	70930	0	195662009	4112343		0
18166	1091	40481087	1997-03-18	1997-03-18 00:00:00	1997-04-08	1997-04-08 00:00:00	32020		\N	71743	0	444814009	40481087		0
18281	1099	4156265	1969-06-12	1969-06-12 00:00:00	1969-07-03	1969-07-03 00:00:00	32020		\N	72157	0	370247008	4156265		0
18491	1113	40481087	2006-10-29	2006-10-29 00:00:00	2006-11-19	2006-11-19 00:00:00	32020		\N	73276	0	444814009	40481087		0
18655	1122	4059173	1972-08-03	1972-08-03 00:00:00	1972-11-01	1972-11-01 00:00:00	32020		\N	73928	0	16114001	4059173		0
18834	1133	40481087	1976-05-19	1976-05-19 00:00:00	1976-06-09	1976-06-09 00:00:00	32020		\N	74597	0	444814009	40481087		0
18958	1138	4112343	2004-05-07	2004-05-07 00:00:00	2004-05-15	2004-05-15 00:00:00	32020		\N	75118	0	195662009	4112343		0
19136	1146	40481087	2009-11-20	2009-11-20 00:00:00	2009-12-11	2009-12-11 00:00:00	32020		\N	75720	0	444814009	40481087		0
19337	1158	195588	1999-07-31	1999-07-31 00:00:00	1999-09-18	1999-09-18 00:00:00	32020		\N	76527	0	38822007	195588		0
19583	1175	372328	1941-04-24	1941-04-24 00:00:00	1941-07-06	1941-07-06 00:00:00	32020		\N	77531	0	65363002	372328		0
19674	1180	4112343	2005-08-19	2005-08-19 00:00:00	2005-08-26	2005-08-26 00:00:00	32020		\N	77905	0	195662009	4112343		0
19898	1197	260139	1980-08-23	1980-08-23 00:00:00	1980-09-06	1980-09-06 00:00:00	32020		\N	78865	0	10509002	260139		0
20001	1206	30753	1999-02-21	1999-02-21 00:00:00	\N	\N	32020		\N	79262	0	16761005	30753		0
20188	1214	4230399	1955-12-23	1955-12-23 00:00:00	1956-01-22	1956-01-22 00:00:00	32020		\N	80004	0	359817006	4230399		0
20297	1222	80180	1995-10-30	1995-10-30 00:00:00	\N	\N	32020		\N	80383	0	396275006	80180		0
20499	1232	260139	1996-07-30	1996-07-30 00:00:00	1996-08-13	1996-08-13 00:00:00	32020		\N	81221	0	10509002	260139		0
20680	1242	40481087	1961-11-30	1961-11-30 00:00:00	1961-12-14	1961-12-14 00:00:00	32020		\N	81791	0	444814009	40481087		0
20811	1249	260139	1973-05-29	1973-05-29 00:00:00	1973-06-05	1973-06-05 00:00:00	32020		\N	82253	0	10509002	260139		0
20955	1258	81151	1983-05-18	1983-05-18 00:00:00	1983-06-08	1983-06-08 00:00:00	32020		\N	82848	0	44465007	81151		0
21201	1272	260139	2008-10-04	2008-10-04 00:00:00	2008-10-18	2008-10-18 00:00:00	32020		\N	83951	0	10509002	260139		0
10641	625	4266809	2014-02-13	2014-02-13 00:00:00	\N	\N	32020		\N	41787	0	397881000	4266809		0
10848	642	40481087	1967-01-09	1967-01-09 00:00:00	1967-01-16	1967-01-16 00:00:00	32020		\N	42536	0	444814009	40481087		0
11048	652	81151	1991-05-18	1991-05-18 00:00:00	1991-06-08	1991-06-08 00:00:00	32020		\N	43185	0	44465007	81151		0
11224	662	4152936	2018-02-05	2018-02-05 00:00:00	2018-02-26	2018-02-26 00:00:00	32020		\N	43755	0	283385000	4152936		0
11340	670	4112343	2018-05-01	2018-05-01 00:00:00	2018-05-13	2018-05-13 00:00:00	32020		\N	44226	0	195662009	4112343		0
11603	686	372328	1948-01-30	1948-01-30 00:00:00	1948-03-19	1948-03-19 00:00:00	32020		\N	45420	0	65363002	372328		0
11673	689	40481087	1987-12-21	1987-12-21 00:00:00	1987-12-28	1987-12-28 00:00:00	32020		\N	45636	0	444814009	40481087		0
11860	701	40481087	1980-02-08	1980-02-08 00:00:00	1980-02-15	1980-02-15 00:00:00	32020		\N	46346	0	444814009	40481087		0
12018	710	40481087	2007-03-04	2007-03-04 00:00:00	2007-03-25	2007-03-25 00:00:00	32020		\N	47039	0	444814009	40481087		0
12218	723	30753	2004-06-22	2004-06-22 00:00:00	\N	\N	32020		\N	47842	0	16761005	30753		0
12317	728	4112343	1997-06-30	1997-06-30 00:00:00	1997-07-13	1997-07-13 00:00:00	32020		\N	48333	0	195662009	4112343		0
12709	752	372328	1949-04-28	1949-04-28 00:00:00	1949-10-16	1949-10-16 00:00:00	32020		\N	49684	0	65363002	372328		0
12880	758	81151	1988-12-01	1988-12-01 00:00:00	1988-12-15	1988-12-15 00:00:00	32020		\N	50355	0	44465007	81151		0
12989	763	28060	1970-01-10	1970-01-10 00:00:00	1970-01-23	1970-01-23 00:00:00	32020		\N	50747	0	43878008	28060		0
13183	776	80180	1998-01-12	1998-01-12 00:00:00	\N	\N	32020		\N	51561	0	396275006	80180		0
13309	782	378419	1994-05-15	1994-05-15 00:00:00	\N	\N	32020		\N	52012	0	26929004	378419		0
13559	800	81151	1984-02-22	1984-02-22 00:00:00	1984-03-28	1984-03-28 00:00:00	32020		\N	53092	0	44465007	81151		0
13671	807	4112343	2015-07-14	2015-07-14 00:00:00	2015-07-21	2015-07-21 00:00:00	32020		\N	53576	0	195662009	4112343		0
13812	817	40481087	2004-04-19	2004-04-19 00:00:00	2004-04-26	2004-04-26 00:00:00	32020		\N	54164	0	444814009	40481087		0
13976	825	40481087	2016-12-04	2016-12-04 00:00:00	2016-12-11	2016-12-11 00:00:00	32020		\N	54694	0	444814009	40481087		0
14237	842	80180	1943-05-08	1943-05-08 00:00:00	\N	\N	32020		\N	55602	0	396275006	80180		0
14318	844	192671	2002-10-10	2002-10-10 00:00:00	\N	\N	32020		\N	55949	0	K92.2	35208414		0
14509	858	4283893	2008-04-23	2008-04-23 00:00:00	2008-07-02	2008-07-02 00:00:00	32020		\N	56690	0	36971009	4283893		0
14666	865	260139	1945-09-01	1945-09-01 00:00:00	1945-09-08	1945-09-08 00:00:00	32020		\N	57392	0	10509002	260139		0
14823	871	195588	2014-01-06	2014-01-06 00:00:00	2014-02-24	2014-02-24 00:00:00	32020		\N	57927	0	38822007	195588		0
15029	885	4112343	1976-10-18	1976-10-18 00:00:00	1976-10-28	1976-10-28 00:00:00	32020		\N	59000	0	195662009	4112343		0
15189	895	40481087	1973-05-05	1973-05-05 00:00:00	1973-05-26	1973-05-26 00:00:00	32020		\N	59718	0	444814009	40481087		0
15369	911	40481087	2001-05-07	2001-05-07 00:00:00	2001-05-21	2001-05-21 00:00:00	32020		\N	60463	0	444814009	40481087		0
15494	918	317576	1991-01-11	1991-01-11 00:00:00	\N	\N	32020		\N	61167	0	53741008	317576		0
15688	929	4051466	1922-08-10	1922-08-10 00:00:00	1939-07-10	1939-07-10 00:00:00	32020		\N	61818	0	233678006	4051466		0
15809	935	192671	1972-07-04	1972-07-04 00:00:00	\N	\N	32020		\N	62204	0	K92.2	35208414		0
16025	948	4152936	2007-12-29	2007-12-29 00:00:00	2008-01-19	2008-01-19 00:00:00	32020		\N	62965	0	283385000	4152936		0
16193	958	40481087	2017-11-23	2017-11-23 00:00:00	2017-12-14	2017-12-14 00:00:00	32020		\N	63648	0	444814009	40481087		0
16310	964	4294548	1987-02-03	1987-02-03 00:00:00	1987-03-24	1987-03-24 00:00:00	32020		\N	64173	0	75498004	4294548		0
16468	972	40481087	2014-09-15	2014-09-15 00:00:00	2014-10-06	2014-10-06 00:00:00	32020		\N	64710	0	444814009	40481087		0
16675	987	4218389	1988-08-06	1988-08-06 00:00:00	1988-09-10	1988-09-10 00:00:00	32020		\N	65522	0	39848009	4218389		0
16842	1000	4116491	2016-01-30	2016-01-30 00:00:00	2016-03-03	2016-03-03 00:00:00	32020		\N	66178	0	301011002	4116491		0
17006	1016	4146173	1985-07-09	1985-07-09 00:00:00	1985-08-08	1985-08-08 00:00:00	32020		\N	66895	0	307731004	4146173		0
17245	1032	4113008	1979-03-21	1979-03-21 00:00:00	1979-04-11	1979-04-11 00:00:00	32020		\N	67950	0	284549007	4113008		0
17414	1046	81151	1988-06-13	1988-06-13 00:00:00	1988-07-18	1988-07-18 00:00:00	32020		\N	68698	0	44465007	81151		0
17503	1053	40481087	2015-12-29	2015-12-29 00:00:00	2016-01-12	2016-01-12 00:00:00	32020		\N	69046	0	444814009	40481087		0
17627	1058	40481087	2007-02-09	2007-02-09 00:00:00	2007-02-23	2007-02-23 00:00:00	32020		\N	69421	0	444814009	40481087		0
17887	1076	40481087	1994-07-19	1994-07-19 00:00:00	1994-08-09	1994-08-09 00:00:00	32020		\N	70548	0	444814009	40481087		0
17987	1082	260139	1961-09-04	1961-09-04 00:00:00	1961-09-11	1961-09-11 00:00:00	32020		\N	70939	0	10509002	260139		0
18167	1091	80180	1997-12-14	1997-12-14 00:00:00	\N	\N	32020		\N	71743	0	396275006	80180		0
18282	1099	81151	1979-09-09	1979-09-09 00:00:00	1979-10-14	1979-10-14 00:00:00	32020		\N	72158	0	44465007	81151		0
18492	1113	4027663	2005-11-07	2005-11-07 00:00:00	\N	\N	32020		\N	73296	0	13200003	4027663		0
18656	1122	40481087	1992-05-27	1992-05-27 00:00:00	1992-06-17	1992-06-17 00:00:00	32020		\N	73887	0	444814009	40481087		0
18835	1133	40481087	1989-11-17	1989-11-17 00:00:00	1989-12-08	1989-12-08 00:00:00	32020		\N	74627	0	444814009	40481087		0
18959	1138	372328	1985-06-24	1985-06-24 00:00:00	1986-01-16	1986-01-16 00:00:00	32020		\N	75007	0	65363002	372328		0
19137	1146	40481087	1999-08-27	1999-08-27 00:00:00	1999-09-17	1999-09-17 00:00:00	32020		\N	75689	0	444814009	40481087		0
19338	1158	81151	1984-03-11	1984-03-11 00:00:00	1984-03-25	1984-03-25 00:00:00	32020		\N	76472	0	44465007	81151		0
19584	1175	372328	1942-07-01	1942-07-01 00:00:00	1943-01-03	1943-01-03 00:00:00	32020		\N	77552	0	65363002	372328		0
19675	1180	40481087	1956-10-16	1956-10-16 00:00:00	1956-10-23	1956-10-23 00:00:00	32020		\N	77923	0	444814009	40481087		0
19899	1197	40481087	1999-08-20	1999-08-20 00:00:00	1999-09-03	1999-09-03 00:00:00	32020		\N	78873	0	444814009	40481087		0
20002	1206	4266809	1999-10-19	1999-10-19 00:00:00	\N	\N	32020		\N	79262	0	397881000	4266809		0
20189	1214	4048171	1942-01-03	1942-01-03 00:00:00	1959-01-01	1959-01-01 00:00:00	32020		\N	79944	0	232353008	4048171		0
20298	1222	4112343	1968-04-13	1968-04-13 00:00:00	1968-04-22	1968-04-22 00:00:00	32020		\N	80413	0	195662009	4112343		0
20500	1232	257012	1977-08-18	1977-08-18 00:00:00	\N	\N	32020		\N	81218	0	40055000	257012		0
20681	1242	372328	1964-02-27	1964-02-27 00:00:00	1965-02-24	1965-02-24 00:00:00	32020		\N	81760	0	65363002	372328		0
20812	1249	439777	1988-01-20	1988-01-20 00:00:00	\N	\N	32020		\N	82277	0	271737000	439777		0
20956	1258	372328	1968-11-02	1968-11-02 00:00:00	1969-02-17	1969-02-17 00:00:00	32020		\N	82867	0	65363002	372328		0
21202	1272	260139	1986-11-08	1986-11-08 00:00:00	1986-11-22	1986-11-22 00:00:00	32020		\N	83865	0	10509002	260139		0
10642	625	28060	1979-06-17	1979-06-17 00:00:00	1979-06-28	1979-06-28 00:00:00	32020		\N	41741	0	43878008	28060		0
10849	642	381316	2017-10-08	2017-10-08 00:00:00	\N	\N	32020		\N	42521	0	230690007	381316		0
11049	652	40481087	1993-09-03	1993-09-03 00:00:00	1993-09-17	1993-09-17 00:00:00	32020		\N	43143	0	444814009	40481087		0
11225	662	372328	1963-05-21	1963-05-21 00:00:00	1963-08-28	1963-08-28 00:00:00	32020		\N	43735	0	65363002	372328		0
11341	670	4113008	1998-08-24	1998-08-24 00:00:00	1998-09-14	1998-09-14 00:00:00	32020		\N	44253	0	284549007	4113008		0
11604	686	378001	2005-02-23	2005-02-23 00:00:00	2005-03-25	2005-03-25 00:00:00	32020		\N	45443	0	62106007	378001		0
11674	689	260139	2010-03-27	2010-03-27 00:00:00	2010-04-10	2010-04-10 00:00:00	32020		\N	45694	0	10509002	260139		0
11861	701	4112343	1997-12-14	1997-12-14 00:00:00	1997-12-27	1997-12-27 00:00:00	32020		\N	46348	0	195662009	4112343		0
12019	710	40481087	1999-12-03	1999-12-03 00:00:00	1999-12-17	1999-12-17 00:00:00	32020		\N	47004	0	444814009	40481087		0
12219	723	4285898	2004-08-21	2004-08-21 00:00:00	\N	\N	32020		\N	47842	0	68496003	4285898		0
12318	728	440448	1960-01-22	1960-01-22 00:00:00	\N	\N	32020		\N	48310	0	74400008	440448		0
12507	741	40481087	1976-04-27	1976-04-27 00:00:00	1976-05-11	1976-05-11 00:00:00	32020		\N	49093	0	444814009	40481087		0
12710	753	4112343	2017-03-31	2017-03-31 00:00:00	2017-04-07	2017-04-07 00:00:00	32020		\N	49775	0	195662009	4112343		0
12881	758	4112343	2007-03-22	2007-03-22 00:00:00	2007-04-02	2007-04-02 00:00:00	32020		\N	50301	0	195662009	4112343		0
12990	763	372328	1966-07-11	1966-07-11 00:00:00	1966-08-25	1966-08-25 00:00:00	32020		\N	50763	0	65363002	372328		0
13184	776	195588	1991-07-23	1991-07-23 00:00:00	1991-09-03	1991-09-03 00:00:00	32020		\N	51587	0	38822007	195588		0
13310	782	260139	1913-03-27	1913-03-27 00:00:00	1913-04-03	1913-04-03 00:00:00	32020		\N	51990	0	10509002	260139		0
13560	800	40481087	2014-01-07	2014-01-07 00:00:00	2014-01-14	2014-01-14 00:00:00	32020		\N	53166	0	444814009	40481087		0
13672	807	4112343	1960-05-17	1960-05-17 00:00:00	1960-05-30	1960-05-30 00:00:00	32020		\N	53566	0	195662009	4112343		0
13813	817	4294548	1998-12-21	1998-12-21 00:00:00	1999-01-11	1999-01-11 00:00:00	32020		\N	54147	0	75498004	4294548		0
13977	825	4109685	1984-07-30	1984-07-30 00:00:00	1984-08-13	1984-08-13 00:00:00	32020		\N	54653	0	284551006	4109685		0
14238	842	4112343	2004-01-28	2004-01-28 00:00:00	2004-02-06	2004-02-06 00:00:00	32020		\N	55647	0	195662009	4112343		0
14319	844	40481087	1978-10-20	1978-10-20 00:00:00	1978-11-10	1978-11-10 00:00:00	32020		\N	55925	0	444814009	40481087		0
14510	858	80180	2009-09-28	2009-09-28 00:00:00	\N	\N	32020		\N	56690	0	396275006	80180		0
14667	865	40481087	2004-11-04	2004-11-04 00:00:00	2004-11-18	2004-11-18 00:00:00	32020		\N	57361	0	444814009	40481087		0
14888	877	40481087	2003-05-27	2003-05-27 00:00:00	2003-06-10	2003-06-10 00:00:00	32020		\N	58383	0	444814009	40481087		0
15030	885	4113008	2002-07-11	2002-07-11 00:00:00	2002-07-25	2002-07-25 00:00:00	32020		\N	58982	0	284549007	4113008		0
15190	895	4112343	2008-03-20	2008-03-20 00:00:00	2008-03-31	2008-03-31 00:00:00	32020		\N	59675	0	195662009	4112343		0
15370	911	4112343	2005-03-08	2005-03-08 00:00:00	2005-03-19	2005-03-19 00:00:00	32020		\N	60465	0	195662009	4112343		0
15495	918	40481087	1966-07-26	1966-07-26 00:00:00	1966-08-02	1966-08-02 00:00:00	32020		\N	61129	0	444814009	40481087		0
15689	929	40481087	1950-08-12	1950-08-12 00:00:00	1950-09-02	1950-09-02 00:00:00	32020		\N	61838	0	444814009	40481087		0
15810	935	4112343	1954-07-15	1954-07-15 00:00:00	1954-07-27	1954-07-27 00:00:00	32020		\N	62218	0	195662009	4112343		0
16026	948	260139	1974-05-09	1974-05-09 00:00:00	1974-05-23	1974-05-23 00:00:00	32020		\N	62916	0	10509002	260139		0
16194	958	40481087	1969-09-05	1969-09-05 00:00:00	1969-09-19	1969-09-19 00:00:00	32020		\N	63592	0	444814009	40481087		0
16311	964	40481087	2015-06-28	2015-06-28 00:00:00	2015-07-05	2015-07-05 00:00:00	32020		\N	64174	0	444814009	40481087		0
16469	973	4112343	1951-01-20	1951-01-20 00:00:00	1951-02-01	1951-02-01 00:00:00	32020		\N	64810	0	195662009	4112343		0
16676	987	4296205	1970-08-01	1970-08-01 00:00:00	1970-09-05	1970-09-05 00:00:00	32020		\N	65520	0	403191005	4296205		0
16843	1000	4237458	1966-10-24	1966-10-24 00:00:00	1967-01-22	1967-01-22 00:00:00	32020		\N	66136	0	58150001	4237458		0
17007	1016	195588	2010-07-14	2010-07-14 00:00:00	2010-09-01	2010-09-01 00:00:00	32020		\N	66898	0	38822007	195588		0
17246	1032	4278672	1969-08-10	1969-08-10 00:00:00	1969-11-08	1969-11-08 00:00:00	32020		\N	67949	0	65966004	4278672		0
17415	1046	372328	1972-08-01	1972-08-01 00:00:00	1972-10-15	1972-10-15 00:00:00	32020		\N	68707	0	65363002	372328		0
17504	1053	260139	2004-09-23	2004-09-23 00:00:00	2004-10-07	2004-10-07 00:00:00	32020		\N	69007	0	10509002	260139		0
17628	1058	260139	1961-12-08	1961-12-08 00:00:00	1961-12-22	1961-12-22 00:00:00	32020		\N	69350	0	10509002	260139		0
17888	1076	192671	2013-09-07	2013-09-07 00:00:00	\N	\N	32020		\N	70519	0	K92.2	35208414		0
17988	1082	260139	1959-09-29	1959-09-29 00:00:00	1959-10-13	1959-10-13 00:00:00	32020		\N	71008	0	10509002	260139		0
18168	1091	4266809	1997-12-14	1997-12-14 00:00:00	\N	\N	32020		\N	71743	0	397881000	4266809		0
18283	1099	260139	2005-09-06	2005-09-06 00:00:00	2005-09-20	2005-09-20 00:00:00	32020		\N	72143	0	10509002	260139		0
18493	1113	4285898	2012-10-26	2012-10-26 00:00:00	\N	\N	32020		\N	73274	0	68496003	4285898		0
18657	1122	78272	1976-11-10	1976-11-10 00:00:00	1976-11-24	1976-11-24 00:00:00	32020		\N	73929	0	70704007	78272		0
18836	1133	260139	2005-10-16	2005-10-16 00:00:00	2005-10-30	2005-10-30 00:00:00	32020		\N	74576	0	10509002	260139		0
18960	1138	372328	1982-08-18	1982-08-18 00:00:00	1983-01-06	1983-01-06 00:00:00	32020		\N	75119	0	65363002	372328		0
19138	1146	28060	1967-04-15	1967-04-15 00:00:00	1967-04-27	1967-04-27 00:00:00	32020		\N	75715	0	43878008	28060		0
19339	1158	260139	1992-10-27	1992-10-27 00:00:00	1992-11-10	1992-11-10 00:00:00	32020		\N	76525	0	10509002	260139		0
19585	1175	4296205	2018-11-11	2018-11-11 00:00:00	2018-12-02	2018-12-02 00:00:00	32020		\N	77481	0	403191005	4296205		0
19676	1180	4237458	2010-09-28	2010-09-28 00:00:00	2010-11-27	2010-11-27 00:00:00	32020		\N	77962	0	58150001	4237458		0
19900	1197	81151	1987-01-18	1987-01-18 00:00:00	1987-02-08	1987-02-08 00:00:00	32020		\N	78848	0	44465007	81151		0
20003	1206	134438	1988-02-11	1988-02-11 00:00:00	1989-03-10	1989-03-10 00:00:00	32020		\N	79231	0	40275004	134438		0
20190	1214	40481087	1992-05-21	1992-05-21 00:00:00	1992-06-11	1992-06-11 00:00:00	32020		\N	79902	0	444814009	40481087		0
20299	1222	260139	1975-06-12	1975-06-12 00:00:00	1975-06-19	1975-06-19 00:00:00	32020		\N	80427	0	10509002	260139		0
20501	1232	260139	1989-06-30	1989-06-30 00:00:00	1989-07-14	1989-07-14 00:00:00	32020		\N	81171	0	10509002	260139		0
20682	1242	260139	2007-05-20	2007-05-20 00:00:00	2007-06-03	2007-06-03 00:00:00	32020		\N	81759	0	10509002	260139		0
20813	1249	4132546	2014-01-23	2014-01-23 00:00:00	\N	\N	32020		\N	82293	0	275272006	4166590		0
20957	1258	260139	2004-07-11	2004-07-11 00:00:00	2004-07-18	2004-07-18 00:00:00	32020		\N	82861	0	10509002	260139		0
21203	1272	28060	2018-12-14	2018-12-14 00:00:00	2018-12-27	2018-12-27 00:00:00	32020		\N	83970	0	43878008	28060		0
10643	625	4112343	2006-06-19	2006-06-19 00:00:00	2006-06-30	2006-06-30 00:00:00	32020		\N	41736	0	195662009	4112343		0
10850	642	4112343	2017-06-26	2017-06-26 00:00:00	2017-07-06	2017-07-06 00:00:00	32020		\N	42493	0	195662009	4112343		0
11050	652	40481087	1986-05-15	1986-05-15 00:00:00	1986-05-22	1986-05-22 00:00:00	32020		\N	43158	0	444814009	40481087		0
11226	662	4283893	2003-01-23	2003-01-23 00:00:00	2003-02-20	2003-02-20 00:00:00	32020		\N	43732	0	36971009	4283893		0
11342	670	28060	1984-08-06	1984-08-06 00:00:00	1984-08-18	1984-08-18 00:00:00	32020		\N	44240	0	43878008	28060		0
11605	686	40481087	1959-03-08	1959-03-08 00:00:00	1959-03-15	1959-03-15 00:00:00	32020		\N	45380	0	444814009	40481087		0
11675	689	372328	1983-08-15	1983-08-15 00:00:00	1984-01-29	1984-01-29 00:00:00	32020		\N	45616	0	65363002	372328		0
11862	701	4283893	2011-11-24	2011-11-24 00:00:00	2012-02-09	2012-02-09 00:00:00	32020		\N	46349	0	36971009	4283893		0
12020	710	40481087	2000-12-20	2000-12-20 00:00:00	2001-01-10	2001-01-10 00:00:00	32020		\N	47038	0	444814009	40481087		0
12220	723	80180	2005-01-18	2005-01-18 00:00:00	\N	\N	32020		\N	47842	0	396275006	80180		0
12320	728	40481087	1990-08-02	1990-08-02 00:00:00	1990-08-23	1990-08-23 00:00:00	32020		\N	48356	0	444814009	40481087		0
12508	741	260139	1992-11-25	1992-11-25 00:00:00	1992-12-02	1992-12-02 00:00:00	32020		\N	49067	0	10509002	260139		0
12711	753	260139	1978-10-14	1978-10-14 00:00:00	1978-10-21	1978-10-21 00:00:00	32020		\N	49806	0	10509002	260139		0
12882	758	40481087	1991-01-11	1991-01-11 00:00:00	1991-01-25	1991-01-25 00:00:00	32020		\N	50327	0	444814009	40481087		0
12991	763	4112343	1973-06-10	1973-06-10 00:00:00	1973-06-17	1973-06-17 00:00:00	32020		\N	50748	0	195662009	4112343		0
13185	776	40481087	2009-02-06	2009-02-06 00:00:00	2009-02-13	2009-02-13 00:00:00	32020		\N	51539	0	444814009	40481087		0
13311	782	40481087	1999-01-07	1999-01-07 00:00:00	1999-01-28	1999-01-28 00:00:00	32020		\N	51985	0	444814009	40481087		0
13561	800	40481087	2003-08-19	2003-08-19 00:00:00	2003-09-09	2003-09-09 00:00:00	32020		\N	53131	0	444814009	40481087		0
13673	807	40481087	1990-09-03	1990-09-03 00:00:00	1990-09-24	1990-09-24 00:00:00	32020		\N	53613	0	444814009	40481087		0
13814	817	4283893	2005-04-19	2005-04-19 00:00:00	2005-09-06	2005-09-06 00:00:00	32020		\N	54132	0	36971009	4283893		0
13978	825	260139	2010-04-13	2010-04-13 00:00:00	2010-04-20	2010-04-20 00:00:00	32020		\N	54643	0	10509002	260139		0
14239	842	440086	1917-11-25	1917-11-25 00:00:00	1918-03-10	1918-03-10 00:00:00	32020		\N	55673	0	192127007	440086		0
14320	844	40481087	2008-05-27	2008-05-27 00:00:00	2008-06-10	2008-06-10 00:00:00	32020		\N	55875	0	444814009	40481087		0
14511	858	28060	1975-02-10	1975-02-10 00:00:00	1975-02-17	1975-02-17 00:00:00	32020		\N	56697	0	43878008	28060		0
14668	865	4112343	1969-04-14	1969-04-14 00:00:00	1969-04-22	1969-04-22 00:00:00	32020		\N	57437	0	195662009	4112343		0
14889	877	4112343	2016-04-20	2016-04-20 00:00:00	2016-05-01	2016-05-01 00:00:00	32020		\N	58468	0	195662009	4112343		0
15031	885	40481087	1978-07-31	1978-07-31 00:00:00	1978-08-07	1978-08-07 00:00:00	32020		\N	58971	0	444814009	40481087		0
15191	895	372328	1988-02-03	1988-02-03 00:00:00	1989-03-10	1989-03-10 00:00:00	32020		\N	59676	0	65363002	372328		0
15371	911	4112343	1995-11-30	1995-11-30 00:00:00	1995-12-10	1995-12-10 00:00:00	32020		\N	60467	0	195662009	4112343		0
15496	918	260139	2002-12-07	2002-12-07 00:00:00	2002-12-14	2002-12-14 00:00:00	32020		\N	61132	0	10509002	260139		0
15690	929	4112343	1943-02-03	1943-02-03 00:00:00	1943-02-12	1943-02-12 00:00:00	32020		\N	61837	0	195662009	4112343		0
15811	935	40481087	1939-12-09	1939-12-09 00:00:00	1939-12-30	1939-12-30 00:00:00	32020		\N	62197	0	444814009	40481087		0
16027	948	372328	1960-05-11	1960-05-11 00:00:00	1960-08-26	1960-08-26 00:00:00	32020		\N	62943	0	65363002	372328		0
16195	958	260139	1990-01-15	1990-01-15 00:00:00	1990-01-22	1990-01-22 00:00:00	32020		\N	63635	0	10509002	260139		0
16328	967	40481087	2005-11-07	2005-11-07 00:00:00	2005-11-28	2005-11-28 00:00:00	32020		\N	64364	0	444814009	40481087		0
16470	973	4112343	1945-04-07	1945-04-07 00:00:00	1945-04-17	1945-04-17 00:00:00	32020		\N	64809	0	195662009	4112343		0
16677	987	28060	1999-09-17	1999-09-17 00:00:00	1999-09-28	1999-09-28 00:00:00	32020		\N	65601	0	43878008	28060		0
16844	1000	4112343	1967-12-22	1967-12-22 00:00:00	1968-01-01	1968-01-01 00:00:00	32020		\N	66132	0	195662009	4112343		0
17008	1016	195588	2007-06-04	2007-06-04 00:00:00	2007-07-15	2007-07-15 00:00:00	32020		\N	66919	0	38822007	195588		0
17247	1032	4283893	1997-09-16	1997-09-16 00:00:00	1997-12-09	1997-12-09 00:00:00	32020		\N	67909	0	36971009	4283893		0
17416	1046	40481087	1989-09-29	1989-09-29 00:00:00	1989-10-20	1989-10-20 00:00:00	32020		\N	68702	0	444814009	40481087		0
17505	1053	195588	2018-03-03	2018-03-03 00:00:00	2018-04-18	2018-04-18 00:00:00	32020		\N	69058	0	38822007	195588		0
17629	1058	133834	1956-01-29	1956-01-29 00:00:00	1973-01-02	1973-01-02 00:00:00	32020		\N	69349	0	24079001	133834		0
17889	1076	40481087	1990-10-11	1990-10-11 00:00:00	1990-11-01	1990-11-01 00:00:00	32020		\N	70521	0	444814009	40481087		0
17989	1082	372328	2011-02-18	2011-02-18 00:00:00	2012-02-04	2012-02-04 00:00:00	32020		\N	71024	0	65363002	372328		0
18169	1091	4112343	2009-06-27	2009-06-27 00:00:00	2009-07-04	2009-07-04 00:00:00	32020		\N	71703	0	195662009	4112343		0
18284	1099	4285898	1990-02-27	1990-02-27 00:00:00	\N	\N	32020		\N	72214	0	68496003	4285898		0
18494	1113	30753	2012-07-28	2012-07-28 00:00:00	\N	\N	32020		\N	73274	0	16761005	30753		0
18658	1122	260139	1972-01-08	1972-01-08 00:00:00	1972-01-22	1972-01-22 00:00:00	32020		\N	73886	0	10509002	260139		0
18837	1133	192671	2000-09-05	2000-09-05 00:00:00	\N	\N	32020		\N	74640	0	K92.2	35208414		0
18961	1138	4134304	2018-03-17	2018-03-17 00:00:00	2018-06-15	2018-06-15 00:00:00	32020		\N	75132	0	263102004	4134304		0
19139	1146	40481087	1967-06-01	1967-06-01 00:00:00	1967-06-08	1967-06-08 00:00:00	32020		\N	75687	0	444814009	40481087		0
19340	1158	81151	1999-07-05	1999-07-05 00:00:00	1999-07-19	1999-07-19 00:00:00	32020		\N	76473	0	44465007	81151		0
19586	1175	260139	2009-04-19	2009-04-19 00:00:00	2009-05-03	2009-05-03 00:00:00	32020		\N	77529	0	10509002	260139		0
19677	1180	4218389	1986-12-28	1986-12-28 00:00:00	1987-02-01	1987-02-01 00:00:00	32020		\N	77961	0	39848009	4218389		0
19901	1197	4112343	2012-06-04	2012-06-04 00:00:00	2012-06-12	2012-06-12 00:00:00	32020		\N	78875	0	195662009	4112343		0
20004	1206	40481087	1965-12-19	1965-12-19 00:00:00	1966-01-02	1966-01-02 00:00:00	32020		\N	79244	0	444814009	40481087		0
20191	1214	40481087	2019-03-08	2019-03-08 00:00:00	2019-03-22	2019-03-22 00:00:00	32020		\N	79909	0	444814009	40481087		0
20300	1222	4283893	1987-10-06	1987-10-06 00:00:00	1987-12-29	1987-12-29 00:00:00	32020		\N	80429	0	36971009	4283893		0
20502	1232	40481087	1986-08-14	1986-08-14 00:00:00	1986-09-04	1986-09-04 00:00:00	32020		\N	81170	0	444814009	40481087		0
20683	1242	260139	1985-05-07	1985-05-07 00:00:00	1985-05-14	1985-05-14 00:00:00	32020		\N	81823	0	10509002	260139		0
20814	1249	4001336	2014-01-23	2014-01-23 00:00:00	2014-03-24	2014-03-24 00:00:00	32020		\N	82293	0	110030002	4001336		0
20958	1258	28060	1997-11-30	1997-11-30 00:00:00	1997-12-10	1997-12-10 00:00:00	32020		\N	82865	0	43878008	28060		0
21204	1272	28060	1990-12-16	1990-12-16 00:00:00	1990-12-23	1990-12-23 00:00:00	32020		\N	83902	0	43878008	28060		0
10644	625	4027663	2006-11-27	2006-11-27 00:00:00	\N	\N	32020		\N	41736	0	13200003	4027663		0
10851	642	40481087	1960-01-27	1960-01-27 00:00:00	1960-02-10	1960-02-10 00:00:00	32020		\N	42487	0	444814009	40481087		0
11051	652	80180	2007-01-14	2007-01-14 00:00:00	\N	\N	32020		\N	43169	0	396275006	80180		0
11227	662	40481087	1991-01-03	1991-01-03 00:00:00	1991-01-24	1991-01-24 00:00:00	32020		\N	43744	0	444814009	40481087		0
11343	670	4059173	1978-05-11	1978-05-11 00:00:00	1978-08-09	1978-08-09 00:00:00	32020		\N	44252	0	16114001	4059173		0
11606	686	40481087	1989-01-29	1989-01-29 00:00:00	1989-02-12	1989-02-12 00:00:00	32020		\N	45397	0	444814009	40481087		0
11676	689	4112343	1989-01-18	1989-01-18 00:00:00	1989-01-25	1989-01-25 00:00:00	32020		\N	45609	0	195662009	4112343		0
11863	701	257012	2012-01-12	2012-01-12 00:00:00	\N	\N	32020		\N	46313	0	40055000	257012		0
12021	710	4237458	1973-02-14	1973-02-14 00:00:00	1973-04-15	1973-04-15 00:00:00	32020		\N	46996	0	58150001	4237458		0
12221	723	4266809	2005-01-18	2005-01-18 00:00:00	\N	\N	32020		\N	47842	0	397881000	4266809		0
12321	728	40481087	2014-09-22	2014-09-22 00:00:00	2014-10-13	2014-10-13 00:00:00	32020		\N	48357	0	444814009	40481087		0
12509	741	40481087	2007-03-11	2007-03-11 00:00:00	2007-03-25	2007-03-25 00:00:00	32020		\N	49055	0	444814009	40481087		0
12712	753	40481087	2005-12-28	2005-12-28 00:00:00	2006-01-18	2006-01-18 00:00:00	32020		\N	49797	0	444814009	40481087		0
12883	758	4237458	1974-03-20	1974-03-20 00:00:00	1974-05-19	1974-05-19 00:00:00	32020		\N	50297	0	58150001	4237458		0
12992	763	80180	2002-11-29	2002-11-29 00:00:00	\N	\N	32020		\N	50803	0	396275006	80180		0
13186	776	257012	1979-04-27	1979-04-27 00:00:00	1979-08-31	1979-08-31 00:00:00	32020		\N	51526	0	40055000	257012		0
13312	782	4112343	1951-12-28	1951-12-28 00:00:00	1952-01-10	1952-01-10 00:00:00	32020		\N	52025	0	195662009	4112343		0
13562	800	260139	1973-06-21	1973-06-21 00:00:00	1973-06-28	1973-06-28 00:00:00	32020		\N	53152	0	10509002	260139		0
13674	807	4112343	1970-06-24	1970-06-24 00:00:00	1970-07-05	1970-07-05 00:00:00	32020		\N	53560	0	195662009	4112343		0
13815	817	375671	1968-10-13	1968-10-13 00:00:00	1968-11-12	1968-11-12 00:00:00	32020		\N	54108	0	62564004	375671		0
13979	825	4112343	2002-03-26	2002-03-26 00:00:00	2002-04-06	2002-04-06 00:00:00	32020		\N	54642	0	195662009	4112343		0
14240	842	257012	1926-04-18	1926-04-18 00:00:00	\N	\N	32020		\N	55634	0	40055000	257012		0
14321	844	4112343	2005-05-04	2005-05-04 00:00:00	2005-05-13	2005-05-13 00:00:00	32020		\N	55966	0	195662009	4112343		0
14512	858	4112343	1997-12-22	1997-12-22 00:00:00	1998-01-02	1998-01-02 00:00:00	32020		\N	56689	0	195662009	4112343		0
14669	865	260139	1957-06-05	1957-06-05 00:00:00	1957-06-12	1957-06-12 00:00:00	32020		\N	57414	0	10509002	260139		0
14890	877	4152936	2005-10-22	2005-10-22 00:00:00	2005-11-05	2005-11-05 00:00:00	32020		\N	58442	0	283385000	4152936		0
15032	885	372328	1993-12-10	1993-12-10 00:00:00	1994-05-29	1994-05-29 00:00:00	32020		\N	59040	0	65363002	372328		0
15192	895	4146173	1984-07-26	1984-07-26 00:00:00	1984-09-24	1984-09-24 00:00:00	32020		\N	59720	0	307731004	4146173		0
15372	911	372328	1976-04-06	1976-04-06 00:00:00	1976-06-13	1976-06-13 00:00:00	32020		\N	60470	0	65363002	372328		0
15497	918	4237458	1928-01-22	1928-01-22 00:00:00	1928-04-21	1928-04-21 00:00:00	32020		\N	61197	0	58150001	4237458		0
15691	929	4113008	1977-05-20	1977-05-20 00:00:00	1977-06-03	1977-06-03 00:00:00	32020		\N	61756	0	284549007	4113008		0
15812	935	40481087	1974-01-22	1974-01-22 00:00:00	1974-02-05	1974-02-05 00:00:00	32020		\N	62199	0	444814009	40481087		0
16028	948	40481087	1989-01-01	1989-01-01 00:00:00	1989-01-22	1989-01-22 00:00:00	32020		\N	62953	0	444814009	40481087		0
16196	958	4283893	1973-05-10	1973-05-10 00:00:00	1973-06-14	1973-06-14 00:00:00	32020		\N	63594	0	36971009	4283893		0
16329	967	40481087	1992-12-05	1992-12-05 00:00:00	1992-12-26	1992-12-26 00:00:00	32020		\N	64355	0	444814009	40481087		0
16471	973	40481087	1982-05-07	1982-05-07 00:00:00	1982-05-21	1982-05-21 00:00:00	32020		\N	64815	0	444814009	40481087		0
16678	987	40481087	1960-11-26	1960-11-26 00:00:00	1960-12-03	1960-12-03 00:00:00	32020		\N	65581	0	444814009	40481087		0
16845	1000	260139	1972-04-20	1972-04-20 00:00:00	1972-05-04	1972-05-04 00:00:00	32020		\N	66133	0	10509002	260139		0
17009	1016	378001	1993-11-24	1993-11-24 00:00:00	1993-12-24	1993-12-24 00:00:00	32020		\N	66894	0	62106007	378001		0
17248	1032	40481087	1971-10-02	1971-10-02 00:00:00	1971-10-16	1971-10-16 00:00:00	32020		\N	67899	0	444814009	40481087		0
17417	1046	80180	2012-10-15	2012-10-15 00:00:00	\N	\N	32020		\N	68694	0	396275006	80180		0
17506	1053	4296204	2017-03-23	2017-03-23 00:00:00	2017-04-13	2017-04-13 00:00:00	32020		\N	69043	0	403190006	4296204		0
17630	1058	40481087	1973-05-06	1973-05-06 00:00:00	1973-05-20	1973-05-20 00:00:00	32020		\N	69481	0	444814009	40481087		0
17890	1076	260139	1974-05-07	1974-05-07 00:00:00	1974-05-14	1974-05-14 00:00:00	32020		\N	70563	0	10509002	260139		0
17990	1082	4112343	1978-10-28	1978-10-28 00:00:00	1978-11-04	1978-11-04 00:00:00	32020		\N	70942	0	195662009	4112343		0
18170	1092	81151	1993-07-11	1993-07-11 00:00:00	1993-08-01	1993-08-01 00:00:00	32020		\N	71799	0	44465007	81151		0
18285	1099	260139	1963-07-23	1963-07-23 00:00:00	1963-07-30	1963-07-30 00:00:00	32020		\N	72106	0	10509002	260139		0
18495	1113	80180	2013-07-23	2013-07-23 00:00:00	\N	\N	32020		\N	73286	0	396275006	80180		0
18659	1122	80180	2004-01-28	2004-01-28 00:00:00	\N	\N	32020		\N	73935	0	396275006	80180		0
18838	1133	40481087	1996-05-03	1996-05-03 00:00:00	1996-05-10	1996-05-10 00:00:00	32020		\N	74608	0	444814009	40481087		0
18962	1138	40481087	2011-10-29	2011-10-29 00:00:00	2011-11-05	2011-11-05 00:00:00	32020		\N	75134	0	444814009	40481087		0
19140	1146	378001	1977-10-17	1977-10-17 00:00:00	1977-12-16	1977-12-16 00:00:00	32020		\N	75752	0	62106007	378001		0
19341	1158	4112343	2010-06-16	2010-06-16 00:00:00	2010-06-28	2010-06-28 00:00:00	32020		\N	76491	0	195662009	4112343		0
19587	1175	40481087	2017-02-15	2017-02-15 00:00:00	2017-03-08	2017-03-08 00:00:00	32020		\N	77530	0	444814009	40481087		0
19678	1180	4112343	2000-03-07	2000-03-07 00:00:00	2000-03-16	2000-03-16 00:00:00	32020		\N	77897	0	195662009	4112343		0
19902	1197	4283893	2004-12-13	2004-12-13 00:00:00	2005-03-21	2005-03-21 00:00:00	32020		\N	78844	0	36971009	4283893		0
20005	1206	4156265	1990-01-24	1990-01-24 00:00:00	1990-02-07	1990-02-07 00:00:00	32020		\N	79260	0	370247008	4156265		0
20192	1215	4134304	1998-09-19	1998-09-19 00:00:00	1998-11-18	1998-11-18 00:00:00	32020		\N	80039	0	263102004	4134304		0
20301	1222	40481087	1954-02-28	1954-02-28 00:00:00	1954-03-07	1954-03-07 00:00:00	32020		\N	80430	0	444814009	40481087		0
20503	1232	4112343	2002-05-10	2002-05-10 00:00:00	2002-05-22	2002-05-22 00:00:00	32020		\N	81203	0	195662009	4112343		0
20684	1242	40481087	1996-02-28	1996-02-28 00:00:00	1996-03-06	1996-03-06 00:00:00	32020		\N	81757	0	444814009	40481087		0
20815	1249	4112343	1983-09-04	1983-09-04 00:00:00	1983-09-14	1983-09-14 00:00:00	32020		\N	82255	0	195662009	4112343		0
20959	1258	4278672	1982-03-24	1982-03-24 00:00:00	1982-04-23	1982-04-23 00:00:00	32020		\N	82847	0	65966004	4278672		0
21205	1272	40481087	2014-12-29	2014-12-29 00:00:00	2015-01-19	2015-01-19 00:00:00	32020		\N	83969	0	444814009	40481087		0
10645	625	4112343	1999-06-11	1999-06-11 00:00:00	1999-06-24	1999-06-24 00:00:00	32020		\N	41765	0	195662009	4112343		0
10852	642	4296205	1989-12-23	1989-12-23 00:00:00	1990-01-20	1990-01-20 00:00:00	32020		\N	42464	0	403191005	4296205		0
11052	652	4296204	1986-08-07	1986-08-07 00:00:00	1986-09-11	1986-09-11 00:00:00	32020		\N	43184	0	403190006	4296204		0
11228	662	40481087	1969-09-11	1969-09-11 00:00:00	1969-09-18	1969-09-18 00:00:00	32020		\N	43730	0	444814009	40481087		0
11344	670	40481087	1984-12-03	1984-12-03 00:00:00	1984-12-17	1984-12-17 00:00:00	32020		\N	44236	0	444814009	40481087		0
11607	686	28060	1967-06-12	1967-06-12 00:00:00	1967-06-19	1967-06-19 00:00:00	32020		\N	45382	0	43878008	28060		0
11677	689	257012	2005-08-28	2005-08-28 00:00:00	\N	\N	32020		\N	45612	0	40055000	257012		0
11864	701	260139	1970-12-22	1970-12-22 00:00:00	1970-12-29	1970-12-29 00:00:00	32020		\N	46345	0	10509002	260139		0
12022	710	260139	1964-10-30	1964-10-30 00:00:00	1964-11-06	1964-11-06 00:00:00	32020		\N	47042	0	10509002	260139		0
12222	723	4112343	2011-10-29	2011-10-29 00:00:00	2011-11-05	2011-11-05 00:00:00	32020		\N	47807	0	195662009	4112343		0
12322	728	378001	2000-04-14	2000-04-14 00:00:00	2000-06-13	2000-06-13 00:00:00	32020		\N	48314	0	62106007	378001		0
12510	741	378001	2004-09-02	2004-09-02 00:00:00	2004-11-01	2004-11-01 00:00:00	32020		\N	49045	0	62106007	378001		0
12713	753	40481087	1999-03-20	1999-03-20 00:00:00	1999-03-27	1999-03-27 00:00:00	32020		\N	49744	0	444814009	40481087		0
12884	758	28060	1985-05-23	1985-05-23 00:00:00	1985-06-04	1985-06-04 00:00:00	32020		\N	50300	0	43878008	28060		0
12993	763	40481087	1983-12-15	1983-12-15 00:00:00	1983-12-29	1983-12-29 00:00:00	32020		\N	50742	0	444814009	40481087		0
13187	776	260139	1979-08-22	1979-08-22 00:00:00	1979-08-29	1979-08-29 00:00:00	32020		\N	51560	0	10509002	260139		0
13328	784	80180	2000-09-13	2000-09-13 00:00:00	\N	\N	32020		\N	52193	0	396275006	80180		0
13563	800	80180	1994-07-09	1994-07-09 00:00:00	\N	\N	32020		\N	53141	0	396275006	80180		0
13675	807	4112343	1967-03-26	1967-03-26 00:00:00	1967-04-08	1967-04-08 00:00:00	32020		\N	53559	0	195662009	4112343		0
13816	817	4112343	1982-07-05	1982-07-05 00:00:00	1982-07-12	1982-07-12 00:00:00	32020		\N	54163	0	195662009	4112343		0
13980	825	260139	1972-04-15	1972-04-15 00:00:00	1972-04-29	1972-04-29 00:00:00	32020		\N	54625	0	10509002	260139		0
14241	842	40481087	2008-03-20	2008-03-20 00:00:00	2008-04-03	2008-04-03 00:00:00	32020		\N	55716	0	444814009	40481087		0
14322	844	4059173	1979-01-15	1979-01-15 00:00:00	1979-03-16	1979-03-16 00:00:00	32020		\N	56001	0	16114001	4059173		0
14513	858	4142905	1979-11-15	1979-11-15 00:00:00	1980-01-14	1980-01-14 00:00:00	32020		\N	56712	0	33737001	4142905		0
14670	865	81151	1993-04-11	1993-04-11 00:00:00	1993-04-25	1993-04-25 00:00:00	32020		\N	57368	0	44465007	81151		0
14891	877	260139	2009-07-15	2009-07-15 00:00:00	2009-07-29	2009-07-29 00:00:00	32020		\N	58367	0	10509002	260139		0
15033	885	4112343	1976-01-09	1976-01-09 00:00:00	1976-01-19	1976-01-19 00:00:00	32020		\N	58999	0	195662009	4112343		0
15193	895	40481087	1980-01-25	1980-01-25 00:00:00	1980-02-15	1980-02-15 00:00:00	32020		\N	59683	0	444814009	40481087		0
15373	911	260139	2003-12-23	2003-12-23 00:00:00	2003-12-30	2003-12-30 00:00:00	32020		\N	60491	0	10509002	260139		0
15498	918	4109685	1966-02-22	1966-02-22 00:00:00	1966-03-08	1966-03-08 00:00:00	32020		\N	61199	0	284551006	4109685		0
15692	929	28060	1925-02-07	1925-02-07 00:00:00	1925-02-20	1925-02-20 00:00:00	32020		\N	61804	0	43878008	28060		0
15813	935	257012	1992-09-11	1992-09-11 00:00:00	\N	\N	32020		\N	62219	0	40055000	257012		0
16029	948	260139	1965-12-13	1965-12-13 00:00:00	1965-12-20	1965-12-20 00:00:00	32020		\N	62968	0	10509002	260139		0
16197	958	4296205	1979-12-07	1979-12-07 00:00:00	1980-01-11	1980-01-11 00:00:00	32020		\N	63596	0	403191005	4296205		0
16330	967	140673	1993-09-30	1993-09-30 00:00:00	\N	\N	32020		\N	64356	0	40930008	140673		0
16472	973	40481087	1926-02-21	1926-02-21 00:00:00	1926-03-14	1926-03-14 00:00:00	32020		\N	64734	0	444814009	40481087		0
16679	987	40481087	1972-08-09	1972-08-09 00:00:00	1972-08-16	1972-08-16 00:00:00	32020		\N	65583	0	444814009	40481087		0
16846	1000	4029498	2017-01-29	2017-01-29 00:00:00	\N	\N	32020		\N	66142	0	128613002	4029498		0
17010	1016	4112343	2002-10-22	2002-10-22 00:00:00	2002-10-30	2002-10-30 00:00:00	32020		\N	66918	0	195662009	4112343		0
17249	1032	378001	2004-11-03	2004-11-03 00:00:00	2005-01-02	2005-01-02 00:00:00	32020		\N	67955	0	62106007	378001		0
17418	1046	257012	1995-12-05	1995-12-05 00:00:00	\N	\N	32020		\N	68650	0	40055000	257012		0
17507	1053	40481087	2008-11-20	2008-11-20 00:00:00	2008-11-27	2008-11-27 00:00:00	32020		\N	69057	0	444814009	40481087		0
17631	1058	40481087	2010-03-01	2010-03-01 00:00:00	2010-03-22	2010-03-22 00:00:00	32020		\N	69344	0	444814009	40481087		0
17891	1076	260139	1976-04-10	1976-04-10 00:00:00	1976-04-17	1976-04-17 00:00:00	32020		\N	70565	0	10509002	260139		0
17991	1082	134438	1988-08-18	1988-08-18 00:00:00	1989-06-18	1989-06-18 00:00:00	32020		\N	70904	0	40275004	134438		0
18171	1092	4112343	1969-02-09	1969-02-09 00:00:00	1969-02-16	1969-02-16 00:00:00	32020		\N	71816	0	195662009	4112343		0
18286	1099	81893	1989-08-01	1989-08-01 00:00:00	\N	\N	32020		\N	72196	0	64766004	81893		0
18496	1113	4218389	2012-12-10	2012-12-10 00:00:00	2012-12-31	2012-12-31 00:00:00	32020		\N	73286	0	39848009	4218389		0
18660	1122	4051466	1973-11-23	1973-11-23 00:00:00	1989-03-04	1989-03-04 00:00:00	32020		\N	73931	0	233678006	4051466		0
18839	1133	4310024	1998-08-30	1998-08-30 00:00:00	\N	\N	32020		\N	74629	0	424802006	4310024		0
18963	1138	4280726	1985-02-05	1985-02-05 00:00:00	1999-02-04	1999-02-04 00:00:00	32020		\N	75038	0	367498001	4280726		0
19141	1146	40481087	2015-09-20	2015-09-20 00:00:00	2015-10-04	2015-10-04 00:00:00	32020		\N	75722	0	444814009	40481087		0
19342	1158	4283893	2010-06-13	2010-06-13 00:00:00	2010-08-15	2010-08-15 00:00:00	32020		\N	76490	0	36971009	4283893		0
19588	1175	4112343	1947-10-07	1947-10-07 00:00:00	1947-10-19	1947-10-19 00:00:00	32020		\N	77545	0	195662009	4112343		0
19679	1180	81151	1968-01-09	1968-01-09 00:00:00	1968-02-06	1968-02-06 00:00:00	32020		\N	77960	0	44465007	81151		0
19903	1197	260139	1997-11-04	1997-11-04 00:00:00	1997-11-11	1997-11-11 00:00:00	32020		\N	78843	0	10509002	260139		0
20006	1206	81893	1998-06-26	1998-06-26 00:00:00	\N	\N	32020		\N	79226	0	64766004	81893		0
20193	1215	257012	2006-02-24	2006-02-24 00:00:00	\N	\N	32020		\N	80059	0	40055000	257012		0
20302	1222	4112343	2018-11-19	2018-11-19 00:00:00	2018-12-01	2018-12-01 00:00:00	32020		\N	80406	0	195662009	4112343		0
20504	1232	372328	1966-03-09	1966-03-09 00:00:00	1966-05-23	1966-05-23 00:00:00	32020		\N	81181	0	65363002	372328		0
20685	1242	40481087	1971-05-01	1971-05-01 00:00:00	1971-05-15	1971-05-15 00:00:00	32020		\N	81756	0	444814009	40481087		0
20816	1249	260139	2016-02-26	2016-02-26 00:00:00	2016-03-04	2016-03-04 00:00:00	32020		\N	82279	0	10509002	260139		0
20960	1258	260139	1970-05-28	1970-05-28 00:00:00	1970-06-11	1970-06-11 00:00:00	32020		\N	82902	0	10509002	260139		0
21206	1272	80180	2015-11-24	2015-11-24 00:00:00	\N	\N	32020		\N	83969	0	396275006	80180		0
10646	625	4112343	1990-11-28	1990-11-28 00:00:00	1990-12-10	1990-12-10 00:00:00	32020		\N	41764	0	195662009	4112343		0
10853	642	28060	2013-12-31	2013-12-31 00:00:00	2014-01-10	2014-01-10 00:00:00	32020		\N	42541	0	43878008	28060		0
11053	652	4155034	2017-10-31	2017-10-31 00:00:00	2017-11-21	2017-11-21 00:00:00	32020		\N	43130	0	283371005	4155034		0
11237	664	40481087	2011-11-18	2011-11-18 00:00:00	2011-12-09	2011-12-09 00:00:00	32020		\N	43905	0	444814009	40481087		0
11345	670	4310024	2015-05-22	2015-05-22 00:00:00	\N	\N	32020		\N	44203	0	424802006	4310024		0
11608	686	4310024	1979-02-01	1979-02-01 00:00:00	\N	\N	32020		\N	45406	0	424802006	4310024		0
11678	689	81151	1995-04-14	1995-04-14 00:00:00	1995-05-12	1995-05-12 00:00:00	32020		\N	45623	0	44465007	81151		0
11865	701	40481087	1968-09-11	1968-09-11 00:00:00	1968-10-02	1968-10-02 00:00:00	32020		\N	46344	0	444814009	40481087		0
12023	710	40481087	2009-09-16	2009-09-16 00:00:00	2009-09-23	2009-09-23 00:00:00	32020		\N	47045	0	444814009	40481087		0
12223	723	28060	2011-08-17	2011-08-17 00:00:00	2011-08-29	2011-08-29 00:00:00	32020		\N	47845	0	43878008	28060		0
12323	728	40481087	1995-04-08	1995-04-08 00:00:00	1995-04-29	1995-04-29 00:00:00	32020		\N	48342	0	444814009	40481087		0
12511	741	260139	2004-05-05	2004-05-05 00:00:00	2004-05-19	2004-05-19 00:00:00	32020		\N	49096	0	10509002	260139		0
12714	753	81151	1968-08-19	1968-08-19 00:00:00	1968-09-02	1968-09-02 00:00:00	32020		\N	49816	0	44465007	81151		0
12885	758	40481087	1983-12-26	1983-12-26 00:00:00	1984-01-09	1984-01-09 00:00:00	32020		\N	50299	0	444814009	40481087		0
12994	763	4112343	2018-07-01	2018-07-01 00:00:00	2018-07-09	2018-07-09 00:00:00	32020		\N	50758	0	195662009	4112343		0
13188	776	4035415	2011-08-16	2011-08-16 00:00:00	2011-09-15	2011-09-15 00:00:00	32020		\N	51573	0	239720000	4035415		0
13329	784	4294548	2016-11-19	2016-11-19 00:00:00	2016-12-17	2016-12-17 00:00:00	32020		\N	52181	0	75498004	4294548		0
13564	800	4112343	2008-08-25	2008-08-25 00:00:00	2008-09-04	2008-09-04 00:00:00	32020		\N	53153	0	195662009	4112343		0
13676	807	4112343	2015-11-21	2015-11-21 00:00:00	2015-11-30	2015-11-30 00:00:00	32020		\N	53568	0	195662009	4112343		0
13817	817	80180	1999-07-20	1999-07-20 00:00:00	\N	\N	32020		\N	54177	0	396275006	80180		0
13981	825	260139	1982-01-31	1982-01-31 00:00:00	1982-02-14	1982-02-14 00:00:00	32020		\N	54691	0	10509002	260139		0
14242	842	4296204	1990-04-29	1990-04-29 00:00:00	1990-05-13	1990-05-13 00:00:00	32020		\N	55713	0	403190006	4296204		0
14323	844	4283893	1971-02-03	1971-02-03 00:00:00	1971-02-24	1971-02-24 00:00:00	32020		\N	55937	0	36971009	4283893		0
14514	859	40481087	1987-02-18	1987-02-18 00:00:00	1987-02-25	1987-02-25 00:00:00	32020		\N	56826	0	444814009	40481087		0
14671	865	4296204	1998-12-25	1998-12-25 00:00:00	1999-01-15	1999-01-15 00:00:00	32020		\N	57369	0	403190006	4296204		0
14892	877	375671	1978-05-28	1978-05-28 00:00:00	1978-07-27	1978-07-27 00:00:00	32020		\N	58437	0	62564004	375671		0
15034	885	4112343	2013-01-06	2013-01-06 00:00:00	2013-01-17	2013-01-17 00:00:00	32020		\N	59039	0	195662009	4112343		0
15194	895	40481087	1982-04-12	1982-04-12 00:00:00	1982-04-19	1982-04-19 00:00:00	32020		\N	59672	0	444814009	40481087		0
15374	911	4112343	1994-04-30	1994-04-30 00:00:00	1994-05-07	1994-05-07 00:00:00	32020		\N	60462	0	195662009	4112343		0
15499	918	260139	1941-10-11	1941-10-11 00:00:00	1941-10-25	1941-10-25 00:00:00	32020		\N	61187	0	10509002	260139		0
15693	929	40481087	1930-12-27	1930-12-27 00:00:00	1931-01-03	1931-01-03 00:00:00	32020		\N	61803	0	444814009	40481087		0
15814	935	4027663	1962-03-04	1962-03-04 00:00:00	\N	\N	32020		\N	62165	0	13200003	4027663		0
16030	948	40481087	1985-05-22	1985-05-22 00:00:00	1985-06-12	1985-06-12 00:00:00	32020		\N	62969	0	444814009	40481087		0
16198	958	260139	2013-12-06	2013-12-06 00:00:00	2013-12-13	2013-12-13 00:00:00	32020		\N	63611	0	10509002	260139		0
16331	967	440086	1944-10-12	1944-10-12 00:00:00	1950-10-21	1950-10-21 00:00:00	32020		\N	64351	0	192127007	440086		0
16473	973	4112343	2005-12-18	2005-12-18 00:00:00	2005-12-27	2005-12-27 00:00:00	32020		\N	64773	0	195662009	4112343		0
16680	987	40481087	2015-10-28	2015-10-28 00:00:00	2015-11-18	2015-11-18 00:00:00	32020		\N	65536	0	444814009	40481087		0
16848	1000	380378	2017-01-29	2017-01-29 00:00:00	\N	\N	32020		\N	66142	0	84757009	380378		0
17011	1016	260139	2000-12-19	2000-12-19 00:00:00	2001-01-02	2001-01-02 00:00:00	32020		\N	66907	0	10509002	260139		0
17250	1032	40481087	2014-06-19	2014-06-19 00:00:00	2014-07-03	2014-07-03 00:00:00	32020		\N	67873	0	444814009	40481087		0
17419	1046	81151	1983-04-06	1983-04-06 00:00:00	1983-05-11	1983-05-11 00:00:00	32020		\N	68697	0	44465007	81151		0
17508	1053	28060	1985-03-25	1985-03-25 00:00:00	1985-04-02	1985-04-02 00:00:00	32020		\N	69005	0	43878008	28060		0
17632	1058	4112343	1962-03-06	1962-03-06 00:00:00	1962-03-13	1962-03-13 00:00:00	32020		\N	69382	0	195662009	4112343		0
17892	1076	80180	2013-08-19	2013-08-19 00:00:00	\N	\N	32020		\N	70584	0	396275006	80180		0
17992	1082	260139	1962-10-24	1962-10-24 00:00:00	1962-11-07	1962-11-07 00:00:00	32020		\N	70940	0	10509002	260139		0
18172	1092	4112343	1966-08-24	1966-08-24 00:00:00	1966-09-04	1966-09-04 00:00:00	32020		\N	71814	0	195662009	4112343		0
18287	1099	78272	1990-02-09	1990-02-09 00:00:00	1990-02-23	1990-02-23 00:00:00	32020		\N	72160	0	70704007	78272		0
18497	1113	195588	2007-11-07	2007-11-07 00:00:00	2007-12-14	2007-12-14 00:00:00	32020		\N	73258	0	38822007	195588		0
16216	959	4285898	1994-10-03	1994-10-03 00:00:00	\N	\N	32020		\N	63775	0	68496003	4285898		0
18661	1122	378001	2005-10-14	2005-10-14 00:00:00	2005-12-13	2005-12-13 00:00:00	32020		\N	73966	0	62106007	378001		0
18840	1133	28060	1968-05-12	1968-05-12 00:00:00	1968-05-24	1968-05-24 00:00:00	32020		\N	74586	0	43878008	28060		0
18964	1138	260139	1993-12-20	1993-12-20 00:00:00	1994-01-03	1994-01-03 00:00:00	32020		\N	75105	0	10509002	260139		0
19153	1148	4059173	1967-09-03	1967-09-03 00:00:00	1967-10-03	1967-10-03 00:00:00	32020		\N	75931	0	16114001	4059173		0
19343	1158	40481087	2008-09-02	2008-09-02 00:00:00	2008-09-16	2008-09-16 00:00:00	32020		\N	76507	0	444814009	40481087		0
30047	1778	40481087	2017-10-08	2017-10-08 00:00:00	2017-10-22	2017-10-22 00:00:00	32020		\N	118953	0	444814009	40481087		0
19680	1180	40481087	2001-10-13	2001-10-13 00:00:00	2001-11-03	2001-11-03 00:00:00	32020		\N	77898	0	444814009	40481087		0
19904	1197	28060	1981-12-17	1981-12-17 00:00:00	1981-12-27	1981-12-27 00:00:00	32020		\N	78842	0	43878008	28060		0
20007	1206	4310024	1997-09-29	1997-09-29 00:00:00	\N	\N	32020		\N	79226	0	424802006	4310024		0
20194	1215	4283893	2006-02-03	2006-02-03 00:00:00	2006-03-31	2006-03-31 00:00:00	32020		\N	80011	0	36971009	4283893		0
20303	1222	4112343	2004-01-01	2004-01-01 00:00:00	2004-01-08	2004-01-08 00:00:00	32020		\N	80435	0	195662009	4112343		0
20505	1232	40481087	1980-05-14	1980-05-14 00:00:00	1980-05-21	1980-05-21 00:00:00	32020		\N	81202	0	444814009	40481087		0
20686	1242	260139	1975-10-14	1975-10-14 00:00:00	1975-10-21	1975-10-21 00:00:00	32020		\N	81821	0	10509002	260139		0
20817	1249	4237458	2002-08-24	2002-08-24 00:00:00	2002-09-23	2002-09-23 00:00:00	32020		\N	82292	0	58150001	4237458		0
20961	1258	4283893	2007-08-17	2007-08-17 00:00:00	2007-11-09	2007-11-09 00:00:00	32020		\N	82878	0	36971009	4283893		0
21207	1272	81151	1994-12-24	1994-12-24 00:00:00	1995-01-07	1995-01-07 00:00:00	32020		\N	83861	0	44465007	81151		0
10647	625	4112343	1998-01-04	1998-01-04 00:00:00	1998-01-13	1998-01-13 00:00:00	32020		\N	41734	0	195662009	4112343		0
10854	642	40481087	2005-08-17	2005-08-17 00:00:00	2005-08-24	2005-08-24 00:00:00	32020		\N	42491	0	444814009	40481087		0
11054	652	4116491	1991-02-07	1991-02-07 00:00:00	1991-03-19	1991-03-19 00:00:00	32020		\N	43160	0	301011002	4116491		0
11238	664	80180	2016-12-17	2016-12-17 00:00:00	\N	\N	32020		\N	43817	0	396275006	80180		0
11346	670	81893	2015-09-19	2015-09-19 00:00:00	\N	\N	32020		\N	44203	0	64766004	81893		0
11609	686	260139	1976-07-30	1976-07-30 00:00:00	1976-08-06	1976-08-06 00:00:00	32020		\N	45440	0	10509002	260139		0
11679	689	40481087	1993-11-01	1993-11-01 00:00:00	1993-11-15	1993-11-15 00:00:00	32020		\N	45611	0	444814009	40481087		0
11866	701	372328	1958-07-27	1958-07-27 00:00:00	1958-11-08	1958-11-08 00:00:00	32020		\N	46350	0	65363002	372328		0
12024	711	4112343	2008-01-20	2008-01-20 00:00:00	2008-01-31	2008-01-31 00:00:00	32020		\N	47202	0	195662009	4112343		0
12224	723	260139	1969-07-28	1969-07-28 00:00:00	1969-08-04	1969-08-04 00:00:00	32020		\N	47823	0	10509002	260139		0
12324	728	28060	1997-04-20	1997-04-20 00:00:00	1997-04-27	1997-04-27 00:00:00	32020		\N	48332	0	43878008	28060		0
12512	741	4112343	2001-04-15	2001-04-15 00:00:00	2001-04-22	2001-04-22 00:00:00	32020		\N	49054	0	195662009	4112343		0
12715	753	28060	1973-04-27	1973-04-27 00:00:00	1973-05-08	1973-05-08 00:00:00	32020		\N	49811	0	43878008	28060		0
12886	758	40481087	1979-01-21	1979-01-21 00:00:00	1979-02-11	1979-02-11 00:00:00	32020		\N	50298	0	444814009	40481087		0
12995	763	4112343	1966-10-13	1966-10-13 00:00:00	1966-10-26	1966-10-26 00:00:00	32020		\N	50752	0	195662009	4112343		0
13189	776	4218389	1962-07-01	1962-07-01 00:00:00	1962-07-22	1962-07-22 00:00:00	32020		\N	51568	0	39848009	4218389		0
13330	784	4112343	2007-01-24	2007-01-24 00:00:00	2007-01-31	2007-01-31 00:00:00	32020		\N	52202	0	195662009	4112343		0
13565	800	375671	1979-04-19	1979-04-19 00:00:00	1979-05-19	1979-05-19 00:00:00	32020		\N	53090	0	62564004	375671		0
13677	807	40481087	1975-05-28	1975-05-28 00:00:00	1975-06-18	1975-06-18 00:00:00	32020		\N	53561	0	444814009	40481087		0
13818	817	28060	1970-01-22	1970-01-22 00:00:00	1970-01-29	1970-01-29 00:00:00	32020		\N	54131	0	43878008	28060		0
13982	825	78272	2011-06-23	2011-06-23 00:00:00	2011-07-14	2011-07-14 00:00:00	32020		\N	54654	0	70704007	78272		0
14243	842	4112343	1980-02-21	1980-02-21 00:00:00	1980-03-02	1980-03-02 00:00:00	32020		\N	55639	0	195662009	4112343		0
14338	847	4109685	1973-08-29	1973-08-29 00:00:00	1973-09-19	1973-09-19 00:00:00	32020		\N	56138	0	284551006	4109685		0
14515	859	40481087	2015-05-10	2015-05-10 00:00:00	2015-05-17	2015-05-17 00:00:00	32020		\N	56862	0	444814009	40481087		0
14672	865	260139	1992-07-22	1992-07-22 00:00:00	1992-08-05	1992-08-05 00:00:00	32020		\N	57438	0	10509002	260139		0
14893	877	4112343	1996-06-05	1996-06-05 00:00:00	1996-06-15	1996-06-15 00:00:00	32020		\N	58460	0	195662009	4112343		0
15036	885	28060	1984-03-22	1984-03-22 00:00:00	1984-04-04	1984-04-04 00:00:00	32020		\N	59001	0	43878008	28060		0
15195	895	81151	1962-11-21	1962-11-21 00:00:00	1962-12-05	1962-12-05 00:00:00	32020		\N	59749	0	44465007	81151		0
15375	911	4112343	1978-11-26	1978-11-26 00:00:00	1978-12-05	1978-12-05 00:00:00	32020		\N	60526	0	195662009	4112343		0
15500	918	4134304	1985-04-27	1985-04-27 00:00:00	1985-05-27	1985-05-27 00:00:00	32020		\N	61201	0	263102004	4134304		0
15694	929	40481087	1958-03-29	1958-03-29 00:00:00	1958-04-12	1958-04-12 00:00:00	32020		\N	61839	0	444814009	40481087		0
15815	935	4237458	1961-08-26	1961-08-26 00:00:00	1961-09-25	1961-09-25 00:00:00	32020		\N	62226	0	58150001	4237458		0
16031	948	372328	1961-08-21	1961-08-21 00:00:00	1962-02-23	1962-02-23 00:00:00	32020		\N	62921	0	65363002	372328		0
16199	958	40481087	1989-03-22	1989-03-22 00:00:00	1989-04-05	1989-04-05 00:00:00	32020		\N	63645	0	444814009	40481087		0
16332	967	4266809	1973-10-25	1973-10-25 00:00:00	\N	\N	32020		\N	64314	0	397881000	4266809		0
16474	973	4283893	1921-12-29	1921-12-29 00:00:00	1922-03-09	1922-03-09 00:00:00	32020		\N	64917	0	36971009	4283893		0
16681	987	4296205	1979-07-20	1979-07-20 00:00:00	1979-08-24	1979-08-24 00:00:00	32020		\N	65521	0	403191005	4296205		0
16849	1000	80180	2008-01-22	2008-01-22 00:00:00	\N	\N	32020		\N	66213	0	396275006	80180		0
17012	1016	378001	1983-05-21	1983-05-21 00:00:00	1983-07-20	1983-07-20 00:00:00	32020		\N	66893	0	62106007	378001		0
17251	1033	4112343	1983-05-16	1983-05-16 00:00:00	1983-05-29	1983-05-29 00:00:00	32020		\N	67971	0	195662009	4112343		0
17420	1046	4142905	1975-03-19	1975-03-19 00:00:00	1975-06-17	1975-06-17 00:00:00	32020		\N	68696	0	33737001	4142905		0
17509	1053	260139	1979-10-22	1979-10-22 00:00:00	1979-10-29	1979-10-29 00:00:00	32020		\N	69047	0	10509002	260139		0
17633	1058	372328	1956-07-20	1956-07-20 00:00:00	1956-09-01	1956-09-01 00:00:00	32020		\N	69408	0	65363002	372328		0
17893	1076	4134304	1981-12-25	1981-12-25 00:00:00	1982-02-23	1982-02-23 00:00:00	32020		\N	70553	0	263102004	4134304		0
17993	1082	40481087	1995-05-13	1995-05-13 00:00:00	1995-06-03	1995-06-03 00:00:00	32020		\N	70925	0	444814009	40481087		0
18173	1092	40481087	1977-03-29	1977-03-29 00:00:00	1977-04-05	1977-04-05 00:00:00	32020		\N	71784	0	444814009	40481087		0
18288	1099	260139	1955-02-27	1955-02-27 00:00:00	1955-03-06	1955-03-06 00:00:00	32020		\N	72172	0	10509002	260139		0
18498	1113	4112343	2009-07-05	2009-07-05 00:00:00	2009-07-12	2009-07-12 00:00:00	32020		\N	73277	0	195662009	4112343		0
18662	1122	40481087	2007-12-15	2007-12-15 00:00:00	2008-01-05	2008-01-05 00:00:00	32020		\N	73937	0	444814009	40481087		0
18841	1133	195588	2012-06-27	2012-06-27 00:00:00	2012-08-13	2012-08-13 00:00:00	32020		\N	74599	0	38822007	195588		0
18965	1138	4035415	2007-03-15	2007-03-15 00:00:00	2007-04-14	2007-04-14 00:00:00	32020		\N	75131	0	239720000	4035415		0
19154	1148	40481087	2006-08-20	2006-08-20 00:00:00	2006-08-27	2006-08-27 00:00:00	32020		\N	75888	0	444814009	40481087		0
19344	1158	260139	2004-06-14	2004-06-14 00:00:00	2004-06-28	2004-06-28 00:00:00	32020		\N	76528	0	10509002	260139		0
30048	1778	260139	2017-10-01	2017-10-01 00:00:00	2017-10-15	2017-10-15 00:00:00	32020		\N	118958	0	10509002	260139		0
19681	1180	260139	1983-04-09	1983-04-09 00:00:00	1983-04-16	1983-04-16 00:00:00	32020		\N	77904	0	10509002	260139		0
19905	1197	40481087	2010-07-30	2010-07-30 00:00:00	2010-08-13	2010-08-13 00:00:00	32020		\N	78874	0	444814009	40481087		0
20008	1206	4285898	1999-03-23	1999-03-23 00:00:00	\N	\N	32020		\N	79262	0	68496003	4285898		0
20195	1215	40481087	1987-07-30	1987-07-30 00:00:00	1987-08-20	1987-08-20 00:00:00	32020		\N	80054	0	444814009	40481087		0
20304	1222	40481087	2013-09-06	2013-09-06 00:00:00	2013-09-20	2013-09-20 00:00:00	32020		\N	80372	0	444814009	40481087		0
20506	1232	4283893	2014-01-15	2014-01-15 00:00:00	2014-04-09	2014-04-09 00:00:00	32020		\N	81223	0	36971009	4283893		0
20687	1242	40481087	1992-07-06	1992-07-06 00:00:00	1992-07-13	1992-07-13 00:00:00	32020		\N	81824	0	444814009	40481087		0
20818	1249	78272	2019-05-02	2019-05-02 00:00:00	2019-06-06	2019-06-06 00:00:00	32020		\N	82295	0	70704007	78272		0
20962	1258	4116491	1984-03-08	1984-03-08 00:00:00	1984-04-11	1984-04-11 00:00:00	32020		\N	82882	0	301011002	4116491		0
21208	1272	372328	1985-04-06	1985-04-06 00:00:00	1985-08-30	1985-08-30 00:00:00	32020		\N	83942	0	65363002	372328		0
10648	625	4283893	2000-12-11	2000-12-11 00:00:00	2001-08-13	2001-08-13 00:00:00	32020		\N	41766	0	36971009	4283893		0
10855	642	260139	1985-06-08	1985-06-08 00:00:00	1985-06-22	1985-06-22 00:00:00	32020		\N	42539	0	10509002	260139		0
11055	652	378001	2016-11-05	2016-11-05 00:00:00	2017-01-04	2017-01-04 00:00:00	32020		\N	43129	0	62106007	378001		0
11239	664	372328	1986-10-17	1986-10-17 00:00:00	1987-06-25	1987-06-25 00:00:00	32020		\N	43901	0	65363002	372328		0
11347	670	40481087	1994-11-03	1994-11-03 00:00:00	1994-11-24	1994-11-24 00:00:00	32020		\N	44255	0	444814009	40481087		0
11610	686	40481087	1963-07-29	1963-07-29 00:00:00	1963-08-05	1963-08-05 00:00:00	32020		\N	45378	0	444814009	40481087		0
11680	689	80180	2017-08-01	2017-08-01 00:00:00	\N	\N	32020		\N	45615	0	396275006	80180		0
11867	701	4112343	1999-10-21	1999-10-21 00:00:00	1999-11-02	1999-11-02 00:00:00	32020		\N	46311	0	195662009	4112343		0
12025	711	40481087	1987-08-26	1987-08-26 00:00:00	1987-09-16	1987-09-16 00:00:00	32020		\N	47166	0	444814009	40481087		0
12225	723	260139	2017-08-12	2017-08-12 00:00:00	2017-08-26	2017-08-26 00:00:00	32020		\N	47825	0	10509002	260139		0
12325	728	260139	1973-02-17	1973-02-17 00:00:00	1973-03-03	1973-03-03 00:00:00	32020		\N	48350	0	10509002	260139		0
12513	741	4283893	1982-03-18	1982-03-18 00:00:00	1982-08-05	1982-08-05 00:00:00	32020		\N	49051	0	36971009	4283893		0
12716	753	4112343	2013-02-08	2013-02-08 00:00:00	2013-02-17	2013-02-17 00:00:00	32020		\N	49747	0	195662009	4112343		0
12887	758	378001	1997-07-31	1997-07-31 00:00:00	1997-08-30	1997-08-30 00:00:00	32020		\N	50356	0	62106007	378001		0
12996	763	4278672	1981-08-21	1981-08-21 00:00:00	1981-11-19	1981-11-19 00:00:00	32020		\N	50732	0	65966004	4278672		0
13190	776	4112343	1971-05-28	1971-05-28 00:00:00	1971-06-10	1971-06-10 00:00:00	32020		\N	51514	0	195662009	4112343		0
13331	784	260139	1970-12-22	1970-12-22 00:00:00	1970-12-29	1970-12-29 00:00:00	32020		\N	52243	0	10509002	260139		0
13566	800	40481087	2004-09-10	2004-09-10 00:00:00	2004-09-17	2004-09-17 00:00:00	32020		\N	53165	0	444814009	40481087		0
13678	807	40481087	1963-12-09	1963-12-09 00:00:00	1963-12-23	1963-12-23 00:00:00	32020		\N	53562	0	444814009	40481087		0
13819	817	40481087	1983-02-27	1983-02-27 00:00:00	1983-03-20	1983-03-20 00:00:00	32020		\N	54145	0	444814009	40481087		0
13983	825	372328	1971-01-10	1971-01-10 00:00:00	1971-02-20	1971-02-20 00:00:00	32020		\N	54645	0	65363002	372328		0
14244	842	4113008	1970-10-20	1970-10-20 00:00:00	1970-11-10	1970-11-10 00:00:00	32020		\N	55712	0	284549007	4113008		0
14339	847	28060	2008-10-27	2008-10-27 00:00:00	2008-11-05	2008-11-05 00:00:00	32020		\N	56146	0	43878008	28060		0
14516	859	40486433	1959-03-11	1959-03-11 00:00:00	\N	\N	32020		\N	56790	0	446096008	40486433		0
14673	865	40481087	2010-05-16	2010-05-16 00:00:00	2010-06-06	2010-06-06 00:00:00	32020		\N	57441	0	444814009	40481087		0
14894	877	80180	2016-02-13	2016-02-13 00:00:00	\N	\N	32020		\N	58416	0	396275006	80180		0
15037	885	4237458	1992-12-30	1992-12-30 00:00:00	1993-02-28	1993-02-28 00:00:00	32020		\N	58981	0	58150001	4237458		0
15196	895	40481087	2003-09-22	2003-09-22 00:00:00	2003-10-13	2003-10-13 00:00:00	32020		\N	59700	0	444814009	40481087		0
15376	911	40481087	2017-09-17	2017-09-17 00:00:00	2017-09-24	2017-09-24 00:00:00	32020		\N	60469	0	444814009	40481087		0
15501	918	4112343	1962-01-07	1962-01-07 00:00:00	1962-01-20	1962-01-20 00:00:00	32020		\N	61128	0	195662009	4112343		0
15695	929	4155034	1932-07-26	1932-07-26 00:00:00	1932-08-09	1932-08-09 00:00:00	32020		\N	61754	0	283371005	4155034		0
15816	935	4112343	1991-10-12	1991-10-12 00:00:00	1991-10-20	1991-10-20 00:00:00	32020		\N	62167	0	195662009	4112343		0
16032	948	4112343	1976-08-16	1976-08-16 00:00:00	1976-08-25	1976-08-25 00:00:00	32020		\N	62952	0	195662009	4112343		0
16200	958	40481087	2003-02-01	2003-02-01 00:00:00	2003-02-22	2003-02-22 00:00:00	32020		\N	63637	0	444814009	40481087		0
16333	967	80180	1973-10-25	1973-10-25 00:00:00	\N	\N	32020		\N	64314	0	396275006	80180		0
16475	973	260139	1990-04-27	1990-04-27 00:00:00	1990-05-11	1990-05-11 00:00:00	32020		\N	64817	0	10509002	260139		0
16682	987	260139	1991-10-01	1991-10-01 00:00:00	1991-10-15	1991-10-15 00:00:00	32020		\N	65600	0	10509002	260139		0
16850	1000	4266809	2008-01-22	2008-01-22 00:00:00	\N	\N	32020		\N	66213	0	397881000	4266809		0
17013	1016	40481087	1975-03-09	1975-03-09 00:00:00	1975-03-30	1975-03-30 00:00:00	32020		\N	66873	0	444814009	40481087		0
17252	1033	4112343	1975-01-19	1975-01-19 00:00:00	1975-01-27	1975-01-27 00:00:00	32020		\N	68008	0	195662009	4112343		0
17421	1046	40481087	1978-01-10	1978-01-10 00:00:00	1978-01-17	1978-01-17 00:00:00	32020		\N	68648	0	444814009	40481087		0
17510	1053	4218389	1989-01-21	1989-01-21 00:00:00	1989-02-18	1989-02-18 00:00:00	32020		\N	69040	0	39848009	4218389		0
17634	1058	4112343	1999-07-10	1999-07-10 00:00:00	1999-07-17	1999-07-17 00:00:00	32020		\N	69394	0	195662009	4112343		0
17894	1076	40481087	1975-11-01	1975-11-01 00:00:00	1975-11-08	1975-11-08 00:00:00	32020		\N	70564	0	444814009	40481087		0
17994	1082	4112343	1997-09-18	1997-09-18 00:00:00	1997-09-27	1997-09-27 00:00:00	32020		\N	70960	0	195662009	4112343		0
18174	1092	40479768	1962-08-04	1962-08-04 00:00:00	1962-09-10	1962-09-10 00:00:00	32020		\N	71796	0	444470001	40479768		0
18289	1099	4155034	2018-10-24	2018-10-24 00:00:00	2018-11-07	2018-11-07 00:00:00	32020		\N	72161	0	283371005	4155034		0
18499	1113	378001	1972-09-11	1972-09-11 00:00:00	1972-11-10	1972-11-10 00:00:00	32020		\N	73285	0	62106007	378001		0
18663	1123	40481087	1994-06-22	1994-06-22 00:00:00	1994-06-29	1994-06-29 00:00:00	32020		\N	74012	0	444814009	40481087		0
18842	1133	4230399	2011-03-10	2011-03-10 00:00:00	2011-05-09	2011-05-09 00:00:00	32020		\N	74585	0	359817006	4230399		0
18966	1138	40481087	2011-12-10	2011-12-10 00:00:00	2011-12-24	2011-12-24 00:00:00	32020		\N	75135	0	444814009	40481087		0
19156	1148	4112343	1963-02-03	1963-02-03 00:00:00	1963-02-10	1963-02-10 00:00:00	32020		\N	75877	0	195662009	4112343		0
19345	1158	40481087	2014-08-02	2014-08-02 00:00:00	2014-08-16	2014-08-16 00:00:00	32020		\N	76479	0	444814009	40481087		0
30049	1778	4027663	2010-05-10	2010-05-10 00:00:00	\N	\N	32020		\N	118967	0	13200003	4027663		0
19682	1180	40481087	1981-04-13	1981-04-13 00:00:00	1981-05-04	1981-05-04 00:00:00	32020		\N	77903	0	444814009	40481087		0
30380	1793	381316	2006-08-30	2006-08-30 00:00:00	\N	\N	32020		\N	120247	0	230690007	381316		0
20009	1206	80180	1999-10-19	1999-10-19 00:00:00	\N	\N	32020		\N	79262	0	396275006	80180		0
20196	1215	4112343	1987-04-22	1987-04-22 00:00:00	1987-04-29	1987-04-29 00:00:00	32020		\N	80009	0	195662009	4112343		0
20305	1222	257012	1987-10-27	1987-10-27 00:00:00	\N	\N	32020		\N	80415	0	40055000	257012		0
20507	1232	372328	1968-12-08	1968-12-08 00:00:00	1969-09-01	1969-09-01 00:00:00	32020		\N	81204	0	65363002	372328		0
20688	1242	4027663	1993-03-02	1993-03-02 00:00:00	\N	\N	32020		\N	81824	0	13200003	4027663		0
20819	1249	40481087	1978-03-12	1978-03-12 00:00:00	1978-03-26	1978-03-26 00:00:00	32020		\N	82254	0	444814009	40481087		0
16349	967	30753	1972-09-30	1972-09-30 00:00:00	\N	\N	32020		\N	64285	0	16761005	30753		0
20963	1258	4112343	2008-11-16	2008-11-16 00:00:00	2008-11-28	2008-11-28 00:00:00	32020		\N	82866	0	195662009	4112343		0
21209	1272	260139	2002-01-07	2002-01-07 00:00:00	2002-01-21	2002-01-21 00:00:00	32020		\N	83929	0	10509002	260139		0
10649	625	81893	2012-07-23	2012-07-23 00:00:00	\N	\N	32020		\N	41760	0	64766004	81893		0
10856	642	378419	2016-01-17	2016-01-17 00:00:00	\N	\N	32020		\N	42516	0	26929004	378419		0
11056	652	40481087	2014-01-09	2014-01-09 00:00:00	2014-01-16	2014-01-16 00:00:00	32020		\N	43183	0	444814009	40481087		0
11240	664	4109685	2007-05-20	2007-05-20 00:00:00	2007-06-03	2007-06-03 00:00:00	32020		\N	43891	0	284551006	4109685		0
11348	670	260139	1995-12-11	1995-12-11 00:00:00	1995-12-25	1995-12-25 00:00:00	32020		\N	44223	0	10509002	260139		0
11611	686	4112343	2002-06-18	2002-06-18 00:00:00	2002-06-28	2002-06-28 00:00:00	32020		\N	45399	0	195662009	4112343		0
11681	689	40481087	2017-06-28	2017-06-28 00:00:00	2017-07-12	2017-07-12 00:00:00	32020		\N	45615	0	444814009	40481087		0
11868	701	372328	1959-05-07	1959-05-07 00:00:00	1959-08-08	1959-08-08 00:00:00	32020		\N	46323	0	65363002	372328		0
12026	711	40481087	1968-05-19	1968-05-19 00:00:00	1968-06-09	1968-06-09 00:00:00	32020		\N	47192	0	444814009	40481087		0
12226	723	4027663	1993-11-02	1993-11-02 00:00:00	\N	\N	32020		\N	47832	0	13200003	4027663		0
12326	728	28060	1963-11-09	1963-11-09 00:00:00	1963-11-21	1963-11-21 00:00:00	32020		\N	48335	0	43878008	28060		0
12514	741	4116491	1995-11-24	1995-11-24 00:00:00	1995-12-30	1995-12-30 00:00:00	32020		\N	49094	0	301011002	4116491		0
12717	753	40481087	1978-10-13	1978-10-13 00:00:00	1978-10-27	1978-10-27 00:00:00	32020		\N	49774	0	444814009	40481087		0
12888	758	40481087	1999-02-20	1999-02-20 00:00:00	1999-02-27	1999-02-27 00:00:00	32020		\N	50313	0	444814009	40481087		0
12997	763	260139	1990-12-21	1990-12-21 00:00:00	1991-01-04	1991-01-04 00:00:00	32020		\N	50753	0	10509002	260139		0
13191	776	4156265	2009-10-11	2009-10-11 00:00:00	2009-10-25	2009-10-25 00:00:00	32020		\N	51572	0	370247008	4156265		0
13332	784	260139	2002-09-27	2002-09-27 00:00:00	2002-10-04	2002-10-04 00:00:00	32020		\N	52222	0	10509002	260139		0
13567	800	4112343	1965-02-04	1965-02-04 00:00:00	1965-02-14	1965-02-14 00:00:00	32020		\N	53106	0	195662009	4112343		0
13679	807	4156265	1965-10-27	1965-10-27 00:00:00	1965-11-10	1965-11-10 00:00:00	32020		\N	53634	0	370247008	4156265		0
13820	817	439777	1976-05-11	1976-05-11 00:00:00	\N	\N	32020		\N	54162	0	271737000	439777		0
13984	825	40481087	2017-09-16	2017-09-16 00:00:00	2017-09-30	2017-09-30 00:00:00	32020		\N	54667	0	444814009	40481087		0
14245	842	4283893	1961-05-10	1961-05-10 00:00:00	1961-09-13	1961-09-13 00:00:00	32020		\N	55623	0	36971009	4283893		0
14340	847	40481087	1996-03-13	1996-03-13 00:00:00	1996-04-03	1996-04-03 00:00:00	32020		\N	56109	0	444814009	40481087		0
14517	859	4283893	2017-03-15	2017-03-15 00:00:00	2017-05-17	2017-05-17 00:00:00	32020		\N	56731	0	36971009	4283893		0
14674	865	40481087	1981-01-19	1981-01-19 00:00:00	1981-02-02	1981-02-02 00:00:00	32020		\N	57394	0	444814009	40481087		0
14895	877	81151	1999-04-06	1999-04-06 00:00:00	1999-04-27	1999-04-27 00:00:00	32020		\N	58441	0	44465007	81151		0
15038	885	40481087	1988-12-18	1988-12-18 00:00:00	1989-01-01	1989-01-01 00:00:00	32020		\N	58984	0	444814009	40481087		0
15197	895	260139	1980-02-22	1980-02-22 00:00:00	1980-03-07	1980-03-07 00:00:00	32020		\N	59719	0	10509002	260139		0
15377	911	4112343	2010-06-09	2010-06-09 00:00:00	2010-06-18	2010-06-18 00:00:00	32020		\N	60468	0	195662009	4112343		0
15502	918	4134304	1969-01-21	1969-01-21 00:00:00	1969-03-22	1969-03-22 00:00:00	32020		\N	61200	0	263102004	4134304		0
15696	929	372328	1919-09-03	1919-09-03 00:00:00	1919-11-10	1919-11-10 00:00:00	32020		\N	61842	0	65363002	372328		0
15817	935	40481087	1983-10-25	1983-10-25 00:00:00	1983-11-08	1983-11-08 00:00:00	32020		\N	62166	0	444814009	40481087		0
16033	948	4142905	2000-11-05	2000-11-05 00:00:00	2000-12-05	2000-12-05 00:00:00	32020		\N	62964	0	33737001	4142905		0
16201	958	4296204	2002-12-12	2002-12-12 00:00:00	2002-12-26	2002-12-26 00:00:00	32020		\N	63598	0	403190006	4296204		0
16334	967	4155034	1973-01-13	1973-01-13 00:00:00	1973-01-27	1973-01-27 00:00:00	32020		\N	64314	0	283371005	4155034		0
16476	973	260139	1953-09-02	1953-09-02 00:00:00	1953-09-16	1953-09-16 00:00:00	32020		\N	64872	0	10509002	260139		0
16683	987	260139	1970-09-29	1970-09-29 00:00:00	1970-10-13	1970-10-13 00:00:00	32020		\N	65597	0	10509002	260139		0
16851	1000	4027663	1997-02-03	1997-02-03 00:00:00	\N	\N	32020		\N	66209	0	13200003	4027663		0
17014	1017	372328	1960-01-06	1960-01-06 00:00:00	1960-05-22	1960-05-22 00:00:00	32020		\N	66933	0	65363002	372328		0
17253	1033	40481087	2016-05-20	2016-05-20 00:00:00	2016-06-03	2016-06-03 00:00:00	32020		\N	68018	0	444814009	40481087		0
17422	1046	40481087	2006-02-24	2006-02-24 00:00:00	2006-03-17	2006-03-17 00:00:00	32020		\N	68703	0	444814009	40481087		0
17511	1053	40481087	1998-01-06	1998-01-06 00:00:00	1998-01-27	1998-01-27 00:00:00	32020		\N	69049	0	444814009	40481087		0
17635	1058	40479422	2004-05-30	2004-05-30 00:00:00	2004-07-06	2004-07-06 00:00:00	32020		\N	69406	0	444448004	40479422		0
17895	1076	4112343	2009-06-26	2009-06-26 00:00:00	2009-07-04	2009-07-04 00:00:00	32020		\N	70550	0	195662009	4112343		0
17995	1082	40481087	1986-04-17	1986-04-17 00:00:00	1986-04-24	1986-04-24 00:00:00	32020		\N	70908	0	444814009	40481087		0
18175	1092	260139	1958-04-29	1958-04-29 00:00:00	1958-05-13	1958-05-13 00:00:00	32020		\N	71754	0	10509002	260139		0
18290	1099	28060	1979-03-23	1979-03-23 00:00:00	1979-04-02	1979-04-02 00:00:00	32020		\N	72242	0	43878008	28060		0
18500	1113	4112343	2010-10-03	2010-10-03 00:00:00	2010-10-15	2010-10-15 00:00:00	32020		\N	73240	0	195662009	4112343		0
18664	1123	4113008	2015-02-25	2015-02-25 00:00:00	2015-03-18	2015-03-18 00:00:00	32020		\N	73969	0	284549007	4113008		0
18843	1133	4112343	2014-12-22	2014-12-22 00:00:00	2014-12-29	2014-12-29 00:00:00	32020		\N	74577	0	195662009	4112343		0
18967	1138	40481087	1992-05-24	1992-05-24 00:00:00	1992-06-07	1992-06-07 00:00:00	32020		\N	75070	0	444814009	40481087		0
19157	1148	4112343	1990-10-04	1990-10-04 00:00:00	1990-10-12	1990-10-12 00:00:00	32020		\N	75901	0	195662009	4112343		0
19346	1158	4112343	2003-06-28	2003-06-28 00:00:00	2003-07-11	2003-07-11 00:00:00	32020		\N	76489	0	195662009	4112343		0
30050	1778	81151	2015-01-14	2015-01-14 00:00:00	2015-02-04	2015-02-04 00:00:00	32020		\N	118932	0	44465007	81151		0
19683	1180	4278672	1963-12-31	1963-12-31 00:00:00	1964-03-30	1964-03-30 00:00:00	32020		\N	77959	0	65966004	4278672		0
30381	1793	28060	2005-12-28	2005-12-28 00:00:00	2006-01-07	2006-01-07 00:00:00	32020		\N	120247	0	43878008	28060		0
20010	1206	4152936	1998-08-08	1998-08-08 00:00:00	1998-08-29	1998-08-29 00:00:00	32020		\N	79262	0	283385000	4152936		0
20197	1215	4156265	1999-12-13	1999-12-13 00:00:00	1999-12-27	1999-12-27 00:00:00	32020		\N	80040	0	370247008	4156265		0
20306	1222	372328	1958-10-29	1958-10-29 00:00:00	1959-08-12	1959-08-12 00:00:00	32020		\N	80437	0	65363002	372328		0
20508	1232	4294548	1977-06-16	1977-06-16 00:00:00	1977-10-20	1977-10-20 00:00:00	32020		\N	81180	0	75498004	4294548		0
20689	1242	372328	1960-03-05	1960-03-05 00:00:00	1960-05-18	1960-05-18 00:00:00	32020		\N	81825	0	65363002	372328		0
20820	1249	80180	2009-10-06	2009-10-06 00:00:00	\N	\N	32020		\N	82307	0	396275006	80180		0
20964	1258	40481087	1986-05-14	1986-05-14 00:00:00	1986-05-21	1986-05-21 00:00:00	32020		\N	82863	0	444814009	40481087		0
21210	1272	40481087	2005-11-18	2005-11-18 00:00:00	2005-12-09	2005-12-09 00:00:00	32020		\N	83930	0	444814009	40481087		0
10650	625	4310024	2012-02-24	2012-02-24 00:00:00	\N	\N	32020		\N	41760	0	424802006	4310024		0
10857	642	40481087	1953-06-30	1953-06-30 00:00:00	1953-07-14	1953-07-14 00:00:00	32020		\N	42523	0	444814009	40481087		0
11057	652	260139	1973-11-07	1973-11-07 00:00:00	1973-11-14	1973-11-14 00:00:00	32020		\N	43157	0	10509002	260139		0
11241	664	4278672	2005-04-09	2005-04-09 00:00:00	2005-06-08	2005-06-08 00:00:00	32020		\N	43904	0	65966004	4278672		0
11349	670	40481087	1997-07-17	1997-07-17 00:00:00	1997-07-24	1997-07-24 00:00:00	32020		\N	44237	0	444814009	40481087		0
11612	686	78272	1994-07-17	1994-07-17 00:00:00	1994-08-21	1994-08-21 00:00:00	32020		\N	45442	0	70704007	78272		0
11682	689	40481087	2001-07-01	2001-07-01 00:00:00	2001-07-22	2001-07-22 00:00:00	32020		\N	45691	0	444814009	40481087		0
11869	701	4116491	1990-08-23	1990-08-23 00:00:00	1990-09-25	1990-09-25 00:00:00	32020		\N	46347	0	301011002	4116491		0
12027	711	40481087	1993-03-26	1993-03-26 00:00:00	1993-04-16	1993-04-16 00:00:00	32020		\N	47095	0	444814009	40481087		0
12227	723	4230399	2013-12-21	2013-12-21 00:00:00	2014-02-19	2014-02-19 00:00:00	32020		\N	47822	0	359817006	4230399		0
12327	728	4112343	2015-06-28	2015-06-28 00:00:00	2015-07-10	2015-07-10 00:00:00	32020		\N	48358	0	195662009	4112343		0
12515	741	40481087	1998-07-16	1998-07-16 00:00:00	1998-07-30	1998-07-30 00:00:00	32020		\N	49036	0	444814009	40481087		0
12718	753	80180	2005-08-05	2005-08-05 00:00:00	\N	\N	32020		\N	49757	0	396275006	80180		0
12889	758	372328	1977-02-02	1977-02-02 00:00:00	1977-02-27	1977-02-27 00:00:00	32020		\N	50307	0	65363002	372328		0
12998	763	4116491	2018-03-05	2018-03-05 00:00:00	2018-04-13	2018-04-13 00:00:00	32020		\N	50762	0	301011002	4116491		0
13192	776	4283893	2004-08-06	2004-08-06 00:00:00	2004-09-03	2004-09-03 00:00:00	32020		\N	51538	0	36971009	4283893		0
13333	784	40481087	2011-08-19	2011-08-19 00:00:00	2011-09-09	2011-09-09 00:00:00	32020		\N	52245	0	444814009	40481087		0
13568	800	28060	2013-03-15	2013-03-15 00:00:00	2013-03-23	2013-03-23 00:00:00	32020		\N	53132	0	43878008	28060		0
13680	807	40481087	1965-09-21	1965-09-21 00:00:00	1965-10-12	1965-10-12 00:00:00	32020		\N	53563	0	444814009	40481087		0
13821	817	4027663	1991-05-08	1991-05-08 00:00:00	\N	\N	32020		\N	54122	0	13200003	4027663		0
13985	825	40481087	2005-01-06	2005-01-06 00:00:00	2005-01-27	2005-01-27 00:00:00	32020		\N	54666	0	444814009	40481087		0
14246	842	4294548	1926-03-28	1926-03-28 00:00:00	1926-07-11	1926-07-11 00:00:00	32020		\N	55653	0	75498004	4294548		0
14341	847	40481087	1975-09-09	1975-09-09 00:00:00	1975-09-30	1975-09-30 00:00:00	32020		\N	56121	0	444814009	40481087		0
14518	859	4112343	1963-10-02	1963-10-02 00:00:00	1963-10-15	1963-10-15 00:00:00	32020		\N	56896	0	195662009	4112343		0
14675	865	40481087	1974-01-05	1974-01-05 00:00:00	1974-01-19	1974-01-19 00:00:00	32020		\N	57393	0	444814009	40481087		0
14896	877	4112343	1992-07-15	1992-07-15 00:00:00	1992-07-22	1992-07-22 00:00:00	32020		\N	58430	0	195662009	4112343		0
15039	886	80180	2018-06-15	2018-06-15 00:00:00	\N	\N	32020		\N	59076	0	396275006	80180		0
15198	895	28060	2011-10-15	2011-10-15 00:00:00	2011-10-24	2011-10-24 00:00:00	32020		\N	59721	0	43878008	28060		0
15378	911	4112343	2008-12-02	2008-12-02 00:00:00	2008-12-13	2008-12-13 00:00:00	32020		\N	60493	0	195662009	4112343		0
15503	918	4112343	2001-04-28	2001-04-28 00:00:00	2001-05-09	2001-05-09 00:00:00	32020		\N	61131	0	195662009	4112343		0
15698	929	4329847	2005-10-10	2005-10-10 00:00:00	\N	\N	32020		\N	61759	0	22298006	4329847		0
15818	935	4134304	1931-04-06	1931-04-06 00:00:00	1931-06-05	1931-06-05 00:00:00	32020		\N	62223	0	263102004	4134304		0
16034	949	40481087	1992-04-25	1992-04-25 00:00:00	1992-05-02	1992-05-02 00:00:00	32020		\N	62988	0	444814009	40481087		0
16202	958	134438	1980-01-08	1980-01-08 00:00:00	1980-09-04	1980-09-04 00:00:00	32020		\N	63633	0	40275004	134438		0
16335	967	40481087	1974-09-07	1974-09-07 00:00:00	1974-09-14	1974-09-14 00:00:00	32020		\N	64352	0	444814009	40481087		0
16477	973	372328	1920-03-23	1920-03-23 00:00:00	1920-05-03	1920-05-03 00:00:00	32020		\N	64780	0	65363002	372328		0
16684	987	260139	1954-01-28	1954-01-28 00:00:00	1954-02-11	1954-02-11 00:00:00	32020		\N	65598	0	10509002	260139		0
16852	1000	28060	1995-12-16	1995-12-16 00:00:00	1995-12-29	1995-12-29 00:00:00	32020		\N	66158	0	43878008	28060		0
17015	1017	257012	2010-02-28	2010-02-28 00:00:00	\N	\N	32020		\N	66932	0	40055000	257012		0
17254	1033	40481087	2014-09-12	2014-09-12 00:00:00	2014-10-03	2014-10-03 00:00:00	32020		\N	67975	0	444814009	40481087		0
17423	1046	40481087	1991-06-19	1991-06-19 00:00:00	1991-07-03	1991-07-03 00:00:00	32020		\N	68676	0	444814009	40481087		0
17513	1053	4029498	1982-01-28	1982-01-28 00:00:00	\N	\N	32020		\N	69038	0	128613002	4029498		0
17636	1058	260139	2009-03-09	2009-03-09 00:00:00	2009-03-23	2009-03-23 00:00:00	32020		\N	69430	0	10509002	260139		0
17896	1076	40481087	2003-01-02	2003-01-02 00:00:00	2003-01-23	2003-01-23 00:00:00	32020		\N	70567	0	444814009	40481087		0
17996	1082	40481087	2015-03-29	2015-03-29 00:00:00	2015-04-19	2015-04-19 00:00:00	32020		\N	70967	0	444814009	40481087		0
18176	1092	4296204	1972-07-19	1972-07-19 00:00:00	1972-08-16	1972-08-16 00:00:00	32020		\N	71797	0	403190006	4296204		0
18291	1099	192671	1990-10-05	1990-10-05 00:00:00	\N	\N	32020		\N	72202	0	K92.2	35208414		0
18501	1113	81893	2011-10-02	2011-10-02 00:00:00	\N	\N	32020		\N	73240	0	64766004	81893		0
18665	1123	372328	1968-09-08	1968-09-08 00:00:00	1968-10-31	1968-10-31 00:00:00	32020		\N	74014	0	65363002	372328		0
18844	1133	81893	1999-06-26	1999-06-26 00:00:00	\N	\N	32020		\N	74574	0	64766004	81893		0
18968	1138	40481087	1987-05-01	1987-05-01 00:00:00	1987-05-22	1987-05-22 00:00:00	32020		\N	75061	0	444814009	40481087		0
19158	1148	40481087	1959-11-14	1959-11-14 00:00:00	1959-12-05	1959-12-05 00:00:00	32020		\N	75873	0	444814009	40481087		0
19347	1158	372328	2005-02-14	2005-02-14 00:00:00	2007-06-24	2007-06-24 00:00:00	32020		\N	76481	0	65363002	372328		0
30051	1778	81893	2016-07-02	2016-07-02 00:00:00	\N	\N	32020		\N	118932	0	64766004	81893		0
19684	1180	4112343	1994-09-23	1994-09-23 00:00:00	1994-10-01	1994-10-01 00:00:00	32020		\N	77896	0	195662009	4112343		0
30382	1793	4294548	1936-10-11	1936-10-11 00:00:00	1936-10-25	1936-10-25 00:00:00	32020		\N	120178	0	75498004	4294548		0
20011	1206	40481087	2012-02-06	2012-02-06 00:00:00	2012-02-27	2012-02-27 00:00:00	32020		\N	79253	0	444814009	40481087		0
20198	1215	40481087	1973-06-08	1973-06-08 00:00:00	1973-06-22	1973-06-22 00:00:00	32020		\N	80023	0	444814009	40481087		0
20307	1222	260139	1988-12-27	1988-12-27 00:00:00	1989-01-03	1989-01-03 00:00:00	32020		\N	80370	0	10509002	260139		0
20509	1232	28060	1965-09-14	1965-09-14 00:00:00	1965-09-27	1965-09-27 00:00:00	32020		\N	81198	0	43878008	28060		0
20690	1242	4156265	1989-12-26	1989-12-26 00:00:00	1990-01-09	1990-01-09 00:00:00	32020		\N	81769	0	370247008	4156265		0
20821	1250	40481087	1967-03-11	1967-03-11 00:00:00	1967-03-25	1967-03-25 00:00:00	32020		\N	82348	0	444814009	40481087		0
20965	1258	40481087	2004-07-12	2004-07-12 00:00:00	2004-07-26	2004-07-26 00:00:00	32020		\N	82877	0	444814009	40481087		0
21211	1272	40481087	2009-08-28	2009-08-28 00:00:00	2009-09-18	2009-09-18 00:00:00	32020		\N	83952	0	444814009	40481087		0
10651	625	4112343	2009-09-13	2009-09-13 00:00:00	2009-09-26	2009-09-26 00:00:00	32020		\N	41737	0	195662009	4112343		0
10864	644	40481087	1988-01-05	1988-01-05 00:00:00	1988-01-12	1988-01-12 00:00:00	32020		\N	42610	0	444814009	40481087		0
11058	652	4112343	1984-07-30	1984-07-30 00:00:00	1984-08-08	1984-08-08 00:00:00	32020		\N	43188	0	195662009	4112343		0
11242	664	40481087	1985-10-21	1985-10-21 00:00:00	1985-11-04	1985-11-04 00:00:00	32020		\N	43819	0	444814009	40481087		0
11350	670	40481087	2016-08-19	2016-08-19 00:00:00	2016-09-09	2016-09-09 00:00:00	32020		\N	44241	0	444814009	40481087		0
11613	686	4112343	1961-03-05	1961-03-05 00:00:00	1961-03-12	1961-03-12 00:00:00	32020		\N	45396	0	195662009	4112343		0
11683	689	4283893	2005-08-07	2005-08-07 00:00:00	2005-11-20	2005-11-20 00:00:00	32020		\N	45679	0	36971009	4283893		0
11880	703	313217	2006-01-27	2006-01-27 00:00:00	\N	\N	32020		\N	46430	0	49436004	313217		0
12028	711	260139	1985-10-30	1985-10-30 00:00:00	1985-11-06	1985-11-06 00:00:00	32020		\N	47165	0	10509002	260139		0
12228	723	260139	1990-10-25	1990-10-25 00:00:00	1990-11-01	1990-11-01 00:00:00	32020		\N	47824	0	10509002	260139		0
12328	728	40481087	1969-09-25	1969-09-25 00:00:00	1969-10-02	1969-10-02 00:00:00	32020		\N	48340	0	444814009	40481087		0
12516	741	78272	2001-07-22	2001-07-22 00:00:00	2001-08-19	2001-08-19 00:00:00	32020		\N	49044	0	70704007	78272		0
12719	753	4266809	2005-08-05	2005-08-05 00:00:00	\N	\N	32020		\N	49757	0	397881000	4266809		0
12890	758	260139	1996-08-23	1996-08-23 00:00:00	1996-09-06	1996-09-06 00:00:00	32020		\N	50315	0	10509002	260139		0
12999	763	375671	2015-03-31	2015-03-31 00:00:00	2015-05-30	2015-05-30 00:00:00	32020		\N	50736	0	62564004	375671		0
13193	776	260139	1961-09-15	1961-09-15 00:00:00	1961-09-29	1961-09-29 00:00:00	32020		\N	51516	0	10509002	260139		0
13334	784	260139	1991-06-29	1991-06-29 00:00:00	1991-07-13	1991-07-13 00:00:00	32020		\N	52180	0	10509002	260139		0
13569	800	378001	1962-03-19	1962-03-19 00:00:00	1962-04-18	1962-04-18 00:00:00	32020		\N	53089	0	62106007	378001		0
13682	807	28060	1981-10-25	1981-10-25 00:00:00	1981-11-05	1981-11-05 00:00:00	32020		\N	53567	0	43878008	28060		0
13822	817	372328	1989-08-11	1989-08-11 00:00:00	1992-03-12	1992-03-12 00:00:00	32020		\N	54122	0	65363002	372328		0
13986	825	4112343	1982-09-13	1982-09-13 00:00:00	1982-09-21	1982-09-21 00:00:00	32020		\N	54692	0	195662009	4112343		0
14247	842	372328	1985-08-09	1985-08-09 00:00:00	1986-04-12	1986-04-12 00:00:00	32020		\N	55607	0	65363002	372328		0
14342	847	4155034	1985-03-20	1985-03-20 00:00:00	1985-04-10	1985-04-10 00:00:00	32020		\N	56139	0	283371005	4155034		0
14519	859	4296204	1979-10-31	1979-10-31 00:00:00	1979-12-05	1979-12-05 00:00:00	32020		\N	56716	0	403190006	4296204		0
14676	865	260139	2000-01-01	2000-01-01 00:00:00	2000-01-08	2000-01-08 00:00:00	32020		\N	57440	0	10509002	260139		0
14897	877	40481087	2002-03-06	2002-03-06 00:00:00	2002-03-27	2002-03-27 00:00:00	32020		\N	58382	0	444814009	40481087		0
15040	886	40481087	1987-02-04	1987-02-04 00:00:00	1987-02-18	1987-02-18 00:00:00	32020		\N	59078	0	444814009	40481087		0
15199	895	40481087	1970-07-20	1970-07-20 00:00:00	1970-08-10	1970-08-10 00:00:00	32020		\N	59696	0	444814009	40481087		0
15379	911	4112343	2012-03-13	2012-03-13 00:00:00	2012-03-23	2012-03-23 00:00:00	32020		\N	60482	0	195662009	4112343		0
15504	918	28060	1935-06-25	1935-06-25 00:00:00	1935-07-02	1935-07-02 00:00:00	32020		\N	61136	0	43878008	28060		0
15699	929	40481087	1985-04-29	1985-04-29 00:00:00	1985-05-20	1985-05-20 00:00:00	32020		\N	61786	0	444814009	40481087		0
15819	936	4113008	1988-03-03	1988-03-03 00:00:00	1988-03-17	1988-03-17 00:00:00	32020		\N	62263	0	284549007	4113008		0
16035	949	372328	1960-01-06	1960-01-06 00:00:00	1960-05-16	1960-05-16 00:00:00	32020		\N	63028	0	65363002	372328		0
16203	958	40481087	1996-04-16	1996-04-16 00:00:00	1996-04-30	1996-04-30 00:00:00	32020		\N	63600	0	444814009	40481087		0
16336	967	260139	1994-02-18	1994-02-18 00:00:00	1994-03-04	1994-03-04 00:00:00	32020		\N	64357	0	10509002	260139		0
16478	973	4051466	1917-08-23	1917-08-23 00:00:00	1933-12-01	1933-12-01 00:00:00	32020		\N	64732	0	233678006	4051466		0
16685	987	4237458	1965-10-26	1965-10-26 00:00:00	1966-01-24	1966-01-24 00:00:00	32020		\N	65519	0	58150001	4237458		0
16853	1000	40481087	2001-01-03	2001-01-03 00:00:00	2001-01-24	2001-01-24 00:00:00	32020		\N	66143	0	444814009	40481087		0
17016	1017	40481087	2018-05-09	2018-05-09 00:00:00	2018-05-30	2018-05-30 00:00:00	32020		\N	66980	0	444814009	40481087		0
17255	1033	81151	1977-03-06	1977-03-06 00:00:00	1977-04-10	1977-04-10 00:00:00	32020		\N	67967	0	44465007	81151		0
17424	1046	195588	2010-06-18	2010-06-18 00:00:00	2010-07-27	2010-07-27 00:00:00	32020		\N	68705	0	38822007	195588		0
17514	1053	4059173	2001-11-12	2001-11-12 00:00:00	2002-02-10	2002-02-10 00:00:00	32020		\N	69042	0	16114001	4059173		0
17637	1058	4112343	2006-03-25	2006-03-25 00:00:00	2006-04-04	2006-04-04 00:00:00	32020		\N	69428	0	195662009	4112343		0
17897	1076	40481087	2008-04-01	2008-04-01 00:00:00	2008-04-15	2008-04-15 00:00:00	32020		\N	70522	0	444814009	40481087		0
17997	1082	439777	2006-08-07	2006-08-07 00:00:00	\N	\N	32020		\N	70962	0	271737000	439777		0
18177	1092	260139	1960-03-11	1960-03-11 00:00:00	1960-03-25	1960-03-25 00:00:00	32020		\N	71783	0	10509002	260139		0
18292	1099	4112343	1997-10-15	1997-10-15 00:00:00	1997-10-26	1997-10-26 00:00:00	32020		\N	72209	0	195662009	4112343		0
18502	1113	4112343	2010-03-13	2010-03-13 00:00:00	2010-03-24	2010-03-24 00:00:00	32020		\N	73278	0	195662009	4112343		0
18666	1123	40481087	2019-05-25	2019-05-25 00:00:00	2019-06-01	2019-06-01 00:00:00	32020		\N	74013	0	444814009	40481087		0
18845	1133	40481087	1998-10-02	1998-10-02 00:00:00	1998-10-09	1998-10-09 00:00:00	32020		\N	74574	0	444814009	40481087		0
18969	1138	40481087	1998-10-10	1998-10-10 00:00:00	1998-10-31	1998-10-31 00:00:00	32020		\N	75000	0	444814009	40481087		0
19159	1148	40481087	1967-11-02	1967-11-02 00:00:00	1967-11-16	1967-11-16 00:00:00	32020		\N	75874	0	444814009	40481087		0
19348	1158	4112343	2014-02-11	2014-02-11 00:00:00	2014-02-18	2014-02-18 00:00:00	32020		\N	76522	0	195662009	4112343		0
30052	1778	4112343	1997-02-21	1997-02-21 00:00:00	1997-03-02	1997-03-02 00:00:00	32020		\N	118969	0	195662009	4112343		0
19685	1180	260139	1977-07-31	1977-07-31 00:00:00	1977-08-07	1977-08-07 00:00:00	32020		\N	77924	0	10509002	260139		0
30383	1793	40481087	1991-01-05	1991-01-05 00:00:00	1991-01-12	1991-01-12 00:00:00	32020		\N	120266	0	444814009	40481087		0
20012	1206	4112343	1995-05-02	1995-05-02 00:00:00	1995-05-10	1995-05-10 00:00:00	32020		\N	79249	0	195662009	4112343		0
20199	1215	260139	1975-11-20	1975-11-20 00:00:00	1975-12-04	1975-12-04 00:00:00	32020		\N	80053	0	10509002	260139		0
20308	1222	4155034	2017-12-09	2017-12-09 00:00:00	2017-12-30	2017-12-30 00:00:00	32020		\N	80444	0	283371005	4155034		0
20510	1232	4155034	1993-12-12	1993-12-12 00:00:00	1993-12-26	1993-12-26 00:00:00	32020		\N	81185	0	283371005	4155034		0
20697	1245	78272	1986-06-30	1986-06-30 00:00:00	1986-08-04	1986-08-04 00:00:00	32020		\N	81902	0	70704007	78272		0
20822	1250	4296204	1985-05-09	1985-05-09 00:00:00	1985-05-23	1985-05-23 00:00:00	32020		\N	82335	0	403190006	4296204		0
20966	1258	4112343	1973-06-10	1973-06-10 00:00:00	1973-06-21	1973-06-21 00:00:00	32020		\N	82903	0	195662009	4112343		0
21212	1273	4112343	1980-10-11	1980-10-11 00:00:00	1980-10-24	1980-10-24 00:00:00	32020		\N	84019	0	195662009	4112343		0
10652	625	372328	1975-05-24	1975-05-24 00:00:00	1975-11-11	1975-11-11 00:00:00	32020		\N	41738	0	65363002	372328		0
10865	644	40481087	2006-01-21	2006-01-21 00:00:00	2006-01-28	2006-01-28 00:00:00	32020		\N	42614	0	444814009	40481087		0
11059	652	372328	1969-08-06	1969-08-06 00:00:00	1970-01-20	1970-01-20 00:00:00	32020		\N	43144	0	65363002	372328		0
11243	664	260139	1987-09-07	1987-09-07 00:00:00	1987-09-14	1987-09-14 00:00:00	32020		\N	43802	0	10509002	260139		0
11351	670	80180	2017-05-11	2017-05-11 00:00:00	\N	\N	32020		\N	44241	0	396275006	80180		0
11614	686	4112343	1967-09-21	1967-09-21 00:00:00	1967-10-04	1967-10-04 00:00:00	32020		\N	45439	0	195662009	4112343		0
11684	689	4112343	2009-04-29	2009-04-29 00:00:00	2009-05-12	2009-05-12 00:00:00	32020		\N	45614	0	195662009	4112343		0
11881	703	4112343	1981-07-25	1981-07-25 00:00:00	1981-08-04	1981-08-04 00:00:00	32020		\N	46440	0	195662009	4112343		0
12029	711	81151	1983-06-09	1983-06-09 00:00:00	1983-07-07	1983-07-07 00:00:00	32020		\N	47198	0	44465007	81151		0
12229	723	81151	1990-09-02	1990-09-02 00:00:00	1990-09-23	1990-09-23 00:00:00	32020		\N	47806	0	44465007	81151		0
12329	728	4112343	1994-04-26	1994-04-26 00:00:00	1994-05-05	1994-05-05 00:00:00	32020		\N	48341	0	195662009	4112343		0
12517	741	4134304	1977-12-13	1977-12-13 00:00:00	1978-01-12	1978-01-12 00:00:00	32020		\N	49040	0	263102004	4134304		0
12720	753	30753	2005-01-07	2005-01-07 00:00:00	\N	\N	32020		\N	49757	0	16761005	30753		0
12891	759	28060	1980-08-22	1980-08-22 00:00:00	1980-09-02	1980-09-02 00:00:00	32020		\N	50445	0	43878008	28060		0
13000	763	40481087	1982-06-23	1982-06-23 00:00:00	1982-07-14	1982-07-14 00:00:00	32020		\N	50749	0	444814009	40481087		0
13194	776	4112343	1981-10-03	1981-10-03 00:00:00	1981-10-11	1981-10-11 00:00:00	32020		\N	51527	0	195662009	4112343		0
13335	784	4112343	1959-10-01	1959-10-01 00:00:00	1959-10-10	1959-10-10 00:00:00	32020		\N	52241	0	195662009	4112343		0
13570	800	4112343	1979-02-05	1979-02-05 00:00:00	1979-02-13	1979-02-13 00:00:00	32020		\N	53119	0	195662009	4112343		0
13683	807	260139	1973-11-17	1973-11-17 00:00:00	1973-11-24	1973-11-24 00:00:00	32020		\N	53624	0	10509002	260139		0
13823	817	40481087	2004-08-01	2004-08-01 00:00:00	2004-08-15	2004-08-15 00:00:00	32020		\N	54148	0	444814009	40481087		0
13987	825	40481087	2003-09-14	2003-09-14 00:00:00	2003-10-05	2003-10-05 00:00:00	32020		\N	54693	0	444814009	40481087		0
14248	842	260139	2011-07-13	2011-07-13 00:00:00	2011-07-20	2011-07-20 00:00:00	32020		\N	55606	0	10509002	260139		0
14343	847	192671	2011-06-26	2011-06-26 00:00:00	\N	\N	32020		\N	56120	0	K92.2	35208414		0
14520	859	40481087	2005-07-01	2005-07-01 00:00:00	2005-07-22	2005-07-22 00:00:00	32020		\N	56784	0	444814009	40481087		0
14677	865	372328	1974-03-31	1974-03-31 00:00:00	1975-08-13	1975-08-13 00:00:00	32020		\N	57374	0	65363002	372328		0
14898	877	4294548	1982-12-11	1982-12-11 00:00:00	1983-01-08	1983-01-08 00:00:00	32020		\N	58445	0	75498004	4294548		0
15041	886	4112343	1998-04-17	1998-04-17 00:00:00	1998-04-28	1998-04-28 00:00:00	32020		\N	59081	0	195662009	4112343		0
15231	902	4112343	1957-07-06	1957-07-06 00:00:00	1957-07-15	1957-07-15 00:00:00	32020		\N	60002	0	195662009	4112343		0
15380	911	40481087	1983-05-08	1983-05-08 00:00:00	1983-05-15	1983-05-15 00:00:00	32020		\N	60461	0	444814009	40481087		0
15505	918	4218389	1989-03-07	1989-03-07 00:00:00	1989-04-04	1989-04-04 00:00:00	32020		\N	61202	0	39848009	4218389		0
15700	929	4112343	1958-12-25	1958-12-25 00:00:00	1959-01-07	1959-01-07 00:00:00	32020		\N	61807	0	195662009	4112343		0
15820	936	4027663	1992-10-20	1992-10-20 00:00:00	\N	\N	32020		\N	62265	0	13200003	4027663		0
16036	949	40481087	2018-01-13	2018-01-13 00:00:00	2018-01-27	2018-01-27 00:00:00	32020		\N	63061	0	444814009	40481087		0
16204	958	4112343	1969-05-06	1969-05-06 00:00:00	1969-05-15	1969-05-15 00:00:00	32020		\N	63591	0	195662009	4112343		0
16337	967	260139	2018-03-08	2018-03-08 00:00:00	2018-03-22	2018-03-22 00:00:00	32020		\N	64366	0	10509002	260139		0
16479	973	40481087	1965-10-11	1965-10-11 00:00:00	1965-10-25	1965-10-25 00:00:00	32020		\N	64834	0	444814009	40481087		0
16718	992	260139	1987-07-01	1987-07-01 00:00:00	1987-07-15	1987-07-15 00:00:00	32020		\N	65771	0	10509002	260139		0
16854	1000	4237458	1964-11-03	1964-11-03 00:00:00	1964-12-03	1964-12-03 00:00:00	32020		\N	66135	0	58150001	4237458		0
17017	1017	4155034	1984-10-17	1984-10-17 00:00:00	1984-11-07	1984-11-07 00:00:00	32020		\N	67003	0	283371005	4155034		0
17256	1033	81151	1995-02-05	1995-02-05 00:00:00	1995-03-05	1995-03-05 00:00:00	32020		\N	67969	0	44465007	81151		0
17425	1046	195588	2009-04-29	2009-04-29 00:00:00	2009-06-18	2009-06-18 00:00:00	32020		\N	68704	0	38822007	195588		0
17515	1053	260139	1978-08-19	1978-08-19 00:00:00	1978-09-02	1978-09-02 00:00:00	32020		\N	69044	0	10509002	260139		0
17638	1058	81151	1996-07-20	1996-07-20 00:00:00	1996-08-10	1996-08-10 00:00:00	32020		\N	69404	0	44465007	81151		0
17898	1076	4278672	1980-10-01	1980-10-01 00:00:00	1980-12-30	1980-12-30 00:00:00	32020		\N	70552	0	65966004	4278672		0
17998	1082	4109685	2018-07-20	2018-07-20 00:00:00	2018-08-10	2018-08-10 00:00:00	32020		\N	71053	0	284551006	4109685		0
18178	1092	4112343	1970-11-11	1970-11-11 00:00:00	1970-11-23	1970-11-23 00:00:00	32020		\N	71756	0	195662009	4112343		0
18293	1099	4027663	1982-04-05	1982-04-05 00:00:00	\N	\N	32020		\N	72193	0	13200003	4027663		0
18503	1113	40481087	1978-04-17	1978-04-17 00:00:00	1978-04-24	1978-04-24 00:00:00	32020		\N	73279	0	444814009	40481087		0
18667	1123	4112343	1971-05-29	1971-05-29 00:00:00	1971-06-05	1971-06-05 00:00:00	32020		\N	73977	0	195662009	4112343		0
18846	1133	4142905	1973-10-25	1973-10-25 00:00:00	1973-12-24	1973-12-24 00:00:00	32020		\N	74584	0	33737001	4142905		0
19014	1143	4237458	1976-01-02	1976-01-02 00:00:00	1976-03-02	1976-03-02 00:00:00	32020		\N	75454	0	58150001	4237458		0
19160	1148	28060	1958-08-17	1958-08-17 00:00:00	1958-08-24	1958-08-24 00:00:00	32020		\N	75886	0	43878008	28060		0
19349	1159	372328	1980-09-24	1980-09-24 00:00:00	1980-11-01	1980-11-01 00:00:00	32020		\N	76559	0	65363002	372328		0
30053	1778	40481087	1984-01-02	1984-01-02 00:00:00	1984-01-09	1984-01-09 00:00:00	32020		\N	118954	0	444814009	40481087		0
19686	1180	4112343	2008-10-21	2008-10-21 00:00:00	2008-10-28	2008-10-28 00:00:00	32020		\N	77936	0	195662009	4112343		0
30384	1793	260139	1932-07-29	1932-07-29 00:00:00	1932-08-12	1932-08-12 00:00:00	32020		\N	120238	0	10509002	260139		0
20014	1206	260139	2011-03-11	2011-03-11 00:00:00	2011-03-18	2011-03-18 00:00:00	32020		\N	79241	0	10509002	260139		0
20200	1215	381316	1993-05-08	1993-05-08 00:00:00	\N	\N	32020		\N	80045	0	230690007	381316		0
20309	1222	40481087	1954-12-21	1954-12-21 00:00:00	1954-12-28	1954-12-28 00:00:00	32020		\N	80359	0	444814009	40481087		0
20511	1232	4112343	1983-05-27	1983-05-27 00:00:00	1983-06-04	1983-06-04 00:00:00	32020		\N	81219	0	195662009	4112343		0
20698	1245	378001	1999-10-25	1999-10-25 00:00:00	1999-12-24	1999-12-24 00:00:00	32020		\N	81903	0	62106007	378001		0
20823	1250	260139	1961-06-11	1961-06-11 00:00:00	1961-06-18	1961-06-18 00:00:00	32020		\N	82328	0	10509002	260139		0
20967	1258	4112343	1991-02-21	1991-02-21 00:00:00	1991-03-06	1991-03-06 00:00:00	32020		\N	82864	0	195662009	4112343		0
21213	1273	78272	1974-04-20	1974-04-20 00:00:00	1974-05-18	1974-05-18 00:00:00	32020		\N	84070	0	70704007	78272		0
10653	625	28060	1979-04-07	1979-04-07 00:00:00	1979-04-15	1979-04-15 00:00:00	32020		\N	41774	0	43878008	28060		0
10866	644	40481087	1996-02-22	1996-02-22 00:00:00	1996-03-07	1996-03-07 00:00:00	32020		\N	42635	0	444814009	40481087		0
11060	653	4112343	1978-03-13	1978-03-13 00:00:00	1978-03-24	1978-03-24 00:00:00	32020		\N	43255	0	195662009	4112343		0
11244	664	372328	1997-10-30	1997-10-30 00:00:00	1998-08-27	1998-08-27 00:00:00	32020		\N	43823	0	65363002	372328		0
11352	670	372328	1974-07-01	1974-07-01 00:00:00	1974-10-12	1974-10-12 00:00:00	32020		\N	44205	0	65363002	372328		0
11615	686	40481087	1960-10-13	1960-10-13 00:00:00	1960-10-20	1960-10-20 00:00:00	32020		\N	45377	0	444814009	40481087		0
11685	689	4059173	1997-05-31	1997-05-31 00:00:00	1997-07-30	1997-07-30 00:00:00	32020		\N	45624	0	16114001	4059173		0
11882	703	81151	1974-04-16	1974-04-16 00:00:00	1974-05-21	1974-05-21 00:00:00	32020		\N	46509	0	44465007	81151		0
12030	711	40481087	1970-04-06	1970-04-06 00:00:00	1970-04-27	1970-04-27 00:00:00	32020		\N	47152	0	444814009	40481087		0
12230	723	4112343	2014-02-25	2014-02-25 00:00:00	2014-03-09	2014-03-09 00:00:00	32020		\N	47836	0	195662009	4112343		0
12330	728	40481087	1965-06-05	1965-06-05 00:00:00	1965-06-19	1965-06-19 00:00:00	32020		\N	48296	0	444814009	40481087		0
12518	741	80180	2011-07-08	2011-07-08 00:00:00	\N	\N	32020		\N	49098	0	396275006	80180		0
12721	753	81893	2004-05-12	2004-05-12 00:00:00	\N	\N	32020		\N	49757	0	64766004	81893		0
12892	759	40481087	1969-07-14	1969-07-14 00:00:00	1969-07-21	1969-07-21 00:00:00	32020		\N	50427	0	444814009	40481087		0
13001	763	260139	1990-05-17	1990-05-17 00:00:00	1990-05-24	1990-05-24 00:00:00	32020		\N	50743	0	10509002	260139		0
13195	776	4116491	1995-09-02	1995-09-02 00:00:00	1995-10-11	1995-10-11 00:00:00	32020		\N	51522	0	301011002	4116491		0
13336	784	4112343	1972-09-03	1972-09-03 00:00:00	1972-09-11	1972-09-11 00:00:00	32020		\N	52220	0	195662009	4112343		0
24071	1435	40481087	1969-07-03	1969-07-03 00:00:00	1969-07-10	1969-07-10 00:00:00	32020		\N	95538	0	444814009	40481087		0
13684	807	440448	1971-01-13	1971-01-13 00:00:00	\N	\N	32020		\N	53544	0	74400008	440448		0
13824	817	40481087	1971-09-30	1971-09-30 00:00:00	1971-10-21	1971-10-21 00:00:00	32020		\N	54090	0	444814009	40481087		0
13988	825	260139	1976-02-05	1976-02-05 00:00:00	1976-02-19	1976-02-19 00:00:00	32020		\N	54626	0	10509002	260139		0
14249	842	258780	1947-04-12	1947-04-12 00:00:00	\N	\N	32020		\N	55726	0	185086009	258780		0
14344	847	40481087	1998-03-03	1998-03-03 00:00:00	1998-03-24	1998-03-24 00:00:00	32020		\N	56145	0	444814009	40481087		0
14521	859	40481087	2018-12-17	2018-12-17 00:00:00	2018-12-31	2018-12-31 00:00:00	32020		\N	56797	0	444814009	40481087		0
14678	865	81151	1983-01-13	1983-01-13 00:00:00	1983-02-03	1983-02-03 00:00:00	32020		\N	57367	0	44465007	81151		0
14899	877	4113008	1992-05-28	1992-05-28 00:00:00	1992-06-11	1992-06-11 00:00:00	32020		\N	58440	0	284549007	4113008		0
15042	886	378001	1993-07-25	1993-07-25 00:00:00	1993-08-24	1993-08-24 00:00:00	32020		\N	59075	0	62106007	378001		0
15232	902	317576	2011-05-21	2011-05-21 00:00:00	\N	\N	32020		\N	60045	0	53741008	317576		0
15381	911	40481087	2005-10-02	2005-10-02 00:00:00	2005-10-16	2005-10-16 00:00:00	32020		\N	60492	0	444814009	40481087		0
15506	918	81151	2008-05-20	2008-05-20 00:00:00	2008-06-03	2008-06-03 00:00:00	32020		\N	61205	0	44465007	81151		0
15701	929	372328	1924-08-15	1924-08-15 00:00:00	1925-07-27	1925-07-27 00:00:00	32020		\N	61762	0	65363002	372328		0
15821	936	4112343	1992-03-16	1992-03-16 00:00:00	1992-03-29	1992-03-29 00:00:00	32020		\N	62265	0	195662009	4112343		0
16037	949	4237458	1974-07-05	1974-07-05 00:00:00	1974-10-03	1974-10-03 00:00:00	32020		\N	63022	0	58150001	4237458		0
16205	958	257012	2014-07-15	2014-07-15 00:00:00	\N	\N	32020		\N	63602	0	40055000	257012		0
16338	967	4294548	1993-12-26	1993-12-26 00:00:00	1994-05-01	1994-05-01 00:00:00	32020		\N	64275	0	75498004	4294548		0
16480	973	372328	1918-11-24	1918-11-24 00:00:00	1919-04-28	1919-04-28 00:00:00	32020		\N	64774	0	65363002	372328		0
16719	992	4112343	1993-08-24	1993-08-24 00:00:00	1993-09-05	1993-09-05 00:00:00	32020		\N	65778	0	195662009	4112343		0
16855	1000	4112343	1989-08-10	1989-08-10 00:00:00	1989-08-17	1989-08-17 00:00:00	32020		\N	66200	0	195662009	4112343		0
17018	1017	4112343	2018-08-26	2018-08-26 00:00:00	2018-09-03	2018-09-03 00:00:00	32020		\N	66981	0	195662009	4112343		0
17257	1033	40481087	2004-04-03	2004-04-03 00:00:00	2004-04-17	2004-04-17 00:00:00	32020		\N	67974	0	444814009	40481087		0
17426	1046	4112343	2016-07-29	2016-07-29 00:00:00	2016-08-07	2016-08-07 00:00:00	32020		\N	68706	0	195662009	4112343		0
17516	1053	40481087	1995-03-24	1995-03-24 00:00:00	1995-04-14	1995-04-14 00:00:00	32020		\N	69048	0	444814009	40481087		0
17639	1058	257012	2018-03-09	2018-03-09 00:00:00	\N	\N	32020		\N	69407	0	40055000	257012		0
17899	1076	40481087	1984-09-27	1984-09-27 00:00:00	1984-10-04	1984-10-04 00:00:00	32020		\N	70547	0	444814009	40481087		0
17999	1082	372328	1956-08-25	1956-08-25 00:00:00	1956-10-27	1956-10-27 00:00:00	32020		\N	70968	0	65363002	372328		0
18179	1092	28060	1959-08-21	1959-08-21 00:00:00	1959-08-29	1959-08-29 00:00:00	32020		\N	71755	0	43878008	28060		0
18294	1099	260139	1968-05-05	1968-05-05 00:00:00	1968-05-12	1968-05-12 00:00:00	32020		\N	72108	0	10509002	260139		0
18504	1113	28060	1976-05-27	1976-05-27 00:00:00	1976-06-04	1976-06-04 00:00:00	32020		\N	73255	0	43878008	28060		0
18668	1123	372328	1970-01-26	1970-01-26 00:00:00	1970-05-07	1970-05-07 00:00:00	32020		\N	74016	0	65363002	372328		0
18847	1133	40481087	2018-09-23	2018-09-23 00:00:00	2018-09-30	2018-09-30 00:00:00	32020		\N	74609	0	444814009	40481087		0
19015	1143	257012	1982-02-21	1982-02-21 00:00:00	\N	\N	32020		\N	75438	0	40055000	257012		0
19161	1148	4112343	1978-05-23	1978-05-23 00:00:00	1978-06-05	1978-06-05 00:00:00	32020		\N	75887	0	195662009	4112343		0
19350	1159	4112343	2002-09-02	2002-09-02 00:00:00	2002-09-10	2002-09-10 00:00:00	32020		\N	76580	0	195662009	4112343		0
30054	1778	4112343	1998-01-29	1998-01-29 00:00:00	1998-02-06	1998-02-06 00:00:00	32020		\N	118956	0	195662009	4112343		0
19687	1180	80180	1990-05-23	1990-05-23 00:00:00	\N	\N	32020		\N	77925	0	396275006	80180		0
30385	1793	260139	2002-10-14	2002-10-14 00:00:00	2002-10-28	2002-10-28 00:00:00	32020		\N	120251	0	10509002	260139		0
20015	1206	260139	1979-11-19	1979-11-19 00:00:00	1979-11-26	1979-11-26 00:00:00	32020		\N	79245	0	10509002	260139		0
20201	1215	4112343	1996-11-21	1996-11-21 00:00:00	1996-12-01	1996-12-01 00:00:00	32020		\N	80010	0	195662009	4112343		0
20310	1222	260139	1969-06-04	1969-06-04 00:00:00	1969-06-11	1969-06-11 00:00:00	32020		\N	80432	0	10509002	260139		0
20512	1232	260139	1969-08-21	1969-08-21 00:00:00	1969-09-04	1969-09-04 00:00:00	32020		\N	81179	0	10509002	260139		0
20699	1245	372328	1935-10-02	1935-10-02 00:00:00	1935-11-15	1935-11-15 00:00:00	32020		\N	81945	0	65363002	372328		0
20824	1250	260139	1997-10-03	1997-10-03 00:00:00	1997-10-17	1997-10-17 00:00:00	32020		\N	82375	0	10509002	260139		0
20968	1258	40481087	1982-10-16	1982-10-16 00:00:00	1982-10-23	1982-10-23 00:00:00	32020		\N	82888	0	444814009	40481087		0
21214	1273	40481087	1973-11-27	1973-11-27 00:00:00	1973-12-18	1973-12-18 00:00:00	32020		\N	84063	0	444814009	40481087		0
10727	636	80180	1982-11-19	1982-11-19 00:00:00	\N	\N	32020		\N	42160	0	396275006	80180		0
10867	644	28060	1987-06-04	1987-06-04 00:00:00	1987-06-14	1987-06-14 00:00:00	32020		\N	42644	0	43878008	28060		0
11061	653	4112343	1979-06-21	1979-06-21 00:00:00	1979-07-02	1979-07-02 00:00:00	32020		\N	43220	0	195662009	4112343		0
11245	664	4112343	2017-07-02	2017-07-02 00:00:00	2017-07-13	2017-07-13 00:00:00	32020		\N	43859	0	195662009	4112343		0
11363	672	260139	1972-11-15	1972-11-15 00:00:00	1972-11-29	1972-11-29 00:00:00	32020		\N	44369	0	10509002	260139		0
11616	686	4112343	2007-01-05	2007-01-05 00:00:00	2007-01-17	2007-01-17 00:00:00	32020		\N	45419	0	195662009	4112343		0
11696	691	40481087	1984-07-12	1984-07-12 00:00:00	1984-07-19	1984-07-19 00:00:00	32020		\N	45776	0	444814009	40481087		0
11883	703	260139	2013-12-25	2013-12-25 00:00:00	2014-01-08	2014-01-08 00:00:00	32020		\N	46447	0	10509002	260139		0
12031	711	4112343	2012-10-07	2012-10-07 00:00:00	2012-10-18	2012-10-18 00:00:00	32020		\N	47203	0	195662009	4112343		0
12231	723	4113008	1984-10-19	1984-10-19 00:00:00	1984-11-02	1984-11-02 00:00:00	32020		\N	47805	0	284549007	4113008		0
12331	728	40481087	1969-05-08	1969-05-08 00:00:00	1969-05-22	1969-05-22 00:00:00	32020		\N	48297	0	444814009	40481087		0
12519	741	4112343	2010-07-05	2010-07-05 00:00:00	2010-07-18	2010-07-18 00:00:00	32020		\N	49098	0	195662009	4112343		0
12722	753	4112343	1976-02-26	1976-02-26 00:00:00	1976-03-08	1976-03-08 00:00:00	32020		\N	49812	0	195662009	4112343		0
12893	759	4152936	1992-09-19	1992-09-19 00:00:00	1992-10-03	1992-10-03 00:00:00	32020		\N	50361	0	283385000	4152936		0
13002	763	260139	2000-11-17	2000-11-17 00:00:00	2000-12-01	2000-12-01 00:00:00	32020		\N	50745	0	10509002	260139		0
13196	776	4294548	1979-03-30	1979-03-30 00:00:00	1979-08-31	1979-08-31 00:00:00	32020		\N	51515	0	75498004	4294548		0
13337	784	40481087	1992-07-03	1992-07-03 00:00:00	1992-07-24	1992-07-24 00:00:00	32020		\N	52201	0	444814009	40481087		0
24072	1435	257012	1964-06-08	1964-06-08 00:00:00	\N	\N	32020		\N	95536	0	40055000	257012		0
13685	807	4230399	1991-10-25	1991-10-25 00:00:00	1991-12-24	1991-12-24 00:00:00	32020		\N	53545	0	359817006	4230399		0
13825	817	260139	2008-12-03	2008-12-03 00:00:00	2008-12-10	2008-12-10 00:00:00	32020		\N	54094	0	10509002	260139		0
13989	826	40481087	1958-09-24	1958-09-24 00:00:00	1958-10-08	1958-10-08 00:00:00	32020		\N	54711	0	444814009	40481087		0
14250	842	40481087	1925-06-18	1925-06-18 00:00:00	1925-06-25	1925-06-25 00:00:00	32020		\N	55652	0	444814009	40481087		0
14345	847	4027663	1999-03-31	1999-03-31 00:00:00	\N	\N	32020		\N	56145	0	13200003	4027663		0
14522	859	28060	1982-07-09	1982-07-09 00:00:00	1982-07-20	1982-07-20 00:00:00	32020		\N	56794	0	43878008	28060		0
14679	865	260139	1972-07-28	1972-07-28 00:00:00	1972-08-04	1972-08-04 00:00:00	32020		\N	57400	0	10509002	260139		0
14900	877	260139	1998-03-16	1998-03-16 00:00:00	1998-03-30	1998-03-30 00:00:00	32020		\N	58461	0	10509002	260139		0
15043	886	28060	1992-07-06	1992-07-06 00:00:00	1992-07-18	1992-07-18 00:00:00	32020		\N	59079	0	43878008	28060		0
15233	902	4152936	1965-03-10	1965-03-10 00:00:00	1965-03-31	1965-03-31 00:00:00	32020		\N	60066	0	283385000	4152936		0
15382	911	378001	2009-06-12	2009-06-12 00:00:00	2009-07-12	2009-07-12 00:00:00	32020		\N	60480	0	62106007	378001		0
15507	918	80180	1954-12-21	1954-12-21 00:00:00	\N	\N	32020		\N	61179	0	396275006	80180		0
15702	929	4112343	1937-06-19	1937-06-19 00:00:00	1937-07-02	1937-07-02 00:00:00	32020		\N	61821	0	195662009	4112343		0
15822	936	81151	2008-10-28	2008-10-28 00:00:00	2008-11-25	2008-11-25 00:00:00	32020		\N	62264	0	44465007	81151		0
16038	949	258780	1980-08-25	1980-08-25 00:00:00	\N	\N	32020		\N	63012	0	185086009	258780		0
16206	958	4112343	1975-06-17	1975-06-17 00:00:00	1975-06-24	1975-06-24 00:00:00	32020		\N	63595	0	195662009	4112343		0
16339	967	260139	1956-10-26	1956-10-26 00:00:00	1956-11-09	1956-11-09 00:00:00	32020		\N	64277	0	10509002	260139		0
16481	973	40481087	1932-01-10	1932-01-10 00:00:00	1932-01-31	1932-01-31 00:00:00	32020		\N	64831	0	444814009	40481087		0
16720	992	40481087	1997-11-15	1997-11-15 00:00:00	1997-12-06	1997-12-06 00:00:00	32020		\N	65772	0	444814009	40481087		0
16856	1000	257012	1964-10-30	1964-10-30 00:00:00	\N	\N	32020		\N	66191	0	40055000	257012		0
17019	1017	4112343	1995-11-19	1995-11-19 00:00:00	1995-11-29	1995-11-29 00:00:00	32020		\N	66930	0	195662009	4112343		0
17258	1033	80180	2007-07-17	2007-07-17 00:00:00	\N	\N	32020		\N	67983	0	396275006	80180		0
17427	1046	4294548	1995-11-14	1995-11-14 00:00:00	1996-03-12	1996-03-12 00:00:00	32020		\N	68679	0	75498004	4294548		0
17517	1053	378001	1996-10-09	1996-10-09 00:00:00	1996-11-08	1996-11-08 00:00:00	32020		\N	69041	0	62106007	378001		0
17640	1058	40481087	2001-06-25	2001-06-25 00:00:00	2001-07-02	2001-07-02 00:00:00	32020		\N	69342	0	444814009	40481087		0
17900	1077	40481087	1993-01-03	1993-01-03 00:00:00	1993-01-24	1993-01-24 00:00:00	32020		\N	70588	0	444814009	40481087		0
18000	1082	28060	1966-02-25	1966-02-25 00:00:00	1966-03-10	1966-03-10 00:00:00	32020		\N	70903	0	43878008	28060		0
18180	1092	40481087	1963-02-09	1963-02-09 00:00:00	1963-02-23	1963-02-23 00:00:00	32020		\N	71813	0	444814009	40481087		0
18295	1100	4113008	2011-11-17	2011-11-17 00:00:00	2011-12-08	2011-12-08 00:00:00	32020		\N	72277	0	284549007	4113008		0
18505	1113	4294548	2013-11-01	2013-11-01 00:00:00	2013-11-08	2013-11-08 00:00:00	32020		\N	73289	0	75498004	4294548		0
18669	1123	80180	2007-02-01	2007-02-01 00:00:00	\N	\N	32020		\N	73973	0	396275006	80180		0
18848	1133	4112343	1966-05-09	1966-05-09 00:00:00	1966-05-21	1966-05-21 00:00:00	32020		\N	74595	0	195662009	4112343		0
19016	1143	40481087	1989-05-16	1989-05-16 00:00:00	1989-06-06	1989-06-06 00:00:00	32020		\N	75446	0	444814009	40481087		0
19162	1148	372328	1958-09-15	1958-09-15 00:00:00	1958-11-22	1958-11-22 00:00:00	32020		\N	75875	0	65363002	372328		0
19351	1159	40481087	1997-07-26	1997-07-26 00:00:00	1997-08-16	1997-08-16 00:00:00	32020		\N	76554	0	444814009	40481087		0
30055	1779	4112343	1965-08-29	1965-08-29 00:00:00	1965-09-07	1965-09-07 00:00:00	32020		\N	119044	0	195662009	4112343		0
19688	1180	40481087	1989-10-27	1989-10-27 00:00:00	1989-11-10	1989-11-10 00:00:00	32020		\N	77925	0	444814009	40481087		0
30386	1793	260139	1955-01-06	1955-01-06 00:00:00	1955-01-20	1955-01-20 00:00:00	32020		\N	120179	0	10509002	260139		0
20016	1206	40481087	1969-11-20	1969-11-20 00:00:00	1969-12-11	1969-12-11 00:00:00	32020		\N	79230	0	444814009	40481087		0
20202	1215	80180	2009-04-19	2009-04-19 00:00:00	\N	\N	32020		\N	80060	0	396275006	80180		0
20311	1223	40481087	1968-08-06	1968-08-06 00:00:00	1968-08-20	1968-08-20 00:00:00	32020		\N	80451	0	444814009	40481087		0
20513	1232	40481087	1982-12-13	1982-12-13 00:00:00	1982-12-27	1982-12-27 00:00:00	32020		\N	81169	0	444814009	40481087		0
20700	1245	4112343	1964-05-27	1964-05-27 00:00:00	1964-06-04	1964-06-04 00:00:00	32020		\N	81952	0	195662009	4112343		0
20825	1250	4112343	1986-01-31	1986-01-31 00:00:00	1986-02-11	1986-02-11 00:00:00	32020		\N	82320	0	195662009	4112343		0
20969	1258	40481087	2009-01-07	2009-01-07 00:00:00	2009-01-28	2009-01-28 00:00:00	32020		\N	82889	0	444814009	40481087		0
21215	1273	260139	1941-09-13	1941-09-13 00:00:00	1941-09-20	1941-09-20 00:00:00	32020		\N	84061	0	10509002	260139		0
10728	636	40481087	1981-03-14	1981-03-14 00:00:00	1981-03-21	1981-03-21 00:00:00	32020		\N	42160	0	444814009	40481087		0
10868	644	260139	1989-06-02	1989-06-02 00:00:00	1989-06-09	1989-06-09 00:00:00	32020		\N	42612	0	10509002	260139		0
11062	653	40481087	1987-10-07	1987-10-07 00:00:00	1987-10-21	1987-10-21 00:00:00	32020		\N	43222	0	444814009	40481087		0
11246	664	4296204	2006-07-03	2006-07-03 00:00:00	2006-07-24	2006-07-24 00:00:00	32020		\N	43890	0	403190006	4296204		0
11364	672	40481087	1985-05-16	1985-05-16 00:00:00	1985-05-23	1985-05-23 00:00:00	32020		\N	44338	0	444814009	40481087		0
11617	686	372328	1971-03-17	1971-03-17 00:00:00	1974-01-19	1974-01-19 00:00:00	32020		\N	45441	0	65363002	372328		0
11697	691	260139	1993-08-17	1993-08-17 00:00:00	1993-08-31	1993-08-31 00:00:00	32020		\N	45780	0	10509002	260139		0
11884	703	40481087	1964-08-01	1964-08-01 00:00:00	1964-08-15	1964-08-15 00:00:00	32020		\N	46435	0	444814009	40481087		0
12032	711	80180	1991-06-30	1991-06-30 00:00:00	\N	\N	32020		\N	47149	0	396275006	80180		0
12232	723	40481087	1966-10-17	1966-10-17 00:00:00	1966-10-31	1966-10-31 00:00:00	32020		\N	47833	0	444814009	40481087		0
12332	728	4156265	1993-06-29	1993-06-29 00:00:00	1993-07-20	1993-07-20 00:00:00	32020		\N	48313	0	370247008	4156265		0
12520	741	257012	1982-05-06	1982-05-06 00:00:00	\N	\N	32020		\N	49035	0	40055000	257012		0
12723	753	260139	1973-02-25	1973-02-25 00:00:00	1973-03-04	1973-03-04 00:00:00	32020		\N	49810	0	10509002	260139		0
12894	759	260139	1982-12-30	1982-12-30 00:00:00	1983-01-13	1983-01-13 00:00:00	32020		\N	50392	0	10509002	260139		0
13003	763	28060	1991-12-12	1991-12-12 00:00:00	1991-12-21	1991-12-21 00:00:00	32020		\N	50751	0	43878008	28060		0
13197	776	4156265	2003-02-01	2003-02-01 00:00:00	2003-02-15	2003-02-15 00:00:00	32020		\N	51571	0	370247008	4156265		0
13338	784	260139	1979-01-17	1979-01-17 00:00:00	1979-01-24	1979-01-24 00:00:00	32020		\N	52200	0	10509002	260139		0
24100	1438	260139	1952-04-19	1952-04-19 00:00:00	1952-05-03	1952-05-03 00:00:00	32020		\N	95801	0	10509002	260139		0
13686	807	192671	1994-11-04	1994-11-04 00:00:00	\N	\N	32020		\N	53556	0	K92.2	35208414		0
13826	817	81893	1997-05-01	1997-05-01 00:00:00	\N	\N	32020		\N	54155	0	64766004	81893		0
13990	826	40481087	1990-07-20	1990-07-20 00:00:00	1990-08-03	1990-08-03 00:00:00	32020		\N	54704	0	444814009	40481087		0
14251	842	260139	1988-05-10	1988-05-10 00:00:00	1988-05-17	1988-05-17 00:00:00	32020		\N	55714	0	10509002	260139		0
14346	847	28060	2008-05-22	2008-05-22 00:00:00	2008-05-29	2008-05-29 00:00:00	32020		\N	56099	0	43878008	28060		0
14523	859	81151	1969-01-28	1969-01-28 00:00:00	1969-02-25	1969-02-25 00:00:00	32020		\N	56715	0	44465007	81151		0
14680	865	40481087	2006-05-17	2006-05-17 00:00:00	2006-05-31	2006-05-31 00:00:00	32020		\N	57373	0	444814009	40481087		0
14901	877	4112343	2004-06-07	2004-06-07 00:00:00	2004-06-19	2004-06-19 00:00:00	32020		\N	58410	0	195662009	4112343		0
15044	886	260139	2016-02-17	2016-02-17 00:00:00	2016-02-26	2016-02-26 00:00:00	32020		\N	59053	0	10509002	260139		0
15234	902	40481087	1956-12-01	1956-12-01 00:00:00	1956-12-08	1956-12-08 00:00:00	32020		\N	60013	0	444814009	40481087		0
15383	911	40481087	1984-11-13	1984-11-13 00:00:00	1984-11-27	1984-11-27 00:00:00	32020		\N	60473	0	444814009	40481087		0
15508	918	40481087	1923-02-24	1923-02-24 00:00:00	1923-03-17	1923-03-17 00:00:00	32020		\N	61135	0	444814009	40481087		0
15703	929	40481087	1919-11-10	1919-11-10 00:00:00	1919-11-17	1919-11-17 00:00:00	32020		\N	61843	0	444814009	40481087		0
15823	936	40481087	1971-10-09	1971-10-09 00:00:00	1971-10-23	1971-10-23 00:00:00	32020		\N	62278	0	444814009	40481087		0
16039	949	4112343	1975-03-01	1975-03-01 00:00:00	1975-03-10	1975-03-10 00:00:00	32020		\N	63025	0	195662009	4112343		0
16207	958	40481087	1994-02-14	1994-02-14 00:00:00	1994-02-21	1994-02-21 00:00:00	32020		\N	63636	0	444814009	40481087		0
16340	967	40481087	1992-06-16	1992-06-16 00:00:00	1992-06-30	1992-06-30 00:00:00	32020		\N	64304	0	444814009	40481087		0
16482	973	260139	1962-12-29	1962-12-29 00:00:00	1963-01-12	1963-01-12 00:00:00	32020		\N	64865	0	10509002	260139		0
16721	992	40481087	1971-08-19	1971-08-19 00:00:00	1971-08-26	1971-08-26 00:00:00	32020		\N	65765	0	444814009	40481087		0
16857	1000	81151	1995-02-08	1995-02-08 00:00:00	1995-03-08	1995-03-08 00:00:00	32020		\N	66140	0	44465007	81151		0
17020	1017	372328	1976-10-25	1976-10-25 00:00:00	1977-04-24	1977-04-24 00:00:00	32020		\N	66982	0	65363002	372328		0
17259	1033	28060	1983-03-31	1983-03-31 00:00:00	1983-04-13	1983-04-13 00:00:00	32020		\N	67987	0	43878008	28060		0
17428	1046	260139	2000-03-17	2000-03-17 00:00:00	2000-03-31	2000-03-31 00:00:00	32020		\N	68677	0	10509002	260139		0
17518	1053	372328	1976-06-28	1976-06-28 00:00:00	1976-07-12	1976-07-12 00:00:00	32020		\N	69052	0	65363002	372328		0
17641	1058	378001	1961-02-24	1961-02-24 00:00:00	1961-04-25	1961-04-25 00:00:00	32020		\N	69403	0	62106007	378001		0
17901	1077	40481087	2012-06-01	2012-06-01 00:00:00	2012-06-22	2012-06-22 00:00:00	32020		\N	70643	0	444814009	40481087		0
18001	1082	372328	1955-12-18	1955-12-18 00:00:00	1956-01-28	1956-01-28 00:00:00	32020		\N	71022	0	65363002	372328		0
18181	1092	40481087	1995-05-27	1995-05-27 00:00:00	1995-06-10	1995-06-10 00:00:00	32020		\N	71785	0	444814009	40481087		0
18296	1100	4237458	2004-02-20	2004-02-20 00:00:00	2004-04-20	2004-04-20 00:00:00	32020		\N	72275	0	58150001	4237458		0
18506	1113	40481087	2015-10-25	2015-10-25 00:00:00	2015-11-01	2015-11-01 00:00:00	32020		\N	73291	0	444814009	40481087		0
18670	1123	4112343	1988-11-05	1988-11-05 00:00:00	1988-11-17	1988-11-17 00:00:00	32020		\N	73996	0	195662009	4112343		0
18849	1134	260139	1966-08-01	1966-08-01 00:00:00	1966-08-15	1966-08-15 00:00:00	32020		\N	74679	0	10509002	260139		0
19017	1143	260139	1990-04-24	1990-04-24 00:00:00	1990-05-08	1990-05-08 00:00:00	32020		\N	75447	0	10509002	260139		0
19163	1148	4166224	2010-06-10	2010-06-10 00:00:00	\N	\N	32020		\N	75934	0	47693006	4166224		0
19352	1159	40481087	1981-07-28	1981-07-28 00:00:00	1981-08-04	1981-08-04 00:00:00	32020		\N	76569	0	444814009	40481087		0
30056	1779	4112343	1975-11-02	1975-11-02 00:00:00	1975-11-11	1975-11-11 00:00:00	32020		\N	119074	0	195662009	4112343		0
19689	1180	260139	1961-03-18	1961-03-18 00:00:00	1961-03-25	1961-03-25 00:00:00	32020		\N	77894	0	10509002	260139		0
30387	1793	4112343	1919-10-06	1919-10-06 00:00:00	1919-10-19	1919-10-19 00:00:00	32020		\N	120248	0	195662009	4112343		0
20017	1206	4294548	2002-02-26	2002-02-26 00:00:00	2002-04-23	2002-04-23 00:00:00	32020		\N	79239	0	75498004	4294548		0
20203	1215	4112343	2008-08-31	2008-08-31 00:00:00	2008-09-07	2008-09-07 00:00:00	32020		\N	80060	0	195662009	4112343		0
20312	1223	260139	1982-08-20	1982-08-20 00:00:00	1982-08-27	1982-08-27 00:00:00	32020		\N	80454	0	10509002	260139		0
20514	1232	80180	2003-01-19	2003-01-19 00:00:00	\N	\N	32020		\N	81213	0	396275006	80180		0
20701	1245	260139	1948-11-11	1948-11-11 00:00:00	1948-11-25	1948-11-25 00:00:00	32020		\N	81937	0	10509002	260139		0
20826	1250	260139	1970-10-03	1970-10-03 00:00:00	1970-10-17	1970-10-17 00:00:00	32020		\N	82384	0	10509002	260139		0
20970	1258	40481087	2000-05-14	2000-05-14 00:00:00	2000-05-28	2000-05-28 00:00:00	32020		\N	82876	0	444814009	40481087		0
21216	1273	40481087	1952-12-20	1952-12-20 00:00:00	1953-01-10	1953-01-10 00:00:00	32020		\N	84015	0	444814009	40481087		0
10729	636	40481087	1957-08-27	1957-08-27 00:00:00	1957-09-17	1957-09-17 00:00:00	32020		\N	42154	0	444814009	40481087		0
10869	644	372328	1981-05-12	1981-05-12 00:00:00	1981-10-07	1981-10-07 00:00:00	32020		\N	42659	0	65363002	372328		0
11063	653	4112343	1962-04-13	1962-04-13 00:00:00	1962-04-21	1962-04-21 00:00:00	32020		\N	43252	0	195662009	4112343		0
11247	664	4112343	1985-03-22	1985-03-22 00:00:00	1985-04-03	1985-04-03 00:00:00	32020		\N	43803	0	195662009	4112343		0
11365	672	40481087	2002-05-25	2002-05-25 00:00:00	2002-06-01	2002-06-01 00:00:00	32020		\N	44395	0	444814009	40481087		0
11618	686	260139	1966-06-18	1966-06-18 00:00:00	1966-06-25	1966-06-25 00:00:00	32020		\N	45438	0	10509002	260139		0
11698	691	28060	1999-05-24	1999-05-24 00:00:00	1999-06-01	1999-06-01 00:00:00	32020		\N	45777	0	43878008	28060		0
11885	703	372328	1954-05-31	1954-05-31 00:00:00	1954-12-03	1954-12-03 00:00:00	32020		\N	46448	0	65363002	372328		0
12033	711	4112343	1978-05-01	1978-05-01 00:00:00	1978-05-13	1978-05-13 00:00:00	32020		\N	47142	0	195662009	4112343		0
12233	723	4112343	2018-02-20	2018-02-20 00:00:00	2018-03-05	2018-03-05 00:00:00	32020		\N	47837	0	195662009	4112343		0
12333	728	260139	1983-12-11	1983-12-11 00:00:00	1983-12-18	1983-12-18 00:00:00	32020		\N	48355	0	10509002	260139		0
12521	741	81151	1982-10-18	1982-10-18 00:00:00	1982-11-01	1982-11-01 00:00:00	32020		\N	49041	0	44465007	81151		0
12724	753	4156265	1997-08-31	1997-08-31 00:00:00	1997-09-14	1997-09-14 00:00:00	32020		\N	49817	0	370247008	4156265		0
12895	759	4059173	2016-11-17	2016-11-17 00:00:00	2017-01-16	2017-01-16 00:00:00	32020		\N	50364	0	16114001	4059173		0
13004	763	4156265	1995-04-24	1995-04-24 00:00:00	1995-05-15	1995-05-15 00:00:00	32020		\N	50734	0	370247008	4156265		0
13198	776	40481087	1964-05-09	1964-05-09 00:00:00	1964-05-23	1964-05-23 00:00:00	32020		\N	51517	0	444814009	40481087		0
13339	784	260139	1967-11-18	1967-11-18 00:00:00	1967-11-25	1967-11-25 00:00:00	32020		\N	52217	0	10509002	260139		0
24101	1438	40481087	1982-01-01	1982-01-01 00:00:00	1982-01-15	1982-01-15 00:00:00	32020		\N	95782	0	444814009	40481087		0
13687	807	78272	1998-04-21	1998-04-21 00:00:00	1998-05-12	1998-05-12 00:00:00	32020		\N	53546	0	70704007	78272		0
13827	817	81151	1961-12-21	1961-12-21 00:00:00	1962-01-18	1962-01-18 00:00:00	32020		\N	54107	0	44465007	81151		0
13991	826	80180	1991-06-29	1991-06-29 00:00:00	\N	\N	32020		\N	54704	0	396275006	80180		0
14252	842	260139	2009-01-17	2009-01-17 00:00:00	2009-01-24	2009-01-24 00:00:00	32020		\N	55648	0	10509002	260139		0
14347	847	40481087	1987-10-04	1987-10-04 00:00:00	1987-10-18	1987-10-18 00:00:00	32020		\N	56091	0	444814009	40481087		0
14524	859	260139	1971-07-09	1971-07-09 00:00:00	1971-07-23	1971-07-23 00:00:00	32020		\N	56897	0	10509002	260139		0
14681	866	80180	1998-01-17	1998-01-17 00:00:00	\N	\N	32020		\N	57506	0	396275006	80180		0
14902	877	260139	2014-07-22	2014-07-22 00:00:00	2014-07-29	2014-07-29 00:00:00	32020		\N	58384	0	10509002	260139		0
15045	886	40481087	1986-06-25	1986-06-25 00:00:00	1986-07-02	1986-07-02 00:00:00	32020		\N	59092	0	444814009	40481087		0
15235	902	28060	2006-04-11	2006-04-11 00:00:00	2006-04-19	2006-04-19 00:00:00	32020		\N	59986	0	43878008	28060		0
15384	911	4112343	2004-02-29	2004-02-29 00:00:00	2004-03-12	2004-03-12 00:00:00	32020		\N	60464	0	195662009	4112343		0
15509	918	4112343	1917-08-20	1917-08-20 00:00:00	1917-08-27	1917-08-27 00:00:00	32020		\N	61119	0	195662009	4112343		0
15704	929	4296205	1947-05-23	1947-05-23 00:00:00	1947-06-27	1947-06-27 00:00:00	32020		\N	61755	0	403191005	4296205		0
15824	936	260139	2010-09-23	2010-09-23 00:00:00	2010-09-30	2010-09-30 00:00:00	32020		\N	62288	0	10509002	260139		0
16040	949	260139	2018-05-06	2018-05-06 00:00:00	2018-05-20	2018-05-20 00:00:00	32020		\N	63045	0	10509002	260139		0
16208	958	28060	2012-12-07	2012-12-07 00:00:00	2012-12-16	2012-12-16 00:00:00	32020		\N	63646	0	43878008	28060		0
16341	967	40481087	1940-12-11	1940-12-11 00:00:00	1940-12-25	1940-12-25 00:00:00	32020		\N	64350	0	444814009	40481087		0
16483	973	4112343	1977-05-28	1977-05-28 00:00:00	1977-06-06	1977-06-06 00:00:00	32020		\N	64740	0	195662009	4112343		0
16722	992	4296204	2015-03-29	2015-03-29 00:00:00	2015-05-03	2015-05-03 00:00:00	32020		\N	65819	0	403190006	4296204		0
16890	1004	4112343	1999-11-04	1999-11-04 00:00:00	1999-11-15	1999-11-15 00:00:00	32020		\N	66359	0	195662009	4112343		0
17021	1017	78272	1962-12-21	1962-12-21 00:00:00	1963-01-11	1963-01-11 00:00:00	32020		\N	67001	0	70704007	78272		0
17260	1033	40481087	1979-07-12	1979-07-12 00:00:00	1979-08-02	1979-08-02 00:00:00	32020		\N	68009	0	444814009	40481087		0
17429	1046	40481087	1984-10-19	1984-10-19 00:00:00	1984-11-02	1984-11-02 00:00:00	32020		\N	68675	0	444814009	40481087		0
17519	1053	260139	2017-05-28	2017-05-28 00:00:00	2017-06-04	2017-06-04 00:00:00	32020		\N	69010	0	10509002	260139		0
17642	1058	260139	1960-07-30	1960-07-30 00:00:00	1960-08-13	1960-08-13 00:00:00	32020		\N	69381	0	10509002	260139		0
17902	1077	372328	1947-05-13	1947-05-13 00:00:00	1947-07-25	1947-07-25 00:00:00	32020		\N	70637	0	65363002	372328		0
18002	1082	4112343	2004-06-24	2004-06-24 00:00:00	2004-07-05	2004-07-05 00:00:00	32020		\N	70961	0	195662009	4112343		0
18182	1092	40479422	1997-03-13	1997-03-13 00:00:00	1997-05-19	1997-05-19 00:00:00	32020		\N	71800	0	444448004	40479422		0
20064	1209	80180	2014-01-17	2014-01-17 00:00:00	\N	\N	32020		\N	79419	0	396275006	80180		0
18297	1100	40481087	2009-05-20	2009-05-20 00:00:00	2009-05-27	2009-05-27 00:00:00	32020		\N	72280	0	444814009	40481087		0
18507	1113	4112343	1992-05-23	1992-05-23 00:00:00	1992-06-02	1992-06-02 00:00:00	32020		\N	73257	0	195662009	4112343		0
18671	1123	372328	1971-09-29	1971-09-29 00:00:00	1972-05-18	1972-05-18 00:00:00	32020		\N	74002	0	65363002	372328		0
18850	1134	4035415	1947-07-19	1947-07-19 00:00:00	1947-08-18	1947-08-18 00:00:00	32020		\N	74729	0	239720000	4035415		0
19018	1143	372328	1973-09-14	1973-09-14 00:00:00	1973-11-02	1973-11-02 00:00:00	32020		\N	75450	0	65363002	372328		0
19164	1148	440448	2010-06-10	2010-06-10 00:00:00	\N	\N	32020		\N	75934	0	74400008	440448		0
19353	1159	4237458	1982-03-18	1982-03-18 00:00:00	1982-04-17	1982-04-17 00:00:00	32020		\N	76596	0	58150001	4237458		0
30057	1779	81151	1994-02-01	1994-02-01 00:00:00	1994-02-22	1994-02-22 00:00:00	32020		\N	119008	0	44465007	81151		0
19690	1180	372328	1956-09-08	1956-09-08 00:00:00	1956-12-19	1956-12-19 00:00:00	32020		\N	77901	0	65363002	372328		0
30388	1793	40481087	1918-09-18	1918-09-18 00:00:00	1918-10-02	1918-10-02 00:00:00	32020		\N	120211	0	444814009	40481087		0
20018	1206	40481087	1980-10-20	1980-10-20 00:00:00	1980-11-10	1980-11-10 00:00:00	32020		\N	79236	0	444814009	40481087		0
20204	1215	40481087	1976-10-11	1976-10-11 00:00:00	1976-10-18	1976-10-18 00:00:00	32020		\N	80024	0	444814009	40481087		0
20313	1223	40481087	2007-05-22	2007-05-22 00:00:00	2007-06-12	2007-06-12 00:00:00	32020		\N	80518	0	444814009	40481087		0
20515	1232	260139	1991-10-04	1991-10-04 00:00:00	1991-10-11	1991-10-11 00:00:00	32020		\N	81220	0	10509002	260139		0
20702	1245	260139	1940-04-10	1940-04-10 00:00:00	1940-04-17	1940-04-17 00:00:00	32020		\N	81936	0	10509002	260139		0
20827	1250	40481087	2006-06-03	2006-06-03 00:00:00	2006-06-24	2006-06-24 00:00:00	32020		\N	82385	0	444814009	40481087		0
20971	1258	260139	1994-06-06	1994-06-06 00:00:00	1994-06-20	1994-06-20 00:00:00	32020		\N	82875	0	10509002	260139		0
21217	1273	260139	1969-04-28	1969-04-28 00:00:00	1969-05-12	1969-05-12 00:00:00	32020		\N	84016	0	10509002	260139		0
10730	636	260139	2013-07-14	2013-07-14 00:00:00	2013-07-28	2013-07-28 00:00:00	32020		\N	42184	0	10509002	260139		0
10870	644	260139	2015-10-11	2015-10-11 00:00:00	2015-10-25	2015-10-25 00:00:00	32020		\N	42615	0	10509002	260139		0
11064	653	4299128	1965-12-23	1965-12-23 00:00:00	1966-01-13	1966-01-13 00:00:00	32020		\N	43261	0	403192003	4299128		0
11248	664	134438	2010-07-09	2010-07-09 00:00:00	2011-03-12	2011-03-12 00:00:00	32020		\N	43918	0	40275004	134438		0
11366	672	4294548	2005-07-23	2005-07-23 00:00:00	2005-08-20	2005-08-20 00:00:00	32020		\N	44406	0	75498004	4294548		0
11619	686	4156265	1976-01-08	1976-01-08 00:00:00	1976-01-22	1976-01-22 00:00:00	32020		\N	45425	0	370247008	4156265		0
11699	691	81151	1971-07-20	1971-07-20 00:00:00	1971-08-03	1971-08-03 00:00:00	32020		\N	45786	0	44465007	81151		0
11886	703	4237458	1966-07-27	1966-07-27 00:00:00	1966-10-25	1966-10-25 00:00:00	32020		\N	46508	0	58150001	4237458		0
12034	711	4112343	1959-10-19	1959-10-19 00:00:00	1959-10-28	1959-10-28 00:00:00	32020		\N	47163	0	195662009	4112343		0
12234	723	78272	1961-10-06	1961-10-06 00:00:00	1961-10-20	1961-10-20 00:00:00	32020		\N	47803	0	70704007	78272		0
12334	728	4112343	2003-10-13	2003-10-13 00:00:00	2003-10-25	2003-10-25 00:00:00	32020		\N	48344	0	195662009	4112343		0
12522	741	40481087	1996-04-14	1996-04-14 00:00:00	1996-04-21	1996-04-21 00:00:00	32020		\N	49095	0	444814009	40481087		0
12725	753	4027663	1997-09-16	1997-09-16 00:00:00	\N	\N	32020		\N	49817	0	13200003	4027663		0
12896	759	4112343	1959-01-03	1959-01-03 00:00:00	1959-01-16	1959-01-16 00:00:00	32020		\N	50434	0	195662009	4112343		0
13005	763	4294548	1995-05-19	1995-05-19 00:00:00	1995-06-09	1995-06-09 00:00:00	32020		\N	50755	0	75498004	4294548		0
13199	776	40481087	2005-05-10	2005-05-10 00:00:00	2005-05-24	2005-05-24 00:00:00	32020		\N	51523	0	444814009	40481087		0
13340	784	4035415	1982-04-01	1982-04-01 00:00:00	1982-05-01	1982-05-01 00:00:00	32020		\N	52250	0	239720000	4035415		0
24102	1438	40481087	1955-08-19	1955-08-19 00:00:00	1955-08-26	1955-08-26 00:00:00	32020		\N	95803	0	444814009	40481087		0
13734	812	4112343	1994-12-03	1994-12-03 00:00:00	1994-12-11	1994-12-11 00:00:00	32020		\N	53836	0	195662009	4112343		0
13828	817	4237458	2007-01-27	2007-01-27 00:00:00	2007-04-27	2007-04-27 00:00:00	32020		\N	54110	0	58150001	4237458		0
13992	826	372328	1963-11-18	1963-11-18 00:00:00	1964-07-02	1964-07-02 00:00:00	32020		\N	54708	0	65363002	372328		0
14253	842	40481087	1937-01-20	1937-01-20 00:00:00	1937-02-03	1937-02-03 00:00:00	32020		\N	55637	0	444814009	40481087		0
14348	847	40481087	1975-07-28	1975-07-28 00:00:00	1975-08-04	1975-08-04 00:00:00	32020		\N	56090	0	444814009	40481087		0
14525	859	4112343	1996-09-08	1996-09-08 00:00:00	1996-09-21	1996-09-21 00:00:00	32020		\N	56814	0	195662009	4112343		0
14682	866	40481087	1989-02-14	1989-02-14 00:00:00	1989-03-07	1989-03-07 00:00:00	32020		\N	57467	0	444814009	40481087		0
14903	877	4278672	1984-12-06	1984-12-06 00:00:00	1985-01-05	1985-01-05 00:00:00	32020		\N	58439	0	65966004	4278672		0
15046	886	372328	1985-09-21	1985-09-21 00:00:00	1986-03-11	1986-03-11 00:00:00	32020		\N	59096	0	65363002	372328		0
15236	902	40481087	1981-10-26	1981-10-26 00:00:00	1981-11-02	1981-11-02 00:00:00	32020		\N	60005	0	444814009	40481087		0
15407	914	81151	1947-01-18	1947-01-18 00:00:00	1947-02-01	1947-02-01 00:00:00	32020		\N	60729	0	44465007	81151		0
15510	918	260139	2015-12-19	2015-12-19 00:00:00	2016-01-02	2016-01-02 00:00:00	32020		\N	61142	0	10509002	260139		0
15705	929	4112343	1979-01-09	1979-01-09 00:00:00	1979-01-21	1979-01-21 00:00:00	32020		\N	61825	0	195662009	4112343		0
15825	936	40481087	2000-03-21	2000-03-21 00:00:00	2000-04-04	2000-04-04 00:00:00	32020		\N	62250	0	444814009	40481087		0
16041	949	260139	1959-11-09	1959-11-09 00:00:00	1959-11-16	1959-11-16 00:00:00	32020		\N	62985	0	10509002	260139		0
16209	958	4294548	2014-06-03	2014-06-03 00:00:00	2014-08-05	2014-08-05 00:00:00	32020		\N	63647	0	75498004	4294548		0
16342	967	257012	1983-08-18	1983-08-18 00:00:00	\N	\N	32020		\N	64273	0	40055000	257012		0
16484	973	80502	1994-09-12	1994-09-12 00:00:00	\N	\N	32020		\N	64851	0	64859006	80502		0
16723	992	4112343	2000-07-04	2000-07-04 00:00:00	2000-07-11	2000-07-11 00:00:00	32020		\N	65787	0	195662009	4112343		0
16891	1004	260139	1974-02-02	1974-02-02 00:00:00	1974-02-16	1974-02-16 00:00:00	32020		\N	66380	0	10509002	260139		0
17022	1017	4112343	1961-04-02	1961-04-02 00:00:00	1961-04-13	1961-04-13 00:00:00	32020		\N	66936	0	195662009	4112343		0
17261	1033	4278672	1980-12-20	1980-12-20 00:00:00	1981-03-20	1981-03-20 00:00:00	32020		\N	67968	0	65966004	4278672		0
17430	1046	40481087	1987-09-25	1987-09-25 00:00:00	1987-10-02	1987-10-02 00:00:00	32020		\N	68678	0	444814009	40481087		0
17520	1053	28060	1981-02-04	1981-02-04 00:00:00	1981-02-13	1981-02-13 00:00:00	32020		\N	69045	0	43878008	28060		0
17643	1058	4283893	2018-01-26	2018-01-26 00:00:00	2018-05-04	2018-05-04 00:00:00	32020		\N	69431	0	36971009	4283893		0
17903	1077	40481087	1953-10-13	1953-10-13 00:00:00	1953-10-27	1953-10-27 00:00:00	32020		\N	70601	0	444814009	40481087		0
18003	1082	4132546	1960-11-21	1960-11-21 00:00:00	\N	\N	32020		\N	71051	0	275272006	4166590		0
18183	1092	40481087	1994-01-13	1994-01-13 00:00:00	1994-01-27	1994-01-27 00:00:00	32020		\N	71753	0	444814009	40481087		0
18298	1100	78272	1995-04-24	1995-04-24 00:00:00	1995-05-08	1995-05-08 00:00:00	32020		\N	72273	0	70704007	78272		0
18508	1113	372328	1971-12-16	1971-12-16 00:00:00	1972-02-22	1972-02-22 00:00:00	32020		\N	73241	0	65363002	372328		0
18672	1123	81151	1974-11-06	1974-11-06 00:00:00	1974-11-27	1974-11-27 00:00:00	32020		\N	73968	0	44465007	81151		0
18851	1134	4283893	1993-05-25	1993-05-25 00:00:00	1993-10-05	1993-10-05 00:00:00	32020		\N	74690	0	36971009	4283893		0
19019	1143	40481087	2007-05-31	2007-05-31 00:00:00	2007-06-07	2007-06-07 00:00:00	32020		\N	75395	0	444814009	40481087		0
19165	1148	4112343	2015-07-04	2015-07-04 00:00:00	2015-07-14	2015-07-14 00:00:00	32020		\N	75902	0	195662009	4112343		0
19354	1159	40481087	2009-05-13	2009-05-13 00:00:00	2009-05-20	2009-05-20 00:00:00	32020		\N	76555	0	444814009	40481087		0
19691	1180	40481087	2017-08-07	2017-08-07 00:00:00	2017-08-14	2017-08-14 00:00:00	32020		\N	77900	0	444814009	40481087		0
30389	1793	4285898	1962-06-21	1962-06-21 00:00:00	\N	\N	32020		\N	120223	0	68496003	4285898		0
20019	1206	260139	1993-11-12	1993-11-12 00:00:00	1993-11-26	1993-11-26 00:00:00	32020		\N	79248	0	10509002	260139		0
20205	1215	4112343	1990-03-15	1990-03-15 00:00:00	1990-03-24	1990-03-24 00:00:00	32020		\N	80025	0	195662009	4112343		0
20314	1223	4278672	1983-07-17	1983-07-17 00:00:00	1983-09-15	1983-09-15 00:00:00	32020		\N	80446	0	65966004	4278672		0
20536	1235	4283893	1988-07-20	1988-07-20 00:00:00	1988-08-31	1988-08-31 00:00:00	32020		\N	81303	0	36971009	4283893		0
20703	1245	4142905	2008-08-08	2008-08-08 00:00:00	2008-11-06	2008-11-06 00:00:00	32020		\N	81905	0	33737001	4142905		0
20828	1250	4112343	1954-10-15	1954-10-15 00:00:00	1954-10-27	1954-10-27 00:00:00	32020		\N	82393	0	195662009	4112343		0
20972	1258	80180	2003-11-14	2003-11-14 00:00:00	\N	\N	32020		\N	82912	0	396275006	80180		0
21218	1273	40481087	2015-11-10	2015-11-10 00:00:00	2015-11-17	2015-11-17 00:00:00	32020		\N	84009	0	444814009	40481087		0
10731	636	4283893	2012-09-22	2012-09-22 00:00:00	2012-10-13	2012-10-13 00:00:00	32020		\N	42183	0	36971009	4283893		0
10871	644	4112343	1978-08-08	1978-08-08 00:00:00	1978-08-17	1978-08-17 00:00:00	32020		\N	42655	0	195662009	4112343		0
11065	653	40481087	2015-12-21	2015-12-21 00:00:00	2016-01-11	2016-01-11 00:00:00	32020		\N	43266	0	444814009	40481087		0
11249	664	4218389	1988-11-29	1988-11-29 00:00:00	1989-01-03	1989-01-03 00:00:00	32020		\N	43902	0	39848009	4218389		0
11367	672	260139	1975-11-17	1975-11-17 00:00:00	1975-11-24	1975-11-24 00:00:00	32020		\N	44350	0	10509002	260139		0
11620	686	260139	1958-11-04	1958-11-04 00:00:00	1958-11-18	1958-11-18 00:00:00	32020		\N	45394	0	10509002	260139		0
11700	691	260139	2008-01-25	2008-01-25 00:00:00	2008-02-08	2008-02-08 00:00:00	32020		\N	45778	0	10509002	260139		0
11887	703	40481087	1955-07-30	1955-07-30 00:00:00	1955-08-13	1955-08-13 00:00:00	32020		\N	46434	0	444814009	40481087		0
12035	711	4112343	1976-07-27	1976-07-27 00:00:00	1976-08-07	1976-08-07 00:00:00	32020		\N	47153	0	195662009	4112343		0
12235	723	195588	1997-11-01	1997-11-01 00:00:00	1997-12-10	1997-12-10 00:00:00	32020		\N	47834	0	38822007	195588		0
12335	728	4113008	1970-10-14	1970-10-14 00:00:00	1970-10-28	1970-10-28 00:00:00	32020		\N	48312	0	284549007	4113008		0
12523	741	40481087	1991-08-24	1991-08-24 00:00:00	1991-08-31	1991-08-31 00:00:00	32020		\N	49052	0	444814009	40481087		0
12726	753	260139	2007-01-17	2007-01-17 00:00:00	2007-01-24	2007-01-24 00:00:00	32020		\N	49746	0	10509002	260139		0
12897	759	260139	1957-10-07	1957-10-07 00:00:00	1957-10-21	1957-10-21 00:00:00	32020		\N	50433	0	10509002	260139		0
13006	763	40481087	1994-08-09	1994-08-09 00:00:00	1994-08-16	1994-08-16 00:00:00	32020		\N	50754	0	444814009	40481087		0
13200	776	78272	1967-05-27	1967-05-27 00:00:00	1967-06-10	1967-06-10 00:00:00	32020		\N	51569	0	70704007	78272		0
13341	784	4112343	1997-04-05	1997-04-05 00:00:00	1997-04-12	1997-04-12 00:00:00	32020		\N	52244	0	195662009	4112343		0
24103	1438	260139	1965-09-07	1965-09-07 00:00:00	1965-09-14	1965-09-14 00:00:00	32020		\N	95779	0	10509002	260139		0
13735	812	40481087	1973-06-26	1973-06-26 00:00:00	1973-07-17	1973-07-17 00:00:00	32020		\N	53847	0	444814009	40481087		0
13829	817	260139	2006-09-07	2006-09-07 00:00:00	2006-09-14	2006-09-14 00:00:00	32020		\N	54165	0	10509002	260139		0
13993	826	40481087	2000-05-19	2000-05-19 00:00:00	2000-06-02	2000-06-02 00:00:00	32020		\N	54713	0	444814009	40481087		0
14254	842	40481087	1950-12-04	1950-12-04 00:00:00	1950-12-11	1950-12-11 00:00:00	32020		\N	55643	0	444814009	40481087		0
14349	847	40481087	1970-07-25	1970-07-25 00:00:00	1970-08-15	1970-08-15 00:00:00	32020		\N	56108	0	444814009	40481087		0
14526	859	4051466	1961-03-10	1961-03-10 00:00:00	1976-06-21	1976-06-21 00:00:00	32020		\N	56729	0	233678006	4051466		0
14683	866	40481087	2000-03-16	2000-03-16 00:00:00	2000-03-30	2000-03-30 00:00:00	32020		\N	57446	0	444814009	40481087		0
14904	877	4156265	1984-01-27	1984-01-27 00:00:00	1984-02-10	1984-02-10 00:00:00	32020		\N	58438	0	370247008	4156265		0
15047	886	4112343	1984-09-30	1984-09-30 00:00:00	1984-10-12	1984-10-12 00:00:00	32020		\N	59091	0	195662009	4112343		0
15237	902	4294548	2014-01-01	2014-01-01 00:00:00	2014-01-22	2014-01-22 00:00:00	32020		\N	60006	0	75498004	4294548		0
15408	914	257012	1971-10-12	1971-10-12 00:00:00	1972-03-14	1972-03-14 00:00:00	32020		\N	60755	0	40055000	257012		0
15511	918	4218389	1964-01-13	1964-01-13 00:00:00	1964-02-03	1964-02-03 00:00:00	32020		\N	61198	0	39848009	4218389		0
15706	929	40481087	2003-08-04	2003-08-04 00:00:00	2003-08-18	2003-08-18 00:00:00	32020		\N	61841	0	444814009	40481087		0
15826	936	4296204	1971-10-01	1971-10-01 00:00:00	1971-10-29	1971-10-29 00:00:00	32020		\N	62262	0	403190006	4296204		0
16042	949	40481087	2001-09-19	2001-09-19 00:00:00	2001-10-03	2001-10-03 00:00:00	32020		\N	63059	0	444814009	40481087		0
16210	958	40481087	1968-11-11	1968-11-11 00:00:00	1968-12-02	1968-12-02 00:00:00	32020		\N	63632	0	444814009	40481087		0
16343	967	4109685	1977-04-06	1977-04-06 00:00:00	1977-04-27	1977-04-27 00:00:00	32020		\N	64315	0	284551006	4109685		0
16485	973	4113008	1997-04-08	1997-04-08 00:00:00	1997-04-22	1997-04-22 00:00:00	32020		\N	64806	0	284549007	4113008		0
16724	992	4285898	1986-12-03	1986-12-03 00:00:00	\N	\N	32020		\N	65730	0	68496003	4285898		0
16892	1004	4152936	2016-09-27	2016-09-27 00:00:00	2016-10-11	2016-10-11 00:00:00	32020		\N	66339	0	283385000	4152936		0
17023	1017	4112343	1995-10-09	1995-10-09 00:00:00	1995-10-17	1995-10-17 00:00:00	32020		\N	67006	0	195662009	4112343		0
17262	1033	439777	1999-07-29	1999-07-29 00:00:00	\N	\N	32020		\N	67973	0	271737000	439777		0
27889	1646	4278672	2012-03-22	2012-03-22 00:00:00	2012-05-21	2012-05-21 00:00:00	32020		\N	110450	0	65966004	4278672		0
17521	1053	40481087	2001-04-17	2001-04-17 00:00:00	2001-04-24	2001-04-24 00:00:00	32020		\N	69050	0	444814009	40481087		0
17680	1062	28060	1994-02-18	1994-02-18 00:00:00	1994-02-28	1994-02-28 00:00:00	32020		\N	69652	0	43878008	28060		0
17904	1077	4112343	2004-04-03	2004-04-03 00:00:00	2004-04-11	2004-04-11 00:00:00	32020		\N	70652	0	195662009	4112343		0
18004	1082	4001336	1960-11-21	1960-11-21 00:00:00	1961-01-20	1961-01-20 00:00:00	32020		\N	71051	0	110030002	4001336		0
18184	1092	40481087	1973-04-06	1973-04-06 00:00:00	1973-04-13	1973-04-13 00:00:00	32020		\N	71757	0	444814009	40481087		0
18299	1100	80180	2019-05-08	2019-05-08 00:00:00	\N	\N	32020		\N	72260	0	396275006	80180		0
18509	1113	40481087	2008-11-14	2008-11-14 00:00:00	2008-11-21	2008-11-21 00:00:00	32020		\N	73280	0	444814009	40481087		0
18673	1123	4112343	1995-10-16	1995-10-16 00:00:00	1995-10-24	1995-10-24 00:00:00	32020		\N	73978	0	195662009	4112343		0
18852	1134	260139	1955-06-08	1955-06-08 00:00:00	1955-06-22	1955-06-22 00:00:00	32020		\N	74666	0	10509002	260139		0
19020	1143	81151	2008-04-18	2008-04-18 00:00:00	2008-05-23	2008-05-23 00:00:00	32020		\N	75459	0	44465007	81151		0
19166	1148	4296204	1976-05-18	1976-05-18 00:00:00	1976-06-01	1976-06-01 00:00:00	32020		\N	75932	0	403190006	4296204		0
19355	1159	40481087	2013-03-30	2013-03-30 00:00:00	2013-04-13	2013-04-13 00:00:00	32020		\N	76556	0	444814009	40481087		0
30060	1779	4084167	1969-04-15	1969-04-15 00:00:00	1969-04-15	1969-04-15 00:00:00	32020		\N	119067	0	241929008	4084167		0
19692	1180	40481087	1963-08-26	1963-08-26 00:00:00	1963-09-09	1963-09-09 00:00:00	32020		\N	77886	0	444814009	40481087		0
30390	1793	80180	1963-03-18	1963-03-18 00:00:00	\N	\N	32020		\N	120223	0	396275006	80180		0
20020	1206	260139	1998-07-19	1998-07-19 00:00:00	1998-07-26	1998-07-26 00:00:00	32020		\N	79232	0	10509002	260139		0
20206	1215	40481087	1991-09-06	1991-09-06 00:00:00	1991-09-13	1991-09-13 00:00:00	32020		\N	80026	0	444814009	40481087		0
20315	1223	4283893	1980-09-22	1980-09-22 00:00:00	1980-12-22	1980-12-22 00:00:00	32020		\N	80453	0	36971009	4283893		0
20537	1235	40481087	2008-12-27	2008-12-27 00:00:00	2009-01-10	2009-01-10 00:00:00	32020		\N	81324	0	444814009	40481087		0
20704	1245	4112343	1961-03-31	1961-03-31 00:00:00	1961-04-09	1961-04-09 00:00:00	32020		\N	81950	0	195662009	4112343		0
20829	1250	4001336	1988-05-12	1988-05-12 00:00:00	1988-06-11	1988-06-11 00:00:00	32020		\N	82337	0	110030002	4001336		0
20973	1259	4112343	2006-05-08	2006-05-08 00:00:00	2006-05-15	2006-05-15 00:00:00	32020		\N	82984	0	195662009	4112343		0
21219	1273	4112343	1989-06-13	1989-06-13 00:00:00	1989-06-20	1989-06-20 00:00:00	32020		\N	84064	0	195662009	4112343		0
10732	636	40481087	1959-02-03	1959-02-03 00:00:00	1959-02-17	1959-02-17 00:00:00	32020		\N	42119	0	444814009	40481087		0
10872	644	40481087	1979-11-05	1979-11-05 00:00:00	1979-11-19	1979-11-19 00:00:00	32020		\N	42634	0	444814009	40481087		0
11066	653	372328	1957-09-20	1957-09-20 00:00:00	1958-01-10	1958-01-10 00:00:00	32020		\N	43276	0	65363002	372328		0
11250	664	4112343	1991-02-05	1991-02-05 00:00:00	1991-02-15	1991-02-15 00:00:00	32020		\N	43866	0	195662009	4112343		0
11368	672	40481087	2016-05-29	2016-05-29 00:00:00	2016-06-05	2016-06-05 00:00:00	32020		\N	44373	0	444814009	40481087		0
22079	1320	40481087	1942-06-02	1942-06-02 00:00:00	1942-06-23	1942-06-23 00:00:00	32020		\N	87555	0	444814009	40481087		0
11701	691	28060	1999-09-30	1999-09-30 00:00:00	1999-10-08	1999-10-08 00:00:00	32020		\N	45746	0	43878008	28060		0
11888	703	4112343	1956-09-18	1956-09-18 00:00:00	1956-09-30	1956-09-30 00:00:00	32020		\N	46472	0	195662009	4112343		0
12036	711	4230399	1990-01-01	1990-01-01 00:00:00	1990-03-02	1990-03-02 00:00:00	32020		\N	47199	0	359817006	4230399		0
12264	726	4134304	1969-02-07	1969-02-07 00:00:00	1969-05-08	1969-05-08 00:00:00	32020		\N	48092	0	263102004	4134304		0
12336	728	4294548	1986-06-11	1986-06-11 00:00:00	1986-06-18	1986-06-18 00:00:00	32020		\N	48298	0	75498004	4294548		0
12524	741	321042	2000-05-26	2000-05-26 00:00:00	\N	\N	32020		\N	49043	0	410429000	321042		0
12727	753	378001	2006-03-31	2006-03-31 00:00:00	2006-04-30	2006-04-30 00:00:00	32020		\N	49818	0	62106007	378001		0
12898	759	81151	1973-12-23	1973-12-23 00:00:00	1974-01-06	1974-01-06 00:00:00	32020		\N	50359	0	44465007	81151		0
13007	763	4112343	1993-11-13	1993-11-13 00:00:00	1993-11-25	1993-11-25 00:00:00	32020		\N	50744	0	195662009	4112343		0
13201	776	40481087	2006-12-23	2006-12-23 00:00:00	2007-01-13	2007-01-13 00:00:00	32020		\N	51563	0	444814009	40481087		0
13342	784	40481087	2008-02-10	2008-02-10 00:00:00	2008-03-02	2008-03-02 00:00:00	32020		\N	52203	0	444814009	40481087		0
24104	1438	260139	2017-04-29	2017-04-29 00:00:00	2017-05-13	2017-05-13 00:00:00	32020		\N	95806	0	10509002	260139		0
13736	812	4142905	1979-09-01	1979-09-01 00:00:00	1979-10-31	1979-10-31 00:00:00	32020		\N	53888	0	33737001	4142905		0
13830	817	4112343	1970-06-30	1970-06-30 00:00:00	1970-07-07	1970-07-07 00:00:00	32020		\N	54161	0	195662009	4112343		0
13994	826	40481087	1989-11-02	1989-11-02 00:00:00	1989-11-16	1989-11-16 00:00:00	32020		\N	54703	0	444814009	40481087		0
14255	842	4001336	1946-09-14	1946-09-14 00:00:00	1946-10-14	1946-10-14 00:00:00	32020		\N	55709	0	110030002	4001336		0
14350	847	4112343	1993-05-29	1993-05-29 00:00:00	1993-06-08	1993-06-08 00:00:00	32020		\N	56098	0	195662009	4112343		0
14527	859	257012	2017-05-03	2017-05-03 00:00:00	\N	\N	32020		\N	56745	0	40055000	257012		0
14684	866	4112343	1979-09-19	1979-09-19 00:00:00	1979-09-29	1979-09-29 00:00:00	32020		\N	57445	0	195662009	4112343		0
14905	877	81151	2017-09-03	2017-09-03 00:00:00	2017-09-24	2017-09-24 00:00:00	32020		\N	58443	0	44465007	81151		0
15048	886	260139	1998-11-19	1998-11-19 00:00:00	1998-12-03	1998-12-03 00:00:00	32020		\N	59060	0	10509002	260139		0
15238	902	260139	1970-05-23	1970-05-23 00:00:00	1970-06-06	1970-06-06 00:00:00	32020		\N	60004	0	10509002	260139		0
15409	914	40481087	1989-04-16	1989-04-16 00:00:00	1989-05-07	1989-05-07 00:00:00	32020		\N	60693	0	444814009	40481087		0
15512	918	372328	1949-01-10	1949-01-10 00:00:00	1950-10-27	1950-10-27 00:00:00	32020		\N	61139	0	65363002	372328		0
15707	929	40481087	1927-04-17	1927-04-17 00:00:00	1927-05-08	1927-05-08 00:00:00	32020		\N	61802	0	444814009	40481087		0
15827	936	260139	1991-08-19	1991-08-19 00:00:00	1991-08-26	1991-08-26 00:00:00	32020		\N	62286	0	10509002	260139		0
16043	949	4155034	1961-01-30	1961-01-30 00:00:00	1961-02-13	1961-02-13 00:00:00	32020		\N	63021	0	283371005	4155034		0
16211	959	40481087	1961-06-16	1961-06-16 00:00:00	1961-07-07	1961-07-07 00:00:00	32020		\N	63694	0	444814009	40481087		0
16344	967	381316	1953-04-25	1953-04-25 00:00:00	\N	\N	32020		\N	64346	0	230690007	381316		0
16486	973	80180	1953-12-25	1953-12-25 00:00:00	\N	\N	32020		\N	64873	0	396275006	80180		0
16725	992	81893	1986-01-07	1986-01-07 00:00:00	\N	\N	32020		\N	65730	0	64766004	81893		0
16893	1004	4027663	1993-10-03	1993-10-03 00:00:00	\N	\N	32020		\N	66394	0	13200003	4027663		0
17024	1017	260139	1971-03-11	1971-03-11 00:00:00	1971-03-18	1971-03-18 00:00:00	32020		\N	66928	0	10509002	260139		0
17263	1033	260139	1974-07-22	1974-07-22 00:00:00	1974-08-05	1974-08-05 00:00:00	32020		\N	67970	0	10509002	260139		0
27890	1646	81151	2014-02-10	2014-02-10 00:00:00	2014-02-24	2014-02-24 00:00:00	32020		\N	110394	0	44465007	81151		0
17522	1053	81151	2018-05-08	2018-05-08 00:00:00	2018-05-22	2018-05-22 00:00:00	32020		\N	69027	0	44465007	81151		0
17681	1062	40479422	1969-02-03	1969-02-03 00:00:00	1969-04-11	1969-04-11 00:00:00	32020		\N	69661	0	444448004	40479422		0
17905	1077	4112343	1989-09-28	1989-09-28 00:00:00	1989-10-07	1989-10-07 00:00:00	32020		\N	70594	0	195662009	4112343		0
18005	1082	260139	1989-12-16	1989-12-16 00:00:00	1989-12-30	1989-12-30 00:00:00	32020		\N	70931	0	10509002	260139		0
18185	1092	40481087	2011-05-10	2011-05-10 00:00:00	2011-05-17	2011-05-17 00:00:00	32020		\N	71818	0	444814009	40481087		0
18300	1100	4142905	1996-03-03	1996-03-03 00:00:00	1996-05-02	1996-05-02 00:00:00	32020		\N	72274	0	33737001	4142905		0
18510	1113	4112343	2010-05-25	2010-05-25 00:00:00	2010-06-02	2010-06-02 00:00:00	32020		\N	73288	0	195662009	4112343		0
18674	1123	28060	2002-10-03	2002-10-03 00:00:00	2002-10-12	2002-10-12 00:00:00	32020		\N	74000	0	43878008	28060		0
18853	1134	40481087	1947-05-25	1947-05-25 00:00:00	1947-06-01	1947-06-01 00:00:00	32020		\N	74678	0	444814009	40481087		0
19021	1143	4278672	1983-11-26	1983-11-26 00:00:00	1983-12-26	1983-12-26 00:00:00	32020		\N	75457	0	65966004	4278672		0
19167	1148	81151	1965-12-07	1965-12-07 00:00:00	1966-01-11	1966-01-11 00:00:00	32020		\N	75930	0	44465007	81151		0
19356	1159	40481087	2001-02-01	2001-02-01 00:00:00	2001-02-22	2001-02-22 00:00:00	32020		\N	76579	0	444814009	40481087		0
30061	1779	40481087	1985-02-27	1985-02-27 00:00:00	1985-03-20	1985-03-20 00:00:00	32020		\N	119047	0	444814009	40481087		0
19716	1185	4112343	1987-04-07	1987-04-07 00:00:00	1987-04-17	1987-04-17 00:00:00	32020		\N	78090	0	195662009	4112343		0
30391	1793	4035415	1962-05-25	1962-05-25 00:00:00	1962-07-24	1962-07-24 00:00:00	32020		\N	120223	0	239720000	4035415		0
20021	1206	440448	1972-02-10	1972-02-10 00:00:00	\N	\N	32020		\N	79259	0	74400008	440448		0
20207	1215	192671	2009-06-07	2009-06-07 00:00:00	\N	\N	32020		\N	80042	0	K92.2	35208414		0
20316	1223	40481087	1963-10-20	1963-10-20 00:00:00	1963-10-27	1963-10-27 00:00:00	32020		\N	80522	0	444814009	40481087		0
20538	1235	28060	2011-01-06	2011-01-06 00:00:00	2011-01-16	2011-01-16 00:00:00	32020		\N	81315	0	43878008	28060		0
20705	1245	81151	1937-07-23	1937-07-23 00:00:00	1937-08-20	1937-08-20 00:00:00	32020		\N	81934	0	44465007	81151		0
20830	1250	4283893	1959-08-27	1959-08-27 00:00:00	1959-11-12	1959-11-12 00:00:00	32020		\N	82394	0	36971009	4283893		0
20974	1259	4218389	1988-05-26	1988-05-26 00:00:00	1988-06-30	1988-06-30 00:00:00	32020		\N	82963	0	39848009	4218389		0
21220	1273	260139	1947-11-29	1947-11-29 00:00:00	1947-12-13	1947-12-13 00:00:00	32020		\N	83976	0	10509002	260139		0
10733	636	257012	1958-07-18	1958-07-18 00:00:00	\N	\N	32020		\N	42155	0	40055000	257012		0
10873	644	4109685	1976-10-16	1976-10-16 00:00:00	1976-10-30	1976-10-30 00:00:00	32020		\N	42665	0	284551006	4109685		0
11067	653	4112343	1988-02-29	1988-02-29 00:00:00	1988-03-08	1988-03-08 00:00:00	32020		\N	43223	0	195662009	4112343		0
11251	664	378001	1995-07-31	1995-07-31 00:00:00	1995-08-30	1995-08-30 00:00:00	32020		\N	43903	0	62106007	378001		0
11369	672	260139	1956-10-25	1956-10-25 00:00:00	1956-11-01	1956-11-01 00:00:00	32020		\N	44334	0	10509002	260139		0
22080	1320	260139	1946-05-31	1946-05-31 00:00:00	1946-06-07	1946-06-07 00:00:00	32020		\N	87556	0	10509002	260139		0
11702	691	40481087	2009-06-15	2009-06-15 00:00:00	2009-06-22	2009-06-22 00:00:00	32020		\N	45751	0	444814009	40481087		0
11889	703	40481087	1980-01-21	1980-01-21 00:00:00	1980-01-28	1980-01-28 00:00:00	32020		\N	46475	0	444814009	40481087		0
12037	711	40481087	1994-03-21	1994-03-21 00:00:00	1994-03-28	1994-03-28 00:00:00	32020		\N	47068	0	444814009	40481087		0
12265	726	4109685	2004-09-01	2004-09-01 00:00:00	2004-09-22	2004-09-22 00:00:00	32020		\N	48093	0	284551006	4109685		0
12337	728	260139	1982-07-21	1982-07-21 00:00:00	1982-07-28	1982-07-28 00:00:00	32020		\N	48352	0	10509002	260139		0
12526	741	372328	1977-04-17	1977-04-17 00:00:00	1977-05-01	1977-05-01 00:00:00	32020		\N	49037	0	65363002	372328		0
12728	753	40481087	2007-08-31	2007-08-31 00:00:00	2007-09-14	2007-09-14 00:00:00	32020		\N	49814	0	444814009	40481087		0
12899	759	4113008	1969-03-28	1969-03-28 00:00:00	1969-04-18	1969-04-18 00:00:00	32020		\N	50358	0	284549007	4113008		0
13008	763	260139	1972-06-10	1972-06-10 00:00:00	1972-06-17	1972-06-17 00:00:00	32020		\N	50750	0	10509002	260139		0
13202	776	261325	2009-08-06	2009-08-06 00:00:00	\N	\N	32020		\N	51506	0	87433001	261325		0
13343	784	4283893	1992-04-08	1992-04-08 00:00:00	1992-04-29	1992-04-29 00:00:00	32020		\N	52221	0	36971009	4283893		0
24105	1438	260139	1955-04-21	1955-04-21 00:00:00	1955-04-28	1955-04-28 00:00:00	32020		\N	95777	0	10509002	260139		0
13737	812	260139	1988-09-30	1988-09-30 00:00:00	1988-10-07	1988-10-07 00:00:00	32020		\N	53848	0	10509002	260139		0
13831	817	4294548	1998-09-01	1998-09-01 00:00:00	1998-09-15	1998-09-15 00:00:00	32020		\N	54092	0	75498004	4294548		0
13995	826	40481087	2008-04-26	2008-04-26 00:00:00	2008-05-10	2008-05-10 00:00:00	32020		\N	54701	0	444814009	40481087		0
14256	842	4112343	1917-09-19	1917-09-19 00:00:00	1917-09-26	1917-09-26 00:00:00	32020		\N	55632	0	195662009	4112343		0
14351	847	321042	1970-07-24	1970-07-24 00:00:00	\N	\N	32020		\N	56137	0	410429000	321042		0
14528	859	372328	1969-01-30	1969-01-30 00:00:00	1969-07-07	1969-07-07 00:00:00	32020		\N	56746	0	65363002	372328		0
14685	866	78272	1970-11-10	1970-11-10 00:00:00	1970-12-01	1970-12-01 00:00:00	32020		\N	57487	0	70704007	78272		0
14918	879	40481087	2013-05-28	2013-05-28 00:00:00	2013-06-11	2013-06-11 00:00:00	32020		\N	58561	0	444814009	40481087		0
15049	886	81151	1989-01-03	1989-01-03 00:00:00	1989-01-17	1989-01-17 00:00:00	32020		\N	59074	0	44465007	81151		0
15239	902	4112343	1955-03-06	1955-03-06 00:00:00	1955-03-16	1955-03-16 00:00:00	32020		\N	60012	0	195662009	4112343		0
15410	914	372328	1948-08-10	1948-08-10 00:00:00	1948-11-01	1948-11-01 00:00:00	32020		\N	60745	0	65363002	372328		0
15513	918	40481087	1958-08-18	1958-08-18 00:00:00	1958-09-01	1958-09-01 00:00:00	32020		\N	61121	0	444814009	40481087		0
15708	929	260139	1934-08-16	1934-08-16 00:00:00	1934-08-23	1934-08-23 00:00:00	32020		\N	61820	0	10509002	260139		0
15828	936	372328	1965-11-01	1965-11-01 00:00:00	1966-10-14	1966-10-14 00:00:00	32020		\N	62289	0	65363002	372328		0
16044	949	4218389	2005-06-22	2005-06-22 00:00:00	2005-07-13	2005-07-13 00:00:00	32020		\N	63023	0	39848009	4218389		0
16212	959	40481087	1977-05-21	1977-05-21 00:00:00	1977-06-11	1977-06-11 00:00:00	32020		\N	63673	0	444814009	40481087		0
16345	967	81151	2007-05-20	2007-05-20 00:00:00	2007-06-10	2007-06-10 00:00:00	32020		\N	64319	0	44465007	81151		0
16487	973	40481087	1920-12-18	1920-12-18 00:00:00	1920-12-25	1920-12-25 00:00:00	32020		\N	64916	0	444814009	40481087		0
16726	992	4310024	1985-07-11	1985-07-11 00:00:00	\N	\N	32020		\N	65730	0	424802006	4310024		0
16894	1004	4112343	2014-04-01	2014-04-01 00:00:00	2014-04-10	2014-04-10 00:00:00	32020		\N	66384	0	195662009	4112343		0
17025	1017	4237458	2009-09-27	2009-09-27 00:00:00	2009-12-26	2009-12-26 00:00:00	32020		\N	67004	0	58150001	4237458		0
17264	1033	28060	1982-03-25	1982-03-25 00:00:00	1982-04-02	1982-04-02 00:00:00	32020		\N	68012	0	43878008	28060		0
27891	1646	40481087	1974-12-30	1974-12-30 00:00:00	1975-01-13	1975-01-13 00:00:00	32020		\N	110371	0	444814009	40481087		0
17523	1053	4294548	1976-07-07	1976-07-07 00:00:00	1976-09-22	1976-09-22 00:00:00	32020		\N	68994	0	75498004	4294548		0
17682	1062	40481087	1988-05-27	1988-05-27 00:00:00	1988-06-17	1988-06-17 00:00:00	32020		\N	69651	0	444814009	40481087		0
17906	1077	81151	2006-03-04	2006-03-04 00:00:00	2006-04-08	2006-04-08 00:00:00	32020		\N	70603	0	44465007	81151		0
18006	1082	4027663	1982-08-13	1982-08-13 00:00:00	\N	\N	32020		\N	70951	0	13200003	4027663		0
18186	1092	4155034	1982-12-22	1982-12-22 00:00:00	1983-01-05	1983-01-05 00:00:00	32020		\N	71798	0	283371005	4155034		0
18301	1100	4112343	1997-10-12	1997-10-12 00:00:00	1997-10-25	1997-10-25 00:00:00	32020		\N	72279	0	195662009	4112343		0
18511	1113	40481087	2014-03-13	2014-03-13 00:00:00	2014-03-27	2014-03-27 00:00:00	32020		\N	73290	0	444814009	40481087		0
18675	1123	40481087	1989-02-25	1989-02-25 00:00:00	1989-03-11	1989-03-11 00:00:00	32020		\N	73997	0	444814009	40481087		0
18854	1134	4112343	1973-05-22	1973-05-22 00:00:00	1973-06-03	1973-06-03 00:00:00	32020		\N	74667	0	195662009	4112343		0
19022	1143	260139	1999-07-18	1999-07-18 00:00:00	1999-08-01	1999-08-01 00:00:00	32020		\N	75419	0	10509002	260139		0
19168	1148	4156265	2002-02-15	2002-02-15 00:00:00	2002-03-01	2002-03-01 00:00:00	32020		\N	75933	0	370247008	4156265		0
19357	1159	40481087	2011-08-17	2011-08-17 00:00:00	2011-08-31	2011-08-31 00:00:00	32020		\N	76535	0	444814009	40481087		0
30062	1779	4048171	1945-12-02	1945-12-02 00:00:00	\N	\N	32020		\N	119070	0	232353008	4048171		0
19717	1185	372328	1939-08-16	1939-08-16 00:00:00	1939-11-05	1939-11-05 00:00:00	32020		\N	78127	0	65363002	372328		0
30392	1793	4294548	1923-08-12	1923-08-12 00:00:00	1923-09-23	1923-09-23 00:00:00	32020		\N	120219	0	75498004	4294548		0
20022	1206	4166224	1972-02-10	1972-02-10 00:00:00	\N	\N	32020		\N	79259	0	47693006	4166224		0
20208	1215	4296204	2001-12-16	2001-12-16 00:00:00	2002-01-06	2002-01-06 00:00:00	32020		\N	80041	0	403190006	4296204		0
20317	1223	28060	1955-06-03	1955-06-03 00:00:00	1955-06-16	1955-06-16 00:00:00	32020		\N	80510	0	43878008	28060		0
20539	1235	40481087	2011-06-07	2011-06-07 00:00:00	2011-06-28	2011-06-28 00:00:00	32020		\N	81349	0	444814009	40481087		0
20706	1245	260139	2013-06-05	2013-06-05 00:00:00	2013-06-19	2013-06-19 00:00:00	32020		\N	81985	0	10509002	260139		0
20831	1250	40481087	1968-09-24	1968-09-24 00:00:00	1968-10-08	1968-10-08 00:00:00	32020		\N	82383	0	444814009	40481087		0
20975	1259	4112343	1962-06-06	1962-06-06 00:00:00	1962-06-18	1962-06-18 00:00:00	32020		\N	82972	0	195662009	4112343		0
21221	1273	40481087	1977-06-05	1977-06-05 00:00:00	1977-06-26	1977-06-26 00:00:00	32020		\N	84018	0	444814009	40481087		0
10734	636	372328	1952-01-21	1952-01-21 00:00:00	1952-02-15	1952-02-15 00:00:00	32020		\N	42149	0	65363002	372328		0
10874	644	4112343	2017-05-30	2017-05-30 00:00:00	2017-06-07	2017-06-07 00:00:00	32020		\N	42647	0	195662009	4112343		0
11068	653	375671	2015-10-14	2015-10-14 00:00:00	2015-11-13	2015-11-13 00:00:00	32020		\N	43263	0	62564004	375671		0
11252	664	372328	1986-02-27	1986-02-27 00:00:00	1986-06-19	1986-06-19 00:00:00	32020		\N	43832	0	65363002	372328		0
11370	672	4112343	1996-09-28	1996-09-28 00:00:00	1996-10-09	1996-10-09 00:00:00	32020		\N	44394	0	195662009	4112343		0
22081	1320	378001	1943-11-11	1943-11-11 00:00:00	1943-12-11	1943-12-11 00:00:00	32020		\N	87473	0	62106007	378001		0
11703	691	4112343	2007-04-03	2007-04-03 00:00:00	2007-04-13	2007-04-13 00:00:00	32020		\N	45782	0	195662009	4112343		0
11890	703	40481087	1976-08-17	1976-08-17 00:00:00	1976-08-31	1976-08-31 00:00:00	32020		\N	46439	0	444814009	40481087		0
12038	711	4112343	1971-05-02	1971-05-02 00:00:00	1971-05-12	1971-05-12 00:00:00	32020		\N	47109	0	195662009	4112343		0
12266	726	372328	1954-04-27	1954-04-27 00:00:00	1954-08-08	1954-08-08 00:00:00	32020		\N	48077	0	65363002	372328		0
12338	728	378001	2002-06-03	2002-06-03 00:00:00	2002-08-02	2002-08-02 00:00:00	32020		\N	48315	0	62106007	378001		0
12527	741	78272	1989-12-24	1989-12-24 00:00:00	1990-01-21	1990-01-21 00:00:00	32020		\N	49042	0	70704007	78272		0
12729	753	260139	2009-11-11	2009-11-11 00:00:00	2009-11-18	2009-11-18 00:00:00	32020		\N	49798	0	10509002	260139		0
12900	759	260139	2017-09-07	2017-09-07 00:00:00	2017-09-21	2017-09-21 00:00:00	32020		\N	50395	0	10509002	260139		0
13009	763	4112343	2017-02-25	2017-02-25 00:00:00	2017-03-07	2017-03-07 00:00:00	32020		\N	50746	0	195662009	4112343		0
13203	776	4134304	1969-06-29	1969-06-29 00:00:00	1969-09-27	1969-09-27 00:00:00	32020		\N	51570	0	263102004	4134304		0
13344	784	4294548	1959-12-04	1959-12-04 00:00:00	1960-01-22	1960-01-22 00:00:00	32020		\N	52242	0	75498004	4294548		0
24106	1438	28060	2009-01-13	2009-01-13 00:00:00	2009-01-21	2009-01-21 00:00:00	32020		\N	95830	0	43878008	28060		0
13738	812	4112343	1971-10-01	1971-10-01 00:00:00	1971-10-10	1971-10-10 00:00:00	32020		\N	53862	0	195662009	4112343		0
13832	817	81151	1972-11-21	1972-11-21 00:00:00	1972-12-26	1972-12-26 00:00:00	32020		\N	54109	0	44465007	81151		0
13996	826	4283893	2015-02-06	2015-02-06 00:00:00	2015-04-17	2015-04-17 00:00:00	32020		\N	54714	0	36971009	4283893		0
14257	842	4094814	2010-01-01	2010-01-01 00:00:00	2010-04-01	2010-04-01 00:00:00	32020		\N	55706	0	262574004	4094814		0
14353	847	28060	1992-01-23	1992-01-23 00:00:00	1992-02-03	1992-02-03 00:00:00	32020		\N	56092	0	43878008	28060		0
14529	859	260139	1992-11-11	1992-11-11 00:00:00	1992-11-18	1992-11-18 00:00:00	32020		\N	56870	0	10509002	260139		0
14686	866	28060	1966-08-18	1966-08-18 00:00:00	1966-08-27	1966-08-27 00:00:00	32020		\N	57465	0	43878008	28060		0
14919	879	4296205	2009-03-16	2009-03-16 00:00:00	2009-04-06	2009-04-06 00:00:00	32020		\N	58582	0	403191005	4296205		0
15050	886	40481087	2007-06-21	2007-06-21 00:00:00	2007-07-12	2007-07-12 00:00:00	32020		\N	59062	0	444814009	40481087		0
15240	902	4230399	1968-01-15	1968-01-15 00:00:00	1968-02-14	1968-02-14 00:00:00	32020		\N	60067	0	359817006	4230399		0
15411	914	4146173	1979-07-04	1979-07-04 00:00:00	1979-08-03	1979-08-03 00:00:00	32020		\N	60734	0	307731004	4146173		0
15514	918	4112343	1948-05-27	1948-05-27 00:00:00	1948-06-05	1948-06-05 00:00:00	32020		\N	61188	0	195662009	4112343		0
15709	929	260139	1942-06-13	1942-06-13 00:00:00	1942-06-20	1942-06-20 00:00:00	32020		\N	61784	0	10509002	260139		0
15829	936	260139	2013-11-15	2013-11-15 00:00:00	2013-11-22	2013-11-22 00:00:00	32020		\N	62251	0	10509002	260139		0
16045	949	80180	2000-02-25	2000-02-25 00:00:00	\N	\N	32020		\N	63015	0	396275006	80180		0
16213	959	30753	1994-08-04	1994-08-04 00:00:00	\N	\N	32020		\N	63775	0	16761005	30753		0
16346	967	4027663	1962-10-08	1962-10-08 00:00:00	\N	\N	32020		\N	64361	0	13200003	4027663		0
16488	973	4113008	1998-02-16	1998-02-16 00:00:00	1998-03-09	1998-03-09 00:00:00	32020		\N	64807	0	284549007	4113008		0
16727	992	40481087	1966-01-02	1966-01-02 00:00:00	1966-01-09	1966-01-09 00:00:00	32020		\N	65777	0	444814009	40481087		0
16895	1004	28060	1977-09-10	1977-09-10 00:00:00	1977-09-20	1977-09-20 00:00:00	32020		\N	66376	0	43878008	28060		0
17026	1017	40481087	1964-06-21	1964-06-21 00:00:00	1964-07-12	1964-07-12 00:00:00	32020		\N	66937	0	444814009	40481087		0
27723	1635	260139	2005-07-19	2005-07-19 00:00:00	2005-08-02	2005-08-02 00:00:00	32020		\N	109854	0	10509002	260139		0
27892	1646	80180	1982-03-05	1982-03-05 00:00:00	\N	\N	32020		\N	110381	0	396275006	80180		0
17524	1053	372328	1981-06-12	1981-06-12 00:00:00	1981-09-04	1981-09-04 00:00:00	32020		\N	69011	0	65363002	372328		0
17683	1062	40481087	2014-02-08	2014-02-08 00:00:00	2014-03-01	2014-03-01 00:00:00	32020		\N	69666	0	444814009	40481087		0
17907	1077	80180	1979-11-26	1979-11-26 00:00:00	\N	\N	32020		\N	70590	0	396275006	80180		0
18007	1082	4112343	1979-08-02	1979-08-02 00:00:00	1979-08-10	1979-08-10 00:00:00	32020		\N	70974	0	195662009	4112343		0
18187	1092	78272	2017-05-04	2017-05-04 00:00:00	2017-05-18	2017-05-18 00:00:00	32020		\N	71802	0	70704007	78272		0
18302	1100	257012	1987-09-27	1987-09-27 00:00:00	\N	\N	32020		\N	72261	0	40055000	257012		0
18523	1115	4142905	2014-12-12	2014-12-12 00:00:00	2015-02-10	2015-02-10 00:00:00	32020		\N	73390	0	33737001	4142905		0
18676	1123	4112343	2001-04-28	2001-04-28 00:00:00	2001-05-09	2001-05-09 00:00:00	32020		\N	73979	0	195662009	4112343		0
18855	1134	4112343	2001-07-10	2001-07-10 00:00:00	2001-07-22	2001-07-22 00:00:00	32020		\N	74691	0	195662009	4112343		0
19023	1143	28060	1975-06-21	1975-06-21 00:00:00	1975-07-03	1975-07-03 00:00:00	32020		\N	75402	0	43878008	28060		0
19169	1148	80180	2001-07-01	2001-07-01 00:00:00	\N	\N	32020		\N	75882	0	396275006	80180		0
19358	1159	260139	1986-01-27	1986-01-27 00:00:00	1986-02-10	1986-02-10 00:00:00	32020		\N	76553	0	10509002	260139		0
30063	1779	4278672	1976-07-14	1976-07-14 00:00:00	1976-10-12	1976-10-12 00:00:00	32020		\N	119068	0	65966004	4278672		0
19718	1185	40481087	1983-09-22	1983-09-22 00:00:00	1983-09-29	1983-09-29 00:00:00	32020		\N	78161	0	444814009	40481087		0
30393	1793	40481087	1964-06-05	1964-06-05 00:00:00	1964-06-12	1964-06-12 00:00:00	32020		\N	120180	0	444814009	40481087		0
20023	1206	257012	2002-04-09	2002-04-09 00:00:00	\N	\N	32020		\N	79240	0	40055000	257012		0
20209	1215	40481087	2014-12-19	2014-12-19 00:00:00	2015-01-02	2015-01-02 00:00:00	32020		\N	80027	0	444814009	40481087		0
20318	1223	28060	1959-12-23	1959-12-23 00:00:00	1959-12-30	1959-12-30 00:00:00	32020		\N	80449	0	43878008	28060		0
20540	1235	80180	2010-09-04	2010-09-04 00:00:00	\N	\N	32020		\N	81345	0	396275006	80180		0
20707	1245	134438	1963-09-07	1963-09-07 00:00:00	1964-06-03	1964-06-03 00:00:00	32020		\N	81951	0	40275004	134438		0
20832	1250	40481087	1978-09-22	1978-09-22 00:00:00	1978-10-06	1978-10-06 00:00:00	32020		\N	82349	0	444814009	40481087		0
20976	1259	40481087	2019-01-03	2019-01-03 00:00:00	2019-01-17	2019-01-17 00:00:00	32020		\N	82985	0	444814009	40481087		0
21222	1273	4112343	2011-01-29	2011-01-29 00:00:00	2011-02-10	2011-02-10 00:00:00	32020		\N	84066	0	195662009	4112343		0
10735	636	4237458	2018-01-04	2018-01-04 00:00:00	2018-04-04	2018-04-04 00:00:00	32020		\N	42161	0	58150001	4237458		0
10875	644	260139	1984-09-22	1984-09-22 00:00:00	1984-09-29	1984-09-29 00:00:00	32020		\N	42656	0	10509002	260139		0
11069	653	4109685	1971-09-14	1971-09-14 00:00:00	1971-10-05	1971-10-05 00:00:00	32020		\N	43262	0	284551006	4109685		0
11253	664	40481087	2002-08-16	2002-08-16 00:00:00	2002-08-30	2002-08-30 00:00:00	32020		\N	43820	0	444814009	40481087		0
11371	672	40481087	2017-07-07	2017-07-07 00:00:00	2017-07-21	2017-07-21 00:00:00	32020		\N	44407	0	444814009	40481087		0
22082	1320	4112343	2004-10-02	2004-10-02 00:00:00	2004-10-11	2004-10-11 00:00:00	32020		\N	87518	0	195662009	4112343		0
11704	691	40481087	1980-02-20	1980-02-20 00:00:00	1980-02-27	1980-02-27 00:00:00	32020		\N	45744	0	444814009	40481087		0
11891	703	4027663	1978-12-16	1978-12-16 00:00:00	\N	\N	32020		\N	46439	0	13200003	4027663		0
12039	711	198809	1967-01-29	1967-01-29 00:00:00	1967-01-29	1967-01-29 00:00:00	32020		\N	47196	0	65275009	198809		0
12267	726	40481087	1982-05-25	1982-05-25 00:00:00	1982-06-01	1982-06-01 00:00:00	32020		\N	48111	0	444814009	40481087		0
12339	728	260139	1973-08-16	1973-08-16 00:00:00	1973-08-30	1973-08-30 00:00:00	32020		\N	48351	0	10509002	260139		0
12528	741	40481087	1999-03-02	1999-03-02 00:00:00	1999-03-16	1999-03-16 00:00:00	32020		\N	49068	0	444814009	40481087		0
12730	753	260139	1999-11-30	1999-11-30 00:00:00	1999-12-14	1999-12-14 00:00:00	32020		\N	49796	0	10509002	260139		0
12901	759	4112343	1947-05-25	1947-05-25 00:00:00	1947-06-04	1947-06-04 00:00:00	32020		\N	50432	0	195662009	4112343		0
13010	764	4283893	2011-07-12	2011-07-12 00:00:00	2011-08-02	2011-08-02 00:00:00	32020		\N	50809	0	36971009	4283893		0
13204	776	4112343	1978-08-05	1978-08-05 00:00:00	1978-08-18	1978-08-18 00:00:00	32020		\N	51558	0	195662009	4112343		0
13345	784	4113008	1992-08-06	1992-08-06 00:00:00	1992-08-27	1992-08-27 00:00:00	32020		\N	52251	0	284549007	4113008		0
24107	1438	4112343	1997-01-02	1997-01-02 00:00:00	1997-01-14	1997-01-14 00:00:00	32020		\N	95809	0	195662009	4112343		0
13739	812	40481087	1984-06-07	1984-06-07 00:00:00	1984-06-28	1984-06-28 00:00:00	32020		\N	53863	0	444814009	40481087		0
13833	817	40481087	1993-04-02	1993-04-02 00:00:00	1993-04-23	1993-04-23 00:00:00	32020		\N	54146	0	444814009	40481087		0
13997	826	381316	1988-06-09	1988-06-09 00:00:00	\N	\N	32020		\N	54769	0	230690007	381316		0
14258	842	4027663	1934-11-21	1934-11-21 00:00:00	\N	\N	32020		\N	55636	0	13200003	4027663		0
14354	847	4237458	1967-02-02	1967-02-02 00:00:00	1967-04-03	1967-04-03 00:00:00	32020		\N	56136	0	58150001	4237458		0
14530	859	260139	1970-05-26	1970-05-26 00:00:00	1970-06-09	1970-06-09 00:00:00	32020		\N	56751	0	10509002	260139		0
14687	866	4156265	2007-03-22	2007-03-22 00:00:00	2007-04-05	2007-04-05 00:00:00	32020		\N	57488	0	370247008	4156265		0
14920	879	4294548	1981-09-15	1981-09-15 00:00:00	1981-11-10	1981-11-10 00:00:00	32020		\N	58524	0	75498004	4294548		0
15051	886	40481087	1988-08-17	1988-08-17 00:00:00	1988-09-07	1988-09-07 00:00:00	32020		\N	59093	0	444814009	40481087		0
15241	902	4112343	1969-09-13	1969-09-13 00:00:00	1969-09-20	1969-09-20 00:00:00	32020		\N	60049	0	195662009	4112343		0
15412	914	40481087	2007-09-05	2007-09-05 00:00:00	2007-09-26	2007-09-26 00:00:00	32020		\N	60717	0	444814009	40481087		0
15515	918	372328	1921-05-06	1921-05-06 00:00:00	1921-08-05	1921-08-05 00:00:00	32020		\N	61144	0	65363002	372328		0
15710	929	4112343	1946-01-01	1946-01-01 00:00:00	1946-01-14	1946-01-14 00:00:00	32020		\N	61785	0	195662009	4112343		0
15830	936	260139	1992-03-12	1992-03-12 00:00:00	1992-03-19	1992-03-19 00:00:00	32020		\N	62287	0	10509002	260139		0
16046	949	40481087	1989-09-24	1989-09-24 00:00:00	1989-10-01	1989-10-01 00:00:00	32020		\N	63043	0	444814009	40481087		0
16214	959	4266809	1995-01-31	1995-01-31 00:00:00	\N	\N	32020		\N	63775	0	397881000	4266809		0
16347	967	4283893	1983-08-04	1983-08-04 00:00:00	1983-11-10	1983-11-10 00:00:00	32020		\N	64348	0	36971009	4283893		0
16489	973	4112343	2001-04-02	2001-04-02 00:00:00	2001-04-12	2001-04-12 00:00:00	32020		\N	64743	0	195662009	4112343		0
16728	992	439777	1969-08-19	1969-08-19 00:00:00	\N	\N	32020		\N	65770	0	271737000	439777		0
16896	1004	260139	1986-12-13	1986-12-13 00:00:00	1986-12-20	1986-12-20 00:00:00	32020		\N	66383	0	10509002	260139		0
17027	1017	4112343	1966-10-15	1966-10-15 00:00:00	1966-10-27	1966-10-27 00:00:00	32020		\N	66988	0	195662009	4112343		0
27724	1635	40481087	2007-11-25	2007-11-25 00:00:00	2007-12-09	2007-12-09 00:00:00	32020		\N	109821	0	444814009	40481087		0
27893	1646	4112343	1981-10-22	1981-10-22 00:00:00	1981-11-02	1981-11-02 00:00:00	32020		\N	110381	0	195662009	4112343		0
17525	1053	80180	2015-03-11	2015-03-11 00:00:00	\N	\N	32020		\N	69008	0	396275006	80180		0
17684	1062	80180	2000-08-29	2000-08-29 00:00:00	\N	\N	32020		\N	69648	0	396275006	80180		0
17908	1077	4112343	1978-07-02	1978-07-02 00:00:00	1978-07-15	1978-07-15 00:00:00	32020		\N	70590	0	195662009	4112343		0
18008	1082	4112343	1975-01-04	1975-01-04 00:00:00	1975-01-13	1975-01-13 00:00:00	32020		\N	70973	0	195662009	4112343		0
18188	1092	260139	1981-01-10	1981-01-10 00:00:00	1981-01-17	1981-01-17 00:00:00	32020		\N	71751	0	10509002	260139		0
18303	1100	40479768	2010-11-15	2010-11-15 00:00:00	2010-12-22	2010-12-22 00:00:00	32020		\N	72276	0	444470001	40479768		0
18524	1115	4142905	1958-01-14	1958-01-14 00:00:00	1958-02-13	1958-02-13 00:00:00	32020		\N	73385	0	33737001	4142905		0
18677	1123	260139	1977-03-26	1977-03-26 00:00:00	1977-04-09	1977-04-09 00:00:00	32020		\N	73999	0	10509002	260139		0
18856	1134	4134304	2013-07-02	2013-07-02 00:00:00	2013-08-01	2013-08-01 00:00:00	32020		\N	74731	0	263102004	4134304		0
19024	1143	4112343	1978-06-20	1978-06-20 00:00:00	1978-07-02	1978-07-02 00:00:00	32020		\N	75426	0	195662009	4112343		0
19170	1148	4112343	2017-05-06	2017-05-06 00:00:00	2017-05-17	2017-05-17 00:00:00	32020		\N	75923	0	195662009	4112343		0
19359	1159	372328	1984-03-15	1984-03-15 00:00:00	1984-06-30	1984-06-30 00:00:00	32020		\N	76537	0	65363002	372328		0
30064	1779	4084167	1946-12-07	1946-12-07 00:00:00	1946-12-07	1946-12-07 00:00:00	32020		\N	119063	0	241929008	4084167		0
19719	1185	4278672	2008-02-11	2008-02-11 00:00:00	2008-04-11	2008-04-11 00:00:00	32020		\N	78150	0	65966004	4278672		0
30394	1793	372328	1921-02-26	1921-02-26 00:00:00	1921-05-18	1921-05-18 00:00:00	32020		\N	120201	0	65363002	372328		0
20024	1206	372328	1964-11-06	1964-11-06 00:00:00	1965-01-18	1965-01-18 00:00:00	32020		\N	79254	0	65363002	372328		0
20210	1215	372328	1975-04-23	1975-04-23 00:00:00	1975-09-06	1975-09-06 00:00:00	32020		\N	80028	0	65363002	372328		0
20319	1223	260139	1989-07-31	1989-07-31 00:00:00	1989-08-07	1989-08-07 00:00:00	32020		\N	80476	0	10509002	260139		0
20541	1235	40481087	1997-07-21	1997-07-21 00:00:00	1997-08-04	1997-08-04 00:00:00	32020		\N	81321	0	444814009	40481087		0
20708	1245	260139	2011-05-29	2011-05-29 00:00:00	2011-06-05	2011-06-05 00:00:00	32020		\N	81909	0	10509002	260139		0
20833	1250	4112343	1996-05-22	1996-05-22 00:00:00	1996-05-30	1996-05-30 00:00:00	32020		\N	82322	0	195662009	4112343		0
20977	1259	78272	1991-02-15	1991-02-15 00:00:00	1991-03-01	1991-03-01 00:00:00	32020		\N	82964	0	70704007	78272		0
21223	1273	40481087	1968-06-28	1968-06-28 00:00:00	1968-07-19	1968-07-19 00:00:00	32020		\N	84006	0	444814009	40481087		0
10736	636	40481087	1998-05-21	1998-05-21 00:00:00	1998-06-04	1998-06-04 00:00:00	32020		\N	42139	0	444814009	40481087		0
10876	644	80180	2013-05-30	2013-05-30 00:00:00	\N	\N	32020		\N	42673	0	396275006	80180		0
11070	653	372328	1954-12-21	1954-12-21 00:00:00	1955-01-04	1955-01-04 00:00:00	32020		\N	43267	0	65363002	372328		0
11254	664	372328	1983-11-26	1983-11-26 00:00:00	1983-12-10	1983-12-10 00:00:00	32020		\N	43860	0	65363002	372328		0
11372	672	40481087	1980-10-09	1980-10-09 00:00:00	1980-10-30	1980-10-30 00:00:00	32020		\N	44337	0	444814009	40481087		0
22083	1320	4156265	2019-05-25	2019-05-25 00:00:00	2019-06-15	2019-06-15 00:00:00	32020		\N	87479	0	370247008	4156265		0
11705	691	40481087	2006-09-09	2006-09-09 00:00:00	2006-09-23	2006-09-23 00:00:00	32020		\N	45781	0	444814009	40481087		0
11892	703	40481087	2018-11-01	2018-11-01 00:00:00	2018-11-08	2018-11-08 00:00:00	32020		\N	46460	0	444814009	40481087		0
12040	711	196456	1967-01-29	1967-01-29 00:00:00	1967-01-29	1967-01-29 00:00:00	32020		\N	47196	0	235919008	196456		0
12268	726	40481087	2018-07-13	2018-07-13 00:00:00	2018-07-20	2018-07-20 00:00:00	32020		\N	48116	0	444814009	40481087		0
12340	729	4112343	2015-12-03	2015-12-03 00:00:00	2015-12-11	2015-12-11 00:00:00	32020		\N	48413	0	195662009	4112343		0
12529	742	260139	1972-08-22	1972-08-22 00:00:00	1972-08-29	1972-08-29 00:00:00	32020		\N	49218	0	10509002	260139		0
12731	753	40481087	1970-02-15	1970-02-15 00:00:00	1970-02-22	1970-02-22 00:00:00	32020		\N	49773	0	444814009	40481087		0
12902	759	4112343	1961-12-04	1961-12-04 00:00:00	1961-12-17	1961-12-17 00:00:00	32020		\N	50375	0	195662009	4112343		0
13011	764	40481087	1990-05-04	1990-05-04 00:00:00	1990-05-25	1990-05-25 00:00:00	32020		\N	50816	0	444814009	40481087		0
13205	776	40481087	1977-11-16	1977-11-16 00:00:00	1977-11-30	1977-11-30 00:00:00	32020		\N	51525	0	444814009	40481087		0
13346	785	372328	1969-06-15	1969-06-15 00:00:00	1969-11-23	1969-11-23 00:00:00	32020		\N	52287	0	65363002	372328		0
24108	1438	372328	1954-05-31	1954-05-31 00:00:00	1954-07-02	1954-07-02 00:00:00	32020		\N	95811	0	65363002	372328		0
13740	812	260139	2006-07-06	2006-07-06 00:00:00	2006-07-13	2006-07-13 00:00:00	32020		\N	53864	0	10509002	260139		0
13834	817	40481087	1969-07-21	1969-07-21 00:00:00	1969-08-04	1969-08-04 00:00:00	32020		\N	54182	0	444814009	40481087		0
13998	826	4134304	2013-09-26	2013-09-26 00:00:00	2013-12-25	2013-12-25 00:00:00	32020		\N	54739	0	263102004	4134304		0
14259	842	4112343	1933-01-22	1933-01-22 00:00:00	1933-01-29	1933-01-29 00:00:00	32020		\N	55636	0	195662009	4112343		0
14355	847	80180	2011-06-11	2011-06-11 00:00:00	\N	\N	32020		\N	56118	0	396275006	80180		0
14531	859	81151	1961-02-11	1961-02-11 00:00:00	1961-03-11	1961-03-11 00:00:00	32020		\N	56713	0	44465007	81151		0
14688	866	4112343	1994-04-16	1994-04-16 00:00:00	1994-04-26	1994-04-26 00:00:00	32020		\N	57491	0	195662009	4112343		0
14921	879	372328	2011-09-13	2011-09-13 00:00:00	2012-04-09	2012-04-09 00:00:00	32020		\N	58550	0	65363002	372328		0
15052	886	40481087	2019-06-15	2019-06-15 00:00:00	\N	\N	32020		\N	59064	0	444814009	40481087		0
15242	902	40481087	1957-05-14	1957-05-14 00:00:00	1957-05-28	1957-05-28 00:00:00	32020		\N	60014	0	444814009	40481087		0
15413	914	4112343	1980-01-25	1980-01-25 00:00:00	1980-02-07	1980-02-07 00:00:00	32020		\N	60716	0	195662009	4112343		0
15516	918	260139	1991-11-14	1991-11-14 00:00:00	1991-11-28	1991-11-28 00:00:00	32020		\N	61123	0	10509002	260139		0
15726	931	4112343	2006-04-19	2006-04-19 00:00:00	2006-04-28	2006-04-28 00:00:00	32020		\N	61928	0	195662009	4112343		0
15831	936	4285898	2001-10-08	2001-10-08 00:00:00	\N	\N	32020		\N	62259	0	68496003	4285898		0
16047	949	40481087	2012-08-26	2012-08-26 00:00:00	2012-09-02	2012-09-02 00:00:00	32020		\N	63060	0	444814009	40481087		0
16215	959	80180	1995-01-31	1995-01-31 00:00:00	\N	\N	32020		\N	63775	0	396275006	80180		0
16348	967	40481087	2016-08-24	2016-08-24 00:00:00	2016-08-31	2016-08-31 00:00:00	32020		\N	64306	0	444814009	40481087		0
16490	973	40481087	1970-12-07	1970-12-07 00:00:00	1970-12-28	1970-12-28 00:00:00	32020		\N	64836	0	444814009	40481087		0
16729	992	40481087	1990-11-23	1990-11-23 00:00:00	1990-12-14	1990-12-14 00:00:00	32020		\N	65806	0	444814009	40481087		0
16897	1004	260139	1970-12-30	1970-12-30 00:00:00	1971-01-06	1971-01-06 00:00:00	32020		\N	66358	0	10509002	260139		0
17028	1017	4029498	1970-06-12	1970-06-12 00:00:00	\N	\N	32020		\N	67002	0	128613002	4029498		0
27725	1635	372328	1975-05-06	1975-05-06 00:00:00	1975-09-24	1975-09-24 00:00:00	32020		\N	109823	0	65363002	372328		0
27894	1646	40481087	1964-06-02	1964-06-02 00:00:00	1964-06-16	1964-06-16 00:00:00	32020		\N	110428	0	444814009	40481087		0
17526	1053	195588	2014-01-20	2014-01-20 00:00:00	2014-03-04	2014-03-04 00:00:00	32020		\N	69008	0	38822007	195588		0
17685	1062	40481087	1987-11-16	1987-11-16 00:00:00	1987-11-23	1987-11-23 00:00:00	32020		\N	69650	0	444814009	40481087		0
17909	1077	4278672	1963-10-16	1963-10-16 00:00:00	1964-01-14	1964-01-14 00:00:00	32020		\N	70602	0	65966004	4278672		0
18009	1082	80180	1989-09-30	1989-09-30 00:00:00	\N	\N	32020		\N	70905	0	396275006	80180		0
18189	1092	4278672	2000-11-29	2000-11-29 00:00:00	2001-02-27	2001-02-27 00:00:00	32020		\N	71801	0	65966004	4278672		0
18304	1100	4283893	1987-08-09	1987-08-09 00:00:00	1987-11-15	1987-11-15 00:00:00	32020		\N	72278	0	36971009	4283893		0
18525	1115	260139	2000-10-11	2000-10-11 00:00:00	2000-10-25	2000-10-25 00:00:00	32020		\N	73373	0	10509002	260139		0
18678	1123	40481087	1969-08-09	1969-08-09 00:00:00	1969-08-30	1969-08-30 00:00:00	32020		\N	73998	0	444814009	40481087		0
18857	1134	372328	1940-09-23	1940-09-23 00:00:00	1941-02-09	1941-02-09 00:00:00	32020		\N	74724	0	65363002	372328		0
19025	1143	260139	1992-02-05	1992-02-05 00:00:00	1992-02-12	1992-02-12 00:00:00	32020		\N	75443	0	10509002	260139		0
19171	1148	260139	1964-03-19	1964-03-19 00:00:00	1964-03-26	1964-03-26 00:00:00	32020		\N	75920	0	10509002	260139		0
19360	1159	40481087	2001-11-28	2001-11-28 00:00:00	2001-12-12	2001-12-12 00:00:00	32020		\N	76574	0	444814009	40481087		0
30065	1779	4027663	1968-11-19	1968-11-19 00:00:00	\N	\N	32020		\N	119086	0	13200003	4027663		0
19720	1185	40480160	2008-02-11	2008-02-11 00:00:00	2008-04-11	2008-04-11 00:00:00	32020		\N	78150	0	443165006	40480160		0
30395	1793	4027663	1951-06-04	1951-06-04 00:00:00	\N	\N	32020		\N	120196	0	13200003	4027663		0
20030	1208	40481087	1982-01-10	1982-01-10 00:00:00	1982-01-24	1982-01-24 00:00:00	32020		\N	79334	0	444814009	40481087		0
20211	1216	40481087	2009-12-21	2009-12-21 00:00:00	2010-01-11	2010-01-11 00:00:00	32020		\N	80115	0	444814009	40481087		0
20320	1223	81151	1995-01-15	1995-01-15 00:00:00	1995-02-05	1995-02-05 00:00:00	32020		\N	80447	0	44465007	81151		0
20543	1235	81151	1980-02-29	1980-02-29 00:00:00	1980-03-14	1980-03-14 00:00:00	32020		\N	81337	0	44465007	81151		0
20709	1245	40481087	1943-06-30	1943-06-30 00:00:00	1943-07-07	1943-07-07 00:00:00	32020		\N	81979	0	444814009	40481087		0
20834	1250	40481087	1982-05-23	1982-05-23 00:00:00	1982-06-06	1982-06-06 00:00:00	32020		\N	82318	0	444814009	40481087		0
20978	1259	40481087	1968-10-28	1968-10-28 00:00:00	1968-11-04	1968-11-04 00:00:00	32020		\N	82973	0	444814009	40481087		0
21224	1273	80180	1976-08-19	1976-08-19 00:00:00	\N	\N	32020		\N	83998	0	396275006	80180		0
10737	636	4294548	1958-06-20	1958-06-20 00:00:00	1958-08-01	1958-08-01 00:00:00	32020		\N	42118	0	75498004	4294548		0
10877	644	40481087	2002-05-14	2002-05-14 00:00:00	2002-06-04	2002-06-04 00:00:00	32020		\N	42658	0	444814009	40481087		0
11071	653	4112343	1999-12-31	1999-12-31 00:00:00	2000-01-13	2000-01-13 00:00:00	32020		\N	43226	0	195662009	4112343		0
11255	665	4112343	1997-12-11	1997-12-11 00:00:00	1997-12-24	1997-12-24 00:00:00	32020		\N	43993	0	195662009	4112343		0
11373	672	4112343	1995-04-27	1995-04-27 00:00:00	1995-05-05	1995-05-05 00:00:00	32020		\N	44351	0	195662009	4112343		0
22084	1320	372328	1937-02-15	1937-02-15 00:00:00	1937-08-05	1937-08-05 00:00:00	32020		\N	87487	0	65363002	372328		0
11706	691	4218389	1991-09-17	1991-09-17 00:00:00	1991-10-15	1991-10-15 00:00:00	32020		\N	45787	0	39848009	4218389		0
11893	703	260139	1992-06-19	1992-06-19 00:00:00	1992-07-03	1992-07-03 00:00:00	32020		\N	46437	0	10509002	260139		0
12041	711	4112343	1954-08-06	1954-08-06 00:00:00	1954-08-13	1954-08-13 00:00:00	32020		\N	47191	0	195662009	4112343		0
12269	726	4112343	1978-06-24	1978-06-24 00:00:00	1978-07-04	1978-07-04 00:00:00	32020		\N	48060	0	195662009	4112343		0
12341	729	192671	2000-04-28	2000-04-28 00:00:00	\N	\N	32020		\N	48405	0	K92.2	35208414		0
12530	742	260139	1926-06-10	1926-06-10 00:00:00	1926-06-24	1926-06-24 00:00:00	32020		\N	49104	0	10509002	260139		0
12732	753	40481087	2006-09-23	2006-09-23 00:00:00	2006-09-30	2006-09-30 00:00:00	32020		\N	49745	0	444814009	40481087		0
12903	759	313217	2003-02-19	2003-02-19 00:00:00	\N	\N	32020		\N	50367	0	49436004	313217		0
13012	764	260139	1997-01-08	1997-01-08 00:00:00	1997-01-15	1997-01-15 00:00:00	32020		\N	50834	0	10509002	260139		0
13206	776	78272	1959-08-25	1959-08-25 00:00:00	1959-09-15	1959-09-15 00:00:00	32020		\N	51567	0	70704007	78272		0
13347	785	40481087	1978-06-30	1978-06-30 00:00:00	1978-07-14	1978-07-14 00:00:00	32020		\N	52296	0	444814009	40481087		0
24109	1438	4112343	1982-04-10	1982-04-10 00:00:00	1982-04-19	1982-04-19 00:00:00	32020		\N	95839	0	195662009	4112343		0
13741	812	81151	1983-08-11	1983-08-11 00:00:00	1983-08-25	1983-08-25 00:00:00	32020		\N	53889	0	44465007	81151		0
13835	817	372328	1958-09-21	1958-09-21 00:00:00	1958-10-23	1958-10-23 00:00:00	32020		\N	54139	0	65363002	372328		0
13999	826	257012	2015-02-20	2015-02-20 00:00:00	\N	\N	32020		\N	54706	0	40055000	257012		0
14260	842	40481087	1952-02-13	1952-02-13 00:00:00	1952-02-20	1952-02-20 00:00:00	32020		\N	55622	0	444814009	40481087		0
14356	847	260139	2007-11-30	2007-11-30 00:00:00	2007-12-14	2007-12-14 00:00:00	32020		\N	56122	0	10509002	260139		0
14532	859	260139	1976-11-02	1976-11-02 00:00:00	1976-11-09	1976-11-09 00:00:00	32020		\N	56753	0	10509002	260139		0
14689	866	372328	1962-10-23	1962-10-23 00:00:00	1963-08-25	1963-08-25 00:00:00	32020		\N	57468	0	65363002	372328		0
14922	879	4278672	1986-02-17	1986-02-17 00:00:00	1986-03-19	1986-03-19 00:00:00	32020		\N	58580	0	65966004	4278672		0
15053	886	4112343	1998-02-02	1998-02-02 00:00:00	1998-02-15	1998-02-15 00:00:00	32020		\N	59080	0	195662009	4112343		0
15243	902	40481087	1969-03-11	1969-03-11 00:00:00	1969-03-25	1969-03-25 00:00:00	32020		\N	60035	0	444814009	40481087		0
15414	914	4059173	2013-05-20	2013-05-20 00:00:00	2013-07-19	2013-07-19 00:00:00	32020		\N	60732	0	16114001	4059173		0
15517	918	372328	1913-10-07	1913-10-07 00:00:00	1913-11-14	1913-11-14 00:00:00	32020		\N	61190	0	65363002	372328		0
15727	931	4113008	1965-05-07	1965-05-07 00:00:00	1965-05-21	1965-05-21 00:00:00	32020		\N	61958	0	284549007	4113008		0
15832	936	30753	2000-12-12	2000-12-12 00:00:00	\N	\N	32020		\N	62259	0	16761005	30753		0
16048	949	260139	2005-10-17	2005-10-17 00:00:00	2005-10-31	2005-10-31 00:00:00	32020		\N	63044	0	10509002	260139		0
16491	973	260139	1993-12-03	1993-12-03 00:00:00	1993-12-10	1993-12-10 00:00:00	32020		\N	64744	0	10509002	260139		0
16730	992	260139	1960-07-03	1960-07-03 00:00:00	1960-07-10	1960-07-10 00:00:00	32020		\N	65764	0	10509002	260139		0
16898	1004	4266809	2001-01-19	2001-01-19 00:00:00	\N	\N	32020		\N	66396	0	397881000	4266809		0
17030	1017	4112343	1967-03-28	1967-03-28 00:00:00	1967-04-07	1967-04-07 00:00:00	32020		\N	66952	0	195662009	4112343		0
27726	1636	4112343	1997-08-05	1997-08-05 00:00:00	1997-08-17	1997-08-17 00:00:00	32020		\N	109914	0	195662009	4112343		0
27895	1646	40481087	1999-09-13	1999-09-13 00:00:00	1999-09-20	1999-09-20 00:00:00	32020		\N	110373	0	444814009	40481087		0
17527	1053	257012	1976-08-11	1976-08-11 00:00:00	\N	\N	32020		\N	69004	0	40055000	257012		0
17686	1062	40481087	1975-09-05	1975-09-05 00:00:00	1975-09-12	1975-09-12 00:00:00	32020		\N	69685	0	444814009	40481087		0
17910	1077	40481087	2004-12-20	2004-12-20 00:00:00	2005-01-03	2005-01-03 00:00:00	32020		\N	70596	0	444814009	40481087		0
18010	1082	30753	1989-08-01	1989-08-01 00:00:00	\N	\N	32020		\N	70905	0	16761005	30753		0
18190	1092	40481087	1997-06-07	1997-06-07 00:00:00	1997-06-14	1997-06-14 00:00:00	32020		\N	71821	0	444814009	40481087		0
18305	1100	40481087	1994-08-17	1994-08-17 00:00:00	1994-08-31	1994-08-31 00:00:00	32020		\N	72292	0	444814009	40481087		0
18526	1115	4113008	1964-10-09	1964-10-09 00:00:00	1964-10-30	1964-10-30 00:00:00	32020		\N	73386	0	284549007	4113008		0
18679	1123	372328	1968-12-30	1968-12-30 00:00:00	1969-05-01	1969-05-01 00:00:00	32020		\N	74015	0	65363002	372328		0
18858	1134	40481087	1953-10-31	1953-10-31 00:00:00	1953-11-14	1953-11-14 00:00:00	32020		\N	74665	0	444814009	40481087		0
19026	1143	260139	1979-08-16	1979-08-16 00:00:00	1979-08-30	1979-08-30 00:00:00	32020		\N	75416	0	10509002	260139		0
19172	1148	40481087	1977-08-31	1977-08-31 00:00:00	1977-09-14	1977-09-14 00:00:00	32020		\N	75922	0	444814009	40481087		0
19361	1159	40481087	2014-07-14	2014-07-14 00:00:00	2014-07-28	2014-07-28 00:00:00	32020		\N	76575	0	444814009	40481087		0
30066	1779	4112343	1997-05-23	1997-05-23 00:00:00	1997-06-04	1997-06-04 00:00:00	32020		\N	119049	0	195662009	4112343		0
19721	1185	4112343	1973-02-04	1973-02-04 00:00:00	1973-02-15	1973-02-15 00:00:00	32020		\N	78159	0	195662009	4112343		0
30396	1793	260139	2002-06-16	2002-06-16 00:00:00	2002-06-30	2002-06-30 00:00:00	32020		\N	120269	0	10509002	260139		0
20031	1208	372328	1945-08-11	1945-08-11 00:00:00	1945-12-11	1945-12-11 00:00:00	32020		\N	79369	0	65363002	372328		0
20212	1216	260139	2005-12-18	2005-12-18 00:00:00	2005-12-25	2005-12-25 00:00:00	32020		\N	80099	0	10509002	260139		0
20321	1223	260139	1989-05-23	1989-05-23 00:00:00	1989-05-30	1989-05-30 00:00:00	32020		\N	80455	0	10509002	260139		0
20544	1235	40481087	1998-10-04	1998-10-04 00:00:00	1998-10-25	1998-10-25 00:00:00	32020		\N	81322	0	444814009	40481087		0
20710	1245	28060	1947-08-31	1947-08-31 00:00:00	1947-09-08	1947-09-08 00:00:00	32020		\N	81980	0	43878008	28060		0
20835	1250	260139	1963-11-18	1963-11-18 00:00:00	1963-11-25	1963-11-25 00:00:00	32020		\N	82317	0	10509002	260139		0
20979	1259	4112343	2005-03-11	2005-03-11 00:00:00	2005-03-24	2005-03-24 00:00:00	32020		\N	82978	0	195662009	4112343		0
21225	1273	378419	2011-10-24	2011-10-24 00:00:00	\N	\N	32020		\N	83993	0	26929004	378419		0
10738	636	40481087	2004-05-01	2004-05-01 00:00:00	2004-05-15	2004-05-15 00:00:00	32020		\N	42182	0	444814009	40481087		0
10878	644	260139	1980-09-26	1980-09-26 00:00:00	1980-10-10	1980-10-10 00:00:00	32020		\N	42643	0	10509002	260139		0
11072	653	4112343	2008-12-15	2008-12-15 00:00:00	2008-12-22	2008-12-22 00:00:00	32020		\N	43274	0	195662009	4112343		0
11256	665	40481087	2010-10-23	2010-10-23 00:00:00	2010-11-06	2010-11-06 00:00:00	32020		\N	43944	0	444814009	40481087		0
11374	672	40481087	1993-04-13	1993-04-13 00:00:00	1993-05-04	1993-05-04 00:00:00	32020		\N	44372	0	444814009	40481087		0
22085	1320	4146173	1972-04-01	1972-04-01 00:00:00	1972-05-31	1972-05-31 00:00:00	32020		\N	87513	0	307731004	4146173		0
11707	691	40481087	1985-11-18	1985-11-18 00:00:00	1985-11-25	1985-11-25 00:00:00	32020		\N	45745	0	444814009	40481087		0
11894	703	4112343	2015-11-05	2015-11-05 00:00:00	2015-11-12	2015-11-12 00:00:00	32020		\N	46459	0	195662009	4112343		0
12042	711	372328	1955-05-30	1955-05-30 00:00:00	1955-12-02	1955-12-02 00:00:00	32020		\N	47069	0	65363002	372328		0
12270	726	40481087	1986-12-12	1986-12-12 00:00:00	1986-12-19	1986-12-19 00:00:00	32020		\N	48087	0	444814009	40481087		0
12342	729	80180	2000-04-07	2000-04-07 00:00:00	\N	\N	32020		\N	48365	0	396275006	80180		0
12531	742	4112343	1970-02-05	1970-02-05 00:00:00	1970-02-18	1970-02-18 00:00:00	32020		\N	49126	0	195662009	4112343		0
12733	753	40481087	2019-01-21	2019-01-21 00:00:00	2019-02-04	2019-02-04 00:00:00	32020		\N	49815	0	444814009	40481087		0
12904	759	260139	1962-10-03	1962-10-03 00:00:00	1962-10-17	1962-10-17 00:00:00	32020		\N	50435	0	10509002	260139		0
13013	764	260139	1992-05-16	1992-05-16 00:00:00	1992-05-30	1992-05-30 00:00:00	32020		\N	50813	0	10509002	260139		0
13207	776	40481087	2002-01-22	2002-01-22 00:00:00	2002-02-12	2002-02-12 00:00:00	32020		\N	51562	0	444814009	40481087		0
13348	785	40481087	2014-10-08	2014-10-08 00:00:00	2014-10-29	2014-10-29 00:00:00	32020		\N	52266	0	444814009	40481087		0
24110	1438	4218389	1980-09-01	1980-09-01 00:00:00	1980-09-22	1980-09-22 00:00:00	32020		\N	95850	0	39848009	4218389		0
13742	812	4112343	1996-10-05	1996-10-05 00:00:00	1996-10-14	1996-10-14 00:00:00	32020		\N	53869	0	195662009	4112343		0
13836	817	4112343	2017-04-11	2017-04-11 00:00:00	2017-04-21	2017-04-21 00:00:00	32020		\N	54151	0	195662009	4112343		0
14000	826	4112343	2019-01-07	2019-01-07 00:00:00	2019-01-18	2019-01-18 00:00:00	32020		\N	54707	0	195662009	4112343		0
14261	842	4112343	1955-02-18	1955-02-18 00:00:00	1955-03-02	1955-03-02 00:00:00	32020		\N	55638	0	195662009	4112343		0
14362	850	40481087	1961-04-11	1961-04-11 00:00:00	1961-05-02	1961-05-02 00:00:00	32020		\N	56189	0	444814009	40481087		0
14533	859	40481087	1988-10-26	1988-10-26 00:00:00	1988-11-02	1988-11-02 00:00:00	32020		\N	56882	0	444814009	40481087		0
14690	866	4112343	1966-05-08	1966-05-08 00:00:00	1966-05-19	1966-05-19 00:00:00	32020		\N	57464	0	195662009	4112343		0
14923	879	40481087	1982-08-14	1982-08-14 00:00:00	1982-09-04	1982-09-04 00:00:00	32020		\N	58558	0	444814009	40481087		0
15054	886	4112343	1994-03-13	1994-03-13 00:00:00	1994-03-24	1994-03-24 00:00:00	32020		\N	59088	0	195662009	4112343		0
15244	902	80180	1991-09-05	1991-09-05 00:00:00	\N	\N	32020		\N	60038	0	396275006	80180		0
15415	914	4112343	1945-11-27	1945-11-27 00:00:00	1945-12-06	1945-12-06 00:00:00	32020		\N	60754	0	195662009	4112343		0
15518	918	372328	1978-08-01	1978-08-01 00:00:00	1978-11-03	1978-11-03 00:00:00	32020		\N	61191	0	65363002	372328		0
15728	931	40481087	1999-05-05	1999-05-05 00:00:00	1999-05-19	1999-05-19 00:00:00	32020		\N	61980	0	444814009	40481087		0
15833	936	80180	2002-05-06	2002-05-06 00:00:00	\N	\N	32020		\N	62259	0	396275006	80180		0
16049	949	40481087	2006-02-15	2006-02-15 00:00:00	2006-02-22	2006-02-22 00:00:00	32020		\N	62989	0	444814009	40481087		0
16217	959	40481087	1983-06-19	1983-06-19 00:00:00	1983-06-26	1983-06-26 00:00:00	32020		\N	63671	0	444814009	40481087		0
16350	967	4109685	2019-02-07	2019-02-07 00:00:00	2019-02-28	2019-02-28 00:00:00	32020		\N	64321	0	284551006	4109685		0
16492	973	81151	1965-03-22	1965-03-22 00:00:00	1965-04-26	1965-04-26 00:00:00	32020		\N	64800	0	44465007	81151		0
16731	992	260139	1971-09-14	1971-09-14 00:00:00	1971-09-21	1971-09-21 00:00:00	32020		\N	65766	0	10509002	260139		0
16899	1004	80180	2001-01-19	2001-01-19 00:00:00	\N	\N	32020		\N	66396	0	396275006	80180		0
17031	1017	40481087	1970-01-21	1970-01-21 00:00:00	1970-01-28	1970-01-28 00:00:00	32020		\N	66927	0	444814009	40481087		0
27727	1636	40481087	1995-08-19	1995-08-19 00:00:00	1995-08-26	1995-08-26 00:00:00	32020		\N	109913	0	444814009	40481087		0
27896	1646	4112343	2018-10-06	2018-10-06 00:00:00	2018-10-16	2018-10-16 00:00:00	32020		\N	110375	0	195662009	4112343		0
17528	1054	40481087	1944-01-23	1944-01-23 00:00:00	1944-02-13	1944-02-13 00:00:00	32020		\N	69144	0	444814009	40481087		0
17687	1062	4296205	1972-01-26	1972-01-26 00:00:00	1972-03-01	1972-03-01 00:00:00	32020		\N	69662	0	403191005	4296205		0
17911	1077	4112343	1987-05-30	1987-05-30 00:00:00	1987-06-09	1987-06-09 00:00:00	32020		\N	70587	0	195662009	4112343		0
18011	1082	4278672	1962-11-11	1962-11-11 00:00:00	1962-12-11	1962-12-11 00:00:00	32020		\N	71052	0	65966004	4278672		0
18191	1092	372328	1960-04-30	1960-04-30 00:00:00	1961-03-24	1961-03-24 00:00:00	32020		\N	71759	0	65363002	372328		0
18306	1101	260139	1974-10-19	1974-10-19 00:00:00	1974-11-02	1974-11-02 00:00:00	32020		\N	72356	0	10509002	260139		0
18527	1115	4152936	1984-11-14	1984-11-14 00:00:00	1984-12-05	1984-12-05 00:00:00	32020		\N	73388	0	283385000	4152936		0
18680	1124	260139	1998-11-20	1998-11-20 00:00:00	1998-12-04	1998-12-04 00:00:00	32020		\N	74077	0	10509002	260139		0
18859	1134	4237458	1999-06-16	1999-06-16 00:00:00	1999-07-16	1999-07-16 00:00:00	32020		\N	74730	0	58150001	4237458		0
19027	1143	260139	1983-06-12	1983-06-12 00:00:00	1983-06-19	1983-06-19 00:00:00	32020		\N	75441	0	10509002	260139		0
19173	1148	372328	1959-01-21	1959-01-21 00:00:00	1959-05-23	1959-05-23 00:00:00	32020		\N	75876	0	65363002	372328		0
19362	1159	80180	2014-11-30	2014-11-30 00:00:00	\N	\N	32020		\N	76575	0	396275006	80180		0
30067	1779	4230399	1953-02-01	1953-02-01 00:00:00	1953-05-02	1953-05-02 00:00:00	32020		\N	119065	0	359817006	4230399		0
19722	1185	4218389	1971-05-30	1971-05-30 00:00:00	1971-06-20	1971-06-20 00:00:00	32020		\N	78147	0	39848009	4218389		0
30397	1793	260139	1947-02-16	1947-02-16 00:00:00	1947-03-02	1947-03-02 00:00:00	32020		\N	120239	0	10509002	260139		0
20032	1208	40481087	1968-01-26	1968-01-26 00:00:00	1968-02-02	1968-02-02 00:00:00	32020		\N	79331	0	444814009	40481087		0
20213	1216	80180	2012-05-09	2012-05-09 00:00:00	\N	\N	32020		\N	80085	0	396275006	80180		0
20322	1223	28060	1975-12-07	1975-12-07 00:00:00	1975-12-14	1975-12-14 00:00:00	32020		\N	80452	0	43878008	28060		0
20545	1235	78272	2004-01-13	2004-01-13 00:00:00	2004-02-10	2004-02-10 00:00:00	32020		\N	81340	0	70704007	78272		0
20711	1245	40481087	1968-11-02	1968-11-02 00:00:00	1968-11-23	1968-11-23 00:00:00	32020		\N	81953	0	444814009	40481087		0
20836	1250	4218389	1987-05-13	1987-05-13 00:00:00	1987-06-17	1987-06-17 00:00:00	32020		\N	82336	0	39848009	4218389		0
20980	1259	4112343	2005-11-23	2005-11-23 00:00:00	2005-12-05	2005-12-05 00:00:00	32020		\N	82931	0	195662009	4112343		0
21226	1273	4112343	1973-12-07	1973-12-07 00:00:00	1973-12-16	1973-12-16 00:00:00	32020		\N	84017	0	195662009	4112343		0
10739	636	260139	1998-11-16	1998-11-16 00:00:00	1998-11-23	1998-11-23 00:00:00	32020		\N	42104	0	10509002	260139		0
10879	644	4278672	1982-09-29	1982-09-29 00:00:00	1982-11-28	1982-11-28 00:00:00	32020		\N	42666	0	65966004	4278672		0
11073	653	4112343	2002-10-01	2002-10-01 00:00:00	2002-10-14	2002-10-14 00:00:00	32020		\N	43256	0	195662009	4112343		0
11257	665	40481087	1979-01-06	1979-01-06 00:00:00	1979-01-27	1979-01-27 00:00:00	32020		\N	43979	0	444814009	40481087		0
11375	672	260139	2004-11-15	2004-11-15 00:00:00	2004-11-22	2004-11-22 00:00:00	32020		\N	44405	0	10509002	260139		0
22086	1320	4112343	1960-08-01	1960-08-01 00:00:00	1960-08-13	1960-08-13 00:00:00	32020		\N	87559	0	195662009	4112343		0
11708	691	28060	1959-05-07	1959-05-07 00:00:00	1959-05-14	1959-05-14 00:00:00	32020		\N	45783	0	43878008	28060		0
11895	703	40481087	2004-05-26	2004-05-26 00:00:00	2004-06-09	2004-06-09 00:00:00	32020		\N	46441	0	444814009	40481087		0
12043	711	40481087	1976-10-29	1976-10-29 00:00:00	1976-11-12	1976-11-12 00:00:00	32020		\N	47193	0	444814009	40481087		0
12271	726	260139	1984-08-18	1984-08-18 00:00:00	1984-08-25	1984-08-25 00:00:00	32020		\N	48112	0	10509002	260139		0
12343	729	81151	2000-01-22	2000-01-22 00:00:00	2000-02-26	2000-02-26 00:00:00	32020		\N	48365	0	44465007	81151		0
12532	742	260139	1974-08-14	1974-08-14 00:00:00	1974-08-21	1974-08-21 00:00:00	32020		\N	49127	0	10509002	260139		0
12734	753	372328	1970-12-07	1970-12-07 00:00:00	1971-02-28	1971-02-28 00:00:00	32020		\N	49776	0	65363002	372328		0
12905	759	4310024	1978-02-24	1978-02-24 00:00:00	\N	\N	32020		\N	50360	0	424802006	4310024		0
13014	764	4059173	2012-05-30	2012-05-30 00:00:00	2012-06-29	2012-06-29 00:00:00	32020		\N	50859	0	16114001	4059173		0
13208	776	40481087	1986-09-02	1986-09-02 00:00:00	1986-09-16	1986-09-16 00:00:00	32020		\N	51521	0	444814009	40481087		0
13349	785	260139	1989-08-15	1989-08-15 00:00:00	1989-08-22	1989-08-22 00:00:00	32020		\N	52286	0	10509002	260139		0
24111	1438	378001	1966-02-03	1966-02-03 00:00:00	1966-04-04	1966-04-04 00:00:00	32020		\N	95848	0	62106007	378001		0
13743	812	4112343	1977-08-20	1977-08-20 00:00:00	1977-08-30	1977-08-30 00:00:00	32020		\N	53853	0	195662009	4112343		0
13837	817	257012	2005-05-31	2005-05-31 00:00:00	\N	\N	32020		\N	54093	0	40055000	257012		0
14001	826	375671	1998-03-19	1998-03-19 00:00:00	1998-05-18	1998-05-18 00:00:00	32020		\N	54738	0	62564004	375671		0
14262	842	317576	2017-11-04	2017-11-04 00:00:00	\N	\N	32020		\N	55686	0	53741008	317576		0
14363	850	4112343	2013-03-14	2013-03-14 00:00:00	2013-03-27	2013-03-27 00:00:00	32020		\N	56241	0	195662009	4112343		0
14534	859	4218389	2018-03-13	2018-03-13 00:00:00	2018-04-10	2018-04-10 00:00:00	32020		\N	56880	0	39848009	4218389		0
14691	866	4112343	2003-06-12	2003-06-12 00:00:00	2003-06-19	2003-06-19 00:00:00	32020		\N	57479	0	195662009	4112343		0
14924	879	40481087	1984-12-28	1984-12-28 00:00:00	1985-01-04	1985-01-04 00:00:00	32020		\N	58559	0	444814009	40481087		0
15055	886	260139	1995-11-29	1995-11-29 00:00:00	1995-12-06	1995-12-06 00:00:00	32020		\N	59077	0	10509002	260139		0
15245	902	372328	1990-12-11	1990-12-11 00:00:00	1992-09-05	1992-09-05 00:00:00	32020		\N	60038	0	65363002	372328		0
15416	914	4283893	1971-08-17	1971-08-17 00:00:00	1972-03-14	1972-03-14 00:00:00	32020		\N	60690	0	36971009	4283893		0
15519	918	4218389	1998-10-05	1998-10-05 00:00:00	1998-11-09	1998-11-09 00:00:00	32020		\N	61204	0	39848009	4218389		0
15729	931	80180	2000-03-25	2000-03-25 00:00:00	\N	\N	32020		\N	61980	0	396275006	80180		0
15834	936	40481087	1992-12-07	1992-12-07 00:00:00	1992-12-21	1992-12-21 00:00:00	32020		\N	62266	0	444814009	40481087		0
16050	949	4112343	1968-06-24	1968-06-24 00:00:00	1968-07-01	1968-07-01 00:00:00	32020		\N	63026	0	195662009	4112343		0
16218	959	4027663	1984-03-19	1984-03-19 00:00:00	\N	\N	32020		\N	63671	0	13200003	4027663		0
16351	967	260139	1987-06-16	1987-06-16 00:00:00	1987-06-23	1987-06-23 00:00:00	32020		\N	64353	0	10509002	260139		0
16493	973	260139	1944-07-27	1944-07-27 00:00:00	1944-08-03	1944-08-03 00:00:00	32020		\N	64738	0	10509002	260139		0
16732	992	4296204	1993-03-26	1993-03-26 00:00:00	1993-04-23	1993-04-23 00:00:00	32020		\N	65749	0	403190006	4296204		0
16900	1004	4285898	2000-08-22	2000-08-22 00:00:00	\N	\N	32020		\N	66396	0	68496003	4285898		0
17032	1017	4294548	2010-02-07	2010-02-07 00:00:00	2010-06-13	2010-06-13 00:00:00	32020		\N	66954	0	75498004	4294548		0
27728	1636	260139	1963-08-03	1963-08-03 00:00:00	1963-08-10	1963-08-10 00:00:00	32020		\N	109861	0	10509002	260139		0
27919	1649	28060	1963-08-29	1963-08-29 00:00:00	1963-09-09	1963-09-09 00:00:00	32020		\N	110657	0	43878008	28060		0
17529	1054	378001	1988-01-07	1988-01-07 00:00:00	1988-03-07	1988-03-07 00:00:00	32020		\N	69135	0	62106007	378001		0
17688	1062	4112343	1994-07-30	1994-07-30 00:00:00	1994-08-12	1994-08-12 00:00:00	32020		\N	69686	0	195662009	4112343		0
17912	1077	40481087	2016-09-08	2016-09-08 00:00:00	2016-09-15	2016-09-15 00:00:00	32020		\N	70597	0	444814009	40481087		0
18012	1082	372328	1958-04-20	1958-04-20 00:00:00	1958-07-26	1958-07-26 00:00:00	32020		\N	70926	0	65363002	372328		0
18192	1092	4112343	1989-04-21	1989-04-21 00:00:00	1989-05-04	1989-05-04 00:00:00	32020		\N	71752	0	195662009	4112343		0
18307	1101	80180	2016-01-25	2016-01-25 00:00:00	\N	\N	32020		\N	72330	0	396275006	80180		0
18528	1115	80180	1987-05-17	1987-05-17 00:00:00	\N	\N	32020		\N	73391	0	396275006	80180		0
18681	1124	4156265	1939-09-15	1939-09-15 00:00:00	1939-10-06	1939-10-06 00:00:00	32020		\N	74109	0	370247008	4156265		0
18860	1134	28060	1948-01-30	1948-01-30 00:00:00	1948-02-06	1948-02-06 00:00:00	32020		\N	74662	0	43878008	28060		0
19028	1143	4112343	2004-01-05	2004-01-05 00:00:00	2004-01-16	2004-01-16 00:00:00	32020		\N	75420	0	195662009	4112343		0
19174	1149	81151	2004-12-21	2004-12-21 00:00:00	2005-01-04	2005-01-04 00:00:00	32020		\N	75946	0	44465007	81151		0
19363	1159	40481087	1992-06-10	1992-06-10 00:00:00	1992-06-24	1992-06-24 00:00:00	32020		\N	76585	0	444814009	40481087		0
30068	1779	40481087	1952-09-24	1952-09-24 00:00:00	1952-10-01	1952-10-01 00:00:00	32020		\N	119012	0	444814009	40481087		0
19723	1185	260139	2012-08-30	2012-08-30 00:00:00	2012-09-13	2012-09-13 00:00:00	32020		\N	78107	0	10509002	260139		0
30398	1793	40481087	2001-04-08	2001-04-08 00:00:00	2001-04-22	2001-04-22 00:00:00	32020		\N	120268	0	444814009	40481087		0
20033	1208	4094814	2009-03-14	2009-03-14 00:00:00	\N	\N	32020		\N	79377	0	262574004	4094814		0
20214	1216	261325	2013-01-08	2013-01-08 00:00:00	\N	\N	32020		\N	80107	0	87433001	261325		0
20323	1223	313217	2012-05-11	2012-05-11 00:00:00	\N	\N	32020		\N	80504	0	49436004	313217		0
20546	1235	40481087	2000-03-24	2000-03-24 00:00:00	2000-04-07	2000-04-07 00:00:00	32020		\N	81323	0	444814009	40481087		0
20712	1245	80180	1976-09-06	1976-09-06 00:00:00	\N	\N	32020		\N	81890	0	396275006	80180		0
20837	1250	40481087	1993-02-13	1993-02-13 00:00:00	1993-03-06	1993-03-06 00:00:00	32020		\N	82374	0	444814009	40481087		0
20981	1259	4027663	1973-03-23	1973-03-23 00:00:00	\N	\N	32020		\N	83013	0	13200003	4027663		0
21227	1273	40481087	2008-09-20	2008-09-20 00:00:00	2008-10-11	2008-10-11 00:00:00	32020		\N	84065	0	444814009	40481087		0
10740	636	40481087	2005-05-18	2005-05-18 00:00:00	2005-05-25	2005-05-25 00:00:00	32020		\N	42141	0	444814009	40481087		0
10880	644	4112343	2001-08-02	2001-08-02 00:00:00	2001-08-12	2001-08-12 00:00:00	32020		\N	42613	0	195662009	4112343		0
11074	653	40481087	2008-11-30	2008-11-30 00:00:00	2008-12-21	2008-12-21 00:00:00	32020		\N	43264	0	444814009	40481087		0
11258	665	40481087	1964-07-08	1964-07-08 00:00:00	1964-07-15	1964-07-15 00:00:00	32020		\N	43941	0	444814009	40481087		0
11376	672	4149245	2000-02-17	2000-02-17 00:00:00	2000-04-24	2000-04-24 00:00:00	32020		\N	44414	0	30832001	4149245		0
22087	1320	40481087	2018-03-29	2018-03-29 00:00:00	2018-04-05	2018-04-05 00:00:00	32020		\N	87486	0	444814009	40481087		0
11709	691	372328	1992-09-09	1992-09-09 00:00:00	1993-08-24	1993-08-24 00:00:00	32020		\N	45804	0	65363002	372328		0
11896	703	260139	2009-05-04	2009-05-04 00:00:00	2009-05-18	2009-05-18 00:00:00	32020		\N	46438	0	10509002	260139		0
12044	711	4116491	2009-12-07	2009-12-07 00:00:00	2010-01-10	2010-01-10 00:00:00	32020		\N	47086	0	301011002	4116491		0
12272	726	260139	2013-05-23	2013-05-23 00:00:00	2013-06-06	2013-06-06 00:00:00	32020		\N	48088	0	10509002	260139		0
12344	729	40481087	2001-09-07	2001-09-07 00:00:00	2001-09-28	2001-09-28 00:00:00	32020		\N	48370	0	444814009	40481087		0
12533	742	378419	2012-12-17	2012-12-17 00:00:00	\N	\N	32020		\N	49197	0	26929004	378419		0
12735	753	4112343	2011-07-05	2011-07-05 00:00:00	2011-07-18	2011-07-18 00:00:00	32020		\N	49799	0	195662009	4112343		0
12906	759	4109685	1977-01-20	1977-01-20 00:00:00	1977-02-10	1977-02-10 00:00:00	32020		\N	50360	0	284551006	4109685		0
13015	764	4112343	2006-11-13	2006-11-13 00:00:00	2006-11-25	2006-11-25 00:00:00	32020		\N	50835	0	195662009	4112343		0
13220	778	260139	2008-01-22	2008-01-22 00:00:00	2008-02-05	2008-02-05 00:00:00	32020		\N	51647	0	10509002	260139		0
13350	785	4112343	1969-10-10	1969-10-10 00:00:00	1969-10-23	1969-10-23 00:00:00	32020		\N	52285	0	195662009	4112343		0
24112	1438	40481087	1958-04-21	1958-04-21 00:00:00	1958-05-05	1958-05-05 00:00:00	32020		\N	95778	0	444814009	40481087		0
13744	812	4109685	1970-01-07	1970-01-07 00:00:00	1970-01-21	1970-01-21 00:00:00	32020		\N	53887	0	284551006	4109685		0
13854	820	40481087	2000-05-26	2000-05-26 00:00:00	2000-06-09	2000-06-09 00:00:00	32020		\N	54359	0	444814009	40481087		0
14002	826	4112343	2006-04-05	2006-04-05 00:00:00	2006-04-14	2006-04-14 00:00:00	32020		\N	54700	0	195662009	4112343		0
14263	842	4156265	1968-11-15	1968-11-15 00:00:00	1968-11-29	1968-11-29 00:00:00	32020		\N	55711	0	370247008	4156265		0
14364	850	40481087	2010-12-18	2010-12-18 00:00:00	2011-01-08	2011-01-08 00:00:00	32020		\N	56207	0	444814009	40481087		0
14535	859	40481087	1986-07-02	1986-07-02 00:00:00	1986-07-16	1986-07-16 00:00:00	32020		\N	56825	0	444814009	40481087		0
14692	866	40481087	1981-11-19	1981-11-19 00:00:00	1981-12-03	1981-12-03 00:00:00	32020		\N	57466	0	444814009	40481087		0
14925	879	372328	1953-04-06	1953-04-06 00:00:00	1953-04-20	1953-04-20 00:00:00	32020		\N	58525	0	65363002	372328		0
15056	886	40481087	1991-11-30	1991-11-30 00:00:00	1991-12-14	1991-12-14 00:00:00	32020		\N	59094	0	444814009	40481087		0
15246	902	40481087	2009-01-01	2009-01-01 00:00:00	2009-01-22	2009-01-22 00:00:00	32020		\N	60050	0	444814009	40481087		0
15417	914	4218389	2016-08-02	2016-08-02 00:00:00	2016-08-23	2016-08-23 00:00:00	32020		\N	60783	0	39848009	4218389		0
15520	919	4294548	2002-02-06	2002-02-06 00:00:00	2002-02-13	2002-02-13 00:00:00	32020		\N	61242	0	75498004	4294548		0
15730	931	40481087	2015-12-09	2015-12-09 00:00:00	2015-12-23	2015-12-23 00:00:00	32020		\N	61930	0	444814009	40481087		0
15835	936	192671	2002-05-22	2002-05-22 00:00:00	\N	\N	32020		\N	62271	0	K92.2	35208414		0
16051	949	40481087	1970-12-14	1970-12-14 00:00:00	1971-01-04	1971-01-04 00:00:00	32020		\N	63027	0	444814009	40481087		0
16219	959	260139	1978-07-01	1978-07-01 00:00:00	1978-07-15	1978-07-15 00:00:00	32020		\N	63697	0	10509002	260139		0
16352	967	260139	1984-08-01	1984-08-01 00:00:00	1984-08-08	1984-08-08 00:00:00	32020		\N	64303	0	10509002	260139		0
16494	973	4155034	2016-06-02	2016-06-02 00:00:00	2016-06-16	2016-06-16 00:00:00	32020		\N	64829	0	283371005	4155034		0
16733	992	257012	1957-10-19	1957-10-19 00:00:00	\N	\N	32020		\N	65769	0	40055000	257012		0
16901	1004	4112343	1981-02-02	1981-02-02 00:00:00	1981-02-09	1981-02-09 00:00:00	32020		\N	66381	0	195662009	4112343		0
17033	1017	40481087	1977-12-25	1977-12-25 00:00:00	1978-01-01	1978-01-01 00:00:00	32020		\N	66929	0	444814009	40481087		0
27729	1636	30753	1999-06-19	1999-06-19 00:00:00	\N	\N	32020		\N	109908	0	16761005	30753		0
27920	1649	40481087	2011-02-18	2011-02-18 00:00:00	2011-03-04	2011-03-04 00:00:00	32020		\N	110658	0	444814009	40481087		0
17530	1054	4266809	1973-01-25	1973-01-25 00:00:00	\N	\N	32020		\N	69151	0	397881000	4266809		0
17689	1062	40481087	2018-01-15	2018-01-15 00:00:00	2018-01-22	2018-01-22 00:00:00	32020		\N	69687	0	444814009	40481087		0
17913	1077	28060	1996-02-05	1996-02-05 00:00:00	1996-02-13	1996-02-13 00:00:00	32020		\N	70636	0	43878008	28060		0
18013	1082	4112343	1971-01-15	1971-01-15 00:00:00	1971-01-23	1971-01-23 00:00:00	32020		\N	70929	0	195662009	4112343		0
18193	1092	30753	1991-04-29	1991-04-29 00:00:00	\N	\N	32020		\N	71752	0	16761005	30753		0
18308	1101	4152936	2014-10-06	2014-10-06 00:00:00	2014-10-20	2014-10-20 00:00:00	32020		\N	72330	0	283385000	4152936		0
18529	1115	28060	1967-01-29	1967-01-29 00:00:00	1967-02-08	1967-02-08 00:00:00	32020		\N	73452	0	43878008	28060		0
18682	1124	4278672	1945-08-19	1945-08-19 00:00:00	1945-10-18	1945-10-18 00:00:00	32020		\N	74111	0	65966004	4278672		0
18861	1134	80180	1978-09-09	1978-09-09 00:00:00	\N	\N	32020		\N	74671	0	396275006	80180		0
19029	1143	4294548	1981-11-08	1981-11-08 00:00:00	1982-04-18	1982-04-18 00:00:00	32020		\N	75427	0	75498004	4294548		0
19175	1149	40481087	1993-04-03	1993-04-03 00:00:00	1993-04-17	1993-04-17 00:00:00	32020		\N	75960	0	444814009	40481087		0
19364	1159	372328	1986-05-21	1986-05-21 00:00:00	1986-07-12	1986-07-12 00:00:00	32020		\N	76538	0	65363002	372328		0
30069	1779	260139	1945-12-11	1945-12-11 00:00:00	1945-12-25	1945-12-25 00:00:00	32020		\N	119070	0	10509002	260139		0
19724	1185	260139	1948-04-21	1948-04-21 00:00:00	1948-04-29	1948-04-29 00:00:00	32020		\N	78178	0	10509002	260139		0
30399	1793	372328	1971-06-20	1971-06-20 00:00:00	1972-03-08	1972-03-08 00:00:00	32020		\N	120217	0	65363002	372328		0
20034	1208	40481087	1962-11-26	1962-11-26 00:00:00	1962-12-17	1962-12-17 00:00:00	32020		\N	79332	0	444814009	40481087		0
20215	1216	4116491	1988-07-24	1988-07-24 00:00:00	1988-09-10	1988-09-10 00:00:00	32020		\N	80089	0	301011002	4116491		0
20324	1223	40481087	2003-12-19	2003-12-19 00:00:00	2004-01-02	2004-01-02 00:00:00	32020		\N	80517	0	444814009	40481087		0
20547	1235	40481087	1978-02-15	1978-02-15 00:00:00	1978-03-08	1978-03-08 00:00:00	32020		\N	81320	0	444814009	40481087		0
20713	1245	40481087	1998-11-25	1998-11-25 00:00:00	1998-12-02	1998-12-02 00:00:00	32020		\N	81943	0	444814009	40481087		0
20838	1250	195588	1984-03-15	1984-03-15 00:00:00	1984-04-30	1984-04-30 00:00:00	32020		\N	82319	0	38822007	195588		0
20982	1259	260139	2001-03-14	2001-03-14 00:00:00	2001-03-21	2001-03-21 00:00:00	32020		\N	83004	0	10509002	260139		0
21228	1273	78272	1943-05-05	1943-05-05 00:00:00	1943-06-02	1943-06-02 00:00:00	32020		\N	84069	0	70704007	78272		0
10741	636	4294548	2003-04-30	2003-04-30 00:00:00	2003-05-28	2003-05-28 00:00:00	32020		\N	42140	0	75498004	4294548		0
10881	644	40481087	1987-10-17	1987-10-17 00:00:00	1987-10-31	1987-10-31 00:00:00	32020		\N	42645	0	444814009	40481087		0
11075	653	4112343	2015-02-21	2015-02-21 00:00:00	2015-03-05	2015-03-05 00:00:00	32020		\N	43275	0	195662009	4112343		0
11259	665	4059173	1966-12-30	1966-12-30 00:00:00	1967-03-30	1967-03-30 00:00:00	32020		\N	43937	0	16114001	4059173		0
11377	672	4156265	1985-03-16	1985-03-16 00:00:00	1985-04-06	1985-04-06 00:00:00	32020		\N	44413	0	370247008	4156265		0
22088	1320	80180	1973-08-15	1973-08-15 00:00:00	\N	\N	32020		\N	87481	0	396275006	80180		0
11710	691	260139	1997-04-25	1997-04-25 00:00:00	1997-05-09	1997-05-09 00:00:00	32020		\N	45784	0	10509002	260139		0
11897	703	4112343	1984-08-07	1984-08-07 00:00:00	1984-08-18	1984-08-18 00:00:00	32020		\N	46457	0	195662009	4112343		0
12045	711	4112343	1972-08-07	1972-08-07 00:00:00	1972-08-14	1972-08-14 00:00:00	32020		\N	47110	0	195662009	4112343		0
12273	726	40481087	1981-05-11	1981-05-11 00:00:00	1981-05-25	1981-05-25 00:00:00	32020		\N	48110	0	444814009	40481087		0
12345	729	4059173	2001-11-17	2001-11-17 00:00:00	2002-01-16	2002-01-16 00:00:00	32020		\N	48366	0	16114001	4059173		0
12534	742	4112343	1965-09-08	1965-09-08 00:00:00	1965-09-15	1965-09-15 00:00:00	32020		\N	49137	0	195662009	4112343		0
12736	754	4237458	1972-09-15	1972-09-15 00:00:00	1972-11-14	1972-11-14 00:00:00	32020		\N	49824	0	58150001	4237458		0
12907	759	40481087	1947-05-01	1947-05-01 00:00:00	1947-05-08	1947-05-08 00:00:00	32020		\N	50411	0	444814009	40481087		0
13016	764	80180	2003-12-24	2003-12-24 00:00:00	\N	\N	32020		\N	50843	0	396275006	80180		0
13221	778	4278672	1988-03-16	1988-03-16 00:00:00	1988-06-14	1988-06-14 00:00:00	32020		\N	51673	0	65966004	4278672		0
13351	785	40481087	2007-07-21	2007-07-21 00:00:00	2007-08-11	2007-08-11 00:00:00	32020		\N	52263	0	444814009	40481087		0
24113	1438	40481087	1966-05-12	1966-05-12 00:00:00	1966-05-19	1966-05-19 00:00:00	32020		\N	95781	0	444814009	40481087		0
13745	812	28060	2016-10-11	2016-10-11 00:00:00	2016-10-24	2016-10-24 00:00:00	32020		\N	53865	0	43878008	28060		0
13855	820	28060	1964-10-22	1964-10-22 00:00:00	1964-10-29	1964-10-29 00:00:00	32020		\N	54304	0	43878008	28060		0
14003	826	40481087	2009-06-10	2009-06-10 00:00:00	2009-07-01	2009-07-01 00:00:00	32020		\N	54720	0	444814009	40481087		0
14264	842	439777	1991-11-07	1991-11-07 00:00:00	\N	\N	32020		\N	55625	0	271737000	439777		0
14365	850	40481087	1947-04-26	1947-04-26 00:00:00	1947-05-17	1947-05-17 00:00:00	32020		\N	56187	0	444814009	40481087		0
14536	859	40481087	1967-06-16	1967-06-16 00:00:00	1967-07-07	1967-07-07 00:00:00	32020		\N	56881	0	444814009	40481087		0
14693	866	260139	1972-10-31	1972-10-31 00:00:00	1972-11-14	1972-11-14 00:00:00	32020		\N	57489	0	10509002	260139		0
14926	879	40481087	2016-12-31	2016-12-31 00:00:00	2017-01-21	2017-01-21 00:00:00	32020		\N	58584	0	444814009	40481087		0
15057	886	40481087	1999-02-11	1999-02-11 00:00:00	1999-02-25	1999-02-25 00:00:00	32020		\N	59061	0	444814009	40481087		0
15247	902	78272	1990-12-15	1990-12-15 00:00:00	1991-01-05	1991-01-05 00:00:00	32020		\N	60000	0	70704007	78272		0
15418	914	4112343	1950-05-18	1950-05-18 00:00:00	1950-05-29	1950-05-29 00:00:00	32020		\N	60709	0	195662009	4112343		0
15521	919	4112343	1992-05-08	1992-05-08 00:00:00	1992-05-17	1992-05-17 00:00:00	32020		\N	61253	0	195662009	4112343		0
15731	931	40481087	1968-03-13	1968-03-13 00:00:00	1968-03-27	1968-03-27 00:00:00	32020		\N	61939	0	444814009	40481087		0
15837	938	260139	1993-12-21	1993-12-21 00:00:00	1994-01-04	1994-01-04 00:00:00	32020		\N	62381	0	10509002	260139		0
16052	949	40481087	1987-10-15	1987-10-15 00:00:00	1987-10-29	1987-10-29 00:00:00	32020		\N	63057	0	444814009	40481087		0
16220	959	40481087	1996-11-23	1996-11-23 00:00:00	1996-12-07	1996-12-07 00:00:00	32020		\N	63681	0	444814009	40481087		0
16353	967	28060	1937-10-31	1937-10-31 00:00:00	1937-11-10	1937-11-10 00:00:00	32020		\N	64333	0	43878008	28060		0
16495	973	4112343	1960-09-13	1960-09-13 00:00:00	1960-09-23	1960-09-23 00:00:00	32020		\N	64833	0	195662009	4112343		0
16734	992	4142905	2009-12-25	2009-12-25 00:00:00	2010-03-25	2010-03-25 00:00:00	32020		\N	65751	0	33737001	4142905		0
16902	1004	40481087	1971-12-29	1971-12-29 00:00:00	1972-01-05	1972-01-05 00:00:00	32020		\N	66375	0	444814009	40481087		0
17034	1017	4112343	2001-01-11	2001-01-11 00:00:00	2001-01-24	2001-01-24 00:00:00	32020		\N	67008	0	195662009	4112343		0
27730	1636	81893	1998-09-22	1998-09-22 00:00:00	\N	\N	32020		\N	109908	0	64766004	81893		0
27921	1649	260139	1969-11-02	1969-11-02 00:00:00	1969-11-16	1969-11-16 00:00:00	32020		\N	110673	0	10509002	260139		0
17531	1054	80180	1973-01-25	1973-01-25 00:00:00	\N	\N	32020		\N	69151	0	396275006	80180		0
17690	1062	372328	1966-12-16	1966-12-16 00:00:00	1967-01-22	1967-01-22 00:00:00	32020		\N	69677	0	65363002	372328		0
17914	1077	40481087	1969-11-09	1969-11-09 00:00:00	1969-11-16	1969-11-16 00:00:00	32020		\N	70650	0	444814009	40481087		0
18014	1083	40481087	2002-10-15	2002-10-15 00:00:00	2002-10-29	2002-10-29 00:00:00	32020		\N	71144	0	444814009	40481087		0
18194	1092	4285898	1992-01-24	1992-01-24 00:00:00	\N	\N	32020		\N	71752	0	68496003	4285898		0
18310	1101	28060	1976-03-12	1976-03-12 00:00:00	1976-03-19	1976-03-19 00:00:00	32020		\N	72340	0	43878008	28060		0
18530	1115	260139	1950-06-27	1950-06-27 00:00:00	1950-07-04	1950-07-04 00:00:00	32020		\N	73489	0	10509002	260139		0
18683	1124	4112343	1950-08-20	1950-08-20 00:00:00	1950-09-01	1950-09-01 00:00:00	32020		\N	74092	0	195662009	4112343		0
18862	1134	372328	1942-02-04	1942-02-04 00:00:00	1942-08-09	1942-08-09 00:00:00	32020		\N	74653	0	65363002	372328		0
19030	1143	4156265	1979-11-12	1979-11-12 00:00:00	1979-11-26	1979-11-26 00:00:00	32020		\N	75455	0	370247008	4156265		0
19176	1149	372328	1981-09-30	1981-09-30 00:00:00	1982-01-05	1982-01-05 00:00:00	32020		\N	75963	0	65363002	372328		0
19365	1159	4152936	2007-09-03	2007-09-03 00:00:00	2007-09-24	2007-09-24 00:00:00	32020		\N	76597	0	283385000	4152936		0
30070	1779	40481087	1993-09-12	1993-09-12 00:00:00	1993-09-26	1993-09-26 00:00:00	32020		\N	118989	0	444814009	40481087		0
19725	1185	4112343	1947-04-22	1947-04-22 00:00:00	1947-05-03	1947-05-03 00:00:00	32020		\N	78178	0	195662009	4112343		0
30400	1793	257012	1933-09-05	1933-09-05 00:00:00	\N	\N	32020		\N	120249	0	40055000	257012		0
20035	1208	40481087	2007-05-08	2007-05-08 00:00:00	2007-05-15	2007-05-15 00:00:00	32020		\N	79336	0	444814009	40481087		0
20216	1216	4278672	1973-03-10	1973-03-10 00:00:00	1973-04-09	1973-04-09 00:00:00	32020		\N	80068	0	65966004	4278672		0
20325	1223	4294548	2012-09-18	2012-09-18 00:00:00	2012-10-09	2012-10-09 00:00:00	32020		\N	80525	0	75498004	4294548		0
20548	1235	28060	2005-02-20	2005-02-20 00:00:00	2005-03-04	2005-03-04 00:00:00	32020		\N	81348	0	43878008	28060		0
20714	1245	313217	2016-07-01	2016-07-01 00:00:00	\N	\N	32020		\N	81923	0	49436004	313217		0
20839	1250	81151	1981-03-26	1981-03-26 00:00:00	1981-04-30	1981-04-30 00:00:00	32020		\N	82334	0	44465007	81151		0
20983	1259	78272	1953-01-02	1953-01-02 00:00:00	1953-01-16	1953-01-16 00:00:00	32020		\N	82961	0	70704007	78272		0
21229	1273	255848	2016-12-26	2016-12-26 00:00:00	\N	\N	32020		\N	84024	0	233604007	255848		0
10742	636	4112343	2004-01-04	2004-01-04 00:00:00	2004-01-12	2004-01-12 00:00:00	32020		\N	42156	0	195662009	4112343		0
10882	644	4116491	1997-10-16	1997-10-16 00:00:00	1997-11-23	1997-11-23 00:00:00	32020		\N	42657	0	301011002	4116491		0
11076	653	4112343	1998-06-26	1998-06-26 00:00:00	1998-07-08	1998-07-08 00:00:00	32020		\N	43225	0	195662009	4112343		0
11260	665	260139	2006-07-31	2006-07-31 00:00:00	2006-08-07	2006-08-07 00:00:00	32020		\N	43982	0	10509002	260139		0
11378	672	4109685	1983-02-04	1983-02-04 00:00:00	1983-02-25	1983-02-25 00:00:00	32020		\N	44412	0	284551006	4109685		0
22089	1320	4112343	1983-04-15	1983-04-15 00:00:00	1983-04-23	1983-04-23 00:00:00	32020		\N	87491	0	195662009	4112343		0
11711	691	81151	1966-11-22	1966-11-22 00:00:00	1966-12-13	1966-12-13 00:00:00	32020		\N	45785	0	44465007	81151		0
11898	703	260139	2007-09-08	2007-09-08 00:00:00	2007-09-22	2007-09-22 00:00:00	32020		\N	46476	0	10509002	260139		0
12046	711	260139	1983-04-05	1983-04-05 00:00:00	1983-04-12	1983-04-12 00:00:00	32020		\N	47194	0	10509002	260139		0
12274	726	260139	1988-06-24	1988-06-24 00:00:00	1988-07-01	1988-07-01 00:00:00	32020		\N	48076	0	10509002	260139		0
12346	729	260139	2019-03-20	2019-03-20 00:00:00	2019-03-27	2019-03-27 00:00:00	32020		\N	48429	0	10509002	260139		0
12535	742	28060	1926-11-18	1926-11-18 00:00:00	1926-11-29	1926-11-29 00:00:00	32020		\N	49105	0	43878008	28060		0
12737	754	40481087	1939-08-23	1939-08-23 00:00:00	1939-09-13	1939-09-13 00:00:00	32020		\N	49977	0	444814009	40481087		0
12908	759	260139	2005-07-25	2005-07-25 00:00:00	2005-08-01	2005-08-01 00:00:00	32020		\N	50393	0	10509002	260139		0
13017	764	40481087	1991-09-25	1991-09-25 00:00:00	1991-10-16	1991-10-16 00:00:00	32020		\N	50808	0	444814009	40481087		0
13222	778	260139	1990-03-18	1990-03-18 00:00:00	1990-03-25	1990-03-25 00:00:00	32020		\N	51642	0	10509002	260139		0
13352	785	372328	1968-10-12	1968-10-12 00:00:00	1968-11-17	1968-11-17 00:00:00	32020		\N	52299	0	65363002	372328		0
24114	1438	40481087	1983-05-19	1983-05-19 00:00:00	1983-05-26	1983-05-26 00:00:00	32020		\N	95829	0	444814009	40481087		0
13746	812	80180	2004-12-14	2004-12-14 00:00:00	\N	\N	32020		\N	53870	0	396275006	80180		0
13856	820	40481087	1968-09-03	1968-09-03 00:00:00	1968-09-24	1968-09-24 00:00:00	32020		\N	54290	0	444814009	40481087		0
14004	826	195588	1998-07-07	1998-07-07 00:00:00	1998-08-14	1998-08-14 00:00:00	32020		\N	54719	0	38822007	195588		0
14265	842	4310024	1941-07-17	1941-07-17 00:00:00	\N	\N	32020		\N	55724	0	424802006	4310024		0
14366	850	4112343	1955-09-06	1955-09-06 00:00:00	1955-09-17	1955-09-17 00:00:00	32020		\N	56188	0	195662009	4112343		0
14537	859	4278672	1996-05-09	1996-05-09 00:00:00	1996-06-08	1996-06-08 00:00:00	32020		\N	56874	0	65966004	4278672		0
14694	866	40481087	1988-09-04	1988-09-04 00:00:00	1988-09-11	1988-09-11 00:00:00	32020		\N	57490	0	444814009	40481087		0
14927	879	257012	1981-11-03	1981-11-03 00:00:00	\N	\N	32020		\N	58547	0	40055000	257012		0
15058	887	260139	2007-06-12	2007-06-12 00:00:00	2007-06-19	2007-06-19 00:00:00	32020		\N	59144	0	10509002	260139		0
15248	902	40481087	1964-06-15	1964-06-15 00:00:00	1964-06-29	1964-06-29 00:00:00	32020		\N	59985	0	444814009	40481087		0
15419	914	260139	2006-07-09	2006-07-09 00:00:00	2006-07-16	2006-07-16 00:00:00	32020		\N	60774	0	10509002	260139		0
15522	919	4283893	2002-12-16	2002-12-16 00:00:00	2003-01-13	2003-01-13 00:00:00	32020		\N	61262	0	36971009	4283893		0
15732	931	40481087	2015-01-27	2015-01-27 00:00:00	2015-02-03	2015-02-03 00:00:00	32020		\N	61942	0	444814009	40481087		0
15838	938	4112343	1969-04-15	1969-04-15 00:00:00	1969-04-23	1969-04-23 00:00:00	32020		\N	62326	0	195662009	4112343		0
16053	949	4112343	1993-07-05	1993-07-05 00:00:00	1993-07-13	1993-07-13 00:00:00	32020		\N	63058	0	195662009	4112343		0
16221	959	28060	2017-06-01	2017-06-01 00:00:00	2017-06-09	2017-06-09 00:00:00	32020		\N	63778	0	43878008	28060		0
16354	967	40481087	1955-08-26	1955-08-26 00:00:00	1955-09-09	1955-09-09 00:00:00	32020		\N	64347	0	444814009	40481087		0
16496	973	260139	1916-09-06	1916-09-06 00:00:00	1916-09-20	1916-09-20 00:00:00	32020		\N	64830	0	10509002	260139		0
16735	992	4059173	1997-02-01	1997-02-01 00:00:00	1997-04-02	1997-04-02 00:00:00	32020		\N	65750	0	16114001	4059173		0
16903	1004	4116491	2011-09-29	2011-09-29 00:00:00	2011-11-01	2011-11-01 00:00:00	32020		\N	66379	0	301011002	4116491		0
17035	1017	40481087	1980-01-29	1980-01-29 00:00:00	1980-02-19	1980-02-19 00:00:00	32020		\N	66938	0	444814009	40481087		0
27731	1636	4285898	1999-08-18	1999-08-18 00:00:00	\N	\N	32020		\N	109908	0	68496003	4285898		0
27922	1649	4113008	1988-03-31	1988-03-31 00:00:00	1988-04-21	1988-04-21 00:00:00	32020		\N	110617	0	284549007	4113008		0
17532	1054	4112343	1949-11-21	1949-11-21 00:00:00	1949-11-30	1949-11-30 00:00:00	32020		\N	69140	0	195662009	4112343		0
17691	1062	260139	1983-09-16	1983-09-16 00:00:00	1983-09-23	1983-09-23 00:00:00	32020		\N	69676	0	10509002	260139		0
17915	1077	78272	2007-05-03	2007-05-03 00:00:00	2007-05-17	2007-05-17 00:00:00	32020		\N	70604	0	70704007	78272		0
18015	1083	378001	1978-09-18	1978-09-18 00:00:00	1978-10-18	1978-10-18 00:00:00	32020		\N	71056	0	62106007	378001		0
18195	1092	4112343	2010-03-17	2010-03-17 00:00:00	2010-03-28	2010-03-28 00:00:00	32020		\N	71823	0	195662009	4112343		0
18311	1101	40481087	1986-11-18	1986-11-18 00:00:00	1986-12-02	1986-12-02 00:00:00	32020		\N	72351	0	444814009	40481087		0
18531	1115	372328	1954-01-05	1954-01-05 00:00:00	1954-07-12	1954-07-12 00:00:00	32020		\N	73469	0	65363002	372328		0
18684	1124	4155034	1991-10-01	1991-10-01 00:00:00	1991-10-22	1991-10-22 00:00:00	32020		\N	74113	0	283371005	4155034		0
18863	1134	4112343	1949-06-01	1949-06-01 00:00:00	1949-06-14	1949-06-14 00:00:00	32020		\N	74663	0	195662009	4112343		0
19031	1143	4112343	1982-12-11	1982-12-11 00:00:00	1982-12-23	1982-12-23 00:00:00	32020		\N	75440	0	195662009	4112343		0
19177	1149	80180	2013-08-09	2013-08-09 00:00:00	\N	\N	32020		\N	75964	0	396275006	80180		0
19366	1159	4112343	2012-09-19	2012-09-19 00:00:00	2012-09-26	2012-09-26 00:00:00	32020		\N	76536	0	195662009	4112343		0
30071	1779	40481087	2016-01-08	2016-01-08 00:00:00	2016-01-15	2016-01-15 00:00:00	32020		\N	119001	0	444814009	40481087		0
19726	1185	260139	1962-07-16	1962-07-16 00:00:00	1962-07-30	1962-07-30 00:00:00	32020		\N	78089	0	10509002	260139		0
30401	1793	81151	1953-11-10	1953-11-10 00:00:00	1953-12-08	1953-12-08 00:00:00	32020		\N	120222	0	44465007	81151		0
20036	1208	40481087	2006-01-20	2006-01-20 00:00:00	2006-02-03	2006-02-03 00:00:00	32020		\N	79395	0	444814009	40481087		0
20217	1216	40481087	1997-04-12	1997-04-12 00:00:00	1997-04-19	1997-04-19 00:00:00	32020		\N	80090	0	444814009	40481087		0
20326	1223	375671	2009-03-23	2009-03-23 00:00:00	2009-05-22	2009-05-22 00:00:00	32020		\N	80448	0	62564004	375671		0
20549	1235	4109685	1992-12-20	1992-12-20 00:00:00	1993-01-10	1993-01-10 00:00:00	32020		\N	81339	0	284551006	4109685		0
20715	1245	40481087	1984-02-19	1984-02-19 00:00:00	1984-02-26	1984-02-26 00:00:00	32020		\N	81955	0	444814009	40481087		0
20840	1250	4283893	1994-01-09	1994-01-09 00:00:00	1994-02-27	1994-02-27 00:00:00	32020		\N	82321	0	36971009	4283893		0
20984	1259	40481087	1954-05-04	1954-05-04 00:00:00	1954-05-11	1954-05-11 00:00:00	32020		\N	82941	0	444814009	40481087		0
21230	1273	372328	2009-11-14	2009-11-14 00:00:00	2010-10-18	2010-10-18 00:00:00	32020		\N	83978	0	65363002	372328		0
10743	636	260139	2017-03-19	2017-03-19 00:00:00	2017-03-26	2017-03-26 00:00:00	32020		\N	42158	0	10509002	260139		0
10883	644	372328	1975-12-21	1975-12-21 00:00:00	1976-01-28	1976-01-28 00:00:00	32020		\N	42637	0	65363002	372328		0
11077	653	40481087	1989-01-18	1989-01-18 00:00:00	1989-02-08	1989-02-08 00:00:00	32020		\N	43224	0	444814009	40481087		0
11261	665	4112343	2018-01-21	2018-01-21 00:00:00	2018-02-02	2018-02-02 00:00:00	32020		\N	43976	0	195662009	4112343		0
11379	672	4112343	1972-12-01	1972-12-01 00:00:00	1972-12-10	1972-12-10 00:00:00	32020		\N	44370	0	195662009	4112343		0
22090	1320	80502	1995-06-15	1995-06-15 00:00:00	\N	\N	32020		\N	87506	0	64859006	80502		0
11712	691	80180	1994-12-20	1994-12-20 00:00:00	\N	\N	32020		\N	45795	0	396275006	80180		0
11899	703	4134304	1952-02-11	1952-02-11 00:00:00	1952-04-11	1952-04-11 00:00:00	32020		\N	46507	0	263102004	4134304		0
12047	711	40481087	1959-05-18	1959-05-18 00:00:00	1959-06-01	1959-06-01 00:00:00	32020		\N	47162	0	444814009	40481087		0
12275	726	80180	1991-06-12	1991-06-12 00:00:00	\N	\N	32020		\N	48124	0	396275006	80180		0
12347	729	4237458	1962-07-26	1962-07-26 00:00:00	1962-10-24	1962-10-24 00:00:00	32020		\N	48403	0	58150001	4237458		0
12536	742	4294548	1981-05-03	1981-05-03 00:00:00	1981-05-17	1981-05-17 00:00:00	32020		\N	49139	0	75498004	4294548		0
12738	754	28060	1952-01-11	1952-01-11 00:00:00	1952-01-19	1952-01-19 00:00:00	32020		\N	49846	0	43878008	28060		0
12909	759	80180	1980-06-13	1980-06-13 00:00:00	\N	\N	32020		\N	50453	0	396275006	80180		0
13018	764	4237458	1989-01-01	1989-01-01 00:00:00	1989-01-31	1989-01-31 00:00:00	32020		\N	50858	0	58150001	4237458		0
13223	778	40481087	1987-08-24	1987-08-24 00:00:00	1987-09-14	1987-09-14 00:00:00	32020		\N	51641	0	444814009	40481087		0
13353	785	4112343	1985-02-03	1985-02-03 00:00:00	1985-02-16	1985-02-16 00:00:00	32020		\N	52297	0	195662009	4112343		0
24115	1438	4112343	1965-09-22	1965-09-22 00:00:00	1965-10-04	1965-10-04 00:00:00	32020		\N	95837	0	195662009	4112343		0
13747	812	260139	1996-09-26	1996-09-26 00:00:00	1996-10-10	1996-10-10 00:00:00	32020		\N	53855	0	10509002	260139		0
13857	820	40481087	1989-12-27	1989-12-27 00:00:00	1990-01-10	1990-01-10 00:00:00	32020		\N	54349	0	444814009	40481087		0
14005	826	4156265	2014-10-21	2014-10-21 00:00:00	2014-11-04	2014-11-04 00:00:00	32020		\N	54740	0	370247008	4156265		0
14266	842	40481087	1969-03-12	1969-03-12 00:00:00	1969-04-02	1969-04-02 00:00:00	32020		\N	55644	0	444814009	40481087		0
14367	850	378001	1961-12-01	1961-12-01 00:00:00	1961-12-31	1961-12-31 00:00:00	32020		\N	56236	0	62106007	378001		0
14538	859	260139	2003-06-17	2003-06-17 00:00:00	2003-06-24	2003-06-24 00:00:00	32020		\N	56796	0	10509002	260139		0
14695	866	4112343	2017-04-24	2017-04-24 00:00:00	2017-05-06	2017-05-06 00:00:00	32020		\N	57493	0	195662009	4112343		0
14928	879	40481087	1998-04-01	1998-04-01 00:00:00	1998-04-08	1998-04-08 00:00:00	32020		\N	58560	0	444814009	40481087		0
15059	887	4156265	1974-10-05	1974-10-05 00:00:00	1974-10-19	1974-10-19 00:00:00	32020		\N	59102	0	370247008	4156265		0
15249	902	260139	1973-12-30	1973-12-30 00:00:00	1974-01-06	1974-01-06 00:00:00	32020		\N	60036	0	10509002	260139		0
15420	914	40481087	2005-10-16	2005-10-16 00:00:00	2005-11-06	2005-11-06 00:00:00	32020		\N	60744	0	444814009	40481087		0
15523	919	4112343	1986-08-24	1986-08-24 00:00:00	1986-09-06	1986-09-06 00:00:00	32020		\N	61249	0	195662009	4112343		0
15733	931	372328	1963-01-04	1963-01-04 00:00:00	1963-02-22	1963-02-22 00:00:00	32020		\N	61931	0	65363002	372328		0
15839	938	4112343	1980-04-15	1980-04-15 00:00:00	1980-04-22	1980-04-22 00:00:00	32020		\N	62349	0	195662009	4112343		0
16054	949	260139	1990-03-09	1990-03-09 00:00:00	1990-03-23	1990-03-23 00:00:00	32020		\N	62987	0	10509002	260139		0
16222	959	40481087	2014-10-01	2014-10-01 00:00:00	2014-10-22	2014-10-22 00:00:00	32020		\N	63777	0	444814009	40481087		0
16355	967	4112343	1990-11-04	1990-11-04 00:00:00	1990-11-14	1990-11-14 00:00:00	32020		\N	64354	0	195662009	4112343		0
16497	973	260139	2006-10-11	2006-10-11 00:00:00	2006-10-18	2006-10-18 00:00:00	32020		\N	64878	0	10509002	260139		0
16736	992	4112343	2004-09-19	2004-09-19 00:00:00	2004-09-30	2004-09-30 00:00:00	32020		\N	65773	0	195662009	4112343		0
16904	1004	260139	2003-10-29	2003-10-29 00:00:00	2003-11-05	2003-11-05 00:00:00	32020		\N	66378	0	10509002	260139		0
17036	1017	80180	1997-08-24	1997-08-24 00:00:00	\N	\N	32020		\N	67007	0	396275006	80180		0
27732	1636	372328	1959-08-31	1959-08-31 00:00:00	1960-01-15	1960-01-15 00:00:00	32020		\N	109863	0	65363002	372328		0
27923	1649	80180	1993-05-17	1993-05-17 00:00:00	\N	\N	32020		\N	110623	0	396275006	80180		0
17533	1054	4112343	1972-11-30	1972-11-30 00:00:00	1972-12-12	1972-12-12 00:00:00	32020		\N	69147	0	195662009	4112343		0
17692	1062	4112343	1967-05-31	1967-05-31 00:00:00	1967-06-08	1967-06-08 00:00:00	32020		\N	69649	0	195662009	4112343		0
17916	1077	260139	1950-08-27	1950-08-27 00:00:00	1950-09-10	1950-09-10 00:00:00	32020		\N	70641	0	10509002	260139		0
18016	1083	260139	2016-03-20	2016-03-20 00:00:00	2016-03-27	2016-03-27 00:00:00	32020		\N	71132	0	10509002	260139		0
18196	1092	260139	2009-09-05	2009-09-05 00:00:00	2009-09-12	2009-09-12 00:00:00	32020		\N	71822	0	10509002	260139		0
18312	1101	372328	1979-01-24	1979-01-24 00:00:00	1979-03-25	1979-03-25 00:00:00	32020		\N	72361	0	65363002	372328		0
18532	1115	378001	1982-10-26	1982-10-26 00:00:00	1982-11-25	1982-11-25 00:00:00	32020		\N	73387	0	62106007	378001		0
18685	1124	260139	1975-07-25	1975-07-25 00:00:00	1975-08-01	1975-08-01 00:00:00	32020		\N	74076	0	10509002	260139		0
18864	1134	4112343	1952-05-03	1952-05-03 00:00:00	1952-05-11	1952-05-11 00:00:00	32020		\N	74664	0	195662009	4112343		0
19032	1143	4112343	2004-05-19	2004-05-19 00:00:00	2004-05-26	2004-05-26 00:00:00	32020		\N	75421	0	195662009	4112343		0
19178	1149	40481087	2005-07-21	2005-07-21 00:00:00	2005-08-11	2005-08-11 00:00:00	32020		\N	75961	0	444814009	40481087		0
19367	1159	260139	2010-11-05	2010-11-05 00:00:00	2010-11-19	2010-11-19 00:00:00	32020		\N	76586	0	10509002	260139		0
30072	1779	80180	1976-11-07	1976-11-07 00:00:00	\N	\N	32020		\N	118987	0	396275006	80180		0
19727	1185	40481087	1940-10-16	1940-10-16 00:00:00	1940-10-30	1940-10-30 00:00:00	32020		\N	78192	0	444814009	40481087		0
30402	1793	4112343	1987-10-08	1987-10-08 00:00:00	1987-10-18	1987-10-18 00:00:00	32020		\N	120182	0	195662009	4112343		0
20037	1208	40481087	1995-11-19	1995-11-19 00:00:00	1995-12-10	1995-12-10 00:00:00	32020		\N	79367	0	444814009	40481087		0
20218	1216	378001	1983-08-15	1983-08-15 00:00:00	1983-10-14	1983-10-14 00:00:00	32020		\N	80069	0	62106007	378001		0
20327	1223	260139	1966-01-21	1966-01-21 00:00:00	1966-01-28	1966-01-28 00:00:00	32020		\N	80513	0	10509002	260139		0
20550	1235	4146173	1985-04-01	1985-04-01 00:00:00	1985-05-01	1985-05-01 00:00:00	32020		\N	81314	0	307731004	4146173		0
20716	1245	4296205	1949-02-18	1949-02-18 00:00:00	1949-03-11	1949-03-11 00:00:00	32020		\N	81935	0	403191005	4296205		0
20841	1250	260139	2002-12-02	2002-12-02 00:00:00	2002-12-16	2002-12-16 00:00:00	32020		\N	82376	0	10509002	260139		0
20985	1259	192671	1981-10-16	1981-10-16 00:00:00	\N	\N	32020		\N	82979	0	K92.2	35208414		0
21231	1273	4112343	1972-06-02	1972-06-02 00:00:00	1972-06-11	1972-06-11 00:00:00	32020		\N	84062	0	195662009	4112343		0
10744	636	40481087	2016-03-31	2016-03-31 00:00:00	2016-04-14	2016-04-14 00:00:00	32020		\N	42157	0	444814009	40481087		0
10884	644	260139	2003-11-04	2003-11-04 00:00:00	2003-11-11	2003-11-11 00:00:00	32020		\N	42636	0	10509002	260139		0
11078	653	4112343	1959-02-01	1959-02-01 00:00:00	1959-02-11	1959-02-11 00:00:00	32020		\N	43257	0	195662009	4112343		0
11262	665	260139	1995-08-02	1995-08-02 00:00:00	1995-08-16	1995-08-16 00:00:00	32020		\N	43980	0	10509002	260139		0
11380	672	260139	1965-04-19	1965-04-19 00:00:00	1965-05-03	1965-05-03 00:00:00	32020		\N	44335	0	10509002	260139		0
22091	1320	260139	1990-05-06	1990-05-06 00:00:00	1990-05-20	1990-05-20 00:00:00	32020		\N	87515	0	10509002	260139		0
11713	691	40481087	2004-04-24	2004-04-24 00:00:00	2004-05-15	2004-05-15 00:00:00	32020		\N	45747	0	444814009	40481087		0
11900	703	40481087	1952-08-14	1952-08-14 00:00:00	1952-09-04	1952-09-04 00:00:00	32020		\N	46464	0	444814009	40481087		0
12048	711	81151	2002-03-29	2002-03-29 00:00:00	2002-04-26	2002-04-26 00:00:00	32020		\N	47200	0	44465007	81151		0
12276	727	4113008	1969-08-25	1969-08-25 00:00:00	1969-09-15	1969-09-15 00:00:00	32020		\N	48206	0	284549007	4113008		0
12348	729	40481087	1978-01-08	1978-01-08 00:00:00	1978-01-22	1978-01-22 00:00:00	32020		\N	48426	0	444814009	40481087		0
12537	742	4112343	1978-01-11	1978-01-11 00:00:00	1978-01-18	1978-01-18 00:00:00	32020		\N	49138	0	195662009	4112343		0
12739	754	4294548	1991-12-19	1991-12-19 00:00:00	1992-05-21	1992-05-21 00:00:00	32020		\N	49937	0	75498004	4294548		0
12910	759	4285898	1980-02-14	1980-02-14 00:00:00	\N	\N	32020		\N	50453	0	68496003	4285898		0
13019	764	260139	2010-01-08	2010-01-08 00:00:00	2010-01-15	2010-01-15 00:00:00	32020		\N	50824	0	10509002	260139		0
13224	778	4112343	1980-11-05	1980-11-05 00:00:00	1980-11-12	1980-11-12 00:00:00	32020		\N	51688	0	195662009	4112343		0
13354	785	260139	1966-09-24	1966-09-24 00:00:00	1966-10-08	1966-10-08 00:00:00	32020		\N	52284	0	10509002	260139		0
24116	1438	40481087	1954-09-10	1954-09-10 00:00:00	1954-09-17	1954-09-17 00:00:00	32020		\N	95802	0	444814009	40481087		0
13748	812	28060	1973-10-30	1973-10-30 00:00:00	1973-11-08	1973-11-08 00:00:00	32020		\N	53833	0	43878008	28060		0
13858	820	40481087	1995-09-06	1995-09-06 00:00:00	1995-09-13	1995-09-13 00:00:00	32020		\N	54351	0	444814009	40481087		0
14006	826	260139	1993-03-16	1993-03-16 00:00:00	1993-03-30	1993-03-30 00:00:00	32020		\N	54698	0	10509002	260139		0
14267	842	40481087	1943-11-20	1943-11-20 00:00:00	1943-12-04	1943-12-04 00:00:00	32020		\N	55656	0	444814009	40481087		0
14368	850	4218389	1991-07-11	1991-07-11 00:00:00	1991-08-08	1991-08-08 00:00:00	32020		\N	56238	0	39848009	4218389		0
14539	859	40481087	2004-03-18	2004-03-18 00:00:00	2004-04-01	2004-04-01 00:00:00	32020		\N	56742	0	444814009	40481087		0
14696	866	28060	2015-12-16	2015-12-16 00:00:00	2015-12-27	2015-12-27 00:00:00	32020		\N	57492	0	43878008	28060		0
14929	879	80180	1989-02-16	1989-02-16 00:00:00	\N	\N	32020		\N	58529	0	396275006	80180		0
15060	887	4283893	1971-06-19	1971-06-19 00:00:00	1971-07-10	1971-07-10 00:00:00	32020		\N	59138	0	36971009	4283893		0
15250	902	257012	1963-02-06	1963-02-06 00:00:00	\N	\N	32020		\N	59984	0	40055000	257012		0
15421	914	80180	1989-03-08	1989-03-08 00:00:00	\N	\N	32020		\N	60701	0	396275006	80180		0
15524	919	40481087	2007-09-24	2007-09-24 00:00:00	2007-10-08	2007-10-08 00:00:00	32020		\N	61231	0	444814009	40481087		0
15734	931	260139	1965-12-20	1965-12-20 00:00:00	1965-12-27	1965-12-27 00:00:00	32020		\N	61926	0	10509002	260139		0
15840	938	4113008	1971-04-04	1971-04-04 00:00:00	1971-04-18	1971-04-18 00:00:00	32020		\N	62329	0	284549007	4113008		0
16055	950	372328	1974-02-21	1974-02-21 00:00:00	1974-04-28	1974-04-28 00:00:00	32020		\N	63118	0	65363002	372328		0
16223	959	4112343	1972-01-13	1972-01-13 00:00:00	1972-01-22	1972-01-22 00:00:00	32020		\N	63749	0	195662009	4112343		0
16356	967	4237458	2003-03-12	2003-03-12 00:00:00	2003-06-10	2003-06-10 00:00:00	32020		\N	64318	0	58150001	4237458		0
16498	973	40481087	1917-10-09	1917-10-09 00:00:00	1917-10-30	1917-10-30 00:00:00	32020		\N	64915	0	444814009	40481087		0
16737	992	372328	1956-07-25	1956-07-25 00:00:00	1956-09-23	1956-09-23 00:00:00	32020		\N	65776	0	65363002	372328		0
16905	1004	372328	1965-06-27	1965-06-27 00:00:00	1965-09-16	1965-09-16 00:00:00	32020		\N	66360	0	65363002	372328		0
17037	1017	4112343	1997-07-22	1997-07-22 00:00:00	1997-07-29	1997-07-29 00:00:00	32020		\N	67007	0	195662009	4112343		0
27733	1636	4112343	1987-03-20	1987-03-20 00:00:00	1987-03-30	1987-03-30 00:00:00	32020		\N	109858	0	195662009	4112343		0
27924	1649	378001	1971-08-16	1971-08-16 00:00:00	1971-09-15	1971-09-15 00:00:00	32020		\N	110677	0	62106007	378001		0
17534	1054	40481087	1987-03-22	1987-03-22 00:00:00	1987-04-12	1987-04-12 00:00:00	32020		\N	69149	0	444814009	40481087		0
17693	1062	4112343	1967-01-18	1967-01-18 00:00:00	1967-01-29	1967-01-29 00:00:00	32020		\N	69683	0	195662009	4112343		0
17917	1077	260139	1999-08-14	1999-08-14 00:00:00	1999-08-28	1999-08-28 00:00:00	32020		\N	70642	0	10509002	260139		0
18017	1083	4283893	1982-10-28	1982-10-28 00:00:00	1982-12-30	1982-12-30 00:00:00	32020		\N	71159	0	36971009	4283893		0
18197	1092	372328	1955-09-10	1955-09-10 00:00:00	1955-12-23	1955-12-23 00:00:00	32020		\N	71758	0	65363002	372328		0
18313	1101	40481087	2012-02-17	2012-02-17 00:00:00	2012-03-09	2012-03-09 00:00:00	32020		\N	72360	0	444814009	40481087		0
18533	1115	40481087	1998-08-06	1998-08-06 00:00:00	1998-08-27	1998-08-27 00:00:00	32020		\N	73372	0	444814009	40481087		0
18686	1124	260139	1951-09-20	1951-09-20 00:00:00	1951-10-04	1951-10-04 00:00:00	32020		\N	74096	0	10509002	260139		0
18865	1134	28060	1940-07-26	1940-07-26 00:00:00	1940-08-05	1940-08-05 00:00:00	32020		\N	74661	0	43878008	28060		0
19033	1143	40481087	1990-07-06	1990-07-06 00:00:00	1990-07-13	1990-07-13 00:00:00	32020		\N	75442	0	444814009	40481087		0
19179	1149	372328	1980-02-24	1980-02-24 00:00:00	1980-04-08	1980-04-08 00:00:00	32020		\N	75955	0	65363002	372328		0
19368	1159	40481087	1986-12-12	1986-12-12 00:00:00	1987-01-02	1987-01-02 00:00:00	32020		\N	76572	0	444814009	40481087		0
30073	1779	260139	2009-10-25	2009-10-25 00:00:00	2009-11-01	2009-11-01 00:00:00	32020		\N	119000	0	10509002	260139		0
19728	1185	4112343	2018-06-22	2018-06-22 00:00:00	2018-07-03	2018-07-03 00:00:00	32020		\N	78181	0	195662009	4112343		0
30403	1793	81893	1961-02-26	1961-02-26 00:00:00	\N	\N	32020		\N	120157	0	64766004	81893		0
20038	1208	40481087	1991-10-25	1991-10-25 00:00:00	1991-11-01	1991-11-01 00:00:00	32020		\N	79344	0	444814009	40481087		0
20219	1216	81151	1993-11-20	1993-11-20 00:00:00	1993-12-25	1993-12-25 00:00:00	32020		\N	80070	0	44465007	81151		0
20328	1223	40481087	2000-06-15	2000-06-15 00:00:00	2000-06-29	2000-06-29 00:00:00	32020		\N	80516	0	444814009	40481087		0
20551	1235	81151	1981-04-08	1981-04-08 00:00:00	1981-04-22	1981-04-22 00:00:00	32020		\N	81338	0	44465007	81151		0
20717	1245	40481087	2017-03-16	2017-03-16 00:00:00	2017-03-23	2017-03-23 00:00:00	32020		\N	81881	0	444814009	40481087		0
20842	1250	80180	1991-08-01	1991-08-01 00:00:00	\N	\N	32020		\N	82403	0	396275006	80180		0
20986	1259	40481087	1987-03-26	1987-03-26 00:00:00	1987-04-16	1987-04-16 00:00:00	32020		\N	82982	0	444814009	40481087		0
21232	1273	260139	2004-09-03	2004-09-03 00:00:00	2004-09-10	2004-09-10 00:00:00	32020		\N	83977	0	10509002	260139		0
10745	636	4294548	1993-05-26	1993-05-26 00:00:00	1993-06-09	1993-06-09 00:00:00	32020		\N	42180	0	75498004	4294548		0
10885	644	372328	1977-12-18	1977-12-18 00:00:00	1978-03-29	1978-03-29 00:00:00	32020		\N	42648	0	65363002	372328		0
11079	653	4112343	1983-01-16	1983-01-16 00:00:00	1983-01-23	1983-01-23 00:00:00	32020		\N	43221	0	195662009	4112343		0
11263	665	40481087	2006-07-05	2006-07-05 00:00:00	2006-07-19	2006-07-19 00:00:00	32020		\N	43942	0	444814009	40481087		0
11381	672	260139	1967-03-26	1967-03-26 00:00:00	1967-04-09	1967-04-09 00:00:00	32020		\N	44349	0	10509002	260139		0
22092	1320	4283893	2000-04-03	2000-04-03 00:00:00	2000-04-24	2000-04-24 00:00:00	32020		\N	87581	0	36971009	4283893		0
11714	691	372328	1961-06-21	1961-06-21 00:00:00	1962-06-19	1962-06-19 00:00:00	32020		\N	45779	0	65363002	372328		0
11901	703	4155034	1992-09-13	1992-09-13 00:00:00	1992-09-27	1992-09-27 00:00:00	32020		\N	46510	0	283371005	4155034		0
12049	711	40479422	1978-07-28	1978-07-28 00:00:00	1978-10-03	1978-10-03 00:00:00	32020		\N	47197	0	444448004	40479422		0
12277	727	4237458	1988-08-06	1988-08-06 00:00:00	1988-09-05	1988-09-05 00:00:00	32020		\N	48208	0	58150001	4237458		0
12349	729	4112343	2014-07-30	2014-07-30 00:00:00	2014-08-06	2014-08-06 00:00:00	32020		\N	48398	0	195662009	4112343		0
12538	742	378001	2003-01-13	2003-01-13 00:00:00	2003-03-14	2003-03-14 00:00:00	32020		\N	49192	0	62106007	378001		0
12740	754	260139	1950-08-12	1950-08-12 00:00:00	1950-08-26	1950-08-26 00:00:00	32020		\N	49845	0	10509002	260139		0
12911	759	4266809	1980-06-13	1980-06-13 00:00:00	\N	\N	32020		\N	50453	0	397881000	4266809		0
13020	764	4112343	1985-10-21	1985-10-21 00:00:00	1985-11-02	1985-11-02 00:00:00	32020		\N	50814	0	195662009	4112343		0
13225	778	40481087	1984-12-22	1984-12-22 00:00:00	1984-12-29	1984-12-29 00:00:00	32020		\N	51666	0	444814009	40481087		0
13355	785	80180	2004-07-15	2004-07-15 00:00:00	\N	\N	32020		\N	52253	0	396275006	80180		0
24117	1438	260139	1965-12-15	1965-12-15 00:00:00	1965-12-29	1965-12-29 00:00:00	32020		\N	95838	0	10509002	260139		0
13749	812	40481087	1978-08-26	1978-08-26 00:00:00	1978-09-02	1978-09-02 00:00:00	32020		\N	53834	0	444814009	40481087		0
13859	820	40481087	1965-11-20	1965-11-20 00:00:00	1965-12-11	1965-12-11 00:00:00	32020		\N	54289	0	444814009	40481087		0
14007	826	28060	1998-12-30	1998-12-30 00:00:00	1999-01-08	1999-01-08 00:00:00	32020		\N	54705	0	43878008	28060		0
14268	842	40481087	1964-10-04	1964-10-04 00:00:00	1964-10-25	1964-10-25 00:00:00	32020		\N	55604	0	444814009	40481087		0
14369	850	4112343	2000-10-05	2000-10-05 00:00:00	2000-10-15	2000-10-15 00:00:00	32020		\N	56191	0	195662009	4112343		0
14540	859	81151	2007-08-10	2007-08-10 00:00:00	2007-09-07	2007-09-07 00:00:00	32020		\N	56878	0	44465007	81151		0
14697	867	260139	1984-02-02	1984-02-02 00:00:00	1984-02-16	1984-02-16 00:00:00	32020		\N	57522	0	10509002	260139		0
14930	879	440086	1963-02-08	1963-02-08 00:00:00	1963-06-21	1963-06-21 00:00:00	32020		\N	58556	0	192127007	440086		0
15061	887	372328	1960-04-30	1960-04-30 00:00:00	1960-06-18	1960-06-18 00:00:00	32020		\N	59146	0	65363002	372328		0
15251	902	372328	1952-05-17	1952-05-17 00:00:00	1952-08-02	1952-08-02 00:00:00	32020		\N	60015	0	65363002	372328		0
15422	914	4156265	2004-01-24	2004-01-24 00:00:00	2004-02-07	2004-02-07 00:00:00	32020		\N	60731	0	370247008	4156265		0
15525	919	375671	2004-12-29	2004-12-29 00:00:00	2005-01-28	2005-01-28 00:00:00	32020		\N	61224	0	62564004	375671		0
15735	931	40481087	1972-01-13	1972-01-13 00:00:00	1972-02-03	1972-02-03 00:00:00	32020		\N	61940	0	444814009	40481087		0
15841	938	4134304	1963-12-12	1963-12-12 00:00:00	1964-01-11	1964-01-11 00:00:00	32020		\N	62328	0	263102004	4134304		0
16056	950	4112343	2000-07-30	2000-07-30 00:00:00	2000-08-09	2000-08-09 00:00:00	32020		\N	63068	0	195662009	4112343		0
16224	959	260139	1967-02-08	1967-02-08 00:00:00	1967-02-15	1967-02-15 00:00:00	32020		\N	63695	0	10509002	260139		0
16357	967	40481087	1955-10-17	1955-10-17 00:00:00	1955-11-07	1955-11-07 00:00:00	32020		\N	64272	0	444814009	40481087		0
16499	973	40481087	1927-07-14	1927-07-14 00:00:00	1927-07-28	1927-07-28 00:00:00	32020		\N	64735	0	444814009	40481087		0
16738	992	40481087	1959-03-12	1959-03-12 00:00:00	1959-04-02	1959-04-02 00:00:00	32020		\N	65763	0	444814009	40481087		0
16906	1004	40481087	1986-03-31	1986-03-31 00:00:00	1986-04-21	1986-04-21 00:00:00	32020		\N	66382	0	444814009	40481087		0
17038	1017	40481087	1990-05-03	1990-05-03 00:00:00	1990-05-17	1990-05-17 00:00:00	32020		\N	66953	0	444814009	40481087		0
27734	1636	4134304	2002-04-07	2002-04-07 00:00:00	2002-05-07	2002-05-07 00:00:00	32020		\N	109883	0	263102004	4134304		0
27925	1649	260139	1960-03-18	1960-03-18 00:00:00	1960-03-25	1960-03-25 00:00:00	32020		\N	110680	0	10509002	260139		0
17535	1054	40481087	1988-06-13	1988-06-13 00:00:00	1988-06-20	1988-06-20 00:00:00	32020		\N	69123	0	444814009	40481087		0
17694	1062	372328	1971-10-28	1971-10-28 00:00:00	1972-04-30	1972-04-30 00:00:00	32020		\N	69688	0	65363002	372328		0
17918	1077	260139	1983-10-06	1983-10-06 00:00:00	1983-10-13	1983-10-13 00:00:00	32020		\N	70651	0	10509002	260139		0
18018	1083	4084167	1980-05-06	1980-05-06 00:00:00	1980-05-06	1980-05-06 00:00:00	32020		\N	71057	0	241929008	4084167		0
18198	1092	4027663	1983-10-08	1983-10-08 00:00:00	\N	\N	32020		\N	71775	0	13200003	4027663		0
18314	1101	81151	2009-12-03	2009-12-03 00:00:00	2009-12-31	2009-12-31 00:00:00	32020		\N	72329	0	44465007	81151		0
18534	1115	4048171	1950-07-12	1950-07-12 00:00:00	\N	\N	32020		\N	73343	0	232353008	4048171		0
18687	1124	81151	1971-10-02	1971-10-02 00:00:00	1971-10-16	1971-10-16 00:00:00	32020		\N	74112	0	44465007	81151		0
18866	1134	257012	1993-06-15	1993-06-15 00:00:00	\N	\N	32020		\N	74722	0	40055000	257012		0
19034	1143	80180	2015-04-07	2015-04-07 00:00:00	\N	\N	32020		\N	75464	0	396275006	80180		0
19180	1149	4296205	2011-11-29	2011-11-29 00:00:00	2011-12-27	2011-12-27 00:00:00	32020		\N	75948	0	403191005	4296205		0
19369	1159	40481087	1994-03-22	1994-03-22 00:00:00	1994-04-05	1994-04-05 00:00:00	32020		\N	76573	0	444814009	40481087		0
30074	1779	40481087	1954-11-26	1954-11-26 00:00:00	1954-12-17	1954-12-17 00:00:00	32020		\N	119072	0	444814009	40481087		0
19729	1185	40481087	1971-03-20	1971-03-20 00:00:00	1971-04-03	1971-04-03 00:00:00	32020		\N	78158	0	444814009	40481087		0
30404	1793	260139	1990-05-28	1990-05-28 00:00:00	1990-06-11	1990-06-11 00:00:00	32020		\N	120243	0	10509002	260139		0
20039	1208	28060	1945-05-02	1945-05-02 00:00:00	1945-05-09	1945-05-09 00:00:00	32020		\N	79342	0	43878008	28060		0
20220	1216	28060	1971-03-22	1971-03-22 00:00:00	1971-04-01	1971-04-01 00:00:00	32020		\N	80096	0	43878008	28060		0
20329	1223	257012	1980-12-15	1980-12-15 00:00:00	\N	\N	32020		\N	80514	0	40055000	257012		0
20552	1235	440448	2009-05-19	2009-05-19 00:00:00	\N	\N	32020		\N	81341	0	74400008	440448		0
20718	1245	40481087	1998-05-31	1998-05-31 00:00:00	1998-06-21	1998-06-21 00:00:00	32020		\N	81907	0	444814009	40481087		0
20843	1250	4294548	1988-03-15	1988-03-15 00:00:00	1988-04-05	1988-04-05 00:00:00	32020		\N	82373	0	75498004	4294548		0
20987	1259	40481087	1976-03-03	1976-03-03 00:00:00	1976-03-17	1976-03-17 00:00:00	32020		\N	82974	0	444814009	40481087		0
21246	1276	40481087	2007-01-11	2007-01-11 00:00:00	2007-01-25	2007-01-25 00:00:00	32020		\N	84266	0	444814009	40481087		0
10746	636	313217	1999-05-28	1999-05-28 00:00:00	\N	\N	32020		\N	42125	0	49436004	313217		0
10886	644	4112343	2011-09-20	2011-09-20 00:00:00	2011-09-28	2011-09-28 00:00:00	32020		\N	42646	0	195662009	4112343		0
11080	653	260139	1971-11-23	1971-11-23 00:00:00	1971-12-07	1971-12-07 00:00:00	32020		\N	43259	0	10509002	260139		0
11264	665	4112343	1958-03-21	1958-03-21 00:00:00	1958-03-29	1958-03-29 00:00:00	32020		\N	43951	0	195662009	4112343		0
11382	672	40481087	1989-07-06	1989-07-06 00:00:00	1989-07-27	1989-07-27 00:00:00	32020		\N	44404	0	444814009	40481087		0
22093	1320	4059173	1998-09-12	1998-09-12 00:00:00	1998-11-11	1998-11-11 00:00:00	32020		\N	87477	0	16114001	4059173		0
11715	691	4237458	2019-06-20	2019-06-20 00:00:00	\N	\N	32020		\N	45788	0	58150001	4237458		0
11902	703	80180	1989-02-01	1989-02-01 00:00:00	\N	\N	32020		\N	46505	0	396275006	80180		0
12050	711	4112343	2003-02-02	2003-02-02 00:00:00	2003-02-11	2003-02-11 00:00:00	32020		\N	47085	0	195662009	4112343		0
12278	727	260139	1926-11-26	1926-11-26 00:00:00	1926-12-03	1926-12-03 00:00:00	32020		\N	48142	0	10509002	260139		0
12350	729	260139	1974-01-25	1974-01-25 00:00:00	1974-02-08	1974-02-08 00:00:00	32020		\N	48368	0	10509002	260139		0
12539	742	261325	1960-03-28	1960-03-28 00:00:00	\N	\N	32020		\N	49149	0	87433001	261325		0
12741	754	4283893	2009-05-31	2009-05-31 00:00:00	2010-02-28	2010-02-28 00:00:00	32020		\N	49921	0	36971009	4283893		0
12912	759	40481087	1960-03-06	1960-03-06 00:00:00	1960-03-27	1960-03-27 00:00:00	32020		\N	50373	0	444814009	40481087		0
13021	764	40481087	2013-07-01	2013-07-01 00:00:00	2013-07-15	2013-07-15 00:00:00	32020		\N	50810	0	444814009	40481087		0
13226	778	40481087	2002-12-05	2002-12-05 00:00:00	2002-12-19	2002-12-19 00:00:00	32020		\N	51691	0	444814009	40481087		0
13356	785	4155034	1984-12-17	1984-12-17 00:00:00	1985-01-07	1985-01-07 00:00:00	32020		\N	52252	0	283371005	4155034		0
24118	1438	372328	1953-12-08	1953-12-08 00:00:00	1954-01-01	1954-01-01 00:00:00	32020		\N	95840	0	65363002	372328		0
13750	812	40481087	1984-04-11	1984-04-11 00:00:00	1984-05-02	1984-05-02 00:00:00	32020		\N	53854	0	444814009	40481087		0
13860	820	40481087	2018-05-04	2018-05-04 00:00:00	2018-05-25	2018-05-25 00:00:00	32020		\N	54362	0	444814009	40481087		0
14008	826	4112343	1967-01-04	1967-01-04 00:00:00	1967-01-13	1967-01-13 00:00:00	32020		\N	54712	0	195662009	4112343		0
14269	842	4237458	1940-08-16	1940-08-16 00:00:00	1940-09-15	1940-09-15 00:00:00	32020		\N	55708	0	58150001	4237458		0
14370	850	4027663	1978-02-10	1978-02-10 00:00:00	\N	\N	32020		\N	56255	0	13200003	4027663		0
14541	859	80180	1993-06-18	1993-06-18 00:00:00	\N	\N	32020		\N	56872	0	396275006	80180		0
14698	867	40481087	2010-01-23	2010-01-23 00:00:00	2010-01-30	2010-01-30 00:00:00	32020		\N	57578	0	444814009	40481087		0
14931	879	4112343	1995-12-23	1995-12-23 00:00:00	1995-12-31	1995-12-31 00:00:00	32020		\N	58583	0	195662009	4112343		0
15062	887	4112343	1960-02-03	1960-02-03 00:00:00	1960-02-11	1960-02-11 00:00:00	32020		\N	59108	0	195662009	4112343		0
15252	902	4283893	1963-01-02	1963-01-02 00:00:00	1963-04-17	1963-04-17 00:00:00	32020		\N	59983	0	36971009	4283893		0
15423	914	40481087	1979-10-23	1979-10-23 00:00:00	1979-10-30	1979-10-30 00:00:00	32020		\N	60773	0	444814009	40481087		0
15526	919	78272	1979-05-19	1979-05-19 00:00:00	1979-06-23	1979-06-23 00:00:00	32020		\N	61221	0	70704007	78272		0
15736	931	260139	1975-06-09	1975-06-09 00:00:00	1975-06-23	1975-06-23 00:00:00	32020		\N	61936	0	10509002	260139		0
15842	938	28060	1957-11-01	1957-11-01 00:00:00	1957-11-10	1957-11-10 00:00:00	32020		\N	62315	0	43878008	28060		0
16057	950	40481087	2013-09-19	2013-09-19 00:00:00	2013-10-10	2013-10-10 00:00:00	32020		\N	63088	0	444814009	40481087		0
16225	959	372328	1958-11-21	1958-11-21 00:00:00	1959-03-04	1959-03-04 00:00:00	32020		\N	63769	0	65363002	372328		0
16358	967	260139	2011-07-09	2011-07-09 00:00:00	2011-07-16	2011-07-16 00:00:00	32020		\N	64305	0	10509002	260139		0
16500	973	40481087	1990-12-12	1990-12-12 00:00:00	1990-12-19	1990-12-19 00:00:00	32020		\N	64766	0	444814009	40481087		0
16739	992	40481087	1955-08-18	1955-08-18 00:00:00	1955-08-25	1955-08-25 00:00:00	32020		\N	65767	0	444814009	40481087		0
16907	1004	81893	1999-07-29	1999-07-29 00:00:00	\N	\N	32020		\N	66351	0	64766004	81893		0
17039	1017	260139	2007-02-09	2007-02-09 00:00:00	2007-02-16	2007-02-16 00:00:00	32020		\N	66931	0	10509002	260139		0
27735	1636	40481087	2004-09-12	2004-09-12 00:00:00	2004-09-19	2004-09-19 00:00:00	32020		\N	109859	0	444814009	40481087		0
27926	1649	4113008	1978-05-02	1978-05-02 00:00:00	1978-05-23	1978-05-23 00:00:00	32020		\N	110679	0	284549007	4113008		0
17536	1054	4152936	1984-02-15	1984-02-15 00:00:00	1984-03-07	1984-03-07 00:00:00	32020		\N	69133	0	283385000	4152936		0
17695	1062	260139	1992-08-22	1992-08-22 00:00:00	1992-09-05	1992-09-05 00:00:00	32020		\N	69665	0	10509002	260139		0
17919	1077	260139	1958-11-18	1958-11-18 00:00:00	1958-11-25	1958-11-25 00:00:00	32020		\N	70585	0	10509002	260139		0
18019	1083	4084167	1967-10-11	1967-10-11 00:00:00	1967-10-11	1967-10-11 00:00:00	32020		\N	71055	0	241929008	4084167		0
18199	1092	80180	1992-10-20	1992-10-20 00:00:00	\N	\N	32020		\N	71778	0	396275006	80180		0
18315	1101	40481087	2011-05-30	2011-05-30 00:00:00	2011-06-13	2011-06-13 00:00:00	32020		\N	72359	0	444814009	40481087		0
18535	1115	40481087	2013-09-16	2013-09-16 00:00:00	2013-09-23	2013-09-23 00:00:00	32020		\N	73498	0	444814009	40481087		0
18688	1124	40481087	1989-10-17	1989-10-17 00:00:00	1989-10-24	1989-10-24 00:00:00	32020		\N	74098	0	444814009	40481087		0
18867	1134	40481087	2006-12-17	2006-12-17 00:00:00	2006-12-24	2006-12-24 00:00:00	32020		\N	74692	0	444814009	40481087		0
19035	1143	260139	2012-12-02	2012-12-02 00:00:00	2012-12-16	2012-12-16 00:00:00	32020		\N	75449	0	10509002	260139		0
19181	1149	40481087	1983-09-12	1983-09-12 00:00:00	1983-10-03	1983-10-03 00:00:00	32020		\N	75950	0	444814009	40481087		0
19370	1159	40481087	1985-12-17	1985-12-17 00:00:00	1986-01-07	1986-01-07 00:00:00	32020		\N	76571	0	444814009	40481087		0
30075	1779	260139	1950-01-13	1950-01-13 00:00:00	1950-01-27	1950-01-27 00:00:00	32020		\N	119041	0	10509002	260139		0
19730	1185	40481087	1973-08-29	1973-08-29 00:00:00	1973-09-05	1973-09-05 00:00:00	32020		\N	78160	0	444814009	40481087		0
30405	1793	260139	1977-01-13	1977-01-13 00:00:00	1977-01-20	1977-01-20 00:00:00	32020		\N	120181	0	10509002	260139		0
20040	1208	40481087	1983-05-28	1983-05-28 00:00:00	1983-06-11	1983-06-11 00:00:00	32020		\N	79365	0	444814009	40481087		0
20221	1216	4109685	2006-05-21	2006-05-21 00:00:00	2006-06-04	2006-06-04 00:00:00	32020		\N	80071	0	284551006	4109685		0
20330	1223	4027663	1980-03-01	1980-03-01 00:00:00	\N	\N	32020		\N	80468	0	13200003	4027663		0
20553	1235	4166224	2009-05-19	2009-05-19 00:00:00	\N	\N	32020		\N	81341	0	47693006	4166224		0
20719	1245	40481087	1963-11-08	1963-11-08 00:00:00	1963-11-22	1963-11-22 00:00:00	32020		\N	81911	0	444814009	40481087		0
20844	1250	4237458	1955-03-13	1955-03-13 00:00:00	1955-06-11	1955-06-11 00:00:00	32020		\N	82333	0	58150001	4237458		0
20988	1259	30753	1980-11-11	1980-11-11 00:00:00	\N	\N	32020		\N	83001	0	16761005	30753		0
21247	1276	260139	1967-03-18	1967-03-18 00:00:00	1967-03-25	1967-03-25 00:00:00	32020		\N	84273	0	10509002	260139		0
10747	636	4112343	1960-12-05	1960-12-05 00:00:00	1960-12-18	1960-12-18 00:00:00	32020		\N	42179	0	195662009	4112343		0
10887	644	40481087	1988-08-17	1988-08-17 00:00:00	1988-08-24	1988-08-24 00:00:00	32020		\N	42611	0	444814009	40481087		0
11081	653	260139	1975-01-21	1975-01-21 00:00:00	1975-01-28	1975-01-28 00:00:00	32020		\N	43254	0	10509002	260139		0
11265	665	4296205	1993-01-08	1993-01-08 00:00:00	1993-01-22	1993-01-22 00:00:00	32020		\N	43940	0	403191005	4296205		0
11383	672	4112343	1982-05-24	1982-05-24 00:00:00	1982-05-31	1982-05-31 00:00:00	32020		\N	44371	0	195662009	4112343		0
22094	1320	40480160	1998-09-12	1998-09-12 00:00:00	1998-11-11	1998-11-11 00:00:00	32020		\N	87477	0	443165006	40480160		0
11716	691	4112343	1974-08-25	1974-08-25 00:00:00	1974-09-01	1974-09-01 00:00:00	32020		\N	45743	0	195662009	4112343		0
11903	703	260139	1995-12-24	1995-12-24 00:00:00	1996-01-07	1996-01-07 00:00:00	32020		\N	46458	0	10509002	260139		0
12051	712	28060	1990-07-13	1990-07-13 00:00:00	1990-07-26	1990-07-26 00:00:00	32020		\N	47224	0	43878008	28060		0
12279	727	4278672	1974-03-23	1974-03-23 00:00:00	1974-04-22	1974-04-22 00:00:00	32020		\N	48207	0	65966004	4278672		0
12351	729	40481087	1996-09-21	1996-09-21 00:00:00	1996-09-28	1996-09-28 00:00:00	32020		\N	48369	0	444814009	40481087		0
12540	742	40481087	2011-03-16	2011-03-16 00:00:00	2011-03-23	2011-03-23 00:00:00	32020		\N	49222	0	444814009	40481087		0
12742	754	40481087	1970-07-12	1970-07-12 00:00:00	1970-08-02	1970-08-02 00:00:00	32020		\N	49981	0	444814009	40481087		0
12913	759	40481087	2006-07-12	2006-07-12 00:00:00	2006-07-26	2006-07-26 00:00:00	32020		\N	50383	0	444814009	40481087		0
13022	764	40481087	2014-05-19	2014-05-19 00:00:00	2014-06-02	2014-06-02 00:00:00	32020		\N	50848	0	444814009	40481087		0
13227	778	81151	2001-12-03	2001-12-03 00:00:00	2001-12-17	2001-12-17 00:00:00	32020		\N	51674	0	44465007	81151		0
13357	785	4112343	1989-04-29	1989-04-29 00:00:00	1989-05-06	1989-05-06 00:00:00	32020		\N	52298	0	195662009	4112343		0
24119	1438	40481087	2004-12-06	2004-12-06 00:00:00	2004-12-20	2004-12-20 00:00:00	32020		\N	95810	0	444814009	40481087		0
13751	812	4112343	2005-05-01	2005-05-01 00:00:00	2005-05-10	2005-05-10 00:00:00	32020		\N	53856	0	195662009	4112343		0
13861	820	4112343	1978-07-20	1978-07-20 00:00:00	1978-07-30	1978-07-30 00:00:00	32020		\N	54305	0	195662009	4112343		0
14015	828	257012	1988-09-25	1988-09-25 00:00:00	\N	\N	32020		\N	54842	0	40055000	257012		0
14270	842	4296204	1997-11-30	1997-11-30 00:00:00	1998-01-04	1998-01-04 00:00:00	32020		\N	55662	0	403190006	4296204		0
14371	850	40481087	2013-05-02	2013-05-02 00:00:00	2013-05-09	2013-05-09 00:00:00	32020		\N	56192	0	444814009	40481087		0
14560	862	260139	1977-02-10	1977-02-10 00:00:00	1977-02-24	1977-02-24 00:00:00	32020		\N	57042	0	10509002	260139		0
14699	867	260139	2018-02-26	2018-02-26 00:00:00	2018-03-12	2018-03-12 00:00:00	32020		\N	57550	0	10509002	260139		0
14932	879	81151	1967-04-23	1967-04-23 00:00:00	1967-05-28	1967-05-28 00:00:00	32020		\N	58579	0	44465007	81151		0
15063	887	4218389	2000-08-03	2000-08-03 00:00:00	2000-09-07	2000-09-07 00:00:00	32020		\N	59105	0	39848009	4218389		0
15253	902	260139	1960-08-05	1960-08-05 00:00:00	1960-08-12	1960-08-12 00:00:00	32020		\N	60047	0	10509002	260139		0
15424	914	4134304	2015-06-09	2015-06-09 00:00:00	2015-07-09	2015-07-09 00:00:00	32020		\N	60733	0	263102004	4134304		0
15527	919	260139	1975-09-09	1975-09-09 00:00:00	1975-09-16	1975-09-16 00:00:00	32020		\N	61252	0	10509002	260139		0
15737	931	40481087	2017-12-18	2017-12-18 00:00:00	2018-01-08	2018-01-08 00:00:00	32020		\N	61981	0	444814009	40481087		0
15843	938	40481087	1947-08-15	1947-08-15 00:00:00	1947-08-29	1947-08-29 00:00:00	32020		\N	62324	0	444814009	40481087		0
16058	950	440086	1981-05-21	1981-05-21 00:00:00	1982-04-08	1982-04-08 00:00:00	32020		\N	63108	0	192127007	440086		0
16226	959	372328	1962-07-16	1962-07-16 00:00:00	1963-03-06	1963-03-06 00:00:00	32020		\N	63779	0	65363002	372328		0
16359	967	260139	1939-01-14	1939-01-14 00:00:00	1939-01-28	1939-01-28 00:00:00	32020		\N	64349	0	10509002	260139		0
16501	974	80180	1993-04-06	1993-04-06 00:00:00	\N	\N	32020		\N	64959	0	396275006	80180		0
16740	992	372328	1955-05-15	1955-05-15 00:00:00	1955-07-31	1955-07-31 00:00:00	32020		\N	65775	0	65363002	372328		0
16908	1004	28060	1964-07-06	1964-07-06 00:00:00	1964-07-16	1964-07-16 00:00:00	32020		\N	66357	0	43878008	28060		0
17040	1017	40481087	1966-05-12	1966-05-12 00:00:00	1966-06-02	1966-06-02 00:00:00	32020		\N	66926	0	444814009	40481087		0
27736	1636	260139	1994-06-13	1994-06-13 00:00:00	1994-06-20	1994-06-20 00:00:00	32020		\N	109862	0	10509002	260139		0
27927	1649	40481087	1979-01-31	1979-01-31 00:00:00	1979-02-14	1979-02-14 00:00:00	32020		\N	110681	0	444814009	40481087		0
17537	1054	372328	1934-06-09	1934-06-09 00:00:00	1934-11-23	1934-11-23 00:00:00	32020		\N	69084	0	65363002	372328		0
17696	1062	260139	1981-05-11	1981-05-11 00:00:00	1981-05-18	1981-05-18 00:00:00	32020		\N	69675	0	10509002	260139		0
17920	1077	40481087	1977-07-13	1977-07-13 00:00:00	1977-07-27	1977-07-27 00:00:00	32020		\N	70589	0	444814009	40481087		0
18020	1083	81893	2004-01-05	2004-01-05 00:00:00	\N	\N	32020		\N	71084	0	64766004	81893		0
18200	1092	28060	1967-01-06	1967-01-06 00:00:00	1967-01-17	1967-01-17 00:00:00	32020		\N	71815	0	43878008	28060		0
18316	1101	260139	1978-03-10	1978-03-10 00:00:00	1978-03-24	1978-03-24 00:00:00	32020		\N	72300	0	10509002	260139		0
18536	1115	40481087	1953-08-17	1953-08-17 00:00:00	1953-08-31	1953-08-31 00:00:00	32020		\N	73450	0	444814009	40481087		0
18689	1124	260139	1940-07-21	1940-07-21 00:00:00	1940-07-28	1940-07-28 00:00:00	32020		\N	74094	0	10509002	260139		0
18868	1134	40481087	1951-08-16	1951-08-16 00:00:00	1951-09-06	1951-09-06 00:00:00	32020		\N	74721	0	444814009	40481087		0
19036	1143	81151	1980-11-20	1980-11-20 00:00:00	1980-12-11	1980-12-11 00:00:00	32020		\N	75456	0	44465007	81151		0
19182	1149	4134304	2007-10-21	2007-10-21 00:00:00	2008-01-19	2008-01-19 00:00:00	32020		\N	75947	0	263102004	4134304		0
19383	1162	260139	1922-12-31	1922-12-31 00:00:00	1923-01-14	1923-01-14 00:00:00	32020		\N	76673	0	10509002	260139		0
30076	1779	140673	2009-11-09	2009-11-09 00:00:00	\N	\N	32020		\N	119050	0	40930008	140673		0
19731	1185	4112343	1941-01-10	1941-01-10 00:00:00	1941-01-22	1941-01-22 00:00:00	32020		\N	78102	0	195662009	4112343		0
30406	1793	4218389	1975-12-27	1975-12-27 00:00:00	1976-01-24	1976-01-24 00:00:00	32020		\N	120225	0	39848009	4218389		0
20041	1208	40481087	1985-07-07	1985-07-07 00:00:00	1985-07-21	1985-07-21 00:00:00	32020		\N	79366	0	444814009	40481087		0
20222	1216	4146173	2017-02-06	2017-02-06 00:00:00	2017-04-07	2017-04-07 00:00:00	32020		\N	80100	0	307731004	4146173		0
20331	1223	4112343	1985-01-27	1985-01-27 00:00:00	1985-02-09	1985-02-09 00:00:00	32020		\N	80515	0	195662009	4112343		0
20554	1236	372328	1922-08-02	1922-08-02 00:00:00	1923-01-04	1923-01-04 00:00:00	32020		\N	81409	0	65363002	372328		0
20720	1245	40481087	1983-02-24	1983-02-24 00:00:00	1983-03-17	1983-03-17 00:00:00	32020		\N	81954	0	444814009	40481087		0
20845	1250	4112343	1958-12-08	1958-12-08 00:00:00	1958-12-20	1958-12-20 00:00:00	32020		\N	82327	0	195662009	4112343		0
20989	1259	81893	1979-12-17	1979-12-17 00:00:00	\N	\N	32020		\N	83001	0	64766004	81893		0
21248	1276	40481087	1998-02-07	1998-02-07 00:00:00	1998-02-28	1998-02-28 00:00:00	32020		\N	84194	0	444814009	40481087		0
10748	636	40481087	2000-05-30	2000-05-30 00:00:00	2000-06-06	2000-06-06 00:00:00	32020		\N	42181	0	444814009	40481087		0
10938	648	260139	1951-12-20	1951-12-20 00:00:00	1952-01-03	1952-01-03 00:00:00	32020		\N	42844	0	10509002	260139		0
11082	653	4112343	1969-07-16	1969-07-16 00:00:00	1969-07-25	1969-07-25 00:00:00	32020		\N	43253	0	195662009	4112343		0
11266	665	40481087	2007-09-19	2007-09-19 00:00:00	2007-10-10	2007-10-10 00:00:00	32020		\N	43983	0	444814009	40481087		0
11384	672	40481087	1966-01-10	1966-01-10 00:00:00	1966-01-17	1966-01-17 00:00:00	32020		\N	44336	0	444814009	40481087		0
22095	1321	40481087	2017-07-24	2017-07-24 00:00:00	2017-07-31	2017-07-31 00:00:00	32020		\N	87643	0	444814009	40481087		0
11717	691	260139	1958-12-06	1958-12-06 00:00:00	1958-12-20	1958-12-20 00:00:00	32020		\N	45775	0	10509002	260139		0
11904	703	28060	1981-12-06	1981-12-06 00:00:00	1981-12-18	1981-12-18 00:00:00	32020		\N	46436	0	43878008	28060		0
12052	712	321042	2011-04-14	2011-04-14 00:00:00	\N	\N	32020		\N	47268	0	410429000	321042		0
12280	727	40481087	2003-01-01	2003-01-01 00:00:00	2003-01-15	2003-01-15 00:00:00	32020		\N	48166	0	444814009	40481087		0
12352	729	4112343	1969-07-01	1969-07-01 00:00:00	1969-07-09	1969-07-09 00:00:00	32020		\N	48397	0	195662009	4112343		0
12541	742	313217	2008-07-21	2008-07-21 00:00:00	\N	\N	32020		\N	49195	0	49436004	313217		0
12743	754	40481087	1954-11-01	1954-11-01 00:00:00	1954-11-08	1954-11-08 00:00:00	32020		\N	49847	0	444814009	40481087		0
12914	759	4155034	2015-11-02	2015-11-02 00:00:00	2015-11-23	2015-11-23 00:00:00	32020		\N	50363	0	283371005	4155034		0
13090	771	4218389	1999-09-08	1999-09-08 00:00:00	1999-10-13	1999-10-13 00:00:00	32020		\N	51182	0	39848009	4218389		0
13228	778	40481087	1990-10-06	1990-10-06 00:00:00	1990-10-13	1990-10-13 00:00:00	32020		\N	51643	0	444814009	40481087		0
13364	787	40481087	1985-06-17	1985-06-17 00:00:00	1985-07-01	1985-07-01 00:00:00	32020		\N	52338	0	444814009	40481087		0
24120	1438	4155034	1975-04-17	1975-04-17 00:00:00	1975-05-01	1975-05-01 00:00:00	32020		\N	95849	0	283371005	4155034		0
13762	814	4112343	1988-02-05	1988-02-05 00:00:00	1988-02-12	1988-02-12 00:00:00	32020		\N	53991	0	195662009	4112343		0
13862	820	40481087	1995-02-10	1995-02-10 00:00:00	1995-03-03	1995-03-03 00:00:00	32020		\N	54307	0	444814009	40481087		0
14016	828	40481087	1985-02-10	1985-02-10 00:00:00	1985-02-17	1985-02-17 00:00:00	32020		\N	54853	0	444814009	40481087		0
14271	842	40481087	1921-08-23	1921-08-23 00:00:00	1921-08-30	1921-08-30 00:00:00	32020		\N	55640	0	444814009	40481087		0
14372	850	40481087	1968-12-15	1968-12-15 00:00:00	1968-12-22	1968-12-22 00:00:00	32020		\N	56190	0	444814009	40481087		0
14561	862	40481087	1977-08-01	1977-08-01 00:00:00	1977-08-22	1977-08-22 00:00:00	32020		\N	57081	0	444814009	40481087		0
14700	867	40481087	1998-10-18	1998-10-18 00:00:00	1998-11-01	1998-11-01 00:00:00	32020		\N	57523	0	444814009	40481087		0
14933	879	78272	2007-06-27	2007-06-27 00:00:00	2007-07-25	2007-07-25 00:00:00	32020		\N	58581	0	70704007	78272		0
15064	887	81151	1967-10-21	1967-10-21 00:00:00	1967-11-11	1967-11-11 00:00:00	32020		\N	59101	0	44465007	81151		0
15254	902	40481087	1999-11-04	1999-11-04 00:00:00	1999-11-11	1999-11-11 00:00:00	32020		\N	60037	0	444814009	40481087		0
15425	914	40481087	1973-12-09	1973-12-09 00:00:00	1973-12-16	1973-12-16 00:00:00	32020		\N	60691	0	444814009	40481087		0
15528	919	4296204	1998-02-13	1998-02-13 00:00:00	1998-03-06	1998-03-06 00:00:00	32020		\N	61222	0	403190006	4296204		0
15738	931	317576	2015-10-16	2015-10-16 00:00:00	\N	\N	32020		\N	62003	0	53741008	317576		0
15844	938	40481087	1990-04-13	1990-04-13 00:00:00	1990-05-04	1990-05-04 00:00:00	32020		\N	62350	0	444814009	40481087		0
16059	950	40481087	1980-11-05	1980-11-05 00:00:00	1980-11-12	1980-11-12 00:00:00	32020		\N	63062	0	444814009	40481087		0
16227	959	4112343	1985-05-26	1985-05-26 00:00:00	1985-06-07	1985-06-07 00:00:00	32020		\N	63739	0	195662009	4112343		0
16360	967	4112343	1936-05-28	1936-05-28 00:00:00	1936-06-04	1936-06-04 00:00:00	32020		\N	64332	0	195662009	4112343		0
16502	974	4142905	1960-03-05	1960-03-05 00:00:00	1960-05-04	1960-05-04 00:00:00	32020		\N	64963	0	33737001	4142905		0
16741	992	260139	1962-12-08	1962-12-08 00:00:00	1962-12-15	1962-12-15 00:00:00	32020		\N	65745	0	10509002	260139		0
16909	1004	260139	1997-05-27	1997-05-27 00:00:00	1997-06-10	1997-06-10 00:00:00	32020		\N	66377	0	10509002	260139		0
17041	1017	439777	1964-06-13	1964-06-13 00:00:00	\N	\N	32020		\N	67005	0	271737000	439777		0
27737	1636	4112343	1963-09-12	1963-09-12 00:00:00	1963-09-22	1963-09-22 00:00:00	32020		\N	109896	0	195662009	4112343		0
27928	1649	260139	1985-01-05	1985-01-05 00:00:00	1985-01-12	1985-01-12 00:00:00	32020		\N	110674	0	10509002	260139		0
17538	1054	4059173	2000-02-03	2000-02-03 00:00:00	2000-05-03	2000-05-03 00:00:00	32020		\N	69136	0	16114001	4059173		0
17697	1062	4035415	2005-09-04	2005-09-04 00:00:00	2005-10-04	2005-10-04 00:00:00	32020		\N	69664	0	239720000	4035415		0
17921	1077	40481087	1999-11-26	1999-11-26 00:00:00	1999-12-10	1999-12-10 00:00:00	32020		\N	70595	0	444814009	40481087		0
18021	1083	30753	2004-08-02	2004-08-02 00:00:00	\N	\N	32020		\N	71084	0	16761005	30753		0
18230	1097	260139	2001-12-28	2001-12-28 00:00:00	2002-01-04	2002-01-04 00:00:00	32020		\N	71969	0	10509002	260139		0
18317	1101	81151	1981-06-12	1981-06-12 00:00:00	1981-07-03	1981-07-03 00:00:00	32020		\N	72325	0	44465007	81151		0
18537	1115	375671	1952-11-11	1952-11-11 00:00:00	1952-12-11	1952-12-11 00:00:00	32020		\N	73384	0	62564004	375671		0
18690	1124	78272	1992-10-16	1992-10-16 00:00:00	1992-10-30	1992-10-30 00:00:00	32020		\N	74114	0	70704007	78272		0
18869	1134	40481087	2003-11-20	2003-11-20 00:00:00	2003-11-27	2003-11-27 00:00:00	32020		\N	74723	0	444814009	40481087		0
19037	1143	375671	2004-07-08	2004-07-08 00:00:00	2004-08-07	2004-08-07 00:00:00	32020		\N	75458	0	62564004	375671		0
19183	1149	4112343	2003-10-07	2003-10-07 00:00:00	2003-10-19	2003-10-19 00:00:00	32020		\N	75952	0	195662009	4112343		0
19384	1162	40481087	1978-01-09	1978-01-09 00:00:00	1978-01-23	1978-01-23 00:00:00	32020		\N	76664	0	444814009	40481087		0
30077	1779	40481087	1949-09-27	1949-09-27 00:00:00	1949-10-04	1949-10-04 00:00:00	32020		\N	119071	0	444814009	40481087		0
19732	1185	40481087	1988-01-12	1988-01-12 00:00:00	1988-01-26	1988-01-26 00:00:00	32020		\N	78091	0	444814009	40481087		0
30407	1793	40481087	1993-02-07	1993-02-07 00:00:00	1993-02-14	1993-02-14 00:00:00	32020		\N	120244	0	444814009	40481087		0
20042	1208	4278672	1961-12-21	1961-12-21 00:00:00	1962-02-19	1962-02-19 00:00:00	32020		\N	79376	0	65966004	4278672		0
20223	1217	40481087	2008-04-01	2008-04-01 00:00:00	2008-04-08	2008-04-08 00:00:00	32020		\N	80160	0	444814009	40481087		0
20332	1223	4112343	1953-04-01	1953-04-01 00:00:00	1953-04-12	1953-04-12 00:00:00	32020		\N	80475	0	195662009	4112343		0
20555	1236	4237458	1994-08-24	1994-08-24 00:00:00	1994-09-23	1994-09-23 00:00:00	32020		\N	81486	0	58150001	4237458		0
20721	1245	4059173	1959-02-17	1959-02-17 00:00:00	1959-05-18	1959-05-18 00:00:00	32020		\N	81899	0	16114001	4059173		0
20846	1250	257012	1959-10-08	1959-10-08 00:00:00	\N	\N	32020		\N	82395	0	40055000	257012		0
20990	1259	260139	2008-03-15	2008-03-15 00:00:00	2008-03-29	2008-03-29 00:00:00	32020		\N	83005	0	10509002	260139		0
31707	1878	28060	1987-09-13	1987-09-13 00:00:00	1987-09-24	1987-09-24 00:00:00	32020		\N	125320	0	43878008	28060		0
10749	636	40481087	1972-08-13	1972-08-13 00:00:00	1972-08-20	1972-08-20 00:00:00	32020		\N	42103	0	444814009	40481087		0
10939	648	260139	1984-05-21	1984-05-21 00:00:00	1984-05-28	1984-05-28 00:00:00	32020		\N	42889	0	10509002	260139		0
11083	653	4112343	1989-10-30	1989-10-30 00:00:00	1989-11-06	1989-11-06 00:00:00	32020		\N	43260	0	195662009	4112343		0
11267	665	40481087	1958-12-18	1958-12-18 00:00:00	1959-01-08	1959-01-08 00:00:00	32020		\N	43974	0	444814009	40481087		0
11385	672	80180	1989-04-13	1989-04-13 00:00:00	\N	\N	32020		\N	44387	0	396275006	80180		0
22096	1321	4296205	1961-07-12	1961-07-12 00:00:00	1961-08-09	1961-08-09 00:00:00	32020		\N	87597	0	403191005	4296205		0
11732	693	260139	2018-01-11	2018-01-11 00:00:00	2018-01-25	2018-01-25 00:00:00	32020		\N	45948	0	10509002	260139		0
11905	703	260139	1976-04-06	1976-04-06 00:00:00	1976-04-13	1976-04-13 00:00:00	32020		\N	46474	0	10509002	260139		0
12054	712	260139	2018-12-25	2018-12-25 00:00:00	2019-01-01	2019-01-01 00:00:00	32020		\N	47233	0	10509002	260139		0
12281	727	4112343	1916-11-11	1916-11-11 00:00:00	1916-11-22	1916-11-22 00:00:00	32020		\N	48238	0	195662009	4112343		0
12353	729	4112343	1984-09-21	1984-09-21 00:00:00	1984-10-03	1984-10-03 00:00:00	32020		\N	48427	0	195662009	4112343		0
12542	742	40481087	1992-03-26	1992-03-26 00:00:00	1992-04-02	1992-04-02 00:00:00	32020		\N	49140	0	444814009	40481087		0
12744	754	260139	1947-08-03	1947-08-03 00:00:00	1947-08-17	1947-08-17 00:00:00	32020		\N	49844	0	10509002	260139		0
12915	759	40481087	2013-08-07	2013-08-07 00:00:00	2013-08-21	2013-08-21 00:00:00	32020		\N	50384	0	444814009	40481087		0
13091	771	4059173	1975-12-13	1975-12-13 00:00:00	1976-03-12	1976-03-12 00:00:00	32020		\N	51180	0	16114001	4059173		0
13229	778	40481087	2002-07-24	2002-07-24 00:00:00	2002-07-31	2002-07-31 00:00:00	32020		\N	51644	0	444814009	40481087		0
13365	787	4146173	2016-03-03	2016-03-03 00:00:00	2016-05-02	2016-05-02 00:00:00	32020		\N	52375	0	307731004	4146173		0
24121	1438	4112343	1959-08-11	1959-08-11 00:00:00	1959-08-23	1959-08-23 00:00:00	32020		\N	95828	0	195662009	4112343		0
13763	814	4278672	1995-12-21	1995-12-21 00:00:00	1996-03-20	1996-03-20 00:00:00	32020		\N	53979	0	65966004	4278672		0
13863	820	40481087	2000-08-16	2000-08-16 00:00:00	2000-09-06	2000-09-06 00:00:00	32020		\N	54308	0	444814009	40481087		0
14017	828	80180	1992-11-29	1992-11-29 00:00:00	\N	\N	32020		\N	54821	0	396275006	80180		0
14272	842	4218389	1948-08-04	1948-08-04 00:00:00	1948-09-01	1948-09-01 00:00:00	32020		\N	55710	0	39848009	4218389		0
14373	850	260139	1971-03-15	1971-03-15 00:00:00	1971-03-29	1971-03-29 00:00:00	32020		\N	56216	0	10509002	260139		0
14562	862	28060	1981-02-24	1981-02-24 00:00:00	1981-03-05	1981-03-05 00:00:00	32020		\N	57101	0	43878008	28060		0
14701	867	4112343	2007-12-09	2007-12-09 00:00:00	2007-12-18	2007-12-18 00:00:00	32020		\N	57525	0	195662009	4112343		0
14934	879	40481087	1956-08-23	1956-08-23 00:00:00	1956-08-30	1956-08-30 00:00:00	32020		\N	58520	0	444814009	40481087		0
15065	887	28060	1992-10-17	1992-10-17 00:00:00	1992-10-25	1992-10-25 00:00:00	32020		\N	59111	0	43878008	28060		0
25731	1528	4112343	2009-04-13	2009-04-13 00:00:00	2009-04-26	2009-04-26 00:00:00	32020		\N	102272	0	195662009	4112343		0
15426	914	4109685	1967-04-17	1967-04-17 00:00:00	1967-05-08	1967-05-08 00:00:00	32020		\N	60730	0	284551006	4109685		0
15529	919	4112343	1974-10-13	1974-10-13 00:00:00	1974-10-25	1974-10-25 00:00:00	32020		\N	61251	0	195662009	4112343		0
15739	931	40481087	2007-03-14	2007-03-14 00:00:00	2007-04-04	2007-04-04 00:00:00	32020		\N	61941	0	444814009	40481087		0
15845	938	40481087	1979-08-30	1979-08-30 00:00:00	1979-09-20	1979-09-20 00:00:00	32020		\N	62318	0	444814009	40481087		0
16060	950	4146173	1999-08-02	1999-08-02 00:00:00	1999-10-01	1999-10-01 00:00:00	32020		\N	63067	0	307731004	4146173		0
16228	959	4113008	1969-05-27	1969-05-27 00:00:00	1969-06-17	1969-06-17 00:00:00	32020		\N	63782	0	284549007	4113008		0
16361	967	317576	2011-07-16	2011-07-16 00:00:00	\N	\N	32020		\N	\N	0	53741008	317576		0
16503	974	28060	1960-02-07	1960-02-07 00:00:00	1960-02-17	1960-02-17 00:00:00	32020		\N	64930	0	43878008	28060		0
16742	992	80180	1987-07-31	1987-07-31 00:00:00	\N	\N	32020		\N	65798	0	396275006	80180		0
16910	1005	260139	2008-10-15	2008-10-15 00:00:00	2008-10-22	2008-10-22 00:00:00	32020		\N	66440	0	10509002	260139		0
17042	1018	40481087	2018-06-20	2018-06-20 00:00:00	2018-07-04	2018-07-04 00:00:00	32020		\N	67042	0	444814009	40481087		0
27738	1636	260139	1983-02-04	1983-02-04 00:00:00	1983-02-18	1983-02-18 00:00:00	32020		\N	109899	0	10509002	260139		0
27929	1649	317576	2007-03-14	2007-03-14 00:00:00	\N	\N	32020		\N	110625	0	53741008	317576		0
17539	1054	260139	1997-07-08	1997-07-08 00:00:00	1997-07-15	1997-07-15 00:00:00	32020		\N	69124	0	10509002	260139		0
17698	1062	260139	1973-03-16	1973-03-16 00:00:00	1973-03-23	1973-03-23 00:00:00	32020		\N	69684	0	10509002	260139		0
17922	1077	40481087	1981-09-10	1981-09-10 00:00:00	1981-09-24	1981-09-24 00:00:00	32020		\N	70591	0	444814009	40481087		0
18022	1083	80180	2005-04-29	2005-04-29 00:00:00	\N	\N	32020		\N	71084	0	396275006	80180		0
18231	1097	40481087	1999-06-23	1999-06-23 00:00:00	1999-07-14	1999-07-14 00:00:00	32020		\N	71968	0	444814009	40481087		0
18318	1101	260139	1993-09-09	1993-09-09 00:00:00	1993-09-16	1993-09-16 00:00:00	32020		\N	72352	0	10509002	260139		0
18538	1115	40481087	1995-03-28	1995-03-28 00:00:00	1995-04-18	1995-04-18 00:00:00	32020		\N	73371	0	444814009	40481087		0
18691	1124	260139	1954-05-29	1954-05-29 00:00:00	1954-06-12	1954-06-12 00:00:00	32020		\N	74093	0	10509002	260139		0
18870	1135	4112343	1972-03-19	1972-03-19 00:00:00	1972-03-30	1972-03-30 00:00:00	32020		\N	74738	0	195662009	4112343		0
19038	1143	4112343	1974-05-16	1974-05-16 00:00:00	1974-05-24	1974-05-24 00:00:00	32020		\N	75401	0	195662009	4112343		0
19184	1149	4112343	2011-04-12	2011-04-12 00:00:00	2011-04-21	2011-04-21 00:00:00	32020		\N	75954	0	195662009	4112343		0
19385	1162	40481087	1982-03-10	1982-03-10 00:00:00	1982-03-24	1982-03-24 00:00:00	32020		\N	76709	0	444814009	40481087		0
30078	1779	40481087	1977-05-25	1977-05-25 00:00:00	1977-06-08	1977-06-08 00:00:00	32020		\N	118988	0	444814009	40481087		0
19733	1185	40481087	1987-03-18	1987-03-18 00:00:00	1987-04-08	1987-04-08 00:00:00	32020		\N	78105	0	444814009	40481087		0
30408	1793	4296205	1943-04-02	1943-04-02 00:00:00	1943-05-07	1943-05-07 00:00:00	32020		\N	120221	0	403191005	4296205		0
20043	1208	40481087	1957-05-31	1957-05-31 00:00:00	1957-06-07	1957-06-07 00:00:00	32020		\N	79401	0	444814009	40481087		0
20224	1217	4112343	1990-07-09	1990-07-09 00:00:00	1990-07-16	1990-07-16 00:00:00	32020		\N	80137	0	195662009	4112343		0
20333	1223	372328	2010-11-24	2010-11-24 00:00:00	2011-05-06	2011-05-06 00:00:00	32020		\N	80456	0	65363002	372328		0
20556	1236	372328	1925-08-21	1925-08-21 00:00:00	1926-07-15	1926-07-15 00:00:00	32020		\N	81410	0	65363002	372328		0
20722	1245	40481087	2016-06-21	2016-06-21 00:00:00	2016-07-12	2016-07-12 00:00:00	32020		\N	81956	0	444814009	40481087		0
20864	1253	4218389	2015-08-10	2015-08-10 00:00:00	2015-09-14	2015-09-14 00:00:00	32020		\N	82579	0	39848009	4218389		0
20991	1259	378001	2014-03-14	2014-03-14 00:00:00	2014-05-13	2014-05-13 00:00:00	32020		\N	82966	0	62106007	378001		0
31708	1878	80180	2010-07-25	2010-07-25 00:00:00	\N	\N	32020		\N	125330	0	396275006	80180		0
10759	639	192671	1989-06-08	1989-06-08 00:00:00	\N	\N	32020		\N	42243	0	K92.2	35208414		0
10940	648	4112343	1946-09-06	1946-09-06 00:00:00	1946-09-15	1946-09-15 00:00:00	32020		\N	42842	0	195662009	4112343		0
11084	653	4112343	1960-07-07	1960-07-07 00:00:00	1960-07-20	1960-07-20 00:00:00	32020		\N	43251	0	195662009	4112343		0
11268	665	4218389	1992-02-22	1992-02-22 00:00:00	1992-03-14	1992-03-14 00:00:00	32020		\N	43939	0	39848009	4218389		0
11386	673	81151	1978-09-28	1978-09-28 00:00:00	1978-10-12	1978-10-12 00:00:00	32020		\N	44433	0	44465007	81151		0
22097	1321	40481087	1987-05-25	1987-05-25 00:00:00	1987-06-15	1987-06-15 00:00:00	32020		\N	87654	0	444814009	40481087		0
11733	693	28060	2005-05-31	2005-05-31 00:00:00	2005-06-13	2005-06-13 00:00:00	32020		\N	45901	0	43878008	28060		0
11906	704	4237458	1968-01-27	1968-01-27 00:00:00	1968-04-26	1968-04-26 00:00:00	32020		\N	46511	0	58150001	4237458		0
12055	712	40481087	1976-01-08	1976-01-08 00:00:00	1976-01-29	1976-01-29 00:00:00	32020		\N	47229	0	444814009	40481087		0
12282	727	4059173	1991-04-23	1991-04-23 00:00:00	1991-06-22	1991-06-22 00:00:00	32020		\N	48209	0	16114001	4059173		0
12354	729	28060	1966-03-09	1966-03-09 00:00:00	1966-03-17	1966-03-17 00:00:00	32020		\N	48367	0	43878008	28060		0
12543	742	40481087	1945-03-06	1945-03-06 00:00:00	1945-03-27	1945-03-27 00:00:00	32020		\N	49214	0	444814009	40481087		0
12745	754	372328	1938-02-20	1938-02-20 00:00:00	1938-05-03	1938-05-03 00:00:00	32020		\N	49905	0	65363002	372328		0
12916	759	40481087	1981-05-10	1981-05-10 00:00:00	1981-05-17	1981-05-17 00:00:00	32020		\N	50428	0	444814009	40481087		0
13092	771	40481087	1964-06-22	1964-06-22 00:00:00	1964-06-29	1964-06-29 00:00:00	32020		\N	51224	0	444814009	40481087		0
13230	778	80180	2011-05-06	2011-05-06 00:00:00	\N	\N	32020		\N	51684	0	396275006	80180		0
13366	787	4112343	2011-11-24	2011-11-24 00:00:00	2011-12-07	2011-12-07 00:00:00	32020		\N	52363	0	195662009	4112343		0
24122	1438	40481087	1961-09-23	1961-09-23 00:00:00	1961-09-30	1961-09-30 00:00:00	32020		\N	95804	0	444814009	40481087		0
13764	814	40481087	2017-02-03	2017-02-03 00:00:00	2017-02-17	2017-02-17 00:00:00	32020		\N	53957	0	444814009	40481087		0
13864	820	40481087	1989-06-17	1989-06-17 00:00:00	1989-06-24	1989-06-24 00:00:00	32020		\N	54295	0	444814009	40481087		0
14018	828	40481087	1957-12-28	1957-12-28 00:00:00	1958-01-04	1958-01-04 00:00:00	32020		\N	54815	0	444814009	40481087		0
14273	842	372328	1912-03-16	1912-03-16 00:00:00	1912-05-04	1912-05-04 00:00:00	32020		\N	55651	0	65363002	372328		0
14374	850	30753	1988-09-30	1988-09-30 00:00:00	\N	\N	32020		\N	56217	0	16761005	30753		0
14563	862	4237458	1986-06-06	1986-06-06 00:00:00	1986-09-04	1986-09-04 00:00:00	32020		\N	57052	0	58150001	4237458		0
14702	867	40481087	2000-05-29	2000-05-29 00:00:00	2000-06-05	2000-06-05 00:00:00	32020		\N	57519	0	444814009	40481087		0
14935	879	40481087	1958-09-24	1958-09-24 00:00:00	1958-10-08	1958-10-08 00:00:00	32020		\N	58546	0	444814009	40481087		0
15066	887	40481087	1967-01-13	1967-01-13 00:00:00	1967-02-03	1967-02-03 00:00:00	32020		\N	59153	0	444814009	40481087		0
25732	1529	40481087	2017-04-20	2017-04-20 00:00:00	2017-05-11	2017-05-11 00:00:00	32020		\N	102322	0	444814009	40481087		0
15427	915	260139	1973-08-23	1973-08-23 00:00:00	1973-09-06	1973-09-06 00:00:00	32020		\N	60861	0	10509002	260139		0
15530	919	260139	2002-01-30	2002-01-30 00:00:00	2002-02-06	2002-02-06 00:00:00	32020		\N	61256	0	10509002	260139		0
15740	931	4112343	1966-01-01	1966-01-01 00:00:00	1966-01-09	1966-01-09 00:00:00	32020		\N	61968	0	195662009	4112343		0
15846	938	4296204	1976-06-20	1976-06-20 00:00:00	1976-07-18	1976-07-18 00:00:00	32020		\N	62330	0	403190006	4296204		0
16061	950	4134304	1988-03-02	1988-03-02 00:00:00	1988-05-31	1988-05-31 00:00:00	32020		\N	63099	0	263102004	4134304		0
16229	959	378001	1971-07-07	1971-07-07 00:00:00	1971-08-06	1971-08-06 00:00:00	32020		\N	63784	0	62106007	378001		0
16362	967	4001336	1952-11-29	1952-11-29 00:00:00	1952-12-29	1952-12-29 00:00:00	32020		\N	64313	0	110030002	4001336		0
16504	974	4218389	1971-08-05	1971-08-05 00:00:00	1971-09-09	1971-09-09 00:00:00	32020		\N	64964	0	39848009	4218389		0
16743	992	4266809	1987-07-31	1987-07-31 00:00:00	\N	\N	32020		\N	65798	0	397881000	4266809		0
16911	1005	40481087	1967-11-23	1967-11-23 00:00:00	1967-11-30	1967-11-30 00:00:00	32020		\N	66439	0	444814009	40481087		0
17043	1018	40481087	1996-02-01	1996-02-01 00:00:00	1996-02-22	1996-02-22 00:00:00	32020		\N	67039	0	444814009	40481087		0
27739	1636	372328	1960-03-15	1960-03-15 00:00:00	1961-01-20	1961-01-20 00:00:00	32020		\N	109921	0	65363002	372328		0
27930	1649	4059173	1960-09-12	1960-09-12 00:00:00	1960-12-11	1960-12-11 00:00:00	32020		\N	110676	0	16114001	4059173		0
17540	1054	260139	1996-10-26	1996-10-26 00:00:00	1996-11-02	1996-11-02 00:00:00	32020		\N	69164	0	10509002	260139		0
17699	1062	4237458	1979-05-24	1979-05-24 00:00:00	1979-06-23	1979-06-23 00:00:00	32020		\N	69663	0	58150001	4237458		0
28392	1679	4278672	1989-07-01	1989-07-01 00:00:00	1989-09-29	1989-09-29 00:00:00	32020		\N	112586	0	65966004	4278672		0
18023	1083	4285898	2005-02-28	2005-02-28 00:00:00	\N	\N	32020		\N	71084	0	68496003	4285898		0
18232	1097	260139	1978-07-10	1978-07-10 00:00:00	1978-07-24	1978-07-24 00:00:00	32020		\N	72015	0	10509002	260139		0
18319	1101	260139	2009-02-01	2009-02-01 00:00:00	2009-02-15	2009-02-15 00:00:00	32020		\N	72345	0	10509002	260139		0
18539	1115	40481087	1981-07-10	1981-07-10 00:00:00	1981-07-17	1981-07-17 00:00:00	32020		\N	73403	0	444814009	40481087		0
18692	1124	40481087	1951-06-19	1951-06-19 00:00:00	1951-07-10	1951-07-10 00:00:00	32020		\N	74074	0	444814009	40481087		0
18871	1135	40481087	1984-04-19	1984-04-19 00:00:00	1984-05-03	1984-05-03 00:00:00	32020		\N	74741	0	444814009	40481087		0
19039	1143	40481087	1996-06-11	1996-06-11 00:00:00	1996-06-18	1996-06-18 00:00:00	32020		\N	75448	0	444814009	40481087		0
19185	1149	375671	2017-09-26	2017-09-26 00:00:00	2017-11-25	2017-11-25 00:00:00	32020		\N	75949	0	62564004	375671		0
19386	1162	40481087	1943-04-06	1943-04-06 00:00:00	1943-04-27	1943-04-27 00:00:00	32020		\N	76704	0	444814009	40481087		0
30079	1779	260139	2011-01-30	2011-01-30 00:00:00	2011-02-06	2011-02-06 00:00:00	32020		\N	118990	0	10509002	260139		0
19734	1185	260139	2000-07-23	2000-07-23 00:00:00	2000-07-30	2000-07-30 00:00:00	32020		\N	78106	0	10509002	260139		0
30409	1793	260139	1934-04-14	1934-04-14 00:00:00	1934-04-28	1934-04-28 00:00:00	32020		\N	120212	0	10509002	260139		0
20044	1208	313217	1993-11-09	1993-11-09 00:00:00	\N	\N	32020		\N	79360	0	49436004	313217		0
20225	1217	81151	2019-04-14	2019-04-14 00:00:00	2019-04-28	2019-04-28 00:00:00	32020		\N	80185	0	44465007	81151		0
20334	1223	40481087	1961-01-21	1961-01-21 00:00:00	1961-01-28	1961-01-28 00:00:00	32020		\N	80450	0	444814009	40481087		0
20557	1236	4109685	1999-03-31	1999-03-31 00:00:00	1999-04-14	1999-04-14 00:00:00	32020		\N	81487	0	284551006	4109685		0
20723	1245	40481087	1969-08-29	1969-08-29 00:00:00	1969-09-05	1969-09-05 00:00:00	32020		\N	81940	0	444814009	40481087		0
20865	1253	40481087	1995-09-13	1995-09-13 00:00:00	1995-10-04	1995-10-04 00:00:00	32020		\N	82509	0	444814009	40481087		0
20992	1259	40481087	1962-01-06	1962-01-06 00:00:00	1962-01-27	1962-01-27 00:00:00	32020		\N	82971	0	444814009	40481087		0
31709	1878	4112343	2010-06-28	2010-06-28 00:00:00	2010-07-11	2010-07-11 00:00:00	32020		\N	125330	0	195662009	4112343		0
10760	639	260139	2008-02-16	2008-02-16 00:00:00	2008-02-23	2008-02-23 00:00:00	32020		\N	42312	0	10509002	260139		0
10941	648	40481087	2014-07-09	2014-07-09 00:00:00	2014-07-23	2014-07-23 00:00:00	32020		\N	42937	0	444814009	40481087		0
11085	653	80180	1990-05-11	1990-05-11 00:00:00	\N	\N	32020		\N	43215	0	396275006	80180		0
11269	665	260139	2011-08-21	2011-08-21 00:00:00	2011-09-06	2011-09-06 00:00:00	32020		\N	44001	0	10509002	260139		0
11387	673	4218389	1984-12-30	1984-12-30 00:00:00	1985-01-27	1985-01-27 00:00:00	32020		\N	44436	0	39848009	4218389		0
22098	1321	40481087	2016-03-15	2016-03-15 00:00:00	2016-03-22	2016-03-22 00:00:00	32020		\N	87614	0	444814009	40481087		0
11734	693	40481087	1980-11-06	1980-11-06 00:00:00	1980-11-20	1980-11-20 00:00:00	32020		\N	45966	0	444814009	40481087		0
11907	704	4112343	2007-09-12	2007-09-12 00:00:00	2007-09-20	2007-09-20 00:00:00	32020		\N	46598	0	195662009	4112343		0
12056	712	40481087	1983-10-10	1983-10-10 00:00:00	1983-10-31	1983-10-31 00:00:00	32020		\N	47221	0	444814009	40481087		0
12283	727	40481087	1981-01-27	1981-01-27 00:00:00	1981-02-10	1981-02-10 00:00:00	32020		\N	48244	0	444814009	40481087		0
12355	729	4109685	1972-02-04	1972-02-04 00:00:00	1972-02-18	1972-02-18 00:00:00	32020		\N	48404	0	284551006	4109685		0
12544	742	78272	2009-10-08	2009-10-08 00:00:00	2009-10-22	2009-10-22 00:00:00	32020		\N	49193	0	70704007	78272		0
12746	754	372328	1943-02-06	1943-02-06 00:00:00	1943-08-03	1943-08-03 00:00:00	32020		\N	49925	0	65363002	372328		0
12917	759	4112343	2005-12-24	2005-12-24 00:00:00	2006-01-02	2006-01-02 00:00:00	32020		\N	50446	0	195662009	4112343		0
13093	771	378001	2010-07-17	2010-07-17 00:00:00	2010-08-16	2010-08-16 00:00:00	32020		\N	51183	0	62106007	378001		0
13231	778	40481087	2001-09-08	2001-09-08 00:00:00	2001-09-22	2001-09-22 00:00:00	32020		\N	51690	0	444814009	40481087		0
13367	787	40481087	2007-08-22	2007-08-22 00:00:00	2007-09-05	2007-09-05 00:00:00	32020		\N	52362	0	444814009	40481087		0
24123	1438	40481087	1983-11-27	1983-11-27 00:00:00	1983-12-18	1983-12-18 00:00:00	32020		\N	95805	0	444814009	40481087		0
13765	814	30753	2018-03-30	2018-03-30 00:00:00	\N	\N	32020		\N	53957	0	16761005	30753		0
13865	820	372328	1967-02-05	1967-02-05 00:00:00	1967-04-27	1967-04-27 00:00:00	32020		\N	54356	0	65363002	372328		0
14019	828	4112343	1986-05-26	1986-05-26 00:00:00	1986-06-08	1986-06-08 00:00:00	32020		\N	54840	0	195662009	4112343		0
14274	842	40481087	2010-01-30	2010-01-30 00:00:00	2010-02-20	2010-02-20 00:00:00	32020		\N	55717	0	444814009	40481087		0
14375	850	4310024	1987-08-07	1987-08-07 00:00:00	\N	\N	32020		\N	56217	0	424802006	4310024		0
14564	862	4278672	2017-08-22	2017-08-22 00:00:00	2017-11-20	2017-11-20 00:00:00	32020		\N	57054	0	65966004	4278672		0
14703	867	40481087	1933-03-14	1933-03-14 00:00:00	1933-04-04	1933-04-04 00:00:00	32020		\N	57539	0	444814009	40481087		0
25399	1513	4112343	1996-05-17	1996-05-17 00:00:00	1996-05-30	1996-05-30 00:00:00	32020		\N	101024	0	195662009	4112343		0
15067	887	260139	1965-06-05	1965-06-05 00:00:00	1965-06-12	1965-06-12 00:00:00	32020		\N	59142	0	10509002	260139		0
25733	1529	40481087	1978-05-17	1978-05-17 00:00:00	1978-05-31	1978-05-31 00:00:00	32020		\N	102362	0	444814009	40481087		0
15428	915	40481087	1999-12-20	1999-12-20 00:00:00	2000-01-10	2000-01-10 00:00:00	32020		\N	60826	0	444814009	40481087		0
15531	919	80180	2009-06-05	2009-06-05 00:00:00	\N	\N	32020		\N	61273	0	396275006	80180		0
15741	931	372328	1975-09-17	1975-09-17 00:00:00	1976-07-02	1976-07-02 00:00:00	32020		\N	61982	0	65363002	372328		0
15847	938	4112343	1949-02-01	1949-02-01 00:00:00	1949-02-12	1949-02-12 00:00:00	32020		\N	62408	0	195662009	4112343		0
16062	950	40481087	1984-12-20	1984-12-20 00:00:00	1984-12-27	1984-12-27 00:00:00	32020		\N	63127	0	444814009	40481087		0
16230	959	40481087	2002-01-16	2002-01-16 00:00:00	2002-01-30	2002-01-30 00:00:00	32020		\N	63726	0	444814009	40481087		0
16363	967	260139	2014-06-01	2014-06-01 00:00:00	2014-06-15	2014-06-15 00:00:00	32020		\N	64279	0	10509002	260139		0
16505	974	4109685	1976-06-14	1976-06-14 00:00:00	1976-07-05	1976-07-05 00:00:00	32020		\N	64965	0	284551006	4109685		0
16744	992	4027663	1979-08-17	1979-08-17 00:00:00	\N	\N	32020		\N	65795	0	13200003	4027663		0
16912	1005	4283893	2004-07-12	2004-07-12 00:00:00	2004-08-09	2004-08-09 00:00:00	32020		\N	66426	0	36971009	4283893		0
17044	1018	4112343	2018-01-14	2018-01-14 00:00:00	2018-01-27	2018-01-27 00:00:00	32020		\N	67032	0	195662009	4112343		0
27740	1636	4112343	1960-08-18	1960-08-18 00:00:00	1960-08-25	1960-08-25 00:00:00	32020		\N	109857	0	195662009	4112343		0
27931	1649	40481087	1996-07-03	1996-07-03 00:00:00	1996-07-10	1996-07-10 00:00:00	32020		\N	110649	0	444814009	40481087		0
17541	1054	4109685	2012-03-01	2012-03-01 00:00:00	2012-03-15	2012-03-15 00:00:00	32020		\N	69137	0	284551006	4109685		0
17743	1068	28060	1984-10-05	1984-10-05 00:00:00	1984-10-15	1984-10-15 00:00:00	32020		\N	69976	0	43878008	28060		0
28393	1679	40481087	2013-04-04	2013-04-04 00:00:00	2013-04-18	2013-04-18 00:00:00	32020		\N	112568	0	444814009	40481087		0
18024	1083	260139	2006-11-12	2006-11-12 00:00:00	2006-11-19	2006-11-19 00:00:00	32020		\N	71174	0	10509002	260139		0
18233	1097	28060	1972-09-22	1972-09-22 00:00:00	1972-09-30	1972-09-30 00:00:00	32020		\N	72004	0	43878008	28060		0
18320	1101	260139	1989-07-01	1989-07-01 00:00:00	1989-07-08	1989-07-08 00:00:00	32020		\N	72344	0	10509002	260139		0
18540	1115	4283893	1985-10-02	1985-10-02 00:00:00	1985-10-16	1985-10-16 00:00:00	32020		\N	73404	0	36971009	4283893		0
18693	1124	381316	1999-08-29	1999-08-29 00:00:00	\N	\N	32020		\N	74069	0	230690007	381316		0
18872	1135	4112343	2003-04-30	2003-04-30 00:00:00	2003-05-09	2003-05-09 00:00:00	32020		\N	74742	0	195662009	4112343		0
19040	1143	40481087	1995-02-25	1995-02-25 00:00:00	1995-03-11	1995-03-11 00:00:00	32020		\N	75418	0	444814009	40481087		0
19186	1149	4112343	1997-05-28	1997-05-28 00:00:00	1997-06-09	1997-06-09 00:00:00	32020		\N	75951	0	195662009	4112343		0
19387	1162	40481087	1976-05-06	1976-05-06 00:00:00	1976-05-13	1976-05-13 00:00:00	32020		\N	76707	0	444814009	40481087		0
30080	1779	4112343	2011-11-02	2011-11-02 00:00:00	2011-11-12	2011-11-12 00:00:00	32020		\N	119051	0	195662009	4112343		0
19735	1185	81151	2004-06-26	2004-06-26 00:00:00	2004-07-31	2004-07-31 00:00:00	32020		\N	78149	0	44465007	81151		0
30410	1793	260139	1978-07-01	1978-07-01 00:00:00	1978-07-08	1978-07-08 00:00:00	32020		\N	120241	0	10509002	260139		0
20045	1208	40481087	1971-12-22	1971-12-22 00:00:00	1971-12-29	1971-12-29 00:00:00	32020		\N	79394	0	444814009	40481087		0
20226	1217	81151	2014-07-11	2014-07-11 00:00:00	2014-08-08	2014-08-08 00:00:00	32020		\N	80184	0	44465007	81151		0
20335	1223	260139	2015-01-24	2015-01-24 00:00:00	2015-02-07	2015-02-07 00:00:00	32020		\N	80526	0	10509002	260139		0
20558	1236	40481087	2017-02-06	2017-02-06 00:00:00	2017-02-20	2017-02-20 00:00:00	32020		\N	81472	0	444814009	40481087		0
20724	1245	40481087	1951-03-21	1951-03-21 00:00:00	1951-04-11	1951-04-11 00:00:00	32020		\N	81949	0	444814009	40481087		0
20866	1253	40481087	2002-01-04	2002-01-04 00:00:00	2002-01-25	2002-01-25 00:00:00	32020		\N	82493	0	444814009	40481087		0
20993	1259	134438	1981-03-28	1981-03-28 00:00:00	1983-11-18	1983-11-18 00:00:00	32020		\N	82975	0	40275004	134438		0
31710	1879	4237458	1994-11-25	1994-11-25 00:00:00	1995-01-24	1995-01-24 00:00:00	32020		\N	125382	0	58150001	4237458		0
10761	639	4112343	2014-02-24	2014-02-24 00:00:00	2014-03-06	2014-03-06 00:00:00	32020		\N	42305	0	195662009	4112343		0
10942	648	4278672	2001-02-27	2001-02-27 00:00:00	2001-03-29	2001-03-29 00:00:00	32020		\N	42966	0	65966004	4278672		0
11086	653	40481087	1989-11-13	1989-11-13 00:00:00	1989-12-04	1989-12-04 00:00:00	32020		\N	43215	0	444814009	40481087		0
11270	665	40481087	2009-05-09	2009-05-09 00:00:00	2009-05-23	2009-05-23 00:00:00	32020		\N	43994	0	444814009	40481087		0
11388	673	40481087	2003-08-23	2003-08-23 00:00:00	2003-09-06	2003-09-06 00:00:00	32020		\N	44505	0	444814009	40481087		0
22099	1321	260139	1978-05-22	1978-05-22 00:00:00	1978-06-05	1978-06-05 00:00:00	32020		\N	87653	0	10509002	260139		0
11735	693	4113008	1966-09-13	1966-09-13 00:00:00	1966-09-27	1966-09-27 00:00:00	32020		\N	45890	0	284549007	4113008		0
11908	704	372328	1976-03-19	1976-03-19 00:00:00	1976-10-06	1976-10-06 00:00:00	32020		\N	46549	0	65363002	372328		0
12057	712	440086	1988-11-03	1988-11-03 00:00:00	1989-02-23	1989-02-23 00:00:00	32020		\N	47222	0	192127007	440086		0
12284	727	40481087	1999-06-06	1999-06-06 00:00:00	1999-06-13	1999-06-13 00:00:00	32020		\N	48165	0	444814009	40481087		0
12356	730	40481087	1968-11-18	1968-11-18 00:00:00	1968-12-02	1968-12-02 00:00:00	32020		\N	48492	0	444814009	40481087		0
12545	742	4152936	1952-10-20	1952-10-20 00:00:00	1952-11-10	1952-11-10 00:00:00	32020		\N	49187	0	283385000	4152936		0
12747	754	40481087	1985-04-03	1985-04-03 00:00:00	1985-04-17	1985-04-17 00:00:00	32020		\N	49965	0	444814009	40481087		0
12918	759	4112343	1973-03-23	1973-03-23 00:00:00	1973-03-30	1973-03-30 00:00:00	32020		\N	50381	0	195662009	4112343		0
13094	771	4112343	1993-12-31	1993-12-31 00:00:00	1994-01-08	1994-01-08 00:00:00	32020		\N	51232	0	195662009	4112343		0
13232	778	81151	1985-01-10	1985-01-10 00:00:00	1985-01-31	1985-01-31 00:00:00	32020		\N	51672	0	44465007	81151		0
13368	787	40481087	1997-04-26	1997-04-26 00:00:00	1997-05-10	1997-05-10 00:00:00	32020		\N	52340	0	444814009	40481087		0
24124	1438	260139	1992-05-18	1992-05-18 00:00:00	1992-05-25	1992-05-25 00:00:00	32020		\N	95808	0	10509002	260139		0
13766	814	260139	2003-04-15	2003-04-15 00:00:00	2003-04-22	2003-04-22 00:00:00	32020		\N	53973	0	10509002	260139		0
13866	820	40481087	1987-01-16	1987-01-16 00:00:00	1987-01-23	1987-01-23 00:00:00	32020		\N	54288	0	444814009	40481087		0
14020	828	4112343	1994-07-28	1994-07-28 00:00:00	1994-08-09	1994-08-09 00:00:00	32020		\N	54843	0	195662009	4112343		0
14275	842	40481087	2013-11-06	2013-11-06 00:00:00	2013-11-20	2013-11-20 00:00:00	32020		\N	55649	0	444814009	40481087		0
14376	850	4112343	1987-07-03	1987-07-03 00:00:00	1987-07-12	1987-07-12 00:00:00	32020		\N	56217	0	195662009	4112343		0
14565	862	40481087	1994-04-09	1994-04-09 00:00:00	1994-04-23	1994-04-23 00:00:00	32020		\N	57064	0	444814009	40481087		0
14704	867	40481087	1953-09-25	1953-09-25 00:00:00	1953-10-16	1953-10-16 00:00:00	32020		\N	57576	0	444814009	40481087		0
25400	1513	40481087	1986-01-17	1986-01-17 00:00:00	1986-01-31	1986-01-31 00:00:00	32020		\N	101158	0	444814009	40481087		0
15068	887	40481087	1965-04-11	1965-04-11 00:00:00	1965-04-18	1965-04-18 00:00:00	32020		\N	59152	0	444814009	40481087		0
25734	1529	260139	2001-06-10	2001-06-10 00:00:00	2001-06-24	2001-06-24 00:00:00	32020		\N	102365	0	10509002	260139		0
15429	915	4112343	1997-08-29	1997-08-29 00:00:00	1997-09-07	1997-09-07 00:00:00	32020		\N	60863	0	195662009	4112343		0
15532	919	260139	1998-11-09	1998-11-09 00:00:00	1998-11-16	1998-11-16 00:00:00	32020		\N	61250	0	10509002	260139		0
15742	931	40481087	2012-06-15	2012-06-15 00:00:00	2012-07-06	2012-07-06 00:00:00	32020		\N	61929	0	444814009	40481087		0
15848	938	4146173	2002-08-01	2002-08-01 00:00:00	2002-09-30	2002-09-30 00:00:00	32020		\N	62321	0	307731004	4146173		0
16063	950	40481087	1983-02-08	1983-02-08 00:00:00	1983-02-22	1983-02-22 00:00:00	32020		\N	63126	0	444814009	40481087		0
16231	959	28060	1979-01-16	1979-01-16 00:00:00	1979-01-27	1979-01-27 00:00:00	32020		\N	63698	0	43878008	28060		0
16364	967	4283893	1947-05-29	1947-05-29 00:00:00	1947-07-03	1947-07-03 00:00:00	32020		\N	64345	0	36971009	4283893		0
16506	974	4112343	1969-06-02	1969-06-02 00:00:00	1969-06-09	1969-06-09 00:00:00	32020		\N	64985	0	195662009	4112343		0
16745	992	40481087	1957-02-24	1957-02-24 00:00:00	1957-03-10	1957-03-10 00:00:00	32020		\N	65728	0	444814009	40481087		0
16913	1005	4051466	1970-02-27	1970-02-27 00:00:00	1986-07-22	1986-07-22 00:00:00	32020		\N	66404	0	233678006	4051466		0
17045	1018	4218389	2009-06-20	2009-06-20 00:00:00	2009-07-11	2009-07-11 00:00:00	32020		\N	67011	0	39848009	4218389		0
27741	1636	372328	1963-04-10	1963-04-10 00:00:00	1963-08-09	1963-08-09 00:00:00	32020		\N	109915	0	65363002	372328		0
27932	1649	40481087	2003-08-09	2003-08-09 00:00:00	2003-08-23	2003-08-23 00:00:00	32020		\N	110650	0	444814009	40481087		0
17542	1054	257012	1995-02-26	1995-02-26 00:00:00	\N	\N	32020		\N	69142	0	40055000	257012		0
17744	1068	4155034	2013-07-28	2013-07-28 00:00:00	2013-08-18	2013-08-18 00:00:00	32020		\N	69963	0	283371005	4155034		0
28394	1679	260139	2009-04-04	2009-04-04 00:00:00	2009-04-11	2009-04-11 00:00:00	32020		\N	112591	0	10509002	260139		0
18025	1083	4152936	2006-10-21	2006-10-21 00:00:00	2006-11-04	2006-11-04 00:00:00	32020		\N	71058	0	283385000	4152936		0
18234	1097	80180	2004-05-07	2004-05-07 00:00:00	\N	\N	32020		\N	71972	0	396275006	80180		0
18321	1101	258780	2000-06-25	2000-06-25 00:00:00	\N	\N	32020		\N	72323	0	185086009	258780		0
18541	1115	4112343	2013-11-07	2013-11-07 00:00:00	2013-11-17	2013-11-17 00:00:00	32020		\N	73374	0	195662009	4112343		0
18694	1124	4112343	1965-03-19	1965-03-19 00:00:00	1965-03-30	1965-03-30 00:00:00	32020		\N	74097	0	195662009	4112343		0
18873	1135	378001	1969-02-02	1969-02-02 00:00:00	1969-04-03	1969-04-03 00:00:00	32020		\N	74761	0	62106007	378001		0
19041	1144	40481087	2008-08-05	2008-08-05 00:00:00	2008-08-26	2008-08-26 00:00:00	32020		\N	75477	0	444814009	40481087		0
19187	1149	40481087	2007-11-04	2007-11-04 00:00:00	2007-11-18	2007-11-18 00:00:00	32020		\N	75962	0	444814009	40481087		0
19388	1162	28060	1987-12-01	1987-12-01 00:00:00	1987-12-13	1987-12-13 00:00:00	32020		\N	76701	0	43878008	28060		0
30081	1779	81893	1975-10-14	1975-10-14 00:00:00	\N	\N	32020		\N	119088	0	64766004	81893		0
19736	1185	80180	1978-08-06	1978-08-06 00:00:00	\N	\N	32020		\N	78142	0	396275006	80180		0
30411	1793	40481087	1986-05-09	1986-05-09 00:00:00	1986-05-23	1986-05-23 00:00:00	32020		\N	120242	0	444814009	40481087		0
20046	1208	4112343	1951-12-06	1951-12-06 00:00:00	1951-12-19	1951-12-19 00:00:00	32020		\N	79329	0	195662009	4112343		0
20227	1217	372328	1974-02-19	1974-02-19 00:00:00	1974-06-21	1974-06-21 00:00:00	32020		\N	80148	0	65363002	372328		0
20336	1223	40481087	1964-07-30	1964-07-30 00:00:00	1964-08-20	1964-08-20 00:00:00	32020		\N	80512	0	444814009	40481087		0
20559	1236	40481087	1932-02-15	1932-02-15 00:00:00	1932-03-07	1932-03-07 00:00:00	32020		\N	81443	0	444814009	40481087		0
20725	1245	40481087	1982-04-07	1982-04-07 00:00:00	1982-04-21	1982-04-21 00:00:00	32020		\N	81941	0	444814009	40481087		0
20867	1253	40481087	1956-09-06	1956-09-06 00:00:00	1956-09-20	1956-09-20 00:00:00	32020		\N	82515	0	444814009	40481087		0
20994	1259	4112343	1953-04-03	1953-04-03 00:00:00	1953-04-10	1953-04-10 00:00:00	32020		\N	82980	0	195662009	4112343		0
31711	1879	80502	2019-05-04	2019-05-04 00:00:00	\N	\N	32020		\N	125427	0	64859006	80502		0
10762	639	4116491	1989-12-25	1989-12-25 00:00:00	1990-02-07	1990-02-07 00:00:00	32020		\N	42304	0	301011002	4116491		0
10943	648	4112343	1942-09-12	1942-09-12 00:00:00	1942-09-23	1942-09-23 00:00:00	32020		\N	42948	0	195662009	4112343		0
11087	654	260139	2010-03-03	2010-03-03 00:00:00	2010-03-10	2010-03-10 00:00:00	32020		\N	43295	0	10509002	260139		0
11271	665	4112343	2007-07-09	2007-07-09 00:00:00	2007-07-17	2007-07-17 00:00:00	32020		\N	43943	0	195662009	4112343		0
11389	673	28060	1987-05-10	1987-05-10 00:00:00	1987-05-21	1987-05-21 00:00:00	32020		\N	44522	0	43878008	28060		0
22100	1321	81151	1999-11-02	1999-11-02 00:00:00	1999-11-16	1999-11-16 00:00:00	32020		\N	87600	0	44465007	81151		0
11736	693	4278672	1984-05-25	1984-05-25 00:00:00	1984-06-24	1984-06-24 00:00:00	32020		\N	45892	0	65966004	4278672		0
11909	704	134438	1986-12-10	1986-12-10 00:00:00	1987-10-11	1987-10-11 00:00:00	32020		\N	46583	0	40275004	134438		0
12058	712	260139	2011-07-27	2011-07-27 00:00:00	2011-08-03	2011-08-03 00:00:00	32020		\N	47217	0	10509002	260139		0
22743	1357	260139	1978-04-19	1978-04-19 00:00:00	1978-04-26	1978-04-26 00:00:00	32020		\N	89996	0	10509002	260139		0
12357	730	4142905	1965-11-02	1965-11-02 00:00:00	1965-12-02	1965-12-02 00:00:00	32020		\N	48502	0	33737001	4142905		0
12546	742	4237458	1991-11-12	1991-11-12 00:00:00	1992-01-11	1992-01-11 00:00:00	32020		\N	49190	0	58150001	4237458		0
12748	754	257012	1992-02-20	1992-02-20 00:00:00	2010-02-28	2010-02-28 00:00:00	32020		\N	49932	0	40055000	257012		0
12919	759	4027663	1971-12-28	1971-12-28 00:00:00	\N	\N	32020		\N	50417	0	13200003	4027663		0
13095	771	40481087	1962-05-04	1962-05-04 00:00:00	1962-05-25	1962-05-25 00:00:00	32020		\N	51170	0	444814009	40481087		0
13233	778	40481087	2011-08-10	2011-08-10 00:00:00	2011-08-24	2011-08-24 00:00:00	32020		\N	51667	0	444814009	40481087		0
13369	787	260139	1978-02-17	1978-02-17 00:00:00	1978-02-24	1978-02-24 00:00:00	32020		\N	52360	0	10509002	260139		0
24125	1438	80180	1986-04-29	1986-04-29 00:00:00	\N	\N	32020		\N	95827	0	396275006	80180		0
13767	814	40481087	2004-09-30	2004-09-30 00:00:00	2004-10-07	2004-10-07 00:00:00	32020		\N	53995	0	444814009	40481087		0
13867	820	260139	2009-10-14	2009-10-14 00:00:00	2009-10-21	2009-10-21 00:00:00	32020		\N	54329	0	10509002	260139		0
14021	828	372328	1954-06-12	1954-06-12 00:00:00	1954-09-21	1954-09-21 00:00:00	32020		\N	54857	0	65363002	372328		0
14276	842	40481087	1918-06-18	1918-06-18 00:00:00	1918-07-02	1918-07-02 00:00:00	32020		\N	55675	0	444814009	40481087		0
14377	850	81893	1987-12-05	1987-12-05 00:00:00	\N	\N	32020		\N	56217	0	64766004	81893		0
14566	862	260139	1995-08-31	1995-08-31 00:00:00	1995-09-07	1995-09-07 00:00:00	32020		\N	57084	0	10509002	260139		0
14705	867	4112343	1933-07-09	1933-07-09 00:00:00	1933-07-18	1933-07-18 00:00:00	32020		\N	57575	0	195662009	4112343		0
25401	1513	4112343	2007-07-04	2007-07-04 00:00:00	2007-07-11	2007-07-11 00:00:00	32020		\N	101025	0	195662009	4112343		0
15069	887	80502	2018-02-24	2018-02-24 00:00:00	\N	\N	32020		\N	59163	0	64859006	80502		0
25735	1529	40481087	2009-07-03	2009-07-03 00:00:00	2009-07-24	2009-07-24 00:00:00	32020		\N	102304	0	444814009	40481087		0
15430	915	4112343	1960-05-27	1960-05-27 00:00:00	1960-06-08	1960-06-08 00:00:00	32020		\N	60833	0	195662009	4112343		0
15533	919	40481087	2012-12-18	2012-12-18 00:00:00	2013-01-08	2013-01-08 00:00:00	32020		\N	61232	0	444814009	40481087		0
15743	931	4156265	1964-05-28	1964-05-28 00:00:00	1964-06-11	1964-06-11 00:00:00	32020		\N	61957	0	370247008	4156265		0
15849	938	260139	2000-12-30	2000-12-30 00:00:00	2001-01-06	2001-01-06 00:00:00	32020		\N	62353	0	10509002	260139		0
16064	950	4112343	2002-08-02	2002-08-02 00:00:00	2002-08-09	2002-08-09 00:00:00	32020		\N	63069	0	195662009	4112343		0
16232	959	260139	1996-10-18	1996-10-18 00:00:00	1996-10-25	1996-10-25 00:00:00	32020		\N	63776	0	10509002	260139		0
16365	967	40481087	2016-04-13	2016-04-13 00:00:00	2016-04-20	2016-04-20 00:00:00	32020		\N	64365	0	444814009	40481087		0
16507	974	40481087	1967-02-05	1967-02-05 00:00:00	1967-02-26	1967-02-26 00:00:00	32020		\N	64982	0	444814009	40481087		0
16746	992	40481087	2002-01-22	2002-01-22 00:00:00	2002-02-05	2002-02-05 00:00:00	32020		\N	65807	0	444814009	40481087		0
16914	1005	4112343	1970-04-20	1970-04-20 00:00:00	1970-04-30	1970-04-30 00:00:00	32020		\N	66405	0	195662009	4112343		0
17046	1018	4112343	1989-10-05	1989-10-05 00:00:00	1989-10-12	1989-10-12 00:00:00	32020		\N	67013	0	195662009	4112343		0
27742	1636	372328	1956-04-10	1956-04-10 00:00:00	1956-05-18	1956-05-18 00:00:00	32020		\N	109873	0	65363002	372328		0
27933	1649	260139	1994-10-26	1994-10-26 00:00:00	1994-11-02	1994-11-02 00:00:00	32020		\N	110675	0	10509002	260139		0
17543	1054	260139	1939-08-13	1939-08-13 00:00:00	1939-08-27	1939-08-27 00:00:00	32020		\N	69139	0	10509002	260139		0
17745	1068	4113008	2004-10-01	2004-10-01 00:00:00	2004-10-15	2004-10-15 00:00:00	32020		\N	69961	0	284549007	4113008		0
28395	1679	4156265	1973-09-09	1973-09-09 00:00:00	1973-09-23	1973-09-23 00:00:00	32020		\N	112585	0	370247008	4156265		0
18026	1083	78272	1967-05-14	1967-05-14 00:00:00	1967-06-18	1967-06-18 00:00:00	32020		\N	71054	0	70704007	78272		0
18235	1097	40481087	2004-01-25	2004-01-25 00:00:00	2004-02-15	2004-02-15 00:00:00	32020		\N	71972	0	444814009	40481087		0
18322	1101	321042	1982-08-22	1982-08-22 00:00:00	\N	\N	32020		\N	72326	0	410429000	321042		0
18542	1115	4152936	2007-01-09	2007-01-09 00:00:00	2007-01-23	2007-01-23 00:00:00	32020		\N	73389	0	283385000	4152936		0
18695	1124	4218389	2005-03-26	2005-03-26 00:00:00	2005-04-23	2005-04-23 00:00:00	32020		\N	74115	0	39848009	4218389		0
18874	1135	4035415	1981-10-27	1981-10-27 00:00:00	1981-11-26	1981-11-26 00:00:00	32020		\N	74762	0	239720000	4035415		0
19042	1144	4112343	1989-08-08	1989-08-08 00:00:00	1989-08-19	1989-08-19 00:00:00	32020		\N	75514	0	195662009	4112343		0
19188	1149	4149245	1986-11-19	1986-11-19 00:00:00	1986-12-26	1986-12-26 00:00:00	32020		\N	75945	0	30832001	4149245		0
19389	1162	378001	1982-08-02	1982-08-02 00:00:00	1982-10-01	1982-10-01 00:00:00	32020		\N	76730	0	62106007	378001		0
30082	1779	4218389	2003-12-16	2003-12-16 00:00:00	2004-01-13	2004-01-13 00:00:00	32020		\N	119010	0	39848009	4218389		0
19737	1185	4294548	2000-07-29	2000-07-29 00:00:00	2000-10-07	2000-10-07 00:00:00	32020		\N	78182	0	75498004	4294548		0
30412	1793	317576	1980-07-23	1980-07-23 00:00:00	\N	\N	32020		\N	120185	0	53741008	317576		0
20047	1208	4112343	1954-07-10	1954-07-10 00:00:00	1954-07-19	1954-07-19 00:00:00	32020		\N	79393	0	195662009	4112343		0
20228	1217	260139	2003-07-05	2003-07-05 00:00:00	2003-07-12	2003-07-12 00:00:00	32020		\N	80159	0	10509002	260139		0
20337	1223	30753	1989-01-23	1989-01-23 00:00:00	\N	\N	32020		\N	80508	0	16761005	30753		0
20560	1236	4237458	2001-03-04	2001-03-04 00:00:00	2001-04-03	2001-04-03 00:00:00	32020		\N	81488	0	58150001	4237458		0
20726	1245	40481087	1991-06-17	1991-06-17 00:00:00	1991-07-01	1991-07-01 00:00:00	32020		\N	81983	0	444814009	40481087		0
20868	1253	4112343	2004-03-18	2004-03-18 00:00:00	2004-03-26	2004-03-26 00:00:00	32020		\N	82562	0	195662009	4112343		0
20995	1259	4112343	1997-10-11	1997-10-11 00:00:00	1997-10-18	1997-10-18 00:00:00	32020		\N	82924	0	195662009	4112343		0
31712	1879	4296204	1984-03-17	1984-03-17 00:00:00	1984-04-07	1984-04-07 00:00:00	32020		\N	125369	0	403190006	4296204		0
10763	639	372328	1954-03-29	1954-03-29 00:00:00	1954-06-12	1954-06-12 00:00:00	32020		\N	42306	0	65363002	372328		0
10944	648	4112343	1949-11-02	1949-11-02 00:00:00	1949-11-10	1949-11-10 00:00:00	32020		\N	42914	0	195662009	4112343		0
11088	654	4112343	1979-05-31	1979-05-31 00:00:00	1979-06-10	1979-06-10 00:00:00	32020		\N	43310	0	195662009	4112343		0
11272	665	40481087	1988-11-12	1988-11-12 00:00:00	1988-11-19	1988-11-19 00:00:00	32020		\N	43991	0	444814009	40481087		0
11390	673	81151	2012-05-26	2012-05-26 00:00:00	2012-06-16	2012-06-16 00:00:00	32020		\N	44440	0	44465007	81151		0
22101	1321	260139	2015-12-11	2015-12-11 00:00:00	2015-12-18	2015-12-18 00:00:00	32020		\N	87642	0	10509002	260139		0
11737	693	4142905	1968-09-16	1968-09-16 00:00:00	1968-11-15	1968-11-15 00:00:00	32020		\N	45891	0	33737001	4142905		0
11910	704	260139	1999-03-20	1999-03-20 00:00:00	1999-04-03	1999-04-03 00:00:00	32020		\N	46597	0	10509002	260139		0
12059	712	40481087	1978-09-21	1978-09-21 00:00:00	1978-09-28	1978-09-28 00:00:00	32020		\N	47243	0	444814009	40481087		0
22744	1357	81151	2000-05-19	2000-05-19 00:00:00	2000-06-09	2000-06-09 00:00:00	32020		\N	90036	0	44465007	81151		0
12358	730	372328	1962-02-07	1962-02-07 00:00:00	1962-03-24	1962-03-24 00:00:00	32020		\N	48470	0	65363002	372328		0
12547	742	4112343	1926-01-12	1926-01-12 00:00:00	1926-01-19	1926-01-19 00:00:00	32020		\N	49135	0	195662009	4112343		0
12749	754	4116491	1989-08-11	1989-08-11 00:00:00	1989-09-30	1989-09-30 00:00:00	32020		\N	49850	0	301011002	4116491		0
12920	759	40481087	1974-12-21	1974-12-21 00:00:00	1975-01-04	1975-01-04 00:00:00	32020		\N	50391	0	444814009	40481087		0
13096	771	4112343	1967-05-29	1967-05-29 00:00:00	1967-06-05	1967-06-05 00:00:00	32020		\N	51172	0	195662009	4112343		0
13234	778	40481087	1995-04-27	1995-04-27 00:00:00	1995-05-04	1995-05-04 00:00:00	32020		\N	51675	0	444814009	40481087		0
13370	787	4112343	1978-05-19	1978-05-19 00:00:00	1978-05-27	1978-05-27 00:00:00	32020		\N	52346	0	195662009	4112343		0
24126	1439	4059173	1991-10-29	1991-10-29 00:00:00	1992-01-27	1992-01-27 00:00:00	32020		\N	95876	0	16114001	4059173		0
13768	814	4027663	2008-07-05	2008-07-05 00:00:00	\N	\N	32020		\N	53966	0	13200003	4027663		0
13868	820	4112343	2008-05-02	2008-05-02 00:00:00	2008-05-15	2008-05-15 00:00:00	32020		\N	54328	0	195662009	4112343		0
14022	828	381316	2005-06-14	2005-06-14 00:00:00	\N	\N	32020		\N	54823	0	230690007	381316		0
24735	1476	4283893	1949-08-23	1949-08-23 00:00:00	1949-09-27	1949-09-27 00:00:00	32020		\N	98436	0	36971009	4283893		0
14378	850	4152936	1978-04-06	1978-04-06 00:00:00	1978-04-20	1978-04-20 00:00:00	32020		\N	56237	0	283385000	4152936		0
14567	862	260139	1997-06-29	1997-06-29 00:00:00	1997-07-06	1997-07-06 00:00:00	32020		\N	57089	0	10509002	260139		0
14706	867	81151	2018-01-17	2018-01-17 00:00:00	2018-02-21	2018-02-21 00:00:00	32020		\N	57585	0	44465007	81151		0
25402	1513	372328	1972-07-21	1972-07-21 00:00:00	1973-01-28	1973-01-28 00:00:00	32020		\N	101085	0	65363002	372328		0
15070	887	80180	1991-06-27	1991-06-27 00:00:00	\N	\N	32020		\N	59123	0	396275006	80180		0
25736	1529	4059173	1967-07-06	1967-07-06 00:00:00	1967-09-04	1967-09-04 00:00:00	32020		\N	102352	0	16114001	4059173		0
15431	915	40481087	1987-01-13	1987-01-13 00:00:00	1987-01-20	1987-01-20 00:00:00	32020		\N	60835	0	444814009	40481087		0
15534	919	260139	1992-08-19	1992-08-19 00:00:00	1992-09-02	1992-09-02 00:00:00	32020		\N	61254	0	10509002	260139		0
15744	931	4112343	1993-04-02	1993-04-02 00:00:00	1993-04-10	1993-04-10 00:00:00	32020		\N	61979	0	195662009	4112343		0
15850	938	40481087	2000-02-19	2000-02-19 00:00:00	2000-03-04	2000-03-04 00:00:00	32020		\N	62352	0	444814009	40481087		0
16065	950	80180	2010-02-28	2010-02-28 00:00:00	\N	\N	32020		\N	63113	0	396275006	80180		0
16233	959	4112343	2016-12-24	2016-12-24 00:00:00	2016-12-31	2016-12-31 00:00:00	32020		\N	63727	0	195662009	4112343		0
16366	967	4278672	2002-02-15	2002-02-15 00:00:00	2002-04-16	2002-04-16 00:00:00	32020		\N	64317	0	65966004	4278672		0
16508	974	372328	1956-12-21	1956-12-21 00:00:00	1957-03-03	1957-03-03 00:00:00	32020		\N	64999	0	65363002	372328		0
16747	992	260139	1956-09-07	1956-09-07 00:00:00	1956-09-21	1956-09-21 00:00:00	32020		\N	65727	0	10509002	260139		0
16915	1005	40481087	1985-03-22	1985-03-22 00:00:00	1985-03-29	1985-03-29 00:00:00	32020		\N	66416	0	444814009	40481087		0
17047	1018	40481087	1975-12-22	1975-12-22 00:00:00	1976-01-12	1976-01-12 00:00:00	32020		\N	67037	0	444814009	40481087		0
27743	1636	4027663	1990-02-01	1990-02-01 00:00:00	\N	\N	32020		\N	109906	0	13200003	4027663		0
27934	1649	4109685	1972-10-09	1972-10-09 00:00:00	1972-10-30	1972-10-30 00:00:00	32020		\N	110678	0	284551006	4109685		0
17544	1054	40481087	1986-02-12	1986-02-12 00:00:00	1986-02-19	1986-02-19 00:00:00	32020		\N	69122	0	444814009	40481087		0
17746	1068	372328	2011-12-24	2011-12-24 00:00:00	2013-09-20	2013-09-20 00:00:00	32020		\N	69990	0	65363002	372328		0
28396	1679	372328	1974-01-02	1974-01-02 00:00:00	1974-08-20	1974-08-20 00:00:00	32020		\N	112562	0	65363002	372328		0
18027	1083	4112343	1969-02-06	1969-02-06 00:00:00	1969-02-19	1969-02-19 00:00:00	32020		\N	71067	0	195662009	4112343		0
18236	1097	40481087	1978-01-15	1978-01-15 00:00:00	1978-02-05	1978-02-05 00:00:00	32020		\N	72005	0	444814009	40481087		0
18324	1101	378001	1977-09-01	1977-09-01 00:00:00	1977-10-01	1977-10-01 00:00:00	32020		\N	72324	0	62106007	378001		0
18543	1115	260139	1959-07-20	1959-07-20 00:00:00	1959-08-03	1959-08-03 00:00:00	32020		\N	73451	0	10509002	260139		0
18696	1124	4113008	1940-08-31	1940-08-31 00:00:00	1940-09-14	1940-09-14 00:00:00	32020		\N	74110	0	284549007	4113008		0
18875	1135	372328	1959-09-04	1959-09-04 00:00:00	1959-12-05	1959-12-05 00:00:00	32020		\N	74743	0	65363002	372328		0
19043	1144	4109685	1980-01-16	1980-01-16 00:00:00	1980-01-30	1980-01-30 00:00:00	32020		\N	75495	0	284551006	4109685		0
19189	1149	40481087	1992-12-20	1992-12-20 00:00:00	1992-12-27	1992-12-27 00:00:00	32020		\N	75979	0	444814009	40481087		0
19390	1162	80180	1963-07-08	1963-07-08 00:00:00	\N	\N	32020		\N	76663	0	396275006	80180		0
30083	1779	4084167	1945-02-13	1945-02-13 00:00:00	1945-02-13	1945-02-13 00:00:00	32020		\N	119062	0	241929008	4084167		0
19738	1185	40481087	1976-09-28	1976-09-28 00:00:00	1976-10-05	1976-10-05 00:00:00	32020		\N	78103	0	444814009	40481087		0
30413	1793	4146173	2005-07-04	2005-07-04 00:00:00	2005-09-02	2005-09-02 00:00:00	32020		\N	120246	0	307731004	4146173		0
20048	1208	40481087	1996-10-10	1996-10-10 00:00:00	1996-10-31	1996-10-31 00:00:00	32020		\N	79335	0	444814009	40481087		0
20229	1217	4294548	1993-06-01	1993-06-01 00:00:00	1993-06-15	1993-06-15 00:00:00	32020		\N	80158	0	75498004	4294548		0
20338	1223	4310024	1988-11-24	1988-11-24 00:00:00	\N	\N	32020		\N	80508	0	424802006	4310024		0
20561	1236	40479422	1966-12-28	1966-12-28 00:00:00	1967-03-05	1967-03-05 00:00:00	32020		\N	81484	0	444448004	40479422		0
20727	1245	40481087	1947-12-18	1947-12-18 00:00:00	1948-01-01	1948-01-01 00:00:00	32020		\N	81870	0	444814009	40481087		0
20869	1253	40481087	2005-03-16	2005-03-16 00:00:00	2005-03-23	2005-03-23 00:00:00	32020		\N	82523	0	444814009	40481087		0
20996	1259	4296204	1960-12-05	1960-12-05 00:00:00	1960-12-19	1960-12-19 00:00:00	32020		\N	82962	0	403190006	4296204		0
31713	1879	40481087	1960-06-03	1960-06-03 00:00:00	1960-06-24	1960-06-24 00:00:00	32020		\N	125432	0	444814009	40481087		0
10764	639	4112343	1981-11-22	1981-11-22 00:00:00	1981-11-29	1981-11-29 00:00:00	32020		\N	42291	0	195662009	4112343		0
10945	648	260139	1991-12-20	1991-12-20 00:00:00	1992-01-03	1992-01-03 00:00:00	32020		\N	42951	0	10509002	260139		0
11089	654	40481087	2015-08-17	2015-08-17 00:00:00	2015-08-24	2015-08-24 00:00:00	32020		\N	43339	0	444814009	40481087		0
11273	665	81151	1986-08-17	1986-08-17 00:00:00	1986-09-21	1986-09-21 00:00:00	32020		\N	43938	0	44465007	81151		0
11391	673	40481087	1989-08-21	1989-08-21 00:00:00	1989-08-28	1989-08-28 00:00:00	32020		\N	44503	0	444814009	40481087		0
22102	1321	40481087	1987-09-20	1987-09-20 00:00:00	1987-10-11	1987-10-11 00:00:00	32020		\N	87610	0	444814009	40481087		0
11738	693	4283893	1962-11-05	1962-11-05 00:00:00	1962-12-10	1962-12-10 00:00:00	32020		\N	45918	0	36971009	4283893		0
11911	704	4112343	1970-05-20	1970-05-20 00:00:00	1970-05-27	1970-05-27 00:00:00	32020		\N	46514	0	195662009	4112343		0
12060	712	81151	2018-04-20	2018-04-20 00:00:00	2018-05-04	2018-05-04 00:00:00	32020		\N	47269	0	44465007	81151		0
22745	1357	4134304	1982-05-24	1982-05-24 00:00:00	1982-07-23	1982-07-23 00:00:00	32020		\N	90033	0	263102004	4134304		0
12359	730	40481087	1998-11-29	1998-11-29 00:00:00	1998-12-06	1998-12-06 00:00:00	32020		\N	48466	0	444814009	40481087		0
12548	742	81151	1975-05-19	1975-05-19 00:00:00	1975-06-09	1975-06-09 00:00:00	32020		\N	49189	0	44465007	81151		0
12750	754	40481087	1977-11-21	1977-11-21 00:00:00	1977-12-05	1977-12-05 00:00:00	32020		\N	49964	0	444814009	40481087		0
12921	759	375671	2000-04-24	2000-04-24 00:00:00	2000-06-23	2000-06-23 00:00:00	32020		\N	50362	0	62564004	375671		0
13097	771	40481087	1961-10-14	1961-10-14 00:00:00	1961-10-28	1961-10-28 00:00:00	32020		\N	51240	0	444814009	40481087		0
13235	778	4112343	1994-02-06	1994-02-06 00:00:00	1994-02-14	1994-02-14 00:00:00	32020		\N	51646	0	195662009	4112343		0
13371	787	80180	2017-01-07	2017-01-07 00:00:00	\N	\N	32020		\N	52349	0	396275006	80180		0
24127	1439	28060	1985-01-05	1985-01-05 00:00:00	1985-01-12	1985-01-12 00:00:00	32020		\N	95917	0	43878008	28060		0
13769	814	4116491	2011-07-05	2011-07-05 00:00:00	2011-08-20	2011-08-20 00:00:00	32020		\N	53992	0	301011002	4116491		0
13869	820	4112343	1980-10-19	1980-10-19 00:00:00	1980-10-29	1980-10-29 00:00:00	32020		\N	54325	0	195662009	4112343		0
14023	828	4112343	1956-04-06	1956-04-06 00:00:00	1956-04-17	1956-04-17 00:00:00	32020		\N	54813	0	195662009	4112343		0
24736	1476	4152936	1957-10-27	1957-10-27 00:00:00	1957-11-10	1957-11-10 00:00:00	32020		\N	98493	0	283385000	4152936		0
14379	850	40481087	1965-03-20	1965-03-20 00:00:00	1965-03-27	1965-03-27 00:00:00	32020		\N	56229	0	444814009	40481087		0
14568	862	4112343	1976-11-21	1976-11-21 00:00:00	1976-12-01	1976-12-01 00:00:00	32020		\N	57041	0	195662009	4112343		0
14707	867	260139	1973-05-15	1973-05-15 00:00:00	1973-05-22	1973-05-22 00:00:00	32020		\N	57516	0	10509002	260139		0
25403	1513	375671	1977-04-09	1977-04-09 00:00:00	1977-05-09	1977-05-09 00:00:00	32020		\N	101149	0	62564004	375671		0
15071	887	81151	2002-07-29	2002-07-29 00:00:00	2002-08-19	2002-08-19 00:00:00	32020		\N	59106	0	44465007	81151		0
25737	1529	80180	2000-07-12	2000-07-12 00:00:00	\N	\N	32020		\N	102346	0	396275006	80180		0
15432	915	40481087	2016-07-12	2016-07-12 00:00:00	2016-07-19	2016-07-19 00:00:00	32020		\N	60801	0	444814009	40481087		0
15535	919	4112343	1999-05-13	1999-05-13 00:00:00	1999-05-22	1999-05-22 00:00:00	32020		\N	61255	0	195662009	4112343		0
15745	931	4112343	1966-08-08	1966-08-08 00:00:00	1966-08-18	1966-08-18 00:00:00	32020		\N	61927	0	195662009	4112343		0
15851	938	40481087	1957-10-11	1957-10-11 00:00:00	1957-10-18	1957-10-18 00:00:00	32020		\N	62409	0	444814009	40481087		0
16066	950	372328	1972-09-10	1972-09-10 00:00:00	1972-10-29	1972-10-29 00:00:00	32020		\N	63089	0	65363002	372328		0
16234	959	4048171	1963-04-01	1963-04-01 00:00:00	1977-03-30	1977-03-30 00:00:00	32020		\N	63669	0	232353008	4048171		0
16367	967	40481087	1984-06-12	1984-06-12 00:00:00	1984-06-19	1984-06-19 00:00:00	32020		\N	64274	0	444814009	40481087		0
16509	974	195588	1999-06-14	1999-06-14 00:00:00	1999-08-01	1999-08-01 00:00:00	32020		\N	64995	0	38822007	195588		0
16748	992	195588	2005-08-10	2005-08-10 00:00:00	2005-09-30	2005-09-30 00:00:00	32020		\N	65788	0	38822007	195588		0
16916	1005	28060	1969-09-09	1969-09-09 00:00:00	1969-09-18	1969-09-18 00:00:00	32020		\N	66424	0	43878008	28060		0
17048	1018	260139	1998-03-06	1998-03-06 00:00:00	1998-03-20	1998-03-20 00:00:00	32020		\N	67031	0	10509002	260139		0
27744	1636	28060	1966-12-07	1966-12-07 00:00:00	1966-12-20	1966-12-20 00:00:00	32020		\N	109897	0	43878008	28060		0
27935	1649	40481087	1963-05-05	1963-05-05 00:00:00	1963-05-19	1963-05-19 00:00:00	32020		\N	110619	0	444814009	40481087		0
17545	1054	4283893	1994-12-25	1994-12-25 00:00:00	1995-05-21	1995-05-21 00:00:00	32020		\N	69162	0	36971009	4283893		0
17747	1068	40481087	1995-10-15	1995-10-15 00:00:00	1995-10-29	1995-10-29 00:00:00	32020		\N	69943	0	444814009	40481087		0
28397	1679	40481087	1973-11-16	1973-11-16 00:00:00	1973-12-07	1973-12-07 00:00:00	32020		\N	112557	0	444814009	40481087		0
18028	1083	133834	1966-10-23	1966-10-23 00:00:00	1983-06-07	1983-06-07 00:00:00	32020		\N	71169	0	24079001	133834		0
18237	1097	81151	2012-02-24	2012-02-24 00:00:00	2012-03-09	2012-03-09 00:00:00	32020		\N	72013	0	44465007	81151		0
18325	1101	440086	1983-08-16	1983-08-16 00:00:00	1984-05-08	1984-05-08 00:00:00	32020		\N	72357	0	192127007	440086		0
18544	1115	40481087	2002-11-13	2002-11-13 00:00:00	2002-12-04	2002-12-04 00:00:00	32020		\N	73487	0	444814009	40481087		0
18697	1124	260139	1958-04-24	1958-04-24 00:00:00	1958-05-08	1958-05-08 00:00:00	32020		\N	74075	0	10509002	260139		0
18876	1135	40481087	2011-01-27	2011-01-27 00:00:00	2011-02-03	2011-02-03 00:00:00	32020		\N	74766	0	444814009	40481087		0
19044	1144	372328	1972-06-09	1972-06-09 00:00:00	1972-11-12	1972-11-12 00:00:00	32020		\N	75520	0	65363002	372328		0
19190	1149	260139	1987-08-18	1987-08-18 00:00:00	1987-08-25	1987-08-25 00:00:00	32020		\N	75959	0	10509002	260139		0
19391	1162	40481087	1950-12-09	1950-12-09 00:00:00	1950-12-30	1950-12-30 00:00:00	32020		\N	76675	0	444814009	40481087		0
30084	1779	81151	1955-03-23	1955-03-23 00:00:00	1955-04-06	1955-04-06 00:00:00	32020		\N	119066	0	44465007	81151		0
19739	1185	260139	2011-06-06	2011-06-06 00:00:00	2011-06-20	2011-06-20 00:00:00	32020		\N	78162	0	10509002	260139		0
30414	1793	4152936	1996-12-04	1996-12-04 00:00:00	1996-12-18	1996-12-18 00:00:00	32020		\N	120227	0	283385000	4152936		0
20049	1208	40481087	1978-05-05	1978-05-05 00:00:00	1978-05-26	1978-05-26 00:00:00	32020		\N	79333	0	444814009	40481087		0
20230	1217	260139	2015-05-28	2015-05-28 00:00:00	2015-06-11	2015-06-11 00:00:00	32020		\N	80169	0	10509002	260139		0
20339	1223	78272	1954-04-22	1954-04-22 00:00:00	1954-05-20	1954-05-20 00:00:00	32020		\N	80445	0	70704007	78272		0
20562	1236	40481087	1950-08-23	1950-08-23 00:00:00	1950-09-06	1950-09-06 00:00:00	32020		\N	81446	0	444814009	40481087		0
20728	1245	321042	2003-10-10	2003-10-10 00:00:00	\N	\N	32020		\N	81904	0	410429000	321042		0
20870	1253	4152936	1969-02-23	1969-02-23 00:00:00	1969-03-09	1969-03-09 00:00:00	32020		\N	82549	0	283385000	4152936		0
20997	1259	4109685	2007-07-05	2007-07-05 00:00:00	2007-07-19	2007-07-19 00:00:00	32020		\N	82965	0	284551006	4109685		0
31714	1879	4294548	1999-01-29	1999-01-29 00:00:00	1999-03-12	1999-03-12 00:00:00	32020		\N	125372	0	75498004	4294548		0
10765	639	372328	1956-12-04	1956-12-04 00:00:00	1957-12-14	1957-12-14 00:00:00	32020		\N	42293	0	65363002	372328		0
10946	648	260139	1980-04-13	1980-04-13 00:00:00	1980-04-27	1980-04-27 00:00:00	32020		\N	42903	0	10509002	260139		0
11090	654	28060	1971-07-31	1971-07-31 00:00:00	1971-08-07	1971-08-07 00:00:00	32020		\N	43337	0	43878008	28060		0
11274	665	40481087	1963-03-23	1963-03-23 00:00:00	1963-04-06	1963-04-06 00:00:00	32020		\N	43978	0	444814009	40481087		0
11392	673	4035415	2014-08-05	2014-08-05 00:00:00	2014-09-04	2014-09-04 00:00:00	32020		\N	44441	0	239720000	4035415		0
22103	1321	260139	1965-02-01	1965-02-01 00:00:00	1965-02-08	1965-02-08 00:00:00	32020		\N	87657	0	10509002	260139		0
11739	693	4112343	1992-10-25	1992-10-25 00:00:00	1992-11-03	1992-11-03 00:00:00	32020		\N	45947	0	195662009	4112343		0
11912	704	40481087	1992-02-05	1992-02-05 00:00:00	1992-02-12	1992-02-12 00:00:00	32020		\N	46573	0	444814009	40481087		0
12061	712	4112343	2008-07-25	2008-07-25 00:00:00	2008-08-03	2008-08-03 00:00:00	32020		\N	47247	0	195662009	4112343		0
22746	1358	260139	1964-05-27	1964-05-27 00:00:00	1964-06-10	1964-06-10 00:00:00	32020		\N	90043	0	10509002	260139		0
12360	730	80502	2017-09-16	2017-09-16 00:00:00	\N	\N	32020		\N	48464	0	64859006	80502		0
12549	742	40481087	1971-01-10	1971-01-10 00:00:00	1971-01-17	1971-01-17 00:00:00	32020		\N	49173	0	444814009	40481087		0
12751	754	80180	1973-08-05	1973-08-05 00:00:00	\N	\N	32020		\N	49951	0	396275006	80180		0
12922	759	260139	1948-12-14	1948-12-14 00:00:00	1948-12-21	1948-12-21 00:00:00	32020		\N	50372	0	10509002	260139		0
13098	771	40481087	1961-04-05	1961-04-05 00:00:00	1961-04-12	1961-04-12 00:00:00	32020		\N	51244	0	444814009	40481087		0
13236	778	372328	1978-07-18	1978-07-18 00:00:00	1978-09-28	1978-09-28 00:00:00	32020		\N	51648	0	65363002	372328		0
13372	787	4112343	2014-03-28	2014-03-28 00:00:00	2014-04-10	2014-04-10 00:00:00	32020		\N	52365	0	195662009	4112343		0
24128	1439	40481087	1984-09-06	1984-09-06 00:00:00	1984-09-20	1984-09-20 00:00:00	32020		\N	95877	0	444814009	40481087		0
13770	814	4112343	1989-06-08	1989-06-08 00:00:00	1989-06-17	1989-06-17 00:00:00	32020		\N	53955	0	195662009	4112343		0
13870	820	28060	1992-06-30	1992-06-30 00:00:00	1992-07-11	1992-07-11 00:00:00	32020		\N	54306	0	43878008	28060		0
14024	828	4294548	1988-09-04	1988-09-04 00:00:00	1988-10-16	1988-10-16 00:00:00	32020		\N	54841	0	75498004	4294548		0
24737	1476	4112343	1959-10-28	1959-10-28 00:00:00	1959-11-05	1959-11-05 00:00:00	32020		\N	98535	0	195662009	4112343		0
14380	850	40481087	1995-06-12	1995-06-12 00:00:00	1995-06-19	1995-06-19 00:00:00	32020		\N	56206	0	444814009	40481087		0
14569	862	4112343	1991-12-20	1991-12-20 00:00:00	1992-01-01	1992-01-01 00:00:00	32020		\N	57088	0	195662009	4112343		0
14708	867	260139	1963-08-31	1963-08-31 00:00:00	1963-09-07	1963-09-07 00:00:00	32020		\N	57541	0	10509002	260139		0
25404	1513	40481087	2007-05-21	2007-05-21 00:00:00	2007-06-11	2007-06-11 00:00:00	32020		\N	101107	0	444814009	40481087		0
15072	887	378001	2013-10-20	2013-10-20 00:00:00	2013-11-19	2013-11-19 00:00:00	32020		\N	59107	0	62106007	378001		0
22773	1359	313217	1987-04-14	1987-04-14 00:00:00	\N	\N	32020		\N	90184	0	49436004	313217		0
25738	1529	4218389	1993-02-24	1993-02-24 00:00:00	1993-03-31	1993-03-31 00:00:00	32020		\N	102355	0	39848009	4218389		0
15433	915	4146173	1999-01-30	1999-01-30 00:00:00	1999-03-31	1999-03-31 00:00:00	32020		\N	60825	0	307731004	4146173		0
15536	919	257012	2002-12-30	2002-12-30 00:00:00	\N	\N	32020		\N	61257	0	40055000	257012		0
15746	931	4283893	1988-09-12	1988-09-12 00:00:00	1988-10-31	1988-10-31 00:00:00	32020		\N	61969	0	36971009	4283893		0
15852	938	4278672	2015-10-22	2015-10-22 00:00:00	2015-11-21	2015-11-21 00:00:00	32020		\N	62331	0	65966004	4278672		0
16067	950	28060	1981-03-29	1981-03-29 00:00:00	1981-04-08	1981-04-08 00:00:00	32020		\N	63100	0	43878008	28060		0
16235	959	260139	1992-04-17	1992-04-17 00:00:00	1992-04-24	1992-04-24 00:00:00	32020		\N	63794	0	10509002	260139		0
16376	969	40481087	1992-10-27	1992-10-27 00:00:00	1992-11-10	1992-11-10 00:00:00	32020		\N	64447	0	444814009	40481087		0
16510	974	4296204	2013-02-21	2013-02-21 00:00:00	2013-03-14	2013-03-14 00:00:00	32020		\N	64967	0	403190006	4296204		0
16749	992	378001	1990-06-10	1990-06-10 00:00:00	1990-07-10	1990-07-10 00:00:00	32020		\N	65748	0	62106007	378001		0
16917	1005	80180	2007-07-01	2007-07-01 00:00:00	\N	\N	32020		\N	66410	0	396275006	80180		0
17049	1018	4278672	1982-11-09	1982-11-09 00:00:00	1983-01-08	1983-01-08 00:00:00	32020		\N	67010	0	65966004	4278672		0
27745	1636	28060	2013-04-27	2013-04-27 00:00:00	2013-05-10	2013-05-10 00:00:00	32020		\N	109860	0	43878008	28060		0
27937	1649	4329847	2017-08-23	2017-08-23 00:00:00	\N	\N	32020		\N	110618	0	22298006	4329847		0
17546	1054	4048171	1934-12-23	1934-12-23 00:00:00	1951-12-21	1951-12-21 00:00:00	32020		\N	69138	0	232353008	4048171		0
17748	1068	40481087	1997-11-24	1997-11-24 00:00:00	1997-12-15	1997-12-15 00:00:00	32020		\N	69944	0	444814009	40481087		0
28398	1679	4310024	2008-03-19	2008-03-19 00:00:00	\N	\N	32020		\N	112596	0	424802006	4310024		0
18029	1083	40486433	1968-05-25	1968-05-25 00:00:00	\N	\N	32020		\N	71066	0	446096008	40486433		0
18238	1097	198199	2008-03-17	2008-03-17 00:00:00	2008-05-01	2008-05-01 00:00:00	32020		\N	71973	0	45816000	198199		0
18326	1101	4166224	1985-08-17	1985-08-17 00:00:00	\N	\N	32020		\N	72327	0	47693006	4166224		0
18545	1115	260139	1970-05-09	1970-05-09 00:00:00	1970-05-16	1970-05-16 00:00:00	32020		\N	73453	0	10509002	260139		0
18698	1124	40481087	1969-09-12	1969-09-12 00:00:00	1969-09-26	1969-09-26 00:00:00	32020		\N	74116	0	444814009	40481087		0
18877	1135	260139	1996-05-09	1996-05-09 00:00:00	1996-05-16	1996-05-16 00:00:00	32020		\N	74764	0	10509002	260139		0
19045	1144	4059173	2003-01-04	2003-01-04 00:00:00	2003-02-03	2003-02-03 00:00:00	32020		\N	75497	0	16114001	4059173		0
19191	1150	80180	1991-10-14	1991-10-14 00:00:00	\N	\N	32020		\N	76084	0	396275006	80180		0
19392	1162	4112343	1958-07-03	1958-07-03 00:00:00	1958-07-13	1958-07-13 00:00:00	32020		\N	76676	0	195662009	4112343		0
30085	1779	4218389	1988-02-12	1988-02-12 00:00:00	1988-03-04	1988-03-04 00:00:00	32020		\N	119007	0	39848009	4218389		0
19740	1185	40481087	1980-10-22	1980-10-22 00:00:00	1980-10-29	1980-10-29 00:00:00	32020		\N	78104	0	444814009	40481087		0
30415	1793	40479422	1991-01-05	1991-01-05 00:00:00	1991-03-06	1991-03-06 00:00:00	32020		\N	120226	0	444448004	40479422		0
20050	1208	80180	1975-01-31	1975-01-31 00:00:00	\N	\N	32020		\N	79409	0	396275006	80180		0
20231	1217	40481087	2013-12-24	2013-12-24 00:00:00	2014-01-14	2014-01-14 00:00:00	32020		\N	80141	0	444814009	40481087		0
20340	1223	80180	1989-10-20	1989-10-20 00:00:00	\N	\N	32020		\N	80490	0	396275006	80180		0
20563	1236	4218389	1961-04-30	1961-04-30 00:00:00	1961-05-28	1961-05-28 00:00:00	32020		\N	81483	0	39848009	4218389		0
20730	1245	4218389	1984-07-05	1984-07-05 00:00:00	1984-08-09	1984-08-09 00:00:00	32020		\N	81900	0	39848009	4218389		0
20871	1253	260139	2012-07-05	2012-07-05 00:00:00	2012-07-19	2012-07-19 00:00:00	32020		\N	82511	0	10509002	260139		0
20998	1259	4112343	1981-07-12	1981-07-12 00:00:00	1981-07-21	1981-07-21 00:00:00	32020		\N	82976	0	195662009	4112343		0
31715	1879	4155034	1988-04-16	1988-04-16 00:00:00	1988-04-30	1988-04-30 00:00:00	32020		\N	125381	0	283371005	4155034		0
10766	639	260139	1998-11-27	1998-11-27 00:00:00	1998-12-11	1998-12-11 00:00:00	32020		\N	42311	0	10509002	260139		0
10947	648	4283893	2007-10-25	2007-10-25 00:00:00	2007-12-06	2007-12-06 00:00:00	32020		\N	42890	0	36971009	4283893		0
11091	654	260139	2018-08-26	2018-08-26 00:00:00	2018-09-02	2018-09-02 00:00:00	32020		\N	43298	0	10509002	260139		0
11275	665	40481087	2000-04-25	2000-04-25 00:00:00	2000-05-02	2000-05-02 00:00:00	32020		\N	43981	0	444814009	40481087		0
11393	673	4051466	1964-09-28	1964-09-28 00:00:00	1981-01-09	1981-01-09 00:00:00	32020		\N	44480	0	233678006	4051466		0
22104	1321	40481087	1974-01-06	1974-01-06 00:00:00	1974-01-27	1974-01-27 00:00:00	32020		\N	87652	0	444814009	40481087		0
11740	693	4296204	1962-02-22	1962-02-22 00:00:00	1962-03-08	1962-03-08 00:00:00	32020		\N	45889	0	403190006	4296204		0
11913	704	30753	2000-08-21	2000-08-21 00:00:00	\N	\N	32020		\N	46643	0	16761005	30753		0
12062	712	40481087	2010-03-17	2010-03-17 00:00:00	2010-04-07	2010-04-07 00:00:00	32020		\N	47225	0	444814009	40481087		0
22747	1358	4237458	2010-08-17	2010-08-17 00:00:00	2010-10-16	2010-10-16 00:00:00	32020		\N	90112	0	58150001	4237458		0
12361	730	40481087	1997-01-18	1997-01-18 00:00:00	1997-02-01	1997-02-01 00:00:00	32020		\N	48480	0	444814009	40481087		0
12550	742	4112343	1968-10-31	1968-10-31 00:00:00	1968-11-08	1968-11-08 00:00:00	32020		\N	49217	0	195662009	4112343		0
12752	754	4112343	1969-04-02	1969-04-02 00:00:00	1969-04-14	1969-04-14 00:00:00	32020		\N	49980	0	195662009	4112343		0
12923	759	372328	1946-07-27	1946-07-27 00:00:00	1946-12-11	1946-12-11 00:00:00	32020		\N	50430	0	65363002	372328		0
13099	771	28060	1975-05-28	1975-05-28 00:00:00	1975-06-06	1975-06-06 00:00:00	32020		\N	51241	0	43878008	28060		0
13237	778	78272	1980-12-04	1980-12-04 00:00:00	1981-01-01	1981-01-01 00:00:00	32020		\N	51671	0	70704007	78272		0
13373	787	28060	1988-06-14	1988-06-14 00:00:00	1988-06-26	1988-06-26 00:00:00	32020		\N	52348	0	43878008	28060		0
24129	1439	40481087	1996-10-25	1996-10-25 00:00:00	1996-11-08	1996-11-08 00:00:00	32020		\N	95898	0	444814009	40481087		0
13771	814	40481087	1988-06-16	1988-06-16 00:00:00	1988-07-07	1988-07-07 00:00:00	32020		\N	53954	0	444814009	40481087		0
13871	820	28060	1999-06-09	1999-06-09 00:00:00	1999-06-18	1999-06-18 00:00:00	32020		\N	54352	0	43878008	28060		0
14025	828	4237458	1965-06-14	1965-06-14 00:00:00	1965-09-12	1965-09-12 00:00:00	32020		\N	54862	0	58150001	4237458		0
24738	1476	4109685	1955-02-19	1955-02-19 00:00:00	1955-03-12	1955-03-12 00:00:00	32020		\N	98491	0	284551006	4109685		0
14381	850	80180	1990-01-23	1990-01-23 00:00:00	\N	\N	32020		\N	56259	0	396275006	80180		0
14570	862	28060	1980-10-14	1980-10-14 00:00:00	1980-10-23	1980-10-23 00:00:00	32020		\N	57086	0	43878008	28060		0
14709	867	378001	1993-04-28	1993-04-28 00:00:00	1993-05-28	1993-05-28 00:00:00	32020		\N	57581	0	62106007	378001		0
25405	1513	260139	1968-07-26	1968-07-26 00:00:00	1968-08-09	1968-08-09 00:00:00	32020		\N	101114	0	10509002	260139		0
15073	887	4294548	2008-12-31	2008-12-31 00:00:00	2009-02-11	2009-02-11 00:00:00	32020		\N	59139	0	75498004	4294548		0
25739	1529	4294548	1991-09-18	1991-09-18 00:00:00	1991-10-09	1991-10-09 00:00:00	32020		\N	102358	0	75498004	4294548		0
15434	915	4112343	2006-01-27	2006-01-27 00:00:00	2006-02-09	2006-02-09 00:00:00	32020		\N	60827	0	195662009	4112343		0
15537	919	40481087	1994-05-21	1994-05-21 00:00:00	1994-06-11	1994-06-11 00:00:00	32020		\N	61240	0	444814009	40481087		0
15747	931	28060	1965-11-20	1965-11-20 00:00:00	1965-11-30	1965-11-30 00:00:00	32020		\N	61967	0	43878008	28060		0
15853	938	4112343	1990-06-01	1990-06-01 00:00:00	1990-06-13	1990-06-13 00:00:00	32020		\N	62320	0	195662009	4112343		0
16068	950	40481087	2000-09-05	2000-09-05 00:00:00	2000-09-19	2000-09-19 00:00:00	32020		\N	63087	0	444814009	40481087		0
16236	959	4134304	1970-05-13	1970-05-13 00:00:00	1970-07-12	1970-07-12 00:00:00	32020		\N	63783	0	263102004	4134304		0
31103	1843	80180	2016-10-29	2016-10-29 00:00:00	\N	\N	32020		\N	123098	0	396275006	80180		0
16377	969	78272	1998-11-02	1998-11-02 00:00:00	1998-11-30	1998-11-30 00:00:00	32020		\N	64471	0	70704007	78272		0
16511	974	4166224	1993-06-16	1993-06-16 00:00:00	\N	\N	32020		\N	64966	0	47693006	4166224		0
16750	992	4283893	1957-09-14	1957-09-14 00:00:00	1957-11-09	1957-11-09 00:00:00	32020		\N	65768	0	36971009	4283893		0
16918	1005	40479768	1989-02-25	1989-02-25 00:00:00	1989-05-03	1989-05-03 00:00:00	32020		\N	66473	0	444470001	40479768		0
17050	1018	260139	1987-04-18	1987-04-18 00:00:00	1987-05-02	1987-05-02 00:00:00	32020		\N	67030	0	10509002	260139		0
27746	1636	4059173	2012-01-15	2012-01-15 00:00:00	2012-02-14	2012-02-14 00:00:00	32020		\N	109884	0	16114001	4059173		0
27938	1649	40481087	1989-04-28	1989-04-28 00:00:00	1989-05-05	1989-05-05 00:00:00	32020		\N	110632	0	444814009	40481087		0
17547	1054	4109685	1956-02-14	1956-02-14 00:00:00	1956-02-28	1956-02-28 00:00:00	32020		\N	69131	0	284551006	4109685		0
17749	1068	78272	2006-10-05	2006-10-05 00:00:00	2006-11-02	2006-11-02 00:00:00	32020		\N	69962	0	70704007	78272		0
28399	1679	80180	2009-06-12	2009-06-12 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
18030	1083	260139	1987-10-28	1987-10-28 00:00:00	1987-11-04	1987-11-04 00:00:00	32020		\N	71088	0	10509002	260139		0
18239	1097	4296204	1976-06-18	1976-06-18 00:00:00	1976-07-02	1976-07-02 00:00:00	32020		\N	72012	0	403190006	4296204		0
18327	1101	440448	1985-08-17	1985-08-17 00:00:00	\N	\N	32020		\N	72327	0	74400008	440448		0
18546	1115	260139	2010-10-11	2010-10-11 00:00:00	2010-10-18	2010-10-18 00:00:00	32020		\N	73488	0	10509002	260139		0
18699	1124	260139	1991-05-11	1991-05-11 00:00:00	1991-05-25	1991-05-25 00:00:00	32020		\N	74047	0	10509002	260139		0
18878	1135	80180	1999-06-05	1999-06-05 00:00:00	\N	\N	32020		\N	74783	0	396275006	80180		0
19046	1144	80180	2014-09-14	2014-09-14 00:00:00	\N	\N	32020		\N	75484	0	396275006	80180		0
19192	1150	40481087	1992-09-20	1992-09-20 00:00:00	1992-10-11	1992-10-11 00:00:00	32020		\N	76000	0	444814009	40481087		0
19393	1162	372328	1924-09-05	1924-09-05 00:00:00	1925-07-18	1925-07-18 00:00:00	32020		\N	76755	0	65363002	372328		0
30086	1779	40481087	1978-02-08	1978-02-08 00:00:00	1978-03-01	1978-03-01 00:00:00	32020		\N	119075	0	444814009	40481087		0
19741	1185	381316	1981-02-22	1981-02-22 00:00:00	\N	\N	32020		\N	78104	0	230690007	381316		0
30416	1793	28060	1967-06-13	1967-06-13 00:00:00	1967-06-21	1967-06-21 00:00:00	32020		\N	120240	0	43878008	28060		0
20051	1208	372328	1941-03-20	1941-03-20 00:00:00	1941-06-03	1941-06-03 00:00:00	32020		\N	79337	0	65363002	372328		0
20232	1217	260139	2006-12-13	2006-12-13 00:00:00	2006-12-27	2006-12-27 00:00:00	32020		\N	80167	0	10509002	260139		0
20341	1223	4285898	1989-08-21	1989-08-21 00:00:00	\N	\N	32020		\N	80490	0	68496003	4285898		0
20564	1236	4237458	2012-01-06	2012-01-06 00:00:00	2012-03-06	2012-03-06 00:00:00	32020		\N	81490	0	58150001	4237458		0
20731	1245	40481087	1990-11-29	1990-11-29 00:00:00	1990-12-13	1990-12-13 00:00:00	32020		\N	81942	0	444814009	40481087		0
20872	1253	260139	2010-09-20	2010-09-20 00:00:00	2010-09-27	2010-09-27 00:00:00	32020		\N	82494	0	10509002	260139		0
20999	1259	4266809	1981-10-07	1981-10-07 00:00:00	\N	\N	32020		\N	82976	0	397881000	4266809		0
31716	1879	40481087	1965-10-02	1965-10-02 00:00:00	1965-10-23	1965-10-23 00:00:00	32020		\N	125370	0	444814009	40481087		0
10767	639	4149245	2007-04-20	2007-04-20 00:00:00	2007-05-27	2007-05-27 00:00:00	32020		\N	42244	0	30832001	4149245		0
10948	648	260139	1936-10-27	1936-10-27 00:00:00	1936-11-10	1936-11-10 00:00:00	32020		\N	42946	0	10509002	260139		0
11092	654	4112343	2017-06-05	2017-06-05 00:00:00	2017-06-17	2017-06-17 00:00:00	32020		\N	43297	0	195662009	4112343		0
11276	665	40481087	2013-06-02	2013-06-02 00:00:00	2013-06-23	2013-06-23 00:00:00	32020		\N	43995	0	444814009	40481087		0
11394	673	260139	1973-11-20	1973-11-20 00:00:00	1973-11-27	1973-11-27 00:00:00	32020		\N	44462	0	10509002	260139		0
22105	1321	4112343	1973-12-28	1973-12-28 00:00:00	1974-01-04	1974-01-04 00:00:00	32020		\N	87651	0	195662009	4112343		0
11741	693	378001	1951-11-28	1951-11-28 00:00:00	1952-01-27	1952-01-27 00:00:00	32020		\N	45886	0	62106007	378001		0
11914	704	4218389	1999-06-23	1999-06-23 00:00:00	1999-07-21	1999-07-21 00:00:00	32020		\N	46643	0	39848009	4218389		0
12063	712	40481087	1991-02-27	1991-02-27 00:00:00	1991-03-20	1991-03-20 00:00:00	32020		\N	47246	0	444814009	40481087		0
22748	1358	4113008	1965-02-20	1965-02-20 00:00:00	1965-03-06	1965-03-06 00:00:00	32020		\N	90037	0	284549007	4113008		0
12362	730	372328	1959-09-17	1959-09-17 00:00:00	1960-03-19	1960-03-19 00:00:00	32020		\N	48469	0	65363002	372328		0
12551	742	372328	1930-09-16	1930-09-16 00:00:00	1931-03-02	1931-03-02 00:00:00	32020		\N	49141	0	65363002	372328		0
12753	754	4112343	1961-10-30	1961-10-30 00:00:00	1961-11-08	1961-11-08 00:00:00	32020		\N	49848	0	195662009	4112343		0
12924	759	40481087	1970-07-24	1970-07-24 00:00:00	1970-08-07	1970-08-07 00:00:00	32020		\N	50374	0	444814009	40481087		0
13100	771	40481087	2000-10-12	2000-10-12 00:00:00	2000-11-02	2000-11-02 00:00:00	32020		\N	51233	0	444814009	40481087		0
13280	782	81151	1949-12-14	1949-12-14 00:00:00	1950-01-04	1950-01-04 00:00:00	32020		\N	52017	0	44465007	81151		0
13374	787	81151	1979-07-11	1979-07-11 00:00:00	1979-08-15	1979-08-15 00:00:00	32020		\N	52344	0	44465007	81151		0
24130	1439	40481087	2007-03-07	2007-03-07 00:00:00	2007-03-14	2007-03-14 00:00:00	32020		\N	95922	0	444814009	40481087		0
13772	814	40481087	2003-03-14	2003-03-14 00:00:00	2003-04-04	2003-04-04 00:00:00	32020		\N	53972	0	444814009	40481087		0
13872	820	40481087	1969-03-02	1969-03-02 00:00:00	1969-03-16	1969-03-16 00:00:00	32020		\N	54291	0	444814009	40481087		0
14026	828	260139	2000-01-13	2000-01-13 00:00:00	2000-01-27	2000-01-27 00:00:00	32020		\N	54844	0	10509002	260139		0
24739	1476	40481087	1967-06-19	1967-06-19 00:00:00	1967-06-26	1967-06-26 00:00:00	32020		\N	98439	0	444814009	40481087		0
14382	850	4285898	1989-08-26	1989-08-26 00:00:00	\N	\N	32020		\N	56259	0	68496003	4285898		0
14571	862	40481087	2006-07-28	2006-07-28 00:00:00	2006-08-18	2006-08-18 00:00:00	32020		\N	57090	0	444814009	40481087		0
14710	867	80180	1966-01-05	1966-01-05 00:00:00	\N	\N	32020		\N	57605	0	396275006	80180		0
25406	1513	40481087	2004-03-18	2004-03-18 00:00:00	2004-04-01	2004-04-01 00:00:00	32020		\N	101018	0	444814009	40481087		0
15074	887	378001	1983-03-06	1983-03-06 00:00:00	1983-05-05	1983-05-05 00:00:00	32020		\N	59103	0	62106007	378001		0
25740	1529	4134304	1974-10-02	1974-10-02 00:00:00	1974-12-31	1974-12-31 00:00:00	32020		\N	102354	0	263102004	4134304		0
15435	915	378001	1988-07-26	1988-07-26 00:00:00	1988-09-24	1988-09-24 00:00:00	32020		\N	60785	0	62106007	378001		0
15538	919	40481087	1979-03-28	1979-03-28 00:00:00	1979-04-04	1979-04-04 00:00:00	32020		\N	61261	0	444814009	40481087		0
15748	931	4112343	1995-02-01	1995-02-01 00:00:00	1995-02-14	1995-02-14 00:00:00	32020		\N	61938	0	195662009	4112343		0
15854	938	4230399	1952-05-13	1952-05-13 00:00:00	1952-07-12	1952-07-12 00:00:00	32020		\N	62327	0	359817006	4230399		0
16069	950	4059173	1983-04-16	1983-04-16 00:00:00	1983-06-15	1983-06-15 00:00:00	32020		\N	63096	0	16114001	4059173		0
16259	962	192671	1995-07-09	1995-07-09 00:00:00	\N	\N	32020		\N	64048	0	K92.2	35208414		0
16378	969	4112343	1988-02-02	1988-02-02 00:00:00	1988-02-11	1988-02-11 00:00:00	32020		\N	64461	0	195662009	4112343		0
16512	974	440448	1993-06-16	1993-06-16 00:00:00	\N	\N	32020		\N	64966	0	74400008	440448		0
16763	994	28060	2007-02-06	2007-02-06 00:00:00	2007-02-15	2007-02-15 00:00:00	32020		\N	65892	0	43878008	28060		0
16919	1005	40481087	1979-06-06	1979-06-06 00:00:00	1979-06-13	1979-06-13 00:00:00	32020		\N	66425	0	444814009	40481087		0
17051	1018	372328	1972-02-05	1972-02-05 00:00:00	1972-03-20	1972-03-20 00:00:00	32020		\N	67051	0	65363002	372328		0
27747	1636	28060	1969-05-09	1969-05-09 00:00:00	1969-05-19	1969-05-19 00:00:00	32020		\N	109898	0	43878008	28060		0
27939	1649	4112343	1976-06-03	1976-06-03 00:00:00	1976-06-11	1976-06-11 00:00:00	32020		\N	110648	0	195662009	4112343		0
17548	1054	40481087	1955-02-22	1955-02-22 00:00:00	1955-03-08	1955-03-08 00:00:00	32020		\N	69160	0	444814009	40481087		0
17750	1068	4112343	2000-02-28	2000-02-28 00:00:00	2000-03-12	2000-03-12 00:00:00	32020		\N	69988	0	195662009	4112343		0
28400	1679	4266809	2009-06-12	2009-06-12 00:00:00	\N	\N	32020		\N	\N	0	397881000	4266809		0
18031	1083	4027663	1997-05-11	1997-05-11 00:00:00	\N	\N	32020		\N	71123	0	13200003	4027663		0
18240	1097	40481087	2016-04-21	2016-04-21 00:00:00	2016-05-12	2016-05-12 00:00:00	32020		\N	71970	0	444814009	40481087		0
18328	1102	40481087	1975-04-24	1975-04-24 00:00:00	1975-05-01	1975-05-01 00:00:00	32020		\N	72386	0	444814009	40481087		0
18547	1115	40481087	1988-02-11	1988-02-11 00:00:00	1988-02-25	1988-02-25 00:00:00	32020		\N	73454	0	444814009	40481087		0
18700	1124	260139	1938-06-23	1938-06-23 00:00:00	1938-06-30	1938-06-30 00:00:00	32020		\N	74091	0	10509002	260139		0
18879	1135	4112343	1974-12-17	1974-12-17 00:00:00	1974-12-27	1974-12-27 00:00:00	32020		\N	74739	0	195662009	4112343		0
19047	1144	260139	1987-10-04	1987-10-04 00:00:00	1987-10-11	1987-10-11 00:00:00	32020		\N	75519	0	10509002	260139		0
19193	1150	4218389	2010-09-04	2010-09-04 00:00:00	2010-10-09	2010-10-09 00:00:00	32020		\N	76065	0	39848009	4218389		0
19394	1162	260139	2002-07-15	2002-07-15 00:00:00	2002-07-29	2002-07-29 00:00:00	32020		\N	76754	0	10509002	260139		0
30087	1779	4156265	2002-12-07	2002-12-07 00:00:00	2002-12-21	2002-12-21 00:00:00	32020		\N	119009	0	370247008	4156265		0
19742	1185	4112343	1957-07-12	1957-07-12 00:00:00	1957-07-24	1957-07-24 00:00:00	32020		\N	78179	0	195662009	4112343		0
30417	1793	80502	1988-06-01	1988-06-01 00:00:00	\N	\N	32020		\N	120170	0	64859006	80502		0
20052	1208	4155034	1941-09-16	1941-09-16 00:00:00	1941-10-07	1941-10-07 00:00:00	32020		\N	79375	0	283371005	4155034		0
20233	1217	40481087	1977-09-10	1977-09-10 00:00:00	1977-10-01	1977-10-01 00:00:00	32020		\N	80157	0	444814009	40481087		0
20358	1226	40481087	2006-06-03	2006-06-03 00:00:00	2006-06-17	2006-06-17 00:00:00	32020		\N	80666	0	444814009	40481087		0
20565	1236	40480160	2012-01-06	2012-01-06 00:00:00	2012-03-06	2012-03-06 00:00:00	32020		\N	81490	0	443165006	40480160		0
20732	1245	40481087	1953-05-05	1953-05-05 00:00:00	1953-05-26	1953-05-26 00:00:00	32020		\N	81938	0	444814009	40481087		0
20873	1253	80180	1997-03-13	1997-03-13 00:00:00	\N	\N	32020		\N	82535	0	396275006	80180		0
21000	1259	80180	1981-10-07	1981-10-07 00:00:00	\N	\N	32020		\N	82976	0	396275006	80180		0
31717	1879	4112343	1961-05-23	1961-05-23 00:00:00	1961-06-02	1961-06-02 00:00:00	32020		\N	125433	0	195662009	4112343		0
10768	639	260139	1965-05-01	1965-05-01 00:00:00	1965-05-15	1965-05-15 00:00:00	32020		\N	42310	0	10509002	260139		0
10949	648	4059173	1939-02-13	1939-02-13 00:00:00	1939-05-14	1939-05-14 00:00:00	32020		\N	42960	0	16114001	4059173		0
11093	654	80180	2001-07-26	2001-07-26 00:00:00	\N	\N	32020		\N	43290	0	396275006	80180		0
11277	665	80180	1993-08-10	1993-08-10 00:00:00	\N	\N	32020		\N	43992	0	396275006	80180		0
11395	673	372328	1962-09-17	1962-09-17 00:00:00	1962-11-30	1962-11-30 00:00:00	32020		\N	44469	0	65363002	372328		0
22106	1321	28060	2007-06-22	2007-06-22 00:00:00	2007-06-29	2007-06-29 00:00:00	32020		\N	87641	0	43878008	28060		0
11742	693	4112343	1966-04-01	1966-04-01 00:00:00	1966-04-14	1966-04-14 00:00:00	32020		\N	45963	0	195662009	4112343		0
11915	704	80180	2001-02-17	2001-02-17 00:00:00	\N	\N	32020		\N	46643	0	396275006	80180		0
12064	712	28060	1989-04-05	1989-04-05 00:00:00	1989-04-16	1989-04-16 00:00:00	32020		\N	47231	0	43878008	28060		0
22749	1358	40481087	1965-04-03	1965-04-03 00:00:00	1965-04-24	1965-04-24 00:00:00	32020		\N	90114	0	444814009	40481087		0
12363	730	40481087	1990-06-27	1990-06-27 00:00:00	1990-07-18	1990-07-18 00:00:00	32020		\N	48479	0	444814009	40481087		0
12552	742	40481087	2014-10-10	2014-10-10 00:00:00	\N	\N	32020		\N	49175	0	444814009	40481087		0
12754	754	78272	1945-01-14	1945-01-14 00:00:00	1945-02-18	1945-02-18 00:00:00	32020		\N	49819	0	70704007	78272		0
12925	759	40481087	2006-08-30	2006-08-30 00:00:00	2006-09-06	2006-09-06 00:00:00	32020		\N	50394	0	444814009	40481087		0
13101	771	40481087	1974-01-29	1974-01-29 00:00:00	1974-02-05	1974-02-05 00:00:00	32020		\N	51186	0	444814009	40481087		0
23758	1418	4112343	2012-08-29	2012-08-29 00:00:00	2012-09-05	2012-09-05 00:00:00	32020		\N	94412	0	195662009	4112343		0
13375	787	40481087	1985-08-05	1985-08-05 00:00:00	1985-08-19	1985-08-19 00:00:00	32020		\N	52347	0	444814009	40481087		0
24131	1439	4283893	1998-05-11	1998-05-11 00:00:00	1999-01-11	1999-01-11 00:00:00	32020		\N	95920	0	36971009	4283893		0
13773	814	4283893	2005-08-08	2005-08-08 00:00:00	2005-09-26	2005-09-26 00:00:00	32020		\N	53996	0	36971009	4283893		0
13873	820	4112343	1974-12-26	1974-12-26 00:00:00	1975-01-04	1975-01-04 00:00:00	32020		\N	54287	0	195662009	4112343		0
14027	828	4109685	1999-10-21	1999-10-21 00:00:00	1999-11-04	1999-11-04 00:00:00	32020		\N	54865	0	284551006	4109685		0
24740	1476	257012	1949-09-20	1949-09-20 00:00:00	\N	\N	32020		\N	98426	0	40055000	257012		0
14383	850	372328	1949-03-09	1949-03-09 00:00:00	1949-07-26	1949-07-26 00:00:00	32020		\N	56231	0	65363002	372328		0
14572	862	80180	2004-08-07	2004-08-07 00:00:00	\N	\N	32020		\N	57097	0	396275006	80180		0
14711	867	40481087	1963-05-06	1963-05-06 00:00:00	1963-05-20	1963-05-20 00:00:00	32020		\N	57521	0	444814009	40481087		0
25407	1513	40481087	1984-09-05	1984-09-05 00:00:00	1984-09-19	1984-09-19 00:00:00	32020		\N	101165	0	444814009	40481087		0
15075	887	260139	1982-04-15	1982-04-15 00:00:00	1982-04-22	1982-04-22 00:00:00	32020		\N	59109	0	10509002	260139		0
25741	1529	372328	1966-07-06	1966-07-06 00:00:00	1967-06-12	1967-06-12 00:00:00	32020		\N	102305	0	65363002	372328		0
15436	915	4112343	2012-03-30	2012-03-30 00:00:00	2012-04-10	2012-04-10 00:00:00	32020		\N	60867	0	195662009	4112343		0
15548	921	4094814	1989-01-22	1989-01-22 00:00:00	1989-02-21	1989-02-21 00:00:00	32020		\N	61383	0	262574004	4094814		0
15749	931	4152936	1978-10-13	1978-10-13 00:00:00	1978-10-27	1978-10-27 00:00:00	32020		\N	61961	0	283385000	4152936		0
15855	938	260139	2017-05-22	2017-05-22 00:00:00	2017-06-05	2017-06-05 00:00:00	32020		\N	62382	0	10509002	260139		0
16070	950	81151	1985-05-26	1985-05-26 00:00:00	1985-06-16	1985-06-16 00:00:00	32020		\N	63098	0	44465007	81151		0
16260	962	40481087	1955-03-24	1955-03-24 00:00:00	1955-03-31	1955-03-31 00:00:00	32020		\N	64086	0	444814009	40481087		0
16379	969	4152936	1997-09-24	1997-09-24 00:00:00	1997-10-08	1997-10-08 00:00:00	32020		\N	64470	0	283385000	4152936		0
16513	974	380378	1956-06-24	1956-06-24 00:00:00	\N	\N	32020		\N	64962	0	84757009	380378		0
16764	994	80180	1998-10-30	1998-10-30 00:00:00	\N	\N	32020		\N	65874	0	396275006	80180		0
16920	1005	40481087	1990-09-05	1990-09-05 00:00:00	1990-09-19	1990-09-19 00:00:00	32020		\N	66417	0	444814009	40481087		0
17052	1018	40481087	1997-09-22	1997-09-22 00:00:00	1997-09-29	1997-09-29 00:00:00	32020		\N	67041	0	444814009	40481087		0
27748	1636	81151	1967-05-13	1967-05-13 00:00:00	1967-06-10	1967-06-10 00:00:00	32020		\N	109882	0	44465007	81151		0
27980	1655	40481087	2017-05-15	2017-05-15 00:00:00	2017-05-22	2017-05-22 00:00:00	32020		\N	110998	0	444814009	40481087		0
17549	1054	378419	2007-09-14	2007-09-14 00:00:00	\N	\N	32020		\N	69158	0	26929004	378419		0
17751	1068	440086	1985-09-11	1985-09-11 00:00:00	1991-09-20	1991-09-20 00:00:00	32020		\N	69977	0	192127007	440086		0
28401	1679	4027663	2002-09-22	2002-09-22 00:00:00	\N	\N	32020		\N	112566	0	13200003	4027663		0
18032	1083	40481087	1995-07-03	1995-07-03 00:00:00	1995-07-17	1995-07-17 00:00:00	32020		\N	71123	0	444814009	40481087		0
18241	1097	381316	2016-09-15	2016-09-15 00:00:00	\N	\N	32020		\N	71970	0	230690007	381316		0
18329	1102	4112343	2006-10-14	2006-10-14 00:00:00	2006-10-27	2006-10-27 00:00:00	32020		\N	72434	0	195662009	4112343		0
18548	1116	81151	1969-10-20	1969-10-20 00:00:00	1969-11-24	1969-11-24 00:00:00	32020		\N	73540	0	44465007	81151		0
18701	1124	40481087	2013-06-29	2013-06-29 00:00:00	2013-07-06	2013-07-06 00:00:00	32020		\N	74099	0	444814009	40481087		0
18880	1135	4283893	1973-01-17	1973-01-17 00:00:00	1973-06-06	1973-06-06 00:00:00	32020		\N	74771	0	36971009	4283893		0
19048	1144	372328	1971-03-04	1971-03-04 00:00:00	1971-05-16	1971-05-16 00:00:00	32020		\N	75503	0	65363002	372328		0
19194	1150	260139	1951-12-04	1951-12-04 00:00:00	1951-12-18	1951-12-18 00:00:00	32020		\N	75999	0	10509002	260139		0
19395	1162	4059173	1952-10-08	1952-10-08 00:00:00	1952-11-07	1952-11-07 00:00:00	32020		\N	76729	0	16114001	4059173		0
30088	1779	4112343	1997-10-06	1997-10-06 00:00:00	1997-10-14	1997-10-14 00:00:00	32020		\N	118999	0	195662009	4112343		0
19743	1185	260139	1946-04-13	1946-04-13 00:00:00	1946-04-27	1946-04-27 00:00:00	32020		\N	78087	0	10509002	260139		0
30418	1793	260139	1982-04-20	1982-04-20 00:00:00	1982-05-04	1982-05-04 00:00:00	32020		\N	120214	0	10509002	260139		0
20053	1208	40481087	1961-09-20	1961-09-20 00:00:00	1961-09-27	1961-09-27 00:00:00	32020		\N	79330	0	444814009	40481087		0
20234	1217	261325	1994-09-23	1994-09-23 00:00:00	\N	\N	32020		\N	80180	0	87433001	261325		0
20359	1226	78272	2014-09-05	2014-09-05 00:00:00	2014-09-26	2014-09-26 00:00:00	32020		\N	80696	0	70704007	78272		0
20566	1236	40481087	1989-09-16	1989-09-16 00:00:00	1989-09-23	1989-09-23 00:00:00	32020		\N	81364	0	444814009	40481087		0
20733	1245	4166224	1985-08-27	1985-08-27 00:00:00	\N	\N	32020		\N	81901	0	47693006	4166224		0
20874	1253	40481087	2000-06-16	2000-06-16 00:00:00	2000-07-07	2000-07-07 00:00:00	32020		\N	82510	0	444814009	40481087		0
21001	1259	260139	1994-02-27	1994-02-27 00:00:00	1994-03-13	1994-03-13 00:00:00	32020		\N	82983	0	10509002	260139		0
31718	1879	4218389	1983-02-23	1983-02-23 00:00:00	1983-03-23	1983-03-23 00:00:00	32020		\N	125368	0	39848009	4218389		0
10769	639	372328	1955-07-07	1955-07-07 00:00:00	1955-12-10	1955-12-10 00:00:00	32020		\N	42313	0	65363002	372328		0
10950	648	260139	1937-02-19	1937-02-19 00:00:00	1937-03-05	1937-03-05 00:00:00	32020		\N	42947	0	10509002	260139		0
11094	654	372328	1964-02-06	1964-02-06 00:00:00	1964-07-24	1964-07-24 00:00:00	32020		\N	43323	0	65363002	372328		0
11278	665	4112343	1964-07-26	1964-07-26 00:00:00	1964-08-04	1964-08-04 00:00:00	32020		\N	43952	0	195662009	4112343		0
11396	673	81151	1998-03-20	1998-03-20 00:00:00	1998-04-03	1998-04-03 00:00:00	32020		\N	44438	0	44465007	81151		0
22107	1321	4027663	1990-06-24	1990-06-24 00:00:00	\N	\N	32020		\N	87671	0	13200003	4027663		0
11743	693	40479768	1999-09-04	1999-09-04 00:00:00	1999-10-11	1999-10-11 00:00:00	32020		\N	45894	0	444470001	40479768		0
11916	704	40481087	2008-03-25	2008-03-25 00:00:00	2008-04-01	2008-04-01 00:00:00	32020		\N	46548	0	444814009	40481087		0
12065	712	372328	1977-01-25	1977-01-25 00:00:00	1977-04-14	1977-04-14 00:00:00	32020		\N	47227	0	65363002	372328		0
22750	1358	40481087	1973-03-12	1973-03-12 00:00:00	1973-04-02	1973-04-02 00:00:00	32020		\N	90070	0	444814009	40481087		0
12364	730	81151	1959-05-03	1959-05-03 00:00:00	1959-06-07	1959-06-07 00:00:00	32020		\N	48500	0	44465007	81151		0
12553	742	4112343	1989-03-23	1989-03-23 00:00:00	1989-03-31	1989-03-31 00:00:00	32020		\N	49219	0	195662009	4112343		0
12755	754	4059173	2008-04-09	2008-04-09 00:00:00	2008-05-09	2008-05-09 00:00:00	32020		\N	49825	0	16114001	4059173		0
12926	760	260139	1992-12-08	1992-12-08 00:00:00	1992-12-22	1992-12-22 00:00:00	32020		\N	50496	0	10509002	260139		0
13102	771	80180	1998-05-19	1998-05-19 00:00:00	\N	\N	32020		\N	51219	0	396275006	80180		0
23759	1418	40481087	1988-08-26	1988-08-26 00:00:00	1988-09-16	1988-09-16 00:00:00	32020		\N	94447	0	444814009	40481087		0
13376	787	192671	2017-04-02	2017-04-02 00:00:00	\N	\N	32020		\N	52374	0	K92.2	35208414		0
24132	1439	80180	2018-12-26	2018-12-26 00:00:00	\N	\N	32020		\N	95886	0	396275006	80180		0
13774	814	40481087	1982-06-08	1982-06-08 00:00:00	1982-06-22	1982-06-22 00:00:00	32020		\N	53993	0	444814009	40481087		0
13874	820	40481087	1976-03-18	1976-03-18 00:00:00	1976-04-08	1976-04-08 00:00:00	32020		\N	54293	0	444814009	40481087		0
14028	828	378001	1982-03-24	1982-03-24 00:00:00	1982-04-23	1982-04-23 00:00:00	32020		\N	54864	0	62106007	378001		0
24741	1476	40481087	1953-09-05	1953-09-05 00:00:00	1953-09-12	1953-09-12 00:00:00	32020		\N	98437	0	444814009	40481087		0
14384	850	4283893	2009-05-13	2009-05-13 00:00:00	2009-06-17	2009-06-17 00:00:00	32020		\N	56240	0	36971009	4283893		0
14573	862	257012	1990-09-09	1990-09-09 00:00:00	1990-11-18	1990-11-18 00:00:00	32020		\N	57063	0	40055000	257012		0
14712	867	381316	2016-07-05	2016-07-05 00:00:00	\N	\N	32020		\N	57590	0	230690007	381316		0
25408	1513	40481087	1975-02-06	1975-02-06 00:00:00	1975-02-20	1975-02-20 00:00:00	32020		\N	101113	0	444814009	40481087		0
15076	887	28060	2019-06-24	2019-06-24 00:00:00	\N	\N	32020		\N	59145	0	43878008	28060		0
25742	1529	260139	2010-04-19	2010-04-19 00:00:00	2010-05-03	2010-05-03 00:00:00	32020		\N	102321	0	10509002	260139		0
15437	915	260139	2010-01-27	2010-01-27 00:00:00	2010-02-10	2010-02-10 00:00:00	32020		\N	60866	0	10509002	260139		0
15549	921	40481087	1977-06-11	1977-06-11 00:00:00	1977-06-25	1977-06-25 00:00:00	32020		\N	61319	0	444814009	40481087		0
15750	931	257012	1988-10-17	1988-10-17 00:00:00	\N	\N	32020		\N	61970	0	40055000	257012		0
15856	938	4116491	1974-07-12	1974-07-12 00:00:00	1974-09-03	1974-09-03 00:00:00	32020		\N	62410	0	301011002	4116491		0
16071	950	40481087	1985-11-01	1985-11-01 00:00:00	1985-11-15	1985-11-15 00:00:00	32020		\N	63066	0	444814009	40481087		0
16261	962	81151	1957-06-06	1957-06-06 00:00:00	1957-06-27	1957-06-27 00:00:00	32020		\N	64024	0	44465007	81151		0
16380	969	4146173	2004-07-31	2004-07-31 00:00:00	2004-10-06	2004-10-06 00:00:00	32020		\N	64448	0	307731004	4146173		0
16514	974	4029498	1956-06-24	1956-06-24 00:00:00	\N	\N	32020		\N	64962	0	128613002	4029498		0
16765	994	4112343	1961-07-12	1961-07-12 00:00:00	1961-07-21	1961-07-21 00:00:00	32020		\N	65906	0	195662009	4112343		0
16921	1005	375671	2016-05-11	2016-05-11 00:00:00	2016-07-10	2016-07-10 00:00:00	32020		\N	66475	0	62564004	375671		0
17053	1018	4218389	2014-12-12	2014-12-12 00:00:00	2015-01-09	2015-01-09 00:00:00	32020		\N	67012	0	39848009	4218389		0
27749	1636	4278672	2016-04-23	2016-04-23 00:00:00	2016-06-22	2016-06-22 00:00:00	32020		\N	109885	0	65966004	4278672		0
27981	1655	4112343	1981-08-03	1981-08-03 00:00:00	1981-08-14	1981-08-14 00:00:00	32020		\N	111006	0	195662009	4112343		0
17550	1054	4027663	1963-12-09	1963-12-09 00:00:00	\N	\N	32020		\N	69063	0	13200003	4027663		0
17752	1068	4112343	1978-07-22	1978-07-22 00:00:00	1978-08-04	1978-08-04 00:00:00	32020		\N	69973	0	195662009	4112343		0
28402	1679	28060	2001-11-09	2001-11-09 00:00:00	2001-11-22	2001-11-22 00:00:00	32020		\N	112566	0	43878008	28060		0
18033	1084	40481087	1986-06-02	1986-06-02 00:00:00	1986-06-09	1986-06-09 00:00:00	32020		\N	71232	0	444814009	40481087		0
18242	1097	4112343	1986-06-23	1986-06-23 00:00:00	1986-07-01	1986-07-01 00:00:00	32020		\N	72006	0	195662009	4112343		0
18330	1102	372328	1983-11-26	1983-11-26 00:00:00	1984-01-03	1984-01-03 00:00:00	32020		\N	72485	0	65363002	372328		0
18549	1116	372328	1967-02-03	1967-02-03 00:00:00	1967-02-17	1967-02-17 00:00:00	32020		\N	73551	0	65363002	372328		0
18702	1124	80180	1968-10-12	1968-10-12 00:00:00	\N	\N	32020		\N	74045	0	396275006	80180		0
18881	1135	40481087	1983-12-07	1983-12-07 00:00:00	1983-12-14	1983-12-14 00:00:00	32020		\N	74746	0	444814009	40481087		0
19049	1144	4112343	2016-06-12	2016-06-12 00:00:00	2016-06-23	2016-06-23 00:00:00	32020		\N	75502	0	195662009	4112343		0
19195	1150	81151	2008-08-17	2008-08-17 00:00:00	2008-09-14	2008-09-14 00:00:00	32020		\N	76064	0	44465007	81151		0
19396	1162	260139	1942-02-15	1942-02-15 00:00:00	1942-02-22	1942-02-22 00:00:00	32020		\N	76674	0	10509002	260139		0
30089	1779	260139	1956-03-31	1956-03-31 00:00:00	1956-04-07	1956-04-07 00:00:00	32020		\N	119043	0	10509002	260139		0
19744	1185	40481087	1952-04-09	1952-04-09 00:00:00	1952-04-23	1952-04-23 00:00:00	32020		\N	78088	0	444814009	40481087		0
30419	1793	4112343	1999-07-18	1999-07-18 00:00:00	1999-07-30	1999-07-30 00:00:00	32020		\N	120267	0	195662009	4112343		0
20054	1209	372328	1995-06-17	1995-06-17 00:00:00	1996-06-20	1996-06-20 00:00:00	32020		\N	79437	0	65363002	372328		0
20235	1217	4112343	1973-06-12	1973-06-12 00:00:00	1973-06-25	1973-06-25 00:00:00	32020		\N	80153	0	195662009	4112343		0
20360	1226	440086	1990-04-04	1990-04-04 00:00:00	1991-06-26	1991-06-26 00:00:00	32020		\N	80686	0	192127007	440086		0
20567	1236	4294548	1993-04-14	1993-04-14 00:00:00	1993-04-21	1993-04-21 00:00:00	32020		\N	81465	0	75498004	4294548		0
20734	1245	440448	1985-08-27	1985-08-27 00:00:00	\N	\N	32020		\N	81901	0	74400008	440448		0
20875	1253	4112343	1977-05-14	1977-05-14 00:00:00	1977-05-22	1977-05-22 00:00:00	32020		\N	82506	0	195662009	4112343		0
21002	1259	4112343	1957-12-17	1957-12-17 00:00:00	1957-12-27	1957-12-27 00:00:00	32020		\N	82981	0	195662009	4112343		0
31719	1879	28060	1967-10-31	1967-10-31 00:00:00	1967-11-13	1967-11-13 00:00:00	32020		\N	125434	0	43878008	28060		0
10770	639	40481087	1976-01-06	1976-01-06 00:00:00	1976-01-20	1976-01-20 00:00:00	32020		\N	42300	0	444814009	40481087		0
10951	648	4278672	1954-10-22	1954-10-22 00:00:00	1954-11-21	1954-11-21 00:00:00	32020		\N	42961	0	65966004	4278672		0
11095	654	40481087	1981-03-16	1981-03-16 00:00:00	1981-03-23	1981-03-23 00:00:00	32020		\N	43294	0	444814009	40481087		0
21747	1306	260139	1983-05-16	1983-05-16 00:00:00	1983-05-30	1983-05-30 00:00:00	32020		\N	86191	0	10509002	260139		0
11397	673	4296205	1983-03-20	1983-03-20 00:00:00	1983-04-10	1983-04-10 00:00:00	32020		\N	44434	0	403191005	4296205		0
22108	1321	40481087	1960-05-04	1960-05-04 00:00:00	1960-05-11	1960-05-11 00:00:00	32020		\N	87658	0	444814009	40481087		0
11744	693	40481087	2007-06-11	2007-06-11 00:00:00	2007-06-18	2007-06-18 00:00:00	32020		\N	45967	0	444814009	40481087		0
11917	704	372328	1968-02-26	1968-02-26 00:00:00	1968-08-28	1968-08-28 00:00:00	32020		\N	46632	0	65363002	372328		0
12066	712	4237458	2003-08-07	2003-08-07 00:00:00	2003-10-06	2003-10-06 00:00:00	32020		\N	47267	0	58150001	4237458		0
22751	1358	4134304	1976-04-07	1976-04-07 00:00:00	1976-05-07	1976-05-07 00:00:00	32020		\N	90108	0	263102004	4134304		0
12365	730	4112343	2017-12-03	2017-12-03 00:00:00	2017-12-11	2017-12-11 00:00:00	32020		\N	48467	0	195662009	4112343		0
12554	742	40481087	1961-10-08	1961-10-08 00:00:00	1961-10-22	1961-10-22 00:00:00	32020		\N	49216	0	444814009	40481087		0
12756	754	4278672	1952-07-11	1952-07-11 00:00:00	1952-08-10	1952-08-10 00:00:00	32020		\N	49821	0	65966004	4278672		0
12927	760	4112343	2017-06-28	2017-06-28 00:00:00	2017-07-07	2017-07-07 00:00:00	32020		\N	50466	0	195662009	4112343		0
13103	771	40481087	1990-12-04	1990-12-04 00:00:00	1990-12-25	1990-12-25 00:00:00	32020		\N	51207	0	444814009	40481087		0
23760	1418	81151	1973-09-22	1973-09-22 00:00:00	1973-10-13	1973-10-13 00:00:00	32020		\N	94420	0	44465007	81151		0
13377	787	4112343	1978-09-26	1978-09-26 00:00:00	1978-10-04	1978-10-04 00:00:00	32020		\N	52361	0	195662009	4112343		0
24133	1439	372328	1979-09-16	1979-09-16 00:00:00	1979-12-22	1979-12-22 00:00:00	32020		\N	95881	0	65363002	372328		0
13775	814	4112343	1993-05-29	1993-05-29 00:00:00	1993-06-05	1993-06-05 00:00:00	32020		\N	53994	0	195662009	4112343		0
13875	820	40481087	1981-03-19	1981-03-19 00:00:00	1981-04-09	1981-04-09 00:00:00	32020		\N	54326	0	444814009	40481087		0
14029	828	40481087	1968-01-18	1968-01-18 00:00:00	1968-02-01	1968-02-01 00:00:00	32020		\N	54838	0	444814009	40481087		0
24742	1476	40481087	1958-02-24	1958-02-24 00:00:00	1958-03-10	1958-03-10 00:00:00	32020		\N	98364	0	444814009	40481087		0
14385	850	4112343	2018-03-05	2018-03-05 00:00:00	2018-03-12	2018-03-12 00:00:00	32020		\N	56230	0	195662009	4112343		0
14574	862	28060	1972-05-23	1972-05-23 00:00:00	1972-06-02	1972-06-02 00:00:00	32020		\N	57100	0	43878008	28060		0
14713	867	260139	1986-05-07	1986-05-07 00:00:00	1986-05-21	1986-05-21 00:00:00	32020		\N	57517	0	10509002	260139		0
25409	1513	4112343	1993-02-21	1993-02-21 00:00:00	1993-03-02	1993-03-02 00:00:00	32020		\N	101080	0	195662009	4112343		0
15077	887	4059173	1989-11-29	1989-11-29 00:00:00	1990-02-27	1990-02-27 00:00:00	32020		\N	59104	0	16114001	4059173		0
25743	1529	372328	1963-02-27	1963-02-27 00:00:00	1963-06-10	1963-06-10 00:00:00	32020		\N	102325	0	65363002	372328		0
15438	915	192671	1995-09-17	1995-09-17 00:00:00	\N	\N	32020		\N	60789	0	K92.2	35208414		0
15550	921	378001	2002-10-02	2002-10-02 00:00:00	2002-12-01	2002-12-01 00:00:00	32020		\N	61385	0	62106007	378001		0
15751	931	260139	2009-07-26	2009-07-26 00:00:00	2009-08-09	2009-08-09 00:00:00	32020		\N	61947	0	10509002	260139		0
15857	938	260139	1990-08-10	1990-08-10 00:00:00	1990-08-24	1990-08-24 00:00:00	32020		\N	62351	0	10509002	260139		0
16072	950	4155034	1984-07-09	1984-07-09 00:00:00	1984-07-30	1984-07-30 00:00:00	32020		\N	63097	0	283371005	4155034		0
16262	962	4294548	1961-10-30	1961-10-30 00:00:00	1962-01-15	1962-01-15 00:00:00	32020		\N	64079	0	75498004	4294548		0
16381	969	40481087	1981-06-27	1981-06-27 00:00:00	1981-07-04	1981-07-04 00:00:00	32020		\N	64417	0	444814009	40481087		0
16516	974	4112343	1998-10-03	1998-10-03 00:00:00	1998-10-13	1998-10-13 00:00:00	32020		\N	64994	0	195662009	4112343		0
16766	994	40481087	1965-11-26	1965-11-26 00:00:00	1965-12-03	1965-12-03 00:00:00	32020		\N	65890	0	444814009	40481087		0
16922	1005	378001	2011-01-08	2011-01-08 00:00:00	2011-02-07	2011-02-07 00:00:00	32020		\N	66474	0	62106007	378001		0
17054	1018	4142905	1972-11-01	1972-11-01 00:00:00	1972-12-01	1972-12-01 00:00:00	32020		\N	67009	0	33737001	4142905		0
27750	1636	260139	1975-07-20	1975-07-20 00:00:00	1975-07-27	1975-07-27 00:00:00	32020		\N	109912	0	10509002	260139		0
27982	1655	28060	1986-04-10	1986-04-10 00:00:00	1986-04-18	1986-04-18 00:00:00	32020		\N	110983	0	43878008	28060		0
17551	1054	40481087	1934-03-20	1934-03-20 00:00:00	1934-04-10	1934-04-10 00:00:00	32020		\N	69143	0	444814009	40481087		0
17753	1068	192671	2015-02-20	2015-02-20 00:00:00	\N	\N	32020		\N	69975	0	K92.2	35208414		0
28403	1679	40481087	2004-06-27	2004-06-27 00:00:00	2004-07-11	2004-07-11 00:00:00	32020		\N	112567	0	444814009	40481087		0
18034	1084	4112343	1979-08-30	1979-08-30 00:00:00	1979-09-09	1979-09-09 00:00:00	32020		\N	71237	0	195662009	4112343		0
18243	1097	4112343	1969-09-25	1969-09-25 00:00:00	1969-10-06	1969-10-06 00:00:00	32020		\N	72014	0	195662009	4112343		0
18331	1102	4283893	1974-08-23	1974-08-23 00:00:00	1974-09-20	1974-09-20 00:00:00	32020		\N	72366	0	36971009	4283893		0
18550	1116	260139	1997-09-25	1997-09-25 00:00:00	1997-10-02	1997-10-02 00:00:00	32020		\N	73550	0	10509002	260139		0
18703	1125	4027663	1975-09-16	1975-09-16 00:00:00	\N	\N	32020		\N	74169	0	13200003	4027663		0
18882	1135	260139	1992-01-04	1992-01-04 00:00:00	1992-01-18	1992-01-18 00:00:00	32020		\N	74763	0	10509002	260139		0
19050	1144	4035415	2009-05-02	2009-05-02 00:00:00	2009-07-01	2009-07-01 00:00:00	32020		\N	75498	0	239720000	4035415		0
19196	1150	260139	2007-11-30	2007-11-30 00:00:00	2007-12-14	2007-12-14 00:00:00	32020		\N	76040	0	10509002	260139		0
19397	1162	28060	1981-09-24	1981-09-24 00:00:00	1981-10-01	1981-10-01 00:00:00	32020		\N	76700	0	43878008	28060		0
30090	1779	30753	1976-02-11	1976-02-11 00:00:00	\N	\N	32020		\N	118997	0	16761005	30753		0
19745	1185	80502	1997-01-05	1997-01-05 00:00:00	\N	\N	32020		\N	78100	0	64859006	80502		0
30420	1793	40481087	2003-12-17	2003-12-17 00:00:00	2004-01-07	2004-01-07 00:00:00	32020		\N	120245	0	444814009	40481087		0
20055	1209	4027663	2002-09-02	2002-09-02 00:00:00	\N	\N	32020		\N	79444	0	13200003	4027663		0
20236	1217	40481087	1995-06-11	1995-06-11 00:00:00	1995-07-02	1995-07-02 00:00:00	32020		\N	80166	0	444814009	40481087		0
20361	1226	40481087	1985-06-16	1985-06-16 00:00:00	1985-06-30	1985-06-30 00:00:00	32020		\N	80691	0	444814009	40481087		0
20568	1236	4112343	2010-12-25	2010-12-25 00:00:00	2011-01-06	2011-01-06 00:00:00	32020		\N	81366	0	195662009	4112343		0
20735	1245	40481087	1995-09-16	1995-09-16 00:00:00	1995-10-07	1995-10-07 00:00:00	32020		\N	81984	0	444814009	40481087		0
20876	1253	40481087	1959-12-12	1959-12-12 00:00:00	1959-12-19	1959-12-19 00:00:00	32020		\N	82492	0	444814009	40481087		0
21003	1259	260139	2016-07-23	2016-07-23 00:00:00	2016-07-30	2016-07-30 00:00:00	32020		\N	82944	0	10509002	260139		0
31720	1879	40481087	1996-03-25	1996-03-25 00:00:00	1996-04-08	1996-04-08 00:00:00	32020		\N	125383	0	444814009	40481087		0
10771	639	260139	1983-02-01	1983-02-01 00:00:00	1983-02-15	1983-02-15 00:00:00	32020		\N	42303	0	10509002	260139		0
10952	648	4112343	1976-05-02	1976-05-02 00:00:00	1976-05-12	1976-05-12 00:00:00	32020		\N	42935	0	195662009	4112343		0
11096	654	40481087	2007-10-16	2007-10-16 00:00:00	2007-11-06	2007-11-06 00:00:00	32020		\N	43322	0	444814009	40481087		0
21748	1306	260139	1970-03-29	1970-03-29 00:00:00	1970-04-05	1970-04-05 00:00:00	32020		\N	86168	0	10509002	260139		0
11398	673	4218389	1967-05-24	1967-05-24 00:00:00	1967-06-28	1967-06-28 00:00:00	32020		\N	44430	0	39848009	4218389		0
22109	1321	260139	1968-01-26	1968-01-26 00:00:00	1968-02-09	1968-02-09 00:00:00	32020		\N	87650	0	10509002	260139		0
11745	693	40481087	1987-02-23	1987-02-23 00:00:00	1987-03-02	1987-03-02 00:00:00	32020		\N	45900	0	444814009	40481087		0
11918	704	40481087	1983-02-17	1983-02-17 00:00:00	1983-03-10	1983-03-10 00:00:00	32020		\N	46516	0	444814009	40481087		0
12067	712	28060	1977-08-25	1977-08-25 00:00:00	1977-09-04	1977-09-04 00:00:00	32020		\N	47242	0	43878008	28060		0
22752	1358	4112343	1978-11-25	1978-11-25 00:00:00	1978-12-05	1978-12-05 00:00:00	32020		\N	90048	0	195662009	4112343		0
12366	730	260139	1966-04-17	1966-04-17 00:00:00	1966-04-24	1966-04-24 00:00:00	32020		\N	48456	0	10509002	260139		0
12555	742	28060	1990-03-29	1990-03-29 00:00:00	1990-04-09	1990-04-09 00:00:00	32020		\N	49220	0	43878008	28060		0
12757	754	40481087	1940-01-18	1940-01-18 00:00:00	1940-01-25	1940-01-25 00:00:00	32020		\N	49978	0	444814009	40481087		0
12928	760	40481087	1970-11-02	1970-11-02 00:00:00	1970-11-09	1970-11-09 00:00:00	32020		\N	50458	0	444814009	40481087		0
13104	771	40481087	1982-06-21	1982-06-21 00:00:00	1982-07-12	1982-07-12 00:00:00	32020		\N	51188	0	444814009	40481087		0
23761	1418	260139	2016-01-18	2016-01-18 00:00:00	2016-01-25	2016-01-25 00:00:00	32020		\N	94415	0	10509002	260139		0
13378	787	378001	1987-01-05	1987-01-05 00:00:00	1987-03-06	1987-03-06 00:00:00	32020		\N	52345	0	62106007	378001		0
24134	1439	40481087	1980-10-05	1980-10-05 00:00:00	1980-10-19	1980-10-19 00:00:00	32020		\N	95897	0	444814009	40481087		0
13776	814	40481087	1994-03-17	1994-03-17 00:00:00	1994-03-24	1994-03-24 00:00:00	32020		\N	53971	0	444814009	40481087		0
13876	820	28060	1969-05-09	1969-05-09 00:00:00	1969-05-22	1969-05-22 00:00:00	32020		\N	54292	0	43878008	28060		0
14030	828	4112343	1979-06-19	1979-06-19 00:00:00	1979-06-28	1979-06-28 00:00:00	32020		\N	54852	0	195662009	4112343		0
24743	1476	4278672	1978-08-22	1978-08-22 00:00:00	1978-10-21	1978-10-21 00:00:00	32020		\N	98367	0	65966004	4278672		0
14386	850	372328	1964-09-05	1964-09-05 00:00:00	1965-04-13	1965-04-13 00:00:00	32020		\N	56193	0	65363002	372328		0
14575	862	260139	1973-09-16	1973-09-16 00:00:00	1973-09-30	1973-09-30 00:00:00	32020		\N	57040	0	10509002	260139		0
14714	867	4237458	2005-04-25	2005-04-25 00:00:00	2005-07-24	2005-07-24 00:00:00	32020		\N	57584	0	58150001	4237458		0
25410	1513	4112343	1970-07-16	1970-07-16 00:00:00	1970-07-26	1970-07-26 00:00:00	32020		\N	101116	0	195662009	4112343		0
15078	887	28060	1971-10-27	1971-10-27 00:00:00	1971-11-05	1971-11-05 00:00:00	32020		\N	59154	0	43878008	28060		0
25744	1529	372328	1968-02-07	1968-02-07 00:00:00	1968-06-17	1968-06-17 00:00:00	32020		\N	102326	0	65363002	372328		0
25897	1537	40481087	1982-10-07	1982-10-07 00:00:00	1982-10-28	1982-10-28 00:00:00	32020		\N	102909	0	444814009	40481087		0
15551	921	4155034	1968-05-11	1968-05-11 00:00:00	1968-05-25	1968-05-25 00:00:00	32020		\N	61341	0	283371005	4155034		0
15752	931	81151	1975-12-30	1975-12-30 00:00:00	1976-01-27	1976-01-27 00:00:00	32020		\N	61960	0	44465007	81151		0
15858	938	4112343	1973-06-05	1973-06-05 00:00:00	1973-06-17	1973-06-17 00:00:00	32020		\N	62347	0	195662009	4112343		0
16073	950	260139	1985-06-05	1985-06-05 00:00:00	1985-06-12	1985-06-12 00:00:00	32020		\N	63128	0	10509002	260139		0
16263	962	4112343	1983-04-18	1983-04-18 00:00:00	1983-04-26	1983-04-26 00:00:00	32020		\N	64083	0	195662009	4112343		0
16382	969	40481087	1986-04-06	1986-04-06 00:00:00	1986-04-27	1986-04-27 00:00:00	32020		\N	64431	0	444814009	40481087		0
16517	974	195588	2001-07-31	2001-07-31 00:00:00	2001-09-10	2001-09-10 00:00:00	32020		\N	64996	0	38822007	195588		0
27236	1608	40481087	1983-05-29	1983-05-29 00:00:00	1983-06-12	1983-06-12 00:00:00	32020		\N	108046	0	444814009	40481087		0
27391	1613	80180	1992-06-19	1992-06-19 00:00:00	\N	\N	32020		\N	108478	0	396275006	80180		0
17055	1018	80180	2012-02-20	2012-02-20 00:00:00	\N	\N	32020		\N	67014	0	396275006	80180		0
27751	1636	4266809	2000-06-13	2000-06-13 00:00:00	\N	\N	32020		\N	109904	0	397881000	4266809		0
27983	1655	4112343	1973-05-25	1973-05-25 00:00:00	1973-06-01	1973-06-01 00:00:00	32020		\N	111021	0	195662009	4112343		0
17552	1054	4112343	2002-11-20	2002-11-20 00:00:00	2002-11-30	2002-11-30 00:00:00	32020		\N	69096	0	195662009	4112343		0
17754	1068	260139	1992-12-13	1992-12-13 00:00:00	1992-12-27	1992-12-27 00:00:00	32020		\N	69945	0	10509002	260139		0
28404	1679	40481087	1978-02-23	1978-02-23 00:00:00	1978-03-16	1978-03-16 00:00:00	32020		\N	112574	0	444814009	40481087		0
18035	1084	260139	2004-06-29	2004-06-29 00:00:00	2004-07-06	2004-07-06 00:00:00	32020		\N	71189	0	10509002	260139		0
18244	1098	4112343	2010-02-26	2010-02-26 00:00:00	2010-03-07	2010-03-07 00:00:00	32020		\N	72037	0	195662009	4112343		0
18332	1102	4112343	2018-03-14	2018-03-14 00:00:00	2018-03-21	2018-03-21 00:00:00	32020		\N	72469	0	195662009	4112343		0
18551	1116	4278672	1996-02-20	1996-02-20 00:00:00	1996-04-20	1996-04-20 00:00:00	32020		\N	73509	0	65966004	4278672		0
18704	1125	40481087	2013-10-19	2013-10-19 00:00:00	2013-11-09	2013-11-09 00:00:00	32020		\N	74191	0	444814009	40481087		0
18883	1135	40481087	1979-05-12	1979-05-12 00:00:00	1979-05-26	1979-05-26 00:00:00	32020		\N	74745	0	444814009	40481087		0
19051	1144	40481087	1981-09-15	1981-09-15 00:00:00	1981-09-22	1981-09-22 00:00:00	32020		\N	75475	0	444814009	40481087		0
19197	1150	260139	1985-11-17	1985-11-17 00:00:00	1985-11-24	1985-11-24 00:00:00	32020		\N	76003	0	10509002	260139		0
19398	1162	4112343	1959-11-08	1959-11-08 00:00:00	1959-11-18	1959-11-18 00:00:00	32020		\N	76698	0	195662009	4112343		0
30091	1779	260139	1978-07-13	1978-07-13 00:00:00	1978-07-27	1978-07-27 00:00:00	32020		\N	118998	0	10509002	260139		0
19746	1185	4112343	2015-01-24	2015-01-24 00:00:00	2015-02-06	2015-02-06 00:00:00	32020		\N	78183	0	195662009	4112343		0
30421	1793	4278672	1919-07-07	1919-07-07 00:00:00	1919-09-05	1919-09-05 00:00:00	32020		\N	120220	0	65966004	4278672		0
20056	1209	4146173	2003-08-23	2003-08-23 00:00:00	2003-10-22	2003-10-22 00:00:00	32020		\N	79432	0	307731004	4146173		0
20237	1217	381316	2018-10-19	2018-10-19 00:00:00	\N	\N	32020		\N	80147	0	230690007	381316		0
20362	1226	40481087	2014-12-11	2014-12-11 00:00:00	2015-01-01	2015-01-01 00:00:00	32020		\N	80700	0	444814009	40481087		0
20569	1236	40481087	1948-12-12	1948-12-12 00:00:00	1948-12-26	1948-12-26 00:00:00	32020		\N	81462	0	444814009	40481087		0
20737	1245	40481087	2012-02-01	2012-02-01 00:00:00	2012-02-08	2012-02-08 00:00:00	32020		\N	81910	0	444814009	40481087		0
20877	1253	372328	1960-11-24	1960-11-24 00:00:00	1961-02-22	1961-02-22 00:00:00	32020		\N	82526	0	65363002	372328		0
21004	1259	28060	1990-10-03	1990-10-03 00:00:00	1990-10-16	1990-10-16 00:00:00	32020		\N	82977	0	43878008	28060		0
31721	1879	40481087	2009-01-09	2009-01-09 00:00:00	2009-01-30	2009-01-30 00:00:00	32020		\N	125416	0	444814009	40481087		0
10772	639	40481087	1953-03-11	1953-03-11 00:00:00	1953-04-01	1953-04-01 00:00:00	32020		\N	42309	0	444814009	40481087		0
10953	648	40481087	1949-06-08	1949-06-08 00:00:00	1949-06-15	1949-06-15 00:00:00	32020		\N	42843	0	444814009	40481087		0
11097	654	40481087	2014-11-07	2014-11-07 00:00:00	2014-11-14	2014-11-14 00:00:00	32020		\N	43296	0	444814009	40481087		0
21749	1306	40481087	1975-06-27	1975-06-27 00:00:00	1975-07-04	1975-07-04 00:00:00	32020		\N	86242	0	444814009	40481087		0
11399	673	372328	1966-06-12	1966-06-12 00:00:00	1966-10-14	1966-10-14 00:00:00	32020		\N	44491	0	65363002	372328		0
22110	1321	260139	2000-10-15	2000-10-15 00:00:00	2000-10-29	2000-10-29 00:00:00	32020		\N	87674	0	10509002	260139		0
11746	693	260139	1975-10-15	1975-10-15 00:00:00	1975-10-23	1975-10-23 00:00:00	32020		\N	45939	0	10509002	260139		0
25644	1524	80180	2004-02-17	2004-02-17 00:00:00	\N	\N	32020		\N	101955	0	396275006	80180		0
11919	704	40481087	1990-08-30	1990-08-30 00:00:00	1990-09-06	1990-09-06 00:00:00	32020		\N	46586	0	444814009	40481087		0
12068	712	80180	2013-07-15	2013-07-15 00:00:00	\N	\N	32020		\N	47256	0	396275006	80180		0
22753	1358	40481087	1966-06-27	1966-06-27 00:00:00	1966-07-11	1966-07-11 00:00:00	32020		\N	90115	0	444814009	40481087		0
12367	730	40481087	1979-06-13	1979-06-13 00:00:00	1979-07-04	1979-07-04 00:00:00	32020		\N	48493	0	444814009	40481087		0
12556	742	378001	1993-02-04	1993-02-04 00:00:00	1993-04-05	1993-04-05 00:00:00	32020		\N	49191	0	62106007	378001		0
12758	754	4109685	1970-01-08	1970-01-08 00:00:00	1970-01-29	1970-01-29 00:00:00	32020		\N	49823	0	284551006	4109685		0
12929	760	81151	1992-09-13	1992-09-13 00:00:00	1992-10-04	1992-10-04 00:00:00	32020		\N	50510	0	44465007	81151		0
13105	771	260139	1965-04-08	1965-04-08 00:00:00	1965-04-15	1965-04-15 00:00:00	32020		\N	51171	0	10509002	260139		0
23762	1418	378001	2003-01-09	2003-01-09 00:00:00	2003-02-08	2003-02-08 00:00:00	32020		\N	94399	0	62106007	378001		0
13379	787	40481087	2012-07-19	2012-07-19 00:00:00	2012-07-26	2012-07-26 00:00:00	32020		\N	52364	0	444814009	40481087		0
24135	1439	260139	2006-08-30	2006-08-30 00:00:00	2006-09-13	2006-09-13 00:00:00	32020		\N	95921	0	10509002	260139		0
13777	814	80180	2019-05-24	2019-05-24 00:00:00	\N	\N	32020		\N	53970	0	396275006	80180		0
13877	820	40481087	2006-12-19	2006-12-19 00:00:00	2007-01-09	2007-01-09 00:00:00	32020		\N	54355	0	444814009	40481087		0
14031	828	40481087	1966-03-29	1966-03-29 00:00:00	1966-04-19	1966-04-19 00:00:00	32020		\N	54814	0	444814009	40481087		0
24744	1476	4112343	2005-09-20	2005-09-20 00:00:00	2005-09-27	2005-09-27 00:00:00	32020		\N	98500	0	195662009	4112343		0
14387	850	4094814	2019-05-13	2019-05-13 00:00:00	\N	\N	32020		\N	56239	0	262574004	4094814		0
14576	862	4230399	1979-09-11	1979-09-11 00:00:00	1979-10-11	1979-10-11 00:00:00	32020		\N	57051	0	359817006	4230399		0
14715	867	260139	1971-05-29	1971-05-29 00:00:00	1971-06-12	1971-06-12 00:00:00	32020		\N	57577	0	10509002	260139		0
25411	1513	40481087	2001-09-03	2001-09-03 00:00:00	2001-09-24	2001-09-24 00:00:00	32020		\N	101106	0	444814009	40481087		0
15079	887	4112343	1996-09-06	1996-09-06 00:00:00	1996-09-19	1996-09-19 00:00:00	32020		\N	59112	0	195662009	4112343		0
25745	1529	4112343	1976-07-31	1976-07-31 00:00:00	1976-08-10	1976-08-10 00:00:00	32020		\N	102361	0	195662009	4112343		0
25898	1537	372328	1994-02-13	1994-02-13 00:00:00	1996-06-19	1996-06-19 00:00:00	32020		\N	102877	0	65363002	372328		0
15552	921	4112343	2009-08-05	2009-08-05 00:00:00	2009-08-16	2009-08-16 00:00:00	32020		\N	61371	0	195662009	4112343		0
15753	931	81151	1974-01-04	1974-01-04 00:00:00	1974-02-08	1974-02-08 00:00:00	32020		\N	61959	0	44465007	81151		0
15859	938	40481087	2017-12-09	2017-12-09 00:00:00	2017-12-16	2017-12-16 00:00:00	32020		\N	62322	0	444814009	40481087		0
16074	950	4294548	2015-10-05	2015-10-05 00:00:00	2015-11-16	2015-11-16 00:00:00	32020		\N	63117	0	75498004	4294548		0
16264	962	4027663	1983-11-02	1983-11-02 00:00:00	\N	\N	32020		\N	64083	0	13200003	4027663		0
16383	969	381316	2014-12-07	2014-12-07 00:00:00	\N	\N	32020		\N	64419	0	230690007	381316		0
16518	974	4112343	1984-08-02	1984-08-02 00:00:00	1984-08-13	1984-08-13 00:00:00	32020		\N	64987	0	195662009	4112343		0
27237	1608	4112343	1967-07-28	1967-07-28 00:00:00	1967-08-04	1967-08-04 00:00:00	32020		\N	107968	0	195662009	4112343		0
27392	1613	4266809	1992-06-19	1992-06-19 00:00:00	\N	\N	32020		\N	108478	0	397881000	4266809		0
17072	1021	378001	2019-05-02	2019-05-02 00:00:00	2019-06-01	2019-06-01 00:00:00	32020		\N	67208	0	62106007	378001		0
27752	1636	80180	2000-06-13	2000-06-13 00:00:00	\N	\N	32020		\N	109904	0	396275006	80180		0
27984	1655	40481087	2002-11-24	2002-11-24 00:00:00	2002-12-15	2002-12-15 00:00:00	32020		\N	110994	0	444814009	40481087		0
17553	1054	4112343	1992-01-03	1992-01-03 00:00:00	1992-01-16	1992-01-16 00:00:00	32020		\N	69141	0	195662009	4112343		0
17755	1068	260139	1987-05-05	1987-05-05 00:00:00	1987-05-12	1987-05-12 00:00:00	32020		\N	69978	0	10509002	260139		0
28405	1679	260139	2019-02-17	2019-02-17 00:00:00	2019-02-24	2019-02-24 00:00:00	32020		\N	112593	0	10509002	260139		0
18036	1084	372328	1979-09-28	1979-09-28 00:00:00	1979-12-14	1979-12-14 00:00:00	32020		\N	71212	0	65363002	372328		0
18245	1098	4152936	2011-10-13	2011-10-13 00:00:00	2011-11-03	2011-11-03 00:00:00	32020		\N	72031	0	283385000	4152936		0
18333	1102	4149245	2003-02-14	2003-02-14 00:00:00	2003-03-23	2003-03-23 00:00:00	32020		\N	72428	0	30832001	4149245		0
18552	1116	40481087	1980-09-12	1980-09-12 00:00:00	1980-09-19	1980-09-19 00:00:00	32020		\N	73510	0	444814009	40481087		0
18705	1125	4278672	2014-07-30	2014-07-30 00:00:00	2014-08-29	2014-08-29 00:00:00	32020		\N	74138	0	65966004	4278672		0
18884	1135	40481087	2006-08-07	2006-08-07 00:00:00	2006-08-14	2006-08-14 00:00:00	32020		\N	74747	0	444814009	40481087		0
19052	1144	260139	1999-06-27	1999-06-27 00:00:00	1999-07-04	1999-07-04 00:00:00	32020		\N	75517	0	10509002	260139		0
19198	1150	40481087	1984-10-04	1984-10-04 00:00:00	1984-10-11	1984-10-11 00:00:00	32020		\N	76038	0	444814009	40481087		0
19399	1162	378419	1999-02-13	1999-02-13 00:00:00	\N	\N	32020		\N	76780	0	26929004	378419		0
30092	1779	372328	1944-10-16	1944-10-16 00:00:00	1944-10-30	1944-10-30 00:00:00	32020		\N	119002	0	65363002	372328		0
19747	1185	372328	1941-10-25	1941-10-25 00:00:00	1942-01-25	1942-01-25 00:00:00	32020		\N	78108	0	65363002	372328		0
30422	1793	81151	1972-03-03	1972-03-03 00:00:00	1972-03-17	1972-03-17 00:00:00	32020		\N	120224	0	44465007	81151		0
20057	1209	4112343	2014-12-31	2014-12-31 00:00:00	2015-01-07	2015-01-07 00:00:00	32020		\N	79434	0	195662009	4112343		0
20238	1217	40481087	2015-07-15	2015-07-15 00:00:00	2015-08-05	2015-08-05 00:00:00	32020		\N	80170	0	444814009	40481087		0
20363	1226	4112343	1986-10-06	1986-10-06 00:00:00	1986-10-18	1986-10-18 00:00:00	32020		\N	80707	0	195662009	4112343		0
20570	1236	28060	1971-04-26	1971-04-26 00:00:00	1971-05-06	1971-05-06 00:00:00	32020		\N	81383	0	43878008	28060		0
20738	1245	260139	1970-06-04	1970-06-04 00:00:00	1970-06-18	1970-06-18 00:00:00	32020		\N	81982	0	10509002	260139		0
20878	1253	4059173	1975-08-05	1975-08-05 00:00:00	1975-10-04	1975-10-04 00:00:00	32020		\N	82550	0	16114001	4059173		0
21014	1261	372328	1973-09-27	1973-09-27 00:00:00	1973-12-08	1973-12-08 00:00:00	32020		\N	83200	0	65363002	372328		0
31722	1879	4112343	1995-12-17	1995-12-17 00:00:00	1995-12-25	1995-12-25 00:00:00	32020		\N	125394	0	195662009	4112343		0
10773	639	4112343	1974-05-16	1974-05-16 00:00:00	1974-05-29	1974-05-29 00:00:00	32020		\N	42290	0	195662009	4112343		0
10954	648	260139	2014-09-30	2014-09-30 00:00:00	2014-10-07	2014-10-07 00:00:00	32020		\N	42891	0	10509002	260139		0
11098	654	4112343	1990-05-16	1990-05-16 00:00:00	1990-05-26	1990-05-26 00:00:00	32020		\N	43320	0	195662009	4112343		0
21750	1306	4094814	1967-02-03	1967-02-03 00:00:00	1967-05-04	1967-05-04 00:00:00	32020		\N	86248	0	262574004	4094814		0
11400	673	4112343	1995-02-09	1995-02-09 00:00:00	1995-02-19	1995-02-19 00:00:00	32020		\N	44466	0	195662009	4112343		0
22111	1321	372328	1962-10-14	1962-10-14 00:00:00	1962-12-06	1962-12-06 00:00:00	32020		\N	87605	0	65363002	372328		0
11747	693	4112343	1954-09-15	1954-09-15 00:00:00	1954-09-28	1954-09-28 00:00:00	32020		\N	45961	0	195662009	4112343		0
11920	704	4155034	1994-10-26	1994-10-26 00:00:00	1994-11-16	1994-11-16 00:00:00	32020		\N	46642	0	283371005	4155034		0
12073	715	40481087	1984-06-17	1984-06-17 00:00:00	1984-07-08	1984-07-08 00:00:00	32020		\N	47332	0	444814009	40481087		0
22754	1358	40481087	1956-12-22	1956-12-22 00:00:00	1957-01-05	1957-01-05 00:00:00	32020		\N	90113	0	444814009	40481087		0
12368	730	80180	2002-11-18	2002-11-18 00:00:00	\N	\N	32020		\N	48452	0	396275006	80180		0
12557	742	28060	1933-07-29	1933-07-29 00:00:00	1933-08-10	1933-08-10 00:00:00	32020		\N	49106	0	43878008	28060		0
12759	754	372328	1939-11-24	1939-11-24 00:00:00	1940-01-23	1940-01-23 00:00:00	32020		\N	49924	0	65363002	372328		0
12930	760	40481087	2011-05-24	2011-05-24 00:00:00	2011-06-07	2011-06-07 00:00:00	32020		\N	50498	0	444814009	40481087		0
13106	771	40481087	1979-03-20	1979-03-20 00:00:00	1979-04-03	1979-04-03 00:00:00	32020		\N	51242	0	444814009	40481087		0
23763	1418	4001336	2005-10-25	2005-10-25 00:00:00	2005-12-24	2005-12-24 00:00:00	32020		\N	94400	0	110030002	4001336		0
13380	788	4109685	2015-08-01	2015-08-01 00:00:00	2015-08-22	2015-08-22 00:00:00	32020		\N	52454	0	284551006	4109685		0
24136	1439	40481087	2008-12-09	2008-12-09 00:00:00	2008-12-16	2008-12-16 00:00:00	32020		\N	95923	0	444814009	40481087		0
13778	814	372328	1984-12-18	1984-12-18 00:00:00	1985-06-22	1985-06-22 00:00:00	32020		\N	53997	0	65363002	372328		0
13878	820	40481087	1990-10-15	1990-10-15 00:00:00	1990-10-29	1990-10-29 00:00:00	32020		\N	54350	0	444814009	40481087		0
14032	828	40479422	1971-04-14	1971-04-14 00:00:00	1971-06-20	1971-06-20 00:00:00	32020		\N	54863	0	444448004	40479422		0
24745	1476	40481087	1952-03-23	1952-03-23 00:00:00	1952-04-06	1952-04-06 00:00:00	32020		\N	98427	0	444814009	40481087		0
14388	851	4027663	2008-05-25	2008-05-25 00:00:00	\N	\N	32020		\N	56318	0	13200003	4027663		0
14577	862	4112343	1986-02-09	1986-02-09 00:00:00	1986-02-17	1986-02-17 00:00:00	32020		\N	57087	0	195662009	4112343		0
14716	867	4112343	1974-09-24	1974-09-24 00:00:00	1974-10-01	1974-10-01 00:00:00	32020		\N	57542	0	195662009	4112343		0
25413	1513	4029498	1981-05-23	1981-05-23 00:00:00	\N	\N	32020		\N	101150	0	128613002	4029498		0
15080	887	28060	1969-07-25	1969-07-25 00:00:00	1969-08-06	1969-08-06 00:00:00	32020		\N	59137	0	43878008	28060		0
25746	1529	40481087	1990-10-02	1990-10-02 00:00:00	1990-10-16	1990-10-16 00:00:00	32020		\N	102364	0	444814009	40481087		0
25899	1537	40481087	1970-07-05	1970-07-05 00:00:00	1970-07-19	1970-07-19 00:00:00	32020		\N	102847	0	444814009	40481087		0
15553	921	81151	2007-07-08	2007-07-08 00:00:00	2007-08-12	2007-08-12 00:00:00	32020		\N	61386	0	44465007	81151		0
15754	931	40481087	1993-11-12	1993-11-12 00:00:00	1993-11-26	1993-11-26 00:00:00	32020		\N	61937	0	444814009	40481087		0
15860	938	260139	1975-05-22	1975-05-22 00:00:00	1975-05-29	1975-05-29 00:00:00	32020		\N	62348	0	10509002	260139		0
16075	951	40481087	1968-10-10	1968-10-10 00:00:00	1968-10-24	1968-10-24 00:00:00	32020		\N	63207	0	444814009	40481087		0
16265	962	4112343	2010-12-06	2010-12-06 00:00:00	2010-12-16	2010-12-16 00:00:00	32020		\N	64099	0	195662009	4112343		0
16384	969	40481087	2014-12-03	2014-12-03 00:00:00	2014-12-24	2014-12-24 00:00:00	32020		\N	64419	0	444814009	40481087		0
16519	974	4112343	1979-01-22	1979-01-22 00:00:00	1979-01-30	1979-01-30 00:00:00	32020		\N	64931	0	195662009	4112343		0
27238	1608	372328	1943-08-03	1943-08-03 00:00:00	1944-02-12	1944-02-12 00:00:00	32020		\N	107943	0	65363002	372328		0
27393	1613	4027663	1981-05-08	1981-05-08 00:00:00	\N	\N	32020		\N	\N	0	13200003	4027663		0
17073	1021	40481087	1956-05-29	1956-05-29 00:00:00	1956-06-19	1956-06-19 00:00:00	32020		\N	67201	0	444814009	40481087		0
27753	1636	260139	2019-02-16	2019-02-16 00:00:00	2019-03-02	2019-03-02 00:00:00	32020		\N	109872	0	10509002	260139		0
27985	1655	80180	2005-10-12	2005-10-12 00:00:00	\N	\N	32020		\N	111008	0	396275006	80180		0
17554	1054	40481087	1975-07-25	1975-07-25 00:00:00	1975-08-01	1975-08-01 00:00:00	32020		\N	69148	0	444814009	40481087		0
17756	1068	4112343	2018-10-21	2018-10-21 00:00:00	2018-11-02	2018-11-02 00:00:00	32020		\N	69964	0	195662009	4112343		0
28406	1679	28060	1974-08-06	1974-08-06 00:00:00	1974-08-17	1974-08-17 00:00:00	32020		\N	112588	0	43878008	28060		0
18037	1084	260139	2019-02-20	2019-02-20 00:00:00	2019-03-06	2019-03-06 00:00:00	32020		\N	71239	0	10509002	260139		0
18246	1098	4116491	1997-11-29	1997-11-29 00:00:00	1998-01-21	1998-01-21 00:00:00	32020		\N	72042	0	301011002	4116491		0
18334	1102	40481087	1981-09-04	1981-09-04 00:00:00	1981-09-11	1981-09-11 00:00:00	32020		\N	72443	0	444814009	40481087		0
18553	1116	4146173	2015-12-07	2015-12-07 00:00:00	2016-02-05	2016-02-05 00:00:00	32020		\N	73512	0	307731004	4146173		0
18706	1125	4112343	2009-08-17	2009-08-17 00:00:00	2009-08-26	2009-08-26 00:00:00	32020		\N	74151	0	195662009	4112343		0
18885	1135	40481087	2002-10-04	2002-10-04 00:00:00	2002-10-18	2002-10-18 00:00:00	32020		\N	74765	0	444814009	40481087		0
19053	1144	378001	2012-04-16	2012-04-16 00:00:00	2012-05-16	2012-05-16 00:00:00	32020		\N	75534	0	62106007	378001		0
19199	1150	40481087	2010-12-24	2010-12-24 00:00:00	2011-01-07	2011-01-07 00:00:00	32020		\N	76017	0	444814009	40481087		0
19400	1162	40481087	1995-05-10	1995-05-10 00:00:00	1995-05-17	1995-05-17 00:00:00	32020		\N	76702	0	444814009	40481087		0
30093	1779	40481087	1971-03-01	1971-03-01 00:00:00	1971-03-22	1971-03-22 00:00:00	32020		\N	119046	0	444814009	40481087		0
30213	1785	257012	1994-10-25	1994-10-25 00:00:00	\N	\N	32020		\N	119580	0	40055000	257012		0
30423	1793	372328	1942-01-28	1942-01-28 00:00:00	1943-09-15	1943-09-15 00:00:00	32020		\N	120216	0	65363002	372328		0
20058	1209	4294548	1985-06-04	1985-06-04 00:00:00	1985-11-12	1985-11-12 00:00:00	32020		\N	79431	0	75498004	4294548		0
20239	1217	260139	2010-11-22	2010-11-22 00:00:00	2010-12-06	2010-12-06 00:00:00	32020		\N	80138	0	10509002	260139		0
20364	1226	260139	1995-09-18	1995-09-18 00:00:00	1995-09-25	1995-09-25 00:00:00	32020		\N	80698	0	10509002	260139		0
20571	1236	4112343	2015-11-15	2015-11-15 00:00:00	2015-11-24	2015-11-24 00:00:00	32020		\N	81386	0	195662009	4112343		0
20739	1246	4310024	1978-05-06	1978-05-06 00:00:00	\N	\N	32020		\N	82079	0	424802006	4310024		0
20879	1253	40481087	1984-12-13	1984-12-13 00:00:00	1985-01-03	1985-01-03 00:00:00	32020		\N	82508	0	444814009	40481087		0
21015	1261	261325	2002-07-06	2002-07-06 00:00:00	\N	\N	32020		\N	83129	0	87433001	261325		0
31723	1879	40481087	2006-06-10	2006-06-10 00:00:00	2006-06-17	2006-06-17 00:00:00	32020		\N	125373	0	444814009	40481087		0
10774	639	40481087	1979-10-06	1979-10-06 00:00:00	1979-10-27	1979-10-27 00:00:00	32020		\N	42301	0	444814009	40481087		0
10955	648	40481087	2000-09-09	2000-09-09 00:00:00	2000-09-23	2000-09-23 00:00:00	32020		\N	42936	0	444814009	40481087		0
11099	654	40481087	2004-04-15	2004-04-15 00:00:00	2004-04-29	2004-04-29 00:00:00	32020		\N	43321	0	444814009	40481087		0
21751	1306	260139	1999-11-17	1999-11-17 00:00:00	1999-12-01	1999-12-01 00:00:00	32020		\N	86193	0	10509002	260139		0
11401	673	4001336	1965-04-04	1965-04-04 00:00:00	1965-06-03	1965-06-03 00:00:00	32020		\N	44428	0	110030002	4001336		0
22112	1321	440448	1995-06-24	1995-06-24 00:00:00	\N	\N	32020		\N	87599	0	74400008	440448		0
11748	693	40481087	1980-03-19	1980-03-19 00:00:00	1980-04-02	1980-04-02 00:00:00	32020		\N	45898	0	444814009	40481087		0
11921	704	260139	2015-12-07	2015-12-07 00:00:00	2015-12-14	2015-12-14 00:00:00	32020		\N	46631	0	10509002	260139		0
12074	715	4152936	2002-09-03	2002-09-03 00:00:00	2002-09-17	2002-09-17 00:00:00	32020		\N	47301	0	283385000	4152936		0
22755	1358	260139	1965-03-06	1965-03-06 00:00:00	1965-03-20	1965-03-20 00:00:00	32020		\N	90044	0	10509002	260139		0
12369	730	4112343	1984-05-08	1984-05-08 00:00:00	1984-05-15	1984-05-15 00:00:00	32020		\N	48478	0	195662009	4112343		0
12558	742	4112343	1951-12-08	1951-12-08 00:00:00	1951-12-19	1951-12-19 00:00:00	32020		\N	49215	0	195662009	4112343		0
12760	754	4142905	1950-09-20	1950-09-20 00:00:00	1950-10-20	1950-10-20 00:00:00	32020		\N	49820	0	33737001	4142905		0
12931	760	4112343	1984-05-28	1984-05-28 00:00:00	1984-06-05	1984-06-05 00:00:00	32020		\N	50499	0	195662009	4112343		0
13107	771	40481087	1968-01-18	1968-01-18 00:00:00	1968-01-25	1968-01-25 00:00:00	32020		\N	51173	0	444814009	40481087		0
23764	1418	4132546	2005-10-25	2005-10-25 00:00:00	\N	\N	32020		\N	94400	0	275272006	4166590		0
13381	788	40481087	2003-11-02	2003-11-02 00:00:00	2003-11-16	2003-11-16 00:00:00	32020		\N	52407	0	444814009	40481087		0
24137	1439	372328	1978-12-06	1978-12-06 00:00:00	1978-12-20	1978-12-20 00:00:00	32020		\N	95900	0	65363002	372328		0
24258	1446	4112343	2002-04-01	2002-04-01 00:00:00	2002-04-14	2002-04-14 00:00:00	32020		\N	96365	0	195662009	4112343		0
13879	820	372328	1970-03-12	1970-03-12 00:00:00	1970-05-21	1970-05-21 00:00:00	32020		\N	54357	0	65363002	372328		0
14033	828	40481087	1954-03-19	1954-03-19 00:00:00	1954-04-09	1954-04-09 00:00:00	32020		\N	54811	0	444814009	40481087		0
24746	1476	40481087	1986-12-21	1986-12-21 00:00:00	1986-12-28	1986-12-28 00:00:00	32020		\N	98331	0	444814009	40481087		0
14389	851	4294548	2015-12-24	2015-12-24 00:00:00	2016-01-07	2016-01-07 00:00:00	32020		\N	56297	0	75498004	4294548		0
14578	862	4218389	1977-09-23	1977-09-23 00:00:00	1977-10-21	1977-10-21 00:00:00	32020		\N	57050	0	39848009	4218389		0
14717	867	81151	1981-09-14	1981-09-14 00:00:00	1981-09-28	1981-09-28 00:00:00	32020		\N	57580	0	44465007	81151		0
25414	1513	380378	1981-05-23	1981-05-23 00:00:00	\N	\N	32020		\N	101150	0	84757009	380378		0
15106	890	260139	1966-03-25	1966-03-25 00:00:00	1966-04-01	1966-04-01 00:00:00	32020		\N	59318	0	10509002	260139		0
25747	1529	260139	1996-12-19	1996-12-19 00:00:00	1997-01-02	1997-01-02 00:00:00	32020		\N	102303	0	10509002	260139		0
25900	1537	4112343	2014-01-26	2014-01-26 00:00:00	2014-02-05	2014-02-05 00:00:00	32020		\N	102910	0	195662009	4112343		0
15554	921	4109685	1999-12-26	1999-12-26 00:00:00	2000-01-16	2000-01-16 00:00:00	32020		\N	61384	0	284551006	4109685		0
15755	932	81151	1975-08-22	1975-08-22 00:00:00	1975-09-05	1975-09-05 00:00:00	32020		\N	62027	0	44465007	81151		0
15861	938	40481087	1989-07-04	1989-07-04 00:00:00	1989-07-11	1989-07-11 00:00:00	32020		\N	62319	0	444814009	40481087		0
16076	951	4218389	2019-01-22	2019-01-22 00:00:00	2019-02-26	2019-02-26 00:00:00	32020		\N	63222	0	39848009	4218389		0
16266	962	4266809	1995-04-18	1995-04-18 00:00:00	\N	\N	32020		\N	64089	0	397881000	4266809		0
16385	969	260139	1988-07-15	1988-07-15 00:00:00	1988-07-29	1988-07-29 00:00:00	32020		\N	64462	0	10509002	260139		0
16520	974	4112343	2010-08-14	2010-08-14 00:00:00	2010-08-23	2010-08-23 00:00:00	32020		\N	64952	0	195662009	4112343		0
27239	1608	260139	1950-01-17	1950-01-17 00:00:00	1950-01-31	1950-01-31 00:00:00	32020		\N	107985	0	10509002	260139		0
27425	1618	4329847	2006-04-12	2006-04-12 00:00:00	\N	\N	32020		\N	108786	0	22298006	4329847		0
17074	1021	80180	1990-01-16	1990-01-16 00:00:00	\N	\N	32020		\N	67145	0	396275006	80180		0
27778	1640	4112343	1956-08-11	1956-08-11 00:00:00	1956-08-20	1956-08-20 00:00:00	32020		\N	110029	0	195662009	4112343		0
27986	1655	40481087	1994-04-22	1994-04-22 00:00:00	1994-05-06	1994-05-06 00:00:00	32020		\N	111030	0	444814009	40481087		0
17555	1054	372328	1999-11-12	1999-11-12 00:00:00	2000-08-04	2000-08-04 00:00:00	32020		\N	69127	0	65363002	372328		0
17757	1068	40481087	1992-03-14	1992-03-14 00:00:00	1992-03-28	1992-03-28 00:00:00	32020		\N	69956	0	444814009	40481087		0
28407	1679	40481087	1983-11-11	1983-11-11 00:00:00	1983-11-18	1983-11-18 00:00:00	32020		\N	112558	0	444814009	40481087		0
18038	1084	4218389	2016-10-13	2016-10-13 00:00:00	2016-11-10	2016-11-10 00:00:00	32020		\N	71209	0	39848009	4218389		0
18247	1098	260139	1999-11-30	1999-11-30 00:00:00	1999-12-07	1999-12-07 00:00:00	32020		\N	72084	0	10509002	260139		0
18335	1102	40481087	2005-03-03	2005-03-03 00:00:00	2005-03-24	2005-03-24 00:00:00	32020		\N	72467	0	444814009	40481087		0
18554	1116	40481087	1995-12-08	1995-12-08 00:00:00	1995-12-15	1995-12-15 00:00:00	32020		\N	73511	0	444814009	40481087		0
18707	1125	40481087	1965-03-28	1965-03-28 00:00:00	1965-04-04	1965-04-04 00:00:00	32020		\N	74197	0	444814009	40481087		0
18886	1135	260139	1981-01-01	1981-01-01 00:00:00	1981-01-15	1981-01-15 00:00:00	32020		\N	74740	0	10509002	260139		0
19054	1144	78272	1990-10-04	1990-10-04 00:00:00	1990-11-08	1990-11-08 00:00:00	32020		\N	75496	0	70704007	78272		0
19200	1150	28060	1973-05-25	1973-05-25 00:00:00	1973-06-02	1973-06-02 00:00:00	32020		\N	76002	0	43878008	28060		0
19401	1162	255848	2007-01-02	2007-01-02 00:00:00	\N	\N	32020		\N	76733	0	233604007	255848		0
30094	1779	4112343	1970-11-14	1970-11-14 00:00:00	1970-11-26	1970-11-26 00:00:00	32020		\N	118986	0	195662009	4112343		0
30214	1785	40481087	2003-06-24	2003-06-24 00:00:00	2003-07-08	2003-07-08 00:00:00	32020		\N	119626	0	444814009	40481087		0
30424	1793	40481087	1986-02-26	1986-02-26 00:00:00	1986-03-05	1986-03-05 00:00:00	32020		\N	120250	0	444814009	40481087		0
20059	1209	4149245	2004-09-16	2004-09-16 00:00:00	2004-10-23	2004-10-23 00:00:00	32020		\N	79458	0	30832001	4149245		0
20240	1217	4112343	1978-05-04	1978-05-04 00:00:00	1978-05-12	1978-05-12 00:00:00	32020		\N	80135	0	195662009	4112343		0
20365	1226	80180	2013-08-21	2013-08-21 00:00:00	\N	\N	32020		\N	80684	0	396275006	80180		0
20572	1236	4296204	2012-12-31	2012-12-31 00:00:00	2013-01-14	2013-01-14 00:00:00	32020		\N	81418	0	403190006	4296204		0
20740	1246	192671	1980-11-06	1980-11-06 00:00:00	\N	\N	32020		\N	82136	0	K92.2	35208414		0
20880	1253	372328	1956-12-28	1956-12-28 00:00:00	1957-02-13	1957-02-13 00:00:00	32020		\N	82525	0	65363002	372328		0
21016	1261	40481087	2005-06-10	2005-06-10 00:00:00	2005-06-17	2005-06-17 00:00:00	32020		\N	83142	0	444814009	40481087		0
31724	1879	28060	2019-04-24	2019-04-24 00:00:00	2019-05-07	2019-05-07 00:00:00	32020		\N	125403	0	43878008	28060		0
10775	639	40481087	1988-12-15	1988-12-15 00:00:00	1989-01-05	1989-01-05 00:00:00	32020		\N	42292	0	444814009	40481087		0
10956	648	260139	1994-11-05	1994-11-05 00:00:00	1994-11-12	1994-11-12 00:00:00	32020		\N	42952	0	10509002	260139		0
11100	654	260139	2007-05-22	2007-05-22 00:00:00	2007-06-05	2007-06-05 00:00:00	32020		\N	43311	0	10509002	260139		0
21752	1306	40481087	1965-06-30	1965-06-30 00:00:00	1965-07-21	1965-07-21 00:00:00	32020		\N	86167	0	444814009	40481087		0
11402	673	4149245	2005-11-22	2005-11-22 00:00:00	2005-12-29	2005-12-29 00:00:00	32020		\N	44439	0	30832001	4149245		0
22113	1321	40481087	1990-11-02	1990-11-02 00:00:00	1990-11-23	1990-11-23 00:00:00	32020		\N	87640	0	444814009	40481087		0
11749	693	260139	1965-05-20	1965-05-20 00:00:00	1965-05-27	1965-05-27 00:00:00	32020		\N	45885	0	10509002	260139		0
11922	704	40481087	1983-10-13	1983-10-13 00:00:00	1983-10-27	1983-10-27 00:00:00	32020		\N	46517	0	444814009	40481087		0
12075	715	40481087	2006-04-28	2006-04-28 00:00:00	2006-05-19	2006-05-19 00:00:00	32020		\N	47318	0	444814009	40481087		0
22756	1358	40481087	1956-01-14	1956-01-14 00:00:00	1956-01-21	1956-01-21 00:00:00	32020		\N	90042	0	444814009	40481087		0
12370	730	4134304	1960-05-02	1960-05-02 00:00:00	1960-07-31	1960-07-31 00:00:00	32020		\N	48501	0	263102004	4134304		0
12559	742	40481087	2010-12-02	2010-12-02 00:00:00	2010-12-09	2010-12-09 00:00:00	32020		\N	49174	0	444814009	40481087		0
12761	754	40486433	1942-08-30	1942-08-30 00:00:00	1993-07-13	1993-07-13 00:00:00	32020		\N	49947	0	446096008	40486433		0
12932	760	40481087	2016-05-18	2016-05-18 00:00:00	2016-05-25	2016-05-25 00:00:00	32020		\N	50456	0	444814009	40481087		0
13108	771	4048695	1971-12-02	1971-12-02 00:00:00	1972-01-03	1972-01-03 00:00:00	32020		\N	51179	0	15724005	4048695		0
23765	1418	28060	1978-01-02	1978-01-02 00:00:00	1978-01-15	1978-01-15 00:00:00	32020		\N	94422	0	43878008	28060		0
13382	788	40481087	2007-10-02	2007-10-02 00:00:00	2007-10-16	2007-10-16 00:00:00	32020		\N	52409	0	444814009	40481087		0
24138	1439	372328	1982-06-09	1982-06-09 00:00:00	1982-06-23	1982-06-23 00:00:00	32020		\N	95924	0	65363002	372328		0
24259	1446	4112343	1997-02-15	1997-02-15 00:00:00	1997-02-23	1997-02-23 00:00:00	32020		\N	96391	0	195662009	4112343		0
13880	820	4001336	1977-07-12	1977-07-12 00:00:00	1977-08-11	1977-08-11 00:00:00	32020		\N	54345	0	110030002	4001336		0
14034	829	4027663	2003-06-10	2003-06-10 00:00:00	\N	\N	32020		\N	54894	0	13200003	4027663		0
24747	1476	80180	1980-06-27	1980-06-27 00:00:00	\N	\N	32020		\N	98386	0	396275006	80180		0
14390	851	80180	2016-03-09	2016-03-09 00:00:00	\N	\N	32020		\N	56297	0	396275006	80180		0
14579	862	40481087	2010-05-04	2010-05-04 00:00:00	2010-05-25	2010-05-25 00:00:00	32020		\N	57085	0	444814009	40481087		0
14718	867	4278672	1998-09-29	1998-09-29 00:00:00	1998-11-28	1998-11-28 00:00:00	32020		\N	57582	0	65966004	4278672		0
25415	1513	40481087	1999-06-01	1999-06-01 00:00:00	1999-06-08	1999-06-08 00:00:00	32020		\N	101083	0	444814009	40481087		0
25565	1520	4112343	1978-07-12	1978-07-12 00:00:00	1978-07-19	1978-07-19 00:00:00	32020		\N	101713	0	195662009	4112343		0
25748	1529	372328	1966-04-25	1966-04-25 00:00:00	1966-06-06	1966-06-06 00:00:00	32020		\N	102366	0	65363002	372328		0
25901	1538	28060	1994-05-19	1994-05-19 00:00:00	1994-05-31	1994-05-31 00:00:00	32020		\N	103038	0	43878008	28060		0
15555	921	4134304	1983-03-25	1983-03-25 00:00:00	1983-06-23	1983-06-23 00:00:00	32020		\N	61345	0	263102004	4134304		0
15756	932	81151	1986-04-10	1986-04-10 00:00:00	1986-05-08	1986-05-08 00:00:00	32020		\N	62054	0	44465007	81151		0
15862	938	260139	1958-02-12	1958-02-12 00:00:00	1958-02-19	1958-02-19 00:00:00	32020		\N	62316	0	10509002	260139		0
16077	951	40481087	2013-12-27	2013-12-27 00:00:00	2014-01-17	2014-01-17 00:00:00	32020		\N	63190	0	444814009	40481087		0
16267	962	4112343	1994-12-07	1994-12-07 00:00:00	1994-12-17	1994-12-17 00:00:00	32020		\N	64089	0	195662009	4112343		0
16386	969	4283893	2019-02-07	2019-02-07 00:00:00	2019-02-28	2019-02-28 00:00:00	32020		\N	64420	0	36971009	4283893		0
16521	974	4142905	2014-04-08	2014-04-08 00:00:00	2014-06-07	2014-06-07 00:00:00	32020		\N	64968	0	33737001	4142905		0
27240	1608	81151	1951-11-03	1951-11-03 00:00:00	1951-11-24	1951-11-24 00:00:00	32020		\N	108012	0	44465007	81151		0
27426	1618	4027663	2002-05-09	2002-05-09 00:00:00	\N	\N	32020		\N	108806	0	13200003	4027663		0
17075	1021	4310024	1987-07-01	1987-07-01 00:00:00	\N	\N	32020		\N	67145	0	424802006	4310024		0
27779	1640	40481087	2019-05-16	2019-05-16 00:00:00	2019-06-06	2019-06-06 00:00:00	32020		\N	110092	0	444814009	40481087		0
27987	1655	40481087	2016-03-31	2016-03-31 00:00:00	2016-04-14	2016-04-14 00:00:00	32020		\N	111033	0	444814009	40481087		0
17556	1054	40481087	1964-01-25	1964-01-25 00:00:00	1964-02-15	1964-02-15 00:00:00	32020		\N	69146	0	444814009	40481087		0
17758	1068	40481087	2008-04-26	2008-04-26 00:00:00	2008-05-03	2008-05-03 00:00:00	32020		\N	69974	0	444814009	40481087		0
28408	1679	372328	1973-06-30	1973-06-30 00:00:00	1973-09-04	1973-09-04 00:00:00	32020		\N	112561	0	65363002	372328		0
18039	1084	40481087	2008-04-23	2008-04-23 00:00:00	2008-05-07	2008-05-07 00:00:00	32020		\N	71206	0	444814009	40481087		0
18248	1098	40481087	1973-09-15	1973-09-15 00:00:00	1973-10-06	1973-10-06 00:00:00	32020		\N	72025	0	444814009	40481087		0
18336	1102	260139	2013-10-26	2013-10-26 00:00:00	2013-11-09	2013-11-09 00:00:00	32020		\N	72468	0	10509002	260139		0
18555	1116	81151	1993-03-23	1993-03-23 00:00:00	1993-04-06	1993-04-06 00:00:00	32020		\N	73508	0	44465007	81151		0
18708	1125	81151	1956-07-20	1956-07-20 00:00:00	1956-08-03	1956-08-03 00:00:00	32020		\N	74136	0	44465007	81151		0
18887	1135	4112343	2009-10-06	2009-10-06 00:00:00	2009-10-19	2009-10-19 00:00:00	32020		\N	74772	0	195662009	4112343		0
19055	1144	260139	2006-03-31	2006-03-31 00:00:00	2006-04-14	2006-04-14 00:00:00	32020		\N	75476	0	10509002	260139		0
19201	1150	4294548	2011-11-12	2011-11-12 00:00:00	2011-11-19	2011-11-19 00:00:00	32020		\N	76077	0	75498004	4294548		0
19402	1162	4112343	1931-08-01	1931-08-01 00:00:00	1931-08-14	1931-08-14 00:00:00	32020		\N	76694	0	195662009	4112343		0
30095	1780	40481087	2003-01-19	2003-01-19 00:00:00	2003-02-02	2003-02-02 00:00:00	32020		\N	119178	0	444814009	40481087		0
30215	1785	4112343	1962-04-09	1962-04-09 00:00:00	1962-04-16	1962-04-16 00:00:00	32020		\N	119611	0	195662009	4112343		0
30425	1793	4283893	1933-08-08	1933-08-08 00:00:00	1933-09-19	1933-09-19 00:00:00	32020		\N	120177	0	36971009	4283893		0
20060	1209	4112343	2009-11-16	2009-11-16 00:00:00	2009-11-26	2009-11-26 00:00:00	32020		\N	79423	0	195662009	4112343		0
20241	1217	80180	2013-02-26	2013-02-26 00:00:00	\N	\N	32020		\N	80152	0	396275006	80180		0
20366	1226	40481087	2001-12-10	2001-12-10 00:00:00	2001-12-17	2001-12-17 00:00:00	32020		\N	80699	0	444814009	40481087		0
20573	1236	40481087	1938-09-08	1938-09-08 00:00:00	1938-09-29	1938-09-29 00:00:00	32020		\N	81445	0	444814009	40481087		0
20741	1246	4112343	1986-12-03	1986-12-03 00:00:00	1986-12-13	1986-12-13 00:00:00	32020		\N	82062	0	195662009	4112343		0
20881	1253	260139	2012-04-20	2012-04-20 00:00:00	2012-05-04	2012-05-04 00:00:00	32020		\N	82517	0	10509002	260139		0
21017	1261	4112343	1987-05-31	1987-05-31 00:00:00	1987-06-07	1987-06-07 00:00:00	32020		\N	83251	0	195662009	4112343		0
31725	1879	28060	1984-02-05	1984-02-05 00:00:00	1984-02-16	1984-02-16 00:00:00	32020		\N	125393	0	43878008	28060		0
10776	639	80180	1989-05-14	1989-05-14 00:00:00	\N	\N	32020		\N	42292	0	396275006	80180		0
21432	1285	4112343	1972-06-19	1972-06-19 00:00:00	1972-06-28	1972-06-28 00:00:00	32020		\N	85020	0	195662009	4112343		0
11101	654	40481087	2001-10-12	2001-10-12 00:00:00	2001-10-19	2001-10-19 00:00:00	32020		\N	43338	0	444814009	40481087		0
21753	1306	40481087	1970-12-31	1970-12-31 00:00:00	1971-01-14	1971-01-14 00:00:00	32020		\N	86241	0	444814009	40481087		0
11403	673	80180	1995-12-03	1995-12-03 00:00:00	\N	\N	32020		\N	44486	0	396275006	80180		0
22114	1321	4112343	2003-12-29	2003-12-29 00:00:00	2004-01-08	2004-01-08 00:00:00	32020		\N	87612	0	195662009	4112343		0
11750	693	372328	1951-11-28	1951-11-28 00:00:00	1952-03-11	1952-03-11 00:00:00	32020		\N	45910	0	65363002	372328		0
11923	704	40481087	2015-09-28	2015-09-28 00:00:00	2015-10-19	2015-10-19 00:00:00	32020		\N	46525	0	444814009	40481087		0
12076	715	40481087	1987-10-28	1987-10-28 00:00:00	1987-11-11	1987-11-11 00:00:00	32020		\N	47334	0	444814009	40481087		0
22757	1358	28060	1976-07-27	1976-07-27 00:00:00	1976-08-05	1976-08-05 00:00:00	32020		\N	90047	0	43878008	28060		0
12371	730	78272	2000-04-02	2000-04-02 00:00:00	2000-05-07	2000-05-07 00:00:00	32020		\N	48503	0	70704007	78272		0
12560	742	80180	1968-02-19	1968-02-19 00:00:00	\N	\N	32020		\N	49169	0	396275006	80180		0
12762	754	40481087	2019-06-20	2019-06-20 00:00:00	\N	\N	32020		\N	49904	0	444814009	40481087		0
12933	760	4112343	1971-10-22	1971-10-22 00:00:00	1971-10-31	1971-10-31 00:00:00	32020		\N	50455	0	195662009	4112343		0
13109	771	4059173	1980-10-17	1980-10-17 00:00:00	1980-12-16	1980-12-16 00:00:00	32020		\N	51181	0	16114001	4059173		0
23766	1418	40481087	2005-07-12	2005-07-12 00:00:00	2005-07-26	2005-07-26 00:00:00	32020		\N	94450	0	444814009	40481087		0
13383	788	378001	1993-08-26	1993-08-26 00:00:00	1993-09-25	1993-09-25 00:00:00	32020		\N	52453	0	62106007	378001		0
24139	1439	257012	1998-06-08	1998-06-08 00:00:00	\N	\N	32020		\N	95919	0	40055000	257012		0
24260	1446	4112343	2004-01-05	2004-01-05 00:00:00	2004-01-15	2004-01-15 00:00:00	32020		\N	96360	0	195662009	4112343		0
13881	820	4283893	2002-08-05	2002-08-05 00:00:00	2003-02-03	2003-02-03 00:00:00	32020		\N	54353	0	36971009	4283893		0
14035	829	78272	1980-03-12	1980-03-12 00:00:00	1980-04-16	1980-04-16 00:00:00	32020		\N	54906	0	70704007	78272		0
24748	1476	40481087	1948-11-11	1948-11-11 00:00:00	1948-11-18	1948-11-18 00:00:00	32020		\N	98531	0	444814009	40481087		0
14391	851	28060	1990-10-30	1990-10-30 00:00:00	1990-11-07	1990-11-07 00:00:00	32020		\N	56321	0	43878008	28060		0
14580	862	260139	1987-02-21	1987-02-21 00:00:00	1987-03-07	1987-03-07 00:00:00	32020		\N	57044	0	10509002	260139		0
14719	867	4146173	1937-02-07	1937-02-07 00:00:00	1937-03-09	1937-03-09 00:00:00	32020		\N	57520	0	307731004	4146173		0
25416	1513	78272	1995-12-01	1995-12-01 00:00:00	1995-12-15	1995-12-15 00:00:00	32020		\N	101152	0	70704007	78272		0
25566	1520	81151	1955-02-19	1955-02-19 00:00:00	1955-03-12	1955-03-12 00:00:00	32020		\N	101708	0	44465007	81151		0
25749	1529	260139	1979-02-05	1979-02-05 00:00:00	1979-02-19	1979-02-19 00:00:00	32020		\N	102363	0	10509002	260139		0
25902	1538	40481087	1985-04-16	1985-04-16 00:00:00	1985-04-30	1985-04-30 00:00:00	32020		\N	103057	0	444814009	40481087		0
15556	921	40481087	2001-01-06	2001-01-06 00:00:00	2001-01-13	2001-01-13 00:00:00	32020		\N	61369	0	444814009	40481087		0
15757	932	4266809	2002-07-06	2002-07-06 00:00:00	\N	\N	32020		\N	62037	0	397881000	4266809		0
15863	938	80180	1987-05-30	1987-05-30 00:00:00	\N	\N	32020		\N	62377	0	396275006	80180		0
16078	951	4237458	1995-09-25	1995-09-25 00:00:00	1995-11-24	1995-11-24 00:00:00	32020		\N	63220	0	58150001	4237458		0
16268	962	80180	1995-04-18	1995-04-18 00:00:00	\N	\N	32020		\N	64089	0	396275006	80180		0
16387	969	378001	2018-08-24	2018-08-24 00:00:00	2018-10-23	2018-10-23 00:00:00	32020		\N	64472	0	62106007	378001		0
29277	1733	192671	2016-02-01	2016-02-01 00:00:00	\N	\N	32020		\N	115806	0	K92.2	35208414		0
16522	974	40481087	1973-09-30	1973-09-30 00:00:00	1973-10-07	1973-10-07 00:00:00	32020		\N	64986	0	444814009	40481087		0
27241	1608	378001	1959-04-16	1959-04-16 00:00:00	1959-05-16	1959-05-16 00:00:00	32020		\N	108013	0	62106007	378001		0
27427	1618	192671	2013-06-07	2013-06-07 00:00:00	\N	\N	32020		\N	108784	0	K92.2	35208414		0
17076	1021	4027663	1979-12-05	1979-12-05 00:00:00	\N	\N	32020		\N	67158	0	13200003	4027663		0
27780	1640	40481087	2000-09-22	2000-09-22 00:00:00	2000-10-13	2000-10-13 00:00:00	32020		\N	110085	0	444814009	40481087		0
27988	1655	4113008	2002-09-18	2002-09-18 00:00:00	2002-10-02	2002-10-02 00:00:00	32020		\N	110988	0	284549007	4113008		0
17557	1054	260139	1957-05-05	1957-05-05 00:00:00	1957-05-19	1957-05-19 00:00:00	32020		\N	69121	0	10509002	260139		0
17759	1068	80180	2014-11-23	2014-11-23 00:00:00	\N	\N	32020		\N	69972	0	396275006	80180		0
28409	1679	40481087	1992-11-07	1992-11-07 00:00:00	1992-11-21	1992-11-21 00:00:00	32020		\N	112559	0	444814009	40481087		0
18040	1084	40481087	2009-04-09	2009-04-09 00:00:00	2009-04-16	2009-04-16 00:00:00	32020		\N	71190	0	444814009	40481087		0
18249	1098	260139	1980-06-11	1980-06-11 00:00:00	1980-06-25	1980-06-25 00:00:00	32020		\N	72026	0	10509002	260139		0
18337	1102	260139	1998-07-26	1998-07-26 00:00:00	1998-08-02	1998-08-02 00:00:00	32020		\N	72415	0	10509002	260139		0
18556	1116	372328	1970-07-01	1970-07-01 00:00:00	1970-11-20	1970-11-20 00:00:00	32020		\N	73525	0	65363002	372328		0
18709	1125	260139	1958-09-11	1958-09-11 00:00:00	1958-09-25	1958-09-25 00:00:00	32020		\N	74195	0	10509002	260139		0
18888	1135	372328	1959-04-26	1959-04-26 00:00:00	1959-06-06	1959-06-06 00:00:00	32020		\N	74748	0	65363002	372328		0
19056	1144	40481087	2003-01-06	2003-01-06 00:00:00	2003-01-27	2003-01-27 00:00:00	32020		\N	75472	0	444814009	40481087		0
19202	1150	78272	1992-03-16	1992-03-16 00:00:00	1992-04-13	1992-04-13 00:00:00	32020		\N	76063	0	70704007	78272		0
19403	1162	260139	1994-07-27	1994-07-27 00:00:00	1994-08-10	1994-08-10 00:00:00	32020		\N	76715	0	10509002	260139		0
30096	1780	40481087	1997-02-01	1997-02-01 00:00:00	1997-02-22	1997-02-22 00:00:00	32020		\N	119155	0	444814009	40481087		0
30216	1785	4112343	1989-11-21	1989-11-21 00:00:00	1989-12-01	1989-12-01 00:00:00	32020		\N	119612	0	195662009	4112343		0
30426	1793	40481087	1920-05-29	1920-05-29 00:00:00	1920-06-19	1920-06-19 00:00:00	32020		\N	120218	0	444814009	40481087		0
20061	1209	81893	2012-04-27	2012-04-27 00:00:00	\N	\N	32020		\N	79423	0	64766004	81893		0
20242	1217	257012	2012-11-30	2012-11-30 00:00:00	\N	\N	32020		\N	80140	0	40055000	257012		0
20367	1226	4112343	1990-08-31	1990-08-31 00:00:00	1990-09-08	1990-09-08 00:00:00	32020		\N	80694	0	195662009	4112343		0
20574	1236	372328	1921-07-24	1921-07-24 00:00:00	1921-10-06	1921-10-06 00:00:00	32020		\N	81468	0	65363002	372328		0
20742	1246	260139	1985-11-30	1985-11-30 00:00:00	1985-12-14	1985-12-14 00:00:00	32020		\N	82115	0	10509002	260139		0
20882	1253	40481087	2009-08-06	2009-08-06 00:00:00	2009-08-27	2009-08-27 00:00:00	32020		\N	82524	0	444814009	40481087		0
21018	1261	260139	2006-05-01	2006-05-01 00:00:00	2006-05-08	2006-05-08 00:00:00	32020		\N	83188	0	10509002	260139		0
31726	1879	40481087	1995-11-03	1995-11-03 00:00:00	1995-11-17	1995-11-17 00:00:00	32020		\N	125415	0	444814009	40481087		0
10777	639	4112343	2017-03-23	2017-03-23 00:00:00	2017-04-03	2017-04-03 00:00:00	32020		\N	42246	0	195662009	4112343		0
21433	1285	40481087	1983-06-23	1983-06-23 00:00:00	1983-07-07	1983-07-07 00:00:00	32020		\N	84933	0	444814009	40481087		0
11102	655	4112343	1996-10-13	1996-10-13 00:00:00	1996-10-20	1996-10-20 00:00:00	32020		\N	43388	0	195662009	4112343		0
21754	1306	80180	2001-01-14	2001-01-14 00:00:00	\N	\N	32020		\N	86176	0	396275006	80180		0
11404	673	40481087	1965-10-06	1965-10-06 00:00:00	1965-10-20	1965-10-20 00:00:00	32020		\N	44500	0	444814009	40481087		0
22115	1321	4113008	1987-04-25	1987-04-25 00:00:00	1987-05-09	1987-05-09 00:00:00	32020		\N	87598	0	284549007	4113008		0
11751	693	192671	1995-09-01	1995-09-01 00:00:00	\N	\N	32020		\N	45895	0	K92.2	35208414		0
11924	704	40481087	1970-09-10	1970-09-10 00:00:00	1970-09-17	1970-09-17 00:00:00	32020		\N	46515	0	444814009	40481087		0
12077	715	40481087	2009-03-11	2009-03-11 00:00:00	2009-03-25	2009-03-25 00:00:00	32020		\N	47325	0	444814009	40481087		0
22758	1358	4283893	1957-08-10	1957-08-10 00:00:00	1957-10-05	1957-10-05 00:00:00	32020		\N	90096	0	36971009	4283893		0
12372	730	40481087	1982-04-24	1982-04-24 00:00:00	1982-05-01	1982-05-01 00:00:00	32020		\N	48458	0	444814009	40481087		0
12561	742	4218389	1961-04-27	1961-04-27 00:00:00	1961-06-01	1961-06-01 00:00:00	32020		\N	49188	0	39848009	4218389		0
12763	754	40481087	1958-11-23	1958-11-23 00:00:00	1958-12-07	1958-12-07 00:00:00	32020		\N	49983	0	444814009	40481087		0
12934	760	40481087	1990-08-02	1990-08-02 00:00:00	1990-08-16	1990-08-16 00:00:00	32020		\N	50461	0	444814009	40481087		0
23573	1408	40481087	1994-02-15	1994-02-15 00:00:00	1994-03-08	1994-03-08 00:00:00	32020		\N	93591	0	444814009	40481087		0
23767	1418	260139	1988-03-09	1988-03-09 00:00:00	1988-03-16	1988-03-16 00:00:00	32020		\N	94446	0	10509002	260139		0
13384	788	40481087	1993-11-21	1993-11-21 00:00:00	1993-12-05	1993-12-05 00:00:00	32020		\N	52412	0	444814009	40481087		0
24140	1439	260139	2019-05-12	2019-05-12 00:00:00	2019-05-26	2019-05-26 00:00:00	32020		\N	95907	0	10509002	260139		0
24261	1446	372328	1985-06-06	1985-06-06 00:00:00	1985-10-08	1985-10-08 00:00:00	32020		\N	96397	0	65363002	372328		0
13882	820	260139	1991-05-01	1991-05-01 00:00:00	1991-05-08	1991-05-08 00:00:00	32020		\N	54327	0	10509002	260139		0
14036	829	4112343	2016-09-04	2016-09-04 00:00:00	2016-09-14	2016-09-14 00:00:00	32020		\N	54931	0	195662009	4112343		0
24749	1476	40481087	1997-07-08	1997-07-08 00:00:00	1997-07-15	1997-07-15 00:00:00	32020		\N	98446	0	444814009	40481087		0
14392	851	40481087	1985-02-16	1985-02-16 00:00:00	1985-03-09	1985-03-09 00:00:00	32020		\N	56319	0	444814009	40481087		0
14581	862	4112343	1973-01-29	1973-01-29 00:00:00	1973-02-06	1973-02-06 00:00:00	32020		\N	57080	0	195662009	4112343		0
14720	867	4112343	1970-09-05	1970-09-05 00:00:00	1970-09-12	1970-09-12 00:00:00	32020		\N	57515	0	195662009	4112343		0
25417	1513	40481087	2017-06-21	2017-06-21 00:00:00	2017-07-12	2017-07-12 00:00:00	32020		\N	101027	0	444814009	40481087		0
25567	1520	4112343	1955-06-18	1955-06-18 00:00:00	1955-06-29	1955-06-29 00:00:00	32020		\N	101723	0	195662009	4112343		0
25750	1529	4112343	1993-09-12	1993-09-12 00:00:00	1993-09-21	1993-09-21 00:00:00	32020		\N	102320	0	195662009	4112343		0
25903	1538	40481087	1952-06-25	1952-06-25 00:00:00	1952-07-02	1952-07-02 00:00:00	32020		\N	102982	0	444814009	40481087		0
15557	921	40481087	1998-08-07	1998-08-07 00:00:00	1998-08-14	1998-08-14 00:00:00	32020		\N	61320	0	444814009	40481087		0
15758	932	4310024	2000-10-14	2000-10-14 00:00:00	\N	\N	32020		\N	62037	0	424802006	4310024		0
15864	939	40481087	1974-01-31	1974-01-31 00:00:00	1974-02-07	1974-02-07 00:00:00	32020		\N	62461	0	444814009	40481087		0
16079	951	260139	1984-01-20	1984-01-20 00:00:00	1984-02-03	1984-02-03 00:00:00	32020		\N	63138	0	10509002	260139		0
26732	1585	40481087	2009-12-24	2009-12-24 00:00:00	2010-01-14	2010-01-14 00:00:00	32020		\N	106275	0	444814009	40481087		0
16388	969	80180	2014-07-17	2014-07-17 00:00:00	\N	\N	32020		\N	64449	0	396275006	80180		0
16523	974	40481087	1988-09-26	1988-09-26 00:00:00	1988-10-17	1988-10-17 00:00:00	32020		\N	64932	0	444814009	40481087		0
27242	1608	4112343	2014-10-08	2014-10-08 00:00:00	2014-10-16	2014-10-16 00:00:00	32020		\N	108047	0	195662009	4112343		0
27428	1618	4112343	2013-08-11	2013-08-11 00:00:00	2013-08-21	2013-08-21 00:00:00	32020		\N	108812	0	195662009	4112343		0
17077	1021	372328	1958-02-13	1958-02-13 00:00:00	1958-11-27	1958-11-27 00:00:00	32020		\N	67189	0	65363002	372328		0
27781	1640	80180	1976-04-20	1976-04-20 00:00:00	\N	\N	32020		\N	110039	0	396275006	80180		0
27989	1655	260139	1989-08-28	1989-08-28 00:00:00	1989-09-11	1989-09-11 00:00:00	32020		\N	110992	0	10509002	260139		0
17558	1054	4155034	1985-11-27	1985-11-27 00:00:00	1985-12-18	1985-12-18 00:00:00	32020		\N	69134	0	283371005	4155034		0
17760	1068	4112343	2003-01-29	2003-01-29 00:00:00	2003-02-11	2003-02-11 00:00:00	32020		\N	69989	0	195662009	4112343		0
28410	1679	4112343	2000-03-06	2000-03-06 00:00:00	2000-03-17	2000-03-17 00:00:00	32020		\N	112560	0	195662009	4112343		0
18041	1084	4112343	1995-04-02	1995-04-02 00:00:00	1995-04-12	1995-04-12 00:00:00	32020		\N	71211	0	195662009	4112343		0
18250	1098	40481087	2001-01-03	2001-01-03 00:00:00	2001-01-10	2001-01-10 00:00:00	32020		\N	72043	0	444814009	40481087		0
18338	1102	260139	1970-10-06	1970-10-06 00:00:00	1970-10-20	1970-10-20 00:00:00	32020		\N	72365	0	10509002	260139		0
18557	1116	40481087	1999-03-07	1999-03-07 00:00:00	1999-03-28	1999-03-28 00:00:00	32020		\N	73517	0	444814009	40481087		0
18710	1125	40481087	1993-10-20	1993-10-20 00:00:00	1993-10-27	1993-10-27 00:00:00	32020		\N	74190	0	444814009	40481087		0
18889	1135	260139	2014-07-13	2014-07-13 00:00:00	2014-07-27	2014-07-27 00:00:00	32020		\N	74773	0	10509002	260139		0
19057	1144	28060	1975-03-14	1975-03-14 00:00:00	1975-03-23	1975-03-23 00:00:00	32020		\N	75470	0	43878008	28060		0
19203	1150	4294548	2007-11-19	2007-11-19 00:00:00	2007-12-31	2007-12-31 00:00:00	32020		\N	76031	0	75498004	4294548		0
19404	1162	40481087	1943-08-04	1943-08-04 00:00:00	1943-08-11	1943-08-11 00:00:00	32020		\N	76697	0	444814009	40481087		0
30097	1780	28060	1978-05-06	1978-05-06 00:00:00	1978-05-15	1978-05-15 00:00:00	32020		\N	119112	0	43878008	28060		0
30217	1785	40481087	1996-10-12	1996-10-12 00:00:00	1996-10-19	1996-10-19 00:00:00	32020		\N	119597	0	444814009	40481087		0
30427	1794	4113008	1990-04-25	1990-04-25 00:00:00	1990-05-09	1990-05-09 00:00:00	32020		\N	120328	0	284549007	4113008		0
20062	1209	372328	1978-01-06	1978-01-06 00:00:00	1978-02-16	1978-02-16 00:00:00	32020		\N	79435	0	65363002	372328		0
20243	1217	40481087	2013-03-14	2013-03-14 00:00:00	2013-03-21	2013-03-21 00:00:00	32020		\N	80156	0	444814009	40481087		0
20368	1226	260139	1989-07-19	1989-07-19 00:00:00	1989-08-02	1989-08-02 00:00:00	32020		\N	80692	0	10509002	260139		0
20575	1236	40481087	1967-02-07	1967-02-07 00:00:00	1967-02-14	1967-02-14 00:00:00	32020		\N	81447	0	444814009	40481087		0
20743	1246	4084167	1939-02-15	1939-02-15 00:00:00	1939-02-16	1939-02-16 00:00:00	32020		\N	82133	0	241929008	4084167		0
20883	1253	4218389	1990-11-14	1990-11-14 00:00:00	1990-12-19	1990-12-19 00:00:00	32020		\N	82578	0	39848009	4218389		0
21019	1261	40481087	2011-06-24	2011-06-24 00:00:00	2011-07-01	2011-07-01 00:00:00	32020		\N	83189	0	444814009	40481087		0
31727	1879	40481087	2015-03-05	2015-03-05 00:00:00	2015-03-19	2015-03-19 00:00:00	32020		\N	125417	0	444814009	40481087		0
10778	639	4112343	1982-09-29	1982-09-29 00:00:00	1982-10-08	1982-10-08 00:00:00	32020		\N	42302	0	195662009	4112343		0
21434	1285	40481087	1958-12-31	1958-12-31 00:00:00	1959-01-21	1959-01-21 00:00:00	32020		\N	85015	0	444814009	40481087		0
11103	655	4116491	1985-12-05	1985-12-05 00:00:00	1986-01-15	1986-01-15 00:00:00	32020		\N	43366	0	301011002	4116491		0
21788	1309	40481087	1980-09-24	1980-09-24 00:00:00	1980-10-15	1980-10-15 00:00:00	32020		\N	86454	0	444814009	40481087		0
11413	675	40481087	1991-01-18	1991-01-18 00:00:00	1991-01-25	1991-01-25 00:00:00	32020		\N	44710	0	444814009	40481087		0
22116	1321	4112343	2018-05-01	2018-05-01 00:00:00	2018-05-14	2018-05-14 00:00:00	32020		\N	87675	0	195662009	4112343		0
11752	693	78272	1959-05-25	1959-05-25 00:00:00	1959-06-08	1959-06-08 00:00:00	32020		\N	45888	0	70704007	78272		0
11925	704	260139	1982-08-03	1982-08-03 00:00:00	1982-08-10	1982-08-10 00:00:00	32020		\N	46582	0	10509002	260139		0
12078	715	40481087	1999-08-18	1999-08-18 00:00:00	1999-09-08	1999-09-08 00:00:00	32020		\N	47304	0	444814009	40481087		0
22759	1358	260139	1969-04-01	1969-04-01 00:00:00	1969-04-15	1969-04-15 00:00:00	32020		\N	90045	0	10509002	260139		0
12373	730	4116491	1978-04-08	1978-04-08 00:00:00	1978-05-27	1978-05-27 00:00:00	32020		\N	48486	0	301011002	4116491		0
12562	743	4283893	2005-01-28	2005-01-28 00:00:00	2005-09-02	2005-09-02 00:00:00	32020		\N	49277	0	36971009	4283893		0
12764	754	375671	1968-02-18	1968-02-18 00:00:00	1968-04-18	1968-04-18 00:00:00	32020		\N	49822	0	62564004	375671		0
12935	760	4059173	1977-06-20	1977-06-20 00:00:00	1977-07-20	1977-07-20 00:00:00	32020		\N	50508	0	16114001	4059173		0
23574	1408	260139	1956-07-25	1956-07-25 00:00:00	1956-08-01	1956-08-01 00:00:00	32020		\N	93641	0	10509002	260139		0
23768	1418	4027663	2006-08-20	2006-08-20 00:00:00	\N	\N	32020		\N	94425	0	13200003	4027663		0
13385	788	81151	1985-09-16	1985-09-16 00:00:00	1985-10-07	1985-10-07 00:00:00	32020		\N	52452	0	44465007	81151		0
24141	1439	260139	1979-07-20	1979-07-20 00:00:00	1979-08-03	1979-08-03 00:00:00	32020		\N	95882	0	10509002	260139		0
24262	1446	78272	2003-10-17	2003-10-17 00:00:00	2003-11-21	2003-11-21 00:00:00	32020		\N	96376	0	70704007	78272		0
13883	820	80180	2004-12-27	2004-12-27 00:00:00	\N	\N	32020		\N	54354	0	396275006	80180		0
14037	829	4112343	1983-04-09	1983-04-09 00:00:00	1983-04-16	1983-04-16 00:00:00	32020		\N	54924	0	195662009	4112343		0
24750	1476	40481087	1958-12-14	1958-12-14 00:00:00	1958-12-28	1958-12-28 00:00:00	32020		\N	98534	0	444814009	40481087		0
14393	851	40481087	1992-10-31	1992-10-31 00:00:00	1992-11-21	1992-11-21 00:00:00	32020		\N	56322	0	444814009	40481087		0
14582	862	4035415	1994-02-24	1994-02-24 00:00:00	1994-03-26	1994-03-26 00:00:00	32020		\N	57053	0	239720000	4035415		0
14721	867	317576	2014-08-12	2014-08-12 00:00:00	\N	\N	32020		\N	57616	0	53741008	317576		0
25418	1513	195588	2007-05-17	2007-05-17 00:00:00	2007-06-17	2007-06-17 00:00:00	32020		\N	101107	0	38822007	195588		0
25568	1520	40481087	2018-11-13	2018-11-13 00:00:00	2018-11-20	2018-11-20 00:00:00	32020		\N	101654	0	444814009	40481087		0
25751	1529	28060	1994-02-21	1994-02-21 00:00:00	1994-02-28	1994-02-28 00:00:00	32020		\N	102359	0	43878008	28060		0
25904	1538	4048171	1932-06-08	1932-06-08 00:00:00	\N	\N	32020		\N	103033	0	232353008	4048171		0
15558	921	40481087	1989-09-26	1989-09-26 00:00:00	1989-10-17	1989-10-17 00:00:00	32020		\N	61328	0	444814009	40481087		0
15759	932	81893	2000-11-13	2000-11-13 00:00:00	\N	\N	32020		\N	62037	0	64766004	81893		0
15865	939	4156265	1966-06-04	1966-06-04 00:00:00	1966-06-18	1966-06-18 00:00:00	32020		\N	62478	0	370247008	4156265		0
16080	951	30753	1985-06-17	1985-06-17 00:00:00	\N	\N	32020		\N	63138	0	16761005	30753		0
26733	1585	4112343	1973-02-25	1973-02-25 00:00:00	1973-03-04	1973-03-04 00:00:00	32020		\N	106273	0	195662009	4112343		0
16389	969	40481087	2013-07-28	2013-07-28 00:00:00	2013-08-04	2013-08-04 00:00:00	32020		\N	64449	0	444814009	40481087		0
16525	975	40481087	1987-02-22	1987-02-22 00:00:00	1987-03-01	1987-03-01 00:00:00	32020		\N	65035	0	444814009	40481087		0
27243	1608	260139	1990-09-17	1990-09-17 00:00:00	1990-09-24	1990-09-24 00:00:00	32020		\N	108002	0	10509002	260139		0
27429	1618	375671	1981-11-30	1981-11-30 00:00:00	1982-01-29	1982-01-29 00:00:00	32020		\N	108785	0	62564004	375671		0
17078	1021	40481087	2016-12-09	2016-12-09 00:00:00	2016-12-30	2016-12-30 00:00:00	32020		\N	67203	0	444814009	40481087		0
27782	1640	260139	1978-08-30	1978-08-30 00:00:00	1978-09-06	1978-09-06 00:00:00	32020		\N	110081	0	10509002	260139		0
27990	1655	260139	1990-11-03	1990-11-03 00:00:00	1990-11-10	1990-11-10 00:00:00	32020		\N	111029	0	10509002	260139		0
17559	1054	40481087	1955-08-12	1955-08-12 00:00:00	1955-09-02	1955-09-02 00:00:00	32020		\N	69145	0	444814009	40481087		0
28221	1666	40481087	1940-01-15	1940-01-15 00:00:00	1940-02-05	1940-02-05 00:00:00	32020		\N	111900	0	444814009	40481087		0
28411	1679	40481087	1981-02-03	1981-02-03 00:00:00	1981-02-17	1981-02-17 00:00:00	32020		\N	112564	0	444814009	40481087		0
18042	1084	260139	1987-10-18	1987-10-18 00:00:00	1987-10-25	1987-10-25 00:00:00	32020		\N	71204	0	10509002	260139		0
18251	1098	4112343	1962-03-10	1962-03-10 00:00:00	1962-03-18	1962-03-18 00:00:00	32020		\N	72033	0	195662009	4112343		0
18339	1102	40481087	1997-01-21	1997-01-21 00:00:00	1997-02-04	1997-02-04 00:00:00	32020		\N	72408	0	444814009	40481087		0
18558	1116	40481087	2016-07-25	2016-07-25 00:00:00	2016-08-01	2016-08-01 00:00:00	32020		\N	73513	0	444814009	40481087		0
18711	1125	4296204	1952-09-11	1952-09-11 00:00:00	1952-10-09	1952-10-09 00:00:00	32020		\N	74135	0	403190006	4296204		0
18890	1136	4112343	2009-02-22	2009-02-22 00:00:00	2009-03-07	2009-03-07 00:00:00	32020		\N	74814	0	195662009	4112343		0
19058	1144	40481087	1993-11-24	1993-11-24 00:00:00	1993-12-15	1993-12-15 00:00:00	32020		\N	75516	0	444814009	40481087		0
19204	1150	4112343	1977-05-15	1977-05-15 00:00:00	1977-05-27	1977-05-27 00:00:00	32020		\N	76066	0	195662009	4112343		0
19405	1162	40481087	1989-01-21	1989-01-21 00:00:00	1989-02-04	1989-02-04 00:00:00	32020		\N	76711	0	444814009	40481087		0
30098	1780	40481087	1997-10-28	1997-10-28 00:00:00	1997-11-11	1997-11-11 00:00:00	32020		\N	119177	0	444814009	40481087		0
30218	1785	4112343	2010-08-17	2010-08-17 00:00:00	2010-08-29	2010-08-29 00:00:00	32020		\N	119614	0	195662009	4112343		0
30428	1794	40481087	1974-05-26	1974-05-26 00:00:00	1974-06-02	1974-06-02 00:00:00	32020		\N	120297	0	444814009	40481087		0
20063	1209	40481087	2004-07-06	2004-07-06 00:00:00	2004-07-27	2004-07-27 00:00:00	32020		\N	79433	0	444814009	40481087		0
20244	1217	81151	1988-10-20	1988-10-20 00:00:00	1988-11-24	1988-11-24 00:00:00	32020		\N	80181	0	44465007	81151		0
20369	1226	4112343	1993-07-28	1993-07-28 00:00:00	1993-08-08	1993-08-08 00:00:00	32020		\N	80712	0	195662009	4112343		0
20576	1236	40481087	1998-04-01	1998-04-01 00:00:00	1998-04-08	1998-04-08 00:00:00	32020		\N	81471	0	444814009	40481087		0
20744	1246	4112343	2007-01-18	2007-01-18 00:00:00	2007-01-28	2007-01-28 00:00:00	32020		\N	82092	0	195662009	4112343		0
20884	1253	4112343	1978-01-20	1978-01-20 00:00:00	1978-01-30	1978-01-30 00:00:00	32020		\N	82507	0	195662009	4112343		0
21020	1261	81151	1973-01-14	1973-01-14 00:00:00	1973-02-04	1973-02-04 00:00:00	32020		\N	83216	0	44465007	81151		0
31728	1879	372328	1963-05-11	1963-05-11 00:00:00	1963-09-14	1963-09-14 00:00:00	32020		\N	125418	0	65363002	372328		0
10779	639	260139	2009-03-11	2009-03-11 00:00:00	2009-03-18	2009-03-18 00:00:00	32020		\N	42245	0	10509002	260139		0
21435	1285	4296205	1989-08-20	1989-08-20 00:00:00	1989-09-10	1989-09-10 00:00:00	32020		\N	84926	0	403191005	4296205		0
11104	655	80180	2003-06-19	2003-06-19 00:00:00	\N	\N	32020		\N	43375	0	396275006	80180		0
21789	1309	4113008	2018-07-25	2018-07-25 00:00:00	2018-08-08	2018-08-08 00:00:00	32020		\N	86445	0	284549007	4113008		0
11414	675	40481087	1991-09-28	1991-09-28 00:00:00	1991-10-12	1991-10-12 00:00:00	32020		\N	44696	0	444814009	40481087		0
22117	1321	4283893	1973-02-08	1973-02-08 00:00:00	1973-04-05	1973-04-05 00:00:00	32020		\N	87659	0	36971009	4283893		0
11753	693	40481087	1989-01-28	1989-01-28 00:00:00	1989-02-18	1989-02-18 00:00:00	32020		\N	45964	0	444814009	40481087		0
11926	704	81151	1985-12-21	1985-12-21 00:00:00	1986-01-11	1986-01-11 00:00:00	32020		\N	46641	0	44465007	81151		0
12079	715	4152936	2008-06-17	2008-06-17 00:00:00	2008-07-01	2008-07-01 00:00:00	32020		\N	47302	0	283385000	4152936		0
22760	1358	40481087	2015-06-16	2015-06-16 00:00:00	2015-06-30	2015-06-30 00:00:00	32020		\N	90091	0	444814009	40481087		0
12374	730	4283893	2006-11-29	2006-11-29 00:00:00	2007-02-07	2007-02-07 00:00:00	32020		\N	48481	0	36971009	4283893		0
12563	743	40481087	2016-12-24	2016-12-24 00:00:00	2016-12-31	2016-12-31 00:00:00	32020		\N	49268	0	444814009	40481087		0
12765	754	40481087	1944-11-04	1944-11-04 00:00:00	1944-11-18	1944-11-18 00:00:00	32020		\N	49949	0	444814009	40481087		0
12936	760	4112343	1999-06-20	1999-06-20 00:00:00	1999-06-30	1999-06-30 00:00:00	32020		\N	50501	0	195662009	4112343		0
23575	1408	4283893	1996-09-09	1996-09-09 00:00:00	1996-10-14	1996-10-14 00:00:00	32020		\N	93632	0	36971009	4283893		0
23769	1418	40481087	2012-09-23	2012-09-23 00:00:00	2012-09-30	2012-09-30 00:00:00	32020		\N	94413	0	444814009	40481087		0
13386	788	372328	1972-01-28	1972-01-28 00:00:00	1972-02-11	1972-02-11 00:00:00	32020		\N	52434	0	65363002	372328		0
24142	1439	260139	1978-03-13	1978-03-13 00:00:00	1978-03-27	1978-03-27 00:00:00	32020		\N	95916	0	10509002	260139		0
24263	1446	80180	2017-08-09	2017-08-09 00:00:00	\N	\N	32020		\N	96396	0	396275006	80180		0
13884	820	40481087	2017-09-21	2017-09-21 00:00:00	2017-09-28	2017-09-28 00:00:00	32020		\N	54361	0	444814009	40481087		0
14038	829	80180	2010-03-30	2010-03-30 00:00:00	\N	\N	32020		\N	54936	0	396275006	80180		0
24751	1476	40481087	2009-10-08	2009-10-08 00:00:00	2009-10-22	2009-10-22 00:00:00	32020		\N	98469	0	444814009	40481087		0
14394	851	372328	1982-05-27	1982-05-27 00:00:00	1982-08-09	1982-08-09 00:00:00	32020		\N	56272	0	65363002	372328		0
14583	862	4283893	1990-08-19	1990-08-19 00:00:00	1990-11-18	1990-11-18 00:00:00	32020		\N	57082	0	36971009	4283893		0
14722	867	4109685	1931-02-18	1931-02-18 00:00:00	1931-03-11	1931-03-11 00:00:00	32020		\N	57579	0	284551006	4109685		0
25436	1516	4149245	1960-08-05	1960-08-05 00:00:00	1960-10-11	1960-10-11 00:00:00	32020		\N	101265	0	30832001	4149245		0
25569	1520	40481087	1984-09-21	1984-09-21 00:00:00	1984-10-05	1984-10-05 00:00:00	32020		\N	101635	0	444814009	40481087		0
25752	1529	78272	1968-06-30	1968-06-30 00:00:00	1968-08-04	1968-08-04 00:00:00	32020		\N	102353	0	70704007	78272		0
25905	1538	313217	2008-05-05	2008-05-05 00:00:00	\N	\N	32020		\N	103050	0	49436004	313217		0
15559	921	81151	1971-01-10	1971-01-10 00:00:00	1971-02-07	1971-02-07 00:00:00	32020		\N	61342	0	44465007	81151		0
15760	932	80180	2002-07-06	2002-07-06 00:00:00	\N	\N	32020		\N	62037	0	396275006	80180		0
15866	939	4113008	1981-03-29	1981-03-29 00:00:00	1981-04-19	1981-04-19 00:00:00	32020		\N	62480	0	284549007	4113008		0
16081	951	80180	1985-10-15	1985-10-15 00:00:00	\N	\N	32020		\N	63138	0	396275006	80180		0
26734	1585	40481087	1930-10-18	1930-10-18 00:00:00	1930-11-01	1930-11-01 00:00:00	32020		\N	106351	0	444814009	40481087		0
16390	969	28060	1979-05-05	1979-05-05 00:00:00	1979-05-18	1979-05-18 00:00:00	32020		\N	64416	0	43878008	28060		0
16526	975	4112343	2004-11-27	2004-11-27 00:00:00	2004-12-04	2004-12-04 00:00:00	32020		\N	65004	0	195662009	4112343		0
27244	1608	4112343	2017-11-02	2017-11-02 00:00:00	2017-11-09	2017-11-09 00:00:00	32020		\N	108048	0	195662009	4112343		0
27430	1618	260139	1986-01-09	1986-01-09 00:00:00	1986-01-23	1986-01-23 00:00:00	32020		\N	108800	0	10509002	260139		0
17079	1021	81151	1976-06-29	1976-06-29 00:00:00	1976-07-20	1976-07-20 00:00:00	32020		\N	67205	0	44465007	81151		0
27783	1640	378419	2013-08-21	2013-08-21 00:00:00	\N	\N	32020		\N	110027	0	26929004	378419		0
27991	1655	40481087	2002-05-13	2002-05-13 00:00:00	2002-05-20	2002-05-20 00:00:00	32020		\N	111007	0	444814009	40481087		0
17560	1054	81893	1971-10-03	1971-10-03 00:00:00	\N	\N	32020		\N	69115	0	64766004	81893		0
28222	1666	4112343	1979-05-13	1979-05-13 00:00:00	1979-05-23	1979-05-23 00:00:00	32020		\N	111913	0	195662009	4112343		0
28412	1679	4112343	1975-06-15	1975-06-15 00:00:00	1975-06-22	1975-06-22 00:00:00	32020		\N	112604	0	195662009	4112343		0
18043	1084	4112343	1990-02-14	1990-02-14 00:00:00	1990-02-26	1990-02-26 00:00:00	32020		\N	71210	0	195662009	4112343		0
18252	1098	40481087	2018-05-19	2018-05-19 00:00:00	2018-06-02	2018-06-02 00:00:00	32020		\N	72044	0	444814009	40481087		0
18340	1102	260139	2005-07-01	2005-07-01 00:00:00	2005-07-08	2005-07-08 00:00:00	32020		\N	72416	0	10509002	260139		0
18559	1116	40481087	1966-05-17	1966-05-17 00:00:00	1966-05-24	1966-05-24 00:00:00	32020		\N	73523	0	444814009	40481087		0
18712	1125	80180	1986-06-30	1986-06-30 00:00:00	\N	\N	32020		\N	74184	0	396275006	80180		0
18891	1136	4112343	1980-12-24	1980-12-24 00:00:00	1980-12-31	1980-12-31 00:00:00	32020		\N	74826	0	195662009	4112343		0
19059	1144	28060	2013-09-13	2013-09-13 00:00:00	2013-09-22	2013-09-22 00:00:00	32020		\N	75501	0	43878008	28060		0
19205	1150	78272	1982-05-24	1982-05-24 00:00:00	1982-06-07	1982-06-07 00:00:00	32020		\N	76062	0	70704007	78272		0
19406	1162	260139	1921-08-24	1921-08-24 00:00:00	1921-09-07	1921-09-07 00:00:00	32020		\N	76703	0	10509002	260139		0
30099	1780	40481087	1999-12-10	1999-12-10 00:00:00	1999-12-31	1999-12-31 00:00:00	32020		\N	119149	0	444814009	40481087		0
30219	1785	40481087	2019-01-23	2019-01-23 00:00:00	2019-02-06	2019-02-06 00:00:00	32020		\N	119615	0	444814009	40481087		0
30429	1794	40481087	2017-05-15	2017-05-15 00:00:00	2017-06-05	2017-06-05 00:00:00	32020		\N	120304	0	444814009	40481087		0
20245	1217	28060	2012-11-21	2012-11-21 00:00:00	2012-12-01	2012-12-01 00:00:00	32020		\N	80139	0	43878008	28060		0
20370	1227	260139	1965-03-07	1965-03-07 00:00:00	1965-03-14	1965-03-14 00:00:00	32020		\N	80749	0	10509002	260139		0
20577	1236	4112343	1921-07-27	1921-07-27 00:00:00	1921-08-05	1921-08-05 00:00:00	32020		\N	81420	0	195662009	4112343		0
20745	1246	4112343	1997-07-31	1997-07-31 00:00:00	1997-08-07	1997-08-07 00:00:00	32020		\N	81990	0	195662009	4112343		0
20885	1253	260139	2000-03-22	2000-03-22 00:00:00	2000-04-05	2000-04-05 00:00:00	32020		\N	82516	0	10509002	260139		0
21021	1261	260139	1989-03-29	1989-03-29 00:00:00	1989-04-12	1989-04-12 00:00:00	32020		\N	83252	0	10509002	260139		0
31729	1879	28060	1968-09-11	1968-09-11 00:00:00	1968-09-23	1968-09-23 00:00:00	32020		\N	125358	0	43878008	28060		0
10780	640	372328	1980-05-15	1980-05-15 00:00:00	1982-05-24	1982-05-24 00:00:00	32020		\N	42356	0	65363002	372328		0
21436	1285	378001	1980-11-05	1980-11-05 00:00:00	1981-01-04	1981-01-04 00:00:00	32020		\N	84925	0	62106007	378001		0
11105	655	4112343	1973-11-07	1973-11-07 00:00:00	1973-11-16	1973-11-16 00:00:00	32020		\N	43412	0	195662009	4112343		0
21790	1309	260139	2012-11-07	2012-11-07 00:00:00	2012-11-14	2012-11-14 00:00:00	32020		\N	86487	0	10509002	260139		0
11415	675	4112343	1959-04-06	1959-04-06 00:00:00	1959-04-17	1959-04-17 00:00:00	32020		\N	44575	0	195662009	4112343		0
22118	1321	4112343	2013-09-27	2013-09-27 00:00:00	2013-10-09	2013-10-09 00:00:00	32020		\N	87613	0	195662009	4112343		0
11754	693	4112343	2007-10-04	2007-10-04 00:00:00	2007-10-13	2007-10-13 00:00:00	32020		\N	45909	0	195662009	4112343		0
11927	704	260139	1978-07-04	1978-07-04 00:00:00	1978-07-18	1978-07-18 00:00:00	32020		\N	46581	0	10509002	260139		0
12080	715	40481087	1991-07-31	1991-07-31 00:00:00	1991-08-21	1991-08-21 00:00:00	32020		\N	47303	0	444814009	40481087		0
22761	1358	378001	1967-03-26	1967-03-26 00:00:00	1967-04-25	1967-04-25 00:00:00	32020		\N	90038	0	62106007	378001		0
12375	730	260139	1962-09-16	1962-09-16 00:00:00	1962-09-30	1962-09-30 00:00:00	32020		\N	48476	0	10509002	260139		0
12564	743	4296205	2004-05-01	2004-05-01 00:00:00	2004-05-15	2004-05-15 00:00:00	32020		\N	49244	0	403191005	4296205		0
12766	754	40481087	1974-12-15	1974-12-15 00:00:00	1974-12-29	1974-12-29 00:00:00	32020		\N	49849	0	444814009	40481087		0
12937	760	260139	2007-06-21	2007-06-21 00:00:00	2007-06-28	2007-06-28 00:00:00	32020		\N	50497	0	10509002	260139		0
23576	1408	28060	1992-11-20	1992-11-20 00:00:00	1992-12-01	1992-12-01 00:00:00	32020		\N	93651	0	43878008	28060		0
23770	1418	257012	2001-08-15	2001-08-15 00:00:00	\N	\N	32020		\N	94457	0	40055000	257012		0
13387	788	4112343	2007-02-22	2007-02-22 00:00:00	2007-03-02	2007-03-02 00:00:00	32020		\N	52408	0	195662009	4112343		0
24143	1439	260139	2003-07-20	2003-07-20 00:00:00	2003-07-27	2003-07-27 00:00:00	32020		\N	95880	0	10509002	260139		0
24264	1446	378001	2005-11-10	2005-11-10 00:00:00	2006-01-09	2006-01-09 00:00:00	32020		\N	96377	0	62106007	378001		0
13885	820	257012	2002-09-23	2002-09-23 00:00:00	\N	\N	32020		\N	54309	0	40055000	257012		0
14039	829	40481087	2005-11-18	2005-11-18 00:00:00	2005-12-02	2005-12-02 00:00:00	32020		\N	54928	0	444814009	40481087		0
24752	1476	40481087	1974-06-24	1974-06-24 00:00:00	1974-07-01	1974-07-01 00:00:00	32020		\N	98329	0	444814009	40481087		0
14395	851	4112343	1999-01-23	1999-01-23 00:00:00	1999-01-30	1999-01-30 00:00:00	32020		\N	56280	0	195662009	4112343		0
14584	863	40481087	1958-05-18	1958-05-18 00:00:00	1958-05-25	1958-05-25 00:00:00	32020		\N	57163	0	444814009	40481087		0
14723	867	4134304	2002-06-10	2002-06-10 00:00:00	2002-09-08	2002-09-08 00:00:00	32020		\N	57583	0	263102004	4134304		0
25437	1516	40481087	1955-08-31	1955-08-31 00:00:00	1955-09-21	1955-09-21 00:00:00	32020		\N	101259	0	444814009	40481087		0
25570	1520	4142905	2010-10-17	2010-10-17 00:00:00	2010-12-16	2010-12-16 00:00:00	32020		\N	101711	0	33737001	4142905		0
25753	1529	40481087	2001-07-26	2001-07-26 00:00:00	2001-08-09	2001-08-09 00:00:00	32020		\N	102309	0	444814009	40481087		0
25906	1538	260139	2010-04-28	2010-04-28 00:00:00	2010-05-05	2010-05-05 00:00:00	32020		\N	103068	0	10509002	260139		0
15560	921	313217	2016-06-21	2016-06-21 00:00:00	\N	\N	32020		\N	61366	0	49436004	313217		0
15761	932	4059173	2017-05-25	2017-05-25 00:00:00	2017-08-23	2017-08-23 00:00:00	32020		\N	62055	0	16114001	4059173		0
15867	939	260139	1989-11-02	1989-11-02 00:00:00	1989-11-09	1989-11-09 00:00:00	32020		\N	62439	0	10509002	260139		0
16082	951	440448	2011-12-20	2011-12-20 00:00:00	\N	\N	32020		\N	63221	0	74400008	440448		0
26735	1585	372328	1930-02-23	1930-02-23 00:00:00	1930-04-06	1930-04-06 00:00:00	32020		\N	106307	0	65363002	372328		0
16391	969	40481087	1984-07-26	1984-07-26 00:00:00	1984-08-09	1984-08-09 00:00:00	32020		\N	64418	0	444814009	40481087		0
16527	975	4112343	2004-02-15	2004-02-15 00:00:00	2004-02-28	2004-02-28 00:00:00	32020		\N	65003	0	195662009	4112343		0
27245	1608	4283893	1961-10-11	1961-10-11 00:00:00	1962-06-27	1962-06-27 00:00:00	32020		\N	108020	0	36971009	4283893		0
27431	1618	40481087	1976-12-05	1976-12-05 00:00:00	1976-12-26	1976-12-26 00:00:00	32020		\N	108799	0	444814009	40481087		0
17080	1021	4294548	1975-01-18	1975-01-18 00:00:00	1975-04-12	1975-04-12 00:00:00	32020		\N	67202	0	75498004	4294548		0
27784	1640	4112343	1968-03-08	1968-03-08 00:00:00	1968-03-18	1968-03-18 00:00:00	32020		\N	110012	0	195662009	4112343		0
27992	1655	40481087	1987-04-07	1987-04-07 00:00:00	1987-04-21	1987-04-21 00:00:00	32020		\N	110991	0	444814009	40481087		0
17561	1054	4310024	1971-01-06	1971-01-06 00:00:00	\N	\N	32020		\N	69115	0	424802006	4310024		0
28223	1666	4218389	1940-02-07	1940-02-07 00:00:00	1940-02-28	1940-02-28 00:00:00	32020		\N	111875	0	39848009	4218389		0
28413	1679	28060	2012-06-30	2012-06-30 00:00:00	2012-07-13	2012-07-13 00:00:00	32020		\N	112592	0	43878008	28060		0
18044	1084	4112343	1996-09-05	1996-09-05 00:00:00	1996-09-17	1996-09-17 00:00:00	32020		\N	71205	0	195662009	4112343		0
18253	1098	372328	1961-03-13	1961-03-13 00:00:00	1961-11-25	1961-11-25 00:00:00	32020		\N	72045	0	65363002	372328		0
18341	1102	80180	2012-05-02	2012-05-02 00:00:00	\N	\N	32020		\N	72402	0	396275006	80180		0
18560	1116	40481087	2003-10-12	2003-10-12 00:00:00	2003-10-26	2003-10-26 00:00:00	32020		\N	73518	0	444814009	40481087		0
18713	1125	81893	1985-04-06	1985-04-06 00:00:00	\N	\N	32020		\N	74184	0	64766004	81893		0
18892	1136	30753	2012-03-25	2012-03-25 00:00:00	\N	\N	32020		\N	74863	0	16761005	30753		0
19060	1144	134438	1991-06-09	1991-06-09 00:00:00	1992-07-03	1992-07-03 00:00:00	32020		\N	75471	0	40275004	134438		0
19206	1150	4112343	1998-04-03	1998-04-03 00:00:00	1998-04-13	1998-04-13 00:00:00	32020		\N	76001	0	195662009	4112343		0
19407	1162	4134304	1993-03-07	1993-03-07 00:00:00	1993-04-06	1993-04-06 00:00:00	32020		\N	76731	0	263102004	4134304		0
30100	1780	4112343	2010-09-28	2010-09-28 00:00:00	2010-10-06	2010-10-06 00:00:00	32020		\N	119156	0	195662009	4112343		0
30220	1785	81151	1958-05-07	1958-05-07 00:00:00	1958-06-11	1958-06-11 00:00:00	32020		\N	119606	0	44465007	81151		0
30430	1794	40481087	1983-12-18	1983-12-18 00:00:00	1983-12-25	1983-12-25 00:00:00	32020		\N	120306	0	444814009	40481087		0
20065	1209	4134304	1984-04-04	1984-04-04 00:00:00	1984-07-03	1984-07-03 00:00:00	32020		\N	79456	0	263102004	4134304		0
20246	1217	40481087	1987-02-19	1987-02-19 00:00:00	1987-03-12	1987-03-12 00:00:00	32020		\N	80136	0	444814009	40481087		0
20371	1227	40481087	2014-05-04	2014-05-04 00:00:00	2014-05-18	2014-05-18 00:00:00	32020		\N	80850	0	444814009	40481087		0
20578	1236	4156265	1938-11-06	1938-11-06 00:00:00	1938-11-20	1938-11-20 00:00:00	32020		\N	81481	0	370247008	4156265		0
20746	1246	30753	1979-01-31	1979-01-31 00:00:00	\N	\N	32020		\N	82146	0	16761005	30753		0
20886	1253	260139	1970-12-16	1970-12-16 00:00:00	1970-12-23	1970-12-23 00:00:00	32020		\N	82561	0	10509002	260139		0
21022	1261	4109685	1972-03-06	1972-03-06 00:00:00	1972-03-20	1972-03-20 00:00:00	32020		\N	83215	0	284551006	4109685		0
31730	1879	80180	1995-10-15	1995-10-15 00:00:00	\N	\N	32020		\N	125376	0	396275006	80180		0
10781	640	40481087	1994-11-07	1994-11-07 00:00:00	1994-11-28	1994-11-28 00:00:00	32020		\N	42377	0	444814009	40481087		0
21437	1285	4112343	1993-02-23	1993-02-23 00:00:00	1993-03-03	1993-03-03 00:00:00	32020		\N	84957	0	195662009	4112343		0
11106	655	78272	1964-06-18	1964-06-18 00:00:00	1964-07-09	1964-07-09 00:00:00	32020		\N	43421	0	70704007	78272		0
21791	1309	40481087	2017-05-03	2017-05-03 00:00:00	2017-05-10	2017-05-10 00:00:00	32020		\N	86456	0	444814009	40481087		0
11416	675	260139	1975-12-16	1975-12-16 00:00:00	1975-12-30	1975-12-30 00:00:00	32020		\N	44577	0	10509002	260139		0
22119	1321	4112343	1966-06-26	1966-06-26 00:00:00	1966-07-04	1966-07-04 00:00:00	32020		\N	87639	0	195662009	4112343		0
11755	693	80180	1995-08-14	1995-08-14 00:00:00	\N	\N	32020		\N	45931	0	396275006	80180		0
11928	704	4027663	1990-12-02	1990-12-02 00:00:00	\N	\N	32020		\N	46589	0	13200003	4027663		0
12081	715	40481087	2000-11-10	2000-11-10 00:00:00	2000-11-17	2000-11-17 00:00:00	32020		\N	47324	0	444814009	40481087		0
22762	1358	4112343	1965-12-21	1965-12-21 00:00:00	1965-12-28	1965-12-28 00:00:00	32020		\N	90068	0	195662009	4112343		0
12376	730	4112343	2012-03-21	2012-03-21 00:00:00	2012-04-01	2012-04-01 00:00:00	32020		\N	48504	0	195662009	4112343		0
12565	743	260139	1983-08-23	1983-08-23 00:00:00	1983-09-06	1983-09-06 00:00:00	32020		\N	49238	0	10509002	260139		0
12767	755	4294548	1965-07-21	1965-07-21 00:00:00	1965-08-04	1965-08-04 00:00:00	32020		\N	50100	0	75498004	4294548		0
12938	760	260139	1966-11-16	1966-11-16 00:00:00	1966-11-23	1966-11-23 00:00:00	32020		\N	50495	0	10509002	260139		0
23577	1408	4237458	1978-05-10	1978-05-10 00:00:00	1978-07-09	1978-07-09 00:00:00	32020		\N	93622	0	58150001	4237458		0
23771	1418	40481087	2004-06-04	2004-06-04 00:00:00	2004-06-11	2004-06-11 00:00:00	32020		\N	94411	0	444814009	40481087		0
13388	788	28060	1970-11-06	1970-11-06 00:00:00	1970-11-16	1970-11-16 00:00:00	32020		\N	52392	0	43878008	28060		0
24144	1439	378001	1986-09-25	1986-09-25 00:00:00	1986-11-24	1986-11-24 00:00:00	32020		\N	95875	0	62106007	378001		0
24265	1446	378001	1992-05-17	1992-05-17 00:00:00	1992-07-16	1992-07-16 00:00:00	32020		\N	96375	0	62106007	378001		0
13886	820	372328	1982-06-17	1982-06-17 00:00:00	1982-07-29	1982-07-29 00:00:00	32020		\N	54363	0	65363002	372328		0
14040	829	4112343	1998-02-14	1998-02-14 00:00:00	1998-02-24	1998-02-24 00:00:00	32020		\N	54927	0	195662009	4112343		0
24753	1476	4051466	1946-09-21	1946-09-21 00:00:00	1963-12-21	1963-12-21 00:00:00	32020		\N	98365	0	233678006	4051466		0
14396	851	40481087	1999-01-24	1999-01-24 00:00:00	1999-01-31	1999-01-31 00:00:00	32020		\N	56295	0	444814009	40481087		0
14585	863	40481087	1982-05-10	1982-05-10 00:00:00	1982-05-31	1982-05-31 00:00:00	32020		\N	57167	0	444814009	40481087		0
14724	867	378419	2012-07-31	2012-07-31 00:00:00	\N	\N	32020		\N	57615	0	26929004	378419		0
25438	1516	40481087	1993-09-19	1993-09-19 00:00:00	1993-10-03	1993-10-03 00:00:00	32020		\N	101278	0	444814009	40481087		0
25571	1520	4283893	1959-12-01	1959-12-01 00:00:00	1960-01-26	1960-01-26 00:00:00	32020		\N	101630	0	36971009	4283893		0
25754	1529	40481087	2018-03-15	2018-03-15 00:00:00	2018-04-05	2018-04-05 00:00:00	32020		\N	102310	0	444814009	40481087		0
25907	1538	40481087	1948-09-21	1948-09-21 00:00:00	1948-10-05	1948-10-05 00:00:00	32020		\N	102952	0	444814009	40481087		0
15561	921	40481087	1974-02-14	1974-02-14 00:00:00	1974-02-21	1974-02-21 00:00:00	32020		\N	61373	0	444814009	40481087		0
15762	932	40481087	1977-02-18	1977-02-18 00:00:00	1977-03-11	1977-03-11 00:00:00	32020		\N	62013	0	444814009	40481087		0
15868	939	4152936	1986-06-22	1986-06-22 00:00:00	1986-07-06	1986-07-06 00:00:00	32020		\N	62481	0	283385000	4152936		0
16083	951	40481087	2008-09-25	2008-09-25 00:00:00	2008-10-16	2008-10-16 00:00:00	32020		\N	63213	0	444814009	40481087		0
26736	1585	260139	1959-10-20	1959-10-20 00:00:00	1959-11-03	1959-11-03 00:00:00	32020		\N	106270	0	10509002	260139		0
16392	970	4112343	2001-12-26	2001-12-26 00:00:00	2002-01-02	2002-01-02 00:00:00	32020		\N	64526	0	195662009	4112343		0
16528	975	28060	1967-10-03	1967-10-03 00:00:00	1967-10-16	1967-10-16 00:00:00	32020		\N	65029	0	43878008	28060		0
27246	1608	260139	1952-03-01	1952-03-01 00:00:00	1952-03-08	1952-03-08 00:00:00	32020		\N	107973	0	10509002	260139		0
27432	1618	4112343	1978-06-21	1978-06-21 00:00:00	1978-07-03	1978-07-03 00:00:00	32020		\N	108822	0	195662009	4112343		0
17081	1021	81151	1962-07-22	1962-07-22 00:00:00	1962-08-12	1962-08-12 00:00:00	32020		\N	67204	0	44465007	81151		0
27785	1640	260139	1989-03-18	1989-03-18 00:00:00	1989-04-01	1989-04-01 00:00:00	32020		\N	110083	0	10509002	260139		0
27993	1655	4112343	1992-09-16	1992-09-16 00:00:00	1992-09-28	1992-09-28 00:00:00	32020		\N	110993	0	195662009	4112343		0
17562	1054	81151	1973-04-29	1973-04-29 00:00:00	1973-05-13	1973-05-13 00:00:00	32020		\N	69132	0	44465007	81151		0
28224	1666	372328	1935-06-03	1935-06-03 00:00:00	1935-09-14	1935-09-14 00:00:00	32020		\N	111935	0	65363002	372328		0
28414	1679	4112343	1991-10-10	1991-10-10 00:00:00	1991-10-19	1991-10-19 00:00:00	32020		\N	112599	0	195662009	4112343		0
18045	1084	4237458	1982-12-11	1982-12-11 00:00:00	1983-02-09	1983-02-09 00:00:00	32020		\N	71208	0	58150001	4237458		0
18254	1098	4112343	2013-02-21	2013-02-21 00:00:00	2013-03-04	2013-03-04 00:00:00	32020		\N	72085	0	195662009	4112343		0
18342	1102	4112343	2014-10-17	2014-10-17 00:00:00	2014-10-30	2014-10-30 00:00:00	32020		\N	72409	0	195662009	4112343		0
18561	1116	40481087	2004-08-29	2004-08-29 00:00:00	2004-09-19	2004-09-19 00:00:00	32020		\N	73519	0	444814009	40481087		0
18714	1125	30753	1985-12-02	1985-12-02 00:00:00	\N	\N	32020		\N	74184	0	16761005	30753		0
18893	1136	80180	2013-01-19	2013-01-19 00:00:00	\N	\N	32020		\N	74863	0	396275006	80180		0
19061	1144	260139	2013-10-16	2013-10-16 00:00:00	2013-10-30	2013-10-30 00:00:00	32020		\N	75473	0	10509002	260139		0
19207	1150	4112343	1988-01-04	1988-01-04 00:00:00	1988-01-11	1988-01-11 00:00:00	32020		\N	76004	0	195662009	4112343		0
19408	1162	40481087	1962-05-07	1962-05-07 00:00:00	1962-05-21	1962-05-21 00:00:00	32020		\N	76677	0	444814009	40481087		0
30101	1780	372328	1982-04-01	1982-04-01 00:00:00	1983-03-01	1983-03-01 00:00:00	32020		\N	119097	0	65363002	372328		0
30221	1785	4112343	1958-06-18	1958-06-18 00:00:00	1958-06-26	1958-06-26 00:00:00	32020		\N	119579	0	195662009	4112343		0
30431	1794	40481087	1984-12-26	1984-12-26 00:00:00	1985-01-02	1985-01-02 00:00:00	32020		\N	120330	0	444814009	40481087		0
20066	1209	257012	1985-07-02	1985-07-02 00:00:00	\N	\N	32020		\N	79441	0	40055000	257012		0
20247	1217	40481087	1990-10-30	1990-10-30 00:00:00	1990-11-06	1990-11-06 00:00:00	32020		\N	80155	0	444814009	40481087		0
20372	1227	4112343	2013-02-19	2013-02-19 00:00:00	2013-02-28	2013-02-28 00:00:00	32020		\N	80806	0	195662009	4112343		0
20579	1236	260139	1979-01-23	1979-01-23 00:00:00	1979-01-30	1979-01-30 00:00:00	32020		\N	81464	0	10509002	260139		0
20747	1246	4266809	1980-08-23	1980-08-23 00:00:00	\N	\N	32020		\N	82146	0	397881000	4266809		0
20887	1253	260139	2017-01-28	2017-01-28 00:00:00	2017-02-04	2017-02-04 00:00:00	32020		\N	82512	0	10509002	260139		0
21023	1261	40481087	1971-05-19	1971-05-19 00:00:00	1971-06-02	1971-06-02 00:00:00	32020		\N	83219	0	444814009	40481087		0
31731	1879	78272	1982-01-01	1982-01-01 00:00:00	1982-01-29	1982-01-29 00:00:00	32020		\N	125367	0	70704007	78272		0
10782	640	40481087	2009-01-17	2009-01-17 00:00:00	2009-02-07	2009-02-07 00:00:00	32020		\N	42344	0	444814009	40481087		0
21438	1285	260139	2014-03-08	2014-03-08 00:00:00	2014-03-22	2014-03-22 00:00:00	32020		\N	84977	0	10509002	260139		0
11107	655	81151	1999-06-06	1999-06-06 00:00:00	1999-07-04	1999-07-04 00:00:00	32020		\N	43422	0	44465007	81151		0
21792	1309	80180	1995-03-09	1995-03-09 00:00:00	\N	\N	32020		\N	86466	0	396275006	80180		0
11417	675	4112343	1968-01-31	1968-01-31 00:00:00	1968-02-08	1968-02-08 00:00:00	32020		\N	44688	0	195662009	4112343		0
22120	1321	80180	2002-02-06	2002-02-06 00:00:00	\N	\N	32020		\N	87601	0	396275006	80180		0
11756	693	40481087	2018-05-29	2018-05-29 00:00:00	2018-06-05	2018-06-05 00:00:00	32020		\N	45949	0	444814009	40481087		0
11929	704	4294548	1967-11-04	1967-11-04 00:00:00	1968-03-16	1968-03-16 00:00:00	32020		\N	46513	0	75498004	4294548		0
12082	715	372328	1986-06-29	1986-06-29 00:00:00	1986-07-22	1986-07-22 00:00:00	32020		\N	47335	0	65363002	372328		0
22763	1358	260139	1987-03-04	1987-03-04 00:00:00	1987-03-18	1987-03-18 00:00:00	32020		\N	90049	0	10509002	260139		0
12377	730	28060	1973-12-18	1973-12-18 00:00:00	1973-12-28	1973-12-28 00:00:00	32020		\N	48457	0	43878008	28060		0
12566	743	4283893	1983-10-09	1983-10-09 00:00:00	1983-12-18	1983-12-18 00:00:00	32020		\N	49289	0	36971009	4283893		0
12768	755	4112343	1981-08-18	1981-08-18 00:00:00	1981-08-28	1981-08-28 00:00:00	32020		\N	50046	0	195662009	4112343		0
12939	760	40481087	1992-03-14	1992-03-14 00:00:00	1992-03-28	1992-03-28 00:00:00	32020		\N	50500	0	444814009	40481087		0
23578	1408	4283893	1982-07-18	1982-07-18 00:00:00	1982-11-07	1982-11-07 00:00:00	32020		\N	93642	0	36971009	4283893		0
23772	1418	40481087	1979-05-31	1979-05-31 00:00:00	1979-06-07	1979-06-07 00:00:00	32020		\N	94423	0	444814009	40481087		0
13389	788	40481087	1972-11-29	1972-11-29 00:00:00	1972-12-06	1972-12-06 00:00:00	32020		\N	52456	0	444814009	40481087		0
24151	1441	4294548	1993-09-25	1993-09-25 00:00:00	1993-11-06	1993-11-06 00:00:00	32020		\N	96022	0	75498004	4294548		0
24266	1446	4152936	2008-09-25	2008-09-25 00:00:00	2008-10-16	2008-10-16 00:00:00	32020		\N	96378	0	283385000	4152936		0
13887	821	260139	1967-02-22	1967-02-22 00:00:00	1967-03-08	1967-03-08 00:00:00	32020		\N	54397	0	10509002	260139		0
14041	829	4059173	2012-03-29	2012-03-29 00:00:00	2012-05-28	2012-05-28 00:00:00	32020		\N	54896	0	16114001	4059173		0
24754	1476	40481087	1970-12-29	1970-12-29 00:00:00	1971-01-05	1971-01-05 00:00:00	32020		\N	98351	0	444814009	40481087		0
14397	851	4109685	1992-10-01	1992-10-01 00:00:00	1992-10-22	1992-10-22 00:00:00	32020		\N	56291	0	284551006	4109685		0
14586	863	372328	1923-01-24	1923-01-24 00:00:00	1923-07-26	1923-07-26 00:00:00	32020		\N	57145	0	65363002	372328		0
14735	869	40481087	1971-04-03	1971-04-03 00:00:00	1971-04-10	1971-04-10 00:00:00	32020		\N	57751	0	444814009	40481087		0
25440	1516	257012	1949-08-20	1949-08-20 00:00:00	\N	\N	32020		\N	101273	0	40055000	257012		0
25572	1520	257012	1960-01-05	1960-01-05 00:00:00	\N	\N	32020		\N	101623	0	40055000	257012		0
25755	1529	372328	1978-10-23	1978-10-23 00:00:00	1979-08-20	1979-08-20 00:00:00	32020		\N	102311	0	65363002	372328		0
25908	1538	4294548	1945-05-21	1945-05-21 00:00:00	1945-07-30	1945-07-30 00:00:00	32020		\N	102972	0	75498004	4294548		0
15562	921	260139	2004-02-04	2004-02-04 00:00:00	2004-02-18	2004-02-18 00:00:00	32020		\N	61375	0	10509002	260139		0
15763	932	4237458	1971-01-15	1971-01-15 00:00:00	1971-02-14	1971-02-14 00:00:00	32020		\N	62026	0	58150001	4237458		0
15869	939	80180	2005-03-26	2005-03-26 00:00:00	\N	\N	32020		\N	62468	0	396275006	80180		0
16084	951	40481087	1979-01-09	1979-01-09 00:00:00	1979-01-23	1979-01-23 00:00:00	32020		\N	63224	0	444814009	40481087		0
26737	1585	4109685	1950-10-06	1950-10-06 00:00:00	1950-10-27	1950-10-27 00:00:00	32020		\N	106346	0	284551006	4109685		0
16393	970	40481087	2000-03-03	2000-03-03 00:00:00	2000-03-10	2000-03-10 00:00:00	32020		\N	64522	0	444814009	40481087		0
16529	975	40479768	1979-12-11	1979-12-11 00:00:00	1980-01-17	1980-01-17 00:00:00	32020		\N	65022	0	444470001	40479768		0
27247	1608	4112343	1987-05-06	1987-05-06 00:00:00	1987-05-16	1987-05-16 00:00:00	32020		\N	108001	0	195662009	4112343		0
27433	1618	260139	1992-12-21	1992-12-21 00:00:00	1993-01-04	1993-01-04 00:00:00	32020		\N	108827	0	10509002	260139		0
17082	1021	81151	1992-09-24	1992-09-24 00:00:00	1992-10-15	1992-10-15 00:00:00	32020		\N	67206	0	44465007	81151		0
27786	1640	28060	2005-03-24	2005-03-24 00:00:00	2005-04-06	2005-04-06 00:00:00	32020		\N	110103	0	43878008	28060		0
27994	1655	4112343	1974-04-28	1974-04-28 00:00:00	1974-05-11	1974-05-11 00:00:00	32020		\N	111005	0	195662009	4112343		0
17589	1057	40481087	1968-10-18	1968-10-18 00:00:00	1968-11-01	1968-11-01 00:00:00	32020		\N	69272	0	444814009	40481087		0
28225	1666	28060	1994-06-07	1994-06-07 00:00:00	1994-06-17	1994-06-17 00:00:00	32020		\N	111945	0	43878008	28060		0
28415	1679	4112343	1989-06-12	1989-06-12 00:00:00	1989-06-19	1989-06-19 00:00:00	32020		\N	112590	0	195662009	4112343		0
18046	1084	192671	2016-08-25	2016-08-25 00:00:00	\N	\N	32020		\N	71241	0	K92.2	35208414		0
18255	1098	80180	1996-09-10	1996-09-10 00:00:00	\N	\N	32020		\N	72035	0	396275006	80180		0
18343	1102	4112343	1986-11-14	1986-11-14 00:00:00	1986-11-27	1986-11-27 00:00:00	32020		\N	72387	0	195662009	4112343		0
18562	1116	40481087	2010-07-28	2010-07-28 00:00:00	2010-08-18	2010-08-18 00:00:00	32020		\N	73520	0	444814009	40481087		0
18715	1125	4266809	1986-06-30	1986-06-30 00:00:00	\N	\N	32020		\N	74184	0	397881000	4266809		0
18894	1136	4285898	2012-09-21	2012-09-21 00:00:00	\N	\N	32020		\N	74863	0	68496003	4285898		0
19062	1144	260139	1981-06-10	1981-06-10 00:00:00	1981-06-17	1981-06-17 00:00:00	32020		\N	75518	0	10509002	260139		0
19208	1150	40481087	1998-06-20	1998-06-20 00:00:00	1998-07-11	1998-07-11 00:00:00	32020		\N	76005	0	444814009	40481087		0
19409	1162	260139	1933-09-13	1933-09-13 00:00:00	1933-09-20	1933-09-20 00:00:00	32020		\N	76695	0	10509002	260139		0
30102	1780	260139	1974-08-28	1974-08-28 00:00:00	1974-09-04	1974-09-04 00:00:00	32020		\N	119168	0	10509002	260139		0
30222	1785	372328	2016-01-12	2016-01-12 00:00:00	2016-09-26	2016-09-26 00:00:00	32020		\N	119641	0	65363002	372328		0
30432	1794	4109685	2005-03-21	2005-03-21 00:00:00	2005-04-04	2005-04-04 00:00:00	32020		\N	120329	0	284551006	4109685		0
20067	1209	378001	2001-09-02	2001-09-02 00:00:00	2001-10-02	2001-10-02 00:00:00	32020		\N	79457	0	62106007	378001		0
20248	1217	4283893	2012-10-19	2012-10-19 00:00:00	2013-01-04	2013-01-04 00:00:00	32020		\N	80168	0	36971009	4283893		0
20373	1227	80180	1980-05-31	1980-05-31 00:00:00	\N	\N	32020		\N	80727	0	396275006	80180		0
20580	1236	4296205	1932-01-28	1932-01-28 00:00:00	1932-02-11	1932-02-11 00:00:00	32020		\N	81382	0	403191005	4296205		0
20748	1246	81893	1979-01-01	1979-01-01 00:00:00	\N	\N	32020		\N	82146	0	64766004	81893		0
31376	1854	192671	2012-05-19	2012-05-19 00:00:00	\N	\N	32020		\N	124120	0	K92.2	35208414		0
21024	1261	4112343	1973-06-01	1973-06-01 00:00:00	1973-06-10	1973-06-10 00:00:00	32020		\N	83246	0	195662009	4112343		0
31732	1879	4294548	1987-01-01	1987-01-01 00:00:00	1987-03-12	1987-03-12 00:00:00	32020		\N	125360	0	75498004	4294548		0
10783	640	40481087	1992-02-22	1992-02-22 00:00:00	1992-03-14	1992-03-14 00:00:00	32020		\N	42352	0	444814009	40481087		0
21439	1285	40481087	2016-10-08	2016-10-08 00:00:00	2016-10-29	2016-10-29 00:00:00	32020		\N	84978	0	444814009	40481087		0
11108	655	40481087	2014-08-14	2014-08-14 00:00:00	2014-09-04	2014-09-04 00:00:00	32020		\N	43414	0	444814009	40481087		0
21793	1309	260139	1957-02-18	1957-02-18 00:00:00	1957-03-04	1957-03-04 00:00:00	32020		\N	86452	0	10509002	260139		0
11418	675	372328	1951-04-19	1951-04-19 00:00:00	1951-08-21	1951-08-21 00:00:00	32020		\N	44632	0	65363002	372328		0
22121	1321	78272	2000-11-10	2000-11-10 00:00:00	2000-12-15	2000-12-15 00:00:00	32020		\N	87601	0	70704007	78272		0
11757	693	81151	1955-01-11	1955-01-11 00:00:00	1955-02-15	1955-02-15 00:00:00	32020		\N	45887	0	44465007	81151		0
11930	704	78272	1977-06-08	1977-06-08 00:00:00	1977-07-06	1977-07-06 00:00:00	32020		\N	46512	0	70704007	78272		0
12083	715	40481087	2015-07-31	2015-07-31 00:00:00	2015-08-21	2015-08-21 00:00:00	32020		\N	47326	0	444814009	40481087		0
22764	1358	28060	1968-09-15	1968-09-15 00:00:00	1968-09-24	1968-09-24 00:00:00	32020		\N	90069	0	43878008	28060		0
12378	730	260139	2013-08-10	2013-08-10 00:00:00	2013-08-24	2013-08-24 00:00:00	32020		\N	48494	0	10509002	260139		0
12567	743	40481087	2016-01-13	2016-01-13 00:00:00	2016-01-20	2016-01-20 00:00:00	32020		\N	49281	0	444814009	40481087		0
12769	755	40481087	2015-02-17	2015-02-17 00:00:00	2015-03-03	2015-03-03 00:00:00	32020		\N	50043	0	444814009	40481087		0
12940	760	4296204	1979-05-11	1979-05-11 00:00:00	1979-05-25	1979-05-25 00:00:00	32020		\N	50509	0	403190006	4296204		0
23579	1409	260139	1931-10-14	1931-10-14 00:00:00	1931-10-28	1931-10-28 00:00:00	32020		\N	93817	0	10509002	260139		0
23773	1418	80180	2014-08-08	2014-08-08 00:00:00	\N	\N	32020		\N	94414	0	396275006	80180		0
13390	788	260139	1998-11-08	1998-11-08 00:00:00	1998-11-22	1998-11-22 00:00:00	32020		\N	52395	0	10509002	260139		0
24152	1441	4112343	2004-02-14	2004-02-14 00:00:00	2004-02-27	2004-02-27 00:00:00	32020		\N	95965	0	195662009	4112343		0
24267	1446	40481087	1992-11-19	1992-11-19 00:00:00	1992-12-03	1992-12-03 00:00:00	32020		\N	96390	0	444814009	40481087		0
13888	821	4112343	1968-12-07	1968-12-07 00:00:00	1968-12-18	1968-12-18 00:00:00	32020		\N	54429	0	195662009	4112343		0
14042	829	378001	1992-12-09	1992-12-09 00:00:00	1993-01-08	1993-01-08 00:00:00	32020		\N	54907	0	62106007	378001		0
24755	1476	40481087	1948-06-30	1948-06-30 00:00:00	1948-07-07	1948-07-07 00:00:00	32020		\N	98425	0	444814009	40481087		0
14398	851	81893	2014-07-18	2014-07-18 00:00:00	\N	\N	32020		\N	56289	0	64766004	81893		0
14587	863	81151	2003-05-09	2003-05-09 00:00:00	2003-06-13	2003-06-13 00:00:00	32020		\N	57180	0	44465007	81151		0
14736	869	4112343	1984-09-24	1984-09-24 00:00:00	1984-10-04	1984-10-04 00:00:00	32020		\N	57752	0	195662009	4112343		0
25441	1516	40481087	1972-12-14	1972-12-14 00:00:00	1972-12-21	1972-12-21 00:00:00	32020		\N	101294	0	444814009	40481087		0
25573	1520	260139	1963-05-04	1963-05-04 00:00:00	1963-05-11	1963-05-11 00:00:00	32020		\N	101632	0	10509002	260139		0
25756	1529	28060	1968-05-03	1968-05-03 00:00:00	1968-05-12	1968-05-12 00:00:00	32020		\N	102360	0	43878008	28060		0
25909	1538	381316	2016-09-19	2016-09-19 00:00:00	\N	\N	32020		\N	103052	0	230690007	381316		0
15563	921	80180	2004-04-02	2004-04-02 00:00:00	\N	\N	32020		\N	61375	0	396275006	80180		0
15764	932	4112343	2003-05-29	2003-05-29 00:00:00	2003-06-09	2003-06-09 00:00:00	32020		\N	62014	0	195662009	4112343		0
15870	939	4112343	2004-02-08	2004-02-08 00:00:00	2004-02-18	2004-02-18 00:00:00	32020		\N	62468	0	195662009	4112343		0
16085	951	4112343	1970-10-10	1970-10-10 00:00:00	1970-10-20	1970-10-20 00:00:00	32020		\N	63209	0	195662009	4112343		0
26738	1585	40481087	1952-08-21	1952-08-21 00:00:00	1952-08-28	1952-08-28 00:00:00	32020		\N	106268	0	444814009	40481087		0
16394	970	4112343	2016-05-01	2016-05-01 00:00:00	2016-05-09	2016-05-09 00:00:00	32020		\N	64528	0	195662009	4112343		0
16530	975	4278672	1972-01-08	1972-01-08 00:00:00	1972-02-07	1972-02-07 00:00:00	32020		\N	65030	0	65966004	4278672		0
27248	1608	40481087	1999-02-21	1999-02-21 00:00:00	1999-03-14	1999-03-14 00:00:00	32020		\N	108025	0	444814009	40481087		0
27434	1618	4112343	1984-06-04	1984-06-04 00:00:00	1984-06-13	1984-06-13 00:00:00	32020		\N	108775	0	195662009	4112343		0
17083	1021	81151	1993-09-10	1993-09-10 00:00:00	1993-10-15	1993-10-15 00:00:00	32020		\N	67207	0	44465007	81151		0
27787	1640	381316	2015-06-10	2015-06-10 00:00:00	\N	\N	32020		\N	110067	0	230690007	381316		0
27995	1655	317009	2004-09-29	2004-09-29 00:00:00	\N	\N	32020		\N	110995	0	195967001	317009		0
17590	1057	4112343	2002-03-31	2002-03-31 00:00:00	2002-04-08	2002-04-08 00:00:00	32020		\N	69309	0	195662009	4112343		0
28226	1666	40481087	2007-03-30	2007-03-30 00:00:00	2007-04-06	2007-04-06 00:00:00	32020		\N	111934	0	444814009	40481087		0
28416	1679	372328	1971-10-20	1971-10-20 00:00:00	1972-03-07	1972-03-07 00:00:00	32020		\N	112600	0	65363002	372328		0
18047	1084	260139	2010-12-04	2010-12-04 00:00:00	2010-12-18	2010-12-18 00:00:00	32020		\N	71191	0	10509002	260139		0
18256	1098	4112343	1995-07-21	1995-07-21 00:00:00	1995-08-03	1995-08-03 00:00:00	32020		\N	72035	0	195662009	4112343		0
18344	1102	4280726	1970-01-30	1970-01-30 00:00:00	1986-01-28	1986-01-28 00:00:00	32020		\N	72442	0	367498001	4280726		0
18563	1116	28060	1972-12-04	1972-12-04 00:00:00	1972-12-16	1972-12-16 00:00:00	32020		\N	73549	0	43878008	28060		0
18716	1125	40481087	1968-10-21	1968-10-21 00:00:00	1968-11-04	1968-11-04 00:00:00	32020		\N	74189	0	444814009	40481087		0
18895	1136	4230399	2013-02-03	2013-02-03 00:00:00	2013-05-04	2013-05-04 00:00:00	32020		\N	74824	0	359817006	4230399		0
19063	1144	260139	1992-10-15	1992-10-15 00:00:00	1992-10-29	1992-10-29 00:00:00	32020		\N	75515	0	10509002	260139		0
19209	1150	40481087	2006-01-09	2006-01-09 00:00:00	2006-01-23	2006-01-23 00:00:00	32020		\N	76076	0	444814009	40481087		0
19410	1162	40481087	1968-05-27	1968-05-27 00:00:00	1968-06-10	1968-06-10 00:00:00	32020		\N	76706	0	444814009	40481087		0
30103	1780	260139	1981-02-01	1981-02-01 00:00:00	1981-02-15	1981-02-15 00:00:00	32020		\N	119171	0	10509002	260139		0
30223	1785	81151	1962-06-20	1962-06-20 00:00:00	1962-07-25	1962-07-25 00:00:00	32020		\N	119608	0	44465007	81151		0
30433	1794	372328	1960-11-28	1960-11-28 00:00:00	1961-01-14	1961-01-14 00:00:00	32020		\N	120305	0	65363002	372328		0
20068	1209	372328	1978-07-16	1978-07-16 00:00:00	1978-08-17	1978-08-17 00:00:00	32020		\N	79424	0	65363002	372328		0
20249	1217	372328	1973-09-09	1973-09-09 00:00:00	1973-12-21	1973-12-21 00:00:00	32020		\N	80162	0	65363002	372328		0
20374	1227	260139	1949-12-22	1949-12-22 00:00:00	1950-01-05	1950-01-05 00:00:00	32020		\N	80802	0	10509002	260139		0
20581	1236	40479422	1939-10-16	1939-10-16 00:00:00	1939-11-22	1939-11-22 00:00:00	32020		\N	81482	0	444448004	40479422		0
20749	1246	80180	1980-08-23	1980-08-23 00:00:00	\N	\N	32020		\N	82146	0	396275006	80180		0
31377	1854	260139	1973-06-21	1973-06-21 00:00:00	1973-07-05	1973-07-05 00:00:00	32020		\N	124074	0	10509002	260139		0
21025	1261	195588	2012-05-05	2012-05-05 00:00:00	2012-06-06	2012-06-06 00:00:00	32020		\N	83237	0	38822007	195588		0
31733	1879	40481087	1970-03-10	1970-03-10 00:00:00	1970-03-24	1970-03-24 00:00:00	32020		\N	125413	0	444814009	40481087		0
10784	640	260139	1973-05-07	1973-05-07 00:00:00	1973-05-14	1973-05-14 00:00:00	32020		\N	42342	0	10509002	260139		0
21440	1285	40481087	2008-11-30	2008-11-30 00:00:00	2008-12-14	2008-12-14 00:00:00	32020		\N	85052	0	444814009	40481087		0
11109	655	40481087	1972-10-10	1972-10-10 00:00:00	1972-10-31	1972-10-31 00:00:00	32020		\N	43399	0	444814009	40481087		0
21794	1309	4112343	1998-07-26	1998-07-26 00:00:00	1998-08-02	1998-08-02 00:00:00	32020		\N	86461	0	195662009	4112343		0
11419	675	4294548	1953-04-29	1953-04-29 00:00:00	1953-06-10	1953-06-10 00:00:00	32020		\N	44713	0	75498004	4294548		0
22122	1321	4266809	2002-02-06	2002-02-06 00:00:00	\N	\N	32020		\N	87601	0	397881000	4266809		0
11758	693	375671	1988-07-03	1988-07-03 00:00:00	1988-08-02	1988-08-02 00:00:00	32020		\N	45893	0	62564004	375671		0
11931	704	257012	1968-02-17	1968-02-17 00:00:00	\N	\N	32020		\N	46533	0	40055000	257012		0
12084	715	80180	2017-06-26	2017-06-26 00:00:00	\N	\N	32020		\N	47326	0	396275006	80180		0
22765	1358	372328	1959-09-20	1959-09-20 00:00:00	1960-07-14	1960-07-14 00:00:00	32020		\N	90098	0	65363002	372328		0
12379	730	372328	1958-10-05	1958-10-05 00:00:00	1959-03-21	1959-03-21 00:00:00	32020		\N	48468	0	65363002	372328		0
12568	743	4112343	2015-03-01	2015-03-01 00:00:00	2015-03-10	2015-03-10 00:00:00	32020		\N	49280	0	195662009	4112343		0
12770	755	260139	1979-12-15	1979-12-15 00:00:00	1979-12-22	1979-12-22 00:00:00	32020		\N	50063	0	10509002	260139		0
12941	760	80180	1998-01-01	1998-01-01 00:00:00	\N	\N	32020		\N	50480	0	396275006	80180		0
23580	1409	260139	2006-03-11	2006-03-11 00:00:00	2006-03-27	2006-03-27 00:00:00	32020		\N	93701	0	10509002	260139		0
23774	1418	4285898	2014-03-11	2014-03-11 00:00:00	\N	\N	32020		\N	94414	0	68496003	4285898		0
13391	788	40481087	1998-12-17	1998-12-17 00:00:00	1998-12-24	1998-12-24 00:00:00	32020		\N	52396	0	444814009	40481087		0
24153	1441	40481087	2017-01-06	2017-01-06 00:00:00	2017-01-13	2017-01-13 00:00:00	32020		\N	96058	0	444814009	40481087		0
24268	1446	372328	1984-03-30	1984-03-30 00:00:00	1984-07-10	1984-07-10 00:00:00	32020		\N	96379	0	65363002	372328		0
13889	821	260139	1953-07-18	1953-07-18 00:00:00	1953-07-25	1953-07-25 00:00:00	32020		\N	54377	0	10509002	260139		0
14043	829	260139	1977-01-28	1977-01-28 00:00:00	1977-02-04	1977-02-04 00:00:00	32020		\N	54923	0	10509002	260139		0
24756	1476	40481087	1967-09-02	1967-09-02 00:00:00	1967-09-09	1967-09-09 00:00:00	32020		\N	98326	0	444814009	40481087		0
14399	851	4112343	1995-04-30	1995-04-30 00:00:00	1995-05-11	1995-05-11 00:00:00	32020		\N	56270	0	195662009	4112343		0
14588	863	40481087	1938-07-10	1938-07-10 00:00:00	1938-07-24	1938-07-24 00:00:00	32020		\N	57161	0	444814009	40481087		0
14737	869	260139	1998-08-10	1998-08-10 00:00:00	1998-08-17	1998-08-17 00:00:00	32020		\N	57812	0	10509002	260139		0
25442	1516	80502	1998-03-02	1998-03-02 00:00:00	\N	\N	32020		\N	101252	0	64859006	80502		0
25574	1520	4112343	1941-11-02	1941-11-02 00:00:00	1941-11-13	1941-11-13 00:00:00	32020		\N	101622	0	195662009	4112343		0
25757	1529	81151	2013-04-15	2013-04-15 00:00:00	2013-05-20	2013-05-20 00:00:00	32020		\N	102356	0	44465007	81151		0
25910	1538	260139	1960-05-18	1960-05-18 00:00:00	1960-05-25	1960-05-25 00:00:00	32020		\N	103055	0	10509002	260139		0
15564	921	4296204	1972-03-03	1972-03-03 00:00:00	1972-03-31	1972-03-31 00:00:00	32020		\N	61343	0	403190006	4296204		0
15765	932	4294548	1997-11-07	1997-11-07 00:00:00	1998-01-09	1998-01-09 00:00:00	32020		\N	62006	0	75498004	4294548		0
15872	939	260139	2014-09-13	2014-09-13 00:00:00	2014-09-20	2014-09-20 00:00:00	32020		\N	62443	0	10509002	260139		0
16086	951	40481087	1978-01-29	1978-01-29 00:00:00	1978-02-05	1978-02-05 00:00:00	32020		\N	63137	0	444814009	40481087		0
26739	1585	4296205	1959-12-09	1959-12-09 00:00:00	1959-12-23	1959-12-23 00:00:00	32020		\N	106347	0	403191005	4296205		0
16395	970	28060	1960-07-25	1960-07-25 00:00:00	1960-08-03	1960-08-03 00:00:00	32020		\N	64487	0	43878008	28060		0
16531	975	40481087	2017-10-09	2017-10-09 00:00:00	2017-10-30	2017-10-30 00:00:00	32020		\N	65054	0	444814009	40481087		0
27249	1608	80180	1977-06-25	1977-06-25 00:00:00	\N	\N	32020		\N	107990	0	396275006	80180		0
27435	1618	30753	2011-10-29	2011-10-29 00:00:00	\N	\N	32020		\N	108782	0	16761005	30753		0
17084	1022	40481087	2004-04-30	2004-04-30 00:00:00	2004-05-07	2004-05-07 00:00:00	32020		\N	67231	0	444814009	40481087		0
27788	1640	4113008	1992-03-17	1992-03-17 00:00:00	1992-03-31	1992-03-31 00:00:00	32020		\N	110030	0	284549007	4113008		0
27996	1655	4112343	2000-10-19	2000-10-19 00:00:00	2000-10-29	2000-10-29 00:00:00	32020		\N	110984	0	195662009	4112343		0
17591	1057	260139	1985-09-01	1985-09-01 00:00:00	1985-09-15	1985-09-15 00:00:00	32020		\N	69275	0	10509002	260139		0
28227	1666	40481087	1958-02-05	1958-02-05 00:00:00	1958-02-19	1958-02-19 00:00:00	32020		\N	111885	0	444814009	40481087		0
28417	1679	4283893	1985-10-17	1985-10-17 00:00:00	1985-11-07	1985-11-07 00:00:00	32020		\N	112589	0	36971009	4283893		0
18048	1084	80180	2016-06-15	2016-06-15 00:00:00	\N	\N	32020		\N	71235	0	396275006	80180		0
18257	1098	372328	1969-01-17	1969-01-17 00:00:00	1970-01-10	1970-01-10 00:00:00	32020		\N	72038	0	65363002	372328		0
18345	1102	40481087	1988-11-11	1988-11-11 00:00:00	1988-11-25	1988-11-25 00:00:00	32020		\N	72444	0	444814009	40481087		0
18564	1116	4112343	2006-10-23	2006-10-23 00:00:00	2006-11-05	2006-11-05 00:00:00	32020		\N	73524	0	195662009	4112343		0
18717	1125	40481087	1964-10-02	1964-10-02 00:00:00	1964-10-23	1964-10-23 00:00:00	32020		\N	74196	0	444814009	40481087		0
18896	1136	4278672	2007-06-05	2007-06-05 00:00:00	2007-08-04	2007-08-04 00:00:00	32020		\N	74856	0	65966004	4278672		0
19064	1145	4278672	2018-08-13	2018-08-13 00:00:00	2018-10-12	2018-10-12 00:00:00	32020		\N	75559	0	65966004	4278672		0
19210	1150	28060	1959-08-25	1959-08-25 00:00:00	1959-09-02	1959-09-02 00:00:00	32020		\N	75998	0	43878008	28060		0
19411	1162	4112343	1936-11-16	1936-11-16 00:00:00	1936-11-23	1936-11-23 00:00:00	32020		\N	76696	0	195662009	4112343		0
30104	1780	80180	2006-02-20	2006-02-20 00:00:00	\N	\N	32020		\N	119120	0	396275006	80180		0
30224	1785	4134304	1961-05-26	1961-05-26 00:00:00	1961-06-25	1961-06-25 00:00:00	32020		\N	119607	0	263102004	4134304		0
30434	1794	372328	1961-02-13	1961-02-13 00:00:00	1961-07-15	1961-07-15 00:00:00	32020		\N	120276	0	65363002	372328		0
20069	1209	372328	1981-11-07	1981-11-07 00:00:00	1982-08-19	1982-08-19 00:00:00	32020		\N	79436	0	65363002	372328		0
20250	1217	40481087	1973-07-17	1973-07-17 00:00:00	1973-07-24	1973-07-24 00:00:00	32020		\N	80154	0	444814009	40481087		0
20375	1227	260139	1974-12-25	1974-12-25 00:00:00	1975-01-08	1975-01-08 00:00:00	32020		\N	80781	0	10509002	260139		0
20582	1236	80180	1963-09-07	1963-09-07 00:00:00	\N	\N	32020		\N	81358	0	396275006	80180		0
20750	1246	4278672	1955-01-22	1955-01-22 00:00:00	1955-03-23	1955-03-23 00:00:00	32020		\N	82135	0	65966004	4278672		0
31378	1854	4266809	2012-04-06	2012-04-06 00:00:00	\N	\N	32020		\N	124118	0	397881000	4266809		0
21026	1261	260139	1973-01-01	1973-01-01 00:00:00	1973-01-08	1973-01-08 00:00:00	32020		\N	83245	0	10509002	260139		0
31734	1879	260139	1980-05-12	1980-05-12 00:00:00	1980-05-26	1980-05-26 00:00:00	32020		\N	125371	0	10509002	260139		0
10785	640	4112343	2007-07-30	2007-07-30 00:00:00	2007-08-10	2007-08-10 00:00:00	32020		\N	42403	0	195662009	4112343		0
21441	1285	4218389	1991-08-01	1991-08-01 00:00:00	1991-08-22	1991-08-22 00:00:00	32020		\N	84927	0	39848009	4218389		0
11110	655	381316	2013-03-30	2013-03-30 00:00:00	\N	\N	32020		\N	43409	0	230690007	381316		0
21795	1309	4112343	1974-01-29	1974-01-29 00:00:00	1974-02-11	1974-02-11 00:00:00	32020		\N	86459	0	195662009	4112343		0
11420	675	4112343	2018-11-08	2018-11-08 00:00:00	2018-11-19	2018-11-19 00:00:00	32020		\N	44611	0	195662009	4112343		0
22123	1321	40481087	1991-12-26	1991-12-26 00:00:00	1992-01-16	1992-01-16 00:00:00	32020		\N	87611	0	444814009	40481087		0
11759	693	40481087	1998-04-07	1998-04-07 00:00:00	1998-04-21	1998-04-21 00:00:00	32020		\N	45908	0	444814009	40481087		0
22411	1338	40481087	2015-10-23	2015-10-23 00:00:00	2015-11-13	2015-11-13 00:00:00	32020		\N	88719	0	444814009	40481087		0
12085	715	260139	1992-11-26	1992-11-26 00:00:00	1992-12-10	1992-12-10 00:00:00	32020		\N	47290	0	10509002	260139		0
22766	1358	40481087	1982-04-20	1982-04-20 00:00:00	1982-05-04	1982-05-04 00:00:00	32020		\N	90097	0	444814009	40481087		0
12383	732	40481087	2012-01-13	2012-01-13 00:00:00	2012-01-20	2012-01-20 00:00:00	32020		\N	48581	0	444814009	40481087		0
12569	743	4112343	1991-02-22	1991-02-22 00:00:00	1991-03-07	1991-03-07 00:00:00	32020		\N	49240	0	195662009	4112343		0
12771	755	4237458	1970-08-08	1970-08-08 00:00:00	1970-11-06	1970-11-06 00:00:00	32020		\N	50007	0	58150001	4237458		0
12942	761	260139	1988-07-26	1988-07-26 00:00:00	1988-08-02	1988-08-02 00:00:00	32020		\N	50592	0	10509002	260139		0
23581	1409	4134304	1946-05-23	1946-05-23 00:00:00	1946-07-22	1946-07-22 00:00:00	32020		\N	93832	0	263102004	4134304		0
23775	1418	40481087	2013-10-01	2013-10-01 00:00:00	2013-10-15	2013-10-15 00:00:00	32020		\N	94414	0	444814009	40481087		0
13392	788	40481087	2000-02-24	2000-02-24 00:00:00	2000-03-16	2000-03-16 00:00:00	32020		\N	52397	0	444814009	40481087		0
24154	1441	40481087	1994-07-13	1994-07-13 00:00:00	1994-07-27	1994-07-27 00:00:00	32020		\N	96051	0	444814009	40481087		0
24269	1446	40481087	2001-03-30	2001-03-30 00:00:00	2001-04-06	2001-04-06 00:00:00	32020		\N	96392	0	444814009	40481087		0
13890	821	192671	1985-02-18	1985-02-18 00:00:00	\N	\N	32020		\N	54376	0	K92.2	35208414		0
14044	829	4112343	1984-04-26	1984-04-26 00:00:00	1984-05-06	1984-05-06 00:00:00	32020		\N	54905	0	195662009	4112343		0
24757	1476	40481087	1975-10-29	1975-10-29 00:00:00	1975-11-12	1975-11-12 00:00:00	32020		\N	98330	0	444814009	40481087		0
14400	851	28060	1989-08-22	1989-08-22 00:00:00	1989-09-04	1989-09-04 00:00:00	32020		\N	56320	0	43878008	28060		0
14589	863	381316	2004-09-30	2004-09-30 00:00:00	\N	\N	32020		\N	57227	0	230690007	381316		0
14738	869	381316	2006-09-29	2006-09-29 00:00:00	\N	\N	32020		\N	57814	0	230690007	381316		0
25443	1516	4112343	1948-06-17	1948-06-17 00:00:00	1948-06-28	1948-06-28 00:00:00	32020		\N	101350	0	195662009	4112343		0
25604	1523	40481087	1971-05-30	1971-05-30 00:00:00	1971-06-06	1971-06-06 00:00:00	32020		\N	101823	0	444814009	40481087		0
25792	1532	260139	2014-05-04	2014-05-04 00:00:00	2014-05-18	2014-05-18 00:00:00	32020		\N	102610	0	10509002	260139		0
25911	1538	80180	1964-02-14	1964-02-14 00:00:00	\N	\N	32020		\N	103022	0	396275006	80180		0
15565	921	40481087	2015-03-29	2015-03-29 00:00:00	2015-04-12	2015-04-12 00:00:00	32020		\N	61377	0	444814009	40481087		0
15766	932	4283893	1986-03-31	1986-03-31 00:00:00	1986-09-01	1986-09-01 00:00:00	32020		\N	62018	0	36971009	4283893		0
15873	939	440448	2003-07-07	2003-07-07 00:00:00	\N	\N	32020		\N	62482	0	74400008	440448		0
16087	951	4027663	1978-12-26	1978-12-26 00:00:00	\N	\N	32020		\N	63137	0	13200003	4027663		0
26740	1585	4283893	1963-10-21	1963-10-21 00:00:00	1963-11-25	1963-11-25 00:00:00	32020		\N	106272	0	36971009	4283893		0
16396	970	4112343	1982-11-18	1982-11-18 00:00:00	1982-11-26	1982-11-26 00:00:00	32020		\N	64483	0	195662009	4112343		0
16532	975	260139	2009-07-27	2009-07-27 00:00:00	2009-08-03	2009-08-03 00:00:00	32020		\N	65005	0	10509002	260139		0
27250	1608	40481087	1968-10-01	1968-10-01 00:00:00	1968-10-22	1968-10-22 00:00:00	32020		\N	107969	0	444814009	40481087		0
27436	1618	4310024	2011-04-02	2011-04-02 00:00:00	\N	\N	32020		\N	108782	0	424802006	4310024		0
17085	1022	81893	2005-03-16	2005-03-16 00:00:00	\N	\N	32020		\N	67231	0	64766004	81893		0
27789	1640	4112343	1994-12-16	1994-12-16 00:00:00	1994-12-27	1994-12-27 00:00:00	32020		\N	110044	0	195662009	4112343		0
27997	1655	40481087	2006-09-30	2006-09-30 00:00:00	2006-10-14	2006-10-14 00:00:00	32020		\N	111032	0	444814009	40481087		0
17592	1057	260139	1989-12-10	1989-12-10 00:00:00	1989-12-24	1989-12-24 00:00:00	32020		\N	69291	0	10509002	260139		0
28228	1666	81151	2015-08-19	2015-08-19 00:00:00	2015-09-09	2015-09-09 00:00:00	32020		\N	111881	0	44465007	81151		0
28418	1679	4155034	2013-03-27	2013-03-27 00:00:00	2013-04-17	2013-04-17 00:00:00	32020		\N	112587	0	283371005	4155034		0
18049	1085	40481087	2005-04-14	2005-04-14 00:00:00	2005-04-28	2005-04-28 00:00:00	32020		\N	71252	0	444814009	40481087		0
18258	1098	81151	2016-11-06	2016-11-06 00:00:00	2016-11-27	2016-11-27 00:00:00	32020		\N	72032	0	44465007	81151		0
18346	1102	40481087	2010-01-05	2010-01-05 00:00:00	2010-01-26	2010-01-26 00:00:00	32020		\N	72435	0	444814009	40481087		0
18565	1116	80180	2007-01-19	2007-01-19 00:00:00	\N	\N	32020		\N	73524	0	396275006	80180		0
18718	1125	260139	2006-02-24	2006-02-24 00:00:00	2006-03-10	2006-03-10 00:00:00	32020		\N	74198	0	10509002	260139		0
18897	1136	40481087	2001-08-11	2001-08-11 00:00:00	2001-08-25	2001-08-25 00:00:00	32020		\N	74861	0	444814009	40481087		0
19065	1145	257012	1953-01-13	1953-01-13 00:00:00	1961-10-24	1961-10-24 00:00:00	32020		\N	75541	0	40055000	257012		0
19211	1150	40481087	1988-04-30	1988-04-30 00:00:00	1988-05-07	1988-05-07 00:00:00	32020		\N	76039	0	444814009	40481087		0
19412	1162	440086	1930-10-29	1930-10-29 00:00:00	1937-11-06	1937-11-06 00:00:00	32020		\N	76712	0	192127007	440086		0
30105	1780	257012	1986-12-25	1986-12-25 00:00:00	\N	\N	32020		\N	119176	0	40055000	257012		0
30225	1785	260139	2013-09-25	2013-09-25 00:00:00	2013-10-09	2013-10-09 00:00:00	32020		\N	119598	0	10509002	260139		0
30435	1794	80180	1996-01-19	1996-01-19 00:00:00	\N	\N	32020		\N	120292	0	396275006	80180		0
20070	1209	4112343	1978-04-10	1978-04-10 00:00:00	1978-04-18	1978-04-18 00:00:00	32020		\N	79471	0	195662009	4112343		0
20252	1219	260139	1949-01-19	1949-01-19 00:00:00	1949-02-02	1949-02-02 00:00:00	32020		\N	80209	0	10509002	260139		0
20376	1227	4230399	2004-05-22	2004-05-22 00:00:00	2004-07-21	2004-07-21 00:00:00	32020		\N	80823	0	359817006	4230399		0
20583	1236	78272	2017-07-22	2017-07-22 00:00:00	2017-08-05	2017-08-05 00:00:00	32020		\N	81419	0	70704007	78272		0
31209	1847	378001	1958-11-17	1958-11-17 00:00:00	1958-12-17	1958-12-17 00:00:00	32020		\N	123518	0	62106007	378001		0
31379	1854	80180	2012-04-06	2012-04-06 00:00:00	\N	\N	32020		\N	124118	0	396275006	80180		0
21027	1261	260139	2016-04-12	2016-04-12 00:00:00	2016-04-19	2016-04-19 00:00:00	32020		\N	83155	0	10509002	260139		0
31746	1882	372328	1969-09-04	1969-09-04 00:00:00	1969-10-18	1969-10-18 00:00:00	32020		\N	125493	0	65363002	372328		0
10786	640	4112343	1956-01-19	1956-01-19 00:00:00	1956-01-29	1956-01-29 00:00:00	32020		\N	42372	0	195662009	4112343		0
21442	1285	81151	1962-01-09	1962-01-09 00:00:00	1962-02-13	1962-02-13 00:00:00	32020		\N	84924	0	44465007	81151		0
11111	655	4112343	2008-09-20	2008-09-20 00:00:00	2008-09-30	2008-09-30 00:00:00	32020		\N	43389	0	195662009	4112343		0
21796	1309	40481087	1992-06-05	1992-06-05 00:00:00	1992-06-12	1992-06-12 00:00:00	32020		\N	86486	0	444814009	40481087		0
11421	675	40481087	2015-03-15	2015-03-15 00:00:00	2015-03-22	2015-03-22 00:00:00	32020		\N	44609	0	444814009	40481087		0
22124	1321	4112343	2014-09-07	2014-09-07 00:00:00	2014-09-15	2014-09-15 00:00:00	32020		\N	87660	0	195662009	4112343		0
11762	695	260139	1996-10-15	1996-10-15 00:00:00	1996-10-29	1996-10-29 00:00:00	32020		\N	46008	0	10509002	260139		0
22412	1338	260139	1997-02-22	1997-02-22 00:00:00	1997-03-01	1997-03-01 00:00:00	32020		\N	88688	0	10509002	260139		0
12086	715	4112343	1984-08-11	1984-08-11 00:00:00	1984-08-18	1984-08-18 00:00:00	32020		\N	47333	0	195662009	4112343		0
22767	1358	80180	1996-08-01	1996-08-01 00:00:00	\N	\N	32020		\N	90063	0	396275006	80180		0
12384	732	260139	1988-12-27	1988-12-27 00:00:00	1989-01-10	1989-01-10 00:00:00	32020		\N	48574	0	10509002	260139		0
12570	743	372328	1977-01-25	1977-01-25 00:00:00	1977-04-10	1977-04-10 00:00:00	32020		\N	49246	0	65363002	372328		0
12772	755	40481087	1967-06-30	1967-06-30 00:00:00	1967-07-14	1967-07-14 00:00:00	32020		\N	50039	0	444814009	40481087		0
12943	761	372328	1981-09-30	1981-09-30 00:00:00	1981-11-20	1981-11-20 00:00:00	32020		\N	50615	0	65363002	372328		0
23582	1409	40481087	1943-03-05	1943-03-05 00:00:00	1943-03-26	1943-03-26 00:00:00	32020		\N	93815	0	444814009	40481087		0
23776	1418	4294548	2001-07-18	2001-07-18 00:00:00	2001-09-12	2001-09-12 00:00:00	32020		\N	94448	0	75498004	4294548		0
13393	788	80180	2012-11-18	2012-11-18 00:00:00	\N	\N	32020		\N	52430	0	396275006	80180		0
24155	1441	4112343	1989-10-26	1989-10-26 00:00:00	1989-11-02	1989-11-02 00:00:00	32020		\N	96038	0	195662009	4112343		0
24270	1446	4112343	2010-09-11	2010-09-11 00:00:00	2010-09-18	2010-09-18 00:00:00	32020		\N	96361	0	195662009	4112343		0
13891	821	40481087	1965-02-20	1965-02-20 00:00:00	1965-03-13	1965-03-13 00:00:00	32020		\N	54380	0	444814009	40481087		0
14045	829	81893	2008-08-07	2008-08-07 00:00:00	\N	\N	32020		\N	54929	0	64766004	81893		0
24758	1476	4112343	2005-06-08	2005-06-08 00:00:00	2005-06-19	2005-06-19 00:00:00	32020		\N	98451	0	195662009	4112343		0
14401	851	40481087	1999-05-06	1999-05-06 00:00:00	1999-05-27	1999-05-27 00:00:00	32020		\N	56281	0	444814009	40481087		0
14590	863	4218389	1985-03-23	1985-03-23 00:00:00	1985-04-13	1985-04-13 00:00:00	32020		\N	57179	0	39848009	4218389		0
14739	869	313217	1993-04-23	1993-04-23 00:00:00	\N	\N	32020		\N	57714	0	49436004	313217		0
25444	1516	4112343	1945-12-15	1945-12-15 00:00:00	1945-12-28	1945-12-28 00:00:00	32020		\N	101241	0	195662009	4112343		0
25605	1523	40481087	2006-08-02	2006-08-02 00:00:00	2006-08-23	2006-08-23 00:00:00	32020		\N	101886	0	444814009	40481087		0
25793	1532	372328	1983-04-23	1983-04-23 00:00:00	1983-09-14	1983-09-14 00:00:00	32020		\N	102613	0	65363002	372328		0
25912	1538	372328	1931-02-27	1931-02-27 00:00:00	1931-05-11	1931-05-11 00:00:00	32020		\N	103003	0	65363002	372328		0
15566	921	4156265	1981-04-13	1981-04-13 00:00:00	1981-05-04	1981-05-04 00:00:00	32020		\N	61344	0	370247008	4156265		0
15767	932	4027663	1995-02-18	1995-02-18 00:00:00	\N	\N	32020		\N	62035	0	13200003	4027663		0
15874	939	40481087	2007-07-26	2007-07-26 00:00:00	2007-08-16	2007-08-16 00:00:00	32020		\N	62442	0	444814009	40481087		0
16088	951	40481087	1969-01-31	1969-01-31 00:00:00	1969-02-07	1969-02-07 00:00:00	32020		\N	63208	0	444814009	40481087		0
26741	1585	40481087	2004-08-02	2004-08-02 00:00:00	2004-08-16	2004-08-16 00:00:00	32020		\N	106260	0	444814009	40481087		0
16397	970	4112343	1976-09-05	1976-09-05 00:00:00	1976-09-16	1976-09-16 00:00:00	32020		\N	64481	0	195662009	4112343		0
16533	975	40481087	1994-07-01	1994-07-01 00:00:00	1994-07-15	1994-07-15 00:00:00	32020		\N	65036	0	444814009	40481087		0
27251	1608	4112343	1949-09-14	1949-09-14 00:00:00	1949-09-26	1949-09-26 00:00:00	32020		\N	107964	0	195662009	4112343		0
27437	1618	81893	2011-05-02	2011-05-02 00:00:00	\N	\N	32020		\N	108782	0	64766004	81893		0
17086	1022	4112343	1973-11-09	1973-11-09 00:00:00	1973-11-21	1973-11-21 00:00:00	32020		\N	67230	0	195662009	4112343		0
27790	1640	4230399	2006-09-14	2006-09-14 00:00:00	2006-11-13	2006-11-13 00:00:00	32020		\N	110031	0	359817006	4230399		0
27998	1655	40481087	1973-08-29	1973-08-29 00:00:00	1973-09-12	1973-09-12 00:00:00	32020		\N	111027	0	444814009	40481087		0
17593	1057	4285898	2003-05-31	2003-05-31 00:00:00	\N	\N	32020		\N	69304	0	68496003	4285898		0
28229	1666	4112343	1949-02-18	1949-02-18 00:00:00	1949-03-01	1949-03-01 00:00:00	32020		\N	111884	0	195662009	4112343		0
28439	1683	4027663	2002-07-14	2002-07-14 00:00:00	\N	\N	32020		\N	112815	0	13200003	4027663		0
18050	1085	40481087	1973-03-11	1973-03-11 00:00:00	1973-03-18	1973-03-18 00:00:00	32020		\N	71256	0	444814009	40481087		0
18259	1098	28060	1962-11-14	1962-11-14 00:00:00	1962-11-21	1962-11-21 00:00:00	32020		\N	72066	0	43878008	28060		0
18393	1107	40481087	1965-03-02	1965-03-02 00:00:00	1965-03-16	1965-03-16 00:00:00	32020		\N	72929	0	444814009	40481087		0
18566	1117	260139	1986-07-06	1986-07-06 00:00:00	1986-07-20	1986-07-20 00:00:00	32020		\N	73571	0	10509002	260139		0
18719	1125	260139	1959-11-20	1959-11-20 00:00:00	1959-11-27	1959-11-27 00:00:00	32020		\N	74202	0	10509002	260139		0
18898	1136	4027663	2004-05-06	2004-05-06 00:00:00	\N	\N	32020		\N	74834	0	13200003	4027663		0
19066	1145	4116491	1957-09-24	1957-09-24 00:00:00	1957-10-28	1957-10-28 00:00:00	32020		\N	75585	0	301011002	4116491		0
19212	1150	4237458	1953-12-22	1953-12-22 00:00:00	1954-02-20	1954-02-20 00:00:00	32020		\N	76061	0	58150001	4237458		0
29892	1769	260139	2012-08-11	2012-08-11 00:00:00	2012-08-18	2012-08-18 00:00:00	32020		\N	118302	0	10509002	260139		0
30106	1780	4310024	2003-11-03	2003-11-03 00:00:00	\N	\N	32020		\N	119137	0	424802006	4310024		0
30226	1785	40481087	1957-04-26	1957-04-26 00:00:00	1957-05-03	1957-05-03 00:00:00	32020		\N	119610	0	444814009	40481087		0
30436	1794	372328	1963-06-07	1963-06-07 00:00:00	1964-01-18	1964-01-18 00:00:00	32020		\N	120286	0	65363002	372328		0
20071	1209	40481087	1987-01-14	1987-01-14 00:00:00	1987-01-28	1987-01-28 00:00:00	32020		\N	79473	0	444814009	40481087		0
30711	1814	28060	2018-02-25	2018-02-25 00:00:00	2018-03-06	2018-03-06 00:00:00	32020		\N	121445	0	43878008	28060		0
20377	1227	260139	2012-03-06	2012-03-06 00:00:00	2012-03-20	2012-03-20 00:00:00	32020		\N	80805	0	10509002	260139		0
20584	1236	80502	2010-07-29	2010-07-29 00:00:00	\N	\N	32020		\N	81448	0	64859006	80502		0
31210	1847	4278672	1926-06-08	1926-06-08 00:00:00	1926-07-08	1926-07-08 00:00:00	32020		\N	123516	0	65966004	4278672		0
31380	1854	4116491	2008-12-19	2008-12-19 00:00:00	2009-02-10	2009-02-10 00:00:00	32020		\N	124125	0	301011002	4116491		0
21028	1261	260139	1990-06-08	1990-06-08 00:00:00	1990-06-22	1990-06-22 00:00:00	32020		\N	83243	0	10509002	260139		0
31747	1882	4112343	1973-07-16	1973-07-16 00:00:00	1973-07-27	1973-07-27 00:00:00	32020		\N	125479	0	195662009	4112343		0
10787	640	372328	1951-06-11	1951-06-11 00:00:00	1951-10-15	1951-10-15 00:00:00	32020		\N	42345	0	65363002	372328		0
21443	1285	4112343	1973-12-23	1973-12-23 00:00:00	1974-01-03	1974-01-03 00:00:00	32020		\N	84984	0	195662009	4112343		0
11112	655	260139	1979-04-10	1979-04-10 00:00:00	1979-04-17	1979-04-17 00:00:00	32020		\N	43348	0	10509002	260139		0
21797	1309	40481087	1967-09-06	1967-09-06 00:00:00	1967-09-27	1967-09-27 00:00:00	32020		\N	86519	0	444814009	40481087		0
11422	675	4112343	1996-09-10	1996-09-10 00:00:00	1996-09-18	1996-09-18 00:00:00	32020		\N	44604	0	195662009	4112343		0
22125	1321	4113008	2016-12-26	2016-12-26 00:00:00	2017-01-09	2017-01-09 00:00:00	32020		\N	87603	0	284549007	4113008		0
11763	695	260139	1974-10-21	1974-10-21 00:00:00	1974-11-04	1974-11-04 00:00:00	32020		\N	45989	0	10509002	260139		0
22413	1338	81151	2007-11-30	2007-11-30 00:00:00	2007-12-21	2007-12-21 00:00:00	32020		\N	88764	0	44465007	81151		0
12087	715	28060	1997-10-11	1997-10-11 00:00:00	1997-10-23	1997-10-23 00:00:00	32020		\N	47291	0	43878008	28060		0
22768	1358	4113008	2002-01-05	2002-01-05 00:00:00	2002-01-26	2002-01-26 00:00:00	32020		\N	90110	0	284549007	4113008		0
12385	732	260139	1984-05-11	1984-05-11 00:00:00	1984-05-25	1984-05-25 00:00:00	32020		\N	48582	0	10509002	260139		0
12571	743	40481087	1982-01-27	1982-01-27 00:00:00	1982-02-10	1982-02-10 00:00:00	32020		\N	49288	0	444814009	40481087		0
12773	755	40481087	1998-01-04	1998-01-04 00:00:00	1998-01-18	1998-01-18 00:00:00	32020		\N	50042	0	444814009	40481087		0
12944	761	4112343	2008-02-23	2008-02-23 00:00:00	2008-03-01	2008-03-01 00:00:00	32020		\N	50583	0	195662009	4112343		0
23583	1409	81151	1922-02-02	1922-02-02 00:00:00	1922-03-09	1922-03-09 00:00:00	32020		\N	93830	0	44465007	81151		0
23777	1418	4112343	2002-06-12	2002-06-12 00:00:00	2002-06-19	2002-06-19 00:00:00	32020		\N	94435	0	195662009	4112343		0
13394	788	372328	1973-04-06	1973-04-06 00:00:00	1973-08-15	1973-08-15 00:00:00	32020		\N	52435	0	65363002	372328		0
24156	1441	40481087	1990-01-17	1990-01-17 00:00:00	1990-02-07	1990-02-07 00:00:00	32020		\N	96031	0	444814009	40481087		0
24271	1446	372328	1984-09-08	1984-09-08 00:00:00	1984-10-09	1984-10-09 00:00:00	32020		\N	96389	0	65363002	372328		0
13892	821	40481087	2015-01-31	2015-01-31 00:00:00	2015-02-14	2015-02-14 00:00:00	32020		\N	54440	0	444814009	40481087		0
14046	829	28060	2006-09-13	2006-09-13 00:00:00	2006-09-23	2006-09-23 00:00:00	32020		\N	54929	0	43878008	28060		0
24759	1476	4059173	1961-08-21	1961-08-21 00:00:00	1961-10-20	1961-10-20 00:00:00	32020		\N	98494	0	16114001	4059173		0
14402	851	372328	1983-06-05	1983-06-05 00:00:00	1983-11-07	1983-11-07 00:00:00	32020		\N	56298	0	65363002	372328		0
14591	863	40481087	1984-03-20	1984-03-20 00:00:00	1984-03-27	1984-03-27 00:00:00	32020		\N	57200	0	444814009	40481087		0
14740	869	372328	1947-05-01	1947-05-01 00:00:00	1947-07-25	1947-07-25 00:00:00	32020		\N	57780	0	65363002	372328		0
25445	1516	4112343	1958-04-09	1958-04-09 00:00:00	1958-04-22	1958-04-22 00:00:00	32020		\N	101351	0	195662009	4112343		0
25606	1523	260139	1959-06-25	1959-06-25 00:00:00	1959-07-09	1959-07-09 00:00:00	32020		\N	101882	0	10509002	260139		0
25794	1532	4278672	1986-04-14	1986-04-14 00:00:00	1986-07-13	1986-07-13 00:00:00	32020		\N	102596	0	65966004	4278672		0
25913	1538	260139	2006-04-04	2006-04-04 00:00:00	2006-04-18	2006-04-18 00:00:00	32020		\N	103039	0	10509002	260139		0
15567	921	40481087	2002-02-12	2002-02-12 00:00:00	2002-02-26	2002-02-26 00:00:00	32020		\N	61321	0	444814009	40481087		0
15768	932	40481087	2014-06-21	2014-06-21 00:00:00	2014-07-12	2014-07-12 00:00:00	32020		\N	62007	0	444814009	40481087		0
15875	939	260139	2001-06-05	2001-06-05 00:00:00	2001-06-19	2001-06-19 00:00:00	32020		\N	62432	0	10509002	260139		0
16089	951	40481087	1988-12-07	1988-12-07 00:00:00	1988-12-21	1988-12-21 00:00:00	32020		\N	63139	0	444814009	40481087		0
26742	1585	4112343	2011-06-23	2011-06-23 00:00:00	2011-07-02	2011-07-02 00:00:00	32020		\N	106261	0	195662009	4112343		0
16398	970	28060	1965-01-11	1965-01-11 00:00:00	1965-01-20	1965-01-20 00:00:00	32020		\N	64518	0	43878008	28060		0
16534	975	80180	2000-03-26	2000-03-26 00:00:00	\N	\N	32020		\N	65052	0	396275006	80180		0
27252	1608	4112343	1960-01-16	1960-01-16 00:00:00	1960-01-23	1960-01-23 00:00:00	32020		\N	107966	0	195662009	4112343		0
27438	1618	317576	1999-03-03	1999-03-03 00:00:00	\N	\N	32020		\N	108805	0	53741008	317576		0
17087	1022	81151	2005-12-21	2005-12-21 00:00:00	2006-01-11	2006-01-11 00:00:00	32020		\N	67209	0	44465007	81151		0
27791	1640	40480160	2006-09-14	2006-09-14 00:00:00	2006-11-13	2006-11-13 00:00:00	32020		\N	110031	0	443165006	40480160		0
27999	1655	4112343	1984-06-02	1984-06-02 00:00:00	1984-06-15	1984-06-15 00:00:00	32020		\N	111028	0	195662009	4112343		0
17594	1057	4218389	2002-05-21	2002-05-21 00:00:00	2002-06-18	2002-06-18 00:00:00	32020		\N	69304	0	39848009	4218389		0
28244	1669	40481087	2002-03-05	2002-03-05 00:00:00	2002-03-26	2002-03-26 00:00:00	32020		\N	112096	0	444814009	40481087		0
28440	1683	4112343	1978-10-17	1978-10-17 00:00:00	1978-10-27	1978-10-27 00:00:00	32020		\N	112774	0	195662009	4112343		0
18051	1085	78272	1977-02-05	1977-02-05 00:00:00	1977-03-05	1977-03-05 00:00:00	32020		\N	71266	0	70704007	78272		0
18260	1098	4152936	1975-02-19	1975-02-19 00:00:00	1975-03-05	1975-03-05 00:00:00	32020		\N	72029	0	283385000	4152936		0
18394	1107	80180	1964-09-30	1964-09-30 00:00:00	\N	\N	32020		\N	72899	0	396275006	80180		0
18567	1117	260139	1974-05-03	1974-05-03 00:00:00	1974-05-10	1974-05-10 00:00:00	32020		\N	73569	0	10509002	260139		0
18720	1125	4134304	1967-01-08	1967-01-08 00:00:00	1967-03-09	1967-03-09 00:00:00	32020		\N	74137	0	263102004	4134304		0
18899	1136	260139	2001-08-21	2001-08-21 00:00:00	2001-08-28	2001-08-28 00:00:00	32020		\N	74868	0	10509002	260139		0
19067	1145	260139	2012-08-14	2012-08-14 00:00:00	2012-08-28	2012-08-28 00:00:00	32020		\N	75571	0	10509002	260139		0
19213	1150	372328	1983-03-20	1983-03-20 00:00:00	1985-03-27	1985-03-27 00:00:00	32020		\N	76041	0	65363002	372328		0
29893	1769	40481087	1982-10-30	1982-10-30 00:00:00	1982-11-13	1982-11-13 00:00:00	32020		\N	118285	0	444814009	40481087		0
30107	1780	81893	2004-09-28	2004-09-28 00:00:00	\N	\N	32020		\N	119137	0	64766004	81893		0
30227	1785	4283893	1997-12-21	1997-12-21 00:00:00	1998-02-15	1998-02-15 00:00:00	32020		\N	119581	0	36971009	4283893		0
30437	1794	440448	1972-02-06	1972-02-06 00:00:00	\N	\N	32020		\N	120327	0	74400008	440448		0
20072	1209	372328	1980-03-09	1980-03-09 00:00:00	1980-08-14	1980-08-14 00:00:00	32020		\N	79445	0	65363002	372328		0
30712	1814	257012	1958-08-31	1958-08-31 00:00:00	1958-09-28	1958-09-28 00:00:00	32020		\N	121359	0	40055000	257012		0
20378	1227	4112343	1951-12-12	1951-12-12 00:00:00	1951-12-25	1951-12-25 00:00:00	32020		\N	80844	0	195662009	4112343		0
31048	1840	40481087	1976-12-18	1976-12-18 00:00:00	1977-01-01	1977-01-01 00:00:00	32020		\N	122835	0	444814009	40481087		0
31211	1847	40481087	1991-04-21	1991-04-21 00:00:00	1991-05-12	1991-05-12 00:00:00	32020		\N	123543	0	444814009	40481087		0
31381	1854	81893	2009-09-19	2009-09-19 00:00:00	\N	\N	32020		\N	124125	0	64766004	81893		0
21029	1261	80180	2005-10-24	2005-10-24 00:00:00	\N	\N	32020		\N	83130	0	396275006	80180		0
31748	1882	260139	2018-10-20	2018-10-20 00:00:00	2018-11-03	2018-11-03 00:00:00	32020		\N	125519	0	10509002	260139		0
10788	640	40481087	2007-06-30	2007-06-30 00:00:00	2007-07-21	2007-07-21 00:00:00	32020		\N	42355	0	444814009	40481087		0
21444	1285	313217	2014-05-19	2014-05-19 00:00:00	\N	\N	32020		\N	84966	0	49436004	313217		0
11113	655	4112343	1964-01-21	1964-01-21 00:00:00	1964-01-28	1964-01-28 00:00:00	32020		\N	43398	0	195662009	4112343		0
21798	1309	40481087	1956-08-30	1956-08-30 00:00:00	1956-09-06	1956-09-06 00:00:00	32020		\N	86451	0	444814009	40481087		0
11423	675	260139	1950-08-06	1950-08-06 00:00:00	1950-08-20	1950-08-20 00:00:00	32020		\N	44574	0	10509002	260139		0
22126	1321	257012	2019-05-22	2019-05-22 00:00:00	\N	\N	32020		\N	87604	0	40055000	257012		0
11764	695	40481087	2016-11-03	2016-11-03 00:00:00	2016-11-10	2016-11-10 00:00:00	32020		\N	46032	0	444814009	40481087		0
22414	1338	40481087	1998-01-25	1998-01-25 00:00:00	1998-02-08	1998-02-08 00:00:00	32020		\N	88689	0	444814009	40481087		0
12110	718	4112343	1971-11-01	1971-11-01 00:00:00	1971-11-12	1971-11-12 00:00:00	32020		\N	47529	0	195662009	4112343		0
22769	1358	28060	1970-07-18	1970-07-18 00:00:00	1970-07-25	1970-07-25 00:00:00	32020		\N	90046	0	43878008	28060		0
12386	732	260139	1986-07-18	1986-07-18 00:00:00	1986-08-01	1986-08-01 00:00:00	32020		\N	48573	0	10509002	260139		0
12572	743	80180	2011-11-08	2011-11-08 00:00:00	\N	\N	32020		\N	49263	0	396275006	80180		0
12774	755	4112343	1965-10-14	1965-10-14 00:00:00	1965-10-21	1965-10-21 00:00:00	32020		\N	50044	0	195662009	4112343		0
12945	761	260139	2004-01-31	2004-01-31 00:00:00	2004-02-14	2004-02-14 00:00:00	32020		\N	50613	0	10509002	260139		0
23584	1409	40481087	1960-01-17	1960-01-17 00:00:00	1960-02-07	1960-02-07 00:00:00	32020		\N	93712	0	444814009	40481087		0
23778	1418	260139	2016-12-21	2016-12-21 00:00:00	2017-01-04	2017-01-04 00:00:00	32020		\N	94458	0	10509002	260139		0
13395	788	40481087	1971-06-08	1971-06-08 00:00:00	1971-06-29	1971-06-29 00:00:00	32020		\N	52455	0	444814009	40481087		0
24157	1441	260139	2008-10-25	2008-10-25 00:00:00	2008-11-01	2008-11-01 00:00:00	32020		\N	96055	0	10509002	260139		0
24272	1446	4112343	1987-10-12	1987-10-12 00:00:00	1987-10-20	1987-10-20 00:00:00	32020		\N	96366	0	195662009	4112343		0
13893	821	372328	1951-08-26	1951-08-26 00:00:00	1951-11-17	1951-11-17 00:00:00	32020		\N	54402	0	65363002	372328		0
14047	829	260139	2016-01-13	2016-01-13 00:00:00	2016-01-20	2016-01-20 00:00:00	32020		\N	54930	0	10509002	260139		0
24760	1476	4112343	1997-07-22	1997-07-22 00:00:00	1997-08-04	1997-08-04 00:00:00	32020		\N	98496	0	195662009	4112343		0
14403	851	40481087	1985-06-12	1985-06-12 00:00:00	1985-07-03	1985-07-03 00:00:00	32020		\N	56304	0	444814009	40481087		0
14592	863	40481087	1994-02-12	1994-02-12 00:00:00	1994-02-19	1994-02-19 00:00:00	32020		\N	57169	0	444814009	40481087		0
14741	869	40481087	2005-03-31	2005-03-31 00:00:00	2005-04-07	2005-04-07 00:00:00	32020		\N	57813	0	444814009	40481087		0
25446	1516	4035415	1982-09-26	1982-09-26 00:00:00	1982-10-26	1982-10-26 00:00:00	32020		\N	101270	0	239720000	4035415		0
25607	1523	40481087	2008-06-22	2008-06-22 00:00:00	2008-06-29	2008-06-29 00:00:00	32020		\N	101824	0	444814009	40481087		0
25795	1532	40481087	2001-06-13	2001-06-13 00:00:00	2001-06-20	2001-06-20 00:00:00	32020		\N	102598	0	444814009	40481087		0
25914	1538	40481087	2001-06-23	2001-06-23 00:00:00	2001-07-14	2001-07-14 00:00:00	32020		\N	103032	0	444814009	40481087		0
15568	921	4296204	2011-07-22	2011-07-22 00:00:00	2011-08-26	2011-08-26 00:00:00	32020		\N	61387	0	403190006	4296204		0
15769	933	4001336	2000-05-31	2000-05-31 00:00:00	2000-06-30	2000-06-30 00:00:00	32020		\N	62061	0	110030002	4001336		0
15876	939	440086	1977-07-11	1977-07-11 00:00:00	1977-12-12	1977-12-12 00:00:00	32020		\N	62462	0	192127007	440086		0
16091	951	4112343	1952-07-04	1952-07-04 00:00:00	1952-07-15	1952-07-15 00:00:00	32020		\N	63223	0	195662009	4112343		0
26743	1585	372328	1935-03-16	1935-03-16 00:00:00	1935-07-14	1935-07-14 00:00:00	32020		\N	106309	0	65363002	372328		0
16399	970	4218389	1956-02-18	1956-02-18 00:00:00	1956-03-17	1956-03-17 00:00:00	32020		\N	64474	0	39848009	4218389		0
16535	975	40481087	2017-02-18	2017-02-18 00:00:00	2017-03-04	2017-03-04 00:00:00	32020		\N	65038	0	444814009	40481087		0
27253	1608	260139	1957-09-10	1957-09-10 00:00:00	1957-09-17	1957-09-17 00:00:00	32020		\N	107965	0	10509002	260139		0
27439	1618	40481087	1990-04-15	1990-04-15 00:00:00	1990-05-06	1990-05-06 00:00:00	32020		\N	108787	0	444814009	40481087		0
17088	1022	4285898	2006-03-11	2006-03-11 00:00:00	\N	\N	32020		\N	67209	0	68496003	4285898		0
27792	1640	4112343	1987-09-09	1987-09-09 00:00:00	1987-09-22	1987-09-22 00:00:00	32020		\N	110082	0	195662009	4112343		0
28000	1655	40481087	1997-01-25	1997-01-25 00:00:00	1997-02-01	1997-02-01 00:00:00	32020		\N	111031	0	444814009	40481087		0
17595	1057	30753	2002-08-04	2002-08-04 00:00:00	\N	\N	32020		\N	69304	0	16761005	30753		0
28245	1669	4112343	2007-12-21	2007-12-21 00:00:00	2007-12-30	2007-12-30 00:00:00	32020		\N	112054	0	195662009	4112343		0
28441	1683	40481087	1973-02-18	1973-02-18 00:00:00	1973-02-25	1973-02-25 00:00:00	32020		\N	112796	0	444814009	40481087		0
18052	1085	40481087	2016-05-31	2016-05-31 00:00:00	2016-06-21	2016-06-21 00:00:00	32020		\N	71271	0	444814009	40481087		0
28727	1702	378001	1967-11-16	1967-11-16 00:00:00	1967-12-16	1967-12-16 00:00:00	32020		\N	113792	0	62106007	378001		0
18395	1107	317576	1964-01-24	1964-01-24 00:00:00	\N	\N	32020		\N	72899	0	53741008	317576		0
18568	1117	372328	1936-09-18	1936-09-18 00:00:00	1936-10-31	1936-10-31 00:00:00	32020		\N	73574	0	65363002	372328		0
18721	1125	40481087	1988-08-27	1988-08-27 00:00:00	1988-09-10	1988-09-10 00:00:00	32020		\N	74150	0	444814009	40481087		0
18900	1136	378001	1997-11-24	1997-11-24 00:00:00	1997-12-24	1997-12-24 00:00:00	32020		\N	74855	0	62106007	378001		0
19068	1145	260139	1958-04-20	1958-04-20 00:00:00	1958-04-27	1958-04-27 00:00:00	32020		\N	75628	0	10509002	260139		0
19214	1150	40481087	1975-07-20	1975-07-20 00:00:00	1975-07-27	1975-07-27 00:00:00	32020		\N	76028	0	444814009	40481087		0
21693	1303	4027663	2004-05-16	2004-05-16 00:00:00	\N	\N	32020		\N	86053	0	13200003	4027663		0
29894	1769	81151	1986-05-25	1986-05-25 00:00:00	1986-06-22	1986-06-22 00:00:00	32020		\N	118284	0	44465007	81151		0
30108	1780	30753	2005-01-26	2005-01-26 00:00:00	\N	\N	32020		\N	119137	0	16761005	30753		0
30228	1785	4218389	1956-08-24	1956-08-24 00:00:00	1956-09-14	1956-09-14 00:00:00	32020		\N	119605	0	39848009	4218389		0
30438	1794	4166224	1972-02-06	1972-02-06 00:00:00	\N	\N	32020		\N	120327	0	47693006	4166224		0
20073	1209	28060	1991-05-13	1991-05-13 00:00:00	1991-05-24	1991-05-24 00:00:00	32020		\N	79443	0	43878008	28060		0
30713	1814	4310024	1979-03-07	1979-03-07 00:00:00	\N	\N	32020		\N	121457	0	424802006	4310024		0
20379	1227	4112343	2003-09-26	2003-09-26 00:00:00	2003-10-08	2003-10-08 00:00:00	32020		\N	80783	0	195662009	4112343		0
31049	1840	260139	2006-09-04	2006-09-04 00:00:00	2006-09-18	2006-09-18 00:00:00	32020		\N	122800	0	10509002	260139		0
31212	1847	260139	1919-12-13	1919-12-13 00:00:00	1919-12-20	1919-12-20 00:00:00	32020		\N	123549	0	10509002	260139		0
31382	1854	260139	1986-07-05	1986-07-05 00:00:00	1986-07-12	1986-07-12 00:00:00	32020		\N	124062	0	10509002	260139		0
21030	1261	40481087	1975-04-19	1975-04-19 00:00:00	1975-05-10	1975-05-10 00:00:00	32020		\N	83250	0	444814009	40481087		0
31749	1882	4112343	1991-10-22	1991-10-22 00:00:00	1991-11-02	1991-11-02 00:00:00	32020		\N	125599	0	195662009	4112343		0
10789	640	81151	2011-06-08	2011-06-08 00:00:00	2011-06-29	2011-06-29 00:00:00	32020		\N	42331	0	44465007	81151		0
21445	1285	40481087	1986-07-30	1986-07-30 00:00:00	1986-08-20	1986-08-20 00:00:00	32020		\N	84985	0	444814009	40481087		0
11114	655	40481087	2005-02-19	2005-02-19 00:00:00	2005-02-26	2005-02-26 00:00:00	32020		\N	43387	0	444814009	40481087		0
21799	1309	4112343	1973-03-08	1973-03-08 00:00:00	1973-03-19	1973-03-19 00:00:00	32020		\N	86441	0	195662009	4112343		0
11424	675	260139	2001-01-17	2001-01-17 00:00:00	2001-01-24	2001-01-24 00:00:00	32020		\N	44606	0	10509002	260139		0
22128	1321	40481087	1965-02-21	1965-02-21 00:00:00	1965-03-14	1965-03-14 00:00:00	32020		\N	87656	0	444814009	40481087		0
11765	695	40481087	1989-06-03	1989-06-03 00:00:00	1989-06-10	1989-06-10 00:00:00	32020		\N	46016	0	444814009	40481087		0
22415	1338	28060	1946-10-25	1946-10-25 00:00:00	1946-11-06	1946-11-06 00:00:00	32020		\N	88682	0	43878008	28060		0
12111	718	4112343	1986-02-11	1986-02-11 00:00:00	1986-02-22	1986-02-22 00:00:00	32020		\N	47441	0	195662009	4112343		0
22770	1358	4218389	2004-02-15	2004-02-15 00:00:00	2004-03-21	2004-03-21 00:00:00	32020		\N	90111	0	39848009	4218389		0
12387	732	28060	2008-08-09	2008-08-09 00:00:00	2008-08-18	2008-08-18 00:00:00	32020		\N	48572	0	43878008	28060		0
12573	743	260139	2006-09-15	2006-09-15 00:00:00	2006-09-29	2006-09-29 00:00:00	32020		\N	49267	0	10509002	260139		0
12775	755	81151	1950-07-19	1950-07-19 00:00:00	1950-08-23	1950-08-23 00:00:00	32020		\N	50102	0	44465007	81151		0
12946	761	4027663	2005-12-08	2005-12-08 00:00:00	\N	\N	32020		\N	50613	0	13200003	4027663		0
23585	1409	80180	1960-03-04	1960-03-04 00:00:00	\N	\N	32020		\N	93712	0	396275006	80180		0
23779	1418	378001	1979-07-14	1979-07-14 00:00:00	1979-08-13	1979-08-13 00:00:00	32020		\N	94421	0	62106007	378001		0
13396	788	4112343	2010-06-29	2010-06-29 00:00:00	2010-07-10	2010-07-10 00:00:00	32020		\N	52414	0	195662009	4112343		0
24158	1441	4112343	1993-03-20	1993-03-20 00:00:00	1993-03-30	1993-03-30 00:00:00	32020		\N	96010	0	195662009	4112343		0
24273	1446	4112343	1993-05-22	1993-05-22 00:00:00	1993-06-03	1993-06-03 00:00:00	32020		\N	96362	0	195662009	4112343		0
13894	821	40481087	1991-11-18	1991-11-18 00:00:00	1991-11-25	1991-11-25 00:00:00	32020		\N	54400	0	444814009	40481087		0
14048	829	28060	1987-04-23	1987-04-23 00:00:00	1987-04-30	1987-04-30 00:00:00	32020		\N	54926	0	43878008	28060		0
24761	1476	40481087	1945-11-14	1945-11-14 00:00:00	1945-12-05	1945-12-05 00:00:00	32020		\N	98362	0	444814009	40481087		0
14404	851	40481087	2009-05-13	2009-05-13 00:00:00	2009-05-20	2009-05-20 00:00:00	32020		\N	56296	0	444814009	40481087		0
14593	863	4109685	1967-08-11	1967-08-11 00:00:00	1967-08-25	1967-08-25 00:00:00	32020		\N	57178	0	284551006	4109685		0
14742	869	4113008	1936-10-10	1936-10-10 00:00:00	1936-10-31	1936-10-31 00:00:00	32020		\N	57722	0	284549007	4113008		0
25447	1516	81893	1977-02-22	1977-02-22 00:00:00	\N	\N	32020		\N	101260	0	64766004	81893		0
25608	1523	40481087	1986-04-07	1986-04-07 00:00:00	1986-04-14	1986-04-14 00:00:00	32020		\N	101884	0	444814009	40481087		0
25796	1532	40481087	2009-12-04	2009-12-04 00:00:00	2009-12-18	2009-12-18 00:00:00	32020		\N	102601	0	444814009	40481087		0
25915	1538	260139	1992-11-18	1992-11-18 00:00:00	1992-12-02	1992-12-02 00:00:00	32020		\N	103028	0	10509002	260139		0
15573	923	372328	1961-06-29	1961-06-29 00:00:00	1961-10-18	1961-10-18 00:00:00	32020		\N	61461	0	65363002	372328		0
15770	933	81151	2014-10-15	2014-10-15 00:00:00	2014-11-05	2014-11-05 00:00:00	32020		\N	62062	0	44465007	81151		0
15877	939	4112343	1980-09-19	1980-09-19 00:00:00	1980-09-29	1980-09-29 00:00:00	32020		\N	62464	0	195662009	4112343		0
16092	951	260139	1971-11-20	1971-11-20 00:00:00	1971-12-04	1971-12-04 00:00:00	32020		\N	63136	0	10509002	260139		0
26744	1585	4156265	1969-09-15	1969-09-15 00:00:00	1969-10-06	1969-10-06 00:00:00	32020		\N	106349	0	370247008	4156265		0
16400	970	4146173	1997-09-13	1997-09-13 00:00:00	1997-10-13	1997-10-13 00:00:00	32020		\N	64525	0	307731004	4146173		0
16536	975	4112343	1985-10-12	1985-10-12 00:00:00	1985-10-19	1985-10-19 00:00:00	32020		\N	65034	0	195662009	4112343		0
27254	1608	40481087	1980-01-02	1980-01-02 00:00:00	1980-01-09	1980-01-09 00:00:00	32020		\N	108022	0	444814009	40481087		0
27440	1618	80180	2013-05-21	2013-05-21 00:00:00	\N	\N	32020		\N	108811	0	396275006	80180		0
17089	1022	372328	1966-02-19	1966-02-19 00:00:00	1966-03-05	1966-03-05 00:00:00	32020		\N	67271	0	65363002	372328		0
27793	1640	4112343	1959-02-09	1959-02-09 00:00:00	1959-02-20	1959-02-20 00:00:00	32020		\N	110102	0	195662009	4112343		0
28001	1656	260139	1994-06-01	1994-06-01 00:00:00	1994-06-15	1994-06-15 00:00:00	32020		\N	111055	0	10509002	260139		0
17596	1057	260139	1963-02-11	1963-02-11 00:00:00	1963-02-25	1963-02-25 00:00:00	32020		\N	69289	0	10509002	260139		0
28246	1669	4134304	1965-01-22	1965-01-22 00:00:00	1965-04-22	1965-04-22 00:00:00	32020		\N	112069	0	263102004	4134304		0
28442	1683	4112343	1987-11-25	1987-11-25 00:00:00	1987-12-06	1987-12-06 00:00:00	32020		\N	112787	0	195662009	4112343		0
18053	1085	40481087	1968-03-23	1968-03-23 00:00:00	1968-03-30	1968-03-30 00:00:00	32020		\N	71269	0	444814009	40481087		0
28728	1702	4142905	1979-07-08	1979-07-08 00:00:00	1979-10-06	1979-10-06 00:00:00	32020		\N	113794	0	33737001	4142905		0
18396	1107	4152936	1929-01-07	1929-01-07 00:00:00	1929-01-21	1929-01-21 00:00:00	32020		\N	72862	0	283385000	4152936		0
18569	1117	4109685	1943-10-03	1943-10-03 00:00:00	1943-10-24	1943-10-24 00:00:00	32020		\N	73616	0	284551006	4109685		0
18722	1125	40481087	1956-09-25	1956-09-25 00:00:00	1956-10-09	1956-10-09 00:00:00	32020		\N	74194	0	444814009	40481087		0
18901	1136	260139	1995-05-26	1995-05-26 00:00:00	1995-06-09	1995-06-09 00:00:00	32020		\N	74860	0	10509002	260139		0
19069	1145	40481087	1995-04-22	1995-04-22 00:00:00	1995-05-06	1995-05-06 00:00:00	32020		\N	75569	0	444814009	40481087		0
19215	1150	40481087	1969-10-05	1969-10-05 00:00:00	1969-10-12	1969-10-12 00:00:00	32020		\N	76027	0	444814009	40481087		0
29895	1769	40481087	2006-10-29	2006-10-29 00:00:00	2006-11-12	2006-11-12 00:00:00	32020		\N	118295	0	444814009	40481087		0
30109	1780	4283893	1986-12-11	1986-12-11 00:00:00	1987-04-23	1987-04-23 00:00:00	32020		\N	119153	0	36971009	4283893		0
30229	1786	40481087	1983-05-22	1983-05-22 00:00:00	1983-05-29	1983-05-29 00:00:00	32020		\N	119752	0	444814009	40481087		0
30439	1794	260139	2014-11-15	2014-11-15 00:00:00	2014-11-29	2014-11-29 00:00:00	32020		\N	120331	0	10509002	260139		0
20074	1209	372328	1986-06-29	1986-06-29 00:00:00	1986-10-02	1986-10-02 00:00:00	32020		\N	79425	0	65363002	372328		0
30714	1814	260139	1991-05-30	1991-05-30 00:00:00	1991-06-06	1991-06-06 00:00:00	32020		\N	121442	0	10509002	260139		0
20380	1227	257012	1983-09-07	1983-09-07 00:00:00	\N	\N	32020		\N	80732	0	40055000	257012		0
31050	1840	4112343	1978-10-01	1978-10-01 00:00:00	1978-10-11	1978-10-11 00:00:00	32020		\N	122795	0	195662009	4112343		0
31213	1847	40481087	1947-04-24	1947-04-24 00:00:00	1947-05-15	1947-05-15 00:00:00	32020		\N	123564	0	444814009	40481087		0
31383	1854	260139	1993-05-07	1993-05-07 00:00:00	1993-05-14	1993-05-14 00:00:00	32020		\N	124063	0	10509002	260139		0
21031	1261	260139	2006-11-06	2006-11-06 00:00:00	2006-11-20	2006-11-20 00:00:00	32020		\N	83143	0	10509002	260139		0
31750	1882	4294548	2007-07-09	2007-07-09 00:00:00	2007-07-16	2007-07-16 00:00:00	32020		\N	125510	0	75498004	4294548		0
10790	640	40481087	2006-07-05	2006-07-05 00:00:00	2006-07-26	2006-07-26 00:00:00	32020		\N	42354	0	444814009	40481087		0
21446	1285	4142905	1996-04-27	1996-04-27 00:00:00	1996-06-26	1996-06-26 00:00:00	32020		\N	84928	0	33737001	4142905		0
11115	655	260139	1991-12-12	1991-12-12 00:00:00	1991-12-19	1991-12-19 00:00:00	32020		\N	43350	0	10509002	260139		0
21800	1309	260139	1987-09-17	1987-09-17 00:00:00	1987-09-24	1987-09-24 00:00:00	32020		\N	86442	0	10509002	260139		0
11425	675	4113008	1972-04-23	1972-04-23 00:00:00	1972-05-14	1972-05-14 00:00:00	32020		\N	44600	0	284549007	4113008		0
22129	1321	4283893	2019-05-01	2019-05-01 00:00:00	\N	\N	32020		\N	87644	0	36971009	4283893		0
11766	695	40481087	1980-04-29	1980-04-29 00:00:00	1980-05-13	1980-05-13 00:00:00	32020		\N	46007	0	444814009	40481087		0
22416	1338	4237458	2019-03-23	2019-03-23 00:00:00	2019-06-21	2019-06-21 00:00:00	32020		\N	88765	0	58150001	4237458		0
12112	718	260139	1983-10-26	1983-10-26 00:00:00	1983-11-09	1983-11-09 00:00:00	32020		\N	47440	0	10509002	260139		0
22771	1358	4155034	1986-10-12	1986-10-12 00:00:00	1986-10-26	1986-10-26 00:00:00	32020		\N	90109	0	283371005	4155034		0
12388	732	260139	2009-06-04	2009-06-04 00:00:00	2009-06-18	2009-06-18 00:00:00	32020		\N	48543	0	10509002	260139		0
12574	743	4112343	1986-08-07	1986-08-07 00:00:00	1986-08-15	1986-08-15 00:00:00	32020		\N	49276	0	195662009	4112343		0
12776	755	40481087	1999-04-21	1999-04-21 00:00:00	1999-05-12	1999-05-12 00:00:00	32020		\N	50067	0	444814009	40481087		0
12947	761	260139	2008-01-16	2008-01-16 00:00:00	2008-01-23	2008-01-23 00:00:00	32020		\N	50614	0	10509002	260139		0
23586	1409	4112343	1933-04-17	1933-04-17 00:00:00	1933-04-27	1933-04-27 00:00:00	32020		\N	93709	0	195662009	4112343		0
23818	1425	372328	1939-10-20	1939-10-20 00:00:00	1940-11-05	1940-11-05 00:00:00	32020		\N	94747	0	65363002	372328		0
13397	788	4112343	2009-03-23	2009-03-23 00:00:00	2009-04-01	2009-04-01 00:00:00	32020		\N	52413	0	195662009	4112343		0
24159	1441	4218389	2018-11-05	2018-11-05 00:00:00	2018-11-26	2018-11-26 00:00:00	32020		\N	95955	0	39848009	4218389		0
24274	1447	260139	1988-09-18	1988-09-18 00:00:00	1988-10-02	1988-10-02 00:00:00	32020		\N	96428	0	10509002	260139		0
13895	821	4112343	1978-04-04	1978-04-04 00:00:00	1978-04-14	1978-04-14 00:00:00	32020		\N	54381	0	195662009	4112343		0
14049	829	28060	1973-12-16	1973-12-16 00:00:00	1973-12-23	1973-12-23 00:00:00	32020		\N	54877	0	43878008	28060		0
24766	1478	40481087	1999-03-31	1999-03-31 00:00:00	1999-04-21	1999-04-21 00:00:00	32020		\N	98619	0	444814009	40481087		0
14405	851	28060	2009-07-08	2009-07-08 00:00:00	2009-07-15	2009-07-15 00:00:00	32020		\N	56306	0	43878008	28060		0
14594	863	40481087	2015-02-06	2015-02-06 00:00:00	2015-02-27	2015-02-27 00:00:00	32020		\N	57201	0	444814009	40481087		0
14743	869	4155034	1915-12-02	1915-12-02 00:00:00	1915-12-16	1915-12-16 00:00:00	32020		\N	57768	0	283371005	4155034		0
25448	1516	4310024	1977-01-23	1977-01-23 00:00:00	\N	\N	32020		\N	101260	0	424802006	4310024		0
25609	1523	40481087	2011-09-27	2011-09-27 00:00:00	2011-10-18	2011-10-18 00:00:00	32020		\N	101836	0	444814009	40481087		0
25797	1532	260139	2006-03-02	2006-03-02 00:00:00	2006-03-16	2006-03-16 00:00:00	32020		\N	102608	0	10509002	260139		0
25916	1538	4112343	2009-09-26	2009-09-26 00:00:00	2009-10-08	2009-10-08 00:00:00	32020		\N	102991	0	195662009	4112343		0
15574	923	4112343	2017-09-10	2017-09-10 00:00:00	2017-09-19	2017-09-19 00:00:00	32020		\N	61447	0	195662009	4112343		0
26234	1558	40481087	1975-10-03	1975-10-03 00:00:00	1975-10-24	1975-10-24 00:00:00	32020		\N	104369	0	444814009	40481087		0
15878	939	260139	1997-11-26	1997-11-26 00:00:00	1997-12-10	1997-12-10 00:00:00	32020		\N	62466	0	10509002	260139		0
16093	951	372328	1954-11-17	1954-11-17 00:00:00	1954-12-08	1954-12-08 00:00:00	32020		\N	63141	0	65363002	372328		0
26745	1585	40481087	1930-04-01	1930-04-01 00:00:00	1930-04-15	1930-04-15 00:00:00	32020		\N	106302	0	444814009	40481087		0
16401	970	40481087	2006-12-11	2006-12-11 00:00:00	2006-12-25	2006-12-25 00:00:00	32020		\N	64523	0	444814009	40481087		0
16537	975	372328	1966-12-05	1966-12-05 00:00:00	1967-04-23	1967-04-23 00:00:00	32020		\N	65039	0	65363002	372328		0
27255	1608	4283893	1988-05-26	1988-05-26 00:00:00	1988-07-21	1988-07-21 00:00:00	32020		\N	107970	0	36971009	4283893		0
27441	1618	40481087	1985-12-17	1985-12-17 00:00:00	1985-12-31	1985-12-31 00:00:00	32020		\N	108826	0	444814009	40481087		0
17091	1022	321042	2010-02-09	2010-02-09 00:00:00	\N	\N	32020		\N	67211	0	410429000	321042		0
27794	1640	260139	1992-03-25	1992-03-25 00:00:00	1992-04-01	1992-04-01 00:00:00	32020		\N	110043	0	10509002	260139		0
28002	1656	4142905	1981-06-08	1981-06-08 00:00:00	1981-07-08	1981-07-08 00:00:00	32020		\N	111150	0	33737001	4142905		0
28055	1658	30753	1947-01-12	1947-01-12 00:00:00	\N	\N	32020		\N	111322	0	16761005	30753		0
28247	1669	40481087	1965-06-28	1965-06-28 00:00:00	1965-07-19	1965-07-19 00:00:00	32020		\N	112062	0	444814009	40481087		0
28443	1683	4112343	1983-11-04	1983-11-04 00:00:00	1983-11-13	1983-11-13 00:00:00	32020		\N	112798	0	195662009	4112343		0
18054	1085	28060	1971-06-03	1971-06-03 00:00:00	1971-06-10	1971-06-10 00:00:00	32020		\N	71242	0	43878008	28060		0
28729	1702	40481087	1973-01-17	1973-01-17 00:00:00	1973-02-07	1973-02-07 00:00:00	32020		\N	113800	0	444814009	40481087		0
18397	1107	375671	1947-02-16	1947-02-16 00:00:00	1947-03-18	1947-03-18 00:00:00	32020		\N	72863	0	62564004	375671		0
18570	1117	4294548	1992-11-26	1992-11-26 00:00:00	1993-02-25	1993-02-25 00:00:00	32020		\N	73623	0	75498004	4294548		0
18750	1128	260139	1975-02-21	1975-02-21 00:00:00	1975-02-28	1975-02-28 00:00:00	32020		\N	74348	0	10509002	260139		0
18902	1136	81893	2011-05-30	2011-05-30 00:00:00	\N	\N	32020		\N	74836	0	64766004	81893		0
19070	1145	40481087	1999-07-18	1999-07-18 00:00:00	1999-07-25	1999-07-25 00:00:00	32020		\N	75576	0	444814009	40481087		0
19216	1150	40481087	2014-05-07	2014-05-07 00:00:00	2014-05-21	2014-05-21 00:00:00	32020		\N	76006	0	444814009	40481087		0
29896	1769	40481087	2011-03-28	2011-03-28 00:00:00	2011-04-11	2011-04-11 00:00:00	32020		\N	118286	0	444814009	40481087		0
30110	1780	260139	1988-11-30	1988-11-30 00:00:00	1988-12-14	1988-12-14 00:00:00	32020		\N	119154	0	10509002	260139		0
30230	1786	80180	1984-12-08	1984-12-08 00:00:00	\N	\N	32020		\N	119752	0	396275006	80180		0
30440	1794	40481087	2015-11-29	2015-11-29 00:00:00	2015-12-13	2015-12-13 00:00:00	32020		\N	120303	0	444814009	40481087		0
20079	1211	81151	1966-12-06	1966-12-06 00:00:00	1966-12-20	1966-12-20 00:00:00	32020		\N	79564	0	44465007	81151		0
30715	1814	4266809	1981-10-22	1981-10-22 00:00:00	\N	\N	32020		\N	121392	0	397881000	4266809		0
20381	1227	4237458	2017-09-11	2017-09-11 00:00:00	2017-10-11	2017-10-11 00:00:00	32020		\N	80824	0	58150001	4237458		0
31051	1840	260139	2017-07-20	2017-07-20 00:00:00	2017-07-27	2017-07-27 00:00:00	32020		\N	122826	0	10509002	260139		0
31214	1847	40481087	1967-07-04	1967-07-04 00:00:00	1967-07-18	1967-07-18 00:00:00	32020		\N	123539	0	444814009	40481087		0
31384	1854	40481087	2010-09-30	2010-09-30 00:00:00	2010-10-21	2010-10-21 00:00:00	32020		\N	124066	0	444814009	40481087		0
21032	1261	134438	1989-05-18	1989-05-18 00:00:00	1991-03-11	1991-03-11 00:00:00	32020		\N	83207	0	40275004	134438		0
31751	1882	40481087	1991-10-02	1991-10-02 00:00:00	1991-10-23	1991-10-23 00:00:00	32020		\N	125573	0	444814009	40481087		0
21249	1276	4112343	2015-04-22	2015-04-22 00:00:00	2015-04-30	2015-04-30 00:00:00	32020		\N	84172	0	195662009	4112343		0
21447	1285	80180	1990-11-28	1990-11-28 00:00:00	\N	\N	32020		\N	84938	0	396275006	80180		0
11116	655	81151	2000-04-29	2000-04-29 00:00:00	2000-05-13	2000-05-13 00:00:00	32020		\N	43423	0	44465007	81151		0
21801	1309	40481087	1996-07-29	1996-07-29 00:00:00	1996-08-12	1996-08-12 00:00:00	32020		\N	86455	0	444814009	40481087		0
11426	675	28060	1956-12-03	1956-12-03 00:00:00	1956-12-14	1956-12-14 00:00:00	32020		\N	44715	0	43878008	28060		0
22130	1321	4218389	2007-11-09	2007-11-09 00:00:00	2007-12-14	2007-12-14 00:00:00	32020		\N	87602	0	39848009	4218389		0
11767	695	4112343	1991-02-03	1991-02-03 00:00:00	1991-02-15	1991-02-15 00:00:00	32020		\N	46015	0	195662009	4112343		0
22417	1338	372328	1956-07-06	1956-07-06 00:00:00	1956-11-01	1956-11-01 00:00:00	32020		\N	88702	0	65363002	372328		0
12113	718	40481087	2018-11-05	2018-11-05 00:00:00	2018-11-12	2018-11-12 00:00:00	32020		\N	47535	0	444814009	40481087		0
22772	1359	260139	1976-08-21	1976-08-21 00:00:00	1976-08-28	1976-08-28 00:00:00	32020		\N	90193	0	10509002	260139		0
12389	732	4112343	1999-07-31	1999-07-31 00:00:00	1999-08-10	1999-08-10 00:00:00	32020		\N	48570	0	195662009	4112343		0
12575	743	4112343	2004-01-14	2004-01-14 00:00:00	2004-01-24	2004-01-24 00:00:00	32020		\N	49254	0	195662009	4112343		0
12777	755	80180	1991-08-08	1991-08-08 00:00:00	\N	\N	32020		\N	50077	0	396275006	80180		0
12948	761	40481087	1983-06-25	1983-06-25 00:00:00	1983-07-09	1983-07-09 00:00:00	32020		\N	50567	0	444814009	40481087		0
23587	1409	4112343	1962-08-24	1962-08-24 00:00:00	1962-09-01	1962-09-01 00:00:00	32020		\N	93823	0	195662009	4112343		0
23819	1425	4112343	1946-03-19	1946-03-19 00:00:00	1946-03-28	1946-03-28 00:00:00	32020		\N	94767	0	195662009	4112343		0
13398	788	4112343	1974-11-27	1974-11-27 00:00:00	1974-12-09	1974-12-09 00:00:00	32020		\N	52393	0	195662009	4112343		0
24160	1441	375671	1991-10-18	1991-10-18 00:00:00	1991-12-17	1991-12-17 00:00:00	32020		\N	95950	0	62564004	375671		0
24275	1447	40481087	1962-01-12	1962-01-12 00:00:00	1962-02-02	1962-02-02 00:00:00	32020		\N	96457	0	444814009	40481087		0
13896	821	4134304	1978-04-18	1978-04-18 00:00:00	1978-07-17	1978-07-17 00:00:00	32020		\N	54396	0	263102004	4134304		0
14050	829	28060	1983-05-19	1983-05-19 00:00:00	1983-05-31	1983-05-31 00:00:00	32020		\N	54878	0	43878008	28060		0
24767	1478	40481087	1965-05-05	1965-05-05 00:00:00	1965-05-12	1965-05-12 00:00:00	32020		\N	98651	0	444814009	40481087		0
14406	851	4112343	2011-11-06	2011-11-06 00:00:00	2011-11-15	2011-11-15 00:00:00	32020		\N	56271	0	195662009	4112343		0
14595	863	40481087	1983-10-29	1983-10-29 00:00:00	1983-11-12	1983-11-12 00:00:00	32020		\N	57168	0	444814009	40481087		0
14744	869	28060	1961-01-02	1961-01-02 00:00:00	1961-01-09	1961-01-09 00:00:00	32020		\N	57750	0	43878008	28060		0
25449	1516	40481087	1975-12-26	1975-12-26 00:00:00	1976-01-09	1976-01-09 00:00:00	32020		\N	101260	0	444814009	40481087		0
25610	1523	40481087	2009-08-28	2009-08-28 00:00:00	2009-09-04	2009-09-04 00:00:00	32020		\N	101887	0	444814009	40481087		0
25798	1532	40481087	1990-11-09	1990-11-09 00:00:00	1990-11-30	1990-11-30 00:00:00	32020		\N	102600	0	444814009	40481087		0
25917	1538	40481087	2012-11-12	2012-11-12 00:00:00	2012-11-19	2012-11-19 00:00:00	32020		\N	103001	0	444814009	40481087		0
15575	923	260139	2001-05-22	2001-05-22 00:00:00	2001-06-05	2001-06-05 00:00:00	32020		\N	61422	0	10509002	260139		0
26235	1558	40481087	1963-08-28	1963-08-28 00:00:00	1963-09-04	1963-09-04 00:00:00	32020		\N	104380	0	444814009	40481087		0
15879	939	4112343	1997-11-01	1997-11-01 00:00:00	1997-11-10	1997-11-10 00:00:00	32020		\N	62440	0	195662009	4112343		0
16094	951	4113008	1967-12-30	1967-12-30 00:00:00	1968-01-20	1968-01-20 00:00:00	32020		\N	63219	0	284549007	4113008		0
26746	1585	4112343	1970-09-25	1970-09-25 00:00:00	1970-10-08	1970-10-08 00:00:00	32020		\N	106304	0	195662009	4112343		0
16402	970	28060	1960-05-11	1960-05-11 00:00:00	1960-05-23	1960-05-23 00:00:00	32020		\N	64517	0	43878008	28060		0
16538	975	4146173	2009-09-11	2009-09-11 00:00:00	2009-10-11	2009-10-11 00:00:00	32020		\N	65053	0	307731004	4146173		0
27256	1608	381316	2016-04-16	2016-04-16 00:00:00	\N	\N	32020		\N	107980	0	230690007	381316		0
27442	1618	40481087	1994-02-21	1994-02-21 00:00:00	1994-03-14	1994-03-14 00:00:00	32020		\N	108828	0	444814009	40481087		0
17092	1022	4112343	1990-10-10	1990-10-10 00:00:00	1990-10-21	1990-10-21 00:00:00	32020		\N	67224	0	195662009	4112343		0
27795	1640	4112343	2011-06-06	2011-06-06 00:00:00	2011-06-15	2011-06-15 00:00:00	32020		\N	110090	0	195662009	4112343		0
28003	1656	4112343	2000-03-19	2000-03-19 00:00:00	2000-04-01	2000-04-01 00:00:00	32020		\N	111069	0	195662009	4112343		0
28056	1658	4112343	1918-10-07	1918-10-07 00:00:00	1918-10-15	1918-10-15 00:00:00	32020		\N	111383	0	195662009	4112343		0
28248	1669	192671	1998-12-29	1998-12-29 00:00:00	\N	\N	32020		\N	112060	0	K92.2	35208414		0
28444	1683	260139	1998-12-28	1998-12-28 00:00:00	1999-01-04	1999-01-04 00:00:00	32020		\N	112800	0	10509002	260139		0
18055	1085	4112343	1995-10-02	1995-10-02 00:00:00	1995-10-11	1995-10-11 00:00:00	32020		\N	71270	0	195662009	4112343		0
28730	1702	4109685	1976-09-30	1976-09-30 00:00:00	1976-10-21	1976-10-21 00:00:00	32020		\N	113793	0	284551006	4109685		0
18398	1107	4112343	1956-12-20	1956-12-20 00:00:00	1956-12-29	1956-12-29 00:00:00	32020		\N	72928	0	195662009	4112343		0
18571	1117	257012	1992-12-17	1992-12-17 00:00:00	\N	\N	32020		\N	73564	0	40055000	257012		0
18751	1128	4112343	1993-03-04	1993-03-04 00:00:00	1993-03-15	1993-03-15 00:00:00	32020		\N	74331	0	195662009	4112343		0
18903	1136	440086	1985-05-11	1985-05-11 00:00:00	1985-10-12	1985-10-12 00:00:00	32020		\N	74843	0	192127007	440086		0
19071	1145	4294548	1961-10-03	1961-10-03 00:00:00	1961-10-24	1961-10-24 00:00:00	32020		\N	75565	0	75498004	4294548		0
19217	1150	40481087	1975-10-31	1975-10-31 00:00:00	1975-11-14	1975-11-14 00:00:00	32020		\N	76029	0	444814009	40481087		0
29897	1769	80180	2011-09-06	2011-09-06 00:00:00	\N	\N	32020		\N	118286	0	396275006	80180		0
30111	1780	4296204	1993-05-19	1993-05-19 00:00:00	1993-06-09	1993-06-09 00:00:00	32020		\N	119145	0	403190006	4296204		0
30231	1786	4112343	1968-10-21	1968-10-21 00:00:00	1968-11-02	1968-11-02 00:00:00	32020		\N	119731	0	195662009	4112343		0
30441	1794	372328	1961-09-13	1961-09-13 00:00:00	1962-01-13	1962-01-13 00:00:00	32020		\N	120277	0	65363002	372328		0
20080	1211	4155034	2012-06-17	2012-06-17 00:00:00	2012-07-08	2012-07-08 00:00:00	32020		\N	79578	0	283371005	4155034		0
30716	1814	80180	1981-10-22	1981-10-22 00:00:00	\N	\N	32020		\N	121392	0	396275006	80180		0
20382	1227	4112343	2000-05-02	2000-05-02 00:00:00	2000-05-13	2000-05-13 00:00:00	32020		\N	80734	0	195662009	4112343		0
31052	1840	4112343	1985-12-21	1985-12-21 00:00:00	1986-01-01	1986-01-01 00:00:00	32020		\N	122797	0	195662009	4112343		0
31215	1847	4112343	1960-09-10	1960-09-10 00:00:00	1960-09-19	1960-09-19 00:00:00	32020		\N	123514	0	195662009	4112343		0
31385	1854	4027663	2000-10-26	2000-10-26 00:00:00	\N	\N	32020		\N	124064	0	13200003	4027663		0
21033	1261	4218389	1995-01-10	1995-01-10 00:00:00	1995-01-31	1995-01-31 00:00:00	32020		\N	83217	0	39848009	4218389		0
31752	1882	260139	1987-06-13	1987-06-13 00:00:00	1987-06-20	1987-06-20 00:00:00	32020		\N	125481	0	10509002	260139		0
21250	1276	4155034	1992-02-03	1992-02-03 00:00:00	1992-02-17	1992-02-17 00:00:00	32020		\N	84133	0	283371005	4155034		0
21448	1285	40481087	2013-08-26	2013-08-26 00:00:00	2013-09-16	2013-09-16 00:00:00	32020		\N	84996	0	444814009	40481087		0
11117	655	195588	1989-01-14	1989-01-14 00:00:00	1989-02-25	1989-02-25 00:00:00	32020		\N	43349	0	38822007	195588		0
21802	1309	4156265	1989-12-09	1989-12-09 00:00:00	1989-12-23	1989-12-23 00:00:00	32020		\N	86449	0	370247008	4156265		0
11427	675	40481087	1959-04-09	1959-04-09 00:00:00	1959-04-30	1959-04-30 00:00:00	32020		\N	44576	0	444814009	40481087		0
22131	1321	4152936	1960-05-27	1960-05-27 00:00:00	1960-06-17	1960-06-17 00:00:00	32020		\N	87679	0	283385000	4152936		0
11768	695	4113008	1969-11-15	1969-11-15 00:00:00	1969-12-06	1969-12-06 00:00:00	32020		\N	46005	0	284549007	4113008		0
22418	1338	40481087	2016-02-19	2016-02-19 00:00:00	2016-03-11	2016-03-11 00:00:00	32020		\N	88720	0	444814009	40481087		0
12114	718	40481087	1976-01-23	1976-01-23 00:00:00	1976-01-30	1976-01-30 00:00:00	32020		\N	47489	0	444814009	40481087		0
12390	732	40481087	1992-02-03	1992-02-03 00:00:00	1992-02-24	1992-02-24 00:00:00	32020		\N	48583	0	444814009	40481087		0
12576	743	4112343	2001-07-15	2001-07-15 00:00:00	2001-07-26	2001-07-26 00:00:00	32020		\N	49278	0	195662009	4112343		0
12778	755	4116491	1995-06-23	1995-06-23 00:00:00	1995-07-27	1995-07-27 00:00:00	32020		\N	50064	0	301011002	4116491		0
23407	1397	40481087	2019-02-15	2019-02-15 00:00:00	2019-03-01	2019-03-01 00:00:00	32020		\N	92747	0	444814009	40481087		0
23588	1409	40481087	1920-03-23	1920-03-23 00:00:00	1920-03-30	1920-03-30 00:00:00	32020		\N	93816	0	444814009	40481087		0
23820	1425	40481087	2018-04-09	2018-04-09 00:00:00	2018-04-23	2018-04-23 00:00:00	32020		\N	94736	0	444814009	40481087		0
13399	788	40481087	2013-04-24	2013-04-24 00:00:00	2013-05-08	2013-05-08 00:00:00	32020		\N	52433	0	444814009	40481087		0
24161	1441	133834	1967-07-03	1967-07-03 00:00:00	1985-03-18	1985-03-18 00:00:00	32020		\N	96033	0	24079001	133834		0
24276	1447	4116491	2009-07-19	2009-07-19 00:00:00	2009-09-07	2009-09-07 00:00:00	32020		\N	96486	0	301011002	4116491		0
13897	821	260139	1968-08-08	1968-08-08 00:00:00	1968-08-15	1968-08-15 00:00:00	32020		\N	54398	0	10509002	260139		0
14051	829	4112343	1988-11-22	1988-11-22 00:00:00	1988-11-30	1988-11-30 00:00:00	32020		\N	54897	0	195662009	4112343		0
24768	1478	40481087	1966-07-11	1966-07-11 00:00:00	1966-08-01	1966-08-01 00:00:00	32020		\N	98573	0	444814009	40481087		0
14407	851	4237458	1982-06-26	1982-06-26 00:00:00	1982-07-26	1982-07-26 00:00:00	32020		\N	56290	0	58150001	4237458		0
14596	863	81151	1923-07-09	1923-07-09 00:00:00	1923-07-23	1923-07-23 00:00:00	32020		\N	57205	0	44465007	81151		0
14745	869	372328	1979-03-09	1979-03-09 00:00:00	1980-02-01	1980-02-01 00:00:00	32020		\N	57781	0	65363002	372328		0
25450	1516	4156265	1961-08-07	1961-08-07 00:00:00	1961-08-21	1961-08-21 00:00:00	32020		\N	101266	0	370247008	4156265		0
25611	1523	260139	1974-07-29	1974-07-29 00:00:00	1974-08-12	1974-08-12 00:00:00	32020		\N	101883	0	10509002	260139		0
25799	1532	40481087	2012-03-12	2012-03-12 00:00:00	2012-03-19	2012-03-19 00:00:00	32020		\N	102602	0	444814009	40481087		0
25918	1538	4112343	1937-06-28	1937-06-28 00:00:00	1937-07-11	1937-07-11 00:00:00	32020		\N	102950	0	195662009	4112343		0
15576	923	40481087	1998-10-16	1998-10-16 00:00:00	1998-11-06	1998-11-06 00:00:00	32020		\N	61432	0	444814009	40481087		0
26236	1558	40481087	2018-04-29	2018-04-29 00:00:00	2018-05-13	2018-05-13 00:00:00	32020		\N	104375	0	444814009	40481087		0
15880	939	40481087	2002-06-09	2002-06-09 00:00:00	2002-06-16	2002-06-16 00:00:00	32020		\N	62434	0	444814009	40481087		0
16095	951	40481087	2002-05-31	2002-05-31 00:00:00	2002-06-21	2002-06-21 00:00:00	32020		\N	63189	0	444814009	40481087		0
26747	1585	40481087	1944-02-03	1944-02-03 00:00:00	1944-02-10	1944-02-10 00:00:00	32020		\N	106255	0	444814009	40481087		0
16403	970	4112343	2010-05-23	2010-05-23 00:00:00	2010-05-31	2010-05-31 00:00:00	32020		\N	64485	0	195662009	4112343		0
16539	975	260139	2003-01-27	2003-01-27 00:00:00	2003-02-03	2003-02-03 00:00:00	32020		\N	65024	0	10509002	260139		0
27257	1608	260139	1945-01-26	1945-01-26 00:00:00	1945-02-02	1945-02-02 00:00:00	32020		\N	108017	0	10509002	260139		0
27468	1622	4156265	2015-02-08	2015-02-08 00:00:00	2015-02-22	2015-02-22 00:00:00	32020		\N	108938	0	370247008	4156265		0
17093	1022	260139	1988-12-18	1988-12-18 00:00:00	1989-01-01	1989-01-01 00:00:00	32020		\N	67254	0	10509002	260139		0
27796	1640	4112343	1996-01-24	1996-01-24 00:00:00	1996-02-06	1996-02-06 00:00:00	32020		\N	110084	0	195662009	4112343		0
28004	1656	40481087	2016-01-18	2016-01-18 00:00:00	2016-01-25	2016-01-25 00:00:00	32020		\N	111056	0	444814009	40481087		0
28057	1658	4134304	1989-05-01	1989-05-01 00:00:00	1989-05-31	1989-05-31 00:00:00	32020		\N	111379	0	263102004	4134304		0
28249	1669	4112343	1985-01-20	1985-01-20 00:00:00	1985-01-30	1985-01-30 00:00:00	32020		\N	112052	0	195662009	4112343		0
28445	1683	81893	2012-02-02	2012-02-02 00:00:00	\N	\N	32020		\N	112777	0	64766004	81893		0
18056	1085	260139	1965-12-30	1965-12-30 00:00:00	1966-01-13	1966-01-13 00:00:00	32020		\N	71255	0	10509002	260139		0
28731	1702	4112343	2015-04-04	2015-04-04 00:00:00	2015-04-13	2015-04-13 00:00:00	32020		\N	113809	0	195662009	4112343		0
18399	1107	40481087	1952-10-20	1952-10-20 00:00:00	1952-10-27	1952-10-27 00:00:00	32020		\N	72913	0	444814009	40481087		0
18572	1117	40481087	2006-01-16	2006-01-16 00:00:00	2006-01-23	2006-01-23 00:00:00	32020		\N	73644	0	444814009	40481087		0
18752	1128	4266809	2006-04-08	2006-04-08 00:00:00	\N	\N	32020		\N	74307	0	397881000	4266809		0
18905	1136	321042	1972-10-07	1972-10-07 00:00:00	\N	\N	32020		\N	74864	0	410429000	321042		0
19072	1145	40481087	1978-10-14	1978-10-14 00:00:00	1978-10-21	1978-10-21 00:00:00	32020		\N	75568	0	444814009	40481087		0
19218	1150	28060	1990-03-02	1990-03-02 00:00:00	1990-03-12	1990-03-12 00:00:00	32020		\N	76030	0	43878008	28060		0
29898	1769	40481087	2003-09-23	2003-09-23 00:00:00	2003-10-07	2003-10-07 00:00:00	32020		\N	118301	0	444814009	40481087		0
30112	1780	260139	1983-02-06	1983-02-06 00:00:00	1983-02-13	1983-02-13 00:00:00	32020		\N	119152	0	10509002	260139		0
30232	1786	40481087	1982-04-07	1982-04-07 00:00:00	1982-04-21	1982-04-21 00:00:00	32020		\N	119733	0	444814009	40481087		0
30442	1794	4112343	2000-08-16	2000-08-16 00:00:00	2000-08-23	2000-08-23 00:00:00	32020		\N	120308	0	195662009	4112343		0
20081	1211	4048171	1967-10-29	1967-10-29 00:00:00	\N	\N	32020		\N	79556	0	232353008	4048171		0
30717	1814	134438	1971-04-20	1971-04-20 00:00:00	1974-07-06	1974-07-06 00:00:00	32020		\N	121381	0	40275004	134438		0
20383	1227	378419	2016-04-06	2016-04-06 00:00:00	\N	\N	32020		\N	80766	0	26929004	378419		0
31053	1840	40481087	1986-12-10	1986-12-10 00:00:00	1986-12-17	1986-12-17 00:00:00	32020		\N	122799	0	444814009	40481087		0
31216	1847	192671	1958-04-09	1958-04-09 00:00:00	\N	\N	32020		\N	123480	0	K92.2	35208414		0
31386	1854	40481087	2000-10-02	2000-10-02 00:00:00	2000-10-16	2000-10-16 00:00:00	32020		\N	124064	0	444814009	40481087		0
21036	1264	28060	1997-06-20	1997-06-20 00:00:00	1997-06-29	1997-06-29 00:00:00	32020		\N	83316	0	43878008	28060		0
31753	1882	260139	1985-11-27	1985-11-27 00:00:00	1985-12-11	1985-12-11 00:00:00	32020		\N	125480	0	10509002	260139		0
21252	1276	4029498	1968-03-05	1968-03-05 00:00:00	\N	\N	32020		\N	84132	0	128613002	4029498		0
21473	1289	372328	1964-08-14	1964-08-14 00:00:00	1965-02-16	1965-02-16 00:00:00	32020		\N	85188	0	65363002	372328		0
11118	655	4112343	1986-09-13	1986-09-13 00:00:00	1986-09-20	1986-09-20 00:00:00	32020		\N	43400	0	195662009	4112343		0
21803	1309	260139	1993-09-11	1993-09-11 00:00:00	1993-09-18	1993-09-18 00:00:00	32020		\N	86465	0	10509002	260139		0
11428	675	78272	2019-06-07	2019-06-07 00:00:00	\N	\N	32020		\N	44647	0	70704007	78272		0
22132	1322	28060	1945-05-02	1945-05-02 00:00:00	1945-05-09	1945-05-09 00:00:00	32020		\N	87792	0	43878008	28060		0
11769	695	260139	1990-08-18	1990-08-18 00:00:00	1990-09-01	1990-09-01 00:00:00	32020		\N	46014	0	10509002	260139		0
22419	1338	80180	1978-08-09	1978-08-09 00:00:00	\N	\N	32020		\N	88734	0	396275006	80180		0
12115	718	4113008	1967-03-23	1967-03-23 00:00:00	1967-04-13	1967-04-13 00:00:00	32020		\N	47523	0	284549007	4113008		0
22774	1359	4112343	1988-11-09	1988-11-09 00:00:00	1988-11-19	1988-11-19 00:00:00	32020		\N	90195	0	195662009	4112343		0
12391	732	257012	2007-07-31	2007-07-31 00:00:00	\N	\N	32020		\N	48532	0	40055000	257012		0
12577	743	40481087	1981-07-09	1981-07-09 00:00:00	1981-07-23	1981-07-23 00:00:00	32020		\N	49237	0	444814009	40481087		0
12779	755	372328	1950-08-18	1950-08-18 00:00:00	1950-12-09	1950-12-09 00:00:00	32020		\N	50025	0	65363002	372328		0
23408	1397	40481087	2018-02-08	2018-02-08 00:00:00	2018-02-15	2018-02-15 00:00:00	32020		\N	92766	0	444814009	40481087		0
23589	1409	4294548	1936-02-02	1936-02-02 00:00:00	1936-08-09	1936-08-09 00:00:00	32020		\N	93719	0	75498004	4294548		0
23821	1425	372328	1937-01-19	1937-01-19 00:00:00	1937-02-02	1937-02-02 00:00:00	32020		\N	94770	0	65363002	372328		0
13400	789	260139	1995-12-01	1995-12-01 00:00:00	1995-12-15	1995-12-15 00:00:00	32020		\N	52511	0	10509002	260139		0
24162	1441	4112343	1974-06-03	1974-06-03 00:00:00	1974-06-14	1974-06-14 00:00:00	32020		\N	96028	0	195662009	4112343		0
24277	1447	4283893	1993-08-07	1993-08-07 00:00:00	1994-08-20	1994-08-20 00:00:00	32020		\N	96467	0	36971009	4283893		0
13898	821	81151	1969-08-12	1969-08-12 00:00:00	1969-09-02	1969-09-02 00:00:00	32020		\N	54395	0	44465007	81151		0
14052	829	40481087	1988-08-03	1988-08-03 00:00:00	1988-08-10	1988-08-10 00:00:00	32020		\N	54915	0	444814009	40481087		0
24769	1478	260139	1975-09-05	1975-09-05 00:00:00	1975-09-19	1975-09-19 00:00:00	32020		\N	98652	0	10509002	260139		0
14408	851	4112343	1994-10-20	1994-10-20 00:00:00	1994-10-29	1994-10-29 00:00:00	32020		\N	56305	0	195662009	4112343		0
14597	863	40481087	1921-09-25	1921-09-25 00:00:00	1921-10-16	1921-10-16 00:00:00	32020		\N	57164	0	444814009	40481087		0
14746	869	4112343	1971-03-01	1971-03-01 00:00:00	1971-03-14	1971-03-14 00:00:00	32020		\N	57765	0	195662009	4112343		0
25451	1516	4283893	1991-10-24	1991-10-24 00:00:00	1991-12-05	1991-12-05 00:00:00	32020		\N	101295	0	36971009	4283893		0
25612	1523	81151	1973-08-09	1973-08-09 00:00:00	1973-08-23	1973-08-23 00:00:00	32020		\N	101880	0	44465007	81151		0
25800	1532	80180	2014-03-13	2014-03-13 00:00:00	\N	\N	32020		\N	102599	0	396275006	80180		0
25919	1538	4112343	2004-07-09	2004-07-09 00:00:00	2004-07-20	2004-07-20 00:00:00	32020		\N	102990	0	195662009	4112343		0
15577	923	378001	1965-04-09	1965-04-09 00:00:00	1965-05-09	1965-05-09 00:00:00	32020		\N	61492	0	62106007	378001		0
26237	1558	4112343	2018-08-12	2018-08-12 00:00:00	2018-08-24	2018-08-24 00:00:00	32020		\N	104310	0	195662009	4112343		0
15881	939	78272	1976-01-27	1976-01-27 00:00:00	1976-02-24	1976-02-24 00:00:00	32020		\N	62479	0	70704007	78272		0
16096	951	260139	1990-12-09	1990-12-09 00:00:00	1990-12-23	1990-12-23 00:00:00	32020		\N	63166	0	10509002	260139		0
26748	1585	28060	1942-09-30	1942-09-30 00:00:00	1942-10-08	1942-10-08 00:00:00	32020		\N	106298	0	43878008	28060		0
16404	970	4112343	1972-12-11	1972-12-11 00:00:00	1972-12-24	1972-12-24 00:00:00	32020		\N	64546	0	195662009	4112343		0
16540	975	378001	2018-12-23	2018-12-23 00:00:00	2019-02-21	2019-02-21 00:00:00	32020		\N	65023	0	62106007	378001		0
27258	1608	28060	1960-06-23	1960-06-23 00:00:00	1960-07-03	1960-07-03 00:00:00	32020		\N	108043	0	43878008	28060		0
27469	1622	78272	1998-11-17	1998-11-17 00:00:00	1998-12-08	1998-12-08 00:00:00	32020		\N	108935	0	70704007	78272		0
17094	1022	372328	1969-07-17	1969-07-17 00:00:00	1970-03-17	1970-03-17 00:00:00	32020		\N	67233	0	65363002	372328		0
27797	1640	28060	1948-05-11	1948-05-11 00:00:00	1948-05-24	1948-05-24 00:00:00	32020		\N	110028	0	43878008	28060		0
28005	1656	4294548	1992-01-18	1992-01-18 00:00:00	1992-04-18	1992-04-18 00:00:00	32020		\N	111099	0	75498004	4294548		0
28058	1658	81151	1990-03-27	1990-03-27 00:00:00	1990-04-10	1990-04-10 00:00:00	32020		\N	111380	0	44465007	81151		0
28250	1669	4218389	2012-05-15	2012-05-15 00:00:00	2012-06-12	2012-06-12 00:00:00	32020		\N	112071	0	39848009	4218389		0
28446	1683	4285898	2013-04-27	2013-04-27 00:00:00	\N	\N	32020		\N	112817	0	68496003	4285898		0
18057	1085	40481087	1973-11-20	1973-11-20 00:00:00	1973-12-04	1973-12-04 00:00:00	32020		\N	71257	0	444814009	40481087		0
28732	1702	40481087	1968-03-23	1968-03-23 00:00:00	1968-04-06	1968-04-06 00:00:00	32020		\N	113774	0	444814009	40481087		0
18400	1107	40481087	1949-06-15	1949-06-15 00:00:00	1949-06-29	1949-06-29 00:00:00	32020		\N	72842	0	444814009	40481087		0
18573	1117	40481087	1999-10-27	1999-10-27 00:00:00	1999-11-10	1999-11-10 00:00:00	32020		\N	73573	0	444814009	40481087		0
18753	1128	80180	2006-04-08	2006-04-08 00:00:00	\N	\N	32020		\N	74307	0	396275006	80180		0
18906	1136	260139	2014-07-08	2014-07-08 00:00:00	2014-07-22	2014-07-22 00:00:00	32020		\N	74871	0	10509002	260139		0
19073	1145	4112343	1940-05-02	1940-05-02 00:00:00	1940-05-11	1940-05-11 00:00:00	32020		\N	75560	0	195662009	4112343		0
19219	1150	40481087	2012-02-25	2012-02-25 00:00:00	2012-03-10	2012-03-10 00:00:00	32020		\N	76018	0	444814009	40481087		0
29899	1769	40481087	2012-12-09	2012-12-09 00:00:00	2012-12-16	2012-12-16 00:00:00	32020		\N	118297	0	444814009	40481087		0
30113	1780	4112343	1967-11-04	1967-11-04 00:00:00	1967-11-15	1967-11-15 00:00:00	32020		\N	119106	0	195662009	4112343		0
30233	1786	4294548	2001-03-30	2001-03-30 00:00:00	2001-06-22	2001-06-22 00:00:00	32020		\N	119739	0	75498004	4294548		0
30443	1794	260139	1978-07-29	1978-07-29 00:00:00	1978-08-05	1978-08-05 00:00:00	32020		\N	120302	0	10509002	260139		0
20082	1211	40481087	2000-02-29	2000-02-29 00:00:00	2000-03-07	2000-03-07 00:00:00	32020		\N	79514	0	444814009	40481087		0
30718	1814	440086	1952-04-17	1952-04-17 00:00:00	1958-04-26	1958-04-26 00:00:00	32020		\N	121409	0	192127007	440086		0
20384	1227	313217	2016-04-06	2016-04-06 00:00:00	\N	\N	32020		\N	80766	0	49436004	313217		0
31054	1840	4294548	1985-05-25	1985-05-25 00:00:00	1985-06-15	1985-06-15 00:00:00	32020		\N	122823	0	75498004	4294548		0
31217	1847	40481087	1981-11-09	1981-11-09 00:00:00	1981-11-16	1981-11-16 00:00:00	32020		\N	123554	0	444814009	40481087		0
31387	1854	195588	2005-10-25	2005-10-25 00:00:00	2005-12-20	2005-12-20 00:00:00	32020		\N	124081	0	38822007	195588		0
21037	1264	40481087	1958-09-14	1958-09-14 00:00:00	1958-09-28	1958-09-28 00:00:00	32020		\N	83323	0	444814009	40481087		0
31754	1882	4113008	2010-06-20	2010-06-20 00:00:00	2010-07-04	2010-07-04 00:00:00	32020		\N	125568	0	284549007	4113008		0
21253	1276	260139	1976-09-15	1976-09-15 00:00:00	1976-09-29	1976-09-29 00:00:00	32020		\N	84140	0	10509002	260139		0
21474	1289	4109685	2011-10-30	2011-10-30 00:00:00	2011-11-20	2011-11-20 00:00:00	32020		\N	85244	0	284551006	4109685		0
11119	655	260139	1975-05-24	1975-05-24 00:00:00	1975-05-31	1975-05-31 00:00:00	32020		\N	43347	0	10509002	260139		0
21804	1309	196456	1994-03-21	1994-03-21 00:00:00	1994-03-22	1994-03-22 00:00:00	32020		\N	86444	0	235919008	196456		0
11429	675	192671	1984-04-21	1984-04-21 00:00:00	\N	\N	32020		\N	44638	0	K92.2	35208414		0
22133	1322	40481087	1946-07-07	1946-07-07 00:00:00	1946-07-14	1946-07-14 00:00:00	32020		\N	87793	0	444814009	40481087		0
11770	695	4218389	1984-12-17	1984-12-17 00:00:00	1985-01-14	1985-01-14 00:00:00	32020		\N	46049	0	39848009	4218389		0
22420	1338	30753	1976-11-17	1976-11-17 00:00:00	\N	\N	32020		\N	88733	0	16761005	30753		0
12116	718	4296204	1992-09-05	1992-09-05 00:00:00	1992-09-26	1992-09-26 00:00:00	32020		\N	47526	0	403190006	4296204		0
22775	1359	4112343	1982-02-03	1982-02-03 00:00:00	1982-02-10	1982-02-10 00:00:00	32020		\N	90180	0	195662009	4112343		0
12392	732	4112343	2001-07-04	2001-07-04 00:00:00	2001-07-14	2001-07-14 00:00:00	32020		\N	48571	0	195662009	4112343		0
12578	743	40481087	1995-09-21	1995-09-21 00:00:00	1995-10-12	1995-10-12 00:00:00	32020		\N	49291	0	444814009	40481087		0
12780	755	81151	1979-06-22	1979-06-22 00:00:00	1979-07-13	1979-07-13 00:00:00	32020		\N	50008	0	44465007	81151		0
23409	1397	4112343	1977-02-21	1977-02-21 00:00:00	1977-03-04	1977-03-04 00:00:00	32020		\N	92727	0	195662009	4112343		0
23590	1409	4112343	1967-11-17	1967-11-17 00:00:00	1967-11-24	1967-11-24 00:00:00	32020		\N	93763	0	195662009	4112343		0
23822	1425	81151	1987-09-29	1987-09-29 00:00:00	1987-10-27	1987-10-27 00:00:00	32020		\N	94733	0	44465007	81151		0
13401	789	372328	1972-07-26	1972-07-26 00:00:00	1972-10-02	1972-10-02 00:00:00	32020		\N	52465	0	65363002	372328		0
24163	1441	80180	2012-11-26	2012-11-26 00:00:00	\N	\N	32020		\N	96071	0	396275006	80180		0
24278	1447	40481087	2013-09-18	2013-09-18 00:00:00	2013-09-25	2013-09-25 00:00:00	32020		\N	96423	0	444814009	40481087		0
13899	821	40481087	1966-10-10	1966-10-10 00:00:00	1966-10-24	1966-10-24 00:00:00	32020		\N	54427	0	444814009	40481087		0
14053	830	40481087	1961-08-21	1961-08-21 00:00:00	1961-09-04	1961-09-04 00:00:00	32020		\N	54954	0	444814009	40481087		0
24770	1478	4112343	1966-01-11	1966-01-11 00:00:00	1966-01-20	1966-01-20 00:00:00	32020		\N	98629	0	195662009	4112343		0
24901	1486	372328	1960-01-15	1960-01-15 00:00:00	1960-04-24	1960-04-24 00:00:00	32020		\N	99101	0	65363002	372328		0
14598	863	260139	2018-02-10	2018-02-10 00:00:00	2018-02-24	2018-02-24 00:00:00	32020		\N	57144	0	10509002	260139		0
14747	869	372328	1914-01-11	1914-01-11 00:00:00	1914-03-20	1914-03-20 00:00:00	32020		\N	57796	0	65363002	372328		0
25452	1516	4112343	1971-02-28	1971-02-28 00:00:00	1971-03-12	1971-03-12 00:00:00	32020		\N	101293	0	195662009	4112343		0
25613	1523	372328	1957-02-04	1957-02-04 00:00:00	1957-03-19	1957-03-19 00:00:00	32020		\N	101837	0	65363002	372328		0
25801	1532	4283893	2013-12-13	2013-12-13 00:00:00	2014-01-31	2014-01-31 00:00:00	32020		\N	102599	0	36971009	4283893		0
25920	1538	4112343	1980-05-06	1980-05-06 00:00:00	1980-05-17	1980-05-17 00:00:00	32020		\N	103056	0	195662009	4112343		0
15578	923	378001	1995-02-22	1995-02-22 00:00:00	1995-03-24	1995-03-24 00:00:00	32020		\N	61446	0	62106007	378001		0
26238	1558	198809	1962-06-14	1962-06-14 00:00:00	1962-06-14	1962-06-14 00:00:00	32020		\N	104301	0	65275009	198809		0
15882	939	40481087	2006-10-29	2006-10-29 00:00:00	2006-11-19	2006-11-19 00:00:00	32020		\N	62441	0	444814009	40481087		0
16097	951	40481087	1991-09-15	1991-09-15 00:00:00	1991-09-22	1991-09-22 00:00:00	32020		\N	63210	0	444814009	40481087		0
26749	1585	260139	1949-02-15	1949-02-15 00:00:00	1949-02-22	1949-02-22 00:00:00	32020		\N	106303	0	10509002	260139		0
16405	970	4296204	1977-03-27	1977-03-27 00:00:00	1977-04-10	1977-04-10 00:00:00	32020		\N	64475	0	403190006	4296204		0
16541	975	40481087	2006-02-19	2006-02-19 00:00:00	2006-03-12	2006-03-12 00:00:00	32020		\N	65069	0	444814009	40481087		0
27259	1608	257012	1961-12-20	1961-12-20 00:00:00	\N	\N	32020		\N	108019	0	40055000	257012		0
27470	1622	260139	1978-04-07	1978-04-07 00:00:00	1978-04-21	1978-04-21 00:00:00	32020		\N	109006	0	10509002	260139		0
17095	1022	4027663	1998-03-23	1998-03-23 00:00:00	\N	\N	32020		\N	67241	0	13200003	4027663		0
27798	1640	80502	1996-05-08	1996-05-08 00:00:00	\N	\N	32020		\N	110023	0	64859006	80502		0
28006	1656	4112343	1992-07-14	1992-07-14 00:00:00	1992-07-25	1992-07-25 00:00:00	32020		\N	111067	0	195662009	4112343		0
28059	1658	260139	1974-10-12	1974-10-12 00:00:00	1974-10-19	1974-10-19 00:00:00	32020		\N	111357	0	10509002	260139		0
28251	1669	4134304	1998-03-30	1998-03-30 00:00:00	1998-05-29	1998-05-29 00:00:00	32020		\N	112070	0	263102004	4134304		0
28447	1683	40481087	2013-01-12	2013-01-12 00:00:00	2013-02-02	2013-02-02 00:00:00	32020		\N	112817	0	444814009	40481087		0
18058	1085	40481087	1998-07-24	1998-07-24 00:00:00	1998-08-14	1998-08-14 00:00:00	32020		\N	71248	0	444814009	40481087		0
28733	1702	4112343	2011-04-01	2011-04-01 00:00:00	2011-04-14	2011-04-14 00:00:00	32020		\N	113796	0	195662009	4112343		0
18401	1107	4112343	2001-03-21	2001-03-21 00:00:00	2001-04-01	2001-04-01 00:00:00	32020		\N	72844	0	195662009	4112343		0
18574	1117	192671	1978-11-29	1978-11-29 00:00:00	\N	\N	32020		\N	73603	0	K92.2	35208414		0
18754	1128	260139	2017-01-23	2017-01-23 00:00:00	2017-01-30	2017-01-30 00:00:00	32020		\N	74318	0	10509002	260139		0
18907	1136	4112343	1999-09-19	1999-09-19 00:00:00	1999-09-26	1999-09-26 00:00:00	32020		\N	74811	0	195662009	4112343		0
19074	1145	4112343	1940-12-10	1940-12-10 00:00:00	1940-12-23	1940-12-23 00:00:00	32020		\N	75561	0	195662009	4112343		0
19220	1151	260139	2014-01-26	2014-01-26 00:00:00	2014-02-09	2014-02-09 00:00:00	32020		\N	76129	0	10509002	260139		0
29900	1769	260139	2007-12-21	2007-12-21 00:00:00	2008-01-04	2008-01-04 00:00:00	32020		\N	118296	0	10509002	260139		0
30114	1780	40481087	2002-10-22	2002-10-22 00:00:00	2002-11-12	2002-11-12 00:00:00	32020		\N	119150	0	444814009	40481087		0
30234	1786	4112343	1988-07-29	1988-07-29 00:00:00	1988-08-09	1988-08-09 00:00:00	32020		\N	119720	0	195662009	4112343		0
30445	1794	4112343	1986-12-15	1986-12-15 00:00:00	1986-12-24	1986-12-24 00:00:00	32020		\N	120307	0	195662009	4112343		0
20083	1211	260139	1992-01-31	1992-01-31 00:00:00	1992-02-07	1992-02-07 00:00:00	32020		\N	79652	0	10509002	260139		0
30719	1814	4112343	1958-06-16	1958-06-16 00:00:00	1958-06-25	1958-06-25 00:00:00	32020		\N	121415	0	195662009	4112343		0
20385	1227	4278672	1943-03-27	1943-03-27 00:00:00	1943-05-26	1943-05-26 00:00:00	32020		\N	80815	0	65966004	4278672		0
31055	1840	4059173	1986-08-19	1986-08-19 00:00:00	1986-11-17	1986-11-17 00:00:00	32020		\N	122840	0	16114001	4059173		0
31218	1847	255848	1995-06-15	1995-06-15 00:00:00	\N	\N	32020		\N	123520	0	233604007	255848		0
31388	1854	4051466	1972-11-09	1972-11-09 00:00:00	1993-01-05	1993-01-05 00:00:00	32020		\N	124059	0	233678006	4051466		0
21038	1264	4112343	2017-09-30	2017-09-30 00:00:00	2017-10-09	2017-10-09 00:00:00	32020		\N	83307	0	195662009	4112343		0
31755	1882	40481087	1973-04-23	1973-04-23 00:00:00	1973-04-30	1973-04-30 00:00:00	32020		\N	125534	0	444814009	40481087		0
21254	1276	80180	1995-08-21	1995-08-21 00:00:00	\N	\N	32020		\N	84209	0	396275006	80180		0
21475	1289	372328	1962-11-08	1962-11-08 00:00:00	1963-02-19	1963-02-19 00:00:00	32020		\N	85230	0	65363002	372328		0
11120	655	4112343	1989-09-05	1989-09-05 00:00:00	1989-09-18	1989-09-18 00:00:00	32020		\N	43413	0	195662009	4112343		0
21805	1309	198809	1994-03-21	1994-03-21 00:00:00	1994-03-22	1994-03-22 00:00:00	32020		\N	86444	0	65275009	198809		0
11430	675	4112343	2013-12-19	2013-12-19 00:00:00	2013-12-30	2013-12-30 00:00:00	32020		\N	44591	0	195662009	4112343		0
22134	1322	4156265	1963-05-09	1963-05-09 00:00:00	1963-05-30	1963-05-30 00:00:00	32020		\N	87783	0	370247008	4156265		0
11771	695	40481087	2007-12-09	2007-12-09 00:00:00	2007-12-23	2007-12-23 00:00:00	32020		\N	46018	0	444814009	40481087		0
22421	1338	4310024	1975-03-28	1975-03-28 00:00:00	\N	\N	32020		\N	88733	0	424802006	4310024		0
12117	718	440086	1978-02-23	1978-02-23 00:00:00	1978-03-30	1978-03-30 00:00:00	32020		\N	47425	0	192127007	440086		0
22776	1359	4294548	1972-01-07	1972-01-07 00:00:00	1972-05-19	1972-05-19 00:00:00	32020		\N	90203	0	75498004	4294548		0
12393	732	4112343	1991-06-05	1991-06-05 00:00:00	1991-06-12	1991-06-12 00:00:00	32020		\N	48569	0	195662009	4112343		0
12579	743	257012	1983-11-06	1983-11-06 00:00:00	\N	\N	32020		\N	49253	0	40055000	257012		0
12781	755	81151	2013-02-28	2013-02-28 00:00:00	2013-03-14	2013-03-14 00:00:00	32020		\N	50011	0	44465007	81151		0
23410	1397	81151	1986-01-31	1986-01-31 00:00:00	1986-02-14	1986-02-14 00:00:00	32020		\N	92837	0	44465007	81151		0
23591	1409	4112343	1996-12-18	1996-12-18 00:00:00	1996-12-27	1996-12-27 00:00:00	32020		\N	93715	0	195662009	4112343		0
23823	1425	40481087	1969-07-29	1969-07-29 00:00:00	1969-08-05	1969-08-05 00:00:00	32020		\N	94786	0	444814009	40481087		0
13402	789	260139	1994-12-28	1994-12-28 00:00:00	1995-01-04	1995-01-04 00:00:00	32020		\N	52510	0	10509002	260139		0
24164	1441	4112343	1971-03-11	1971-03-11 00:00:00	1971-03-20	1971-03-20 00:00:00	32020		\N	96034	0	195662009	4112343		0
24279	1447	4156265	1963-06-01	1963-06-01 00:00:00	1963-06-15	1963-06-15 00:00:00	32020		\N	96480	0	370247008	4156265		0
13900	821	40481087	1965-05-19	1965-05-19 00:00:00	1965-06-09	1965-06-09 00:00:00	32020		\N	54428	0	444814009	40481087		0
14054	830	40481087	1985-08-18	1985-08-18 00:00:00	1985-09-01	1985-09-01 00:00:00	32020		\N	54969	0	444814009	40481087		0
24771	1478	372328	1962-04-15	1962-04-15 00:00:00	1962-05-29	1962-05-29 00:00:00	32020		\N	98562	0	65363002	372328		0
24902	1486	372328	1960-05-24	1960-05-24 00:00:00	1961-04-30	1961-04-30 00:00:00	32020		\N	99153	0	65363002	372328		0
14599	863	4218389	1953-12-24	1953-12-24 00:00:00	1954-01-21	1954-01-21 00:00:00	32020		\N	57177	0	39848009	4218389		0
14748	869	4155034	1952-06-23	1952-06-23 00:00:00	1952-07-07	1952-07-07 00:00:00	32020		\N	57725	0	283371005	4155034		0
25453	1516	4152936	2000-04-24	2000-04-24 00:00:00	2000-05-08	2000-05-08 00:00:00	32020		\N	101272	0	283385000	4152936		0
25614	1523	80180	1996-01-21	1996-01-21 00:00:00	\N	\N	32020		\N	101876	0	396275006	80180		0
25802	1532	4112343	2018-09-27	2018-09-27 00:00:00	2018-10-06	2018-10-06 00:00:00	32020		\N	102611	0	195662009	4112343		0
25921	1538	40481087	1991-03-06	1991-03-06 00:00:00	1991-03-13	1991-03-13 00:00:00	32020		\N	103061	0	444814009	40481087		0
15579	923	80180	1995-02-26	1995-02-26 00:00:00	\N	\N	32020		\N	61446	0	396275006	80180		0
26239	1558	196456	1962-06-14	1962-06-14 00:00:00	1962-06-14	1962-06-14 00:00:00	32020		\N	104301	0	235919008	196456		0
15883	939	40481087	1988-03-30	1988-03-30 00:00:00	1988-04-20	1988-04-20 00:00:00	32020		\N	62431	0	444814009	40481087		0
16098	951	372328	1957-11-22	1957-11-22 00:00:00	1957-12-18	1957-12-18 00:00:00	32020		\N	63168	0	65363002	372328		0
26750	1585	372328	1931-01-01	1931-01-01 00:00:00	1931-07-05	1931-07-05 00:00:00	32020		\N	106308	0	65363002	372328		0
16406	970	4112343	1988-11-10	1988-11-10 00:00:00	1988-11-21	1988-11-21 00:00:00	32020		\N	64548	0	195662009	4112343		0
16542	975	40481087	1983-05-18	1983-05-18 00:00:00	1983-06-08	1983-06-08 00:00:00	32020		\N	65032	0	444814009	40481087		0
27260	1608	40481087	1943-03-30	1943-03-30 00:00:00	1943-04-13	1943-04-13 00:00:00	32020		\N	108040	0	444814009	40481087		0
27471	1622	81151	2000-10-28	2000-10-28 00:00:00	2000-12-02	2000-12-02 00:00:00	32020		\N	108936	0	44465007	81151		0
17096	1022	40481087	1974-02-25	1974-02-25 00:00:00	1974-03-11	1974-03-11 00:00:00	32020		\N	67223	0	444814009	40481087		0
27799	1640	40481087	1942-10-12	1942-10-12 00:00:00	1942-10-19	1942-10-19 00:00:00	32020		\N	110080	0	444814009	40481087		0
28007	1656	4134304	1992-06-10	1992-06-10 00:00:00	1992-08-09	1992-08-09 00:00:00	32020		\N	111151	0	263102004	4134304		0
28060	1658	260139	2008-03-13	2008-03-13 00:00:00	2008-03-27	2008-03-27 00:00:00	32020		\N	111329	0	10509002	260139		0
28252	1669	80180	1998-10-15	1998-10-15 00:00:00	\N	\N	32020		\N	112053	0	396275006	80180		0
28448	1683	375671	2014-08-22	2014-08-22 00:00:00	2014-09-21	2014-09-21 00:00:00	32020		\N	112773	0	62564004	375671		0
18059	1085	40481087	2006-08-29	2006-08-29 00:00:00	2006-09-19	2006-09-19 00:00:00	32020		\N	71259	0	444814009	40481087		0
28734	1702	40481087	1996-10-06	1996-10-06 00:00:00	1996-10-13	1996-10-13 00:00:00	32020		\N	113808	0	444814009	40481087		0
18402	1107	372328	1928-08-10	1928-08-10 00:00:00	1928-10-26	1928-10-26 00:00:00	32020		\N	72916	0	65363002	372328		0
18575	1117	260139	2002-06-30	2002-06-30 00:00:00	2002-07-07	2002-07-07 00:00:00	32020		\N	73566	0	10509002	260139		0
18755	1128	40481087	1996-07-08	1996-07-08 00:00:00	1996-07-29	1996-07-29 00:00:00	32020		\N	74350	0	444814009	40481087		0
18908	1136	4112343	1989-11-15	1989-11-15 00:00:00	1989-11-23	1989-11-23 00:00:00	32020		\N	74859	0	195662009	4112343		0
19075	1145	260139	1977-03-12	1977-03-12 00:00:00	1977-03-26	1977-03-26 00:00:00	32020		\N	75573	0	10509002	260139		0
19221	1151	28060	1986-11-14	1986-11-14 00:00:00	1986-11-25	1986-11-25 00:00:00	32020		\N	76123	0	43878008	28060		0
29901	1769	40481087	2003-03-05	2003-03-05 00:00:00	2003-03-19	2003-03-19 00:00:00	32020		\N	118300	0	444814009	40481087		0
30115	1780	4051466	1967-06-22	1967-06-22 00:00:00	1985-03-12	1985-03-12 00:00:00	32020		\N	119105	0	233678006	4051466		0
30235	1786	81151	2014-04-06	2014-04-06 00:00:00	2014-04-20	2014-04-20 00:00:00	32020		\N	119708	0	44465007	81151		0
30453	1796	4112343	2005-07-10	2005-07-10 00:00:00	2005-07-20	2005-07-20 00:00:00	32020		\N	120386	0	195662009	4112343		0
20084	1211	372328	1969-03-25	1969-03-25 00:00:00	1969-10-08	1969-10-08 00:00:00	32020		\N	79546	0	65363002	372328		0
30720	1814	40481087	2002-10-27	2002-10-27 00:00:00	2002-11-10	2002-11-10 00:00:00	32020		\N	121396	0	444814009	40481087		0
20386	1227	372328	1940-10-08	1940-10-08 00:00:00	1941-01-29	1941-01-29 00:00:00	32020		\N	80857	0	65363002	372328		0
31056	1840	40481087	1985-11-19	1985-11-19 00:00:00	1985-12-10	1985-12-10 00:00:00	32020		\N	122796	0	444814009	40481087		0
31219	1847	260139	1949-05-10	1949-05-10 00:00:00	1949-05-17	1949-05-17 00:00:00	32020		\N	123575	0	10509002	260139		0
31389	1854	40481087	1975-05-20	1975-05-20 00:00:00	1975-06-10	1975-06-10 00:00:00	32020		\N	124060	0	444814009	40481087		0
21039	1264	261325	1986-05-02	1986-05-02 00:00:00	\N	\N	32020		\N	83300	0	87433001	261325		0
31756	1882	40486433	1970-08-17	1970-08-17 00:00:00	1987-08-15	1987-08-15 00:00:00	32020		\N	125533	0	446096008	40486433		0
21255	1276	4112343	1963-10-17	1963-10-17 00:00:00	1963-10-28	1963-10-28 00:00:00	32020		\N	84141	0	195662009	4112343		0
21476	1289	4283893	1966-06-25	1966-06-25 00:00:00	1966-11-26	1966-11-26 00:00:00	32020		\N	85206	0	36971009	4283893		0
11121	656	4112343	1972-10-29	1972-10-29 00:00:00	1972-11-07	1972-11-07 00:00:00	32020		\N	43461	0	195662009	4112343		0
21806	1309	372328	1984-04-25	1984-04-25 00:00:00	1986-06-11	1986-06-11 00:00:00	32020		\N	86526	0	65363002	372328		0
11431	675	439777	1981-02-08	1981-02-08 00:00:00	\N	\N	32020		\N	44708	0	271737000	439777		0
22135	1322	4112343	1954-08-08	1954-08-08 00:00:00	1954-08-15	1954-08-15 00:00:00	32020		\N	87788	0	195662009	4112343		0
11772	695	28060	1976-06-12	1976-06-12 00:00:00	1976-06-20	1976-06-20 00:00:00	32020		\N	46006	0	43878008	28060		0
22422	1338	4112343	1999-01-26	1999-01-26 00:00:00	1999-02-06	1999-02-06 00:00:00	32020		\N	88743	0	195662009	4112343		0
12118	718	260139	2016-01-27	2016-01-27 00:00:00	2016-02-03	2016-02-03 00:00:00	32020		\N	47461	0	10509002	260139		0
22777	1359	4294548	1991-01-20	1991-01-20 00:00:00	1991-05-19	1991-05-19 00:00:00	32020		\N	90196	0	75498004	4294548		0
12394	732	4283893	2007-07-10	2007-07-10 00:00:00	2007-11-13	2007-11-13 00:00:00	32020		\N	48584	0	36971009	4283893		0
12580	743	4296205	1991-11-08	1991-11-08 00:00:00	1991-12-06	1991-12-06 00:00:00	32020		\N	49243	0	403191005	4296205		0
12782	755	40481087	1947-12-07	1947-12-07 00:00:00	1947-12-14	1947-12-14 00:00:00	32020		\N	50090	0	444814009	40481087		0
23411	1397	133834	1977-08-23	1977-08-23 00:00:00	1994-05-26	1994-05-26 00:00:00	32020		\N	92728	0	24079001	133834		0
23592	1409	4294548	1992-10-10	1992-10-10 00:00:00	1992-12-12	1992-12-12 00:00:00	32020		\N	93766	0	75498004	4294548		0
23824	1425	260139	1946-08-01	1946-08-01 00:00:00	1946-08-15	1946-08-15 00:00:00	32020		\N	94768	0	10509002	260139		0
13403	789	4112343	2003-10-11	2003-10-11 00:00:00	2003-10-23	2003-10-23 00:00:00	32020		\N	52484	0	195662009	4112343		0
24165	1441	4237458	2013-11-01	2013-11-01 00:00:00	2013-12-31	2013-12-31 00:00:00	32020		\N	95954	0	58150001	4237458		0
24280	1447	257012	1993-08-28	1993-08-28 00:00:00	\N	\N	32020		\N	96421	0	40055000	257012		0
13901	821	40481087	1977-09-03	1977-09-03 00:00:00	1977-09-24	1977-09-24 00:00:00	32020		\N	54399	0	444814009	40481087		0
14055	830	81151	1965-11-19	1965-11-19 00:00:00	1965-12-24	1965-12-24 00:00:00	32020		\N	55005	0	44465007	81151		0
24772	1478	195588	1990-03-14	1990-03-14 00:00:00	1990-04-17	1990-04-17 00:00:00	32020		\N	98653	0	38822007	195588		0
24904	1486	40481087	1975-02-09	1975-02-09 00:00:00	1975-02-16	1975-02-16 00:00:00	32020		\N	99135	0	444814009	40481087		0
14600	863	372328	1943-08-10	1943-08-10 00:00:00	1943-09-16	1943-09-16 00:00:00	32020		\N	57202	0	65363002	372328		0
14749	869	40481087	2004-07-21	2004-07-21 00:00:00	2004-07-28	2004-07-28 00:00:00	32020		\N	57798	0	444814009	40481087		0
25454	1516	260139	1988-11-02	1988-11-02 00:00:00	1988-11-09	1988-11-09 00:00:00	32020		\N	101262	0	10509002	260139		0
25615	1523	4142905	1988-11-02	1988-11-02 00:00:00	1989-01-31	1989-01-31 00:00:00	32020		\N	101881	0	33737001	4142905		0
25803	1532	40481087	1977-12-06	1977-12-06 00:00:00	1977-12-20	1977-12-20 00:00:00	32020		\N	102634	0	444814009	40481087		0
25922	1538	4112343	1965-09-26	1965-09-26 00:00:00	1965-10-05	1965-10-05 00:00:00	32020		\N	102953	0	195662009	4112343		0
15580	923	40481087	1999-05-14	1999-05-14 00:00:00	1999-05-28	1999-05-28 00:00:00	32020		\N	61421	0	444814009	40481087		0
26240	1558	40481087	1978-01-11	1978-01-11 00:00:00	1978-02-01	1978-02-01 00:00:00	32020		\N	104382	0	444814009	40481087		0
15884	939	40481087	2001-10-27	2001-10-27 00:00:00	2001-11-03	2001-11-03 00:00:00	32020		\N	62433	0	444814009	40481087		0
16099	951	4218389	1966-12-14	1966-12-14 00:00:00	1967-01-04	1967-01-04 00:00:00	32020		\N	63218	0	39848009	4218389		0
26751	1585	372328	1987-04-12	1987-04-12 00:00:00	1988-03-06	1988-03-06 00:00:00	32020		\N	106336	0	65363002	372328		0
16407	970	81151	1998-11-07	1998-11-07 00:00:00	1998-12-12	1998-12-12 00:00:00	32020		\N	64477	0	44465007	81151		0
16543	975	4156265	1975-10-19	1975-10-19 00:00:00	1975-11-02	1975-11-02 00:00:00	32020		\N	65031	0	370247008	4156265		0
27261	1608	372328	1945-03-08	1945-03-08 00:00:00	1946-02-16	1946-02-16 00:00:00	32020		\N	108027	0	65363002	372328		0
21882	1313	192671	2011-09-04	2011-09-04 00:00:00	\N	\N	32020		\N	86893	0	K92.2	35208414		0
27472	1622	4112343	1977-02-13	1977-02-13 00:00:00	1977-02-22	1977-02-22 00:00:00	32020		\N	108943	0	195662009	4112343		0
17097	1022	40481087	2000-04-28	2000-04-28 00:00:00	2000-05-12	2000-05-12 00:00:00	32020		\N	67255	0	444814009	40481087		0
27800	1640	260139	2003-06-18	2003-06-18 00:00:00	2003-07-02	2003-07-02 00:00:00	32020		\N	110024	0	10509002	260139		0
28008	1656	80180	2018-07-04	2018-07-04 00:00:00	\N	\N	32020		\N	111097	0	396275006	80180		0
28061	1658	260139	2000-06-14	2000-06-14 00:00:00	2000-06-21	2000-06-21 00:00:00	32020		\N	111417	0	10509002	260139		0
28253	1669	4218389	1959-12-29	1959-12-29 00:00:00	1960-01-19	1960-01-19 00:00:00	32020		\N	112068	0	39848009	4218389		0
28449	1683	4283893	1981-12-18	1981-12-18 00:00:00	1982-02-05	1982-02-05 00:00:00	32020		\N	112831	0	36971009	4283893		0
18060	1085	4112343	1988-04-28	1988-04-28 00:00:00	1988-05-07	1988-05-07 00:00:00	32020		\N	71258	0	195662009	4112343		0
28735	1702	4112343	1975-11-30	1975-11-30 00:00:00	1975-12-12	1975-12-12 00:00:00	32020		\N	113806	0	195662009	4112343		0
18403	1107	4112343	1939-05-13	1939-05-13 00:00:00	1939-05-20	1939-05-20 00:00:00	32020		\N	72840	0	195662009	4112343		0
18576	1117	4296204	1982-05-16	1982-05-16 00:00:00	1982-06-13	1982-06-13 00:00:00	32020		\N	73618	0	403190006	4296204		0
18756	1128	4112343	2002-11-26	2002-11-26 00:00:00	2002-12-03	2002-12-03 00:00:00	32020		\N	74332	0	195662009	4112343		0
18909	1136	260139	1974-08-28	1974-08-28 00:00:00	1974-09-11	1974-09-11 00:00:00	32020		\N	74825	0	10509002	260139		0
19076	1145	28060	1939-04-24	1939-04-24 00:00:00	1939-05-06	1939-05-06 00:00:00	32020		\N	75582	0	43878008	28060		0
19222	1151	260139	2019-04-01	2019-04-01 00:00:00	2019-04-08	2019-04-08 00:00:00	32020		\N	76089	0	10509002	260139		0
29902	1769	40481087	1980-11-27	1980-11-27 00:00:00	1980-12-11	1980-12-11 00:00:00	32020		\N	118269	0	444814009	40481087		0
30116	1780	4112343	1972-01-27	1972-01-27 00:00:00	1972-02-06	1972-02-06 00:00:00	32020		\N	119110	0	195662009	4112343		0
30236	1786	4155034	2001-02-22	2001-02-22 00:00:00	2001-03-15	2001-03-15 00:00:00	32020		\N	119707	0	283371005	4155034		0
30454	1796	40481087	1980-04-04	1980-04-04 00:00:00	1980-04-11	1980-04-11 00:00:00	32020		\N	120378	0	444814009	40481087		0
20085	1211	40481087	1998-04-12	1998-04-12 00:00:00	1998-05-03	1998-05-03 00:00:00	32020		\N	79660	0	444814009	40481087		0
30721	1814	4283893	1958-07-20	1958-07-20 00:00:00	1958-09-28	1958-09-28 00:00:00	32020		\N	121358	0	36971009	4283893		0
20387	1227	40481087	2019-04-27	2019-04-27 00:00:00	2019-05-04	2019-05-04 00:00:00	32020		\N	80736	0	444814009	40481087		0
31057	1840	260139	2016-02-17	2016-02-17 00:00:00	2016-02-24	2016-02-24 00:00:00	32020		\N	122825	0	10509002	260139		0
31220	1847	4112343	1923-11-03	1923-11-03 00:00:00	1923-11-14	1923-11-14 00:00:00	32020		\N	123584	0	195662009	4112343		0
31390	1854	4296205	2015-02-08	2015-02-08 00:00:00	2015-03-08	2015-03-08 00:00:00	32020		\N	124134	0	403191005	4296205		0
21040	1264	4112343	1949-12-21	1949-12-21 00:00:00	1949-12-30	1949-12-30 00:00:00	32020		\N	83274	0	195662009	4112343		0
31757	1882	4278672	2015-04-09	2015-04-09 00:00:00	2015-05-09	2015-05-09 00:00:00	32020		\N	125569	0	65966004	4278672		0
21256	1276	4142905	2009-07-17	2009-07-17 00:00:00	2009-09-15	2009-09-15 00:00:00	32020		\N	84134	0	33737001	4142905		0
21477	1289	372328	1963-06-19	1963-06-19 00:00:00	1963-08-20	1963-08-20 00:00:00	32020		\N	85199	0	65363002	372328		0
11122	656	4112343	1966-02-24	1966-02-24 00:00:00	1966-03-03	1966-03-03 00:00:00	32020		\N	43432	0	195662009	4112343		0
21807	1309	28060	1964-05-13	1964-05-13 00:00:00	1964-05-21	1964-05-21 00:00:00	32020		\N	86518	0	43878008	28060		0
11432	675	4142905	1958-08-21	1958-08-21 00:00:00	1958-10-20	1958-10-20 00:00:00	32020		\N	44594	0	33737001	4142905		0
22136	1322	40481087	2017-04-12	2017-04-12 00:00:00	2017-04-26	2017-04-26 00:00:00	32020		\N	87723	0	444814009	40481087		0
11773	695	4112343	1999-11-03	1999-11-03 00:00:00	1999-11-13	1999-11-13 00:00:00	32020		\N	45991	0	195662009	4112343		0
22423	1338	4027663	1969-09-30	1969-09-30 00:00:00	\N	\N	32020		\N	88698	0	13200003	4027663		0
22577	1348	4112343	1985-11-29	1985-11-29 00:00:00	1985-12-11	1985-12-11 00:00:00	32020		\N	89295	0	195662009	4112343		0
22778	1359	4156265	1932-05-28	1932-05-28 00:00:00	1932-06-11	1932-06-11 00:00:00	32020		\N	90154	0	370247008	4156265		0
12395	732	40481087	2016-10-01	2016-10-01 00:00:00	2016-10-22	2016-10-22 00:00:00	32020		\N	48585	0	444814009	40481087		0
12581	744	4112343	1960-03-19	1960-03-19 00:00:00	1960-03-26	1960-03-26 00:00:00	32020		\N	49313	0	195662009	4112343		0
23241	1387	260139	1989-03-19	1989-03-19 00:00:00	1989-03-26	1989-03-26 00:00:00	32020		\N	92044	0	10509002	260139		0
23412	1397	80180	2016-08-26	2016-08-26 00:00:00	\N	\N	32020		\N	92745	0	396275006	80180		0
23593	1409	4112343	2016-12-15	2016-12-15 00:00:00	2016-12-27	2016-12-27 00:00:00	32020		\N	93776	0	195662009	4112343		0
23825	1425	4152936	1938-06-13	1938-06-13 00:00:00	1938-06-27	1938-06-27 00:00:00	32020		\N	94722	0	283385000	4152936		0
13404	789	4278672	1991-02-22	1991-02-22 00:00:00	1991-05-23	1991-05-23 00:00:00	32020		\N	52458	0	65966004	4278672		0
24167	1441	321042	1985-11-11	1985-11-11 00:00:00	\N	\N	32020		\N	95949	0	410429000	321042		0
24281	1447	81151	1990-09-21	1990-09-21 00:00:00	1990-10-12	1990-10-12 00:00:00	32020		\N	96522	0	44465007	81151		0
13902	821	40481087	1955-01-15	1955-01-15 00:00:00	1955-01-22	1955-01-22 00:00:00	32020		\N	54378	0	444814009	40481087		0
14056	830	4112343	1967-06-13	1967-06-13 00:00:00	1967-06-21	1967-06-21 00:00:00	32020		\N	54978	0	195662009	4112343		0
24773	1478	260139	2012-08-14	2012-08-14 00:00:00	2012-08-21	2012-08-21 00:00:00	32020		\N	98575	0	10509002	260139		0
24905	1486	4048171	1960-07-15	1960-07-15 00:00:00	1993-07-18	1993-07-18 00:00:00	32020		\N	99041	0	232353008	4048171		0
14601	863	4112343	1942-04-14	1942-04-14 00:00:00	1942-04-23	1942-04-23 00:00:00	32020		\N	57165	0	195662009	4112343		0
14750	869	260139	1980-06-30	1980-06-30 00:00:00	1980-07-14	1980-07-14 00:00:00	32020		\N	57767	0	10509002	260139		0
25455	1516	4112343	1982-06-15	1982-06-15 00:00:00	1982-06-22	1982-06-22 00:00:00	32020		\N	101337	0	195662009	4112343		0
25616	1523	372328	2001-08-25	2001-08-25 00:00:00	2002-04-30	2002-04-30 00:00:00	32020		\N	101866	0	65363002	372328		0
25804	1532	40481087	1986-04-15	1986-04-15 00:00:00	1986-04-29	1986-04-29 00:00:00	32020		\N	102597	0	444814009	40481087		0
25923	1538	40481087	2008-09-11	2008-09-11 00:00:00	2008-09-25	2008-09-25 00:00:00	32020		\N	103000	0	444814009	40481087		0
15581	923	4146173	1981-08-13	1981-08-13 00:00:00	1981-10-12	1981-10-12 00:00:00	32020		\N	61488	0	307731004	4146173		0
26241	1558	40481087	1979-03-22	1979-03-22 00:00:00	1979-03-29	1979-03-29 00:00:00	32020		\N	104371	0	444814009	40481087		0
15885	939	40481087	1989-12-16	1989-12-16 00:00:00	1989-12-23	1989-12-23 00:00:00	32020		\N	62465	0	444814009	40481087		0
16100	951	4112343	1974-08-02	1974-08-02 00:00:00	1974-08-11	1974-08-11 00:00:00	32020		\N	63165	0	195662009	4112343		0
26752	1585	40481087	2000-12-30	2000-12-30 00:00:00	2001-01-20	2001-01-20 00:00:00	32020		\N	106259	0	444814009	40481087		0
16408	970	4112343	1985-09-14	1985-09-14 00:00:00	1985-09-23	1985-09-23 00:00:00	32020		\N	64520	0	195662009	4112343		0
16560	978	4134304	1985-01-24	1985-01-24 00:00:00	1985-04-24	1985-04-24 00:00:00	32020		\N	65152	0	263102004	4134304		0
27262	1608	40481087	1985-02-27	1985-02-27 00:00:00	1985-03-06	1985-03-06 00:00:00	32020		\N	108023	0	444814009	40481087		0
27473	1622	260139	1995-11-14	1995-11-14 00:00:00	1995-11-28	1995-11-28 00:00:00	32020		\N	108970	0	10509002	260139		0
17098	1022	40481087	1967-04-20	1967-04-20 00:00:00	1967-04-27	1967-04-27 00:00:00	32020		\N	67221	0	444814009	40481087		0
27801	1641	378001	1976-08-21	1976-08-21 00:00:00	1976-10-20	1976-10-20 00:00:00	32020		\N	110176	0	62106007	378001		0
28009	1656	195588	2001-11-20	2001-11-20 00:00:00	2002-01-02	2002-01-02 00:00:00	32020		\N	111070	0	38822007	195588		0
28062	1658	40481087	1981-08-02	1981-08-02 00:00:00	1981-08-16	1981-08-16 00:00:00	32020		\N	111318	0	444814009	40481087		0
28254	1669	317576	1996-11-18	1996-11-18 00:00:00	\N	\N	32020		\N	112115	0	53741008	317576		0
28450	1683	4237458	2012-10-01	2012-10-01 00:00:00	2012-11-30	2012-11-30 00:00:00	32020		\N	112772	0	58150001	4237458		0
18061	1085	372328	1965-10-29	1965-10-29 00:00:00	1965-12-11	1965-12-11 00:00:00	32020		\N	71261	0	65363002	372328		0
28736	1702	260139	2003-09-25	2003-09-25 00:00:00	2003-10-04	2003-10-04 00:00:00	32020		\N	113831	0	10509002	260139		0
18404	1107	4283893	1971-03-21	1971-03-21 00:00:00	1971-04-18	1971-04-18 00:00:00	32020		\N	72920	0	36971009	4283893		0
18577	1117	4112343	1998-05-25	1998-05-25 00:00:00	1998-06-06	1998-06-06 00:00:00	32020		\N	73565	0	195662009	4112343		0
18757	1128	40481087	1993-02-05	1993-02-05 00:00:00	1993-02-19	1993-02-19 00:00:00	32020		\N	74349	0	444814009	40481087		0
18910	1136	260139	2003-05-22	2003-05-22 00:00:00	2003-06-05	2003-06-05 00:00:00	32020		\N	74838	0	10509002	260139		0
19077	1145	40481087	1965-01-30	1965-01-30 00:00:00	1965-02-20	1965-02-20 00:00:00	32020		\N	75572	0	444814009	40481087		0
19223	1151	4296204	2009-04-14	2009-04-14 00:00:00	2009-05-12	2009-05-12 00:00:00	32020		\N	76100	0	403190006	4296204		0
29903	1769	260139	1978-06-07	1978-06-07 00:00:00	1978-06-21	1978-06-21 00:00:00	32020		\N	118293	0	10509002	260139		0
30117	1780	40481087	1977-07-18	1977-07-18 00:00:00	1977-07-25	1977-07-25 00:00:00	32020		\N	119111	0	444814009	40481087		0
30237	1786	4112343	2014-03-22	2014-03-22 00:00:00	2014-03-29	2014-03-29 00:00:00	32020		\N	119734	0	195662009	4112343		0
30455	1796	4155034	1997-06-28	1997-06-28 00:00:00	1997-07-12	1997-07-12 00:00:00	32020		\N	120433	0	283371005	4155034		0
20086	1211	133834	1967-11-08	1967-11-08 00:00:00	\N	\N	32020		\N	79556	0	24079001	133834		0
30748	1819	81151	1991-06-10	1991-06-10 00:00:00	1991-07-08	1991-07-08 00:00:00	32020		\N	121684	0	44465007	81151		0
20388	1227	40481087	1952-02-13	1952-02-13 00:00:00	1952-03-05	1952-03-05 00:00:00	32020		\N	80779	0	444814009	40481087		0
31058	1840	4112343	1986-10-02	1986-10-02 00:00:00	1986-10-12	1986-10-12 00:00:00	32020		\N	122824	0	195662009	4112343		0
31221	1847	4112343	1926-09-03	1926-09-03 00:00:00	1926-09-13	1926-09-13 00:00:00	32020		\N	123585	0	195662009	4112343		0
31391	1854	260139	2012-12-12	2012-12-12 00:00:00	2012-12-26	2012-12-26 00:00:00	32020		\N	124091	0	10509002	260139		0
21041	1264	260139	2014-05-03	2014-05-03 00:00:00	2014-05-17	2014-05-17 00:00:00	32020		\N	83330	0	10509002	260139		0
31758	1882	80180	2004-07-22	2004-07-22 00:00:00	\N	\N	32020		\N	125530	0	396275006	80180		0
21257	1276	40481087	1966-09-23	1966-09-23 00:00:00	1966-10-14	1966-10-14 00:00:00	32020		\N	84272	0	444814009	40481087		0
21478	1289	260139	1996-03-07	1996-03-07 00:00:00	1996-03-14	1996-03-14 00:00:00	32020		\N	85196	0	10509002	260139		0
21581	1293	40481087	1940-04-02	1940-04-02 00:00:00	1940-04-09	1940-04-09 00:00:00	32020		\N	85509	0	444814009	40481087		0
21808	1309	375671	1956-03-23	1956-03-23 00:00:00	1956-04-22	1956-04-22 00:00:00	32020		\N	86446	0	62564004	375671		0
11433	675	4237458	2013-11-05	2013-11-05 00:00:00	2014-02-03	2014-02-03 00:00:00	32020		\N	44646	0	58150001	4237458		0
22137	1322	378001	1980-01-01	1980-01-01 00:00:00	1980-03-01	1980-03-01 00:00:00	32020		\N	87738	0	62106007	378001		0
11774	695	80180	2006-03-01	2006-03-01 00:00:00	\N	\N	32020		\N	46029	0	396275006	80180		0
22424	1338	40481087	2019-03-03	2019-03-03 00:00:00	2019-03-10	2019-03-10 00:00:00	32020		\N	88721	0	444814009	40481087		0
22578	1348	260139	1942-09-03	1942-09-03 00:00:00	1942-09-17	1942-09-17 00:00:00	32020		\N	89361	0	10509002	260139		0
22779	1359	28060	1961-06-02	1961-06-02 00:00:00	1961-06-11	1961-06-11 00:00:00	32020		\N	90167	0	43878008	28060		0
12396	732	260139	2000-09-16	2000-09-16 00:00:00	2000-09-30	2000-09-30 00:00:00	32020		\N	48575	0	10509002	260139		0
12582	744	4283893	2007-09-23	2007-09-23 00:00:00	2007-11-11	2007-11-11 00:00:00	32020		\N	49330	0	36971009	4283893		0
23242	1387	80180	2008-10-13	2008-10-13 00:00:00	\N	\N	32020		\N	92079	0	396275006	80180		0
23413	1397	4048171	1981-11-25	1981-11-25 00:00:00	\N	\N	32020		\N	92781	0	232353008	4048171		0
23594	1409	40481087	1932-09-29	1932-09-29 00:00:00	1932-10-13	1932-10-13 00:00:00	32020		\N	93718	0	444814009	40481087		0
23826	1425	260139	1996-04-17	1996-04-17 00:00:00	1996-04-24	1996-04-24 00:00:00	32020		\N	94746	0	10509002	260139		0
13405	789	260139	1987-12-07	1987-12-07 00:00:00	1987-12-21	1987-12-21 00:00:00	32020		\N	52462	0	10509002	260139		0
24168	1441	260139	1993-10-10	1993-10-10 00:00:00	1993-10-24	1993-10-24 00:00:00	32020		\N	96050	0	10509002	260139		0
24282	1447	40481087	2016-11-14	2016-11-14 00:00:00	2016-11-28	2016-11-28 00:00:00	32020		\N	96542	0	444814009	40481087		0
13903	821	4113008	1960-06-09	1960-06-09 00:00:00	1960-06-30	1960-06-30 00:00:00	32020		\N	54394	0	284549007	4113008		0
14057	830	40481087	1972-01-08	1972-01-08 00:00:00	1972-01-22	1972-01-22 00:00:00	32020		\N	54957	0	444814009	40481087		0
24774	1478	81151	2013-08-04	2013-08-04 00:00:00	2013-08-18	2013-08-18 00:00:00	32020		\N	98644	0	44465007	81151		0
24906	1486	4112343	1958-12-25	1958-12-25 00:00:00	1959-01-01	1959-01-01 00:00:00	32020		\N	99133	0	195662009	4112343		0
14602	863	40481087	2016-08-29	2016-08-29 00:00:00	2016-09-05	2016-09-05 00:00:00	32020		\N	57143	0	444814009	40481087		0
14751	869	40481087	1979-04-04	1979-04-04 00:00:00	1979-04-25	1979-04-25 00:00:00	32020		\N	57766	0	444814009	40481087		0
25456	1516	260139	1952-10-17	1952-10-17 00:00:00	1952-10-24	1952-10-24 00:00:00	32020		\N	101257	0	10509002	260139		0
25617	1523	40481087	1978-10-04	1978-10-04 00:00:00	1978-10-11	1978-10-11 00:00:00	32020		\N	101865	0	444814009	40481087		0
25805	1532	372328	1981-01-01	1981-01-01 00:00:00	1981-03-04	1981-03-04 00:00:00	32020		\N	102612	0	65363002	372328		0
25924	1538	260139	1938-02-21	1938-02-21 00:00:00	1938-02-28	1938-02-28 00:00:00	32020		\N	102951	0	10509002	260139		0
15582	923	40481087	2012-02-03	2012-02-03 00:00:00	2012-02-17	2012-02-17 00:00:00	32020		\N	61435	0	444814009	40481087		0
26242	1558	4027663	1981-04-22	1981-04-22 00:00:00	\N	\N	32020		\N	104320	0	13200003	4027663		0
15886	940	372328	1944-09-16	1944-09-16 00:00:00	1944-11-02	1944-11-02 00:00:00	32020		\N	62569	0	65363002	372328		0
16101	951	4112343	2015-07-21	2015-07-21 00:00:00	2015-07-28	2015-07-28 00:00:00	32020		\N	63167	0	195662009	4112343		0
26753	1585	4112343	1941-12-24	1941-12-24 00:00:00	1942-01-01	1942-01-01 00:00:00	32020		\N	106296	0	195662009	4112343		0
16409	970	40481087	1952-12-14	1952-12-14 00:00:00	1952-12-21	1952-12-21 00:00:00	32020		\N	64479	0	444814009	40481087		0
16561	978	40481087	2018-11-09	2018-11-09 00:00:00	2018-11-30	2018-11-30 00:00:00	32020		\N	65145	0	444814009	40481087		0
27263	1608	4112343	1985-06-01	1985-06-01 00:00:00	1985-06-13	1985-06-13 00:00:00	32020		\N	107977	0	195662009	4112343		0
27474	1622	4112343	1997-09-20	1997-09-20 00:00:00	1997-10-02	1997-10-02 00:00:00	32020		\N	108996	0	195662009	4112343		0
27557	1626	40481087	1990-02-23	1990-02-23 00:00:00	1990-03-02	1990-03-02 00:00:00	32020		\N	109205	0	444814009	40481087		0
27802	1641	40481087	1995-07-05	1995-07-05 00:00:00	1995-07-26	1995-07-26 00:00:00	32020		\N	110167	0	444814009	40481087		0
28010	1656	257012	1992-02-22	1992-02-22 00:00:00	\N	\N	32020		\N	111120	0	40055000	257012		0
28063	1658	4027663	1936-04-24	1936-04-24 00:00:00	\N	\N	32020		\N	111331	0	13200003	4027663		0
28255	1669	4310024	1997-05-23	1997-05-23 00:00:00	\N	\N	32020		\N	112115	0	424802006	4310024		0
28451	1683	378001	2003-03-09	2003-03-09 00:00:00	2003-05-08	2003-05-08 00:00:00	32020		\N	112770	0	62106007	378001		0
18062	1085	4112343	2002-10-07	2002-10-07 00:00:00	2002-10-14	2002-10-14 00:00:00	32020		\N	71290	0	195662009	4112343		0
28737	1702	4112343	1978-05-03	1978-05-03 00:00:00	1978-05-14	1978-05-14 00:00:00	32020		\N	113807	0	195662009	4112343		0
18405	1107	260139	1930-04-03	1930-04-03 00:00:00	1930-04-10	1930-04-10 00:00:00	32020		\N	72860	0	10509002	260139		0
18578	1117	40481087	1968-08-12	1968-08-12 00:00:00	1968-09-02	1968-09-02 00:00:00	32020		\N	73589	0	444814009	40481087		0
18758	1128	4027663	1995-07-20	1995-07-20 00:00:00	\N	\N	32020		\N	74358	0	13200003	4027663		0
18911	1136	4112343	1993-03-08	1993-03-08 00:00:00	1993-03-21	1993-03-21 00:00:00	32020		\N	74867	0	195662009	4112343		0
19078	1145	40481087	1991-06-22	1991-06-22 00:00:00	1991-07-06	1991-07-06 00:00:00	32020		\N	75638	0	444814009	40481087		0
19224	1151	260139	1994-12-30	1994-12-30 00:00:00	1995-01-06	1995-01-06 00:00:00	32020		\N	76086	0	10509002	260139		0
29904	1769	378001	1983-06-10	1983-06-10 00:00:00	1983-07-10	1983-07-10 00:00:00	32020		\N	118283	0	62106007	378001		0
30118	1780	378001	1966-06-10	1966-06-10 00:00:00	1966-08-09	1966-08-09 00:00:00	32020		\N	119141	0	62106007	378001		0
30238	1786	28060	1959-12-18	1959-12-18 00:00:00	1959-12-26	1959-12-26 00:00:00	32020		\N	119682	0	43878008	28060		0
30456	1796	4112343	1987-01-18	1987-01-18 00:00:00	1987-01-27	1987-01-27 00:00:00	32020		\N	120400	0	195662009	4112343		0
30545	1801	4084167	1955-05-17	1955-05-17 00:00:00	1955-05-18	1955-05-18 00:00:00	32020		\N	120748	0	241929008	4084167		0
30749	1819	260139	1989-08-20	1989-08-20 00:00:00	1989-08-27	1989-08-27 00:00:00	32020		\N	121645	0	10509002	260139		0
20389	1227	260139	1956-01-08	1956-01-08 00:00:00	1956-01-22	1956-01-22 00:00:00	32020		\N	80845	0	10509002	260139		0
31059	1840	4294548	1994-04-15	1994-04-15 00:00:00	1994-05-13	1994-05-13 00:00:00	32020		\N	122815	0	75498004	4294548		0
31222	1847	260139	1926-12-24	1926-12-24 00:00:00	1927-01-07	1927-01-07 00:00:00	32020		\N	123586	0	10509002	260139		0
31392	1854	4218389	1999-08-03	1999-08-03 00:00:00	1999-08-31	1999-08-31 00:00:00	32020		\N	124132	0	39848009	4218389		0
21042	1264	40481087	1988-06-29	1988-06-29 00:00:00	1988-07-13	1988-07-13 00:00:00	32020		\N	83276	0	444814009	40481087		0
31759	1882	4296204	1999-03-06	1999-03-06 00:00:00	1999-03-20	1999-03-20 00:00:00	32020		\N	125567	0	403190006	4296204		0
21258	1276	40481087	1984-11-16	1984-11-16 00:00:00	1984-11-30	1984-11-30 00:00:00	32020		\N	84142	0	444814009	40481087		0
21479	1289	40481087	1981-10-28	1981-10-28 00:00:00	1981-11-11	1981-11-11 00:00:00	32020		\N	85209	0	444814009	40481087		0
21582	1293	4294548	1979-12-09	1979-12-09 00:00:00	1980-03-30	1980-03-30 00:00:00	32020		\N	85523	0	75498004	4294548		0
21809	1309	260139	1970-08-25	1970-08-25 00:00:00	1970-09-01	1970-09-01 00:00:00	32020		\N	86458	0	10509002	260139		0
11434	675	372328	1949-10-09	1949-10-09 00:00:00	1950-01-24	1950-01-24 00:00:00	32020		\N	44612	0	65363002	372328		0
22138	1322	28060	1937-06-18	1937-06-18 00:00:00	1937-06-25	1937-06-25 00:00:00	32020		\N	87791	0	43878008	28060		0
11775	695	40481087	2014-10-25	2014-10-25 00:00:00	2014-11-08	2014-11-08 00:00:00	32020		\N	46009	0	444814009	40481087		0
22425	1338	195588	1974-09-29	1974-09-29 00:00:00	1974-11-14	1974-11-14 00:00:00	32020		\N	88699	0	38822007	195588		0
22579	1348	4112343	1918-09-09	1918-09-09 00:00:00	1918-09-17	1918-09-17 00:00:00	32020		\N	89280	0	195662009	4112343		0
22780	1359	40481087	1974-02-13	1974-02-13 00:00:00	1974-03-06	1974-03-06 00:00:00	32020		\N	90204	0	444814009	40481087		0
12397	732	80180	2015-11-19	2015-11-19 00:00:00	\N	\N	32020		\N	48560	0	396275006	80180		0
12583	744	80180	1994-07-01	1994-07-01 00:00:00	\N	\N	32020		\N	49296	0	396275006	80180		0
23243	1387	4296205	2001-12-09	2001-12-09 00:00:00	2002-01-06	2002-01-06 00:00:00	32020		\N	92093	0	403191005	4296205		0
23414	1397	4112343	2002-07-18	2002-07-18 00:00:00	2002-07-30	2002-07-30 00:00:00	32020		\N	92764	0	195662009	4112343		0
23595	1409	4112343	2007-03-23	2007-03-23 00:00:00	2007-04-04	2007-04-04 00:00:00	32020		\N	93824	0	195662009	4112343		0
23827	1425	40479768	1954-06-17	1954-06-17 00:00:00	1954-08-23	1954-08-23 00:00:00	32020		\N	94731	0	444470001	40479768		0
13406	789	40481087	1985-02-08	1985-02-08 00:00:00	1985-03-01	1985-03-01 00:00:00	32020		\N	52463	0	444814009	40481087		0
24169	1441	260139	1976-10-08	1976-10-08 00:00:00	1976-10-22	1976-10-22 00:00:00	32020		\N	96029	0	10509002	260139		0
24283	1447	4084167	1970-08-23	1970-08-23 00:00:00	1970-08-23	1970-08-23 00:00:00	32020		\N	96481	0	241929008	4084167		0
13904	821	81893	1984-02-29	1984-02-29 00:00:00	\N	\N	32020		\N	54411	0	64766004	81893		0
14058	830	260139	1973-07-12	1973-07-12 00:00:00	1973-07-19	1973-07-19 00:00:00	32020		\N	55000	0	10509002	260139		0
24775	1478	4296204	1972-01-23	1972-01-23 00:00:00	1972-02-27	1972-02-27 00:00:00	32020		\N	98638	0	403190006	4296204		0
24907	1486	80180	1991-07-16	1991-07-16 00:00:00	\N	\N	32020		\N	99034	0	396275006	80180		0
14603	863	40481087	1937-03-03	1937-03-03 00:00:00	1937-03-10	1937-03-10 00:00:00	32020		\N	57173	0	444814009	40481087		0
14752	869	78272	1920-12-19	1920-12-19 00:00:00	1921-01-02	1921-01-02 00:00:00	32020		\N	57769	0	70704007	78272		0
25457	1516	40481087	1992-10-05	1992-10-05 00:00:00	1992-10-19	1992-10-19 00:00:00	32020		\N	101296	0	444814009	40481087		0
25618	1523	260139	2014-08-14	2014-08-14 00:00:00	2014-08-28	2014-08-28 00:00:00	32020		\N	101888	0	10509002	260139		0
25806	1532	40481087	2004-10-11	2004-10-11 00:00:00	2004-10-25	2004-10-25 00:00:00	32020		\N	102607	0	444814009	40481087		0
25925	1538	4113008	1960-08-23	1960-08-23 00:00:00	1960-09-13	1960-09-13 00:00:00	32020		\N	102945	0	284549007	4113008		0
15583	923	4112343	1978-02-06	1978-02-06 00:00:00	1978-02-18	1978-02-18 00:00:00	32020		\N	61420	0	195662009	4112343		0
26243	1558	372328	1957-02-12	1957-02-12 00:00:00	1957-04-04	1957-04-04 00:00:00	32020		\N	104376	0	65363002	372328		0
15887	940	4112343	1972-03-19	1972-03-19 00:00:00	1972-04-01	1972-04-01 00:00:00	32020		\N	62550	0	195662009	4112343		0
16102	951	40481087	1998-04-24	1998-04-24 00:00:00	1998-05-15	1998-05-15 00:00:00	32020		\N	63211	0	444814009	40481087		0
26754	1585	40481087	1931-04-07	1931-04-07 00:00:00	1931-04-28	1931-04-28 00:00:00	32020		\N	106253	0	444814009	40481087		0
16410	970	40481087	1975-10-17	1975-10-17 00:00:00	1975-11-07	1975-11-07 00:00:00	32020		\N	64489	0	444814009	40481087		0
16562	978	28060	1981-05-29	1981-05-29 00:00:00	1981-06-11	1981-06-11 00:00:00	32020		\N	65175	0	43878008	28060		0
27264	1608	40481087	2010-09-20	2010-09-20 00:00:00	2010-09-27	2010-09-27 00:00:00	32020		\N	108026	0	444814009	40481087		0
27475	1622	40481087	1984-03-03	1984-03-03 00:00:00	1984-03-24	1984-03-24 00:00:00	32020		\N	109029	0	444814009	40481087		0
27558	1626	261325	2000-09-24	2000-09-24 00:00:00	\N	\N	32020		\N	109226	0	87433001	261325		0
27803	1641	4310024	1996-05-09	1996-05-09 00:00:00	\N	\N	32020		\N	110167	0	424802006	4310024		0
28011	1657	4218389	1975-08-02	1975-08-02 00:00:00	1975-08-30	1975-08-30 00:00:00	32020		\N	111185	0	39848009	4218389		0
28064	1658	260139	1952-01-16	1952-01-16 00:00:00	1952-01-30	1952-01-30 00:00:00	32020		\N	111323	0	10509002	260139		0
28256	1669	372328	1964-02-06	1964-02-06 00:00:00	1965-01-18	1965-01-18 00:00:00	32020		\N	112093	0	65363002	372328		0
28452	1683	80180	2014-01-22	2014-01-22 00:00:00	\N	\N	32020		\N	112785	0	396275006	80180		0
18063	1085	80180	2004-11-08	2004-11-08 00:00:00	\N	\N	32020		\N	71290	0	396275006	80180		0
28738	1702	260139	1967-09-20	1967-09-20 00:00:00	1967-10-04	1967-10-04 00:00:00	32020		\N	113798	0	10509002	260139		0
18406	1107	40481087	1943-12-26	1943-12-26 00:00:00	1944-01-09	1944-01-09 00:00:00	32020		\N	72919	0	444814009	40481087		0
18579	1117	4027663	1968-11-14	1968-11-14 00:00:00	\N	\N	32020		\N	73589	0	13200003	4027663		0
29217	1729	78272	2014-02-14	2014-02-14 00:00:00	2014-03-14	2014-03-14 00:00:00	32020		\N	115622	0	70704007	78272		0
18912	1136	4112343	2001-10-18	2001-10-18 00:00:00	2001-10-31	2001-10-31 00:00:00	32020		\N	74869	0	195662009	4112343		0
19079	1145	4134304	2011-12-18	2011-12-18 00:00:00	2012-01-17	2012-01-17 00:00:00	32020		\N	75558	0	263102004	4134304		0
19225	1151	372328	1987-12-19	1987-12-19 00:00:00	1988-04-27	1988-04-27 00:00:00	32020		\N	76125	0	65363002	372328		0
29905	1769	40481087	1981-07-16	1981-07-16 00:00:00	1981-07-30	1981-07-30 00:00:00	32020		\N	118270	0	444814009	40481087		0
30119	1780	372328	2019-02-20	2019-02-20 00:00:00	\N	\N	32020		\N	119157	0	65363002	372328		0
30239	1786	372328	1947-12-03	1947-12-03 00:00:00	1948-02-07	1948-02-07 00:00:00	32020		\N	119740	0	65363002	372328		0
30457	1796	4112343	1980-04-30	1980-04-30 00:00:00	1980-05-11	1980-05-11 00:00:00	32020		\N	120379	0	195662009	4112343		0
30546	1801	260139	1964-01-31	1964-01-31 00:00:00	1964-02-14	1964-02-14 00:00:00	32020		\N	120729	0	10509002	260139		0
30750	1819	40481087	1990-01-17	1990-01-17 00:00:00	1990-01-31	1990-01-31 00:00:00	32020		\N	121688	0	444814009	40481087		0
20390	1227	78272	1954-01-12	1954-01-12 00:00:00	1954-02-16	1954-02-16 00:00:00	32020		\N	80819	0	70704007	78272		0
31060	1840	80180	2016-12-29	2016-12-29 00:00:00	\N	\N	32020		\N	122814	0	396275006	80180		0
31223	1847	40481087	1971-06-05	1971-06-05 00:00:00	1971-06-26	1971-06-26 00:00:00	32020		\N	123553	0	444814009	40481087		0
31393	1854	378001	1985-10-15	1985-10-15 00:00:00	1985-12-14	1985-12-14 00:00:00	32020		\N	124130	0	62106007	378001		0
21043	1264	28060	2004-09-24	2004-09-24 00:00:00	2004-10-05	2004-10-05 00:00:00	32020		\N	83340	0	43878008	28060		0
31760	1882	4278672	1971-09-24	1971-09-24 00:00:00	1971-12-23	1971-12-23 00:00:00	32020		\N	125565	0	65966004	4278672		0
21259	1276	4112343	1962-03-15	1962-03-15 00:00:00	1962-03-24	1962-03-24 00:00:00	32020		\N	84138	0	195662009	4112343		0
21480	1289	81151	2015-09-30	2015-09-30 00:00:00	2015-10-28	2015-10-28 00:00:00	32020		\N	85245	0	44465007	81151		0
21583	1293	40481087	1985-03-13	1985-03-13 00:00:00	1985-03-27	1985-03-27 00:00:00	32020		\N	85549	0	444814009	40481087		0
21810	1309	4152936	1964-01-11	1964-01-11 00:00:00	1964-01-25	1964-01-25 00:00:00	32020		\N	86448	0	283385000	4152936		0
11435	675	260139	1985-03-25	1985-03-25 00:00:00	1985-04-08	1985-04-08 00:00:00	32020		\N	44588	0	10509002	260139		0
22139	1322	260139	1940-07-18	1940-07-18 00:00:00	1940-07-25	1940-07-25 00:00:00	32020		\N	87785	0	10509002	260139		0
11776	695	4112343	2017-05-13	2017-05-13 00:00:00	2017-05-20	2017-05-20 00:00:00	32020		\N	45993	0	195662009	4112343		0
22426	1338	40481087	2003-10-06	2003-10-06 00:00:00	2003-10-20	2003-10-20 00:00:00	32020		\N	88700	0	444814009	40481087		0
22580	1348	378419	1992-11-02	1992-11-02 00:00:00	\N	\N	32020		\N	89356	0	26929004	378419		0
22781	1359	4112343	1993-07-28	1993-07-28 00:00:00	1993-08-04	1993-08-04 00:00:00	32020		\N	90182	0	195662009	4112343		0
12398	732	78272	1977-03-18	1977-03-18 00:00:00	1977-04-15	1977-04-15 00:00:00	32020		\N	48595	0	70704007	78272		0
12584	744	81151	1972-04-12	1972-04-12 00:00:00	1972-05-03	1972-05-03 00:00:00	32020		\N	49352	0	44465007	81151		0
23244	1387	4056621	2013-06-02	2013-06-02 00:00:00	\N	\N	32020		\N	92091	0	197927001	4056621		0
23415	1397	40481087	2006-03-26	2006-03-26 00:00:00	2006-04-02	2006-04-02 00:00:00	32020		\N	92806	0	444814009	40481087		0
23596	1409	40481087	2016-11-22	2016-11-22 00:00:00	2016-12-13	2016-12-13 00:00:00	32020		\N	93745	0	444814009	40481087		0
23828	1425	40481087	1950-09-11	1950-09-11 00:00:00	1950-10-02	1950-10-02 00:00:00	32020		\N	94729	0	444814009	40481087		0
13407	789	81151	1992-03-18	1992-03-18 00:00:00	1992-04-08	1992-04-08 00:00:00	32020		\N	52459	0	44465007	81151		0
24170	1441	4112343	1997-08-07	1997-08-07 00:00:00	1997-08-16	1997-08-16 00:00:00	32020		\N	96053	0	195662009	4112343		0
24284	1447	372328	1974-03-05	1974-03-05 00:00:00	1974-09-19	1974-09-19 00:00:00	32020		\N	96487	0	65363002	372328		0
13905	821	4112343	1981-03-01	1981-03-01 00:00:00	1981-03-13	1981-03-13 00:00:00	32020		\N	54411	0	195662009	4112343		0
14059	830	40481087	1963-07-01	1963-07-01 00:00:00	1963-07-15	1963-07-15 00:00:00	32020		\N	54977	0	444814009	40481087		0
24776	1478	196456	1975-05-03	1975-05-03 00:00:00	1975-05-03	1975-05-03 00:00:00	32020		\N	98639	0	235919008	196456		0
24908	1486	40481087	1990-04-24	1990-04-24 00:00:00	1990-05-15	1990-05-15 00:00:00	32020		\N	99129	0	444814009	40481087		0
14604	863	80180	1964-10-26	1964-10-26 00:00:00	\N	\N	32020		\N	57129	0	396275006	80180		0
14753	869	4112343	1950-07-15	1950-07-15 00:00:00	1950-07-26	1950-07-26 00:00:00	32020		\N	57749	0	195662009	4112343		0
25458	1516	378419	2007-04-23	2007-04-23 00:00:00	\N	\N	32020		\N	101354	0	26929004	378419		0
25619	1523	40481087	2010-07-08	2010-07-08 00:00:00	2010-07-29	2010-07-29 00:00:00	32020		\N	101825	0	444814009	40481087		0
25807	1532	40481087	2013-07-19	2013-07-19 00:00:00	2013-08-09	2013-08-09 00:00:00	32020		\N	102609	0	444814009	40481087		0
25926	1538	40481087	1932-06-26	1932-06-26 00:00:00	1932-07-03	1932-07-03 00:00:00	32020		\N	102948	0	444814009	40481087		0
15584	923	378001	1991-02-13	1991-02-13 00:00:00	1991-04-14	1991-04-14 00:00:00	32020		\N	61495	0	62106007	378001		0
26244	1558	40481087	1955-08-29	1955-08-29 00:00:00	1955-09-05	1955-09-05 00:00:00	32020		\N	104378	0	444814009	40481087		0
15888	940	4112343	1964-05-05	1964-05-05 00:00:00	1964-05-14	1964-05-14 00:00:00	32020		\N	62538	0	195662009	4112343		0
26561	1574	80180	2000-12-11	2000-12-11 00:00:00	\N	\N	32020		\N	105689	0	396275006	80180		0
26755	1585	40481087	1987-03-01	1987-03-01 00:00:00	1987-03-08	1987-03-08 00:00:00	32020		\N	106326	0	444814009	40481087		0
16411	970	4142905	1953-04-04	1953-04-04 00:00:00	1953-07-03	1953-07-03 00:00:00	32020		\N	64473	0	33737001	4142905		0
16563	978	40481087	2008-10-11	2008-10-11 00:00:00	2008-10-25	2008-10-25 00:00:00	32020		\N	65166	0	444814009	40481087		0
27265	1608	260139	2013-05-07	2013-05-07 00:00:00	2013-05-21	2013-05-21 00:00:00	32020		\N	108004	0	10509002	260139		0
27476	1622	81151	2011-11-05	2011-11-05 00:00:00	2011-11-26	2011-11-26 00:00:00	32020		\N	108937	0	44465007	81151		0
27559	1626	372328	1935-10-26	1935-10-26 00:00:00	1935-12-08	1935-12-08 00:00:00	32020		\N	109194	0	65363002	372328		0
27804	1641	40481087	1983-03-09	1983-03-09 00:00:00	1983-03-16	1983-03-16 00:00:00	32020		\N	110164	0	444814009	40481087		0
28012	1657	4112343	2010-08-20	2010-08-20 00:00:00	2010-08-28	2010-08-28 00:00:00	32020		\N	111246	0	195662009	4112343		0
28065	1658	260139	1971-03-31	1971-03-31 00:00:00	1971-04-09	1971-04-09 00:00:00	32020		\N	111279	0	10509002	260139		0
28257	1669	40481087	1974-10-09	1974-10-09 00:00:00	1974-10-30	1974-10-30 00:00:00	32020		\N	112063	0	444814009	40481087		0
28453	1683	4134304	1985-11-03	1985-11-03 00:00:00	1986-02-01	1986-02-01 00:00:00	32020		\N	112768	0	263102004	4134304		0
18064	1085	4112343	1976-05-16	1976-05-16 00:00:00	1976-05-28	1976-05-28 00:00:00	32020		\N	71251	0	195662009	4112343		0
28739	1702	28060	1970-08-05	1970-08-05 00:00:00	1970-08-15	1970-08-15 00:00:00	32020		\N	113775	0	43878008	28060		0
18407	1107	4218389	1979-07-28	1979-07-28 00:00:00	1979-08-25	1979-08-25 00:00:00	32020		\N	72855	0	39848009	4218389		0
18580	1117	4218389	1984-05-03	1984-05-03 00:00:00	1984-05-24	1984-05-24 00:00:00	32020		\N	73619	0	39848009	4218389		0
29218	1729	40481087	2014-05-15	2014-05-15 00:00:00	2014-05-29	2014-05-29 00:00:00	32020		\N	115644	0	444814009	40481087		0
18913	1136	40481087	2007-12-30	2007-12-30 00:00:00	2008-01-20	2008-01-20 00:00:00	32020		\N	74813	0	444814009	40481087		0
19080	1145	195588	1956-08-19	1956-08-19 00:00:00	1956-09-24	1956-09-24 00:00:00	32020		\N	75544	0	38822007	195588		0
19226	1151	372328	1985-11-15	1985-11-15 00:00:00	1986-01-28	1986-01-28 00:00:00	32020		\N	76090	0	65363002	372328		0
29906	1769	372328	1989-03-10	1989-03-10 00:00:00	1989-08-16	1989-08-16 00:00:00	32020		\N	118271	0	65363002	372328		0
30120	1780	4112343	2011-07-06	2011-07-06 00:00:00	2011-07-16	2011-07-16 00:00:00	32020		\N	119096	0	195662009	4112343		0
30240	1786	4278672	1970-11-02	1970-11-02 00:00:00	1971-01-01	1971-01-01 00:00:00	32020		\N	119705	0	65966004	4278672		0
30458	1796	372328	1994-11-11	1994-11-11 00:00:00	1995-05-17	1995-05-17 00:00:00	32020		\N	120427	0	65363002	372328		0
30547	1801	81151	1967-01-05	1967-01-05 00:00:00	1967-01-26	1967-01-26 00:00:00	32020		\N	120751	0	44465007	81151		0
30751	1819	4112343	1981-04-07	1981-04-07 00:00:00	1981-04-15	1981-04-15 00:00:00	32020		\N	121673	0	195662009	4112343		0
20391	1227	40481087	1969-07-11	1969-07-11 00:00:00	1969-07-25	1969-07-25 00:00:00	32020		\N	80751	0	444814009	40481087		0
31061	1840	4112343	1983-01-22	1983-01-22 00:00:00	1983-02-03	1983-02-03 00:00:00	32020		\N	122836	0	195662009	4112343		0
31224	1847	40481087	1960-06-20	1960-06-20 00:00:00	1960-07-04	1960-07-04 00:00:00	32020		\N	123550	0	444814009	40481087		0
31394	1854	4059173	2006-04-26	2006-04-26 00:00:00	2006-07-25	2006-07-25 00:00:00	32020		\N	124133	0	16114001	4059173		0
21044	1264	260139	1993-03-31	1993-03-31 00:00:00	1993-04-14	1993-04-14 00:00:00	32020		\N	83315	0	10509002	260139		0
31761	1882	260139	1973-02-17	1973-02-17 00:00:00	1973-03-03	1973-03-03 00:00:00	32020		\N	125587	0	10509002	260139		0
21260	1276	4278672	2010-08-11	2010-08-11 00:00:00	2010-09-10	2010-09-10 00:00:00	32020		\N	84135	0	65966004	4278672		0
21481	1289	40481087	2005-09-02	2005-09-02 00:00:00	2005-09-23	2005-09-23 00:00:00	32020		\N	85167	0	444814009	40481087		0
21584	1293	40481087	2012-12-07	2012-12-07 00:00:00	2012-12-14	2012-12-14 00:00:00	32020		\N	85567	0	444814009	40481087		0
21811	1309	40481087	1984-11-01	1984-11-01 00:00:00	1984-11-08	1984-11-08 00:00:00	32020		\N	86460	0	444814009	40481087		0
11436	675	4027663	1975-02-10	1975-02-10 00:00:00	\N	\N	32020		\N	44706	0	13200003	4027663		0
22140	1322	40481087	1960-04-30	1960-04-30 00:00:00	1960-05-21	1960-05-21 00:00:00	32020		\N	87789	0	444814009	40481087		0
11777	695	260139	2011-10-31	2011-10-31 00:00:00	2011-11-07	2011-11-07 00:00:00	32020		\N	45992	0	10509002	260139		0
22427	1338	4112343	1961-03-10	1961-03-10 00:00:00	1961-03-17	1961-03-17 00:00:00	32020		\N	88684	0	195662009	4112343		0
22581	1348	40481087	2001-08-09	2001-08-09 00:00:00	2001-08-30	2001-08-30 00:00:00	32020		\N	89307	0	444814009	40481087		0
22782	1359	4112343	1941-07-26	1941-07-26 00:00:00	1941-08-05	1941-08-05 00:00:00	32020		\N	90192	0	195662009	4112343		0
12399	732	40481087	2010-11-05	2010-11-05 00:00:00	2010-11-12	2010-11-12 00:00:00	32020		\N	48580	0	444814009	40481087		0
12586	744	28060	2009-11-03	2009-11-03 00:00:00	2009-11-10	2009-11-10 00:00:00	32020		\N	49350	0	43878008	28060		0
23245	1387	195588	2013-06-02	2013-06-02 00:00:00	2013-07-25	2013-07-25 00:00:00	32020		\N	92091	0	38822007	195588		0
23416	1397	4283893	2013-05-31	2013-05-31 00:00:00	2013-07-26	2013-07-26 00:00:00	32020		\N	92776	0	36971009	4283893		0
23597	1409	40481087	1998-10-16	1998-10-16 00:00:00	1998-10-23	1998-10-23 00:00:00	32020		\N	93774	0	444814009	40481087		0
23829	1425	40481087	1976-09-05	1976-09-05 00:00:00	1976-09-26	1976-09-26 00:00:00	32020		\N	94743	0	444814009	40481087		0
13408	789	28060	1985-03-21	1985-03-21 00:00:00	1985-03-30	1985-03-30 00:00:00	32020		\N	52493	0	43878008	28060		0
24171	1441	4237458	1974-01-20	1974-01-20 00:00:00	1974-02-19	1974-02-19 00:00:00	32020		\N	95947	0	58150001	4237458		0
24285	1447	4294548	1963-07-04	1963-07-04 00:00:00	1963-08-01	1963-08-01 00:00:00	32020		\N	96545	0	75498004	4294548		0
13906	821	40481087	1961-11-22	1961-11-22 00:00:00	1961-11-29	1961-11-29 00:00:00	32020		\N	54426	0	444814009	40481087		0
14060	830	40481087	2000-08-22	2000-08-22 00:00:00	2000-08-29	2000-08-29 00:00:00	32020		\N	54944	0	444814009	40481087		0
24777	1478	198809	1975-05-03	1975-05-03 00:00:00	1975-05-03	1975-05-03 00:00:00	32020		\N	98639	0	65275009	198809		0
24935	1490	4112343	1999-06-27	1999-06-27 00:00:00	1999-07-07	1999-07-07 00:00:00	32020		\N	99374	0	195662009	4112343		0
14605	863	4112343	1945-03-10	1945-03-10 00:00:00	1945-03-19	1945-03-19 00:00:00	32020		\N	57162	0	195662009	4112343		0
14754	869	260139	1960-09-04	1960-09-04 00:00:00	1960-09-11	1960-09-11 00:00:00	32020		\N	57810	0	10509002	260139		0
25459	1516	40481087	1948-03-16	1948-03-16 00:00:00	1948-03-30	1948-03-30 00:00:00	32020		\N	101349	0	444814009	40481087		0
25620	1523	4112343	1996-10-11	1996-10-11 00:00:00	1996-10-18	1996-10-18 00:00:00	32020		\N	101885	0	195662009	4112343		0
25808	1532	372328	1980-08-13	1980-08-13 00:00:00	1980-09-03	1980-09-03 00:00:00	32020		\N	102579	0	65363002	372328		0
25927	1538	40481087	1942-01-17	1942-01-17 00:00:00	1942-01-31	1942-01-31 00:00:00	32020		\N	103053	0	444814009	40481087		0
15585	923	378001	1983-11-01	1983-11-01 00:00:00	1983-12-31	1983-12-31 00:00:00	32020		\N	61493	0	62106007	378001		0
26245	1558	40481087	1965-09-28	1965-09-28 00:00:00	1965-10-19	1965-10-19 00:00:00	32020		\N	104368	0	444814009	40481087		0
15889	940	4294548	1951-05-17	1951-05-17 00:00:00	1951-10-25	1951-10-25 00:00:00	32020		\N	62518	0	75498004	4294548		0
26562	1574	257012	1972-07-09	1972-07-09 00:00:00	\N	\N	32020		\N	105637	0	40055000	257012		0
26756	1585	80180	1966-02-04	1966-02-04 00:00:00	\N	\N	32020		\N	106356	0	396275006	80180		0
16412	970	4113008	1996-07-29	1996-07-29 00:00:00	1996-08-19	1996-08-19 00:00:00	32020		\N	64476	0	284549007	4113008		0
16564	978	40481087	1982-08-24	1982-08-24 00:00:00	1982-08-31	1982-08-31 00:00:00	32020		\N	65178	0	444814009	40481087		0
27266	1608	260139	2017-12-05	2017-12-05 00:00:00	2017-12-12	2017-12-12 00:00:00	32020		\N	107972	0	10509002	260139		0
27477	1622	80180	2012-12-08	2012-12-08 00:00:00	\N	\N	32020		\N	108937	0	396275006	80180		0
27560	1626	4283893	2007-05-08	2007-05-08 00:00:00	2007-06-05	2007-06-05 00:00:00	32020		\N	109193	0	36971009	4283893		0
27805	1641	81151	1967-04-20	1967-04-20 00:00:00	1967-05-11	1967-05-11 00:00:00	32020		\N	110175	0	44465007	81151		0
28013	1657	4112343	1990-07-29	1990-07-29 00:00:00	1990-08-09	1990-08-09 00:00:00	32020		\N	111230	0	195662009	4112343		0
28066	1658	40481087	1952-03-09	1952-03-09 00:00:00	1952-03-30	1952-03-30 00:00:00	32020		\N	111414	0	444814009	40481087		0
28258	1669	4027663	1992-01-25	1992-01-25 00:00:00	\N	\N	32020		\N	112113	0	13200003	4027663		0
28454	1683	40481087	1990-11-29	1990-11-29 00:00:00	1990-12-13	1990-12-13 00:00:00	32020		\N	112780	0	444814009	40481087		0
18065	1085	40481087	2007-11-22	2007-11-22 00:00:00	2007-12-06	2007-12-06 00:00:00	32020		\N	71260	0	444814009	40481087		0
28740	1702	4112343	1973-05-04	1973-05-04 00:00:00	1973-05-11	1973-05-11 00:00:00	32020		\N	113801	0	195662009	4112343		0
18408	1107	81151	1980-08-19	1980-08-19 00:00:00	1980-09-02	1980-09-02 00:00:00	32020		\N	72856	0	44465007	81151		0
18581	1117	81151	1937-11-12	1937-11-12 00:00:00	1937-12-03	1937-12-03 00:00:00	32020		\N	73615	0	44465007	81151		0
29219	1729	4027663	2003-09-01	2003-09-01 00:00:00	\N	\N	32020		\N	115612	0	13200003	4027663		0
18914	1136	4237458	1984-11-02	1984-11-02 00:00:00	1985-01-31	1985-01-31 00:00:00	32020		\N	74865	0	58150001	4237458		0
19081	1145	260139	1964-02-27	1964-02-27 00:00:00	1964-03-12	1964-03-12 00:00:00	32020		\N	75566	0	10509002	260139		0
19227	1151	372328	1990-04-17	1990-04-17 00:00:00	1990-11-06	1990-11-06 00:00:00	32020		\N	76091	0	65363002	372328		0
29907	1769	4112343	1986-09-26	1986-09-26 00:00:00	1986-10-05	1986-10-05 00:00:00	32020		\N	118294	0	195662009	4112343		0
30121	1780	40481087	1994-03-23	1994-03-23 00:00:00	1994-04-13	1994-04-13 00:00:00	32020		\N	119095	0	444814009	40481087		0
30241	1786	40481087	1962-06-21	1962-06-21 00:00:00	1962-07-12	1962-07-12 00:00:00	32020		\N	119683	0	444814009	40481087		0
30459	1796	4283893	1995-10-04	1995-10-04 00:00:00	1995-11-08	1995-11-08 00:00:00	32020		\N	120411	0	36971009	4283893		0
30548	1801	80180	1994-07-31	1994-07-31 00:00:00	\N	\N	32020		\N	120787	0	396275006	80180		0
30752	1819	260139	1998-04-13	1998-04-13 00:00:00	1998-04-27	1998-04-27 00:00:00	32020		\N	121674	0	10509002	260139		0
20392	1227	4237458	1981-02-22	1981-02-22 00:00:00	1981-04-23	1981-04-23 00:00:00	32020		\N	80822	0	58150001	4237458		0
31062	1840	372328	1978-02-02	1978-02-02 00:00:00	1978-03-25	1978-03-25 00:00:00	32020		\N	122827	0	65363002	372328		0
31225	1847	81893	1956-09-23	1956-09-23 00:00:00	\N	\N	32020		\N	\N	0	64766004	81893		0
31395	1854	257012	2015-06-09	2015-06-09 00:00:00	\N	\N	32020		\N	124094	0	40055000	257012		0
21045	1264	378001	1952-09-03	1952-09-03 00:00:00	1952-10-03	1952-10-03 00:00:00	32020		\N	83306	0	62106007	378001		0
31762	1882	4112343	2016-12-21	2016-12-21 00:00:00	2017-01-03	2017-01-03 00:00:00	32020		\N	125518	0	195662009	4112343		0
21261	1276	4112343	2014-02-16	2014-02-16 00:00:00	2014-02-23	2014-02-23 00:00:00	32020		\N	84267	0	195662009	4112343		0
21482	1289	4059173	1997-05-25	1997-05-25 00:00:00	1997-08-23	1997-08-23 00:00:00	32020		\N	85242	0	16114001	4059173		0
21585	1293	378001	1978-12-01	1978-12-01 00:00:00	1978-12-31	1978-12-31 00:00:00	32020		\N	85604	0	62106007	378001		0
21812	1309	4112343	1989-09-02	1989-09-02 00:00:00	1989-09-09	1989-09-09 00:00:00	32020		\N	86443	0	195662009	4112343		0
11437	675	4051466	1952-02-23	1952-02-23 00:00:00	1967-06-07	1967-06-07 00:00:00	32020		\N	44712	0	233678006	4051466		0
22141	1322	80502	2003-08-13	2003-08-13 00:00:00	\N	\N	32020		\N	87686	0	64859006	80502		0
22246	1328	4156265	2014-03-25	2014-03-25 00:00:00	2014-04-15	2014-04-15 00:00:00	32020		\N	88160	0	370247008	4156265		0
22428	1338	372328	1948-04-08	1948-04-08 00:00:00	1948-09-16	1948-09-16 00:00:00	32020		\N	88701	0	65363002	372328		0
22582	1348	4294548	1941-05-10	1941-05-10 00:00:00	1941-05-31	1941-05-31 00:00:00	32020		\N	89342	0	75498004	4294548		0
22783	1359	40481087	1943-06-06	1943-06-06 00:00:00	1943-06-20	1943-06-20 00:00:00	32020		\N	90200	0	444814009	40481087		0
12400	733	4112343	1993-04-11	1993-04-11 00:00:00	1993-04-21	1993-04-21 00:00:00	32020		\N	48616	0	195662009	4112343		0
12587	744	40481087	1958-04-02	1958-04-02 00:00:00	1958-04-16	1958-04-16 00:00:00	32020		\N	49312	0	444814009	40481087		0
23246	1387	440086	1981-03-29	1981-03-29 00:00:00	1987-01-25	1987-01-25 00:00:00	32020		\N	91996	0	192127007	440086		0
23417	1397	4084167	1977-11-14	1977-11-14 00:00:00	1977-11-14	1977-11-14 00:00:00	32020		\N	92836	0	241929008	4084167		0
23598	1409	28060	1993-05-27	1993-05-27 00:00:00	1993-06-03	1993-06-03 00:00:00	32020		\N	93714	0	43878008	28060		0
23830	1425	80180	1977-01-04	1977-01-04 00:00:00	\N	\N	32020		\N	94743	0	396275006	80180		0
13409	789	80180	2014-09-04	2014-09-04 00:00:00	\N	\N	32020		\N	52474	0	396275006	80180		0
24172	1441	4112343	2004-12-24	2004-12-24 00:00:00	2004-12-31	2004-12-31 00:00:00	32020		\N	96054	0	195662009	4112343		0
24286	1447	260139	2009-01-17	2009-01-17 00:00:00	2009-01-31	2009-01-31 00:00:00	32020		\N	96485	0	10509002	260139		0
13907	821	80180	1985-01-24	1985-01-24 00:00:00	\N	\N	32020		\N	54372	0	396275006	80180		0
14061	830	372328	1962-06-22	1962-06-22 00:00:00	1962-10-31	1962-10-31 00:00:00	32020		\N	54971	0	65363002	372328		0
24778	1478	4084167	1990-11-23	1990-11-23 00:00:00	1990-11-23	1990-11-23 00:00:00	32020		\N	98642	0	241929008	4084167		0
24936	1490	40481087	1960-02-03	1960-02-03 00:00:00	1960-02-24	1960-02-24 00:00:00	32020		\N	99361	0	444814009	40481087		0
14606	863	4027663	1953-08-10	1953-08-10 00:00:00	\N	\N	32020		\N	57208	0	13200003	4027663		0
14755	869	4112343	2007-06-18	2007-06-18 00:00:00	2007-06-29	2007-06-29 00:00:00	32020		\N	57755	0	195662009	4112343		0
25460	1516	40481087	2005-07-31	2005-07-31 00:00:00	2005-08-21	2005-08-21 00:00:00	32020		\N	101338	0	444814009	40481087		0
25621	1524	4112343	1968-03-08	1968-03-08 00:00:00	1968-03-21	1968-03-21 00:00:00	32020		\N	101914	0	195662009	4112343		0
25809	1532	260139	2010-04-06	2010-04-06 00:00:00	2010-04-20	2010-04-20 00:00:00	32020		\N	102635	0	10509002	260139		0
25928	1538	372328	1932-04-06	1932-04-06 00:00:00	1932-05-09	1932-05-09 00:00:00	32020		\N	102992	0	65363002	372328		0
15586	923	4112343	1959-09-12	1959-09-12 00:00:00	1959-09-20	1959-09-20 00:00:00	32020		\N	61415	0	195662009	4112343		0
26246	1558	40481087	1993-07-10	1993-07-10 00:00:00	1993-07-24	1993-07-24 00:00:00	32020		\N	104313	0	444814009	40481087		0
15890	940	260139	1956-10-06	1956-10-06 00:00:00	1956-10-20	1956-10-20 00:00:00	32020		\N	62536	0	10509002	260139		0
26563	1574	440086	1972-09-29	1972-09-29 00:00:00	1972-12-29	1972-12-29 00:00:00	32020		\N	105663	0	192127007	440086		0
26757	1585	40481087	1949-08-18	1949-08-18 00:00:00	1949-09-01	1949-09-01 00:00:00	32020		\N	106267	0	444814009	40481087		0
16413	970	40481087	1966-03-18	1966-03-18 00:00:00	1966-04-01	1966-04-01 00:00:00	32020		\N	64480	0	444814009	40481087		0
16565	978	195588	2014-08-05	2014-08-05 00:00:00	2014-09-16	2014-09-16 00:00:00	32020		\N	65167	0	38822007	195588		0
27267	1608	4152936	1974-11-23	1974-11-23 00:00:00	1974-12-14	1974-12-14 00:00:00	32020		\N	108014	0	283385000	4152936		0
27478	1622	40481087	1998-07-13	1998-07-13 00:00:00	1998-07-27	1998-07-27 00:00:00	32020		\N	108992	0	444814009	40481087		0
27561	1626	372328	1939-10-26	1939-10-26 00:00:00	1939-12-10	1939-12-10 00:00:00	32020		\N	109195	0	65363002	372328		0
27806	1641	260139	1963-12-05	1963-12-05 00:00:00	1963-12-12	1963-12-12 00:00:00	32020		\N	110126	0	10509002	260139		0
28014	1657	372328	1949-09-19	1949-09-19 00:00:00	1949-12-14	1949-12-14 00:00:00	32020		\N	111250	0	65363002	372328		0
28067	1658	28060	1925-03-16	1925-03-16 00:00:00	1925-03-24	1925-03-24 00:00:00	32020		\N	111384	0	43878008	28060		0
28259	1669	440086	1970-01-30	1970-01-30 00:00:00	1977-02-07	1977-02-07 00:00:00	32020		\N	112051	0	192127007	440086		0
28455	1683	78272	1987-01-27	1987-01-27 00:00:00	1987-03-03	1987-03-03 00:00:00	32020		\N	112769	0	70704007	78272		0
18066	1085	192671	2004-11-22	2004-11-22 00:00:00	\N	\N	32020		\N	71299	0	K92.2	35208414		0
28741	1702	40481087	1980-12-05	1980-12-05 00:00:00	1980-12-19	1980-12-19 00:00:00	32020		\N	113803	0	444814009	40481087		0
18409	1107	4230399	1927-12-14	1927-12-14 00:00:00	1928-03-13	1928-03-13 00:00:00	32020		\N	72861	0	359817006	4230399		0
18582	1117	4155034	1980-04-12	1980-04-12 00:00:00	1980-04-26	1980-04-26 00:00:00	32020		\N	73617	0	283371005	4155034		0
29220	1729	40481087	2003-02-03	2003-02-03 00:00:00	2003-02-24	2003-02-24 00:00:00	32020		\N	115612	0	444814009	40481087		0
18915	1136	4112343	2014-04-13	2014-04-13 00:00:00	2014-04-22	2014-04-22 00:00:00	32020		\N	74815	0	195662009	4112343		0
19082	1145	4112343	2015-05-31	2015-05-31 00:00:00	2015-06-08	2015-06-08 00:00:00	32020		\N	75636	0	195662009	4112343		0
19228	1151	260139	2000-01-15	2000-01-15 00:00:00	2000-01-22	2000-01-22 00:00:00	32020		\N	76088	0	10509002	260139		0
29908	1770	40481087	1998-12-21	1998-12-21 00:00:00	1998-12-28	1998-12-28 00:00:00	32020		\N	118358	0	444814009	40481087		0
30122	1780	4027663	1994-06-08	1994-06-08 00:00:00	\N	\N	32020		\N	119095	0	13200003	4027663		0
30242	1786	4112343	2010-11-24	2010-11-24 00:00:00	2010-12-04	2010-12-04 00:00:00	32020		\N	119696	0	195662009	4112343		0
30460	1796	40481087	2015-11-28	2015-11-28 00:00:00	2015-12-12	2015-12-12 00:00:00	32020		\N	120402	0	444814009	40481087		0
30553	1804	4112343	1943-03-07	1943-03-07 00:00:00	1943-03-20	1943-03-20 00:00:00	32020		\N	120826	0	195662009	4112343		0
30753	1819	4112343	1989-01-07	1989-01-07 00:00:00	1989-01-20	1989-01-20 00:00:00	32020		\N	121644	0	195662009	4112343		0
20393	1227	4109685	1949-05-24	1949-05-24 00:00:00	1949-06-07	1949-06-07 00:00:00	32020		\N	80817	0	284551006	4109685		0
31086	1842	4027663	1994-08-13	1994-08-13 00:00:00	\N	\N	32020		\N	122962	0	13200003	4027663		0
31226	1847	4112343	1922-11-24	1922-11-24 00:00:00	1922-12-04	1922-12-04 00:00:00	32020		\N	123583	0	195662009	4112343		0
31396	1854	4112343	1973-08-23	1973-08-23 00:00:00	1973-09-03	1973-09-03 00:00:00	32020		\N	124121	0	195662009	4112343		0
21046	1264	40481087	1982-12-09	1982-12-09 00:00:00	1982-12-30	1982-12-30 00:00:00	32020		\N	83314	0	444814009	40481087		0
31763	1882	81151	1972-12-17	1972-12-17 00:00:00	1973-01-21	1973-01-21 00:00:00	32020		\N	125566	0	44465007	81151		0
21262	1276	4084167	1958-05-02	1958-05-02 00:00:00	1958-05-02	1958-05-02 00:00:00	32020		\N	84131	0	241929008	4084167		0
21483	1289	28060	1973-12-14	1973-12-14 00:00:00	1973-12-23	1973-12-23 00:00:00	32020		\N	85193	0	43878008	28060		0
21586	1294	372328	1986-11-24	1986-11-24 00:00:00	1987-11-21	1987-11-21 00:00:00	32020		\N	85652	0	65363002	372328		0
21813	1309	4278672	1958-04-12	1958-04-12 00:00:00	1958-06-12	1958-06-12 00:00:00	32020		\N	86447	0	65966004	4278672		0
11438	675	40481087	1996-04-25	1996-04-25 00:00:00	1996-05-02	1996-05-02 00:00:00	32020		\N	44603	0	444814009	40481087		0
22142	1322	40481087	2018-07-25	2018-07-25 00:00:00	2018-08-15	2018-08-15 00:00:00	32020		\N	87776	0	444814009	40481087		0
22247	1328	4218389	1953-04-15	1953-04-15 00:00:00	1953-05-13	1953-05-13 00:00:00	32020		\N	88208	0	39848009	4218389		0
22429	1339	4112343	1994-04-05	1994-04-05 00:00:00	1994-04-13	1994-04-13 00:00:00	32020		\N	88823	0	195662009	4112343		0
22583	1348	40481087	1921-11-28	1921-11-28 00:00:00	1921-12-05	1921-12-05 00:00:00	32020		\N	89303	0	444814009	40481087		0
22784	1359	40481087	1984-06-29	1984-06-29 00:00:00	1984-07-20	1984-07-20 00:00:00	32020		\N	90181	0	444814009	40481087		0
12401	733	4112343	1947-09-28	1947-09-28 00:00:00	1947-10-10	1947-10-10 00:00:00	32020		\N	48679	0	195662009	4112343		0
12588	744	4113008	2012-01-14	2012-01-14 00:00:00	2012-01-28	2012-01-28 00:00:00	32020		\N	49357	0	284549007	4113008		0
23247	1387	40481087	1983-05-06	1983-05-06 00:00:00	1983-05-20	1983-05-20 00:00:00	32020		\N	92002	0	444814009	40481087		0
23418	1397	260139	1989-02-15	1989-02-15 00:00:00	1989-03-01	1989-03-01 00:00:00	32020		\N	92840	0	10509002	260139		0
23599	1409	4112343	2005-11-14	2005-11-14 00:00:00	2005-11-25	2005-11-25 00:00:00	32020		\N	93744	0	195662009	4112343		0
23831	1425	4146173	1993-06-27	1993-06-27 00:00:00	1993-08-26	1993-08-26 00:00:00	32020		\N	94745	0	307731004	4146173		0
13410	789	4112343	2001-03-16	2001-03-16 00:00:00	2001-03-23	2001-03-23 00:00:00	32020		\N	52483	0	195662009	4112343		0
24173	1441	378001	1996-07-28	1996-07-28 00:00:00	1996-08-27	1996-08-27 00:00:00	32020		\N	95952	0	62106007	378001		0
24287	1447	40481087	1985-12-08	1985-12-08 00:00:00	1985-12-29	1985-12-29 00:00:00	32020		\N	96546	0	444814009	40481087		0
13908	821	260139	2008-11-15	2008-11-15 00:00:00	2008-11-29	2008-11-29 00:00:00	32020		\N	54382	0	10509002	260139		0
14062	830	260139	1984-12-30	1984-12-30 00:00:00	1985-01-06	1985-01-06 00:00:00	32020		\N	54967	0	10509002	260139		0
24779	1478	81151	2016-04-04	2016-04-04 00:00:00	2016-04-18	2016-04-18 00:00:00	32020		\N	98645	0	44465007	81151		0
24937	1490	4112343	1999-04-18	1999-04-18 00:00:00	1999-04-27	1999-04-27 00:00:00	32020		\N	99352	0	195662009	4112343		0
14607	863	372328	1922-07-14	1922-07-14 00:00:00	1922-10-26	1922-10-26 00:00:00	32020		\N	57170	0	65363002	372328		0
14756	869	4132546	2017-10-15	2017-10-15 00:00:00	\N	\N	32020		\N	57728	0	275272006	4166590		0
25461	1516	40481087	1966-02-03	1966-02-03 00:00:00	1966-02-10	1966-02-10 00:00:00	32020		\N	101292	0	444814009	40481087		0
25622	1524	40481087	1973-04-30	1973-04-30 00:00:00	1973-05-07	1973-05-07 00:00:00	32020		\N	101916	0	444814009	40481087		0
25810	1533	260139	1983-10-24	1983-10-24 00:00:00	1983-10-31	1983-10-31 00:00:00	32020		\N	102658	0	10509002	260139		0
25929	1538	4112343	1982-07-08	1982-07-08 00:00:00	1982-07-20	1982-07-20 00:00:00	32020		\N	102974	0	195662009	4112343		0
15587	923	28060	1986-11-05	1986-11-05 00:00:00	1986-11-12	1986-11-12 00:00:00	32020		\N	61475	0	43878008	28060		0
26247	1558	40481087	1957-02-03	1957-02-03 00:00:00	1957-02-24	1957-02-24 00:00:00	32020		\N	104379	0	444814009	40481087		0
15891	940	4237458	1956-05-30	1956-05-30 00:00:00	1956-08-28	1956-08-28 00:00:00	32020		\N	62560	0	58150001	4237458		0
26564	1574	375671	1961-08-18	1961-08-18 00:00:00	1961-10-17	1961-10-17 00:00:00	32020		\N	105631	0	62564004	375671		0
26758	1585	260139	1953-12-30	1953-12-30 00:00:00	1954-01-13	1954-01-13 00:00:00	32020		\N	106256	0	10509002	260139		0
16414	970	4112343	1953-08-03	1953-08-03 00:00:00	1953-08-12	1953-08-12 00:00:00	32020		\N	64486	0	195662009	4112343		0
16566	978	40481087	2002-11-20	2002-11-20 00:00:00	2002-12-04	2002-12-04 00:00:00	32020		\N	65154	0	444814009	40481087		0
27268	1608	4155034	1982-04-06	1982-04-06 00:00:00	1982-04-20	1982-04-20 00:00:00	32020		\N	107983	0	283371005	4155034		0
27479	1622	260139	1982-03-09	1982-03-09 00:00:00	1982-03-23	1982-03-23 00:00:00	32020		\N	108969	0	10509002	260139		0
27562	1626	40481087	1995-01-25	1995-01-25 00:00:00	1995-02-01	1995-02-01 00:00:00	32020		\N	109278	0	444814009	40481087		0
27807	1641	4112343	1963-08-09	1963-08-09 00:00:00	1963-08-20	1963-08-20 00:00:00	32020		\N	110118	0	195662009	4112343		0
28015	1657	4112343	1977-10-12	1977-10-12 00:00:00	1977-10-23	1977-10-23 00:00:00	32020		\N	111229	0	195662009	4112343		0
28068	1658	372328	1914-11-25	1914-11-25 00:00:00	1915-04-05	1915-04-05 00:00:00	32020		\N	111299	0	65363002	372328		0
28260	1669	4112343	1995-11-08	1995-11-08 00:00:00	1995-11-21	1995-11-21 00:00:00	32020		\N	112091	0	195662009	4112343		0
28456	1683	4296204	1981-04-30	1981-04-30 00:00:00	1981-05-28	1981-05-28 00:00:00	32020		\N	112767	0	403190006	4296204		0
18067	1085	4149245	1968-11-12	1968-11-12 00:00:00	1969-01-18	1969-01-18 00:00:00	32020		\N	71265	0	30832001	4149245		0
28742	1702	4155034	2016-08-22	2016-08-22 00:00:00	2016-09-05	2016-09-05 00:00:00	32020		\N	113805	0	283371005	4155034		0
18410	1107	40481087	1944-10-12	1944-10-12 00:00:00	1944-11-02	1944-11-02 00:00:00	32020		\N	72912	0	444814009	40481087		0
18583	1117	4146173	1947-10-03	1947-10-03 00:00:00	1947-11-02	1947-11-02 00:00:00	32020		\N	73621	0	307731004	4146173		0
29221	1729	40481087	2016-04-25	2016-04-25 00:00:00	2016-05-02	2016-05-02 00:00:00	32020		\N	115627	0	444814009	40481087		0
18916	1137	260139	2011-04-06	2011-04-06 00:00:00	2011-04-20	2011-04-20 00:00:00	32020		\N	74910	0	10509002	260139		0
19083	1145	40481087	1963-11-18	1963-11-18 00:00:00	1963-12-02	1963-12-02 00:00:00	32020		\N	75637	0	444814009	40481087		0
19229	1151	40481087	2016-12-01	2016-12-01 00:00:00	2016-12-15	2016-12-15 00:00:00	32020		\N	76119	0	444814009	40481087		0
29909	1770	4112343	1998-01-19	1998-01-19 00:00:00	1998-01-29	1998-01-29 00:00:00	32020		\N	118340	0	195662009	4112343		0
30123	1780	4134304	1989-02-09	1989-02-09 00:00:00	1989-04-10	1989-04-10 00:00:00	32020		\N	119144	0	263102004	4134304		0
30243	1786	260139	2007-11-05	2007-11-05 00:00:00	2007-11-19	2007-11-19 00:00:00	32020		\N	119695	0	10509002	260139		0
30461	1796	81151	2016-05-01	2016-05-01 00:00:00	2016-06-05	2016-06-05 00:00:00	32020		\N	120435	0	44465007	81151		0
30554	1804	192671	1972-06-05	1972-06-05 00:00:00	\N	\N	32020		\N	120834	0	K92.2	35208414		0
30754	1819	375671	2014-10-03	2014-10-03 00:00:00	2014-12-02	2014-12-02 00:00:00	32020		\N	121686	0	62564004	375671		0
20394	1227	28060	1967-01-21	1967-01-21 00:00:00	1967-02-02	1967-02-02 00:00:00	32020		\N	80780	0	43878008	28060		0
31087	1842	40481087	1975-12-26	1975-12-26 00:00:00	1976-01-09	1976-01-09 00:00:00	32020		\N	122943	0	444814009	40481087		0
31227	1847	4112343	1922-02-18	1922-02-18 00:00:00	1922-02-25	1922-02-25 00:00:00	32020		\N	123582	0	195662009	4112343		0
31397	1854	4294548	2015-05-05	2015-05-05 00:00:00	2015-11-24	2015-11-24 00:00:00	32020		\N	124093	0	75498004	4294548		0
21047	1264	40481087	1984-01-30	1984-01-30 00:00:00	1984-02-13	1984-02-13 00:00:00	32020		\N	83275	0	444814009	40481087		0
31780	1885	260139	2006-11-03	2006-11-03 00:00:00	2006-11-17	2006-11-17 00:00:00	32020		\N	125674	0	10509002	260139		0
21263	1276	40481087	1992-03-30	1992-03-30 00:00:00	1992-04-20	1992-04-20 00:00:00	32020		\N	84254	0	444814009	40481087		0
21484	1289	4156265	1963-02-06	1963-02-06 00:00:00	1963-02-27	1963-02-27 00:00:00	32020		\N	85168	0	370247008	4156265		0
21587	1294	260139	1985-09-05	1985-09-05 00:00:00	1985-09-12	1985-09-12 00:00:00	32020		\N	85644	0	10509002	260139		0
21814	1309	4112343	1973-12-18	1973-12-18 00:00:00	1973-12-26	1973-12-26 00:00:00	32020		\N	86453	0	195662009	4112343		0
11439	675	4283893	1999-09-20	1999-09-20 00:00:00	1999-11-15	1999-11-15 00:00:00	32020		\N	44605	0	36971009	4283893		0
22143	1322	257012	1965-02-16	1965-02-16 00:00:00	\N	\N	32020		\N	87794	0	40055000	257012		0
22248	1328	260139	1987-12-25	1987-12-25 00:00:00	1988-01-01	1988-01-01 00:00:00	32020		\N	88162	0	10509002	260139		0
22430	1339	4027663	1994-04-07	1994-04-07 00:00:00	\N	\N	32020		\N	88823	0	13200003	4027663		0
22608	1352	260139	1959-12-07	1959-12-07 00:00:00	1959-12-14	1959-12-14 00:00:00	32020		\N	89590	0	10509002	260139		0
22785	1359	80180	1971-05-14	1971-05-14 00:00:00	\N	\N	32020		\N	90134	0	396275006	80180		0
12402	733	81151	1992-01-08	1992-01-08 00:00:00	1992-02-05	1992-02-05 00:00:00	32020		\N	48598	0	44465007	81151		0
12589	744	4218389	1977-12-03	1977-12-03 00:00:00	1978-01-07	1978-01-07 00:00:00	32020		\N	49353	0	39848009	4218389		0
23248	1387	40481087	2001-09-21	2001-09-21 00:00:00	2001-10-05	2001-10-05 00:00:00	32020		\N	92045	0	444814009	40481087		0
23419	1397	4112343	1990-04-27	1990-04-27 00:00:00	1990-05-06	1990-05-06 00:00:00	32020		\N	92842	0	195662009	4112343		0
23600	1409	40481087	1943-10-30	1943-10-30 00:00:00	1943-11-06	1943-11-06 00:00:00	32020		\N	93820	0	444814009	40481087		0
23832	1425	40481087	1937-04-26	1937-04-26 00:00:00	1937-05-17	1937-05-17 00:00:00	32020		\N	94785	0	444814009	40481087		0
13411	789	4112343	1998-09-19	1998-09-19 00:00:00	1998-09-26	1998-09-26 00:00:00	32020		\N	52494	0	195662009	4112343		0
24174	1441	4299128	1994-10-02	1994-10-02 00:00:00	1994-11-06	1994-11-06 00:00:00	32020		\N	95951	0	403192003	4299128		0
24288	1447	4142905	1975-03-14	1975-03-14 00:00:00	1975-04-13	1975-04-13 00:00:00	32020		\N	96483	0	33737001	4142905		0
13909	821	4112343	2003-09-18	2003-09-18 00:00:00	2003-09-25	2003-09-25 00:00:00	32020		\N	54401	0	195662009	4112343		0
14063	830	4112343	1985-05-11	1985-05-11 00:00:00	1985-05-21	1985-05-21 00:00:00	32020		\N	54968	0	195662009	4112343		0
24780	1478	40481087	1999-12-23	1999-12-23 00:00:00	2000-01-06	2000-01-06 00:00:00	32020		\N	98620	0	444814009	40481087		0
24938	1490	40481087	2017-02-20	2017-02-20 00:00:00	2017-02-27	2017-02-27 00:00:00	32020		\N	99375	0	444814009	40481087		0
14608	863	260139	1932-07-23	1932-07-23 00:00:00	1932-07-30	1932-07-30 00:00:00	32020		\N	57199	0	10509002	260139		0
14757	869	4001336	2017-10-15	2017-10-15 00:00:00	2017-12-14	2017-12-14 00:00:00	32020		\N	57728	0	110030002	4001336		0
25462	1516	40481087	1948-10-05	1948-10-05 00:00:00	1948-10-26	1948-10-26 00:00:00	32020		\N	101242	0	444814009	40481087		0
25623	1524	40481087	2008-12-02	2008-12-02 00:00:00	2008-12-16	2008-12-16 00:00:00	32020		\N	101922	0	444814009	40481087		0
25811	1533	28060	2014-08-27	2014-08-27 00:00:00	2014-09-03	2014-09-03 00:00:00	32020		\N	102647	0	43878008	28060		0
25930	1538	4112343	1965-12-07	1965-12-07 00:00:00	1965-12-19	1965-12-19 00:00:00	32020		\N	102973	0	195662009	4112343		0
15588	923	4155034	1989-04-03	1989-04-03 00:00:00	1989-04-24	1989-04-24 00:00:00	32020		\N	61494	0	283371005	4155034		0
26248	1558	80180	1992-09-01	1992-09-01 00:00:00	\N	\N	32020		\N	104353	0	396275006	80180		0
15892	940	4109685	1979-05-30	1979-05-30 00:00:00	1979-06-13	1979-06-13 00:00:00	32020		\N	62562	0	284551006	4109685		0
26565	1574	40481087	2007-09-08	2007-09-08 00:00:00	2007-09-29	2007-09-29 00:00:00	32020		\N	105697	0	444814009	40481087		0
26759	1585	4112343	1967-05-03	1967-05-03 00:00:00	1967-05-12	1967-05-12 00:00:00	32020		\N	106299	0	195662009	4112343		0
16415	970	260139	1967-11-28	1967-11-28 00:00:00	1967-12-12	1967-12-12 00:00:00	32020		\N	64519	0	10509002	260139		0
16567	978	28060	1979-09-25	1979-09-25 00:00:00	1979-10-03	1979-10-03 00:00:00	32020		\N	65165	0	43878008	28060		0
27269	1608	4112343	2012-11-04	2012-11-04 00:00:00	2012-11-14	2012-11-14 00:00:00	32020		\N	107971	0	195662009	4112343		0
27480	1622	4112343	2006-07-21	2006-07-21 00:00:00	2006-08-02	2006-08-02 00:00:00	32020		\N	108999	0	195662009	4112343		0
27563	1626	4116491	1993-12-29	1993-12-29 00:00:00	1994-02-21	1994-02-21 00:00:00	32020		\N	109276	0	301011002	4116491		0
27808	1641	372328	1967-02-07	1967-02-07 00:00:00	1968-01-03	1968-01-03 00:00:00	32020		\N	110155	0	65363002	372328		0
28016	1657	4112343	1949-04-02	1949-04-02 00:00:00	1949-04-13	1949-04-13 00:00:00	32020		\N	111211	0	195662009	4112343		0
28069	1658	40481087	1926-06-01	1926-06-01 00:00:00	1926-06-15	1926-06-15 00:00:00	32020		\N	111341	0	444814009	40481087		0
28261	1669	258780	1998-02-16	1998-02-16 00:00:00	\N	\N	32020		\N	112086	0	185086009	258780		0
28457	1683	372328	1973-09-09	1973-09-09 00:00:00	1973-12-27	1973-12-27 00:00:00	32020		\N	112833	0	65363002	372328		0
18068	1085	40481087	1976-01-28	1976-01-28 00:00:00	1976-02-11	1976-02-11 00:00:00	32020		\N	71250	0	444814009	40481087		0
28743	1702	4112343	1967-10-03	1967-10-03 00:00:00	1967-10-16	1967-10-16 00:00:00	32020		\N	113799	0	195662009	4112343		0
18411	1107	260139	2001-10-29	2001-10-29 00:00:00	2001-11-12	2001-11-12 00:00:00	32020		\N	72915	0	10509002	260139		0
18584	1117	40481087	2012-09-23	2012-09-23 00:00:00	2012-10-07	2012-10-07 00:00:00	32020		\N	73645	0	444814009	40481087		0
29222	1729	30753	2010-04-22	2010-04-22 00:00:00	\N	\N	32020		\N	115641	0	16761005	30753		0
18917	1137	40481087	1983-12-08	1983-12-08 00:00:00	1983-12-22	1983-12-22 00:00:00	32020		\N	74907	0	444814009	40481087		0
19084	1145	4112343	1942-05-20	1942-05-20 00:00:00	1942-05-27	1942-05-27 00:00:00	32020		\N	75538	0	195662009	4112343		0
19230	1151	40481087	1997-04-24	1997-04-24 00:00:00	1997-05-15	1997-05-15 00:00:00	32020		\N	76118	0	444814009	40481087		0
29910	1770	78272	1981-05-26	1981-05-26 00:00:00	1981-06-23	1981-06-23 00:00:00	32020		\N	118374	0	70704007	78272		0
30124	1780	372328	1966-11-07	1966-11-07 00:00:00	1966-11-21	1966-11-21 00:00:00	32020		\N	119179	0	65363002	372328		0
30244	1786	257012	2001-04-27	2001-04-27 00:00:00	\N	\N	32020		\N	119753	0	40055000	257012		0
30462	1796	40481087	1993-04-02	1993-04-02 00:00:00	1993-04-09	1993-04-09 00:00:00	32020		\N	120410	0	444814009	40481087		0
30555	1804	4027663	1963-10-07	1963-10-07 00:00:00	\N	\N	32020		\N	120878	0	13200003	4027663		0
30755	1819	4112343	2009-01-08	2009-01-08 00:00:00	2009-01-17	2009-01-17 00:00:00	32020		\N	121664	0	195662009	4112343		0
20395	1227	260139	2000-06-03	2000-06-03 00:00:00	2000-06-10	2000-06-10 00:00:00	32020		\N	80735	0	10509002	260139		0
31088	1842	4112343	2000-11-02	2000-11-02 00:00:00	2000-11-12	2000-11-12 00:00:00	32020		\N	122968	0	195662009	4112343		0
31228	1847	372328	1915-07-06	1915-07-06 00:00:00	1915-10-17	1915-10-17 00:00:00	32020		\N	123555	0	65363002	372328		0
31398	1854	260139	1992-08-17	1992-08-17 00:00:00	1992-08-24	1992-08-24 00:00:00	32020		\N	124080	0	10509002	260139		0
21048	1264	28060	1953-05-16	1953-05-16 00:00:00	1953-05-27	1953-05-27 00:00:00	32020		\N	83321	0	43878008	28060		0
31781	1885	4283893	1973-12-01	1973-12-01 00:00:00	1974-04-06	1974-04-06 00:00:00	32020		\N	125685	0	36971009	4283893		0
21264	1276	40481087	1979-05-21	1979-05-21 00:00:00	1979-06-11	1979-06-11 00:00:00	32020		\N	84232	0	444814009	40481087		0
21485	1289	4112343	1989-06-11	1989-06-11 00:00:00	1989-06-21	1989-06-21 00:00:00	32020		\N	85195	0	195662009	4112343		0
21588	1294	260139	2000-10-06	2000-10-06 00:00:00	2000-10-13	2000-10-13 00:00:00	32020		\N	85625	0	10509002	260139		0
21815	1309	40481087	1963-02-07	1963-02-07 00:00:00	1963-02-21	1963-02-21 00:00:00	32020		\N	86517	0	444814009	40481087		0
11440	675	4116491	1986-02-07	1986-02-07 00:00:00	1986-03-28	1986-03-28 00:00:00	32020		\N	44709	0	301011002	4116491		0
22144	1322	40481087	2005-06-02	2005-06-02 00:00:00	2005-06-23	2005-06-23 00:00:00	32020		\N	87774	0	444814009	40481087		0
22249	1328	80180	1989-05-01	1989-05-01 00:00:00	\N	\N	32020		\N	88163	0	396275006	80180		0
22431	1339	260139	2018-07-16	2018-07-16 00:00:00	2018-07-23	2018-07-23 00:00:00	32020		\N	88825	0	10509002	260139		0
22609	1352	80809	1971-07-29	1971-07-29 00:00:00	\N	\N	32020		\N	89559	0	69896004	80809		0
22786	1359	255848	2008-09-06	2008-09-06 00:00:00	\N	\N	32020		\N	90207	0	233604007	255848		0
12403	733	80180	1980-05-07	1980-05-07 00:00:00	\N	\N	32020		\N	48608	0	396275006	80180		0
12590	744	372328	1954-09-01	1954-09-01 00:00:00	1955-03-04	1955-03-04 00:00:00	32020		\N	49315	0	65363002	372328		0
23249	1387	4278672	1980-08-31	1980-08-31 00:00:00	1980-11-29	1980-11-29 00:00:00	32020		\N	92092	0	65966004	4278672		0
23420	1397	4218389	2001-01-10	2001-01-10 00:00:00	2001-01-31	2001-01-31 00:00:00	32020		\N	92839	0	39848009	4218389		0
23601	1409	40481087	1996-10-29	1996-10-29 00:00:00	1996-11-19	1996-11-19 00:00:00	32020		\N	93773	0	444814009	40481087		0
23833	1425	40481087	1967-06-11	1967-06-11 00:00:00	1967-07-02	1967-07-02 00:00:00	32020		\N	94730	0	444814009	40481087		0
13412	789	260139	1989-05-07	1989-05-07 00:00:00	1989-05-21	1989-05-21 00:00:00	32020		\N	52509	0	10509002	260139		0
24175	1441	372328	1974-02-19	1974-02-19 00:00:00	1974-06-17	1974-06-17 00:00:00	32020		\N	96036	0	65363002	372328		0
24289	1447	4112343	1974-01-08	1974-01-08 00:00:00	1974-01-19	1974-01-19 00:00:00	32020		\N	96459	0	195662009	4112343		0
13910	821	4112343	1956-11-30	1956-11-30 00:00:00	1956-12-09	1956-12-09 00:00:00	32020		\N	54379	0	195662009	4112343		0
14064	830	378001	1962-12-05	1962-12-05 00:00:00	1963-01-04	1963-01-04 00:00:00	32020		\N	55004	0	62106007	378001		0
24781	1478	4112343	2008-11-10	2008-11-10 00:00:00	2008-11-20	2008-11-20 00:00:00	32020		\N	98661	0	195662009	4112343		0
24939	1490	40481087	1969-11-08	1969-11-08 00:00:00	1969-11-22	1969-11-22 00:00:00	32020		\N	99382	0	444814009	40481087		0
25067	1496	4296205	1970-11-23	1970-11-23 00:00:00	1970-12-14	1970-12-14 00:00:00	32020		\N	99740	0	403191005	4296205		0
14758	869	260139	1992-04-11	1992-04-11 00:00:00	1992-04-18	1992-04-18 00:00:00	32020		\N	57793	0	10509002	260139		0
25463	1516	40481087	1953-07-14	1953-07-14 00:00:00	1953-08-04	1953-08-04 00:00:00	32020		\N	101258	0	444814009	40481087		0
25624	1524	4112343	1968-09-21	1968-09-21 00:00:00	1968-10-02	1968-10-02 00:00:00	32020		\N	101910	0	195662009	4112343		0
25812	1533	260139	2016-09-27	2016-09-27 00:00:00	2016-10-06	2016-10-06 00:00:00	32020		\N	102650	0	10509002	260139		0
25931	1538	372328	1931-07-10	1931-07-10 00:00:00	1931-08-10	1931-08-10 00:00:00	32020		\N	103040	0	65363002	372328		0
15589	923	40481087	2017-02-28	2017-02-28 00:00:00	2017-03-07	2017-03-07 00:00:00	32020		\N	61476	0	444814009	40481087		0
26249	1558	4294548	1991-01-16	1991-01-16 00:00:00	1991-02-13	1991-02-13 00:00:00	32020		\N	104312	0	75498004	4294548		0
15893	940	40481087	1946-12-10	1946-12-10 00:00:00	1946-12-31	1946-12-31 00:00:00	32020		\N	62517	0	444814009	40481087		0
26566	1574	4237458	1967-04-19	1967-04-19 00:00:00	1967-07-18	1967-07-18 00:00:00	32020		\N	105632	0	58150001	4237458		0
26760	1585	40481087	1999-12-07	1999-12-07 00:00:00	1999-12-28	1999-12-28 00:00:00	32020		\N	106258	0	444814009	40481087		0
16416	970	260139	1966-12-24	1966-12-24 00:00:00	1966-12-31	1966-12-31 00:00:00	32020		\N	64488	0	10509002	260139		0
16568	978	4059173	1995-09-29	1995-09-29 00:00:00	1995-12-28	1995-12-28 00:00:00	32020		\N	65153	0	16114001	4059173		0
27270	1608	40481087	1947-08-25	1947-08-25 00:00:00	1947-09-01	1947-09-01 00:00:00	32020		\N	108018	0	444814009	40481087		0
27481	1622	260139	1998-10-29	1998-10-29 00:00:00	1998-11-05	1998-11-05 00:00:00	32020		\N	109031	0	10509002	260139		0
27564	1627	260139	1977-01-12	1977-01-12 00:00:00	1977-01-27	1977-01-27 00:00:00	32020		\N	109347	0	10509002	260139		0
27809	1641	40481087	1979-01-31	1979-01-31 00:00:00	1979-02-21	1979-02-21 00:00:00	32020		\N	110162	0	444814009	40481087		0
28017	1657	4035415	1953-04-24	1953-04-24 00:00:00	1953-06-23	1953-06-23 00:00:00	32020		\N	111183	0	239720000	4035415		0
28070	1658	81893	1946-02-16	1946-02-16 00:00:00	\N	\N	32020		\N	111305	0	64766004	81893		0
28262	1669	40481087	1998-02-01	1998-02-01 00:00:00	1998-02-15	1998-02-15 00:00:00	32020		\N	112092	0	444814009	40481087		0
28458	1683	40481087	2016-06-23	2016-06-23 00:00:00	2016-06-30	2016-06-30 00:00:00	32020		\N	112789	0	444814009	40481087		0
18069	1085	4237458	2000-07-02	2000-07-02 00:00:00	2000-08-01	2000-08-01 00:00:00	32020		\N	71267	0	58150001	4237458		0
28744	1702	372328	1965-11-26	1965-11-26 00:00:00	1966-01-09	1966-01-09 00:00:00	32020		\N	113819	0	65363002	372328		0
18412	1107	4112343	1929-04-09	1929-04-09 00:00:00	1929-04-19	1929-04-19 00:00:00	32020		\N	72911	0	195662009	4112343		0
18585	1117	4112343	1997-02-14	1997-02-14 00:00:00	1997-02-26	1997-02-26 00:00:00	32020		\N	73643	0	195662009	4112343		0
29223	1729	80180	2011-08-15	2011-08-15 00:00:00	\N	\N	32020		\N	115641	0	396275006	80180		0
18918	1137	260139	1956-11-18	1956-11-18 00:00:00	1956-11-25	1956-11-25 00:00:00	32020		\N	74903	0	10509002	260139		0
19085	1145	4285898	1981-03-06	1981-03-06 00:00:00	\N	\N	32020		\N	75610	0	68496003	4285898		0
19231	1151	80180	2019-06-06	2019-06-06 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
29911	1770	40481087	2016-08-13	2016-08-13 00:00:00	2016-09-03	2016-09-03 00:00:00	32020		\N	118351	0	444814009	40481087		0
30125	1781	40481087	1950-01-30	1950-01-30 00:00:00	1950-02-06	1950-02-06 00:00:00	32020		\N	119195	0	444814009	40481087		0
30245	1786	4112343	1980-09-25	1980-09-25 00:00:00	1980-10-07	1980-10-07 00:00:00	32020		\N	119732	0	195662009	4112343		0
30463	1796	4146173	1983-01-13	1983-01-13 00:00:00	1983-02-12	1983-02-12 00:00:00	32020		\N	120407	0	307731004	4146173		0
30556	1804	378001	1976-10-22	1976-10-22 00:00:00	1976-11-21	1976-11-21 00:00:00	32020		\N	120876	0	62106007	378001		0
30756	1819	78272	2007-02-14	2007-02-14 00:00:00	2007-03-14	2007-03-14 00:00:00	32020		\N	121685	0	70704007	78272		0
20396	1227	4112343	1988-04-21	1988-04-21 00:00:00	1988-05-04	1988-05-04 00:00:00	32020		\N	80756	0	195662009	4112343		0
31089	1842	4112343	1991-09-24	1991-09-24 00:00:00	1991-10-06	1991-10-06 00:00:00	32020		\N	122944	0	195662009	4112343		0
31229	1847	260139	1990-10-28	1990-10-28 00:00:00	1990-11-04	1990-11-04 00:00:00	32020		\N	123566	0	10509002	260139		0
31399	1855	80180	2016-11-20	2016-11-20 00:00:00	\N	\N	32020		\N	124190	0	396275006	80180		0
21049	1264	260139	2001-02-02	2001-02-02 00:00:00	2001-02-09	2001-02-09 00:00:00	32020		\N	83339	0	10509002	260139		0
31782	1885	4112343	2009-02-19	2009-02-19 00:00:00	2009-02-28	2009-02-28 00:00:00	32020		\N	125675	0	195662009	4112343		0
21265	1276	372328	1961-10-13	1961-10-13 00:00:00	1962-02-16	1962-02-16 00:00:00	32020		\N	84268	0	65363002	372328		0
21486	1289	4112343	2017-06-07	2017-06-07 00:00:00	2017-06-15	2017-06-15 00:00:00	32020		\N	85229	0	195662009	4112343		0
21589	1294	4230399	1978-08-19	1978-08-19 00:00:00	1978-11-17	1978-11-17 00:00:00	32020		\N	85611	0	359817006	4230399		0
21816	1309	260139	2017-06-23	2017-06-23 00:00:00	2017-07-07	2017-07-07 00:00:00	32020		\N	86525	0	10509002	260139		0
11441	675	40481087	2003-06-02	2003-06-02 00:00:00	2003-06-09	2003-06-09 00:00:00	32020		\N	44589	0	444814009	40481087		0
22145	1322	40481087	1967-01-13	1967-01-13 00:00:00	1967-01-27	1967-01-27 00:00:00	32020		\N	87743	0	444814009	40481087		0
22250	1328	40481087	1988-05-24	1988-05-24 00:00:00	1988-06-07	1988-06-07 00:00:00	32020		\N	88163	0	444814009	40481087		0
22432	1339	4142905	1973-05-12	1973-05-12 00:00:00	1973-08-10	1973-08-10 00:00:00	32020		\N	88819	0	33737001	4142905		0
22610	1352	260139	1946-09-05	1946-09-05 00:00:00	1946-09-19	1946-09-19 00:00:00	32020		\N	89532	0	10509002	260139		0
22787	1359	4218389	1949-05-13	1949-05-13 00:00:00	1949-06-10	1949-06-10 00:00:00	32020		\N	90155	0	39848009	4218389		0
12404	733	81151	1948-07-29	1948-07-29 00:00:00	1948-08-26	1948-08-26 00:00:00	32020		\N	48596	0	44465007	81151		0
12591	744	40481087	1975-01-26	1975-01-26 00:00:00	1975-02-09	1975-02-09 00:00:00	32020		\N	49328	0	444814009	40481087		0
23250	1387	4112343	1995-11-24	1995-11-24 00:00:00	1995-12-04	1995-12-04 00:00:00	32020		\N	92089	0	195662009	4112343		0
23421	1397	28060	1995-02-13	1995-02-13 00:00:00	1995-02-24	1995-02-24 00:00:00	32020		\N	92763	0	43878008	28060		0
23602	1409	81151	1928-09-03	1928-09-03 00:00:00	1928-09-24	1928-09-24 00:00:00	32020		\N	93831	0	44465007	81151		0
23834	1425	4294548	1995-12-09	1995-12-09 00:00:00	1995-12-30	1995-12-30 00:00:00	32020		\N	94769	0	75498004	4294548		0
13413	789	40481087	2015-02-15	2015-02-15 00:00:00	2015-03-01	2015-03-01 00:00:00	32020		\N	52486	0	444814009	40481087		0
24176	1441	372328	1994-01-03	1994-01-03 00:00:00	1996-01-01	1996-01-01 00:00:00	32020		\N	96015	0	65363002	372328		0
24290	1447	40481087	1959-09-26	1959-09-26 00:00:00	1959-10-17	1959-10-17 00:00:00	32020		\N	96456	0	444814009	40481087		0
13911	821	4027663	1974-06-06	1974-06-06 00:00:00	\N	\N	32020		\N	54430	0	13200003	4027663		0
14065	830	28060	2016-09-21	2016-09-21 00:00:00	2016-09-30	2016-09-30 00:00:00	32020		\N	55013	0	43878008	28060		0
24782	1478	4084167	1977-11-22	1977-11-22 00:00:00	1977-11-22	1977-11-22 00:00:00	32020		\N	98640	0	241929008	4084167		0
24940	1490	4112343	1959-01-01	1959-01-01 00:00:00	1959-01-14	1959-01-14 00:00:00	32020		\N	99360	0	195662009	4112343		0
25068	1496	372328	1922-08-06	1922-08-06 00:00:00	1922-09-24	1922-09-24 00:00:00	32020		\N	99701	0	65363002	372328		0
14759	869	40481087	2018-11-30	2018-11-30 00:00:00	2018-12-07	2018-12-07 00:00:00	32020		\N	57795	0	444814009	40481087		0
25464	1516	28060	1959-04-21	1959-04-21 00:00:00	1959-04-29	1959-04-29 00:00:00	32020		\N	101274	0	43878008	28060		0
25625	1524	4027663	1992-01-06	1992-01-06 00:00:00	\N	\N	32020		\N	101946	0	13200003	4027663		0
25813	1533	4112343	2015-07-31	2015-07-31 00:00:00	2015-08-13	2015-08-13 00:00:00	32020		\N	102650	0	195662009	4112343		0
25932	1538	4109685	1993-12-19	1993-12-19 00:00:00	1994-01-02	1994-01-02 00:00:00	32020		\N	102946	0	284551006	4109685		0
15590	923	40481087	1986-05-26	1986-05-26 00:00:00	1986-06-16	1986-06-16 00:00:00	32020		\N	61431	0	444814009	40481087		0
26250	1558	260139	1996-01-21	1996-01-21 00:00:00	1996-01-28	1996-01-28 00:00:00	32020		\N	104386	0	10509002	260139		0
15894	940	4112343	1971-07-11	1971-07-11 00:00:00	1971-07-21	1971-07-21 00:00:00	32020		\N	62492	0	195662009	4112343		0
26567	1574	28060	1965-11-26	1965-11-26 00:00:00	1965-12-06	1965-12-06 00:00:00	32020		\N	105693	0	43878008	28060		0
26761	1585	40481087	1942-05-28	1942-05-28 00:00:00	1942-06-04	1942-06-04 00:00:00	32020		\N	106297	0	444814009	40481087		0
16417	970	4112343	2016-09-07	2016-09-07 00:00:00	2016-09-18	2016-09-18 00:00:00	32020		\N	64529	0	195662009	4112343		0
16569	978	4112343	2014-04-04	2014-04-04 00:00:00	2014-04-13	2014-04-13 00:00:00	32020		\N	65144	0	195662009	4112343		0
27271	1608	40481087	1955-11-26	1955-11-26 00:00:00	1955-12-03	1955-12-03 00:00:00	32020		\N	107986	0	444814009	40481087		0
27482	1622	40481087	1980-06-02	1980-06-02 00:00:00	1980-06-16	1980-06-16 00:00:00	32020		\N	108944	0	444814009	40481087		0
27565	1627	257012	1953-06-23	1953-06-23 00:00:00	\N	\N	32020		\N	109328	0	40055000	257012		0
27810	1641	4266809	1997-10-31	1997-10-31 00:00:00	\N	\N	32020		\N	110130	0	397881000	4266809		0
28018	1657	40481087	2016-12-16	2016-12-16 00:00:00	2016-12-23	2016-12-23 00:00:00	32020		\N	111247	0	444814009	40481087		0
28071	1658	317576	1996-02-19	1996-02-19 00:00:00	\N	\N	32020		\N	111269	0	53741008	317576		0
28263	1669	40481087	1960-02-05	1960-02-05 00:00:00	1960-02-19	1960-02-19 00:00:00	32020		\N	112050	0	444814009	40481087		0
28459	1683	4294548	1994-02-02	1994-02-02 00:00:00	1994-04-13	1994-04-13 00:00:00	32020		\N	112799	0	75498004	4294548		0
18070	1086	4283893	2001-06-11	2001-06-11 00:00:00	2001-07-09	2001-07-09 00:00:00	32020		\N	71321	0	36971009	4283893		0
28745	1702	4112343	1967-04-22	1967-04-22 00:00:00	1967-05-03	1967-05-03 00:00:00	32020		\N	113786	0	195662009	4112343		0
18413	1107	28060	2002-05-30	2002-05-30 00:00:00	2002-06-06	2002-06-06 00:00:00	32020		\N	72930	0	43878008	28060		0
18586	1117	80180	1978-09-28	1978-09-28 00:00:00	\N	\N	32020		\N	73599	0	396275006	80180		0
29224	1729	378001	1981-05-19	1981-05-19 00:00:00	1981-07-18	1981-07-18 00:00:00	32020		\N	115619	0	62106007	378001		0
18919	1137	81151	1988-10-09	1988-10-09 00:00:00	1988-11-06	1988-11-06 00:00:00	32020		\N	74934	0	44465007	81151		0
19086	1145	30753	1980-12-06	1980-12-06 00:00:00	\N	\N	32020		\N	75610	0	16761005	30753		0
19232	1151	4112343	1989-12-10	1989-12-10 00:00:00	1989-12-22	1989-12-22 00:00:00	32020		\N	76087	0	195662009	4112343		0
29912	1770	40481087	1984-02-29	1984-02-29 00:00:00	1984-03-14	1984-03-14 00:00:00	32020		\N	118399	0	444814009	40481087		0
30126	1781	260139	1999-10-11	1999-10-11 00:00:00	1999-10-25	1999-10-25 00:00:00	32020		\N	119184	0	10509002	260139		0
30246	1786	260139	1965-06-02	1965-06-02 00:00:00	1965-06-16	1965-06-16 00:00:00	32020		\N	119730	0	10509002	260139		0
30464	1796	4296204	2015-03-10	2015-03-10 00:00:00	2015-04-07	2015-04-07 00:00:00	32020		\N	120434	0	403190006	4296204		0
30557	1804	372328	1937-11-14	1937-11-14 00:00:00	1938-03-21	1938-03-21 00:00:00	32020		\N	120864	0	65363002	372328		0
30757	1819	195588	2006-05-17	2006-05-17 00:00:00	2006-07-06	2006-07-06 00:00:00	32020		\N	121675	0	38822007	195588		0
20397	1227	4278672	1950-04-03	1950-04-03 00:00:00	1950-05-03	1950-05-03 00:00:00	32020		\N	80818	0	65966004	4278672		0
31090	1842	260139	1981-07-29	1981-07-29 00:00:00	1981-08-12	1981-08-12 00:00:00	32020		\N	122950	0	10509002	260139		0
31230	1847	4027663	1946-10-31	1946-10-31 00:00:00	\N	\N	32020		\N	123495	0	13200003	4027663		0
31400	1855	4266809	2016-11-20	2016-11-20 00:00:00	\N	\N	32020		\N	124190	0	397881000	4266809		0
21050	1264	4146173	1987-01-03	1987-01-03 00:00:00	1987-03-04	1987-03-04 00:00:00	32020		\N	83328	0	307731004	4146173		0
31783	1885	80180	2009-11-05	2009-11-05 00:00:00	\N	\N	32020		\N	125675	0	396275006	80180		0
21266	1276	40481087	1991-06-06	1991-06-06 00:00:00	1991-06-27	1991-06-27 00:00:00	32020		\N	84180	0	444814009	40481087		0
21487	1289	81151	1965-03-18	1965-03-18 00:00:00	1965-04-08	1965-04-08 00:00:00	32020		\N	85239	0	44465007	81151		0
21590	1294	80180	2011-03-29	2011-03-29 00:00:00	\N	\N	32020		\N	85636	0	396275006	80180		0
21817	1309	4112343	1981-12-31	1981-12-31 00:00:00	1982-01-08	1982-01-08 00:00:00	32020		\N	86485	0	195662009	4112343		0
11442	675	40481087	1958-12-20	1958-12-20 00:00:00	1959-01-03	1959-01-03 00:00:00	32020		\N	44685	0	444814009	40481087		0
22146	1322	260139	2007-06-20	2007-06-20 00:00:00	2007-06-27	2007-06-27 00:00:00	32020		\N	87744	0	10509002	260139		0
22251	1328	81151	2013-01-31	2013-01-31 00:00:00	2013-02-28	2013-02-28 00:00:00	32020		\N	88159	0	44465007	81151		0
22433	1339	40481087	2013-08-10	2013-08-10 00:00:00	2013-08-24	2013-08-24 00:00:00	32020		\N	88806	0	444814009	40481087		0
22611	1352	260139	1959-08-12	1959-08-12 00:00:00	1959-08-19	1959-08-19 00:00:00	32020		\N	89534	0	10509002	260139		0
22788	1359	4112343	1941-01-13	1941-01-13 00:00:00	1941-01-24	1941-01-24 00:00:00	32020		\N	90199	0	195662009	4112343		0
12405	733	4112343	1956-04-29	1956-04-29 00:00:00	1956-05-09	1956-05-09 00:00:00	32020		\N	48609	0	195662009	4112343		0
12592	744	4166224	2004-03-17	2004-03-17 00:00:00	\N	\N	32020		\N	49356	0	47693006	4166224		0
23251	1387	40481087	1985-08-14	1985-08-14 00:00:00	1985-08-21	1985-08-21 00:00:00	32020		\N	92076	0	444814009	40481087		0
23422	1397	257012	2013-07-19	2013-07-19 00:00:00	\N	\N	32020		\N	92746	0	40055000	257012		0
23603	1409	4156265	2012-09-03	2012-09-03 00:00:00	2012-09-24	2012-09-24 00:00:00	32020		\N	93833	0	370247008	4156265		0
23835	1425	375671	1967-03-18	1967-03-18 00:00:00	1967-04-17	1967-04-17 00:00:00	32020		\N	94732	0	62564004	375671		0
13414	789	260139	2005-12-03	2005-12-03 00:00:00	2005-12-17	2005-12-17 00:00:00	32020		\N	52485	0	10509002	260139		0
24177	1441	81151	1999-06-13	1999-06-13 00:00:00	1999-07-18	1999-07-18 00:00:00	32020		\N	95953	0	44465007	81151		0
24291	1447	4112343	2018-03-31	2018-03-31 00:00:00	2018-04-08	2018-04-08 00:00:00	32020		\N	96435	0	195662009	4112343		0
13912	822	40481087	1973-06-03	1973-06-03 00:00:00	1973-06-17	1973-06-17 00:00:00	32020		\N	54502	0	444814009	40481087		0
14066	830	4113008	1981-09-22	1981-09-22 00:00:00	1981-10-06	1981-10-06 00:00:00	32020		\N	55008	0	284549007	4113008		0
24783	1478	4155034	2001-09-22	2001-09-22 00:00:00	2001-10-06	2001-10-06 00:00:00	32020		\N	98643	0	283371005	4155034		0
24941	1490	81151	1940-11-23	1940-11-23 00:00:00	1940-12-14	1940-12-14 00:00:00	32020		\N	99303	0	44465007	81151		0
25069	1496	255848	1998-05-02	1998-05-02 00:00:00	\N	\N	32020		\N	99646	0	233604007	255848		0
14760	869	80180	1949-11-23	1949-11-23 00:00:00	\N	\N	32020		\N	57683	0	396275006	80180		0
25465	1516	4156265	1967-12-02	1967-12-02 00:00:00	1967-12-23	1967-12-23 00:00:00	32020		\N	101268	0	370247008	4156265		0
25626	1524	4112343	1993-06-02	1993-06-02 00:00:00	1993-06-14	1993-06-14 00:00:00	32020		\N	101954	0	195662009	4112343		0
25814	1533	4294548	2006-12-31	2006-12-31 00:00:00	2007-02-11	2007-02-11 00:00:00	32020		\N	102661	0	75498004	4294548		0
25933	1538	4112343	1950-12-03	1950-12-03 00:00:00	1950-12-11	1950-12-11 00:00:00	32020		\N	103054	0	195662009	4112343		0
15591	923	260139	2000-10-21	2000-10-21 00:00:00	2000-10-28	2000-10-28 00:00:00	32020		\N	61433	0	10509002	260139		0
26251	1558	260139	2006-04-06	2006-04-06 00:00:00	2006-04-13	2006-04-13 00:00:00	32020		\N	104309	0	10509002	260139		0
15895	940	260139	1971-08-08	1971-08-08 00:00:00	1971-08-23	1971-08-23 00:00:00	32020		\N	62492	0	10509002	260139		0
26568	1574	375671	1981-07-02	1981-07-02 00:00:00	1981-08-31	1981-08-31 00:00:00	32020		\N	105707	0	62564004	375671		0
26762	1585	260139	1957-03-26	1957-03-26 00:00:00	1957-04-02	1957-04-02 00:00:00	32020		\N	106257	0	10509002	260139		0
16418	970	80180	1986-12-17	1986-12-17 00:00:00	\N	\N	32020		\N	64540	0	396275006	80180		0
16570	978	78272	2003-06-19	2003-06-19 00:00:00	2003-07-10	2003-07-10 00:00:00	32020		\N	65121	0	70704007	78272		0
27272	1608	40481087	1981-05-10	1981-05-10 00:00:00	1981-05-31	1981-05-31 00:00:00	32020		\N	108045	0	444814009	40481087		0
27483	1622	40481087	2014-03-14	2014-03-14 00:00:00	2014-03-21	2014-03-21 00:00:00	32020		\N	108954	0	444814009	40481087		0
27566	1627	4112343	2000-06-03	2000-06-03 00:00:00	2000-06-15	2000-06-15 00:00:00	32020		\N	109368	0	195662009	4112343		0
27811	1641	4285898	1997-01-04	1997-01-04 00:00:00	\N	\N	32020		\N	110130	0	68496003	4285898		0
28019	1657	372328	1944-02-27	1944-02-27 00:00:00	1944-04-05	1944-04-05 00:00:00	32020		\N	111248	0	65363002	372328		0
28072	1658	40481087	1940-01-29	1940-01-29 00:00:00	1940-02-12	1940-02-12 00:00:00	32020		\N	111354	0	444814009	40481087		0
28264	1670	81151	2002-10-26	2002-10-26 00:00:00	2002-11-16	2002-11-16 00:00:00	32020		\N	112172	0	44465007	81151		0
28460	1683	4109685	2006-11-18	2006-11-18 00:00:00	2006-12-02	2006-12-02 00:00:00	32020		\N	112771	0	284551006	4109685		0
18071	1086	260139	1988-11-23	1988-11-23 00:00:00	1988-11-30	1988-11-30 00:00:00	32020		\N	71355	0	10509002	260139		0
28746	1702	4112343	2013-03-05	2013-03-05 00:00:00	2013-03-14	2013-03-14 00:00:00	32020		\N	113776	0	195662009	4112343		0
18414	1107	40481087	2000-12-30	2000-12-30 00:00:00	2001-01-13	2001-01-13 00:00:00	32020		\N	72923	0	444814009	40481087		0
18587	1117	4285898	1978-03-02	1978-03-02 00:00:00	\N	\N	32020		\N	73599	0	68496003	4285898		0
29225	1729	372328	1978-07-04	1978-07-04 00:00:00	1978-08-16	1978-08-16 00:00:00	32020		\N	115645	0	65363002	372328		0
18920	1137	4155034	1993-09-02	1993-09-02 00:00:00	1993-09-23	1993-09-23 00:00:00	32020		\N	74936	0	283371005	4155034		0
19087	1145	81893	1980-04-10	1980-04-10 00:00:00	\N	\N	32020		\N	75610	0	64766004	81893		0
19233	1151	4283893	2008-09-21	2008-09-21 00:00:00	2009-01-03	2009-01-03 00:00:00	32020		\N	76128	0	36971009	4283893		0
29913	1770	40481087	1998-01-29	1998-01-29 00:00:00	1998-02-19	1998-02-19 00:00:00	32020		\N	118403	0	444814009	40481087		0
30127	1781	260139	1966-02-09	1966-02-09 00:00:00	1966-02-23	1966-02-23 00:00:00	32020		\N	119257	0	10509002	260139		0
30247	1786	4059173	1959-03-05	1959-03-05 00:00:00	1959-06-03	1959-06-03 00:00:00	32020		\N	119704	0	16114001	4059173		0
30465	1796	4310024	2014-10-22	2014-10-22 00:00:00	\N	\N	32020		\N	120399	0	424802006	4310024		0
30558	1804	372328	1936-03-12	1936-03-12 00:00:00	1936-06-22	1936-06-22 00:00:00	32020		\N	120885	0	65363002	372328		0
30758	1819	40481087	1994-12-11	1994-12-11 00:00:00	1994-12-18	1994-12-18 00:00:00	32020		\N	121646	0	444814009	40481087		0
20398	1227	40479422	1961-08-29	1961-08-29 00:00:00	1961-11-04	1961-11-04 00:00:00	32020		\N	80821	0	444448004	40479422		0
31091	1842	28060	1968-08-07	1968-08-07 00:00:00	1968-08-15	1968-08-15 00:00:00	32020		\N	122966	0	43878008	28060		0
31231	1847	4116491	1963-10-27	1963-10-27 00:00:00	1963-12-13	1963-12-13 00:00:00	32020		\N	123551	0	301011002	4116491		0
31401	1855	40481087	1995-10-12	1995-10-12 00:00:00	1995-10-19	1995-10-19 00:00:00	32020		\N	124143	0	444814009	40481087		0
21051	1264	80180	1987-12-14	1987-12-14 00:00:00	\N	\N	32020		\N	83329	0	396275006	80180		0
31784	1885	4294548	1987-09-12	1987-09-12 00:00:00	1987-10-03	1987-10-03 00:00:00	32020		\N	125695	0	75498004	4294548		0
21267	1276	40481087	1979-02-01	1979-02-01 00:00:00	1979-02-15	1979-02-15 00:00:00	32020		\N	84231	0	444814009	40481087		0
21488	1289	40481087	1978-08-30	1978-08-30 00:00:00	1978-09-06	1978-09-06 00:00:00	32020		\N	85165	0	444814009	40481087		0
21591	1294	40481087	1983-10-14	1983-10-14 00:00:00	1983-10-28	1983-10-28 00:00:00	32020		\N	85613	0	444814009	40481087		0
21818	1310	28060	1953-11-02	1953-11-02 00:00:00	1953-11-11	1953-11-11 00:00:00	32020		\N	86572	0	43878008	28060		0
11443	675	4218389	1950-12-03	1950-12-03 00:00:00	1950-12-31	1950-12-31 00:00:00	32020		\N	44593	0	39848009	4218389		0
22147	1322	40481087	1950-07-23	1950-07-23 00:00:00	1950-08-13	1950-08-13 00:00:00	32020		\N	87737	0	444814009	40481087		0
22252	1328	260139	1980-11-16	1980-11-16 00:00:00	1980-11-30	1980-11-30 00:00:00	32020		\N	88222	0	10509002	260139		0
22434	1339	378001	1972-04-17	1972-04-17 00:00:00	1972-05-17	1972-05-17 00:00:00	32020		\N	88790	0	62106007	378001		0
22612	1352	4112343	2016-03-26	2016-03-26 00:00:00	2016-04-03	2016-04-03 00:00:00	32020		\N	89609	0	195662009	4112343		0
22789	1359	4294548	1998-09-12	1998-09-12 00:00:00	1998-10-03	1998-10-03 00:00:00	32020		\N	90157	0	75498004	4294548		0
12406	733	40479768	2003-09-05	2003-09-05 00:00:00	2003-11-11	2003-11-11 00:00:00	32020		\N	48643	0	444470001	40479768		0
12593	744	440448	2004-03-17	2004-03-17 00:00:00	\N	\N	32020		\N	49356	0	74400008	440448		0
23252	1387	4112343	1978-09-15	1978-09-15 00:00:00	1978-09-23	1978-09-23 00:00:00	32020		\N	91995	0	195662009	4112343		0
23423	1397	4112343	2003-07-29	2003-07-29 00:00:00	2003-08-08	2003-08-08 00:00:00	32020		\N	92765	0	195662009	4112343		0
23604	1409	4112343	1958-12-28	1958-12-28 00:00:00	1959-01-08	1959-01-08 00:00:00	32020		\N	93711	0	195662009	4112343		0
23836	1425	260139	1961-10-23	1961-10-23 00:00:00	1961-11-06	1961-11-06 00:00:00	32020		\N	94734	0	10509002	260139		0
13415	789	4112343	2014-02-16	2014-02-16 00:00:00	2014-02-26	2014-02-26 00:00:00	32020		\N	52464	0	195662009	4112343		0
24178	1441	4112343	2013-08-18	2013-08-18 00:00:00	2013-08-31	2013-08-31 00:00:00	32020		\N	96056	0	195662009	4112343		0
24292	1447	4059173	1972-06-27	1972-06-27 00:00:00	1972-07-27	1972-07-27 00:00:00	32020		\N	96482	0	16114001	4059173		0
13913	822	40481087	1996-08-22	1996-08-22 00:00:00	1996-09-12	1996-09-12 00:00:00	32020		\N	54460	0	444814009	40481087		0
14067	830	40481087	2009-04-21	2009-04-21 00:00:00	2009-04-28	2009-04-28 00:00:00	32020		\N	54945	0	444814009	40481087		0
24784	1478	80180	2001-12-26	2001-12-26 00:00:00	\N	\N	32020		\N	98643	0	396275006	80180		0
24942	1490	40481087	1939-06-11	1939-06-11 00:00:00	1939-06-18	1939-06-18 00:00:00	32020		\N	99379	0	444814009	40481087		0
25070	1496	40481087	1989-03-30	1989-03-30 00:00:00	1989-04-13	1989-04-13 00:00:00	32020		\N	99734	0	444814009	40481087		0
14761	869	260139	1947-07-19	1947-07-19 00:00:00	1947-07-26	1947-07-26 00:00:00	32020		\N	57683	0	10509002	260139		0
25466	1516	378001	1952-01-20	1952-01-20 00:00:00	1952-02-19	1952-02-19 00:00:00	32020		\N	101263	0	62106007	378001		0
25627	1524	4112343	1987-09-08	1987-09-08 00:00:00	1987-09-15	1987-09-15 00:00:00	32020		\N	101917	0	195662009	4112343		0
25815	1533	4027663	1998-12-22	1998-12-22 00:00:00	\N	\N	32020		\N	102684	0	13200003	4027663		0
25934	1538	40481087	1998-09-07	1998-09-07 00:00:00	1998-09-28	1998-09-28 00:00:00	32020		\N	102966	0	444814009	40481087		0
15592	923	372328	1985-06-14	1985-06-14 00:00:00	1987-02-11	1987-02-11 00:00:00	32020		\N	61479	0	65363002	372328		0
26252	1558	372328	1957-09-01	1957-09-01 00:00:00	1957-10-03	1957-10-03 00:00:00	32020		\N	104314	0	65363002	372328		0
15896	940	40481087	1980-05-30	1980-05-30 00:00:00	1980-06-20	1980-06-20 00:00:00	32020		\N	62566	0	444814009	40481087		0
26569	1574	40481087	1988-06-05	1988-06-05 00:00:00	1988-06-12	1988-06-12 00:00:00	32020		\N	105716	0	444814009	40481087		0
26763	1585	40481087	1954-02-28	1954-02-28 00:00:00	1954-03-07	1954-03-07 00:00:00	32020		\N	106269	0	444814009	40481087		0
16419	970	40481087	1977-08-05	1977-08-05 00:00:00	1977-08-26	1977-08-26 00:00:00	32020		\N	64482	0	444814009	40481087		0
16571	978	4266809	2012-04-22	2012-04-22 00:00:00	\N	\N	32020		\N	65143	0	397881000	4266809		0
27273	1608	81151	1947-12-10	1947-12-10 00:00:00	1947-12-24	1947-12-24 00:00:00	32020		\N	108011	0	44465007	81151		0
27484	1622	260139	2015-04-08	2015-04-08 00:00:00	2015-04-22	2015-04-22 00:00:00	32020		\N	108971	0	10509002	260139		0
27567	1627	4294548	1953-06-02	1953-06-02 00:00:00	1953-11-17	1953-11-17 00:00:00	32020		\N	109334	0	75498004	4294548		0
27812	1641	80180	1997-10-31	1997-10-31 00:00:00	\N	\N	32020		\N	110130	0	396275006	80180		0
28020	1657	40481087	1993-08-11	1993-08-11 00:00:00	1993-08-25	1993-08-25 00:00:00	32020		\N	111244	0	444814009	40481087		0
28073	1658	4112343	1929-06-15	1929-06-15 00:00:00	1929-06-28	1929-06-28 00:00:00	32020		\N	111385	0	195662009	4112343		0
28265	1670	260139	1989-01-03	1989-01-03 00:00:00	1989-01-17	1989-01-17 00:00:00	32020		\N	112198	0	10509002	260139		0
28461	1683	372328	1977-05-10	1977-05-10 00:00:00	1977-07-07	1977-07-07 00:00:00	32020		\N	112790	0	65363002	372328		0
18072	1086	40481087	1965-11-13	1965-11-13 00:00:00	1965-11-27	1965-11-27 00:00:00	32020		\N	71327	0	444814009	40481087		0
28747	1702	40481087	2000-05-04	2000-05-04 00:00:00	2000-05-18	2000-05-18 00:00:00	32020		\N	113818	0	444814009	40481087		0
18415	1107	4142905	2004-12-09	2004-12-09 00:00:00	2005-03-09	2005-03-09 00:00:00	32020		\N	72858	0	33737001	4142905		0
18588	1117	40481087	1936-02-27	1936-02-27 00:00:00	1936-03-05	1936-03-05 00:00:00	32020		\N	73604	0	444814009	40481087		0
29226	1729	81151	1984-06-02	1984-06-02 00:00:00	1984-06-16	1984-06-16 00:00:00	32020		\N	115620	0	44465007	81151		0
18921	1137	4218389	1984-11-24	1984-11-24 00:00:00	1984-12-29	1984-12-29 00:00:00	32020		\N	74978	0	39848009	4218389		0
19088	1145	80180	1981-12-01	1981-12-01 00:00:00	\N	\N	32020		\N	75610	0	396275006	80180		0
19234	1151	40481087	2002-08-24	2002-08-24 00:00:00	2002-09-14	2002-09-14 00:00:00	32020		\N	76127	0	444814009	40481087		0
29914	1770	372328	1983-03-17	1983-03-17 00:00:00	1984-03-25	1984-03-25 00:00:00	32020		\N	118362	0	65363002	372328		0
30128	1781	4156265	2009-11-24	2009-11-24 00:00:00	2009-12-08	2009-12-08 00:00:00	32020		\N	119227	0	370247008	4156265		0
30248	1786	40481087	1964-08-07	1964-08-07 00:00:00	1964-08-21	1964-08-21 00:00:00	32020		\N	119729	0	444814009	40481087		0
30466	1796	4294548	1983-08-29	1983-08-29 00:00:00	1983-10-17	1983-10-17 00:00:00	32020		\N	120408	0	75498004	4294548		0
30559	1804	4112343	1973-03-28	1973-03-28 00:00:00	1973-04-06	1973-04-06 00:00:00	32020		\N	120862	0	195662009	4112343		0
30759	1819	4112343	2013-12-04	2013-12-04 00:00:00	2013-12-14	2013-12-14 00:00:00	32020		\N	121647	0	195662009	4112343		0
20399	1227	4278672	1946-04-10	1946-04-10 00:00:00	1946-07-09	1946-07-09 00:00:00	32020		\N	80816	0	65966004	4278672		0
31092	1842	372328	1967-02-11	1967-02-11 00:00:00	1967-07-28	1967-07-28 00:00:00	32020		\N	122946	0	65363002	372328		0
31232	1847	4059173	1928-05-28	1928-05-28 00:00:00	1928-08-26	1928-08-26 00:00:00	32020		\N	123517	0	16114001	4059173		0
31402	1855	4051466	1977-03-27	1977-03-27 00:00:00	1994-06-29	1994-06-29 00:00:00	32020		\N	124163	0	233678006	4051466		0
21052	1264	4112343	1987-08-16	1987-08-16 00:00:00	1987-08-27	1987-08-27 00:00:00	32020		\N	83329	0	195662009	4112343		0
31785	1885	372328	1978-11-04	1978-11-04 00:00:00	1979-02-13	1979-02-13 00:00:00	32020		\N	125724	0	65363002	372328		0
21268	1276	260139	2017-04-13	2017-04-13 00:00:00	2017-04-27	2017-04-27 00:00:00	32020		\N	84198	0	10509002	260139		0
21489	1289	78272	1972-09-28	1972-09-28 00:00:00	1972-10-12	1972-10-12 00:00:00	32020		\N	85240	0	70704007	78272		0
21592	1294	4112343	1984-11-19	1984-11-19 00:00:00	1984-11-26	1984-11-26 00:00:00	32020		\N	85614	0	195662009	4112343		0
21819	1310	40481087	1951-03-10	1951-03-10 00:00:00	1951-03-17	1951-03-17 00:00:00	32020		\N	86567	0	444814009	40481087		0
11444	675	260139	1968-04-19	1968-04-19 00:00:00	1968-04-26	1968-04-26 00:00:00	32020		\N	44724	0	10509002	260139		0
22148	1322	28060	1945-09-09	1945-09-09 00:00:00	1945-09-22	1945-09-22 00:00:00	32020		\N	87787	0	43878008	28060		0
22253	1328	40481087	1999-04-20	1999-04-20 00:00:00	1999-05-11	1999-05-11 00:00:00	32020		\N	88164	0	444814009	40481087		0
22435	1339	81151	1970-04-23	1970-04-23 00:00:00	1970-05-28	1970-05-28 00:00:00	32020		\N	88789	0	44465007	81151		0
22613	1352	40481087	2015-03-14	2015-03-14 00:00:00	2015-03-28	2015-03-28 00:00:00	32020		\N	89619	0	444814009	40481087		0
22790	1359	4112343	1998-02-12	1998-02-12 00:00:00	1998-02-21	1998-02-21 00:00:00	32020		\N	90156	0	195662009	4112343		0
12407	733	4112343	1978-06-15	1978-06-15 00:00:00	1978-06-27	1978-06-27 00:00:00	32020		\N	48661	0	195662009	4112343		0
12594	744	4112343	2017-03-06	2017-03-06 00:00:00	2017-03-17	2017-03-17 00:00:00	32020		\N	49351	0	195662009	4112343		0
23253	1387	40481087	1986-01-23	1986-01-23 00:00:00	1986-02-06	1986-02-06 00:00:00	32020		\N	92026	0	444814009	40481087		0
23424	1397	260139	2008-12-18	2008-12-18 00:00:00	2008-12-25	2008-12-25 00:00:00	32020		\N	92798	0	10509002	260139		0
23605	1409	28060	1971-04-10	1971-04-10 00:00:00	1971-04-20	1971-04-20 00:00:00	32020		\N	93764	0	43878008	28060		0
23837	1425	4109685	1947-08-09	1947-08-09 00:00:00	1947-08-23	1947-08-23 00:00:00	32020		\N	94723	0	284551006	4109685		0
13416	789	40481087	1976-04-14	1976-04-14 00:00:00	1976-04-21	1976-04-21 00:00:00	32020		\N	52461	0	444814009	40481087		0
24179	1441	4112343	2016-12-17	2016-12-17 00:00:00	2016-12-29	2016-12-29 00:00:00	32020		\N	96013	0	195662009	4112343		0
24293	1447	81151	2017-07-22	2017-07-22 00:00:00	2017-08-26	2017-08-26 00:00:00	32020		\N	96523	0	44465007	81151		0
13914	822	40481087	2008-07-30	2008-07-30 00:00:00	2008-08-06	2008-08-06 00:00:00	32020		\N	54462	0	444814009	40481087		0
14068	830	80180	1995-08-04	1995-08-04 00:00:00	\N	\N	32020		\N	54953	0	396275006	80180		0
24785	1478	378001	1963-02-09	1963-02-09 00:00:00	1963-03-11	1963-03-11 00:00:00	32020		\N	98581	0	62106007	378001		0
24943	1490	40481087	1985-01-08	1985-01-08 00:00:00	1985-01-29	1985-01-29 00:00:00	32020		\N	99362	0	444814009	40481087		0
25071	1496	4296204	1940-04-08	1940-04-08 00:00:00	1940-04-29	1940-04-29 00:00:00	32020		\N	99645	0	403190006	4296204		0
14762	869	4112343	1993-01-23	1993-01-23 00:00:00	1993-01-30	1993-01-30 00:00:00	32020		\N	57753	0	195662009	4112343		0
25467	1516	80180	1979-07-12	1979-07-12 00:00:00	\N	\N	32020		\N	101249	0	396275006	80180		0
25628	1524	440448	1969-01-12	1969-01-12 00:00:00	\N	\N	32020		\N	101907	0	74400008	440448		0
25816	1533	40481087	1984-05-27	1984-05-27 00:00:00	1984-06-17	1984-06-17 00:00:00	32020		\N	102693	0	444814009	40481087		0
25935	1538	4155034	1999-07-05	1999-07-05 00:00:00	1999-07-26	1999-07-26 00:00:00	32020		\N	102947	0	283371005	4155034		0
15593	923	40481087	2005-01-31	2005-01-31 00:00:00	2005-02-14	2005-02-14 00:00:00	32020		\N	61423	0	444814009	40481087		0
26253	1558	40481087	1977-11-19	1977-11-19 00:00:00	1977-12-03	1977-12-03 00:00:00	32020		\N	104304	0	444814009	40481087		0
15897	940	260139	1947-05-05	1947-05-05 00:00:00	1947-05-19	1947-05-19 00:00:00	32020		\N	62537	0	10509002	260139		0
26570	1574	260139	2002-08-08	2002-08-08 00:00:00	2002-08-15	2002-08-15 00:00:00	32020		\N	105666	0	10509002	260139		0
26764	1585	40481087	2015-05-14	2015-05-14 00:00:00	2015-06-04	2015-06-04 00:00:00	32020		\N	106276	0	444814009	40481087		0
16420	970	28060	1997-03-10	1997-03-10 00:00:00	1997-03-21	1997-03-21 00:00:00	32020		\N	64521	0	43878008	28060		0
16572	978	28060	2011-11-02	2011-11-02 00:00:00	2011-11-13	2011-11-13 00:00:00	32020		\N	65143	0	43878008	28060		0
27274	1608	40481087	1983-11-14	1983-11-14 00:00:00	1983-11-28	1983-11-28 00:00:00	32020		\N	107976	0	444814009	40481087		0
27485	1622	260139	2002-06-12	2002-06-12 00:00:00	2002-06-26	2002-06-26 00:00:00	32020		\N	108998	0	10509002	260139		0
27568	1627	4237458	1964-12-24	1964-12-24 00:00:00	1965-01-23	1965-01-23 00:00:00	32020		\N	109349	0	58150001	4237458		0
27813	1641	40481087	1960-09-25	1960-09-25 00:00:00	1960-10-02	1960-10-02 00:00:00	32020		\N	110117	0	444814009	40481087		0
28021	1657	4283893	1987-09-02	1987-09-02 00:00:00	1987-10-07	1987-10-07 00:00:00	32020		\N	111243	0	36971009	4283893		0
28074	1658	260139	1984-09-17	1984-09-17 00:00:00	1984-10-01	1984-10-01 00:00:00	32020		\N	111327	0	10509002	260139		0
28266	1670	28060	1964-06-07	1964-06-07 00:00:00	1964-06-18	1964-06-18 00:00:00	32020		\N	112136	0	43878008	28060		0
28469	1685	4112343	1999-01-01	1999-01-01 00:00:00	1999-01-08	1999-01-08 00:00:00	32020		\N	112872	0	195662009	4112343		0
18073	1086	40481087	1969-11-13	1969-11-13 00:00:00	1969-12-04	1969-12-04 00:00:00	32020		\N	71310	0	444814009	40481087		0
28748	1702	80180	2008-10-07	2008-10-07 00:00:00	\N	\N	32020		\N	113829	0	396275006	80180		0
18416	1107	4329847	2007-06-15	2007-06-15 00:00:00	\N	\N	32020		\N	72859	0	22298006	4329847		0
18589	1117	40481087	1988-05-09	1988-05-09 00:00:00	1988-05-16	1988-05-16 00:00:00	32020		\N	73590	0	444814009	40481087		0
29227	1729	4112343	2018-03-04	2018-03-04 00:00:00	2018-03-17	2018-03-17 00:00:00	32020		\N	115628	0	195662009	4112343		0
18922	1137	40481087	1968-06-10	1968-06-10 00:00:00	1968-06-24	1968-06-24 00:00:00	32020		\N	74906	0	444814009	40481087		0
19089	1145	4027663	1972-08-15	1972-08-15 00:00:00	\N	\N	32020		\N	75655	0	13200003	4027663		0
19249	1154	40481087	1986-06-12	1986-06-12 00:00:00	1986-06-19	1986-06-19 00:00:00	32020		\N	76281	0	444814009	40481087		0
29915	1770	28060	1996-01-21	1996-01-21 00:00:00	1996-01-28	1996-01-28 00:00:00	32020		\N	118379	0	43878008	28060		0
30129	1781	4294548	1995-06-19	1995-06-19 00:00:00	1995-07-03	1995-07-03 00:00:00	32020		\N	119251	0	75498004	4294548		0
30249	1786	4112343	1989-04-09	1989-04-09 00:00:00	1989-04-16	1989-04-16 00:00:00	32020		\N	119721	0	195662009	4112343		0
30467	1796	4112343	1986-11-07	1986-11-07 00:00:00	1986-11-15	1986-11-15 00:00:00	32020		\N	120409	0	195662009	4112343		0
30560	1804	4218389	1986-06-02	1986-06-02 00:00:00	1986-06-23	1986-06-23 00:00:00	32020		\N	120877	0	39848009	4218389		0
30760	1819	372328	1999-09-26	1999-09-26 00:00:00	1999-10-10	1999-10-10 00:00:00	32020		\N	121649	0	65363002	372328		0
20400	1227	40481087	2006-01-27	2006-01-27 00:00:00	2006-02-10	2006-02-10 00:00:00	32020		\N	80782	0	444814009	40481087		0
31093	1842	4285898	2004-07-01	2004-07-01 00:00:00	\N	\N	32020		\N	122963	0	68496003	4285898		0
31233	1847	372328	1981-05-03	1981-05-03 00:00:00	1981-11-08	1981-11-08 00:00:00	32020		\N	123556	0	65363002	372328		0
31403	1855	260139	2016-10-31	2016-10-31 00:00:00	2016-11-14	2016-11-14 00:00:00	32020		\N	124171	0	10509002	260139		0
21053	1264	40481087	2002-06-07	2002-06-07 00:00:00	2002-06-28	2002-06-28 00:00:00	32020		\N	83277	0	444814009	40481087		0
31786	1885	40481087	2015-07-07	2015-07-07 00:00:00	2015-07-14	2015-07-14 00:00:00	32020		\N	125722	0	444814009	40481087		0
21269	1276	40481087	2000-08-23	2000-08-23 00:00:00	2000-09-06	2000-09-06 00:00:00	32020		\N	84149	0	444814009	40481087		0
21490	1289	40481087	2014-09-13	2014-09-13 00:00:00	2014-10-04	2014-10-04 00:00:00	32020		\N	85198	0	444814009	40481087		0
21593	1294	372328	1989-04-14	1989-04-14 00:00:00	1989-12-02	1989-12-02 00:00:00	32020		\N	85645	0	65363002	372328		0
21820	1310	4112343	2011-01-24	2011-01-24 00:00:00	2011-02-04	2011-02-04 00:00:00	32020		\N	86574	0	195662009	4112343		0
11445	675	4266809	1984-04-03	1984-04-03 00:00:00	\N	\N	32020		\N	44681	0	397881000	4266809		0
22149	1322	78272	1929-02-15	1929-02-15 00:00:00	1929-03-08	1929-03-08 00:00:00	32020		\N	87782	0	70704007	78272		0
22254	1328	28060	2010-04-08	2010-04-08 00:00:00	2010-04-18	2010-04-18 00:00:00	32020		\N	88224	0	43878008	28060		0
22436	1339	4134304	1968-12-29	1968-12-29 00:00:00	1969-03-29	1969-03-29 00:00:00	32020		\N	88788	0	263102004	4134304		0
22614	1352	28060	1972-07-13	1972-07-13 00:00:00	1972-07-21	1972-07-21 00:00:00	32020		\N	89560	0	43878008	28060		0
22791	1359	4294548	1947-06-04	1947-06-04 00:00:00	1947-06-18	1947-06-18 00:00:00	32020		\N	90166	0	75498004	4294548		0
12408	733	372328	2016-05-03	2016-05-03 00:00:00	2016-08-18	2016-08-18 00:00:00	32020		\N	48611	0	65363002	372328		0
12595	744	4112343	1963-01-14	1963-01-14 00:00:00	1963-01-22	1963-01-22 00:00:00	32020		\N	49314	0	195662009	4112343		0
23254	1387	260139	2000-08-26	2000-08-26 00:00:00	2000-09-02	2000-09-02 00:00:00	32020		\N	92015	0	10509002	260139		0
23436	1399	260139	1967-05-25	1967-05-25 00:00:00	1967-06-01	1967-06-01 00:00:00	32020		\N	92994	0	10509002	260139		0
23606	1409	260139	1997-11-17	1997-11-17 00:00:00	1997-12-01	1997-12-01 00:00:00	32020		\N	93716	0	10509002	260139		0
23838	1425	4112343	1990-02-08	1990-02-08 00:00:00	1990-02-19	1990-02-19 00:00:00	32020		\N	94787	0	195662009	4112343		0
13417	789	40481087	2007-03-09	2007-03-09 00:00:00	2007-03-23	2007-03-23 00:00:00	32020		\N	52512	0	444814009	40481087		0
24180	1441	40481087	1973-05-03	1973-05-03 00:00:00	1973-05-10	1973-05-10 00:00:00	32020		\N	96035	0	444814009	40481087		0
24294	1447	80180	1996-01-09	1996-01-09 00:00:00	\N	\N	32020		\N	96525	0	396275006	80180		0
13915	822	80180	2013-09-21	2013-09-21 00:00:00	\N	\N	32020		\N	54510	0	396275006	80180		0
14069	830	4112343	2016-02-09	2016-02-09 00:00:00	2016-02-21	2016-02-21 00:00:00	32020		\N	54958	0	195662009	4112343		0
24786	1478	260139	1997-12-22	1997-12-22 00:00:00	1997-12-29	1997-12-29 00:00:00	32020		\N	98632	0	10509002	260139		0
24944	1490	4218389	2011-01-20	2011-01-20 00:00:00	2011-02-10	2011-02-10 00:00:00	32020		\N	99328	0	39848009	4218389		0
25072	1496	260139	1924-06-28	1924-06-28 00:00:00	1924-07-05	1924-07-05 00:00:00	32020		\N	99672	0	10509002	260139		0
14763	869	28060	1970-06-25	1970-06-25 00:00:00	1970-07-02	1970-07-02 00:00:00	32020		\N	57791	0	43878008	28060		0
25468	1516	81151	1968-10-18	1968-10-18 00:00:00	1968-11-08	1968-11-08 00:00:00	32020		\N	101269	0	44465007	81151		0
25629	1524	4112343	2005-10-31	2005-10-31 00:00:00	2005-11-10	2005-11-10 00:00:00	32020		\N	101921	0	195662009	4112343		0
25817	1533	4112343	1974-01-13	1974-01-13 00:00:00	1974-01-26	1974-01-26 00:00:00	32020		\N	102646	0	195662009	4112343		0
25949	1540	4266809	1994-03-11	1994-03-11 00:00:00	\N	\N	32020		\N	103201	0	397881000	4266809		0
15594	923	28060	1970-11-02	1970-11-02 00:00:00	1970-11-13	1970-11-13 00:00:00	32020		\N	61472	0	43878008	28060		0
26254	1558	40481087	1974-01-13	1974-01-13 00:00:00	1974-02-03	1974-02-03 00:00:00	32020		\N	104381	0	444814009	40481087		0
15898	940	317576	1990-12-20	1990-12-20 00:00:00	\N	\N	32020		\N	62545	0	53741008	317576		0
26571	1574	40481087	2010-02-20	2010-02-20 00:00:00	2010-03-06	2010-03-06 00:00:00	32020		\N	105698	0	444814009	40481087		0
26765	1585	260139	1976-03-26	1976-03-26 00:00:00	1976-04-09	1976-04-09 00:00:00	32020		\N	106274	0	10509002	260139		0
16421	970	81151	2002-12-21	2002-12-21 00:00:00	2003-01-18	2003-01-18 00:00:00	32020		\N	64478	0	44465007	81151		0
16573	978	80180	2012-04-22	2012-04-22 00:00:00	\N	\N	32020		\N	65143	0	396275006	80180		0
27275	1608	28060	1943-08-05	1943-08-05 00:00:00	1943-08-14	1943-08-14 00:00:00	32020		\N	108016	0	43878008	28060		0
27486	1622	40481087	1984-10-10	1984-10-10 00:00:00	1984-10-31	1984-10-31 00:00:00	32020		\N	109007	0	444814009	40481087		0
27569	1627	4116491	1972-07-10	1972-07-10 00:00:00	1972-08-27	1972-08-27 00:00:00	32020		\N	109365	0	301011002	4116491		0
27814	1641	4112343	1976-02-12	1976-02-12 00:00:00	1976-02-25	1976-02-25 00:00:00	32020		\N	110153	0	195662009	4112343		0
28022	1657	40481087	1969-05-21	1969-05-21 00:00:00	1969-06-11	1969-06-11 00:00:00	32020		\N	111212	0	444814009	40481087		0
28075	1658	81151	1939-03-24	1939-03-24 00:00:00	1939-04-21	1939-04-21 00:00:00	32020		\N	111376	0	44465007	81151		0
28267	1670	40481087	2003-03-26	2003-03-26 00:00:00	2003-04-16	2003-04-16 00:00:00	32020		\N	112151	0	444814009	40481087		0
28470	1685	192671	2016-01-14	2016-01-14 00:00:00	\N	\N	32020		\N	112881	0	K92.2	35208414		0
18074	1086	40481087	1970-05-08	1970-05-08 00:00:00	1970-05-22	1970-05-22 00:00:00	32020		\N	71312	0	444814009	40481087		0
28749	1702	4112343	1983-12-14	1983-12-14 00:00:00	1983-12-21	1983-12-21 00:00:00	32020		\N	113795	0	195662009	4112343		0
18418	1107	4112343	1930-08-13	1930-08-13 00:00:00	1930-08-25	1930-08-25 00:00:00	32020		\N	72927	0	195662009	4112343		0
18590	1117	4112343	1957-11-30	1957-11-30 00:00:00	1957-12-08	1957-12-08 00:00:00	32020		\N	73622	0	195662009	4112343		0
29228	1729	40481087	1983-07-16	1983-07-16 00:00:00	1983-07-30	1983-07-30 00:00:00	32020		\N	115610	0	444814009	40481087		0
18923	1137	40481087	1997-01-27	1997-01-27 00:00:00	1997-02-03	1997-02-03 00:00:00	32020		\N	74887	0	444814009	40481087		0
19090	1145	4112343	1986-12-18	1986-12-18 00:00:00	1986-12-30	1986-12-30 00:00:00	32020		\N	75633	0	195662009	4112343		0
19250	1154	40481087	1976-02-16	1976-02-16 00:00:00	1976-03-01	1976-03-01 00:00:00	32020		\N	76278	0	444814009	40481087		0
29916	1770	4116491	2010-06-03	2010-06-03 00:00:00	2010-07-18	2010-07-18 00:00:00	32020		\N	118361	0	301011002	4116491		0
30130	1781	260139	2002-10-04	2002-10-04 00:00:00	2002-10-11	2002-10-11 00:00:00	32020		\N	119185	0	10509002	260139		0
30250	1786	4112343	1980-08-16	1980-08-16 00:00:00	1980-08-23	1980-08-23 00:00:00	32020		\N	119751	0	195662009	4112343		0
30468	1796	40481087	2017-05-14	2017-05-14 00:00:00	2017-05-21	2017-05-21 00:00:00	32020		\N	120426	0	444814009	40481087		0
30561	1804	260139	1989-07-12	1989-07-12 00:00:00	1989-07-19	1989-07-19 00:00:00	32020		\N	120891	0	10509002	260139		0
30761	1819	80180	2014-08-28	2014-08-28 00:00:00	\N	\N	32020		\N	121683	0	396275006	80180		0
20401	1227	4112343	1966-11-09	1966-11-09 00:00:00	1966-11-21	1966-11-21 00:00:00	32020		\N	80804	0	195662009	4112343		0
31094	1842	80180	2004-11-28	2004-11-28 00:00:00	\N	\N	32020		\N	122963	0	396275006	80180		0
31234	1847	4112343	1941-12-25	1941-12-25 00:00:00	1942-01-02	1942-01-02 00:00:00	32020		\N	123574	0	195662009	4112343		0
31404	1855	40481087	1992-02-26	1992-02-26 00:00:00	1992-03-11	1992-03-11 00:00:00	32020		\N	124212	0	444814009	40481087		0
21054	1264	40481087	1957-08-06	1957-08-06 00:00:00	1957-08-13	1957-08-13 00:00:00	32020		\N	83326	0	444814009	40481087		0
31787	1885	372328	1976-02-12	1976-02-12 00:00:00	1976-08-03	1976-08-03 00:00:00	32020		\N	125723	0	65363002	372328		0
21270	1276	40481087	1978-02-22	1978-02-22 00:00:00	1978-03-01	1978-03-01 00:00:00	32020		\N	84230	0	444814009	40481087		0
21491	1289	40481087	1995-06-06	1995-06-06 00:00:00	1995-06-20	1995-06-20 00:00:00	32020		\N	85210	0	444814009	40481087		0
21594	1294	260139	1978-09-19	1978-09-19 00:00:00	1978-10-03	1978-10-03 00:00:00	32020		\N	85650	0	10509002	260139		0
21821	1310	4112343	1979-05-03	1979-05-03 00:00:00	1979-05-12	1979-05-12 00:00:00	32020		\N	86563	0	195662009	4112343		0
11446	675	4310024	1983-03-10	1983-03-10 00:00:00	\N	\N	32020		\N	44681	0	424802006	4310024		0
22150	1322	4278672	1928-02-21	1928-02-21 00:00:00	1928-03-22	1928-03-22 00:00:00	32020		\N	87781	0	65966004	4278672		0
22255	1328	28060	1973-04-11	1973-04-11 00:00:00	1973-04-23	1973-04-23 00:00:00	32020		\N	88193	0	43878008	28060		0
22437	1339	4218389	1999-04-17	1999-04-17 00:00:00	1999-05-08	1999-05-08 00:00:00	32020		\N	88821	0	39848009	4218389		0
22615	1352	4112343	1986-08-24	1986-08-24 00:00:00	1986-08-31	1986-08-31 00:00:00	32020		\N	89538	0	195662009	4112343		0
22792	1359	40481087	1981-04-04	1981-04-04 00:00:00	1981-04-11	1981-04-11 00:00:00	32020		\N	90194	0	444814009	40481087		0
12409	733	40481087	1961-04-29	1961-04-29 00:00:00	1961-05-06	1961-05-06 00:00:00	32020		\N	48659	0	444814009	40481087		0
12596	744	40481087	1979-07-23	1979-07-23 00:00:00	1979-08-13	1979-08-13 00:00:00	32020		\N	49329	0	444814009	40481087		0
23255	1387	195588	2013-03-21	2013-03-21 00:00:00	2013-05-05	2013-05-05 00:00:00	32020		\N	92046	0	38822007	195588		0
23437	1399	40481087	1986-03-19	1986-03-19 00:00:00	1986-04-02	1986-04-02 00:00:00	32020		\N	93033	0	444814009	40481087		0
23607	1409	192671	1960-04-29	1960-04-29 00:00:00	\N	\N	32020		\N	93829	0	K92.2	35208414		0
23839	1425	40481087	1989-06-28	1989-06-28 00:00:00	1989-07-05	1989-07-05 00:00:00	32020		\N	94744	0	444814009	40481087		0
13418	789	4109685	2000-06-25	2000-06-25 00:00:00	2000-07-09	2000-07-09 00:00:00	32020		\N	52460	0	284551006	4109685		0
24181	1441	378001	1976-11-05	1976-11-05 00:00:00	1976-12-05	1976-12-05 00:00:00	32020		\N	95948	0	62106007	378001		0
24295	1447	81151	2019-05-18	2019-05-18 00:00:00	2019-06-01	2019-06-01 00:00:00	32020		\N	96524	0	44465007	81151		0
13916	822	4112343	1976-03-26	1976-03-26 00:00:00	1976-04-02	1976-04-02 00:00:00	32020		\N	54480	0	195662009	4112343		0
14070	830	4112343	1994-06-19	1994-06-19 00:00:00	1994-06-30	1994-06-30 00:00:00	32020		\N	55002	0	195662009	4112343		0
24787	1478	260139	1980-07-26	1980-07-26 00:00:00	1980-08-02	1980-08-02 00:00:00	32020		\N	98615	0	10509002	260139		0
24945	1490	4230399	2018-10-01	2018-10-01 00:00:00	2018-10-31	2018-10-31 00:00:00	32020		\N	99329	0	359817006	4230399		0
25073	1496	260139	1977-03-31	1977-03-31 00:00:00	1977-04-14	1977-04-14 00:00:00	32020		\N	99698	0	10509002	260139		0
14764	869	260139	1997-04-04	1997-04-04 00:00:00	1997-04-18	1997-04-18 00:00:00	32020		\N	57754	0	10509002	260139		0
25469	1516	4027663	1968-12-26	1968-12-26 00:00:00	\N	\N	32020		\N	101269	0	13200003	4027663		0
25630	1524	260139	1988-02-23	1988-02-23 00:00:00	1988-03-01	1988-03-01 00:00:00	32020		\N	101953	0	10509002	260139		0
25818	1533	4310024	2008-05-18	2008-05-18 00:00:00	\N	\N	32020		\N	102681	0	424802006	4310024		0
25950	1540	4285898	1994-01-10	1994-01-10 00:00:00	\N	\N	32020		\N	103201	0	68496003	4285898		0
15595	923	4112343	2015-12-07	2015-12-07 00:00:00	2015-12-18	2015-12-18 00:00:00	32020		\N	61478	0	195662009	4112343		0
26255	1558	40481087	1978-03-11	1978-03-11 00:00:00	1978-03-18	1978-03-18 00:00:00	32020		\N	104370	0	444814009	40481087		0
15899	940	372328	1982-07-16	1982-07-16 00:00:00	1982-12-02	1982-12-02 00:00:00	32020		\N	62552	0	65363002	372328		0
26572	1574	260139	2017-09-26	2017-09-26 00:00:00	2017-10-10	2017-10-10 00:00:00	32020		\N	105648	0	10509002	260139		0
26766	1585	40481087	2003-03-19	2003-03-19 00:00:00	2003-04-02	2003-04-02 00:00:00	32020		\N	106300	0	444814009	40481087		0
16422	970	372328	1956-11-14	1956-11-14 00:00:00	1957-05-19	1957-05-19 00:00:00	32020		\N	64531	0	65363002	372328		0
16574	978	4294548	1978-10-06	1978-10-06 00:00:00	1979-04-06	1979-04-06 00:00:00	32020		\N	65164	0	75498004	4294548		0
27276	1608	40481087	1942-03-20	1942-03-20 00:00:00	1942-03-27	1942-03-27 00:00:00	32020		\N	107984	0	444814009	40481087		0
27487	1622	28060	1989-01-21	1989-01-21 00:00:00	1989-01-31	1989-01-31 00:00:00	32020		\N	108945	0	43878008	28060		0
27570	1627	260139	1995-10-05	1995-10-05 00:00:00	1995-10-12	1995-10-12 00:00:00	32020		\N	109337	0	10509002	260139		0
27815	1641	40481087	2001-02-24	2001-02-24 00:00:00	2001-03-17	2001-03-17 00:00:00	32020		\N	110194	0	444814009	40481087		0
28023	1657	40481087	1957-01-27	1957-01-27 00:00:00	1957-02-17	1957-02-17 00:00:00	32020		\N	111228	0	444814009	40481087		0
28076	1658	40481087	1972-06-27	1972-06-27 00:00:00	1972-07-04	1972-07-04 00:00:00	32020		\N	111326	0	444814009	40481087		0
28268	1670	80180	2004-06-13	2004-06-13 00:00:00	\N	\N	32020		\N	112151	0	396275006	80180		0
28471	1685	260139	1985-09-13	1985-09-13 00:00:00	1985-09-27	1985-09-27 00:00:00	32020		\N	112870	0	10509002	260139		0
18075	1086	4027663	1994-06-04	1994-06-04 00:00:00	\N	\N	32020		\N	71380	0	13200003	4027663		0
28750	1703	378001	2002-03-11	2002-03-11 00:00:00	2002-05-10	2002-05-10 00:00:00	32020		\N	113932	0	62106007	378001		0
18419	1107	40481087	1982-05-26	1982-05-26 00:00:00	1982-06-09	1982-06-09 00:00:00	32020		\N	72921	0	444814009	40481087		0
18591	1117	30753	1977-11-02	1977-11-02 00:00:00	\N	\N	32020		\N	73584	0	16761005	30753		0
29261	1733	257012	1998-04-20	1998-04-20 00:00:00	\N	\N	32020		\N	115834	0	40055000	257012		0
18924	1137	4156265	1975-06-01	1975-06-01 00:00:00	1975-06-15	1975-06-15 00:00:00	32020		\N	74977	0	370247008	4156265		0
29567	1750	4294548	1973-08-23	1973-08-23 00:00:00	1973-09-13	1973-09-13 00:00:00	32020		\N	117039	0	75498004	4294548		0
19251	1154	40481087	1988-08-14	1988-08-14 00:00:00	1988-08-28	1988-08-28 00:00:00	32020		\N	76282	0	444814009	40481087		0
29917	1770	40481087	2006-09-07	2006-09-07 00:00:00	2006-09-14	2006-09-14 00:00:00	32020		\N	118360	0	444814009	40481087		0
30131	1781	40481087	2004-07-12	2004-07-12 00:00:00	2004-07-19	2004-07-19 00:00:00	32020		\N	119207	0	444814009	40481087		0
30251	1786	4112343	1979-11-08	1979-11-08 00:00:00	1979-11-19	1979-11-19 00:00:00	32020		\N	119694	0	195662009	4112343		0
30469	1796	80180	2017-09-06	2017-09-06 00:00:00	\N	\N	32020		\N	120426	0	396275006	80180		0
30562	1804	40481087	1998-11-24	1998-11-24 00:00:00	1998-12-15	1998-12-15 00:00:00	32020		\N	120850	0	444814009	40481087		0
30762	1819	40481087	2013-03-14	2013-03-14 00:00:00	2013-04-04	2013-04-04 00:00:00	32020		\N	121665	0	444814009	40481087		0
20402	1227	4112343	1967-09-02	1967-09-02 00:00:00	1967-09-10	1967-09-10 00:00:00	32020		\N	80750	0	195662009	4112343		0
31095	1842	28060	1997-08-08	1997-08-08 00:00:00	1997-08-17	1997-08-17 00:00:00	32020		\N	122951	0	43878008	28060		0
31235	1847	378419	1988-12-18	1988-12-18 00:00:00	\N	\N	32020		\N	123525	0	26929004	378419		0
31405	1855	4112343	2005-11-21	2005-11-21 00:00:00	2005-12-01	2005-12-01 00:00:00	32020		\N	124224	0	195662009	4112343		0
21055	1264	40481087	2017-02-17	2017-02-17 00:00:00	2017-03-03	2017-03-03 00:00:00	32020		\N	83278	0	444814009	40481087		0
31788	1885	260139	2019-04-01	2019-04-01 00:00:00	2019-04-08	2019-04-08 00:00:00	32020		\N	125691	0	10509002	260139		0
21271	1276	4112343	1967-09-10	1967-09-10 00:00:00	1967-09-19	1967-09-19 00:00:00	32020		\N	84139	0	195662009	4112343		0
21492	1289	4112343	2006-12-23	2006-12-23 00:00:00	2006-12-31	2006-12-31 00:00:00	32020		\N	85197	0	195662009	4112343		0
21595	1294	40481087	1974-02-20	1974-02-20 00:00:00	1974-02-27	1974-02-27 00:00:00	32020		\N	85623	0	444814009	40481087		0
21822	1310	4142905	1944-01-10	1944-01-10 00:00:00	1944-03-10	1944-03-10 00:00:00	32020		\N	86677	0	33737001	4142905		0
11447	675	81893	1983-07-08	1983-07-08 00:00:00	\N	\N	32020		\N	44681	0	64766004	81893		0
22151	1322	40481087	2005-09-30	2005-09-30 00:00:00	2005-10-07	2005-10-07 00:00:00	32020		\N	87722	0	444814009	40481087		0
22256	1328	28060	1993-02-22	1993-02-22 00:00:00	1993-03-06	1993-03-06 00:00:00	32020		\N	88136	0	43878008	28060		0
22438	1339	4285898	2005-10-21	2005-10-21 00:00:00	\N	\N	32020		\N	88824	0	68496003	4285898		0
22616	1352	4112343	1996-10-09	1996-10-09 00:00:00	1996-10-19	1996-10-19 00:00:00	32020		\N	89594	0	195662009	4112343		0
22793	1359	4112343	1975-06-29	1975-06-29 00:00:00	1975-07-09	1975-07-09 00:00:00	32020		\N	90205	0	195662009	4112343		0
12410	733	4112343	1994-02-16	1994-02-16 00:00:00	1994-02-27	1994-02-27 00:00:00	32020		\N	48610	0	195662009	4112343		0
12597	744	372328	1957-11-18	1957-11-18 00:00:00	1958-03-14	1958-03-14 00:00:00	32020		\N	49365	0	65363002	372328		0
23269	1389	40481087	1991-05-17	1991-05-17 00:00:00	1991-06-07	1991-06-07 00:00:00	32020		\N	92218	0	444814009	40481087		0
23438	1399	4112343	1978-08-08	1978-08-08 00:00:00	1978-08-17	1978-08-17 00:00:00	32020		\N	92995	0	195662009	4112343		0
23608	1409	40481087	1941-12-20	1941-12-20 00:00:00	1942-01-03	1942-01-03 00:00:00	32020		\N	93814	0	444814009	40481087		0
23840	1425	28060	1945-11-04	1945-11-04 00:00:00	1945-11-16	1945-11-16 00:00:00	32020		\N	94783	0	43878008	28060		0
13419	789	4112343	2006-04-14	2006-04-14 00:00:00	2006-04-25	2006-04-25 00:00:00	32020		\N	52477	0	195662009	4112343		0
24182	1441	40481087	1982-11-27	1982-11-27 00:00:00	1982-12-18	1982-12-18 00:00:00	32020		\N	96037	0	444814009	40481087		0
24296	1447	40481087	1993-02-25	1993-02-25 00:00:00	1993-03-04	1993-03-04 00:00:00	32020		\N	96538	0	444814009	40481087		0
13917	822	4112343	2007-01-21	2007-01-21 00:00:00	2007-02-01	2007-02-01 00:00:00	32020		\N	54461	0	195662009	4112343		0
14071	830	40481087	1961-12-09	1961-12-09 00:00:00	1961-12-30	1961-12-30 00:00:00	32020		\N	54976	0	444814009	40481087		0
24788	1478	4048171	1964-03-27	1964-03-27 00:00:00	\N	\N	32020		\N	98628	0	232353008	4048171		0
24946	1490	4283893	1996-08-06	1996-08-06 00:00:00	1996-10-01	1996-10-01 00:00:00	32020		\N	99364	0	36971009	4283893		0
25074	1496	28060	1933-10-07	1933-10-07 00:00:00	1933-10-17	1933-10-17 00:00:00	32020		\N	99720	0	43878008	28060		0
14765	869	4152936	1975-09-05	1975-09-05 00:00:00	1975-09-26	1975-09-26 00:00:00	32020		\N	57726	0	283385000	4152936		0
25470	1516	260139	1984-04-18	1984-04-18 00:00:00	1984-05-02	1984-05-02 00:00:00	32020		\N	101276	0	10509002	260139		0
25631	1524	40481087	1981-04-02	1981-04-02 00:00:00	1981-04-23	1981-04-23 00:00:00	32020		\N	101912	0	444814009	40481087		0
25819	1533	4155034	2017-08-29	2017-08-29 00:00:00	2017-09-19	2017-09-19 00:00:00	32020		\N	102692	0	283371005	4155034		0
25951	1540	80180	1994-03-11	1994-03-11 00:00:00	\N	\N	32020		\N	103201	0	396275006	80180		0
15596	923	40481087	1961-10-15	1961-10-15 00:00:00	1961-10-29	1961-10-29 00:00:00	32020		\N	61417	0	444814009	40481087		0
26256	1558	4283893	2016-10-30	2016-10-30 00:00:00	2016-11-27	2016-11-27 00:00:00	32020		\N	104374	0	36971009	4283893		0
15900	940	260139	1982-07-13	1982-07-13 00:00:00	1982-07-20	1982-07-20 00:00:00	32020		\N	62567	0	10509002	260139		0
26573	1574	4218389	1972-05-22	1972-05-22 00:00:00	1972-06-19	1972-06-19 00:00:00	32020		\N	105705	0	39848009	4218389		0
26767	1585	260139	1939-05-08	1939-05-08 00:00:00	1939-05-15	1939-05-15 00:00:00	32020		\N	106254	0	10509002	260139		0
16423	970	4294548	2008-07-25	2008-07-25 00:00:00	2008-08-01	2008-08-01 00:00:00	32020		\N	64527	0	75498004	4294548		0
16575	978	257012	1978-10-20	1978-10-20 00:00:00	\N	\N	32020		\N	65122	0	40055000	257012		0
27277	1608	40481087	1965-09-18	1965-09-18 00:00:00	1965-09-25	1965-09-25 00:00:00	32020		\N	107967	0	444814009	40481087		0
27488	1622	40481087	1984-05-29	1984-05-29 00:00:00	1984-06-05	1984-06-05 00:00:00	32020		\N	109030	0	444814009	40481087		0
27571	1627	28060	1971-02-09	1971-02-09 00:00:00	1971-02-22	1971-02-22 00:00:00	32020		\N	109364	0	43878008	28060		0
27816	1641	78272	1964-06-13	1964-06-13 00:00:00	1964-07-04	1964-07-04 00:00:00	32020		\N	110174	0	70704007	78272		0
28024	1657	28060	1955-11-22	1955-11-22 00:00:00	1955-12-03	1955-12-03 00:00:00	32020		\N	111175	0	43878008	28060		0
28077	1658	40481087	1999-12-17	1999-12-17 00:00:00	2000-01-07	2000-01-07 00:00:00	32020		\N	111416	0	444814009	40481087		0
28269	1670	260139	2014-10-13	2014-10-13 00:00:00	2014-10-20	2014-10-20 00:00:00	32020		\N	112139	0	10509002	260139		0
28472	1685	40481087	2019-01-20	2019-01-20 00:00:00	2019-02-10	2019-02-10 00:00:00	32020		\N	112915	0	444814009	40481087		0
18076	1086	4109685	1975-09-17	1975-09-17 00:00:00	1975-10-01	1975-10-01 00:00:00	32020		\N	71349	0	284551006	4109685		0
28751	1703	378001	1976-05-14	1976-05-14 00:00:00	1976-07-13	1976-07-13 00:00:00	32020		\N	113929	0	62106007	378001		0
18420	1107	40481087	1955-02-23	1955-02-23 00:00:00	1955-03-16	1955-03-16 00:00:00	32020		\N	72843	0	444814009	40481087		0
18592	1117	81893	1976-12-07	1976-12-07 00:00:00	\N	\N	32020		\N	73584	0	64766004	81893		0
29262	1733	4218389	1999-04-20	1999-04-20 00:00:00	1999-05-18	1999-05-18 00:00:00	32020		\N	115805	0	39848009	4218389		0
29383	1740	40481087	1984-08-14	1984-08-14 00:00:00	1984-09-04	1984-09-04 00:00:00	32020		\N	116296	0	444814009	40481087		0
29568	1750	80180	2002-08-24	2002-08-24 00:00:00	\N	\N	32020		\N	117012	0	396275006	80180		0
19252	1154	4283893	2007-12-31	2007-12-31 00:00:00	2008-03-03	2008-03-03 00:00:00	32020		\N	76286	0	36971009	4283893		0
29918	1770	40481087	2002-07-12	2002-07-12 00:00:00	2002-07-26	2002-07-26 00:00:00	32020		\N	118341	0	444814009	40481087		0
30132	1781	40481087	1950-09-09	1950-09-09 00:00:00	1950-09-23	1950-09-23 00:00:00	32020		\N	119196	0	444814009	40481087		0
30252	1786	40481087	1977-01-07	1977-01-07 00:00:00	1977-01-28	1977-01-28 00:00:00	32020		\N	119686	0	444814009	40481087		0
30470	1796	4112343	2014-11-01	2014-11-01 00:00:00	2014-11-10	2014-11-10 00:00:00	32020		\N	120401	0	195662009	4112343		0
30563	1804	4283893	1992-12-22	1992-12-22 00:00:00	1993-01-12	1993-01-12 00:00:00	32020		\N	120849	0	36971009	4283893		0
30763	1819	4112343	2010-09-10	2010-09-10 00:00:00	2010-09-18	2010-09-18 00:00:00	32020		\N	121689	0	195662009	4112343		0
20403	1227	4112343	1977-06-23	1977-06-23 00:00:00	1977-07-04	1977-07-04 00:00:00	32020		\N	80847	0	195662009	4112343		0
31096	1842	40481087	1999-06-05	1999-06-05 00:00:00	1999-06-19	1999-06-19 00:00:00	32020		\N	122958	0	444814009	40481087		0
31236	1848	40481087	1974-12-12	1974-12-12 00:00:00	1975-01-02	1975-01-02 00:00:00	32020		\N	123596	0	444814009	40481087		0
31406	1855	4310024	2013-10-07	2013-10-07 00:00:00	\N	\N	32020		\N	124207	0	424802006	4310024		0
21056	1264	40481087	1955-06-26	1955-06-26 00:00:00	1955-07-10	1955-07-10 00:00:00	32020		\N	83322	0	444814009	40481087		0
31789	1885	40481087	2000-11-29	2000-11-29 00:00:00	2000-12-13	2000-12-13 00:00:00	32020		\N	125688	0	444814009	40481087		0
21272	1276	40481087	2016-08-12	2016-08-12 00:00:00	2016-08-19	2016-08-19 00:00:00	32020		\N	84197	0	444814009	40481087		0
21493	1289	260139	1976-12-26	1976-12-26 00:00:00	1977-01-09	1977-01-09 00:00:00	32020		\N	85194	0	10509002	260139		0
21596	1294	372328	1975-01-07	1975-01-07 00:00:00	1975-04-26	1975-04-26 00:00:00	32020		\N	85626	0	65363002	372328		0
21823	1310	372328	1968-09-30	1968-09-30 00:00:00	1971-09-24	1971-09-24 00:00:00	32020		\N	86575	0	65363002	372328		0
11448	675	80180	1984-04-03	1984-04-03 00:00:00	\N	\N	32020		\N	44681	0	396275006	80180		0
22152	1322	4152936	1996-12-02	1996-12-02 00:00:00	1996-12-23	1996-12-23 00:00:00	32020		\N	87739	0	283385000	4152936		0
22257	1328	372328	1947-08-29	1947-08-29 00:00:00	1948-01-01	1948-01-01 00:00:00	32020		\N	88137	0	65363002	372328		0
22439	1339	80180	2006-03-20	2006-03-20 00:00:00	\N	\N	32020		\N	88824	0	396275006	80180		0
22617	1352	40481087	1976-10-03	1976-10-03 00:00:00	1976-10-24	1976-10-24 00:00:00	32020		\N	89537	0	444814009	40481087		0
22794	1359	28060	1945-04-17	1945-04-17 00:00:00	1945-04-24	1945-04-24 00:00:00	32020		\N	90201	0	43878008	28060		0
12411	733	28060	1944-09-19	1944-09-19 00:00:00	1944-09-30	1944-09-30 00:00:00	32020		\N	48651	0	43878008	28060		0
12598	744	4112343	1963-04-26	1963-04-26 00:00:00	1963-05-08	1963-05-08 00:00:00	32020		\N	49327	0	195662009	4112343		0
23270	1389	40481087	1965-07-31	1965-07-31 00:00:00	1965-08-14	1965-08-14 00:00:00	32020		\N	92198	0	444814009	40481087		0
23439	1399	260139	1988-04-01	1988-04-01 00:00:00	1988-04-08	1988-04-08 00:00:00	32020		\N	93045	0	10509002	260139		0
23609	1409	4112343	1930-12-18	1930-12-18 00:00:00	1930-12-27	1930-12-27 00:00:00	32020		\N	93812	0	195662009	4112343		0
23841	1426	4112343	1970-03-30	1970-03-30 00:00:00	1970-04-08	1970-04-08 00:00:00	32020		\N	94806	0	195662009	4112343		0
13420	789	81151	1990-02-22	1990-02-22 00:00:00	1990-03-29	1990-03-29 00:00:00	32020		\N	52457	0	44465007	81151		0
24183	1442	40481087	1997-11-23	1997-11-23 00:00:00	1997-11-30	1997-11-30 00:00:00	32020		\N	96149	0	444814009	40481087		0
24297	1448	372328	1977-11-23	1977-11-23 00:00:00	1978-03-08	1978-03-08 00:00:00	32020		\N	96572	0	65363002	372328		0
13918	822	40481087	1992-09-23	1992-09-23 00:00:00	1992-10-07	1992-10-07 00:00:00	32020		\N	54459	0	444814009	40481087		0
14072	830	4112343	1992-05-18	1992-05-18 00:00:00	1992-05-27	1992-05-27 00:00:00	32020		\N	55009	0	195662009	4112343		0
24789	1478	257012	2018-10-07	2018-10-07 00:00:00	\N	\N	32020		\N	98662	0	40055000	257012		0
24947	1490	4112343	1953-08-19	1953-08-19 00:00:00	1953-08-28	1953-08-28 00:00:00	32020		\N	99380	0	195662009	4112343		0
25075	1496	378419	1992-05-03	1992-05-03 00:00:00	\N	\N	32020		\N	99704	0	26929004	378419		0
14766	869	40481087	1925-03-05	1925-03-05 00:00:00	1925-03-26	1925-03-26 00:00:00	32020		\N	57682	0	444814009	40481087		0
25471	1516	4109685	1966-12-23	1966-12-23 00:00:00	1967-01-06	1967-01-06 00:00:00	32020		\N	101267	0	284551006	4109685		0
25632	1524	40481087	1972-02-23	1972-02-23 00:00:00	1972-03-01	1972-03-01 00:00:00	32020		\N	101911	0	444814009	40481087		0
25820	1533	40481087	1991-02-16	1991-02-16 00:00:00	1991-03-02	1991-03-02 00:00:00	32020		\N	102694	0	444814009	40481087		0
25952	1540	372328	1998-09-21	1998-09-21 00:00:00	1998-12-21	1998-12-21 00:00:00	32020		\N	103187	0	65363002	372328		0
15597	923	40481087	2010-05-24	2010-05-24 00:00:00	2010-06-07	2010-06-07 00:00:00	32020		\N	61434	0	444814009	40481087		0
26257	1558	4109685	1969-04-10	1969-04-10 00:00:00	1969-05-01	1969-05-01 00:00:00	32020		\N	104302	0	284551006	4109685		0
15901	940	80180	1982-07-09	1982-07-09 00:00:00	\N	\N	32020		\N	62529	0	396275006	80180		0
26574	1574	40481087	2014-01-20	2014-01-20 00:00:00	2014-01-27	2014-01-27 00:00:00	32020		\N	105699	0	444814009	40481087		0
26768	1585	4112343	2007-06-05	2007-06-05 00:00:00	2007-06-12	2007-06-12 00:00:00	32020		\N	106301	0	195662009	4112343		0
16424	970	40481087	2019-03-15	2019-03-15 00:00:00	2019-03-29	2019-03-29 00:00:00	32020		\N	64530	0	444814009	40481087		0
16576	978	4027663	2000-08-08	2000-08-08 00:00:00	\N	\N	32020		\N	65134	0	13200003	4027663		0
27278	1608	4112343	1953-01-12	1953-01-12 00:00:00	1953-01-20	1953-01-20 00:00:00	32020		\N	108041	0	195662009	4112343		0
27489	1622	40481087	1995-03-16	1995-03-16 00:00:00	1995-03-23	1995-03-23 00:00:00	32020		\N	108995	0	444814009	40481087		0
27572	1627	372328	1955-09-13	1955-09-13 00:00:00	1955-10-08	1955-10-08 00:00:00	32020		\N	109371	0	65363002	372328		0
27817	1641	40481087	1959-12-15	1959-12-15 00:00:00	1959-12-22	1959-12-22 00:00:00	32020		\N	110152	0	444814009	40481087		0
28025	1657	4112343	1984-03-21	1984-03-21 00:00:00	1984-03-29	1984-03-29 00:00:00	32020		\N	111242	0	195662009	4112343		0
28078	1658	260139	2016-04-18	2016-04-18 00:00:00	2016-04-25	2016-04-25 00:00:00	32020		\N	111297	0	10509002	260139		0
28270	1670	4051466	1968-01-11	1968-01-11 00:00:00	1983-11-27	1983-11-27 00:00:00	32020		\N	112131	0	233678006	4051466		0
28473	1685	4112343	1980-09-10	1980-09-10 00:00:00	1980-09-20	1980-09-20 00:00:00	32020		\N	112883	0	195662009	4112343		0
18077	1086	40481087	2008-09-06	2008-09-06 00:00:00	2008-09-13	2008-09-13 00:00:00	32020		\N	71317	0	444814009	40481087		0
28752	1703	4112343	1963-07-27	1963-07-27 00:00:00	1963-08-08	1963-08-08 00:00:00	32020		\N	113907	0	195662009	4112343		0
18421	1107	260139	1956-12-20	1956-12-20 00:00:00	1956-12-27	1956-12-27 00:00:00	32020		\N	72928	0	10509002	260139		0
29051	1719	260139	1973-06-25	1973-06-25 00:00:00	1973-07-02	1973-07-02 00:00:00	32020		\N	114956	0	10509002	260139		0
29263	1733	4294548	1998-03-30	1998-03-30 00:00:00	1998-08-03	1998-08-03 00:00:00	32020		\N	115800	0	75498004	4294548		0
29384	1740	4266809	1989-10-12	1989-10-12 00:00:00	\N	\N	32020		\N	116281	0	397881000	4266809		0
29569	1750	4296205	2012-09-09	2012-09-09 00:00:00	2012-10-14	2012-10-14 00:00:00	32020		\N	117017	0	403191005	4296205		0
19253	1154	260139	2014-07-19	2014-07-19 00:00:00	2014-08-02	2014-08-02 00:00:00	32020		\N	76255	0	10509002	260139		0
29919	1770	260139	1995-01-04	1995-01-04 00:00:00	1995-01-18	1995-01-18 00:00:00	32020		\N	118401	0	10509002	260139		0
30133	1781	260139	1961-01-27	1961-01-27 00:00:00	1961-02-03	1961-02-03 00:00:00	32020		\N	119204	0	10509002	260139		0
30253	1786	4112343	1947-03-10	1947-03-10 00:00:00	1947-03-22	1947-03-22 00:00:00	32020		\N	119681	0	195662009	4112343		0
30471	1796	4112343	1991-05-10	1991-05-10 00:00:00	1991-05-21	1991-05-21 00:00:00	32020		\N	120424	0	195662009	4112343		0
30564	1804	40481087	1939-04-04	1939-04-04 00:00:00	1939-04-25	1939-04-25 00:00:00	32020		\N	120825	0	444814009	40481087		0
30764	1819	257012	1977-08-28	1977-08-28 00:00:00	\N	\N	32020		\N	121672	0	40055000	257012		0
20404	1227	4296204	1960-07-14	1960-07-14 00:00:00	1960-08-04	1960-08-04 00:00:00	32020		\N	80820	0	403190006	4296204		0
31097	1842	40481087	1974-12-09	1974-12-09 00:00:00	1974-12-23	1974-12-23 00:00:00	32020		\N	122956	0	444814009	40481087		0
31237	1848	4112343	1983-07-23	1983-07-23 00:00:00	1983-08-01	1983-08-01 00:00:00	32020		\N	123686	0	195662009	4112343		0
31407	1855	372328	1976-12-10	1976-12-10 00:00:00	1977-02-25	1977-02-25 00:00:00	32020		\N	124172	0	65363002	372328		0
21057	1264	440086	1956-12-31	1956-12-31 00:00:00	1965-01-08	1965-01-08 00:00:00	32020		\N	83337	0	192127007	440086		0
31790	1885	40481087	1976-03-31	1976-03-31 00:00:00	1976-04-07	1976-04-07 00:00:00	32020		\N	125687	0	444814009	40481087		0
21273	1276	40481087	1997-12-25	1997-12-25 00:00:00	1998-01-01	1998-01-01 00:00:00	32020		\N	84170	0	444814009	40481087		0
21494	1289	28060	1975-03-19	1975-03-19 00:00:00	1975-03-26	1975-03-26 00:00:00	32020		\N	85187	0	43878008	28060		0
21597	1294	81151	1989-11-19	1989-11-19 00:00:00	1989-12-03	1989-12-03 00:00:00	32020		\N	85612	0	44465007	81151		0
21824	1310	260139	1954-07-27	1954-07-27 00:00:00	1954-08-10	1954-08-10 00:00:00	32020		\N	86573	0	10509002	260139		0
11449	675	4155034	1959-10-15	1959-10-15 00:00:00	1959-10-29	1959-10-29 00:00:00	32020		\N	44596	0	283371005	4155034		0
22153	1322	40481087	1995-12-06	1995-12-06 00:00:00	1995-12-13	1995-12-13 00:00:00	32020		\N	87721	0	444814009	40481087		0
22258	1328	81151	1980-12-31	1980-12-31 00:00:00	1981-02-04	1981-02-04 00:00:00	32020		\N	88157	0	44465007	81151		0
22440	1339	4112343	2005-01-17	2005-01-17 00:00:00	2005-01-28	2005-01-28 00:00:00	32020		\N	88824	0	195662009	4112343		0
22618	1352	78272	1970-07-29	1970-07-29 00:00:00	1970-08-26	1970-08-26 00:00:00	32020		\N	89605	0	70704007	78272		0
22795	1359	40481087	1991-09-21	1991-09-21 00:00:00	1991-10-12	1991-10-12 00:00:00	32020		\N	90198	0	444814009	40481087		0
12412	733	192671	1980-07-22	1980-07-22 00:00:00	\N	\N	32020		\N	48642	0	K92.2	35208414		0
12599	744	4156265	1983-12-07	1983-12-07 00:00:00	1983-12-28	1983-12-28 00:00:00	32020		\N	49354	0	370247008	4156265		0
23271	1389	28060	1967-06-01	1967-06-01 00:00:00	1967-06-10	1967-06-10 00:00:00	32020		\N	92150	0	43878008	28060		0
23440	1399	4296204	2008-04-21	2008-04-21 00:00:00	2008-05-26	2008-05-26 00:00:00	32020		\N	93040	0	403190006	4296204		0
23610	1409	4283893	1976-06-18	1976-06-18 00:00:00	1976-08-27	1976-08-27 00:00:00	32020		\N	93765	0	36971009	4283893		0
23842	1426	4278672	2005-10-18	2005-10-18 00:00:00	2005-11-17	2005-11-17 00:00:00	32020		\N	94875	0	65966004	4278672		0
13421	789	40481087	1993-01-23	1993-01-23 00:00:00	1993-02-13	1993-02-13 00:00:00	32020		\N	52476	0	444814009	40481087		0
24184	1442	40481087	1958-05-08	1958-05-08 00:00:00	1958-05-15	1958-05-15 00:00:00	32020		\N	96104	0	444814009	40481087		0
24298	1448	28060	1981-05-19	1981-05-19 00:00:00	1981-05-29	1981-05-29 00:00:00	32020		\N	96569	0	43878008	28060		0
13919	822	28060	1973-11-26	1973-11-26 00:00:00	1973-12-03	1973-12-03 00:00:00	32020		\N	54458	0	43878008	28060		0
14073	830	4112343	1971-02-01	1971-02-01 00:00:00	1971-02-11	1971-02-11 00:00:00	32020		\N	54956	0	195662009	4112343		0
24790	1478	4112343	2005-10-18	2005-10-18 00:00:00	2005-10-25	2005-10-25 00:00:00	32020		\N	98655	0	195662009	4112343		0
24948	1490	372328	1941-01-22	1941-01-22 00:00:00	1941-05-15	1941-05-15 00:00:00	32020		\N	99365	0	65363002	372328		0
25076	1496	4296205	1989-06-07	1989-06-07 00:00:00	1989-07-12	1989-07-12 00:00:00	32020		\N	99742	0	403191005	4296205		0
14767	869	4059173	1937-11-25	1937-11-25 00:00:00	1938-02-23	1938-02-23 00:00:00	32020		\N	57723	0	16114001	4059173		0
25472	1516	40481087	2003-06-20	2003-06-20 00:00:00	2003-07-04	2003-07-04 00:00:00	32020		\N	101297	0	444814009	40481087		0
25633	1524	4112343	1988-03-16	1988-03-16 00:00:00	1988-03-29	1988-03-29 00:00:00	32020		\N	101918	0	195662009	4112343		0
25821	1533	80180	2009-09-10	2009-09-10 00:00:00	\N	\N	32020		\N	102695	0	396275006	80180		0
25953	1540	192671	1994-05-06	1994-05-06 00:00:00	\N	\N	32020		\N	103232	0	K92.2	35208414		0
15598	923	28060	1965-09-21	1965-09-21 00:00:00	1965-09-28	1965-09-28 00:00:00	32020		\N	61419	0	43878008	28060		0
26258	1558	28060	1999-08-03	1999-08-03 00:00:00	1999-08-11	1999-08-11 00:00:00	32020		\N	104308	0	43878008	28060		0
15902	940	378001	1965-02-12	1965-02-12 00:00:00	1965-04-13	1965-04-13 00:00:00	32020		\N	62561	0	62106007	378001		0
26575	1574	378001	1974-06-09	1974-06-09 00:00:00	1974-08-08	1974-08-08 00:00:00	32020		\N	105706	0	62106007	378001		0
26769	1585	4152936	1960-11-17	1960-11-17 00:00:00	1960-12-01	1960-12-01 00:00:00	32020		\N	106348	0	283385000	4152936		0
16425	970	260139	2003-08-16	2003-08-16 00:00:00	2003-08-23	2003-08-23 00:00:00	32020		\N	64490	0	10509002	260139		0
16577	978	260139	1985-10-23	1985-10-23 00:00:00	1985-10-30	1985-10-30 00:00:00	32020		\N	65142	0	10509002	260139		0
27279	1608	40481087	1968-02-20	1968-02-20 00:00:00	1968-02-27	1968-02-27 00:00:00	32020		\N	108044	0	444814009	40481087		0
27490	1623	40481087	2015-02-01	2015-02-01 00:00:00	2015-02-08	2015-02-08 00:00:00	32020		\N	109114	0	444814009	40481087		0
27573	1627	4142905	1981-09-26	1981-09-26 00:00:00	1981-10-26	1981-10-26 00:00:00	32020		\N	109350	0	33737001	4142905		0
27818	1641	40481087	1958-10-09	1958-10-09 00:00:00	1958-10-16	1958-10-16 00:00:00	32020		\N	110125	0	444814009	40481087		0
28026	1657	260139	1994-02-20	1994-02-20 00:00:00	1994-02-27	1994-02-27 00:00:00	32020		\N	111245	0	10509002	260139		0
28079	1658	4146173	1942-02-04	1942-02-04 00:00:00	1942-03-06	1942-03-06 00:00:00	32020		\N	111388	0	307731004	4146173		0
28271	1670	81151	1991-04-13	1991-04-13 00:00:00	1991-04-27	1991-04-27 00:00:00	32020		\N	112193	0	44465007	81151		0
28474	1685	40481087	2001-01-24	2001-01-24 00:00:00	2001-02-14	2001-02-14 00:00:00	32020		\N	112884	0	444814009	40481087		0
18078	1086	260139	1973-04-02	1973-04-02 00:00:00	1973-04-16	1973-04-16 00:00:00	32020		\N	71319	0	10509002	260139		0
28753	1703	4112343	1961-08-22	1961-08-22 00:00:00	1961-09-04	1961-09-04 00:00:00	32020		\N	113921	0	195662009	4112343		0
18422	1107	81151	2000-02-20	2000-02-20 00:00:00	2000-03-05	2000-03-05 00:00:00	32020		\N	72857	0	44465007	81151		0
29052	1719	4218389	2006-02-20	2006-02-20 00:00:00	2006-03-13	2006-03-13 00:00:00	32020		\N	114997	0	39848009	4218389		0
29264	1733	40481087	2011-12-30	2011-12-30 00:00:00	2012-01-13	2012-01-13 00:00:00	32020		\N	115815	0	444814009	40481087		0
29385	1740	80180	1989-10-12	1989-10-12 00:00:00	\N	\N	32020		\N	116281	0	396275006	80180		0
29570	1750	4155034	1995-04-23	1995-04-23 00:00:00	1995-05-07	1995-05-07 00:00:00	32020		\N	117004	0	283371005	4155034		0
19254	1154	4237458	2016-08-17	2016-08-17 00:00:00	2016-11-15	2016-11-15 00:00:00	32020		\N	76276	0	58150001	4237458		0
29920	1770	4283893	2008-11-10	2008-11-10 00:00:00	2008-12-15	2008-12-15 00:00:00	32020		\N	118344	0	36971009	4283893		0
30134	1781	4112343	2014-05-12	2014-05-12 00:00:00	2014-05-19	2014-05-19 00:00:00	32020		\N	119186	0	195662009	4112343		0
30254	1786	4237458	1986-07-11	1986-07-11 00:00:00	1986-10-09	1986-10-09 00:00:00	32020		\N	119706	0	58150001	4237458		0
30472	1796	4027663	2009-03-27	2009-03-27 00:00:00	\N	\N	32020		\N	120397	0	13200003	4027663		0
30565	1804	80180	1972-05-22	1972-05-22 00:00:00	\N	\N	32020		\N	120843	0	396275006	80180		0
30765	1819	40481087	2008-08-14	2008-08-14 00:00:00	2008-08-28	2008-08-28 00:00:00	32020		\N	121677	0	444814009	40481087		0
20405	1227	4112343	2018-02-04	2018-02-04 00:00:00	2018-02-16	2018-02-16 00:00:00	32020		\N	80855	0	195662009	4112343		0
31098	1842	40481087	2007-06-01	2007-06-01 00:00:00	2007-06-08	2007-06-08 00:00:00	32020		\N	122945	0	444814009	40481087		0
31238	1848	4112343	1989-11-29	1989-11-29 00:00:00	1989-12-08	1989-12-08 00:00:00	32020		\N	123688	0	195662009	4112343		0
31408	1855	40481087	2006-10-29	2006-10-29 00:00:00	2006-11-19	2006-11-19 00:00:00	32020		\N	124198	0	444814009	40481087		0
21058	1264	28060	1953-08-28	1953-08-28 00:00:00	1953-09-10	1953-09-10 00:00:00	32020		\N	83336	0	43878008	28060		0
31791	1885	257012	1974-01-05	1974-01-05 00:00:00	\N	\N	32020		\N	125686	0	40055000	257012		0
21274	1276	40481087	2014-01-27	2014-01-27 00:00:00	2014-02-17	2014-02-17 00:00:00	32020		\N	84171	0	444814009	40481087		0
21495	1289	40481087	2004-07-11	2004-07-11 00:00:00	2004-08-01	2004-08-01 00:00:00	32020		\N	85166	0	444814009	40481087		0
21598	1294	4112343	1999-03-17	1999-03-17 00:00:00	1999-03-29	1999-03-29 00:00:00	32020		\N	85624	0	195662009	4112343		0
21825	1310	4112343	2013-03-29	2013-03-29 00:00:00	2013-04-06	2013-04-06 00:00:00	32020		\N	86622	0	195662009	4112343		0
21913	1314	317576	2012-01-14	2012-01-14 00:00:00	\N	\N	32020		\N	87014	0	53741008	317576		0
22154	1322	375671	2017-09-04	2017-09-04 00:00:00	2017-10-04	2017-10-04 00:00:00	32020		\N	87740	0	62564004	375671		0
22259	1328	372328	1945-12-23	1945-12-23 00:00:00	1946-04-04	1946-04-04 00:00:00	32020		\N	88225	0	65363002	372328		0
22441	1339	30753	2004-11-25	2004-11-25 00:00:00	\N	\N	32020		\N	88802	0	16761005	30753		0
22620	1352	321042	1984-11-25	1984-11-25 00:00:00	\N	\N	32020		\N	89607	0	410429000	321042		0
22796	1359	378419	2002-03-12	2002-03-12 00:00:00	\N	\N	32020		\N	90189	0	26929004	378419		0
12413	733	40481087	2000-10-29	2000-10-29 00:00:00	2000-11-19	2000-11-19 00:00:00	32020		\N	48645	0	444814009	40481087		0
12600	744	372328	1953-10-19	1953-10-19 00:00:00	1954-03-05	1954-03-05 00:00:00	32020		\N	49364	0	65363002	372328		0
23272	1389	40481087	1982-03-27	1982-03-27 00:00:00	1982-04-17	1982-04-17 00:00:00	32020		\N	92182	0	444814009	40481087		0
23441	1399	40481087	1960-12-05	1960-12-05 00:00:00	1960-12-26	1960-12-26 00:00:00	32020		\N	93042	0	444814009	40481087		0
23611	1409	40481087	1957-10-17	1957-10-17 00:00:00	1957-10-24	1957-10-24 00:00:00	32020		\N	93710	0	444814009	40481087		0
23843	1426	4278672	2007-10-08	2007-10-08 00:00:00	2008-01-06	2008-01-06 00:00:00	32020		\N	94876	0	65966004	4278672		0
13438	793	260139	1993-08-10	1993-08-10 00:00:00	1993-08-17	1993-08-17 00:00:00	32020		\N	52603	0	10509002	260139		0
24185	1442	372328	1948-02-25	1948-02-25 00:00:00	1948-07-13	1948-07-13 00:00:00	32020		\N	96108	0	65363002	372328		0
24299	1448	4310024	2007-05-19	2007-05-19 00:00:00	\N	\N	32020		\N	96613	0	424802006	4310024		0
13920	822	4112343	1978-09-08	1978-09-08 00:00:00	1978-09-18	1978-09-18 00:00:00	32020		\N	54490	0	195662009	4112343		0
14074	830	4218389	1970-08-30	1970-08-30 00:00:00	1970-09-20	1970-09-20 00:00:00	32020		\N	55006	0	39848009	4218389		0
24791	1478	4294548	2018-08-26	2018-08-26 00:00:00	\N	\N	32020		\N	98658	0	75498004	4294548		0
24949	1490	257012	1996-09-03	1996-09-03 00:00:00	1996-10-01	1996-10-01 00:00:00	32020		\N	99307	0	40055000	257012		0
25077	1496	4112343	1971-03-06	1971-03-06 00:00:00	1971-03-17	1971-03-17 00:00:00	32020		\N	99696	0	195662009	4112343		0
14768	869	4112343	1922-06-02	1922-06-02 00:00:00	1922-06-09	1922-06-09 00:00:00	32020		\N	57808	0	195662009	4112343		0
25473	1516	4112343	1944-02-15	1944-02-15 00:00:00	1944-02-22	1944-02-22 00:00:00	32020		\N	101348	0	195662009	4112343		0
25634	1524	4294548	2015-01-23	2015-01-23 00:00:00	2015-05-15	2015-05-15 00:00:00	32020		\N	101923	0	75498004	4294548		0
25822	1533	30753	2009-04-13	2009-04-13 00:00:00	\N	\N	32020		\N	102695	0	16761005	30753		0
25954	1540	257012	1962-08-09	1962-08-09 00:00:00	\N	\N	32020		\N	103213	0	40055000	257012		0
15599	923	4112343	2014-01-05	2014-01-05 00:00:00	2014-01-13	2014-01-13 00:00:00	32020		\N	61477	0	195662009	4112343		0
26259	1558	40481087	1986-01-18	1986-01-18 00:00:00	1986-01-25	1986-01-25 00:00:00	32020		\N	104305	0	444814009	40481087		0
15903	940	40481087	1968-04-20	1968-04-20 00:00:00	1968-04-27	1968-04-27 00:00:00	32020		\N	62540	0	444814009	40481087		0
26576	1574	260139	1966-07-25	1966-07-25 00:00:00	1966-08-08	1966-08-08 00:00:00	32020		\N	105694	0	10509002	260139		0
26770	1585	81151	1990-04-19	1990-04-19 00:00:00	1990-05-03	1990-05-03 00:00:00	32020		\N	106350	0	44465007	81151		0
16426	971	372328	1946-06-18	1946-06-18 00:00:00	1946-10-18	1946-10-18 00:00:00	32020		\N	64627	0	65363002	372328		0
27059	1600	40481087	1965-05-13	1965-05-13 00:00:00	1965-05-20	1965-05-20 00:00:00	32020		\N	107408	0	444814009	40481087		0
27280	1608	4134304	1979-04-22	1979-04-22 00:00:00	1979-06-21	1979-06-21 00:00:00	32020		\N	108015	0	263102004	4134304		0
27491	1623	4294548	1960-10-23	1960-10-23 00:00:00	1960-11-13	1960-11-13 00:00:00	32020		\N	109133	0	75498004	4294548		0
27574	1627	40481087	1985-12-08	1985-12-08 00:00:00	1985-12-15	1985-12-15 00:00:00	32020		\N	109332	0	444814009	40481087		0
27819	1641	40481087	1999-10-11	1999-10-11 00:00:00	1999-10-25	1999-10-25 00:00:00	32020		\N	110193	0	444814009	40481087		0
28027	1657	4112343	2004-11-07	2004-11-07 00:00:00	2004-11-15	2004-11-15 00:00:00	32020		\N	111231	0	195662009	4112343		0
28080	1658	40480160	1995-04-14	1995-04-14 00:00:00	1995-06-13	1995-06-13 00:00:00	32020		\N	111381	0	443165006	40480160		0
28272	1670	260139	1981-11-03	1981-11-03 00:00:00	1981-11-10	1981-11-10 00:00:00	32020		\N	112156	0	10509002	260139		0
28475	1685	80180	2015-10-19	2015-10-19 00:00:00	\N	\N	32020		\N	112882	0	396275006	80180		0
18079	1086	28060	1970-02-17	1970-02-17 00:00:00	1970-03-01	1970-03-01 00:00:00	32020		\N	71311	0	43878008	28060		0
28754	1703	81151	1995-09-02	1995-09-02 00:00:00	1995-09-30	1995-09-30 00:00:00	32020		\N	113930	0	44465007	81151		0
18423	1107	28060	1979-04-07	1979-04-07 00:00:00	1979-04-15	1979-04-15 00:00:00	32020		\N	72914	0	43878008	28060		0
29053	1719	28060	2015-05-27	2015-05-27 00:00:00	2015-06-07	2015-06-07 00:00:00	32020		\N	114964	0	43878008	28060		0
29265	1733	260139	2002-04-08	2002-04-08 00:00:00	2002-04-15	2002-04-15 00:00:00	32020		\N	115836	0	10509002	260139		0
29386	1740	4285898	1988-12-16	1988-12-16 00:00:00	\N	\N	32020		\N	116281	0	68496003	4285898		0
29571	1750	40481087	1998-01-10	1998-01-10 00:00:00	1998-01-24	1998-01-24 00:00:00	32020		\N	116990	0	444814009	40481087		0
19255	1154	40481087	1984-04-26	1984-04-26 00:00:00	1984-05-17	1984-05-17 00:00:00	32020		\N	76280	0	444814009	40481087		0
29921	1770	81151	1992-09-23	1992-09-23 00:00:00	1992-10-21	1992-10-21 00:00:00	32020		\N	118375	0	44465007	81151		0
30135	1781	40481087	1977-11-20	1977-11-20 00:00:00	1977-12-04	1977-12-04 00:00:00	32020		\N	119258	0	444814009	40481087		0
30255	1786	40481087	1969-12-31	1969-12-31 00:00:00	1970-01-07	1970-01-07 00:00:00	32020		\N	119685	0	444814009	40481087		0
30526	1801	40481087	2005-07-01	2005-07-01 00:00:00	2005-07-15	2005-07-15 00:00:00	32020		\N	120735	0	444814009	40481087		0
30566	1804	260139	1981-09-14	1981-09-14 00:00:00	1981-09-21	1981-09-21 00:00:00	32020		\N	120893	0	10509002	260139		0
30766	1819	4283893	1977-07-31	1977-07-31 00:00:00	1977-10-16	1977-10-16 00:00:00	32020		\N	121687	0	36971009	4283893		0
20406	1227	317576	2013-03-20	2013-03-20 00:00:00	\N	\N	32020		\N	80769	0	53741008	317576		0
31099	1842	4218389	1986-05-02	1986-05-02 00:00:00	1986-05-30	1986-05-30 00:00:00	32020		\N	122987	0	39848009	4218389		0
31239	1848	40481087	2011-04-03	2011-04-03 00:00:00	2011-04-24	2011-04-24 00:00:00	32020		\N	123603	0	444814009	40481087		0
31409	1855	4027663	2004-03-13	2004-03-13 00:00:00	\N	\N	32020		\N	124178	0	13200003	4027663		0
21059	1264	40481087	1982-05-21	1982-05-21 00:00:00	1982-06-04	1982-06-04 00:00:00	32020		\N	83324	0	444814009	40481087		0
31792	1885	40481087	2013-03-30	2013-03-30 00:00:00	2013-04-13	2013-04-13 00:00:00	32020		\N	125721	0	444814009	40481087		0
21275	1276	4156265	2015-09-14	2015-09-14 00:00:00	2015-09-28	2015-09-28 00:00:00	32020		\N	84136	0	370247008	4156265		0
21496	1289	257012	1966-07-30	1966-07-30 00:00:00	\N	\N	32020		\N	85207	0	40055000	257012		0
21599	1294	28060	2014-07-12	2014-07-12 00:00:00	2014-07-24	2014-07-24 00:00:00	32020		\N	85615	0	43878008	28060		0
21826	1310	4112343	2010-04-01	2010-04-01 00:00:00	2010-04-11	2010-04-11 00:00:00	32020		\N	86661	0	195662009	4112343		0
21914	1314	40481087	1997-03-20	1997-03-20 00:00:00	1997-04-10	1997-04-10 00:00:00	32020		\N	87040	0	444814009	40481087		0
22155	1322	381316	2019-01-30	2019-01-30 00:00:00	\N	\N	32020		\N	87724	0	230690007	381316		0
22260	1328	261325	1980-12-04	1980-12-04 00:00:00	\N	\N	32020		\N	88227	0	87433001	261325		0
22442	1339	4310024	2003-07-04	2003-07-04 00:00:00	\N	\N	32020		\N	88802	0	424802006	4310024		0
22621	1352	4112343	2016-01-12	2016-01-12 00:00:00	2016-01-24	2016-01-24 00:00:00	32020		\N	89540	0	195662009	4112343		0
22797	1359	40481087	1965-10-18	1965-10-18 00:00:00	1965-11-01	1965-11-01 00:00:00	32020		\N	90202	0	444814009	40481087		0
12414	733	28060	1944-12-31	1944-12-31 00:00:00	1945-01-08	1945-01-08 00:00:00	32020		\N	48652	0	43878008	28060		0
12601	744	4156265	2017-08-29	2017-08-29 00:00:00	2017-09-19	2017-09-19 00:00:00	32020		\N	49358	0	370247008	4156265		0
23273	1389	40481087	1965-04-18	1965-04-18 00:00:00	1965-04-25	1965-04-25 00:00:00	32020		\N	92217	0	444814009	40481087		0
23442	1399	40481087	2018-12-13	2018-12-13 00:00:00	2018-12-20	2018-12-20 00:00:00	32020		\N	93071	0	444814009	40481087		0
23612	1409	4112343	1966-04-17	1966-04-17 00:00:00	1966-04-24	1966-04-24 00:00:00	32020		\N	93713	0	195662009	4112343		0
23844	1426	40481087	1963-11-14	1963-11-14 00:00:00	1963-11-21	1963-11-21 00:00:00	32020		\N	94816	0	444814009	40481087		0
13439	793	40479422	2012-02-13	2012-02-13 00:00:00	2012-04-20	2012-04-20 00:00:00	32020		\N	52612	0	444448004	40479422		0
24186	1442	40481087	2011-01-18	2011-01-18 00:00:00	2011-02-01	2011-02-01 00:00:00	32020		\N	96107	0	444814009	40481087		0
24300	1448	4294548	2012-02-15	2012-02-15 00:00:00	2012-04-18	2012-04-18 00:00:00	32020		\N	96589	0	75498004	4294548		0
13921	822	81151	1988-02-10	1988-02-10 00:00:00	1988-03-09	1988-03-09 00:00:00	32020		\N	54497	0	44465007	81151		0
14076	830	4112343	1973-10-29	1973-10-29 00:00:00	1973-11-09	1973-11-09 00:00:00	32020		\N	55001	0	195662009	4112343		0
24792	1478	4084167	1981-04-12	1981-04-12 00:00:00	1981-04-12	1981-04-12 00:00:00	32020		\N	98641	0	241929008	4084167		0
24950	1490	4027663	1962-12-03	1962-12-03 00:00:00	\N	\N	32020		\N	99341	0	13200003	4027663		0
25078	1496	28060	1980-06-12	1980-06-12 00:00:00	1980-06-24	1980-06-24 00:00:00	32020		\N	99733	0	43878008	28060		0
14769	869	40481087	1918-03-27	1918-03-27 00:00:00	1918-04-03	1918-04-03 00:00:00	32020		\N	57790	0	444814009	40481087		0
25474	1516	40481087	1975-03-18	1975-03-18 00:00:00	1975-03-25	1975-03-25 00:00:00	32020		\N	101275	0	444814009	40481087		0
25635	1524	257012	2015-02-13	2015-02-13 00:00:00	\N	\N	32020		\N	101935	0	40055000	257012		0
25823	1533	4296205	2009-03-09	2009-03-09 00:00:00	2009-04-13	2009-04-13 00:00:00	32020		\N	102691	0	403191005	4296205		0
25955	1540	260139	1984-11-27	1984-11-27 00:00:00	1984-12-04	1984-12-04 00:00:00	32020		\N	103158	0	10509002	260139		0
15600	923	260139	1987-02-02	1987-02-02 00:00:00	1987-02-16	1987-02-16 00:00:00	32020		\N	61489	0	10509002	260139		0
26260	1558	40481087	1988-07-20	1988-07-20 00:00:00	1988-08-03	1988-08-03 00:00:00	32020		\N	104384	0	444814009	40481087		0
15904	940	40481087	2000-05-18	2000-05-18 00:00:00	2000-06-01	2000-06-01 00:00:00	32020		\N	62502	0	444814009	40481087		0
26577	1574	4112343	2007-04-24	2007-04-24 00:00:00	2007-05-06	2007-05-06 00:00:00	32020		\N	105718	0	195662009	4112343		0
26771	1585	40481087	1941-12-10	1941-12-10 00:00:00	1941-12-24	1941-12-24 00:00:00	32020		\N	106352	0	444814009	40481087		0
16427	971	40481087	1970-11-28	1970-11-28 00:00:00	1970-12-12	1970-12-12 00:00:00	32020		\N	64591	0	444814009	40481087		0
27060	1600	40481087	1972-02-18	1972-02-18 00:00:00	1972-02-25	1972-02-25 00:00:00	32020		\N	107433	0	444814009	40481087		0
27281	1608	4294548	1992-04-08	1992-04-08 00:00:00	1992-04-22	1992-04-22 00:00:00	32020		\N	108003	0	75498004	4294548		0
27492	1623	4112343	2002-05-12	2002-05-12 00:00:00	2002-05-22	2002-05-22 00:00:00	32020		\N	109086	0	195662009	4112343		0
27575	1627	372328	1972-03-12	1972-03-12 00:00:00	1975-02-22	1975-02-22 00:00:00	32020		\N	109372	0	65363002	372328		0
27820	1641	4112343	1970-11-23	1970-11-23 00:00:00	1970-12-06	1970-12-06 00:00:00	32020		\N	110127	0	195662009	4112343		0
28028	1657	321042	1998-04-22	1998-04-22 00:00:00	\N	\N	32020		\N	111186	0	410429000	321042		0
28081	1658	4142905	1995-04-14	1995-04-14 00:00:00	1995-06-13	1995-06-13 00:00:00	32020		\N	111381	0	33737001	4142905		0
28273	1670	260139	2015-10-01	2015-10-01 00:00:00	2015-10-08	2015-10-08 00:00:00	32020		\N	112152	0	10509002	260139		0
28476	1685	4266809	2015-10-19	2015-10-19 00:00:00	\N	\N	32020		\N	112882	0	397881000	4266809		0
18080	1086	40481087	2014-07-23	2014-07-23 00:00:00	2014-08-13	2014-08-13 00:00:00	32020		\N	71318	0	444814009	40481087		0
28755	1703	40481087	1971-12-24	1971-12-24 00:00:00	1972-01-07	1972-01-07 00:00:00	32020		\N	113910	0	444814009	40481087		0
18424	1107	40481087	1992-05-23	1992-05-23 00:00:00	1992-06-06	1992-06-06 00:00:00	32020		\N	72922	0	444814009	40481087		0
29054	1719	4112343	2010-01-28	2010-01-28 00:00:00	2010-02-07	2010-02-07 00:00:00	32020		\N	114896	0	195662009	4112343		0
29266	1733	40479422	1989-08-03	1989-08-03 00:00:00	1989-10-09	1989-10-09 00:00:00	32020		\N	115804	0	444448004	40479422		0
29387	1740	260139	1988-08-09	1988-08-09 00:00:00	1988-08-16	1988-08-16 00:00:00	32020		\N	116264	0	10509002	260139		0
29572	1750	4112343	1979-07-20	1979-07-20 00:00:00	1979-08-01	1979-08-01 00:00:00	32020		\N	117031	0	195662009	4112343		0
19256	1154	81151	2005-05-05	2005-05-05 00:00:00	2005-05-26	2005-05-26 00:00:00	32020		\N	76274	0	44465007	81151		0
29922	1770	80180	2014-12-19	2014-12-19 00:00:00	\N	\N	32020		\N	118385	0	396275006	80180		0
30136	1781	4294548	1952-03-24	1952-03-24 00:00:00	1952-03-31	1952-03-31 00:00:00	32020		\N	119197	0	75498004	4294548		0
30256	1786	40481087	1959-11-05	1959-11-05 00:00:00	1959-11-26	1959-11-26 00:00:00	32020		\N	119749	0	444814009	40481087		0
30527	1801	4218389	2003-09-28	2003-09-28 00:00:00	2003-10-19	2003-10-19 00:00:00	32020		\N	120754	0	39848009	4218389		0
30567	1804	28060	1945-02-08	1945-02-08 00:00:00	1945-02-19	1945-02-19 00:00:00	32020		\N	120827	0	43878008	28060		0
30767	1820	260139	2006-12-02	2006-12-02 00:00:00	2006-12-09	2006-12-09 00:00:00	32020		\N	121746	0	10509002	260139		0
20407	1227	440086	1946-08-23	1946-08-23 00:00:00	1947-09-19	1947-09-19 00:00:00	32020		\N	80853	0	192127007	440086		0
31100	1842	40481087	1991-04-29	1991-04-29 00:00:00	1991-05-13	1991-05-13 00:00:00	32020		\N	122957	0	444814009	40481087		0
31240	1848	4112343	1973-10-30	1973-10-30 00:00:00	1973-11-11	1973-11-11 00:00:00	32020		\N	123683	0	195662009	4112343		0
31410	1855	40481087	2006-02-11	2006-02-11 00:00:00	2006-02-25	2006-02-25 00:00:00	32020		\N	124217	0	444814009	40481087		0
21060	1264	40481087	1970-05-27	1970-05-27 00:00:00	1970-06-17	1970-06-17 00:00:00	32020		\N	83312	0	444814009	40481087		0
31793	1885	40481087	2009-01-07	2009-01-07 00:00:00	2009-01-21	2009-01-21 00:00:00	32020		\N	125696	0	444814009	40481087		0
21306	1280	40481087	1958-01-04	1958-01-04 00:00:00	1958-01-25	1958-01-25 00:00:00	32020		\N	84595	0	444814009	40481087		0
21497	1289	4156265	2002-12-25	2002-12-25 00:00:00	2003-01-15	2003-01-15 00:00:00	32020		\N	85243	0	370247008	4156265		0
21600	1294	260139	1997-04-11	1997-04-11 00:00:00	1997-04-18	1997-04-18 00:00:00	32020		\N	85651	0	10509002	260139		0
21827	1310	380378	2013-02-11	2013-02-11 00:00:00	\N	\N	32020		\N	86679	0	84757009	380378		0
21915	1314	40481087	2007-04-22	2007-04-22 00:00:00	2007-05-13	2007-05-13 00:00:00	32020		\N	87056	0	444814009	40481087		0
22156	1322	4112343	1942-07-30	1942-07-30 00:00:00	1942-08-12	1942-08-12 00:00:00	32020		\N	87786	0	195662009	4112343		0
22261	1328	4112343	1950-05-03	1950-05-03 00:00:00	1950-05-16	1950-05-16 00:00:00	32020		\N	88191	0	195662009	4112343		0
22443	1339	81151	1977-08-19	1977-08-19 00:00:00	1977-09-09	1977-09-09 00:00:00	32020		\N	88820	0	44465007	81151		0
22622	1352	28060	1947-04-05	1947-04-05 00:00:00	1947-04-14	1947-04-14 00:00:00	32020		\N	89533	0	43878008	28060		0
22798	1359	260139	1994-05-06	1994-05-06 00:00:00	1994-05-20	1994-05-20 00:00:00	32020		\N	90183	0	10509002	260139		0
12415	733	40481087	1976-05-22	1976-05-22 00:00:00	1976-06-05	1976-06-05 00:00:00	32020		\N	48644	0	444814009	40481087		0
12602	744	4152936	1996-07-22	1996-07-22 00:00:00	1996-08-05	1996-08-05 00:00:00	32020		\N	49355	0	283385000	4152936		0
23274	1389	4059173	1962-04-27	1962-04-27 00:00:00	1962-06-26	1962-06-26 00:00:00	32020		\N	92203	0	16114001	4059173		0
23443	1399	260139	1995-01-12	1995-01-12 00:00:00	1995-01-19	1995-01-19 00:00:00	32020		\N	93126	0	10509002	260139		0
23613	1409	4001336	1921-02-07	1921-02-07 00:00:00	1921-03-09	1921-03-09 00:00:00	32020		\N	93761	0	110030002	4001336		0
23845	1426	260139	1983-11-23	1983-11-23 00:00:00	1983-11-30	1983-11-30 00:00:00	32020		\N	94830	0	10509002	260139		0
13440	793	4112343	1980-04-15	1980-04-15 00:00:00	1980-04-23	1980-04-23 00:00:00	32020		\N	52615	0	195662009	4112343		0
24187	1442	4112343	1965-11-20	1965-11-20 00:00:00	1965-12-01	1965-12-01 00:00:00	32020		\N	96134	0	195662009	4112343		0
24301	1448	40481087	1984-10-01	1984-10-01 00:00:00	1984-10-22	1984-10-22 00:00:00	32020		\N	96601	0	444814009	40481087		0
13922	822	372328	1975-09-16	1975-09-16 00:00:00	1976-05-07	1976-05-07 00:00:00	32020		\N	54463	0	65363002	372328		0
14077	830	372328	1961-04-14	1961-04-14 00:00:00	1961-04-28	1961-04-28 00:00:00	32020		\N	54970	0	65363002	372328		0
24793	1478	4112343	1994-01-08	1994-01-08 00:00:00	1994-01-16	1994-01-16 00:00:00	32020		\N	98618	0	195662009	4112343		0
24951	1490	260139	1992-10-18	1992-10-18 00:00:00	1992-11-01	1992-11-01 00:00:00	32020		\N	99363	0	10509002	260139		0
25079	1496	28060	1952-08-04	1952-08-04 00:00:00	1952-08-17	1952-08-17 00:00:00	32020		\N	99721	0	43878008	28060		0
14770	869	4109685	1947-02-06	1947-02-06 00:00:00	1947-02-20	1947-02-20 00:00:00	32020		\N	57724	0	284551006	4109685		0
25475	1516	260139	1979-05-07	1979-05-07 00:00:00	1979-05-14	1979-05-14 00:00:00	32020		\N	101261	0	10509002	260139		0
25636	1524	4112343	1969-01-04	1969-01-04 00:00:00	1969-01-13	1969-01-13 00:00:00	32020		\N	101915	0	195662009	4112343		0
25824	1533	40481087	2002-05-11	2002-05-11 00:00:00	2002-06-01	2002-06-01 00:00:00	32020		\N	102648	0	444814009	40481087		0
25956	1540	81893	1992-12-16	1992-12-16 00:00:00	\N	\N	32020		\N	103200	0	64766004	81893		0
15601	923	260139	1976-10-30	1976-10-30 00:00:00	1976-11-06	1976-11-06 00:00:00	32020		\N	61487	0	10509002	260139		0
26261	1558	4294548	1987-01-27	1987-01-27 00:00:00	1987-04-21	1987-04-21 00:00:00	32020		\N	104383	0	75498004	4294548		0
15905	940	40481087	1994-12-03	1994-12-03 00:00:00	1994-12-24	1994-12-24 00:00:00	32020		\N	62568	0	444814009	40481087		0
26578	1574	28060	1970-03-25	1970-03-25 00:00:00	1970-04-07	1970-04-07 00:00:00	32020		\N	105660	0	43878008	28060		0
26772	1585	4294548	2012-06-09	2012-06-09 00:00:00	2012-07-21	2012-07-21 00:00:00	32020		\N	106306	0	75498004	4294548		0
16428	971	81151	1965-08-20	1965-08-20 00:00:00	1965-09-17	1965-09-17 00:00:00	32020		\N	64662	0	44465007	81151		0
27061	1600	40481087	2015-03-11	2015-03-11 00:00:00	2015-04-01	2015-04-01 00:00:00	32020		\N	107415	0	444814009	40481087		0
27282	1609	260139	1986-11-14	1986-11-14 00:00:00	1986-11-28	1986-11-28 00:00:00	32020		\N	108149	0	10509002	260139		0
27493	1623	40481087	1993-03-22	1993-03-22 00:00:00	1993-03-29	1993-03-29 00:00:00	32020		\N	109084	0	444814009	40481087		0
27576	1627	40481087	2009-12-08	2009-12-08 00:00:00	2009-12-29	2009-12-29 00:00:00	32020		\N	109342	0	444814009	40481087		0
27821	1641	81151	1956-09-11	1956-09-11 00:00:00	1956-10-16	1956-10-16 00:00:00	32020		\N	110172	0	44465007	81151		0
28030	1657	372328	1946-06-24	1946-06-24 00:00:00	1946-12-04	1946-12-04 00:00:00	32020		\N	111249	0	65363002	372328		0
28082	1658	4112343	1913-01-24	1913-01-24 00:00:00	1913-02-04	1913-02-04 00:00:00	32020		\N	111411	0	195662009	4112343		0
28274	1670	4283893	1978-09-16	1978-09-16 00:00:00	1978-12-23	1978-12-23 00:00:00	32020		\N	112195	0	36971009	4283893		0
28477	1685	78272	2014-12-13	2014-12-13 00:00:00	2015-01-10	2015-01-10 00:00:00	32020		\N	112882	0	70704007	78272		0
18081	1086	81151	2013-03-20	2013-03-20 00:00:00	2013-04-03	2013-04-03 00:00:00	32020		\N	71351	0	44465007	81151		0
28756	1703	260139	1954-05-26	1954-05-26 00:00:00	1954-06-04	1954-06-04 00:00:00	32020		\N	113862	0	10509002	260139		0
18425	1108	40481087	2013-12-24	2013-12-24 00:00:00	2014-01-14	2014-01-14 00:00:00	32020		\N	72987	0	444814009	40481087		0
29055	1719	4294548	2005-06-30	2005-06-30 00:00:00	2005-07-14	2005-07-14 00:00:00	32020		\N	114895	0	75498004	4294548		0
29267	1733	40481087	2003-05-16	2003-05-16 00:00:00	2003-06-06	2003-06-06 00:00:00	32020		\N	115842	0	444814009	40481087		0
29388	1740	4134304	2010-08-24	2010-08-24 00:00:00	2010-09-23	2010-09-23 00:00:00	32020		\N	116292	0	263102004	4134304		0
29573	1750	78272	1996-04-01	1996-04-01 00:00:00	1996-04-15	1996-04-15 00:00:00	32020		\N	117005	0	70704007	78272		0
29715	1759	260139	2006-01-29	2006-01-29 00:00:00	2006-02-05	2006-02-05 00:00:00	32020		\N	117576	0	10509002	260139		0
29923	1770	40481087	2000-05-30	2000-05-30 00:00:00	2000-06-13	2000-06-13 00:00:00	32020		\N	118345	0	444814009	40481087		0
30137	1781	40481087	2001-08-08	2001-08-08 00:00:00	2001-08-22	2001-08-22 00:00:00	32020		\N	119252	0	444814009	40481087		0
30257	1786	40481087	2016-02-11	2016-02-11 00:00:00	2016-02-18	2016-02-18 00:00:00	32020		\N	119735	0	444814009	40481087		0
30528	1801	260139	2009-11-24	2009-11-24 00:00:00	2009-12-01	2009-12-01 00:00:00	32020		\N	120736	0	10509002	260139		0
30568	1804	40481087	1946-08-23	1946-08-23 00:00:00	1946-08-30	1946-08-30 00:00:00	32020		\N	120860	0	444814009	40481087		0
30768	1820	260139	1984-01-09	1984-01-09 00:00:00	1984-01-23	1984-01-23 00:00:00	32020		\N	121742	0	10509002	260139		0
20408	1227	28060	1984-12-27	1984-12-27 00:00:00	1985-01-04	1985-01-04 00:00:00	32020		\N	80755	0	43878008	28060		0
31101	1842	40481087	2001-02-13	2001-02-13 00:00:00	2001-02-27	2001-02-27 00:00:00	32020		\N	122952	0	444814009	40481087		0
31241	1848	260139	1970-12-15	1970-12-15 00:00:00	1970-12-29	1970-12-29 00:00:00	32020		\N	123595	0	10509002	260139		0
31411	1855	81151	1978-10-31	1978-10-31 00:00:00	1978-11-14	1978-11-14 00:00:00	32020		\N	124135	0	44465007	81151		0
21061	1264	260139	1974-04-13	1974-04-13 00:00:00	1974-04-27	1974-04-27 00:00:00	32020		\N	83313	0	10509002	260139		0
31794	1885	372328	1977-08-28	1977-08-28 00:00:00	1978-02-07	1978-02-07 00:00:00	32020		\N	125701	0	65363002	372328		0
21307	1280	40481087	1992-02-04	1992-02-04 00:00:00	1992-02-25	1992-02-25 00:00:00	32020		\N	84533	0	444814009	40481087		0
21498	1289	81151	1989-04-16	1989-04-16 00:00:00	1989-05-07	1989-05-07 00:00:00	32020		\N	85241	0	44465007	81151		0
21608	1297	260139	2000-12-26	2000-12-26 00:00:00	2001-01-02	2001-01-02 00:00:00	32020		\N	85732	0	10509002	260139		0
21828	1310	4029498	2013-02-11	2013-02-11 00:00:00	\N	\N	32020		\N	86679	0	128613002	4029498		0
21916	1314	4112343	1955-12-28	1955-12-28 00:00:00	1956-01-07	1956-01-07 00:00:00	32020		\N	87007	0	195662009	4112343		0
22157	1322	4294548	1965-02-02	1965-02-02 00:00:00	1965-03-16	1965-03-16 00:00:00	32020		\N	87742	0	75498004	4294548		0
22262	1328	372328	1946-09-01	1946-09-01 00:00:00	1946-10-03	1946-10-03 00:00:00	32020		\N	88145	0	65363002	372328		0
22444	1339	4112343	1968-05-04	1968-05-04 00:00:00	1968-05-17	1968-05-17 00:00:00	32020		\N	88800	0	195662009	4112343		0
22623	1352	372328	1993-02-28	1993-02-28 00:00:00	1993-08-15	1993-08-15 00:00:00	32020		\N	89598	0	65363002	372328		0
22799	1359	260139	1962-01-22	1962-01-22 00:00:00	1962-01-29	1962-01-29 00:00:00	32020		\N	90168	0	10509002	260139		0
12416	733	4237458	1959-08-29	1959-08-29 00:00:00	1959-11-27	1959-11-27 00:00:00	32020		\N	48597	0	58150001	4237458		0
12603	744	4112343	2019-03-08	2019-03-08 00:00:00	2019-03-16	2019-03-16 00:00:00	32020		\N	49332	0	195662009	4112343		0
23275	1389	4112343	1959-07-16	1959-07-16 00:00:00	1959-07-26	1959-07-26 00:00:00	32020		\N	92179	0	195662009	4112343		0
23444	1399	80180	1992-10-09	1992-10-09 00:00:00	\N	\N	32020		\N	93062	0	396275006	80180		0
23614	1409	4132546	1921-02-07	1921-02-07 00:00:00	\N	\N	32020		\N	93761	0	275272006	4166590		0
23846	1426	378001	1974-10-10	1974-10-10 00:00:00	1974-12-09	1974-12-09 00:00:00	32020		\N	94873	0	62106007	378001		0
13441	793	260139	1988-01-30	1988-01-30 00:00:00	1988-02-13	1988-02-13 00:00:00	32020		\N	52624	0	10509002	260139		0
24188	1442	4112343	1996-05-18	1996-05-18 00:00:00	1996-05-28	1996-05-28 00:00:00	32020		\N	96137	0	195662009	4112343		0
24302	1448	372328	1976-01-12	1976-01-12 00:00:00	1976-03-03	1976-03-03 00:00:00	32020		\N	96571	0	65363002	372328		0
13923	822	40481087	2002-07-19	2002-07-19 00:00:00	2002-07-26	2002-07-26 00:00:00	32020		\N	54503	0	444814009	40481087		0
14078	830	440448	1973-11-24	1973-11-24 00:00:00	\N	\N	32020		\N	55007	0	74400008	440448		0
24794	1478	28060	2015-07-21	2015-07-21 00:00:00	2015-07-29	2015-07-29 00:00:00	32020		\N	98633	0	43878008	28060		0
24952	1490	372328	1942-09-07	1942-09-07 00:00:00	1942-11-19	1942-11-19 00:00:00	32020		\N	99353	0	65363002	372328		0
25080	1496	4112343	1976-08-21	1976-08-21 00:00:00	1976-08-30	1976-08-30 00:00:00	32020		\N	99697	0	195662009	4112343		0
14771	869	372328	1914-09-16	1914-09-16 00:00:00	1914-11-20	1914-11-20 00:00:00	32020		\N	57799	0	65363002	372328		0
25476	1516	255848	2015-06-10	2015-06-10 00:00:00	\N	\N	32020		\N	101271	0	233604007	255848		0
25637	1524	81893	2002-05-28	2002-05-28 00:00:00	\N	\N	32020		\N	101949	0	64766004	81893		0
25825	1533	40481087	2003-07-01	2003-07-01 00:00:00	2003-07-15	2003-07-15 00:00:00	32020		\N	102660	0	444814009	40481087		0
25957	1540	260139	1971-11-11	1971-11-11 00:00:00	1971-11-18	1971-11-18 00:00:00	32020		\N	103156	0	10509002	260139		0
15602	923	40481087	1960-01-12	1960-01-12 00:00:00	1960-01-19	1960-01-19 00:00:00	32020		\N	61416	0	444814009	40481087		0
26262	1558	40481087	1989-06-05	1989-06-05 00:00:00	1989-06-19	1989-06-19 00:00:00	32020		\N	104307	0	444814009	40481087		0
15906	940	40481087	1995-01-31	1995-01-31 00:00:00	1995-02-07	1995-02-07 00:00:00	32020		\N	62541	0	444814009	40481087		0
26579	1574	4112343	1967-03-02	1967-03-02 00:00:00	1967-03-09	1967-03-09 00:00:00	32020		\N	105710	0	195662009	4112343		0
26773	1586	317576	1966-05-22	1966-05-22 00:00:00	\N	\N	32020		\N	\N	0	53741008	317576		0
16429	971	40481087	1993-01-20	1993-01-20 00:00:00	1993-01-27	1993-01-27 00:00:00	32020		\N	64611	0	444814009	40481087		0
27062	1600	260139	2008-08-06	2008-08-06 00:00:00	2008-08-13	2008-08-13 00:00:00	32020		\N	107371	0	10509002	260139		0
27283	1609	81151	1980-11-21	1980-11-21 00:00:00	1980-12-19	1980-12-19 00:00:00	32020		\N	108162	0	44465007	81151		0
27494	1623	40481087	1965-08-21	1965-08-21 00:00:00	1965-09-11	1965-09-11 00:00:00	32020		\N	109079	0	444814009	40481087		0
27577	1627	40481087	2002-10-25	2002-10-25 00:00:00	2002-11-08	2002-11-08 00:00:00	32020		\N	109369	0	444814009	40481087		0
27822	1641	4149245	1962-06-17	1962-06-17 00:00:00	1962-07-24	1962-07-24 00:00:00	32020		\N	110173	0	30832001	4149245		0
28031	1657	80180	1987-02-01	1987-02-01 00:00:00	\N	\N	32020		\N	111167	0	396275006	80180		0
28083	1658	40481087	1971-11-04	1971-11-04 00:00:00	1971-11-25	1971-11-25 00:00:00	32020		\N	111316	0	444814009	40481087		0
28275	1670	257012	1978-11-25	1978-11-25 00:00:00	\N	\N	32020		\N	112196	0	40055000	257012		0
28478	1685	40481087	1987-02-09	1987-02-09 00:00:00	1987-03-02	1987-03-02 00:00:00	32020		\N	112871	0	444814009	40481087		0
18082	1086	4146173	1974-08-23	1974-08-23 00:00:00	1974-09-22	1974-09-22 00:00:00	32020		\N	71320	0	307731004	4146173		0
28757	1703	4113008	1962-10-20	1962-10-20 00:00:00	1962-11-10	1962-11-10 00:00:00	32020		\N	113927	0	284549007	4113008		0
18426	1108	80180	2013-02-04	2013-02-04 00:00:00	\N	\N	32020		\N	72941	0	396275006	80180		0
29056	1719	4112343	2015-04-15	2015-04-15 00:00:00	2015-04-25	2015-04-25 00:00:00	32020		\N	114963	0	195662009	4112343		0
29268	1733	28060	2005-03-16	2005-03-16 00:00:00	2005-03-26	2005-03-26 00:00:00	32020		\N	115837	0	43878008	28060		0
29389	1740	4294548	1994-01-20	1994-01-20 00:00:00	1994-06-09	1994-06-09 00:00:00	32020		\N	116265	0	75498004	4294548		0
29574	1750	4155034	2010-10-29	2010-10-29 00:00:00	2010-11-19	2010-11-19 00:00:00	32020		\N	117016	0	283371005	4155034		0
29716	1759	372328	1987-11-30	1987-11-30 00:00:00	1988-06-06	1988-06-06 00:00:00	32020		\N	117626	0	65363002	372328		0
29924	1770	4112343	2017-03-21	2017-03-21 00:00:00	2017-03-28	2017-03-28 00:00:00	32020		\N	118347	0	195662009	4112343		0
30138	1781	4152936	1957-01-17	1957-01-17 00:00:00	1957-01-31	1957-01-31 00:00:00	32020		\N	119225	0	283385000	4152936		0
30258	1786	4112343	1967-03-22	1967-03-22 00:00:00	1967-03-30	1967-03-30 00:00:00	32020		\N	119684	0	195662009	4112343		0
30529	1801	4029498	1966-07-18	1966-07-18 00:00:00	\N	\N	32020		\N	120750	0	128613002	4029498		0
30569	1804	4109685	1955-10-29	1955-10-29 00:00:00	1955-11-12	1955-11-12 00:00:00	32020		\N	120875	0	284551006	4109685		0
30769	1820	40481087	1995-05-17	1995-05-17 00:00:00	1995-05-24	1995-05-24 00:00:00	32020		\N	121704	0	444814009	40481087		0
20409	1227	4283893	1983-08-17	1983-08-17 00:00:00	1983-11-16	1983-11-16 00:00:00	32020		\N	80752	0	36971009	4283893		0
31102	1842	4112343	1990-03-25	1990-03-25 00:00:00	1990-04-01	1990-04-01 00:00:00	32020		\N	122967	0	195662009	4112343		0
31242	1848	40481087	2005-12-03	2005-12-03 00:00:00	2005-12-24	2005-12-24 00:00:00	32020		\N	123690	0	444814009	40481087		0
31412	1855	440086	1989-03-17	1989-03-17 00:00:00	1989-09-22	1989-09-22 00:00:00	32020		\N	124166	0	192127007	440086		0
21062	1264	40481087	1961-02-21	1961-02-21 00:00:00	1961-03-07	1961-03-07 00:00:00	32020		\N	83327	0	444814009	40481087		0
31795	1885	40481087	2011-08-15	2011-08-15 00:00:00	2011-08-29	2011-08-29 00:00:00	32020		\N	125690	0	444814009	40481087		0
21308	1280	4146173	1976-02-26	1976-02-26 00:00:00	1976-04-03	1976-04-03 00:00:00	32020		\N	84558	0	307731004	4146173		0
21499	1289	372328	1965-04-17	1965-04-17 00:00:00	1965-08-17	1965-08-17 00:00:00	32020		\N	85212	0	65363002	372328		0
21609	1297	40481087	2008-03-25	2008-03-25 00:00:00	2008-04-01	2008-04-01 00:00:00	32020		\N	85712	0	444814009	40481087		0
21830	1310	80180	1980-07-09	1980-07-09 00:00:00	\N	\N	32020		\N	86671	0	396275006	80180		0
21917	1314	260139	1970-12-14	1970-12-14 00:00:00	1970-12-21	1970-12-21 00:00:00	32020		\N	87037	0	10509002	260139		0
22158	1322	4112343	1935-09-14	1935-09-14 00:00:00	1935-09-25	1935-09-25 00:00:00	32020		\N	87735	0	195662009	4112343		0
22263	1328	4112343	1956-04-27	1956-04-27 00:00:00	1956-05-09	1956-05-09 00:00:00	32020		\N	88161	0	195662009	4112343		0
22445	1339	260139	2001-05-12	2001-05-12 00:00:00	2001-05-19	2001-05-19 00:00:00	32020		\N	88791	0	10509002	260139		0
22624	1352	196456	1976-07-29	1976-07-29 00:00:00	1976-07-29	1976-07-29 00:00:00	32020		\N	89606	0	235919008	196456		0
22800	1359	4294548	1946-11-09	1946-11-09 00:00:00	1946-12-28	1946-12-28 00:00:00	32020		\N	90208	0	75498004	4294548		0
12417	733	260139	1999-05-04	1999-05-04 00:00:00	1999-05-11	1999-05-11 00:00:00	32020		\N	48617	0	10509002	260139		0
12604	744	40481087	2015-04-08	2015-04-08 00:00:00	2015-04-15	2015-04-15 00:00:00	32020		\N	49331	0	444814009	40481087		0
23276	1389	4296205	2007-08-29	2007-08-29 00:00:00	2007-09-19	2007-09-19 00:00:00	32020		\N	92206	0	403191005	4296205		0
23445	1399	40481087	1990-01-16	1990-01-16 00:00:00	1990-02-06	1990-02-06 00:00:00	32020		\N	93046	0	444814009	40481087		0
23615	1409	4112343	1939-06-29	1939-06-29 00:00:00	1939-07-09	1939-07-09 00:00:00	32020		\N	93819	0	195662009	4112343		0
23847	1426	40481087	1977-05-13	1977-05-13 00:00:00	1977-06-03	1977-06-03 00:00:00	32020		\N	94818	0	444814009	40481087		0
13442	793	260139	1982-03-23	1982-03-23 00:00:00	1982-03-30	1982-03-30 00:00:00	32020		\N	52602	0	10509002	260139		0
24189	1442	4059173	2012-09-07	2012-09-07 00:00:00	2012-12-06	2012-12-06 00:00:00	32020		\N	96188	0	16114001	4059173		0
24303	1448	40481087	2019-04-17	2019-04-17 00:00:00	2019-04-24	2019-04-24 00:00:00	32020		\N	96570	0	444814009	40481087		0
13924	822	4112343	1976-08-04	1976-08-04 00:00:00	1976-08-15	1976-08-15 00:00:00	32020		\N	54489	0	195662009	4112343		0
14079	830	40481087	1980-03-18	1980-03-18 00:00:00	1980-04-08	1980-04-08 00:00:00	32020		\N	54966	0	444814009	40481087		0
24795	1478	40481087	2008-05-01	2008-05-01 00:00:00	2008-05-15	2008-05-15 00:00:00	32020		\N	98656	0	444814009	40481087		0
24953	1490	4230399	1970-09-08	1970-09-08 00:00:00	1970-12-07	1970-12-07 00:00:00	32020		\N	99304	0	359817006	4230399		0
25081	1496	4296204	1933-05-10	1933-05-10 00:00:00	1933-06-14	1933-06-14 00:00:00	32020		\N	99644	0	403190006	4296204		0
14772	869	4112343	1973-03-13	1973-03-13 00:00:00	1973-03-25	1973-03-25 00:00:00	32020		\N	57811	0	195662009	4112343		0
25477	1516	440448	1956-01-01	1956-01-01 00:00:00	\N	\N	32020		\N	101264	0	74400008	440448		0
25638	1524	134438	1996-01-12	1996-01-12 00:00:00	1996-11-07	1996-11-07 00:00:00	32020		\N	101913	0	40275004	134438		0
25826	1533	260139	2013-07-22	2013-07-22 00:00:00	2013-08-05	2013-08-05 00:00:00	32020		\N	102649	0	10509002	260139		0
25958	1540	40481087	1973-02-24	1973-02-24 00:00:00	1973-03-17	1973-03-17 00:00:00	32020		\N	103169	0	444814009	40481087		0
15603	923	4112343	2012-10-27	2012-10-27 00:00:00	2012-11-08	2012-11-08 00:00:00	32020		\N	61436	0	195662009	4112343		0
26263	1558	40481087	1982-08-16	1982-08-16 00:00:00	1982-08-30	1982-08-30 00:00:00	32020		\N	104372	0	444814009	40481087		0
15907	940	40481087	1965-12-18	1965-12-18 00:00:00	1965-12-25	1965-12-25 00:00:00	32020		\N	62491	0	444814009	40481087		0
26580	1574	375671	2016-09-01	2016-09-01 00:00:00	2016-10-01	2016-10-01 00:00:00	32020		\N	105709	0	62564004	375671		0
26774	1586	260139	1997-02-26	1997-02-26 00:00:00	1997-03-05	1997-03-05 00:00:00	32020		\N	106439	0	10509002	260139		0
16430	971	4152936	1985-12-01	1985-12-01 00:00:00	1985-12-15	1985-12-15 00:00:00	32020		\N	64581	0	283385000	4152936		0
27063	1600	40481087	2009-11-17	2009-11-17 00:00:00	2009-12-08	2009-12-08 00:00:00	32020		\N	107451	0	444814009	40481087		0
27284	1609	372328	1955-05-19	1955-05-19 00:00:00	1956-04-18	1956-04-18 00:00:00	32020		\N	108196	0	65363002	372328		0
27495	1623	260139	2019-01-19	2019-01-19 00:00:00	2019-02-02	2019-02-02 00:00:00	32020		\N	109092	0	10509002	260139		0
27578	1627	195588	1977-08-26	1977-08-26 00:00:00	1977-10-19	1977-10-19 00:00:00	32020		\N	109366	0	38822007	195588		0
27823	1641	40481087	1991-04-28	1991-04-28 00:00:00	1991-05-19	1991-05-19 00:00:00	32020		\N	110166	0	444814009	40481087		0
28032	1657	40481087	2011-11-24	2011-11-24 00:00:00	2011-12-08	2011-12-08 00:00:00	32020		\N	111178	0	444814009	40481087		0
28084	1658	28060	2005-02-26	2005-02-26 00:00:00	2005-03-08	2005-03-08 00:00:00	32020		\N	111346	0	43878008	28060		0
28276	1670	40481087	1964-12-07	1964-12-07 00:00:00	1964-12-21	1964-12-21 00:00:00	32020		\N	112153	0	444814009	40481087		0
28479	1685	260139	1997-10-29	1997-10-29 00:00:00	1997-11-12	1997-11-12 00:00:00	32020		\N	112912	0	10509002	260139		0
18083	1086	260139	1980-03-19	1980-03-19 00:00:00	1980-04-02	1980-04-02 00:00:00	32020		\N	71354	0	10509002	260139		0
28758	1703	78272	1963-11-05	1963-11-05 00:00:00	1963-11-19	1963-11-19 00:00:00	32020		\N	113928	0	70704007	78272		0
28885	1709	4112343	1957-05-09	1957-05-09 00:00:00	1957-05-22	1957-05-22 00:00:00	32020		\N	114299	0	195662009	4112343		0
29057	1719	372328	1958-02-03	1958-02-03 00:00:00	1958-03-18	1958-03-18 00:00:00	32020		\N	114985	0	65363002	372328		0
29269	1733	4027663	2006-02-12	2006-02-12 00:00:00	\N	\N	32020		\N	115837	0	13200003	4027663		0
29390	1740	372328	1957-02-12	1957-02-12 00:00:00	1957-08-17	1957-08-17 00:00:00	32020		\N	116267	0	65363002	372328		0
29575	1750	4237458	1974-01-13	1974-01-13 00:00:00	1974-04-13	1974-04-13 00:00:00	32020		\N	117003	0	58150001	4237458		0
29717	1759	260139	2001-09-25	2001-09-25 00:00:00	2001-10-02	2001-10-02 00:00:00	32020		\N	117606	0	10509002	260139		0
29925	1770	4112343	2017-12-25	2017-12-25 00:00:00	2018-01-04	2018-01-04 00:00:00	32020		\N	118363	0	195662009	4112343		0
30139	1781	40481087	1991-01-22	1991-01-22 00:00:00	1991-02-05	1991-02-05 00:00:00	32020		\N	119200	0	444814009	40481087		0
30260	1788	40481087	1982-02-09	1982-02-09 00:00:00	1982-03-02	1982-03-02 00:00:00	32020		\N	119824	0	444814009	40481087		0
30530	1801	380378	1966-07-18	1966-07-18 00:00:00	\N	\N	32020		\N	120750	0	84757009	380378		0
30570	1804	4116491	1976-10-03	1976-10-03 00:00:00	1976-11-18	1976-11-18 00:00:00	32020		\N	120863	0	301011002	4116491		0
30770	1820	28060	1982-03-19	1982-03-19 00:00:00	1982-03-31	1982-03-31 00:00:00	32020		\N	121738	0	43878008	28060		0
20410	1228	40479422	1980-01-06	1980-01-06 00:00:00	1980-03-13	1980-03-13 00:00:00	32020		\N	80894	0	444448004	40479422		0
31243	1848	40481087	1992-11-20	1992-11-20 00:00:00	1992-12-04	1992-12-04 00:00:00	32020		\N	123651	0	444814009	40481087		0
31413	1855	40481087	2005-10-02	2005-10-02 00:00:00	2005-10-09	2005-10-09 00:00:00	32020		\N	124215	0	444814009	40481087		0
21063	1264	4112343	1987-12-28	1987-12-28 00:00:00	1988-01-05	1988-01-05 00:00:00	32020		\N	83338	0	195662009	4112343		0
31823	1889	4112343	2012-07-03	2012-07-03 00:00:00	2012-07-15	2012-07-15 00:00:00	32020		\N	125937	0	195662009	4112343		0
21309	1280	4112343	1989-02-26	1989-02-26 00:00:00	1989-03-07	1989-03-07 00:00:00	32020		\N	84532	0	195662009	4112343		0
21500	1289	80180	2000-11-23	2000-11-23 00:00:00	\N	\N	32020		\N	85220	0	396275006	80180		0
21610	1297	372328	1981-10-26	1981-10-26 00:00:00	1982-01-17	1982-01-17 00:00:00	32020		\N	85708	0	65363002	372328		0
21831	1310	4112343	2010-12-11	2010-12-11 00:00:00	2010-12-24	2010-12-24 00:00:00	32020		\N	86662	0	195662009	4112343		0
21918	1314	40481087	1977-02-23	1977-02-23 00:00:00	1977-03-02	1977-03-02 00:00:00	32020		\N	86984	0	444814009	40481087		0
22159	1322	28060	2014-07-30	2014-07-30 00:00:00	2014-08-12	2014-08-12 00:00:00	32020		\N	87775	0	43878008	28060		0
22264	1328	4109685	1969-04-19	1969-04-19 00:00:00	1969-05-03	1969-05-03 00:00:00	32020		\N	88209	0	284551006	4109685		0
22446	1340	4112343	1934-02-24	1934-02-24 00:00:00	1934-03-06	1934-03-06 00:00:00	32020		\N	88939	0	195662009	4112343		0
22625	1352	198809	1976-07-29	1976-07-29 00:00:00	1976-07-29	1976-07-29 00:00:00	32020		\N	89606	0	65275009	198809		0
22801	1359	257012	1972-02-25	1972-02-25 00:00:00	\N	\N	32020		\N	90169	0	40055000	257012		0
12418	733	40481087	1978-04-02	1978-04-02 00:00:00	1978-04-23	1978-04-23 00:00:00	32020		\N	48660	0	444814009	40481087		0
23075	1378	40481087	1997-04-29	1997-04-29 00:00:00	1997-05-06	1997-05-06 00:00:00	32020		\N	91308	0	444814009	40481087		0
23277	1389	4112343	1966-06-22	1966-06-22 00:00:00	1966-07-04	1966-07-04 00:00:00	32020		\N	92149	0	195662009	4112343		0
23446	1399	440086	1972-06-26	1972-06-26 00:00:00	1978-07-05	1978-07-05 00:00:00	32020		\N	93080	0	192127007	440086		0
23616	1409	257012	1936-05-31	1936-05-31 00:00:00	\N	\N	32020		\N	93740	0	40055000	257012		0
23848	1426	4155034	2009-09-27	2009-09-27 00:00:00	2009-10-18	2009-10-18 00:00:00	32020		\N	94877	0	283371005	4155034		0
13443	793	192671	2010-06-18	2010-06-18 00:00:00	\N	\N	32020		\N	52651	0	K92.2	35208414		0
24190	1442	80180	1980-12-18	1980-12-18 00:00:00	\N	\N	32020		\N	96133	0	396275006	80180		0
24304	1448	81893	2007-07-18	2007-07-18 00:00:00	\N	\N	32020		\N	96614	0	64766004	81893		0
13925	822	40481087	1973-10-20	1973-10-20 00:00:00	1973-10-27	1973-10-27 00:00:00	32020		\N	54469	0	444814009	40481087		0
14104	834	4112343	1978-08-21	1978-08-21 00:00:00	1978-08-29	1978-08-29 00:00:00	32020		\N	55240	0	195662009	4112343		0
24796	1478	4294548	1998-04-14	1998-04-14 00:00:00	1998-04-28	1998-04-28 00:00:00	32020		\N	98654	0	75498004	4294548		0
24954	1490	4134304	1982-05-08	1982-05-08 00:00:00	1982-08-06	1982-08-06 00:00:00	32020		\N	99305	0	263102004	4134304		0
25082	1496	81151	1949-07-11	1949-07-11 00:00:00	1949-08-15	1949-08-15 00:00:00	32020		\N	99739	0	44465007	81151		0
14773	869	4112343	1971-12-11	1971-12-11 00:00:00	1971-12-18	1971-12-18 00:00:00	32020		\N	57792	0	195662009	4112343		0
25478	1516	4112343	1938-04-07	1938-04-07 00:00:00	1938-04-16	1938-04-16 00:00:00	32020		\N	101255	0	195662009	4112343		0
25640	1524	378001	2015-08-12	2015-08-12 00:00:00	2015-10-11	2015-10-11 00:00:00	32020		\N	101894	0	62106007	378001		0
25827	1533	378001	2000-08-23	2000-08-23 00:00:00	2000-09-22	2000-09-22 00:00:00	32020		\N	102690	0	62106007	378001		0
25959	1540	4283893	1962-07-12	1962-07-12 00:00:00	1962-10-04	1962-10-04 00:00:00	32020		\N	103197	0	36971009	4283893		0
15604	923	260139	1968-07-23	1968-07-23 00:00:00	1968-08-06	1968-08-06 00:00:00	32020		\N	61471	0	10509002	260139		0
26264	1558	378001	1995-09-12	1995-09-12 00:00:00	1995-11-11	1995-11-11 00:00:00	32020		\N	104303	0	62106007	378001		0
15908	940	40481087	1982-07-16	1982-07-16 00:00:00	1982-07-30	1982-07-30 00:00:00	32020		\N	62552	0	444814009	40481087		0
26581	1574	4218389	1986-10-04	1986-10-04 00:00:00	1986-11-08	1986-11-08 00:00:00	32020		\N	105708	0	39848009	4218389		0
26775	1586	4294548	1985-11-06	1985-11-06 00:00:00	1986-05-28	1986-05-28 00:00:00	32020		\N	106429	0	75498004	4294548		0
16431	971	4294548	1977-01-18	1977-01-18 00:00:00	1977-03-08	1977-03-08 00:00:00	32020		\N	64592	0	75498004	4294548		0
27064	1600	81151	2005-04-20	2005-04-20 00:00:00	2005-05-25	2005-05-25 00:00:00	32020		\N	107365	0	44465007	81151		0
27285	1609	40481087	2001-03-18	2001-03-18 00:00:00	2001-03-25	2001-03-25 00:00:00	32020		\N	108068	0	444814009	40481087		0
27496	1623	81151	1952-08-23	1952-08-23 00:00:00	1952-09-20	1952-09-20 00:00:00	32020		\N	109136	0	44465007	81151		0
27579	1627	80180	1987-11-04	1987-11-04 00:00:00	\N	\N	32020		\N	109325	0	396275006	80180		0
27824	1641	40481087	2016-03-04	2016-03-04 00:00:00	2016-03-25	2016-03-25 00:00:00	32020		\N	110195	0	444814009	40481087		0
28033	1657	40481087	1985-02-23	1985-02-23 00:00:00	1985-03-09	1985-03-09 00:00:00	32020		\N	111176	0	444814009	40481087		0
28085	1658	4112343	2001-01-01	2001-01-01 00:00:00	2001-01-14	2001-01-14 00:00:00	32020		\N	111345	0	195662009	4112343		0
28277	1670	4112343	1984-08-13	1984-08-13 00:00:00	1984-08-22	1984-08-22 00:00:00	32020		\N	112149	0	195662009	4112343		0
28480	1685	30753	2014-08-25	2014-08-25 00:00:00	\N	\N	32020		\N	112906	0	16761005	30753		0
18084	1086	40481087	1989-08-19	1989-08-19 00:00:00	1989-09-09	1989-09-09 00:00:00	32020		\N	71313	0	444814009	40481087		0
28759	1703	40481087	1970-09-30	1970-09-30 00:00:00	1970-10-21	1970-10-21 00:00:00	32020		\N	113909	0	444814009	40481087		0
28886	1709	4112343	1990-08-23	1990-08-23 00:00:00	1990-09-03	1990-09-03 00:00:00	32020		\N	114302	0	195662009	4112343		0
29058	1719	4218389	1993-02-23	1993-02-23 00:00:00	1993-03-30	1993-03-30 00:00:00	32020		\N	114994	0	39848009	4218389		0
29270	1733	4310024	2013-06-10	2013-06-10 00:00:00	\N	\N	32020		\N	115856	0	424802006	4310024		0
29391	1740	4027663	1978-08-31	1978-08-31 00:00:00	\N	\N	32020		\N	116314	0	13200003	4027663		0
29576	1750	372328	1968-08-12	1968-08-12 00:00:00	1968-10-23	1968-10-23 00:00:00	32020		\N	117022	0	65363002	372328		0
29718	1759	80180	2019-03-08	2019-03-08 00:00:00	\N	\N	32020		\N	117598	0	396275006	80180		0
29926	1770	40481087	1979-03-16	1979-03-16 00:00:00	1979-04-06	1979-04-06 00:00:00	32020		\N	118338	0	444814009	40481087		0
30140	1781	80502	2011-12-06	2011-12-06 00:00:00	\N	\N	32020		\N	119201	0	64859006	80502		0
30261	1788	40481087	1985-04-04	1985-04-04 00:00:00	1985-04-18	1985-04-18 00:00:00	32020		\N	119825	0	444814009	40481087		0
30531	1801	378001	1990-06-24	1990-06-24 00:00:00	1990-07-24	1990-07-24 00:00:00	32020		\N	120752	0	62106007	378001		0
30571	1804	40481087	1953-12-27	1953-12-27 00:00:00	1954-01-10	1954-01-10 00:00:00	32020		\N	120861	0	444814009	40481087		0
30771	1820	4156265	1992-07-23	1992-07-23 00:00:00	1992-08-13	1992-08-13 00:00:00	32020		\N	121709	0	370247008	4156265		0
20411	1228	40481087	2000-03-26	2000-03-26 00:00:00	2000-04-16	2000-04-16 00:00:00	32020		\N	80925	0	444814009	40481087		0
31104	1843	4112343	2002-08-25	2002-08-25 00:00:00	2002-09-06	2002-09-06 00:00:00	32020		\N	122993	0	195662009	4112343		0
31244	1848	28060	1954-11-24	1954-11-24 00:00:00	1954-12-06	1954-12-06 00:00:00	32020		\N	123680	0	43878008	28060		0
31414	1855	4155034	1991-12-27	1991-12-27 00:00:00	1992-01-10	1992-01-10 00:00:00	32020		\N	124139	0	283371005	4155034		0
21064	1265	4218389	1999-05-02	1999-05-02 00:00:00	1999-05-23	1999-05-23 00:00:00	32020		\N	83399	0	39848009	4218389		0
31824	1889	40481087	1990-01-19	1990-01-19 00:00:00	1990-01-26	1990-01-26 00:00:00	32020		\N	125923	0	444814009	40481087		0
21310	1280	260139	1955-07-15	1955-07-15 00:00:00	1955-07-29	1955-07-29 00:00:00	32020		\N	84550	0	10509002	260139		0
21534	1292	81151	1986-02-26	1986-02-26 00:00:00	1986-03-26	1986-03-26 00:00:00	32020		\N	85415	0	44465007	81151		0
21611	1297	40481087	1998-04-20	1998-04-20 00:00:00	1998-05-11	1998-05-11 00:00:00	32020		\N	85718	0	444814009	40481087		0
21832	1310	40481087	1972-09-14	1972-09-14 00:00:00	1972-09-28	1972-09-28 00:00:00	32020		\N	86570	0	444814009	40481087		0
21919	1314	4112343	1945-03-15	1945-03-15 00:00:00	1945-03-22	1945-03-22 00:00:00	32020		\N	87016	0	195662009	4112343		0
22160	1322	40481087	1926-10-07	1926-10-07 00:00:00	1926-10-14	1926-10-14 00:00:00	32020		\N	87790	0	444814009	40481087		0
22265	1328	260139	1966-11-05	1966-11-05 00:00:00	1966-11-12	1966-11-12 00:00:00	32020		\N	88177	0	10509002	260139		0
22447	1340	81151	1927-12-17	1927-12-17 00:00:00	1928-01-07	1928-01-07 00:00:00	32020		\N	88843	0	44465007	81151		0
22626	1352	40481087	2005-12-05	2005-12-05 00:00:00	2005-12-26	2005-12-26 00:00:00	32020		\N	89595	0	444814009	40481087		0
22802	1359	40481087	1986-03-20	1986-03-20 00:00:00	1986-04-10	1986-04-10 00:00:00	32020		\N	90206	0	444814009	40481087		0
12440	736	4112343	1974-06-25	1974-06-25 00:00:00	1974-07-03	1974-07-03 00:00:00	32020		\N	48847	0	195662009	4112343		0
23076	1378	40481087	2001-10-17	2001-10-17 00:00:00	2001-10-31	2001-10-31 00:00:00	32020		\N	91310	0	444814009	40481087		0
23278	1389	378001	1997-03-24	1997-03-24 00:00:00	1997-04-23	1997-04-23 00:00:00	32020		\N	92205	0	62106007	378001		0
23447	1399	372328	1960-11-26	1960-11-26 00:00:00	1961-03-08	1961-03-08 00:00:00	32020		\N	93115	0	65363002	372328		0
23617	1409	260139	1937-09-07	1937-09-07 00:00:00	1937-09-21	1937-09-21 00:00:00	32020		\N	93813	0	10509002	260139		0
23849	1426	4113008	1984-07-19	1984-07-19 00:00:00	1984-08-09	1984-08-09 00:00:00	32020		\N	94874	0	284549007	4113008		0
13444	793	40481087	1975-01-24	1975-01-24 00:00:00	1975-02-14	1975-02-14 00:00:00	32020		\N	52601	0	444814009	40481087		0
24191	1442	40481087	1999-07-31	1999-07-31 00:00:00	1999-08-14	1999-08-14 00:00:00	32020		\N	96138	0	444814009	40481087		0
24305	1448	4112343	1993-10-08	1993-10-08 00:00:00	1993-10-21	1993-10-21 00:00:00	32020		\N	96602	0	195662009	4112343		0
13926	823	440448	1977-11-14	1977-11-14 00:00:00	\N	\N	32020		\N	54546	0	74400008	440448		0
14105	834	40481087	1966-09-02	1966-09-02 00:00:00	1966-09-09	1966-09-09 00:00:00	32020		\N	55156	0	444814009	40481087		0
24797	1478	28060	1961-10-19	1961-10-19 00:00:00	1961-10-30	1961-10-30 00:00:00	32020		\N	98621	0	43878008	28060		0
24955	1490	40481087	1938-12-13	1938-12-13 00:00:00	1939-01-03	1939-01-03 00:00:00	32020		\N	99378	0	444814009	40481087		0
25083	1496	372328	1925-11-07	1925-11-07 00:00:00	1926-07-18	1926-07-18 00:00:00	32020		\N	99702	0	65363002	372328		0
14774	870	28060	2011-11-23	2011-11-23 00:00:00	2011-12-04	2011-12-04 00:00:00	32020		\N	57855	0	43878008	28060		0
25479	1516	4294548	1949-07-02	1949-07-02 00:00:00	1949-09-24	1949-09-24 00:00:00	32020		\N	101243	0	75498004	4294548		0
25641	1524	4112343	1998-06-02	1998-06-02 00:00:00	1998-06-13	1998-06-13 00:00:00	32020		\N	101920	0	195662009	4112343		0
25828	1535	80180	2013-04-14	2013-04-14 00:00:00	\N	\N	32020		\N	102738	0	396275006	80180		0
25960	1540	28060	1960-01-23	1960-01-23 00:00:00	1960-01-30	1960-01-30 00:00:00	32020		\N	103212	0	43878008	28060		0
26063	1545	4310024	2004-06-25	2004-06-25 00:00:00	\N	\N	32020		\N	103532	0	424802006	4310024		0
26265	1558	257012	1987-02-17	1987-02-17 00:00:00	\N	\N	32020		\N	104306	0	40055000	257012		0
15910	940	321042	1993-03-04	1993-03-04 00:00:00	\N	\N	32020		\N	62564	0	410429000	321042		0
26582	1574	40481087	1968-10-17	1968-10-17 00:00:00	1968-10-31	1968-10-31 00:00:00	32020		\N	105659	0	444814009	40481087		0
26776	1586	78272	1967-04-26	1967-04-26 00:00:00	1967-05-10	1967-05-10 00:00:00	32020		\N	106389	0	70704007	78272		0
16432	971	40481087	1964-11-01	1964-11-01 00:00:00	1964-11-22	1964-11-22 00:00:00	32020		\N	64601	0	444814009	40481087		0
27065	1600	40481087	1956-11-03	1956-11-03 00:00:00	1956-11-10	1956-11-10 00:00:00	32020		\N	107407	0	444814009	40481087		0
27286	1609	40481087	1989-02-22	1989-02-22 00:00:00	1989-03-15	1989-03-15 00:00:00	32020		\N	108169	0	444814009	40481087		0
27497	1623	40481087	1983-05-05	1983-05-05 00:00:00	1983-05-19	1983-05-19 00:00:00	32020		\N	109135	0	444814009	40481087		0
27580	1627	4116491	1971-05-27	1971-05-27 00:00:00	1971-07-11	1971-07-11 00:00:00	32020		\N	109353	0	301011002	4116491		0
27825	1641	4027663	1987-09-14	1987-09-14 00:00:00	\N	\N	32020		\N	110186	0	13200003	4027663		0
28034	1657	4218389	1966-02-15	1966-02-15 00:00:00	1966-03-22	1966-03-22 00:00:00	32020		\N	111184	0	39848009	4218389		0
28086	1658	80502	1992-01-27	1992-01-27 00:00:00	\N	\N	32020		\N	111287	0	64859006	80502		0
28278	1670	4112343	1998-01-15	1998-01-15 00:00:00	1998-01-26	1998-01-26 00:00:00	32020		\N	112150	0	195662009	4112343		0
28481	1685	40481087	2010-12-11	2010-12-11 00:00:00	2010-12-25	2010-12-25 00:00:00	32020		\N	112914	0	444814009	40481087		0
18085	1086	260139	1990-02-24	1990-02-24 00:00:00	1990-03-03	1990-03-03 00:00:00	32020		\N	71328	0	10509002	260139		0
28760	1703	4283893	1949-10-13	1949-10-13 00:00:00	1950-08-24	1950-08-24 00:00:00	32020		\N	113915	0	36971009	4283893		0
28887	1709	4112343	2014-08-15	2014-08-15 00:00:00	2014-08-28	2014-08-28 00:00:00	32020		\N	114258	0	195662009	4112343		0
29059	1719	4285898	1995-09-22	1995-09-22 00:00:00	\N	\N	32020		\N	114925	0	68496003	4285898		0
29271	1733	372328	1983-03-10	1983-03-10 00:00:00	1983-07-27	1983-07-27 00:00:00	32020		\N	115831	0	65363002	372328		0
29392	1740	40481087	1980-06-14	1980-06-14 00:00:00	1980-06-28	1980-06-28 00:00:00	32020		\N	116236	0	444814009	40481087		0
29577	1750	4112343	2006-09-11	2006-09-11 00:00:00	2006-09-19	2006-09-19 00:00:00	32020		\N	117020	0	195662009	4112343		0
29719	1759	260139	2005-06-25	2005-06-25 00:00:00	2005-07-02	2005-07-02 00:00:00	32020		\N	117607	0	10509002	260139		0
29927	1770	40481087	1979-06-11	1979-06-11 00:00:00	1979-06-18	1979-06-18 00:00:00	32020		\N	118350	0	444814009	40481087		0
30141	1781	40481087	2017-04-17	2017-04-17 00:00:00	2017-05-01	2017-05-01 00:00:00	32020		\N	119261	0	444814009	40481087		0
30262	1788	4112343	2003-10-09	2003-10-09 00:00:00	2003-10-21	2003-10-21 00:00:00	32020		\N	119828	0	195662009	4112343		0
30532	1801	40481087	2008-06-06	2008-06-06 00:00:00	2008-06-13	2008-06-13 00:00:00	32020		\N	120756	0	444814009	40481087		0
30572	1804	381316	1999-06-14	1999-06-14 00:00:00	\N	\N	32020		\N	120884	0	230690007	381316		0
30772	1820	260139	1989-08-25	1989-08-25 00:00:00	1989-09-08	1989-09-08 00:00:00	32020		\N	121712	0	10509002	260139		0
20412	1228	40481087	1981-10-04	1981-10-04 00:00:00	1981-10-25	1981-10-25 00:00:00	32020		\N	80923	0	444814009	40481087		0
31105	1843	28060	1993-10-02	1993-10-02 00:00:00	1993-10-15	1993-10-15 00:00:00	32020		\N	123058	0	43878008	28060		0
31245	1848	81893	1981-08-01	1981-08-01 00:00:00	\N	\N	32020		\N	123631	0	64766004	81893		0
31415	1855	40481087	1992-12-14	1992-12-14 00:00:00	1992-12-21	1992-12-21 00:00:00	32020		\N	124213	0	444814009	40481087		0
21065	1265	4278672	1991-04-14	1991-04-14 00:00:00	1991-07-13	1991-07-13 00:00:00	32020		\N	83398	0	65966004	4278672		0
31825	1889	40481087	2002-03-25	2002-03-25 00:00:00	2002-04-01	2002-04-01 00:00:00	32020		\N	125911	0	444814009	40481087		0
21311	1280	260139	1970-06-04	1970-06-04 00:00:00	1970-06-18	1970-06-18 00:00:00	32020		\N	84615	0	10509002	260139		0
21535	1292	4218389	1987-01-20	1987-01-20 00:00:00	1987-02-17	1987-02-17 00:00:00	32020		\N	85416	0	39848009	4218389		0
21612	1297	40481087	1986-09-29	1986-09-29 00:00:00	1986-10-13	1986-10-13 00:00:00	32020		\N	85717	0	444814009	40481087		0
21833	1310	134438	1969-03-01	1969-03-01 00:00:00	1971-02-21	1971-02-21 00:00:00	32020		\N	86684	0	40275004	134438		0
21920	1314	40481087	2011-03-02	2011-03-02 00:00:00	2011-03-16	2011-03-16 00:00:00	32020		\N	86973	0	444814009	40481087		0
22161	1322	260139	1989-05-17	1989-05-17 00:00:00	1989-05-24	1989-05-24 00:00:00	32020		\N	87720	0	10509002	260139		0
22266	1328	260139	2008-02-17	2008-02-17 00:00:00	2008-02-24	2008-02-24 00:00:00	32020		\N	88223	0	10509002	260139		0
22448	1340	4112343	1935-03-03	1935-03-03 00:00:00	1935-03-16	1935-03-16 00:00:00	32020		\N	88906	0	195662009	4112343		0
22627	1352	80180	1989-09-07	1989-09-07 00:00:00	\N	\N	32020		\N	89617	0	396275006	80180		0
22803	1360	4294548	1976-05-11	1976-05-11 00:00:00	1976-08-10	1976-08-10 00:00:00	32020		\N	90263	0	75498004	4294548		0
12441	736	30753	2008-10-18	2008-10-18 00:00:00	\N	\N	32020		\N	48858	0	16761005	30753		0
23077	1378	260139	1968-01-10	1968-01-10 00:00:00	1968-01-24	1968-01-24 00:00:00	32020		\N	91433	0	10509002	260139		0
23279	1389	4112343	2006-01-17	2006-01-17 00:00:00	2006-01-26	2006-01-26 00:00:00	32020		\N	92221	0	195662009	4112343		0
23448	1399	40481087	2003-06-03	2003-06-03 00:00:00	2003-06-17	2003-06-17 00:00:00	32020		\N	93013	0	444814009	40481087		0
23618	1409	40481087	1957-06-03	1957-06-03 00:00:00	1957-06-10	1957-06-10 00:00:00	32020		\N	93741	0	444814009	40481087		0
23850	1426	40481087	1990-06-03	1990-06-03 00:00:00	1990-06-10	1990-06-10 00:00:00	32020		\N	94831	0	444814009	40481087		0
13445	793	260139	2003-02-27	2003-02-27 00:00:00	2003-03-06	2003-03-06 00:00:00	32020		\N	52625	0	10509002	260139		0
24192	1442	40481087	1986-11-07	1986-11-07 00:00:00	1986-11-21	1986-11-21 00:00:00	32020		\N	96136	0	444814009	40481087		0
24306	1448	40481087	1982-04-19	1982-04-19 00:00:00	1982-05-10	1982-05-10 00:00:00	32020		\N	96600	0	444814009	40481087		0
13927	823	4142905	2017-10-19	2017-10-19 00:00:00	2017-11-18	2017-11-18 00:00:00	32020		\N	54559	0	33737001	4142905		0
14106	834	260139	2014-05-17	2014-05-17 00:00:00	2014-05-24	2014-05-24 00:00:00	32020		\N	55181	0	10509002	260139		0
24798	1478	260139	2009-12-12	2009-12-12 00:00:00	2009-12-27	2009-12-27 00:00:00	32020		\N	98667	0	10509002	260139		0
24956	1490	81151	1998-11-10	1998-11-10 00:00:00	1998-11-24	1998-11-24 00:00:00	32020		\N	99327	0	44465007	81151		0
25084	1496	40481087	1953-10-20	1953-10-20 00:00:00	1953-11-03	1953-11-03 00:00:00	32020		\N	99730	0	444814009	40481087		0
25233	1505	4112343	2015-10-31	2015-10-31 00:00:00	2015-11-13	2015-11-13 00:00:00	32020		\N	100387	0	195662009	4112343		0
25480	1517	40481087	1954-07-15	1954-07-15 00:00:00	1954-08-05	1954-08-05 00:00:00	32020		\N	101358	0	444814009	40481087		0
25642	1524	28060	2003-04-19	2003-04-19 00:00:00	2003-04-30	2003-04-30 00:00:00	32020		\N	101955	0	43878008	28060		0
25829	1535	4112343	2015-10-31	2015-10-31 00:00:00	2015-11-12	2015-11-12 00:00:00	32020		\N	102762	0	195662009	4112343		0
25961	1540	40481087	2009-05-27	2009-05-27 00:00:00	2009-06-17	2009-06-17 00:00:00	32020		\N	103171	0	444814009	40481087		0
26064	1545	40481087	1992-05-31	1992-05-31 00:00:00	1992-06-14	1992-06-14 00:00:00	32020		\N	103519	0	444814009	40481087		0
26266	1558	28060	2000-12-04	2000-12-04 00:00:00	2000-12-11	2000-12-11 00:00:00	32020		\N	104373	0	43878008	28060		0
15912	940	4329847	2001-11-29	2001-11-29 00:00:00	\N	\N	32020		\N	62565	0	22298006	4329847		0
26599	1576	28060	1980-03-19	1980-03-19 00:00:00	1980-03-27	1980-03-27 00:00:00	32020		\N	105818	0	43878008	28060		0
26777	1586	40481087	1947-11-04	1947-11-04 00:00:00	1947-11-18	1947-11-18 00:00:00	32020		\N	106384	0	444814009	40481087		0
16433	971	195588	2005-05-11	2005-05-11 00:00:00	2005-07-05	2005-07-05 00:00:00	32020		\N	64594	0	38822007	195588		0
27066	1600	40481087	2013-07-26	2013-07-26 00:00:00	2013-08-09	2013-08-09 00:00:00	32020		\N	107426	0	444814009	40481087		0
27287	1609	381316	1998-10-28	1998-10-28 00:00:00	\N	\N	32020		\N	108089	0	230690007	381316		0
27498	1623	372328	1956-02-04	1956-02-04 00:00:00	1957-01-04	1957-01-04 00:00:00	32020		\N	109127	0	65363002	372328		0
27581	1627	260139	1970-06-28	1970-06-28 00:00:00	1970-07-05	1970-07-05 00:00:00	32020		\N	109330	0	10509002	260139		0
27826	1641	4112343	1968-11-23	1968-11-23 00:00:00	1968-12-01	1968-12-01 00:00:00	32020		\N	110191	0	195662009	4112343		0
28035	1657	4237458	2013-01-12	2013-01-12 00:00:00	2013-04-12	2013-04-12 00:00:00	32020		\N	111189	0	58150001	4237458		0
28087	1658	4112343	1946-11-27	1946-11-27 00:00:00	1946-12-04	1946-12-04 00:00:00	32020		\N	111322	0	195662009	4112343		0
28279	1670	4112343	2002-08-04	2002-08-04 00:00:00	2002-08-15	2002-08-15 00:00:00	32020		\N	112137	0	195662009	4112343		0
28482	1685	4112343	1989-01-10	1989-01-10 00:00:00	1989-01-22	1989-01-22 00:00:00	32020		\N	112892	0	195662009	4112343		0
18086	1086	4218389	2012-03-20	2012-03-20 00:00:00	2012-04-24	2012-04-24 00:00:00	32020		\N	71350	0	39848009	4218389		0
28761	1703	260139	1965-03-19	1965-03-19 00:00:00	1965-04-02	1965-04-02 00:00:00	32020		\N	113908	0	10509002	260139		0
28908	1713	260139	2000-04-09	2000-04-09 00:00:00	2000-04-24	2000-04-24 00:00:00	32020		\N	114479	0	10509002	260139		0
29060	1719	4310024	1994-11-26	1994-11-26 00:00:00	\N	\N	32020		\N	114925	0	424802006	4310024		0
29272	1733	4296204	1986-09-20	1986-09-20 00:00:00	1986-10-18	1986-10-18 00:00:00	32020		\N	115803	0	403190006	4296204		0
29394	1740	4029498	1952-09-06	1952-09-06 00:00:00	\N	\N	32020		\N	116290	0	128613002	4029498		0
29578	1750	40481087	2005-08-23	2005-08-23 00:00:00	2005-09-13	2005-09-13 00:00:00	32020		\N	117040	0	444814009	40481087		0
29720	1759	81151	1993-02-17	1993-02-17 00:00:00	1993-03-10	1993-03-10 00:00:00	32020		\N	117599	0	44465007	81151		0
29928	1770	40481087	2005-03-19	2005-03-19 00:00:00	2005-04-09	2005-04-09 00:00:00	32020		\N	118359	0	444814009	40481087		0
30142	1781	40481087	1984-06-19	1984-06-19 00:00:00	1984-06-26	1984-06-26 00:00:00	32020		\N	119206	0	444814009	40481087		0
30263	1788	80180	2004-12-24	2004-12-24 00:00:00	\N	\N	32020		\N	119854	0	396275006	80180		0
30533	1801	40481087	1962-11-04	1962-11-04 00:00:00	1962-11-11	1962-11-11 00:00:00	32020		\N	120728	0	444814009	40481087		0
30573	1804	4112343	1950-05-12	1950-05-12 00:00:00	1950-05-25	1950-05-25 00:00:00	32020		\N	120835	0	195662009	4112343		0
30773	1820	440448	2015-01-31	2015-01-31 00:00:00	\N	\N	32020		\N	121711	0	74400008	440448		0
20413	1228	4294548	2008-06-01	2008-06-01 00:00:00	2008-06-22	2008-06-22 00:00:00	32020		\N	80878	0	75498004	4294548		0
31106	1843	40481087	1985-08-18	1985-08-18 00:00:00	1985-09-01	1985-09-01 00:00:00	32020		\N	123055	0	444814009	40481087		0
31246	1848	260139	2010-01-24	2010-01-24 00:00:00	2010-02-07	2010-02-07 00:00:00	32020		\N	123602	0	10509002	260139		0
31416	1855	4112343	1990-05-03	1990-05-03 00:00:00	1990-05-12	1990-05-12 00:00:00	32020		\N	124222	0	195662009	4112343		0
21066	1265	372328	1981-04-06	1981-04-06 00:00:00	1981-07-19	1981-07-19 00:00:00	32020		\N	83425	0	65363002	372328		0
31826	1889	40481087	1993-08-14	1993-08-14 00:00:00	1993-09-04	1993-09-04 00:00:00	32020		\N	125936	0	444814009	40481087		0
21312	1280	40481087	1987-05-03	1987-05-03 00:00:00	1987-05-24	1987-05-24 00:00:00	32020		\N	84531	0	444814009	40481087		0
21536	1292	440086	1963-08-12	1963-08-12 00:00:00	1968-08-20	1968-08-20 00:00:00	32020		\N	85383	0	192127007	440086		0
21613	1297	260139	2007-10-16	2007-10-16 00:00:00	2007-10-30	2007-10-30 00:00:00	32020		\N	85711	0	10509002	260139		0
21834	1310	40481087	1971-01-10	1971-01-10 00:00:00	1971-01-17	1971-01-17 00:00:00	32020		\N	86585	0	444814009	40481087		0
21921	1314	260139	1977-07-01	1977-07-01 00:00:00	1977-07-15	1977-07-15 00:00:00	32020		\N	87008	0	10509002	260139		0
22162	1322	4112343	1987-10-05	1987-10-05 00:00:00	1987-10-16	1987-10-16 00:00:00	32020		\N	87773	0	195662009	4112343		0
22267	1328	4278672	1948-04-11	1948-04-11 00:00:00	1948-07-10	1948-07-10 00:00:00	32020		\N	88207	0	65966004	4278672		0
22449	1340	4112343	1978-05-13	1978-05-13 00:00:00	1978-05-20	1978-05-20 00:00:00	32020		\N	88909	0	195662009	4112343		0
22628	1352	4294548	1999-08-10	1999-08-10 00:00:00	1999-08-31	1999-08-31 00:00:00	32020		\N	89539	0	75498004	4294548		0
22804	1360	30753	2017-08-15	2017-08-15 00:00:00	\N	\N	32020		\N	90243	0	16761005	30753		0
12442	736	260139	2000-10-22	2000-10-22 00:00:00	2000-10-29	2000-10-29 00:00:00	32020		\N	48841	0	10509002	260139		0
23078	1378	40481087	1949-01-01	1949-01-01 00:00:00	1949-01-15	1949-01-15 00:00:00	32020		\N	91361	0	444814009	40481087		0
23280	1389	260139	1972-08-15	1972-08-15 00:00:00	1972-08-22	1972-08-22 00:00:00	32020		\N	92151	0	10509002	260139		0
23449	1399	4048171	1962-07-06	1962-07-06 00:00:00	\N	\N	32020		\N	93044	0	232353008	4048171		0
23619	1410	4112343	2005-05-30	2005-05-30 00:00:00	2005-06-08	2005-06-08 00:00:00	32020		\N	93897	0	195662009	4112343		0
23851	1426	80180	1986-09-19	1986-09-19 00:00:00	\N	\N	32020		\N	94864	0	396275006	80180		0
13446	793	40481087	2008-02-13	2008-02-13 00:00:00	2008-02-27	2008-02-27 00:00:00	32020		\N	52626	0	444814009	40481087		0
24193	1442	260139	1963-01-25	1963-01-25 00:00:00	1963-02-01	1963-02-01 00:00:00	32020		\N	96145	0	10509002	260139		0
24307	1448	81151	1978-01-01	1978-01-01 00:00:00	1978-01-15	1978-01-15 00:00:00	32020		\N	96585	0	44465007	81151		0
13928	823	40480160	2017-10-19	2017-10-19 00:00:00	2017-11-18	2017-11-18 00:00:00	32020		\N	54559	0	443165006	40480160		0
14107	834	81151	1971-06-01	1971-06-01 00:00:00	1971-07-06	1971-07-06 00:00:00	32020		\N	55250	0	44465007	81151		0
24799	1478	40481087	1985-03-31	1985-03-31 00:00:00	1985-04-14	1985-04-14 00:00:00	32020		\N	98616	0	444814009	40481087		0
24957	1490	80180	1974-02-18	1974-02-18 00:00:00	\N	\N	32020		\N	99319	0	396275006	80180		0
25085	1496	4112343	1968-12-01	1968-12-01 00:00:00	1968-12-14	1968-12-14 00:00:00	32020		\N	99723	0	195662009	4112343		0
25234	1506	4152936	1998-03-22	1998-03-22 00:00:00	1998-04-05	1998-04-05 00:00:00	32020		\N	100395	0	283385000	4152936		0
25481	1517	313217	2017-04-17	2017-04-17 00:00:00	\N	\N	32020		\N	101405	0	49436004	313217		0
25643	1524	4285898	2003-05-23	2003-05-23 00:00:00	\N	\N	32020		\N	101955	0	68496003	4285898		0
25830	1535	81151	1999-09-10	1999-09-10 00:00:00	1999-10-01	1999-10-01 00:00:00	32020		\N	102747	0	44465007	81151		0
25962	1540	40481087	2013-11-02	2013-11-02 00:00:00	2013-11-23	2013-11-23 00:00:00	32020		\N	103172	0	444814009	40481087		0
26065	1545	440086	1981-12-03	1981-12-03 00:00:00	1986-12-12	1986-12-12 00:00:00	32020		\N	103539	0	192127007	440086		0
26279	1560	4112343	1936-02-12	1936-02-12 00:00:00	1936-02-25	1936-02-25 00:00:00	32020		\N	104436	0	195662009	4112343		0
15913	940	4155034	1987-05-02	1987-05-02 00:00:00	1987-05-23	1987-05-23 00:00:00	32020		\N	62563	0	283371005	4155034		0
26600	1576	4112343	1972-01-18	1972-01-18 00:00:00	1972-01-30	1972-01-30 00:00:00	32020		\N	105770	0	195662009	4112343		0
26778	1586	40481087	1961-09-13	1961-09-13 00:00:00	1961-09-27	1961-09-27 00:00:00	32020		\N	106452	0	444814009	40481087		0
16434	971	260139	1961-09-12	1961-09-12 00:00:00	1961-09-26	1961-09-26 00:00:00	32020		\N	64590	0	10509002	260139		0
27067	1600	4237458	1971-10-02	1971-10-02 00:00:00	1971-12-31	1971-12-31 00:00:00	32020		\N	107369	0	58150001	4237458		0
27288	1609	4283893	2002-01-24	2002-01-24 00:00:00	2002-06-07	2002-06-07 00:00:00	32020		\N	108192	0	36971009	4283893		0
27499	1623	260139	1958-12-21	1958-12-21 00:00:00	1959-01-04	1959-01-04 00:00:00	32020		\N	109083	0	10509002	260139		0
27582	1627	4112343	1995-11-15	1995-11-15 00:00:00	1995-11-25	1995-11-25 00:00:00	32020		\N	109341	0	195662009	4112343		0
27827	1641	40481087	1988-05-23	1988-05-23 00:00:00	1988-06-06	1988-06-06 00:00:00	32020		\N	110165	0	444814009	40481087		0
28036	1657	260139	1990-11-23	1990-11-23 00:00:00	1990-12-07	1990-12-07 00:00:00	32020		\N	111213	0	10509002	260139		0
28088	1658	4294548	1980-12-26	1980-12-26 00:00:00	1981-02-27	1981-02-27 00:00:00	32020		\N	111390	0	75498004	4294548		0
28280	1670	4113008	2017-01-01	2017-01-01 00:00:00	2017-01-22	2017-01-22 00:00:00	32020		\N	112173	0	284549007	4113008		0
28483	1685	4296204	1989-09-11	1989-09-11 00:00:00	1989-09-25	1989-09-25 00:00:00	32020		\N	112869	0	403190006	4296204		0
18087	1086	4146173	1989-09-17	1989-09-17 00:00:00	1989-10-17	1989-10-17 00:00:00	32020		\N	71314	0	307731004	4146173		0
28762	1703	4112343	1984-06-10	1984-06-10 00:00:00	1984-06-22	1984-06-22 00:00:00	32020		\N	113893	0	195662009	4112343		0
28909	1713	28060	1999-07-09	1999-07-09 00:00:00	1999-07-17	1999-07-17 00:00:00	32020		\N	114479	0	43878008	28060		0
29061	1719	40481087	2014-03-07	2014-03-07 00:00:00	2014-03-21	2014-03-21 00:00:00	32020		\N	114903	0	444814009	40481087		0
29273	1733	260139	2001-03-06	2001-03-06 00:00:00	2001-03-13	2001-03-13 00:00:00	32020		\N	115835	0	10509002	260139		0
29395	1740	40481087	1995-10-10	1995-10-10 00:00:00	1995-10-17	1995-10-17 00:00:00	32020		\N	116306	0	444814009	40481087		0
29579	1750	260139	2017-11-03	2017-11-03 00:00:00	2017-11-17	2017-11-17 00:00:00	32020		\N	117021	0	10509002	260139		0
29721	1759	4116491	2016-12-23	2016-12-23 00:00:00	2017-02-13	2017-02-13 00:00:00	32020		\N	117577	0	301011002	4116491		0
29929	1770	260139	2006-04-28	2006-04-28 00:00:00	2006-05-14	2006-05-14 00:00:00	32020		\N	118359	0	10509002	260139		0
30143	1781	439777	2000-05-26	2000-05-26 00:00:00	\N	\N	32020		\N	119260	0	271737000	439777		0
30264	1788	4109685	1990-07-21	1990-07-21 00:00:00	1990-08-11	1990-08-11 00:00:00	32020		\N	119834	0	284551006	4109685		0
30534	1801	4112343	2010-07-08	2010-07-08 00:00:00	2010-07-16	2010-07-16 00:00:00	32020		\N	120757	0	195662009	4112343		0
30574	1804	40481087	1998-04-12	1998-04-12 00:00:00	1998-04-19	1998-04-19 00:00:00	32020		\N	120892	0	444814009	40481087		0
30774	1820	40481087	2019-02-21	2019-02-21 00:00:00	2019-02-28	2019-02-28 00:00:00	32020		\N	121706	0	444814009	40481087		0
20414	1228	80180	2009-01-13	2009-01-13 00:00:00	\N	\N	32020		\N	80902	0	396275006	80180		0
31107	1843	260139	1989-06-26	1989-06-26 00:00:00	1989-07-03	1989-07-03 00:00:00	32020		\N	123012	0	10509002	260139		0
31247	1848	4109685	1957-03-10	1957-03-10 00:00:00	1957-03-31	1957-03-31 00:00:00	32020		\N	123677	0	284551006	4109685		0
31417	1855	4113008	1996-12-05	1996-12-05 00:00:00	1996-12-26	1996-12-26 00:00:00	32020		\N	124141	0	284549007	4113008		0
21067	1265	80180	2017-12-18	2017-12-18 00:00:00	\N	\N	32020		\N	83392	0	396275006	80180		0
31827	1889	40481087	2006-01-18	2006-01-18 00:00:00	2006-02-01	2006-02-01 00:00:00	32020		\N	125904	0	444814009	40481087		0
21313	1280	80809	1994-06-23	1994-06-23 00:00:00	1998-12-29	1998-12-29 00:00:00	32020		\N	84546	0	69896004	80809		0
21537	1292	40481087	2011-05-30	2011-05-30 00:00:00	2011-06-13	2011-06-13 00:00:00	32020		\N	85358	0	444814009	40481087		0
21614	1297	40481087	1979-10-27	1979-10-27 00:00:00	1979-11-10	1979-11-10 00:00:00	32020		\N	85716	0	444814009	40481087		0
21835	1310	40486433	1945-03-07	1945-03-07 00:00:00	1959-03-06	1959-03-06 00:00:00	32020		\N	86565	0	446096008	40486433		0
21922	1314	372328	1935-05-03	1935-05-03 00:00:00	1936-02-01	1936-02-01 00:00:00	32020		\N	87055	0	65363002	372328		0
22163	1322	40481087	1949-08-04	1949-08-04 00:00:00	1949-08-18	1949-08-18 00:00:00	32020		\N	87736	0	444814009	40481087		0
22268	1328	4112343	1978-06-30	1978-06-30 00:00:00	1978-07-08	1978-07-08 00:00:00	32020		\N	88135	0	195662009	4112343		0
22450	1340	40481087	1938-02-28	1938-02-28 00:00:00	1938-03-21	1938-03-21 00:00:00	32020		\N	88907	0	444814009	40481087		0
22629	1352	40481087	1998-06-30	1998-06-30 00:00:00	1998-07-07	1998-07-07 00:00:00	32020		\N	89562	0	444814009	40481087		0
22805	1360	40481087	2017-02-23	2017-02-23 00:00:00	2017-03-09	2017-03-09 00:00:00	32020		\N	90243	0	444814009	40481087		0
12443	736	4112343	1986-01-26	1986-01-26 00:00:00	1986-02-04	1986-02-04 00:00:00	32020		\N	48790	0	195662009	4112343		0
23079	1378	40481087	1962-06-11	1962-06-11 00:00:00	1962-06-25	1962-06-25 00:00:00	32020		\N	91292	0	444814009	40481087		0
23281	1389	260139	1956-10-27	1956-10-27 00:00:00	1956-11-10	1956-11-10 00:00:00	32020		\N	92148	0	10509002	260139		0
23450	1399	40481087	1962-10-25	1962-10-25 00:00:00	1962-11-15	1962-11-15 00:00:00	32020		\N	93031	0	444814009	40481087		0
23620	1410	40481087	2006-08-24	2006-08-24 00:00:00	2006-08-31	2006-08-31 00:00:00	32020		\N	93905	0	444814009	40481087		0
23852	1426	40481087	1997-05-30	1997-05-30 00:00:00	1997-06-13	1997-06-13 00:00:00	32020		\N	94881	0	444814009	40481087		0
23905	1428	40481087	1977-03-07	1977-03-07 00:00:00	1977-03-21	1977-03-21 00:00:00	32020		\N	94987	0	444814009	40481087		0
24194	1442	4278672	2004-12-18	2004-12-18 00:00:00	2005-02-16	2005-02-16 00:00:00	32020		\N	96187	0	65966004	4278672		0
24308	1448	40481087	2002-03-10	2002-03-10 00:00:00	2002-03-31	2002-03-31 00:00:00	32020		\N	96603	0	444814009	40481087		0
13929	823	80502	2005-01-17	2005-01-17 00:00:00	\N	\N	32020		\N	54579	0	64859006	80502		0
14108	834	4218389	1965-09-20	1965-09-20 00:00:00	1965-10-25	1965-10-25 00:00:00	32020		\N	55206	0	39848009	4218389		0
24800	1478	4112343	1969-11-01	1969-11-01 00:00:00	1969-11-14	1969-11-14 00:00:00	32020		\N	98612	0	195662009	4112343		0
24958	1490	4285898	1973-10-21	1973-10-21 00:00:00	\N	\N	32020		\N	99319	0	68496003	4285898		0
25086	1496	40481087	1988-08-06	1988-08-06 00:00:00	1988-08-27	1988-08-27 00:00:00	32020		\N	99648	0	444814009	40481087		0
25235	1506	28060	1980-05-02	1980-05-02 00:00:00	1980-05-12	1980-05-12 00:00:00	32020		\N	100414	0	43878008	28060		0
25482	1517	40481087	1944-01-26	1944-01-26 00:00:00	1944-02-02	1944-02-02 00:00:00	32020		\N	101394	0	444814009	40481087		0
25831	1535	4112343	1995-12-16	1995-12-16 00:00:00	1995-12-26	1995-12-26 00:00:00	32020		\N	102760	0	195662009	4112343		0
25963	1540	4142905	1973-04-10	1973-04-10 00:00:00	1973-05-10	1973-05-10 00:00:00	32020		\N	103154	0	33737001	4142905		0
26066	1545	260139	1996-09-12	1996-09-12 00:00:00	1996-09-19	1996-09-19 00:00:00	32020		\N	103521	0	10509002	260139		0
26280	1560	4112343	1984-05-27	1984-05-27 00:00:00	1984-06-03	1984-06-03 00:00:00	32020		\N	104483	0	195662009	4112343		0
15914	940	257012	1951-06-28	1951-06-28 00:00:00	\N	\N	32020		\N	62519	0	40055000	257012		0
26601	1576	4237458	1983-12-17	1983-12-17 00:00:00	1984-02-15	1984-02-15 00:00:00	32020		\N	105775	0	58150001	4237458		0
26779	1586	40481087	1965-07-13	1965-07-13 00:00:00	1965-07-20	1965-07-20 00:00:00	32020		\N	106413	0	444814009	40481087		0
26893	1593	4112343	1998-04-10	1998-04-10 00:00:00	1998-04-18	1998-04-18 00:00:00	32020		\N	106891	0	195662009	4112343		0
27068	1600	40481087	2004-12-16	2004-12-16 00:00:00	2005-01-06	2005-01-06 00:00:00	32020		\N	107414	0	444814009	40481087		0
27289	1609	4142905	2014-02-15	2014-02-15 00:00:00	2014-05-17	2014-05-17 00:00:00	32020		\N	108165	0	33737001	4142905		0
27500	1623	78272	1955-09-05	1955-09-05 00:00:00	1955-09-19	1955-09-19 00:00:00	32020		\N	109137	0	70704007	78272		0
27583	1627	4112343	1965-04-26	1965-04-26 00:00:00	1965-05-08	1965-05-08 00:00:00	32020		\N	109329	0	195662009	4112343		0
27828	1641	372328	1957-07-08	1957-07-08 00:00:00	1957-08-28	1957-08-28 00:00:00	32020		\N	110196	0	65363002	372328		0
28037	1657	81151	1947-09-09	1947-09-09 00:00:00	1947-09-23	1947-09-23 00:00:00	32020		\N	111182	0	44465007	81151		0
28089	1658	439777	1912-04-30	1912-04-30 00:00:00	\N	\N	32020		\N	111353	0	271737000	439777		0
28281	1670	260139	2002-12-24	2002-12-24 00:00:00	2002-12-31	2002-12-31 00:00:00	32020		\N	112138	0	10509002	260139		0
28484	1685	4027663	2005-02-03	2005-02-03 00:00:00	\N	\N	32020		\N	112885	0	13200003	4027663		0
18088	1086	260139	1993-12-01	1993-12-01 00:00:00	1993-12-15	1993-12-15 00:00:00	32020		\N	71356	0	10509002	260139		0
28763	1703	4112343	1976-03-05	1976-03-05 00:00:00	1976-03-14	1976-03-14 00:00:00	32020		\N	113911	0	195662009	4112343		0
28910	1713	4296205	2011-07-13	2011-07-13 00:00:00	2011-08-17	2011-08-17 00:00:00	32020		\N	114456	0	403191005	4296205		0
29062	1719	4027663	1985-04-02	1985-04-02 00:00:00	\N	\N	32020		\N	114901	0	13200003	4027663		0
29274	1733	40481087	2014-02-10	2014-02-10 00:00:00	2014-02-17	2014-02-17 00:00:00	32020		\N	115830	0	444814009	40481087		0
29396	1740	4112343	1977-07-16	1977-07-16 00:00:00	1977-07-25	1977-07-25 00:00:00	32020		\N	116263	0	195662009	4112343		0
29580	1750	260139	2001-05-22	2001-05-22 00:00:00	2001-05-29	2001-05-29 00:00:00	32020		\N	117019	0	10509002	260139		0
29722	1759	260139	2012-09-15	2012-09-15 00:00:00	2012-09-22	2012-09-22 00:00:00	32020		\N	117625	0	10509002	260139		0
29930	1770	4294548	1996-07-15	1996-07-15 00:00:00	1996-07-29	1996-07-29 00:00:00	32020		\N	118339	0	75498004	4294548		0
30144	1781	4112343	1961-11-03	1961-11-03 00:00:00	1961-11-15	1961-11-15 00:00:00	32020		\N	119256	0	195662009	4112343		0
30265	1788	40481087	1965-11-03	1965-11-03 00:00:00	1965-11-24	1965-11-24 00:00:00	32020		\N	119840	0	444814009	40481087		0
30535	1801	40481087	1956-03-17	1956-03-17 00:00:00	1956-03-31	1956-03-31 00:00:00	32020		\N	120755	0	444814009	40481087		0
30575	1804	372328	1940-03-10	1940-03-10 00:00:00	1940-09-23	1940-09-23 00:00:00	32020		\N	120886	0	65363002	372328		0
30775	1820	195588	2008-01-31	2008-01-31 00:00:00	2008-03-18	2008-03-18 00:00:00	32020		\N	121705	0	38822007	195588		0
20416	1228	260139	1984-10-13	1984-10-13 00:00:00	1984-10-20	1984-10-20 00:00:00	32020		\N	80874	0	10509002	260139		0
31108	1843	4112343	2000-08-22	2000-08-22 00:00:00	2000-09-03	2000-09-03 00:00:00	32020		\N	123042	0	195662009	4112343		0
31248	1848	378001	1953-04-30	1953-04-30 00:00:00	1953-05-30	1953-05-30 00:00:00	32020		\N	123676	0	62106007	378001		0
31418	1855	4109685	1979-10-10	1979-10-10 00:00:00	1979-10-31	1979-10-31 00:00:00	32020		\N	124136	0	284551006	4109685		0
21068	1265	378001	1989-05-24	1989-05-24 00:00:00	1989-06-23	1989-06-23 00:00:00	32020		\N	83397	0	62106007	378001		0
31828	1889	40481087	2018-03-06	2018-03-06 00:00:00	2018-03-13	2018-03-13 00:00:00	32020		\N	125912	0	444814009	40481087		0
21314	1280	40481087	1993-04-26	1993-04-26 00:00:00	1993-05-03	1993-05-03 00:00:00	32020		\N	84534	0	444814009	40481087		0
21538	1292	40481087	2013-02-07	2013-02-07 00:00:00	2013-02-14	2013-02-14 00:00:00	32020		\N	85427	0	444814009	40481087		0
21615	1297	260139	1989-11-04	1989-11-04 00:00:00	1989-11-18	1989-11-18 00:00:00	32020		\N	85706	0	10509002	260139		0
21836	1310	4134304	1968-02-03	1968-02-03 00:00:00	1968-05-03	1968-05-03 00:00:00	32020		\N	86678	0	263102004	4134304		0
21923	1314	40481087	2016-11-18	2016-11-18 00:00:00	2016-11-25	2016-11-25 00:00:00	32020		\N	86974	0	444814009	40481087		0
22164	1322	372328	2003-01-18	2003-01-18 00:00:00	2003-08-13	2003-08-13 00:00:00	32020		\N	87745	0	65363002	372328		0
22269	1328	4294548	1952-03-28	1952-03-28 00:00:00	1952-05-09	1952-05-09 00:00:00	32020		\N	88188	0	75498004	4294548		0
22451	1340	4294548	1916-11-11	1916-11-11 00:00:00	1917-08-11	1917-08-11 00:00:00	32020		\N	88935	0	75498004	4294548		0
22630	1352	40481087	1998-01-01	1998-01-01 00:00:00	1998-01-22	1998-01-22 00:00:00	32020		\N	89561	0	444814009	40481087		0
22806	1360	40481087	1999-12-11	1999-12-11 00:00:00	1999-12-25	1999-12-25 00:00:00	32020		\N	90276	0	444814009	40481087		0
12444	736	257012	2008-06-03	2008-06-03 00:00:00	2008-06-10	2008-06-10 00:00:00	32020		\N	48804	0	40055000	257012		0
23080	1378	4152936	2013-08-27	2013-08-27 00:00:00	2013-09-10	2013-09-10 00:00:00	32020		\N	91320	0	283385000	4152936		0
23282	1389	40481087	1989-04-05	1989-04-05 00:00:00	1989-04-19	1989-04-19 00:00:00	32020		\N	92164	0	444814009	40481087		0
23451	1399	4218389	1994-12-28	1994-12-28 00:00:00	1995-01-25	1995-01-25 00:00:00	32020		\N	93107	0	39848009	4218389		0
23621	1410	375671	1987-02-12	1987-02-12 00:00:00	1987-04-14	1987-04-14 00:00:00	32020		\N	93835	0	62564004	375671		0
23853	1426	372328	1958-02-27	1958-02-27 00:00:00	1958-12-02	1958-12-02 00:00:00	32020		\N	94833	0	65363002	372328		0
23906	1428	260139	1962-12-07	1962-12-07 00:00:00	1962-12-14	1962-12-14 00:00:00	32020		\N	95010	0	10509002	260139		0
24195	1442	140673	2016-01-19	2016-01-19 00:00:00	\N	\N	32020		\N	96178	0	40930008	140673		0
24309	1448	4027663	2002-03-21	2002-03-21 00:00:00	\N	\N	32020		\N	96603	0	13200003	4027663		0
13930	823	4112343	2007-12-04	2007-12-04 00:00:00	2007-12-17	2007-12-17 00:00:00	32020		\N	54514	0	195662009	4112343		0
14109	834	4112343	1968-06-07	1968-06-07 00:00:00	1968-06-16	1968-06-16 00:00:00	32020		\N	55207	0	195662009	4112343		0
24809	1480	80180	2001-07-01	2001-07-01 00:00:00	\N	\N	32020		\N	98764	0	396275006	80180		0
24959	1490	4310024	1972-06-28	1972-06-28 00:00:00	\N	\N	32020		\N	99319	0	424802006	4310024		0
25087	1496	4112343	1932-01-29	1932-01-29 00:00:00	1932-02-11	1932-02-11 00:00:00	32020		\N	99719	0	195662009	4112343		0
25236	1506	4156265	1964-12-01	1964-12-01 00:00:00	1964-12-15	1964-12-15 00:00:00	32020		\N	100394	0	370247008	4156265		0
25483	1517	40481087	1968-12-02	1968-12-02 00:00:00	1968-12-09	1968-12-09 00:00:00	32020		\N	101361	0	444814009	40481087		0
25645	1524	4156265	1973-01-10	1973-01-10 00:00:00	1973-01-24	1973-01-24 00:00:00	32020		\N	101908	0	370247008	4156265		0
25832	1535	4112343	2009-09-07	2009-09-07 00:00:00	2009-09-16	2009-09-16 00:00:00	32020		\N	102754	0	195662009	4112343		0
25964	1540	260139	1966-06-18	1966-06-18 00:00:00	1966-07-02	1966-07-02 00:00:00	32020		\N	103165	0	10509002	260139		0
26067	1545	378001	1997-10-03	1997-10-03 00:00:00	1997-12-02	1997-12-02 00:00:00	32020		\N	103510	0	62106007	378001		0
26281	1560	40481087	1983-09-30	1983-09-30 00:00:00	1983-10-07	1983-10-07 00:00:00	32020		\N	104451	0	444814009	40481087		0
15915	940	260139	1965-07-16	1965-07-16 00:00:00	1965-07-23	1965-07-23 00:00:00	32020		\N	62539	0	10509002	260139		0
26602	1576	40481087	1974-12-06	1974-12-06 00:00:00	1974-12-20	1974-12-20 00:00:00	32020		\N	105793	0	444814009	40481087		0
26780	1586	40481087	1988-04-26	1988-04-26 00:00:00	1988-05-03	1988-05-03 00:00:00	32020		\N	106462	0	444814009	40481087		0
26894	1593	372328	1944-01-09	1944-01-09 00:00:00	1944-10-19	1944-10-19 00:00:00	32020		\N	106901	0	65363002	372328		0
27069	1600	4156265	2002-07-21	2002-07-21 00:00:00	2002-08-04	2002-08-04 00:00:00	32020		\N	107364	0	370247008	4156265		0
27290	1609	260139	1984-06-19	1984-06-19 00:00:00	1984-06-26	1984-06-26 00:00:00	32020		\N	108179	0	10509002	260139		0
27501	1623	317576	2017-07-14	2017-07-14 00:00:00	\N	\N	32020		\N	109072	0	53741008	317576		0
27584	1627	40481087	1978-08-15	1978-08-15 00:00:00	1978-08-29	1978-08-29 00:00:00	32020		\N	109367	0	444814009	40481087		0
27829	1641	260139	1981-05-23	1981-05-23 00:00:00	1981-05-30	1981-05-30 00:00:00	32020		\N	110119	0	10509002	260139		0
28038	1657	4059173	2008-01-09	2008-01-09 00:00:00	2008-03-09	2008-03-09 00:00:00	32020		\N	111187	0	16114001	4059173		0
28090	1658	40481087	1988-12-16	1988-12-16 00:00:00	1989-01-06	1989-01-06 00:00:00	32020		\N	111415	0	444814009	40481087		0
28282	1670	28060	1967-09-02	1967-09-02 00:00:00	1967-09-11	1967-09-11 00:00:00	32020		\N	112154	0	43878008	28060		0
28485	1685	4112343	2004-03-16	2004-03-16 00:00:00	2004-03-29	2004-03-29 00:00:00	32020		\N	112885	0	195662009	4112343		0
18089	1086	4134304	2015-04-23	2015-04-23 00:00:00	2015-06-22	2015-06-22 00:00:00	32020		\N	71352	0	263102004	4134304		0
28764	1703	260139	1983-09-05	1983-09-05 00:00:00	1983-09-12	1983-09-12 00:00:00	32020		\N	113923	0	10509002	260139		0
28911	1713	4155034	2009-06-09	2009-06-09 00:00:00	2009-06-23	2009-06-23 00:00:00	32020		\N	114455	0	283371005	4155034		0
29063	1719	40481087	1983-05-18	1983-05-18 00:00:00	1983-06-01	1983-06-01 00:00:00	32020		\N	114901	0	444814009	40481087		0
29275	1733	80180	2015-11-27	2015-11-27 00:00:00	\N	\N	32020		\N	115830	0	396275006	80180		0
29397	1740	260139	1992-08-26	1992-08-26 00:00:00	1992-09-09	1992-09-09 00:00:00	32020		\N	116305	0	10509002	260139		0
29581	1751	81151	1980-09-12	1980-09-12 00:00:00	1980-09-26	1980-09-26 00:00:00	32020		\N	117076	0	44465007	81151		0
29723	1759	4112343	1999-09-16	1999-09-16 00:00:00	1999-09-24	1999-09-24 00:00:00	32020		\N	117575	0	195662009	4112343		0
29931	1770	257012	2008-11-24	2008-11-24 00:00:00	\N	\N	32020		\N	118346	0	40055000	257012		0
30145	1781	378001	1979-12-02	1979-12-02 00:00:00	1980-01-01	1980-01-01 00:00:00	32020		\N	119226	0	62106007	378001		0
30266	1788	4112343	1994-03-28	1994-03-28 00:00:00	1994-04-06	1994-04-06 00:00:00	32020		\N	119844	0	195662009	4112343		0
30536	1801	28060	1981-12-27	1981-12-27 00:00:00	1982-01-03	1982-01-03 00:00:00	32020		\N	120761	0	43878008	28060		0
30576	1804	4112343	1945-07-23	1945-07-23 00:00:00	1945-08-05	1945-08-05 00:00:00	32020		\N	120890	0	195662009	4112343		0
30776	1820	40481087	2001-04-30	2001-04-30 00:00:00	2001-05-07	2001-05-07 00:00:00	32020		\N	121713	0	444814009	40481087		0
20417	1228	4156265	2001-09-19	2001-09-19 00:00:00	2001-10-10	2001-10-10 00:00:00	32020		\N	80895	0	370247008	4156265		0
31109	1843	260139	2012-06-04	2012-06-04 00:00:00	2012-06-11	2012-06-11 00:00:00	32020		\N	123086	0	10509002	260139		0
31249	1848	4112343	2004-04-24	2004-04-24 00:00:00	2004-05-01	2004-05-01 00:00:00	32020		\N	123689	0	195662009	4112343		0
31419	1855	4109685	1995-01-24	1995-01-24 00:00:00	1995-02-14	1995-02-14 00:00:00	32020		\N	124140	0	284551006	4109685		0
21069	1265	192671	2018-02-20	2018-02-20 00:00:00	\N	\N	32020		\N	83400	0	K92.2	35208414		0
31829	1889	80180	2018-04-28	2018-04-28 00:00:00	\N	\N	32020		\N	125912	0	396275006	80180		0
21315	1280	40481087	1956-11-11	1956-11-11 00:00:00	1956-12-02	1956-12-02 00:00:00	32020		\N	84540	0	444814009	40481087		0
21539	1292	40479768	1999-01-15	1999-01-15 00:00:00	1999-03-23	1999-03-23 00:00:00	32020		\N	85417	0	444470001	40479768		0
21616	1297	40481087	1981-05-09	1981-05-09 00:00:00	1981-05-23	1981-05-23 00:00:00	32020		\N	85705	0	444814009	40481087		0
21837	1310	40481087	1944-07-17	1944-07-17 00:00:00	1944-08-07	1944-08-07 00:00:00	32020		\N	86681	0	444814009	40481087		0
21924	1314	372328	1930-10-13	1930-10-13 00:00:00	1931-01-24	1931-01-24 00:00:00	32020		\N	87058	0	65363002	372328		0
22165	1322	40481087	1982-08-12	1982-08-12 00:00:00	1982-08-19	1982-08-19 00:00:00	32020		\N	87772	0	444814009	40481087		0
22270	1328	4035415	1976-02-26	1976-02-26 00:00:00	1976-04-26	1976-04-26 00:00:00	32020		\N	88210	0	239720000	4035415		0
22452	1340	4283893	1934-12-18	1934-12-18 00:00:00	1935-04-09	1935-04-09 00:00:00	32020		\N	88924	0	36971009	4283893		0
22631	1352	261325	1993-08-15	1993-08-15 00:00:00	\N	\N	32020		\N	89553	0	87433001	261325		0
22807	1360	260139	1981-02-07	1981-02-07 00:00:00	1981-02-14	1981-02-14 00:00:00	32020		\N	90275	0	10509002	260139		0
12445	736	40481087	1983-12-02	1983-12-02 00:00:00	1983-12-23	1983-12-23 00:00:00	32020		\N	48778	0	444814009	40481087		0
23081	1378	40481087	2006-09-12	2006-09-12 00:00:00	2006-09-19	2006-09-19 00:00:00	32020		\N	91333	0	444814009	40481087		0
23283	1389	260139	2008-09-10	2008-09-10 00:00:00	2008-09-24	2008-09-24 00:00:00	32020		\N	92167	0	10509002	260139		0
23452	1399	260139	1992-07-18	1992-07-18 00:00:00	1992-07-25	1992-07-25 00:00:00	32020		\N	93111	0	10509002	260139		0
23622	1410	4152936	2008-02-22	2008-02-22 00:00:00	2008-03-07	2008-03-07 00:00:00	32020		\N	93837	0	283385000	4152936		0
23854	1426	40481087	1975-07-27	1975-07-27 00:00:00	1975-08-17	1975-08-17 00:00:00	32020		\N	94879	0	444814009	40481087		0
23907	1428	260139	1979-11-17	1979-11-17 00:00:00	1979-12-01	1979-12-01 00:00:00	32020		\N	95044	0	10509002	260139		0
24196	1442	4112343	1966-05-02	1966-05-02 00:00:00	1966-05-11	1966-05-11 00:00:00	32020		\N	96143	0	195662009	4112343		0
24310	1448	4112343	2008-10-19	2008-10-19 00:00:00	2008-10-26	2008-10-26 00:00:00	32020		\N	96632	0	195662009	4112343		0
13931	823	40481087	2001-07-16	2001-07-16 00:00:00	2001-08-06	2001-08-06 00:00:00	32020		\N	54531	0	444814009	40481087		0
14110	834	40481087	1960-06-13	1960-06-13 00:00:00	1960-06-27	1960-06-27 00:00:00	32020		\N	55155	0	444814009	40481087		0
24810	1480	81151	2000-10-24	2000-10-24 00:00:00	2000-11-07	2000-11-07 00:00:00	32020		\N	98764	0	44465007	81151		0
24960	1490	30753	1972-12-25	1972-12-25 00:00:00	\N	\N	32020		\N	99319	0	16761005	30753		0
25088	1496	4112343	1923-12-01	1923-12-01 00:00:00	1923-12-09	1923-12-09 00:00:00	32020		\N	99724	0	195662009	4112343		0
25237	1506	40479422	1952-08-29	1952-08-29 00:00:00	1952-10-05	1952-10-05 00:00:00	32020		\N	100393	0	444448004	40479422		0
25484	1517	40481087	2016-01-12	2016-01-12 00:00:00	2016-02-02	2016-02-02 00:00:00	32020		\N	101363	0	444814009	40481087		0
25646	1524	4112343	1997-06-27	1997-06-27 00:00:00	1997-07-05	1997-07-05 00:00:00	32020		\N	101919	0	195662009	4112343		0
25833	1535	260139	1986-10-28	1986-10-28 00:00:00	1986-11-11	1986-11-11 00:00:00	32020		\N	102708	0	10509002	260139		0
25965	1540	4112343	1979-09-06	1979-09-06 00:00:00	1979-09-15	1979-09-15 00:00:00	32020		\N	103216	0	195662009	4112343		0
26110	1550	4294548	1977-03-15	1977-03-15 00:00:00	1977-05-03	1977-05-03 00:00:00	32020		\N	103765	0	75498004	4294548		0
26282	1560	4112343	1968-01-10	1968-01-10 00:00:00	1968-01-18	1968-01-18 00:00:00	32020		\N	104482	0	195662009	4112343		0
15916	940	81151	1950-04-18	1950-04-18 00:00:00	1950-05-02	1950-05-02 00:00:00	32020		\N	62559	0	44465007	81151		0
26603	1576	40481087	2015-05-13	2015-05-13 00:00:00	2015-06-03	2015-06-03 00:00:00	32020		\N	105820	0	444814009	40481087		0
26781	1586	372328	1953-04-27	1953-04-27 00:00:00	1954-04-18	1954-04-18 00:00:00	32020		\N	106432	0	65363002	372328		0
26895	1593	260139	1976-08-03	1976-08-03 00:00:00	1976-08-10	1976-08-10 00:00:00	32020		\N	106826	0	10509002	260139		0
27070	1600	260139	1965-04-17	1965-04-17 00:00:00	1965-04-24	1965-04-24 00:00:00	32020		\N	107432	0	10509002	260139		0
27291	1609	40481087	2015-04-05	2015-04-05 00:00:00	2015-04-19	2015-04-19 00:00:00	32020		\N	108140	0	444814009	40481087		0
27502	1623	40481087	1962-02-15	1962-02-15 00:00:00	1962-03-01	1962-03-01 00:00:00	32020		\N	109118	0	444814009	40481087		0
27585	1627	40481087	1985-07-29	1985-07-29 00:00:00	1985-08-05	1985-08-05 00:00:00	32020		\N	109340	0	444814009	40481087		0
27830	1641	378001	1982-08-20	1982-08-20 00:00:00	1982-09-19	1982-09-19 00:00:00	32020		\N	110177	0	62106007	378001		0
28039	1657	4112343	1996-06-09	1996-06-09 00:00:00	1996-06-20	1996-06-20 00:00:00	32020		\N	111177	0	195662009	4112343		0
28091	1658	4112343	1991-01-13	1991-01-13 00:00:00	1991-01-22	1991-01-22 00:00:00	32020		\N	111328	0	195662009	4112343		0
28283	1670	4112343	2010-12-03	2010-12-03 00:00:00	2010-12-14	2010-12-14 00:00:00	32020		\N	112157	0	195662009	4112343		0
28486	1685	372328	1985-05-14	1985-05-14 00:00:00	1985-12-29	1985-12-29 00:00:00	32020		\N	112894	0	65363002	372328		0
18090	1086	4112343	2007-03-07	2007-03-07 00:00:00	2007-03-20	2007-03-20 00:00:00	32020		\N	71322	0	195662009	4112343		0
28765	1703	4112343	1951-04-03	1951-04-03 00:00:00	1951-04-13	1951-04-13 00:00:00	32020		\N	113904	0	195662009	4112343		0
28912	1713	30753	2009-08-17	2009-08-17 00:00:00	\N	\N	32020		\N	114455	0	16761005	30753		0
29064	1719	80180	1996-05-19	1996-05-19 00:00:00	\N	\N	32020		\N	114926	0	396275006	80180		0
29276	1733	4112343	2008-02-11	2008-02-11 00:00:00	2008-02-18	2008-02-18 00:00:00	32020		\N	115843	0	195662009	4112343		0
29398	1740	4116491	2012-09-05	2012-09-05 00:00:00	2012-10-11	2012-10-11 00:00:00	32020		\N	116297	0	301011002	4116491		0
29582	1751	260139	2017-05-24	2017-05-24 00:00:00	2017-06-07	2017-06-07 00:00:00	32020		\N	117051	0	10509002	260139		0
29724	1759	372328	1986-01-25	1986-01-25 00:00:00	1986-03-10	1986-03-10 00:00:00	32020		\N	117609	0	65363002	372328		0
29932	1770	260139	1986-06-01	1986-06-01 00:00:00	1986-06-15	1986-06-15 00:00:00	32020		\N	118400	0	10509002	260139		0
30146	1781	4112343	1994-08-10	1994-08-10 00:00:00	1994-08-21	1994-08-21 00:00:00	32020		\N	119259	0	195662009	4112343		0
30267	1788	260139	2011-10-09	2011-10-09 00:00:00	2011-10-16	2011-10-16 00:00:00	32020		\N	119814	0	10509002	260139		0
30537	1801	40481087	1987-11-08	1987-11-08 00:00:00	1987-11-22	1987-11-22 00:00:00	32020		\N	120730	0	444814009	40481087		0
30577	1804	40481087	1996-01-02	1996-01-02 00:00:00	1996-01-16	1996-01-16 00:00:00	32020		\N	120894	0	444814009	40481087		0
30777	1820	80180	2014-08-17	2014-08-17 00:00:00	\N	\N	32020		\N	121737	0	396275006	80180		0
20418	1228	4116491	2014-06-26	2014-06-26 00:00:00	2014-08-09	2014-08-09 00:00:00	32020		\N	80927	0	301011002	4116491		0
31110	1843	40481087	2013-04-23	2013-04-23 00:00:00	2013-05-14	2013-05-14 00:00:00	32020		\N	122994	0	444814009	40481087		0
31250	1848	375671	1988-07-16	1988-07-16 00:00:00	1988-08-15	1988-08-15 00:00:00	32020		\N	123648	0	62564004	375671		0
31420	1855	260139	2004-03-22	2004-03-22 00:00:00	2004-04-05	2004-04-05 00:00:00	32020		\N	124214	0	10509002	260139		0
21070	1265	40481087	2008-02-09	2008-02-09 00:00:00	2008-02-16	2008-02-16 00:00:00	32020		\N	83422	0	444814009	40481087		0
31830	1889	4112343	1995-10-15	1995-10-15 00:00:00	1995-10-28	1995-10-28 00:00:00	32020		\N	125924	0	195662009	4112343		0
21316	1280	372328	1978-03-28	1978-03-28 00:00:00	1979-01-03	1979-01-03 00:00:00	32020		\N	84547	0	65363002	372328		0
21540	1292	80180	1990-03-23	1990-03-23 00:00:00	\N	\N	32020		\N	85357	0	396275006	80180		0
21617	1297	4116491	2013-08-04	2013-08-04 00:00:00	2013-09-15	2013-09-15 00:00:00	32020		\N	85733	0	301011002	4116491		0
21838	1310	372328	2013-10-10	2013-10-10 00:00:00	\N	\N	32020		\N	86625	0	65363002	372328		0
21925	1314	40481087	1959-10-20	1959-10-20 00:00:00	1959-10-27	1959-10-27 00:00:00	32020		\N	86983	0	444814009	40481087		0
22166	1322	4112343	1962-02-07	1962-02-07 00:00:00	1962-02-15	1962-02-15 00:00:00	32020		\N	87717	0	195662009	4112343		0
22271	1328	195588	1999-07-13	1999-07-13 00:00:00	1999-08-14	1999-08-14 00:00:00	32020		\N	88189	0	38822007	195588		0
22453	1340	40481087	1919-01-11	1919-01-11 00:00:00	1919-01-25	1919-01-25 00:00:00	32020		\N	88938	0	444814009	40481087		0
22632	1352	192671	1989-09-23	1989-09-23 00:00:00	\N	\N	32020		\N	89608	0	K92.2	35208414		0
22808	1360	372328	1977-03-28	1977-03-28 00:00:00	1977-07-31	1977-07-31 00:00:00	32020		\N	90286	0	65363002	372328		0
12446	736	40481087	1979-03-05	1979-03-05 00:00:00	1979-03-19	1979-03-19 00:00:00	32020		\N	48783	0	444814009	40481087		0
23082	1378	134438	1974-06-20	1974-06-20 00:00:00	1975-02-21	1975-02-21 00:00:00	32020		\N	91295	0	40275004	134438		0
23284	1389	372328	1955-07-03	1955-07-03 00:00:00	1955-08-13	1955-08-13 00:00:00	32020		\N	92223	0	65363002	372328		0
23453	1399	40481087	2006-03-09	2006-03-09 00:00:00	2006-03-16	2006-03-16 00:00:00	32020		\N	93070	0	444814009	40481087		0
23623	1410	4027663	1996-03-07	1996-03-07 00:00:00	\N	\N	32020		\N	93856	0	13200003	4027663		0
23855	1426	40481087	1992-10-02	1992-10-02 00:00:00	1992-10-16	1992-10-16 00:00:00	32020		\N	94820	0	444814009	40481087		0
23908	1428	81151	1952-09-10	1952-09-10 00:00:00	1952-09-30	1952-09-30 00:00:00	32020		\N	94965	0	44465007	81151		0
24197	1442	260139	1968-12-02	1968-12-02 00:00:00	1968-12-16	1968-12-16 00:00:00	32020		\N	96144	0	10509002	260139		0
24311	1448	4112343	1996-11-07	1996-11-07 00:00:00	1996-11-20	1996-11-20 00:00:00	32020		\N	96588	0	195662009	4112343		0
13932	823	4112343	2009-12-08	2009-12-08 00:00:00	2009-12-18	2009-12-18 00:00:00	32020		\N	54552	0	195662009	4112343		0
24569	1467	260139	1998-04-16	1998-04-16 00:00:00	1998-04-30	1998-04-30 00:00:00	32020		\N	97719	0	10509002	260139		0
24811	1480	4112343	1969-03-08	1969-03-08 00:00:00	1969-03-17	1969-03-17 00:00:00	32020		\N	98752	0	195662009	4112343		0
24961	1490	81893	1972-11-25	1972-11-25 00:00:00	\N	\N	32020		\N	99319	0	64766004	81893		0
25089	1496	40481087	1928-05-15	1928-05-15 00:00:00	1928-05-29	1928-05-29 00:00:00	32020		\N	99693	0	444814009	40481087		0
25238	1506	4283893	1986-09-28	1986-09-28 00:00:00	1987-04-19	1987-04-19 00:00:00	32020		\N	100447	0	36971009	4283893		0
25485	1517	4112343	2017-12-15	2017-12-15 00:00:00	2017-12-26	2017-12-26 00:00:00	32020		\N	101459	0	195662009	4112343		0
25647	1524	4116491	2008-01-02	2008-01-02 00:00:00	2008-02-13	2008-02-13 00:00:00	32020		\N	101956	0	301011002	4116491		0
25834	1535	372328	1979-10-03	1979-10-03 00:00:00	1980-03-10	1980-03-10 00:00:00	32020		\N	102704	0	65363002	372328		0
25966	1540	40481087	1990-02-06	1990-02-06 00:00:00	1990-02-27	1990-02-27 00:00:00	32020		\N	103218	0	444814009	40481087		0
26111	1550	260139	1993-05-07	1993-05-07 00:00:00	1993-05-14	1993-05-14 00:00:00	32020		\N	103805	0	10509002	260139		0
26283	1560	260139	1946-07-16	1946-07-16 00:00:00	1946-07-23	1946-07-23 00:00:00	32020		\N	104439	0	10509002	260139		0
26395	1566	4310024	2000-05-24	2000-05-24 00:00:00	\N	\N	32020		\N	105032	0	424802006	4310024		0
26604	1576	260139	2009-11-27	2009-11-27 00:00:00	2009-12-04	2009-12-04 00:00:00	32020		\N	105803	0	10509002	260139		0
26782	1586	4056621	1966-05-10	1966-05-10 00:00:00	\N	\N	32020		\N	106454	0	197927001	4056621		0
26896	1593	40481087	1945-11-17	1945-11-17 00:00:00	1945-12-01	1945-12-01 00:00:00	32020		\N	106824	0	444814009	40481087		0
27071	1600	28060	1959-11-30	1959-11-30 00:00:00	1959-12-13	1959-12-13 00:00:00	32020		\N	107440	0	43878008	28060		0
27292	1609	4218389	1996-09-27	1996-09-27 00:00:00	1996-10-18	1996-10-18 00:00:00	32020		\N	108164	0	39848009	4218389		0
27503	1623	28060	2017-07-05	2017-07-05 00:00:00	2017-07-18	2017-07-18 00:00:00	32020		\N	109088	0	43878008	28060		0
27586	1627	40481087	2011-10-28	2011-10-28 00:00:00	2011-11-18	2011-11-18 00:00:00	32020		\N	109370	0	444814009	40481087		0
27831	1641	4112343	2010-11-24	2010-11-24 00:00:00	2010-12-06	2010-12-06 00:00:00	32020		\N	110154	0	195662009	4112343		0
28040	1657	4152936	2014-02-06	2014-02-06 00:00:00	2014-02-20	2014-02-20 00:00:00	32020		\N	111190	0	283385000	4152936		0
28092	1658	40481087	1968-09-30	1968-09-30 00:00:00	1968-10-14	1968-10-14 00:00:00	32020		\N	111325	0	444814009	40481087		0
28286	1672	40481087	2004-02-06	2004-02-06 00:00:00	2004-02-13	2004-02-13 00:00:00	32020		\N	112230	0	444814009	40481087		0
28487	1685	40481087	2002-12-11	2002-12-11 00:00:00	2002-12-25	2002-12-25 00:00:00	32020		\N	112893	0	444814009	40481087		0
18091	1086	372328	1967-06-01	1967-06-01 00:00:00	1967-11-17	1967-11-17 00:00:00	32020		\N	71340	0	65363002	372328		0
28766	1703	372328	1950-06-04	1950-06-04 00:00:00	1950-07-19	1950-07-19 00:00:00	32020		\N	113873	0	65363002	372328		0
28913	1713	372328	1972-04-03	1972-04-03 00:00:00	1972-06-14	1972-06-14 00:00:00	32020		\N	114480	0	65363002	372328		0
29065	1720	372328	1979-12-26	1979-12-26 00:00:00	1980-03-08	1980-03-08 00:00:00	32020		\N	115010	0	65363002	372328		0
29399	1740	4112343	1994-08-06	1994-08-06 00:00:00	1994-08-16	1994-08-16 00:00:00	32020		\N	116238	0	195662009	4112343		0
29583	1751	40481087	2008-08-24	2008-08-24 00:00:00	2008-09-07	2008-09-07 00:00:00	32020		\N	117063	0	444814009	40481087		0
29725	1759	40481087	2012-05-05	2012-05-05 00:00:00	2012-05-26	2012-05-26 00:00:00	32020		\N	117608	0	444814009	40481087		0
29933	1770	378001	2007-10-03	2007-10-03 00:00:00	2007-12-02	2007-12-02 00:00:00	32020		\N	118376	0	62106007	378001		0
30147	1781	40481087	1990-03-06	1990-03-06 00:00:00	1990-03-20	1990-03-20 00:00:00	32020		\N	119250	0	444814009	40481087		0
30268	1788	4112343	2002-04-09	2002-04-09 00:00:00	2002-04-16	2002-04-16 00:00:00	32020		\N	119795	0	195662009	4112343		0
30538	1801	40481087	2003-06-23	2003-06-23 00:00:00	2003-07-07	2003-07-07 00:00:00	32020		\N	120734	0	444814009	40481087		0
30605	1808	260139	2014-04-27	2014-04-27 00:00:00	2014-05-04	2014-05-04 00:00:00	32020		\N	121050	0	10509002	260139		0
30778	1820	78272	1995-04-30	1995-04-30 00:00:00	1995-05-14	1995-05-14 00:00:00	32020		\N	121710	0	70704007	78272		0
30877	1826	4035415	1964-05-04	1964-05-04 00:00:00	1964-06-03	1964-06-03 00:00:00	32020		\N	122061	0	239720000	4035415		0
31111	1843	81151	1992-04-21	1992-04-21 00:00:00	1992-05-12	1992-05-12 00:00:00	32020		\N	123010	0	44465007	81151		0
31251	1848	378001	1959-04-20	1959-04-20 00:00:00	1959-06-19	1959-06-19 00:00:00	32020		\N	123678	0	62106007	378001		0
31421	1855	30753	2015-03-01	2015-03-01 00:00:00	\N	\N	32020		\N	124218	0	16761005	30753		0
21071	1265	40481087	2012-10-27	2012-10-27 00:00:00	2012-11-10	2012-11-10 00:00:00	32020		\N	83424	0	444814009	40481087		0
31831	1889	40481087	2000-10-01	2000-10-01 00:00:00	2000-10-22	2000-10-22 00:00:00	32020		\N	125910	0	444814009	40481087		0
21317	1280	4296204	1964-08-24	1964-08-24 00:00:00	1964-09-28	1964-09-28 00:00:00	32020		\N	84525	0	403190006	4296204		0
21541	1292	40481087	2014-12-12	2014-12-12 00:00:00	2014-12-19	2014-12-19 00:00:00	32020		\N	85396	0	444814009	40481087		0
21618	1297	80180	2014-10-23	2014-10-23 00:00:00	\N	\N	32020		\N	85754	0	396275006	80180		0
21839	1310	4283893	1988-12-10	1988-12-10 00:00:00	1989-02-18	1989-02-18 00:00:00	32020		\N	86564	0	36971009	4283893		0
21926	1314	40481087	1952-12-04	1952-12-04 00:00:00	1952-12-18	1952-12-18 00:00:00	32020		\N	87017	0	444814009	40481087		0
22167	1322	40481087	1933-04-16	1933-04-16 00:00:00	1933-05-07	1933-05-07 00:00:00	32020		\N	87734	0	444814009	40481087		0
22272	1328	40481087	1967-06-25	1967-06-25 00:00:00	1967-07-09	1967-07-09 00:00:00	32020		\N	88192	0	444814009	40481087		0
22454	1340	4296204	1980-01-25	1980-01-25 00:00:00	1980-02-29	1980-02-29 00:00:00	32020		\N	88846	0	403190006	4296204		0
22633	1352	4112343	1985-07-16	1985-07-16 00:00:00	1985-07-26	1985-07-26 00:00:00	32020		\N	89593	0	195662009	4112343		0
22809	1360	4134304	2013-06-17	2013-06-17 00:00:00	2013-08-16	2013-08-16 00:00:00	32020		\N	90274	0	263102004	4134304		0
12447	736	40481087	1987-07-10	1987-07-10 00:00:00	1987-07-24	1987-07-24 00:00:00	32020		\N	48811	0	444814009	40481087		0
23083	1378	80180	1981-07-26	1981-07-26 00:00:00	\N	\N	32020		\N	91322	0	396275006	80180		0
23285	1389	4112343	1981-05-01	1981-05-01 00:00:00	1981-05-13	1981-05-13 00:00:00	32020		\N	92152	0	195662009	4112343		0
23454	1399	4112343	1961-04-26	1961-04-26 00:00:00	1961-05-07	1961-05-07 00:00:00	32020		\N	92993	0	195662009	4112343		0
23624	1410	40481087	2014-07-28	2014-07-28 00:00:00	2014-08-11	2014-08-11 00:00:00	32020		\N	93876	0	444814009	40481087		0
23856	1426	40481087	1957-06-21	1957-06-21 00:00:00	1957-07-12	1957-07-12 00:00:00	32020		\N	94884	0	444814009	40481087		0
23909	1428	40481087	1994-10-03	1994-10-03 00:00:00	1994-10-10	1994-10-10 00:00:00	32020		\N	94988	0	444814009	40481087		0
24198	1442	260139	1973-04-09	1973-04-09 00:00:00	1973-04-16	1973-04-16 00:00:00	32020		\N	96106	0	10509002	260139		0
24312	1448	80180	2009-03-09	2009-03-09 00:00:00	\N	\N	32020		\N	96604	0	396275006	80180		0
13933	823	260139	2009-02-01	2009-02-01 00:00:00	2009-02-08	2009-02-08 00:00:00	32020		\N	54532	0	10509002	260139		0
24570	1467	4112343	1989-03-29	1989-03-29 00:00:00	1989-04-09	1989-04-09 00:00:00	32020		\N	97749	0	195662009	4112343		0
24812	1480	40481087	1969-06-10	1969-06-10 00:00:00	1969-07-01	1969-07-01 00:00:00	32020		\N	98706	0	444814009	40481087		0
24962	1490	260139	1968-09-29	1968-09-29 00:00:00	1968-10-13	1968-10-13 00:00:00	32020		\N	99381	0	10509002	260139		0
25090	1497	260139	1983-10-25	1983-10-25 00:00:00	1983-11-08	1983-11-08 00:00:00	32020		\N	99769	0	10509002	260139		0
25239	1506	40481087	1989-10-11	1989-10-11 00:00:00	1989-10-25	1989-10-25 00:00:00	32020		\N	100423	0	444814009	40481087		0
25486	1517	440086	1944-10-30	1944-10-30 00:00:00	1947-11-10	1947-11-10 00:00:00	32020		\N	101356	0	192127007	440086		0
25648	1524	4112343	2004-05-27	2004-05-27 00:00:00	2004-06-04	2004-06-04 00:00:00	32020		\N	101934	0	195662009	4112343		0
25835	1535	260139	1998-03-29	1998-03-29 00:00:00	1998-04-05	1998-04-05 00:00:00	32020		\N	102753	0	10509002	260139		0
25967	1540	4283893	1965-04-11	1965-04-11 00:00:00	1965-05-30	1965-05-30 00:00:00	32020		\N	103168	0	36971009	4283893		0
26112	1550	260139	2007-12-03	2007-12-03 00:00:00	2007-12-17	2007-12-17 00:00:00	32020		\N	103751	0	10509002	260139		0
26284	1560	4112343	1944-03-18	1944-03-18 00:00:00	1944-03-29	1944-03-29 00:00:00	32020		\N	104500	0	195662009	4112343		0
26396	1566	40481087	2005-03-03	2005-03-03 00:00:00	2005-03-17	2005-03-17 00:00:00	32020		\N	105043	0	444814009	40481087		0
26605	1576	4112343	2003-04-15	2003-04-15 00:00:00	2003-04-26	2003-04-26 00:00:00	32020		\N	105819	0	195662009	4112343		0
26783	1586	4116491	1966-05-10	1966-05-10 00:00:00	1966-06-26	1966-06-26 00:00:00	32020		\N	106454	0	301011002	4116491		0
26897	1593	4296204	1961-12-30	1961-12-30 00:00:00	1962-01-13	1962-01-13 00:00:00	32020		\N	106844	0	403190006	4296204		0
27072	1600	4112343	1993-04-04	1993-04-04 00:00:00	1993-04-12	1993-04-12 00:00:00	32020		\N	107413	0	195662009	4112343		0
27293	1609	260139	1992-11-03	1992-11-03 00:00:00	1992-11-10	1992-11-10 00:00:00	32020		\N	108132	0	10509002	260139		0
27504	1623	260139	2009-04-08	2009-04-08 00:00:00	2009-04-22	2009-04-22 00:00:00	32020		\N	109082	0	10509002	260139		0
27587	1627	372328	1980-06-25	1980-06-25 00:00:00	1983-01-29	1983-01-29 00:00:00	32020		\N	109373	0	65363002	372328		0
27832	1641	192671	1997-11-10	1997-11-10 00:00:00	\N	\N	32020		\N	110190	0	K92.2	35208414		0
28041	1657	4112343	1951-12-01	1951-12-01 00:00:00	1951-12-09	1951-12-09 00:00:00	32020		\N	111174	0	195662009	4112343		0
28093	1658	4283893	1914-11-19	1914-11-19 00:00:00	1914-12-24	1914-12-24 00:00:00	32020		\N	111340	0	36971009	4283893		0
28287	1672	4116491	1979-04-23	1979-04-23 00:00:00	1979-06-06	1979-06-06 00:00:00	32020		\N	112256	0	301011002	4116491		0
28488	1685	40481087	2005-07-17	2005-07-17 00:00:00	2005-07-31	2005-07-31 00:00:00	32020		\N	112913	0	444814009	40481087		0
18092	1086	40481087	1996-02-10	1996-02-10 00:00:00	1996-03-02	1996-03-02 00:00:00	32020		\N	71316	0	444814009	40481087		0
28767	1703	40481087	1953-03-03	1953-03-03 00:00:00	1953-03-10	1953-03-10 00:00:00	32020		\N	113905	0	444814009	40481087		0
28914	1713	40481087	1976-05-20	1976-05-20 00:00:00	1976-06-03	1976-06-03 00:00:00	32020		\N	114432	0	444814009	40481087		0
29066	1720	372328	1981-06-01	1981-06-01 00:00:00	1981-11-21	1981-11-21 00:00:00	32020		\N	115039	0	65363002	372328		0
29278	1733	40481087	2000-04-01	2000-04-01 00:00:00	2000-04-22	2000-04-22 00:00:00	32020		\N	115802	0	444814009	40481087		0
29400	1740	40481087	1975-07-27	1975-07-27 00:00:00	1975-08-03	1975-08-03 00:00:00	32020		\N	116262	0	444814009	40481087		0
29584	1751	260139	1988-02-21	1988-02-21 00:00:00	1988-02-28	1988-02-28 00:00:00	32020		\N	117057	0	10509002	260139		0
29726	1759	40481087	1999-02-21	1999-02-21 00:00:00	1999-03-07	1999-03-07 00:00:00	32020		\N	117624	0	444814009	40481087		0
29934	1770	4112343	1984-03-12	1984-03-12 00:00:00	1984-03-22	1984-03-22 00:00:00	32020		\N	118357	0	195662009	4112343		0
30148	1781	372328	1942-02-05	1942-02-05 00:00:00	1942-04-21	1942-04-21 00:00:00	32020		\N	119262	0	65363002	372328		0
30269	1788	40481087	2014-06-27	2014-06-27 00:00:00	2014-07-04	2014-07-04 00:00:00	32020		\N	119832	0	444814009	40481087		0
30539	1801	4155034	1963-12-01	1963-12-01 00:00:00	1963-12-22	1963-12-22 00:00:00	32020		\N	120749	0	283371005	4155034		0
30606	1808	372328	1979-04-18	1979-04-18 00:00:00	1979-09-25	1979-09-25 00:00:00	32020		\N	121021	0	65363002	372328		0
30779	1820	260139	2010-11-20	2010-11-20 00:00:00	2010-12-04	2010-12-04 00:00:00	32020		\N	121747	0	10509002	260139		0
30878	1826	4112343	1949-06-25	1949-06-25 00:00:00	1949-07-03	1949-07-03 00:00:00	32020		\N	121998	0	195662009	4112343		0
31112	1843	260139	2014-04-03	2014-04-03 00:00:00	2014-04-17	2014-04-17 00:00:00	32020		\N	123068	0	10509002	260139		0
31252	1848	260139	1960-08-23	1960-08-23 00:00:00	1960-09-06	1960-09-06 00:00:00	32020		\N	123593	0	10509002	260139		0
31422	1855	260139	1998-11-16	1998-11-16 00:00:00	1998-11-23	1998-11-23 00:00:00	32020		\N	124144	0	10509002	260139		0
21072	1265	40486433	1983-05-18	1983-05-18 00:00:00	1999-05-16	1999-05-16 00:00:00	32020		\N	83413	0	446096008	40486433		0
31832	1889	40481087	1995-05-02	1995-05-02 00:00:00	1995-05-23	1995-05-23 00:00:00	32020		\N	125945	0	444814009	40481087		0
21318	1280	28060	2016-12-14	2016-12-14 00:00:00	2016-12-23	2016-12-23 00:00:00	32020		\N	84536	0	43878008	28060		0
21542	1292	260139	1959-05-31	1959-05-31 00:00:00	1959-06-14	1959-06-14 00:00:00	32020		\N	85423	0	10509002	260139		0
21619	1297	260139	1983-09-18	1983-09-18 00:00:00	1983-10-02	1983-10-02 00:00:00	32020		\N	85707	0	10509002	260139		0
21840	1310	260139	1953-04-07	1953-04-07 00:00:00	1953-04-14	1953-04-14 00:00:00	32020		\N	86569	0	10509002	260139		0
21927	1314	28060	1977-01-01	1977-01-01 00:00:00	1977-01-12	1977-01-12 00:00:00	32020		\N	86988	0	43878008	28060		0
22168	1322	80180	1958-09-01	1958-09-01 00:00:00	\N	\N	32020		\N	87741	0	396275006	80180		0
22273	1328	381316	2019-06-13	2019-06-13 00:00:00	\N	\N	32020		\N	88175	0	230690007	381316		0
22455	1340	372328	1916-05-19	1916-05-19 00:00:00	1916-06-11	1916-06-11 00:00:00	32020		\N	88927	0	65363002	372328		0
22634	1352	28060	1951-09-21	1951-09-21 00:00:00	1951-10-01	1951-10-01 00:00:00	32020		\N	89536	0	43878008	28060		0
22810	1360	4285898	2018-05-12	2018-05-12 00:00:00	\N	\N	32020		\N	90241	0	68496003	4285898		0
12448	736	40481087	2003-04-29	2003-04-29 00:00:00	2003-05-20	2003-05-20 00:00:00	32020		\N	48843	0	444814009	40481087		0
23084	1378	372328	1949-09-22	1949-09-22 00:00:00	1950-01-10	1950-01-10 00:00:00	32020		\N	91381	0	65363002	372328		0
23286	1389	4112343	1995-02-01	1995-02-01 00:00:00	1995-02-11	1995-02-11 00:00:00	32020		\N	92219	0	195662009	4112343		0
23455	1399	4218389	2000-09-25	2000-09-25 00:00:00	2000-10-30	2000-10-30 00:00:00	32020		\N	93039	0	39848009	4218389		0
23626	1410	321042	2010-03-25	2010-03-25 00:00:00	\N	\N	32020		\N	93838	0	410429000	321042		0
23857	1426	4112343	1953-12-02	1953-12-02 00:00:00	1953-12-12	1953-12-12 00:00:00	32020		\N	94815	0	195662009	4112343		0
23910	1428	40481087	1996-05-08	1996-05-08 00:00:00	1996-05-22	1996-05-22 00:00:00	32020		\N	95048	0	444814009	40481087		0
24199	1442	40481087	1965-05-16	1965-05-16 00:00:00	1965-05-30	1965-05-30 00:00:00	32020		\N	96146	0	444814009	40481087		0
24313	1448	4112343	2008-11-28	2008-11-28 00:00:00	2008-12-07	2008-12-07 00:00:00	32020		\N	96604	0	195662009	4112343		0
13934	823	261325	2008-12-15	2008-12-15 00:00:00	\N	\N	32020		\N	54525	0	87433001	261325		0
24571	1467	4112343	1963-09-18	1963-09-18 00:00:00	1963-09-30	1963-09-30 00:00:00	32020		\N	97715	0	195662009	4112343		0
24813	1480	4278672	1973-07-13	1973-07-13 00:00:00	1973-10-11	1973-10-11 00:00:00	32020		\N	98759	0	65966004	4278672		0
24963	1490	4059173	1993-01-10	1993-01-10 00:00:00	1993-02-09	1993-02-09 00:00:00	32020		\N	99306	0	16114001	4059173		0
25091	1497	81151	1943-09-26	1943-09-26 00:00:00	1943-10-24	1943-10-24 00:00:00	32020		\N	99779	0	44465007	81151		0
25240	1506	80180	1985-08-06	1985-08-06 00:00:00	\N	\N	32020		\N	100478	0	396275006	80180		0
25487	1517	380378	1949-10-29	1949-10-29 00:00:00	\N	\N	32020		\N	101446	0	84757009	380378		0
25649	1525	4109685	2013-02-09	2013-02-09 00:00:00	2013-02-23	2013-02-23 00:00:00	32020		\N	102032	0	284551006	4109685		0
25836	1535	372328	1978-05-03	1978-05-03 00:00:00	1978-07-10	1978-07-10 00:00:00	32020		\N	102757	0	65363002	372328		0
25968	1540	4112343	1966-07-31	1966-07-31 00:00:00	1966-08-11	1966-08-11 00:00:00	32020		\N	103215	0	195662009	4112343		0
26113	1550	4278672	1981-02-07	1981-02-07 00:00:00	1981-05-08	1981-05-08 00:00:00	32020		\N	103802	0	65966004	4278672		0
26285	1560	372328	1941-09-28	1941-09-28 00:00:00	1942-01-05	1942-01-05 00:00:00	32020		\N	104505	0	65363002	372328		0
26397	1566	4283893	2009-12-27	2009-12-27 00:00:00	2010-03-14	2010-03-14 00:00:00	32020		\N	105036	0	36971009	4283893		0
26606	1576	40481087	1986-03-01	1986-03-01 00:00:00	1986-03-22	1986-03-22 00:00:00	32020		\N	105802	0	444814009	40481087		0
26784	1586	80180	1974-10-19	1974-10-19 00:00:00	\N	\N	32020		\N	106392	0	396275006	80180		0
26898	1593	40481087	2014-06-28	2014-06-28 00:00:00	2014-07-12	2014-07-12 00:00:00	32020		\N	106900	0	444814009	40481087		0
27073	1600	4142905	2013-09-01	2013-09-01 00:00:00	2013-10-31	2013-10-31 00:00:00	32020		\N	107367	0	33737001	4142905		0
27294	1609	81151	1960-11-01	1960-11-01 00:00:00	1960-12-06	1960-12-06 00:00:00	32020		\N	108161	0	44465007	81151		0
27505	1623	40481087	1951-04-08	1951-04-08 00:00:00	1951-04-22	1951-04-22 00:00:00	32020		\N	109130	0	444814009	40481087		0
27627	1632	40481087	1999-07-29	1999-07-29 00:00:00	1999-08-05	1999-08-05 00:00:00	32020		\N	109624	0	444814009	40481087		0
27833	1642	40481087	2000-07-06	2000-07-06 00:00:00	2000-07-27	2000-07-27 00:00:00	32020		\N	110222	0	444814009	40481087		0
28042	1658	4296204	1982-05-03	1982-05-03 00:00:00	1982-06-07	1982-06-07 00:00:00	32020		\N	111378	0	403190006	4296204		0
28094	1658	192671	1948-01-29	1948-01-29 00:00:00	\N	\N	32020		\N	111399	0	K92.2	35208414		0
28288	1672	260139	2001-08-17	2001-08-17 00:00:00	2001-08-31	2001-08-31 00:00:00	32020		\N	112243	0	10509002	260139		0
28489	1685	78272	1983-08-23	1983-08-23 00:00:00	1983-09-13	1983-09-13 00:00:00	32020		\N	112868	0	70704007	78272		0
18093	1086	4266809	2004-07-21	2004-07-21 00:00:00	\N	\N	32020		\N	71339	0	397881000	4266809		0
28768	1703	40479422	2019-05-11	2019-05-11 00:00:00	\N	\N	32020		\N	113933	0	444448004	40479422		0
28915	1713	4112343	1989-11-04	1989-11-04 00:00:00	1989-11-12	1989-11-12 00:00:00	32020		\N	114452	0	195662009	4112343		0
29067	1720	40481087	2000-08-27	2000-08-27 00:00:00	2000-09-03	2000-09-03 00:00:00	32020		\N	115008	0	444814009	40481087		0
29283	1736	260139	2011-10-24	2011-10-24 00:00:00	2011-11-07	2011-11-07 00:00:00	32020		\N	115920	0	10509002	260139		0
29401	1740	4155034	1961-06-21	1961-06-21 00:00:00	1961-07-12	1961-07-12 00:00:00	32020		\N	116291	0	283371005	4155034		0
29585	1751	4112343	1993-06-03	1993-06-03 00:00:00	1993-06-16	1993-06-16 00:00:00	32020		\N	117048	0	195662009	4112343		0
29727	1759	372328	1990-02-26	1990-02-26 00:00:00	1990-12-17	1990-12-17 00:00:00	32020		\N	117627	0	65363002	372328		0
29954	1773	40481087	1988-09-12	1988-09-12 00:00:00	1988-10-03	1988-10-03 00:00:00	32020		\N	118556	0	444814009	40481087		0
30149	1781	378001	1947-05-10	1947-05-10 00:00:00	1947-06-09	1947-06-09 00:00:00	32020		\N	119231	0	62106007	378001		0
30270	1788	40481087	1995-04-02	1995-04-02 00:00:00	1995-04-23	1995-04-23 00:00:00	32020		\N	119793	0	444814009	40481087		0
30540	1801	40481087	1997-08-07	1997-08-07 00:00:00	1997-08-14	1997-08-14 00:00:00	32020		\N	120733	0	444814009	40481087		0
30607	1808	260139	1971-08-03	1971-08-03 00:00:00	1971-08-10	1971-08-10 00:00:00	32020		\N	121028	0	10509002	260139		0
30780	1820	4112343	1986-08-08	1986-08-08 00:00:00	1986-08-15	1986-08-15 00:00:00	32020		\N	121739	0	195662009	4112343		0
30879	1826	4296204	1957-11-23	1957-11-23 00:00:00	1957-12-07	1957-12-07 00:00:00	32020		\N	122041	0	403190006	4296204		0
31113	1843	4112343	1994-08-12	1994-08-12 00:00:00	1994-08-20	1994-08-20 00:00:00	32020		\N	123013	0	195662009	4112343		0
31253	1848	4266809	1982-09-25	1982-09-25 00:00:00	\N	\N	32020		\N	123685	0	397881000	4266809		0
31455	1860	4112343	1978-08-26	1978-08-26 00:00:00	1978-09-06	1978-09-06 00:00:00	32020		\N	124358	0	195662009	4112343		0
21073	1265	40481087	1983-02-04	1983-02-04 00:00:00	1983-02-11	1983-02-11 00:00:00	32020		\N	83412	0	444814009	40481087		0
31833	1889	4113008	1994-06-18	1994-06-18 00:00:00	1994-07-02	1994-07-02 00:00:00	32020		\N	125915	0	284549007	4113008		0
21319	1280	40481087	1996-11-22	1996-11-22 00:00:00	1996-12-13	1996-12-13 00:00:00	32020		\N	84618	0	444814009	40481087		0
21543	1292	4156265	1972-02-26	1972-02-26 00:00:00	1972-03-11	1972-03-11 00:00:00	32020		\N	85414	0	370247008	4156265		0
21620	1297	40481087	1979-08-15	1979-08-15 00:00:00	1979-08-22	1979-08-22 00:00:00	32020		\N	85704	0	444814009	40481087		0
21841	1310	260139	1959-07-17	1959-07-17 00:00:00	1959-07-24	1959-07-24 00:00:00	32020		\N	86682	0	10509002	260139		0
21928	1314	40481087	2000-07-29	2000-07-29 00:00:00	2000-08-19	2000-08-19 00:00:00	32020		\N	87012	0	444814009	40481087		0
22169	1322	260139	1957-02-07	1957-02-07 00:00:00	1957-02-14	1957-02-14 00:00:00	32020		\N	87741	0	10509002	260139		0
22274	1328	4112343	1951-11-09	1951-11-09 00:00:00	1951-11-17	1951-11-17 00:00:00	32020		\N	88176	0	195662009	4112343		0
22456	1340	40481087	1962-07-17	1962-07-17 00:00:00	1962-07-31	1962-07-31 00:00:00	32020		\N	88926	0	444814009	40481087		0
22635	1352	40481087	1999-03-13	1999-03-13 00:00:00	1999-04-03	1999-04-03 00:00:00	32020		\N	89535	0	444814009	40481087		0
22811	1360	4266809	2018-06-11	2018-06-11 00:00:00	\N	\N	32020		\N	90241	0	397881000	4266809		0
12449	736	40481087	2011-03-26	2011-03-26 00:00:00	2011-04-09	2011-04-09 00:00:00	32020		\N	48845	0	444814009	40481087		0
23085	1378	378001	2010-10-12	2010-10-12 00:00:00	2010-11-11	2010-11-11 00:00:00	32020		\N	91319	0	62106007	378001		0
23287	1389	80180	1997-07-12	1997-07-12 00:00:00	\N	\N	32020		\N	92165	0	396275006	80180		0
23456	1401	4152936	1989-11-28	1989-11-28 00:00:00	1989-12-12	1989-12-12 00:00:00	32020		\N	93179	0	283385000	4152936		0
23627	1410	40481087	1983-10-27	1983-10-27 00:00:00	1983-11-16	1983-11-16 00:00:00	32020		\N	93874	0	444814009	40481087		0
23858	1426	40481087	2001-04-29	2001-04-29 00:00:00	2001-05-06	2001-05-06 00:00:00	32020		\N	94882	0	444814009	40481087		0
23911	1428	260139	1954-02-03	1954-02-03 00:00:00	1954-02-17	1954-02-17 00:00:00	32020		\N	95009	0	10509002	260139		0
24200	1442	4112343	1965-06-07	1965-06-07 00:00:00	1965-06-20	1965-06-20 00:00:00	32020		\N	96105	0	195662009	4112343		0
24314	1448	4112343	1986-04-05	1986-04-05 00:00:00	1986-04-14	1986-04-14 00:00:00	32020		\N	96631	0	195662009	4112343		0
13935	823	40481087	1971-11-15	1971-11-15 00:00:00	1971-11-29	1971-11-29 00:00:00	32020		\N	54551	0	444814009	40481087		0
24572	1467	4112343	1966-09-15	1966-09-15 00:00:00	1966-09-22	1966-09-22 00:00:00	32020		\N	97716	0	195662009	4112343		0
24814	1480	260139	1989-05-06	1989-05-06 00:00:00	1989-05-13	1989-05-13 00:00:00	32020		\N	98705	0	10509002	260139		0
24964	1491	4155034	2001-06-06	2001-06-06 00:00:00	2001-06-27	2001-06-27 00:00:00	32020		\N	99455	0	283371005	4155034		0
25092	1497	4278672	2007-02-18	2007-02-18 00:00:00	2007-03-20	2007-03-20 00:00:00	32020		\N	99782	0	65966004	4278672		0
25241	1506	4112343	1958-08-28	1958-08-28 00:00:00	1958-09-07	1958-09-07 00:00:00	32020		\N	100397	0	195662009	4112343		0
25489	1517	4029498	1949-10-29	1949-10-29 00:00:00	\N	\N	32020		\N	101446	0	128613002	4029498		0
25650	1525	260139	1977-07-20	1977-07-20 00:00:00	1977-07-27	1977-07-27 00:00:00	32020		\N	101964	0	10509002	260139		0
25837	1535	372328	1999-12-26	1999-12-26 00:00:00	2001-04-09	2001-04-09 00:00:00	32020		\N	102705	0	65363002	372328		0
25969	1540	40481087	1987-06-09	1987-06-09 00:00:00	1987-06-16	1987-06-16 00:00:00	32020		\N	103170	0	444814009	40481087		0
26114	1550	40481087	1974-12-05	1974-12-05 00:00:00	1974-12-19	1974-12-19 00:00:00	32020		\N	103754	0	444814009	40481087		0
26286	1560	4283893	1960-09-16	1960-09-16 00:00:00	1960-10-28	1960-10-28 00:00:00	32020		\N	104441	0	36971009	4283893		0
26398	1566	4142905	1970-08-20	1970-08-20 00:00:00	1970-09-19	1970-09-19 00:00:00	32020		\N	104982	0	33737001	4142905		0
26607	1576	192671	2007-06-28	2007-06-28 00:00:00	\N	\N	32020		\N	105773	0	K92.2	35208414		0
26785	1586	260139	1972-07-10	1972-07-10 00:00:00	1972-07-24	1972-07-24 00:00:00	32020		\N	106392	0	10509002	260139		0
26899	1593	260139	2014-09-22	2014-09-22 00:00:00	2014-09-29	2014-09-29 00:00:00	32020		\N	106893	0	10509002	260139		0
27074	1600	40481087	1981-05-01	1981-05-01 00:00:00	1981-05-08	1981-05-08 00:00:00	32020		\N	107435	0	444814009	40481087		0
27295	1609	40481087	1977-04-07	1977-04-07 00:00:00	1977-04-21	1977-04-21 00:00:00	32020		\N	108178	0	444814009	40481087		0
27506	1623	4294548	1984-06-21	1984-06-21 00:00:00	1984-10-11	1984-10-11 00:00:00	32020		\N	109081	0	75498004	4294548		0
27628	1632	260139	1958-05-18	1958-05-18 00:00:00	1958-06-01	1958-06-01 00:00:00	32020		\N	109586	0	10509002	260139		0
27834	1642	372328	1951-11-18	1951-11-18 00:00:00	1952-02-05	1952-02-05 00:00:00	32020		\N	110203	0	65363002	372328		0
28043	1658	40481087	1957-04-11	1957-04-11 00:00:00	1957-04-25	1957-04-25 00:00:00	32020		\N	111324	0	444814009	40481087		0
28095	1658	40481087	1951-05-31	1951-05-31 00:00:00	1951-06-07	1951-06-07 00:00:00	32020		\N	111389	0	444814009	40481087		0
28289	1672	4112343	1974-06-11	1974-06-11 00:00:00	1974-06-20	1974-06-20 00:00:00	32020		\N	112255	0	195662009	4112343		0
28490	1686	372328	1964-08-30	1964-08-30 00:00:00	1965-02-21	1965-02-21 00:00:00	32020		\N	112975	0	65363002	372328		0
18094	1086	4112343	2004-04-05	2004-04-05 00:00:00	2004-04-18	2004-04-18 00:00:00	32020		\N	71339	0	195662009	4112343		0
28769	1703	4112343	1995-09-06	1995-09-06 00:00:00	1995-09-19	1995-09-19 00:00:00	32020		\N	113863	0	195662009	4112343		0
28916	1713	40481087	2004-12-22	2004-12-22 00:00:00	2004-12-29	2004-12-29 00:00:00	32020		\N	114436	0	444814009	40481087		0
29068	1720	81151	2007-10-30	2007-10-30 00:00:00	2007-12-04	2007-12-04 00:00:00	32020		\N	115002	0	44465007	81151		0
29284	1736	4056621	1989-09-20	1989-09-20 00:00:00	\N	\N	32020		\N	115899	0	197927001	4056621		0
29402	1740	40481087	2010-09-25	2010-09-25 00:00:00	2010-10-16	2010-10-16 00:00:00	32020		\N	116266	0	444814009	40481087		0
29586	1751	78272	2013-01-14	2013-01-14 00:00:00	2013-02-18	2013-02-18 00:00:00	32020		\N	117082	0	70704007	78272		0
29728	1759	192671	2019-04-03	2019-04-03 00:00:00	\N	\N	32020		\N	117574	0	K92.2	35208414		0
29955	1773	40481087	1999-06-14	1999-06-14 00:00:00	1999-06-21	1999-06-21 00:00:00	32020		\N	118514	0	444814009	40481087		0
30150	1781	4112343	1962-03-16	1962-03-16 00:00:00	1962-03-27	1962-03-27 00:00:00	32020		\N	119198	0	195662009	4112343		0
30271	1788	260139	2010-03-09	2010-03-09 00:00:00	2010-03-16	2010-03-16 00:00:00	32020		\N	119813	0	10509002	260139		0
30541	1801	4112343	2011-02-15	2011-02-15 00:00:00	2011-02-25	2011-02-25 00:00:00	32020		\N	120762	0	195662009	4112343		0
30608	1808	78272	2018-07-29	2018-07-29 00:00:00	2018-08-19	2018-08-19 00:00:00	32020		\N	121087	0	70704007	78272		0
30781	1820	4294548	2015-07-14	2015-07-14 00:00:00	2015-08-04	2015-08-04 00:00:00	32020		\N	121748	0	75498004	4294548		0
30880	1826	4112343	1945-08-02	1945-08-02 00:00:00	1945-08-13	1945-08-13 00:00:00	32020		\N	121997	0	195662009	4112343		0
31114	1843	4112343	1986-05-28	1986-05-28 00:00:00	1986-06-07	1986-06-07 00:00:00	32020		\N	123056	0	195662009	4112343		0
31254	1848	80180	1982-09-25	1982-09-25 00:00:00	\N	\N	32020		\N	123685	0	396275006	80180		0
31456	1860	4146173	1979-10-07	1979-10-07 00:00:00	1979-11-06	1979-11-06 00:00:00	32020		\N	124373	0	307731004	4146173		0
21074	1265	40481087	1987-12-23	1987-12-23 00:00:00	1988-01-13	1988-01-13 00:00:00	32020		\N	83419	0	444814009	40481087		0
31834	1889	4109685	2015-10-31	2015-10-31 00:00:00	2015-11-21	2015-11-21 00:00:00	32020		\N	125917	0	284551006	4109685		0
21320	1280	80180	1988-03-11	1988-03-11 00:00:00	\N	\N	32020		\N	84566	0	396275006	80180		0
21544	1292	4084167	1963-06-14	1963-06-14 00:00:00	1963-06-14	1963-06-14 00:00:00	32020		\N	85413	0	241929008	4084167		0
21621	1297	260139	2011-06-30	2011-06-30 00:00:00	2011-07-07	2011-07-07 00:00:00	32020		\N	85713	0	10509002	260139		0
21842	1310	4112343	1951-07-04	1951-07-04 00:00:00	1951-07-15	1951-07-15 00:00:00	32020		\N	86568	0	195662009	4112343		0
21929	1314	40481087	1970-06-07	1970-06-07 00:00:00	1970-06-21	1970-06-21 00:00:00	32020		\N	87036	0	444814009	40481087		0
22170	1322	40481087	1982-10-24	1982-10-24 00:00:00	1982-11-07	1982-11-07 00:00:00	32020		\N	87719	0	444814009	40481087		0
22275	1328	78272	1995-02-21	1995-02-21 00:00:00	1995-03-07	1995-03-07 00:00:00	32020		\N	88158	0	70704007	78272		0
22457	1340	4112343	1912-09-23	1912-09-23 00:00:00	1912-10-05	1912-10-05 00:00:00	32020		\N	88874	0	195662009	4112343		0
22636	1352	40481087	1983-09-26	1983-09-26 00:00:00	1983-10-10	1983-10-10 00:00:00	32020		\N	89592	0	444814009	40481087		0
22812	1360	80180	2018-06-11	2018-06-11 00:00:00	\N	\N	32020		\N	90241	0	396275006	80180		0
12450	736	4027663	1999-12-30	1999-12-30 00:00:00	\N	\N	32020		\N	48840	0	13200003	4027663		0
23086	1378	260139	2017-07-18	2017-07-18 00:00:00	2017-08-01	2017-08-01 00:00:00	32020		\N	91418	0	10509002	260139		0
23288	1389	28060	2012-03-28	2012-03-28 00:00:00	2012-04-04	2012-04-04 00:00:00	32020		\N	92222	0	43878008	28060		0
23457	1401	40481087	2001-08-09	2001-08-09 00:00:00	2001-08-23	2001-08-23 00:00:00	32020		\N	93155	0	444814009	40481087		0
23628	1410	260139	1991-12-05	1991-12-05 00:00:00	1991-12-19	1991-12-19 00:00:00	32020		\N	93904	0	10509002	260139		0
23859	1426	40481087	2014-09-03	2014-09-03 00:00:00	2014-09-24	2014-09-24 00:00:00	32020		\N	94810	0	444814009	40481087		0
23912	1428	4278672	1998-06-05	1998-06-05 00:00:00	1998-08-04	1998-08-04 00:00:00	32020		\N	95043	0	65966004	4278672		0
24201	1442	78272	2017-06-13	2017-06-13 00:00:00	2017-06-27	2017-06-27 00:00:00	32020		\N	96189	0	70704007	78272		0
24315	1448	4283893	1991-01-27	1991-01-27 00:00:00	1991-03-03	1991-03-03 00:00:00	32020		\N	96587	0	36971009	4283893		0
13936	823	28060	2011-01-13	2011-01-13 00:00:00	2011-01-24	2011-01-24 00:00:00	32020		\N	54589	0	43878008	28060		0
24573	1467	40481087	1950-05-15	1950-05-15 00:00:00	1950-06-05	1950-06-05 00:00:00	32020		\N	97713	0	444814009	40481087		0
24815	1480	4112343	1993-01-24	1993-01-24 00:00:00	1993-02-02	1993-02-02 00:00:00	32020		\N	98708	0	195662009	4112343		0
24965	1491	40481087	1983-06-11	1983-06-11 00:00:00	1983-07-02	1983-07-02 00:00:00	32020		\N	99404	0	444814009	40481087		0
25093	1497	4084167	1941-05-09	1941-05-09 00:00:00	1941-05-10	1941-05-10 00:00:00	32020		\N	99778	0	241929008	4084167		0
25242	1506	257012	1986-10-19	1986-10-19 00:00:00	\N	\N	32020		\N	100415	0	40055000	257012		0
25490	1517	28060	1996-04-27	1996-04-27 00:00:00	1996-05-05	1996-05-05 00:00:00	32020		\N	101457	0	43878008	28060		0
25651	1525	4112343	1999-02-19	1999-02-19 00:00:00	1999-02-26	1999-02-26 00:00:00	32020		\N	101990	0	195662009	4112343		0
25838	1535	4112343	2012-07-06	2012-07-06 00:00:00	2012-07-16	2012-07-16 00:00:00	32020		\N	102761	0	195662009	4112343		0
25970	1540	4027663	1987-07-21	1987-07-21 00:00:00	\N	\N	32020		\N	103170	0	13200003	4027663		0
26115	1550	40481087	2014-11-13	2014-11-13 00:00:00	2014-12-04	2014-12-04 00:00:00	32020		\N	103807	0	444814009	40481087		0
26287	1560	40481087	1994-12-15	1994-12-15 00:00:00	1995-01-05	1995-01-05 00:00:00	32020		\N	104442	0	444814009	40481087		0
26399	1566	81151	1979-10-02	1979-10-02 00:00:00	1979-10-30	1979-10-30 00:00:00	32020		\N	105010	0	44465007	81151		0
26608	1576	40481087	2002-01-02	2002-01-02 00:00:00	2002-01-16	2002-01-16 00:00:00	32020		\N	105783	0	444814009	40481087		0
26786	1586	4152936	1961-04-13	1961-04-13 00:00:00	1961-04-27	1961-04-27 00:00:00	32020		\N	106387	0	283385000	4152936		0
26900	1593	378001	1952-07-06	1952-07-06 00:00:00	1952-08-05	1952-08-05 00:00:00	32020		\N	106841	0	62106007	378001		0
27075	1600	4156265	2008-03-10	2008-03-10 00:00:00	2008-03-31	2008-03-31 00:00:00	32020		\N	107366	0	370247008	4156265		0
27296	1609	40481087	1946-12-08	1946-12-08 00:00:00	1946-12-15	1946-12-15 00:00:00	32020		\N	108166	0	444814009	40481087		0
27507	1623	40481087	1953-12-16	1953-12-16 00:00:00	1953-12-30	1953-12-30 00:00:00	32020		\N	109132	0	444814009	40481087		0
27629	1632	81151	1976-10-09	1976-10-09 00:00:00	1976-11-05	1976-11-05 00:00:00	32020		\N	109550	0	44465007	81151		0
27835	1642	4296205	1981-08-12	1981-08-12 00:00:00	1981-08-26	1981-08-26 00:00:00	32020		\N	110201	0	403191005	4296205		0
28044	1658	4112343	1989-09-03	1989-09-03 00:00:00	1989-09-16	1989-09-16 00:00:00	32020		\N	111344	0	195662009	4112343		0
28096	1658	28060	1926-06-21	1926-06-21 00:00:00	1926-06-29	1926-06-29 00:00:00	32020		\N	111342	0	43878008	28060		0
28290	1672	28060	2006-02-03	2006-02-03 00:00:00	2006-02-11	2006-02-11 00:00:00	32020		\N	112250	0	43878008	28060		0
28491	1686	81151	1978-03-20	1978-03-20 00:00:00	1978-04-24	1978-04-24 00:00:00	32020		\N	112989	0	44465007	81151		0
28553	1689	40481087	2007-05-02	2007-05-02 00:00:00	2007-05-09	2007-05-09 00:00:00	32020		\N	113070	0	444814009	40481087		0
28770	1703	4278672	1954-11-10	1954-11-10 00:00:00	1955-02-08	1955-02-08 00:00:00	32020		\N	113925	0	65966004	4278672		0
28917	1713	80180	2010-05-14	2010-05-14 00:00:00	\N	\N	32020		\N	114450	0	396275006	80180		0
29069	1720	40481087	1980-09-29	1980-09-29 00:00:00	1980-10-13	1980-10-13 00:00:00	32020		\N	115037	0	444814009	40481087		0
29285	1736	4116491	1989-09-20	1989-09-20 00:00:00	1989-11-03	1989-11-03 00:00:00	32020		\N	115899	0	301011002	4116491		0
29403	1740	260139	1962-10-16	1962-10-16 00:00:00	1962-10-23	1962-10-23 00:00:00	32020		\N	116304	0	10509002	260139		0
29587	1751	81151	1999-04-23	1999-04-23 00:00:00	1999-05-14	1999-05-14 00:00:00	32020		\N	117080	0	44465007	81151		0
29729	1760	81151	2005-02-22	2005-02-22 00:00:00	2005-03-29	2005-03-29 00:00:00	32020		\N	117689	0	44465007	81151		0
29956	1773	4218389	1966-08-07	1966-08-07 00:00:00	1966-08-28	1966-08-28 00:00:00	32020		\N	118550	0	39848009	4218389		0
30151	1781	28060	1941-08-11	1941-08-11 00:00:00	1941-08-19	1941-08-19 00:00:00	32020		\N	119194	0	43878008	28060		0
30272	1788	4294548	1982-12-03	1982-12-03 00:00:00	1983-01-07	1983-01-07 00:00:00	32020		\N	119792	0	75498004	4294548		0
30542	1801	313217	2007-08-08	2007-08-08 00:00:00	\N	\N	32020		\N	120779	0	49436004	313217		0
30609	1808	4112343	2016-01-19	2016-01-19 00:00:00	2016-01-28	2016-01-28 00:00:00	32020		\N	121024	0	195662009	4112343		0
30783	1820	40481087	1987-07-08	1987-07-08 00:00:00	1987-07-22	1987-07-22 00:00:00	32020		\N	121744	0	444814009	40481087		0
30881	1826	372328	1940-01-27	1940-01-27 00:00:00	1940-02-10	1940-02-10 00:00:00	32020		\N	122046	0	65363002	372328		0
31115	1843	4237458	1997-03-17	1997-03-17 00:00:00	1997-05-16	1997-05-16 00:00:00	32020		\N	123011	0	58150001	4237458		0
31255	1848	195588	1981-10-12	1981-10-12 00:00:00	1981-11-14	1981-11-14 00:00:00	32020		\N	123685	0	38822007	195588		0
31457	1860	378001	1987-03-29	1987-03-29 00:00:00	1987-04-28	1987-04-28 00:00:00	32020		\N	124405	0	62106007	378001		0
21075	1265	40481087	1994-02-08	1994-02-08 00:00:00	1994-02-15	1994-02-15 00:00:00	32020		\N	83404	0	444814009	40481087		0
31835	1889	4109685	2009-04-14	2009-04-14 00:00:00	2009-05-05	2009-05-05 00:00:00	32020		\N	125916	0	284551006	4109685		0
21321	1280	4112343	1990-04-05	1990-04-05 00:00:00	1990-04-18	1990-04-18 00:00:00	32020		\N	84617	0	195662009	4112343		0
21545	1292	40481087	1974-11-14	1974-11-14 00:00:00	1974-12-05	1974-12-05 00:00:00	32020		\N	85421	0	444814009	40481087		0
21622	1297	4112343	2002-02-09	2002-02-09 00:00:00	2002-02-22	2002-02-22 00:00:00	32020		\N	85719	0	195662009	4112343		0
21843	1310	260139	1944-02-11	1944-02-11 00:00:00	1944-02-25	1944-02-25 00:00:00	32020		\N	86561	0	10509002	260139		0
21930	1315	4027663	1988-06-01	1988-06-01 00:00:00	\N	\N	32020		\N	87111	0	13200003	4027663		0
22171	1323	78272	2018-06-18	2018-06-18 00:00:00	2018-07-16	2018-07-16 00:00:00	32020		\N	87850	0	70704007	78272		0
22292	1332	4296204	1970-08-14	1970-08-14 00:00:00	1970-09-04	1970-09-04 00:00:00	32020		\N	88318	0	403190006	4296204		0
22458	1340	80180	1952-01-31	1952-01-31 00:00:00	\N	\N	32020		\N	88885	0	396275006	80180		0
22637	1353	260139	2017-04-18	2017-04-18 00:00:00	2017-04-25	2017-04-25 00:00:00	32020		\N	89664	0	10509002	260139		0
22813	1360	257012	1976-07-20	1976-07-20 00:00:00	\N	\N	32020		\N	90232	0	40055000	257012		0
22909	1367	40481087	1990-11-24	1990-11-24 00:00:00	1990-12-08	1990-12-08 00:00:00	32020		\N	90630	0	444814009	40481087		0
23087	1378	4112343	1957-03-18	1957-03-18 00:00:00	1957-03-27	1957-03-27 00:00:00	32020		\N	91363	0	195662009	4112343		0
23289	1389	40481087	1999-07-03	1999-07-03 00:00:00	1999-07-24	1999-07-24 00:00:00	32020		\N	92220	0	444814009	40481087		0
23458	1401	40481087	1986-03-04	1986-03-04 00:00:00	1986-03-11	1986-03-11 00:00:00	32020		\N	93140	0	444814009	40481087		0
23629	1410	28060	1973-02-24	1973-02-24 00:00:00	1973-03-04	1973-03-04 00:00:00	32020		\N	93848	0	43878008	28060		0
23860	1426	372328	1954-04-30	1954-04-30 00:00:00	1954-08-17	1954-08-17 00:00:00	32020		\N	94811	0	65363002	372328		0
23927	1430	78272	2010-01-01	2010-01-01 00:00:00	2010-01-22	2010-01-22 00:00:00	32020		\N	95184	0	70704007	78272		0
24202	1442	260139	1955-01-21	1955-01-21 00:00:00	1955-02-04	1955-02-04 00:00:00	32020		\N	96142	0	10509002	260139		0
24316	1448	260139	1973-12-24	1973-12-24 00:00:00	1974-01-07	1974-01-07 00:00:00	32020		\N	96586	0	10509002	260139		0
13937	823	378001	1954-07-22	1954-07-22 00:00:00	1954-08-21	1954-08-21 00:00:00	32020		\N	54545	0	62106007	378001		0
24574	1467	40481087	1940-08-23	1940-08-23 00:00:00	1940-09-06	1940-09-06 00:00:00	32020		\N	97755	0	444814009	40481087		0
24816	1480	440086	1975-01-19	1975-01-19 00:00:00	1975-02-16	1975-02-16 00:00:00	32020		\N	98753	0	192127007	440086		0
24967	1491	4329847	2011-07-12	2011-07-12 00:00:00	\N	\N	32020		\N	99456	0	22298006	4329847		0
25094	1497	4283893	1984-11-10	1984-11-10 00:00:00	1984-12-22	1984-12-22 00:00:00	32020		\N	99862	0	36971009	4283893		0
25243	1506	28060	1972-09-05	1972-09-05 00:00:00	1972-09-15	1972-09-15 00:00:00	32020		\N	100398	0	43878008	28060		0
25491	1517	4035415	2013-02-09	2013-02-09 00:00:00	2013-03-11	2013-03-11 00:00:00	32020		\N	101448	0	239720000	4035415		0
25652	1525	4310024	1996-11-20	1996-11-20 00:00:00	\N	\N	32020		\N	101989	0	424802006	4310024		0
25839	1535	4230399	2008-02-16	2008-02-16 00:00:00	2008-05-16	2008-05-16 00:00:00	32020		\N	102748	0	359817006	4230399		0
25971	1540	40481087	1964-01-04	1964-01-04 00:00:00	1964-01-11	1964-01-11 00:00:00	32020		\N	103167	0	444814009	40481087		0
26116	1550	4112343	1982-12-21	1982-12-21 00:00:00	1983-01-01	1983-01-01 00:00:00	32020		\N	103766	0	195662009	4112343		0
26288	1560	40481087	1968-08-07	1968-08-07 00:00:00	1968-08-14	1968-08-14 00:00:00	32020		\N	104449	0	444814009	40481087		0
26400	1566	40481087	1994-08-31	1994-08-31 00:00:00	1994-09-07	1994-09-07 00:00:00	32020		\N	105059	0	444814009	40481087		0
26609	1576	4027663	1999-09-29	1999-09-29 00:00:00	\N	\N	32020		\N	105794	0	13200003	4027663		0
26787	1586	4112343	2003-07-27	2003-07-27 00:00:00	2003-08-05	2003-08-05 00:00:00	32020		\N	106398	0	195662009	4112343		0
26901	1593	4112343	1955-02-04	1955-02-04 00:00:00	1955-02-11	1955-02-11 00:00:00	32020		\N	106862	0	195662009	4112343		0
27085	1602	4294548	2005-02-11	2005-02-11 00:00:00	2005-03-18	2005-03-18 00:00:00	32020		\N	107559	0	75498004	4294548		0
27297	1609	4084167	1959-07-29	1959-07-29 00:00:00	1959-07-29	1959-07-29 00:00:00	32020		\N	108160	0	241929008	4084167		0
27508	1623	81151	1968-01-14	1968-01-14 00:00:00	1968-02-04	1968-02-04 00:00:00	32020		\N	109138	0	44465007	81151		0
27630	1632	28060	1966-02-18	1966-02-18 00:00:00	1966-02-27	1966-02-27 00:00:00	32020		\N	109588	0	43878008	28060		0
27836	1642	40481087	2004-01-13	2004-01-13 00:00:00	2004-02-03	2004-02-03 00:00:00	32020		\N	110202	0	444814009	40481087		0
28045	1658	4112343	1982-07-02	1982-07-02 00:00:00	1982-07-11	1982-07-11 00:00:00	32020		\N	111319	0	195662009	4112343		0
28097	1658	40481087	1943-12-28	1943-12-28 00:00:00	1944-01-04	1944-01-04 00:00:00	32020		\N	111413	0	444814009	40481087		0
28291	1672	40481087	1984-03-24	1984-03-24 00:00:00	1984-04-07	1984-04-07 00:00:00	32020		\N	112249	0	444814009	40481087		0
28492	1686	257012	1998-06-07	1998-06-07 00:00:00	\N	\N	32020		\N	112923	0	40055000	257012		0
28554	1689	40481087	2008-02-12	2008-02-12 00:00:00	2008-02-26	2008-02-26 00:00:00	32020		\N	113071	0	444814009	40481087		0
28771	1703	4296204	1956-01-04	1956-01-04 00:00:00	1956-01-25	1956-01-25 00:00:00	32020		\N	113926	0	403190006	4296204		0
28918	1713	4266809	2010-05-14	2010-05-14 00:00:00	\N	\N	32020		\N	114450	0	397881000	4266809		0
29070	1720	4278672	1998-03-21	1998-03-21 00:00:00	1998-06-19	1998-06-19 00:00:00	32020		\N	115001	0	65966004	4278672		0
29286	1736	4283893	1975-10-11	1975-10-11 00:00:00	1976-05-08	1976-05-08 00:00:00	32020		\N	115951	0	36971009	4283893		0
29404	1740	40481087	1968-05-22	1968-05-22 00:00:00	1968-05-29	1968-05-29 00:00:00	32020		\N	116261	0	444814009	40481087		0
29588	1751	80180	2017-09-08	2017-09-08 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
29730	1760	28060	1993-03-19	1993-03-19 00:00:00	1993-03-31	1993-03-31 00:00:00	32020		\N	117693	0	43878008	28060		0
29957	1773	4112343	1967-05-19	1967-05-19 00:00:00	1967-05-29	1967-05-29 00:00:00	32020		\N	118571	0	195662009	4112343		0
30152	1781	80180	1975-09-15	1975-09-15 00:00:00	\N	\N	32020		\N	119267	0	396275006	80180		0
30273	1788	40481087	2006-07-17	2006-07-17 00:00:00	2006-08-07	2006-08-07 00:00:00	32020		\N	119829	0	444814009	40481087		0
30543	1801	4155034	1996-12-19	1996-12-19 00:00:00	1997-01-02	1997-01-02 00:00:00	32020		\N	120753	0	283371005	4155034		0
30610	1808	40481087	1981-06-27	1981-06-27 00:00:00	1981-07-04	1981-07-04 00:00:00	32020		\N	121072	0	444814009	40481087		0
30784	1820	4112343	1999-02-09	1999-02-09 00:00:00	1999-02-19	1999-02-19 00:00:00	32020		\N	121745	0	195662009	4112343		0
30882	1826	40481087	1978-09-21	1978-09-21 00:00:00	1978-10-12	1978-10-12 00:00:00	32020		\N	122065	0	444814009	40481087		0
31116	1843	4155034	1984-08-03	1984-08-03 00:00:00	1984-08-17	1984-08-17 00:00:00	32020		\N	123008	0	283371005	4155034		0
31256	1848	30753	1981-10-30	1981-10-30 00:00:00	\N	\N	32020		\N	123685	0	16761005	30753		0
31458	1860	4112343	1991-07-14	1991-07-14 00:00:00	1991-07-22	1991-07-22 00:00:00	32020		\N	124383	0	195662009	4112343		0
21076	1265	40481087	1989-12-09	1989-12-09 00:00:00	1989-12-23	1989-12-23 00:00:00	32020		\N	83414	0	444814009	40481087		0
31844	1892	4112343	1979-11-19	1979-11-19 00:00:00	1979-11-27	1979-11-27 00:00:00	32020		\N	126026	0	195662009	4112343		0
21322	1280	4112343	1952-03-03	1952-03-03 00:00:00	1952-03-10	1952-03-10 00:00:00	32020		\N	84572	0	195662009	4112343		0
21546	1292	4112343	1965-10-09	1965-10-09 00:00:00	1965-10-19	1965-10-19 00:00:00	32020		\N	85425	0	195662009	4112343		0
21686	1303	260139	1981-11-03	1981-11-03 00:00:00	1981-11-17	1981-11-17 00:00:00	32020		\N	86062	0	10509002	260139		0
21844	1310	260139	1945-04-11	1945-04-11 00:00:00	1945-04-18	1945-04-18 00:00:00	32020		\N	86566	0	10509002	260139		0
21931	1315	4155034	1964-05-25	1964-05-25 00:00:00	1964-06-08	1964-06-08 00:00:00	32020		\N	87106	0	283371005	4155034		0
22172	1323	4112343	2017-12-18	2017-12-18 00:00:00	2017-12-30	2017-12-30 00:00:00	32020		\N	87808	0	195662009	4112343		0
22293	1332	260139	1999-12-14	1999-12-14 00:00:00	1999-12-21	1999-12-21 00:00:00	32020		\N	88368	0	10509002	260139		0
22459	1340	4152936	1975-03-01	1975-03-01 00:00:00	1975-03-22	1975-03-22 00:00:00	32020		\N	88845	0	283385000	4152936		0
22638	1353	40481087	2006-02-19	2006-02-19 00:00:00	2006-03-12	2006-03-12 00:00:00	32020		\N	89702	0	444814009	40481087		0
22814	1360	81893	2017-02-16	2017-02-16 00:00:00	\N	\N	32020		\N	90252	0	64766004	81893		0
22910	1367	257012	2006-06-11	2006-06-11 00:00:00	\N	\N	32020		\N	90590	0	40055000	257012		0
23088	1378	28060	1962-10-29	1962-10-29 00:00:00	1962-11-05	1962-11-05 00:00:00	32020		\N	91432	0	43878008	28060		0
23290	1389	40481087	1986-01-05	1986-01-05 00:00:00	1986-01-12	1986-01-12 00:00:00	32020		\N	92163	0	444814009	40481087		0
23459	1401	4112343	1996-06-26	1996-06-26 00:00:00	1996-07-09	1996-07-09 00:00:00	32020		\N	93136	0	195662009	4112343		0
23630	1410	40481087	2004-08-07	2004-08-07 00:00:00	2004-08-28	2004-08-28 00:00:00	32020		\N	93896	0	444814009	40481087		0
23861	1426	4112343	1970-07-09	1970-07-09 00:00:00	1970-07-21	1970-07-21 00:00:00	32020		\N	94817	0	195662009	4112343		0
23928	1430	4113008	1986-04-25	1986-04-25 00:00:00	1986-05-09	1986-05-09 00:00:00	32020		\N	95182	0	284549007	4113008		0
24203	1442	40481087	1970-02-12	1970-02-12 00:00:00	1970-02-26	1970-02-26 00:00:00	32020		\N	96176	0	444814009	40481087		0
24329	1450	260139	1991-12-31	1991-12-31 00:00:00	1992-01-14	1992-01-14 00:00:00	32020		\N	96714	0	10509002	260139		0
13938	823	40481087	2008-07-05	2008-07-05 00:00:00	2008-07-26	2008-07-26 00:00:00	32020		\N	54588	0	444814009	40481087		0
24575	1467	4112343	1962-07-12	1962-07-12 00:00:00	1962-07-23	1962-07-23 00:00:00	32020		\N	97777	0	195662009	4112343		0
24817	1480	260139	2006-04-11	2006-04-11 00:00:00	2006-04-18	2006-04-18 00:00:00	32020		\N	98720	0	10509002	260139		0
24968	1491	257012	2005-10-08	2005-10-08 00:00:00	\N	\N	32020		\N	99407	0	40055000	257012		0
25095	1497	40481087	1973-04-26	1973-04-26 00:00:00	1973-05-03	1973-05-03 00:00:00	32020		\N	99820	0	444814009	40481087		0
25244	1506	40481087	1957-02-11	1957-02-11 00:00:00	1957-02-25	1957-02-25 00:00:00	32020		\N	100410	0	444814009	40481087		0
25492	1517	260139	1984-11-25	1984-11-25 00:00:00	1984-12-02	1984-12-02 00:00:00	32020		\N	101456	0	10509002	260139		0
25653	1525	40481087	1994-09-10	1994-09-10 00:00:00	1994-09-17	1994-09-17 00:00:00	32020		\N	101989	0	444814009	40481087		0
25840	1535	4285898	2012-06-18	2012-06-18 00:00:00	\N	\N	32020		\N	102740	0	68496003	4285898		0
25972	1540	372328	1964-07-26	1964-07-26 00:00:00	1964-10-19	1964-10-19 00:00:00	32020		\N	103159	0	65363002	372328		0
26117	1550	80180	2004-08-25	2004-08-25 00:00:00	\N	\N	32020		\N	103779	0	396275006	80180		0
26289	1560	4278672	2017-01-29	2017-01-29 00:00:00	2017-04-29	2017-04-29 00:00:00	32020		\N	104435	0	65966004	4278672		0
26401	1566	260139	2000-08-13	2000-08-13 00:00:00	2000-08-20	2000-08-20 00:00:00	32020		\N	105026	0	10509002	260139		0
26610	1576	30753	2005-09-22	2005-09-22 00:00:00	\N	\N	32020		\N	105778	0	16761005	30753		0
26788	1586	260139	2001-10-15	2001-10-15 00:00:00	2001-10-22	2001-10-22 00:00:00	32020		\N	106463	0	10509002	260139		0
26902	1593	4112343	2006-02-06	2006-02-06 00:00:00	2006-02-13	2006-02-13 00:00:00	32020		\N	106827	0	195662009	4112343		0
27086	1602	4112343	1971-11-19	1971-11-19 00:00:00	1971-11-27	1971-11-27 00:00:00	32020		\N	107540	0	195662009	4112343		0
27298	1609	4156265	1957-03-01	1957-03-01 00:00:00	1957-03-22	1957-03-22 00:00:00	32020		\N	108159	0	370247008	4156265		0
27509	1623	260139	2006-08-08	2006-08-08 00:00:00	2006-08-22	2006-08-22 00:00:00	32020		\N	109087	0	10509002	260139		0
27631	1632	40481087	1988-01-10	1988-01-10 00:00:00	1988-01-31	1988-01-31 00:00:00	32020		\N	109569	0	444814009	40481087		0
27837	1642	439777	1979-05-15	1979-05-15 00:00:00	\N	\N	32020		\N	110279	0	271737000	439777		0
28046	1658	4113008	1928-01-07	1928-01-07 00:00:00	1928-01-21	1928-01-21 00:00:00	32020		\N	111375	0	284549007	4113008		0
28098	1658	4116491	1946-04-22	1946-04-22 00:00:00	1946-05-26	1946-05-26 00:00:00	32020		\N	111321	0	301011002	4116491		0
28292	1672	260139	2002-10-31	2002-10-31 00:00:00	2002-11-07	2002-11-07 00:00:00	32020		\N	112244	0	10509002	260139		0
28493	1686	378001	1999-12-30	1999-12-30 00:00:00	2000-02-28	2000-02-28 00:00:00	32020		\N	112990	0	62106007	378001		0
28555	1690	40481087	2012-02-27	2012-02-27 00:00:00	2012-03-13	2012-03-13 00:00:00	32020		\N	113199	0	444814009	40481087		0
28772	1703	260139	1949-08-10	1949-08-10 00:00:00	1949-08-17	1949-08-17 00:00:00	32020		\N	113914	0	10509002	260139		0
28919	1713	40481087	2017-11-03	2017-11-03 00:00:00	2017-11-17	2017-11-17 00:00:00	32020		\N	114498	0	444814009	40481087		0
29071	1720	40481087	2013-03-12	2013-03-12 00:00:00	2013-04-02	2013-04-02 00:00:00	32020		\N	115018	0	444814009	40481087		0
29287	1736	40481087	2016-08-21	2016-08-21 00:00:00	2016-09-11	2016-09-11 00:00:00	32020		\N	115904	0	444814009	40481087		0
29405	1740	40481087	2008-02-18	2008-02-18 00:00:00	2008-03-03	2008-03-03 00:00:00	32020		\N	116307	0	444814009	40481087		0
29589	1751	192671	2017-11-13	2017-11-13 00:00:00	\N	\N	32020		\N	117072	0	K92.2	35208414		0
29731	1760	4035415	2006-01-23	2006-01-23 00:00:00	2006-02-22	2006-02-22 00:00:00	32020		\N	117690	0	239720000	4035415		0
29958	1773	40481087	1984-09-10	1984-09-10 00:00:00	1984-09-24	1984-09-24 00:00:00	32020		\N	118573	0	444814009	40481087		0
30153	1781	40481087	1983-02-13	1983-02-13 00:00:00	1983-02-20	1983-02-20 00:00:00	32020		\N	119205	0	444814009	40481087		0
30274	1788	440086	1971-08-15	1971-08-15 00:00:00	1979-08-23	1979-08-23 00:00:00	32020		\N	119841	0	192127007	440086		0
41003	2437	40481087	1963-03-08	1963-03-08 00:00:00	1963-03-22	1963-03-22 00:00:00	32020		\N	161714	0	444814009	40481087		0
30611	1808	81151	1993-12-11	1993-12-11 00:00:00	1994-01-08	1994-01-08 00:00:00	32020		\N	121085	0	44465007	81151		0
30785	1820	40481087	2011-02-20	2011-02-20 00:00:00	2011-02-27	2011-02-27 00:00:00	32020		\N	121714	0	444814009	40481087		0
30906	1829	4113008	1989-07-22	1989-07-22 00:00:00	1989-08-12	1989-08-12 00:00:00	32020		\N	122271	0	284549007	4113008		0
31117	1843	40481087	1983-11-13	1983-11-13 00:00:00	1983-11-20	1983-11-20 00:00:00	32020		\N	123020	0	444814009	40481087		0
31257	1848	260139	1978-07-07	1978-07-07 00:00:00	1978-07-21	1978-07-21 00:00:00	32020		\N	123670	0	10509002	260139		0
31459	1860	40481087	1995-12-20	1995-12-20 00:00:00	1996-01-10	1996-01-10 00:00:00	32020		\N	124362	0	444814009	40481087		0
21077	1265	4112343	1998-06-10	1998-06-10 00:00:00	1998-06-18	1998-06-18 00:00:00	32020		\N	83421	0	195662009	4112343		0
31845	1892	4109685	1981-04-07	1981-04-07 00:00:00	1981-04-28	1981-04-28 00:00:00	32020		\N	126047	0	284551006	4109685		0
21323	1280	4116491	2012-07-02	2012-07-02 00:00:00	2012-08-18	2012-08-18 00:00:00	32020		\N	84535	0	301011002	4116491		0
21547	1292	4112343	2017-11-02	2017-11-02 00:00:00	2017-11-10	2017-11-10 00:00:00	32020		\N	85428	0	195662009	4112343		0
21687	1303	4112343	1998-12-09	1998-12-09 00:00:00	1998-12-19	1998-12-19 00:00:00	32020		\N	86026	0	195662009	4112343		0
21845	1310	40481087	1989-06-27	1989-06-27 00:00:00	1989-07-11	1989-07-11 00:00:00	32020		\N	86551	0	444814009	40481087		0
21932	1315	28060	1971-03-21	1971-03-21 00:00:00	1971-04-02	1971-04-02 00:00:00	32020		\N	87133	0	43878008	28060		0
22173	1323	378001	2008-01-12	2008-01-12 00:00:00	2008-03-12	2008-03-12 00:00:00	32020		\N	87848	0	62106007	378001		0
22294	1332	4112343	1951-10-21	1951-10-21 00:00:00	1951-11-02	1951-11-02 00:00:00	32020		\N	88345	0	195662009	4112343		0
22460	1340	257012	1913-02-09	1913-02-09 00:00:00	\N	\N	32020		\N	88877	0	40055000	257012		0
22639	1353	40481087	1978-04-03	1978-04-03 00:00:00	1978-04-24	1978-04-24 00:00:00	32020		\N	89698	0	444814009	40481087		0
22815	1360	28060	2016-03-28	2016-03-28 00:00:00	2016-04-05	2016-04-05 00:00:00	32020		\N	90252	0	43878008	28060		0
22911	1367	40481087	2000-10-01	2000-10-01 00:00:00	2000-10-22	2000-10-22 00:00:00	32020		\N	90589	0	444814009	40481087		0
23089	1378	40481087	2001-02-21	2001-02-21 00:00:00	2001-03-14	2001-03-14 00:00:00	32020		\N	91309	0	444814009	40481087		0
23291	1389	4278672	1965-03-12	1965-03-12 00:00:00	1965-06-10	1965-06-10 00:00:00	32020		\N	92204	0	65966004	4278672		0
23460	1401	40481087	2011-01-20	2011-01-20 00:00:00	2011-02-03	2011-02-03 00:00:00	32020		\N	93137	0	444814009	40481087		0
23631	1410	260139	2016-12-19	2016-12-19 00:00:00	2017-01-02	2017-01-02 00:00:00	32020		\N	93898	0	10509002	260139		0
23862	1426	4112343	1955-11-04	1955-11-04 00:00:00	1955-11-12	1955-11-12 00:00:00	32020		\N	94805	0	195662009	4112343		0
23929	1430	260139	1946-02-11	1946-02-11 00:00:00	1946-02-25	1946-02-25 00:00:00	32020		\N	95119	0	10509002	260139		0
24204	1442	260139	2006-08-23	2006-08-23 00:00:00	2006-08-30	2006-08-30 00:00:00	32020		\N	96150	0	10509002	260139		0
24330	1450	372328	1968-09-03	1968-09-03 00:00:00	1969-04-27	1969-04-27 00:00:00	32020		\N	96682	0	65363002	372328		0
13939	823	260139	1964-08-08	1964-08-08 00:00:00	1964-08-22	1964-08-22 00:00:00	32020		\N	54511	0	10509002	260139		0
24576	1467	40481087	1953-09-24	1953-09-24 00:00:00	1953-10-15	1953-10-15 00:00:00	32020		\N	97774	0	444814009	40481087		0
24818	1480	4112343	1978-07-29	1978-07-29 00:00:00	1978-08-09	1978-08-09 00:00:00	32020		\N	98740	0	195662009	4112343		0
24969	1491	192671	2006-05-25	2006-05-25 00:00:00	\N	\N	32020		\N	99457	0	K92.2	35208414		0
25096	1497	372328	1942-06-16	1942-06-16 00:00:00	1942-08-21	1942-08-21 00:00:00	32020		\N	99908	0	65363002	372328		0
25245	1506	381316	2012-10-13	2012-10-13 00:00:00	\N	\N	32020		\N	100408	0	230690007	381316		0
25493	1517	40481087	1985-11-16	1985-11-16 00:00:00	1985-12-07	1985-12-07 00:00:00	32020		\N	101417	0	444814009	40481087		0
25654	1525	372328	1966-09-28	1966-09-28 00:00:00	1967-01-05	1967-01-05 00:00:00	32020		\N	102008	0	65363002	372328		0
25841	1535	40481087	2012-01-01	2012-01-01 00:00:00	2012-01-15	2012-01-15 00:00:00	32020		\N	102740	0	444814009	40481087		0
25973	1540	28060	1986-04-12	1986-04-12 00:00:00	1986-04-25	1986-04-25 00:00:00	32020		\N	103217	0	43878008	28060		0
26118	1550	40481087	1980-01-24	1980-01-24 00:00:00	1980-02-07	1980-02-07 00:00:00	32020		\N	103755	0	444814009	40481087		0
26290	1560	4112343	1944-11-27	1944-11-27 00:00:00	1944-12-07	1944-12-07 00:00:00	32020		\N	104501	0	195662009	4112343		0
26402	1566	40481087	1992-06-21	1992-06-21 00:00:00	1992-07-05	1992-07-05 00:00:00	32020		\N	105024	0	444814009	40481087		0
26611	1576	4310024	2005-01-25	2005-01-25 00:00:00	\N	\N	32020		\N	105778	0	424802006	4310024		0
26789	1586	40481087	1940-05-14	1940-05-14 00:00:00	1940-06-04	1940-06-04 00:00:00	32020		\N	106451	0	444814009	40481087		0
26903	1593	4152936	1953-06-01	1953-06-01 00:00:00	1953-06-15	1953-06-15 00:00:00	32020		\N	106842	0	283385000	4152936		0
27087	1602	4059173	2001-06-20	2001-06-20 00:00:00	2001-07-20	2001-07-20 00:00:00	32020		\N	107524	0	16114001	4059173		0
27299	1609	80180	1980-01-29	1980-01-29 00:00:00	\N	\N	32020		\N	108125	0	396275006	80180		0
27510	1623	4112343	1995-12-07	1995-12-07 00:00:00	1995-12-14	1995-12-14 00:00:00	32020		\N	109085	0	195662009	4112343		0
27632	1632	372328	1955-04-23	1955-04-23 00:00:00	1955-06-27	1955-06-27 00:00:00	32020		\N	109626	0	65363002	372328		0
27838	1642	40481087	1986-09-04	1986-09-04 00:00:00	1986-09-11	1986-09-11 00:00:00	32020		\N	110221	0	444814009	40481087		0
28047	1658	4310024	1945-05-22	1945-05-22 00:00:00	\N	\N	32020		\N	111355	0	424802006	4310024		0
28099	1658	81151	2010-12-21	2010-12-21 00:00:00	2011-01-11	2011-01-11 00:00:00	32020		\N	111382	0	44465007	81151		0
28293	1672	4296205	2000-01-15	2000-01-15 00:00:00	2000-01-29	2000-01-29 00:00:00	32020		\N	112282	0	403191005	4296205		0
28494	1686	40481087	1968-03-21	1968-03-21 00:00:00	1968-04-11	1968-04-11 00:00:00	32020		\N	112950	0	444814009	40481087		0
28556	1690	4094814	2015-12-17	2015-12-17 00:00:00	\N	\N	32020		\N	113163	0	262574004	4094814		0
28773	1703	40481087	1999-06-17	1999-06-17 00:00:00	1999-07-01	1999-07-01 00:00:00	32020		\N	113913	0	444814009	40481087		0
28920	1713	40481087	1997-12-10	1997-12-10 00:00:00	1997-12-24	1997-12-24 00:00:00	32020		\N	114468	0	444814009	40481087		0
29072	1720	80180	2014-05-11	2014-05-11 00:00:00	\N	\N	32020		\N	115018	0	396275006	80180		0
29288	1736	4294548	2001-04-12	2001-04-12 00:00:00	2001-09-06	2001-09-06 00:00:00	32020		\N	115901	0	75498004	4294548		0
29406	1740	4112343	1955-06-27	1955-06-27 00:00:00	1955-07-08	1955-07-08 00:00:00	32020		\N	116235	0	195662009	4112343		0
29590	1751	28060	2011-05-15	2011-05-15 00:00:00	2011-05-22	2011-05-22 00:00:00	32020		\N	117049	0	43878008	28060		0
29732	1760	4283893	2018-03-13	2018-03-13 00:00:00	2018-06-19	2018-06-19 00:00:00	32020		\N	117658	0	36971009	4283893		0
29959	1773	4084167	1967-10-04	1967-10-04 00:00:00	1967-10-04	1967-10-04 00:00:00	32020		\N	118551	0	241929008	4084167		0
30154	1781	40481087	1957-09-10	1957-09-10 00:00:00	1957-10-01	1957-10-01 00:00:00	32020		\N	119249	0	444814009	40481087		0
30275	1788	40481087	2008-08-04	2008-08-04 00:00:00	2008-08-18	2008-08-18 00:00:00	32020		\N	119831	0	444814009	40481087		0
41004	2437	4156265	1962-08-02	1962-08-02 00:00:00	1962-08-16	1962-08-16 00:00:00	32020		\N	161666	0	370247008	4156265		0
30612	1808	372328	1967-01-11	1967-01-11 00:00:00	1968-01-16	1968-01-16 00:00:00	32020		\N	121074	0	65363002	372328		0
30786	1820	40481087	1984-03-13	1984-03-13 00:00:00	1984-03-20	1984-03-20 00:00:00	32020		\N	121743	0	444814009	40481087		0
30907	1829	40481087	1969-03-31	1969-03-31 00:00:00	1969-04-07	1969-04-07 00:00:00	32020		\N	122272	0	444814009	40481087		0
31118	1843	40481087	1997-12-18	1997-12-18 00:00:00	1997-12-25	1997-12-25 00:00:00	32020		\N	123083	0	444814009	40481087		0
31258	1848	40481087	1979-11-16	1979-11-16 00:00:00	1979-11-23	1979-11-23 00:00:00	32020		\N	123687	0	444814009	40481087		0
31460	1860	4285898	1996-01-06	1996-01-06 00:00:00	\N	\N	32020		\N	124362	0	68496003	4285898		0
21078	1265	4112343	2011-08-11	2011-08-11 00:00:00	2011-08-21	2011-08-21 00:00:00	32020		\N	83423	0	195662009	4112343		0
31846	1892	4218389	1962-06-04	1962-06-04 00:00:00	1962-06-25	1962-06-25 00:00:00	32020		\N	126044	0	39848009	4218389		0
21324	1280	28060	1984-12-07	1984-12-07 00:00:00	1984-12-16	1984-12-16 00:00:00	32020		\N	84530	0	43878008	28060		0
21548	1292	260139	1981-06-24	1981-06-24 00:00:00	1981-07-08	1981-07-08 00:00:00	32020		\N	85384	0	10509002	260139		0
21688	1303	28060	1976-08-23	1976-08-23 00:00:00	1976-09-03	1976-09-03 00:00:00	32020		\N	86056	0	43878008	28060		0
21846	1310	372328	1987-09-30	1987-09-30 00:00:00	1988-03-25	1988-03-25 00:00:00	32020		\N	86624	0	65363002	372328		0
21933	1315	372328	1961-05-29	1961-05-29 00:00:00	1961-11-14	1961-11-14 00:00:00	32020		\N	87118	0	65363002	372328		0
22174	1323	40481087	1995-09-15	1995-09-15 00:00:00	1995-09-29	1995-09-29 00:00:00	32020		\N	87817	0	444814009	40481087		0
22295	1332	4294548	2014-07-07	2014-07-07 00:00:00	2015-01-05	2015-01-05 00:00:00	32020		\N	88386	0	75498004	4294548		0
22461	1340	260139	1955-04-26	1955-04-26 00:00:00	1955-05-10	1955-05-10 00:00:00	32020		\N	88941	0	10509002	260139		0
22640	1353	4294548	1961-10-13	1961-10-13 00:00:00	1962-01-26	1962-01-26 00:00:00	32020		\N	89665	0	75498004	4294548		0
22816	1360	40481087	2003-01-15	2003-01-15 00:00:00	2003-01-29	2003-01-29 00:00:00	32020		\N	90264	0	444814009	40481087		0
22912	1367	4152936	1978-03-28	1978-03-28 00:00:00	1978-04-18	1978-04-18 00:00:00	32020		\N	90621	0	283385000	4152936		0
23090	1379	40481087	1967-04-12	1967-04-12 00:00:00	1967-04-19	1967-04-19 00:00:00	32020		\N	91455	0	444814009	40481087		0
23292	1389	439777	1962-03-03	1962-03-03 00:00:00	\N	\N	32020		\N	92180	0	271737000	439777		0
23461	1401	4112343	1991-01-14	1991-01-14 00:00:00	1991-01-21	1991-01-21 00:00:00	32020		\N	93141	0	195662009	4112343		0
23632	1410	4296205	1970-12-24	1970-12-24 00:00:00	1971-01-07	1971-01-07 00:00:00	32020		\N	93834	0	403191005	4296205		0
23863	1426	81151	2013-10-27	2013-10-27 00:00:00	2013-11-17	2013-11-17 00:00:00	32020		\N	94878	0	44465007	81151		0
23930	1430	260139	2017-11-18	2017-11-18 00:00:00	2017-12-02	2017-12-02 00:00:00	32020		\N	95133	0	10509002	260139		0
24205	1442	4112343	1994-03-17	1994-03-17 00:00:00	1994-03-26	1994-03-26 00:00:00	32020		\N	96177	0	195662009	4112343		0
24331	1450	40481087	2018-03-08	2018-03-08 00:00:00	2018-03-22	2018-03-22 00:00:00	32020		\N	96725	0	444814009	40481087		0
13940	823	4112343	1953-02-19	1953-02-19 00:00:00	1953-02-26	1953-02-26 00:00:00	32020		\N	54529	0	195662009	4112343		0
24577	1467	260139	1944-02-29	1944-02-29 00:00:00	1944-03-07	1944-03-07 00:00:00	32020		\N	97670	0	10509002	260139		0
24819	1480	4112343	1998-09-07	1998-09-07 00:00:00	1998-09-19	1998-09-19 00:00:00	32020		\N	98743	0	195662009	4112343		0
24970	1491	372328	1970-08-27	1970-08-27 00:00:00	1970-10-13	1970-10-13 00:00:00	32020		\N	99424	0	65363002	372328		0
25097	1497	28060	1978-06-08	1978-06-08 00:00:00	1978-06-19	1978-06-19 00:00:00	32020		\N	99847	0	43878008	28060		0
25246	1506	313217	2011-04-30	2011-04-30 00:00:00	\N	\N	32020		\N	100439	0	49436004	313217		0
25494	1517	40481087	2006-02-27	2006-02-27 00:00:00	2006-03-20	2006-03-20 00:00:00	32020		\N	101418	0	444814009	40481087		0
25655	1525	40481087	1992-07-22	1992-07-22 00:00:00	1992-08-12	1992-08-12 00:00:00	32020		\N	102006	0	444814009	40481087		0
25842	1535	30753	2012-04-19	2012-04-19 00:00:00	\N	\N	32020		\N	102740	0	16761005	30753		0
25974	1540	260139	2004-12-08	2004-12-08 00:00:00	2004-12-15	2004-12-15 00:00:00	32020		\N	103166	0	10509002	260139		0
26119	1550	40481087	2004-05-12	2004-05-12 00:00:00	2004-06-02	2004-06-02 00:00:00	32020		\N	103806	0	444814009	40481087		0
26291	1560	313217	2018-02-05	2018-02-05 00:00:00	\N	\N	32020		\N	104471	0	49436004	313217		0
26403	1566	4027663	1993-10-28	1993-10-28 00:00:00	\N	\N	32020		\N	105018	0	13200003	4027663		0
26612	1576	80180	2007-04-15	2007-04-15 00:00:00	\N	\N	32020		\N	105778	0	396275006	80180		0
26790	1586	4112343	1978-10-23	1978-10-23 00:00:00	1978-11-01	1978-11-01 00:00:00	32020		\N	106450	0	195662009	4112343		0
26904	1593	372328	1936-10-30	1936-10-30 00:00:00	1937-03-18	1937-03-18 00:00:00	32020		\N	106866	0	65363002	372328		0
27088	1602	40481087	2004-07-30	2004-07-30 00:00:00	2004-08-06	2004-08-06 00:00:00	32020		\N	107558	0	444814009	40481087		0
27300	1609	372328	1949-03-17	1949-03-17 00:00:00	1950-03-15	1950-03-15 00:00:00	32020		\N	108195	0	65363002	372328		0
27511	1623	4112343	1979-01-20	1979-01-20 00:00:00	1979-01-31	1979-01-31 00:00:00	32020		\N	109080	0	195662009	4112343		0
27633	1632	257012	1983-05-18	1983-05-18 00:00:00	\N	\N	32020		\N	109621	0	40055000	257012		0
27839	1642	381316	2008-06-17	2008-06-17 00:00:00	\N	\N	32020		\N	110265	0	230690007	381316		0
28048	1658	40481087	1944-06-09	1944-06-09 00:00:00	1944-06-30	1944-06-30 00:00:00	32020		\N	111355	0	444814009	40481087		0
28100	1658	40481087	1964-07-23	1964-07-23 00:00:00	1964-08-13	1964-08-13 00:00:00	32020		\N	111356	0	444814009	40481087		0
28294	1672	192671	1989-06-20	1989-06-20 00:00:00	\N	\N	32020		\N	112284	0	K92.2	35208414		0
28495	1686	80180	1999-04-29	1999-04-29 00:00:00	\N	\N	32020		\N	112974	0	396275006	80180		0
28557	1690	4283893	1996-06-13	1996-06-13 00:00:00	1996-08-01	1996-08-01 00:00:00	32020		\N	113196	0	36971009	4283893		0
28774	1703	4109685	1997-08-20	1997-08-20 00:00:00	1997-09-03	1997-09-03 00:00:00	32020		\N	113931	0	284551006	4109685		0
28921	1713	4027663	1998-09-29	1998-09-29 00:00:00	\N	\N	32020		\N	114468	0	13200003	4027663		0
29073	1720	40481087	1980-11-20	1980-11-20 00:00:00	1980-12-04	1980-12-04 00:00:00	32020		\N	115029	0	444814009	40481087		0
29289	1736	260139	1989-09-06	1989-09-06 00:00:00	1989-09-13	1989-09-13 00:00:00	32020		\N	115916	0	10509002	260139		0
29407	1740	4112343	1986-05-10	1986-05-10 00:00:00	1986-05-18	1986-05-18 00:00:00	32020		\N	116237	0	195662009	4112343		0
29591	1751	4218389	1986-05-28	1986-05-28 00:00:00	1986-07-02	1986-07-02 00:00:00	32020		\N	117077	0	39848009	4218389		0
29733	1760	40481087	1981-03-08	1981-03-08 00:00:00	1981-03-15	1981-03-15 00:00:00	32020		\N	117660	0	444814009	40481087		0
29960	1773	40481087	1955-02-13	1955-02-13 00:00:00	1955-02-27	1955-02-27 00:00:00	32020		\N	118581	0	444814009	40481087		0
30155	1781	372328	1944-01-11	1944-01-11 00:00:00	1944-04-18	1944-04-18 00:00:00	32020		\N	119253	0	65363002	372328		0
30276	1788	81151	2008-11-18	2008-11-18 00:00:00	2008-12-09	2008-12-09 00:00:00	32020		\N	119836	0	44465007	81151		0
41005	2437	81151	1977-10-26	1977-10-26 00:00:00	1977-11-30	1977-11-30 00:00:00	32020		\N	161668	0	44465007	81151		0
30613	1808	260139	1963-03-05	1963-03-05 00:00:00	1963-03-12	1963-03-12 00:00:00	32020		\N	121018	0	10509002	260139		0
30787	1820	4112343	1999-05-22	1999-05-22 00:00:00	1999-06-04	1999-06-04 00:00:00	32020		\N	121750	0	195662009	4112343		0
30908	1829	40481087	1993-01-06	1993-01-06 00:00:00	1993-01-20	1993-01-20 00:00:00	32020		\N	122279	0	444814009	40481087		0
31119	1843	81151	1985-06-13	1985-06-13 00:00:00	1985-06-27	1985-06-27 00:00:00	32020		\N	123009	0	44465007	81151		0
31259	1848	4310024	1980-10-05	1980-10-05 00:00:00	\N	\N	32020		\N	123687	0	424802006	4310024		0
31461	1860	260139	1995-09-30	1995-09-30 00:00:00	1995-10-07	1995-10-07 00:00:00	32020		\N	124384	0	10509002	260139		0
21079	1265	4116491	2017-05-02	2017-05-02 00:00:00	2017-06-16	2017-06-16 00:00:00	32020		\N	83416	0	301011002	4116491		0
31847	1892	40481087	2001-10-10	2001-10-10 00:00:00	2001-10-24	2001-10-24 00:00:00	32020		\N	126029	0	444814009	40481087		0
21325	1280	4283893	1977-10-07	1977-10-07 00:00:00	1977-10-28	1977-10-28 00:00:00	32020		\N	84545	0	36971009	4283893		0
21549	1292	260139	1995-09-16	1995-09-16 00:00:00	1995-09-30	1995-09-30 00:00:00	32020		\N	85385	0	10509002	260139		0
21689	1303	372328	1977-04-18	1977-04-18 00:00:00	1977-05-29	1977-05-29 00:00:00	32020		\N	86035	0	65363002	372328		0
21878	1313	4112343	1996-01-23	1996-01-23 00:00:00	1996-02-04	1996-02-04 00:00:00	32020		\N	86927	0	195662009	4112343		0
21934	1315	260139	1973-02-09	1973-02-09 00:00:00	1973-02-23	1973-02-23 00:00:00	32020		\N	87115	0	10509002	260139		0
22175	1323	40481087	1969-05-29	1969-05-29 00:00:00	1969-06-12	1969-06-12 00:00:00	32020		\N	87877	0	444814009	40481087		0
22296	1332	260139	1970-05-12	1970-05-12 00:00:00	1970-05-19	1970-05-19 00:00:00	32020		\N	88366	0	10509002	260139		0
22462	1340	378001	1944-03-13	1944-03-13 00:00:00	1944-05-12	1944-05-12 00:00:00	32020		\N	88844	0	62106007	378001		0
22641	1353	4112343	2001-09-09	2001-09-09 00:00:00	2001-09-16	2001-09-16 00:00:00	32020		\N	89662	0	195662009	4112343		0
22817	1360	4294548	2009-12-29	2009-12-29 00:00:00	2010-03-23	2010-03-23 00:00:00	32020		\N	90251	0	75498004	4294548		0
22913	1367	4283893	2006-04-30	2006-04-30 00:00:00	2006-09-24	2006-09-24 00:00:00	32020		\N	90631	0	36971009	4283893		0
23091	1379	261325	1997-04-12	1997-04-12 00:00:00	\N	\N	32020		\N	91483	0	87433001	261325		0
23293	1390	40481087	2017-05-07	2017-05-07 00:00:00	2017-05-28	2017-05-28 00:00:00	32020		\N	92272	0	444814009	40481087		0
23462	1401	40481087	1997-02-08	1997-02-08 00:00:00	1997-02-22	1997-02-22 00:00:00	32020		\N	93188	0	444814009	40481087		0
23633	1410	372328	1971-04-23	1971-04-23 00:00:00	1972-02-16	1972-02-16 00:00:00	32020		\N	93877	0	65363002	372328		0
23864	1426	4112343	1980-10-27	1980-10-27 00:00:00	1980-11-03	1980-11-03 00:00:00	32020		\N	94819	0	195662009	4112343		0
23931	1430	4296205	1993-12-28	1993-12-28 00:00:00	1994-01-25	1994-01-25 00:00:00	32020		\N	95183	0	403191005	4296205		0
24206	1442	40481087	1995-01-17	1995-01-17 00:00:00	1995-01-31	1995-01-31 00:00:00	32020		\N	96148	0	444814009	40481087		0
24332	1450	260139	1970-03-08	1970-03-08 00:00:00	1970-03-15	1970-03-15 00:00:00	32020		\N	96738	0	10509002	260139		0
13942	823	80180	1979-01-26	1979-01-26 00:00:00	\N	\N	32020		\N	54560	0	396275006	80180		0
24578	1467	40481087	1962-07-09	1962-07-09 00:00:00	1962-07-16	1962-07-16 00:00:00	32020		\N	97776	0	444814009	40481087		0
24820	1480	260139	1982-02-23	1982-02-23 00:00:00	1982-03-09	1982-03-09 00:00:00	32020		\N	98741	0	10509002	260139		0
24971	1491	28060	1979-05-08	1979-05-08 00:00:00	1979-05-19	1979-05-19 00:00:00	32020		\N	99432	0	43878008	28060		0
25098	1497	40481087	2018-05-09	2018-05-09 00:00:00	2018-05-23	2018-05-23 00:00:00	32020		\N	99924	0	444814009	40481087		0
25247	1506	80502	2006-04-01	2006-04-01 00:00:00	\N	\N	32020		\N	100480	0	64859006	80502		0
25495	1517	40481087	1961-04-20	1961-04-20 00:00:00	1961-05-04	1961-05-04 00:00:00	32020		\N	101360	0	444814009	40481087		0
25656	1525	4237458	1993-08-23	1993-08-23 00:00:00	1993-11-21	1993-11-21 00:00:00	32020		\N	102031	0	58150001	4237458		0
25843	1535	40481087	1979-10-30	1979-10-30 00:00:00	1979-11-06	1979-11-06 00:00:00	32020		\N	102759	0	444814009	40481087		0
25975	1540	381316	2018-12-10	2018-12-10 00:00:00	\N	\N	32020		\N	103181	0	230690007	381316		0
26120	1550	40481087	1969-07-19	1969-07-19 00:00:00	1969-07-26	1969-07-26 00:00:00	32020		\N	103764	0	444814009	40481087		0
26292	1560	192671	1975-02-16	1975-02-16 00:00:00	\N	\N	32020		\N	104536	0	K92.2	35208414		0
26404	1566	40481087	1969-10-01	1969-10-01 00:00:00	1969-10-15	1969-10-15 00:00:00	32020		\N	105051	0	444814009	40481087		0
26613	1576	378001	1998-11-28	1998-11-28 00:00:00	1999-01-27	1999-01-27 00:00:00	32020		\N	105776	0	62106007	378001		0
26791	1586	4059173	2008-07-03	2008-07-03 00:00:00	2008-09-01	2008-09-01 00:00:00	32020		\N	106390	0	16114001	4059173		0
26905	1593	40481087	1940-08-18	1940-08-18 00:00:00	1940-09-08	1940-09-08 00:00:00	32020		\N	106858	0	444814009	40481087		0
27089	1602	40481087	1987-11-29	1987-11-29 00:00:00	1987-12-20	1987-12-20 00:00:00	32020		\N	107504	0	444814009	40481087		0
27301	1609	372328	1946-10-15	1946-10-15 00:00:00	1947-02-26	1947-02-26 00:00:00	32020		\N	108112	0	65363002	372328		0
27512	1623	40481087	1957-08-18	1957-08-18 00:00:00	1957-09-01	1957-09-01 00:00:00	32020		\N	109117	0	444814009	40481087		0
27634	1632	40481087	1965-02-10	1965-02-10 00:00:00	1965-02-24	1965-02-24 00:00:00	32020		\N	109618	0	444814009	40481087		0
27840	1642	260139	2018-07-05	2018-07-05 00:00:00	2018-07-12	2018-07-12 00:00:00	32020		\N	110212	0	10509002	260139		0
28049	1658	40481087	1937-07-16	1937-07-16 00:00:00	1937-08-06	1937-08-06 00:00:00	32020		\N	111387	0	444814009	40481087		0
28101	1658	4218389	1918-02-23	1918-02-23 00:00:00	1918-03-30	1918-03-30 00:00:00	32020		\N	111374	0	39848009	4218389		0
28295	1672	40481087	1979-11-26	1979-11-26 00:00:00	1979-12-10	1979-12-10 00:00:00	32020		\N	112248	0	444814009	40481087		0
21938	1315	4310024	1995-01-26	1995-01-26 00:00:00	\N	\N	32020		\N	87124	0	424802006	4310024		0
28496	1686	40481087	1998-09-23	1998-09-23 00:00:00	1998-10-14	1998-10-14 00:00:00	32020		\N	112974	0	444814009	40481087		0
28558	1690	4112343	1981-10-05	1981-10-05 00:00:00	1981-10-13	1981-10-13 00:00:00	32020		\N	113208	0	195662009	4112343		0
28775	1703	80180	1992-10-16	1992-10-16 00:00:00	\N	\N	32020		\N	113880	0	396275006	80180		0
28922	1713	4294548	2006-11-27	2006-11-27 00:00:00	2007-04-23	2007-04-23 00:00:00	32020		\N	114466	0	75498004	4294548		0
29074	1720	257012	2012-03-08	2012-03-08 00:00:00	\N	\N	32020		\N	115004	0	40055000	257012		0
29290	1736	260139	2006-07-15	2006-07-15 00:00:00	2006-07-29	2006-07-29 00:00:00	32020		\N	115892	0	10509002	260139		0
29425	1743	440448	2011-01-25	2011-01-25 00:00:00	\N	\N	32020		\N	116511	0	74400008	440448		0
29592	1751	40481087	2013-09-17	2013-09-17 00:00:00	2013-09-24	2013-09-24 00:00:00	32020		\N	117059	0	444814009	40481087		0
29734	1760	4112343	1980-03-09	1980-03-09 00:00:00	1980-03-17	1980-03-17 00:00:00	32020		\N	117671	0	195662009	4112343		0
29961	1773	28060	1959-07-19	1959-07-19 00:00:00	1959-07-29	1959-07-29 00:00:00	32020		\N	118554	0	43878008	28060		0
30156	1781	260139	2009-11-17	2009-11-17 00:00:00	2009-12-01	2009-12-01 00:00:00	32020		\N	119208	0	10509002	260139		0
30277	1788	4112343	1976-08-17	1976-08-17 00:00:00	1976-08-27	1976-08-27 00:00:00	32020		\N	119823	0	195662009	4112343		0
41006	2437	372328	1964-08-21	1964-08-21 00:00:00	1965-01-11	1965-01-11 00:00:00	32020		\N	161718	0	65363002	372328		0
30614	1808	4116491	2001-01-27	2001-01-27 00:00:00	2001-03-28	2001-03-28 00:00:00	32020		\N	121020	0	301011002	4116491		0
30788	1820	381316	2004-09-14	2004-09-14 00:00:00	\N	\N	32020		\N	121716	0	230690007	381316		0
30909	1829	40481087	1997-04-05	1997-04-05 00:00:00	1997-04-26	1997-04-26 00:00:00	32020		\N	122304	0	444814009	40481087		0
31120	1843	260139	1983-01-13	1983-01-13 00:00:00	1983-01-27	1983-01-27 00:00:00	32020		\N	123053	0	10509002	260139		0
31260	1848	40481087	1970-09-22	1970-09-22 00:00:00	1970-09-29	1970-09-29 00:00:00	32020		\N	123682	0	444814009	40481087		0
31462	1860	260139	1971-04-24	1971-04-24 00:00:00	1971-05-08	1971-05-08 00:00:00	32020		\N	124350	0	10509002	260139		0
21080	1265	40481087	2001-05-17	2001-05-17 00:00:00	2001-06-07	2001-06-07 00:00:00	32020		\N	83415	0	444814009	40481087		0
31848	1892	260139	2006-05-24	2006-05-24 00:00:00	2006-05-31	2006-05-31 00:00:00	32020		\N	126030	0	10509002	260139		0
21326	1280	40481087	1972-06-03	1972-06-03 00:00:00	1972-06-17	1972-06-17 00:00:00	32020		\N	84604	0	444814009	40481087		0
21550	1292	4084167	1960-09-21	1960-09-21 00:00:00	1960-09-21	1960-09-21 00:00:00	32020		\N	85412	0	241929008	4084167		0
21690	1303	378001	2007-04-11	2007-04-11 00:00:00	2007-06-10	2007-06-10 00:00:00	32020		\N	86060	0	62106007	378001		0
21879	1313	40481087	1978-11-13	1978-11-13 00:00:00	1978-11-27	1978-11-27 00:00:00	32020		\N	86895	0	444814009	40481087		0
21935	1315	28060	1965-10-08	1965-10-08 00:00:00	1965-10-16	1965-10-16 00:00:00	32020		\N	87128	0	43878008	28060		0
22176	1323	4059173	2016-04-29	2016-04-29 00:00:00	2016-05-29	2016-05-29 00:00:00	32020		\N	87849	0	16114001	4059173		0
22297	1332	317576	1999-08-04	1999-08-04 00:00:00	\N	\N	32020		\N	88397	0	53741008	317576		0
22463	1340	40481087	2000-04-11	2000-04-11 00:00:00	2000-04-25	2000-04-25 00:00:00	32020		\N	88974	0	444814009	40481087		0
22642	1353	40481087	1985-10-21	1985-10-21 00:00:00	1985-11-11	1985-11-11 00:00:00	32020		\N	89632	0	444814009	40481087		0
22818	1360	40481087	2004-01-02	2004-01-02 00:00:00	2004-01-23	2004-01-23 00:00:00	32020		\N	90250	0	444814009	40481087		0
22914	1367	40481087	1992-01-07	1992-01-07 00:00:00	1992-01-28	1992-01-28 00:00:00	32020		\N	90586	0	444814009	40481087		0
23092	1379	4112343	2002-07-05	2002-07-05 00:00:00	2002-07-14	2002-07-14 00:00:00	32020		\N	91460	0	195662009	4112343		0
23294	1390	4059173	2013-12-21	2013-12-21 00:00:00	2014-03-21	2014-03-21 00:00:00	32020		\N	92251	0	16114001	4059173		0
23463	1401	40481087	2015-03-22	2015-03-22 00:00:00	2015-04-12	2015-04-12 00:00:00	32020		\N	93167	0	444814009	40481087		0
23634	1410	28060	1976-01-21	1976-01-21 00:00:00	1976-01-31	1976-01-31 00:00:00	32020		\N	93902	0	43878008	28060		0
23865	1426	260139	1978-11-22	1978-11-22 00:00:00	1978-12-06	1978-12-06 00:00:00	32020		\N	94880	0	10509002	260139		0
23932	1430	440448	1965-11-18	1965-11-18 00:00:00	\N	\N	32020		\N	95180	0	74400008	440448		0
24207	1442	4116491	1974-01-29	1974-01-29 00:00:00	1974-03-18	1974-03-18 00:00:00	32020		\N	96135	0	301011002	4116491		0
24333	1450	4112343	2010-01-21	2010-01-21 00:00:00	2010-01-28	2010-01-28 00:00:00	32020		\N	96722	0	195662009	4112343		0
13943	823	381316	2019-04-15	2019-04-15 00:00:00	\N	\N	32020		\N	54601	0	230690007	381316		0
24579	1467	4112343	1935-04-17	1935-04-17 00:00:00	1935-04-24	1935-04-24 00:00:00	32020		\N	97769	0	195662009	4112343		0
24821	1480	4329847	2006-08-04	2006-08-04 00:00:00	\N	\N	32020		\N	98765	0	22298006	4329847		0
24972	1491	4112343	1975-09-13	1975-09-13 00:00:00	1975-09-23	1975-09-23 00:00:00	32020		\N	99442	0	195662009	4112343		0
25099	1497	372328	1940-11-10	1940-11-10 00:00:00	1941-02-21	1941-02-21 00:00:00	32020		\N	99884	0	65363002	372328		0
25248	1506	4112343	1963-11-28	1963-11-28 00:00:00	1963-12-09	1963-12-09 00:00:00	32020		\N	100400	0	195662009	4112343		0
25496	1517	4112343	1985-02-08	1985-02-08 00:00:00	1985-02-21	1985-02-21 00:00:00	32020		\N	101362	0	195662009	4112343		0
25657	1525	40481087	2015-03-08	2015-03-08 00:00:00	2015-03-29	2015-03-29 00:00:00	32020		\N	102007	0	444814009	40481087		0
25844	1535	260139	1995-11-21	1995-11-21 00:00:00	1995-11-28	1995-11-28 00:00:00	32020		\N	102701	0	10509002	260139		0
25976	1541	378001	1966-02-12	1966-02-12 00:00:00	1966-04-13	1966-04-13 00:00:00	32020		\N	103299	0	62106007	378001		0
26121	1550	28060	1972-05-29	1972-05-29 00:00:00	1972-06-05	1972-06-05 00:00:00	32020		\N	103801	0	43878008	28060		0
26293	1560	81151	2009-02-05	2009-02-05 00:00:00	2009-03-12	2009-03-12 00:00:00	32020		\N	104434	0	44465007	81151		0
26405	1566	4146173	2012-10-20	2012-10-20 00:00:00	2012-12-19	2012-12-19 00:00:00	32020		\N	105038	0	307731004	4146173		0
26614	1576	4112343	1999-10-18	1999-10-18 00:00:00	1999-10-31	1999-10-31 00:00:00	32020		\N	105795	0	195662009	4112343		0
26792	1586	40480160	2008-07-03	2008-07-03 00:00:00	2008-09-01	2008-09-01 00:00:00	32020		\N	106390	0	443165006	40480160		0
26906	1593	372328	1938-02-11	1938-02-11 00:00:00	1938-03-17	1938-03-17 00:00:00	32020		\N	106867	0	65363002	372328		0
27090	1602	4113008	1971-04-10	1971-04-10 00:00:00	1971-04-24	1971-04-24 00:00:00	32020		\N	107520	0	284549007	4113008		0
27302	1609	372328	1943-06-23	1943-06-23 00:00:00	1943-09-02	1943-09-02 00:00:00	32020		\N	108194	0	65363002	372328		0
27513	1623	40481087	1973-01-08	1973-01-08 00:00:00	1973-01-22	1973-01-22 00:00:00	32020		\N	109134	0	444814009	40481087		0
27635	1632	4294548	1965-05-01	1965-05-01 00:00:00	1965-05-22	1965-05-22 00:00:00	32020		\N	109567	0	75498004	4294548		0
27841	1642	260139	1951-06-22	1951-06-22 00:00:00	1951-07-06	1951-07-06 00:00:00	32020		\N	110247	0	10509002	260139		0
28050	1658	372328	1912-09-22	1912-09-22 00:00:00	1912-10-06	1912-10-06 00:00:00	32020		\N	111298	0	65363002	372328		0
28102	1658	257012	1981-02-13	1981-02-13 00:00:00	\N	\N	32020		\N	111317	0	40055000	257012		0
28296	1672	4027663	1982-04-22	1982-04-22 00:00:00	\N	\N	32020		\N	112212	0	13200003	4027663		0
28497	1686	260139	1976-11-27	1976-11-27 00:00:00	1976-12-04	1976-12-04 00:00:00	32020		\N	112932	0	10509002	260139		0
28559	1690	80180	2009-12-12	2009-12-12 00:00:00	\N	\N	32020		\N	113197	0	396275006	80180		0
28776	1703	4112343	1995-07-28	1995-07-28 00:00:00	1995-08-04	1995-08-04 00:00:00	32020		\N	113912	0	195662009	4112343		0
28923	1713	375671	1985-11-21	1985-11-21 00:00:00	1985-12-21	1985-12-21 00:00:00	32020		\N	114453	0	62564004	375671		0
29075	1720	40481087	2005-12-12	2005-12-12 00:00:00	2006-01-02	2006-01-02 00:00:00	32020		\N	115031	0	444814009	40481087		0
29291	1736	260139	1992-05-02	1992-05-02 00:00:00	1992-05-09	1992-05-09 00:00:00	32020		\N	115917	0	10509002	260139		0
29426	1743	81151	1967-11-20	1967-11-20 00:00:00	1967-12-11	1967-12-11 00:00:00	32020		\N	116507	0	44465007	81151		0
23467	1401	4266809	2007-08-03	2007-08-03 00:00:00	\N	\N	32020		\N	93165	0	397881000	4266809		0
29593	1751	28060	1985-06-20	1985-06-20 00:00:00	1985-06-29	1985-06-29 00:00:00	32020		\N	117098	0	43878008	28060		0
29735	1760	4278672	1988-12-18	1988-12-18 00:00:00	1989-01-17	1989-01-17 00:00:00	32020		\N	117688	0	65966004	4278672		0
29962	1773	4112343	1978-07-18	1978-07-18 00:00:00	1978-07-25	1978-07-25 00:00:00	32020		\N	118572	0	195662009	4112343		0
30157	1782	260139	1960-02-01	1960-02-01 00:00:00	1960-02-08	1960-02-08 00:00:00	32020		\N	119372	0	10509002	260139		0
30278	1788	81151	1963-10-06	1963-10-06 00:00:00	1963-11-10	1963-11-10 00:00:00	32020		\N	119833	0	44465007	81151		0
41007	2438	4155034	1997-05-15	1997-05-15 00:00:00	1997-05-29	1997-05-29 00:00:00	32020		\N	161755	0	283371005	4155034		0
30615	1808	80180	2003-12-18	2003-12-18 00:00:00	\N	\N	32020		\N	121056	0	396275006	80180		0
30789	1821	313217	1986-08-03	1986-08-03 00:00:00	\N	\N	32020		\N	121841	0	49436004	313217		0
30910	1829	4152936	1975-07-22	1975-07-22 00:00:00	1975-08-05	1975-08-05 00:00:00	32020		\N	122270	0	283385000	4152936		0
31121	1843	40481087	2005-07-11	2005-07-11 00:00:00	2005-07-25	2005-07-25 00:00:00	32020		\N	123067	0	444814009	40481087		0
31261	1848	439777	2015-08-28	2015-08-28 00:00:00	\N	\N	32020		\N	123652	0	271737000	439777		0
31463	1860	4027663	1985-10-20	1985-10-20 00:00:00	\N	\N	32020		\N	124382	0	13200003	4027663		0
21081	1266	260139	2017-12-11	2017-12-11 00:00:00	2017-12-25	2017-12-25 00:00:00	32020		\N	83435	0	10509002	260139		0
31849	1892	4283893	2005-03-15	2005-03-15 00:00:00	2005-04-26	2005-04-26 00:00:00	32020		\N	125975	0	36971009	4283893		0
21327	1280	4112343	1974-11-08	1974-11-08 00:00:00	1974-11-16	1974-11-16 00:00:00	32020		\N	84543	0	195662009	4112343		0
21551	1292	40481087	2015-07-26	2015-07-26 00:00:00	2015-08-09	2015-08-09 00:00:00	32020		\N	85436	0	444814009	40481087		0
21691	1303	372328	1977-10-26	1977-10-26 00:00:00	1978-02-26	1978-02-26 00:00:00	32020		\N	86038	0	65363002	372328		0
21880	1313	40481087	2004-04-03	2004-04-03 00:00:00	2004-04-17	2004-04-17 00:00:00	32020		\N	86896	0	444814009	40481087		0
21936	1315	30753	1995-10-23	1995-10-23 00:00:00	\N	\N	32020		\N	87124	0	16761005	30753		0
22177	1323	40481087	2002-06-29	2002-06-29 00:00:00	2002-07-20	2002-07-20 00:00:00	32020		\N	87807	0	444814009	40481087		0
22298	1332	4113008	1975-05-09	1975-05-09 00:00:00	1975-05-30	1975-05-30 00:00:00	32020		\N	88380	0	284549007	4113008		0
22464	1340	40481087	1981-09-28	1981-09-28 00:00:00	1981-10-12	1981-10-12 00:00:00	32020		\N	88942	0	444814009	40481087		0
22643	1353	4294548	2008-11-02	2008-11-02 00:00:00	2009-01-11	2009-01-11 00:00:00	32020		\N	89703	0	75498004	4294548		0
22819	1360	40481087	1999-02-21	1999-02-21 00:00:00	1999-03-07	1999-03-07 00:00:00	32020		\N	90242	0	444814009	40481087		0
22915	1367	40481087	1998-10-21	1998-10-21 00:00:00	1998-11-04	1998-11-04 00:00:00	32020		\N	90594	0	444814009	40481087		0
23093	1379	4112343	1985-02-11	1985-02-11 00:00:00	1985-02-22	1985-02-22 00:00:00	32020		\N	91474	0	195662009	4112343		0
23295	1390	40481087	2011-07-10	2011-07-10 00:00:00	2011-07-31	2011-07-31 00:00:00	32020		\N	92230	0	444814009	40481087		0
23464	1401	40481087	1991-01-20	1991-01-20 00:00:00	1991-02-03	1991-02-03 00:00:00	32020		\N	93142	0	444814009	40481087		0
23635	1410	4112343	1969-02-04	1969-02-04 00:00:00	1969-02-13	1969-02-13 00:00:00	32020		\N	93847	0	195662009	4112343		0
23866	1426	81151	1954-12-26	1954-12-26 00:00:00	1955-01-23	1955-01-23 00:00:00	32020		\N	94872	0	44465007	81151		0
23934	1430	81893	1984-01-12	1984-01-12 00:00:00	\N	\N	32020		\N	95163	0	64766004	81893		0
24208	1442	4112343	1946-07-07	1946-07-07 00:00:00	1946-07-14	1946-07-14 00:00:00	32020		\N	96141	0	195662009	4112343		0
24334	1450	40481087	2009-01-29	2009-01-29 00:00:00	2009-02-05	2009-02-05 00:00:00	32020		\N	96721	0	444814009	40481087		0
13944	823	40480160	2011-07-23	2011-07-23 00:00:00	2011-09-21	2011-09-21 00:00:00	32020		\N	54557	0	443165006	40480160		0
24580	1467	4048695	2011-07-17	2011-07-17 00:00:00	2011-08-18	2011-08-18 00:00:00	32020		\N	97668	0	15724005	4048695		0
24823	1480	378001	1983-08-25	1983-08-25 00:00:00	1983-09-24	1983-09-24 00:00:00	32020		\N	98762	0	62106007	378001		0
24973	1491	4310024	2004-11-26	2004-11-26 00:00:00	\N	\N	32020		\N	99449	0	424802006	4310024		0
25100	1497	40481087	1969-06-17	1969-06-17 00:00:00	1969-07-01	1969-07-01 00:00:00	32020		\N	99764	0	444814009	40481087		0
25249	1506	4112343	1950-09-26	1950-09-26 00:00:00	1950-10-07	1950-10-07 00:00:00	32020		\N	100446	0	195662009	4112343		0
25497	1517	40481087	2014-08-04	2014-08-04 00:00:00	2014-08-11	2014-08-11 00:00:00	32020		\N	101464	0	444814009	40481087		0
25658	1525	40481087	1987-08-15	1987-08-15 00:00:00	1987-08-22	1987-08-22 00:00:00	32020		\N	101988	0	444814009	40481087		0
25845	1535	4027663	2006-03-27	2006-03-27 00:00:00	\N	\N	32020		\N	102731	0	13200003	4027663		0
25977	1541	4112343	1966-12-20	1966-12-20 00:00:00	1967-01-01	1967-01-01 00:00:00	32020		\N	103234	0	195662009	4112343		0
26122	1550	257012	1977-04-26	1977-04-26 00:00:00	\N	\N	32020		\N	103803	0	40055000	257012		0
26294	1560	372328	1935-04-14	1935-04-14 00:00:00	1935-06-24	1935-06-24 00:00:00	32020		\N	104513	0	65363002	372328		0
26406	1567	40481087	1978-06-16	1978-06-16 00:00:00	1978-06-23	1978-06-23 00:00:00	32020		\N	105108	0	444814009	40481087		0
26615	1576	4296205	1982-02-20	1982-02-20 00:00:00	1982-03-27	1982-03-27 00:00:00	32020		\N	105774	0	403191005	4296205		0
26793	1586	80502	1999-10-17	1999-10-17 00:00:00	\N	\N	32020		\N	106378	0	64859006	80502		0
26907	1593	4109685	1968-10-22	1968-10-22 00:00:00	1968-11-12	1968-11-12 00:00:00	32020		\N	106846	0	284551006	4109685		0
27091	1602	4156265	1995-09-15	1995-09-15 00:00:00	1995-10-06	1995-10-06 00:00:00	32020		\N	107522	0	370247008	4156265		0
27303	1609	257012	2002-02-28	2002-02-28 00:00:00	\N	\N	32020		\N	108138	0	40055000	257012		0
27514	1623	257012	1984-07-12	1984-07-12 00:00:00	\N	\N	32020		\N	109125	0	40055000	257012		0
27637	1632	4029498	1962-07-20	1962-07-20 00:00:00	\N	\N	32020		\N	109549	0	128613002	4029498		0
27842	1642	4283893	1966-05-12	1966-05-12 00:00:00	1966-08-11	1966-08-11 00:00:00	32020		\N	110254	0	36971009	4283893		0
28051	1658	40481087	1929-11-03	1929-11-03 00:00:00	1929-11-17	1929-11-17 00:00:00	32020		\N	111386	0	444814009	40481087		0
28103	1658	260139	1982-01-12	1982-01-12 00:00:00	1982-01-26	1982-01-26 00:00:00	32020		\N	111391	0	10509002	260139		0
28297	1672	78272	1962-08-01	1962-08-01 00:00:00	1962-09-05	1962-09-05 00:00:00	32020		\N	112279	0	70704007	78272		0
28498	1686	40481087	2018-10-13	2018-10-13 00:00:00	2018-10-20	2018-10-20 00:00:00	32020		\N	112988	0	444814009	40481087		0
28560	1690	40481087	2007-01-05	2007-01-05 00:00:00	2007-01-19	2007-01-19 00:00:00	32020		\N	113197	0	444814009	40481087		0
28777	1703	40481087	1990-04-08	1990-04-08 00:00:00	1990-04-29	1990-04-29 00:00:00	32020		\N	113924	0	444814009	40481087		0
28924	1713	4283893	1982-11-08	1982-11-08 00:00:00	1983-02-07	1983-02-07 00:00:00	32020		\N	114463	0	36971009	4283893		0
29076	1720	28060	1980-02-27	1980-02-27 00:00:00	1980-03-09	1980-03-09 00:00:00	32020		\N	115028	0	43878008	28060		0
29292	1736	40481087	1980-08-13	1980-08-13 00:00:00	1980-08-20	1980-08-20 00:00:00	32020		\N	115942	0	444814009	40481087		0
29427	1743	40481087	2004-07-27	2004-07-27 00:00:00	2004-08-10	2004-08-10 00:00:00	32020		\N	116495	0	444814009	40481087		0
29594	1751	81151	1995-05-16	1995-05-16 00:00:00	1995-06-13	1995-06-13 00:00:00	32020		\N	117079	0	44465007	81151		0
29736	1760	80180	2017-08-23	2017-08-23 00:00:00	\N	\N	32020		\N	117659	0	396275006	80180		0
29963	1773	40481087	2015-02-05	2015-02-05 00:00:00	2015-02-26	2015-02-26 00:00:00	32020		\N	118615	0	444814009	40481087		0
30158	1782	4059173	1961-09-09	1961-09-09 00:00:00	1961-12-08	1961-12-08 00:00:00	32020		\N	119340	0	16114001	4059173		0
30279	1788	378001	2017-10-21	2017-10-21 00:00:00	2017-12-20	2017-12-20 00:00:00	32020		\N	119838	0	62106007	378001		0
41008	2438	40481087	2010-10-05	2010-10-05 00:00:00	2010-10-12	2010-10-12 00:00:00	32020		\N	161772	0	444814009	40481087		0
30616	1808	78272	1969-12-26	1969-12-26 00:00:00	1970-01-16	1970-01-16 00:00:00	32020		\N	121084	0	70704007	78272		0
30790	1821	260139	1978-07-07	1978-07-07 00:00:00	1978-07-21	1978-07-21 00:00:00	32020		\N	121812	0	10509002	260139		0
30911	1829	260139	2003-07-17	2003-07-17 00:00:00	2003-07-24	2003-07-24 00:00:00	32020		\N	122305	0	10509002	260139		0
31122	1843	40481087	1992-11-02	1992-11-02 00:00:00	1992-11-09	1992-11-09 00:00:00	32020		\N	123057	0	444814009	40481087		0
31262	1848	40481087	1947-04-10	1947-04-10 00:00:00	1947-04-17	1947-04-17 00:00:00	32020		\N	123592	0	444814009	40481087		0
31464	1860	4142905	1984-05-13	1984-05-13 00:00:00	1984-07-12	1984-07-12 00:00:00	32020		\N	124403	0	33737001	4142905		0
21082	1266	260139	1972-03-15	1972-03-15 00:00:00	1972-03-22	1972-03-22 00:00:00	32020		\N	83441	0	10509002	260139		0
31850	1892	4116491	1999-07-05	1999-07-05 00:00:00	1999-08-09	1999-08-09 00:00:00	32020		\N	126035	0	301011002	4116491		0
21328	1280	260139	1964-03-16	1964-03-16 00:00:00	1964-03-23	1964-03-23 00:00:00	32020		\N	84573	0	10509002	260139		0
21552	1292	372328	1953-05-31	1953-05-31 00:00:00	1953-07-21	1953-07-21 00:00:00	32020		\N	85437	0	65363002	372328		0
21692	1303	28060	2005-07-16	2005-07-16 00:00:00	2005-07-29	2005-07-29 00:00:00	32020		\N	86063	0	43878008	28060		0
21881	1313	40481087	2004-02-19	2004-02-19 00:00:00	2004-02-26	2004-02-26 00:00:00	32020		\N	86919	0	444814009	40481087		0
21937	1315	80180	1996-03-21	1996-03-21 00:00:00	\N	\N	32020		\N	87124	0	396275006	80180		0
22178	1323	28060	1971-05-18	1971-05-18 00:00:00	1971-05-28	1971-05-28 00:00:00	32020		\N	87872	0	43878008	28060		0
22299	1332	40481087	1952-09-16	1952-09-16 00:00:00	1952-09-23	1952-09-23 00:00:00	32020		\N	88346	0	444814009	40481087		0
22465	1340	372328	1912-10-22	1912-10-22 00:00:00	1913-01-05	1913-01-05 00:00:00	32020		\N	88976	0	65363002	372328		0
22644	1353	4112343	2009-12-22	2009-12-22 00:00:00	2009-12-30	2009-12-30 00:00:00	32020		\N	89669	0	195662009	4112343		0
22820	1360	4146173	2006-01-25	2006-01-25 00:00:00	2006-03-26	2006-03-26 00:00:00	32020		\N	90283	0	307731004	4146173		0
22916	1367	80180	2005-02-04	2005-02-04 00:00:00	\N	\N	32020		\N	90656	0	396275006	80180		0
23094	1379	4152936	1998-02-17	1998-02-17 00:00:00	1998-03-10	1998-03-10 00:00:00	32020		\N	91517	0	283385000	4152936		0
23296	1390	40481087	1992-03-22	1992-03-22 00:00:00	1992-03-29	1992-03-29 00:00:00	32020		\N	92269	0	444814009	40481087		0
23465	1401	4112343	1982-09-11	1982-09-11 00:00:00	1982-09-24	1982-09-24 00:00:00	32020		\N	93153	0	195662009	4112343		0
23636	1410	81893	2002-12-01	2002-12-01 00:00:00	\N	\N	32020		\N	93891	0	64766004	81893		0
23867	1426	4112343	2006-09-01	2006-09-01 00:00:00	2006-09-14	2006-09-14 00:00:00	32020		\N	94808	0	195662009	4112343		0
23935	1430	4310024	1983-12-13	1983-12-13 00:00:00	\N	\N	32020		\N	95163	0	424802006	4310024		0
24209	1442	260139	2005-03-11	2005-03-11 00:00:00	2005-03-18	2005-03-18 00:00:00	32020		\N	96140	0	10509002	260139		0
24335	1450	375671	2017-03-16	2017-03-16 00:00:00	2017-05-15	2017-05-15 00:00:00	32020		\N	96697	0	62564004	375671		0
24403	1454	375671	1983-11-06	1983-11-06 00:00:00	1984-01-05	1984-01-05 00:00:00	32020		\N	96974	0	62564004	375671		0
24581	1467	80180	1967-10-09	1967-10-09 00:00:00	\N	\N	32020		\N	97709	0	396275006	80180		0
24824	1480	260139	2001-12-26	2001-12-26 00:00:00	2002-01-02	2002-01-02 00:00:00	32020		\N	98719	0	10509002	260139		0
24974	1491	4027663	1998-10-29	1998-10-29 00:00:00	\N	\N	32020		\N	99447	0	13200003	4027663		0
25101	1497	40481087	1999-04-15	1999-04-15 00:00:00	1999-04-29	1999-04-29 00:00:00	32020		\N	99883	0	444814009	40481087		0
25250	1506	4112343	1948-01-12	1948-01-12 00:00:00	1948-01-23	1948-01-23 00:00:00	32020		\N	100399	0	195662009	4112343		0
25498	1517	80180	1981-04-09	1981-04-09 00:00:00	\N	\N	32020		\N	101440	0	396275006	80180		0
25659	1525	4112343	1976-01-05	1976-01-05 00:00:00	1976-01-17	1976-01-17 00:00:00	32020		\N	101963	0	195662009	4112343		0
25846	1535	40481087	2011-08-11	2011-08-11 00:00:00	2011-08-25	2011-08-25 00:00:00	32020		\N	102703	0	444814009	40481087		0
25978	1541	40481087	1964-02-01	1964-02-01 00:00:00	1964-02-15	1964-02-15 00:00:00	32020		\N	103239	0	444814009	40481087		0
26123	1550	40481087	1990-10-03	1990-10-03 00:00:00	1990-10-17	1990-10-17 00:00:00	32020		\N	103767	0	444814009	40481087		0
26295	1560	40481087	1968-09-22	1968-09-22 00:00:00	1968-09-29	1968-09-29 00:00:00	32020		\N	104502	0	444814009	40481087		0
26407	1567	40481087	2009-12-20	2009-12-20 00:00:00	2010-01-10	2010-01-10 00:00:00	32020		\N	105132	0	444814009	40481087		0
26616	1577	4113008	2013-12-16	2013-12-16 00:00:00	2014-01-06	2014-01-06 00:00:00	32020		\N	105933	0	284549007	4113008		0
26794	1586	195588	1966-03-05	1966-03-05 00:00:00	1966-04-19	1966-04-19 00:00:00	32020		\N	106385	0	38822007	195588		0
26908	1593	4112343	1959-06-22	1959-06-22 00:00:00	1959-07-03	1959-07-03 00:00:00	32020		\N	106941	0	195662009	4112343		0
27092	1602	4112343	2006-08-07	2006-08-07 00:00:00	2006-08-15	2006-08-15 00:00:00	32020		\N	107506	0	195662009	4112343		0
27304	1609	4112343	2008-09-24	2008-09-24 00:00:00	2008-10-02	2008-10-02 00:00:00	32020		\N	108139	0	195662009	4112343		0
27515	1623	4112343	1953-11-17	1953-11-17 00:00:00	1953-11-29	1953-11-29 00:00:00	32020		\N	109131	0	195662009	4112343		0
27638	1632	4294548	1983-03-08	1983-03-08 00:00:00	1983-06-01	1983-06-01 00:00:00	32020		\N	109620	0	75498004	4294548		0
27843	1642	80180	1990-09-24	1990-09-24 00:00:00	\N	\N	32020		\N	110268	0	396275006	80180		0
28052	1658	4285898	1947-02-11	1947-02-11 00:00:00	\N	\N	32020		\N	111322	0	68496003	4285898		0
28104	1658	378001	1912-04-25	1912-04-25 00:00:00	1912-05-25	1912-05-25 00:00:00	32020		\N	111373	0	62106007	378001		0
28298	1672	4112343	1962-08-20	1962-08-20 00:00:00	1962-09-01	1962-09-01 00:00:00	32020		\N	112221	0	195662009	4112343		0
28499	1686	40481087	1993-07-08	1993-07-08 00:00:00	1993-07-29	1993-07-29 00:00:00	32020		\N	112986	0	444814009	40481087		0
28561	1690	40481087	2003-10-01	2003-10-01 00:00:00	2003-10-15	2003-10-15 00:00:00	32020		\N	113198	0	444814009	40481087		0
28778	1703	40481087	1952-04-21	1952-04-21 00:00:00	1952-04-28	1952-04-28 00:00:00	32020		\N	113890	0	444814009	40481087		0
28925	1713	28060	2013-05-19	2013-05-19 00:00:00	2013-05-27	2013-05-27 00:00:00	32020		\N	114497	0	43878008	28060		0
29077	1720	4283893	2011-12-08	2011-12-08 00:00:00	2012-05-17	2012-05-17 00:00:00	32020		\N	115006	0	36971009	4283893		0
29293	1736	80180	2010-01-13	2010-01-13 00:00:00	\N	\N	32020		\N	115956	0	396275006	80180		0
29428	1743	40481087	2015-08-21	2015-08-21 00:00:00	2015-09-04	2015-09-04 00:00:00	32020		\N	116553	0	444814009	40481087		0
29595	1751	40481087	2017-10-22	2017-10-22 00:00:00	2017-10-29	2017-10-29 00:00:00	32020		\N	117052	0	444814009	40481087		0
29737	1760	260139	2015-01-02	2015-01-02 00:00:00	2015-01-16	2015-01-16 00:00:00	32020		\N	117694	0	10509002	260139		0
29964	1773	4048171	1954-09-01	1954-09-01 00:00:00	\N	\N	32020		\N	118503	0	232353008	4048171		0
30159	1782	378001	2005-02-11	2005-02-11 00:00:00	2005-04-12	2005-04-12 00:00:00	32020		\N	119343	0	62106007	378001		0
30280	1788	40481087	1997-03-22	1997-03-22 00:00:00	1997-03-29	1997-03-29 00:00:00	32020		\N	119794	0	444814009	40481087		0
41009	2438	80180	2016-08-27	2016-08-27 00:00:00	\N	\N	32020		\N	161773	0	396275006	80180		0
30617	1808	40481087	1963-07-10	1963-07-10 00:00:00	1963-07-31	1963-07-31 00:00:00	32020		\N	121069	0	444814009	40481087		0
30791	1821	440086	1947-07-02	1947-07-02 00:00:00	1955-07-10	1955-07-10 00:00:00	32020		\N	121815	0	192127007	440086		0
30912	1829	40481087	1972-01-01	1972-01-01 00:00:00	1972-01-22	1972-01-22 00:00:00	32020		\N	122273	0	444814009	40481087		0
31123	1843	40481087	2002-12-08	2002-12-08 00:00:00	2002-12-15	2002-12-15 00:00:00	32020		\N	123073	0	444814009	40481087		0
31263	1848	372328	1962-04-13	1962-04-13 00:00:00	1962-09-20	1962-09-20 00:00:00	32020		\N	123604	0	65363002	372328		0
31465	1860	40481087	1973-11-12	1973-11-12 00:00:00	1973-11-19	1973-11-19 00:00:00	32020		\N	124357	0	444814009	40481087		0
31546	1867	372328	1977-01-13	1977-01-13 00:00:00	1977-03-01	1977-03-01 00:00:00	32020		\N	124698	0	65363002	372328		0
31851	1892	260139	1981-03-28	1981-03-28 00:00:00	1981-04-04	1981-04-04 00:00:00	32020		\N	126027	0	10509002	260139		0
21329	1280	4109685	2017-04-28	2017-04-28 00:00:00	2017-05-12	2017-05-12 00:00:00	32020		\N	84527	0	284551006	4109685		0
21553	1292	4112343	1986-05-04	1986-05-04 00:00:00	1986-05-15	1986-05-15 00:00:00	32020		\N	85426	0	195662009	4112343		0
22179	1323	40481087	1977-05-27	1977-05-27 00:00:00	1977-06-17	1977-06-17 00:00:00	32020		\N	87873	0	444814009	40481087		0
22300	1332	40481087	2010-01-13	2010-01-13 00:00:00	2010-01-20	2010-01-20 00:00:00	32020		\N	88369	0	444814009	40481087		0
22466	1340	260139	1916-06-04	1916-06-04 00:00:00	1916-06-18	1916-06-18 00:00:00	32020		\N	88934	0	10509002	260139		0
22645	1353	260139	1985-06-12	1985-06-12 00:00:00	1985-06-19	1985-06-19 00:00:00	32020		\N	89661	0	10509002	260139		0
22821	1360	195588	2014-09-25	2014-09-25 00:00:00	2014-11-06	2014-11-06 00:00:00	32020		\N	90285	0	38822007	195588		0
22917	1367	81151	1966-04-25	1966-04-25 00:00:00	1966-05-30	1966-05-30 00:00:00	32020		\N	90619	0	44465007	81151		0
23095	1379	80180	1998-11-20	1998-11-20 00:00:00	\N	\N	32020		\N	91517	0	396275006	80180		0
23297	1390	4294548	2000-09-17	2000-09-17 00:00:00	2000-10-08	2000-10-08 00:00:00	32020		\N	92271	0	75498004	4294548		0
23466	1401	4237458	1987-03-14	1987-03-14 00:00:00	1987-05-13	1987-05-13 00:00:00	32020		\N	93178	0	58150001	4237458		0
23637	1410	80180	2004-05-25	2004-05-25 00:00:00	\N	\N	32020		\N	93891	0	396275006	80180		0
23868	1426	4112343	2000-01-26	2000-01-26 00:00:00	2000-02-04	2000-02-04 00:00:00	32020		\N	94807	0	195662009	4112343		0
23936	1430	260139	2000-09-02	2000-09-02 00:00:00	2000-09-16	2000-09-16 00:00:00	32020		\N	95158	0	10509002	260139		0
24210	1442	4296204	1975-07-03	1975-07-03 00:00:00	1975-07-24	1975-07-24 00:00:00	32020		\N	96186	0	403190006	4296204		0
24336	1450	260139	1979-04-29	1979-04-29 00:00:00	1979-05-06	1979-05-06 00:00:00	32020		\N	96739	0	10509002	260139		0
24404	1454	372328	1973-09-29	1973-09-29 00:00:00	1974-02-15	1974-02-15 00:00:00	32020		\N	97029	0	65363002	372328		0
24582	1467	4112343	2012-02-27	2012-02-27 00:00:00	2012-03-09	2012-03-09 00:00:00	32020		\N	97673	0	195662009	4112343		0
24825	1480	40481087	1968-03-20	1968-03-20 00:00:00	1968-04-10	1968-04-10 00:00:00	32020		\N	98751	0	444814009	40481087		0
24975	1491	317576	1997-02-18	1997-02-18 00:00:00	\N	\N	32020		\N	99447	0	53741008	317576		0
25102	1497	4112343	2014-08-10	2014-08-10 00:00:00	2014-08-23	2014-08-23 00:00:00	32020		\N	99907	0	195662009	4112343		0
25251	1506	28060	1975-12-30	1975-12-30 00:00:00	1976-01-10	1976-01-10 00:00:00	32020		\N	100402	0	43878008	28060		0
25499	1517	40481087	1955-10-05	1955-10-05 00:00:00	1955-10-12	1955-10-12 00:00:00	32020		\N	101359	0	444814009	40481087		0
25660	1525	4112343	1968-12-03	1968-12-03 00:00:00	1968-12-10	1968-12-10 00:00:00	32020		\N	101972	0	195662009	4112343		0
25847	1535	28060	1999-10-19	1999-10-19 00:00:00	1999-10-28	1999-10-28 00:00:00	32020		\N	102739	0	43878008	28060		0
25979	1541	28060	1972-08-04	1972-08-04 00:00:00	1972-08-16	1972-08-16 00:00:00	32020		\N	103240	0	43878008	28060		0
26124	1550	78272	2015-03-11	2015-03-11 00:00:00	2015-04-15	2015-04-15 00:00:00	32020		\N	103774	0	70704007	78272		0
26296	1560	40481087	2016-03-09	2016-03-09 00:00:00	2016-03-23	2016-03-23 00:00:00	32020		\N	104484	0	444814009	40481087		0
26408	1567	40481087	1986-07-09	1986-07-09 00:00:00	1986-07-16	1986-07-16 00:00:00	32020		\N	105144	0	444814009	40481087		0
26617	1577	40481087	1931-04-07	1931-04-07 00:00:00	1931-04-21	1931-04-21 00:00:00	32020		\N	105925	0	444814009	40481087		0
26795	1586	4278672	1964-03-12	1964-03-12 00:00:00	1964-05-11	1964-05-11 00:00:00	32020		\N	106388	0	65966004	4278672		0
26909	1593	4027663	1964-10-03	1964-10-03 00:00:00	\N	\N	32020		\N	106831	0	13200003	4027663		0
27093	1602	80180	2001-11-23	2001-11-23 00:00:00	\N	\N	32020		\N	107505	0	396275006	80180		0
27305	1609	4112343	1994-04-27	1994-04-27 00:00:00	1994-05-08	1994-05-08 00:00:00	32020		\N	108111	0	195662009	4112343		0
27516	1623	40481087	1999-08-02	1999-08-02 00:00:00	1999-08-16	1999-08-16 00:00:00	32020		\N	109113	0	444814009	40481087		0
27639	1632	321042	1988-11-13	1988-11-13 00:00:00	\N	\N	32020		\N	109551	0	410429000	321042		0
27844	1642	40481087	1977-08-09	1977-08-09 00:00:00	1977-08-16	1977-08-16 00:00:00	32020		\N	110249	0	444814009	40481087		0
28053	1658	80180	1948-01-07	1948-01-07 00:00:00	\N	\N	32020		\N	111322	0	396275006	80180		0
28105	1658	81151	1978-08-24	1978-08-24 00:00:00	1978-09-21	1978-09-21 00:00:00	32020		\N	111377	0	44465007	81151		0
28299	1672	40481087	1988-01-22	1988-01-22 00:00:00	1988-02-05	1988-02-05 00:00:00	32020		\N	112257	0	444814009	40481087		0
28500	1686	40481087	1990-02-05	1990-02-05 00:00:00	1990-02-19	1990-02-19 00:00:00	32020		\N	112952	0	444814009	40481087		0
28562	1690	257012	2012-09-12	2012-09-12 00:00:00	\N	\N	32020		\N	113221	0	40055000	257012		0
28779	1703	4112343	1977-08-07	1977-08-07 00:00:00	1977-08-14	1977-08-14 00:00:00	32020		\N	113922	0	195662009	4112343		0
28926	1713	257012	1982-12-20	1982-12-20 00:00:00	\N	\N	32020		\N	114464	0	40055000	257012		0
29078	1720	4109685	2009-12-23	2009-12-23 00:00:00	2010-01-06	2010-01-06 00:00:00	32020		\N	115003	0	284551006	4109685		0
29294	1736	40481087	2016-06-23	2016-06-23 00:00:00	2016-07-14	2016-07-14 00:00:00	32020		\N	115893	0	444814009	40481087		0
29430	1743	4156265	2012-03-24	2012-03-24 00:00:00	2012-04-14	2012-04-14 00:00:00	32020		\N	116512	0	370247008	4156265		0
29596	1751	4134304	1987-05-28	1987-05-28 00:00:00	1987-06-27	1987-06-27 00:00:00	32020		\N	117078	0	263102004	4134304		0
29738	1760	372328	1979-02-23	1979-02-23 00:00:00	1979-05-27	1979-05-27 00:00:00	32020		\N	117676	0	65363002	372328		0
29965	1773	4112343	2011-07-20	2011-07-20 00:00:00	2011-08-02	2011-08-02 00:00:00	32020		\N	118605	0	195662009	4112343		0
30160	1782	4237458	1968-12-01	1968-12-01 00:00:00	1969-03-01	1969-03-01 00:00:00	32020		\N	119341	0	58150001	4237458		0
30281	1788	381316	2018-05-24	2018-05-24 00:00:00	\N	\N	32020		\N	119803	0	230690007	381316		0
41010	2438	4112343	1989-07-19	1989-07-19 00:00:00	1989-07-30	1989-07-30 00:00:00	32020		\N	161769	0	195662009	4112343		0
30618	1808	4112343	1969-06-03	1969-06-03 00:00:00	1969-06-10	1969-06-10 00:00:00	32020		\N	121047	0	195662009	4112343		0
30792	1821	4048695	1967-05-31	1967-05-31 00:00:00	1967-07-31	1967-07-31 00:00:00	32020		\N	121773	0	15724005	4048695		0
30913	1829	40481087	1984-02-26	1984-02-26 00:00:00	1984-03-18	1984-03-18 00:00:00	32020		\N	122313	0	444814009	40481087		0
31124	1844	260139	1994-10-31	1994-10-31 00:00:00	1994-11-14	1994-11-14 00:00:00	32020		\N	123161	0	10509002	260139		0
31264	1848	4278672	1985-04-03	1985-04-03 00:00:00	1985-05-03	1985-05-03 00:00:00	32020		\N	123647	0	65966004	4278672		0
31466	1860	372328	1960-12-15	1960-12-15 00:00:00	1961-04-03	1961-04-03 00:00:00	32020		\N	124376	0	65363002	372328		0
31547	1867	4112343	1985-01-01	1985-01-01 00:00:00	1985-01-11	1985-01-11 00:00:00	32020		\N	124704	0	195662009	4112343		0
31852	1892	4112343	1987-12-16	1987-12-16 00:00:00	1987-12-29	1987-12-29 00:00:00	32020		\N	126034	0	195662009	4112343		0
21330	1280	4112343	1974-07-02	1974-07-02 00:00:00	1974-07-09	1974-07-09 00:00:00	32020		\N	84557	0	195662009	4112343		0
21554	1292	40486433	1954-08-21	1954-08-21 00:00:00	\N	\N	32020		\N	85418	0	446096008	40486433		0
21694	1303	40481087	2013-07-17	2013-07-17 00:00:00	2013-08-07	2013-08-07 00:00:00	32020		\N	86027	0	444814009	40481087		0
21883	1313	260139	1993-12-22	1993-12-22 00:00:00	1993-12-29	1993-12-29 00:00:00	32020		\N	86918	0	10509002	260139		0
21939	1315	40481087	1989-10-06	1989-10-06 00:00:00	1989-10-20	1989-10-20 00:00:00	32020		\N	87130	0	444814009	40481087		0
22180	1323	80180	2005-02-09	2005-02-09 00:00:00	\N	\N	32020		\N	87859	0	396275006	80180		0
22301	1332	4112343	2008-01-29	2008-01-29 00:00:00	2008-02-08	2008-02-08 00:00:00	32020		\N	88349	0	195662009	4112343		0
22467	1340	260139	1986-09-09	1986-09-09 00:00:00	1986-09-23	1986-09-23 00:00:00	32020		\N	88958	0	10509002	260139		0
22646	1353	40481087	1969-06-23	1969-06-23 00:00:00	1969-07-14	1969-07-14 00:00:00	32020		\N	89631	0	444814009	40481087		0
22822	1360	4027663	2008-09-26	2008-09-26 00:00:00	\N	\N	32020		\N	90279	0	13200003	4027663		0
22918	1367	372328	1981-08-25	1981-08-25 00:00:00	1982-06-18	1982-06-18 00:00:00	32020		\N	90596	0	65363002	372328		0
23096	1379	372328	1979-04-04	1979-04-04 00:00:00	1982-03-27	1982-03-27 00:00:00	32020		\N	91498	0	65363002	372328		0
23298	1390	4027663	1996-12-22	1996-12-22 00:00:00	\N	\N	32020		\N	92291	0	13200003	4027663		0
23638	1410	30753	2003-05-31	2003-05-31 00:00:00	\N	\N	32020		\N	93891	0	16761005	30753		0
23869	1427	4116491	1986-11-01	1986-11-01 00:00:00	1986-12-24	1986-12-24 00:00:00	32020		\N	94954	0	301011002	4116491		0
23937	1430	40481087	2000-07-13	2000-07-13 00:00:00	2000-07-27	2000-07-27 00:00:00	32020		\N	95132	0	444814009	40481087		0
24211	1443	40481087	1981-03-12	1981-03-12 00:00:00	1981-04-02	1981-04-02 00:00:00	32020		\N	96200	0	444814009	40481087		0
24337	1450	40481087	2002-09-10	2002-09-10 00:00:00	2002-09-24	2002-09-24 00:00:00	32020		\N	96679	0	444814009	40481087		0
24405	1454	40481087	2009-06-14	2009-06-14 00:00:00	2009-07-05	2009-07-05 00:00:00	32020		\N	97028	0	444814009	40481087		0
24583	1467	4112343	2006-03-15	2006-03-15 00:00:00	2006-03-27	2006-03-27 00:00:00	32020		\N	97672	0	195662009	4112343		0
24826	1480	260139	1971-10-24	1971-10-24 00:00:00	1971-11-07	1971-11-07 00:00:00	32020		\N	98704	0	10509002	260139		0
24976	1491	4112343	2002-05-26	2002-05-26 00:00:00	2002-06-04	2002-06-04 00:00:00	32020		\N	99406	0	195662009	4112343		0
25103	1497	40481087	1993-03-06	1993-03-06 00:00:00	1993-03-20	1993-03-20 00:00:00	32020		\N	99805	0	444814009	40481087		0
25252	1506	4112343	1971-02-01	1971-02-01 00:00:00	1971-02-09	1971-02-09 00:00:00	32020		\N	100401	0	195662009	4112343		0
25500	1517	4112343	1954-09-04	1954-09-04 00:00:00	1954-09-15	1954-09-15 00:00:00	32020		\N	101455	0	195662009	4112343		0
25661	1525	4285898	1998-02-13	1998-02-13 00:00:00	\N	\N	32020		\N	101983	0	68496003	4285898		0
25848	1535	4112343	2016-03-31	2016-03-31 00:00:00	2016-04-10	2016-04-10 00:00:00	32020		\N	102756	0	195662009	4112343		0
25980	1541	40481087	1986-05-10	1986-05-10 00:00:00	1986-05-31	1986-05-31 00:00:00	32020		\N	103235	0	444814009	40481087		0
26125	1550	4112343	1993-10-08	1993-10-08 00:00:00	1993-10-21	1993-10-21 00:00:00	32020		\N	103757	0	195662009	4112343		0
26297	1560	40481087	1949-05-19	1949-05-19 00:00:00	1949-06-09	1949-06-09 00:00:00	32020		\N	104440	0	444814009	40481087		0
26409	1567	40481087	2016-04-10	2016-04-10 00:00:00	2016-04-17	2016-04-17 00:00:00	32020		\N	105134	0	444814009	40481087		0
26618	1577	260139	2003-05-15	2003-05-15 00:00:00	2003-05-22	2003-05-22 00:00:00	32020		\N	105878	0	10509002	260139		0
26796	1586	81151	1954-06-21	1954-06-21 00:00:00	1954-07-19	1954-07-19 00:00:00	32020		\N	106386	0	44465007	81151		0
26910	1593	40481087	1983-06-22	1983-06-22 00:00:00	1983-07-06	1983-07-06 00:00:00	32020		\N	106890	0	444814009	40481087		0
27094	1602	40481087	1988-11-22	1988-11-22 00:00:00	1988-12-13	1988-12-13 00:00:00	32020		\N	107557	0	444814009	40481087		0
27306	1609	4059173	1993-10-13	1993-10-13 00:00:00	1994-01-10	1994-01-10 00:00:00	32020		\N	108163	0	16114001	4059173		0
27517	1623	40481087	1987-12-30	1987-12-30 00:00:00	1988-01-13	1988-01-13 00:00:00	32020		\N	109126	0	444814009	40481087		0
27641	1632	4294548	1993-12-07	1993-12-07 00:00:00	1993-12-21	1993-12-21 00:00:00	32020		\N	109571	0	75498004	4294548		0
27845	1642	40481087	1973-07-10	1973-07-10 00:00:00	1973-07-24	1973-07-24 00:00:00	32020		\N	110248	0	444814009	40481087		0
28054	1658	4266809	1948-01-07	1948-01-07 00:00:00	\N	\N	32020		\N	111322	0	397881000	4266809		0
28106	1658	260139	1928-07-31	1928-07-31 00:00:00	1928-08-14	1928-08-14 00:00:00	32020		\N	111320	0	10509002	260139		0
28300	1672	4112343	2011-07-18	2011-07-18 00:00:00	2011-07-26	2011-07-26 00:00:00	32020		\N	112258	0	195662009	4112343		0
28501	1686	4283893	1998-05-03	1998-05-03 00:00:00	1998-07-19	1998-07-19 00:00:00	32020		\N	112934	0	36971009	4283893		0
28563	1690	4278672	1978-05-10	1978-05-10 00:00:00	1978-08-08	1978-08-08 00:00:00	32020		\N	113159	0	65966004	4278672		0
28780	1703	4112343	2016-04-05	2016-04-05 00:00:00	2016-04-16	2016-04-16 00:00:00	32020		\N	113855	0	195662009	4112343		0
28927	1713	4116491	2004-09-27	2004-09-27 00:00:00	2004-11-02	2004-11-02 00:00:00	32020		\N	114465	0	301011002	4116491		0
29079	1720	40481087	2012-10-20	2012-10-20 00:00:00	2012-11-03	2012-11-03 00:00:00	32020		\N	115009	0	444814009	40481087		0
29295	1736	4283893	2003-12-31	2003-12-31 00:00:00	2004-02-25	2004-02-25 00:00:00	32020		\N	115902	0	36971009	4283893		0
29431	1743	4278672	1965-12-30	1965-12-30 00:00:00	1966-01-29	1966-01-29 00:00:00	32020		\N	116506	0	65966004	4278672		0
29597	1751	4109685	2004-03-18	2004-03-18 00:00:00	2004-04-01	2004-04-01 00:00:00	32020		\N	117081	0	284551006	4109685		0
29739	1760	372328	1980-05-21	1980-05-21 00:00:00	1980-09-14	1980-09-14 00:00:00	32020		\N	117677	0	65363002	372328		0
29966	1773	4146173	1960-11-06	1960-11-06 00:00:00	1960-12-06	1960-12-06 00:00:00	32020		\N	118534	0	307731004	4146173		0
30161	1782	198809	1956-01-11	1956-01-11 00:00:00	1956-01-11	1956-01-11 00:00:00	32020		\N	119339	0	65275009	198809		0
30282	1788	4112343	1999-05-13	1999-05-13 00:00:00	1999-05-24	1999-05-24 00:00:00	32020		\N	119827	0	195662009	4112343		0
41011	2438	40481087	1991-05-05	1991-05-05 00:00:00	1991-05-12	1991-05-12 00:00:00	32020		\N	161737	0	444814009	40481087		0
30619	1808	4112343	1986-10-10	1986-10-10 00:00:00	1986-10-22	1986-10-22 00:00:00	32020		\N	121073	0	195662009	4112343		0
30793	1821	4112343	1972-12-22	1972-12-22 00:00:00	1973-01-04	1973-01-04 00:00:00	32020		\N	121853	0	195662009	4112343		0
30914	1829	40481087	2009-06-30	2009-06-30 00:00:00	2009-07-21	2009-07-21 00:00:00	32020		\N	122306	0	444814009	40481087		0
31125	1844	4027663	1992-03-29	1992-03-29 00:00:00	\N	\N	32020		\N	123159	0	13200003	4027663		0
31265	1848	313217	2011-02-17	2011-02-17 00:00:00	\N	\N	32020		\N	123636	0	49436004	313217		0
31467	1860	4112343	1994-11-04	1994-11-04 00:00:00	1994-11-15	1994-11-15 00:00:00	32020		\N	124361	0	195662009	4112343		0
31548	1867	80180	2006-07-04	2006-07-04 00:00:00	\N	\N	32020		\N	124732	0	396275006	80180		0
31853	1892	378001	1984-04-12	1984-04-12 00:00:00	1984-06-11	1984-06-11 00:00:00	32020		\N	126048	0	62106007	378001		0
21331	1280	4218389	1975-03-05	1975-03-05 00:00:00	1975-04-02	1975-04-02 00:00:00	32020		\N	84526	0	39848009	4218389		0
21555	1292	4218389	1960-05-24	1960-05-24 00:00:00	1960-06-28	1960-06-28 00:00:00	32020		\N	85411	0	39848009	4218389		0
21695	1303	260139	1977-02-18	1977-02-18 00:00:00	1977-02-25	1977-02-25 00:00:00	32020		\N	86061	0	10509002	260139		0
21884	1313	4112343	1997-09-28	1997-09-28 00:00:00	1997-10-07	1997-10-07 00:00:00	32020		\N	86928	0	195662009	4112343		0
21940	1315	4112343	1982-03-06	1982-03-06 00:00:00	1982-03-15	1982-03-15 00:00:00	32020		\N	87129	0	195662009	4112343		0
22181	1323	4134304	1987-05-11	1987-05-11 00:00:00	1987-07-10	1987-07-10 00:00:00	32020		\N	87846	0	263102004	4134304		0
22302	1332	257012	2014-09-15	2014-09-15 00:00:00	\N	\N	32020		\N	88370	0	40055000	257012		0
22468	1340	40481087	1914-10-31	1914-10-31 00:00:00	1914-11-14	1914-11-14 00:00:00	32020		\N	88933	0	444814009	40481087		0
22647	1353	28060	1980-12-26	1980-12-26 00:00:00	1981-01-08	1981-01-08 00:00:00	32020		\N	89660	0	43878008	28060		0
22823	1360	4112343	1985-04-17	1985-04-17 00:00:00	1985-04-25	1985-04-25 00:00:00	32020		\N	90233	0	195662009	4112343		0
22919	1367	4112343	1997-05-23	1997-05-23 00:00:00	1997-05-31	1997-05-31 00:00:00	32020		\N	90588	0	195662009	4112343		0
23097	1379	78272	1986-07-31	1986-07-31 00:00:00	1986-09-04	1986-09-04 00:00:00	32020		\N	91514	0	70704007	78272		0
23299	1390	30753	2006-07-13	2006-07-13 00:00:00	\N	\N	32020		\N	92292	0	16761005	30753		0
23468	1401	80180	2007-08-03	2007-08-03 00:00:00	\N	\N	32020		\N	93165	0	396275006	80180		0
23639	1410	4310024	2002-08-04	2002-08-04 00:00:00	\N	\N	32020		\N	93891	0	424802006	4310024		0
23870	1427	4296205	2008-08-26	2008-08-26 00:00:00	2008-09-09	2008-09-09 00:00:00	32020		\N	94963	0	403191005	4296205		0
23938	1430	40481087	1995-02-20	1995-02-20 00:00:00	1995-03-06	1995-03-06 00:00:00	32020		\N	95156	0	444814009	40481087		0
24212	1443	80180	2014-05-31	2014-05-31 00:00:00	\N	\N	32020		\N	96227	0	396275006	80180		0
24338	1450	4112343	1983-10-25	1983-10-25 00:00:00	1983-11-07	1983-11-07 00:00:00	32020		\N	96719	0	195662009	4112343		0
24406	1454	80180	2009-11-14	2009-11-14 00:00:00	\N	\N	32020		\N	97028	0	396275006	80180		0
24584	1467	4116491	1955-03-21	1955-03-21 00:00:00	1955-05-04	1955-05-04 00:00:00	32020		\N	97775	0	301011002	4116491		0
24827	1480	378001	1996-11-14	1996-11-14 00:00:00	1997-01-13	1997-01-13 00:00:00	32020		\N	98763	0	62106007	378001		0
24977	1491	4059173	1982-04-26	1982-04-26 00:00:00	1982-07-25	1982-07-25 00:00:00	32020		\N	99451	0	16114001	4059173		0
25104	1497	4142905	1975-11-05	1975-11-05 00:00:00	1975-12-05	1975-12-05 00:00:00	32020		\N	99780	0	33737001	4142905		0
25253	1506	4112343	1978-11-28	1978-11-28 00:00:00	1978-12-08	1978-12-08 00:00:00	32020		\N	100413	0	195662009	4112343		0
25501	1517	40481087	1940-10-24	1940-10-24 00:00:00	1940-11-07	1940-11-07 00:00:00	32020		\N	101419	0	444814009	40481087		0
25662	1525	80180	1998-10-11	1998-10-11 00:00:00	\N	\N	32020		\N	101983	0	396275006	80180		0
25849	1535	260139	1980-09-20	1980-09-20 00:00:00	1980-09-27	1980-09-27 00:00:00	32020		\N	102749	0	10509002	260139		0
25981	1541	378001	2002-01-16	2002-01-16 00:00:00	2002-03-17	2002-03-17 00:00:00	32020		\N	103302	0	62106007	378001		0
26126	1550	40481087	1985-05-20	1985-05-20 00:00:00	1985-05-27	1985-05-27 00:00:00	32020		\N	103804	0	444814009	40481087		0
26298	1560	40481087	1982-11-22	1982-11-22 00:00:00	1982-11-29	1982-11-29 00:00:00	32020		\N	104450	0	444814009	40481087		0
26410	1567	260139	1981-11-21	1981-11-21 00:00:00	1981-12-05	1981-12-05 00:00:00	32020		\N	105079	0	10509002	260139		0
26619	1577	40481087	1954-09-17	1954-09-17 00:00:00	1954-09-24	1954-09-24 00:00:00	32020		\N	105835	0	444814009	40481087		0
26797	1586	260139	1954-10-20	1954-10-20 00:00:00	1954-11-03	1954-11-03 00:00:00	32020		\N	106449	0	10509002	260139		0
26911	1593	372328	1976-02-04	1976-02-04 00:00:00	1976-08-12	1976-08-12 00:00:00	32020		\N	106828	0	65363002	372328		0
27095	1602	260139	1967-10-25	1967-10-25 00:00:00	1967-11-08	1967-11-08 00:00:00	32020		\N	107527	0	10509002	260139		0
27307	1609	40481087	1961-06-05	1961-06-05 00:00:00	1961-06-26	1961-06-26 00:00:00	32020		\N	108167	0	444814009	40481087		0
27518	1623	80180	1988-12-17	1988-12-17 00:00:00	\N	\N	32020		\N	109126	0	396275006	80180		0
27642	1632	4112343	1989-09-10	1989-09-10 00:00:00	1989-09-21	1989-09-21 00:00:00	32020		\N	109570	0	195662009	4112343		0
27846	1642	257012	1966-07-14	1966-07-14 00:00:00	\N	\N	32020		\N	110278	0	40055000	257012		0
38513	2287	313217	2004-05-21	2004-05-21 00:00:00	\N	\N	32020		\N	152146	0	49436004	313217		0
28107	1659	260139	1980-01-29	1980-01-29 00:00:00	1980-02-05	1980-02-05 00:00:00	32020		\N	111486	0	10509002	260139		0
28301	1672	4112343	1966-09-11	1966-09-11 00:00:00	1966-09-18	1966-09-18 00:00:00	32020		\N	112240	0	195662009	4112343		0
28502	1686	28060	1969-03-11	1969-03-11 00:00:00	1969-03-21	1969-03-21 00:00:00	32020		\N	112931	0	43878008	28060		0
28564	1690	4112343	1983-01-07	1983-01-07 00:00:00	1983-01-14	1983-01-14 00:00:00	32020		\N	113164	0	195662009	4112343		0
28781	1703	40481087	1966-12-04	1966-12-04 00:00:00	1966-12-11	1966-12-11 00:00:00	32020		\N	113891	0	444814009	40481087		0
28928	1713	192671	2010-07-22	2010-07-22 00:00:00	\N	\N	32020		\N	114477	0	K92.2	35208414		0
29080	1720	260139	1991-09-26	1991-09-26 00:00:00	1991-10-03	1991-10-03 00:00:00	32020		\N	115030	0	10509002	260139		0
29296	1736	257012	1976-01-17	1976-01-17 00:00:00	\N	\N	32020		\N	115886	0	40055000	257012		0
29432	1743	260139	2012-06-21	2012-06-21 00:00:00	2012-07-05	2012-07-05 00:00:00	32020		\N	116552	0	10509002	260139		0
29598	1751	28060	1990-05-07	1990-05-07 00:00:00	1990-05-17	1990-05-17 00:00:00	32020		\N	117058	0	43878008	28060		0
29740	1760	192671	2017-09-23	2017-09-23 00:00:00	\N	\N	32020		\N	117691	0	K92.2	35208414		0
29967	1773	372328	1957-04-26	1957-04-26 00:00:00	1957-08-11	1957-08-11 00:00:00	32020		\N	118624	0	65363002	372328		0
30162	1782	196456	1956-01-11	1956-01-11 00:00:00	1956-01-11	1956-01-11 00:00:00	32020		\N	119339	0	235919008	196456		0
30283	1788	4112343	1976-03-05	1976-03-05 00:00:00	1976-03-16	1976-03-16 00:00:00	32020		\N	119842	0	195662009	4112343		0
41012	2438	4294548	2005-09-22	2005-09-22 00:00:00	2005-11-24	2005-11-24 00:00:00	32020		\N	161752	0	75498004	4294548		0
30620	1808	40481087	1993-08-05	1993-08-05 00:00:00	1993-08-12	1993-08-12 00:00:00	32020		\N	121049	0	444814009	40481087		0
30794	1821	40481087	1981-07-04	1981-07-04 00:00:00	1981-07-11	1981-07-11 00:00:00	32020		\N	121813	0	444814009	40481087		0
30915	1829	4116491	2005-06-24	2005-06-24 00:00:00	2005-08-11	2005-08-11 00:00:00	32020		\N	122274	0	301011002	4116491		0
31126	1844	4296204	1986-07-28	1986-07-28 00:00:00	1986-08-11	1986-08-11 00:00:00	32020		\N	123182	0	403190006	4296204		0
31266	1848	134438	1967-09-16	1967-09-16 00:00:00	1969-07-07	1969-07-07 00:00:00	32020		\N	123594	0	40275004	134438		0
31468	1860	81893	1995-01-11	1995-01-11 00:00:00	\N	\N	32020		\N	124361	0	64766004	81893		0
31549	1867	40481087	1982-07-17	1982-07-17 00:00:00	1982-07-31	1982-07-31 00:00:00	32020		\N	124675	0	444814009	40481087		0
31854	1892	4059173	1974-07-13	1974-07-13 00:00:00	1974-09-11	1974-09-11 00:00:00	32020		\N	126046	0	16114001	4059173		0
21332	1280	40481087	1974-01-13	1974-01-13 00:00:00	1974-01-20	1974-01-20 00:00:00	32020		\N	84556	0	444814009	40481087		0
21556	1292	4112343	1961-07-21	1961-07-21 00:00:00	1961-07-31	1961-07-31 00:00:00	32020		\N	85381	0	195662009	4112343		0
21696	1303	81893	2010-10-12	2010-10-12 00:00:00	\N	\N	32020		\N	86047	0	64766004	81893		0
21885	1313	4112343	1989-07-17	1989-07-17 00:00:00	1989-07-27	1989-07-27 00:00:00	32020		\N	86926	0	195662009	4112343		0
21941	1315	4112343	2010-10-31	2010-10-31 00:00:00	2010-11-13	2010-11-13 00:00:00	32020		\N	87117	0	195662009	4112343		0
22182	1323	28060	1986-07-10	1986-07-10 00:00:00	1986-07-17	1986-07-17 00:00:00	32020		\N	87870	0	43878008	28060		0
22303	1332	40481087	1982-08-28	1982-08-28 00:00:00	1982-09-18	1982-09-18 00:00:00	32020		\N	88385	0	444814009	40481087		0
22469	1340	4294548	1931-03-28	1931-03-28 00:00:00	1931-04-18	1931-04-18 00:00:00	32020		\N	88905	0	75498004	4294548		0
22648	1353	378001	1982-09-23	1982-09-23 00:00:00	1982-10-23	1982-10-23 00:00:00	32020		\N	89642	0	62106007	378001		0
22824	1360	372328	1977-08-30	1977-08-30 00:00:00	1978-01-29	1978-01-29 00:00:00	32020		\N	90269	0	65363002	372328		0
22920	1367	4296204	1980-03-08	1980-03-08 00:00:00	1980-03-22	1980-03-22 00:00:00	32020		\N	90622	0	403190006	4296204		0
23098	1379	4112343	1961-06-11	1961-06-11 00:00:00	1961-06-24	1961-06-24 00:00:00	32020		\N	91489	0	195662009	4112343		0
23300	1390	80180	2006-10-11	2006-10-11 00:00:00	\N	\N	32020		\N	92292	0	396275006	80180		0
23469	1401	4310024	2004-09-17	2004-09-17 00:00:00	\N	\N	32020		\N	93164	0	424802006	4310024		0
23640	1410	4266809	2004-05-25	2004-05-25 00:00:00	\N	\N	32020		\N	93891	0	397881000	4266809		0
23871	1427	4059173	1968-06-03	1968-06-03 00:00:00	1968-07-03	1968-07-03 00:00:00	32020		\N	94958	0	16114001	4059173		0
23939	1430	30753	1984-11-07	1984-11-07 00:00:00	\N	\N	32020		\N	95126	0	16761005	30753		0
24213	1443	4218389	1990-11-03	1990-11-03 00:00:00	1990-12-01	1990-12-01 00:00:00	32020		\N	96191	0	39848009	4218389		0
24339	1450	260139	1995-02-09	1995-02-09 00:00:00	1995-02-16	1995-02-16 00:00:00	32020		\N	96694	0	10509002	260139		0
24407	1454	40481087	2010-10-04	2010-10-04 00:00:00	2010-10-11	2010-10-11 00:00:00	32020		\N	96978	0	444814009	40481087		0
24585	1467	439777	2006-03-08	2006-03-08 00:00:00	\N	\N	32020		\N	97751	0	271737000	439777		0
24828	1480	4155034	1980-03-22	1980-03-22 00:00:00	1980-04-12	1980-04-12 00:00:00	32020		\N	98761	0	283371005	4155034		0
24978	1491	4142905	1995-08-07	1995-08-07 00:00:00	1995-09-06	1995-09-06 00:00:00	32020		\N	99454	0	33737001	4142905		0
25105	1497	4218389	2000-07-26	2000-07-26 00:00:00	2000-08-23	2000-08-23 00:00:00	32020		\N	99781	0	39848009	4218389		0
25254	1506	4112343	1959-07-08	1959-07-08 00:00:00	1959-07-19	1959-07-19 00:00:00	32020		\N	100411	0	195662009	4112343		0
25502	1517	40481087	2014-02-15	2014-02-15 00:00:00	2014-03-01	2014-03-01 00:00:00	32020		\N	101463	0	444814009	40481087		0
25663	1525	81893	1997-09-16	1997-09-16 00:00:00	\N	\N	32020		\N	101983	0	64766004	81893		0
25850	1535	4112343	2015-12-16	2015-12-16 00:00:00	2015-12-28	2015-12-28 00:00:00	32020		\N	102755	0	195662009	4112343		0
25982	1541	4112343	1998-12-29	1998-12-29 00:00:00	1999-01-08	1999-01-08 00:00:00	32020		\N	103249	0	195662009	4112343		0
26127	1550	28060	1981-12-18	1981-12-18 00:00:00	1981-12-25	1981-12-25 00:00:00	32020		\N	103756	0	43878008	28060		0
26299	1560	260139	1963-04-07	1963-04-07 00:00:00	1963-04-14	1963-04-14 00:00:00	32020		\N	104438	0	10509002	260139		0
26411	1567	80180	2008-05-06	2008-05-06 00:00:00	\N	\N	32020		\N	105128	0	396275006	80180		0
26620	1577	260139	1989-10-14	1989-10-14 00:00:00	1989-10-28	1989-10-28 00:00:00	32020		\N	105876	0	10509002	260139		0
26798	1586	40481087	1979-11-11	1979-11-11 00:00:00	1979-12-02	1979-12-02 00:00:00	32020		\N	106393	0	444814009	40481087		0
26912	1593	4112343	1944-10-03	1944-10-03 00:00:00	1944-10-13	1944-10-13 00:00:00	32020		\N	106859	0	195662009	4112343		0
27096	1602	372328	1975-06-13	1975-06-13 00:00:00	1975-12-17	1975-12-17 00:00:00	32020		\N	107560	0	65363002	372328		0
27308	1609	4152936	1950-10-13	1950-10-13 00:00:00	1950-11-03	1950-11-03 00:00:00	32020		\N	108158	0	283385000	4152936		0
27529	1626	28060	1987-10-28	1987-10-28 00:00:00	1987-11-09	1987-11-09 00:00:00	32020		\N	109274	0	43878008	28060		0
27643	1632	40481087	1975-01-28	1975-01-28 00:00:00	1975-02-11	1975-02-11 00:00:00	32020		\N	109559	0	444814009	40481087		0
27847	1642	4294548	2017-03-04	2017-03-04 00:00:00	2017-07-08	2017-07-08 00:00:00	32020		\N	110280	0	75498004	4294548		0
38514	2287	4112343	1988-02-29	1988-02-29 00:00:00	1988-03-08	1988-03-08 00:00:00	32020		\N	152193	0	195662009	4112343		0
28108	1659	4112343	1977-09-13	1977-09-13 00:00:00	1977-09-21	1977-09-21 00:00:00	32020		\N	111557	0	195662009	4112343		0
28302	1672	81893	1987-09-18	1987-09-18 00:00:00	\N	\N	32020		\N	112214	0	64766004	81893		0
28503	1686	378001	2016-12-30	2016-12-30 00:00:00	2017-01-29	2017-01-29 00:00:00	32020		\N	112991	0	62106007	378001		0
28565	1690	4283893	2012-08-15	2012-08-15 00:00:00	2012-10-17	2012-10-17 00:00:00	32020		\N	113177	0	36971009	4283893		0
28782	1703	257012	1950-02-02	1950-02-02 00:00:00	\N	\N	32020		\N	113917	0	40055000	257012		0
28929	1713	40481087	1983-03-16	1983-03-16 00:00:00	1983-03-30	1983-03-30 00:00:00	32020		\N	114449	0	444814009	40481087		0
29111	1724	40481087	1979-11-25	1979-11-25 00:00:00	1979-12-02	1979-12-02 00:00:00	32020		\N	115277	0	444814009	40481087		0
29297	1736	40481087	2000-01-26	2000-01-26 00:00:00	2000-02-09	2000-02-09 00:00:00	32020		\N	115890	0	444814009	40481087		0
29433	1743	372328	1969-01-13	1969-01-13 00:00:00	1970-01-14	1970-01-14 00:00:00	32020		\N	116554	0	65363002	372328		0
29599	1751	40481087	2015-11-18	2015-11-18 00:00:00	2015-11-25	2015-11-25 00:00:00	32020		\N	117050	0	444814009	40481087		0
29741	1760	40481087	2002-01-13	2002-01-13 00:00:00	2002-01-27	2002-01-27 00:00:00	32020		\N	117673	0	444814009	40481087		0
29968	1773	4112343	1974-01-25	1974-01-25 00:00:00	1974-02-05	1974-02-05 00:00:00	32020		\N	118523	0	195662009	4112343		0
30163	1782	28060	2003-09-17	2003-09-17 00:00:00	2003-09-24	2003-09-24 00:00:00	32020		\N	119348	0	43878008	28060		0
30284	1788	372328	1977-09-22	1977-09-22 00:00:00	1978-01-12	1978-01-12 00:00:00	32020		\N	119805	0	65363002	372328		0
41013	2438	4152936	2010-01-21	2010-01-21 00:00:00	2010-02-04	2010-02-04 00:00:00	32020		\N	161756	0	283385000	4152936		0
30621	1808	4218389	1997-11-18	1997-11-18 00:00:00	1997-12-16	1997-12-16 00:00:00	32020		\N	121086	0	39848009	4218389		0
30795	1821	40481087	2000-05-07	2000-05-07 00:00:00	2000-05-28	2000-05-28 00:00:00	32020		\N	121797	0	444814009	40481087		0
30916	1829	40481087	2014-01-01	2014-01-01 00:00:00	2014-01-08	2014-01-08 00:00:00	32020		\N	122275	0	444814009	40481087		0
31127	1844	40481087	1972-07-25	1972-07-25 00:00:00	1972-08-15	1972-08-15 00:00:00	32020		\N	123239	0	444814009	40481087		0
31267	1848	192671	1982-10-10	1982-10-10 00:00:00	\N	\N	32020		\N	123649	0	K92.2	35208414		0
31469	1860	80180	1996-10-02	1996-10-02 00:00:00	\N	\N	32020		\N	124372	0	396275006	80180		0
31550	1867	4146173	2014-06-12	2014-06-12 00:00:00	2014-08-11	2014-08-11 00:00:00	32020		\N	124692	0	307731004	4146173		0
31855	1892	372328	1964-07-23	1964-07-23 00:00:00	1965-06-24	1965-06-24 00:00:00	32020		\N	125977	0	65363002	372328		0
21333	1280	4112343	1975-12-15	1975-12-15 00:00:00	1975-12-23	1975-12-23 00:00:00	32020		\N	84544	0	195662009	4112343		0
21557	1293	80180	1979-07-09	1979-07-09 00:00:00	\N	\N	32020		\N	85522	0	396275006	80180		0
21697	1303	4266809	2012-03-05	2012-03-05 00:00:00	\N	\N	32020		\N	86047	0	397881000	4266809		0
21886	1313	4112343	2012-04-03	2012-04-03 00:00:00	2012-04-14	2012-04-14 00:00:00	32020		\N	86933	0	195662009	4112343		0
21942	1315	4156265	2010-02-21	2010-02-21 00:00:00	2010-03-07	2010-03-07 00:00:00	32020		\N	87108	0	370247008	4156265		0
22183	1323	4152936	1977-12-08	1977-12-08 00:00:00	1977-12-29	1977-12-29 00:00:00	32020		\N	87845	0	283385000	4152936		0
22304	1332	40481087	1962-10-08	1962-10-08 00:00:00	1962-10-22	1962-10-22 00:00:00	32020		\N	88365	0	444814009	40481087		0
22470	1340	378001	2002-01-02	2002-01-02 00:00:00	2002-03-03	2002-03-03 00:00:00	32020		\N	88848	0	62106007	378001		0
22649	1353	4152936	1986-05-05	1986-05-05 00:00:00	1986-05-26	1986-05-26 00:00:00	32020		\N	89643	0	283385000	4152936		0
22825	1360	260139	2015-09-29	2015-09-29 00:00:00	2015-10-06	2015-10-06 00:00:00	32020		\N	90268	0	10509002	260139		0
22921	1367	372328	1965-12-26	1965-12-26 00:00:00	1966-04-08	1966-04-08 00:00:00	32020		\N	90591	0	65363002	372328		0
23099	1379	40481087	2007-02-26	2007-02-26 00:00:00	2007-03-05	2007-03-05 00:00:00	32020		\N	91462	0	444814009	40481087		0
23301	1390	40481087	2006-03-20	2006-03-20 00:00:00	2006-04-03	2006-04-03 00:00:00	32020		\N	92292	0	444814009	40481087		0
23470	1401	81893	2005-04-15	2005-04-15 00:00:00	\N	\N	32020		\N	93164	0	64766004	81893		0
23641	1410	378001	1988-03-08	1988-03-08 00:00:00	1988-05-08	1988-05-08 00:00:00	32020		\N	93836	0	62106007	378001		0
23872	1427	372328	1959-05-15	1959-05-15 00:00:00	1959-10-14	1959-10-14 00:00:00	32020		\N	94924	0	65363002	372328		0
23940	1430	40481087	1984-10-03	1984-10-03 00:00:00	1984-10-10	1984-10-10 00:00:00	32020		\N	95126	0	444814009	40481087		0
24214	1443	4109685	2001-05-13	2001-05-13 00:00:00	2001-06-03	2001-06-03 00:00:00	32020		\N	96193	0	284551006	4109685		0
24340	1450	40481087	1997-05-13	1997-05-13 00:00:00	1997-06-03	1997-06-03 00:00:00	32020		\N	96715	0	444814009	40481087		0
24408	1454	378001	1986-11-20	1986-11-20 00:00:00	1987-01-19	1987-01-19 00:00:00	32020		\N	96985	0	62106007	378001		0
24586	1467	40481087	1997-04-21	1997-04-21 00:00:00	1997-04-28	1997-04-28 00:00:00	32020		\N	97718	0	444814009	40481087		0
24829	1480	4113008	1974-09-06	1974-09-06 00:00:00	1974-09-20	1974-09-20 00:00:00	32020		\N	98760	0	284549007	4113008		0
24979	1491	4112343	1980-10-13	1980-10-13 00:00:00	1980-10-22	1980-10-22 00:00:00	32020		\N	99433	0	195662009	4112343		0
25106	1497	40481087	2003-10-14	2003-10-14 00:00:00	2003-11-04	2003-11-04 00:00:00	32020		\N	99920	0	444814009	40481087		0
25255	1506	372328	1949-01-30	1949-01-30 00:00:00	1949-07-09	1949-07-09 00:00:00	32020		\N	100404	0	65363002	372328		0
25503	1517	4035415	1998-04-29	1998-04-29 00:00:00	1998-05-29	1998-05-29 00:00:00	32020		\N	101447	0	239720000	4035415		0
25664	1525	30753	1997-11-15	1997-11-15 00:00:00	\N	\N	32020		\N	101983	0	16761005	30753		0
25851	1535	260139	1989-01-03	1989-01-03 00:00:00	1989-01-17	1989-01-17 00:00:00	32020		\N	102750	0	10509002	260139		0
25983	1541	40481087	2004-10-28	2004-10-28 00:00:00	2004-11-18	2004-11-18 00:00:00	32020		\N	103243	0	444814009	40481087		0
26128	1550	258780	1996-10-19	1996-10-19 00:00:00	\N	\N	32020		\N	103786	0	185086009	258780		0
26300	1560	40481087	2001-01-12	2001-01-12 00:00:00	2001-01-19	2001-01-19 00:00:00	32020		\N	104503	0	444814009	40481087		0
26412	1567	4084167	1991-09-28	1991-09-28 00:00:00	1991-09-29	1991-09-29 00:00:00	32020		\N	105106	0	241929008	4084167		0
26621	1577	40481087	2015-03-08	2015-03-08 00:00:00	2015-03-29	2015-03-29 00:00:00	32020		\N	105927	0	444814009	40481087		0
26799	1586	257012	1985-12-11	1985-12-11 00:00:00	\N	\N	32020		\N	106430	0	40055000	257012		0
26913	1593	439777	1973-10-01	1973-10-01 00:00:00	\N	\N	32020		\N	106850	0	271737000	439777		0
27097	1602	260139	1969-09-04	1969-09-04 00:00:00	1969-09-18	1969-09-18 00:00:00	32020		\N	107539	0	10509002	260139		0
27319	1611	4112343	1998-12-23	1998-12-23 00:00:00	1999-01-05	1999-01-05 00:00:00	32020		\N	108318	0	195662009	4112343		0
27530	1626	321042	2010-10-10	2010-10-10 00:00:00	\N	\N	32020		\N	109220	0	410429000	321042		0
27644	1632	40481087	2003-05-22	2003-05-22 00:00:00	2003-06-05	2003-06-05 00:00:00	32020		\N	109590	0	444814009	40481087		0
27848	1642	260139	1978-07-15	1978-07-15 00:00:00	1978-07-22	1978-07-22 00:00:00	32020		\N	110255	0	10509002	260139		0
38515	2287	4329847	2001-01-26	2001-01-26 00:00:00	\N	\N	32020		\N	152152	0	22298006	4329847		0
28109	1659	40481087	1986-02-09	1986-02-09 00:00:00	1986-03-02	1986-03-02 00:00:00	32020		\N	111565	0	444814009	40481087		0
28303	1672	40481087	1988-11-07	1988-11-07 00:00:00	1988-11-21	1988-11-21 00:00:00	32020		\N	112241	0	444814009	40481087		0
28504	1686	4112343	2002-04-09	2002-04-09 00:00:00	2002-04-22	2002-04-22 00:00:00	32020		\N	112936	0	195662009	4112343		0
28566	1690	4112343	1999-06-24	1999-06-24 00:00:00	1999-07-07	1999-07-07 00:00:00	32020		\N	113220	0	195662009	4112343		0
28819	1707	372328	1973-10-23	1973-10-23 00:00:00	1974-01-14	1974-01-14 00:00:00	32020		\N	114143	0	65363002	372328		0
28930	1713	4112343	1994-09-18	1994-09-18 00:00:00	1994-09-29	1994-09-29 00:00:00	32020		\N	114467	0	195662009	4112343		0
29112	1724	260139	2015-01-23	2015-01-23 00:00:00	2015-01-30	2015-01-30 00:00:00	32020		\N	115325	0	10509002	260139		0
29298	1736	40481087	1976-06-16	1976-06-16 00:00:00	1976-06-30	1976-06-30 00:00:00	32020		\N	115887	0	444814009	40481087		0
29434	1743	4296204	2006-07-03	2006-07-03 00:00:00	2006-07-24	2006-07-24 00:00:00	32020		\N	116510	0	403190006	4296204		0
29600	1751	260139	2008-04-02	2008-04-02 00:00:00	2008-04-09	2008-04-09 00:00:00	32020		\N	117097	0	10509002	260139		0
29742	1760	4112343	1985-01-21	1985-01-21 00:00:00	1985-01-28	1985-01-28 00:00:00	32020		\N	117655	0	195662009	4112343		0
29969	1773	81151	1988-04-04	1988-04-04 00:00:00	1988-05-02	1988-05-02 00:00:00	32020		\N	118552	0	44465007	81151		0
30164	1782	260139	2018-12-02	2018-12-02 00:00:00	2018-12-16	2018-12-16 00:00:00	32020		\N	119374	0	10509002	260139		0
30285	1788	257012	1967-03-26	1967-03-26 00:00:00	\N	\N	32020		\N	119839	0	40055000	257012		0
41014	2438	81151	1987-03-18	1987-03-18 00:00:00	1987-04-08	1987-04-08 00:00:00	32020		\N	161754	0	44465007	81151		0
30622	1808	40481087	1970-07-02	1970-07-02 00:00:00	1970-07-16	1970-07-16 00:00:00	32020		\N	121019	0	444814009	40481087		0
30796	1821	260139	1960-08-18	1960-08-18 00:00:00	1960-09-01	1960-09-01 00:00:00	32020		\N	121807	0	10509002	260139		0
30917	1829	4112343	2001-12-05	2001-12-05 00:00:00	2001-12-14	2001-12-14 00:00:00	32020		\N	122280	0	195662009	4112343		0
31128	1844	28060	1962-11-18	1962-11-18 00:00:00	1962-11-30	1962-11-30 00:00:00	32020		\N	123219	0	43878008	28060		0
31268	1848	4027663	1975-09-07	1975-09-07 00:00:00	\N	\N	32020		\N	123684	0	13200003	4027663		0
31470	1860	192671	1996-12-24	1996-12-24 00:00:00	\N	\N	32020		\N	124406	0	K92.2	35208414		0
31551	1867	40481087	1973-07-24	1973-07-24 00:00:00	1973-07-31	1973-07-31 00:00:00	32020		\N	124689	0	444814009	40481087		0
31856	1892	40481087	1989-06-15	1989-06-15 00:00:00	1989-07-06	1989-07-06 00:00:00	32020		\N	126028	0	444814009	40481087		0
21334	1280	4112343	2014-07-15	2014-07-15 00:00:00	2014-07-25	2014-07-25 00:00:00	32020		\N	84608	0	195662009	4112343		0
21558	1293	4112343	1979-05-11	1979-05-11 00:00:00	1979-05-23	1979-05-23 00:00:00	32020		\N	85522	0	195662009	4112343		0
21698	1303	80180	2012-03-05	2012-03-05 00:00:00	\N	\N	32020		\N	86047	0	396275006	80180		0
21887	1313	80180	2011-08-03	2011-08-03 00:00:00	\N	\N	32020		\N	86924	0	396275006	80180		0
21943	1315	4155034	1974-10-14	1974-10-14 00:00:00	1974-10-28	1974-10-28 00:00:00	32020		\N	87107	0	283371005	4155034		0
22184	1323	40481087	1988-11-21	1988-11-21 00:00:00	1988-12-12	1988-12-12 00:00:00	32020		\N	87851	0	444814009	40481087		0
22305	1332	4152936	1966-11-12	1966-11-12 00:00:00	1966-12-03	1966-12-03 00:00:00	32020		\N	88317	0	283385000	4152936		0
22471	1340	40481087	1934-01-08	1934-01-08 00:00:00	1934-01-15	1934-01-15 00:00:00	32020		\N	88923	0	444814009	40481087		0
22650	1353	40481087	2001-03-31	2001-03-31 00:00:00	2001-04-07	2001-04-07 00:00:00	32020		\N	89701	0	444814009	40481087		0
22826	1360	40481087	2003-05-07	2003-05-07 00:00:00	2003-05-28	2003-05-28 00:00:00	32020		\N	90265	0	444814009	40481087		0
22922	1367	4278672	1969-03-15	1969-03-15 00:00:00	1969-06-13	1969-06-13 00:00:00	32020		\N	90620	0	65966004	4278672		0
23100	1379	40481087	1982-01-05	1982-01-05 00:00:00	1982-01-26	1982-01-26 00:00:00	32020		\N	91494	0	444814009	40481087		0
23302	1390	40481087	1976-12-07	1976-12-07 00:00:00	1976-12-21	1976-12-21 00:00:00	32020		\N	92255	0	444814009	40481087		0
23471	1401	4112343	1998-05-01	1998-05-01 00:00:00	1998-05-08	1998-05-08 00:00:00	32020		\N	93154	0	195662009	4112343		0
23642	1411	40481087	1982-01-09	1982-01-09 00:00:00	1982-01-30	1982-01-30 00:00:00	32020		\N	93929	0	444814009	40481087		0
23873	1427	40481087	1990-05-27	1990-05-27 00:00:00	1990-06-03	1990-06-03 00:00:00	32020		\N	94955	0	444814009	40481087		0
23941	1430	4112343	1995-10-04	1995-10-04 00:00:00	1995-10-17	1995-10-17 00:00:00	32020		\N	95140	0	195662009	4112343		0
24215	1443	40481087	2000-10-22	2000-10-22 00:00:00	2000-11-04	2000-11-04 00:00:00	32020		\N	96195	0	444814009	40481087		0
24341	1450	4218389	1965-11-27	1965-11-27 00:00:00	1966-01-01	1966-01-01 00:00:00	32020		\N	96698	0	39848009	4218389		0
24409	1454	378001	1977-10-08	1977-10-08 00:00:00	1977-11-07	1977-11-07 00:00:00	32020		\N	96973	0	62106007	378001		0
24587	1467	4146173	1993-02-23	1993-02-23 00:00:00	1993-04-24	1993-04-24 00:00:00	32020		\N	97778	0	307731004	4146173		0
24830	1480	372328	1968-02-10	1968-02-10 00:00:00	1968-06-28	1968-06-28 00:00:00	32020		\N	98721	0	65363002	372328		0
24980	1491	4112343	1985-06-02	1985-06-02 00:00:00	1985-06-12	1985-06-12 00:00:00	32020		\N	99434	0	195662009	4112343		0
25107	1497	40481087	1985-12-24	1985-12-24 00:00:00	1986-01-07	1986-01-07 00:00:00	32020		\N	99770	0	444814009	40481087		0
25256	1506	4112343	1947-09-27	1947-09-27 00:00:00	1947-10-10	1947-10-10 00:00:00	32020		\N	100409	0	195662009	4112343		0
25504	1517	81151	1945-02-22	1945-02-22 00:00:00	1945-03-08	1945-03-08 00:00:00	32020		\N	101445	0	44465007	81151		0
25665	1525	4112343	2012-10-29	2012-10-29 00:00:00	2012-11-11	2012-11-11 00:00:00	32020		\N	102024	0	195662009	4112343		0
25852	1535	28060	1997-01-22	1997-01-22 00:00:00	1997-01-29	1997-01-29 00:00:00	32020		\N	102752	0	43878008	28060		0
25984	1541	4156265	1983-03-13	1983-03-13 00:00:00	1983-03-27	1983-03-27 00:00:00	32020		\N	103301	0	370247008	4156265		0
26129	1550	40481087	2015-10-09	2015-10-09 00:00:00	2015-10-23	2015-10-23 00:00:00	32020		\N	103758	0	444814009	40481087		0
26301	1560	80180	1974-12-20	1974-12-20 00:00:00	\N	\N	32020		\N	104473	0	396275006	80180		0
26413	1567	4112343	1997-05-06	1997-05-06 00:00:00	1997-05-13	1997-05-13 00:00:00	32020		\N	105104	0	195662009	4112343		0
26622	1577	4059173	1991-01-16	1991-01-16 00:00:00	1991-03-17	1991-03-17 00:00:00	32020		\N	105930	0	16114001	4059173		0
26800	1586	4112343	1952-07-02	1952-07-02 00:00:00	1952-07-10	1952-07-10 00:00:00	32020		\N	106411	0	195662009	4112343		0
26914	1593	4112343	2014-08-02	2014-08-02 00:00:00	2014-08-09	2014-08-09 00:00:00	32020		\N	106892	0	195662009	4112343		0
27098	1602	4109685	2000-08-10	2000-08-10 00:00:00	2000-08-24	2000-08-24 00:00:00	32020		\N	107523	0	284551006	4109685		0
27320	1611	4112343	2002-12-18	2002-12-18 00:00:00	2002-12-25	2002-12-25 00:00:00	32020		\N	108351	0	195662009	4112343		0
27532	1626	40481087	1984-06-20	1984-06-20 00:00:00	1984-07-04	1984-07-04 00:00:00	32020		\N	109212	0	444814009	40481087		0
27645	1632	40481087	2016-02-04	2016-02-04 00:00:00	2016-02-25	2016-02-25 00:00:00	32020		\N	109561	0	444814009	40481087		0
27867	1646	40481087	2011-03-26	2011-03-26 00:00:00	2011-04-09	2011-04-09 00:00:00	32020		\N	110353	0	444814009	40481087		0
38517	2287	4059173	1969-07-19	1969-07-19 00:00:00	1969-08-18	1969-08-18 00:00:00	32020		\N	152150	0	16114001	4059173		0
28110	1659	4237458	1980-03-19	1980-03-19 00:00:00	1980-06-17	1980-06-17 00:00:00	32020		\N	111456	0	58150001	4237458		0
28304	1672	80180	1989-04-10	1989-04-10 00:00:00	\N	\N	32020		\N	112241	0	396275006	80180		0
28505	1686	28060	1991-10-23	1991-10-23 00:00:00	1991-11-01	1991-11-01 00:00:00	32020		\N	112933	0	43878008	28060		0
28567	1690	28060	1979-12-31	1979-12-31 00:00:00	1980-01-12	1980-01-12 00:00:00	32020		\N	113207	0	43878008	28060		0
28820	1707	40481087	2008-03-07	2008-03-07 00:00:00	2008-03-21	2008-03-21 00:00:00	32020		\N	114131	0	444814009	40481087		0
28931	1713	40481087	1988-11-05	1988-11-05 00:00:00	1988-11-19	1988-11-19 00:00:00	32020		\N	114434	0	444814009	40481087		0
29113	1724	260139	1958-06-08	1958-06-08 00:00:00	1958-06-22	1958-06-22 00:00:00	32020		\N	115276	0	10509002	260139		0
29299	1736	195588	1985-05-04	1985-05-04 00:00:00	1985-06-24	1985-06-24 00:00:00	32020		\N	115898	0	38822007	195588		0
29435	1743	4059173	1999-09-08	1999-09-08 00:00:00	1999-10-08	1999-10-08 00:00:00	32020		\N	116509	0	16114001	4059173		0
29601	1751	40481087	2014-10-24	2014-10-24 00:00:00	2014-11-14	2014-11-14 00:00:00	32020		\N	117060	0	444814009	40481087		0
29743	1760	40481087	1985-08-30	1985-08-30 00:00:00	1985-09-06	1985-09-06 00:00:00	32020		\N	117656	0	444814009	40481087		0
29970	1773	40481087	1977-05-08	1977-05-08 00:00:00	1977-05-15	1977-05-15 00:00:00	32020		\N	118555	0	444814009	40481087		0
30165	1782	80180	1988-01-01	1988-01-01 00:00:00	\N	\N	32020		\N	119346	0	396275006	80180		0
30286	1788	260139	1991-07-12	1991-07-12 00:00:00	1991-07-26	1991-07-26 00:00:00	32020		\N	119843	0	10509002	260139		0
41015	2438	260139	1988-06-12	1988-06-12 00:00:00	1988-06-26	1988-06-26 00:00:00	32020		\N	161768	0	10509002	260139		0
30623	1809	4112343	1982-12-04	1982-12-04 00:00:00	1982-12-14	1982-12-14 00:00:00	32020		\N	121141	0	195662009	4112343		0
30797	1821	4152936	1955-09-19	1955-09-19 00:00:00	1955-10-10	1955-10-10 00:00:00	32020		\N	121771	0	283385000	4152936		0
30918	1829	80180	2002-08-09	2002-08-09 00:00:00	\N	\N	32020		\N	122280	0	396275006	80180		0
31129	1844	260139	1996-02-08	1996-02-08 00:00:00	1996-02-22	1996-02-22 00:00:00	32020		\N	123248	0	10509002	260139		0
31269	1848	4116491	1975-09-07	1975-09-07 00:00:00	1975-10-14	1975-10-14 00:00:00	32020		\N	123684	0	301011002	4116491		0
31471	1860	4112343	1966-11-15	1966-11-15 00:00:00	1966-11-26	1966-11-26 00:00:00	32020		\N	124356	0	195662009	4112343		0
31552	1867	372328	1978-05-06	1978-05-06 00:00:00	1979-03-13	1979-03-13 00:00:00	32020		\N	124693	0	65363002	372328		0
31857	1892	4294548	1979-03-12	1979-03-12 00:00:00	1979-04-02	1979-04-02 00:00:00	32020		\N	125981	0	75498004	4294548		0
21335	1280	4112343	1958-08-10	1958-08-10 00:00:00	1958-08-21	1958-08-21 00:00:00	32020		\N	84596	0	195662009	4112343		0
21559	1293	40481087	1993-06-21	1993-06-21 00:00:00	1993-06-28	1993-06-28 00:00:00	32020		\N	85458	0	444814009	40481087		0
21715	1305	372328	1967-01-07	1967-01-07 00:00:00	1967-06-15	1967-06-15 00:00:00	32020		\N	86133	0	65363002	372328		0
21888	1313	40481087	1978-04-18	1978-04-18 00:00:00	1978-05-09	1978-05-09 00:00:00	32020		\N	86894	0	444814009	40481087		0
21944	1315	372328	1962-09-10	1962-09-10 00:00:00	1963-03-05	1963-03-05 00:00:00	32020		\N	87119	0	65363002	372328		0
22185	1323	40481087	1970-07-14	1970-07-14 00:00:00	1970-07-28	1970-07-28 00:00:00	32020		\N	87871	0	444814009	40481087		0
22306	1332	40481087	1946-04-22	1946-04-22 00:00:00	1946-04-29	1946-04-29 00:00:00	32020		\N	88344	0	444814009	40481087		0
22472	1340	78272	1926-12-08	1926-12-08 00:00:00	1926-12-22	1926-12-22 00:00:00	32020		\N	88842	0	70704007	78272		0
22651	1353	4112343	1966-01-04	1966-01-04 00:00:00	1966-01-11	1966-01-11 00:00:00	32020		\N	89700	0	195662009	4112343		0
22827	1360	4294548	1981-06-20	1981-06-20 00:00:00	1981-07-18	1981-07-18 00:00:00	32020		\N	90249	0	75498004	4294548		0
22923	1367	4112343	1966-08-24	1966-08-24 00:00:00	1966-09-01	1966-09-01 00:00:00	32020		\N	90585	0	195662009	4112343		0
23101	1379	4109685	1987-08-30	1987-08-30 00:00:00	1987-09-13	1987-09-13 00:00:00	32020		\N	91515	0	284551006	4109685		0
23303	1390	81151	2007-05-13	2007-05-13 00:00:00	2007-05-27	2007-05-27 00:00:00	32020		\N	92250	0	44465007	81151		0
23472	1401	4027663	1999-01-22	1999-01-22 00:00:00	\N	\N	32020		\N	93154	0	13200003	4027663		0
23643	1411	4237458	1972-04-27	1972-04-27 00:00:00	1972-07-26	1972-07-26 00:00:00	32020		\N	93976	0	58150001	4237458		0
23874	1427	80180	1995-09-15	1995-09-15 00:00:00	\N	\N	32020		\N	94921	0	396275006	80180		0
23942	1430	260139	1971-12-16	1971-12-16 00:00:00	1971-12-23	1971-12-23 00:00:00	32020		\N	95123	0	10509002	260139		0
24216	1443	78272	2018-10-02	2018-10-02 00:00:00	2018-11-05	2018-11-05 00:00:00	32020		\N	96194	0	70704007	78272		0
24342	1450	372328	1966-02-12	1966-02-12 00:00:00	1966-04-17	1966-04-17 00:00:00	32020		\N	96743	0	65363002	372328		0
24410	1454	4112343	1998-07-28	1998-07-28 00:00:00	1998-08-10	1998-08-10 00:00:00	32020		\N	97026	0	195662009	4112343		0
24588	1467	40481087	1978-04-16	1978-04-16 00:00:00	1978-05-07	1978-05-07 00:00:00	32020		\N	97747	0	444814009	40481087		0
24838	1482	378001	1995-09-20	1995-09-20 00:00:00	1995-11-19	1995-11-19 00:00:00	32020		\N	98829	0	62106007	378001		0
24981	1491	28060	1970-12-28	1970-12-28 00:00:00	1971-01-05	1971-01-05 00:00:00	32020		\N	99410	0	43878008	28060		0
25108	1497	439777	1983-03-05	1983-03-05 00:00:00	\N	\N	32020		\N	99768	0	271737000	439777		0
25257	1506	28060	1948-10-22	1948-10-22 00:00:00	1948-11-01	1948-11-01 00:00:00	32020		\N	100445	0	43878008	28060		0
25505	1518	28060	1956-10-05	1956-10-05 00:00:00	1956-10-13	1956-10-13 00:00:00	32020		\N	101526	0	43878008	28060		0
25666	1525	40481087	1984-01-26	1984-01-26 00:00:00	1984-02-02	1984-02-02 00:00:00	32020		\N	102021	0	444814009	40481087		0
25853	1535	40481087	1981-11-03	1981-11-03 00:00:00	1981-11-10	1981-11-10 00:00:00	32020		\N	102700	0	444814009	40481087		0
25985	1541	4218389	1982-01-19	1982-01-19 00:00:00	1982-02-16	1982-02-16 00:00:00	32020		\N	103300	0	39848009	4218389		0
26130	1551	317576	2018-03-12	2018-03-12 00:00:00	\N	\N	32020		\N	103865	0	53741008	317576		0
26302	1560	372328	1937-05-14	1937-05-14 00:00:00	1937-06-21	1937-06-21 00:00:00	32020		\N	104453	0	65363002	372328		0
26414	1567	4112343	1989-10-07	1989-10-07 00:00:00	1989-10-14	1989-10-14 00:00:00	32020		\N	105080	0	195662009	4112343		0
26623	1577	260139	1972-08-25	1972-08-25 00:00:00	1972-09-08	1972-09-08 00:00:00	32020		\N	105837	0	10509002	260139		0
26801	1586	40481087	1953-09-25	1953-09-25 00:00:00	1953-10-16	1953-10-16 00:00:00	32020		\N	106412	0	444814009	40481087		0
26915	1593	28060	1946-11-03	1946-11-03 00:00:00	1946-11-15	1946-11-15 00:00:00	32020		\N	106940	0	43878008	28060		0
27099	1602	4112343	1973-12-19	1973-12-19 00:00:00	1973-12-26	1973-12-26 00:00:00	32020		\N	107502	0	195662009	4112343		0
27321	1611	4134304	1991-07-28	1991-07-28 00:00:00	1991-10-26	1991-10-26 00:00:00	32020		\N	108355	0	263102004	4134304		0
27533	1626	80180	1970-01-10	1970-01-10 00:00:00	\N	\N	32020		\N	109228	0	396275006	80180		0
27646	1632	4296204	1989-11-27	1989-11-27 00:00:00	1989-12-18	1989-12-18 00:00:00	32020		\N	109552	0	403190006	4296204		0
27868	1646	260139	1948-02-18	1948-02-18 00:00:00	1948-03-03	1948-03-03 00:00:00	32020		\N	110380	0	10509002	260139		0
38518	2287	4112343	2000-08-01	2000-08-01 00:00:00	2000-08-11	2000-08-11 00:00:00	32020		\N	152134	0	195662009	4112343		0
28111	1659	257012	1975-01-23	1975-01-23 00:00:00	1975-06-05	1975-06-05 00:00:00	32020		\N	111569	0	40055000	257012		0
28305	1672	4266809	1989-04-10	1989-04-10 00:00:00	\N	\N	32020		\N	112241	0	397881000	4266809		0
28506	1686	4283893	2018-02-22	2018-02-22 00:00:00	2018-03-08	2018-03-08 00:00:00	32020		\N	112925	0	36971009	4283893		0
28568	1690	375671	2013-11-27	2013-11-27 00:00:00	2013-12-27	2013-12-27 00:00:00	32020		\N	113162	0	62564004	375671		0
28821	1707	40481087	2013-03-04	2013-03-04 00:00:00	2013-03-11	2013-03-11 00:00:00	32020		\N	114142	0	444814009	40481087		0
28932	1713	40481087	1990-12-17	1990-12-17 00:00:00	1991-01-07	1991-01-07 00:00:00	32020		\N	114478	0	444814009	40481087		0
29114	1724	4155034	1987-06-21	1987-06-21 00:00:00	1987-07-05	1987-07-05 00:00:00	32020		\N	115265	0	283371005	4155034		0
29300	1736	260139	1999-06-20	1999-06-20 00:00:00	1999-07-04	1999-07-04 00:00:00	32020		\N	115900	0	10509002	260139		0
29436	1743	78272	1974-10-05	1974-10-05 00:00:00	1974-10-19	1974-10-19 00:00:00	32020		\N	116508	0	70704007	78272		0
29602	1751	260139	1979-04-22	1979-04-22 00:00:00	1979-04-29	1979-04-29 00:00:00	32020		\N	117095	0	10509002	260139		0
29744	1760	372328	1978-06-14	1978-06-14 00:00:00	1978-08-27	1978-08-27 00:00:00	32020		\N	117675	0	65363002	372328		0
29971	1773	4218389	1992-01-12	1992-01-12 00:00:00	1992-02-16	1992-02-16 00:00:00	32020		\N	118553	0	39848009	4218389		0
30166	1782	40481087	1987-07-03	1987-07-03 00:00:00	1987-07-24	1987-07-24 00:00:00	32020		\N	119346	0	444814009	40481087		0
30287	1788	4113008	1999-05-26	1999-05-26 00:00:00	1999-06-09	1999-06-09 00:00:00	32020		\N	119835	0	284549007	4113008		0
41016	2438	4146173	2015-09-06	2015-09-06 00:00:00	2015-11-05	2015-11-05 00:00:00	32020		\N	161750	0	307731004	4146173		0
30624	1809	4294548	2017-06-04	2017-06-04 00:00:00	2017-08-13	2017-08-13 00:00:00	32020		\N	121093	0	75498004	4294548		0
30798	1821	4155034	2010-02-20	2010-02-20 00:00:00	2010-03-13	2010-03-13 00:00:00	32020		\N	121776	0	283371005	4155034		0
30919	1829	260139	1985-04-02	1985-04-02 00:00:00	1985-04-16	1985-04-16 00:00:00	32020		\N	122303	0	10509002	260139		0
31130	1844	40481087	1977-12-08	1977-12-08 00:00:00	1977-12-22	1977-12-22 00:00:00	32020		\N	123154	0	444814009	40481087		0
31278	1850	40481087	1989-04-23	1989-04-23 00:00:00	1989-05-07	1989-05-07 00:00:00	32020		\N	123765	0	444814009	40481087		0
31472	1860	40481087	1997-03-14	1997-03-14 00:00:00	1997-03-21	1997-03-21 00:00:00	32020		\N	124363	0	444814009	40481087		0
31553	1867	40481087	2002-12-18	2002-12-18 00:00:00	2003-01-01	2003-01-01 00:00:00	32020		\N	124696	0	444814009	40481087		0
31858	1892	261325	2007-05-17	2007-05-17 00:00:00	\N	\N	32020		\N	126021	0	87433001	261325		0
21336	1280	260139	1975-12-23	1975-12-23 00:00:00	1976-01-06	1976-01-06 00:00:00	32020		\N	84605	0	10509002	260139		0
21560	1293	4059173	1945-10-25	1945-10-25 00:00:00	1945-11-24	1945-11-24 00:00:00	32020		\N	85596	0	16114001	4059173		0
21716	1305	40481087	2008-05-21	2008-05-21 00:00:00	2008-06-11	2008-06-11 00:00:00	32020		\N	86128	0	444814009	40481087		0
21889	1313	4112343	1999-08-30	1999-08-30 00:00:00	1999-09-06	1999-09-06 00:00:00	32020		\N	86891	0	195662009	4112343		0
21945	1315	260139	1962-02-24	1962-02-24 00:00:00	1962-03-10	1962-03-10 00:00:00	32020		\N	87132	0	10509002	260139		0
22186	1323	260139	1984-03-08	1984-03-08 00:00:00	1984-03-15	1984-03-15 00:00:00	32020		\N	87876	0	10509002	260139		0
22307	1332	4112343	1954-06-22	1954-06-22 00:00:00	1954-06-29	1954-06-29 00:00:00	32020		\N	88354	0	195662009	4112343		0
22473	1340	80502	1971-07-15	1971-07-15 00:00:00	\N	\N	32020		\N	88865	0	64859006	80502		0
22652	1353	81151	1969-11-02	1969-11-02 00:00:00	1969-11-30	1969-11-30 00:00:00	32020		\N	89641	0	44465007	81151		0
22828	1360	260139	2009-11-12	2009-11-12 00:00:00	2009-11-26	2009-11-26 00:00:00	32020		\N	90267	0	10509002	260139		0
22924	1367	40481087	1994-07-21	1994-07-21 00:00:00	1994-08-04	1994-08-04 00:00:00	32020		\N	90584	0	444814009	40481087		0
23102	1379	4109685	1969-08-15	1969-08-15 00:00:00	1969-08-29	1969-08-29 00:00:00	32020		\N	91511	0	284551006	4109685		0
23304	1390	4155034	1967-10-21	1967-10-21 00:00:00	1967-11-11	1967-11-11 00:00:00	32020		\N	92247	0	283371005	4155034		0
23473	1401	40481087	1977-10-13	1977-10-13 00:00:00	1977-10-27	1977-10-27 00:00:00	32020		\N	93134	0	444814009	40481087		0
23644	1411	4112343	1981-06-08	1981-06-08 00:00:00	1981-06-15	1981-06-15 00:00:00	32020		\N	93928	0	195662009	4112343		0
23875	1427	40481087	1994-12-17	1994-12-17 00:00:00	1994-12-31	1994-12-31 00:00:00	32020		\N	94921	0	444814009	40481087		0
23943	1430	80502	2004-10-12	2004-10-12 00:00:00	\N	\N	32020		\N	95168	0	64859006	80502		0
24217	1443	4112343	1990-08-19	1990-08-19 00:00:00	1990-08-30	1990-08-30 00:00:00	32020		\N	96244	0	195662009	4112343		0
24343	1450	40481087	2013-05-20	2013-05-20 00:00:00	2013-06-03	2013-06-03 00:00:00	32020		\N	96741	0	444814009	40481087		0
24411	1454	4112343	1984-07-17	1984-07-17 00:00:00	1984-07-28	1984-07-28 00:00:00	32020		\N	97007	0	195662009	4112343		0
24589	1467	4218389	1994-03-20	1994-03-20 00:00:00	1994-04-17	1994-04-17 00:00:00	32020		\N	97667	0	39848009	4218389		0
24839	1482	4283893	1983-07-09	1983-07-09 00:00:00	1983-10-01	1983-10-01 00:00:00	32020		\N	98886	0	36971009	4283893		0
24982	1491	78272	1990-10-11	1990-10-11 00:00:00	1990-11-01	1990-11-01 00:00:00	32020		\N	99453	0	70704007	78272		0
25109	1497	260139	2007-05-01	2007-05-01 00:00:00	2007-05-15	2007-05-15 00:00:00	32020		\N	99922	0	10509002	260139		0
25258	1506	372328	1946-09-30	1946-09-30 00:00:00	1947-01-11	1947-01-11 00:00:00	32020		\N	100449	0	65363002	372328		0
25506	1518	40481087	1992-12-04	1992-12-04 00:00:00	1992-12-11	1992-12-11 00:00:00	32020		\N	101529	0	444814009	40481087		0
25667	1525	40481087	2005-05-30	2005-05-30 00:00:00	2005-06-20	2005-06-20 00:00:00	32020		\N	102022	0	444814009	40481087		0
25854	1535	4112343	1983-08-09	1983-08-09 00:00:00	1983-08-19	1983-08-19 00:00:00	32020		\N	102707	0	195662009	4112343		0
25986	1541	30753	2006-05-13	2006-05-13 00:00:00	\N	\N	32020		\N	103287	0	16761005	30753		0
26131	1551	40481087	1958-09-15	1958-09-15 00:00:00	1958-09-22	1958-09-22 00:00:00	32020		\N	103848	0	444814009	40481087		0
26303	1560	4112343	2014-08-29	2014-08-29 00:00:00	2014-09-06	2014-09-06 00:00:00	32020		\N	104504	0	195662009	4112343		0
26415	1567	260139	2014-09-15	2014-09-15 00:00:00	2014-09-29	2014-09-29 00:00:00	32020		\N	105083	0	10509002	260139		0
26624	1577	40481087	1947-12-23	1947-12-23 00:00:00	1948-01-13	1948-01-13 00:00:00	32020		\N	105859	0	444814009	40481087		0
26802	1586	260139	1966-05-14	1966-05-14 00:00:00	1966-05-21	1966-05-21 00:00:00	32020		\N	106391	0	10509002	260139		0
26916	1593	4296204	1964-12-28	1964-12-28 00:00:00	1965-01-11	1965-01-11 00:00:00	32020		\N	106845	0	403190006	4296204		0
27100	1602	4112343	1964-05-13	1964-05-13 00:00:00	1964-05-25	1964-05-25 00:00:00	32020		\N	107528	0	195662009	4112343		0
27322	1611	81151	2013-11-29	2013-11-29 00:00:00	2013-12-20	2013-12-20 00:00:00	32020		\N	108356	0	44465007	81151		0
27534	1626	40481087	1986-10-30	1986-10-30 00:00:00	1986-11-20	1986-11-20 00:00:00	32020		\N	109273	0	444814009	40481087		0
27647	1632	4112343	2002-06-01	2002-06-01 00:00:00	2002-06-10	2002-06-10 00:00:00	32020		\N	109572	0	195662009	4112343		0
27869	1646	440448	1982-11-22	1982-11-22 00:00:00	\N	\N	32020		\N	110449	0	74400008	440448		0
38519	2287	260139	1981-01-06	1981-01-06 00:00:00	1981-01-20	1981-01-20 00:00:00	32020		\N	152133	0	10509002	260139		0
28112	1659	372328	1976-07-17	1976-07-17 00:00:00	1977-04-18	1977-04-18 00:00:00	32020		\N	111474	0	65363002	372328		0
28306	1672	4156265	1973-10-07	1973-10-07 00:00:00	1973-10-28	1973-10-28 00:00:00	32020		\N	112280	0	370247008	4156265		0
28507	1686	40481087	1994-05-04	1994-05-04 00:00:00	1994-05-18	1994-05-18 00:00:00	32020		\N	112953	0	444814009	40481087		0
28569	1690	81151	2002-07-03	2002-07-03 00:00:00	2002-08-07	2002-08-07 00:00:00	32020		\N	113160	0	44465007	81151		0
28822	1707	4112343	1991-06-20	1991-06-20 00:00:00	1991-07-01	1991-07-01 00:00:00	32020		\N	114130	0	195662009	4112343		0
28933	1713	28060	2010-10-20	2010-10-20 00:00:00	2010-10-29	2010-10-29 00:00:00	32020		\N	114496	0	43878008	28060		0
29115	1724	40481087	1979-09-26	1979-09-26 00:00:00	1979-10-17	1979-10-17 00:00:00	32020		\N	115242	0	444814009	40481087		0
29301	1736	4116491	1989-06-23	1989-06-23 00:00:00	1989-08-16	1989-08-16 00:00:00	32020		\N	115943	0	301011002	4116491		0
29437	1743	40481087	1985-05-25	1985-05-25 00:00:00	1985-06-15	1985-06-15 00:00:00	32020		\N	116533	0	444814009	40481087		0
29603	1752	260139	1993-06-07	1993-06-07 00:00:00	1993-06-21	1993-06-21 00:00:00	32020		\N	117153	0	10509002	260139		0
29745	1760	257012	2018-05-29	2018-05-29 00:00:00	2018-06-19	2018-06-19 00:00:00	32020		\N	117695	0	40055000	257012		0
29972	1773	260139	1982-08-01	1982-08-01 00:00:00	1982-08-08	1982-08-08 00:00:00	32020		\N	118524	0	10509002	260139		0
30167	1782	4112343	2008-03-05	2008-03-05 00:00:00	2008-03-12	2008-03-12 00:00:00	32020		\N	119326	0	195662009	4112343		0
30288	1788	260139	2007-01-16	2007-01-16 00:00:00	2007-01-23	2007-01-23 00:00:00	32020		\N	119830	0	10509002	260139		0
41017	2438	28060	1995-01-03	1995-01-03 00:00:00	1995-01-14	1995-01-14 00:00:00	32020		\N	161749	0	43878008	28060		0
30625	1809	4112343	1995-09-09	1995-09-09 00:00:00	1995-09-20	1995-09-20 00:00:00	32020		\N	121119	0	195662009	4112343		0
30799	1821	28060	1950-06-09	1950-06-09 00:00:00	1950-06-19	1950-06-19 00:00:00	32020		\N	121816	0	43878008	28060		0
30920	1829	40481087	2018-08-22	2018-08-22 00:00:00	2018-09-12	2018-09-12 00:00:00	32020		\N	122302	0	444814009	40481087		0
31131	1844	192671	2002-12-16	2002-12-16 00:00:00	\N	\N	32020		\N	123196	0	K92.2	35208414		0
31279	1850	260139	1973-10-17	1973-10-17 00:00:00	1973-10-31	1973-10-31 00:00:00	32020		\N	123752	0	10509002	260139		0
31473	1860	4112343	1985-12-01	1985-12-01 00:00:00	1985-12-11	1985-12-11 00:00:00	32020		\N	124360	0	195662009	4112343		0
31554	1867	372328	1974-07-23	1974-07-23 00:00:00	1974-08-27	1974-08-27 00:00:00	32020		\N	124705	0	65363002	372328		0
31859	1892	260139	2008-11-08	2008-11-08 00:00:00	2008-11-22	2008-11-22 00:00:00	32020		\N	125976	0	10509002	260139		0
21337	1280	372328	1956-07-07	1956-07-07 00:00:00	1956-07-21	1956-07-21 00:00:00	32020		\N	84537	0	65363002	372328		0
21561	1293	40481087	1951-12-01	1951-12-01 00:00:00	1951-12-22	1951-12-22 00:00:00	32020		\N	85553	0	444814009	40481087		0
21717	1305	28060	1966-03-02	1966-03-02 00:00:00	1966-03-09	1966-03-09 00:00:00	32020		\N	86109	0	43878008	28060		0
21890	1314	260139	1998-10-04	1998-10-04 00:00:00	1998-10-11	1998-10-11 00:00:00	32020		\N	87050	0	10509002	260139		0
21946	1315	40481087	2006-05-02	2006-05-02 00:00:00	2006-05-16	2006-05-16 00:00:00	32020		\N	87070	0	444814009	40481087		0
22187	1323	4112343	1986-10-19	1986-10-19 00:00:00	1986-10-29	1986-10-29 00:00:00	32020		\N	87874	0	195662009	4112343		0
22308	1332	4218389	1971-08-30	1971-08-30 00:00:00	1971-09-27	1971-09-27 00:00:00	32020		\N	88319	0	39848009	4218389		0
22474	1340	260139	1948-03-09	1948-03-09 00:00:00	1948-03-23	1948-03-23 00:00:00	32020		\N	88955	0	10509002	260139		0
22653	1353	260139	1968-10-19	1968-10-19 00:00:00	1968-11-02	1968-11-02 00:00:00	32020		\N	89629	0	10509002	260139		0
22829	1360	28060	1993-12-11	1993-12-11 00:00:00	1993-12-20	1993-12-20 00:00:00	32020		\N	90282	0	43878008	28060		0
22925	1367	28060	2000-05-17	2000-05-17 00:00:00	2000-05-24	2000-05-24 00:00:00	32020		\N	90599	0	43878008	28060		0
23103	1379	260139	1973-02-06	1973-02-06 00:00:00	1973-02-13	1973-02-13 00:00:00	32020		\N	91493	0	10509002	260139		0
23305	1390	28060	1981-04-22	1981-04-22 00:00:00	1981-05-05	1981-05-05 00:00:00	32020		\N	92290	0	43878008	28060		0
23474	1401	40481087	2002-01-27	2002-01-27 00:00:00	2002-02-17	2002-02-17 00:00:00	32020		\N	93146	0	444814009	40481087		0
23645	1411	40481087	2003-05-20	2003-05-20 00:00:00	2003-06-10	2003-06-10 00:00:00	32020		\N	93920	0	444814009	40481087		0
23876	1427	40481087	1959-06-30	1959-06-30 00:00:00	1959-07-14	1959-07-14 00:00:00	32020		\N	94919	0	444814009	40481087		0
23944	1430	4112343	1999-03-01	1999-03-01 00:00:00	1999-03-13	1999-03-13 00:00:00	32020		\N	95141	0	195662009	4112343		0
24218	1443	40481087	1986-04-10	1986-04-10 00:00:00	1986-04-17	1986-04-17 00:00:00	32020		\N	96203	0	444814009	40481087		0
24344	1450	372328	1965-01-13	1965-01-13 00:00:00	1965-04-18	1965-04-18 00:00:00	32020		\N	96716	0	65363002	372328		0
24412	1454	4112343	1992-12-17	1992-12-17 00:00:00	1992-12-25	1992-12-25 00:00:00	32020		\N	97020	0	195662009	4112343		0
24590	1467	260139	1988-07-19	1988-07-19 00:00:00	1988-08-02	1988-08-02 00:00:00	32020		\N	97717	0	10509002	260139		0
24840	1482	4112343	2011-06-08	2011-06-08 00:00:00	2011-06-17	2011-06-17 00:00:00	32020		\N	98838	0	195662009	4112343		0
24983	1491	372328	1974-06-24	1974-06-24 00:00:00	1974-10-22	1974-10-22 00:00:00	32020		\N	99425	0	65363002	372328		0
25110	1497	40481087	1997-09-25	1997-09-25 00:00:00	1997-10-16	1997-10-16 00:00:00	32020		\N	99906	0	444814009	40481087		0
25267	1508	40481087	1990-03-05	1990-03-05 00:00:00	1990-03-12	1990-03-12 00:00:00	32020		\N	100654	0	444814009	40481087		0
25507	1518	81151	1967-04-26	1967-04-26 00:00:00	1967-05-10	1967-05-10 00:00:00	32020		\N	101485	0	44465007	81151		0
25668	1525	4027663	1990-07-25	1990-07-25 00:00:00	\N	\N	32020		\N	101966	0	13200003	4027663		0
25855	1536	4218389	1971-02-01	1971-02-01 00:00:00	1971-03-01	1971-03-01 00:00:00	32020		\N	102790	0	39848009	4218389		0
25987	1541	81893	2006-03-14	2006-03-14 00:00:00	\N	\N	32020		\N	103287	0	64766004	81893		0
26132	1551	40481087	1963-01-30	1963-01-30 00:00:00	1963-02-13	1963-02-13 00:00:00	32020		\N	103854	0	444814009	40481087		0
26304	1560	4112343	2017-01-27	2017-01-27 00:00:00	2017-02-03	2017-02-03 00:00:00	32020		\N	104452	0	195662009	4112343		0
26416	1567	40481087	2003-10-04	2003-10-04 00:00:00	2003-10-18	2003-10-18 00:00:00	32020		\N	105113	0	444814009	40481087		0
26625	1577	40481087	1941-05-07	1941-05-07 00:00:00	1941-05-21	1941-05-21 00:00:00	32020		\N	105834	0	444814009	40481087		0
26814	1588	40481087	1974-01-31	1974-01-31 00:00:00	1974-02-21	1974-02-21 00:00:00	32020		\N	106626	0	444814009	40481087		0
26917	1593	4155034	1970-09-03	1970-09-03 00:00:00	1970-09-17	1970-09-17 00:00:00	32020		\N	106847	0	283371005	4155034		0
27101	1602	4134304	1972-03-19	1972-03-19 00:00:00	1972-04-18	1972-04-18 00:00:00	32020		\N	107521	0	263102004	4134304		0
27323	1611	28060	1952-08-09	1952-08-09 00:00:00	1952-08-22	1952-08-22 00:00:00	32020		\N	108347	0	43878008	28060		0
27535	1626	40481087	1994-09-15	1994-09-15 00:00:00	1994-09-22	1994-09-22 00:00:00	32020		\N	109277	0	444814009	40481087		0
27648	1632	28060	1962-07-26	1962-07-26 00:00:00	1962-08-05	1962-08-05 00:00:00	32020		\N	109587	0	43878008	28060		0
27870	1646	4112343	2008-09-12	2008-09-12 00:00:00	2008-09-24	2008-09-24 00:00:00	32020		\N	110374	0	195662009	4112343		0
38520	2287	40481087	1964-02-22	1964-02-22 00:00:00	1964-03-07	1964-03-07 00:00:00	32020		\N	152129	0	444814009	40481087		0
28113	1659	4283893	2000-11-30	2000-11-30 00:00:00	2001-01-18	2001-01-18 00:00:00	32020		\N	111567	0	36971009	4283893		0
28307	1672	372328	1955-11-04	1955-11-04 00:00:00	1956-04-04	1956-04-04 00:00:00	32020		\N	112259	0	65363002	372328		0
28508	1686	260139	1980-06-15	1980-06-15 00:00:00	1980-06-29	1980-06-29 00:00:00	32020		\N	112922	0	10509002	260139		0
28570	1690	260139	1985-05-05	1985-05-05 00:00:00	1985-05-12	1985-05-12 00:00:00	32020		\N	113219	0	10509002	260139		0
28823	1707	30753	2005-03-24	2005-03-24 00:00:00	\N	\N	32020		\N	114158	0	16761005	30753		0
28934	1713	78272	1990-10-26	1990-10-26 00:00:00	1990-11-16	1990-11-16 00:00:00	32020		\N	114454	0	70704007	78272		0
29116	1724	4112343	1997-03-15	1997-03-15 00:00:00	1997-03-22	1997-03-22 00:00:00	32020		\N	115300	0	195662009	4112343		0
29302	1736	260139	1970-09-01	1970-09-01 00:00:00	1970-09-08	1970-09-08 00:00:00	32020		\N	115941	0	10509002	260139		0
29438	1743	260139	1968-03-20	1968-03-20 00:00:00	1968-04-03	1968-04-03 00:00:00	32020		\N	116532	0	10509002	260139		0
29604	1752	4112343	2001-07-06	2001-07-06 00:00:00	2001-07-19	2001-07-19 00:00:00	32020		\N	117111	0	195662009	4112343		0
29746	1760	4112343	2016-04-03	2016-04-03 00:00:00	2016-04-10	2016-04-10 00:00:00	32020		\N	117657	0	195662009	4112343		0
29973	1773	4112343	1984-12-24	1984-12-24 00:00:00	1985-01-05	1985-01-05 00:00:00	32020		\N	118537	0	195662009	4112343		0
30168	1782	372328	1954-08-01	1954-08-01 00:00:00	1954-11-02	1954-11-02 00:00:00	32020		\N	119349	0	65363002	372328		0
30289	1788	4294548	1967-02-26	1967-02-26 00:00:00	1967-05-21	1967-05-21 00:00:00	32020		\N	119774	0	75498004	4294548		0
41018	2438	40481087	1993-07-08	1993-07-08 00:00:00	1993-07-22	1993-07-22 00:00:00	32020		\N	161770	0	444814009	40481087		0
30626	1809	40481087	1963-03-20	1963-03-20 00:00:00	1963-03-27	1963-03-27 00:00:00	32020		\N	121118	0	444814009	40481087		0
30800	1821	4155034	1978-08-02	1978-08-02 00:00:00	1978-08-23	1978-08-23 00:00:00	32020		\N	121774	0	283371005	4155034		0
30953	1834	257012	2006-05-02	2006-05-02 00:00:00	\N	\N	32020		\N	122564	0	40055000	257012		0
31132	1844	4051466	1963-04-13	1963-04-13 00:00:00	1978-07-26	1978-07-26 00:00:00	32020		\N	123132	0	233678006	4051466		0
31280	1850	40481087	1972-06-28	1972-06-28 00:00:00	1972-07-19	1972-07-19 00:00:00	32020		\N	123778	0	444814009	40481087		0
31474	1860	40481087	1991-11-21	1991-11-21 00:00:00	1991-12-05	1991-12-05 00:00:00	32020		\N	124374	0	444814009	40481087		0
31555	1867	40481087	1977-05-16	1977-05-16 00:00:00	1977-06-06	1977-06-06 00:00:00	32020		\N	124690	0	444814009	40481087		0
31860	1892	4112343	1969-09-28	1969-09-28 00:00:00	1969-10-11	1969-10-11 00:00:00	32020		\N	126024	0	195662009	4112343		0
21338	1280	40481087	2009-05-16	2009-05-16 00:00:00	2009-05-30	2009-05-30 00:00:00	32020		\N	84606	0	444814009	40481087		0
21562	1293	372328	1941-05-19	1941-05-19 00:00:00	1941-06-02	1941-06-02 00:00:00	32020		\N	85474	0	65363002	372328		0
21718	1305	40481087	2007-10-09	2007-10-09 00:00:00	2007-10-16	2007-10-16 00:00:00	32020		\N	86127	0	444814009	40481087		0
21891	1314	257012	1996-07-20	1996-07-20 00:00:00	\N	\N	32020		\N	87048	0	40055000	257012		0
21947	1315	4112343	1990-08-03	1990-08-03 00:00:00	1990-08-13	1990-08-13 00:00:00	32020		\N	87116	0	195662009	4112343		0
22188	1323	260139	2011-08-23	2011-08-23 00:00:00	2011-09-06	2011-09-06 00:00:00	32020		\N	87852	0	10509002	260139		0
22309	1332	4112343	1998-06-10	1998-06-10 00:00:00	1998-06-19	1998-06-19 00:00:00	32020		\N	88367	0	195662009	4112343		0
22475	1340	81151	1985-09-30	1985-09-30 00:00:00	1985-10-28	1985-10-28 00:00:00	32020		\N	88847	0	44465007	81151		0
22654	1353	4112343	2007-02-21	2007-02-21 00:00:00	2007-03-05	2007-03-05 00:00:00	32020		\N	89668	0	195662009	4112343		0
22830	1361	40481087	2015-01-09	2015-01-09 00:00:00	2015-01-16	2015-01-16 00:00:00	32020		\N	90356	0	444814009	40481087		0
22926	1367	260139	2006-06-25	2006-06-25 00:00:00	2006-07-02	2006-07-02 00:00:00	32020		\N	90601	0	10509002	260139		0
23104	1379	260139	2000-07-23	2000-07-23 00:00:00	2000-08-06	2000-08-06 00:00:00	32020		\N	91495	0	10509002	260139		0
23306	1390	40481087	2009-10-20	2009-10-20 00:00:00	2009-11-10	2009-11-10 00:00:00	32020		\N	92262	0	444814009	40481087		0
23475	1401	81151	1986-03-21	1986-03-21 00:00:00	1986-04-18	1986-04-18 00:00:00	32020		\N	93177	0	44465007	81151		0
23646	1411	4112343	1967-05-27	1967-05-27 00:00:00	1967-06-09	1967-06-09 00:00:00	32020		\N	93963	0	195662009	4112343		0
23877	1427	372328	1958-11-23	1958-11-23 00:00:00	1959-04-15	1959-04-15 00:00:00	32020		\N	94918	0	65363002	372328		0
23945	1430	4109685	1972-02-24	1972-02-24 00:00:00	1972-03-09	1972-03-09 00:00:00	32020		\N	95181	0	284551006	4109685		0
24219	1443	257012	1989-07-04	1989-07-04 00:00:00	\N	\N	32020		\N	96225	0	40055000	257012		0
24345	1450	4112343	2015-03-17	2015-03-17 00:00:00	2015-03-26	2015-03-26 00:00:00	32020		\N	96680	0	195662009	4112343		0
24413	1454	260139	1999-11-19	1999-11-19 00:00:00	1999-11-26	1999-11-26 00:00:00	32020		\N	97027	0	10509002	260139		0
24591	1467	40481087	1980-01-02	1980-01-02 00:00:00	1980-01-23	1980-01-23 00:00:00	32020		\N	97748	0	444814009	40481087		0
24841	1482	4156265	1987-12-10	1987-12-10 00:00:00	1987-12-31	1987-12-31 00:00:00	32020		\N	98828	0	370247008	4156265		0
24984	1491	4112343	1996-11-12	1996-11-12 00:00:00	1996-11-22	1996-11-22 00:00:00	32020		\N	99405	0	195662009	4112343		0
25111	1497	40481087	2004-01-10	2004-01-10 00:00:00	2004-01-17	2004-01-17 00:00:00	32020		\N	99895	0	444814009	40481087		0
25268	1508	260139	1967-09-13	1967-09-13 00:00:00	1967-09-27	1967-09-27 00:00:00	32020		\N	100649	0	10509002	260139		0
25508	1518	260139	1997-01-22	1997-01-22 00:00:00	1997-02-05	1997-02-05 00:00:00	32020		\N	101530	0	10509002	260139		0
25669	1525	40481087	1990-04-20	1990-04-20 00:00:00	1990-04-27	1990-04-27 00:00:00	32020		\N	101966	0	444814009	40481087		0
25856	1536	4109685	1944-03-10	1944-03-10 00:00:00	1944-03-24	1944-03-24 00:00:00	32020		\N	102789	0	284551006	4109685		0
25988	1541	4112343	1997-10-19	1997-10-19 00:00:00	1997-11-01	1997-11-01 00:00:00	32020		\N	103236	0	195662009	4112343		0
26133	1551	4113008	2008-09-20	2008-09-20 00:00:00	2008-10-11	2008-10-11 00:00:00	32020		\N	103886	0	284549007	4113008		0
26305	1560	81151	1940-06-16	1940-06-16 00:00:00	1940-07-07	1940-07-07 00:00:00	32020		\N	104433	0	44465007	81151		0
26417	1567	4283893	2014-10-07	2014-10-07 00:00:00	2014-11-11	2014-11-11 00:00:00	32020		\N	105090	0	36971009	4283893		0
26626	1577	80502	1992-07-03	1992-07-03 00:00:00	\N	\N	32020		\N	105935	0	64859006	80502		0
26815	1588	4112343	2016-02-05	2016-02-05 00:00:00	2016-02-18	2016-02-18 00:00:00	32020		\N	106579	0	195662009	4112343		0
26918	1593	4116491	1981-09-29	1981-09-29 00:00:00	1981-11-07	1981-11-07 00:00:00	32020		\N	106852	0	301011002	4116491		0
27102	1602	81151	1967-05-26	1967-05-26 00:00:00	1967-06-30	1967-06-30 00:00:00	32020		\N	107519	0	44465007	81151		0
27324	1611	4112343	1977-02-16	1977-02-16 00:00:00	1977-02-28	1977-02-28 00:00:00	32020		\N	108275	0	195662009	4112343		0
27536	1626	28060	1956-07-19	1956-07-19 00:00:00	1956-07-26	1956-07-26 00:00:00	32020		\N	109260	0	43878008	28060		0
27649	1632	80180	1993-01-22	1993-01-22 00:00:00	\N	\N	32020		\N	109613	0	396275006	80180		0
27871	1646	4310024	1979-08-18	1979-08-18 00:00:00	\N	\N	32020		\N	110402	0	424802006	4310024		0
38521	2287	4283893	1964-08-13	1964-08-13 00:00:00	1965-01-28	1965-01-28 00:00:00	32020		\N	152115	0	36971009	4283893		0
28114	1659	4112343	1969-08-15	1969-08-15 00:00:00	1969-08-23	1969-08-23 00:00:00	32020		\N	111578	0	195662009	4112343		0
28308	1672	40481087	1974-04-14	1974-04-14 00:00:00	1974-04-21	1974-04-21 00:00:00	32020		\N	112254	0	444814009	40481087		0
28509	1686	40481087	2004-08-19	2004-08-19 00:00:00	2004-08-26	2004-08-26 00:00:00	32020		\N	112937	0	444814009	40481087		0
28571	1690	4155034	2009-12-27	2009-12-27 00:00:00	2010-01-17	2010-01-17 00:00:00	32020		\N	113161	0	283371005	4155034		0
28824	1707	372328	1976-06-02	1976-06-02 00:00:00	1976-07-26	1976-07-26 00:00:00	32020		\N	114134	0	65363002	372328		0
28935	1713	260139	1999-01-14	1999-01-14 00:00:00	1999-01-28	1999-01-28 00:00:00	32020		\N	114435	0	10509002	260139		0
29117	1724	375671	1996-07-31	1996-07-31 00:00:00	1996-08-30	1996-08-30 00:00:00	32020		\N	115302	0	62564004	375671		0
29303	1736	4142905	2010-07-02	2010-07-02 00:00:00	2010-09-30	2010-09-30 00:00:00	32020		\N	115958	0	33737001	4142905		0
29439	1743	4112343	1997-11-13	1997-11-13 00:00:00	1997-11-20	1997-11-20 00:00:00	32020		\N	116493	0	195662009	4112343		0
29605	1752	40481087	1996-11-19	1996-11-19 00:00:00	1996-12-10	1996-12-10 00:00:00	32020		\N	117109	0	444814009	40481087		0
29747	1760	40481087	1986-06-10	1986-06-10 00:00:00	1986-07-01	1986-07-01 00:00:00	32020		\N	117692	0	444814009	40481087		0
29974	1773	80180	1986-01-29	1986-01-29 00:00:00	\N	\N	32020		\N	118537	0	396275006	80180		0
30169	1782	260139	1955-08-13	1955-08-13 00:00:00	1955-08-27	1955-08-27 00:00:00	32020		\N	119359	0	10509002	260139		0
30290	1788	78272	2012-10-19	2012-10-19 00:00:00	2012-11-16	2012-11-16 00:00:00	32020		\N	119837	0	70704007	78272		0
41019	2438	28060	1981-12-15	1981-12-15 00:00:00	1981-12-25	1981-12-25 00:00:00	32020		\N	161767	0	43878008	28060		0
30627	1809	372328	1978-12-18	1978-12-18 00:00:00	1979-01-24	1979-01-24 00:00:00	32020		\N	121094	0	65363002	372328		0
30801	1821	80180	1982-08-12	1982-08-12 00:00:00	\N	\N	32020		\N	121784	0	396275006	80180		0
30954	1834	257012	1969-04-28	1969-04-28 00:00:00	1969-05-05	1969-05-05 00:00:00	32020		\N	122556	0	40055000	257012		0
31133	1844	4112343	1999-10-24	1999-10-24 00:00:00	1999-11-06	1999-11-06 00:00:00	32020		\N	123178	0	195662009	4112343		0
31281	1850	4283893	1970-09-22	1970-09-22 00:00:00	1971-03-30	1971-03-30 00:00:00	32020		\N	123747	0	36971009	4283893		0
31475	1860	260139	1992-08-04	1992-08-04 00:00:00	1992-08-18	1992-08-18 00:00:00	32020		\N	124375	0	10509002	260139		0
31556	1867	372328	1977-07-29	1977-07-29 00:00:00	1978-03-07	1978-03-07 00:00:00	32020		\N	124706	0	65363002	372328		0
31861	1892	80180	1993-09-19	1993-09-19 00:00:00	\N	\N	32020		\N	126011	0	396275006	80180		0
21339	1280	40481087	1984-07-31	1984-07-31 00:00:00	1984-08-07	1984-08-07 00:00:00	32020		\N	84559	0	444814009	40481087		0
21563	1293	4112343	1988-02-01	1988-02-01 00:00:00	1988-02-10	1988-02-10 00:00:00	32020		\N	85468	0	195662009	4112343		0
21719	1305	40481087	1983-05-03	1983-05-03 00:00:00	1983-05-17	1983-05-17 00:00:00	32020		\N	86149	0	444814009	40481087		0
21892	1314	4112343	1938-03-31	1938-03-31 00:00:00	1938-04-09	1938-04-09 00:00:00	32020		\N	87006	0	195662009	4112343		0
21948	1315	4149245	1962-05-29	1962-05-29 00:00:00	1962-08-04	1962-08-04 00:00:00	32020		\N	87105	0	30832001	4149245		0
22189	1323	372328	1962-03-02	1962-03-02 00:00:00	1962-04-14	1962-04-14 00:00:00	32020		\N	87860	0	65363002	372328		0
22310	1332	4027663	1970-05-26	1970-05-26 00:00:00	\N	\N	32020		\N	88360	0	13200003	4027663		0
22476	1340	40481087	1956-05-23	1956-05-23 00:00:00	1956-06-13	1956-06-13 00:00:00	32020		\N	88925	0	444814009	40481087		0
22655	1353	40481087	1957-07-22	1957-07-22 00:00:00	1957-07-29	1957-07-29 00:00:00	32020		\N	89699	0	444814009	40481087		0
22831	1361	372328	1952-07-18	1952-07-18 00:00:00	1952-09-29	1952-09-29 00:00:00	32020		\N	90357	0	65363002	372328		0
22927	1367	4155034	1992-05-18	1992-05-18 00:00:00	1992-06-01	1992-06-01 00:00:00	32020		\N	90623	0	283371005	4155034		0
23105	1379	378001	1977-03-20	1977-03-20 00:00:00	1977-04-19	1977-04-19 00:00:00	32020		\N	91513	0	62106007	378001		0
23307	1390	4112343	2001-02-22	2001-02-22 00:00:00	2001-03-04	2001-03-04 00:00:00	32020		\N	92261	0	195662009	4112343		0
23476	1401	30753	2006-02-09	2006-02-09 00:00:00	\N	\N	32020		\N	93157	0	16761005	30753		0
23647	1411	4283893	2009-03-18	2009-03-18 00:00:00	2009-05-06	2009-05-06 00:00:00	32020		\N	93931	0	36971009	4283893		0
23878	1427	4112343	1978-06-24	1978-06-24 00:00:00	1978-07-03	1978-07-03 00:00:00	32020		\N	94953	0	195662009	4112343		0
23946	1430	257012	1991-09-16	1991-09-16 00:00:00	\N	\N	32020		\N	95155	0	40055000	257012		0
24220	1443	40481087	2018-11-04	2018-11-04 00:00:00	2018-11-24	2018-11-24 00:00:00	32020		\N	96246	0	444814009	40481087		0
24346	1450	378001	1990-09-13	1990-09-13 00:00:00	1990-10-13	1990-10-13 00:00:00	32020		\N	96695	0	62106007	378001		0
24414	1454	40481087	1982-06-20	1982-06-20 00:00:00	1982-07-04	1982-07-04 00:00:00	32020		\N	97006	0	444814009	40481087		0
24592	1467	40481087	1974-02-22	1974-02-22 00:00:00	1974-03-01	1974-03-01 00:00:00	32020		\N	97746	0	444814009	40481087		0
24842	1482	257012	1983-09-03	1983-09-03 00:00:00	\N	\N	32020		\N	98798	0	40055000	257012		0
24985	1491	4112343	2008-05-05	2008-05-05 00:00:00	2008-05-16	2008-05-16 00:00:00	32020		\N	99414	0	195662009	4112343		0
25112	1497	4112343	1953-04-09	1953-04-09 00:00:00	1953-04-18	1953-04-18 00:00:00	32020		\N	99857	0	195662009	4112343		0
25269	1508	40481087	1965-03-26	1965-03-26 00:00:00	1965-04-02	1965-04-02 00:00:00	32020		\N	100617	0	444814009	40481087		0
25509	1518	260139	1997-12-24	1997-12-24 00:00:00	1997-12-31	1997-12-31 00:00:00	32020		\N	101514	0	10509002	260139		0
25670	1525	40481087	1985-05-04	1985-05-04 00:00:00	1985-05-18	1985-05-18 00:00:00	32020		\N	102005	0	444814009	40481087		0
25857	1536	80180	1945-05-09	1945-05-09 00:00:00	\N	\N	32020		\N	102789	0	396275006	80180		0
25989	1541	4027663	1996-04-20	1996-04-20 00:00:00	\N	\N	32020		\N	103257	0	13200003	4027663		0
26134	1551	260139	1958-07-12	1958-07-12 00:00:00	1958-07-19	1958-07-19 00:00:00	32020		\N	103851	0	10509002	260139		0
26306	1560	40481087	1941-11-13	1941-11-13 00:00:00	1941-11-20	1941-11-20 00:00:00	32020		\N	104437	0	444814009	40481087		0
26418	1567	4048171	1980-01-01	1980-01-01 00:00:00	\N	\N	32020		\N	105143	0	232353008	4048171		0
26627	1577	4112343	1969-04-07	1969-04-07 00:00:00	1969-04-15	1969-04-15 00:00:00	32020		\N	105861	0	195662009	4112343		0
26816	1588	4166224	1981-12-01	1981-12-01 00:00:00	\N	\N	32020		\N	106567	0	47693006	4166224		0
26919	1593	381316	2009-10-01	2009-10-01 00:00:00	\N	\N	32020		\N	106939	0	230690007	381316		0
27103	1602	81151	2013-04-18	2013-04-18 00:00:00	2013-05-23	2013-05-23 00:00:00	32020		\N	107526	0	44465007	81151		0
27325	1611	4156265	1972-11-20	1972-11-20 00:00:00	1972-12-04	1972-12-04 00:00:00	32020		\N	108353	0	370247008	4156265		0
27537	1626	196456	1989-12-17	1989-12-17 00:00:00	1989-12-17	1989-12-17 00:00:00	32020		\N	109189	0	235919008	196456		0
27650	1632	4146173	1972-12-28	1972-12-28 00:00:00	1973-01-27	1973-01-27 00:00:00	32020		\N	109568	0	307731004	4146173		0
27872	1646	30753	1981-03-10	1981-03-10 00:00:00	\N	\N	32020		\N	110402	0	16761005	30753		0
38522	2287	81151	1940-12-26	1940-12-26 00:00:00	1941-01-16	1941-01-16 00:00:00	32020		\N	152094	0	44465007	81151		0
28115	1659	40481087	1979-11-17	1979-11-17 00:00:00	1979-12-08	1979-12-08 00:00:00	32020		\N	111531	0	444814009	40481087		0
28309	1672	4218389	1992-01-22	1992-01-22 00:00:00	1992-02-26	1992-02-26 00:00:00	32020		\N	112281	0	39848009	4218389		0
28510	1686	40481087	1978-01-24	1978-01-24 00:00:00	1978-01-31	1978-01-31 00:00:00	32020		\N	112951	0	444814009	40481087		0
28572	1691	4059173	1977-06-25	1977-06-25 00:00:00	1977-08-24	1977-08-24 00:00:00	32020		\N	113253	0	16114001	4059173		0
28825	1707	40481087	1990-01-19	1990-01-19 00:00:00	1990-02-09	1990-02-09 00:00:00	32020		\N	114128	0	444814009	40481087		0
28938	1715	4112343	2006-03-15	2006-03-15 00:00:00	2006-03-24	2006-03-24 00:00:00	32020		\N	114546	0	195662009	4112343		0
29118	1724	40481087	1962-09-05	1962-09-05 00:00:00	1962-09-12	1962-09-12 00:00:00	32020		\N	115241	0	444814009	40481087		0
29304	1736	40481087	2004-05-31	2004-05-31 00:00:00	2004-06-21	2004-06-21 00:00:00	32020		\N	115891	0	444814009	40481087		0
29440	1743	80180	2002-01-15	2002-01-15 00:00:00	\N	\N	32020		\N	116494	0	396275006	80180		0
29606	1752	40481087	1987-08-28	1987-08-28 00:00:00	1987-09-04	1987-09-04 00:00:00	32020		\N	117134	0	444814009	40481087		0
29748	1761	4112343	1963-11-27	1963-11-27 00:00:00	1963-12-08	1963-12-08 00:00:00	32020		\N	117753	0	195662009	4112343		0
29975	1773	4294548	1996-04-03	1996-04-03 00:00:00	1996-04-24	1996-04-24 00:00:00	32020		\N	118513	0	75498004	4294548		0
30170	1782	78272	1973-01-09	1973-01-09 00:00:00	1973-01-30	1973-01-30 00:00:00	32020		\N	119342	0	70704007	78272		0
30291	1788	4112343	2016-12-15	2016-12-15 00:00:00	2016-12-22	2016-12-22 00:00:00	32020		\N	119776	0	195662009	4112343		0
41020	2438	372328	2017-11-05	2017-11-05 00:00:00	2018-04-15	2018-04-15 00:00:00	32020		\N	161722	0	65363002	372328		0
30628	1809	4113008	2004-12-01	2004-12-01 00:00:00	2004-12-15	2004-12-15 00:00:00	32020		\N	121089	0	284549007	4113008		0
30802	1821	40481087	1943-07-09	1943-07-09 00:00:00	1943-07-23	1943-07-23 00:00:00	32020		\N	121768	0	444814009	40481087		0
30955	1834	40481087	2017-08-16	2017-08-16 00:00:00	2017-08-23	2017-08-23 00:00:00	32020		\N	122518	0	444814009	40481087		0
31134	1844	4112343	1964-04-24	1964-04-24 00:00:00	1964-05-02	1964-05-02 00:00:00	32020		\N	123191	0	195662009	4112343		0
31282	1850	372328	1962-05-17	1962-05-17 00:00:00	1962-11-30	1962-11-30 00:00:00	32020		\N	123770	0	65363002	372328		0
31477	1860	321042	1991-12-23	1991-12-23 00:00:00	\N	\N	32020		\N	124407	0	410429000	321042		0
31557	1867	372328	1973-03-19	1973-03-19 00:00:00	1973-05-29	1973-05-29 00:00:00	32020		\N	124677	0	65363002	372328		0
31862	1892	40481087	2012-12-22	2012-12-22 00:00:00	2012-12-29	2012-12-29 00:00:00	32020		\N	126036	0	444814009	40481087		0
21340	1280	260139	2011-12-13	2011-12-13 00:00:00	2011-12-20	2011-12-20 00:00:00	32020		\N	84607	0	10509002	260139		0
21564	1293	40481087	1949-07-29	1949-07-29 00:00:00	1949-08-05	1949-08-05 00:00:00	32020		\N	85552	0	444814009	40481087		0
21720	1305	4218389	1967-05-25	1967-05-25 00:00:00	1967-06-15	1967-06-15 00:00:00	32020		\N	86107	0	39848009	4218389		0
21893	1314	28060	1936-04-28	1936-04-28 00:00:00	1936-05-09	1936-05-09 00:00:00	32020		\N	87020	0	43878008	28060		0
21949	1315	81151	1960-05-04	1960-05-04 00:00:00	1960-06-08	1960-06-08 00:00:00	32020		\N	87104	0	44465007	81151		0
22190	1323	4155034	1997-09-15	1997-09-15 00:00:00	1997-10-06	1997-10-06 00:00:00	32020		\N	87847	0	283371005	4155034		0
22311	1332	4329847	2019-01-02	2019-01-02 00:00:00	\N	\N	32020		\N	88384	0	22298006	4329847		0
22477	1340	28060	1958-02-16	1958-02-16 00:00:00	1958-02-24	1958-02-24 00:00:00	32020		\N	88956	0	43878008	28060		0
22656	1353	4109685	1964-09-08	1964-09-08 00:00:00	1964-09-29	1964-09-29 00:00:00	32020		\N	89639	0	284551006	4109685		0
22832	1361	40481087	2018-03-09	2018-03-09 00:00:00	2018-03-30	2018-03-30 00:00:00	32020		\N	90375	0	444814009	40481087		0
22928	1367	372328	1967-11-29	1967-11-29 00:00:00	1968-04-05	1968-04-05 00:00:00	32020		\N	90609	0	65363002	372328		0
23106	1379	4112343	1972-01-11	1972-01-11 00:00:00	1972-01-18	1972-01-18 00:00:00	32020		\N	91492	0	195662009	4112343		0
23308	1390	378001	1994-09-18	1994-09-18 00:00:00	1994-10-18	1994-10-18 00:00:00	32020		\N	92249	0	62106007	378001		0
23477	1401	4285898	2006-09-07	2006-09-07 00:00:00	\N	\N	32020		\N	93157	0	68496003	4285898		0
23648	1411	4027663	1995-11-23	1995-11-23 00:00:00	\N	\N	32020		\N	93968	0	13200003	4027663		0
23879	1427	78272	2000-10-16	2000-10-16 00:00:00	2000-11-06	2000-11-06 00:00:00	32020		\N	94962	0	70704007	78272		0
23947	1430	195588	1997-11-09	1997-11-09 00:00:00	1998-01-01	1998-01-01 00:00:00	32020		\N	95157	0	38822007	195588		0
24221	1443	4283893	2012-02-27	2012-02-27 00:00:00	2012-04-03	2012-04-03 00:00:00	32020		\N	96245	0	36971009	4283893		0
24347	1450	81151	1976-01-09	1976-01-09 00:00:00	1976-01-30	1976-01-30 00:00:00	32020		\N	96699	0	44465007	81151		0
24415	1454	260139	1979-01-02	1979-01-02 00:00:00	1979-01-09	1979-01-09 00:00:00	32020		\N	96976	0	10509002	260139		0
24593	1467	4112343	1951-09-30	1951-09-30 00:00:00	1951-10-08	1951-10-08 00:00:00	32020		\N	97759	0	195662009	4112343		0
24843	1482	372328	1993-01-01	1993-01-01 00:00:00	1993-11-06	1993-11-06 00:00:00	32020		\N	98846	0	65363002	372328		0
24986	1491	4112343	2008-11-13	2008-11-13 00:00:00	2008-11-22	2008-11-22 00:00:00	32020		\N	99436	0	195662009	4112343		0
25113	1497	372328	1945-05-07	1945-05-07 00:00:00	1946-03-01	1946-03-01 00:00:00	32020		\N	99755	0	65363002	372328		0
25270	1508	40481087	1927-06-21	1927-06-21 00:00:00	1927-07-12	1927-07-12 00:00:00	32020		\N	100522	0	444814009	40481087		0
25510	1518	4266809	1998-07-14	1998-07-14 00:00:00	\N	\N	32020		\N	101567	0	397881000	4266809		0
25671	1525	257012	1969-03-07	1969-03-07 00:00:00	1969-05-09	1969-05-09 00:00:00	32020		\N	102003	0	40055000	257012		0
25858	1536	4112343	1964-08-18	1964-08-18 00:00:00	1964-08-30	1964-08-30 00:00:00	32020		\N	102778	0	195662009	4112343		0
25990	1541	4112343	1964-01-26	1964-01-26 00:00:00	1964-02-02	1964-02-02 00:00:00	32020		\N	103238	0	195662009	4112343		0
26135	1551	4152936	1990-04-07	1990-04-07 00:00:00	1990-04-28	1990-04-28 00:00:00	32020		\N	103885	0	283385000	4152936		0
26307	1560	260139	1997-12-12	1997-12-12 00:00:00	1997-12-26	1997-12-26 00:00:00	32020		\N	104443	0	10509002	260139		0
26419	1567	40481087	1991-05-27	1991-05-27 00:00:00	1991-06-03	1991-06-03 00:00:00	32020		\N	105146	0	444814009	40481087		0
26628	1577	260139	1990-06-07	1990-06-07 00:00:00	1990-06-21	1990-06-21 00:00:00	32020		\N	105838	0	10509002	260139		0
26817	1588	440448	1981-12-01	1981-12-01 00:00:00	\N	\N	32020		\N	106567	0	74400008	440448		0
26920	1593	372328	1940-01-06	1940-01-06 00:00:00	1940-09-26	1940-09-26 00:00:00	32020		\N	106868	0	65363002	372328		0
27104	1602	4278672	2006-05-25	2006-05-25 00:00:00	2006-07-24	2006-07-24 00:00:00	32020		\N	107525	0	65966004	4278672		0
27326	1611	440448	1989-05-31	1989-05-31 00:00:00	\N	\N	32020		\N	108354	0	74400008	440448		0
27538	1626	198809	1989-12-17	1989-12-17 00:00:00	1989-12-17	1989-12-17 00:00:00	32020		\N	109189	0	65275009	198809		0
27651	1632	260139	2004-01-07	2004-01-07 00:00:00	2004-01-21	2004-01-21 00:00:00	32020		\N	109560	0	10509002	260139		0
27873	1646	81893	1980-04-14	1980-04-14 00:00:00	\N	\N	32020		\N	110402	0	64766004	81893		0
38523	2287	4059173	1954-09-10	1954-09-10 00:00:00	1954-10-10	1954-10-10 00:00:00	32020		\N	152155	0	16114001	4059173		0
28116	1659	40481087	1986-07-05	1986-07-05 00:00:00	1986-07-12	1986-07-12 00:00:00	32020		\N	111501	0	444814009	40481087		0
28310	1672	4112343	1958-10-31	1958-10-31 00:00:00	1958-11-07	1958-11-07 00:00:00	32020		\N	112247	0	195662009	4112343		0
28525	1689	4283893	1949-03-10	1949-03-10 00:00:00	1949-08-18	1949-08-18 00:00:00	32020		\N	113091	0	36971009	4283893		0
28573	1691	4112343	1960-02-06	1960-02-06 00:00:00	1960-02-16	1960-02-16 00:00:00	32020		\N	113259	0	195662009	4112343		0
28826	1707	80180	2006-04-18	2006-04-18 00:00:00	\N	\N	32020		\N	114150	0	396275006	80180		0
28939	1715	372328	1959-04-09	1959-04-09 00:00:00	1959-05-02	1959-05-02 00:00:00	32020		\N	114569	0	65363002	372328		0
29119	1724	439777	2016-08-26	2016-08-26 00:00:00	\N	\N	32020		\N	115252	0	271737000	439777		0
29305	1736	372328	1974-04-12	1974-04-12 00:00:00	1975-04-24	1975-04-24 00:00:00	32020		\N	115944	0	65363002	372328		0
29441	1743	40481087	1986-08-16	1986-08-16 00:00:00	1986-08-23	1986-08-23 00:00:00	32020		\N	116482	0	444814009	40481087		0
29607	1752	4283893	2015-01-26	2015-01-26 00:00:00	2015-03-02	2015-03-02 00:00:00	32020		\N	117123	0	36971009	4283893		0
29749	1761	4109685	1972-10-14	1972-10-14 00:00:00	1972-10-28	1972-10-28 00:00:00	32020		\N	117719	0	284551006	4109685		0
29976	1773	4084167	1965-01-14	1965-01-14 00:00:00	1965-01-14	1965-01-14 00:00:00	32020		\N	118549	0	241929008	4084167		0
30171	1782	4112343	1970-03-13	1970-03-13 00:00:00	1970-03-26	1970-03-26 00:00:00	32020		\N	119307	0	195662009	4112343		0
30292	1788	40481087	1988-09-05	1988-09-05 00:00:00	1988-09-12	1988-09-12 00:00:00	32020		\N	119826	0	444814009	40481087		0
41021	2438	260139	2014-01-12	2014-01-12 00:00:00	2014-01-19	2014-01-19 00:00:00	32020		\N	161753	0	10509002	260139		0
30629	1809	4112343	1970-02-25	1970-02-25 00:00:00	1970-03-08	1970-03-08 00:00:00	32020		\N	121098	0	195662009	4112343		0
30803	1821	260139	2016-02-14	2016-02-14 00:00:00	2016-02-21	2016-02-21 00:00:00	32020		\N	121798	0	10509002	260139		0
30956	1834	28060	2016-05-17	2016-05-17 00:00:00	2016-05-30	2016-05-30 00:00:00	32020		\N	122517	0	43878008	28060		0
31135	1844	4283893	1977-09-26	1977-09-26 00:00:00	1977-10-31	1977-10-31 00:00:00	32020		\N	123243	0	36971009	4283893		0
31283	1850	40481087	1991-03-05	1991-03-05 00:00:00	1991-03-19	1991-03-19 00:00:00	32020		\N	123756	0	444814009	40481087		0
31478	1860	372328	1963-03-24	1963-03-24 00:00:00	1963-10-07	1963-10-07 00:00:00	32020		\N	124377	0	65363002	372328		0
31558	1867	81151	2018-06-21	2018-06-21 00:00:00	2018-07-26	2018-07-26 00:00:00	32020		\N	124730	0	44465007	81151		0
31863	1892	40481087	2013-02-06	2013-02-06 00:00:00	2013-02-20	2013-02-20 00:00:00	32020		\N	125992	0	444814009	40481087		0
21341	1280	440086	1964-06-30	1964-06-30 00:00:00	1965-08-31	1965-08-31 00:00:00	32020		\N	84574	0	192127007	440086		0
21565	1293	40481087	1971-12-15	1971-12-15 00:00:00	1971-12-29	1971-12-29 00:00:00	32020		\N	85540	0	444814009	40481087		0
21721	1305	260139	1969-06-14	1969-06-14 00:00:00	1969-06-28	1969-06-28 00:00:00	32020		\N	86124	0	10509002	260139		0
21894	1314	44782520	1946-07-21	1946-07-21 00:00:00	\N	\N	32020		\N	87033	0	698754002	44782520		0
21950	1316	260139	1985-06-02	1985-06-02 00:00:00	1985-06-09	1985-06-09 00:00:00	32020		\N	87180	0	10509002	260139		0
22210	1325	40481087	1978-12-14	1978-12-14 00:00:00	1979-01-04	1979-01-04 00:00:00	32020		\N	87959	0	444814009	40481087		0
22313	1332	4155034	2002-12-25	2002-12-25 00:00:00	2003-01-08	2003-01-08 00:00:00	32020		\N	88383	0	283371005	4155034		0
22478	1340	4027663	1943-07-22	1943-07-22 00:00:00	\N	\N	32020		\N	88972	0	13200003	4027663		0
22657	1353	4112343	1981-05-11	1981-05-11 00:00:00	1981-05-23	1981-05-23 00:00:00	32020		\N	89666	0	195662009	4112343		0
22833	1361	4112343	1999-04-20	1999-04-20 00:00:00	1999-04-29	1999-04-29 00:00:00	32020		\N	90346	0	195662009	4112343		0
22929	1368	4156265	1985-01-30	1985-01-30 00:00:00	1985-02-20	1985-02-20 00:00:00	32020		\N	90747	0	370247008	4156265		0
23107	1379	321042	1987-09-05	1987-09-05 00:00:00	\N	\N	32020		\N	91516	0	410429000	321042		0
23309	1390	192671	2006-12-19	2006-12-19 00:00:00	\N	\N	32020		\N	92252	0	K92.2	35208414		0
23478	1401	40481087	2005-04-25	2005-04-25 00:00:00	2005-05-16	2005-05-16 00:00:00	32020		\N	93157	0	444814009	40481087		0
23649	1411	257012	1995-05-22	1995-05-22 00:00:00	\N	\N	32020		\N	93968	0	40055000	257012		0
23880	1427	40481087	1983-03-16	1983-03-16 00:00:00	1983-03-30	1983-03-30 00:00:00	32020		\N	94930	0	444814009	40481087		0
23948	1430	80180	1986-03-02	1986-03-02 00:00:00	\N	\N	32020		\N	95104	0	396275006	80180		0
24222	1443	81151	1993-07-19	1993-07-19 00:00:00	1993-08-23	1993-08-23 00:00:00	32020		\N	96192	0	44465007	81151		0
24348	1450	260139	2015-11-24	2015-11-24 00:00:00	2015-12-08	2015-12-08 00:00:00	32020		\N	96724	0	10509002	260139		0
24416	1454	40481087	1992-05-18	1992-05-18 00:00:00	1992-06-08	1992-06-08 00:00:00	32020		\N	96988	0	444814009	40481087		0
24594	1467	81151	1966-08-30	1966-08-30 00:00:00	1966-09-13	1966-09-13 00:00:00	32020		\N	97666	0	44465007	81151		0
24844	1482	260139	2006-06-13	2006-06-13 00:00:00	2006-06-20	2006-06-20 00:00:00	32020		\N	98901	0	10509002	260139		0
24987	1491	80180	2006-05-20	2006-05-20 00:00:00	\N	\N	32020		\N	99420	0	396275006	80180		0
25114	1497	40481087	1996-06-09	1996-06-09 00:00:00	1996-06-23	1996-06-23 00:00:00	32020		\N	99919	0	444814009	40481087		0
25271	1508	4146173	1986-04-01	1986-04-01 00:00:00	1986-05-31	1986-05-31 00:00:00	32020		\N	100619	0	307731004	4146173		0
25511	1518	80180	1998-07-14	1998-07-14 00:00:00	\N	\N	32020		\N	101567	0	396275006	80180		0
25672	1525	372328	1965-12-18	1965-12-18 00:00:00	1966-01-01	1966-01-01 00:00:00	32020		\N	102025	0	65363002	372328		0
25859	1536	260139	1919-09-17	1919-09-17 00:00:00	1919-09-24	1919-09-24 00:00:00	32020		\N	102819	0	10509002	260139		0
25991	1541	40481087	1984-09-05	1984-09-05 00:00:00	1984-09-12	1984-09-12 00:00:00	32020		\N	103241	0	444814009	40481087		0
26136	1551	260139	1996-12-05	1996-12-05 00:00:00	1996-12-19	1996-12-19 00:00:00	32020		\N	103868	0	10509002	260139		0
26308	1560	40481087	1967-06-29	1967-06-29 00:00:00	1967-07-06	1967-07-06 00:00:00	32020		\N	104448	0	444814009	40481087		0
26420	1567	40481087	1984-03-01	1984-03-01 00:00:00	1984-03-15	1984-03-15 00:00:00	32020		\N	105111	0	444814009	40481087		0
26629	1577	4112343	2007-01-10	2007-01-10 00:00:00	2007-01-22	2007-01-22 00:00:00	32020		\N	105941	0	195662009	4112343		0
26818	1588	28060	1975-08-29	1975-08-29 00:00:00	1975-09-09	1975-09-09 00:00:00	32020		\N	106643	0	43878008	28060		0
26921	1593	81151	1945-03-17	1945-03-17 00:00:00	1945-04-14	1945-04-14 00:00:00	32020		\N	106840	0	44465007	81151		0
27105	1602	40481087	1980-10-23	1980-10-23 00:00:00	1980-10-30	1980-10-30 00:00:00	32020		\N	107503	0	444814009	40481087		0
27327	1611	260139	2011-10-12	2011-10-12 00:00:00	2011-10-19	2011-10-19 00:00:00	32020		\N	108327	0	10509002	260139		0
27539	1626	40481087	1968-04-18	1968-04-18 00:00:00	1968-05-02	1968-05-02 00:00:00	32020		\N	109221	0	444814009	40481087		0
27652	1632	4112343	1969-11-12	1969-11-12 00:00:00	1969-11-20	1969-11-20 00:00:00	32020		\N	109589	0	195662009	4112343		0
27874	1646	260139	2018-03-23	2018-03-23 00:00:00	2018-04-06	2018-04-06 00:00:00	32020		\N	110438	0	10509002	260139		0
38524	2287	4294548	2010-04-04	2010-04-04 00:00:00	2010-04-25	2010-04-25 00:00:00	32020		\N	152103	0	75498004	4294548		0
28117	1659	4113008	2004-08-24	2004-08-24 00:00:00	2004-09-07	2004-09-07 00:00:00	32020		\N	111458	0	284549007	4113008		0
28311	1672	372328	1955-08-17	1955-08-17 00:00:00	1955-10-05	1955-10-05 00:00:00	32020		\N	112231	0	65363002	372328		0
28526	1689	28060	1945-12-03	1945-12-03 00:00:00	1945-12-12	1945-12-12 00:00:00	32020		\N	113137	0	43878008	28060		0
28574	1691	40481087	2014-10-28	2014-10-28 00:00:00	2014-11-11	2014-11-11 00:00:00	32020		\N	113290	0	444814009	40481087		0
28827	1707	40481087	2005-04-07	2005-04-07 00:00:00	2005-04-14	2005-04-14 00:00:00	32020		\N	114150	0	444814009	40481087		0
28940	1715	378001	1987-03-27	1987-03-27 00:00:00	1987-05-26	1987-05-26 00:00:00	32020		\N	114535	0	62106007	378001		0
29120	1724	81151	1957-03-02	1957-03-02 00:00:00	1957-03-30	1957-03-30 00:00:00	32020		\N	115263	0	44465007	81151		0
29306	1736	40481087	1983-11-11	1983-11-11 00:00:00	1983-11-18	1983-11-18 00:00:00	32020		\N	115896	0	444814009	40481087		0
29442	1744	40481087	1992-10-04	1992-10-04 00:00:00	1992-10-25	1992-10-25 00:00:00	32020		\N	116612	0	444814009	40481087		0
29608	1752	40481087	1999-06-05	1999-06-05 00:00:00	1999-06-12	1999-06-12 00:00:00	32020		\N	117135	0	444814009	40481087		0
29750	1761	28060	2001-01-01	2001-01-01 00:00:00	2001-01-10	2001-01-10 00:00:00	32020		\N	117709	0	43878008	28060		0
29977	1773	260139	1969-12-21	1969-12-21 00:00:00	1970-01-04	1970-01-04 00:00:00	32020		\N	118536	0	10509002	260139		0
30172	1782	4152936	2009-11-17	2009-11-17 00:00:00	2009-12-01	2009-12-01 00:00:00	32020		\N	119344	0	283385000	4152936		0
30293	1788	4112343	2018-11-13	2018-11-13 00:00:00	2018-11-26	2018-11-26 00:00:00	32020		\N	119804	0	195662009	4112343		0
41022	2438	257012	2005-11-10	2005-11-10 00:00:00	\N	\N	32020		\N	161771	0	40055000	257012		0
30630	1809	28060	1964-07-05	1964-07-05 00:00:00	1964-07-13	1964-07-13 00:00:00	32020		\N	121091	0	43878008	28060		0
30804	1821	260139	1974-11-18	1974-11-18 00:00:00	1974-11-25	1974-11-25 00:00:00	32020		\N	121811	0	10509002	260139		0
30957	1834	40481087	2016-04-27	2016-04-27 00:00:00	2016-05-18	2016-05-18 00:00:00	32020		\N	122490	0	444814009	40481087		0
31136	1844	28060	2009-04-21	2009-04-21 00:00:00	2009-04-29	2009-04-29 00:00:00	32020		\N	123204	0	43878008	28060		0
31284	1850	4112343	2013-06-01	2013-06-01 00:00:00	2013-06-08	2013-06-08 00:00:00	32020		\N	123769	0	195662009	4112343		0
31479	1860	4329847	1985-11-11	1985-11-11 00:00:00	\N	\N	32020		\N	124404	0	22298006	4329847		0
31559	1867	260139	1983-04-28	1983-04-28 00:00:00	1983-05-05	1983-05-05 00:00:00	32020		\N	124703	0	10509002	260139		0
31864	1892	4094814	2018-06-13	2018-06-13 00:00:00	2018-09-11	2018-09-11 00:00:00	32020		\N	126049	0	262574004	4094814		0
21342	1280	40481087	1971-04-26	1971-04-26 00:00:00	1971-05-03	1971-05-03 00:00:00	32020		\N	84555	0	444814009	40481087		0
21566	1293	40481087	1976-09-11	1976-09-11 00:00:00	1976-09-18	1976-09-18 00:00:00	32020		\N	85542	0	444814009	40481087		0
21722	1305	378001	2004-04-01	2004-04-01 00:00:00	2004-05-01	2004-05-01 00:00:00	32020		\N	86108	0	62106007	378001		0
21895	1314	4066995	1946-07-21	1946-07-21 00:00:00	1946-09-20	1946-09-20 00:00:00	32020		\N	87033	0	1734006	4066995		0
21951	1316	40481087	1997-11-20	1997-11-20 00:00:00	1997-12-11	1997-12-11 00:00:00	32020		\N	87227	0	444814009	40481087		0
22211	1325	260139	1974-04-24	1974-04-24 00:00:00	1974-05-01	1974-05-01 00:00:00	32020		\N	87950	0	10509002	260139		0
22314	1332	4134304	1979-12-05	1979-12-05 00:00:00	1980-01-04	1980-01-04 00:00:00	32020		\N	88381	0	263102004	4134304		0
22479	1340	4112343	1913-08-03	1913-08-03 00:00:00	1913-08-11	1913-08-11 00:00:00	32020		\N	88963	0	195662009	4112343		0
22658	1353	80180	1992-11-05	1992-11-05 00:00:00	\N	\N	32020		\N	89644	0	396275006	80180		0
22834	1361	4112343	1980-10-06	1980-10-06 00:00:00	1980-10-16	1980-10-16 00:00:00	32020		\N	90345	0	195662009	4112343		0
22930	1368	4299128	1970-09-18	1970-09-18 00:00:00	1970-10-16	1970-10-16 00:00:00	32020		\N	90746	0	403192003	4299128		0
23109	1379	4112343	1964-09-09	1964-09-09 00:00:00	1964-09-18	1964-09-18 00:00:00	32020		\N	91490	0	195662009	4112343		0
23310	1390	40481087	1977-05-26	1977-05-26 00:00:00	1977-06-02	1977-06-02 00:00:00	32020		\N	92256	0	444814009	40481087		0
23479	1401	40481087	2008-05-09	2008-05-09 00:00:00	2008-05-30	2008-05-30 00:00:00	32020		\N	93147	0	444814009	40481087		0
23650	1411	40481087	1969-02-19	1969-02-19 00:00:00	1969-03-12	1969-03-12 00:00:00	32020		\N	93942	0	444814009	40481087		0
23881	1427	4142905	1958-09-24	1958-09-24 00:00:00	1958-11-23	1958-11-23 00:00:00	32020		\N	94957	0	33737001	4142905		0
23949	1430	40481087	1958-02-23	1958-02-23 00:00:00	1958-03-16	1958-03-16 00:00:00	32020		\N	95129	0	444814009	40481087		0
24223	1443	78272	1988-09-24	1988-09-24 00:00:00	1988-10-15	1988-10-15 00:00:00	32020		\N	96190	0	70704007	78272		0
24349	1450	80180	1996-03-19	1996-03-19 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
24450	1459	4134304	1997-07-15	1997-07-15 00:00:00	1997-09-13	1997-09-13 00:00:00	32020		\N	97248	0	263102004	4134304		0
24595	1467	372328	1935-06-14	1935-06-14 00:00:00	1935-09-01	1935-09-01 00:00:00	32020		\N	97674	0	65363002	372328		0
24845	1482	261325	2005-11-19	2005-11-19 00:00:00	\N	\N	32020		\N	98823	0	87433001	261325		0
24988	1491	4266809	2006-05-20	2006-05-20 00:00:00	\N	\N	32020		\N	99420	0	397881000	4266809		0
25115	1497	4283893	1972-04-13	1972-04-13 00:00:00	1972-05-25	1972-05-25 00:00:00	32020		\N	99860	0	36971009	4283893		0
25272	1508	372328	1928-03-24	1928-03-24 00:00:00	1928-12-11	1928-12-11 00:00:00	32020		\N	100610	0	65363002	372328		0
25512	1518	4285898	1998-02-14	1998-02-14 00:00:00	\N	\N	32020		\N	101567	0	68496003	4285898		0
25673	1525	4294548	1969-02-07	1969-02-07 00:00:00	1969-05-09	1969-05-09 00:00:00	32020		\N	101987	0	75498004	4294548		0
25860	1536	40481087	1964-05-30	1964-05-30 00:00:00	1964-06-20	1964-06-20 00:00:00	32020		\N	102777	0	444814009	40481087		0
25992	1541	80180	2007-02-07	2007-02-07 00:00:00	\N	\N	32020		\N	103289	0	396275006	80180		0
26137	1551	80180	1998-08-24	1998-08-24 00:00:00	\N	\N	32020		\N	103862	0	396275006	80180		0
26330	1563	4283893	2018-05-03	2018-05-03 00:00:00	2018-05-31	2018-05-31 00:00:00	32020		\N	104695	0	36971009	4283893		0
26421	1567	4112343	2008-08-16	2008-08-16 00:00:00	2008-08-28	2008-08-28 00:00:00	32020		\N	105147	0	195662009	4112343		0
26630	1577	4112343	1922-10-16	1922-10-16 00:00:00	1922-10-29	1922-10-29 00:00:00	32020		\N	105858	0	195662009	4112343		0
26819	1588	4112343	1972-03-07	1972-03-07 00:00:00	1972-03-16	1972-03-16 00:00:00	32020		\N	106631	0	195662009	4112343		0
26922	1593	40481087	2019-01-23	2019-01-23 00:00:00	2019-01-30	2019-01-30 00:00:00	32020		\N	106894	0	444814009	40481087		0
27109	1604	372328	1957-10-25	1957-10-25 00:00:00	1958-10-09	1958-10-09 00:00:00	32020		\N	107656	0	65363002	372328		0
27328	1611	40481087	1972-05-25	1972-05-25 00:00:00	1972-06-15	1972-06-15 00:00:00	32020		\N	108274	0	444814009	40481087		0
27540	1626	378001	1993-06-26	1993-06-26 00:00:00	1993-08-25	1993-08-25 00:00:00	32020		\N	109190	0	62106007	378001		0
27653	1632	40481087	1971-02-25	1971-02-25 00:00:00	1971-03-11	1971-03-11 00:00:00	32020		\N	109558	0	444814009	40481087		0
27875	1646	260139	1946-01-14	1946-01-14 00:00:00	1946-01-28	1946-01-28 00:00:00	32020		\N	110352	0	10509002	260139		0
38526	2289	40481087	1985-04-16	1985-04-16 00:00:00	1985-05-07	1985-05-07 00:00:00	32020		\N	152285	0	444814009	40481087		0
28118	1659	40481087	1974-06-10	1974-06-10 00:00:00	1974-06-17	1974-06-17 00:00:00	32020		\N	111454	0	444814009	40481087		0
28312	1672	4113008	2007-09-19	2007-09-19 00:00:00	2007-10-10	2007-10-10 00:00:00	32020		\N	112283	0	284549007	4113008		0
28527	1689	4112343	1960-05-15	1960-05-15 00:00:00	1960-05-22	1960-05-22 00:00:00	32020		\N	113093	0	195662009	4112343		0
28575	1691	4113008	2015-12-24	2015-12-24 00:00:00	2016-01-07	2016-01-07 00:00:00	32020		\N	113271	0	284549007	4113008		0
28828	1707	4266809	2006-04-18	2006-04-18 00:00:00	\N	\N	32020		\N	114150	0	397881000	4266809		0
28941	1715	4218389	2010-09-27	2010-09-27 00:00:00	2010-10-25	2010-10-25 00:00:00	32020		\N	114556	0	39848009	4218389		0
29121	1724	4112343	1984-05-07	1984-05-07 00:00:00	1984-05-19	1984-05-19 00:00:00	32020		\N	115299	0	195662009	4112343		0
29307	1736	40481087	1984-11-18	1984-11-18 00:00:00	1984-12-09	1984-12-09 00:00:00	32020		\N	115897	0	444814009	40481087		0
29443	1744	260139	1993-02-15	1993-02-15 00:00:00	1993-03-01	1993-03-01 00:00:00	32020		\N	116618	0	10509002	260139		0
29609	1752	28060	2009-08-08	2009-08-08 00:00:00	2009-08-21	2009-08-21 00:00:00	32020		\N	117122	0	43878008	28060		0
29751	1761	40481087	1967-03-09	1967-03-09 00:00:00	1967-03-30	1967-03-30 00:00:00	32020		\N	117755	0	444814009	40481087		0
29989	1776	4112343	1974-05-21	1974-05-21 00:00:00	1974-06-01	1974-06-01 00:00:00	32020		\N	118774	0	195662009	4112343		0
30173	1782	40481087	1997-10-22	1997-10-22 00:00:00	1997-10-29	1997-10-29 00:00:00	32020		\N	119347	0	444814009	40481087		0
30294	1788	40481087	1991-06-08	1991-06-08 00:00:00	1991-06-15	1991-06-15 00:00:00	32020		\N	119775	0	444814009	40481087		0
41023	2439	372328	1976-02-11	1976-02-11 00:00:00	1976-04-21	1976-04-21 00:00:00	32020		\N	161815	0	65363002	372328		0
30631	1809	260139	1996-10-05	1996-10-05 00:00:00	1996-10-19	1996-10-19 00:00:00	32020		\N	121120	0	10509002	260139		0
30805	1821	260139	1939-11-22	1939-11-22 00:00:00	1939-12-06	1939-12-06 00:00:00	32020		\N	121849	0	10509002	260139		0
30958	1834	260139	1971-06-11	1971-06-11 00:00:00	1971-06-25	1971-06-25 00:00:00	32020		\N	122559	0	10509002	260139		0
31137	1844	4278672	1977-07-15	1977-07-15 00:00:00	1977-09-13	1977-09-13 00:00:00	32020		\N	123218	0	65966004	4278672		0
31285	1850	28060	1984-10-06	1984-10-06 00:00:00	1984-10-14	1984-10-14 00:00:00	32020		\N	123755	0	43878008	28060		0
31481	1860	317576	1973-12-03	1973-12-03 00:00:00	\N	\N	32020		\N	124381	0	53741008	317576		0
31560	1867	40481087	1976-07-22	1976-07-22 00:00:00	1976-08-12	1976-08-12 00:00:00	32020		\N	124731	0	444814009	40481087		0
31865	1892	28060	1999-10-29	1999-10-29 00:00:00	1999-11-06	1999-11-06 00:00:00	32020		\N	125991	0	43878008	28060		0
21343	1281	81151	2008-10-31	2008-10-31 00:00:00	2008-11-28	2008-11-28 00:00:00	32020		\N	84705	0	44465007	81151		0
21567	1293	4112343	1953-04-03	1953-04-03 00:00:00	1953-04-11	1953-04-11 00:00:00	32020		\N	85481	0	195662009	4112343		0
21723	1305	372328	1964-12-06	1964-12-06 00:00:00	1965-03-18	1965-03-18 00:00:00	32020		\N	86140	0	65363002	372328		0
21896	1314	378419	2017-07-15	2017-07-15 00:00:00	\N	\N	32020		\N	87005	0	26929004	378419		0
21952	1316	81151	1968-05-05	1968-05-05 00:00:00	1968-06-09	1968-06-09 00:00:00	32020		\N	87221	0	44465007	81151		0
22212	1325	4112343	2002-03-12	2002-03-12 00:00:00	2002-03-22	2002-03-22 00:00:00	32020		\N	87972	0	195662009	4112343		0
22315	1332	80180	1979-12-10	1979-12-10 00:00:00	\N	\N	32020		\N	88381	0	396275006	80180		0
22480	1340	4283893	1912-12-29	1912-12-29 00:00:00	1913-08-31	1913-08-31 00:00:00	32020		\N	88876	0	36971009	4283893		0
22659	1353	4142905	1968-08-09	1968-08-09 00:00:00	1968-11-07	1968-11-07 00:00:00	32020		\N	89640	0	33737001	4142905		0
22835	1361	4237458	1999-10-31	1999-10-31 00:00:00	1999-12-30	1999-12-30 00:00:00	32020		\N	90292	0	58150001	4237458		0
22931	1368	40481087	1971-02-20	1971-02-20 00:00:00	1971-03-13	1971-03-13 00:00:00	32020		\N	90710	0	444814009	40481087		0
23110	1379	4113008	1968-08-29	1968-08-29 00:00:00	1968-09-19	1968-09-19 00:00:00	32020		\N	91510	0	284549007	4113008		0
23311	1390	40481087	2000-05-21	2000-05-21 00:00:00	2000-06-11	2000-06-11 00:00:00	32020		\N	92270	0	444814009	40481087		0
23480	1401	40481087	2016-04-14	2016-04-14 00:00:00	2016-04-28	2016-04-28 00:00:00	32020		\N	93168	0	444814009	40481087		0
23651	1411	372328	1966-09-26	1966-09-26 00:00:00	1966-11-08	1966-11-08 00:00:00	32020		\N	93954	0	65363002	372328		0
23882	1427	40481087	2011-03-15	2011-03-15 00:00:00	2011-04-05	2011-04-05 00:00:00	32020		\N	94922	0	444814009	40481087		0
23950	1430	40481087	1973-08-02	1973-08-02 00:00:00	1973-08-23	1973-08-23 00:00:00	32020		\N	95138	0	444814009	40481087		0
24224	1443	40481087	1986-01-13	1986-01-13 00:00:00	1986-02-03	1986-02-03 00:00:00	32020		\N	96202	0	444814009	40481087		0
24350	1450	4156265	1994-11-21	1994-11-21 00:00:00	1994-12-12	1994-12-12 00:00:00	32020		\N	96696	0	370247008	4156265		0
24451	1459	40481087	2000-05-27	2000-05-27 00:00:00	2000-06-10	2000-06-10 00:00:00	32020		\N	97181	0	444814009	40481087		0
24596	1467	4112343	1953-04-03	1953-04-03 00:00:00	1953-04-13	1953-04-13 00:00:00	32020		\N	97714	0	195662009	4112343		0
24846	1482	80180	2017-08-24	2017-08-24 00:00:00	\N	\N	32020		\N	98827	0	396275006	80180		0
24989	1491	40481087	1995-02-04	1995-02-04 00:00:00	1995-02-11	1995-02-11 00:00:00	32020		\N	99413	0	444814009	40481087		0
25116	1497	80180	1974-07-25	1974-07-25 00:00:00	\N	\N	32020		\N	99827	0	396275006	80180		0
25273	1508	4112343	1974-07-09	1974-07-09 00:00:00	1974-07-18	1974-07-18 00:00:00	32020		\N	100652	0	195662009	4112343		0
25513	1518	260139	2010-04-29	2010-04-29 00:00:00	2010-05-06	2010-05-06 00:00:00	32020		\N	101532	0	10509002	260139		0
25674	1525	40481087	2013-02-16	2013-02-16 00:00:00	2013-03-09	2013-03-09 00:00:00	32020		\N	102011	0	444814009	40481087		0
25861	1536	40481087	1958-01-06	1958-01-06 00:00:00	1958-01-27	1958-01-27 00:00:00	32020		\N	102817	0	444814009	40481087		0
25993	1541	4112343	2006-10-29	2006-10-29 00:00:00	2006-11-05	2006-11-05 00:00:00	32020		\N	103289	0	195662009	4112343		0
26138	1551	40481087	1989-04-14	1989-04-14 00:00:00	1989-04-28	1989-04-28 00:00:00	32020		\N	103849	0	444814009	40481087		0
26331	1563	260139	1998-02-03	1998-02-03 00:00:00	1998-02-10	1998-02-10 00:00:00	32020		\N	104715	0	10509002	260139		0
26422	1567	4112343	2017-01-15	2017-01-15 00:00:00	2017-01-27	2017-01-27 00:00:00	32020		\N	105135	0	195662009	4112343		0
26631	1577	196456	1997-01-31	1997-01-31 00:00:00	1997-01-31	1997-01-31 00:00:00	32020		\N	105932	0	235919008	196456		0
26820	1588	195588	2011-11-22	2011-11-22 00:00:00	2011-12-23	2011-12-23 00:00:00	32020		\N	106578	0	38822007	195588		0
26923	1593	4266809	1975-08-17	1975-08-17 00:00:00	\N	\N	32020		\N	106851	0	397881000	4266809		0
27110	1604	4027663	1981-10-22	1981-10-22 00:00:00	\N	\N	32020		\N	107642	0	13200003	4027663		0
27329	1611	40481087	1999-07-03	1999-07-03 00:00:00	1999-07-17	1999-07-17 00:00:00	32020		\N	108277	0	444814009	40481087		0
27541	1626	40481087	1976-03-18	1976-03-18 00:00:00	1976-04-01	1976-04-01 00:00:00	32020		\N	109204	0	444814009	40481087		0
27654	1632	372328	1954-03-08	1954-03-08 00:00:00	1954-06-28	1954-06-28 00:00:00	32020		\N	109625	0	65363002	372328		0
27876	1646	372328	1956-12-06	1956-12-06 00:00:00	1957-04-20	1957-04-20 00:00:00	32020		\N	110376	0	65363002	372328		0
38527	2289	80180	1985-10-08	1985-10-08 00:00:00	\N	\N	32020		\N	152285	0	396275006	80180		0
28119	1659	80180	2006-08-25	2006-08-25 00:00:00	\N	\N	32020		\N	111542	0	396275006	80180		0
28313	1672	78272	1957-03-09	1957-03-09 00:00:00	1957-03-30	1957-03-30 00:00:00	32020		\N	112278	0	70704007	78272		0
28528	1689	40481087	1973-02-19	1973-02-19 00:00:00	1973-03-12	1973-03-12 00:00:00	32020		\N	113095	0	444814009	40481087		0
28576	1691	4112343	2000-01-17	2000-01-17 00:00:00	2000-01-27	2000-01-27 00:00:00	32020		\N	113289	0	195662009	4112343		0
28829	1707	40481087	1998-08-23	1998-08-23 00:00:00	1998-09-06	1998-09-06 00:00:00	32020		\N	114133	0	444814009	40481087		0
28942	1715	260139	1970-06-20	1970-06-20 00:00:00	1970-06-27	1970-06-27 00:00:00	32020		\N	114562	0	10509002	260139		0
29122	1724	4112343	1953-01-10	1953-01-10 00:00:00	1953-01-18	1953-01-18 00:00:00	32020		\N	115240	0	195662009	4112343		0
29308	1736	40481087	2007-01-12	2007-01-12 00:00:00	2007-02-02	2007-02-02 00:00:00	32020		\N	115903	0	444814009	40481087		0
29444	1744	4112343	1996-06-27	1996-06-27 00:00:00	1996-07-07	1996-07-07 00:00:00	32020		\N	116614	0	195662009	4112343		0
29610	1752	372328	1982-06-20	1982-06-20 00:00:00	1982-12-05	1982-12-05 00:00:00	32020		\N	117113	0	65363002	372328		0
29752	1761	28060	1958-02-25	1958-02-25 00:00:00	1958-03-04	1958-03-04 00:00:00	32020		\N	117703	0	43878008	28060		0
29990	1776	40481087	1964-01-22	1964-01-22 00:00:00	1964-02-12	1964-02-12 00:00:00	32020		\N	118773	0	444814009	40481087		0
30174	1782	4116491	1979-11-19	1979-11-19 00:00:00	1979-12-21	1979-12-21 00:00:00	32020		\N	119308	0	301011002	4116491		0
30295	1789	4112343	2015-05-23	2015-05-23 00:00:00	2015-05-31	2015-05-31 00:00:00	32020		\N	119931	0	195662009	4112343		0
41024	2439	80180	2014-08-25	2014-08-25 00:00:00	\N	\N	32020		\N	161800	0	396275006	80180		0
30632	1809	4112343	1996-05-21	1996-05-21 00:00:00	1996-05-30	1996-05-30 00:00:00	32020		\N	121100	0	195662009	4112343		0
30806	1821	40481087	2000-09-01	2000-09-01 00:00:00	2000-09-22	2000-09-22 00:00:00	32020		\N	121818	0	444814009	40481087		0
30959	1834	40481087	1997-02-09	1997-02-09 00:00:00	1997-02-16	1997-02-16 00:00:00	32020		\N	122514	0	444814009	40481087		0
31138	1844	28060	1979-10-27	1979-10-27 00:00:00	1979-11-06	1979-11-06 00:00:00	32020		\N	123155	0	43878008	28060		0
31286	1850	40481087	1974-09-13	1974-09-13 00:00:00	1974-10-04	1974-10-04 00:00:00	32020		\N	123753	0	444814009	40481087		0
31482	1860	4310024	1994-06-15	1994-06-15 00:00:00	\N	\N	32020		\N	124371	0	424802006	4310024		0
31561	1867	28060	1972-11-20	1972-11-20 00:00:00	1972-12-03	1972-12-03 00:00:00	32020		\N	124695	0	43878008	28060		0
31866	1892	4113008	1968-02-24	1968-02-24 00:00:00	1968-03-16	1968-03-16 00:00:00	32020		\N	126045	0	284549007	4113008		0
21344	1281	40481087	1981-10-04	1981-10-04 00:00:00	1981-10-18	1981-10-18 00:00:00	32020		\N	84640	0	444814009	40481087		0
21568	1293	317576	2010-02-23	2010-02-23 00:00:00	\N	\N	32020		\N	85562	0	53741008	317576		0
21724	1305	440086	1976-07-06	1976-07-06 00:00:00	1976-08-10	1976-08-10 00:00:00	32020		\N	86138	0	192127007	440086		0
21897	1314	40481087	1940-02-28	1940-02-28 00:00:00	1940-03-06	1940-03-06 00:00:00	32020		\N	87021	0	444814009	40481087		0
21953	1316	40481087	1972-11-20	1972-11-20 00:00:00	1972-12-11	1972-12-11 00:00:00	32020		\N	87138	0	444814009	40481087		0
22213	1325	4112343	1987-10-02	1987-10-02 00:00:00	1987-10-10	1987-10-10 00:00:00	32020		\N	87987	0	195662009	4112343		0
22316	1332	40481087	1965-05-14	1965-05-14 00:00:00	1965-06-04	1965-06-04 00:00:00	32020		\N	88320	0	444814009	40481087		0
22481	1340	40480160	2014-04-29	2014-04-29 00:00:00	2014-05-29	2014-05-29 00:00:00	32020		\N	88841	0	443165006	40480160		0
22660	1353	372328	1960-06-01	1960-06-01 00:00:00	1961-02-13	1961-02-13 00:00:00	32020		\N	89672	0	65363002	372328		0
22836	1361	40481087	2016-07-17	2016-07-17 00:00:00	2016-08-07	2016-08-07 00:00:00	32020		\N	90336	0	444814009	40481087		0
22932	1368	378001	1994-06-03	1994-06-03 00:00:00	1994-08-02	1994-08-02 00:00:00	32020		\N	90748	0	62106007	378001		0
23111	1379	260139	2001-02-03	2001-02-03 00:00:00	2001-02-17	2001-02-17 00:00:00	32020		\N	91459	0	10509002	260139		0
23312	1390	40481087	1974-12-21	1974-12-21 00:00:00	1975-01-11	1975-01-11 00:00:00	32020		\N	92254	0	444814009	40481087		0
23481	1401	372328	1978-01-02	1978-01-02 00:00:00	1979-01-14	1979-01-14 00:00:00	32020		\N	93189	0	65363002	372328		0
23652	1411	372328	1968-07-30	1968-07-30 00:00:00	1968-11-05	1968-11-05 00:00:00	32020		\N	93932	0	65363002	372328		0
23883	1427	4112343	1957-11-29	1957-11-29 00:00:00	1957-12-09	1957-12-09 00:00:00	32020		\N	94951	0	195662009	4112343		0
23951	1430	4027663	1974-11-15	1974-11-15 00:00:00	\N	\N	32020		\N	95138	0	13200003	4027663		0
24225	1443	40481087	2007-07-11	2007-07-11 00:00:00	2007-07-18	2007-07-18 00:00:00	32020		\N	96224	0	444814009	40481087		0
24351	1450	40481087	1969-06-16	1969-06-16 00:00:00	1969-06-30	1969-06-30 00:00:00	32020		\N	96718	0	444814009	40481087		0
24452	1459	40481087	1963-03-18	1963-03-18 00:00:00	1963-03-25	1963-03-25 00:00:00	32020		\N	97261	0	444814009	40481087		0
24597	1467	40481087	1983-10-11	1983-10-11 00:00:00	1983-10-25	1983-10-25 00:00:00	32020		\N	97671	0	444814009	40481087		0
24847	1482	378001	1982-03-11	1982-03-11 00:00:00	1982-04-10	1982-04-10 00:00:00	32020		\N	98906	0	62106007	378001		0
24990	1491	378001	1988-02-24	1988-02-24 00:00:00	1988-04-24	1988-04-24 00:00:00	32020		\N	99452	0	62106007	378001		0
25117	1497	4294548	1970-07-19	1970-07-19 00:00:00	1970-09-13	1970-09-13 00:00:00	32020		\N	99819	0	75498004	4294548		0
25274	1508	257012	2004-05-31	2004-05-31 00:00:00	\N	\N	32020		\N	100621	0	40055000	257012		0
25514	1518	78272	1959-02-23	1959-02-23 00:00:00	1959-03-09	1959-03-09 00:00:00	32020		\N	101484	0	70704007	78272		0
25675	1525	192671	1998-12-22	1998-12-22 00:00:00	\N	\N	32020		\N	102033	0	K92.2	35208414		0
25862	1536	4278672	1926-11-10	1926-11-10 00:00:00	1927-01-09	1927-01-09 00:00:00	32020		\N	102788	0	65966004	4278672		0
25994	1541	260139	1996-01-08	1996-01-08 00:00:00	1996-01-22	1996-01-22 00:00:00	32020		\N	103248	0	10509002	260139		0
26139	1551	40481087	1961-09-14	1961-09-14 00:00:00	1961-09-28	1961-09-28 00:00:00	32020		\N	103852	0	444814009	40481087		0
26332	1563	4152936	1975-10-12	1975-10-12 00:00:00	1975-10-26	1975-10-26 00:00:00	32020		\N	104745	0	283385000	4152936		0
26423	1567	28060	1980-07-29	1980-07-29 00:00:00	1980-08-08	1980-08-08 00:00:00	32020		\N	105109	0	43878008	28060		0
26632	1577	198809	1997-01-31	1997-01-31 00:00:00	1997-01-31	1997-01-31 00:00:00	32020		\N	105932	0	65275009	198809		0
26822	1588	4112343	1999-06-08	1999-06-08 00:00:00	1999-06-19	1999-06-19 00:00:00	32020		\N	106628	0	195662009	4112343		0
26924	1593	80180	1975-08-17	1975-08-17 00:00:00	\N	\N	32020		\N	106851	0	396275006	80180		0
27111	1604	4218389	1959-09-28	1959-09-28 00:00:00	1959-10-26	1959-10-26 00:00:00	32020		\N	107604	0	39848009	4218389		0
27330	1611	260139	1977-06-21	1977-06-21 00:00:00	1977-07-05	1977-07-05 00:00:00	32020		\N	108317	0	10509002	260139		0
27542	1626	4218389	1977-07-22	1977-07-22 00:00:00	1977-08-19	1977-08-19 00:00:00	32020		\N	109188	0	39848009	4218389		0
27655	1632	4112343	2011-09-24	2011-09-24 00:00:00	2011-10-07	2011-10-07 00:00:00	32020		\N	109573	0	195662009	4112343		0
27877	1646	4112343	1967-05-31	1967-05-31 00:00:00	1967-06-07	1967-06-07 00:00:00	32020		\N	110370	0	195662009	4112343		0
38528	2289	4112343	1972-07-01	1972-07-01 00:00:00	1972-07-09	1972-07-09 00:00:00	32020		\N	152283	0	195662009	4112343		0
28120	1659	4155034	1983-05-03	1983-05-03 00:00:00	1983-05-17	1983-05-17 00:00:00	32020		\N	111457	0	283371005	4155034		0
28328	1674	260139	1997-05-07	1997-05-07 00:00:00	1997-05-21	1997-05-21 00:00:00	32020		\N	112344	0	10509002	260139		0
28529	1689	80180	1984-05-06	1984-05-06 00:00:00	\N	\N	32020		\N	113101	0	396275006	80180		0
28577	1691	4112343	1972-05-16	1972-05-16 00:00:00	1972-05-24	1972-05-24 00:00:00	32020		\N	113260	0	195662009	4112343		0
28830	1707	4112343	1988-01-12	1988-01-12 00:00:00	1988-01-21	1988-01-21 00:00:00	32020		\N	114141	0	195662009	4112343		0
28943	1715	372328	1972-09-20	1972-09-20 00:00:00	1973-03-17	1973-03-17 00:00:00	32020		\N	114570	0	65363002	372328		0
29123	1724	28060	2013-04-29	2013-04-29 00:00:00	2013-05-08	2013-05-08 00:00:00	32020		\N	115281	0	43878008	28060		0
29309	1736	195588	1990-11-03	1990-11-03 00:00:00	1990-12-10	1990-12-10 00:00:00	32020		\N	115889	0	38822007	195588		0
29445	1744	4112343	2006-11-13	2006-11-13 00:00:00	2006-11-22	2006-11-22 00:00:00	32020		\N	116619	0	195662009	4112343		0
29611	1752	80180	2016-03-10	2016-03-10 00:00:00	\N	\N	32020		\N	117141	0	396275006	80180		0
29753	1761	4112343	1994-08-29	1994-08-29 00:00:00	1994-09-08	1994-09-08 00:00:00	32020		\N	117790	0	195662009	4112343		0
29991	1776	80180	1954-06-11	1954-06-11 00:00:00	\N	\N	32020		\N	118854	0	396275006	80180		0
30175	1782	40481087	1959-06-30	1959-06-30 00:00:00	1959-07-14	1959-07-14 00:00:00	32020		\N	119360	0	444814009	40481087		0
30296	1789	4310024	2015-07-17	2015-07-17 00:00:00	\N	\N	32020		\N	119920	0	424802006	4310024		0
41025	2439	4112343	2014-04-24	2014-04-24 00:00:00	2014-05-03	2014-05-03 00:00:00	32020		\N	161800	0	195662009	4112343		0
30633	1809	4112343	1969-05-21	1969-05-21 00:00:00	1969-05-30	1969-05-30 00:00:00	32020		\N	121090	0	195662009	4112343		0
30807	1821	4112343	1964-07-30	1964-07-30 00:00:00	1964-08-09	1964-08-09 00:00:00	32020		\N	121769	0	195662009	4112343		0
30960	1834	40481087	1946-04-09	1946-04-09 00:00:00	1946-04-16	1946-04-16 00:00:00	32020		\N	122532	0	444814009	40481087		0
31139	1844	375671	1972-08-26	1972-08-26 00:00:00	1972-10-25	1972-10-25 00:00:00	32020		\N	123216	0	62564004	375671		0
31287	1850	260139	2006-11-29	2006-11-29 00:00:00	2006-12-13	2006-12-13 00:00:00	32020		\N	123779	0	10509002	260139		0
31483	1861	4156265	1986-10-24	1986-10-24 00:00:00	1986-11-07	1986-11-07 00:00:00	32020		\N	124410	0	370247008	4156265		0
31562	1867	4059173	1990-08-17	1990-08-17 00:00:00	1990-10-16	1990-10-16 00:00:00	32020		\N	124729	0	16114001	4059173		0
31867	1892	40481087	1978-10-13	1978-10-13 00:00:00	1978-11-03	1978-11-03 00:00:00	32020		\N	126025	0	444814009	40481087		0
21345	1281	40481087	1999-01-13	1999-01-13 00:00:00	1999-02-03	1999-02-03 00:00:00	32020		\N	84697	0	444814009	40481087		0
21569	1293	260139	2014-10-24	2014-10-24 00:00:00	2014-10-31	2014-10-31 00:00:00	32020		\N	85462	0	10509002	260139		0
21725	1305	260139	1976-05-02	1976-05-02 00:00:00	1976-05-16	1976-05-16 00:00:00	32020		\N	86110	0	10509002	260139		0
21898	1314	4283893	1996-06-22	1996-06-22 00:00:00	1996-10-12	1996-10-12 00:00:00	32020		\N	86972	0	36971009	4283893		0
21954	1316	260139	1976-09-26	1976-09-26 00:00:00	1976-10-03	1976-10-03 00:00:00	32020		\N	87179	0	10509002	260139		0
22214	1325	40481087	2002-02-14	2002-02-14 00:00:00	2002-02-28	2002-02-28 00:00:00	32020		\N	87986	0	444814009	40481087		0
22317	1332	40481087	2002-08-09	2002-08-09 00:00:00	2002-08-16	2002-08-16 00:00:00	32020		\N	88348	0	444814009	40481087		0
22482	1340	4278672	2014-04-29	2014-04-29 00:00:00	2014-05-29	2014-05-29 00:00:00	32020		\N	88841	0	65966004	4278672		0
22661	1353	257012	1961-11-17	1961-11-17 00:00:00	\N	\N	32020		\N	89659	0	40055000	257012		0
22837	1361	81151	1974-07-02	1974-07-02 00:00:00	1974-07-30	1974-07-30 00:00:00	32020		\N	90290	0	44465007	81151		0
22933	1368	378001	1967-02-06	1967-02-06 00:00:00	1967-03-08	1967-03-08 00:00:00	32020		\N	90717	0	62106007	378001		0
23112	1379	4237458	1970-07-25	1970-07-25 00:00:00	1970-08-24	1970-08-24 00:00:00	32020		\N	91512	0	58150001	4237458		0
23313	1390	4112343	1972-07-27	1972-07-27 00:00:00	1972-08-05	1972-08-05 00:00:00	32020		\N	92253	0	195662009	4112343		0
23482	1401	40481087	1985-05-24	1985-05-24 00:00:00	1985-05-31	1985-05-31 00:00:00	32020		\N	93135	0	444814009	40481087		0
23653	1411	4294548	2000-05-26	2000-05-26 00:00:00	2000-07-28	2000-07-28 00:00:00	32020		\N	93953	0	75498004	4294548		0
23884	1427	81151	1973-06-07	1973-06-07 00:00:00	1973-06-28	1973-06-28 00:00:00	32020		\N	94959	0	44465007	81151		0
23952	1430	4283893	1991-08-12	1991-08-12 00:00:00	1991-09-30	1991-09-30 00:00:00	32020		\N	95130	0	36971009	4283893		0
24226	1443	40481087	1997-11-08	1997-11-08 00:00:00	1997-11-29	1997-11-29 00:00:00	32020		\N	96223	0	444814009	40481087		0
24352	1450	260139	1999-11-03	1999-11-03 00:00:00	1999-11-17	1999-11-17 00:00:00	32020		\N	96740	0	10509002	260139		0
24453	1459	40481087	1972-01-12	1972-01-12 00:00:00	1972-01-19	1972-01-19 00:00:00	32020		\N	97179	0	444814009	40481087		0
24598	1467	4112343	1957-11-20	1957-11-20 00:00:00	1957-12-02	1957-12-02 00:00:00	32020		\N	97745	0	195662009	4112343		0
24848	1482	4027663	2006-10-11	2006-10-11 00:00:00	\N	\N	32020		\N	\N	0	13200003	4027663		0
24991	1491	4283893	2005-09-24	2005-09-24 00:00:00	2005-10-15	2005-10-15 00:00:00	32020		\N	99422	0	36971009	4283893		0
25118	1497	260139	1992-03-11	1992-03-11 00:00:00	1992-03-18	1992-03-18 00:00:00	32020		\N	99800	0	10509002	260139		0
25275	1508	4112343	1972-07-08	1972-07-08 00:00:00	1972-07-18	1972-07-18 00:00:00	32020		\N	100572	0	195662009	4112343		0
25515	1518	28060	1981-08-20	1981-08-20 00:00:00	1981-08-31	1981-08-31 00:00:00	32020		\N	101494	0	43878008	28060		0
25676	1525	4283893	1989-08-17	1989-08-17 00:00:00	1989-09-14	1989-09-14 00:00:00	32020		\N	101965	0	36971009	4283893		0
25863	1536	375671	1920-02-15	1920-02-15 00:00:00	1920-03-16	1920-03-16 00:00:00	32020		\N	102787	0	62564004	375671		0
25995	1541	4112343	1989-04-22	1989-04-22 00:00:00	1989-05-02	1989-05-02 00:00:00	32020		\N	103242	0	195662009	4112343		0
26140	1551	40481087	1982-10-25	1982-10-25 00:00:00	1982-11-15	1982-11-15 00:00:00	32020		\N	103856	0	444814009	40481087		0
26333	1563	317009	1977-06-25	1977-06-25 00:00:00	\N	\N	32020		\N	104703	0	195967001	317009		0
26424	1567	260139	2018-05-12	2018-05-12 00:00:00	2018-05-26	2018-05-26 00:00:00	32020		\N	105136	0	10509002	260139		0
26633	1577	40480160	2017-01-20	2017-01-20 00:00:00	2017-04-20	2017-04-20 00:00:00	32020		\N	105934	0	443165006	40480160		0
26823	1588	260139	2010-09-03	2010-09-03 00:00:00	2010-09-10	2010-09-10 00:00:00	32020		\N	106613	0	10509002	260139		0
26925	1593	40481087	1975-02-24	1975-02-24 00:00:00	1975-03-10	1975-03-10 00:00:00	32020		\N	106851	0	444814009	40481087		0
27112	1604	260139	1997-02-27	1997-02-27 00:00:00	1997-03-13	1997-03-13 00:00:00	32020		\N	107608	0	10509002	260139		0
27332	1611	40481087	1952-08-12	1952-08-12 00:00:00	1952-09-02	1952-09-02 00:00:00	32020		\N	108348	0	444814009	40481087		0
27543	1626	28060	1958-09-15	1958-09-15 00:00:00	1958-09-26	1958-09-26 00:00:00	32020		\N	109203	0	43878008	28060		0
27656	1632	40481087	1956-01-06	1956-01-06 00:00:00	1956-01-20	1956-01-20 00:00:00	32020		\N	109607	0	444814009	40481087		0
27878	1646	260139	1941-05-30	1941-05-30 00:00:00	1941-06-13	1941-06-13 00:00:00	32020		\N	110379	0	10509002	260139		0
38529	2289	4294548	1952-12-15	1952-12-15 00:00:00	1953-03-02	1953-03-02 00:00:00	32020		\N	152258	0	75498004	4294548		0
28121	1659	260139	1971-06-07	1971-06-07 00:00:00	1971-06-14	1971-06-14 00:00:00	32020		\N	111453	0	10509002	260139		0
28329	1674	4112343	2003-04-10	2003-04-10 00:00:00	2003-04-20	2003-04-20 00:00:00	32020		\N	112378	0	195662009	4112343		0
28530	1689	4112343	1984-02-12	1984-02-12 00:00:00	1984-02-24	1984-02-24 00:00:00	32020		\N	113107	0	195662009	4112343		0
28578	1691	81893	1983-12-01	1983-12-01 00:00:00	\N	\N	32020		\N	113246	0	64766004	81893		0
28831	1707	4112343	1988-11-18	1988-11-18 00:00:00	1988-11-29	1988-11-29 00:00:00	32020		\N	114148	0	195662009	4112343		0
28944	1715	40481087	2008-09-26	2008-09-26 00:00:00	2008-10-17	2008-10-17 00:00:00	32020		\N	114560	0	444814009	40481087		0
29124	1724	78272	1954-06-18	1954-06-18 00:00:00	1954-07-16	1954-07-16 00:00:00	32020		\N	115262	0	70704007	78272		0
29310	1737	260139	1993-03-21	1993-03-21 00:00:00	1993-04-04	1993-04-04 00:00:00	32020		\N	116099	0	10509002	260139		0
29446	1744	4112343	2016-12-03	2016-12-03 00:00:00	2016-12-16	2016-12-16 00:00:00	32020		\N	116640	0	195662009	4112343		0
29612	1752	40481087	2013-09-14	2013-09-14 00:00:00	2013-09-28	2013-09-28 00:00:00	32020		\N	117112	0	444814009	40481087		0
29754	1761	80180	1995-03-02	1995-03-02 00:00:00	\N	\N	32020		\N	117790	0	396275006	80180		0
29992	1776	40481087	1991-12-07	1991-12-07 00:00:00	1991-12-14	1991-12-14 00:00:00	32020		\N	118787	0	444814009	40481087		0
30176	1782	40481087	1963-03-01	1963-03-01 00:00:00	1963-03-08	1963-03-08 00:00:00	32020		\N	119373	0	444814009	40481087		0
30297	1789	260139	2018-06-13	2018-06-13 00:00:00	2018-06-27	2018-06-27 00:00:00	32020		\N	119878	0	10509002	260139		0
41026	2439	4112343	1976-05-29	1976-05-29 00:00:00	1976-06-11	1976-06-11 00:00:00	32020		\N	161798	0	195662009	4112343		0
30634	1809	40481087	2009-11-16	2009-11-16 00:00:00	2009-12-07	2009-12-07 00:00:00	32020		\N	121092	0	444814009	40481087		0
30808	1821	4112343	1983-02-12	1983-02-12 00:00:00	1983-02-20	1983-02-20 00:00:00	32020		\N	121814	0	195662009	4112343		0
30961	1834	260139	1955-05-18	1955-05-18 00:00:00	1955-06-01	1955-06-01 00:00:00	32020		\N	122534	0	10509002	260139		0
31140	1844	4296204	1976-06-06	1976-06-06 00:00:00	1976-06-20	1976-06-20 00:00:00	32020		\N	123217	0	403190006	4296204		0
31288	1850	4112343	2005-05-01	2005-05-01 00:00:00	2005-05-10	2005-05-10 00:00:00	32020		\N	123768	0	195662009	4112343		0
31484	1861	4113008	1983-10-19	1983-10-19 00:00:00	1983-11-09	1983-11-09 00:00:00	32020		\N	124409	0	284549007	4113008		0
31563	1867	372328	1981-07-30	1981-07-30 00:00:00	1982-03-30	1982-03-30 00:00:00	32020		\N	124707	0	65363002	372328		0
42331	2521	4112343	1953-01-10	1953-01-10 00:00:00	1953-01-17	1953-01-17 00:00:00	32020		\N	166757	0	195662009	4112343		0
21346	1281	440086	1981-12-31	1981-12-31 00:00:00	1988-01-09	1988-01-09 00:00:00	32020		\N	84694	0	192127007	440086		0
21570	1293	4112343	1991-07-26	1991-07-26 00:00:00	1991-08-07	1991-08-07 00:00:00	32020		\N	85579	0	195662009	4112343		0
21726	1305	40481087	1973-01-02	1973-01-02 00:00:00	1973-01-16	1973-01-16 00:00:00	32020		\N	86125	0	444814009	40481087		0
21899	1314	4112343	1941-05-25	1941-05-25 00:00:00	1941-06-03	1941-06-03 00:00:00	32020		\N	86981	0	195662009	4112343		0
21955	1316	4112343	2009-12-10	2009-12-10 00:00:00	2009-12-17	2009-12-17 00:00:00	32020		\N	87182	0	195662009	4112343		0
22215	1325	40481087	1987-11-09	1987-11-09 00:00:00	1987-11-23	1987-11-23 00:00:00	32020		\N	87988	0	444814009	40481087		0
22318	1332	4294548	1947-01-01	1947-01-01 00:00:00	1947-01-08	1947-01-08 00:00:00	32020		\N	88302	0	75498004	4294548		0
22483	1340	4116491	1948-07-20	1948-07-20 00:00:00	1948-08-24	1948-08-24 00:00:00	32020		\N	88940	0	301011002	4116491		0
22662	1353	4112343	2011-03-27	2011-03-27 00:00:00	2011-04-09	2011-04-09 00:00:00	32020		\N	89663	0	195662009	4112343		0
22838	1361	4112343	1951-11-01	1951-11-01 00:00:00	1951-11-13	1951-11-13 00:00:00	32020		\N	90369	0	195662009	4112343		0
22934	1368	40481087	2007-01-01	2007-01-01 00:00:00	2007-01-08	2007-01-08 00:00:00	32020		\N	90720	0	444814009	40481087		0
23113	1379	40481087	1991-10-12	1991-10-12 00:00:00	1991-10-19	1991-10-19 00:00:00	32020		\N	91457	0	444814009	40481087		0
23314	1390	81151	1980-03-07	1980-03-07 00:00:00	1980-04-04	1980-04-04 00:00:00	32020		\N	92248	0	44465007	81151		0
23483	1401	40481087	2003-02-21	2003-02-21 00:00:00	2003-02-28	2003-02-28 00:00:00	32020		\N	93156	0	444814009	40481087		0
23654	1411	30753	2001-11-16	2001-11-16 00:00:00	\N	\N	32020		\N	93953	0	16761005	30753		0
23885	1427	260139	2011-07-20	2011-07-20 00:00:00	2011-07-27	2011-07-27 00:00:00	32020		\N	94932	0	10509002	260139		0
23953	1430	40481087	1955-12-17	1955-12-17 00:00:00	1955-12-31	1955-12-31 00:00:00	32020		\N	95153	0	444814009	40481087		0
24227	1443	4294548	1989-06-06	1989-06-06 00:00:00	1989-08-15	1989-08-15 00:00:00	32020		\N	96222	0	75498004	4294548		0
24353	1450	40481087	2017-07-19	2017-07-19 00:00:00	2017-08-02	2017-08-02 00:00:00	32020		\N	96681	0	444814009	40481087		0
24454	1459	81151	2006-10-26	2006-10-26 00:00:00	2006-11-16	2006-11-16 00:00:00	32020		\N	97249	0	44465007	81151		0
24599	1468	4112343	2004-06-02	2004-06-02 00:00:00	2004-06-13	2004-06-13 00:00:00	32020		\N	97812	0	195662009	4112343		0
24849	1482	372328	1976-10-19	1976-10-19 00:00:00	1977-03-26	1977-03-26 00:00:00	32020		\N	98845	0	65363002	372328		0
24992	1491	40481087	1982-01-05	1982-01-05 00:00:00	1982-01-12	1982-01-12 00:00:00	32020		\N	99411	0	444814009	40481087		0
25119	1497	257012	1972-05-18	1972-05-18 00:00:00	\N	\N	32020		\N	99861	0	40055000	257012		0
25276	1508	4112343	1949-10-13	1949-10-13 00:00:00	1949-10-24	1949-10-24 00:00:00	32020		\N	100648	0	195662009	4112343		0
25516	1518	28060	1955-07-03	1955-07-03 00:00:00	1955-07-11	1955-07-11 00:00:00	32020		\N	101537	0	43878008	28060		0
25677	1525	4112343	2009-01-07	2009-01-07 00:00:00	2009-01-17	2009-01-17 00:00:00	32020		\N	102023	0	195662009	4112343		0
25864	1536	40481087	1967-02-14	1967-02-14 00:00:00	1967-02-21	1967-02-21 00:00:00	32020		\N	102797	0	444814009	40481087		0
25996	1541	372328	1963-09-26	1963-09-26 00:00:00	1964-01-06	1964-01-06 00:00:00	32020		\N	103290	0	65363002	372328		0
26141	1551	40481087	2009-05-30	2009-05-30 00:00:00	2009-06-06	2009-06-06 00:00:00	32020		\N	103835	0	444814009	40481087		0
26334	1563	4112343	1983-06-28	1983-06-28 00:00:00	1983-07-05	1983-07-05 00:00:00	32020		\N	104706	0	195662009	4112343		0
26425	1567	40481087	2010-06-15	2010-06-15 00:00:00	2010-06-22	2010-06-22 00:00:00	32020		\N	105133	0	444814009	40481087		0
26634	1577	4230399	2017-01-20	2017-01-20 00:00:00	2017-04-20	2017-04-20 00:00:00	32020		\N	105934	0	359817006	4230399		0
26824	1588	40481087	1970-10-14	1970-10-14 00:00:00	1970-10-21	1970-10-21 00:00:00	32020		\N	106640	0	444814009	40481087		0
26926	1593	4285898	1975-04-19	1975-04-19 00:00:00	\N	\N	32020		\N	106851	0	68496003	4285898		0
27113	1604	4237458	2018-12-27	2018-12-27 00:00:00	2019-01-26	2019-01-26 00:00:00	32020		\N	107607	0	58150001	4237458		0
27333	1611	40481087	2011-10-15	2011-10-15 00:00:00	2011-11-05	2011-11-05 00:00:00	32020		\N	108328	0	444814009	40481087		0
27544	1626	40481087	1936-04-02	1936-04-02 00:00:00	1936-04-09	1936-04-09 00:00:00	32020		\N	109258	0	444814009	40481087		0
27657	1632	4112343	1996-10-16	1996-10-16 00:00:00	1996-10-27	1996-10-27 00:00:00	32020		\N	109623	0	195662009	4112343		0
27879	1646	4027663	1969-11-23	1969-11-23 00:00:00	\N	\N	32020		\N	110368	0	13200003	4027663		0
38530	2289	260139	1977-04-29	1977-04-29 00:00:00	1977-05-06	1977-05-06 00:00:00	32020		\N	152267	0	10509002	260139		0
28122	1659	40481087	1972-06-06	1972-06-06 00:00:00	1972-06-13	1972-06-13 00:00:00	32020		\N	111568	0	444814009	40481087		0
28330	1674	40481087	1986-02-24	1986-02-24 00:00:00	1986-03-10	1986-03-10 00:00:00	32020		\N	112343	0	444814009	40481087		0
28531	1689	378419	2019-01-10	2019-01-10 00:00:00	\N	\N	32020		\N	113098	0	26929004	378419		0
28579	1691	192671	1985-10-20	1985-10-20 00:00:00	\N	\N	32020		\N	113251	0	K92.2	35208414		0
28832	1707	40481087	1997-07-30	1997-07-30 00:00:00	1997-08-20	1997-08-20 00:00:00	32020		\N	114149	0	444814009	40481087		0
28945	1715	134438	1988-11-24	1988-11-24 00:00:00	1989-12-19	1989-12-19 00:00:00	32020		\N	114563	0	40275004	134438		0
29125	1724	4155034	2019-02-01	2019-02-01 00:00:00	2019-02-22	2019-02-22 00:00:00	32020		\N	115303	0	283371005	4155034		0
29311	1737	4112343	1973-06-21	1973-06-21 00:00:00	1973-06-29	1973-06-29 00:00:00	32020		\N	116012	0	195662009	4112343		0
29447	1744	4109685	2007-07-04	2007-07-04 00:00:00	2007-07-18	2007-07-18 00:00:00	32020		\N	116628	0	284551006	4109685		0
29613	1752	378001	1992-01-11	1992-01-11 00:00:00	1992-02-10	1992-02-10 00:00:00	32020		\N	117131	0	62106007	378001		0
29755	1761	378001	1993-03-11	1993-03-11 00:00:00	1993-04-11	1993-04-11 00:00:00	32020		\N	117720	0	62106007	378001		0
29993	1776	4112343	1926-08-30	1926-08-30 00:00:00	1926-09-11	1926-09-11 00:00:00	32020		\N	118777	0	195662009	4112343		0
30177	1782	40481087	2002-12-07	2002-12-07 00:00:00	2002-12-28	2002-12-28 00:00:00	32020		\N	119324	0	444814009	40481087		0
30298	1789	133834	1975-10-02	1975-10-02 00:00:00	\N	\N	32020		\N	119859	0	24079001	133834		0
41027	2439	260139	2012-12-24	2012-12-24 00:00:00	2013-01-07	2013-01-07 00:00:00	32020		\N	161810	0	10509002	260139		0
30635	1809	4278672	1978-08-20	1978-08-20 00:00:00	1978-10-19	1978-10-19 00:00:00	32020		\N	121088	0	65966004	4278672		0
30809	1821	4112343	1954-09-30	1954-09-30 00:00:00	1954-10-08	1954-10-08 00:00:00	32020		\N	121851	0	195662009	4112343		0
30962	1834	40481087	1968-10-25	1968-10-25 00:00:00	1968-11-01	1968-11-01 00:00:00	32020		\N	122463	0	444814009	40481087		0
31141	1844	378001	2004-02-08	2004-02-08 00:00:00	2004-04-08	2004-04-08 00:00:00	32020		\N	123183	0	62106007	378001		0
31289	1850	81151	1959-01-24	1959-01-24 00:00:00	1959-02-07	1959-02-07 00:00:00	32020		\N	123731	0	44465007	81151		0
31485	1861	40481087	1993-08-30	1993-08-30 00:00:00	1993-09-20	1993-09-20 00:00:00	32020		\N	124453	0	444814009	40481087		0
31564	1867	40481087	2006-02-22	2006-02-22 00:00:00	2006-03-15	2006-03-15 00:00:00	32020		\N	124676	0	444814009	40481087		0
42332	2521	378001	1978-09-27	1978-09-27 00:00:00	1978-10-27	1978-10-27 00:00:00	32020		\N	166738	0	62106007	378001		0
21347	1281	40481087	1991-01-18	1991-01-18 00:00:00	1991-02-01	1991-02-01 00:00:00	32020		\N	84663	0	444814009	40481087		0
21571	1293	28060	1976-07-11	1976-07-11 00:00:00	1976-07-22	1976-07-22 00:00:00	32020		\N	85545	0	43878008	28060		0
21727	1305	40481087	2000-10-19	2000-10-19 00:00:00	2000-11-09	2000-11-09 00:00:00	32020		\N	86139	0	444814009	40481087		0
21900	1314	40481087	1953-09-22	1953-09-22 00:00:00	1953-10-13	1953-10-13 00:00:00	32020		\N	87018	0	444814009	40481087		0
21956	1316	40481087	1997-06-23	1997-06-23 00:00:00	1997-07-14	1997-07-14 00:00:00	32020		\N	87181	0	444814009	40481087		0
22216	1325	372328	2013-09-22	2013-09-22 00:00:00	2013-11-17	2013-11-17 00:00:00	32020		\N	87975	0	65363002	372328		0
22319	1332	78272	1950-12-22	1950-12-22 00:00:00	1951-01-05	1951-01-05 00:00:00	32020		\N	88316	0	70704007	78272		0
22484	1340	260139	1919-05-01	1919-05-01 00:00:00	1919-05-15	1919-05-15 00:00:00	32020		\N	88922	0	10509002	260139		0
22663	1354	40481087	1988-07-26	1988-07-26 00:00:00	1988-08-16	1988-08-16 00:00:00	32020		\N	89757	0	444814009	40481087		0
22839	1361	378001	1947-03-26	1947-03-26 00:00:00	1947-05-25	1947-05-25 00:00:00	32020		\N	90288	0	62106007	378001		0
22935	1368	40481087	1974-12-20	1974-12-20 00:00:00	1975-01-03	1975-01-03 00:00:00	32020		\N	90735	0	444814009	40481087		0
23114	1379	40481087	2002-09-30	2002-09-30 00:00:00	2002-10-14	2002-10-14 00:00:00	32020		\N	91461	0	444814009	40481087		0
23315	1391	28060	1936-02-09	1936-02-09 00:00:00	1936-02-18	1936-02-18 00:00:00	32020		\N	92313	0	43878008	28060		0
23529	1407	260139	1999-09-26	1999-09-26 00:00:00	1999-10-03	1999-10-03 00:00:00	32020		\N	93457	0	10509002	260139		0
23655	1411	4266809	2002-11-11	2002-11-11 00:00:00	\N	\N	32020		\N	93953	0	397881000	4266809		0
23886	1427	260139	1979-07-07	1979-07-07 00:00:00	1979-07-21	1979-07-21 00:00:00	32020		\N	94920	0	10509002	260139		0
23954	1430	40481087	1949-11-26	1949-11-26 00:00:00	1949-12-17	1949-12-17 00:00:00	32020		\N	95120	0	444814009	40481087		0
24228	1443	372328	1981-06-03	1981-06-03 00:00:00	1982-03-05	1982-03-05 00:00:00	32020		\N	96204	0	65363002	372328		0
24354	1450	4112343	2011-05-24	2011-05-24 00:00:00	2011-06-03	2011-06-03 00:00:00	32020		\N	96723	0	195662009	4112343		0
24455	1459	4283893	1946-07-27	1946-07-27 00:00:00	1946-12-07	1946-12-07 00:00:00	32020		\N	97231	0	36971009	4283893		0
24600	1468	4112343	1967-09-05	1967-09-05 00:00:00	1967-09-15	1967-09-15 00:00:00	32020		\N	97853	0	195662009	4112343		0
24850	1482	40481087	1985-09-26	1985-09-26 00:00:00	1985-10-03	1985-10-03 00:00:00	32020		\N	98887	0	444814009	40481087		0
24993	1491	440086	1975-11-04	1975-11-04 00:00:00	1986-11-11	1986-11-11 00:00:00	32020		\N	99402	0	192127007	440086		0
25120	1497	260139	1979-05-21	1979-05-21 00:00:00	1979-06-04	1979-06-04 00:00:00	32020		\N	99766	0	10509002	260139		0
25277	1508	4283893	2004-04-26	2004-04-26 00:00:00	2004-09-06	2004-09-06 00:00:00	32020		\N	100620	0	36971009	4283893		0
25517	1518	40481087	1975-09-16	1975-09-16 00:00:00	1975-09-30	1975-09-30 00:00:00	32020		\N	101492	0	444814009	40481087		0
25678	1526	4294548	2009-09-26	2009-09-26 00:00:00	2009-10-10	2009-10-10 00:00:00	32020		\N	102083	0	75498004	4294548		0
25865	1536	80502	1971-11-28	1971-11-28 00:00:00	\N	\N	32020		\N	102837	0	64859006	80502		0
25997	1542	80180	2005-07-02	2005-07-02 00:00:00	\N	\N	32020		\N	103317	0	396275006	80180		0
26142	1551	4112343	2005-07-01	2005-07-01 00:00:00	2005-07-11	2005-07-11 00:00:00	32020		\N	103869	0	195662009	4112343		0
26335	1563	81151	1976-08-21	1976-08-21 00:00:00	1976-09-18	1976-09-18 00:00:00	32020		\N	104746	0	44465007	81151		0
26426	1567	4084167	2002-09-05	2002-09-05 00:00:00	2002-09-06	2002-09-06 00:00:00	32020		\N	105107	0	241929008	4084167		0
26635	1577	378001	1996-08-17	1996-08-17 00:00:00	1996-09-16	1996-09-16 00:00:00	32020		\N	105931	0	62106007	378001		0
26825	1588	372328	1961-08-31	1961-08-31 00:00:00	1961-11-12	1961-11-12 00:00:00	32020		\N	106619	0	65363002	372328		0
26927	1593	40481087	1983-05-04	1983-05-04 00:00:00	1983-05-18	1983-05-18 00:00:00	32020		\N	106899	0	444814009	40481087		0
27114	1604	40481087	1999-06-04	1999-06-04 00:00:00	1999-06-11	1999-06-11 00:00:00	32020		\N	107589	0	444814009	40481087		0
27334	1611	381316	2017-04-09	2017-04-09 00:00:00	\N	\N	32020		\N	108330	0	230690007	381316		0
27545	1626	40481087	1982-05-02	1982-05-02 00:00:00	1982-05-23	1982-05-23 00:00:00	32020		\N	109262	0	444814009	40481087		0
27672	1634	378419	2013-08-23	2013-08-23 00:00:00	\N	\N	32020		\N	109696	0	26929004	378419		0
27880	1646	195588	1977-11-21	1977-11-21 00:00:00	1977-12-31	1977-12-31 00:00:00	32020		\N	110372	0	38822007	195588		0
38531	2289	372328	1953-06-13	1953-06-13 00:00:00	1953-09-08	1953-09-08 00:00:00	32020		\N	152220	0	65363002	372328		0
28123	1659	4283893	1974-12-19	1974-12-19 00:00:00	1975-06-05	1975-06-05 00:00:00	32020		\N	111549	0	36971009	4283893		0
28331	1674	4112343	2006-01-07	2006-01-07 00:00:00	2006-01-16	2006-01-16 00:00:00	32020		\N	112379	0	195662009	4112343		0
28532	1689	378001	1943-09-14	1943-09-14 00:00:00	1943-10-14	1943-10-14 00:00:00	32020		\N	113087	0	62106007	378001		0
28580	1691	40481087	1966-01-10	1966-01-10 00:00:00	1966-01-31	1966-01-31 00:00:00	32020		\N	113256	0	444814009	40481087		0
28833	1707	4027663	1998-08-03	1998-08-03 00:00:00	\N	\N	32020		\N	114149	0	13200003	4027663		0
28946	1715	80180	1999-05-29	1999-05-29 00:00:00	\N	\N	32020		\N	114564	0	396275006	80180		0
29126	1724	378001	1951-07-04	1951-07-04 00:00:00	1951-09-02	1951-09-02 00:00:00	32020		\N	115261	0	62106007	378001		0
29312	1737	4112343	1993-03-31	1993-03-31 00:00:00	1993-04-09	1993-04-09 00:00:00	32020		\N	116037	0	195662009	4112343		0
29448	1744	40481087	2011-05-13	2011-05-13 00:00:00	2011-06-03	2011-06-03 00:00:00	32020		\N	116630	0	444814009	40481087		0
29614	1752	372328	1979-10-17	1979-10-17 00:00:00	1979-12-02	1979-12-02 00:00:00	32020		\N	117142	0	65363002	372328		0
29756	1761	4112343	1996-07-01	1996-07-01 00:00:00	1996-07-11	1996-07-11 00:00:00	32020		\N	117791	0	195662009	4112343		0
29994	1776	40481087	1934-12-11	1934-12-11 00:00:00	1934-12-18	1934-12-18 00:00:00	32020		\N	118818	0	444814009	40481087		0
30178	1782	40481087	1973-06-18	1973-06-18 00:00:00	1973-07-09	1973-07-09 00:00:00	32020		\N	119345	0	444814009	40481087		0
30299	1789	40481087	2011-12-22	2011-12-22 00:00:00	2012-01-05	2012-01-05 00:00:00	32020		\N	119916	0	444814009	40481087		0
41028	2439	260139	1978-03-19	1978-03-19 00:00:00	1978-03-26	1978-03-26 00:00:00	32020		\N	161799	0	10509002	260139		0
30636	1809	40481087	1999-07-21	1999-07-21 00:00:00	1999-08-04	1999-08-04 00:00:00	32020		\N	121121	0	444814009	40481087		0
30810	1821	40481087	1964-01-13	1964-01-13 00:00:00	1964-01-27	1964-01-27 00:00:00	32020		\N	121808	0	444814009	40481087		0
30963	1834	28060	1987-05-14	1987-05-14 00:00:00	1987-05-23	1987-05-23 00:00:00	32020		\N	122484	0	43878008	28060		0
31142	1844	4310024	2000-05-26	2000-05-26 00:00:00	\N	\N	32020		\N	123179	0	424802006	4310024		0
31290	1850	257012	1970-10-27	1970-10-27 00:00:00	1971-03-30	1971-03-30 00:00:00	32020		\N	123748	0	40055000	257012		0
31486	1861	4112343	1981-12-31	1981-12-31 00:00:00	1982-01-12	1982-01-12 00:00:00	32020		\N	124417	0	195662009	4112343		0
31588	1870	40481087	1955-10-23	1955-10-23 00:00:00	1955-10-30	1955-10-30 00:00:00	32020		\N	124949	0	444814009	40481087		0
42333	2521	81151	1980-08-17	1980-08-17 00:00:00	1980-09-07	1980-09-07 00:00:00	32020		\N	166739	0	44465007	81151		0
21348	1281	372328	1975-06-12	1975-06-12 00:00:00	1976-02-21	1976-02-21 00:00:00	32020		\N	84699	0	65363002	372328		0
21572	1293	28060	1951-01-28	1951-01-28 00:00:00	1951-02-09	1951-02-09 00:00:00	32020		\N	85544	0	43878008	28060		0
21728	1305	80180	2000-10-18	2000-10-18 00:00:00	\N	\N	32020		\N	86139	0	396275006	80180		0
21901	1314	40481087	1980-07-20	1980-07-20 00:00:00	1980-08-10	1980-08-10 00:00:00	32020		\N	87009	0	444814009	40481087		0
21957	1316	81151	2006-08-19	2006-08-19 00:00:00	2006-09-16	2006-09-16 00:00:00	32020		\N	87222	0	44465007	81151		0
22217	1325	260139	1970-11-18	1970-11-18 00:00:00	1970-12-02	1970-12-02 00:00:00	32020		\N	87983	0	10509002	260139		0
22320	1332	4218389	1984-07-11	1984-07-11 00:00:00	1984-08-01	1984-08-01 00:00:00	32020		\N	88382	0	39848009	4218389		0
22503	1345	81893	2003-06-29	2003-06-29 00:00:00	\N	\N	32020		\N	89149	0	64766004	81893		0
22664	1354	4237458	1995-05-29	1995-05-29 00:00:00	1995-06-28	1995-06-28 00:00:00	32020		\N	89761	0	58150001	4237458		0
22840	1361	260139	2000-06-08	2000-06-08 00:00:00	2000-06-22	2000-06-22 00:00:00	32020		\N	90335	0	10509002	260139		0
22936	1368	4237458	1959-05-19	1959-05-19 00:00:00	1959-06-18	1959-06-18 00:00:00	32020		\N	90716	0	58150001	4237458		0
23115	1379	4112343	1994-11-03	1994-11-03 00:00:00	1994-11-12	1994-11-12 00:00:00	32020		\N	91458	0	195662009	4112343		0
23316	1391	40481087	1992-03-29	1992-03-29 00:00:00	1992-04-12	1992-04-12 00:00:00	32020		\N	92401	0	444814009	40481087		0
23530	1407	257012	1996-02-25	1996-02-25 00:00:00	\N	\N	32020		\N	93558	0	40055000	257012		0
23656	1411	4310024	2000-12-21	2000-12-21 00:00:00	\N	\N	32020		\N	93953	0	424802006	4310024		0
23887	1427	81151	1982-03-13	1982-03-13 00:00:00	1982-04-03	1982-04-03 00:00:00	32020		\N	94960	0	44465007	81151		0
23955	1430	40481087	1954-04-04	1954-04-04 00:00:00	1954-04-18	1954-04-18 00:00:00	32020		\N	95121	0	444814009	40481087		0
24229	1443	260139	1983-03-25	1983-03-25 00:00:00	1983-04-08	1983-04-08 00:00:00	32020		\N	96201	0	10509002	260139		0
24355	1450	372328	1963-10-09	1963-10-09 00:00:00	1964-01-19	1964-01-19 00:00:00	32020		\N	96726	0	65363002	372328		0
24456	1459	4112343	1948-11-09	1948-11-09 00:00:00	1948-11-21	1948-11-21 00:00:00	32020		\N	97233	0	195662009	4112343		0
24601	1468	40481087	1983-09-12	1983-09-12 00:00:00	1983-09-26	1983-09-26 00:00:00	32020		\N	97854	0	444814009	40481087		0
24851	1482	372328	1975-01-17	1975-01-17 00:00:00	1975-03-29	1975-03-29 00:00:00	32020		\N	98843	0	65363002	372328		0
24994	1491	4294548	2005-11-19	2005-11-19 00:00:00	2005-12-17	2005-12-17 00:00:00	32020		\N	99408	0	75498004	4294548		0
25121	1497	40481087	2006-05-14	2006-05-14 00:00:00	2006-05-21	2006-05-21 00:00:00	32020		\N	99754	0	444814009	40481087		0
25278	1508	28060	1959-07-07	1959-07-07 00:00:00	1959-07-15	1959-07-15 00:00:00	32020		\N	100641	0	43878008	28060		0
25518	1518	40481087	1990-10-18	1990-10-18 00:00:00	1990-11-08	1990-11-08 00:00:00	32020		\N	101527	0	444814009	40481087		0
25679	1526	4112343	2004-12-30	2004-12-30 00:00:00	2005-01-12	2005-01-12 00:00:00	32020		\N	102080	0	195662009	4112343		0
25866	1536	40481087	1939-07-26	1939-07-26 00:00:00	1939-08-09	1939-08-09 00:00:00	32020		\N	102820	0	444814009	40481087		0
25998	1542	260139	1970-09-01	1970-09-01 00:00:00	1970-09-15	1970-09-15 00:00:00	32020		\N	103338	0	10509002	260139		0
26143	1551	4112343	1978-09-24	1978-09-24 00:00:00	1978-10-05	1978-10-05 00:00:00	32020		\N	103828	0	195662009	4112343		0
26336	1563	80180	1997-09-01	1997-09-01 00:00:00	\N	\N	32020		\N	104663	0	396275006	80180		0
26427	1567	4156265	1990-07-05	1990-07-05 00:00:00	1990-07-26	1990-07-26 00:00:00	32020		\N	105105	0	370247008	4156265		0
26636	1577	195588	1955-02-09	1955-02-09 00:00:00	1955-03-29	1955-03-29 00:00:00	32020		\N	105836	0	38822007	195588		0
26826	1588	40481087	1980-12-23	1980-12-23 00:00:00	1980-12-30	1980-12-30 00:00:00	32020		\N	106632	0	444814009	40481087		0
26928	1593	40481087	1950-09-14	1950-09-14 00:00:00	1950-09-28	1950-09-28 00:00:00	32020		\N	106860	0	444814009	40481087		0
27115	1604	40481087	1978-11-10	1978-11-10 00:00:00	1978-11-17	1978-11-17 00:00:00	32020		\N	107614	0	444814009	40481087		0
27335	1611	40481087	2017-01-14	2017-01-14 00:00:00	2017-01-28	2017-01-28 00:00:00	32020		\N	108330	0	444814009	40481087		0
27546	1626	313217	1995-08-27	1995-08-27 00:00:00	\N	\N	32020		\N	109233	0	49436004	313217		0
27673	1634	260139	1950-11-07	1950-11-07 00:00:00	1950-11-21	1950-11-21 00:00:00	32020		\N	109728	0	10509002	260139		0
27881	1646	40481087	2014-08-27	2014-08-27 00:00:00	2014-09-10	2014-09-10 00:00:00	32020		\N	110437	0	444814009	40481087		0
38532	2289	80502	2009-12-29	2009-12-29 00:00:00	\N	\N	32020		\N	152245	0	64859006	80502		0
28124	1659	257012	2001-01-11	2001-01-11 00:00:00	\N	\N	32020		\N	111489	0	40055000	257012		0
28332	1674	40481087	2008-09-06	2008-09-06 00:00:00	2008-09-20	2008-09-20 00:00:00	32020		\N	112380	0	444814009	40481087		0
28533	1689	260139	2000-09-20	2000-09-20 00:00:00	2000-10-04	2000-10-04 00:00:00	32020		\N	113123	0	10509002	260139		0
28581	1691	28060	1951-07-27	1951-07-27 00:00:00	1951-08-08	1951-08-08 00:00:00	32020		\N	113261	0	43878008	28060		0
28834	1707	40481087	1990-10-16	1990-10-16 00:00:00	1990-10-30	1990-10-30 00:00:00	32020		\N	114129	0	444814009	40481087		0
28947	1715	260139	1998-09-04	1998-09-04 00:00:00	1998-09-18	1998-09-18 00:00:00	32020		\N	114564	0	10509002	260139		0
29127	1724	40481087	2018-09-01	2018-09-01 00:00:00	2018-09-22	2018-09-22 00:00:00	32020		\N	115253	0	444814009	40481087		0
29313	1737	40481087	1935-07-12	1935-07-12 00:00:00	1935-08-02	1935-08-02 00:00:00	32020		\N	116015	0	444814009	40481087		0
29449	1744	260139	2014-10-20	2014-10-20 00:00:00	2014-11-03	2014-11-03 00:00:00	32020		\N	116631	0	10509002	260139		0
29615	1752	40481087	2011-11-10	2011-11-10 00:00:00	2011-11-17	2011-11-17 00:00:00	32020		\N	117154	0	444814009	40481087		0
29757	1761	260139	1985-12-21	1985-12-21 00:00:00	1986-01-04	1986-01-04 00:00:00	32020		\N	117770	0	10509002	260139		0
29995	1776	4112343	1983-03-18	1983-03-18 00:00:00	1983-03-30	1983-03-30 00:00:00	32020		\N	118784	0	195662009	4112343		0
30179	1782	40481087	1993-12-26	1993-12-26 00:00:00	1994-01-02	1994-01-02 00:00:00	32020		\N	119323	0	444814009	40481087		0
30300	1789	260139	1988-04-21	1988-04-21 00:00:00	1988-05-05	1988-05-05 00:00:00	32020		\N	119862	0	10509002	260139		0
41029	2439	40481087	2016-01-19	2016-01-19 00:00:00	2016-02-02	2016-02-02 00:00:00	32020		\N	161786	0	444814009	40481087		0
30637	1809	80180	1995-01-23	1995-01-23 00:00:00	\N	\N	32020		\N	121106	0	396275006	80180		0
30811	1821	4155034	1963-04-01	1963-04-01 00:00:00	1963-04-22	1963-04-22 00:00:00	32020		\N	121772	0	283371005	4155034		0
30964	1834	260139	1969-10-02	1969-10-02 00:00:00	1969-10-09	1969-10-09 00:00:00	32020		\N	122557	0	10509002	260139		0
31143	1844	81893	2000-12-22	2000-12-22 00:00:00	\N	\N	32020		\N	123179	0	64766004	81893		0
31291	1850	4285898	1997-12-24	1997-12-24 00:00:00	\N	\N	32020		\N	123742	0	68496003	4285898		0
31487	1861	4112343	2004-11-26	2004-11-26 00:00:00	2004-12-09	2004-12-09 00:00:00	32020		\N	124455	0	195662009	4112343		0
31589	1870	4112343	1943-05-27	1943-05-27 00:00:00	1943-06-03	1943-06-03 00:00:00	32020		\N	124918	0	195662009	4112343		0
42334	2521	40481087	1971-02-18	1971-02-18 00:00:00	1971-03-11	1971-03-11 00:00:00	32020		\N	166760	0	444814009	40481087		0
21349	1281	260139	1978-06-22	1978-06-22 00:00:00	1978-07-06	1978-07-06 00:00:00	32020		\N	84685	0	10509002	260139		0
21573	1293	4051466	1942-01-01	1942-01-01 00:00:00	1959-04-06	1959-04-06 00:00:00	32020		\N	85477	0	233678006	4051466		0
21729	1306	4278672	1966-01-09	1966-01-09 00:00:00	1966-04-09	1966-04-09 00:00:00	32020		\N	86247	0	65966004	4278672		0
21902	1314	4294548	2015-05-24	2015-05-24 00:00:00	2015-07-19	2015-07-19 00:00:00	32020		\N	87041	0	75498004	4294548		0
21958	1316	260139	2004-07-26	2004-07-26 00:00:00	2004-08-09	2004-08-09 00:00:00	32020		\N	87156	0	10509002	260139		0
22218	1325	40481087	2002-08-03	2002-08-03 00:00:00	2002-08-24	2002-08-24 00:00:00	32020		\N	87973	0	444814009	40481087		0
22321	1332	30753	1978-12-15	1978-12-15 00:00:00	\N	\N	32020		\N	88347	0	16761005	30753		0
22504	1345	30753	2003-11-26	2003-11-26 00:00:00	\N	\N	32020		\N	89149	0	16761005	30753		0
22665	1354	40481087	2007-12-04	2007-12-04 00:00:00	2007-12-25	2007-12-25 00:00:00	32020		\N	89727	0	444814009	40481087		0
22841	1361	80180	1982-02-10	1982-02-10 00:00:00	\N	\N	32020		\N	90316	0	396275006	80180		0
22937	1368	40481087	2006-02-20	2006-02-20 00:00:00	2006-02-27	2006-02-27 00:00:00	32020		\N	90719	0	444814009	40481087		0
23116	1379	4134304	1962-10-30	1962-10-30 00:00:00	1962-11-29	1962-11-29 00:00:00	32020		\N	91509	0	263102004	4134304		0
23317	1391	260139	1961-02-02	1961-02-02 00:00:00	1961-02-16	1961-02-16 00:00:00	32020		\N	92382	0	10509002	260139		0
23531	1407	40481087	2017-04-20	2017-04-20 00:00:00	2017-04-27	2017-04-27 00:00:00	32020		\N	93486	0	444814009	40481087		0
23657	1411	4285898	2002-08-13	2002-08-13 00:00:00	\N	\N	32020		\N	93953	0	68496003	4285898		0
23888	1427	4152936	1983-01-28	1983-01-28 00:00:00	1983-02-18	1983-02-18 00:00:00	32020		\N	94961	0	283385000	4152936		0
23956	1430	4112343	1986-09-09	1986-09-09 00:00:00	1986-09-17	1986-09-17 00:00:00	32020		\N	95154	0	195662009	4112343		0
24230	1443	4112343	2011-03-14	2011-03-14 00:00:00	2011-03-25	2011-03-25 00:00:00	32020		\N	96196	0	195662009	4112343		0
24400	1454	260139	1985-05-09	1985-05-09 00:00:00	1985-05-16	1985-05-16 00:00:00	32020		\N	96989	0	10509002	260139		0
24457	1459	4294548	2018-06-07	2018-06-07 00:00:00	2018-11-22	2018-11-22 00:00:00	32020		\N	97195	0	75498004	4294548		0
24602	1468	4218389	1974-02-09	1974-02-09 00:00:00	1974-03-09	1974-03-09 00:00:00	32020		\N	97874	0	39848009	4218389		0
24852	1482	4112343	2016-09-20	2016-09-20 00:00:00	2016-09-28	2016-09-28 00:00:00	32020		\N	98839	0	195662009	4112343		0
25003	1493	40481087	2016-05-31	2016-05-31 00:00:00	2016-06-21	2016-06-21 00:00:00	32020		\N	99525	0	444814009	40481087		0
25122	1497	40481087	1969-11-05	1969-11-05 00:00:00	1969-11-12	1969-11-12 00:00:00	32020		\N	99859	0	444814009	40481087		0
25279	1508	40481087	1961-06-01	1961-06-01 00:00:00	1961-06-08	1961-06-08 00:00:00	32020		\N	100571	0	444814009	40481087		0
25519	1518	40481087	1994-07-10	1994-07-10 00:00:00	1994-07-17	1994-07-17 00:00:00	32020		\N	101496	0	444814009	40481087		0
25680	1526	4296204	1972-11-24	1972-11-24 00:00:00	1972-12-22	1972-12-22 00:00:00	32020		\N	102048	0	403190006	4296204		0
25867	1536	260139	1917-12-28	1917-12-28 00:00:00	1918-01-11	1918-01-11 00:00:00	32020		\N	102795	0	10509002	260139		0
25999	1542	81151	1992-11-16	1992-11-16 00:00:00	1992-12-21	1992-12-21 00:00:00	32020		\N	103305	0	44465007	81151		0
26144	1551	4112343	1992-06-27	1992-06-27 00:00:00	1992-07-05	1992-07-05 00:00:00	32020		\N	103867	0	195662009	4112343		0
26337	1563	4112343	1961-05-14	1961-05-14 00:00:00	1961-05-22	1961-05-22 00:00:00	32020		\N	104696	0	195662009	4112343		0
26428	1567	260139	1989-07-07	1989-07-07 00:00:00	1989-07-14	1989-07-14 00:00:00	32020		\N	105112	0	10509002	260139		0
26637	1577	40481087	2010-02-10	2010-02-10 00:00:00	2010-02-24	2010-02-24 00:00:00	32020		\N	105942	0	444814009	40481087		0
26827	1588	40481087	1968-08-02	1968-08-02 00:00:00	1968-08-16	1968-08-16 00:00:00	32020		\N	106625	0	444814009	40481087		0
26929	1593	4142905	1941-08-05	1941-08-05 00:00:00	1941-10-04	1941-10-04 00:00:00	32020		\N	106919	0	33737001	4142905		0
27116	1604	40481087	1967-09-11	1967-09-11 00:00:00	1967-10-02	1967-10-02 00:00:00	32020		\N	107613	0	444814009	40481087		0
27336	1611	4112343	2003-01-28	2003-01-28 00:00:00	2003-02-10	2003-02-10 00:00:00	32020		\N	108319	0	195662009	4112343		0
27547	1626	81151	1943-09-14	1943-09-14 00:00:00	1943-10-05	1943-10-05 00:00:00	32020		\N	109186	0	44465007	81151		0
27674	1634	260139	1975-03-23	1975-03-23 00:00:00	1975-03-30	1975-03-30 00:00:00	32020		\N	109738	0	10509002	260139		0
27882	1646	4296204	1973-03-03	1973-03-03 00:00:00	1973-03-17	1973-03-17 00:00:00	32020		\N	110448	0	403190006	4296204		0
38533	2289	40481087	1951-04-02	1951-04-02 00:00:00	1951-04-16	1951-04-16 00:00:00	32020		\N	152257	0	444814009	40481087		0
28125	1659	440086	1976-03-15	1976-03-15 00:00:00	1983-06-27	1983-06-27 00:00:00	32020		\N	111570	0	192127007	440086		0
28333	1674	260139	1985-01-28	1985-01-28 00:00:00	1985-02-04	1985-02-04 00:00:00	32020		\N	112342	0	10509002	260139		0
28534	1689	4296204	1986-02-14	1986-02-14 00:00:00	1986-03-07	1986-03-07 00:00:00	32020		\N	113090	0	403190006	4296204		0
28582	1691	40481087	1993-08-15	1993-08-15 00:00:00	1993-08-22	1993-08-22 00:00:00	32020		\N	113288	0	444814009	40481087		0
28835	1707	40481087	1982-06-14	1982-06-14 00:00:00	1982-06-21	1982-06-21 00:00:00	32020		\N	114147	0	444814009	40481087		0
28948	1715	78272	1984-09-24	1984-09-24 00:00:00	1984-10-08	1984-10-08 00:00:00	32020		\N	114534	0	70704007	78272		0
29128	1724	40481087	1959-12-08	1959-12-08 00:00:00	1959-12-15	1959-12-15 00:00:00	32020		\N	115248	0	444814009	40481087		0
29314	1737	260139	1972-05-02	1972-05-02 00:00:00	1972-05-09	1972-05-09 00:00:00	32020		\N	116097	0	10509002	260139		0
29450	1744	4156265	1990-07-12	1990-07-12 00:00:00	1990-08-02	1990-08-02 00:00:00	32020		\N	116627	0	370247008	4156265		0
29616	1752	40481087	1978-11-29	1978-11-29 00:00:00	1978-12-06	1978-12-06 00:00:00	32020		\N	117106	0	444814009	40481087		0
29758	1761	372328	1957-10-27	1957-10-27 00:00:00	1958-08-11	1958-08-11 00:00:00	32020		\N	117746	0	65363002	372328		0
29996	1776	40481087	1991-08-16	1991-08-16 00:00:00	1991-08-30	1991-08-30 00:00:00	32020		\N	118786	0	444814009	40481087		0
30180	1782	4112343	2008-11-11	2008-11-11 00:00:00	2008-11-20	2008-11-20 00:00:00	32020		\N	119327	0	195662009	4112343		0
30301	1789	4155034	1978-11-08	1978-11-08 00:00:00	1978-11-29	1978-11-29 00:00:00	32020		\N	119897	0	283371005	4155034		0
41030	2439	260139	1993-10-04	1993-10-04 00:00:00	1993-10-18	1993-10-18 00:00:00	32020		\N	161784	0	10509002	260139		0
30638	1809	260139	1971-03-02	1971-03-02 00:00:00	1971-03-09	1971-03-09 00:00:00	32020		\N	121099	0	10509002	260139		0
30812	1821	4112343	1944-07-30	1944-07-30 00:00:00	1944-08-06	1944-08-06 00:00:00	32020		\N	121850	0	195662009	4112343		0
30965	1834	375671	1982-04-05	1982-04-05 00:00:00	1982-06-04	1982-06-04 00:00:00	32020		\N	122543	0	62564004	375671		0
31144	1844	28060	1976-11-29	1976-11-29 00:00:00	1976-12-08	1976-12-08 00:00:00	32020		\N	123134	0	43878008	28060		0
31292	1850	80180	1998-07-22	1998-07-22 00:00:00	\N	\N	32020		\N	123742	0	396275006	80180		0
31488	1861	40481087	1992-11-05	1992-11-05 00:00:00	1992-11-26	1992-11-26 00:00:00	32020		\N	124438	0	444814009	40481087		0
31590	1870	4112343	1925-05-04	1925-05-04 00:00:00	1925-05-12	1925-05-12 00:00:00	32020		\N	124915	0	195662009	4112343		0
42335	2522	4218389	1961-05-26	1961-05-26 00:00:00	1961-06-23	1961-06-23 00:00:00	32020		\N	166786	0	39848009	4218389		0
21350	1281	4112343	2006-10-19	2006-10-19 00:00:00	2006-10-30	2006-10-30 00:00:00	32020		\N	84644	0	195662009	4112343		0
21574	1293	4278672	1970-03-18	1970-03-18 00:00:00	1970-05-17	1970-05-17 00:00:00	32020		\N	85602	0	65966004	4278672		0
21730	1306	4116491	2006-07-27	2006-07-27 00:00:00	2006-09-17	2006-09-17 00:00:00	32020		\N	86240	0	301011002	4116491		0
21903	1314	4152936	1980-05-22	1980-05-22 00:00:00	1980-06-12	1980-06-12 00:00:00	32020		\N	87035	0	283385000	4152936		0
21959	1316	4112343	1950-04-23	1950-04-23 00:00:00	1950-05-06	1950-05-06 00:00:00	32020		\N	87226	0	195662009	4112343		0
22219	1325	260139	1966-01-03	1966-01-03 00:00:00	1966-01-10	1966-01-10 00:00:00	32020		\N	87982	0	10509002	260139		0
22322	1332	40481087	1976-06-14	1976-06-14 00:00:00	1976-06-21	1976-06-21 00:00:00	32020		\N	88347	0	444814009	40481087		0
22505	1345	4285898	2004-08-22	2004-08-22 00:00:00	\N	\N	32020		\N	89150	0	68496003	4285898		0
22666	1354	260139	1994-09-14	1994-09-14 00:00:00	1994-09-28	1994-09-28 00:00:00	32020		\N	89726	0	10509002	260139		0
22842	1361	28060	1955-09-06	1955-09-06 00:00:00	1955-09-16	1955-09-16 00:00:00	32020		\N	90366	0	43878008	28060		0
22938	1368	4146173	2001-08-25	2001-08-25 00:00:00	2001-09-24	2001-09-24 00:00:00	32020		\N	90712	0	307731004	4146173		0
23122	1381	4112343	2001-07-24	2001-07-24 00:00:00	2001-08-06	2001-08-06 00:00:00	32020		\N	91579	0	195662009	4112343		0
23318	1391	80180	1962-09-13	1962-09-13 00:00:00	\N	\N	32020		\N	92382	0	396275006	80180		0
23532	1407	4146173	1982-08-18	1982-08-18 00:00:00	1982-09-17	1982-09-17 00:00:00	32020		\N	93505	0	307731004	4146173		0
23658	1411	80180	2002-11-11	2002-11-11 00:00:00	\N	\N	32020		\N	93953	0	396275006	80180		0
23889	1427	40481087	1985-02-26	1985-02-26 00:00:00	1985-03-19	1985-03-19 00:00:00	32020		\N	94931	0	444814009	40481087		0
23957	1430	4134304	1955-05-24	1955-05-24 00:00:00	1955-08-22	1955-08-22 00:00:00	32020		\N	95179	0	263102004	4134304		0
24231	1443	40481087	1999-06-02	1999-06-02 00:00:00	1999-06-23	1999-06-23 00:00:00	32020		\N	96226	0	444814009	40481087		0
24401	1454	28060	1984-04-06	1984-04-06 00:00:00	1984-04-15	1984-04-15 00:00:00	32020		\N	96977	0	43878008	28060		0
24458	1459	4027663	1967-12-04	1967-12-04 00:00:00	\N	\N	32020		\N	97251	0	13200003	4027663		0
24603	1468	4112343	1977-02-25	1977-02-25 00:00:00	1977-03-10	1977-03-10 00:00:00	32020		\N	97859	0	195662009	4112343		0
24853	1482	4084167	1981-12-11	1981-12-11 00:00:00	1981-12-11	1981-12-11 00:00:00	32020		\N	98905	0	241929008	4084167		0
25004	1493	4112343	2000-02-02	2000-02-02 00:00:00	2000-02-15	2000-02-15 00:00:00	32020		\N	99567	0	195662009	4112343		0
25123	1497	40481087	2009-08-10	2009-08-10 00:00:00	2009-08-17	2009-08-17 00:00:00	32020		\N	99923	0	444814009	40481087		0
25280	1508	80180	1963-12-07	1963-12-07 00:00:00	\N	\N	32020		\N	100571	0	396275006	80180		0
25520	1518	378001	1996-07-27	1996-07-27 00:00:00	1996-08-26	1996-08-26 00:00:00	32020		\N	101541	0	62106007	378001		0
25681	1526	4112343	1991-01-04	1991-01-04 00:00:00	1991-01-11	1991-01-11 00:00:00	32020		\N	102079	0	195662009	4112343		0
25868	1536	4112343	1959-07-04	1959-07-04 00:00:00	1959-07-15	1959-07-15 00:00:00	32020		\N	102796	0	195662009	4112343		0
26000	1542	40481087	1976-09-02	1976-09-02 00:00:00	1976-09-16	1976-09-16 00:00:00	32020		\N	103307	0	444814009	40481087		0
26145	1551	4283893	1979-03-28	1979-03-28 00:00:00	1979-05-09	1979-05-09 00:00:00	32020		\N	103853	0	36971009	4283893		0
26338	1563	28060	2002-10-24	2002-10-24 00:00:00	2002-10-31	2002-10-31 00:00:00	32020		\N	104678	0	43878008	28060		0
26429	1567	4112343	1981-02-07	1981-02-07 00:00:00	1981-02-17	1981-02-17 00:00:00	32020		\N	105110	0	195662009	4112343		0
26638	1577	372328	1925-07-01	1925-07-01 00:00:00	1925-07-24	1925-07-24 00:00:00	32020		\N	105840	0	65363002	372328		0
26828	1588	80180	2005-03-13	2005-03-13 00:00:00	\N	\N	32020		\N	106573	0	396275006	80180		0
26930	1593	4035415	1957-02-24	1957-02-24 00:00:00	1957-03-26	1957-03-26 00:00:00	32020		\N	106843	0	239720000	4035415		0
27117	1604	372328	1958-12-08	1958-12-08 00:00:00	1959-10-15	1959-10-15 00:00:00	32020		\N	107611	0	65363002	372328		0
27337	1611	260139	1968-12-13	1968-12-13 00:00:00	1968-12-27	1968-12-27 00:00:00	32020		\N	108349	0	10509002	260139		0
27548	1626	40481087	1981-06-13	1981-06-13 00:00:00	1981-06-27	1981-06-27 00:00:00	32020		\N	109191	0	444814009	40481087		0
27675	1634	4112343	1945-11-03	1945-11-03 00:00:00	1945-11-15	1945-11-15 00:00:00	32020		\N	109721	0	195662009	4112343		0
27883	1646	372328	1946-01-03	1946-01-03 00:00:00	1946-02-02	1946-02-02 00:00:00	32020		\N	110439	0	65363002	372328		0
38534	2289	257012	1953-01-26	1953-01-26 00:00:00	\N	\N	32020		\N	152259	0	40055000	257012		0
28126	1659	4112343	1999-10-07	1999-10-07 00:00:00	1999-10-15	1999-10-15 00:00:00	32020		\N	111473	0	195662009	4112343		0
28334	1674	40481087	1997-06-08	1997-06-08 00:00:00	1997-06-15	1997-06-15 00:00:00	32020		\N	112345	0	444814009	40481087		0
28535	1689	260139	1982-03-23	1982-03-23 00:00:00	1982-03-30	1982-03-30 00:00:00	32020		\N	113096	0	10509002	260139		0
28583	1691	28060	1951-01-11	1951-01-11 00:00:00	1951-01-24	1951-01-24 00:00:00	32020		\N	113255	0	43878008	28060		0
28851	1709	40481087	1952-03-26	1952-03-26 00:00:00	1952-04-02	1952-04-02 00:00:00	32020		\N	114296	0	444814009	40481087		0
28949	1715	260139	2015-01-08	2015-01-08 00:00:00	2015-01-15	2015-01-15 00:00:00	32020		\N	114565	0	10509002	260139		0
29129	1724	4112343	2016-07-23	2016-07-23 00:00:00	2016-07-31	2016-07-31 00:00:00	32020		\N	115244	0	195662009	4112343		0
29315	1737	40481087	1939-10-18	1939-10-18 00:00:00	1939-11-01	1939-11-01 00:00:00	32020		\N	116011	0	444814009	40481087		0
29451	1744	260139	1999-01-09	1999-01-09 00:00:00	1999-01-23	1999-01-23 00:00:00	32020		\N	116621	0	10509002	260139		0
29617	1752	4296204	2004-11-03	2004-11-03 00:00:00	2004-11-17	2004-11-17 00:00:00	32020		\N	117161	0	403190006	4296204		0
29759	1761	4113008	2016-05-10	2016-05-10 00:00:00	2016-05-31	2016-05-31 00:00:00	32020		\N	117722	0	284549007	4113008		0
29997	1776	4142905	1992-12-03	1992-12-03 00:00:00	1993-01-02	1993-01-02 00:00:00	32020		\N	118805	0	33737001	4142905		0
30181	1782	372328	1954-04-19	1954-04-19 00:00:00	1954-05-03	1954-05-03 00:00:00	32020		\N	119328	0	65363002	372328		0
30302	1789	28060	1985-03-07	1985-03-07 00:00:00	1985-03-15	1985-03-15 00:00:00	32020		\N	119883	0	43878008	28060		0
41031	2439	4116491	2006-05-09	2006-05-09 00:00:00	2006-06-11	2006-06-11 00:00:00	32020		\N	161813	0	301011002	4116491		0
30660	1812	260139	1992-05-09	1992-05-09 00:00:00	1992-05-23	1992-05-23 00:00:00	32020		\N	121256	0	10509002	260139		0
30813	1821	4152936	1998-10-07	1998-10-07 00:00:00	1998-10-21	1998-10-21 00:00:00	32020		\N	121775	0	283385000	4152936		0
30966	1834	40481087	1978-06-14	1978-06-14 00:00:00	1978-06-21	1978-06-21 00:00:00	32020		\N	122538	0	444814009	40481087		0
31145	1844	40481087	2014-08-09	2014-08-09 00:00:00	2014-08-30	2014-08-30 00:00:00	32020		\N	123228	0	444814009	40481087		0
31293	1850	30753	1997-10-25	1997-10-25 00:00:00	\N	\N	32020		\N	123742	0	16761005	30753		0
31489	1861	4237458	1995-02-28	1995-02-28 00:00:00	1995-04-29	1995-04-29 00:00:00	32020		\N	124414	0	58150001	4237458		0
31591	1870	40481087	1932-10-09	1932-10-09 00:00:00	1932-10-16	1932-10-16 00:00:00	32020		\N	124941	0	444814009	40481087		0
42336	2522	40481087	1970-08-04	1970-08-04 00:00:00	1970-08-11	1970-08-11 00:00:00	32020		\N	166819	0	444814009	40481087		0
21351	1281	4283893	1991-09-07	1991-09-07 00:00:00	1992-01-25	1992-01-25 00:00:00	32020		\N	84664	0	36971009	4283893		0
21575	1293	378001	1949-09-04	1949-09-04 00:00:00	1949-10-04	1949-10-04 00:00:00	32020		\N	85597	0	62106007	378001		0
21731	1306	260139	1971-04-02	1971-04-02 00:00:00	1971-04-09	1971-04-09 00:00:00	32020		\N	86169	0	10509002	260139		0
21904	1314	260139	2012-04-22	2012-04-22 00:00:00	2012-05-06	2012-05-06 00:00:00	32020		\N	87051	0	10509002	260139		0
21960	1316	40481087	2002-11-21	2002-11-21 00:00:00	2002-12-05	2002-12-05 00:00:00	32020		\N	87140	0	444814009	40481087		0
22220	1325	260139	2001-04-06	2001-04-06 00:00:00	2001-04-13	2001-04-13 00:00:00	32020		\N	87951	0	10509002	260139		0
22323	1332	40481087	1968-12-23	1968-12-23 00:00:00	1969-01-13	1969-01-13 00:00:00	32020		\N	88303	0	444814009	40481087		0
22506	1345	317576	2008-03-25	2008-03-25 00:00:00	\N	\N	32020		\N	89151	0	53741008	317576		0
22667	1354	40481087	1994-01-02	1994-01-02 00:00:00	1994-01-09	1994-01-09 00:00:00	32020		\N	89762	0	444814009	40481087		0
22843	1361	195588	1973-08-26	1973-08-26 00:00:00	1973-10-17	1973-10-17 00:00:00	32020		\N	90370	0	38822007	195588		0
22939	1368	372328	1982-05-16	1982-05-16 00:00:00	1982-09-15	1982-09-15 00:00:00	32020		\N	90738	0	65363002	372328		0
23123	1381	40481087	2014-02-14	2014-02-14 00:00:00	2014-02-21	2014-02-21 00:00:00	32020		\N	91581	0	444814009	40481087		0
23319	1391	40481087	1928-06-16	1928-06-16 00:00:00	1928-06-30	1928-06-30 00:00:00	32020		\N	92394	0	444814009	40481087		0
23533	1407	81151	1975-04-29	1975-04-29 00:00:00	1975-05-27	1975-05-27 00:00:00	32020		\N	93563	0	44465007	81151		0
23659	1411	4149245	1996-03-22	1996-03-22 00:00:00	1996-04-28	1996-04-28 00:00:00	32020		\N	93966	0	30832001	4149245		0
23890	1428	260139	1998-09-18	1998-09-18 00:00:00	1998-10-02	1998-10-02 00:00:00	32020		\N	94995	0	10509002	260139		0
23958	1431	40481087	1975-07-20	1975-07-20 00:00:00	1975-08-10	1975-08-10 00:00:00	32020		\N	95222	0	444814009	40481087		0
34695	2060	260139	1998-12-19	1998-12-19 00:00:00	1999-01-02	1999-01-02 00:00:00	32020		\N	136977	0	10509002	260139		0
24402	1454	260139	1989-12-23	1989-12-23 00:00:00	1989-12-30	1989-12-30 00:00:00	32020		\N	96987	0	10509002	260139		0
24459	1459	4285898	1975-12-22	1975-12-22 00:00:00	\N	\N	32020		\N	97190	0	68496003	4285898		0
24604	1468	4294548	1969-10-24	1969-10-24 00:00:00	1969-10-31	1969-10-31 00:00:00	32020		\N	97791	0	75498004	4294548		0
24854	1482	81893	2016-04-01	2016-04-01 00:00:00	\N	\N	32020		\N	98826	0	64766004	81893		0
25005	1493	40481087	2014-04-29	2014-04-29 00:00:00	2014-05-06	2014-05-06 00:00:00	32020		\N	99538	0	444814009	40481087		0
25124	1498	4112343	2012-08-29	2012-08-29 00:00:00	2012-09-08	2012-09-08 00:00:00	32020		\N	99948	0	195662009	4112343		0
25281	1508	440086	1936-12-28	1936-12-28 00:00:00	1938-08-29	1938-08-29 00:00:00	32020		\N	100551	0	192127007	440086		0
25521	1518	4027663	1986-07-02	1986-07-02 00:00:00	\N	\N	32020		\N	101524	0	13200003	4027663		0
25682	1526	4155034	2005-09-30	2005-09-30 00:00:00	2005-10-14	2005-10-14 00:00:00	32020		\N	102050	0	283371005	4155034		0
25869	1536	260139	1919-02-08	1919-02-08 00:00:00	1919-02-22	1919-02-22 00:00:00	32020		\N	102814	0	10509002	260139		0
26001	1542	372328	1966-06-22	1966-06-22 00:00:00	1966-08-03	1966-08-03 00:00:00	32020		\N	103310	0	65363002	372328		0
26146	1551	260139	2001-12-07	2001-12-07 00:00:00	2001-12-21	2001-12-21 00:00:00	32020		\N	103834	0	10509002	260139		0
26339	1563	260139	1976-04-06	1976-04-06 00:00:00	1976-04-13	1976-04-13 00:00:00	32020		\N	104676	0	10509002	260139		0
26430	1568	260139	1977-09-08	1977-09-08 00:00:00	1977-09-15	1977-09-15 00:00:00	32020		\N	105184	0	10509002	260139		0
26639	1577	372328	1926-07-19	1926-07-19 00:00:00	1927-01-28	1927-01-28 00:00:00	32020		\N	105841	0	65363002	372328		0
26829	1588	260139	1984-10-01	1984-10-01 00:00:00	1984-10-15	1984-10-15 00:00:00	32020		\N	106633	0	10509002	260139		0
26971	1597	4048695	1987-10-22	1987-10-22 00:00:00	1987-12-22	1987-12-22 00:00:00	32020		\N	107122	0	15724005	4048695		0
27118	1604	28060	1953-11-30	1953-11-30 00:00:00	1953-12-09	1953-12-09 00:00:00	32020		\N	107623	0	43878008	28060		0
27338	1611	28060	1981-04-10	1981-04-10 00:00:00	1981-04-23	1981-04-23 00:00:00	32020		\N	108276	0	43878008	28060		0
27549	1626	40481087	1973-01-14	1973-01-14 00:00:00	1973-01-28	1973-01-28 00:00:00	32020		\N	109222	0	444814009	40481087		0
27676	1634	4109685	2017-09-10	2017-09-10 00:00:00	2017-09-24	2017-09-24 00:00:00	32020		\N	109692	0	284551006	4109685		0
27885	1646	4156265	1943-09-16	1943-09-16 00:00:00	1943-10-07	1943-10-07 00:00:00	32020		\N	110447	0	370247008	4156265		0
38535	2289	260139	1955-11-01	1955-11-01 00:00:00	1955-11-15	1955-11-15 00:00:00	32020		\N	152260	0	10509002	260139		0
28127	1659	4112343	1992-05-06	1992-05-06 00:00:00	1992-05-13	1992-05-13 00:00:00	32020		\N	111566	0	195662009	4112343		0
28335	1674	260139	1990-06-09	1990-06-09 00:00:00	1990-06-16	1990-06-16 00:00:00	32020		\N	112377	0	10509002	260139		0
28536	1689	4156265	1964-10-23	1964-10-23 00:00:00	1964-11-06	1964-11-06 00:00:00	32020		\N	113089	0	370247008	4156265		0
28584	1691	4027663	1978-07-05	1978-07-05 00:00:00	\N	\N	32020		\N	113287	0	13200003	4027663		0
28852	1709	80180	1978-02-26	1978-02-26 00:00:00	\N	\N	32020		\N	114265	0	396275006	80180		0
28950	1715	4112343	1958-03-19	1958-03-19 00:00:00	1958-03-31	1958-03-31 00:00:00	32020		\N	114520	0	195662009	4112343		0
29130	1724	40481087	1972-09-06	1972-09-06 00:00:00	1972-09-27	1972-09-27 00:00:00	32020		\N	115250	0	444814009	40481087		0
29316	1737	4142905	2000-10-12	2000-10-12 00:00:00	2000-11-11	2000-11-11 00:00:00	32020		\N	115964	0	33737001	4142905		0
29452	1744	40481087	1997-03-08	1997-03-08 00:00:00	1997-03-22	1997-03-22 00:00:00	32020		\N	116615	0	444814009	40481087		0
29618	1752	4146173	1993-12-01	1993-12-01 00:00:00	1993-12-31	1993-12-31 00:00:00	32020		\N	117152	0	307731004	4146173		0
29760	1761	78272	1960-10-12	1960-10-12 00:00:00	1960-11-15	1960-11-15 00:00:00	32020		\N	117718	0	70704007	78272		0
29998	1776	40481087	1920-09-13	1920-09-13 00:00:00	1920-09-27	1920-09-27 00:00:00	32020		\N	118816	0	444814009	40481087		0
30182	1782	4112343	2003-02-03	2003-02-03 00:00:00	2003-02-16	2003-02-16 00:00:00	32020		\N	119325	0	195662009	4112343		0
30303	1789	260139	2014-11-16	2014-11-16 00:00:00	2014-11-30	2014-11-30 00:00:00	32020		\N	119893	0	10509002	260139		0
41032	2439	4218389	1975-05-02	1975-05-02 00:00:00	1975-06-06	1975-06-06 00:00:00	32020		\N	161794	0	39848009	4218389		0
30661	1812	40481087	2012-01-19	2012-01-19 00:00:00	2012-02-09	2012-02-09 00:00:00	32020		\N	121295	0	444814009	40481087		0
30814	1821	78272	1952-12-12	1952-12-12 00:00:00	1953-01-02	1953-01-02 00:00:00	32020		\N	121770	0	70704007	78272		0
30967	1834	40481087	2005-10-07	2005-10-07 00:00:00	2005-10-28	2005-10-28 00:00:00	32020		\N	122515	0	444814009	40481087		0
31146	1844	4266809	2002-10-13	2002-10-13 00:00:00	\N	\N	32020		\N	123168	0	397881000	4266809		0
31294	1850	40481087	1995-06-13	1995-06-13 00:00:00	1995-06-27	1995-06-27 00:00:00	32020		\N	123758	0	444814009	40481087		0
31490	1861	4156265	2000-02-02	2000-02-02 00:00:00	2000-02-23	2000-02-23 00:00:00	32020		\N	124415	0	370247008	4156265		0
31592	1870	4152936	1953-01-25	1953-01-25 00:00:00	1953-02-08	1953-02-08 00:00:00	32020		\N	124946	0	283385000	4152936		0
42337	2522	4310024	1989-10-31	1989-10-31 00:00:00	\N	\N	32020		\N	166856	0	424802006	4310024		0
21352	1281	40481087	2018-01-29	2018-01-29 00:00:00	2018-02-19	2018-02-19 00:00:00	32020		\N	84688	0	444814009	40481087		0
21576	1293	40481087	2006-01-30	2006-01-30 00:00:00	2006-02-06	2006-02-06 00:00:00	32020		\N	85585	0	444814009	40481087		0
21732	1306	4156265	2001-12-20	2001-12-20 00:00:00	2002-01-10	2002-01-10 00:00:00	32020		\N	86203	0	370247008	4156265		0
21905	1314	40481087	1978-06-01	1978-06-01 00:00:00	1978-06-22	1978-06-22 00:00:00	32020		\N	86971	0	444814009	40481087		0
21961	1316	40481087	1958-07-14	1958-07-14 00:00:00	1958-08-04	1958-08-04 00:00:00	32020		\N	87154	0	444814009	40481087		0
22221	1325	378001	2007-01-11	2007-01-11 00:00:00	2007-02-10	2007-02-10 00:00:00	32020		\N	87938	0	62106007	378001		0
22324	1333	4112343	1978-03-26	1978-03-26 00:00:00	1978-04-05	1978-04-05 00:00:00	32020		\N	88453	0	195662009	4112343		0
22507	1345	4112343	2016-12-02	2016-12-02 00:00:00	2016-12-15	2016-12-15 00:00:00	32020		\N	89162	0	195662009	4112343		0
22668	1354	260139	2013-12-06	2013-12-06 00:00:00	2013-12-13	2013-12-13 00:00:00	32020		\N	89765	0	10509002	260139		0
22844	1361	4112343	1981-08-14	1981-08-14 00:00:00	1981-08-25	1981-08-25 00:00:00	32020		\N	90372	0	195662009	4112343		0
22940	1368	40481087	1973-07-05	1973-07-05 00:00:00	1973-07-19	1973-07-19 00:00:00	32020		\N	90662	0	444814009	40481087		0
23124	1381	40481087	1984-06-10	1984-06-10 00:00:00	1984-06-24	1984-06-24 00:00:00	32020		\N	91611	0	444814009	40481087		0
23320	1391	40481087	1938-10-06	1938-10-06 00:00:00	1938-10-13	1938-10-13 00:00:00	32020		\N	92380	0	444814009	40481087		0
23534	1407	40481087	1989-08-07	1989-08-07 00:00:00	1989-08-21	1989-08-21 00:00:00	32020		\N	93536	0	444814009	40481087		0
23660	1411	4294548	1995-04-24	1995-04-24 00:00:00	1995-07-17	1995-07-17 00:00:00	32020		\N	93909	0	75498004	4294548		0
23891	1428	40481087	1981-11-28	1981-11-28 00:00:00	1981-12-19	1981-12-19 00:00:00	32020		\N	95045	0	444814009	40481087		0
23959	1431	40481087	1985-05-25	1985-05-25 00:00:00	1985-06-15	1985-06-15 00:00:00	32020		\N	95316	0	444814009	40481087		0
34696	2060	40481087	1984-09-24	1984-09-24 00:00:00	1984-10-01	1984-10-01 00:00:00	32020		\N	137004	0	444814009	40481087		0
34861	2071	260139	1972-10-08	1972-10-08 00:00:00	1972-10-22	1972-10-22 00:00:00	32020		\N	137821	0	10509002	260139		0
24460	1459	81893	1974-08-29	1974-08-29 00:00:00	\N	\N	32020		\N	97190	0	64766004	81893		0
24605	1468	260139	1989-07-13	1989-07-13 00:00:00	1989-07-20	1989-07-20 00:00:00	32020		\N	97862	0	10509002	260139		0
24855	1482	40481087	2004-04-03	2004-04-03 00:00:00	2004-04-17	2004-04-17 00:00:00	32020		\N	98837	0	444814009	40481087		0
25006	1493	40481087	1960-07-11	1960-07-11 00:00:00	1960-07-18	1960-07-18 00:00:00	32020		\N	99546	0	444814009	40481087		0
25125	1498	40481087	2000-06-12	2000-06-12 00:00:00	2000-07-03	2000-07-03 00:00:00	32020		\N	99938	0	444814009	40481087		0
25282	1508	372328	1925-01-03	1925-01-03 00:00:00	1925-03-10	1925-03-10 00:00:00	32020		\N	100609	0	65363002	372328		0
25522	1518	4152936	1957-03-21	1957-03-21 00:00:00	1957-04-04	1957-04-04 00:00:00	32020		\N	101483	0	283385000	4152936		0
25683	1526	28060	1985-08-05	1985-08-05 00:00:00	1985-08-17	1985-08-17 00:00:00	32020		\N	102082	0	43878008	28060		0
25870	1536	260139	1964-02-03	1964-02-03 00:00:00	1964-02-10	1964-02-10 00:00:00	32020		\N	102793	0	10509002	260139		0
26002	1542	313217	2015-11-25	2015-11-25 00:00:00	\N	\N	32020		\N	103319	0	49436004	313217		0
26147	1551	40481087	1993-06-11	1993-06-11 00:00:00	1993-06-18	1993-06-18 00:00:00	32020		\N	103833	0	444814009	40481087		0
26340	1563	40481087	1998-11-28	1998-11-28 00:00:00	1998-12-19	1998-12-19 00:00:00	32020		\N	104739	0	444814009	40481087		0
26431	1568	372328	1956-10-09	1956-10-09 00:00:00	1957-08-11	1957-08-11 00:00:00	32020		\N	105168	0	65363002	372328		0
26640	1577	80180	1962-03-29	1962-03-29 00:00:00	\N	\N	32020		\N	105867	0	396275006	80180		0
26830	1588	4113008	2018-12-30	2018-12-30 00:00:00	2019-01-13	2019-01-13 00:00:00	32020		\N	106568	0	284549007	4113008		0
26972	1597	4152936	1960-06-10	1960-06-10 00:00:00	1960-06-24	1960-06-24 00:00:00	32020		\N	107118	0	283385000	4152936		0
27119	1604	40479422	1973-04-15	1973-04-15 00:00:00	1973-05-22	1973-05-22 00:00:00	32020		\N	107605	0	444448004	40479422		0
27339	1611	260139	1990-09-07	1990-09-07 00:00:00	1990-09-21	1990-09-21 00:00:00	32020		\N	108337	0	10509002	260139		0
27550	1626	317576	2006-10-29	2006-10-29 00:00:00	\N	\N	32020		\N	109219	0	53741008	317576		0
27677	1634	28060	1948-08-05	1948-08-05 00:00:00	1948-08-18	1948-08-18 00:00:00	32020		\N	109724	0	43878008	28060		0
27886	1646	4112343	1956-03-12	1956-03-12 00:00:00	1956-03-25	1956-03-25 00:00:00	32020		\N	110369	0	195662009	4112343		0
38536	2289	372328	1963-01-19	1963-01-19 00:00:00	1963-12-24	1963-12-24 00:00:00	32020		\N	152235	0	65363002	372328		0
28128	1659	372328	1971-03-07	1971-03-07 00:00:00	1971-06-14	1971-06-14 00:00:00	32020		\N	111502	0	65363002	372328		0
28336	1674	4230399	2008-09-07	2008-09-07 00:00:00	2008-12-06	2008-12-06 00:00:00	32020		\N	112387	0	359817006	4230399		0
28537	1689	260139	1959-10-21	1959-10-21 00:00:00	1959-11-04	1959-11-04 00:00:00	32020		\N	113078	0	10509002	260139		0
28585	1691	4155034	2014-12-08	2014-12-08 00:00:00	2014-12-29	2014-12-29 00:00:00	32020		\N	113254	0	283371005	4155034		0
28853	1709	4149245	1951-10-27	1951-10-27 00:00:00	1951-11-26	1951-11-26 00:00:00	32020		\N	114221	0	30832001	4149245		0
28951	1715	40481087	2018-07-01	2018-07-01 00:00:00	2018-07-08	2018-07-08 00:00:00	32020		\N	114521	0	444814009	40481087		0
29131	1724	80180	1992-11-15	1992-11-15 00:00:00	\N	\N	32020		\N	115313	0	396275006	80180		0
29317	1737	4112343	1918-08-19	1918-08-19 00:00:00	1918-08-27	1918-08-27 00:00:00	32020		\N	116036	0	195662009	4112343		0
29453	1744	260139	1999-08-10	1999-08-10 00:00:00	1999-08-24	1999-08-24 00:00:00	32020		\N	116620	0	10509002	260139		0
29619	1752	4112343	2000-05-01	2000-05-01 00:00:00	2000-05-11	2000-05-11 00:00:00	32020		\N	117121	0	195662009	4112343		0
29761	1761	4112343	1958-06-07	1958-06-07 00:00:00	1958-06-14	1958-06-14 00:00:00	32020		\N	117768	0	195662009	4112343		0
29999	1776	372328	1921-06-27	1921-06-27 00:00:00	1921-10-08	1921-10-08 00:00:00	32020		\N	118790	0	65363002	372328		0
30183	1782	378001	1953-11-20	1953-11-20 00:00:00	1953-12-20	1953-12-20 00:00:00	32020		\N	119338	0	62106007	378001		0
30304	1789	4237458	1991-11-21	1991-11-21 00:00:00	1992-01-20	1992-01-20 00:00:00	32020		\N	119906	0	58150001	4237458		0
41033	2439	372328	1973-05-12	1973-05-12 00:00:00	1973-07-25	1973-07-25 00:00:00	32020		\N	161814	0	65363002	372328		0
30662	1812	40481087	2006-12-03	2006-12-03 00:00:00	2006-12-24	2006-12-24 00:00:00	32020		\N	121258	0	444814009	40481087		0
30815	1821	4112343	1966-05-03	1966-05-03 00:00:00	1966-05-13	1966-05-13 00:00:00	32020		\N	121832	0	195662009	4112343		0
30968	1834	4112343	1998-05-10	1998-05-10 00:00:00	1998-05-19	1998-05-19 00:00:00	32020		\N	122563	0	195662009	4112343		0
31147	1844	4285898	2002-04-16	2002-04-16 00:00:00	\N	\N	32020		\N	123168	0	68496003	4285898		0
31295	1850	4134304	1961-12-23	1961-12-23 00:00:00	1962-02-21	1962-02-21 00:00:00	32020		\N	123732	0	263102004	4134304		0
31491	1861	28060	1990-07-01	1990-07-01 00:00:00	1990-07-10	1990-07-10 00:00:00	32020		\N	124418	0	43878008	28060		0
31593	1870	381316	1961-02-19	1961-02-19 00:00:00	\N	\N	32020		\N	124934	0	230690007	381316		0
42338	2522	30753	1990-11-25	1990-11-25 00:00:00	\N	\N	32020		\N	166856	0	16761005	30753		0
21353	1281	40481087	1987-11-21	1987-11-21 00:00:00	1987-11-28	1987-11-28 00:00:00	32020		\N	84641	0	444814009	40481087		0
21577	1293	4112343	1979-10-22	1979-10-22 00:00:00	1979-10-29	1979-10-29 00:00:00	32020		\N	85547	0	195662009	4112343		0
21733	1306	4112343	1994-05-24	1994-05-24 00:00:00	1994-06-05	1994-06-05 00:00:00	32020		\N	86181	0	195662009	4112343		0
21906	1314	4112343	1982-05-19	1982-05-19 00:00:00	1982-05-30	1982-05-30 00:00:00	32020		\N	87010	0	195662009	4112343		0
21962	1316	4283893	2016-04-23	2016-04-23 00:00:00	2016-06-11	2016-06-11 00:00:00	32020		\N	87184	0	36971009	4283893		0
22222	1325	4112343	1965-09-07	1965-09-07 00:00:00	1965-09-16	1965-09-16 00:00:00	32020		\N	87956	0	195662009	4112343		0
22325	1333	260139	2006-02-08	2006-02-08 00:00:00	2006-02-15	2006-02-15 00:00:00	32020		\N	88447	0	10509002	260139		0
22508	1345	4059173	1977-09-13	1977-09-13 00:00:00	1977-10-13	1977-10-13 00:00:00	32020		\N	89171	0	16114001	4059173		0
22669	1354	40481087	1982-02-19	1982-02-19 00:00:00	1982-03-12	1982-03-12 00:00:00	32020		\N	89756	0	444814009	40481087		0
22845	1361	40481087	1997-05-27	1997-05-27 00:00:00	1997-06-03	1997-06-03 00:00:00	32020		\N	90368	0	444814009	40481087		0
22941	1368	4112343	1965-02-19	1965-02-19 00:00:00	1965-03-03	1965-03-03 00:00:00	32020		\N	90661	0	195662009	4112343		0
23125	1381	40481087	2010-03-27	2010-03-27 00:00:00	2010-04-03	2010-04-03 00:00:00	32020		\N	91587	0	444814009	40481087		0
23321	1391	40481087	1952-11-02	1952-11-02 00:00:00	1952-11-09	1952-11-09 00:00:00	32020		\N	92381	0	444814009	40481087		0
23535	1407	4112343	1998-12-02	1998-12-02 00:00:00	1998-12-13	1998-12-13 00:00:00	32020		\N	93495	0	195662009	4112343		0
23661	1411	40481087	1982-07-04	1982-07-04 00:00:00	1982-07-25	1982-07-25 00:00:00	32020		\N	93918	0	444814009	40481087		0
23892	1428	4283893	1980-06-02	1980-06-02 00:00:00	1980-06-30	1980-06-30 00:00:00	32020		\N	95026	0	36971009	4283893		0
23960	1431	81151	2003-02-16	2003-02-16 00:00:00	2003-03-02	2003-03-02 00:00:00	32020		\N	95253	0	44465007	81151		0
34697	2060	40481087	1973-05-21	1973-05-21 00:00:00	1973-05-28	1973-05-28 00:00:00	32020		\N	137033	0	444814009	40481087		0
34862	2071	372328	1968-04-01	1968-04-01 00:00:00	1968-05-22	1968-05-22 00:00:00	32020		\N	137791	0	65363002	372328		0
24461	1459	4266809	1976-03-21	1976-03-21 00:00:00	\N	\N	32020		\N	97190	0	397881000	4266809		0
24606	1468	260139	1981-06-16	1981-06-16 00:00:00	1981-06-23	1981-06-23 00:00:00	32020		\N	97827	0	10509002	260139		0
24856	1482	260139	1986-09-17	1986-09-17 00:00:00	1986-09-24	1986-09-24 00:00:00	32020		\N	98896	0	10509002	260139		0
25007	1493	4142905	1972-07-03	1972-07-03 00:00:00	1972-09-01	1972-09-01 00:00:00	32020		\N	99575	0	33737001	4142905		0
25126	1498	4112343	1966-04-08	1966-04-08 00:00:00	1966-04-20	1966-04-20 00:00:00	32020		\N	99933	0	195662009	4112343		0
25283	1508	40481087	1979-08-25	1979-08-25 00:00:00	1979-09-01	1979-09-01 00:00:00	32020		\N	100650	0	444814009	40481087		0
25523	1518	81151	2009-12-16	2009-12-16 00:00:00	2010-01-06	2010-01-06 00:00:00	32020		\N	101542	0	44465007	81151		0
25684	1526	40481087	2017-07-28	2017-07-28 00:00:00	2017-08-11	2017-08-11 00:00:00	32020		\N	102040	0	444814009	40481087		0
25871	1536	372328	1912-08-25	1912-08-25 00:00:00	1912-09-08	1912-09-08 00:00:00	32020		\N	102799	0	65363002	372328		0
26003	1542	28060	1984-10-16	1984-10-16 00:00:00	1984-10-29	1984-10-29 00:00:00	32020		\N	103308	0	43878008	28060		0
26148	1551	4113008	1982-10-02	1982-10-02 00:00:00	1982-10-16	1982-10-16 00:00:00	32020		\N	103884	0	284549007	4113008		0
26341	1563	40481087	2000-06-19	2000-06-19 00:00:00	2000-07-10	2000-07-10 00:00:00	32020		\N	104740	0	444814009	40481087		0
26432	1568	260139	1986-01-03	1986-01-03 00:00:00	1986-01-10	1986-01-10 00:00:00	32020		\N	105167	0	10509002	260139		0
26641	1577	4112343	1965-04-19	1965-04-19 00:00:00	1965-04-27	1965-04-27 00:00:00	32020		\N	105860	0	195662009	4112343		0
26831	1588	40481087	1989-11-01	1989-11-01 00:00:00	1989-11-22	1989-11-22 00:00:00	32020		\N	106611	0	444814009	40481087		0
26973	1597	4112343	1973-02-08	1973-02-08 00:00:00	1973-02-15	1973-02-15 00:00:00	32020		\N	107100	0	195662009	4112343		0
27120	1604	4112343	1957-02-24	1957-02-24 00:00:00	1957-03-07	1957-03-07 00:00:00	32020		\N	107624	0	195662009	4112343		0
27340	1611	4112343	2012-05-27	2012-05-27 00:00:00	2012-06-07	2012-06-07 00:00:00	32020		\N	108329	0	195662009	4112343		0
27551	1626	78272	1967-08-30	1967-08-30 00:00:00	1967-09-13	1967-09-13 00:00:00	32020		\N	109187	0	70704007	78272		0
27678	1634	40481087	1948-08-06	1948-08-06 00:00:00	1948-08-13	1948-08-13 00:00:00	32020		\N	109781	0	444814009	40481087		0
27887	1646	260139	2010-12-12	2010-12-12 00:00:00	2010-12-19	2010-12-19 00:00:00	32020		\N	110382	0	10509002	260139		0
38537	2289	4155034	1971-11-18	1971-11-18 00:00:00	1971-12-02	1971-12-02 00:00:00	32020		\N	152251	0	283371005	4155034		0
28129	1659	81151	2011-08-02	2011-08-02 00:00:00	2011-08-16	2011-08-16 00:00:00	32020		\N	111445	0	44465007	81151		0
28337	1674	40481087	1977-09-11	1977-09-11 00:00:00	1977-10-02	1977-10-02 00:00:00	32020		\N	112341	0	444814009	40481087		0
28538	1689	40481087	2001-05-05	2001-05-05 00:00:00	2001-05-26	2001-05-26 00:00:00	32020		\N	113069	0	444814009	40481087		0
28586	1691	4112343	1959-12-27	1959-12-27 00:00:00	1960-01-03	1960-01-03 00:00:00	32020		\N	113258	0	195662009	4112343		0
28854	1709	4001336	1976-05-07	1976-05-07 00:00:00	1976-06-06	1976-06-06 00:00:00	32020		\N	114238	0	110030002	4001336		0
28952	1715	260139	1964-01-15	1964-01-15 00:00:00	1964-01-22	1964-01-22 00:00:00	32020		\N	114561	0	10509002	260139		0
29132	1724	40481087	1959-04-14	1959-04-14 00:00:00	1959-05-05	1959-05-05 00:00:00	32020		\N	115247	0	444814009	40481087		0
29318	1737	80180	1950-07-04	1950-07-04 00:00:00	\N	\N	32020		\N	116050	0	396275006	80180		0
29454	1744	4237458	2010-06-02	2010-06-02 00:00:00	2010-08-01	2010-08-01 00:00:00	32020		\N	116629	0	58150001	4237458		0
29620	1753	4283893	1999-09-07	1999-09-07 00:00:00	1999-09-28	1999-09-28 00:00:00	32020		\N	117205	0	36971009	4283893		0
29762	1761	40481087	1962-12-04	1962-12-04 00:00:00	1962-12-18	1962-12-18 00:00:00	32020		\N	117769	0	444814009	40481087		0
30000	1776	198809	1984-10-13	1984-10-13 00:00:00	1984-10-13	1984-10-13 00:00:00	32020		\N	118804	0	65275009	198809		0
30184	1782	4112343	1956-10-08	1956-10-08 00:00:00	1956-10-21	1956-10-21 00:00:00	32020		\N	119371	0	195662009	4112343		0
30305	1789	4027663	2007-02-19	2007-02-19 00:00:00	\N	\N	32020		\N	119890	0	13200003	4027663		0
41034	2439	4218389	2018-12-06	2018-12-06 00:00:00	2019-01-10	2019-01-10 00:00:00	32020		\N	161797	0	39848009	4218389		0
30663	1812	40481087	2014-09-01	2014-09-01 00:00:00	2014-09-08	2014-09-08 00:00:00	32020		\N	121249	0	444814009	40481087		0
30816	1821	28060	1971-08-17	1971-08-17 00:00:00	1971-08-29	1971-08-29 00:00:00	32020		\N	121810	0	43878008	28060		0
30969	1834	81151	1981-04-05	1981-04-05 00:00:00	1981-05-10	1981-05-10 00:00:00	32020		\N	122542	0	44465007	81151		0
31148	1844	80180	2002-10-13	2002-10-13 00:00:00	\N	\N	32020		\N	123168	0	396275006	80180		0
31296	1850	4027663	1986-12-07	1986-12-07 00:00:00	\N	\N	32020		\N	123788	0	13200003	4027663		0
31492	1861	78272	1993-12-30	1993-12-30 00:00:00	1994-02-03	1994-02-03 00:00:00	32020		\N	124413	0	70704007	78272		0
31594	1870	4112343	1924-10-26	1924-10-26 00:00:00	1924-11-03	1924-11-03 00:00:00	32020		\N	124923	0	195662009	4112343		0
42339	2522	4285898	1990-12-25	1990-12-25 00:00:00	\N	\N	32020		\N	166856	0	68496003	4285898		0
21354	1281	40481087	1970-04-11	1970-04-11 00:00:00	1970-05-02	1970-05-02 00:00:00	32020		\N	84638	0	444814009	40481087		0
21578	1293	257012	1980-01-06	1980-01-06 00:00:00	\N	\N	32020		\N	85610	0	40055000	257012		0
21734	1306	4112343	2014-11-19	2014-11-19 00:00:00	2014-11-29	2014-11-29 00:00:00	32020		\N	86183	0	195662009	4112343		0
21907	1314	375671	1938-01-04	1938-01-04 00:00:00	1938-02-03	1938-02-03 00:00:00	32020		\N	87032	0	62564004	375671		0
21963	1316	260139	2013-04-30	2013-04-30 00:00:00	2013-05-14	2013-05-14 00:00:00	32020		\N	87183	0	10509002	260139		0
22223	1325	4112343	2009-11-14	2009-11-14 00:00:00	2009-11-24	2009-11-24 00:00:00	32020		\N	87962	0	195662009	4112343		0
22326	1333	40481087	1973-10-09	1973-10-09 00:00:00	1973-10-16	1973-10-16 00:00:00	32020		\N	88451	0	444814009	40481087		0
22509	1345	260139	2001-02-10	2001-02-10 00:00:00	2001-02-17	2001-02-17 00:00:00	32020		\N	89161	0	10509002	260139		0
22670	1354	260139	2018-02-22	2018-02-22 00:00:00	2018-03-01	2018-03-01 00:00:00	32020		\N	89766	0	10509002	260139		0
22846	1361	40481087	1973-05-13	1973-05-13 00:00:00	1973-05-27	1973-05-27 00:00:00	32020		\N	90325	0	444814009	40481087		0
22942	1368	372328	1956-04-20	1956-04-20 00:00:00	1956-06-27	1956-06-27 00:00:00	32020		\N	90666	0	65363002	372328		0
23126	1381	4112343	1986-02-22	1986-02-22 00:00:00	1986-03-02	1986-03-02 00:00:00	32020		\N	91604	0	195662009	4112343		0
23322	1391	40481087	1947-04-02	1947-04-02 00:00:00	1947-04-09	1947-04-09 00:00:00	32020		\N	92320	0	444814009	40481087		0
23536	1407	4237458	1989-03-05	1989-03-05 00:00:00	1989-04-04	1989-04-04 00:00:00	32020		\N	93565	0	58150001	4237458		0
23662	1411	4112343	1999-02-12	1999-02-12 00:00:00	1999-02-24	1999-02-24 00:00:00	32020		\N	93969	0	195662009	4112343		0
23893	1428	4112343	2006-07-24	2006-07-24 00:00:00	2006-08-01	2006-08-01 00:00:00	32020		\N	94996	0	195662009	4112343		0
23961	1431	80180	1989-01-09	1989-01-09 00:00:00	\N	\N	32020		\N	95211	0	396275006	80180		0
34698	2060	4112343	1996-09-07	1996-09-07 00:00:00	1996-09-15	1996-09-15 00:00:00	32020		\N	137010	0	195662009	4112343		0
34863	2071	4134304	1973-03-06	1973-03-06 00:00:00	1973-05-05	1973-05-05 00:00:00	32020		\N	137801	0	263102004	4134304		0
24462	1459	80180	1976-03-21	1976-03-21 00:00:00	\N	\N	32020		\N	97190	0	396275006	80180		0
24607	1468	40481087	1981-12-25	1981-12-25 00:00:00	1982-01-15	1982-01-15 00:00:00	32020		\N	97860	0	444814009	40481087		0
24881	1486	4112343	1971-07-31	1971-07-31 00:00:00	1971-08-08	1971-08-08 00:00:00	32020		\N	99134	0	195662009	4112343		0
25008	1493	260139	2007-04-18	2007-04-18 00:00:00	2007-04-25	2007-04-25 00:00:00	32020		\N	99555	0	10509002	260139		0
25127	1498	4112343	1974-04-11	1974-04-11 00:00:00	1974-04-18	1974-04-18 00:00:00	32020		\N	99934	0	195662009	4112343		0
25284	1508	81151	2011-09-17	2011-09-17 00:00:00	2011-10-22	2011-10-22 00:00:00	32020		\N	100549	0	44465007	81151		0
25524	1518	4155034	1968-06-03	1968-06-03 00:00:00	1968-06-24	1968-06-24 00:00:00	32020		\N	101486	0	283371005	4155034		0
25685	1526	28060	1979-09-23	1979-09-23 00:00:00	1979-10-03	1979-10-03 00:00:00	32020		\N	102078	0	43878008	28060		0
25872	1536	40481087	1913-01-27	1913-01-27 00:00:00	1913-02-03	1913-02-03 00:00:00	32020		\N	102791	0	444814009	40481087		0
26004	1542	4112343	2003-04-12	2003-04-12 00:00:00	2003-04-21	2003-04-21 00:00:00	32020		\N	103322	0	195662009	4112343		0
26149	1551	4142905	1979-08-19	1979-08-19 00:00:00	1979-11-17	1979-11-17 00:00:00	32020		\N	103883	0	33737001	4142905		0
26342	1563	372328	1959-01-09	1959-01-09 00:00:00	1959-05-30	1959-05-30 00:00:00	32020		\N	104719	0	65363002	372328		0
26433	1568	40481087	1975-02-09	1975-02-09 00:00:00	1975-02-16	1975-02-16 00:00:00	32020		\N	105183	0	444814009	40481087		0
26642	1577	28060	2006-06-02	2006-06-02 00:00:00	2006-06-11	2006-06-11 00:00:00	32020		\N	105940	0	43878008	28060		0
26832	1588	260139	2015-07-05	2015-07-05 00:00:00	2015-07-12	2015-07-12 00:00:00	32020		\N	106618	0	10509002	260139		0
26974	1597	81151	1949-05-04	1949-05-04 00:00:00	1949-05-18	1949-05-18 00:00:00	32020		\N	107115	0	44465007	81151		0
27121	1604	81151	1977-04-01	1977-04-01 00:00:00	1977-05-06	1977-05-06 00:00:00	32020		\N	107606	0	44465007	81151		0
27341	1611	4294548	2002-10-06	2002-10-06 00:00:00	2002-10-27	2002-10-27 00:00:00	32020		\N	108338	0	75498004	4294548		0
27552	1626	4112343	1948-08-21	1948-08-21 00:00:00	1948-08-28	1948-08-28 00:00:00	32020		\N	109259	0	195662009	4112343		0
27679	1634	260139	2006-07-07	2006-07-07 00:00:00	2006-07-21	2006-07-21 00:00:00	32020		\N	109730	0	10509002	260139		0
27888	1646	372328	2017-12-31	2017-12-31 00:00:00	2018-01-27	2018-01-27 00:00:00	32020		\N	110431	0	65363002	372328		0
38539	2289	4029498	1958-10-30	1958-10-30 00:00:00	\N	\N	32020		\N	152263	0	128613002	4029498		0
28142	1661	4112343	1994-08-28	1994-08-28 00:00:00	1994-09-06	1994-09-06 00:00:00	32020		\N	111692	0	195662009	4112343		0
28338	1674	81893	2010-05-01	2010-05-01 00:00:00	\N	\N	32020		\N	112350	0	64766004	81893		0
28539	1689	4112343	2000-11-28	2000-11-28 00:00:00	2000-12-08	2000-12-08 00:00:00	32020		\N	113068	0	195662009	4112343		0
28587	1691	80180	1985-07-23	1985-07-23 00:00:00	\N	\N	32020		\N	113247	0	396275006	80180		0
28855	1709	4218389	1948-10-14	1948-10-14 00:00:00	1948-11-11	1948-11-11 00:00:00	32020		\N	114219	0	39848009	4218389		0
28953	1715	260139	2019-06-27	2019-06-27 00:00:00	\N	\N	32020		\N	114547	0	10509002	260139		0
29133	1724	4112343	1952-08-29	1952-08-29 00:00:00	1952-09-08	1952-09-08 00:00:00	32020		\N	115246	0	195662009	4112343		0
29319	1737	381316	2013-10-11	2013-10-11 00:00:00	\N	\N	32020		\N	116083	0	230690007	381316		0
29455	1744	4237458	1981-09-27	1981-09-27 00:00:00	1981-10-27	1981-10-27 00:00:00	32020		\N	116626	0	58150001	4237458		0
29621	1753	4310024	2000-05-28	2000-05-28 00:00:00	\N	\N	32020		\N	117205	0	424802006	4310024		0
29763	1761	81151	2019-04-16	2019-04-16 00:00:00	2019-05-21	2019-05-21 00:00:00	32020		\N	117723	0	44465007	81151		0
30001	1776	196456	1984-10-13	1984-10-13 00:00:00	1984-10-13	1984-10-13 00:00:00	32020		\N	118804	0	235919008	196456		0
30185	1783	4084167	1974-06-14	1974-06-14 00:00:00	1974-06-14	1974-06-14 00:00:00	32020		\N	119439	0	241929008	4084167		0
30306	1789	81893	2016-05-12	2016-05-12 00:00:00	\N	\N	32020		\N	119932	0	64766004	81893		0
41035	2439	81151	1989-10-25	1989-10-25 00:00:00	1989-11-08	1989-11-08 00:00:00	32020		\N	161796	0	44465007	81151		0
30664	1812	28060	1971-03-04	1971-03-04 00:00:00	1971-03-13	1971-03-13 00:00:00	32020		\N	121254	0	43878008	28060		0
30817	1821	192671	1982-11-03	1982-11-03 00:00:00	\N	\N	32020		\N	121820	0	K92.2	35208414		0
30970	1834	4112343	1989-06-13	1989-06-13 00:00:00	1989-06-23	1989-06-23 00:00:00	32020		\N	122561	0	195662009	4112343		0
31149	1844	40481087	1963-06-24	1963-06-24 00:00:00	1963-07-08	1963-07-08 00:00:00	32020		\N	123220	0	444814009	40481087		0
31297	1850	260139	1979-10-05	1979-10-05 00:00:00	1979-10-19	1979-10-19 00:00:00	32020		\N	123754	0	10509002	260139		0
31493	1861	378001	1988-08-28	1988-08-28 00:00:00	1988-10-27	1988-10-27 00:00:00	32020		\N	124411	0	62106007	378001		0
31595	1870	260139	1943-01-15	1943-01-15 00:00:00	1943-01-30	1943-01-30 00:00:00	32020		\N	124966	0	10509002	260139		0
42340	2522	80180	1991-01-24	1991-01-24 00:00:00	\N	\N	32020		\N	166856	0	396275006	80180		0
21355	1281	40481087	1985-02-04	1985-02-04 00:00:00	1985-02-25	1985-02-25 00:00:00	32020		\N	84695	0	444814009	40481087		0
21579	1293	4278672	2016-09-12	2016-09-12 00:00:00	2016-12-11	2016-12-11 00:00:00	32020		\N	85594	0	65966004	4278672		0
21735	1306	378001	2017-04-21	2017-04-21 00:00:00	2017-05-21	2017-05-21 00:00:00	32020		\N	86204	0	62106007	378001		0
21908	1314	78272	1955-04-06	1955-04-06 00:00:00	1955-05-04	1955-05-04 00:00:00	32020		\N	87034	0	70704007	78272		0
21964	1316	260139	1998-03-22	1998-03-22 00:00:00	1998-03-29	1998-03-29 00:00:00	32020		\N	87228	0	10509002	260139		0
22224	1325	40481087	2009-08-26	2009-08-26 00:00:00	2009-09-02	2009-09-02 00:00:00	32020		\N	87960	0	444814009	40481087		0
22327	1333	40481087	1980-12-03	1980-12-03 00:00:00	1980-12-24	1980-12-24 00:00:00	32020		\N	88455	0	444814009	40481087		0
22510	1345	260139	2015-03-15	2015-03-15 00:00:00	2015-03-29	2015-03-29 00:00:00	32020		\N	89168	0	10509002	260139		0
22671	1354	4112343	2000-11-17	2000-11-17 00:00:00	2000-11-24	2000-11-24 00:00:00	32020		\N	89767	0	195662009	4112343		0
22847	1361	4112343	1994-12-18	1994-12-18 00:00:00	1994-12-25	1994-12-25 00:00:00	32020		\N	90327	0	195662009	4112343		0
22943	1368	4113008	1958-04-10	1958-04-10 00:00:00	1958-04-24	1958-04-24 00:00:00	32020		\N	90715	0	284549007	4113008		0
23127	1381	4142905	1983-12-04	1983-12-04 00:00:00	1984-02-02	1984-02-02 00:00:00	32020		\N	91564	0	33737001	4142905		0
23323	1391	4283893	1940-10-10	1940-10-10 00:00:00	1940-11-28	1940-11-28 00:00:00	32020		\N	92319	0	36971009	4283893		0
23537	1407	372328	1973-11-09	1973-11-09 00:00:00	1974-11-02	1974-11-02 00:00:00	32020		\N	93487	0	65363002	372328		0
23663	1411	40481087	1979-05-27	1979-05-27 00:00:00	1979-06-17	1979-06-17 00:00:00	32020		\N	93965	0	444814009	40481087		0
23894	1428	40481087	1977-12-25	1977-12-25 00:00:00	1978-01-08	1978-01-08 00:00:00	32020		\N	95011	0	444814009	40481087		0
23962	1431	4294548	1988-07-04	1988-07-04 00:00:00	1988-09-12	1988-09-12 00:00:00	32020		\N	95211	0	75498004	4294548		0
34699	2060	260139	1969-07-15	1969-07-15 00:00:00	1969-07-22	1969-07-22 00:00:00	32020		\N	136996	0	10509002	260139		0
34864	2071	260139	1993-04-22	1993-04-22 00:00:00	1993-04-29	1993-04-29 00:00:00	32020		\N	137790	0	10509002	260139		0
24463	1459	30753	1975-02-25	1975-02-25 00:00:00	\N	\N	32020		\N	97190	0	16761005	30753		0
24608	1468	4116491	1998-06-03	1998-06-03 00:00:00	1998-07-14	1998-07-14 00:00:00	32020		\N	97811	0	301011002	4116491		0
24882	1486	133834	1960-02-21	1960-02-21 00:00:00	1973-04-13	1973-04-13 00:00:00	32020		\N	99141	0	24079001	133834		0
25009	1493	40481087	1964-09-03	1964-09-03 00:00:00	1964-09-17	1964-09-17 00:00:00	32020		\N	99562	0	444814009	40481087		0
25128	1498	260139	2008-09-11	2008-09-11 00:00:00	2008-09-18	2008-09-18 00:00:00	32020		\N	99960	0	10509002	260139		0
25285	1508	40481087	2001-03-21	2001-03-21 00:00:00	2001-04-04	2001-04-04 00:00:00	32020		\N	100575	0	444814009	40481087		0
25525	1518	40481087	1997-11-07	1997-11-07 00:00:00	1997-11-21	1997-11-21 00:00:00	32020		\N	101531	0	444814009	40481087		0
25686	1526	28060	2018-12-03	2018-12-03 00:00:00	2018-12-14	2018-12-14 00:00:00	32020		\N	102085	0	43878008	28060		0
25873	1536	28060	1968-10-29	1968-10-29 00:00:00	1968-11-09	1968-11-09 00:00:00	32020		\N	102779	0	43878008	28060		0
26005	1542	378001	1990-11-27	1990-11-27 00:00:00	1991-01-26	1991-01-26 00:00:00	32020		\N	103304	0	62106007	378001		0
26150	1551	40481087	1983-10-17	1983-10-17 00:00:00	1983-11-07	1983-11-07 00:00:00	32020		\N	103866	0	444814009	40481087		0
26343	1563	260139	1971-06-06	1971-06-06 00:00:00	1971-06-20	1971-06-20 00:00:00	32020		\N	104702	0	10509002	260139		0
26434	1568	4237458	1967-07-28	1967-07-28 00:00:00	1967-10-26	1967-10-26 00:00:00	32020		\N	105165	0	58150001	4237458		0
26643	1578	80180	1986-05-16	1986-05-16 00:00:00	\N	\N	32020		\N	106008	0	396275006	80180		0
26833	1588	40481087	1972-01-19	1972-01-19 00:00:00	1972-02-09	1972-02-09 00:00:00	32020		\N	106641	0	444814009	40481087		0
26975	1597	4283893	2010-10-18	2010-10-18 00:00:00	2011-02-21	2011-02-21 00:00:00	32020		\N	107104	0	36971009	4283893		0
27122	1604	40481087	1962-06-19	1962-06-19 00:00:00	1962-07-03	1962-07-03 00:00:00	32020		\N	107626	0	444814009	40481087		0
27342	1611	372328	1955-07-23	1955-07-23 00:00:00	1955-11-13	1955-11-13 00:00:00	32020		\N	108320	0	65363002	372328		0
27553	1626	40481087	1977-07-04	1977-07-04 00:00:00	1977-07-25	1977-07-25 00:00:00	32020		\N	109223	0	444814009	40481087		0
27680	1634	81151	1971-02-18	1971-02-18 00:00:00	1971-03-11	1971-03-11 00:00:00	32020		\N	109688	0	44465007	81151		0
38347	2277	40481087	1965-11-12	1965-11-12 00:00:00	1965-11-19	1965-11-19 00:00:00	32020		\N	151350	0	444814009	40481087		0
38540	2289	40481087	1994-01-24	1994-01-24 00:00:00	1994-02-07	1994-02-07 00:00:00	32020		\N	152218	0	444814009	40481087		0
28143	1661	80180	1995-02-05	1995-02-05 00:00:00	\N	\N	32020		\N	111692	0	396275006	80180		0
28339	1674	30753	2010-11-27	2010-11-27 00:00:00	\N	\N	32020		\N	112350	0	16761005	30753		0
28540	1689	4112343	1963-02-07	1963-02-07 00:00:00	1963-02-20	1963-02-20 00:00:00	32020		\N	113079	0	195662009	4112343		0
28588	1691	30753	1984-07-28	1984-07-28 00:00:00	\N	\N	32020		\N	113247	0	16761005	30753		0
28856	1709	4112343	1955-09-05	1955-09-05 00:00:00	1955-09-16	1955-09-16 00:00:00	32020		\N	114263	0	195662009	4112343		0
28954	1715	4112343	1960-04-21	1960-04-21 00:00:00	1960-04-30	1960-04-30 00:00:00	32020		\N	114566	0	195662009	4112343		0
29134	1724	40481087	1954-05-28	1954-05-28 00:00:00	1954-06-04	1954-06-04 00:00:00	32020		\N	115297	0	444814009	40481087		0
29320	1737	28060	1922-12-08	1922-12-08 00:00:00	1922-12-20	1922-12-20 00:00:00	32020		\N	115976	0	43878008	28060		0
29456	1744	260139	1980-05-06	1980-05-06 00:00:00	1980-05-13	1980-05-13 00:00:00	32020		\N	116611	0	10509002	260139		0
29622	1753	40481087	1970-07-26	1970-07-26 00:00:00	1970-08-09	1970-08-09 00:00:00	32020		\N	117271	0	444814009	40481087		0
29764	1761	40481087	2001-04-22	2001-04-22 00:00:00	2001-05-13	2001-05-13 00:00:00	32020		\N	117744	0	444814009	40481087		0
30002	1776	260139	1947-12-17	1947-12-17 00:00:00	1947-12-24	1947-12-24 00:00:00	32020		\N	118778	0	10509002	260139		0
30186	1783	4112343	1982-10-01	1982-10-01 00:00:00	1982-10-10	1982-10-10 00:00:00	32020		\N	119425	0	195662009	4112343		0
30307	1789	4285898	2016-11-08	2016-11-08 00:00:00	\N	\N	32020		\N	119932	0	68496003	4285898		0
41036	2439	40481087	1993-12-30	1993-12-30 00:00:00	1994-01-06	1994-01-06 00:00:00	32020		\N	161809	0	444814009	40481087		0
30665	1812	260139	1984-06-12	1984-06-12 00:00:00	1984-06-19	1984-06-19 00:00:00	32020		\N	121255	0	10509002	260139		0
30818	1821	4112343	1959-10-13	1959-10-13 00:00:00	1959-10-23	1959-10-23 00:00:00	32020		\N	121817	0	195662009	4112343		0
30971	1834	260139	1988-12-08	1988-12-08 00:00:00	1988-12-22	1988-12-22 00:00:00	32020		\N	122560	0	10509002	260139		0
31150	1844	40481087	2009-06-14	2009-06-14 00:00:00	2009-06-28	2009-06-28 00:00:00	32020		\N	123205	0	444814009	40481087		0
31298	1850	4113008	1976-09-26	1976-09-26 00:00:00	1976-10-17	1976-10-17 00:00:00	32020		\N	123734	0	284549007	4113008		0
31494	1861	378001	1990-09-17	1990-09-17 00:00:00	1990-11-16	1990-11-16 00:00:00	32020		\N	124412	0	62106007	378001		0
31596	1870	195588	1957-04-09	1957-04-09 00:00:00	1957-05-15	1957-05-15 00:00:00	32020		\N	124935	0	38822007	195588		0
42341	2522	4112343	1997-04-26	1997-04-26 00:00:00	1997-05-09	1997-05-09 00:00:00	32020		\N	166820	0	195662009	4112343		0
21356	1281	260139	1997-11-30	1997-11-30 00:00:00	1997-12-07	1997-12-07 00:00:00	32020		\N	84687	0	10509002	260139		0
21580	1293	4112343	1981-01-22	1981-01-22 00:00:00	1981-02-04	1981-02-04 00:00:00	32020		\N	85578	0	195662009	4112343		0
21736	1306	372328	1961-08-12	1961-08-12 00:00:00	1962-06-13	1962-06-13 00:00:00	32020		\N	86197	0	65363002	372328		0
21909	1314	4283893	2013-09-08	2013-09-08 00:00:00	2013-09-22	2013-09-22 00:00:00	32020		\N	87052	0	36971009	4283893		0
21965	1316	4027663	1982-10-18	1982-10-18 00:00:00	\N	\N	32020		\N	87175	0	13200003	4027663		0
22225	1325	40481087	1982-08-22	1982-08-22 00:00:00	1982-08-29	1982-08-29 00:00:00	32020		\N	87936	0	444814009	40481087		0
22328	1333	4218389	1981-07-18	1981-07-18 00:00:00	1981-08-22	1981-08-22 00:00:00	32020		\N	88415	0	39848009	4218389		0
22511	1345	40481087	1977-08-13	1977-08-13 00:00:00	1977-08-20	1977-08-20 00:00:00	32020		\N	89123	0	444814009	40481087		0
22672	1354	40481087	2009-11-23	2009-11-23 00:00:00	2009-11-30	2009-11-30 00:00:00	32020		\N	89728	0	444814009	40481087		0
22848	1361	260139	1980-09-30	1980-09-30 00:00:00	1980-10-14	1980-10-14 00:00:00	32020		\N	90371	0	10509002	260139		0
22944	1368	381316	2019-06-26	2019-06-26 00:00:00	\N	\N	32020		\N	90677	0	230690007	381316		0
23128	1381	372328	1982-07-12	1982-07-12 00:00:00	1983-05-14	1983-05-14 00:00:00	32020		\N	91585	0	65363002	372328		0
23324	1391	40481087	1989-12-21	1989-12-21 00:00:00	1990-01-04	1990-01-04 00:00:00	32020		\N	92400	0	444814009	40481087		0
23538	1407	40481087	2009-09-17	2009-09-17 00:00:00	2009-10-08	2009-10-08 00:00:00	32020		\N	93458	0	444814009	40481087		0
23664	1411	4112343	1978-12-11	1978-12-11 00:00:00	1978-12-19	1978-12-19 00:00:00	32020		\N	93964	0	195662009	4112343		0
23895	1428	4112343	2004-03-23	2004-03-23 00:00:00	2004-04-02	2004-04-02 00:00:00	32020		\N	95012	0	195662009	4112343		0
23963	1431	4152936	1956-01-28	1956-01-28 00:00:00	1956-02-18	1956-02-18 00:00:00	32020		\N	95249	0	283385000	4152936		0
34700	2060	260139	2008-06-29	2008-06-29 00:00:00	2008-07-13	2008-07-13 00:00:00	32020		\N	136978	0	10509002	260139		0
34865	2071	40481087	1986-09-03	1986-09-03 00:00:00	1986-09-17	1986-09-17 00:00:00	32020		\N	137841	0	444814009	40481087		0
24464	1459	4112343	2015-06-11	2015-06-11 00:00:00	2015-06-19	2015-06-19 00:00:00	32020		\N	97219	0	195662009	4112343		0
24609	1468	28060	1956-02-13	1956-02-13 00:00:00	1956-02-23	1956-02-23 00:00:00	32020		\N	97850	0	43878008	28060		0
24883	1486	257012	1982-04-15	1982-04-15 00:00:00	\N	\N	32020		\N	99136	0	40055000	257012		0
25010	1493	260139	2003-12-28	2003-12-28 00:00:00	2004-01-11	2004-01-11 00:00:00	32020		\N	99537	0	10509002	260139		0
25129	1498	40481087	1978-04-01	1978-04-01 00:00:00	1978-04-15	1978-04-15 00:00:00	32020		\N	99935	0	444814009	40481087		0
25286	1508	40481087	1980-07-04	1980-07-04 00:00:00	1980-07-18	1980-07-18 00:00:00	32020		\N	100573	0	444814009	40481087		0
25526	1518	40481087	1972-08-20	1972-08-20 00:00:00	1972-08-27	1972-08-27 00:00:00	32020		\N	101535	0	444814009	40481087		0
25687	1526	40481087	1983-06-25	1983-06-25 00:00:00	1983-07-16	1983-07-16 00:00:00	32020		\N	102039	0	444814009	40481087		0
25874	1536	261325	1966-02-20	1966-02-20 00:00:00	\N	\N	32020		\N	102775	0	87433001	261325		0
26006	1542	4112343	1992-03-24	1992-03-24 00:00:00	1992-04-06	1992-04-06 00:00:00	32020		\N	103321	0	195662009	4112343		0
26151	1551	4112343	2019-01-02	2019-01-02 00:00:00	2019-01-12	2019-01-12 00:00:00	32020		\N	103829	0	195662009	4112343		0
26344	1563	4112343	1958-06-17	1958-06-17 00:00:00	1958-06-28	1958-06-28 00:00:00	32020		\N	104664	0	195662009	4112343		0
26435	1568	81151	2017-12-07	2017-12-07 00:00:00	2017-12-28	2017-12-28 00:00:00	32020		\N	105225	0	44465007	81151		0
26644	1578	28060	1998-05-30	1998-05-30 00:00:00	1998-06-11	1998-06-11 00:00:00	32020		\N	105991	0	43878008	28060		0
26834	1588	40481087	2010-07-20	2010-07-20 00:00:00	2010-07-27	2010-07-27 00:00:00	32020		\N	106612	0	444814009	40481087		0
26976	1597	28060	1959-02-26	1959-02-26 00:00:00	1959-03-10	1959-03-10 00:00:00	32020		\N	107099	0	43878008	28060		0
27123	1604	40481087	1990-02-25	1990-02-25 00:00:00	1990-03-11	1990-03-11 00:00:00	32020		\N	107615	0	444814009	40481087		0
27343	1611	80180	1997-10-10	1997-10-10 00:00:00	\N	\N	32020		\N	108336	0	396275006	80180		0
27554	1626	372328	1937-07-30	1937-07-30 00:00:00	1937-12-05	1937-12-05 00:00:00	32020		\N	109280	0	65363002	372328		0
27681	1634	381316	2009-07-03	2009-07-03 00:00:00	\N	\N	32020		\N	109765	0	230690007	381316		0
38348	2277	81151	1987-07-12	1987-07-12 00:00:00	1987-08-02	1987-08-02 00:00:00	32020		\N	151385	0	44465007	81151		0
38541	2289	4283893	2010-03-11	2010-03-11 00:00:00	2010-04-29	2010-04-29 00:00:00	32020		\N	152219	0	36971009	4283893		0
28144	1661	4112343	2008-05-29	2008-05-29 00:00:00	2008-06-10	2008-06-10 00:00:00	32020		\N	111639	0	195662009	4112343		0
28340	1674	4310024	2010-01-01	2010-01-01 00:00:00	\N	\N	32020		\N	112350	0	424802006	4310024		0
28541	1689	40481087	1993-01-02	1993-01-02 00:00:00	1993-01-09	1993-01-09 00:00:00	32020		\N	113122	0	444814009	40481087		0
28589	1691	4266809	1985-07-23	1985-07-23 00:00:00	\N	\N	32020		\N	113247	0	397881000	4266809		0
28857	1709	4296204	2004-04-08	2004-04-08 00:00:00	2004-05-06	2004-05-06 00:00:00	32020		\N	114241	0	403190006	4296204		0
28955	1715	40481087	2010-07-17	2010-07-17 00:00:00	2010-08-07	2010-08-07 00:00:00	32020		\N	114538	0	444814009	40481087		0
29135	1724	4294548	2009-06-06	2009-06-06 00:00:00	2010-04-10	2010-04-10 00:00:00	32020		\N	115301	0	75498004	4294548		0
29321	1737	81151	1952-12-20	1952-12-20 00:00:00	1953-01-17	1953-01-17 00:00:00	32020		\N	115961	0	44465007	81151		0
29457	1744	28060	1994-05-24	1994-05-24 00:00:00	1994-06-05	1994-06-05 00:00:00	32020		\N	116613	0	43878008	28060		0
29623	1753	40481087	1985-01-13	1985-01-13 00:00:00	1985-01-20	1985-01-20 00:00:00	32020		\N	117274	0	444814009	40481087		0
29765	1761	40481087	1989-07-20	1989-07-20 00:00:00	1989-07-27	1989-07-27 00:00:00	32020		\N	117708	0	444814009	40481087		0
30003	1776	4112343	1964-08-26	1964-08-26 00:00:00	1964-09-08	1964-09-08 00:00:00	32020		\N	118864	0	195662009	4112343		0
30187	1783	260139	1981-03-15	1981-03-15 00:00:00	1981-03-22	1981-03-22 00:00:00	32020		\N	119381	0	10509002	260139		0
30308	1789	30753	2016-10-09	2016-10-09 00:00:00	\N	\N	32020		\N	119932	0	16761005	30753		0
41037	2439	260139	2008-05-18	2008-05-18 00:00:00	2008-06-01	2008-06-01 00:00:00	32020		\N	161785	0	10509002	260139		0
30666	1812	40481087	1968-04-21	1968-04-21 00:00:00	1968-05-05	1968-05-05 00:00:00	32020		\N	121292	0	444814009	40481087		0
30850	1826	40481087	2016-12-11	2016-12-11 00:00:00	2016-12-18	2016-12-18 00:00:00	32020		\N	122019	0	444814009	40481087		0
30972	1834	260139	1993-12-09	1993-12-09 00:00:00	1993-12-23	1993-12-23 00:00:00	32020		\N	122562	0	10509002	260139		0
31151	1844	30753	2001-08-19	2001-08-19 00:00:00	\N	\N	32020		\N	123140	0	16761005	30753		0
31299	1850	28060	1969-05-14	1969-05-14 00:00:00	1969-05-24	1969-05-24 00:00:00	32020		\N	123724	0	43878008	28060		0
23131	1381	4285898	2018-08-12	2018-08-12 00:00:00	\N	\N	32020		\N	91589	0	68496003	4285898		0
31495	1861	372328	1982-03-28	1982-03-28 00:00:00	1982-05-08	1982-05-08 00:00:00	32020		\N	124426	0	65363002	372328		0
31597	1870	80180	1957-05-29	1957-05-29 00:00:00	\N	\N	32020		\N	124935	0	396275006	80180		0
42342	2522	260139	1970-06-23	1970-06-23 00:00:00	1970-06-30	1970-06-30 00:00:00	32020		\N	166799	0	10509002	260139		0
21357	1281	4112343	1989-03-27	1989-03-27 00:00:00	1989-04-06	1989-04-06 00:00:00	32020		\N	84642	0	195662009	4112343		0
32040	1903	4112343	2018-05-19	2018-05-19 00:00:00	2018-05-31	2018-05-31 00:00:00	32020		\N	126680	0	195662009	4112343		0
21737	1306	378001	1986-03-14	1986-03-14 00:00:00	1986-05-13	1986-05-13 00:00:00	32020		\N	86202	0	62106007	378001		0
21910	1314	80180	1966-08-25	1966-08-25 00:00:00	\N	\N	32020		\N	87047	0	396275006	80180		0
21966	1316	81151	2013-03-13	2013-03-13 00:00:00	2013-03-27	2013-03-27 00:00:00	32020		\N	87223	0	44465007	81151		0
22226	1325	4112343	1999-12-07	1999-12-07 00:00:00	1999-12-20	1999-12-20 00:00:00	32020		\N	87985	0	195662009	4112343		0
22329	1333	40481087	1965-07-30	1965-07-30 00:00:00	1965-08-13	1965-08-13 00:00:00	32020		\N	88419	0	444814009	40481087		0
22512	1345	372328	1967-11-05	1967-11-05 00:00:00	1968-02-20	1968-02-20 00:00:00	32020		\N	89169	0	65363002	372328		0
22673	1354	4152936	1980-01-27	1980-01-27 00:00:00	1980-02-17	1980-02-17 00:00:00	32020		\N	89760	0	283385000	4152936		0
22849	1361	372328	1978-10-13	1978-10-13 00:00:00	1979-09-10	1979-09-10 00:00:00	32020		\N	90378	0	65363002	372328		0
22945	1368	372328	1956-10-25	1956-10-25 00:00:00	1956-11-28	1956-11-28 00:00:00	32020		\N	90737	0	65363002	372328		0
23129	1381	4278672	1993-11-11	1993-11-11 00:00:00	1994-02-09	1994-02-09 00:00:00	32020		\N	91565	0	65966004	4278672		0
23325	1391	4112343	1969-11-17	1969-11-17 00:00:00	1969-11-29	1969-11-29 00:00:00	32020		\N	92384	0	195662009	4112343		0
23539	1407	4146173	1985-08-02	1985-08-02 00:00:00	1985-09-01	1985-09-01 00:00:00	32020		\N	93581	0	307731004	4146173		0
23665	1411	196456	1999-11-23	1999-11-23 00:00:00	1999-11-23	1999-11-23 00:00:00	32020		\N	93967	0	235919008	196456		0
23896	1428	372328	1950-04-23	1950-04-23 00:00:00	1950-08-09	1950-08-09 00:00:00	32020		\N	95049	0	65363002	372328		0
23964	1431	260139	2003-03-14	2003-03-14 00:00:00	2003-03-21	2003-03-21 00:00:00	32020		\N	95305	0	10509002	260139		0
34701	2060	40481087	1999-01-26	1999-01-26 00:00:00	1999-02-16	1999-02-16 00:00:00	32020		\N	137011	0	444814009	40481087		0
34866	2071	4134304	1977-02-13	1977-02-13 00:00:00	1977-03-15	1977-03-15 00:00:00	32020		\N	137802	0	263102004	4134304		0
24465	1459	4283893	2002-12-06	2002-12-06 00:00:00	2003-02-07	2003-02-07 00:00:00	32020		\N	97194	0	36971009	4283893		0
24610	1468	78272	1989-06-18	1989-06-18 00:00:00	1989-07-23	1989-07-23 00:00:00	32020		\N	97875	0	70704007	78272		0
24884	1486	260139	2001-03-11	2001-03-11 00:00:00	2001-03-18	2001-03-18 00:00:00	32020		\N	99055	0	10509002	260139		0
25011	1493	40481087	1990-11-20	1990-11-20 00:00:00	1990-12-04	1990-12-04 00:00:00	32020		\N	99564	0	444814009	40481087		0
25130	1498	378001	1990-09-27	1990-09-27 00:00:00	1990-10-27	1990-10-27 00:00:00	32020		\N	99942	0	62106007	378001		0
25287	1508	4112343	1976-06-09	1976-06-09 00:00:00	1976-06-20	1976-06-20 00:00:00	32020		\N	100653	0	195662009	4112343		0
25527	1518	4112343	1994-03-12	1994-03-12 00:00:00	1994-03-24	1994-03-24 00:00:00	32020		\N	101538	0	195662009	4112343		0
25688	1526	40481087	1977-05-09	1977-05-09 00:00:00	1977-05-23	1977-05-23 00:00:00	32020		\N	102075	0	444814009	40481087		0
25875	1536	28060	1915-04-14	1915-04-14 00:00:00	1915-04-22	1915-04-22 00:00:00	32020		\N	102792	0	43878008	28060		0
26007	1542	260139	2016-10-19	2016-10-19 00:00:00	2016-11-02	2016-11-02 00:00:00	32020		\N	103331	0	10509002	260139		0
26167	1553	40481087	2002-06-12	2002-06-12 00:00:00	2002-07-03	2002-07-03 00:00:00	32020		\N	103972	0	444814009	40481087		0
26345	1563	4112343	2003-07-01	2003-07-01 00:00:00	2003-07-14	2003-07-14 00:00:00	32020		\N	104688	0	195662009	4112343		0
26436	1568	260139	1960-01-22	1960-01-22 00:00:00	1960-01-29	1960-01-29 00:00:00	32020		\N	105198	0	10509002	260139		0
26645	1578	317576	2015-07-19	2015-07-19 00:00:00	\N	\N	32020		\N	106036	0	53741008	317576		0
26835	1588	40481087	2006-01-29	2006-01-29 00:00:00	2006-02-12	2006-02-12 00:00:00	32020		\N	106615	0	444814009	40481087		0
26977	1597	4237458	1965-02-28	1965-02-28 00:00:00	1965-04-29	1965-04-29 00:00:00	32020		\N	107119	0	58150001	4237458		0
27124	1604	4285898	1990-03-14	1990-03-14 00:00:00	\N	\N	32020		\N	107615	0	68496003	4285898		0
27344	1612	40481087	1996-04-23	1996-04-23 00:00:00	1996-05-07	1996-05-07 00:00:00	32020		\N	108417	0	444814009	40481087		0
27555	1626	40481087	1963-03-24	1963-03-24 00:00:00	1963-04-07	1963-04-07 00:00:00	32020		\N	109261	0	444814009	40481087		0
27682	1634	40481087	2002-03-07	2002-03-07 00:00:00	2002-03-28	2002-03-28 00:00:00	32020		\N	109796	0	444814009	40481087		0
38349	2277	40481087	1995-07-13	1995-07-13 00:00:00	1995-07-20	1995-07-20 00:00:00	32020		\N	151353	0	444814009	40481087		0
38542	2289	4059173	1964-11-24	1964-11-24 00:00:00	1965-01-23	1965-01-23 00:00:00	32020		\N	152250	0	16114001	4059173		0
28145	1661	4027663	1985-06-22	1985-06-22 00:00:00	\N	\N	32020		\N	111677	0	13200003	4027663		0
28341	1674	40481087	2003-12-18	2003-12-18 00:00:00	2003-12-25	2003-12-25 00:00:00	32020		\N	112346	0	444814009	40481087		0
28542	1689	81151	2019-03-28	2019-03-28 00:00:00	2019-05-02	2019-05-02 00:00:00	32020		\N	113158	0	44465007	81151		0
28590	1691	260139	1970-06-29	1970-06-29 00:00:00	1970-07-13	1970-07-13 00:00:00	32020		\N	113262	0	10509002	260139		0
28858	1709	4112343	2005-12-16	2005-12-16 00:00:00	2005-12-29	2005-12-29 00:00:00	32020		\N	114303	0	195662009	4112343		0
28956	1715	4218389	2019-03-12	2019-03-12 00:00:00	2019-04-16	2019-04-16 00:00:00	32020		\N	114557	0	39848009	4218389		0
29136	1724	40481087	1982-03-27	1982-03-27 00:00:00	1982-04-10	1982-04-10 00:00:00	32020		\N	115243	0	444814009	40481087		0
29322	1737	260139	2001-02-01	2001-02-01 00:00:00	2001-02-15	2001-02-15 00:00:00	32020		\N	116018	0	10509002	260139		0
29458	1744	80180	2010-08-06	2010-08-06 00:00:00	\N	\N	32020		\N	116616	0	396275006	80180		0
29624	1753	40481087	1965-02-08	1965-02-08 00:00:00	1965-02-15	1965-02-15 00:00:00	32020		\N	117171	0	444814009	40481087		0
29766	1761	4112343	1996-09-11	1996-09-11 00:00:00	1996-09-24	1996-09-24 00:00:00	32020		\N	117743	0	195662009	4112343		0
30004	1776	4109685	1921-09-30	1921-09-30 00:00:00	1921-10-14	1921-10-14 00:00:00	32020		\N	118799	0	284551006	4109685		0
30188	1783	4156265	1986-08-04	1986-08-04 00:00:00	1986-08-18	1986-08-18 00:00:00	32020		\N	119441	0	370247008	4156265		0
30309	1789	80180	2017-01-07	2017-01-07 00:00:00	\N	\N	32020		\N	119932	0	396275006	80180		0
41038	2439	4218389	1981-02-04	1981-02-04 00:00:00	1981-03-11	1981-03-11 00:00:00	32020		\N	161795	0	39848009	4218389		0
30667	1812	4146173	1971-06-29	1971-06-29 00:00:00	1971-07-29	1971-07-29 00:00:00	32020		\N	121245	0	307731004	4146173		0
30851	1826	40481087	1998-03-05	1998-03-05 00:00:00	1998-03-19	1998-03-19 00:00:00	32020		\N	122056	0	444814009	40481087		0
30973	1834	40481087	2013-03-15	2013-03-15 00:00:00	2013-04-05	2013-04-05 00:00:00	32020		\N	122485	0	444814009	40481087		0
31152	1845	260139	1979-01-31	1979-01-31 00:00:00	1979-02-14	1979-02-14 00:00:00	32020		\N	123326	0	10509002	260139		0
31300	1850	40481087	1994-11-19	1994-11-19 00:00:00	1994-12-10	1994-12-10 00:00:00	32020		\N	123728	0	444814009	40481087		0
31496	1861	78272	2004-02-02	2004-02-02 00:00:00	2004-02-16	2004-02-16 00:00:00	32020		\N	124416	0	70704007	78272		0
31598	1870	260139	1947-10-21	1947-10-21 00:00:00	1947-11-04	1947-11-04 00:00:00	32020		\N	124948	0	10509002	260139		0
42343	2522	4027663	1984-07-04	1984-07-04 00:00:00	\N	\N	32020		\N	166854	0	13200003	4027663		0
21358	1281	4134304	1984-06-18	1984-06-18 00:00:00	1984-08-17	1984-08-17 00:00:00	32020		\N	84703	0	263102004	4134304		0
32041	1903	260139	2014-08-21	2014-08-21 00:00:00	2014-08-28	2014-08-28 00:00:00	32020		\N	126725	0	10509002	260139		0
21738	1306	81151	1968-05-28	1968-05-28 00:00:00	1968-07-02	1968-07-02 00:00:00	32020		\N	86200	0	44465007	81151		0
21911	1314	4112343	1966-03-17	1966-03-17 00:00:00	1966-03-29	1966-03-29 00:00:00	32020		\N	87047	0	195662009	4112343		0
21967	1316	372328	1949-10-21	1949-10-21 00:00:00	1949-12-27	1949-12-27 00:00:00	32020		\N	87157	0	65363002	372328		0
22227	1325	80180	2000-12-19	2000-12-19 00:00:00	\N	\N	32020		\N	87985	0	396275006	80180		0
22330	1333	28060	1957-12-18	1957-12-18 00:00:00	1957-12-27	1957-12-27 00:00:00	32020		\N	88440	0	43878008	28060		0
22513	1345	260139	2013-10-13	2013-10-13 00:00:00	2013-10-20	2013-10-20 00:00:00	32020		\N	89129	0	10509002	260139		0
22674	1354	260139	1982-03-12	1982-03-12 00:00:00	1982-03-19	1982-03-19 00:00:00	32020		\N	89745	0	10509002	260139		0
22850	1361	4112343	1977-11-23	1977-11-23 00:00:00	1977-12-03	1977-12-03 00:00:00	32020		\N	90326	0	195662009	4112343		0
22946	1368	4112343	2008-02-28	2008-02-28 00:00:00	2008-03-11	2008-03-11 00:00:00	32020		\N	90713	0	195662009	4112343		0
23130	1381	80180	2018-11-10	2018-11-10 00:00:00	\N	\N	32020		\N	91589	0	396275006	80180		0
23326	1391	28060	1951-09-14	1951-09-14 00:00:00	1951-09-27	1951-09-27 00:00:00	32020		\N	92321	0	43878008	28060		0
23540	1407	40481087	1979-09-15	1979-09-15 00:00:00	1979-09-22	1979-09-22 00:00:00	32020		\N	93572	0	444814009	40481087		0
23666	1411	198809	1999-11-23	1999-11-23 00:00:00	1999-11-23	1999-11-23 00:00:00	32020		\N	93967	0	65275009	198809		0
23897	1428	40481087	1982-11-20	1982-11-20 00:00:00	1982-11-27	1982-11-27 00:00:00	32020		\N	95046	0	444814009	40481087		0
23965	1431	4112343	1984-07-13	1984-07-13 00:00:00	1984-07-26	1984-07-26 00:00:00	32020		\N	95210	0	195662009	4112343		0
34702	2060	40481087	1981-01-14	1981-01-14 00:00:00	1981-02-04	1981-02-04 00:00:00	32020		\N	137003	0	444814009	40481087		0
34867	2071	260139	1989-01-19	1989-01-19 00:00:00	1989-01-26	1989-01-26 00:00:00	32020		\N	137806	0	10509002	260139		0
24466	1459	40481087	1972-03-26	1972-03-26 00:00:00	1972-04-16	1972-04-16 00:00:00	32020		\N	97180	0	444814009	40481087		0
24611	1468	260139	1965-08-11	1965-08-11 00:00:00	1965-08-18	1965-08-18 00:00:00	32020		\N	97852	0	10509002	260139		0
24885	1486	4294548	1982-03-18	1982-03-18 00:00:00	1982-09-09	1982-09-09 00:00:00	32020		\N	99008	0	75498004	4294548		0
25012	1493	4283893	1998-01-23	1998-01-23 00:00:00	1998-03-13	1998-03-13 00:00:00	32020		\N	99569	0	36971009	4283893		0
25131	1498	372328	1969-01-19	1969-01-19 00:00:00	1969-02-24	1969-02-24 00:00:00	32020		\N	99949	0	65363002	372328		0
25288	1508	40481087	2012-02-03	2012-02-03 00:00:00	2012-02-17	2012-02-17 00:00:00	32020		\N	100626	0	444814009	40481087		0
25528	1518	4310024	1996-05-25	1996-05-25 00:00:00	\N	\N	32020		\N	101556	0	424802006	4310024		0
25689	1526	378001	1976-12-31	1976-12-31 00:00:00	1977-01-30	1977-01-30 00:00:00	32020		\N	102049	0	62106007	378001		0
25876	1536	372328	1913-12-02	1913-12-02 00:00:00	1914-06-07	1914-06-07 00:00:00	32020		\N	102821	0	65363002	372328		0
26008	1542	4237458	2007-11-03	2007-11-03 00:00:00	2007-12-03	2007-12-03 00:00:00	32020		\N	103306	0	58150001	4237458		0
26168	1553	4294548	1989-11-18	1989-11-18 00:00:00	1989-12-09	1989-12-09 00:00:00	32020		\N	103971	0	75498004	4294548		0
26346	1563	260139	1978-04-04	1978-04-04 00:00:00	1978-04-18	1978-04-18 00:00:00	32020		\N	104698	0	10509002	260139		0
26437	1568	40481087	2003-05-20	2003-05-20 00:00:00	2003-05-27	2003-05-27 00:00:00	32020		\N	105186	0	444814009	40481087		0
26646	1578	4059173	1999-08-22	1999-08-22 00:00:00	1999-11-20	1999-11-20 00:00:00	32020		\N	105970	0	16114001	4059173		0
26836	1588	40481087	2007-11-12	2007-11-12 00:00:00	2007-11-26	2007-11-26 00:00:00	32020		\N	106616	0	444814009	40481087		0
26978	1597	372328	1947-06-14	1947-06-14 00:00:00	1947-07-05	1947-07-05 00:00:00	32020		\N	107105	0	65363002	372328		0
27125	1604	192671	1991-04-13	1991-04-13 00:00:00	\N	\N	32020		\N	107602	0	K92.2	35208414		0
27345	1612	260139	1965-09-19	1965-09-19 00:00:00	1965-09-26	1965-09-26 00:00:00	32020		\N	108380	0	10509002	260139		0
27556	1626	40481087	1988-05-22	1988-05-22 00:00:00	1988-05-29	1988-05-29 00:00:00	32020		\N	109192	0	444814009	40481087		0
27683	1634	260139	1985-02-03	1985-02-03 00:00:00	1985-02-17	1985-02-17 00:00:00	32020		\N	109740	0	10509002	260139		0
38350	2277	40481087	2011-01-04	2011-01-04 00:00:00	2011-01-18	2011-01-18 00:00:00	32020		\N	151340	0	444814009	40481087		0
38543	2289	40481087	1968-06-19	1968-06-19 00:00:00	1968-06-26	1968-06-26 00:00:00	32020		\N	152261	0	444814009	40481087		0
28146	1661	372328	1962-03-14	1962-03-14 00:00:00	1962-06-21	1962-06-21 00:00:00	32020		\N	111688	0	65363002	372328		0
28342	1674	4027663	2004-10-04	2004-10-04 00:00:00	\N	\N	32020		\N	112346	0	13200003	4027663		0
28543	1689	4113008	1992-02-04	1992-02-04 00:00:00	1992-02-18	1992-02-18 00:00:00	32020		\N	113157	0	284549007	4113008		0
28591	1691	4112343	1977-07-31	1977-07-31 00:00:00	1977-08-11	1977-08-11 00:00:00	32020		\N	113224	0	195662009	4112343		0
28859	1709	40481087	1974-09-04	1974-09-04 00:00:00	1974-09-25	1974-09-25 00:00:00	32020		\N	114300	0	444814009	40481087		0
28957	1715	4112343	2003-09-14	2003-09-14 00:00:00	2003-09-24	2003-09-24 00:00:00	32020		\N	114545	0	195662009	4112343		0
29137	1724	4278672	1986-05-27	1986-05-27 00:00:00	1986-08-25	1986-08-25 00:00:00	32020		\N	115264	0	65966004	4278672		0
29323	1737	40481087	1929-06-27	1929-06-27 00:00:00	1929-07-04	1929-07-04 00:00:00	32020		\N	116016	0	444814009	40481087		0
29459	1745	372328	1980-02-09	1980-02-09 00:00:00	1980-03-24	1980-03-24 00:00:00	32020		\N	116696	0	65363002	372328		0
29625	1753	40481087	1973-10-28	1973-10-28 00:00:00	1973-11-04	1973-11-04 00:00:00	32020		\N	117173	0	444814009	40481087		0
29767	1761	40481087	1986-01-23	1986-01-23 00:00:00	1986-01-30	1986-01-30 00:00:00	32020		\N	117756	0	444814009	40481087		0
30005	1776	40481087	2012-11-24	2012-11-24 00:00:00	2012-12-15	2012-12-15 00:00:00	32020		\N	118794	0	444814009	40481087		0
30189	1783	4084167	1962-03-13	1962-03-13 00:00:00	1962-03-13	1962-03-13 00:00:00	32020		\N	119436	0	241929008	4084167		0
30310	1789	4283893	2016-01-19	2016-01-19 00:00:00	2016-03-15	2016-03-15 00:00:00	32020		\N	119932	0	36971009	4283893		0
41039	2439	372328	1973-08-24	1973-08-24 00:00:00	1973-10-24	1973-10-24 00:00:00	32020		\N	161811	0	65363002	372328		0
30668	1812	80180	2003-10-04	2003-10-04 00:00:00	\N	\N	32020		\N	121276	0	396275006	80180		0
30852	1826	40481087	1995-08-19	1995-08-19 00:00:00	1995-09-09	1995-09-09 00:00:00	32020		\N	122055	0	444814009	40481087		0
30974	1834	4237458	1960-04-25	1960-04-25 00:00:00	1960-06-24	1960-06-24 00:00:00	32020		\N	122541	0	58150001	4237458		0
31153	1845	4112343	1979-02-19	1979-02-19 00:00:00	1979-03-02	1979-03-02 00:00:00	32020		\N	123327	0	195662009	4112343		0
31301	1850	192671	1998-09-29	1998-09-29 00:00:00	\N	\N	32020		\N	123735	0	K92.2	35208414		0
31497	1861	40481087	2018-01-09	2018-01-09 00:00:00	2018-01-23	2018-01-23 00:00:00	32020		\N	124440	0	444814009	40481087		0
31599	1870	260139	1927-04-13	1927-04-13 00:00:00	1927-04-20	1927-04-20 00:00:00	32020		\N	124924	0	10509002	260139		0
42344	2522	4109685	1998-06-14	1998-06-14 00:00:00	1998-07-05	1998-07-05 00:00:00	32020		\N	166788	0	284551006	4109685		0
21359	1281	372328	1972-02-22	1972-02-22 00:00:00	1972-06-10	1972-06-10 00:00:00	32020		\N	84666	0	65363002	372328		0
32042	1903	4156265	2019-01-01	2019-01-01 00:00:00	2019-01-22	2019-01-22 00:00:00	32020		\N	126735	0	370247008	4156265		0
21739	1306	4112343	1984-11-25	1984-11-25 00:00:00	1984-12-08	1984-12-08 00:00:00	32020		\N	86192	0	195662009	4112343		0
21912	1314	4112343	1935-06-21	1935-06-21 00:00:00	1935-06-30	1935-06-30 00:00:00	32020		\N	87019	0	195662009	4112343		0
21968	1316	40481087	2018-08-08	2018-08-08 00:00:00	2018-08-29	2018-08-29 00:00:00	32020		\N	87143	0	444814009	40481087		0
22228	1325	4112343	1974-03-05	1974-03-05 00:00:00	1974-03-13	1974-03-13 00:00:00	32020		\N	87957	0	195662009	4112343		0
22331	1333	4156265	1990-04-07	1990-04-07 00:00:00	1990-04-21	1990-04-21 00:00:00	32020		\N	88416	0	370247008	4156265		0
22514	1345	4112343	1995-12-10	1995-12-10 00:00:00	1995-12-19	1995-12-19 00:00:00	32020		\N	89160	0	195662009	4112343		0
22675	1354	372328	1986-06-24	1986-06-24 00:00:00	1987-04-17	1987-04-17 00:00:00	32020		\N	89750	0	65363002	372328		0
22851	1361	4112343	1979-04-01	1979-04-01 00:00:00	1979-04-11	1979-04-11 00:00:00	32020		\N	90367	0	195662009	4112343		0
22947	1368	4112343	2018-08-20	2018-08-20 00:00:00	2018-08-29	2018-08-29 00:00:00	32020		\N	90736	0	195662009	4112343		0
23327	1391	40481087	1933-03-09	1933-03-09 00:00:00	1933-03-30	1933-03-30 00:00:00	32020		\N	92311	0	444814009	40481087		0
23541	1407	4218389	1970-10-01	1970-10-01 00:00:00	1970-10-22	1970-10-22 00:00:00	32020		\N	93561	0	39848009	4218389		0
23667	1411	40481087	2003-03-23	2003-03-23 00:00:00	2003-04-13	2003-04-13 00:00:00	32020		\N	93919	0	444814009	40481087		0
23898	1428	4112343	1972-10-27	1972-10-27 00:00:00	1972-11-05	1972-11-05 00:00:00	32020		\N	94986	0	195662009	4112343		0
23966	1431	4278672	1965-05-31	1965-05-31 00:00:00	1965-06-30	1965-06-30 00:00:00	32020		\N	95250	0	65966004	4278672		0
34703	2060	4112343	1992-05-01	1992-05-01 00:00:00	1992-05-14	1992-05-14 00:00:00	32020		\N	137007	0	195662009	4112343		0
34868	2071	4112343	2006-07-24	2006-07-24 00:00:00	2006-08-02	2006-08-02 00:00:00	32020		\N	137807	0	195662009	4112343		0
24467	1459	257012	1946-08-31	1946-08-31 00:00:00	\N	\N	32020		\N	97228	0	40055000	257012		0
24612	1468	372328	1958-01-29	1958-01-29 00:00:00	1958-06-18	1958-06-18 00:00:00	32020		\N	97879	0	65363002	372328		0
24886	1486	4112343	2018-07-18	2018-07-18 00:00:00	2018-07-31	2018-07-31 00:00:00	32020		\N	99078	0	195662009	4112343		0
25013	1493	40481087	2006-08-20	2006-08-20 00:00:00	2006-09-03	2006-09-03 00:00:00	32020		\N	99554	0	444814009	40481087		0
25132	1498	40481087	1965-10-17	1965-10-17 00:00:00	1965-10-31	1965-10-31 00:00:00	32020		\N	99932	0	444814009	40481087		0
25289	1508	40481087	1944-10-15	1944-10-15 00:00:00	1944-10-22	1944-10-22 00:00:00	32020		\N	100639	0	444814009	40481087		0
25529	1518	4112343	1992-05-09	1992-05-09 00:00:00	1992-05-20	1992-05-20 00:00:00	32020		\N	101528	0	195662009	4112343		0
25690	1526	40481087	1979-09-18	1979-09-18 00:00:00	1979-10-09	1979-10-09 00:00:00	32020		\N	102063	0	444814009	40481087		0
25877	1536	4112343	1965-01-31	1965-01-31 00:00:00	1965-02-13	1965-02-13 00:00:00	32020		\N	102803	0	195662009	4112343		0
26009	1542	4112343	2013-04-01	2013-04-01 00:00:00	2013-04-14	2013-04-14 00:00:00	32020		\N	103309	0	195662009	4112343		0
26169	1553	40481087	2009-12-14	2009-12-14 00:00:00	2009-12-21	2009-12-21 00:00:00	32020		\N	103993	0	444814009	40481087		0
26347	1563	40481087	2016-11-07	2016-11-07 00:00:00	2016-11-21	2016-11-21 00:00:00	32020		\N	104679	0	444814009	40481087		0
26438	1568	4059173	1960-03-22	1960-03-22 00:00:00	1960-05-21	1960-05-21 00:00:00	32020		\N	105163	0	16114001	4059173		0
26647	1578	40481087	1952-06-06	1952-06-06 00:00:00	1952-06-27	1952-06-27 00:00:00	32020		\N	105955	0	444814009	40481087		0
26837	1588	260139	2004-01-17	2004-01-17 00:00:00	2004-01-24	2004-01-24 00:00:00	32020		\N	106577	0	10509002	260139		0
26979	1597	28060	1953-08-15	1953-08-15 00:00:00	1953-08-23	1953-08-23 00:00:00	32020		\N	107098	0	43878008	28060		0
27126	1604	258780	1999-03-11	1999-03-11 00:00:00	\N	\N	32020		\N	107634	0	185086009	258780		0
27346	1612	40481087	1964-05-01	1964-05-01 00:00:00	1964-05-22	1964-05-22 00:00:00	32020		\N	108412	0	444814009	40481087		0
38018	2258	40481087	1961-05-20	1961-05-20 00:00:00	1961-06-10	1961-06-10 00:00:00	32020		\N	150089	0	444814009	40481087		0
27684	1634	260139	1956-08-11	1956-08-11 00:00:00	1956-08-25	1956-08-25 00:00:00	32020		\N	109782	0	10509002	260139		0
38373	2280	4112343	1986-08-31	1986-08-31 00:00:00	1986-09-07	1986-09-07 00:00:00	32020		\N	151566	0	195662009	4112343		0
38544	2289	81151	1957-04-23	1957-04-23 00:00:00	1957-05-14	1957-05-14 00:00:00	32020		\N	152262	0	44465007	81151		0
28147	1661	260139	2003-08-16	2003-08-16 00:00:00	2003-08-30	2003-08-30 00:00:00	32020		\N	111638	0	10509002	260139		0
28343	1674	40481087	2012-11-06	2012-11-06 00:00:00	2012-11-27	2012-11-27 00:00:00	32020		\N	112356	0	444814009	40481087		0
28544	1689	40481087	1943-03-26	1943-03-26 00:00:00	1943-04-02	1943-04-02 00:00:00	32020		\N	113117	0	444814009	40481087		0
28592	1691	40481087	1995-03-22	1995-03-22 00:00:00	1995-04-05	1995-04-05 00:00:00	32020		\N	113235	0	444814009	40481087		0
28860	1709	4112343	1971-03-13	1971-03-13 00:00:00	1971-03-25	1971-03-25 00:00:00	32020		\N	114264	0	195662009	4112343		0
28958	1715	260139	1994-03-06	1994-03-06 00:00:00	1994-03-13	1994-03-13 00:00:00	32020		\N	114558	0	10509002	260139		0
29138	1724	260139	1975-02-20	1975-02-20 00:00:00	1975-03-06	1975-03-06 00:00:00	32020		\N	115298	0	10509002	260139		0
29324	1737	260139	1912-10-17	1912-10-17 00:00:00	1912-10-24	1912-10-24 00:00:00	32020		\N	115975	0	10509002	260139		0
29460	1745	4112343	2002-09-09	2002-09-09 00:00:00	2002-09-22	2002-09-22 00:00:00	32020		\N	116695	0	195662009	4112343		0
29626	1753	4112343	2011-04-22	2011-04-22 00:00:00	2011-05-01	2011-05-01 00:00:00	32020		\N	117207	0	195662009	4112343		0
29768	1761	40481087	1989-10-29	1989-10-29 00:00:00	1989-11-12	1989-11-12 00:00:00	32020		\N	117789	0	444814009	40481087		0
30006	1776	40479768	2018-04-17	2018-04-17 00:00:00	2018-05-24	2018-05-24 00:00:00	32020		\N	118776	0	444470001	40479768		0
30190	1783	4112343	1974-07-10	1974-07-10 00:00:00	1974-07-20	1974-07-20 00:00:00	32020		\N	119418	0	195662009	4112343		0
30311	1789	4084167	1976-02-22	1976-02-22 00:00:00	1976-02-22	1976-02-22 00:00:00	32020		\N	119896	0	241929008	4084167		0
41062	2442	40481087	2010-01-11	2010-01-11 00:00:00	2010-01-25	2010-01-25 00:00:00	32020		\N	161934	0	444814009	40481087		0
30669	1812	4112343	2003-01-26	2003-01-26 00:00:00	2003-02-06	2003-02-06 00:00:00	32020		\N	121257	0	195662009	4112343		0
30853	1826	30753	1977-05-22	1977-05-22 00:00:00	\N	\N	32020		\N	122009	0	16761005	30753		0
30975	1834	80180	1986-07-13	1986-07-13 00:00:00	\N	\N	32020		\N	122506	0	396275006	80180		0
31154	1845	260139	1972-04-22	1972-04-22 00:00:00	1972-05-06	1972-05-06 00:00:00	32020		\N	123365	0	10509002	260139		0
31302	1850	40481087	1960-02-26	1960-02-26 00:00:00	1960-03-11	1960-03-11 00:00:00	32020		\N	123763	0	444814009	40481087		0
31498	1861	80180	2019-02-02	2019-02-02 00:00:00	\N	\N	32020		\N	124440	0	396275006	80180		0
31600	1870	28060	1939-09-30	1939-09-30 00:00:00	1939-10-12	1939-10-12 00:00:00	32020		\N	124947	0	43878008	28060		0
42345	2522	260139	1959-05-08	1959-05-08 00:00:00	1959-05-15	1959-05-15 00:00:00	32020		\N	166798	0	10509002	260139		0
21360	1281	40481087	1975-02-12	1975-02-12 00:00:00	1975-03-05	1975-03-05 00:00:00	32020		\N	84639	0	444814009	40481087		0
32043	1903	28060	1969-05-16	1969-05-16 00:00:00	1969-05-29	1969-05-29 00:00:00	32020		\N	126669	0	43878008	28060		0
21740	1306	40481087	2014-08-31	2014-08-31 00:00:00	2014-09-14	2014-09-14 00:00:00	32020		\N	86196	0	444814009	40481087		0
32371	1923	260139	2013-03-27	2013-03-27 00:00:00	2013-04-03	2013-04-03 00:00:00	32020		\N	127854	0	10509002	260139		0
21969	1316	28060	1963-09-29	1963-09-29 00:00:00	1963-10-08	1963-10-08 00:00:00	32020		\N	87219	0	43878008	28060		0
22229	1325	4059173	2011-10-17	2011-10-17 00:00:00	2012-01-15	2012-01-15 00:00:00	32020		\N	87939	0	16114001	4059173		0
22332	1333	4149245	2002-05-18	2002-05-18 00:00:00	2002-06-24	2002-06-24 00:00:00	32020		\N	88417	0	30832001	4149245		0
22515	1345	4278672	1993-07-21	1993-07-21 00:00:00	1993-10-19	1993-10-19 00:00:00	32020		\N	89172	0	65966004	4278672		0
22676	1354	40481087	1978-05-13	1978-05-13 00:00:00	1978-06-03	1978-06-03 00:00:00	32020		\N	89721	0	444814009	40481087		0
22852	1361	372328	1942-04-21	1942-04-21 00:00:00	1942-08-10	1942-08-10 00:00:00	32020		\N	90376	0	65363002	372328		0
22948	1368	28060	1976-09-02	1976-09-02 00:00:00	1976-09-09	1976-09-09 00:00:00	32020		\N	90708	0	43878008	28060		0
23132	1381	4112343	2018-03-28	2018-03-28 00:00:00	2018-04-07	2018-04-07 00:00:00	32020		\N	91589	0	195662009	4112343		0
23328	1391	40481087	1978-07-25	1978-07-25 00:00:00	1978-08-15	1978-08-15 00:00:00	32020		\N	92385	0	444814009	40481087		0
23542	1407	4155034	1992-12-14	1992-12-14 00:00:00	1992-12-28	1992-12-28 00:00:00	32020		\N	93566	0	283371005	4155034		0
23668	1412	4294548	1980-07-16	1980-07-16 00:00:00	1980-09-03	1980-09-03 00:00:00	32020		\N	94054	0	75498004	4294548		0
23899	1428	378001	1945-09-17	1945-09-17 00:00:00	1945-11-15	1945-11-15 00:00:00	32020		\N	94964	0	62106007	378001		0
23967	1431	260139	2018-07-09	2018-07-09 00:00:00	2018-07-16	2018-07-16 00:00:00	32020		\N	95353	0	10509002	260139		0
34704	2060	40481087	2008-07-05	2008-07-05 00:00:00	2008-07-19	2008-07-19 00:00:00	32020		\N	136979	0	444814009	40481087		0
34869	2071	260139	1976-12-08	1976-12-08 00:00:00	1976-12-15	1976-12-15 00:00:00	32020		\N	137789	0	10509002	260139		0
24468	1459	4112343	1958-07-18	1958-07-18 00:00:00	1958-07-29	1958-07-29 00:00:00	32020		\N	97178	0	195662009	4112343		0
24613	1468	4112343	2015-04-05	2015-04-05 00:00:00	2015-04-18	2015-04-18 00:00:00	32020		\N	97813	0	195662009	4112343		0
24887	1486	40481087	1984-11-06	1984-11-06 00:00:00	1984-11-13	1984-11-13 00:00:00	32020		\N	99009	0	444814009	40481087		0
25014	1493	40481087	1982-10-03	1982-10-03 00:00:00	1982-10-24	1982-10-24 00:00:00	32020		\N	99582	0	444814009	40481087		0
25133	1498	80180	2007-04-21	2007-04-21 00:00:00	\N	\N	32020		\N	99928	0	396275006	80180		0
25290	1508	40481087	2014-02-13	2014-02-13 00:00:00	2014-02-27	2014-02-27 00:00:00	32020		\N	100656	0	444814009	40481087		0
25530	1518	40481087	2014-08-14	2014-08-14 00:00:00	2014-09-04	2014-09-04 00:00:00	32020		\N	101533	0	444814009	40481087		0
25691	1526	81151	2007-09-04	2007-09-04 00:00:00	2007-09-25	2007-09-25 00:00:00	32020		\N	102051	0	44465007	81151		0
25878	1537	4294548	1978-01-15	1978-01-15 00:00:00	1978-01-22	1978-01-22 00:00:00	32020		\N	102869	0	75498004	4294548		0
26010	1542	260139	1986-12-27	1986-12-27 00:00:00	1987-01-10	1987-01-10 00:00:00	32020		\N	103339	0	10509002	260139		0
26170	1553	40481087	2007-05-13	2007-05-13 00:00:00	2007-05-20	2007-05-20 00:00:00	32020		\N	103973	0	444814009	40481087		0
26348	1563	4001336	2009-11-24	2009-11-24 00:00:00	2009-12-24	2009-12-24 00:00:00	32020		\N	104750	0	110030002	4001336		0
26439	1568	40481087	1988-07-14	1988-07-14 00:00:00	1988-07-28	1988-07-28 00:00:00	32020		\N	105185	0	444814009	40481087		0
26648	1578	195588	1977-03-29	1977-03-29 00:00:00	1977-05-03	1977-05-03 00:00:00	32020		\N	106025	0	38822007	195588		0
26838	1588	260139	1992-03-23	1992-03-23 00:00:00	1992-04-06	1992-04-06 00:00:00	32020		\N	106634	0	10509002	260139		0
26980	1597	78272	1969-12-04	1969-12-04 00:00:00	1969-12-25	1969-12-25 00:00:00	32020		\N	107120	0	70704007	78272		0
27127	1604	372328	1955-06-21	1955-06-21 00:00:00	1955-10-06	1955-10-06 00:00:00	32020		\N	107610	0	65363002	372328		0
27347	1612	4051466	1966-08-06	1966-08-06 00:00:00	1982-12-14	1982-12-14 00:00:00	32020		\N	108381	0	233678006	4051466		0
38019	2258	372328	1959-11-30	1959-11-30 00:00:00	1960-03-24	1960-03-24 00:00:00	32020		\N	150095	0	65363002	372328		0
27685	1634	40481087	1995-12-27	1995-12-27 00:00:00	1996-01-17	1996-01-17 00:00:00	32020		\N	109784	0	444814009	40481087		0
38374	2280	40481087	1973-04-14	1973-04-14 00:00:00	1973-05-05	1973-05-05 00:00:00	32020		\N	151555	0	444814009	40481087		0
38545	2289	260139	2019-06-02	2019-06-02 00:00:00	2019-06-16	2019-06-16 00:00:00	32020		\N	152286	0	10509002	260139		0
28148	1661	260139	2016-08-03	2016-08-03 00:00:00	2016-08-17	2016-08-17 00:00:00	32020		\N	111640	0	10509002	260139		0
28344	1674	4112343	1980-06-23	1980-06-23 00:00:00	1980-07-06	1980-07-06 00:00:00	32020		\N	112368	0	195662009	4112343		0
28545	1689	40481087	2014-12-30	2014-12-30 00:00:00	2015-01-13	2015-01-13 00:00:00	32020		\N	113108	0	444814009	40481087		0
28593	1691	372328	1950-01-30	1950-01-30 00:00:00	1950-06-29	1950-06-29 00:00:00	32020		\N	113263	0	65363002	372328		0
28861	1709	40481087	1948-02-25	1948-02-25 00:00:00	1948-03-10	1948-03-10 00:00:00	32020		\N	114295	0	444814009	40481087		0
28959	1715	4296204	1996-02-08	1996-02-08 00:00:00	1996-03-14	1996-03-14 00:00:00	32020		\N	114555	0	403190006	4296204		0
29139	1724	4113008	1995-07-23	1995-07-23 00:00:00	1995-08-06	1995-08-06 00:00:00	32020		\N	115266	0	284549007	4113008		0
29325	1737	260139	1941-08-31	1941-08-31 00:00:00	1941-09-14	1941-09-14 00:00:00	32020		\N	115978	0	10509002	260139		0
29461	1745	28060	1979-08-16	1979-08-16 00:00:00	1979-08-27	1979-08-27 00:00:00	32020		\N	116670	0	43878008	28060		0
29627	1753	40481087	2000-12-30	2000-12-30 00:00:00	2001-01-06	2001-01-06 00:00:00	32020		\N	117237	0	444814009	40481087		0
29769	1761	28060	1959-04-10	1959-04-10 00:00:00	1959-04-20	1959-04-20 00:00:00	32020		\N	117786	0	43878008	28060		0
30007	1776	81151	2001-01-11	2001-01-11 00:00:00	2001-02-15	2001-02-15 00:00:00	32020		\N	118885	0	44465007	81151		0
30191	1783	80180	2002-03-03	2002-03-03 00:00:00	\N	\N	32020		\N	119432	0	396275006	80180		0
30312	1789	192671	2017-04-02	2017-04-02 00:00:00	\N	\N	32020		\N	119898	0	K92.2	35208414		0
41063	2442	260139	2012-06-24	2012-06-24 00:00:00	2012-07-08	2012-07-08 00:00:00	32020		\N	162015	0	10509002	260139		0
30670	1812	40481087	1984-05-18	1984-05-18 00:00:00	1984-05-25	1984-05-25 00:00:00	32020		\N	121293	0	444814009	40481087		0
30854	1826	4285898	1977-09-19	1977-09-19 00:00:00	\N	\N	32020		\N	122009	0	68496003	4285898		0
30976	1834	40481087	1961-03-21	1961-03-21 00:00:00	1961-03-28	1961-03-28 00:00:00	32020		\N	122465	0	444814009	40481087		0
31155	1845	257012	1978-03-17	1978-03-17 00:00:00	\N	\N	32020		\N	123387	0	40055000	257012		0
31303	1850	40481087	1959-04-09	1959-04-09 00:00:00	1959-04-23	1959-04-23 00:00:00	32020		\N	123746	0	444814009	40481087		0
31499	1861	260139	2015-05-05	2015-05-05 00:00:00	2015-05-19	2015-05-19 00:00:00	32020		\N	124439	0	10509002	260139		0
31601	1870	40481087	1931-10-17	1931-10-17 00:00:00	1931-11-07	1931-11-07 00:00:00	32020		\N	124925	0	444814009	40481087		0
42346	2522	4112343	2015-06-05	2015-06-05 00:00:00	2015-06-17	2015-06-17 00:00:00	32020		\N	166797	0	195662009	4112343		0
21361	1281	80180	2005-11-10	2005-11-10 00:00:00	\N	\N	32020		\N	84653	0	396275006	80180		0
32044	1903	260139	1971-03-05	1971-03-05 00:00:00	1971-03-19	1971-03-19 00:00:00	32020		\N	126699	0	10509002	260139		0
21741	1306	4156265	1962-04-09	1962-04-09 00:00:00	1962-04-30	1962-04-30 00:00:00	32020		\N	86246	0	370247008	4156265		0
32372	1923	260139	1962-06-13	1962-06-13 00:00:00	1962-06-27	1962-06-27 00:00:00	32020		\N	127953	0	10509002	260139		0
21970	1316	4059173	2018-09-27	2018-09-27 00:00:00	2018-12-26	2018-12-26 00:00:00	32020		\N	87224	0	16114001	4059173		0
22230	1325	28060	2018-05-12	2018-05-12 00:00:00	2018-05-21	2018-05-21 00:00:00	32020		\N	87963	0	43878008	28060		0
22333	1333	4152936	2013-05-27	2013-05-27 00:00:00	2013-06-17	2013-06-17 00:00:00	32020		\N	88418	0	283385000	4152936		0
22516	1345	40481087	2011-03-20	2011-03-20 00:00:00	2011-04-03	2011-04-03 00:00:00	32020		\N	89128	0	444814009	40481087		0
22677	1354	40481087	1984-07-04	1984-07-04 00:00:00	1984-07-11	1984-07-11 00:00:00	32020		\N	89725	0	444814009	40481087		0
22853	1361	4112343	2003-08-07	2003-08-07 00:00:00	2003-08-14	2003-08-14 00:00:00	32020		\N	90373	0	195662009	4112343		0
22949	1368	40481087	1985-07-14	1985-07-14 00:00:00	1985-07-21	1985-07-21 00:00:00	32020		\N	90718	0	444814009	40481087		0
23133	1381	261325	2006-08-12	2006-08-12 00:00:00	\N	\N	32020		\N	91573	0	87433001	261325		0
23329	1391	440086	1935-12-29	1935-12-29 00:00:00	1942-01-06	1942-01-06 00:00:00	32020		\N	92312	0	192127007	440086		0
23543	1407	80180	2002-11-17	2002-11-17 00:00:00	\N	\N	32020		\N	93508	0	396275006	80180		0
23669	1412	28060	1969-02-02	1969-02-02 00:00:00	1969-02-10	1969-02-10 00:00:00	32020		\N	94091	0	43878008	28060		0
23900	1428	81151	1995-08-22	1995-08-22 00:00:00	1995-09-19	1995-09-19 00:00:00	32020		\N	94967	0	44465007	81151		0
23968	1431	4146173	1950-07-28	1950-07-28 00:00:00	1950-09-26	1950-09-26 00:00:00	32020		\N	95343	0	307731004	4146173		0
34705	2060	4112343	1980-11-21	1980-11-21 00:00:00	1980-12-02	1980-12-02 00:00:00	32020		\N	137034	0	195662009	4112343		0
34870	2071	4112343	1983-04-14	1983-04-14 00:00:00	1983-04-22	1983-04-22 00:00:00	32020		\N	137823	0	195662009	4112343		0
24469	1459	40481087	2010-12-04	2010-12-04 00:00:00	2010-12-11	2010-12-11 00:00:00	32020		\N	97183	0	444814009	40481087		0
24614	1468	40481087	1997-05-03	1997-05-03 00:00:00	1997-05-17	1997-05-17 00:00:00	32020		\N	97828	0	444814009	40481087		0
24888	1486	195588	1995-06-30	1995-06-30 00:00:00	1995-08-21	1995-08-21 00:00:00	32020		\N	99023	0	38822007	195588		0
25015	1493	4112343	1958-08-31	1958-08-31 00:00:00	1958-09-10	1958-09-10 00:00:00	32020		\N	99550	0	195662009	4112343		0
25134	1498	192671	2007-05-02	2007-05-02 00:00:00	\N	\N	32020		\N	99931	0	K92.2	35208414		0
25291	1508	4112343	2000-01-19	2000-01-19 00:00:00	2000-01-26	2000-01-26 00:00:00	32020		\N	100574	0	195662009	4112343		0
25531	1518	40481087	1963-09-22	1963-09-22 00:00:00	1963-09-29	1963-09-29 00:00:00	32020		\N	101534	0	444814009	40481087		0
25692	1526	40481087	2011-11-06	2011-11-06 00:00:00	2011-11-20	2011-11-20 00:00:00	32020		\N	102084	0	444814009	40481087		0
25879	1537	80180	1992-01-21	1992-01-21 00:00:00	\N	\N	32020		\N	102905	0	396275006	80180		0
26011	1542	260139	2012-10-13	2012-10-13 00:00:00	2012-10-27	2012-10-27 00:00:00	32020		\N	103323	0	10509002	260139		0
26171	1553	40481087	2004-10-11	2004-10-11 00:00:00	2004-10-18	2004-10-18 00:00:00	32020		\N	103956	0	444814009	40481087		0
26349	1563	40481087	2015-12-24	2015-12-24 00:00:00	2016-01-07	2016-01-07 00:00:00	32020		\N	104693	0	444814009	40481087		0
26440	1568	260139	1975-02-12	1975-02-12 00:00:00	1975-02-19	1975-02-19 00:00:00	32020		\N	105166	0	10509002	260139		0
26649	1578	260139	1950-09-27	1950-09-27 00:00:00	1950-10-11	1950-10-11 00:00:00	32020		\N	106023	0	10509002	260139		0
26839	1588	40481087	1972-08-12	1972-08-12 00:00:00	1972-09-02	1972-09-02 00:00:00	32020		\N	106642	0	444814009	40481087		0
26981	1597	4084167	1945-04-25	1945-04-25 00:00:00	1945-04-25	1945-04-25 00:00:00	32020		\N	107113	0	241929008	4084167		0
27128	1604	260139	1990-06-18	1990-06-18 00:00:00	1990-07-02	1990-07-02 00:00:00	32020		\N	107616	0	10509002	260139		0
27348	1612	40481087	2008-07-09	2008-07-09 00:00:00	2008-07-16	2008-07-16 00:00:00	32020		\N	108366	0	444814009	40481087		0
38020	2258	40481087	2001-06-30	2001-06-30 00:00:00	2001-07-07	2001-07-07 00:00:00	32020		\N	150099	0	444814009	40481087		0
27686	1634	40481087	1947-09-28	1947-09-28 00:00:00	1947-10-05	1947-10-05 00:00:00	32020		\N	109722	0	444814009	40481087		0
38375	2280	28060	1993-04-04	1993-04-04 00:00:00	1993-04-15	1993-04-15 00:00:00	32020		\N	151670	0	43878008	28060		0
38546	2289	78272	2018-07-15	2018-07-15 00:00:00	2018-08-19	2018-08-19 00:00:00	32020		\N	152255	0	70704007	78272		0
28149	1661	260139	1994-02-11	1994-02-11 00:00:00	1994-02-25	1994-02-25 00:00:00	32020		\N	111637	0	10509002	260139		0
28345	1674	4112343	2011-12-20	2011-12-20 00:00:00	2011-12-30	2011-12-30 00:00:00	32020		\N	112355	0	195662009	4112343		0
28546	1689	260139	1975-02-19	1975-02-19 00:00:00	1975-02-26	1975-02-26 00:00:00	32020		\N	113067	0	10509002	260139		0
28594	1691	40481087	1957-06-14	1957-06-14 00:00:00	1957-06-21	1957-06-21 00:00:00	32020		\N	113257	0	444814009	40481087		0
28862	1709	260139	1989-05-23	1989-05-23 00:00:00	1989-06-06	1989-06-06 00:00:00	32020		\N	114321	0	10509002	260139		0
28960	1716	378001	1959-03-06	1959-03-06 00:00:00	1959-04-05	1959-04-05 00:00:00	32020		\N	114699	0	62106007	378001		0
29140	1724	260139	1950-05-12	1950-05-12 00:00:00	1950-05-19	1950-05-19 00:00:00	32020		\N	115239	0	10509002	260139		0
29326	1737	40481087	2004-12-11	2004-12-11 00:00:00	2004-12-18	2004-12-18 00:00:00	32020		\N	116059	0	444814009	40481087		0
29462	1745	78272	1984-08-16	1984-08-16 00:00:00	1984-09-13	1984-09-13 00:00:00	32020		\N	116680	0	70704007	78272		0
29628	1753	28060	1998-04-18	1998-04-18 00:00:00	1998-04-29	1998-04-29 00:00:00	32020		\N	117204	0	43878008	28060		0
29770	1761	4230399	2014-04-21	2014-04-21 00:00:00	2014-05-21	2014-05-21 00:00:00	32020		\N	117721	0	359817006	4230399		0
30008	1776	81151	1931-08-23	1931-08-23 00:00:00	1931-09-13	1931-09-13 00:00:00	32020		\N	118801	0	44465007	81151		0
30192	1783	4112343	2001-11-01	2001-11-01 00:00:00	2001-11-13	2001-11-13 00:00:00	32020		\N	119391	0	195662009	4112343		0
30313	1789	4051466	1979-03-05	1979-03-05 00:00:00	1994-06-15	1994-06-15 00:00:00	32020		\N	119860	0	233678006	4051466		0
41064	2442	4112343	2008-09-29	2008-09-29 00:00:00	2008-10-09	2008-10-09 00:00:00	32020		\N	161933	0	195662009	4112343		0
30671	1812	4112343	2018-01-21	2018-01-21 00:00:00	2018-02-03	2018-02-03 00:00:00	32020		\N	121296	0	195662009	4112343		0
30855	1826	80180	1978-05-17	1978-05-17 00:00:00	\N	\N	32020		\N	122009	0	396275006	80180		0
30977	1834	4283893	1969-04-07	1969-04-07 00:00:00	1969-05-05	1969-05-05 00:00:00	32020		\N	122512	0	36971009	4283893		0
31156	1845	4283893	1978-02-24	1978-02-24 00:00:00	1978-06-02	1978-06-02 00:00:00	32020		\N	123346	0	36971009	4283893		0
31304	1850	40481087	1993-09-12	1993-09-12 00:00:00	1993-09-19	1993-09-19 00:00:00	32020		\N	123757	0	444814009	40481087		0
31500	1861	40481087	2002-02-13	2002-02-13 00:00:00	2002-02-27	2002-02-27 00:00:00	32020		\N	124428	0	444814009	40481087		0
31602	1870	260139	1932-07-24	1932-07-24 00:00:00	1932-07-31	1932-07-31 00:00:00	32020		\N	124916	0	10509002	260139		0
42347	2522	4112343	1986-10-09	1986-10-09 00:00:00	1986-10-20	1986-10-20 00:00:00	32020		\N	166849	0	195662009	4112343		0
21362	1281	257012	1991-11-02	1991-11-02 00:00:00	\N	\N	32020		\N	84686	0	40055000	257012		0
32045	1903	372328	1964-06-08	1964-06-08 00:00:00	1964-11-24	1964-11-24 00:00:00	32020		\N	126681	0	65363002	372328		0
21742	1306	4237458	2019-04-11	2019-04-11 00:00:00	2019-05-11	2019-05-11 00:00:00	32020		\N	86205	0	58150001	4237458		0
32373	1923	4112343	2007-08-12	2007-08-12 00:00:00	2007-08-24	2007-08-24 00:00:00	32020		\N	127969	0	195662009	4112343		0
21971	1316	260139	1953-03-23	1953-03-23 00:00:00	1953-03-30	1953-03-30 00:00:00	32020		\N	87217	0	10509002	260139		0
22231	1325	260139	2009-10-29	2009-10-29 00:00:00	2009-11-12	2009-11-12 00:00:00	32020		\N	87961	0	10509002	260139		0
22334	1333	40481087	1961-08-23	1961-08-23 00:00:00	1961-09-13	1961-09-13 00:00:00	32020		\N	88446	0	444814009	40481087		0
22517	1345	372328	1968-06-19	1968-06-19 00:00:00	1968-08-20	1968-08-20 00:00:00	32020		\N	89155	0	65363002	372328		0
22678	1354	40481087	1993-03-15	1993-03-15 00:00:00	1993-03-29	1993-03-29 00:00:00	32020		\N	89759	0	444814009	40481087		0
22854	1361	4112343	1995-11-24	1995-11-24 00:00:00	1995-12-04	1995-12-04 00:00:00	32020		\N	90328	0	195662009	4112343		0
22950	1368	80180	1992-05-26	1992-05-26 00:00:00	\N	\N	32020		\N	90681	0	396275006	80180		0
23134	1381	4027663	2007-05-27	2007-05-27 00:00:00	\N	\N	32020		\N	91573	0	13200003	4027663		0
23330	1391	40481087	1965-10-09	1965-10-09 00:00:00	1965-10-16	1965-10-16 00:00:00	32020		\N	92383	0	444814009	40481087		0
23544	1407	40481087	1999-06-27	1999-06-27 00:00:00	1999-07-04	1999-07-04 00:00:00	32020		\N	93473	0	444814009	40481087		0
23670	1412	40481087	1964-05-04	1964-05-04 00:00:00	1964-05-11	1964-05-11 00:00:00	32020		\N	94089	0	444814009	40481087		0
23901	1428	4218389	1958-09-30	1958-09-30 00:00:00	1958-11-03	1958-11-03 00:00:00	32020		\N	94966	0	39848009	4218389		0
23969	1431	4027663	1978-09-24	1978-09-24 00:00:00	\N	\N	32020		\N	95244	0	13200003	4027663		0
34706	2060	28060	1964-11-02	1964-11-02 00:00:00	1964-11-14	1964-11-14 00:00:00	32020		\N	137032	0	43878008	28060		0
34871	2071	40481087	1983-12-18	1983-12-18 00:00:00	1984-01-08	1984-01-08 00:00:00	32020		\N	137840	0	444814009	40481087		0
24470	1459	40481087	2008-12-16	2008-12-16 00:00:00	2009-01-06	2009-01-06 00:00:00	32020		\N	97218	0	444814009	40481087		0
24615	1468	313217	2015-06-03	2015-06-03 00:00:00	\N	\N	32020		\N	97794	0	49436004	313217		0
24889	1486	4027663	1982-07-03	1982-07-03 00:00:00	\N	\N	32020		\N	99138	0	13200003	4027663		0
25016	1493	40481087	1969-04-25	1969-04-25 00:00:00	1969-05-09	1969-05-09 00:00:00	32020		\N	99547	0	444814009	40481087		0
25135	1498	260139	1987-10-15	1987-10-15 00:00:00	1987-10-28	1987-10-28 00:00:00	32020		\N	99936	0	10509002	260139		0
25292	1508	4134304	2014-10-06	2014-10-06 00:00:00	2015-01-04	2015-01-04 00:00:00	32020		\N	100550	0	263102004	4134304		0
25532	1518	40481087	2001-06-08	2001-06-08 00:00:00	2001-06-15	2001-06-15 00:00:00	32020		\N	101497	0	444814009	40481087		0
25693	1526	40481087	1990-09-13	1990-09-13 00:00:00	1990-09-27	1990-09-27 00:00:00	32020		\N	102064	0	444814009	40481087		0
25880	1537	260139	2010-12-29	2010-12-29 00:00:00	2011-01-05	2011-01-05 00:00:00	32020		\N	102862	0	10509002	260139		0
26012	1542	4155034	1978-02-19	1978-02-19 00:00:00	1978-03-05	1978-03-05 00:00:00	32020		\N	103303	0	283371005	4155034		0
26172	1553	260139	1982-10-03	1982-10-03 00:00:00	1982-10-17	1982-10-17 00:00:00	32020		\N	103978	0	10509002	260139		0
26350	1563	4294548	1977-06-11	1977-06-11 00:00:00	1977-07-16	1977-07-16 00:00:00	32020		\N	104665	0	75498004	4294548		0
26441	1568	260139	1959-04-29	1959-04-29 00:00:00	1959-05-13	1959-05-13 00:00:00	32020		\N	105153	0	10509002	260139		0
26650	1578	40481087	1962-08-03	1962-08-03 00:00:00	1962-08-24	1962-08-24 00:00:00	32020		\N	106024	0	444814009	40481087		0
26840	1588	4112343	2004-02-25	2004-02-25 00:00:00	2004-03-08	2004-03-08 00:00:00	32020		\N	106614	0	195662009	4112343		0
26982	1597	4001336	1957-03-28	1957-03-28 00:00:00	1957-05-27	1957-05-27 00:00:00	32020		\N	107117	0	110030002	4001336		0
27129	1604	40481087	1995-04-06	1995-04-06 00:00:00	1995-04-20	1995-04-20 00:00:00	32020		\N	107628	0	444814009	40481087		0
27349	1612	40481087	2016-01-26	2016-01-26 00:00:00	2016-02-09	2016-02-09 00:00:00	32020		\N	108390	0	444814009	40481087		0
38021	2258	4112343	1972-11-16	1972-11-16 00:00:00	1972-11-26	1972-11-26 00:00:00	32020		\N	150075	0	195662009	4112343		0
27687	1634	372328	1939-03-08	1939-03-08 00:00:00	1939-05-19	1939-05-19 00:00:00	32020		\N	109708	0	65363002	372328		0
38376	2280	4112343	2000-08-08	2000-08-08 00:00:00	2000-08-19	2000-08-19 00:00:00	32020		\N	151608	0	195662009	4112343		0
38547	2289	4294548	1972-11-10	1972-11-10 00:00:00	1973-05-11	1973-05-11 00:00:00	32020		\N	152284	0	75498004	4294548		0
28150	1661	4142905	2018-11-16	2018-11-16 00:00:00	2019-02-14	2019-02-14 00:00:00	32020		\N	111657	0	33737001	4142905		0
28346	1674	4266809	2012-04-20	2012-04-20 00:00:00	\N	\N	32020		\N	112355	0	397881000	4266809		0
28547	1689	257012	1949-04-07	1949-04-07 00:00:00	\N	\N	32020		\N	113077	0	40055000	257012		0
28595	1691	40481087	1987-07-19	1987-07-19 00:00:00	1987-08-09	1987-08-09 00:00:00	32020		\N	113234	0	444814009	40481087		0
28863	1709	4035415	1949-11-06	1949-11-06 00:00:00	1949-12-06	1949-12-06 00:00:00	32020		\N	114220	0	239720000	4035415		0
28961	1716	4237458	2010-08-25	2010-08-25 00:00:00	2010-10-24	2010-10-24 00:00:00	32020		\N	114709	0	58150001	4237458		0
29141	1724	372328	1954-11-15	1954-11-15 00:00:00	1955-08-29	1955-08-29 00:00:00	32020		\N	115245	0	65363002	372328		0
29327	1737	317576	1970-11-13	1970-11-13 00:00:00	\N	\N	32020		\N	115995	0	53741008	317576		0
29463	1745	40481087	1993-10-31	1993-10-31 00:00:00	1993-11-14	1993-11-14 00:00:00	32020		\N	116652	0	444814009	40481087		0
29629	1753	4051466	1967-05-14	1967-05-14 00:00:00	1986-05-29	1986-05-29 00:00:00	32020		\N	117194	0	233678006	4051466		0
29771	1761	4283893	2011-09-25	2011-09-25 00:00:00	2011-10-23	2011-10-23 00:00:00	32020		\N	117759	0	36971009	4283893		0
30009	1776	40481087	1959-12-13	1959-12-13 00:00:00	1959-12-27	1959-12-27 00:00:00	32020		\N	118779	0	444814009	40481087		0
30193	1783	4112343	1979-05-09	1979-05-09 00:00:00	1979-05-18	1979-05-18 00:00:00	32020		\N	119478	0	195662009	4112343		0
30314	1789	372328	1977-09-14	1977-09-14 00:00:00	1978-02-02	1978-02-02 00:00:00	32020		\N	119879	0	65363002	372328		0
41065	2442	40481087	2014-10-06	2014-10-06 00:00:00	2014-10-27	2014-10-27 00:00:00	32020		\N	161936	0	444814009	40481087		0
30672	1812	4112343	2018-05-08	2018-05-08 00:00:00	2018-05-18	2018-05-18 00:00:00	32020		\N	121268	0	195662009	4112343		0
30856	1826	4112343	2016-01-22	2016-01-22 00:00:00	2016-01-31	2016-01-31 00:00:00	32020		\N	122018	0	195662009	4112343		0
30978	1834	40481087	1976-01-06	1976-01-06 00:00:00	1976-01-20	1976-01-20 00:00:00	32020		\N	122537	0	444814009	40481087		0
31157	1845	378001	1988-03-28	1988-03-28 00:00:00	1988-05-27	1988-05-27 00:00:00	32020		\N	123324	0	62106007	378001		0
31305	1850	260139	1999-02-20	1999-02-20 00:00:00	1999-02-27	1999-02-27 00:00:00	32020		\N	123729	0	10509002	260139		0
31510	1864	40481087	1984-08-23	1984-08-23 00:00:00	1984-08-30	1984-08-30 00:00:00	32020		\N	124554	0	444814009	40481087		0
31603	1870	40481087	1923-02-11	1923-02-11 00:00:00	1923-02-25	1923-02-25 00:00:00	32020		\N	124914	0	444814009	40481087		0
42348	2522	4112343	1979-11-01	1979-11-01 00:00:00	1979-11-11	1979-11-11 00:00:00	32020		\N	166793	0	195662009	4112343		0
21364	1281	321042	2012-07-21	2012-07-21 00:00:00	\N	\N	32020		\N	84706	0	410429000	321042		0
32046	1903	260139	2016-07-20	2016-07-20 00:00:00	2016-07-27	2016-07-27 00:00:00	32020		\N	126679	0	10509002	260139		0
21743	1306	4152936	1980-06-29	1980-06-29 00:00:00	1980-07-13	1980-07-13 00:00:00	32020		\N	86201	0	283385000	4152936		0
32374	1923	378419	2010-05-21	2010-05-21 00:00:00	\N	\N	32020		\N	127965	0	26929004	378419		0
21972	1316	4112343	2006-04-21	2006-04-21 00:00:00	2006-04-29	2006-04-29 00:00:00	32020		\N	87141	0	195662009	4112343		0
22232	1325	260139	1990-05-03	1990-05-03 00:00:00	1990-05-17	1990-05-17 00:00:00	32020		\N	87984	0	10509002	260139		0
22335	1333	4112343	2007-06-04	2007-06-04 00:00:00	2007-06-15	2007-06-15 00:00:00	32020		\N	88466	0	195662009	4112343		0
22518	1345	4152936	1996-06-05	1996-06-05 00:00:00	1996-06-26	1996-06-26 00:00:00	32020		\N	89173	0	283385000	4152936		0
22679	1354	4294548	1989-12-15	1989-12-15 00:00:00	1989-12-22	1989-12-22 00:00:00	32020		\N	89758	0	75498004	4294548		0
22855	1361	4059173	1955-01-13	1955-01-13 00:00:00	1955-03-14	1955-03-14 00:00:00	32020		\N	90289	0	16114001	4059173		0
22951	1368	40481087	1963-07-19	1963-07-19 00:00:00	1963-07-26	1963-07-26 00:00:00	32020		\N	90697	0	444814009	40481087		0
23135	1381	81893	2017-07-18	2017-07-18 00:00:00	\N	\N	32020		\N	91577	0	64766004	81893		0
23331	1391	4112343	1927-08-14	1927-08-14 00:00:00	1927-08-23	1927-08-23 00:00:00	32020		\N	92310	0	195662009	4112343		0
23545	1407	28060	2012-10-02	2012-10-02 00:00:00	2012-10-15	2012-10-15 00:00:00	32020		\N	93485	0	43878008	28060		0
23671	1412	40481087	1993-05-06	1993-05-06 00:00:00	1993-05-20	1993-05-20 00:00:00	32020		\N	93992	0	444814009	40481087		0
23902	1428	4112343	1983-03-16	1983-03-16 00:00:00	1983-03-25	1983-03-25 00:00:00	32020		\N	95027	0	195662009	4112343		0
23970	1431	40481087	1953-05-21	1953-05-21 00:00:00	1953-05-28	1953-05-28 00:00:00	32020		\N	95285	0	444814009	40481087		0
34718	2062	260139	1951-12-03	1951-12-03 00:00:00	1951-12-10	1951-12-10 00:00:00	32020		\N	137109	0	10509002	260139		0
34872	2071	4142905	1970-02-20	1970-02-20 00:00:00	1970-05-21	1970-05-21 00:00:00	32020		\N	137800	0	33737001	4142905		0
24471	1459	28060	1949-01-23	1949-01-23 00:00:00	1949-02-04	1949-02-04 00:00:00	32020		\N	97260	0	43878008	28060		0
24616	1468	40481087	1953-06-02	1953-06-02 00:00:00	1953-06-09	1953-06-09 00:00:00	32020		\N	97849	0	444814009	40481087		0
24890	1486	40481087	2007-03-24	2007-03-24 00:00:00	2007-03-31	2007-03-31 00:00:00	32020		\N	99056	0	444814009	40481087		0
25017	1493	4059173	1962-10-24	1962-10-24 00:00:00	1962-11-23	1962-11-23 00:00:00	32020		\N	99574	0	16114001	4059173		0
25136	1498	40481087	1997-08-12	1997-08-12 00:00:00	1997-08-19	1997-08-19 00:00:00	32020		\N	99937	0	444814009	40481087		0
25293	1508	40480160	2014-10-06	2014-10-06 00:00:00	2015-01-04	2015-01-04 00:00:00	32020		\N	100550	0	443165006	40480160		0
25533	1518	378001	2016-10-01	2016-10-01 00:00:00	2016-11-30	2016-11-30 00:00:00	32020		\N	101543	0	62106007	378001		0
25694	1526	80180	2012-10-05	2012-10-05 00:00:00	\N	\N	32020		\N	102054	0	396275006	80180		0
25881	1537	140673	2010-05-31	2010-05-31 00:00:00	\N	\N	32020		\N	102871	0	40930008	140673		0
26013	1542	40481087	1999-02-23	1999-02-23 00:00:00	1999-03-02	1999-03-02 00:00:00	32020		\N	103330	0	444814009	40481087		0
26173	1553	372328	1967-12-05	1967-12-05 00:00:00	1968-02-16	1968-02-16 00:00:00	32020		\N	103974	0	65363002	372328		0
26351	1563	40481087	2014-03-20	2014-03-20 00:00:00	2014-03-27	2014-03-27 00:00:00	32020		\N	104742	0	444814009	40481087		0
26442	1568	81151	1993-01-12	1993-01-12 00:00:00	1993-02-16	1993-02-16 00:00:00	32020		\N	105224	0	44465007	81151		0
26651	1578	40481087	1949-01-03	1949-01-03 00:00:00	1949-01-24	1949-01-24 00:00:00	32020		\N	105954	0	444814009	40481087		0
26841	1588	40481087	2014-01-15	2014-01-15 00:00:00	2014-01-29	2014-01-29 00:00:00	32020		\N	106617	0	444814009	40481087		0
26983	1597	4109685	1956-04-11	1956-04-11 00:00:00	1956-05-02	1956-05-02 00:00:00	32020		\N	107116	0	284551006	4109685		0
27130	1604	80180	1991-02-07	1991-02-07 00:00:00	\N	\N	32020		\N	107649	0	396275006	80180		0
27350	1612	4112343	1969-09-29	1969-09-29 00:00:00	1969-10-06	1969-10-06 00:00:00	32020		\N	108385	0	195662009	4112343		0
38022	2258	40481087	1988-09-13	1988-09-13 00:00:00	1988-10-04	1988-10-04 00:00:00	32020		\N	150043	0	444814009	40481087		0
27688	1634	257012	1944-08-02	1944-08-02 00:00:00	\N	\N	32020		\N	109768	0	40055000	257012		0
38377	2280	4283893	1983-03-20	1983-03-20 00:00:00	1983-08-21	1983-08-21 00:00:00	32020		\N	151563	0	36971009	4283893		0
38548	2289	81151	1996-05-29	1996-05-29 00:00:00	1996-06-19	1996-06-19 00:00:00	32020		\N	152253	0	44465007	81151		0
28151	1661	81151	2018-01-06	2018-01-06 00:00:00	2018-01-20	2018-01-20 00:00:00	32020		\N	111656	0	44465007	81151		0
28347	1674	80180	2012-04-20	2012-04-20 00:00:00	\N	\N	32020		\N	112355	0	396275006	80180		0
28548	1689	4112343	1967-01-02	1967-01-02 00:00:00	1967-01-11	1967-01-11 00:00:00	32020		\N	113094	0	195662009	4112343		0
28596	1691	372328	1946-01-04	1946-01-04 00:00:00	1946-06-20	1946-06-20 00:00:00	32020		\N	113291	0	65363002	372328		0
28864	1709	40481087	1989-10-14	1989-10-14 00:00:00	1989-10-21	1989-10-21 00:00:00	32020		\N	114266	0	444814009	40481087		0
28962	1716	40481087	2012-12-15	2012-12-15 00:00:00	2012-12-29	2012-12-29 00:00:00	32020		\N	114652	0	444814009	40481087		0
29142	1724	4283893	1967-10-23	1967-10-23 00:00:00	1967-11-27	1967-11-27 00:00:00	32020		\N	115249	0	36971009	4283893		0
29328	1737	378001	1937-10-10	1937-10-10 00:00:00	1937-11-09	1937-11-09 00:00:00	32020		\N	115960	0	62106007	378001		0
29464	1745	40481087	1982-02-07	1982-02-07 00:00:00	1982-02-28	1982-02-28 00:00:00	32020		\N	116671	0	444814009	40481087		0
29630	1753	4113008	1968-05-16	1968-05-16 00:00:00	1968-05-30	1968-05-30 00:00:00	32020		\N	117163	0	284549007	4113008		0
29772	1761	260139	1967-07-09	1967-07-09 00:00:00	1967-07-23	1967-07-23 00:00:00	32020		\N	117787	0	10509002	260139		0
30010	1776	260139	1977-05-08	1977-05-08 00:00:00	1977-05-15	1977-05-15 00:00:00	32020		\N	118783	0	10509002	260139		0
30194	1783	378001	1989-06-03	1989-06-03 00:00:00	1989-07-03	1989-07-03 00:00:00	32020		\N	119443	0	62106007	378001		0
30315	1789	28060	2014-09-10	2014-09-10 00:00:00	2014-09-21	2014-09-21 00:00:00	32020		\N	119877	0	43878008	28060		0
41066	2442	81151	1997-07-25	1997-07-25 00:00:00	1997-08-15	1997-08-15 00:00:00	32020		\N	161961	0	44465007	81151		0
30673	1812	4278672	2005-09-28	2005-09-28 00:00:00	2005-11-27	2005-11-27 00:00:00	32020		\N	121298	0	65966004	4278672		0
30857	1826	40481087	1947-12-22	1947-12-22 00:00:00	1947-12-29	1947-12-29 00:00:00	32020		\N	122042	0	444814009	40481087		0
30979	1834	40481087	1979-11-19	1979-11-19 00:00:00	1979-12-03	1979-12-03 00:00:00	32020		\N	122513	0	444814009	40481087		0
31158	1845	40481087	1998-10-30	1998-10-30 00:00:00	1998-11-13	1998-11-13 00:00:00	32020		\N	123321	0	444814009	40481087		0
31306	1850	4155034	1963-01-17	1963-01-17 00:00:00	1963-02-07	1963-02-07 00:00:00	32020		\N	123733	0	283371005	4155034		0
31511	1864	40481087	2006-11-07	2006-11-07 00:00:00	2006-11-28	2006-11-28 00:00:00	32020		\N	124512	0	444814009	40481087		0
31634	1874	378001	1975-08-02	1975-08-02 00:00:00	1975-10-01	1975-10-01 00:00:00	32020		\N	125102	0	62106007	378001		0
42349	2522	40481087	1966-01-05	1966-01-05 00:00:00	1966-01-19	1966-01-19 00:00:00	32020		\N	166791	0	444814009	40481087		0
21365	1281	4112343	2000-07-09	2000-07-09 00:00:00	2000-07-20	2000-07-20 00:00:00	32020		\N	84698	0	195662009	4112343		0
32047	1903	4112343	2010-07-16	2010-07-16 00:00:00	2010-07-26	2010-07-26 00:00:00	32020		\N	126700	0	195662009	4112343		0
21744	1306	195588	2008-09-16	2008-09-16 00:00:00	2008-10-31	2008-10-31 00:00:00	32020		\N	86195	0	38822007	195588		0
32375	1923	40481087	2016-09-02	2016-09-02 00:00:00	2016-09-23	2016-09-23 00:00:00	32020		\N	127971	0	444814009	40481087		0
21973	1316	260139	1949-12-22	1949-12-22 00:00:00	1950-01-05	1950-01-05 00:00:00	32020		\N	87225	0	10509002	260139		0
22233	1325	40481087	1978-07-03	1978-07-03 00:00:00	1978-07-10	1978-07-10 00:00:00	32020		\N	87958	0	444814009	40481087		0
22336	1333	40481087	1978-12-24	1978-12-24 00:00:00	1979-01-07	1979-01-07 00:00:00	32020		\N	88454	0	444814009	40481087		0
22519	1345	4027663	1997-03-07	1997-03-07 00:00:00	\N	\N	32020		\N	89173	0	13200003	4027663		0
22680	1354	4294548	2011-11-25	2011-11-25 00:00:00	2012-03-30	2012-03-30 00:00:00	32020		\N	89763	0	75498004	4294548		0
22856	1361	4155034	1987-06-22	1987-06-22 00:00:00	1987-07-06	1987-07-06 00:00:00	32020		\N	90291	0	283371005	4155034		0
22952	1368	40481087	2018-09-13	2018-09-13 00:00:00	2018-09-27	2018-09-27 00:00:00	32020		\N	90665	0	444814009	40481087		0
23136	1381	260139	1990-01-03	1990-01-03 00:00:00	1990-01-10	1990-01-10 00:00:00	32020		\N	91567	0	10509002	260139		0
23332	1391	4112343	1954-08-14	1954-08-14 00:00:00	1954-08-21	1954-08-21 00:00:00	32020		\N	92345	0	195662009	4112343		0
23546	1407	4294548	1995-12-24	1995-12-24 00:00:00	1996-07-07	1996-07-07 00:00:00	32020		\N	93455	0	75498004	4294548		0
23672	1412	4112343	1995-07-20	1995-07-20 00:00:00	1995-07-29	1995-07-29 00:00:00	32020		\N	93984	0	195662009	4112343		0
23903	1428	80180	1984-03-30	1984-03-30 00:00:00	\N	\N	32020		\N	95027	0	396275006	80180		0
23971	1431	4084167	1950-05-29	1950-05-29 00:00:00	1950-05-30	1950-05-30 00:00:00	32020		\N	95248	0	241929008	4084167		0
34719	2062	4237458	2006-02-16	2006-02-16 00:00:00	2006-05-17	2006-05-17 00:00:00	32020		\N	137200	0	58150001	4237458		0
34879	2073	260139	2007-11-18	2007-11-18 00:00:00	2007-11-25	2007-11-25 00:00:00	32020		\N	137924	0	10509002	260139		0
24472	1459	4112343	1981-10-28	1981-10-28 00:00:00	1981-11-05	1981-11-05 00:00:00	32020		\N	97262	0	195662009	4112343		0
24617	1468	4112343	1958-09-12	1958-09-12 00:00:00	1958-09-20	1958-09-20 00:00:00	32020		\N	97851	0	195662009	4112343		0
24891	1486	40481087	1972-02-07	1972-02-07 00:00:00	1972-02-21	1972-02-21 00:00:00	32020		\N	99006	0	444814009	40481087		0
25018	1493	378001	1996-03-13	1996-03-13 00:00:00	1996-05-12	1996-05-12 00:00:00	32020		\N	99577	0	62106007	378001		0
25137	1498	40481087	2008-08-25	2008-08-25 00:00:00	2008-09-15	2008-09-15 00:00:00	32020		\N	99974	0	444814009	40481087		0
25294	1508	80502	1984-12-11	1984-12-11 00:00:00	\N	\N	32020		\N	100596	0	64859006	80502		0
25534	1518	40481087	1982-01-04	1982-01-04 00:00:00	1982-01-25	1982-01-25 00:00:00	32020		\N	101512	0	444814009	40481087		0
25695	1526	372328	1974-05-18	1974-05-18 00:00:00	1974-06-01	1974-06-01 00:00:00	32020		\N	102086	0	65363002	372328		0
25882	1537	378001	1962-12-23	1962-12-23 00:00:00	1963-02-21	1963-02-21 00:00:00	32020		\N	102885	0	62106007	378001		0
26014	1543	4035415	1957-03-25	1957-03-25 00:00:00	1957-05-24	1957-05-24 00:00:00	32020		\N	103422	0	239720000	4035415		0
26174	1553	4059173	1968-01-04	1968-01-04 00:00:00	1968-04-03	1968-04-03 00:00:00	32020		\N	103937	0	16114001	4059173		0
26352	1563	40481087	2001-08-13	2001-08-13 00:00:00	2001-08-20	2001-08-20 00:00:00	32020		\N	104677	0	444814009	40481087		0
26443	1568	80180	1993-05-13	1993-05-13 00:00:00	\N	\N	32020		\N	105224	0	396275006	80180		0
26652	1578	4112343	1997-04-19	1997-04-19 00:00:00	1997-05-02	1997-05-02 00:00:00	32020		\N	105957	0	195662009	4112343		0
26842	1588	40481087	1985-08-11	1985-08-11 00:00:00	1985-08-18	1985-08-18 00:00:00	32020		\N	106627	0	444814009	40481087		0
26984	1597	4155034	1994-07-18	1994-07-18 00:00:00	1994-08-01	1994-08-01 00:00:00	32020		\N	107196	0	283371005	4155034		0
27131	1604	4112343	1959-09-27	1959-09-27 00:00:00	1959-10-10	1959-10-10 00:00:00	32020		\N	107625	0	195662009	4112343		0
27351	1612	40481087	1980-11-28	1980-11-28 00:00:00	1980-12-12	1980-12-12 00:00:00	32020		\N	108364	0	444814009	40481087		0
38023	2258	4112343	1999-04-06	1999-04-06 00:00:00	1999-04-15	1999-04-15 00:00:00	32020		\N	150086	0	195662009	4112343		0
27689	1634	372328	1941-01-08	1941-01-08 00:00:00	1941-02-14	1941-02-14 00:00:00	32020		\N	109731	0	65363002	372328		0
38378	2280	40479768	1997-04-08	1997-04-08 00:00:00	1997-05-15	1997-05-15 00:00:00	32020		\N	151558	0	444470001	40479768		0
38549	2289	81151	1975-08-13	1975-08-13 00:00:00	1975-09-17	1975-09-17 00:00:00	32020		\N	152252	0	44465007	81151		0
28152	1661	260139	2017-03-31	2017-03-31 00:00:00	2017-04-14	2017-04-14 00:00:00	32020		\N	111694	0	10509002	260139		0
28348	1674	40481087	1994-03-05	1994-03-05 00:00:00	1994-03-19	1994-03-19 00:00:00	32020		\N	112391	0	444814009	40481087		0
28549	1689	4112343	2007-02-06	2007-02-06 00:00:00	2007-02-19	2007-02-19 00:00:00	32020		\N	113124	0	195662009	4112343		0
28597	1691	260139	2005-06-01	2005-06-01 00:00:00	2005-06-08	2005-06-08 00:00:00	32020		\N	113236	0	10509002	260139		0
28865	1709	4112343	1955-04-28	1955-04-28 00:00:00	1955-05-06	1955-05-06 00:00:00	32020		\N	114298	0	195662009	4112343		0
28963	1716	81151	1966-01-26	1966-01-26 00:00:00	1966-03-02	1966-03-02 00:00:00	32020		\N	114701	0	44465007	81151		0
29143	1724	257012	2009-12-26	2009-12-26 00:00:00	\N	\N	32020		\N	115321	0	40055000	257012		0
29329	1737	4112343	1935-08-15	1935-08-15 00:00:00	1935-08-28	1935-08-28 00:00:00	32020		\N	115977	0	195662009	4112343		0
29465	1745	40481087	1986-07-13	1986-07-13 00:00:00	1986-08-03	1986-08-03 00:00:00	32020		\N	116651	0	444814009	40481087		0
29631	1753	40481087	1970-01-29	1970-01-29 00:00:00	1970-02-19	1970-02-19 00:00:00	32020		\N	117210	0	444814009	40481087		0
29773	1761	40481087	1980-04-25	1980-04-25 00:00:00	1980-05-17	1980-05-17 00:00:00	32020		\N	117788	0	444814009	40481087		0
30011	1776	4278672	1922-09-09	1922-09-09 00:00:00	1922-12-08	1922-12-08 00:00:00	32020		\N	118800	0	65966004	4278672		0
30195	1783	40481087	1995-08-15	1995-08-15 00:00:00	1995-08-29	1995-08-29 00:00:00	32020		\N	119525	0	444814009	40481087		0
30331	1791	81151	1997-08-31	1997-08-31 00:00:00	1997-09-28	1997-09-28 00:00:00	32020		\N	120059	0	44465007	81151		0
41067	2442	4112343	1978-12-06	1978-12-06 00:00:00	1978-12-19	1978-12-19 00:00:00	32020		\N	161920	0	195662009	4112343		0
30674	1812	260139	2005-09-02	2005-09-02 00:00:00	2005-09-16	2005-09-16 00:00:00	32020		\N	121294	0	10509002	260139		0
30858	1826	4027663	1971-02-28	1971-02-28 00:00:00	\N	\N	32020		\N	122006	0	13200003	4027663		0
30980	1834	4112343	1954-10-22	1954-10-22 00:00:00	1954-11-04	1954-11-04 00:00:00	32020		\N	122464	0	195662009	4112343		0
31159	1845	4112343	1962-01-17	1962-01-17 00:00:00	1962-01-30	1962-01-30 00:00:00	32020		\N	123269	0	195662009	4112343		0
31307	1850	81151	1957-12-09	1957-12-09 00:00:00	1957-12-30	1957-12-30 00:00:00	32020		\N	123730	0	44465007	81151		0
31512	1864	260139	2008-04-22	2008-04-22 00:00:00	2008-04-29	2008-04-29 00:00:00	32020		\N	124564	0	10509002	260139		0
31635	1874	378001	2014-08-03	2014-08-03 00:00:00	2014-09-02	2014-09-02 00:00:00	32020		\N	125106	0	62106007	378001		0
42350	2522	4237458	2000-07-24	2000-07-24 00:00:00	2000-09-22	2000-09-22 00:00:00	32020		\N	166789	0	58150001	4237458		0
21366	1281	372328	1973-12-02	1973-12-02 00:00:00	1974-12-14	1974-12-14 00:00:00	32020		\N	84667	0	65363002	372328		0
32048	1903	40481087	2009-10-14	2009-10-14 00:00:00	2009-11-04	2009-11-04 00:00:00	32020		\N	126708	0	444814009	40481087		0
21745	1306	28060	1959-05-28	1959-05-28 00:00:00	1959-06-07	1959-06-07 00:00:00	32020		\N	86238	0	43878008	28060		0
32376	1923	4112343	1999-03-17	1999-03-17 00:00:00	1999-03-25	1999-03-25 00:00:00	32020		\N	127922	0	195662009	4112343		0
21974	1316	28060	2004-08-16	2004-08-16 00:00:00	2004-08-26	2004-08-26 00:00:00	32020		\N	87229	0	43878008	28060		0
22234	1325	4109685	1989-12-27	1989-12-27 00:00:00	1990-01-10	1990-01-10 00:00:00	32020		\N	87937	0	284551006	4109685		0
22337	1333	40481087	1957-02-25	1957-02-25 00:00:00	1957-03-11	1957-03-11 00:00:00	32020		\N	88403	0	444814009	40481087		0
22520	1345	80180	2005-04-19	2005-04-19 00:00:00	\N	\N	32020		\N	89106	0	396275006	80180		0
22681	1354	260139	1980-06-26	1980-06-26 00:00:00	1980-07-03	1980-07-03 00:00:00	32020		\N	89723	0	10509002	260139		0
22857	1361	4112343	1954-10-02	1954-10-02 00:00:00	1954-10-09	1954-10-09 00:00:00	32020		\N	90344	0	195662009	4112343		0
22953	1368	40481087	1997-10-12	1997-10-12 00:00:00	1997-10-26	1997-10-26 00:00:00	32020		\N	90663	0	444814009	40481087		0
23137	1381	40481087	1997-11-18	1997-11-18 00:00:00	1997-12-02	1997-12-02 00:00:00	32020		\N	91568	0	444814009	40481087		0
23333	1391	40481087	1931-12-03	1931-12-03 00:00:00	1931-12-10	1931-12-10 00:00:00	32020		\N	92344	0	444814009	40481087		0
23547	1407	81151	1986-06-28	1986-06-28 00:00:00	1986-07-19	1986-07-19 00:00:00	32020		\N	93564	0	44465007	81151		0
23673	1412	4155034	1987-08-14	1987-08-14 00:00:00	1987-09-04	1987-09-04 00:00:00	32020		\N	94040	0	283371005	4155034		0
23904	1428	4112343	1995-11-19	1995-11-19 00:00:00	1995-12-02	1995-12-02 00:00:00	32020		\N	95047	0	195662009	4112343		0
23972	1431	372328	1954-07-28	1954-07-28 00:00:00	1954-09-11	1954-09-11 00:00:00	32020		\N	95308	0	65363002	372328		0
34720	2062	40481087	1999-04-07	1999-04-07 00:00:00	1999-04-28	1999-04-28 00:00:00	32020		\N	137171	0	444814009	40481087		0
34880	2073	40481087	2009-08-22	2009-08-22 00:00:00	2009-08-29	2009-08-29 00:00:00	32020		\N	137936	0	444814009	40481087		0
24473	1459	372328	1943-02-08	1943-02-08 00:00:00	1943-03-18	1943-03-18 00:00:00	32020		\N	97264	0	65363002	372328		0
24618	1468	4112343	1983-01-11	1983-01-11 00:00:00	1983-01-20	1983-01-20 00:00:00	32020		\N	97861	0	195662009	4112343		0
24892	1486	81151	1970-08-20	1970-08-20 00:00:00	1970-09-03	1970-09-03 00:00:00	32020		\N	99028	0	44465007	81151		0
25019	1493	4294548	1967-06-07	1967-06-07 00:00:00	1967-06-28	1967-06-28 00:00:00	32020		\N	99579	0	75498004	4294548		0
25138	1498	260139	2015-04-17	2015-04-17 00:00:00	2015-05-01	2015-05-01 00:00:00	32020		\N	99975	0	10509002	260139		0
25295	1508	81151	1934-03-09	1934-03-09 00:00:00	1934-03-30	1934-03-30 00:00:00	32020		\N	100544	0	44465007	81151		0
25535	1518	4112343	1978-06-21	1978-06-21 00:00:00	1978-07-03	1978-07-03 00:00:00	32020		\N	101493	0	195662009	4112343		0
25696	1526	4112343	1988-04-04	1988-04-04 00:00:00	1988-04-15	1988-04-15 00:00:00	32020		\N	102056	0	195662009	4112343		0
25883	1537	260139	1956-08-13	1956-08-13 00:00:00	1956-08-27	1956-08-27 00:00:00	32020		\N	102846	0	10509002	260139		0
26015	1543	40481087	1983-01-13	1983-01-13 00:00:00	1983-02-03	1983-02-03 00:00:00	32020		\N	103430	0	444814009	40481087		0
26175	1553	4155034	1990-06-28	1990-06-28 00:00:00	1990-07-19	1990-07-19 00:00:00	32020		\N	103939	0	283371005	4155034		0
26353	1563	40481087	2018-03-22	2018-03-22 00:00:00	2018-03-29	2018-03-29 00:00:00	32020		\N	104718	0	444814009	40481087		0
26444	1568	4112343	1999-02-10	1999-02-10 00:00:00	1999-02-18	1999-02-18 00:00:00	32020		\N	105177	0	195662009	4112343		0
26653	1578	260139	1948-02-02	1948-02-02 00:00:00	1948-02-09	1948-02-09 00:00:00	32020		\N	105973	0	10509002	260139		0
26843	1588	40481087	1998-12-11	1998-12-11 00:00:00	1999-01-01	1999-01-01 00:00:00	32020		\N	106644	0	444814009	40481087		0
26985	1597	28060	2006-03-11	2006-03-11 00:00:00	2006-03-20	2006-03-20 00:00:00	32020		\N	107161	0	43878008	28060		0
27132	1604	4310024	1989-02-17	1989-02-17 00:00:00	\N	\N	32020		\N	107596	0	424802006	4310024		0
27352	1612	4112343	2011-08-28	2011-08-28 00:00:00	2011-09-08	2011-09-08 00:00:00	32020		\N	108389	0	195662009	4112343		0
38024	2258	81151	1981-03-09	1981-03-09 00:00:00	1981-04-06	1981-04-06 00:00:00	32020		\N	150059	0	44465007	81151		0
27690	1634	4278672	1966-12-11	1966-12-11 00:00:00	1967-02-09	1967-02-09 00:00:00	32020		\N	109687	0	65966004	4278672		0
38379	2280	372328	1972-04-19	1972-04-19 00:00:00	1972-05-10	1972-05-10 00:00:00	32020		\N	151609	0	65363002	372328		0
38550	2289	4156265	2000-07-28	2000-07-28 00:00:00	2000-08-18	2000-08-18 00:00:00	32020		\N	152254	0	370247008	4156265		0
28153	1661	4237458	1991-06-13	1991-06-13 00:00:00	1991-08-12	1991-08-12 00:00:00	32020		\N	111654	0	58150001	4237458		0
28349	1674	192671	2012-04-27	2012-04-27 00:00:00	\N	\N	32020		\N	112389	0	K92.2	35208414		0
28550	1689	4112343	1953-01-07	1953-01-07 00:00:00	1953-01-19	1953-01-19 00:00:00	32020		\N	113066	0	195662009	4112343		0
28598	1691	40481087	2000-10-14	2000-10-14 00:00:00	2000-11-04	2000-11-04 00:00:00	32020		\N	113225	0	444814009	40481087		0
28866	1709	81151	1953-10-16	1953-10-16 00:00:00	1953-11-20	1953-11-20 00:00:00	32020		\N	114222	0	44465007	81151		0
28964	1716	40481087	1994-12-30	1994-12-30 00:00:00	1995-01-13	1995-01-13 00:00:00	32020		\N	114750	0	444814009	40481087		0
29144	1724	260139	2015-06-30	2015-06-30 00:00:00	2015-07-14	2015-07-14 00:00:00	32020		\N	115326	0	10509002	260139		0
29330	1737	78272	1958-10-18	1958-10-18 00:00:00	1958-11-22	1958-11-22 00:00:00	32020		\N	115962	0	70704007	78272		0
29466	1745	260139	2018-03-18	2018-03-18 00:00:00	2018-03-25	2018-03-25 00:00:00	32020		\N	116653	0	10509002	260139		0
29632	1753	40481087	2008-03-23	2008-03-23 00:00:00	2008-03-30	2008-03-30 00:00:00	32020		\N	117206	0	444814009	40481087		0
29774	1761	40481087	1965-06-13	1965-06-13 00:00:00	1965-06-20	1965-06-20 00:00:00	32020		\N	117705	0	444814009	40481087		0
30012	1776	372328	1920-01-28	1920-01-28 00:00:00	1920-04-03	1920-04-03 00:00:00	32020		\N	118796	0	65363002	372328		0
30196	1783	260139	1968-04-11	1968-04-11 00:00:00	1968-04-18	1968-04-18 00:00:00	32020		\N	119414	0	10509002	260139		0
30332	1791	81151	2006-06-13	2006-06-13 00:00:00	2006-07-04	2006-07-04 00:00:00	32020		\N	120060	0	44465007	81151		0
41068	2442	40481087	1982-11-02	1982-11-02 00:00:00	1982-11-16	1982-11-16 00:00:00	32020		\N	161931	0	444814009	40481087		0
30675	1812	260139	1973-01-21	1973-01-21 00:00:00	1973-02-04	1973-02-04 00:00:00	32020		\N	121246	0	10509002	260139		0
30859	1826	260139	1997-12-25	1997-12-25 00:00:00	1998-01-08	1998-01-08 00:00:00	32020		\N	122067	0	10509002	260139		0
30981	1834	4134304	1955-11-18	1955-11-18 00:00:00	1955-12-18	1955-12-18 00:00:00	32020		\N	122540	0	263102004	4134304		0
31160	1845	378001	1974-04-11	1974-04-11 00:00:00	1974-05-11	1974-05-11 00:00:00	32020		\N	123323	0	62106007	378001		0
31308	1851	260139	2000-11-08	2000-11-08 00:00:00	2000-11-15	2000-11-15 00:00:00	32020		\N	123858	0	10509002	260139		0
31513	1864	372328	1971-02-05	1971-02-05 00:00:00	1971-10-15	1971-10-15 00:00:00	32020		\N	124539	0	65363002	372328		0
31636	1874	4112343	2014-12-22	2014-12-22 00:00:00	2014-12-30	2014-12-30 00:00:00	32020		\N	125121	0	195662009	4112343		0
42351	2522	4294548	2014-08-09	2014-08-09 00:00:00	2014-08-23	2014-08-23 00:00:00	32020		\N	166822	0	75498004	4294548		0
21367	1281	40481087	1997-08-01	1997-08-01 00:00:00	1997-08-15	1997-08-15 00:00:00	32020		\N	84696	0	444814009	40481087		0
32049	1903	40481087	2001-05-14	2001-05-14 00:00:00	2001-05-21	2001-05-21 00:00:00	32020		\N	126707	0	444814009	40481087		0
21746	1306	40481087	2006-07-28	2006-07-28 00:00:00	2006-08-04	2006-08-04 00:00:00	32020		\N	86194	0	444814009	40481087		0
32377	1923	4218389	1953-06-13	1953-06-13 00:00:00	1953-07-11	1953-07-11 00:00:00	32020		\N	127998	0	39848009	4218389		0
21975	1316	80180	1994-05-03	1994-05-03 00:00:00	\N	\N	32020		\N	87201	0	396275006	80180		0
32722	1945	4278672	1972-11-17	1972-11-17 00:00:00	1973-01-16	1973-01-16 00:00:00	32020		\N	129241	0	65966004	4278672		0
22338	1333	4218389	1976-12-06	1976-12-06 00:00:00	1977-01-10	1977-01-10 00:00:00	32020		\N	88414	0	39848009	4218389		0
22521	1345	80809	2005-03-05	2005-03-05 00:00:00	2009-06-12	2009-06-12 00:00:00	32020		\N	89106	0	69896004	80809		0
22682	1354	80180	2019-06-16	2019-06-16 00:00:00	\N	\N	32020		\N	89720	0	396275006	80180		0
22858	1361	260139	2008-08-28	2008-08-28 00:00:00	2008-09-11	2008-09-11 00:00:00	32020		\N	90374	0	10509002	260139		0
22954	1368	260139	1971-07-03	1971-07-03 00:00:00	1971-07-17	1971-07-17 00:00:00	32020		\N	90707	0	10509002	260139		0
23138	1381	4059173	1982-02-12	1982-02-12 00:00:00	1982-03-14	1982-03-14 00:00:00	32020		\N	91563	0	16114001	4059173		0
23334	1391	40481087	1947-12-14	1947-12-14 00:00:00	1947-12-21	1947-12-21 00:00:00	32020		\N	92396	0	444814009	40481087		0
23548	1407	40481087	2009-11-13	2009-11-13 00:00:00	2009-11-20	2009-11-20 00:00:00	32020		\N	93474	0	444814009	40481087		0
23674	1412	4051466	1963-05-20	1963-05-20 00:00:00	1980-08-21	1980-08-21 00:00:00	32020		\N	94078	0	233678006	4051466		0
34382	2041	40481087	2009-02-23	2009-02-23 00:00:00	2009-03-16	2009-03-16 00:00:00	32020		\N	135813	0	444814009	40481087		0
23973	1431	260139	2019-03-21	2019-03-21 00:00:00	2019-04-04	2019-04-04 00:00:00	32020		\N	95307	0	10509002	260139		0
34721	2062	40481087	1977-06-08	1977-06-08 00:00:00	1977-06-22	1977-06-22 00:00:00	32020		\N	137169	0	444814009	40481087		0
34881	2073	80180	2003-12-22	2003-12-22 00:00:00	\N	\N	32020		\N	137914	0	396275006	80180		0
24474	1459	4296204	1944-11-29	1944-11-29 00:00:00	1944-12-20	1944-12-20 00:00:00	32020		\N	97247	0	403190006	4296204		0
24619	1468	40481087	2000-03-08	2000-03-08 00:00:00	2000-03-15	2000-03-15 00:00:00	32020		\N	97797	0	444814009	40481087		0
24893	1486	40481087	1975-10-22	1975-10-22 00:00:00	1975-11-12	1975-11-12 00:00:00	32020		\N	99142	0	444814009	40481087		0
25020	1493	40481087	1980-07-31	1980-07-31 00:00:00	1980-08-07	1980-08-07 00:00:00	32020		\N	99580	0	444814009	40481087		0
25152	1500	40481087	1985-02-20	1985-02-20 00:00:00	1985-02-27	1985-02-27 00:00:00	32020		\N	100128	0	444814009	40481087		0
25296	1508	4156265	1943-01-12	1943-01-12 00:00:00	1943-01-26	1943-01-26 00:00:00	32020		\N	100545	0	370247008	4156265		0
25536	1518	378001	1984-05-01	1984-05-01 00:00:00	1984-05-31	1984-05-31 00:00:00	32020		\N	101487	0	62106007	378001		0
25706	1528	260139	1971-03-31	1971-03-31 00:00:00	1971-04-07	1971-04-07 00:00:00	32020		\N	102244	0	10509002	260139		0
25884	1537	40481087	1976-10-22	1976-10-22 00:00:00	1976-11-12	1976-11-12 00:00:00	32020		\N	102868	0	444814009	40481087		0
26016	1543	40481087	1945-08-24	1945-08-24 00:00:00	1945-09-14	1945-09-14 00:00:00	32020		\N	103425	0	444814009	40481087		0
26176	1553	260139	1969-03-30	1969-03-30 00:00:00	1969-04-06	1969-04-06 00:00:00	32020		\N	103991	0	10509002	260139		0
26364	1565	40481087	1992-08-13	1992-08-13 00:00:00	1992-09-03	1992-09-03 00:00:00	32020		\N	104938	0	444814009	40481087		0
26445	1568	4112343	2009-06-27	2009-06-27 00:00:00	2009-07-08	2009-07-08 00:00:00	32020		\N	105187	0	195662009	4112343		0
26654	1578	81151	1954-01-29	1954-01-29 00:00:00	1954-02-19	1954-02-19 00:00:00	32020		\N	105969	0	44465007	81151		0
26848	1590	40481087	2000-01-13	2000-01-13 00:00:00	2000-01-27	2000-01-27 00:00:00	32020		\N	106717	0	444814009	40481087		0
26986	1597	260139	1954-07-08	1954-07-08 00:00:00	1954-07-22	1954-07-22 00:00:00	32020		\N	107169	0	10509002	260139		0
27133	1604	30753	1989-11-14	1989-11-14 00:00:00	\N	\N	32020		\N	107596	0	16761005	30753		0
27353	1612	40481087	1998-09-15	1998-09-15 00:00:00	1998-09-29	1998-09-29 00:00:00	32020		\N	108383	0	444814009	40481087		0
38025	2258	4112343	2008-04-13	2008-04-13 00:00:00	2008-04-21	2008-04-21 00:00:00	32020		\N	150044	0	195662009	4112343		0
27691	1634	4296204	2008-01-17	2008-01-17 00:00:00	2008-01-31	2008-01-31 00:00:00	32020		\N	109690	0	403190006	4296204		0
38380	2280	4048171	1974-06-10	1974-06-10 00:00:00	\N	\N	32020		\N	151617	0	232353008	4048171		0
38551	2289	4113008	1961-11-19	1961-11-19 00:00:00	1961-12-10	1961-12-10 00:00:00	32020		\N	152249	0	284549007	4113008		0
28154	1661	40481087	1980-02-24	1980-02-24 00:00:00	1980-03-16	1980-03-16 00:00:00	32020		\N	111683	0	444814009	40481087		0
28350	1674	260139	2013-11-01	2013-11-01 00:00:00	2013-11-15	2013-11-15 00:00:00	32020		\N	112393	0	10509002	260139		0
28551	1689	260139	1986-06-08	1986-06-08 00:00:00	1986-06-22	1986-06-22 00:00:00	32020		\N	113121	0	10509002	260139		0
28599	1691	81151	1953-01-27	1953-01-27 00:00:00	1953-03-03	1953-03-03 00:00:00	32020		\N	113252	0	44465007	81151		0
28867	1709	372328	1940-04-22	1940-04-22 00:00:00	1940-08-24	1940-08-24 00:00:00	32020		\N	114260	0	65363002	372328		0
28965	1716	4283893	1966-08-23	1966-08-23 00:00:00	1966-09-13	1966-09-13 00:00:00	32020		\N	114644	0	36971009	4283893		0
29145	1724	40481087	1995-02-08	1995-02-08 00:00:00	1995-02-15	1995-02-15 00:00:00	32020		\N	115279	0	444814009	40481087		0
29331	1737	78272	1923-01-22	1923-01-22 00:00:00	1923-02-26	1923-02-26 00:00:00	32020		\N	115959	0	70704007	78272		0
29467	1745	40481087	1994-02-20	1994-02-20 00:00:00	1994-03-06	1994-03-06 00:00:00	32020		\N	116694	0	444814009	40481087		0
29633	1753	372328	1965-04-02	1965-04-02 00:00:00	1965-05-13	1965-05-13 00:00:00	32020		\N	117208	0	65363002	372328		0
29775	1761	260139	1995-09-30	1995-09-30 00:00:00	1995-10-07	1995-10-07 00:00:00	32020		\N	117757	0	10509002	260139		0
30013	1776	81151	1920-09-07	1920-09-07 00:00:00	1920-10-05	1920-10-05 00:00:00	32020		\N	118798	0	44465007	81151		0
30197	1783	40481087	1995-02-01	1995-02-01 00:00:00	1995-02-08	1995-02-08 00:00:00	32020		\N	119389	0	444814009	40481087		0
30333	1791	260139	1969-12-30	1969-12-30 00:00:00	1970-01-13	1970-01-13 00:00:00	32020		\N	120089	0	10509002	260139		0
41069	2442	4112343	1977-12-19	1977-12-19 00:00:00	1977-12-28	1977-12-28 00:00:00	32020		\N	162008	0	195662009	4112343		0
30676	1812	378001	1988-07-29	1988-07-29 00:00:00	1988-08-28	1988-08-28 00:00:00	32020		\N	121297	0	62106007	378001		0
30860	1826	40481087	2013-04-19	2013-04-19 00:00:00	2013-04-26	2013-04-26 00:00:00	32020		\N	122068	0	444814009	40481087		0
30982	1834	40481087	2007-08-31	2007-08-31 00:00:00	2007-09-07	2007-09-07 00:00:00	32020		\N	122489	0	444814009	40481087		0
31161	1845	378001	1965-02-27	1965-02-27 00:00:00	1965-03-29	1965-03-29 00:00:00	32020		\N	123322	0	62106007	378001		0
31309	1851	372328	1982-11-01	1982-11-01 00:00:00	1982-11-15	1982-11-15 00:00:00	32020		\N	123811	0	65363002	372328		0
31514	1864	4116491	2012-11-21	2012-11-21 00:00:00	2012-12-26	2012-12-26 00:00:00	32020		\N	124565	0	301011002	4116491		0
31637	1874	260139	1982-04-29	1982-04-29 00:00:00	1982-05-06	1982-05-06 00:00:00	32020		\N	125129	0	10509002	260139		0
42352	2522	40481087	1973-08-02	1973-08-02 00:00:00	1973-08-09	1973-08-09 00:00:00	32020		\N	166792	0	444814009	40481087		0
21368	1281	4156265	2002-10-12	2002-10-12 00:00:00	2002-11-02	2002-11-02 00:00:00	32020		\N	84704	0	370247008	4156265		0
32050	1903	4218389	2014-01-29	2014-01-29 00:00:00	2014-02-26	2014-02-26 00:00:00	32020		\N	126668	0	39848009	4218389		0
32212	1915	40481087	2011-03-03	2011-03-03 00:00:00	2011-03-24	2011-03-24 00:00:00	32020		\N	127357	0	444814009	40481087		0
32378	1923	40481087	1994-10-16	1994-10-16 00:00:00	1994-11-06	1994-11-06 00:00:00	32020		\N	127921	0	444814009	40481087		0
21976	1316	4266809	1994-05-03	1994-05-03 00:00:00	\N	\N	32020		\N	87201	0	397881000	4266809		0
32723	1945	372328	1972-08-02	1972-08-02 00:00:00	1972-11-04	1972-11-04 00:00:00	32020		\N	129214	0	65363002	372328		0
22339	1333	28060	1969-04-02	1969-04-02 00:00:00	1969-04-09	1969-04-09 00:00:00	32020		\N	88441	0	43878008	28060		0
22522	1345	40481087	1967-11-12	1967-11-12 00:00:00	1967-11-26	1967-11-26 00:00:00	32020		\N	89102	0	444814009	40481087		0
22683	1354	260139	1998-04-18	1998-04-18 00:00:00	1998-05-02	1998-05-02 00:00:00	32020		\N	89747	0	10509002	260139		0
22863	1365	260139	1986-02-20	1986-02-20 00:00:00	1986-02-27	1986-02-27 00:00:00	32020		\N	90463	0	10509002	260139		0
22955	1368	4112343	1958-04-13	1958-04-13 00:00:00	1958-04-25	1958-04-25 00:00:00	32020		\N	90733	0	195662009	4112343		0
23139	1381	260139	2017-04-25	2017-04-25 00:00:00	2017-05-02	2017-05-02 00:00:00	32020		\N	91584	0	10509002	260139		0
23335	1391	40481087	1932-05-13	1932-05-13 00:00:00	1932-06-03	1932-06-03 00:00:00	32020		\N	92395	0	444814009	40481087		0
23549	1407	40481087	1987-03-22	1987-03-22 00:00:00	1987-04-12	1987-04-12 00:00:00	32020		\N	93524	0	444814009	40481087		0
23675	1412	260139	2002-02-25	2002-02-25 00:00:00	2002-03-04	2002-03-04 00:00:00	32020		\N	93997	0	10509002	260139		0
34383	2041	372328	1964-04-25	1964-04-25 00:00:00	1964-06-02	1964-06-02 00:00:00	32020		\N	135843	0	65363002	372328		0
23974	1431	40481087	1993-11-21	1993-11-21 00:00:00	1993-11-28	1993-11-28 00:00:00	32020		\N	95341	0	444814009	40481087		0
34722	2062	80180	1984-03-25	1984-03-25 00:00:00	\N	\N	32020		\N	137143	0	396275006	80180		0
34882	2073	30753	2002-05-31	2002-05-31 00:00:00	\N	\N	32020		\N	137913	0	16761005	30753		0
24475	1459	260139	1990-06-02	1990-06-02 00:00:00	1990-06-16	1990-06-16 00:00:00	32020		\N	97263	0	10509002	260139		0
24620	1468	40481087	1962-11-09	1962-11-09 00:00:00	1962-11-23	1962-11-23 00:00:00	32020		\N	97790	0	444814009	40481087		0
24894	1486	4310024	1989-01-27	1989-01-27 00:00:00	\N	\N	32020		\N	99024	0	424802006	4310024		0
25021	1493	372328	1961-11-28	1961-11-28 00:00:00	1962-09-25	1962-09-25 00:00:00	32020		\N	99568	0	65363002	372328		0
25153	1500	4152936	1968-03-26	1968-03-26 00:00:00	1968-04-16	1968-04-16 00:00:00	32020		\N	100079	0	283385000	4152936		0
25297	1508	372328	1924-03-01	1924-03-01 00:00:00	1924-04-08	1924-04-08 00:00:00	32020		\N	100608	0	65363002	372328		0
25550	1520	80180	1971-01-11	1971-01-11 00:00:00	\N	\N	32020		\N	101689	0	396275006	80180		0
25707	1528	4109685	2004-05-26	2004-05-26 00:00:00	2004-06-09	2004-06-09 00:00:00	32020		\N	102240	0	284551006	4109685		0
25885	1537	260139	1977-11-04	1977-11-04 00:00:00	1977-11-11	1977-11-11 00:00:00	32020		\N	102922	0	10509002	260139		0
26017	1543	4112343	1969-04-25	1969-04-25 00:00:00	1969-05-06	1969-05-06 00:00:00	32020		\N	103370	0	195662009	4112343		0
26177	1553	260139	1979-11-09	1979-11-09 00:00:00	1979-11-16	1979-11-16 00:00:00	32020		\N	103954	0	10509002	260139		0
26365	1565	4310024	1998-07-02	1998-07-02 00:00:00	\N	\N	32020		\N	104910	0	424802006	4310024		0
26446	1568	4156265	1964-09-27	1964-09-27 00:00:00	1964-10-11	1964-10-11 00:00:00	32020		\N	105164	0	370247008	4156265		0
26655	1578	40481087	1983-05-08	1983-05-08 00:00:00	1983-05-15	1983-05-15 00:00:00	32020		\N	105990	0	444814009	40481087		0
26849	1590	4112343	1989-06-07	1989-06-07 00:00:00	1989-06-16	1989-06-16 00:00:00	32020		\N	106716	0	195662009	4112343		0
26987	1597	260139	1993-01-15	1993-01-15 00:00:00	1993-01-29	1993-01-29 00:00:00	32020		\N	107131	0	10509002	260139		0
27134	1604	40481087	1993-12-29	1993-12-29 00:00:00	1994-01-05	1994-01-05 00:00:00	32020		\N	107627	0	444814009	40481087		0
27354	1612	4113008	1971-05-20	1971-05-20 00:00:00	1971-06-03	1971-06-03 00:00:00	32020		\N	108357	0	284549007	4113008		0
38026	2258	40481087	1969-10-31	1969-10-31 00:00:00	1969-11-07	1969-11-07 00:00:00	32020		\N	150042	0	444814009	40481087		0
27692	1634	4112343	2004-12-23	2004-12-23 00:00:00	2005-01-04	2005-01-04 00:00:00	32020		\N	109726	0	195662009	4112343		0
38381	2280	260139	2015-11-01	2015-11-01 00:00:00	2015-11-15	2015-11-15 00:00:00	32020		\N	151618	0	10509002	260139		0
38552	2289	440086	1963-10-29	1963-10-29 00:00:00	1967-11-07	1967-11-07 00:00:00	32020		\N	152214	0	192127007	440086		0
28155	1661	81893	1993-08-14	1993-08-14 00:00:00	\N	\N	32020		\N	111655	0	64766004	81893		0
28351	1674	260139	2004-12-22	2004-12-22 00:00:00	2005-01-05	2005-01-05 00:00:00	32020		\N	112354	0	10509002	260139		0
28552	1689	4278672	1952-07-28	1952-07-28 00:00:00	1952-09-26	1952-09-26 00:00:00	32020		\N	113088	0	65966004	4278672		0
28600	1692	4029498	1982-08-15	1982-08-15 00:00:00	\N	\N	32020		\N	113360	0	128613002	4029498		0
28868	1709	40481087	1966-08-15	1966-08-15 00:00:00	1966-08-29	1966-08-29 00:00:00	32020		\N	114254	0	444814009	40481087		0
28966	1716	4294548	1978-10-30	1978-10-30 00:00:00	1978-11-20	1978-11-20 00:00:00	32020		\N	114756	0	75498004	4294548		0
29167	1727	196456	1982-03-24	1982-03-24 00:00:00	1982-03-25	1982-03-25 00:00:00	32020		\N	115482	0	235919008	196456		0
29332	1737	192671	1950-09-18	1950-09-18 00:00:00	\N	\N	32020		\N	116047	0	K92.2	35208414		0
29468	1745	4112343	2003-11-19	2003-11-19 00:00:00	2003-11-28	2003-11-28 00:00:00	32020		\N	116687	0	195662009	4112343		0
29634	1753	260139	1988-06-02	1988-06-02 00:00:00	1988-06-09	1988-06-09 00:00:00	32020		\N	117214	0	10509002	260139		0
29776	1761	40481087	1966-06-20	1966-06-20 00:00:00	1966-07-04	1966-07-04 00:00:00	32020		\N	117754	0	444814009	40481087		0
30014	1776	372328	1918-01-21	1918-01-21 00:00:00	1918-04-06	1918-04-06 00:00:00	32020		\N	118789	0	65363002	372328		0
30198	1783	133834	1962-12-15	1962-12-15 00:00:00	1976-10-07	1976-10-07 00:00:00	32020		\N	119413	0	24079001	133834		0
30334	1791	40481087	1983-02-24	1983-02-24 00:00:00	1983-03-10	1983-03-10 00:00:00	32020		\N	120022	0	444814009	40481087		0
41070	2442	40481087	1979-01-10	1979-01-10 00:00:00	1979-01-24	1979-01-24 00:00:00	32020		\N	161921	0	444814009	40481087		0
30677	1812	40481087	2015-06-13	2015-06-13 00:00:00	2015-06-27	2015-06-27 00:00:00	32020		\N	121267	0	444814009	40481087		0
30861	1826	4112343	1975-08-27	1975-08-27 00:00:00	1975-09-08	1975-09-08 00:00:00	32020		\N	122053	0	195662009	4112343		0
30983	1834	372328	1946-10-31	1946-10-31 00:00:00	1947-01-12	1947-01-12 00:00:00	32020		\N	122491	0	65363002	372328		0
31162	1845	40481087	1997-05-17	1997-05-17 00:00:00	1997-05-31	1997-05-31 00:00:00	32020		\N	123355	0	444814009	40481087		0
31310	1851	40481087	2011-12-22	2011-12-22 00:00:00	2012-01-12	2012-01-12 00:00:00	32020		\N	123816	0	444814009	40481087		0
31515	1864	4112343	1989-03-03	1989-03-03 00:00:00	1989-03-10	1989-03-10 00:00:00	32020		\N	124511	0	195662009	4112343		0
31638	1874	4218389	2006-11-22	2006-11-22 00:00:00	2006-12-13	2006-12-13 00:00:00	32020		\N	125105	0	39848009	4218389		0
42353	2522	4296204	2009-07-07	2009-07-07 00:00:00	2009-07-21	2009-07-21 00:00:00	32020		\N	166790	0	403190006	4296204		0
21369	1282	4084167	1994-03-31	1994-03-31 00:00:00	1994-03-31	1994-03-31 00:00:00	32020		\N	84736	0	241929008	4084167		0
32051	1903	4112343	1984-04-11	1984-04-11 00:00:00	1984-04-18	1984-04-18 00:00:00	32020		\N	126721	0	195662009	4112343		0
32213	1915	260139	2002-11-29	2002-11-29 00:00:00	2002-12-06	2002-12-06 00:00:00	32020		\N	127380	0	10509002	260139		0
32379	1923	260139	2008-08-10	2008-08-10 00:00:00	2008-08-24	2008-08-24 00:00:00	32020		\N	127938	0	10509002	260139		0
21977	1316	40481087	2015-05-07	2015-05-07 00:00:00	2015-05-21	2015-05-21 00:00:00	32020		\N	87142	0	444814009	40481087		0
32724	1945	40481087	2013-01-12	2013-01-12 00:00:00	2013-02-02	2013-02-02 00:00:00	32020		\N	129244	0	444814009	40481087		0
22340	1333	80180	1993-07-10	1993-07-10 00:00:00	\N	\N	32020		\N	88475	0	396275006	80180		0
22523	1345	40481087	1984-05-24	1984-05-24 00:00:00	1984-05-31	1984-05-31 00:00:00	32020		\N	89103	0	444814009	40481087		0
22684	1354	260139	1981-07-29	1981-07-29 00:00:00	1981-08-12	1981-08-12 00:00:00	32020		\N	89724	0	10509002	260139		0
22864	1365	40481087	1979-07-08	1979-07-08 00:00:00	1979-07-22	1979-07-22 00:00:00	32020		\N	90458	0	444814009	40481087		0
22956	1368	40481087	1994-01-11	1994-01-11 00:00:00	1994-01-25	1994-01-25 00:00:00	32020		\N	90709	0	444814009	40481087		0
23140	1381	40481087	2015-12-21	2015-12-21 00:00:00	2016-01-04	2016-01-04 00:00:00	32020		\N	91582	0	444814009	40481087		0
23336	1391	372328	1927-09-24	1927-09-24 00:00:00	1928-08-28	1928-08-28 00:00:00	32020		\N	92327	0	65363002	372328		0
23550	1407	4218389	1968-10-06	1968-10-06 00:00:00	1968-11-10	1968-11-10 00:00:00	32020		\N	93560	0	39848009	4218389		0
23676	1412	4116491	2010-06-15	2010-06-15 00:00:00	2010-07-20	2010-07-20 00:00:00	32020		\N	94017	0	301011002	4116491		0
34384	2041	372328	1969-11-01	1969-11-01 00:00:00	1970-02-10	1970-02-10 00:00:00	32020		\N	135834	0	65363002	372328		0
23975	1431	40481087	1966-02-26	1966-02-26 00:00:00	1966-03-05	1966-03-05 00:00:00	32020		\N	95298	0	444814009	40481087		0
34723	2062	4218389	1951-04-23	1951-04-23 00:00:00	1951-05-28	1951-05-28 00:00:00	32020		\N	137161	0	39848009	4218389		0
34883	2073	4310024	2001-03-07	2001-03-07 00:00:00	\N	\N	32020		\N	137913	0	424802006	4310024		0
24476	1460	260139	1991-01-30	1991-01-30 00:00:00	1991-02-06	1991-02-06 00:00:00	32020		\N	97279	0	10509002	260139		0
24621	1468	40481087	1958-06-18	1958-06-18 00:00:00	1958-06-25	1958-06-25 00:00:00	32020		\N	97858	0	444814009	40481087		0
24895	1486	81893	1989-08-25	1989-08-25 00:00:00	\N	\N	32020		\N	99024	0	64766004	81893		0
25022	1493	40481087	1972-05-16	1972-05-16 00:00:00	1972-06-06	1972-06-06 00:00:00	32020		\N	99563	0	444814009	40481087		0
25154	1500	4112343	1966-07-25	1966-07-25 00:00:00	1966-08-02	1966-08-02 00:00:00	32020		\N	100107	0	195662009	4112343		0
25298	1508	4142905	1949-02-23	1949-02-23 00:00:00	1949-05-24	1949-05-24 00:00:00	32020		\N	100546	0	33737001	4142905		0
25551	1520	40481087	2001-08-10	2001-08-10 00:00:00	2001-08-24	2001-08-24 00:00:00	32020		\N	101625	0	444814009	40481087		0
25708	1528	40481087	1977-07-10	1977-07-10 00:00:00	1977-07-31	1977-07-31 00:00:00	32020		\N	102282	0	444814009	40481087		0
25886	1537	40481087	1997-07-19	1997-07-19 00:00:00	1997-08-09	1997-08-09 00:00:00	32020		\N	102923	0	444814009	40481087		0
26018	1543	4112343	1974-01-13	1974-01-13 00:00:00	1974-01-25	1974-01-25 00:00:00	32020		\N	103429	0	195662009	4112343		0
26178	1553	4109685	1978-01-11	1978-01-11 00:00:00	1978-02-01	1978-02-01 00:00:00	32020		\N	103938	0	284551006	4109685		0
26366	1565	372328	1968-05-25	1968-05-25 00:00:00	1968-08-18	1968-08-18 00:00:00	32020		\N	104897	0	65363002	372328		0
26447	1568	4112343	1966-04-23	1966-04-23 00:00:00	1966-05-03	1966-05-03 00:00:00	32020		\N	105154	0	195662009	4112343		0
26656	1578	4278672	2018-11-01	2018-11-01 00:00:00	2019-01-30	2019-01-30 00:00:00	32020		\N	105972	0	65966004	4278672		0
26850	1590	4112343	2011-09-16	2011-09-16 00:00:00	2011-09-28	2011-09-28 00:00:00	32020		\N	106712	0	195662009	4112343		0
26988	1597	4278672	1985-09-02	1985-09-02 00:00:00	1985-11-01	1985-11-01 00:00:00	32020		\N	107121	0	65966004	4278672		0
27135	1605	4294548	1941-03-12	1941-03-12 00:00:00	1941-05-28	1941-05-28 00:00:00	32020		\N	107720	0	75498004	4294548		0
27355	1612	40481087	2002-06-28	2002-06-28 00:00:00	2002-07-05	2002-07-05 00:00:00	32020		\N	108375	0	444814009	40481087		0
38027	2258	260139	1979-07-19	1979-07-19 00:00:00	1979-07-26	1979-07-26 00:00:00	32020		\N	150077	0	10509002	260139		0
27693	1634	4155034	1981-07-16	1981-07-16 00:00:00	1981-08-06	1981-08-06 00:00:00	32020		\N	109689	0	283371005	4155034		0
38382	2280	4112343	1980-03-09	1980-03-09 00:00:00	1980-03-22	1980-03-22 00:00:00	32020		\N	151561	0	195662009	4112343		0
38553	2289	260139	1991-04-03	1991-04-03 00:00:00	1991-04-17	1991-04-17 00:00:00	32020		\N	152268	0	10509002	260139		0
28156	1661	81151	1993-06-02	1993-06-02 00:00:00	1993-06-16	1993-06-16 00:00:00	32020		\N	111655	0	44465007	81151		0
28352	1674	260139	2008-09-09	2008-09-09 00:00:00	2008-09-16	2008-09-16 00:00:00	32020		\N	112392	0	10509002	260139		0
39011	2319	40481087	1976-08-03	1976-08-03 00:00:00	1976-08-10	1976-08-10 00:00:00	32020		\N	154217	0	444814009	40481087		0
28602	1692	40481087	2012-09-14	2012-09-14 00:00:00	2012-10-05	2012-10-05 00:00:00	32020		\N	113321	0	444814009	40481087		0
28869	1709	4112343	2017-04-15	2017-04-15 00:00:00	2017-04-27	2017-04-27 00:00:00	32020		\N	114259	0	195662009	4112343		0
28967	1716	40481087	1967-09-17	1967-09-17 00:00:00	1967-10-01	1967-10-01 00:00:00	32020		\N	114734	0	444814009	40481087		0
29168	1727	198809	1982-03-24	1982-03-24 00:00:00	1982-03-25	1982-03-25 00:00:00	32020		\N	115482	0	65275009	198809		0
29333	1737	4112343	1956-02-12	1956-02-12 00:00:00	1956-02-20	1956-02-20 00:00:00	32020		\N	116017	0	195662009	4112343		0
29469	1745	4278672	1986-06-05	1986-06-05 00:00:00	1986-08-04	1986-08-04 00:00:00	32020		\N	116681	0	65966004	4278672		0
29635	1753	30753	2001-08-21	2001-08-21 00:00:00	\N	\N	32020		\N	117265	0	16761005	30753		0
29777	1761	40481087	1959-06-26	1959-06-26 00:00:00	1959-07-17	1959-07-17 00:00:00	32020		\N	117704	0	444814009	40481087		0
30015	1776	40481087	1967-04-04	1967-04-04 00:00:00	1967-04-18	1967-04-18 00:00:00	32020		\N	118865	0	444814009	40481087		0
30199	1783	40481087	1968-05-08	1968-05-08 00:00:00	1968-05-15	1968-05-15 00:00:00	32020		\N	119421	0	444814009	40481087		0
30335	1791	260139	1975-04-25	1975-04-25 00:00:00	1975-05-02	1975-05-02 00:00:00	32020		\N	120101	0	10509002	260139		0
41071	2442	260139	1975-07-31	1975-07-31 00:00:00	1975-08-07	1975-08-07 00:00:00	32020		\N	162001	0	10509002	260139		0
30678	1812	40481087	2011-04-10	2011-04-10 00:00:00	2011-04-17	2011-04-17 00:00:00	32020		\N	121248	0	444814009	40481087		0
30862	1826	40481087	1949-10-25	1949-10-25 00:00:00	1949-11-08	1949-11-08 00:00:00	32020		\N	122051	0	444814009	40481087		0
30984	1834	440086	1960-01-31	1960-01-31 00:00:00	1964-02-09	1964-02-09 00:00:00	32020		\N	122535	0	192127007	440086		0
31163	1845	80180	1997-07-24	1997-07-24 00:00:00	\N	\N	32020		\N	123355	0	396275006	80180		0
31311	1851	40481087	2006-07-11	2006-07-11 00:00:00	2006-08-01	2006-08-01 00:00:00	32020		\N	123810	0	444814009	40481087		0
31516	1864	40481087	1978-07-06	1978-07-06 00:00:00	1978-07-20	1978-07-20 00:00:00	32020		\N	124536	0	444814009	40481087		0
31639	1874	4112343	2010-12-15	2010-12-15 00:00:00	2010-12-27	2010-12-27 00:00:00	32020		\N	125152	0	195662009	4112343		0
42354	2522	4218389	1985-02-17	1985-02-17 00:00:00	1985-03-24	1985-03-24 00:00:00	32020		\N	166787	0	39848009	4218389		0
21370	1282	4116491	1998-03-29	1998-03-29 00:00:00	1998-05-12	1998-05-12 00:00:00	32020		\N	84758	0	301011002	4116491		0
32052	1903	4155034	2009-05-04	2009-05-04 00:00:00	2009-05-25	2009-05-25 00:00:00	32020		\N	126667	0	283371005	4155034		0
32214	1915	260139	1984-05-13	1984-05-13 00:00:00	1984-05-20	1984-05-20 00:00:00	32020		\N	127375	0	10509002	260139		0
32380	1923	40481087	1945-11-14	1945-11-14 00:00:00	1945-11-21	1945-11-21 00:00:00	32020		\N	127863	0	444814009	40481087		0
21978	1316	4296204	1959-12-28	1959-12-28 00:00:00	1960-01-18	1960-01-18 00:00:00	32020		\N	87220	0	403190006	4296204		0
32725	1945	40481087	2000-10-11	2000-10-11 00:00:00	2000-10-31	2000-10-31 00:00:00	32020		\N	129213	0	444814009	40481087		0
22341	1333	4112343	2011-11-23	2011-11-23 00:00:00	2011-12-06	2011-12-06 00:00:00	32020		\N	88420	0	195662009	4112343		0
22545	1348	4112343	1914-06-18	1914-06-18 00:00:00	1914-06-30	1914-06-30 00:00:00	32020		\N	89331	0	195662009	4112343		0
22685	1354	257012	2012-02-03	2012-02-03 00:00:00	\N	\N	32020		\N	89748	0	40055000	257012		0
22865	1365	4132546	1977-03-11	1977-03-11 00:00:00	\N	\N	32020		\N	90456	0	275272006	4166590		0
22973	1371	28060	1974-05-30	1974-05-30 00:00:00	1974-06-09	1974-06-09 00:00:00	32020		\N	90913	0	43878008	28060		0
23141	1381	260139	2009-08-14	2009-08-14 00:00:00	2009-08-28	2009-08-28 00:00:00	32020		\N	91586	0	10509002	260139		0
23337	1391	40481087	1995-02-04	1995-02-04 00:00:00	1995-02-25	1995-02-25 00:00:00	32020		\N	92349	0	444814009	40481087		0
23551	1407	4237458	1971-08-18	1971-08-18 00:00:00	1971-09-17	1971-09-17 00:00:00	32020		\N	93562	0	58150001	4237458		0
23677	1412	260139	1991-02-08	1991-02-08 00:00:00	1991-02-22	1991-02-22 00:00:00	32020		\N	94094	0	10509002	260139		0
34385	2041	378001	2006-07-29	2006-07-29 00:00:00	2006-08-28	2006-08-28 00:00:00	32020		\N	135808	0	62106007	378001		0
23976	1431	4112343	1984-12-26	1984-12-26 00:00:00	1985-01-06	1985-01-06 00:00:00	32020		\N	95287	0	195662009	4112343		0
34724	2062	40481087	2019-06-19	2019-06-19 00:00:00	2019-06-26	2019-06-26 00:00:00	32020		\N	137188	0	444814009	40481087		0
34884	2073	4112343	2017-02-07	2017-02-07 00:00:00	2017-02-16	2017-02-16 00:00:00	32020		\N	137902	0	195662009	4112343		0
24477	1460	4112343	1983-04-21	1983-04-21 00:00:00	1983-05-01	1983-05-01 00:00:00	32020		\N	97307	0	195662009	4112343		0
24622	1468	40481087	1997-02-19	1997-02-19 00:00:00	1997-02-26	1997-02-26 00:00:00	32020		\N	97855	0	444814009	40481087		0
24896	1486	40481087	1973-04-22	1973-04-22 00:00:00	1973-05-13	1973-05-13 00:00:00	32020		\N	99007	0	444814009	40481087		0
25023	1493	40481087	1971-10-03	1971-10-03 00:00:00	1971-10-10	1971-10-10 00:00:00	32020		\N	99552	0	444814009	40481087		0
25155	1500	80180	2001-10-25	2001-10-25 00:00:00	\N	\N	32020		\N	100080	0	396275006	80180		0
25299	1508	28060	1933-09-11	1933-09-11 00:00:00	1933-09-23	1933-09-23 00:00:00	32020		\N	100580	0	43878008	28060		0
25552	1520	40481087	2003-11-19	2003-11-19 00:00:00	2003-11-26	2003-11-26 00:00:00	32020		\N	101652	0	444814009	40481087		0
25709	1528	4294548	1991-05-09	1991-05-09 00:00:00	1991-08-29	1991-08-29 00:00:00	32020		\N	102245	0	75498004	4294548		0
25887	1537	40481087	2007-04-27	2007-04-27 00:00:00	2007-05-18	2007-05-18 00:00:00	32020		\N	102874	0	444814009	40481087		0
26019	1543	4112343	1986-04-23	1986-04-23 00:00:00	1986-05-06	1986-05-06 00:00:00	32020		\N	103436	0	195662009	4112343		0
26179	1553	40481087	2003-08-04	2003-08-04 00:00:00	2003-08-11	2003-08-11 00:00:00	32020		\N	103955	0	444814009	40481087		0
26367	1565	4112343	1972-02-07	1972-02-07 00:00:00	1972-02-15	1972-02-15 00:00:00	32020		\N	104916	0	195662009	4112343		0
26448	1568	4112343	2011-05-31	2011-05-31 00:00:00	2011-06-09	2011-06-09 00:00:00	32020		\N	105199	0	195662009	4112343		0
26657	1578	40481087	1992-07-31	1992-07-31 00:00:00	1992-08-21	1992-08-21 00:00:00	32020		\N	106010	0	444814009	40481087		0
26851	1590	4059173	2014-08-23	2014-08-23 00:00:00	2014-10-22	2014-10-22 00:00:00	32020		\N	106721	0	16114001	4059173		0
26989	1597	28060	1960-10-01	1960-10-01 00:00:00	1960-10-11	1960-10-11 00:00:00	32020		\N	107107	0	43878008	28060		0
27136	1605	4152936	1948-01-27	1948-01-27 00:00:00	1948-02-17	1948-02-17 00:00:00	32020		\N	107745	0	283385000	4152936		0
27356	1612	80180	2003-05-07	2003-05-07 00:00:00	\N	\N	32020		\N	108375	0	396275006	80180		0
38028	2258	28060	1968-04-01	1968-04-01 00:00:00	1968-04-09	1968-04-09 00:00:00	32020		\N	150074	0	43878008	28060		0
27694	1634	4116491	1974-08-31	1974-08-31 00:00:00	1974-10-15	1974-10-15 00:00:00	32020		\N	109783	0	301011002	4116491		0
38383	2280	40481087	1972-06-25	1972-06-25 00:00:00	1972-07-09	1972-07-09 00:00:00	32020		\N	151554	0	444814009	40481087		0
38554	2289	40481087	2002-07-01	2002-07-01 00:00:00	2002-07-15	2002-07-15 00:00:00	32020		\N	152233	0	444814009	40481087		0
28157	1661	260139	1963-02-19	1963-02-19 00:00:00	1963-02-26	1963-02-26 00:00:00	32020		\N	111682	0	10509002	260139		0
28353	1674	260139	1993-12-29	1993-12-29 00:00:00	1994-01-12	1994-01-12 00:00:00	32020		\N	112369	0	10509002	260139		0
39012	2319	40481087	1979-06-06	1979-06-06 00:00:00	1979-06-27	1979-06-27 00:00:00	32020		\N	154199	0	444814009	40481087		0
28603	1692	40481087	1992-10-03	1992-10-03 00:00:00	1992-10-10	1992-10-10 00:00:00	32020		\N	113348	0	444814009	40481087		0
28870	1709	80502	2017-02-04	2017-02-04 00:00:00	\N	\N	32020		\N	114283	0	64859006	80502		0
28968	1716	40481087	1988-08-12	1988-08-12 00:00:00	1988-08-26	1988-08-26 00:00:00	32020		\N	114621	0	444814009	40481087		0
29169	1727	372328	1950-07-24	1950-07-24 00:00:00	1950-09-07	1950-09-07 00:00:00	32020		\N	115487	0	65363002	372328		0
29334	1737	4112343	2012-11-29	2012-11-29 00:00:00	2012-12-06	2012-12-06 00:00:00	32020		\N	115966	0	195662009	4112343		0
29470	1745	40481087	1988-11-29	1988-11-29 00:00:00	1988-12-20	1988-12-20 00:00:00	32020		\N	116673	0	444814009	40481087		0
29636	1753	80180	2002-06-17	2002-06-17 00:00:00	\N	\N	32020		\N	117265	0	396275006	80180		0
29778	1762	40481087	1996-04-27	1996-04-27 00:00:00	1996-05-11	1996-05-11 00:00:00	32020		\N	117850	0	444814009	40481087		0
30016	1776	4112343	1988-02-03	1988-02-03 00:00:00	1988-02-14	1988-02-14 00:00:00	32020		\N	118785	0	195662009	4112343		0
30200	1783	40481087	1967-09-21	1967-09-21 00:00:00	1967-10-05	1967-10-05 00:00:00	32020		\N	119494	0	444814009	40481087		0
30336	1791	198199	2011-11-11	2011-11-11 00:00:00	2011-12-19	2011-12-19 00:00:00	32020		\N	120104	0	45816000	198199		0
41072	2442	4134304	1979-07-09	1979-07-09 00:00:00	1979-09-07	1979-09-07 00:00:00	32020		\N	161957	0	263102004	4134304		0
30679	1813	80180	2016-10-29	2016-10-29 00:00:00	\N	\N	32020		\N	121314	0	396275006	80180		0
30863	1826	260139	1965-04-17	1965-04-17 00:00:00	1965-05-01	1965-05-01 00:00:00	32020		\N	122015	0	10509002	260139		0
30985	1834	317576	2014-07-20	2014-07-20 00:00:00	\N	\N	32020		\N	122469	0	53741008	317576		0
31164	1845	40481087	1982-06-17	1982-06-17 00:00:00	1982-07-08	1982-07-08 00:00:00	32020		\N	123274	0	444814009	40481087		0
31312	1851	4283893	1994-03-19	1994-03-19 00:00:00	1994-04-16	1994-04-16 00:00:00	32020		\N	123814	0	36971009	4283893		0
31517	1864	40481087	1994-10-14	1994-10-14 00:00:00	1994-11-04	1994-11-04 00:00:00	32020		\N	124563	0	444814009	40481087		0
31640	1874	40481087	2010-10-28	2010-10-28 00:00:00	2010-11-04	2010-11-04 00:00:00	32020		\N	125151	0	444814009	40481087		0
42355	2522	40481087	1979-08-13	1979-08-13 00:00:00	1979-09-03	1979-09-03 00:00:00	32020		\N	166800	0	444814009	40481087		0
21371	1282	260139	1985-09-14	1985-09-14 00:00:00	1985-09-28	1985-09-28 00:00:00	32020		\N	84752	0	10509002	260139		0
32053	1903	40481087	1999-07-25	1999-07-25 00:00:00	1999-08-15	1999-08-15 00:00:00	32020		\N	126706	0	444814009	40481087		0
32215	1915	4237458	1991-07-09	1991-07-09 00:00:00	1991-10-07	1991-10-07 00:00:00	32020		\N	127404	0	58150001	4237458		0
32381	1923	378001	2012-09-29	2012-09-29 00:00:00	2012-11-28	2012-11-28 00:00:00	32020		\N	127888	0	62106007	378001		0
21979	1316	372328	1950-08-24	1950-08-24 00:00:00	1950-10-31	1950-10-31 00:00:00	32020		\N	87230	0	65363002	372328		0
32726	1945	4112343	1976-07-01	1976-07-01 00:00:00	1976-07-12	1976-07-12 00:00:00	32020		\N	129199	0	195662009	4112343		0
22342	1333	260139	1970-02-13	1970-02-13 00:00:00	1970-02-20	1970-02-20 00:00:00	32020		\N	88404	0	10509002	260139		0
22546	1348	4112343	1954-08-06	1954-08-06 00:00:00	1954-08-17	1954-08-17 00:00:00	32020		\N	89336	0	195662009	4112343		0
22686	1354	4112343	1980-02-28	1980-02-28 00:00:00	1980-03-06	1980-03-06 00:00:00	32020		\N	89722	0	195662009	4112343		0
22866	1365	4001336	1977-03-11	1977-03-11 00:00:00	1977-04-10	1977-04-10 00:00:00	32020		\N	90456	0	110030002	4001336		0
22974	1371	40481087	2015-04-09	2015-04-09 00:00:00	2015-04-16	2015-04-16 00:00:00	32020		\N	90938	0	444814009	40481087		0
23142	1381	28060	2016-08-21	2016-08-21 00:00:00	2016-09-02	2016-09-02 00:00:00	32020		\N	91583	0	43878008	28060		0
23338	1391	40481087	1978-04-12	1978-04-12 00:00:00	1978-04-19	1978-04-19 00:00:00	32020		\N	92323	0	444814009	40481087		0
23552	1408	81151	1954-09-03	1954-09-03 00:00:00	1954-10-01	1954-10-01 00:00:00	32020		\N	93619	0	44465007	81151		0
23678	1412	4156265	1999-11-30	1999-11-30 00:00:00	1999-12-14	1999-12-14 00:00:00	32020		\N	94042	0	370247008	4156265		0
34386	2041	378001	2017-07-31	2017-07-31 00:00:00	2017-08-30	2017-08-30 00:00:00	32020		\N	135809	0	62106007	378001		0
23977	1431	4059173	2018-11-08	2018-11-08 00:00:00	2018-12-08	2018-12-08 00:00:00	32020		\N	95254	0	16114001	4059173		0
34725	2062	40481087	1959-01-23	1959-01-23 00:00:00	1959-02-13	1959-02-13 00:00:00	32020		\N	137166	0	444814009	40481087		0
34885	2073	372328	1987-06-21	1987-06-21 00:00:00	1987-10-02	1987-10-02 00:00:00	32020		\N	137937	0	65363002	372328		0
24478	1460	78272	2016-11-20	2016-11-20 00:00:00	2016-12-25	2016-12-25 00:00:00	32020		\N	97305	0	70704007	78272		0
24623	1468	40481087	2008-02-09	2008-02-09 00:00:00	2008-02-16	2008-02-16 00:00:00	32020		\N	97856	0	444814009	40481087		0
24897	1486	321042	2001-12-23	2001-12-23 00:00:00	\N	\N	32020		\N	99029	0	410429000	321042		0
25024	1493	40481087	1999-03-17	1999-03-17 00:00:00	1999-03-24	1999-03-24 00:00:00	32020		\N	99566	0	444814009	40481087		0
25156	1500	40481087	1984-02-05	1984-02-05 00:00:00	1984-02-19	1984-02-19 00:00:00	32020		\N	100070	0	444814009	40481087		0
25300	1508	4152936	1967-05-20	1967-05-20 00:00:00	1967-06-10	1967-06-10 00:00:00	32020		\N	100547	0	283385000	4152936		0
25553	1520	28060	1982-08-31	1982-08-31 00:00:00	1982-09-10	1982-09-10 00:00:00	32020		\N	101624	0	43878008	28060		0
25710	1528	28060	1973-01-11	1973-01-11 00:00:00	1973-01-23	1973-01-23 00:00:00	32020		\N	102262	0	43878008	28060		0
25888	1537	4112343	1963-10-09	1963-10-09 00:00:00	1963-10-18	1963-10-18 00:00:00	32020		\N	102867	0	195662009	4112343		0
26021	1543	4329847	1994-10-23	1994-10-23 00:00:00	\N	\N	32020		\N	103423	0	22298006	4329847		0
26180	1553	80180	2011-05-18	2011-05-18 00:00:00	\N	\N	32020		\N	103964	0	396275006	80180		0
26368	1565	81893	1998-12-29	1998-12-29 00:00:00	\N	\N	32020		\N	104925	0	64766004	81893		0
26449	1568	4112343	2012-12-03	2012-12-03 00:00:00	2012-12-16	2012-12-16 00:00:00	32020		\N	105178	0	195662009	4112343		0
26658	1578	4155034	2017-10-16	2017-10-16 00:00:00	2017-11-06	2017-11-06 00:00:00	32020		\N	105971	0	283371005	4155034		0
26852	1590	4112343	1964-09-11	1964-09-11 00:00:00	1964-09-21	1964-09-21 00:00:00	32020		\N	106706	0	195662009	4112343		0
26990	1597	40481087	2013-03-21	2013-03-21 00:00:00	2013-04-11	2013-04-11 00:00:00	32020		\N	107162	0	444814009	40481087		0
27137	1605	40481087	2004-08-04	2004-08-04 00:00:00	2004-08-11	2004-08-11 00:00:00	32020		\N	107673	0	444814009	40481087		0
27357	1612	381316	2014-04-16	2014-04-16 00:00:00	\N	\N	32020		\N	108401	0	230690007	381316		0
38029	2258	4296204	1985-03-16	1985-03-16 00:00:00	1985-04-06	1985-04-06 00:00:00	32020		\N	150060	0	403190006	4296204		0
27695	1634	4112343	1975-09-28	1975-09-28 00:00:00	1975-10-08	1975-10-08 00:00:00	32020		\N	109739	0	195662009	4112343		0
38384	2280	40481087	1985-10-18	1985-10-18 00:00:00	1985-11-08	1985-11-08 00:00:00	32020		\N	151589	0	444814009	40481087		0
38555	2289	4112343	2013-08-07	2013-08-07 00:00:00	2013-08-15	2013-08-15 00:00:00	32020		\N	152234	0	195662009	4112343		0
28158	1661	313217	2007-07-12	2007-07-12 00:00:00	\N	\N	32020		\N	111679	0	49436004	313217		0
28354	1674	4152936	1995-12-01	1995-12-01 00:00:00	1995-12-15	1995-12-15 00:00:00	32020		\N	112386	0	283385000	4152936		0
39013	2319	4142905	1983-09-07	1983-09-07 00:00:00	1983-10-07	1983-10-07 00:00:00	32020		\N	154136	0	33737001	4142905		0
28604	1692	40481087	1986-07-04	1986-07-04 00:00:00	1986-07-18	1986-07-18 00:00:00	32020		\N	113346	0	444814009	40481087		0
28871	1709	372328	1939-03-22	1939-03-22 00:00:00	1939-08-26	1939-08-26 00:00:00	32020		\N	114322	0	65363002	372328		0
28969	1716	40481087	1960-02-29	1960-02-29 00:00:00	1960-03-21	1960-03-21 00:00:00	32020		\N	114732	0	444814009	40481087		0
29170	1727	28060	1954-02-05	1954-02-05 00:00:00	1954-02-13	1954-02-13 00:00:00	32020		\N	115524	0	43878008	28060		0
29335	1737	40481087	1962-06-09	1962-06-09 00:00:00	1962-06-16	1962-06-16 00:00:00	32020		\N	116096	0	444814009	40481087		0
29471	1745	4112343	1985-07-28	1985-07-28 00:00:00	1985-08-07	1985-08-07 00:00:00	32020		\N	116650	0	195662009	4112343		0
29637	1753	372328	1968-07-26	1968-07-26 00:00:00	1969-02-13	1969-02-13 00:00:00	32020		\N	117209	0	65363002	372328		0
29779	1762	4112343	1996-03-29	1996-03-29 00:00:00	1996-04-11	1996-04-11 00:00:00	32020		\N	117804	0	195662009	4112343		0
30017	1776	4156265	1997-12-07	1997-12-07 00:00:00	1997-12-28	1997-12-28 00:00:00	32020		\N	118884	0	370247008	4156265		0
30201	1783	4112343	2007-03-20	2007-03-20 00:00:00	2007-03-27	2007-03-27 00:00:00	32020		\N	119507	0	195662009	4112343		0
30337	1791	372328	1980-12-27	1980-12-27 00:00:00	1983-02-10	1983-02-10 00:00:00	32020		\N	120029	0	65363002	372328		0
41073	2442	28060	1978-05-30	1978-05-30 00:00:00	1978-06-08	1978-06-08 00:00:00	32020		\N	161919	0	43878008	28060		0
30680	1813	4278672	1986-07-24	1986-07-24 00:00:00	1986-10-22	1986-10-22 00:00:00	32020		\N	121309	0	65966004	4278672		0
30864	1826	40481087	2010-09-20	2010-09-20 00:00:00	2010-09-27	2010-09-27 00:00:00	32020		\N	122058	0	444814009	40481087		0
30986	1834	40481087	1954-07-10	1954-07-10 00:00:00	1954-07-17	1954-07-17 00:00:00	32020		\N	122533	0	444814009	40481087		0
31165	1845	4112343	1992-11-21	1992-11-21 00:00:00	1992-11-29	1992-11-29 00:00:00	32020		\N	123298	0	195662009	4112343		0
31313	1851	260139	2001-01-15	2001-01-15 00:00:00	2001-01-22	2001-01-22 00:00:00	32020		\N	123859	0	10509002	260139		0
31518	1864	4146173	2018-06-26	2018-06-26 00:00:00	2018-08-25	2018-08-25 00:00:00	32020		\N	124538	0	307731004	4146173		0
31641	1874	4112343	1986-08-08	1986-08-08 00:00:00	1986-08-20	1986-08-20 00:00:00	32020		\N	125130	0	195662009	4112343		0
42356	2522	4266809	1991-01-24	1991-01-24 00:00:00	\N	\N	32020		\N	166856	0	397881000	4266809		0
21372	1282	4109685	2010-10-16	2010-10-16 00:00:00	2010-11-06	2010-11-06 00:00:00	32020		\N	84737	0	284551006	4109685		0
32054	1903	40481087	2001-06-29	2001-06-29 00:00:00	2001-07-20	2001-07-20 00:00:00	32020		\N	126722	0	444814009	40481087		0
32216	1915	257012	1992-12-02	1992-12-02 00:00:00	\N	\N	32020		\N	127391	0	40055000	257012		0
32382	1923	4112343	1973-03-21	1973-03-21 00:00:00	1973-03-31	1973-03-31 00:00:00	32020		\N	128004	0	195662009	4112343		0
21980	1316	4112343	1989-06-25	1989-06-25 00:00:00	1989-07-03	1989-07-03 00:00:00	32020		\N	87155	0	195662009	4112343		0
32727	1945	40481087	2004-11-15	2004-11-15 00:00:00	2004-12-06	2004-12-06 00:00:00	32020		\N	129206	0	444814009	40481087		0
22343	1333	260139	1974-10-29	1974-10-29 00:00:00	1974-11-12	1974-11-12 00:00:00	32020		\N	88452	0	10509002	260139		0
22547	1348	4112343	1963-11-30	1963-11-30 00:00:00	1963-12-13	1963-12-13 00:00:00	32020		\N	89337	0	195662009	4112343		0
22687	1355	80180	1996-05-22	1996-05-22 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
22867	1365	260139	1993-10-19	1993-10-19 00:00:00	1993-11-02	1993-11-02 00:00:00	32020		\N	90505	0	10509002	260139		0
22975	1371	260139	1985-03-02	1985-03-02 00:00:00	1985-03-09	1985-03-09 00:00:00	32020		\N	90898	0	10509002	260139		0
23143	1381	40481087	2010-08-08	2010-08-08 00:00:00	2010-08-29	2010-08-29 00:00:00	32020		\N	91588	0	444814009	40481087		0
23339	1391	81151	1928-09-06	1928-09-06 00:00:00	1928-10-04	1928-10-04 00:00:00	32020		\N	92390	0	44465007	81151		0
23553	1408	372328	1947-08-11	1947-08-11 00:00:00	1948-07-12	1948-07-12 00:00:00	32020		\N	93595	0	65363002	372328		0
23679	1412	4112343	1994-01-13	1994-01-13 00:00:00	1994-01-25	1994-01-25 00:00:00	32020		\N	94064	0	195662009	4112343		0
34387	2041	4112343	1992-02-13	1992-02-13 00:00:00	1992-02-26	1992-02-26 00:00:00	32020		\N	135859	0	195662009	4112343		0
23978	1431	372328	1967-08-04	1967-08-04 00:00:00	1968-07-27	1968-07-27 00:00:00	32020		\N	95263	0	65363002	372328		0
34726	2062	4283893	1965-12-17	1965-12-17 00:00:00	1965-12-31	1965-12-31 00:00:00	32020		\N	137111	0	36971009	4283893		0
34886	2073	4027663	1996-02-07	1996-02-07 00:00:00	\N	\N	32020		\N	137923	0	13200003	4027663		0
24479	1460	80180	2017-09-03	2017-09-03 00:00:00	\N	\N	32020		\N	97305	0	396275006	80180		0
24624	1468	317576	1977-02-02	1977-02-02 00:00:00	\N	\N	32020		\N	97864	0	53741008	317576		0
24898	1486	260139	2007-06-16	2007-06-16 00:00:00	2007-06-23	2007-06-23 00:00:00	32020		\N	99152	0	10509002	260139		0
25025	1493	4112343	1971-10-03	1971-10-03 00:00:00	1971-10-16	1971-10-16 00:00:00	32020		\N	99552	0	195662009	4112343		0
25157	1500	40481087	1970-01-08	1970-01-08 00:00:00	1970-01-15	1970-01-15 00:00:00	32020		\N	100108	0	444814009	40481087		0
25301	1508	378001	1968-05-05	1968-05-05 00:00:00	1968-06-04	1968-06-04 00:00:00	32020		\N	100548	0	62106007	378001		0
25554	1520	81151	1963-06-28	1963-06-28 00:00:00	1963-07-26	1963-07-26 00:00:00	32020		\N	101709	0	44465007	81151		0
25711	1528	40481087	2004-03-14	2004-03-14 00:00:00	2004-03-28	2004-03-28 00:00:00	32020		\N	102286	0	444814009	40481087		0
25889	1537	372328	1958-05-04	1958-05-04 00:00:00	1958-10-22	1958-10-22 00:00:00	32020		\N	102924	0	65363002	372328		0
26022	1543	40481087	1988-09-12	1988-09-12 00:00:00	1988-09-26	1988-09-26 00:00:00	32020		\N	103377	0	444814009	40481087		0
26181	1553	260139	1977-08-24	1977-08-24 00:00:00	1977-08-31	1977-08-31 00:00:00	32020		\N	103992	0	10509002	260139		0
26369	1565	30753	1999-05-28	1999-05-28 00:00:00	\N	\N	32020		\N	104925	0	16761005	30753		0
26450	1569	40481087	1954-10-11	1954-10-11 00:00:00	1954-11-01	1954-11-01 00:00:00	32020		\N	105253	0	444814009	40481087		0
26659	1578	40481087	1993-08-21	1993-08-21 00:00:00	1993-09-11	1993-09-11 00:00:00	32020		\N	106011	0	444814009	40481087		0
26853	1590	4237458	1965-01-06	1965-01-06 00:00:00	1965-02-05	1965-02-05 00:00:00	32020		\N	106672	0	58150001	4237458		0
26991	1597	28060	2003-04-12	2003-04-12 00:00:00	2003-04-23	2003-04-23 00:00:00	32020		\N	107160	0	43878008	28060		0
27138	1605	4059173	2011-06-01	2011-06-01 00:00:00	2011-08-30	2011-08-30 00:00:00	32020		\N	107751	0	16114001	4059173		0
27358	1612	40481087	1989-08-07	1989-08-07 00:00:00	1989-08-21	1989-08-21 00:00:00	32020		\N	108386	0	444814009	40481087		0
38030	2258	372328	1961-08-16	1961-08-16 00:00:00	1961-12-07	1961-12-07 00:00:00	32020		\N	150080	0	65363002	372328		0
27696	1634	40481087	1996-10-21	1996-10-21 00:00:00	1996-10-28	1996-10-28 00:00:00	32020		\N	109785	0	444814009	40481087		0
38385	2280	40481087	1999-11-04	1999-11-04 00:00:00	1999-11-18	1999-11-18 00:00:00	32020		\N	151645	0	444814009	40481087		0
38556	2289	4112343	1953-02-28	1953-02-28 00:00:00	1953-03-10	1953-03-10 00:00:00	32020		\N	152215	0	195662009	4112343		0
28159	1661	81151	1963-04-19	1963-04-19 00:00:00	1963-05-24	1963-05-24 00:00:00	32020		\N	111650	0	44465007	81151		0
28360	1676	40481087	1990-02-17	1990-02-17 00:00:00	1990-03-03	1990-03-03 00:00:00	32020		\N	112453	0	444814009	40481087		0
39014	2319	4280726	1952-02-21	1952-02-21 00:00:00	\N	\N	32020		\N	154193	0	367498001	4280726		0
28605	1692	80180	2017-01-23	2017-01-23 00:00:00	\N	\N	32020		\N	113359	0	396275006	80180		0
28872	1709	4109685	1959-10-20	1959-10-20 00:00:00	1959-11-03	1959-11-03 00:00:00	32020		\N	114237	0	284551006	4109685		0
28970	1716	4112343	1963-02-17	1963-02-17 00:00:00	1963-02-26	1963-02-26 00:00:00	32020		\N	114603	0	195662009	4112343		0
29171	1727	4112343	1997-04-26	1997-04-26 00:00:00	1997-05-07	1997-05-07 00:00:00	32020		\N	115426	0	195662009	4112343		0
29336	1737	4112343	1988-10-10	1988-10-10 00:00:00	1988-10-22	1988-10-22 00:00:00	32020		\N	116098	0	195662009	4112343		0
29472	1745	260139	2007-06-19	2007-06-19 00:00:00	2007-06-26	2007-06-26 00:00:00	32020		\N	116688	0	10509002	260139		0
29638	1753	4112343	1976-03-31	1976-03-31 00:00:00	1976-04-11	1976-04-11 00:00:00	32020		\N	117212	0	195662009	4112343		0
29780	1762	4112343	1997-08-06	1997-08-06 00:00:00	1997-08-14	1997-08-14 00:00:00	32020		\N	117851	0	195662009	4112343		0
30018	1776	40481087	1999-10-11	1999-10-11 00:00:00	1999-10-25	1999-10-25 00:00:00	32020		\N	118820	0	444814009	40481087		0
30202	1783	4112343	1975-06-18	1975-06-18 00:00:00	1975-06-25	1975-06-25 00:00:00	32020		\N	119495	0	195662009	4112343		0
30338	1791	4296204	1965-05-01	1965-05-01 00:00:00	1965-06-05	1965-06-05 00:00:00	32020		\N	120076	0	403190006	4296204		0
41074	2442	4310024	2005-04-08	2005-04-08 00:00:00	\N	\N	32020		\N	161980	0	424802006	4310024		0
30681	1813	260139	1990-10-09	1990-10-09 00:00:00	1990-10-16	1990-10-16 00:00:00	32020		\N	121343	0	10509002	260139		0
30865	1826	260139	1999-04-13	1999-04-13 00:00:00	1999-04-20	1999-04-20 00:00:00	32020		\N	122016	0	10509002	260139		0
30987	1834	4218389	1954-12-18	1954-12-18 00:00:00	1955-01-22	1955-01-22 00:00:00	32020		\N	122539	0	39848009	4218389		0
31166	1845	260139	2019-02-06	2019-02-06 00:00:00	2019-02-13	2019-02-13 00:00:00	32020		\N	123284	0	10509002	260139		0
31314	1851	4112343	1995-12-17	1995-12-17 00:00:00	1995-12-29	1995-12-29 00:00:00	32020		\N	123809	0	195662009	4112343		0
31519	1864	40481087	1966-07-10	1966-07-10 00:00:00	1966-07-31	1966-07-31 00:00:00	32020		\N	124535	0	444814009	40481087		0
31642	1874	80180	2014-12-20	2014-12-20 00:00:00	\N	\N	32020		\N	125134	0	396275006	80180		0
42357	2522	4112343	1959-11-05	1959-11-05 00:00:00	1959-11-15	1959-11-15 00:00:00	32020		\N	166848	0	195662009	4112343		0
21373	1282	40481087	1981-03-17	1981-03-17 00:00:00	1981-03-31	1981-03-31 00:00:00	32020		\N	84751	0	444814009	40481087		0
32055	1903	257012	1976-10-11	1976-10-11 00:00:00	\N	\N	32020		\N	126671	0	40055000	257012		0
32217	1915	40481087	2007-06-10	2007-06-10 00:00:00	2007-06-17	2007-06-17 00:00:00	32020		\N	127356	0	444814009	40481087		0
32383	1923	257012	1940-07-16	1940-07-16 00:00:00	\N	\N	32020		\N	127852	0	40055000	257012		0
21981	1316	40481087	1972-01-29	1972-01-29 00:00:00	1972-02-19	1972-02-19 00:00:00	32020		\N	87137	0	444814009	40481087		0
32728	1945	4113008	1985-01-13	1985-01-13 00:00:00	1985-02-03	1985-02-03 00:00:00	32020		\N	129242	0	284549007	4113008		0
22344	1333	40481087	1955-10-04	1955-10-04 00:00:00	1955-10-25	1955-10-25 00:00:00	32020		\N	88439	0	444814009	40481087		0
22548	1348	4112343	1936-06-18	1936-06-18 00:00:00	1936-06-25	1936-06-25 00:00:00	32020		\N	89333	0	195662009	4112343		0
22688	1355	40481087	1993-10-07	1993-10-07 00:00:00	1993-10-21	1993-10-21 00:00:00	32020		\N	89855	0	444814009	40481087		0
22868	1365	4116491	1994-11-27	1994-11-27 00:00:00	1995-01-15	1995-01-15 00:00:00	32020		\N	90464	0	301011002	4116491		0
22976	1371	40481087	1992-12-16	1992-12-16 00:00:00	1993-01-06	1993-01-06 00:00:00	32020		\N	90877	0	444814009	40481087		0
23144	1381	4112343	1993-02-24	1993-02-24 00:00:00	1993-03-06	1993-03-06 00:00:00	32020		\N	91612	0	195662009	4112343		0
23340	1391	4112343	1961-01-19	1961-01-19 00:00:00	1961-02-01	1961-02-01 00:00:00	32020		\N	92398	0	195662009	4112343		0
23554	1408	4112343	1948-01-19	1948-01-19 00:00:00	1948-01-31	1948-01-31 00:00:00	32020		\N	93639	0	195662009	4112343		0
23680	1412	4155034	1983-12-12	1983-12-12 00:00:00	1984-01-02	1984-01-02 00:00:00	32020		\N	94038	0	283371005	4155034		0
34388	2041	80809	2008-02-14	2008-02-14 00:00:00	2011-05-29	2011-05-29 00:00:00	32020		\N	135860	0	69896004	80809		0
23979	1431	40481087	1972-01-09	1972-01-09 00:00:00	1972-01-30	1972-01-30 00:00:00	32020		\N	95299	0	444814009	40481087		0
34727	2062	4296205	1989-03-03	1989-03-03 00:00:00	1989-03-17	1989-03-17 00:00:00	32020		\N	137199	0	403191005	4296205		0
34887	2073	4112343	1995-09-08	1995-09-08 00:00:00	1995-09-17	1995-09-17 00:00:00	32020		\N	137923	0	195662009	4112343		0
24480	1460	4294548	1982-10-30	1982-10-30 00:00:00	1983-01-22	1983-01-22 00:00:00	32020		\N	97278	0	75498004	4294548		0
24625	1468	80180	1992-03-26	1992-03-26 00:00:00	\N	\N	32020		\N	97843	0	396275006	80180		0
24899	1486	40481087	1960-04-21	1960-04-21 00:00:00	1960-05-05	1960-05-05 00:00:00	32020		\N	99005	0	444814009	40481087		0
25026	1493	4112343	1982-06-22	1982-06-22 00:00:00	1982-07-02	1982-07-02 00:00:00	32020		\N	99581	0	195662009	4112343		0
25158	1500	4112343	1984-08-30	1984-08-30 00:00:00	1984-09-10	1984-09-10 00:00:00	32020		\N	100127	0	195662009	4112343		0
25302	1508	4112343	1941-12-12	1941-12-12 00:00:00	1941-12-22	1941-12-22 00:00:00	32020		\N	100586	0	195662009	4112343		0
25555	1520	40481087	2000-03-20	2000-03-20 00:00:00	2000-04-10	2000-04-10 00:00:00	32020		\N	101637	0	444814009	40481087		0
25712	1528	40481087	1993-06-25	1993-06-25 00:00:00	1993-07-09	1993-07-09 00:00:00	32020		\N	102266	0	444814009	40481087		0
25890	1537	40481087	1957-02-14	1957-02-14 00:00:00	1957-03-07	1957-03-07 00:00:00	32020		\N	102908	0	444814009	40481087		0
26023	1543	260139	1941-06-19	1941-06-19 00:00:00	1941-06-26	1941-06-26 00:00:00	32020		\N	103417	0	10509002	260139		0
26209	1556	4112343	1997-02-04	1997-02-04 00:00:00	1997-02-13	1997-02-13 00:00:00	32020		\N	104186	0	195662009	4112343		0
26370	1565	80180	1999-11-24	1999-11-24 00:00:00	\N	\N	32020		\N	104925	0	396275006	80180		0
26451	1569	40481087	1968-02-17	1968-02-17 00:00:00	1968-02-24	1968-02-24 00:00:00	32020		\N	105234	0	444814009	40481087		0
26660	1578	40481087	2016-03-17	2016-03-17 00:00:00	2016-03-31	2016-03-31 00:00:00	32020		\N	106026	0	444814009	40481087		0
26854	1590	40481087	1994-07-25	1994-07-25 00:00:00	1994-08-08	1994-08-08 00:00:00	32020		\N	106709	0	444814009	40481087		0
26992	1597	80180	1981-04-06	1981-04-06 00:00:00	\N	\N	32020		\N	107177	0	396275006	80180		0
27139	1605	381316	2006-09-17	2006-09-17 00:00:00	\N	\N	32020		\N	107770	0	230690007	381316		0
27359	1612	4152936	1976-02-06	1976-02-06 00:00:00	1976-02-20	1976-02-20 00:00:00	32020		\N	108358	0	283385000	4152936		0
38031	2258	4112343	1987-06-14	1987-06-14 00:00:00	1987-06-23	1987-06-23 00:00:00	32020		\N	150091	0	195662009	4112343		0
27697	1634	4294548	1944-05-17	1944-05-17 00:00:00	1945-04-04	1945-04-04 00:00:00	32020		\N	109767	0	75498004	4294548		0
38386	2280	133834	1975-06-10	1975-06-10 00:00:00	1986-12-14	1986-12-14 00:00:00	32020		\N	151556	0	24079001	133834		0
38557	2289	28060	1950-04-04	1950-04-04 00:00:00	1950-04-12	1950-04-12 00:00:00	32020		\N	152256	0	43878008	28060		0
28160	1661	40481087	1982-07-09	1982-07-09 00:00:00	1982-07-16	1982-07-16 00:00:00	32020		\N	111636	0	444814009	40481087		0
28361	1676	40481087	1985-04-21	1985-04-21 00:00:00	1985-05-05	1985-05-05 00:00:00	32020		\N	112470	0	444814009	40481087		0
39015	2319	260139	1971-06-11	1971-06-11 00:00:00	1971-06-18	1971-06-18 00:00:00	32020		\N	154157	0	10509002	260139		0
28606	1692	4266809	2017-01-23	2017-01-23 00:00:00	\N	\N	32020		\N	113359	0	397881000	4266809		0
28873	1709	378001	1986-02-14	1986-02-14 00:00:00	1986-04-15	1986-04-15 00:00:00	32020		\N	114239	0	62106007	378001		0
28971	1716	80180	1977-11-01	1977-11-01 00:00:00	\N	\N	32020		\N	114661	0	396275006	80180		0
29172	1727	40481087	2009-03-27	2009-03-27 00:00:00	2009-04-03	2009-04-03 00:00:00	32020		\N	115418	0	444814009	40481087		0
29337	1737	257012	2005-03-26	2005-03-26 00:00:00	\N	\N	32020		\N	116014	0	40055000	257012		0
29473	1745	80180	2017-05-25	2017-05-25 00:00:00	\N	\N	32020		\N	116713	0	396275006	80180		0
29639	1753	40481087	1973-07-30	1973-07-30 00:00:00	1973-08-20	1973-08-20 00:00:00	32020		\N	117172	0	444814009	40481087		0
29781	1762	4112343	1961-02-27	1961-02-27 00:00:00	1961-03-12	1961-03-12 00:00:00	32020		\N	117799	0	195662009	4112343		0
30019	1776	40481087	1988-01-20	1988-01-20 00:00:00	1988-01-27	1988-01-27 00:00:00	32020		\N	118793	0	444814009	40481087		0
30203	1783	81151	1994-03-09	1994-03-09 00:00:00	1994-03-30	1994-03-30 00:00:00	32020		\N	119444	0	44465007	81151		0
30339	1791	81151	1970-04-15	1970-04-15 00:00:00	1970-05-20	1970-05-20 00:00:00	32020		\N	120055	0	44465007	81151		0
41075	2442	40481087	1974-10-11	1974-10-11 00:00:00	1974-10-25	1974-10-25 00:00:00	32020		\N	161918	0	444814009	40481087		0
30682	1813	260139	2007-04-21	2007-04-21 00:00:00	2007-05-05	2007-05-05 00:00:00	32020		\N	121346	0	10509002	260139		0
30866	1826	40481087	1949-07-28	1949-07-28 00:00:00	1949-08-18	1949-08-18 00:00:00	32020		\N	122013	0	444814009	40481087		0
30988	1834	4294548	2006-04-04	2006-04-04 00:00:00	2006-05-30	2006-05-30 00:00:00	32020		\N	122488	0	75498004	4294548		0
31167	1845	260139	2006-02-07	2006-02-07 00:00:00	2006-02-21	2006-02-21 00:00:00	32020		\N	123356	0	10509002	260139		0
31315	1851	4112343	1992-09-23	1992-09-23 00:00:00	1992-09-30	1992-09-30 00:00:00	32020		\N	123838	0	195662009	4112343		0
31520	1864	4152936	2014-02-03	2014-02-03 00:00:00	2014-02-17	2014-02-17 00:00:00	32020		\N	124522	0	283385000	4152936		0
31643	1874	4112343	1987-10-18	1987-10-18 00:00:00	1987-10-27	1987-10-27 00:00:00	32020		\N	125100	0	195662009	4112343		0
42358	2522	4112343	2017-10-08	2017-10-08 00:00:00	2017-10-18	2017-10-18 00:00:00	32020		\N	166830	0	195662009	4112343		0
21374	1282	4112343	2001-05-10	2001-05-10 00:00:00	2001-05-21	2001-05-21 00:00:00	32020		\N	84767	0	195662009	4112343		0
32069	1905	260139	1986-02-19	1986-02-19 00:00:00	1986-02-26	1986-02-26 00:00:00	32020		\N	126815	0	10509002	260139		0
32218	1915	372328	1977-05-18	1977-05-18 00:00:00	1977-08-09	1977-08-09 00:00:00	32020		\N	127382	0	65363002	372328		0
32384	1924	257012	1982-01-02	1982-01-02 00:00:00	\N	\N	32020		\N	128045	0	40055000	257012		0
21982	1316	40481087	1984-07-17	1984-07-17 00:00:00	1984-07-24	1984-07-24 00:00:00	32020		\N	87139	0	444814009	40481087		0
32729	1945	372328	1971-05-28	1971-05-28 00:00:00	1971-08-08	1971-08-08 00:00:00	32020		\N	129229	0	65363002	372328		0
22345	1333	40481087	2018-03-17	2018-03-17 00:00:00	2018-04-07	2018-04-07 00:00:00	32020		\N	88467	0	444814009	40481087		0
22549	1348	40481087	1939-10-19	1939-10-19 00:00:00	1939-11-09	1939-11-09 00:00:00	32020		\N	89334	0	444814009	40481087		0
22689	1355	40481087	2006-03-23	2006-03-23 00:00:00	2006-03-30	2006-03-30 00:00:00	32020		\N	89780	0	444814009	40481087		0
22869	1365	195588	1993-08-14	1993-08-14 00:00:00	1993-09-28	1993-09-28 00:00:00	32020		\N	90482	0	38822007	195588		0
22977	1371	40481087	2013-10-25	2013-10-25 00:00:00	2013-11-08	2013-11-08 00:00:00	32020		\N	90903	0	444814009	40481087		0
23145	1381	40481087	2001-12-16	2001-12-16 00:00:00	2001-12-30	2001-12-30 00:00:00	32020		\N	91580	0	444814009	40481087		0
23341	1391	378419	1993-10-19	1993-10-19 00:00:00	\N	\N	32020		\N	92317	0	26929004	378419		0
23555	1408	80180	1981-03-10	1981-03-10 00:00:00	\N	\N	32020		\N	93687	0	396275006	80180		0
23681	1412	40481087	2015-01-03	2015-01-03 00:00:00	2015-01-24	2015-01-24 00:00:00	32020		\N	94065	0	444814009	40481087		0
34389	2041	4155034	1966-01-15	1966-01-15 00:00:00	1966-02-05	1966-02-05 00:00:00	32020		\N	135852	0	283371005	4155034		0
23980	1431	4285898	1988-04-14	1988-04-14 00:00:00	\N	\N	32020		\N	95313	0	68496003	4285898		0
34728	2062	4283893	1957-05-30	1957-05-30 00:00:00	1957-07-25	1957-07-25 00:00:00	32020		\N	137110	0	36971009	4283893		0
34888	2073	260139	1984-12-30	1984-12-30 00:00:00	1985-01-06	1985-01-06 00:00:00	32020		\N	137899	0	10509002	260139		0
24481	1460	257012	1982-11-20	1982-11-20 00:00:00	\N	\N	32020		\N	97270	0	40055000	257012		0
24626	1468	260139	1951-10-05	1951-10-05 00:00:00	1951-10-19	1951-10-19 00:00:00	32020		\N	97821	0	10509002	260139		0
24900	1486	4112343	2006-08-07	2006-08-07 00:00:00	2006-08-18	2006-08-18 00:00:00	32020		\N	99100	0	195662009	4112343		0
25027	1493	40481087	1966-12-12	1966-12-12 00:00:00	1967-01-02	1967-01-02 00:00:00	32020		\N	99578	0	444814009	40481087		0
25159	1500	4112343	2007-04-15	2007-04-15 00:00:00	2007-04-23	2007-04-23 00:00:00	32020		\N	100071	0	195662009	4112343		0
25303	1508	40481087	1982-04-18	1982-04-18 00:00:00	1982-05-09	1982-05-09 00:00:00	32020		\N	100651	0	444814009	40481087		0
25556	1520	4112343	1955-10-29	1955-10-29 00:00:00	1955-11-08	1955-11-08 00:00:00	32020		\N	101629	0	195662009	4112343		0
25713	1528	260139	1970-05-12	1970-05-12 00:00:00	1970-05-26	1970-05-26 00:00:00	32020		\N	102210	0	10509002	260139		0
25891	1537	81151	1969-07-19	1969-07-19 00:00:00	1969-08-16	1969-08-16 00:00:00	32020		\N	102886	0	44465007	81151		0
26024	1543	40481087	1975-02-27	1975-02-27 00:00:00	1975-03-06	1975-03-06 00:00:00	32020		\N	103371	0	444814009	40481087		0
26210	1556	4112343	1981-12-02	1981-12-02 00:00:00	1981-12-14	1981-12-14 00:00:00	32020		\N	104257	0	195662009	4112343		0
26371	1565	4285898	1999-08-26	1999-08-26 00:00:00	\N	\N	32020		\N	104925	0	68496003	4285898		0
26452	1569	372328	1941-07-29	1941-07-29 00:00:00	1941-08-12	1941-08-12 00:00:00	32020		\N	105301	0	65363002	372328		0
26661	1578	4112343	2013-10-23	2013-10-23 00:00:00	2013-11-03	2013-11-03 00:00:00	32020		\N	105960	0	195662009	4112343		0
26855	1590	78272	1965-12-02	1965-12-02 00:00:00	1965-12-23	1965-12-23 00:00:00	32020		\N	106673	0	70704007	78272		0
26993	1597	257012	1984-10-09	1984-10-09 00:00:00	\N	\N	32020		\N	107101	0	40055000	257012		0
27140	1605	40481087	1968-08-03	1968-08-03 00:00:00	1968-08-17	1968-08-17 00:00:00	32020		\N	107678	0	444814009	40481087		0
27360	1612	40481087	1997-02-06	1997-02-06 00:00:00	1997-02-13	1997-02-13 00:00:00	32020		\N	108365	0	444814009	40481087		0
38032	2258	40481087	1982-10-29	1982-10-29 00:00:00	1982-11-05	1982-11-05 00:00:00	32020		\N	150078	0	444814009	40481087		0
27698	1634	313217	2014-08-29	2014-08-29 00:00:00	\N	\N	32020		\N	109777	0	49436004	313217		0
38387	2280	260139	1993-12-20	1993-12-20 00:00:00	1994-01-03	1994-01-03 00:00:00	32020		\N	151607	0	10509002	260139		0
38558	2289	40481087	1990-09-15	1990-09-15 00:00:00	1990-10-06	1990-10-06 00:00:00	32020		\N	152217	0	444814009	40481087		0
28161	1661	4109685	1980-05-24	1980-05-24 00:00:00	1980-06-14	1980-06-14 00:00:00	32020		\N	111651	0	284551006	4109685		0
28362	1676	257012	1999-03-03	1999-03-03 00:00:00	\N	\N	32020		\N	112452	0	40055000	257012		0
39016	2319	40481087	1966-07-07	1966-07-07 00:00:00	1966-07-21	1966-07-21 00:00:00	32020		\N	154196	0	444814009	40481087		0
28607	1692	40481087	1996-10-25	1996-10-25 00:00:00	1996-11-15	1996-11-15 00:00:00	32020		\N	113320	0	444814009	40481087		0
28874	1709	40481087	1967-03-02	1967-03-02 00:00:00	1967-03-09	1967-03-09 00:00:00	32020		\N	114255	0	444814009	40481087		0
28972	1716	4109685	1971-08-31	1971-08-31 00:00:00	1971-09-21	1971-09-21 00:00:00	32020		\N	114703	0	284551006	4109685		0
29173	1727	40481087	1952-11-15	1952-11-15 00:00:00	1952-11-22	1952-11-22 00:00:00	32020		\N	115512	0	444814009	40481087		0
29338	1737	40481087	1997-04-22	1997-04-22 00:00:00	1997-05-13	1997-05-13 00:00:00	32020		\N	116013	0	444814009	40481087		0
29474	1745	40481087	1996-12-25	1996-12-25 00:00:00	1997-01-15	1997-01-15 00:00:00	32020		\N	116674	0	444814009	40481087		0
29640	1753	4296204	1972-05-09	1972-05-09 00:00:00	1972-05-23	1972-05-23 00:00:00	32020		\N	117164	0	403190006	4296204		0
29782	1762	260139	1967-10-06	1967-10-06 00:00:00	1967-10-20	1967-10-20 00:00:00	32020		\N	117847	0	10509002	260139		0
30020	1776	4218389	1940-11-24	1940-11-24 00:00:00	1940-12-15	1940-12-15 00:00:00	32020		\N	118802	0	39848009	4218389		0
30204	1783	195588	2017-07-26	2017-07-26 00:00:00	2017-09-18	2017-09-18 00:00:00	32020		\N	119460	0	38822007	195588		0
30340	1791	4112343	1983-01-29	1983-01-29 00:00:00	1983-02-09	1983-02-09 00:00:00	32020		\N	120021	0	195662009	4112343		0
41076	2442	28060	1979-12-18	1979-12-18 00:00:00	1979-12-28	1979-12-28 00:00:00	32020		\N	162010	0	43878008	28060		0
30683	1813	4112343	2004-05-07	2004-05-07 00:00:00	2004-05-20	2004-05-20 00:00:00	32020		\N	121345	0	195662009	4112343		0
30867	1826	4283893	1963-02-16	1963-02-16 00:00:00	1963-03-09	1963-03-09 00:00:00	32020		\N	122052	0	36971009	4283893		0
30989	1834	28060	1985-01-13	1985-01-13 00:00:00	1985-01-21	1985-01-21 00:00:00	32020		\N	122483	0	43878008	28060		0
31168	1845	40481087	2011-07-29	2011-07-29 00:00:00	2011-08-12	2011-08-12 00:00:00	32020		\N	123255	0	444814009	40481087		0
31316	1851	40481087	2009-04-24	2009-04-24 00:00:00	2009-05-01	2009-05-01 00:00:00	32020		\N	123841	0	444814009	40481087		0
31521	1864	260139	1979-11-04	1979-11-04 00:00:00	1979-11-11	1979-11-11 00:00:00	32020		\N	124553	0	10509002	260139		0
31644	1874	4112343	2011-01-27	2011-01-27 00:00:00	2011-02-07	2011-02-07 00:00:00	32020		\N	125133	0	195662009	4112343		0
42360	2524	4112343	1993-06-02	1993-06-02 00:00:00	1993-06-11	1993-06-11 00:00:00	32020		\N	166915	0	195662009	4112343		0
21375	1282	40481087	1993-10-28	1993-10-28 00:00:00	1993-11-04	1993-11-04 00:00:00	32020		\N	84754	0	444814009	40481087		0
32070	1905	81151	2000-10-31	2000-10-31 00:00:00	2000-11-21	2000-11-21 00:00:00	32020		\N	126841	0	44465007	81151		0
32219	1915	78272	1985-03-07	1985-03-07 00:00:00	1985-03-21	1985-03-21 00:00:00	32020		\N	127416	0	70704007	78272		0
32385	1924	78272	1985-10-18	1985-10-18 00:00:00	1985-11-01	1985-11-01 00:00:00	32020		\N	128070	0	70704007	78272		0
21983	1316	260139	1952-03-18	1952-03-18 00:00:00	1952-04-01	1952-04-01 00:00:00	32020		\N	87216	0	10509002	260139		0
32730	1945	40481087	2000-01-23	2000-01-23 00:00:00	2000-02-06	2000-02-06 00:00:00	32020		\N	129204	0	444814009	40481087		0
22346	1334	4113008	1973-09-05	1973-09-05 00:00:00	1973-09-26	1973-09-26 00:00:00	32020		\N	88530	0	284549007	4113008		0
22550	1348	4112343	1977-06-19	1977-06-19 00:00:00	1977-07-01	1977-07-01 00:00:00	32020		\N	89314	0	195662009	4112343		0
22690	1355	260139	1971-12-24	1971-12-24 00:00:00	1972-01-07	1972-01-07 00:00:00	32020		\N	89839	0	10509002	260139		0
22870	1365	260139	1978-06-05	1978-06-05 00:00:00	1978-06-12	1978-06-12 00:00:00	32020		\N	90501	0	10509002	260139		0
22978	1371	4112343	1998-10-25	1998-10-25 00:00:00	1998-11-04	1998-11-04 00:00:00	32020		\N	90901	0	195662009	4112343		0
23146	1382	80180	2014-07-07	2014-07-07 00:00:00	\N	\N	32020		\N	91614	0	396275006	80180		0
23342	1391	4112343	1987-07-02	1987-07-02 00:00:00	1987-07-10	1987-07-10 00:00:00	32020		\N	92386	0	195662009	4112343		0
23556	1408	4283893	1994-08-11	1994-08-11 00:00:00	1995-02-09	1995-02-09 00:00:00	32020		\N	93625	0	36971009	4283893		0
23682	1412	372328	1964-09-24	1964-09-24 00:00:00	1964-11-14	1964-11-14 00:00:00	32020		\N	93991	0	65363002	372328		0
34390	2041	40481087	1998-08-20	1998-08-20 00:00:00	1998-09-10	1998-09-10 00:00:00	32020		\N	135866	0	444814009	40481087		0
23981	1431	81893	1987-06-19	1987-06-19 00:00:00	\N	\N	32020		\N	95313	0	64766004	81893		0
34729	2062	4112343	1965-01-12	1965-01-12 00:00:00	1965-01-24	1965-01-24 00:00:00	32020		\N	137167	0	195662009	4112343		0
34889	2073	4112343	1965-10-06	1965-10-06 00:00:00	1965-10-13	1965-10-13 00:00:00	32020		\N	137881	0	195662009	4112343		0
24482	1460	4152936	1984-03-15	1984-03-15 00:00:00	1984-03-29	1984-03-29 00:00:00	32020		\N	97303	0	283385000	4152936		0
24627	1468	378001	2007-04-20	2007-04-20 00:00:00	2007-05-20	2007-05-20 00:00:00	32020		\N	97876	0	62106007	378001		0
35359	2094	40481087	1977-02-20	1977-02-20 00:00:00	1977-03-13	1977-03-13 00:00:00	32020		\N	139584	0	444814009	40481087		0
25028	1493	260139	1960-09-05	1960-09-05 00:00:00	1960-09-12	1960-09-12 00:00:00	32020		\N	99561	0	10509002	260139		0
25160	1500	40481087	2015-08-04	2015-08-04 00:00:00	2015-08-11	2015-08-11 00:00:00	32020		\N	100073	0	444814009	40481087		0
25304	1508	381316	1982-11-23	1982-11-23 00:00:00	\N	\N	32020		\N	100651	0	230690007	381316		0
25557	1520	4112343	1946-05-22	1946-05-22 00:00:00	1946-06-03	1946-06-03 00:00:00	32020		\N	101712	0	195662009	4112343		0
25714	1528	4112343	1964-09-12	1964-09-12 00:00:00	1964-09-22	1964-09-22 00:00:00	32020		\N	102261	0	195662009	4112343		0
25892	1537	40481087	2008-01-21	2008-01-21 00:00:00	2008-01-28	2008-01-28 00:00:00	32020		\N	102870	0	444814009	40481087		0
26025	1543	40481087	1943-07-15	1943-07-15 00:00:00	1943-07-29	1943-07-29 00:00:00	32020		\N	103424	0	444814009	40481087		0
26211	1556	4112343	1990-10-29	1990-10-29 00:00:00	1990-11-05	1990-11-05 00:00:00	32020		\N	104262	0	195662009	4112343		0
26372	1565	4027663	1990-09-07	1990-09-07 00:00:00	\N	\N	32020		\N	104960	0	13200003	4027663		0
26453	1569	40479768	1987-04-06	1987-04-06 00:00:00	1987-06-12	1987-06-12 00:00:00	32020		\N	105228	0	444470001	40479768		0
26662	1578	4112343	1972-03-04	1972-03-04 00:00:00	1972-03-16	1972-03-16 00:00:00	32020		\N	105977	0	195662009	4112343		0
26856	1590	4112343	1971-11-14	1971-11-14 00:00:00	1971-11-27	1971-11-27 00:00:00	32020		\N	106700	0	195662009	4112343		0
26994	1597	4084167	1948-11-08	1948-11-08 00:00:00	1948-11-08	1948-11-08 00:00:00	32020		\N	107114	0	241929008	4084167		0
27141	1605	4112343	2018-12-08	2018-12-08 00:00:00	2018-12-16	2018-12-16 00:00:00	32020		\N	107783	0	195662009	4112343		0
27361	1612	4296204	1982-01-19	1982-01-19 00:00:00	1982-02-02	1982-02-02 00:00:00	32020		\N	108359	0	403190006	4296204		0
38033	2258	40481087	1991-05-28	1991-05-28 00:00:00	1991-06-18	1991-06-18 00:00:00	32020		\N	150092	0	444814009	40481087		0
27699	1634	4146173	1940-08-29	1940-08-29 00:00:00	1940-10-28	1940-10-28 00:00:00	32020		\N	109723	0	307731004	4146173		0
38388	2280	4112343	1985-09-24	1985-09-24 00:00:00	1985-10-03	1985-10-03 00:00:00	32020		\N	151565	0	195662009	4112343		0
38559	2289	380378	1959-03-19	1959-03-19 00:00:00	\N	\N	32020		\N	152248	0	84757009	380378		0
28162	1661	40481087	2000-10-17	2000-10-17 00:00:00	2000-11-07	2000-11-07 00:00:00	32020		\N	111686	0	444814009	40481087		0
28363	1676	80180	2014-10-21	2014-10-21 00:00:00	\N	\N	32020		\N	112468	0	396275006	80180		0
39017	2319	4084167	1947-08-14	1947-08-14 00:00:00	1947-08-14	1947-08-14 00:00:00	32020		\N	154131	0	241929008	4084167		0
28608	1692	4027663	2007-08-09	2007-08-09 00:00:00	\N	\N	32020		\N	113341	0	13200003	4027663		0
28875	1709	40481087	2004-10-07	2004-10-07 00:00:00	2004-10-14	2004-10-14 00:00:00	32020		\N	114267	0	444814009	40481087		0
28973	1716	4112343	2013-01-09	2013-01-09 00:00:00	2013-01-20	2013-01-20 00:00:00	32020		\N	114668	0	195662009	4112343		0
29174	1727	195588	2000-03-17	2000-03-17 00:00:00	2000-04-18	2000-04-18 00:00:00	32020		\N	115427	0	38822007	195588		0
29339	1737	4283893	2005-01-22	2005-01-22 00:00:00	2006-01-14	2006-01-14 00:00:00	32020		\N	116039	0	36971009	4283893		0
29475	1746	4094814	1957-10-16	1957-10-16 00:00:00	1958-01-14	1958-01-14 00:00:00	32020		\N	116762	0	262574004	4094814		0
29641	1753	4112343	1973-03-09	1973-03-09 00:00:00	1973-03-16	1973-03-16 00:00:00	32020		\N	117272	0	195662009	4112343		0
29783	1762	4112343	1952-08-01	1952-08-01 00:00:00	1952-08-12	1952-08-12 00:00:00	32020		\N	117891	0	195662009	4112343		0
30021	1776	40481087	1980-06-17	1980-06-17 00:00:00	1980-06-24	1980-06-24 00:00:00	32020		\N	118866	0	444814009	40481087		0
30205	1783	4048171	1961-08-02	1961-08-02 00:00:00	\N	\N	32020		\N	119420	0	232353008	4048171		0
30341	1791	4112343	1976-10-19	1976-10-19 00:00:00	1976-10-28	1976-10-28 00:00:00	32020		\N	120086	0	195662009	4112343		0
41077	2442	4155034	1982-06-23	1982-06-23 00:00:00	1982-07-14	1982-07-14 00:00:00	32020		\N	161958	0	283371005	4155034		0
30684	1813	4134304	2016-03-18	2016-03-18 00:00:00	2016-04-17	2016-04-17 00:00:00	32020		\N	121310	0	263102004	4134304		0
30868	1826	378001	1989-08-21	1989-08-21 00:00:00	1989-10-20	1989-10-20 00:00:00	32020		\N	122062	0	62106007	378001		0
30990	1834	78272	2009-01-13	2009-01-13 00:00:00	2009-02-17	2009-02-17 00:00:00	32020		\N	122544	0	70704007	78272		0
31169	1845	40481087	1992-04-23	1992-04-23 00:00:00	1992-05-07	1992-05-07 00:00:00	32020		\N	123350	0	444814009	40481087		0
31317	1851	4001336	2006-09-21	2006-09-21 00:00:00	2006-10-21	2006-10-21 00:00:00	32020		\N	123827	0	110030002	4001336		0
31522	1864	80180	2004-09-14	2004-09-14 00:00:00	\N	\N	32020		\N	124528	0	396275006	80180		0
31645	1874	260139	2000-11-27	2000-11-27 00:00:00	2000-12-11	2000-12-11 00:00:00	32020		\N	125120	0	10509002	260139		0
42361	2524	261325	2002-07-06	2002-07-06 00:00:00	\N	\N	32020		\N	166932	0	87433001	261325		0
21376	1282	40481087	1987-05-05	1987-05-05 00:00:00	1987-05-26	1987-05-26 00:00:00	32020		\N	84753	0	444814009	40481087		0
32071	1905	4112343	1980-01-09	1980-01-09 00:00:00	1980-01-17	1980-01-17 00:00:00	32020		\N	126814	0	195662009	4112343		0
32220	1915	40481087	2012-07-22	2012-07-22 00:00:00	2012-08-05	2012-08-05 00:00:00	32020		\N	127392	0	444814009	40481087		0
32386	1924	4134304	1978-08-26	1978-08-26 00:00:00	1978-11-24	1978-11-24 00:00:00	32020		\N	128069	0	263102004	4134304		0
21984	1316	4310024	1992-09-10	1992-09-10 00:00:00	\N	\N	32020		\N	87198	0	424802006	4310024		0
32731	1945	40481087	1973-07-21	1973-07-21 00:00:00	1973-08-11	1973-08-11 00:00:00	32020		\N	129243	0	444814009	40481087		0
22347	1334	372328	1974-05-19	1974-05-19 00:00:00	1975-02-09	1975-02-09 00:00:00	32020		\N	88509	0	65363002	372328		0
22551	1348	375671	1947-07-12	1947-07-12 00:00:00	1947-08-11	1947-08-11 00:00:00	32020		\N	89372	0	62564004	375671		0
22691	1355	4112343	1966-09-07	1966-09-07 00:00:00	1966-09-17	1966-09-17 00:00:00	32020		\N	89796	0	195662009	4112343		0
22871	1365	40481087	1974-10-25	1974-10-25 00:00:00	1974-11-01	1974-11-01 00:00:00	32020		\N	90428	0	444814009	40481087		0
22979	1371	4059173	1991-08-01	1991-08-01 00:00:00	1991-08-31	1991-08-31 00:00:00	32020		\N	90895	0	16114001	4059173		0
23147	1382	40481087	1990-11-11	1990-11-11 00:00:00	1990-12-02	1990-12-02 00:00:00	32020		\N	91643	0	444814009	40481087		0
23343	1391	40481087	1980-10-09	1980-10-09 00:00:00	1980-10-30	1980-10-30 00:00:00	32020		\N	92348	0	444814009	40481087		0
23557	1408	4112343	1989-06-26	1989-06-26 00:00:00	1989-07-06	1989-07-06 00:00:00	32020		\N	93643	0	195662009	4112343		0
23683	1412	260139	2018-07-31	2018-07-31 00:00:00	2018-08-14	2018-08-14 00:00:00	32020		\N	93989	0	10509002	260139		0
34391	2041	260139	1972-07-14	1972-07-14 00:00:00	1972-07-21	1972-07-21 00:00:00	32020		\N	135811	0	10509002	260139		0
23982	1431	260139	1963-06-22	1963-06-22 00:00:00	1963-07-06	1963-07-06 00:00:00	32020		\N	95296	0	10509002	260139		0
34730	2062	4112343	1984-08-15	1984-08-15 00:00:00	1984-08-27	1984-08-27 00:00:00	32020		\N	137125	0	195662009	4112343		0
34890	2073	381316	2012-04-13	2012-04-13 00:00:00	\N	\N	32020		\N	137922	0	230690007	381316		0
24483	1460	372328	1982-07-24	1982-07-24 00:00:00	1982-08-07	1982-08-07 00:00:00	32020		\N	97273	0	65363002	372328		0
24628	1468	4112343	2009-03-23	2009-03-23 00:00:00	2009-04-02	2009-04-02 00:00:00	32020		\N	97857	0	195662009	4112343		0
35360	2094	4027663	1977-12-31	1977-12-31 00:00:00	\N	\N	32020		\N	139584	0	13200003	4027663		0
25029	1493	381316	2016-03-08	2016-03-08 00:00:00	\N	\N	32020		\N	99518	0	230690007	381316		0
25161	1500	40481087	1971-01-18	1971-01-18 00:00:00	1971-02-08	1971-02-08 00:00:00	32020		\N	100126	0	444814009	40481087		0
25310	1510	4059173	1989-06-18	1989-06-18 00:00:00	1989-08-17	1989-08-17 00:00:00	32020		\N	100790	0	16114001	4059173		0
25558	1520	4112343	2000-03-13	2000-03-13 00:00:00	2000-03-21	2000-03-21 00:00:00	32020		\N	101636	0	195662009	4112343		0
25715	1528	4112343	1980-08-18	1980-08-18 00:00:00	1980-08-28	1980-08-28 00:00:00	32020		\N	102263	0	195662009	4112343		0
25893	1537	78272	1960-11-19	1960-11-19 00:00:00	1960-12-03	1960-12-03 00:00:00	32020		\N	102884	0	70704007	78272		0
26026	1543	4237458	1946-06-21	1946-06-21 00:00:00	1946-09-19	1946-09-19 00:00:00	32020		\N	103421	0	58150001	4237458		0
26212	1556	4112343	1978-09-03	1978-09-03 00:00:00	1978-09-16	1978-09-16 00:00:00	32020		\N	104272	0	195662009	4112343		0
26373	1565	257012	1995-07-08	1995-07-08 00:00:00	\N	\N	32020		\N	104972	0	40055000	257012		0
26454	1569	4027663	1961-08-29	1961-08-29 00:00:00	\N	\N	32020		\N	105312	0	13200003	4027663		0
26663	1578	28060	1952-01-11	1952-01-11 00:00:00	1952-01-18	1952-01-18 00:00:00	32020		\N	105975	0	43878008	28060		0
26857	1590	260139	1985-05-24	1985-05-24 00:00:00	1985-06-07	1985-06-07 00:00:00	32020		\N	106701	0	10509002	260139		0
26995	1597	4294548	1984-09-04	1984-09-04 00:00:00	1984-12-25	1984-12-25 00:00:00	32020		\N	107124	0	75498004	4294548		0
27142	1605	40481087	2003-09-10	2003-09-10 00:00:00	2003-10-01	2003-10-01 00:00:00	32020		\N	107780	0	444814009	40481087		0
27362	1612	372328	1966-11-11	1966-11-11 00:00:00	1967-01-03	1967-01-03 00:00:00	32020		\N	108391	0	65363002	372328		0
38034	2258	4112343	1991-02-05	1991-02-05 00:00:00	1991-02-13	1991-02-13 00:00:00	32020		\N	150084	0	195662009	4112343		0
27700	1634	40481087	1959-03-28	1959-03-28 00:00:00	1959-04-04	1959-04-04 00:00:00	32020		\N	109737	0	444814009	40481087		0
38389	2280	4112343	2002-07-11	2002-07-11 00:00:00	2002-07-20	2002-07-20 00:00:00	32020		\N	151646	0	195662009	4112343		0
38560	2290	4237458	1988-02-28	1988-02-28 00:00:00	1988-04-28	1988-04-28 00:00:00	32020		\N	152337	0	58150001	4237458		0
28163	1661	260139	1979-01-05	1979-01-05 00:00:00	1979-01-12	1979-01-12 00:00:00	32020		\N	111691	0	10509002	260139		0
28364	1676	4283893	1999-01-20	1999-01-20 00:00:00	1999-04-07	1999-04-07 00:00:00	32020		\N	112451	0	36971009	4283893		0
39018	2319	4109685	1986-10-21	1986-10-21 00:00:00	1986-11-11	1986-11-11 00:00:00	32020		\N	154137	0	284551006	4109685		0
28609	1692	4112343	2012-10-22	2012-10-22 00:00:00	2012-11-04	2012-11-04 00:00:00	32020		\N	113322	0	195662009	4112343		0
28876	1709	40481087	1953-07-31	1953-07-31 00:00:00	1953-08-14	1953-08-14 00:00:00	32020		\N	114297	0	444814009	40481087		0
28974	1716	4294548	1979-04-28	1979-04-28 00:00:00	1979-09-22	1979-09-22 00:00:00	32020		\N	114757	0	75498004	4294548		0
29175	1727	40481087	2008-07-01	2008-07-01 00:00:00	2008-07-22	2008-07-22 00:00:00	32020		\N	115485	0	444814009	40481087		0
29340	1737	40481087	2008-07-11	2008-07-11 00:00:00	2008-07-25	2008-07-25 00:00:00	32020		\N	116021	0	444814009	40481087		0
29476	1746	40481087	1958-06-02	1958-06-02 00:00:00	1958-06-09	1958-06-09 00:00:00	32020		\N	116778	0	444814009	40481087		0
29642	1753	40481087	2007-06-12	2007-06-12 00:00:00	2007-06-19	2007-06-19 00:00:00	32020		\N	117238	0	444814009	40481087		0
29784	1762	261325	1961-03-09	1961-03-09 00:00:00	\N	\N	32020		\N	117887	0	87433001	261325		0
30022	1776	4112343	1923-07-07	1923-07-07 00:00:00	1923-07-14	1923-07-14 00:00:00	32020		\N	118771	0	195662009	4112343		0
30206	1783	4051466	1961-08-02	1961-08-02 00:00:00	1978-11-05	1978-11-05 00:00:00	32020		\N	119420	0	233678006	4051466		0
30342	1791	4112343	2011-03-30	2011-03-30 00:00:00	2011-04-08	2011-04-08 00:00:00	32020		\N	120069	0	195662009	4112343		0
41078	2442	4027663	1998-06-14	1998-06-14 00:00:00	\N	\N	32020		\N	162012	0	13200003	4027663		0
30685	1813	372328	1984-04-05	1984-04-05 00:00:00	1984-05-26	1984-05-26 00:00:00	32020		\N	121351	0	65363002	372328		0
30869	1826	260139	2004-02-27	2004-02-27 00:00:00	2004-03-05	2004-03-05 00:00:00	32020		\N	122057	0	10509002	260139		0
30991	1834	28060	1970-12-13	1970-12-13 00:00:00	1970-12-25	1970-12-25 00:00:00	32020		\N	122558	0	43878008	28060		0
31170	1845	4152936	1996-04-15	1996-04-15 00:00:00	1996-04-29	1996-04-29 00:00:00	32020		\N	123325	0	283385000	4152936		0
31319	1851	4029498	1988-12-05	1988-12-05 00:00:00	\N	\N	32020		\N	123828	0	128613002	4029498		0
31523	1864	260139	1971-04-08	1971-04-08 00:00:00	1971-04-22	1971-04-22 00:00:00	32020		\N	124552	0	10509002	260139		0
31646	1874	4112343	2005-11-24	2005-11-24 00:00:00	2005-12-07	2005-12-07 00:00:00	32020		\N	125101	0	195662009	4112343		0
42362	2524	40481087	1999-05-18	1999-05-18 00:00:00	1999-06-01	1999-06-01 00:00:00	32020		\N	166904	0	444814009	40481087		0
21377	1282	378001	1994-02-12	1994-02-12 00:00:00	1994-04-13	1994-04-13 00:00:00	32020		\N	84735	0	62106007	378001		0
32072	1905	40481087	1988-08-22	1988-08-22 00:00:00	1988-08-29	1988-08-29 00:00:00	32020		\N	126804	0	444814009	40481087		0
32221	1915	40481087	1980-06-21	1980-06-21 00:00:00	1980-07-12	1980-07-12 00:00:00	32020		\N	127342	0	444814009	40481087		0
32387	1924	313217	2019-06-28	2019-06-28 00:00:00	\N	\N	32020		\N	128060	0	49436004	313217		0
21985	1317	4155034	1999-01-18	1999-01-18 00:00:00	1999-02-01	1999-02-01 00:00:00	32020		\N	87279	0	283371005	4155034		0
32732	1945	4112343	2003-08-21	2003-08-21 00:00:00	2003-08-28	2003-08-28 00:00:00	32020		\N	129205	0	195662009	4112343		0
22348	1334	78272	1997-01-23	1997-01-23 00:00:00	1997-02-27	1997-02-27 00:00:00	32020		\N	88531	0	70704007	78272		0
22552	1348	40481087	1948-04-01	1948-04-01 00:00:00	1948-04-15	1948-04-15 00:00:00	32020		\N	89362	0	444814009	40481087		0
22692	1355	28060	1987-07-02	1987-07-02 00:00:00	1987-07-09	1987-07-09 00:00:00	32020		\N	89778	0	43878008	28060		0
22872	1365	40481087	1967-03-09	1967-03-09 00:00:00	1967-03-16	1967-03-16 00:00:00	32020		\N	90496	0	444814009	40481087		0
22980	1371	40481087	1990-08-06	1990-08-06 00:00:00	1990-08-20	1990-08-20 00:00:00	32020		\N	90914	0	444814009	40481087		0
23148	1382	260139	2003-08-04	2003-08-04 00:00:00	2003-08-11	2003-08-11 00:00:00	32020		\N	91645	0	10509002	260139		0
23344	1391	4278672	1997-12-20	1997-12-20 00:00:00	1998-03-20	1998-03-20 00:00:00	32020		\N	92409	0	65966004	4278672		0
23558	1408	81151	1959-08-06	1959-08-06 00:00:00	1959-09-03	1959-09-03 00:00:00	32020		\N	93620	0	44465007	81151		0
23684	1412	260139	2011-01-12	2011-01-12 00:00:00	2011-01-19	2011-01-19 00:00:00	32020		\N	93986	0	10509002	260139		0
34392	2041	78272	1994-04-28	1994-04-28 00:00:00	1994-06-02	1994-06-02 00:00:00	32020		\N	135856	0	70704007	78272		0
23983	1431	4112343	1961-01-05	1961-01-05 00:00:00	1961-01-13	1961-01-13 00:00:00	32020		\N	95286	0	195662009	4112343		0
34731	2062	81151	1988-02-02	1988-02-02 00:00:00	1988-03-08	1988-03-08 00:00:00	32020		\N	137198	0	44465007	81151		0
34891	2073	40481087	1997-12-27	1997-12-27 00:00:00	1998-01-17	1998-01-17 00:00:00	32020		\N	137888	0	444814009	40481087		0
24484	1460	28060	1988-10-05	1988-10-05 00:00:00	1988-10-13	1988-10-13 00:00:00	32020		\N	97315	0	43878008	28060		0
24629	1468	4152936	1964-11-07	1964-11-07 00:00:00	1964-11-28	1964-11-28 00:00:00	32020		\N	97873	0	283385000	4152936		0
35361	2094	4112343	2004-08-29	2004-08-29 00:00:00	2004-09-08	2004-09-08 00:00:00	32020		\N	139604	0	195662009	4112343		0
25030	1493	4109685	1994-04-09	1994-04-09 00:00:00	1994-04-23	1994-04-23 00:00:00	32020		\N	99576	0	284551006	4109685		0
25162	1500	40481087	2008-07-19	2008-07-19 00:00:00	2008-08-02	2008-08-02 00:00:00	32020		\N	100129	0	444814009	40481087		0
25311	1510	81893	2001-01-15	2001-01-15 00:00:00	\N	\N	32020		\N	100824	0	64766004	81893		0
25559	1520	260139	2002-09-22	2002-09-22 00:00:00	2002-09-29	2002-09-29 00:00:00	32020		\N	101626	0	10509002	260139		0
25716	1528	81151	1972-01-31	1972-01-31 00:00:00	1972-02-14	1972-02-14 00:00:00	32020		\N	102239	0	44465007	81151		0
25894	1537	372328	1961-05-26	1961-05-26 00:00:00	1962-05-02	1962-05-02 00:00:00	32020		\N	102925	0	65363002	372328		0
26027	1543	317576	1986-08-24	1986-08-24 00:00:00	\N	\N	32020		\N	103397	0	53741008	317576		0
26213	1556	80180	2016-05-07	2016-05-07 00:00:00	\N	\N	32020		\N	104166	0	396275006	80180		0
26374	1565	260139	1998-03-14	1998-03-14 00:00:00	1998-03-28	1998-03-28 00:00:00	32020		\N	104919	0	10509002	260139		0
26455	1569	260139	1974-08-15	1974-08-15 00:00:00	1974-08-22	1974-08-22 00:00:00	32020		\N	105235	0	10509002	260139		0
26664	1578	4112343	1981-12-27	1981-12-27 00:00:00	1982-01-04	1982-01-04 00:00:00	32020		\N	105956	0	195662009	4112343		0
26858	1590	4112343	1976-01-08	1976-01-08 00:00:00	1976-01-15	1976-01-15 00:00:00	32020		\N	106686	0	195662009	4112343		0
26996	1597	40481087	2013-07-16	2013-07-16 00:00:00	2013-07-30	2013-07-30 00:00:00	32020		\N	107133	0	444814009	40481087		0
27143	1605	4278672	1958-06-08	1958-06-08 00:00:00	1958-07-08	1958-07-08 00:00:00	32020		\N	107747	0	65966004	4278672		0
27363	1612	40481087	2015-07-17	2015-07-17 00:00:00	2015-07-24	2015-07-24 00:00:00	32020		\N	108367	0	444814009	40481087		0
38035	2258	40481087	1995-12-14	1995-12-14 00:00:00	1995-12-21	1995-12-21 00:00:00	32020		\N	150093	0	444814009	40481087		0
27701	1634	4112343	1997-08-17	1997-08-17 00:00:00	1997-08-30	1997-08-30 00:00:00	32020		\N	109725	0	195662009	4112343		0
38390	2280	4112343	1969-09-04	1969-09-04 00:00:00	1969-09-17	1969-09-17 00:00:00	32020		\N	151551	0	195662009	4112343		0
38561	2290	40481087	2009-05-31	2009-05-31 00:00:00	2009-06-21	2009-06-21 00:00:00	32020		\N	152329	0	444814009	40481087		0
28164	1661	372328	1957-09-17	1957-09-17 00:00:00	1957-12-05	1957-12-05 00:00:00	32020		\N	111695	0	65363002	372328		0
28365	1676	260139	1983-01-28	1983-01-28 00:00:00	1983-02-11	1983-02-11 00:00:00	32020		\N	112450	0	10509002	260139		0
39019	2319	80180	1990-02-24	1990-02-24 00:00:00	\N	\N	32020		\N	154209	0	396275006	80180		0
28610	1692	260139	1982-08-17	1982-08-17 00:00:00	1982-08-24	1982-08-24 00:00:00	32020		\N	113345	0	10509002	260139		0
28877	1709	81151	2002-01-21	2002-01-21 00:00:00	2002-02-18	2002-02-18 00:00:00	32020		\N	114240	0	44465007	81151		0
28975	1716	375671	1991-05-30	1991-05-30 00:00:00	1991-07-29	1991-07-29 00:00:00	32020		\N	114705	0	62564004	375671		0
29176	1727	258780	1999-03-31	1999-03-31 00:00:00	\N	\N	32020		\N	115511	0	185086009	258780		0
29341	1737	375671	1996-09-03	1996-09-03 00:00:00	1996-10-03	1996-10-03 00:00:00	32020		\N	115963	0	62564004	375671		0
29477	1746	40481087	2001-05-31	2001-05-31 00:00:00	2001-06-14	2001-06-14 00:00:00	32020		\N	116782	0	444814009	40481087		0
29643	1753	40481087	1987-03-16	1987-03-16 00:00:00	1987-04-06	1987-04-06 00:00:00	32020		\N	117175	0	444814009	40481087		0
29785	1762	4112343	1969-12-24	1969-12-24 00:00:00	1969-12-31	1969-12-31 00:00:00	32020		\N	117848	0	195662009	4112343		0
30023	1776	40481087	1961-12-21	1961-12-21 00:00:00	1961-12-28	1961-12-28 00:00:00	32020		\N	118772	0	444814009	40481087		0
30207	1783	28060	2008-12-19	2008-12-19 00:00:00	2008-12-26	2008-12-26 00:00:00	32020		\N	119508	0	43878008	28060		0
30343	1791	40481087	2016-12-10	2016-12-10 00:00:00	2016-12-24	2016-12-24 00:00:00	32020		\N	120070	0	444814009	40481087		0
41079	2442	40481087	1998-03-12	1998-03-12 00:00:00	1998-03-26	1998-03-26 00:00:00	32020		\N	162012	0	444814009	40481087		0
30686	1813	372328	1984-09-23	1984-09-23 00:00:00	1984-11-24	1984-11-24 00:00:00	32020		\N	121349	0	65363002	372328		0
30870	1826	40481087	1950-06-14	1950-06-14 00:00:00	1950-07-05	1950-07-05 00:00:00	32020		\N	122014	0	444814009	40481087		0
31009	1837	40481087	1972-08-20	1972-08-20 00:00:00	1972-08-27	1972-08-27 00:00:00	32020		\N	122713	0	444814009	40481087		0
31171	1845	372328	1964-08-31	1964-08-31 00:00:00	1964-09-23	1964-09-23 00:00:00	32020		\N	123302	0	65363002	372328		0
31320	1851	380378	1988-12-05	1988-12-05 00:00:00	\N	\N	32020		\N	123828	0	84757009	380378		0
31524	1864	4112343	1994-06-15	1994-06-15 00:00:00	1994-06-26	1994-06-26 00:00:00	32020		\N	124555	0	195662009	4112343		0
31647	1874	40481087	2016-11-09	2016-11-09 00:00:00	2016-11-30	2016-11-30 00:00:00	32020		\N	125153	0	444814009	40481087		0
42363	2524	4112343	1986-01-28	1986-01-28 00:00:00	1986-02-08	1986-02-08 00:00:00	32020		\N	166903	0	195662009	4112343		0
21378	1282	40481087	2015-02-10	2015-02-10 00:00:00	2015-02-24	2015-02-24 00:00:00	32020		\N	84724	0	444814009	40481087		0
32073	1905	28060	1990-01-27	1990-01-27 00:00:00	1990-02-04	1990-02-04 00:00:00	32020		\N	126821	0	43878008	28060		0
32222	1915	4156265	2018-09-13	2018-09-13 00:00:00	2018-09-27	2018-09-27 00:00:00	32020		\N	127407	0	370247008	4156265		0
32388	1924	40481087	1973-09-26	1973-09-26 00:00:00	1973-10-10	1973-10-10 00:00:00	32020		\N	128026	0	444814009	40481087		0
21986	1317	80180	1989-11-19	1989-11-19 00:00:00	\N	\N	32020		\N	87326	0	396275006	80180		0
32733	1945	28060	2007-10-22	2007-10-22 00:00:00	2007-11-01	2007-11-01 00:00:00	32020		\N	129208	0	43878008	28060		0
22349	1334	40481087	1980-06-20	1980-06-20 00:00:00	1980-07-04	1980-07-04 00:00:00	32020		\N	88506	0	444814009	40481087		0
22553	1348	40481087	1959-10-20	1959-10-20 00:00:00	1959-10-27	1959-10-27 00:00:00	32020		\N	89363	0	444814009	40481087		0
22693	1355	4112343	1963-11-11	1963-11-11 00:00:00	1963-11-19	1963-11-19 00:00:00	32020		\N	89850	0	195662009	4112343		0
22873	1365	40481087	1970-04-05	1970-04-05 00:00:00	1970-04-12	1970-04-12 00:00:00	32020		\N	90416	0	444814009	40481087		0
22981	1371	40481087	1974-06-03	1974-06-03 00:00:00	1974-06-24	1974-06-24 00:00:00	32020		\N	90936	0	444814009	40481087		0
23149	1382	4142905	1994-08-26	1994-08-26 00:00:00	1994-10-25	1994-10-25 00:00:00	32020		\N	91652	0	33737001	4142905		0
23345	1391	40480160	1997-12-20	1997-12-20 00:00:00	1998-03-20	1998-03-20 00:00:00	32020		\N	92409	0	443165006	40480160		0
23559	1408	40481087	1955-07-06	1955-07-06 00:00:00	1955-07-20	1955-07-20 00:00:00	32020		\N	93640	0	444814009	40481087		0
23685	1412	257012	1980-08-06	1980-08-06 00:00:00	\N	\N	32020		\N	94093	0	40055000	257012		0
34393	2041	372328	1965-02-27	1965-02-27 00:00:00	1965-05-04	1965-05-04 00:00:00	32020		\N	135844	0	65363002	372328		0
23984	1431	4296204	1994-09-26	1994-09-26 00:00:00	1994-10-17	1994-10-17 00:00:00	32020		\N	95251	0	403190006	4296204		0
34732	2062	4112343	1948-07-09	1948-07-09 00:00:00	1948-07-21	1948-07-21 00:00:00	32020		\N	137163	0	195662009	4112343		0
34892	2073	260139	1982-04-07	1982-04-07 00:00:00	1982-04-14	1982-04-14 00:00:00	32020		\N	137934	0	10509002	260139		0
24485	1460	260139	1989-07-19	1989-07-19 00:00:00	1989-08-02	1989-08-02 00:00:00	32020		\N	97271	0	10509002	260139		0
24630	1468	4155034	1958-09-26	1958-09-26 00:00:00	1958-10-10	1958-10-10 00:00:00	32020		\N	97887	0	283371005	4155034		0
35362	2094	40481087	1991-04-25	1991-04-25 00:00:00	1991-05-16	1991-05-16 00:00:00	32020		\N	139583	0	444814009	40481087		0
25031	1493	4112343	1957-09-21	1957-09-21 00:00:00	1957-10-02	1957-10-02 00:00:00	32020		\N	99549	0	195662009	4112343		0
25163	1500	260139	2015-04-30	2015-04-30 00:00:00	2015-05-07	2015-05-07 00:00:00	32020		\N	100072	0	10509002	260139		0
25312	1510	80180	2002-01-10	2002-01-10 00:00:00	\N	\N	32020		\N	100824	0	396275006	80180		0
25560	1520	4134304	2002-10-29	2002-10-29 00:00:00	2003-01-27	2003-01-27 00:00:00	32020		\N	101710	0	263102004	4134304		0
25717	1528	40481087	1995-01-18	1995-01-18 00:00:00	1995-01-25	1995-01-25 00:00:00	32020		\N	102267	0	444814009	40481087		0
25895	1537	40481087	2018-04-13	2018-04-13 00:00:00	2018-04-27	2018-04-27 00:00:00	32020		\N	102875	0	444814009	40481087		0
26028	1543	260139	1971-07-21	1971-07-21 00:00:00	1971-07-28	1971-07-28 00:00:00	32020		\N	103376	0	10509002	260139		0
26214	1556	40481087	1996-12-09	1996-12-09 00:00:00	1996-12-23	1996-12-23 00:00:00	32020		\N	104189	0	444814009	40481087		0
26375	1565	4001336	1971-03-11	1971-03-11 00:00:00	1971-04-10	1971-04-10 00:00:00	32020		\N	104981	0	110030002	4001336		0
26456	1569	4283893	1939-05-15	1939-05-15 00:00:00	1939-06-26	1939-06-26 00:00:00	32020		\N	105239	0	36971009	4283893		0
26665	1578	40481087	1970-12-15	1970-12-15 00:00:00	1971-01-05	1971-01-05 00:00:00	32020		\N	105989	0	444814009	40481087		0
26859	1590	40481087	1988-07-27	1988-07-27 00:00:00	1988-08-17	1988-08-17 00:00:00	32020		\N	106715	0	444814009	40481087		0
26997	1598	80180	2003-09-26	2003-09-26 00:00:00	\N	\N	32020		\N	107227	0	396275006	80180		0
27144	1605	372328	1937-11-03	1937-11-03 00:00:00	1937-12-05	1937-12-05 00:00:00	32020		\N	107681	0	65363002	372328		0
27364	1612	40481087	2001-10-18	2001-10-18 00:00:00	2001-10-25	2001-10-25 00:00:00	32020		\N	108388	0	444814009	40481087		0
38036	2258	4112343	1960-11-26	1960-11-26 00:00:00	1960-12-06	1960-12-06 00:00:00	32020		\N	150041	0	195662009	4112343		0
27702	1634	260139	1992-01-13	1992-01-13 00:00:00	1992-01-20	1992-01-20 00:00:00	32020		\N	109741	0	10509002	260139		0
38391	2280	28060	1976-04-16	1976-04-16 00:00:00	1976-04-28	1976-04-28 00:00:00	32020		\N	151560	0	43878008	28060		0
38562	2290	40481087	1960-09-11	1960-09-11 00:00:00	1960-09-25	1960-09-25 00:00:00	32020		\N	152355	0	444814009	40481087		0
28165	1661	4112343	2010-06-03	2010-06-03 00:00:00	2010-06-11	2010-06-11 00:00:00	32020		\N	111693	0	195662009	4112343		0
28366	1676	4237458	1999-06-02	1999-06-02 00:00:00	1999-07-02	1999-07-02 00:00:00	32020		\N	112469	0	58150001	4237458		0
39020	2319	4112343	1964-11-25	1964-11-25 00:00:00	1964-12-08	1964-12-08 00:00:00	32020		\N	154227	0	195662009	4112343		0
28611	1692	192671	2017-01-28	2017-01-28 00:00:00	\N	\N	32020		\N	113361	0	K92.2	35208414		0
28878	1709	4283893	1947-04-03	1947-04-03 00:00:00	1947-04-24	1947-04-24 00:00:00	32020		\N	114319	0	36971009	4283893		0
28976	1716	40481087	1980-01-29	1980-01-29 00:00:00	1980-02-19	1980-02-19 00:00:00	32020		\N	114760	0	444814009	40481087		0
29177	1727	4112343	1961-10-23	1961-10-23 00:00:00	1961-11-01	1961-11-01 00:00:00	32020		\N	115520	0	195662009	4112343		0
29342	1738	260139	2006-03-19	2006-03-19 00:00:00	2006-04-02	2006-04-02 00:00:00	32020		\N	116107	0	10509002	260139		0
29478	1746	40481087	1962-04-13	1962-04-13 00:00:00	1962-04-27	1962-04-27 00:00:00	32020		\N	116779	0	444814009	40481087		0
29644	1753	133834	1964-07-13	1964-07-13 00:00:00	1981-09-12	1981-09-12 00:00:00	32020		\N	117191	0	24079001	133834		0
29786	1762	372328	1946-08-01	1946-08-01 00:00:00	1946-10-17	1946-10-17 00:00:00	32020		\N	117809	0	65363002	372328		0
30024	1776	4112343	2019-05-17	2019-05-17 00:00:00	2019-05-24	2019-05-24 00:00:00	32020		\N	118795	0	195662009	4112343		0
30210	1785	80180	1990-12-14	1990-12-14 00:00:00	\N	\N	32020		\N	119612	0	396275006	80180		0
30344	1791	40481087	1971-10-02	1971-10-02 00:00:00	1971-10-23	1971-10-23 00:00:00	32020		\N	120100	0	444814009	40481087		0
41080	2442	40481087	2007-05-15	2007-05-15 00:00:00	2007-05-22	2007-05-22 00:00:00	32020		\N	161992	0	444814009	40481087		0
30687	1813	260139	1987-07-20	1987-07-20 00:00:00	1987-08-03	1987-08-03 00:00:00	32020		\N	121340	0	10509002	260139		0
30871	1826	378001	2000-03-26	2000-03-26 00:00:00	2000-05-25	2000-05-25 00:00:00	32020		\N	122063	0	62106007	378001		0
31010	1837	372328	1961-08-06	1961-08-06 00:00:00	1961-10-20	1961-10-20 00:00:00	32020		\N	122689	0	65363002	372328		0
31172	1845	4112343	1969-10-24	1969-10-24 00:00:00	1969-11-05	1969-11-05 00:00:00	32020		\N	123259	0	195662009	4112343		0
31321	1851	4296204	1997-09-24	1997-09-24 00:00:00	1997-10-08	1997-10-08 00:00:00	32020		\N	123826	0	403190006	4296204		0
31525	1864	261325	2009-12-18	2009-12-18 00:00:00	\N	\N	32020		\N	124529	0	87433001	261325		0
31648	1874	4283893	1978-12-20	1978-12-20 00:00:00	1979-01-17	1979-01-17 00:00:00	32020		\N	125132	0	36971009	4283893		0
42364	2524	40481087	1963-06-11	1963-06-11 00:00:00	1963-06-25	1963-06-25 00:00:00	32020		\N	166911	0	444814009	40481087		0
21379	1282	80180	2015-07-13	2015-07-13 00:00:00	\N	\N	32020		\N	84724	0	396275006	80180		0
32074	1905	40481087	1977-06-29	1977-06-29 00:00:00	1977-07-13	1977-07-13 00:00:00	32020		\N	126813	0	444814009	40481087		0
32223	1915	260139	1987-06-06	1987-06-06 00:00:00	1987-06-13	1987-06-13 00:00:00	32020		\N	127378	0	10509002	260139		0
32389	1924	4283893	1981-12-05	1981-12-05 00:00:00	1982-02-20	1982-02-20 00:00:00	32020		\N	128071	0	36971009	4283893		0
21987	1317	40481087	1962-03-09	1962-03-09 00:00:00	1962-03-23	1962-03-23 00:00:00	32020		\N	87292	0	444814009	40481087		0
32734	1945	4294548	1995-02-19	1995-02-19 00:00:00	1995-03-12	1995-03-12 00:00:00	32020		\N	129203	0	75498004	4294548		0
22350	1334	372328	1971-10-11	1971-10-11 00:00:00	1972-01-30	1972-01-30 00:00:00	32020		\N	88508	0	65363002	372328		0
22554	1348	378001	1923-11-24	1923-11-24 00:00:00	1924-01-23	1924-01-23 00:00:00	32020		\N	89302	0	62106007	378001		0
22694	1355	372328	1967-07-22	1967-07-22 00:00:00	1968-03-01	1968-03-01 00:00:00	32020		\N	89801	0	65363002	372328		0
22874	1365	40481087	1975-11-04	1975-11-04 00:00:00	1975-11-18	1975-11-18 00:00:00	32020		\N	90515	0	444814009	40481087		0
22982	1371	4134304	1998-04-26	1998-04-26 00:00:00	1998-06-25	1998-06-25 00:00:00	32020		\N	90896	0	263102004	4134304		0
23150	1382	28060	1992-12-05	1992-12-05 00:00:00	1992-12-15	1992-12-15 00:00:00	32020		\N	91644	0	43878008	28060		0
23346	1391	40481087	1930-09-27	1930-09-27 00:00:00	1930-10-04	1930-10-04 00:00:00	32020		\N	92328	0	444814009	40481087		0
23560	1408	257012	1982-10-24	1982-10-24 00:00:00	\N	\N	32020		\N	93650	0	40055000	257012		0
23686	1412	40481087	1967-07-27	1967-07-27 00:00:00	1967-08-17	1967-08-17 00:00:00	32020		\N	94090	0	444814009	40481087		0
34394	2041	78272	1974-09-21	1974-09-21 00:00:00	1974-10-19	1974-10-19 00:00:00	32020		\N	135854	0	70704007	78272		0
23985	1431	40481087	2012-08-28	2012-08-28 00:00:00	2012-09-04	2012-09-04 00:00:00	32020		\N	95255	0	444814009	40481087		0
34733	2062	4109685	1985-04-04	1985-04-04 00:00:00	1985-04-18	1985-04-18 00:00:00	32020		\N	137197	0	284551006	4109685		0
34893	2073	81151	1978-04-27	1978-04-27 00:00:00	1978-05-18	1978-05-18 00:00:00	32020		\N	137883	0	44465007	81151		0
24486	1460	4156265	2017-10-21	2017-10-21 00:00:00	2017-11-11	2017-11-11 00:00:00	32020		\N	97306	0	370247008	4156265		0
24631	1468	40481087	1977-01-29	1977-01-29 00:00:00	1977-02-12	1977-02-12 00:00:00	32020		\N	97792	0	444814009	40481087		0
35363	2094	40481087	2018-11-30	2018-11-30 00:00:00	2018-12-07	2018-12-07 00:00:00	32020		\N	139638	0	444814009	40481087		0
25032	1493	40481087	1993-01-29	1993-01-29 00:00:00	1993-02-12	1993-02-12 00:00:00	32020		\N	99548	0	444814009	40481087		0
25164	1500	260139	1973-11-12	1973-11-12 00:00:00	1973-11-26	1973-11-26 00:00:00	32020		\N	100109	0	10509002	260139		0
25313	1510	4285898	2001-11-11	2001-11-11 00:00:00	\N	\N	32020		\N	100824	0	68496003	4285898		0
25561	1520	40481087	1966-12-29	1966-12-29 00:00:00	1967-01-05	1967-01-05 00:00:00	32020		\N	101724	0	444814009	40481087		0
25718	1528	4218389	2012-03-13	2012-03-13 00:00:00	2012-04-10	2012-04-10 00:00:00	32020		\N	102243	0	39848009	4218389		0
25896	1537	372328	1960-08-12	1960-08-12 00:00:00	1961-04-26	1961-04-26 00:00:00	32020		\N	102897	0	65363002	372328		0
26029	1543	440086	1950-10-18	1950-10-18 00:00:00	1951-11-21	1951-11-21 00:00:00	32020		\N	103367	0	192127007	440086		0
26215	1556	4084167	1973-09-25	1973-09-25 00:00:00	1973-09-25	1973-09-25 00:00:00	32020		\N	104147	0	241929008	4084167		0
26376	1565	4132546	1971-03-11	1971-03-11 00:00:00	\N	\N	32020		\N	104981	0	275272006	4166590		0
26457	1569	40481087	1991-07-22	1991-07-22 00:00:00	1991-07-29	1991-07-29 00:00:00	32020		\N	105304	0	444814009	40481087		0
26666	1578	40481087	1949-08-01	1949-08-01 00:00:00	1949-08-15	1949-08-15 00:00:00	32020		\N	105974	0	444814009	40481087		0
26860	1590	260139	2006-10-23	2006-10-23 00:00:00	2006-11-05	2006-11-05 00:00:00	32020		\N	106711	0	10509002	260139		0
26998	1598	28060	1965-08-13	1965-08-13 00:00:00	1965-08-25	1965-08-25 00:00:00	32020		\N	107220	0	43878008	28060		0
27145	1605	40481087	1992-11-18	1992-11-18 00:00:00	1992-12-09	1992-12-09 00:00:00	32020		\N	107672	0	444814009	40481087		0
27365	1612	4112343	2014-08-24	2014-08-24 00:00:00	2014-09-04	2014-09-04 00:00:00	32020		\N	108376	0	195662009	4112343		0
38037	2258	80180	1995-01-30	1995-01-30 00:00:00	\N	\N	32020		\N	150085	0	396275006	80180		0
27703	1634	80180	1978-12-18	1978-12-18 00:00:00	\N	\N	32020		\N	109753	0	396275006	80180		0
38392	2280	260139	1982-07-28	1982-07-28 00:00:00	1982-08-11	1982-08-11 00:00:00	32020		\N	151562	0	10509002	260139		0
38563	2290	78272	1998-09-03	1998-09-03 00:00:00	1998-09-17	1998-09-17 00:00:00	32020		\N	152338	0	70704007	78272		0
28166	1661	40481087	2004-04-27	2004-04-27 00:00:00	2004-05-11	2004-05-11 00:00:00	32020		\N	111687	0	444814009	40481087		0
28367	1676	4112343	1998-01-10	1998-01-10 00:00:00	1998-01-22	1998-01-22 00:00:00	32020		\N	112460	0	195662009	4112343		0
39021	2319	40481087	1958-09-17	1958-09-17 00:00:00	1958-09-24	1958-09-24 00:00:00	32020		\N	154194	0	444814009	40481087		0
28612	1692	40481087	2016-04-24	2016-04-24 00:00:00	2016-05-08	2016-05-08 00:00:00	32020		\N	113362	0	444814009	40481087		0
28879	1709	260139	1970-04-25	1970-04-25 00:00:00	1970-05-02	1970-05-02 00:00:00	32020		\N	114256	0	10509002	260139		0
28977	1716	4112343	1977-08-05	1977-08-05 00:00:00	1977-08-12	1977-08-12 00:00:00	32020		\N	114645	0	195662009	4112343		0
29178	1727	4155034	1952-03-14	1952-03-14 00:00:00	1952-04-04	1952-04-04 00:00:00	32020		\N	115413	0	283371005	4155034		0
29343	1738	260139	1971-11-02	1971-11-02 00:00:00	1971-11-16	1971-11-16 00:00:00	32020		\N	116103	0	10509002	260139		0
29479	1746	28060	2014-03-27	2014-03-27 00:00:00	2014-04-09	2014-04-09 00:00:00	32020		\N	116801	0	43878008	28060		0
29645	1753	28060	1965-04-03	1965-04-03 00:00:00	1965-04-16	1965-04-16 00:00:00	32020		\N	117192	0	43878008	28060		0
29787	1762	40481087	2008-08-11	2008-08-11 00:00:00	2008-08-25	2008-08-25 00:00:00	32020		\N	117852	0	444814009	40481087		0
30025	1776	4152936	1945-04-23	1945-04-23 00:00:00	1945-05-14	1945-05-14 00:00:00	32020		\N	118803	0	283385000	4152936		0
30211	1785	4155034	2001-10-28	2001-10-28 00:00:00	2001-11-18	2001-11-18 00:00:00	32020		\N	119609	0	283371005	4155034		0
30345	1791	260139	2005-07-07	2005-07-07 00:00:00	2005-07-14	2005-07-14 00:00:00	32020		\N	120068	0	10509002	260139		0
41081	2442	40481087	1991-02-21	1991-02-21 00:00:00	1991-03-14	1991-03-14 00:00:00	32020		\N	161932	0	444814009	40481087		0
30688	1813	28060	2002-06-04	2002-06-04 00:00:00	2002-06-16	2002-06-16 00:00:00	32020		\N	121350	0	43878008	28060		0
30872	1826	28060	1985-06-18	1985-06-18 00:00:00	1985-06-30	1985-06-30 00:00:00	32020		\N	122054	0	43878008	28060		0
31011	1837	4112343	1962-09-04	1962-09-04 00:00:00	1962-09-11	1962-09-11 00:00:00	32020		\N	122734	0	195662009	4112343		0
31173	1845	40481087	2007-04-06	2007-04-06 00:00:00	2007-04-13	2007-04-13 00:00:00	32020		\N	123254	0	444814009	40481087		0
31322	1851	258780	2009-07-16	2009-07-16 00:00:00	\N	\N	32020		\N	123835	0	185086009	258780		0
31526	1864	40481087	1989-03-14	1989-03-14 00:00:00	1989-04-04	1989-04-04 00:00:00	32020		\N	124537	0	444814009	40481087		0
31649	1874	4109685	1987-04-15	1987-04-15 00:00:00	1987-05-06	1987-05-06 00:00:00	32020		\N	125104	0	284551006	4109685		0
42365	2524	40481087	1975-12-20	1975-12-20 00:00:00	1976-01-10	1976-01-10 00:00:00	32020		\N	166902	0	444814009	40481087		0
21380	1282	4156265	1977-03-29	1977-03-29 00:00:00	1977-04-12	1977-04-12 00:00:00	32020		\N	84707	0	370247008	4156265		0
32075	1905	372328	1972-01-30	1972-01-30 00:00:00	1973-02-09	1973-02-09 00:00:00	32020		\N	126791	0	65363002	372328		0
32224	1915	4109685	2001-12-13	2001-12-13 00:00:00	2001-12-27	2001-12-27 00:00:00	32020		\N	127405	0	284551006	4109685		0
32390	1924	40481087	1984-02-17	1984-02-17 00:00:00	1984-03-09	1984-03-09 00:00:00	32020		\N	128054	0	444814009	40481087		0
21988	1317	4059173	1982-09-14	1982-09-14 00:00:00	1982-10-14	1982-10-14 00:00:00	32020		\N	87277	0	16114001	4059173		0
32735	1945	4112343	2007-06-09	2007-06-09 00:00:00	2007-06-21	2007-06-21 00:00:00	32020		\N	129207	0	195662009	4112343		0
22351	1334	40481087	1990-04-18	1990-04-18 00:00:00	1990-05-09	1990-05-09 00:00:00	32020		\N	88507	0	444814009	40481087		0
22555	1348	28060	1979-07-22	1979-07-22 00:00:00	1979-08-01	1979-08-01 00:00:00	32020		\N	89339	0	43878008	28060		0
22695	1355	372328	1975-11-20	1975-11-20 00:00:00	1976-01-23	1976-01-23 00:00:00	32020		\N	89802	0	65363002	372328		0
22875	1365	4142905	1974-02-25	1974-02-25 00:00:00	1974-05-26	1974-05-26 00:00:00	32020		\N	90455	0	33737001	4142905		0
22983	1371	4112343	2015-03-02	2015-03-02 00:00:00	2015-03-15	2015-03-15 00:00:00	32020		\N	90883	0	195662009	4112343		0
23151	1382	4112343	2007-08-17	2007-08-17 00:00:00	2007-08-29	2007-08-29 00:00:00	32020		\N	91665	0	195662009	4112343		0
23347	1391	372328	1968-05-30	1968-05-30 00:00:00	1970-01-20	1970-01-20 00:00:00	32020		\N	92403	0	65363002	372328		0
23561	1408	260139	2007-07-07	2007-07-07 00:00:00	2007-07-21	2007-07-21 00:00:00	32020		\N	93593	0	10509002	260139		0
23687	1412	40481087	1966-03-07	1966-03-07 00:00:00	1966-03-28	1966-03-28 00:00:00	32020		\N	94079	0	444814009	40481087		0
34395	2041	40481087	2009-07-19	2009-07-19 00:00:00	2009-08-02	2009-08-02 00:00:00	32020		\N	135861	0	444814009	40481087		0
23986	1431	372328	1952-05-18	1952-05-18 00:00:00	1952-09-06	1952-09-06 00:00:00	32020		\N	95256	0	65363002	372328		0
34734	2062	313217	2014-11-29	2014-11-29 00:00:00	\N	\N	32020		\N	137121	0	49436004	313217		0
34894	2073	40481087	2006-01-10	2006-01-10 00:00:00	2006-01-31	2006-01-31 00:00:00	32020		\N	137901	0	444814009	40481087		0
24487	1460	40481087	1997-01-13	1997-01-13 00:00:00	1997-02-03	1997-02-03 00:00:00	32020		\N	97316	0	444814009	40481087		0
24691	1475	4112343	1941-04-02	1941-04-02 00:00:00	1941-04-11	1941-04-11 00:00:00	32020		\N	98268	0	195662009	4112343		0
35364	2094	40481087	1958-05-12	1958-05-12 00:00:00	1958-05-26	1958-05-26 00:00:00	32020		\N	139602	0	444814009	40481087		0
25033	1493	257012	1998-03-06	1998-03-06 00:00:00	\N	\N	32020		\N	99565	0	40055000	257012		0
25165	1500	40481087	1994-08-16	1994-08-16 00:00:00	1994-08-23	1994-08-23 00:00:00	32020		\N	100091	0	444814009	40481087		0
25314	1510	40481087	1970-10-28	1970-10-28 00:00:00	1970-11-11	1970-11-11 00:00:00	32020		\N	100844	0	444814009	40481087		0
25562	1520	260139	1969-08-08	1969-08-08 00:00:00	1969-08-15	1969-08-15 00:00:00	32020		\N	101633	0	10509002	260139		0
25719	1528	40481087	1994-04-10	1994-04-10 00:00:00	1994-04-17	1994-04-17 00:00:00	32020		\N	102247	0	444814009	40481087		0
36355	2152	381316	1988-01-23	1988-01-23 00:00:00	\N	\N	32020		\N	143347	0	230690007	381316		0
26030	1543	40481087	1950-02-28	1950-02-28 00:00:00	1950-03-14	1950-03-14 00:00:00	32020		\N	103414	0	444814009	40481087		0
26216	1556	40481087	1979-07-03	1979-07-03 00:00:00	1979-07-17	1979-07-17 00:00:00	32020		\N	104254	0	444814009	40481087		0
26377	1565	4283893	1995-05-27	1995-05-27 00:00:00	1995-09-16	1995-09-16 00:00:00	32020		\N	104971	0	36971009	4283893		0
26458	1569	4112343	1965-01-23	1965-01-23 00:00:00	1965-02-05	1965-02-05 00:00:00	32020		\N	105292	0	195662009	4112343		0
26667	1578	40481087	1955-04-21	1955-04-21 00:00:00	1955-05-05	1955-05-05 00:00:00	32020		\N	105976	0	444814009	40481087		0
26861	1590	40481087	1978-06-29	1978-06-29 00:00:00	1978-07-13	1978-07-13 00:00:00	32020		\N	106670	0	444814009	40481087		0
26999	1598	80502	2018-08-06	2018-08-06 00:00:00	\N	\N	32020		\N	107269	0	64859006	80502		0
27146	1605	40481087	1987-02-09	1987-02-09 00:00:00	1987-03-02	1987-03-02 00:00:00	32020		\N	107667	0	444814009	40481087		0
27366	1612	40481087	1969-12-29	1969-12-29 00:00:00	1970-01-19	1970-01-19 00:00:00	32020		\N	108413	0	444814009	40481087		0
38038	2258	40481087	1993-06-12	1993-06-12 00:00:00	1993-06-19	1993-06-19 00:00:00	32020		\N	150085	0	444814009	40481087		0
27704	1635	40481087	1996-05-16	1996-05-16 00:00:00	1996-05-23	1996-05-23 00:00:00	32020		\N	109853	0	444814009	40481087		0
38393	2280	80180	2002-06-16	2002-06-16 00:00:00	\N	\N	32020		\N	151559	0	396275006	80180		0
38564	2290	4112343	2005-06-01	2005-06-01 00:00:00	2005-06-09	2005-06-09 00:00:00	32020		\N	152318	0	195662009	4112343		0
28167	1661	4310024	1992-09-18	1992-09-18 00:00:00	\N	\N	32020		\N	111685	0	424802006	4310024		0
28368	1677	40481087	2011-11-20	2011-11-20 00:00:00	2011-12-04	2011-12-04 00:00:00	32020		\N	112529	0	444814009	40481087		0
39022	2319	4113008	1949-03-06	1949-03-06 00:00:00	1949-03-20	1949-03-20 00:00:00	32020		\N	154132	0	284549007	4113008		0
28613	1692	30753	2015-11-30	2015-11-30 00:00:00	\N	\N	32020		\N	113344	0	16761005	30753		0
28880	1709	4296204	1943-11-12	1943-11-12 00:00:00	1943-12-10	1943-12-10 00:00:00	32020		\N	114218	0	403190006	4296204		0
28978	1716	4294548	1953-10-08	1953-10-08 00:00:00	1953-11-12	1953-11-12 00:00:00	32020		\N	114601	0	75498004	4294548		0
29179	1727	4112343	1955-02-12	1955-02-12 00:00:00	1955-02-22	1955-02-22 00:00:00	32020		\N	115513	0	195662009	4112343		0
29344	1738	4112343	1985-06-08	1985-06-08 00:00:00	1985-06-15	1985-06-15 00:00:00	32020		\N	116148	0	195662009	4112343		0
29480	1746	4278672	2000-03-25	2000-03-25 00:00:00	2000-06-23	2000-06-23 00:00:00	32020		\N	116764	0	65966004	4278672		0
29646	1753	4027663	1993-04-30	1993-04-30 00:00:00	\N	\N	32020		\N	117302	0	13200003	4027663		0
29788	1762	4116491	2002-10-30	2002-10-30 00:00:00	2002-12-16	2002-12-16 00:00:00	32020		\N	117866	0	301011002	4116491		0
30026	1776	28060	1921-08-06	1921-08-06 00:00:00	1921-08-13	1921-08-13 00:00:00	32020		\N	118770	0	43878008	28060		0
30212	1785	4294548	1994-08-23	1994-08-23 00:00:00	1994-12-13	1994-12-13 00:00:00	32020		\N	119594	0	75498004	4294548		0
30346	1791	40481087	1955-03-03	1955-03-03 00:00:00	1955-03-24	1955-03-24 00:00:00	32020		\N	120061	0	444814009	40481087		0
41082	2442	30753	2007-01-28	2007-01-28 00:00:00	\N	\N	32020		\N	162014	0	16761005	30753		0
30689	1813	260139	1990-02-02	1990-02-02 00:00:00	1990-02-09	1990-02-09 00:00:00	32020		\N	121308	0	10509002	260139		0
30873	1826	260139	2017-02-27	2017-02-27 00:00:00	2017-03-13	2017-03-13 00:00:00	32020		\N	122059	0	10509002	260139		0
31012	1837	439777	1970-05-11	1970-05-11 00:00:00	\N	\N	32020		\N	122738	0	271737000	439777		0
31174	1846	372328	1952-07-20	1952-07-20 00:00:00	1952-12-04	1952-12-04 00:00:00	32020		\N	123428	0	65363002	372328		0
31323	1851	260139	2014-10-12	2014-10-12 00:00:00	2014-10-19	2014-10-19 00:00:00	32020		\N	123817	0	10509002	260139		0
31527	1864	78272	1996-08-22	1996-08-22 00:00:00	1996-09-05	1996-09-05 00:00:00	32020		\N	124521	0	70704007	78272		0
31650	1874	4109685	1978-05-18	1978-05-18 00:00:00	1978-06-01	1978-06-01 00:00:00	32020		\N	125103	0	284551006	4109685		0
42366	2524	4112343	1968-03-11	1968-03-11 00:00:00	1968-03-21	1968-03-21 00:00:00	32020		\N	166913	0	195662009	4112343		0
21381	1282	4134304	1980-06-25	1980-06-25 00:00:00	1980-09-23	1980-09-23 00:00:00	32020		\N	84708	0	263102004	4134304		0
32076	1905	80180	2008-08-31	2008-08-31 00:00:00	\N	\N	32020		\N	126837	0	396275006	80180		0
32225	1915	40481087	1991-12-22	1991-12-22 00:00:00	1992-01-12	1992-01-12 00:00:00	32020		\N	127353	0	444814009	40481087		0
32391	1924	40481087	2000-06-10	2000-06-10 00:00:00	2000-07-01	2000-07-01 00:00:00	32020		\N	128075	0	444814009	40481087		0
21989	1317	40481087	1969-12-16	1969-12-16 00:00:00	1969-12-30	1969-12-30 00:00:00	32020		\N	87293	0	444814009	40481087		0
32736	1945	80180	2007-06-08	2007-06-08 00:00:00	\N	\N	32020		\N	129207	0	396275006	80180		0
22352	1334	372328	1982-06-02	1982-06-02 00:00:00	1983-03-27	1983-03-27 00:00:00	32020		\N	88526	0	65363002	372328		0
22556	1348	4112343	2000-06-09	2000-06-09 00:00:00	2000-06-19	2000-06-19 00:00:00	32020		\N	89282	0	195662009	4112343		0
22696	1355	40481087	2012-03-22	2012-03-22 00:00:00	2012-04-12	2012-04-12 00:00:00	32020		\N	89800	0	444814009	40481087		0
22876	1365	28060	2007-11-22	2007-11-22 00:00:00	2007-11-30	2007-11-30 00:00:00	32020		\N	90507	0	43878008	28060		0
22984	1371	4109685	1999-06-20	1999-06-20 00:00:00	1999-07-04	1999-07-04 00:00:00	32020		\N	90939	0	284551006	4109685		0
23152	1382	4112343	1997-01-25	1997-01-25 00:00:00	1997-02-06	1997-02-06 00:00:00	32020		\N	91633	0	195662009	4112343		0
23348	1391	4134304	1980-11-19	1980-11-19 00:00:00	1981-01-18	1981-01-18 00:00:00	32020		\N	92309	0	263102004	4134304		0
23562	1408	40481087	1964-05-09	1964-05-09 00:00:00	1964-05-16	1964-05-16 00:00:00	32020		\N	93630	0	444814009	40481087		0
23688	1412	195588	2007-05-02	2007-05-02 00:00:00	2007-06-16	2007-06-16 00:00:00	32020		\N	93998	0	38822007	195588		0
34396	2041	4112343	1968-04-18	1968-04-18 00:00:00	1968-04-30	1968-04-30 00:00:00	32020		\N	135865	0	195662009	4112343		0
23987	1431	40481087	1969-03-26	1969-03-26 00:00:00	1969-04-16	1969-04-16 00:00:00	32020		\N	95220	0	444814009	40481087		0
34735	2062	40481087	1954-10-24	1954-10-24 00:00:00	1954-11-07	1954-11-07 00:00:00	32020		\N	137165	0	444814009	40481087		0
34895	2073	4218389	1986-09-03	1986-09-03 00:00:00	1986-09-24	1986-09-24 00:00:00	32020		\N	137886	0	39848009	4218389		0
24488	1460	4296204	1999-10-07	1999-10-07 00:00:00	1999-10-21	1999-10-21 00:00:00	32020		\N	97304	0	403190006	4296204		0
24692	1475	40481087	2001-10-03	2001-10-03 00:00:00	2001-10-24	2001-10-24 00:00:00	32020		\N	98277	0	444814009	40481087		0
35365	2094	40481087	1946-06-25	1946-06-25 00:00:00	1946-07-09	1946-07-09 00:00:00	32020		\N	139593	0	444814009	40481087		0
25034	1493	260139	2006-08-09	2006-08-09 00:00:00	2006-08-16	2006-08-16 00:00:00	32020		\N	99570	0	10509002	260139		0
25166	1500	4152936	1965-07-26	1965-07-26 00:00:00	1965-08-09	1965-08-09 00:00:00	32020		\N	100078	0	283385000	4152936		0
25315	1510	40481087	2010-11-28	2010-11-28 00:00:00	2010-12-05	2010-12-05 00:00:00	32020		\N	100775	0	444814009	40481087		0
25563	1520	260139	1952-01-08	1952-01-08 00:00:00	1952-01-22	1952-01-22 00:00:00	32020		\N	101649	0	10509002	260139		0
25720	1528	257012	1991-06-20	1991-06-20 00:00:00	\N	\N	32020		\N	102246	0	40055000	257012		0
36356	2152	40481087	1933-12-01	1933-12-01 00:00:00	1933-12-22	1933-12-22 00:00:00	32020		\N	143379	0	444814009	40481087		0
26031	1543	40481087	1958-09-03	1958-09-03 00:00:00	1958-09-17	1958-09-17 00:00:00	32020		\N	103375	0	444814009	40481087		0
26217	1556	4094814	2004-04-20	2004-04-20 00:00:00	2004-07-19	2004-07-19 00:00:00	32020		\N	104150	0	262574004	4094814		0
26378	1565	260139	1998-11-25	1998-11-25 00:00:00	1998-12-09	1998-12-09 00:00:00	32020		\N	104940	0	10509002	260139		0
26459	1569	80502	2007-03-02	2007-03-02 00:00:00	\N	\N	32020		\N	105336	0	64859006	80502		0
26668	1578	40481087	2006-07-12	2006-07-12 00:00:00	2006-08-02	2006-08-02 00:00:00	32020		\N	105959	0	444814009	40481087		0
26862	1590	378001	1987-10-14	1987-10-14 00:00:00	1987-12-12	1987-12-12 00:00:00	32020		\N	106720	0	62106007	378001		0
27000	1598	81151	1970-02-16	1970-02-16 00:00:00	1970-03-02	1970-03-02 00:00:00	32020		\N	107217	0	44465007	81151		0
27147	1605	4296205	1999-12-03	1999-12-03 00:00:00	1999-12-31	1999-12-31 00:00:00	32020		\N	107750	0	403191005	4296205		0
27367	1613	4113008	2002-03-04	2002-03-04 00:00:00	2002-03-18	2002-03-18 00:00:00	32020		\N	108497	0	284549007	4113008		0
38039	2258	4134304	1977-11-25	1977-11-25 00:00:00	1978-02-23	1978-02-23 00:00:00	32020		\N	150058	0	263102004	4134304		0
27705	1635	260139	2014-07-30	2014-07-30 00:00:00	2014-08-06	2014-08-06 00:00:00	32020		\N	109822	0	10509002	260139		0
38394	2280	4113008	2000-08-27	2000-08-27 00:00:00	2000-09-10	2000-09-10 00:00:00	32020		\N	151559	0	284549007	4113008		0
38565	2290	40481087	1962-07-24	1962-07-24 00:00:00	1962-08-07	1962-08-07 00:00:00	32020		\N	152356	0	444814009	40481087		0
28168	1661	4112343	1991-11-03	1991-11-03 00:00:00	1991-11-11	1991-11-11 00:00:00	32020		\N	111685	0	195662009	4112343		0
28369	1677	372328	1971-03-17	1971-03-17 00:00:00	1971-06-19	1971-06-19 00:00:00	32020		\N	112515	0	65363002	372328		0
39023	2319	260139	1980-10-11	1980-10-11 00:00:00	1980-10-18	1980-10-18 00:00:00	32020		\N	154164	0	10509002	260139		0
28614	1692	4310024	2015-06-03	2015-06-03 00:00:00	\N	\N	32020		\N	113344	0	424802006	4310024		0
28881	1709	4112343	1978-03-19	1978-03-19 00:00:00	1978-03-27	1978-03-27 00:00:00	32020		\N	114301	0	195662009	4112343		0
28979	1716	260139	1990-01-30	1990-01-30 00:00:00	1990-02-06	1990-02-06 00:00:00	32020		\N	114622	0	10509002	260139		0
29180	1727	4116491	2002-04-18	2002-04-18 00:00:00	2002-06-04	2002-06-04 00:00:00	32020		\N	115417	0	301011002	4116491		0
29345	1738	4112343	1972-05-01	1972-05-01 00:00:00	1972-05-09	1972-05-09 00:00:00	32020		\N	116100	0	195662009	4112343		0
29481	1746	4294548	1961-12-25	1961-12-25 00:00:00	1962-02-05	1962-02-05 00:00:00	32020		\N	116720	0	75498004	4294548		0
29648	1755	4218389	2001-11-25	2001-11-25 00:00:00	2001-12-30	2001-12-30 00:00:00	32020		\N	117378	0	39848009	4218389		0
29789	1762	381316	2002-12-26	2002-12-26 00:00:00	\N	\N	32020		\N	117866	0	230690007	381316		0
30027	1776	313217	2003-10-11	2003-10-11 00:00:00	\N	\N	32020		\N	118838	0	49436004	313217		0
40671	2418	260139	1989-05-14	1989-05-14 00:00:00	1989-05-28	1989-05-28 00:00:00	32020		\N	160421	0	10509002	260139		0
30347	1791	260139	1988-06-07	1988-06-07 00:00:00	1988-06-21	1988-06-21 00:00:00	32020		\N	120023	0	10509002	260139		0
41083	2442	40481087	1979-04-03	1979-04-03 00:00:00	1979-04-17	1979-04-17 00:00:00	32020		\N	161996	0	444814009	40481087		0
30690	1813	28060	2007-09-03	2007-09-03 00:00:00	2007-09-16	2007-09-16 00:00:00	32020		\N	121347	0	43878008	28060		0
30874	1826	4237458	1956-10-29	1956-10-29 00:00:00	1956-12-28	1956-12-28 00:00:00	32020		\N	122040	0	58150001	4237458		0
31013	1837	28060	2016-11-21	2016-11-21 00:00:00	2016-11-28	2016-11-28 00:00:00	32020		\N	122717	0	43878008	28060		0
31175	1846	378001	1956-08-28	1956-08-28 00:00:00	1956-10-27	1956-10-27 00:00:00	32020		\N	123440	0	62106007	378001		0
31324	1851	372328	1980-02-26	1980-02-26 00:00:00	1980-05-15	1980-05-15 00:00:00	32020		\N	123842	0	65363002	372328		0
41999	2501	81151	1997-06-15	1997-06-15 00:00:00	1997-06-29	1997-06-29 00:00:00	32020		\N	165577	0	44465007	81151		0
31651	1874	260139	1987-06-22	1987-06-22 00:00:00	1987-07-06	1987-07-06 00:00:00	32020		\N	125131	0	10509002	260139		0
42367	2524	80180	1987-03-26	1987-03-26 00:00:00	\N	\N	32020		\N	166928	0	396275006	80180		0
21382	1282	40481087	1995-10-31	1995-10-31 00:00:00	1995-11-14	1995-11-14 00:00:00	32020		\N	84749	0	444814009	40481087		0
32077	1905	260139	1973-06-12	1973-06-12 00:00:00	1973-06-26	1973-06-26 00:00:00	32020		\N	126812	0	10509002	260139		0
32226	1915	40481087	1990-04-19	1990-04-19 00:00:00	1990-04-26	1990-04-26 00:00:00	32020		\N	127376	0	444814009	40481087		0
32392	1924	4112343	2015-10-27	2015-10-27 00:00:00	2015-11-03	2015-11-03 00:00:00	32020		\N	128076	0	195662009	4112343		0
21990	1317	40481087	1983-12-03	1983-12-03 00:00:00	1983-12-10	1983-12-10 00:00:00	32020		\N	87295	0	444814009	40481087		0
32737	1945	40481087	1979-12-13	1979-12-13 00:00:00	1980-01-03	1980-01-03 00:00:00	32020		\N	129202	0	444814009	40481087		0
22353	1334	40481087	1997-04-07	1997-04-07 00:00:00	1997-04-28	1997-04-28 00:00:00	32020		\N	88532	0	444814009	40481087		0
22557	1348	4112343	1972-06-01	1972-06-01 00:00:00	1972-06-11	1972-06-11 00:00:00	32020		\N	89294	0	195662009	4112343		0
22697	1355	4112343	1998-09-25	1998-09-25 00:00:00	1998-10-08	1998-10-08 00:00:00	32020		\N	89798	0	195662009	4112343		0
22877	1365	372328	1963-10-21	1963-10-21 00:00:00	1963-11-28	1963-11-28 00:00:00	32020		\N	90484	0	65363002	372328		0
22985	1371	80180	2008-02-23	2008-02-23 00:00:00	\N	\N	32020		\N	90940	0	396275006	80180		0
23153	1382	260139	1987-12-25	1987-12-25 00:00:00	1988-01-08	1988-01-08 00:00:00	32020		\N	91651	0	10509002	260139		0
23349	1391	40481087	1954-09-09	1954-09-09 00:00:00	1954-09-30	1954-09-30 00:00:00	32020		\N	92346	0	444814009	40481087		0
23563	1408	40481087	2015-11-11	2015-11-11 00:00:00	2015-11-25	2015-11-25 00:00:00	32020		\N	93633	0	444814009	40481087		0
23689	1412	4112343	1992-04-13	1992-04-13 00:00:00	1992-04-22	1992-04-22 00:00:00	32020		\N	94063	0	195662009	4112343		0
34397	2041	78272	1993-04-12	1993-04-12 00:00:00	1993-05-03	1993-05-03 00:00:00	32020		\N	135855	0	70704007	78272		0
23988	1431	4113008	2000-05-18	2000-05-18 00:00:00	2000-06-01	2000-06-01 00:00:00	32020		\N	95252	0	284549007	4113008		0
34736	2062	260139	1947-08-13	1947-08-13 00:00:00	1947-08-27	1947-08-27 00:00:00	32020		\N	137122	0	10509002	260139		0
34896	2073	40481087	1969-05-13	1969-05-13 00:00:00	1969-05-20	1969-05-20 00:00:00	32020		\N	137897	0	444814009	40481087		0
24489	1461	40481087	1990-06-15	1990-06-15 00:00:00	1990-07-06	1990-07-06 00:00:00	32020		\N	97325	0	444814009	40481087		0
24693	1475	40481087	1950-12-02	1950-12-02 00:00:00	1950-12-09	1950-12-09 00:00:00	32020		\N	98270	0	444814009	40481087		0
35366	2094	4156265	2002-07-17	2002-07-17 00:00:00	2002-08-07	2002-08-07 00:00:00	32020		\N	139574	0	370247008	4156265		0
25035	1493	80180	1989-11-06	1989-11-06 00:00:00	\N	\N	32020		\N	99507	0	396275006	80180		0
25180	1504	4116491	2003-06-09	2003-06-09 00:00:00	2003-07-15	2003-07-15 00:00:00	32020		\N	100272	0	301011002	4116491		0
25316	1510	4134304	1960-11-21	1960-11-21 00:00:00	1961-01-20	1961-01-20 00:00:00	32020		\N	100819	0	263102004	4134304		0
25564	1520	40481087	1973-12-06	1973-12-06 00:00:00	1973-12-13	1973-12-13 00:00:00	32020		\N	101634	0	444814009	40481087		0
25721	1528	40481087	2018-10-14	2018-10-14 00:00:00	2018-10-28	2018-10-28 00:00:00	32020		\N	102287	0	444814009	40481087		0
36357	2152	4112343	1985-07-27	1985-07-27 00:00:00	1985-08-03	1985-08-03 00:00:00	32020		\N	143426	0	195662009	4112343		0
26032	1543	80180	1981-03-29	1981-03-29 00:00:00	\N	\N	32020		\N	103396	0	396275006	80180		0
26218	1556	4283893	1982-02-09	1982-02-09 00:00:00	1982-03-30	1982-03-30 00:00:00	32020		\N	104193	0	36971009	4283893		0
26379	1565	40481087	2010-08-03	2010-08-03 00:00:00	2010-08-24	2010-08-24 00:00:00	32020		\N	104956	0	444814009	40481087		0
26460	1569	28060	1945-06-22	1945-06-22 00:00:00	1945-07-03	1945-07-03 00:00:00	32020		\N	105294	0	43878008	28060		0
26669	1579	4156265	1959-08-06	1959-08-06 00:00:00	1959-08-27	1959-08-27 00:00:00	32020		\N	106101	0	370247008	4156265		0
26863	1590	4112343	2008-02-20	2008-02-20 00:00:00	2008-03-01	2008-03-01 00:00:00	32020		\N	106719	0	195662009	4112343		0
27001	1598	40481087	2008-09-21	2008-09-21 00:00:00	2008-10-05	2008-10-05 00:00:00	32020		\N	107271	0	444814009	40481087		0
27148	1605	40481087	1991-03-09	1991-03-09 00:00:00	1991-03-23	1991-03-23 00:00:00	32020		\N	107668	0	444814009	40481087		0
27368	1613	372328	1955-03-23	1955-03-23 00:00:00	1955-04-23	1955-04-23 00:00:00	32020		\N	108458	0	65363002	372328		0
38040	2258	4112343	2007-12-31	2007-12-31 00:00:00	2008-01-10	2008-01-10 00:00:00	32020		\N	150100	0	195662009	4112343		0
27706	1635	40481087	2006-06-06	2006-06-06 00:00:00	2006-06-27	2006-06-27 00:00:00	32020		\N	109820	0	444814009	40481087		0
38395	2280	257012	1983-04-17	1983-04-17 00:00:00	\N	\N	32020		\N	151576	0	40055000	257012		0
38566	2290	28060	1999-10-07	1999-10-07 00:00:00	1999-10-17	1999-10-17 00:00:00	32020		\N	152359	0	43878008	28060		0
28169	1661	81151	1981-06-09	1981-06-09 00:00:00	1981-07-14	1981-07-14 00:00:00	32020		\N	111652	0	44465007	81151		0
28370	1677	4027663	1994-07-06	1994-07-06 00:00:00	\N	\N	32020		\N	112527	0	13200003	4027663		0
39024	2319	4112343	1984-02-06	1984-02-06 00:00:00	1984-02-18	1984-02-18 00:00:00	32020		\N	154208	0	195662009	4112343		0
28615	1692	81893	2015-10-31	2015-10-31 00:00:00	\N	\N	32020		\N	113344	0	64766004	81893		0
28882	1709	4218389	2017-10-25	2017-10-25 00:00:00	2017-11-22	2017-11-22 00:00:00	32020		\N	114242	0	39848009	4218389		0
28980	1716	40481087	2015-01-25	2015-01-25 00:00:00	2015-02-15	2015-02-15 00:00:00	32020		\N	114653	0	444814009	40481087		0
29181	1727	40481087	1995-10-29	1995-10-29 00:00:00	1995-11-04	1995-11-04 00:00:00	32020		\N	115440	0	444814009	40481087		0
29346	1738	372328	1971-10-31	1971-10-31 00:00:00	1972-05-07	1972-05-07 00:00:00	32020		\N	116138	0	65363002	372328		0
29482	1746	260139	1970-11-15	1970-11-15 00:00:00	1970-11-29	1970-11-29 00:00:00	32020		\N	116721	0	10509002	260139		0
29649	1755	80180	2002-02-21	2002-02-21 00:00:00	\N	\N	32020		\N	117378	0	396275006	80180		0
29790	1762	4152936	2012-05-16	2012-05-16 00:00:00	2012-05-30	2012-05-30 00:00:00	32020		\N	117865	0	283385000	4152936		0
30028	1776	40481087	1931-07-11	1931-07-11 00:00:00	1931-07-25	1931-07-25 00:00:00	32020		\N	118863	0	444814009	40481087		0
40672	2418	260139	2018-06-02	2018-06-02 00:00:00	2018-06-09	2018-06-09 00:00:00	32020		\N	160446	0	10509002	260139		0
30348	1791	260139	1963-05-14	1963-05-14 00:00:00	1963-05-21	1963-05-21 00:00:00	32020		\N	120084	0	10509002	260139		0
41084	2442	4112343	2014-04-12	2014-04-12 00:00:00	2014-04-19	2014-04-19 00:00:00	32020		\N	161935	0	195662009	4112343		0
30691	1814	40481087	1984-11-22	1984-11-22 00:00:00	1984-11-29	1984-11-29 00:00:00	32020		\N	121417	0	444814009	40481087		0
30875	1826	4112343	1961-08-30	1961-08-30 00:00:00	1961-09-06	1961-09-06 00:00:00	32020		\N	122045	0	195662009	4112343		0
31014	1837	40481087	1984-10-31	1984-10-31 00:00:00	1984-11-14	1984-11-14 00:00:00	32020		\N	122729	0	444814009	40481087		0
31176	1846	260139	1963-05-25	1963-05-25 00:00:00	1963-06-01	1963-06-01 00:00:00	32020		\N	123408	0	10509002	260139		0
31325	1851	381316	2017-12-28	2017-12-28 00:00:00	\N	\N	32020		\N	123857	0	230690007	381316		0
42000	2501	40481087	1989-12-06	1989-12-06 00:00:00	1989-12-13	1989-12-13 00:00:00	32020		\N	165553	0	444814009	40481087		0
31652	1874	40481087	1988-09-01	1988-09-01 00:00:00	1988-09-15	1988-09-15 00:00:00	32020		\N	125119	0	444814009	40481087		0
42368	2524	40481087	1970-04-07	1970-04-07 00:00:00	1970-04-28	1970-04-28 00:00:00	32020		\N	166876	0	444814009	40481087		0
21383	1282	4146173	1979-06-01	1979-06-01 00:00:00	1979-07-01	1979-07-01 00:00:00	32020		\N	84750	0	307731004	4146173		0
32078	1905	28060	2010-04-04	2010-04-04 00:00:00	2010-04-16	2010-04-16 00:00:00	32020		\N	126818	0	43878008	28060		0
32227	1915	80180	2006-08-14	2006-08-14 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
32393	1924	80180	2017-03-04	2017-03-04 00:00:00	\N	\N	32020		\N	128076	0	396275006	80180		0
21991	1317	40481087	1967-10-31	1967-10-31 00:00:00	1967-11-21	1967-11-21 00:00:00	32020		\N	87289	0	444814009	40481087		0
32738	1945	40481087	2008-08-24	2008-08-24 00:00:00	2008-08-31	2008-08-31 00:00:00	32020		\N	129200	0	444814009	40481087		0
22354	1334	40479768	1972-08-04	1972-08-04 00:00:00	1972-10-10	1972-10-10 00:00:00	32020		\N	88529	0	444470001	40479768		0
22558	1348	4112343	1948-06-25	1948-06-25 00:00:00	1948-07-05	1948-07-05 00:00:00	32020		\N	89335	0	195662009	4112343		0
22698	1355	78272	1965-07-29	1965-07-29 00:00:00	1965-09-02	1965-09-02 00:00:00	32020		\N	89792	0	70704007	78272		0
22878	1365	4112343	1988-10-19	1988-10-19 00:00:00	1988-10-31	1988-10-31 00:00:00	32020		\N	90528	0	195662009	4112343		0
22986	1371	260139	2015-09-29	2015-09-29 00:00:00	2015-10-13	2015-10-13 00:00:00	32020		\N	90926	0	10509002	260139		0
23154	1382	372328	1979-07-16	1979-07-16 00:00:00	1979-10-03	1979-10-03 00:00:00	32020		\N	91646	0	65363002	372328		0
23350	1391	81151	1933-05-11	1933-05-11 00:00:00	1933-06-01	1933-06-01 00:00:00	32020		\N	92391	0	44465007	81151		0
23564	1408	4112343	1943-12-31	1943-12-31 00:00:00	1944-01-09	1944-01-09 00:00:00	32020		\N	93636	0	195662009	4112343		0
23690	1412	260139	1979-08-23	1979-08-23 00:00:00	1979-08-30	1979-08-30 00:00:00	32020		\N	94053	0	10509002	260139		0
34398	2041	28060	1964-06-25	1964-06-25 00:00:00	1964-07-07	1964-07-07 00:00:00	32020		\N	135857	0	43878008	28060		0
23989	1431	40481087	1974-06-26	1974-06-26 00:00:00	1974-07-17	1974-07-17 00:00:00	32020		\N	95221	0	444814009	40481087		0
34737	2062	4218389	1962-01-30	1962-01-30 00:00:00	1962-02-20	1962-02-20 00:00:00	32020		\N	137162	0	39848009	4218389		0
34897	2073	40481087	2013-12-12	2013-12-12 00:00:00	2014-01-02	2014-01-02 00:00:00	32020		\N	137889	0	444814009	40481087		0
24490	1461	40481087	1967-05-02	1967-05-02 00:00:00	1967-05-09	1967-05-09 00:00:00	32020		\N	97324	0	444814009	40481087		0
24694	1475	260139	1980-09-11	1980-09-11 00:00:00	1980-09-25	1980-09-25 00:00:00	32020		\N	98272	0	10509002	260139		0
35367	2094	81893	1983-12-25	1983-12-25 00:00:00	\N	\N	32020		\N	139631	0	64766004	81893		0
25056	1496	4112343	1961-12-30	1961-12-30 00:00:00	1962-01-06	1962-01-06 00:00:00	32020		\N	99722	0	195662009	4112343		0
25181	1504	4112343	1992-09-30	1992-09-30 00:00:00	1992-10-10	1992-10-10 00:00:00	32020		\N	100270	0	195662009	4112343		0
25317	1510	4310024	2000-05-20	2000-05-20 00:00:00	\N	\N	32020		\N	100810	0	424802006	4310024		0
36023	2135	4152936	1968-09-03	1968-09-03 00:00:00	1968-09-17	1968-09-17 00:00:00	32020		\N	142102	0	283385000	4152936		0
25722	1528	40481087	1978-07-05	1978-07-05 00:00:00	1978-07-12	1978-07-12 00:00:00	32020		\N	102283	0	444814009	40481087		0
36359	2152	80180	1963-05-17	1963-05-17 00:00:00	\N	\N	32020		\N	143420	0	396275006	80180		0
26033	1543	378001	1943-09-05	1943-09-05 00:00:00	1943-10-05	1943-10-05 00:00:00	32020		\N	103420	0	62106007	378001		0
26219	1556	40481087	1985-02-19	1985-02-19 00:00:00	1985-03-05	1985-03-05 00:00:00	32020		\N	104225	0	444814009	40481087		0
26380	1565	40481087	1983-01-14	1983-01-14 00:00:00	1983-01-28	1983-01-28 00:00:00	32020		\N	104937	0	444814009	40481087		0
26461	1569	4112343	1986-10-15	1986-10-15 00:00:00	1986-10-26	1986-10-26 00:00:00	32020		\N	105237	0	195662009	4112343		0
26670	1579	4155034	1965-06-26	1965-06-26 00:00:00	1965-07-10	1965-07-10 00:00:00	32020		\N	106103	0	283371005	4155034		0
26864	1590	81151	1979-02-13	1979-02-13 00:00:00	1979-02-27	1979-02-27 00:00:00	32020		\N	106674	0	44465007	81151		0
35409	2097	80180	2014-03-21	2014-03-21 00:00:00	\N	\N	32020		\N	139778	0	396275006	80180		0
27002	1598	4112343	2017-07-17	2017-07-17 00:00:00	2017-07-26	2017-07-26 00:00:00	32020		\N	107251	0	195662009	4112343		0
27149	1605	40481087	1963-09-08	1963-09-08 00:00:00	1963-09-22	1963-09-22 00:00:00	32020		\N	107695	0	444814009	40481087		0
27369	1613	260139	1966-03-04	1966-03-04 00:00:00	1966-03-11	1966-03-11 00:00:00	32020		\N	108437	0	10509002	260139		0
38041	2258	40481087	1974-09-20	1974-09-20 00:00:00	1974-10-04	1974-10-04 00:00:00	32020		\N	150090	0	444814009	40481087		0
27707	1635	321042	2013-03-27	2013-03-27 00:00:00	\N	\N	32020		\N	109831	0	410429000	321042		0
38396	2280	260139	1995-08-28	1995-08-28 00:00:00	1995-09-04	1995-09-04 00:00:00	32020		\N	151644	0	10509002	260139		0
38567	2290	4112343	1966-03-26	1966-03-26 00:00:00	1966-04-03	1966-04-03 00:00:00	32020		\N	152362	0	195662009	4112343		0
28170	1661	28060	1977-01-07	1977-01-07 00:00:00	1977-01-18	1977-01-18 00:00:00	32020		\N	111665	0	43878008	28060		0
28371	1677	40481087	1993-02-10	1993-02-10 00:00:00	1993-03-03	1993-03-03 00:00:00	32020		\N	112527	0	444814009	40481087		0
39025	2319	28060	2001-12-25	2001-12-25 00:00:00	2002-01-01	2002-01-01 00:00:00	32020		\N	154228	0	43878008	28060		0
28616	1692	4285898	2016-02-28	2016-02-28 00:00:00	\N	\N	32020		\N	113344	0	68496003	4285898		0
28883	1709	372328	1937-09-14	1937-09-14 00:00:00	1937-11-27	1937-11-27 00:00:00	32020		\N	114285	0	65363002	372328		0
28981	1716	4280726	1948-10-26	1948-10-26 00:00:00	1963-10-25	1963-10-25 00:00:00	32020		\N	114731	0	367498001	4280726		0
29182	1727	4112343	1970-03-21	1970-03-21 00:00:00	1970-04-02	1970-04-02 00:00:00	32020		\N	115465	0	195662009	4112343		0
29347	1738	40481087	2004-02-16	2004-02-16 00:00:00	2004-03-08	2004-03-08 00:00:00	32020		\N	116106	0	444814009	40481087		0
29483	1746	4116491	2014-05-23	2014-05-23 00:00:00	2014-06-23	2014-06-23 00:00:00	32020		\N	116727	0	301011002	4116491		0
29650	1755	4296204	1967-05-11	1967-05-11 00:00:00	1967-06-08	1967-06-08 00:00:00	32020		\N	117342	0	403190006	4296204		0
29791	1762	4112343	1964-06-28	1964-06-28 00:00:00	1964-07-08	1964-07-08 00:00:00	32020		\N	117861	0	195662009	4112343		0
30029	1776	80502	2006-10-28	2006-10-28 00:00:00	\N	\N	32020		\N	118881	0	64859006	80502		0
40673	2418	80180	2009-06-17	2009-06-17 00:00:00	\N	\N	32020		\N	160477	0	396275006	80180		0
30349	1791	260139	1963-11-19	1963-11-19 00:00:00	1963-11-26	1963-11-26 00:00:00	32020		\N	120088	0	10509002	260139		0
41085	2442	80180	2008-09-19	2008-09-19 00:00:00	\N	\N	32020		\N	161993	0	396275006	80180		0
30692	1814	260139	1940-12-17	1940-12-17 00:00:00	1940-12-24	1940-12-24 00:00:00	32020		\N	121408	0	10509002	260139		0
30876	1826	40481087	1960-10-16	1960-10-16 00:00:00	1960-10-23	1960-10-23 00:00:00	32020		\N	122044	0	444814009	40481087		0
31015	1837	40481087	1993-11-18	1993-11-18 00:00:00	1993-12-02	1993-12-02 00:00:00	32020		\N	122688	0	444814009	40481087		0
31177	1846	4112343	1976-07-09	1976-07-09 00:00:00	1976-07-18	1976-07-18 00:00:00	32020		\N	123458	0	195662009	4112343		0
31326	1851	40481087	2003-07-07	2003-07-07 00:00:00	2003-07-21	2003-07-21 00:00:00	32020		\N	123860	0	444814009	40481087		0
42001	2501	28060	1974-05-27	1974-05-27 00:00:00	1974-06-05	1974-06-05 00:00:00	32020		\N	165547	0	43878008	28060		0
31688	1878	4112343	2011-09-07	2011-09-07 00:00:00	2011-09-17	2011-09-17 00:00:00	32020		\N	125311	0	195662009	4112343		0
42369	2524	40481087	1966-09-12	1966-09-12 00:00:00	1966-09-19	1966-09-19 00:00:00	32020		\N	166912	0	444814009	40481087		0
21384	1282	40481087	2013-02-20	2013-02-20 00:00:00	2013-03-13	2013-03-13 00:00:00	32020		\N	84723	0	444814009	40481087		0
32079	1905	4112343	2018-06-04	2018-06-04 00:00:00	2018-06-13	2018-06-13 00:00:00	32020		\N	126809	0	195662009	4112343		0
32228	1915	4156265	1989-06-28	1989-06-28 00:00:00	1989-07-19	1989-07-19 00:00:00	32020		\N	127403	0	370247008	4156265		0
32394	1924	4112343	1980-02-21	1980-02-21 00:00:00	1980-03-01	1980-03-01 00:00:00	32020		\N	128027	0	195662009	4112343		0
21992	1317	258780	1996-05-24	1996-05-24 00:00:00	\N	\N	32020		\N	87299	0	185086009	258780		0
32739	1945	372328	1983-09-09	1983-09-09 00:00:00	1983-12-24	1983-12-24 00:00:00	32020		\N	129215	0	65363002	372328		0
22355	1334	80180	2008-11-30	2008-11-30 00:00:00	\N	\N	32020		\N	88525	0	396275006	80180		0
22559	1348	4112343	1997-11-11	1997-11-11 00:00:00	1997-11-21	1997-11-21 00:00:00	32020		\N	89297	0	195662009	4112343		0
22699	1355	372328	1966-08-23	1966-08-23 00:00:00	1966-09-23	1966-09-23 00:00:00	32020		\N	89842	0	65363002	372328		0
22879	1365	4142905	1967-05-03	1967-05-03 00:00:00	1967-07-02	1967-07-02 00:00:00	32020		\N	90454	0	33737001	4142905		0
22987	1371	78272	1972-02-07	1972-02-07 00:00:00	1972-03-13	1972-03-13 00:00:00	32020		\N	90893	0	70704007	78272		0
23155	1382	372328	1982-04-20	1982-04-20 00:00:00	1983-04-13	1983-04-13 00:00:00	32020		\N	91647	0	65363002	372328		0
23351	1391	260139	1954-01-25	1954-01-25 00:00:00	1954-02-01	1954-02-01 00:00:00	32020		\N	92322	0	10509002	260139		0
23565	1408	317576	2015-03-23	2015-03-23 00:00:00	\N	\N	32020		\N	93607	0	53741008	317576		0
23691	1412	78272	1981-12-08	1981-12-08 00:00:00	1981-12-22	1981-12-22 00:00:00	32020		\N	94037	0	70704007	78272		0
34399	2041	40481087	2010-12-13	2010-12-13 00:00:00	2010-12-27	2010-12-27 00:00:00	32020		\N	135832	0	444814009	40481087		0
23990	1432	260139	1983-03-06	1983-03-06 00:00:00	1983-03-20	1983-03-20 00:00:00	32020		\N	95370	0	10509002	260139		0
34738	2062	4112343	1953-09-26	1953-09-26 00:00:00	1953-10-09	1953-10-09 00:00:00	32020		\N	137123	0	195662009	4112343		0
34898	2073	40481087	1966-12-03	1966-12-03 00:00:00	1966-12-17	1966-12-17 00:00:00	32020		\N	137933	0	444814009	40481087		0
24491	1461	40481087	1998-10-27	1998-10-27 00:00:00	1998-11-10	1998-11-10 00:00:00	32020		\N	97326	0	444814009	40481087		0
24695	1475	4112343	1959-12-06	1959-12-06 00:00:00	1959-12-16	1959-12-16 00:00:00	32020		\N	98217	0	195662009	4112343		0
35368	2094	4059173	1948-09-14	1948-09-14 00:00:00	1948-10-14	1948-10-14 00:00:00	32020		\N	139571	0	16114001	4059173		0
25057	1496	28060	1948-08-17	1948-08-17 00:00:00	1948-08-24	1948-08-24 00:00:00	32020		\N	99726	0	43878008	28060		0
25182	1504	40481087	1976-10-19	1976-10-19 00:00:00	1976-11-09	1976-11-09 00:00:00	32020		\N	100269	0	444814009	40481087		0
25318	1510	40481087	1999-12-30	1999-12-30 00:00:00	2000-01-20	2000-01-20 00:00:00	32020		\N	100810	0	444814009	40481087		0
36024	2135	81151	1953-02-05	1953-02-05 00:00:00	1953-03-12	1953-03-12 00:00:00	32020		\N	142159	0	44465007	81151		0
25723	1528	372328	1960-03-04	1960-03-04 00:00:00	1960-03-18	1960-03-18 00:00:00	32020		\N	102288	0	65363002	372328		0
36360	2152	4112343	1995-11-25	1995-11-25 00:00:00	1995-12-06	1995-12-06 00:00:00	32020		\N	143451	0	195662009	4112343		0
26034	1543	40481087	1975-11-07	1975-11-07 00:00:00	1975-11-14	1975-11-14 00:00:00	32020		\N	103435	0	444814009	40481087		0
26220	1556	4155034	1990-02-19	1990-02-19 00:00:00	1990-03-05	1990-03-05 00:00:00	32020		\N	104149	0	283371005	4155034		0
26381	1565	40481087	1965-08-18	1965-08-18 00:00:00	1965-09-08	1965-09-08 00:00:00	32020		\N	104949	0	444814009	40481087		0
26462	1569	372328	1938-12-08	1938-12-08 00:00:00	1939-02-10	1939-02-10 00:00:00	32020		\N	105300	0	65363002	372328		0
26671	1579	40481087	1993-08-11	1993-08-11 00:00:00	1993-08-25	1993-08-25 00:00:00	32020		\N	106085	0	444814009	40481087		0
26865	1590	260139	2003-05-20	2003-05-20 00:00:00	2003-05-27	2003-05-27 00:00:00	32020		\N	106687	0	10509002	260139		0
27003	1598	260139	1997-05-28	1997-05-28 00:00:00	1997-06-04	1997-06-04 00:00:00	32020		\N	107246	0	10509002	260139		0
27150	1605	4218389	2016-05-05	2016-05-05 00:00:00	2016-05-26	2016-05-26 00:00:00	32020		\N	107752	0	39848009	4218389		0
27370	1613	4112343	1990-07-30	1990-07-30 00:00:00	1990-08-10	1990-08-10 00:00:00	32020		\N	108483	0	195662009	4112343		0
38042	2258	40481087	1960-09-30	1960-09-30 00:00:00	1960-10-14	1960-10-14 00:00:00	32020		\N	150073	0	444814009	40481087		0
27709	1635	81151	1976-07-29	1976-07-29 00:00:00	1976-08-19	1976-08-19 00:00:00	32020		\N	109829	0	44465007	81151		0
38397	2280	372328	1974-09-27	1974-09-27 00:00:00	1975-05-21	1975-05-21 00:00:00	32020		\N	151594	0	65363002	372328		0
38568	2290	40481087	2008-01-24	2008-01-24 00:00:00	2008-01-31	2008-01-31 00:00:00	32020		\N	152319	0	444814009	40481087		0
28171	1661	4296204	1986-06-18	1986-06-18 00:00:00	1986-07-09	1986-07-09 00:00:00	32020		\N	111653	0	403190006	4296204		0
28372	1677	4152936	1974-01-17	1974-01-17 00:00:00	1974-01-31	1974-01-31 00:00:00	32020		\N	112489	0	283385000	4152936		0
39026	2319	40481087	1979-09-30	1979-09-30 00:00:00	1979-10-14	1979-10-14 00:00:00	32020		\N	154200	0	444814009	40481087		0
28617	1692	40481087	2000-08-05	2000-08-05 00:00:00	2000-08-12	2000-08-12 00:00:00	32020		\N	113349	0	444814009	40481087		0
28884	1709	4112343	1955-03-18	1955-03-18 00:00:00	1955-03-27	1955-03-27 00:00:00	32020		\N	114253	0	195662009	4112343		0
28982	1716	257012	1979-06-09	1979-06-09 00:00:00	\N	\N	32020		\N	114620	0	40055000	257012		0
29183	1727	260139	2004-09-10	2004-09-10 00:00:00	2004-09-24	2004-09-24 00:00:00	32020		\N	115441	0	10509002	260139		0
29348	1738	40481087	1991-04-06	1991-04-06 00:00:00	1991-04-13	1991-04-13 00:00:00	32020		\N	116131	0	444814009	40481087		0
29484	1746	260139	1967-10-13	1967-10-13 00:00:00	1967-10-20	1967-10-20 00:00:00	32020		\N	116785	0	10509002	260139		0
29651	1755	4155034	2018-10-16	2018-10-16 00:00:00	2018-10-30	2018-10-30 00:00:00	32020		\N	117381	0	283371005	4155034		0
29792	1762	260139	1975-09-20	1975-09-20 00:00:00	1975-09-27	1975-09-27 00:00:00	32020		\N	117806	0	10509002	260139		0
30030	1776	4112343	2014-09-29	2014-09-29 00:00:00	2014-10-08	2014-10-08 00:00:00	32020		\N	118780	0	195662009	4112343		0
40674	2418	195588	1998-08-29	1998-08-29 00:00:00	1998-09-29	1998-09-29 00:00:00	32020		\N	160443	0	38822007	195588		0
30350	1791	28060	1955-08-24	1955-08-24 00:00:00	1955-08-31	1955-08-31 00:00:00	32020		\N	120062	0	43878008	28060		0
41086	2442	40481087	2008-08-23	2008-08-23 00:00:00	2008-09-13	2008-09-13 00:00:00	32020		\N	161993	0	444814009	40481087		0
30693	1814	372328	1945-07-29	1945-07-29 00:00:00	1946-04-06	1946-04-06 00:00:00	32020		\N	121446	0	65363002	372328		0
41335	2458	78272	2003-03-05	2003-03-05 00:00:00	2003-04-02	2003-04-02 00:00:00	32020		\N	162944	0	70704007	78272		0
31016	1837	4116491	1992-05-05	1992-05-05 00:00:00	1992-06-24	1992-06-24 00:00:00	32020		\N	122687	0	301011002	4116491		0
31178	1846	40481087	1964-11-02	1964-11-02 00:00:00	1964-11-09	1964-11-09 00:00:00	32020		\N	123410	0	444814009	40481087		0
31327	1851	80180	2016-07-16	2016-07-16 00:00:00	\N	\N	32020		\N	123837	0	396275006	80180		0
42002	2501	372328	1962-09-05	1962-09-05 00:00:00	1962-11-05	1962-11-05 00:00:00	32020		\N	165555	0	65363002	372328		0
31689	1878	257012	1998-03-10	1998-03-10 00:00:00	1998-04-15	1998-04-15 00:00:00	32020		\N	125328	0	40055000	257012		0
42370	2524	372328	1950-08-12	1950-08-12 00:00:00	1950-08-26	1950-08-26 00:00:00	32020		\N	166905	0	65363002	372328		0
21385	1282	40486433	1981-04-09	1981-04-09 00:00:00	\N	\N	32020		\N	84721	0	446096008	40486433		0
32080	1905	40481087	1992-09-13	1992-09-13 00:00:00	1992-09-27	1992-09-27 00:00:00	32020		\N	126806	0	444814009	40481087		0
32229	1915	4296205	2005-12-06	2005-12-06 00:00:00	2005-12-20	2005-12-20 00:00:00	32020		\N	127406	0	403191005	4296205		0
32395	1924	4283893	1990-02-11	1990-02-11 00:00:00	1990-05-27	1990-05-27 00:00:00	32020		\N	128073	0	36971009	4283893		0
21993	1317	4001336	2006-02-24	2006-02-24 00:00:00	2006-04-25	2006-04-25 00:00:00	32020		\N	87280	0	110030002	4001336		0
32740	1946	4112343	2000-06-05	2000-06-05 00:00:00	2000-06-16	2000-06-16 00:00:00	32020		\N	129311	0	195662009	4112343		0
22356	1334	40481087	2008-08-06	2008-08-06 00:00:00	2008-08-27	2008-08-27 00:00:00	32020		\N	88525	0	444814009	40481087		0
22560	1348	80180	1954-03-06	1954-03-06 00:00:00	\N	\N	32020		\N	89348	0	396275006	80180		0
22700	1355	260139	1965-11-28	1965-11-28 00:00:00	1965-12-12	1965-12-12 00:00:00	32020		\N	89851	0	10509002	260139		0
22880	1365	4112343	2013-04-06	2013-04-06 00:00:00	2013-04-19	2013-04-19 00:00:00	32020		\N	90465	0	195662009	4112343		0
22988	1371	4112343	1984-10-27	1984-10-27 00:00:00	1984-11-04	1984-11-04 00:00:00	32020		\N	90876	0	195662009	4112343		0
23156	1382	4152936	2019-05-17	2019-05-17 00:00:00	2019-06-07	2019-06-07 00:00:00	32020		\N	91653	0	283385000	4152936		0
23352	1391	28060	1937-10-14	1937-10-14 00:00:00	1937-10-24	1937-10-24 00:00:00	32020		\N	92318	0	43878008	28060		0
23566	1408	372328	1953-12-13	1953-12-13 00:00:00	1954-08-16	1954-08-16 00:00:00	32020		\N	93626	0	65363002	372328		0
23692	1412	378001	1994-03-01	1994-03-01 00:00:00	1994-04-30	1994-04-30 00:00:00	32020		\N	94041	0	62106007	378001		0
34400	2041	40481087	2013-04-21	2013-04-21 00:00:00	2013-05-05	2013-05-05 00:00:00	32020		\N	135842	0	444814009	40481087		0
23991	1432	260139	2012-08-29	2012-08-29 00:00:00	2012-09-05	2012-09-05 00:00:00	32020		\N	95412	0	10509002	260139		0
34739	2062	257012	1957-07-18	1957-07-18 00:00:00	1965-12-31	1965-12-31 00:00:00	32020		\N	137124	0	40055000	257012		0
34899	2073	4112343	1995-03-29	1995-03-29 00:00:00	1995-04-10	1995-04-10 00:00:00	32020		\N	137935	0	195662009	4112343		0
24492	1461	40481087	2014-10-22	2014-10-22 00:00:00	2014-11-12	2014-11-12 00:00:00	32020		\N	97366	0	444814009	40481087		0
24696	1475	372328	1935-01-20	1935-01-20 00:00:00	1935-02-03	1935-02-03 00:00:00	32020		\N	98279	0	65363002	372328		0
35369	2094	260139	2018-12-17	2018-12-17 00:00:00	2018-12-24	2018-12-24 00:00:00	32020		\N	139646	0	10509002	260139		0
25058	1496	40481087	1957-03-26	1957-03-26 00:00:00	1957-04-16	1957-04-16 00:00:00	32020		\N	99731	0	444814009	40481087		0
25183	1504	40481087	1960-11-20	1960-11-20 00:00:00	1960-12-04	1960-12-04 00:00:00	32020		\N	100267	0	444814009	40481087		0
25319	1510	260139	1970-05-21	1970-05-21 00:00:00	1970-06-04	1970-06-04 00:00:00	32020		\N	100779	0	10509002	260139		0
36025	2135	81151	1969-07-14	1969-07-14 00:00:00	1969-08-11	1969-08-11 00:00:00	32020		\N	142103	0	44465007	81151		0
25724	1528	40481087	1991-03-14	1991-03-14 00:00:00	1991-04-04	1991-04-04 00:00:00	32020		\N	102284	0	444814009	40481087		0
36361	2152	313217	2008-02-23	2008-02-23 00:00:00	\N	\N	32020		\N	143390	0	49436004	313217		0
26045	1545	372328	1974-10-06	1974-10-06 00:00:00	1974-11-22	1974-11-22 00:00:00	32020		\N	103505	0	65363002	372328		0
26221	1556	81151	1989-01-04	1989-01-04 00:00:00	1989-01-25	1989-01-25 00:00:00	32020		\N	104148	0	44465007	81151		0
26382	1565	260139	1974-07-24	1974-07-24 00:00:00	1974-08-07	1974-08-07 00:00:00	32020		\N	104970	0	10509002	260139		0
26463	1569	260139	2007-06-21	2007-06-21 00:00:00	2007-07-05	2007-07-05 00:00:00	32020		\N	105298	0	10509002	260139		0
26672	1579	260139	1974-08-18	1974-08-18 00:00:00	1974-09-01	1974-09-01 00:00:00	32020		\N	106088	0	10509002	260139		0
26866	1590	40481087	1975-08-18	1975-08-18 00:00:00	1975-09-08	1975-09-08 00:00:00	32020		\N	106685	0	444814009	40481087		0
27004	1598	372328	1958-05-20	1958-05-20 00:00:00	1958-06-30	1958-06-30 00:00:00	32020		\N	107211	0	65363002	372328		0
27151	1605	40481087	1975-05-15	1975-05-15 00:00:00	1975-06-05	1975-06-05 00:00:00	32020		\N	107778	0	444814009	40481087		0
27371	1613	4112343	1960-09-11	1960-09-11 00:00:00	1960-09-18	1960-09-18 00:00:00	32020		\N	108466	0	195662009	4112343		0
38043	2258	40481087	1983-06-12	1983-06-12 00:00:00	1983-07-03	1983-07-03 00:00:00	32020		\N	150083	0	444814009	40481087		0
27710	1635	81151	1988-01-19	1988-01-19 00:00:00	1988-02-16	1988-02-16 00:00:00	32020		\N	109830	0	44465007	81151		0
38398	2280	260139	1984-05-02	1984-05-02 00:00:00	1984-05-16	1984-05-16 00:00:00	32020		\N	151588	0	10509002	260139		0
38569	2290	40481087	1959-06-22	1959-06-22 00:00:00	1959-07-13	1959-07-13 00:00:00	32020		\N	152354	0	444814009	40481087		0
28172	1662	260139	1969-11-14	1969-11-14 00:00:00	1969-11-28	1969-11-28 00:00:00	32020		\N	111710	0	10509002	260139		0
28373	1677	28060	1985-06-02	1985-06-02 00:00:00	1985-06-10	1985-06-10 00:00:00	32020		\N	112526	0	43878008	28060		0
39027	2319	4112343	2019-03-05	2019-03-05 00:00:00	2019-03-14	2019-03-14 00:00:00	32020		\N	154222	0	195662009	4112343		0
28618	1692	4112343	1983-04-14	1983-04-14 00:00:00	1983-04-24	1983-04-24 00:00:00	32020		\N	113325	0	195662009	4112343		0
39343	2333	40481087	2006-03-14	2006-03-14 00:00:00	2006-03-21	2006-03-21 00:00:00	32020		\N	155135	0	444814009	40481087		0
28983	1716	372328	1950-06-21	1950-06-21 00:00:00	1950-10-06	1950-10-06 00:00:00	32020		\N	114634	0	65363002	372328		0
29184	1727	40481087	1970-04-13	1970-04-13 00:00:00	1970-05-05	1970-05-05 00:00:00	32020		\N	115466	0	444814009	40481087		0
29349	1738	4116491	2009-05-09	2009-05-09 00:00:00	2009-06-14	2009-06-14 00:00:00	32020		\N	116137	0	301011002	4116491		0
29485	1746	4056621	2005-03-01	2005-03-01 00:00:00	\N	\N	32020		\N	116799	0	197927001	4056621		0
29652	1755	4156265	1995-12-06	1995-12-06 00:00:00	1995-12-27	1995-12-27 00:00:00	32020		\N	117377	0	370247008	4156265		0
29793	1762	313217	1998-04-09	1998-04-09 00:00:00	\N	\N	32020		\N	117826	0	49436004	313217		0
30031	1776	372328	1918-08-04	1918-08-04 00:00:00	1918-10-05	1918-10-05 00:00:00	32020		\N	118781	0	65363002	372328		0
40675	2418	40481087	2000-07-20	2000-07-20 00:00:00	2000-08-03	2000-08-03 00:00:00	32020		\N	160444	0	444814009	40481087		0
30351	1791	4296205	1996-08-01	1996-08-01 00:00:00	1996-09-05	1996-09-05 00:00:00	32020		\N	120058	0	403191005	4296205		0
41087	2442	4266809	2008-09-19	2008-09-19 00:00:00	\N	\N	32020		\N	161993	0	397881000	4266809		0
30694	1814	40481087	1973-02-01	1973-02-01 00:00:00	1973-02-15	1973-02-15 00:00:00	32020		\N	121416	0	444814009	40481087		0
41336	2458	40481087	1978-01-20	1978-01-20 00:00:00	1978-02-10	1978-02-10 00:00:00	32020		\N	162966	0	444814009	40481087		0
31017	1837	4112343	1973-11-14	1973-11-14 00:00:00	1973-11-23	1973-11-23 00:00:00	32020		\N	122726	0	195662009	4112343		0
31179	1846	40481087	1959-04-21	1959-04-21 00:00:00	1959-05-05	1959-05-05 00:00:00	32020		\N	123443	0	444814009	40481087		0
31328	1851	4112343	2007-05-04	2007-05-04 00:00:00	2007-05-13	2007-05-13 00:00:00	32020		\N	123815	0	195662009	4112343		0
42003	2501	4112343	2014-07-11	2014-07-11 00:00:00	2014-07-19	2014-07-19 00:00:00	32020		\N	165539	0	195662009	4112343		0
31690	1878	4112343	1992-01-14	1992-01-14 00:00:00	1992-01-23	1992-01-23 00:00:00	32020		\N	125297	0	195662009	4112343		0
42371	2524	40481087	1971-12-26	1971-12-26 00:00:00	1972-01-02	1972-01-02 00:00:00	32020		\N	166914	0	444814009	40481087		0
21386	1282	372328	1980-09-09	1980-09-09 00:00:00	1981-03-14	1981-03-14 00:00:00	32020		\N	84741	0	65363002	372328		0
32081	1905	317576	1983-08-05	1983-08-05 00:00:00	\N	\N	32020		\N	126851	0	53741008	317576		0
32230	1915	260139	2006-05-20	2006-05-20 00:00:00	2006-06-03	2006-06-03 00:00:00	32020		\N	127355	0	10509002	260139		0
32396	1924	40481087	1986-05-04	1986-05-04 00:00:00	1986-05-25	1986-05-25 00:00:00	32020		\N	128037	0	444814009	40481087		0
21994	1317	260139	1992-05-05	1992-05-05 00:00:00	1992-05-12	1992-05-12 00:00:00	32020		\N	87297	0	10509002	260139		0
32741	1946	4112343	1973-01-16	1973-01-16 00:00:00	1973-01-26	1973-01-26 00:00:00	32020		\N	129273	0	195662009	4112343		0
22357	1334	4112343	1991-01-03	1991-01-03 00:00:00	1991-01-14	1991-01-14 00:00:00	32020		\N	88538	0	195662009	4112343		0
22561	1348	40481087	1960-08-01	1960-08-01 00:00:00	1960-08-08	1960-08-08 00:00:00	32020		\N	89364	0	444814009	40481087		0
22701	1355	4112343	1987-09-08	1987-09-08 00:00:00	1987-09-21	1987-09-21 00:00:00	32020		\N	89779	0	195662009	4112343		0
22881	1365	372328	2009-02-25	2009-02-25 00:00:00	2009-12-03	2009-12-03 00:00:00	32020		\N	90425	0	65363002	372328		0
22989	1371	28060	2008-11-13	2008-11-13 00:00:00	2008-11-21	2008-11-21 00:00:00	32020		\N	90915	0	43878008	28060		0
23157	1382	260139	2002-08-02	2002-08-02 00:00:00	2002-08-09	2002-08-09 00:00:00	32020		\N	91664	0	10509002	260139		0
23353	1391	4116491	1959-12-23	1959-12-23 00:00:00	1960-02-06	1960-02-06 00:00:00	32020		\N	92347	0	301011002	4116491		0
23567	1408	40481087	1948-05-16	1948-05-16 00:00:00	1948-06-06	1948-06-06 00:00:00	32020		\N	93623	0	444814009	40481087		0
23693	1412	40481087	2018-04-13	2018-04-13 00:00:00	2018-05-04	2018-05-04 00:00:00	32020		\N	93988	0	444814009	40481087		0
34401	2041	40481087	2010-04-05	2010-04-05 00:00:00	2010-04-12	2010-04-12 00:00:00	32020		\N	135862	0	444814009	40481087		0
23992	1432	40481087	1964-05-23	1964-05-23 00:00:00	1964-06-13	1964-06-13 00:00:00	32020		\N	95392	0	444814009	40481087		0
34740	2062	4112343	2008-12-21	2008-12-21 00:00:00	2008-12-30	2008-12-30 00:00:00	32020		\N	137126	0	195662009	4112343		0
34900	2073	4112343	1983-11-10	1983-11-10 00:00:00	1983-11-23	1983-11-23 00:00:00	32020		\N	137882	0	195662009	4112343		0
24493	1461	4218389	2007-11-12	2007-11-12 00:00:00	2007-12-10	2007-12-10 00:00:00	32020		\N	97379	0	39848009	4218389		0
24697	1475	4112343	1980-05-03	1980-05-03 00:00:00	1980-05-16	1980-05-16 00:00:00	32020		\N	98271	0	195662009	4112343		0
35370	2094	4112343	1977-01-02	1977-01-02 00:00:00	1977-01-12	1977-01-12 00:00:00	32020		\N	139594	0	195662009	4112343		0
25059	1496	4112343	1947-04-11	1947-04-11 00:00:00	1947-04-21	1947-04-21 00:00:00	32020		\N	99729	0	195662009	4112343		0
25184	1504	4237458	1957-04-01	1957-04-01 00:00:00	1957-06-30	1957-06-30 00:00:00	32020		\N	100255	0	58150001	4237458		0
25320	1510	4283893	1995-01-10	1995-01-10 00:00:00	1995-06-27	1995-06-27 00:00:00	32020		\N	100781	0	36971009	4283893		0
36026	2135	4155034	1963-06-18	1963-06-18 00:00:00	1963-07-02	1963-07-02 00:00:00	32020		\N	142101	0	283371005	4155034		0
25725	1528	40481087	2013-06-14	2013-06-14 00:00:00	2013-07-05	2013-07-05 00:00:00	32020		\N	102273	0	444814009	40481087		0
36362	2152	260139	1922-08-12	1922-08-12 00:00:00	1922-08-19	1922-08-19 00:00:00	32020		\N	143378	0	10509002	260139		0
26046	1545	81151	2013-06-25	2013-06-25 00:00:00	2013-07-23	2013-07-23 00:00:00	32020		\N	103513	0	44465007	81151		0
26222	1556	4294548	2009-05-25	2009-05-25 00:00:00	2009-06-29	2009-06-29 00:00:00	32020		\N	104190	0	75498004	4294548		0
26383	1565	260139	2017-08-18	2017-08-18 00:00:00	2017-09-01	2017-09-01 00:00:00	32020		\N	104941	0	10509002	260139		0
26464	1569	40481087	2012-10-13	2012-10-13 00:00:00	2012-10-20	2012-10-20 00:00:00	32020		\N	105299	0	444814009	40481087		0
26673	1579	4266809	1988-03-11	1988-03-11 00:00:00	\N	\N	32020		\N	106070	0	397881000	4266809		0
26867	1590	4112343	1989-09-16	1989-09-16 00:00:00	1989-09-25	1989-09-25 00:00:00	32020		\N	106671	0	195662009	4112343		0
27005	1598	260139	1995-08-15	1995-08-15 00:00:00	1995-08-22	1995-08-22 00:00:00	32020		\N	107245	0	10509002	260139		0
27152	1605	4027663	1962-06-22	1962-06-22 00:00:00	\N	\N	32020		\N	107714	0	13200003	4027663		0
27372	1613	4112343	2006-09-29	2006-09-29 00:00:00	2006-10-08	2006-10-08 00:00:00	32020		\N	108442	0	195662009	4112343		0
38044	2258	260139	2003-11-11	2003-11-11 00:00:00	2003-11-25	2003-11-25 00:00:00	32020		\N	150094	0	10509002	260139		0
27711	1635	260139	1981-08-03	1981-08-03 00:00:00	1981-08-17	1981-08-17 00:00:00	32020		\N	109844	0	10509002	260139		0
38416	2283	372328	1951-04-22	1951-04-22 00:00:00	1951-12-31	1951-12-31 00:00:00	32020		\N	151931	0	65363002	372328		0
38570	2290	260139	1984-03-07	1984-03-07 00:00:00	1984-03-14	1984-03-14 00:00:00	32020		\N	152358	0	10509002	260139		0
28173	1662	40481087	1988-11-14	1988-11-14 00:00:00	1988-11-28	1988-11-28 00:00:00	32020		\N	111712	0	444814009	40481087		0
28374	1677	40481087	2008-10-16	2008-10-16 00:00:00	2008-10-30	2008-10-30 00:00:00	32020		\N	112514	0	444814009	40481087		0
39028	2319	257012	2003-11-29	2003-11-29 00:00:00	\N	\N	32020		\N	154185	0	40055000	257012		0
28619	1692	40481087	1990-10-30	1990-10-30 00:00:00	1990-11-06	1990-11-06 00:00:00	32020		\N	113347	0	444814009	40481087		0
39344	2333	372328	1925-11-23	1925-11-23 00:00:00	1926-02-09	1926-02-09 00:00:00	32020		\N	155259	0	65363002	372328		0
28984	1716	40481087	2018-02-05	2018-02-05 00:00:00	2018-02-26	2018-02-26 00:00:00	32020		\N	114633	0	444814009	40481087		0
29185	1727	40481087	1969-09-03	1969-09-03 00:00:00	1969-09-10	1969-09-10 00:00:00	32020		\N	115521	0	444814009	40481087		0
29350	1738	4218389	1980-11-12	1980-11-12 00:00:00	1980-12-17	1980-12-17 00:00:00	32020		\N	116167	0	39848009	4218389		0
29486	1746	4116491	2005-03-01	2005-03-01 00:00:00	2005-04-19	2005-04-19 00:00:00	32020		\N	116799	0	301011002	4116491		0
29654	1755	321042	2015-08-26	2015-08-26 00:00:00	\N	\N	32020		\N	117380	0	410429000	321042		0
29794	1762	4112343	1967-08-25	1967-08-25 00:00:00	1967-09-03	1967-09-03 00:00:00	32020		\N	117846	0	195662009	4112343		0
30037	1778	4142905	1993-07-08	1993-07-08 00:00:00	1993-09-06	1993-09-06 00:00:00	32020		\N	118931	0	33737001	4142905		0
40676	2418	28060	1983-04-19	1983-04-19 00:00:00	1983-04-26	1983-04-26 00:00:00	32020		\N	160419	0	43878008	28060		0
30352	1791	4112343	2016-11-10	2016-11-10 00:00:00	2016-11-17	2016-11-17 00:00:00	32020		\N	120025	0	195662009	4112343		0
41088	2442	4051466	1973-06-27	1973-06-27 00:00:00	1990-09-26	1990-09-26 00:00:00	32020		\N	162005	0	233678006	4051466		0
30695	1814	4237458	1953-07-11	1953-07-11 00:00:00	1953-09-09	1953-09-09 00:00:00	32020		\N	121429	0	58150001	4237458		0
41337	2458	260139	2016-12-19	2016-12-19 00:00:00	2017-01-02	2017-01-02 00:00:00	32020		\N	162949	0	10509002	260139		0
31018	1837	260139	1964-01-04	1964-01-04 00:00:00	1964-01-18	1964-01-18 00:00:00	32020		\N	122702	0	10509002	260139		0
31180	1846	4266809	1987-11-09	1987-11-09 00:00:00	\N	\N	32020		\N	123439	0	397881000	4266809		0
31329	1852	40481087	2001-09-11	2001-09-11 00:00:00	2001-09-25	2001-09-25 00:00:00	32020		\N	123988	0	444814009	40481087		0
42004	2501	4109685	1979-05-09	1979-05-09 00:00:00	1979-05-30	1979-05-30 00:00:00	32020		\N	165575	0	284551006	4109685		0
31691	1878	260139	1990-03-27	1990-03-27 00:00:00	1990-04-04	1990-04-04 00:00:00	32020		\N	125326	0	10509002	260139		0
42372	2524	372328	1951-09-20	1951-09-20 00:00:00	1951-11-24	1951-11-24 00:00:00	32020		\N	166877	0	65363002	372328		0
21387	1282	4084167	1991-06-14	1991-06-14 00:00:00	1991-06-14	1991-06-14 00:00:00	32020		\N	84709	0	241929008	4084167		0
32082	1905	372328	1966-07-18	1966-07-18 00:00:00	1966-10-28	1966-10-28 00:00:00	32020		\N	126819	0	65363002	372328		0
32231	1915	40481087	1976-11-26	1976-11-26 00:00:00	1976-12-03	1976-12-03 00:00:00	32020		\N	127371	0	444814009	40481087		0
32397	1925	40481087	1978-01-15	1978-01-15 00:00:00	1978-02-05	1978-02-05 00:00:00	32020		\N	128142	0	444814009	40481087		0
21995	1317	40481087	1986-07-04	1986-07-04 00:00:00	1986-07-18	1986-07-18 00:00:00	32020		\N	87296	0	444814009	40481087		0
32742	1946	260139	1953-12-19	1953-12-19 00:00:00	1953-12-26	1953-12-26 00:00:00	32020		\N	129316	0	10509002	260139		0
22358	1334	40481087	1969-07-29	1969-07-29 00:00:00	1969-08-19	1969-08-19 00:00:00	32020		\N	88522	0	444814009	40481087		0
22562	1348	40481087	1919-07-15	1919-07-15 00:00:00	1919-08-05	1919-08-05 00:00:00	32020		\N	89359	0	444814009	40481087		0
22702	1355	4155034	2000-01-02	2000-01-02 00:00:00	2000-01-23	2000-01-23 00:00:00	32020		\N	89793	0	283371005	4155034		0
22882	1365	4112343	1965-11-10	1965-11-10 00:00:00	1965-11-18	1965-11-18 00:00:00	32020		\N	90415	0	195662009	4112343		0
22990	1371	372328	1972-07-06	1972-07-06 00:00:00	1972-09-19	1972-09-19 00:00:00	32020		\N	90904	0	65363002	372328		0
23158	1382	260139	2019-06-19	2019-06-19 00:00:00	\N	\N	32020		\N	91624	0	10509002	260139		0
23354	1391	80502	1994-10-25	1994-10-25 00:00:00	\N	\N	32020		\N	92308	0	64859006	80502		0
23568	1408	4112343	2011-11-07	2011-11-07 00:00:00	2011-11-19	2011-11-19 00:00:00	32020		\N	93594	0	195662009	4112343		0
23694	1412	260139	1975-11-27	1975-11-27 00:00:00	1975-12-11	1975-12-11 00:00:00	32020		\N	94081	0	10509002	260139		0
34402	2041	317576	1998-09-01	1998-09-01 00:00:00	\N	\N	32020		\N	135804	0	53741008	317576		0
23993	1432	4112343	2018-03-27	2018-03-27 00:00:00	2018-04-05	2018-04-05 00:00:00	32020		\N	95395	0	195662009	4112343		0
34741	2062	257012	2015-07-10	2015-07-10 00:00:00	\N	\N	32020		\N	137172	0	40055000	257012		0
34901	2073	372328	1973-11-19	1973-11-19 00:00:00	1974-03-01	1974-03-01 00:00:00	32020		\N	137943	0	65363002	372328		0
24494	1461	80180	2008-07-28	2008-07-28 00:00:00	\N	\N	32020		\N	97379	0	396275006	80180		0
24698	1475	260139	1944-03-05	1944-03-05 00:00:00	1944-03-12	1944-03-12 00:00:00	32020		\N	98219	0	10509002	260139		0
35395	2097	192671	2014-04-17	2014-04-17 00:00:00	\N	\N	32020		\N	139779	0	K92.2	35208414		0
25060	1496	40481087	1966-08-05	1966-08-05 00:00:00	1966-08-26	1966-08-26 00:00:00	32020		\N	99695	0	444814009	40481087		0
25186	1504	40481087	2004-10-23	2004-10-23 00:00:00	2004-11-13	2004-11-13 00:00:00	32020		\N	100279	0	444814009	40481087		0
25321	1510	40481087	1959-01-08	1959-01-08 00:00:00	1959-01-22	1959-01-22 00:00:00	32020		\N	100772	0	444814009	40481087		0
36027	2135	40481087	1971-07-05	1971-07-05 00:00:00	1971-07-12	1971-07-12 00:00:00	32020		\N	142073	0	444814009	40481087		0
25726	1528	4278672	2007-02-24	2007-02-24 00:00:00	2007-05-25	2007-05-25 00:00:00	32020		\N	102241	0	65966004	4278672		0
36363	2152	40481087	1978-01-02	1978-01-02 00:00:00	1978-01-16	1978-01-16 00:00:00	32020		\N	143425	0	444814009	40481087		0
26047	1545	4294548	1978-11-19	1978-11-19 00:00:00	1979-02-04	1979-02-04 00:00:00	32020		\N	103503	0	75498004	4294548		0
26223	1556	260139	1996-10-26	1996-10-26 00:00:00	1996-11-09	1996-11-09 00:00:00	32020		\N	104156	0	10509002	260139		0
26384	1565	440086	1972-09-11	1972-09-11 00:00:00	1974-09-02	1974-09-02 00:00:00	32020		\N	104965	0	192127007	440086		0
26465	1569	40481087	1980-05-13	1980-05-13 00:00:00	1980-05-27	1980-05-27 00:00:00	32020		\N	105236	0	444814009	40481087		0
26674	1579	80180	1988-03-11	1988-03-11 00:00:00	\N	\N	32020		\N	106070	0	396275006	80180		0
26868	1590	40481087	1997-11-26	1997-11-26 00:00:00	1997-12-17	1997-12-17 00:00:00	32020		\N	106710	0	444814009	40481087		0
27006	1598	40481087	1961-01-10	1961-01-10 00:00:00	1961-01-31	1961-01-31 00:00:00	32020		\N	107270	0	444814009	40481087		0
27153	1605	372328	1937-02-23	1937-02-23 00:00:00	1937-06-06	1937-06-06 00:00:00	32020		\N	107697	0	65363002	372328		0
27373	1613	4094814	2006-10-23	2006-10-23 00:00:00	\N	\N	32020		\N	108498	0	262574004	4094814		0
38067	2260	4155034	2009-04-16	2009-04-16 00:00:00	2009-05-07	2009-05-07 00:00:00	32020		\N	150222	0	283371005	4155034		0
27712	1635	30753	2011-02-26	2011-02-26 00:00:00	\N	\N	32020		\N	109802	0	16761005	30753		0
38417	2283	40481087	1970-01-26	1970-01-26 00:00:00	1970-02-02	1970-02-02 00:00:00	32020		\N	151911	0	444814009	40481087		0
38571	2290	260139	1993-10-28	1993-10-28 00:00:00	1993-11-11	1993-11-11 00:00:00	32020		\N	152326	0	10509002	260139		0
28174	1662	4112343	1999-02-12	1999-02-12 00:00:00	1999-02-24	1999-02-24 00:00:00	32020		\N	111722	0	195662009	4112343		0
28375	1677	372328	1970-05-08	1970-05-08 00:00:00	1970-06-20	1970-06-20 00:00:00	32020		\N	112497	0	65363002	372328		0
39029	2319	140673	2015-01-29	2015-01-29 00:00:00	\N	\N	32020		\N	154211	0	40930008	140673		0
28632	1695	4146173	1967-08-22	1967-08-22 00:00:00	1967-09-21	1967-09-21 00:00:00	32020		\N	113485	0	307731004	4146173		0
39345	2333	4283893	1982-11-19	1982-11-19 00:00:00	1983-05-27	1983-05-27 00:00:00	32020		\N	155243	0	36971009	4283893		0
28985	1716	4237458	1993-06-18	1993-06-18 00:00:00	1993-09-16	1993-09-16 00:00:00	32020		\N	114707	0	58150001	4237458		0
29186	1727	4278672	1977-02-22	1977-02-22 00:00:00	1977-03-24	1977-03-24 00:00:00	32020		\N	115481	0	65966004	4278672		0
29351	1738	40481087	2013-05-25	2013-05-25 00:00:00	2013-06-01	2013-06-01 00:00:00	32020		\N	116152	0	444814009	40481087		0
29487	1746	40481087	1954-10-09	1954-10-09 00:00:00	1954-10-16	1954-10-16 00:00:00	32020		\N	116714	0	444814009	40481087		0
29655	1755	78272	1969-04-28	1969-04-28 00:00:00	1969-05-26	1969-05-26 00:00:00	32020		\N	117343	0	70704007	78272		0
29795	1762	40481087	1989-05-25	1989-05-25 00:00:00	1989-06-15	1989-06-15 00:00:00	32020		\N	117803	0	444814009	40481087		0
30038	1778	257012	2003-06-06	2003-06-06 00:00:00	\N	\N	32020		\N	118957	0	40055000	257012		0
40677	2418	40481087	2005-05-15	2005-05-15 00:00:00	2005-05-29	2005-05-29 00:00:00	32020		\N	160454	0	444814009	40481087		0
30353	1791	4112343	1971-04-08	1971-04-08 00:00:00	1971-04-18	1971-04-18 00:00:00	32020		\N	120065	0	195662009	4112343		0
41089	2442	40481087	1986-10-01	1986-10-01 00:00:00	1986-10-08	1986-10-08 00:00:00	32020		\N	161923	0	444814009	40481087		0
30696	1814	40481087	2004-07-08	2004-07-08 00:00:00	2004-07-22	2004-07-22 00:00:00	32020		\N	121397	0	444814009	40481087		0
41338	2458	260139	1982-05-23	1982-05-23 00:00:00	1982-05-30	1982-05-30 00:00:00	32020		\N	162958	0	10509002	260139		0
31019	1837	260139	2015-07-02	2015-07-02 00:00:00	2015-07-16	2015-07-16 00:00:00	32020		\N	122731	0	10509002	260139		0
31181	1846	4310024	1986-08-16	1986-08-16 00:00:00	\N	\N	32020		\N	123439	0	424802006	4310024		0
31330	1852	4112343	2011-01-24	2011-01-24 00:00:00	2011-02-02	2011-02-02 00:00:00	32020		\N	123877	0	195662009	4112343		0
42005	2501	260139	1992-07-17	1992-07-17 00:00:00	1992-07-31	1992-07-31 00:00:00	32020		\N	165530	0	10509002	260139		0
31692	1878	4156265	1980-12-04	1980-12-04 00:00:00	1980-12-25	1980-12-25 00:00:00	32020		\N	125348	0	370247008	4156265		0
42373	2524	40481087	1987-07-20	1987-07-20 00:00:00	1987-08-10	1987-08-10 00:00:00	32020		\N	166878	0	444814009	40481087		0
21388	1282	4112343	1978-08-23	1978-08-23 00:00:00	1978-09-04	1978-09-04 00:00:00	32020		\N	84720	0	195662009	4112343		0
32083	1905	260139	2003-11-28	2003-11-28 00:00:00	2003-12-05	2003-12-05 00:00:00	32020		\N	126807	0	10509002	260139		0
32232	1915	440086	1983-03-03	1983-03-03 00:00:00	1983-09-15	1983-09-15 00:00:00	32020		\N	127373	0	192127007	440086		0
32398	1925	40481087	1953-07-06	1953-07-06 00:00:00	1953-07-27	1953-07-27 00:00:00	32020		\N	128117	0	444814009	40481087		0
21996	1317	260139	1964-04-14	1964-04-14 00:00:00	1964-04-21	1964-04-21 00:00:00	32020		\N	87287	0	10509002	260139		0
32743	1946	4113008	1975-01-29	1975-01-29 00:00:00	1975-02-19	1975-02-19 00:00:00	32020		\N	129276	0	284549007	4113008		0
22359	1334	81151	1969-12-20	1969-12-20 00:00:00	1970-01-17	1970-01-17 00:00:00	32020		\N	88528	0	44465007	81151		0
22563	1348	260139	1931-07-07	1931-07-07 00:00:00	1931-07-14	1931-07-14 00:00:00	32020		\N	89341	0	10509002	260139		0
22703	1355	4296204	2007-01-16	2007-01-16 00:00:00	2007-01-30	2007-01-30 00:00:00	32020		\N	89860	0	403190006	4296204		0
22883	1365	372328	1975-10-26	1975-10-26 00:00:00	1976-09-16	1976-09-16 00:00:00	32020		\N	90466	0	65363002	372328		0
22991	1371	4112343	1978-12-17	1978-12-17 00:00:00	1978-12-25	1978-12-25 00:00:00	32020		\N	90937	0	195662009	4112343		0
23159	1382	40481087	1985-12-17	1985-12-17 00:00:00	1985-12-31	1985-12-31 00:00:00	32020		\N	91642	0	444814009	40481087		0
23355	1391	372328	1924-07-29	1924-07-29 00:00:00	1924-09-09	1924-09-09 00:00:00	32020		\N	92331	0	65363002	372328		0
23569	1408	4156265	1972-09-24	1972-09-24 00:00:00	1972-10-08	1972-10-08 00:00:00	32020		\N	93621	0	370247008	4156265		0
23695	1412	80180	1997-05-24	1997-05-24 00:00:00	\N	\N	32020		\N	94059	0	396275006	80180		0
34403	2041	4112343	1974-05-31	1974-05-31 00:00:00	1974-06-13	1974-06-13 00:00:00	32020		\N	135789	0	195662009	4112343		0
23994	1432	40481087	1999-01-23	1999-01-23 00:00:00	1999-02-13	1999-02-13 00:00:00	32020		\N	95416	0	444814009	40481087		0
34742	2062	4283893	2015-06-12	2015-06-12 00:00:00	2015-07-31	2015-07-31 00:00:00	32020		\N	137187	0	36971009	4283893		0
34902	2073	260139	1987-09-25	1987-09-25 00:00:00	1987-10-02	1987-10-02 00:00:00	32020		\N	137887	0	10509002	260139		0
24495	1461	40481087	2016-09-11	2016-09-11 00:00:00	2016-09-25	2016-09-25 00:00:00	32020		\N	97328	0	444814009	40481087		0
24699	1475	4112343	2002-01-06	2002-01-06 00:00:00	2002-01-15	2002-01-15 00:00:00	32020		\N	98261	0	195662009	4112343		0
35396	2097	4296204	1998-10-23	1998-10-23 00:00:00	1998-11-27	1998-11-27 00:00:00	32020		\N	139810	0	403190006	4296204		0
25061	1496	4134304	1979-08-29	1979-08-29 00:00:00	1979-10-28	1979-10-28 00:00:00	32020		\N	99741	0	263102004	4134304		0
25187	1504	4059173	1959-06-20	1959-06-20 00:00:00	1959-09-18	1959-09-18 00:00:00	32020		\N	100217	0	16114001	4059173		0
25322	1510	260139	2005-09-05	2005-09-05 00:00:00	2005-09-12	2005-09-12 00:00:00	32020		\N	100861	0	10509002	260139		0
36028	2135	257012	2000-02-09	2000-02-09 00:00:00	\N	\N	32020		\N	142039	0	40055000	257012		0
25727	1528	372328	1964-06-25	1964-06-25 00:00:00	1964-12-25	1964-12-25 00:00:00	32020		\N	102214	0	65363002	372328		0
36364	2152	440448	1962-02-03	1962-02-03 00:00:00	\N	\N	32020		\N	143417	0	74400008	440448		0
26048	1545	78272	1992-12-30	1992-12-30 00:00:00	1993-01-27	1993-01-27 00:00:00	32020		\N	103509	0	70704007	78272		0
26224	1556	40486433	1977-04-04	1977-04-04 00:00:00	1993-07-15	1993-07-15 00:00:00	32020		\N	104271	0	446096008	40486433		0
26385	1566	260139	1985-05-04	1985-05-04 00:00:00	1985-05-11	1985-05-11 00:00:00	32020		\N	105058	0	10509002	260139		0
26466	1569	4116491	1976-10-14	1976-10-14 00:00:00	1976-12-02	1976-12-02 00:00:00	32020		\N	105256	0	301011002	4116491		0
26675	1579	317576	2017-02-23	2017-02-23 00:00:00	\N	\N	32020		\N	106043	0	53741008	317576		0
26869	1590	80180	1999-02-07	1999-02-07 00:00:00	\N	\N	32020		\N	106745	0	396275006	80180		0
27007	1598	260139	2011-06-19	2011-06-19 00:00:00	2011-07-03	2011-07-03 00:00:00	32020		\N	107247	0	10509002	260139		0
27154	1605	80180	1971-08-09	1971-08-09 00:00:00	\N	\N	32020		\N	107743	0	396275006	80180		0
27374	1613	260139	1959-12-17	1959-12-17 00:00:00	1959-12-24	1959-12-24 00:00:00	32020		\N	108480	0	10509002	260139		0
38068	2260	40481087	2013-03-15	2013-03-15 00:00:00	2013-04-05	2013-04-05 00:00:00	32020		\N	150199	0	444814009	40481087		0
27713	1635	81893	2010-04-02	2010-04-02 00:00:00	\N	\N	32020		\N	109802	0	64766004	81893		0
38418	2283	260139	1960-01-15	1960-01-15 00:00:00	1960-01-29	1960-01-29 00:00:00	32020		\N	151878	0	10509002	260139		0
38572	2290	260139	1992-07-02	1992-07-02 00:00:00	1992-07-09	1992-07-09 00:00:00	32020		\N	152315	0	10509002	260139		0
28175	1662	4294548	1999-03-04	1999-03-04 00:00:00	1999-05-27	1999-05-27 00:00:00	32020		\N	111718	0	75498004	4294548		0
28376	1677	4112343	2000-07-11	2000-07-11 00:00:00	2000-07-18	2000-07-18 00:00:00	32020		\N	112528	0	195662009	4112343		0
39030	2319	28060	1964-05-17	1964-05-17 00:00:00	1964-05-28	1964-05-28 00:00:00	32020		\N	154195	0	43878008	28060		0
28633	1695	40481087	1990-03-06	1990-03-06 00:00:00	1990-03-27	1990-03-27 00:00:00	32020		\N	113472	0	444814009	40481087		0
39346	2333	4112343	1926-12-11	1926-12-11 00:00:00	1926-12-23	1926-12-23 00:00:00	32020		\N	155222	0	195662009	4112343		0
28986	1716	40479768	2009-06-24	2009-06-24 00:00:00	2009-07-31	2009-07-31 00:00:00	32020		\N	114708	0	444470001	40479768		0
29187	1727	4156265	2012-11-06	2012-11-06 00:00:00	2012-11-27	2012-11-27 00:00:00	32020		\N	115474	0	370247008	4156265		0
29352	1738	4112343	1975-09-07	1975-09-07 00:00:00	1975-09-16	1975-09-16 00:00:00	32020		\N	116130	0	195662009	4112343		0
29488	1746	4112343	1987-02-25	1987-02-25 00:00:00	1987-03-04	1987-03-04 00:00:00	32020		\N	116795	0	195662009	4112343		0
29656	1755	40481087	1966-10-13	1966-10-13 00:00:00	1966-10-27	1966-10-27 00:00:00	32020		\N	117383	0	444814009	40481087		0
29796	1762	40481087	1996-01-16	1996-01-16 00:00:00	1996-01-23	1996-01-23 00:00:00	32020		\N	117893	0	444814009	40481087		0
30039	1778	30753	2016-11-29	2016-11-29 00:00:00	\N	\N	32020		\N	118936	0	16761005	30753		0
40678	2418	40481087	2005-12-04	2005-12-04 00:00:00	2005-12-11	2005-12-11 00:00:00	32020		\N	160455	0	444814009	40481087		0
30354	1791	80180	1992-01-05	1992-01-05 00:00:00	\N	\N	32020		\N	120103	0	396275006	80180		0
41090	2442	81893	2006-03-04	2006-03-04 00:00:00	\N	\N	32020		\N	162013	0	64766004	81893		0
30697	1814	196456	2018-04-03	2018-04-03 00:00:00	2018-04-03	2018-04-03 00:00:00	32020		\N	121406	0	235919008	196456		0
41339	2458	4112343	1985-03-20	1985-03-20 00:00:00	1985-04-01	1985-04-01 00:00:00	32020		\N	162967	0	195662009	4112343		0
31020	1837	40481087	2001-11-25	2001-11-25 00:00:00	2001-12-16	2001-12-16 00:00:00	32020		\N	122716	0	444814009	40481087		0
31182	1846	80180	1987-11-09	1987-11-09 00:00:00	\N	\N	32020		\N	123439	0	396275006	80180		0
31331	1852	4112343	2017-06-01	2017-06-01 00:00:00	2017-06-10	2017-06-10 00:00:00	32020		\N	123879	0	195662009	4112343		0
42006	2501	40481087	2015-10-02	2015-10-02 00:00:00	2015-10-16	2015-10-16 00:00:00	32020		\N	165554	0	444814009	40481087		0
31693	1878	4112343	1990-03-12	1990-03-12 00:00:00	1990-03-21	1990-03-21 00:00:00	32020		\N	125321	0	195662009	4112343		0
42374	2524	4112343	1970-12-08	1970-12-08 00:00:00	1970-12-15	1970-12-15 00:00:00	32020		\N	166901	0	195662009	4112343		0
21389	1283	4112343	1960-11-17	1960-11-17 00:00:00	1960-11-25	1960-11-25 00:00:00	32020		\N	84796	0	195662009	4112343		0
32084	1905	195588	2006-02-08	2006-02-08 00:00:00	2006-03-16	2006-03-16 00:00:00	32020		\N	126817	0	38822007	195588		0
32233	1915	4112343	2011-12-18	2011-12-18 00:00:00	2011-12-27	2011-12-27 00:00:00	32020		\N	127381	0	195662009	4112343		0
32399	1925	195588	2000-01-07	2000-01-07 00:00:00	2000-02-12	2000-02-12 00:00:00	32020		\N	128144	0	38822007	195588		0
21997	1317	4296205	1963-03-16	1963-03-16 00:00:00	1963-04-06	1963-04-06 00:00:00	32020		\N	87275	0	403191005	4296205		0
32744	1946	40481087	1942-01-08	1942-01-08 00:00:00	1942-01-15	1942-01-15 00:00:00	32020		\N	129332	0	444814009	40481087		0
29819	1764	30753	1995-07-21	1995-07-21 00:00:00	\N	\N	32020		\N	117957	0	16761005	30753		0
22360	1334	40481087	1971-05-18	1971-05-18 00:00:00	1971-06-01	1971-06-01 00:00:00	32020		\N	88523	0	444814009	40481087		0
22564	1348	4156265	1977-12-01	1977-12-01 00:00:00	1977-12-22	1977-12-22 00:00:00	32020		\N	89373	0	370247008	4156265		0
22704	1355	260139	1995-11-07	1995-11-07 00:00:00	1995-11-14	1995-11-14 00:00:00	32020		\N	89856	0	10509002	260139		0
22884	1365	4056621	1993-10-19	1993-10-19 00:00:00	\N	\N	32020		\N	90505	0	197927001	4056621		0
22992	1371	378001	1979-10-03	1979-10-03 00:00:00	1979-11-02	1979-11-02 00:00:00	32020		\N	90894	0	62106007	378001		0
23160	1382	40481087	2008-03-08	2008-03-08 00:00:00	2008-03-22	2008-03-22 00:00:00	32020		\N	91617	0	444814009	40481087		0
23356	1391	378001	1960-09-05	1960-09-05 00:00:00	1960-10-05	1960-10-05 00:00:00	32020		\N	92393	0	62106007	378001		0
23570	1408	4112343	2005-10-27	2005-10-27 00:00:00	2005-11-04	2005-11-04 00:00:00	32020		\N	93653	0	195662009	4112343		0
23696	1412	260139	2006-11-05	2006-11-05 00:00:00	2006-11-19	2006-11-19 00:00:00	32020		\N	93985	0	10509002	260139		0
34404	2041	372328	1968-02-18	1968-02-18 00:00:00	1969-02-04	1969-02-04 00:00:00	32020		\N	135845	0	65363002	372328		0
23995	1432	40481087	1993-04-09	1993-04-09 00:00:00	1993-04-30	1993-04-30 00:00:00	32020		\N	95411	0	444814009	40481087		0
34743	2062	81151	1964-04-10	1964-04-10 00:00:00	1964-04-24	1964-04-24 00:00:00	32020		\N	137196	0	44465007	81151		0
34903	2073	378001	1980-06-06	1980-06-06 00:00:00	1980-07-06	1980-07-06 00:00:00	32020		\N	137885	0	62106007	378001		0
24496	1461	4156265	1994-09-30	1994-09-30 00:00:00	1994-10-21	1994-10-21 00:00:00	32020		\N	97353	0	370247008	4156265		0
24700	1475	80502	2005-02-17	2005-02-17 00:00:00	\N	\N	32020		\N	98302	0	64859006	80502		0
35397	2097	260139	1982-09-06	1982-09-06 00:00:00	1982-09-20	1982-09-20 00:00:00	32020		\N	139767	0	10509002	260139		0
25062	1496	40481087	1984-09-12	1984-09-12 00:00:00	1984-09-19	1984-09-19 00:00:00	32020		\N	99647	0	444814009	40481087		0
25188	1504	4112343	1987-10-05	1987-10-05 00:00:00	1987-10-13	1987-10-13 00:00:00	32020		\N	100276	0	195662009	4112343		0
25323	1510	40481087	1998-05-11	1998-05-11 00:00:00	1998-06-01	1998-06-01 00:00:00	32020		\N	100774	0	444814009	40481087		0
36029	2135	4116491	1991-01-22	1991-01-22 00:00:00	1991-03-08	1991-03-08 00:00:00	32020		\N	142172	0	301011002	4116491		0
25728	1528	80180	2001-11-14	2001-11-14 00:00:00	\N	\N	32020		\N	102257	0	396275006	80180		0
36365	2152	4166224	1962-02-03	1962-02-03 00:00:00	\N	\N	32020		\N	143417	0	47693006	4166224		0
26049	1545	4278672	2000-12-16	2000-12-16 00:00:00	2001-02-14	2001-02-14 00:00:00	32020		\N	103511	0	65966004	4278672		0
26225	1556	4155034	2011-08-12	2011-08-12 00:00:00	2011-08-26	2011-08-26 00:00:00	32020		\N	104151	0	283371005	4155034		0
26386	1566	40481087	2018-02-07	2018-02-07 00:00:00	2018-02-14	2018-02-14 00:00:00	32020		\N	104998	0	444814009	40481087		0
26467	1569	40481087	1956-11-25	1956-11-25 00:00:00	1956-12-09	1956-12-09 00:00:00	32020		\N	105295	0	444814009	40481087		0
26676	1579	192671	1988-05-25	1988-05-25 00:00:00	\N	\N	32020		\N	106105	0	K92.2	35208414		0
26870	1590	4146173	2005-10-09	2005-10-09 00:00:00	2005-11-07	2005-11-07 00:00:00	32020		\N	106718	0	307731004	4146173		0
27008	1598	40481087	1990-03-18	1990-03-18 00:00:00	1990-03-25	1990-03-25 00:00:00	32020		\N	107244	0	444814009	40481087		0
27155	1605	317576	2017-10-22	2017-10-22 00:00:00	\N	\N	32020		\N	107709	0	53741008	317576		0
27375	1613	260139	1987-10-28	1987-10-28 00:00:00	1987-11-04	1987-11-04 00:00:00	32020		\N	108439	0	10509002	260139		0
38069	2260	40481087	1986-05-15	1986-05-15 00:00:00	1986-05-29	1986-05-29 00:00:00	32020		\N	150197	0	444814009	40481087		0
27714	1635	4027663	1999-10-12	1999-10-12 00:00:00	\N	\N	32020		\N	109815	0	13200003	4027663		0
38419	2283	378419	2017-11-13	2017-11-13 00:00:00	\N	\N	32020		\N	151856	0	26929004	378419		0
38573	2290	80180	1993-04-08	1993-04-08 00:00:00	\N	\N	32020		\N	152315	0	396275006	80180		0
28176	1662	257012	1999-05-06	1999-05-06 00:00:00	\N	\N	32020		\N	111734	0	40055000	257012		0
28377	1677	4266809	2003-04-20	2003-04-20 00:00:00	\N	\N	32020		\N	112481	0	397881000	4266809		0
39031	2319	40481087	2018-08-19	2018-08-19 00:00:00	2018-09-09	2018-09-09 00:00:00	32020		\N	154230	0	444814009	40481087		0
28634	1695	4116491	2018-03-15	2018-03-15 00:00:00	2018-05-08	2018-05-08 00:00:00	32020		\N	113492	0	301011002	4116491		0
39347	2333	313217	1990-04-17	1990-04-17 00:00:00	\N	\N	32020		\N	155231	0	49436004	313217		0
28987	1716	4112343	1969-11-22	1969-11-22 00:00:00	1969-12-02	1969-12-02 00:00:00	32020		\N	114735	0	195662009	4112343		0
29188	1727	40481087	2017-03-30	2017-03-30 00:00:00	2017-04-06	2017-04-06 00:00:00	32020		\N	115430	0	444814009	40481087		0
29353	1738	4112343	2005-11-29	2005-11-29 00:00:00	2005-12-09	2005-12-09 00:00:00	32020		\N	116151	0	195662009	4112343		0
29489	1746	80180	1988-04-23	1988-04-23 00:00:00	\N	\N	32020		\N	116795	0	396275006	80180		0
29657	1755	260139	1990-08-22	1990-08-22 00:00:00	1990-09-05	1990-09-05 00:00:00	32020		\N	117385	0	10509002	260139		0
29797	1762	40481087	1984-01-30	1984-01-30 00:00:00	1984-02-13	1984-02-13 00:00:00	32020		\N	117849	0	444814009	40481087		0
30040	1778	80180	2017-09-25	2017-09-25 00:00:00	\N	\N	32020		\N	118936	0	396275006	80180		0
40679	2418	78272	1979-02-10	1979-02-10 00:00:00	1979-02-24	1979-02-24 00:00:00	32020		\N	160439	0	70704007	78272		0
30355	1791	40481087	1991-11-02	1991-11-02 00:00:00	1991-11-23	1991-11-23 00:00:00	32020		\N	120103	0	444814009	40481087		0
41091	2442	40481087	1981-06-10	1981-06-10 00:00:00	1981-07-01	1981-07-01 00:00:00	32020		\N	162011	0	444814009	40481087		0
30698	1814	198809	2018-04-03	2018-04-03 00:00:00	2018-04-03	2018-04-03 00:00:00	32020		\N	121406	0	65275009	198809		0
41340	2458	375671	1986-03-29	1986-03-29 00:00:00	1986-05-28	1986-05-28 00:00:00	32020		\N	162942	0	62564004	375671		0
31021	1837	260139	1990-04-23	1990-04-23 00:00:00	1990-04-30	1990-04-30 00:00:00	32020		\N	122669	0	10509002	260139		0
31183	1846	40481087	1984-03-01	1984-03-01 00:00:00	1984-03-08	1984-03-08 00:00:00	32020		\N	123459	0	444814009	40481087		0
31332	1852	40481087	2003-12-19	2003-12-19 00:00:00	2004-01-09	2004-01-09 00:00:00	32020		\N	123989	0	444814009	40481087		0
42007	2501	40481087	2010-01-02	2010-01-02 00:00:00	2010-01-23	2010-01-23 00:00:00	32020		\N	165531	0	444814009	40481087		0
31694	1878	81151	1976-02-08	1976-02-08 00:00:00	1976-02-29	1976-02-29 00:00:00	32020		\N	125347	0	44465007	81151		0
42375	2525	40481087	2011-12-11	2011-12-11 00:00:00	2011-12-18	2011-12-18 00:00:00	32020		\N	166954	0	444814009	40481087		0
21390	1283	40481087	1992-08-16	1992-08-16 00:00:00	1992-08-23	1992-08-23 00:00:00	32020		\N	84849	0	444814009	40481087		0
32085	1905	4296204	1997-12-02	1997-12-02 00:00:00	1997-12-16	1997-12-16 00:00:00	32020		\N	126840	0	403190006	4296204		0
32234	1915	372328	2013-04-02	2013-04-02 00:00:00	2014-03-11	2014-03-11 00:00:00	32020		\N	127343	0	65363002	372328		0
32400	1925	4112343	1985-12-11	1985-12-11 00:00:00	1985-12-24	1985-12-24 00:00:00	32020		\N	128126	0	195662009	4112343		0
21998	1317	40481087	1958-04-06	1958-04-06 00:00:00	1958-04-20	1958-04-20 00:00:00	32020		\N	87244	0	444814009	40481087		0
32745	1946	28060	1936-09-13	1936-09-13 00:00:00	1936-09-25	1936-09-25 00:00:00	32020		\N	129358	0	43878008	28060		0
22361	1334	4112343	1997-10-11	1997-10-11 00:00:00	1997-10-19	1997-10-19 00:00:00	32020		\N	88524	0	195662009	4112343		0
22565	1348	81151	1932-12-06	1932-12-06 00:00:00	1932-12-27	1932-12-27 00:00:00	32020		\N	89371	0	44465007	81151		0
22705	1355	40481087	2009-04-22	2009-04-22 00:00:00	2009-04-29	2009-04-29 00:00:00	32020		\N	89841	0	444814009	40481087		0
22885	1365	195588	1993-10-19	1993-10-19 00:00:00	1993-11-27	1993-11-27 00:00:00	32020		\N	90505	0	38822007	195588		0
22993	1371	28060	2009-05-22	2009-05-22 00:00:00	2009-05-29	2009-05-29 00:00:00	32020		\N	90902	0	43878008	28060		0
23161	1382	260139	1985-06-16	1985-06-16 00:00:00	1985-06-30	1985-06-30 00:00:00	32020		\N	91616	0	10509002	260139		0
23357	1391	4155034	1999-04-14	1999-04-14 00:00:00	1999-04-28	1999-04-28 00:00:00	32020		\N	92410	0	283371005	4155034		0
23571	1408	40481087	1959-04-06	1959-04-06 00:00:00	1959-04-27	1959-04-27 00:00:00	32020		\N	93637	0	444814009	40481087		0
23697	1412	4109685	1970-06-25	1970-06-25 00:00:00	1970-07-09	1970-07-09 00:00:00	32020		\N	94034	0	284551006	4109685		0
34405	2041	40481087	1984-06-15	1984-06-15 00:00:00	1984-06-29	1984-06-29 00:00:00	32020		\N	135812	0	444814009	40481087		0
23996	1432	4112343	1962-11-24	1962-11-24 00:00:00	1962-12-05	1962-12-05 00:00:00	32020		\N	95391	0	195662009	4112343		0
34744	2062	372328	1948-04-08	1948-04-08 00:00:00	1948-05-22	1948-05-22 00:00:00	32020		\N	137151	0	65363002	372328		0
34904	2073	4142905	1979-05-13	1979-05-13 00:00:00	1979-06-12	1979-06-12 00:00:00	32020		\N	137884	0	33737001	4142905		0
24497	1461	28060	2005-05-20	2005-05-20 00:00:00	2005-06-01	2005-06-01 00:00:00	32020		\N	97327	0	43878008	28060		0
24701	1475	40481087	1985-02-20	1985-02-20 00:00:00	1985-02-27	1985-02-27 00:00:00	32020		\N	98258	0	444814009	40481087		0
35398	2097	4152936	1993-02-07	1993-02-07 00:00:00	1993-02-21	1993-02-21 00:00:00	32020		\N	139808	0	283385000	4152936		0
25063	1496	4112343	1993-08-19	1993-08-19 00:00:00	1993-08-29	1993-08-29 00:00:00	32020		\N	99649	0	195662009	4112343		0
25189	1504	40481087	1979-10-02	1979-10-02 00:00:00	1979-10-16	1979-10-16 00:00:00	32020		\N	100240	0	444814009	40481087		0
25324	1510	40481087	2019-02-26	2019-02-26 00:00:00	2019-03-05	2019-03-05 00:00:00	32020		\N	100812	0	444814009	40481087		0
36030	2135	4294548	2000-01-12	2000-01-12 00:00:00	2000-03-08	2000-03-08 00:00:00	32020		\N	142107	0	75498004	4294548		0
25729	1528	4112343	1989-12-13	1989-12-13 00:00:00	1989-12-21	1989-12-21 00:00:00	32020		\N	102211	0	195662009	4112343		0
36366	2152	260139	1972-11-25	1972-11-25 00:00:00	1972-12-09	1972-12-09 00:00:00	32020		\N	143424	0	10509002	260139		0
26050	1545	40481087	2013-05-13	2013-05-13 00:00:00	2013-05-27	2013-05-27 00:00:00	32020		\N	103504	0	444814009	40481087		0
26226	1556	40481087	2015-01-07	2015-01-07 00:00:00	2015-01-21	2015-01-21 00:00:00	32020		\N	104157	0	444814009	40481087		0
26387	1566	4112343	1972-08-12	1972-08-12 00:00:00	1972-08-24	1972-08-24 00:00:00	32020		\N	104994	0	195662009	4112343		0
26468	1569	40481087	1976-12-14	1976-12-14 00:00:00	1977-01-04	1977-01-04 00:00:00	32020		\N	105257	0	444814009	40481087		0
26677	1579	28060	1989-03-10	1989-03-10 00:00:00	1989-03-20	1989-03-20 00:00:00	32020		\N	106089	0	43878008	28060		0
26892	1593	28060	1935-06-12	1935-06-12 00:00:00	1935-06-21	1935-06-21 00:00:00	32020		\N	106823	0	43878008	28060		0
27009	1598	40481087	1987-11-17	1987-11-17 00:00:00	1987-11-24	1987-11-24 00:00:00	32020		\N	107250	0	444814009	40481087		0
27156	1605	40481087	2002-12-29	2002-12-29 00:00:00	2003-01-05	2003-01-05 00:00:00	32020		\N	107680	0	444814009	40481087		0
27376	1613	4112343	1981-07-31	1981-07-31 00:00:00	1981-08-13	1981-08-13 00:00:00	32020		\N	108457	0	195662009	4112343		0
38070	2260	40481087	1944-07-31	1944-07-31 00:00:00	1944-08-14	1944-08-14 00:00:00	32020		\N	150178	0	444814009	40481087		0
27715	1635	4112343	2019-05-01	2019-05-01 00:00:00	2019-05-14	2019-05-14 00:00:00	32020		\N	109804	0	195662009	4112343		0
38420	2283	260139	2001-08-07	2001-08-07 00:00:00	2001-08-14	2001-08-14 00:00:00	32020		\N	151910	0	10509002	260139		0
38574	2290	4112343	1959-01-18	1959-01-18 00:00:00	1959-01-28	1959-01-28 00:00:00	32020		\N	152325	0	195662009	4112343		0
28177	1662	80180	1999-05-24	1999-05-24 00:00:00	\N	\N	32020		\N	111734	0	396275006	80180		0
28378	1677	30753	2002-02-24	2002-02-24 00:00:00	\N	\N	32020		\N	112481	0	16761005	30753		0
39032	2319	4156265	1967-06-14	1967-06-14 00:00:00	1967-07-05	1967-07-05 00:00:00	32020		\N	154134	0	370247008	4156265		0
28635	1695	4056621	2018-03-15	2018-03-15 00:00:00	\N	\N	32020		\N	113492	0	197927001	4056621		0
39348	2333	260139	1926-02-01	1926-02-01 00:00:00	1926-02-08	1926-02-08 00:00:00	32020		\N	155257	0	10509002	260139		0
28988	1716	40481087	1971-03-22	1971-03-22 00:00:00	1971-04-05	1971-04-05 00:00:00	32020		\N	114618	0	444814009	40481087		0
29189	1727	4283893	1973-06-26	1973-06-26 00:00:00	1973-07-17	1973-07-17 00:00:00	32020		\N	115522	0	36971009	4283893		0
29354	1738	80180	2013-02-27	2013-02-27 00:00:00	\N	\N	32020		\N	116127	0	396275006	80180		0
29490	1746	4112343	1970-10-26	1970-10-26 00:00:00	1970-11-06	1970-11-06 00:00:00	32020		\N	116715	0	195662009	4112343		0
29658	1755	40481087	1975-04-19	1975-04-19 00:00:00	1975-05-03	1975-05-03 00:00:00	32020		\N	117384	0	444814009	40481087		0
29798	1762	192671	1979-12-16	1979-12-16 00:00:00	\N	\N	32020		\N	117862	0	K92.2	35208414		0
30041	1778	40481087	2016-11-16	2016-11-16 00:00:00	2016-12-07	2016-12-07 00:00:00	32020		\N	118936	0	444814009	40481087		0
40680	2418	40481087	1984-04-13	1984-04-13 00:00:00	1984-04-27	1984-04-27 00:00:00	32020		\N	160424	0	444814009	40481087		0
30356	1791	372328	1957-01-13	1957-01-13 00:00:00	1957-05-02	1957-05-02 00:00:00	32020		\N	120027	0	65363002	372328		0
41092	2443	4237458	1979-10-26	1979-10-26 00:00:00	1979-12-24	1979-12-24 00:00:00	32020		\N	162034	0	58150001	4237458		0
30699	1814	372328	1941-09-12	1941-09-12 00:00:00	1941-09-26	1941-09-26 00:00:00	32020		\N	121419	0	65363002	372328		0
41341	2458	4112343	1972-09-11	1972-09-11 00:00:00	1972-09-21	1972-09-21 00:00:00	32020		\N	162957	0	195662009	4112343		0
31022	1837	4059173	1976-05-17	1976-05-17 00:00:00	1976-06-16	1976-06-16 00:00:00	32020		\N	122694	0	16114001	4059173		0
31184	1846	4027663	1979-12-21	1979-12-21 00:00:00	\N	\N	32020		\N	123437	0	13200003	4027663		0
31333	1852	4283893	1975-09-28	1975-09-28 00:00:00	1975-10-26	1975-10-26 00:00:00	32020		\N	123887	0	36971009	4283893		0
42008	2501	4156265	1962-10-23	1962-10-23 00:00:00	1962-11-06	1962-11-06 00:00:00	32020		\N	165573	0	370247008	4156265		0
31695	1878	372328	1980-05-01	1980-05-01 00:00:00	1981-02-28	1981-02-28 00:00:00	32020		\N	125337	0	65363002	372328		0
42376	2525	4112343	1987-06-28	1987-06-28 00:00:00	1987-07-06	1987-07-06 00:00:00	32020		\N	166968	0	195662009	4112343		0
21391	1283	80180	1998-06-24	1998-06-24 00:00:00	\N	\N	32020		\N	84817	0	396275006	80180		0
32086	1905	260139	2018-01-20	2018-01-20 00:00:00	2018-02-03	2018-02-03 00:00:00	32020		\N	126808	0	10509002	260139		0
32235	1915	40481087	1987-06-14	1987-06-14 00:00:00	1987-06-28	1987-06-28 00:00:00	32020		\N	127390	0	444814009	40481087		0
32401	1925	40481087	1998-12-05	1998-12-05 00:00:00	1998-12-19	1998-12-19 00:00:00	32020		\N	128133	0	444814009	40481087		0
21999	1317	317576	2009-12-25	2009-12-25 00:00:00	\N	\N	32020		\N	87331	0	53741008	317576		0
32746	1946	4237458	2008-10-23	2008-10-23 00:00:00	2008-11-22	2008-11-22 00:00:00	32020		\N	129278	0	58150001	4237458		0
22362	1335	4112343	1983-07-14	1983-07-14 00:00:00	1983-07-22	1983-07-22 00:00:00	32020		\N	88605	0	195662009	4112343		0
22566	1348	40481087	1918-03-03	1918-03-03 00:00:00	1918-03-17	1918-03-17 00:00:00	32020		\N	89279	0	444814009	40481087		0
22706	1355	372328	1966-11-22	1966-11-22 00:00:00	1967-03-24	1967-03-24 00:00:00	32020		\N	89809	0	65363002	372328		0
22886	1365	440086	1977-08-18	1977-08-18 00:00:00	1980-10-16	1980-10-16 00:00:00	32020		\N	90467	0	192127007	440086		0
23042	1376	40481087	1996-08-18	1996-08-18 00:00:00	1996-09-08	1996-09-08 00:00:00	32020		\N	91221	0	444814009	40481087		0
23176	1384	40481087	1983-02-14	1983-02-14 00:00:00	1983-02-28	1983-02-28 00:00:00	32020		\N	91747	0	444814009	40481087		0
23358	1391	40481087	1966-09-16	1966-09-16 00:00:00	1966-10-07	1966-10-07 00:00:00	32020		\N	92399	0	444814009	40481087		0
23572	1408	40481087	2018-09-19	2018-09-19 00:00:00	2018-09-26	2018-09-26 00:00:00	32020		\N	93654	0	444814009	40481087		0
23717	1415	28060	1984-05-12	1984-05-12 00:00:00	1984-05-19	1984-05-19 00:00:00	32020		\N	94195	0	43878008	28060		0
34406	2041	80180	2007-07-09	2007-07-09 00:00:00	\N	\N	32020		\N	135867	0	396275006	80180		0
23997	1432	40481087	2005-11-11	2005-11-11 00:00:00	2005-11-18	2005-11-18 00:00:00	32020		\N	95418	0	444814009	40481087		0
34745	2062	4294548	1950-12-29	1950-12-29 00:00:00	1951-01-05	1951-01-05 00:00:00	32020		\N	137164	0	75498004	4294548		0
34905	2073	28060	2015-07-08	2015-07-08 00:00:00	2015-07-17	2015-07-17 00:00:00	32020		\N	137925	0	43878008	28060		0
24498	1461	372328	1969-07-13	1969-07-13 00:00:00	1969-10-02	1969-10-02 00:00:00	32020		\N	97376	0	65363002	372328		0
24702	1475	260139	1963-12-30	1963-12-30 00:00:00	1964-01-13	1964-01-13 00:00:00	32020		\N	98220	0	10509002	260139		0
35399	2097	4112343	2010-12-28	2010-12-28 00:00:00	2011-01-05	2011-01-05 00:00:00	32020		\N	139799	0	195662009	4112343		0
25064	1496	40481087	1984-07-29	1984-07-29 00:00:00	1984-08-05	1984-08-05 00:00:00	32020		\N	99699	0	444814009	40481087		0
25190	1504	40481087	1959-09-14	1959-09-14 00:00:00	1959-09-21	1959-09-21 00:00:00	32020		\N	100257	0	444814009	40481087		0
25325	1510	78272	2010-01-29	2010-01-29 00:00:00	2010-02-26	2010-02-26 00:00:00	32020		\N	100793	0	70704007	78272		0
36031	2135	28060	2000-12-30	2000-12-30 00:00:00	2001-01-08	2001-01-08 00:00:00	32020		\N	142108	0	43878008	28060		0
25730	1528	81151	2009-05-14	2009-05-14 00:00:00	2009-05-28	2009-05-28 00:00:00	32020		\N	102242	0	44465007	81151		0
36367	2152	260139	2005-01-26	2005-01-26 00:00:00	2005-02-09	2005-02-09 00:00:00	32020		\N	143427	0	10509002	260139		0
26051	1545	40481087	1992-07-22	1992-07-22 00:00:00	1992-07-29	1992-07-29 00:00:00	32020		\N	103520	0	444814009	40481087		0
36687	2172	4112343	1991-11-11	1991-11-11 00:00:00	1991-11-20	1991-11-20 00:00:00	32020		\N	144666	0	195662009	4112343		0
26388	1566	192671	2003-01-01	2003-01-01 00:00:00	\N	\N	32020		\N	104985	0	K92.2	35208414		0
26469	1569	4112343	1943-06-04	1943-06-04 00:00:00	1943-06-16	1943-06-16 00:00:00	32020		\N	105241	0	195662009	4112343		0
26678	1579	4027663	1980-12-23	1980-12-23 00:00:00	\N	\N	32020		\N	106039	0	13200003	4027663		0
37351	2211	4285898	2006-03-03	2006-03-03 00:00:00	\N	\N	32020		\N	147315	0	68496003	4285898		0
27010	1598	4112343	1984-09-26	1984-09-26 00:00:00	1984-10-07	1984-10-07 00:00:00	32020		\N	107249	0	195662009	4112343		0
27157	1605	4296204	1992-01-16	1992-01-16 00:00:00	1992-02-13	1992-02-13 00:00:00	32020		\N	107749	0	403190006	4296204		0
27377	1613	260139	1961-01-27	1961-01-27 00:00:00	1961-02-03	1961-02-03 00:00:00	32020		\N	108467	0	10509002	260139		0
38071	2260	4112343	1976-03-28	1976-03-28 00:00:00	1976-04-08	1976-04-08 00:00:00	32020		\N	150234	0	195662009	4112343		0
27716	1635	40481087	2019-01-18	2019-01-18 00:00:00	2019-02-01	2019-02-01 00:00:00	32020		\N	109828	0	444814009	40481087		0
38421	2283	260139	1986-06-21	1986-06-21 00:00:00	1986-06-28	1986-06-28 00:00:00	32020		\N	151909	0	10509002	260139		0
38575	2290	4155034	1976-11-13	1976-11-13 00:00:00	1976-11-27	1976-11-27 00:00:00	32020		\N	152336	0	283371005	4155034		0
28178	1662	40481087	1978-04-29	1978-04-29 00:00:00	1978-05-06	1978-05-06 00:00:00	32020		\N	111711	0	444814009	40481087		0
28379	1677	81893	2001-06-29	2001-06-29 00:00:00	\N	\N	32020		\N	112481	0	64766004	81893		0
39033	2319	260139	1995-06-21	1995-06-21 00:00:00	1995-06-28	1995-06-28 00:00:00	32020		\N	154210	0	10509002	260139		0
28636	1695	4294548	1997-10-24	1997-10-24 00:00:00	1997-11-21	1997-11-21 00:00:00	32020		\N	113473	0	75498004	4294548		0
39349	2333	4294548	1926-10-07	1926-10-07 00:00:00	1927-03-17	1927-03-17 00:00:00	32020		\N	155130	0	75498004	4294548		0
28989	1716	4109685	1978-11-13	1978-11-13 00:00:00	1978-12-04	1978-12-04 00:00:00	32020		\N	114704	0	284551006	4109685		0
29190	1727	4152936	1991-06-10	1991-06-10 00:00:00	1991-07-01	1991-07-01 00:00:00	32020		\N	115473	0	283385000	4152936		0
29355	1738	40481087	1976-09-09	1976-09-09 00:00:00	1976-09-16	1976-09-16 00:00:00	32020		\N	116147	0	444814009	40481087		0
29491	1746	260139	1997-05-30	1997-05-30 00:00:00	1997-06-13	1997-06-13 00:00:00	32020		\N	116781	0	10509002	260139		0
29659	1755	260139	2010-04-21	2010-04-21 00:00:00	2010-05-05	2010-05-05 00:00:00	32020		\N	117345	0	10509002	260139		0
29799	1762	40481087	2017-10-13	2017-10-13 00:00:00	2017-11-03	2017-11-03 00:00:00	32020		\N	117808	0	444814009	40481087		0
30042	1778	4285898	2017-03-29	2017-03-29 00:00:00	\N	\N	32020		\N	118936	0	68496003	4285898		0
40681	2418	40481087	1975-04-05	1975-04-05 00:00:00	1975-04-26	1975-04-26 00:00:00	32020		\N	160422	0	444814009	40481087		0
30357	1791	4112343	1966-02-19	1966-02-19 00:00:00	1966-03-03	1966-03-03 00:00:00	32020		\N	120085	0	195662009	4112343		0
41093	2443	4152936	2019-02-02	2019-02-02 00:00:00	2019-02-23	2019-02-23 00:00:00	32020		\N	162036	0	283385000	4152936		0
30700	1814	378001	1968-07-22	1968-07-22 00:00:00	1968-09-20	1968-09-20 00:00:00	32020		\N	121430	0	62106007	378001		0
41342	2458	4112343	1973-04-22	1973-04-22 00:00:00	1973-05-05	1973-05-05 00:00:00	32020		\N	162946	0	195662009	4112343		0
31023	1837	4084167	1964-01-23	1964-01-23 00:00:00	1964-01-23	1964-01-23 00:00:00	32020		\N	122691	0	241929008	4084167		0
31185	1846	4059173	2018-01-26	2018-01-26 00:00:00	2018-02-25	2018-02-25 00:00:00	32020		\N	123470	0	16114001	4059173		0
31334	1852	257012	2010-08-23	2010-08-23 00:00:00	2011-12-29	2011-12-29 00:00:00	32020		\N	123876	0	40055000	257012		0
42009	2501	4112343	1987-04-01	1987-04-01 00:00:00	1987-04-10	1987-04-10 00:00:00	32020		\N	165599	0	195662009	4112343		0
31697	1878	372328	1975-12-21	1975-12-21 00:00:00	1976-02-21	1976-02-21 00:00:00	32020		\N	125331	0	65363002	372328		0
42377	2525	4155034	1976-01-24	1976-01-24 00:00:00	1976-02-14	1976-02-14 00:00:00	32020		\N	166975	0	283371005	4155034		0
21392	1283	28060	1975-10-09	1975-10-09 00:00:00	1975-10-19	1975-10-19 00:00:00	32020		\N	84827	0	43878008	28060		0
32087	1905	4112343	1990-08-07	1990-08-07 00:00:00	1990-08-16	1990-08-16 00:00:00	32020		\N	126805	0	195662009	4112343		0
32236	1915	40481087	1999-05-27	1999-05-27 00:00:00	1999-06-17	1999-06-17 00:00:00	32020		\N	127379	0	444814009	40481087		0
32402	1925	4237458	1952-07-12	1952-07-12 00:00:00	1952-08-11	1952-08-11 00:00:00	32020		\N	128082	0	58150001	4237458		0
22000	1317	4112343	2011-09-13	2011-09-13 00:00:00	2011-09-20	2011-09-20 00:00:00	32020		\N	87257	0	195662009	4112343		0
32747	1946	4112343	1960-06-22	1960-06-22 00:00:00	1960-07-04	1960-07-04 00:00:00	32020		\N	129257	0	195662009	4112343		0
22363	1335	4112343	1982-02-04	1982-02-04 00:00:00	1982-02-16	1982-02-16 00:00:00	32020		\N	88561	0	195662009	4112343		0
22567	1348	260139	1988-10-02	1988-10-02 00:00:00	1988-10-18	1988-10-18 00:00:00	32020		\N	89354	0	10509002	260139		0
22707	1355	40481087	1982-09-05	1982-09-05 00:00:00	1982-09-26	1982-09-26 00:00:00	32020		\N	89797	0	444814009	40481087		0
22887	1365	4278672	1996-05-30	1996-05-30 00:00:00	1996-07-29	1996-07-29 00:00:00	32020		\N	90457	0	65966004	4278672		0
23043	1376	4112343	1992-06-26	1992-06-26 00:00:00	1992-07-09	1992-07-09 00:00:00	32020		\N	91182	0	195662009	4112343		0
23177	1384	4134304	1991-03-29	1991-03-29 00:00:00	1991-04-28	1991-04-28 00:00:00	32020		\N	91724	0	263102004	4134304		0
23359	1391	4218389	1947-03-20	1947-03-20 00:00:00	1947-04-17	1947-04-17 00:00:00	32020		\N	92392	0	39848009	4218389		0
34049	2025	40481087	2010-01-31	2010-01-31 00:00:00	2010-02-21	2010-02-21 00:00:00	32020		\N	134700	0	444814009	40481087		0
23718	1415	4278672	2004-06-05	2004-06-05 00:00:00	2004-07-05	2004-07-05 00:00:00	32020		\N	94213	0	65966004	4278672		0
34407	2041	260139	1974-06-13	1974-06-13 00:00:00	1974-06-27	1974-06-27 00:00:00	32020		\N	135790	0	10509002	260139		0
23998	1432	80180	2005-01-30	2005-01-30 00:00:00	\N	\N	32020		\N	95356	0	396275006	80180		0
34746	2063	4283893	1987-01-23	1987-01-23 00:00:00	1987-03-27	1987-03-27 00:00:00	32020		\N	137209	0	36971009	4283893		0
34919	2075	372328	1970-06-20	1970-06-20 00:00:00	1970-11-10	1970-11-10 00:00:00	32020		\N	138034	0	65363002	372328		0
24499	1461	4112343	1968-09-17	1968-09-17 00:00:00	1968-09-29	1968-09-29 00:00:00	32020		\N	97364	0	195662009	4112343		0
24703	1475	40481087	1948-09-13	1948-09-13 00:00:00	1948-10-04	1948-10-04 00:00:00	32020		\N	98269	0	444814009	40481087		0
35400	2097	4294548	1993-06-29	1993-06-29 00:00:00	1993-12-07	1993-12-07 00:00:00	32020		\N	139768	0	75498004	4294548		0
25065	1496	80180	1957-12-25	1957-12-25 00:00:00	\N	\N	32020		\N	99659	0	396275006	80180		0
25191	1504	40481087	2005-06-16	2005-06-16 00:00:00	2005-06-30	2005-06-30 00:00:00	32020		\N	100242	0	444814009	40481087		0
25326	1510	4116491	1995-10-24	1995-10-24 00:00:00	1995-11-25	1995-11-25 00:00:00	32020		\N	100840	0	301011002	4116491		0
36032	2135	40481087	1965-01-09	1965-01-09 00:00:00	1965-01-30	1965-01-30 00:00:00	32020		\N	142070	0	444814009	40481087		0
36189	2145	4113008	1993-10-14	1993-10-14 00:00:00	1993-10-28	1993-10-28 00:00:00	32020		\N	142800	0	284549007	4113008		0
36368	2152	40481087	2013-11-17	2013-11-17 00:00:00	2013-11-24	2013-11-24 00:00:00	32020		\N	143452	0	444814009	40481087		0
26052	1545	40481087	1997-07-10	1997-07-10 00:00:00	1997-07-31	1997-07-31 00:00:00	32020		\N	103494	0	444814009	40481087		0
36688	2172	260139	2004-01-25	2004-01-25 00:00:00	2004-02-08	2004-02-08 00:00:00	32020		\N	144682	0	10509002	260139		0
26389	1566	257012	2010-02-21	2010-02-21 00:00:00	2010-03-14	2010-03-14 00:00:00	32020		\N	105045	0	40055000	257012		0
26470	1569	4296205	2003-12-22	2003-12-22 00:00:00	2004-01-12	2004-01-12 00:00:00	32020		\N	105230	0	403191005	4296205		0
26679	1579	40481087	1976-02-07	1976-02-07 00:00:00	1976-02-21	1976-02-21 00:00:00	32020		\N	106091	0	444814009	40481087		0
37352	2213	40481087	1986-11-07	1986-11-07 00:00:00	1986-11-28	1986-11-28 00:00:00	32020		\N	147419	0	444814009	40481087		0
27011	1598	4112343	1972-08-19	1972-08-19 00:00:00	1972-08-27	1972-08-27 00:00:00	32020		\N	107221	0	195662009	4112343		0
27158	1605	4155034	1948-12-13	1948-12-13 00:00:00	1948-12-27	1948-12-27 00:00:00	32020		\N	107746	0	283371005	4155034		0
27378	1613	260139	1973-03-30	1973-03-30 00:00:00	1973-04-13	1973-04-13 00:00:00	32020		\N	108481	0	10509002	260139		0
38072	2260	4283893	1984-05-22	1984-05-22 00:00:00	1984-11-13	1984-11-13 00:00:00	32020		\N	150196	0	36971009	4283893		0
27717	1635	4112343	1983-03-29	1983-03-29 00:00:00	1983-04-06	1983-04-06 00:00:00	32020		\N	109819	0	195662009	4112343		0
38422	2283	40481087	1946-11-24	1946-11-24 00:00:00	1946-12-08	1946-12-08 00:00:00	32020		\N	151875	0	444814009	40481087		0
38576	2290	260139	1998-06-19	1998-06-19 00:00:00	1998-07-03	1998-07-03 00:00:00	32020		\N	152316	0	10509002	260139		0
28179	1662	40481087	2013-07-18	2013-07-18 00:00:00	2013-07-25	2013-07-25 00:00:00	32020		\N	111719	0	444814009	40481087		0
28380	1677	80180	2003-04-20	2003-04-20 00:00:00	\N	\N	32020		\N	112481	0	396275006	80180		0
39034	2319	40481087	1984-01-25	1984-01-25 00:00:00	1984-02-01	1984-02-01 00:00:00	32020		\N	154219	0	444814009	40481087		0
28637	1695	195588	2017-12-17	2017-12-17 00:00:00	2018-02-08	2018-02-08 00:00:00	32020		\N	113447	0	38822007	195588		0
39350	2333	4112343	1954-04-12	1954-04-12 00:00:00	1954-04-24	1954-04-24 00:00:00	32020		\N	155239	0	195662009	4112343		0
28990	1716	81151	1963-04-14	1963-04-14 00:00:00	1963-05-12	1963-05-12 00:00:00	32020		\N	114700	0	44465007	81151		0
29191	1727	4112343	1985-01-17	1985-01-17 00:00:00	1985-01-24	1985-01-24 00:00:00	32020		\N	115526	0	195662009	4112343		0
29356	1738	40481087	1998-01-11	1998-01-11 00:00:00	1998-01-25	1998-01-25 00:00:00	32020		\N	116150	0	444814009	40481087		0
29492	1746	260139	1964-03-26	1964-03-26 00:00:00	1964-04-02	1964-04-02 00:00:00	32020		\N	116780	0	10509002	260139		0
29660	1755	28060	2000-04-21	2000-04-21 00:00:00	2000-04-29	2000-04-29 00:00:00	32020		\N	117386	0	43878008	28060		0
29800	1762	4112343	1992-01-06	1992-01-06 00:00:00	1992-01-19	1992-01-19 00:00:00	32020		\N	117892	0	195662009	4112343		0
30043	1778	4266809	2017-09-25	2017-09-25 00:00:00	\N	\N	32020		\N	118936	0	397881000	4266809		0
40683	2418	40481087	1988-06-27	1988-06-27 00:00:00	1988-07-18	1988-07-18 00:00:00	32020		\N	160425	0	444814009	40481087		0
30358	1791	378001	1975-02-23	1975-02-23 00:00:00	1975-04-24	1975-04-24 00:00:00	32020		\N	120056	0	62106007	378001		0
41094	2443	80180	1999-04-09	1999-04-09 00:00:00	\N	\N	32020		\N	162057	0	396275006	80180		0
30701	1814	4237458	1949-09-30	1949-09-30 00:00:00	1949-11-29	1949-11-29 00:00:00	32020		\N	121428	0	58150001	4237458		0
41343	2458	40481087	2004-08-29	2004-08-29 00:00:00	2004-09-19	2004-09-19 00:00:00	32020		\N	162959	0	444814009	40481087		0
31024	1837	260139	1961-01-10	1961-01-10 00:00:00	1961-01-17	1961-01-17 00:00:00	32020		\N	122701	0	10509002	260139		0
31186	1846	40481087	1964-05-13	1964-05-13 00:00:00	1964-05-27	1964-05-27 00:00:00	32020		\N	123396	0	444814009	40481087		0
31335	1852	40481087	2016-12-09	2016-12-09 00:00:00	2016-12-23	2016-12-23 00:00:00	32020		\N	123866	0	444814009	40481087		0
42010	2501	40481087	2017-07-14	2017-07-14 00:00:00	2017-08-04	2017-08-04 00:00:00	32020		\N	165540	0	444814009	40481087		0
31698	1878	4112343	1996-08-01	1996-08-01 00:00:00	1996-08-08	1996-08-08 00:00:00	32020		\N	125322	0	195662009	4112343		0
42378	2525	372328	1982-04-22	1982-04-22 00:00:00	1983-01-07	1983-01-07 00:00:00	32020		\N	166956	0	65363002	372328		0
21393	1283	4152936	1993-11-08	1993-11-08 00:00:00	1993-11-22	1993-11-22 00:00:00	32020		\N	84825	0	283385000	4152936		0
32088	1905	260139	1996-12-01	1996-12-01 00:00:00	1996-12-15	1996-12-15 00:00:00	32020		\N	126789	0	10509002	260139		0
32237	1915	40481087	1981-04-17	1981-04-17 00:00:00	1981-05-08	1981-05-08 00:00:00	32020		\N	127372	0	444814009	40481087		0
32403	1925	40481087	1981-08-11	1981-08-11 00:00:00	1981-08-25	1981-08-25 00:00:00	32020		\N	128131	0	444814009	40481087		0
22001	1317	40481087	1977-09-25	1977-09-25 00:00:00	1977-10-09	1977-10-09 00:00:00	32020		\N	87290	0	444814009	40481087		0
32748	1946	4283893	1981-08-26	1981-08-26 00:00:00	1981-11-25	1981-11-25 00:00:00	32020		\N	129320	0	36971009	4283893		0
22364	1335	81151	1987-12-03	1987-12-03 00:00:00	1987-12-17	1987-12-17 00:00:00	32020		\N	88553	0	44465007	81151		0
22568	1348	260139	1947-07-10	1947-07-10 00:00:00	1947-07-24	1947-07-24 00:00:00	32020		\N	89291	0	10509002	260139		0
22708	1355	4112343	2017-10-02	2017-10-02 00:00:00	2017-10-12	2017-10-12 00:00:00	32020		\N	89858	0	195662009	4112343		0
22888	1365	80180	2002-06-28	2002-06-28 00:00:00	\N	\N	32020		\N	90475	0	396275006	80180		0
23044	1376	4112343	2002-07-03	2002-07-03 00:00:00	2002-07-14	2002-07-14 00:00:00	32020		\N	91179	0	195662009	4112343		0
23178	1384	4112343	2015-04-23	2015-04-23 00:00:00	2015-05-05	2015-05-05 00:00:00	32020		\N	91790	0	195662009	4112343		0
23406	1397	4156265	1998-01-12	1998-01-12 00:00:00	1998-01-26	1998-01-26 00:00:00	32020		\N	92838	0	370247008	4156265		0
34050	2025	28060	2012-01-28	2012-01-28 00:00:00	2012-02-05	2012-02-05 00:00:00	32020		\N	134724	0	43878008	28060		0
23719	1415	257012	1976-01-22	1976-01-22 00:00:00	\N	\N	32020		\N	94193	0	40055000	257012		0
34409	2043	4283893	2004-09-08	2004-09-08 00:00:00	2004-11-24	2004-11-24 00:00:00	32020		\N	135874	0	36971009	4283893		0
23999	1432	260139	2018-09-16	2018-09-16 00:00:00	2018-09-23	2018-09-23 00:00:00	32020		\N	95382	0	10509002	260139		0
34747	2063	40481087	2008-01-14	2008-01-14 00:00:00	2008-01-21	2008-01-21 00:00:00	32020		\N	137228	0	444814009	40481087		0
34920	2075	4084167	1967-04-24	1967-04-24 00:00:00	1967-04-24	1967-04-24 00:00:00	32020		\N	137999	0	241929008	4084167		0
24500	1461	40481087	2005-09-10	2005-09-10 00:00:00	2005-10-01	2005-10-01 00:00:00	32020		\N	97365	0	444814009	40481087		0
24704	1475	4296204	2003-02-04	2003-02-04 00:00:00	2003-03-11	2003-03-11 00:00:00	32020		\N	98252	0	403190006	4296204		0
35401	2097	195588	1996-02-29	1996-02-29 00:00:00	1996-04-13	1996-04-13 00:00:00	32020		\N	139777	0	38822007	195588		0
25066	1496	4134304	1994-06-16	1994-06-16 00:00:00	1994-07-16	1994-07-16 00:00:00	32020		\N	99743	0	263102004	4134304		0
25192	1504	4112343	1988-04-11	1988-04-11 00:00:00	1988-04-20	1988-04-20 00:00:00	32020		\N	100277	0	195662009	4112343		0
25327	1510	257012	1995-02-21	1995-02-21 00:00:00	\N	\N	32020		\N	100857	0	40055000	257012		0
36033	2135	40481087	1983-12-07	1983-12-07 00:00:00	1983-12-28	1983-12-28 00:00:00	32020		\N	142183	0	444814009	40481087		0
36190	2145	260139	1968-06-29	1968-06-29 00:00:00	1968-07-13	1968-07-13 00:00:00	32020		\N	142785	0	10509002	260139		0
36369	2152	28060	1924-06-18	1924-06-18 00:00:00	1924-06-27	1924-06-27 00:00:00	32020		\N	143341	0	43878008	28060		0
26053	1545	4152936	2017-04-03	2017-04-03 00:00:00	2017-04-17	2017-04-17 00:00:00	32020		\N	103514	0	283385000	4152936		0
36689	2172	372328	1981-05-11	1981-05-11 00:00:00	1981-09-12	1981-09-12 00:00:00	32020		\N	144684	0	65363002	372328		0
26390	1566	80180	2002-11-10	2002-11-10 00:00:00	\N	\N	32020		\N	105034	0	396275006	80180		0
26471	1569	260139	2005-02-12	2005-02-12 00:00:00	2005-02-26	2005-02-26 00:00:00	32020		\N	105259	0	10509002	260139		0
26680	1579	40481087	1989-06-20	1989-06-20 00:00:00	1989-06-27	1989-06-27 00:00:00	32020		\N	106084	0	444814009	40481087		0
37353	2213	40481087	2008-11-28	2008-11-28 00:00:00	2008-12-05	2008-12-05 00:00:00	32020		\N	147407	0	444814009	40481087		0
27012	1598	260139	2009-09-12	2009-09-12 00:00:00	2009-09-26	2009-09-26 00:00:00	32020		\N	107238	0	10509002	260139		0
27159	1605	40481087	1970-03-16	1970-03-16 00:00:00	1970-04-06	1970-04-06 00:00:00	32020		\N	107754	0	444814009	40481087		0
27379	1613	260139	1979-10-13	1979-10-13 00:00:00	1979-10-20	1979-10-20 00:00:00	32020		\N	108438	0	10509002	260139		0
38073	2260	80180	1983-11-19	1983-11-19 00:00:00	\N	\N	32020		\N	150257	0	396275006	80180		0
27718	1635	80180	2012-02-21	2012-02-21 00:00:00	\N	\N	32020		\N	109803	0	396275006	80180		0
38423	2283	4112343	1948-07-17	1948-07-17 00:00:00	1948-07-29	1948-07-29 00:00:00	32020		\N	151847	0	195662009	4112343		0
38577	2290	372328	1975-05-23	1975-05-23 00:00:00	1976-05-29	1976-05-29 00:00:00	32020		\N	152320	0	65363002	372328		0
28180	1662	4112343	2004-08-27	2004-08-27 00:00:00	2004-09-03	2004-09-03 00:00:00	32020		\N	111735	0	195662009	4112343		0
28381	1677	4112343	1979-09-19	1979-09-19 00:00:00	1979-09-28	1979-09-28 00:00:00	32020		\N	112491	0	195662009	4112343		0
39035	2319	81151	1980-11-23	1980-11-23 00:00:00	1980-12-21	1980-12-21 00:00:00	32020		\N	154135	0	44465007	81151		0
28638	1695	260139	2007-02-27	2007-02-27 00:00:00	2007-03-13	2007-03-13 00:00:00	32020		\N	113440	0	10509002	260139		0
39351	2333	381316	2007-04-03	2007-04-03 00:00:00	\N	\N	32020		\N	155219	0	230690007	381316		0
28991	1716	372328	1951-10-31	1951-10-31 00:00:00	1952-10-17	1952-10-17 00:00:00	32020		\N	114669	0	65363002	372328		0
29192	1727	40481087	2008-01-05	2008-01-05 00:00:00	2008-01-26	2008-01-26 00:00:00	32020		\N	115428	0	444814009	40481087		0
29357	1738	4112343	1974-01-30	1974-01-30 00:00:00	1974-02-10	1974-02-10 00:00:00	32020		\N	116129	0	195662009	4112343		0
29493	1746	40481087	1964-07-22	1964-07-22 00:00:00	1964-08-05	1964-08-05 00:00:00	32020		\N	116807	0	444814009	40481087		0
29661	1755	260139	1969-09-03	1969-09-03 00:00:00	1969-09-10	1969-09-10 00:00:00	32020		\N	117333	0	10509002	260139		0
29801	1762	40481087	1941-10-01	1941-10-01 00:00:00	1941-10-08	1941-10-08 00:00:00	32020		\N	117798	0	444814009	40481087		0
30044	1778	4112343	2012-02-25	2012-02-25 00:00:00	2012-03-07	2012-03-07 00:00:00	32020		\N	118971	0	195662009	4112343		0
40684	2418	4156265	1996-09-20	1996-09-20 00:00:00	1996-10-04	1996-10-04 00:00:00	32020		\N	160467	0	370247008	4156265		0
30359	1791	40481087	2010-08-22	2010-08-22 00:00:00	2010-09-05	2010-09-05 00:00:00	32020		\N	120015	0	444814009	40481087		0
41095	2443	4283893	1995-06-12	1995-06-12 00:00:00	1995-09-25	1995-09-25 00:00:00	32020		\N	162043	0	36971009	4283893		0
30702	1814	4134304	2009-12-12	2009-12-12 00:00:00	2010-02-10	2010-02-10 00:00:00	32020		\N	121432	0	263102004	4134304		0
41344	2458	28060	1975-09-25	1975-09-25 00:00:00	1975-10-08	1975-10-08 00:00:00	32020		\N	162965	0	43878008	28060		0
31025	1837	260139	1980-01-15	1980-01-15 00:00:00	1980-01-29	1980-01-29 00:00:00	32020		\N	122685	0	10509002	260139		0
31187	1846	40481087	2013-08-08	2013-08-08 00:00:00	2013-08-22	2013-08-22 00:00:00	32020		\N	123462	0	444814009	40481087		0
31336	1852	40481087	1977-04-25	1977-04-25 00:00:00	1977-05-16	1977-05-16 00:00:00	32020		\N	123888	0	444814009	40481087		0
42011	2501	4156265	2019-06-04	2019-06-04 00:00:00	2019-06-18	2019-06-18 00:00:00	32020		\N	165578	0	370247008	4156265		0
31699	1878	40481087	1996-07-30	1996-07-30 00:00:00	1996-08-06	1996-08-06 00:00:00	32020		\N	125310	0	444814009	40481087		0
42379	2525	260139	2009-12-26	2009-12-26 00:00:00	2010-01-09	2010-01-09 00:00:00	32020		\N	166977	0	10509002	260139		0
21394	1283	40481087	2000-06-19	2000-06-19 00:00:00	2000-06-26	2000-06-26 00:00:00	32020		\N	84799	0	444814009	40481087		0
32089	1905	40481087	2005-10-27	2005-10-27 00:00:00	2005-11-10	2005-11-10 00:00:00	32020		\N	126790	0	444814009	40481087		0
32238	1915	4294548	1992-10-14	1992-10-14 00:00:00	1992-12-23	1992-12-23 00:00:00	32020		\N	127362	0	75498004	4294548		0
32404	1925	80180	1984-01-31	1984-01-31 00:00:00	\N	\N	32020		\N	128131	0	396275006	80180		0
22002	1317	40481087	1986-12-21	1986-12-21 00:00:00	1987-01-04	1987-01-04 00:00:00	32020		\N	87254	0	444814009	40481087		0
32749	1946	260139	1985-07-21	1985-07-21 00:00:00	1985-08-04	1985-08-04 00:00:00	32020		\N	129274	0	10509002	260139		0
22365	1335	4283893	2010-09-07	2010-09-07 00:00:00	2010-10-05	2010-10-05 00:00:00	32020		\N	88574	0	36971009	4283893		0
22569	1348	40481087	1971-04-20	1971-04-20 00:00:00	1971-05-11	1971-05-11 00:00:00	32020		\N	89293	0	444814009	40481087		0
22709	1355	260139	1968-02-25	1968-02-25 00:00:00	1968-03-03	1968-03-03 00:00:00	32020		\N	89838	0	10509002	260139		0
22907	1367	4146173	1994-01-22	1994-01-22 00:00:00	1994-03-23	1994-03-23 00:00:00	32020		\N	90583	0	307731004	4146173		0
23045	1376	40481087	1993-04-06	1993-04-06 00:00:00	1993-04-27	1993-04-27 00:00:00	32020		\N	91203	0	444814009	40481087		0
23179	1384	28060	1997-08-30	1997-08-30 00:00:00	1997-09-10	1997-09-10 00:00:00	32020		\N	91729	0	43878008	28060		0
33874	2012	260139	2009-11-21	2009-11-21 00:00:00	2009-12-05	2009-12-05 00:00:00	32020		\N	133845	0	10509002	260139		0
34051	2025	4112343	1911-10-21	1911-10-21 00:00:00	1911-11-02	1911-11-02 00:00:00	32020		\N	134768	0	195662009	4112343		0
23720	1415	260139	1995-01-27	1995-01-27 00:00:00	1995-02-03	1995-02-03 00:00:00	32020		\N	94190	0	10509002	260139		0
34410	2043	260139	1973-12-30	1973-12-30 00:00:00	1974-01-06	1974-01-06 00:00:00	32020		\N	135915	0	10509002	260139		0
24000	1432	372328	1963-10-18	1963-10-18 00:00:00	1964-02-04	1964-02-04 00:00:00	32020		\N	95383	0	65363002	372328		0
34748	2063	257012	1987-03-06	1987-03-06 00:00:00	\N	\N	32020		\N	137210	0	40055000	257012		0
34921	2075	378001	2005-07-08	2005-07-08 00:00:00	2005-09-06	2005-09-06 00:00:00	32020		\N	138001	0	62106007	378001		0
24520	1464	4112343	1972-08-23	1972-08-23 00:00:00	1972-09-03	1972-09-03 00:00:00	32020		\N	97511	0	195662009	4112343		0
24705	1475	40481087	1969-12-20	1969-12-20 00:00:00	1970-01-03	1970-01-03 00:00:00	32020		\N	98221	0	444814009	40481087		0
35402	2097	81151	1982-11-04	1982-11-04 00:00:00	1982-12-02	1982-12-02 00:00:00	32020		\N	139807	0	44465007	81151		0
35525	2105	372328	1974-10-17	1974-10-17 00:00:00	1974-11-24	1974-11-24 00:00:00	32020		\N	140245	0	65363002	372328		0
25193	1504	4218389	1986-04-29	1986-04-29 00:00:00	1986-05-27	1986-05-27 00:00:00	32020		\N	100220	0	39848009	4218389		0
25328	1510	260139	1960-05-26	1960-05-26 00:00:00	1960-06-09	1960-06-09 00:00:00	32020		\N	100778	0	10509002	260139		0
36034	2135	4112343	1967-02-16	1967-02-16 00:00:00	1967-02-26	1967-02-26 00:00:00	32020		\N	142071	0	195662009	4112343		0
36191	2145	81151	2015-06-05	2015-06-05 00:00:00	2015-06-19	2015-06-19 00:00:00	32020		\N	142801	0	44465007	81151		0
36370	2152	4112343	1939-03-25	1939-03-25 00:00:00	1939-04-06	1939-04-06 00:00:00	32020		\N	143433	0	195662009	4112343		0
26054	1545	4113008	2012-08-15	2012-08-15 00:00:00	2012-08-29	2012-08-29 00:00:00	32020		\N	103512	0	284549007	4113008		0
36690	2172	4278672	2007-07-07	2007-07-07 00:00:00	2007-09-05	2007-09-05 00:00:00	32020		\N	144702	0	65966004	4278672		0
26391	1566	4051466	1970-11-10	1970-11-10 00:00:00	1987-02-17	1987-02-17 00:00:00	32020		\N	105052	0	233678006	4051466		0
26472	1569	40481087	1936-12-12	1936-12-12 00:00:00	1936-12-19	1936-12-19 00:00:00	32020		\N	105238	0	444814009	40481087		0
26681	1579	4112343	1968-08-20	1968-08-20 00:00:00	1968-08-29	1968-08-29 00:00:00	32020		\N	106082	0	195662009	4112343		0
37354	2213	260139	2004-09-04	2004-09-04 00:00:00	2004-09-18	2004-09-18 00:00:00	32020		\N	147391	0	10509002	260139		0
27013	1598	260139	2002-08-21	2002-08-21 00:00:00	2002-09-04	2002-09-04 00:00:00	32020		\N	107210	0	10509002	260139		0
27160	1605	257012	2001-01-03	2001-01-03 00:00:00	\N	\N	32020		\N	107779	0	40055000	257012		0
27380	1613	260139	1962-07-02	1962-07-02 00:00:00	1962-07-09	1962-07-09 00:00:00	32020		\N	108468	0	10509002	260139		0
38074	2260	378001	2002-09-20	2002-09-20 00:00:00	2002-10-20	2002-10-20 00:00:00	32020		\N	150221	0	62106007	378001		0
27719	1635	4266809	2012-02-21	2012-02-21 00:00:00	\N	\N	32020		\N	109803	0	397881000	4266809		0
38424	2283	4112343	1980-02-23	1980-02-23 00:00:00	1980-03-02	1980-03-02 00:00:00	32020		\N	151908	0	195662009	4112343		0
38578	2290	40481087	1996-08-15	1996-08-15 00:00:00	1996-08-29	1996-08-29 00:00:00	32020		\N	152327	0	444814009	40481087		0
28181	1662	4112343	2017-11-27	2017-11-27 00:00:00	2017-12-10	2017-12-10 00:00:00	32020		\N	111723	0	195662009	4112343		0
28382	1677	4112343	1991-12-09	1991-12-09 00:00:00	1991-12-22	1991-12-22 00:00:00	32020		\N	112513	0	195662009	4112343		0
39036	2319	28060	1968-09-02	1968-09-02 00:00:00	1968-09-09	1968-09-09 00:00:00	32020		\N	154156	0	43878008	28060		0
28639	1695	40481087	1996-06-12	1996-06-12 00:00:00	1996-06-26	1996-06-26 00:00:00	32020		\N	113486	0	444814009	40481087		0
39352	2333	81151	1936-01-09	1936-01-09 00:00:00	1936-02-06	1936-02-06 00:00:00	32020		\N	155158	0	44465007	81151		0
28992	1716	4218389	1970-09-07	1970-09-07 00:00:00	1970-10-05	1970-10-05 00:00:00	32020		\N	114702	0	39848009	4218389		0
29193	1727	40481087	2017-06-11	2017-06-11 00:00:00	2017-06-25	2017-06-25 00:00:00	32020		\N	115486	0	444814009	40481087		0
29358	1738	4296205	2014-12-19	2014-12-19 00:00:00	2015-01-02	2015-01-02 00:00:00	32020		\N	116168	0	403191005	4296205		0
29494	1746	4116491	2011-04-18	2011-04-18 00:00:00	2011-05-24	2011-05-24 00:00:00	32020		\N	116726	0	301011002	4116491		0
29662	1755	4113008	2008-07-26	2008-07-26 00:00:00	2008-08-09	2008-08-09 00:00:00	32020		\N	117379	0	284549007	4113008		0
29802	1762	28060	1985-08-23	1985-08-23 00:00:00	1985-09-05	1985-09-05 00:00:00	32020		\N	117807	0	43878008	28060		0
30045	1778	372328	1983-04-02	1983-04-02 00:00:00	1983-04-23	1983-04-23 00:00:00	32020		\N	118972	0	65363002	372328		0
40685	2418	440448	1995-09-01	1995-09-01 00:00:00	\N	\N	32020		\N	160466	0	74400008	440448		0
30360	1791	4218389	1968-03-21	1968-03-21 00:00:00	1968-04-25	1968-04-25 00:00:00	32020		\N	120054	0	39848009	4218389		0
41096	2443	257012	1995-08-07	1995-08-07 00:00:00	\N	\N	32020		\N	162074	0	40055000	257012		0
30703	1814	4218389	2000-05-05	2000-05-05 00:00:00	2000-06-02	2000-06-02 00:00:00	32020		\N	121431	0	39848009	4218389		0
41345	2459	40481087	2007-06-07	2007-06-07 00:00:00	2007-06-28	2007-06-28 00:00:00	32020		\N	163062	0	444814009	40481087		0
31026	1837	80180	2000-07-22	2000-07-22 00:00:00	\N	\N	32020		\N	122663	0	396275006	80180		0
31188	1846	81151	2003-06-23	2003-06-23 00:00:00	2003-07-14	2003-07-14 00:00:00	32020		\N	123468	0	44465007	81151		0
31337	1852	4294548	2012-11-02	2012-11-02 00:00:00	2012-11-23	2012-11-23 00:00:00	32020		\N	123907	0	75498004	4294548		0
42012	2501	260139	1996-05-27	1996-05-27 00:00:00	1996-06-10	1996-06-10 00:00:00	32020		\N	165538	0	10509002	260139		0
31700	1878	192671	2010-10-08	2010-10-08 00:00:00	\N	\N	32020		\N	125323	0	K92.2	35208414		0
42380	2525	40481087	1996-08-06	1996-08-06 00:00:00	1996-08-13	1996-08-13 00:00:00	32020		\N	166943	0	444814009	40481087		0
21395	1283	4294548	1967-08-22	1967-08-22 00:00:00	1967-09-19	1967-09-19 00:00:00	32020		\N	84786	0	75498004	4294548		0
32090	1906	80180	1997-09-25	1997-09-25 00:00:00	\N	\N	32020		\N	126927	0	396275006	80180		0
32239	1916	378001	1996-12-12	1996-12-12 00:00:00	1997-01-11	1997-01-11 00:00:00	32020		\N	127444	0	62106007	378001		0
32405	1925	78272	2006-11-10	2006-11-10 00:00:00	2006-12-08	2006-12-08 00:00:00	32020		\N	128087	0	70704007	78272		0
22003	1317	4112343	2005-12-26	2005-12-26 00:00:00	2006-01-08	2006-01-08 00:00:00	32020		\N	87248	0	195662009	4112343		0
32750	1946	260139	1974-11-08	1974-11-08 00:00:00	1974-11-15	1974-11-15 00:00:00	32020		\N	129334	0	10509002	260139		0
22366	1335	81151	1990-09-02	1990-09-02 00:00:00	1990-10-07	1990-10-07 00:00:00	32020		\N	88554	0	44465007	81151		0
22570	1348	4035415	1919-09-16	1919-09-16 00:00:00	1919-11-15	1919-11-15 00:00:00	32020		\N	89301	0	239720000	4035415		0
22710	1356	40481087	2009-08-24	2009-08-24 00:00:00	2009-09-14	2009-09-14 00:00:00	32020		\N	89954	0	444814009	40481087		0
22908	1367	4116491	2002-04-21	2002-04-21 00:00:00	2002-06-11	2002-06-11 00:00:00	32020		\N	90600	0	301011002	4116491		0
23046	1376	40481087	1985-08-24	1985-08-24 00:00:00	1985-09-07	1985-09-07 00:00:00	32020		\N	91201	0	444814009	40481087		0
23180	1384	372328	1984-06-03	1984-06-03 00:00:00	1984-08-21	1984-08-21 00:00:00	32020		\N	91749	0	65363002	372328		0
33875	2012	80180	1994-04-13	1994-04-13 00:00:00	\N	\N	32020		\N	133857	0	396275006	80180		0
34052	2025	4112343	1911-08-09	1911-08-09 00:00:00	1911-08-20	1911-08-20 00:00:00	32020		\N	134630	0	195662009	4112343		0
23721	1415	40481087	1983-03-29	1983-03-29 00:00:00	1983-04-19	1983-04-19 00:00:00	32020		\N	94189	0	444814009	40481087		0
34411	2043	4059173	1973-01-09	1973-01-09 00:00:00	1973-02-08	1973-02-08 00:00:00	32020		\N	135903	0	16114001	4059173		0
24001	1432	260139	1972-06-04	1972-06-04 00:00:00	1972-06-11	1972-06-11 00:00:00	32020		\N	95393	0	10509002	260139		0
34749	2063	80180	2014-05-19	2014-05-19 00:00:00	\N	\N	32020		\N	137208	0	396275006	80180		0
34922	2075	4112343	2016-06-17	2016-06-17 00:00:00	2016-06-24	2016-06-24 00:00:00	32020		\N	138007	0	195662009	4112343		0
24521	1464	4134304	1965-09-01	1965-09-01 00:00:00	1965-11-30	1965-11-30 00:00:00	32020		\N	97580	0	263102004	4134304		0
24706	1475	40481087	2000-05-14	2000-05-14 00:00:00	2000-06-04	2000-06-04 00:00:00	32020		\N	98223	0	444814009	40481087		0
35403	2097	378001	1993-12-18	1993-12-18 00:00:00	1994-01-17	1994-01-17 00:00:00	32020		\N	139809	0	62106007	378001		0
35526	2105	4112343	1996-07-22	1996-07-22 00:00:00	1996-08-02	1996-08-02 00:00:00	32020		\N	140256	0	195662009	4112343		0
25194	1504	4112343	1968-05-05	1968-05-05 00:00:00	1968-05-15	1968-05-15 00:00:00	32020		\N	100239	0	195662009	4112343		0
25329	1510	40481087	1987-12-20	1987-12-20 00:00:00	1988-01-10	1988-01-10 00:00:00	32020		\N	100845	0	444814009	40481087		0
36035	2135	80180	1983-11-15	1983-11-15 00:00:00	\N	\N	32020		\N	142148	0	396275006	80180		0
36192	2145	28060	2013-08-09	2013-08-09 00:00:00	2013-08-21	2013-08-21 00:00:00	32020		\N	142802	0	43878008	28060		0
36371	2152	40481087	1978-10-22	1978-10-22 00:00:00	1978-11-05	1978-11-05 00:00:00	32020		\N	143437	0	444814009	40481087		0
26055	1545	257012	1979-01-07	1979-01-07 00:00:00	\N	\N	32020		\N	103518	0	40055000	257012		0
36691	2172	372328	1980-08-12	1980-08-12 00:00:00	1980-09-13	1980-09-13 00:00:00	32020		\N	144694	0	65363002	372328		0
26392	1566	260139	2017-03-16	2017-03-16 00:00:00	2017-03-23	2017-03-23 00:00:00	32020		\N	105046	0	10509002	260139		0
26473	1569	260139	1943-03-03	1943-03-03 00:00:00	1943-03-17	1943-03-17 00:00:00	32020		\N	105240	0	10509002	260139		0
26682	1579	260139	2000-11-30	2000-11-30 00:00:00	2000-12-07	2000-12-07 00:00:00	32020		\N	106092	0	10509002	260139		0
37355	2213	4152936	1972-05-23	1972-05-23 00:00:00	1972-06-06	1972-06-06 00:00:00	32020		\N	147424	0	283385000	4152936		0
27014	1598	40481087	1987-06-20	1987-06-20 00:00:00	1987-07-11	1987-07-11 00:00:00	32020		\N	107243	0	444814009	40481087		0
27161	1605	40481087	1994-09-04	1994-09-04 00:00:00	1994-09-25	1994-09-25 00:00:00	32020		\N	107756	0	444814009	40481087		0
27381	1613	40481087	1960-12-16	1960-12-16 00:00:00	1961-01-06	1961-01-06 00:00:00	32020		\N	108445	0	444814009	40481087		0
38075	2260	40481087	2017-09-19	2017-09-19 00:00:00	2017-10-03	2017-10-03 00:00:00	32020		\N	150182	0	444814009	40481087		0
27720	1635	4283893	1993-05-29	1993-05-29 00:00:00	1993-06-26	1993-06-26 00:00:00	32020		\N	109852	0	36971009	4283893		0
38425	2283	4112343	1940-01-07	1940-01-07 00:00:00	1940-01-14	1940-01-14 00:00:00	32020		\N	151873	0	195662009	4112343		0
38579	2290	4278672	1972-10-05	1972-10-05 00:00:00	1972-12-04	1972-12-04 00:00:00	32020		\N	152341	0	65966004	4278672		0
28182	1662	40481087	1974-05-28	1974-05-28 00:00:00	1974-06-11	1974-06-11 00:00:00	32020		\N	111721	0	444814009	40481087		0
28383	1677	4156265	2018-08-08	2018-08-08 00:00:00	2018-08-22	2018-08-22 00:00:00	32020		\N	112490	0	370247008	4156265		0
39037	2319	40481087	2011-09-09	2011-09-09 00:00:00	2011-09-16	2011-09-16 00:00:00	32020		\N	154220	0	444814009	40481087		0
28640	1695	28060	2017-10-17	2017-10-17 00:00:00	2017-10-26	2017-10-26 00:00:00	32020		\N	113446	0	43878008	28060		0
39353	2333	257012	1926-11-18	1926-11-18 00:00:00	\N	\N	32020		\N	155131	0	40055000	257012		0
28993	1716	40481087	1959-06-22	1959-06-22 00:00:00	1959-06-29	1959-06-29 00:00:00	32020		\N	114643	0	444814009	40481087		0
29194	1727	80180	1991-12-10	1991-12-10 00:00:00	\N	\N	32020		\N	115556	0	396275006	80180		0
29359	1738	40481087	1998-08-02	1998-08-02 00:00:00	1998-08-09	1998-08-09 00:00:00	32020		\N	116105	0	444814009	40481087		0
32252	1916	80180	2007-05-13	2007-05-13 00:00:00	\N	\N	32020		\N	127498	0	396275006	80180		0
29495	1746	4296204	2015-06-03	2015-06-03 00:00:00	2015-06-24	2015-06-24 00:00:00	32020		\N	116766	0	403190006	4296204		0
29663	1755	260139	1961-10-06	1961-10-06 00:00:00	1961-10-20	1961-10-20 00:00:00	32020		\N	117332	0	10509002	260139		0
29803	1762	260139	1948-08-22	1948-08-22 00:00:00	1948-09-05	1948-09-05 00:00:00	32020		\N	117805	0	10509002	260139		0
30046	1778	4283893	2003-04-04	2003-04-04 00:00:00	2003-06-20	2003-06-20 00:00:00	32020		\N	118970	0	36971009	4283893		0
40686	2418	372328	1975-12-23	1975-12-23 00:00:00	1976-02-10	1976-02-10 00:00:00	32020		\N	160431	0	65363002	372328		0
30361	1791	40481087	1981-05-08	1981-05-08 00:00:00	1981-05-29	1981-05-29 00:00:00	32020		\N	120102	0	444814009	40481087		0
41097	2443	4112343	2016-11-02	2016-11-02 00:00:00	2016-11-10	2016-11-10 00:00:00	32020		\N	162061	0	195662009	4112343		0
30704	1814	260139	1964-08-21	1964-08-21 00:00:00	1964-09-04	1964-09-04 00:00:00	32020		\N	121425	0	10509002	260139		0
41346	2459	4112343	1994-08-04	1994-08-04 00:00:00	1994-08-16	1994-08-16 00:00:00	32020		\N	163048	0	195662009	4112343		0
31027	1837	257012	1968-09-27	1968-09-27 00:00:00	\N	\N	32020		\N	122737	0	40055000	257012		0
31189	1846	4112343	1968-11-04	1968-11-04 00:00:00	1968-11-16	1968-11-16 00:00:00	32020		\N	123397	0	195662009	4112343		0
31338	1852	375671	1983-08-12	1983-08-12 00:00:00	1983-10-11	1983-10-11 00:00:00	32020		\N	123945	0	62564004	375671		0
42013	2501	260139	1981-11-14	1981-11-14 00:00:00	1981-11-21	1981-11-21 00:00:00	32020		\N	165537	0	10509002	260139		0
31701	1878	440448	2004-03-09	2004-03-09 00:00:00	\N	\N	32020		\N	125349	0	74400008	440448		0
42381	2525	40481087	2015-10-04	2015-10-04 00:00:00	2015-10-18	2015-10-18 00:00:00	32020		\N	166978	0	444814009	40481087		0
21396	1283	81151	1962-11-25	1962-11-25 00:00:00	1962-12-23	1962-12-23 00:00:00	32020		\N	84820	0	44465007	81151		0
32091	1906	4296205	2017-05-18	2017-05-18 00:00:00	2017-06-08	2017-06-08 00:00:00	32020		\N	126852	0	403191005	4296205		0
32240	1916	40481087	1995-10-10	1995-10-10 00:00:00	1995-10-31	1995-10-31 00:00:00	32020		\N	127464	0	444814009	40481087		0
32406	1925	4134304	1960-05-01	1960-05-01 00:00:00	1960-05-31	1960-05-31 00:00:00	32020		\N	128085	0	263102004	4134304		0
22004	1317	40481087	2010-08-28	2010-08-28 00:00:00	2010-09-18	2010-09-18 00:00:00	32020		\N	87249	0	444814009	40481087		0
32751	1946	4146173	2011-12-07	2011-12-07 00:00:00	2012-01-06	2012-01-06 00:00:00	32020		\N	129281	0	307731004	4146173		0
22367	1335	40481087	2007-01-09	2007-01-09 00:00:00	2007-01-23	2007-01-23 00:00:00	32020		\N	88558	0	444814009	40481087		0
22571	1348	260139	1920-03-15	1920-03-15 00:00:00	1920-03-22	1920-03-22 00:00:00	32020		\N	89360	0	10509002	260139		0
22711	1356	4149245	2007-09-22	2007-09-22 00:00:00	2007-10-29	2007-10-29 00:00:00	32020		\N	89862	0	30832001	4149245		0
33367	1980	4294548	1990-03-28	1990-03-28 00:00:00	1990-05-16	1990-05-16 00:00:00	32020		\N	131812	0	75498004	4294548		0
23047	1376	78272	1999-12-16	1999-12-16 00:00:00	2000-01-13	2000-01-13 00:00:00	32020		\N	91178	0	70704007	78272		0
23181	1384	40481087	1985-04-25	1985-04-25 00:00:00	1985-05-09	1985-05-09 00:00:00	32020		\N	91774	0	444814009	40481087		0
33876	2012	375671	2004-07-15	2004-07-15 00:00:00	2004-08-14	2004-08-14 00:00:00	32020		\N	133868	0	62564004	375671		0
34053	2025	260139	1953-08-25	1953-08-25 00:00:00	1953-09-01	1953-09-01 00:00:00	32020		\N	134666	0	10509002	260139		0
23722	1415	4283893	1975-12-18	1975-12-18 00:00:00	1976-04-29	1976-04-29 00:00:00	32020		\N	94216	0	36971009	4283893		0
34412	2043	4294548	2017-10-08	2017-10-08 00:00:00	2017-10-15	2017-10-15 00:00:00	32020		\N	135876	0	75498004	4294548		0
24002	1432	4112343	1972-05-17	1972-05-17 00:00:00	1972-05-26	1972-05-26 00:00:00	32020		\N	95414	0	195662009	4112343		0
34750	2063	4112343	1987-12-21	1987-12-21 00:00:00	1987-12-28	1987-12-28 00:00:00	32020		\N	137205	0	195662009	4112343		0
34923	2075	40486433	1968-12-06	1968-12-06 00:00:00	\N	\N	32020		\N	138066	0	446096008	40486433		0
24522	1464	40481087	2005-10-13	2005-10-13 00:00:00	2005-10-27	2005-10-27 00:00:00	32020		\N	97551	0	444814009	40481087		0
24707	1475	4310024	1977-12-10	1977-12-10 00:00:00	\N	\N	32020		\N	98324	0	424802006	4310024		0
35404	2097	28060	1990-11-05	1990-11-05 00:00:00	1990-11-12	1990-11-12 00:00:00	32020		\N	139770	0	43878008	28060		0
35527	2105	260139	2015-03-06	2015-03-06 00:00:00	2015-03-20	2015-03-20 00:00:00	32020		\N	140220	0	10509002	260139		0
25195	1504	440448	1960-06-07	1960-06-07 00:00:00	\N	\N	32020		\N	100218	0	74400008	440448		0
25330	1510	372328	1963-09-21	1963-09-21 00:00:00	1963-10-13	1963-10-13 00:00:00	32020		\N	100813	0	65363002	372328		0
36036	2135	28060	1958-02-13	1958-02-13 00:00:00	1958-02-23	1958-02-23 00:00:00	32020		\N	142069	0	43878008	28060		0
36193	2145	4112343	1971-05-30	1971-05-30 00:00:00	1971-06-08	1971-06-08 00:00:00	32020		\N	142790	0	195662009	4112343		0
36372	2152	4112343	2010-08-20	2010-08-20 00:00:00	2010-08-28	2010-08-28 00:00:00	32020		\N	143380	0	195662009	4112343		0
26056	1545	80180	2006-05-16	2006-05-16 00:00:00	\N	\N	32020		\N	103533	0	396275006	80180		0
36692	2172	40481087	1990-12-29	1990-12-29 00:00:00	1991-01-12	1991-01-12 00:00:00	32020		\N	144690	0	444814009	40481087		0
26393	1566	4109685	1985-05-01	1985-05-01 00:00:00	1985-05-15	1985-05-15 00:00:00	32020		\N	105011	0	284551006	4109685		0
26474	1569	28060	2006-06-15	2006-06-15 00:00:00	2006-06-22	2006-06-22 00:00:00	32020		\N	105272	0	43878008	28060		0
26683	1579	81893	1986-11-17	1986-11-17 00:00:00	\N	\N	32020		\N	106079	0	64766004	81893		0
37356	2213	80180	1995-08-05	1995-08-05 00:00:00	\N	\N	32020		\N	147400	0	396275006	80180		0
27015	1598	81151	1989-03-22	1989-03-22 00:00:00	1989-04-05	1989-04-05 00:00:00	32020		\N	107218	0	44465007	81151		0
27162	1605	40481087	1993-06-13	1993-06-13 00:00:00	1993-07-04	1993-07-04 00:00:00	32020		\N	107679	0	444814009	40481087		0
27382	1613	4116491	1990-05-06	1990-05-06 00:00:00	1990-06-11	1990-06-11 00:00:00	32020		\N	108499	0	301011002	4116491		0
38076	2260	40481087	1976-05-06	1976-05-06 00:00:00	1976-05-27	1976-05-27 00:00:00	32020		\N	150235	0	444814009	40481087		0
27721	1635	40481087	1990-11-21	1990-11-21 00:00:00	1990-12-05	1990-12-05 00:00:00	32020		\N	109845	0	444814009	40481087		0
38426	2283	4112343	1998-12-24	1998-12-24 00:00:00	1999-01-05	1999-01-05 00:00:00	32020		\N	151914	0	195662009	4112343		0
38580	2290	40481087	2003-06-23	2003-06-23 00:00:00	2003-07-14	2003-07-14 00:00:00	32020		\N	152328	0	444814009	40481087		0
28183	1662	40481087	1996-08-24	1996-08-24 00:00:00	1996-09-07	1996-09-07 00:00:00	32020		\N	111717	0	444814009	40481087		0
28384	1677	375671	1970-05-08	1970-05-08 00:00:00	1970-06-07	1970-06-07 00:00:00	32020		\N	112488	0	62564004	375671		0
39038	2319	40481087	1977-07-12	1977-07-12 00:00:00	1977-07-19	1977-07-19 00:00:00	32020		\N	154197	0	444814009	40481087		0
28641	1695	4113008	2016-09-15	2016-09-15 00:00:00	2016-09-29	2016-09-29 00:00:00	32020		\N	113484	0	284549007	4113008		0
39354	2333	81151	1948-02-17	1948-02-17 00:00:00	1948-03-16	1948-03-16 00:00:00	32020		\N	155160	0	44465007	81151		0
28994	1716	260139	1982-07-02	1982-07-02 00:00:00	1982-07-16	1982-07-16 00:00:00	32020		\N	114604	0	10509002	260139		0
29208	1729	81151	2004-03-03	2004-03-03 00:00:00	2004-04-07	2004-04-07 00:00:00	32020		\N	115621	0	44465007	81151		0
29360	1738	28060	1976-07-13	1976-07-13 00:00:00	1976-07-21	1976-07-21 00:00:00	32020		\N	116104	0	43878008	28060		0
29496	1746	28060	1972-01-04	1972-01-04 00:00:00	1972-01-11	1972-01-11 00:00:00	32020		\N	116722	0	43878008	28060		0
29664	1755	4112343	1999-03-15	1999-03-15 00:00:00	1999-03-24	1999-03-24 00:00:00	32020		\N	117344	0	195662009	4112343		0
29804	1762	40481087	1979-01-29	1979-01-29 00:00:00	1979-02-19	1979-02-19 00:00:00	32020		\N	117801	0	444814009	40481087		0
40505	2406	321042	1961-05-11	1961-05-11 00:00:00	\N	\N	32020		\N	159828	0	410429000	321042		0
40687	2418	4112343	2011-04-30	2011-04-30 00:00:00	2011-05-10	2011-05-10 00:00:00	32020		\N	160445	0	195662009	4112343		0
30362	1791	260139	2017-03-22	2017-03-22 00:00:00	2017-04-05	2017-04-05 00:00:00	32020		\N	120026	0	10509002	260139		0
41098	2443	375671	1974-09-22	1974-09-22 00:00:00	1974-10-22	1974-10-22 00:00:00	32020		\N	162033	0	62564004	375671		0
30705	1814	372328	1945-02-07	1945-02-07 00:00:00	1945-03-31	1945-03-31 00:00:00	32020		\N	121412	0	65363002	372328		0
41347	2459	4112343	2019-04-21	2019-04-21 00:00:00	2019-04-28	2019-04-28 00:00:00	32020		\N	163032	0	195662009	4112343		0
31028	1837	40481087	2014-07-18	2014-07-18 00:00:00	2014-08-08	2014-08-08 00:00:00	32020		\N	122670	0	444814009	40481087		0
31190	1846	40481087	1971-10-10	1971-10-10 00:00:00	1971-10-31	1971-10-31 00:00:00	32020		\N	123398	0	444814009	40481087		0
31339	1852	260139	2001-01-19	2001-01-19 00:00:00	2001-01-26	2001-01-26 00:00:00	32020		\N	123969	0	10509002	260139		0
42014	2501	4112343	2010-01-21	2010-01-21 00:00:00	2010-01-30	2010-01-30 00:00:00	32020		\N	165532	0	195662009	4112343		0
31702	1878	4166224	2004-03-09	2004-03-09 00:00:00	\N	\N	32020		\N	125349	0	47693006	4166224		0
42382	2525	4294548	1978-11-04	1978-11-04 00:00:00	1979-01-06	1979-01-06 00:00:00	32020		\N	166951	0	75498004	4294548		0
21397	1283	78272	2010-07-26	2010-07-26 00:00:00	2010-08-16	2010-08-16 00:00:00	32020		\N	84826	0	70704007	78272		0
32092	1906	40481087	2016-11-01	2016-11-01 00:00:00	2016-11-21	2016-11-21 00:00:00	32020		\N	126880	0	444814009	40481087		0
32241	1916	40479768	1982-05-23	1982-05-23 00:00:00	1982-06-29	1982-06-29 00:00:00	32020		\N	127442	0	444470001	40479768		0
32407	1925	4112343	1997-12-15	1997-12-15 00:00:00	1997-12-27	1997-12-27 00:00:00	32020		\N	128127	0	195662009	4112343		0
22005	1317	260139	1957-10-09	1957-10-09 00:00:00	1957-10-16	1957-10-16 00:00:00	32020		\N	87241	0	10509002	260139		0
32752	1946	372328	1930-01-04	1930-01-04 00:00:00	1930-12-06	1930-12-06 00:00:00	32020		\N	129313	0	65363002	372328		0
22368	1335	81151	1998-05-28	1998-05-28 00:00:00	1998-06-18	1998-06-18 00:00:00	32020		\N	88555	0	44465007	81151		0
22572	1348	40481087	1971-09-16	1971-09-16 00:00:00	1971-10-07	1971-10-07 00:00:00	32020		\N	89338	0	444814009	40481087		0
22712	1356	4285898	2016-05-14	2016-05-14 00:00:00	\N	\N	32020		\N	89885	0	68496003	4285898		0
33368	1980	40481087	1975-08-02	1975-08-02 00:00:00	1975-08-16	1975-08-16 00:00:00	32020		\N	131824	0	444814009	40481087		0
23048	1376	40481087	1982-02-18	1982-02-18 00:00:00	1982-03-04	1982-03-04 00:00:00	32020		\N	91199	0	444814009	40481087		0
23182	1384	4112343	1994-11-22	1994-11-22 00:00:00	1994-12-01	1994-12-01 00:00:00	32020		\N	91767	0	195662009	4112343		0
33877	2012	260139	1968-03-10	1968-03-10 00:00:00	1968-03-17	1968-03-17 00:00:00	32020		\N	133844	0	10509002	260139		0
34054	2025	4146173	2016-12-13	2016-12-13 00:00:00	2017-02-11	2017-02-11 00:00:00	32020		\N	134697	0	307731004	4146173		0
23723	1415	40481087	1987-06-05	1987-06-05 00:00:00	1987-06-19	1987-06-19 00:00:00	32020		\N	94218	0	444814009	40481087		0
34413	2043	40481087	2012-04-21	2012-04-21 00:00:00	2012-04-28	2012-04-28 00:00:00	32020		\N	135898	0	444814009	40481087		0
24003	1432	4112343	1979-08-22	1979-08-22 00:00:00	1979-09-02	1979-09-02 00:00:00	32020		\N	95369	0	195662009	4112343		0
34751	2063	40481087	2013-01-03	2013-01-03 00:00:00	2013-01-24	2013-01-24 00:00:00	32020		\N	137220	0	444814009	40481087		0
34924	2075	4112343	1968-08-18	1968-08-18 00:00:00	1968-08-25	1968-08-25 00:00:00	32020		\N	138075	0	195662009	4112343		0
24523	1464	40481087	2004-09-05	2004-09-05 00:00:00	2004-09-12	2004-09-12 00:00:00	32020		\N	97539	0	444814009	40481087		0
24708	1475	40481087	1997-12-12	1997-12-12 00:00:00	1997-12-19	1997-12-19 00:00:00	32020		\N	98222	0	444814009	40481087		0
35405	2097	372328	1982-09-24	1982-09-24 00:00:00	1983-09-24	1983-09-24 00:00:00	32020		\N	139800	0	65363002	372328		0
35528	2105	260139	1978-11-27	1978-11-27 00:00:00	1978-12-04	1978-12-04 00:00:00	32020		\N	140254	0	10509002	260139		0
25196	1504	40481087	2009-04-19	2009-04-19 00:00:00	2009-04-26	2009-04-26 00:00:00	32020		\N	100280	0	444814009	40481087		0
25331	1510	40479422	1978-08-08	1978-08-08 00:00:00	1978-10-14	1978-10-14 00:00:00	32020		\N	100789	0	444448004	40479422		0
36037	2135	4134304	1957-08-18	1957-08-18 00:00:00	1957-10-17	1957-10-17 00:00:00	32020		\N	142099	0	263102004	4134304		0
36194	2145	40481087	1998-11-03	1998-11-03 00:00:00	1998-11-17	1998-11-17 00:00:00	32020		\N	142786	0	444814009	40481087		0
36373	2152	260139	2016-10-17	2016-10-17 00:00:00	2016-10-31	2016-10-31 00:00:00	32020		\N	143370	0	10509002	260139		0
26057	1545	192671	2006-07-22	2006-07-22 00:00:00	\N	\N	32020		\N	103501	0	K92.2	35208414		0
36693	2172	372328	1980-01-14	1980-01-14 00:00:00	1980-03-15	1980-03-15 00:00:00	32020		\N	144670	0	65363002	372328		0
26394	1566	40481087	2000-12-12	2000-12-12 00:00:00	2000-12-19	2000-12-19 00:00:00	32020		\N	104987	0	444814009	40481087		0
26475	1569	372328	1937-11-28	1937-11-28 00:00:00	1938-02-11	1938-02-11 00:00:00	32020		\N	105305	0	65363002	372328		0
26684	1579	4285898	1987-06-15	1987-06-15 00:00:00	\N	\N	32020		\N	106079	0	68496003	4285898		0
37357	2213	28060	1987-03-19	1987-03-19 00:00:00	1987-03-29	1987-03-29 00:00:00	32020		\N	147377	0	43878008	28060		0
27016	1598	40481087	1964-01-22	1964-01-22 00:00:00	1964-02-12	1964-02-12 00:00:00	32020		\N	107219	0	444814009	40481087		0
27163	1605	40481087	1989-08-23	1989-08-23 00:00:00	1989-09-06	1989-09-06 00:00:00	32020		\N	107755	0	444814009	40481087		0
27383	1613	4112343	2005-02-25	2005-02-25 00:00:00	2005-03-06	2005-03-06 00:00:00	32020		\N	108441	0	195662009	4112343		0
38077	2260	80502	2012-09-30	2012-09-30 00:00:00	\N	\N	32020		\N	150193	0	64859006	80502		0
27722	1635	4278672	1973-08-14	1973-08-14 00:00:00	1973-11-12	1973-11-12 00:00:00	32020		\N	109856	0	65966004	4278672		0
38427	2283	4109685	1988-04-30	1988-04-30 00:00:00	1988-05-21	1988-05-21 00:00:00	32020		\N	151883	0	284551006	4109685		0
38581	2290	4112343	2003-07-30	2003-07-30 00:00:00	2003-08-08	2003-08-08 00:00:00	32020		\N	152317	0	195662009	4112343		0
28184	1662	372328	1964-07-11	1964-07-11 00:00:00	1964-08-21	1964-08-21 00:00:00	32020		\N	111736	0	65363002	372328		0
28385	1677	40481087	1982-09-08	1982-09-08 00:00:00	1982-09-29	1982-09-29 00:00:00	32020		\N	112512	0	444814009	40481087		0
39039	2319	4112343	1966-10-03	1966-10-03 00:00:00	1966-10-12	1966-10-12 00:00:00	32020		\N	154162	0	195662009	4112343		0
28642	1695	40481087	1971-12-28	1971-12-28 00:00:00	1972-01-04	1972-01-04 00:00:00	32020		\N	113436	0	444814009	40481087		0
39355	2333	40481087	1949-09-30	1949-09-30 00:00:00	1949-10-21	1949-10-21 00:00:00	32020		\N	155237	0	444814009	40481087		0
28995	1716	4112343	1977-05-28	1977-05-28 00:00:00	1977-06-05	1977-06-05 00:00:00	32020		\N	114619	0	195662009	4112343		0
29209	1729	40481087	1995-12-02	1995-12-02 00:00:00	1995-12-09	1995-12-09 00:00:00	32020		\N	115625	0	444814009	40481087		0
29361	1738	260139	1986-07-15	1986-07-15 00:00:00	1986-07-29	1986-07-29 00:00:00	32020		\N	116149	0	10509002	260139		0
29497	1746	81151	1963-11-14	1963-11-14 00:00:00	1963-12-05	1963-12-05 00:00:00	32020		\N	116763	0	44465007	81151		0
29665	1755	4112343	1984-10-13	1984-10-13 00:00:00	1984-10-25	1984-10-25 00:00:00	32020		\N	117362	0	195662009	4112343		0
29805	1762	80180	1979-10-12	1979-10-12 00:00:00	\N	\N	32020		\N	117801	0	396275006	80180		0
40506	2406	80180	1979-04-20	1979-04-20 00:00:00	\N	\N	32020		\N	159851	0	396275006	80180		0
40688	2418	4134304	1981-09-09	1981-09-09 00:00:00	1981-12-08	1981-12-08 00:00:00	32020		\N	160441	0	263102004	4134304		0
30363	1791	260139	2017-02-12	2017-02-12 00:00:00	2017-02-19	2017-02-19 00:00:00	32020		\N	120071	0	10509002	260139		0
41099	2443	378001	1964-10-14	1964-10-14 00:00:00	1964-12-12	1964-12-12 00:00:00	32020		\N	162071	0	62106007	378001		0
30706	1814	40481087	1990-01-07	1990-01-07 00:00:00	1990-01-28	1990-01-28 00:00:00	32020		\N	121384	0	444814009	40481087		0
41348	2459	4027663	2008-06-13	2008-06-13 00:00:00	\N	\N	32020		\N	163023	0	13200003	4027663		0
31029	1837	4112343	1974-03-27	1974-03-27 00:00:00	1974-04-04	1974-04-04 00:00:00	32020		\N	122668	0	195662009	4112343		0
31191	1846	260139	2002-11-30	2002-11-30 00:00:00	2002-12-14	2002-12-14 00:00:00	32020		\N	123460	0	10509002	260139		0
31340	1852	28060	1978-05-24	1978-05-24 00:00:00	1978-06-06	1978-06-06 00:00:00	32020		\N	123894	0	43878008	28060		0
42015	2501	4113008	1995-09-03	1995-09-03 00:00:00	1995-09-24	1995-09-24 00:00:00	32020		\N	165576	0	284549007	4113008		0
31703	1878	4283893	1998-02-03	1998-02-03 00:00:00	1998-04-15	1998-04-15 00:00:00	32020		\N	125327	0	36971009	4283893		0
42383	2525	40481087	1981-01-31	1981-01-31 00:00:00	1981-02-07	1981-02-07 00:00:00	32020		\N	166967	0	444814009	40481087		0
21398	1283	40481087	2000-09-03	2000-09-03 00:00:00	2000-09-10	2000-09-10 00:00:00	32020		\N	84850	0	444814009	40481087		0
32093	1906	40486433	1964-11-18	1964-11-18 00:00:00	\N	\N	32020		\N	126910	0	446096008	40486433		0
32242	1916	260139	1972-01-04	1972-01-04 00:00:00	1972-01-11	1972-01-11 00:00:00	32020		\N	127461	0	10509002	260139		0
32408	1925	260139	1954-02-04	1954-02-04 00:00:00	1954-02-11	1954-02-11 00:00:00	32020		\N	128171	0	10509002	260139		0
22006	1317	40481087	1954-12-10	1954-12-10 00:00:00	1954-12-17	1954-12-17 00:00:00	32020		\N	87240	0	444814009	40481087		0
32753	1946	4112343	1926-07-25	1926-07-25 00:00:00	1926-08-05	1926-08-05 00:00:00	32020		\N	129256	0	195662009	4112343		0
22369	1335	260139	2008-03-27	2008-03-27 00:00:00	2008-04-10	2008-04-10 00:00:00	32020		\N	88559	0	10509002	260139		0
22573	1348	40481087	1938-03-02	1938-03-02 00:00:00	1938-03-23	1938-03-23 00:00:00	32020		\N	89304	0	444814009	40481087		0
22713	1356	4310024	2014-10-22	2014-10-22 00:00:00	\N	\N	32020		\N	89885	0	424802006	4310024		0
33369	1980	260139	1984-08-31	1984-08-31 00:00:00	1984-09-14	1984-09-14 00:00:00	32020		\N	131879	0	10509002	260139		0
23049	1376	260139	2004-09-06	2004-09-06 00:00:00	2004-09-13	2004-09-13 00:00:00	32020		\N	91204	0	10509002	260139		0
23183	1384	40481087	2003-09-20	2003-09-20 00:00:00	2003-10-11	2003-10-11 00:00:00	32020		\N	91777	0	444814009	40481087		0
33878	2012	4156265	2006-06-05	2006-06-05 00:00:00	2006-06-26	2006-06-26 00:00:00	32020		\N	133869	0	370247008	4156265		0
34055	2025	40481087	1950-09-05	1950-09-05 00:00:00	1950-09-19	1950-09-19 00:00:00	32020		\N	134632	0	444814009	40481087		0
23724	1415	4218389	2005-05-31	2005-05-31 00:00:00	2005-06-28	2005-06-28 00:00:00	32020		\N	94226	0	39848009	4218389		0
34414	2043	40481087	1988-04-09	1988-04-09 00:00:00	1988-04-16	1988-04-16 00:00:00	32020		\N	135896	0	444814009	40481087		0
24004	1432	4112343	2016-09-16	2016-09-16 00:00:00	2016-09-29	2016-09-29 00:00:00	32020		\N	95419	0	195662009	4112343		0
34752	2063	40481087	1993-01-12	1993-01-12 00:00:00	1993-01-26	1993-01-26 00:00:00	32020		\N	137206	0	444814009	40481087		0
34925	2075	4112343	2009-11-07	2009-11-07 00:00:00	2009-11-17	2009-11-17 00:00:00	32020		\N	138021	0	195662009	4112343		0
24524	1464	4027663	1993-11-23	1993-11-23 00:00:00	\N	\N	32020		\N	97561	0	13200003	4027663		0
24709	1475	4112343	1997-11-17	1997-11-17 00:00:00	1997-11-25	1997-11-25 00:00:00	32020		\N	98317	0	195662009	4112343		0
35406	2097	4112343	2011-04-09	2011-04-09 00:00:00	2011-04-16	2011-04-16 00:00:00	32020		\N	139764	0	195662009	4112343		0
35529	2105	4155034	2008-06-04	2008-06-04 00:00:00	2008-06-18	2008-06-18 00:00:00	32020		\N	140262	0	283371005	4155034		0
25197	1504	40481087	1983-09-03	1983-09-03 00:00:00	1983-09-24	1983-09-24 00:00:00	32020		\N	100258	0	444814009	40481087		0
25332	1510	260139	1995-05-12	1995-05-12 00:00:00	1995-05-26	1995-05-26 00:00:00	32020		\N	100808	0	10509002	260139		0
36038	2136	195588	2013-05-21	2013-05-21 00:00:00	2013-07-04	2013-07-04 00:00:00	32020		\N	142294	0	38822007	195588		0
36195	2145	372328	1976-07-17	1976-07-17 00:00:00	1976-10-02	1976-10-02 00:00:00	32020		\N	142793	0	65363002	372328		0
36374	2152	40481087	1947-12-15	1947-12-15 00:00:00	1948-01-05	1948-01-05 00:00:00	32020		\N	143434	0	444814009	40481087		0
26058	1545	4059173	1970-09-27	1970-09-27 00:00:00	1970-11-26	1970-11-26 00:00:00	32020		\N	103508	0	16114001	4059173		0
36694	2172	40481087	1999-08-19	1999-08-19 00:00:00	1999-09-02	1999-09-02 00:00:00	32020		\N	144693	0	444814009	40481087		0
36853	2180	40481087	2012-10-09	2012-10-09 00:00:00	2012-10-16	2012-10-16 00:00:00	32020		\N	145390	0	444814009	40481087		0
26476	1569	81151	1957-05-17	1957-05-17 00:00:00	1957-06-07	1957-06-07 00:00:00	32020		\N	105226	0	44465007	81151		0
26685	1579	40481087	2012-08-25	2012-08-25 00:00:00	2012-09-15	2012-09-15 00:00:00	32020		\N	106093	0	444814009	40481087		0
37358	2213	260139	2003-04-05	2003-04-05 00:00:00	2003-04-12	2003-04-12 00:00:00	32020		\N	147390	0	10509002	260139		0
27017	1598	260139	1969-06-23	1969-06-23 00:00:00	1969-06-30	1969-06-30 00:00:00	32020		\N	107248	0	10509002	260139		0
27164	1605	321042	2019-05-12	2019-05-12 00:00:00	\N	\N	32020		\N	107753	0	410429000	321042		0
27384	1613	40481087	1985-06-18	1985-06-18 00:00:00	1985-07-02	1985-07-02 00:00:00	32020		\N	108482	0	444814009	40481087		0
38078	2260	260139	1969-10-15	1969-10-15 00:00:00	1969-10-22	1969-10-22 00:00:00	32020		\N	150247	0	10509002	260139		0
38181	2266	4266809	2008-04-28	2008-04-28 00:00:00	\N	\N	32020		\N	150678	0	397881000	4266809		0
38428	2283	80180	1975-07-21	1975-07-21 00:00:00	\N	\N	32020		\N	151945	0	396275006	80180		0
38582	2290	4059173	1969-01-24	1969-01-24 00:00:00	1969-02-23	1969-02-23 00:00:00	32020		\N	152340	0	16114001	4059173		0
28201	1666	80180	1976-11-14	1976-11-14 00:00:00	\N	\N	32020		\N	111865	0	396275006	80180		0
38845	2307	40481087	1966-03-20	1966-03-20 00:00:00	1966-04-10	1966-04-10 00:00:00	32020		\N	153479	0	444814009	40481087		0
39040	2319	40481087	1977-11-24	1977-11-24 00:00:00	1977-12-08	1977-12-08 00:00:00	32020		\N	154198	0	444814009	40481087		0
28643	1695	260139	2016-11-02	2016-11-02 00:00:00	2016-11-16	2016-11-16 00:00:00	32020		\N	113491	0	10509002	260139		0
39356	2333	260139	1958-09-19	1958-09-19 00:00:00	1958-09-26	1958-09-26 00:00:00	32020		\N	155202	0	10509002	260139		0
28996	1716	260139	1965-03-06	1965-03-06 00:00:00	1965-03-13	1965-03-13 00:00:00	32020		\N	114733	0	10509002	260139		0
29210	1729	257012	2004-05-15	2004-05-15 00:00:00	\N	\N	32020		\N	115626	0	40055000	257012		0
29362	1738	260139	1979-05-01	1979-05-01 00:00:00	1979-05-17	1979-05-17 00:00:00	32020		\N	116116	0	10509002	260139		0
29498	1746	372328	1958-07-15	1958-07-15 00:00:00	1959-07-30	1959-07-30 00:00:00	32020		\N	116728	0	65363002	372328		0
29666	1755	4218389	1960-07-11	1960-07-11 00:00:00	1960-08-15	1960-08-15 00:00:00	32020		\N	117341	0	39848009	4218389		0
29806	1762	4112343	1977-06-23	1977-06-23 00:00:00	1977-07-02	1977-07-02 00:00:00	32020		\N	117800	0	195662009	4112343		0
40507	2406	4112343	1978-08-26	1978-08-26 00:00:00	1978-09-06	1978-09-06 00:00:00	32020		\N	159851	0	195662009	4112343		0
40689	2419	4112343	2013-02-21	2013-02-21 00:00:00	2013-03-06	2013-03-06 00:00:00	32020		\N	160610	0	195662009	4112343		0
30364	1791	4112343	1986-03-29	1986-03-29 00:00:00	1986-04-07	1986-04-07 00:00:00	32020		\N	120066	0	195662009	4112343		0
41100	2443	40481087	1965-09-12	1965-09-12 00:00:00	1965-09-19	1965-09-19 00:00:00	32020		\N	162027	0	444814009	40481087		0
30707	1814	40481087	2000-10-11	2000-10-11 00:00:00	2000-11-01	2000-11-01 00:00:00	32020		\N	121443	0	444814009	40481087		0
41349	2459	40481087	2012-10-07	2012-10-07 00:00:00	2012-10-21	2012-10-21 00:00:00	32020		\N	163006	0	444814009	40481087		0
31030	1837	260139	1971-06-07	1971-06-07 00:00:00	1971-06-21	1971-06-21 00:00:00	32020		\N	122739	0	10509002	260139		0
31192	1846	4112343	1956-03-03	1956-03-03 00:00:00	1956-03-10	1956-03-10 00:00:00	32020		\N	123429	0	195662009	4112343		0
31341	1852	4218389	2011-09-05	2011-09-05 00:00:00	2011-09-26	2011-09-26 00:00:00	32020		\N	123947	0	39848009	4218389		0
42016	2501	80180	1995-11-09	1995-11-09 00:00:00	\N	\N	32020		\N	165576	0	396275006	80180		0
31704	1878	28060	2013-07-12	2013-07-12 00:00:00	2013-07-20	2013-07-20 00:00:00	32020		\N	125325	0	43878008	28060		0
42384	2525	40481087	1986-08-09	1986-08-09 00:00:00	1986-08-23	1986-08-23 00:00:00	32020		\N	166942	0	444814009	40481087		0
21399	1283	4094814	1971-06-23	1971-06-23 00:00:00	1971-08-22	1971-08-22 00:00:00	32020		\N	84822	0	262574004	4094814		0
32094	1906	40481087	1969-07-30	1969-07-30 00:00:00	1969-08-13	1969-08-13 00:00:00	32020		\N	126864	0	444814009	40481087		0
32243	1916	40481087	1986-09-14	1986-09-14 00:00:00	1986-09-21	1986-09-21 00:00:00	32020		\N	127486	0	444814009	40481087		0
32409	1925	40481087	1963-12-17	1963-12-17 00:00:00	1963-12-31	1963-12-31 00:00:00	32020		\N	128177	0	444814009	40481087		0
22007	1317	28060	1995-08-03	1995-08-03 00:00:00	1995-08-10	1995-08-10 00:00:00	32020		\N	87246	0	43878008	28060		0
32754	1946	4112343	1969-06-26	1969-06-26 00:00:00	1969-07-04	1969-07-04 00:00:00	32020		\N	129319	0	195662009	4112343		0
22370	1335	40481087	2014-11-18	2014-11-18 00:00:00	2014-12-02	2014-12-02 00:00:00	32020		\N	88575	0	444814009	40481087		0
22574	1348	40481087	1964-06-27	1964-06-27 00:00:00	1964-07-18	1964-07-18 00:00:00	32020		\N	89313	0	444814009	40481087		0
22714	1356	30753	2015-12-16	2015-12-16 00:00:00	\N	\N	32020		\N	89885	0	16761005	30753		0
33370	1980	257012	1990-04-25	1990-04-25 00:00:00	\N	\N	32020		\N	131782	0	40055000	257012		0
23050	1376	80180	2019-04-20	2019-04-20 00:00:00	\N	\N	32020		\N	91233	0	396275006	80180		0
23184	1384	40479422	1994-01-12	1994-01-12 00:00:00	1994-02-18	1994-02-18 00:00:00	32020		\N	91725	0	444448004	40479422		0
33879	2012	81151	1976-02-22	1976-02-22 00:00:00	1976-03-07	1976-03-07 00:00:00	32020		\N	133864	0	44465007	81151		0
34056	2025	260139	2014-05-16	2014-05-16 00:00:00	2014-05-30	2014-05-30 00:00:00	32020		\N	134727	0	10509002	260139		0
23725	1415	40481087	1974-05-07	1974-05-07 00:00:00	1974-05-21	1974-05-21 00:00:00	32020		\N	94188	0	444814009	40481087		0
34415	2043	257012	1975-01-19	1975-01-19 00:00:00	\N	\N	32020		\N	135916	0	40055000	257012		0
24005	1432	78272	1963-08-19	1963-08-19 00:00:00	1963-09-16	1963-09-16 00:00:00	32020		\N	95406	0	70704007	78272		0
34753	2063	260139	2018-08-06	2018-08-06 00:00:00	2018-08-13	2018-08-13 00:00:00	32020		\N	137251	0	10509002	260139		0
34926	2075	260139	2019-04-03	2019-04-03 00:00:00	2019-04-10	2019-04-10 00:00:00	32020		\N	138032	0	10509002	260139		0
24525	1464	439777	1965-11-30	1965-11-30 00:00:00	\N	\N	32020		\N	97538	0	271737000	439777		0
24710	1475	4266809	1981-03-24	1981-03-24 00:00:00	\N	\N	32020		\N	98233	0	397881000	4266809		0
35407	2097	257012	1993-08-03	1993-08-03 00:00:00	\N	\N	32020		\N	139797	0	40055000	257012		0
35530	2105	192671	2013-04-19	2013-04-19 00:00:00	\N	\N	32020		\N	140275	0	K92.2	35208414		0
25198	1504	40481087	1942-10-30	1942-10-30 00:00:00	1942-11-06	1942-11-06 00:00:00	32020		\N	100256	0	444814009	40481087		0
25333	1510	81151	2014-01-06	2014-01-06 00:00:00	2014-01-20	2014-01-20 00:00:00	32020		\N	100794	0	44465007	81151		0
36039	2136	80180	2008-01-08	2008-01-08 00:00:00	\N	\N	32020		\N	142287	0	396275006	80180		0
36196	2145	260139	1989-09-05	1989-09-05 00:00:00	1989-09-19	1989-09-19 00:00:00	32020		\N	142784	0	10509002	260139		0
36375	2152	4112343	1958-11-08	1958-11-08 00:00:00	1958-11-17	1958-11-17 00:00:00	32020		\N	143423	0	195662009	4112343		0
26059	1545	260139	2018-06-27	2018-06-27 00:00:00	2018-07-04	2018-07-04 00:00:00	32020		\N	103523	0	10509002	260139		0
36695	2172	372328	1979-09-02	1979-09-02 00:00:00	1979-12-15	1979-12-15 00:00:00	32020		\N	144683	0	65363002	372328		0
36854	2180	260139	1985-02-26	1985-02-26 00:00:00	1985-03-12	1985-03-12 00:00:00	32020		\N	145394	0	10509002	260139		0
26477	1569	4112343	1945-04-09	1945-04-09 00:00:00	1945-04-20	1945-04-20 00:00:00	32020		\N	105242	0	195662009	4112343		0
26686	1579	4237458	1964-04-02	1964-04-02 00:00:00	1964-07-01	1964-07-01 00:00:00	32020		\N	106102	0	58150001	4237458		0
37359	2213	40481087	2010-10-04	2010-10-04 00:00:00	2010-10-11	2010-10-11 00:00:00	32020		\N	147408	0	444814009	40481087		0
27018	1598	195588	1977-01-15	1977-01-15 00:00:00	1977-03-06	1977-03-06 00:00:00	32020		\N	107222	0	38822007	195588		0
27166	1605	4112343	2010-11-09	2010-11-09 00:00:00	2010-11-16	2010-11-16 00:00:00	32020		\N	107674	0	195662009	4112343		0
27385	1613	372328	1954-10-12	1954-10-12 00:00:00	1955-01-22	1955-01-22 00:00:00	32020		\N	108444	0	65363002	372328		0
38079	2260	260139	1997-05-29	1997-05-29 00:00:00	1997-06-12	1997-06-12 00:00:00	32020		\N	150181	0	10509002	260139		0
38182	2266	4285898	2008-02-28	2008-02-28 00:00:00	\N	\N	32020		\N	150678	0	68496003	4285898		0
38429	2283	378001	1943-12-16	1943-12-16 00:00:00	1944-02-14	1944-02-14 00:00:00	32020		\N	151843	0	62106007	378001		0
38583	2290	40481087	2001-02-10	2001-02-10 00:00:00	2001-02-24	2001-02-24 00:00:00	32020		\N	152360	0	444814009	40481087		0
28202	1666	260139	1971-02-10	1971-02-10 00:00:00	1971-02-24	1971-02-24 00:00:00	32020		\N	111912	0	10509002	260139		0
38846	2307	40481087	2010-04-29	2010-04-29 00:00:00	2010-05-20	2010-05-20 00:00:00	32020		\N	153481	0	444814009	40481087		0
39041	2319	40481087	1964-06-26	1964-06-26 00:00:00	1964-07-10	1964-07-10 00:00:00	32020		\N	154161	0	444814009	40481087		0
28644	1695	257012	2000-11-08	2000-11-08 00:00:00	\N	\N	32020		\N	113488	0	40055000	257012		0
39357	2333	80502	2000-06-13	2000-06-13 00:00:00	\N	\N	32020		\N	155177	0	64859006	80502		0
29007	1718	260139	2011-10-14	2011-10-14 00:00:00	2011-10-28	2011-10-28 00:00:00	32020		\N	114860	0	10509002	260139		0
29211	1729	4283893	2004-03-27	2004-03-27 00:00:00	2004-08-14	2004-08-14 00:00:00	32020		\N	115649	0	36971009	4283893		0
29363	1739	4152936	1976-05-20	1976-05-20 00:00:00	1976-06-03	1976-06-03 00:00:00	32020		\N	116170	0	283385000	4152936		0
29499	1746	260139	2005-10-28	2005-10-28 00:00:00	2005-11-04	2005-11-04 00:00:00	32020		\N	116800	0	10509002	260139		0
29667	1755	260139	2006-05-27	2006-05-27 00:00:00	2006-06-10	2006-06-10 00:00:00	32020		\N	117387	0	10509002	260139		0
29807	1762	260139	1982-01-25	1982-01-25 00:00:00	1982-02-08	1982-02-08 00:00:00	32020		\N	117802	0	10509002	260139		0
40508	2406	260139	1965-10-05	1965-10-05 00:00:00	1965-10-19	1965-10-19 00:00:00	32020		\N	159831	0	10509002	260139		0
40690	2419	4112343	1971-07-09	1971-07-09 00:00:00	1971-07-21	1971-07-21 00:00:00	32020		\N	160629	0	195662009	4112343		0
30365	1791	4112343	1965-01-11	1965-01-11 00:00:00	1965-01-23	1965-01-23 00:00:00	32020		\N	120063	0	195662009	4112343		0
41101	2443	40481087	1989-09-19	1989-09-19 00:00:00	1989-10-03	1989-10-03 00:00:00	32020		\N	162039	0	444814009	40481087		0
30708	1814	4027663	1970-04-13	1970-04-13 00:00:00	\N	\N	32020		\N	121427	0	13200003	4027663		0
41350	2459	260139	2008-09-06	2008-09-06 00:00:00	2008-09-13	2008-09-13 00:00:00	32020		\N	163039	0	10509002	260139		0
31031	1837	40481087	1991-12-15	1991-12-15 00:00:00	1991-12-22	1991-12-22 00:00:00	32020		\N	122686	0	444814009	40481087		0
31193	1846	260139	1979-09-29	1979-09-29 00:00:00	1979-10-13	1979-10-13 00:00:00	32020		\N	123400	0	10509002	260139		0
31342	1852	4294548	2011-11-24	2011-11-24 00:00:00	2011-12-29	2011-12-29 00:00:00	32020		\N	123905	0	75498004	4294548		0
42017	2501	372328	1962-05-26	1962-05-26 00:00:00	1962-08-06	1962-08-06 00:00:00	32020		\N	165534	0	65363002	372328		0
31705	1878	372328	1975-06-14	1975-06-14 00:00:00	1975-08-24	1975-08-24 00:00:00	32020		\N	125336	0	65363002	372328		0
42385	2525	40481087	1978-04-19	1978-04-19 00:00:00	1978-05-03	1978-05-03 00:00:00	32020		\N	166950	0	444814009	40481087		0
21400	1283	4112343	2012-07-20	2012-07-20 00:00:00	2012-07-29	2012-07-29 00:00:00	32020		\N	84800	0	195662009	4112343		0
32095	1906	40481087	1993-10-22	1993-10-22 00:00:00	1993-11-11	1993-11-11 00:00:00	32020		\N	126879	0	444814009	40481087		0
32244	1916	260139	2015-09-12	2015-09-12 00:00:00	2015-09-19	2015-09-19 00:00:00	32020		\N	127421	0	10509002	260139		0
32410	1925	40481087	2018-01-23	2018-01-23 00:00:00	2018-02-13	2018-02-13 00:00:00	32020		\N	128136	0	444814009	40481087		0
22008	1317	4283893	1997-05-18	1997-05-18 00:00:00	1998-02-08	1998-02-08 00:00:00	32020		\N	87255	0	36971009	4283893		0
32755	1946	80180	1963-01-06	1963-01-06 00:00:00	\N	\N	32020		\N	129339	0	396275006	80180		0
22371	1335	80180	2017-06-28	2017-06-28 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
22575	1348	372328	1913-01-20	1913-01-20 00:00:00	1913-04-07	1913-04-07 00:00:00	32020		\N	89283	0	65363002	372328		0
22715	1356	40481087	2013-06-03	2013-06-03 00:00:00	2013-06-24	2013-06-24 00:00:00	32020		\N	89955	0	444814009	40481087		0
33371	1980	40481087	1984-01-06	1984-01-06 00:00:00	1984-01-20	1984-01-20 00:00:00	32020		\N	131810	0	444814009	40481087		0
23051	1376	4112343	1995-04-27	1995-04-27 00:00:00	1995-05-08	1995-05-08 00:00:00	32020		\N	91183	0	195662009	4112343		0
23185	1384	4237458	1989-03-09	1989-03-09 00:00:00	1989-04-08	1989-04-08 00:00:00	32020		\N	91723	0	58150001	4237458		0
33880	2012	4283893	2017-04-19	2017-04-19 00:00:00	2017-05-24	2017-05-24 00:00:00	32020		\N	133905	0	36971009	4283893		0
34057	2025	4113008	1948-01-02	1948-01-02 00:00:00	1948-01-16	1948-01-16 00:00:00	32020		\N	134665	0	284549007	4113008		0
23726	1415	81151	1984-02-07	1984-02-07 00:00:00	1984-02-21	1984-02-21 00:00:00	32020		\N	94212	0	44465007	81151		0
34416	2043	4283893	1974-12-08	1974-12-08 00:00:00	1975-03-30	1975-03-30 00:00:00	32020		\N	135895	0	36971009	4283893		0
24006	1432	4152936	2005-04-06	2005-04-06 00:00:00	2005-04-27	2005-04-27 00:00:00	32020		\N	95408	0	283385000	4152936		0
34754	2063	4112343	2017-07-27	2017-07-27 00:00:00	2017-08-03	2017-08-03 00:00:00	32020		\N	137211	0	195662009	4112343		0
34927	2075	4266809	2006-03-10	2006-03-10 00:00:00	\N	\N	32020		\N	138014	0	397881000	4266809		0
24526	1464	40481087	1998-08-10	1998-08-10 00:00:00	1998-08-31	1998-08-31 00:00:00	32020		\N	97535	0	444814009	40481087		0
24711	1475	80180	1981-03-24	1981-03-24 00:00:00	\N	\N	32020		\N	98233	0	396275006	80180		0
35408	2097	260139	1988-02-01	1988-02-01 00:00:00	1988-02-15	1988-02-15 00:00:00	32020		\N	139760	0	10509002	260139		0
35531	2105	40481087	1989-01-29	1989-01-29 00:00:00	1989-02-12	1989-02-12 00:00:00	32020		\N	140218	0	444814009	40481087		0
25199	1504	4112343	2015-09-23	2015-09-23 00:00:00	2015-10-01	2015-10-01 00:00:00	32020		\N	100273	0	195662009	4112343		0
25334	1510	81151	1968-05-13	1968-05-13 00:00:00	1968-05-27	1968-05-27 00:00:00	32020		\N	100820	0	44465007	81151		0
36040	2136	4294548	1995-10-21	1995-10-21 00:00:00	1995-11-04	1995-11-04 00:00:00	32020		\N	142194	0	75498004	4294548		0
36197	2145	4035415	1982-03-16	1982-03-16 00:00:00	1982-04-15	1982-04-15 00:00:00	32020		\N	142799	0	239720000	4035415		0
36376	2152	28060	1936-06-28	1936-06-28 00:00:00	1936-07-05	1936-07-05 00:00:00	32020		\N	143421	0	43878008	28060		0
26060	1545	4027663	1995-11-30	1995-11-30 00:00:00	\N	\N	32020		\N	103492	0	13200003	4027663		0
36696	2172	260139	2016-01-19	2016-01-19 00:00:00	2016-01-26	2016-01-26 00:00:00	32020		\N	144663	0	10509002	260139		0
36855	2180	4112343	2000-12-30	2000-12-30 00:00:00	2001-01-12	2001-01-12 00:00:00	32020		\N	145401	0	195662009	4112343		0
26478	1569	4155034	2018-01-28	2018-01-28 00:00:00	2018-02-18	2018-02-18 00:00:00	32020		\N	105231	0	283371005	4155034		0
26687	1579	4112343	2019-01-15	2019-01-15 00:00:00	2019-01-25	2019-01-25 00:00:00	32020		\N	106044	0	195662009	4112343		0
37360	2213	28060	1997-09-14	1997-09-14 00:00:00	1997-09-22	1997-09-22 00:00:00	32020		\N	147362	0	43878008	28060		0
27019	1599	4112343	2013-10-07	2013-10-07 00:00:00	2013-10-18	2013-10-18 00:00:00	32020		\N	107351	0	195662009	4112343		0
27167	1605	372328	1938-04-04	1938-04-04 00:00:00	1938-06-05	1938-06-05 00:00:00	32020		\N	107698	0	65363002	372328		0
27386	1613	40481087	1974-09-01	1974-09-01 00:00:00	1974-09-08	1974-09-08 00:00:00	32020		\N	108456	0	444814009	40481087		0
38080	2260	4112343	1975-11-14	1975-11-14 00:00:00	1975-11-26	1975-11-26 00:00:00	32020		\N	150233	0	195662009	4112343		0
38183	2267	4112343	1966-06-13	1966-06-13 00:00:00	1966-06-23	1966-06-23 00:00:00	32020		\N	150682	0	195662009	4112343		0
38430	2283	40481087	1953-05-09	1953-05-09 00:00:00	1953-05-30	1953-05-30 00:00:00	32020		\N	151876	0	444814009	40481087		0
38584	2290	4112343	1970-06-14	1970-06-14 00:00:00	1970-06-23	1970-06-23 00:00:00	32020		\N	152357	0	195662009	4112343		0
28203	1666	28060	1944-11-01	1944-11-01 00:00:00	1944-11-10	1944-11-10 00:00:00	32020		\N	111932	0	43878008	28060		0
38847	2307	4112343	1977-05-25	1977-05-25 00:00:00	1977-06-02	1977-06-02 00:00:00	32020		\N	153480	0	195662009	4112343		0
39042	2319	40481087	1956-01-05	1956-01-05 00:00:00	1956-01-26	1956-01-26 00:00:00	32020		\N	154155	0	444814009	40481087		0
28645	1695	260139	1999-09-01	1999-09-01 00:00:00	1999-09-08	1999-09-08 00:00:00	32020		\N	113487	0	10509002	260139		0
39358	2333	4116491	1962-05-22	1962-05-22 00:00:00	1962-07-01	1962-07-01 00:00:00	32020		\N	155240	0	301011002	4116491		0
29008	1718	40481087	1999-12-04	1999-12-04 00:00:00	1999-12-18	1999-12-18 00:00:00	32020		\N	114856	0	444814009	40481087		0
29212	1729	40481087	2012-05-11	2012-05-11 00:00:00	2012-05-18	2012-05-18 00:00:00	32020		\N	115657	0	444814009	40481087		0
29364	1739	81151	1973-02-14	1973-02-14 00:00:00	1973-03-07	1973-03-07 00:00:00	32020		\N	116169	0	44465007	81151		0
29500	1746	40481087	2004-07-02	2004-07-02 00:00:00	2004-07-23	2004-07-23 00:00:00	32020		\N	116724	0	444814009	40481087		0
29668	1755	4112343	1963-11-24	1963-11-24 00:00:00	1963-12-01	1963-12-01 00:00:00	32020		\N	117382	0	195662009	4112343		0
29808	1762	40481087	2001-01-21	2001-01-21 00:00:00	2001-02-11	2001-02-11 00:00:00	32020		\N	117876	0	444814009	40481087		0
40509	2406	4112343	1949-05-08	1949-05-08 00:00:00	1949-05-20	1949-05-20 00:00:00	32020		\N	159804	0	195662009	4112343		0
40691	2419	260139	2000-01-30	2000-01-30 00:00:00	2000-02-06	2000-02-06 00:00:00	32020		\N	160546	0	10509002	260139		0
30366	1791	4142905	1995-07-08	1995-07-08 00:00:00	1995-09-06	1995-09-06 00:00:00	32020		\N	120057	0	33737001	4142905		0
41102	2443	81893	1997-06-18	1997-06-18 00:00:00	\N	\N	32020		\N	162056	0	64766004	81893		0
30709	1814	40481087	1969-04-11	1969-04-11 00:00:00	1969-04-18	1969-04-18 00:00:00	32020		\N	121427	0	444814009	40481087		0
41351	2459	28060	1984-06-15	1984-06-15 00:00:00	1984-06-25	1984-06-25 00:00:00	32020		\N	163052	0	43878008	28060		0
31032	1837	4278672	1965-02-16	1965-02-16 00:00:00	1965-05-17	1965-05-17 00:00:00	32020		\N	122692	0	65966004	4278672		0
31194	1846	4094814	1963-12-20	1963-12-20 00:00:00	1964-03-19	1964-03-19 00:00:00	32020		\N	123441	0	262574004	4094814		0
31343	1852	4155034	2016-10-29	2016-10-29 00:00:00	2016-11-19	2016-11-19 00:00:00	32020		\N	123948	0	283371005	4155034		0
42018	2501	40481087	2018-07-06	2018-07-06 00:00:00	2018-07-13	2018-07-13 00:00:00	32020		\N	165533	0	444814009	40481087		0
31706	1878	40481087	2007-02-04	2007-02-04 00:00:00	2007-02-18	2007-02-18 00:00:00	32020		\N	125324	0	444814009	40481087		0
42386	2525	260139	1996-05-09	1996-05-09 00:00:00	1996-05-23	1996-05-23 00:00:00	32020		\N	166953	0	10509002	260139		0
21401	1283	260139	1984-12-31	1984-12-31 00:00:00	1985-01-14	1985-01-14 00:00:00	32020		\N	84798	0	10509002	260139		0
32096	1906	4112343	1970-02-08	1970-02-08 00:00:00	1970-02-20	1970-02-20 00:00:00	32020		\N	126912	0	195662009	4112343		0
32245	1916	4146173	1995-12-18	1995-12-18 00:00:00	1996-02-16	1996-02-16 00:00:00	32020		\N	127495	0	307731004	4146173		0
32411	1925	40481087	2012-05-18	2012-05-18 00:00:00	2012-05-25	2012-05-25 00:00:00	32020		\N	128134	0	444814009	40481087		0
22009	1317	40481087	1978-07-13	1978-07-13 00:00:00	1978-07-27	1978-07-27 00:00:00	32020		\N	87245	0	444814009	40481087		0
32756	1946	40481087	2006-11-11	2006-11-11 00:00:00	2006-12-02	2006-12-02 00:00:00	32020		\N	129262	0	444814009	40481087		0
22372	1335	40481087	2003-10-14	2003-10-14 00:00:00	2003-10-21	2003-10-21 00:00:00	32020		\N	88557	0	444814009	40481087		0
22576	1348	40481087	1924-09-29	1924-09-29 00:00:00	1924-10-06	1924-10-06 00:00:00	32020		\N	89332	0	444814009	40481087		0
22716	1356	28060	1981-02-14	1981-02-14 00:00:00	1981-02-26	1981-02-26 00:00:00	32020		\N	89939	0	43878008	28060		0
33372	1980	260139	1975-07-07	1975-07-07 00:00:00	1975-07-21	1975-07-21 00:00:00	32020		\N	131823	0	10509002	260139		0
23052	1376	260139	1986-11-25	1986-11-25 00:00:00	1986-12-09	1986-12-09 00:00:00	32020		\N	91200	0	10509002	260139		0
23186	1384	372328	1986-12-09	1986-12-09 00:00:00	1987-02-24	1987-02-24 00:00:00	32020		\N	91750	0	65363002	372328		0
33881	2012	4112343	1977-05-20	1977-05-20 00:00:00	1977-05-29	1977-05-29 00:00:00	32020		\N	133918	0	195662009	4112343		0
34058	2025	313217	1973-11-10	1973-11-10 00:00:00	\N	\N	32020		\N	134672	0	49436004	313217		0
23727	1415	260139	1988-09-15	1988-09-15 00:00:00	1988-09-22	1988-09-22 00:00:00	32020		\N	94196	0	10509002	260139		0
34417	2043	40481087	1995-04-17	1995-04-17 00:00:00	1995-04-24	1995-04-24 00:00:00	32020		\N	135897	0	444814009	40481087		0
24007	1432	260139	1979-07-06	1979-07-06 00:00:00	1979-07-13	1979-07-13 00:00:00	32020		\N	95415	0	10509002	260139		0
34755	2063	40481087	1973-11-11	1973-11-11 00:00:00	1973-11-25	1973-11-25 00:00:00	32020		\N	137227	0	444814009	40481087		0
34928	2075	80180	2006-03-10	2006-03-10 00:00:00	\N	\N	32020		\N	138014	0	396275006	80180		0
24527	1464	260139	2018-11-09	2018-11-09 00:00:00	2018-11-16	2018-11-16 00:00:00	32020		\N	97552	0	10509002	260139		0
24712	1475	4152936	1961-01-03	1961-01-03 00:00:00	1961-01-17	1961-01-17 00:00:00	32020		\N	98249	0	283385000	4152936		0
35532	2105	40481087	2016-01-15	2016-01-15 00:00:00	2016-01-29	2016-01-29 00:00:00	32020		\N	140221	0	444814009	40481087		0
25200	1504	40481087	1944-02-06	1944-02-06 00:00:00	1944-02-27	1944-02-27 00:00:00	32020		\N	100236	0	444814009	40481087		0
25335	1510	4112343	1977-09-24	1977-09-24 00:00:00	1977-10-07	1977-10-07 00:00:00	32020		\N	100780	0	195662009	4112343		0
36041	2136	40481087	1983-08-10	1983-08-10 00:00:00	1983-08-17	1983-08-17 00:00:00	32020		\N	142193	0	444814009	40481087		0
36198	2145	40481087	1992-03-13	1992-03-13 00:00:00	1992-04-03	1992-04-03 00:00:00	32020		\N	142836	0	444814009	40481087		0
36377	2152	4112343	1973-04-16	1973-04-16 00:00:00	1973-04-28	1973-04-28 00:00:00	32020		\N	143436	0	195662009	4112343		0
26061	1545	81893	2004-12-22	2004-12-22 00:00:00	\N	\N	32020		\N	103532	0	64766004	81893		0
36697	2172	378001	1996-03-06	1996-03-06 00:00:00	1996-04-05	1996-04-05 00:00:00	32020		\N	144701	0	62106007	378001		0
36856	2180	80180	2017-08-06	2017-08-06 00:00:00	\N	\N	32020		\N	145436	0	396275006	80180		0
26479	1569	4310024	1968-09-26	1968-09-26 00:00:00	\N	\N	32020		\N	105283	0	424802006	4310024		0
26688	1579	40481087	2017-03-31	2017-03-31 00:00:00	2017-04-14	2017-04-14 00:00:00	32020		\N	106090	0	444814009	40481087		0
37361	2213	4230399	1974-06-26	1974-06-26 00:00:00	1974-09-24	1974-09-24 00:00:00	32020		\N	147425	0	359817006	4230399		0
27020	1599	260139	1972-11-19	1972-11-19 00:00:00	1972-12-03	1972-12-03 00:00:00	32020		\N	107291	0	10509002	260139		0
27168	1605	4112343	1991-03-22	1991-03-22 00:00:00	1991-04-04	1991-04-04 00:00:00	32020		\N	107669	0	195662009	4112343		0
27387	1613	372328	1958-01-07	1958-01-07 00:00:00	1958-04-19	1958-04-19 00:00:00	32020		\N	108501	0	65363002	372328		0
38081	2260	4112343	1992-08-28	1992-08-28 00:00:00	1992-09-10	1992-09-10 00:00:00	32020		\N	150180	0	195662009	4112343		0
38184	2267	40481087	1983-11-21	1983-11-21 00:00:00	1983-12-05	1983-12-05 00:00:00	32020		\N	150740	0	444814009	40481087		0
38431	2283	4294548	1953-09-02	1953-09-02 00:00:00	1953-09-16	1953-09-16 00:00:00	32020		\N	151877	0	75498004	4294548		0
38585	2290	28060	1984-05-14	1984-05-14 00:00:00	1984-05-25	1984-05-25 00:00:00	32020		\N	152353	0	43878008	28060		0
28204	1666	81151	2018-08-24	2018-08-24 00:00:00	2018-09-28	2018-09-28 00:00:00	32020		\N	111882	0	44465007	81151		0
38848	2307	80180	2003-11-12	2003-11-12 00:00:00	\N	\N	32020		\N	153523	0	396275006	80180		0
39043	2319	4294548	2003-10-25	2003-10-25 00:00:00	2004-04-10	2004-04-10 00:00:00	32020		\N	154184	0	75498004	4294548		0
28646	1695	40479768	2003-06-19	2003-06-19 00:00:00	2003-07-26	2003-07-26 00:00:00	32020		\N	113483	0	444470001	40479768		0
39359	2333	4109685	1991-04-19	1991-04-19 00:00:00	1991-05-10	1991-05-10 00:00:00	32020		\N	155164	0	284551006	4109685		0
29009	1718	372328	1980-07-26	1980-07-26 00:00:00	1981-03-21	1981-03-21 00:00:00	32020		\N	114861	0	65363002	372328		0
29213	1729	40481087	1999-03-28	1999-03-28 00:00:00	1999-04-18	1999-04-18 00:00:00	32020		\N	115656	0	444814009	40481087		0
29365	1739	260139	1999-10-14	1999-10-14 00:00:00	1999-10-28	1999-10-28 00:00:00	32020		\N	116213	0	10509002	260139		0
29501	1746	260139	1954-04-08	1954-04-08 00:00:00	1954-04-22	1954-04-22 00:00:00	32020		\N	116718	0	10509002	260139		0
29669	1756	4112343	2009-04-25	2009-04-25 00:00:00	2009-05-08	2009-05-08 00:00:00	32020		\N	117463	0	195662009	4112343		0
29815	1764	40481087	1997-01-11	1997-01-11 00:00:00	1997-01-18	1997-01-18 00:00:00	32020		\N	117984	0	444814009	40481087		0
40510	2406	260139	1981-01-30	1981-01-30 00:00:00	1981-02-13	1981-02-13 00:00:00	32020		\N	159842	0	10509002	260139		0
40692	2419	4134304	1989-12-12	1989-12-12 00:00:00	1990-02-10	1990-02-10 00:00:00	32020		\N	160507	0	263102004	4134304		0
40837	2428	40481087	1985-05-31	1985-05-31 00:00:00	1985-06-07	1985-06-07 00:00:00	32020		\N	161110	0	444814009	40481087		0
41103	2443	4285898	1998-05-14	1998-05-14 00:00:00	\N	\N	32020		\N	162056	0	68496003	4285898		0
30710	1814	4112343	1990-11-05	1990-11-05 00:00:00	1990-11-18	1990-11-18 00:00:00	32020		\N	121385	0	195662009	4112343		0
41352	2459	28060	1977-07-19	1977-07-19 00:00:00	1977-07-29	1977-07-29 00:00:00	32020		\N	163049	0	43878008	28060		0
31033	1837	40481087	1965-06-21	1965-06-21 00:00:00	1965-07-12	1965-07-12 00:00:00	32020		\N	122681	0	444814009	40481087		0
31195	1846	4112343	2010-12-18	2010-12-18 00:00:00	2010-12-25	2010-12-25 00:00:00	32020		\N	123461	0	195662009	4112343		0
31344	1852	4294548	2010-07-12	2010-07-12 00:00:00	2010-11-22	2010-11-22 00:00:00	32020		\N	123990	0	75498004	4294548		0
42019	2501	372328	1965-06-22	1965-06-22 00:00:00	1965-11-01	1965-11-01 00:00:00	32020		\N	165556	0	65363002	372328		0
42244	2518	28060	2004-08-06	2004-08-06 00:00:00	2004-08-19	2004-08-19 00:00:00	32020		\N	166520	0	43878008	28060		0
42387	2525	80180	2017-12-09	2017-12-09 00:00:00	\N	\N	32020		\N	166974	0	396275006	80180		0
21402	1283	4112343	1959-09-13	1959-09-13 00:00:00	1959-09-23	1959-09-23 00:00:00	32020		\N	84795	0	195662009	4112343		0
32097	1906	372328	1964-01-15	1964-01-15 00:00:00	1964-04-18	1964-04-18 00:00:00	32020		\N	126855	0	65363002	372328		0
32246	1916	260139	2001-09-09	2001-09-09 00:00:00	2001-09-23	2001-09-23 00:00:00	32020		\N	127434	0	10509002	260139		0
32412	1925	40481087	1956-11-16	1956-11-16 00:00:00	1956-11-23	1956-11-23 00:00:00	32020		\N	128175	0	444814009	40481087		0
22010	1317	40481087	1998-08-16	1998-08-16 00:00:00	1998-08-23	1998-08-23 00:00:00	32020		\N	87298	0	444814009	40481087		0
32757	1946	40481087	1958-08-31	1958-08-31 00:00:00	1958-09-07	1958-09-07 00:00:00	32020		\N	129318	0	444814009	40481087		0
22373	1335	4112343	2010-03-20	2010-03-20 00:00:00	2010-03-27	2010-03-27 00:00:00	32020		\N	88560	0	195662009	4112343		0
33035	1960	4283893	1995-04-22	1995-04-22 00:00:00	1995-06-17	1995-06-17 00:00:00	32020		\N	130365	0	36971009	4283893		0
22717	1356	4112343	2001-08-11	2001-08-11 00:00:00	2001-08-22	2001-08-22 00:00:00	32020		\N	89945	0	195662009	4112343		0
33373	1980	260139	1985-03-22	1985-03-22 00:00:00	1985-04-05	1985-04-05 00:00:00	32020		\N	131880	0	10509002	260139		0
23053	1376	4146173	1987-07-22	1987-07-22 00:00:00	1987-08-21	1987-08-21 00:00:00	32020		\N	91202	0	307731004	4146173		0
23187	1384	4146173	1996-04-08	1996-04-08 00:00:00	1996-06-14	1996-06-14 00:00:00	32020		\N	91748	0	307731004	4146173		0
33882	2012	4237458	1970-07-23	1970-07-23 00:00:00	1970-08-22	1970-08-22 00:00:00	32020		\N	133863	0	58150001	4237458		0
34059	2025	260139	1965-10-30	1965-10-30 00:00:00	1965-11-13	1965-11-13 00:00:00	32020		\N	134692	0	10509002	260139		0
23728	1415	40481087	2017-11-18	2017-11-18 00:00:00	2017-12-09	2017-12-09 00:00:00	32020		\N	94181	0	444814009	40481087		0
34418	2043	40481087	2000-12-01	2000-12-01 00:00:00	2000-12-22	2000-12-22 00:00:00	32020		\N	135936	0	444814009	40481087		0
24008	1432	40481087	1993-07-04	1993-07-04 00:00:00	1993-07-18	1993-07-18 00:00:00	32020		\N	95394	0	444814009	40481087		0
34756	2063	4112343	1985-01-09	1985-01-09 00:00:00	1985-01-18	1985-01-18 00:00:00	32020		\N	137218	0	195662009	4112343		0
34929	2075	4218389	1980-06-14	1980-06-14 00:00:00	1980-07-19	1980-07-19 00:00:00	32020		\N	138000	0	39848009	4218389		0
24528	1464	4113008	1970-11-04	1970-11-04 00:00:00	1970-11-25	1970-11-25 00:00:00	32020		\N	97581	0	284549007	4113008		0
24713	1475	4059173	1951-02-25	1951-02-25 00:00:00	1951-04-26	1951-04-26 00:00:00	32020		\N	98248	0	16114001	4059173		0
35410	2097	40481087	2011-11-03	2011-11-03 00:00:00	2011-11-24	2011-11-24 00:00:00	32020		\N	139778	0	444814009	40481087		0
35533	2105	40481087	1982-05-06	1982-05-06 00:00:00	1982-05-13	1982-05-13 00:00:00	32020		\N	140243	0	444814009	40481087		0
25201	1504	80180	1985-01-15	1985-01-15 00:00:00	\N	\N	32020		\N	100286	0	396275006	80180		0
25336	1510	372328	1974-02-17	1974-02-17 00:00:00	1974-06-23	1974-06-23 00:00:00	32020		\N	100776	0	65363002	372328		0
36042	2136	40481087	1972-07-15	1972-07-15 00:00:00	1972-07-29	1972-07-29 00:00:00	32020		\N	142299	0	444814009	40481087		0
36199	2145	40481087	1965-10-20	1965-10-20 00:00:00	1965-11-03	1965-11-03 00:00:00	32020		\N	142783	0	444814009	40481087		0
36378	2152	4296204	1949-08-02	1949-08-02 00:00:00	1949-08-16	1949-08-16 00:00:00	32020		\N	143416	0	403190006	4296204		0
26062	1545	4285898	2005-09-18	2005-09-18 00:00:00	\N	\N	32020		\N	103532	0	68496003	4285898		0
36698	2172	4112343	1985-05-06	1985-05-06 00:00:00	1985-05-15	1985-05-15 00:00:00	32020		\N	144662	0	195662009	4112343		0
36857	2180	78272	2010-12-25	2010-12-25 00:00:00	2011-01-15	2011-01-15 00:00:00	32020		\N	145420	0	70704007	78272		0
26480	1569	4116491	1972-08-26	1972-08-26 00:00:00	1972-10-15	1972-10-15 00:00:00	32020		\N	105255	0	301011002	4116491		0
26689	1579	40481087	2008-05-05	2008-05-05 00:00:00	2008-05-12	2008-05-12 00:00:00	32020		\N	106055	0	444814009	40481087		0
37362	2213	4048695	1969-05-08	1969-05-08 00:00:00	1969-07-08	1969-07-08 00:00:00	32020		\N	147423	0	15724005	4048695		0
27021	1599	40481087	2013-09-12	2013-09-12 00:00:00	2013-09-19	2013-09-19 00:00:00	32020		\N	107332	0	444814009	40481087		0
27169	1605	4112343	2007-08-10	2007-08-10 00:00:00	2007-08-23	2007-08-23 00:00:00	32020		\N	107759	0	195662009	4112343		0
27388	1613	40481087	2006-03-20	2006-03-20 00:00:00	2006-04-03	2006-04-03 00:00:00	32020		\N	108500	0	444814009	40481087		0
38082	2260	4112343	1982-02-10	1982-02-10 00:00:00	1982-02-19	1982-02-19 00:00:00	32020		\N	150195	0	195662009	4112343		0
38185	2267	260139	1983-10-21	1983-10-21 00:00:00	1983-10-28	1983-10-28 00:00:00	32020		\N	150708	0	10509002	260139		0
38432	2283	40481087	1962-10-06	1962-10-06 00:00:00	1962-10-27	1962-10-27 00:00:00	32020		\N	151907	0	444814009	40481087		0
38586	2290	40481087	2013-04-08	2013-04-08 00:00:00	2013-04-29	2013-04-29 00:00:00	32020		\N	152361	0	444814009	40481087		0
28205	1666	40481087	1960-02-16	1960-02-16 00:00:00	1960-03-08	1960-03-08 00:00:00	32020		\N	111944	0	444814009	40481087		0
38849	2307	260139	1993-01-20	1993-01-20 00:00:00	1993-02-03	1993-02-03 00:00:00	32020		\N	153486	0	10509002	260139		0
39044	2319	40481087	1963-01-10	1963-01-10 00:00:00	1963-01-24	1963-01-24 00:00:00	32020		\N	154160	0	444814009	40481087		0
28647	1695	4218389	2000-06-29	2000-06-29 00:00:00	2000-08-03	2000-08-03 00:00:00	32020		\N	113482	0	39848009	4218389		0
39360	2333	372328	1922-12-18	1922-12-18 00:00:00	1923-05-08	1923-05-08 00:00:00	32020		\N	155209	0	65363002	372328		0
29010	1718	4112343	1972-07-21	1972-07-21 00:00:00	1972-08-03	1972-08-03 00:00:00	32020		\N	114848	0	195662009	4112343		0
29214	1729	28060	2015-01-03	2015-01-03 00:00:00	2015-01-16	2015-01-16 00:00:00	32020		\N	115658	0	43878008	28060		0
29366	1739	133834	1970-05-08	1970-05-08 00:00:00	\N	\N	32020		\N	116200	0	24079001	133834		0
29502	1746	372328	1996-05-16	1996-05-16 00:00:00	1996-11-28	1996-11-28 00:00:00	32020		\N	116730	0	65363002	372328		0
29670	1756	30753	2012-06-22	2012-06-22 00:00:00	\N	\N	32020		\N	117449	0	16761005	30753		0
29816	1764	4285898	1996-06-15	1996-06-15 00:00:00	\N	\N	32020		\N	117957	0	68496003	4285898		0
40511	2406	4112343	1974-07-22	1974-07-22 00:00:00	1974-08-01	1974-08-01 00:00:00	32020		\N	159840	0	195662009	4112343		0
40693	2419	372328	1949-07-26	1949-07-26 00:00:00	1949-09-30	1949-09-30 00:00:00	32020		\N	160595	0	65363002	372328		0
40838	2428	40481087	1975-10-25	1975-10-25 00:00:00	1975-11-15	1975-11-15 00:00:00	32020		\N	161067	0	444814009	40481087		0
41104	2443	260139	1963-10-22	1963-10-22 00:00:00	1963-10-28	1963-10-28 00:00:00	32020		\N	162025	0	10509002	260139		0
41169	2447	40481087	2000-03-29	2000-03-29 00:00:00	2000-04-05	2000-04-05 00:00:00	32020		\N	162312	0	444814009	40481087		0
41353	2459	4112343	1978-08-25	1978-08-25 00:00:00	1978-09-05	1978-09-05 00:00:00	32020		\N	163050	0	195662009	4112343		0
31034	1837	4112343	2017-01-28	2017-01-28 00:00:00	2017-02-10	2017-02-10 00:00:00	32020		\N	122718	0	195662009	4112343		0
31196	1846	4059173	2007-04-24	2007-04-24 00:00:00	2007-06-23	2007-06-23 00:00:00	32020		\N	123469	0	16114001	4059173		0
31345	1852	81151	1989-05-12	1989-05-12 00:00:00	1989-06-02	1989-06-02 00:00:00	32020		\N	123946	0	44465007	81151		0
42020	2501	372328	1966-08-28	1966-08-28 00:00:00	1966-11-07	1966-11-07 00:00:00	32020		\N	165541	0	65363002	372328		0
42245	2518	40481087	1978-04-23	1978-04-23 00:00:00	1978-05-14	1978-05-14 00:00:00	32020		\N	166503	0	444814009	40481087		0
42388	2525	4112343	1991-06-17	1991-06-17 00:00:00	1991-06-25	1991-06-25 00:00:00	32020		\N	166976	0	195662009	4112343		0
21403	1283	198809	1972-04-22	1972-04-22 00:00:00	1972-04-22	1972-04-22 00:00:00	32020		\N	84823	0	65275009	198809		0
32098	1906	260139	1975-10-27	1975-10-27 00:00:00	1975-11-03	1975-11-03 00:00:00	32020		\N	126865	0	10509002	260139		0
32247	1916	40481087	2004-05-23	2004-05-23 00:00:00	2004-05-30	2004-05-30 00:00:00	32020		\N	127420	0	444814009	40481087		0
32413	1925	40481087	1970-01-01	1970-01-01 00:00:00	1970-01-22	1970-01-22 00:00:00	32020		\N	128125	0	444814009	40481087		0
22011	1317	4156265	1971-02-23	1971-02-23 00:00:00	1971-03-16	1971-03-16 00:00:00	32020		\N	87276	0	370247008	4156265		0
32758	1946	313217	2014-01-04	2014-01-04 00:00:00	\N	\N	32020		\N	129354	0	49436004	313217		0
22374	1335	4112343	1984-12-15	1984-12-15 00:00:00	1984-12-27	1984-12-27 00:00:00	32020		\N	88562	0	195662009	4112343		0
33036	1960	4027663	1959-07-01	1959-07-01 00:00:00	\N	\N	32020		\N	130349	0	13200003	4027663		0
22718	1356	4027663	2005-01-27	2005-01-27 00:00:00	\N	\N	32020		\N	89925	0	13200003	4027663		0
33374	1980	4059173	1982-03-22	1982-03-22 00:00:00	1982-06-20	1982-06-20 00:00:00	32020		\N	131804	0	16114001	4059173		0
23054	1376	260139	2007-09-11	2007-09-11 00:00:00	2007-09-25	2007-09-25 00:00:00	32020		\N	91180	0	10509002	260139		0
23188	1384	80180	2016-11-27	2016-11-27 00:00:00	\N	\N	32020		\N	91784	0	396275006	80180		0
33883	2012	4112343	1987-08-07	1987-08-07 00:00:00	1987-08-17	1987-08-17 00:00:00	32020		\N	133920	0	195662009	4112343		0
34060	2025	40481087	1946-08-09	1946-08-09 00:00:00	1946-08-23	1946-08-23 00:00:00	32020		\N	134631	0	444814009	40481087		0
23729	1415	40481087	2001-05-27	2001-05-27 00:00:00	2001-06-10	2001-06-10 00:00:00	32020		\N	94198	0	444814009	40481087		0
34419	2043	372328	1958-05-28	1958-05-28 00:00:00	1958-08-17	1958-08-17 00:00:00	32020		\N	135907	0	65363002	372328		0
24009	1432	40481087	1991-06-27	1991-06-27 00:00:00	1991-07-11	1991-07-11 00:00:00	32020		\N	95410	0	444814009	40481087		0
34757	2063	40481087	1988-01-26	1988-01-26 00:00:00	1988-02-02	1988-02-02 00:00:00	32020		\N	137219	0	444814009	40481087		0
34930	2075	81151	2012-06-01	2012-06-01 00:00:00	2012-06-29	2012-06-29 00:00:00	32020		\N	138002	0	44465007	81151		0
24529	1464	40481087	1982-08-08	1982-08-08 00:00:00	1982-08-29	1982-08-29 00:00:00	32020		\N	97513	0	444814009	40481087		0
24714	1475	4146173	1990-06-12	1990-06-12 00:00:00	1990-07-12	1990-07-12 00:00:00	32020		\N	98316	0	307731004	4146173		0
35411	2097	40481087	1989-04-07	1989-04-07 00:00:00	1989-04-14	1989-04-14 00:00:00	32020		\N	139775	0	444814009	40481087		0
35534	2105	4027663	2001-08-11	2001-08-11 00:00:00	\N	\N	32020		\N	140238	0	13200003	4027663		0
25202	1504	28060	1960-11-30	1960-11-30 00:00:00	1960-12-12	1960-12-12 00:00:00	32020		\N	100268	0	43878008	28060		0
25337	1510	372328	1959-10-28	1959-10-28 00:00:00	1960-01-10	1960-01-10 00:00:00	32020		\N	100863	0	65363002	372328		0
36043	2136	40481087	2017-06-28	2017-06-28 00:00:00	2017-07-05	2017-07-05 00:00:00	32020		\N	142271	0	444814009	40481087		0
36200	2145	4112343	2016-12-04	2016-12-04 00:00:00	2016-12-17	2016-12-17 00:00:00	32020		\N	142837	0	195662009	4112343		0
36379	2153	4112343	2009-12-18	2009-12-18 00:00:00	2009-12-31	2009-12-31 00:00:00	32020		\N	143508	0	195662009	4112343		0
36545	2164	260139	1978-08-30	1978-08-30 00:00:00	1978-09-13	1978-09-13 00:00:00	32020		\N	144180	0	10509002	260139		0
36699	2172	40481087	1982-03-27	1982-03-27 00:00:00	1982-04-10	1982-04-10 00:00:00	32020		\N	144689	0	444814009	40481087		0
36858	2180	40481087	1991-04-15	1991-04-15 00:00:00	1991-05-06	1991-05-06 00:00:00	32020		\N	145407	0	444814009	40481087		0
26481	1569	260139	2016-06-24	2016-06-24 00:00:00	2016-07-08	2016-07-08 00:00:00	32020		\N	105273	0	10509002	260139		0
26690	1579	81151	2013-05-29	2013-05-29 00:00:00	2013-07-03	2013-07-03 00:00:00	32020		\N	106104	0	44465007	81151		0
37363	2213	4112343	1989-05-19	1989-05-19 00:00:00	1989-05-26	1989-05-26 00:00:00	32020		\N	147356	0	195662009	4112343		0
27022	1599	260139	1962-09-28	1962-09-28 00:00:00	1962-10-12	1962-10-12 00:00:00	32020		\N	107321	0	10509002	260139		0
27170	1605	81151	1984-03-23	1984-03-23 00:00:00	1984-04-27	1984-04-27 00:00:00	32020		\N	107748	0	44465007	81151		0
27389	1613	195588	1994-06-10	1994-06-10 00:00:00	1994-07-28	1994-07-28 00:00:00	32020		\N	108484	0	38822007	195588		0
38083	2260	257012	1984-11-06	1984-11-06 00:00:00	\N	\N	32020		\N	150248	0	40055000	257012		0
38186	2267	372328	1971-10-08	1971-10-08 00:00:00	1971-11-29	1971-11-29 00:00:00	32020		\N	150687	0	65363002	372328		0
38433	2283	4149245	1987-02-28	1987-02-28 00:00:00	1987-04-06	1987-04-06 00:00:00	32020		\N	151882	0	30832001	4149245		0
38587	2290	4155034	1999-08-13	1999-08-13 00:00:00	1999-09-03	1999-09-03 00:00:00	32020		\N	152339	0	283371005	4155034		0
28206	1666	4059173	1941-11-19	1941-11-19 00:00:00	1941-12-19	1941-12-19 00:00:00	32020		\N	111876	0	16114001	4059173		0
38850	2307	372328	1963-06-25	1963-06-25 00:00:00	1963-09-10	1963-09-10 00:00:00	32020		\N	153530	0	65363002	372328		0
39045	2319	378001	1953-09-25	1953-09-25 00:00:00	1953-10-25	1953-10-25 00:00:00	32020		\N	154133	0	62106007	378001		0
28648	1695	192671	2010-07-26	2010-07-26 00:00:00	\N	\N	32020		\N	113498	0	K92.2	35208414		0
39361	2333	378419	2001-06-19	2001-06-19 00:00:00	\N	\N	32020		\N	155252	0	26929004	378419		0
29011	1718	260139	1991-10-27	1991-10-27 00:00:00	1991-11-03	1991-11-03 00:00:00	32020		\N	114851	0	10509002	260139		0
29215	1729	4112343	2001-05-05	2001-05-05 00:00:00	2001-05-15	2001-05-15 00:00:00	32020		\N	115611	0	195662009	4112343		0
29367	1739	4112343	1969-03-11	1969-03-11 00:00:00	1969-03-22	1969-03-22 00:00:00	32020		\N	116209	0	195662009	4112343		0
29503	1746	81151	1953-10-09	1953-10-09 00:00:00	1953-11-06	1953-11-06 00:00:00	32020		\N	116761	0	44465007	81151		0
29671	1756	40481087	2011-12-12	2011-12-12 00:00:00	2011-12-19	2011-12-19 00:00:00	32020		\N	117449	0	444814009	40481087		0
29817	1764	80180	1996-12-12	1996-12-12 00:00:00	\N	\N	32020		\N	117957	0	396275006	80180		0
40512	2406	381316	1993-09-23	1993-09-23 00:00:00	\N	\N	32020		\N	159858	0	230690007	381316		0
40694	2419	4112343	1965-02-15	1965-02-15 00:00:00	1965-02-27	1965-02-27 00:00:00	32020		\N	160570	0	195662009	4112343		0
40839	2428	40481087	2007-08-29	2007-08-29 00:00:00	2007-09-19	2007-09-19 00:00:00	32020		\N	161085	0	444814009	40481087		0
41105	2443	372328	1965-05-12	1965-05-12 00:00:00	1965-10-29	1965-10-29 00:00:00	32020		\N	162029	0	65363002	372328		0
41170	2447	260139	1985-06-27	1985-06-27 00:00:00	1985-07-04	1985-07-04 00:00:00	32020		\N	162303	0	10509002	260139		0
41354	2459	4278672	1993-04-23	1993-04-23 00:00:00	1993-05-23	1993-05-23 00:00:00	32020		\N	163067	0	65966004	4278672		0
31035	1837	78272	1974-04-30	1974-04-30 00:00:00	1974-05-28	1974-05-28 00:00:00	32020		\N	122693	0	70704007	78272		0
31197	1846	260139	1975-10-24	1975-10-24 00:00:00	1975-11-07	1975-11-07 00:00:00	32020		\N	123399	0	10509002	260139		0
31346	1852	260139	1974-05-03	1974-05-03 00:00:00	1974-05-10	1974-05-10 00:00:00	32020		\N	123893	0	10509002	260139		0
42021	2501	81151	1974-04-07	1974-04-07 00:00:00	1974-05-05	1974-05-05 00:00:00	32020		\N	165574	0	44465007	81151		0
42246	2518	195588	1976-10-07	1976-10-07 00:00:00	1976-11-11	1976-11-11 00:00:00	32020		\N	166504	0	38822007	195588		0
42389	2525	40481087	2006-05-29	2006-05-29 00:00:00	2006-06-05	2006-06-05 00:00:00	32020		\N	166944	0	444814009	40481087		0
21404	1283	196456	1972-04-22	1972-04-22 00:00:00	1972-04-22	1972-04-22 00:00:00	32020		\N	84823	0	235919008	196456		0
32099	1906	4112343	1963-04-04	1963-04-04 00:00:00	1963-04-13	1963-04-13 00:00:00	32020		\N	126863	0	195662009	4112343		0
32248	1916	40481087	1976-01-17	1976-01-17 00:00:00	1976-01-31	1976-01-31 00:00:00	32020		\N	127475	0	444814009	40481087		0
32414	1925	40481087	1962-04-03	1962-04-03 00:00:00	1962-04-17	1962-04-17 00:00:00	32020		\N	128123	0	444814009	40481087		0
22012	1317	372328	1952-12-03	1952-12-03 00:00:00	1953-01-16	1953-01-16 00:00:00	32020		\N	87283	0	65363002	372328		0
32759	1946	40481087	1985-06-14	1985-06-14 00:00:00	1985-06-21	1985-06-21 00:00:00	32020		\N	129309	0	444814009	40481087		0
22375	1335	372328	1979-11-15	1979-11-15 00:00:00	1980-01-28	1980-01-28 00:00:00	32020		\N	88576	0	65363002	372328		0
33037	1960	195588	1955-09-29	1955-09-29 00:00:00	1955-11-20	1955-11-20 00:00:00	32020		\N	130337	0	38822007	195588		0
22719	1356	4112343	1988-01-06	1988-01-06 00:00:00	1988-01-19	1988-01-19 00:00:00	32020		\N	89886	0	195662009	4112343		0
33375	1980	4112343	1991-02-15	1991-02-15 00:00:00	1991-02-25	1991-02-25 00:00:00	32020		\N	131786	0	195662009	4112343		0
23055	1376	372328	1979-12-31	1979-12-31 00:00:00	1980-04-18	1980-04-18 00:00:00	32020		\N	91206	0	65363002	372328		0
23189	1384	4112343	1987-09-20	1987-09-20 00:00:00	1987-09-28	1987-09-28 00:00:00	32020		\N	91765	0	195662009	4112343		0
33884	2012	40481087	2017-08-30	2017-08-30 00:00:00	2017-09-06	2017-09-06 00:00:00	32020		\N	133900	0	444814009	40481087		0
34061	2025	80180	1946-12-28	1946-12-28 00:00:00	\N	\N	32020		\N	134631	0	396275006	80180		0
23730	1415	80180	2002-12-09	2002-12-09 00:00:00	\N	\N	32020		\N	94198	0	396275006	80180		0
34420	2043	260139	1966-09-15	1966-09-15 00:00:00	1966-09-29	1966-09-29 00:00:00	32020		\N	135927	0	10509002	260139		0
24010	1432	81151	1984-05-28	1984-05-28 00:00:00	1984-06-25	1984-06-25 00:00:00	32020		\N	95407	0	44465007	81151		0
34758	2063	260139	2008-04-30	2008-04-30 00:00:00	2008-05-14	2008-05-14 00:00:00	32020		\N	137250	0	10509002	260139		0
34931	2075	260139	1993-05-08	1993-05-08 00:00:00	1993-05-22	1993-05-22 00:00:00	32020		\N	138107	0	10509002	260139		0
24530	1464	80180	2002-08-13	2002-08-13 00:00:00	\N	\N	32020		\N	97550	0	396275006	80180		0
24715	1475	4112343	2002-11-14	2002-11-14 00:00:00	2002-11-23	2002-11-23 00:00:00	32020		\N	98262	0	195662009	4112343		0
35412	2097	4112343	1986-12-15	1986-12-15 00:00:00	1986-12-23	1986-12-23 00:00:00	32020		\N	139769	0	195662009	4112343		0
35535	2105	40481087	2000-06-20	2000-06-20 00:00:00	2000-07-11	2000-07-11 00:00:00	32020		\N	140238	0	444814009	40481087		0
25203	1504	40481087	1989-03-01	1989-03-01 00:00:00	1989-03-08	1989-03-08 00:00:00	32020		\N	100241	0	444814009	40481087		0
25338	1510	260139	1992-11-14	1992-11-14 00:00:00	1992-11-21	1992-11-21 00:00:00	32020		\N	100856	0	10509002	260139		0
36044	2136	260139	1988-01-26	1988-01-26 00:00:00	1988-02-02	1988-02-02 00:00:00	32020		\N	142213	0	10509002	260139		0
36201	2145	372328	1969-02-22	1969-02-22 00:00:00	1969-08-23	1969-08-23 00:00:00	32020		\N	142792	0	65363002	372328		0
36380	2153	372328	1966-09-16	1966-09-16 00:00:00	1966-10-29	1966-10-29 00:00:00	32020		\N	143521	0	65363002	372328		0
36546	2164	260139	1992-02-07	1992-02-07 00:00:00	1992-02-14	1992-02-14 00:00:00	32020		\N	144161	0	10509002	260139		0
36700	2172	80180	2012-07-20	2012-07-20 00:00:00	\N	\N	32020		\N	144675	0	396275006	80180		0
36859	2180	40481087	2011-02-17	2011-02-17 00:00:00	2011-03-10	2011-03-10 00:00:00	32020		\N	145403	0	444814009	40481087		0
26482	1569	40481087	1985-11-06	1985-11-06 00:00:00	1985-11-13	1985-11-13 00:00:00	32020		\N	105258	0	444814009	40481087		0
26691	1579	381316	1999-04-29	1999-04-29 00:00:00	\N	\N	32020		\N	106071	0	230690007	381316		0
37364	2213	4112343	1982-01-01	1982-01-01 00:00:00	1982-01-12	1982-01-12 00:00:00	32020		\N	147389	0	195662009	4112343		0
27023	1599	4112343	1987-02-26	1987-02-26 00:00:00	1987-03-10	1987-03-10 00:00:00	32020		\N	107293	0	195662009	4112343		0
27171	1605	260139	1992-08-20	1992-08-20 00:00:00	1992-08-27	1992-08-27 00:00:00	32020		\N	107671	0	10509002	260139		0
27390	1613	4285898	1992-04-20	1992-04-20 00:00:00	\N	\N	32020		\N	108478	0	68496003	4285898		0
38084	2260	4237458	1994-09-02	1994-09-02 00:00:00	1994-12-01	1994-12-01 00:00:00	32020		\N	150220	0	58150001	4237458		0
38187	2267	40481087	2008-10-14	2008-10-14 00:00:00	2008-11-04	2008-11-04 00:00:00	32020		\N	150684	0	444814009	40481087		0
38434	2283	40481087	1940-07-09	1940-07-09 00:00:00	1940-07-23	1940-07-23 00:00:00	32020		\N	151845	0	444814009	40481087		0
38588	2291	40481087	1978-09-19	1978-09-19 00:00:00	1978-09-26	1978-09-26 00:00:00	32020		\N	152450	0	444814009	40481087		0
28207	1666	40481087	2002-05-28	2002-05-28 00:00:00	2002-06-18	2002-06-18 00:00:00	32020		\N	111933	0	444814009	40481087		0
38851	2307	4109685	1972-03-09	1972-03-09 00:00:00	1972-03-23	1972-03-23 00:00:00	32020		\N	153483	0	284551006	4109685		0
39046	2319	80502	2017-10-14	2017-10-14 00:00:00	\N	\N	32020		\N	154146	0	64859006	80502		0
28649	1695	4112343	1970-11-08	1970-11-08 00:00:00	1970-11-21	1970-11-21 00:00:00	32020		\N	113435	0	195662009	4112343		0
39362	2333	40481087	1957-09-14	1957-09-14 00:00:00	1957-09-28	1957-09-28 00:00:00	32020		\N	155201	0	444814009	40481087		0
29012	1718	28060	1982-11-23	1982-11-23 00:00:00	1982-12-05	1982-12-05 00:00:00	32020		\N	114850	0	43878008	28060		0
29216	1729	260139	1985-07-28	1985-07-28 00:00:00	1985-08-11	1985-08-11 00:00:00	32020		\N	115643	0	10509002	260139		0
29368	1739	40481087	1970-11-17	1970-11-17 00:00:00	1970-11-24	1970-11-24 00:00:00	32020		\N	116215	0	444814009	40481087		0
29504	1746	28060	1997-08-09	1997-08-09 00:00:00	1997-08-20	1997-08-20 00:00:00	32020		\N	116723	0	43878008	28060		0
29672	1756	375671	1982-08-14	1982-08-14 00:00:00	1982-09-13	1982-09-13 00:00:00	32020		\N	117445	0	62564004	375671		0
29818	1764	81893	1995-03-23	1995-03-23 00:00:00	\N	\N	32020		\N	117957	0	64766004	81893		0
40513	2406	28060	1975-05-30	1975-05-30 00:00:00	1975-06-10	1975-06-10 00:00:00	32020		\N	159841	0	43878008	28060		0
40695	2419	4152936	1959-05-10	1959-05-10 00:00:00	1959-05-24	1959-05-24 00:00:00	32020		\N	160506	0	283385000	4152936		0
40840	2428	4156265	1977-04-10	1977-04-10 00:00:00	1977-04-24	1977-04-24 00:00:00	32020		\N	161123	0	370247008	4156265		0
41106	2443	260139	2009-09-05	2009-09-05 00:00:00	2009-09-12	2009-09-12 00:00:00	32020		\N	162044	0	10509002	260139		0
41171	2447	80180	2017-02-27	2017-02-27 00:00:00	\N	\N	32020		\N	162330	0	396275006	80180		0
41355	2459	372328	1980-06-30	1980-06-30 00:00:00	1981-06-01	1981-06-01 00:00:00	32020		\N	163033	0	65363002	372328		0
31036	1837	440086	1973-05-10	1973-05-10 00:00:00	1973-12-20	1973-12-20 00:00:00	32020		\N	122666	0	192127007	440086		0
31198	1846	192671	1987-12-07	1987-12-07 00:00:00	\N	\N	32020		\N	123479	0	K92.2	35208414		0
31347	1852	372328	1977-04-26	1977-04-26 00:00:00	1978-02-01	1978-02-01 00:00:00	32020		\N	123919	0	65363002	372328		0
42038	2503	378001	1992-07-08	1992-07-08 00:00:00	1992-09-06	1992-09-06 00:00:00	32020		\N	165650	0	62106007	378001		0
42247	2518	4112343	2010-12-18	2010-12-18 00:00:00	2010-12-25	2010-12-25 00:00:00	32020		\N	166583	0	195662009	4112343		0
42390	2525	4112343	2014-03-28	2014-03-28 00:00:00	2014-04-10	2014-04-10 00:00:00	32020		\N	166955	0	195662009	4112343		0
21405	1283	81151	1967-01-01	1967-01-01 00:00:00	1967-01-15	1967-01-15 00:00:00	32020		\N	84821	0	44465007	81151		0
32100	1906	40481087	1974-03-22	1974-03-22 00:00:00	1974-03-29	1974-03-29 00:00:00	32020		\N	126871	0	444814009	40481087		0
32249	1916	4109685	1973-09-23	1973-09-23 00:00:00	1973-10-07	1973-10-07 00:00:00	32020		\N	127439	0	284551006	4109685		0
32415	1925	4237458	1957-06-16	1957-06-16 00:00:00	1957-07-16	1957-07-16 00:00:00	32020		\N	128083	0	58150001	4237458		0
22013	1317	4112343	2001-09-10	2001-09-10 00:00:00	2001-09-17	2001-09-17 00:00:00	32020		\N	87247	0	195662009	4112343		0
32760	1946	40481087	1986-04-26	1986-04-26 00:00:00	1986-05-03	1986-05-03 00:00:00	32020		\N	129322	0	444814009	40481087		0
22376	1335	40481087	2008-11-03	2008-11-03 00:00:00	2008-11-10	2008-11-10 00:00:00	32020		\N	88564	0	444814009	40481087		0
33038	1960	4112343	1944-01-13	1944-01-13 00:00:00	1944-01-21	1944-01-21 00:00:00	32020		\N	130319	0	195662009	4112343		0
22720	1356	440086	1980-02-03	1980-02-03 00:00:00	1989-02-10	1989-02-10 00:00:00	32020		\N	89874	0	192127007	440086		0
33376	1980	28060	1976-11-19	1976-11-19 00:00:00	1976-11-28	1976-11-28 00:00:00	32020		\N	131825	0	43878008	28060		0
23056	1376	40481087	1981-03-02	1981-03-02 00:00:00	1981-03-16	1981-03-16 00:00:00	32020		\N	91198	0	444814009	40481087		0
23190	1384	40481087	2006-05-06	2006-05-06 00:00:00	2006-05-13	2006-05-13 00:00:00	32020		\N	91788	0	444814009	40481087		0
33885	2012	440448	1996-01-25	1996-01-25 00:00:00	\N	\N	32020		\N	133867	0	74400008	440448		0
34062	2025	381316	2007-07-21	2007-07-21 00:00:00	\N	\N	32020		\N	134648	0	230690007	381316		0
23731	1415	4294548	1997-08-20	1997-08-20 00:00:00	1997-10-08	1997-10-08 00:00:00	32020		\N	94197	0	75498004	4294548		0
34421	2043	80180	1997-08-21	1997-08-21 00:00:00	\N	\N	32020		\N	135905	0	396275006	80180		0
24011	1432	4112343	1991-05-03	1991-05-03 00:00:00	1991-05-13	1991-05-13 00:00:00	32020		\N	95409	0	195662009	4112343		0
34759	2063	40481087	2014-07-26	2014-07-26 00:00:00	2014-08-02	2014-08-02 00:00:00	32020		\N	137221	0	444814009	40481087		0
34932	2075	192671	2006-05-05	2006-05-05 00:00:00	\N	\N	32020		\N	138115	0	K92.2	35208414		0
24531	1464	4112343	2002-06-01	2002-06-01 00:00:00	2002-06-09	2002-06-09 00:00:00	32020		\N	97550	0	195662009	4112343		0
24716	1475	260139	2000-01-09	2000-01-09 00:00:00	2000-01-23	2000-01-23 00:00:00	32020		\N	98275	0	10509002	260139		0
35413	2097	372328	1979-04-24	1979-04-24 00:00:00	1979-08-11	1979-08-11 00:00:00	32020		\N	139765	0	65363002	372328		0
35536	2105	4285898	2012-06-29	2012-06-29 00:00:00	\N	\N	32020		\N	140260	0	68496003	4285898		0
25204	1504	260139	2004-10-17	2004-10-17 00:00:00	2004-10-31	2004-10-31 00:00:00	32020		\N	100278	0	10509002	260139		0
25339	1510	40481087	2016-07-11	2016-07-11 00:00:00	2016-08-01	2016-08-01 00:00:00	32020		\N	100862	0	444814009	40481087		0
36045	2136	134438	2001-05-31	2001-05-31 00:00:00	2002-01-29	2002-01-29 00:00:00	32020		\N	142304	0	40275004	134438		0
36202	2145	4134304	1965-12-10	1965-12-10 00:00:00	1966-02-08	1966-02-08 00:00:00	32020		\N	142797	0	263102004	4134304		0
36381	2153	4283893	1994-11-07	1994-11-07 00:00:00	1995-04-03	1995-04-03 00:00:00	32020		\N	143484	0	36971009	4283893		0
36547	2164	260139	2018-12-26	2018-12-26 00:00:00	2019-01-09	2019-01-09 00:00:00	32020		\N	144126	0	10509002	260139		0
36701	2172	4294548	1996-11-20	1996-11-20 00:00:00	1996-11-27	1996-11-27 00:00:00	32020		\N	144692	0	75498004	4294548		0
36860	2180	40481087	2013-11-17	2013-11-17 00:00:00	2013-11-24	2013-11-24 00:00:00	32020		\N	145408	0	444814009	40481087		0
26483	1569	4294548	1979-04-03	1979-04-03 00:00:00	1979-04-10	1979-04-10 00:00:00	32020		\N	105293	0	75498004	4294548		0
26692	1579	4112343	1973-11-03	1973-11-03 00:00:00	1973-11-11	1973-11-11 00:00:00	32020		\N	106054	0	195662009	4112343		0
37365	2213	134438	1991-07-19	1991-07-19 00:00:00	1993-02-10	1993-02-10 00:00:00	32020		\N	147360	0	40275004	134438		0
27024	1599	4027663	1987-05-03	1987-05-03 00:00:00	\N	\N	32020		\N	107293	0	13200003	4027663		0
27172	1605	260139	1964-10-31	1964-10-31 00:00:00	1964-11-14	1964-11-14 00:00:00	32020		\N	107677	0	10509002	260139		0
37849	2242	4112343	1933-12-19	1933-12-19 00:00:00	1934-01-01	1934-01-01 00:00:00	32020		\N	149264	0	195662009	4112343		0
38085	2260	260139	1952-02-17	1952-02-17 00:00:00	1952-02-24	1952-02-24 00:00:00	32020		\N	150179	0	10509002	260139		0
38188	2267	80180	2009-11-17	2009-11-17 00:00:00	\N	\N	32020		\N	150684	0	396275006	80180		0
38435	2283	40481087	1951-03-24	1951-03-24 00:00:00	1951-04-14	1951-04-14 00:00:00	32020		\N	151848	0	444814009	40481087		0
38589	2291	40481087	2014-12-01	2014-12-01 00:00:00	2014-12-08	2014-12-08 00:00:00	32020		\N	152428	0	444814009	40481087		0
28208	1666	4112343	1953-04-13	1953-04-13 00:00:00	1953-04-25	1953-04-25 00:00:00	32020		\N	111853	0	195662009	4112343		0
38852	2307	372328	1985-07-16	1985-07-16 00:00:00	1986-12-09	1986-12-09 00:00:00	32020		\N	153490	0	65363002	372328		0
39047	2319	372328	1949-08-20	1949-08-20 00:00:00	1950-01-21	1950-01-21 00:00:00	32020		\N	154186	0	65363002	372328		0
28650	1695	375671	1998-07-10	1998-07-10 00:00:00	1998-09-08	1998-09-08 00:00:00	32020		\N	113497	0	62564004	375671		0
39363	2333	198809	1978-05-19	1978-05-19 00:00:00	1978-05-19	1978-05-19 00:00:00	32020		\N	155162	0	65275009	198809		0
29013	1718	260139	1980-03-09	1980-03-09 00:00:00	1980-03-23	1980-03-23 00:00:00	32020		\N	114843	0	10509002	260139		0
39675	2349	260139	2010-03-23	2010-03-23 00:00:00	2010-03-30	2010-03-30 00:00:00	32020		\N	156451	0	10509002	260139		0
29369	1739	4112343	1994-09-11	1994-09-11 00:00:00	1994-09-18	1994-09-18 00:00:00	32020		\N	116201	0	195662009	4112343		0
29505	1746	81151	2014-07-10	2014-07-10 00:00:00	2014-08-07	2014-08-07 00:00:00	32020		\N	116765	0	44465007	81151		0
29673	1756	4112343	1993-08-06	1993-08-06 00:00:00	1993-08-15	1993-08-15 00:00:00	32020		\N	117451	0	195662009	4112343		0
40514	2406	260139	1991-03-02	1991-03-02 00:00:00	1991-03-09	1991-03-09 00:00:00	32020		\N	159806	0	10509002	260139		0
40696	2419	4112343	2003-04-03	2003-04-03 00:00:00	2003-04-14	2003-04-14 00:00:00	32020		\N	160609	0	195662009	4112343		0
40841	2428	4112343	1993-09-13	1993-09-13 00:00:00	1993-09-25	1993-09-25 00:00:00	32020		\N	161095	0	195662009	4112343		0
41107	2443	28060	1962-12-25	1962-12-25 00:00:00	1963-01-04	1963-01-04 00:00:00	32020		\N	162085	0	43878008	28060		0
41172	2447	258780	2014-10-08	2014-10-08 00:00:00	\N	\N	32020		\N	162330	0	185086009	258780		0
41356	2459	40481087	2003-07-05	2003-07-05 00:00:00	2003-07-19	2003-07-19 00:00:00	32020		\N	163054	0	444814009	40481087		0
31037	1837	260139	1966-05-11	1966-05-11 00:00:00	1966-05-18	1966-05-18 00:00:00	32020		\N	122723	0	10509002	260139		0
31199	1847	260139	1956-02-29	1956-02-29 00:00:00	1956-03-14	1956-03-14 00:00:00	32020		\N	123511	0	10509002	260139		0
31348	1852	40481087	1992-12-30	1992-12-30 00:00:00	1993-01-20	1993-01-20 00:00:00	32020		\N	123934	0	444814009	40481087		0
42039	2503	4112343	2006-02-06	2006-02-06 00:00:00	2006-02-16	2006-02-16 00:00:00	32020		\N	165690	0	195662009	4112343		0
42248	2518	4113008	1983-08-05	1983-08-05 00:00:00	1983-08-26	1983-08-26 00:00:00	32020		\N	166541	0	284549007	4113008		0
42391	2525	40481087	1983-05-04	1983-05-04 00:00:00	1983-05-18	1983-05-18 00:00:00	32020		\N	166952	0	444814009	40481087		0
21406	1283	40481087	1967-06-08	1967-06-08 00:00:00	1967-06-15	1967-06-15 00:00:00	32020		\N	84841	0	444814009	40481087		0
32101	1906	40481087	1968-08-13	1968-08-13 00:00:00	1968-08-27	1968-08-27 00:00:00	32020		\N	126869	0	444814009	40481087		0
32250	1916	4113008	2004-10-31	2004-10-31 00:00:00	2004-11-21	2004-11-21 00:00:00	32020		\N	127446	0	284549007	4113008		0
32416	1925	40481087	1965-03-01	1965-03-01 00:00:00	1965-03-22	1965-03-22 00:00:00	32020		\N	128141	0	444814009	40481087		0
22014	1317	81151	1952-11-03	1952-11-03 00:00:00	1952-12-08	1952-12-08 00:00:00	32020		\N	87274	0	44465007	81151		0
32761	1946	4112343	1974-07-23	1974-07-23 00:00:00	1974-08-03	1974-08-03 00:00:00	32020		\N	129260	0	195662009	4112343		0
22377	1335	257012	2010-09-28	2010-09-28 00:00:00	\N	\N	32020		\N	88565	0	40055000	257012		0
33039	1960	4112343	1950-11-17	1950-11-17 00:00:00	1950-11-24	1950-11-24 00:00:00	32020		\N	130321	0	195662009	4112343		0
22721	1356	260139	1988-11-04	1988-11-04 00:00:00	1988-11-11	1988-11-11 00:00:00	32020		\N	89875	0	10509002	260139		0
33377	1980	4109685	1983-04-16	1983-04-16 00:00:00	1983-04-30	1983-04-30 00:00:00	32020		\N	131805	0	284551006	4109685		0
23057	1376	439777	1979-11-11	1979-11-11 00:00:00	\N	\N	32020		\N	91181	0	271737000	439777		0
23191	1384	4112343	1995-03-04	1995-03-04 00:00:00	1995-03-11	1995-03-11 00:00:00	32020		\N	91786	0	195662009	4112343		0
33886	2012	372328	1959-12-18	1959-12-18 00:00:00	1960-01-08	1960-01-08 00:00:00	32020		\N	133906	0	65363002	372328		0
34063	2025	4155034	1918-09-01	1918-09-01 00:00:00	1918-09-15	1918-09-15 00:00:00	32020		\N	134662	0	283371005	4155034		0
23732	1415	40481087	2015-09-03	2015-09-03 00:00:00	2015-09-24	2015-09-24 00:00:00	32020		\N	94180	0	444814009	40481087		0
34422	2043	40481087	1997-04-21	1997-04-21 00:00:00	1997-05-12	1997-05-12 00:00:00	32020		\N	135905	0	444814009	40481087		0
24012	1432	40481087	2000-07-13	2000-07-13 00:00:00	2000-08-03	2000-08-03 00:00:00	32020		\N	95417	0	444814009	40481087		0
34760	2063	78272	1979-05-08	1979-05-08 00:00:00	1979-06-12	1979-06-12 00:00:00	32020		\N	137201	0	70704007	78272		0
34933	2075	4218389	2017-05-04	2017-05-04 00:00:00	2017-05-25	2017-05-25 00:00:00	32020		\N	138003	0	39848009	4218389		0
24532	1464	4112343	1975-11-21	1975-11-21 00:00:00	1975-11-30	1975-11-30 00:00:00	32020		\N	97512	0	195662009	4112343		0
24717	1475	4155034	1966-04-21	1966-04-21 00:00:00	1966-05-05	1966-05-05 00:00:00	32020		\N	98250	0	283371005	4155034		0
35414	2097	40481087	2009-11-20	2009-11-20 00:00:00	2009-12-04	2009-12-04 00:00:00	32020		\N	139763	0	444814009	40481087		0
35537	2105	40481087	2018-01-26	2018-01-26 00:00:00	2018-02-02	2018-02-02 00:00:00	32020		\N	140222	0	444814009	40481087		0
25205	1504	372328	1942-06-05	1942-06-05 00:00:00	1942-08-25	1942-08-25 00:00:00	32020		\N	100282	0	65363002	372328		0
25340	1510	4027663	1992-10-24	1992-10-24 00:00:00	\N	\N	32020		\N	100853	0	13200003	4027663		0
36046	2136	372328	1971-07-16	1971-07-16 00:00:00	1971-11-06	1971-11-06 00:00:00	32020		\N	142295	0	65363002	372328		0
36203	2145	40481087	1966-02-07	1966-02-07 00:00:00	1966-02-21	1966-02-21 00:00:00	32020		\N	142788	0	444814009	40481087		0
36382	2153	4112343	1981-12-23	1981-12-23 00:00:00	1982-01-01	1982-01-01 00:00:00	32020		\N	143506	0	195662009	4112343		0
36548	2164	192671	2012-10-14	2012-10-14 00:00:00	\N	\N	32020		\N	144177	0	K92.2	35208414		0
36702	2173	260139	2012-08-27	2012-08-27 00:00:00	2012-09-10	2012-09-10 00:00:00	32020		\N	144750	0	10509002	260139		0
36861	2180	4112343	1984-10-13	1984-10-13 00:00:00	1984-10-23	1984-10-23 00:00:00	32020		\N	145399	0	195662009	4112343		0
26484	1569	81151	1973-01-14	1973-01-14 00:00:00	1973-02-18	1973-02-18 00:00:00	32020		\N	105227	0	44465007	81151		0
26693	1579	4112343	1981-12-31	1981-12-31 00:00:00	1982-01-13	1982-01-13 00:00:00	32020		\N	106083	0	195662009	4112343		0
37366	2213	260139	2011-12-16	2011-12-16 00:00:00	2011-12-23	2011-12-23 00:00:00	32020		\N	147378	0	10509002	260139		0
27025	1599	4310024	1996-05-30	1996-05-30 00:00:00	\N	\N	32020		\N	107307	0	424802006	4310024		0
27173	1605	4112343	1950-08-15	1950-08-15 00:00:00	1950-08-22	1950-08-22 00:00:00	32020		\N	107694	0	195662009	4112343		0
37850	2242	4112343	1954-05-31	1954-05-31 00:00:00	1954-06-09	1954-06-09 00:00:00	32020		\N	149204	0	195662009	4112343		0
38086	2261	81151	2007-11-17	2007-11-17 00:00:00	2007-12-08	2007-12-08 00:00:00	32020		\N	150336	0	44465007	81151		0
38189	2267	4112343	1988-01-03	1988-01-03 00:00:00	1988-01-14	1988-01-14 00:00:00	32020		\N	150724	0	195662009	4112343		0
38436	2283	260139	1941-01-31	1941-01-31 00:00:00	1941-02-07	1941-02-07 00:00:00	32020		\N	151905	0	10509002	260139		0
38590	2291	4134304	1977-12-20	1977-12-20 00:00:00	1978-02-18	1978-02-18 00:00:00	32020		\N	152493	0	263102004	4134304		0
28209	1666	40481087	1985-12-16	1985-12-16 00:00:00	1985-12-23	1985-12-23 00:00:00	32020		\N	111886	0	444814009	40481087		0
38853	2307	4278672	2013-02-07	2013-02-07 00:00:00	2013-03-09	2013-03-09 00:00:00	32020		\N	153485	0	65966004	4278672		0
39048	2319	4112343	1977-03-29	1977-03-29 00:00:00	1977-04-11	1977-04-11 00:00:00	32020		\N	154218	0	195662009	4112343		0
28651	1695	40481087	2006-10-11	2006-10-11 00:00:00	2006-11-01	2006-11-01 00:00:00	32020		\N	113478	0	444814009	40481087		0
39364	2333	196456	1978-05-19	1978-05-19 00:00:00	1978-05-19	1978-05-19 00:00:00	32020		\N	155162	0	235919008	196456		0
29014	1718	4112343	2013-09-09	2013-09-09 00:00:00	2013-09-16	2013-09-16 00:00:00	32020		\N	114853	0	195662009	4112343		0
39676	2349	4109685	1994-05-03	1994-05-03 00:00:00	1994-05-17	1994-05-17 00:00:00	32020		\N	156413	0	284551006	4109685		0
29370	1739	4152936	2011-09-28	2011-09-28 00:00:00	2011-10-19	2011-10-19 00:00:00	32020		\N	116172	0	283385000	4152936		0
29506	1746	40481087	2003-11-08	2003-11-08 00:00:00	2003-11-29	2003-11-29 00:00:00	32020		\N	116797	0	444814009	40481087		0
29674	1756	260139	2008-02-19	2008-02-19 00:00:00	2008-02-26	2008-02-26 00:00:00	32020		\N	117462	0	10509002	260139		0
29820	1764	4266809	1996-12-12	1996-12-12 00:00:00	\N	\N	32020		\N	117957	0	397881000	4266809		0
40519	2409	260139	2002-12-16	2002-12-16 00:00:00	2002-12-23	2002-12-23 00:00:00	32020		\N	159896	0	10509002	260139		0
40697	2419	40481087	1955-07-13	1955-07-13 00:00:00	1955-07-20	1955-07-20 00:00:00	32020		\N	160569	0	444814009	40481087		0
40842	2428	40481087	2002-01-31	2002-01-31 00:00:00	2002-02-21	2002-02-21 00:00:00	32020		\N	161096	0	444814009	40481087		0
41108	2443	260139	1989-12-11	1989-12-11 00:00:00	1989-12-18	1989-12-18 00:00:00	32020		\N	162040	0	10509002	260139		0
41173	2447	30753	2016-01-04	2016-01-04 00:00:00	\N	\N	32020		\N	162330	0	16761005	30753		0
41357	2459	40481087	2013-03-25	2013-03-25 00:00:00	2013-04-15	2013-04-15 00:00:00	32020		\N	163040	0	444814009	40481087		0
31038	1837	4283893	1968-08-30	1968-08-30 00:00:00	1968-10-18	1968-10-18 00:00:00	32020		\N	122724	0	36971009	4283893		0
31200	1847	4112343	1919-05-20	1919-05-20 00:00:00	1919-06-02	1919-06-02 00:00:00	32020		\N	123481	0	195662009	4112343		0
31349	1852	372328	2018-10-29	2018-10-29 00:00:00	2019-02-27	2019-02-27 00:00:00	32020		\N	123921	0	65363002	372328		0
42040	2503	260139	1999-01-07	1999-01-07 00:00:00	1999-01-21	1999-01-21 00:00:00	32020		\N	165651	0	10509002	260139		0
42249	2518	40481087	1999-09-03	1999-09-03 00:00:00	1999-09-10	1999-09-10 00:00:00	32020		\N	166507	0	444814009	40481087		0
42392	2526	40481087	1988-04-10	1988-04-10 00:00:00	1988-04-17	1988-04-17 00:00:00	32020		\N	166992	0	444814009	40481087		0
21407	1283	372328	1960-12-05	1960-12-05 00:00:00	1961-02-20	1961-02-20 00:00:00	32020		\N	84801	0	65363002	372328		0
32102	1906	372328	1965-06-13	1965-06-13 00:00:00	1965-10-24	1965-10-24 00:00:00	32020		\N	126856	0	65363002	372328		0
32251	1916	40481087	2019-06-19	2019-06-19 00:00:00	\N	\N	32020		\N	127493	0	444814009	40481087		0
32417	1925	372328	1946-06-26	1946-06-26 00:00:00	1946-12-28	1946-12-28 00:00:00	32020		\N	128147	0	65363002	372328		0
22015	1317	28060	1964-10-04	1964-10-04 00:00:00	1964-10-13	1964-10-13 00:00:00	32020		\N	87288	0	43878008	28060		0
32762	1946	40481087	1954-07-11	1954-07-11 00:00:00	1954-07-18	1954-07-18 00:00:00	32020		\N	129271	0	444814009	40481087		0
22378	1335	260139	2017-06-24	2017-06-24 00:00:00	2017-07-01	2017-07-01 00:00:00	32020		\N	88544	0	10509002	260139		0
33040	1960	78272	1936-02-07	1936-02-07 00:00:00	1936-03-13	1936-03-13 00:00:00	32020		\N	130330	0	70704007	78272		0
22722	1356	134438	1995-02-06	1995-02-06 00:00:00	1996-04-02	1996-04-02 00:00:00	32020		\N	89876	0	40275004	134438		0
33378	1980	378001	2007-02-07	2007-02-07 00:00:00	2007-04-08	2007-04-08 00:00:00	32020		\N	131808	0	62106007	378001		0
23058	1376	40481087	2011-01-29	2011-01-29 00:00:00	2011-02-05	2011-02-05 00:00:00	32020		\N	91205	0	444814009	40481087		0
23192	1384	40481087	2000-01-19	2000-01-19 00:00:00	2000-02-02	2000-02-02 00:00:00	32020		\N	91776	0	444814009	40481087		0
33887	2012	260139	1957-08-31	1957-08-31 00:00:00	1957-09-14	1957-09-14 00:00:00	32020		\N	133896	0	10509002	260139		0
34064	2025	28060	1920-08-18	1920-08-18 00:00:00	1920-08-28	1920-08-28 00:00:00	32020		\N	134747	0	43878008	28060		0
23733	1415	4112343	1969-08-13	1969-08-13 00:00:00	1969-08-26	1969-08-26 00:00:00	32020		\N	94176	0	195662009	4112343		0
34423	2043	4112343	2018-01-19	2018-01-19 00:00:00	2018-01-31	2018-01-31 00:00:00	32020		\N	135937	0	195662009	4112343		0
24013	1432	4112343	2014-11-12	2014-11-12 00:00:00	2014-11-23	2014-11-23 00:00:00	32020		\N	95381	0	195662009	4112343		0
34761	2063	260139	1984-11-08	1984-11-08 00:00:00	1984-11-22	1984-11-22 00:00:00	32020		\N	137202	0	10509002	260139		0
34934	2075	4027663	1996-11-22	1996-11-22 00:00:00	\N	\N	32020		\N	138126	0	13200003	4027663		0
24533	1464	260139	1996-03-31	1996-03-31 00:00:00	1996-04-07	1996-04-07 00:00:00	32020		\N	97548	0	10509002	260139		0
24718	1475	4112343	1934-11-23	1934-11-23 00:00:00	1934-12-01	1934-12-01 00:00:00	32020		\N	98215	0	195662009	4112343		0
35415	2098	4112343	1968-02-06	1968-02-06 00:00:00	1968-02-18	1968-02-18 00:00:00	32020		\N	139893	0	195662009	4112343		0
35538	2105	40481087	1977-08-07	1977-08-07 00:00:00	1977-08-21	1977-08-21 00:00:00	32020		\N	140215	0	444814009	40481087		0
25206	1504	4112343	2005-08-06	2005-08-06 00:00:00	2005-08-15	2005-08-15 00:00:00	32020		\N	100243	0	195662009	4112343		0
25341	1510	40481087	1996-04-21	1996-04-21 00:00:00	1996-05-12	1996-05-12 00:00:00	32020		\N	100841	0	444814009	40481087		0
36047	2136	372328	1974-01-24	1974-01-24 00:00:00	1974-05-18	1974-05-18 00:00:00	32020		\N	142253	0	65363002	372328		0
36207	2147	4112343	1995-01-17	1995-01-17 00:00:00	1995-01-28	1995-01-28 00:00:00	32020		\N	142889	0	195662009	4112343		0
36383	2153	40481087	2014-08-18	2014-08-18 00:00:00	2014-08-25	2014-08-25 00:00:00	32020		\N	143480	0	444814009	40481087		0
36549	2164	260139	1979-05-12	1979-05-12 00:00:00	1979-05-26	1979-05-26 00:00:00	32020		\N	144136	0	10509002	260139		0
36703	2173	40481087	2005-01-26	2005-01-26 00:00:00	2005-02-02	2005-02-02 00:00:00	32020		\N	144807	0	444814009	40481087		0
36862	2180	378001	2015-08-22	2015-08-22 00:00:00	2015-09-21	2015-09-21 00:00:00	32020		\N	145421	0	62106007	378001		0
26485	1569	372328	1956-01-26	1956-01-26 00:00:00	1956-08-31	1956-08-31 00:00:00	32020		\N	105274	0	65363002	372328		0
26694	1579	40481087	2007-02-21	2007-02-21 00:00:00	2007-03-07	2007-03-07 00:00:00	32020		\N	106086	0	444814009	40481087		0
37367	2213	40481087	1986-05-14	1986-05-14 00:00:00	1986-06-04	1986-06-04 00:00:00	32020		\N	147418	0	444814009	40481087		0
27026	1599	4266809	1997-12-21	1997-12-21 00:00:00	\N	\N	32020		\N	107307	0	397881000	4266809		0
27174	1605	260139	2011-05-22	2011-05-22 00:00:00	2011-06-05	2011-06-05 00:00:00	32020		\N	107781	0	10509002	260139		0
37851	2243	40481087	1978-12-22	1978-12-22 00:00:00	1978-12-29	1978-12-29 00:00:00	32020		\N	149310	0	444814009	40481087		0
38087	2261	372328	1990-11-30	1990-11-30 00:00:00	1992-01-14	1992-01-14 00:00:00	32020		\N	150316	0	65363002	372328		0
38190	2267	375671	1969-12-22	1969-12-22 00:00:00	1970-02-20	1970-02-20 00:00:00	32020		\N	150733	0	62564004	375671		0
38437	2283	4059173	2017-09-07	2017-09-07 00:00:00	2017-10-07	2017-10-07 00:00:00	32020		\N	151885	0	16114001	4059173		0
38591	2291	40481087	2017-03-03	2017-03-03 00:00:00	2017-03-24	2017-03-24 00:00:00	32020		\N	152508	0	444814009	40481087		0
28210	1666	4112343	1941-07-04	1941-07-04 00:00:00	1941-07-16	1941-07-16 00:00:00	32020		\N	111883	0	195662009	4112343		0
38854	2307	372328	1967-05-06	1967-05-06 00:00:00	1967-09-19	1967-09-19 00:00:00	32020		\N	153497	0	65363002	372328		0
39049	2319	4146173	2018-07-26	2018-07-26 00:00:00	2018-08-25	2018-08-25 00:00:00	32020		\N	154221	0	307731004	4146173		0
28652	1695	40481087	1999-09-21	1999-09-21 00:00:00	1999-10-12	1999-10-12 00:00:00	32020		\N	113474	0	444814009	40481087		0
39365	2333	4056621	1962-07-29	1962-07-29 00:00:00	\N	\N	32020		\N	155241	0	197927001	4056621		0
29015	1718	40481087	2005-01-29	2005-01-29 00:00:00	2005-02-19	2005-02-19 00:00:00	32020		\N	114857	0	444814009	40481087		0
39677	2349	260139	2016-12-21	2016-12-21 00:00:00	2016-12-28	2016-12-28 00:00:00	32020		\N	156356	0	10509002	260139		0
29371	1739	40481087	1969-09-11	1969-09-11 00:00:00	1969-09-18	1969-09-18 00:00:00	32020		\N	116194	0	444814009	40481087		0
29507	1746	260139	1957-07-07	1957-07-07 00:00:00	1957-07-21	1957-07-21 00:00:00	32020		\N	116719	0	10509002	260139		0
29675	1756	40481087	1973-05-09	1973-05-09 00:00:00	1973-05-23	1973-05-23 00:00:00	32020		\N	117423	0	444814009	40481087		0
29821	1764	260139	1970-05-27	1970-05-27 00:00:00	1970-06-10	1970-06-10 00:00:00	32020		\N	117995	0	10509002	260139		0
40520	2409	4278672	1986-07-21	1986-07-21 00:00:00	1986-10-19	1986-10-19 00:00:00	32020		\N	159942	0	65966004	4278672		0
40698	2419	4112343	2000-11-02	2000-11-02 00:00:00	2000-11-13	2000-11-13 00:00:00	32020		\N	160527	0	195662009	4112343		0
40843	2428	80180	2015-10-08	2015-10-08 00:00:00	\N	\N	32020		\N	161079	0	396275006	80180		0
41109	2443	4027663	1989-12-21	1989-12-21 00:00:00	\N	\N	32020		\N	162040	0	13200003	4027663		0
41174	2447	4285898	2016-08-01	2016-08-01 00:00:00	\N	\N	32020		\N	162330	0	68496003	4285898		0
41358	2459	4112343	2006-02-15	2006-02-15 00:00:00	2006-02-25	2006-02-25 00:00:00	32020		\N	163031	0	195662009	4112343		0
31039	1837	40481087	1968-12-25	1968-12-25 00:00:00	1969-01-01	1969-01-01 00:00:00	32020		\N	122735	0	444814009	40481087		0
31201	1847	80180	1958-01-16	1958-01-16 00:00:00	\N	\N	32020		\N	123512	0	396275006	80180		0
31350	1852	372328	1974-06-30	1974-06-30 00:00:00	1974-08-07	1974-08-07 00:00:00	32020		\N	123918	0	65363002	372328		0
42041	2503	260139	2013-05-26	2013-05-26 00:00:00	2013-06-09	2013-06-09 00:00:00	32020		\N	165654	0	10509002	260139		0
42250	2518	40481087	1964-05-17	1964-05-17 00:00:00	1964-05-24	1964-05-24 00:00:00	32020		\N	166579	0	444814009	40481087		0
42393	2526	4112343	1982-05-16	1982-05-16 00:00:00	1982-05-27	1982-05-27 00:00:00	32020		\N	166990	0	195662009	4112343		0
21408	1283	40481087	1988-06-09	1988-06-09 00:00:00	1988-06-30	1988-06-30 00:00:00	32020		\N	84828	0	444814009	40481087		0
32103	1906	4112343	1981-09-23	1981-09-23 00:00:00	1981-10-04	1981-10-04 00:00:00	32020		\N	126878	0	195662009	4112343		0
32418	1925	4112343	2013-04-24	2013-04-24 00:00:00	2013-05-05	2013-05-05 00:00:00	32020		\N	128135	0	195662009	4112343		0
22016	1317	40481087	1952-12-08	1952-12-08 00:00:00	1952-12-15	1952-12-15 00:00:00	32020		\N	87286	0	444814009	40481087		0
32763	1946	40481087	1955-02-19	1955-02-19 00:00:00	1955-03-12	1955-03-12 00:00:00	32020		\N	129317	0	444814009	40481087		0
22379	1335	40481087	1985-03-25	1985-03-25 00:00:00	1985-04-01	1985-04-01 00:00:00	32020		\N	88543	0	444814009	40481087		0
33041	1960	4294548	1950-07-24	1950-07-24 00:00:00	1950-09-18	1950-09-18 00:00:00	32020		\N	130320	0	75498004	4294548		0
22723	1356	4112343	2012-09-24	2012-09-24 00:00:00	2012-10-04	2012-10-04 00:00:00	32020		\N	89905	0	195662009	4112343		0
33379	1980	4156265	2005-04-04	2005-04-04 00:00:00	2005-04-18	2005-04-18 00:00:00	32020		\N	131807	0	370247008	4156265		0
23059	1376	260139	2012-07-17	2012-07-17 00:00:00	2012-07-24	2012-07-24 00:00:00	32020		\N	91184	0	10509002	260139		0
23193	1384	4112343	2002-03-22	2002-03-22 00:00:00	2002-03-31	2002-03-31 00:00:00	32020		\N	91730	0	195662009	4112343		0
33889	2012	4112343	2002-08-01	2002-08-01 00:00:00	2002-08-11	2002-08-11 00:00:00	32020		\N	133899	0	195662009	4112343		0
34065	2025	40481087	1947-03-27	1947-03-27 00:00:00	1947-04-17	1947-04-17 00:00:00	32020		\N	134751	0	444814009	40481087		0
23734	1415	40481087	1994-08-17	1994-08-17 00:00:00	1994-08-31	1994-08-31 00:00:00	32020		\N	94219	0	444814009	40481087		0
34424	2043	40481087	1976-07-28	1976-07-28 00:00:00	1976-08-04	1976-08-04 00:00:00	32020		\N	135904	0	444814009	40481087		0
24014	1433	81151	1989-05-01	1989-05-01 00:00:00	1989-05-29	1989-05-29 00:00:00	32020		\N	95490	0	44465007	81151		0
34762	2063	28060	1987-01-11	1987-01-11 00:00:00	1987-01-24	1987-01-24 00:00:00	32020		\N	137203	0	43878008	28060		0
34935	2075	4294548	1966-04-08	1966-04-08 00:00:00	1966-07-15	1966-07-15 00:00:00	32020		\N	138074	0	75498004	4294548		0
24534	1464	4112343	1968-05-03	1968-05-03 00:00:00	1968-05-14	1968-05-14 00:00:00	32020		\N	97533	0	195662009	4112343		0
24719	1475	260139	2017-12-29	2017-12-29 00:00:00	2018-01-05	2018-01-05 00:00:00	32020		\N	98278	0	10509002	260139		0
35416	2098	40481087	2013-11-29	2013-11-29 00:00:00	2013-12-13	2013-12-13 00:00:00	32020		\N	139845	0	444814009	40481087		0
35539	2105	40481087	1977-06-12	1977-06-12 00:00:00	1977-07-03	1977-07-03 00:00:00	32020		\N	140211	0	444814009	40481087		0
25207	1504	4152936	1954-05-03	1954-05-03 00:00:00	1954-05-17	1954-05-17 00:00:00	32020		\N	100254	0	283385000	4152936		0
25342	1510	78272	1970-07-16	1970-07-16 00:00:00	1970-08-20	1970-08-20 00:00:00	32020		\N	100788	0	70704007	78272		0
36048	2136	260139	1983-12-11	1983-12-11 00:00:00	1983-12-25	1983-12-25 00:00:00	32020		\N	142212	0	10509002	260139		0
36208	2147	378001	1965-07-26	1965-07-26 00:00:00	1965-09-24	1965-09-24 00:00:00	32020		\N	142901	0	62106007	378001		0
36384	2153	4152936	1992-09-18	1992-09-18 00:00:00	1992-10-09	1992-10-09 00:00:00	32020		\N	143470	0	283385000	4152936		0
36550	2164	4113008	2014-05-04	2014-05-04 00:00:00	2014-05-18	2014-05-18 00:00:00	32020		\N	144125	0	284549007	4113008		0
36704	2173	439777	1974-06-27	1974-06-27 00:00:00	\N	\N	32020		\N	144867	0	271737000	439777		0
36863	2180	40481087	2003-06-30	2003-06-30 00:00:00	2003-07-21	2003-07-21 00:00:00	32020		\N	145402	0	444814009	40481087		0
26486	1569	30753	1969-12-20	1969-12-20 00:00:00	\N	\N	32020		\N	105254	0	16761005	30753		0
26695	1579	40481087	1963-05-25	1963-05-25 00:00:00	1963-06-08	1963-06-08 00:00:00	32020		\N	106087	0	444814009	40481087		0
37368	2213	260139	1975-07-07	1975-07-07 00:00:00	1975-07-14	1975-07-14 00:00:00	32020		\N	147359	0	10509002	260139		0
27027	1599	80180	1997-12-21	1997-12-21 00:00:00	\N	\N	32020		\N	107307	0	396275006	80180		0
27175	1605	40481087	2018-08-03	2018-08-03 00:00:00	2018-08-24	2018-08-24 00:00:00	32020		\N	107675	0	444814009	40481087		0
37852	2243	4027663	1996-01-14	1996-01-14 00:00:00	\N	\N	32020		\N	149354	0	13200003	4027663		0
38088	2261	40481087	2002-09-04	2002-09-04 00:00:00	2002-09-11	2002-09-11 00:00:00	32020		\N	150272	0	444814009	40481087		0
38191	2267	40481087	1968-11-04	1968-11-04 00:00:00	1968-11-25	1968-11-25 00:00:00	32020		\N	150681	0	444814009	40481087		0
38438	2283	4112343	1978-10-22	1978-10-22 00:00:00	1978-10-29	1978-10-29 00:00:00	32020		\N	151913	0	195662009	4112343		0
38592	2291	80180	1997-05-22	1997-05-22 00:00:00	\N	\N	32020		\N	152465	0	396275006	80180		0
28211	1666	4152936	1977-01-28	1977-01-28 00:00:00	1977-02-18	1977-02-18 00:00:00	32020		\N	111878	0	283385000	4152936		0
38855	2307	372328	1966-08-25	1966-08-25 00:00:00	1966-09-08	1966-09-08 00:00:00	32020		\N	153531	0	65363002	372328		0
39050	2319	4112343	1988-04-29	1988-04-29 00:00:00	1988-05-06	1988-05-06 00:00:00	32020		\N	154166	0	195662009	4112343		0
28653	1695	260139	2001-01-31	2001-01-31 00:00:00	2001-02-14	2001-02-14 00:00:00	32020		\N	113477	0	10509002	260139		0
39366	2333	195588	1962-07-29	1962-07-29 00:00:00	1962-08-31	1962-08-31 00:00:00	32020		\N	155241	0	38822007	195588		0
29016	1718	4112343	1989-08-04	1989-08-04 00:00:00	1989-08-15	1989-08-15 00:00:00	32020		\N	114845	0	195662009	4112343		0
39678	2349	372328	1973-04-16	1973-04-16 00:00:00	1973-06-17	1973-06-17 00:00:00	32020		\N	156357	0	65363002	372328		0
29372	1739	40481087	1999-10-01	1999-10-01 00:00:00	1999-10-15	1999-10-15 00:00:00	32020		\N	116212	0	444814009	40481087		0
29508	1746	4116491	2004-12-14	2004-12-14 00:00:00	2005-02-01	2005-02-01 00:00:00	32020		\N	116798	0	301011002	4116491		0
29676	1756	260139	1995-11-06	1995-11-06 00:00:00	1995-11-20	1995-11-20 00:00:00	32020		\N	117448	0	10509002	260139		0
29822	1764	372328	1959-11-02	1959-11-02 00:00:00	1959-12-10	1959-12-10 00:00:00	32020		\N	117948	0	65363002	372328		0
40521	2409	4237458	2011-01-25	2011-01-25 00:00:00	2011-04-25	2011-04-25 00:00:00	32020		\N	159944	0	58150001	4237458		0
40699	2419	40481087	2014-07-01	2014-07-01 00:00:00	2014-07-15	2014-07-15 00:00:00	32020		\N	160547	0	444814009	40481087		0
40844	2428	372328	1975-02-20	1975-02-20 00:00:00	1975-06-03	1975-06-03 00:00:00	32020		\N	161098	0	65363002	372328		0
41110	2443	28060	1986-03-04	1986-03-04 00:00:00	1986-03-13	1986-03-13 00:00:00	32020		\N	162073	0	43878008	28060		0
41175	2447	260139	1995-07-24	1995-07-24 00:00:00	1995-08-07	1995-08-07 00:00:00	32020		\N	162311	0	10509002	260139		0
41359	2459	4283893	1980-11-05	1980-11-05 00:00:00	1980-12-24	1980-12-24 00:00:00	32020		\N	163051	0	36971009	4283893		0
41501	2468	40481087	1975-06-15	1975-06-15 00:00:00	1975-06-29	1975-06-29 00:00:00	32020		\N	163592	0	444814009	40481087		0
31202	1847	40481087	1957-09-07	1957-09-07 00:00:00	1957-09-28	1957-09-28 00:00:00	32020		\N	123512	0	444814009	40481087		0
31351	1852	80180	2007-05-18	2007-05-18 00:00:00	\N	\N	32020		\N	123941	0	396275006	80180		0
42042	2503	4048171	1978-02-26	1978-02-26 00:00:00	\N	\N	32020		\N	165710	0	232353008	4048171		0
42251	2518	78272	1992-11-06	1992-11-06 00:00:00	1992-12-04	1992-12-04 00:00:00	32020		\N	166543	0	70704007	78272		0
42394	2526	40481087	2002-06-04	2002-06-04 00:00:00	2002-06-11	2002-06-11 00:00:00	32020		\N	166993	0	444814009	40481087		0
21409	1283	40481087	2016-07-23	2016-07-23 00:00:00	2016-08-06	2016-08-06 00:00:00	32020		\N	84787	0	444814009	40481087		0
32104	1906	260139	1980-01-13	1980-01-13 00:00:00	1980-01-20	1980-01-20 00:00:00	32020		\N	126872	0	10509002	260139		0
32253	1916	4112343	2007-04-30	2007-04-30 00:00:00	2007-05-09	2007-05-09 00:00:00	32020		\N	127498	0	195662009	4112343		0
32419	1925	40481087	1947-08-16	1947-08-16 00:00:00	1947-08-30	1947-08-30 00:00:00	32020		\N	128120	0	444814009	40481087		0
22017	1317	257012	1997-06-29	1997-06-29 00:00:00	\N	\N	32020		\N	87256	0	40055000	257012		0
32764	1946	381316	1973-10-20	1973-10-20 00:00:00	\N	\N	32020		\N	129307	0	230690007	381316		0
22380	1335	40481087	1998-01-01	1998-01-01 00:00:00	1998-01-08	1998-01-08 00:00:00	32020		\N	88573	0	444814009	40481087		0
33042	1960	40481087	1938-06-01	1938-06-01 00:00:00	1938-06-08	1938-06-08 00:00:00	32020		\N	130335	0	444814009	40481087		0
22724	1356	4112343	1986-12-29	1986-12-29 00:00:00	1987-01-09	1987-01-09 00:00:00	32020		\N	89930	0	195662009	4112343		0
33380	1980	439777	1999-09-04	1999-09-04 00:00:00	\N	\N	32020		\N	131769	0	271737000	439777		0
23060	1376	4134304	1983-06-13	1983-06-13 00:00:00	1983-09-11	1983-09-11 00:00:00	32020		\N	91177	0	263102004	4134304		0
23194	1384	40481087	1999-10-29	1999-10-29 00:00:00	1999-11-12	1999-11-12 00:00:00	32020		\N	91787	0	444814009	40481087		0
33890	2012	40481087	2003-03-28	2003-03-28 00:00:00	2003-04-11	2003-04-11 00:00:00	32020		\N	133880	0	444814009	40481087		0
34066	2025	260139	1938-07-18	1938-07-18 00:00:00	1938-08-01	1938-08-01 00:00:00	32020		\N	134771	0	10509002	260139		0
23735	1415	4112343	1969-02-28	1969-02-28 00:00:00	1969-03-13	1969-03-13 00:00:00	32020		\N	94177	0	195662009	4112343		0
34425	2043	260139	1995-09-23	1995-09-23 00:00:00	1995-09-30	1995-09-30 00:00:00	32020		\N	135935	0	10509002	260139		0
24015	1433	4266809	1995-08-18	1995-08-18 00:00:00	\N	\N	32020		\N	95480	0	397881000	4266809		0
34763	2064	260139	1996-06-30	1996-06-30 00:00:00	1996-07-07	1996-07-07 00:00:00	32020		\N	137290	0	10509002	260139		0
34936	2075	4112343	1977-02-10	1977-02-10 00:00:00	1977-02-17	1977-02-17 00:00:00	32020		\N	138077	0	195662009	4112343		0
24535	1464	28060	1998-03-08	1998-03-08 00:00:00	1998-03-20	1998-03-20 00:00:00	32020		\N	97549	0	43878008	28060		0
24720	1475	40481087	2016-06-16	2016-06-16 00:00:00	2016-06-30	2016-06-30 00:00:00	32020		\N	98225	0	444814009	40481087		0
35417	2098	4294548	1972-09-18	1972-09-18 00:00:00	1972-12-18	1972-12-18 00:00:00	32020		\N	139854	0	75498004	4294548		0
35540	2105	372328	1979-09-29	1979-09-29 00:00:00	1979-12-09	1979-12-09 00:00:00	32020		\N	140223	0	65363002	372328		0
25208	1504	260139	1993-12-05	1993-12-05 00:00:00	1993-12-12	1993-12-12 00:00:00	32020		\N	100271	0	10509002	260139		0
25343	1510	4112343	2019-02-03	2019-02-03 00:00:00	2019-02-14	2019-02-14 00:00:00	32020		\N	100811	0	195662009	4112343		0
36049	2136	4112343	1995-10-10	1995-10-10 00:00:00	1995-10-18	1995-10-18 00:00:00	32020		\N	142303	0	195662009	4112343		0
36209	2147	40481087	1996-10-31	1996-10-31 00:00:00	1996-11-21	1996-11-21 00:00:00	32020		\N	142963	0	444814009	40481087		0
36385	2153	40481087	1972-06-23	1972-06-23 00:00:00	1972-07-14	1972-07-14 00:00:00	32020		\N	143504	0	444814009	40481087		0
36551	2164	4112343	2012-08-14	2012-08-14 00:00:00	2012-08-27	2012-08-27 00:00:00	32020		\N	144158	0	195662009	4112343		0
36705	2173	40481087	2007-03-31	2007-03-31 00:00:00	2007-04-14	2007-04-14 00:00:00	32020		\N	144749	0	444814009	40481087		0
36864	2180	81151	1989-04-05	1989-04-05 00:00:00	1989-04-19	1989-04-19 00:00:00	32020		\N	145419	0	44465007	81151		0
26487	1569	80180	1971-03-15	1971-03-15 00:00:00	\N	\N	32020		\N	105254	0	396275006	80180		0
37185	2202	4283893	1985-11-16	1985-11-16 00:00:00	1985-11-30	1985-11-30 00:00:00	32020		\N	146772	0	36971009	4283893		0
37369	2213	40481087	2008-02-12	2008-02-12 00:00:00	2008-02-26	2008-02-26 00:00:00	32020		\N	147392	0	444814009	40481087		0
27028	1599	40481087	1981-07-28	1981-07-28 00:00:00	1981-08-11	1981-08-11 00:00:00	32020		\N	107349	0	444814009	40481087		0
27176	1605	4283893	2000-11-29	2000-11-29 00:00:00	2001-01-31	2001-01-31 00:00:00	32020		\N	107758	0	36971009	4283893		0
37853	2243	260139	1984-12-29	1984-12-29 00:00:00	1985-01-05	1985-01-05 00:00:00	32020		\N	149336	0	10509002	260139		0
38089	2261	260139	2012-03-31	2012-03-31 00:00:00	2012-04-07	2012-04-07 00:00:00	32020		\N	150273	0	10509002	260139		0
38192	2267	4112343	1997-03-10	1997-03-10 00:00:00	1997-03-17	1997-03-17 00:00:00	32020		\N	150709	0	195662009	4112343		0
38439	2283	4112343	1943-01-29	1943-01-29 00:00:00	1943-02-10	1943-02-10 00:00:00	32020		\N	151874	0	195662009	4112343		0
38593	2291	40481087	1995-10-17	1995-10-17 00:00:00	1995-11-07	1995-11-07 00:00:00	32020		\N	152465	0	444814009	40481087		0
28212	1666	260139	1951-05-20	1951-05-20 00:00:00	1951-05-27	1951-05-27 00:00:00	32020		\N	111852	0	10509002	260139		0
38856	2307	28060	1973-11-01	1973-11-01 00:00:00	1973-11-09	1973-11-09 00:00:00	32020		\N	153527	0	43878008	28060		0
39051	2319	40481087	1989-01-11	1989-01-11 00:00:00	1989-02-01	1989-02-01 00:00:00	32020		\N	154182	0	444814009	40481087		0
28654	1695	260139	1986-09-12	1986-09-12 00:00:00	1986-09-19	1986-09-19 00:00:00	32020		\N	113437	0	10509002	260139		0
39367	2333	40481087	1971-09-21	1971-09-21 00:00:00	1971-10-12	1971-10-12 00:00:00	32020		\N	155191	0	444814009	40481087		0
29017	1718	372328	1969-08-02	1969-08-02 00:00:00	1969-08-23	1969-08-23 00:00:00	32020		\N	114867	0	65363002	372328		0
39679	2349	4155034	1974-02-03	1974-02-03 00:00:00	1974-02-17	1974-02-17 00:00:00	32020		\N	156411	0	283371005	4155034		0
29373	1739	80180	2009-04-26	2009-04-26 00:00:00	\N	\N	32020		\N	116198	0	396275006	80180		0
29509	1746	40481087	2007-04-17	2007-04-17 00:00:00	2007-04-24	2007-04-24 00:00:00	32020		\N	116725	0	444814009	40481087		0
29677	1756	4112343	1980-08-03	1980-08-03 00:00:00	1980-08-10	1980-08-10 00:00:00	32020		\N	117460	0	195662009	4112343		0
29823	1764	378001	2018-05-20	2018-05-20 00:00:00	2018-06-19	2018-06-19 00:00:00	32020		\N	117993	0	62106007	378001		0
40522	2409	80180	2018-10-06	2018-10-06 00:00:00	\N	\N	32020		\N	159935	0	396275006	80180		0
40700	2419	260139	1948-07-03	1948-07-03 00:00:00	1948-07-10	1948-07-10 00:00:00	32020		\N	160510	0	10509002	260139		0
40845	2428	4296204	1996-04-14	1996-04-14 00:00:00	1996-05-19	1996-05-19 00:00:00	32020		\N	161081	0	403190006	4296204		0
41111	2443	260139	1994-11-08	1994-11-08 00:00:00	1994-11-15	1994-11-15 00:00:00	32020		\N	162042	0	10509002	260139		0
41176	2447	40481087	2005-08-16	2005-08-16 00:00:00	2005-09-06	2005-09-06 00:00:00	32020		\N	162313	0	444814009	40481087		0
41360	2459	28060	1984-03-09	1984-03-09 00:00:00	1984-03-16	1984-03-16 00:00:00	32020		\N	163030	0	43878008	28060		0
41502	2468	80180	1976-01-21	1976-01-21 00:00:00	\N	\N	32020		\N	163592	0	396275006	80180		0
31203	1847	40481087	1954-09-11	1954-09-11 00:00:00	1954-09-18	1954-09-18 00:00:00	32020		\N	123576	0	444814009	40481087		0
31352	1852	4112343	1987-03-22	1987-03-22 00:00:00	1987-03-29	1987-03-29 00:00:00	32020		\N	123889	0	195662009	4112343		0
42043	2503	4112343	1998-07-25	1998-07-25 00:00:00	1998-08-06	1998-08-06 00:00:00	32020		\N	165745	0	195662009	4112343		0
42252	2518	40481087	1967-08-16	1967-08-16 00:00:00	1967-08-30	1967-08-30 00:00:00	32020		\N	166580	0	444814009	40481087		0
42395	2526	372328	1976-08-14	1976-08-14 00:00:00	1976-11-29	1976-11-29 00:00:00	32020		\N	167031	0	65363002	372328		0
21410	1283	4112343	1994-11-12	1994-11-12 00:00:00	1994-11-20	1994-11-20 00:00:00	32020		\N	84829	0	195662009	4112343		0
32105	1906	260139	1981-03-16	1981-03-16 00:00:00	1981-03-30	1981-03-30 00:00:00	32020		\N	126866	0	10509002	260139		0
32254	1916	372328	1984-02-12	1984-02-12 00:00:00	1984-03-19	1984-03-19 00:00:00	32020		\N	127424	0	65363002	372328		0
32420	1925	4112343	1991-01-11	1991-01-11 00:00:00	1991-01-18	1991-01-18 00:00:00	32020		\N	128132	0	195662009	4112343		0
22018	1317	40481087	1953-10-16	1953-10-16 00:00:00	1953-11-06	1953-11-06 00:00:00	32020		\N	87291	0	444814009	40481087		0
32765	1946	4294548	1960-01-06	1960-01-06 00:00:00	1960-01-13	1960-01-13 00:00:00	32020		\N	129272	0	75498004	4294548		0
22381	1335	260139	1981-07-08	1981-07-08 00:00:00	1981-07-15	1981-07-15 00:00:00	32020		\N	88604	0	10509002	260139		0
33043	1960	40481087	1961-02-19	1961-02-19 00:00:00	1961-03-12	1961-03-12 00:00:00	32020		\N	130363	0	444814009	40481087		0
22725	1356	40481087	1981-06-19	1981-06-19 00:00:00	1981-07-03	1981-07-03 00:00:00	32020		\N	89940	0	444814009	40481087		0
33381	1980	40486433	1975-09-17	1975-09-17 00:00:00	1993-07-18	1993-07-18 00:00:00	32020		\N	131876	0	446096008	40486433		0
23061	1377	372328	1988-05-13	1988-05-13 00:00:00	1988-12-06	1988-12-06 00:00:00	32020		\N	91241	0	65363002	372328		0
23195	1384	375671	1995-01-14	1995-01-14 00:00:00	1995-03-15	1995-03-15 00:00:00	32020		\N	91726	0	62564004	375671		0
33891	2012	378001	1962-03-07	1962-03-07 00:00:00	1962-04-06	1962-04-06 00:00:00	32020		\N	133862	0	62106007	378001		0
34067	2025	28060	1921-03-29	1921-03-29 00:00:00	1921-04-06	1921-04-06 00:00:00	32020		\N	134770	0	43878008	28060		0
34197	2030	4112343	2010-08-05	2010-08-05 00:00:00	2010-08-16	2010-08-16 00:00:00	32020		\N	135162	0	195662009	4112343		0
34426	2043	4112343	1978-10-21	1978-10-21 00:00:00	1978-11-01	1978-11-01 00:00:00	32020		\N	135873	0	195662009	4112343		0
24016	1433	80180	1995-08-18	1995-08-18 00:00:00	\N	\N	32020		\N	95480	0	396275006	80180		0
34764	2064	4152936	2008-11-06	2008-11-06 00:00:00	2008-11-20	2008-11-20 00:00:00	32020		\N	137306	0	283385000	4152936		0
34937	2075	4112343	1978-04-14	1978-04-14 00:00:00	1978-04-27	1978-04-27 00:00:00	32020		\N	138067	0	195662009	4112343		0
24536	1464	192671	2002-11-01	2002-11-01 00:00:00	\N	\N	32020		\N	97567	0	K92.2	35208414		0
24721	1475	40481087	1989-07-15	1989-07-15 00:00:00	1989-07-22	1989-07-22 00:00:00	32020		\N	98274	0	444814009	40481087		0
35418	2098	4112343	1973-07-22	1973-07-22 00:00:00	1973-07-31	1973-07-31 00:00:00	32020		\N	139825	0	195662009	4112343		0
35541	2105	28060	1980-07-31	1980-07-31 00:00:00	1980-08-13	1980-08-13 00:00:00	32020		\N	140216	0	43878008	28060		0
25209	1504	40481087	1944-10-02	1944-10-02 00:00:00	1944-10-23	1944-10-23 00:00:00	32020		\N	100266	0	444814009	40481087		0
25344	1510	40481087	1995-08-04	1995-08-04 00:00:00	1995-08-18	1995-08-18 00:00:00	32020		\N	100860	0	444814009	40481087		0
36050	2136	40481087	2002-03-07	2002-03-07 00:00:00	2002-03-14	2002-03-14 00:00:00	32020		\N	142217	0	444814009	40481087		0
36210	2147	40481087	1976-01-26	1976-01-26 00:00:00	1976-02-16	1976-02-16 00:00:00	32020		\N	142886	0	444814009	40481087		0
36386	2153	40481087	2009-08-22	2009-08-22 00:00:00	2009-09-05	2009-09-05 00:00:00	32020		\N	143479	0	444814009	40481087		0
36552	2164	4112343	2011-03-01	2011-03-01 00:00:00	2011-03-11	2011-03-11 00:00:00	32020		\N	144142	0	195662009	4112343		0
36706	2173	40481087	1963-12-27	1963-12-27 00:00:00	1964-01-10	1964-01-10 00:00:00	32020		\N	144848	0	444814009	40481087		0
36865	2180	40481087	1998-05-06	1998-05-06 00:00:00	1998-05-20	1998-05-20 00:00:00	32020		\N	145389	0	444814009	40481087		0
26488	1569	4285898	1970-05-19	1970-05-19 00:00:00	\N	\N	32020		\N	105254	0	68496003	4285898		0
37186	2202	80180	2011-04-20	2011-04-20 00:00:00	\N	\N	32020		\N	146798	0	396275006	80180		0
37370	2213	260139	1980-11-15	1980-11-15 00:00:00	1980-11-22	1980-11-22 00:00:00	32020		\N	147355	0	10509002	260139		0
27029	1599	40481087	1982-04-13	1982-04-13 00:00:00	1982-04-20	1982-04-20 00:00:00	32020		\N	107288	0	444814009	40481087		0
27177	1606	4027663	1979-12-26	1979-12-26 00:00:00	\N	\N	32020		\N	107793	0	13200003	4027663		0
37854	2243	40481087	1997-07-16	1997-07-16 00:00:00	1997-08-06	1997-08-06 00:00:00	32020		\N	149329	0	444814009	40481087		0
38090	2261	81151	1994-04-15	1994-04-15 00:00:00	1994-04-29	1994-04-29 00:00:00	32020		\N	150335	0	44465007	81151		0
38193	2267	4112343	2012-12-09	2012-12-09 00:00:00	2012-12-16	2012-12-16 00:00:00	32020		\N	150685	0	195662009	4112343		0
38440	2283	40481087	2004-04-14	2004-04-14 00:00:00	2004-05-05	2004-05-05 00:00:00	32020		\N	151915	0	444814009	40481087		0
38594	2291	440448	1966-10-14	1966-10-14 00:00:00	\N	\N	32020		\N	152488	0	74400008	440448		0
28213	1666	40481087	1962-08-31	1962-08-31 00:00:00	1962-09-21	1962-09-21 00:00:00	32020		\N	111911	0	444814009	40481087		0
38857	2307	4296204	1999-09-28	1999-09-28 00:00:00	1999-10-19	1999-10-19 00:00:00	32020		\N	153484	0	403190006	4296204		0
39052	2319	372328	1948-11-06	1948-11-06 00:00:00	1949-01-22	1949-01-22 00:00:00	32020		\N	154223	0	65363002	372328		0
28655	1695	4283893	2000-10-11	2000-10-11 00:00:00	2001-01-31	2001-01-31 00:00:00	32020		\N	113475	0	36971009	4283893		0
39368	2333	40481087	1966-08-21	1966-08-21 00:00:00	1966-09-11	1966-09-11 00:00:00	32020		\N	155242	0	444814009	40481087		0
29018	1718	4112343	2003-05-06	2003-05-06 00:00:00	2003-05-16	2003-05-16 00:00:00	32020		\N	114852	0	195662009	4112343		0
39680	2349	4112343	1981-06-08	1981-06-08 00:00:00	1981-06-18	1981-06-18 00:00:00	32020		\N	156439	0	195662009	4112343		0
29374	1739	4112343	1996-04-13	1996-04-13 00:00:00	1996-04-20	1996-04-20 00:00:00	32020		\N	116211	0	195662009	4112343		0
29510	1746	28060	1962-06-28	1962-06-28 00:00:00	1962-07-08	1962-07-08 00:00:00	32020		\N	116806	0	43878008	28060		0
29678	1756	80180	2013-05-18	2013-05-18 00:00:00	\N	\N	32020		\N	117422	0	396275006	80180		0
29824	1764	372328	1963-10-23	1963-10-23 00:00:00	1964-07-09	1964-07-09 00:00:00	32020		\N	117998	0	65363002	372328		0
40523	2409	260139	1993-11-12	1993-11-12 00:00:00	1993-11-26	1993-11-26 00:00:00	32020		\N	159901	0	10509002	260139		0
40701	2419	378001	2018-12-10	2018-12-10 00:00:00	2019-01-09	2019-01-09 00:00:00	32020		\N	160508	0	62106007	378001		0
40846	2428	4112343	1989-04-21	1989-04-21 00:00:00	1989-05-03	1989-05-03 00:00:00	32020		\N	161083	0	195662009	4112343		0
41112	2443	4043241	2018-01-25	2018-01-25 00:00:00	\N	\N	32020		\N	162032	0	230265002	4043241		0
41177	2447	40481087	1994-06-13	1994-06-13 00:00:00	1994-06-20	1994-06-20 00:00:00	32020		\N	162332	0	444814009	40481087		0
41361	2459	260139	2006-06-16	2006-06-16 00:00:00	2006-06-23	2006-06-23 00:00:00	32020		\N	163055	0	10509002	260139		0
41503	2468	40481087	2004-10-29	2004-10-29 00:00:00	2004-11-05	2004-11-05 00:00:00	32020		\N	163636	0	444814009	40481087		0
31204	1847	260139	1961-09-24	1961-09-24 00:00:00	1961-10-08	1961-10-08 00:00:00	32020		\N	123515	0	10509002	260139		0
31353	1852	40481087	1995-07-16	1995-07-16 00:00:00	1995-08-06	1995-08-06 00:00:00	32020		\N	123987	0	444814009	40481087		0
42044	2503	81151	1986-10-10	1986-10-10 00:00:00	1986-11-07	1986-11-07 00:00:00	32020		\N	165649	0	44465007	81151		0
42253	2518	40481087	2008-02-01	2008-02-01 00:00:00	2008-02-15	2008-02-15 00:00:00	32020		\N	166532	0	444814009	40481087		0
42396	2526	40481087	1990-06-06	1990-06-06 00:00:00	1990-06-20	1990-06-20 00:00:00	32020		\N	167026	0	444814009	40481087		0
21411	1283	81151	1989-01-19	1989-01-19 00:00:00	1989-02-02	1989-02-02 00:00:00	32020		\N	84824	0	44465007	81151		0
32106	1906	40481087	1967-04-04	1967-04-04 00:00:00	1967-04-11	1967-04-11 00:00:00	32020		\N	126911	0	444814009	40481087		0
32255	1916	372328	1977-06-04	1977-06-04 00:00:00	1978-02-13	1978-02-13 00:00:00	32020		\N	127467	0	65363002	372328		0
32421	1925	4237458	1959-06-06	1959-06-06 00:00:00	1959-07-06	1959-07-06 00:00:00	32020		\N	128084	0	58150001	4237458		0
22019	1317	40481087	1968-12-21	1968-12-21 00:00:00	1969-01-11	1969-01-11 00:00:00	32020		\N	87243	0	444814009	40481087		0
32766	1946	40481087	1927-10-24	1927-10-24 00:00:00	1927-11-14	1927-11-14 00:00:00	32020		\N	129314	0	444814009	40481087		0
22382	1335	78272	2003-12-19	2003-12-19 00:00:00	2004-01-02	2004-01-02 00:00:00	32020		\N	88556	0	70704007	78272		0
33044	1960	4156265	1969-11-15	1969-11-15 00:00:00	1969-12-06	1969-12-06 00:00:00	32020		\N	130331	0	370247008	4156265		0
22726	1356	81151	1983-08-01	1983-08-01 00:00:00	1983-08-29	1983-08-29 00:00:00	32020		\N	89861	0	44465007	81151		0
33382	1980	4142905	1988-07-02	1988-07-02 00:00:00	1988-08-01	1988-08-01 00:00:00	32020		\N	131806	0	33737001	4142905		0
23062	1377	80180	2015-07-13	2015-07-13 00:00:00	\N	\N	32020		\N	91285	0	396275006	80180		0
23196	1384	40481087	2012-08-16	2012-08-16 00:00:00	2012-08-23	2012-08-23 00:00:00	32020		\N	91789	0	444814009	40481087		0
33892	2012	40481087	1973-04-12	1973-04-12 00:00:00	1973-04-26	1973-04-26 00:00:00	32020		\N	133898	0	444814009	40481087		0
34068	2025	28060	2017-08-10	2017-08-10 00:00:00	2017-08-17	2017-08-17 00:00:00	32020		\N	134702	0	43878008	28060		0
34198	2030	260139	2014-03-27	2014-03-27 00:00:00	2014-04-10	2014-04-10 00:00:00	32020		\N	135163	0	10509002	260139		0
34427	2043	4112343	2005-04-15	2005-04-15 00:00:00	2005-04-23	2005-04-23 00:00:00	32020		\N	135875	0	195662009	4112343		0
24017	1433	4027663	1985-12-28	1985-12-28 00:00:00	\N	\N	32020		\N	95476	0	13200003	4027663		0
34765	2064	260139	1993-10-06	1993-10-06 00:00:00	1993-10-13	1993-10-13 00:00:00	32020		\N	137281	0	10509002	260139		0
34938	2075	28060	1982-06-07	1982-06-07 00:00:00	1982-06-20	1982-06-20 00:00:00	32020		\N	138117	0	43878008	28060		0
24537	1464	28060	2016-07-26	2016-07-26 00:00:00	2016-08-04	2016-08-04 00:00:00	32020		\N	97514	0	43878008	28060		0
24722	1475	4027663	1968-08-14	1968-08-14 00:00:00	\N	\N	32020		\N	98273	0	13200003	4027663		0
35419	2098	257012	1972-11-06	1972-11-06 00:00:00	\N	\N	32020		\N	139894	0	40055000	257012		0
35542	2105	81893	2011-05-06	2011-05-06 00:00:00	\N	\N	32020		\N	140219	0	64766004	81893		0
25210	1504	40481087	2011-02-23	2011-02-23 00:00:00	2011-03-02	2011-03-02 00:00:00	32020		\N	100281	0	444814009	40481087		0
25345	1511	4218389	2000-09-09	2000-09-09 00:00:00	2000-10-14	2000-10-14 00:00:00	32020		\N	100934	0	39848009	4218389		0
36063	2138	40481087	1955-10-13	1955-10-13 00:00:00	1955-10-20	1955-10-20 00:00:00	32020		\N	142429	0	444814009	40481087		0
36211	2147	4112343	1962-04-08	1962-04-08 00:00:00	1962-04-18	1962-04-18 00:00:00	32020		\N	142928	0	195662009	4112343		0
36387	2153	40481087	2008-11-25	2008-11-25 00:00:00	2008-12-16	2008-12-16 00:00:00	32020		\N	143478	0	444814009	40481087		0
36553	2164	4112343	1985-05-17	1985-05-17 00:00:00	1985-05-30	1985-05-30 00:00:00	32020		\N	144141	0	195662009	4112343		0
36707	2173	4027663	1964-06-29	1964-06-29 00:00:00	\N	\N	32020		\N	144848	0	13200003	4027663		0
36866	2180	4112343	1979-01-30	1979-01-30 00:00:00	1979-02-11	1979-02-11 00:00:00	32020		\N	145404	0	195662009	4112343		0
26489	1569	81893	1969-06-23	1969-06-23 00:00:00	\N	\N	32020		\N	105254	0	64766004	81893		0
37187	2202	260139	1982-08-26	1982-08-26 00:00:00	1982-09-09	1982-09-09 00:00:00	32020		\N	146789	0	10509002	260139		0
37395	2217	80180	2018-11-06	2018-11-06 00:00:00	\N	\N	32020		\N	147681	0	396275006	80180		0
27030	1599	40481087	1975-01-28	1975-01-28 00:00:00	1975-02-04	1975-02-04 00:00:00	32020		\N	107292	0	444814009	40481087		0
27178	1606	378001	1984-07-12	1984-07-12 00:00:00	1984-08-11	1984-08-11 00:00:00	32020		\N	107857	0	62106007	378001		0
37855	2243	4112343	1988-06-09	1988-06-09 00:00:00	1988-06-17	1988-06-17 00:00:00	32020		\N	149373	0	195662009	4112343		0
38091	2261	4112343	2006-02-05	2006-02-05 00:00:00	2006-02-12	2006-02-12 00:00:00	32020		\N	150287	0	195662009	4112343		0
38194	2267	81151	1980-02-28	1980-02-28 00:00:00	1980-04-03	1980-04-03 00:00:00	32020		\N	150705	0	44465007	81151		0
38441	2283	40481087	2011-12-03	2011-12-03 00:00:00	2011-12-17	2011-12-17 00:00:00	32020		\N	151916	0	444814009	40481087		0
38595	2291	4155034	1989-05-21	1989-05-21 00:00:00	1989-06-04	1989-06-04 00:00:00	32020		\N	152486	0	283371005	4155034		0
28214	1666	40481087	1967-08-31	1967-08-31 00:00:00	1967-09-14	1967-09-14 00:00:00	32020		\N	111854	0	444814009	40481087		0
38873	2309	4112343	1999-04-04	1999-04-04 00:00:00	1999-04-16	1999-04-16 00:00:00	32020		\N	153651	0	195662009	4112343		0
39053	2319	40481087	1983-10-31	1983-10-31 00:00:00	1983-11-21	1983-11-21 00:00:00	32020		\N	154165	0	444814009	40481087		0
28656	1695	80180	2010-05-03	2010-05-03 00:00:00	\N	\N	32020		\N	113490	0	396275006	80180		0
39369	2334	4059173	1964-08-14	1964-08-14 00:00:00	1964-10-13	1964-10-13 00:00:00	32020		\N	155341	0	16114001	4059173		0
29019	1718	40481087	1973-09-19	1973-09-19 00:00:00	1973-10-03	1973-10-03 00:00:00	32020		\N	114855	0	444814009	40481087		0
39681	2349	192671	2005-02-03	2005-02-03 00:00:00	\N	\N	32020		\N	156438	0	K92.2	35208414		0
29375	1739	260139	1985-06-13	1985-06-13 00:00:00	1985-06-27	1985-06-27 00:00:00	32020		\N	116210	0	10509002	260139		0
29511	1746	195588	2002-11-01	2002-11-01 00:00:00	2002-12-15	2002-12-15 00:00:00	32020		\N	116796	0	38822007	195588		0
29679	1756	4027663	2002-07-30	2002-07-30 00:00:00	\N	\N	32020		\N	117418	0	13200003	4027663		0
29825	1764	40481087	1977-11-01	1977-11-01 00:00:00	1977-11-15	1977-11-15 00:00:00	32020		\N	117996	0	444814009	40481087		0
40524	2409	4112343	2016-01-02	2016-01-02 00:00:00	2016-01-14	2016-01-14 00:00:00	32020		\N	159952	0	195662009	4112343		0
40702	2419	40481087	1951-01-26	1951-01-26 00:00:00	1951-02-16	1951-02-16 00:00:00	32020		\N	160615	0	444814009	40481087		0
40847	2428	4294548	1987-03-08	1987-03-08 00:00:00	1987-03-29	1987-03-29 00:00:00	32020		\N	161093	0	75498004	4294548		0
41113	2443	28060	1980-08-20	1980-08-20 00:00:00	1980-08-30	1980-08-30 00:00:00	32020		\N	162038	0	43878008	28060		0
41178	2447	40481087	2010-03-19	2010-03-19 00:00:00	2010-04-02	2010-04-02 00:00:00	32020		\N	162333	0	444814009	40481087		0
41362	2459	260139	2015-03-23	2015-03-23 00:00:00	2015-04-06	2015-04-06 00:00:00	32020		\N	163063	0	10509002	260139		0
41504	2468	81151	1979-05-19	1979-05-19 00:00:00	1979-06-09	1979-06-09 00:00:00	32020		\N	163676	0	44465007	81151		0
31205	1847	260139	1931-08-15	1931-08-15 00:00:00	1931-08-22	1931-08-22 00:00:00	32020		\N	123573	0	10509002	260139		0
31354	1852	28060	1976-07-22	1976-07-22 00:00:00	1976-07-29	1976-07-29 00:00:00	32020		\N	123950	0	43878008	28060		0
42045	2503	80180	2017-02-24	2017-02-24 00:00:00	\N	\N	32020		\N	165729	0	396275006	80180		0
42254	2518	28060	1993-12-21	1993-12-21 00:00:00	1993-12-28	1993-12-28 00:00:00	32020		\N	166506	0	43878008	28060		0
42397	2526	4218389	2014-04-23	2014-04-23 00:00:00	2014-05-21	2014-05-21 00:00:00	32020		\N	167008	0	39848009	4218389		0
31929	1898	4152936	1994-06-04	1994-06-04 00:00:00	1994-06-25	1994-06-25 00:00:00	32020		\N	126338	0	283385000	4152936		0
32107	1906	28060	2012-03-26	2012-03-26 00:00:00	2012-04-04	2012-04-04 00:00:00	32020		\N	126913	0	43878008	28060		0
32256	1916	192671	2007-06-07	2007-06-07 00:00:00	\N	\N	32020		\N	127417	0	K92.2	35208414		0
32422	1925	40481087	1980-04-03	1980-04-03 00:00:00	1980-04-10	1980-04-10 00:00:00	32020		\N	128172	0	444814009	40481087		0
22020	1318	81151	1972-07-10	1972-07-10 00:00:00	1972-07-31	1972-07-31 00:00:00	32020		\N	87400	0	44465007	81151		0
32767	1946	4230399	1997-05-24	1997-05-24 00:00:00	1997-06-23	1997-06-23 00:00:00	32020		\N	129277	0	359817006	4230399		0
22383	1335	4112343	2010-05-30	2010-05-30 00:00:00	2010-06-12	2010-06-12 00:00:00	32020		\N	88582	0	195662009	4112343		0
33045	1960	4294548	1979-09-10	1979-09-10 00:00:00	1979-10-08	1979-10-08 00:00:00	32020		\N	130364	0	75498004	4294548		0
22727	1356	40481087	1981-09-08	1981-09-08 00:00:00	1981-09-15	1981-09-15 00:00:00	32020		\N	89929	0	444814009	40481087		0
33383	1980	81151	2014-05-31	2014-05-31 00:00:00	2014-06-14	2014-06-14 00:00:00	32020		\N	131809	0	44465007	81151		0
23063	1377	4112343	2017-11-16	2017-11-16 00:00:00	2017-11-23	2017-11-23 00:00:00	32020		\N	91240	0	195662009	4112343		0
23197	1385	4296205	2003-06-02	2003-06-02 00:00:00	2003-06-30	2003-06-30 00:00:00	32020		\N	91875	0	403191005	4296205		0
33893	2012	260139	1965-06-02	1965-06-02 00:00:00	1965-06-16	1965-06-16 00:00:00	32020		\N	133917	0	10509002	260139		0
34069	2025	28060	1910-11-29	1910-11-29 00:00:00	1910-12-10	1910-12-10 00:00:00	32020		\N	134691	0	43878008	28060		0
34199	2030	4112343	2010-06-21	2010-06-21 00:00:00	2010-07-04	2010-07-04 00:00:00	32020		\N	135161	0	195662009	4112343		0
34428	2043	40481087	1985-10-24	1985-10-24 00:00:00	1985-11-14	1985-11-14 00:00:00	32020		\N	135934	0	444814009	40481087		0
24018	1433	4112343	1963-07-18	1963-07-18 00:00:00	1963-07-30	1963-07-30 00:00:00	32020		\N	95459	0	195662009	4112343		0
34766	2064	4112343	2000-09-02	2000-09-02 00:00:00	2000-09-12	2000-09-12 00:00:00	32020		\N	137259	0	195662009	4112343		0
34939	2075	4294548	1973-10-14	1973-10-14 00:00:00	1973-10-21	1973-10-21 00:00:00	32020		\N	138076	0	75498004	4294548		0
24538	1464	4155034	2017-06-21	2017-06-21 00:00:00	2017-07-05	2017-07-05 00:00:00	32020		\N	97582	0	283371005	4155034		0
24723	1475	40481087	1967-02-20	1967-02-20 00:00:00	1967-02-27	1967-02-27 00:00:00	32020		\N	98273	0	444814009	40481087		0
35420	2098	4294548	1981-02-13	1981-02-13 00:00:00	1981-05-01	1981-05-01 00:00:00	32020		\N	139826	0	75498004	4294548		0
35543	2105	40481087	2010-12-21	2010-12-21 00:00:00	2011-01-04	2011-01-04 00:00:00	32020		\N	140219	0	444814009	40481087		0
25211	1504	4294548	1942-02-11	1942-02-11 00:00:00	1942-02-25	1942-02-25 00:00:00	32020		\N	100265	0	75498004	4294548		0
25347	1511	40481087	2000-07-24	2000-07-24 00:00:00	2000-08-07	2000-08-07 00:00:00	32020		\N	100914	0	444814009	40481087		0
36064	2138	4155034	1995-03-09	1995-03-09 00:00:00	1995-03-23	1995-03-23 00:00:00	32020		\N	142414	0	283371005	4155034		0
36212	2147	40481087	2002-08-22	2002-08-22 00:00:00	2002-09-05	2002-09-05 00:00:00	32020		\N	142890	0	444814009	40481087		0
36388	2153	81151	1975-02-06	1975-02-06 00:00:00	1975-02-20	1975-02-20 00:00:00	32020		\N	143472	0	44465007	81151		0
36554	2164	4296204	1982-10-07	1982-10-07 00:00:00	1982-10-28	1982-10-28 00:00:00	32020		\N	144122	0	403190006	4296204		0
36708	2173	4059173	1940-10-13	1940-10-13 00:00:00	1940-11-12	1940-11-12 00:00:00	32020		\N	144757	0	16114001	4059173		0
36867	2180	40481087	1990-01-30	1990-01-30 00:00:00	1990-02-13	1990-02-13 00:00:00	32020		\N	145406	0	444814009	40481087		0
26490	1569	4294548	1968-09-29	1968-09-29 00:00:00	1968-10-20	1968-10-20 00:00:00	32020		\N	105254	0	75498004	4294548		0
37199	2204	40481087	1954-02-25	1954-02-25 00:00:00	1954-03-04	1954-03-04 00:00:00	32020		\N	146913	0	444814009	40481087		0
37396	2217	40481087	2017-01-18	2017-01-18 00:00:00	2017-02-01	2017-02-01 00:00:00	32020		\N	147681	0	444814009	40481087		0
27031	1599	372328	1980-05-23	1980-05-23 00:00:00	1982-07-05	1982-07-05 00:00:00	32020		\N	107301	0	65363002	372328		0
27179	1606	260139	2000-12-28	2000-12-28 00:00:00	2001-01-04	2001-01-04 00:00:00	32020		\N	107859	0	10509002	260139		0
37856	2243	192671	2005-10-16	2005-10-16 00:00:00	\N	\N	32020		\N	149316	0	K92.2	35208414		0
38092	2261	4152936	1973-10-13	1973-10-13 00:00:00	1973-10-27	1973-10-27 00:00:00	32020		\N	150308	0	283385000	4152936		0
38195	2267	40481087	1972-09-12	1972-09-12 00:00:00	1972-09-26	1972-09-26 00:00:00	32020		\N	150720	0	444814009	40481087		0
38442	2283	4218389	2003-05-03	2003-05-03 00:00:00	2003-05-24	2003-05-24 00:00:00	32020		\N	151884	0	39848009	4218389		0
38596	2291	40481087	1997-07-05	1997-07-05 00:00:00	1997-07-26	1997-07-26 00:00:00	32020		\N	152505	0	444814009	40481087		0
28215	1666	260139	2018-05-04	2018-05-04 00:00:00	2018-05-18	2018-05-18 00:00:00	32020		\N	111887	0	10509002	260139		0
38874	2309	4142905	1980-04-06	1980-04-06 00:00:00	1980-06-05	1980-06-05 00:00:00	32020		\N	153630	0	33737001	4142905		0
39054	2320	372328	1947-05-03	1947-05-03 00:00:00	1947-07-19	1947-07-19 00:00:00	32020		\N	154293	0	65363002	372328		0
28657	1695	4294548	2009-11-24	2009-11-24 00:00:00	2009-12-15	2009-12-15 00:00:00	32020		\N	113490	0	75498004	4294548		0
39370	2334	80180	1971-07-05	1971-07-05 00:00:00	\N	\N	32020		\N	155333	0	396275006	80180		0
29020	1718	4112343	1976-04-16	1976-04-16 00:00:00	1976-04-24	1976-04-24 00:00:00	32020		\N	114842	0	195662009	4112343		0
39682	2349	4283893	1992-08-28	1992-08-28 00:00:00	1992-10-16	1992-10-16 00:00:00	32020		\N	156351	0	36971009	4283893		0
29376	1739	439777	1986-04-07	1986-04-07 00:00:00	\N	\N	32020		\N	116216	0	271737000	439777		0
29518	1748	40481087	1947-07-09	1947-07-09 00:00:00	1947-07-23	1947-07-23 00:00:00	32020		\N	116914	0	444814009	40481087		0
29680	1756	40481087	2011-03-19	2011-03-19 00:00:00	2011-04-09	2011-04-09 00:00:00	32020		\N	117436	0	444814009	40481087		0
29826	1764	4146173	1984-10-12	1984-10-12 00:00:00	1984-11-11	1984-11-11 00:00:00	32020		\N	117940	0	307731004	4146173		0
40525	2409	4112343	1996-09-19	1996-09-19 00:00:00	1996-09-28	1996-09-28 00:00:00	32020		\N	159914	0	195662009	4112343		0
40703	2419	40481087	1953-05-12	1953-05-12 00:00:00	1953-05-19	1953-05-19 00:00:00	32020		\N	160628	0	444814009	40481087		0
40848	2428	4142905	1984-01-18	1984-01-18 00:00:00	1984-02-17	1984-02-17 00:00:00	32020		\N	161080	0	33737001	4142905		0
41114	2443	40481087	2014-12-19	2014-12-19 00:00:00	2015-01-02	2015-01-02 00:00:00	32020		\N	162028	0	444814009	40481087		0
41179	2447	40481087	1984-05-07	1984-05-07 00:00:00	1984-05-28	1984-05-28 00:00:00	32020		\N	162310	0	444814009	40481087		0
41363	2459	80180	2015-08-31	2015-08-31 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
41505	2468	4112343	2005-03-04	2005-03-04 00:00:00	2005-03-11	2005-03-11 00:00:00	32020		\N	163608	0	195662009	4112343		0
31206	1847	40481087	1989-03-16	1989-03-16 00:00:00	1989-03-23	1989-03-23 00:00:00	32020		\N	123540	0	444814009	40481087		0
31355	1852	372328	1976-09-25	1976-09-25 00:00:00	1977-01-26	1977-01-26 00:00:00	32020		\N	123867	0	65363002	372328		0
42046	2503	4112343	2003-11-09	2003-11-09 00:00:00	2003-11-17	2003-11-17 00:00:00	32020		\N	165652	0	195662009	4112343		0
42255	2518	4296205	1997-10-09	1997-10-09 00:00:00	1997-11-13	1997-11-13 00:00:00	32020		\N	166544	0	403191005	4296205		0
42398	2526	372328	1977-04-28	1977-04-28 00:00:00	1977-05-30	1977-05-30 00:00:00	32020		\N	167032	0	65363002	372328		0
31930	1898	260139	1979-10-23	1979-10-23 00:00:00	1979-10-30	1979-10-30 00:00:00	32020		\N	126392	0	10509002	260139		0
32108	1906	372328	1963-01-01	1963-01-01 00:00:00	1963-04-20	1963-04-20 00:00:00	32020		\N	126881	0	65363002	372328		0
32257	1916	4051466	1974-10-10	1974-10-10 00:00:00	1991-01-16	1991-01-16 00:00:00	32020		\N	127450	0	233678006	4051466		0
32423	1925	4152936	2019-02-03	2019-02-03 00:00:00	2019-02-17	2019-02-17 00:00:00	32020		\N	128178	0	283385000	4152936		0
22021	1318	80180	1973-02-17	1973-02-17 00:00:00	\N	\N	32020		\N	87400	0	396275006	80180		0
32768	1946	40481087	1993-05-03	1993-05-03 00:00:00	1993-05-17	1993-05-17 00:00:00	32020		\N	129310	0	444814009	40481087		0
22384	1335	40481087	2007-06-27	2007-06-27 00:00:00	2007-07-04	2007-07-04 00:00:00	32020		\N	88563	0	444814009	40481087		0
33046	1960	195588	1954-08-20	1954-08-20 00:00:00	1954-09-29	1954-09-29 00:00:00	32020		\N	130336	0	38822007	195588		0
22728	1356	80180	2016-09-11	2016-09-11 00:00:00	\N	\N	32020		\N	89906	0	396275006	80180		0
33384	1980	260139	2006-01-23	2006-01-23 00:00:00	2006-02-06	2006-02-06 00:00:00	32020		\N	131832	0	10509002	260139		0
23064	1377	40481087	1988-08-23	1988-08-23 00:00:00	1988-09-06	1988-09-06 00:00:00	32020		\N	91254	0	444814009	40481087		0
23198	1385	4146173	1999-10-21	1999-10-21 00:00:00	1999-11-20	1999-11-20 00:00:00	32020		\N	91812	0	307731004	4146173		0
33894	2012	4094814	1983-03-08	1983-03-08 00:00:00	1983-06-06	1983-06-06 00:00:00	32020		\N	133866	0	262574004	4094814		0
34070	2025	378001	1928-12-21	1928-12-21 00:00:00	1929-02-19	1929-02-19 00:00:00	32020		\N	134663	0	62106007	378001		0
34200	2030	4112343	1978-12-24	1978-12-24 00:00:00	1979-01-04	1979-01-04 00:00:00	32020		\N	135119	0	195662009	4112343		0
34429	2043	28060	1970-05-28	1970-05-28 00:00:00	1970-06-04	1970-06-04 00:00:00	32020		\N	135894	0	43878008	28060		0
24019	1433	4112343	2017-03-21	2017-03-21 00:00:00	2017-03-30	2017-03-30 00:00:00	32020		\N	95485	0	195662009	4112343		0
34767	2064	78272	1989-02-28	1989-02-28 00:00:00	1989-03-21	1989-03-21 00:00:00	32020		\N	137305	0	70704007	78272		0
34940	2075	40481087	2000-04-11	2000-04-11 00:00:00	2000-04-18	2000-04-18 00:00:00	32020		\N	138132	0	444814009	40481087		0
24539	1464	4112343	1965-01-08	1965-01-08 00:00:00	1965-01-18	1965-01-18 00:00:00	32020		\N	97547	0	195662009	4112343		0
24724	1475	260139	1993-04-29	1993-04-29 00:00:00	1993-05-13	1993-05-13 00:00:00	32020		\N	98260	0	10509002	260139		0
35421	2098	4283893	2007-08-28	2007-08-28 00:00:00	2008-07-22	2008-07-22 00:00:00	32020		\N	139906	0	36971009	4283893		0
35544	2105	30753	2011-08-04	2011-08-04 00:00:00	\N	\N	32020		\N	140219	0	16761005	30753		0
25212	1505	4112343	2004-10-18	2004-10-18 00:00:00	2004-10-25	2004-10-25 00:00:00	32020		\N	100357	0	195662009	4112343		0
25348	1511	260139	1966-01-22	1966-01-22 00:00:00	1966-02-05	1966-02-05 00:00:00	32020		\N	100899	0	10509002	260139		0
36065	2138	4112343	1958-07-24	1958-07-24 00:00:00	1958-08-03	1958-08-03 00:00:00	32020		\N	142373	0	195662009	4112343		0
36213	2147	4112343	1967-02-24	1967-02-24 00:00:00	1967-03-04	1967-03-04 00:00:00	32020		\N	142885	0	195662009	4112343		0
36389	2153	257012	1994-11-28	1994-11-28 00:00:00	\N	\N	32020		\N	143477	0	40055000	257012		0
36555	2164	4112343	2012-04-07	2012-04-07 00:00:00	2012-04-14	2012-04-14 00:00:00	32020		\N	144157	0	195662009	4112343		0
36709	2173	4112343	1976-11-21	1976-11-21 00:00:00	1976-12-02	1976-12-02 00:00:00	32020		\N	144730	0	195662009	4112343		0
36868	2180	40481087	1986-12-25	1986-12-25 00:00:00	1987-01-15	1987-01-15 00:00:00	32020		\N	145400	0	444814009	40481087		0
26491	1569	4149245	1998-12-11	1998-12-11 00:00:00	1999-01-17	1999-01-17 00:00:00	32020		\N	105229	0	30832001	4149245		0
37200	2204	378001	1964-06-17	1964-06-17 00:00:00	1964-08-16	1964-08-16 00:00:00	32020		\N	146928	0	62106007	378001		0
37397	2217	260139	2001-01-06	2001-01-06 00:00:00	2001-01-13	2001-01-13 00:00:00	32020		\N	147629	0	10509002	260139		0
27032	1599	260139	1971-10-24	1971-10-24 00:00:00	1971-10-31	1971-10-31 00:00:00	32020		\N	107290	0	10509002	260139		0
27180	1606	260139	2018-02-10	2018-02-10 00:00:00	2018-02-17	2018-02-17 00:00:00	32020		\N	107862	0	10509002	260139		0
37857	2243	81151	1967-01-16	1967-01-16 00:00:00	1967-01-30	1967-01-30 00:00:00	32020		\N	149360	0	44465007	81151		0
38093	2261	4112343	2016-09-19	2016-09-19 00:00:00	2016-10-01	2016-10-01 00:00:00	32020		\N	150314	0	195662009	4112343		0
38196	2267	4112343	2000-08-30	2000-08-30 00:00:00	2000-09-11	2000-09-11 00:00:00	32020		\N	150726	0	195662009	4112343		0
38443	2283	40481087	1976-04-09	1976-04-09 00:00:00	1976-04-23	1976-04-23 00:00:00	32020		\N	151912	0	444814009	40481087		0
38597	2291	28060	2016-02-21	2016-02-21 00:00:00	2016-03-01	2016-03-01 00:00:00	32020		\N	152507	0	43878008	28060		0
28216	1666	260139	1948-08-25	1948-08-25 00:00:00	1948-09-01	1948-09-01 00:00:00	32020		\N	111943	0	10509002	260139		0
38875	2309	28060	1977-09-07	1977-09-07 00:00:00	1977-09-16	1977-09-16 00:00:00	32020		\N	153612	0	43878008	28060		0
39055	2320	192671	1980-03-23	1980-03-23 00:00:00	\N	\N	32020		\N	154340	0	K92.2	35208414		0
28658	1695	40481087	1970-02-15	1970-02-15 00:00:00	1970-03-01	1970-03-01 00:00:00	32020		\N	113471	0	444814009	40481087		0
39371	2334	28060	1942-05-10	1942-05-10 00:00:00	1942-05-17	1942-05-17 00:00:00	32020		\N	155285	0	43878008	28060		0
29021	1718	4112343	2010-09-10	2010-09-10 00:00:00	2010-09-22	2010-09-22 00:00:00	32020		\N	114858	0	195662009	4112343		0
39688	2351	260139	1958-07-26	1958-07-26 00:00:00	1958-08-09	1958-08-09 00:00:00	32020		\N	156569	0	10509002	260139		0
29377	1739	40481087	2017-04-12	2017-04-12 00:00:00	2017-04-19	2017-04-19 00:00:00	32020		\N	116222	0	444814009	40481087		0
29519	1748	260139	1964-10-08	1964-10-08 00:00:00	1964-10-22	1964-10-22 00:00:00	32020		\N	116921	0	10509002	260139		0
29681	1756	4094814	2017-07-11	2017-07-11 00:00:00	2017-10-09	2017-10-09 00:00:00	32020		\N	117446	0	262574004	4094814		0
29827	1764	260139	1992-12-22	1992-12-22 00:00:00	1992-12-29	1992-12-29 00:00:00	32020		\N	117982	0	10509002	260139		0
40526	2409	28060	2017-04-10	2017-04-10 00:00:00	2017-04-22	2017-04-22 00:00:00	32020		\N	159937	0	43878008	28060		0
40704	2419	4112343	1952-05-13	1952-05-13 00:00:00	1952-05-23	1952-05-23 00:00:00	32020		\N	160568	0	195662009	4112343		0
40849	2428	40481087	2010-09-11	2010-09-11 00:00:00	2010-09-18	2010-09-18 00:00:00	32020		\N	161086	0	444814009	40481087		0
41115	2443	28060	1975-06-04	1975-06-04 00:00:00	1975-06-17	1975-06-17 00:00:00	32020		\N	162087	0	43878008	28060		0
41180	2447	4027663	2008-08-13	2008-08-13 00:00:00	\N	\N	32020		\N	162314	0	13200003	4027663		0
41364	2460	4152936	1991-04-04	1991-04-04 00:00:00	1991-04-18	1991-04-18 00:00:00	32020		\N	163069	0	283385000	4152936		0
41506	2468	40481087	2012-04-27	2012-04-27 00:00:00	2012-05-18	2012-05-18 00:00:00	32020		\N	163654	0	444814009	40481087		0
31207	1847	4285898	1957-08-19	1957-08-19 00:00:00	\N	\N	32020		\N	123497	0	68496003	4285898		0
41905	2495	260139	1985-05-08	1985-05-08 00:00:00	1985-05-22	1985-05-22 00:00:00	32020		\N	165123	0	10509002	260139		0
42047	2503	372328	1975-03-12	1975-03-12 00:00:00	1975-07-29	1975-07-29 00:00:00	32020		\N	165765	0	65363002	372328		0
42256	2518	260139	1993-08-09	1993-08-09 00:00:00	1993-08-16	1993-08-16 00:00:00	32020		\N	166530	0	10509002	260139		0
42399	2526	4113008	2004-05-17	2004-05-17 00:00:00	2004-05-31	2004-05-31 00:00:00	32020		\N	167006	0	284549007	4113008		0
31931	1898	4112343	1976-07-09	1976-07-09 00:00:00	1976-07-20	1976-07-20 00:00:00	32020		\N	126395	0	195662009	4112343		0
32109	1906	40481087	1999-06-20	1999-06-20 00:00:00	1999-06-27	1999-06-27 00:00:00	32020		\N	126853	0	444814009	40481087		0
32258	1916	4059173	1977-07-18	1977-07-18 00:00:00	1977-08-17	1977-08-17 00:00:00	32020		\N	127440	0	16114001	4059173		0
32424	1925	260139	1975-06-08	1975-06-08 00:00:00	1975-06-15	1975-06-15 00:00:00	32020		\N	128161	0	10509002	260139		0
22022	1318	4112343	1953-07-13	1953-07-13 00:00:00	1953-07-21	1953-07-21 00:00:00	32020		\N	87340	0	195662009	4112343		0
32769	1946	4112343	1963-10-18	1963-10-18 00:00:00	1963-10-25	1963-10-25 00:00:00	32020		\N	129333	0	195662009	4112343		0
22385	1335	372328	1984-02-06	1984-02-06 00:00:00	1984-07-30	1984-07-30 00:00:00	32020		\N	88566	0	65363002	372328		0
33047	1960	378419	2002-11-12	2002-11-12 00:00:00	\N	\N	32020		\N	130412	0	26929004	378419		0
22729	1356	372328	2016-08-07	2016-08-07 00:00:00	2016-10-14	2016-10-14 00:00:00	32020		\N	89906	0	65363002	372328		0
33385	1980	4112343	2007-06-05	2007-06-05 00:00:00	2007-06-16	2007-06-16 00:00:00	32020		\N	131834	0	195662009	4112343		0
23065	1377	260139	2008-12-02	2008-12-02 00:00:00	2008-12-09	2008-12-09 00:00:00	32020		\N	91253	0	10509002	260139		0
23199	1385	28060	1972-05-22	1972-05-22 00:00:00	1972-05-31	1972-05-31 00:00:00	32020		\N	91818	0	43878008	28060		0
33895	2012	372328	1971-05-10	1971-05-10 00:00:00	1971-07-16	1971-07-16 00:00:00	32020		\N	133907	0	65363002	372328		0
34071	2025	4283893	2015-11-27	2015-11-27 00:00:00	2016-03-04	2016-03-04 00:00:00	32020		\N	134696	0	36971009	4283893		0
34201	2030	381316	2005-07-24	2005-07-24 00:00:00	\N	\N	32020		\N	135101	0	230690007	381316		0
34430	2044	40481087	2015-05-17	2015-05-17 00:00:00	2015-05-31	2015-05-31 00:00:00	32020		\N	135981	0	444814009	40481087		0
24020	1433	260139	1970-01-13	1970-01-13 00:00:00	1970-01-27	1970-01-27 00:00:00	32020		\N	95491	0	10509002	260139		0
34768	2064	260139	2008-11-02	2008-11-02 00:00:00	2008-11-16	2008-11-16 00:00:00	32020		\N	137291	0	10509002	260139		0
34941	2075	4112343	2007-02-11	2007-02-11 00:00:00	2007-02-18	2007-02-18 00:00:00	32020		\N	138031	0	195662009	4112343		0
24540	1464	40481087	1986-02-18	1986-02-18 00:00:00	1986-03-11	1986-03-11 00:00:00	32020		\N	97534	0	444814009	40481087		0
24725	1475	81151	1984-12-26	1984-12-26 00:00:00	1985-01-09	1985-01-09 00:00:00	32020		\N	98251	0	44465007	81151		0
35422	2098	4113008	2007-04-23	2007-04-23 00:00:00	2007-05-14	2007-05-14 00:00:00	32020		\N	139842	0	284549007	4113008		0
35545	2105	4310024	2011-02-05	2011-02-05 00:00:00	\N	\N	32020		\N	140219	0	424802006	4310024		0
25213	1505	378001	1990-03-30	1990-03-30 00:00:00	1990-04-29	1990-04-29 00:00:00	32020		\N	100382	0	62106007	378001		0
25349	1511	4112343	1970-03-02	1970-03-02 00:00:00	1970-03-09	1970-03-09 00:00:00	32020		\N	100900	0	195662009	4112343		0
36066	2138	260139	1992-10-30	1992-10-30 00:00:00	1992-11-06	1992-11-06 00:00:00	32020		\N	142388	0	10509002	260139		0
36214	2147	4109685	1987-05-02	1987-05-02 00:00:00	1987-05-16	1987-05-16 00:00:00	32020		\N	142903	0	284551006	4109685		0
36390	2153	4112343	2007-04-22	2007-04-22 00:00:00	2007-05-01	2007-05-01 00:00:00	32020		\N	143474	0	195662009	4112343		0
36556	2164	80180	2012-08-05	2012-08-05 00:00:00	\N	\N	32020		\N	144157	0	396275006	80180		0
36710	2173	40479422	2010-06-27	2010-06-27 00:00:00	2010-09-02	2010-09-02 00:00:00	32020		\N	144892	0	444448004	40479422		0
36869	2180	192671	2017-09-28	2017-09-28 00:00:00	\N	\N	32020		\N	145442	0	K92.2	35208414		0
26504	1571	260139	1980-03-06	1980-03-06 00:00:00	1980-03-13	1980-03-13 00:00:00	32020		\N	105429	0	10509002	260139		0
37201	2204	40481087	1946-11-14	1946-11-14 00:00:00	1946-11-28	1946-11-28 00:00:00	32020		\N	146905	0	444814009	40481087		0
37398	2217	4112343	2015-08-04	2015-08-04 00:00:00	2015-08-16	2015-08-16 00:00:00	32020		\N	147671	0	195662009	4112343		0
27033	1599	378001	2003-09-26	2003-09-26 00:00:00	2003-10-26	2003-10-26 00:00:00	32020		\N	107362	0	62106007	378001		0
27181	1606	4112343	1994-01-31	1994-01-31 00:00:00	1994-02-10	1994-02-10 00:00:00	32020		\N	107819	0	195662009	4112343		0
37858	2243	40481087	2000-11-18	2000-11-18 00:00:00	2000-12-09	2000-12-09 00:00:00	32020		\N	149331	0	444814009	40481087		0
38094	2261	372328	1969-07-19	1969-07-19 00:00:00	1969-10-21	1969-10-21 00:00:00	32020		\N	150288	0	65363002	372328		0
38197	2267	40481087	1999-07-05	1999-07-05 00:00:00	1999-07-19	1999-07-19 00:00:00	32020		\N	150710	0	444814009	40481087		0
38444	2283	40481087	1991-11-07	1991-11-07 00:00:00	1991-11-14	1991-11-14 00:00:00	32020		\N	151879	0	444814009	40481087		0
38599	2291	260139	2001-03-14	2001-03-14 00:00:00	2001-03-21	2001-03-21 00:00:00	32020		\N	152417	0	10509002	260139		0
28217	1666	4134304	1982-06-22	1982-06-22 00:00:00	1982-08-21	1982-08-21 00:00:00	32020		\N	111879	0	263102004	4134304		0
38876	2309	4230399	1986-02-04	1986-02-04 00:00:00	1986-04-05	1986-04-05 00:00:00	32020		\N	153631	0	359817006	4230399		0
39056	2320	81151	1945-03-14	1945-03-14 00:00:00	1945-04-18	1945-04-18 00:00:00	32020		\N	154301	0	44465007	81151		0
28659	1695	40481087	1993-08-14	1993-08-14 00:00:00	1993-08-21	1993-08-21 00:00:00	32020		\N	113438	0	444814009	40481087		0
39372	2334	4112343	1975-06-05	1975-06-05 00:00:00	1975-06-15	1975-06-15 00:00:00	32020		\N	155316	0	195662009	4112343		0
29022	1718	40481087	2018-02-17	2018-02-17 00:00:00	2018-02-24	2018-02-24 00:00:00	32020		\N	114847	0	444814009	40481087		0
39689	2351	4278672	1966-03-27	1966-03-27 00:00:00	1966-04-26	1966-04-26 00:00:00	32020		\N	156506	0	65966004	4278672		0
29378	1739	4134304	1997-03-15	1997-03-15 00:00:00	1997-06-13	1997-06-13 00:00:00	32020		\N	116171	0	263102004	4134304		0
29520	1748	260139	1955-05-01	1955-05-01 00:00:00	1955-05-08	1955-05-08 00:00:00	32020		\N	116916	0	10509002	260139		0
29682	1756	28060	1977-05-13	1977-05-13 00:00:00	1977-05-20	1977-05-20 00:00:00	32020		\N	117424	0	43878008	28060		0
29828	1764	40481087	1969-01-16	1969-01-16 00:00:00	1969-01-23	1969-01-23 00:00:00	32020		\N	117937	0	444814009	40481087		0
40527	2409	40481087	1984-03-22	1984-03-22 00:00:00	1984-04-05	1984-04-05 00:00:00	32020		\N	159912	0	444814009	40481087		0
40705	2419	260139	1985-06-09	1985-06-09 00:00:00	1985-06-16	1985-06-16 00:00:00	32020		\N	160483	0	10509002	260139		0
40869	2431	40481087	1996-04-04	1996-04-04 00:00:00	1996-04-25	1996-04-25 00:00:00	32020		\N	161229	0	444814009	40481087		0
41116	2443	4296205	1992-08-18	1992-08-18 00:00:00	1992-09-22	1992-09-22 00:00:00	32020		\N	162035	0	403191005	4296205		0
41181	2447	40481087	2006-08-08	2006-08-08 00:00:00	2006-08-29	2006-08-29 00:00:00	32020		\N	162314	0	444814009	40481087		0
41365	2460	40481087	2010-05-30	2010-05-30 00:00:00	2010-06-20	2010-06-20 00:00:00	32020		\N	163123	0	444814009	40481087		0
41507	2468	260139	1998-07-21	1998-07-21 00:00:00	1998-07-28	1998-07-28 00:00:00	32020		\N	163653	0	10509002	260139		0
31208	1847	28060	1952-09-07	1952-09-07 00:00:00	1952-09-20	1952-09-20 00:00:00	32020		\N	123565	0	43878008	28060		0
41906	2495	80180	2015-04-10	2015-04-10 00:00:00	\N	\N	32020		\N	165183	0	396275006	80180		0
42048	2503	40481087	1994-04-07	1994-04-07 00:00:00	1994-04-28	1994-04-28 00:00:00	32020		\N	165764	0	444814009	40481087		0
42257	2518	40481087	1978-01-07	1978-01-07 00:00:00	1978-01-14	1978-01-14 00:00:00	32020		\N	166502	0	444814009	40481087		0
42400	2526	81151	2000-07-16	2000-07-16 00:00:00	2000-08-06	2000-08-06 00:00:00	32020		\N	167004	0	44465007	81151		0
31932	1898	4294548	1982-08-14	1982-08-14 00:00:00	1983-04-09	1983-04-09 00:00:00	32020		\N	126396	0	75498004	4294548		0
32110	1906	40481087	1962-10-13	1962-10-13 00:00:00	1962-10-20	1962-10-20 00:00:00	32020		\N	126909	0	444814009	40481087		0
32259	1916	40481087	2001-02-10	2001-02-10 00:00:00	2001-03-03	2001-03-03 00:00:00	32020		\N	127488	0	444814009	40481087		0
32425	1925	4112343	1990-05-03	1990-05-03 00:00:00	1990-05-13	1990-05-13 00:00:00	32020		\N	128162	0	195662009	4112343		0
22023	1318	40481087	1984-10-24	1984-10-24 00:00:00	1984-11-07	1984-11-07 00:00:00	32020		\N	87351	0	444814009	40481087		0
32770	1946	257012	1981-10-28	1981-10-28 00:00:00	\N	\N	32020		\N	129261	0	40055000	257012		0
22402	1338	260139	1992-05-24	1992-05-24 00:00:00	1992-05-31	1992-05-31 00:00:00	32020		\N	88686	0	10509002	260139		0
33048	1960	372328	1934-12-31	1934-12-31 00:00:00	1935-03-26	1935-03-26 00:00:00	32020		\N	130402	0	65363002	372328		0
22730	1357	40481087	1990-08-23	1990-08-23 00:00:00	1990-08-30	1990-08-30 00:00:00	32020		\N	90000	0	444814009	40481087		0
33386	1980	260139	1972-10-12	1972-10-12 00:00:00	1972-10-19	1972-10-19 00:00:00	32020		\N	131849	0	10509002	260139		0
23066	1377	40481087	2007-06-05	2007-06-05 00:00:00	2007-06-12	2007-06-12 00:00:00	32020		\N	91270	0	444814009	40481087		0
23200	1385	4112343	2016-11-12	2016-11-12 00:00:00	2016-11-22	2016-11-22 00:00:00	32020		\N	91830	0	195662009	4112343		0
33896	2012	40481087	2007-07-27	2007-07-27 00:00:00	2007-08-03	2007-08-03 00:00:00	32020		\N	133904	0	444814009	40481087		0
34072	2025	40481087	2009-04-15	2009-04-15 00:00:00	2009-04-29	2009-04-29 00:00:00	32020		\N	134754	0	444814009	40481087		0
34202	2030	260139	1995-01-05	1995-01-05 00:00:00	1995-01-12	1995-01-12 00:00:00	32020		\N	135159	0	10509002	260139		0
34431	2044	40481087	2006-04-04	2006-04-04 00:00:00	2006-04-18	2006-04-18 00:00:00	32020		\N	135969	0	444814009	40481087		0
24021	1433	195588	2019-01-03	2019-01-03 00:00:00	2019-02-20	2019-02-20 00:00:00	32020		\N	95444	0	38822007	195588		0
34769	2064	80180	2017-06-16	2017-06-16 00:00:00	\N	\N	32020		\N	137279	0	396275006	80180		0
34942	2075	260139	2000-09-14	2000-09-14 00:00:00	2000-09-21	2000-09-21 00:00:00	32020		\N	138005	0	10509002	260139		0
24541	1464	260139	1963-02-15	1963-02-15 00:00:00	1963-02-22	1963-02-22 00:00:00	32020		\N	97510	0	10509002	260139		0
24726	1476	80502	2004-12-02	2004-12-02 00:00:00	\N	\N	32020		\N	98458	0	64859006	80502		0
35423	2098	260139	1973-11-19	1973-11-19 00:00:00	1973-12-03	1973-12-03 00:00:00	32020		\N	139855	0	10509002	260139		0
35546	2105	80180	2013-01-25	2013-01-25 00:00:00	\N	\N	32020		\N	140257	0	396275006	80180		0
25214	1505	260139	1978-03-25	1978-03-25 00:00:00	1978-04-01	1978-04-01 00:00:00	32020		\N	100368	0	10509002	260139		0
25350	1511	4116491	2006-04-15	2006-04-15 00:00:00	2006-06-04	2006-06-04 00:00:00	32020		\N	100923	0	301011002	4116491		0
36067	2138	4112343	1968-10-25	1968-10-25 00:00:00	1968-11-02	1968-11-02 00:00:00	32020		\N	142419	0	195662009	4112343		0
36215	2147	28060	2016-06-10	2016-06-10 00:00:00	2016-06-18	2016-06-18 00:00:00	32020		\N	142991	0	43878008	28060		0
36391	2153	260139	1981-06-30	1981-06-30 00:00:00	1981-07-07	1981-07-07 00:00:00	32020		\N	143505	0	10509002	260139		0
36557	2164	40481087	1992-03-17	1992-03-17 00:00:00	1992-03-31	1992-03-31 00:00:00	32020		\N	144156	0	444814009	40481087		0
36711	2173	40481087	1957-01-09	1957-01-09 00:00:00	1957-01-23	1957-01-23 00:00:00	32020		\N	144864	0	444814009	40481087		0
36870	2180	40481087	1989-03-10	1989-03-10 00:00:00	1989-03-31	1989-03-31 00:00:00	32020		\N	145405	0	444814009	40481087		0
26505	1571	4142905	1971-02-03	1971-02-03 00:00:00	1971-03-05	1971-03-05 00:00:00	32020		\N	105506	0	33737001	4142905		0
37202	2204	4112343	1988-06-15	1988-06-15 00:00:00	1988-06-26	1988-06-26 00:00:00	32020		\N	146918	0	195662009	4112343		0
37399	2217	4112343	1983-08-11	1983-08-11 00:00:00	1983-08-22	1983-08-22 00:00:00	32020		\N	147667	0	195662009	4112343		0
27034	1599	81151	1964-12-14	1964-12-14 00:00:00	1965-01-18	1965-01-18 00:00:00	32020		\N	107359	0	44465007	81151		0
27182	1606	40481087	1991-06-03	1991-06-03 00:00:00	1991-06-10	1991-06-10 00:00:00	32020		\N	107858	0	444814009	40481087		0
37859	2243	40481087	1997-09-12	1997-09-12 00:00:00	1997-09-26	1997-09-26 00:00:00	32020		\N	149330	0	444814009	40481087		0
38095	2261	372328	1964-08-12	1964-08-12 00:00:00	1964-10-13	1964-10-13 00:00:00	32020		\N	150341	0	65363002	372328		0
38198	2267	40481087	2007-06-13	2007-06-13 00:00:00	2007-06-27	2007-06-27 00:00:00	32020		\N	150741	0	444814009	40481087		0
38445	2283	192671	1975-10-06	1975-10-06 00:00:00	\N	\N	32020		\N	151844	0	K92.2	35208414		0
38600	2291	4112343	1995-06-13	1995-06-13 00:00:00	1995-06-25	1995-06-25 00:00:00	32020		\N	152427	0	195662009	4112343		0
28218	1666	81151	1991-09-03	1991-09-03 00:00:00	1991-09-24	1991-09-24 00:00:00	32020		\N	111880	0	44465007	81151		0
38877	2309	4149245	2018-01-06	2018-01-06 00:00:00	2018-03-14	2018-03-14 00:00:00	32020		\N	153636	0	30832001	4149245		0
39057	2320	4029498	1941-08-02	1941-08-02 00:00:00	\N	\N	32020		\N	154315	0	128613002	4029498		0
28675	1699	4112343	1977-06-03	1977-06-03 00:00:00	1977-06-16	1977-06-16 00:00:00	32020		\N	113635	0	195662009	4112343		0
39373	2334	381316	2015-08-27	2015-08-27 00:00:00	\N	\N	32020		\N	155365	0	230690007	381316		0
29023	1718	40481087	1990-12-31	1990-12-31 00:00:00	1991-01-14	1991-01-14 00:00:00	32020		\N	114846	0	444814009	40481087		0
39690	2351	81151	2011-09-30	2011-09-30 00:00:00	2011-10-14	2011-10-14 00:00:00	32020		\N	156511	0	44465007	81151		0
29379	1739	372328	1972-04-20	1972-04-20 00:00:00	1973-03-22	1973-03-22 00:00:00	32020		\N	116173	0	65363002	372328		0
29521	1748	372328	1948-03-28	1948-03-28 00:00:00	1948-09-11	1948-09-11 00:00:00	32020		\N	116928	0	65363002	372328		0
29683	1756	40481087	1979-06-21	1979-06-21 00:00:00	1979-06-28	1979-06-28 00:00:00	32020		\N	117447	0	444814009	40481087		0
29829	1764	4283893	1974-06-01	1974-06-01 00:00:00	1974-07-13	1974-07-13 00:00:00	32020		\N	117945	0	36971009	4283893		0
40528	2409	4116491	2007-09-24	2007-09-24 00:00:00	2007-11-11	2007-11-11 00:00:00	32020		\N	159902	0	301011002	4116491		0
40706	2419	4112343	1974-09-04	1974-09-04 00:00:00	1974-09-17	1974-09-17 00:00:00	32020		\N	160489	0	195662009	4112343		0
40870	2431	4112343	1976-11-04	1976-11-04 00:00:00	1976-11-12	1976-11-12 00:00:00	32020		\N	161214	0	195662009	4112343		0
41117	2443	40481087	1965-01-17	1965-01-17 00:00:00	1965-02-07	1965-02-07 00:00:00	32020		\N	162037	0	444814009	40481087		0
41182	2447	4112343	2010-10-16	2010-10-16 00:00:00	2010-10-27	2010-10-27 00:00:00	32020		\N	162290	0	195662009	4112343		0
41366	2460	372328	1986-03-31	1986-03-31 00:00:00	1986-07-16	1986-07-16 00:00:00	32020		\N	163124	0	65363002	372328		0
41508	2468	40481087	1997-01-13	1997-01-13 00:00:00	1997-02-03	1997-02-03 00:00:00	32020		\N	163605	0	444814009	40481087		0
41670	2480	4134304	2009-06-05	2009-06-05 00:00:00	2009-09-03	2009-09-03 00:00:00	32020		\N	164319	0	263102004	4134304		0
41907	2495	4112343	1987-05-30	1987-05-30 00:00:00	1987-06-08	1987-06-08 00:00:00	32020		\N	165124	0	195662009	4112343		0
42049	2503	4112343	2009-06-01	2009-06-01 00:00:00	2009-06-10	2009-06-10 00:00:00	32020		\N	165653	0	195662009	4112343		0
42258	2518	40481087	1992-08-04	1992-08-04 00:00:00	1992-08-18	1992-08-18 00:00:00	32020		\N	166505	0	444814009	40481087		0
42401	2526	40481087	1986-11-19	1986-11-19 00:00:00	1986-12-10	1986-12-10 00:00:00	32020		\N	166991	0	444814009	40481087		0
31933	1898	40481087	1996-12-01	1996-12-01 00:00:00	1996-12-08	1996-12-08 00:00:00	32020		\N	126398	0	444814009	40481087		0
32111	1906	40481087	1973-12-24	1973-12-24 00:00:00	1974-01-15	1974-01-15 00:00:00	32020		\N	126870	0	444814009	40481087		0
32260	1916	260139	1987-07-24	1987-07-24 00:00:00	1987-07-31	1987-07-31 00:00:00	32020		\N	127476	0	10509002	260139		0
32426	1925	4294548	1989-01-20	1989-01-20 00:00:00	1989-02-17	1989-02-17 00:00:00	32020		\N	128143	0	75498004	4294548		0
22024	1318	255848	2018-12-21	2018-12-21 00:00:00	\N	\N	32020		\N	87342	0	233604007	255848		0
32771	1946	4109685	1935-02-07	1935-02-07 00:00:00	1935-02-28	1935-02-28 00:00:00	32020		\N	129275	0	284551006	4109685		0
22403	1338	40481087	1983-08-14	1983-08-14 00:00:00	1983-09-04	1983-09-04 00:00:00	32020		\N	88718	0	444814009	40481087		0
33049	1960	372328	1932-04-28	1932-04-28 00:00:00	1932-06-14	1932-06-14 00:00:00	32020		\N	130401	0	65363002	372328		0
22731	1357	260139	2015-04-22	2015-04-22 00:00:00	2015-05-06	2015-05-06 00:00:00	32020		\N	90017	0	10509002	260139		0
33387	1980	80180	2013-06-22	2013-06-22 00:00:00	\N	\N	32020		\N	131778	0	396275006	80180		0
23067	1377	372328	1982-11-18	1982-11-18 00:00:00	1983-05-10	1983-05-10 00:00:00	32020		\N	91271	0	65363002	372328		0
23201	1385	78272	1963-12-24	1963-12-24 00:00:00	1964-01-07	1964-01-07 00:00:00	32020		\N	91872	0	70704007	78272		0
33897	2012	260139	2014-02-23	2014-02-23 00:00:00	2014-03-02	2014-03-02 00:00:00	32020		\N	133846	0	10509002	260139		0
34073	2025	40481087	1998-07-29	1998-07-29 00:00:00	1998-08-12	1998-08-12 00:00:00	32020		\N	134753	0	444814009	40481087		0
34203	2030	40481087	1989-05-12	1989-05-12 00:00:00	1989-05-19	1989-05-19 00:00:00	32020		\N	135145	0	444814009	40481087		0
34432	2044	375671	1985-08-09	1985-08-09 00:00:00	1985-10-08	1985-10-08 00:00:00	32020		\N	136024	0	62564004	375671		0
24022	1433	40481087	1960-11-07	1960-11-07 00:00:00	1960-11-28	1960-11-28 00:00:00	32020		\N	95458	0	444814009	40481087		0
34770	2064	40481087	2010-12-11	2010-12-11 00:00:00	2011-01-01	2011-01-01 00:00:00	32020		\N	137282	0	444814009	40481087		0
34943	2075	372328	1966-07-28	1966-07-28 00:00:00	1966-11-08	1966-11-08 00:00:00	32020		\N	138033	0	65363002	372328		0
24545	1466	4112343	1996-07-06	1996-07-06 00:00:00	1996-07-16	1996-07-16 00:00:00	32020		\N	97611	0	195662009	4112343		0
24727	1476	40481087	2000-07-07	2000-07-07 00:00:00	2000-07-21	2000-07-21 00:00:00	32020		\N	98467	0	444814009	40481087		0
35424	2098	80180	2001-11-06	2001-11-06 00:00:00	\N	\N	32020		\N	139875	0	396275006	80180		0
35547	2105	4112343	2012-07-10	2012-07-10 00:00:00	2012-07-20	2012-07-20 00:00:00	32020		\N	140257	0	195662009	4112343		0
25215	1505	4113008	1995-03-04	1995-03-04 00:00:00	1995-03-25	1995-03-25 00:00:00	32020		\N	100383	0	284549007	4113008		0
25351	1511	40481087	1986-01-12	1986-01-12 00:00:00	1986-02-02	1986-02-02 00:00:00	32020		\N	100877	0	444814009	40481087		0
36068	2138	40481087	1961-06-27	1961-06-27 00:00:00	1961-07-11	1961-07-11 00:00:00	32020		\N	142384	0	444814009	40481087		0
36216	2147	260139	1988-01-23	1988-01-23 00:00:00	1988-02-06	1988-02-06 00:00:00	32020		\N	142943	0	10509002	260139		0
36392	2153	81151	1972-04-17	1972-04-17 00:00:00	1972-05-22	1972-05-22 00:00:00	32020		\N	143471	0	44465007	81151		0
36558	2164	40481087	1976-02-28	1976-02-28 00:00:00	1976-03-06	1976-03-06 00:00:00	32020		\N	144154	0	444814009	40481087		0
36712	2173	4294548	1994-02-05	1994-02-05 00:00:00	1994-02-19	1994-02-19 00:00:00	32020		\N	144869	0	75498004	4294548		0
36891	2184	4112343	2003-04-19	2003-04-19 00:00:00	2003-05-01	2003-05-01 00:00:00	32020		\N	145595	0	195662009	4112343		0
26506	1571	257012	1984-07-27	1984-07-27 00:00:00	\N	\N	32020		\N	105467	0	40055000	257012		0
37203	2204	28060	1967-06-22	1967-06-22 00:00:00	1967-07-02	1967-07-02 00:00:00	32020		\N	146904	0	43878008	28060		0
37400	2217	372328	1995-02-05	1995-02-05 00:00:00	1995-10-27	1995-10-27 00:00:00	32020		\N	147682	0	65363002	372328		0
27035	1599	4112343	2008-01-21	2008-01-21 00:00:00	2008-02-02	2008-02-02 00:00:00	32020		\N	107299	0	195662009	4112343		0
27183	1606	260139	2012-08-14	2012-08-14 00:00:00	2012-08-28	2012-08-28 00:00:00	32020		\N	107822	0	10509002	260139		0
37860	2243	260139	1977-08-22	1977-08-22 00:00:00	1977-09-05	1977-09-05 00:00:00	32020		\N	149327	0	10509002	260139		0
38096	2261	80180	2001-08-17	2001-08-17 00:00:00	\N	\N	32020		\N	150347	0	396275006	80180		0
38199	2267	260139	1979-07-05	1979-07-05 00:00:00	1979-07-12	1979-07-12 00:00:00	32020		\N	150721	0	10509002	260139		0
38446	2283	378001	1947-08-27	1947-08-27 00:00:00	1947-09-26	1947-09-26 00:00:00	32020		\N	151881	0	62106007	378001		0
38601	2291	40486433	1963-10-20	1963-10-20 00:00:00	\N	\N	32020		\N	152534	0	446096008	40486433		0
28219	1666	4156265	1953-01-20	1953-01-20 00:00:00	1953-02-03	1953-02-03 00:00:00	32020		\N	111877	0	370247008	4156265		0
38878	2309	80180	2016-10-10	2016-10-10 00:00:00	\N	\N	32020		\N	153658	0	396275006	80180		0
39059	2320	40481087	1993-01-19	1993-01-19 00:00:00	1993-01-26	1993-01-26 00:00:00	32020		\N	154244	0	444814009	40481087		0
28676	1699	81893	2001-10-21	2001-10-21 00:00:00	\N	\N	32020		\N	113611	0	64766004	81893		0
39374	2334	4112343	1977-09-03	1977-09-03 00:00:00	1977-09-14	1977-09-14 00:00:00	32020		\N	155306	0	195662009	4112343		0
29024	1718	80180	2010-07-28	2010-07-28 00:00:00	\N	\N	32020		\N	114821	0	396275006	80180		0
39691	2351	40481087	1965-10-17	1965-10-17 00:00:00	1965-11-07	1965-11-07 00:00:00	32020		\N	156585	0	444814009	40481087		0
29380	1739	40481087	2017-01-19	2017-01-19 00:00:00	2017-02-02	2017-02-02 00:00:00	32020		\N	116214	0	444814009	40481087		0
29522	1748	260139	2006-02-21	2006-02-21 00:00:00	2006-02-28	2006-02-28 00:00:00	32020		\N	116927	0	10509002	260139		0
29684	1756	40481087	1977-08-08	1977-08-08 00:00:00	1977-08-22	1977-08-22 00:00:00	32020		\N	117425	0	444814009	40481087		0
29830	1764	4296205	1993-05-28	1993-05-28 00:00:00	1993-06-18	1993-06-18 00:00:00	32020		\N	117990	0	403191005	4296205		0
40529	2409	4112343	1992-12-30	1992-12-30 00:00:00	1993-01-07	1993-01-07 00:00:00	32020		\N	159913	0	195662009	4112343		0
40707	2419	81151	1955-11-22	1955-11-22 00:00:00	1955-12-27	1955-12-27 00:00:00	32020		\N	160505	0	44465007	81151		0
40871	2431	40481087	2017-12-14	2017-12-14 00:00:00	2018-01-04	2018-01-04 00:00:00	32020		\N	161205	0	444814009	40481087		0
41118	2444	40481087	2018-09-28	2018-09-28 00:00:00	2018-10-19	2018-10-19 00:00:00	32020		\N	162133	0	444814009	40481087		0
41183	2447	4218389	2011-02-09	2011-02-09 00:00:00	2011-03-09	2011-03-09 00:00:00	32020		\N	162324	0	39848009	4218389		0
41367	2460	372328	1988-04-06	1988-04-06 00:00:00	1988-07-13	1988-07-13 00:00:00	32020		\N	163093	0	65363002	372328		0
41509	2468	40481087	1952-12-27	1952-12-27 00:00:00	1953-01-17	1953-01-17 00:00:00	32020		\N	163663	0	444814009	40481087		0
41671	2480	40481087	1956-09-03	1956-09-03 00:00:00	1956-09-10	1956-09-10 00:00:00	32020		\N	164316	0	444814009	40481087		0
41908	2495	260139	2013-12-20	2013-12-20 00:00:00	2013-12-27	2013-12-27 00:00:00	32020		\N	165133	0	10509002	260139		0
42050	2503	28060	1985-09-17	1985-09-17 00:00:00	1985-09-29	1985-09-29 00:00:00	32020		\N	165711	0	43878008	28060		0
42259	2518	40481087	1961-09-03	1961-09-03 00:00:00	1961-09-24	1961-09-24 00:00:00	32020		\N	166500	0	444814009	40481087		0
42402	2526	40481087	2001-09-25	2001-09-25 00:00:00	2001-10-02	2001-10-02 00:00:00	32020		\N	167027	0	444814009	40481087		0
31934	1898	260139	1986-10-24	1986-10-24 00:00:00	1986-10-31	1986-10-31 00:00:00	32020		\N	126341	0	10509002	260139		0
32117	1908	40481087	1994-05-02	1994-05-02 00:00:00	1994-05-09	1994-05-09 00:00:00	32020		\N	126957	0	444814009	40481087		0
32261	1917	260139	1955-11-30	1955-11-30 00:00:00	1955-12-07	1955-12-07 00:00:00	32020		\N	127527	0	10509002	260139		0
32427	1925	28060	1966-02-13	1966-02-13 00:00:00	1966-02-23	1966-02-23 00:00:00	32020		\N	128118	0	43878008	28060		0
22025	1318	372328	1943-04-04	1943-04-04 00:00:00	1944-02-22	1944-02-22 00:00:00	32020		\N	87354	0	65363002	372328		0
32772	1946	192671	1963-02-12	1963-02-12 00:00:00	\N	\N	32020		\N	129357	0	K92.2	35208414		0
22404	1338	40481087	2002-02-24	2002-02-24 00:00:00	2002-03-10	2002-03-10 00:00:00	32020		\N	88690	0	444814009	40481087		0
33050	1960	4112343	1935-03-15	1935-03-15 00:00:00	1935-03-28	1935-03-28 00:00:00	32020		\N	130317	0	195662009	4112343		0
22732	1357	80180	2014-11-07	2014-11-07 00:00:00	\N	\N	32020		\N	90016	0	396275006	80180		0
33404	1982	40481087	1963-12-05	1963-12-05 00:00:00	1963-12-12	1963-12-12 00:00:00	32020		\N	131952	0	444814009	40481087		0
23068	1378	28060	1967-03-15	1967-03-15 00:00:00	1967-03-23	1967-03-23 00:00:00	32020		\N	91294	0	43878008	28060		0
23202	1385	40481087	2013-06-20	2013-06-20 00:00:00	2013-07-11	2013-07-11 00:00:00	32020		\N	91842	0	444814009	40481087		0
33898	2012	40481087	1966-05-21	1966-05-21 00:00:00	1966-06-11	1966-06-11 00:00:00	32020		\N	133843	0	444814009	40481087		0
34074	2025	4112343	1950-09-04	1950-09-04 00:00:00	1950-09-15	1950-09-15 00:00:00	32020		\N	134772	0	195662009	4112343		0
34204	2030	4112343	1987-12-20	1987-12-20 00:00:00	1987-12-31	1987-12-31 00:00:00	32020		\N	135140	0	195662009	4112343		0
34433	2044	372328	1964-11-27	1964-11-27 00:00:00	1965-03-20	1965-03-20 00:00:00	32020		\N	135982	0	65363002	372328		0
24023	1433	260139	1977-04-11	1977-04-11 00:00:00	1977-04-18	1977-04-18 00:00:00	32020		\N	95461	0	10509002	260139		0
34771	2064	40481087	2019-06-25	2019-06-25 00:00:00	\N	\N	32020		\N	137270	0	444814009	40481087		0
34944	2075	40481087	2008-02-15	2008-02-15 00:00:00	2008-03-07	2008-03-07 00:00:00	32020		\N	138133	0	444814009	40481087		0
24546	1466	40481087	1994-07-18	1994-07-18 00:00:00	1994-08-01	1994-08-01 00:00:00	32020		\N	97603	0	444814009	40481087		0
24728	1476	313217	2003-11-27	2003-11-27 00:00:00	\N	\N	32020		\N	98473	0	49436004	313217		0
35425	2098	372328	1962-11-01	1962-11-01 00:00:00	1962-12-12	1962-12-12 00:00:00	32020		\N	139864	0	65363002	372328		0
35548	2105	4112343	1978-10-27	1978-10-27 00:00:00	1978-11-07	1978-11-07 00:00:00	32020		\N	140237	0	195662009	4112343		0
25216	1505	40481087	1993-03-05	1993-03-05 00:00:00	1993-03-12	1993-03-12 00:00:00	32020		\N	100352	0	444814009	40481087		0
25352	1511	4142905	2012-12-15	2012-12-15 00:00:00	2013-02-13	2013-02-13 00:00:00	32020		\N	100937	0	33737001	4142905		0
36069	2138	28060	2015-07-14	2015-07-14 00:00:00	2015-07-25	2015-07-25 00:00:00	32020		\N	142422	0	43878008	28060		0
36217	2147	4112343	1975-12-30	1975-12-30 00:00:00	1976-01-12	1976-01-12 00:00:00	32020		\N	142888	0	195662009	4112343		0
36393	2153	4112343	1981-05-14	1981-05-14 00:00:00	1981-05-26	1981-05-26 00:00:00	32020		\N	143473	0	195662009	4112343		0
36559	2164	4156265	2006-09-22	2006-09-22 00:00:00	2006-10-13	2006-10-13 00:00:00	32020		\N	144124	0	370247008	4156265		0
36713	2173	4294548	1953-07-12	1953-07-12 00:00:00	1953-09-20	1953-09-20 00:00:00	32020		\N	144722	0	75498004	4294548		0
36892	2184	192671	2003-02-26	2003-02-26 00:00:00	\N	\N	32020		\N	145620	0	K92.2	35208414		0
26507	1571	260139	1995-01-25	1995-01-25 00:00:00	1995-02-08	1995-02-08 00:00:00	32020		\N	105510	0	10509002	260139		0
37204	2204	40481087	1989-01-22	1989-01-22 00:00:00	1989-02-05	1989-02-05 00:00:00	32020		\N	146919	0	444814009	40481087		0
37401	2217	40481087	2009-11-23	2009-11-23 00:00:00	2009-12-07	2009-12-07 00:00:00	32020		\N	147669	0	444814009	40481087		0
27036	1599	4142905	1979-12-31	1979-12-31 00:00:00	1980-02-29	1980-02-29 00:00:00	32020		\N	107361	0	33737001	4142905		0
27184	1606	372328	1956-11-19	1956-11-19 00:00:00	1956-12-24	1956-12-24 00:00:00	32020		\N	107824	0	65363002	372328		0
37861	2243	40481087	2003-08-04	2003-08-04 00:00:00	2003-08-11	2003-08-11 00:00:00	32020		\N	149375	0	444814009	40481087		0
38097	2261	372328	1964-02-03	1964-02-03 00:00:00	1964-04-14	1964-04-14 00:00:00	32020		\N	150303	0	65363002	372328		0
38200	2267	372328	1969-08-24	1969-08-24 00:00:00	1969-11-17	1969-11-17 00:00:00	32020		\N	150712	0	65363002	372328		0
38447	2283	372328	1939-03-12	1939-03-12 00:00:00	1939-03-26	1939-03-26 00:00:00	32020		\N	151893	0	65363002	372328		0
38602	2291	372328	1964-01-26	1964-01-26 00:00:00	1964-03-19	1964-03-19 00:00:00	32020		\N	152418	0	65363002	372328		0
28220	1666	40481087	1994-05-17	1994-05-17 00:00:00	1994-05-31	1994-05-31 00:00:00	32020		\N	111914	0	444814009	40481087		0
38879	2309	40481087	1990-05-19	1990-05-19 00:00:00	1990-05-26	1990-05-26 00:00:00	32020		\N	153650	0	444814009	40481087		0
39060	2320	260139	1947-11-01	1947-11-01 00:00:00	1947-11-15	1947-11-15 00:00:00	32020		\N	154277	0	10509002	260139		0
28677	1699	30753	2002-08-17	2002-08-17 00:00:00	\N	\N	32020		\N	113611	0	16761005	30753		0
39375	2334	4112343	1999-07-23	1999-07-23 00:00:00	1999-07-30	1999-07-30 00:00:00	32020		\N	155308	0	195662009	4112343		0
29025	1718	372328	1986-12-20	1986-12-20 00:00:00	1989-04-22	1989-04-22 00:00:00	32020		\N	114868	0	65363002	372328		0
39692	2351	40481087	2011-10-12	2011-10-12 00:00:00	2011-10-19	2011-10-19 00:00:00	32020		\N	156561	0	444814009	40481087		0
29381	1739	78272	2016-08-23	2016-08-23 00:00:00	2016-09-27	2016-09-27 00:00:00	32020		\N	116193	0	70704007	78272		0
29523	1748	4112343	2017-10-26	2017-10-26 00:00:00	2017-11-03	2017-11-03 00:00:00	32020		\N	116861	0	195662009	4112343		0
29685	1756	192671	2013-07-14	2013-07-14 00:00:00	\N	\N	32020		\N	117439	0	K92.2	35208414		0
29831	1764	260139	1968-11-16	1968-11-16 00:00:00	1968-11-30	1968-11-30 00:00:00	32020		\N	117936	0	10509002	260139		0
40530	2409	4112343	1982-02-16	1982-02-16 00:00:00	1982-02-24	1982-02-24 00:00:00	32020		\N	159945	0	195662009	4112343		0
40708	2419	4112343	2013-11-05	2013-11-05 00:00:00	2013-11-17	2013-11-17 00:00:00	32020		\N	160611	0	195662009	4112343		0
40872	2431	4112343	1972-07-19	1972-07-19 00:00:00	1972-07-27	1972-07-27 00:00:00	32020		\N	161201	0	195662009	4112343		0
41119	2444	80180	1998-11-14	1998-11-14 00:00:00	\N	\N	32020		\N	162105	0	396275006	80180		0
41184	2447	40481087	1985-12-27	1985-12-27 00:00:00	1986-01-17	1986-01-17 00:00:00	32020		\N	162304	0	444814009	40481087		0
41368	2460	4112343	2006-08-17	2006-08-17 00:00:00	2006-08-29	2006-08-29 00:00:00	32020		\N	163092	0	195662009	4112343		0
41510	2468	4035415	1946-05-12	1946-05-12 00:00:00	1946-06-11	1946-06-11 00:00:00	32020		\N	163673	0	239720000	4035415		0
41672	2480	372328	1957-11-06	1957-11-06 00:00:00	1958-04-09	1958-04-09 00:00:00	32020		\N	164305	0	65363002	372328		0
41909	2495	40481087	2002-02-18	2002-02-18 00:00:00	2002-03-04	2002-03-04 00:00:00	32020		\N	165153	0	444814009	40481087		0
42051	2504	40481087	2014-03-24	2014-03-24 00:00:00	2014-03-31	2014-03-31 00:00:00	32020		\N	165775	0	444814009	40481087		0
42260	2518	4112343	2013-01-17	2013-01-17 00:00:00	2013-01-26	2013-01-26 00:00:00	32020		\N	166533	0	195662009	4112343		0
42403	2526	80180	2012-12-28	2012-12-28 00:00:00	\N	\N	32020		\N	167023	0	396275006	80180		0
31935	1898	30753	2010-09-18	2010-09-18 00:00:00	\N	\N	32020		\N	126378	0	16761005	30753		0
32118	1908	4142905	2018-03-11	2018-03-11 00:00:00	2018-05-10	2018-05-10 00:00:00	32020		\N	126954	0	33737001	4142905		0
32262	1917	4218389	1983-01-06	1983-01-06 00:00:00	1983-02-10	1983-02-10 00:00:00	32020		\N	127554	0	39848009	4218389		0
32428	1925	4152936	2002-12-17	2002-12-17 00:00:00	2002-12-31	2002-12-31 00:00:00	32020		\N	128086	0	283385000	4152936		0
22026	1318	40481087	1987-11-27	1987-11-27 00:00:00	1987-12-18	1987-12-18 00:00:00	32020		\N	87344	0	444814009	40481087		0
32773	1946	260139	2017-10-20	2017-10-20 00:00:00	2017-10-27	2017-10-27 00:00:00	32020		\N	129264	0	10509002	260139		0
22405	1338	28060	1959-02-03	1959-02-03 00:00:00	1959-02-15	1959-02-15 00:00:00	32020		\N	88717	0	43878008	28060		0
33051	1960	80180	1971-05-14	1971-05-14 00:00:00	\N	\N	32020		\N	130352	0	396275006	80180		0
22733	1357	4112343	2012-07-20	2012-07-20 00:00:00	2012-07-30	2012-07-30 00:00:00	32020		\N	90016	0	195662009	4112343		0
33405	1982	40481087	1925-01-01	1925-01-01 00:00:00	1925-01-22	1925-01-22 00:00:00	32020		\N	131997	0	444814009	40481087		0
23069	1378	261325	1999-07-20	1999-07-20 00:00:00	\N	\N	32020		\N	91349	0	87433001	261325		0
23203	1385	4112343	2000-10-09	2000-10-09 00:00:00	2000-10-18	2000-10-18 00:00:00	32020		\N	91838	0	195662009	4112343		0
33899	2012	4149245	1978-02-25	1978-02-25 00:00:00	1978-05-03	1978-05-03 00:00:00	32020		\N	133865	0	30832001	4149245		0
34075	2025	260139	2013-10-03	2013-10-03 00:00:00	2013-10-17	2013-10-17 00:00:00	32020		\N	134726	0	10509002	260139		0
34205	2030	260139	1995-07-13	1995-07-13 00:00:00	1995-07-27	1995-07-27 00:00:00	32020		\N	135120	0	10509002	260139		0
34434	2044	40481087	2010-02-28	2010-02-28 00:00:00	2010-03-14	2010-03-14 00:00:00	32020		\N	135959	0	444814009	40481087		0
24024	1433	260139	1980-07-12	1980-07-12 00:00:00	1980-07-26	1980-07-26 00:00:00	32020		\N	95468	0	10509002	260139		0
34772	2064	4278672	1982-04-06	1982-04-06 00:00:00	1982-07-05	1982-07-05 00:00:00	32020		\N	137304	0	65966004	4278672		0
34945	2075	4237458	2019-04-15	2019-04-15 00:00:00	\N	\N	32020		\N	138004	0	58150001	4237458		0
24547	1466	4152936	1972-02-13	1972-02-13 00:00:00	1972-02-27	1972-02-27 00:00:00	32020		\N	97663	0	283385000	4152936		0
24729	1476	4094814	1956-11-01	1956-11-01 00:00:00	1956-12-31	1956-12-31 00:00:00	32020		\N	98492	0	262574004	4094814		0
35426	2098	4112343	1999-11-16	1999-11-16 00:00:00	1999-11-28	1999-11-28 00:00:00	32020		\N	139897	0	195662009	4112343		0
35549	2105	40481087	1988-12-15	1988-12-15 00:00:00	1988-12-22	1988-12-22 00:00:00	32020		\N	140217	0	444814009	40481087		0
25217	1505	40481087	1986-03-26	1986-03-26 00:00:00	1986-04-02	1986-04-02 00:00:00	32020		\N	100350	0	444814009	40481087		0
25353	1511	260139	2007-01-28	2007-01-28 00:00:00	2007-02-04	2007-02-04 00:00:00	32020		\N	100879	0	10509002	260139		0
36070	2138	372328	1957-02-26	1957-02-26 00:00:00	1957-03-12	1957-03-12 00:00:00	32020		\N	142424	0	65363002	372328		0
36218	2147	40481087	1978-04-12	1978-04-12 00:00:00	1978-05-04	1978-05-04 00:00:00	32020		\N	143004	0	444814009	40481087		0
36394	2153	40481087	1984-03-18	1984-03-18 00:00:00	1984-03-25	1984-03-25 00:00:00	32020		\N	143476	0	444814009	40481087		0
36560	2164	40481087	1984-02-02	1984-02-02 00:00:00	1984-02-23	1984-02-23 00:00:00	32020		\N	144159	0	444814009	40481087		0
36714	2173	28060	1938-07-21	1938-07-21 00:00:00	1938-08-01	1938-08-01 00:00:00	32020		\N	144725	0	43878008	28060		0
36893	2184	372328	1967-08-14	1967-08-14 00:00:00	1967-10-25	1967-10-25 00:00:00	32020		\N	145584	0	65363002	372328		0
26508	1571	4294548	1984-06-22	1984-06-22 00:00:00	1984-08-03	1984-08-03 00:00:00	32020		\N	105406	0	75498004	4294548		0
37205	2204	4112343	1984-10-28	1984-10-28 00:00:00	1984-11-03	1984-11-03 00:00:00	32020		\N	146935	0	195662009	4112343		0
37402	2217	4059173	1995-12-02	1995-12-02 00:00:00	1996-03-01	1996-03-01 00:00:00	32020		\N	147668	0	16114001	4059173		0
27037	1599	372328	1964-12-26	1964-12-26 00:00:00	1965-04-12	1965-04-12 00:00:00	32020		\N	107352	0	65363002	372328		0
27185	1606	40481087	1987-08-03	1987-08-03 00:00:00	1987-08-17	1987-08-17 00:00:00	32020		\N	107848	0	444814009	40481087		0
37862	2243	378001	2000-06-19	2000-06-19 00:00:00	2000-08-18	2000-08-18 00:00:00	32020		\N	149363	0	62106007	378001		0
38098	2261	40481087	1986-06-16	1986-06-16 00:00:00	1986-06-30	1986-06-30 00:00:00	32020		\N	150301	0	444814009	40481087		0
38201	2267	4112343	2016-12-26	2016-12-26 00:00:00	2017-01-04	2017-01-04 00:00:00	32020		\N	150686	0	195662009	4112343		0
38448	2283	317576	2018-11-19	2018-11-19 00:00:00	\N	\N	32020		\N	151872	0	53741008	317576		0
38603	2291	81151	1998-09-15	1998-09-15 00:00:00	1998-10-13	1998-10-13 00:00:00	32020		\N	152487	0	44465007	81151		0
38679	2295	40481087	1984-02-16	1984-02-16 00:00:00	1984-03-01	1984-03-01 00:00:00	32020		\N	152773	0	444814009	40481087		0
38880	2309	4278672	2013-11-28	2013-11-28 00:00:00	2013-12-28	2013-12-28 00:00:00	32020		\N	153635	0	65966004	4278672		0
39061	2320	260139	2015-06-19	2015-06-19 00:00:00	2015-07-03	2015-07-03 00:00:00	32020		\N	154288	0	10509002	260139		0
28678	1699	80180	2003-11-10	2003-11-10 00:00:00	\N	\N	32020		\N	113611	0	396275006	80180		0
39376	2334	40481087	1951-10-28	1951-10-28 00:00:00	1951-11-11	1951-11-11 00:00:00	32020		\N	155314	0	444814009	40481087		0
29026	1718	40481087	1987-07-21	1987-07-21 00:00:00	1987-08-11	1987-08-11 00:00:00	32020		\N	114844	0	444814009	40481087		0
39693	2351	80180	1990-11-24	1990-11-24 00:00:00	\N	\N	32020		\N	156496	0	396275006	80180		0
29382	1739	4112343	2018-01-28	2018-01-28 00:00:00	2018-02-07	2018-02-07 00:00:00	32020		\N	116217	0	195662009	4112343		0
29524	1748	260139	1987-09-01	1987-09-01 00:00:00	1987-09-15	1987-09-15 00:00:00	32020		\N	116912	0	10509002	260139		0
29692	1758	80180	2002-09-28	2002-09-28 00:00:00	\N	\N	32020		\N	117528	0	396275006	80180		0
29832	1764	81151	1970-07-07	1970-07-07 00:00:00	1970-07-28	1970-07-28 00:00:00	32020		\N	117989	0	44465007	81151		0
40531	2409	260139	2013-06-27	2013-06-27 00:00:00	2013-07-04	2013-07-04 00:00:00	32020		\N	159897	0	10509002	260139		0
40709	2419	80180	1979-10-02	1979-10-02 00:00:00	\N	\N	32020		\N	160499	0	396275006	80180		0
40873	2431	40481087	2001-10-04	2001-10-04 00:00:00	2001-10-25	2001-10-25 00:00:00	32020		\N	161216	0	444814009	40481087		0
41120	2444	40481087	1988-08-27	1988-08-27 00:00:00	1988-09-03	1988-09-03 00:00:00	32020		\N	162166	0	444814009	40481087		0
41185	2448	257012	1990-08-23	1990-08-23 00:00:00	\N	\N	32020		\N	162356	0	40055000	257012		0
41369	2460	80180	2018-02-16	2018-02-16 00:00:00	\N	\N	32020		\N	163115	0	396275006	80180		0
41511	2468	40481087	1991-02-14	1991-02-14 00:00:00	1991-03-07	1991-03-07 00:00:00	32020		\N	163634	0	444814009	40481087		0
41673	2480	4112343	1970-03-01	1970-03-01 00:00:00	1970-03-14	1970-03-14 00:00:00	32020		\N	164341	0	195662009	4112343		0
41910	2495	40481087	1997-03-23	1997-03-23 00:00:00	1997-04-06	1997-04-06 00:00:00	32020		\N	165136	0	444814009	40481087		0
42052	2504	4112343	1997-06-27	1997-06-27 00:00:00	1997-07-07	1997-07-07 00:00:00	32020		\N	165802	0	195662009	4112343		0
42261	2518	4116491	1973-08-16	1973-08-16 00:00:00	1973-10-08	1973-10-08 00:00:00	32020		\N	166529	0	301011002	4116491		0
42404	2526	40481087	1988-06-24	1988-06-24 00:00:00	1988-07-08	1988-07-08 00:00:00	32020		\N	167025	0	444814009	40481087		0
31936	1898	260139	2007-09-12	2007-09-12 00:00:00	2007-09-19	2007-09-19 00:00:00	32020		\N	126344	0	10509002	260139		0
32119	1908	40481087	1987-04-18	1987-04-18 00:00:00	1987-05-02	1987-05-02 00:00:00	32020		\N	126970	0	444814009	40481087		0
32263	1917	4112343	1986-07-30	1986-07-30 00:00:00	1986-08-06	1986-08-06 00:00:00	32020		\N	127541	0	195662009	4112343		0
32429	1925	260139	1962-01-23	1962-01-23 00:00:00	1962-02-06	1962-02-06 00:00:00	32020		\N	128122	0	10509002	260139		0
22027	1318	40481087	1973-07-10	1973-07-10 00:00:00	1973-07-17	1973-07-17 00:00:00	32020		\N	87370	0	444814009	40481087		0
32774	1946	40481087	1992-01-09	1992-01-09 00:00:00	1992-01-30	1992-01-30 00:00:00	32020		\N	129323	0	444814009	40481087		0
22406	1338	372328	1947-04-19	1947-04-19 00:00:00	1947-09-11	1947-09-11 00:00:00	32020		\N	88745	0	65363002	372328		0
33052	1960	4266809	1971-05-14	1971-05-14 00:00:00	\N	\N	32020		\N	130352	0	397881000	4266809		0
22734	1357	260139	1976-10-18	1976-10-18 00:00:00	1976-10-25	1976-10-25 00:00:00	32020		\N	89995	0	10509002	260139		0
33406	1982	40481087	1987-09-29	1987-09-29 00:00:00	1987-10-20	1987-10-20 00:00:00	32020		\N	132035	0	444814009	40481087		0
32448	1926	4027663	1998-04-04	1998-04-04 00:00:00	\N	\N	32020		\N	128235	0	13200003	4027663		0
23070	1378	4218389	1945-05-16	1945-05-16 00:00:00	1945-06-06	1945-06-06 00:00:00	32020		\N	91316	0	39848009	4218389		0
23204	1385	80180	1999-12-20	1999-12-20 00:00:00	\N	\N	32020		\N	91837	0	396275006	80180		0
33900	2013	4112343	2004-10-02	2004-10-02 00:00:00	2004-10-12	2004-10-12 00:00:00	32020		\N	133942	0	195662009	4112343		0
34076	2025	4218389	1984-07-06	1984-07-06 00:00:00	1984-08-03	1984-08-03 00:00:00	32020		\N	134743	0	39848009	4218389		0
34206	2030	40481087	2002-12-16	2002-12-16 00:00:00	2002-12-23	2002-12-23 00:00:00	32020		\N	135160	0	444814009	40481087		0
34435	2044	40481087	2014-09-28	2014-09-28 00:00:00	2014-10-12	2014-10-12 00:00:00	32020		\N	136029	0	444814009	40481087		0
24025	1433	260139	1978-11-11	1978-11-11 00:00:00	1978-11-18	1978-11-18 00:00:00	32020		\N	95427	0	10509002	260139		0
34812	2069	81151	2011-04-30	2011-04-30 00:00:00	2011-06-04	2011-06-04 00:00:00	32020		\N	137586	0	44465007	81151		0
34946	2075	4112343	2018-11-15	2018-11-15 00:00:00	2018-11-22	2018-11-22 00:00:00	32020		\N	138134	0	195662009	4112343		0
24548	1466	4027663	1994-02-27	1994-02-27 00:00:00	\N	\N	32020		\N	97643	0	13200003	4027663		0
24730	1476	4112343	1992-08-02	1992-08-02 00:00:00	1992-08-13	1992-08-13 00:00:00	32020		\N	98379	0	195662009	4112343		0
35427	2098	40481087	2007-03-17	2007-03-17 00:00:00	2007-03-24	2007-03-24 00:00:00	32020		\N	139905	0	444814009	40481087		0
35550	2105	4237458	1981-02-12	1981-02-12 00:00:00	1981-04-13	1981-04-13 00:00:00	32020		\N	140212	0	58150001	4237458		0
25218	1505	40481087	1971-07-30	1971-07-30 00:00:00	1971-08-20	1971-08-20 00:00:00	32020		\N	100313	0	444814009	40481087		0
25354	1511	4230399	1974-11-04	1974-11-04 00:00:00	1974-12-04	1974-12-04 00:00:00	32020		\N	100931	0	359817006	4230399		0
36071	2138	40481087	2018-05-20	2018-05-20 00:00:00	2018-05-27	2018-05-27 00:00:00	32020		\N	142423	0	444814009	40481087		0
36219	2147	4156265	2013-08-27	2013-08-27 00:00:00	2013-09-10	2013-09-10 00:00:00	32020		\N	142967	0	370247008	4156265		0
36395	2153	80180	2006-03-30	2006-03-30 00:00:00	\N	\N	32020		\N	143467	0	396275006	80180		0
36561	2164	40481087	1973-07-01	1973-07-01 00:00:00	1973-07-08	1973-07-08 00:00:00	32020		\N	144179	0	444814009	40481087		0
36715	2173	4218389	1987-07-30	1987-07-30 00:00:00	1987-08-27	1987-08-27 00:00:00	32020		\N	144891	0	39848009	4218389		0
36894	2184	40481087	1975-02-08	1975-02-08 00:00:00	1975-03-01	1975-03-01 00:00:00	32020		\N	145532	0	444814009	40481087		0
26509	1571	40481087	1959-07-13	1959-07-13 00:00:00	1959-08-03	1959-08-03 00:00:00	32020		\N	105427	0	444814009	40481087		0
37206	2204	4155034	1959-07-30	1959-07-30 00:00:00	1959-08-13	1959-08-13 00:00:00	32020		\N	146927	0	283371005	4155034		0
37403	2217	4112343	2015-05-20	2015-05-20 00:00:00	2015-06-01	2015-06-01 00:00:00	32020		\N	147631	0	195662009	4112343		0
27038	1599	372328	1962-06-28	1962-06-28 00:00:00	1962-10-08	1962-10-08 00:00:00	32020		\N	107300	0	65363002	372328		0
27186	1606	4310024	1987-08-21	1987-08-21 00:00:00	\N	\N	32020		\N	107848	0	424802006	4310024		0
37863	2243	260139	1982-07-23	1982-07-23 00:00:00	1982-08-06	1982-08-06 00:00:00	32020		\N	149335	0	10509002	260139		0
38099	2261	81151	1975-08-18	1975-08-18 00:00:00	1975-09-22	1975-09-22 00:00:00	32020		\N	150309	0	44465007	81151		0
38202	2267	4296204	1990-09-08	1990-09-08 00:00:00	1990-10-13	1990-10-13 00:00:00	32020		\N	150706	0	403190006	4296204		0
38469	2286	4109685	2004-02-24	2004-02-24 00:00:00	2004-03-09	2004-03-09 00:00:00	32020		\N	152093	0	284551006	4109685		0
38604	2291	40481087	1967-05-31	1967-05-31 00:00:00	1967-06-14	1967-06-14 00:00:00	32020		\N	152449	0	444814009	40481087		0
38680	2295	40481087	2007-08-30	2007-08-30 00:00:00	2007-09-06	2007-09-06 00:00:00	32020		\N	152779	0	444814009	40481087		0
38881	2309	40481087	1998-10-20	1998-10-20 00:00:00	1998-11-03	1998-11-03 00:00:00	32020		\N	153616	0	444814009	40481087		0
39062	2320	4027663	1973-07-25	1973-07-25 00:00:00	\N	\N	32020		\N	154280	0	13200003	4027663		0
28679	1699	40481087	1991-08-24	1991-08-24 00:00:00	1991-09-14	1991-09-14 00:00:00	32020		\N	113670	0	444814009	40481087		0
39377	2334	40481087	1992-06-22	1992-06-22 00:00:00	1992-07-06	1992-07-06 00:00:00	32020		\N	155307	0	444814009	40481087		0
29027	1718	40481087	2019-01-27	2019-01-27 00:00:00	2019-02-03	2019-02-03 00:00:00	32020		\N	114877	0	444814009	40481087		0
39694	2351	4112343	1962-02-15	1962-02-15 00:00:00	1962-02-25	1962-02-25 00:00:00	32020		\N	156584	0	195662009	4112343		0
39841	2358	375671	2009-12-06	2009-12-06 00:00:00	2010-01-05	2010-01-05 00:00:00	32020		\N	157131	0	62564004	375671		0
29525	1748	40481087	2014-10-11	2014-10-11 00:00:00	2014-11-01	2014-11-01 00:00:00	32020		\N	116845	0	444814009	40481087		0
29693	1758	372328	1962-11-07	1962-11-07 00:00:00	1963-01-25	1963-01-25 00:00:00	32020		\N	117559	0	65363002	372328		0
29833	1764	372328	1960-01-09	1960-01-09 00:00:00	1960-02-11	1960-02-11 00:00:00	32020		\N	118007	0	65363002	372328		0
40532	2409	4048695	2019-04-13	2019-04-13 00:00:00	2019-06-14	2019-06-14 00:00:00	32020		\N	159911	0	15724005	4048695		0
40710	2419	40481087	2013-10-15	2013-10-15 00:00:00	2013-10-29	2013-10-29 00:00:00	32020		\N	160582	0	444814009	40481087		0
40874	2431	40481087	1987-10-17	1987-10-17 00:00:00	1987-10-24	1987-10-24 00:00:00	32020		\N	161235	0	444814009	40481087		0
41121	2444	4112343	1980-03-27	1980-03-27 00:00:00	1980-04-06	1980-04-06 00:00:00	32020		\N	162165	0	195662009	4112343		0
41186	2448	192671	2000-08-10	2000-08-10 00:00:00	\N	\N	32020		\N	162403	0	K92.2	35208414		0
41370	2460	40481087	2017-12-18	2017-12-18 00:00:00	2018-01-08	2018-01-08 00:00:00	32020		\N	163115	0	444814009	40481087		0
41512	2468	260139	2003-01-10	2003-01-10 00:00:00	2003-01-17	2003-01-17 00:00:00	32020		\N	163607	0	10509002	260139		0
41674	2480	4283893	1996-06-10	1996-06-10 00:00:00	1996-07-22	1996-07-22 00:00:00	32020		\N	164333	0	36971009	4283893		0
41911	2495	81151	1992-09-27	1992-09-27 00:00:00	1992-10-11	1992-10-11 00:00:00	32020		\N	165162	0	44465007	81151		0
42053	2504	40481087	2002-02-22	2002-02-22 00:00:00	2002-03-08	2002-03-08 00:00:00	32020		\N	165815	0	444814009	40481087		0
42262	2518	4278672	1961-01-11	1961-01-11 00:00:00	1961-02-10	1961-02-10 00:00:00	32020		\N	166538	0	65966004	4278672		0
42405	2526	4113008	2012-04-19	2012-04-19 00:00:00	2012-05-03	2012-05-03 00:00:00	32020		\N	167007	0	284549007	4113008		0
31937	1898	28060	1991-04-03	1991-04-03 00:00:00	1991-04-16	1991-04-16 00:00:00	32020		\N	126342	0	43878008	28060		0
32120	1908	81151	1987-04-09	1987-04-09 00:00:00	1987-04-23	1987-04-23 00:00:00	32020		\N	126952	0	44465007	81151		0
32264	1917	4266809	1987-03-11	1987-03-11 00:00:00	\N	\N	32020		\N	127541	0	397881000	4266809		0
32430	1925	4112343	1966-01-01	1966-01-01 00:00:00	1966-01-12	1966-01-12 00:00:00	32020		\N	128124	0	195662009	4112343		0
22028	1318	260139	1998-06-06	1998-06-06 00:00:00	1998-06-13	1998-06-13 00:00:00	32020		\N	87346	0	10509002	260139		0
32775	1946	260139	1942-10-30	1942-10-30 00:00:00	1942-11-13	1942-11-13 00:00:00	32020		\N	129315	0	10509002	260139		0
22407	1338	4112343	1987-01-03	1987-01-03 00:00:00	1987-01-11	1987-01-11 00:00:00	32020		\N	88685	0	195662009	4112343		0
33061	1962	4112343	2014-07-11	2014-07-11 00:00:00	2014-07-24	2014-07-24 00:00:00	32020		\N	130512	0	195662009	4112343		0
22735	1357	40481087	1999-06-23	1999-06-23 00:00:00	1999-06-30	1999-06-30 00:00:00	32020		\N	90001	0	444814009	40481087		0
33407	1982	260139	1960-02-14	1960-02-14 00:00:00	1960-02-21	1960-02-21 00:00:00	32020		\N	131988	0	10509002	260139		0
23071	1378	260139	1950-12-18	1950-12-18 00:00:00	1951-01-01	1951-01-01 00:00:00	32020		\N	91362	0	10509002	260139		0
23205	1385	439777	2007-05-02	2007-05-02 00:00:00	\N	\N	32020		\N	91820	0	271737000	439777		0
33901	2013	372328	1956-10-13	1956-10-13 00:00:00	1956-11-24	1956-11-24 00:00:00	32020		\N	133951	0	65363002	372328		0
34077	2025	40481087	1920-07-14	1920-07-14 00:00:00	1920-07-21	1920-07-21 00:00:00	32020		\N	134746	0	444814009	40481087		0
34207	2030	4218389	1970-12-06	1970-12-06 00:00:00	1971-01-10	1971-01-10 00:00:00	32020		\N	135104	0	39848009	4218389		0
34436	2044	260139	2016-10-14	2016-10-14 00:00:00	2016-10-28	2016-10-28 00:00:00	32020		\N	135971	0	10509002	260139		0
24026	1433	40481087	1994-01-25	1994-01-25 00:00:00	1994-02-15	1994-02-15 00:00:00	32020		\N	95428	0	444814009	40481087		0
34813	2069	40481087	1955-03-24	1955-03-24 00:00:00	1955-04-07	1955-04-07 00:00:00	32020		\N	137612	0	444814009	40481087		0
34947	2076	260139	1972-07-02	1972-07-02 00:00:00	1972-07-09	1972-07-09 00:00:00	32020		\N	138143	0	10509002	260139		0
24549	1466	4218389	2004-12-19	2004-12-19 00:00:00	2005-01-09	2005-01-09 00:00:00	32020		\N	97665	0	39848009	4218389		0
24731	1476	381316	2011-05-26	2011-05-26 00:00:00	\N	\N	32020		\N	98421	0	230690007	381316		0
35428	2098	4112343	2009-02-03	2009-02-03 00:00:00	2009-02-11	2009-02-11 00:00:00	32020		\N	139902	0	195662009	4112343		0
35551	2105	378001	1988-09-03	1988-09-03 00:00:00	1988-10-03	1988-10-03 00:00:00	32020		\N	140213	0	62106007	378001		0
25219	1505	260139	1983-12-02	1983-12-02 00:00:00	1983-12-09	1983-12-09 00:00:00	32020		\N	100349	0	10509002	260139		0
25355	1511	40481087	1991-06-13	1991-06-13 00:00:00	1991-06-20	1991-06-20 00:00:00	32020		\N	100913	0	444814009	40481087		0
36072	2138	40481087	1987-11-01	1987-11-01 00:00:00	1987-11-22	1987-11-22 00:00:00	32020		\N	142386	0	444814009	40481087		0
36220	2147	81151	1955-06-14	1955-06-14 00:00:00	1955-07-19	1955-07-19 00:00:00	32020		\N	142897	0	44465007	81151		0
36396	2153	260139	1996-08-18	1996-08-18 00:00:00	1996-08-25	1996-08-25 00:00:00	32020		\N	143507	0	10509002	260139		0
36562	2164	4112343	1973-01-31	1973-01-31 00:00:00	1973-02-09	1973-02-09 00:00:00	32020		\N	144178	0	195662009	4112343		0
36716	2173	40481087	1996-12-12	1996-12-12 00:00:00	1997-01-02	1997-01-02 00:00:00	32020		\N	144870	0	444814009	40481087		0
36895	2184	81151	1973-01-14	1973-01-14 00:00:00	1973-02-11	1973-02-11 00:00:00	32020		\N	145587	0	44465007	81151		0
26510	1571	4084167	1958-04-12	1958-04-12 00:00:00	1958-04-12	1958-04-12 00:00:00	32020		\N	105389	0	241929008	4084167		0
37207	2204	372328	1948-10-26	1948-10-26 00:00:00	1949-02-16	1949-02-16 00:00:00	32020		\N	146941	0	65363002	372328		0
37404	2217	40481087	2010-11-07	2010-11-07 00:00:00	2010-11-14	2010-11-14 00:00:00	32020		\N	147630	0	444814009	40481087		0
27039	1599	28060	1962-11-26	1962-11-26 00:00:00	1962-12-03	1962-12-03 00:00:00	32020		\N	107285	0	43878008	28060		0
27187	1606	40481087	2006-10-19	2006-10-19 00:00:00	2006-11-02	2006-11-02 00:00:00	32020		\N	107861	0	444814009	40481087		0
37864	2243	260139	1978-12-08	1978-12-08 00:00:00	1978-12-22	1978-12-22 00:00:00	32020		\N	149328	0	10509002	260139		0
38100	2261	40481087	1988-01-29	1988-01-29 00:00:00	1988-02-12	1988-02-12 00:00:00	32020		\N	150337	0	444814009	40481087		0
38203	2267	40481087	2007-10-31	2007-10-31 00:00:00	2007-11-14	2007-11-14 00:00:00	32020		\N	150711	0	444814009	40481087		0
38470	2286	440448	1971-08-31	1971-08-31 00:00:00	\N	\N	32020		\N	152091	0	74400008	440448		0
38605	2291	4051466	1964-10-19	1964-10-19 00:00:00	1980-10-09	1980-10-09 00:00:00	32020		\N	152406	0	233678006	4051466		0
38681	2295	40481087	2006-04-25	2006-04-25 00:00:00	2006-05-02	2006-05-02 00:00:00	32020		\N	152778	0	444814009	40481087		0
38882	2309	40481087	2000-10-31	2000-10-31 00:00:00	2000-11-14	2000-11-14 00:00:00	32020		\N	153617	0	444814009	40481087		0
39063	2320	40481087	1972-07-11	1972-07-11 00:00:00	1972-08-01	1972-08-01 00:00:00	32020		\N	154280	0	444814009	40481087		0
28680	1699	40481087	1980-09-22	1980-09-22 00:00:00	1980-10-13	1980-10-13 00:00:00	32020		\N	113646	0	444814009	40481087		0
39378	2334	40481087	1942-12-29	1942-12-29 00:00:00	1943-01-05	1943-01-05 00:00:00	32020		\N	155324	0	444814009	40481087		0
29028	1718	4152936	2006-02-19	2006-02-19 00:00:00	2006-03-12	2006-03-12 00:00:00	32020		\N	114854	0	283385000	4152936		0
39695	2351	4059173	1958-02-23	1958-02-23 00:00:00	1958-05-24	1958-05-24 00:00:00	32020		\N	156557	0	16114001	4059173		0
39842	2358	40481087	2004-11-17	2004-11-17 00:00:00	2004-11-24	2004-11-24 00:00:00	32020		\N	157151	0	444814009	40481087		0
29526	1748	260139	1949-04-23	1949-04-23 00:00:00	1949-04-30	1949-04-30 00:00:00	32020		\N	116837	0	10509002	260139		0
29694	1758	192671	2002-11-07	2002-11-07 00:00:00	\N	\N	32020		\N	117573	0	K92.2	35208414		0
29834	1764	40481087	1961-06-30	1961-06-30 00:00:00	1961-07-07	1961-07-07 00:00:00	32020		\N	117935	0	444814009	40481087		0
40533	2409	260139	2008-06-14	2008-06-14 00:00:00	2008-06-21	2008-06-21 00:00:00	32020		\N	159903	0	10509002	260139		0
40711	2419	40481087	1990-03-22	1990-03-22 00:00:00	1990-04-12	1990-04-12 00:00:00	32020		\N	160492	0	444814009	40481087		0
40875	2431	4156265	1995-05-16	1995-05-16 00:00:00	1995-05-30	1995-05-30 00:00:00	32020		\N	161244	0	370247008	4156265		0
41122	2444	381316	2013-08-11	2013-08-11 00:00:00	\N	\N	32020		\N	162130	0	230690007	381316		0
41187	2448	260139	1979-12-26	1979-12-26 00:00:00	1980-01-02	1980-01-02 00:00:00	32020		\N	162389	0	10509002	260139		0
41371	2460	260139	2012-10-11	2012-10-11 00:00:00	2012-10-18	2012-10-18 00:00:00	32020		\N	163072	0	10509002	260139		0
41513	2468	4152936	1939-04-05	1939-04-05 00:00:00	1939-04-19	1939-04-19 00:00:00	32020		\N	163672	0	283385000	4152936		0
41675	2480	40481087	1969-06-09	1969-06-09 00:00:00	1969-06-23	1969-06-23 00:00:00	32020		\N	164298	0	444814009	40481087		0
41912	2495	4134304	1987-06-26	1987-06-26 00:00:00	1987-08-25	1987-08-25 00:00:00	32020		\N	165161	0	263102004	4134304		0
42054	2504	40481087	2003-12-02	2003-12-02 00:00:00	2003-12-09	2003-12-09 00:00:00	32020		\N	165803	0	444814009	40481087		0
42263	2518	261325	1980-11-21	1980-11-21 00:00:00	\N	\N	32020		\N	166547	0	87433001	261325		0
42406	2526	40479422	1996-06-30	1996-06-30 00:00:00	1996-09-05	1996-09-05 00:00:00	32020		\N	167003	0	444448004	40479422		0
31938	1898	4112343	2005-09-26	2005-09-26 00:00:00	2005-10-07	2005-10-07 00:00:00	32020		\N	126386	0	195662009	4112343		0
32121	1908	40481087	2017-05-29	2017-05-29 00:00:00	2017-06-05	2017-06-05 00:00:00	32020		\N	126959	0	444814009	40481087		0
32265	1917	80180	1987-03-11	1987-03-11 00:00:00	\N	\N	32020		\N	127541	0	396275006	80180		0
32431	1925	4278672	1949-07-28	1949-07-28 00:00:00	1949-08-27	1949-08-27 00:00:00	32020		\N	128081	0	65966004	4278672		0
22029	1318	260139	2014-06-20	2014-06-20 00:00:00	2014-07-04	2014-07-04 00:00:00	32020		\N	87348	0	10509002	260139		0
32776	1946	40481087	1948-09-19	1948-09-19 00:00:00	1948-10-03	1948-10-03 00:00:00	32020		\N	129270	0	444814009	40481087		0
22408	1338	4237458	1948-04-13	1948-04-13 00:00:00	1948-05-13	1948-05-13 00:00:00	32020		\N	88763	0	58150001	4237458		0
33062	1962	40481087	2004-05-16	2004-05-16 00:00:00	2004-05-23	2004-05-23 00:00:00	32020		\N	130510	0	444814009	40481087		0
22736	1357	4134304	1984-06-12	1984-06-12 00:00:00	1984-09-10	1984-09-10 00:00:00	32020		\N	90034	0	263102004	4134304		0
33408	1982	4149245	1957-05-18	1957-05-18 00:00:00	1957-07-24	1957-07-24 00:00:00	32020		\N	131972	0	30832001	4149245		0
23072	1378	4155034	1952-06-29	1952-06-29 00:00:00	1952-07-13	1952-07-13 00:00:00	32020		\N	91317	0	283371005	4155034		0
23206	1385	257012	2008-08-31	2008-08-31 00:00:00	\N	\N	32020		\N	91829	0	40055000	257012		0
33902	2013	260139	1975-11-24	1975-11-24 00:00:00	1975-12-08	1975-12-08 00:00:00	32020		\N	133959	0	10509002	260139		0
34078	2025	4112343	1910-08-17	1910-08-17 00:00:00	1910-08-30	1910-08-30 00:00:00	32020		\N	134629	0	195662009	4112343		0
34208	2030	260139	1971-01-07	1971-01-07 00:00:00	1971-01-14	1971-01-14 00:00:00	32020		\N	135117	0	10509002	260139		0
34437	2044	378001	1974-07-08	1974-07-08 00:00:00	1974-08-07	1974-08-07 00:00:00	32020		\N	136023	0	62106007	378001		0
24027	1433	260139	2004-01-09	2004-01-09 00:00:00	2004-01-16	2004-01-16 00:00:00	32020		\N	95469	0	10509002	260139		0
34814	2069	4112343	1978-01-25	1978-01-25 00:00:00	1978-02-02	1978-02-02 00:00:00	32020		\N	137600	0	195662009	4112343		0
34948	2076	4027663	1992-12-22	1992-12-22 00:00:00	\N	\N	32020		\N	138178	0	13200003	4027663		0
24550	1466	372328	1969-07-28	1969-07-28 00:00:00	1969-08-11	1969-08-11 00:00:00	32020		\N	97606	0	65363002	372328		0
24732	1476	260139	1978-08-18	1978-08-18 00:00:00	1978-09-01	1978-09-01 00:00:00	32020		\N	98352	0	10509002	260139		0
35429	2098	260139	1970-12-21	1970-12-21 00:00:00	1970-12-28	1970-12-28 00:00:00	32020		\N	139903	0	10509002	260139		0
35555	2108	40481087	1955-10-12	1955-10-12 00:00:00	1955-10-19	1955-10-19 00:00:00	32020		\N	140394	0	444814009	40481087		0
25220	1505	372328	1974-09-02	1974-09-02 00:00:00	1976-05-22	1976-05-22 00:00:00	32020		\N	100317	0	65363002	372328		0
25356	1511	372328	1968-08-07	1968-08-07 00:00:00	1969-01-26	1969-01-26 00:00:00	32020		\N	100917	0	65363002	372328		0
36073	2138	40481087	1994-04-30	1994-04-30 00:00:00	1994-05-21	1994-05-21 00:00:00	32020		\N	142432	0	444814009	40481087		0
36221	2147	40481087	2001-04-09	2001-04-09 00:00:00	2001-04-23	2001-04-23 00:00:00	32020		\N	142929	0	444814009	40481087		0
36397	2153	4112343	1974-10-06	1974-10-06 00:00:00	1974-10-16	1974-10-16 00:00:00	32020		\N	143475	0	195662009	4112343		0
36563	2164	4112343	1974-03-07	1974-03-07 00:00:00	1974-03-15	1974-03-15 00:00:00	32020		\N	144153	0	195662009	4112343		0
36717	2173	260139	1959-08-07	1959-08-07 00:00:00	1959-08-14	1959-08-14 00:00:00	32020		\N	144723	0	10509002	260139		0
36896	2184	40481087	2009-10-23	2009-10-23 00:00:00	2009-10-30	2009-10-30 00:00:00	32020		\N	145549	0	444814009	40481087		0
26511	1571	28060	1967-04-28	1967-04-28 00:00:00	1967-05-11	1967-05-11 00:00:00	32020		\N	105519	0	43878008	28060		0
37208	2204	28060	1987-11-19	1987-11-19 00:00:00	1987-12-01	1987-12-01 00:00:00	32020		\N	146936	0	43878008	28060		0
37405	2217	28060	1993-11-01	1993-11-01 00:00:00	1993-11-08	1993-11-08 00:00:00	32020		\N	147670	0	43878008	28060		0
27040	1599	40481087	2002-07-12	2002-07-12 00:00:00	2002-08-02	2002-08-02 00:00:00	32020		\N	107295	0	444814009	40481087		0
27188	1606	260139	1999-04-16	1999-04-16 00:00:00	1999-04-30	1999-04-30 00:00:00	32020		\N	107803	0	10509002	260139		0
37865	2243	4113008	1968-01-25	1968-01-25 00:00:00	1968-02-08	1968-02-08 00:00:00	32020		\N	149361	0	284549007	4113008		0
38101	2261	4237458	1993-02-19	1993-02-19 00:00:00	1993-05-20	1993-05-20 00:00:00	32020		\N	150334	0	58150001	4237458		0
38204	2267	40481087	1977-11-06	1977-11-06 00:00:00	1977-11-27	1977-11-27 00:00:00	32020		\N	150707	0	444814009	40481087		0
38471	2286	80180	1996-10-07	1996-10-07 00:00:00	\N	\N	32020		\N	152092	0	396275006	80180		0
38606	2291	4116491	2010-10-01	2010-10-01 00:00:00	2010-11-02	2010-11-02 00:00:00	32020		\N	152547	0	301011002	4116491		0
38682	2295	372328	1976-06-07	1976-06-07 00:00:00	1976-07-13	1976-07-13 00:00:00	32020		\N	152756	0	65363002	372328		0
38883	2309	81151	1977-01-08	1977-01-08 00:00:00	1977-01-22	1977-01-22 00:00:00	32020		\N	153629	0	44465007	81151		0
39064	2320	4112343	1986-09-22	1986-09-22 00:00:00	1986-10-04	1986-10-04 00:00:00	32020		\N	154281	0	195662009	4112343		0
28681	1699	40481087	2004-02-21	2004-02-21 00:00:00	2004-03-13	2004-03-13 00:00:00	32020		\N	113653	0	444814009	40481087		0
39379	2334	40481087	1965-09-05	1965-09-05 00:00:00	1965-09-12	1965-09-12 00:00:00	32020		\N	155315	0	444814009	40481087		0
29029	1718	40481087	1977-10-21	1977-10-21 00:00:00	1977-11-04	1977-11-04 00:00:00	32020		\N	114849	0	444814009	40481087		0
39696	2351	40481087	1977-04-06	1977-04-06 00:00:00	1977-04-27	1977-04-27 00:00:00	32020		\N	156546	0	444814009	40481087		0
39843	2358	40481087	1979-09-30	1979-09-30 00:00:00	1979-10-21	1979-10-21 00:00:00	32020		\N	157139	0	444814009	40481087		0
29527	1748	4112343	1949-05-23	1949-05-23 00:00:00	1949-06-01	1949-06-01 00:00:00	32020		\N	116915	0	195662009	4112343		0
29695	1758	40481087	1984-08-31	1984-08-31 00:00:00	1984-09-14	1984-09-14 00:00:00	32020		\N	117546	0	444814009	40481087		0
29835	1764	4112343	2003-05-18	2003-05-18 00:00:00	2003-05-31	2003-05-31 00:00:00	32020		\N	117942	0	195662009	4112343		0
40534	2409	4112343	2001-03-10	2001-03-10 00:00:00	2001-03-18	2001-03-18 00:00:00	32020		\N	159895	0	195662009	4112343		0
40712	2419	28060	1970-08-01	1970-08-01 00:00:00	1970-08-09	1970-08-09 00:00:00	32020		\N	160511	0	43878008	28060		0
40876	2431	40481087	1991-07-11	1991-07-11 00:00:00	1991-07-25	1991-07-25 00:00:00	32020		\N	161228	0	444814009	40481087		0
41123	2444	4113008	1965-04-23	1965-04-23 00:00:00	1965-05-07	1965-05-07 00:00:00	32020		\N	162154	0	284549007	4113008		0
41188	2448	40481087	1988-04-02	1988-04-02 00:00:00	1988-04-23	1988-04-23 00:00:00	32020		\N	162391	0	444814009	40481087		0
41372	2460	4112343	2016-10-20	2016-10-20 00:00:00	2016-10-30	2016-10-30 00:00:00	32020		\N	163114	0	195662009	4112343		0
41514	2468	28060	1972-09-18	1972-09-18 00:00:00	1972-09-26	1972-09-26 00:00:00	32020		\N	163652	0	43878008	28060		0
41676	2480	80809	1988-10-24	1988-10-24 00:00:00	\N	\N	32020		\N	164344	0	69896004	80809		0
41913	2495	4283893	1992-06-22	1992-06-22 00:00:00	1992-08-10	1992-08-10 00:00:00	32020		\N	165152	0	36971009	4283893		0
42055	2504	260139	2006-04-02	2006-04-02 00:00:00	2006-04-16	2006-04-16 00:00:00	32020		\N	165804	0	10509002	260139		0
42264	2518	40481087	1956-09-10	1956-09-10 00:00:00	1956-09-24	1956-09-24 00:00:00	32020		\N	166499	0	444814009	40481087		0
42407	2526	40481087	1983-03-19	1983-03-19 00:00:00	1983-04-02	1983-04-02 00:00:00	32020		\N	167030	0	444814009	40481087		0
31939	1898	80180	2011-08-14	2011-08-14 00:00:00	\N	\N	32020		\N	126372	0	396275006	80180		0
32122	1908	260139	2014-06-15	2014-06-15 00:00:00	2014-06-29	2014-06-29 00:00:00	32020		\N	126972	0	10509002	260139		0
32266	1917	4112343	1953-03-15	1953-03-15 00:00:00	1953-03-26	1953-03-26 00:00:00	32020		\N	127525	0	195662009	4112343		0
32432	1925	372328	1945-06-19	1945-06-19 00:00:00	1945-09-29	1945-09-29 00:00:00	32020		\N	128146	0	65363002	372328		0
22030	1318	372328	1941-05-21	1941-05-21 00:00:00	1941-08-12	1941-08-12 00:00:00	32020		\N	87373	0	65363002	372328		0
32777	1946	28060	1977-09-20	1977-09-20 00:00:00	1977-10-01	1977-10-01 00:00:00	32020		\N	129279	0	43878008	28060		0
22409	1338	4112343	1994-04-08	1994-04-08 00:00:00	1994-04-20	1994-04-20 00:00:00	32020		\N	88687	0	195662009	4112343		0
33063	1962	40481087	2003-04-25	2003-04-25 00:00:00	2003-05-16	2003-05-16 00:00:00	32020		\N	130491	0	444814009	40481087		0
22737	1357	378001	1989-01-17	1989-01-17 00:00:00	1989-03-18	1989-03-18 00:00:00	32020		\N	90035	0	62106007	378001		0
33409	1982	80180	1963-08-05	1963-08-05 00:00:00	\N	\N	32020		\N	131951	0	396275006	80180		0
23073	1378	4218389	1981-08-10	1981-08-10 00:00:00	1981-09-14	1981-09-14 00:00:00	32020		\N	91318	0	39848009	4218389		0
23207	1385	4296205	2016-03-23	2016-03-23 00:00:00	2016-04-13	2016-04-13 00:00:00	32020		\N	91876	0	403191005	4296205		0
33903	2013	260139	1964-05-06	1964-05-06 00:00:00	1964-05-20	1964-05-20 00:00:00	32020		\N	134005	0	10509002	260139		0
34079	2025	81151	1954-09-11	1954-09-11 00:00:00	1954-10-16	1954-10-16 00:00:00	32020		\N	134737	0	44465007	81151		0
34209	2030	40481087	2018-06-04	2018-06-04 00:00:00	2018-06-25	2018-06-25 00:00:00	32020		\N	135165	0	444814009	40481087		0
34438	2044	40481087	1994-05-24	1994-05-24 00:00:00	1994-05-31	1994-05-31 00:00:00	32020		\N	135978	0	444814009	40481087		0
24028	1433	4294548	1973-10-30	1973-10-30 00:00:00	1973-12-04	1973-12-04 00:00:00	32020		\N	95426	0	75498004	4294548		0
34815	2069	4112343	1958-08-17	1958-08-17 00:00:00	1958-08-25	1958-08-25 00:00:00	32020		\N	137567	0	195662009	4112343		0
34949	2076	257012	2016-08-22	2016-08-22 00:00:00	\N	\N	32020		\N	138148	0	40055000	257012		0
24551	1466	4112343	1998-11-04	1998-11-04 00:00:00	1998-11-16	1998-11-16 00:00:00	32020		\N	97662	0	195662009	4112343		0
24733	1476	4112343	1961-11-28	1961-11-28 00:00:00	1961-12-10	1961-12-10 00:00:00	32020		\N	98537	0	195662009	4112343		0
35430	2098	4156265	2005-07-18	2005-07-18 00:00:00	2005-08-01	2005-08-01 00:00:00	32020		\N	139841	0	370247008	4156265		0
35556	2108	40481087	1940-06-09	1940-06-09 00:00:00	1940-06-16	1940-06-16 00:00:00	32020		\N	140311	0	444814009	40481087		0
25221	1505	372328	1959-05-22	1959-05-22 00:00:00	1959-08-22	1959-08-22 00:00:00	32020		\N	100388	0	65363002	372328		0
25357	1511	4112343	2002-07-08	2002-07-08 00:00:00	2002-07-18	2002-07-18 00:00:00	32020		\N	100902	0	195662009	4112343		0
36074	2138	4112343	1972-05-19	1972-05-19 00:00:00	1972-05-28	1972-05-28 00:00:00	32020		\N	142376	0	195662009	4112343		0
36222	2147	4112343	1971-07-15	1971-07-15 00:00:00	1971-07-24	1971-07-24 00:00:00	32020		\N	143002	0	195662009	4112343		0
36398	2153	4112343	2012-05-23	2012-05-23 00:00:00	2012-05-31	2012-05-31 00:00:00	32020		\N	143509	0	195662009	4112343		0
36564	2164	4001336	1983-10-23	1983-10-23 00:00:00	1983-11-22	1983-11-22 00:00:00	32020		\N	144123	0	110030002	4001336		0
36718	2173	40481087	2007-11-15	2007-11-15 00:00:00	2007-12-06	2007-12-06 00:00:00	32020		\N	144800	0	444814009	40481087		0
36897	2184	28060	1973-01-15	1973-01-15 00:00:00	1973-01-23	1973-01-23 00:00:00	32020		\N	145594	0	43878008	28060		0
26512	1571	4112343	1988-06-10	1988-06-10 00:00:00	1988-06-18	1988-06-18 00:00:00	32020		\N	105468	0	195662009	4112343		0
37209	2204	4112343	2004-09-02	2004-09-02 00:00:00	2004-09-14	2004-09-14 00:00:00	32020		\N	146937	0	195662009	4112343		0
37406	2218	28060	1988-01-18	1988-01-18 00:00:00	1988-01-31	1988-01-31 00:00:00	32020		\N	147701	0	43878008	28060		0
27041	1599	4112343	1991-12-18	1991-12-18 00:00:00	1991-12-30	1991-12-30 00:00:00	32020		\N	107330	0	195662009	4112343		0
27189	1606	40481087	2008-12-26	2008-12-26 00:00:00	2009-01-02	2009-01-02 00:00:00	32020		\N	107821	0	444814009	40481087		0
37866	2243	4266809	2005-09-03	2005-09-03 00:00:00	\N	\N	32020		\N	149357	0	397881000	4266809		0
38102	2261	260139	1990-05-30	1990-05-30 00:00:00	1990-06-13	1990-06-13 00:00:00	32020		\N	150339	0	10509002	260139		0
38205	2267	40481087	1986-06-01	1986-06-01 00:00:00	1986-06-08	1986-06-08 00:00:00	32020		\N	150723	0	444814009	40481087		0
38472	2286	78272	1996-01-09	1996-01-09 00:00:00	1996-02-06	1996-02-06 00:00:00	32020		\N	152092	0	70704007	78272		0
38607	2291	4112343	1992-12-11	1992-12-11 00:00:00	1992-12-21	1992-12-21 00:00:00	32020		\N	152542	0	195662009	4112343		0
38683	2295	4112343	1984-08-23	1984-08-23 00:00:00	1984-09-05	1984-09-05 00:00:00	32020		\N	152776	0	195662009	4112343		0
38884	2309	78272	2005-07-22	2005-07-22 00:00:00	2005-08-12	2005-08-12 00:00:00	32020		\N	153634	0	70704007	78272		0
39065	2320	260139	2001-08-23	2001-08-23 00:00:00	2001-08-30	2001-08-30 00:00:00	32020		\N	154287	0	10509002	260139		0
28682	1699	4112343	2011-03-03	2011-03-03 00:00:00	2011-03-15	2011-03-15 00:00:00	32020		\N	113654	0	195662009	4112343		0
39380	2334	40481087	1973-06-29	1973-06-29 00:00:00	1973-07-20	1973-07-20 00:00:00	32020		\N	155327	0	444814009	40481087		0
29030	1719	4109685	2007-01-07	2007-01-07 00:00:00	2007-01-21	2007-01-21 00:00:00	32020		\N	114998	0	284551006	4109685		0
39697	2351	40481087	2018-05-23	2018-05-23 00:00:00	2018-06-06	2018-06-06 00:00:00	32020		\N	156504	0	444814009	40481087		0
39844	2358	4027663	1998-06-01	1998-06-01 00:00:00	\N	\N	32020		\N	157124	0	13200003	4027663		0
29528	1748	40481087	1971-09-15	1971-09-15 00:00:00	1971-09-22	1971-09-22 00:00:00	32020		\N	116873	0	444814009	40481087		0
29696	1758	40481087	2003-01-13	2003-01-13 00:00:00	2003-01-20	2003-01-20 00:00:00	32020		\N	117506	0	444814009	40481087		0
29836	1764	40479422	2008-12-01	2008-12-01 00:00:00	2009-02-06	2009-02-06 00:00:00	32020		\N	117992	0	444448004	40479422		0
40535	2409	40481087	1983-07-12	1983-07-12 00:00:00	1983-07-19	1983-07-19 00:00:00	32020		\N	159946	0	444814009	40481087		0
40713	2419	260139	1972-11-19	1972-11-19 00:00:00	1972-12-03	1972-12-03 00:00:00	32020		\N	160571	0	10509002	260139		0
40877	2431	4266809	2013-07-30	2013-07-30 00:00:00	\N	\N	32020		\N	161204	0	397881000	4266809		0
41124	2444	378001	1996-09-21	1996-09-21 00:00:00	1996-11-20	1996-11-20 00:00:00	32020		\N	162155	0	62106007	378001		0
41189	2448	4112343	1974-01-06	1974-01-06 00:00:00	1974-01-19	1974-01-19 00:00:00	32020		\N	162364	0	195662009	4112343		0
41373	2460	4051466	1988-08-14	1988-08-14 00:00:00	2003-11-25	2003-11-25 00:00:00	32020		\N	163084	0	233678006	4051466		0
41515	2468	260139	1986-11-19	1986-11-19 00:00:00	1986-11-26	1986-11-26 00:00:00	32020		\N	163604	0	10509002	260139		0
41677	2480	40481087	1980-09-02	1980-09-02 00:00:00	1980-09-09	1980-09-09 00:00:00	32020		\N	164302	0	444814009	40481087		0
41914	2495	40481087	1990-11-16	1990-11-16 00:00:00	1990-11-23	1990-11-23 00:00:00	32020		\N	165132	0	444814009	40481087		0
42056	2504	4230399	1963-08-05	1963-08-05 00:00:00	1963-10-04	1963-10-04 00:00:00	32020		\N	165851	0	359817006	4230399		0
42265	2518	40481087	1977-11-10	1977-11-10 00:00:00	1977-12-01	1977-12-01 00:00:00	32020		\N	166501	0	444814009	40481087		0
42419	2528	40481087	1979-05-06	1979-05-06 00:00:00	1979-05-27	1979-05-27 00:00:00	32020		\N	167109	0	444814009	40481087		0
31940	1898	4266809	2011-08-14	2011-08-14 00:00:00	\N	\N	32020		\N	126372	0	397881000	4266809		0
32123	1908	4112343	1998-09-22	1998-09-22 00:00:00	1998-10-02	1998-10-02 00:00:00	32020		\N	126971	0	195662009	4112343		0
32267	1917	378001	1953-12-09	1953-12-09 00:00:00	1954-01-08	1954-01-08 00:00:00	32020		\N	127553	0	62106007	378001		0
32433	1925	4112343	2007-12-06	2007-12-06 00:00:00	2007-12-18	2007-12-18 00:00:00	32020		\N	128163	0	195662009	4112343		0
22031	1318	260139	1942-06-16	1942-06-16 00:00:00	1942-06-23	1942-06-23 00:00:00	32020		\N	87337	0	10509002	260139		0
32778	1947	40481087	1985-04-30	1985-04-30 00:00:00	1985-05-21	1985-05-21 00:00:00	32020		\N	129471	0	444814009	40481087		0
22410	1338	260139	2004-10-22	2004-10-22 00:00:00	2004-10-29	2004-10-29 00:00:00	32020		\N	88691	0	10509002	260139		0
33064	1962	40481087	2015-08-26	2015-08-26 00:00:00	2015-09-16	2015-09-16 00:00:00	32020		\N	130483	0	444814009	40481087		0
22738	1357	28060	2018-01-03	2018-01-03 00:00:00	2018-01-12	2018-01-12 00:00:00	32020		\N	90024	0	43878008	28060		0
33410	1982	4112343	1963-03-13	1963-03-13 00:00:00	1963-03-25	1963-03-25 00:00:00	32020		\N	131951	0	195662009	4112343		0
23074	1378	260139	1964-09-26	1964-09-26 00:00:00	1964-10-10	1964-10-10 00:00:00	32020		\N	91293	0	10509002	260139		0
23208	1385	260139	1997-05-17	1997-05-17 00:00:00	1997-05-24	1997-05-24 00:00:00	32020		\N	91811	0	10509002	260139		0
33904	2013	4237458	1975-10-16	1975-10-16 00:00:00	1975-12-15	1975-12-15 00:00:00	32020		\N	134003	0	58150001	4237458		0
34080	2025	40481087	1969-04-18	1969-04-18 00:00:00	1969-04-25	1969-04-25 00:00:00	32020		\N	134694	0	444814009	40481087		0
34210	2030	134438	1983-04-24	1983-04-24 00:00:00	1984-04-18	1984-04-18 00:00:00	32020		\N	135089	0	40275004	134438		0
34439	2044	30753	1996-03-24	1996-03-24 00:00:00	\N	\N	32020		\N	135978	0	16761005	30753		0
24029	1433	260139	1975-05-28	1975-05-28 00:00:00	1975-06-11	1975-06-11 00:00:00	32020		\N	95460	0	10509002	260139		0
34816	2069	372328	1952-06-17	1952-06-17 00:00:00	1952-09-28	1952-09-28 00:00:00	32020		\N	137628	0	65363002	372328		0
34950	2076	4278672	1973-01-17	1973-01-17 00:00:00	1973-02-16	1973-02-16 00:00:00	32020		\N	138209	0	65966004	4278672		0
24552	1466	28060	1975-06-30	1975-06-30 00:00:00	1975-07-09	1975-07-09 00:00:00	32020		\N	97620	0	43878008	28060		0
24734	1476	28060	2002-11-07	2002-11-07 00:00:00	2002-11-20	2002-11-20 00:00:00	32020		\N	98419	0	43878008	28060		0
35431	2098	40481087	1999-02-02	1999-02-02 00:00:00	1999-02-23	1999-02-23 00:00:00	32020		\N	139827	0	444814009	40481087		0
35557	2108	40481087	1961-03-26	1961-03-26 00:00:00	1961-04-02	1961-04-02 00:00:00	32020		\N	140395	0	444814009	40481087		0
25222	1505	372328	1954-12-29	1954-12-29 00:00:00	1955-02-12	1955-02-12 00:00:00	32020		\N	100316	0	65363002	372328		0
25358	1511	260139	2009-04-27	2009-04-27 00:00:00	2009-05-11	2009-05-11 00:00:00	32020		\N	100924	0	10509002	260139		0
36075	2138	260139	1972-12-05	1972-12-05 00:00:00	1972-12-12	1972-12-12 00:00:00	32020		\N	142430	0	10509002	260139		0
36224	2147	321042	2005-03-25	2005-03-25 00:00:00	\N	\N	32020		\N	142966	0	410429000	321042		0
36408	2155	260139	1985-10-10	1985-10-10 00:00:00	1985-10-17	1985-10-17 00:00:00	32020		\N	143576	0	10509002	260139		0
36565	2164	4132546	1983-10-23	1983-10-23 00:00:00	\N	\N	32020		\N	144123	0	275272006	4166590		0
36719	2173	4112343	1931-10-02	1931-10-02 00:00:00	1931-10-10	1931-10-10 00:00:00	32020		\N	144724	0	195662009	4112343		0
36898	2184	378001	1970-01-30	1970-01-30 00:00:00	1970-03-01	1970-03-01 00:00:00	32020		\N	145565	0	62106007	378001		0
26513	1571	28060	1979-02-15	1979-02-15 00:00:00	1979-02-24	1979-02-24 00:00:00	32020		\N	105482	0	43878008	28060		0
37210	2204	439777	1954-09-11	1954-09-11 00:00:00	\N	\N	32020		\N	146930	0	271737000	439777		0
37407	2218	4084167	1994-01-01	1994-01-01 00:00:00	1994-01-01	1994-01-01 00:00:00	32020		\N	147710	0	241929008	4084167		0
27042	1599	4278672	1966-11-09	1966-11-09 00:00:00	1966-12-09	1966-12-09 00:00:00	32020		\N	107360	0	65966004	4278672		0
27190	1606	4283893	2006-05-06	2006-05-06 00:00:00	2006-08-12	2006-08-12 00:00:00	32020		\N	107805	0	36971009	4283893		0
37867	2243	30753	2004-10-08	2004-10-08 00:00:00	\N	\N	32020		\N	149357	0	16761005	30753		0
38103	2261	40481087	1989-10-10	1989-10-10 00:00:00	1989-10-31	1989-10-31 00:00:00	32020		\N	150338	0	444814009	40481087		0
38206	2267	40481087	1980-12-20	1980-12-20 00:00:00	1980-12-27	1980-12-27 00:00:00	32020		\N	150722	0	444814009	40481087		0
38474	2286	260139	1969-12-29	1969-12-29 00:00:00	1970-01-05	1970-01-05 00:00:00	32020		\N	152059	0	10509002	260139		0
38608	2291	4112343	1966-01-18	1966-01-18 00:00:00	1966-01-30	1966-01-30 00:00:00	32020		\N	152448	0	195662009	4112343		0
38684	2295	4112343	1973-11-04	1973-11-04 00:00:00	1973-11-16	1973-11-16 00:00:00	32020		\N	152772	0	195662009	4112343		0
38885	2309	378001	1994-03-22	1994-03-22 00:00:00	1994-05-21	1994-05-21 00:00:00	32020		\N	153633	0	62106007	378001		0
39066	2320	4109685	1976-08-03	1976-08-03 00:00:00	1976-08-17	1976-08-17 00:00:00	32020		\N	154303	0	284551006	4109685		0
28683	1699	4152936	2004-06-10	2004-06-10 00:00:00	2004-07-01	2004-07-01 00:00:00	32020		\N	113615	0	283385000	4152936		0
39381	2334	4059173	1942-11-24	1942-11-24 00:00:00	1943-02-22	1943-02-22 00:00:00	32020		\N	155339	0	16114001	4059173		0
29031	1719	260139	1961-03-05	1961-03-05 00:00:00	1961-03-19	1961-03-19 00:00:00	32020		\N	114965	0	10509002	260139		0
39698	2351	40481087	1984-01-30	1984-01-30 00:00:00	1984-02-13	1984-02-13 00:00:00	32020		\N	156547	0	444814009	40481087		0
39845	2358	260139	2016-10-01	2016-10-01 00:00:00	2016-10-15	2016-10-15 00:00:00	32020		\N	157143	0	10509002	260139		0
29529	1748	40479768	1989-07-03	1989-07-03 00:00:00	1989-08-09	1989-08-09 00:00:00	32020		\N	116870	0	444470001	40479768		0
29697	1758	40481087	2018-02-03	2018-02-03 00:00:00	2018-02-17	2018-02-17 00:00:00	32020		\N	117550	0	444814009	40481087		0
29837	1764	40481087	1962-01-08	1962-01-08 00:00:00	1962-01-15	1962-01-15 00:00:00	32020		\N	117944	0	444814009	40481087		0
40536	2409	81151	1989-07-05	1989-07-05 00:00:00	1989-07-19	1989-07-19 00:00:00	32020		\N	159943	0	44465007	81151		0
40714	2419	4294548	1977-10-29	1977-10-29 00:00:00	1977-11-19	1977-11-19 00:00:00	32020		\N	160482	0	75498004	4294548		0
40878	2431	40481087	2013-07-22	2013-07-22 00:00:00	2013-07-29	2013-07-29 00:00:00	32020		\N	161204	0	444814009	40481087		0
41125	2444	4112343	1981-01-02	1981-01-02 00:00:00	1981-01-09	1981-01-09 00:00:00	32020		\N	162143	0	195662009	4112343		0
41190	2448	40481087	2006-03-22	2006-03-22 00:00:00	2006-03-29	2006-03-29 00:00:00	32020		\N	162357	0	444814009	40481087		0
41374	2460	4112343	2015-05-17	2015-05-17 00:00:00	2015-05-28	2015-05-28 00:00:00	32020		\N	163074	0	195662009	4112343		0
41516	2468	260139	2016-10-07	2016-10-07 00:00:00	2016-10-21	2016-10-21 00:00:00	32020		\N	163679	0	10509002	260139		0
41678	2480	4218389	2010-08-29	2010-08-29 00:00:00	2010-09-19	2010-09-19 00:00:00	32020		\N	164320	0	39848009	4218389		0
41915	2495	260139	1990-09-28	1990-09-28 00:00:00	1990-10-12	1990-10-12 00:00:00	32020		\N	165151	0	10509002	260139		0
42057	2504	40481087	1971-02-22	1971-02-22 00:00:00	1971-03-01	1971-03-01 00:00:00	32020		\N	165830	0	444814009	40481087		0
42266	2518	260139	2000-01-22	2000-01-22 00:00:00	2000-02-05	2000-02-05 00:00:00	32020		\N	166519	0	10509002	260139		0
42420	2528	28060	1969-11-12	1969-11-12 00:00:00	1969-11-25	1969-11-25 00:00:00	32020		\N	167103	0	43878008	28060		0
31941	1898	40481087	2004-10-05	2004-10-05 00:00:00	2004-10-26	2004-10-26 00:00:00	32020		\N	126353	0	444814009	40481087		0
32124	1908	372328	1974-09-26	1974-09-26 00:00:00	1975-05-18	1975-05-18 00:00:00	32020		\N	126985	0	65363002	372328		0
32268	1917	381316	2006-06-04	2006-06-04 00:00:00	\N	\N	32020		\N	127552	0	230690007	381316		0
32434	1925	372328	1971-09-22	1971-09-22 00:00:00	1973-02-24	1973-02-24 00:00:00	32020		\N	128107	0	65363002	372328		0
22033	1318	378419	2011-08-30	2011-08-30 00:00:00	\N	\N	32020		\N	87416	0	26929004	378419		0
32779	1947	40481087	1958-02-19	1958-02-19 00:00:00	1958-03-05	1958-03-05 00:00:00	32020		\N	129480	0	444814009	40481087		0
32869	1950	375671	1967-11-18	1967-11-18 00:00:00	1968-01-17	1968-01-17 00:00:00	32020		\N	129715	0	62564004	375671		0
33065	1962	40481087	2001-11-16	2001-11-16 00:00:00	2001-11-23	2001-11-23 00:00:00	32020		\N	130509	0	444814009	40481087		0
22739	1357	28060	1980-07-29	1980-07-29 00:00:00	1980-08-06	1980-08-06 00:00:00	32020		\N	89997	0	43878008	28060		0
33411	1982	260139	1939-03-25	1939-03-25 00:00:00	1939-04-08	1939-04-08 00:00:00	32020		\N	131948	0	10509002	260139		0
33533	1989	440086	1963-02-12	1963-02-12 00:00:00	1970-02-20	1970-02-20 00:00:00	32020		\N	132406	0	192127007	440086		0
23209	1385	260139	2007-05-14	2007-05-14 00:00:00	2007-05-28	2007-05-28 00:00:00	32020		\N	91828	0	10509002	260139		0
33905	2013	80180	1996-08-19	1996-08-19 00:00:00	\N	\N	32020		\N	133995	0	396275006	80180		0
34081	2025	4283893	1992-08-01	1992-08-01 00:00:00	1992-09-19	1992-09-19 00:00:00	32020		\N	134752	0	36971009	4283893		0
34211	2030	40481087	2016-05-19	2016-05-19 00:00:00	2016-06-09	2016-06-09 00:00:00	32020		\N	135164	0	444814009	40481087		0
34440	2044	81893	1995-05-29	1995-05-29 00:00:00	\N	\N	32020		\N	135978	0	64766004	81893		0
24030	1433	192671	1995-11-08	1995-11-08 00:00:00	\N	\N	32020		\N	95489	0	K92.2	35208414		0
34817	2069	28060	1965-09-18	1965-09-18 00:00:00	1965-09-30	1965-09-30 00:00:00	32020		\N	137615	0	43878008	28060		0
34951	2076	4283893	2016-07-25	2016-07-25 00:00:00	2016-11-07	2016-11-07 00:00:00	32020		\N	138195	0	36971009	4283893		0
24553	1466	4112343	1978-02-27	1978-02-27 00:00:00	1978-03-11	1978-03-11 00:00:00	32020		\N	97621	0	195662009	4112343		0
35193	2087	4112343	2013-02-24	2013-02-24 00:00:00	2013-03-03	2013-03-03 00:00:00	32020		\N	139141	0	195662009	4112343		0
35432	2098	4112343	2002-01-17	2002-01-17 00:00:00	2002-01-29	2002-01-29 00:00:00	32020		\N	139898	0	195662009	4112343		0
35558	2108	4134304	2017-07-23	2017-07-23 00:00:00	2017-09-21	2017-09-21 00:00:00	32020		\N	140360	0	263102004	4134304		0
25223	1505	40481087	1978-06-21	1978-06-21 00:00:00	1978-06-28	1978-06-28 00:00:00	32020		\N	100384	0	444814009	40481087		0
25359	1511	80180	2010-01-29	2010-01-29 00:00:00	\N	\N	32020		\N	100924	0	396275006	80180		0
36076	2138	192671	1990-07-14	1990-07-14 00:00:00	\N	\N	32020		\N	142418	0	K92.2	35208414		0
36225	2147	4294548	2002-10-13	2002-10-13 00:00:00	2002-12-14	2002-12-14 00:00:00	32020		\N	142914	0	75498004	4294548		0
36409	2155	260139	1935-05-28	1935-05-28 00:00:00	1935-06-04	1935-06-04 00:00:00	32020		\N	143653	0	10509002	260139		0
36566	2164	260139	1991-10-01	1991-10-01 00:00:00	1991-10-08	1991-10-08 00:00:00	32020		\N	144160	0	10509002	260139		0
36720	2173	40481087	1991-03-10	1991-03-10 00:00:00	1991-03-17	1991-03-17 00:00:00	32020		\N	144737	0	444814009	40481087		0
36899	2184	260139	1987-01-02	1987-01-02 00:00:00	1987-01-09	1987-01-09 00:00:00	32020		\N	145525	0	10509002	260139		0
26514	1571	4112343	1973-08-22	1973-08-22 00:00:00	1973-09-02	1973-09-02 00:00:00	32020		\N	105428	0	195662009	4112343		0
37211	2204	40481087	2003-04-30	2003-04-30 00:00:00	2003-05-14	2003-05-14 00:00:00	32020		\N	146920	0	444814009	40481087		0
37408	2218	195588	2016-06-25	2016-06-25 00:00:00	2016-07-30	2016-07-30 00:00:00	32020		\N	147758	0	38822007	195588		0
27043	1599	192671	1998-02-23	1998-02-23 00:00:00	\N	\N	32020		\N	107363	0	K92.2	35208414		0
27191	1606	192671	1989-06-03	1989-06-03 00:00:00	\N	\N	32020		\N	107797	0	K92.2	35208414		0
37868	2243	81893	2004-09-08	2004-09-08 00:00:00	\N	\N	32020		\N	149357	0	64766004	81893		0
38104	2261	30753	2000-08-22	2000-08-22 00:00:00	\N	\N	32020		\N	150302	0	16761005	30753		0
38207	2267	4112343	1993-07-19	1993-07-19 00:00:00	1993-07-26	1993-07-26 00:00:00	32020		\N	150725	0	195662009	4112343		0
38475	2286	40481087	2006-09-21	2006-09-21 00:00:00	2006-10-12	2006-10-12 00:00:00	32020		\N	152077	0	444814009	40481087		0
38609	2291	4294548	1988-05-12	1988-05-12 00:00:00	1988-05-19	1988-05-19 00:00:00	32020		\N	152538	0	75498004	4294548		0
38685	2295	372328	1974-11-28	1974-11-28 00:00:00	1975-01-14	1975-01-14 00:00:00	32020		\N	152784	0	65363002	372328		0
38886	2309	28060	1983-05-19	1983-05-19 00:00:00	1983-05-27	1983-05-27 00:00:00	32020		\N	153621	0	43878008	28060		0
39067	2320	40481087	1946-02-16	1946-02-16 00:00:00	1946-03-09	1946-03-09 00:00:00	32020		\N	154284	0	444814009	40481087		0
28684	1699	372328	1967-08-26	1967-08-26 00:00:00	1967-09-09	1967-09-09 00:00:00	32020		\N	113673	0	65363002	372328		0
37247	2206	192671	2008-04-09	2008-04-09 00:00:00	\N	\N	32020		\N	147012	0	K92.2	35208414		0
39382	2334	40481087	1965-04-22	1965-04-22 00:00:00	1965-04-29	1965-04-29 00:00:00	32020		\N	155287	0	444814009	40481087		0
29032	1719	4112343	1967-02-15	1967-02-15 00:00:00	1967-02-27	1967-02-27 00:00:00	32020		\N	114888	0	195662009	4112343		0
39699	2351	4296205	1949-05-13	1949-05-13 00:00:00	1949-06-10	1949-06-10 00:00:00	32020		\N	156556	0	403191005	4296205		0
39846	2358	40481087	2002-07-31	2002-07-31 00:00:00	2002-08-21	2002-08-21 00:00:00	32020		\N	157134	0	444814009	40481087		0
29530	1748	40481087	1959-12-24	1959-12-24 00:00:00	1960-01-14	1960-01-14 00:00:00	32020		\N	116843	0	444814009	40481087		0
29698	1758	40481087	1966-10-22	1966-10-22 00:00:00	1966-10-29	1966-10-29 00:00:00	32020		\N	117502	0	444814009	40481087		0
29838	1764	40481087	2003-05-24	2003-05-24 00:00:00	2003-06-07	2003-06-07 00:00:00	32020		\N	117943	0	444814009	40481087		0
40537	2409	195588	2013-11-09	2013-11-09 00:00:00	2013-12-23	2013-12-23 00:00:00	32020		\N	159898	0	38822007	195588		0
40715	2419	378001	1946-09-10	1946-09-10 00:00:00	1946-11-09	1946-11-09 00:00:00	32020		\N	160504	0	62106007	378001		0
40879	2431	80180	2013-07-30	2013-07-30 00:00:00	\N	\N	32020		\N	161204	0	396275006	80180		0
41126	2444	4112343	1960-02-16	1960-02-16 00:00:00	1960-02-29	1960-02-29 00:00:00	32020		\N	162102	0	195662009	4112343		0
41191	2448	4112343	1996-02-06	1996-02-06 00:00:00	1996-02-17	1996-02-17 00:00:00	32020		\N	162365	0	195662009	4112343		0
41375	2461	40481087	2014-08-26	2014-08-26 00:00:00	2014-09-02	2014-09-02 00:00:00	32020		\N	163179	0	444814009	40481087		0
41517	2468	372328	1943-05-14	1943-05-14 00:00:00	1944-03-26	1944-03-26 00:00:00	32020		\N	163637	0	65363002	372328		0
41679	2480	4113008	1977-12-06	1977-12-06 00:00:00	1977-12-20	1977-12-20 00:00:00	32020		\N	164317	0	284549007	4113008		0
41916	2495	4112343	2010-10-06	2010-10-06 00:00:00	2010-10-16	2010-10-16 00:00:00	32020		\N	165137	0	195662009	4112343		0
42058	2504	260139	1970-12-28	1970-12-28 00:00:00	1971-01-04	1971-01-04 00:00:00	32020		\N	165773	0	10509002	260139		0
42267	2518	80180	1988-05-29	1988-05-29 00:00:00	\N	\N	32020		\N	166517	0	396275006	80180		0
42421	2528	40481087	1992-06-06	1992-06-06 00:00:00	1992-06-13	1992-06-13 00:00:00	32020		\N	167088	0	444814009	40481087		0
31942	1898	4112343	2001-09-06	2001-09-06 00:00:00	2001-09-13	2001-09-13 00:00:00	32020		\N	126385	0	195662009	4112343		0
32125	1908	40481087	2010-03-18	2010-03-18 00:00:00	2010-04-01	2010-04-01 00:00:00	32020		\N	127000	0	444814009	40481087		0
32269	1917	40481087	1998-02-05	1998-02-05 00:00:00	1998-02-19	1998-02-19 00:00:00	32020		\N	127562	0	444814009	40481087		0
32435	1925	372328	1947-06-26	1947-06-26 00:00:00	1947-12-27	1947-12-27 00:00:00	32020		\N	128164	0	65363002	372328		0
22034	1318	313217	2017-08-01	2017-08-01 00:00:00	\N	\N	32020		\N	87417	0	49436004	313217		0
32780	1947	40481087	2019-03-15	2019-03-15 00:00:00	2019-03-22	2019-03-22 00:00:00	32020		\N	129412	0	444814009	40481087		0
32870	1950	372328	1944-06-23	1944-06-23 00:00:00	1944-08-17	1944-08-17 00:00:00	32020		\N	129633	0	65363002	372328		0
33066	1962	4283893	2009-10-29	2009-10-29 00:00:00	2009-11-26	2009-11-26 00:00:00	32020		\N	130482	0	36971009	4283893		0
22740	1357	260139	1980-03-18	1980-03-18 00:00:00	1980-03-25	1980-03-25 00:00:00	32020		\N	90022	0	10509002	260139		0
33412	1982	4112343	1943-06-02	1943-06-02 00:00:00	1943-06-15	1943-06-15 00:00:00	32020		\N	132032	0	195662009	4112343		0
33534	1989	4116491	1997-02-03	1997-02-03 00:00:00	1997-03-20	1997-03-20 00:00:00	32020		\N	132446	0	301011002	4116491		0
23210	1385	4283893	2008-07-20	2008-07-20 00:00:00	2008-09-07	2008-09-07 00:00:00	32020		\N	91840	0	36971009	4283893		0
33906	2013	40481087	1983-04-02	1983-04-02 00:00:00	1983-04-16	1983-04-16 00:00:00	32020		\N	133960	0	444814009	40481087		0
34082	2025	4112343	1956-06-18	1956-06-18 00:00:00	1956-07-01	1956-07-01 00:00:00	32020		\N	134667	0	195662009	4112343		0
34212	2030	4112343	1989-11-24	1989-11-24 00:00:00	1989-12-04	1989-12-04 00:00:00	32020		\N	135146	0	195662009	4112343		0
34441	2044	378001	2009-11-01	2009-11-01 00:00:00	2009-12-01	2009-12-01 00:00:00	32020		\N	136025	0	62106007	378001		0
24040	1435	40481087	1996-05-14	1996-05-14 00:00:00	1996-06-04	1996-06-04 00:00:00	32020		\N	95560	0	444814009	40481087		0
34818	2069	40481087	2004-05-24	2004-05-24 00:00:00	2004-06-07	2004-06-07 00:00:00	32020		\N	137570	0	444814009	40481087		0
34952	2076	4155034	1970-11-08	1970-11-08 00:00:00	1970-11-29	1970-11-29 00:00:00	32020		\N	138208	0	283371005	4155034		0
24554	1466	40481087	1980-12-04	1980-12-04 00:00:00	1980-12-25	1980-12-25 00:00:00	32020		\N	97660	0	444814009	40481087		0
35194	2087	260139	1936-09-15	1936-09-15 00:00:00	1936-09-22	1936-09-22 00:00:00	32020		\N	139026	0	10509002	260139		0
35433	2098	40481087	2004-10-29	2004-10-29 00:00:00	2004-11-19	2004-11-19 00:00:00	32020		\N	139899	0	444814009	40481087		0
35559	2108	260139	1957-04-12	1957-04-12 00:00:00	1957-04-26	1957-04-26 00:00:00	32020		\N	140397	0	10509002	260139		0
25224	1505	40481087	1969-04-19	1969-04-19 00:00:00	1969-05-03	1969-05-03 00:00:00	32020		\N	100312	0	444814009	40481087		0
25360	1511	4218389	2003-06-01	2003-06-01 00:00:00	2003-07-06	2003-07-06 00:00:00	32020		\N	100935	0	39848009	4218389		0
36077	2138	4146173	1997-12-07	1997-12-07 00:00:00	1998-02-05	1998-02-05 00:00:00	32020		\N	142389	0	307731004	4146173		0
36226	2147	40481087	1973-01-15	1973-01-15 00:00:00	1973-02-05	1973-02-05 00:00:00	32020		\N	143007	0	444814009	40481087		0
36410	2155	28060	1979-09-19	1979-09-19 00:00:00	1979-10-02	1979-10-02 00:00:00	32020		\N	143655	0	43878008	28060		0
36567	2164	4112343	1989-07-12	1989-07-12 00:00:00	1989-07-22	1989-07-22 00:00:00	32020		\N	144137	0	195662009	4112343		0
36721	2173	28060	1934-05-29	1934-05-29 00:00:00	1934-06-09	1934-06-09 00:00:00	32020		\N	144863	0	43878008	28060		0
36900	2184	372328	1969-02-16	1969-02-16 00:00:00	1969-07-23	1969-07-23 00:00:00	32020		\N	145598	0	65363002	372328		0
26515	1571	40481087	1976-11-06	1976-11-06 00:00:00	1976-11-13	1976-11-13 00:00:00	32020		\N	105444	0	444814009	40481087		0
37212	2204	4112343	1982-12-13	1982-12-13 00:00:00	1982-12-21	1982-12-21 00:00:00	32020		\N	146934	0	195662009	4112343		0
37409	2218	40481087	1999-10-09	1999-10-09 00:00:00	1999-10-16	1999-10-16 00:00:00	32020		\N	147704	0	444814009	40481087		0
27044	1599	40481087	1980-11-09	1980-11-09 00:00:00	1980-11-23	1980-11-23 00:00:00	32020		\N	107287	0	444814009	40481087		0
27192	1606	40481087	1985-05-24	1985-05-24 00:00:00	1985-06-07	1985-06-07 00:00:00	32020		\N	107800	0	444814009	40481087		0
37869	2243	80180	2005-09-03	2005-09-03 00:00:00	\N	\N	32020		\N	149357	0	396275006	80180		0
38105	2261	40481087	2000-08-02	2000-08-02 00:00:00	2000-08-09	2000-08-09 00:00:00	32020		\N	150302	0	444814009	40481087		0
38230	2270	81151	2012-01-24	2012-01-24 00:00:00	2012-02-07	2012-02-07 00:00:00	32020		\N	150940	0	44465007	81151		0
38476	2286	40481087	2010-04-21	2010-04-21 00:00:00	2010-05-05	2010-05-05 00:00:00	32020		\N	152070	0	444814009	40481087		0
38610	2291	4112343	2011-10-02	2011-10-02 00:00:00	2011-10-12	2011-10-12 00:00:00	32020		\N	152506	0	195662009	4112343		0
38686	2295	4113008	1996-12-23	1996-12-23 00:00:00	1997-01-06	1997-01-06 00:00:00	32020		\N	152754	0	284549007	4113008		0
38887	2309	260139	1990-08-29	1990-08-29 00:00:00	1990-09-05	1990-09-05 00:00:00	32020		\N	153622	0	10509002	260139		0
39068	2320	4112343	1962-07-13	1962-07-13 00:00:00	1962-07-26	1962-07-26 00:00:00	32020		\N	154242	0	195662009	4112343		0
28685	1699	4059173	1979-01-25	1979-01-25 00:00:00	1979-04-25	1979-04-25 00:00:00	32020		\N	113627	0	16114001	4059173		0
39383	2334	4112343	1939-02-15	1939-02-15 00:00:00	1939-02-22	1939-02-22 00:00:00	32020		\N	155282	0	195662009	4112343		0
29033	1719	28060	1965-06-12	1965-06-12 00:00:00	1965-06-23	1965-06-23 00:00:00	32020		\N	114943	0	43878008	28060		0
39700	2351	4109685	1963-02-27	1963-02-27 00:00:00	1963-03-13	1963-03-13 00:00:00	32020		\N	156558	0	284551006	4109685		0
39847	2358	40481087	2011-04-27	2011-04-27 00:00:00	2011-05-18	2011-05-18 00:00:00	32020		\N	157153	0	444814009	40481087		0
29531	1748	40481087	2005-09-21	2005-09-21 00:00:00	2005-09-28	2005-09-28 00:00:00	32020		\N	116858	0	444814009	40481087		0
29699	1758	260139	2013-01-22	2013-01-22 00:00:00	2013-02-05	2013-02-05 00:00:00	32020		\N	117548	0	10509002	260139		0
40922	2435	30753	2014-09-26	2014-09-26 00:00:00	\N	\N	32020		\N	161388	0	16761005	30753		0
29839	1764	260139	1978-11-01	1978-11-01 00:00:00	1978-11-08	1978-11-08 00:00:00	32020		\N	117939	0	10509002	260139		0
40539	2411	40481087	1984-10-12	1984-10-12 00:00:00	1984-11-02	1984-11-02 00:00:00	32020		\N	159969	0	444814009	40481087		0
40716	2419	40481087	1987-08-06	1987-08-06 00:00:00	1987-08-27	1987-08-27 00:00:00	32020		\N	160572	0	444814009	40481087		0
40880	2431	4112343	1999-01-18	1999-01-18 00:00:00	1999-01-27	1999-01-27 00:00:00	32020		\N	161215	0	195662009	4112343		0
41127	2444	4112343	1973-12-03	1973-12-03 00:00:00	1973-12-13	1973-12-13 00:00:00	32020		\N	162110	0	195662009	4112343		0
41192	2448	28060	1978-05-31	1978-05-31 00:00:00	1978-06-07	1978-06-07 00:00:00	32020		\N	162337	0	43878008	28060		0
41376	2461	4112343	1996-03-29	1996-03-29 00:00:00	1996-04-11	1996-04-11 00:00:00	32020		\N	163146	0	195662009	4112343		0
41518	2468	260139	1963-04-29	1963-04-29 00:00:00	1963-05-06	1963-05-06 00:00:00	32020		\N	163603	0	10509002	260139		0
41680	2480	40481087	1979-05-27	1979-05-27 00:00:00	1979-06-03	1979-06-03 00:00:00	32020		\N	164342	0	444814009	40481087		0
41917	2495	28060	2013-04-05	2013-04-05 00:00:00	2013-04-14	2013-04-14 00:00:00	32020		\N	165163	0	43878008	28060		0
42059	2504	40481087	2003-04-09	2003-04-09 00:00:00	2003-04-30	2003-04-30 00:00:00	32020		\N	165780	0	444814009	40481087		0
42268	2518	40481087	1987-03-06	1987-03-06 00:00:00	1987-03-27	1987-03-27 00:00:00	32020		\N	166517	0	444814009	40481087		0
42422	2528	375671	1981-09-08	1981-09-08 00:00:00	1981-10-08	1981-10-08 00:00:00	32020		\N	167132	0	62564004	375671		0
31943	1898	4027663	2002-11-29	2002-11-29 00:00:00	\N	\N	32020		\N	126385	0	13200003	4027663		0
32126	1908	4112343	1982-06-07	1982-06-07 00:00:00	1982-06-17	1982-06-17 00:00:00	32020		\N	126955	0	195662009	4112343		0
32270	1917	4027663	1978-06-26	1978-06-26 00:00:00	\N	\N	32020		\N	127538	0	13200003	4027663		0
32436	1925	40481087	2013-04-26	2013-04-26 00:00:00	2013-05-10	2013-05-10 00:00:00	32020		\N	128145	0	444814009	40481087		0
22035	1318	40481087	1967-01-20	1967-01-20 00:00:00	1967-02-03	1967-02-03 00:00:00	32020		\N	87350	0	444814009	40481087		0
32781	1947	4218389	2012-08-10	2012-08-10 00:00:00	2012-09-07	2012-09-07 00:00:00	32020		\N	129394	0	39848009	4218389		0
32871	1950	81151	1956-06-20	1956-06-20 00:00:00	1956-07-18	1956-07-18 00:00:00	32020		\N	129714	0	44465007	81151		0
33067	1962	4113008	1967-01-23	1967-01-23 00:00:00	1967-02-06	1967-02-06 00:00:00	32020		\N	130476	0	284549007	4113008		0
22741	1357	81151	1976-01-21	1976-01-21 00:00:00	1976-02-25	1976-02-25 00:00:00	32020		\N	90032	0	44465007	81151		0
33413	1982	40481087	1950-07-20	1950-07-20 00:00:00	1950-07-27	1950-07-27 00:00:00	32020		\N	131987	0	444814009	40481087		0
33535	1989	4112343	1976-05-30	1976-05-30 00:00:00	1976-06-09	1976-06-09 00:00:00	32020		\N	132444	0	195662009	4112343		0
23211	1385	40481087	1966-03-21	1966-03-21 00:00:00	1966-04-04	1966-04-04 00:00:00	32020		\N	91863	0	444814009	40481087		0
33907	2013	81151	1965-07-28	1965-07-28 00:00:00	1965-08-25	1965-08-25 00:00:00	32020		\N	134001	0	44465007	81151		0
34083	2025	4113008	1963-04-02	1963-04-02 00:00:00	1963-04-23	1963-04-23 00:00:00	32020		\N	134738	0	284549007	4113008		0
34243	2033	260139	1978-05-08	1978-05-08 00:00:00	1978-05-15	1978-05-15 00:00:00	32020		\N	135316	0	10509002	260139		0
34442	2044	40481087	1962-12-14	1962-12-14 00:00:00	1962-12-21	1962-12-21 00:00:00	32020		\N	135952	0	444814009	40481087		0
24041	1435	40481087	1978-03-05	1978-03-05 00:00:00	1978-03-12	1978-03-12 00:00:00	32020		\N	95597	0	444814009	40481087		0
34819	2069	260139	1997-01-28	1997-01-28 00:00:00	1997-02-11	1997-02-11 00:00:00	32020		\N	137579	0	10509002	260139		0
34953	2076	260139	1988-03-17	1988-03-17 00:00:00	1988-03-31	1988-03-31 00:00:00	32020		\N	138200	0	10509002	260139		0
24555	1466	40481087	2005-09-22	2005-09-22 00:00:00	2005-09-29	2005-09-29 00:00:00	32020		\N	97604	0	444814009	40481087		0
35195	2087	260139	1938-04-16	1938-04-16 00:00:00	1938-04-23	1938-04-23 00:00:00	32020		\N	139027	0	10509002	260139		0
35434	2098	4112343	2004-06-18	2004-06-18 00:00:00	2004-06-25	2004-06-25 00:00:00	32020		\N	139828	0	195662009	4112343		0
35560	2108	40481087	2010-03-01	2010-03-01 00:00:00	2010-03-22	2010-03-22 00:00:00	32020		\N	140386	0	444814009	40481087		0
25225	1505	260139	1968-06-19	1968-06-19 00:00:00	1968-06-26	1968-06-26 00:00:00	32020		\N	100367	0	10509002	260139		0
25361	1511	440448	2010-04-15	2010-04-15 00:00:00	\N	\N	32020		\N	100936	0	74400008	440448		0
36078	2138	4237458	1959-08-15	1959-08-15 00:00:00	1959-11-13	1959-11-13 00:00:00	32020		\N	142411	0	58150001	4237458		0
36227	2147	257012	2002-10-27	2002-10-27 00:00:00	\N	\N	32020		\N	142951	0	40055000	257012		0
36411	2155	80180	1970-07-16	1970-07-16 00:00:00	\N	\N	32020		\N	143590	0	396275006	80180		0
36568	2164	372328	1973-08-25	1973-08-25 00:00:00	1973-12-07	1973-12-07 00:00:00	32020		\N	144127	0	65363002	372328		0
36722	2173	260139	1997-02-27	1997-02-27 00:00:00	1997-03-06	1997-03-06 00:00:00	32020		\N	144871	0	10509002	260139		0
36901	2184	4155034	1993-05-27	1993-05-27 00:00:00	1993-06-17	1993-06-17 00:00:00	32020		\N	145588	0	283371005	4155034		0
26516	1571	4283893	2001-11-27	2001-11-27 00:00:00	2001-12-18	2001-12-18 00:00:00	32020		\N	105488	0	36971009	4283893		0
37213	2204	4156265	1986-03-21	1986-03-21 00:00:00	1986-04-04	1986-04-04 00:00:00	32020		\N	146880	0	370247008	4156265		0
37410	2218	4084167	1989-03-26	1989-03-26 00:00:00	1989-03-26	1989-03-26 00:00:00	32020		\N	147708	0	241929008	4084167		0
27045	1599	4112343	2006-10-14	2006-10-14 00:00:00	2006-10-27	2006-10-27 00:00:00	32020		\N	107331	0	195662009	4112343		0
27193	1606	4112343	1957-08-24	1957-08-24 00:00:00	1957-09-01	1957-09-01 00:00:00	32020		\N	107873	0	195662009	4112343		0
37870	2243	4285898	2005-03-07	2005-03-07 00:00:00	\N	\N	32020		\N	149357	0	68496003	4285898		0
38106	2261	260139	2017-04-12	2017-04-12 00:00:00	2017-04-26	2017-04-26 00:00:00	32020		\N	150315	0	10509002	260139		0
38231	2270	440086	1992-05-27	1992-05-27 00:00:00	1996-06-05	1996-06-05 00:00:00	32020		\N	150919	0	192127007	440086		0
38477	2286	40481087	2007-11-13	2007-11-13 00:00:00	2007-11-27	2007-11-27 00:00:00	32020		\N	152069	0	444814009	40481087		0
38611	2291	40481087	1965-01-26	1965-01-26 00:00:00	1965-02-02	1965-02-02 00:00:00	32020		\N	152447	0	444814009	40481087		0
38687	2295	40481087	2013-09-10	2013-09-10 00:00:00	2013-09-24	2013-09-24 00:00:00	32020		\N	152775	0	444814009	40481087		0
38888	2309	40481087	1986-10-25	1986-10-25 00:00:00	1986-11-01	1986-11-01 00:00:00	32020		\N	153614	0	444814009	40481087		0
39069	2320	28060	1997-01-19	1997-01-19 00:00:00	1997-02-01	1997-02-01 00:00:00	32020		\N	154283	0	43878008	28060		0
28686	1699	260139	1973-02-26	1973-02-26 00:00:00	1973-03-12	1973-03-12 00:00:00	32020		\N	113605	0	10509002	260139		0
39384	2334	258780	1960-02-11	1960-02-11 00:00:00	\N	\N	32020		\N	155367	0	185086009	258780		0
29034	1719	40481087	1979-06-19	1979-06-19 00:00:00	1979-07-03	1979-07-03 00:00:00	32020		\N	114957	0	444814009	40481087		0
39701	2351	4112343	2013-10-22	2013-10-22 00:00:00	2013-11-04	2013-11-04 00:00:00	32020		\N	156503	0	195662009	4112343		0
39848	2359	4112343	1957-02-07	1957-02-07 00:00:00	1957-02-16	1957-02-16 00:00:00	32020		\N	157276	0	195662009	4112343		0
29532	1748	4112343	2008-08-27	2008-08-27 00:00:00	2008-09-09	2008-09-09 00:00:00	32020		\N	116844	0	195662009	4112343		0
29700	1758	4152936	1973-02-12	1973-02-12 00:00:00	1973-02-26	1973-02-26 00:00:00	32020		\N	117556	0	283385000	4152936		0
29840	1764	4112343	1994-08-04	1994-08-04 00:00:00	1994-08-16	1994-08-16 00:00:00	32020		\N	117997	0	195662009	4112343		0
40540	2411	4112343	2017-11-04	2017-11-04 00:00:00	2017-11-12	2017-11-12 00:00:00	32020		\N	159992	0	195662009	4112343		0
40731	2423	378001	2018-04-17	2018-04-17 00:00:00	2018-05-17	2018-05-17 00:00:00	32020		\N	160770	0	62106007	378001		0
40881	2431	4310024	2011-09-09	2011-09-09 00:00:00	\N	\N	32020		\N	161188	0	424802006	4310024		0
41128	2444	40481087	1963-11-21	1963-11-21 00:00:00	1963-12-05	1963-12-05 00:00:00	32020		\N	162158	0	444814009	40481087		0
41193	2448	40481087	1973-01-23	1973-01-23 00:00:00	1973-02-13	1973-02-13 00:00:00	32020		\N	162336	0	444814009	40481087		0
41377	2461	4112343	1981-12-16	1981-12-16 00:00:00	1981-12-24	1981-12-24 00:00:00	32020		\N	163176	0	195662009	4112343		0
41519	2468	4218389	1985-01-08	1985-01-08 00:00:00	1985-02-05	1985-02-05 00:00:00	32020		\N	163677	0	39848009	4218389		0
41681	2480	80180	1991-06-16	1991-06-16 00:00:00	\N	\N	32020		\N	164326	0	396275006	80180		0
41928	2497	313217	2017-08-17	2017-08-17 00:00:00	\N	\N	32020		\N	165301	0	49436004	313217		0
42060	2504	4112343	1957-12-06	1957-12-06 00:00:00	1957-12-13	1957-12-13 00:00:00	32020		\N	165813	0	195662009	4112343		0
42269	2518	40481087	1995-08-06	1995-08-06 00:00:00	1995-08-20	1995-08-20 00:00:00	32020		\N	166582	0	444814009	40481087		0
42423	2528	375671	2008-04-19	2008-04-19 00:00:00	2008-05-19	2008-05-19 00:00:00	32020		\N	167133	0	62564004	375671		0
31944	1898	260139	2013-05-25	2013-05-25 00:00:00	2013-06-01	2013-06-01 00:00:00	32020		\N	126345	0	10509002	260139		0
32127	1908	260139	2007-01-14	2007-01-14 00:00:00	2007-01-21	2007-01-21 00:00:00	32020		\N	126958	0	10509002	260139		0
32271	1917	81893	1985-06-19	1985-06-19 00:00:00	\N	\N	32020		\N	127522	0	64766004	81893		0
32437	1926	81151	2017-12-21	2017-12-21 00:00:00	2018-01-18	2018-01-18 00:00:00	32020		\N	128203	0	44465007	81151		0
22036	1318	28060	1949-10-09	1949-10-09 00:00:00	1949-10-16	1949-10-16 00:00:00	32020		\N	87335	0	43878008	28060		0
32782	1947	260139	1986-12-20	1986-12-20 00:00:00	1986-12-27	1986-12-27 00:00:00	32020		\N	129435	0	10509002	260139		0
32872	1950	40481087	2018-08-28	2018-08-28 00:00:00	2018-09-11	2018-09-11 00:00:00	32020		\N	129629	0	444814009	40481087		0
33068	1962	4278672	2005-03-28	2005-03-28 00:00:00	2005-05-27	2005-05-27 00:00:00	32020		\N	130481	0	65966004	4278672		0
22742	1357	40481087	1986-08-02	1986-08-02 00:00:00	1986-08-09	1986-08-09 00:00:00	32020		\N	89999	0	444814009	40481087		0
33414	1982	4112343	1948-10-18	1948-10-18 00:00:00	1948-10-29	1948-10-29 00:00:00	32020		\N	132014	0	195662009	4112343		0
33536	1989	378001	1953-12-06	1953-12-06 00:00:00	1954-02-04	1954-02-04 00:00:00	32020		\N	132394	0	62106007	378001		0
23212	1385	260139	2012-01-26	2012-01-26 00:00:00	2012-02-02	2012-02-02 00:00:00	32020		\N	91841	0	10509002	260139		0
33908	2013	40481087	2003-12-23	2003-12-23 00:00:00	2004-01-06	2004-01-06 00:00:00	32020		\N	133928	0	444814009	40481087		0
34084	2025	78272	1943-06-06	1943-06-06 00:00:00	1943-06-27	1943-06-27 00:00:00	32020		\N	134664	0	70704007	78272		0
34244	2033	4283893	1984-02-07	1984-02-07 00:00:00	1985-03-12	1985-03-12 00:00:00	32020		\N	135318	0	36971009	4283893		0
34443	2044	4283893	1982-10-13	1982-10-13 00:00:00	1983-01-26	1983-01-26 00:00:00	32020		\N	135956	0	36971009	4283893		0
24042	1435	4237458	1968-07-11	1968-07-11 00:00:00	1968-10-09	1968-10-09 00:00:00	32020		\N	95581	0	58150001	4237458		0
34820	2069	4237458	1955-05-03	1955-05-03 00:00:00	1955-06-02	1955-06-02 00:00:00	32020		\N	137584	0	58150001	4237458		0
34954	2076	260139	1984-04-16	1984-04-16 00:00:00	1984-04-23	1984-04-23 00:00:00	32020		\N	138144	0	10509002	260139		0
24556	1466	80180	2004-11-16	2004-11-16 00:00:00	\N	\N	32020		\N	97646	0	396275006	80180		0
35196	2087	40481087	2004-10-12	2004-10-12 00:00:00	2004-10-19	2004-10-19 00:00:00	32020		\N	139050	0	444814009	40481087		0
35439	2100	40481087	1957-06-02	1957-06-02 00:00:00	1957-06-09	1957-06-09 00:00:00	32020		\N	139933	0	444814009	40481087		0
35561	2108	40481087	1946-12-07	1946-12-07 00:00:00	1946-12-21	1946-12-21 00:00:00	32020		\N	140372	0	444814009	40481087		0
25226	1505	4112343	1980-05-03	1980-05-03 00:00:00	1980-05-10	1980-05-10 00:00:00	32020		\N	100328	0	195662009	4112343		0
25362	1511	4166224	2010-04-15	2010-04-15 00:00:00	\N	\N	32020		\N	100936	0	47693006	4166224		0
36079	2138	40481087	1997-11-07	1997-11-07 00:00:00	1997-11-28	1997-11-28 00:00:00	32020		\N	142420	0	444814009	40481087		0
36228	2147	4112343	1989-10-03	1989-10-03 00:00:00	1989-10-13	1989-10-13 00:00:00	32020		\N	142944	0	195662009	4112343		0
36412	2155	80502	2007-04-25	2007-04-25 00:00:00	\N	\N	32020		\N	143622	0	64859006	80502		0
36569	2165	40481087	1987-02-28	1987-02-28 00:00:00	1987-03-14	1987-03-14 00:00:00	32020		\N	144223	0	444814009	40481087		0
36723	2173	372328	1934-11-14	1934-11-14 00:00:00	1935-06-18	1935-06-18 00:00:00	32020		\N	144873	0	65363002	372328		0
36902	2184	4266809	2002-12-23	2002-12-23 00:00:00	\N	\N	32020		\N	145529	0	397881000	4266809		0
26517	1571	28060	2003-02-12	2003-02-12 00:00:00	2003-02-22	2003-02-22 00:00:00	32020		\N	105511	0	43878008	28060		0
37214	2204	4156265	1965-08-11	1965-08-11 00:00:00	1965-08-25	1965-08-25 00:00:00	32020		\N	146878	0	370247008	4156265		0
37411	2218	4116491	2015-05-14	2015-05-14 00:00:00	2015-06-26	2015-06-26 00:00:00	32020		\N	147757	0	301011002	4116491		0
27046	1599	195588	2002-04-29	2002-04-29 00:00:00	2002-06-13	2002-06-13 00:00:00	32020		\N	107294	0	38822007	195588		0
27194	1606	40481087	1962-10-18	1962-10-18 00:00:00	1962-11-01	1962-11-01 00:00:00	32020		\N	107798	0	444814009	40481087		0
37871	2243	4112343	1993-01-25	1993-01-25 00:00:00	1993-02-07	1993-02-07 00:00:00	32020		\N	149374	0	195662009	4112343		0
38107	2261	81893	2000-07-23	2000-07-23 00:00:00	\N	\N	32020		\N	150271	0	64766004	81893		0
38232	2270	195588	2001-05-25	2001-05-25 00:00:00	2001-06-26	2001-06-26 00:00:00	32020		\N	150925	0	38822007	195588		0
38478	2286	372328	1957-11-01	1957-11-01 00:00:00	1957-12-09	1957-12-09 00:00:00	32020		\N	152061	0	65363002	372328		0
38612	2291	260139	2018-12-19	2018-12-19 00:00:00	2018-12-26	2018-12-26 00:00:00	32020		\N	152509	0	10509002	260139		0
38688	2295	4237458	2015-07-01	2015-07-01 00:00:00	2015-08-30	2015-08-30 00:00:00	32020		\N	152755	0	58150001	4237458		0
38889	2309	260139	1999-03-15	1999-03-15 00:00:00	1999-03-29	1999-03-29 00:00:00	32020		\N	153623	0	10509002	260139		0
39070	2320	4112343	1992-11-03	1992-11-03 00:00:00	1992-11-10	1992-11-10 00:00:00	32020		\N	154243	0	195662009	4112343		0
28687	1699	40481087	2016-07-16	2016-07-16 00:00:00	2016-07-23	2016-07-23 00:00:00	32020		\N	113661	0	444814009	40481087		0
39385	2334	4142905	1979-06-25	1979-06-25 00:00:00	1979-07-25	1979-07-25 00:00:00	32020		\N	155344	0	33737001	4142905		0
29035	1719	80502	2017-06-13	2017-06-13 00:00:00	\N	\N	32020		\N	114975	0	64859006	80502		0
39702	2351	4218389	1978-09-04	1978-09-04 00:00:00	1978-10-09	1978-10-09 00:00:00	32020		\N	156508	0	39848009	4218389		0
39849	2359	4112343	1955-09-06	1955-09-06 00:00:00	1955-09-15	1955-09-15 00:00:00	32020		\N	157246	0	195662009	4112343		0
29533	1748	40481087	1961-05-13	1961-05-13 00:00:00	1961-06-03	1961-06-03 00:00:00	32020		\N	116920	0	444814009	40481087		0
29701	1758	4112343	2017-01-16	2017-01-16 00:00:00	2017-01-27	2017-01-27 00:00:00	32020		\N	117519	0	195662009	4112343		0
29841	1764	4310024	1994-10-24	1994-10-24 00:00:00	\N	\N	32020		\N	117997	0	424802006	4310024		0
40541	2411	40481087	2011-09-14	2011-09-14 00:00:00	2011-10-05	2011-10-05 00:00:00	32020		\N	160001	0	444814009	40481087		0
40732	2423	40481087	1960-03-17	1960-03-17 00:00:00	1960-03-24	1960-03-24 00:00:00	32020		\N	160748	0	444814009	40481087		0
40882	2431	30753	2012-06-05	2012-06-05 00:00:00	\N	\N	32020		\N	161188	0	16761005	30753		0
41129	2444	4112343	1971-01-05	1971-01-05 00:00:00	1971-01-14	1971-01-14 00:00:00	32020		\N	162142	0	195662009	4112343		0
41194	2448	4112343	1964-08-16	1964-08-16 00:00:00	1964-08-23	1964-08-23 00:00:00	32020		\N	162388	0	195662009	4112343		0
41378	2461	40481087	2016-12-26	2016-12-26 00:00:00	2017-01-09	2017-01-09 00:00:00	32020		\N	163185	0	444814009	40481087		0
41520	2468	4112343	1941-09-23	1941-09-23 00:00:00	1941-10-05	1941-10-05 00:00:00	32020		\N	163662	0	195662009	4112343		0
41682	2480	260139	2010-09-09	2010-09-09 00:00:00	2010-09-23	2010-09-23 00:00:00	32020		\N	164345	0	10509002	260139		0
41929	2497	40481087	2008-01-14	2008-01-14 00:00:00	2008-02-04	2008-02-04 00:00:00	32020		\N	165352	0	444814009	40481087		0
42061	2504	40481087	1954-10-26	1954-10-26 00:00:00	1954-11-09	1954-11-09 00:00:00	32020		\N	165812	0	444814009	40481087		0
42270	2518	260139	1993-05-25	1993-05-25 00:00:00	1993-06-08	1993-06-08 00:00:00	32020		\N	166581	0	10509002	260139		0
42424	2528	4112343	1979-09-10	1979-09-10 00:00:00	1979-09-20	1979-09-20 00:00:00	32020		\N	167104	0	195662009	4112343		0
31945	1898	4109685	2011-08-25	2011-08-25 00:00:00	2011-09-15	2011-09-15 00:00:00	32020		\N	126340	0	284551006	4109685		0
42325	2521	381316	2006-03-20	2006-03-20 00:00:00	\N	\N	32020		\N	166783	0	230690007	381316		0
32128	1908	372328	1980-01-03	1980-01-03 00:00:00	1980-06-15	1980-06-15 00:00:00	32020		\N	126974	0	65363002	372328		0
32272	1917	4310024	1984-11-21	1984-11-21 00:00:00	\N	\N	32020		\N	127522	0	424802006	4310024		0
32438	1926	81893	2004-10-24	2004-10-24 00:00:00	\N	\N	32020		\N	128215	0	64766004	81893		0
22037	1318	4296204	2010-06-12	2010-06-12 00:00:00	2010-07-03	2010-07-03 00:00:00	32020		\N	87401	0	403190006	4296204		0
32783	1947	80502	2009-06-21	2009-06-21 00:00:00	\N	\N	32020		\N	129400	0	64859006	80502		0
32873	1951	4112343	1995-05-21	1995-05-21 00:00:00	1995-06-02	1995-06-02 00:00:00	32020		\N	129750	0	195662009	4112343		0
33069	1962	4112343	1985-02-10	1985-02-10 00:00:00	1985-02-17	1985-02-17 00:00:00	32020		\N	130489	0	195662009	4112343		0
33201	1971	40481087	2011-02-01	2011-02-01 00:00:00	2011-02-22	2011-02-22 00:00:00	32020		\N	131028	0	444814009	40481087		0
33415	1982	317576	1976-09-23	1976-09-23 00:00:00	\N	\N	32020		\N	132061	0	53741008	317576		0
33537	1989	260139	1984-04-14	1984-04-14 00:00:00	1984-04-21	1984-04-21 00:00:00	32020		\N	132445	0	10509002	260139		0
23213	1385	4112343	1975-09-27	1975-09-27 00:00:00	1975-10-05	1975-10-05 00:00:00	32020		\N	91835	0	195662009	4112343		0
33909	2013	4156265	1971-12-22	1971-12-22 00:00:00	1972-01-05	1972-01-05 00:00:00	32020		\N	134002	0	370247008	4156265		0
34085	2025	260139	2012-10-26	2012-10-26 00:00:00	2012-11-02	2012-11-02 00:00:00	32020		\N	134634	0	10509002	260139		0
34245	2033	40481087	1973-03-15	1973-03-15 00:00:00	1973-03-29	1973-03-29 00:00:00	32020		\N	135310	0	444814009	40481087		0
34444	2044	80180	1997-01-18	1997-01-18 00:00:00	\N	\N	32020		\N	135968	0	396275006	80180		0
24043	1435	40481087	1998-10-27	1998-10-27 00:00:00	1998-11-03	1998-11-03 00:00:00	32020		\N	95562	0	444814009	40481087		0
34821	2069	40481087	1981-03-17	1981-03-17 00:00:00	1981-03-31	1981-03-31 00:00:00	32020		\N	137601	0	444814009	40481087		0
34955	2076	4218389	2017-12-27	2017-12-27 00:00:00	2018-01-24	2018-01-24 00:00:00	32020		\N	138212	0	39848009	4218389		0
24557	1466	4112343	2008-11-24	2008-11-24 00:00:00	2008-12-02	2008-12-02 00:00:00	32020		\N	97612	0	195662009	4112343		0
35197	2087	4112343	1927-02-11	1927-02-11 00:00:00	1927-02-23	1927-02-23 00:00:00	32020		\N	139012	0	195662009	4112343		0
35440	2100	372328	1947-07-02	1947-07-02 00:00:00	1947-08-11	1947-08-11 00:00:00	32020		\N	140015	0	65363002	372328		0
35562	2108	40481087	2004-12-05	2004-12-05 00:00:00	2004-12-19	2004-12-19 00:00:00	32020		\N	140384	0	444814009	40481087		0
25227	1505	80180	1992-04-13	1992-04-13 00:00:00	\N	\N	32020		\N	100351	0	396275006	80180		0
25363	1511	40481087	1992-06-21	1992-06-21 00:00:00	1992-06-28	1992-06-28 00:00:00	32020		\N	100878	0	444814009	40481087		0
36080	2138	4134304	1966-09-07	1966-09-07 00:00:00	1966-11-06	1966-11-06 00:00:00	32020		\N	142412	0	263102004	4134304		0
36229	2147	260139	1958-03-01	1958-03-01 00:00:00	1958-03-08	1958-03-08 00:00:00	32020		\N	142924	0	10509002	260139		0
36413	2155	260139	2005-04-06	2005-04-06 00:00:00	2005-04-20	2005-04-20 00:00:00	32020		\N	143603	0	10509002	260139		0
36570	2165	81151	1962-04-20	1962-04-20 00:00:00	1962-05-11	1962-05-11 00:00:00	32020		\N	144275	0	44465007	81151		0
36724	2173	4283893	1966-05-07	1966-05-07 00:00:00	1966-07-16	1966-07-16 00:00:00	32020		\N	144841	0	36971009	4283893		0
36903	2184	80180	2002-12-23	2002-12-23 00:00:00	\N	\N	32020		\N	145529	0	396275006	80180		0
26518	1571	40481087	1981-05-27	1981-05-27 00:00:00	1981-06-03	1981-06-03 00:00:00	32020		\N	105483	0	444814009	40481087		0
37215	2204	40481087	1966-12-30	1966-12-30 00:00:00	1967-01-06	1967-01-06 00:00:00	32020		\N	146916	0	444814009	40481087		0
37412	2218	4109685	1986-09-08	1986-09-08 00:00:00	1986-09-29	1986-09-29 00:00:00	32020		\N	147707	0	284551006	4109685		0
27047	1600	80180	1978-01-12	1978-01-12 00:00:00	\N	\N	32020		\N	107394	0	396275006	80180		0
27195	1606	257012	2006-07-29	2006-07-29 00:00:00	\N	\N	32020		\N	107876	0	40055000	257012		0
37872	2243	260139	1980-06-11	1980-06-11 00:00:00	1980-06-25	1980-06-25 00:00:00	32020		\N	149311	0	10509002	260139		0
38108	2261	40481087	1999-06-16	1999-06-16 00:00:00	1999-06-30	1999-06-30 00:00:00	32020		\N	150271	0	444814009	40481087		0
38233	2270	40481087	1987-04-06	1987-04-06 00:00:00	1987-04-20	1987-04-20 00:00:00	32020		\N	150933	0	444814009	40481087		0
38479	2286	4112343	1972-04-17	1972-04-17 00:00:00	1972-04-28	1972-04-28 00:00:00	32020		\N	152076	0	195662009	4112343		0
38613	2291	4149245	1971-02-18	1971-02-18 00:00:00	1971-04-26	1971-04-26 00:00:00	32020		\N	152490	0	30832001	4149245		0
38689	2295	80180	2005-10-21	2005-10-21 00:00:00	\N	\N	32020		\N	152782	0	396275006	80180		0
38890	2309	78272	1987-03-31	1987-03-31 00:00:00	1987-04-28	1987-04-28 00:00:00	32020		\N	153632	0	70704007	78272		0
39071	2320	40481087	2004-11-02	2004-11-02 00:00:00	2004-11-16	2004-11-16 00:00:00	32020		\N	154257	0	444814009	40481087		0
28688	1699	4094814	2005-07-26	2005-07-26 00:00:00	2005-09-24	2005-09-24 00:00:00	32020		\N	113616	0	262574004	4094814		0
39386	2334	40481087	1956-02-26	1956-02-26 00:00:00	1956-03-04	1956-03-04 00:00:00	32020		\N	155325	0	444814009	40481087		0
29036	1719	4059173	2004-12-27	2004-12-27 00:00:00	2005-01-26	2005-01-26 00:00:00	32020		\N	114996	0	16114001	4059173		0
39703	2351	40481087	1970-11-18	1970-11-18 00:00:00	1970-12-02	1970-12-02 00:00:00	32020		\N	156501	0	444814009	40481087		0
39850	2359	4237458	1998-03-23	1998-03-23 00:00:00	1998-04-22	1998-04-22 00:00:00	32020		\N	157239	0	58150001	4237458		0
29534	1748	40481087	1993-10-03	1993-10-03 00:00:00	1993-10-17	1993-10-17 00:00:00	32020		\N	116923	0	444814009	40481087		0
29702	1758	81151	1988-06-07	1988-06-07 00:00:00	1988-07-12	1988-07-12 00:00:00	32020		\N	117557	0	44465007	81151		0
29842	1764	260139	1995-01-19	1995-01-19 00:00:00	1995-01-26	1995-01-26 00:00:00	32020		\N	117983	0	10509002	260139		0
40542	2411	260139	2014-11-09	2014-11-09 00:00:00	2014-11-16	2014-11-16 00:00:00	32020		\N	159989	0	10509002	260139		0
40733	2423	40481087	1978-06-20	1978-06-20 00:00:00	1978-07-04	1978-07-04 00:00:00	32020		\N	160791	0	444814009	40481087		0
40883	2431	4112343	1996-02-20	1996-02-20 00:00:00	1996-02-29	1996-02-29 00:00:00	32020		\N	161190	0	195662009	4112343		0
41130	2444	260139	1985-02-02	1985-02-02 00:00:00	1985-02-09	1985-02-09 00:00:00	32020		\N	162160	0	10509002	260139		0
41195	2448	40481087	1970-11-16	1970-11-16 00:00:00	1970-11-30	1970-11-30 00:00:00	32020		\N	162363	0	444814009	40481087		0
41379	2461	40481087	1979-03-03	1979-03-03 00:00:00	1979-03-17	1979-03-17 00:00:00	32020		\N	163175	0	444814009	40481087		0
41521	2468	260139	1959-01-09	1959-01-09 00:00:00	1959-01-23	1959-01-23 00:00:00	32020		\N	163602	0	10509002	260139		0
41683	2480	260139	1996-10-28	1996-10-28 00:00:00	1996-11-11	1996-11-11 00:00:00	32020		\N	164277	0	10509002	260139		0
41930	2497	80180	2006-06-06	2006-06-06 00:00:00	\N	\N	32020		\N	165351	0	396275006	80180		0
42062	2504	4218389	1968-01-11	1968-01-11 00:00:00	1968-02-08	1968-02-08 00:00:00	32020		\N	165852	0	39848009	4218389		0
42271	2518	4156265	1973-06-07	1973-06-07 00:00:00	1973-06-28	1973-06-28 00:00:00	32020		\N	166539	0	370247008	4156265		0
42425	2528	40481087	1975-09-17	1975-09-17 00:00:00	1975-10-01	1975-10-01 00:00:00	32020		\N	167127	0	444814009	40481087		0
31946	1898	372328	1973-11-21	1973-11-21 00:00:00	1974-05-13	1974-05-13 00:00:00	32020		\N	126400	0	65363002	372328		0
32129	1908	372328	1971-01-03	1971-01-03 00:00:00	1971-02-14	1971-02-14 00:00:00	32020		\N	126973	0	65363002	372328		0
32273	1917	28060	1984-03-01	1984-03-01 00:00:00	1984-03-10	1984-03-10 00:00:00	32020		\N	127522	0	43878008	28060		0
32439	1926	4310024	2004-02-27	2004-02-27 00:00:00	\N	\N	32020		\N	128215	0	424802006	4310024		0
22038	1318	40481087	2013-07-02	2013-07-02 00:00:00	2013-07-16	2013-07-16 00:00:00	32020		\N	87353	0	444814009	40481087		0
32784	1947	4294548	1987-03-20	1987-03-20 00:00:00	1987-10-09	1987-10-09 00:00:00	32020		\N	129436	0	75498004	4294548		0
32874	1951	40481087	1998-11-25	1998-11-25 00:00:00	1998-12-16	1998-12-16 00:00:00	32020		\N	129736	0	444814009	40481087		0
33070	1962	4113008	1992-09-20	1992-09-20 00:00:00	1992-10-04	1992-10-04 00:00:00	32020		\N	130479	0	284549007	4113008		0
33202	1971	4113008	1984-04-08	1984-04-08 00:00:00	1984-04-22	1984-04-22 00:00:00	32020		\N	131064	0	284549007	4113008		0
33416	1982	4112343	1983-06-10	1983-06-10 00:00:00	1983-06-18	1983-06-18 00:00:00	32020		\N	131993	0	195662009	4112343		0
33538	1989	80180	1986-07-26	1986-07-26 00:00:00	\N	\N	32020		\N	132445	0	396275006	80180		0
23214	1385	4112343	2006-11-20	2006-11-20 00:00:00	2006-12-01	2006-12-01 00:00:00	32020		\N	91813	0	195662009	4112343		0
33910	2013	4283893	1983-06-22	1983-06-22 00:00:00	1983-07-06	1983-07-06 00:00:00	32020		\N	133941	0	36971009	4283893		0
34086	2025	40481087	1942-12-29	1942-12-29 00:00:00	1943-01-19	1943-01-19 00:00:00	32020		\N	134750	0	444814009	40481087		0
34246	2033	40481087	1972-08-04	1972-08-04 00:00:00	1972-08-11	1972-08-11 00:00:00	32020		\N	135284	0	444814009	40481087		0
34445	2044	4285898	1996-10-20	1996-10-20 00:00:00	\N	\N	32020		\N	135968	0	68496003	4285898		0
24044	1435	28060	1975-11-17	1975-11-17 00:00:00	1975-11-24	1975-11-24 00:00:00	32020		\N	95574	0	43878008	28060		0
34822	2069	4112343	1991-01-27	1991-01-27 00:00:00	1991-02-05	1991-02-05 00:00:00	32020		\N	137569	0	195662009	4112343		0
34956	2076	40481087	2011-09-28	2011-09-28 00:00:00	2011-10-12	2011-10-12 00:00:00	32020		\N	138147	0	444814009	40481087		0
24558	1466	4112343	2013-08-12	2013-08-12 00:00:00	2013-08-22	2013-08-22 00:00:00	32020		\N	97650	0	195662009	4112343		0
35198	2087	40481087	2012-04-02	2012-04-02 00:00:00	2012-04-23	2012-04-23 00:00:00	32020		\N	139140	0	444814009	40481087		0
35441	2100	257012	1953-02-12	1953-02-12 00:00:00	1953-04-02	1953-04-02 00:00:00	32020		\N	139938	0	40055000	257012		0
35563	2108	4027663	1967-09-01	1967-09-01 00:00:00	\N	\N	32020		\N	140336	0	13200003	4027663		0
25228	1505	4112343	1996-03-21	1996-03-21 00:00:00	1996-03-31	1996-03-31 00:00:00	32020		\N	100353	0	195662009	4112343		0
25364	1511	4109685	1981-08-29	1981-08-29 00:00:00	1981-09-19	1981-09-19 00:00:00	32020		\N	100933	0	284551006	4109685		0
36081	2138	81151	2007-10-16	2007-10-16 00:00:00	2007-11-13	2007-11-13 00:00:00	32020		\N	142415	0	44465007	81151		0
36230	2147	4051466	1956-10-03	1956-10-03 00:00:00	1972-01-20	1972-01-20 00:00:00	32020		\N	142926	0	233678006	4051466		0
36414	2155	4134304	1996-01-11	1996-01-11 00:00:00	1996-02-10	1996-02-10 00:00:00	32020		\N	143617	0	263102004	4134304		0
36571	2165	4294548	2000-08-07	2000-08-07 00:00:00	2000-09-25	2000-09-25 00:00:00	32020		\N	144245	0	75498004	4294548		0
36725	2173	4152936	1960-03-02	1960-03-02 00:00:00	1960-03-23	1960-03-23 00:00:00	32020		\N	144889	0	283385000	4152936		0
36904	2184	81151	2019-05-30	2019-05-30 00:00:00	\N	\N	32020		\N	145593	0	44465007	81151		0
26519	1571	4112343	1991-07-04	1991-07-04 00:00:00	1991-07-11	1991-07-11 00:00:00	32020		\N	105500	0	195662009	4112343		0
37216	2204	4149245	1957-04-03	1957-04-03 00:00:00	1957-06-10	1957-06-10 00:00:00	32020		\N	146926	0	30832001	4149245		0
37413	2218	40481087	2013-09-10	2013-09-10 00:00:00	2013-09-24	2013-09-24 00:00:00	32020		\N	147734	0	444814009	40481087		0
27048	1600	4112343	1952-10-24	1952-10-24 00:00:00	1952-11-03	1952-11-03 00:00:00	32020		\N	107438	0	195662009	4112343		0
27196	1606	81151	1962-04-04	1962-04-04 00:00:00	1962-04-25	1962-04-25 00:00:00	32020		\N	107796	0	44465007	81151		0
37873	2243	40481087	2007-08-26	2007-08-26 00:00:00	2007-09-02	2007-09-02 00:00:00	32020		\N	149338	0	444814009	40481087		0
38109	2261	4027663	1992-10-28	1992-10-28 00:00:00	\N	\N	32020		\N	150325	0	13200003	4027663		0
38234	2270	40481087	2012-03-15	2012-03-15 00:00:00	2012-03-22	2012-03-22 00:00:00	32020		\N	150955	0	444814009	40481087		0
38480	2286	4112343	1980-10-17	1980-10-17 00:00:00	1980-10-26	1980-10-26 00:00:00	32020		\N	152025	0	195662009	4112343		0
38614	2292	40481087	1985-11-13	1985-11-13 00:00:00	1985-12-04	1985-12-04 00:00:00	32020		\N	152632	0	444814009	40481087		0
38690	2295	260139	2001-03-12	2001-03-12 00:00:00	2001-03-19	2001-03-19 00:00:00	32020		\N	152777	0	10509002	260139		0
38893	2311	372328	1964-06-07	1964-06-07 00:00:00	1964-10-10	1964-10-10 00:00:00	32020		\N	153746	0	65363002	372328		0
39072	2320	81893	1979-01-20	1979-01-20 00:00:00	\N	\N	32020		\N	154331	0	64766004	81893		0
28689	1699	260139	1995-02-05	1995-02-05 00:00:00	1995-02-20	1995-02-20 00:00:00	32020		\N	113621	0	10509002	260139		0
39387	2334	378419	2018-08-02	2018-08-02 00:00:00	\N	\N	32020		\N	155323	0	26929004	378419		0
29037	1719	40481087	1974-07-17	1974-07-17 00:00:00	1974-08-07	1974-08-07 00:00:00	32020		\N	114944	0	444814009	40481087		0
39704	2351	372328	1950-12-04	1950-12-04 00:00:00	1950-12-18	1950-12-18 00:00:00	32020		\N	156570	0	65363002	372328		0
39851	2359	4155034	2007-12-01	2007-12-01 00:00:00	2007-12-22	2007-12-22 00:00:00	32020		\N	157240	0	283371005	4155034		0
29535	1748	80180	1987-05-08	1987-05-08 00:00:00	\N	\N	32020		\N	116855	0	396275006	80180		0
29703	1758	4112343	1975-07-12	1975-07-12 00:00:00	1975-07-22	1975-07-22 00:00:00	32020		\N	117503	0	195662009	4112343		0
29843	1764	4027663	1985-08-27	1985-08-27 00:00:00	\N	\N	32020		\N	117981	0	13200003	4027663		0
40543	2411	4310024	1999-10-22	1999-10-22 00:00:00	\N	\N	32020		\N	160004	0	424802006	4310024		0
40734	2423	28060	1967-12-08	1967-12-08 00:00:00	1967-12-16	1967-12-16 00:00:00	32020		\N	160727	0	43878008	28060		0
40884	2431	40481087	1979-08-17	1979-08-17 00:00:00	1979-08-31	1979-08-31 00:00:00	32020		\N	161226	0	444814009	40481087		0
41131	2444	4112343	1988-04-04	1988-04-04 00:00:00	1988-04-17	1988-04-17 00:00:00	32020		\N	162161	0	195662009	4112343		0
41196	2448	260139	1981-08-24	1981-08-24 00:00:00	1981-08-31	1981-08-31 00:00:00	32020		\N	162390	0	10509002	260139		0
41380	2461	260139	1991-02-24	1991-02-24 00:00:00	1991-03-10	1991-03-10 00:00:00	32020		\N	163143	0	10509002	260139		0
41522	2468	40481087	1950-02-21	1950-02-21 00:00:00	1950-03-07	1950-03-07 00:00:00	32020		\N	163583	0	444814009	40481087		0
41684	2480	372328	1957-01-25	1957-01-25 00:00:00	1957-04-10	1957-04-10 00:00:00	32020		\N	164334	0	65363002	372328		0
41931	2497	40481087	2011-04-27	2011-04-27 00:00:00	2011-05-11	2011-05-11 00:00:00	32020		\N	165353	0	444814009	40481087		0
42063	2504	378001	2010-12-08	2010-12-08 00:00:00	2011-02-06	2011-02-06 00:00:00	32020		\N	165854	0	62106007	378001		0
42272	2518	40481087	2014-10-18	2014-10-18 00:00:00	2014-11-01	2014-11-01 00:00:00	32020		\N	166508	0	444814009	40481087		0
42426	2528	4035415	1974-09-15	1974-09-15 00:00:00	1974-10-15	1974-10-15 00:00:00	32020		\N	167130	0	239720000	4035415		0
31947	1898	257012	1982-09-04	1982-09-04 00:00:00	\N	\N	32020		\N	126380	0	40055000	257012		0
32130	1908	372328	1975-08-16	1975-08-16 00:00:00	1976-05-23	1976-05-23 00:00:00	32020		\N	126986	0	65363002	372328		0
32274	1917	40481087	1955-04-10	1955-04-10 00:00:00	1955-04-17	1955-04-17 00:00:00	32020		\N	127560	0	444814009	40481087		0
32440	1926	372328	1975-10-18	1975-10-18 00:00:00	1976-03-27	1976-03-27 00:00:00	32020		\N	128196	0	65363002	372328		0
22039	1318	40481087	1998-04-24	1998-04-24 00:00:00	1998-05-15	1998-05-15 00:00:00	32020		\N	87360	0	444814009	40481087		0
32785	1947	40481087	1969-11-27	1969-11-27 00:00:00	1969-12-18	1969-12-18 00:00:00	32020		\N	129426	0	444814009	40481087		0
32875	1951	372328	1987-02-25	1987-02-25 00:00:00	1987-04-29	1987-04-29 00:00:00	32020		\N	129726	0	65363002	372328		0
33071	1962	192671	1999-02-24	1999-02-24 00:00:00	\N	\N	32020		\N	130487	0	K92.2	35208414		0
33203	1971	40481087	1994-10-23	1994-10-23 00:00:00	1994-10-30	1994-10-30 00:00:00	32020		\N	131001	0	444814009	40481087		0
33417	1982	40481087	1928-08-13	1928-08-13 00:00:00	1928-08-27	1928-08-27 00:00:00	32020		\N	132012	0	444814009	40481087		0
33539	1989	4146173	1976-12-03	1976-12-03 00:00:00	1977-01-02	1977-01-02 00:00:00	32020		\N	132459	0	307731004	4146173		0
23215	1385	28060	1972-11-29	1972-11-29 00:00:00	1972-12-07	1972-12-07 00:00:00	32020		\N	91834	0	43878008	28060		0
33911	2013	4112343	2012-06-06	2012-06-06 00:00:00	2012-06-14	2012-06-14 00:00:00	32020		\N	133929	0	195662009	4112343		0
34087	2025	260139	1972-10-29	1972-10-29 00:00:00	1972-11-05	1972-11-05 00:00:00	32020		\N	134668	0	10509002	260139		0
34247	2033	40481087	1970-03-07	1970-03-07 00:00:00	1970-03-21	1970-03-21 00:00:00	32020		\N	135283	0	444814009	40481087		0
34446	2044	4266809	1997-01-18	1997-01-18 00:00:00	\N	\N	32020		\N	135968	0	397881000	4266809		0
24045	1435	260139	2008-11-20	2008-11-20 00:00:00	2008-11-27	2008-11-27 00:00:00	32020		\N	95549	0	10509002	260139		0
34823	2069	40481087	1995-03-22	1995-03-22 00:00:00	1995-04-06	1995-04-06 00:00:00	32020		\N	137578	0	444814009	40481087		0
34957	2076	260139	1987-12-09	1987-12-09 00:00:00	1987-12-16	1987-12-16 00:00:00	32020		\N	138199	0	10509002	260139		0
24559	1466	81893	2003-11-22	2003-11-22 00:00:00	\N	\N	32020		\N	97632	0	64766004	81893		0
35199	2087	40481087	1959-04-14	1959-04-14 00:00:00	1959-04-21	1959-04-21 00:00:00	32020		\N	139136	0	444814009	40481087		0
35442	2100	80180	1976-01-16	1976-01-16 00:00:00	\N	\N	32020		\N	139976	0	396275006	80180		0
35564	2108	40481087	1965-12-12	1965-12-12 00:00:00	1966-01-02	1966-01-02 00:00:00	32020		\N	140336	0	444814009	40481087		0
25229	1505	40481087	1994-10-10	1994-10-10 00:00:00	1994-10-24	1994-10-24 00:00:00	32020		\N	100315	0	444814009	40481087		0
25365	1511	40481087	2005-09-19	2005-09-19 00:00:00	2005-10-03	2005-10-03 00:00:00	32020		\N	100915	0	444814009	40481087		0
36082	2138	40481087	1982-06-30	1982-06-30 00:00:00	1982-07-21	1982-07-21 00:00:00	32020		\N	142385	0	444814009	40481087		0
36231	2147	260139	1984-12-24	1984-12-24 00:00:00	1985-01-07	1985-01-07 00:00:00	32020		\N	142942	0	10509002	260139		0
36415	2155	4112343	2006-05-29	2006-05-29 00:00:00	2006-06-10	2006-06-10 00:00:00	32020		\N	143604	0	195662009	4112343		0
36572	2165	257012	2010-10-06	2010-10-06 00:00:00	\N	\N	32020		\N	144196	0	40055000	257012		0
36726	2173	40481087	1982-06-03	1982-06-03 00:00:00	1982-06-17	1982-06-17 00:00:00	32020		\N	144868	0	444814009	40481087		0
36905	2184	260139	2012-05-19	2012-05-19 00:00:00	2012-06-02	2012-06-02 00:00:00	32020		\N	145583	0	10509002	260139		0
26520	1571	40481087	1982-03-06	1982-03-06 00:00:00	1982-03-27	1982-03-27 00:00:00	32020		\N	105484	0	444814009	40481087		0
37217	2204	4109685	1950-07-19	1950-07-19 00:00:00	1950-08-09	1950-08-09 00:00:00	32020		\N	146925	0	284551006	4109685		0
37414	2218	40481087	1997-05-18	1997-05-18 00:00:00	1997-05-25	1997-05-25 00:00:00	32020		\N	147703	0	444814009	40481087		0
27049	1600	4134304	1978-08-26	1978-08-26 00:00:00	1978-10-25	1978-10-25 00:00:00	32020		\N	107370	0	263102004	4134304		0
27197	1606	4266809	1989-05-12	1989-05-12 00:00:00	\N	\N	32020		\N	107837	0	397881000	4266809		0
37874	2243	4112343	2018-12-25	2018-12-25 00:00:00	2019-01-04	2019-01-04 00:00:00	32020		\N	149339	0	195662009	4112343		0
38110	2261	260139	1974-01-13	1974-01-13 00:00:00	1974-01-20	1974-01-20 00:00:00	32020		\N	150300	0	10509002	260139		0
38235	2270	40481087	1987-10-26	1987-10-26 00:00:00	1987-11-16	1987-11-16 00:00:00	32020		\N	150934	0	444814009	40481087		0
38481	2286	372328	1973-08-26	1973-08-26 00:00:00	1974-01-28	1974-01-28 00:00:00	32020		\N	152071	0	65363002	372328		0
38615	2292	78272	1988-08-03	1988-08-03 00:00:00	1988-08-31	1988-08-31 00:00:00	32020		\N	152635	0	70704007	78272		0
38691	2295	81151	1980-07-29	1980-07-29 00:00:00	1980-08-19	1980-08-19 00:00:00	32020		\N	152753	0	44465007	81151		0
38894	2311	4112343	2009-12-08	2009-12-08 00:00:00	2009-12-20	2009-12-20 00:00:00	32020		\N	153756	0	195662009	4112343		0
39073	2320	4310024	1978-12-21	1978-12-21 00:00:00	\N	\N	32020		\N	154331	0	424802006	4310024		0
28690	1699	260139	1991-06-20	1991-06-20 00:00:00	1991-07-04	1991-07-04 00:00:00	32020		\N	113647	0	10509002	260139		0
39388	2334	4109685	2005-06-13	2005-06-13 00:00:00	2005-06-27	2005-06-27 00:00:00	32020		\N	155346	0	284551006	4109685		0
29038	1719	4112343	1965-03-30	1965-03-30 00:00:00	1965-04-11	1965-04-11 00:00:00	32020		\N	114942	0	195662009	4112343		0
39705	2351	4112343	1982-10-09	1982-10-09 00:00:00	1982-10-17	1982-10-17 00:00:00	32020		\N	156586	0	195662009	4112343		0
39852	2359	260139	1941-01-31	1941-01-31 00:00:00	1941-02-14	1941-02-14 00:00:00	32020		\N	157275	0	10509002	260139		0
29536	1748	40481087	2011-09-05	2011-09-05 00:00:00	2011-09-19	2011-09-19 00:00:00	32020		\N	116859	0	444814009	40481087		0
29704	1758	81151	2000-01-11	2000-01-11 00:00:00	2000-02-15	2000-02-15 00:00:00	32020		\N	117558	0	44465007	81151		0
29844	1764	4218389	2000-09-09	2000-09-09 00:00:00	2000-10-14	2000-10-14 00:00:00	32020		\N	117991	0	39848009	4218389		0
40544	2411	4156265	1999-10-02	1999-10-02 00:00:00	1999-10-23	1999-10-23 00:00:00	32020		\N	160004	0	370247008	4156265		0
40735	2423	81151	1962-05-24	1962-05-24 00:00:00	1962-06-14	1962-06-14 00:00:00	32020		\N	160763	0	44465007	81151		0
40885	2431	372328	1989-09-20	1989-09-20 00:00:00	1990-09-19	1990-09-19 00:00:00	32020		\N	161232	0	65363002	372328		0
41132	2444	4218389	2007-12-23	2007-12-23 00:00:00	2008-01-20	2008-01-20 00:00:00	32020		\N	162156	0	39848009	4218389		0
41197	2448	4112343	2000-03-30	2000-03-30 00:00:00	2000-04-11	2000-04-11 00:00:00	32020		\N	162366	0	195662009	4112343		0
41381	2461	40481087	1993-08-21	1993-08-21 00:00:00	1993-08-28	1993-08-28 00:00:00	32020		\N	163144	0	444814009	40481087		0
41523	2468	28060	1970-07-07	1970-07-07 00:00:00	1970-07-15	1970-07-15 00:00:00	32020		\N	163586	0	43878008	28060		0
41685	2480	372328	1961-03-24	1961-03-24 00:00:00	1961-10-18	1961-10-18 00:00:00	32020		\N	164306	0	65363002	372328		0
41932	2497	260139	1971-06-20	1971-06-20 00:00:00	1971-06-27	1971-06-27 00:00:00	32020		\N	165329	0	10509002	260139		0
42064	2504	4112343	1971-05-06	1971-05-06 00:00:00	1971-05-14	1971-05-14 00:00:00	32020		\N	165774	0	195662009	4112343		0
42274	2518	321042	1986-08-08	1986-08-08 00:00:00	\N	\N	32020		\N	166542	0	410429000	321042		0
42427	2528	257012	1997-12-31	1997-12-31 00:00:00	\N	\N	32020		\N	167089	0	40055000	257012		0
31948	1898	4112343	1998-12-09	1998-12-09 00:00:00	1998-12-19	1998-12-19 00:00:00	32020		\N	126352	0	195662009	4112343		0
32131	1908	80180	2002-12-16	2002-12-16 00:00:00	\N	\N	32020		\N	127003	0	396275006	80180		0
32275	1917	28060	1959-06-27	1959-06-27 00:00:00	1959-07-07	1959-07-07 00:00:00	32020		\N	127561	0	43878008	28060		0
32441	1926	40481087	1986-01-17	1986-01-17 00:00:00	1986-01-24	1986-01-24 00:00:00	32020		\N	128194	0	444814009	40481087		0
22040	1318	440448	1953-03-05	1953-03-05 00:00:00	\N	\N	32020		\N	87399	0	74400008	440448		0
32786	1947	81151	1954-03-20	1954-03-20 00:00:00	1954-04-03	1954-04-03 00:00:00	32020		\N	129464	0	44465007	81151		0
32876	1951	40481087	2015-08-24	2015-08-24 00:00:00	2015-09-14	2015-09-14 00:00:00	32020		\N	129753	0	444814009	40481087		0
33072	1962	4112343	1966-10-28	1966-10-28 00:00:00	1966-11-04	1966-11-04 00:00:00	32020		\N	130455	0	195662009	4112343		0
33204	1971	4116491	1993-03-08	1993-03-08 00:00:00	1993-04-22	1993-04-22 00:00:00	32020		\N	131044	0	301011002	4116491		0
33418	1982	4152936	1983-10-02	1983-10-02 00:00:00	1983-10-23	1983-10-23 00:00:00	32020		\N	131976	0	283385000	4152936		0
33540	1989	4112343	1976-02-20	1976-02-20 00:00:00	1976-02-29	1976-02-29 00:00:00	32020		\N	132443	0	195662009	4112343		0
23216	1385	4112343	1983-11-24	1983-11-24 00:00:00	1983-12-05	1983-12-05 00:00:00	32020		\N	91819	0	195662009	4112343		0
33933	2016	4112343	2002-01-19	2002-01-19 00:00:00	2002-02-01	2002-02-01 00:00:00	32020		\N	134143	0	195662009	4112343		0
34088	2025	40481087	2002-05-30	2002-05-30 00:00:00	2002-06-13	2002-06-13 00:00:00	32020		\N	134695	0	444814009	40481087		0
34248	2033	4112343	1983-07-06	1983-07-06 00:00:00	1983-07-19	1983-07-19 00:00:00	32020		\N	135377	0	195662009	4112343		0
34447	2044	260139	1967-03-19	1967-03-19 00:00:00	1967-03-26	1967-03-26 00:00:00	32020		\N	136027	0	10509002	260139		0
24046	1435	80180	2002-09-26	2002-09-26 00:00:00	\N	\N	32020		\N	95585	0	396275006	80180		0
34824	2069	28060	1959-02-24	1959-02-24 00:00:00	1959-03-09	1959-03-09 00:00:00	32020		\N	137613	0	43878008	28060		0
34958	2076	4237458	1976-11-27	1976-11-27 00:00:00	1977-02-25	1977-02-25 00:00:00	32020		\N	138210	0	58150001	4237458		0
24560	1466	30753	2004-03-21	2004-03-21 00:00:00	\N	\N	32020		\N	97632	0	16761005	30753		0
35200	2087	260139	1955-09-07	1955-09-07 00:00:00	1955-09-21	1955-09-21 00:00:00	32020		\N	139029	0	10509002	260139		0
35443	2100	260139	2015-04-01	2015-04-01 00:00:00	2015-04-15	2015-04-15 00:00:00	32020		\N	140013	0	10509002	260139		0
35565	2108	4134304	1945-03-10	1945-03-10 00:00:00	1945-04-09	1945-04-09 00:00:00	32020		\N	140353	0	263102004	4134304		0
25230	1505	4283893	2014-01-17	2014-01-17 00:00:00	2014-03-07	2014-03-07 00:00:00	32020		\N	100386	0	36971009	4283893		0
40240	2387	4310024	2004-11-10	2004-11-10 00:00:00	\N	\N	32020		\N	158778	0	424802006	4310024		0
25366	1511	378001	1979-09-09	1979-09-09 00:00:00	1979-10-09	1979-10-09 00:00:00	32020		\N	100932	0	62106007	378001		0
36083	2138	440448	1976-10-06	1976-10-06 00:00:00	\N	\N	32020		\N	142413	0	74400008	440448		0
36232	2147	260139	1973-08-27	1973-08-27 00:00:00	1973-09-10	1973-09-10 00:00:00	32020		\N	143003	0	10509002	260139		0
36416	2155	4112343	1961-08-11	1961-08-11 00:00:00	1961-08-21	1961-08-21 00:00:00	32020		\N	143654	0	195662009	4112343		0
36573	2165	4112343	2010-10-31	2010-10-31 00:00:00	2010-11-10	2010-11-10 00:00:00	32020		\N	144211	0	195662009	4112343		0
36727	2173	80180	1975-02-17	1975-02-17 00:00:00	\N	\N	32020		\N	144842	0	396275006	80180		0
36906	2184	4051466	1970-02-21	1970-02-21 00:00:00	1986-05-28	1986-05-28 00:00:00	32020		\N	145531	0	233678006	4051466		0
26521	1571	40481087	2011-06-25	2011-06-25 00:00:00	2011-07-02	2011-07-02 00:00:00	32020		\N	105421	0	444814009	40481087		0
37218	2204	40481087	2016-05-13	2016-05-13 00:00:00	2016-06-03	2016-06-03 00:00:00	32020		\N	146921	0	444814009	40481087		0
37415	2218	4283893	1978-09-26	1978-09-26 00:00:00	1978-10-31	1978-10-31 00:00:00	32020		\N	147731	0	36971009	4283893		0
27050	1600	4283893	1981-10-12	1981-10-12 00:00:00	1981-11-09	1981-11-09 00:00:00	32020		\N	107436	0	36971009	4283893		0
27198	1606	80180	1989-05-12	1989-05-12 00:00:00	\N	\N	32020		\N	107837	0	396275006	80180		0
37875	2243	40481087	1996-03-07	1996-03-07 00:00:00	1996-03-14	1996-03-14 00:00:00	32020		\N	149312	0	444814009	40481087		0
38111	2261	4112343	1984-08-19	1984-08-19 00:00:00	1984-08-28	1984-08-28 00:00:00	32020		\N	150270	0	195662009	4112343		0
38236	2270	4112343	1996-04-12	1996-04-12 00:00:00	1996-04-22	1996-04-22 00:00:00	32020		\N	150953	0	195662009	4112343		0
38482	2286	81151	1967-03-14	1967-03-14 00:00:00	1967-04-11	1967-04-11 00:00:00	32020		\N	152090	0	44465007	81151		0
38616	2292	4112343	1997-03-19	1997-03-19 00:00:00	1997-03-31	1997-03-31 00:00:00	32020		\N	152567	0	195662009	4112343		0
38705	2297	40481087	1981-12-01	1981-12-01 00:00:00	1981-12-22	1981-12-22 00:00:00	32020		\N	152955	0	444814009	40481087		0
38895	2311	40481087	1978-09-25	1978-09-25 00:00:00	1978-10-02	1978-10-02 00:00:00	32020		\N	153754	0	444814009	40481087		0
39074	2320	80180	1980-01-15	1980-01-15 00:00:00	\N	\N	32020		\N	154331	0	396275006	80180		0
28691	1699	40481087	1992-08-14	1992-08-14 00:00:00	1992-08-28	1992-08-28 00:00:00	32020		\N	113648	0	444814009	40481087		0
39389	2334	260139	1942-09-26	1942-09-26 00:00:00	1942-10-10	1942-10-10 00:00:00	32020		\N	155313	0	10509002	260139		0
29039	1719	372328	1959-06-11	1959-06-11 00:00:00	1959-09-15	1959-09-15 00:00:00	32020		\N	114951	0	65363002	372328		0
39706	2351	4155034	1968-03-16	1968-03-16 00:00:00	1968-03-30	1968-03-30 00:00:00	32020		\N	156507	0	283371005	4155034		0
39853	2359	40481087	1933-06-23	1933-06-23 00:00:00	1933-07-07	1933-07-07 00:00:00	32020		\N	157244	0	444814009	40481087		0
29537	1748	4112343	1998-04-01	1998-04-01 00:00:00	1998-04-08	1998-04-08 00:00:00	32020		\N	116875	0	195662009	4112343		0
29705	1758	4116491	2008-08-07	2008-08-07 00:00:00	2008-09-11	2008-09-11 00:00:00	32020		\N	117547	0	301011002	4116491		0
29845	1764	260139	1981-09-24	1981-09-24 00:00:00	1981-10-08	1981-10-08 00:00:00	32020		\N	117980	0	10509002	260139		0
40545	2411	4285898	2001-03-15	2001-03-15 00:00:00	\N	\N	32020		\N	160004	0	68496003	4285898		0
40736	2423	40481087	1957-08-26	1957-08-26 00:00:00	1957-09-09	1957-09-09 00:00:00	32020		\N	160726	0	444814009	40481087		0
40886	2431	40481087	1986-04-02	1986-04-02 00:00:00	1986-04-16	1986-04-16 00:00:00	32020		\N	161227	0	444814009	40481087		0
41133	2444	40479422	1963-02-26	1963-02-26 00:00:00	1963-05-04	1963-05-04 00:00:00	32020		\N	162153	0	444448004	40479422		0
41198	2448	4266809	2000-05-22	2000-05-22 00:00:00	\N	\N	32020		\N	162366	0	397881000	4266809		0
41382	2461	4027663	1993-10-25	1993-10-25 00:00:00	\N	\N	32020		\N	163144	0	13200003	4027663		0
41524	2468	40481087	2003-09-09	2003-09-09 00:00:00	2003-09-30	2003-09-30 00:00:00	32020		\N	163598	0	444814009	40481087		0
41686	2480	372328	1964-05-05	1964-05-05 00:00:00	1964-11-04	1964-11-04 00:00:00	32020		\N	164335	0	65363002	372328		0
41933	2497	4310024	2004-06-16	2004-06-16 00:00:00	\N	\N	32020		\N	165310	0	424802006	4310024		0
42065	2504	40481087	1996-05-26	1996-05-26 00:00:00	1996-06-16	1996-06-16 00:00:00	32020		\N	165814	0	444814009	40481087		0
42275	2518	40481087	1994-08-13	1994-08-13 00:00:00	1994-09-03	1994-09-03 00:00:00	32020		\N	166531	0	444814009	40481087		0
42428	2528	40481087	1983-01-13	1983-01-13 00:00:00	1983-01-20	1983-01-20 00:00:00	32020		\N	167108	0	444814009	40481087		0
31949	1898	4112343	1981-09-24	1981-09-24 00:00:00	1981-10-03	1981-10-03 00:00:00	32020		\N	126351	0	195662009	4112343		0
32132	1908	4142905	1998-02-24	1998-02-24 00:00:00	1998-05-25	1998-05-25 00:00:00	32020		\N	126953	0	33737001	4142905		0
32276	1917	40481087	1999-09-17	1999-09-17 00:00:00	1999-10-01	1999-10-01 00:00:00	32020		\N	127528	0	444814009	40481087		0
32442	1926	372328	1973-11-14	1973-11-14 00:00:00	1974-03-16	1974-03-16 00:00:00	32020		\N	128246	0	65363002	372328		0
22041	1318	40481087	1954-09-26	1954-09-26 00:00:00	1954-10-17	1954-10-17 00:00:00	32020		\N	87341	0	444814009	40481087		0
32787	1947	40481087	1981-12-18	1981-12-18 00:00:00	1981-12-25	1981-12-25 00:00:00	32020		\N	129402	0	444814009	40481087		0
32877	1951	4218389	2012-01-22	2012-01-22 00:00:00	2012-02-26	2012-02-26 00:00:00	32020		\N	129772	0	39848009	4218389		0
33073	1962	81151	1998-04-06	1998-04-06 00:00:00	1998-05-04	1998-05-04 00:00:00	32020		\N	130480	0	44465007	81151		0
33205	1971	4112343	1996-02-17	1996-02-17 00:00:00	1996-02-26	1996-02-26 00:00:00	32020		\N	131002	0	195662009	4112343		0
33419	1982	4329847	2006-10-19	2006-10-19 00:00:00	\N	\N	32020		\N	131963	0	22298006	4329847		0
33541	1989	28060	1954-02-05	1954-02-05 00:00:00	1954-02-13	1954-02-13 00:00:00	32020		\N	132421	0	43878008	28060		0
23217	1385	372328	1962-07-02	1962-07-02 00:00:00	1962-10-19	1962-10-19 00:00:00	32020		\N	91821	0	65363002	372328		0
33934	2016	192671	2017-04-14	2017-04-14 00:00:00	\N	\N	32020		\N	134108	0	K92.2	35208414		0
34089	2025	4294548	1915-11-22	1915-11-22 00:00:00	1915-11-29	1915-11-29 00:00:00	32020		\N	134769	0	75498004	4294548		0
34249	2033	40481087	1975-08-23	1975-08-23 00:00:00	1975-09-06	1975-09-06 00:00:00	32020		\N	135332	0	444814009	40481087		0
34448	2044	28060	1978-04-20	1978-04-20 00:00:00	1978-05-02	1978-05-02 00:00:00	32020		\N	135976	0	43878008	28060		0
24047	1435	81151	2002-05-26	2002-05-26 00:00:00	2002-06-30	2002-06-30 00:00:00	32020		\N	95585	0	44465007	81151		0
34825	2069	260139	1977-12-26	1977-12-26 00:00:00	1978-01-02	1978-01-02 00:00:00	32020		\N	137616	0	10509002	260139		0
34959	2076	40481087	1976-03-31	1976-03-31 00:00:00	1976-04-07	1976-04-07 00:00:00	32020		\N	138190	0	444814009	40481087		0
24561	1466	40481087	1990-10-10	1990-10-10 00:00:00	1990-10-31	1990-10-31 00:00:00	32020		\N	97661	0	444814009	40481087		0
35201	2087	40481087	1990-05-13	1990-05-13 00:00:00	1990-05-27	1990-05-27 00:00:00	32020		\N	139089	0	444814009	40481087		0
35444	2100	40481087	1955-02-27	1955-02-27 00:00:00	1955-03-06	1955-03-06 00:00:00	32020		\N	139932	0	444814009	40481087		0
35566	2108	260139	2006-10-14	2006-10-14 00:00:00	2006-10-28	2006-10-28 00:00:00	32020		\N	140385	0	10509002	260139		0
25231	1505	81151	1968-04-19	1968-04-19 00:00:00	1968-05-24	1968-05-24 00:00:00	32020		\N	100381	0	44465007	81151		0
25367	1511	260139	2014-07-23	2014-07-23 00:00:00	2014-07-30	2014-07-30 00:00:00	32020		\N	100916	0	10509002	260139		0
36085	2138	260139	1999-12-27	1999-12-27 00:00:00	2000-01-03	2000-01-03 00:00:00	32020		\N	142378	0	10509002	260139		0
36233	2147	80180	1989-03-06	1989-03-06 00:00:00	\N	\N	32020		\N	142936	0	396275006	80180		0
36417	2155	4112343	2000-10-14	2000-10-14 00:00:00	2000-10-24	2000-10-24 00:00:00	32020		\N	143580	0	195662009	4112343		0
36574	2165	40481087	1963-09-17	1963-09-17 00:00:00	1963-09-24	1963-09-24 00:00:00	32020		\N	144241	0	444814009	40481087		0
36728	2173	40481087	1974-11-21	1974-11-21 00:00:00	1974-12-05	1974-12-05 00:00:00	32020		\N	144842	0	444814009	40481087		0
36907	2184	4027663	1995-02-08	1995-02-08 00:00:00	\N	\N	32020		\N	145553	0	13200003	4027663		0
26522	1571	40481087	1994-05-18	1994-05-18 00:00:00	1994-06-01	1994-06-01 00:00:00	32020		\N	105487	0	444814009	40481087		0
37219	2204	260139	1952-12-05	1952-12-05 00:00:00	1952-12-19	1952-12-19 00:00:00	32020		\N	146903	0	10509002	260139		0
37416	2218	378001	1993-12-21	1993-12-21 00:00:00	1994-01-20	1994-01-20 00:00:00	32020		\N	147709	0	62106007	378001		0
27051	1600	40481087	1973-06-26	1973-06-26 00:00:00	1973-07-03	1973-07-03 00:00:00	32020		\N	107412	0	444814009	40481087		0
27199	1606	40481087	1975-10-31	1975-10-31 00:00:00	1975-11-07	1975-11-07 00:00:00	32020		\N	107874	0	444814009	40481087		0
37876	2243	4112343	1967-08-16	1967-08-16 00:00:00	1967-08-28	1967-08-28 00:00:00	32020		\N	149372	0	195662009	4112343		0
38126	2264	372328	1972-06-15	1972-06-15 00:00:00	1972-10-15	1972-10-15 00:00:00	32020		\N	150447	0	65363002	372328		0
38237	2270	4112343	1979-05-30	1979-05-30 00:00:00	1979-06-09	1979-06-09 00:00:00	32020		\N	150981	0	195662009	4112343		0
38483	2286	40481087	1958-12-03	1958-12-03 00:00:00	1958-12-24	1958-12-24 00:00:00	32020		\N	152075	0	444814009	40481087		0
38617	2292	260139	1965-09-07	1965-09-07 00:00:00	1965-09-21	1965-09-21 00:00:00	32020		\N	152611	0	10509002	260139		0
38706	2297	4112343	2014-06-06	2014-06-06 00:00:00	2014-06-18	2014-06-18 00:00:00	32020		\N	152932	0	195662009	4112343		0
38896	2311	260139	1973-08-31	1973-08-31 00:00:00	1973-09-14	1973-09-14 00:00:00	32020		\N	153696	0	10509002	260139		0
39075	2320	4266809	1980-01-15	1980-01-15 00:00:00	\N	\N	32020		\N	154331	0	397881000	4266809		0
28692	1699	78272	1982-04-09	1982-04-09 00:00:00	1982-05-07	1982-05-07 00:00:00	32020		\N	113614	0	70704007	78272		0
39390	2334	40481087	2017-01-01	2017-01-01 00:00:00	2017-01-08	2017-01-08 00:00:00	32020		\N	155317	0	444814009	40481087		0
29040	1719	81151	1961-09-15	1961-09-15 00:00:00	1961-10-06	1961-10-06 00:00:00	32020		\N	114915	0	44465007	81151		0
39707	2351	4237458	1993-07-22	1993-07-22 00:00:00	1993-10-20	1993-10-20 00:00:00	32020		\N	156509	0	58150001	4237458		0
39854	2359	260139	1984-11-14	1984-11-14 00:00:00	1984-11-21	1984-11-21 00:00:00	32020		\N	157179	0	10509002	260139		0
29538	1748	40481087	2003-01-14	2003-01-14 00:00:00	2003-01-28	2003-01-28 00:00:00	32020		\N	116926	0	444814009	40481087		0
29706	1758	4112343	1973-11-12	1973-11-12 00:00:00	1973-11-23	1973-11-23 00:00:00	32020		\N	117543	0	195662009	4112343		0
29846	1764	4112343	2002-06-08	2002-06-08 00:00:00	2002-06-18	2002-06-18 00:00:00	32020		\N	117941	0	195662009	4112343		0
40546	2411	80180	2001-05-14	2001-05-14 00:00:00	\N	\N	32020		\N	160004	0	396275006	80180		0
40737	2423	4112343	2019-05-27	2019-05-27 00:00:00	2019-06-04	2019-06-04 00:00:00	32020		\N	160723	0	195662009	4112343		0
40887	2431	260139	1992-09-29	1992-09-29 00:00:00	1992-10-06	1992-10-06 00:00:00	32020		\N	161236	0	10509002	260139		0
41134	2444	40481087	1980-07-17	1980-07-17 00:00:00	1980-07-31	1980-07-31 00:00:00	32020		\N	162159	0	444814009	40481087		0
41199	2448	80180	2000-05-22	2000-05-22 00:00:00	\N	\N	32020		\N	162366	0	396275006	80180		0
41383	2461	4112343	1994-02-22	1994-02-22 00:00:00	1994-03-07	1994-03-07 00:00:00	32020		\N	163178	0	195662009	4112343		0
41525	2469	4266809	2008-08-06	2008-08-06 00:00:00	\N	\N	32020		\N	163716	0	397881000	4266809		0
41687	2480	378001	1980-01-09	1980-01-09 00:00:00	1980-02-08	1980-02-08 00:00:00	32020		\N	164318	0	62106007	378001		0
41934	2497	40481087	1963-08-30	1963-08-30 00:00:00	1963-09-06	1963-09-06 00:00:00	32020		\N	165338	0	444814009	40481087		0
42066	2504	78272	1968-12-04	1968-12-04 00:00:00	1968-12-18	1968-12-18 00:00:00	32020		\N	165853	0	70704007	78272		0
42301	2521	4112343	1986-01-02	1986-01-02 00:00:00	1986-01-12	1986-01-12 00:00:00	32020		\N	166715	0	195662009	4112343		0
42429	2528	4112343	2000-05-17	2000-05-17 00:00:00	2000-05-27	2000-05-27 00:00:00	32020		\N	167111	0	195662009	4112343		0
31950	1898	4112343	1987-02-06	1987-02-06 00:00:00	1987-02-19	1987-02-19 00:00:00	32020		\N	126384	0	195662009	4112343		0
32133	1908	40481087	2005-04-20	2005-04-20 00:00:00	2005-05-04	2005-05-04 00:00:00	32020		\N	126999	0	444814009	40481087		0
32277	1917	260139	1982-08-08	1982-08-08 00:00:00	1982-08-22	1982-08-22 00:00:00	32020		\N	127513	0	10509002	260139		0
32443	1926	4112343	1987-07-23	1987-07-23 00:00:00	1987-08-03	1987-08-03 00:00:00	32020		\N	128233	0	195662009	4112343		0
22042	1318	4218389	1949-05-07	1949-05-07 00:00:00	1949-06-11	1949-06-11 00:00:00	32020		\N	87398	0	39848009	4218389		0
32788	1947	372328	1952-12-25	1952-12-25 00:00:00	1953-06-28	1953-06-28 00:00:00	32020		\N	129439	0	65363002	372328		0
32878	1951	260139	2003-04-10	2003-04-10 00:00:00	2003-04-24	2003-04-24 00:00:00	32020		\N	129737	0	10509002	260139		0
33074	1962	40481087	2015-06-07	2015-06-07 00:00:00	2015-06-21	2015-06-21 00:00:00	32020		\N	130513	0	444814009	40481087		0
33206	1971	40481087	1991-12-19	1991-12-19 00:00:00	1992-01-02	1992-01-02 00:00:00	32020		\N	131079	0	444814009	40481087		0
33421	1982	4294548	1978-11-01	1978-11-01 00:00:00	1979-10-10	1979-10-10 00:00:00	32020		\N	131953	0	75498004	4294548		0
33542	1989	372328	1952-11-11	1952-11-11 00:00:00	1953-01-23	1953-01-23 00:00:00	32020		\N	132467	0	65363002	372328		0
23218	1385	4112343	1992-11-06	1992-11-06 00:00:00	1992-11-17	1992-11-17 00:00:00	32020		\N	91826	0	195662009	4112343		0
33935	2016	372328	1981-03-09	1981-03-09 00:00:00	1981-05-19	1981-05-19 00:00:00	32020		\N	134123	0	65363002	372328		0
34090	2025	4112343	1996-08-04	1996-08-04 00:00:00	1996-08-17	1996-08-17 00:00:00	32020		\N	134670	0	195662009	4112343		0
34250	2033	4112343	2011-04-14	2011-04-14 00:00:00	2011-04-24	2011-04-24 00:00:00	32020		\N	135338	0	195662009	4112343		0
34449	2044	40481087	1983-09-29	1983-09-29 00:00:00	1983-10-13	1983-10-13 00:00:00	32020		\N	136028	0	444814009	40481087		0
24048	1435	40481087	2010-09-03	2010-09-03 00:00:00	2010-09-24	2010-09-24 00:00:00	32020		\N	95550	0	444814009	40481087		0
34826	2069	4112343	1959-04-09	1959-04-09 00:00:00	1959-04-18	1959-04-18 00:00:00	32020		\N	137598	0	195662009	4112343		0
34960	2076	4285898	1999-09-12	1999-09-12 00:00:00	\N	\N	32020		\N	138201	0	68496003	4285898		0
24562	1466	40481087	2015-04-16	2015-04-16 00:00:00	2015-04-30	2015-04-30 00:00:00	32020		\N	97605	0	444814009	40481087		0
35202	2087	80180	1956-04-18	1956-04-18 00:00:00	\N	\N	32020		\N	139068	0	396275006	80180		0
35445	2100	372328	1944-08-01	1944-08-01 00:00:00	1944-11-13	1944-11-13 00:00:00	32020		\N	139961	0	65363002	372328		0
35567	2108	4112343	2015-12-04	2015-12-04 00:00:00	2015-12-12	2015-12-12 00:00:00	32020		\N	140316	0	195662009	4112343		0
25232	1505	4112343	1961-01-29	1961-01-29 00:00:00	1961-02-08	1961-02-08 00:00:00	32020		\N	100327	0	195662009	4112343		0
25368	1511	4112343	1972-04-01	1972-04-01 00:00:00	1972-04-13	1972-04-13 00:00:00	32020		\N	100887	0	195662009	4112343		0
36086	2138	372328	2002-02-14	2002-02-14 00:00:00	2004-01-18	2004-01-18 00:00:00	32020		\N	142380	0	65363002	372328		0
36247	2149	260139	1996-10-12	1996-10-12 00:00:00	1996-10-19	1996-10-19 00:00:00	32020		\N	143128	0	10509002	260139		0
36418	2155	260139	1999-02-02	1999-02-02 00:00:00	1999-02-16	1999-02-16 00:00:00	32020		\N	143578	0	10509002	260139		0
36575	2165	4112343	1995-10-05	1995-10-05 00:00:00	1995-10-16	1995-10-16 00:00:00	32020		\N	144227	0	195662009	4112343		0
36729	2173	40481087	1949-07-07	1949-07-07 00:00:00	1949-07-28	1949-07-28 00:00:00	32020		\N	144728	0	444814009	40481087		0
36908	2184	40481087	1994-10-26	1994-10-26 00:00:00	1994-11-02	1994-11-02 00:00:00	32020		\N	145553	0	444814009	40481087		0
26523	1571	192671	1998-08-27	1998-08-27 00:00:00	\N	\N	32020		\N	105541	0	K92.2	35208414		0
37220	2204	40481087	1977-11-02	1977-11-02 00:00:00	1977-11-16	1977-11-16 00:00:00	32020		\N	146932	0	444814009	40481087		0
37417	2218	80180	2011-08-03	2011-08-03 00:00:00	\N	\N	32020		\N	147718	0	396275006	80180		0
27052	1600	4218389	1952-02-23	1952-02-23 00:00:00	1952-03-15	1952-03-15 00:00:00	32020		\N	107368	0	39848009	4218389		0
27200	1606	4112343	2014-03-01	2014-03-01 00:00:00	2014-03-13	2014-03-13 00:00:00	32020		\N	107806	0	195662009	4112343		0
37878	2244	4112343	1987-01-21	1987-01-21 00:00:00	1987-02-02	1987-02-02 00:00:00	32020		\N	149405	0	195662009	4112343		0
38127	2264	4112343	2007-10-03	2007-10-03 00:00:00	2007-10-13	2007-10-13 00:00:00	32020		\N	150475	0	195662009	4112343		0
38238	2270	257012	1980-02-04	1980-02-04 00:00:00	\N	\N	32020		\N	150923	0	40055000	257012		0
38484	2286	28060	1998-01-28	1998-01-28 00:00:00	1998-02-06	1998-02-06 00:00:00	32020		\N	152068	0	43878008	28060		0
38618	2292	4152936	2007-02-05	2007-02-05 00:00:00	2007-02-19	2007-02-19 00:00:00	32020		\N	152638	0	283385000	4152936		0
38707	2297	372328	1976-10-20	1976-10-20 00:00:00	1977-02-10	1977-02-10 00:00:00	32020		\N	152934	0	65363002	372328		0
38897	2311	4112343	1971-09-17	1971-09-17 00:00:00	1971-09-30	1971-09-30 00:00:00	32020		\N	153742	0	195662009	4112343		0
39076	2320	40481087	1952-09-10	1952-09-10 00:00:00	1952-09-24	1952-09-24 00:00:00	32020		\N	154291	0	444814009	40481087		0
28693	1699	4027663	1996-03-26	1996-03-26 00:00:00	\N	\N	32020		\N	113649	0	13200003	4027663		0
39391	2334	4296205	1996-10-23	1996-10-23 00:00:00	1996-11-27	1996-11-27 00:00:00	32020		\N	155345	0	403191005	4296205		0
29041	1719	81151	2007-12-17	2007-12-17 00:00:00	2008-01-07	2008-01-07 00:00:00	32020		\N	115000	0	44465007	81151		0
39708	2351	40481087	2000-08-10	2000-08-10 00:00:00	2000-08-31	2000-08-31 00:00:00	32020		\N	156560	0	444814009	40481087		0
39855	2359	40481087	1955-10-22	1955-10-22 00:00:00	1955-11-05	1955-11-05 00:00:00	32020		\N	157269	0	444814009	40481087		0
29539	1748	4109685	1980-08-05	1980-08-05 00:00:00	1980-08-19	1980-08-19 00:00:00	32020		\N	116869	0	284551006	4109685		0
29707	1758	4112343	1974-03-24	1974-03-24 00:00:00	1974-04-02	1974-04-02 00:00:00	32020		\N	117544	0	195662009	4112343		0
29847	1764	257012	1974-06-15	1974-06-15 00:00:00	\N	\N	32020		\N	117938	0	40055000	257012		0
40547	2411	40481087	2005-01-25	2005-01-25 00:00:00	2005-02-08	2005-02-08 00:00:00	32020		\N	160000	0	444814009	40481087		0
40738	2423	40481087	1990-06-29	1990-06-29 00:00:00	1990-07-06	1990-07-06 00:00:00	32020		\N	160731	0	444814009	40481087		0
40888	2431	372328	1976-05-25	1976-05-25 00:00:00	1976-06-30	1976-06-30 00:00:00	32020		\N	161231	0	65363002	372328		0
41135	2444	4112343	1976-11-29	1976-11-29 00:00:00	1976-12-12	1976-12-12 00:00:00	32020		\N	162164	0	195662009	4112343		0
41200	2448	4283893	1990-07-19	1990-07-19 00:00:00	1990-09-06	1990-09-06 00:00:00	32020		\N	162355	0	36971009	4283893		0
41384	2461	40481087	1995-09-22	1995-09-22 00:00:00	1995-10-13	1995-10-13 00:00:00	32020		\N	163145	0	444814009	40481087		0
41526	2469	4112343	2007-07-04	2007-07-04 00:00:00	2007-07-12	2007-07-12 00:00:00	32020		\N	163716	0	195662009	4112343		0
41688	2480	257012	1996-07-01	1996-07-01 00:00:00	\N	\N	32020		\N	164276	0	40055000	257012		0
41935	2497	81893	2004-09-14	2004-09-14 00:00:00	\N	\N	32020		\N	165315	0	64766004	81893		0
42067	2504	80180	1989-12-31	1989-12-31 00:00:00	\N	\N	32020		\N	165847	0	396275006	80180		0
42302	2521	372328	1949-03-30	1949-03-30 00:00:00	1949-05-30	1949-05-30 00:00:00	32020		\N	166747	0	65363002	372328		0
42430	2528	260139	2011-03-28	2011-03-28 00:00:00	2011-04-11	2011-04-11 00:00:00	32020		\N	167121	0	10509002	260139		0
31951	1898	4059173	1996-05-15	1996-05-15 00:00:00	1996-06-14	1996-06-14 00:00:00	32020		\N	126339	0	16114001	4059173		0
32134	1908	260139	1989-10-27	1989-10-27 00:00:00	1989-11-03	1989-11-03 00:00:00	32020		\N	126956	0	10509002	260139		0
32278	1917	372328	1952-05-18	1952-05-18 00:00:00	1952-06-08	1952-06-08 00:00:00	32020		\N	127543	0	65363002	372328		0
32444	1926	260139	2016-01-11	2016-01-11 00:00:00	2016-01-18	2016-01-18 00:00:00	32020		\N	128245	0	10509002	260139		0
22043	1318	40481087	1940-08-28	1940-08-28 00:00:00	1940-09-04	1940-09-04 00:00:00	32020		\N	87334	0	444814009	40481087		0
32789	1947	4283893	1974-11-18	1974-11-18 00:00:00	1974-12-16	1974-12-16 00:00:00	32020		\N	129433	0	36971009	4283893		0
32879	1951	260139	1995-11-27	1995-11-27 00:00:00	1995-12-11	1995-12-11 00:00:00	32020		\N	129751	0	10509002	260139		0
33075	1962	4155034	1979-06-03	1979-06-03 00:00:00	1979-06-17	1979-06-17 00:00:00	32020		\N	130477	0	283371005	4155034		0
33207	1971	4112343	1980-03-03	1980-03-03 00:00:00	1980-03-13	1980-03-13 00:00:00	32020		\N	131084	0	195662009	4112343		0
33422	1982	372328	1927-06-25	1927-06-25 00:00:00	1927-08-11	1927-08-11 00:00:00	32020		\N	131996	0	65363002	372328		0
33543	1989	40481087	1987-01-01	1987-01-01 00:00:00	1987-01-08	1987-01-08 00:00:00	32020		\N	132408	0	444814009	40481087		0
23219	1385	4112343	1991-06-30	1991-06-30 00:00:00	1991-07-12	1991-07-12 00:00:00	32020		\N	91825	0	195662009	4112343		0
33936	2016	372328	1983-09-06	1983-09-06 00:00:00	1983-11-15	1983-11-15 00:00:00	32020		\N	134148	0	65363002	372328		0
34091	2025	260139	2012-04-21	2012-04-21 00:00:00	2012-04-28	2012-04-28 00:00:00	32020		\N	134725	0	10509002	260139		0
34251	2033	372328	1958-03-16	1958-03-16 00:00:00	1958-05-13	1958-05-13 00:00:00	32020		\N	135341	0	65363002	372328		0
34450	2044	40481087	2008-11-08	2008-11-08 00:00:00	2008-11-29	2008-11-29 00:00:00	32020		\N	135980	0	444814009	40481087		0
24049	1435	4112343	1997-01-29	1997-01-29 00:00:00	1997-02-05	1997-02-05 00:00:00	32020		\N	95561	0	195662009	4112343		0
34827	2069	40481087	1988-05-31	1988-05-31 00:00:00	1988-06-21	1988-06-21 00:00:00	32020		\N	137568	0	444814009	40481087		0
34961	2076	80180	1999-11-11	1999-11-11 00:00:00	\N	\N	32020		\N	138201	0	396275006	80180		0
24563	1466	40481087	1996-06-30	1996-06-30 00:00:00	1996-07-07	1996-07-07 00:00:00	32020		\N	97610	0	444814009	40481087		0
35203	2087	40481087	1941-09-15	1941-09-15 00:00:00	1941-09-22	1941-09-22 00:00:00	32020		\N	139134	0	444814009	40481087		0
35446	2100	4112343	1951-09-06	1951-09-06 00:00:00	1951-09-14	1951-09-14 00:00:00	32020		\N	139982	0	195662009	4112343		0
35568	2108	40481087	1945-12-23	1945-12-23 00:00:00	1946-01-06	1946-01-06 00:00:00	32020		\N	140333	0	444814009	40481087		0
35691	2115	372328	1975-09-12	1975-09-12 00:00:00	1975-11-17	1975-11-17 00:00:00	32020		\N	140761	0	65363002	372328		0
25369	1512	40481087	1998-04-21	1998-04-21 00:00:00	1998-04-28	1998-04-28 00:00:00	32020		\N	100961	0	444814009	40481087		0
36087	2138	260139	1994-09-16	1994-09-16 00:00:00	1994-09-23	1994-09-23 00:00:00	32020		\N	142377	0	10509002	260139		0
36248	2149	4112343	1998-11-12	1998-11-12 00:00:00	1998-11-23	1998-11-23 00:00:00	32020		\N	143061	0	195662009	4112343		0
36419	2155	381316	2006-02-08	2006-02-08 00:00:00	\N	\N	32020		\N	143621	0	230690007	381316		0
36576	2165	4112343	1982-10-18	1982-10-18 00:00:00	1982-10-25	1982-10-25 00:00:00	32020		\N	144222	0	195662009	4112343		0
36730	2173	28060	1998-09-09	1998-09-09 00:00:00	1998-09-20	1998-09-20 00:00:00	32020		\N	144872	0	43878008	28060		0
36909	2184	378001	1995-05-08	1995-05-08 00:00:00	1995-07-07	1995-07-07 00:00:00	32020		\N	145589	0	62106007	378001		0
26524	1571	4112343	1968-12-05	1968-12-05 00:00:00	1968-12-15	1968-12-15 00:00:00	32020		\N	105481	0	195662009	4112343		0
37221	2204	40481087	1979-07-16	1979-07-16 00:00:00	1979-07-23	1979-07-23 00:00:00	32020		\N	146933	0	444814009	40481087		0
37418	2218	4112343	1978-12-22	1978-12-22 00:00:00	1979-01-01	1979-01-01 00:00:00	32020		\N	147732	0	195662009	4112343		0
27053	1600	4112343	1967-08-04	1967-08-04 00:00:00	1967-08-15	1967-08-15 00:00:00	32020		\N	107409	0	195662009	4112343		0
27201	1606	28060	1958-04-01	1958-04-01 00:00:00	1958-04-11	1958-04-11 00:00:00	32020		\N	107844	0	43878008	28060		0
37879	2244	40481087	2014-03-18	2014-03-18 00:00:00	2014-04-08	2014-04-08 00:00:00	32020		\N	149393	0	444814009	40481087		0
38128	2264	40481087	1984-09-23	1984-09-23 00:00:00	1984-10-14	1984-10-14 00:00:00	32020		\N	150460	0	444814009	40481087		0
38239	2270	40481087	2000-02-07	2000-02-07 00:00:00	2000-02-21	2000-02-21 00:00:00	32020		\N	150920	0	444814009	40481087		0
38485	2286	372328	1959-03-04	1959-03-04 00:00:00	1959-08-10	1959-08-10 00:00:00	32020		\N	152062	0	65363002	372328		0
38619	2292	4278672	1964-12-09	1964-12-09 00:00:00	1965-02-07	1965-02-07 00:00:00	32020		\N	152594	0	65966004	4278672		0
38708	2297	4296204	2017-05-18	2017-05-18 00:00:00	2017-06-01	2017-06-01 00:00:00	32020		\N	152930	0	403190006	4296204		0
38898	2311	81151	2010-11-03	2010-11-03 00:00:00	2010-12-01	2010-12-01 00:00:00	32020		\N	153700	0	44465007	81151		0
39077	2320	4237458	1954-05-01	1954-05-01 00:00:00	1954-06-30	1954-06-30 00:00:00	32020		\N	154302	0	58150001	4237458		0
28694	1699	40481087	1998-06-10	1998-06-10 00:00:00	1998-07-01	1998-07-01 00:00:00	32020		\N	113652	0	444814009	40481087		0
39392	2334	81151	1951-06-10	1951-06-10 00:00:00	1951-06-24	1951-06-24 00:00:00	32020		\N	155340	0	44465007	81151		0
29042	1719	40481087	2001-06-05	2001-06-05 00:00:00	2001-06-12	2001-06-12 00:00:00	32020		\N	114902	0	444814009	40481087		0
39709	2351	28060	1959-07-22	1959-07-22 00:00:00	1959-07-30	1959-07-30 00:00:00	32020		\N	156514	0	43878008	28060		0
39856	2359	40481087	2000-05-03	2000-05-03 00:00:00	2000-05-24	2000-05-24 00:00:00	32020		\N	157217	0	444814009	40481087		0
29540	1748	260139	2012-03-06	2012-03-06 00:00:00	2012-03-20	2012-03-20 00:00:00	32020		\N	116860	0	10509002	260139		0
29708	1758	40481087	1987-03-26	1987-03-26 00:00:00	1987-04-02	1987-04-02 00:00:00	32020		\N	117569	0	444814009	40481087		0
29856	1766	4112343	2007-01-22	2007-01-22 00:00:00	2007-02-02	2007-02-02 00:00:00	32020		\N	118136	0	195662009	4112343		0
40548	2411	40481087	1967-09-22	1967-09-22 00:00:00	1967-10-06	1967-10-06 00:00:00	32020		\N	159987	0	444814009	40481087		0
40739	2423	40481087	1959-04-08	1959-04-08 00:00:00	1959-04-15	1959-04-15 00:00:00	32020		\N	160725	0	444814009	40481087		0
40889	2431	28060	1979-05-04	1979-05-04 00:00:00	1979-05-17	1979-05-17 00:00:00	32020		\N	161203	0	43878008	28060		0
41136	2444	40481087	2018-05-16	2018-05-16 00:00:00	2018-05-23	2018-05-23 00:00:00	32020		\N	162132	0	444814009	40481087		0
41201	2448	40481087	2011-10-04	2011-10-04 00:00:00	2011-10-11	2011-10-11 00:00:00	32020		\N	162367	0	444814009	40481087		0
41385	2461	40481087	1988-08-04	1988-08-04 00:00:00	1988-08-11	1988-08-11 00:00:00	32020		\N	163177	0	444814009	40481087		0
41527	2469	80180	2008-08-06	2008-08-06 00:00:00	\N	\N	32020		\N	163716	0	396275006	80180		0
41689	2480	40481087	1972-05-14	1972-05-14 00:00:00	1972-05-28	1972-05-28 00:00:00	32020		\N	164299	0	444814009	40481087		0
41936	2497	4134304	2004-06-28	2004-06-28 00:00:00	2004-09-26	2004-09-26 00:00:00	32020		\N	165315	0	263102004	4134304		0
42068	2504	372328	1966-09-18	1966-09-18 00:00:00	1966-11-21	1966-11-21 00:00:00	32020		\N	165816	0	65363002	372328		0
42303	2521	28060	2012-11-29	2012-11-29 00:00:00	2012-12-12	2012-12-12 00:00:00	32020		\N	166770	0	43878008	28060		0
42431	2528	260139	1977-05-03	1977-05-03 00:00:00	1977-05-17	1977-05-17 00:00:00	32020		\N	167129	0	10509002	260139		0
31952	1898	40481087	2019-01-05	2019-01-05 00:00:00	2019-01-12	2019-01-12 00:00:00	32020		\N	126388	0	444814009	40481087		0
32135	1908	4112343	2008-08-13	2008-08-13 00:00:00	2008-08-20	2008-08-20 00:00:00	32020		\N	126984	0	195662009	4112343		0
32279	1918	4112343	1986-09-30	1986-09-30 00:00:00	1986-10-13	1986-10-13 00:00:00	32020		\N	127650	0	195662009	4112343		0
32445	1926	4112343	1978-11-10	1978-11-10 00:00:00	1978-11-23	1978-11-23 00:00:00	32020		\N	128242	0	195662009	4112343		0
22044	1318	40481087	1998-01-24	1998-01-24 00:00:00	1998-02-14	1998-02-14 00:00:00	32020		\N	87336	0	444814009	40481087		0
32790	1947	28060	1956-06-17	1956-06-17 00:00:00	1956-06-25	1956-06-25 00:00:00	32020		\N	129432	0	43878008	28060		0
32880	1951	4278672	2015-04-11	2015-04-11 00:00:00	2015-07-10	2015-07-10 00:00:00	32020		\N	129773	0	65966004	4278672		0
33076	1962	4112343	1992-04-13	1992-04-13 00:00:00	1992-04-24	1992-04-24 00:00:00	32020		\N	130490	0	195662009	4112343		0
33208	1971	40481087	1996-12-25	1996-12-25 00:00:00	1997-01-08	1997-01-08 00:00:00	32020		\N	131027	0	444814009	40481087		0
33423	1982	78272	1987-05-05	1987-05-05 00:00:00	1987-06-09	1987-06-09 00:00:00	32020		\N	131959	0	70704007	78272		0
33544	1989	40481087	2008-11-14	2008-11-14 00:00:00	2008-12-05	2008-12-05 00:00:00	32020		\N	132460	0	444814009	40481087		0
23220	1385	260139	1965-08-17	1965-08-17 00:00:00	1965-08-31	1965-08-31 00:00:00	32020		\N	91817	0	10509002	260139		0
33937	2016	81151	2003-05-07	2003-05-07 00:00:00	2003-05-21	2003-05-21 00:00:00	32020		\N	134135	0	44465007	81151		0
34092	2025	378001	1995-04-08	1995-04-08 00:00:00	1995-05-08	1995-05-08 00:00:00	32020		\N	134744	0	62106007	378001		0
34252	2033	40481087	2000-02-01	2000-02-01 00:00:00	2000-02-15	2000-02-15 00:00:00	32020		\N	135370	0	444814009	40481087		0
34451	2044	40481087	1999-06-24	1999-06-24 00:00:00	1999-07-01	1999-07-01 00:00:00	32020		\N	135979	0	444814009	40481087		0
24050	1435	4283893	1964-05-11	1964-05-11 00:00:00	1964-06-22	1964-06-22 00:00:00	32020		\N	95557	0	36971009	4283893		0
34828	2069	80180	1988-09-01	1988-09-01 00:00:00	\N	\N	32020		\N	137568	0	396275006	80180		0
34962	2076	4266809	1999-11-11	1999-11-11 00:00:00	\N	\N	32020		\N	138201	0	397881000	4266809		0
24564	1466	4156265	1998-03-12	1998-03-12 00:00:00	1998-03-26	1998-03-26 00:00:00	32020		\N	97664	0	370247008	4156265		0
35204	2087	40481087	1926-02-09	1926-02-09 00:00:00	1926-03-02	1926-03-02 00:00:00	32020		\N	139132	0	444814009	40481087		0
35447	2100	40481087	1971-05-04	1971-05-04 00:00:00	1971-05-11	1971-05-11 00:00:00	32020		\N	139939	0	444814009	40481087		0
35569	2108	260139	1947-12-06	1947-12-06 00:00:00	1947-12-20	1947-12-20 00:00:00	32020		\N	140334	0	10509002	260139		0
35692	2115	4296204	1968-02-21	1968-02-21 00:00:00	1968-03-27	1968-03-27 00:00:00	32020		\N	140701	0	403190006	4296204		0
25370	1512	260139	1979-07-17	1979-07-17 00:00:00	1979-07-24	1979-07-24 00:00:00	32020		\N	100959	0	10509002	260139		0
36088	2138	4152936	2012-08-18	2012-08-18 00:00:00	2012-09-08	2012-09-08 00:00:00	32020		\N	142416	0	283385000	4152936		0
36249	2149	260139	2004-09-26	2004-09-26 00:00:00	2004-10-03	2004-10-03 00:00:00	32020		\N	143065	0	10509002	260139		0
36420	2155	40481087	1970-06-02	1970-06-02 00:00:00	1970-06-16	1970-06-16 00:00:00	32020		\N	143590	0	444814009	40481087		0
36577	2165	40479768	1989-09-16	1989-09-16 00:00:00	1989-10-23	1989-10-23 00:00:00	32020		\N	144206	0	444470001	40479768		0
36731	2173	40481087	1970-04-04	1970-04-04 00:00:00	1970-04-11	1970-04-11 00:00:00	32020		\N	144729	0	444814009	40481087		0
36910	2184	4296205	2004-03-21	2004-03-21 00:00:00	2004-04-18	2004-04-18 00:00:00	32020		\N	145590	0	403191005	4296205		0
26525	1571	80180	1998-08-05	1998-08-05 00:00:00	\N	\N	32020		\N	105452	0	396275006	80180		0
37222	2204	28060	1955-04-20	1955-04-20 00:00:00	1955-05-01	1955-05-01 00:00:00	32020		\N	146931	0	43878008	28060		0
37419	2218	260139	2005-06-02	2005-06-02 00:00:00	2005-06-09	2005-06-09 00:00:00	32020		\N	147705	0	10509002	260139		0
27054	1600	40481087	1958-11-06	1958-11-06 00:00:00	1958-11-13	1958-11-13 00:00:00	32020		\N	107439	0	444814009	40481087		0
27202	1606	260139	2011-04-13	2011-04-13 00:00:00	2011-04-20	2011-04-20 00:00:00	32020		\N	107877	0	10509002	260139		0
37880	2244	372328	1954-07-19	1954-07-19 00:00:00	1954-10-01	1954-10-01 00:00:00	32020		\N	149394	0	65363002	372328		0
38129	2264	40481087	2016-09-02	2016-09-02 00:00:00	2016-09-23	2016-09-23 00:00:00	32020		\N	150436	0	444814009	40481087		0
38240	2270	4294548	1979-12-31	1979-12-31 00:00:00	1980-04-14	1980-04-14 00:00:00	32020		\N	150982	0	75498004	4294548		0
38486	2286	4112343	2012-06-24	2012-06-24 00:00:00	2012-07-05	2012-07-05 00:00:00	32020		\N	152060	0	195662009	4112343		0
38620	2292	28060	1966-11-02	1966-11-02 00:00:00	1966-11-15	1966-11-15 00:00:00	32020		\N	152612	0	43878008	28060		0
38709	2297	40481087	1990-11-11	1990-11-11 00:00:00	1990-11-18	1990-11-18 00:00:00	32020		\N	152931	0	444814009	40481087		0
38899	2311	40481087	1965-09-08	1965-09-08 00:00:00	1965-09-15	1965-09-15 00:00:00	32020		\N	153695	0	444814009	40481087		0
39078	2320	260139	1955-08-11	1955-08-11 00:00:00	1955-08-25	1955-08-25 00:00:00	32020		\N	154278	0	10509002	260139		0
28695	1699	40481087	1996-11-14	1996-11-14 00:00:00	1996-11-28	1996-11-28 00:00:00	32020		\N	113671	0	444814009	40481087		0
39393	2334	4152936	1977-06-21	1977-06-21 00:00:00	1977-07-05	1977-07-05 00:00:00	32020		\N	155343	0	283385000	4152936		0
29043	1719	260139	1959-08-28	1959-08-28 00:00:00	1959-09-11	1959-09-11 00:00:00	32020		\N	114887	0	10509002	260139		0
39710	2351	40481087	1998-03-10	1998-03-10 00:00:00	1998-03-31	1998-03-31 00:00:00	32020		\N	156559	0	444814009	40481087		0
39857	2359	40481087	2003-03-15	2003-03-15 00:00:00	2003-03-29	2003-03-29 00:00:00	32020		\N	157181	0	444814009	40481087		0
29541	1748	40481087	1950-07-16	1950-07-16 00:00:00	1950-08-06	1950-08-06 00:00:00	32020		\N	116872	0	444814009	40481087		0
29709	1758	40481087	2016-03-18	2016-03-18 00:00:00	2016-04-08	2016-04-08 00:00:00	32020		\N	117549	0	444814009	40481087		0
29857	1766	40481087	2005-04-17	2005-04-17 00:00:00	2005-05-08	2005-05-08 00:00:00	32020		\N	118149	0	444814009	40481087		0
34286	2034	81893	1962-05-03	1962-05-03 00:00:00	\N	\N	32020		\N	135457	0	64766004	81893		0
40549	2411	4112343	2019-02-08	2019-02-08 00:00:00	2019-02-20	2019-02-20 00:00:00	32020		\N	159990	0	195662009	4112343		0
40740	2423	260139	1970-01-14	1970-01-14 00:00:00	1970-01-28	1970-01-28 00:00:00	32020		\N	160728	0	10509002	260139		0
40890	2431	4027663	2003-07-13	2003-07-13 00:00:00	\N	\N	32020		\N	161185	0	13200003	4027663		0
41137	2444	260139	2011-01-18	2011-01-18 00:00:00	2011-01-25	2011-01-25 00:00:00	32020		\N	162168	0	10509002	260139		0
41202	2448	440448	2003-07-07	2003-07-07 00:00:00	\N	\N	32020		\N	162352	0	74400008	440448		0
41386	2461	40481087	2013-01-17	2013-01-17 00:00:00	2013-01-24	2013-01-24 00:00:00	32020		\N	163184	0	444814009	40481087		0
41528	2469	4116491	1988-07-27	1988-07-27 00:00:00	1988-09-10	1988-09-10 00:00:00	32020		\N	163747	0	301011002	4116491		0
41690	2480	4112343	1998-05-05	1998-05-05 00:00:00	1998-05-13	1998-05-13 00:00:00	32020		\N	164303	0	195662009	4112343		0
41937	2497	260139	1988-08-23	1988-08-23 00:00:00	1988-08-30	1988-08-30 00:00:00	32020		\N	165319	0	10509002	260139		0
42069	2504	439777	1981-10-19	1981-10-19 00:00:00	\N	\N	32020		\N	165791	0	271737000	439777		0
42304	2521	80180	1983-12-31	1983-12-31 00:00:00	\N	\N	32020		\N	166763	0	396275006	80180		0
42432	2528	4283893	1997-12-03	1997-12-03 00:00:00	1998-04-15	1998-04-15 00:00:00	32020		\N	167110	0	36971009	4283893		0
31953	1898	40481087	2018-11-14	2018-11-14 00:00:00	2018-11-28	2018-11-28 00:00:00	32020		\N	126387	0	444814009	40481087		0
32136	1908	260139	1993-09-15	1993-09-15 00:00:00	1993-09-22	1993-09-22 00:00:00	32020		\N	126997	0	10509002	260139		0
32280	1918	260139	2002-05-25	2002-05-25 00:00:00	2002-06-01	2002-06-01 00:00:00	32020		\N	127651	0	10509002	260139		0
32446	1926	4294548	1995-07-25	1995-07-25 00:00:00	1995-08-01	1995-08-01 00:00:00	32020		\N	128254	0	75498004	4294548		0
22045	1318	40481087	2004-09-17	2004-09-17 00:00:00	2004-10-08	2004-10-08 00:00:00	32020		\N	87352	0	444814009	40481087		0
32791	1947	257012	1987-04-17	1987-04-17 00:00:00	\N	\N	32020		\N	129472	0	40055000	257012		0
32881	1951	40481087	1987-05-17	1987-05-17 00:00:00	1987-05-31	1987-05-31 00:00:00	32020		\N	129725	0	444814009	40481087		0
33077	1962	28060	2015-08-20	2015-08-20 00:00:00	2015-08-27	2015-08-27 00:00:00	32020		\N	130514	0	43878008	28060		0
33209	1971	260139	1993-07-04	1993-07-04 00:00:00	1993-07-11	1993-07-11 00:00:00	32020		\N	131000	0	10509002	260139		0
33424	1982	4283893	1981-08-06	1981-08-06 00:00:00	1981-10-22	1981-10-22 00:00:00	32020		\N	131956	0	36971009	4283893		0
33545	1989	378001	1953-01-10	1953-01-10 00:00:00	1953-02-09	1953-02-09 00:00:00	32020		\N	132393	0	62106007	378001		0
23221	1385	40481087	2002-10-31	2002-10-31 00:00:00	2002-11-14	2002-11-14 00:00:00	32020		\N	91839	0	444814009	40481087		0
33938	2016	40481087	2006-05-03	2006-05-03 00:00:00	2006-05-24	2006-05-24 00:00:00	32020		\N	134121	0	444814009	40481087		0
34093	2025	4059173	1979-09-01	1979-09-01 00:00:00	1979-10-31	1979-10-31 00:00:00	32020		\N	134742	0	16114001	4059173		0
34253	2033	81151	2006-11-29	2006-11-29 00:00:00	2006-12-27	2006-12-27 00:00:00	32020		\N	135299	0	44465007	81151		0
34452	2044	257012	1982-12-29	1982-12-29 00:00:00	\N	\N	32020		\N	135957	0	40055000	257012		0
24051	1435	4112343	2018-10-16	2018-10-16 00:00:00	2018-10-23	2018-10-23 00:00:00	32020		\N	95588	0	195662009	4112343		0
34829	2069	40481087	1972-03-14	1972-03-14 00:00:00	1972-03-28	1972-03-28 00:00:00	32020		\N	137599	0	444814009	40481087		0
34963	2076	81893	1998-10-17	1998-10-17 00:00:00	\N	\N	32020		\N	138201	0	64766004	81893		0
24565	1466	40481087	1997-02-08	1997-02-08 00:00:00	1997-03-01	1997-03-01 00:00:00	32020		\N	97622	0	444814009	40481087		0
35205	2087	381316	2011-06-15	2011-06-15 00:00:00	\N	\N	32020		\N	139063	0	230690007	381316		0
35448	2100	4112343	1951-11-17	1951-11-17 00:00:00	1951-11-25	1951-11-25 00:00:00	32020		\N	139937	0	195662009	4112343		0
35570	2108	4112343	1948-03-28	1948-03-28 00:00:00	1948-04-05	1948-04-05 00:00:00	32020		\N	140393	0	195662009	4112343		0
35693	2116	4156265	2006-10-25	2006-10-25 00:00:00	2006-11-08	2006-11-08 00:00:00	32020		\N	140840	0	370247008	4156265		0
25371	1512	40481087	2002-04-12	2002-04-12 00:00:00	2002-04-26	2002-04-26 00:00:00	32020		\N	101004	0	444814009	40481087		0
36089	2138	4146173	2009-11-02	2009-11-02 00:00:00	2010-01-01	2010-01-01 00:00:00	32020		\N	142379	0	307731004	4146173		0
36250	2149	4112343	1968-07-12	1968-07-12 00:00:00	1968-07-21	1968-07-21 00:00:00	32020		\N	143124	0	195662009	4112343		0
36421	2155	260139	2003-05-23	2003-05-23 00:00:00	2003-06-06	2003-06-06 00:00:00	32020		\N	143602	0	10509002	260139		0
36578	2165	260139	1968-11-24	1968-11-24 00:00:00	1968-12-01	1968-12-01 00:00:00	32020		\N	144220	0	10509002	260139		0
36732	2173	257012	1966-06-04	1966-06-04 00:00:00	\N	\N	32020		\N	144849	0	40055000	257012		0
36911	2185	4116491	1987-01-26	1987-01-26 00:00:00	1987-03-07	1987-03-07 00:00:00	32020		\N	145674	0	301011002	4116491		0
26526	1571	4084167	1966-01-06	1966-01-06 00:00:00	1966-01-06	1966-01-06 00:00:00	32020		\N	105505	0	241929008	4084167		0
37223	2204	4112343	1983-08-20	1983-08-20 00:00:00	1983-08-31	1983-08-31 00:00:00	32020		\N	146939	0	195662009	4112343		0
37420	2218	40481087	1997-11-29	1997-11-29 00:00:00	1997-12-13	1997-12-13 00:00:00	32020		\N	147756	0	444814009	40481087		0
27055	1600	40481087	1968-05-13	1968-05-13 00:00:00	1968-06-03	1968-06-03 00:00:00	32020		\N	107410	0	444814009	40481087		0
27203	1606	40481087	2002-11-04	2002-11-04 00:00:00	2002-11-25	2002-11-25 00:00:00	32020		\N	107804	0	444814009	40481087		0
37881	2244	28060	1956-09-07	1956-09-07 00:00:00	1956-09-15	1956-09-15 00:00:00	32020		\N	149389	0	43878008	28060		0
38130	2264	40481087	1984-04-28	1984-04-28 00:00:00	1984-05-19	1984-05-19 00:00:00	32020		\N	150459	0	444814009	40481087		0
38241	2270	4112343	2012-05-29	2012-05-29 00:00:00	2012-06-11	2012-06-11 00:00:00	32020		\N	150921	0	195662009	4112343		0
38487	2287	4278672	2014-01-22	2014-01-22 00:00:00	\N	\N	32020		\N	152153	0	65966004	4278672		0
38621	2292	4294548	1964-11-17	1964-11-17 00:00:00	1965-01-26	1965-01-26 00:00:00	32020		\N	152562	0	75498004	4294548		0
38710	2297	80180	2012-06-13	2012-06-13 00:00:00	\N	\N	32020		\N	152953	0	396275006	80180		0
38900	2311	40481087	1977-07-05	1977-07-05 00:00:00	1977-07-26	1977-07-26 00:00:00	32020		\N	153697	0	444814009	40481087		0
39079	2320	4156265	2017-12-10	2017-12-10 00:00:00	2017-12-31	2017-12-31 00:00:00	32020		\N	154304	0	370247008	4156265		0
28696	1699	4112343	1973-02-12	1973-02-12 00:00:00	1973-02-21	1973-02-21 00:00:00	32020		\N	113645	0	195662009	4112343		0
39394	2334	78272	1966-10-03	1966-10-03 00:00:00	1966-10-17	1966-10-17 00:00:00	32020		\N	155342	0	70704007	78272		0
29044	1719	4112343	1985-12-23	1985-12-23 00:00:00	1986-01-02	1986-01-02 00:00:00	32020		\N	114947	0	195662009	4112343		0
39711	2351	81151	2009-11-25	2009-11-25 00:00:00	2009-12-09	2009-12-09 00:00:00	32020		\N	156510	0	44465007	81151		0
39858	2359	80180	1965-01-30	1965-01-30 00:00:00	\N	\N	32020		\N	157257	0	396275006	80180		0
29542	1748	40481087	1997-05-06	1997-05-06 00:00:00	1997-05-20	1997-05-20 00:00:00	32020		\N	116925	0	444814009	40481087		0
29710	1758	40481087	1985-12-16	1985-12-16 00:00:00	1985-12-23	1985-12-23 00:00:00	32020		\N	117505	0	444814009	40481087		0
29858	1766	40481087	1970-02-10	1970-02-10 00:00:00	1970-03-03	1970-03-03 00:00:00	32020		\N	118176	0	444814009	40481087		0
40550	2411	4299128	1993-01-01	1993-01-01 00:00:00	1993-02-05	1993-02-05 00:00:00	32020		\N	160003	0	403192003	4299128		0
40741	2423	40481087	1971-06-04	1971-06-04 00:00:00	1971-06-25	1971-06-25 00:00:00	32020		\N	160720	0	444814009	40481087		0
40891	2431	4237458	1975-06-30	1975-06-30 00:00:00	1975-07-30	1975-07-30 00:00:00	32020		\N	161243	0	58150001	4237458		0
41138	2444	40481087	1959-09-24	1959-09-24 00:00:00	1959-10-08	1959-10-08 00:00:00	32020		\N	162101	0	444814009	40481087		0
41204	2448	4027663	1991-07-09	1991-07-09 00:00:00	\N	\N	32020		\N	162338	0	13200003	4027663		0
41387	2461	4112343	1984-04-23	1984-04-23 00:00:00	1984-05-03	1984-05-03 00:00:00	32020		\N	163181	0	195662009	4112343		0
41529	2469	372328	1971-10-30	1971-10-30 00:00:00	1972-01-09	1972-01-09 00:00:00	32020		\N	163736	0	65363002	372328		0
41691	2480	4112343	1967-07-03	1967-07-03 00:00:00	1967-07-13	1967-07-13 00:00:00	32020		\N	164297	0	195662009	4112343		0
41938	2497	40481087	2017-08-15	2017-08-15 00:00:00	2017-08-22	2017-08-22 00:00:00	32020		\N	165361	0	444814009	40481087		0
42070	2504	40481087	2015-10-28	2015-10-28 00:00:00	2015-11-04	2015-11-04 00:00:00	32020		\N	165805	0	444814009	40481087		0
42305	2521	4156265	1949-02-12	1949-02-12 00:00:00	1949-03-05	1949-03-05 00:00:00	32020		\N	166736	0	370247008	4156265		0
42433	2528	40481087	1977-04-01	1977-04-01 00:00:00	1977-04-08	1977-04-08 00:00:00	32020		\N	167128	0	444814009	40481087		0
31954	1898	40481087	2007-12-16	2007-12-16 00:00:00	2008-01-06	2008-01-06 00:00:00	32020		\N	126399	0	444814009	40481087		0
32155	1911	260139	1959-11-23	1959-11-23 00:00:00	1959-12-07	1959-12-07 00:00:00	32020		\N	127097	0	10509002	260139		0
32281	1918	372328	1969-10-04	1969-10-04 00:00:00	1969-10-18	1969-10-18 00:00:00	32020		\N	127620	0	65363002	372328		0
32447	1926	40481087	2008-04-29	2008-04-29 00:00:00	2008-05-06	2008-05-06 00:00:00	32020		\N	128237	0	444814009	40481087		0
22046	1318	260139	1944-05-13	1944-05-13 00:00:00	1944-05-27	1944-05-27 00:00:00	32020		\N	87338	0	10509002	260139		0
32792	1947	40481087	2011-09-04	2011-09-04 00:00:00	2011-09-18	2011-09-18 00:00:00	32020		\N	129438	0	444814009	40481087		0
32882	1951	4142905	1993-05-31	1993-05-31 00:00:00	1993-07-30	1993-07-30 00:00:00	32020		\N	129771	0	33737001	4142905		0
33078	1962	80180	1999-02-19	1999-02-19 00:00:00	\N	\N	32020		\N	130499	0	396275006	80180		0
33210	1971	81151	1981-08-08	1981-08-08 00:00:00	1981-08-22	1981-08-22 00:00:00	32020		\N	131063	0	44465007	81151		0
33425	1982	4112343	1996-07-18	1996-07-18 00:00:00	1996-07-27	1996-07-27 00:00:00	32020		\N	132036	0	195662009	4112343		0
33546	1989	40479422	1988-10-22	1988-10-22 00:00:00	1988-11-28	1988-11-28 00:00:00	32020		\N	132479	0	444448004	40479422		0
23222	1385	378001	1972-09-21	1972-09-21 00:00:00	1972-10-21	1972-10-21 00:00:00	32020		\N	91873	0	62106007	378001		0
33939	2016	4112343	2013-07-20	2013-07-20 00:00:00	2013-08-02	2013-08-02 00:00:00	32020		\N	134111	0	195662009	4112343		0
34094	2025	4155034	1965-01-12	1965-01-12 00:00:00	1965-01-26	1965-01-26 00:00:00	32020		\N	134739	0	283371005	4155034		0
34254	2033	80180	1995-02-25	1995-02-25 00:00:00	\N	\N	32020		\N	135277	0	396275006	80180		0
34453	2044	40481087	2018-07-19	2018-07-19 00:00:00	2018-08-09	2018-08-09 00:00:00	32020		\N	135972	0	444814009	40481087		0
24052	1435	40481087	1996-10-08	1996-10-08 00:00:00	1996-10-29	1996-10-29 00:00:00	32020		\N	95576	0	444814009	40481087		0
34830	2069	40481087	1952-02-26	1952-02-26 00:00:00	1952-03-04	1952-03-04 00:00:00	32020		\N	137577	0	444814009	40481087		0
34964	2076	260139	1997-12-23	1997-12-23 00:00:00	1998-01-06	1998-01-06 00:00:00	32020		\N	138201	0	10509002	260139		0
24566	1466	260139	2016-02-23	2016-02-23 00:00:00	2016-03-01	2016-03-01 00:00:00	32020		\N	97651	0	10509002	260139		0
35206	2087	40481087	2007-06-12	2007-06-12 00:00:00	2007-06-19	2007-06-19 00:00:00	32020		\N	139126	0	444814009	40481087		0
35449	2100	28060	1945-10-27	1945-10-27 00:00:00	1945-11-05	1945-11-05 00:00:00	32020		\N	139981	0	43878008	28060		0
35571	2108	4112343	1980-05-14	1980-05-14 00:00:00	1980-05-26	1980-05-26 00:00:00	32020		\N	140396	0	195662009	4112343		0
35694	2116	192671	1990-10-19	1990-10-19 00:00:00	\N	\N	32020		\N	140857	0	K92.2	35208414		0
25372	1512	257012	2014-03-09	2014-03-09 00:00:00	\N	\N	32020		\N	100955	0	40055000	257012		0
36090	2138	4027663	1979-10-04	1979-10-04 00:00:00	\N	\N	32020		\N	142404	0	13200003	4027663		0
36251	2149	4294548	1961-11-10	1961-11-10 00:00:00	1962-01-19	1962-01-19 00:00:00	32020		\N	143122	0	75498004	4294548		0
36422	2155	4112343	1986-01-02	1986-01-02 00:00:00	1986-01-14	1986-01-14 00:00:00	32020		\N	143656	0	195662009	4112343		0
36579	2165	80180	1991-09-15	1991-09-15 00:00:00	\N	\N	32020		\N	144208	0	396275006	80180		0
36733	2173	192671	1975-04-22	1975-04-22 00:00:00	\N	\N	32020		\N	144721	0	K92.2	35208414		0
36912	2185	260139	1983-11-12	1983-11-12 00:00:00	1983-11-19	1983-11-19 00:00:00	32020		\N	145683	0	10509002	260139		0
26527	1571	81151	2001-03-27	2001-03-27 00:00:00	2001-04-10	2001-04-10 00:00:00	32020		\N	105507	0	44465007	81151		0
37224	2204	4112343	1966-05-16	1966-05-16 00:00:00	1966-05-27	1966-05-27 00:00:00	32020		\N	146875	0	195662009	4112343		0
37421	2218	257012	1978-10-10	1978-10-10 00:00:00	\N	\N	32020		\N	147749	0	40055000	257012		0
27056	1600	40481087	1960-09-09	1960-09-09 00:00:00	1960-09-30	1960-09-30 00:00:00	32020		\N	107431	0	444814009	40481087		0
27204	1606	4285898	1988-08-15	1988-08-15 00:00:00	\N	\N	32020		\N	107849	0	68496003	4285898		0
37882	2244	40481087	2003-12-22	2003-12-22 00:00:00	2004-01-05	2004-01-05 00:00:00	32020		\N	149399	0	444814009	40481087		0
38131	2264	4112343	1975-04-26	1975-04-26 00:00:00	1975-05-09	1975-05-09 00:00:00	32020		\N	150458	0	195662009	4112343		0
38242	2270	260139	2016-04-12	2016-04-12 00:00:00	2016-04-26	2016-04-26 00:00:00	32020		\N	150922	0	10509002	260139		0
38488	2287	40481087	2002-08-17	2002-08-17 00:00:00	2002-09-07	2002-09-07 00:00:00	32020		\N	152121	0	444814009	40481087		0
38622	2292	4112343	2009-08-13	2009-08-13 00:00:00	2009-08-26	2009-08-26 00:00:00	32020		\N	152607	0	195662009	4112343		0
38711	2297	40481087	1998-03-19	1998-03-19 00:00:00	1998-03-26	1998-03-26 00:00:00	32020		\N	152918	0	444814009	40481087		0
38901	2311	40481087	2015-08-07	2015-08-07 00:00:00	2015-08-21	2015-08-21 00:00:00	32020		\N	153745	0	444814009	40481087		0
39080	2320	40481087	1962-08-10	1962-08-10 00:00:00	1962-08-24	1962-08-24 00:00:00	32020		\N	154292	0	444814009	40481087		0
28697	1699	4156265	2011-03-27	2011-03-27 00:00:00	2011-04-10	2011-04-10 00:00:00	32020		\N	113617	0	370247008	4156265		0
39395	2334	40481087	2005-09-02	2005-09-02 00:00:00	2005-09-23	2005-09-23 00:00:00	32020		\N	155350	0	444814009	40481087		0
29045	1719	4134304	1967-03-09	1967-03-09 00:00:00	1967-04-08	1967-04-08 00:00:00	32020		\N	114916	0	263102004	4134304		0
39712	2351	4112343	1959-01-07	1959-01-07 00:00:00	1959-01-20	1959-01-20 00:00:00	32020		\N	156513	0	195662009	4112343		0
39859	2359	28060	1983-04-13	1983-04-13 00:00:00	1983-04-26	1983-04-26 00:00:00	32020		\N	157178	0	43878008	28060		0
29543	1748	4146173	1995-06-09	1995-06-09 00:00:00	1995-08-08	1995-08-08 00:00:00	32020		\N	116924	0	307731004	4146173		0
29711	1758	40481087	1991-09-15	1991-09-15 00:00:00	1991-10-06	1991-10-06 00:00:00	32020		\N	117570	0	444814009	40481087		0
29859	1766	4146173	2015-05-25	2015-05-25 00:00:00	2015-07-24	2015-07-24 00:00:00	32020		\N	118126	0	307731004	4146173		0
40551	2411	372328	1967-07-01	1967-07-01 00:00:00	1967-12-07	1967-12-07 00:00:00	32020		\N	160014	0	65363002	372328		0
40742	2423	81151	1987-11-30	1987-11-30 00:00:00	1987-12-28	1987-12-28 00:00:00	32020		\N	160764	0	44465007	81151		0
40892	2431	40481087	2007-10-03	2007-10-03 00:00:00	2007-10-17	2007-10-17 00:00:00	32020		\N	161230	0	444814009	40481087		0
41139	2444	40481087	1991-07-17	1991-07-17 00:00:00	1991-07-31	1991-07-31 00:00:00	32020		\N	162144	0	444814009	40481087		0
41205	2448	439777	1991-07-09	1991-07-09 00:00:00	\N	\N	32020		\N	162338	0	271737000	439777		0
41388	2461	81151	1976-01-13	1976-01-13 00:00:00	1976-01-27	1976-01-27 00:00:00	32020		\N	163198	0	44465007	81151		0
41530	2469	378001	1986-04-19	1986-04-19 00:00:00	1986-05-19	1986-05-19 00:00:00	32020		\N	163712	0	62106007	378001		0
41692	2480	260139	1975-07-21	1975-07-21 00:00:00	1975-08-04	1975-08-04 00:00:00	32020		\N	164301	0	10509002	260139		0
41939	2497	4112343	2001-04-04	2001-04-04 00:00:00	2001-04-13	2001-04-13 00:00:00	32020		\N	165321	0	195662009	4112343		0
42089	2507	40481087	2009-07-02	2009-07-02 00:00:00	2009-07-09	2009-07-09 00:00:00	32020		\N	165951	0	444814009	40481087		0
42306	2521	4112343	1997-05-18	1997-05-18 00:00:00	1997-05-26	1997-05-26 00:00:00	32020		\N	166746	0	195662009	4112343		0
42434	2528	28060	1977-05-30	1977-05-30 00:00:00	1977-06-08	1977-06-08 00:00:00	32020		\N	167119	0	43878008	28060		0
31965	1900	40481087	1985-02-01	1985-02-01 00:00:00	1985-02-08	1985-02-08 00:00:00	32020		\N	126452	0	444814009	40481087		0
32156	1911	40481087	1962-03-24	1962-03-24 00:00:00	1962-04-14	1962-04-14 00:00:00	32020		\N	127099	0	444814009	40481087		0
32282	1918	4142905	1987-09-03	1987-09-03 00:00:00	1987-12-02	1987-12-02 00:00:00	32020		\N	127586	0	33737001	4142905		0
22047	1318	40481087	1991-02-09	1991-02-09 00:00:00	1991-02-23	1991-02-23 00:00:00	32020		\N	87371	0	444814009	40481087		0
32793	1947	4112343	2017-01-03	2017-01-03 00:00:00	2017-01-12	2017-01-12 00:00:00	32020		\N	129476	0	195662009	4112343		0
32883	1951	4112343	2009-07-20	2009-07-20 00:00:00	2009-07-27	2009-07-27 00:00:00	32020		\N	129760	0	195662009	4112343		0
33079	1962	40481087	1985-12-21	1985-12-21 00:00:00	1986-01-11	1986-01-11 00:00:00	32020		\N	130457	0	444814009	40481087		0
33211	1971	4112343	1985-12-16	1985-12-16 00:00:00	1985-12-24	1985-12-24 00:00:00	32020		\N	130988	0	195662009	4112343		0
33426	1982	260139	1996-07-15	1996-07-15 00:00:00	1996-07-24	1996-07-24 00:00:00	32020		\N	132036	0	10509002	260139		0
33547	1989	81151	1956-12-20	1956-12-20 00:00:00	1957-01-17	1957-01-17 00:00:00	32020		\N	132395	0	44465007	81151		0
23223	1385	4296205	1997-11-09	1997-11-09 00:00:00	1997-11-30	1997-11-30 00:00:00	32020		\N	91874	0	403191005	4296205		0
33940	2016	4146173	1986-07-11	1986-07-11 00:00:00	1986-09-09	1986-09-09 00:00:00	32020		\N	134109	0	307731004	4146173		0
34095	2025	378001	1966-02-20	1966-02-20 00:00:00	1966-04-21	1966-04-21 00:00:00	32020		\N	134740	0	62106007	378001		0
34255	2033	40481087	1972-01-18	1972-01-18 00:00:00	1972-02-01	1972-02-01 00:00:00	32020		\N	135374	0	444814009	40481087		0
34454	2044	4027663	1986-10-08	1986-10-08 00:00:00	\N	\N	32020		\N	135977	0	13200003	4027663		0
24053	1435	40481087	2015-03-07	2015-03-07 00:00:00	2015-03-21	2015-03-21 00:00:00	32020		\N	95600	0	444814009	40481087		0
34831	2069	4218389	1967-02-28	1967-02-28 00:00:00	1967-03-21	1967-03-21 00:00:00	32020		\N	137585	0	39848009	4218389		0
34965	2076	30753	1999-05-15	1999-05-15 00:00:00	\N	\N	32020		\N	138201	0	16761005	30753		0
24567	1467	40481087	1942-11-01	1942-11-01 00:00:00	1942-11-15	1942-11-15 00:00:00	32020		\N	97696	0	444814009	40481087		0
35207	2087	40481087	1988-02-01	1988-02-01 00:00:00	1988-02-15	1988-02-15 00:00:00	32020		\N	139008	0	444814009	40481087		0
35450	2100	40481087	1982-09-11	1982-09-11 00:00:00	1982-09-18	1982-09-18 00:00:00	32020		\N	139940	0	444814009	40481087		0
35572	2108	81893	1973-08-25	1973-08-25 00:00:00	\N	\N	32020		\N	140398	0	64766004	81893		0
35695	2116	40481087	2006-06-29	2006-06-29 00:00:00	2006-07-13	2006-07-13 00:00:00	32020		\N	140848	0	444814009	40481087		0
25373	1512	28060	1987-10-03	1987-10-03 00:00:00	1987-10-16	1987-10-16 00:00:00	32020		\N	100953	0	43878008	28060		0
36091	2138	40481087	1989-06-21	1989-06-21 00:00:00	1989-07-12	1989-07-12 00:00:00	32020		\N	142387	0	444814009	40481087		0
36252	2149	4112343	1963-12-24	1963-12-24 00:00:00	1964-01-01	1964-01-01 00:00:00	32020		\N	143072	0	195662009	4112343		0
36423	2155	40481087	2006-02-17	2006-02-17 00:00:00	2006-03-03	2006-03-03 00:00:00	32020		\N	143658	0	444814009	40481087		0
36580	2165	260139	2014-07-03	2014-07-03 00:00:00	2014-07-10	2014-07-10 00:00:00	32020		\N	144191	0	10509002	260139		0
36734	2173	4112343	1972-10-02	1972-10-02 00:00:00	1972-10-10	1972-10-10 00:00:00	32020		\N	144866	0	195662009	4112343		0
36913	2185	4112343	1965-09-23	1965-09-23 00:00:00	1965-10-05	1965-10-05 00:00:00	32020		\N	145655	0	195662009	4112343		0
26528	1571	40481087	2017-08-08	2017-08-08 00:00:00	2017-08-29	2017-08-29 00:00:00	32020		\N	105422	0	444814009	40481087		0
37225	2204	40481087	1964-04-18	1964-04-18 00:00:00	1964-05-10	1964-05-10 00:00:00	32020		\N	146914	0	444814009	40481087		0
37422	2218	40481087	1982-12-17	1982-12-17 00:00:00	1982-12-24	1982-12-24 00:00:00	32020		\N	147750	0	444814009	40481087		0
27057	1600	372328	1945-12-26	1945-12-26 00:00:00	1946-03-04	1946-03-04 00:00:00	32020		\N	107427	0	65363002	372328		0
27205	1606	30753	1988-01-18	1988-01-18 00:00:00	\N	\N	32020		\N	107849	0	16761005	30753		0
37883	2244	4152936	1993-01-16	1993-01-16 00:00:00	1993-02-06	1993-02-06 00:00:00	32020		\N	149384	0	283385000	4152936		0
38132	2264	372328	1972-03-26	1972-03-26 00:00:00	1972-04-16	1972-04-16 00:00:00	32020		\N	150437	0	65363002	372328		0
38243	2270	40481087	1989-01-16	1989-01-16 00:00:00	1989-01-30	1989-01-30 00:00:00	32020		\N	150918	0	444814009	40481087		0
38489	2287	4112343	2008-12-31	2008-12-31 00:00:00	2009-01-10	2009-01-10 00:00:00	32020		\N	152194	0	195662009	4112343		0
38623	2292	28060	1978-11-09	1978-11-09 00:00:00	1978-11-22	1978-11-22 00:00:00	32020		\N	152631	0	43878008	28060		0
38712	2297	40481087	2017-09-20	2017-09-20 00:00:00	2017-09-27	2017-09-27 00:00:00	32020		\N	152933	0	444814009	40481087		0
38902	2311	260139	1982-08-05	1982-08-05 00:00:00	1982-08-12	1982-08-12 00:00:00	32020		\N	153698	0	10509002	260139		0
39081	2320	40481087	1989-02-12	1989-02-12 00:00:00	1989-03-05	1989-03-05 00:00:00	32020		\N	154282	0	444814009	40481087		0
28698	1699	40481087	1998-04-29	1998-04-29 00:00:00	1998-05-06	1998-05-06 00:00:00	32020		\N	113651	0	444814009	40481087		0
39396	2334	372328	1936-02-29	1936-02-29 00:00:00	1936-05-07	1936-05-07 00:00:00	32020		\N	155318	0	65363002	372328		0
29046	1719	4218389	1991-03-08	1991-03-08 00:00:00	1991-04-05	1991-04-05 00:00:00	32020		\N	114918	0	39848009	4218389		0
39713	2351	4059173	1964-03-07	1964-03-07 00:00:00	1964-05-06	1964-05-06 00:00:00	32020		\N	156505	0	16114001	4059173		0
39860	2359	4283893	1938-07-20	1938-07-20 00:00:00	1938-08-31	1938-08-31 00:00:00	32020		\N	157274	0	36971009	4283893		0
29544	1748	40481087	2001-05-05	2001-05-05 00:00:00	2001-05-19	2001-05-19 00:00:00	32020		\N	116913	0	444814009	40481087		0
29712	1758	260139	2004-02-01	2004-02-01 00:00:00	2004-02-08	2004-02-08 00:00:00	32020		\N	117545	0	10509002	260139		0
29860	1766	40481087	2010-05-19	2010-05-19 00:00:00	2010-05-26	2010-05-26 00:00:00	32020		\N	118122	0	444814009	40481087		0
40552	2411	4112343	2008-02-12	2008-02-12 00:00:00	2008-02-21	2008-02-21 00:00:00	32020		\N	159988	0	195662009	4112343		0
40743	2423	4112343	1981-07-07	1981-07-07 00:00:00	1981-07-14	1981-07-14 00:00:00	32020		\N	160722	0	195662009	4112343		0
40898	2433	40481087	2019-02-28	2019-02-28 00:00:00	2019-03-14	2019-03-14 00:00:00	32020		\N	161329	0	444814009	40481087		0
41140	2444	40481087	1988-10-08	1988-10-08 00:00:00	1988-10-22	1988-10-22 00:00:00	32020		\N	162167	0	444814009	40481087		0
41206	2448	4116491	1998-07-07	1998-07-07 00:00:00	1998-08-21	1998-08-21 00:00:00	32020		\N	162392	0	301011002	4116491		0
41389	2461	4278672	2006-01-19	2006-01-19 00:00:00	2006-02-18	2006-02-18 00:00:00	32020		\N	163199	0	65966004	4278672		0
41531	2469	4027663	1998-07-25	1998-07-25 00:00:00	\N	\N	32020		\N	163704	0	13200003	4027663		0
41693	2480	40481087	1968-10-12	1968-10-12 00:00:00	1968-11-02	1968-11-02 00:00:00	32020		\N	164331	0	444814009	40481087		0
41940	2497	4152936	2012-06-16	2012-06-16 00:00:00	2012-07-07	2012-07-07 00:00:00	32020		\N	165317	0	283385000	4152936		0
42090	2507	260139	1992-05-22	1992-05-22 00:00:00	1992-06-05	1992-06-05 00:00:00	32020		\N	165948	0	10509002	260139		0
42307	2521	195588	1986-01-09	1986-01-09 00:00:00	1986-03-03	1986-03-03 00:00:00	32020		\N	166733	0	38822007	195588		0
42435	2528	260139	2010-07-30	2010-07-30 00:00:00	2010-08-13	2010-08-13 00:00:00	32020		\N	167120	0	10509002	260139		0
31966	1900	40481087	2011-04-08	2011-04-08 00:00:00	2011-04-15	2011-04-15 00:00:00	32020		\N	126478	0	444814009	40481087		0
32157	1911	40481087	1953-06-19	1953-06-19 00:00:00	1953-07-03	1953-07-03 00:00:00	32020		\N	127116	0	444814009	40481087		0
32283	1918	440086	1977-08-08	1977-08-08 00:00:00	1979-07-16	1979-07-16 00:00:00	32020		\N	127627	0	192127007	440086		0
32449	1926	4112343	1997-05-16	1997-05-16 00:00:00	1997-05-25	1997-05-25 00:00:00	32020		\N	128235	0	195662009	4112343		0
22048	1318	40481087	1939-06-09	1939-06-09 00:00:00	1939-06-30	1939-06-30 00:00:00	32020		\N	87343	0	444814009	40481087		0
32794	1947	4112343	1959-08-13	1959-08-13 00:00:00	1959-08-20	1959-08-20 00:00:00	32020		\N	129481	0	195662009	4112343		0
32884	1951	4296204	2018-01-25	2018-01-25 00:00:00	2018-03-01	2018-03-01 00:00:00	32020		\N	129774	0	403190006	4296204		0
33080	1962	28060	1972-08-05	1972-08-05 00:00:00	1972-08-14	1972-08-14 00:00:00	32020		\N	130456	0	43878008	28060		0
33212	1971	80180	2012-02-17	2012-02-17 00:00:00	\N	\N	32020		\N	131019	0	396275006	80180		0
33427	1982	28060	1954-01-14	1954-01-14 00:00:00	1954-01-27	1954-01-27 00:00:00	32020		\N	131950	0	43878008	28060		0
33548	1989	40481087	1992-04-16	1992-04-16 00:00:00	1992-05-07	1992-05-07 00:00:00	32020		\N	132409	0	444814009	40481087		0
23224	1385	28060	1970-07-21	1970-07-21 00:00:00	1970-07-31	1970-07-31 00:00:00	32020		\N	91864	0	43878008	28060		0
33941	2016	40481087	2000-02-05	2000-02-05 00:00:00	2000-02-26	2000-02-26 00:00:00	32020		\N	134110	0	444814009	40481087		0
34096	2025	260139	1926-06-22	1926-06-22 00:00:00	1926-06-29	1926-06-29 00:00:00	32020		\N	134748	0	10509002	260139		0
34256	2033	260139	2013-03-25	2013-03-25 00:00:00	2013-04-01	2013-04-01 00:00:00	32020		\N	135323	0	10509002	260139		0
34455	2044	4112343	1982-09-10	1982-09-10 00:00:00	1982-09-20	1982-09-20 00:00:00	32020		\N	135966	0	195662009	4112343		0
24054	1435	28060	1976-08-21	1976-08-21 00:00:00	1976-09-01	1976-09-01 00:00:00	32020		\N	95547	0	43878008	28060		0
34832	2069	260139	1963-06-22	1963-06-22 00:00:00	1963-07-06	1963-07-06 00:00:00	32020		\N	137614	0	10509002	260139		0
34966	2076	4112343	2009-09-29	2009-09-29 00:00:00	2009-10-12	2009-10-12 00:00:00	32020		\N	138146	0	195662009	4112343		0
24568	1467	440086	1942-03-24	1942-03-24 00:00:00	1943-06-01	1943-06-01 00:00:00	32020		\N	97694	0	192127007	440086		0
35208	2087	40481087	1999-09-12	1999-09-12 00:00:00	1999-10-03	1999-10-03 00:00:00	32020		\N	139090	0	444814009	40481087		0
35451	2100	260139	1954-07-12	1954-07-12 00:00:00	1954-07-19	1954-07-19 00:00:00	32020		\N	140033	0	10509002	260139		0
35573	2108	40481087	1973-03-31	1973-03-31 00:00:00	1973-04-14	1973-04-14 00:00:00	32020		\N	140398	0	444814009	40481087		0
35696	2116	4112343	1979-12-05	1979-12-05 00:00:00	1979-12-16	1979-12-16 00:00:00	32020		\N	140794	0	195662009	4112343		0
25374	1512	372328	1977-03-12	1977-03-12 00:00:00	1977-05-18	1977-05-18 00:00:00	32020		\N	100943	0	65363002	372328		0
36092	2138	80180	1990-04-24	1990-04-24 00:00:00	\N	\N	32020		\N	142387	0	396275006	80180		0
36253	2149	81151	1972-10-27	1972-10-27 00:00:00	1972-12-01	1972-12-01 00:00:00	32020		\N	143076	0	44465007	81151		0
36424	2155	40481087	1994-05-17	1994-05-17 00:00:00	1994-05-24	1994-05-24 00:00:00	32020		\N	143601	0	444814009	40481087		0
36581	2165	4237458	2003-01-13	2003-01-13 00:00:00	2003-02-12	2003-02-12 00:00:00	32020		\N	144207	0	58150001	4237458		0
36735	2173	81893	1973-11-24	1973-11-24 00:00:00	\N	\N	32020		\N	144866	0	64766004	81893		0
36914	2185	195588	1990-03-06	1990-03-06 00:00:00	1990-04-10	1990-04-10 00:00:00	32020		\N	145696	0	38822007	195588		0
26529	1571	40481087	2003-03-20	2003-03-20 00:00:00	2003-04-03	2003-04-03 00:00:00	32020		\N	105462	0	444814009	40481087		0
37226	2204	40481087	1985-08-28	1985-08-28 00:00:00	1985-09-04	1985-09-04 00:00:00	32020		\N	146940	0	444814009	40481087		0
37423	2218	372328	1980-12-08	1980-12-08 00:00:00	1981-04-28	1981-04-28 00:00:00	32020		\N	147753	0	65363002	372328		0
27058	1600	195588	1984-11-16	1984-11-16 00:00:00	1984-12-27	1984-12-27 00:00:00	32020		\N	107437	0	38822007	195588		0
27206	1606	81893	1987-10-20	1987-10-20 00:00:00	\N	\N	32020		\N	107849	0	64766004	81893		0
37884	2244	260139	1962-02-08	1962-02-08 00:00:00	1962-02-22	1962-02-22 00:00:00	32020		\N	149378	0	10509002	260139		0
38133	2264	40481087	1997-09-14	1997-09-14 00:00:00	1997-09-21	1997-09-21 00:00:00	32020		\N	150434	0	444814009	40481087		0
38244	2270	80180	2019-03-12	2019-03-12 00:00:00	\N	\N	32020		\N	150980	0	396275006	80180		0
38490	2287	378419	2013-07-12	2013-07-12 00:00:00	\N	\N	32020		\N	152192	0	26929004	378419		0
38624	2292	4152936	2005-02-24	2005-02-24 00:00:00	2005-03-17	2005-03-17 00:00:00	32020		\N	152637	0	283385000	4152936		0
38713	2297	40481087	1987-02-01	1987-02-01 00:00:00	1987-02-22	1987-02-22 00:00:00	32020		\N	152962	0	444814009	40481087		0
38903	2311	260139	1963-03-25	1963-03-25 00:00:00	1963-04-08	1963-04-08 00:00:00	32020		\N	153717	0	10509002	260139		0
39082	2320	4112343	1950-02-18	1950-02-18 00:00:00	1950-03-02	1950-03-02 00:00:00	32020		\N	154314	0	195662009	4112343		0
28699	1699	40481087	2000-12-23	2000-12-23 00:00:00	2000-12-30	2000-12-30 00:00:00	32020		\N	113650	0	444814009	40481087		0
39397	2334	40481087	1983-06-18	1983-06-18 00:00:00	1983-07-02	1983-07-02 00:00:00	32020		\N	155348	0	444814009	40481087		0
29047	1719	260139	1973-03-18	1973-03-18 00:00:00	1973-03-25	1973-03-25 00:00:00	32020		\N	114921	0	10509002	260139		0
39714	2351	378419	2018-06-02	2018-06-02 00:00:00	\N	\N	32020		\N	156493	0	26929004	378419		0
39861	2359	4112343	2017-03-28	2017-03-28 00:00:00	2017-04-10	2017-04-10 00:00:00	32020		\N	157272	0	195662009	4112343		0
29545	1748	260139	1975-02-28	1975-02-28 00:00:00	1975-03-07	1975-03-07 00:00:00	32020		\N	116922	0	10509002	260139		0
29713	1758	28060	1974-11-02	1974-11-02 00:00:00	1974-11-13	1974-11-13 00:00:00	32020		\N	117504	0	43878008	28060		0
29861	1766	261325	1981-01-06	1981-01-06 00:00:00	\N	\N	32020		\N	118180	0	87433001	261325		0
40553	2411	4027663	1994-06-25	1994-06-25 00:00:00	\N	\N	32020		\N	159991	0	13200003	4027663		0
40744	2423	80502	2016-12-19	2016-12-19 00:00:00	\N	\N	32020		\N	160790	0	64859006	80502		0
40899	2433	4218389	1981-06-04	1981-06-04 00:00:00	1981-07-02	1981-07-02 00:00:00	32020		\N	161344	0	39848009	4218389		0
41141	2445	40479422	1979-09-17	1979-09-17 00:00:00	1979-11-23	1979-11-23 00:00:00	32020		\N	162234	0	444448004	40479422		0
41207	2448	81893	1998-09-30	1998-09-30 00:00:00	\N	\N	32020		\N	162392	0	64766004	81893		0
41390	2461	80180	2003-03-07	2003-03-07 00:00:00	\N	\N	32020		\N	163147	0	396275006	80180		0
41532	2469	81151	1981-09-07	1981-09-07 00:00:00	1981-10-12	1981-10-12 00:00:00	32020		\N	163711	0	44465007	81151		0
41694	2480	40481087	1986-06-18	1986-06-18 00:00:00	1986-06-25	1986-06-25 00:00:00	32020		\N	164332	0	444814009	40481087		0
41941	2497	260139	1983-09-24	1983-09-24 00:00:00	1983-10-08	1983-10-08 00:00:00	32020		\N	165350	0	10509002	260139		0
42091	2507	4283893	2005-09-09	2005-09-09 00:00:00	2006-04-21	2006-04-21 00:00:00	32020		\N	165965	0	36971009	4283893		0
42308	2521	4112343	1959-10-30	1959-10-30 00:00:00	1959-11-09	1959-11-09 00:00:00	32020		\N	166758	0	195662009	4112343		0
42436	2528	80180	2007-08-03	2007-08-03 00:00:00	\N	\N	32020		\N	167154	0	396275006	80180		0
31967	1900	28060	2012-03-12	2012-03-12 00:00:00	2012-03-23	2012-03-23 00:00:00	32020		\N	126460	0	43878008	28060		0
32158	1911	372328	1950-05-17	1950-05-17 00:00:00	1950-11-06	1950-11-06 00:00:00	32020		\N	127183	0	65363002	372328		0
32284	1918	4112343	2005-05-23	2005-05-23 00:00:00	2005-06-01	2005-06-01 00:00:00	32020		\N	127594	0	195662009	4112343		0
32450	1926	40481087	1980-03-26	1980-03-26 00:00:00	1980-04-16	1980-04-16 00:00:00	32020		\N	128243	0	444814009	40481087		0
22049	1318	260139	1997-10-24	1997-10-24 00:00:00	1997-11-07	1997-11-07 00:00:00	32020		\N	87345	0	10509002	260139		0
32795	1947	4116491	1976-10-10	1976-10-10 00:00:00	1976-11-11	1976-11-11 00:00:00	32020		\N	129428	0	301011002	4116491		0
32885	1951	4112343	2014-05-03	2014-05-03 00:00:00	2014-05-10	2014-05-10 00:00:00	32020		\N	129761	0	195662009	4112343		0
33081	1962	4112343	1967-10-04	1967-10-04 00:00:00	1967-10-16	1967-10-16 00:00:00	32020		\N	130488	0	195662009	4112343		0
33213	1971	4116491	1996-04-21	1996-04-21 00:00:00	1996-06-08	1996-06-08 00:00:00	32020		\N	131003	0	301011002	4116491		0
33428	1982	4142905	1997-02-07	1997-02-07 00:00:00	1997-05-08	1997-05-08 00:00:00	32020		\N	131961	0	33737001	4142905		0
33549	1990	80180	2005-05-07	2005-05-07 00:00:00	\N	\N	32020		\N	132521	0	396275006	80180		0
23239	1387	40481087	2013-01-14	2013-01-14 00:00:00	2013-02-04	2013-02-04 00:00:00	32020		\N	92017	0	444814009	40481087		0
33942	2016	4230399	2011-09-06	2011-09-06 00:00:00	2011-10-06	2011-10-06 00:00:00	32020		\N	134136	0	359817006	4230399		0
34097	2025	4152936	1969-04-05	1969-04-05 00:00:00	1969-04-26	1969-04-26 00:00:00	32020		\N	134741	0	283385000	4152936		0
34257	2033	28060	1992-09-01	1992-09-01 00:00:00	1992-09-08	1992-09-08 00:00:00	32020		\N	135336	0	43878008	28060		0
34456	2044	40481087	1996-09-24	1996-09-24 00:00:00	1996-10-01	1996-10-01 00:00:00	32020		\N	135968	0	444814009	40481087		0
24055	1435	4116491	1987-02-12	1987-02-12 00:00:00	1987-04-06	1987-04-06 00:00:00	32020		\N	95559	0	301011002	4116491		0
34833	2070	260139	2001-05-10	2001-05-10 00:00:00	2001-05-24	2001-05-24 00:00:00	32020		\N	137701	0	10509002	260139		0
34967	2076	40481087	1986-08-17	1986-08-17 00:00:00	1986-08-31	1986-08-31 00:00:00	32020		\N	138198	0	444814009	40481087		0
35027	2079	260139	2005-11-01	2005-11-01 00:00:00	2005-11-08	2005-11-08 00:00:00	32020		\N	138448	0	10509002	260139		0
35209	2087	4237458	1927-09-23	1927-09-23 00:00:00	1927-10-23	1927-10-23 00:00:00	32020		\N	139099	0	58150001	4237458		0
35452	2100	4156265	2014-12-16	2014-12-16 00:00:00	2014-12-30	2014-12-30 00:00:00	32020		\N	139974	0	370247008	4156265		0
35574	2108	4112343	1976-09-18	1976-09-18 00:00:00	1976-09-28	1976-09-28 00:00:00	32020		\N	140337	0	195662009	4112343		0
35697	2116	4142905	2015-09-27	2015-09-27 00:00:00	2015-12-26	2015-12-26 00:00:00	32020		\N	140842	0	33737001	4142905		0
25375	1512	40481087	1994-05-05	1994-05-05 00:00:00	1994-05-12	1994-05-12 00:00:00	32020		\N	100940	0	444814009	40481087		0
36093	2138	4285898	1989-11-25	1989-11-25 00:00:00	\N	\N	32020		\N	142387	0	68496003	4285898		0
36254	2149	40481087	1975-07-10	1975-07-10 00:00:00	1975-07-17	1975-07-17 00:00:00	32020		\N	143073	0	444814009	40481087		0
36425	2155	260139	1979-07-25	1979-07-25 00:00:00	1979-08-08	1979-08-08 00:00:00	32020		\N	143575	0	10509002	260139		0
36582	2165	4112343	1963-11-15	1963-11-15 00:00:00	1963-11-25	1963-11-25 00:00:00	32020		\N	144225	0	195662009	4112343		0
36736	2173	40481087	2009-04-07	2009-04-07 00:00:00	2009-04-21	2009-04-21 00:00:00	32020		\N	144808	0	444814009	40481087		0
36915	2185	80502	2000-09-28	2000-09-28 00:00:00	\N	\N	32020		\N	145629	0	64859006	80502		0
26530	1571	40481087	1971-07-09	1971-07-09 00:00:00	1971-07-30	1971-07-30 00:00:00	32020		\N	105442	0	444814009	40481087		0
37227	2204	28060	1950-07-03	1950-07-03 00:00:00	1950-07-15	1950-07-15 00:00:00	32020		\N	146902	0	43878008	28060		0
37424	2218	372328	1984-02-12	1984-02-12 00:00:00	1984-05-08	1984-05-08 00:00:00	32020		\N	147706	0	65363002	372328		0
37517	2226	4112343	2014-07-26	2014-07-26 00:00:00	2014-08-02	2014-08-02 00:00:00	32020		\N	148077	0	195662009	4112343		0
27207	1606	4112343	1987-09-20	1987-09-20 00:00:00	1987-10-01	1987-10-01 00:00:00	32020		\N	107849	0	195662009	4112343		0
37885	2244	80180	1993-09-27	1993-09-27 00:00:00	\N	\N	32020		\N	149457	0	396275006	80180		0
38134	2264	195588	1989-05-06	1989-05-06 00:00:00	1989-06-07	1989-06-07 00:00:00	32020		\N	150428	0	38822007	195588		0
38245	2270	40481087	2009-12-07	2009-12-07 00:00:00	2009-12-21	2009-12-21 00:00:00	32020		\N	150954	0	444814009	40481087		0
38491	2287	317576	1962-05-04	1962-05-04 00:00:00	\N	\N	32020		\N	152138	0	53741008	317576		0
38625	2292	260139	1984-05-13	1984-05-13 00:00:00	1984-05-27	1984-05-27 00:00:00	32020		\N	152565	0	10509002	260139		0
38714	2297	378001	2005-10-18	2005-10-18 00:00:00	2005-12-17	2005-12-17 00:00:00	32020		\N	152929	0	62106007	378001		0
38904	2311	4112343	2008-01-03	2008-01-03 00:00:00	2008-01-14	2008-01-14 00:00:00	32020		\N	153744	0	195662009	4112343		0
39083	2320	4112343	1952-11-19	1952-11-19 00:00:00	1952-11-28	1952-11-28 00:00:00	32020		\N	154285	0	195662009	4112343		0
28700	1699	4112343	2011-06-14	2011-06-14 00:00:00	2011-06-25	2011-06-25 00:00:00	32020		\N	113655	0	195662009	4112343		0
39398	2334	313217	2011-06-23	2011-06-23 00:00:00	\N	\N	32020		\N	155281	0	49436004	313217		0
29048	1719	4051466	1961-04-15	1961-04-15 00:00:00	1976-07-25	1976-07-25 00:00:00	32020		\N	114883	0	233678006	4051466		0
39715	2351	40481087	1961-04-15	1961-04-15 00:00:00	1961-05-06	1961-05-06 00:00:00	32020		\N	156515	0	444814009	40481087		0
39862	2359	40481087	1951-12-27	1951-12-27 00:00:00	1952-01-03	1952-01-03 00:00:00	32020		\N	157245	0	444814009	40481087		0
29546	1748	4112343	2007-01-24	2007-01-24 00:00:00	2007-01-31	2007-01-31 00:00:00	32020		\N	116876	0	195662009	4112343		0
29714	1759	260139	1993-12-16	1993-12-16 00:00:00	1993-12-23	1993-12-23 00:00:00	32020		\N	117605	0	10509002	260139		0
29862	1766	260139	1994-05-13	1994-05-13 00:00:00	1994-05-27	1994-05-27 00:00:00	32020		\N	118177	0	10509002	260139		0
40554	2411	372328	1965-05-28	1965-05-28 00:00:00	1965-09-09	1965-09-09 00:00:00	32020		\N	159971	0	65363002	372328		0
40745	2423	260139	2005-10-02	2005-10-02 00:00:00	2005-10-09	2005-10-09 00:00:00	32020		\N	160793	0	10509002	260139		0
40900	2433	40481087	1976-07-10	1976-07-10 00:00:00	1976-07-24	1976-07-24 00:00:00	32020		\N	161283	0	444814009	40481087		0
41142	2445	260139	1955-11-07	1955-11-07 00:00:00	1955-11-21	1955-11-21 00:00:00	32020		\N	162236	0	10509002	260139		0
41226	2450	4146173	1957-09-29	1957-09-29 00:00:00	1957-10-29	1957-10-29 00:00:00	32020		\N	162497	0	307731004	4146173		0
41391	2461	4266809	2003-03-07	2003-03-07 00:00:00	\N	\N	32020		\N	163147	0	397881000	4266809		0
41533	2469	260139	1993-04-08	1993-04-08 00:00:00	1993-04-15	1993-04-15 00:00:00	32020		\N	163756	0	10509002	260139		0
41695	2480	4112343	1975-05-21	1975-05-21 00:00:00	1975-06-03	1975-06-03 00:00:00	32020		\N	164300	0	195662009	4112343		0
41942	2497	372328	1967-08-17	1967-08-17 00:00:00	1968-08-15	1968-08-15 00:00:00	32020		\N	165354	0	65363002	372328		0
42092	2507	80180	2006-05-12	2006-05-12 00:00:00	\N	\N	32020		\N	165933	0	396275006	80180		0
42309	2521	4112343	1969-03-18	1969-03-18 00:00:00	1969-03-28	1969-03-28 00:00:00	32020		\N	166713	0	195662009	4112343		0
42437	2528	28060	1978-09-04	1978-09-04 00:00:00	1978-09-12	1978-09-12 00:00:00	32020		\N	167087	0	43878008	28060		0
31968	1900	4294548	2002-10-11	2002-10-11 00:00:00	2002-11-15	2002-11-15 00:00:00	32020		\N	126476	0	75498004	4294548		0
32159	1911	4112343	1991-02-06	1991-02-06 00:00:00	1991-02-14	1991-02-14 00:00:00	32020		\N	127102	0	195662009	4112343		0
32285	1918	372328	1984-06-01	1984-06-01 00:00:00	1984-09-22	1984-09-22 00:00:00	32020		\N	127595	0	65363002	372328		0
32451	1926	4155034	1986-05-17	1986-05-17 00:00:00	1986-06-07	1986-06-07 00:00:00	32020		\N	128200	0	283371005	4155034		0
22050	1318	4112343	1950-04-18	1950-04-18 00:00:00	1950-04-27	1950-04-27 00:00:00	32020		\N	87339	0	195662009	4112343		0
32796	1947	439777	1961-10-14	1961-10-14 00:00:00	\N	\N	32020		\N	129425	0	271737000	439777		0
32886	1951	40481087	1997-04-18	1997-04-18 00:00:00	1997-04-25	1997-04-25 00:00:00	32020		\N	129759	0	444814009	40481087		0
33082	1962	260139	2019-01-22	2019-01-22 00:00:00	2019-01-29	2019-01-29 00:00:00	32020		\N	130502	0	10509002	260139		0
33214	1971	4112343	1993-06-16	1993-06-16 00:00:00	1993-06-28	1993-06-28 00:00:00	32020		\N	131026	0	195662009	4112343		0
33429	1982	4109685	1960-07-08	1960-07-08 00:00:00	1960-07-29	1960-07-29 00:00:00	32020		\N	131973	0	284551006	4109685		0
33550	1990	4035415	2001-03-15	2001-03-15 00:00:00	2001-04-14	2001-04-14 00:00:00	32020		\N	132505	0	239720000	4035415		0
23240	1387	40481087	1975-06-04	1975-06-04 00:00:00	1975-06-11	1975-06-11 00:00:00	32020		\N	91986	0	444814009	40481087		0
33943	2016	260139	1998-05-11	1998-05-11 00:00:00	1998-05-25	1998-05-25 00:00:00	32020		\N	134120	0	10509002	260139		0
34098	2026	40481087	2007-02-08	2007-02-08 00:00:00	2007-02-15	2007-02-15 00:00:00	32020		\N	134827	0	444814009	40481087		0
34258	2033	4112343	2003-07-14	2003-07-14 00:00:00	2003-07-22	2003-07-22 00:00:00	32020		\N	135337	0	195662009	4112343		0
34457	2044	372328	1966-04-14	1966-04-14 00:00:00	1966-09-24	1966-09-24 00:00:00	32020		\N	135960	0	65363002	372328		0
24056	1435	40481087	1970-03-12	1970-03-12 00:00:00	1970-03-19	1970-03-19 00:00:00	32020		\N	95573	0	444814009	40481087		0
34834	2070	4112343	1986-10-17	1986-10-17 00:00:00	1986-10-24	1986-10-24 00:00:00	32020		\N	137751	0	195662009	4112343		0
34968	2076	28060	1982-12-07	1982-12-07 00:00:00	1982-12-18	1982-12-18 00:00:00	32020		\N	138192	0	43878008	28060		0
35028	2079	260139	1975-12-28	1975-12-28 00:00:00	1976-01-11	1976-01-11 00:00:00	32020		\N	138492	0	10509002	260139		0
35210	2087	4112343	1974-06-28	1974-06-28 00:00:00	1974-07-11	1974-07-11 00:00:00	32020		\N	139087	0	195662009	4112343		0
35453	2100	4112343	2015-12-19	2015-12-19 00:00:00	2015-12-29	2015-12-29 00:00:00	32020		\N	139960	0	195662009	4112343		0
35575	2108	4134304	1986-05-09	1986-05-09 00:00:00	1986-08-07	1986-08-07 00:00:00	32020		\N	140357	0	263102004	4134304		0
35698	2116	40481087	2005-03-06	2005-03-06 00:00:00	2005-03-27	2005-03-27 00:00:00	32020		\N	140795	0	444814009	40481087		0
25376	1512	40481087	1994-11-15	1994-11-15 00:00:00	1994-11-29	1994-11-29 00:00:00	32020		\N	100960	0	444814009	40481087		0
36094	2138	4294548	1993-01-29	1993-01-29 00:00:00	1993-02-26	1993-02-26 00:00:00	32020		\N	142431	0	75498004	4294548		0
36255	2149	81151	1960-02-12	1960-02-12 00:00:00	1960-03-04	1960-03-04 00:00:00	32020		\N	143075	0	44465007	81151		0
36426	2155	40481087	1953-02-17	1953-02-17 00:00:00	1953-02-24	1953-02-24 00:00:00	32020		\N	143589	0	444814009	40481087		0
36583	2165	4112343	1985-10-11	1985-10-11 00:00:00	1985-10-23	1985-10-23 00:00:00	32020		\N	144188	0	195662009	4112343		0
36737	2173	4059173	1942-08-04	1942-08-04 00:00:00	1942-11-02	1942-11-02 00:00:00	32020		\N	144758	0	16114001	4059173		0
36916	2185	372328	1972-04-19	1972-04-19 00:00:00	1973-02-21	1973-02-21 00:00:00	32020		\N	145644	0	65363002	372328		0
26531	1571	4112343	1974-08-29	1974-08-29 00:00:00	1974-09-05	1974-09-05 00:00:00	32020		\N	105443	0	195662009	4112343		0
37228	2204	4156265	2000-06-20	2000-06-20 00:00:00	2000-07-04	2000-07-04 00:00:00	32020		\N	146881	0	370247008	4156265		0
37425	2220	260139	1978-06-20	1978-06-20 00:00:00	1978-07-04	1978-07-04 00:00:00	32020		\N	147863	0	10509002	260139		0
37518	2226	40481087	1949-01-23	1949-01-23 00:00:00	1949-01-30	1949-01-30 00:00:00	32020		\N	148116	0	444814009	40481087		0
27208	1606	260139	1988-10-07	1988-10-07 00:00:00	1988-10-15	1988-10-15 00:00:00	32020		\N	107849	0	10509002	260139		0
37886	2244	4237458	1975-03-22	1975-03-22 00:00:00	1975-05-21	1975-05-21 00:00:00	32020		\N	149383	0	58150001	4237458		0
38135	2264	4112343	1971-04-05	1971-04-05 00:00:00	1971-04-16	1971-04-16 00:00:00	32020		\N	150427	0	195662009	4112343		0
38246	2270	4156265	1988-05-08	1988-05-08 00:00:00	1988-05-29	1988-05-29 00:00:00	32020		\N	150939	0	370247008	4156265		0
38492	2287	40481087	1958-03-19	1958-03-19 00:00:00	1958-04-02	1958-04-02 00:00:00	32020		\N	152127	0	444814009	40481087		0
38626	2292	80180	2006-06-22	2006-06-22 00:00:00	\N	\N	32020		\N	152624	0	396275006	80180		0
38715	2297	4059173	1978-06-12	1978-06-12 00:00:00	1978-08-11	1978-08-11 00:00:00	32020		\N	152928	0	16114001	4059173		0
38905	2311	40481087	2003-08-18	2003-08-18 00:00:00	2003-09-01	2003-09-01 00:00:00	32020		\N	153755	0	444814009	40481087		0
39084	2320	260139	1957-11-20	1957-11-20 00:00:00	1957-12-04	1957-12-04 00:00:00	32020		\N	154279	0	10509002	260139		0
28701	1699	40481087	1973-07-02	1973-07-02 00:00:00	1973-07-23	1973-07-23 00:00:00	32020		\N	113680	0	444814009	40481087		0
39399	2334	4294548	1973-11-25	1973-11-25 00:00:00	1973-12-02	1973-12-02 00:00:00	32020		\N	155305	0	75498004	4294548		0
29049	1719	4218389	1987-02-22	1987-02-22 00:00:00	1987-03-29	1987-03-29 00:00:00	32020		\N	114917	0	39848009	4218389		0
39716	2351	4112343	1953-05-26	1953-05-26 00:00:00	1953-06-03	1953-06-03 00:00:00	32020		\N	156500	0	195662009	4112343		0
39863	2359	40481087	1926-02-14	1926-02-14 00:00:00	1926-02-21	1926-02-21 00:00:00	32020		\N	157243	0	444814009	40481087		0
29547	1748	81151	1976-12-26	1976-12-26 00:00:00	1977-01-23	1977-01-23 00:00:00	32020		\N	116871	0	44465007	81151		0
40194	2384	40481087	2010-06-03	2010-06-03 00:00:00	2010-06-24	2010-06-24 00:00:00	32020		\N	158477	0	444814009	40481087		0
29863	1766	40481087	2018-03-23	2018-03-23 00:00:00	2018-03-30	2018-03-30 00:00:00	32020		\N	118150	0	444814009	40481087		0
40555	2411	375671	1981-07-03	1981-07-03 00:00:00	1981-08-02	1981-08-02 00:00:00	32020		\N	160002	0	62564004	375671		0
40746	2423	4112343	1964-03-15	1964-03-15 00:00:00	1964-03-24	1964-03-24 00:00:00	32020		\N	160749	0	195662009	4112343		0
40901	2433	40481087	1977-08-24	1977-08-24 00:00:00	1977-08-31	1977-08-31 00:00:00	32020		\N	161327	0	444814009	40481087		0
41143	2445	40481087	1973-11-29	1973-11-29 00:00:00	1973-12-20	1973-12-20 00:00:00	32020		\N	162237	0	444814009	40481087		0
41227	2450	80180	1986-05-15	1986-05-15 00:00:00	\N	\N	32020		\N	162501	0	396275006	80180		0
41392	2461	40481087	2002-02-16	2002-02-16 00:00:00	2002-03-09	2002-03-09 00:00:00	32020		\N	163147	0	444814009	40481087		0
41534	2469	40481087	2016-03-12	2016-03-12 00:00:00	2016-03-26	2016-03-26 00:00:00	32020		\N	163719	0	444814009	40481087		0
41696	2481	40481087	2007-12-21	2007-12-21 00:00:00	2008-01-11	2008-01-11 00:00:00	32020		\N	164409	0	444814009	40481087		0
41943	2497	4112343	1968-07-27	1968-07-27 00:00:00	1968-08-09	1968-08-09 00:00:00	32020		\N	165349	0	195662009	4112343		0
42093	2507	257012	2005-10-07	2005-10-07 00:00:00	2006-04-21	2006-04-21 00:00:00	32020		\N	165945	0	40055000	257012		0
42310	2521	4218389	1986-08-07	1986-08-07 00:00:00	1986-09-04	1986-09-04 00:00:00	32020		\N	166784	0	39848009	4218389		0
42438	2528	378001	1979-12-18	1979-12-18 00:00:00	1980-01-17	1980-01-17 00:00:00	32020		\N	167131	0	62106007	378001		0
31969	1900	4112343	1969-07-09	1969-07-09 00:00:00	1969-07-22	1969-07-22 00:00:00	32020		\N	126449	0	195662009	4112343		0
32160	1911	28060	1948-03-17	1948-03-17 00:00:00	1948-03-29	1948-03-29 00:00:00	32020		\N	127164	0	43878008	28060		0
32286	1918	40481087	1982-02-02	1982-02-02 00:00:00	1982-02-16	1982-02-16 00:00:00	32020		\N	127635	0	444814009	40481087		0
32452	1926	40481087	1982-09-12	1982-09-12 00:00:00	1982-09-26	1982-09-26 00:00:00	32020		\N	128253	0	444814009	40481087		0
22051	1318	81151	1948-06-13	1948-06-13 00:00:00	1948-07-11	1948-07-11 00:00:00	32020		\N	87397	0	44465007	81151		0
32797	1947	40481087	1949-04-21	1949-04-21 00:00:00	1949-04-28	1949-04-28 00:00:00	32020		\N	129422	0	444814009	40481087		0
32887	1951	40481087	2015-12-22	2015-12-22 00:00:00	2016-01-05	2016-01-05 00:00:00	32020		\N	129762	0	444814009	40481087		0
33083	1962	28060	1968-06-13	1968-06-13 00:00:00	1968-06-23	1968-06-23 00:00:00	32020		\N	130508	0	43878008	28060		0
33215	1971	40481087	2017-12-22	2017-12-22 00:00:00	2018-01-12	2018-01-12 00:00:00	32020		\N	131029	0	444814009	40481087		0
33430	1982	4112343	1961-02-05	1961-02-05 00:00:00	1961-02-18	1961-02-18 00:00:00	32020		\N	132034	0	195662009	4112343		0
33551	1990	4296205	1978-06-23	1978-06-23 00:00:00	1978-07-14	1978-07-14 00:00:00	32020		\N	132503	0	403191005	4296205		0
33720	2002	260139	2010-04-19	2010-04-19 00:00:00	2010-04-26	2010-04-26 00:00:00	32020		\N	133376	0	10509002	260139		0
33944	2016	4109685	1989-05-26	1989-05-26 00:00:00	1989-06-16	1989-06-16 00:00:00	32020		\N	134106	0	284551006	4109685		0
34099	2026	40481087	2016-03-07	2016-03-07 00:00:00	2016-03-28	2016-03-28 00:00:00	32020		\N	134793	0	444814009	40481087		0
34259	2033	40481087	2002-07-11	2002-07-11 00:00:00	2002-08-01	2002-08-01 00:00:00	32020		\N	135351	0	444814009	40481087		0
34458	2044	260139	1993-08-07	1993-08-07 00:00:00	1993-08-14	1993-08-14 00:00:00	32020		\N	135967	0	10509002	260139		0
24057	1435	372328	2014-03-12	2014-03-12 00:00:00	2014-04-26	2014-04-26 00:00:00	32020		\N	95579	0	65363002	372328		0
34835	2070	40481087	1965-03-02	1965-03-02 00:00:00	1965-03-16	1965-03-16 00:00:00	32020		\N	137653	0	444814009	40481087		0
34969	2076	40481087	1994-12-26	1994-12-26 00:00:00	1995-01-16	1995-01-16 00:00:00	32020		\N	138194	0	444814009	40481087		0
35029	2079	260139	1989-05-21	1989-05-21 00:00:00	1989-05-28	1989-05-28 00:00:00	32020		\N	138493	0	10509002	260139		0
35211	2087	257012	1944-03-23	1944-03-23 00:00:00	1957-10-13	1957-10-13 00:00:00	32020		\N	139014	0	40055000	257012		0
35454	2100	4294548	1953-01-22	1953-01-22 00:00:00	1953-04-02	1953-04-02 00:00:00	32020		\N	139946	0	75498004	4294548		0
35576	2108	4094814	1987-06-03	1987-06-03 00:00:00	1987-09-01	1987-09-01 00:00:00	32020		\N	140358	0	262574004	4094814		0
35699	2116	40481087	1966-04-15	1966-04-15 00:00:00	1966-04-29	1966-04-29 00:00:00	32020		\N	140825	0	444814009	40481087		0
25377	1512	40481087	2011-12-09	2011-12-09 00:00:00	2011-12-23	2011-12-23 00:00:00	32020		\N	101006	0	444814009	40481087		0
36095	2138	4112343	1964-09-03	1964-09-03 00:00:00	1964-09-12	1964-09-12 00:00:00	32020		\N	142374	0	195662009	4112343		0
36256	2149	4084167	1959-10-15	1959-10-15 00:00:00	1959-10-15	1959-10-15 00:00:00	32020		\N	143074	0	241929008	4084167		0
36427	2155	40481087	1932-12-30	1932-12-30 00:00:00	1933-01-06	1933-01-06 00:00:00	32020		\N	143586	0	444814009	40481087		0
36584	2165	260139	1975-01-25	1975-01-25 00:00:00	1975-02-01	1975-02-01 00:00:00	32020		\N	144243	0	10509002	260139		0
36738	2173	378001	1972-08-17	1972-08-17 00:00:00	1972-09-16	1972-09-16 00:00:00	32020		\N	144890	0	62106007	378001		0
36917	2185	260139	1982-10-26	1982-10-26 00:00:00	1982-11-08	1982-11-08 00:00:00	32020		\N	145682	0	10509002	260139		0
26532	1571	4112343	2007-05-05	2007-05-05 00:00:00	2007-05-12	2007-05-12 00:00:00	32020		\N	105463	0	195662009	4112343		0
37229	2204	40481087	1972-02-17	1972-02-17 00:00:00	1972-02-24	1972-02-24 00:00:00	32020		\N	146876	0	444814009	40481087		0
37426	2220	40481087	2014-09-06	2014-09-06 00:00:00	2014-09-13	2014-09-13 00:00:00	32020		\N	147775	0	444814009	40481087		0
37519	2226	4112343	1966-12-27	1966-12-27 00:00:00	1967-01-08	1967-01-08 00:00:00	32020		\N	148139	0	195662009	4112343		0
27209	1606	4112343	1986-11-12	1986-11-12 00:00:00	1986-11-20	1986-11-20 00:00:00	32020		\N	107847	0	195662009	4112343		0
37887	2244	313217	2017-10-13	2017-10-13 00:00:00	\N	\N	32020		\N	149422	0	49436004	313217		0
38136	2264	40481087	2002-07-02	2002-07-02 00:00:00	2002-07-09	2002-07-09 00:00:00	32020		\N	150429	0	444814009	40481087		0
38247	2270	40481087	1986-12-17	1986-12-17 00:00:00	1986-12-31	1986-12-31 00:00:00	32020		\N	150952	0	444814009	40481087		0
38493	2287	4296204	1965-07-19	1965-07-19 00:00:00	1965-08-09	1965-08-09 00:00:00	32020		\N	152149	0	403190006	4296204		0
38627	2292	40481087	1986-01-10	1986-01-10 00:00:00	1986-01-17	1986-01-17 00:00:00	32020		\N	152566	0	444814009	40481087		0
38716	2298	4027663	1995-10-23	1995-10-23 00:00:00	\N	\N	32020		\N	152978	0	13200003	4027663		0
38906	2311	40481087	1987-11-21	1987-11-21 00:00:00	1987-12-05	1987-12-05 00:00:00	32020		\N	153699	0	444814009	40481087		0
39085	2320	4112343	2007-01-14	2007-01-14 00:00:00	2007-01-24	2007-01-24 00:00:00	32020		\N	154258	0	195662009	4112343		0
28702	1699	4112343	1981-12-23	1981-12-23 00:00:00	1982-01-02	1982-01-02 00:00:00	32020		\N	113637	0	195662009	4112343		0
39400	2334	4146173	1997-09-23	1997-09-23 00:00:00	1997-11-22	1997-11-22 00:00:00	32020		\N	155349	0	307731004	4146173		0
29050	1719	260139	2015-01-28	2015-01-28 00:00:00	2015-02-04	2015-02-04 00:00:00	32020		\N	114962	0	10509002	260139		0
39717	2351	28060	1998-02-27	1998-02-27 00:00:00	1998-03-11	1998-03-11 00:00:00	32020		\N	156518	0	43878008	28060		0
39864	2359	40481087	1959-04-24	1959-04-24 00:00:00	1959-05-15	1959-05-15 00:00:00	32020		\N	157277	0	444814009	40481087		0
29548	1748	28060	1959-02-12	1959-02-12 00:00:00	1959-02-21	1959-02-21 00:00:00	32020		\N	116838	0	43878008	28060		0
40195	2384	81151	1998-08-06	1998-08-06 00:00:00	1998-08-20	1998-08-20 00:00:00	32020		\N	158496	0	44465007	81151		0
29864	1766	40481087	2001-07-31	2001-07-31 00:00:00	2001-08-07	2001-08-07 00:00:00	32020		\N	118148	0	444814009	40481087		0
40556	2411	4112343	1987-07-04	1987-07-04 00:00:00	1987-07-17	1987-07-17 00:00:00	32020		\N	159999	0	195662009	4112343		0
40747	2423	80180	1997-09-02	1997-09-02 00:00:00	\N	\N	32020		\N	160767	0	396275006	80180		0
40902	2433	317576	2014-03-16	2014-03-16 00:00:00	\N	\N	32020		\N	161315	0	53741008	317576		0
41144	2445	40481087	1972-09-12	1972-09-12 00:00:00	1972-09-26	1972-09-26 00:00:00	32020		\N	162199	0	444814009	40481087		0
41228	2450	28060	1985-11-29	1985-11-29 00:00:00	1985-12-12	1985-12-12 00:00:00	32020		\N	162501	0	43878008	28060		0
41393	2461	4112343	1984-03-15	1984-03-15 00:00:00	1984-03-22	1984-03-22 00:00:00	32020		\N	163180	0	195662009	4112343		0
41535	2469	260139	2017-02-07	2017-02-07 00:00:00	2017-02-21	2017-02-21 00:00:00	32020		\N	163735	0	10509002	260139		0
41697	2481	40481087	1984-10-10	1984-10-10 00:00:00	1984-10-31	1984-10-31 00:00:00	32020		\N	164391	0	444814009	40481087		0
41944	2497	372328	1963-03-24	1963-03-24 00:00:00	1963-08-08	1963-08-08 00:00:00	32020		\N	165322	0	65363002	372328		0
42094	2507	81151	1979-08-27	1979-08-27 00:00:00	1979-09-17	1979-09-17 00:00:00	32020		\N	165952	0	44465007	81151		0
42311	2521	28060	1961-01-04	1961-01-04 00:00:00	1961-01-13	1961-01-13 00:00:00	32020		\N	166712	0	43878008	28060		0
42439	2528	4109685	2018-11-23	2018-11-23 00:00:00	2018-12-07	2018-12-07 00:00:00	32020		\N	167134	0	284551006	4109685		0
31970	1900	40481087	1986-12-08	1986-12-08 00:00:00	1986-12-29	1986-12-29 00:00:00	32020		\N	126453	0	444814009	40481087		0
32161	1911	261325	1997-09-01	1997-09-01 00:00:00	\N	\N	32020		\N	127138	0	87433001	261325		0
32287	1918	81151	1973-09-27	1973-09-27 00:00:00	1973-11-01	1973-11-01 00:00:00	32020		\N	127604	0	44465007	81151		0
32453	1926	4112343	1980-06-19	1980-06-19 00:00:00	1980-06-28	1980-06-28 00:00:00	32020		\N	128232	0	195662009	4112343		0
22057	1320	260139	1992-01-20	1992-01-20 00:00:00	1992-01-27	1992-01-27 00:00:00	32020		\N	87516	0	10509002	260139		0
32798	1947	260139	1950-02-11	1950-02-11 00:00:00	1950-02-25	1950-02-25 00:00:00	32020		\N	129423	0	10509002	260139		0
32888	1951	40481087	1985-11-23	1985-11-23 00:00:00	1985-12-14	1985-12-14 00:00:00	32020		\N	129724	0	444814009	40481087		0
33084	1962	40481087	1991-08-18	1991-08-18 00:00:00	1991-09-01	1991-09-01 00:00:00	32020		\N	130500	0	444814009	40481087		0
33216	1971	372328	1974-04-23	1974-04-23 00:00:00	1975-02-28	1975-02-28 00:00:00	32020		\N	131116	0	65363002	372328		0
33431	1982	257012	1978-11-15	1978-11-15 00:00:00	\N	\N	32020		\N	132016	0	40055000	257012		0
33552	1990	4278672	1975-04-10	1975-04-10 00:00:00	1975-07-09	1975-07-09 00:00:00	32020		\N	132502	0	65966004	4278672		0
33721	2002	81151	1976-04-06	1976-04-06 00:00:00	1976-05-04	1976-05-04 00:00:00	32020		\N	133378	0	44465007	81151		0
33945	2016	4266809	2017-03-20	2017-03-20 00:00:00	\N	\N	32020		\N	134142	0	397881000	4266809		0
34100	2026	40481087	1972-01-17	1972-01-17 00:00:00	1972-01-24	1972-01-24 00:00:00	32020		\N	134791	0	444814009	40481087		0
34260	2033	260139	1962-03-17	1962-03-17 00:00:00	1962-03-31	1962-03-31 00:00:00	32020		\N	135330	0	10509002	260139		0
34471	2046	40481087	1948-04-21	1948-04-21 00:00:00	1948-05-12	1948-05-12 00:00:00	32020		\N	136172	0	444814009	40481087		0
24058	1435	260139	1980-10-27	1980-10-27 00:00:00	1980-11-10	1980-11-10 00:00:00	32020		\N	95598	0	10509002	260139		0
34836	2070	40481087	1969-07-02	1969-07-02 00:00:00	1969-07-16	1969-07-16 00:00:00	32020		\N	137678	0	444814009	40481087		0
34970	2076	40481087	1978-09-03	1978-09-03 00:00:00	1978-09-10	1978-09-10 00:00:00	32020		\N	138182	0	444814009	40481087		0
35030	2079	4112343	1958-03-06	1958-03-06 00:00:00	1958-03-15	1958-03-15 00:00:00	32020		\N	138466	0	195662009	4112343		0
35212	2087	257012	1964-05-30	1964-05-30 00:00:00	\N	\N	32020		\N	139137	0	40055000	257012		0
35455	2100	4146173	1979-12-22	1979-12-22 00:00:00	1980-02-20	1980-02-20 00:00:00	32020		\N	139985	0	307731004	4146173		0
35577	2108	4112343	1950-11-25	1950-11-25 00:00:00	1950-12-03	1950-12-03 00:00:00	32020		\N	140373	0	195662009	4112343		0
35700	2116	40481087	2003-12-14	2003-12-14 00:00:00	2004-01-04	2004-01-04 00:00:00	32020		\N	140786	0	444814009	40481087		0
25378	1512	80180	2016-10-19	2016-10-19 00:00:00	\N	\N	32020		\N	100950	0	396275006	80180		0
36102	2140	40481087	2006-05-03	2006-05-03 00:00:00	2006-05-24	2006-05-24 00:00:00	32020		\N	142571	0	444814009	40481087		0
36257	2149	40481087	1993-08-10	1993-08-10 00:00:00	1993-08-31	1993-08-31 00:00:00	32020		\N	143077	0	444814009	40481087		0
36428	2155	260139	2000-04-17	2000-04-17 00:00:00	2000-05-01	2000-05-01 00:00:00	32020		\N	143579	0	10509002	260139		0
36585	2165	134438	1978-06-02	1978-06-02 00:00:00	1979-04-28	1979-04-28 00:00:00	32020		\N	144244	0	40275004	134438		0
36739	2173	372328	1942-10-09	1942-10-09 00:00:00	1943-08-03	1943-08-03 00:00:00	32020		\N	144801	0	65363002	372328		0
36918	2185	40480160	2015-06-05	2015-06-05 00:00:00	2015-07-05	2015-07-05 00:00:00	32020		\N	145627	0	443165006	40480160		0
26533	1571	260139	1959-07-08	1959-07-08 00:00:00	1959-07-22	1959-07-22 00:00:00	32020		\N	105479	0	10509002	260139		0
37230	2204	260139	1954-12-10	1954-12-10 00:00:00	1954-12-24	1954-12-24 00:00:00	32020		\N	146873	0	10509002	260139		0
37427	2220	4112343	1983-03-18	1983-03-18 00:00:00	1983-03-28	1983-03-28 00:00:00	32020		\N	147864	0	195662009	4112343		0
37520	2226	260139	1945-05-08	1945-05-08 00:00:00	1945-05-15	1945-05-15 00:00:00	32020		\N	148135	0	10509002	260139		0
27210	1606	40481087	1960-07-16	1960-07-16 00:00:00	1960-07-23	1960-07-23 00:00:00	32020		\N	107818	0	444814009	40481087		0
37888	2244	440448	1964-07-23	1964-07-23 00:00:00	\N	\N	32020		\N	149380	0	74400008	440448		0
38137	2264	80180	2009-06-15	2009-06-15 00:00:00	\N	\N	32020		\N	150476	0	396275006	80180		0
38248	2272	40481087	2016-02-04	2016-02-04 00:00:00	2016-02-25	2016-02-25 00:00:00	32020		\N	151014	0	444814009	40481087		0
35605	2109	80180	2005-12-04	2005-12-04 00:00:00	\N	\N	32020		\N	140421	0	396275006	80180		0
38494	2287	4112343	1957-08-02	1957-08-02 00:00:00	1957-08-09	1957-08-09 00:00:00	32020		\N	152168	0	195662009	4112343		0
38628	2292	260139	2009-01-16	2009-01-16 00:00:00	2009-01-30	2009-01-30 00:00:00	32020		\N	152569	0	10509002	260139		0
38717	2298	40481087	1983-03-30	1983-03-30 00:00:00	1983-04-20	1983-04-20 00:00:00	32020		\N	152970	0	444814009	40481087		0
38907	2311	260139	1972-04-22	1972-04-22 00:00:00	1972-05-06	1972-05-06 00:00:00	32020		\N	153718	0	10509002	260139		0
39131	2325	40481087	1991-01-15	1991-01-15 00:00:00	1991-01-22	1991-01-22 00:00:00	32020		\N	154558	0	444814009	40481087		0
28703	1699	4237458	1968-12-18	1968-12-18 00:00:00	1969-02-16	1969-02-16 00:00:00	32020		\N	113626	0	58150001	4237458		0
39401	2334	4294548	1965-11-16	1965-11-16 00:00:00	1965-11-30	1965-11-30 00:00:00	32020		\N	155304	0	75498004	4294548		0
39509	2341	260139	2008-03-26	2008-03-26 00:00:00	2008-04-02	2008-04-02 00:00:00	32020		\N	155819	0	10509002	260139		0
39718	2351	40481087	1999-01-02	1999-01-02 00:00:00	1999-01-09	1999-01-09 00:00:00	32020		\N	156502	0	444814009	40481087		0
39865	2359	260139	1978-11-29	1978-11-29 00:00:00	1978-12-13	1978-12-13 00:00:00	32020		\N	157278	0	10509002	260139		0
40007	2372	4112343	1970-04-22	1970-04-22 00:00:00	1970-05-02	1970-05-02 00:00:00	32020		\N	157824	0	195662009	4112343		0
40196	2384	40481087	1986-11-15	1986-11-15 00:00:00	1986-11-22	1986-11-22 00:00:00	32020		\N	158500	0	444814009	40481087		0
29865	1766	28060	1958-10-10	1958-10-10 00:00:00	1958-10-19	1958-10-19 00:00:00	32020		\N	118173	0	43878008	28060		0
40557	2411	4112343	1995-12-05	1995-12-05 00:00:00	1995-12-15	1995-12-15 00:00:00	32020		\N	159970	0	195662009	4112343		0
40748	2423	4134304	1997-06-29	1997-06-29 00:00:00	1997-09-27	1997-09-27 00:00:00	32020		\N	160767	0	263102004	4134304		0
40903	2433	4155034	1955-01-01	1955-01-01 00:00:00	1955-01-22	1955-01-22 00:00:00	32020		\N	161342	0	283371005	4155034		0
41145	2445	4112343	1953-02-11	1953-02-11 00:00:00	1953-02-21	1953-02-21 00:00:00	32020		\N	162235	0	195662009	4112343		0
41229	2450	4112343	2009-02-26	2009-02-26 00:00:00	2009-03-09	2009-03-09 00:00:00	32020		\N	162505	0	195662009	4112343		0
41394	2461	4112343	1987-08-17	1987-08-17 00:00:00	1987-08-24	1987-08-24 00:00:00	32020		\N	163182	0	195662009	4112343		0
41536	2469	40481087	1992-08-28	1992-08-28 00:00:00	1992-09-04	1992-09-04 00:00:00	32020		\N	163734	0	444814009	40481087		0
41698	2481	4112343	1990-08-02	1990-08-02 00:00:00	1990-08-14	1990-08-14 00:00:00	32020		\N	164396	0	195662009	4112343		0
41946	2497	321042	2008-02-28	2008-02-28 00:00:00	\N	\N	32020		\N	165316	0	410429000	321042		0
42095	2507	4156265	2017-07-20	2017-07-20 00:00:00	2017-08-03	2017-08-03 00:00:00	32020		\N	165956	0	370247008	4156265		0
42312	2521	40481087	1974-03-01	1974-03-01 00:00:00	1974-03-08	1974-03-08 00:00:00	32020		\N	166714	0	444814009	40481087		0
42440	2528	40481087	1994-04-10	1994-04-10 00:00:00	1994-04-17	1994-04-17 00:00:00	32020		\N	167139	0	444814009	40481087		0
31971	1900	4112343	1964-02-07	1964-02-07 00:00:00	1964-02-19	1964-02-19 00:00:00	32020		\N	126457	0	195662009	4112343		0
32162	1911	40481087	2002-08-06	2002-08-06 00:00:00	2002-08-20	2002-08-20 00:00:00	32020		\N	127182	0	444814009	40481087		0
32288	1918	260139	1982-01-30	1982-01-30 00:00:00	1982-02-13	1982-02-13 00:00:00	32020		\N	127592	0	10509002	260139		0
32454	1926	4285898	2005-08-20	2005-08-20 00:00:00	\N	\N	32020		\N	128201	0	68496003	4285898		0
22058	1320	4294548	1938-08-17	1938-08-17 00:00:00	1938-09-14	1938-09-14 00:00:00	32020		\N	87554	0	75498004	4294548		0
32799	1947	4134304	1976-04-07	1976-04-07 00:00:00	1976-07-06	1976-07-06 00:00:00	32020		\N	129466	0	263102004	4134304		0
32889	1951	80180	2013-10-27	2013-10-27 00:00:00	\N	\N	32020		\N	129775	0	396275006	80180		0
33085	1962	4112343	1993-08-20	1993-08-20 00:00:00	1993-08-29	1993-08-29 00:00:00	32020		\N	130501	0	195662009	4112343		0
33217	1971	4027663	2001-03-06	2001-03-06 00:00:00	\N	\N	32020		\N	131049	0	13200003	4027663		0
33432	1982	4112343	1949-04-29	1949-04-29 00:00:00	1949-05-09	1949-05-09 00:00:00	32020		\N	131999	0	195662009	4112343		0
33553	1990	40481087	1992-06-15	1992-06-15 00:00:00	1992-06-22	1992-06-22 00:00:00	32020		\N	132506	0	444814009	40481087		0
33722	2002	4027663	2002-03-06	2002-03-06 00:00:00	\N	\N	32020		\N	133329	0	13200003	4027663		0
33946	2016	80180	2017-03-20	2017-03-20 00:00:00	\N	\N	32020		\N	134142	0	396275006	80180		0
34101	2026	4112343	1975-06-17	1975-06-17 00:00:00	1975-06-26	1975-06-26 00:00:00	32020		\N	134814	0	195662009	4112343		0
34261	2033	257012	1984-03-13	1984-03-13 00:00:00	\N	\N	32020		\N	135378	0	40055000	257012		0
34472	2046	40481087	1959-06-19	1959-06-19 00:00:00	1959-07-03	1959-07-03 00:00:00	32020		\N	136100	0	444814009	40481087		0
24059	1435	40481087	1976-01-23	1976-01-23 00:00:00	1976-02-06	1976-02-06 00:00:00	32020		\N	95575	0	444814009	40481087		0
34837	2070	4059173	1988-02-07	1988-02-07 00:00:00	1988-04-07	1988-04-07 00:00:00	32020		\N	137727	0	16114001	4059173		0
34971	2076	4218389	2006-10-21	2006-10-21 00:00:00	2006-11-25	2006-11-25 00:00:00	32020		\N	138211	0	39848009	4218389		0
35031	2079	440448	1956-12-17	1956-12-17 00:00:00	\N	\N	32020		\N	138477	0	74400008	440448		0
35213	2087	40481087	1985-11-14	1985-11-14 00:00:00	1985-12-05	1985-12-05 00:00:00	32020		\N	139048	0	444814009	40481087		0
35456	2100	4112343	1961-01-08	1961-01-08 00:00:00	1961-01-17	1961-01-17 00:00:00	32020		\N	140034	0	195662009	4112343		0
35578	2108	81151	1993-05-02	1993-05-02 00:00:00	1993-05-30	1993-05-30 00:00:00	32020		\N	140359	0	44465007	81151		0
35701	2116	40481087	1977-07-27	1977-07-27 00:00:00	1977-08-10	1977-08-10 00:00:00	32020		\N	140792	0	444814009	40481087		0
25379	1512	4112343	2002-11-30	2002-11-30 00:00:00	2002-12-10	2002-12-10 00:00:00	32020		\N	100962	0	195662009	4112343		0
36103	2140	40481087	1999-02-08	1999-02-08 00:00:00	1999-02-22	1999-02-22 00:00:00	32020		\N	142552	0	444814009	40481087		0
36258	2149	80180	1995-11-25	1995-11-25 00:00:00	\N	\N	32020		\N	143077	0	396275006	80180		0
36429	2155	4112343	1987-06-12	1987-06-12 00:00:00	1987-06-24	1987-06-24 00:00:00	32020		\N	143577	0	195662009	4112343		0
36586	2165	4146173	1970-10-26	1970-10-26 00:00:00	1970-11-25	1970-11-25 00:00:00	32020		\N	144242	0	307731004	4146173		0
36740	2174	40481087	1996-06-26	1996-06-26 00:00:00	1996-07-10	1996-07-10 00:00:00	32020		\N	144930	0	444814009	40481087		0
36919	2185	4134304	2015-06-05	2015-06-05 00:00:00	2015-07-05	2015-07-05 00:00:00	32020		\N	145627	0	263102004	4134304		0
26534	1572	80180	1997-12-25	1997-12-25 00:00:00	\N	\N	32020		\N	105559	0	396275006	80180		0
37231	2204	4112343	1949-09-25	1949-09-25 00:00:00	1949-10-02	1949-10-02 00:00:00	32020		\N	146929	0	195662009	4112343		0
37428	2220	28060	2013-12-07	2013-12-07 00:00:00	2013-12-17	2013-12-17 00:00:00	32020		\N	147774	0	43878008	28060		0
37521	2226	40481087	2002-03-19	2002-03-19 00:00:00	2002-04-02	2002-04-02 00:00:00	32020		\N	148122	0	444814009	40481087		0
27211	1606	40481087	2002-09-12	2002-09-12 00:00:00	2002-09-26	2002-09-26 00:00:00	32020		\N	107820	0	444814009	40481087		0
37889	2244	4166224	1964-07-23	1964-07-23 00:00:00	\N	\N	32020		\N	149380	0	47693006	4166224		0
38138	2264	4112343	2008-01-14	2008-01-14 00:00:00	2008-01-21	2008-01-21 00:00:00	32020		\N	150476	0	195662009	4112343		0
38249	2272	40481087	2010-07-20	2010-07-20 00:00:00	2010-07-27	2010-07-27 00:00:00	32020		\N	150988	0	444814009	40481087		0
38495	2287	81151	1987-12-12	1987-12-12 00:00:00	1988-01-09	1988-01-09 00:00:00	32020		\N	152151	0	44465007	81151		0
38629	2292	4112343	1975-08-15	1975-08-15 00:00:00	1975-08-25	1975-08-25 00:00:00	32020		\N	152564	0	195662009	4112343		0
38718	2298	4112343	2015-10-26	2015-10-26 00:00:00	2015-11-03	2015-11-03 00:00:00	32020		\N	153006	0	195662009	4112343		0
38908	2311	80180	1993-05-11	1993-05-11 00:00:00	\N	\N	32020		\N	153715	0	396275006	80180		0
39132	2325	372328	1972-05-21	1972-05-21 00:00:00	1972-10-05	1972-10-05 00:00:00	32020		\N	154592	0	65363002	372328		0
28704	1699	28060	1969-10-18	1969-10-18 00:00:00	1969-10-29	1969-10-29 00:00:00	32020		\N	113628	0	43878008	28060		0
39402	2334	28060	1949-08-12	1949-08-12 00:00:00	1949-08-19	1949-08-19 00:00:00	32020		\N	155286	0	43878008	28060		0
39510	2341	372328	1953-09-18	1953-09-18 00:00:00	1953-12-31	1953-12-31 00:00:00	32020		\N	155840	0	65363002	372328		0
39719	2352	40481087	2001-02-22	2001-02-22 00:00:00	2001-03-08	2001-03-08 00:00:00	32020		\N	156620	0	444814009	40481087		0
39866	2359	28060	1962-11-18	1962-11-18 00:00:00	1962-11-27	1962-11-27 00:00:00	32020		\N	157177	0	43878008	28060		0
40008	2372	28060	1977-11-13	1977-11-13 00:00:00	1977-11-20	1977-11-20 00:00:00	32020		\N	157842	0	43878008	28060		0
40197	2384	78272	2005-10-12	2005-10-12 00:00:00	2005-10-26	2005-10-26 00:00:00	32020		\N	158497	0	70704007	78272		0
29866	1766	372328	1957-05-29	1957-05-29 00:00:00	1958-06-10	1958-06-10 00:00:00	32020		\N	118127	0	65363002	372328		0
40558	2412	40481087	1996-03-04	1996-03-04 00:00:00	1996-03-11	1996-03-11 00:00:00	32020		\N	160078	0	444814009	40481087		0
40749	2423	40479768	1998-09-22	1998-09-22 00:00:00	1998-11-28	1998-11-28 00:00:00	32020		\N	160768	0	444470001	40479768		0
40904	2433	4059173	1966-09-21	1966-09-21 00:00:00	1966-11-20	1966-11-20 00:00:00	32020		\N	161343	0	16114001	4059173		0
41146	2445	4155034	1955-10-27	1955-10-27 00:00:00	1955-11-17	1955-11-17 00:00:00	32020		\N	162196	0	283371005	4155034		0
41230	2450	4112343	1980-01-17	1980-01-17 00:00:00	1980-01-28	1980-01-28 00:00:00	32020		\N	162500	0	195662009	4112343		0
41395	2461	4310024	2000-04-21	2000-04-21 00:00:00	\N	\N	32020		\N	163151	0	424802006	4310024		0
41537	2469	40481087	1978-02-16	1978-02-16 00:00:00	1978-03-09	1978-03-09 00:00:00	32020		\N	163714	0	444814009	40481087		0
41699	2481	78272	1984-06-01	1984-06-01 00:00:00	1984-06-29	1984-06-29 00:00:00	32020		\N	164388	0	70704007	78272		0
41947	2497	4112343	2000-11-20	2000-11-20 00:00:00	2000-12-02	2000-12-02 00:00:00	32020		\N	165320	0	195662009	4112343		0
42096	2507	372328	1969-08-19	1969-08-19 00:00:00	1969-10-07	1969-10-07 00:00:00	32020		\N	165967	0	65363002	372328		0
42313	2521	260139	1981-11-05	1981-11-05 00:00:00	1981-11-12	1981-11-12 00:00:00	32020		\N	166731	0	10509002	260139		0
42441	2528	4112343	2005-06-02	2005-06-02 00:00:00	2005-06-13	2005-06-13 00:00:00	32020		\N	167140	0	195662009	4112343		0
31972	1900	40481087	1965-08-04	1965-08-04 00:00:00	1965-08-25	1965-08-25 00:00:00	32020		\N	126505	0	444814009	40481087		0
32163	1911	28060	1960-01-13	1960-01-13 00:00:00	1960-01-23	1960-01-23 00:00:00	32020		\N	127166	0	43878008	28060		0
32289	1918	40481087	1974-05-17	1974-05-17 00:00:00	1974-06-07	1974-06-07 00:00:00	32020		\N	127574	0	444814009	40481087		0
32455	1926	4134304	2005-07-27	2005-07-27 00:00:00	2005-08-26	2005-08-26 00:00:00	32020		\N	128201	0	263102004	4134304		0
22059	1320	372328	1939-10-09	1939-10-09 00:00:00	1940-08-15	1940-08-15 00:00:00	32020		\N	87494	0	65363002	372328		0
32800	1947	260139	1968-02-01	1968-02-01 00:00:00	1968-02-15	1968-02-15 00:00:00	32020		\N	129469	0	10509002	260139		0
32890	1951	81151	1985-10-19	1985-10-19 00:00:00	1985-11-09	1985-11-09 00:00:00	32020		\N	129718	0	44465007	81151		0
33086	1962	4156265	1987-02-05	1987-02-05 00:00:00	1987-02-19	1987-02-19 00:00:00	32020		\N	130478	0	370247008	4156265		0
33218	1971	260139	1997-09-06	1997-09-06 00:00:00	1997-09-20	1997-09-20 00:00:00	32020		\N	131112	0	10509002	260139		0
33433	1982	4112343	1957-06-11	1957-06-11 00:00:00	1957-06-22	1957-06-22 00:00:00	32020		\N	132015	0	195662009	4112343		0
33554	1990	40481087	2017-11-03	2017-11-03 00:00:00	2017-11-10	2017-11-10 00:00:00	32020		\N	132539	0	444814009	40481087		0
33723	2002	40481087	2012-10-11	2012-10-11 00:00:00	2012-10-25	2012-10-25 00:00:00	32020		\N	133377	0	444814009	40481087		0
33947	2016	40481087	1983-10-02	1983-10-02 00:00:00	1983-10-23	1983-10-23 00:00:00	32020		\N	134119	0	444814009	40481087		0
34102	2026	28060	1960-03-23	1960-03-23 00:00:00	1960-04-03	1960-04-03 00:00:00	32020		\N	134798	0	43878008	28060		0
34262	2033	40481087	1975-12-10	1975-12-10 00:00:00	1975-12-24	1975-12-24 00:00:00	32020		\N	135333	0	444814009	40481087		0
34473	2046	4112343	1977-06-30	1977-06-30 00:00:00	1977-07-08	1977-07-08 00:00:00	32020		\N	136180	0	195662009	4112343		0
24060	1435	4155034	1994-02-09	1994-02-09 00:00:00	1994-02-23	1994-02-23 00:00:00	32020		\N	95583	0	283371005	4155034		0
34838	2070	260139	2005-09-02	2005-09-02 00:00:00	2005-09-09	2005-09-09 00:00:00	32020		\N	137658	0	10509002	260139		0
34972	2076	40481087	1983-05-23	1983-05-23 00:00:00	1983-05-30	1983-05-30 00:00:00	32020		\N	138193	0	444814009	40481087		0
35032	2079	4112343	2006-01-28	2006-01-28 00:00:00	2006-02-04	2006-02-04 00:00:00	32020		\N	138469	0	195662009	4112343		0
35214	2087	4152936	1950-11-21	1950-11-21 00:00:00	1950-12-05	1950-12-05 00:00:00	32020		\N	139100	0	283385000	4152936		0
35457	2100	40481087	2000-05-10	2000-05-10 00:00:00	2000-05-24	2000-05-24 00:00:00	32020		\N	139942	0	444814009	40481087		0
35579	2108	4278672	1961-07-19	1961-07-19 00:00:00	1961-10-17	1961-10-17 00:00:00	32020		\N	140355	0	65966004	4278672		0
35702	2116	40481087	1987-03-09	1987-03-09 00:00:00	1987-03-23	1987-03-23 00:00:00	32020		\N	140785	0	444814009	40481087		0
25380	1512	40481087	2005-09-13	2005-09-13 00:00:00	2005-10-04	2005-10-04 00:00:00	32020		\N	101005	0	444814009	40481087		0
36104	2140	4134304	1960-01-20	1960-01-20 00:00:00	1960-03-20	1960-03-20 00:00:00	32020		\N	142554	0	263102004	4134304		0
36259	2149	260139	2010-01-12	2010-01-12 00:00:00	2010-01-19	2010-01-19 00:00:00	32020		\N	143079	0	10509002	260139		0
36430	2155	40481087	1928-07-10	1928-07-10 00:00:00	1928-07-17	1928-07-17 00:00:00	32020		\N	143638	0	444814009	40481087		0
36587	2165	4146173	2009-12-07	2009-12-07 00:00:00	2010-01-13	2010-01-13 00:00:00	32020		\N	144209	0	307731004	4146173		0
36741	2174	40481087	1978-03-16	1978-03-16 00:00:00	1978-04-06	1978-04-06 00:00:00	32020		\N	144928	0	444814009	40481087		0
36920	2185	40481087	1950-10-30	1950-10-30 00:00:00	1950-11-20	1950-11-20 00:00:00	32020		\N	145678	0	444814009	40481087		0
26535	1572	4112343	1997-06-10	1997-06-10 00:00:00	1997-06-18	1997-06-18 00:00:00	32020		\N	105559	0	195662009	4112343		0
37232	2204	4113008	1980-04-07	1980-04-07 00:00:00	1980-04-21	1980-04-21 00:00:00	32020		\N	146879	0	284549007	4113008		0
37429	2220	81151	1949-07-07	1949-07-07 00:00:00	1949-07-28	1949-07-28 00:00:00	32020		\N	147791	0	44465007	81151		0
37522	2226	260139	1957-08-11	1957-08-11 00:00:00	1957-08-25	1957-08-25 00:00:00	32020		\N	148137	0	10509002	260139		0
27212	1606	260139	1990-04-09	1990-04-09 00:00:00	1990-04-23	1990-04-23 00:00:00	32020		\N	107801	0	10509002	260139		0
37890	2244	4112343	1995-11-21	1995-11-21 00:00:00	1995-12-02	1995-12-02 00:00:00	32020		\N	149398	0	195662009	4112343		0
38139	2264	4112343	1981-05-09	1981-05-09 00:00:00	1981-05-21	1981-05-21 00:00:00	32020		\N	150445	0	195662009	4112343		0
38250	2272	40481087	1987-01-02	1987-01-02 00:00:00	1987-01-23	1987-01-23 00:00:00	32020		\N	151021	0	444814009	40481087		0
38496	2287	28060	1970-02-17	1970-02-17 00:00:00	1970-03-01	1970-03-01 00:00:00	32020		\N	152102	0	43878008	28060		0
38630	2292	40481087	2015-02-20	2015-02-20 00:00:00	2015-03-06	2015-03-06 00:00:00	32020		\N	152626	0	444814009	40481087		0
38719	2298	372328	1973-10-28	1973-10-28 00:00:00	1974-04-04	1974-04-04 00:00:00	32020		\N	152989	0	65363002	372328		0
38909	2311	372328	1976-11-06	1976-11-06 00:00:00	1977-10-01	1977-10-01 00:00:00	32020		\N	153757	0	65363002	372328		0
39133	2325	4112343	2004-07-31	2004-07-31 00:00:00	2004-08-11	2004-08-11 00:00:00	32020		\N	154604	0	195662009	4112343		0
39178	2326	40481087	1978-05-23	1978-05-23 00:00:00	1978-06-13	1978-06-13 00:00:00	32020		\N	154646	0	444814009	40481087		0
39427	2337	4112343	1992-09-25	1992-09-25 00:00:00	1992-10-05	1992-10-05 00:00:00	32020		\N	155491	0	195662009	4112343		0
39511	2341	378001	1972-12-12	1972-12-12 00:00:00	1973-01-11	1973-01-11 00:00:00	32020		\N	155803	0	62106007	378001		0
39720	2352	28060	2018-08-02	2018-08-02 00:00:00	2018-08-13	2018-08-13 00:00:00	32020		\N	156742	0	43878008	28060		0
39867	2359	317576	2011-04-25	2011-04-25 00:00:00	\N	\N	32020		\N	157234	0	53741008	317576		0
40009	2372	4112343	1975-03-10	1975-03-10 00:00:00	1975-03-18	1975-03-18 00:00:00	32020		\N	157823	0	195662009	4112343		0
40198	2384	81893	2015-08-12	2015-08-12 00:00:00	\N	\N	32020		\N	158484	0	64766004	81893		0
29867	1766	40481087	1968-11-05	1968-11-05 00:00:00	1968-11-12	1968-11-12 00:00:00	32020		\N	118175	0	444814009	40481087		0
40559	2412	81151	1952-06-05	1952-06-05 00:00:00	1952-06-26	1952-06-26 00:00:00	32020		\N	160094	0	44465007	81151		0
40750	2423	40481087	1979-01-08	1979-01-08 00:00:00	1979-01-22	1979-01-22 00:00:00	32020		\N	160729	0	444814009	40481087		0
40905	2433	4112343	2004-05-25	2004-05-25 00:00:00	2004-06-06	2004-06-06 00:00:00	32020		\N	161328	0	195662009	4112343		0
41147	2445	4112343	1988-04-19	1988-04-19 00:00:00	1988-04-26	1988-04-26 00:00:00	32020		\N	162189	0	195662009	4112343		0
41231	2450	4218389	2014-03-09	2014-03-09 00:00:00	2014-04-06	2014-04-06 00:00:00	32020		\N	162560	0	39848009	4218389		0
41396	2461	260139	2010-04-04	2010-04-04 00:00:00	2010-04-11	2010-04-11 00:00:00	32020		\N	163148	0	10509002	260139		0
41538	2469	4112343	2016-09-24	2016-09-24 00:00:00	2016-10-01	2016-10-01 00:00:00	32020		\N	163720	0	195662009	4112343		0
41700	2481	40481087	2008-09-15	2008-09-15 00:00:00	2008-10-06	2008-10-06 00:00:00	32020		\N	164398	0	444814009	40481087		0
41948	2497	378001	1962-09-25	1962-09-25 00:00:00	1962-10-25	1962-10-25 00:00:00	32020		\N	165312	0	62106007	378001		0
42097	2507	378001	1991-01-17	1991-01-17 00:00:00	1991-02-16	1991-02-16 00:00:00	32020		\N	165953	0	62106007	378001		0
42314	2521	260139	1985-08-24	1985-08-24 00:00:00	1985-09-07	1985-09-07 00:00:00	32020		\N	166732	0	10509002	260139		0
42442	2528	4112343	1970-10-24	1970-10-24 00:00:00	1970-11-02	1970-11-02 00:00:00	32020		\N	167086	0	195662009	4112343		0
31973	1900	4112343	1966-09-10	1966-09-10 00:00:00	1966-09-19	1966-09-19 00:00:00	32020		\N	126462	0	195662009	4112343		0
32164	1911	4112343	1986-07-08	1986-07-08 00:00:00	1986-07-15	1986-07-15 00:00:00	32020		\N	127143	0	195662009	4112343		0
32290	1918	28060	1976-05-02	1976-05-02 00:00:00	1976-05-09	1976-05-09 00:00:00	32020		\N	127575	0	43878008	28060		0
32456	1926	378001	2014-03-12	2014-03-12 00:00:00	2014-05-11	2014-05-11 00:00:00	32020		\N	128202	0	62106007	378001		0
22060	1320	40481087	1961-02-05	1961-02-05 00:00:00	1961-02-12	1961-02-12 00:00:00	32020		\N	87490	0	444814009	40481087		0
32801	1947	4156265	1991-08-17	1991-08-17 00:00:00	1991-08-31	1991-08-31 00:00:00	32020		\N	129468	0	370247008	4156265		0
32891	1951	28060	1991-04-25	1991-04-25 00:00:00	1991-05-08	1991-05-08 00:00:00	32020		\N	129776	0	43878008	28060		0
33093	1964	40481087	2003-06-28	2003-06-28 00:00:00	2003-07-12	2003-07-12 00:00:00	32020		\N	130562	0	444814009	40481087		0
33219	1971	260139	1981-05-12	1981-05-12 00:00:00	1981-05-19	1981-05-19 00:00:00	32020		\N	131066	0	10509002	260139		0
33434	1982	4278672	1933-11-20	1933-11-20 00:00:00	1933-12-20	1933-12-20 00:00:00	32020		\N	131971	0	65966004	4278672		0
33555	1990	260139	1998-04-10	1998-04-10 00:00:00	1998-04-24	1998-04-24 00:00:00	32020		\N	132486	0	10509002	260139		0
33724	2002	80180	2013-03-23	2013-03-23 00:00:00	\N	\N	32020		\N	133377	0	396275006	80180		0
33948	2016	81151	2002-06-13	2002-06-13 00:00:00	2002-07-11	2002-07-11 00:00:00	32020		\N	134134	0	44465007	81151		0
34103	2026	80180	1995-07-14	1995-07-14 00:00:00	\N	\N	32020		\N	134819	0	396275006	80180		0
34263	2033	40481087	1965-12-09	1965-12-09 00:00:00	1965-12-23	1965-12-23 00:00:00	32020		\N	135331	0	444814009	40481087		0
34474	2046	4112343	1992-11-26	1992-11-26 00:00:00	1992-12-03	1992-12-03 00:00:00	32020		\N	136174	0	195662009	4112343		0
24061	1435	28060	1969-09-08	1969-09-08 00:00:00	1969-09-17	1969-09-17 00:00:00	32020		\N	95539	0	43878008	28060		0
34839	2070	4152936	2001-07-19	2001-07-19 00:00:00	2001-08-02	2001-08-02 00:00:00	32020		\N	137729	0	283385000	4152936		0
34973	2076	40481087	1969-10-19	1969-10-19 00:00:00	1969-10-26	1969-10-26 00:00:00	32020		\N	138189	0	444814009	40481087		0
35033	2079	80180	1991-06-25	1991-06-25 00:00:00	\N	\N	32020		\N	138440	0	396275006	80180		0
35215	2087	317576	2001-07-18	2001-07-18 00:00:00	\N	\N	32020		\N	139117	0	53741008	317576		0
35458	2100	4112343	2000-11-06	2000-11-06 00:00:00	2000-11-13	2000-11-13 00:00:00	32020		\N	139943	0	195662009	4112343		0
35580	2108	260139	1946-10-03	1946-10-03 00:00:00	1946-10-10	1946-10-10 00:00:00	32020		\N	140312	0	10509002	260139		0
35703	2116	40481087	2008-02-09	2008-02-09 00:00:00	2008-02-23	2008-02-23 00:00:00	32020		\N	140796	0	444814009	40481087		0
25381	1512	40481087	2010-11-14	2010-11-14 00:00:00	2010-12-05	2010-12-05 00:00:00	32020		\N	100941	0	444814009	40481087		0
36105	2140	4266809	1989-10-14	1989-10-14 00:00:00	\N	\N	32020		\N	142569	0	397881000	4266809		0
36260	2149	81151	1982-03-14	1982-03-14 00:00:00	1982-04-04	1982-04-04 00:00:00	32020		\N	143126	0	44465007	81151		0
36431	2155	40481087	2004-04-07	2004-04-07 00:00:00	2004-04-21	2004-04-21 00:00:00	32020		\N	143657	0	444814009	40481087		0
36588	2165	4294548	2010-08-11	2010-08-11 00:00:00	2010-11-03	2010-11-03 00:00:00	32020		\N	144210	0	75498004	4294548		0
36742	2174	260139	2000-08-02	2000-08-02 00:00:00	2000-08-09	2000-08-09 00:00:00	32020		\N	144937	0	10509002	260139		0
36921	2185	40481087	1973-06-26	1973-06-26 00:00:00	1973-07-10	1973-07-10 00:00:00	32020		\N	145681	0	444814009	40481087		0
26536	1572	317576	1968-03-01	1968-03-01 00:00:00	\N	\N	32020		\N	105586	0	53741008	317576		0
37233	2204	372328	1950-02-11	1950-02-11 00:00:00	1950-07-13	1950-07-13 00:00:00	32020		\N	146887	0	65363002	372328		0
37430	2220	4112343	1986-03-15	1986-03-15 00:00:00	1986-03-27	1986-03-27 00:00:00	32020		\N	147865	0	195662009	4112343		0
37523	2226	28060	1999-03-09	1999-03-09 00:00:00	1999-03-19	1999-03-19 00:00:00	32020		\N	148120	0	43878008	28060		0
27213	1606	4059173	1964-05-14	1964-05-14 00:00:00	1964-07-13	1964-07-13 00:00:00	32020		\N	107855	0	16114001	4059173		0
37891	2244	4112343	1983-07-29	1983-07-29 00:00:00	1983-08-08	1983-08-08 00:00:00	32020		\N	149386	0	195662009	4112343		0
38140	2264	4112343	2000-04-28	2000-04-28 00:00:00	2000-05-09	2000-05-09 00:00:00	32020		\N	150446	0	195662009	4112343		0
38251	2272	28060	2001-03-14	2001-03-14 00:00:00	2001-03-26	2001-03-26 00:00:00	32020		\N	150987	0	43878008	28060		0
38497	2287	4112343	1999-01-24	1999-01-24 00:00:00	1999-02-04	1999-02-04 00:00:00	32020		\N	152120	0	195662009	4112343		0
38631	2292	4113008	1997-10-13	1997-10-13 00:00:00	1997-11-03	1997-11-03 00:00:00	32020		\N	152636	0	284549007	4113008		0
38720	2298	40481087	1983-06-24	1983-06-24 00:00:00	1983-07-08	1983-07-08 00:00:00	32020		\N	152988	0	444814009	40481087		0
38910	2311	4112343	1993-11-04	1993-11-04 00:00:00	1993-11-13	1993-11-13 00:00:00	32020		\N	153743	0	195662009	4112343		0
39134	2325	28060	2018-10-30	2018-10-30 00:00:00	2018-11-08	2018-11-08 00:00:00	32020		\N	154562	0	43878008	28060		0
39179	2326	4152936	1985-02-23	1985-02-23 00:00:00	1985-03-16	1985-03-16 00:00:00	32020		\N	154671	0	283385000	4152936		0
39428	2337	4116491	1985-07-10	1985-07-10 00:00:00	1985-09-02	1985-09-02 00:00:00	32020		\N	155505	0	301011002	4116491		0
39512	2341	40481087	2019-04-04	2019-04-04 00:00:00	2019-04-11	2019-04-11 00:00:00	32020		\N	155839	0	444814009	40481087		0
39721	2352	4285898	2011-09-06	2011-09-06 00:00:00	\N	\N	32020		\N	156638	0	68496003	4285898		0
39868	2359	260139	2004-03-21	2004-03-21 00:00:00	2004-04-04	2004-04-04 00:00:00	32020		\N	157271	0	10509002	260139		0
40010	2372	28060	1966-07-27	1966-07-27 00:00:00	1966-08-09	1966-08-09 00:00:00	32020		\N	157811	0	43878008	28060		0
40199	2384	4310024	2015-07-13	2015-07-13 00:00:00	\N	\N	32020		\N	158484	0	424802006	4310024		0
29868	1766	80180	1996-08-27	1996-08-27 00:00:00	\N	\N	32020		\N	118143	0	396275006	80180		0
40560	2412	4112343	2009-12-24	2009-12-24 00:00:00	2010-01-05	2010-01-05 00:00:00	32020		\N	160098	0	195662009	4112343		0
40751	2423	195588	1996-10-12	1996-10-12 00:00:00	1996-11-23	1996-11-23 00:00:00	32020		\N	160732	0	38822007	195588		0
40906	2433	372328	1958-02-14	1958-02-14 00:00:00	1958-12-28	1958-12-28 00:00:00	32020		\N	161337	0	65363002	372328		0
41148	2445	40481087	1951-02-24	1951-02-24 00:00:00	1951-03-10	1951-03-10 00:00:00	32020		\N	162187	0	444814009	40481087		0
41232	2450	4112343	1988-03-04	1988-03-04 00:00:00	1988-03-16	1988-03-16 00:00:00	32020		\N	162502	0	195662009	4112343		0
41397	2462	4218389	2018-08-15	2018-08-15 00:00:00	2018-09-12	2018-09-12 00:00:00	32020		\N	163201	0	39848009	4218389		0
41539	2469	260139	1993-08-14	1993-08-14 00:00:00	1993-08-28	1993-08-28 00:00:00	32020		\N	163748	0	10509002	260139		0
41701	2481	4113008	1997-07-21	1997-07-21 00:00:00	1997-08-11	1997-08-11 00:00:00	32020		\N	164389	0	284549007	4113008		0
41949	2497	260139	1964-01-20	1964-01-20 00:00:00	1964-01-27	1964-01-27 00:00:00	32020		\N	165359	0	10509002	260139		0
42098	2507	4218389	2010-12-03	2010-12-03 00:00:00	2010-12-24	2010-12-24 00:00:00	32020		\N	165955	0	39848009	4218389		0
42315	2521	4112343	1952-08-29	1952-08-29 00:00:00	1952-09-09	1952-09-09 00:00:00	32020		\N	166766	0	195662009	4112343		0
42443	2528	4112343	1980-10-16	1980-10-16 00:00:00	1980-10-26	1980-10-26 00:00:00	32020		\N	167106	0	195662009	4112343		0
31974	1900	40481087	2003-01-21	2003-01-21 00:00:00	2003-01-28	2003-01-28 00:00:00	32020		\N	126455	0	444814009	40481087		0
32165	1911	260139	2002-07-30	2002-07-30 00:00:00	2002-08-13	2002-08-13 00:00:00	32020		\N	127145	0	10509002	260139		0
32291	1918	4296204	1980-04-28	1980-04-28 00:00:00	1980-05-12	1980-05-12 00:00:00	32020		\N	127583	0	403190006	4296204		0
32457	1926	372328	1988-09-20	1988-09-20 00:00:00	1989-08-12	1989-08-12 00:00:00	32020		\N	128257	0	65363002	372328		0
22061	1320	4112343	1949-09-14	1949-09-14 00:00:00	1949-09-25	1949-09-25 00:00:00	32020		\N	87538	0	195662009	4112343		0
32802	1947	260139	1951-12-17	1951-12-17 00:00:00	1951-12-24	1951-12-24 00:00:00	32020		\N	129391	0	10509002	260139		0
32892	1951	4112343	2019-05-18	2019-05-18 00:00:00	2019-05-25	2019-05-25 00:00:00	32020		\N	129754	0	195662009	4112343		0
33094	1964	40481087	2014-12-14	2014-12-14 00:00:00	2015-01-04	2015-01-04 00:00:00	32020		\N	130575	0	444814009	40481087		0
33220	1971	4084167	1979-11-17	1979-11-17 00:00:00	1979-11-17	1979-11-17 00:00:00	32020		\N	131062	0	241929008	4084167		0
33435	1982	40481087	1941-10-07	1941-10-07 00:00:00	1941-10-28	1941-10-28 00:00:00	32020		\N	132013	0	444814009	40481087		0
33556	1990	4112343	1967-07-22	1967-07-22 00:00:00	1967-08-03	1967-08-03 00:00:00	32020		\N	132481	0	195662009	4112343		0
33725	2002	40481087	2005-04-05	2005-04-05 00:00:00	2005-04-19	2005-04-19 00:00:00	32020		\N	133355	0	444814009	40481087		0
33949	2016	4027663	2009-12-02	2009-12-02 00:00:00	\N	\N	32020		\N	134145	0	13200003	4027663		0
34104	2026	260139	2009-02-11	2009-02-11 00:00:00	2009-02-25	2009-02-25 00:00:00	32020		\N	134858	0	10509002	260139		0
34264	2033	40481087	1980-12-04	1980-12-04 00:00:00	1980-12-18	1980-12-18 00:00:00	32020		\N	135317	0	444814009	40481087		0
34475	2046	372328	1942-10-11	1942-10-11 00:00:00	1942-12-01	1942-12-01 00:00:00	32020		\N	136177	0	65363002	372328		0
24062	1435	260139	1967-12-16	1967-12-16 00:00:00	1967-12-30	1967-12-30 00:00:00	32020		\N	95558	0	10509002	260139		0
34840	2070	4048171	1969-11-01	1969-11-01 00:00:00	1993-07-12	1993-07-12 00:00:00	32020		\N	137741	0	232353008	4048171		0
34974	2076	260139	2005-07-10	2005-07-10 00:00:00	2005-07-24	2005-07-24 00:00:00	32020		\N	138145	0	10509002	260139		0
35034	2079	4112343	1980-06-28	1980-06-28 00:00:00	1980-07-10	1980-07-10 00:00:00	32020		\N	138457	0	195662009	4112343		0
35216	2088	40481087	1951-06-23	1951-06-23 00:00:00	1951-07-07	1951-07-07 00:00:00	32020		\N	139198	0	444814009	40481087		0
35459	2100	4109685	1959-08-13	1959-08-13 00:00:00	1959-08-27	1959-08-27 00:00:00	32020		\N	139968	0	284551006	4109685		0
35581	2108	4166224	1978-08-31	1978-08-31 00:00:00	\N	\N	32020		\N	140356	0	47693006	4166224		0
35704	2116	80180	1990-10-04	1990-10-04 00:00:00	\N	\N	32020		\N	140805	0	396275006	80180		0
25382	1512	372328	1976-05-02	1976-05-02 00:00:00	1976-05-16	1976-05-16 00:00:00	32020		\N	100956	0	65363002	372328		0
36106	2140	80180	1989-10-14	1989-10-14 00:00:00	\N	\N	32020		\N	142569	0	396275006	80180		0
36261	2149	28060	1961-10-08	1961-10-08 00:00:00	1961-10-15	1961-10-15 00:00:00	32020		\N	143070	0	43878008	28060		0
36432	2155	40481087	1940-12-02	1940-12-02 00:00:00	1940-12-16	1940-12-16 00:00:00	32020		\N	143588	0	444814009	40481087		0
36589	2165	260139	1957-10-14	1957-10-14 00:00:00	1957-10-21	1957-10-21 00:00:00	32020		\N	144187	0	10509002	260139		0
36743	2174	40481087	2013-03-21	2013-03-21 00:00:00	2013-04-04	2013-04-04 00:00:00	32020		\N	144938	0	444814009	40481087		0
36922	2185	40481087	1964-02-25	1964-02-25 00:00:00	1964-03-10	1964-03-10 00:00:00	32020		\N	145654	0	444814009	40481087		0
26537	1572	40481087	1968-02-26	1968-02-26 00:00:00	1968-03-04	1968-03-04 00:00:00	32020		\N	105604	0	444814009	40481087		0
37234	2204	260139	1986-09-18	1986-09-18 00:00:00	1986-09-25	1986-09-25 00:00:00	32020		\N	146917	0	10509002	260139		0
37431	2220	4266809	1987-07-23	1987-07-23 00:00:00	\N	\N	32020		\N	147835	0	397881000	4266809		0
37524	2226	40481087	2002-06-10	2002-06-10 00:00:00	2002-07-01	2002-07-01 00:00:00	32020		\N	148123	0	444814009	40481087		0
27214	1606	4296205	1953-12-12	1953-12-12 00:00:00	1954-01-16	1954-01-16 00:00:00	32020		\N	107795	0	403191005	4296205		0
37892	2244	4134304	1966-08-15	1966-08-15 00:00:00	1966-09-14	1966-09-14 00:00:00	32020		\N	149381	0	263102004	4134304		0
38141	2264	4112343	1998-11-19	1998-11-19 00:00:00	1998-12-01	1998-12-01 00:00:00	32020		\N	150435	0	195662009	4112343		0
38252	2272	260139	1994-09-14	1994-09-14 00:00:00	1994-09-21	1994-09-21 00:00:00	32020		\N	151022	0	10509002	260139		0
38498	2287	260139	1958-04-28	1958-04-28 00:00:00	1958-05-05	1958-05-05 00:00:00	32020		\N	152097	0	10509002	260139		0
38632	2292	258780	2011-01-28	2011-01-28 00:00:00	\N	\N	32020		\N	152589	0	185086009	258780		0
38721	2298	378001	2017-12-24	2017-12-24 00:00:00	2018-01-23	2018-01-23 00:00:00	32020		\N	153018	0	62106007	378001		0
38911	2311	4112343	1960-08-31	1960-08-31 00:00:00	1960-09-12	1960-09-12 00:00:00	32020		\N	153751	0	195662009	4112343		0
39135	2325	40481087	2005-05-21	2005-05-21 00:00:00	2005-05-28	2005-05-28 00:00:00	32020		\N	154560	0	444814009	40481087		0
39180	2326	4113008	2000-07-21	2000-07-21 00:00:00	2000-08-04	2000-08-04 00:00:00	32020		\N	154722	0	284549007	4113008		0
39429	2337	260139	2004-07-08	2004-07-08 00:00:00	2004-07-15	2004-07-15 00:00:00	32020		\N	155473	0	10509002	260139		0
39513	2341	40481087	1975-06-28	1975-06-28 00:00:00	1975-07-19	1975-07-19 00:00:00	32020		\N	155838	0	444814009	40481087		0
39722	2352	30753	2011-07-08	2011-07-08 00:00:00	\N	\N	32020		\N	156638	0	16761005	30753		0
39869	2359	4278672	1995-06-07	1995-06-07 00:00:00	1995-07-07	1995-07-07 00:00:00	32020		\N	157238	0	65966004	4278672		0
40011	2372	28060	1984-08-17	1984-08-17 00:00:00	1984-08-24	1984-08-24 00:00:00	32020		\N	157825	0	43878008	28060		0
40200	2384	40481087	2014-07-11	2014-07-11 00:00:00	2014-07-25	2014-07-25 00:00:00	32020		\N	158484	0	444814009	40481087		0
29869	1766	40481087	2003-09-03	2003-09-03 00:00:00	2003-09-17	2003-09-17 00:00:00	32020		\N	118179	0	444814009	40481087		0
40561	2412	28060	1955-08-12	1955-08-12 00:00:00	1955-08-24	1955-08-24 00:00:00	32020		\N	160032	0	43878008	28060		0
40752	2423	378001	1989-12-17	1989-12-17 00:00:00	1990-01-16	1990-01-16 00:00:00	32020		\N	160765	0	62106007	378001		0
40907	2433	260139	1996-02-06	1996-02-06 00:00:00	1996-02-20	1996-02-20 00:00:00	32020		\N	161282	0	10509002	260139		0
41149	2445	4112343	1940-06-02	1940-06-02 00:00:00	1940-06-15	1940-06-15 00:00:00	32020		\N	162256	0	195662009	4112343		0
41233	2450	78272	1970-08-22	1970-08-22 00:00:00	1970-09-26	1970-09-26 00:00:00	32020		\N	162559	0	70704007	78272		0
41398	2462	4112343	1964-09-25	1964-09-25 00:00:00	1964-10-05	1964-10-05 00:00:00	32020		\N	163292	0	195662009	4112343		0
41540	2469	4134304	1979-09-18	1979-09-18 00:00:00	1979-11-17	1979-11-17 00:00:00	32020		\N	163710	0	263102004	4134304		0
41702	2481	40481087	2002-12-21	2002-12-21 00:00:00	2003-01-11	2003-01-11 00:00:00	32020		\N	164397	0	444814009	40481087		0
41950	2497	40481087	1983-11-28	1983-11-28 00:00:00	1983-12-12	1983-12-12 00:00:00	32020		\N	165330	0	444814009	40481087		0
42099	2507	4059173	1996-11-16	1996-11-16 00:00:00	1997-01-15	1997-01-15 00:00:00	32020		\N	165954	0	16114001	4059173		0
42316	2521	40481087	2011-07-18	2011-07-18 00:00:00	2011-07-25	2011-07-25 00:00:00	32020		\N	166734	0	444814009	40481087		0
42444	2528	372328	1991-10-16	1991-10-16 00:00:00	1992-06-10	1992-06-10 00:00:00	32020		\N	167141	0	65363002	372328		0
31975	1900	192671	1996-01-04	1996-01-04 00:00:00	\N	\N	32020		\N	126520	0	K92.2	35208414		0
32166	1911	4116491	1987-11-16	1987-11-16 00:00:00	1987-12-30	1987-12-30 00:00:00	32020		\N	127168	0	301011002	4116491		0
32292	1918	4112343	1977-08-05	1977-08-05 00:00:00	1977-08-14	1977-08-14 00:00:00	32020		\N	127626	0	195662009	4112343		0
32458	1926	40481087	1992-05-27	1992-05-27 00:00:00	1992-06-03	1992-06-03 00:00:00	32020		\N	128234	0	444814009	40481087		0
22062	1320	372328	1939-02-26	1939-02-26 00:00:00	1939-08-10	1939-08-10 00:00:00	32020		\N	87493	0	65363002	372328		0
32803	1947	260139	1979-04-05	1979-04-05 00:00:00	1979-04-12	1979-04-12 00:00:00	32020		\N	129470	0	10509002	260139		0
32893	1951	4283893	1993-06-04	1993-06-04 00:00:00	1993-07-02	1993-07-02 00:00:00	32020		\N	129749	0	36971009	4283893		0
33095	1964	260139	1997-08-22	1997-08-22 00:00:00	1997-09-05	1997-09-05 00:00:00	32020		\N	130564	0	10509002	260139		0
33221	1971	28060	1971-04-07	1971-04-07 00:00:00	1971-04-17	1971-04-17 00:00:00	32020		\N	131020	0	43878008	28060		0
33436	1982	4142905	2004-05-01	2004-05-01 00:00:00	2004-07-30	2004-07-30 00:00:00	32020		\N	131962	0	33737001	4142905		0
33557	1990	372328	1970-04-25	1970-04-25 00:00:00	1970-05-09	1970-05-09 00:00:00	32020		\N	132508	0	65363002	372328		0
33726	2002	4278672	1986-05-24	1986-05-24 00:00:00	1986-07-23	1986-07-23 00:00:00	32020		\N	133381	0	65966004	4278672		0
33950	2016	4112343	2009-07-28	2009-07-28 00:00:00	2009-08-06	2009-08-06 00:00:00	32020		\N	134145	0	195662009	4112343		0
34105	2026	4112343	2012-02-28	2012-02-28 00:00:00	2012-03-07	2012-03-07 00:00:00	32020		\N	134859	0	195662009	4112343		0
34265	2033	40481087	1966-01-27	1966-01-27 00:00:00	1966-02-17	1966-02-17 00:00:00	32020		\N	135282	0	444814009	40481087		0
34476	2046	28060	1948-02-17	1948-02-17 00:00:00	1948-02-29	1948-02-29 00:00:00	32020		\N	136171	0	43878008	28060		0
24063	1435	260139	2016-09-11	2016-09-11 00:00:00	2016-09-18	2016-09-18 00:00:00	32020		\N	95578	0	10509002	260139		0
34841	2070	4112343	2018-02-04	2018-02-04 00:00:00	2018-02-11	2018-02-11 00:00:00	32020		\N	137765	0	195662009	4112343		0
34975	2077	134438	1958-03-27	1958-03-27 00:00:00	1958-11-24	1958-11-24 00:00:00	32020		\N	138240	0	40275004	134438		0
35035	2079	40481087	2009-12-02	2009-12-02 00:00:00	2009-12-09	2009-12-09 00:00:00	32020		\N	138458	0	444814009	40481087		0
35217	2088	40481087	1967-01-20	1967-01-20 00:00:00	1967-02-03	1967-02-03 00:00:00	32020		\N	139227	0	444814009	40481087		0
35460	2100	378001	1973-05-20	1973-05-20 00:00:00	1973-07-19	1973-07-19 00:00:00	32020		\N	139970	0	62106007	378001		0
35582	2108	440448	1978-08-31	1978-08-31 00:00:00	\N	\N	32020		\N	140356	0	74400008	440448		0
35705	2116	40481087	1990-07-11	1990-07-11 00:00:00	1990-07-25	1990-07-25 00:00:00	32020		\N	140805	0	444814009	40481087		0
25383	1512	4112343	2003-10-08	2003-10-08 00:00:00	2003-10-18	2003-10-18 00:00:00	32020		\N	100954	0	195662009	4112343		0
36107	2140	40481087	1989-10-28	1989-10-28 00:00:00	1989-11-18	1989-11-18 00:00:00	32020		\N	142551	0	444814009	40481087		0
36262	2149	40481087	1962-03-29	1962-03-29 00:00:00	1962-04-12	1962-04-12 00:00:00	32020		\N	143107	0	444814009	40481087		0
36433	2155	40481087	1938-12-15	1938-12-15 00:00:00	1939-01-05	1939-01-05 00:00:00	32020		\N	143574	0	444814009	40481087		0
36590	2165	372328	1954-11-28	1954-11-28 00:00:00	1955-02-08	1955-02-08 00:00:00	32020		\N	144197	0	65363002	372328		0
36744	2174	372328	1974-12-27	1974-12-27 00:00:00	1975-03-09	1975-03-09 00:00:00	32020		\N	144939	0	65363002	372328		0
36923	2185	4155034	1970-02-16	1970-02-16 00:00:00	1970-03-02	1970-03-02 00:00:00	32020		\N	145625	0	283371005	4155034		0
26538	1572	4112343	1980-01-20	1980-01-20 00:00:00	1980-01-29	1980-01-29 00:00:00	32020		\N	105606	0	195662009	4112343		0
37235	2204	80180	1986-11-16	1986-11-16 00:00:00	\N	\N	32020		\N	146917	0	396275006	80180		0
37432	2220	80180	1987-07-23	1987-07-23 00:00:00	\N	\N	32020		\N	147835	0	396275006	80180		0
37525	2226	372328	1947-02-11	1947-02-11 00:00:00	1947-09-26	1947-09-26 00:00:00	32020		\N	148140	0	65363002	372328		0
27215	1606	372328	1995-05-04	1995-05-04 00:00:00	1996-04-29	1996-04-29 00:00:00	32020		\N	107807	0	65363002	372328		0
37893	2244	78272	1972-04-15	1972-04-15 00:00:00	1972-05-06	1972-05-06 00:00:00	32020		\N	149382	0	70704007	78272		0
38142	2265	4283893	1997-03-26	1997-03-26 00:00:00	1997-08-13	1997-08-13 00:00:00	32020		\N	150596	0	36971009	4283893		0
38253	2272	81151	1996-09-02	1996-09-02 00:00:00	1996-10-07	1996-10-07 00:00:00	32020		\N	151061	0	44465007	81151		0
38499	2287	4218389	1960-07-10	1960-07-10 00:00:00	1960-08-14	1960-08-14 00:00:00	32020		\N	152148	0	39848009	4218389		0
38633	2292	257012	1964-12-22	1964-12-22 00:00:00	\N	\N	32020		\N	152563	0	40055000	257012		0
38722	2298	40481087	2008-07-07	2008-07-07 00:00:00	2008-07-21	2008-07-21 00:00:00	32020		\N	153005	0	444814009	40481087		0
38912	2311	40481087	1965-10-21	1965-10-21 00:00:00	1965-11-11	1965-11-11 00:00:00	32020		\N	153753	0	444814009	40481087		0
39136	2325	260139	2019-06-19	2019-06-19 00:00:00	\N	\N	32020		\N	154565	0	10509002	260139		0
39181	2326	80180	1994-01-13	1994-01-13 00:00:00	\N	\N	32020		\N	154697	0	396275006	80180		0
39430	2337	40481087	2006-10-09	2006-10-09 00:00:00	2006-10-23	2006-10-23 00:00:00	32020		\N	155537	0	444814009	40481087		0
39514	2341	4278672	1954-05-16	1954-05-16 00:00:00	1954-08-14	1954-08-14 00:00:00	32020		\N	155800	0	65966004	4278672		0
39723	2352	4051466	1972-11-01	1972-11-01 00:00:00	1990-02-05	1990-02-05 00:00:00	32020		\N	156644	0	233678006	4051466		0
39870	2359	81151	2008-12-16	2008-12-16 00:00:00	2009-01-06	2009-01-06 00:00:00	32020		\N	157241	0	44465007	81151		0
40012	2372	40481087	1986-03-18	1986-03-18 00:00:00	1986-04-01	1986-04-01 00:00:00	32020		\N	157867	0	444814009	40481087		0
40201	2384	4112343	1988-02-19	1988-02-19 00:00:00	1988-03-03	1988-03-03 00:00:00	32020		\N	158507	0	195662009	4112343		0
29870	1766	260139	1961-05-09	1961-05-09 00:00:00	1961-05-16	1961-05-16 00:00:00	32020		\N	118174	0	10509002	260139		0
40562	2412	40481087	2008-02-14	2008-02-14 00:00:00	2008-03-06	2008-03-06 00:00:00	32020		\N	160059	0	444814009	40481087		0
40753	2423	40481087	1974-02-18	1974-02-18 00:00:00	1974-03-04	1974-03-04 00:00:00	32020		\N	160721	0	444814009	40481087		0
40908	2433	260139	1962-12-22	1962-12-22 00:00:00	1962-12-29	1962-12-29 00:00:00	32020		\N	161281	0	10509002	260139		0
41150	2445	40481087	1964-09-01	1964-09-01 00:00:00	1964-09-15	1964-09-15 00:00:00	32020		\N	162198	0	444814009	40481087		0
41234	2450	40481087	1975-01-28	1975-01-28 00:00:00	1975-02-04	1975-02-04 00:00:00	32020		\N	162499	0	444814009	40481087		0
41399	2462	40481087	2009-12-11	2009-12-11 00:00:00	2009-12-18	2009-12-18 00:00:00	32020		\N	163202	0	444814009	40481087		0
41541	2469	40481087	1975-05-14	1975-05-14 00:00:00	1975-05-28	1975-05-28 00:00:00	32020		\N	163713	0	444814009	40481087		0
41703	2481	372328	1972-05-05	1972-05-05 00:00:00	1972-06-25	1972-06-25 00:00:00	32020		\N	164392	0	65363002	372328		0
41951	2497	4109685	1969-07-20	1969-07-20 00:00:00	1969-08-10	1969-08-10 00:00:00	32020		\N	165313	0	284551006	4109685		0
42100	2507	40481087	1991-06-07	1991-06-07 00:00:00	1991-06-28	1991-06-28 00:00:00	32020		\N	165947	0	444814009	40481087		0
42317	2521	4112343	1967-04-15	1967-04-15 00:00:00	1967-04-27	1967-04-27 00:00:00	32020		\N	166730	0	195662009	4112343		0
42458	2530	4112343	1983-06-08	1983-06-08 00:00:00	1983-06-17	1983-06-17 00:00:00	32020		\N	167214	0	195662009	4112343		0
31976	1900	260139	1980-01-04	1980-01-04 00:00:00	1980-01-11	1980-01-11 00:00:00	32020		\N	126475	0	10509002	260139		0
32167	1911	4113008	1979-08-30	1979-08-30 00:00:00	1979-09-13	1979-09-13 00:00:00	32020		\N	127176	0	284549007	4113008		0
32293	1918	4296204	1969-07-06	1969-07-06 00:00:00	1969-07-20	1969-07-20 00:00:00	32020		\N	127603	0	403190006	4296204		0
32459	1926	260139	2000-01-06	2000-01-06 00:00:00	2000-01-20	2000-01-20 00:00:00	32020		\N	128255	0	10509002	260139		0
22063	1320	40481087	1964-08-30	1964-08-30 00:00:00	1964-09-20	1964-09-20 00:00:00	32020		\N	87523	0	444814009	40481087		0
32804	1947	260139	1995-05-16	1995-05-16 00:00:00	1995-05-30	1995-05-30 00:00:00	32020		\N	129404	0	10509002	260139		0
32894	1951	372328	1982-10-05	1982-10-05 00:00:00	1982-10-19	1982-10-19 00:00:00	32020		\N	129755	0	65363002	372328		0
33096	1964	4112343	2004-08-08	2004-08-08 00:00:00	2004-08-16	2004-08-16 00:00:00	32020		\N	130556	0	195662009	4112343		0
33222	1971	372328	2015-08-27	2015-08-27 00:00:00	2017-04-07	2017-04-07 00:00:00	32020		\N	131107	0	65363002	372328		0
33437	1982	4296204	1993-03-09	1993-03-09 00:00:00	1993-03-30	1993-03-30 00:00:00	32020		\N	131960	0	403190006	4296204		0
33558	1990	28060	2002-11-28	2002-11-28 00:00:00	2002-12-07	2002-12-07 00:00:00	32020		\N	132487	0	43878008	28060		0
33727	2002	40479768	1983-08-01	1983-08-01 00:00:00	1983-10-07	1983-10-07 00:00:00	32020		\N	133380	0	444470001	40479768		0
33951	2016	78272	1998-05-30	1998-05-30 00:00:00	1998-07-04	1998-07-04 00:00:00	32020		\N	134107	0	70704007	78272		0
34106	2026	378001	2019-04-19	2019-04-19 00:00:00	2019-06-18	2019-06-18 00:00:00	32020		\N	134788	0	62106007	378001		0
34266	2033	40481087	2012-10-16	2012-10-16 00:00:00	2012-10-23	2012-10-23 00:00:00	32020		\N	135353	0	444814009	40481087		0
34477	2046	40481087	1996-04-19	1996-04-19 00:00:00	1996-05-03	1996-05-03 00:00:00	32020		\N	136175	0	444814009	40481087		0
24064	1435	4112343	1996-12-16	1996-12-16 00:00:00	1996-12-28	1996-12-28 00:00:00	32020		\N	95548	0	195662009	4112343		0
34842	2070	372328	1968-02-08	1968-02-08 00:00:00	1968-04-01	1968-04-01 00:00:00	32020		\N	137734	0	65363002	372328		0
34976	2077	40481087	1997-02-08	1997-02-08 00:00:00	1997-02-22	1997-02-22 00:00:00	32020		\N	138368	0	444814009	40481087		0
35036	2079	4218389	2016-03-26	2016-03-26 00:00:00	2016-04-23	2016-04-23 00:00:00	32020		\N	138491	0	39848009	4218389		0
35218	2088	4296205	1977-03-18	1977-03-18 00:00:00	1977-04-08	1977-04-08 00:00:00	32020		\N	139182	0	403191005	4296205		0
35461	2100	4278672	2012-08-28	2012-08-28 00:00:00	2012-11-26	2012-11-26 00:00:00	32020		\N	139973	0	65966004	4278672		0
35583	2108	260139	1974-03-09	1974-03-09 00:00:00	1974-03-23	1974-03-23 00:00:00	32020		\N	140314	0	10509002	260139		0
35706	2116	260139	1972-07-04	1972-07-04 00:00:00	1972-07-18	1972-07-18 00:00:00	32020		\N	140803	0	10509002	260139		0
25384	1512	372328	1979-11-04	1979-11-04 00:00:00	1980-07-30	1980-07-30 00:00:00	32020		\N	100994	0	65363002	372328		0
36108	2140	4310024	1987-07-27	1987-07-27 00:00:00	\N	\N	32020		\N	142576	0	424802006	4310024		0
36263	2149	381316	2005-11-12	2005-11-12 00:00:00	\N	\N	32020		\N	143066	0	230690007	381316		0
36434	2155	81151	1986-12-24	1986-12-24 00:00:00	1987-01-28	1987-01-28 00:00:00	32020		\N	143616	0	44465007	81151		0
36591	2165	4278672	1961-03-26	1961-03-26 00:00:00	1961-05-25	1961-05-25 00:00:00	32020		\N	144274	0	65966004	4278672		0
36745	2174	40481087	1995-03-15	1995-03-15 00:00:00	1995-03-29	1995-03-29 00:00:00	32020		\N	144929	0	444814009	40481087		0
36924	2185	40481087	1986-07-11	1986-07-11 00:00:00	1986-07-18	1986-07-18 00:00:00	32020		\N	145656	0	444814009	40481087		0
26539	1572	40481087	1994-03-08	1994-03-08 00:00:00	1994-03-15	1994-03-15 00:00:00	32020		\N	105594	0	444814009	40481087		0
37236	2204	4112343	1988-01-01	1988-01-01 00:00:00	1988-01-14	1988-01-14 00:00:00	32020		\N	146897	0	195662009	4112343		0
37433	2220	81893	1986-11-25	1986-11-25 00:00:00	\N	\N	32020		\N	147835	0	64766004	81893		0
37526	2226	372328	1943-05-31	1943-05-31 00:00:00	1943-07-02	1943-07-02 00:00:00	32020		\N	148149	0	65363002	372328		0
27216	1606	40481087	1997-06-13	1997-06-13 00:00:00	1997-07-04	1997-07-04 00:00:00	32020		\N	107802	0	444814009	40481087		0
37894	2244	4112343	1972-11-24	1972-11-24 00:00:00	1972-12-05	1972-12-05 00:00:00	32020		\N	149391	0	195662009	4112343		0
38143	2265	260139	1996-06-07	1996-06-07 00:00:00	1996-06-14	1996-06-14 00:00:00	32020		\N	150522	0	10509002	260139		0
38254	2272	40481087	1990-12-09	1990-12-09 00:00:00	1990-12-23	1990-12-23 00:00:00	32020		\N	151049	0	444814009	40481087		0
38500	2287	28060	1969-09-06	1969-09-06 00:00:00	1969-09-17	1969-09-17 00:00:00	32020		\N	152101	0	43878008	28060		0
38634	2292	372328	1966-08-31	1966-08-31 00:00:00	1966-09-14	1966-09-14 00:00:00	32020		\N	152570	0	65363002	372328		0
38723	2298	260139	1982-03-11	1982-03-11 00:00:00	1982-03-18	1982-03-18 00:00:00	32020		\N	153004	0	10509002	260139		0
38913	2311	40481087	1976-10-19	1976-10-19 00:00:00	1976-11-02	1976-11-02 00:00:00	32020		\N	153719	0	444814009	40481087		0
39137	2325	40481087	1980-12-26	1980-12-26 00:00:00	1981-01-02	1981-01-02 00:00:00	32020		\N	154585	0	444814009	40481087		0
39182	2326	28060	2009-07-23	2009-07-23 00:00:00	2009-08-04	2009-08-04 00:00:00	32020		\N	154662	0	43878008	28060		0
39431	2337	40481087	2005-03-25	2005-03-25 00:00:00	2005-04-08	2005-04-08 00:00:00	32020		\N	155474	0	444814009	40481087		0
39515	2341	40481087	1968-06-05	1968-06-05 00:00:00	1968-06-12	1968-06-12 00:00:00	32020		\N	155789	0	444814009	40481087		0
39724	2352	40481087	2007-07-11	2007-07-11 00:00:00	2007-07-18	2007-07-18 00:00:00	32020		\N	156621	0	444814009	40481087		0
39871	2359	28060	1945-10-12	1945-10-12 00:00:00	1945-10-24	1945-10-24 00:00:00	32020		\N	157176	0	43878008	28060		0
40013	2372	4155034	1974-04-14	1974-04-14 00:00:00	1974-05-05	1974-05-05 00:00:00	32020		\N	157840	0	283371005	4155034		0
40202	2384	4218389	2018-01-05	2018-01-05 00:00:00	2018-02-02	2018-02-02 00:00:00	32020		\N	158499	0	39848009	4218389		0
29871	1766	4112343	1952-12-23	1952-12-23 00:00:00	1953-01-05	1953-01-05 00:00:00	32020		\N	118172	0	195662009	4112343		0
40563	2412	80180	1994-12-01	1994-12-01 00:00:00	\N	\N	32020		\N	160054	0	396275006	80180		0
40754	2423	375671	2004-01-31	2004-01-31 00:00:00	2004-03-01	2004-03-01 00:00:00	32020		\N	160769	0	62564004	375671		0
40909	2433	4218389	1984-05-17	1984-05-17 00:00:00	1984-06-07	1984-06-07 00:00:00	32020		\N	161345	0	39848009	4218389		0
41151	2445	81151	1969-01-28	1969-01-28 00:00:00	1969-02-11	1969-02-11 00:00:00	32020		\N	162233	0	44465007	81151		0
41235	2450	439777	1974-12-29	1974-12-29 00:00:00	\N	\N	32020		\N	162503	0	271737000	439777		0
41400	2462	40481087	2009-08-17	2009-08-17 00:00:00	2009-09-07	2009-09-07 00:00:00	32020		\N	163332	0	444814009	40481087		0
41542	2469	372328	1977-04-12	1977-04-12 00:00:00	1977-07-24	1977-07-24 00:00:00	32020		\N	163750	0	65363002	372328		0
41704	2481	40481087	1990-02-07	1990-02-07 00:00:00	1990-02-28	1990-02-28 00:00:00	32020		\N	164407	0	444814009	40481087		0
41952	2497	78272	1990-04-22	1990-04-22 00:00:00	1990-05-13	1990-05-13 00:00:00	32020		\N	165314	0	70704007	78272		0
42101	2507	40481087	1985-06-03	1985-06-03 00:00:00	1985-06-17	1985-06-17 00:00:00	32020		\N	165931	0	444814009	40481087		0
42318	2521	78272	1964-04-15	1964-04-15 00:00:00	1964-05-13	1964-05-13 00:00:00	32020		\N	166737	0	70704007	78272		0
42459	2530	81151	1970-12-26	1970-12-26 00:00:00	1971-01-30	1971-01-30 00:00:00	32020		\N	167221	0	44465007	81151		0
31977	1900	40481087	2008-02-10	2008-02-10 00:00:00	2008-02-17	2008-02-17 00:00:00	32020		\N	126508	0	444814009	40481087		0
32168	1911	40481087	1982-07-02	1982-07-02 00:00:00	1982-07-16	1982-07-16 00:00:00	32020		\N	127167	0	444814009	40481087		0
32294	1918	4112343	2017-01-13	2017-01-13 00:00:00	2017-01-22	2017-01-22 00:00:00	32020		\N	127653	0	195662009	4112343		0
32460	1926	372328	1973-03-26	1973-03-26 00:00:00	1973-09-15	1973-09-15 00:00:00	32020		\N	128238	0	65363002	372328		0
22064	1320	81151	1959-10-09	1959-10-09 00:00:00	1959-11-06	1959-11-06 00:00:00	32020		\N	87475	0	44465007	81151		0
32805	1947	4112343	1998-03-30	1998-03-30 00:00:00	1998-04-09	1998-04-09 00:00:00	32020		\N	129474	0	195662009	4112343		0
32895	1952	78272	1964-01-10	1964-01-10 00:00:00	1964-02-14	1964-02-14 00:00:00	32020		\N	129787	0	70704007	78272		0
33097	1964	40481087	2018-12-07	2018-12-07 00:00:00	2018-12-21	2018-12-21 00:00:00	32020		\N	130602	0	444814009	40481087		0
33230	1973	260139	2004-11-04	2004-11-04 00:00:00	2004-11-18	2004-11-18 00:00:00	32020		\N	131190	0	10509002	260139		0
33438	1982	81151	1961-06-24	1961-06-24 00:00:00	1961-07-29	1961-07-29 00:00:00	32020		\N	131974	0	44465007	81151		0
33559	1990	4112343	1995-03-12	1995-03-12 00:00:00	1995-03-24	1995-03-24 00:00:00	32020		\N	132485	0	195662009	4112343		0
33728	2002	40481087	2015-11-15	2015-11-15 00:00:00	2015-11-29	2015-11-29 00:00:00	32020		\N	133334	0	444814009	40481087		0
33952	2016	40481087	2011-05-30	2011-05-30 00:00:00	2011-06-20	2011-06-20 00:00:00	32020		\N	134094	0	444814009	40481087		0
34107	2026	40481087	2000-07-23	2000-07-23 00:00:00	2000-08-06	2000-08-06 00:00:00	32020		\N	134856	0	444814009	40481087		0
34267	2033	260139	1959-05-11	1959-05-11 00:00:00	1959-05-25	1959-05-25 00:00:00	32020		\N	135329	0	10509002	260139		0
34478	2046	372328	2005-06-18	2005-06-18 00:00:00	2006-03-07	2006-03-07 00:00:00	32020		\N	136178	0	65363002	372328		0
24065	1435	4156265	1984-05-18	1984-05-18 00:00:00	1984-06-01	1984-06-01 00:00:00	32020		\N	95582	0	370247008	4156265		0
34843	2070	81151	1993-10-08	1993-10-08 00:00:00	1993-10-29	1993-10-29 00:00:00	32020		\N	137728	0	44465007	81151		0
34977	2077	78272	1996-10-21	1996-10-21 00:00:00	1996-11-04	1996-11-04 00:00:00	32020		\N	138378	0	70704007	78272		0
35037	2079	40481087	1980-03-31	1980-03-31 00:00:00	1980-04-21	1980-04-21 00:00:00	32020		\N	138447	0	444814009	40481087		0
35219	2088	4113008	2002-10-24	2002-10-24 00:00:00	2002-11-14	2002-11-14 00:00:00	32020		\N	139184	0	284549007	4113008		0
35462	2100	40479768	1976-06-03	1976-06-03 00:00:00	1976-07-10	1976-07-10 00:00:00	32020		\N	139971	0	444470001	40479768		0
35584	2108	4218389	1949-11-14	1949-11-14 00:00:00	1949-12-19	1949-12-19 00:00:00	32020		\N	140354	0	39848009	4218389		0
35707	2116	4112343	1971-07-04	1971-07-04 00:00:00	1971-07-16	1971-07-16 00:00:00	32020		\N	140802	0	195662009	4112343		0
25385	1512	4113008	2010-10-01	2010-10-01 00:00:00	2010-10-15	2010-10-15 00:00:00	32020		\N	100938	0	284549007	4113008		0
36109	2140	372328	1952-09-28	1952-09-28 00:00:00	1952-11-12	1952-11-12 00:00:00	32020		\N	142572	0	65363002	372328		0
36264	2149	40481087	2005-10-04	2005-10-04 00:00:00	2005-10-25	2005-10-25 00:00:00	32020		\N	143066	0	444814009	40481087		0
36435	2155	4109685	2003-06-03	2003-06-03 00:00:00	2003-06-17	2003-06-17 00:00:00	32020		\N	143618	0	284551006	4109685		0
36592	2165	378001	1978-05-17	1978-05-17 00:00:00	1978-07-16	1978-07-16 00:00:00	32020		\N	144276	0	62106007	378001		0
36746	2174	4294548	1990-12-08	1990-12-08 00:00:00	1991-04-13	1991-04-13 00:00:00	32020		\N	144932	0	75498004	4294548		0
36925	2185	40481087	1958-10-06	1958-10-06 00:00:00	1958-10-20	1958-10-20 00:00:00	32020		\N	145653	0	444814009	40481087		0
26540	1572	81151	1989-07-12	1989-07-12 00:00:00	1989-08-09	1989-08-09 00:00:00	32020		\N	105548	0	44465007	81151		0
37237	2204	4112343	1958-06-18	1958-06-18 00:00:00	1958-06-25	1958-06-25 00:00:00	32020		\N	146874	0	195662009	4112343		0
37434	2220	40481087	2019-01-26	2019-01-26 00:00:00	2019-02-16	2019-02-16 00:00:00	32020		\N	147840	0	444814009	40481087		0
37527	2226	4112343	1982-02-21	1982-02-21 00:00:00	1982-03-05	1982-03-05 00:00:00	32020		\N	148118	0	195662009	4112343		0
27217	1606	260139	1985-01-29	1985-01-29 00:00:00	1985-02-05	1985-02-05 00:00:00	32020		\N	107846	0	10509002	260139		0
37895	2244	40481087	1967-12-15	1967-12-15 00:00:00	1968-01-05	1968-01-05 00:00:00	32020		\N	149390	0	444814009	40481087		0
38144	2265	40481087	1985-10-28	1985-10-28 00:00:00	1985-11-18	1985-11-18 00:00:00	32020		\N	150549	0	444814009	40481087		0
38255	2272	4278672	1987-11-19	1987-11-19 00:00:00	1988-02-17	1988-02-17 00:00:00	32020		\N	151060	0	65966004	4278672		0
38501	2287	40481087	2012-12-19	2012-12-19 00:00:00	2012-12-26	2012-12-26 00:00:00	32020		\N	152195	0	444814009	40481087		0
38635	2292	81151	1979-02-24	1979-02-24 00:00:00	1979-03-24	1979-03-24 00:00:00	32020		\N	152595	0	44465007	81151		0
38724	2298	81151	1982-11-09	1982-11-09 00:00:00	1982-12-14	1982-12-14 00:00:00	32020		\N	153016	0	44465007	81151		0
38914	2311	260139	1960-10-28	1960-10-28 00:00:00	1960-11-04	1960-11-04 00:00:00	32020		\N	153752	0	10509002	260139		0
39138	2325	4112343	1999-01-03	1999-01-03 00:00:00	1999-01-12	1999-01-12 00:00:00	32020		\N	154618	0	195662009	4112343		0
39183	2326	260139	2010-02-20	2010-02-20 00:00:00	2010-03-06	2010-03-06 00:00:00	32020		\N	154663	0	10509002	260139		0
39432	2337	4156265	1990-02-22	1990-02-22 00:00:00	1990-03-15	1990-03-15 00:00:00	32020		\N	155539	0	370247008	4156265		0
39516	2341	4116491	1977-03-21	1977-03-21 00:00:00	1977-04-24	1977-04-24 00:00:00	32020		\N	155848	0	301011002	4116491		0
39725	2352	4112343	1997-06-25	1997-06-25 00:00:00	1997-07-02	1997-07-02 00:00:00	32020		\N	156685	0	195662009	4112343		0
39872	2359	4112343	2002-08-02	2002-08-02 00:00:00	2002-08-13	2002-08-13 00:00:00	32020		\N	157247	0	195662009	4112343		0
40014	2372	40481087	1987-07-04	1987-07-04 00:00:00	1987-07-25	1987-07-25 00:00:00	32020		\N	157826	0	444814009	40481087		0
40203	2384	80180	2017-03-04	2017-03-04 00:00:00	\N	\N	32020		\N	158521	0	396275006	80180		0
29872	1766	4112343	1994-04-15	1994-04-15 00:00:00	1994-04-26	1994-04-26 00:00:00	32020		\N	118147	0	195662009	4112343		0
40564	2412	40481087	1970-07-23	1970-07-23 00:00:00	1970-08-13	1970-08-13 00:00:00	32020		\N	160076	0	444814009	40481087		0
40755	2423	4218389	1992-11-01	1992-11-01 00:00:00	1992-11-22	1992-11-22 00:00:00	32020		\N	160766	0	39848009	4218389		0
40910	2433	4237458	1986-02-27	1986-02-27 00:00:00	1986-05-28	1986-05-28 00:00:00	32020		\N	161346	0	58150001	4237458		0
41152	2445	40481087	1962-06-18	1962-06-18 00:00:00	1962-07-09	1962-07-09 00:00:00	32020		\N	162188	0	444814009	40481087		0
41236	2450	40481087	1952-04-03	1952-04-03 00:00:00	1952-04-24	1952-04-24 00:00:00	32020		\N	162496	0	444814009	40481087		0
41401	2462	40481087	2005-03-13	2005-03-13 00:00:00	2005-04-03	2005-04-03 00:00:00	32020		\N	163291	0	444814009	40481087		0
41543	2469	4112343	1990-05-24	1990-05-24 00:00:00	1990-06-01	1990-06-01 00:00:00	32020		\N	163726	0	195662009	4112343		0
41705	2481	260139	1978-10-03	1978-10-03 00:00:00	1978-10-17	1978-10-17 00:00:00	32020		\N	164368	0	10509002	260139		0
41953	2497	4027663	1995-08-23	1995-08-23 00:00:00	\N	\N	32020		\N	165344	0	13200003	4027663		0
42102	2507	40481087	1990-05-31	1990-05-31 00:00:00	1990-06-07	1990-06-07 00:00:00	32020		\N	165993	0	444814009	40481087		0
42319	2521	372328	1949-01-13	1949-01-13 00:00:00	1949-02-28	1949-02-28 00:00:00	32020		\N	166685	0	65363002	372328		0
42460	2530	40481087	2008-04-22	2008-04-22 00:00:00	2008-04-29	2008-04-29 00:00:00	32020		\N	167218	0	444814009	40481087		0
31978	1900	260139	1971-12-26	1971-12-26 00:00:00	1972-01-09	1972-01-09 00:00:00	32020		\N	126507	0	10509002	260139		0
32169	1911	4112343	1953-02-05	1953-02-05 00:00:00	1953-02-16	1953-02-16 00:00:00	32020		\N	127142	0	195662009	4112343		0
32295	1918	80180	2004-11-19	2004-11-19 00:00:00	\N	\N	32020		\N	127657	0	396275006	80180		0
32461	1926	4112343	1978-07-02	1978-07-02 00:00:00	1978-07-10	1978-07-10 00:00:00	32020		\N	128252	0	195662009	4112343		0
22065	1320	378419	2016-10-13	2016-10-13 00:00:00	\N	\N	32020		\N	87525	0	26929004	378419		0
32806	1947	80180	1989-10-22	1989-10-22 00:00:00	\N	\N	32020		\N	129387	0	396275006	80180		0
32896	1952	40481087	2018-09-17	2018-09-17 00:00:00	2018-10-08	2018-10-08 00:00:00	32020		\N	129838	0	444814009	40481087		0
33098	1964	40481087	2011-02-24	2011-02-24 00:00:00	2011-03-03	2011-03-03 00:00:00	32020		\N	130565	0	444814009	40481087		0
33231	1973	81151	1978-04-15	1978-04-15 00:00:00	1978-04-29	1978-04-29 00:00:00	32020		\N	131200	0	44465007	81151		0
33439	1982	4294548	1929-03-01	1929-03-01 00:00:00	1929-03-22	1929-03-22 00:00:00	32020		\N	131998	0	75498004	4294548		0
33560	1990	260139	1980-11-18	1980-11-18 00:00:00	1980-12-02	1980-12-02 00:00:00	32020		\N	132483	0	10509002	260139		0
33729	2002	4112343	1999-04-09	1999-04-09 00:00:00	1999-04-18	1999-04-18 00:00:00	32020		\N	133353	0	195662009	4112343		0
33953	2016	40481087	2008-09-19	2008-09-19 00:00:00	2008-10-03	2008-10-03 00:00:00	32020		\N	134144	0	444814009	40481087		0
34108	2026	40481087	1954-10-05	1954-10-05 00:00:00	1954-10-19	1954-10-19 00:00:00	32020		\N	134797	0	444814009	40481087		0
34268	2033	4112343	2017-07-25	2017-07-25 00:00:00	2017-08-03	2017-08-03 00:00:00	32020		\N	135339	0	195662009	4112343		0
34479	2046	260139	2001-01-31	2001-01-31 00:00:00	2001-02-07	2001-02-07 00:00:00	32020		\N	136176	0	10509002	260139		0
24066	1435	4278672	2009-01-24	2009-01-24 00:00:00	2009-04-24	2009-04-24 00:00:00	32020		\N	95586	0	65966004	4278672		0
34844	2070	40481087	1975-05-24	1975-05-24 00:00:00	1975-06-07	1975-06-07 00:00:00	32020		\N	137743	0	444814009	40481087		0
34978	2077	381316	1981-08-23	1981-08-23 00:00:00	\N	\N	32020		\N	138312	0	230690007	381316		0
35039	2079	372328	1957-03-10	1957-03-10 00:00:00	1957-05-24	1957-05-24 00:00:00	32020		\N	138470	0	65363002	372328		0
35220	2088	40481087	1914-01-20	1914-01-20 00:00:00	1914-01-27	1914-01-27 00:00:00	32020		\N	139223	0	444814009	40481087		0
35463	2100	40481087	1990-02-13	1990-02-13 00:00:00	1990-02-27	1990-02-27 00:00:00	32020		\N	139957	0	444814009	40481087		0
35585	2108	4112343	1995-07-08	1995-07-08 00:00:00	1995-07-20	1995-07-20 00:00:00	32020		\N	140383	0	195662009	4112343		0
35708	2116	260139	2005-12-02	2005-12-02 00:00:00	2005-12-16	2005-12-16 00:00:00	32020		\N	140847	0	10509002	260139		0
25386	1512	260139	1983-04-05	1983-04-05 00:00:00	1983-04-12	1983-04-12 00:00:00	32020		\N	100952	0	10509002	260139		0
36110	2140	260139	1962-10-08	1962-10-08 00:00:00	1962-10-22	1962-10-22 00:00:00	32020		\N	142560	0	10509002	260139		0
36265	2149	4112343	1999-05-24	1999-05-24 00:00:00	1999-06-06	1999-06-06 00:00:00	32020		\N	143129	0	195662009	4112343		0
36436	2155	260139	1993-07-19	1993-07-19 00:00:00	1993-08-02	1993-08-02 00:00:00	32020		\N	143587	0	10509002	260139		0
36593	2165	40481087	1970-11-25	1970-11-25 00:00:00	1970-12-16	1970-12-16 00:00:00	32020		\N	144226	0	444814009	40481087		0
36747	2174	80180	2012-02-06	2012-02-06 00:00:00	\N	\N	32020		\N	144947	0	396275006	80180		0
36926	2185	4113008	1954-09-22	1954-09-22 00:00:00	1954-10-05	1954-10-05 00:00:00	32020		\N	145622	0	284549007	4113008		0
26541	1572	260139	1995-07-30	1995-07-30 00:00:00	1995-08-06	1995-08-06 00:00:00	32020		\N	105558	0	10509002	260139		0
37246	2206	260139	1987-11-10	1987-11-10 00:00:00	1987-11-17	1987-11-17 00:00:00	32020		\N	147051	0	10509002	260139		0
37435	2220	260139	2007-01-31	2007-01-31 00:00:00	2007-02-07	2007-02-07 00:00:00	32020		\N	147855	0	10509002	260139		0
37528	2226	40481087	1992-03-20	1992-03-20 00:00:00	1992-04-03	1992-04-03 00:00:00	32020		\N	148145	0	444814009	40481087		0
27218	1606	40481087	2003-07-02	2003-07-02 00:00:00	2003-07-16	2003-07-16 00:00:00	32020		\N	107860	0	444814009	40481087		0
37896	2244	4112343	1979-08-05	1979-08-05 00:00:00	1979-08-17	1979-08-17 00:00:00	32020		\N	149392	0	195662009	4112343		0
38145	2265	4112343	1971-08-06	1971-08-06 00:00:00	1971-08-13	1971-08-13 00:00:00	32020		\N	150558	0	195662009	4112343		0
38256	2272	28060	2010-06-20	2010-06-20 00:00:00	2010-07-02	2010-07-02 00:00:00	32020		\N	151033	0	43878008	28060		0
38502	2287	321042	2014-01-24	2014-01-24 00:00:00	\N	\N	32020		\N	152154	0	410429000	321042		0
38636	2292	4112343	2003-08-30	2003-08-30 00:00:00	2003-09-12	2003-09-12 00:00:00	32020		\N	152605	0	195662009	4112343		0
38725	2298	80180	2006-01-03	2006-01-03 00:00:00	\N	\N	32020		\N	152981	0	396275006	80180		0
38927	2314	40481087	2017-10-23	2017-10-23 00:00:00	2017-11-13	2017-11-13 00:00:00	32020		\N	153845	0	444814009	40481087		0
39139	2325	260139	2009-08-29	2009-08-29 00:00:00	2009-09-12	2009-09-12 00:00:00	32020		\N	154621	0	10509002	260139		0
39184	2326	4266809	1994-01-13	1994-01-13 00:00:00	\N	\N	32020		\N	154697	0	397881000	4266809		0
39433	2337	40481087	2012-09-29	2012-09-29 00:00:00	2012-10-20	2012-10-20 00:00:00	32020		\N	155538	0	444814009	40481087		0
39517	2341	372328	1955-12-21	1955-12-21 00:00:00	1957-01-03	1957-01-03 00:00:00	32020		\N	155863	0	65363002	372328		0
39726	2352	133834	1973-07-19	1973-07-19 00:00:00	\N	\N	32020		\N	156710	0	24079001	133834		0
39873	2359	381316	1982-12-27	1982-12-27 00:00:00	\N	\N	32020		\N	157205	0	230690007	381316		0
40015	2372	78272	2007-07-11	2007-07-11 00:00:00	2007-07-25	2007-07-25 00:00:00	32020		\N	157841	0	70704007	78272		0
40204	2384	4266809	2017-03-04	2017-03-04 00:00:00	\N	\N	32020		\N	158521	0	397881000	4266809		0
29873	1766	40481087	1999-03-09	1999-03-09 00:00:00	1999-03-16	1999-03-16 00:00:00	32020		\N	118178	0	444814009	40481087		0
40565	2412	4112343	1954-12-04	1954-12-04 00:00:00	1954-12-13	1954-12-13 00:00:00	32020		\N	160064	0	195662009	4112343		0
40756	2424	4294548	1969-06-25	1969-06-25 00:00:00	1969-07-16	1969-07-16 00:00:00	32020		\N	160806	0	75498004	4294548		0
40911	2433	4218389	1994-03-17	1994-03-17 00:00:00	1994-04-21	1994-04-21 00:00:00	32020		\N	161347	0	39848009	4218389		0
41153	2445	80180	1964-03-12	1964-03-12 00:00:00	\N	\N	32020		\N	162188	0	396275006	80180		0
41237	2450	40481087	1993-11-15	1993-11-15 00:00:00	1993-12-06	1993-12-06 00:00:00	32020		\N	162516	0	444814009	40481087		0
41402	2462	4112343	1980-10-24	1980-10-24 00:00:00	1980-11-04	1980-11-04 00:00:00	32020		\N	163220	0	195662009	4112343		0
41544	2469	4283893	2015-12-26	2015-12-26 00:00:00	2016-02-06	2016-02-06 00:00:00	32020		\N	163718	0	36971009	4283893		0
41706	2481	40481087	1981-05-29	1981-05-29 00:00:00	1981-06-19	1981-06-19 00:00:00	32020		\N	164406	0	444814009	40481087		0
41954	2498	317576	2006-04-08	2006-04-08 00:00:00	\N	\N	32020		\N	165420	0	53741008	317576		0
42103	2507	40481087	2006-10-23	2006-10-23 00:00:00	2006-11-06	2006-11-06 00:00:00	32020		\N	165950	0	444814009	40481087		0
42320	2521	40481087	2014-04-17	2014-04-17 00:00:00	2014-04-24	2014-04-24 00:00:00	32020		\N	166716	0	444814009	40481087		0
42461	2530	4230399	1972-12-20	1972-12-20 00:00:00	1973-01-19	1973-01-19 00:00:00	32020		\N	167222	0	359817006	4230399		0
31979	1900	80180	1995-11-18	1995-11-18 00:00:00	\N	\N	32020		\N	126490	0	396275006	80180		0
32170	1911	40481087	1991-06-07	1991-06-07 00:00:00	1991-06-28	1991-06-28 00:00:00	32020		\N	127144	0	444814009	40481087		0
32296	1918	28060	1998-01-15	1998-01-15 00:00:00	1998-01-28	1998-01-28 00:00:00	32020		\N	127619	0	43878008	28060		0
32462	1926	80180	2006-06-16	2006-06-16 00:00:00	\N	\N	32020		\N	128216	0	396275006	80180		0
22066	1320	4134304	1993-08-09	1993-08-09 00:00:00	1993-10-08	1993-10-08 00:00:00	32020		\N	87476	0	263102004	4134304		0
32807	1947	40481087	1970-09-21	1970-09-21 00:00:00	1970-10-05	1970-10-05 00:00:00	32020		\N	129393	0	444814009	40481087		0
32897	1952	40481087	2013-07-19	2013-07-19 00:00:00	2013-08-09	2013-08-09 00:00:00	32020		\N	129837	0	444814009	40481087		0
33099	1964	260139	2013-08-13	2013-08-13 00:00:00	2013-08-20	2013-08-20 00:00:00	32020		\N	130566	0	10509002	260139		0
33232	1973	260139	1995-09-22	1995-09-22 00:00:00	1995-10-06	1995-10-06 00:00:00	32020		\N	131162	0	10509002	260139		0
33440	1982	4112343	1985-09-23	1985-09-23 00:00:00	1985-10-01	1985-10-01 00:00:00	32020		\N	131994	0	195662009	4112343		0
33561	1990	378001	1992-06-30	1992-06-30 00:00:00	1992-08-29	1992-08-29 00:00:00	32020		\N	132504	0	62106007	378001		0
33730	2002	4218389	2019-02-14	2019-02-14 00:00:00	2019-03-14	2019-03-14 00:00:00	32020		\N	133365	0	39848009	4218389		0
33954	2016	4285898	2016-06-23	2016-06-23 00:00:00	\N	\N	32020		\N	134147	0	68496003	4285898		0
34109	2026	40481087	1983-07-31	1983-07-31 00:00:00	1983-08-14	1983-08-14 00:00:00	32020		\N	134857	0	444814009	40481087		0
34269	2033	260139	1980-08-03	1980-08-03 00:00:00	1980-08-17	1980-08-17 00:00:00	32020		\N	135376	0	10509002	260139		0
34480	2046	78272	1966-03-30	1966-03-30 00:00:00	1966-04-13	1966-04-13 00:00:00	32020		\N	136152	0	70704007	78272		0
24067	1435	40481087	2001-06-29	2001-06-29 00:00:00	2001-07-13	2001-07-13 00:00:00	32020		\N	95577	0	444814009	40481087		0
34845	2070	192671	2008-08-15	2008-08-15 00:00:00	\N	\N	32020		\N	137646	0	K92.2	35208414		0
34979	2077	4112343	1941-04-16	1941-04-16 00:00:00	1941-04-28	1941-04-28 00:00:00	32020		\N	138237	0	195662009	4112343		0
35040	2079	4152936	2008-01-17	2008-01-17 00:00:00	2008-02-07	2008-02-07 00:00:00	32020		\N	138490	0	283385000	4152936		0
35221	2088	81151	1974-01-05	1974-01-05 00:00:00	1974-02-02	1974-02-02 00:00:00	32020		\N	139181	0	44465007	81151		0
35464	2100	4112343	1977-11-23	1977-11-23 00:00:00	1977-12-03	1977-12-03 00:00:00	32020		\N	139984	0	195662009	4112343		0
35586	2108	313217	2018-12-28	2018-12-28 00:00:00	\N	\N	32020		\N	140382	0	49436004	313217		0
35709	2116	40481087	2016-04-08	2016-04-08 00:00:00	2016-04-22	2016-04-22 00:00:00	32020		\N	140788	0	444814009	40481087		0
25387	1512	4283893	2014-02-16	2014-02-16 00:00:00	2014-04-27	2014-04-27 00:00:00	32020		\N	101007	0	36971009	4283893		0
36111	2140	375671	1988-03-14	1988-03-14 00:00:00	1988-04-13	1988-04-13 00:00:00	32020		\N	142556	0	62564004	375671		0
36266	2149	4112343	2006-01-04	2006-01-04 00:00:00	2006-01-17	2006-01-17 00:00:00	32020		\N	143078	0	195662009	4112343		0
36437	2156	372328	1968-08-01	1968-08-01 00:00:00	1969-07-03	1969-07-03 00:00:00	32020		\N	143723	0	65363002	372328		0
36594	2165	372328	1959-07-17	1959-07-17 00:00:00	1960-05-03	1960-05-03 00:00:00	32020		\N	144228	0	65363002	372328		0
36748	2174	40481087	1994-03-05	1994-03-05 00:00:00	1994-03-12	1994-03-12 00:00:00	32020		\N	144936	0	444814009	40481087		0
36927	2185	260139	2018-11-23	2018-11-23 00:00:00	2018-11-30	2018-11-30 00:00:00	32020		\N	145658	0	10509002	260139		0
26542	1572	40481087	1983-08-20	1983-08-20 00:00:00	1983-08-27	1983-08-27 00:00:00	32020		\N	105607	0	444814009	40481087		0
37436	2220	260139	1980-08-24	1980-08-24 00:00:00	1980-08-31	1980-08-31 00:00:00	32020		\N	147770	0	10509002	260139		0
37529	2226	260139	1988-09-30	1988-09-30 00:00:00	1988-10-07	1988-10-07 00:00:00	32020		\N	148119	0	10509002	260139		0
27219	1606	28060	1958-06-12	1958-06-12 00:00:00	1958-06-25	1958-06-25 00:00:00	32020		\N	107879	0	43878008	28060		0
37897	2244	40481087	1995-01-26	1995-01-26 00:00:00	1995-02-02	1995-02-02 00:00:00	32020		\N	149397	0	444814009	40481087		0
38146	2265	4048171	1967-02-23	1967-02-23 00:00:00	1982-02-21	1982-02-21 00:00:00	32020		\N	150513	0	232353008	4048171		0
38257	2272	4112343	2010-02-10	2010-02-10 00:00:00	2010-02-17	2010-02-17 00:00:00	32020		\N	151012	0	195662009	4112343		0
38504	2287	40481087	1956-03-09	1956-03-09 00:00:00	1956-03-23	1956-03-23 00:00:00	32020		\N	152167	0	444814009	40481087		0
38637	2292	4112343	1971-03-27	1971-03-27 00:00:00	1971-04-04	1971-04-04 00:00:00	32020		\N	152568	0	195662009	4112343		0
38726	2298	4266809	2006-01-03	2006-01-03 00:00:00	\N	\N	32020		\N	152981	0	397881000	4266809		0
38928	2314	372328	1952-10-29	1952-10-29 00:00:00	1952-12-13	1952-12-13 00:00:00	32020		\N	153857	0	65363002	372328		0
39140	2325	40481087	2014-09-17	2014-09-17 00:00:00	2014-10-08	2014-10-08 00:00:00	32020		\N	154561	0	444814009	40481087		0
39185	2326	4112343	1983-02-05	1983-02-05 00:00:00	1983-02-18	1983-02-18 00:00:00	32020		\N	154647	0	195662009	4112343		0
39434	2337	78272	1978-01-28	1978-01-28 00:00:00	1978-02-25	1978-02-25 00:00:00	32020		\N	155490	0	70704007	78272		0
39518	2341	4112343	2014-08-17	2014-08-17 00:00:00	2014-08-28	2014-08-28 00:00:00	32020		\N	155862	0	195662009	4112343		0
39727	2352	40481087	2016-09-04	2016-09-04 00:00:00	2016-09-11	2016-09-11 00:00:00	32020		\N	156741	0	444814009	40481087		0
39874	2359	40481087	2003-08-02	2003-08-02 00:00:00	2003-08-23	2003-08-23 00:00:00	32020		\N	157218	0	444814009	40481087		0
40016	2372	40481087	2017-02-17	2017-02-17 00:00:00	2017-02-24	2017-02-24 00:00:00	32020		\N	157828	0	444814009	40481087		0
40205	2384	4112343	1989-03-02	1989-03-02 00:00:00	1989-03-12	1989-03-12 00:00:00	32020		\N	158476	0	195662009	4112343		0
29874	1766	40481087	2001-02-08	2001-02-08 00:00:00	2001-02-22	2001-02-22 00:00:00	32020		\N	118121	0	444814009	40481087		0
40566	2412	40481087	2018-10-15	2018-10-15 00:00:00	2018-10-22	2018-10-22 00:00:00	32020		\N	160035	0	444814009	40481087		0
40757	2424	80180	2004-04-19	2004-04-19 00:00:00	\N	\N	32020		\N	160866	0	396275006	80180		0
40912	2433	28060	1961-01-30	1961-01-30 00:00:00	1961-02-07	1961-02-07 00:00:00	32020		\N	161280	0	43878008	28060		0
41154	2445	4043241	1990-11-05	1990-11-05 00:00:00	\N	\N	32020		\N	162219	0	230265002	4043241		0
41238	2450	260139	1984-05-18	1984-05-18 00:00:00	1984-06-01	1984-06-01 00:00:00	32020		\N	162539	0	10509002	260139		0
41403	2462	80180	2002-02-10	2002-02-10 00:00:00	\N	\N	32020		\N	163239	0	396275006	80180		0
41545	2469	81893	2006-11-15	2006-11-15 00:00:00	\N	\N	32020		\N	163749	0	64766004	81893		0
41707	2481	4112343	2015-10-17	2015-10-17 00:00:00	2015-10-24	2015-10-24 00:00:00	32020		\N	164410	0	195662009	4112343		0
41955	2498	80180	2007-11-18	2007-11-18 00:00:00	\N	\N	32020		\N	165420	0	396275006	80180		0
42104	2507	40481087	1995-02-14	1995-02-14 00:00:00	1995-03-07	1995-03-07 00:00:00	32020		\N	165944	0	444814009	40481087		0
42321	2521	40481087	1962-10-10	1962-10-10 00:00:00	1962-10-31	1962-10-31 00:00:00	32020		\N	166759	0	444814009	40481087		0
42462	2530	372328	1965-03-04	1965-03-04 00:00:00	1965-04-04	1965-04-04 00:00:00	32020		\N	167235	0	65363002	372328		0
31980	1900	28060	1980-08-27	1980-08-27 00:00:00	1980-09-04	1980-09-04 00:00:00	32020		\N	126451	0	43878008	28060		0
32171	1911	40481087	1979-02-18	1979-02-18 00:00:00	1979-03-11	1979-03-11 00:00:00	32020		\N	127101	0	444814009	40481087		0
32297	1918	260139	1985-04-29	1985-04-29 00:00:00	1985-05-13	1985-05-13 00:00:00	32020		\N	127593	0	10509002	260139		0
32463	1926	4266809	2006-06-16	2006-06-16 00:00:00	\N	\N	32020		\N	128216	0	397881000	4266809		0
22067	1320	375671	1935-06-26	1935-06-26 00:00:00	1935-08-25	1935-08-25 00:00:00	32020		\N	87472	0	62564004	375671		0
32808	1947	4112343	1955-06-15	1955-06-15 00:00:00	1955-06-22	1955-06-22 00:00:00	32020		\N	129424	0	195662009	4112343		0
32898	1952	40481087	1961-12-14	1961-12-14 00:00:00	1961-12-28	1961-12-28 00:00:00	32020		\N	129777	0	444814009	40481087		0
33100	1964	81151	2009-04-25	2009-04-25 00:00:00	2009-05-23	2009-05-23 00:00:00	32020		\N	130553	0	44465007	81151		0
33233	1973	4112343	1981-05-18	1981-05-18 00:00:00	1981-05-26	1981-05-26 00:00:00	32020		\N	131145	0	195662009	4112343		0
33441	1982	28060	1992-10-26	1992-10-26 00:00:00	1992-11-05	1992-11-05 00:00:00	32020		\N	132019	0	43878008	28060		0
33562	1990	260139	2011-06-28	2011-06-28 00:00:00	2011-07-12	2011-07-12 00:00:00	32020		\N	132538	0	10509002	260139		0
33731	2002	81151	1982-07-02	1982-07-02 00:00:00	1982-08-06	1982-08-06 00:00:00	32020		\N	133379	0	44465007	81151		0
33955	2016	40481087	2013-11-12	2013-11-12 00:00:00	2013-12-03	2013-12-03 00:00:00	32020		\N	134147	0	444814009	40481087		0
34110	2026	40481087	1956-04-18	1956-04-18 00:00:00	1956-05-02	1956-05-02 00:00:00	32020		\N	134790	0	444814009	40481087		0
34270	2033	4237458	1956-04-25	1956-04-25 00:00:00	1956-07-24	1956-07-24 00:00:00	32020		\N	135298	0	58150001	4237458		0
34481	2046	4112343	2006-03-27	2006-03-27 00:00:00	2006-04-06	2006-04-06 00:00:00	32020		\N	136147	0	195662009	4112343		0
24068	1435	40481087	1964-08-29	1964-08-29 00:00:00	1964-09-19	1964-09-19 00:00:00	32020		\N	95572	0	444814009	40481087		0
34846	2070	4112343	1980-03-10	1980-03-10 00:00:00	1980-03-19	1980-03-19 00:00:00	32020		\N	137679	0	195662009	4112343		0
34980	2077	4156265	1962-08-21	1962-08-21 00:00:00	1962-09-04	1962-09-04 00:00:00	32020		\N	138213	0	370247008	4156265		0
35041	2079	40481087	1976-06-07	1976-06-07 00:00:00	1976-06-14	1976-06-14 00:00:00	32020		\N	138467	0	444814009	40481087		0
35222	2088	40481087	1981-05-14	1981-05-14 00:00:00	1981-05-28	1981-05-28 00:00:00	32020		\N	139229	0	444814009	40481087		0
35465	2100	372328	1945-01-12	1945-01-12 00:00:00	1945-02-12	1945-02-12 00:00:00	32020		\N	139962	0	65363002	372328		0
35588	2108	260139	1951-09-26	1951-09-26 00:00:00	1951-10-10	1951-10-10 00:00:00	32020		\N	140313	0	10509002	260139		0
35710	2116	4296205	2012-10-07	2012-10-07 00:00:00	2012-11-11	2012-11-11 00:00:00	32020		\N	140841	0	403191005	4296205		0
25388	1513	4112343	1985-05-25	1985-05-25 00:00:00	1985-06-02	1985-06-02 00:00:00	32020		\N	101120	0	195662009	4112343		0
36112	2140	40481087	1958-09-30	1958-09-30 00:00:00	1958-10-21	1958-10-21 00:00:00	32020		\N	142499	0	444814009	40481087		0
36267	2149	40481087	1984-10-06	1984-10-06 00:00:00	1984-10-20	1984-10-20 00:00:00	32020		\N	143060	0	444814009	40481087		0
36438	2156	4283893	1983-05-24	1983-05-24 00:00:00	1984-02-21	1984-02-21 00:00:00	32020		\N	143719	0	36971009	4283893		0
36595	2166	4146173	2003-01-13	2003-01-13 00:00:00	2003-03-14	2003-03-14 00:00:00	32020		\N	144305	0	307731004	4146173		0
36749	2174	260139	1991-06-03	1991-06-03 00:00:00	1991-06-17	1991-06-17 00:00:00	32020		\N	144935	0	10509002	260139		0
36928	2185	4237458	1992-09-03	1992-09-03 00:00:00	1992-10-03	1992-10-03 00:00:00	32020		\N	145626	0	58150001	4237458		0
26543	1572	4112343	2018-09-27	2018-09-27 00:00:00	2018-10-08	2018-10-08 00:00:00	32020		\N	105560	0	195662009	4112343		0
37248	2206	260139	2006-08-25	2006-08-25 00:00:00	2006-09-08	2006-09-08 00:00:00	32020		\N	147024	0	10509002	260139		0
37437	2220	40481087	1976-06-08	1976-06-08 00:00:00	1976-06-29	1976-06-29 00:00:00	32020		\N	147861	0	444814009	40481087		0
37530	2226	4027663	1968-01-17	1968-01-17 00:00:00	\N	\N	32020		\N	148162	0	13200003	4027663		0
27220	1606	372328	1953-03-17	1953-03-17 00:00:00	1953-06-08	1953-06-08 00:00:00	32020		\N	107823	0	65363002	372328		0
37898	2244	40481087	1991-07-02	1991-07-02 00:00:00	1991-07-09	1991-07-09 00:00:00	32020		\N	149387	0	444814009	40481087		0
38147	2265	260139	1975-09-26	1975-09-26 00:00:00	1975-10-10	1975-10-10 00:00:00	32020		\N	150548	0	10509002	260139		0
38258	2272	4310024	2014-02-20	2014-02-20 00:00:00	\N	\N	32020		\N	151013	0	424802006	4310024		0
38505	2287	78272	1945-12-12	1945-12-12 00:00:00	1945-12-26	1945-12-26 00:00:00	32020		\N	152096	0	70704007	78272		0
38638	2292	4112343	2017-06-19	2017-06-19 00:00:00	2017-06-26	2017-06-26 00:00:00	32020		\N	152596	0	195662009	4112343		0
38727	2298	40481087	1995-11-01	1995-11-01 00:00:00	1995-11-08	1995-11-08 00:00:00	32020		\N	152971	0	444814009	40481087		0
38929	2314	40481087	2005-08-28	2005-08-28 00:00:00	2005-09-18	2005-09-18 00:00:00	32020		\N	153891	0	444814009	40481087		0
39141	2325	40481087	2002-04-15	2002-04-15 00:00:00	2002-04-29	2002-04-29 00:00:00	32020		\N	154603	0	444814009	40481087		0
39186	2326	81151	1990-09-16	1990-09-16 00:00:00	1990-10-07	1990-10-07 00:00:00	32020		\N	154672	0	44465007	81151		0
39435	2337	260139	2016-09-11	2016-09-11 00:00:00	2016-09-18	2016-09-18 00:00:00	32020		\N	155524	0	10509002	260139		0
39519	2341	4112343	2007-03-13	2007-03-13 00:00:00	2007-03-25	2007-03-25 00:00:00	32020		\N	155818	0	195662009	4112343		0
39728	2352	40481087	1971-04-29	1971-04-29 00:00:00	1971-05-06	1971-05-06 00:00:00	32020		\N	156643	0	444814009	40481087		0
39875	2359	40481087	1998-12-21	1998-12-21 00:00:00	1999-01-04	1999-01-04 00:00:00	32020		\N	157258	0	444814009	40481087		0
40017	2372	372328	1965-04-01	1965-04-01 00:00:00	1965-05-14	1965-05-14 00:00:00	32020		\N	157844	0	65363002	372328		0
40206	2384	260139	2003-10-11	2003-10-11 00:00:00	2003-10-18	2003-10-18 00:00:00	32020		\N	158483	0	10509002	260139		0
40339	2394	40481087	1970-10-25	1970-10-25 00:00:00	1970-11-01	1970-11-01 00:00:00	32020		\N	159137	0	444814009	40481087		0
40567	2412	4296204	1982-11-16	1982-11-16 00:00:00	1982-12-14	1982-12-14 00:00:00	32020		\N	160095	0	403190006	4296204		0
40758	2424	4112343	2014-11-30	2014-11-30 00:00:00	2014-12-08	2014-12-08 00:00:00	32020		\N	160805	0	195662009	4112343		0
40913	2433	40481087	1970-05-21	1970-05-21 00:00:00	1970-06-04	1970-06-04 00:00:00	32020		\N	161314	0	444814009	40481087		0
41155	2445	260139	1981-09-08	1981-09-08 00:00:00	1981-09-15	1981-09-15 00:00:00	32020		\N	162222	0	10509002	260139		0
41239	2450	260139	2005-07-01	2005-07-01 00:00:00	2005-07-15	2005-07-15 00:00:00	32020		\N	162542	0	10509002	260139		0
41404	2462	40481087	1983-02-24	1983-02-24 00:00:00	1983-03-17	1983-03-17 00:00:00	32020		\N	163231	0	444814009	40481087		0
41546	2469	40481087	2006-09-26	2006-09-26 00:00:00	2006-10-10	2006-10-10 00:00:00	32020		\N	163749	0	444814009	40481087		0
41708	2481	40481087	2009-03-11	2009-03-11 00:00:00	2009-03-25	2009-03-25 00:00:00	32020		\N	164399	0	444814009	40481087		0
41956	2498	372328	1976-05-31	1976-05-31 00:00:00	1977-01-01	1977-01-01 00:00:00	32020		\N	165409	0	65363002	372328		0
42105	2507	260139	2009-03-11	2009-03-11 00:00:00	2009-03-25	2009-03-25 00:00:00	32020		\N	165966	0	10509002	260139		0
42322	2521	4112343	2001-07-06	2001-07-06 00:00:00	2001-07-17	2001-07-17 00:00:00	32020		\N	166768	0	195662009	4112343		0
42463	2530	4112343	1985-06-10	1985-06-10 00:00:00	1985-06-18	1985-06-18 00:00:00	32020		\N	167215	0	195662009	4112343		0
31981	1900	260139	2017-08-26	2017-08-26 00:00:00	2017-09-02	2017-09-02 00:00:00	32020		\N	126456	0	10509002	260139		0
32172	1911	28060	1989-08-02	1989-08-02 00:00:00	1989-08-11	1989-08-11 00:00:00	32020		\N	127127	0	43878008	28060		0
32298	1918	4112343	2010-10-06	2010-10-06 00:00:00	2010-10-13	2010-10-13 00:00:00	32020		\N	127652	0	195662009	4112343		0
32464	1926	372328	1974-09-12	1974-09-12 00:00:00	1975-03-22	1975-03-22 00:00:00	32020		\N	128247	0	65363002	372328		0
22068	1320	40481087	1958-10-03	1958-10-03 00:00:00	1958-10-10	1958-10-10 00:00:00	32020		\N	87558	0	444814009	40481087		0
32809	1947	40481087	1982-08-30	1982-08-30 00:00:00	1982-09-06	1982-09-06 00:00:00	32020		\N	129429	0	444814009	40481087		0
32899	1952	4237458	1967-12-25	1967-12-25 00:00:00	1968-01-24	1968-01-24 00:00:00	32020		\N	129788	0	58150001	4237458		0
33101	1964	40481087	2017-03-01	2017-03-01 00:00:00	2017-03-08	2017-03-08 00:00:00	32020		\N	130601	0	444814009	40481087		0
33234	1973	80180	2011-07-17	2011-07-17 00:00:00	\N	\N	32020		\N	131163	0	396275006	80180		0
33442	1982	40481087	1960-12-06	1960-12-06 00:00:00	1960-12-13	1960-12-13 00:00:00	32020		\N	132033	0	444814009	40481087		0
33563	1990	372328	1968-06-15	1968-06-15 00:00:00	1968-11-01	1968-11-01 00:00:00	32020		\N	132545	0	65363002	372328		0
33732	2002	4112343	2008-09-12	2008-09-12 00:00:00	2008-09-25	2008-09-25 00:00:00	32020		\N	133345	0	195662009	4112343		0
33956	2016	4112343	2017-06-14	2017-06-14 00:00:00	2017-06-21	2017-06-21 00:00:00	32020		\N	134095	0	195662009	4112343		0
34111	2026	40481087	2018-07-23	2018-07-23 00:00:00	2018-07-30	2018-07-30 00:00:00	32020		\N	134828	0	444814009	40481087		0
34271	2033	260139	2004-10-17	2004-10-17 00:00:00	2004-10-31	2004-10-31 00:00:00	32020		\N	135352	0	10509002	260139		0
34482	2046	372328	2003-08-13	2003-08-13 00:00:00	2004-02-24	2004-02-24 00:00:00	32020		\N	136160	0	65363002	372328		0
24069	1435	4155034	1996-02-13	1996-02-13 00:00:00	1996-02-27	1996-02-27 00:00:00	32020		\N	95584	0	283371005	4155034		0
34847	2070	4027663	1996-10-18	1996-10-18 00:00:00	\N	\N	32020		\N	137778	0	13200003	4027663		0
34981	2077	4048695	1988-05-04	1988-05-04 00:00:00	1988-07-05	1988-07-05 00:00:00	32020		\N	138215	0	15724005	4048695		0
35042	2079	4109685	1978-06-18	1978-06-18 00:00:00	1978-07-09	1978-07-09 00:00:00	32020		\N	138488	0	284551006	4109685		0
35223	2088	372328	1910-02-14	1910-02-14 00:00:00	1910-06-28	1910-06-28 00:00:00	32020		\N	139296	0	65363002	372328		0
35466	2100	4218389	1960-06-22	1960-06-22 00:00:00	1960-07-27	1960-07-27 00:00:00	32020		\N	139969	0	39848009	4218389		0
35589	2108	40481087	2016-04-27	2016-04-27 00:00:00	2016-05-04	2016-05-04 00:00:00	32020		\N	140387	0	444814009	40481087		0
35711	2116	40481087	1975-01-17	1975-01-17 00:00:00	1975-01-31	1975-01-31 00:00:00	32020		\N	140791	0	444814009	40481087		0
25389	1513	28060	1975-09-30	1975-09-30 00:00:00	1975-10-12	1975-10-12 00:00:00	32020		\N	101117	0	43878008	28060		0
36113	2140	4112343	1980-01-01	1980-01-01 00:00:00	1980-01-10	1980-01-10 00:00:00	32020		\N	142506	0	195662009	4112343		0
36268	2149	257012	1961-12-22	1961-12-22 00:00:00	\N	\N	32020		\N	143123	0	40055000	257012		0
36439	2156	80180	2009-03-04	2009-03-04 00:00:00	\N	\N	32020		\N	143702	0	396275006	80180		0
36596	2166	4109685	2006-01-27	2006-01-27 00:00:00	2006-02-17	2006-02-17 00:00:00	32020		\N	144343	0	284551006	4109685		0
36750	2174	257012	1991-01-19	1991-01-19 00:00:00	\N	\N	32020		\N	144933	0	40055000	257012		0
36929	2185	40481087	1970-02-15	1970-02-15 00:00:00	1970-03-08	1970-03-08 00:00:00	32020		\N	145673	0	444814009	40481087		0
26544	1572	260139	2016-07-27	2016-07-27 00:00:00	2016-08-10	2016-08-10 00:00:00	32020		\N	105579	0	10509002	260139		0
37249	2206	81893	2006-10-20	2006-10-20 00:00:00	\N	\N	32020		\N	147024	0	64766004	81893		0
37438	2220	372328	1942-05-15	1942-05-15 00:00:00	1942-07-22	1942-07-22 00:00:00	32020		\N	147776	0	65363002	372328		0
37531	2226	4112343	1950-03-29	1950-03-29 00:00:00	1950-04-08	1950-04-08 00:00:00	32020		\N	148074	0	195662009	4112343		0
27221	1606	78272	1977-08-04	1977-08-04 00:00:00	1977-08-18	1977-08-18 00:00:00	32020		\N	107856	0	70704007	78272		0
37899	2244	260139	1976-01-16	1976-01-16 00:00:00	1976-01-23	1976-01-23 00:00:00	32020		\N	149379	0	10509002	260139		0
38148	2265	40481087	2002-07-26	2002-07-26 00:00:00	2002-08-02	2002-08-02 00:00:00	32020		\N	150524	0	444814009	40481087		0
38259	2272	81893	2014-07-20	2014-07-20 00:00:00	\N	\N	32020		\N	151013	0	64766004	81893		0
38506	2287	40481087	1962-08-18	1962-08-18 00:00:00	1962-08-25	1962-08-25 00:00:00	32020		\N	152128	0	444814009	40481087		0
38639	2292	260139	2001-12-26	2001-12-26 00:00:00	2002-01-09	2002-01-09 00:00:00	32020		\N	152613	0	10509002	260139		0
38728	2298	260139	2018-02-08	2018-02-08 00:00:00	2018-02-22	2018-02-22 00:00:00	32020		\N	153019	0	10509002	260139		0
38930	2314	260139	1991-12-04	1991-12-04 00:00:00	1991-12-18	1991-12-18 00:00:00	32020		\N	153890	0	10509002	260139		0
39142	2325	80180	2013-04-06	2013-04-06 00:00:00	\N	\N	32020		\N	154598	0	396275006	80180		0
39187	2326	375671	1952-02-03	1952-02-03 00:00:00	1952-03-04	1952-03-04 00:00:00	32020		\N	154643	0	62564004	375671		0
39436	2337	4112343	2015-07-31	2015-07-31 00:00:00	2015-08-09	2015-08-09 00:00:00	32020		\N	155523	0	195662009	4112343		0
39520	2341	78272	1969-02-17	1969-02-17 00:00:00	1969-03-03	1969-03-03 00:00:00	32020		\N	155802	0	70704007	78272		0
39729	2352	4112343	2014-05-16	2014-05-16 00:00:00	2014-05-24	2014-05-24 00:00:00	32020		\N	156740	0	195662009	4112343		0
39876	2359	4112343	1926-10-10	1926-10-10 00:00:00	1926-10-19	1926-10-19 00:00:00	32020		\N	157268	0	195662009	4112343		0
40018	2373	4112343	1962-07-03	1962-07-03 00:00:00	1962-07-13	1962-07-13 00:00:00	32020		\N	157954	0	195662009	4112343		0
40207	2384	4278672	1997-05-13	1997-05-13 00:00:00	1997-08-11	1997-08-11 00:00:00	32020		\N	158495	0	65966004	4278672		0
40340	2394	81151	1912-02-25	1912-02-25 00:00:00	1912-03-10	1912-03-10 00:00:00	32020		\N	159152	0	44465007	81151		0
40568	2412	40481087	1951-04-26	1951-04-26 00:00:00	1951-05-10	1951-05-10 00:00:00	32020		\N	160058	0	444814009	40481087		0
40759	2424	40481087	1968-09-16	1968-09-16 00:00:00	1968-09-23	1968-09-23 00:00:00	32020		\N	160801	0	444814009	40481087		0
40914	2433	80180	1992-01-27	1992-01-27 00:00:00	\N	\N	32020		\N	161322	0	396275006	80180		0
41156	2445	4112343	1935-08-19	1935-08-19 00:00:00	1935-08-27	1935-08-27 00:00:00	32020		\N	162197	0	195662009	4112343		0
41240	2450	372328	1952-07-27	1952-07-27 00:00:00	1952-12-11	1952-12-11 00:00:00	32020		\N	162492	0	65363002	372328		0
41405	2462	4112343	2008-03-30	2008-03-30 00:00:00	2008-04-12	2008-04-12 00:00:00	32020		\N	163302	0	195662009	4112343		0
41547	2469	40481087	1972-01-03	1972-01-03 00:00:00	1972-01-24	1972-01-24 00:00:00	32020		\N	163733	0	444814009	40481087		0
41709	2481	40481087	1996-09-02	1996-09-02 00:00:00	1996-09-16	1996-09-16 00:00:00	32020		\N	164370	0	444814009	40481087		0
41957	2498	4218389	1986-10-17	1986-10-17 00:00:00	1986-11-14	1986-11-14 00:00:00	32020		\N	165402	0	39848009	4218389		0
42106	2507	40481087	2003-03-03	2003-03-03 00:00:00	2003-03-17	2003-03-17 00:00:00	32020		\N	165994	0	444814009	40481087		0
42323	2521	195588	1989-03-02	1989-03-02 00:00:00	1989-04-12	1989-04-12 00:00:00	32020		\N	166765	0	38822007	195588		0
42464	2530	40481087	1975-06-19	1975-06-19 00:00:00	1975-06-26	1975-06-26 00:00:00	32020		\N	167211	0	444814009	40481087		0
31982	1900	4112343	1990-01-16	1990-01-16 00:00:00	1990-01-26	1990-01-26 00:00:00	32020		\N	126459	0	195662009	4112343		0
32173	1911	40481087	1948-05-20	1948-05-20 00:00:00	1948-06-10	1948-06-10 00:00:00	32020		\N	127141	0	444814009	40481087		0
32299	1918	4155034	2018-08-21	2018-08-21 00:00:00	2018-09-11	2018-09-11 00:00:00	32020		\N	127587	0	283371005	4155034		0
32465	1926	4112343	2007-01-07	2007-01-07 00:00:00	2007-01-16	2007-01-16 00:00:00	32020		\N	128256	0	195662009	4112343		0
22069	1320	40481087	1981-01-02	1981-01-02 00:00:00	1981-01-23	1981-01-23 00:00:00	32020		\N	87580	0	444814009	40481087		0
32810	1947	4278672	1956-05-22	1956-05-22 00:00:00	1956-08-20	1956-08-20 00:00:00	32020		\N	129465	0	65966004	4278672		0
32900	1952	372328	1959-09-05	1959-09-05 00:00:00	1960-07-18	1960-07-18 00:00:00	32020		\N	129839	0	65363002	372328		0
33102	1964	81151	1966-07-05	1966-07-05 00:00:00	1966-08-09	1966-08-09 00:00:00	32020		\N	130552	0	44465007	81151		0
33235	1973	4112343	2010-12-21	2010-12-21 00:00:00	2010-12-30	2010-12-30 00:00:00	32020		\N	131163	0	195662009	4112343		0
33443	1982	40481087	1923-11-19	1923-11-19 00:00:00	1923-12-03	1923-12-03 00:00:00	32020		\N	132011	0	444814009	40481087		0
33564	1990	40481087	1999-01-23	1999-01-23 00:00:00	1999-02-06	1999-02-06 00:00:00	32020		\N	132507	0	444814009	40481087		0
33733	2002	260139	1980-05-17	1980-05-17 00:00:00	1980-05-31	1980-05-31 00:00:00	32020		\N	133324	0	10509002	260139		0
33957	2017	28060	1971-02-20	1971-02-20 00:00:00	1971-02-27	1971-02-27 00:00:00	32020		\N	134166	0	43878008	28060		0
34112	2026	4116491	1974-01-05	1974-01-05 00:00:00	1974-03-04	1974-03-04 00:00:00	32020		\N	134854	0	301011002	4116491		0
34272	2034	260139	2006-05-19	2006-05-19 00:00:00	2006-05-26	2006-05-26 00:00:00	32020		\N	135517	0	10509002	260139		0
34483	2046	4283893	1982-03-21	1982-03-21 00:00:00	1982-04-25	1982-04-25 00:00:00	32020		\N	136181	0	36971009	4283893		0
24070	1435	260139	2010-03-23	2010-03-23 00:00:00	2010-04-06	2010-04-06 00:00:00	32020		\N	95587	0	10509002	260139		0
34848	2070	78272	1978-05-16	1978-05-16 00:00:00	1978-05-30	1978-05-30 00:00:00	32020		\N	137726	0	70704007	78272		0
34982	2077	40481087	2012-01-14	2012-01-14 00:00:00	2012-02-04	2012-02-04 00:00:00	32020		\N	138275	0	444814009	40481087		0
35043	2080	80180	2019-05-20	2019-05-20 00:00:00	\N	\N	32020		\N	138531	0	396275006	80180		0
35224	2088	4283893	1974-06-15	1974-06-15 00:00:00	1974-08-10	1974-08-10 00:00:00	32020		\N	139200	0	36971009	4283893		0
35467	2100	375671	1948-05-12	1948-05-12 00:00:00	1948-06-11	1948-06-11 00:00:00	32020		\N	139967	0	62564004	375671		0
35590	2108	40481087	1974-04-17	1974-04-17 00:00:00	1974-05-08	1974-05-08 00:00:00	32020		\N	140399	0	444814009	40481087		0
35712	2116	40481087	2009-10-19	2009-10-19 00:00:00	2009-11-02	2009-11-02 00:00:00	32020		\N	140849	0	444814009	40481087		0
25390	1513	28060	2009-11-28	2009-11-28 00:00:00	2009-12-10	2009-12-10 00:00:00	32020		\N	101108	0	43878008	28060		0
36114	2140	40481087	1985-01-06	1985-01-06 00:00:00	1985-01-20	1985-01-20 00:00:00	32020		\N	142507	0	444814009	40481087		0
36269	2149	4112343	2016-06-27	2016-06-27 00:00:00	2016-07-07	2016-07-07 00:00:00	32020		\N	143080	0	195662009	4112343		0
36440	2156	40481087	2008-10-17	2008-10-17 00:00:00	2008-10-24	2008-10-24 00:00:00	32020		\N	143702	0	444814009	40481087		0
36597	2166	4146173	2009-09-29	2009-09-29 00:00:00	2009-10-29	2009-10-29 00:00:00	32020		\N	144306	0	307731004	4146173		0
36751	2175	134438	2009-01-27	2009-01-27 00:00:00	2010-01-26	2010-01-26 00:00:00	32020		\N	144997	0	40275004	134438		0
36930	2185	40481087	1957-05-23	1957-05-23 00:00:00	1957-06-06	1957-06-06 00:00:00	32020		\N	145672	0	444814009	40481087		0
26545	1572	4156265	1972-11-26	1972-11-26 00:00:00	1972-12-10	1972-12-10 00:00:00	32020		\N	105544	0	370247008	4156265		0
37250	2206	40481087	2018-03-06	2018-03-06 00:00:00	2018-03-13	2018-03-13 00:00:00	32020		\N	147039	0	444814009	40481087		0
37439	2220	40481087	1992-08-10	1992-08-10 00:00:00	1992-08-24	1992-08-24 00:00:00	32020		\N	147773	0	444814009	40481087		0
37532	2226	4285898	1977-09-06	1977-09-06 00:00:00	\N	\N	32020		\N	148101	0	68496003	4285898		0
27222	1606	4112343	1959-06-23	1959-06-23 00:00:00	1959-07-04	1959-07-04 00:00:00	32020		\N	107880	0	195662009	4112343		0
37900	2244	4112343	2006-05-09	2006-05-09 00:00:00	2006-05-20	2006-05-20 00:00:00	32020		\N	149406	0	195662009	4112343		0
38149	2265	4109685	1978-10-26	1978-10-26 00:00:00	1978-11-09	1978-11-09 00:00:00	32020		\N	150603	0	284551006	4109685		0
38260	2272	28060	2013-11-17	2013-11-17 00:00:00	2013-11-27	2013-11-27 00:00:00	32020		\N	151013	0	43878008	28060		0
38507	2287	257012	1964-09-17	1964-09-17 00:00:00	\N	\N	32020		\N	152116	0	40055000	257012		0
38640	2292	4035415	1986-08-14	1986-08-14 00:00:00	1986-09-13	1986-09-13 00:00:00	32020		\N	152634	0	239720000	4035415		0
38729	2298	372328	1972-02-21	1972-02-21 00:00:00	1972-04-06	1972-04-06 00:00:00	32020		\N	153020	0	65363002	372328		0
38931	2314	4112343	2004-12-12	2004-12-12 00:00:00	2004-12-21	2004-12-21 00:00:00	32020		\N	153844	0	195662009	4112343		0
39143	2325	260139	1983-07-04	1983-07-04 00:00:00	1983-07-11	1983-07-11 00:00:00	32020		\N	154557	0	10509002	260139		0
39188	2327	260139	1970-11-08	1970-11-08 00:00:00	1970-11-15	1970-11-15 00:00:00	32020		\N	154732	0	10509002	260139		0
39437	2337	4155034	1999-12-23	1999-12-23 00:00:00	2000-01-06	2000-01-06 00:00:00	32020		\N	155540	0	283371005	4155034		0
39521	2341	260139	2006-05-28	2006-05-28 00:00:00	2006-06-04	2006-06-04 00:00:00	32020		\N	155817	0	10509002	260139		0
39730	2352	28060	2013-02-10	2013-02-10 00:00:00	2013-02-18	2013-02-18 00:00:00	32020		\N	156603	0	43878008	28060		0
39877	2359	4112343	1997-08-14	1997-08-14 00:00:00	1997-08-24	1997-08-24 00:00:00	32020		\N	157180	0	195662009	4112343		0
40019	2373	4112343	1988-07-17	1988-07-17 00:00:00	1988-07-24	1988-07-24 00:00:00	32020		\N	157899	0	195662009	4112343		0
40208	2384	4027663	2010-02-14	2010-02-14 00:00:00	\N	\N	32020		\N	158493	0	13200003	4027663		0
40341	2394	260139	1956-04-19	1956-04-19 00:00:00	1956-04-26	1956-04-26 00:00:00	32020		\N	159149	0	10509002	260139		0
40569	2412	372328	1951-02-20	1951-02-20 00:00:00	1951-05-04	1951-05-04 00:00:00	32020		\N	160080	0	65363002	372328		0
40760	2424	260139	2005-06-30	2005-06-30 00:00:00	2005-07-14	2005-07-14 00:00:00	32020		\N	160807	0	10509002	260139		0
41157	2445	28060	1933-02-22	1933-02-22 00:00:00	1933-03-01	1933-03-01 00:00:00	32020		\N	162255	0	43878008	28060		0
41241	2450	260139	1966-11-13	1966-11-13 00:00:00	1966-11-27	1966-11-27 00:00:00	32020		\N	162498	0	10509002	260139		0
41406	2462	4296205	1997-09-29	1997-09-29 00:00:00	1997-11-03	1997-11-03 00:00:00	32020		\N	163200	0	403191005	4296205		0
41548	2469	40481087	2014-09-03	2014-09-03 00:00:00	2014-09-24	2014-09-24 00:00:00	32020		\N	163717	0	444814009	40481087		0
41710	2481	378001	2018-06-22	2018-06-22 00:00:00	2018-08-21	2018-08-21 00:00:00	32020		\N	164367	0	62106007	378001		0
41958	2498	4112343	1975-12-19	1975-12-19 00:00:00	1975-12-31	1975-12-31 00:00:00	32020		\N	165384	0	195662009	4112343		0
42107	2507	372328	1973-01-19	1973-01-19 00:00:00	1973-04-17	1973-04-17 00:00:00	32020		\N	165996	0	65363002	372328		0
42324	2521	4112343	1955-02-07	1955-02-07 00:00:00	1955-02-19	1955-02-19 00:00:00	32020		\N	166729	0	195662009	4112343		0
42465	2530	260139	1988-08-04	1988-08-04 00:00:00	1988-08-11	1988-08-11 00:00:00	32020		\N	167252	0	10509002	260139		0
31983	1900	40481087	1979-11-04	1979-11-04 00:00:00	1979-11-11	1979-11-11 00:00:00	32020		\N	126464	0	444814009	40481087		0
32174	1911	4134304	1960-03-12	1960-03-12 00:00:00	1960-06-10	1960-06-10 00:00:00	32020		\N	127175	0	263102004	4134304		0
32313	1921	4112343	1978-03-18	1978-03-18 00:00:00	1978-03-30	1978-03-30 00:00:00	32020		\N	127743	0	195662009	4112343		0
32466	1926	4237458	1984-06-26	1984-06-26 00:00:00	1984-08-25	1984-08-25 00:00:00	32020		\N	128199	0	58150001	4237458		0
22070	1320	4152936	1947-09-21	1947-09-21 00:00:00	1947-10-12	1947-10-12 00:00:00	32020		\N	87474	0	283385000	4152936		0
32811	1947	40481087	2004-05-20	2004-05-20 00:00:00	2004-06-03	2004-06-03 00:00:00	32020		\N	129475	0	444814009	40481087		0
32901	1952	28060	1996-12-09	1996-12-09 00:00:00	1996-12-21	1996-12-21 00:00:00	32020		\N	129816	0	43878008	28060		0
33103	1964	4112343	1961-10-01	1961-10-01 00:00:00	1961-10-09	1961-10-09 00:00:00	32020		\N	130554	0	195662009	4112343		0
33236	1973	4109685	1974-06-21	1974-06-21 00:00:00	1974-07-05	1974-07-05 00:00:00	32020		\N	131199	0	284551006	4109685		0
33444	1982	40481087	1940-11-25	1940-11-25 00:00:00	1940-12-02	1940-12-02 00:00:00	32020		\N	131949	0	444814009	40481087		0
33565	1990	260139	1970-05-07	1970-05-07 00:00:00	1970-05-14	1970-05-14 00:00:00	32020		\N	132535	0	10509002	260139		0
33734	2002	40481087	2005-06-27	2005-06-27 00:00:00	2005-07-11	2005-07-11 00:00:00	32020		\N	133344	0	444814009	40481087		0
33958	2017	4112343	2009-10-09	2009-10-09 00:00:00	2009-10-19	2009-10-19 00:00:00	32020		\N	134161	0	195662009	4112343		0
34113	2026	4116491	1975-03-04	1975-03-04 00:00:00	1975-04-12	1975-04-12 00:00:00	32020		\N	134800	0	301011002	4116491		0
34273	2034	40481087	1980-04-26	1980-04-26 00:00:00	1980-05-10	1980-05-10 00:00:00	32020		\N	135428	0	444814009	40481087		0
34484	2046	80180	1984-11-29	1984-11-29 00:00:00	\N	\N	32020		\N	136140	0	396275006	80180		0
34545	2051	4109685	1974-05-10	1974-05-10 00:00:00	1974-05-31	1974-05-31 00:00:00	32020		\N	136397	0	284551006	4109685		0
34849	2070	78272	2017-07-09	2017-07-09 00:00:00	2017-08-13	2017-08-13 00:00:00	32020		\N	137730	0	70704007	78272		0
34983	2077	40481087	1939-10-25	1939-10-25 00:00:00	1939-11-08	1939-11-08 00:00:00	32020		\N	138282	0	444814009	40481087		0
35044	2080	4278672	1993-03-23	1993-03-23 00:00:00	1993-06-21	1993-06-21 00:00:00	32020		\N	138522	0	65966004	4278672		0
35225	2088	260139	1909-09-18	1909-09-18 00:00:00	1909-10-02	1909-10-02 00:00:00	32020		\N	139225	0	10509002	260139		0
35468	2100	439777	1990-08-25	1990-08-25 00:00:00	\N	\N	32020		\N	139958	0	271737000	439777		0
35591	2108	4266809	1975-11-13	1975-11-13 00:00:00	\N	\N	32020		\N	140399	0	397881000	4266809		0
35713	2116	40481087	1995-08-05	1995-08-05 00:00:00	1995-08-19	1995-08-19 00:00:00	32020		\N	140806	0	444814009	40481087		0
25391	1513	40481087	2011-03-27	2011-03-27 00:00:00	2011-04-17	2011-04-17 00:00:00	32020		\N	101026	0	444814009	40481087		0
36115	2140	260139	1998-03-20	1998-03-20 00:00:00	1998-04-03	1998-04-03 00:00:00	32020		\N	142488	0	10509002	260139		0
36270	2149	4112343	1962-12-13	1962-12-13 00:00:00	1962-12-25	1962-12-25 00:00:00	32020		\N	143071	0	195662009	4112343		0
36441	2156	260139	2014-02-12	2014-02-12 00:00:00	2014-02-26	2014-02-26 00:00:00	32020		\N	143704	0	10509002	260139		0
36598	2166	40481087	1994-09-03	1994-09-03 00:00:00	1994-09-24	1994-09-24 00:00:00	32020		\N	144285	0	444814009	40481087		0
36752	2175	28060	1979-12-12	1979-12-12 00:00:00	1979-12-22	1979-12-22 00:00:00	32020		\N	144999	0	43878008	28060		0
36931	2185	28060	1948-06-09	1948-06-09 00:00:00	1948-06-22	1948-06-22 00:00:00	32020		\N	145676	0	43878008	28060		0
26546	1572	81151	1987-09-23	1987-09-23 00:00:00	1987-10-21	1987-10-21 00:00:00	32020		\N	105547	0	44465007	81151		0
37251	2206	4112343	1990-02-14	1990-02-14 00:00:00	1990-02-25	1990-02-25 00:00:00	32020		\N	147052	0	195662009	4112343		0
37440	2220	260139	1991-06-07	1991-06-07 00:00:00	1991-06-14	1991-06-14 00:00:00	32020		\N	147772	0	10509002	260139		0
37533	2226	80180	1978-02-03	1978-02-03 00:00:00	\N	\N	32020		\N	148101	0	396275006	80180		0
37683	2235	40481087	1988-10-23	1988-10-23 00:00:00	1988-11-06	1988-11-06 00:00:00	32020		\N	148635	0	444814009	40481087		0
37901	2244	4294548	1968-02-10	1968-02-10 00:00:00	1968-02-24	1968-02-24 00:00:00	32020		\N	149396	0	75498004	4294548		0
38150	2265	4112343	1979-04-05	1979-04-05 00:00:00	1979-04-13	1979-04-13 00:00:00	32020		\N	150516	0	195662009	4112343		0
38261	2272	4059173	1982-09-16	1982-09-16 00:00:00	1982-12-15	1982-12-15 00:00:00	32020		\N	151059	0	16114001	4059173		0
38508	2287	81151	1944-11-26	1944-11-26 00:00:00	1944-12-17	1944-12-17 00:00:00	32020		\N	152095	0	44465007	81151		0
38641	2292	4218389	2018-01-22	2018-01-22 00:00:00	2018-02-12	2018-02-12 00:00:00	32020		\N	152633	0	39848009	4218389		0
38730	2298	4113008	1973-04-16	1973-04-16 00:00:00	1973-04-30	1973-04-30 00:00:00	32020		\N	153015	0	284549007	4113008		0
38932	2314	28060	2016-03-25	2016-03-25 00:00:00	2016-04-02	2016-04-02 00:00:00	32020		\N	153893	0	43878008	28060		0
39144	2325	40481087	1973-11-18	1973-11-18 00:00:00	1973-11-25	1973-11-25 00:00:00	32020		\N	154563	0	444814009	40481087		0
39189	2327	4134304	1958-10-11	1958-10-11 00:00:00	1959-01-09	1959-01-09 00:00:00	32020		\N	154725	0	263102004	4134304		0
39438	2337	28060	1998-12-05	1998-12-05 00:00:00	1998-12-17	1998-12-17 00:00:00	32020		\N	155492	0	43878008	28060		0
39522	2342	40481087	2007-10-19	2007-10-19 00:00:00	2007-10-26	2007-10-26 00:00:00	32020		\N	155925	0	444814009	40481087		0
39731	2352	40486433	1974-11-01	1974-11-01 00:00:00	\N	\N	32020		\N	156645	0	446096008	40486433		0
39878	2359	260139	1927-12-03	1927-12-03 00:00:00	1927-12-10	1927-12-10 00:00:00	32020		\N	157175	0	10509002	260139		0
40020	2373	4294548	1978-08-10	1978-08-10 00:00:00	1978-08-31	1978-08-31 00:00:00	32020		\N	157950	0	75498004	4294548		0
40209	2384	28060	1985-02-19	1985-02-19 00:00:00	1985-03-04	1985-03-04 00:00:00	32020		\N	158471	0	43878008	28060		0
40342	2394	4112343	1964-04-21	1964-04-21 00:00:00	1964-05-04	1964-05-04 00:00:00	32020		\N	159150	0	195662009	4112343		0
40570	2412	4156265	1951-05-21	1951-05-21 00:00:00	1951-06-11	1951-06-11 00:00:00	32020		\N	160093	0	370247008	4156265		0
40761	2424	4237458	1979-08-14	1979-08-14 00:00:00	1979-11-12	1979-11-12 00:00:00	32020		\N	160818	0	58150001	4237458		0
40923	2435	4294548	1988-07-25	1988-07-25 00:00:00	1988-11-07	1988-11-07 00:00:00	32020		\N	161400	0	75498004	4294548		0
41158	2445	372328	1928-10-27	1928-10-27 00:00:00	1928-12-10	1928-12-10 00:00:00	32020		\N	162226	0	65363002	372328		0
41242	2450	4112343	2016-10-29	2016-10-29 00:00:00	2016-11-11	2016-11-11 00:00:00	32020		\N	162543	0	195662009	4112343		0
41407	2462	372328	1964-09-22	1964-09-22 00:00:00	1965-03-14	1965-03-14 00:00:00	32020		\N	163277	0	65363002	372328		0
41549	2470	195588	1998-01-22	1998-01-22 00:00:00	1998-02-27	1998-02-27 00:00:00	32020		\N	163767	0	38822007	195588		0
41711	2481	372328	2012-07-25	2012-07-25 00:00:00	2013-03-17	2013-03-17 00:00:00	32020		\N	164375	0	65363002	372328		0
41959	2498	40481087	1987-09-15	1987-09-15 00:00:00	1987-09-29	1987-09-29 00:00:00	32020		\N	165391	0	444814009	40481087		0
42108	2507	40481087	1982-01-21	1982-01-21 00:00:00	1982-02-11	1982-02-11 00:00:00	32020		\N	165932	0	444814009	40481087		0
42466	2530	40481087	1995-04-05	1995-04-05 00:00:00	1995-04-26	1995-04-26 00:00:00	32020		\N	167253	0	444814009	40481087		0
31984	1900	40481087	1978-07-10	1978-07-10 00:00:00	1978-07-24	1978-07-24 00:00:00	32020		\N	126463	0	444814009	40481087		0
32175	1911	40481087	1976-10-04	1976-10-04 00:00:00	1976-10-25	1976-10-25 00:00:00	32020		\N	127126	0	444814009	40481087		0
32314	1921	4113008	2016-01-19	2016-01-19 00:00:00	2016-02-09	2016-02-09 00:00:00	32020		\N	127793	0	284549007	4113008		0
32479	1928	378001	1976-05-09	1976-05-09 00:00:00	1976-07-08	1976-07-08 00:00:00	32020		\N	128308	0	62106007	378001		0
22071	1320	40481087	1953-12-01	1953-12-01 00:00:00	1953-12-22	1953-12-22 00:00:00	32020		\N	87557	0	444814009	40481087		0
32812	1947	378001	1979-05-22	1979-05-22 00:00:00	1979-07-21	1979-07-21 00:00:00	32020		\N	129467	0	62106007	378001		0
32902	1952	40481087	1977-10-03	1977-10-03 00:00:00	1977-10-10	1977-10-10 00:00:00	32020		\N	129834	0	444814009	40481087		0
33104	1964	40481087	2012-03-02	2012-03-02 00:00:00	2012-03-24	2012-03-24 00:00:00	32020		\N	130563	0	444814009	40481087		0
33237	1973	40481087	1972-01-12	1972-01-12 00:00:00	1972-01-19	1972-01-19 00:00:00	32020		\N	131154	0	444814009	40481087		0
33445	1982	378001	1971-09-05	1971-09-05 00:00:00	1971-10-05	1971-10-05 00:00:00	32020		\N	131975	0	62106007	378001		0
33566	1990	28060	1996-05-21	1996-05-21 00:00:00	1996-06-01	1996-06-01 00:00:00	32020		\N	132537	0	43878008	28060		0
33735	2002	4112343	2001-03-12	2001-03-12 00:00:00	2001-03-22	2001-03-22 00:00:00	32020		\N	133341	0	195662009	4112343		0
33959	2017	40481087	2018-04-28	2018-04-28 00:00:00	2018-05-12	2018-05-12 00:00:00	32020		\N	134164	0	444814009	40481087		0
34114	2026	4278672	2016-05-04	2016-05-04 00:00:00	2016-06-03	2016-06-03 00:00:00	32020		\N	134796	0	65966004	4278672		0
34274	2034	4278672	1940-12-14	1940-12-14 00:00:00	1941-02-12	1941-02-12 00:00:00	32020		\N	135486	0	65966004	4278672		0
34485	2046	260139	1991-11-12	1991-11-12 00:00:00	1991-11-19	1991-11-19 00:00:00	32020		\N	136183	0	10509002	260139		0
34546	2051	260139	1984-04-14	1984-04-14 00:00:00	1984-04-21	1984-04-21 00:00:00	32020		\N	136355	0	10509002	260139		0
34850	2070	40481087	2014-10-31	2014-10-31 00:00:00	2014-11-14	2014-11-14 00:00:00	32020		\N	137764	0	444814009	40481087		0
34984	2077	40481087	1994-09-29	1994-09-29 00:00:00	1994-10-13	1994-10-13 00:00:00	32020		\N	138362	0	444814009	40481087		0
35045	2080	4237458	1989-02-21	1989-02-21 00:00:00	1989-05-22	1989-05-22 00:00:00	32020		\N	138520	0	58150001	4237458		0
35226	2088	4112343	2013-06-30	2013-06-30 00:00:00	2013-07-09	2013-07-09 00:00:00	32020		\N	139295	0	195662009	4112343		0
35469	2100	4112343	2002-05-09	2002-05-09 00:00:00	2002-05-18	2002-05-18 00:00:00	32020		\N	140012	0	195662009	4112343		0
35592	2108	30753	1974-06-21	1974-06-21 00:00:00	\N	\N	32020		\N	140399	0	16761005	30753		0
35714	2116	378419	2018-02-19	2018-02-19 00:00:00	\N	\N	32020		\N	140839	0	26929004	378419		0
25392	1513	4283893	1973-02-04	1973-02-04 00:00:00	1973-04-08	1973-04-08 00:00:00	32020		\N	101064	0	36971009	4283893		0
36116	2140	40481087	1952-06-05	1952-06-05 00:00:00	1952-06-26	1952-06-26 00:00:00	32020		\N	142482	0	444814009	40481087		0
36271	2149	4112343	2018-04-30	2018-04-30 00:00:00	2018-05-10	2018-05-10 00:00:00	32020		\N	143081	0	195662009	4112343		0
36442	2156	192671	2009-05-07	2009-05-07 00:00:00	\N	\N	32020		\N	143743	0	K92.2	35208414		0
36599	2166	4278672	1986-09-09	1986-09-09 00:00:00	1986-12-08	1986-12-08 00:00:00	32020		\N	144342	0	65966004	4278672		0
36753	2175	260139	2003-04-16	2003-04-16 00:00:00	2003-04-23	2003-04-23 00:00:00	32020		\N	144981	0	10509002	260139		0
36932	2185	4218389	1962-04-24	1962-04-24 00:00:00	1962-05-30	1962-05-30 00:00:00	32020		\N	145624	0	39848009	4218389		0
26547	1572	40481087	1970-12-28	1970-12-28 00:00:00	1971-01-04	1971-01-04 00:00:00	32020		\N	105567	0	444814009	40481087		0
37252	2206	372328	1974-02-20	1974-02-20 00:00:00	1974-05-10	1974-05-10 00:00:00	32020		\N	147013	0	65363002	372328		0
37441	2220	4112343	1954-04-15	1954-04-15 00:00:00	1954-04-28	1954-04-28 00:00:00	32020		\N	147812	0	195662009	4112343		0
37534	2226	30753	1977-07-08	1977-07-08 00:00:00	\N	\N	32020		\N	148101	0	16761005	30753		0
37684	2235	81151	1959-03-28	1959-03-28 00:00:00	1959-04-25	1959-04-25 00:00:00	32020		\N	148700	0	44465007	81151		0
37933	2250	80180	1995-03-18	1995-03-18 00:00:00	\N	\N	32020		\N	149683	0	396275006	80180		0
38151	2265	260139	1986-05-23	1986-05-23 00:00:00	1986-05-30	1986-05-30 00:00:00	32020		\N	150559	0	10509002	260139		0
38262	2272	4027663	2006-11-24	2006-11-24 00:00:00	\N	\N	32020		\N	151078	0	13200003	4027663		0
38509	2287	4112343	1998-02-17	1998-02-17 00:00:00	1998-02-24	1998-02-24 00:00:00	32020		\N	152119	0	195662009	4112343		0
38642	2292	40481087	2008-08-28	2008-08-28 00:00:00	2008-09-18	2008-09-18 00:00:00	32020		\N	152606	0	444814009	40481087		0
38731	2298	4112343	1992-02-17	1992-02-17 00:00:00	1992-02-25	1992-02-25 00:00:00	32020		\N	152986	0	195662009	4112343		0
38933	2314	260139	1964-01-02	1964-01-02 00:00:00	1964-01-16	1964-01-16 00:00:00	32020		\N	153855	0	10509002	260139		0
39145	2325	4142905	1976-07-29	1976-07-29 00:00:00	1976-08-28	1976-08-28 00:00:00	32020		\N	154599	0	33737001	4142905		0
39190	2327	28060	2019-04-20	2019-04-20 00:00:00	2019-04-30	2019-04-30 00:00:00	32020		\N	154756	0	43878008	28060		0
39439	2337	28060	1963-11-17	1963-11-17 00:00:00	1963-11-24	1963-11-24 00:00:00	32020		\N	155535	0	43878008	28060		0
39523	2342	372328	1978-09-13	1978-09-13 00:00:00	1979-09-21	1979-09-21 00:00:00	32020		\N	155899	0	65363002	372328		0
39732	2352	4237458	1977-03-23	1977-03-23 00:00:00	1977-04-22	1977-04-22 00:00:00	32020		\N	156659	0	58150001	4237458		0
39879	2359	260139	1998-12-10	1998-12-10 00:00:00	1998-12-17	1998-12-17 00:00:00	32020		\N	157270	0	10509002	260139		0
40021	2373	81151	1973-02-23	1973-02-23 00:00:00	1973-03-09	1973-03-09 00:00:00	32020		\N	157947	0	44465007	81151		0
40210	2384	40481087	1988-02-22	1988-02-22 00:00:00	1988-03-07	1988-03-07 00:00:00	32020		\N	158508	0	444814009	40481087		0
40343	2394	372328	1916-11-14	1916-11-14 00:00:00	1917-03-05	1917-03-05 00:00:00	32020		\N	159124	0	65363002	372328		0
40571	2412	40481087	1966-04-30	1966-04-30 00:00:00	1966-05-07	1966-05-07 00:00:00	32020		\N	160033	0	444814009	40481087		0
40762	2424	4112343	1985-02-26	1985-02-26 00:00:00	1985-03-06	1985-03-06 00:00:00	32020		\N	160838	0	195662009	4112343		0
40924	2435	40481087	2007-06-09	2007-06-09 00:00:00	2007-06-16	2007-06-16 00:00:00	32020		\N	161410	0	444814009	40481087		0
41159	2445	40481087	1947-04-26	1947-04-26 00:00:00	1947-05-10	1947-05-10 00:00:00	32020		\N	162220	0	444814009	40481087		0
41243	2450	40481087	1952-08-30	1952-08-30 00:00:00	1952-09-20	1952-09-20 00:00:00	32020		\N	162536	0	444814009	40481087		0
41408	2462	134438	1988-10-08	1988-10-08 00:00:00	1989-11-06	1989-11-06 00:00:00	32020		\N	163319	0	40275004	134438		0
41550	2470	4109685	2015-08-07	2015-08-07 00:00:00	2015-08-28	2015-08-28 00:00:00	32020		\N	163797	0	284551006	4109685		0
41712	2481	80180	2004-09-24	2004-09-24 00:00:00	\N	\N	32020		\N	164417	0	396275006	80180		0
41960	2498	40481087	1973-01-09	1973-01-09 00:00:00	1973-01-23	1973-01-23 00:00:00	32020		\N	165374	0	444814009	40481087		0
42119	2509	40481087	2006-03-01	2006-03-01 00:00:00	2006-03-15	2006-03-15 00:00:00	32020		\N	166098	0	444814009	40481087		0
42326	2521	40481087	1970-09-24	1970-09-24 00:00:00	1970-10-15	1970-10-15 00:00:00	32020		\N	166767	0	444814009	40481087		0
42467	2530	260139	2017-04-21	2017-04-21 00:00:00	2017-04-28	2017-04-28 00:00:00	32020		\N	167254	0	10509002	260139		0
31985	1900	4112343	2006-11-29	2006-11-29 00:00:00	2006-12-06	2006-12-06 00:00:00	32020		\N	126477	0	195662009	4112343		0
32176	1911	80180	1984-05-05	1984-05-05 00:00:00	\N	\N	32020		\N	127110	0	396275006	80180		0
32315	1921	4112343	1999-10-07	1999-10-07 00:00:00	1999-10-16	1999-10-16 00:00:00	32020		\N	127746	0	195662009	4112343		0
32480	1928	260139	1974-03-22	1974-03-22 00:00:00	1974-04-05	1974-04-05 00:00:00	32020		\N	128321	0	10509002	260139		0
22072	1320	40481087	1990-02-10	1990-02-10 00:00:00	1990-02-17	1990-02-17 00:00:00	32020		\N	87492	0	444814009	40481087		0
32813	1947	40481087	1963-12-09	1963-12-09 00:00:00	1963-12-23	1963-12-23 00:00:00	32020		\N	129392	0	444814009	40481087		0
32903	1952	4112343	1970-06-05	1970-06-05 00:00:00	1970-06-16	1970-06-16 00:00:00	32020		\N	129778	0	195662009	4112343		0
33105	1964	4112343	1979-10-07	1979-10-07 00:00:00	1979-10-18	1979-10-18 00:00:00	32020		\N	130555	0	195662009	4112343		0
33238	1973	40481087	1983-03-01	1983-03-01 00:00:00	1983-03-08	1983-03-08 00:00:00	32020		\N	131189	0	444814009	40481087		0
33446	1982	28060	1984-03-18	1984-03-18 00:00:00	1984-03-31	1984-03-31 00:00:00	32020		\N	132018	0	43878008	28060		0
33567	1990	4112343	1975-07-09	1975-07-09 00:00:00	1975-07-22	1975-07-22 00:00:00	32020		\N	132536	0	195662009	4112343		0
33736	2002	372328	2007-10-21	2007-10-21 00:00:00	2008-08-14	2008-08-14 00:00:00	32020		\N	133335	0	65363002	372328		0
33960	2017	4112343	2011-04-15	2011-04-15 00:00:00	2011-04-27	2011-04-27 00:00:00	32020		\N	134162	0	195662009	4112343		0
34115	2026	4112343	1954-05-02	1954-05-02 00:00:00	1954-05-09	1954-05-09 00:00:00	32020		\N	134853	0	195662009	4112343		0
34275	2034	317576	2004-11-10	2004-11-10 00:00:00	\N	\N	32020		\N	135499	0	53741008	317576		0
34486	2046	260139	1946-11-21	1946-11-21 00:00:00	1946-11-28	1946-11-28 00:00:00	32020		\N	136170	0	10509002	260139		0
34547	2051	80180	2005-06-25	2005-06-25 00:00:00	\N	\N	32020		\N	136361	0	396275006	80180		0
34851	2070	4146173	2014-08-24	2014-08-24 00:00:00	2014-09-23	2014-09-23 00:00:00	32020		\N	137659	0	307731004	4146173		0
34985	2077	260139	1946-11-09	1946-11-09 00:00:00	1946-11-23	1946-11-23 00:00:00	32020		\N	138332	0	10509002	260139		0
35046	2080	4112343	1985-12-21	1985-12-21 00:00:00	1986-01-02	1986-01-02 00:00:00	32020		\N	138533	0	195662009	4112343		0
35227	2088	4112343	2009-05-11	2009-05-11 00:00:00	2009-05-19	2009-05-19 00:00:00	32020		\N	139186	0	195662009	4112343		0
35470	2100	4112343	2015-04-11	2015-04-11 00:00:00	2015-04-19	2015-04-19 00:00:00	32020		\N	140014	0	195662009	4112343		0
35593	2108	80180	1975-11-13	1975-11-13 00:00:00	\N	\N	32020		\N	140399	0	396275006	80180		0
35715	2116	40481087	2019-06-11	2019-06-11 00:00:00	2019-06-18	2019-06-18 00:00:00	32020		\N	140851	0	444814009	40481087		0
25393	1513	4294548	1986-08-07	1986-08-07 00:00:00	1986-10-02	1986-10-02 00:00:00	32020		\N	101166	0	75498004	4294548		0
36117	2140	40481087	1959-04-28	1959-04-28 00:00:00	1959-05-05	1959-05-05 00:00:00	32020		\N	142558	0	444814009	40481087		0
36272	2149	4155034	1990-09-19	1990-09-19 00:00:00	1990-10-10	1990-10-10 00:00:00	32020		\N	143127	0	283371005	4155034		0
36443	2156	4112343	1969-10-27	1969-10-27 00:00:00	1969-11-05	1969-11-05 00:00:00	32020		\N	143744	0	195662009	4112343		0
36600	2166	40481087	1973-12-23	1973-12-23 00:00:00	1974-01-06	1974-01-06 00:00:00	32020		\N	144329	0	444814009	40481087		0
36754	2175	372328	1980-08-22	1980-08-22 00:00:00	1981-01-08	1981-01-08 00:00:00	32020		\N	144974	0	65363002	372328		0
36933	2185	40481087	1988-08-14	1988-08-14 00:00:00	1988-09-04	1988-09-04 00:00:00	32020		\N	145657	0	444814009	40481087		0
26548	1572	40481087	2000-05-04	2000-05-04 00:00:00	2000-05-25	2000-05-25 00:00:00	32020		\N	105569	0	444814009	40481087		0
37253	2206	4027663	2000-11-25	2000-11-25 00:00:00	\N	\N	32020		\N	147028	0	13200003	4027663		0
37442	2220	4059173	2005-02-04	2005-02-04 00:00:00	2005-05-05	2005-05-05 00:00:00	32020		\N	147792	0	16114001	4059173		0
37535	2226	4112343	2001-05-08	2001-05-08 00:00:00	2001-05-20	2001-05-20 00:00:00	32020		\N	148121	0	195662009	4112343		0
37685	2235	40481087	1975-09-16	1975-09-16 00:00:00	1975-09-23	1975-09-23 00:00:00	32020		\N	148657	0	444814009	40481087		0
37934	2250	4112343	1994-07-17	1994-07-17 00:00:00	1994-07-30	1994-07-30 00:00:00	32020		\N	149683	0	195662009	4112343		0
38152	2265	40481087	2017-10-19	2017-10-19 00:00:00	2017-10-26	2017-10-26 00:00:00	32020		\N	150525	0	444814009	40481087		0
38263	2272	80180	2015-12-12	2015-12-12 00:00:00	\N	\N	32020		\N	151020	0	396275006	80180		0
38510	2287	4283893	1946-01-05	1946-01-05 00:00:00	1946-02-23	1946-02-23 00:00:00	32020		\N	152125	0	36971009	4283893		0
38644	2294	40481087	1967-06-10	1967-06-10 00:00:00	1967-07-01	1967-07-01 00:00:00	32020		\N	152656	0	444814009	40481087		0
38732	2298	28060	1972-02-23	1972-02-23 00:00:00	1972-03-01	1972-03-01 00:00:00	32020		\N	153003	0	43878008	28060		0
38934	2314	4237458	1958-03-02	1958-03-02 00:00:00	1958-05-31	1958-05-31 00:00:00	32020		\N	153862	0	58150001	4237458		0
39146	2325	40481087	1994-10-11	1994-10-11 00:00:00	1994-10-18	1994-10-18 00:00:00	32020		\N	154559	0	444814009	40481087		0
39191	2327	4112343	1993-12-18	1993-12-18 00:00:00	1993-12-30	1993-12-30 00:00:00	32020		\N	154754	0	195662009	4112343		0
39440	2337	4283893	1979-10-12	1979-10-12 00:00:00	1979-11-30	1979-11-30 00:00:00	32020		\N	155544	0	36971009	4283893		0
39524	2342	192671	2018-07-10	2018-07-10 00:00:00	\N	\N	32020		\N	155931	0	K92.2	35208414		0
39733	2352	4029498	1970-10-26	1970-10-26 00:00:00	\N	\N	32020		\N	156656	0	128613002	4029498		0
39929	2366	260139	2003-08-14	2003-08-14 00:00:00	2003-08-21	2003-08-21 00:00:00	32020		\N	157521	0	10509002	260139		0
40022	2373	134438	1978-01-20	1978-01-20 00:00:00	1980-11-05	1980-11-05 00:00:00	32020		\N	157949	0	40275004	134438		0
40211	2384	4113008	2008-09-10	2008-09-10 00:00:00	2008-09-24	2008-09-24 00:00:00	32020		\N	158498	0	284549007	4113008		0
40344	2394	4112343	1973-06-18	1973-06-18 00:00:00	1973-06-27	1973-06-27 00:00:00	32020		\N	159138	0	195662009	4112343		0
40572	2412	260139	2009-06-11	2009-06-11 00:00:00	2009-06-18	2009-06-18 00:00:00	32020		\N	160097	0	10509002	260139		0
40763	2424	28060	1971-04-02	1971-04-02 00:00:00	1971-04-09	1971-04-09 00:00:00	32020		\N	160802	0	43878008	28060		0
40925	2435	372328	1988-02-07	1988-02-07 00:00:00	1988-09-23	1988-09-23 00:00:00	32020		\N	161420	0	65363002	372328		0
41160	2445	78272	1965-12-24	1965-12-24 00:00:00	1966-01-14	1966-01-14 00:00:00	32020		\N	162231	0	70704007	78272		0
41244	2450	40481087	1993-09-03	1993-09-03 00:00:00	1993-09-10	1993-09-10 00:00:00	32020		\N	162504	0	444814009	40481087		0
41409	2462	260139	2011-10-24	2011-10-24 00:00:00	2011-10-31	2011-10-31 00:00:00	32020		\N	163308	0	10509002	260139		0
41551	2470	40481087	2008-06-24	2008-06-24 00:00:00	2008-07-08	2008-07-08 00:00:00	32020		\N	163765	0	444814009	40481087		0
41713	2481	40481087	2006-03-04	2006-03-04 00:00:00	2006-03-25	2006-03-25 00:00:00	32020		\N	164371	0	444814009	40481087		0
41961	2498	4278672	1997-10-15	1997-10-15 00:00:00	1997-11-14	1997-11-14 00:00:00	32020		\N	165404	0	65966004	4278672		0
42120	2509	4112343	1970-05-08	1970-05-08 00:00:00	1970-05-19	1970-05-19 00:00:00	32020		\N	166094	0	195662009	4112343		0
42327	2521	4112343	2009-06-09	2009-06-09 00:00:00	2009-06-16	2009-06-16 00:00:00	32020		\N	166769	0	195662009	4112343		0
42468	2530	80180	2000-09-04	2000-09-04 00:00:00	\N	\N	32020		\N	167267	0	396275006	80180		0
31986	1900	40481087	1979-12-18	1979-12-18 00:00:00	1979-12-25	1979-12-25 00:00:00	32020		\N	126458	0	444814009	40481087		0
32177	1911	4112343	1996-06-20	1996-06-20 00:00:00	1996-06-27	1996-06-27 00:00:00	32020		\N	127169	0	195662009	4112343		0
32316	1921	4059173	1968-07-10	1968-07-10 00:00:00	1968-10-08	1968-10-08 00:00:00	32020		\N	127790	0	16114001	4059173		0
32481	1928	80180	2010-07-15	2010-07-15 00:00:00	\N	\N	32020		\N	128386	0	396275006	80180		0
22073	1320	4230399	2006-03-04	2006-03-04 00:00:00	2006-04-03	2006-04-03 00:00:00	32020		\N	87478	0	359817006	4230399		0
32844	1950	260139	1998-12-09	1998-12-09 00:00:00	1998-12-16	1998-12-16 00:00:00	32020		\N	129667	0	10509002	260139		0
32904	1952	4112343	1962-07-04	1962-07-04 00:00:00	1962-07-14	1962-07-14 00:00:00	32020		\N	129821	0	195662009	4112343		0
33106	1964	40481087	2010-04-11	2010-04-11 00:00:00	2010-04-25	2010-04-25 00:00:00	32020		\N	130574	0	444814009	40481087		0
33239	1973	260139	1985-08-24	1985-08-24 00:00:00	1985-09-07	1985-09-07 00:00:00	32020		\N	131151	0	10509002	260139		0
33447	1982	4294548	1981-01-08	1981-01-08 00:00:00	1981-04-02	1981-04-02 00:00:00	32020		\N	131991	0	75498004	4294548		0
33568	1990	4112343	1968-07-01	1968-07-01 00:00:00	1968-07-12	1968-07-12 00:00:00	32020		\N	132491	0	195662009	4112343		0
33737	2002	81893	2011-07-02	2011-07-02 00:00:00	\N	\N	32020		\N	133391	0	64766004	81893		0
33961	2017	40481087	1989-04-08	1989-04-08 00:00:00	1989-04-29	1989-04-29 00:00:00	32020		\N	134168	0	444814009	40481087		0
34116	2026	4112343	1955-10-05	1955-10-05 00:00:00	1955-10-13	1955-10-13 00:00:00	32020		\N	134789	0	195662009	4112343		0
34276	2034	28060	2006-06-22	2006-06-22 00:00:00	2006-07-04	2006-07-04 00:00:00	32020		\N	135450	0	43878008	28060		0
34487	2046	28060	1991-04-27	1991-04-27 00:00:00	1991-05-05	1991-05-05 00:00:00	32020		\N	136182	0	43878008	28060		0
34548	2051	40481087	2011-04-17	2011-04-17 00:00:00	2011-04-24	2011-04-24 00:00:00	32020		\N	136374	0	444814009	40481087		0
34852	2070	80180	2008-07-02	2008-07-02 00:00:00	\N	\N	32020		\N	137753	0	396275006	80180		0
34986	2077	4296204	1977-08-16	1977-08-16 00:00:00	1977-08-30	1977-08-30 00:00:00	32020		\N	138214	0	403190006	4296204		0
35047	2080	4112343	2008-11-14	2008-11-14 00:00:00	2008-11-22	2008-11-22 00:00:00	32020		\N	138599	0	195662009	4112343		0
35228	2088	40481087	1994-05-01	1994-05-01 00:00:00	1994-05-08	1994-05-08 00:00:00	32020		\N	139203	0	444814009	40481087		0
35471	2100	4218389	2009-09-15	2009-09-15 00:00:00	2009-10-13	2009-10-13 00:00:00	32020		\N	139972	0	39848009	4218389		0
35594	2108	4285898	1975-03-18	1975-03-18 00:00:00	\N	\N	32020		\N	140399	0	68496003	4285898		0
35716	2116	40481087	1979-11-30	1979-11-30 00:00:00	1979-12-07	1979-12-07 00:00:00	32020		\N	140828	0	444814009	40481087		0
25394	1513	4112343	2010-06-12	2010-06-12 00:00:00	2010-06-19	2010-06-19 00:00:00	32020		\N	101109	0	195662009	4112343		0
36118	2140	30753	1988-10-19	1988-10-19 00:00:00	\N	\N	32020		\N	142577	0	16761005	30753		0
36273	2149	260139	1959-08-17	1959-08-17 00:00:00	1959-08-31	1959-08-31 00:00:00	32020		\N	143119	0	10509002	260139		0
36444	2156	257012	1984-01-10	1984-01-10 00:00:00	1994-07-10	1994-07-10 00:00:00	32020		\N	143697	0	40055000	257012		0
36601	2166	40481087	1987-07-22	1987-07-22 00:00:00	1987-08-05	1987-08-05 00:00:00	32020		\N	144314	0	444814009	40481087		0
36755	2175	40481087	2010-12-14	2010-12-14 00:00:00	2010-12-28	2010-12-28 00:00:00	32020		\N	145060	0	444814009	40481087		0
36934	2185	4112343	2013-10-25	2013-10-25 00:00:00	2013-11-05	2013-11-05 00:00:00	32020		\N	145684	0	195662009	4112343		0
26549	1572	40481087	1995-02-15	1995-02-15 00:00:00	1995-02-22	1995-02-22 00:00:00	32020		\N	105595	0	444814009	40481087		0
37254	2206	260139	2001-04-08	2001-04-08 00:00:00	2001-04-22	2001-04-22 00:00:00	32020		\N	146990	0	10509002	260139		0
37443	2220	4112343	2003-11-06	2003-11-06 00:00:00	2003-11-15	2003-11-15 00:00:00	32020		\N	147866	0	195662009	4112343		0
37536	2226	4113008	2001-06-12	2001-06-12 00:00:00	2001-07-03	2001-07-03 00:00:00	32020		\N	148169	0	284549007	4113008		0
37686	2235	4027663	1976-11-28	1976-11-28 00:00:00	\N	\N	32020		\N	148657	0	13200003	4027663		0
37935	2250	40481087	2015-01-19	2015-01-19 00:00:00	2015-01-26	2015-01-26 00:00:00	32020		\N	149667	0	444814009	40481087		0
38153	2265	40481087	1967-06-04	1967-06-04 00:00:00	1967-06-18	1967-06-18 00:00:00	32020		\N	150488	0	444814009	40481087		0
38264	2272	30753	2015-02-15	2015-02-15 00:00:00	\N	\N	32020		\N	151020	0	16761005	30753		0
38511	2287	80180	1982-05-10	1982-05-10 00:00:00	\N	\N	32020		\N	152179	0	396275006	80180		0
38645	2294	260139	1984-12-20	1984-12-20 00:00:00	1985-01-03	1985-01-03 00:00:00	32020		\N	152680	0	10509002	260139		0
38733	2298	40481087	1986-02-01	1986-02-01 00:00:00	1986-02-15	1986-02-15 00:00:00	32020		\N	152985	0	444814009	40481087		0
38935	2314	372328	1956-06-25	1956-06-25 00:00:00	1957-06-22	1957-06-22 00:00:00	32020		\N	153907	0	65363002	372328		0
39147	2325	260139	2012-11-25	2012-11-25 00:00:00	2012-12-09	2012-12-09 00:00:00	32020		\N	154564	0	10509002	260139		0
39192	2327	4113008	1995-04-19	1995-04-19 00:00:00	1995-05-03	1995-05-03 00:00:00	32020		\N	154728	0	284549007	4113008		0
39441	2337	4112343	2000-05-11	2000-05-11 00:00:00	2000-05-18	2000-05-18 00:00:00	32020		\N	155536	0	195662009	4112343		0
39525	2342	260139	1976-09-10	1976-09-10 00:00:00	1976-09-17	1976-09-17 00:00:00	32020		\N	155900	0	10509002	260139		0
39735	2352	81893	2010-09-11	2010-09-11 00:00:00	\N	\N	32020		\N	156654	0	64766004	81893		0
39930	2366	80180	2006-06-25	2006-06-25 00:00:00	\N	\N	32020		\N	157506	0	396275006	80180		0
40023	2373	40481087	1984-04-03	1984-04-03 00:00:00	1984-04-17	1984-04-17 00:00:00	32020		\N	157951	0	444814009	40481087		0
40212	2384	4116491	2013-02-13	2013-02-13 00:00:00	2013-04-01	2013-04-01 00:00:00	32020		\N	158501	0	301011002	4116491		0
40345	2394	80180	1953-02-04	1953-02-04 00:00:00	\N	\N	32020		\N	159188	0	396275006	80180		0
40573	2412	4112343	2001-06-26	2001-06-26 00:00:00	2001-07-07	2001-07-07 00:00:00	32020		\N	160079	0	195662009	4112343		0
40764	2424	260139	1975-12-05	1975-12-05 00:00:00	1975-12-12	1975-12-12 00:00:00	32020		\N	160837	0	10509002	260139		0
40926	2435	28060	1979-07-17	1979-07-17 00:00:00	1979-07-24	1979-07-24 00:00:00	32020		\N	161408	0	43878008	28060		0
41161	2445	81151	1928-08-28	1928-08-28 00:00:00	1928-09-18	1928-09-18 00:00:00	32020		\N	162195	0	44465007	81151		0
41245	2450	260139	1994-05-22	1994-05-22 00:00:00	1994-05-29	1994-05-29 00:00:00	32020		\N	162540	0	10509002	260139		0
41410	2462	4112343	1994-10-26	1994-10-26 00:00:00	1994-11-08	1994-11-08 00:00:00	32020		\N	163290	0	195662009	4112343		0
41552	2470	81151	1968-04-17	1968-04-17 00:00:00	1968-05-15	1968-05-15 00:00:00	32020		\N	163796	0	44465007	81151		0
41714	2481	40481087	1979-01-17	1979-01-17 00:00:00	1979-01-31	1979-01-31 00:00:00	32020		\N	164369	0	444814009	40481087		0
41962	2498	4112343	1996-10-25	1996-10-25 00:00:00	1996-11-06	1996-11-06 00:00:00	32020		\N	165376	0	195662009	4112343		0
42121	2509	28060	1983-10-26	1983-10-26 00:00:00	1983-11-03	1983-11-03 00:00:00	32020		\N	166095	0	43878008	28060		0
42328	2521	40481087	1975-09-06	1975-09-06 00:00:00	1975-09-20	1975-09-20 00:00:00	32020		\N	166761	0	444814009	40481087		0
42469	2530	260139	1968-10-03	1968-10-03 00:00:00	1968-10-17	1968-10-17 00:00:00	32020		\N	167233	0	10509002	260139		0
31987	1900	40481087	1971-05-03	1971-05-03 00:00:00	1971-05-10	1971-05-10 00:00:00	32020		\N	126506	0	444814009	40481087		0
32178	1911	378001	1999-01-31	1999-01-31 00:00:00	1999-03-02	1999-03-02 00:00:00	32020		\N	127177	0	62106007	378001		0
32317	1921	372328	1951-12-23	1951-12-23 00:00:00	1952-03-03	1952-03-03 00:00:00	32020		\N	127740	0	65363002	372328		0
32482	1928	40481087	1981-09-28	1981-09-28 00:00:00	1981-10-12	1981-10-12 00:00:00	32020		\N	128336	0	444814009	40481087		0
22074	1320	40480160	2006-03-04	2006-03-04 00:00:00	2006-04-03	2006-04-03 00:00:00	32020		\N	87478	0	443165006	40480160		0
32845	1950	80502	2011-01-06	2011-01-06 00:00:00	\N	\N	32020		\N	129709	0	64859006	80502		0
32905	1952	40481087	1989-05-18	1989-05-18 00:00:00	1989-06-01	1989-06-01 00:00:00	32020		\N	129835	0	444814009	40481087		0
33107	1964	80180	2000-08-10	2000-08-10 00:00:00	\N	\N	32020		\N	130595	0	396275006	80180		0
33240	1973	4237458	1996-12-20	1996-12-20 00:00:00	1997-01-19	1997-01-19 00:00:00	32020		\N	131202	0	58150001	4237458		0
33448	1982	260139	1987-08-16	1987-08-16 00:00:00	1987-08-30	1987-08-30 00:00:00	32020		\N	131957	0	10509002	260139		0
33569	1990	260139	2014-07-06	2014-07-06 00:00:00	2014-07-20	2014-07-20 00:00:00	32020		\N	132488	0	10509002	260139		0
33738	2002	4285898	2012-07-26	2012-07-26 00:00:00	\N	\N	32020		\N	133391	0	68496003	4285898		0
33962	2017	40481087	2015-11-14	2015-11-14 00:00:00	2015-12-05	2015-12-05 00:00:00	32020		\N	134163	0	444814009	40481087		0
34117	2026	4112343	1984-11-07	1984-11-07 00:00:00	1984-11-19	1984-11-19 00:00:00	32020		\N	134792	0	195662009	4112343		0
34277	2034	4294548	1942-05-21	1942-05-21 00:00:00	1942-10-15	1942-10-15 00:00:00	32020		\N	135424	0	75498004	4294548		0
34488	2046	28060	1945-03-03	1945-03-03 00:00:00	1945-03-15	1945-03-15 00:00:00	32020		\N	136145	0	43878008	28060		0
34549	2051	4112343	1974-05-22	1974-05-22 00:00:00	1974-05-31	1974-05-31 00:00:00	32020		\N	136354	0	195662009	4112343		0
34853	2070	260139	1980-09-04	1980-09-04 00:00:00	1980-09-18	1980-09-18 00:00:00	32020		\N	137654	0	10509002	260139		0
34987	2077	4278672	2001-06-11	2001-06-11 00:00:00	2001-09-09	2001-09-09 00:00:00	32020		\N	138379	0	65966004	4278672		0
35048	2080	4155034	2009-08-24	2009-08-24 00:00:00	2009-09-07	2009-09-07 00:00:00	32020		\N	138544	0	283371005	4155034		0
35229	2088	4112343	1934-12-07	1934-12-07 00:00:00	1934-12-16	1934-12-16 00:00:00	32020		\N	139167	0	195662009	4112343		0
35472	2100	40481087	1976-02-19	1976-02-19 00:00:00	1976-03-11	1976-03-11 00:00:00	32020		\N	140036	0	444814009	40481087		0
35595	2109	4112343	1992-11-19	1992-11-19 00:00:00	1992-12-02	1992-12-02 00:00:00	32020		\N	140407	0	195662009	4112343		0
35717	2116	260139	1965-02-04	1965-02-04 00:00:00	1965-02-11	1965-02-11 00:00:00	32020		\N	140790	0	10509002	260139		0
25395	1513	80180	2011-01-01	2011-01-01 00:00:00	\N	\N	32020		\N	101109	0	396275006	80180		0
36119	2140	40481087	1988-08-08	1988-08-08 00:00:00	1988-08-29	1988-08-29 00:00:00	32020		\N	142577	0	444814009	40481087		0
36274	2149	40486433	1962-04-24	1962-04-24 00:00:00	\N	\N	32020		\N	143108	0	446096008	40486433		0
36445	2156	4134304	1988-04-18	1988-04-18 00:00:00	1988-06-17	1988-06-17 00:00:00	32020		\N	143732	0	263102004	4134304		0
36602	2166	40481087	1993-09-08	1993-09-08 00:00:00	1993-09-29	1993-09-29 00:00:00	32020		\N	144316	0	444814009	40481087		0
36756	2175	40481087	1977-07-29	1977-07-29 00:00:00	1977-08-12	1977-08-12 00:00:00	32020		\N	144980	0	444814009	40481087		0
36935	2185	4278672	1942-12-24	1942-12-24 00:00:00	1943-02-22	1943-02-22 00:00:00	32020		\N	145621	0	65966004	4278672		0
26550	1572	40481087	2008-12-14	2008-12-14 00:00:00	2008-12-28	2008-12-28 00:00:00	32020		\N	105596	0	444814009	40481087		0
37255	2206	4278672	1986-01-18	1986-01-18 00:00:00	1986-02-17	1986-02-17 00:00:00	32020		\N	147010	0	65966004	4278672		0
37444	2220	40481087	1968-11-08	1968-11-08 00:00:00	1968-11-22	1968-11-22 00:00:00	32020		\N	147852	0	444814009	40481087		0
37537	2226	4310024	1976-10-11	1976-10-11 00:00:00	\N	\N	32020		\N	148100	0	424802006	4310024		0
37687	2235	372328	1960-02-16	1960-02-16 00:00:00	1960-12-07	1960-12-07 00:00:00	32020		\N	148658	0	65363002	372328		0
37936	2250	260139	1965-12-03	1965-12-03 00:00:00	1965-12-10	1965-12-10 00:00:00	32020		\N	149627	0	10509002	260139		0
38154	2265	192671	2002-06-16	2002-06-16 00:00:00	\N	\N	32020		\N	150619	0	K92.2	35208414		0
38265	2273	4112343	1989-07-20	1989-07-20 00:00:00	1989-07-27	1989-07-27 00:00:00	32020		\N	151114	0	195662009	4112343		0
38512	2287	260139	1984-12-13	1984-12-13 00:00:00	1984-12-20	1984-12-20 00:00:00	32020		\N	152099	0	10509002	260139		0
38646	2294	81151	1972-04-17	1972-04-17 00:00:00	1972-05-01	1972-05-01 00:00:00	32020		\N	152748	0	44465007	81151		0
38734	2298	4152936	2008-06-30	2008-06-30 00:00:00	2008-07-14	2008-07-14 00:00:00	32020		\N	153017	0	283385000	4152936		0
38936	2314	372328	1989-12-01	1989-12-01 00:00:00	1991-07-13	1991-07-13 00:00:00	32020		\N	153894	0	65363002	372328		0
39148	2325	260139	1999-09-17	1999-09-17 00:00:00	1999-10-01	1999-10-01 00:00:00	32020		\N	154619	0	10509002	260139		0
39193	2327	4155034	1967-12-23	1967-12-23 00:00:00	1968-01-13	1968-01-13 00:00:00	32020		\N	154726	0	283371005	4155034		0
39442	2337	80180	2003-07-26	2003-07-26 00:00:00	\N	\N	32020		\N	155502	0	396275006	80180		0
39526	2342	81151	2018-11-18	2018-11-18 00:00:00	2018-12-23	2018-12-23 00:00:00	32020		\N	155889	0	44465007	81151		0
39736	2352	4266809	2012-08-01	2012-08-01 00:00:00	\N	\N	32020		\N	156614	0	397881000	4266809		0
39931	2366	40481087	2014-02-11	2014-02-11 00:00:00	2014-03-04	2014-03-04 00:00:00	32020		\N	157523	0	444814009	40481087		0
40024	2373	4059173	1969-08-13	1969-08-13 00:00:00	1969-09-12	1969-09-12 00:00:00	32020		\N	157946	0	16114001	4059173		0
40213	2384	40481087	2000-09-09	2000-09-09 00:00:00	2000-09-16	2000-09-16 00:00:00	32020		\N	158482	0	444814009	40481087		0
40346	2394	40481087	1931-01-21	1931-01-21 00:00:00	1931-02-04	1931-02-04 00:00:00	32020		\N	159128	0	444814009	40481087		0
40574	2412	260139	1985-10-20	1985-10-20 00:00:00	1985-10-27	1985-10-27 00:00:00	32020		\N	160034	0	10509002	260139		0
40765	2424	40481087	1988-07-14	1988-07-14 00:00:00	1988-08-04	1988-08-04 00:00:00	32020		\N	160839	0	444814009	40481087		0
40927	2435	4027663	2004-11-02	2004-11-02 00:00:00	\N	\N	32020		\N	161385	0	13200003	4027663		0
41162	2445	40481087	1983-06-09	1983-06-09 00:00:00	1983-06-23	1983-06-23 00:00:00	32020		\N	162223	0	444814009	40481087		0
41246	2450	40481087	2005-04-12	2005-04-12 00:00:00	2005-05-03	2005-05-03 00:00:00	32020		\N	162541	0	444814009	40481087		0
41411	2462	260139	2008-06-11	2008-06-11 00:00:00	2008-06-18	2008-06-18 00:00:00	32020		\N	163276	0	10509002	260139		0
41553	2470	372328	1959-09-11	1959-09-11 00:00:00	1959-11-23	1959-11-23 00:00:00	32020		\N	163821	0	65363002	372328		0
41715	2481	40481087	1974-04-01	1974-04-01 00:00:00	1974-04-08	1974-04-08 00:00:00	32020		\N	164357	0	444814009	40481087		0
41963	2498	81151	1982-12-23	1982-12-23 00:00:00	1983-01-06	1983-01-06 00:00:00	32020		\N	165401	0	44465007	81151		0
42122	2509	28060	1976-06-20	1976-06-20 00:00:00	1976-07-02	1976-07-02 00:00:00	32020		\N	166090	0	43878008	28060		0
42329	2521	260139	1948-03-20	1948-03-20 00:00:00	1948-04-03	1948-04-03 00:00:00	32020		\N	166756	0	10509002	260139		0
42470	2530	40481087	1971-12-25	1971-12-25 00:00:00	1972-01-01	1972-01-01 00:00:00	32020		\N	167210	0	444814009	40481087		0
31988	1900	40481087	1979-05-25	1979-05-25 00:00:00	1979-06-01	1979-06-01 00:00:00	32020		\N	126450	0	444814009	40481087		0
32179	1911	372328	1946-07-24	1946-07-24 00:00:00	1946-11-04	1946-11-04 00:00:00	32020		\N	127171	0	65363002	372328		0
32318	1921	4112343	1954-10-09	1954-10-09 00:00:00	1954-10-17	1954-10-17 00:00:00	32020		\N	127762	0	195662009	4112343		0
32483	1928	4113008	1996-02-24	1996-02-24 00:00:00	1996-03-16	1996-03-16 00:00:00	32020		\N	128378	0	284549007	4113008		0
22075	1320	260139	1971-10-06	1971-10-06 00:00:00	1971-10-13	1971-10-13 00:00:00	32020		\N	87480	0	10509002	260139		0
32846	1950	40481087	2004-07-07	2004-07-07 00:00:00	2004-07-21	2004-07-21 00:00:00	32020		\N	129668	0	444814009	40481087		0
32906	1952	4112343	1960-08-04	1960-08-04 00:00:00	1960-08-11	1960-08-11 00:00:00	32020		\N	129813	0	195662009	4112343		0
33108	1965	40481087	1998-10-14	1998-10-14 00:00:00	1998-11-04	1998-11-04 00:00:00	32020		\N	130654	0	444814009	40481087		0
33241	1973	378001	1979-05-24	1979-05-24 00:00:00	1979-06-23	1979-06-23 00:00:00	32020		\N	131201	0	62106007	378001		0
33483	1986	40481087	1992-11-17	1992-11-17 00:00:00	1992-11-24	1992-11-24 00:00:00	32020		\N	132254	0	444814009	40481087		0
33570	1991	40481087	1968-09-24	1968-09-24 00:00:00	1968-10-08	1968-10-08 00:00:00	32020		\N	132595	0	444814009	40481087		0
33739	2002	257012	1981-08-21	1981-08-21 00:00:00	\N	\N	32020		\N	133331	0	40055000	257012		0
33963	2017	372328	1974-05-04	1974-05-04 00:00:00	1975-03-11	1975-03-11 00:00:00	32020		\N	134155	0	65363002	372328		0
34118	2027	4310024	2000-08-04	2000-08-04 00:00:00	\N	\N	32020		\N	134930	0	424802006	4310024		0
34278	2034	4112343	1941-08-25	1941-08-25 00:00:00	1941-09-04	1941-09-04 00:00:00	32020		\N	135445	0	195662009	4112343		0
34489	2046	260139	1951-02-15	1951-02-15 00:00:00	1951-02-22	1951-02-22 00:00:00	32020		\N	136099	0	10509002	260139		0
34550	2051	4116491	2013-11-05	2013-11-05 00:00:00	2013-12-23	2013-12-23 00:00:00	32020		\N	136335	0	301011002	4116491		0
34854	2070	4112343	2016-08-02	2016-08-02 00:00:00	2016-08-10	2016-08-10 00:00:00	32020		\N	137733	0	195662009	4112343		0
34989	2077	321042	2005-08-21	2005-08-21 00:00:00	\N	\N	32020		\N	138380	0	410429000	321042		0
35049	2080	4112343	1990-06-12	1990-06-12 00:00:00	1990-06-19	1990-06-19 00:00:00	32020		\N	138535	0	195662009	4112343		0
35230	2088	4109685	2012-05-25	2012-05-25 00:00:00	2012-06-15	2012-06-15 00:00:00	32020		\N	139185	0	284551006	4109685		0
35497	2103	4112343	1994-08-04	1994-08-04 00:00:00	1994-08-17	1994-08-17 00:00:00	32020		\N	140125	0	195662009	4112343		0
35596	2109	372328	1973-10-18	1973-10-18 00:00:00	1974-11-03	1974-11-03 00:00:00	32020		\N	140433	0	65363002	372328		0
35718	2116	260139	1979-03-26	1979-03-26 00:00:00	1979-04-09	1979-04-09 00:00:00	32020		\N	140793	0	10509002	260139		0
25396	1513	372328	1969-12-17	1969-12-17 00:00:00	1970-05-03	1970-05-03 00:00:00	32020		\N	101028	0	65363002	372328		0
36120	2140	4027663	1978-05-30	1978-05-30 00:00:00	\N	\N	32020		\N	142565	0	13200003	4027663		0
36275	2150	4134304	2005-11-07	2005-11-07 00:00:00	2006-02-05	2006-02-05 00:00:00	32020		\N	143153	0	263102004	4134304		0
36446	2156	4112343	2011-08-08	2011-08-08 00:00:00	2011-08-16	2011-08-16 00:00:00	32020		\N	143703	0	195662009	4112343		0
45998	2740	80180	2010-04-19	2010-04-19 00:00:00	\N	\N	32020		\N	181319	0	396275006	80180		0
36603	2166	260139	1970-12-13	1970-12-13 00:00:00	1970-12-20	1970-12-20 00:00:00	32020		\N	144286	0	10509002	260139		0
36757	2175	80180	2013-08-07	2013-08-07 00:00:00	\N	\N	32020		\N	144972	0	396275006	80180		0
36936	2185	81151	1959-05-13	1959-05-13 00:00:00	1959-06-10	1959-06-10 00:00:00	32020		\N	145623	0	44465007	81151		0
26551	1572	4237458	1976-01-24	1976-01-24 00:00:00	1976-04-23	1976-04-23 00:00:00	32020		\N	105546	0	58150001	4237458		0
37256	2206	4285898	2007-08-16	2007-08-16 00:00:00	\N	\N	32020		\N	146998	0	68496003	4285898		0
37445	2220	260139	1947-12-16	1947-12-16 00:00:00	1947-12-23	1947-12-23 00:00:00	32020		\N	147838	0	10509002	260139		0
37538	2226	81893	1976-11-10	1976-11-10 00:00:00	\N	\N	32020		\N	148100	0	64766004	81893		0
37688	2235	28060	1963-12-05	1963-12-05 00:00:00	1963-12-17	1963-12-17 00:00:00	32020		\N	148688	0	43878008	28060		0
37937	2250	378001	2005-08-08	2005-08-08 00:00:00	2005-10-07	2005-10-07 00:00:00	32020		\N	149652	0	62106007	378001		0
38155	2265	4112343	2015-10-02	2015-10-02 00:00:00	2015-10-14	2015-10-14 00:00:00	32020		\N	150508	0	195662009	4112343		0
38266	2273	30753	2015-08-07	2015-08-07 00:00:00	\N	\N	32020		\N	151117	0	16761005	30753		0
48971	2898	4116491	2015-02-15	2015-02-15 00:00:00	2015-04-06	2015-04-06 00:00:00	32020		\N	193099	0	301011002	4116491		0
38647	2294	378001	1973-04-26	1973-04-26 00:00:00	1973-05-26	1973-05-26 00:00:00	32020		\N	152749	0	62106007	378001		0
38735	2298	260139	1978-02-21	1978-02-21 00:00:00	1978-03-07	1978-03-07 00:00:00	32020		\N	152984	0	10509002	260139		0
38937	2314	4112343	1982-09-25	1982-09-25 00:00:00	1982-10-08	1982-10-08 00:00:00	32020		\N	153843	0	195662009	4112343		0
39149	2325	4112343	1999-12-09	1999-12-09 00:00:00	1999-12-22	1999-12-22 00:00:00	32020		\N	154602	0	195662009	4112343		0
39194	2327	4112343	1976-07-20	1976-07-20 00:00:00	1976-07-28	1976-07-28 00:00:00	32020		\N	154777	0	195662009	4112343		0
39443	2337	40481087	2000-04-20	2000-04-20 00:00:00	2000-05-11	2000-05-11 00:00:00	32020		\N	155506	0	444814009	40481087		0
39527	2342	260139	2012-04-20	2012-04-20 00:00:00	2012-04-27	2012-04-27 00:00:00	32020		\N	155926	0	10509002	260139		0
39737	2352	40481087	1981-08-18	1981-08-18 00:00:00	1981-08-25	1981-08-25 00:00:00	32020		\N	156688	0	444814009	40481087		0
39932	2366	28060	1968-11-13	1968-11-13 00:00:00	1968-11-21	1968-11-21 00:00:00	32020		\N	157527	0	43878008	28060		0
40025	2373	260139	1996-06-12	1996-06-12 00:00:00	1996-06-26	1996-06-26 00:00:00	32020		\N	157940	0	10509002	260139		0
40214	2384	4112343	2004-01-24	2004-01-24 00:00:00	2004-02-05	2004-02-05 00:00:00	32020		\N	158509	0	195662009	4112343		0
40347	2394	40481087	1954-04-09	1954-04-09 00:00:00	1954-04-16	1954-04-16 00:00:00	32020		\N	159129	0	444814009	40481087		0
40575	2412	260139	1990-11-02	1990-11-02 00:00:00	1990-11-16	1990-11-16 00:00:00	32020		\N	160096	0	10509002	260139		0
40766	2424	4296204	1997-09-08	1997-09-08 00:00:00	1997-09-22	1997-09-22 00:00:00	32020		\N	160869	0	403190006	4296204		0
40928	2435	4112343	1981-04-15	1981-04-15 00:00:00	1981-04-28	1981-04-28 00:00:00	32020		\N	161417	0	195662009	4112343		0
41163	2445	4112343	1931-11-14	1931-11-14 00:00:00	1931-11-26	1931-11-26 00:00:00	32020		\N	162254	0	195662009	4112343		0
41247	2450	40481087	2018-10-29	2018-10-29 00:00:00	2018-11-12	2018-11-12 00:00:00	32020		\N	162491	0	444814009	40481087		0
41412	2462	260139	1989-09-19	1989-09-19 00:00:00	1989-10-03	1989-10-03 00:00:00	32020		\N	163233	0	10509002	260139		0
41554	2470	260139	2000-01-11	2000-01-11 00:00:00	2000-01-18	2000-01-18 00:00:00	32020		\N	163819	0	10509002	260139		0
41716	2481	4059173	2012-08-22	2012-08-22 00:00:00	2012-10-21	2012-10-21 00:00:00	32020		\N	164390	0	16114001	4059173		0
41964	2498	4218389	1995-08-29	1995-08-29 00:00:00	1995-09-26	1995-09-26 00:00:00	32020		\N	165403	0	39848009	4218389		0
42123	2509	4237458	1975-11-04	1975-11-04 00:00:00	1975-12-04	1975-12-04 00:00:00	32020		\N	166089	0	58150001	4237458		0
42330	2521	378001	1983-06-24	1983-06-24 00:00:00	1983-08-23	1983-08-23 00:00:00	32020		\N	166740	0	62106007	378001		0
42471	2530	40481087	1973-08-02	1973-08-02 00:00:00	1973-08-23	1973-08-23 00:00:00	32020		\N	167234	0	444814009	40481087		0
31989	1900	257012	2002-11-08	2002-11-08 00:00:00	\N	\N	32020		\N	126454	0	40055000	257012		0
32180	1911	40481087	1976-05-08	1976-05-08 00:00:00	1976-05-29	1976-05-29 00:00:00	32020		\N	127100	0	444814009	40481087		0
32319	1921	260139	2012-12-17	2012-12-17 00:00:00	2012-12-24	2012-12-24 00:00:00	32020		\N	127748	0	10509002	260139		0
32484	1928	260139	1997-09-21	1997-09-21 00:00:00	1997-09-30	1997-09-30 00:00:00	32020		\N	128339	0	10509002	260139		0
22076	1320	260139	1985-10-11	1985-10-11 00:00:00	1985-10-18	1985-10-18 00:00:00	32020		\N	87483	0	10509002	260139		0
32847	1950	40481087	1989-07-06	1989-07-06 00:00:00	1989-07-20	1989-07-20 00:00:00	32020		\N	129627	0	444814009	40481087		0
32907	1952	260139	2001-12-18	2001-12-18 00:00:00	2002-01-01	2002-01-01 00:00:00	32020		\N	129817	0	10509002	260139		0
33109	1965	4027663	2000-01-22	2000-01-22 00:00:00	\N	\N	32020		\N	130654	0	13200003	4027663		0
33242	1973	372328	1974-03-23	1974-03-23 00:00:00	1974-05-13	1974-05-13 00:00:00	32020		\N	131191	0	65363002	372328		0
33484	1986	28060	1988-12-03	1988-12-03 00:00:00	1988-12-13	1988-12-13 00:00:00	32020		\N	132264	0	43878008	28060		0
33571	1991	40481087	1994-05-30	1994-05-30 00:00:00	1994-06-06	1994-06-06 00:00:00	32020		\N	132596	0	444814009	40481087		0
33740	2002	378001	2002-07-13	2002-07-13 00:00:00	2002-08-12	2002-08-12 00:00:00	32020		\N	133383	0	62106007	378001		0
33964	2017	260139	1980-07-03	1980-07-03 00:00:00	1980-07-17	1980-07-17 00:00:00	32020		\N	134191	0	10509002	260139		0
34119	2027	40481087	2001-06-23	2001-06-23 00:00:00	2001-06-30	2001-06-30 00:00:00	32020		\N	134871	0	444814009	40481087		0
34279	2034	4035415	2016-11-04	2016-11-04 00:00:00	2017-01-03	2017-01-03 00:00:00	32020		\N	135431	0	239720000	4035415		0
34490	2046	40481087	1953-05-22	1953-05-22 00:00:00	1953-06-12	1953-06-12 00:00:00	32020		\N	136173	0	444814009	40481087		0
34551	2051	4116491	2017-12-22	2017-12-22 00:00:00	2018-01-22	2018-01-22 00:00:00	32020		\N	136373	0	301011002	4116491		0
34855	2070	40481087	1981-07-11	1981-07-11 00:00:00	1981-07-18	1981-07-18 00:00:00	32020		\N	137744	0	444814009	40481087		0
34990	2077	378419	2004-07-25	2004-07-25 00:00:00	\N	\N	32020		\N	138324	0	26929004	378419		0
35050	2080	260139	2009-04-09	2009-04-09 00:00:00	2009-04-23	2009-04-23 00:00:00	32020		\N	138541	0	10509002	260139		0
35231	2088	4116491	1951-09-12	1951-09-12 00:00:00	1951-11-01	1951-11-01 00:00:00	32020		\N	139263	0	301011002	4116491		0
35498	2103	372328	1975-11-08	1975-11-08 00:00:00	1976-04-17	1976-04-17 00:00:00	32020		\N	140166	0	65363002	372328		0
35597	2109	40481087	1973-12-07	1973-12-07 00:00:00	1973-12-14	1973-12-14 00:00:00	32020		\N	140409	0	444814009	40481087		0
35719	2116	40481087	1952-09-13	1952-09-13 00:00:00	1952-09-20	1952-09-20 00:00:00	32020		\N	140826	0	444814009	40481087		0
25397	1513	4109685	2010-03-31	2010-03-31 00:00:00	2010-04-14	2010-04-14 00:00:00	32020		\N	101153	0	284551006	4109685		0
36121	2140	81893	1988-05-22	1988-05-22 00:00:00	\N	\N	32020		\N	142550	0	64766004	81893		0
36276	2150	4112343	1973-09-09	1973-09-09 00:00:00	1973-09-22	1973-09-22 00:00:00	32020		\N	143176	0	195662009	4112343		0
36447	2156	4294548	1994-04-03	1994-04-03 00:00:00	1994-07-10	1994-07-10 00:00:00	32020		\N	143747	0	75498004	4294548		0
36604	2166	28060	2015-04-26	2015-04-26 00:00:00	2015-05-09	2015-05-09 00:00:00	32020		\N	144318	0	43878008	28060		0
36758	2175	40481087	1990-03-09	1990-03-09 00:00:00	1990-03-30	1990-03-30 00:00:00	32020		\N	145001	0	444814009	40481087		0
36937	2185	40481087	1950-09-19	1950-09-19 00:00:00	1950-09-25	1950-09-25 00:00:00	32020		\N	145677	0	444814009	40481087		0
26552	1572	4112343	1991-04-02	1991-04-02 00:00:00	1991-04-11	1991-04-11 00:00:00	32020		\N	105608	0	195662009	4112343		0
37257	2206	30753	2007-06-17	2007-06-17 00:00:00	\N	\N	32020		\N	146998	0	16761005	30753		0
37446	2220	260139	1966-12-15	1966-12-15 00:00:00	1966-12-22	1966-12-22 00:00:00	32020		\N	147851	0	10509002	260139		0
37539	2226	40481087	2011-12-20	2011-12-20 00:00:00	2011-12-27	2011-12-27 00:00:00	32020		\N	148125	0	444814009	40481087		0
37689	2235	40481087	1953-12-30	1953-12-30 00:00:00	1954-01-20	1954-01-20 00:00:00	32020		\N	148653	0	444814009	40481087		0
37938	2250	192671	1995-05-12	1995-05-12 00:00:00	\N	\N	32020		\N	149694	0	K92.2	35208414		0
38156	2265	257012	1997-06-04	1997-06-04 00:00:00	\N	\N	32020		\N	150597	0	40055000	257012		0
38267	2273	81893	2015-05-09	2015-05-09 00:00:00	\N	\N	32020		\N	151117	0	64766004	81893		0
48972	2898	80180	2016-08-29	2016-08-29 00:00:00	\N	\N	32020		\N	193099	0	396275006	80180		0
38648	2294	257012	1965-10-19	1965-10-19 00:00:00	\N	\N	32020		\N	152672	0	40055000	257012		0
38750	2300	4112343	1966-03-29	1966-03-29 00:00:00	1966-04-11	1966-04-11 00:00:00	32020		\N	153204	0	195662009	4112343		0
38938	2314	440086	1963-07-04	1963-07-04 00:00:00	1964-06-11	1964-06-11 00:00:00	32020		\N	153903	0	192127007	440086		0
39150	2325	4116491	2017-11-28	2017-11-28 00:00:00	2018-01-17	2018-01-17 00:00:00	32020		\N	154591	0	301011002	4116491		0
39195	2327	4112343	1979-05-15	1979-05-15 00:00:00	1979-05-26	1979-05-26 00:00:00	32020		\N	154733	0	195662009	4112343		0
39444	2337	4152936	2011-02-28	2011-02-28 00:00:00	2011-03-14	2011-03-14 00:00:00	32020		\N	155542	0	283385000	4152936		0
39528	2342	4156265	1990-01-28	1990-01-28 00:00:00	1990-02-18	1990-02-18 00:00:00	32020		\N	155888	0	370247008	4156265		0
39738	2352	4027663	2004-10-17	2004-10-17 00:00:00	\N	\N	32020		\N	156632	0	13200003	4027663		0
39933	2366	4112343	2015-10-28	2015-10-28 00:00:00	2015-11-04	2015-11-04 00:00:00	32020		\N	157486	0	195662009	4112343		0
40026	2373	260139	1992-12-01	1992-12-01 00:00:00	1992-12-15	1992-12-15 00:00:00	32020		\N	157900	0	10509002	260139		0
40238	2387	4283893	2009-02-01	2009-02-01 00:00:00	2009-05-17	2009-05-17 00:00:00	32020		\N	158763	0	36971009	4283893		0
40348	2394	4218389	1955-06-23	1955-06-23 00:00:00	1955-07-28	1955-07-28 00:00:00	32020		\N	159213	0	39848009	4218389		0
40592	2414	260139	1981-10-29	1981-10-29 00:00:00	1981-11-05	1981-11-05 00:00:00	32020		\N	160223	0	10509002	260139		0
40767	2424	196456	1997-06-06	1997-06-06 00:00:00	1997-06-06	1997-06-06 00:00:00	32020		\N	160819	0	235919008	196456		0
40929	2435	257012	1988-09-12	1988-09-12 00:00:00	\N	\N	32020		\N	161409	0	40055000	257012		0
41164	2445	378001	1967-01-09	1967-01-09 00:00:00	1967-03-10	1967-03-10 00:00:00	32020		\N	162232	0	62106007	378001		0
41248	2450	192671	1986-06-04	1986-06-04 00:00:00	\N	\N	32020		\N	162561	0	K92.2	35208414		0
41413	2462	28060	1966-10-27	1966-10-27 00:00:00	1966-11-06	1966-11-06 00:00:00	32020		\N	163318	0	43878008	28060		0
41555	2470	4116491	1993-12-06	1993-12-06 00:00:00	1994-01-23	1994-01-23 00:00:00	32020		\N	163818	0	301011002	4116491		0
41717	2481	4112343	1996-10-12	1996-10-12 00:00:00	1996-10-23	1996-10-23 00:00:00	32020		\N	164408	0	195662009	4112343		0
41965	2498	81151	1972-08-03	1972-08-03 00:00:00	1972-08-17	1972-08-17 00:00:00	32020		\N	165400	0	44465007	81151		0
42124	2509	260139	2004-04-06	2004-04-06 00:00:00	2004-04-20	2004-04-20 00:00:00	32020		\N	166097	0	10509002	260139		0
52789	3125	4112343	1994-08-10	1994-08-10 00:00:00	1994-08-18	1994-08-18 00:00:00	32020		\N	207947	0	195662009	4112343		0
42472	2530	4112343	1979-04-10	1979-04-10 00:00:00	1979-04-17	1979-04-17 00:00:00	32020		\N	167245	0	195662009	4112343		0
31998	1902	4283893	2016-05-06	2016-05-06 00:00:00	2016-06-24	2016-06-24 00:00:00	32020		\N	126628	0	36971009	4283893		0
32181	1911	260139	1957-06-28	1957-06-28 00:00:00	1957-07-05	1957-07-05 00:00:00	32020		\N	127165	0	10509002	260139		0
32320	1921	40481087	2012-03-23	2012-03-23 00:00:00	2012-04-13	2012-04-13 00:00:00	32020		\N	127765	0	444814009	40481087		0
32485	1928	40481087	1996-05-27	1996-05-27 00:00:00	1996-06-17	1996-06-17 00:00:00	32020		\N	128339	0	444814009	40481087		0
22077	1320	4112343	1979-08-22	1979-08-22 00:00:00	1979-09-02	1979-09-02 00:00:00	32020		\N	87514	0	195662009	4112343		0
32848	1950	28060	1952-10-10	1952-10-10 00:00:00	1952-10-22	1952-10-22 00:00:00	32020		\N	129645	0	43878008	28060		0
32908	1952	257012	1995-12-27	1995-12-27 00:00:00	\N	\N	32020		\N	129836	0	40055000	257012		0
33110	1965	378001	1989-03-26	1989-03-26 00:00:00	1989-04-25	1989-04-25 00:00:00	32020		\N	130669	0	62106007	378001		0
33243	1973	40481087	2014-06-02	2014-06-02 00:00:00	2014-06-09	2014-06-09 00:00:00	32020		\N	131164	0	444814009	40481087		0
33485	1986	372328	2009-12-31	2009-12-31 00:00:00	2011-02-01	2011-02-01 00:00:00	32020		\N	132267	0	65363002	372328		0
33572	1991	4278672	1958-07-15	1958-07-15 00:00:00	1958-10-13	1958-10-13 00:00:00	32020		\N	132607	0	65966004	4278672		0
33741	2002	4294548	1981-07-17	1981-07-17 00:00:00	1981-09-11	1981-09-11 00:00:00	32020		\N	133364	0	75498004	4294548		0
33965	2017	80180	2007-10-08	2007-10-08 00:00:00	\N	\N	32020		\N	134215	0	396275006	80180		0
34120	2027	30753	2001-10-28	2001-10-28 00:00:00	\N	\N	32020		\N	134871	0	16761005	30753		0
34280	2034	4283893	1968-01-10	1968-01-10 00:00:00	1968-01-24	1968-01-24 00:00:00	32020		\N	135492	0	36971009	4283893		0
34491	2046	317576	2004-02-24	2004-02-24 00:00:00	\N	\N	32020		\N	136128	0	53741008	317576		0
34552	2051	4112343	1980-07-11	1980-07-11 00:00:00	1980-07-18	1980-07-18 00:00:00	32020		\N	136346	0	195662009	4112343		0
34856	2070	4112343	1988-03-20	1988-03-20 00:00:00	1988-03-30	1988-03-30 00:00:00	32020		\N	137766	0	195662009	4112343		0
34991	2077	4112343	2006-07-10	2006-07-10 00:00:00	2006-07-22	2006-07-22 00:00:00	32020		\N	138274	0	195662009	4112343		0
35051	2080	40481087	1984-03-24	1984-03-24 00:00:00	1984-04-07	1984-04-07 00:00:00	32020		\N	138515	0	444814009	40481087		0
35232	2088	40481087	1913-04-04	1913-04-04 00:00:00	1913-04-18	1913-04-18 00:00:00	32020		\N	139256	0	444814009	40481087		0
35499	2103	40481087	1976-04-30	1976-04-30 00:00:00	1976-05-21	1976-05-21 00:00:00	32020		\N	140160	0	444814009	40481087		0
35598	2109	78272	1985-06-23	1985-06-23 00:00:00	1985-07-07	1985-07-07 00:00:00	32020		\N	140425	0	70704007	78272		0
35720	2116	40481087	1978-08-11	1978-08-11 00:00:00	1978-09-01	1978-09-01 00:00:00	32020		\N	140827	0	444814009	40481087		0
25398	1513	440086	1979-05-24	1979-05-24 00:00:00	1980-08-14	1980-08-14 00:00:00	32020		\N	101160	0	192127007	440086		0
36122	2140	260139	1964-12-25	1964-12-25 00:00:00	1965-01-01	1965-01-01 00:00:00	32020		\N	142504	0	10509002	260139		0
36277	2150	260139	1966-07-14	1966-07-14 00:00:00	1966-07-28	1966-07-28 00:00:00	32020		\N	143147	0	10509002	260139		0
36448	2156	4112343	2016-01-25	2016-01-25 00:00:00	2016-02-05	2016-02-05 00:00:00	32020		\N	143699	0	195662009	4112343		0
36605	2166	195588	1992-05-05	1992-05-05 00:00:00	1992-06-22	1992-06-22 00:00:00	32020		\N	144284	0	38822007	195588		0
36759	2175	4278672	1981-01-02	1981-01-02 00:00:00	1981-03-03	1981-03-03 00:00:00	32020		\N	145067	0	65966004	4278672		0
36938	2185	4112343	1946-12-04	1946-12-04 00:00:00	1946-12-14	1946-12-14 00:00:00	32020		\N	145680	0	195662009	4112343		0
26553	1572	40481087	2019-02-13	2019-02-13 00:00:00	2019-03-06	2019-03-06 00:00:00	32020		\N	105610	0	444814009	40481087		0
37258	2206	80180	2008-03-13	2008-03-13 00:00:00	\N	\N	32020		\N	146998	0	396275006	80180		0
37447	2220	4112343	1989-07-10	1989-07-10 00:00:00	1989-07-19	1989-07-19 00:00:00	32020		\N	147771	0	195662009	4112343		0
37540	2226	260139	1945-08-29	1945-08-29 00:00:00	1945-09-12	1945-09-12 00:00:00	32020		\N	148136	0	10509002	260139		0
37690	2235	28060	2000-10-19	2000-10-19 00:00:00	2000-10-26	2000-10-26 00:00:00	32020		\N	148691	0	43878008	28060		0
37939	2250	4109685	1988-07-17	1988-07-17 00:00:00	1988-08-07	1988-08-07 00:00:00	32020		\N	149650	0	284551006	4109685		0
38157	2265	80180	2002-05-28	2002-05-28 00:00:00	\N	\N	32020		\N	150581	0	396275006	80180		0
38268	2273	40481087	2015-03-03	2015-03-03 00:00:00	2015-03-10	2015-03-10 00:00:00	32020		\N	151117	0	444814009	40481087		0
48973	2898	4112343	1986-08-09	1986-08-09 00:00:00	1986-08-22	1986-08-22 00:00:00	32020		\N	193066	0	195662009	4112343		0
38649	2294	40481087	2011-09-03	2011-09-03 00:00:00	2011-09-17	2011-09-17 00:00:00	32020		\N	152720	0	444814009	40481087		0
38751	2300	4152936	1960-12-29	1960-12-29 00:00:00	1961-01-12	1961-01-12 00:00:00	32020		\N	153126	0	283385000	4152936		0
38939	2314	40481087	1975-04-09	1975-04-09 00:00:00	1975-04-16	1975-04-16 00:00:00	32020		\N	153874	0	444814009	40481087		0
39151	2325	260139	1981-01-06	1981-01-06 00:00:00	1981-01-13	1981-01-13 00:00:00	32020		\N	154617	0	10509002	260139		0
39196	2327	40481087	1992-07-06	1992-07-06 00:00:00	1992-07-13	1992-07-13 00:00:00	32020		\N	154748	0	444814009	40481087		0
39445	2337	260139	1993-09-08	1993-09-08 00:00:00	1993-09-15	1993-09-15 00:00:00	32020		\N	155472	0	10509002	260139		0
39529	2342	40481087	2008-05-01	2008-05-01 00:00:00	2008-05-22	2008-05-22 00:00:00	32020		\N	155895	0	444814009	40481087		0
39739	2352	260139	2000-01-24	2000-01-24 00:00:00	2000-02-07	2000-02-07 00:00:00	32020		\N	156619	0	10509002	260139		0
39934	2366	4059173	1974-12-09	1974-12-09 00:00:00	1975-03-09	1975-03-09 00:00:00	32020		\N	157516	0	16114001	4059173		0
40027	2373	40481087	2008-04-17	2008-04-17 00:00:00	2008-05-08	2008-05-08 00:00:00	32020		\N	157959	0	444814009	40481087		0
40239	2387	81893	2005-01-09	2005-01-09 00:00:00	\N	\N	32020		\N	158778	0	64766004	81893		0
40349	2394	260139	1914-08-14	1914-08-14 00:00:00	1914-08-28	1914-08-28 00:00:00	32020		\N	159120	0	10509002	260139		0
40593	2414	40481087	1946-08-25	1946-08-25 00:00:00	1946-09-08	1946-09-08 00:00:00	32020		\N	160194	0	444814009	40481087		0
40768	2424	198809	1997-06-06	1997-06-06 00:00:00	1997-06-06	1997-06-06 00:00:00	32020		\N	160819	0	65275009	198809		0
40930	2435	4112343	2010-01-18	2010-01-18 00:00:00	2010-01-28	2010-01-28 00:00:00	32020		\N	161435	0	195662009	4112343		0
41168	2447	4112343	2011-02-27	2011-02-27 00:00:00	2011-03-11	2011-03-11 00:00:00	32020		\N	162315	0	195662009	4112343		0
41249	2450	40481087	1977-01-31	1977-01-31 00:00:00	1977-02-21	1977-02-21 00:00:00	32020		\N	162538	0	444814009	40481087		0
41414	2462	40481087	1995-04-15	1995-04-15 00:00:00	1995-04-29	1995-04-29 00:00:00	32020		\N	163275	0	444814009	40481087		0
41556	2470	372328	1960-09-18	1960-09-18 00:00:00	1960-11-21	1960-11-21 00:00:00	32020		\N	163822	0	65363002	372328		0
41718	2481	40481087	2013-05-11	2013-05-11 00:00:00	2013-06-01	2013-06-01 00:00:00	32020		\N	164373	0	444814009	40481087		0
41966	2498	40481087	2012-03-30	2012-03-30 00:00:00	2012-04-13	2012-04-13 00:00:00	32020		\N	165424	0	444814009	40481087		0
42125	2509	40481087	1973-06-24	1973-06-24 00:00:00	1973-07-15	1973-07-15 00:00:00	32020		\N	166092	0	444814009	40481087		0
52790	3125	40481087	2015-03-14	2015-03-14 00:00:00	2015-04-04	2015-04-04 00:00:00	32020		\N	207938	0	444814009	40481087		0
42473	2530	4278672	1980-09-09	1980-09-09 00:00:00	1980-12-08	1980-12-08 00:00:00	32020		\N	167223	0	65966004	4278672		0
31999	1902	4294548	2011-11-30	2011-11-30 00:00:00	2011-12-07	2011-12-07 00:00:00	32020		\N	126592	0	75498004	4294548		0
42663	2543	81151	2011-10-17	2011-10-17 00:00:00	2011-11-07	2011-11-07 00:00:00	32020		\N	168267	0	44465007	81151		0
32321	1921	81151	2015-01-26	2015-01-26 00:00:00	2015-02-23	2015-02-23 00:00:00	32020		\N	127792	0	44465007	81151		0
32486	1928	4116491	2016-07-23	2016-07-23 00:00:00	2016-09-14	2016-09-14 00:00:00	32020		\N	128313	0	301011002	4116491		0
22078	1320	4112343	1976-01-25	1976-01-25 00:00:00	1976-02-07	1976-02-07 00:00:00	32020		\N	87482	0	195662009	4112343		0
32849	1950	4112343	1982-12-31	1982-12-31 00:00:00	1983-01-11	1983-01-11 00:00:00	32020		\N	129699	0	195662009	4112343		0
32909	1952	40481087	1963-10-25	1963-10-25 00:00:00	1963-11-08	1963-11-08 00:00:00	32020		\N	129832	0	444814009	40481087		0
33111	1965	4294548	1995-03-11	1995-03-11 00:00:00	1995-03-25	1995-03-25 00:00:00	32020		\N	130642	0	75498004	4294548		0
33263	1975	40481087	1931-12-28	1931-12-28 00:00:00	1932-01-18	1932-01-18 00:00:00	32020		\N	131264	0	444814009	40481087		0
33486	1986	440086	1988-11-17	1988-11-17 00:00:00	1989-11-23	1989-11-23 00:00:00	32020		\N	132263	0	192127007	440086		0
33573	1991	78272	1977-01-06	1977-01-06 00:00:00	1977-02-10	1977-02-10 00:00:00	32020		\N	132608	0	70704007	78272		0
33742	2002	81151	1995-05-07	1995-05-07 00:00:00	1995-05-21	1995-05-21 00:00:00	32020		\N	133382	0	44465007	81151		0
33966	2017	4296205	1972-09-11	1972-09-11 00:00:00	1972-09-25	1972-09-25 00:00:00	32020		\N	134157	0	403191005	4296205		0
34121	2027	80180	2002-03-27	2002-03-27 00:00:00	\N	\N	32020		\N	134871	0	396275006	80180		0
34281	2034	4294548	1994-10-10	1994-10-10 00:00:00	1994-11-07	1994-11-07 00:00:00	32020		\N	135449	0	75498004	4294548		0
34492	2046	4113008	1995-01-18	1995-01-18 00:00:00	1995-02-08	1995-02-08 00:00:00	32020		\N	136153	0	284549007	4113008		0
34553	2051	40481087	1966-03-11	1966-03-11 00:00:00	1966-03-25	1966-03-25 00:00:00	32020		\N	136349	0	444814009	40481087		0
34857	2071	80180	2004-05-22	2004-05-22 00:00:00	\N	\N	32020		\N	137826	0	396275006	80180		0
34992	2077	28060	1951-07-09	1951-07-09 00:00:00	1951-07-22	1951-07-22 00:00:00	32020		\N	138266	0	43878008	28060		0
35052	2080	257012	2000-07-26	2000-07-26 00:00:00	\N	\N	32020		\N	138575	0	40055000	257012		0
35233	2088	260139	1915-12-29	1915-12-29 00:00:00	1916-01-05	1916-01-05 00:00:00	32020		\N	139164	0	10509002	260139		0
35500	2103	4278672	1975-02-27	1975-02-27 00:00:00	1975-05-28	1975-05-28 00:00:00	32020		\N	140121	0	65966004	4278672		0
35599	2109	4112343	1985-11-11	1985-11-11 00:00:00	1985-11-24	1985-11-24 00:00:00	32020		\N	140411	0	195662009	4112343		0
35721	2116	40481087	2008-12-26	2008-12-26 00:00:00	2009-01-16	2009-01-16 00:00:00	32020		\N	140807	0	444814009	40481087		0
35875	2127	40481087	1971-07-29	1971-07-29 00:00:00	1971-08-12	1971-08-12 00:00:00	32020		\N	141462	0	444814009	40481087		0
36123	2140	40481087	2002-05-12	2002-05-12 00:00:00	2002-05-19	2002-05-19 00:00:00	32020		\N	142553	0	444814009	40481087		0
36278	2150	4299128	2017-02-28	2017-02-28 00:00:00	2017-03-28	2017-03-28 00:00:00	32020		\N	143155	0	403192003	4299128		0
36449	2156	40481087	2007-06-27	2007-06-27 00:00:00	2007-07-18	2007-07-18 00:00:00	32020		\N	143722	0	444814009	40481087		0
36606	2166	4112343	1975-03-14	1975-03-14 00:00:00	1975-03-26	1975-03-26 00:00:00	32020		\N	144288	0	195662009	4112343		0
36760	2175	4156265	1990-07-14	1990-07-14 00:00:00	1990-08-04	1990-08-04 00:00:00	32020		\N	145068	0	370247008	4156265		0
36939	2185	40481087	1979-07-18	1979-07-18 00:00:00	1979-08-08	1979-08-08 00:00:00	32020		\N	145679	0	444814009	40481087		0
26554	1572	40481087	1977-08-31	1977-08-31 00:00:00	1977-09-14	1977-09-14 00:00:00	32020		\N	105543	0	444814009	40481087		0
37259	2206	372328	1976-03-30	1976-03-30 00:00:00	1976-11-12	1976-11-12 00:00:00	32020		\N	147053	0	65363002	372328		0
37448	2220	40481087	1953-03-15	1953-03-15 00:00:00	1953-03-29	1953-03-29 00:00:00	32020		\N	147794	0	444814009	40481087		0
37541	2226	28060	1993-11-06	1993-11-06 00:00:00	1993-11-19	1993-11-19 00:00:00	32020		\N	148075	0	43878008	28060		0
37691	2235	40481087	1966-01-24	1966-01-24 00:00:00	1966-02-14	1966-02-14 00:00:00	32020		\N	148655	0	444814009	40481087		0
37940	2250	260139	1974-08-13	1974-08-13 00:00:00	1974-08-20	1974-08-20 00:00:00	32020		\N	149681	0	10509002	260139		0
38158	2265	260139	1964-06-12	1964-06-12 00:00:00	1964-06-26	1964-06-26 00:00:00	32020		\N	150529	0	10509002	260139		0
38269	2273	192671	2016-06-25	2016-06-25 00:00:00	\N	\N	32020		\N	151092	0	K92.2	35208414		0
48974	2898	260139	2000-08-02	2000-08-02 00:00:00	2000-08-16	2000-08-16 00:00:00	32020		\N	192975	0	10509002	260139		0
38650	2294	4283893	1980-02-05	1980-02-05 00:00:00	1980-03-18	1980-03-18 00:00:00	32020		\N	152679	0	36971009	4283893		0
38752	2300	4112343	2010-09-25	2010-09-25 00:00:00	2010-10-06	2010-10-06 00:00:00	32020		\N	153167	0	195662009	4112343		0
38940	2314	81151	1962-12-13	1962-12-13 00:00:00	1962-12-27	1962-12-27 00:00:00	32020		\N	153864	0	44465007	81151		0
39152	2325	195588	2014-10-18	2014-10-18 00:00:00	2014-11-29	2014-11-29 00:00:00	32020		\N	154605	0	38822007	195588		0
39197	2327	4112343	1965-12-17	1965-12-17 00:00:00	1965-12-30	1965-12-30 00:00:00	32020		\N	154731	0	195662009	4112343		0
39446	2337	40481087	1978-02-05	1978-02-05 00:00:00	1978-02-12	1978-02-12 00:00:00	32020		\N	155543	0	444814009	40481087		0
39530	2342	40481087	2004-04-17	2004-04-17 00:00:00	2004-05-01	2004-05-01 00:00:00	32020		\N	155919	0	444814009	40481087		0
39740	2352	80180	2012-08-01	2012-08-01 00:00:00	\N	\N	32020		\N	156614	0	396275006	80180		0
39935	2366	372328	1966-06-10	1966-06-10 00:00:00	1966-08-22	1966-08-22 00:00:00	32020		\N	157485	0	65363002	372328		0
40028	2373	4112343	1957-06-14	1957-06-14 00:00:00	1957-06-26	1957-06-26 00:00:00	32020		\N	157953	0	195662009	4112343		0
40350	2394	4059173	1988-01-06	1988-01-06 00:00:00	1988-03-06	1988-03-06 00:00:00	32020		\N	159215	0	16114001	4059173		0
40594	2414	28060	1921-08-18	1921-08-18 00:00:00	1921-08-31	1921-08-31 00:00:00	32020		\N	160218	0	43878008	28060		0
40769	2424	372328	1967-11-02	1967-11-02 00:00:00	1968-05-30	1968-05-30 00:00:00	32020		\N	160821	0	65363002	372328		0
40931	2435	260139	2014-03-07	2014-03-07 00:00:00	2014-03-21	2014-03-21 00:00:00	32020		\N	161418	0	10509002	260139		0
51645	3064	372328	1938-08-18	1938-08-18 00:00:00	1938-09-08	1938-09-08 00:00:00	32020		\N	203982	0	65363002	372328		0
41250	2450	4112343	1974-05-07	1974-05-07 00:00:00	1974-05-15	1974-05-15 00:00:00	32020		\N	162490	0	195662009	4112343		0
41415	2462	4112343	2018-05-23	2018-05-23 00:00:00	2018-06-04	2018-06-04 00:00:00	32020		\N	163309	0	195662009	4112343		0
41557	2470	4112343	2019-05-07	2019-05-07 00:00:00	2019-05-20	2019-05-20 00:00:00	32020		\N	163768	0	195662009	4112343		0
41719	2482	4035415	1991-05-16	1991-05-16 00:00:00	1991-06-15	1991-06-15 00:00:00	32020		\N	164478	0	239720000	4035415		0
41967	2498	260139	1992-01-22	1992-01-22 00:00:00	1992-02-05	1992-02-05 00:00:00	32020		\N	165375	0	10509002	260139		0
42126	2509	260139	1972-06-24	1972-06-24 00:00:00	1972-07-01	1972-07-01 00:00:00	32020		\N	166049	0	10509002	260139		0
52791	3125	4155034	1988-11-09	1988-11-09 00:00:00	1988-11-23	1988-11-23 00:00:00	32020		\N	208008	0	283371005	4155034		0
42474	2530	4112343	1979-07-18	1979-07-18 00:00:00	1979-07-26	1979-07-26 00:00:00	32020		\N	167246	0	195662009	4112343		0
32000	1902	4283893	2002-06-10	2002-06-10 00:00:00	2002-07-15	2002-07-15 00:00:00	32020		\N	126591	0	36971009	4283893		0
42665	2543	4029498	1964-10-18	1964-10-18 00:00:00	\N	\N	32020		\N	168264	0	128613002	4029498		0
32322	1921	372328	1957-02-05	1957-02-05 00:00:00	1957-08-26	1957-08-26 00:00:00	32020		\N	127723	0	65363002	372328		0
32487	1928	40481087	1982-04-17	1982-04-17 00:00:00	1982-05-08	1982-05-08 00:00:00	32020		\N	128349	0	444814009	40481087		0
32545	1933	40481087	1972-03-19	1972-03-19 00:00:00	1972-03-26	1972-03-26 00:00:00	32020		\N	128577	0	444814009	40481087		0
32850	1950	372328	1944-11-15	1944-11-15 00:00:00	1945-05-03	1945-05-03 00:00:00	32020		\N	129670	0	65363002	372328		0
32910	1952	4112343	1993-05-19	1993-05-19 00:00:00	1993-05-28	1993-05-28 00:00:00	32020		\N	129822	0	195662009	4112343		0
33112	1965	30753	2009-03-15	2009-03-15 00:00:00	\N	\N	32020		\N	130643	0	16761005	30753		0
33264	1975	4134304	1928-08-22	1928-08-22 00:00:00	1928-11-20	1928-11-20 00:00:00	32020		\N	131309	0	263102004	4134304		0
33487	1986	4112343	1993-11-21	1993-11-21 00:00:00	1993-11-30	1993-11-30 00:00:00	32020		\N	132248	0	195662009	4112343		0
33574	1991	80180	1977-07-24	1977-07-24 00:00:00	\N	\N	32020		\N	132608	0	396275006	80180		0
33743	2002	4283893	1992-04-24	1992-04-24 00:00:00	1992-07-03	1992-07-03 00:00:00	32020		\N	133332	0	36971009	4283893		0
33967	2017	81151	1983-05-01	1983-05-01 00:00:00	1983-06-05	1983-06-05 00:00:00	32020		\N	134158	0	44465007	81151		0
34122	2027	40481087	1974-10-01	1974-10-01 00:00:00	1974-10-22	1974-10-22 00:00:00	32020		\N	134935	0	444814009	40481087		0
34282	2034	260139	1939-12-22	1939-12-22 00:00:00	1939-12-29	1939-12-29 00:00:00	32020		\N	135433	0	10509002	260139		0
34493	2046	40481087	1965-07-10	1965-07-10 00:00:00	1965-07-17	1965-07-17 00:00:00	32020		\N	136165	0	444814009	40481087		0
34554	2051	4283893	2009-01-23	2009-01-23 00:00:00	2009-03-20	2009-03-20 00:00:00	32020		\N	136371	0	36971009	4283893		0
34858	2071	378001	1986-11-23	1986-11-23 00:00:00	1987-01-22	1987-01-22 00:00:00	32020		\N	137803	0	62106007	378001		0
34993	2077	260139	1942-06-08	1942-06-08 00:00:00	1942-06-22	1942-06-22 00:00:00	32020		\N	138238	0	10509002	260139		0
35053	2080	4109685	1992-02-06	1992-02-06 00:00:00	1992-02-27	1992-02-27 00:00:00	32020		\N	138521	0	284551006	4109685		0
35234	2088	40481087	1908-10-30	1908-10-30 00:00:00	1908-11-20	1908-11-20 00:00:00	32020		\N	139163	0	444814009	40481087		0
35501	2103	4156265	2002-08-18	2002-08-18 00:00:00	2002-09-08	2002-09-08 00:00:00	32020		\N	140124	0	370247008	4156265		0
35600	2109	81151	1994-05-21	1994-05-21 00:00:00	1994-06-04	1994-06-04 00:00:00	32020		\N	140426	0	44465007	81151		0
35722	2116	4112343	1984-12-21	1984-12-21 00:00:00	1985-01-02	1985-01-02 00:00:00	32020		\N	140804	0	195662009	4112343		0
35876	2127	40481087	2018-11-15	2018-11-15 00:00:00	2018-11-22	2018-11-22 00:00:00	32020		\N	141456	0	444814009	40481087		0
36124	2140	28060	1989-11-22	1989-11-22 00:00:00	1989-12-04	1989-12-04 00:00:00	32020		\N	142487	0	43878008	28060		0
36279	2150	260139	2013-03-28	2013-03-28 00:00:00	2013-04-04	2013-04-04 00:00:00	32020		\N	143178	0	10509002	260139		0
36450	2156	40481087	2003-01-29	2003-01-29 00:00:00	2003-02-12	2003-02-12 00:00:00	32020		\N	143749	0	444814009	40481087		0
36607	2166	40481087	1986-05-02	1986-05-02 00:00:00	1986-05-23	1986-05-23 00:00:00	32020		\N	144313	0	444814009	40481087		0
36761	2175	4283893	1996-08-03	1996-08-03 00:00:00	1996-09-21	1996-09-21 00:00:00	32020		\N	145003	0	36971009	4283893		0
36940	2185	80180	1981-03-18	1981-03-18 00:00:00	\N	\N	32020		\N	145679	0	396275006	80180		0
26555	1572	4237458	1974-10-31	1974-10-31 00:00:00	1974-12-30	1974-12-30 00:00:00	32020		\N	105545	0	58150001	4237458		0
37260	2206	40481087	2005-11-26	2005-11-26 00:00:00	2005-12-03	2005-12-03 00:00:00	32020		\N	146991	0	444814009	40481087		0
37449	2220	40481087	1971-05-18	1971-05-18 00:00:00	1971-06-08	1971-06-08 00:00:00	32020		\N	147839	0	444814009	40481087		0
37542	2226	4112343	1994-08-17	1994-08-17 00:00:00	1994-08-28	1994-08-28 00:00:00	32020		\N	148146	0	195662009	4112343		0
37692	2235	40481087	1974-06-07	1974-06-07 00:00:00	1974-06-14	1974-06-14 00:00:00	32020		\N	148656	0	444814009	40481087		0
37941	2250	4027663	1987-02-28	1987-02-28 00:00:00	\N	\N	32020		\N	149646	0	13200003	4027663		0
38159	2265	40481087	1975-09-09	1975-09-09 00:00:00	1975-09-16	1975-09-16 00:00:00	32020		\N	150515	0	444814009	40481087		0
38270	2273	40481087	1998-01-06	1998-01-06 00:00:00	1998-01-20	1998-01-20 00:00:00	32020		\N	151091	0	444814009	40481087		0
48975	2898	372328	1981-04-20	1981-04-20 00:00:00	1981-06-23	1981-06-23 00:00:00	32020		\N	193083	0	65363002	372328		0
38651	2294	40481087	1967-11-04	1967-11-04 00:00:00	1967-11-18	1967-11-18 00:00:00	32020		\N	152673	0	444814009	40481087		0
38753	2300	40481087	1984-11-26	1984-11-26 00:00:00	1984-12-10	1984-12-10 00:00:00	32020		\N	153185	0	444814009	40481087		0
38941	2314	378001	2014-09-28	2014-09-28 00:00:00	2014-10-28	2014-10-28 00:00:00	32020		\N	153870	0	62106007	378001		0
39153	2325	40481087	1987-01-08	1987-01-08 00:00:00	1987-01-29	1987-01-29 00:00:00	32020		\N	154586	0	444814009	40481087		0
39198	2327	40481087	1969-05-12	1969-05-12 00:00:00	1969-05-26	1969-05-26 00:00:00	32020		\N	154753	0	444814009	40481087		0
39447	2337	381316	2002-10-01	2002-10-01 00:00:00	\N	\N	32020		\N	155541	0	230690007	381316		0
39531	2342	4112343	2007-09-27	2007-09-27 00:00:00	2007-10-07	2007-10-07 00:00:00	32020		\N	155924	0	195662009	4112343		0
39741	2352	4112343	1997-04-10	1997-04-10 00:00:00	1997-04-22	1997-04-22 00:00:00	32020		\N	156618	0	195662009	4112343		0
39936	2366	81151	1972-03-10	1972-03-10 00:00:00	1972-03-24	1972-03-24 00:00:00	32020		\N	157515	0	44465007	81151		0
40029	2373	4112343	1970-05-01	1970-05-01 00:00:00	1970-05-08	1970-05-08 00:00:00	32020		\N	157938	0	195662009	4112343		0
40241	2387	80180	2006-04-04	2006-04-04 00:00:00	\N	\N	32020		\N	158778	0	396275006	80180		0
40351	2394	40481087	1953-09-14	1953-09-14 00:00:00	1953-10-05	1953-10-05 00:00:00	32020		\N	159148	0	444814009	40481087		0
40595	2414	28060	1940-07-07	1940-07-07 00:00:00	1940-07-16	1940-07-16 00:00:00	32020		\N	160274	0	43878008	28060		0
40770	2424	40481087	1994-03-12	1994-03-12 00:00:00	1994-03-26	1994-03-26 00:00:00	32020		\N	160840	0	444814009	40481087		0
40932	2435	4310024	2013-12-30	2013-12-30 00:00:00	\N	\N	32020		\N	161431	0	424802006	4310024		0
51646	3064	40481087	1947-10-31	1947-10-31 00:00:00	1947-11-21	1947-11-21 00:00:00	32020		\N	203918	0	444814009	40481087		0
41251	2450	40481087	1973-03-09	1973-03-09 00:00:00	1973-03-30	1973-03-30 00:00:00	32020		\N	162489	0	444814009	40481087		0
41416	2462	260139	1966-01-17	1966-01-17 00:00:00	1966-01-24	1966-01-24 00:00:00	32020		\N	163293	0	10509002	260139		0
41558	2470	4112343	1974-08-09	1974-08-09 00:00:00	1974-08-18	1974-08-18 00:00:00	32020		\N	163779	0	195662009	4112343		0
41720	2482	372328	1974-12-11	1974-12-11 00:00:00	1975-02-20	1975-02-20 00:00:00	32020		\N	164429	0	65363002	372328		0
41968	2498	372328	1973-03-31	1973-03-31 00:00:00	1973-06-16	1973-06-16 00:00:00	32020		\N	165408	0	65363002	372328		0
42127	2509	28060	2006-05-02	2006-05-02 00:00:00	2006-05-13	2006-05-13 00:00:00	32020		\N	166050	0	43878008	28060		0
52792	3125	260139	2010-07-06	2010-07-06 00:00:00	2010-07-13	2010-07-13 00:00:00	32020		\N	207948	0	10509002	260139		0
42475	2530	372328	1964-10-23	1964-10-23 00:00:00	1965-01-03	1965-01-03 00:00:00	32020		\N	167256	0	65363002	372328		0
32001	1902	40481087	1986-06-07	1986-06-07 00:00:00	1986-06-28	1986-06-28 00:00:00	32020		\N	126614	0	444814009	40481087		0
42666	2543	78272	2015-02-19	2015-02-19 00:00:00	2015-03-19	2015-03-19 00:00:00	32020		\N	168268	0	70704007	78272		0
32323	1921	4156265	1988-07-25	1988-07-25 00:00:00	1988-08-15	1988-08-15 00:00:00	32020		\N	127791	0	370247008	4156265		0
32488	1928	260139	1993-06-10	1993-06-10 00:00:00	1993-06-24	1993-06-24 00:00:00	32020		\N	128311	0	10509002	260139		0
32546	1933	378001	1994-01-21	1994-01-21 00:00:00	1994-02-20	1994-02-20 00:00:00	32020		\N	128597	0	62106007	378001		0
32851	1950	40481087	2003-06-16	2003-06-16 00:00:00	2003-07-07	2003-07-07 00:00:00	32020		\N	129700	0	444814009	40481087		0
32911	1952	80502	2015-03-02	2015-03-02 00:00:00	\N	\N	32020		\N	129811	0	64859006	80502		0
33113	1965	40481087	2008-09-17	2008-09-17 00:00:00	2008-10-08	2008-10-08 00:00:00	32020		\N	130643	0	444814009	40481087		0
33265	1975	4029498	1973-01-29	1973-01-29 00:00:00	\N	\N	32020		\N	131312	0	128613002	4029498		0
33488	1986	372328	1981-05-13	1981-05-13 00:00:00	1981-10-27	1981-10-27 00:00:00	32020		\N	132241	0	65363002	372328		0
33575	1991	28060	1987-07-02	1987-07-02 00:00:00	1987-07-09	1987-07-09 00:00:00	32020		\N	132559	0	43878008	28060		0
33744	2002	40481087	2006-03-17	2006-03-17 00:00:00	2006-04-07	2006-04-07 00:00:00	32020		\N	133375	0	444814009	40481087		0
33968	2017	260139	2001-08-08	2001-08-08 00:00:00	2001-08-22	2001-08-22 00:00:00	32020		\N	134154	0	10509002	260139		0
34123	2027	28060	1969-01-15	1969-01-15 00:00:00	1969-01-25	1969-01-25 00:00:00	32020		\N	134869	0	43878008	28060		0
34283	2034	81151	1987-01-26	1987-01-26 00:00:00	1987-03-02	1987-03-02 00:00:00	32020		\N	135488	0	44465007	81151		0
34494	2046	40481087	1946-01-16	1946-01-16 00:00:00	1946-01-23	1946-01-23 00:00:00	32020		\N	136169	0	444814009	40481087		0
34555	2051	4134304	2012-12-28	2012-12-28 00:00:00	2013-01-27	2013-01-27 00:00:00	32020		\N	136399	0	263102004	4134304		0
34859	2071	81151	2005-12-13	2005-12-13 00:00:00	2006-01-03	2006-01-03 00:00:00	32020		\N	137788	0	44465007	81151		0
34994	2077	40481087	1934-09-25	1934-09-25 00:00:00	1934-10-16	1934-10-16 00:00:00	32020		\N	138330	0	444814009	40481087		0
35054	2080	4051466	1982-10-18	1982-10-18 00:00:00	1999-01-25	1999-01-25 00:00:00	32020		\N	138532	0	233678006	4051466		0
35235	2088	4059173	1911-09-07	1911-09-07 00:00:00	1911-12-06	1911-12-06 00:00:00	32020		\N	139176	0	16114001	4059173		0
35502	2103	372328	1973-06-19	1973-06-19 00:00:00	1973-07-21	1973-07-21 00:00:00	32020		\N	140154	0	65363002	372328		0
35601	2109	372328	1971-02-16	1971-02-16 00:00:00	1971-05-02	1971-05-02 00:00:00	32020		\N	140408	0	65363002	372328		0
35759	2119	4112343	1984-05-30	1984-05-30 00:00:00	1984-06-10	1984-06-10 00:00:00	32020		\N	140965	0	195662009	4112343		0
35877	2127	4112343	2016-12-21	2016-12-21 00:00:00	2016-12-30	2016-12-30 00:00:00	32020		\N	141455	0	195662009	4112343		0
36125	2140	4113008	1984-02-13	1984-02-13 00:00:00	1984-03-05	1984-03-05 00:00:00	32020		\N	142555	0	284549007	4113008		0
36280	2150	81893	1984-11-02	1984-11-02 00:00:00	\N	\N	32020		\N	143238	0	64766004	81893		0
36451	2156	4134304	1967-06-08	1967-06-08 00:00:00	1967-08-07	1967-08-07 00:00:00	32020		\N	143731	0	263102004	4134304		0
36608	2166	80180	2000-12-24	2000-12-24 00:00:00	\N	\N	32020		\N	144340	0	396275006	80180		0
36762	2175	317576	2000-11-09	2000-11-09 00:00:00	\N	\N	32020		\N	145084	0	53741008	317576		0
36941	2186	40486433	1975-02-15	1975-02-15 00:00:00	1992-02-13	1992-02-13 00:00:00	32020		\N	145729	0	446096008	40486433		0
26556	1572	40481087	1974-11-19	1974-11-19 00:00:00	1974-12-10	1974-12-10 00:00:00	32020		\N	105557	0	444814009	40481087		0
37261	2206	4112343	1984-09-29	1984-09-29 00:00:00	1984-10-12	1984-10-12 00:00:00	32020		\N	147050	0	195662009	4112343		0
37450	2220	4112343	1976-09-03	1976-09-03 00:00:00	1976-09-16	1976-09-16 00:00:00	32020		\N	147862	0	195662009	4112343		0
37552	2228	40481087	1996-01-21	1996-01-21 00:00:00	1996-02-04	1996-02-04 00:00:00	32020		\N	148267	0	444814009	40481087		0
37693	2235	40481087	1989-10-07	1989-10-07 00:00:00	1989-10-28	1989-10-28 00:00:00	32020		\N	148689	0	444814009	40481087		0
37942	2250	40481087	1960-05-24	1960-05-24 00:00:00	1960-05-31	1960-05-31 00:00:00	32020		\N	149664	0	444814009	40481087		0
38160	2266	260139	1995-05-31	1995-05-31 00:00:00	1995-06-14	1995-06-14 00:00:00	32020		\N	150621	0	10509002	260139		0
38271	2273	81151	1994-05-24	1994-05-24 00:00:00	1994-06-21	1994-06-21 00:00:00	32020		\N	151093	0	44465007	81151		0
48976	2898	372328	1980-03-24	1980-03-24 00:00:00	1980-06-24	1980-06-24 00:00:00	32020		\N	193082	0	65363002	372328		0
38652	2294	4112343	1972-01-28	1972-01-28 00:00:00	1972-02-04	1972-02-04 00:00:00	32020		\N	152660	0	195662009	4112343		0
38754	2300	261325	1972-12-07	1972-12-07 00:00:00	\N	\N	32020		\N	153198	0	87433001	261325		0
38942	2314	4218389	1984-04-10	1984-04-10 00:00:00	1984-05-08	1984-05-08 00:00:00	32020		\N	153867	0	39848009	4218389		0
39154	2325	40481087	2015-06-13	2015-06-13 00:00:00	2015-06-27	2015-06-27 00:00:00	32020		\N	154590	0	444814009	40481087		0
39199	2327	80180	1999-11-25	1999-11-25 00:00:00	\N	\N	32020		\N	154770	0	396275006	80180		0
39448	2337	4218389	2001-12-26	2001-12-26 00:00:00	2002-01-16	2002-01-16 00:00:00	32020		\N	155541	0	39848009	4218389		0
39532	2342	372328	1976-05-11	1976-05-11 00:00:00	1976-06-25	1976-06-25 00:00:00	32020		\N	155898	0	65363002	372328		0
39742	2352	40481087	1993-02-14	1993-02-14 00:00:00	1993-02-28	1993-02-28 00:00:00	32020		\N	156673	0	444814009	40481087		0
39937	2366	4134304	1983-06-25	1983-06-25 00:00:00	1983-09-23	1983-09-23 00:00:00	32020		\N	157517	0	263102004	4134304		0
40030	2373	260139	1956-09-16	1956-09-16 00:00:00	1956-09-30	1956-09-30 00:00:00	32020		\N	157956	0	10509002	260139		0
40242	2387	4027663	1997-02-15	1997-02-15 00:00:00	\N	\N	32020		\N	158777	0	13200003	4027663		0
40352	2394	255848	1992-02-04	1992-02-04 00:00:00	\N	\N	32020		\N	159151	0	233604007	255848		0
40596	2414	40481087	1965-02-09	1965-02-09 00:00:00	1965-02-16	1965-02-16 00:00:00	32020		\N	160216	0	444814009	40481087		0
40771	2424	372328	1964-03-05	1964-03-05 00:00:00	1964-05-21	1964-05-21 00:00:00	32020		\N	160847	0	65363002	372328		0
40933	2435	81893	2014-02-28	2014-02-28 00:00:00	\N	\N	32020		\N	161431	0	64766004	81893		0
51647	3064	260139	1993-12-29	1993-12-29 00:00:00	1994-01-12	1994-01-12 00:00:00	32020		\N	203940	0	10509002	260139		0
41290	2456	372328	1961-01-06	1961-01-06 00:00:00	1961-04-09	1961-04-09 00:00:00	32020		\N	162774	0	65363002	372328		0
41417	2462	40481087	1988-12-20	1988-12-20 00:00:00	1989-01-10	1989-01-10 00:00:00	32020		\N	163221	0	444814009	40481087		0
41559	2470	4109685	1962-09-25	1962-09-25 00:00:00	1962-10-16	1962-10-16 00:00:00	32020		\N	163795	0	284551006	4109685		0
41721	2482	40481087	1987-06-23	1987-06-23 00:00:00	1987-07-14	1987-07-14 00:00:00	32020		\N	164425	0	444814009	40481087		0
41969	2498	4237458	2018-08-26	2018-08-26 00:00:00	2018-09-25	2018-09-25 00:00:00	32020		\N	165405	0	58150001	4237458		0
42128	2509	80180	2006-05-20	2006-05-20 00:00:00	\N	\N	32020		\N	166050	0	396275006	80180		0
52793	3125	4112343	1969-06-12	1969-06-12 00:00:00	1969-06-20	1969-06-20 00:00:00	32020		\N	207927	0	195662009	4112343		0
42476	2530	40481087	1988-02-25	1988-02-25 00:00:00	1988-03-03	1988-03-03 00:00:00	32020		\N	167216	0	444814009	40481087		0
32002	1902	4112343	1981-10-09	1981-10-09 00:00:00	1981-10-19	1981-10-19 00:00:00	32020		\N	126590	0	195662009	4112343		0
33154	1967	80180	1994-02-20	1994-02-20 00:00:00	\N	\N	32020		\N	130834	0	396275006	80180		0
42667	2543	4112343	1991-01-15	1991-01-15 00:00:00	1991-01-22	1991-01-22 00:00:00	32020		\N	168221	0	195662009	4112343		0
32324	1921	40481087	1992-12-07	1992-12-07 00:00:00	1992-12-28	1992-12-28 00:00:00	32020		\N	127764	0	444814009	40481087		0
32489	1928	40481087	1975-09-18	1975-09-18 00:00:00	1975-10-02	1975-10-02 00:00:00	32020		\N	128345	0	444814009	40481087		0
32547	1933	372328	1959-11-21	1959-11-21 00:00:00	1960-05-06	1960-05-06 00:00:00	32020		\N	128578	0	65363002	372328		0
32852	1950	40481087	1986-04-10	1986-04-10 00:00:00	1986-04-17	1986-04-17 00:00:00	32020		\N	129626	0	444814009	40481087		0
32912	1952	4294548	1995-12-06	1995-12-06 00:00:00	1996-03-13	1996-03-13 00:00:00	32020		\N	129779	0	75498004	4294548		0
33114	1965	440086	1987-01-25	1987-01-25 00:00:00	1987-03-29	1987-03-29 00:00:00	32020		\N	130652	0	192127007	440086		0
33267	1975	40481087	1948-02-19	1948-02-19 00:00:00	1948-03-04	1948-03-04 00:00:00	32020		\N	131321	0	444814009	40481087		0
33489	1986	80180	2014-04-30	2014-04-30 00:00:00	\N	\N	32020		\N	132224	0	396275006	80180		0
33576	1991	4112343	1983-03-28	1983-03-28 00:00:00	1983-04-07	1983-04-07 00:00:00	32020		\N	132604	0	195662009	4112343		0
33745	2002	260139	2002-08-02	2002-08-02 00:00:00	2002-08-09	2002-08-09 00:00:00	32020		\N	133342	0	10509002	260139		0
33969	2017	40481087	1994-02-08	1994-02-08 00:00:00	1994-03-01	1994-03-01 00:00:00	32020		\N	134160	0	444814009	40481087		0
34124	2027	378001	1963-02-05	1963-02-05 00:00:00	1963-03-07	1963-03-07 00:00:00	32020		\N	134931	0	62106007	378001		0
34284	2034	40481087	2006-04-08	2006-04-08 00:00:00	2006-04-29	2006-04-29 00:00:00	32020		\N	135465	0	444814009	40481087		0
34495	2046	378001	1944-08-31	1944-08-31 00:00:00	1944-10-30	1944-10-30 00:00:00	32020		\N	136150	0	62106007	378001		0
34556	2051	260139	1969-03-18	1969-03-18 00:00:00	1969-04-01	1969-04-01 00:00:00	32020		\N	136365	0	10509002	260139		0
34860	2071	40481087	1990-03-06	1990-03-06 00:00:00	1990-03-27	1990-03-27 00:00:00	32020		\N	137843	0	444814009	40481087		0
34995	2077	80180	1972-06-04	1972-06-04 00:00:00	\N	\N	32020		\N	138292	0	396275006	80180		0
35055	2080	40481087	1990-01-13	1990-01-13 00:00:00	1990-01-20	1990-01-20 00:00:00	32020		\N	138516	0	444814009	40481087		0
35236	2088	4230399	1992-06-18	1992-06-18 00:00:00	1992-09-16	1992-09-16 00:00:00	32020		\N	139183	0	359817006	4230399		0
35503	2103	78272	1982-11-17	1982-11-17 00:00:00	1982-12-01	1982-12-01 00:00:00	32020		\N	140122	0	70704007	78272		0
35602	2109	40481087	1975-07-15	1975-07-15 00:00:00	1975-08-05	1975-08-05 00:00:00	32020		\N	140410	0	444814009	40481087		0
35760	2119	40481087	2014-05-29	2014-05-29 00:00:00	2014-06-19	2014-06-19 00:00:00	32020		\N	141012	0	444814009	40481087		0
35878	2127	372328	2005-06-28	2005-06-28 00:00:00	2006-09-23	2006-09-23 00:00:00	32020		\N	141493	0	65363002	372328		0
36126	2140	260139	1963-06-21	1963-06-21 00:00:00	1963-07-05	1963-07-05 00:00:00	32020		\N	142529	0	10509002	260139		0
36281	2150	80180	1986-02-25	1986-02-25 00:00:00	\N	\N	32020		\N	143238	0	396275006	80180		0
36452	2156	81151	2017-02-15	2017-02-15 00:00:00	2017-03-22	2017-03-22 00:00:00	32020		\N	143687	0	44465007	81151		0
36609	2166	260139	1970-01-08	1970-01-08 00:00:00	1970-01-15	1970-01-15 00:00:00	32020		\N	144277	0	10509002	260139		0
36763	2175	40481087	2004-09-30	2004-09-30 00:00:00	2004-10-14	2004-10-14 00:00:00	32020		\N	144982	0	444814009	40481087		0
36942	2186	372328	1974-06-03	1974-06-03 00:00:00	1974-07-18	1974-07-18 00:00:00	32020		\N	145839	0	65363002	372328		0
26557	1572	195588	1987-06-16	1987-06-16 00:00:00	1987-08-08	1987-08-08 00:00:00	32020		\N	105568	0	38822007	195588		0
37262	2206	40481087	2000-02-13	2000-02-13 00:00:00	2000-02-20	2000-02-20 00:00:00	32020		\N	147038	0	444814009	40481087		0
37451	2220	40481087	1944-06-10	1944-06-10 00:00:00	1944-06-24	1944-06-24 00:00:00	32020		\N	147793	0	444814009	40481087		0
37553	2228	4218389	1962-02-19	1962-02-19 00:00:00	1962-03-19	1962-03-19 00:00:00	32020		\N	148292	0	39848009	4218389		0
37694	2235	440086	1963-12-02	1963-12-02 00:00:00	1969-12-10	1969-12-10 00:00:00	32020		\N	148654	0	192127007	440086		0
37943	2250	40481087	1999-04-04	1999-04-04 00:00:00	1999-04-25	1999-04-25 00:00:00	32020		\N	149685	0	444814009	40481087		0
38161	2266	4152936	1978-06-25	1978-06-25 00:00:00	1978-07-16	1978-07-16 00:00:00	32020		\N	150635	0	283385000	4152936		0
38272	2273	40481087	1988-11-12	1988-11-12 00:00:00	1988-11-19	1988-11-19 00:00:00	32020		\N	151124	0	444814009	40481087		0
48977	2898	260139	2017-04-02	2017-04-02 00:00:00	2017-04-09	2017-04-09 00:00:00	32020		\N	193110	0	10509002	260139		0
38653	2294	4112343	1980-03-26	1980-03-26 00:00:00	1980-04-03	1980-04-03 00:00:00	32020		\N	152702	0	195662009	4112343		0
38755	2300	260139	1957-09-18	1957-09-18 00:00:00	1957-10-02	1957-10-02 00:00:00	32020		\N	153122	0	10509002	260139		0
38943	2314	260139	1986-05-21	1986-05-21 00:00:00	1986-06-04	1986-06-04 00:00:00	32020		\N	153906	0	10509002	260139		0
39155	2325	4230399	2007-10-06	2007-10-06 00:00:00	2007-12-05	2007-12-05 00:00:00	32020		\N	154601	0	359817006	4230399		0
39200	2327	40481087	1967-05-04	1967-05-04 00:00:00	1967-05-18	1967-05-18 00:00:00	32020		\N	154752	0	444814009	40481087		0
39460	2339	40481087	2017-10-02	2017-10-02 00:00:00	2017-10-09	2017-10-09 00:00:00	32020		\N	155646	0	444814009	40481087		0
39533	2342	378001	1979-09-23	1979-09-23 00:00:00	1979-10-23	1979-10-23 00:00:00	32020		\N	155887	0	62106007	378001		0
39743	2352	40481087	1984-11-13	1984-11-13 00:00:00	1984-11-20	1984-11-20 00:00:00	32020		\N	156712	0	444814009	40481087		0
39938	2366	28060	1978-10-04	1978-10-04 00:00:00	1978-10-11	1978-10-11 00:00:00	32020		\N	157528	0	43878008	28060		0
40031	2373	372328	1956-09-15	1956-09-15 00:00:00	1956-09-29	1956-09-29 00:00:00	32020		\N	157961	0	65363002	372328		0
40243	2387	40481087	1994-11-07	1994-11-07 00:00:00	1994-11-28	1994-11-28 00:00:00	32020		\N	158777	0	444814009	40481087		0
40353	2395	28060	1975-05-03	1975-05-03 00:00:00	1975-05-13	1975-05-13 00:00:00	32020		\N	159219	0	43878008	28060		0
40597	2414	260139	1982-03-07	1982-03-07 00:00:00	1982-03-14	1982-03-14 00:00:00	32020		\N	160224	0	10509002	260139		0
40772	2424	40481087	1964-05-11	1964-05-11 00:00:00	1964-06-01	1964-06-01 00:00:00	32020		\N	160810	0	444814009	40481087		0
40934	2435	4112343	1982-09-22	1982-09-22 00:00:00	1982-09-30	1982-09-30 00:00:00	32020		\N	161399	0	195662009	4112343		0
51648	3064	81151	1949-02-17	1949-02-17 00:00:00	1949-03-03	1949-03-03 00:00:00	32020		\N	203996	0	44465007	81151		0
41291	2456	40481087	2018-06-09	2018-06-09 00:00:00	2018-06-23	2018-06-23 00:00:00	32020		\N	162811	0	444814009	40481087		0
41418	2463	81151	1979-10-13	1979-10-13 00:00:00	1979-11-03	1979-11-03 00:00:00	32020		\N	163398	0	44465007	81151		0
41560	2470	40481087	1974-09-28	1974-09-28 00:00:00	1974-10-12	1974-10-12 00:00:00	32020		\N	163816	0	444814009	40481087		0
41722	2482	260139	1975-09-08	1975-09-08 00:00:00	1975-09-22	1975-09-22 00:00:00	32020		\N	164422	0	10509002	260139		0
41970	2498	4112343	1985-11-09	1985-11-09 00:00:00	1985-11-19	1985-11-19 00:00:00	32020		\N	165406	0	195662009	4112343		0
42129	2509	4112343	2010-11-20	2010-11-20 00:00:00	2010-11-29	2010-11-29 00:00:00	32020		\N	166069	0	195662009	4112343		0
52794	3125	40481087	1966-05-03	1966-05-03 00:00:00	1966-05-17	1966-05-17 00:00:00	32020		\N	207935	0	444814009	40481087		0
42477	2530	81151	1968-03-06	1968-03-06 00:00:00	1968-04-10	1968-04-10 00:00:00	32020		\N	167220	0	44465007	81151		0
32003	1902	40481087	2005-04-06	2005-04-06 00:00:00	2005-04-13	2005-04-13 00:00:00	32020		\N	126627	0	444814009	40481087		0
42668	2543	4027663	1993-10-11	1993-10-11 00:00:00	\N	\N	32020		\N	168271	0	13200003	4027663		0
32325	1921	81151	1964-08-16	1964-08-16 00:00:00	1964-08-30	1964-08-30 00:00:00	32020		\N	127789	0	44465007	81151		0
32490	1928	40481087	1988-06-22	1988-06-22 00:00:00	1988-07-06	1988-07-06 00:00:00	32020		\N	128369	0	444814009	40481087		0
32548	1933	4112343	1963-06-07	1963-06-07 00:00:00	1963-06-19	1963-06-19 00:00:00	32020		\N	128549	0	195662009	4112343		0
32853	1950	40481087	1973-06-18	1973-06-18 00:00:00	1973-07-09	1973-07-09 00:00:00	32020		\N	129698	0	444814009	40481087		0
32913	1952	78272	1991-03-24	1991-03-24 00:00:00	1991-04-21	1991-04-21 00:00:00	32020		\N	129789	0	70704007	78272		0
33307	1977	80180	1952-04-20	1952-04-20 00:00:00	\N	\N	32020		\N	131476	0	396275006	80180		0
33115	1965	40481087	2006-08-02	2006-08-02 00:00:00	2006-08-23	2006-08-23 00:00:00	32020		\N	130618	0	444814009	40481087		0
33268	1975	4112343	1936-02-10	1936-02-10 00:00:00	1936-02-18	1936-02-18 00:00:00	32020		\N	131269	0	195662009	4112343		0
33490	1986	81151	2007-08-25	2007-08-25 00:00:00	2007-09-22	2007-09-22 00:00:00	32020		\N	132214	0	44465007	81151		0
33577	1991	260139	1965-12-03	1965-12-03 00:00:00	1965-12-10	1965-12-10 00:00:00	32020		\N	132603	0	10509002	260139		0
33746	2002	260139	1996-02-09	1996-02-09 00:00:00	1996-02-16	1996-02-16 00:00:00	32020		\N	133374	0	10509002	260139		0
33970	2017	40481087	1974-04-11	1974-04-11 00:00:00	1974-04-25	1974-04-25 00:00:00	32020		\N	134189	0	444814009	40481087		0
34125	2027	260139	2002-11-03	2002-11-03 00:00:00	2002-11-10	2002-11-10 00:00:00	32020		\N	134879	0	10509002	260139		0
34285	2034	30753	1962-12-29	1962-12-29 00:00:00	\N	\N	32020		\N	135457	0	16761005	30753		0
34496	2046	81151	1952-09-18	1952-09-18 00:00:00	1952-10-09	1952-10-09 00:00:00	32020		\N	136151	0	44465007	81151		0
34557	2051	260139	1980-03-17	1980-03-17 00:00:00	1980-03-31	1980-03-31 00:00:00	32020		\N	136369	0	10509002	260139		0
45332	2697	40481087	1991-07-28	1991-07-28 00:00:00	1991-08-18	1991-08-18 00:00:00	32020		\N	178598	0	444814009	40481087		0
34996	2077	4112343	1984-12-22	1984-12-22 00:00:00	1984-12-29	1984-12-29 00:00:00	32020		\N	138269	0	195662009	4112343		0
35056	2080	28060	1984-01-20	1984-01-20 00:00:00	1984-01-29	1984-01-29 00:00:00	32020		\N	138514	0	43878008	28060		0
35237	2088	40480160	1992-06-18	1992-06-18 00:00:00	1992-09-16	1992-09-16 00:00:00	32020		\N	139183	0	443165006	40480160		0
35504	2103	260139	1978-02-13	1978-02-13 00:00:00	1978-02-20	1978-02-20 00:00:00	32020		\N	140135	0	10509002	260139		0
35603	2109	81151	1979-02-04	1979-02-04 00:00:00	1979-02-25	1979-02-25 00:00:00	32020		\N	140424	0	44465007	81151		0
35761	2119	40481087	2004-09-02	2004-09-02 00:00:00	2004-09-23	2004-09-23 00:00:00	32020		\N	141085	0	444814009	40481087		0
35879	2127	40481087	1996-02-21	1996-02-21 00:00:00	1996-03-06	1996-03-06 00:00:00	32020		\N	141490	0	444814009	40481087		0
36127	2140	40481087	1975-05-30	1975-05-30 00:00:00	1975-06-20	1975-06-20 00:00:00	32020		\N	142505	0	444814009	40481087		0
36282	2150	30753	1985-06-30	1985-06-30 00:00:00	\N	\N	32020		\N	143238	0	16761005	30753		0
36453	2156	195588	2008-07-12	2008-07-12 00:00:00	2008-08-24	2008-08-24 00:00:00	32020		\N	143715	0	38822007	195588		0
36610	2166	4112343	1978-05-26	1978-05-26 00:00:00	1978-06-05	1978-06-05 00:00:00	32020		\N	144304	0	195662009	4112343		0
36765	2175	4112343	2000-11-02	2000-11-02 00:00:00	2000-11-10	2000-11-10 00:00:00	32020		\N	145005	0	195662009	4112343		0
36943	2186	4112343	1981-11-09	1981-11-09 00:00:00	1981-11-16	1981-11-16 00:00:00	32020		\N	145756	0	195662009	4112343		0
26558	1572	40481087	1992-12-15	1992-12-15 00:00:00	1993-01-05	1993-01-05 00:00:00	32020		\N	105609	0	444814009	40481087		0
37263	2206	4112343	2010-08-13	2010-08-13 00:00:00	2010-08-20	2010-08-20 00:00:00	32020		\N	147025	0	195662009	4112343		0
37452	2220	4112343	2008-06-22	2008-06-22 00:00:00	2008-07-03	2008-07-03 00:00:00	32020		\N	147867	0	195662009	4112343		0
37554	2228	4112343	2000-10-12	2000-10-12 00:00:00	2000-10-22	2000-10-22 00:00:00	32020		\N	148248	0	195662009	4112343		0
37695	2235	80180	1983-05-21	1983-05-21 00:00:00	\N	\N	32020		\N	148671	0	396275006	80180		0
37944	2250	4112343	2013-10-19	2013-10-19 00:00:00	2013-10-29	2013-10-29 00:00:00	32020		\N	149628	0	195662009	4112343		0
38162	2266	378001	1999-04-18	1999-04-18 00:00:00	1999-06-17	1999-06-17 00:00:00	32020		\N	150637	0	62106007	378001		0
38273	2273	4112343	1994-06-04	1994-06-04 00:00:00	1994-06-11	1994-06-11 00:00:00	32020		\N	151115	0	195662009	4112343		0
48978	2898	260139	1984-01-21	1984-01-21 00:00:00	1984-01-28	1984-01-28 00:00:00	32020		\N	192995	0	10509002	260139		0
38654	2294	4112343	1994-11-28	1994-11-28 00:00:00	1994-12-11	1994-12-11 00:00:00	32020		\N	152661	0	195662009	4112343		0
38756	2300	260139	1974-11-08	1974-11-08 00:00:00	1974-11-15	1974-11-15 00:00:00	32020		\N	153205	0	10509002	260139		0
38944	2314	81151	1979-08-14	1979-08-14 00:00:00	1979-09-04	1979-09-04 00:00:00	32020		\N	153866	0	44465007	81151		0
39156	2325	4218389	1996-05-15	1996-05-15 00:00:00	1996-06-05	1996-06-05 00:00:00	32020		\N	154600	0	39848009	4218389		0
39201	2327	28060	1960-06-06	1960-06-06 00:00:00	1960-06-13	1960-06-13 00:00:00	32020		\N	154744	0	43878008	28060		0
39461	2339	40481087	2010-12-17	2010-12-17 00:00:00	2011-01-07	2011-01-07 00:00:00	32020		\N	155645	0	444814009	40481087		0
39534	2342	40481087	2018-08-03	2018-08-03 00:00:00	2018-08-10	2018-08-10 00:00:00	32020		\N	155897	0	444814009	40481087		0
39776	2356	260139	2015-12-14	2015-12-14 00:00:00	2015-12-28	2015-12-28 00:00:00	32020		\N	156909	0	10509002	260139		0
39939	2366	40481087	1970-03-27	1970-03-27 00:00:00	1970-04-03	1970-04-03 00:00:00	32020		\N	157484	0	444814009	40481087		0
40032	2373	4218389	1959-12-29	1959-12-29 00:00:00	1960-02-02	1960-02-02 00:00:00	32020		\N	157945	0	39848009	4218389		0
40244	2387	4112343	1990-12-30	1990-12-30 00:00:00	1991-01-12	1991-01-12 00:00:00	32020		\N	158739	0	195662009	4112343		0
40354	2395	28060	1972-08-06	1972-08-06 00:00:00	1972-08-13	1972-08-13 00:00:00	32020		\N	159243	0	43878008	28060		0
40598	2414	28060	1964-11-23	1964-11-23 00:00:00	1964-12-04	1964-12-04 00:00:00	32020		\N	160169	0	43878008	28060		0
40773	2424	4112343	2018-07-21	2018-07-21 00:00:00	2018-07-31	2018-07-31 00:00:00	32020		\N	160842	0	195662009	4112343		0
40935	2435	372328	1974-08-02	1974-08-02 00:00:00	1974-10-18	1974-10-18 00:00:00	32020		\N	161412	0	65363002	372328		0
51649	3064	40481087	1999-03-06	1999-03-06 00:00:00	1999-03-20	1999-03-20 00:00:00	32020		\N	203942	0	444814009	40481087		0
41292	2456	40481087	1976-07-07	1976-07-07 00:00:00	1976-07-21	1976-07-21 00:00:00	32020		\N	162827	0	444814009	40481087		0
41419	2463	4112343	1992-09-18	1992-09-18 00:00:00	1992-09-26	1992-09-26 00:00:00	32020		\N	163385	0	195662009	4112343		0
41561	2470	80180	1992-12-21	1992-12-21 00:00:00	\N	\N	32020		\N	163828	0	396275006	80180		0
41723	2482	40481087	1978-04-29	1978-04-29 00:00:00	1978-05-06	1978-05-06 00:00:00	32020		\N	164423	0	444814009	40481087		0
41971	2498	4112343	2008-06-10	2008-06-10 00:00:00	2008-06-22	2008-06-22 00:00:00	32020		\N	165392	0	195662009	4112343		0
42130	2509	4112343	1998-05-02	1998-05-02 00:00:00	1998-05-10	1998-05-10 00:00:00	32020		\N	166068	0	195662009	4112343		0
52795	3125	375671	1991-11-08	1991-11-08 00:00:00	1991-12-08	1991-12-08 00:00:00	32020		\N	208009	0	62564004	375671		0
42478	2530	260139	1978-04-06	1978-04-06 00:00:00	1978-04-20	1978-04-20 00:00:00	32020		\N	167212	0	10509002	260139		0
32004	1902	40481087	1962-07-24	1962-07-24 00:00:00	1962-08-14	1962-08-14 00:00:00	32020		\N	126626	0	444814009	40481087		0
42669	2543	4155034	1965-11-12	1965-11-12 00:00:00	1965-11-26	1965-11-26 00:00:00	32020		\N	168265	0	283371005	4155034		0
32326	1921	4056621	1992-11-20	1992-11-20 00:00:00	\N	\N	32020		\N	127764	0	197927001	4056621		0
32491	1928	257012	1979-08-12	1979-08-12 00:00:00	\N	\N	32020		\N	128332	0	40055000	257012		0
32549	1933	40481087	1960-04-24	1960-04-24 00:00:00	1960-05-15	1960-05-15 00:00:00	32020		\N	128562	0	444814009	40481087		0
32854	1950	81151	1988-08-29	1988-08-29 00:00:00	1988-09-19	1988-09-19 00:00:00	32020		\N	129716	0	44465007	81151		0
32914	1952	4112343	2004-09-14	2004-09-14 00:00:00	2004-09-27	2004-09-27 00:00:00	32020		\N	129823	0	195662009	4112343		0
33116	1965	192671	2010-05-27	2010-05-27 00:00:00	\N	\N	32020		\N	130616	0	K92.2	35208414		0
33269	1975	4142905	1923-01-07	1923-01-07 00:00:00	1923-02-06	1923-02-06 00:00:00	32020		\N	131307	0	33737001	4142905		0
33491	1986	372328	1982-02-24	1982-02-24 00:00:00	1982-04-27	1982-04-27 00:00:00	32020		\N	132266	0	65363002	372328		0
33578	1991	40481087	1996-03-06	1996-03-06 00:00:00	1996-03-13	1996-03-13 00:00:00	32020		\N	132597	0	444814009	40481087		0
33749	2004	4152936	1989-12-28	1989-12-28 00:00:00	1990-01-11	1990-01-11 00:00:00	32020		\N	133464	0	283385000	4152936		0
33971	2017	260139	1985-04-26	1985-04-26 00:00:00	1985-05-03	1985-05-03 00:00:00	32020		\N	134167	0	10509002	260139		0
34126	2027	260139	1961-08-15	1961-08-15 00:00:00	1961-08-22	1961-08-22 00:00:00	32020		\N	134876	0	10509002	260139		0
34497	2046	4112343	1945-08-14	1945-08-14 00:00:00	1945-08-27	1945-08-27 00:00:00	32020		\N	136146	0	195662009	4112343		0
34558	2051	28060	1993-06-13	1993-06-13 00:00:00	1993-06-26	1993-06-26 00:00:00	32020		\N	136350	0	43878008	28060		0
45333	2697	28060	1978-03-07	1978-03-07 00:00:00	1978-03-16	1978-03-16 00:00:00	32020		\N	178596	0	43878008	28060		0
34997	2077	260139	1952-02-26	1952-02-26 00:00:00	1952-03-11	1952-03-11 00:00:00	32020		\N	138267	0	10509002	260139		0
35057	2080	81151	2000-11-11	2000-11-11 00:00:00	2000-12-09	2000-12-09 00:00:00	32020		\N	138523	0	44465007	81151		0
35238	2088	4237458	1969-03-02	1969-03-02 00:00:00	1969-05-01	1969-05-01 00:00:00	32020		\N	139180	0	58150001	4237458		0
35505	2103	372328	1972-07-12	1972-07-12 00:00:00	1972-08-19	1972-08-19 00:00:00	32020		\N	140139	0	65363002	372328		0
35604	2109	40481087	1979-07-21	1979-07-21 00:00:00	1979-08-04	1979-08-04 00:00:00	32020		\N	140446	0	444814009	40481087		0
35762	2119	378001	2012-11-14	2012-11-14 00:00:00	2012-12-14	2012-12-14 00:00:00	32020		\N	140976	0	62106007	378001		0
35880	2127	80180	1997-01-07	1997-01-07 00:00:00	\N	\N	32020		\N	141490	0	396275006	80180		0
36128	2140	40481087	1972-01-03	1972-01-03 00:00:00	1972-01-10	1972-01-10 00:00:00	32020		\N	142549	0	444814009	40481087		0
36283	2150	4285898	1985-10-28	1985-10-28 00:00:00	\N	\N	32020		\N	143238	0	68496003	4285898		0
36454	2156	4112343	2005-10-28	2005-10-28 00:00:00	2005-11-04	2005-11-04 00:00:00	32020		\N	143721	0	195662009	4112343		0
36611	2166	260139	2001-06-13	2001-06-13 00:00:00	2001-06-27	2001-06-27 00:00:00	32020		\N	144291	0	10509002	260139		0
36766	2175	4112343	2016-02-23	2016-02-23 00:00:00	2016-03-02	2016-03-02 00:00:00	32020		\N	145022	0	195662009	4112343		0
36944	2186	4152936	2003-09-09	2003-09-09 00:00:00	2003-09-30	2003-09-30 00:00:00	32020		\N	145830	0	283385000	4152936		0
26560	1574	4283893	1972-06-18	1972-06-18 00:00:00	1972-12-17	1972-12-17 00:00:00	32020		\N	105661	0	36971009	4283893		0
37264	2206	260139	2017-09-09	2017-09-09 00:00:00	2017-09-23	2017-09-23 00:00:00	32020		\N	146992	0	10509002	260139		0
37453	2220	260139	1973-10-06	1973-10-06 00:00:00	1973-10-13	1973-10-13 00:00:00	32020		\N	147853	0	10509002	260139		0
37555	2228	40481087	2001-08-10	2001-08-10 00:00:00	2001-08-24	2001-08-24 00:00:00	32020		\N	148249	0	444814009	40481087		0
37696	2235	4285898	1983-03-22	1983-03-22 00:00:00	\N	\N	32020		\N	148671	0	68496003	4285898		0
37945	2250	372328	1960-10-12	1960-10-12 00:00:00	1961-05-31	1961-05-31 00:00:00	32020		\N	149629	0	65363002	372328		0
38163	2266	192671	2008-07-01	2008-07-01 00:00:00	\N	\N	32020		\N	150658	0	K92.2	35208414		0
38274	2273	80180	2016-05-03	2016-05-03 00:00:00	\N	\N	32020		\N	151130	0	396275006	80180		0
48979	2898	28060	1991-09-27	1991-09-27 00:00:00	1991-10-05	1991-10-05 00:00:00	32020		\N	193067	0	43878008	28060		0
38655	2294	372328	1964-09-05	1964-09-05 00:00:00	1964-10-30	1964-10-30 00:00:00	32020		\N	152708	0	65363002	372328		0
38757	2300	40481087	1969-02-20	1969-02-20 00:00:00	1969-03-13	1969-03-13 00:00:00	32020		\N	153182	0	444814009	40481087		0
38945	2314	4149245	1961-01-15	1961-01-15 00:00:00	1961-02-21	1961-02-21 00:00:00	32020		\N	153863	0	30832001	4149245		0
39157	2326	260139	2008-06-03	2008-06-03 00:00:00	2008-06-17	2008-06-17 00:00:00	32020		\N	154648	0	10509002	260139		0
39202	2327	4109685	1996-04-27	1996-04-27 00:00:00	1996-05-11	1996-05-11 00:00:00	32020		\N	154729	0	284551006	4109685		0
39462	2339	4059173	1984-12-17	1984-12-17 00:00:00	1985-01-16	1985-01-16 00:00:00	32020		\N	155678	0	16114001	4059173		0
39535	2342	40481087	2010-03-19	2010-03-19 00:00:00	2010-04-09	2010-04-09 00:00:00	32020		\N	155896	0	444814009	40481087		0
39777	2356	40481087	1987-08-18	1987-08-18 00:00:00	1987-08-25	1987-08-25 00:00:00	32020		\N	156901	0	444814009	40481087		0
39940	2366	4112343	1967-06-09	1967-06-09 00:00:00	1967-06-20	1967-06-20 00:00:00	32020		\N	157526	0	195662009	4112343		0
40033	2373	4112343	1965-11-26	1965-11-26 00:00:00	1965-12-09	1965-12-09 00:00:00	32020		\N	157884	0	195662009	4112343		0
40245	2387	40481087	1994-09-08	1994-09-08 00:00:00	1994-09-29	1994-09-29 00:00:00	32020		\N	158762	0	444814009	40481087		0
40355	2395	372328	1964-06-07	1964-06-07 00:00:00	1965-01-29	1965-01-29 00:00:00	32020		\N	159224	0	65363002	372328		0
40599	2414	4116491	1984-05-07	1984-05-07 00:00:00	1984-06-19	1984-06-19 00:00:00	32020		\N	160276	0	301011002	4116491		0
40774	2424	260139	1991-10-31	1991-10-31 00:00:00	1991-11-07	1991-11-07 00:00:00	32020		\N	160820	0	10509002	260139		0
40936	2435	4112343	2001-01-26	2001-01-26 00:00:00	2001-02-02	2001-02-02 00:00:00	32020		\N	161389	0	195662009	4112343		0
51650	3064	4112343	2015-11-27	2015-11-27 00:00:00	2015-12-09	2015-12-09 00:00:00	32020		\N	203981	0	195662009	4112343		0
41293	2456	260139	1971-12-03	1971-12-03 00:00:00	1971-12-10	1971-12-10 00:00:00	32020		\N	162769	0	10509002	260139		0
41420	2463	260139	2001-02-19	2001-02-19 00:00:00	2001-03-05	2001-03-05 00:00:00	32020		\N	163345	0	10509002	260139		0
41562	2470	260139	2014-01-20	2014-01-20 00:00:00	2014-01-27	2014-01-27 00:00:00	32020		\N	163780	0	10509002	260139		0
41724	2482	4112343	1984-02-24	1984-02-24 00:00:00	1984-03-03	1984-03-03 00:00:00	32020		\N	164424	0	195662009	4112343		0
41972	2498	40481087	2018-10-18	2018-10-18 00:00:00	2018-11-01	2018-11-01 00:00:00	32020		\N	165407	0	444814009	40481087		0
42131	2509	372328	1974-07-12	1974-07-12 00:00:00	1975-01-12	1975-01-12 00:00:00	32020		\N	166070	0	65363002	372328		0
52796	3125	4152936	1975-09-30	1975-09-30 00:00:00	1975-10-21	1975-10-21 00:00:00	32020		\N	208006	0	283385000	4152936		0
42479	2530	40481087	2017-05-20	2017-05-20 00:00:00	2017-05-27	2017-05-27 00:00:00	32020		\N	167255	0	444814009	40481087		0
32005	1902	4112343	2019-03-07	2019-03-07 00:00:00	2019-03-17	2019-03-17 00:00:00	32020		\N	126594	0	195662009	4112343		0
42670	2543	4112343	2011-06-02	2011-06-02 00:00:00	2011-06-13	2011-06-13 00:00:00	32020		\N	168233	0	195662009	4112343		0
32327	1921	4116491	1992-11-20	1992-11-20 00:00:00	1993-01-07	1993-01-07 00:00:00	32020		\N	127764	0	301011002	4116491		0
32492	1928	4112343	2011-06-03	2011-06-03 00:00:00	2011-06-16	2011-06-16 00:00:00	32020		\N	128340	0	195662009	4112343		0
32550	1933	4112343	1999-10-20	1999-10-20 00:00:00	1999-11-02	1999-11-02 00:00:00	32020		\N	128564	0	195662009	4112343		0
32855	1950	40481087	1964-04-14	1964-04-14 00:00:00	1964-04-28	1964-04-28 00:00:00	32020		\N	129630	0	444814009	40481087		0
32915	1952	198199	2006-07-20	2006-07-20 00:00:00	2006-09-10	2006-09-10 00:00:00	32020		\N	129780	0	45816000	198199		0
33117	1965	372328	1980-07-13	1980-07-13 00:00:00	1981-01-25	1981-01-25 00:00:00	32020		\N	130619	0	65363002	372328		0
33270	1975	378001	1971-11-05	1971-11-05 00:00:00	1972-01-04	1972-01-04 00:00:00	32020		\N	131311	0	62106007	378001		0
33492	1986	260139	2005-11-05	2005-11-05 00:00:00	2005-11-12	2005-11-12 00:00:00	32020		\N	132249	0	10509002	260139		0
33579	1991	260139	1971-07-01	1971-07-01 00:00:00	1971-07-08	1971-07-08 00:00:00	32020		\N	132632	0	10509002	260139		0
33750	2004	372328	1972-02-26	1972-02-26 00:00:00	1972-05-09	1972-05-09 00:00:00	32020		\N	133454	0	65363002	372328		0
33972	2017	40481087	1982-10-15	1982-10-15 00:00:00	1982-11-05	1982-11-05 00:00:00	32020		\N	134153	0	444814009	40481087		0
34127	2027	4112343	1977-03-18	1977-03-18 00:00:00	1977-03-30	1977-03-30 00:00:00	32020		\N	134936	0	195662009	4112343		0
34287	2034	4310024	1961-10-05	1961-10-05 00:00:00	\N	\N	32020		\N	135457	0	424802006	4310024		0
34498	2046	28060	2011-12-08	2011-12-08 00:00:00	2011-12-21	2011-12-21 00:00:00	32020		\N	136148	0	43878008	28060		0
34559	2051	4156265	1963-11-13	1963-11-13 00:00:00	1963-12-04	1963-12-04 00:00:00	32020		\N	136353	0	370247008	4156265		0
45334	2697	40481087	1955-02-21	1955-02-21 00:00:00	1955-03-07	1955-03-07 00:00:00	32020		\N	178610	0	444814009	40481087		0
34998	2077	40481087	1952-06-21	1952-06-21 00:00:00	1952-07-12	1952-07-12 00:00:00	32020		\N	138239	0	444814009	40481087		0
35058	2080	40481087	2006-11-08	2006-11-08 00:00:00	2006-11-29	2006-11-29 00:00:00	32020		\N	138518	0	444814009	40481087		0
35239	2088	4113008	1921-09-14	1921-09-14 00:00:00	1921-09-28	1921-09-28 00:00:00	32020		\N	139177	0	284549007	4113008		0
35506	2103	4283893	2012-05-18	2012-05-18 00:00:00	2012-08-17	2012-08-17 00:00:00	32020		\N	140126	0	36971009	4283893		0
35763	2119	81151	1994-03-10	1994-03-10 00:00:00	1994-03-24	1994-03-24 00:00:00	32020		\N	140975	0	44465007	81151		0
35881	2127	195588	1978-08-30	1978-08-30 00:00:00	1978-10-06	1978-10-06 00:00:00	32020		\N	141489	0	38822007	195588		0
36129	2140	440086	1962-06-03	1962-06-03 00:00:00	1963-10-13	1963-10-13 00:00:00	32020		\N	142483	0	192127007	440086		0
36284	2150	4109685	1965-12-18	1965-12-18 00:00:00	1966-01-08	1966-01-08 00:00:00	32020		\N	143150	0	284551006	4109685		0
36455	2156	40481087	1988-12-31	1988-12-31 00:00:00	1989-01-07	1989-01-07 00:00:00	32020		\N	143745	0	444814009	40481087		0
36612	2166	260139	1990-04-10	1990-04-10 00:00:00	1990-04-24	1990-04-24 00:00:00	32020		\N	144315	0	10509002	260139		0
36767	2175	260139	1992-02-06	1992-02-06 00:00:00	1992-02-13	1992-02-13 00:00:00	32020		\N	145045	0	10509002	260139		0
36945	2186	40481087	1975-10-01	1975-10-01 00:00:00	1975-10-15	1975-10-15 00:00:00	32020		\N	145730	0	444814009	40481087		0
37019	2191	28060	1985-02-07	1985-02-07 00:00:00	1985-02-18	1985-02-18 00:00:00	32020		\N	146118	0	43878008	28060		0
37265	2206	81151	1990-11-23	1990-11-23 00:00:00	1990-12-14	1990-12-14 00:00:00	32020		\N	147011	0	44465007	81151		0
37454	2220	40481087	1965-02-01	1965-02-01 00:00:00	1965-02-22	1965-02-22 00:00:00	32020		\N	147795	0	444814009	40481087		0
37556	2228	40481087	2011-09-08	2011-09-08 00:00:00	2011-09-22	2011-09-22 00:00:00	32020		\N	148276	0	444814009	40481087		0
37697	2235	4266809	1983-05-21	1983-05-21 00:00:00	\N	\N	32020		\N	148671	0	397881000	4266809		0
37946	2250	260139	1993-12-27	1993-12-27 00:00:00	1994-01-03	1994-01-03 00:00:00	32020		\N	149682	0	10509002	260139		0
38164	2266	40481087	2002-08-16	2002-08-16 00:00:00	2002-08-30	2002-08-30 00:00:00	32020		\N	150659	0	444814009	40481087		0
38275	2273	4285898	2016-04-03	2016-04-03 00:00:00	\N	\N	32020		\N	151130	0	68496003	4285898		0
48980	2898	4112343	2013-08-22	2013-08-22 00:00:00	2013-08-31	2013-08-31 00:00:00	32020		\N	193081	0	195662009	4112343		0
38656	2294	4113008	2018-11-10	2018-11-10 00:00:00	2018-12-01	2018-12-01 00:00:00	32020		\N	152752	0	284549007	4113008		0
38758	2300	40481087	2001-01-24	2001-01-24 00:00:00	2001-01-31	2001-01-31 00:00:00	32020		\N	153186	0	444814009	40481087		0
38946	2314	40481087	1986-05-25	1986-05-25 00:00:00	1986-06-01	1986-06-01 00:00:00	32020		\N	153875	0	444814009	40481087		0
39158	2326	260139	1986-01-14	1986-01-14 00:00:00	1986-01-28	1986-01-28 00:00:00	32020		\N	154636	0	10509002	260139		0
39203	2327	4109685	2001-05-15	2001-05-15 00:00:00	2001-06-05	2001-06-05 00:00:00	32020		\N	154730	0	284551006	4109685		0
39463	2339	40486433	1977-08-28	1977-08-28 00:00:00	1993-07-13	1993-07-13 00:00:00	32020		\N	155588	0	446096008	40486433		0
39536	2342	40481087	2003-08-25	2003-08-25 00:00:00	2003-09-15	2003-09-15 00:00:00	32020		\N	155911	0	444814009	40481087		0
39778	2356	4218389	2017-05-25	2017-05-25 00:00:00	2017-06-15	2017-06-15 00:00:00	32020		\N	156928	0	39848009	4218389		0
39941	2366	40481087	1989-04-02	1989-04-02 00:00:00	1989-04-16	1989-04-16 00:00:00	32020		\N	157530	0	444814009	40481087		0
40034	2373	40481087	2011-11-24	2011-11-24 00:00:00	2011-12-15	2011-12-15 00:00:00	32020		\N	157942	0	444814009	40481087		0
40246	2387	375671	2003-09-06	2003-09-06 00:00:00	2003-10-06	2003-10-06 00:00:00	32020		\N	158760	0	62564004	375671		0
40356	2395	260139	1990-06-01	1990-06-01 00:00:00	1990-06-15	1990-06-15 00:00:00	32020		\N	159221	0	10509002	260139		0
40600	2414	260139	1944-10-31	1944-10-31 00:00:00	1944-11-07	1944-11-07 00:00:00	32020		\N	160215	0	10509002	260139		0
40775	2425	81151	1962-01-08	1962-01-08 00:00:00	1962-01-29	1962-01-29 00:00:00	32020		\N	160870	0	44465007	81151		0
40937	2435	4112343	1978-02-13	1978-02-13 00:00:00	1978-02-20	1978-02-20 00:00:00	32020		\N	161433	0	195662009	4112343		0
51651	3064	40481087	1985-08-01	1985-08-01 00:00:00	1985-08-22	1985-08-22 00:00:00	32020		\N	203979	0	444814009	40481087		0
41294	2456	260139	1998-10-10	1998-10-10 00:00:00	1998-10-17	1998-10-17 00:00:00	32020		\N	162771	0	10509002	260139		0
41421	2463	378001	1994-08-16	1994-08-16 00:00:00	1994-10-15	1994-10-15 00:00:00	32020		\N	163399	0	62106007	378001		0
41563	2470	4112343	1983-03-19	1983-03-19 00:00:00	1983-03-30	1983-03-30 00:00:00	32020		\N	163817	0	195662009	4112343		0
41725	2482	40481087	1981-07-27	1981-07-27 00:00:00	1981-08-17	1981-08-17 00:00:00	32020		\N	164460	0	444814009	40481087		0
41998	2501	4112343	1991-10-18	1991-10-18 00:00:00	1991-10-26	1991-10-26 00:00:00	32020		\N	165529	0	195662009	4112343		0
42132	2509	40481087	2018-05-17	2018-05-17 00:00:00	2018-05-31	2018-05-31 00:00:00	32020		\N	166100	0	444814009	40481087		0
52809	3128	133834	1973-07-31	1973-07-31 00:00:00	1990-11-29	1990-11-29 00:00:00	32020		\N	208194	0	24079001	133834		0
42480	2530	4112343	1996-09-21	1996-09-21 00:00:00	1996-10-04	1996-10-04 00:00:00	32020		\N	167247	0	195662009	4112343		0
32006	1902	40481087	2012-03-15	2012-03-15 00:00:00	2012-03-22	2012-03-22 00:00:00	32020		\N	126593	0	444814009	40481087		0
42671	2543	28060	1979-09-04	1979-09-04 00:00:00	1979-09-14	1979-09-14 00:00:00	32020		\N	168281	0	43878008	28060		0
32328	1921	260139	1987-03-06	1987-03-06 00:00:00	1987-03-20	1987-03-20 00:00:00	32020		\N	127721	0	10509002	260139		0
32493	1928	4142905	1983-11-29	1983-11-29 00:00:00	1984-02-27	1984-02-27 00:00:00	32020		\N	128377	0	33737001	4142905		0
32551	1933	4112343	2016-11-05	2016-11-05 00:00:00	2016-11-16	2016-11-16 00:00:00	32020		\N	128550	0	195662009	4112343		0
32856	1950	40481087	2013-01-27	2013-01-27 00:00:00	2013-02-17	2013-02-17 00:00:00	32020		\N	129631	0	444814009	40481087		0
32916	1952	260139	1965-09-04	1965-09-04 00:00:00	1965-09-11	1965-09-11 00:00:00	32020		\N	129814	0	10509002	260139		0
33118	1965	28060	1974-05-26	1974-05-26 00:00:00	1974-06-02	1974-06-02 00:00:00	32020		\N	130651	0	43878008	28060		0
33271	1975	28060	1961-09-21	1961-09-21 00:00:00	1961-09-30	1961-09-30 00:00:00	32020		\N	131298	0	43878008	28060		0
33493	1986	4112343	2014-09-12	2014-09-12 00:00:00	2014-09-22	2014-09-22 00:00:00	32020		\N	132255	0	195662009	4112343		0
33580	1991	317576	1993-10-11	1993-10-11 00:00:00	\N	\N	32020		\N	132581	0	53741008	317576		0
33751	2004	40481087	2014-12-02	2014-12-02 00:00:00	2014-12-16	2014-12-16 00:00:00	32020		\N	133453	0	444814009	40481087		0
33973	2017	40481087	1976-03-21	1976-03-21 00:00:00	1976-04-11	1976-04-11 00:00:00	32020		\N	134190	0	444814009	40481087		0
34128	2027	372328	1962-03-12	1962-03-12 00:00:00	1962-05-25	1962-05-25 00:00:00	32020		\N	134922	0	65363002	372328		0
34288	2034	40481087	1969-10-20	1969-10-20 00:00:00	1969-11-10	1969-11-10 00:00:00	32020		\N	135493	0	444814009	40481087		0
34499	2046	260139	1961-04-01	1961-04-01 00:00:00	1961-04-08	1961-04-08 00:00:00	32020		\N	136087	0	10509002	260139		0
34560	2051	28060	1976-10-18	1976-10-18 00:00:00	1976-10-26	1976-10-26 00:00:00	32020		\N	136345	0	43878008	28060		0
45335	2697	4112343	1947-07-09	1947-07-09 00:00:00	1947-07-20	1947-07-20 00:00:00	32020		\N	178571	0	195662009	4112343		0
34999	2077	40481087	1993-11-10	1993-11-10 00:00:00	1993-11-24	1993-11-24 00:00:00	32020		\N	138255	0	444814009	40481087		0
35059	2080	40481087	2001-05-24	2001-05-24 00:00:00	2001-05-31	2001-05-31 00:00:00	32020		\N	138549	0	444814009	40481087		0
35240	2088	372328	1912-11-14	1912-11-14 00:00:00	1913-07-01	1913-07-01 00:00:00	32020		\N	139205	0	65363002	372328		0
35507	2103	257012	2012-07-06	2012-07-06 00:00:00	\N	\N	32020		\N	140137	0	40055000	257012		0
35606	2109	4112343	2017-02-28	2017-02-28 00:00:00	2017-03-12	2017-03-12 00:00:00	32020		\N	140447	0	195662009	4112343		0
35764	2119	4112343	1962-11-20	1962-11-20 00:00:00	1962-12-03	1962-12-03 00:00:00	32020		\N	140962	0	195662009	4112343		0
35882	2127	4112343	2005-09-10	2005-09-10 00:00:00	2005-09-18	2005-09-18 00:00:00	32020		\N	141463	0	195662009	4112343		0
36130	2140	4112343	1966-10-29	1966-10-29 00:00:00	1966-11-09	1966-11-09 00:00:00	32020		\N	142548	0	195662009	4112343		0
36285	2150	40481087	1976-08-10	1976-08-10 00:00:00	1976-08-24	1976-08-24 00:00:00	32020		\N	143158	0	444814009	40481087		0
36456	2156	260139	1978-10-10	1978-10-10 00:00:00	1978-10-17	1978-10-17 00:00:00	32020		\N	143696	0	10509002	260139		0
36613	2166	40481087	1975-09-06	1975-09-06 00:00:00	1975-09-20	1975-09-20 00:00:00	32020		\N	144303	0	444814009	40481087		0
32596	1935	192671	2009-04-10	2009-04-10 00:00:00	\N	\N	32020		\N	128724	0	K92.2	35208414		0
36768	2175	378001	2012-06-09	2012-06-09 00:00:00	2012-07-09	2012-07-09 00:00:00	32020		\N	145069	0	62106007	378001		0
36946	2186	40481087	2002-06-03	2002-06-03 00:00:00	2002-06-24	2002-06-24 00:00:00	32020		\N	145811	0	444814009	40481087		0
37020	2191	40481087	1982-03-31	1982-03-31 00:00:00	1982-04-14	1982-04-14 00:00:00	32020		\N	146095	0	444814009	40481087		0
37266	2207	80180	2013-05-06	2013-05-06 00:00:00	\N	\N	32020		\N	147077	0	396275006	80180		0
37455	2220	40481087	1976-03-20	1976-03-20 00:00:00	1976-04-03	1976-04-03 00:00:00	32020		\N	147796	0	444814009	40481087		0
37557	2228	4296205	1952-12-17	1952-12-17 00:00:00	1953-01-07	1953-01-07 00:00:00	32020		\N	148291	0	403191005	4296205		0
37698	2235	260139	2012-03-24	2012-03-24 00:00:00	2012-03-31	2012-03-31 00:00:00	32020		\N	148693	0	10509002	260139		0
37947	2250	40481087	1997-02-22	1997-02-22 00:00:00	1997-03-08	1997-03-08 00:00:00	32020		\N	149684	0	444814009	40481087		0
38165	2266	372328	1984-03-18	1984-03-18 00:00:00	1985-01-26	1985-01-26 00:00:00	32020		\N	150623	0	65363002	372328		0
38276	2273	4266809	2016-05-03	2016-05-03 00:00:00	\N	\N	32020		\N	151130	0	397881000	4266809		0
48981	2898	192671	2016-09-03	2016-09-03 00:00:00	\N	\N	32020		\N	193101	0	K92.2	35208414		0
38657	2294	40481087	2006-02-04	2006-02-04 00:00:00	2006-02-18	2006-02-18 00:00:00	32020		\N	152718	0	444814009	40481087		0
38759	2300	4296204	1993-02-28	1993-02-28 00:00:00	1993-03-28	1993-03-28 00:00:00	32020		\N	153129	0	403190006	4296204		0
38947	2314	4109685	1972-04-08	1972-04-08 00:00:00	1972-04-22	1972-04-22 00:00:00	32020		\N	153865	0	284551006	4109685		0
39159	2326	40481087	1965-03-19	1965-03-19 00:00:00	1965-03-26	1965-03-26 00:00:00	32020		\N	154635	0	444814009	40481087		0
39204	2327	40481087	1995-02-03	1995-02-03 00:00:00	1995-02-10	1995-02-10 00:00:00	32020		\N	154749	0	444814009	40481087		0
39464	2339	4112343	2006-10-06	2006-10-06 00:00:00	2006-10-14	2006-10-14 00:00:00	32020		\N	155651	0	195662009	4112343		0
39537	2342	260139	1980-06-29	1980-06-29 00:00:00	1980-07-13	1980-07-13 00:00:00	32020		\N	155923	0	10509002	260139		0
39779	2356	4218389	1998-12-26	1998-12-26 00:00:00	1999-01-30	1999-01-30 00:00:00	32020		\N	156927	0	39848009	4218389		0
39942	2366	260139	2008-06-06	2008-06-06 00:00:00	2008-06-20	2008-06-20 00:00:00	32020		\N	157522	0	10509002	260139		0
40035	2373	4294548	1992-10-08	1992-10-08 00:00:00	1992-12-03	1992-12-03 00:00:00	32020		\N	157939	0	75498004	4294548		0
40247	2387	260139	2012-08-30	2012-08-30 00:00:00	2012-09-13	2012-09-13 00:00:00	32020		\N	158781	0	10509002	260139		0
40357	2395	4027663	1987-02-06	1987-02-06 00:00:00	\N	\N	32020		\N	159285	0	13200003	4027663		0
40601	2414	40481087	1984-11-22	1984-11-22 00:00:00	1984-12-13	1984-12-13 00:00:00	32020		\N	160277	0	444814009	40481087		0
40776	2425	260139	2008-09-20	2008-09-20 00:00:00	2008-10-04	2008-10-04 00:00:00	32020		\N	160945	0	10509002	260139		0
40938	2435	4294548	2014-12-12	2014-12-12 00:00:00	2014-12-26	2014-12-26 00:00:00	32020		\N	161419	0	75498004	4294548		0
51652	3064	4112343	2006-06-06	2006-06-06 00:00:00	2006-06-15	2006-06-15 00:00:00	32020		\N	203980	0	195662009	4112343		0
41295	2456	40481087	1984-01-19	1984-01-19 00:00:00	1984-02-02	1984-02-02 00:00:00	32020		\N	162819	0	444814009	40481087		0
41422	2463	40481087	1995-02-20	1995-02-20 00:00:00	1995-03-06	1995-03-06 00:00:00	32020		\N	163344	0	444814009	40481087		0
41564	2470	4112343	1971-10-12	1971-10-12 00:00:00	1971-10-21	1971-10-21 00:00:00	32020		\N	163762	0	195662009	4112343		0
41726	2482	4134304	2002-03-26	2002-03-26 00:00:00	2002-06-24	2002-06-24 00:00:00	32020		\N	164479	0	263102004	4134304		0
52469	3109	260139	1964-06-29	1964-06-29 00:00:00	1964-07-06	1964-07-06 00:00:00	32020		\N	206757	0	10509002	260139		0
42133	2509	28060	1984-03-03	1984-03-03 00:00:00	1984-03-14	1984-03-14 00:00:00	32020		\N	166096	0	43878008	28060		0
52810	3128	4152936	1982-09-05	1982-09-05 00:00:00	1982-09-19	1982-09-19 00:00:00	32020		\N	208163	0	283385000	4152936		0
42481	2530	260139	2001-08-05	2001-08-05 00:00:00	2001-08-12	2001-08-12 00:00:00	32020		\N	167217	0	10509002	260139		0
32007	1902	4112343	1952-02-17	1952-02-17 00:00:00	1952-02-28	1952-02-28 00:00:00	32020		\N	126588	0	195662009	4112343		0
42672	2543	40481087	1968-07-08	1968-07-08 00:00:00	1968-07-15	1968-07-15 00:00:00	32020		\N	168248	0	444814009	40481087		0
32329	1921	40481087	1975-01-30	1975-01-30 00:00:00	1975-02-20	1975-02-20 00:00:00	32020		\N	127737	0	444814009	40481087		0
32494	1928	4283893	1984-06-03	1984-06-03 00:00:00	1984-07-08	1984-07-08 00:00:00	32020		\N	128351	0	36971009	4283893		0
32552	1933	4112343	1968-06-25	1968-06-25 00:00:00	1968-07-02	1968-07-02 00:00:00	32020		\N	128545	0	195662009	4112343		0
32857	1950	378001	1955-06-26	1955-06-26 00:00:00	1955-08-25	1955-08-25 00:00:00	32020		\N	129713	0	62106007	378001		0
32917	1952	378001	2017-09-22	2017-09-22 00:00:00	2017-11-21	2017-11-21 00:00:00	32020		\N	129791	0	62106007	378001		0
33119	1965	81151	1986-04-20	1986-04-20 00:00:00	1986-05-11	1986-05-11 00:00:00	32020		\N	130668	0	44465007	81151		0
33272	1975	372328	1927-04-16	1927-04-16 00:00:00	1928-01-28	1928-01-28 00:00:00	32020		\N	131302	0	65363002	372328		0
33494	1986	378001	1981-09-10	1981-09-10 00:00:00	1981-11-09	1981-11-09 00:00:00	32020		\N	132213	0	62106007	378001		0
33581	1991	4112343	1992-08-26	1992-08-26 00:00:00	1992-09-03	1992-09-03 00:00:00	32020		\N	132612	0	195662009	4112343		0
33752	2004	40481087	1976-12-29	1976-12-29 00:00:00	1977-01-05	1977-01-05 00:00:00	32020		\N	133436	0	444814009	40481087		0
33981	2020	40481087	1997-04-10	1997-04-10 00:00:00	1997-05-01	1997-05-01 00:00:00	32020		\N	134245	0	444814009	40481087		0
34129	2027	4296205	1968-02-09	1968-02-09 00:00:00	1968-03-15	1968-03-15 00:00:00	32020		\N	134932	0	403191005	4296205		0
34289	2034	40481087	2015-01-29	2015-01-29 00:00:00	2015-02-05	2015-02-05 00:00:00	32020		\N	135417	0	444814009	40481087		0
34500	2046	4146173	1969-12-23	1969-12-23 00:00:00	1970-01-29	1970-01-29 00:00:00	32020		\N	136088	0	307731004	4146173		0
34561	2051	257012	2009-02-20	2009-02-20 00:00:00	\N	\N	32020		\N	136348	0	40055000	257012		0
45336	2697	40481087	1969-02-09	1969-02-09 00:00:00	1969-02-16	1969-02-16 00:00:00	32020		\N	178595	0	444814009	40481087		0
35000	2077	40481087	1944-08-18	1944-08-18 00:00:00	1944-08-25	1944-08-25 00:00:00	32020		\N	138331	0	444814009	40481087		0
35060	2080	4283893	2000-07-05	2000-07-05 00:00:00	2000-09-20	2000-09-20 00:00:00	32020		\N	138539	0	36971009	4283893		0
35241	2088	40481087	1972-06-12	1972-06-12 00:00:00	1972-06-19	1972-06-19 00:00:00	32020		\N	139199	0	444814009	40481087		0
35508	2103	4112343	2017-03-10	2017-03-10 00:00:00	2017-03-19	2017-03-19 00:00:00	32020		\N	140153	0	195662009	4112343		0
35607	2109	40481087	1996-09-12	1996-09-12 00:00:00	1996-10-03	1996-10-03 00:00:00	32020		\N	140432	0	444814009	40481087		0
35765	2119	134438	1983-06-14	1983-06-14 00:00:00	1984-04-13	1984-04-13 00:00:00	32020		\N	140999	0	40275004	134438		0
35883	2127	78272	1995-06-23	1995-06-23 00:00:00	1995-07-07	1995-07-07 00:00:00	32020		\N	141449	0	70704007	78272		0
36131	2140	4112343	1955-08-18	1955-08-18 00:00:00	1955-08-26	1955-08-26 00:00:00	32020		\N	142557	0	195662009	4112343		0
36286	2150	4027663	1978-01-13	1978-01-13 00:00:00	\N	\N	32020		\N	\N	0	13200003	4027663		0
36457	2156	40481087	1992-09-27	1992-09-27 00:00:00	1992-10-04	1992-10-04 00:00:00	32020		\N	143746	0	444814009	40481087		0
36614	2166	28060	1976-12-16	1976-12-16 00:00:00	1976-12-28	1976-12-28 00:00:00	32020		\N	144289	0	43878008	28060		0
36769	2175	40481087	2004-06-09	2004-06-09 00:00:00	2004-06-23	2004-06-23 00:00:00	32020		\N	144996	0	444814009	40481087		0
36947	2186	4027663	2006-01-31	2006-01-31 00:00:00	\N	\N	32020		\N	145786	0	13200003	4027663		0
37021	2191	4112343	1979-01-16	1979-01-16 00:00:00	1979-01-23	1979-01-23 00:00:00	32020		\N	146129	0	195662009	4112343		0
37267	2207	40481087	1998-11-05	1998-11-05 00:00:00	1998-11-26	1998-11-26 00:00:00	32020		\N	147056	0	444814009	40481087		0
37456	2220	4027663	1976-04-06	1976-04-06 00:00:00	\N	\N	32020		\N	147796	0	13200003	4027663		0
37558	2228	4112343	2000-03-01	2000-03-01 00:00:00	2000-03-12	2000-03-12 00:00:00	32020		\N	148247	0	195662009	4112343		0
37699	2235	260139	2002-09-09	2002-09-09 00:00:00	2002-09-16	2002-09-16 00:00:00	32020		\N	148678	0	10509002	260139		0
37948	2250	260139	1958-07-27	1958-07-27 00:00:00	1958-08-10	1958-08-10 00:00:00	32020		\N	149626	0	10509002	260139		0
38166	2266	4027663	2000-12-06	2000-12-06 00:00:00	\N	\N	32020		\N	150622	0	13200003	4027663		0
38277	2273	40481087	2001-08-08	2001-08-08 00:00:00	2001-08-15	2001-08-15 00:00:00	32020		\N	151116	0	444814009	40481087		0
48982	2898	4112343	2006-04-21	2006-04-21 00:00:00	2006-04-30	2006-04-30 00:00:00	32020		\N	192976	0	195662009	4112343		0
38658	2294	80180	1997-09-02	1997-09-02 00:00:00	\N	\N	32020		\N	152671	0	396275006	80180		0
38760	2300	40481087	1959-02-14	1959-02-14 00:00:00	1959-03-07	1959-03-07 00:00:00	32020		\N	153123	0	444814009	40481087		0
38948	2314	80180	1987-08-17	1987-08-17 00:00:00	\N	\N	32020		\N	153869	0	396275006	80180		0
39160	2326	40481087	1959-06-04	1959-06-04 00:00:00	1959-06-11	1959-06-11 00:00:00	32020		\N	154644	0	444814009	40481087		0
39205	2327	40481087	1992-04-17	1992-04-17 00:00:00	1992-05-01	1992-05-01 00:00:00	32020		\N	154747	0	444814009	40481087		0
39465	2339	40481087	2016-01-18	2016-01-18 00:00:00	2016-02-01	2016-02-01 00:00:00	32020		\N	155610	0	444814009	40481087		0
39538	2342	4116491	2010-01-08	2010-01-08 00:00:00	2010-02-15	2010-02-15 00:00:00	32020		\N	155902	0	301011002	4116491		0
39780	2356	40481087	2009-05-21	2009-05-21 00:00:00	2009-06-11	2009-06-11 00:00:00	32020		\N	156870	0	444814009	40481087		0
39943	2366	372328	1970-07-02	1970-07-02 00:00:00	1970-08-24	1970-08-24 00:00:00	32020		\N	157524	0	65363002	372328		0
40036	2373	4112343	1967-06-05	1967-06-05 00:00:00	1967-06-12	1967-06-12 00:00:00	32020		\N	157885	0	195662009	4112343		0
40248	2387	40481087	2006-09-03	2006-09-03 00:00:00	2006-09-10	2006-09-10 00:00:00	32020		\N	158779	0	444814009	40481087		0
40358	2395	40481087	1987-06-20	1987-06-20 00:00:00	1987-06-27	1987-06-27 00:00:00	32020		\N	159273	0	444814009	40481087		0
40602	2414	260139	1950-06-10	1950-06-10 00:00:00	1950-06-24	1950-06-24 00:00:00	32020		\N	160195	0	10509002	260139		0
40777	2425	4266809	1994-07-29	1994-07-29 00:00:00	\N	\N	32020		\N	160899	0	397881000	4266809		0
40939	2435	4266809	2015-11-20	2015-11-20 00:00:00	\N	\N	32020		\N	161419	0	397881000	4266809		0
51653	3064	81151	1997-01-30	1997-01-30 00:00:00	1997-03-06	1997-03-06 00:00:00	32020		\N	203945	0	44465007	81151		0
41296	2456	260139	1972-11-06	1972-11-06 00:00:00	1972-11-20	1972-11-20 00:00:00	32020		\N	162753	0	10509002	260139		0
41423	2463	4112343	2011-06-05	2011-06-05 00:00:00	2011-06-18	2011-06-18 00:00:00	32020		\N	163365	0	195662009	4112343		0
41565	2470	192671	1992-12-29	1992-12-29 00:00:00	\N	\N	32020		\N	163798	0	K92.2	35208414		0
41727	2482	80180	2015-05-20	2015-05-20 00:00:00	\N	\N	32020		\N	164481	0	396275006	80180		0
52470	3109	381316	1990-02-21	1990-02-21 00:00:00	\N	\N	32020		\N	206724	0	230690007	381316		0
42134	2509	260139	1979-04-27	1979-04-27 00:00:00	1979-05-11	1979-05-11 00:00:00	32020		\N	166091	0	10509002	260139		0
52811	3128	375671	1988-08-25	1988-08-25 00:00:00	1988-09-24	1988-09-24 00:00:00	32020		\N	208167	0	62564004	375671		0
52955	3135	80180	2005-10-13	2005-10-13 00:00:00	\N	\N	32020		\N	208719	0	396275006	80180		0
32008	1902	260139	1966-01-03	1966-01-03 00:00:00	1966-01-17	1966-01-17 00:00:00	32020		\N	126637	0	10509002	260139		0
42673	2543	260139	2015-10-23	2015-10-23 00:00:00	2015-10-30	2015-10-30 00:00:00	32020		\N	168254	0	10509002	260139		0
32330	1921	260139	1991-07-06	1991-07-06 00:00:00	1991-07-13	1991-07-13 00:00:00	32020		\N	127738	0	10509002	260139		0
32495	1928	4283893	1979-06-17	1979-06-17 00:00:00	1979-12-02	1979-12-02 00:00:00	32020		\N	128367	0	36971009	4283893		0
32553	1933	4059173	1960-05-19	1960-05-19 00:00:00	1960-08-17	1960-08-17 00:00:00	32020		\N	128561	0	16114001	4059173		0
32858	1950	40481087	1985-08-13	1985-08-13 00:00:00	1985-09-03	1985-09-03 00:00:00	32020		\N	129646	0	444814009	40481087		0
32918	1952	80180	1989-01-10	1989-01-10 00:00:00	\N	\N	32020		\N	129865	0	396275006	80180		0
33120	1965	372328	1976-01-13	1976-01-13 00:00:00	1976-07-04	1976-07-04 00:00:00	32020		\N	130655	0	65363002	372328		0
33273	1975	28060	1952-11-21	1952-11-21 00:00:00	1952-12-04	1952-12-04 00:00:00	32020		\N	131297	0	43878008	28060		0
33495	1987	28060	1947-11-21	1947-11-21 00:00:00	1947-11-29	1947-11-29 00:00:00	32020		\N	132316	0	43878008	28060		0
33582	1991	40481087	1964-12-15	1964-12-15 00:00:00	1965-01-05	1965-01-05 00:00:00	32020		\N	132594	0	444814009	40481087		0
33753	2004	372328	2014-02-28	2014-02-28 00:00:00	2015-06-16	2015-06-16 00:00:00	32020		\N	133455	0	65363002	372328		0
33982	2020	40481087	1994-09-23	1994-09-23 00:00:00	1994-10-14	1994-10-14 00:00:00	32020		\N	134279	0	444814009	40481087		0
34130	2027	4027663	1995-03-09	1995-03-09 00:00:00	\N	\N	32020		\N	134928	0	13200003	4027663		0
34290	2034	4285898	1963-07-27	1963-07-27 00:00:00	\N	\N	32020		\N	135458	0	68496003	4285898		0
34501	2046	40481087	1999-08-25	1999-08-25 00:00:00	1999-09-01	1999-09-01 00:00:00	32020		\N	136089	0	444814009	40481087		0
34562	2051	40481087	1996-05-18	1996-05-18 00:00:00	1996-05-25	1996-05-25 00:00:00	32020		\N	136351	0	444814009	40481087		0
45337	2697	260139	2004-03-20	2004-03-20 00:00:00	2004-04-03	2004-04-03 00:00:00	32020		\N	178566	0	10509002	260139		0
35001	2077	4112343	1961-05-31	1961-05-31 00:00:00	1961-06-09	1961-06-09 00:00:00	32020		\N	138283	0	195662009	4112343		0
35061	2080	4112343	2013-11-27	2013-11-27 00:00:00	2013-12-08	2013-12-08 00:00:00	32020		\N	138578	0	195662009	4112343		0
35242	2088	4109685	1923-10-18	1923-10-18 00:00:00	1923-11-08	1923-11-08 00:00:00	32020		\N	139178	0	284551006	4109685		0
35509	2103	372328	1972-11-17	1972-11-17 00:00:00	1973-01-20	1973-01-20 00:00:00	32020		\N	140165	0	65363002	372328		0
35608	2109	4112343	1974-02-01	1974-02-01 00:00:00	1974-02-11	1974-02-11 00:00:00	32020		\N	140445	0	195662009	4112343		0
35766	2119	80180	2001-05-23	2001-05-23 00:00:00	\N	\N	32020		\N	141094	0	396275006	80180		0
35884	2127	260139	1970-07-23	1970-07-23 00:00:00	1970-08-06	1970-08-06 00:00:00	32020		\N	141452	0	10509002	260139		0
36132	2140	4146173	1987-03-20	1987-03-20 00:00:00	1987-05-19	1987-05-19 00:00:00	32020		\N	142515	0	307731004	4146173		0
36287	2150	4283893	1962-07-15	1962-07-15 00:00:00	1962-08-05	1962-08-05 00:00:00	32020		\N	143175	0	36971009	4283893		0
36484	2160	4156265	2014-05-23	2014-05-23 00:00:00	2014-06-13	2014-06-13 00:00:00	32020		\N	143923	0	370247008	4156265		0
36615	2167	40481087	1984-03-19	1984-03-19 00:00:00	1984-03-26	1984-03-26 00:00:00	32020		\N	144362	0	444814009	40481087		0
36770	2175	372328	1977-09-20	1977-09-20 00:00:00	1978-01-05	1978-01-05 00:00:00	32020		\N	144973	0	65363002	372328		0
36948	2186	260139	1987-02-26	1987-02-26 00:00:00	1987-03-12	1987-03-12 00:00:00	32020		\N	145817	0	10509002	260139		0
37022	2191	40481087	1972-11-09	1972-11-09 00:00:00	1972-11-30	1972-11-30 00:00:00	32020		\N	146128	0	444814009	40481087		0
37268	2207	81893	2012-08-09	2012-08-09 00:00:00	\N	\N	32020		\N	147099	0	64766004	81893		0
37458	2222	40481087	1987-05-04	1987-05-04 00:00:00	1987-05-11	1987-05-11 00:00:00	32020		\N	147908	0	444814009	40481087		0
37559	2228	40481087	2015-11-16	2015-11-16 00:00:00	2015-11-30	2015-11-30 00:00:00	32020		\N	148270	0	444814009	40481087		0
37700	2235	40481087	2002-10-10	2002-10-10 00:00:00	2002-10-17	2002-10-17 00:00:00	32020		\N	148638	0	444814009	40481087		0
37949	2250	40481087	2008-10-24	2008-10-24 00:00:00	2008-11-14	2008-11-14 00:00:00	32020		\N	149666	0	444814009	40481087		0
38167	2266	4112343	2009-05-14	2009-05-14 00:00:00	2009-05-24	2009-05-24 00:00:00	32020		\N	150643	0	195662009	4112343		0
38278	2273	4310024	2015-02-08	2015-02-08 00:00:00	\N	\N	32020		\N	151129	0	424802006	4310024		0
48983	2898	4084167	1980-03-11	1980-03-11 00:00:00	1980-03-12	1980-03-12 00:00:00	32020		\N	192993	0	241929008	4084167		0
38659	2294	4112343	1998-12-22	1998-12-22 00:00:00	1998-12-29	1998-12-29 00:00:00	32020		\N	152681	0	195662009	4112343		0
38761	2300	4218389	2004-09-26	2004-09-26 00:00:00	2004-10-31	2004-10-31 00:00:00	32020		\N	153130	0	39848009	4218389		0
38949	2315	260139	1984-08-23	1984-08-23 00:00:00	1984-08-30	1984-08-30 00:00:00	32020		\N	153963	0	10509002	260139		0
39161	2326	78272	2015-10-15	2015-10-15 00:00:00	2015-11-12	2015-11-12 00:00:00	32020		\N	154724	0	70704007	78272		0
39206	2327	4116491	2012-10-02	2012-10-02 00:00:00	2012-11-11	2012-11-11 00:00:00	32020		\N	154755	0	301011002	4116491		0
39466	2339	4112343	1982-08-01	1982-08-01 00:00:00	1982-08-11	1982-08-11 00:00:00	32020		\N	155612	0	195662009	4112343		0
39539	2342	260139	1985-06-27	1985-06-27 00:00:00	1985-07-11	1985-07-11 00:00:00	32020		\N	155910	0	10509002	260139		0
39781	2356	40481087	2006-09-21	2006-09-21 00:00:00	2006-10-12	2006-10-12 00:00:00	32020		\N	156907	0	444814009	40481087		0
39944	2366	260139	1982-01-18	1982-01-18 00:00:00	1982-01-25	1982-01-25 00:00:00	32020		\N	157529	0	10509002	260139		0
40037	2373	40481087	1976-08-07	1976-08-07 00:00:00	1976-08-14	1976-08-14 00:00:00	32020		\N	157958	0	444814009	40481087		0
40249	2387	378001	1994-04-12	1994-04-12 00:00:00	1994-05-12	1994-05-12 00:00:00	32020		\N	158758	0	62106007	378001		0
40359	2395	40481087	1978-05-28	1978-05-28 00:00:00	1978-06-04	1978-06-04 00:00:00	32020		\N	159244	0	444814009	40481087		0
40603	2414	4112343	1937-09-07	1937-09-07 00:00:00	1937-09-17	1937-09-17 00:00:00	32020		\N	160220	0	195662009	4112343		0
40778	2425	80180	1994-07-29	1994-07-29 00:00:00	\N	\N	32020		\N	160899	0	396275006	80180		0
40940	2435	80180	2015-11-20	2015-11-20 00:00:00	\N	\N	32020		\N	161419	0	396275006	80180		0
51654	3064	80180	1975-05-16	1975-05-16 00:00:00	\N	\N	32020		\N	203933	0	396275006	80180		0
41297	2456	4112343	1992-04-04	1992-04-04 00:00:00	1992-04-15	1992-04-15 00:00:00	32020		\N	162828	0	195662009	4112343		0
41424	2463	28060	2004-05-30	2004-05-30 00:00:00	2004-06-10	2004-06-10 00:00:00	32020		\N	163391	0	43878008	28060		0
41566	2470	260139	2007-02-26	2007-02-26 00:00:00	2007-03-12	2007-03-12 00:00:00	32020		\N	163820	0	10509002	260139		0
41728	2482	4146173	1995-02-24	1995-02-24 00:00:00	1995-05-02	1995-05-02 00:00:00	32020		\N	164426	0	307731004	4146173		0
52471	3109	81151	1971-02-09	1971-02-09 00:00:00	1971-03-02	1971-03-02 00:00:00	32020		\N	206707	0	44465007	81151		0
42135	2509	4116491	2006-05-30	2006-05-30 00:00:00	2006-07-15	2006-07-15 00:00:00	32020		\N	166099	0	301011002	4116491		0
52812	3128	40479768	1984-09-08	1984-09-08 00:00:00	1984-10-15	1984-10-15 00:00:00	32020		\N	208164	0	444470001	40479768		0
52956	3135	4112343	1970-08-30	1970-08-30 00:00:00	1970-09-11	1970-09-11 00:00:00	32020		\N	208681	0	195662009	4112343		0
32009	1902	40481087	1995-01-20	1995-01-20 00:00:00	1995-02-10	1995-02-10 00:00:00	32020		\N	126615	0	444814009	40481087		0
42674	2543	372328	1967-08-04	1967-08-04 00:00:00	1967-09-24	1967-09-24 00:00:00	32020		\N	168255	0	65363002	372328		0
32331	1921	40481087	2008-04-15	2008-04-15 00:00:00	2008-05-06	2008-05-06 00:00:00	32020		\N	127739	0	444814009	40481087		0
32496	1928	40481087	1988-09-13	1988-09-13 00:00:00	1988-09-27	1988-09-27 00:00:00	32020		\N	128338	0	444814009	40481087		0
32554	1933	80180	1998-05-10	1998-05-10 00:00:00	\N	\N	32020		\N	128557	0	396275006	80180		0
32859	1950	28060	1951-04-08	1951-04-08 00:00:00	1951-04-17	1951-04-17 00:00:00	32020		\N	129710	0	43878008	28060		0
32919	1952	40481087	1960-06-09	1960-06-09 00:00:00	1960-06-16	1960-06-16 00:00:00	32020		\N	129831	0	444814009	40481087		0
33121	1965	4112343	1990-04-11	1990-04-11 00:00:00	1990-04-23	1990-04-23 00:00:00	32020		\N	130617	0	195662009	4112343		0
33274	1975	192671	1957-06-15	1957-06-15 00:00:00	\N	\N	32020		\N	131306	0	K92.2	35208414		0
33496	1987	260139	1950-03-11	1950-03-11 00:00:00	1950-03-25	1950-03-25 00:00:00	32020		\N	132282	0	10509002	260139		0
33583	1991	4112343	1986-12-18	1986-12-18 00:00:00	1986-12-31	1986-12-31 00:00:00	32020		\N	132558	0	195662009	4112343		0
33754	2004	40481087	2016-05-15	2016-05-15 00:00:00	2016-06-05	2016-06-05 00:00:00	32020		\N	133443	0	444814009	40481087		0
33983	2020	81151	2012-07-22	2012-07-22 00:00:00	2012-08-19	2012-08-19 00:00:00	32020		\N	134308	0	44465007	81151		0
34131	2027	40481087	1977-05-15	1977-05-15 00:00:00	1977-05-29	1977-05-29 00:00:00	32020		\N	134937	0	444814009	40481087		0
34291	2034	80180	1963-09-25	1963-09-25 00:00:00	\N	\N	32020		\N	135458	0	396275006	80180		0
34502	2046	40481087	1940-07-31	1940-07-31 00:00:00	1940-08-07	1940-08-07 00:00:00	32020		\N	136167	0	444814009	40481087		0
34563	2051	372328	1967-03-27	1967-03-27 00:00:00	1967-10-29	1967-10-29 00:00:00	32020		\N	136336	0	65363002	372328		0
45338	2697	40481087	1987-10-18	1987-10-18 00:00:00	1987-11-08	1987-11-08 00:00:00	32020		\N	178640	0	444814009	40481087		0
35002	2077	4112343	1970-05-25	1970-05-25 00:00:00	1970-06-07	1970-06-07 00:00:00	32020		\N	138334	0	195662009	4112343		0
35062	2080	4112343	2019-01-15	2019-01-15 00:00:00	2019-01-26	2019-01-26 00:00:00	32020		\N	138600	0	195662009	4112343		0
35243	2088	80180	1945-03-02	1945-03-02 00:00:00	\N	\N	32020		\N	139313	0	396275006	80180		0
35510	2103	28060	2015-09-07	2015-09-07 00:00:00	2015-09-14	2015-09-14 00:00:00	32020		\N	140164	0	43878008	28060		0
35650	2114	4294548	2001-10-06	2001-10-06 00:00:00	2002-03-02	2002-03-02 00:00:00	32020		\N	140677	0	75498004	4294548		0
35767	2119	4112343	1982-10-21	1982-10-21 00:00:00	1982-11-03	1982-11-03 00:00:00	32020		\N	141049	0	195662009	4112343		0
35885	2127	260139	2004-09-11	2004-09-11 00:00:00	2004-09-25	2004-09-25 00:00:00	32020		\N	141461	0	10509002	260139		0
36133	2141	260139	1958-04-07	1958-04-07 00:00:00	1958-04-14	1958-04-14 00:00:00	32020		\N	142650	0	10509002	260139		0
36288	2150	28060	1953-07-04	1953-07-04 00:00:00	1953-07-12	1953-07-12 00:00:00	32020		\N	143145	0	43878008	28060		0
36485	2160	40481087	2003-01-30	2003-01-30 00:00:00	2003-02-13	2003-02-13 00:00:00	32020		\N	143956	0	444814009	40481087		0
36616	2167	40481087	2005-09-01	2005-09-01 00:00:00	2005-09-15	2005-09-15 00:00:00	32020		\N	144377	0	444814009	40481087		0
36771	2175	40481087	2006-09-09	2006-09-09 00:00:00	2006-09-30	2006-09-30 00:00:00	32020		\N	145007	0	444814009	40481087		0
36949	2186	260139	2013-05-30	2013-05-30 00:00:00	2013-06-13	2013-06-13 00:00:00	32020		\N	145769	0	10509002	260139		0
37023	2191	4027663	2004-04-10	2004-04-10 00:00:00	\N	\N	32020		\N	146123	0	13200003	4027663		0
37269	2207	4218389	2011-10-23	2011-10-23 00:00:00	2011-11-20	2011-11-20 00:00:00	32020		\N	147099	0	39848009	4218389		0
37459	2222	4294548	2001-05-19	2001-05-19 00:00:00	2001-08-11	2001-08-11 00:00:00	32020		\N	147926	0	75498004	4294548		0
37560	2228	260139	1958-12-17	1958-12-17 00:00:00	1958-12-31	1958-12-31 00:00:00	32020		\N	148273	0	10509002	260139		0
37701	2235	381316	2012-12-12	2012-12-12 00:00:00	\N	\N	32020		\N	148639	0	230690007	381316		0
37950	2250	260139	2007-10-14	2007-10-14 00:00:00	2007-10-28	2007-10-28 00:00:00	32020		\N	149665	0	10509002	260139		0
38168	2266	4218389	2015-07-07	2015-07-07 00:00:00	2015-08-11	2015-08-11 00:00:00	32020		\N	150639	0	39848009	4218389		0
38279	2273	40481087	2010-08-03	2010-08-03 00:00:00	2010-08-17	2010-08-17 00:00:00	32020		\N	151097	0	444814009	40481087		0
48984	2899	4112343	1951-09-17	1951-09-17 00:00:00	1951-09-27	1951-09-27 00:00:00	32020		\N	193177	0	195662009	4112343		0
38660	2294	28060	1990-10-08	1990-10-08 00:00:00	1990-10-17	1990-10-17 00:00:00	32020		\N	152704	0	43878008	28060		0
38762	2300	4112343	1953-09-08	1953-09-08 00:00:00	1953-09-16	1953-09-16 00:00:00	32020		\N	153148	0	195662009	4112343		0
38950	2315	40481087	2004-01-15	2004-01-15 00:00:00	2004-01-22	2004-01-22 00:00:00	32020		\N	153919	0	444814009	40481087		0
39162	2326	28060	1985-01-10	1985-01-10 00:00:00	1985-01-17	1985-01-17 00:00:00	32020		\N	154675	0	43878008	28060		0
39207	2327	4112343	1983-05-06	1983-05-06 00:00:00	1983-05-13	1983-05-13 00:00:00	32020		\N	154778	0	195662009	4112343		0
39467	2339	4294548	1988-02-24	1988-02-24 00:00:00	1988-03-09	1988-03-09 00:00:00	32020		\N	155599	0	75498004	4294548		0
39540	2342	40481087	2013-11-27	2013-11-27 00:00:00	2013-12-18	2013-12-18 00:00:00	32020		\N	155912	0	444814009	40481087		0
39782	2356	4027663	2006-10-26	2006-10-26 00:00:00	\N	\N	32020		\N	156907	0	13200003	4027663		0
39945	2366	78272	2001-05-21	2001-05-21 00:00:00	2001-06-11	2001-06-11 00:00:00	32020		\N	157518	0	70704007	78272		0
40038	2373	80180	1997-10-25	1997-10-25 00:00:00	\N	\N	32020		\N	157892	0	396275006	80180		0
40250	2387	260139	1972-05-08	1972-05-08 00:00:00	1972-05-15	1972-05-15 00:00:00	32020		\N	158776	0	10509002	260139		0
43376	2583	440448	2001-06-08	2001-06-08 00:00:00	\N	\N	32020		\N	171046	0	74400008	440448		0
40360	2395	372328	1961-08-31	1961-08-31 00:00:00	1962-01-19	1962-01-19 00:00:00	32020		\N	159270	0	65363002	372328		0
40604	2414	317576	1991-08-01	1991-08-01 00:00:00	\N	\N	32020		\N	160271	0	53741008	317576		0
40779	2425	4285898	1994-06-29	1994-06-29 00:00:00	\N	\N	32020		\N	160899	0	68496003	4285898		0
40941	2435	28060	2011-01-26	2011-01-26 00:00:00	2011-02-06	2011-02-06 00:00:00	32020		\N	161411	0	43878008	28060		0
51655	3064	4285898	1975-04-16	1975-04-16 00:00:00	\N	\N	32020		\N	203933	0	68496003	4285898		0
41298	2456	4112343	1995-08-01	1995-08-01 00:00:00	1995-08-12	1995-08-12 00:00:00	32020		\N	162755	0	195662009	4112343		0
41425	2463	4134304	1970-03-06	1970-03-06 00:00:00	1970-06-04	1970-06-04 00:00:00	32020		\N	163396	0	263102004	4134304		0
41567	2470	4112343	2004-07-09	2004-07-09 00:00:00	2004-07-22	2004-07-22 00:00:00	32020		\N	163764	0	195662009	4112343		0
41729	2482	40481087	1997-03-30	1997-03-30 00:00:00	1997-04-06	1997-04-06 00:00:00	32020		\N	164427	0	444814009	40481087		0
52472	3109	40481087	1948-10-03	1948-10-03 00:00:00	1948-10-24	1948-10-24 00:00:00	32020		\N	206797	0	444814009	40481087		0
52628	3117	4294548	2004-11-24	2004-11-24 00:00:00	2004-12-22	2004-12-22 00:00:00	32020		\N	207373	0	75498004	4294548		0
52813	3128	40481087	1990-05-11	1990-05-11 00:00:00	1990-06-01	1990-06-01 00:00:00	32020		\N	208219	0	444814009	40481087		0
52957	3135	4152936	2001-07-16	2001-07-16 00:00:00	2001-07-30	2001-07-30 00:00:00	32020		\N	208695	0	283385000	4152936		0
32010	1902	40481087	1956-10-26	1956-10-26 00:00:00	1956-11-16	1956-11-16 00:00:00	32020		\N	126589	0	444814009	40481087		0
42675	2543	192671	2001-06-21	2001-06-21 00:00:00	\N	\N	32020		\N	168219	0	K92.2	35208414		0
32332	1921	260139	1955-02-06	1955-02-06 00:00:00	1955-02-13	1955-02-13 00:00:00	32020		\N	127729	0	10509002	260139		0
32497	1928	40481087	1979-03-20	1979-03-20 00:00:00	1979-04-10	1979-04-10 00:00:00	32020		\N	128331	0	444814009	40481087		0
32555	1933	4285898	1997-09-12	1997-09-12 00:00:00	\N	\N	32020		\N	128557	0	68496003	4285898		0
32860	1950	195588	1966-09-06	1966-09-06 00:00:00	1966-10-30	1966-10-30 00:00:00	32020		\N	129624	0	38822007	195588		0
32920	1952	4218389	2012-08-28	2012-08-28 00:00:00	2012-09-18	2012-09-18 00:00:00	32020		\N	129790	0	39848009	4218389		0
33122	1965	260139	1982-04-12	1982-04-12 00:00:00	1982-04-19	1982-04-19 00:00:00	32020		\N	130614	0	10509002	260139		0
33275	1975	40481087	1969-05-05	1969-05-05 00:00:00	1969-05-12	1969-05-12 00:00:00	32020		\N	131265	0	444814009	40481087		0
33497	1987	4156265	2003-07-25	2003-07-25 00:00:00	2003-08-15	2003-08-15 00:00:00	32020		\N	132291	0	370247008	4156265		0
33584	1991	4112343	2008-07-14	2008-07-14 00:00:00	2008-07-26	2008-07-26 00:00:00	32020		\N	132560	0	195662009	4112343		0
33755	2004	40481087	1989-07-08	1989-07-08 00:00:00	1989-07-22	1989-07-22 00:00:00	32020		\N	133450	0	444814009	40481087		0
33984	2020	4112343	2015-05-20	2015-05-20 00:00:00	2015-05-31	2015-05-31 00:00:00	32020		\N	134284	0	195662009	4112343		0
34132	2027	4112343	1963-10-04	1963-10-04 00:00:00	1963-10-11	1963-10-11 00:00:00	32020		\N	134872	0	195662009	4112343		0
34292	2034	4112343	1978-12-04	1978-12-04 00:00:00	1978-12-13	1978-12-13 00:00:00	32020		\N	135495	0	195662009	4112343		0
34503	2046	40481087	1973-06-13	1973-06-13 00:00:00	1973-06-27	1973-06-27 00:00:00	32020		\N	136179	0	444814009	40481087		0
34564	2051	260139	2002-08-07	2002-08-07 00:00:00	2002-08-14	2002-08-14 00:00:00	32020		\N	136352	0	10509002	260139		0
45339	2697	4112343	1952-02-11	1952-02-11 00:00:00	1952-02-19	1952-02-19 00:00:00	32020		\N	178609	0	195662009	4112343		0
35003	2078	80180	2017-07-25	2017-07-25 00:00:00	\N	\N	32020		\N	138410	0	396275006	80180		0
35068	2082	40481087	2011-01-19	2011-01-19 00:00:00	2011-01-26	2011-01-26 00:00:00	32020		\N	138647	0	444814009	40481087		0
35244	2088	4285898	1944-12-02	1944-12-02 00:00:00	\N	\N	32020		\N	139313	0	68496003	4285898		0
35511	2103	192671	2010-11-02	2010-11-02 00:00:00	\N	\N	32020		\N	140185	0	K92.2	35208414		0
35651	2114	40481087	2017-12-12	2017-12-12 00:00:00	2017-12-26	2017-12-26 00:00:00	32020		\N	140647	0	444814009	40481087		0
35768	2119	4112343	1988-01-25	1988-01-25 00:00:00	1988-02-07	1988-02-07 00:00:00	32020		\N	141051	0	195662009	4112343		0
35886	2127	260139	1966-10-03	1966-10-03 00:00:00	1966-10-10	1966-10-10 00:00:00	32020		\N	141460	0	10509002	260139		0
36134	2141	4059173	1956-01-31	1956-01-31 00:00:00	1956-03-01	1956-03-01 00:00:00	32020		\N	142597	0	16114001	4059173		0
36289	2150	4112343	1966-11-03	1966-11-03 00:00:00	1966-11-14	1966-11-14 00:00:00	32020		\N	143166	0	195662009	4112343		0
36486	2160	40479422	2012-06-25	2012-06-25 00:00:00	2012-08-31	2012-08-31 00:00:00	32020		\N	143922	0	444448004	40479422		0
36617	2167	40481087	1991-09-08	1991-09-08 00:00:00	1991-09-22	1991-09-22 00:00:00	32020		\N	144390	0	444814009	40481087		0
36772	2175	40481087	2003-01-27	2003-01-27 00:00:00	2003-02-10	2003-02-10 00:00:00	32020		\N	145006	0	444814009	40481087		0
36950	2186	4109685	1987-10-28	1987-10-28 00:00:00	1987-11-11	1987-11-11 00:00:00	32020		\N	145827	0	284551006	4109685		0
37024	2191	4285898	2011-02-28	2011-02-28 00:00:00	\N	\N	32020		\N	146126	0	68496003	4285898		0
37270	2207	81151	1981-02-18	1981-02-18 00:00:00	1981-03-04	1981-03-04 00:00:00	32020		\N	147098	0	44465007	81151		0
37460	2222	4112343	1986-02-09	1986-02-09 00:00:00	1986-02-20	1986-02-20 00:00:00	32020		\N	147925	0	195662009	4112343		0
37561	2228	40481087	2017-09-30	2017-09-30 00:00:00	2017-10-21	2017-10-21 00:00:00	32020		\N	148216	0	444814009	40481087		0
37702	2235	28060	2012-10-26	2012-10-26 00:00:00	2012-11-06	2012-11-06 00:00:00	32020		\N	148639	0	43878008	28060		0
37951	2250	4112343	1990-03-25	1990-03-25 00:00:00	1990-04-06	1990-04-06 00:00:00	32020		\N	149696	0	195662009	4112343		0
38169	2266	4112343	1971-04-04	1971-04-04 00:00:00	1971-04-17	1971-04-17 00:00:00	32020		\N	150620	0	195662009	4112343		0
38280	2273	4283893	1997-05-28	1997-05-28 00:00:00	1997-07-02	1997-07-02 00:00:00	32020		\N	151086	0	36971009	4283893		0
48985	2899	4112343	1973-01-15	1973-01-15 00:00:00	1973-01-27	1973-01-27 00:00:00	32020		\N	193116	0	195662009	4112343		0
38661	2294	4237458	1978-06-29	1978-06-29 00:00:00	1978-07-29	1978-07-29 00:00:00	32020		\N	152750	0	58150001	4237458		0
38763	2300	4112343	2015-08-12	2015-08-12 00:00:00	2015-08-21	2015-08-21 00:00:00	32020		\N	153207	0	195662009	4112343		0
38951	2315	372328	1978-08-23	1978-08-23 00:00:00	1978-10-07	1978-10-07 00:00:00	32020		\N	153964	0	65363002	372328		0
39163	2326	4027663	1985-01-30	1985-01-30 00:00:00	\N	\N	32020		\N	154675	0	13200003	4027663		0
39208	2327	40481087	1986-07-04	1986-07-04 00:00:00	1986-07-11	1986-07-11 00:00:00	32020		\N	154746	0	444814009	40481087		0
39468	2339	133834	1977-03-06	1977-03-06 00:00:00	\N	\N	32020		\N	155597	0	24079001	133834		0
39541	2342	80180	2018-06-25	2018-06-25 00:00:00	\N	\N	32020		\N	155909	0	396275006	80180		0
39783	2356	81151	1984-06-28	1984-06-28 00:00:00	1984-07-12	1984-07-12 00:00:00	32020		\N	156926	0	44465007	81151		0
39946	2367	375671	1978-06-10	1978-06-10 00:00:00	1978-08-09	1978-08-09 00:00:00	32020		\N	157571	0	62564004	375671		0
40039	2373	40481087	1979-07-02	1979-07-02 00:00:00	1979-07-23	1979-07-23 00:00:00	32020		\N	157898	0	444814009	40481087		0
40251	2387	40481087	1988-10-25	1988-10-25 00:00:00	1988-11-01	1988-11-01 00:00:00	32020		\N	158761	0	444814009	40481087		0
40361	2395	40481087	1989-03-26	1989-03-26 00:00:00	1989-04-09	1989-04-09 00:00:00	32020		\N	159220	0	444814009	40481087		0
40605	2414	192671	1957-05-09	1957-05-09 00:00:00	\N	\N	32020		\N	160193	0	K92.2	35208414		0
40780	2425	40481087	1977-04-02	1977-04-02 00:00:00	1977-04-23	1977-04-23 00:00:00	32020		\N	160942	0	444814009	40481087		0
40942	2436	260139	1970-10-25	1970-10-25 00:00:00	1970-11-08	1970-11-08 00:00:00	32020		\N	161580	0	10509002	260139		0
51656	3064	4266809	1975-05-16	1975-05-16 00:00:00	\N	\N	32020		\N	203933	0	397881000	4266809		0
41299	2456	78272	2002-04-17	2002-04-17 00:00:00	2002-05-01	2002-05-01 00:00:00	32020		\N	162817	0	70704007	78272		0
41426	2463	80180	2006-07-20	2006-07-20 00:00:00	\N	\N	32020		\N	163346	0	396275006	80180		0
41568	2470	4112343	1981-08-15	1981-08-15 00:00:00	1981-08-24	1981-08-24 00:00:00	32020		\N	163763	0	195662009	4112343		0
41730	2482	4230399	1976-07-03	1976-07-03 00:00:00	1976-09-01	1976-09-01 00:00:00	32020		\N	164477	0	359817006	4230399		0
52473	3109	40481087	1973-08-22	1973-08-22 00:00:00	1973-09-05	1973-09-05 00:00:00	32020		\N	206748	0	444814009	40481087		0
52629	3117	4266809	2008-04-14	2008-04-14 00:00:00	\N	\N	32020		\N	207340	0	397881000	4266809		0
52814	3128	4084167	1974-02-19	1974-02-19 00:00:00	1974-02-19	1974-02-19 00:00:00	32020		\N	208162	0	241929008	4084167		0
52958	3135	4112343	2008-10-13	2008-10-13 00:00:00	2008-10-24	2008-10-24 00:00:00	32020		\N	208649	0	195662009	4112343		0
32011	1902	378001	1992-11-10	1992-11-10 00:00:00	1993-01-09	1993-01-09 00:00:00	32020		\N	126624	0	62106007	378001		0
42676	2543	4109685	1978-05-22	1978-05-22 00:00:00	1978-06-12	1978-06-12 00:00:00	32020		\N	168266	0	284551006	4109685		0
32333	1921	40481087	1982-02-21	1982-02-21 00:00:00	1982-03-14	1982-03-14 00:00:00	32020		\N	127744	0	444814009	40481087		0
32498	1928	4237458	2019-04-22	2019-04-22 00:00:00	2019-05-22	2019-05-22 00:00:00	32020		\N	128380	0	58150001	4237458		0
32556	1933	4113008	2015-05-01	2015-05-01 00:00:00	2015-05-22	2015-05-22 00:00:00	32020		\N	128598	0	284549007	4113008		0
32861	1950	40480160	2016-01-26	2016-01-26 00:00:00	2016-03-26	2016-03-26 00:00:00	32020		\N	129717	0	443165006	40480160		0
32921	1952	81151	1962-01-22	1962-01-22 00:00:00	1962-02-19	1962-02-19 00:00:00	32020		\N	129786	0	44465007	81151		0
33123	1965	4112343	2009-06-16	2009-06-16 00:00:00	2009-06-24	2009-06-24 00:00:00	32020		\N	130646	0	195662009	4112343		0
33276	1975	40481087	1938-05-23	1938-05-23 00:00:00	1938-06-06	1938-06-06 00:00:00	32020		\N	131296	0	444814009	40481087		0
33498	1987	4283893	1989-04-10	1989-04-10 00:00:00	1989-04-24	1989-04-24 00:00:00	32020		\N	132337	0	36971009	4283893		0
33585	1991	40481087	1997-03-14	1997-03-14 00:00:00	1997-03-28	1997-03-28 00:00:00	32020		\N	132613	0	444814009	40481087		0
33756	2004	260139	1984-05-25	1984-05-25 00:00:00	1984-06-01	1984-06-01 00:00:00	32020		\N	133448	0	10509002	260139		0
33985	2020	40481087	2002-10-10	2002-10-10 00:00:00	2002-10-31	2002-10-31 00:00:00	32020		\N	134283	0	444814009	40481087		0
34133	2027	260139	1963-04-16	1963-04-16 00:00:00	1963-04-30	1963-04-30 00:00:00	32020		\N	134867	0	10509002	260139		0
34293	2034	260139	1954-12-20	1954-12-20 00:00:00	1954-12-27	1954-12-27 00:00:00	32020		\N	135447	0	10509002	260139		0
34504	2046	4329847	2014-04-01	2014-04-01 00:00:00	\N	\N	32020		\N	136154	0	22298006	4329847		0
34565	2051	40481087	1985-11-15	1985-11-15 00:00:00	1985-12-06	1985-12-06 00:00:00	32020		\N	136370	0	444814009	40481087		0
45340	2697	257012	1944-07-20	1944-07-20 00:00:00	\N	\N	32020		\N	178637	0	40055000	257012		0
35004	2078	40479422	2014-01-13	2014-01-13 00:00:00	2014-02-19	2014-02-19 00:00:00	32020		\N	138384	0	444448004	40479422		0
35069	2082	378001	1959-07-11	1959-07-11 00:00:00	1959-08-10	1959-08-10 00:00:00	32020		\N	138660	0	62106007	378001		0
35245	2088	30753	1944-02-06	1944-02-06 00:00:00	\N	\N	32020		\N	139313	0	16761005	30753		0
35512	2103	28060	2015-04-01	2015-04-01 00:00:00	2015-04-09	2015-04-09 00:00:00	32020		\N	140138	0	43878008	28060		0
35652	2114	4112343	2003-11-08	2003-11-08 00:00:00	2003-11-15	2003-11-15 00:00:00	32020		\N	140672	0	195662009	4112343		0
35769	2119	40481087	1981-11-18	1981-11-18 00:00:00	1981-12-09	1981-12-09 00:00:00	32020		\N	141048	0	444814009	40481087		0
35887	2127	372328	1962-11-22	1962-11-22 00:00:00	1963-02-09	1963-02-09 00:00:00	32020		\N	141457	0	65363002	372328		0
36135	2141	134438	1970-07-09	1970-07-09 00:00:00	1971-07-09	1971-07-09 00:00:00	32020		\N	142652	0	40275004	134438		0
36290	2150	4156265	1961-02-21	1961-02-21 00:00:00	1961-03-14	1961-03-14 00:00:00	32020		\N	143149	0	370247008	4156265		0
36487	2160	40481087	2017-08-17	2017-08-17 00:00:00	2017-09-07	2017-09-07 00:00:00	32020		\N	143967	0	444814009	40481087		0
36618	2167	4027663	2010-03-07	2010-03-07 00:00:00	\N	\N	32020		\N	144386	0	13200003	4027663		0
36773	2175	4152936	2019-02-03	2019-02-03 00:00:00	2019-02-17	2019-02-17 00:00:00	32020		\N	145070	0	283385000	4152936		0
36951	2186	28060	1974-10-02	1974-10-02 00:00:00	1974-10-14	1974-10-14 00:00:00	32020		\N	145816	0	43878008	28060		0
37025	2191	80180	2011-12-25	2011-12-25 00:00:00	\N	\N	32020		\N	146126	0	396275006	80180		0
37271	2207	4027663	2006-04-18	2006-04-18 00:00:00	\N	\N	32020		\N	147074	0	13200003	4027663		0
37461	2222	260139	1967-07-03	1967-07-03 00:00:00	1967-07-10	1967-07-10 00:00:00	32020		\N	147905	0	10509002	260139		0
37562	2228	4296204	1987-07-06	1987-07-06 00:00:00	1987-07-20	1987-07-20 00:00:00	32020		\N	148295	0	403190006	4296204		0
37703	2235	40481087	1968-06-11	1968-06-11 00:00:00	1968-07-02	1968-07-02 00:00:00	32020		\N	148634	0	444814009	40481087		0
37952	2250	40481087	2003-11-07	2003-11-07 00:00:00	2003-11-14	2003-11-14 00:00:00	32020		\N	149686	0	444814009	40481087		0
38170	2266	4283893	1980-03-24	1980-03-24 00:00:00	1980-04-07	1980-04-07 00:00:00	32020		\N	150640	0	36971009	4283893		0
38281	2273	40481087	1985-09-14	1985-09-14 00:00:00	1985-09-21	1985-09-21 00:00:00	32020		\N	151089	0	444814009	40481087		0
48986	2899	260139	1972-12-09	1972-12-09 00:00:00	1972-12-16	1972-12-16 00:00:00	32020		\N	193182	0	10509002	260139		0
38662	2294	4294548	1965-07-06	1965-07-06 00:00:00	1965-11-09	1965-11-09 00:00:00	32020		\N	152655	0	75498004	4294548		0
38764	2300	4112343	2001-04-12	2001-04-12 00:00:00	2001-04-25	2001-04-25 00:00:00	32020		\N	153178	0	195662009	4112343		0
38952	2315	80180	2012-04-11	2012-04-11 00:00:00	\N	\N	32020		\N	153950	0	396275006	80180		0
39164	2326	372328	2000-12-04	2000-12-04 00:00:00	2001-02-08	2001-02-08 00:00:00	32020		\N	154649	0	65363002	372328		0
39209	2327	4112343	1974-04-18	1974-04-18 00:00:00	1974-05-01	1974-05-01 00:00:00	32020		\N	154745	0	195662009	4112343		0
39469	2339	4155034	2016-08-22	2016-08-22 00:00:00	2016-09-05	2016-09-05 00:00:00	32020		\N	155618	0	283371005	4155034		0
39542	2343	81151	2012-11-09	2012-11-09 00:00:00	2012-11-23	2012-11-23 00:00:00	32020		\N	155983	0	44465007	81151		0
39784	2356	40481087	2012-05-01	2012-05-01 00:00:00	2012-05-22	2012-05-22 00:00:00	32020		\N	156887	0	444814009	40481087		0
39947	2367	4112343	2013-05-11	2013-05-11 00:00:00	2013-05-21	2013-05-21 00:00:00	32020		\N	157553	0	195662009	4112343		0
40040	2373	4283893	1970-08-11	1970-08-11 00:00:00	1970-09-29	1970-09-29 00:00:00	32020		\N	157957	0	36971009	4283893		0
40252	2387	257012	2009-03-01	2009-03-01 00:00:00	\N	\N	32020		\N	158780	0	40055000	257012		0
40362	2395	4278672	1966-01-28	1966-01-28 00:00:00	1966-04-28	1966-04-28 00:00:00	32020		\N	159237	0	65966004	4278672		0
40606	2414	260139	1919-05-31	1919-05-31 00:00:00	1919-06-14	1919-06-14 00:00:00	32020		\N	160273	0	10509002	260139		0
40781	2425	40481087	1968-02-06	1968-02-06 00:00:00	1968-02-13	1968-02-13 00:00:00	32020		\N	160941	0	444814009	40481087		0
40943	2436	4112343	1920-08-03	1920-08-03 00:00:00	1920-08-13	1920-08-13 00:00:00	32020		\N	161484	0	195662009	4112343		0
51657	3064	81893	1974-09-18	1974-09-18 00:00:00	\N	\N	32020		\N	203933	0	64766004	81893		0
41300	2456	4278672	1968-02-15	1968-02-15 00:00:00	1968-03-16	1968-03-16 00:00:00	32020		\N	162816	0	65966004	4278672		0
41427	2463	40481087	2005-05-21	2005-05-21 00:00:00	2005-06-04	2005-06-04 00:00:00	32020		\N	163346	0	444814009	40481087		0
41617	2476	4112343	1976-05-25	1976-05-25 00:00:00	1976-06-02	1976-06-02 00:00:00	32020		\N	164060	0	195662009	4112343		0
41731	2482	40481087	1997-10-11	1997-10-11 00:00:00	1997-10-18	1997-10-18 00:00:00	32020		\N	164441	0	444814009	40481087		0
52474	3109	255848	1990-07-16	1990-07-16 00:00:00	\N	\N	32020		\N	206704	0	233604007	255848		0
52630	3117	80180	2008-04-14	2008-04-14 00:00:00	\N	\N	32020		\N	207340	0	396275006	80180		0
52815	3128	4237458	1985-08-11	1985-08-11 00:00:00	1985-11-09	1985-11-09 00:00:00	32020		\N	208166	0	58150001	4237458		0
52959	3135	40481087	1984-06-15	1984-06-15 00:00:00	1984-06-29	1984-06-29 00:00:00	32020		\N	208686	0	444814009	40481087		0
32012	1902	81893	1984-06-10	1984-06-10 00:00:00	\N	\N	32020		\N	126638	0	64766004	81893		0
42677	2543	40481087	1971-02-06	1971-02-06 00:00:00	1971-02-13	1971-02-13 00:00:00	32020		\N	168231	0	444814009	40481087		0
32334	1921	195588	1992-09-13	1992-09-13 00:00:00	1992-10-23	1992-10-23 00:00:00	32020		\N	127745	0	38822007	195588		0
32499	1928	260139	2004-09-24	2004-09-24 00:00:00	2004-10-08	2004-10-08 00:00:00	32020		\N	128371	0	10509002	260139		0
32557	1933	260139	1980-12-02	1980-12-02 00:00:00	1980-12-16	1980-12-16 00:00:00	32020		\N	128546	0	10509002	260139		0
32862	1950	4230399	2016-01-26	2016-01-26 00:00:00	2016-03-26	2016-03-26 00:00:00	32020		\N	129717	0	359817006	4230399		0
32922	1953	40481087	1969-04-01	1969-04-01 00:00:00	1969-04-22	1969-04-22 00:00:00	32020		\N	129881	0	444814009	40481087		0
33124	1965	80180	2010-04-09	2010-04-09 00:00:00	\N	\N	32020		\N	130646	0	396275006	80180		0
33277	1975	40481087	1965-08-27	1965-08-27 00:00:00	1965-09-17	1965-09-17 00:00:00	32020		\N	131299	0	444814009	40481087		0
33499	1987	4237458	1948-04-18	1948-04-18 00:00:00	1948-07-17	1948-07-17 00:00:00	32020		\N	132360	0	58150001	4237458		0
33586	1991	40481087	1998-01-30	1998-01-30 00:00:00	1998-02-13	1998-02-13 00:00:00	32020		\N	132614	0	444814009	40481087		0
33757	2004	80180	2005-12-09	2005-12-09 00:00:00	\N	\N	32020		\N	133438	0	396275006	80180		0
33986	2020	134438	2000-10-30	2000-10-30 00:00:00	2002-10-20	2002-10-20 00:00:00	32020		\N	134282	0	40275004	134438		0
34134	2027	260139	2019-01-04	2019-01-04 00:00:00	2019-01-18	2019-01-18 00:00:00	32020		\N	134880	0	10509002	260139		0
34294	2034	257012	1942-07-02	1942-07-02 00:00:00	\N	\N	32020		\N	135425	0	40055000	257012		0
44987	2677	372328	2015-01-29	2015-01-29 00:00:00	2016-04-23	2016-04-23 00:00:00	32020		\N	177420	0	65363002	372328		0
34566	2051	4296204	1981-08-22	1981-08-22 00:00:00	1981-09-12	1981-09-12 00:00:00	32020		\N	136398	0	403190006	4296204		0
45341	2697	40481087	1960-03-14	1960-03-14 00:00:00	1960-03-21	1960-03-21 00:00:00	32020		\N	178638	0	444814009	40481087		0
35005	2078	4112343	2012-12-29	2012-12-29 00:00:00	2013-01-09	2013-01-09 00:00:00	32020		\N	138430	0	195662009	4112343		0
35070	2082	40481087	2000-01-21	2000-01-21 00:00:00	2000-02-11	2000-02-11 00:00:00	32020		\N	138699	0	444814009	40481087		0
35246	2088	40481087	1931-07-03	1931-07-03 00:00:00	1931-07-10	1931-07-10 00:00:00	32020		\N	139257	0	444814009	40481087		0
35513	2103	80180	2010-09-21	2010-09-21 00:00:00	\N	\N	32020		\N	140163	0	396275006	80180		0
35653	2114	81151	2008-08-12	2008-08-12 00:00:00	2008-09-09	2008-09-09 00:00:00	32020		\N	140685	0	44465007	81151		0
35770	2119	4155034	1992-05-05	1992-05-05 00:00:00	1992-05-19	1992-05-19 00:00:00	32020		\N	140974	0	283371005	4155034		0
35888	2127	40481087	1978-05-02	1978-05-02 00:00:00	1978-05-23	1978-05-23 00:00:00	32020		\N	141453	0	444814009	40481087		0
36136	2141	81151	2006-02-14	2006-02-14 00:00:00	2006-03-07	2006-03-07 00:00:00	32020		\N	142599	0	44465007	81151		0
36291	2150	372328	1995-09-14	1995-09-14 00:00:00	1996-02-09	1996-02-09 00:00:00	32020		\N	143180	0	65363002	372328		0
36488	2160	28060	1974-05-16	1974-05-16 00:00:00	1974-05-28	1974-05-28 00:00:00	32020		\N	143977	0	43878008	28060		0
36619	2167	40481087	1991-10-30	1991-10-30 00:00:00	1991-11-06	1991-11-06 00:00:00	32020		\N	144364	0	444814009	40481087		0
36774	2175	40481087	1984-03-15	1984-03-15 00:00:00	1984-04-05	1984-04-05 00:00:00	32020		\N	145000	0	444814009	40481087		0
36952	2186	4230399	2019-01-09	2019-01-09 00:00:00	2019-04-09	2019-04-09 00:00:00	32020		\N	145831	0	359817006	4230399		0
37026	2192	4283893	1979-06-07	1979-06-07 00:00:00	1979-09-06	1979-09-06 00:00:00	32020		\N	146227	0	36971009	4283893		0
37272	2207	195588	2002-04-19	2002-04-19 00:00:00	2002-06-03	2002-06-03 00:00:00	32020		\N	147101	0	38822007	195588		0
37462	2222	80180	2005-11-04	2005-11-04 00:00:00	\N	\N	32020		\N	147898	0	396275006	80180		0
37563	2228	375671	1975-01-10	1975-01-10 00:00:00	1975-03-11	1975-03-11 00:00:00	32020		\N	148293	0	62564004	375671		0
37704	2235	28060	1992-07-19	1992-07-19 00:00:00	1992-07-31	1992-07-31 00:00:00	32020		\N	148690	0	43878008	28060		0
37953	2250	4112343	1958-12-24	1958-12-24 00:00:00	1959-01-05	1959-01-05 00:00:00	32020		\N	149663	0	195662009	4112343		0
38171	2266	260139	1985-10-17	1985-10-17 00:00:00	1985-10-24	1985-10-24 00:00:00	32020		\N	150671	0	10509002	260139		0
38282	2273	4027663	2009-10-12	2009-10-12 00:00:00	\N	\N	32020		\N	151128	0	13200003	4027663		0
48987	2899	40481087	1950-12-27	1950-12-27 00:00:00	1951-01-03	1951-01-03 00:00:00	32020		\N	193176	0	444814009	40481087		0
38663	2294	40481087	2010-06-26	2010-06-26 00:00:00	2010-07-03	2010-07-03 00:00:00	32020		\N	152706	0	444814009	40481087		0
38765	2300	4218389	2018-03-13	2018-03-13 00:00:00	2018-04-17	2018-04-17 00:00:00	32020		\N	153132	0	39848009	4218389		0
38953	2315	81151	1984-01-24	1984-01-24 00:00:00	1984-02-21	1984-02-21 00:00:00	32020		\N	153945	0	44465007	81151		0
39165	2326	260139	1963-01-07	1963-01-07 00:00:00	1963-01-14	1963-01-14 00:00:00	32020		\N	154673	0	10509002	260139		0
39210	2327	4296204	1985-10-10	1985-10-10 00:00:00	1985-11-07	1985-11-07 00:00:00	32020		\N	154727	0	403190006	4296204		0
39470	2339	4112343	1986-02-24	1986-02-24 00:00:00	1986-03-06	1986-03-06 00:00:00	32020		\N	155598	0	195662009	4112343		0
39543	2343	381316	2016-05-21	2016-05-21 00:00:00	\N	\N	32020		\N	156005	0	230690007	381316		0
39785	2356	440086	1988-10-30	1988-10-30 00:00:00	1990-06-17	1990-06-17 00:00:00	32020		\N	156899	0	192127007	440086		0
39948	2367	78272	1990-01-06	1990-01-06 00:00:00	1990-01-27	1990-01-27 00:00:00	32020		\N	157574	0	70704007	78272		0
40041	2373	260139	2017-07-16	2017-07-16 00:00:00	2017-07-30	2017-07-30 00:00:00	32020		\N	157960	0	10509002	260139		0
40253	2387	4109685	2002-10-27	2002-10-27 00:00:00	2002-11-10	2002-11-10 00:00:00	32020		\N	158759	0	284551006	4109685		0
40363	2395	40481087	2019-04-30	2019-04-30 00:00:00	2019-05-21	2019-05-21 00:00:00	32020		\N	159269	0	444814009	40481087		0
40607	2414	40481087	1985-06-19	1985-06-19 00:00:00	1985-07-03	1985-07-03 00:00:00	32020		\N	160278	0	444814009	40481087		0
40782	2425	40481087	2017-01-15	2017-01-15 00:00:00	2017-02-05	2017-02-05 00:00:00	32020		\N	160946	0	444814009	40481087		0
40944	2436	40481087	1953-11-10	1953-11-10 00:00:00	1953-11-24	1953-11-24 00:00:00	32020		\N	161586	0	444814009	40481087		0
51658	3064	4278672	1971-10-18	1971-10-18 00:00:00	1971-12-17	1971-12-17 00:00:00	32020		\N	203998	0	65966004	4278672		0
41301	2456	40481087	1999-06-29	1999-06-29 00:00:00	1999-07-20	1999-07-20 00:00:00	32020		\N	162782	0	444814009	40481087		0
41428	2463	372328	1972-03-14	1972-03-14 00:00:00	1972-09-14	1972-09-14 00:00:00	32020		\N	163393	0	65363002	372328		0
41618	2476	260139	2010-06-30	2010-06-30 00:00:00	2010-07-07	2010-07-07 00:00:00	32020		\N	164063	0	10509002	260139		0
41732	2482	40481087	2008-07-01	2008-07-01 00:00:00	2008-07-22	2008-07-22 00:00:00	32020		\N	164480	0	444814009	40481087		0
52475	3109	257012	1985-05-05	1985-05-05 00:00:00	\N	\N	32020		\N	206752	0	40055000	257012		0
52631	3117	4112343	1979-01-04	1979-01-04 00:00:00	1979-01-11	1979-01-11 00:00:00	32020		\N	207332	0	195662009	4112343		0
52816	3128	40481087	1984-03-23	1984-03-23 00:00:00	1984-04-06	1984-04-06 00:00:00	32020		\N	208199	0	444814009	40481087		0
52960	3135	4027663	1994-05-29	1994-05-29 00:00:00	\N	\N	32020		\N	208661	0	13200003	4027663		0
32013	1902	30753	1984-10-08	1984-10-08 00:00:00	\N	\N	32020		\N	126638	0	16761005	30753		0
42678	2543	4310024	1999-08-06	1999-08-06 00:00:00	\N	\N	32020		\N	168222	0	424802006	4310024		0
32335	1921	260139	2003-03-13	2003-03-13 00:00:00	2003-03-20	2003-03-20 00:00:00	32020		\N	127747	0	10509002	260139		0
32500	1928	40479768	2018-02-19	2018-02-19 00:00:00	2018-03-28	2018-03-28 00:00:00	32020		\N	128379	0	444470001	40479768		0
32558	1933	4027663	1989-05-22	1989-05-22 00:00:00	\N	\N	32020		\N	128607	0	13200003	4027663		0
32863	1950	261325	1983-01-06	1983-01-06 00:00:00	\N	\N	32020		\N	129654	0	87433001	261325		0
32923	1953	40481087	1988-03-21	1988-03-21 00:00:00	1988-03-28	1988-03-28 00:00:00	32020		\N	129909	0	444814009	40481087		0
33125	1965	260139	1988-06-11	1988-06-11 00:00:00	1988-06-25	1988-06-25 00:00:00	32020		\N	130640	0	10509002	260139		0
33278	1975	372328	1928-10-24	1928-10-24 00:00:00	1929-02-02	1929-02-02 00:00:00	32020		\N	131286	0	65363002	372328		0
33500	1987	40481087	1951-10-07	1951-10-07 00:00:00	1951-10-21	1951-10-21 00:00:00	32020		\N	132283	0	444814009	40481087		0
33588	1991	4329847	2011-02-21	2011-02-21 00:00:00	\N	\N	32020		\N	132611	0	22298006	4329847		0
33758	2004	260139	2005-11-13	2005-11-13 00:00:00	2005-11-27	2005-11-27 00:00:00	32020		\N	133438	0	10509002	260139		0
33987	2020	80180	2006-05-10	2006-05-10 00:00:00	\N	\N	32020		\N	134254	0	396275006	80180		0
34135	2027	40481087	2016-07-09	2016-07-09 00:00:00	2016-07-23	2016-07-23 00:00:00	32020		\N	134921	0	444814009	40481087		0
34295	2034	40481087	1967-10-12	1967-10-12 00:00:00	1967-11-02	1967-11-02 00:00:00	32020		\N	135491	0	444814009	40481087		0
44988	2677	4027663	1999-04-09	1999-04-09 00:00:00	\N	\N	32020		\N	177407	0	13200003	4027663		0
34567	2052	260139	1973-03-28	1973-03-28 00:00:00	1973-04-04	1973-04-04 00:00:00	32020		\N	136438	0	10509002	260139		0
45342	2697	4218389	1994-11-17	1994-11-17 00:00:00	1994-12-22	1994-12-22 00:00:00	32020		\N	178581	0	39848009	4218389		0
35006	2078	372328	1983-04-13	1983-04-13 00:00:00	1983-05-18	1983-05-18 00:00:00	32020		\N	138412	0	65363002	372328		0
35071	2082	40481087	1990-09-26	1990-09-26 00:00:00	1990-10-03	1990-10-03 00:00:00	32020		\N	138713	0	444814009	40481087		0
35247	2088	260139	1973-04-21	1973-04-21 00:00:00	1973-04-28	1973-04-28 00:00:00	32020		\N	139264	0	10509002	260139		0
35514	2103	4116491	2009-05-04	2009-05-04 00:00:00	2009-06-07	2009-06-07 00:00:00	32020		\N	140163	0	301011002	4116491		0
35654	2114	40481087	1973-11-16	1973-11-16 00:00:00	1973-11-23	1973-11-23 00:00:00	32020		\N	140642	0	444814009	40481087		0
35771	2119	40481087	1965-05-01	1965-05-01 00:00:00	1965-05-08	1965-05-08 00:00:00	32020		\N	140963	0	444814009	40481087		0
35889	2127	40481087	1995-08-29	1995-08-29 00:00:00	1995-09-19	1995-09-19 00:00:00	32020		\N	141454	0	444814009	40481087		0
36137	2141	40481087	1950-06-23	1950-06-23 00:00:00	1950-07-14	1950-07-14 00:00:00	32020		\N	142637	0	444814009	40481087		0
36292	2150	260139	1969-08-06	1969-08-06 00:00:00	1969-08-13	1969-08-13 00:00:00	32020		\N	143157	0	10509002	260139		0
36489	2160	4112343	1994-01-24	1994-01-24 00:00:00	1994-02-04	1994-02-04 00:00:00	32020		\N	143955	0	195662009	4112343		0
36620	2167	372328	1979-05-09	1979-05-09 00:00:00	1979-05-23	1979-05-23 00:00:00	32020		\N	144366	0	65363002	372328		0
36775	2175	257012	1996-09-14	1996-09-14 00:00:00	\N	\N	32020		\N	145004	0	40055000	257012		0
36953	2186	4296204	1986-10-28	1986-10-28 00:00:00	1986-12-02	1986-12-02 00:00:00	32020		\N	145826	0	403190006	4296204		0
37027	2192	4112343	2013-09-02	2013-09-02 00:00:00	2013-09-12	2013-09-12 00:00:00	32020		\N	146149	0	195662009	4112343		0
37273	2207	40481087	1982-10-19	1982-10-19 00:00:00	1982-10-26	1982-10-26 00:00:00	32020		\N	147100	0	444814009	40481087		0
37463	2222	28060	2008-02-10	2008-02-10 00:00:00	2008-02-20	2008-02-20 00:00:00	32020		\N	147927	0	43878008	28060		0
37564	2228	4112343	1969-06-04	1969-06-04 00:00:00	1969-06-11	1969-06-11 00:00:00	32020		\N	148245	0	195662009	4112343		0
37718	2237	4230399	2005-10-29	2005-10-29 00:00:00	2005-12-28	2005-12-28 00:00:00	32020		\N	148809	0	359817006	4230399		0
37954	2250	378001	1990-08-27	1990-08-27 00:00:00	1990-10-26	1990-10-26 00:00:00	32020		\N	149651	0	62106007	378001		0
38172	2266	40481087	1996-06-18	1996-06-18 00:00:00	1996-07-09	1996-07-09 00:00:00	32020		\N	150625	0	444814009	40481087		0
38283	2273	40481087	1993-02-05	1993-02-05 00:00:00	1993-02-12	1993-02-12 00:00:00	32020		\N	151090	0	444814009	40481087		0
48988	2899	40481087	1964-05-30	1964-05-30 00:00:00	1964-06-20	1964-06-20 00:00:00	32020		\N	193115	0	444814009	40481087		0
38664	2294	440086	1967-11-24	1967-11-24 00:00:00	1969-01-10	1969-01-10 00:00:00	32020		\N	152657	0	192127007	440086		0
38766	2300	4112343	1957-09-28	1957-09-28 00:00:00	1957-10-10	1957-10-10 00:00:00	32020		\N	153203	0	195662009	4112343		0
38954	2315	4112343	2004-07-09	2004-07-09 00:00:00	2004-07-21	2004-07-21 00:00:00	32020		\N	153935	0	195662009	4112343		0
39166	2326	4112343	2008-10-15	2008-10-15 00:00:00	2008-10-25	2008-10-25 00:00:00	32020		\N	154637	0	195662009	4112343		0
39211	2328	40481087	2005-11-13	2005-11-13 00:00:00	2005-11-27	2005-11-27 00:00:00	32020		\N	154857	0	444814009	40481087		0
39471	2339	81151	1995-01-24	1995-01-24 00:00:00	1995-02-14	1995-02-14 00:00:00	32020		\N	155617	0	44465007	81151		0
39544	2343	40481087	2000-12-11	2000-12-11 00:00:00	2000-12-25	2000-12-25 00:00:00	32020		\N	155972	0	444814009	40481087		0
39786	2356	372328	1985-02-23	1985-02-23 00:00:00	1985-10-30	1985-10-30 00:00:00	32020		\N	156871	0	65363002	372328		0
39949	2367	260139	2003-04-01	2003-04-01 00:00:00	2003-04-08	2003-04-08 00:00:00	32020		\N	157581	0	10509002	260139		0
40042	2373	4112343	1972-01-30	1972-01-30 00:00:00	1972-02-09	1972-02-09 00:00:00	32020		\N	157948	0	195662009	4112343		0
40254	2387	4294548	1969-04-28	1969-04-28 00:00:00	1969-06-30	1969-06-30 00:00:00	32020		\N	158767	0	75498004	4294548		0
40364	2395	260139	2012-10-19	2012-10-19 00:00:00	2012-10-26	2012-10-26 00:00:00	32020		\N	159268	0	10509002	260139		0
40608	2414	313217	1994-08-18	1994-08-18 00:00:00	\N	\N	32020		\N	160263	0	49436004	313217		0
40783	2425	4112343	2004-12-10	2004-12-10 00:00:00	2004-12-18	2004-12-18 00:00:00	32020		\N	160916	0	195662009	4112343		0
40945	2436	40481087	1966-01-03	1966-01-03 00:00:00	1966-01-17	1966-01-17 00:00:00	32020		\N	161500	0	444814009	40481087		0
51659	3064	81151	1947-01-08	1947-01-08 00:00:00	1947-01-29	1947-01-29 00:00:00	32020		\N	203995	0	44465007	81151		0
41302	2456	260139	2001-08-03	2001-08-03 00:00:00	2001-08-17	2001-08-17 00:00:00	32020		\N	162772	0	10509002	260139		0
41429	2463	439777	2008-03-31	2008-03-31 00:00:00	\N	\N	32020		\N	163392	0	271737000	439777		0
41619	2476	260139	1971-04-08	1971-04-08 00:00:00	1971-04-22	1971-04-22 00:00:00	32020		\N	164100	0	10509002	260139		0
41733	2482	260139	1990-06-04	1990-06-04 00:00:00	1990-06-11	1990-06-11 00:00:00	32020		\N	164439	0	10509002	260139		0
52476	3109	4112343	1939-09-16	1939-09-16 00:00:00	1939-09-24	1939-09-24 00:00:00	32020		\N	206733	0	195662009	4112343		0
52632	3117	40481087	1993-02-08	1993-02-08 00:00:00	1993-02-22	1993-02-22 00:00:00	32020		\N	207333	0	444814009	40481087		0
52817	3128	28060	2011-01-10	2011-01-10 00:00:00	2011-01-21	2011-01-21 00:00:00	32020		\N	208175	0	43878008	28060		0
52961	3135	40481087	2011-05-08	2011-05-08 00:00:00	2011-05-15	2011-05-15 00:00:00	32020		\N	208706	0	444814009	40481087		0
32014	1902	80180	1985-09-03	1985-09-03 00:00:00	\N	\N	32020		\N	126638	0	396275006	80180		0
42679	2543	4294548	1998-01-13	1998-01-13 00:00:00	1998-01-20	1998-01-20 00:00:00	32020		\N	168222	0	75498004	4294548		0
32336	1921	40481087	1963-06-02	1963-06-02 00:00:00	1963-06-23	1963-06-23 00:00:00	32020		\N	127719	0	444814009	40481087		0
32501	1928	40481087	1998-03-15	1998-03-15 00:00:00	1998-04-05	1998-04-05 00:00:00	32020		\N	128352	0	444814009	40481087		0
32559	1933	195588	1979-05-25	1979-05-25 00:00:00	1979-07-06	1979-07-06 00:00:00	32020		\N	128563	0	38822007	195588		0
32864	1950	4112343	1945-04-23	1945-04-23 00:00:00	1945-05-06	1945-05-06 00:00:00	32020		\N	129644	0	195662009	4112343		0
32924	1953	372328	1960-07-27	1960-07-27 00:00:00	1961-07-17	1961-07-17 00:00:00	32020		\N	129911	0	65363002	372328		0
33126	1966	4218389	1990-01-21	1990-01-21 00:00:00	1990-02-25	1990-02-25 00:00:00	32020		\N	130737	0	39848009	4218389		0
33279	1975	378001	1966-01-05	1966-01-05 00:00:00	1966-02-04	1966-02-04 00:00:00	32020		\N	131310	0	62106007	378001		0
33501	1987	4112343	1946-03-17	1946-03-17 00:00:00	1946-03-27	1946-03-27 00:00:00	32020		\N	132315	0	195662009	4112343		0
33589	1991	4112343	1981-10-22	1981-10-22 00:00:00	1981-10-31	1981-10-31 00:00:00	32020		\N	132557	0	195662009	4112343		0
33759	2004	4112343	1979-12-18	1979-12-18 00:00:00	1979-12-25	1979-12-25 00:00:00	32020		\N	133441	0	195662009	4112343		0
33988	2020	372328	1976-09-20	1976-09-20 00:00:00	1976-10-16	1976-10-16 00:00:00	32020		\N	134291	0	65363002	372328		0
34136	2027	4112343	2005-12-29	2005-12-29 00:00:00	2006-01-11	2006-01-11 00:00:00	32020		\N	134877	0	195662009	4112343		0
34296	2034	40481087	1979-12-29	1979-12-29 00:00:00	1980-01-19	1980-01-19 00:00:00	32020		\N	135437	0	444814009	40481087		0
44989	2677	4134304	1980-09-21	1980-09-21 00:00:00	1980-10-21	1980-10-21 00:00:00	32020		\N	177359	0	263102004	4134304		0
34568	2052	80180	2003-07-13	2003-07-13 00:00:00	\N	\N	32020		\N	136454	0	396275006	80180		0
45343	2697	40481087	1999-08-11	1999-08-11 00:00:00	1999-08-18	1999-08-18 00:00:00	32020		\N	178641	0	444814009	40481087		0
35007	2078	40481087	1996-12-15	1996-12-15 00:00:00	1997-01-05	1997-01-05 00:00:00	32020		\N	138429	0	444814009	40481087		0
35072	2082	4112343	1944-05-27	1944-05-27 00:00:00	1944-06-05	1944-06-05 00:00:00	32020		\N	138696	0	195662009	4112343		0
35248	2088	40481087	1990-01-22	1990-01-22 00:00:00	1990-02-12	1990-02-12 00:00:00	32020		\N	139262	0	444814009	40481087		0
35515	2103	4112343	1983-08-15	1983-08-15 00:00:00	1983-08-28	1983-08-28 00:00:00	32020		\N	140162	0	195662009	4112343		0
35655	2114	81151	2018-01-20	2018-01-20 00:00:00	2018-02-10	2018-02-10 00:00:00	32020		\N	140686	0	44465007	81151		0
35772	2119	4112343	1989-06-04	1989-06-04 00:00:00	1989-06-13	1989-06-13 00:00:00	32020		\N	141056	0	195662009	4112343		0
35890	2127	40481087	1976-08-21	1976-08-21 00:00:00	1976-09-04	1976-09-04 00:00:00	32020		\N	141488	0	444814009	40481087		0
36138	2141	40481087	1981-06-24	1981-06-24 00:00:00	1981-07-08	1981-07-08 00:00:00	32020		\N	142614	0	444814009	40481087		0
36293	2150	40481087	1977-03-30	1977-03-30 00:00:00	1977-04-13	1977-04-13 00:00:00	32020		\N	143159	0	444814009	40481087		0
36490	2160	372328	1962-03-03	1962-03-03 00:00:00	1962-06-18	1962-06-18 00:00:00	32020		\N	143968	0	65363002	372328		0
36621	2167	40481087	2013-03-15	2013-03-15 00:00:00	2013-03-22	2013-03-22 00:00:00	32020		\N	144350	0	444814009	40481087		0
36776	2175	440448	1979-01-29	1979-01-29 00:00:00	\N	\N	32020		\N	145066	0	74400008	440448		0
36954	2186	378001	1992-11-14	1992-11-14 00:00:00	1993-01-13	1993-01-13 00:00:00	32020		\N	145828	0	62106007	378001		0
37028	2192	260139	1997-11-15	1997-11-15 00:00:00	1997-11-29	1997-11-29 00:00:00	32020		\N	146175	0	10509002	260139		0
37274	2207	4112343	2014-11-22	2014-11-22 00:00:00	2014-12-03	2014-12-03 00:00:00	32020		\N	147058	0	195662009	4112343		0
37464	2222	260139	1973-05-08	1973-05-08 00:00:00	1973-05-15	1973-05-15 00:00:00	32020		\N	147929	0	10509002	260139		0
37565	2228	78272	2010-04-20	2010-04-20 00:00:00	2010-05-18	2010-05-18 00:00:00	32020		\N	148296	0	70704007	78272		0
37719	2237	40480160	2005-10-29	2005-10-29 00:00:00	2005-12-28	2005-12-28 00:00:00	32020		\N	148809	0	443165006	40480160		0
37955	2250	4310024	1993-06-26	1993-06-26 00:00:00	\N	\N	32020		\N	149661	0	424802006	4310024		0
38173	2266	260139	1991-04-28	1991-04-28 00:00:00	1991-05-05	1991-05-05 00:00:00	32020		\N	150641	0	10509002	260139		0
38284	2274	372328	1949-07-20	1949-07-20 00:00:00	1949-10-09	1949-10-09 00:00:00	32020		\N	151199	0	65363002	372328		0
48989	2899	4152936	2004-03-14	2004-03-14 00:00:00	2004-04-04	2004-04-04 00:00:00	32020		\N	193181	0	283385000	4152936		0
38665	2294	40481087	2009-06-09	2009-06-09 00:00:00	2009-06-23	2009-06-23 00:00:00	32020		\N	152719	0	444814009	40481087		0
38767	2300	40481087	2015-06-25	2015-06-25 00:00:00	2015-07-16	2015-07-16 00:00:00	32020		\N	153206	0	444814009	40481087		0
38955	2315	40481087	1980-04-21	1980-04-21 00:00:00	1980-05-05	1980-05-05 00:00:00	32020		\N	153944	0	444814009	40481087		0
39167	2326	28060	2011-08-25	2011-08-25 00:00:00	2011-09-02	2011-09-02 00:00:00	32020		\N	154638	0	43878008	28060		0
39212	2328	28060	2016-07-08	2016-07-08 00:00:00	2016-07-19	2016-07-19 00:00:00	32020		\N	154871	0	43878008	28060		0
39472	2339	4112343	1997-08-08	1997-08-08 00:00:00	1997-08-21	1997-08-21 00:00:00	32020		\N	155631	0	195662009	4112343		0
39545	2343	40481087	1962-04-18	1962-04-18 00:00:00	1962-04-25	1962-04-25 00:00:00	32020		\N	155958	0	444814009	40481087		0
39787	2356	4294548	2007-10-15	2007-10-15 00:00:00	2007-10-22	2007-10-22 00:00:00	32020		\N	156908	0	75498004	4294548		0
39950	2367	40481087	2017-03-02	2017-03-02 00:00:00	2017-03-23	2017-03-23 00:00:00	32020		\N	157554	0	444814009	40481087		0
40043	2373	260139	1961-04-08	1961-04-08 00:00:00	1961-04-22	1961-04-22 00:00:00	32020		\N	157883	0	10509002	260139		0
40261	2389	81151	1992-12-31	1992-12-31 00:00:00	1993-01-28	1993-01-28 00:00:00	32020		\N	158843	0	44465007	81151		0
40365	2395	4155034	1962-03-29	1962-03-29 00:00:00	1962-04-19	1962-04-19 00:00:00	32020		\N	159236	0	283371005	4155034		0
40609	2414	40481087	1968-11-02	1968-11-02 00:00:00	1968-11-09	1968-11-09 00:00:00	32020		\N	160217	0	444814009	40481087		0
40784	2425	372328	1965-02-21	1965-02-21 00:00:00	1966-02-03	1966-02-03 00:00:00	32020		\N	160917	0	65363002	372328		0
40946	2436	40481087	1929-07-27	1929-07-27 00:00:00	1929-08-17	1929-08-17 00:00:00	32020		\N	161485	0	444814009	40481087		0
51660	3064	4218389	1993-03-01	1993-03-01 00:00:00	1993-03-22	1993-03-22 00:00:00	32020		\N	204002	0	39848009	4218389		0
41303	2456	40481087	2002-12-01	2002-12-01 00:00:00	2002-12-22	2002-12-22 00:00:00	32020		\N	162764	0	444814009	40481087		0
41430	2463	372328	1975-04-02	1975-04-02 00:00:00	1976-04-01	1976-04-01 00:00:00	32020		\N	163333	0	65363002	372328		0
41620	2476	80180	1994-01-12	1994-01-12 00:00:00	\N	\N	32020		\N	164054	0	396275006	80180		0
41734	2483	260139	1962-12-15	1962-12-15 00:00:00	1962-12-29	1962-12-29 00:00:00	32020		\N	164512	0	10509002	260139		0
52477	3109	40481087	1937-09-22	1937-09-22 00:00:00	1937-10-13	1937-10-13 00:00:00	32020		\N	206848	0	444814009	40481087		0
52633	3117	4156265	2015-03-24	2015-03-24 00:00:00	2015-04-07	2015-04-07 00:00:00	32020		\N	207399	0	370247008	4156265		0
52818	3128	81151	2007-03-19	2007-03-19 00:00:00	2007-04-09	2007-04-09 00:00:00	32020		\N	208170	0	44465007	81151		0
52962	3135	260139	2011-08-19	2011-08-19 00:00:00	2011-08-26	2011-08-26 00:00:00	32020		\N	208707	0	10509002	260139		0
32015	1902	4027663	1974-11-20	1974-11-20 00:00:00	\N	\N	32020		\N	126564	0	13200003	4027663		0
42680	2543	80180	2001-03-28	2001-03-28 00:00:00	\N	\N	32020		\N	168273	0	396275006	80180		0
32337	1921	80180	1995-03-02	1995-03-02 00:00:00	\N	\N	32020		\N	127773	0	396275006	80180		0
32502	1928	4059173	1974-03-21	1974-03-21 00:00:00	1974-04-20	1974-04-20 00:00:00	32020		\N	128307	0	16114001	4059173		0
32560	1934	4112343	1963-02-15	1963-02-15 00:00:00	1963-02-25	1963-02-25 00:00:00	32020		\N	128632	0	195662009	4112343		0
32865	1950	80180	1978-12-17	1978-12-17 00:00:00	\N	\N	32020		\N	129625	0	396275006	80180		0
32925	1953	134438	1983-08-09	1983-08-09 00:00:00	1984-08-03	1984-08-03 00:00:00	32020		\N	129906	0	40275004	134438		0
33127	1966	4027663	1990-04-18	1990-04-18 00:00:00	\N	\N	32020		\N	130737	0	13200003	4027663		0
33280	1975	40481087	1959-06-14	1959-06-14 00:00:00	1959-06-21	1959-06-21 00:00:00	32020		\N	131270	0	444814009	40481087		0
33502	1987	4112343	1952-09-06	1952-09-06 00:00:00	1952-09-17	1952-09-17 00:00:00	32020		\N	132317	0	195662009	4112343		0
33590	1991	260139	1988-08-19	1988-08-19 00:00:00	1988-08-26	1988-08-26 00:00:00	32020		\N	132633	0	10509002	260139		0
33760	2004	260139	1988-08-05	1988-08-05 00:00:00	1988-08-12	1988-08-12 00:00:00	32020		\N	133449	0	10509002	260139		0
33989	2020	40481087	2003-01-07	2003-01-07 00:00:00	2003-01-21	2003-01-21 00:00:00	32020		\N	134301	0	444814009	40481087		0
34137	2027	40481087	1985-07-21	1985-07-21 00:00:00	1985-08-11	1985-08-11 00:00:00	32020		\N	134870	0	444814009	40481087		0
34297	2034	40481087	1977-12-25	1977-12-25 00:00:00	1978-01-01	1978-01-01 00:00:00	32020		\N	135494	0	444814009	40481087		0
44990	2677	40481087	1988-01-29	1988-01-29 00:00:00	1988-02-05	1988-02-05 00:00:00	32020		\N	177418	0	444814009	40481087		0
34569	2052	28060	1987-03-26	1987-03-26 00:00:00	1987-04-07	1987-04-07 00:00:00	32020		\N	136408	0	43878008	28060		0
45344	2697	28060	2003-12-31	2003-12-31 00:00:00	2004-01-08	2004-01-08 00:00:00	32020		\N	178565	0	43878008	28060		0
35008	2078	4059173	1995-08-30	1995-08-30 00:00:00	1995-11-28	1995-11-28 00:00:00	32020		\N	138381	0	16114001	4059173		0
35073	2082	81151	1969-02-18	1969-02-18 00:00:00	1969-03-04	1969-03-04 00:00:00	32020		\N	138661	0	44465007	81151		0
35249	2088	192671	1945-04-25	1945-04-25 00:00:00	\N	\N	32020		\N	139175	0	K92.2	35208414		0
35516	2103	40481087	2009-02-04	2009-02-04 00:00:00	2009-02-25	2009-02-25 00:00:00	32020		\N	140152	0	444814009	40481087		0
35656	2114	260139	1996-05-06	1996-05-06 00:00:00	1996-05-13	1996-05-13 00:00:00	32020		\N	140676	0	10509002	260139		0
35773	2119	40481087	2013-04-18	2013-04-18 00:00:00	2013-04-25	2013-04-25 00:00:00	32020		\N	141037	0	444814009	40481087		0
35891	2127	4218389	1992-07-17	1992-07-17 00:00:00	1992-08-07	1992-08-07 00:00:00	32020		\N	141448	0	39848009	4218389		0
36139	2141	4112343	1973-10-24	1973-10-24 00:00:00	1973-11-02	1973-11-02 00:00:00	32020		\N	142661	0	195662009	4112343		0
36294	2150	4134304	1958-04-08	1958-04-08 00:00:00	1958-06-07	1958-06-07 00:00:00	32020		\N	143148	0	263102004	4134304		0
36491	2160	80180	1998-07-22	1998-07-22 00:00:00	\N	\N	32020		\N	143938	0	396275006	80180		0
36622	2167	40481087	1997-07-20	1997-07-20 00:00:00	1997-08-10	1997-08-10 00:00:00	32020		\N	144348	0	444814009	40481087		0
36777	2175	40481087	1984-06-12	1984-06-12 00:00:00	1984-07-03	1984-07-03 00:00:00	32020		\N	144995	0	444814009	40481087		0
36955	2186	372328	1975-05-14	1975-05-14 00:00:00	1975-07-17	1975-07-17 00:00:00	32020		\N	145771	0	65363002	372328		0
37029	2192	40481087	2003-03-11	2003-03-11 00:00:00	2003-04-01	2003-04-01 00:00:00	32020		\N	146181	0	444814009	40481087		0
37275	2207	40481087	1992-02-14	1992-02-14 00:00:00	1992-03-06	1992-03-06 00:00:00	32020		\N	147080	0	444814009	40481087		0
37465	2222	40481087	1964-01-28	1964-01-28 00:00:00	1964-02-11	1964-02-11 00:00:00	32020		\N	147889	0	444814009	40481087		0
37566	2228	4112343	1980-09-27	1980-09-27 00:00:00	1980-10-10	1980-10-10 00:00:00	32020		\N	148265	0	195662009	4112343		0
37720	2237	378001	1959-07-28	1959-07-28 00:00:00	1959-08-27	1959-08-27 00:00:00	32020		\N	148806	0	62106007	378001		0
37956	2250	260139	1973-02-11	1973-02-11 00:00:00	1973-02-18	1973-02-18 00:00:00	32020		\N	149695	0	10509002	260139		0
38174	2266	4113008	2006-12-07	2006-12-07 00:00:00	2006-12-21	2006-12-21 00:00:00	32020		\N	150638	0	284549007	4113008		0
38285	2274	4112343	2009-07-31	2009-07-31 00:00:00	2009-08-13	2009-08-13 00:00:00	32020		\N	151195	0	195662009	4112343		0
48990	2899	260139	2013-10-24	2013-10-24 00:00:00	2013-11-07	2013-11-07 00:00:00	32020		\N	193117	0	10509002	260139		0
38666	2294	40481087	1995-02-05	1995-02-05 00:00:00	1995-02-26	1995-02-26 00:00:00	32020		\N	152705	0	444814009	40481087		0
38768	2300	372328	2017-07-03	2017-07-03 00:00:00	2018-04-05	2018-04-05 00:00:00	32020		\N	153168	0	65363002	372328		0
38956	2315	372328	1989-10-09	1989-10-09 00:00:00	1990-10-06	1990-10-06 00:00:00	32020		\N	153929	0	65363002	372328		0
39168	2326	81151	1991-10-02	1991-10-02 00:00:00	1991-11-06	1991-11-06 00:00:00	32020		\N	154721	0	44465007	81151		0
39213	2328	4112343	1980-01-13	1980-01-13 00:00:00	1980-01-23	1980-01-23 00:00:00	32020		\N	154816	0	195662009	4112343		0
39473	2339	260139	2013-11-16	2013-11-16 00:00:00	2013-11-23	2013-11-23 00:00:00	32020		\N	155632	0	10509002	260139		0
39546	2343	260139	1990-07-11	1990-07-11 00:00:00	1990-07-25	1990-07-25 00:00:00	32020		\N	155935	0	10509002	260139		0
39788	2356	80180	2017-02-10	2017-02-10 00:00:00	\N	\N	32020		\N	156898	0	396275006	80180		0
39951	2367	260139	1986-09-20	1986-09-20 00:00:00	1986-10-04	1986-10-04 00:00:00	32020		\N	157550	0	10509002	260139		0
40044	2373	4142905	1957-10-10	1957-10-10 00:00:00	1958-01-08	1958-01-08 00:00:00	32020		\N	157944	0	33737001	4142905		0
40262	2389	30753	2007-12-13	2007-12-13 00:00:00	\N	\N	32020		\N	158847	0	16761005	30753		0
40366	2395	40481087	2003-01-02	2003-01-02 00:00:00	2003-01-16	2003-01-16 00:00:00	32020		\N	159222	0	444814009	40481087		0
40610	2414	260139	1978-07-25	1978-07-25 00:00:00	1978-08-08	1978-08-08 00:00:00	32020		\N	160221	0	10509002	260139		0
40785	2425	4294548	1978-06-25	1978-06-25 00:00:00	1978-10-08	1978-10-08 00:00:00	32020		\N	160876	0	75498004	4294548		0
40947	2436	40481087	2009-09-11	2009-09-11 00:00:00	2009-09-18	2009-09-18 00:00:00	32020		\N	161453	0	444814009	40481087		0
51661	3064	260139	1995-01-03	1995-01-03 00:00:00	1995-01-10	1995-01-10 00:00:00	32020		\N	203941	0	10509002	260139		0
41304	2456	4112343	2016-09-23	2016-09-23 00:00:00	2016-10-02	2016-10-02 00:00:00	32020		\N	162773	0	195662009	4112343		0
41431	2463	372328	1971-06-29	1971-06-29 00:00:00	1971-09-16	1971-09-16 00:00:00	32020		\N	163386	0	65363002	372328		0
41621	2476	40481087	2013-08-07	2013-08-07 00:00:00	2013-08-21	2013-08-21 00:00:00	32020		\N	164064	0	444814009	40481087		0
41735	2483	372328	1945-03-29	1945-03-29 00:00:00	1945-05-12	1945-05-12 00:00:00	32020		\N	164526	0	65363002	372328		0
52478	3109	4112343	1928-11-18	1928-11-18 00:00:00	1928-11-27	1928-11-27 00:00:00	32020		\N	206792	0	195662009	4112343		0
52634	3117	40481087	1982-11-19	1982-11-19 00:00:00	1982-11-26	1982-11-26 00:00:00	32020		\N	207368	0	444814009	40481087		0
52819	3128	4218389	2009-05-28	2009-05-28 00:00:00	2009-06-25	2009-06-25 00:00:00	32020		\N	208171	0	39848009	4218389		0
52963	3135	4112343	1993-05-06	1993-05-06 00:00:00	1993-05-17	1993-05-17 00:00:00	32020		\N	208648	0	195662009	4112343		0
32016	1902	192671	1985-11-17	1985-11-17 00:00:00	\N	\N	32020		\N	126608	0	K92.2	35208414		0
42681	2543	40481087	2016-07-20	2016-07-20 00:00:00	2016-07-27	2016-07-27 00:00:00	32020		\N	168223	0	444814009	40481087		0
32338	1921	40481087	1992-09-23	1992-09-23 00:00:00	1992-09-30	1992-09-30 00:00:00	32020		\N	127745	0	444814009	40481087		0
32503	1928	4112343	1998-09-26	1998-09-26 00:00:00	1998-10-06	1998-10-06 00:00:00	32020		\N	128312	0	195662009	4112343		0
32561	1934	372328	1965-09-06	1965-09-06 00:00:00	1966-01-15	1966-01-15 00:00:00	32020		\N	128627	0	65363002	372328		0
32866	1950	4112343	1978-05-10	1978-05-10 00:00:00	1978-05-23	1978-05-23 00:00:00	32020		\N	129625	0	195662009	4112343		0
32926	1953	372328	1956-08-28	1956-08-28 00:00:00	1957-01-14	1957-01-14 00:00:00	32020		\N	129870	0	65363002	372328		0
33128	1966	40481087	2006-05-16	2006-05-16 00:00:00	2006-05-30	2006-05-30 00:00:00	32020		\N	130701	0	444814009	40481087		0
33281	1975	28060	1932-07-22	1932-07-22 00:00:00	1932-07-29	1932-07-29 00:00:00	32020		\N	131268	0	43878008	28060		0
33503	1987	81151	2012-04-29	2012-04-29 00:00:00	2012-05-20	2012-05-20 00:00:00	32020		\N	132292	0	44465007	81151		0
33591	1991	40481087	2004-01-19	2004-01-19 00:00:00	2004-02-09	2004-02-09 00:00:00	32020		\N	132635	0	444814009	40481087		0
33761	2004	40481087	1971-09-06	1971-09-06 00:00:00	1971-09-20	1971-09-20 00:00:00	32020		\N	133475	0	444814009	40481087		0
33990	2020	4112343	1974-05-15	1974-05-15 00:00:00	1974-05-24	1974-05-24 00:00:00	32020		\N	134267	0	195662009	4112343		0
34138	2027	40481087	1965-10-27	1965-10-27 00:00:00	1965-11-10	1965-11-10 00:00:00	32020		\N	134868	0	444814009	40481087		0
34298	2034	4112343	2012-03-05	2012-03-05 00:00:00	2012-03-17	2012-03-17 00:00:00	32020		\N	135416	0	195662009	4112343		0
44991	2677	40481087	1986-06-27	1986-06-27 00:00:00	1986-07-04	1986-07-04 00:00:00	32020		\N	177366	0	444814009	40481087		0
34570	2052	260139	2013-02-02	2013-02-02 00:00:00	2013-02-09	2013-02-09 00:00:00	32020		\N	136409	0	10509002	260139		0
45345	2697	40481087	1974-02-26	1974-02-26 00:00:00	1974-03-19	1974-03-19 00:00:00	32020		\N	178561	0	444814009	40481087		0
35009	2078	40481087	1982-08-17	1982-08-17 00:00:00	1982-08-24	1982-08-24 00:00:00	32020		\N	138427	0	444814009	40481087		0
35074	2082	40481087	1943-07-05	1943-07-05 00:00:00	1943-07-19	1943-07-19 00:00:00	32020		\N	138711	0	444814009	40481087		0
35250	2088	260139	1983-06-11	1983-06-11 00:00:00	1983-06-25	1983-06-25 00:00:00	32020		\N	139230	0	10509002	260139		0
35517	2103	260139	1982-03-03	1982-03-03 00:00:00	1982-03-17	1982-03-17 00:00:00	32020		\N	140161	0	10509002	260139		0
35657	2114	321042	1988-06-15	1988-06-15 00:00:00	\N	\N	32020		\N	140683	0	410429000	321042		0
35774	2119	260139	1976-04-25	1976-04-25 00:00:00	1976-05-02	1976-05-02 00:00:00	32020		\N	141001	0	10509002	260139		0
35892	2127	40481087	1966-05-10	1966-05-10 00:00:00	1966-05-17	1966-05-17 00:00:00	32020		\N	141487	0	444814009	40481087		0
36140	2141	40481087	1958-05-03	1958-05-03 00:00:00	1958-05-10	1958-05-10 00:00:00	32020		\N	142651	0	444814009	40481087		0
36295	2150	40481087	1961-02-17	1961-02-17 00:00:00	1961-02-24	1961-02-24 00:00:00	32020		\N	143200	0	444814009	40481087		0
36492	2160	195588	1993-07-03	1993-07-03 00:00:00	1993-08-12	1993-08-12 00:00:00	32020		\N	143982	0	38822007	195588		0
36623	2167	40481087	1992-12-07	1992-12-07 00:00:00	1992-12-14	1992-12-14 00:00:00	32020		\N	144391	0	444814009	40481087		0
36778	2175	195588	1992-01-25	1992-01-25 00:00:00	1992-03-13	1992-03-13 00:00:00	32020		\N	145002	0	38822007	195588		0
36956	2186	30753	2013-10-21	2013-10-21 00:00:00	\N	\N	32020		\N	145783	0	16761005	30753		0
37030	2192	260139	1972-04-23	1972-04-23 00:00:00	1972-04-30	1972-04-30 00:00:00	32020		\N	146207	0	10509002	260139		0
37276	2207	260139	2010-02-08	2010-02-08 00:00:00	2010-02-15	2010-02-15 00:00:00	32020		\N	147057	0	10509002	260139		0
37466	2222	4152936	1992-08-19	1992-08-19 00:00:00	1992-09-09	1992-09-09 00:00:00	32020		\N	147957	0	283385000	4152936		0
37567	2228	40481087	2017-04-19	2017-04-19 00:00:00	2017-04-26	2017-04-26 00:00:00	32020		\N	148215	0	444814009	40481087		0
37721	2237	28060	1955-10-18	1955-10-18 00:00:00	1955-10-31	1955-10-31 00:00:00	32020		\N	148760	0	43878008	28060		0
37985	2256	4142905	1990-06-07	1990-06-07 00:00:00	1990-07-07	1990-07-07 00:00:00	32020		\N	149937	0	33737001	4142905		0
38175	2266	372328	1971-12-11	1971-12-11 00:00:00	1972-05-20	1972-05-20 00:00:00	32020		\N	150627	0	65363002	372328		0
38286	2274	40481087	1980-04-18	1980-04-18 00:00:00	1980-05-09	1980-05-09 00:00:00	32020		\N	151169	0	444814009	40481087		0
48991	2899	28060	1955-12-06	1955-12-06 00:00:00	1955-12-15	1955-12-15 00:00:00	32020		\N	193114	0	43878008	28060		0
38667	2294	40481087	2010-11-08	2010-11-08 00:00:00	2010-11-29	2010-11-29 00:00:00	32020		\N	152707	0	444814009	40481087		0
38769	2300	4112343	1977-05-26	1977-05-26 00:00:00	1977-06-05	1977-06-05 00:00:00	32020		\N	153184	0	195662009	4112343		0
38957	2315	260139	2018-10-30	2018-10-30 00:00:00	2018-11-13	2018-11-13 00:00:00	32020		\N	153920	0	10509002	260139		0
39169	2326	30753	1992-07-22	1992-07-22 00:00:00	\N	\N	32020		\N	154721	0	16761005	30753		0
39214	2328	372328	1955-08-23	1955-08-23 00:00:00	1955-12-05	1955-12-05 00:00:00	32020		\N	154823	0	65363002	372328		0
39474	2339	4084167	1983-05-27	1983-05-27 00:00:00	1983-05-27	1983-05-27 00:00:00	32020		\N	155677	0	241929008	4084167		0
39547	2343	40481087	1988-09-23	1988-09-23 00:00:00	1988-10-14	1988-10-14 00:00:00	32020		\N	155952	0	444814009	40481087		0
39789	2356	4285898	2016-03-17	2016-03-17 00:00:00	\N	\N	32020		\N	156898	0	68496003	4285898		0
39952	2367	4283893	2013-08-30	2013-08-30 00:00:00	2013-10-11	2013-10-11 00:00:00	32020		\N	157577	0	36971009	4283893		0
40045	2373	257012	1970-09-08	1970-09-08 00:00:00	1992-12-03	1992-12-03 00:00:00	32020		\N	157897	0	40055000	257012		0
40263	2389	4112343	2007-10-25	2007-10-25 00:00:00	2007-11-04	2007-11-04 00:00:00	32020		\N	158847	0	195662009	4112343		0
40367	2395	80180	1996-06-23	1996-06-23 00:00:00	\N	\N	32020		\N	159232	0	396275006	80180		0
40611	2414	260139	1954-05-30	1954-05-30 00:00:00	1954-06-13	1954-06-13 00:00:00	32020		\N	160168	0	10509002	260139		0
40786	2425	4112343	1994-08-22	1994-08-22 00:00:00	1994-08-31	1994-08-31 00:00:00	32020		\N	160915	0	195662009	4112343		0
40948	2436	260139	1919-07-09	1919-07-09 00:00:00	1919-07-23	1919-07-23 00:00:00	32020		\N	161450	0	10509002	260139		0
51662	3064	440086	1949-09-29	1949-09-29 00:00:00	1951-05-17	1951-05-17 00:00:00	32020		\N	203958	0	192127007	440086		0
41305	2456	372328	1956-05-18	1956-05-18 00:00:00	1956-07-01	1956-07-01 00:00:00	32020		\N	162812	0	65363002	372328		0
41432	2463	40481087	1989-06-01	1989-06-01 00:00:00	1989-06-15	1989-06-15 00:00:00	32020		\N	163383	0	444814009	40481087		0
41622	2476	40481087	1989-10-27	1989-10-27 00:00:00	1989-11-03	1989-11-03 00:00:00	32020		\N	164062	0	444814009	40481087		0
41736	2483	192671	1984-11-07	1984-11-07 00:00:00	\N	\N	32020		\N	164533	0	K92.2	35208414		0
52479	3109	40481087	1941-10-20	1941-10-20 00:00:00	1941-11-10	1941-11-10 00:00:00	32020		\N	206734	0	444814009	40481087		0
52635	3117	4112343	1995-12-08	1995-12-08 00:00:00	1995-12-18	1995-12-18 00:00:00	32020		\N	207369	0	195662009	4112343		0
52820	3128	4051466	1976-07-30	1976-07-30 00:00:00	1992-11-04	1992-11-04 00:00:00	32020		\N	208195	0	233678006	4051466		0
52964	3135	192671	2005-11-30	2005-11-30 00:00:00	\N	\N	32020		\N	208694	0	K92.2	35208414		0
32017	1902	260139	2012-01-29	2012-01-29 00:00:00	2012-02-12	2012-02-12 00:00:00	32020		\N	126649	0	10509002	260139		0
42682	2543	40481087	1979-08-05	1979-08-05 00:00:00	1979-08-12	1979-08-12 00:00:00	32020		\N	168250	0	444814009	40481087		0
32339	1921	260139	1965-08-20	1965-08-20 00:00:00	1965-08-27	1965-08-27 00:00:00	32020		\N	127720	0	10509002	260139		0
32504	1928	260139	1980-06-09	1980-06-09 00:00:00	1980-06-16	1980-06-16 00:00:00	32020		\N	128334	0	10509002	260139		0
32562	1934	4094814	1985-08-16	1985-08-16 00:00:00	1985-10-15	1985-10-15 00:00:00	32020		\N	128622	0	262574004	4094814		0
32867	1950	40481087	2008-11-05	2008-11-05 00:00:00	2008-11-12	2008-11-12 00:00:00	32020		\N	129628	0	444814009	40481087		0
32927	1953	4146173	1980-06-23	1980-06-23 00:00:00	1980-08-22	1980-08-22 00:00:00	32020		\N	129904	0	307731004	4146173		0
33129	1966	4112343	1991-12-10	1991-12-10 00:00:00	1991-12-23	1991-12-23 00:00:00	32020		\N	130672	0	195662009	4112343		0
33282	1975	80180	1957-04-23	1957-04-23 00:00:00	\N	\N	32020		\N	131282	0	396275006	80180		0
33504	1987	372328	1945-06-03	1945-06-03 00:00:00	1945-11-16	1945-11-16 00:00:00	32020		\N	132332	0	65363002	372328		0
33592	1991	81151	1946-11-24	1946-11-24 00:00:00	1946-12-15	1946-12-15 00:00:00	32020		\N	132606	0	44465007	81151		0
33762	2004	40481087	1990-02-25	1990-02-25 00:00:00	1990-03-04	1990-03-04 00:00:00	32020		\N	133442	0	444814009	40481087		0
33991	2020	372328	1973-07-17	1973-07-17 00:00:00	1973-10-06	1973-10-06 00:00:00	32020		\N	134247	0	65363002	372328		0
34139	2027	4112343	2013-05-08	2013-05-08 00:00:00	2013-05-17	2013-05-17 00:00:00	32020		\N	134874	0	195662009	4112343		0
34299	2034	40481087	1955-04-27	1955-04-27 00:00:00	1955-05-11	1955-05-11 00:00:00	32020		\N	135448	0	444814009	40481087		0
44992	2677	134438	2000-04-15	2000-04-15 00:00:00	2001-06-09	2001-06-09 00:00:00	32020		\N	177371	0	40275004	134438		0
34571	2052	260139	1978-05-04	1978-05-04 00:00:00	1978-05-18	1978-05-18 00:00:00	32020		\N	136439	0	10509002	260139		0
45346	2697	440086	1944-04-17	1944-04-17 00:00:00	1951-04-26	1951-04-26 00:00:00	32020		\N	178606	0	192127007	440086		0
35010	2078	40481087	1983-01-30	1983-01-30 00:00:00	1983-02-20	1983-02-20 00:00:00	32020		\N	138392	0	444814009	40481087		0
35075	2082	4035415	1997-04-06	1997-04-06 00:00:00	1997-05-06	1997-05-06 00:00:00	32020		\N	138717	0	239720000	4035415		0
35251	2088	40481087	1982-11-09	1982-11-09 00:00:00	1982-11-23	1982-11-23 00:00:00	32020		\N	139265	0	444814009	40481087		0
35518	2103	4134304	1991-06-17	1991-06-17 00:00:00	1991-08-16	1991-08-16 00:00:00	32020		\N	140123	0	263102004	4134304		0
35659	2114	40481087	1980-07-16	1980-07-16 00:00:00	1980-07-30	1980-07-30 00:00:00	32020		\N	140670	0	444814009	40481087		0
35775	2119	28060	1961-10-13	1961-10-13 00:00:00	1961-10-24	1961-10-24 00:00:00	32020		\N	140998	0	43878008	28060		0
35916	2130	260139	1994-05-13	1994-05-13 00:00:00	1994-05-27	1994-05-27 00:00:00	32020		\N	141729	0	10509002	260139		0
36141	2141	4112343	1947-11-04	1947-11-04 00:00:00	1947-11-14	1947-11-14 00:00:00	32020		\N	142653	0	195662009	4112343		0
36296	2150	372328	1951-07-14	1951-07-14 00:00:00	1951-12-28	1951-12-28 00:00:00	32020		\N	143171	0	65363002	372328		0
36493	2160	372328	1963-07-13	1963-07-13 00:00:00	1963-12-16	1963-12-16 00:00:00	32020		\N	143969	0	65363002	372328		0
36624	2167	192671	2017-10-03	2017-10-03 00:00:00	\N	\N	32020		\N	144363	0	K92.2	35208414		0
36779	2176	372328	1960-08-13	1960-08-13 00:00:00	1961-07-24	1961-07-24 00:00:00	32020		\N	145163	0	65363002	372328		0
36957	2186	4285898	2014-04-19	2014-04-19 00:00:00	\N	\N	32020		\N	145783	0	68496003	4285898		0
37031	2192	4112343	1996-11-16	1996-11-16 00:00:00	1996-11-26	1996-11-26 00:00:00	32020		\N	146198	0	195662009	4112343		0
37277	2207	4112343	2010-09-29	2010-09-29 00:00:00	2010-10-12	2010-10-12 00:00:00	32020		\N	147102	0	195662009	4112343		0
37467	2222	40481087	1968-12-24	1968-12-24 00:00:00	1968-12-31	1968-12-31 00:00:00	32020		\N	147906	0	444814009	40481087		0
37568	2228	40481087	2014-02-27	2014-02-27 00:00:00	2014-03-20	2014-03-20 00:00:00	32020		\N	148277	0	444814009	40481087		0
37722	2237	40481087	1959-01-16	1959-01-16 00:00:00	1959-01-23	1959-01-23 00:00:00	32020		\N	148810	0	444814009	40481087		0
37986	2256	260139	1992-02-23	1992-02-23 00:00:00	1992-03-08	1992-03-08 00:00:00	32020		\N	149916	0	10509002	260139		0
38176	2266	372328	1969-06-12	1969-06-12 00:00:00	1969-08-23	1969-08-23 00:00:00	32020		\N	150626	0	65363002	372328		0
38287	2274	4113008	1976-02-02	1976-02-02 00:00:00	1976-02-16	1976-02-16 00:00:00	32020		\N	151209	0	284549007	4113008		0
48992	2899	260139	1960-08-29	1960-08-29 00:00:00	1960-09-12	1960-09-12 00:00:00	32020		\N	193171	0	10509002	260139		0
38668	2294	4112343	1981-05-15	1981-05-15 00:00:00	1981-05-26	1981-05-26 00:00:00	32020		\N	152703	0	195662009	4112343		0
38770	2300	4294548	1987-01-08	1987-01-08 00:00:00	1987-01-29	1987-01-29 00:00:00	32020		\N	153176	0	75498004	4294548		0
38958	2315	260139	2002-03-31	2002-03-31 00:00:00	2002-04-07	2002-04-07 00:00:00	32020		\N	153918	0	10509002	260139		0
39170	2326	260139	1988-10-14	1988-10-14 00:00:00	1988-10-28	1988-10-28 00:00:00	32020		\N	154661	0	10509002	260139		0
39215	2328	4027663	1988-09-18	1988-09-18 00:00:00	\N	\N	32020		\N	154819	0	13200003	4027663		0
39475	2339	80180	2006-04-01	2006-04-01 00:00:00	\N	\N	32020		\N	155616	0	396275006	80180		0
39548	2343	192671	1996-02-10	1996-02-10 00:00:00	\N	\N	32020		\N	156016	0	K92.2	35208414		0
39790	2356	4266809	2017-02-10	2017-02-10 00:00:00	\N	\N	32020		\N	156898	0	397881000	4266809		0
39953	2367	80180	2016-04-06	2016-04-06 00:00:00	\N	\N	32020		\N	157570	0	396275006	80180		0
40046	2373	40481087	2003-10-14	2003-10-14 00:00:00	2003-11-04	2003-11-04 00:00:00	32020		\N	157941	0	444814009	40481087		0
40264	2389	80180	2008-08-09	2008-08-09 00:00:00	\N	\N	32020		\N	158847	0	396275006	80180		0
40368	2395	4112343	2015-07-27	2015-07-27 00:00:00	2015-08-07	2015-08-07 00:00:00	32020		\N	159223	0	195662009	4112343		0
40612	2414	4112343	1965-02-06	1965-02-06 00:00:00	1965-02-16	1965-02-16 00:00:00	32020		\N	160197	0	195662009	4112343		0
40787	2425	81151	2003-01-08	2003-01-08 00:00:00	2003-01-22	2003-01-22 00:00:00	32020		\N	160874	0	44465007	81151		0
40949	2436	4237458	1963-02-11	1963-02-11 00:00:00	1963-04-12	1963-04-12 00:00:00	32020		\N	161574	0	58150001	4237458		0
51663	3064	4152936	1980-05-03	1980-05-03 00:00:00	1980-05-24	1980-05-24 00:00:00	32020		\N	203999	0	283385000	4152936		0
41306	2456	4283893	1997-07-06	1997-07-06 00:00:00	1997-08-03	1997-08-03 00:00:00	32020		\N	162781	0	36971009	4283893		0
41433	2463	4294548	1979-07-22	1979-07-22 00:00:00	1979-08-05	1979-08-05 00:00:00	32020		\N	163382	0	75498004	4294548		0
41623	2476	40481087	2000-01-18	2000-01-18 00:00:00	2000-02-08	2000-02-08 00:00:00	32020		\N	164072	0	444814009	40481087		0
41737	2483	28060	1981-04-06	1981-04-06 00:00:00	1981-04-16	1981-04-16 00:00:00	32020		\N	164491	0	43878008	28060		0
52480	3109	81151	1956-12-03	1956-12-03 00:00:00	1956-12-24	1956-12-24 00:00:00	32020		\N	206706	0	44465007	81151		0
52636	3117	372328	2005-03-16	2005-03-16 00:00:00	2008-02-27	2008-02-27 00:00:00	32020		\N	207392	0	65363002	372328		0
52821	3128	4048171	1978-07-30	1978-07-30 00:00:00	\N	\N	32020		\N	208197	0	232353008	4048171		0
52965	3135	4112343	1986-02-21	1986-02-21 00:00:00	1986-02-28	1986-02-28 00:00:00	32020		\N	208667	0	195662009	4112343		0
32018	1902	4112343	1960-11-14	1960-11-14 00:00:00	1960-11-26	1960-11-26 00:00:00	32020		\N	126635	0	195662009	4112343		0
42683	2543	4112343	1993-11-11	1993-11-11 00:00:00	1993-11-21	1993-11-21 00:00:00	32020		\N	168252	0	195662009	4112343		0
32354	1923	40481087	2011-08-09	2011-08-09 00:00:00	2011-08-23	2011-08-23 00:00:00	32020		\N	127923	0	444814009	40481087		0
32505	1928	4112343	1979-04-27	1979-04-27 00:00:00	1979-05-05	1979-05-05 00:00:00	32020		\N	128346	0	195662009	4112343		0
32563	1934	372328	1961-05-24	1961-05-24 00:00:00	1961-07-08	1961-07-08 00:00:00	32020		\N	128650	0	65363002	372328		0
32868	1950	260139	2017-02-03	2017-02-03 00:00:00	2017-02-10	2017-02-10 00:00:00	32020		\N	129632	0	10509002	260139		0
32928	1953	4112343	1969-08-21	1969-08-21 00:00:00	1969-08-29	1969-08-29 00:00:00	32020		\N	129902	0	195662009	4112343		0
33130	1966	4149245	2010-04-30	2010-04-30 00:00:00	2010-07-06	2010-07-06 00:00:00	32020		\N	130740	0	30832001	4149245		0
33283	1975	81151	1924-10-28	1924-10-28 00:00:00	1924-11-11	1924-11-11 00:00:00	32020		\N	131308	0	44465007	81151		0
33505	1987	4112343	1968-07-15	1968-07-15 00:00:00	1968-07-24	1968-07-24 00:00:00	32020		\N	132336	0	195662009	4112343		0
33593	1991	372328	1946-04-28	1946-04-28 00:00:00	1946-09-16	1946-09-16 00:00:00	32020		\N	132615	0	65363002	372328		0
33763	2004	81151	1987-01-08	1987-01-08 00:00:00	1987-02-12	1987-02-12 00:00:00	32020		\N	133463	0	44465007	81151		0
33992	2020	4112343	1999-11-27	1999-11-27 00:00:00	1999-12-07	1999-12-07 00:00:00	32020		\N	134246	0	195662009	4112343		0
34140	2027	40481087	2011-09-15	2011-09-15 00:00:00	2011-09-29	2011-09-29 00:00:00	32020		\N	134873	0	444814009	40481087		0
34300	2034	28060	1991-07-28	1991-07-28 00:00:00	1991-08-09	1991-08-09 00:00:00	32020		\N	135462	0	43878008	28060		0
44993	2677	80180	2006-11-27	2006-11-27 00:00:00	\N	\N	32020		\N	177387	0	396275006	80180		0
34572	2052	260139	2015-03-03	2015-03-03 00:00:00	2015-03-10	2015-03-10 00:00:00	32020		\N	136414	0	10509002	260139		0
45347	2697	4283893	1944-06-29	1944-06-29 00:00:00	1944-08-03	1944-08-03 00:00:00	32020		\N	178569	0	36971009	4283893		0
35011	2078	4142905	2019-01-24	2019-01-24 00:00:00	2019-03-25	2019-03-25 00:00:00	32020		\N	138385	0	33737001	4142905		0
35076	2082	40481087	1967-07-05	1967-07-05 00:00:00	1967-07-12	1967-07-12 00:00:00	32020		\N	138676	0	444814009	40481087		0
35252	2088	260139	1972-07-10	1972-07-10 00:00:00	1972-07-24	1972-07-24 00:00:00	32020		\N	139261	0	10509002	260139		0
35524	2105	81151	1994-07-04	1994-07-04 00:00:00	1994-07-18	1994-07-18 00:00:00	32020		\N	140214	0	44465007	81151		0
35660	2114	4112343	2016-10-11	2016-10-11 00:00:00	2016-10-21	2016-10-21 00:00:00	32020		\N	140646	0	195662009	4112343		0
35776	2119	4156265	2018-12-13	2018-12-13 00:00:00	2019-01-03	2019-01-03 00:00:00	32020		\N	140977	0	370247008	4156265		0
35917	2130	80180	1996-05-12	1996-05-12 00:00:00	\N	\N	32020		\N	141729	0	396275006	80180		0
36142	2141	40481087	1955-01-28	1955-01-28 00:00:00	1955-02-11	1955-02-11 00:00:00	32020		\N	142638	0	444814009	40481087		0
36297	2150	4310024	1983-12-08	1983-12-08 00:00:00	\N	\N	32020		\N	143177	0	424802006	4310024		0
36494	2160	40481087	2012-01-18	2012-01-18 00:00:00	2012-02-08	2012-02-08 00:00:00	32020		\N	143986	0	444814009	40481087		0
36625	2167	260139	1993-07-26	1993-07-26 00:00:00	1993-08-09	1993-08-09 00:00:00	32020		\N	144346	0	10509002	260139		0
36780	2176	40481087	2016-12-25	2016-12-25 00:00:00	2017-01-15	2017-01-15 00:00:00	32020		\N	145108	0	444814009	40481087		0
36958	2186	80180	2014-10-16	2014-10-16 00:00:00	\N	\N	32020		\N	145783	0	396275006	80180		0
37032	2192	372328	1957-06-22	1957-06-22 00:00:00	1957-11-21	1957-11-21 00:00:00	32020		\N	146182	0	65363002	372328		0
37278	2207	4310024	2011-09-14	2011-09-14 00:00:00	\N	\N	32020		\N	147102	0	424802006	4310024		0
37468	2222	40481087	1992-01-22	1992-01-22 00:00:00	1992-01-29	1992-01-29 00:00:00	32020		\N	147932	0	444814009	40481087		0
37569	2228	28060	1950-12-01	1950-12-01 00:00:00	1950-12-09	1950-12-09 00:00:00	32020		\N	148280	0	43878008	28060		0
37723	2237	40481087	1959-07-30	1959-07-30 00:00:00	1959-08-13	1959-08-13 00:00:00	32020		\N	148761	0	444814009	40481087		0
37987	2256	4296204	2004-12-20	2004-12-20 00:00:00	2005-01-03	2005-01-03 00:00:00	32020		\N	149938	0	403190006	4296204		0
38177	2266	81151	1993-03-29	1993-03-29 00:00:00	1993-04-19	1993-04-19 00:00:00	32020		\N	150636	0	44465007	81151		0
38288	2274	28060	1954-10-25	1954-10-25 00:00:00	1954-11-06	1954-11-06 00:00:00	32020		\N	151189	0	43878008	28060		0
48993	2899	260139	2017-08-27	2017-08-27 00:00:00	2017-09-10	2017-09-10 00:00:00	32020		\N	193183	0	10509002	260139		0
38669	2294	4155034	1961-11-20	1961-11-20 00:00:00	1961-12-11	1961-12-11 00:00:00	32020		\N	152747	0	283371005	4155034		0
38771	2300	4112343	1975-04-26	1975-04-26 00:00:00	1975-05-05	1975-05-05 00:00:00	32020		\N	153183	0	195662009	4112343		0
38959	2315	40481087	1995-10-20	1995-10-20 00:00:00	1995-11-10	1995-11-10 00:00:00	32020		\N	153928	0	444814009	40481087		0
39171	2326	4112343	1966-11-19	1966-11-19 00:00:00	1966-11-29	1966-11-29 00:00:00	32020		\N	154645	0	195662009	4112343		0
39216	2328	40481087	1988-07-08	1988-07-08 00:00:00	1988-07-15	1988-07-15 00:00:00	32020		\N	154819	0	444814009	40481087		0
39476	2339	40481087	1978-10-29	1978-10-29 00:00:00	1978-11-05	1978-11-05 00:00:00	32020		\N	155589	0	444814009	40481087		0
39549	2343	40481087	2013-12-31	2013-12-31 00:00:00	2014-01-14	2014-01-14 00:00:00	32020		\N	155954	0	444814009	40481087		0
39791	2356	4112343	1983-01-08	1983-01-08 00:00:00	1983-01-20	1983-01-20 00:00:00	32020		\N	156864	0	195662009	4112343		0
39954	2367	257012	2013-10-04	2013-10-04 00:00:00	\N	\N	32020		\N	157578	0	40055000	257012		0
40096	2380	4112343	1981-09-27	1981-09-27 00:00:00	1981-10-06	1981-10-06 00:00:00	32020		\N	158186	0	195662009	4112343		0
40265	2389	257012	1986-10-06	1986-10-06 00:00:00	\N	\N	32020		\N	158888	0	40055000	257012		0
40369	2395	375671	1993-07-26	1993-07-26 00:00:00	1993-08-25	1993-08-25 00:00:00	32020		\N	159241	0	62564004	375671		0
40613	2414	4296204	1970-09-12	1970-09-12 00:00:00	1970-10-17	1970-10-17 00:00:00	32020		\N	160250	0	403190006	4296204		0
40788	2425	4112343	1977-04-12	1977-04-12 00:00:00	1977-04-21	1977-04-21 00:00:00	32020		\N	160943	0	195662009	4112343		0
40950	2436	81151	1957-07-21	1957-07-21 00:00:00	1957-08-11	1957-08-11 00:00:00	32020		\N	161573	0	44465007	81151		0
51664	3064	4112343	1938-09-19	1938-09-19 00:00:00	1938-09-27	1938-09-27 00:00:00	32020		\N	203952	0	195662009	4112343		0
41307	2456	40481087	2002-03-14	2002-03-14 00:00:00	2002-03-28	2002-03-28 00:00:00	32020		\N	162829	0	444814009	40481087		0
41434	2463	4112343	1975-10-08	1975-10-08 00:00:00	1975-10-17	1975-10-17 00:00:00	32020		\N	163384	0	195662009	4112343		0
41624	2476	4112343	1982-10-13	1982-10-13 00:00:00	1982-10-21	1982-10-21 00:00:00	32020		\N	164101	0	195662009	4112343		0
41738	2483	4113008	1961-02-17	1961-02-17 00:00:00	1961-03-10	1961-03-10 00:00:00	32020		\N	164511	0	284549007	4113008		0
52481	3109	372328	1921-06-13	1921-06-13 00:00:00	1921-11-16	1921-11-16 00:00:00	32020		\N	206760	0	65363002	372328		0
52637	3117	28060	1981-08-01	1981-08-01 00:00:00	1981-08-11	1981-08-11 00:00:00	32020		\N	207367	0	43878008	28060		0
52822	3128	40481087	1977-06-09	1977-06-09 00:00:00	1977-06-23	1977-06-23 00:00:00	32020		\N	208097	0	444814009	40481087		0
52966	3135	40481087	2010-12-16	2010-12-16 00:00:00	2010-12-30	2010-12-30 00:00:00	32020		\N	208650	0	444814009	40481087		0
32019	1902	372328	1949-09-20	1949-09-20 00:00:00	1949-11-13	1949-11-13 00:00:00	32020		\N	126596	0	65363002	372328		0
42684	2543	40481087	2017-02-28	2017-02-28 00:00:00	2017-03-14	2017-03-14 00:00:00	32020		\N	168282	0	444814009	40481087		0
32355	1923	28060	1946-08-09	1946-08-09 00:00:00	1946-08-16	1946-08-16 00:00:00	32020		\N	127951	0	43878008	28060		0
32506	1929	40481087	1962-11-11	1962-11-11 00:00:00	1962-12-02	1962-12-02 00:00:00	32020		\N	128408	0	444814009	40481087		0
32564	1934	4112343	1992-07-24	1992-07-24 00:00:00	1992-08-06	1992-08-06 00:00:00	32020		\N	128652	0	195662009	4112343		0
43327	2580	372328	1961-04-24	1961-04-24 00:00:00	1961-05-15	1961-05-15 00:00:00	32020		\N	170931	0	65363002	372328		0
32929	1953	80180	1998-03-11	1998-03-11 00:00:00	\N	\N	32020		\N	129900	0	396275006	80180		0
33131	1966	372328	1966-10-02	1966-10-02 00:00:00	1967-04-11	1967-04-11 00:00:00	32020		\N	130705	0	65363002	372328		0
33284	1975	440086	1936-02-08	1936-02-08 00:00:00	1940-02-17	1940-02-17 00:00:00	32020		\N	131263	0	192127007	440086		0
33506	1987	4112343	2001-10-17	2001-10-17 00:00:00	2001-10-24	2001-10-24 00:00:00	32020		\N	132358	0	195662009	4112343		0
33594	1991	4112343	1991-11-19	1991-11-19 00:00:00	1991-11-29	1991-11-29 00:00:00	32020		\N	132634	0	195662009	4112343		0
33764	2004	260139	2002-01-04	2002-01-04 00:00:00	2002-01-13	2002-01-13 00:00:00	32020		\N	133473	0	10509002	260139		0
33993	2020	28060	1983-12-06	1983-12-06 00:00:00	1983-12-19	1983-12-19 00:00:00	32020		\N	134278	0	43878008	28060		0
34141	2027	372328	1965-09-06	1965-09-06 00:00:00	1965-11-05	1965-11-05 00:00:00	32020		\N	134875	0	65363002	372328		0
34301	2034	381316	2018-01-17	2018-01-17 00:00:00	\N	\N	32020		\N	135443	0	230690007	381316		0
44994	2677	4266809	2006-11-27	2006-11-27 00:00:00	\N	\N	32020		\N	177387	0	397881000	4266809		0
34573	2052	260139	2000-11-29	2000-11-29 00:00:00	2000-12-06	2000-12-06 00:00:00	32020		\N	136440	0	10509002	260139		0
45348	2697	28060	1947-12-21	1947-12-21 00:00:00	1947-12-30	1947-12-30 00:00:00	32020		\N	178608	0	43878008	28060		0
35012	2078	372328	1982-07-09	1982-07-09 00:00:00	1982-09-15	1982-09-15 00:00:00	32020		\N	138431	0	65363002	372328		0
35077	2082	378001	2011-02-22	2011-02-22 00:00:00	2011-03-24	2011-03-24 00:00:00	32020		\N	138720	0	62106007	378001		0
35253	2088	40481087	1938-03-10	1938-03-10 00:00:00	1938-03-24	1938-03-24 00:00:00	32020		\N	139258	0	444814009	40481087		0
45983	2739	4112343	2007-01-05	2007-01-05 00:00:00	2007-01-15	2007-01-15 00:00:00	32020		\N	181188	0	195662009	4112343		0
35661	2114	78272	1999-12-07	1999-12-07 00:00:00	1999-12-28	1999-12-28 00:00:00	32020		\N	140684	0	70704007	78272		0
35777	2119	260139	2017-12-12	2017-12-12 00:00:00	2017-12-19	2017-12-19 00:00:00	32020		\N	140988	0	10509002	260139		0
35918	2130	4112343	1971-08-24	1971-08-24 00:00:00	1971-09-02	1971-09-02 00:00:00	32020		\N	141695	0	195662009	4112343		0
36143	2141	4112343	1961-05-18	1961-05-18 00:00:00	1961-05-27	1961-05-27 00:00:00	32020		\N	142612	0	195662009	4112343		0
36298	2150	4294548	1981-09-24	1981-09-24 00:00:00	1981-10-01	1981-10-01 00:00:00	32020		\N	143177	0	75498004	4294548		0
36495	2160	81151	2009-09-11	2009-09-11 00:00:00	2009-10-09	2009-10-09 00:00:00	32020		\N	143921	0	44465007	81151		0
36626	2167	4155034	1993-08-23	1993-08-23 00:00:00	1993-09-06	1993-09-06 00:00:00	32020		\N	144344	0	283371005	4155034		0
36781	2176	40481087	2003-10-04	2003-10-04 00:00:00	2003-10-11	2003-10-11 00:00:00	32020		\N	145128	0	444814009	40481087		0
36959	2186	4152936	1996-02-27	1996-02-27 00:00:00	1996-03-19	1996-03-19 00:00:00	32020		\N	145829	0	283385000	4152936		0
37033	2192	28060	1955-10-20	1955-10-20 00:00:00	1955-10-30	1955-10-30 00:00:00	32020		\N	146194	0	43878008	28060		0
37279	2207	372328	1982-01-14	1982-01-14 00:00:00	1982-04-01	1982-04-01 00:00:00	32020		\N	147081	0	65363002	372328		0
37469	2222	4112343	1971-09-12	1971-09-12 00:00:00	1971-09-22	1971-09-22 00:00:00	32020		\N	147895	0	195662009	4112343		0
37570	2228	260139	2001-02-26	2001-02-26 00:00:00	2001-03-12	2001-03-12 00:00:00	32020		\N	148275	0	10509002	260139		0
37724	2237	40481087	1971-12-29	1971-12-29 00:00:00	1972-01-12	1972-01-12 00:00:00	32020		\N	148813	0	444814009	40481087		0
37988	2256	4112343	2004-11-18	2004-11-18 00:00:00	2004-11-29	2004-11-29 00:00:00	32020		\N	149906	0	195662009	4112343		0
38178	2266	4112343	1996-05-09	1996-05-09 00:00:00	1996-05-19	1996-05-19 00:00:00	32020		\N	150642	0	195662009	4112343		0
38289	2274	40481087	2018-06-17	2018-06-17 00:00:00	2018-06-24	2018-06-24 00:00:00	32020		\N	151139	0	444814009	40481087		0
48994	2899	372328	1953-01-18	1953-01-18 00:00:00	1953-07-30	1953-07-30 00:00:00	32020		\N	193118	0	65363002	372328		0
38670	2294	372328	1972-01-22	1972-01-22 00:00:00	1972-12-15	1972-12-15 00:00:00	32020		\N	152722	0	65363002	372328		0
38772	2300	4237458	1955-12-26	1955-12-26 00:00:00	1956-03-25	1956-03-25 00:00:00	32020		\N	153125	0	58150001	4237458		0
38960	2315	40481087	1998-04-03	1998-04-03 00:00:00	1998-04-10	1998-04-10 00:00:00	32020		\N	153962	0	444814009	40481087		0
39172	2326	4152936	1966-11-16	1966-11-16 00:00:00	1966-11-30	1966-11-30 00:00:00	32020		\N	154670	0	283385000	4152936		0
39217	2328	40481087	1994-10-04	1994-10-04 00:00:00	1994-10-11	1994-10-11 00:00:00	32020		\N	154855	0	444814009	40481087		0
39477	2340	260139	1999-06-11	1999-06-11 00:00:00	1999-06-18	1999-06-18 00:00:00	32020		\N	155713	0	10509002	260139		0
39550	2343	372328	1959-05-28	1959-05-28 00:00:00	1959-06-20	1959-06-20 00:00:00	32020		\N	155984	0	65363002	372328		0
39792	2356	192671	2017-02-27	2017-02-27 00:00:00	\N	\N	32020		\N	156889	0	K92.2	35208414		0
39955	2367	40481087	1998-01-31	1998-01-31 00:00:00	1998-02-14	1998-02-14 00:00:00	32020		\N	157580	0	444814009	40481087		0
40097	2380	195588	1998-05-15	1998-05-15 00:00:00	1998-06-20	1998-06-20 00:00:00	32020		\N	158189	0	38822007	195588		0
40266	2389	40481087	1977-12-07	1977-12-07 00:00:00	1977-12-14	1977-12-14 00:00:00	32020		\N	158845	0	444814009	40481087		0
40370	2395	30753	1995-06-29	1995-06-29 00:00:00	\N	\N	32020		\N	159267	0	16761005	30753		0
40614	2414	4112343	1999-11-16	1999-11-16 00:00:00	1999-11-27	1999-11-27 00:00:00	32020		\N	160279	0	195662009	4112343		0
40789	2425	4294548	1964-03-03	1964-03-03 00:00:00	1964-05-26	1964-05-26 00:00:00	32020		\N	160922	0	75498004	4294548		0
40951	2436	40481087	2017-06-13	2017-06-13 00:00:00	2017-06-27	2017-06-27 00:00:00	32020		\N	161511	0	444814009	40481087		0
51665	3064	4027663	1965-09-25	1965-09-25 00:00:00	\N	\N	32020		\N	203976	0	13200003	4027663		0
41308	2456	260139	1959-11-30	1959-11-30 00:00:00	1959-12-14	1959-12-14 00:00:00	32020		\N	162768	0	10509002	260139		0
41435	2463	81151	2009-12-25	2009-12-25 00:00:00	2010-01-29	2010-01-29 00:00:00	32020		\N	163400	0	44465007	81151		0
41625	2476	4112343	2012-03-21	2012-03-21 00:00:00	2012-03-31	2012-03-31 00:00:00	32020		\N	164102	0	195662009	4112343		0
41739	2483	40481087	1952-06-26	1952-06-26 00:00:00	1952-07-17	1952-07-17 00:00:00	32020		\N	164523	0	444814009	40481087		0
52482	3109	40481087	1946-02-17	1946-02-17 00:00:00	1946-03-10	1946-03-10 00:00:00	32020		\N	206735	0	444814009	40481087		0
52638	3117	4027663	2000-07-25	2000-07-25 00:00:00	\N	\N	32020		\N	207378	0	13200003	4027663		0
52823	3128	80180	2010-11-02	2010-11-02 00:00:00	\N	\N	32020		\N	208174	0	396275006	80180		0
52967	3135	4112343	1991-04-05	1991-04-05 00:00:00	1991-04-14	1991-04-14 00:00:00	32020		\N	208669	0	195662009	4112343		0
32020	1902	40481087	1964-03-12	1964-03-12 00:00:00	1964-03-26	1964-03-26 00:00:00	32020		\N	126636	0	444814009	40481087		0
42699	2545	4113008	1947-09-14	1947-09-14 00:00:00	1947-10-05	1947-10-05 00:00:00	32020		\N	168453	0	284549007	4113008		0
32356	1923	80502	1993-02-12	1993-02-12 00:00:00	\N	\N	32020		\N	127980	0	64859006	80502		0
32507	1929	40481087	1995-12-09	1995-12-09 00:00:00	1995-12-16	1995-12-16 00:00:00	32020		\N	128450	0	444814009	40481087		0
32565	1934	4294548	1963-05-03	1963-05-03 00:00:00	1963-05-24	1963-05-24 00:00:00	32020		\N	128633	0	75498004	4294548		0
43328	2580	198199	1980-06-03	1980-06-03 00:00:00	1980-07-12	1980-07-12 00:00:00	32020		\N	170908	0	45816000	198199		0
32930	1953	4112343	1997-08-17	1997-08-17 00:00:00	1997-08-30	1997-08-30 00:00:00	32020		\N	129900	0	195662009	4112343		0
33132	1966	4266809	2000-04-05	2000-04-05 00:00:00	\N	\N	32020		\N	130699	0	397881000	4266809		0
33285	1976	260139	2008-06-07	2008-06-07 00:00:00	2008-06-21	2008-06-21 00:00:00	32020		\N	131391	0	10509002	260139		0
33507	1987	81151	1996-10-24	1996-10-24 00:00:00	1996-11-28	1996-11-28 00:00:00	32020		\N	132290	0	44465007	81151		0
33595	1991	4299128	1988-01-14	1988-01-14 00:00:00	1988-01-28	1988-01-28 00:00:00	32020		\N	132609	0	403192003	4299128		0
33765	2004	4112343	1993-03-17	1993-03-17 00:00:00	1993-03-30	1993-03-30 00:00:00	32020		\N	133437	0	195662009	4112343		0
33994	2020	40481087	1981-10-11	1981-10-11 00:00:00	1981-10-25	1981-10-25 00:00:00	32020		\N	134281	0	444814009	40481087		0
34142	2028	40481087	1946-07-12	1946-07-12 00:00:00	1946-07-19	1946-07-19 00:00:00	32020		\N	135004	0	444814009	40481087		0
34302	2034	4142905	1996-09-10	1996-09-10 00:00:00	1996-10-10	1996-10-10 00:00:00	32020		\N	135489	0	33737001	4142905		0
44995	2677	40481087	1982-07-07	1982-07-07 00:00:00	1982-07-28	1982-07-28 00:00:00	32020		\N	177412	0	444814009	40481087		0
34574	2052	40481087	2005-04-24	2005-04-24 00:00:00	2005-05-08	2005-05-08 00:00:00	32020		\N	136441	0	444814009	40481087		0
45349	2697	80180	1975-12-26	1975-12-26 00:00:00	\N	\N	32020		\N	178650	0	396275006	80180		0
35013	2078	4112343	2007-02-15	2007-02-15 00:00:00	2007-02-27	2007-02-27 00:00:00	32020		\N	138423	0	195662009	4112343		0
35078	2082	78272	1945-01-20	1945-01-20 00:00:00	1945-02-24	1945-02-24 00:00:00	32020		\N	138659	0	70704007	78272		0
35254	2088	260139	1932-12-07	1932-12-07 00:00:00	1932-12-14	1932-12-14 00:00:00	32020		\N	139166	0	10509002	260139		0
45984	2739	4112343	1995-04-05	1995-04-05 00:00:00	1995-04-13	1995-04-13 00:00:00	32020		\N	181219	0	195662009	4112343		0
35662	2114	372328	1969-12-02	1969-12-02 00:00:00	1970-01-07	1970-01-07 00:00:00	32020		\N	140678	0	65363002	372328		0
35778	2119	4237458	1962-05-08	1962-05-08 00:00:00	1962-06-07	1962-06-07 00:00:00	32020		\N	140972	0	58150001	4237458		0
35919	2130	40481087	1972-09-07	1972-09-07 00:00:00	1972-09-28	1972-09-28 00:00:00	32020		\N	141742	0	444814009	40481087		0
36144	2141	4112343	1955-10-20	1955-10-20 00:00:00	1955-10-27	1955-10-27 00:00:00	32020		\N	142611	0	195662009	4112343		0
36299	2150	4142905	2003-10-19	2003-10-19 00:00:00	2003-11-18	2003-11-18 00:00:00	32020		\N	143152	0	33737001	4142905		0
36496	2160	81151	1997-09-09	1997-09-09 00:00:00	1997-09-23	1997-09-23 00:00:00	32020		\N	143919	0	44465007	81151		0
36627	2167	4296204	2018-02-27	2018-02-27 00:00:00	2018-04-03	2018-04-03 00:00:00	32020		\N	144345	0	403190006	4296204		0
36782	2176	257012	1990-12-25	1990-12-25 00:00:00	1991-01-15	1991-01-15 00:00:00	32020		\N	145142	0	40055000	257012		0
36960	2186	372328	1975-12-14	1975-12-14 00:00:00	1976-01-15	1976-01-15 00:00:00	32020		\N	145840	0	65363002	372328		0
37034	2192	40481087	2018-09-30	2018-09-30 00:00:00	2018-10-07	2018-10-07 00:00:00	32020		\N	146150	0	444814009	40481087		0
37280	2207	4112343	1990-07-03	1990-07-03 00:00:00	1990-07-14	1990-07-14 00:00:00	32020		\N	147079	0	195662009	4112343		0
37470	2222	4112343	1987-10-16	1987-10-16 00:00:00	1987-10-25	1987-10-25 00:00:00	32020		\N	147890	0	195662009	4112343		0
37571	2228	378001	1980-08-11	1980-08-11 00:00:00	1980-09-10	1980-09-10 00:00:00	32020		\N	148294	0	62106007	378001		0
37725	2237	4112343	1991-02-04	1991-02-04 00:00:00	1991-02-15	1991-02-15 00:00:00	32020		\N	148850	0	195662009	4112343		0
37989	2256	40481087	1994-09-06	1994-09-06 00:00:00	1994-09-13	1994-09-13 00:00:00	32020		\N	149918	0	444814009	40481087		0
38179	2266	80180	2008-04-28	2008-04-28 00:00:00	\N	\N	32020		\N	150678	0	396275006	80180		0
38290	2274	40481087	1955-06-15	1955-06-15 00:00:00	1955-06-22	1955-06-22 00:00:00	32020		\N	151134	0	444814009	40481087		0
48995	2899	40481087	2019-04-11	2019-04-11 00:00:00	2019-04-18	2019-04-18 00:00:00	32020		\N	193150	0	444814009	40481087		0
38671	2294	4112343	1980-12-01	1980-12-01 00:00:00	1980-12-14	1980-12-14 00:00:00	32020		\N	152716	0	195662009	4112343		0
38773	2300	4029498	1950-01-26	1950-01-26 00:00:00	\N	\N	32020		\N	153124	0	128613002	4029498		0
38981	2318	4027663	1995-01-18	1995-01-18 00:00:00	\N	\N	32020		\N	154075	0	13200003	4027663		0
39173	2326	372328	1952-10-30	1952-10-30 00:00:00	1953-01-15	1953-01-15 00:00:00	32020		\N	154664	0	65363002	372328		0
39218	2328	4283893	2012-10-18	2012-10-18 00:00:00	2012-12-06	2012-12-06 00:00:00	32020		\N	154890	0	36971009	4283893		0
39478	2340	30753	1998-01-18	1998-01-18 00:00:00	\N	\N	32020		\N	155716	0	16761005	30753		0
39551	2343	80180	1995-12-25	1995-12-25 00:00:00	\N	\N	32020		\N	155968	0	396275006	80180		0
39793	2356	30753	2015-09-19	2015-09-19 00:00:00	\N	\N	32020		\N	156883	0	16761005	30753		0
39956	2367	260139	2004-05-04	2004-05-04 00:00:00	2004-05-11	2004-05-11 00:00:00	32020		\N	157551	0	10509002	260139		0
40098	2380	4112343	1951-11-19	1951-11-19 00:00:00	1951-12-02	1951-12-02 00:00:00	32020		\N	158174	0	195662009	4112343		0
40267	2389	4156265	1992-02-21	1992-02-21 00:00:00	1992-03-06	1992-03-06 00:00:00	32020		\N	158842	0	370247008	4156265		0
40371	2395	4285898	1995-10-27	1995-10-27 00:00:00	\N	\N	32020		\N	159267	0	68496003	4285898		0
40615	2414	4237458	1933-04-29	1933-04-29 00:00:00	1933-07-28	1933-07-28 00:00:00	32020		\N	160249	0	58150001	4237458		0
40790	2425	4027663	1986-02-11	1986-02-11 00:00:00	\N	\N	32020		\N	160907	0	13200003	4027663		0
40952	2436	260139	1942-10-28	1942-10-28 00:00:00	1942-11-11	1942-11-11 00:00:00	32020		\N	161513	0	10509002	260139		0
51666	3064	81151	1936-08-28	1936-08-28 00:00:00	1936-10-02	1936-10-02 00:00:00	32020		\N	203993	0	44465007	81151		0
41309	2456	28060	1981-10-21	1981-10-21 00:00:00	1981-10-28	1981-10-28 00:00:00	32020		\N	162754	0	43878008	28060		0
41436	2463	78272	1978-08-21	1978-08-21 00:00:00	1978-09-18	1978-09-18 00:00:00	32020		\N	163397	0	70704007	78272		0
41626	2476	40481087	1985-05-29	1985-05-29 00:00:00	1985-06-12	1985-06-12 00:00:00	32020		\N	164106	0	444814009	40481087		0
41740	2483	439777	1952-03-02	1952-03-02 00:00:00	\N	\N	32020		\N	164522	0	271737000	439777		0
52483	3109	40481087	1933-10-27	1933-10-27 00:00:00	1933-11-03	1933-11-03 00:00:00	32020		\N	206732	0	444814009	40481087		0
52639	3117	40481087	1996-11-08	1996-11-08 00:00:00	1996-11-15	1996-11-15 00:00:00	32020		\N	207334	0	444814009	40481087		0
52824	3129	4112343	2012-12-17	2012-12-17 00:00:00	2012-12-29	2012-12-29 00:00:00	32020		\N	208279	0	195662009	4112343		0
52968	3135	40481087	1969-06-09	1969-06-09 00:00:00	1969-06-23	1969-06-23 00:00:00	32020		\N	208682	0	444814009	40481087		0
32021	1902	81151	2000-06-01	2000-06-01 00:00:00	2000-06-29	2000-06-29 00:00:00	32020		\N	126625	0	44465007	81151		0
42700	2545	4112343	1977-08-31	1977-08-31 00:00:00	1977-09-10	1977-09-10 00:00:00	32020		\N	168415	0	195662009	4112343		0
32357	1923	4283893	1940-05-14	1940-05-14 00:00:00	1940-08-06	1940-08-06 00:00:00	32020		\N	127950	0	36971009	4283893		0
32508	1929	4294548	1996-01-20	1996-01-20 00:00:00	1996-02-24	1996-02-24 00:00:00	32020		\N	128451	0	75498004	4294548		0
32566	1934	4112343	2017-04-07	2017-04-07 00:00:00	2017-04-18	2017-04-18 00:00:00	32020		\N	128649	0	195662009	4112343		0
43329	2580	40481087	1974-12-13	1974-12-13 00:00:00	1974-12-20	1974-12-20 00:00:00	32020		\N	170907	0	444814009	40481087		0
32931	1953	4112343	1982-03-14	1982-03-14 00:00:00	1982-03-23	1982-03-23 00:00:00	32020		\N	129898	0	195662009	4112343		0
33133	1966	81893	1998-12-12	1998-12-12 00:00:00	\N	\N	32020		\N	130699	0	64766004	81893		0
33286	1976	4296204	1995-07-15	1995-07-15 00:00:00	1995-08-19	1995-08-19 00:00:00	32020		\N	131373	0	403190006	4296204		0
33508	1987	4112343	1944-08-09	1944-08-09 00:00:00	1944-08-20	1944-08-20 00:00:00	32020		\N	132281	0	195662009	4112343		0
33596	1991	40481087	1954-04-23	1954-04-23 00:00:00	1954-05-07	1954-05-07 00:00:00	32020		\N	132556	0	444814009	40481087		0
33766	2005	260139	2013-05-02	2013-05-02 00:00:00	2013-05-09	2013-05-09 00:00:00	32020		\N	133511	0	10509002	260139		0
33995	2020	378001	2005-08-28	2005-08-28 00:00:00	2005-10-27	2005-10-27 00:00:00	32020		\N	134307	0	62106007	378001		0
34143	2028	378001	1989-07-31	1989-07-31 00:00:00	1989-09-29	1989-09-29 00:00:00	32020		\N	134953	0	62106007	378001		0
34303	2034	40481087	1926-04-10	1926-04-10 00:00:00	1926-04-17	1926-04-17 00:00:00	32020		\N	135502	0	444814009	40481087		0
44996	2677	40481087	1985-05-18	1985-05-18 00:00:00	1985-05-25	1985-05-25 00:00:00	32020		\N	177364	0	444814009	40481087		0
34575	2052	4218389	2014-06-30	2014-06-30 00:00:00	2014-07-28	2014-07-28 00:00:00	32020		\N	136410	0	39848009	4218389		0
45350	2697	40481087	2002-02-11	2002-02-11 00:00:00	2002-02-25	2002-02-25 00:00:00	32020		\N	178564	0	444814009	40481087		0
35014	2078	4278672	2005-05-09	2005-05-09 00:00:00	2005-06-08	2005-06-08 00:00:00	32020		\N	138382	0	65966004	4278672		0
35079	2082	4112343	1967-02-23	1967-02-23 00:00:00	1967-03-08	1967-03-08 00:00:00	32020		\N	138710	0	195662009	4112343		0
35255	2088	4027663	1933-09-16	1933-09-16 00:00:00	\N	\N	32020		\N	139166	0	13200003	4027663		0
45985	2739	4059173	1988-06-26	1988-06-26 00:00:00	1988-08-25	1988-08-25 00:00:00	32020		\N	181240	0	16114001	4059173		0
35663	2114	40481087	1977-02-09	1977-02-09 00:00:00	1977-02-23	1977-02-23 00:00:00	32020		\N	140669	0	444814009	40481087		0
35779	2119	40481087	1987-05-20	1987-05-20 00:00:00	1987-06-03	1987-06-03 00:00:00	32020		\N	141002	0	444814009	40481087		0
35920	2130	40481087	1988-09-20	1988-09-20 00:00:00	1988-10-11	1988-10-11 00:00:00	32020		\N	141747	0	444814009	40481087		0
36145	2141	40481087	1992-07-18	1992-07-18 00:00:00	1992-08-08	1992-08-08 00:00:00	32020		\N	142644	0	444814009	40481087		0
36300	2150	81151	1990-04-02	1990-04-02 00:00:00	1990-04-30	1990-04-30 00:00:00	32020		\N	143151	0	44465007	81151		0
36497	2160	4112343	1988-12-12	1988-12-12 00:00:00	1988-12-20	1988-12-20 00:00:00	32020		\N	143978	0	195662009	4112343		0
36628	2167	40481087	1984-07-30	1984-07-30 00:00:00	1984-08-06	1984-08-06 00:00:00	32020		\N	144376	0	444814009	40481087		0
36783	2176	372328	1962-04-20	1962-04-20 00:00:00	1962-07-30	1962-07-30 00:00:00	32020		\N	145086	0	65363002	372328		0
36972	2189	4112343	1999-07-07	1999-07-07 00:00:00	1999-07-20	1999-07-20 00:00:00	32020		\N	145892	0	195662009	4112343		0
37035	2192	40481087	1970-07-28	1970-07-28 00:00:00	1970-08-11	1970-08-11 00:00:00	32020		\N	146226	0	444814009	40481087		0
37281	2207	260139	1989-01-08	1989-01-08 00:00:00	1989-01-22	1989-01-22 00:00:00	32020		\N	147078	0	10509002	260139		0
37471	2222	257012	2001-06-09	2001-06-09 00:00:00	\N	\N	32020		\N	147933	0	40055000	257012		0
37572	2228	40481087	2016-11-29	2016-11-29 00:00:00	2016-12-13	2016-12-13 00:00:00	32020		\N	148271	0	444814009	40481087		0
37726	2237	40481087	1974-04-09	1974-04-09 00:00:00	1974-04-23	1974-04-23 00:00:00	32020		\N	148814	0	444814009	40481087		0
37990	2256	192671	2012-05-31	2012-05-31 00:00:00	\N	\N	32020		\N	149939	0	K92.2	35208414		0
38180	2266	30753	2007-10-01	2007-10-01 00:00:00	\N	\N	32020		\N	150678	0	16761005	30753		0
38291	2274	78272	2008-07-18	2008-07-18 00:00:00	2008-08-01	2008-08-01 00:00:00	32020		\N	151211	0	70704007	78272		0
48996	2899	40481087	2011-11-23	2011-11-23 00:00:00	2011-12-14	2011-12-14 00:00:00	32020		\N	193148	0	444814009	40481087		0
38672	2294	40481087	2018-10-19	2018-10-19 00:00:00	2018-11-09	2018-11-09 00:00:00	32020		\N	152721	0	444814009	40481087		0
38775	2300	4155034	2010-08-01	2010-08-01 00:00:00	2010-08-22	2010-08-22 00:00:00	32020		\N	153131	0	283371005	4155034		0
38982	2318	378001	1965-11-16	1965-11-16 00:00:00	1965-12-16	1965-12-16 00:00:00	32020		\N	154113	0	62106007	378001		0
39174	2326	260139	1999-04-05	1999-04-05 00:00:00	1999-04-19	1999-04-19 00:00:00	32020		\N	154676	0	10509002	260139		0
39219	2328	40481087	1964-04-10	1964-04-10 00:00:00	1964-04-17	1964-04-17 00:00:00	32020		\N	154809	0	444814009	40481087		0
39479	2340	4285898	1998-06-18	1998-06-18 00:00:00	\N	\N	32020		\N	155716	0	68496003	4285898		0
39552	2343	4285898	1995-10-26	1995-10-26 00:00:00	\N	\N	32020		\N	155968	0	68496003	4285898		0
39794	2356	4112343	2002-04-14	2002-04-14 00:00:00	2002-04-26	2002-04-26 00:00:00	32020		\N	156886	0	195662009	4112343		0
39957	2367	372328	1975-04-27	1975-04-27 00:00:00	1975-07-08	1975-07-08 00:00:00	32020		\N	157579	0	65363002	372328		0
40099	2380	260139	1969-05-27	1969-05-27 00:00:00	1969-06-10	1969-06-10 00:00:00	32020		\N	158227	0	10509002	260139		0
40268	2389	4230399	1975-12-17	1975-12-17 00:00:00	1976-01-16	1976-01-16 00:00:00	32020		\N	158841	0	359817006	4230399		0
40372	2395	40481087	1979-01-07	1979-01-07 00:00:00	1979-01-28	1979-01-28 00:00:00	32020		\N	159266	0	444814009	40481087		0
40616	2414	40481087	1927-06-25	1927-06-25 00:00:00	1927-07-09	1927-07-09 00:00:00	32020		\N	160219	0	444814009	40481087		0
40791	2425	40481087	1967-11-16	1967-11-16 00:00:00	1967-11-30	1967-11-30 00:00:00	32020		\N	160923	0	444814009	40481087		0
40953	2436	4218389	1915-12-26	1915-12-26 00:00:00	1916-01-30	1916-01-30 00:00:00	32020		\N	161446	0	39848009	4218389		0
51667	3064	40481087	1972-08-11	1972-08-11 00:00:00	1972-09-01	1972-09-01 00:00:00	32020		\N	203937	0	444814009	40481087		0
41310	2456	40481087	1985-03-06	1985-03-06 00:00:00	1985-03-13	1985-03-13 00:00:00	32020		\N	162770	0	444814009	40481087		0
41437	2463	260139	1999-01-04	1999-01-04 00:00:00	1999-01-18	1999-01-18 00:00:00	32020		\N	163390	0	10509002	260139		0
41627	2476	4112343	1981-12-06	1981-12-06 00:00:00	1981-12-16	1981-12-16 00:00:00	32020		\N	164061	0	195662009	4112343		0
41741	2483	40481087	1985-07-03	1985-07-03 00:00:00	1985-07-10	1985-07-10 00:00:00	32020		\N	164517	0	444814009	40481087		0
52484	3109	78272	1987-09-04	1987-09-04 00:00:00	1987-09-25	1987-09-25 00:00:00	32020		\N	206708	0	70704007	78272		0
52640	3117	4116491	1997-07-26	1997-07-26 00:00:00	1997-08-30	1997-08-30 00:00:00	32020		\N	207335	0	301011002	4116491		0
52825	3129	28060	2009-04-09	2009-04-09 00:00:00	2009-04-17	2009-04-17 00:00:00	32020		\N	208251	0	43878008	28060		0
52969	3135	260139	1963-09-05	1963-09-05 00:00:00	1963-09-12	1963-09-12 00:00:00	32020		\N	208680	0	10509002	260139		0
32022	1902	40481087	2017-12-24	2017-12-24 00:00:00	2018-01-07	2018-01-07 00:00:00	32020		\N	126650	0	444814009	40481087		0
42701	2545	4294548	1975-07-30	1975-07-30 00:00:00	1975-09-17	1975-09-17 00:00:00	32020		\N	168440	0	75498004	4294548		0
32358	1923	4112343	1958-12-13	1958-12-13 00:00:00	1958-12-22	1958-12-22 00:00:00	32020		\N	128002	0	195662009	4112343		0
32509	1929	372328	1954-09-18	1954-09-18 00:00:00	1954-11-25	1954-11-25 00:00:00	32020		\N	128453	0	65363002	372328		0
32567	1934	40481087	1976-09-21	1976-09-21 00:00:00	1976-10-05	1976-10-05 00:00:00	32020		\N	128647	0	444814009	40481087		0
43330	2580	260139	1963-07-15	1963-07-15 00:00:00	1963-07-29	1963-07-29 00:00:00	32020		\N	170921	0	10509002	260139		0
32932	1953	260139	1957-06-26	1957-06-26 00:00:00	1957-07-03	1957-07-03 00:00:00	32020		\N	129908	0	10509002	260139		0
33134	1966	80180	2000-04-05	2000-04-05 00:00:00	\N	\N	32020		\N	130699	0	396275006	80180		0
33287	1976	40481087	2015-09-04	2015-09-04 00:00:00	2015-09-18	2015-09-18 00:00:00	32020		\N	131461	0	444814009	40481087		0
33509	1987	4112343	1998-12-18	1998-12-18 00:00:00	1998-12-31	1998-12-31 00:00:00	32020		\N	132338	0	195662009	4112343		0
33597	1991	4155034	1992-12-02	1992-12-02 00:00:00	1992-12-16	1992-12-16 00:00:00	32020		\N	132610	0	283371005	4155034		0
33767	2005	40481087	2001-04-12	2001-04-12 00:00:00	2001-05-03	2001-05-03 00:00:00	32020		\N	133481	0	444814009	40481087		0
44489	2647	372328	1971-05-12	1971-05-12 00:00:00	1971-08-22	1971-08-22 00:00:00	32020		\N	175219	0	65363002	372328		0
34144	2028	260139	1959-03-29	1959-03-29 00:00:00	1959-04-12	1959-04-12 00:00:00	32020		\N	135006	0	10509002	260139		0
34304	2034	4112343	1924-03-14	1924-03-14 00:00:00	1924-03-23	1924-03-23 00:00:00	32020		\N	135422	0	195662009	4112343		0
44997	2677	4278672	1974-11-30	1974-11-30 00:00:00	1974-12-30	1974-12-30 00:00:00	32020		\N	177357	0	65966004	4278672		0
34577	2052	321042	2015-10-19	2015-10-19 00:00:00	\N	\N	32020		\N	136411	0	410429000	321042		0
45351	2697	40481087	1947-02-25	1947-02-25 00:00:00	1947-03-11	1947-03-11 00:00:00	32020		\N	178607	0	444814009	40481087		0
35015	2078	4294548	2006-05-23	2006-05-23 00:00:00	2006-07-11	2006-07-11 00:00:00	32020		\N	138411	0	75498004	4294548		0
35080	2082	4134304	2017-02-20	2017-02-20 00:00:00	2017-04-21	2017-04-21 00:00:00	32020		\N	138721	0	263102004	4134304		0
35256	2088	40481087	1933-12-01	1933-12-01 00:00:00	1933-12-08	1933-12-08 00:00:00	32020		\N	139224	0	444814009	40481087		0
45986	2739	4112343	1995-08-14	1995-08-14 00:00:00	1995-08-24	1995-08-24 00:00:00	32020		\N	181212	0	195662009	4112343		0
35664	2114	80180	2002-07-02	2002-07-02 00:00:00	\N	\N	32020		\N	140688	0	396275006	80180		0
35780	2119	4296205	1980-04-03	1980-04-03 00:00:00	1980-05-08	1980-05-08 00:00:00	32020		\N	140973	0	403191005	4296205		0
35921	2130	4155034	1980-06-05	1980-06-05 00:00:00	1980-06-19	1980-06-19 00:00:00	32020		\N	141692	0	283371005	4155034		0
36146	2141	40481087	1970-09-27	1970-09-27 00:00:00	1970-10-18	1970-10-18 00:00:00	32020		\N	142613	0	444814009	40481087		0
36301	2150	4112343	1980-10-04	1980-10-04 00:00:00	1980-10-12	1980-10-12 00:00:00	32020		\N	143190	0	195662009	4112343		0
36498	2160	4109685	1982-09-14	1982-09-14 00:00:00	1982-09-28	1982-09-28 00:00:00	32020		\N	143918	0	284551006	4109685		0
36629	2167	4112343	1988-03-26	1988-03-26 00:00:00	1988-04-07	1988-04-07 00:00:00	32020		\N	144389	0	195662009	4112343		0
36784	2176	378001	2008-11-30	2008-11-30 00:00:00	2009-01-29	2009-01-29 00:00:00	32020		\N	145140	0	62106007	378001		0
36973	2189	4112343	2009-10-13	2009-10-13 00:00:00	2009-10-24	2009-10-24 00:00:00	32020		\N	145955	0	195662009	4112343		0
37036	2192	260139	2000-05-01	2000-05-01 00:00:00	2000-05-08	2000-05-08 00:00:00	32020		\N	146229	0	10509002	260139		0
37282	2207	260139	2018-10-03	2018-10-03 00:00:00	2018-10-17	2018-10-17 00:00:00	32020		\N	147083	0	10509002	260139		0
37472	2222	40481087	1975-09-14	1975-09-14 00:00:00	1975-10-05	1975-10-05 00:00:00	32020		\N	147923	0	444814009	40481087		0
37573	2228	80180	1984-08-26	1984-08-26 00:00:00	\N	\N	32020		\N	148212	0	396275006	80180		0
37727	2237	30753	1966-03-22	1966-03-22 00:00:00	\N	\N	32020		\N	148773	0	16761005	30753		0
37991	2256	260139	1989-11-11	1989-11-11 00:00:00	1989-11-25	1989-11-25 00:00:00	32020		\N	149965	0	10509002	260139		0
48660	2882	4112343	1988-04-20	1988-04-20 00:00:00	1988-04-30	1988-04-30 00:00:00	32020		\N	191709	0	195662009	4112343		0
38292	2274	4294548	2013-02-27	2013-02-27 00:00:00	2013-09-04	2013-09-04 00:00:00	32020		\N	151196	0	75498004	4294548		0
48997	2899	40481087	1969-11-27	1969-11-27 00:00:00	1969-12-11	1969-12-11 00:00:00	32020		\N	193173	0	444814009	40481087		0
38673	2294	4296204	1999-06-09	1999-06-09 00:00:00	1999-06-23	1999-06-23 00:00:00	32020		\N	152751	0	403190006	4296204		0
38776	2300	4218389	1970-12-21	1970-12-21 00:00:00	1971-01-25	1971-01-25 00:00:00	32020		\N	153127	0	39848009	4218389		0
38983	2318	4266809	2003-05-01	2003-05-01 00:00:00	\N	\N	32020		\N	154083	0	397881000	4266809		0
39175	2326	40481087	1983-06-25	1983-06-25 00:00:00	1983-07-02	1983-07-02 00:00:00	32020		\N	154674	0	444814009	40481087		0
39220	2328	40481087	1955-07-01	1955-07-01 00:00:00	1955-07-22	1955-07-22 00:00:00	32020		\N	154812	0	444814009	40481087		0
39480	2340	40481087	1974-10-19	1974-10-19 00:00:00	1974-11-01	1974-11-01 00:00:00	32020		\N	155731	0	444814009	40481087		0
39553	2343	4266809	1995-12-25	1995-12-25 00:00:00	\N	\N	32020		\N	155968	0	397881000	4266809		0
39795	2357	260139	1955-03-19	1955-03-19 00:00:00	1955-04-02	1955-04-02 00:00:00	32020		\N	157091	0	10509002	260139		0
39958	2367	260139	1999-09-04	1999-09-04 00:00:00	1999-09-18	1999-09-18 00:00:00	32020		\N	157576	0	10509002	260139		0
40100	2380	260139	2010-09-23	2010-09-23 00:00:00	2010-09-30	2010-09-30 00:00:00	32020		\N	158191	0	10509002	260139		0
40269	2389	81893	2007-05-17	2007-05-17 00:00:00	\N	\N	32020		\N	158863	0	64766004	81893		0
40373	2395	192671	1996-09-12	1996-09-12 00:00:00	\N	\N	32020		\N	159286	0	K92.2	35208414		0
40617	2414	4329847	1994-05-26	1994-05-26 00:00:00	\N	\N	32020		\N	160252	0	22298006	4329847		0
40792	2425	260139	1971-06-21	1971-06-21 00:00:00	1971-07-05	1971-07-05 00:00:00	32020		\N	160913	0	10509002	260139		0
40954	2436	4283893	1990-08-01	1990-08-01 00:00:00	1990-09-12	1990-09-12 00:00:00	32020		\N	161504	0	36971009	4283893		0
51668	3064	4112343	2017-10-03	2017-10-03 00:00:00	2017-10-10	2017-10-10 00:00:00	32020		\N	203943	0	195662009	4112343		0
41311	2456	28060	1969-04-14	1969-04-14 00:00:00	1969-04-26	1969-04-26 00:00:00	32020		\N	162826	0	43878008	28060		0
41438	2463	40481087	1980-06-05	1980-06-05 00:00:00	1980-06-12	1980-06-12 00:00:00	32020		\N	163388	0	444814009	40481087		0
41628	2476	260139	1966-07-15	1966-07-15 00:00:00	1966-07-29	1966-07-29 00:00:00	32020		\N	164099	0	10509002	260139		0
41742	2483	40481087	1986-07-13	1986-07-13 00:00:00	1986-07-27	1986-07-27 00:00:00	32020		\N	164525	0	444814009	40481087		0
52485	3109	40481087	1969-01-24	1969-01-24 00:00:00	1969-02-07	1969-02-07 00:00:00	32020		\N	206747	0	444814009	40481087		0
52641	3117	4218389	2018-09-18	2018-09-18 00:00:00	2018-10-09	2018-10-09 00:00:00	32020		\N	207400	0	39848009	4218389		0
52826	3129	40481087	1989-10-02	1989-10-02 00:00:00	1989-10-16	1989-10-16 00:00:00	32020		\N	208284	0	444814009	40481087		0
52970	3135	4283893	1976-07-25	1976-07-25 00:00:00	1976-09-26	1976-09-26 00:00:00	32020		\N	208684	0	36971009	4283893		0
32023	1902	4310024	1983-07-16	1983-07-16 00:00:00	\N	\N	32020		\N	126568	0	424802006	4310024		0
42702	2545	4283893	1972-05-30	1972-05-30 00:00:00	1972-09-19	1972-09-19 00:00:00	32020		\N	168429	0	36971009	4283893		0
32359	1923	40481087	1955-04-09	1955-04-09 00:00:00	1955-04-16	1955-04-16 00:00:00	32020		\N	127952	0	444814009	40481087		0
32510	1929	372328	1955-02-23	1955-02-23 00:00:00	1955-04-28	1955-04-28 00:00:00	32020		\N	128464	0	65363002	372328		0
32568	1934	372328	1964-07-02	1964-07-02 00:00:00	1965-01-09	1965-01-09 00:00:00	32020		\N	128638	0	65363002	372328		0
43331	2580	4112343	1988-10-29	1988-10-29 00:00:00	1988-11-05	1988-11-05 00:00:00	32020		\N	170922	0	195662009	4112343		0
32933	1953	4112343	1973-11-10	1973-11-10 00:00:00	1973-11-23	1973-11-23 00:00:00	32020		\N	129903	0	195662009	4112343		0
33135	1966	4285898	1999-10-08	1999-10-08 00:00:00	\N	\N	32020		\N	130699	0	68496003	4285898		0
33288	1976	372328	1985-09-19	1985-09-19 00:00:00	1985-11-25	1985-11-25 00:00:00	32020		\N	131421	0	65363002	372328		0
33510	1987	372328	1948-06-03	1948-06-03 00:00:00	1948-12-03	1948-12-03 00:00:00	32020		\N	132333	0	65363002	372328		0
33598	1991	260139	1954-09-14	1954-09-14 00:00:00	1954-09-28	1954-09-28 00:00:00	32020		\N	132555	0	10509002	260139		0
33768	2005	257012	2007-09-21	2007-09-21 00:00:00	\N	\N	32020		\N	133498	0	40055000	257012		0
44490	2647	260139	1974-08-25	1974-08-25 00:00:00	1974-09-01	1974-09-01 00:00:00	32020		\N	175109	0	10509002	260139		0
34145	2028	40481087	2004-08-03	2004-08-03 00:00:00	2004-08-24	2004-08-24 00:00:00	32020		\N	134981	0	444814009	40481087		0
34305	2034	40481087	1944-06-13	1944-06-13 00:00:00	1944-06-27	1944-06-27 00:00:00	32020		\N	135435	0	444814009	40481087		0
44998	2677	40481087	1975-12-25	1975-12-25 00:00:00	1976-01-01	1976-01-01 00:00:00	32020		\N	177362	0	444814009	40481087		0
34578	2052	4112343	2012-04-26	2012-04-26 00:00:00	2012-05-04	2012-05-04 00:00:00	32020		\N	136413	0	195662009	4112343		0
45352	2697	321042	2005-09-08	2005-09-08 00:00:00	\N	\N	32020		\N	178582	0	410429000	321042		0
35016	2078	4112343	1984-06-02	1984-06-02 00:00:00	1984-06-14	1984-06-14 00:00:00	32020		\N	138393	0	195662009	4112343		0
35081	2082	40481087	1957-07-27	1957-07-27 00:00:00	1957-08-17	1957-08-17 00:00:00	32020		\N	138697	0	444814009	40481087		0
35257	2088	40481087	1998-05-22	1998-05-22 00:00:00	1998-06-12	1998-06-12 00:00:00	32020		\N	139234	0	444814009	40481087		0
45987	2739	4112343	2014-06-09	2014-06-09 00:00:00	2014-06-17	2014-06-17 00:00:00	32020		\N	181189	0	195662009	4112343		0
35665	2114	257012	2001-10-27	2001-10-27 00:00:00	\N	\N	32020		\N	140688	0	40055000	257012		0
35781	2119	40481087	1991-04-22	1991-04-22 00:00:00	1991-05-06	1991-05-06 00:00:00	32020		\N	141074	0	444814009	40481087		0
35922	2130	260139	1962-02-11	1962-02-11 00:00:00	1962-02-25	1962-02-25 00:00:00	32020		\N	141726	0	10509002	260139		0
36147	2141	372328	1950-11-14	1950-11-14 00:00:00	1951-06-18	1951-06-18 00:00:00	32020		\N	142615	0	65363002	372328		0
36302	2150	372328	1952-12-22	1952-12-22 00:00:00	1953-06-26	1953-06-26 00:00:00	32020		\N	143172	0	65363002	372328		0
36499	2160	40481087	2008-01-25	2008-01-25 00:00:00	2008-02-01	2008-02-01 00:00:00	32020		\N	143963	0	444814009	40481087		0
36630	2167	4285898	2017-03-25	2017-03-25 00:00:00	\N	\N	32020		\N	144388	0	68496003	4285898		0
36785	2176	4218389	1966-07-20	1966-07-20 00:00:00	1966-08-24	1966-08-24 00:00:00	32020		\N	145136	0	39848009	4218389		0
36974	2189	40481087	2002-01-18	2002-01-18 00:00:00	2002-02-08	2002-02-08 00:00:00	32020		\N	145903	0	444814009	40481087		0
37037	2192	4237458	1962-08-13	1962-08-13 00:00:00	1962-10-12	1962-10-12 00:00:00	32020		\N	146243	0	58150001	4237458		0
37294	2210	4156265	2014-12-22	2014-12-22 00:00:00	2015-01-05	2015-01-05 00:00:00	32020		\N	147201	0	370247008	4156265		0
37473	2222	317576	2012-07-24	2012-07-24 00:00:00	\N	\N	32020		\N	147899	0	53741008	317576		0
37574	2228	40481087	2012-01-25	2012-01-25 00:00:00	2012-02-01	2012-02-01 00:00:00	32020		\N	148269	0	444814009	40481087		0
37728	2237	81893	1965-06-25	1965-06-25 00:00:00	\N	\N	32020		\N	148773	0	64766004	81893		0
37992	2256	40481087	1985-11-08	1985-11-08 00:00:00	1985-11-15	1985-11-15 00:00:00	32020		\N	149964	0	444814009	40481087		0
48661	2882	40481087	2004-08-14	2004-08-14 00:00:00	2004-09-04	2004-09-04 00:00:00	32020		\N	191700	0	444814009	40481087		0
38293	2274	40481087	2006-10-17	2006-10-17 00:00:00	2006-11-07	2006-11-07 00:00:00	32020		\N	151171	0	444814009	40481087		0
48998	2899	260139	1967-07-17	1967-07-17 00:00:00	1967-07-31	1967-07-31 00:00:00	32020		\N	193172	0	10509002	260139		0
38674	2294	40481087	1983-08-08	1983-08-08 00:00:00	1983-08-29	1983-08-29 00:00:00	32020		\N	152717	0	444814009	40481087		0
38777	2300	260139	1991-05-09	1991-05-09 00:00:00	1991-05-16	1991-05-16 00:00:00	32020		\N	153166	0	10509002	260139		0
38984	2318	80180	2003-05-01	2003-05-01 00:00:00	\N	\N	32020		\N	154083	0	396275006	80180		0
39176	2326	4029498	2011-01-24	2011-01-24 00:00:00	\N	\N	32020		\N	154723	0	128613002	4029498		0
39221	2328	260139	1972-05-15	1972-05-15 00:00:00	1972-05-22	1972-05-22 00:00:00	32020		\N	154815	0	10509002	260139		0
39481	2340	4027663	1991-02-24	1991-02-24 00:00:00	\N	\N	32020		\N	155734	0	13200003	4027663		0
39554	2343	4109685	2010-04-03	2010-04-03 00:00:00	2010-04-24	2010-04-24 00:00:00	32020		\N	155982	0	284551006	4109685		0
39796	2357	260139	1973-05-02	1973-05-02 00:00:00	1973-05-09	1973-05-09 00:00:00	32020		\N	157094	0	10509002	260139		0
39959	2367	40481087	1996-09-12	1996-09-12 00:00:00	1996-10-03	1996-10-03 00:00:00	32020		\N	157592	0	444814009	40481087		0
40101	2380	4112343	2013-07-03	2013-07-03 00:00:00	2013-07-12	2013-07-12 00:00:00	32020		\N	158213	0	195662009	4112343		0
40270	2389	378001	1994-01-23	1994-01-23 00:00:00	1994-03-24	1994-03-24 00:00:00	32020		\N	158886	0	62106007	378001		0
40374	2395	4109685	1989-07-26	1989-07-26 00:00:00	1989-08-16	1989-08-16 00:00:00	32020		\N	159240	0	284551006	4109685		0
40619	2414	40481087	1941-11-27	1941-11-27 00:00:00	1941-12-11	1941-12-11 00:00:00	32020		\N	160275	0	444814009	40481087		0
40793	2425	4059173	1966-01-08	1966-01-08 00:00:00	1966-04-08	1966-04-08 00:00:00	32020		\N	160871	0	16114001	4059173		0
40955	2436	4146173	2018-02-04	2018-02-04 00:00:00	2018-03-06	2018-03-06 00:00:00	32020		\N	161455	0	307731004	4146173		0
51669	3064	40481087	2009-03-02	2009-03-02 00:00:00	2009-03-16	2009-03-16 00:00:00	32020		\N	203922	0	444814009	40481087		0
41312	2456	80180	1995-05-04	1995-05-04 00:00:00	\N	\N	32020		\N	162792	0	396275006	80180		0
41452	2466	4059173	1993-07-04	1993-07-04 00:00:00	1993-10-02	1993-10-02 00:00:00	32020		\N	163500	0	16114001	4059173		0
41629	2476	81151	1958-09-23	1958-09-23 00:00:00	1958-10-28	1958-10-28 00:00:00	32020		\N	164115	0	44465007	81151		0
41743	2483	261325	1966-05-07	1966-05-07 00:00:00	\N	\N	32020		\N	164490	0	87433001	261325		0
52486	3109	372328	1920-03-03	1920-03-03 00:00:00	1920-05-19	1920-05-19 00:00:00	32020		\N	206754	0	65363002	372328		0
52642	3117	40481087	2005-09-26	2005-09-26 00:00:00	2005-10-03	2005-10-03 00:00:00	32020		\N	207391	0	444814009	40481087		0
52827	3129	4112343	2003-03-02	2003-03-02 00:00:00	2003-03-10	2003-03-10 00:00:00	32020		\N	208250	0	195662009	4112343		0
52971	3135	257012	1976-08-29	1976-08-29 00:00:00	\N	\N	32020		\N	208683	0	40055000	257012		0
32024	1902	372328	1946-11-12	1946-11-12 00:00:00	1947-05-04	1947-05-04 00:00:00	32020		\N	126595	0	65363002	372328		0
42703	2545	4043241	2000-09-14	2000-09-14 00:00:00	\N	\N	32020		\N	168423	0	230265002	4043241		0
32360	1923	378001	1972-10-29	1972-10-29 00:00:00	1972-11-28	1972-11-28 00:00:00	32020		\N	127999	0	62106007	378001		0
32511	1929	80180	1993-05-26	1993-05-26 00:00:00	\N	\N	32020		\N	128434	0	396275006	80180		0
32569	1934	260139	2013-01-22	2013-01-22 00:00:00	2013-01-29	2013-01-29 00:00:00	32020		\N	128635	0	10509002	260139		0
43332	2580	80180	1995-01-16	1995-01-16 00:00:00	\N	\N	32020		\N	170891	0	396275006	80180		0
32934	1953	4112343	1990-05-12	1990-05-12 00:00:00	1990-05-22	1990-05-22 00:00:00	32020		\N	129899	0	195662009	4112343		0
33136	1966	4152936	1984-05-08	1984-05-08 00:00:00	1984-05-22	1984-05-22 00:00:00	32020		\N	130736	0	283385000	4152936		0
33289	1976	40481087	2007-10-01	2007-10-01 00:00:00	2007-10-08	2007-10-08 00:00:00	32020		\N	131460	0	444814009	40481087		0
33511	1987	4237458	1967-10-06	1967-10-06 00:00:00	1967-12-05	1967-12-05 00:00:00	32020		\N	132288	0	58150001	4237458		0
33599	1992	4112343	1985-10-20	1985-10-20 00:00:00	1985-11-02	1985-11-02 00:00:00	32020		\N	132708	0	195662009	4112343		0
33769	2005	40481087	2017-05-04	2017-05-04 00:00:00	2017-05-18	2017-05-18 00:00:00	32020		\N	133534	0	444814009	40481087		0
44491	2647	260139	1988-01-31	1988-01-31 00:00:00	1988-02-07	1988-02-07 00:00:00	32020		\N	175114	0	10509002	260139		0
34146	2028	4112343	1966-11-30	1966-11-30 00:00:00	1966-12-11	1966-12-11 00:00:00	32020		\N	134970	0	195662009	4112343		0
34306	2034	4149245	2011-08-26	2011-08-26 00:00:00	2011-11-01	2011-11-01 00:00:00	32020		\N	135430	0	30832001	4149245		0
44999	2677	81151	1975-10-26	1975-10-26 00:00:00	1975-11-16	1975-11-16 00:00:00	32020		\N	177358	0	44465007	81151		0
34579	2052	260139	1964-02-24	1964-02-24 00:00:00	1964-03-09	1964-03-09 00:00:00	32020		\N	136407	0	10509002	260139		0
45354	2697	4283893	1983-06-30	1983-06-30 00:00:00	1983-12-01	1983-12-01 00:00:00	32020		\N	178639	0	36971009	4283893		0
35017	2078	40481087	1996-03-21	1996-03-21 00:00:00	1996-04-11	1996-04-11 00:00:00	32020		\N	138394	0	444814009	40481087		0
35082	2082	375671	1972-10-14	1972-10-14 00:00:00	1972-11-13	1972-11-13 00:00:00	32020		\N	138662	0	62564004	375671		0
35258	2088	40481087	2007-01-31	2007-01-31 00:00:00	2007-02-07	2007-02-07 00:00:00	32020		\N	139267	0	444814009	40481087		0
45988	2739	40481087	1955-04-16	1955-04-16 00:00:00	1955-04-23	1955-04-23 00:00:00	32020		\N	181259	0	444814009	40481087		0
35666	2114	40481087	1981-12-01	1981-12-01 00:00:00	1981-12-15	1981-12-15 00:00:00	32020		\N	140643	0	444814009	40481087		0
35782	2119	40481087	1998-04-08	1998-04-08 00:00:00	1998-04-29	1998-04-29 00:00:00	32020		\N	141084	0	444814009	40481087		0
35923	2130	4112343	1977-02-18	1977-02-18 00:00:00	1977-03-03	1977-03-03 00:00:00	32020		\N	141696	0	195662009	4112343		0
36148	2141	28060	1949-09-07	1949-09-07 00:00:00	1949-09-18	1949-09-18 00:00:00	32020		\N	142636	0	43878008	28060		0
36303	2150	4146173	1976-07-14	1976-07-14 00:00:00	1976-08-13	1976-08-13 00:00:00	32020		\N	143168	0	307731004	4146173		0
36500	2160	4156265	2002-03-31	2002-03-31 00:00:00	2002-04-21	2002-04-21 00:00:00	32020		\N	143920	0	370247008	4156265		0
36631	2167	4266809	2017-09-21	2017-09-21 00:00:00	\N	\N	32020		\N	144388	0	397881000	4266809		0
36786	2176	260139	1959-01-08	1959-01-08 00:00:00	1959-01-22	1959-01-22 00:00:00	32020		\N	145122	0	10509002	260139		0
36975	2189	4112343	2003-04-01	2003-04-01 00:00:00	2003-04-14	2003-04-14 00:00:00	32020		\N	145921	0	195662009	4112343		0
37038	2192	260139	1959-08-10	1959-08-10 00:00:00	1959-08-17	1959-08-17 00:00:00	32020		\N	146221	0	10509002	260139		0
37295	2210	4146173	2003-07-23	2003-07-23 00:00:00	2003-09-21	2003-09-21 00:00:00	32020		\N	147218	0	307731004	4146173		0
37474	2222	4155034	2014-02-16	2014-02-16 00:00:00	2014-03-02	2014-03-02 00:00:00	32020		\N	147958	0	283371005	4155034		0
37575	2228	40481087	1999-07-23	1999-07-23 00:00:00	1999-08-13	1999-08-13 00:00:00	32020		\N	148268	0	444814009	40481087		0
37729	2237	260139	1936-05-05	1936-05-05 00:00:00	1936-05-12	1936-05-12 00:00:00	32020		\N	148744	0	10509002	260139		0
37993	2256	4230399	1985-05-04	1985-05-04 00:00:00	1985-07-03	1985-07-03 00:00:00	32020		\N	149936	0	359817006	4230399		0
48662	2882	260139	1990-09-06	1990-09-06 00:00:00	1990-09-13	1990-09-13 00:00:00	32020		\N	191711	0	10509002	260139		0
38294	2274	257012	2013-05-22	2013-05-22 00:00:00	\N	\N	32020		\N	151197	0	40055000	257012		0
48999	2899	372328	1950-03-23	1950-03-23 00:00:00	1950-05-04	1950-05-04 00:00:00	32020		\N	193174	0	65363002	372328		0
38675	2294	40481087	1973-01-27	1973-01-27 00:00:00	1973-02-03	1973-02-03 00:00:00	32020		\N	152731	0	444814009	40481087		0
38778	2300	4112343	2003-01-18	2003-01-18 00:00:00	2003-01-31	2003-01-31 00:00:00	32020		\N	153179	0	195662009	4112343		0
38985	2318	4112343	1978-01-10	1978-01-10 00:00:00	1978-01-22	1978-01-22 00:00:00	32020		\N	154119	0	195662009	4112343		0
49635	2936	260139	1997-06-22	1997-06-22 00:00:00	1997-06-29	1997-06-29 00:00:00	32020		\N	195757	0	10509002	260139		0
39222	2328	260139	2015-12-26	2015-12-26 00:00:00	2016-01-02	2016-01-02 00:00:00	32020		\N	154858	0	10509002	260139		0
39482	2340	4112343	1990-06-18	1990-06-18 00:00:00	1990-06-29	1990-06-29 00:00:00	32020		\N	155734	0	195662009	4112343		0
39555	2343	40481087	1980-02-19	1980-02-19 00:00:00	1980-03-04	1980-03-04 00:00:00	32020		\N	155951	0	444814009	40481087		0
39797	2357	4116491	1995-11-15	1995-11-15 00:00:00	1995-12-26	1995-12-26 00:00:00	32020		\N	156983	0	301011002	4116491		0
39960	2367	28060	2018-06-26	2018-06-26 00:00:00	2018-07-08	2018-07-08 00:00:00	32020		\N	157582	0	43878008	28060		0
40102	2380	40481087	2016-11-28	2016-11-28 00:00:00	2016-12-12	2016-12-12 00:00:00	32020		\N	158214	0	444814009	40481087		0
40271	2389	40481087	1981-01-06	1981-01-06 00:00:00	1981-01-13	1981-01-13 00:00:00	32020		\N	158858	0	444814009	40481087		0
40375	2395	4112343	1978-12-25	1978-12-25 00:00:00	1979-01-05	1979-01-05 00:00:00	32020		\N	159265	0	195662009	4112343		0
40620	2414	40481087	1994-11-22	1994-11-22 00:00:00	1994-12-06	1994-12-06 00:00:00	32020		\N	160226	0	444814009	40481087		0
40794	2425	257012	1964-05-05	1964-05-05 00:00:00	\N	\N	32020		\N	160940	0	40055000	257012		0
40956	2436	40481087	1940-12-26	1940-12-26 00:00:00	1941-01-09	1941-01-09 00:00:00	32020		\N	161497	0	444814009	40481087		0
51670	3064	372328	1941-04-25	1941-04-25 00:00:00	1941-09-18	1941-09-18 00:00:00	32020		\N	203964	0	65363002	372328		0
41313	2456	40481087	1987-03-08	1987-03-08 00:00:00	1987-03-22	1987-03-22 00:00:00	32020		\N	162820	0	444814009	40481087		0
41453	2466	4112343	1981-05-11	1981-05-11 00:00:00	1981-05-24	1981-05-24 00:00:00	32020		\N	163503	0	195662009	4112343		0
41630	2476	81151	1970-02-27	1970-02-27 00:00:00	1970-03-20	1970-03-20 00:00:00	32020		\N	164116	0	44465007	81151		0
41744	2483	4112343	1980-05-27	1980-05-27 00:00:00	1980-06-07	1980-06-07 00:00:00	32020		\N	164516	0	195662009	4112343		0
52487	3109	80180	1953-10-16	1953-10-16 00:00:00	\N	\N	32020		\N	206843	0	396275006	80180		0
52643	3117	4310024	2007-01-20	2007-01-20 00:00:00	\N	\N	32020		\N	207391	0	424802006	4310024		0
52828	3129	4027663	2004-05-09	2004-05-09 00:00:00	\N	\N	32020		\N	208250	0	13200003	4027663		0
52984	3137	260139	1910-06-13	1910-06-13 00:00:00	1910-06-27	1910-06-27 00:00:00	32020		\N	208830	0	10509002	260139		0
32025	1902	40481087	2008-03-07	2008-03-07 00:00:00	2008-03-14	2008-03-14 00:00:00	32020		\N	126648	0	444814009	40481087		0
42704	2545	375671	1986-05-18	1986-05-18 00:00:00	1986-07-17	1986-07-17 00:00:00	32020		\N	168457	0	62564004	375671		0
32361	1923	372328	1948-09-29	1948-09-29 00:00:00	1949-09-02	1949-09-02 00:00:00	32020		\N	127857	0	65363002	372328		0
32512	1929	4112343	1974-01-07	1974-01-07 00:00:00	1974-01-15	1974-01-15 00:00:00	32020		\N	128461	0	195662009	4112343		0
32570	1934	4112343	2001-04-22	2001-04-22 00:00:00	2001-04-30	2001-04-30 00:00:00	32020		\N	128653	0	195662009	4112343		0
43333	2580	30753	1993-11-22	1993-11-22 00:00:00	\N	\N	32020		\N	170891	0	16761005	30753		0
32935	1953	4278672	1964-06-17	1964-06-17 00:00:00	1964-07-17	1964-07-17 00:00:00	32020		\N	129882	0	65966004	4278672		0
33137	1966	4218389	2003-06-08	2003-06-08 00:00:00	2003-07-06	2003-07-06 00:00:00	32020		\N	130739	0	39848009	4218389		0
33290	1976	372328	1986-12-20	1986-12-20 00:00:00	1987-11-30	1987-11-30 00:00:00	32020		\N	131380	0	65363002	372328		0
33512	1987	4112343	1954-02-12	1954-02-12 00:00:00	1954-02-25	1954-02-25 00:00:00	32020		\N	132331	0	195662009	4112343		0
33600	1992	80180	2019-01-26	2019-01-26 00:00:00	\N	\N	32020		\N	132764	0	396275006	80180		0
33770	2005	260139	1988-07-24	1988-07-24 00:00:00	1988-08-07	1988-08-07 00:00:00	32020		\N	133521	0	10509002	260139		0
44492	2647	28060	1977-02-23	1977-02-23 00:00:00	1977-03-04	1977-03-04 00:00:00	32020		\N	175111	0	43878008	28060		0
34147	2028	40481087	1954-08-04	1954-08-04 00:00:00	1954-08-25	1954-08-25 00:00:00	32020		\N	134988	0	444814009	40481087		0
34307	2034	40481087	1992-06-10	1992-06-10 00:00:00	1992-06-17	1992-06-17 00:00:00	32020		\N	135463	0	444814009	40481087		0
45000	2677	40481087	2000-09-01	2000-09-01 00:00:00	2000-09-22	2000-09-22 00:00:00	32020		\N	177430	0	444814009	40481087		0
34580	2053	40481087	1961-09-24	1961-09-24 00:00:00	1961-10-08	1961-10-08 00:00:00	32020		\N	136509	0	444814009	40481087		0
45355	2697	192671	1976-01-06	1976-01-06 00:00:00	\N	\N	32020		\N	178605	0	K92.2	35208414		0
35018	2078	4218389	2008-05-23	2008-05-23 00:00:00	2008-06-13	2008-06-13 00:00:00	32020		\N	138383	0	39848009	4218389		0
35083	2082	40481087	1990-08-15	1990-08-15 00:00:00	1990-08-22	1990-08-22 00:00:00	32020		\N	138708	0	444814009	40481087		0
35259	2088	258780	1967-11-14	1967-11-14 00:00:00	\N	\N	32020		\N	139249	0	185086009	258780		0
45989	2739	255848	2015-11-17	2015-11-17 00:00:00	\N	\N	32020		\N	181241	0	233604007	255848		0
35667	2114	4155034	1974-11-27	1974-11-27 00:00:00	1974-12-18	1974-12-18 00:00:00	32020		\N	140682	0	283371005	4155034		0
35800	2122	4112343	1990-04-28	1990-04-28 00:00:00	1990-05-10	1990-05-10 00:00:00	32020		\N	141189	0	195662009	4112343		0
35924	2130	40481087	1962-08-18	1962-08-18 00:00:00	1962-08-25	1962-08-25 00:00:00	32020		\N	141694	0	444814009	40481087		0
36149	2141	40481087	1995-10-30	1995-10-30 00:00:00	1995-11-13	1995-11-13 00:00:00	32020		\N	142662	0	444814009	40481087		0
36304	2150	40481087	2004-09-06	2004-09-06 00:00:00	2004-09-13	2004-09-13 00:00:00	32020		\N	143192	0	444814009	40481087		0
36501	2160	192671	1998-09-23	1998-09-23 00:00:00	\N	\N	32020		\N	143995	0	K92.2	35208414		0
36632	2167	4310024	2015-10-02	2015-10-02 00:00:00	\N	\N	32020		\N	144388	0	424802006	4310024		0
36787	2176	378001	1968-04-15	1968-04-15 00:00:00	1968-06-14	1968-06-14 00:00:00	32020		\N	145137	0	62106007	378001		0
36976	2189	40481087	1995-10-10	1995-10-10 00:00:00	1995-10-17	1995-10-17 00:00:00	32020		\N	145891	0	444814009	40481087		0
37039	2192	40481087	2005-06-24	2005-06-24 00:00:00	2005-07-01	2005-07-01 00:00:00	32020		\N	146230	0	444814009	40481087		0
37296	2210	4146173	2006-09-05	2006-09-05 00:00:00	2006-10-05	2006-10-05 00:00:00	32020		\N	147221	0	307731004	4146173		0
37475	2222	260139	1979-05-13	1979-05-13 00:00:00	1979-05-20	1979-05-20 00:00:00	32020		\N	147924	0	10509002	260139		0
37576	2228	80502	2007-04-21	2007-04-21 00:00:00	\N	\N	32020		\N	148242	0	64859006	80502		0
37730	2237	4112343	1973-01-29	1973-01-29 00:00:00	1973-02-06	1973-02-06 00:00:00	32020		\N	148849	0	195662009	4112343		0
37994	2256	28060	1989-05-17	1989-05-17 00:00:00	1989-05-29	1989-05-29 00:00:00	32020		\N	149961	0	43878008	28060		0
48663	2882	40481087	1984-10-11	1984-10-11 00:00:00	1984-10-25	1984-10-25 00:00:00	32020		\N	191726	0	444814009	40481087		0
38295	2274	4156265	1997-11-22	1997-11-22 00:00:00	1997-12-13	1997-12-13 00:00:00	32020		\N	151210	0	370247008	4156265		0
49000	2899	4112343	2004-02-28	2004-02-28 00:00:00	2004-03-11	2004-03-11 00:00:00	32020		\N	193147	0	195662009	4112343		0
38676	2294	40481087	1963-04-19	1963-04-19 00:00:00	1963-05-10	1963-05-10 00:00:00	32020		\N	152712	0	444814009	40481087		0
38779	2300	80180	1990-07-30	1990-07-30 00:00:00	\N	\N	32020		\N	153165	0	396275006	80180		0
38986	2318	4112343	1972-01-02	1972-01-02 00:00:00	1972-01-11	1972-01-11 00:00:00	32020		\N	154037	0	195662009	4112343		0
49636	2936	4112343	2019-01-08	2019-01-08 00:00:00	2019-01-15	2019-01-15 00:00:00	32020		\N	195747	0	195662009	4112343		0
39223	2328	40481087	1981-10-02	1981-10-02 00:00:00	1981-10-09	1981-10-09 00:00:00	32020		\N	154807	0	444814009	40481087		0
39483	2340	372328	1961-06-06	1961-06-06 00:00:00	1961-08-10	1961-08-10 00:00:00	32020		\N	155736	0	65363002	372328		0
39556	2343	4218389	1986-03-12	1986-03-12 00:00:00	1986-04-09	1986-04-09 00:00:00	32020		\N	155981	0	39848009	4218389		0
39798	2357	4296205	1952-07-04	1952-07-04 00:00:00	1952-07-25	1952-07-25 00:00:00	32020		\N	157003	0	403191005	4296205		0
39961	2367	40481087	1978-10-17	1978-10-17 00:00:00	1978-11-07	1978-11-07 00:00:00	32020		\N	157558	0	444814009	40481087		0
40103	2380	40481087	1972-05-29	1972-05-29 00:00:00	1972-06-19	1972-06-19 00:00:00	32020		\N	158210	0	444814009	40481087		0
40272	2389	81151	1974-01-05	1974-01-05 00:00:00	1974-01-26	1974-01-26 00:00:00	32020		\N	158840	0	44465007	81151		0
40376	2395	4134304	1973-01-21	1973-01-21 00:00:00	1973-04-21	1973-04-21 00:00:00	32020		\N	159238	0	263102004	4134304		0
40621	2414	372328	1924-01-03	1924-01-03 00:00:00	1924-03-20	1924-03-20 00:00:00	32020		\N	160229	0	65363002	372328		0
40795	2425	28060	1961-10-13	1961-10-13 00:00:00	1961-10-20	1961-10-20 00:00:00	32020		\N	160939	0	43878008	28060		0
40957	2436	40481087	1984-03-21	1984-03-21 00:00:00	1984-03-28	1984-03-28 00:00:00	32020		\N	161589	0	444814009	40481087		0
51671	3064	40481087	1957-01-09	1957-01-09 00:00:00	1957-01-23	1957-01-23 00:00:00	32020		\N	203921	0	444814009	40481087		0
41326	2458	81151	1981-09-23	1981-09-23 00:00:00	1981-10-21	1981-10-21 00:00:00	32020		\N	162941	0	44465007	81151		0
41454	2466	134438	2002-09-17	2002-09-17 00:00:00	2003-12-10	2003-12-10 00:00:00	32020		\N	163510	0	40275004	134438		0
41631	2476	4152936	1978-08-05	1978-08-05 00:00:00	1978-08-19	1978-08-19 00:00:00	32020		\N	164117	0	283385000	4152936		0
41745	2483	40481087	1968-05-03	1968-05-03 00:00:00	1968-05-24	1968-05-24 00:00:00	32020		\N	164524	0	444814009	40481087		0
52488	3109	260139	1931-02-05	1931-02-05 00:00:00	1931-02-19	1931-02-19 00:00:00	32020		\N	206769	0	10509002	260139		0
52644	3117	192671	2008-05-11	2008-05-11 00:00:00	\N	\N	32020		\N	207387	0	K92.2	35208414		0
52829	3129	4059173	2008-08-31	2008-08-31 00:00:00	2008-09-30	2008-09-30 00:00:00	32020		\N	208249	0	16114001	4059173		0
52985	3137	28060	1928-06-23	1928-06-23 00:00:00	1928-07-03	1928-07-03 00:00:00	32020		\N	208851	0	43878008	28060		0
32026	1902	4059173	1958-01-13	1958-01-13 00:00:00	1958-02-12	1958-02-12 00:00:00	32020		\N	126623	0	16114001	4059173		0
42705	2545	378001	1951-08-15	1951-08-15 00:00:00	1951-09-14	1951-09-14 00:00:00	32020		\N	168454	0	62106007	378001		0
32362	1923	40481087	1980-11-01	1980-11-01 00:00:00	1980-11-22	1980-11-22 00:00:00	32020		\N	127906	0	444814009	40481087		0
32513	1929	40481087	1981-10-12	1981-10-12 00:00:00	1981-10-26	1981-10-26 00:00:00	32020		\N	128440	0	444814009	40481087		0
32571	1934	4156265	2001-11-02	2001-11-02 00:00:00	2001-11-23	2001-11-23 00:00:00	32020		\N	128625	0	370247008	4156265		0
43334	2580	4285898	1994-05-21	1994-05-21 00:00:00	\N	\N	32020		\N	170891	0	68496003	4285898		0
32936	1953	4112343	2008-08-05	2008-08-05 00:00:00	2008-08-14	2008-08-14 00:00:00	32020		\N	129910	0	195662009	4112343		0
33138	1966	4112343	2006-08-24	2006-08-24 00:00:00	2006-09-01	2006-09-01 00:00:00	32020		\N	130702	0	195662009	4112343		0
33291	1976	80180	2017-11-01	2017-11-01 00:00:00	\N	\N	32020		\N	131410	0	396275006	80180		0
33513	1987	4112343	2006-04-03	2006-04-03 00:00:00	2006-04-15	2006-04-15 00:00:00	32020		\N	132339	0	195662009	4112343		0
33601	1992	30753	2018-03-02	2018-03-02 00:00:00	\N	\N	32020		\N	132764	0	16761005	30753		0
33771	2005	40481087	1985-06-13	1985-06-13 00:00:00	1985-07-04	1985-07-04 00:00:00	32020		\N	133520	0	444814009	40481087		0
44493	2647	372328	1973-02-12	1973-02-12 00:00:00	1973-05-20	1973-05-20 00:00:00	32020		\N	175166	0	65363002	372328		0
34148	2028	4156265	1984-07-13	1984-07-13 00:00:00	1984-07-27	1984-07-27 00:00:00	32020		\N	134952	0	370247008	4156265		0
34308	2034	40481087	2007-02-28	2007-02-28 00:00:00	2007-03-07	2007-03-07 00:00:00	32020		\N	135415	0	444814009	40481087		0
45001	2677	40481087	1972-10-20	1972-10-20 00:00:00	1972-11-02	1972-11-02 00:00:00	32020		\N	177411	0	444814009	40481087		0
34581	2053	4283893	1995-03-24	1995-03-24 00:00:00	1995-08-11	1995-08-11 00:00:00	32020		\N	136517	0	36971009	4283893		0
45356	2697	260139	2001-06-15	2001-06-15 00:00:00	2001-06-22	2001-06-22 00:00:00	32020		\N	178563	0	10509002	260139		0
35019	2078	260139	1994-08-07	1994-08-07 00:00:00	1994-08-14	1994-08-14 00:00:00	32020		\N	138428	0	10509002	260139		0
35084	2082	28060	1997-03-17	1997-03-17 00:00:00	1997-03-29	1997-03-29 00:00:00	32020		\N	138678	0	43878008	28060		0
35260	2088	40481087	1935-02-09	1935-02-09 00:00:00	1935-02-16	1935-02-16 00:00:00	32020		\N	139168	0	444814009	40481087		0
45990	2740	28060	1988-03-28	1988-03-28 00:00:00	1988-04-10	1988-04-10 00:00:00	32020		\N	181286	0	43878008	28060		0
35668	2114	40481087	1974-07-29	1974-07-29 00:00:00	1974-08-19	1974-08-19 00:00:00	32020		\N	140668	0	444814009	40481087		0
35801	2122	4112343	1987-10-27	1987-10-27 00:00:00	1987-11-07	1987-11-07 00:00:00	32020		\N	141195	0	195662009	4112343		0
35925	2130	40481087	2012-10-29	2012-10-29 00:00:00	2012-11-19	2012-11-19 00:00:00	32020		\N	141734	0	444814009	40481087		0
36150	2141	260139	1959-03-12	1959-03-12 00:00:00	1959-03-26	1959-03-26 00:00:00	32020		\N	142639	0	10509002	260139		0
36305	2150	260139	1989-06-30	1989-06-30 00:00:00	1989-07-07	1989-07-07 00:00:00	32020		\N	143191	0	10509002	260139		0
36502	2160	4310024	1997-04-28	1997-04-28 00:00:00	\N	\N	32020		\N	143983	0	424802006	4310024		0
36633	2167	80180	2017-09-21	2017-09-21 00:00:00	\N	\N	32020		\N	144388	0	396275006	80180		0
36788	2176	40481087	1997-05-19	1997-05-19 00:00:00	1997-06-09	1997-06-09 00:00:00	32020		\N	145160	0	444814009	40481087		0
36977	2189	28060	1998-04-02	1998-04-02 00:00:00	1998-04-11	1998-04-11 00:00:00	32020		\N	145920	0	43878008	28060		0
37040	2192	257012	1979-07-19	1979-07-19 00:00:00	\N	\N	32020		\N	146228	0	40055000	257012		0
37297	2210	40481087	1985-10-15	1985-10-15 00:00:00	1985-10-29	1985-10-29 00:00:00	32020		\N	147253	0	444814009	40481087		0
37476	2222	40481087	1974-05-09	1974-05-09 00:00:00	1974-05-16	1974-05-16 00:00:00	32020		\N	147930	0	444814009	40481087		0
37577	2228	40481087	1964-09-21	1964-09-21 00:00:00	1964-09-28	1964-09-28 00:00:00	32020		\N	148201	0	444814009	40481087		0
37731	2237	4112343	1939-05-22	1939-05-22 00:00:00	1939-05-30	1939-05-30 00:00:00	32020		\N	148745	0	195662009	4112343		0
37995	2256	4146173	1984-05-09	1984-05-09 00:00:00	1984-07-08	1984-07-08 00:00:00	32020		\N	149966	0	307731004	4146173		0
48664	2882	4051466	1975-05-19	1975-05-19 00:00:00	1993-12-24	1993-12-24 00:00:00	32020		\N	191707	0	233678006	4051466		0
38296	2274	40481087	2010-06-24	2010-06-24 00:00:00	2010-07-08	2010-07-08 00:00:00	32020		\N	151172	0	444814009	40481087		0
49001	2899	4112343	2012-05-30	2012-05-30 00:00:00	2012-06-10	2012-06-10 00:00:00	32020		\N	193149	0	195662009	4112343		0
38677	2295	40481087	1986-11-22	1986-11-22 00:00:00	1986-11-29	1986-11-29 00:00:00	32020		\N	152794	0	444814009	40481087		0
38780	2300	4112343	1990-03-30	1990-03-30 00:00:00	1990-04-07	1990-04-07 00:00:00	32020		\N	153165	0	195662009	4112343		0
38987	2318	4294548	2013-09-21	2013-09-21 00:00:00	2014-01-04	2014-01-04 00:00:00	32020		\N	154050	0	75498004	4294548		0
49637	2936	40479768	1989-03-03	1989-03-03 00:00:00	1989-05-09	1989-05-09 00:00:00	32020		\N	195769	0	444470001	40479768		0
39224	2328	257012	1992-11-17	1992-11-17 00:00:00	\N	\N	32020		\N	154867	0	40055000	257012		0
39484	2340	372328	1961-01-22	1961-01-22 00:00:00	1961-02-05	1961-02-05 00:00:00	32020		\N	155746	0	65363002	372328		0
39557	2343	260139	2002-11-05	2002-11-05 00:00:00	2002-11-12	2002-11-12 00:00:00	32020		\N	155953	0	10509002	260139		0
39799	2357	4112343	1958-12-26	1958-12-26 00:00:00	1959-01-07	1959-01-07 00:00:00	32020		\N	157018	0	195662009	4112343		0
39962	2367	260139	1978-03-14	1978-03-14 00:00:00	1978-03-21	1978-03-21 00:00:00	32020		\N	157575	0	10509002	260139		0
40104	2380	260139	1950-06-28	1950-06-28 00:00:00	1950-07-12	1950-07-12 00:00:00	32020		\N	158225	0	10509002	260139		0
40273	2389	4112343	2013-12-03	2013-12-03 00:00:00	2013-12-16	2013-12-16 00:00:00	32020		\N	158876	0	195662009	4112343		0
40377	2395	375671	1975-03-12	1975-03-12 00:00:00	1975-04-11	1975-04-11 00:00:00	32020		\N	159239	0	62564004	375671		0
40622	2414	378419	1996-08-29	1996-08-29 00:00:00	\N	\N	32020		\N	160264	0	26929004	378419		0
40796	2425	4134304	1968-04-27	1968-04-27 00:00:00	1968-06-26	1968-06-26 00:00:00	32020		\N	160872	0	263102004	4134304		0
40958	2436	40481087	1916-07-22	1916-07-22 00:00:00	1916-08-12	1916-08-12 00:00:00	32020		\N	161579	0	444814009	40481087		0
51672	3064	40481087	1992-07-21	1992-07-21 00:00:00	1992-08-04	1992-08-04 00:00:00	32020		\N	203939	0	444814009	40481087		0
41327	2458	40481087	2008-05-09	2008-05-09 00:00:00	2008-05-23	2008-05-23 00:00:00	32020		\N	162960	0	444814009	40481087		0
41455	2466	80180	2018-11-24	2018-11-24 00:00:00	\N	\N	32020		\N	163488	0	396275006	80180		0
41632	2476	40481087	1974-07-06	1974-07-06 00:00:00	1974-07-20	1974-07-20 00:00:00	32020		\N	164071	0	444814009	40481087		0
41746	2483	80180	1984-08-11	1984-08-11 00:00:00	\N	\N	32020		\N	164509	0	396275006	80180		0
52489	3109	4112343	1955-05-07	1955-05-07 00:00:00	1955-05-19	1955-05-19 00:00:00	32020		\N	206849	0	195662009	4112343		0
52645	3117	375671	1999-11-13	1999-11-13 00:00:00	1999-12-13	1999-12-13 00:00:00	32020		\N	207398	0	62564004	375671		0
52830	3129	40481087	2006-03-14	2006-03-14 00:00:00	2006-04-04	2006-04-04 00:00:00	32020		\N	208290	0	444814009	40481087		0
52986	3137	4116491	1939-04-10	1939-04-10 00:00:00	1939-05-18	1939-05-18 00:00:00	32020		\N	208852	0	301011002	4116491		0
32027	1903	78272	1973-07-21	1973-07-21 00:00:00	1973-08-11	1973-08-11 00:00:00	32020		\N	126663	0	70704007	78272		0
42706	2545	28060	1988-05-16	1988-05-16 00:00:00	1988-05-29	1988-05-29 00:00:00	32020		\N	168391	0	43878008	28060		0
32363	1923	4156265	1938-10-16	1938-10-16 00:00:00	1938-10-30	1938-10-30 00:00:00	32020		\N	127997	0	370247008	4156265		0
32514	1929	40481087	1985-02-16	1985-02-16 00:00:00	1985-03-09	1985-03-09 00:00:00	32020		\N	128462	0	444814009	40481087		0
32572	1934	372328	1963-04-29	1963-04-29 00:00:00	1963-07-06	1963-07-06 00:00:00	32020		\N	128636	0	65363002	372328		0
43335	2580	4310024	1993-01-26	1993-01-26 00:00:00	\N	\N	32020		\N	170891	0	424802006	4310024		0
32937	1953	260139	1993-07-26	1993-07-26 00:00:00	1993-08-09	1993-08-09 00:00:00	32020		\N	129907	0	10509002	260139		0
33139	1966	28060	1973-04-25	1973-04-25 00:00:00	1973-05-02	1973-05-02 00:00:00	32020		\N	130671	0	43878008	28060		0
33292	1976	4218389	2010-07-01	2010-07-01 00:00:00	2010-07-22	2010-07-22 00:00:00	32020		\N	131374	0	39848009	4218389		0
33514	1987	4113008	1993-10-19	1993-10-19 00:00:00	1993-11-09	1993-11-09 00:00:00	32020		\N	132289	0	284549007	4113008		0
33602	1992	40481087	2015-12-19	2015-12-19 00:00:00	2016-01-02	2016-01-02 00:00:00	32020		\N	132757	0	444814009	40481087		0
33772	2005	28060	1979-11-12	1979-11-12 00:00:00	1979-11-25	1979-11-25 00:00:00	32020		\N	133510	0	43878008	28060		0
44494	2647	4112343	2011-02-16	2011-02-16 00:00:00	2011-02-28	2011-02-28 00:00:00	32020		\N	175218	0	195662009	4112343		0
34149	2028	4296204	2015-12-03	2015-12-03 00:00:00	2015-12-31	2015-12-31 00:00:00	32020		\N	134977	0	403190006	4296204		0
34309	2034	4112343	1983-09-22	1983-09-22 00:00:00	1983-10-04	1983-10-04 00:00:00	32020		\N	135412	0	195662009	4112343		0
45002	2677	260139	2016-05-04	2016-05-04 00:00:00	2016-05-11	2016-05-11 00:00:00	32020		\N	177348	0	10509002	260139		0
34582	2053	4218389	1989-09-21	1989-09-21 00:00:00	1989-10-12	1989-10-12 00:00:00	32020		\N	136569	0	39848009	4218389		0
45357	2697	372328	1936-07-14	1936-07-14 00:00:00	1936-09-24	1936-09-24 00:00:00	32020		\N	178567	0	65363002	372328		0
35020	2079	81151	2002-07-03	2002-07-03 00:00:00	2002-07-17	2002-07-17 00:00:00	32020		\N	138489	0	44465007	81151		0
35085	2082	4112343	1949-06-12	1949-06-12 00:00:00	1949-06-23	1949-06-23 00:00:00	32020		\N	138706	0	195662009	4112343		0
35261	2088	260139	1938-12-28	1938-12-28 00:00:00	1939-01-04	1939-01-04 00:00:00	32020		\N	139259	0	10509002	260139		0
45991	2740	260139	2008-08-31	2008-08-31 00:00:00	2008-09-14	2008-09-14 00:00:00	32020		\N	181273	0	10509002	260139		0
35669	2114	40481087	1982-09-17	1982-09-17 00:00:00	1982-10-08	1982-10-08 00:00:00	32020		\N	140687	0	444814009	40481087		0
35802	2122	260139	2017-09-07	2017-09-07 00:00:00	2017-09-21	2017-09-21 00:00:00	32020		\N	141197	0	10509002	260139		0
35926	2130	257012	2001-04-12	2001-04-12 00:00:00	\N	\N	32020		\N	141730	0	40055000	257012		0
36151	2141	40481087	1980-03-08	1980-03-08 00:00:00	1980-03-22	1980-03-22 00:00:00	32020		\N	142642	0	444814009	40481087		0
36306	2150	260139	1954-12-27	1954-12-27 00:00:00	1955-01-10	1955-01-10 00:00:00	32020		\N	143188	0	10509002	260139		0
36503	2160	81893	1997-06-27	1997-06-27 00:00:00	\N	\N	32020		\N	143983	0	64766004	81893		0
36634	2167	81893	2016-02-29	2016-02-29 00:00:00	\N	\N	32020		\N	144388	0	64766004	81893		0
36789	2176	372328	1957-09-14	1957-09-14 00:00:00	1957-10-28	1957-10-28 00:00:00	32020		\N	145109	0	65363002	372328		0
36978	2189	260139	1981-03-31	1981-03-31 00:00:00	1981-04-07	1981-04-07 00:00:00	32020		\N	145942	0	10509002	260139		0
37041	2192	260139	1956-05-18	1956-05-18 00:00:00	1956-05-25	1956-05-25 00:00:00	32020		\N	146219	0	10509002	260139		0
37298	2210	40481087	1965-10-24	1965-10-24 00:00:00	1965-11-07	1965-11-07 00:00:00	32020		\N	147212	0	444814009	40481087		0
37477	2222	260139	1987-06-07	1987-06-07 00:00:00	1987-06-21	1987-06-21 00:00:00	32020		\N	147931	0	10509002	260139		0
37578	2228	4112343	1980-05-15	1980-05-15 00:00:00	1980-05-28	1980-05-28 00:00:00	32020		\N	148264	0	195662009	4112343		0
37732	2237	4218389	1940-08-10	1940-08-10 00:00:00	1940-09-14	1940-09-14 00:00:00	32020		\N	148804	0	39848009	4218389		0
37996	2256	40481087	2005-08-23	2005-08-23 00:00:00	2005-09-06	2005-09-06 00:00:00	32020		\N	149926	0	444814009	40481087		0
48665	2882	4112343	2006-07-08	2006-07-08 00:00:00	2006-07-16	2006-07-16 00:00:00	32020		\N	191712	0	195662009	4112343		0
38297	2274	4155034	1966-07-26	1966-07-26 00:00:00	1966-08-09	1966-08-09 00:00:00	32020		\N	151207	0	283371005	4155034		0
49002	2899	81151	1967-08-21	1967-08-21 00:00:00	1967-09-25	1967-09-25 00:00:00	32020		\N	193179	0	44465007	81151		0
38678	2295	260139	1994-09-16	1994-09-16 00:00:00	1994-09-30	1994-09-30 00:00:00	32020		\N	152774	0	10509002	260139		0
38842	2307	40481087	1989-12-09	1989-12-09 00:00:00	1989-12-23	1989-12-23 00:00:00	32020		\N	153528	0	444814009	40481087		0
38988	2318	40481087	1996-08-10	1996-08-10 00:00:00	1996-08-17	1996-08-17 00:00:00	32020		\N	154094	0	444814009	40481087		0
49638	2936	40481087	1965-06-15	1965-06-15 00:00:00	1965-07-06	1965-07-06 00:00:00	32020		\N	195816	0	444814009	40481087		0
39225	2328	260139	1975-09-06	1975-09-06 00:00:00	1975-09-20	1975-09-20 00:00:00	32020		\N	154864	0	10509002	260139		0
39485	2340	372328	1962-11-02	1962-11-02 00:00:00	1963-02-06	1963-02-06 00:00:00	32020		\N	155747	0	65363002	372328		0
39558	2343	40481087	2012-08-16	2012-08-16 00:00:00	2012-08-30	2012-08-30 00:00:00	32020		\N	156011	0	444814009	40481087		0
39800	2357	40481087	1956-05-06	1956-05-06 00:00:00	1956-05-20	1956-05-20 00:00:00	32020		\N	157017	0	444814009	40481087		0
39963	2367	378001	1987-03-23	1987-03-23 00:00:00	1987-04-22	1987-04-22 00:00:00	32020		\N	157573	0	62106007	378001		0
40105	2380	260139	1960-04-20	1960-04-20 00:00:00	1960-05-04	1960-05-04 00:00:00	32020		\N	158184	0	10509002	260139		0
40274	2389	4294548	1986-09-22	1986-09-22 00:00:00	1987-02-09	1987-02-09 00:00:00	32020		\N	158835	0	75498004	4294548		0
40378	2395	4112343	2015-10-08	2015-10-08 00:00:00	2015-10-20	2015-10-20 00:00:00	32020		\N	159274	0	195662009	4112343		0
40623	2414	80180	1957-04-14	1957-04-14 00:00:00	\N	\N	32020		\N	160179	0	396275006	80180		0
40797	2425	81151	1991-04-27	1991-04-27 00:00:00	1991-05-11	1991-05-11 00:00:00	32020		\N	160873	0	44465007	81151		0
40959	2436	378001	1976-08-01	1976-08-01 00:00:00	1976-09-30	1976-09-30 00:00:00	32020		\N	161575	0	62106007	378001		0
51673	3064	375671	1984-01-04	1984-01-04 00:00:00	1984-02-03	1984-02-03 00:00:00	32020		\N	204000	0	62564004	375671		0
41328	2458	4059173	2015-02-28	2015-02-28 00:00:00	2015-04-29	2015-04-29 00:00:00	32020		\N	162945	0	16114001	4059173		0
41456	2466	260139	2004-04-26	2004-04-26 00:00:00	2004-05-03	2004-05-03 00:00:00	32020		\N	163506	0	10509002	260139		0
41633	2477	372328	1956-03-23	1956-03-23 00:00:00	1956-05-06	1956-05-06 00:00:00	32020		\N	164167	0	65363002	372328		0
41747	2483	81151	1945-12-24	1945-12-24 00:00:00	1946-01-07	1946-01-07 00:00:00	32020		\N	164510	0	44465007	81151		0
52490	3109	40481087	1979-02-13	1979-02-13 00:00:00	1979-02-20	1979-02-20 00:00:00	32020		\N	206830	0	444814009	40481087		0
52646	3117	4112343	1995-05-01	1995-05-01 00:00:00	1995-05-10	1995-05-10 00:00:00	32020		\N	207377	0	195662009	4112343		0
52831	3129	40481087	1975-01-02	1975-01-02 00:00:00	1975-01-09	1975-01-09 00:00:00	32020		\N	208288	0	444814009	40481087		0
52987	3137	375671	1910-03-13	1910-03-13 00:00:00	1910-05-12	1910-05-12 00:00:00	32020		\N	208836	0	62564004	375671		0
32028	1903	260139	1995-09-14	1995-09-14 00:00:00	1995-09-28	1995-09-28 00:00:00	32020		\N	126657	0	10509002	260139		0
42707	2545	372328	1948-06-10	1948-06-10 00:00:00	1948-07-01	1948-07-01 00:00:00	32020		\N	168394	0	65363002	372328		0
32364	1923	4112343	1970-10-22	1970-10-22 00:00:00	1970-10-30	1970-10-30 00:00:00	32020		\N	127904	0	195662009	4112343		0
32515	1929	372328	1990-12-01	1990-12-01 00:00:00	1991-11-07	1991-11-07 00:00:00	32020		\N	128395	0	65363002	372328		0
32573	1934	4218389	1999-01-19	1999-01-19 00:00:00	1999-02-16	1999-02-16 00:00:00	32020		\N	128624	0	39848009	4218389		0
43336	2580	4112343	1962-04-22	1962-04-22 00:00:00	1962-05-02	1962-05-02 00:00:00	32020		\N	170878	0	195662009	4112343		0
32938	1953	80502	2014-10-27	2014-10-27 00:00:00	\N	\N	32020		\N	129945	0	64859006	80502		0
33140	1966	4116491	1992-04-17	1992-04-17 00:00:00	1992-06-07	1992-06-07 00:00:00	32020		\N	130716	0	301011002	4116491		0
33293	1976	4112343	2004-08-30	2004-08-30 00:00:00	2004-09-10	2004-09-10 00:00:00	32020		\N	131408	0	195662009	4112343		0
33515	1987	80180	1981-04-25	1981-04-25 00:00:00	\N	\N	32020		\N	132308	0	396275006	80180		0
33603	1992	4310024	2017-02-05	2017-02-05 00:00:00	\N	\N	32020		\N	132690	0	424802006	4310024		0
33773	2005	28060	2003-12-04	2003-12-04 00:00:00	2003-12-12	2003-12-12 00:00:00	32020		\N	133525	0	43878008	28060		0
44495	2647	4294548	2014-10-06	2014-10-06 00:00:00	2014-11-03	2014-11-03 00:00:00	32020		\N	175165	0	75498004	4294548		0
34150	2028	4112343	1956-11-09	1956-11-09 00:00:00	1956-11-18	1956-11-18 00:00:00	32020		\N	134969	0	195662009	4112343		0
34310	2034	40481087	1951-11-24	1951-11-24 00:00:00	1951-12-08	1951-12-08 00:00:00	32020		\N	135446	0	444814009	40481087		0
45003	2677	4112343	1991-02-02	1991-02-02 00:00:00	1991-02-12	1991-02-12 00:00:00	32020		\N	177380	0	195662009	4112343		0
34583	2053	4112343	1962-09-04	1962-09-04 00:00:00	1962-09-14	1962-09-14 00:00:00	32020		\N	136502	0	195662009	4112343		0
45358	2697	317576	1981-05-14	1981-05-14 00:00:00	\N	\N	32020		\N	178615	0	53741008	317576		0
35021	2079	4112343	1960-03-06	1960-03-06 00:00:00	1960-03-13	1960-03-13 00:00:00	32020		\N	138445	0	195662009	4112343		0
35086	2082	40481087	1943-12-25	1943-12-25 00:00:00	1944-01-01	1944-01-01 00:00:00	32020		\N	138712	0	444814009	40481087		0
35262	2088	28060	1941-04-17	1941-04-17 00:00:00	1941-04-24	1941-04-24 00:00:00	32020		\N	139169	0	43878008	28060		0
45992	2740	260139	1975-11-05	1975-11-05 00:00:00	1975-11-12	1975-11-12 00:00:00	32020		\N	181285	0	10509002	260139		0
35670	2114	372328	1970-07-06	1970-07-06 00:00:00	1971-01-13	1971-01-13 00:00:00	32020		\N	140648	0	65363002	372328		0
35803	2122	4112343	1987-06-21	1987-06-21 00:00:00	1987-06-28	1987-06-28 00:00:00	32020		\N	141173	0	195662009	4112343		0
35927	2130	40481087	1983-11-25	1983-11-25 00:00:00	1983-12-09	1983-12-09 00:00:00	32020		\N	141746	0	444814009	40481087		0
36152	2141	40481087	1966-07-06	1966-07-06 00:00:00	1966-07-13	1966-07-13 00:00:00	32020		\N	142655	0	444814009	40481087		0
36307	2150	4112343	1977-04-07	1977-04-07 00:00:00	1977-04-19	1977-04-19 00:00:00	32020		\N	143169	0	195662009	4112343		0
36504	2160	260139	1995-11-14	1995-11-14 00:00:00	1995-11-21	1995-11-21 00:00:00	32020		\N	143983	0	10509002	260139		0
36635	2167	40481087	1999-12-05	1999-12-05 00:00:00	1999-12-26	1999-12-26 00:00:00	32020		\N	144349	0	444814009	40481087		0
36790	2176	28060	1991-09-13	1991-09-13 00:00:00	1991-09-20	1991-09-20 00:00:00	32020		\N	145107	0	43878008	28060		0
36979	2189	260139	2004-04-08	2004-04-08 00:00:00	2004-04-22	2004-04-22 00:00:00	32020		\N	145906	0	10509002	260139		0
37042	2192	260139	1997-01-11	1997-01-11 00:00:00	1997-01-18	1997-01-18 00:00:00	32020		\N	146174	0	10509002	260139		0
37299	2210	4294548	1975-09-06	1975-09-06 00:00:00	1976-02-28	1976-02-28 00:00:00	32020		\N	147169	0	75498004	4294548		0
37478	2222	372328	1963-12-20	1963-12-20 00:00:00	1964-03-03	1964-03-03 00:00:00	32020		\N	147892	0	65363002	372328		0
37579	2228	4116491	2007-01-17	2007-01-17 00:00:00	2007-03-06	2007-03-06 00:00:00	32020		\N	148250	0	301011002	4116491		0
37733	2237	40481087	2001-12-02	2001-12-02 00:00:00	2001-12-16	2001-12-16 00:00:00	32020		\N	148748	0	444814009	40481087		0
37997	2256	260139	1992-09-05	1992-09-05 00:00:00	1992-09-19	1992-09-19 00:00:00	32020		\N	149951	0	10509002	260139		0
48666	2882	40481087	1993-12-14	1993-12-14 00:00:00	1994-01-04	1994-01-04 00:00:00	32020		\N	191727	0	444814009	40481087		0
38298	2274	260139	1967-09-19	1967-09-19 00:00:00	1967-10-03	1967-10-03 00:00:00	32020		\N	151135	0	10509002	260139		0
49003	2899	40481087	1970-04-16	1970-04-16 00:00:00	1970-04-23	1970-04-23 00:00:00	32020		\N	193178	0	444814009	40481087		0
49137	2906	372328	1929-12-26	1929-12-26 00:00:00	1930-03-29	1930-03-29 00:00:00	32020		\N	193628	0	65363002	372328		0
38843	2307	40481087	1970-09-24	1970-09-24 00:00:00	1970-10-15	1970-10-15 00:00:00	32020		\N	153482	0	444814009	40481087		0
38989	2318	40481087	1995-11-22	1995-11-22 00:00:00	1995-12-06	1995-12-06 00:00:00	32020		\N	154044	0	444814009	40481087		0
49639	2936	40481087	1972-12-24	1972-12-24 00:00:00	1973-01-14	1973-01-14 00:00:00	32020		\N	195737	0	444814009	40481087		0
39226	2328	40481087	2018-04-04	2018-04-04 00:00:00	2018-04-25	2018-04-25 00:00:00	32020		\N	154822	0	444814009	40481087		0
39486	2340	260139	1963-02-12	1963-02-12 00:00:00	1963-02-26	1963-02-26 00:00:00	32020		\N	155764	0	10509002	260139		0
39559	2343	40481087	1996-11-09	1996-11-09 00:00:00	1996-11-23	1996-11-23 00:00:00	32020		\N	156009	0	444814009	40481087		0
39801	2357	4112343	1967-06-28	1967-06-28 00:00:00	1967-07-05	1967-07-05 00:00:00	32020		\N	157081	0	195662009	4112343		0
39964	2367	40481087	2009-11-22	2009-11-22 00:00:00	2009-12-13	2009-12-13 00:00:00	32020		\N	157552	0	444814009	40481087		0
40106	2380	260139	2002-09-28	2002-09-28 00:00:00	2002-10-12	2002-10-12 00:00:00	32020		\N	158190	0	10509002	260139		0
40275	2389	40481087	1971-03-28	1971-03-28 00:00:00	1971-04-04	1971-04-04 00:00:00	32020		\N	158887	0	444814009	40481087		0
40379	2395	40481087	1963-08-26	1963-08-26 00:00:00	1963-09-09	1963-09-09 00:00:00	32020		\N	159242	0	444814009	40481087		0
40624	2414	4112343	1961-12-27	1961-12-27 00:00:00	1962-01-07	1962-01-07 00:00:00	32020		\N	160196	0	195662009	4112343		0
40798	2425	81893	1993-06-04	1993-06-04 00:00:00	\N	\N	32020		\N	160873	0	64766004	81893		0
40960	2436	4156265	1992-03-10	1992-03-10 00:00:00	1992-03-31	1992-03-31 00:00:00	32020		\N	161577	0	370247008	4156265		0
51674	3064	192671	1975-06-26	1975-06-26 00:00:00	\N	\N	32020		\N	203944	0	K92.2	35208414		0
41329	2458	40481087	2002-06-26	2002-06-26 00:00:00	2002-07-03	2002-07-03 00:00:00	32020		\N	162978	0	444814009	40481087		0
41457	2466	260139	1979-10-17	1979-10-17 00:00:00	1979-10-30	1979-10-30 00:00:00	32020		\N	163502	0	10509002	260139		0
41634	2477	4112343	2003-10-05	2003-10-05 00:00:00	2003-10-18	2003-10-18 00:00:00	32020		\N	164165	0	195662009	4112343		0
41748	2483	260139	1946-07-24	1946-07-24 00:00:00	1946-07-31	1946-07-31 00:00:00	32020		\N	164482	0	10509002	260139		0
52491	3109	81151	1925-02-05	1925-02-05 00:00:00	1925-02-19	1925-02-19 00:00:00	32020		\N	206703	0	44465007	81151		0
52647	3117	260139	1985-10-28	1985-10-28 00:00:00	1985-11-04	1985-11-04 00:00:00	32020		\N	207379	0	10509002	260139		0
52832	3129	40481087	1979-04-24	1979-04-24 00:00:00	1979-05-08	1979-05-08 00:00:00	32020		\N	208283	0	444814009	40481087		0
52988	3137	4116491	1947-06-27	1947-06-27 00:00:00	1947-08-14	1947-08-14 00:00:00	32020		\N	208780	0	301011002	4116491		0
32029	1903	40481087	2012-10-16	2012-10-16 00:00:00	2012-10-23	2012-10-23 00:00:00	32020		\N	126710	0	444814009	40481087		0
42708	2545	40481087	1984-02-10	1984-02-10 00:00:00	1984-02-24	1984-02-24 00:00:00	32020		\N	168431	0	444814009	40481087		0
32365	1923	80180	1972-06-29	1972-06-29 00:00:00	\N	\N	32020		\N	127960	0	396275006	80180		0
32516	1929	40481087	1989-07-23	1989-07-23 00:00:00	1989-08-06	1989-08-06 00:00:00	32020		\N	128425	0	444814009	40481087		0
32574	1934	4296204	1992-04-11	1992-04-11 00:00:00	1992-04-25	1992-04-25 00:00:00	32020		\N	128623	0	403190006	4296204		0
43337	2580	40481087	1971-09-04	1971-09-04 00:00:00	1971-09-25	1971-09-25 00:00:00	32020		\N	170879	0	444814009	40481087		0
32939	1953	372328	1969-05-06	1969-05-06 00:00:00	1969-09-01	1969-09-01 00:00:00	32020		\N	129871	0	65363002	372328		0
33141	1966	260139	1978-10-24	1978-10-24 00:00:00	1978-11-07	1978-11-07 00:00:00	32020		\N	130704	0	10509002	260139		0
33294	1976	4134304	1993-05-26	1993-05-26 00:00:00	1993-06-25	1993-06-25 00:00:00	32020		\N	131375	0	263102004	4134304		0
33516	1987	372328	1964-09-10	1964-09-10 00:00:00	1966-06-03	1966-06-03 00:00:00	32020		\N	132359	0	65363002	372328		0
33604	1992	81893	2017-07-05	2017-07-05 00:00:00	\N	\N	32020		\N	132690	0	64766004	81893		0
33774	2005	4112343	2005-04-21	2005-04-21 00:00:00	2005-04-30	2005-04-30 00:00:00	32020		\N	133522	0	195662009	4112343		0
44496	2647	80180	2014-08-19	2014-08-19 00:00:00	\N	\N	32020		\N	175146	0	396275006	80180		0
34151	2028	260139	1980-01-17	1980-01-17 00:00:00	1980-02-01	1980-02-01 00:00:00	32020		\N	134951	0	10509002	260139		0
34311	2034	4027663	1953-04-10	1953-04-10 00:00:00	\N	\N	32020		\N	135446	0	13200003	4027663		0
45004	2677	4112343	2004-07-08	2004-07-08 00:00:00	2004-07-18	2004-07-18 00:00:00	32020		\N	177419	0	195662009	4112343		0
34584	2053	372328	1957-06-28	1957-06-28 00:00:00	1958-01-30	1958-01-30 00:00:00	32020		\N	136480	0	65363002	372328		0
45359	2697	40481087	1980-07-22	1980-07-22 00:00:00	1980-08-05	1980-08-05 00:00:00	32020		\N	178562	0	444814009	40481087		0
35022	2079	378001	1974-08-08	1974-08-08 00:00:00	1974-09-07	1974-09-07 00:00:00	32020		\N	138478	0	62106007	378001		0
35087	2082	375671	2004-11-25	2004-11-25 00:00:00	2004-12-25	2004-12-25 00:00:00	32020		\N	138718	0	62564004	375671		0
35263	2088	40481087	1981-12-29	1981-12-29 00:00:00	1982-01-05	1982-01-05 00:00:00	32020		\N	139202	0	444814009	40481087		0
45993	2740	4113008	2016-02-02	2016-02-02 00:00:00	2016-02-16	2016-02-16 00:00:00	32020		\N	181284	0	284549007	4113008		0
35671	2114	260139	1990-04-18	1990-04-18 00:00:00	1990-04-25	1990-04-25 00:00:00	32020		\N	140671	0	10509002	260139		0
35804	2122	4155034	1995-03-11	1995-03-11 00:00:00	1995-04-01	1995-04-01 00:00:00	32020		\N	141216	0	283371005	4155034		0
35928	2130	4112343	2008-04-21	2008-04-21 00:00:00	2008-05-03	2008-05-03 00:00:00	32020		\N	141733	0	195662009	4112343		0
36153	2141	4112343	2004-07-25	2004-07-25 00:00:00	2004-08-07	2004-08-07 00:00:00	32020		\N	142663	0	195662009	4112343		0
36308	2150	40481087	1961-11-28	1961-11-28 00:00:00	1961-12-12	1961-12-12 00:00:00	32020		\N	143156	0	444814009	40481087		0
36505	2160	260139	1989-01-11	1989-01-11 00:00:00	1989-01-18	1989-01-18 00:00:00	32020		\N	143981	0	10509002	260139		0
36636	2167	40481087	1996-10-01	1996-10-01 00:00:00	1996-10-15	1996-10-15 00:00:00	32020		\N	144347	0	444814009	40481087		0
36791	2176	78272	1994-12-25	1994-12-25 00:00:00	1995-01-29	1995-01-29 00:00:00	32020		\N	145138	0	70704007	78272		0
36980	2189	80180	2012-11-16	2012-11-16 00:00:00	\N	\N	32020		\N	145984	0	396275006	80180		0
37043	2192	4112343	1992-01-19	1992-01-19 00:00:00	1992-01-28	1992-01-28 00:00:00	32020		\N	146172	0	195662009	4112343		0
37300	2210	260139	2016-05-10	2016-05-10 00:00:00	2016-05-24	2016-05-24 00:00:00	32020		\N	147219	0	10509002	260139		0
37479	2222	40481087	1980-11-14	1980-11-14 00:00:00	1980-11-28	1980-11-28 00:00:00	32020		\N	147907	0	444814009	40481087		0
37580	2228	4109685	2016-01-17	2016-01-17 00:00:00	2016-02-07	2016-02-07 00:00:00	32020		\N	148279	0	284551006	4109685		0
37734	2237	78272	1990-02-15	1990-02-15 00:00:00	1990-03-22	1990-03-22 00:00:00	32020		\N	148807	0	70704007	78272		0
37998	2256	4112343	1993-05-12	1993-05-12 00:00:00	1993-05-19	1993-05-19 00:00:00	32020		\N	149917	0	195662009	4112343		0
48667	2882	4112343	1996-07-20	1996-07-20 00:00:00	1996-07-28	1996-07-28 00:00:00	32020		\N	191699	0	195662009	4112343		0
38299	2274	40481087	1970-09-06	1970-09-06 00:00:00	1970-09-13	1970-09-13 00:00:00	32020		\N	151167	0	444814009	40481087		0
49004	2899	4112343	1981-12-15	1981-12-15 00:00:00	1981-12-23	1981-12-23 00:00:00	32020		\N	193146	0	195662009	4112343		0
49138	2906	372328	1925-05-19	1925-05-19 00:00:00	1925-06-20	1925-06-20 00:00:00	32020		\N	193694	0	65363002	372328		0
38844	2307	40481087	2006-08-04	2006-08-04 00:00:00	2006-08-11	2006-08-11 00:00:00	32020		\N	153529	0	444814009	40481087		0
38990	2318	4112343	1964-01-24	1964-01-24 00:00:00	1964-02-01	1964-02-01 00:00:00	32020		\N	154040	0	195662009	4112343		0
49640	2936	4112343	2009-08-18	2009-08-18 00:00:00	2009-08-26	2009-08-26 00:00:00	32020		\N	195758	0	195662009	4112343		0
39227	2328	4283893	1993-08-22	1993-08-22 00:00:00	1993-10-03	1993-10-03 00:00:00	32020		\N	154854	0	36971009	4283893		0
39487	2340	4112343	1984-10-03	1984-10-03 00:00:00	1984-10-13	1984-10-13 00:00:00	32020		\N	155732	0	195662009	4112343		0
39560	2343	40481087	1972-01-10	1972-01-10 00:00:00	1972-01-24	1972-01-24 00:00:00	32020		\N	155950	0	444814009	40481087		0
39802	2357	40481087	1993-08-23	1993-08-23 00:00:00	1993-08-30	1993-08-30 00:00:00	32020		\N	157038	0	444814009	40481087		0
39965	2367	4296204	1983-03-16	1983-03-16 00:00:00	1983-04-13	1983-04-13 00:00:00	32020		\N	157572	0	403190006	4296204		0
40107	2380	4112343	1989-11-26	1989-11-26 00:00:00	1989-12-03	1989-12-03 00:00:00	32020		\N	158188	0	195662009	4112343		0
40276	2389	40481087	2017-08-27	2017-08-27 00:00:00	2017-09-03	2017-09-03 00:00:00	32020		\N	158861	0	444814009	40481087		0
40380	2396	372328	1920-08-15	1920-08-15 00:00:00	1920-10-27	1920-10-27 00:00:00	32020		\N	159299	0	65363002	372328		0
40625	2414	4116491	1980-04-02	1980-04-02 00:00:00	1980-05-08	1980-05-08 00:00:00	32020		\N	160222	0	301011002	4116491		0
40799	2425	4112343	1971-09-29	1971-09-29 00:00:00	1971-10-08	1971-10-08 00:00:00	32020		\N	160875	0	195662009	4112343		0
40961	2436	260139	2009-04-13	2009-04-13 00:00:00	2009-04-27	2009-04-27 00:00:00	32020		\N	161452	0	10509002	260139		0
51675	3064	4152936	1962-05-24	1962-05-24 00:00:00	1962-06-07	1962-06-07 00:00:00	32020		\N	203997	0	283385000	4152936		0
41330	2458	80180	2006-03-01	2006-03-01 00:00:00	\N	\N	32020		\N	162997	0	396275006	80180		0
41458	2466	260139	2000-06-14	2000-06-14 00:00:00	2000-06-28	2000-06-28 00:00:00	32020		\N	163490	0	10509002	260139		0
41635	2477	4112343	1993-10-01	1993-10-01 00:00:00	1993-10-09	1993-10-09 00:00:00	32020		\N	164209	0	195662009	4112343		0
41756	2485	78272	2004-08-24	2004-08-24 00:00:00	2004-09-21	2004-09-21 00:00:00	32020		\N	164691	0	70704007	78272		0
52492	3109	4283893	1985-03-24	1985-03-24 00:00:00	1985-07-14	1985-07-14 00:00:00	32020		\N	206751	0	36971009	4283893		0
52648	3117	40481087	2000-10-01	2000-10-01 00:00:00	2000-10-08	2000-10-08 00:00:00	32020		\N	207342	0	444814009	40481087		0
52833	3129	40481087	1998-06-28	1998-06-28 00:00:00	1998-07-19	1998-07-19 00:00:00	32020		\N	208275	0	444814009	40481087		0
52989	3137	381316	1987-11-14	1987-11-14 00:00:00	\N	\N	32020		\N	208867	0	230690007	381316		0
32030	1903	40481087	2010-09-06	2010-09-06 00:00:00	2010-09-20	2010-09-20 00:00:00	32020		\N	126709	0	444814009	40481087		0
42709	2545	80180	1987-01-02	1987-01-02 00:00:00	\N	\N	32020		\N	168386	0	396275006	80180		0
32366	1923	40481087	2004-06-25	2004-06-25 00:00:00	2004-07-09	2004-07-09 00:00:00	32020		\N	127937	0	444814009	40481087		0
32517	1929	40481087	1964-04-01	1964-04-01 00:00:00	1964-04-08	1964-04-08 00:00:00	32020		\N	128390	0	444814009	40481087		0
32575	1934	372328	1963-12-03	1963-12-03 00:00:00	1964-01-04	1964-01-04 00:00:00	32020		\N	128637	0	65363002	372328		0
43338	2580	260139	2015-08-21	2015-08-21 00:00:00	2015-08-28	2015-08-28 00:00:00	32020		\N	170868	0	10509002	260139		0
32940	1953	4116491	2002-07-28	2002-07-28 00:00:00	2002-09-11	2002-09-11 00:00:00	32020		\N	129901	0	301011002	4116491		0
33142	1966	260139	2013-07-12	2013-07-12 00:00:00	2013-07-26	2013-07-26 00:00:00	32020		\N	130673	0	10509002	260139		0
33295	1976	40481087	2003-08-10	2003-08-10 00:00:00	2003-08-17	2003-08-17 00:00:00	32020		\N	131407	0	444814009	40481087		0
33526	1989	4109685	1984-01-26	1984-01-26 00:00:00	1984-02-16	1984-02-16 00:00:00	32020		\N	132478	0	284551006	4109685		0
33605	1992	81151	2016-09-18	2016-09-18 00:00:00	2016-10-23	2016-10-23 00:00:00	32020		\N	132690	0	44465007	81151		0
33775	2005	372328	1977-10-12	1977-10-12 00:00:00	1978-07-22	1978-07-22 00:00:00	32020		\N	133483	0	65363002	372328		0
44497	2647	40481087	1993-04-09	1993-04-09 00:00:00	1993-04-23	1993-04-23 00:00:00	32020		\N	175161	0	444814009	40481087		0
34152	2028	260139	2007-01-12	2007-01-12 00:00:00	2007-01-19	2007-01-19 00:00:00	32020		\N	134975	0	10509002	260139		0
34312	2034	40481087	1974-05-25	1974-05-25 00:00:00	1974-06-08	1974-06-08 00:00:00	32020		\N	135436	0	444814009	40481087		0
45005	2677	30753	2006-05-02	2006-05-02 00:00:00	\N	\N	32020		\N	177419	0	16761005	30753		0
34585	2053	81151	2000-11-13	2000-11-13 00:00:00	2000-12-11	2000-12-11 00:00:00	32020		\N	136570	0	44465007	81151		0
45360	2697	40481087	1947-05-19	1947-05-19 00:00:00	1947-05-26	1947-05-26 00:00:00	32020		\N	178570	0	444814009	40481087		0
35023	2079	260139	1970-05-25	1970-05-25 00:00:00	1970-06-01	1970-06-01 00:00:00	32020		\N	138475	0	10509002	260139		0
35088	2082	28060	1978-08-11	1978-08-11 00:00:00	1978-08-20	1978-08-20 00:00:00	32020		\N	138677	0	43878008	28060		0
35264	2088	80502	1989-07-25	1989-07-25 00:00:00	\N	\N	32020		\N	139235	0	64859006	80502		0
45994	2740	40481087	2007-12-01	2007-12-01 00:00:00	2007-12-22	2007-12-22 00:00:00	32020		\N	181308	0	444814009	40481087		0
35672	2114	4155034	1971-09-23	1971-09-23 00:00:00	1971-10-14	1971-10-14 00:00:00	32020		\N	140681	0	283371005	4155034		0
35805	2122	260139	1982-03-09	1982-03-09 00:00:00	1982-03-16	1982-03-16 00:00:00	32020		\N	141188	0	10509002	260139		0
35929	2130	40481087	1990-06-10	1990-06-10 00:00:00	1990-06-17	1990-06-17 00:00:00	32020		\N	141728	0	444814009	40481087		0
36154	2141	81151	1955-03-23	1955-03-23 00:00:00	1955-04-06	1955-04-06 00:00:00	32020		\N	142600	0	44465007	81151		0
36309	2150	260139	1968-02-25	1968-02-25 00:00:00	1968-03-03	1968-03-03 00:00:00	32020		\N	143167	0	10509002	260139		0
36506	2160	4056621	1993-09-16	1993-09-16 00:00:00	\N	\N	32020		\N	143962	0	197927001	4056621		0
36637	2167	40481087	2018-01-01	2018-01-01 00:00:00	2018-01-22	2018-01-22 00:00:00	32020		\N	144351	0	444814009	40481087		0
36792	2176	4283893	1968-03-19	1968-03-19 00:00:00	1968-04-30	1968-04-30 00:00:00	32020		\N	145124	0	36971009	4283893		0
36981	2189	4112343	2012-04-15	2012-04-15 00:00:00	2012-04-24	2012-04-24 00:00:00	32020		\N	145993	0	195662009	4112343		0
37045	2192	321042	2001-12-06	2001-12-06 00:00:00	\N	\N	32020		\N	146244	0	410429000	321042		0
37301	2210	4112343	1990-09-08	1990-09-08 00:00:00	1990-09-19	1990-09-19 00:00:00	32020		\N	147216	0	195662009	4112343		0
37510	2226	4112343	1965-11-17	1965-11-17 00:00:00	1965-11-29	1965-11-29 00:00:00	32020		\N	148138	0	195662009	4112343		0
37581	2228	40481087	2015-02-22	2015-02-22 00:00:00	2015-03-15	2015-03-15 00:00:00	32020		\N	148278	0	444814009	40481087		0
37735	2237	80180	1967-01-16	1967-01-16 00:00:00	\N	\N	32020		\N	148774	0	396275006	80180		0
37999	2256	80180	2012-03-23	2012-03-23 00:00:00	\N	\N	32020		\N	149935	0	396275006	80180		0
48668	2882	80180	2005-09-21	2005-09-21 00:00:00	\N	\N	32020		\N	191688	0	396275006	80180		0
38300	2274	40481087	1959-04-11	1959-04-11 00:00:00	1959-05-02	1959-05-02 00:00:00	32020		\N	151191	0	444814009	40481087		0
49005	2899	4237458	1979-01-25	1979-01-25 00:00:00	1979-02-24	1979-02-24 00:00:00	32020		\N	193180	0	58150001	4237458		0
49139	2906	78272	1958-11-13	1958-11-13 00:00:00	1958-12-18	1958-12-18 00:00:00	32020		\N	193723	0	70704007	78272		0
49303	2915	28060	1950-07-18	1950-07-18 00:00:00	1950-07-30	1950-07-30 00:00:00	32020		\N	194338	0	43878008	28060		0
38991	2318	4112343	1987-12-16	1987-12-16 00:00:00	1987-12-24	1987-12-24 00:00:00	32020		\N	154042	0	195662009	4112343		0
49641	2936	4112343	2000-12-19	2000-12-19 00:00:00	2000-12-31	2000-12-31 00:00:00	32020		\N	195782	0	195662009	4112343		0
39228	2328	40481087	2017-07-19	2017-07-19 00:00:00	2017-08-02	2017-08-02 00:00:00	32020		\N	154872	0	444814009	40481087		0
39488	2340	80180	1999-05-14	1999-05-14 00:00:00	\N	\N	32020		\N	155717	0	396275006	80180		0
39561	2343	40481087	2007-04-30	2007-04-30 00:00:00	2007-05-07	2007-05-07 00:00:00	32020		\N	156010	0	444814009	40481087		0
39803	2357	28060	1951-01-14	1951-01-14 00:00:00	1951-01-24	1951-01-24 00:00:00	32020		\N	156933	0	43878008	28060		0
39967	2369	4084167	1981-12-29	1981-12-29 00:00:00	1981-12-29	1981-12-29 00:00:00	32020		\N	157732	0	241929008	4084167		0
40108	2380	260139	1961-04-30	1961-04-30 00:00:00	1961-05-07	1961-05-07 00:00:00	32020		\N	158177	0	10509002	260139		0
40277	2389	4112343	1979-06-10	1979-06-10 00:00:00	1979-06-22	1979-06-22 00:00:00	32020		\N	158834	0	195662009	4112343		0
40381	2396	80180	1961-08-30	1961-08-30 00:00:00	\N	\N	32020		\N	159369	0	396275006	80180		0
40626	2414	78272	1929-06-05	1929-06-05 00:00:00	1929-06-19	1929-06-19 00:00:00	32020		\N	160248	0	70704007	78272		0
40800	2425	40481087	1982-02-26	1982-02-26 00:00:00	1982-03-12	1982-03-12 00:00:00	32020		\N	160892	0	444814009	40481087		0
40962	2436	260139	1961-09-18	1961-09-18 00:00:00	1961-10-02	1961-10-02 00:00:00	32020		\N	161499	0	10509002	260139		0
51676	3064	4113008	1990-07-01	1990-07-01 00:00:00	1990-07-15	1990-07-15 00:00:00	32020		\N	204001	0	284549007	4113008		0
41331	2458	40481087	1998-03-03	1998-03-03 00:00:00	1998-03-10	1998-03-10 00:00:00	32020		\N	162947	0	444814009	40481087		0
41459	2466	4155034	1996-08-17	1996-08-17 00:00:00	1996-09-07	1996-09-07 00:00:00	32020		\N	163501	0	283371005	4155034		0
41636	2477	4112343	2007-04-04	2007-04-04 00:00:00	2007-04-12	2007-04-12 00:00:00	32020		\N	164181	0	195662009	4112343		0
41757	2485	260139	1920-04-28	1920-04-28 00:00:00	1920-05-12	1920-05-12 00:00:00	32020		\N	164571	0	10509002	260139		0
52493	3109	40481087	1979-10-26	1979-10-26 00:00:00	1979-11-16	1979-11-16 00:00:00	32020		\N	206750	0	444814009	40481087		0
52649	3118	372328	1951-05-08	1951-05-08 00:00:00	1951-09-09	1951-09-09 00:00:00	32020		\N	207531	0	65363002	372328		0
52834	3129	4112343	2012-05-05	2012-05-05 00:00:00	2012-05-17	2012-05-17 00:00:00	32020		\N	208256	0	195662009	4112343		0
52990	3137	4112343	1921-12-27	1921-12-27 00:00:00	1922-01-09	1922-01-09 00:00:00	32020		\N	208822	0	195662009	4112343		0
33173	1967	40486433	1958-10-19	1958-10-19 00:00:00	\N	\N	32020		\N	130864	0	446096008	40486433		0
32031	1903	260139	1981-12-30	1981-12-30 00:00:00	1982-01-06	1982-01-06 00:00:00	32020		\N	126673	0	10509002	260139		0
42710	2545	4112343	1994-03-11	1994-03-11 00:00:00	1994-03-20	1994-03-20 00:00:00	32020		\N	168366	0	195662009	4112343		0
32367	1923	40481087	1967-10-15	1967-10-15 00:00:00	1967-11-05	1967-11-05 00:00:00	32020		\N	128009	0	444814009	40481087		0
32518	1929	372328	1957-08-15	1957-08-15 00:00:00	1958-01-23	1958-01-23 00:00:00	32020		\N	128441	0	65363002	372328		0
32576	1934	80180	2000-08-12	2000-08-12 00:00:00	\N	\N	32020		\N	128663	0	396275006	80180		0
43339	2580	260139	1991-10-03	1991-10-03 00:00:00	1991-10-10	1991-10-10 00:00:00	32020		\N	170882	0	10509002	260139		0
32941	1953	40481087	2000-01-04	2000-01-04 00:00:00	2000-01-11	2000-01-11 00:00:00	32020		\N	129905	0	444814009	40481087		0
33143	1966	78272	1990-12-22	1990-12-22 00:00:00	1991-01-12	1991-01-12 00:00:00	32020		\N	130738	0	70704007	78272		0
33296	1976	372328	1988-01-29	1988-01-29 00:00:00	1988-12-05	1988-12-05 00:00:00	32020		\N	131381	0	65363002	372328		0
33527	1989	4112343	2010-08-14	2010-08-14 00:00:00	2010-08-24	2010-08-24 00:00:00	32020		\N	132423	0	195662009	4112343		0
33606	1992	260139	1984-03-06	1984-03-06 00:00:00	1984-03-13	1984-03-13 00:00:00	32020		\N	132732	0	10509002	260139		0
33776	2005	4278672	2013-08-11	2013-08-11 00:00:00	2013-10-10	2013-10-10 00:00:00	32020		\N	133496	0	65966004	4278672		0
44498	2647	4059173	1996-06-29	1996-06-29 00:00:00	1996-09-27	1996-09-27 00:00:00	32020		\N	175139	0	16114001	4059173		0
34153	2028	378001	1955-10-14	1955-10-14 00:00:00	1955-11-13	1955-11-13 00:00:00	32020		\N	134948	0	62106007	378001		0
34313	2034	78272	1958-02-13	1958-02-13 00:00:00	1958-02-27	1958-02-27 00:00:00	32020		\N	135487	0	70704007	78272		0
45006	2677	192671	2007-01-26	2007-01-26 00:00:00	\N	\N	32020		\N	177356	0	K92.2	35208414		0
34586	2053	28060	1955-07-25	1955-07-25 00:00:00	1955-08-02	1955-08-02 00:00:00	32020		\N	136508	0	43878008	28060		0
45361	2697	40481087	1956-04-05	1956-04-05 00:00:00	1956-04-26	1956-04-26 00:00:00	32020		\N	178560	0	444814009	40481087		0
35024	2079	40481087	1996-06-01	1996-06-01 00:00:00	1996-06-08	1996-06-08 00:00:00	32020		\N	138468	0	444814009	40481087		0
35089	2082	80180	1975-09-15	1975-09-15 00:00:00	\N	\N	32020		\N	138668	0	396275006	80180		0
35265	2088	260139	1922-03-15	1922-03-15 00:00:00	1922-03-22	1922-03-22 00:00:00	32020		\N	139165	0	10509002	260139		0
45995	2740	4027663	2002-12-02	2002-12-02 00:00:00	\N	\N	32020		\N	181307	0	13200003	4027663		0
35673	2114	40481087	2009-06-30	2009-06-30 00:00:00	2009-07-21	2009-07-21 00:00:00	32020		\N	140645	0	444814009	40481087		0
35806	2122	80180	2013-08-01	2013-08-01 00:00:00	\N	\N	32020		\N	141191	0	396275006	80180		0
35930	2130	4294548	1983-03-13	1983-03-13 00:00:00	1983-05-22	1983-05-22 00:00:00	32020		\N	141745	0	75498004	4294548		0
36155	2141	40479768	1961-09-01	1961-09-01 00:00:00	1961-10-08	1961-10-08 00:00:00	32020		\N	142598	0	444470001	40479768		0
36310	2150	4112343	2017-08-30	2017-08-30 00:00:00	2017-09-10	2017-09-10 00:00:00	32020		\N	143179	0	195662009	4112343		0
36507	2160	4116491	1993-09-16	1993-09-16 00:00:00	1993-11-10	1993-11-10 00:00:00	32020		\N	143962	0	301011002	4116491		0
36638	2168	40481087	1976-03-31	1976-03-31 00:00:00	1976-04-21	1976-04-21 00:00:00	32020		\N	144457	0	444814009	40481087		0
36793	2176	4112343	1989-09-15	1989-09-15 00:00:00	1989-09-22	1989-09-22 00:00:00	32020		\N	145141	0	195662009	4112343		0
36982	2189	4156265	1988-09-18	1988-09-18 00:00:00	1988-10-02	1988-10-02 00:00:00	32020		\N	145890	0	370247008	4156265		0
37046	2192	28060	1963-04-12	1963-04-12 00:00:00	1963-04-20	1963-04-20 00:00:00	32020		\N	146195	0	43878008	28060		0
37303	2210	81151	1958-06-02	1958-06-02 00:00:00	1958-06-23	1958-06-23 00:00:00	32020		\N	147196	0	44465007	81151		0
37511	2226	81151	2008-11-23	2008-11-23 00:00:00	2008-12-14	2008-12-14 00:00:00	32020		\N	148170	0	44465007	81151		0
37603	2230	4296204	2009-10-05	2009-10-05 00:00:00	2009-11-02	2009-11-02 00:00:00	32020		\N	148401	0	403190006	4296204		0
37736	2237	4285898	1966-11-17	1966-11-17 00:00:00	\N	\N	32020		\N	148774	0	68496003	4285898		0
48485	2871	260139	1959-07-29	1959-07-29 00:00:00	1959-08-12	1959-08-12 00:00:00	32020		\N	191063	0	10509002	260139		0
48669	2882	4048171	1974-05-19	1974-05-19 00:00:00	\N	\N	32020		\N	191725	0	232353008	4048171		0
38301	2274	260139	2003-11-05	2003-11-05 00:00:00	2003-11-19	2003-11-19 00:00:00	32020		\N	151193	0	10509002	260139		0
49006	2899	80180	1990-09-04	1990-09-04 00:00:00	\N	\N	32020		\N	193188	0	396275006	80180		0
49140	2906	28060	2004-06-10	2004-06-10 00:00:00	2004-06-18	2004-06-18 00:00:00	32020		\N	193625	0	43878008	28060		0
49304	2915	260139	2007-07-07	2007-07-07 00:00:00	2007-07-14	2007-07-14 00:00:00	32020		\N	194275	0	10509002	260139		0
38992	2318	4112343	2015-06-24	2015-06-24 00:00:00	2015-07-03	2015-07-03 00:00:00	32020		\N	154097	0	195662009	4112343		0
49642	2936	378001	1979-09-22	1979-09-22 00:00:00	1979-11-21	1979-11-21 00:00:00	32020		\N	195768	0	62106007	378001		0
39229	2328	81893	1997-10-11	1997-10-11 00:00:00	\N	\N	32020		\N	154841	0	64766004	81893		0
39489	2340	4278672	1966-07-26	1966-07-26 00:00:00	1966-10-24	1966-10-24 00:00:00	32020		\N	155755	0	65966004	4278672		0
39562	2343	81151	1958-09-30	1958-09-30 00:00:00	1958-11-04	1958-11-04 00:00:00	32020		\N	155980	0	44465007	81151		0
39804	2357	28060	1993-10-02	1993-10-02 00:00:00	1993-10-10	1993-10-10 00:00:00	32020		\N	156982	0	43878008	28060		0
39968	2369	40481087	1995-02-26	1995-02-26 00:00:00	1995-03-12	1995-03-12 00:00:00	32020		\N	157663	0	444814009	40481087		0
40109	2380	40481087	1958-02-10	1958-02-10 00:00:00	1958-02-17	1958-02-17 00:00:00	32020		\N	158175	0	444814009	40481087		0
40278	2389	40481087	2017-02-09	2017-02-09 00:00:00	2017-02-23	2017-02-23 00:00:00	32020		\N	158860	0	444814009	40481087		0
40382	2396	40481087	1993-09-21	1993-09-21 00:00:00	1993-10-05	1993-10-05 00:00:00	32020		\N	159297	0	444814009	40481087		0
40627	2414	260139	1989-07-08	1989-07-08 00:00:00	1989-07-22	1989-07-22 00:00:00	32020		\N	160225	0	10509002	260139		0
40803	2427	260139	1975-07-21	1975-07-21 00:00:00	1975-08-04	1975-08-04 00:00:00	32020		\N	161030	0	10509002	260139		0
40963	2436	4112343	1985-04-14	1985-04-14 00:00:00	1985-04-27	1985-04-27 00:00:00	32020		\N	161590	0	195662009	4112343		0
51677	3064	378001	1944-03-24	1944-03-24 00:00:00	1944-05-23	1944-05-23 00:00:00	32020		\N	203994	0	62106007	378001		0
41332	2458	372328	1972-03-14	1972-03-14 00:00:00	1972-04-30	1972-04-30 00:00:00	32020		\N	162961	0	65363002	372328		0
41460	2466	4134304	1989-06-25	1989-06-25 00:00:00	1989-08-24	1989-08-24 00:00:00	32020		\N	163499	0	263102004	4134304		0
41637	2477	40481087	1956-09-25	1956-09-25 00:00:00	1956-10-16	1956-10-16 00:00:00	32020		\N	164174	0	444814009	40481087		0
41758	2485	40481087	1992-09-18	1992-09-18 00:00:00	1992-10-09	1992-10-09 00:00:00	32020		\N	164646	0	444814009	40481087		0
52494	3109	40481087	1944-11-02	1944-11-02 00:00:00	1944-11-16	1944-11-16 00:00:00	32020		\N	206770	0	444814009	40481087		0
52650	3118	4230399	1964-04-06	1964-04-06 00:00:00	1964-06-05	1964-06-05 00:00:00	32020		\N	207402	0	359817006	4230399		0
52835	3129	40481087	2012-04-15	2012-04-15 00:00:00	2012-04-29	2012-04-29 00:00:00	32020		\N	208252	0	444814009	40481087		0
52991	3137	372328	1912-03-02	1912-03-02 00:00:00	1912-03-30	1912-03-30 00:00:00	32020		\N	208868	0	65363002	372328		0
32032	1903	378001	2006-10-17	2006-10-17 00:00:00	2006-11-16	2006-11-16 00:00:00	32020		\N	126666	0	62106007	378001		0
42711	2545	40481087	1971-05-10	1971-05-10 00:00:00	1971-05-31	1971-05-31 00:00:00	32020		\N	168428	0	444814009	40481087		0
32368	1923	372328	1937-06-23	1937-06-23 00:00:00	1937-11-26	1937-11-26 00:00:00	32020		\N	127856	0	65363002	372328		0
32519	1929	4112343	2019-01-12	2019-01-12 00:00:00	2019-01-20	2019-01-20 00:00:00	32020		\N	128452	0	195662009	4112343		0
32577	1934	4283893	1987-12-01	1987-12-01 00:00:00	1987-12-22	1987-12-22 00:00:00	32020		\N	128634	0	36971009	4283893		0
43340	2580	372328	1962-10-07	1962-10-07 00:00:00	1963-05-20	1963-05-20 00:00:00	32020		\N	170897	0	65363002	372328		0
32942	1954	260139	1964-05-04	1964-05-04 00:00:00	1964-05-11	1964-05-11 00:00:00	32020		\N	130046	0	10509002	260139		0
33144	1966	4296204	2019-04-20	2019-04-20 00:00:00	2019-05-04	2019-05-04 00:00:00	32020		\N	130741	0	403190006	4296204		0
33297	1976	40486433	1985-12-26	1985-12-26 00:00:00	2001-12-24	2001-12-24 00:00:00	32020		\N	131338	0	446096008	40486433		0
33528	1989	4155034	1994-05-31	1994-05-31 00:00:00	1994-06-14	1994-06-14 00:00:00	32020		\N	132480	0	283371005	4155034		0
33607	1992	40481087	1995-08-31	1995-08-31 00:00:00	1995-09-07	1995-09-07 00:00:00	32020		\N	132660	0	444814009	40481087		0
33777	2005	192671	2010-02-12	2010-02-12 00:00:00	\N	\N	32020		\N	133519	0	K92.2	35208414		0
44499	2647	40481087	2000-12-07	2000-12-07 00:00:00	2000-12-14	2000-12-14 00:00:00	32020		\N	175163	0	444814009	40481087		0
34154	2028	4112343	1971-10-19	1971-10-19 00:00:00	1971-10-26	1971-10-26 00:00:00	32020		\N	134991	0	195662009	4112343		0
34314	2034	40481087	1940-06-11	1940-06-11 00:00:00	1940-06-25	1940-06-25 00:00:00	32020		\N	135444	0	444814009	40481087		0
45007	2677	260139	2009-07-02	2009-07-02 00:00:00	2009-07-09	2009-07-09 00:00:00	32020		\N	177339	0	10509002	260139		0
34587	2053	4112343	1965-12-30	1965-12-30 00:00:00	1966-01-12	1966-01-12 00:00:00	32020		\N	136474	0	195662009	4112343		0
45362	2697	372328	1933-07-19	1933-07-19 00:00:00	1933-09-28	1933-09-28 00:00:00	32020		\N	178599	0	65363002	372328		0
35025	2079	260139	1967-08-16	1967-08-16 00:00:00	1967-08-23	1967-08-23 00:00:00	32020		\N	138446	0	10509002	260139		0
35090	2082	4237458	2007-12-10	2007-12-10 00:00:00	2008-03-09	2008-03-09 00:00:00	32020		\N	138719	0	58150001	4237458		0
35266	2088	4113008	1955-09-21	1955-09-21 00:00:00	1955-10-12	1955-10-12 00:00:00	32020		\N	139179	0	284549007	4113008		0
45996	2740	40481087	2000-07-14	2000-07-14 00:00:00	2000-08-04	2000-08-04 00:00:00	32020		\N	181307	0	444814009	40481087		0
35674	2115	260139	2016-09-21	2016-09-21 00:00:00	2016-10-05	2016-10-05 00:00:00	32020		\N	140711	0	10509002	260139		0
35807	2122	4266809	2013-08-01	2013-08-01 00:00:00	\N	\N	32020		\N	141191	0	397881000	4266809		0
35931	2130	40481087	1977-02-13	1977-02-13 00:00:00	1977-03-06	1977-03-06 00:00:00	32020		\N	141743	0	444814009	40481087		0
36156	2141	80180	1978-06-20	1978-06-20 00:00:00	\N	\N	32020		\N	142590	0	396275006	80180		0
36311	2150	40481087	1964-02-01	1964-02-01 00:00:00	1964-02-08	1964-02-08 00:00:00	32020		\N	143165	0	444814009	40481087		0
36508	2160	4112343	1967-10-06	1967-10-06 00:00:00	1967-10-19	1967-10-19 00:00:00	32020		\N	143961	0	195662009	4112343		0
36639	2168	4059173	1959-07-30	1959-07-30 00:00:00	1959-09-28	1959-09-28 00:00:00	32020		\N	144573	0	16114001	4059173		0
36794	2176	4027663	1990-08-12	1990-08-12 00:00:00	\N	\N	32020		\N	145141	0	13200003	4027663		0
36983	2189	134438	2010-02-02	2010-02-02 00:00:00	2011-09-26	2011-09-26 00:00:00	32020		\N	145904	0	40275004	134438		0
37047	2192	40481087	1977-01-31	1977-01-31 00:00:00	1977-02-14	1977-02-14 00:00:00	32020		\N	146223	0	444814009	40481087		0
37304	2210	260139	1954-01-05	1954-01-05 00:00:00	1954-01-12	1954-01-12 00:00:00	32020		\N	147167	0	10509002	260139		0
37512	2226	260139	1971-02-23	1971-02-23 00:00:00	1971-03-02	1971-03-02 00:00:00	32020		\N	148144	0	10509002	260139		0
37604	2230	40481087	1975-11-01	1975-11-01 00:00:00	1975-11-08	1975-11-08 00:00:00	32020		\N	148387	0	444814009	40481087		0
37737	2237	4294548	2013-12-14	2013-12-14 00:00:00	2014-01-11	2014-01-11 00:00:00	32020		\N	148749	0	75498004	4294548		0
48486	2871	40481087	2015-05-26	2015-05-26 00:00:00	2015-06-16	2015-06-16 00:00:00	32020		\N	191146	0	444814009	40481087		0
48670	2883	40481087	1979-03-10	1979-03-10 00:00:00	1979-03-24	1979-03-24 00:00:00	32020		\N	191781	0	444814009	40481087		0
38302	2274	40481087	2018-10-27	2018-10-27 00:00:00	2018-11-17	2018-11-17 00:00:00	32020		\N	151140	0	444814009	40481087		0
49007	2899	80502	2009-10-22	2009-10-22 00:00:00	\N	\N	32020		\N	193167	0	64859006	80502		0
49141	2906	260139	1977-01-15	1977-01-15 00:00:00	1977-01-22	1977-01-22 00:00:00	32020		\N	193691	0	10509002	260139		0
49305	2915	4294548	1974-11-14	1974-11-14 00:00:00	1975-01-16	1975-01-16 00:00:00	32020		\N	194343	0	75498004	4294548		0
38993	2318	260139	1979-09-01	1979-09-01 00:00:00	1979-09-15	1979-09-15 00:00:00	32020		\N	154089	0	10509002	260139		0
49643	2936	40481087	1965-02-22	1965-02-22 00:00:00	1965-03-08	1965-03-08 00:00:00	32020		\N	195743	0	444814009	40481087		0
39230	2328	30753	1998-07-08	1998-07-08 00:00:00	\N	\N	32020		\N	154841	0	16761005	30753		0
39490	2340	4112343	1967-12-21	1967-12-21 00:00:00	1967-12-29	1967-12-29 00:00:00	32020		\N	155766	0	195662009	4112343		0
39563	2343	28060	1965-03-30	1965-03-30 00:00:00	1965-04-10	1965-04-10 00:00:00	32020		\N	156000	0	43878008	28060		0
39805	2357	260139	2005-01-25	2005-01-25 00:00:00	2005-02-01	2005-02-01 00:00:00	32020		\N	156962	0	10509002	260139		0
39969	2369	4051466	1984-05-09	1984-05-09 00:00:00	2001-04-01	2001-04-01 00:00:00	32020		\N	157672	0	233678006	4051466		0
40110	2380	40481087	1953-09-13	1953-09-13 00:00:00	1953-09-27	1953-09-27 00:00:00	32020		\N	158226	0	444814009	40481087		0
40279	2389	4027663	1999-03-25	1999-03-25 00:00:00	\N	\N	32020		\N	158873	0	13200003	4027663		0
40383	2396	81151	1946-01-15	1946-01-15 00:00:00	1946-01-29	1946-01-29 00:00:00	32020		\N	159320	0	44465007	81151		0
40628	2414	78272	1975-05-24	1975-05-24 00:00:00	1975-06-07	1975-06-07 00:00:00	32020		\N	160251	0	70704007	78272		0
40804	2427	4112343	2014-03-22	2014-03-22 00:00:00	2014-04-01	2014-04-01 00:00:00	32020		\N	161013	0	195662009	4112343		0
40964	2436	40481087	1913-11-13	1913-11-13 00:00:00	1913-11-27	1913-11-27 00:00:00	32020		\N	161483	0	444814009	40481087		0
51678	3064	40481087	1937-01-04	1937-01-04 00:00:00	1937-01-18	1937-01-18 00:00:00	32020		\N	203916	0	444814009	40481087		0
41333	2458	40481087	2013-01-03	2013-01-03 00:00:00	2013-01-24	2013-01-24 00:00:00	32020		\N	162948	0	444814009	40481087		0
41461	2466	4112343	2002-02-04	2002-02-04 00:00:00	2002-02-17	2002-02-17 00:00:00	32020		\N	163491	0	195662009	4112343		0
41638	2477	40481087	1971-05-21	1971-05-21 00:00:00	1971-05-28	1971-05-28 00:00:00	32020		\N	164207	0	444814009	40481087		0
41759	2485	40481087	1994-05-08	1994-05-08 00:00:00	1994-05-15	1994-05-15 00:00:00	32020		\N	164597	0	444814009	40481087		0
52495	3109	372328	1923-05-10	1923-05-10 00:00:00	1924-05-28	1924-05-28 00:00:00	32020		\N	206755	0	65363002	372328		0
52651	3118	40481087	1956-03-05	1956-03-05 00:00:00	1956-03-26	1956-03-26 00:00:00	32020		\N	207432	0	444814009	40481087		0
52836	3129	4134304	1998-03-27	1998-03-27 00:00:00	1998-05-26	1998-05-26 00:00:00	32020		\N	208248	0	263102004	4134304		0
52992	3137	4112343	1948-05-09	1948-05-09 00:00:00	1948-05-22	1948-05-22 00:00:00	32020		\N	208826	0	195662009	4112343		0
32033	1903	4294548	1976-08-02	1976-08-02 00:00:00	1976-12-13	1976-12-13 00:00:00	32020		\N	126670	0	75498004	4294548		0
42712	2545	260139	1959-11-12	1959-11-12 00:00:00	1959-11-26	1959-11-26 00:00:00	32020		\N	168438	0	10509002	260139		0
32369	1923	255848	2018-04-09	2018-04-09 00:00:00	\N	\N	32020		\N	127949	0	233604007	255848		0
32520	1929	4283893	1974-04-22	1974-04-22 00:00:00	1974-05-13	1974-05-13 00:00:00	32020		\N	128449	0	36971009	4283893		0
32578	1934	192671	2000-09-08	2000-09-08 00:00:00	\N	\N	32020		\N	128626	0	K92.2	35208414		0
43341	2580	317576	1963-05-20	1963-05-20 00:00:00	\N	\N	32020		\N	170875	0	53741008	317576		0
32943	1954	40481087	1975-07-22	1975-07-22 00:00:00	1975-08-05	1975-08-05 00:00:00	32020		\N	130050	0	444814009	40481087		0
33145	1966	372328	1965-07-03	1965-07-03 00:00:00	1966-04-05	1966-04-05 00:00:00	32020		\N	130707	0	65363002	372328		0
33298	1976	260139	2003-12-02	2003-12-02 00:00:00	2003-12-09	2003-12-09 00:00:00	32020		\N	131390	0	10509002	260139		0
33529	1989	260139	1967-10-25	1967-10-25 00:00:00	1967-11-08	1967-11-08 00:00:00	32020		\N	132407	0	10509002	260139		0
33608	1992	257012	2014-05-18	2014-05-18 00:00:00	\N	\N	32020		\N	132645	0	40055000	257012		0
33778	2005	40481087	1975-01-08	1975-01-08 00:00:00	1975-01-29	1975-01-29 00:00:00	32020		\N	133523	0	444814009	40481087		0
44500	2647	28060	1980-10-15	1980-10-15 00:00:00	1980-10-25	1980-10-25 00:00:00	32020		\N	175112	0	43878008	28060		0
34155	2028	260139	2016-09-24	2016-09-24 00:00:00	2016-10-01	2016-10-01 00:00:00	32020		\N	135010	0	10509002	260139		0
52579	3114	257012	1957-05-05	1957-05-05 00:00:00	\N	\N	32020		\N	207131	0	40055000	257012		0
34315	2034	4218389	2006-02-25	2006-02-25 00:00:00	2006-03-25	2006-03-25 00:00:00	32020		\N	135429	0	39848009	4218389		0
45008	2677	40481087	2000-01-07	2000-01-07 00:00:00	2000-01-28	2000-01-28 00:00:00	32020		\N	177347	0	444814009	40481087		0
34588	2053	372328	1954-10-06	1954-10-06 00:00:00	1954-12-09	1954-12-09 00:00:00	32020		\N	136549	0	65363002	372328		0
45363	2697	4109685	1941-02-07	1941-02-07 00:00:00	1941-02-28	1941-02-28 00:00:00	32020		\N	178580	0	284551006	4109685		0
35026	2079	40481087	2018-11-28	2018-11-28 00:00:00	2018-12-05	2018-12-05 00:00:00	32020		\N	138449	0	444814009	40481087		0
35107	2084	40481087	2003-06-16	2003-06-16 00:00:00	2003-07-07	2003-07-07 00:00:00	32020		\N	138840	0	444814009	40481087		0
35267	2088	4112343	1942-01-22	1942-01-22 00:00:00	1942-02-01	1942-02-01 00:00:00	32020		\N	139260	0	195662009	4112343		0
45997	2740	192671	2010-05-13	2010-05-13 00:00:00	\N	\N	32020		\N	181336	0	K92.2	35208414		0
35675	2115	4116491	1986-09-19	1986-09-19 00:00:00	1986-10-29	1986-10-29 00:00:00	32020		\N	140707	0	301011002	4116491		0
35808	2122	260139	1991-05-02	1991-05-02 00:00:00	1991-05-16	1991-05-16 00:00:00	32020		\N	141190	0	10509002	260139		0
35932	2130	260139	2004-07-16	2004-07-16 00:00:00	2004-07-23	2004-07-23 00:00:00	32020		\N	141732	0	10509002	260139		0
36157	2141	4112343	1956-07-26	1956-07-26 00:00:00	1956-08-08	1956-08-08 00:00:00	32020		\N	142649	0	195662009	4112343		0
36312	2150	40481087	1950-07-26	1950-07-26 00:00:00	1950-08-09	1950-08-09 00:00:00	32020		\N	143199	0	444814009	40481087		0
36509	2160	40481087	1984-10-22	1984-10-22 00:00:00	1984-10-29	1984-10-29 00:00:00	32020		\N	143980	0	444814009	40481087		0
36640	2168	81151	1960-08-23	1960-08-23 00:00:00	1960-09-27	1960-09-27 00:00:00	32020		\N	144574	0	44465007	81151		0
36795	2176	40481087	1956-10-26	1956-10-26 00:00:00	1956-11-09	1956-11-09 00:00:00	32020		\N	145156	0	444814009	40481087		0
36984	2189	40481087	1989-09-21	1989-09-21 00:00:00	1989-10-05	1989-10-05 00:00:00	32020		\N	145902	0	444814009	40481087		0
37048	2192	28060	2013-10-15	2013-10-15 00:00:00	2013-10-28	2013-10-28 00:00:00	32020		\N	146176	0	43878008	28060		0
37305	2210	260139	1951-01-21	1951-01-21 00:00:00	1951-02-04	1951-02-04 00:00:00	32020		\N	147236	0	10509002	260139		0
37513	2226	28060	2003-11-10	2003-11-10 00:00:00	2003-11-17	2003-11-17 00:00:00	32020		\N	148076	0	43878008	28060		0
37605	2230	40481087	1999-07-19	1999-07-19 00:00:00	1999-08-09	1999-08-09 00:00:00	32020		\N	148364	0	444814009	40481087		0
37738	2237	4116491	1970-12-17	1970-12-17 00:00:00	1971-01-20	1971-01-20 00:00:00	32020		\N	148763	0	301011002	4116491		0
48487	2871	80180	1996-07-12	1996-07-12 00:00:00	\N	\N	32020		\N	191103	0	396275006	80180		0
48671	2883	260139	1970-01-27	1970-01-27 00:00:00	1970-02-03	1970-02-03 00:00:00	32020		\N	191780	0	10509002	260139		0
38303	2274	40481087	1975-12-24	1975-12-24 00:00:00	1976-01-07	1976-01-07 00:00:00	32020		\N	151192	0	444814009	40481087		0
49023	2902	4112343	1954-01-25	1954-01-25 00:00:00	1954-02-02	1954-02-02 00:00:00	32020		\N	193263	0	195662009	4112343		0
49142	2906	4156265	1936-08-14	1936-08-14 00:00:00	1936-08-28	1936-08-28 00:00:00	32020		\N	193719	0	370247008	4156265		0
49306	2915	4112343	2016-06-12	2016-06-12 00:00:00	2016-06-19	2016-06-19 00:00:00	32020		\N	194246	0	195662009	4112343		0
38994	2318	4310024	2000-12-12	2000-12-12 00:00:00	\N	\N	32020		\N	154100	0	424802006	4310024		0
49644	2936	4294548	1984-11-15	1984-11-15 00:00:00	1985-01-03	1985-01-03 00:00:00	32020		\N	195754	0	75498004	4294548		0
39231	2328	40481087	1977-08-02	1977-08-02 00:00:00	1977-08-16	1977-08-16 00:00:00	32020		\N	154810	0	444814009	40481087		0
39491	2340	4112343	2013-03-31	2013-03-31 00:00:00	2013-04-09	2013-04-09 00:00:00	32020		\N	155735	0	195662009	4112343		0
39564	2343	260139	1970-06-30	1970-06-30 00:00:00	1970-07-14	1970-07-14 00:00:00	32020		\N	155949	0	10509002	260139		0
39806	2357	40481087	1952-03-31	1952-03-31 00:00:00	1952-04-21	1952-04-21 00:00:00	32020		\N	157058	0	444814009	40481087		0
39970	2369	40486433	1985-05-09	1985-05-09 00:00:00	2000-05-07	2000-05-07 00:00:00	32020		\N	157630	0	446096008	40486433		0
40111	2380	80180	1987-04-08	1987-04-08 00:00:00	\N	\N	32020		\N	158187	0	396275006	80180		0
40280	2389	260139	1996-06-11	1996-06-11 00:00:00	1996-06-18	1996-06-18 00:00:00	32020		\N	158889	0	10509002	260139		0
40384	2396	4278672	1997-10-19	1997-10-19 00:00:00	1997-12-18	1997-12-18 00:00:00	32020		\N	159323	0	65966004	4278672		0
40667	2418	40481087	1980-06-06	1980-06-06 00:00:00	1980-06-27	1980-06-27 00:00:00	32020		\N	160423	0	444814009	40481087		0
40805	2427	4112343	1948-06-21	1948-06-21 00:00:00	1948-06-30	1948-06-30 00:00:00	32020		\N	160979	0	195662009	4112343		0
40965	2436	381316	1961-11-25	1961-11-25 00:00:00	\N	\N	32020		\N	161568	0	230690007	381316		0
51679	3065	4112343	1977-11-13	1977-11-13 00:00:00	1977-11-26	1977-11-26 00:00:00	32020		\N	204035	0	195662009	4112343		0
41334	2458	78272	1996-05-05	1996-05-05 00:00:00	1996-06-09	1996-06-09 00:00:00	32020		\N	162943	0	70704007	78272		0
41486	2468	260139	1939-12-03	1939-12-03 00:00:00	1939-12-10	1939-12-10 00:00:00	32020		\N	163609	0	10509002	260139		0
41639	2477	4112343	2001-08-30	2001-08-30 00:00:00	2001-09-12	2001-09-12 00:00:00	32020		\N	164180	0	195662009	4112343		0
41760	2485	4283893	2002-11-08	2002-11-08 00:00:00	2003-01-31	2003-01-31 00:00:00	32020		\N	164598	0	36971009	4283893		0
52496	3109	440086	1925-06-10	1925-06-10 00:00:00	1929-08-21	1929-08-21 00:00:00	32020		\N	206827	0	192127007	440086		0
52652	3118	28060	1950-10-15	1950-10-15 00:00:00	1950-10-24	1950-10-24 00:00:00	32020		\N	207482	0	43878008	28060		0
52837	3129	260139	2006-12-25	2006-12-25 00:00:00	2007-01-08	2007-01-08 00:00:00	32020		\N	208291	0	10509002	260139		0
52993	3137	40481087	1937-07-14	1937-07-14 00:00:00	1937-07-21	1937-07-21 00:00:00	32020		\N	208833	0	444814009	40481087		0
32034	1903	4112343	2007-08-20	2007-08-20 00:00:00	2007-08-29	2007-08-29 00:00:00	32020		\N	126678	0	195662009	4112343		0
42713	2545	40481087	1949-01-15	1949-01-15 00:00:00	1949-02-05	1949-02-05 00:00:00	32020		\N	168412	0	444814009	40481087		0
32370	1923	40481087	1948-03-17	1948-03-17 00:00:00	1948-04-07	1948-04-07 00:00:00	32020		\N	128001	0	444814009	40481087		0
32521	1929	4155034	1966-08-16	1966-08-16 00:00:00	1966-09-06	1966-09-06 00:00:00	32020		\N	128391	0	283371005	4155034		0
32579	1934	40481087	1979-02-20	1979-02-20 00:00:00	1979-03-13	1979-03-13 00:00:00	32020		\N	128645	0	444814009	40481087		0
43342	2580	4112343	2005-02-19	2005-02-19 00:00:00	2005-03-02	2005-03-02 00:00:00	32020		\N	170925	0	195662009	4112343		0
32944	1954	4112343	1969-05-15	1969-05-15 00:00:00	1969-05-23	1969-05-23 00:00:00	32020		\N	129949	0	195662009	4112343		0
33146	1966	260139	2016-07-20	2016-07-20 00:00:00	2016-07-27	2016-07-27 00:00:00	32020		\N	130706	0	10509002	260139		0
33299	1976	372328	1984-05-13	1984-05-13 00:00:00	1984-05-27	1984-05-27 00:00:00	32020		\N	131379	0	65363002	372328		0
33530	1989	40481087	2017-05-27	2017-05-27 00:00:00	2017-06-17	2017-06-17 00:00:00	32020		\N	132461	0	444814009	40481087		0
33609	1992	4112343	1983-07-22	1983-07-22 00:00:00	1983-07-30	1983-07-30 00:00:00	32020		\N	132731	0	195662009	4112343		0
33779	2005	4155034	2018-03-18	2018-03-18 00:00:00	2018-04-08	2018-04-08 00:00:00	32020		\N	133497	0	283371005	4155034		0
44501	2647	40481087	2003-02-09	2003-02-09 00:00:00	2003-03-02	2003-03-02 00:00:00	32020		\N	175164	0	444814009	40481087		0
34156	2028	140673	2018-11-17	2018-11-17 00:00:00	\N	\N	32020		\N	135011	0	40930008	140673		0
34316	2034	4283893	1987-06-11	1987-06-11 00:00:00	1987-08-27	1987-08-27 00:00:00	32020		\N	135438	0	36971009	4283893		0
45009	2677	40481087	1995-05-08	1995-05-08 00:00:00	1995-05-29	1995-05-29 00:00:00	32020		\N	177346	0	444814009	40481087		0
34589	2053	80180	1993-11-04	1993-11-04 00:00:00	\N	\N	32020		\N	136492	0	396275006	80180		0
45364	2697	260139	1941-10-07	1941-10-07 00:00:00	1941-10-21	1941-10-21 00:00:00	32020		\N	178568	0	10509002	260139		0
45485	2703	4156265	2004-10-03	2004-10-03 00:00:00	2004-10-24	2004-10-24 00:00:00	32020		\N	179107	0	370247008	4156265		0
35108	2084	4112343	1990-07-11	1990-07-11 00:00:00	1990-07-19	1990-07-19 00:00:00	32020		\N	138836	0	195662009	4112343		0
35268	2088	4310024	1943-02-11	1943-02-11 00:00:00	\N	\N	32020		\N	139260	0	424802006	4310024		0
35676	2115	40481087	1992-12-16	1992-12-16 00:00:00	1992-12-30	1992-12-30 00:00:00	32020		\N	140758	0	444814009	40481087		0
35809	2122	4152936	1992-03-12	1992-03-12 00:00:00	1992-03-26	1992-03-26 00:00:00	32020		\N	141215	0	283385000	4152936		0
35933	2130	372328	2004-02-23	2004-02-23 00:00:00	2004-07-22	2004-07-22 00:00:00	32020		\N	141707	0	65363002	372328		0
36184	2145	28060	1968-06-30	1968-06-30 00:00:00	1968-07-11	1968-07-11 00:00:00	32020		\N	142789	0	43878008	28060		0
36313	2150	4218389	2008-01-26	2008-01-26 00:00:00	2008-02-16	2008-02-16 00:00:00	32020		\N	143154	0	39848009	4218389		0
36510	2160	4112343	2003-03-20	2003-03-20 00:00:00	2003-03-31	2003-03-31 00:00:00	32020		\N	143984	0	195662009	4112343		0
36641	2168	40481087	2003-08-05	2003-08-05 00:00:00	2003-08-19	2003-08-19 00:00:00	32020		\N	144492	0	444814009	40481087		0
36796	2176	4283893	1990-11-27	1990-11-27 00:00:00	1991-01-15	1991-01-15 00:00:00	32020		\N	145127	0	36971009	4283893		0
36985	2190	40481087	2009-04-17	2009-04-17 00:00:00	2009-05-01	2009-05-01 00:00:00	32020		\N	146029	0	444814009	40481087		0
37049	2192	372328	1957-01-11	1957-01-11 00:00:00	1957-05-23	1957-05-23 00:00:00	32020		\N	146151	0	65363002	372328		0
37306	2210	260139	1943-03-25	1943-03-25 00:00:00	1943-04-01	1943-04-01 00:00:00	32020		\N	147165	0	10509002	260139		0
37514	2226	28060	1949-08-17	1949-08-17 00:00:00	1949-08-27	1949-08-27 00:00:00	32020		\N	148117	0	43878008	28060		0
37606	2230	81893	2007-12-05	2007-12-05 00:00:00	\N	\N	32020		\N	148415	0	64766004	81893		0
37739	2237	4112343	1966-06-20	1966-06-20 00:00:00	1966-07-01	1966-07-01 00:00:00	32020		\N	148812	0	195662009	4112343		0
48488	2871	372328	1951-06-09	1951-06-09 00:00:00	1951-08-20	1951-08-20 00:00:00	32020		\N	191147	0	65363002	372328		0
48672	2883	40481087	1966-07-15	1966-07-15 00:00:00	1966-07-29	1966-07-29 00:00:00	32020		\N	191784	0	444814009	40481087		0
38304	2274	40481087	1952-09-09	1952-09-09 00:00:00	1952-09-23	1952-09-23 00:00:00	32020		\N	151132	0	444814009	40481087		0
49024	2902	78272	1998-08-06	1998-08-06 00:00:00	1998-08-27	1998-08-27 00:00:00	32020		\N	193369	0	70704007	78272		0
49143	2906	40481087	1986-04-15	1986-04-15 00:00:00	1986-04-22	1986-04-22 00:00:00	32020		\N	193740	0	444814009	40481087		0
49307	2915	80502	2005-04-03	2005-04-03 00:00:00	\N	\N	32020		\N	194378	0	64859006	80502		0
38995	2318	4294548	1991-04-06	1991-04-06 00:00:00	1991-12-07	1991-12-07 00:00:00	32020		\N	154120	0	75498004	4294548		0
49645	2936	4112343	2019-06-17	2019-06-17 00:00:00	\N	\N	32020		\N	195784	0	195662009	4112343		0
39232	2328	28060	1960-12-26	1960-12-26 00:00:00	1961-01-04	1961-01-04 00:00:00	32020		\N	154813	0	43878008	28060		0
39492	2340	40481087	2006-03-25	2006-03-25 00:00:00	2006-04-16	2006-04-16 00:00:00	32020		\N	155745	0	444814009	40481087		0
39565	2343	440086	1966-01-11	1966-01-11 00:00:00	1966-10-25	1966-10-25 00:00:00	32020		\N	155934	0	192127007	440086		0
39807	2357	40481087	1985-01-24	1985-01-24 00:00:00	1985-01-31	1985-01-31 00:00:00	32020		\N	157021	0	444814009	40481087		0
39971	2369	260139	2004-07-03	2004-07-03 00:00:00	2004-07-17	2004-07-17 00:00:00	32020		\N	157647	0	10509002	260139		0
40112	2380	40481087	1986-12-09	1986-12-09 00:00:00	1986-12-30	1986-12-30 00:00:00	32020		\N	158187	0	444814009	40481087		0
40281	2389	260139	1990-11-08	1990-11-08 00:00:00	1990-11-22	1990-11-22 00:00:00	32020		\N	158837	0	10509002	260139		0
40385	2396	40481087	1938-04-18	1938-04-18 00:00:00	1938-05-02	1938-05-02 00:00:00	32020		\N	159400	0	444814009	40481087		0
40668	2418	4218389	1980-10-16	1980-10-16 00:00:00	1980-11-13	1980-11-13 00:00:00	32020		\N	160440	0	39848009	4218389		0
40806	2427	40481087	1965-01-15	1965-01-15 00:00:00	1965-01-29	1965-01-29 00:00:00	32020		\N	161034	0	444814009	40481087		0
40966	2436	40481087	1963-08-22	1963-08-22 00:00:00	1963-08-29	1963-08-29 00:00:00	32020		\N	161516	0	444814009	40481087		0
51680	3065	4294548	1976-12-21	1976-12-21 00:00:00	1977-03-29	1977-03-29 00:00:00	32020		\N	204018	0	75498004	4294548		0
51793	3070	4218389	2018-12-28	2018-12-28 00:00:00	2019-01-25	2019-01-25 00:00:00	32020		\N	204327	0	39848009	4218389		0
41487	2468	40481087	1993-11-30	1993-11-30 00:00:00	1993-12-21	1993-12-21 00:00:00	32020		\N	163597	0	444814009	40481087		0
41640	2477	40481087	2002-04-26	2002-04-26 00:00:00	2002-05-10	2002-05-10 00:00:00	32020		\N	164164	0	444814009	40481087		0
41761	2485	4112343	1950-03-31	1950-03-31 00:00:00	1950-04-13	1950-04-13 00:00:00	32020		\N	164596	0	195662009	4112343		0
52497	3109	40481087	1937-12-20	1937-12-20 00:00:00	1938-01-03	1938-01-03 00:00:00	32020		\N	206796	0	444814009	40481087		0
52653	3118	40479768	1972-08-22	1972-08-22 00:00:00	1972-09-28	1972-09-28 00:00:00	32020		\N	207534	0	444470001	40479768		0
52838	3129	260139	1998-11-07	1998-11-07 00:00:00	1998-11-21	1998-11-21 00:00:00	32020		\N	208276	0	10509002	260139		0
52994	3137	40481087	1936-02-01	1936-02-01 00:00:00	1936-02-15	1936-02-15 00:00:00	32020		\N	208779	0	444814009	40481087		0
32035	1903	40481087	1962-07-26	1962-07-26 00:00:00	1962-08-09	1962-08-09 00:00:00	32020		\N	126719	0	444814009	40481087		0
42714	2545	4218389	1977-06-29	1977-06-29 00:00:00	1977-08-03	1977-08-03 00:00:00	32020		\N	168456	0	39848009	4218389		0
42829	2551	260139	2014-12-22	2014-12-22 00:00:00	2015-01-05	2015-01-05 00:00:00	32020		\N	168867	0	10509002	260139		0
32522	1929	4155034	1975-09-19	1975-09-19 00:00:00	1975-10-10	1975-10-10 00:00:00	32020		\N	128392	0	283371005	4155034		0
32580	1934	40481087	1977-07-07	1977-07-07 00:00:00	1977-07-21	1977-07-21 00:00:00	32020		\N	128648	0	444814009	40481087		0
43343	2580	28060	1995-02-16	1995-02-16 00:00:00	1995-03-01	1995-03-01 00:00:00	32020		\N	170930	0	43878008	28060		0
32945	1954	80180	1970-08-14	1970-08-14 00:00:00	\N	\N	32020		\N	129949	0	396275006	80180		0
33147	1966	81151	1968-04-18	1968-04-18 00:00:00	1968-05-02	1968-05-02 00:00:00	32020		\N	130735	0	44465007	81151		0
33300	1977	4112343	1913-02-25	1913-02-25 00:00:00	1913-03-10	1913-03-10 00:00:00	32020		\N	131554	0	195662009	4112343		0
33531	1989	4218389	2010-07-20	2010-07-20 00:00:00	2010-08-10	2010-08-10 00:00:00	32020		\N	132442	0	39848009	4218389		0
33610	1992	195588	2011-03-14	2011-03-14 00:00:00	2011-04-29	2011-04-29 00:00:00	32020		\N	132661	0	38822007	195588		0
33780	2005	4112343	2017-07-28	2017-07-28 00:00:00	2017-08-07	2017-08-07 00:00:00	32020		\N	133513	0	195662009	4112343		0
44502	2647	260139	1975-11-13	1975-11-13 00:00:00	1975-11-27	1975-11-27 00:00:00	32020		\N	175148	0	10509002	260139		0
34157	2028	80180	1987-02-08	1987-02-08 00:00:00	\N	\N	32020		\N	135024	0	396275006	80180		0
34317	2034	40481087	2003-05-03	2003-05-03 00:00:00	2003-05-17	2003-05-17 00:00:00	32020		\N	135414	0	444814009	40481087		0
45010	2677	40481087	2010-07-09	2010-07-09 00:00:00	2010-07-23	2010-07-23 00:00:00	32020		\N	177390	0	444814009	40481087		0
34590	2053	4112343	1983-12-04	1983-12-04 00:00:00	1983-12-12	1983-12-12 00:00:00	32020		\N	136513	0	195662009	4112343		0
45365	2698	4283893	2002-04-14	2002-04-14 00:00:00	2002-06-16	2002-06-16 00:00:00	32020		\N	178671	0	36971009	4283893		0
45486	2703	260139	1983-11-04	1983-11-04 00:00:00	1983-11-11	1983-11-11 00:00:00	32020		\N	179066	0	10509002	260139		0
35109	2084	40481087	2011-06-04	2011-06-04 00:00:00	2011-06-25	2011-06-25 00:00:00	32020		\N	138876	0	444814009	40481087		0
35269	2088	81893	1943-05-12	1943-05-12 00:00:00	\N	\N	32020		\N	139260	0	64766004	81893		0
45999	2740	4285898	2009-08-22	2009-08-22 00:00:00	\N	\N	32020		\N	181319	0	68496003	4285898		0
35677	2115	260139	1971-09-05	1971-09-05 00:00:00	1971-09-19	1971-09-19 00:00:00	32020		\N	140756	0	10509002	260139		0
35810	2122	4155034	1975-09-24	1975-09-24 00:00:00	1975-10-08	1975-10-08 00:00:00	32020		\N	141214	0	283371005	4155034		0
35934	2130	4113008	1987-04-14	1987-04-14 00:00:00	1987-04-28	1987-04-28 00:00:00	32020		\N	141693	0	284549007	4113008		0
36185	2145	4112343	1974-02-23	1974-02-23 00:00:00	1974-03-03	1974-03-03 00:00:00	32020		\N	142813	0	195662009	4112343		0
36314	2151	40481087	1940-11-18	1940-11-18 00:00:00	1940-12-02	1940-12-02 00:00:00	32020		\N	143256	0	444814009	40481087		0
36511	2160	260139	2005-12-23	2005-12-23 00:00:00	2005-12-30	2005-12-30 00:00:00	32020		\N	143985	0	10509002	260139		0
36642	2168	4027663	1982-09-07	1982-09-07 00:00:00	\N	\N	32020		\N	144411	0	13200003	4027663		0
36797	2176	40481087	1973-01-12	1973-01-12 00:00:00	1973-01-26	1973-01-26 00:00:00	32020		\N	145157	0	444814009	40481087		0
36986	2190	372328	1955-12-08	1955-12-08 00:00:00	1956-01-16	1956-01-16 00:00:00	32020		\N	146008	0	65363002	372328		0
37050	2192	4112343	1986-06-02	1986-06-02 00:00:00	1986-06-15	1986-06-15 00:00:00	32020		\N	146180	0	195662009	4112343		0
37307	2210	4112343	1994-12-30	1994-12-30 00:00:00	1995-01-12	1995-01-12 00:00:00	32020		\N	147266	0	195662009	4112343		0
37515	2226	378001	2010-12-04	2010-12-04 00:00:00	2011-02-02	2011-02-02 00:00:00	32020		\N	148171	0	62106007	378001		0
37607	2230	40481087	1973-11-18	1973-11-18 00:00:00	1973-12-02	1973-12-02 00:00:00	32020		\N	148386	0	444814009	40481087		0
37740	2237	40481087	1938-11-28	1938-11-28 00:00:00	1938-12-12	1938-12-12 00:00:00	32020		\N	148746	0	444814009	40481087		0
48489	2871	440086	1960-12-08	1960-12-08 00:00:00	1963-09-05	1963-09-05 00:00:00	32020		\N	191073	0	192127007	440086		0
48673	2883	40481087	1965-11-06	1965-11-06 00:00:00	1965-11-13	1965-11-13 00:00:00	32020		\N	191750	0	444814009	40481087		0
38305	2274	4112343	2010-11-08	2010-11-08 00:00:00	2010-11-15	2010-11-15 00:00:00	32020		\N	151146	0	195662009	4112343		0
49025	2902	28060	1986-03-17	1986-03-17 00:00:00	1986-03-28	1986-03-28 00:00:00	32020		\N	193274	0	43878008	28060		0
49144	2906	40481087	2018-04-10	2018-04-10 00:00:00	2018-04-17	2018-04-17 00:00:00	32020		\N	193741	0	444814009	40481087		0
49308	2915	4146173	1984-08-01	1984-08-01 00:00:00	1984-08-31	1984-08-31 00:00:00	32020		\N	194347	0	307731004	4146173		0
38996	2318	4112343	1995-07-17	1995-07-17 00:00:00	1995-07-27	1995-07-27 00:00:00	32020		\N	154091	0	195662009	4112343		0
49646	2936	257012	1984-12-20	1984-12-20 00:00:00	\N	\N	32020		\N	195755	0	40055000	257012		0
39233	2328	192671	1999-06-28	1999-06-28 00:00:00	\N	\N	32020		\N	154829	0	K92.2	35208414		0
39493	2341	260139	1953-06-21	1953-06-21 00:00:00	1953-07-05	1953-07-05 00:00:00	32020		\N	155850	0	10509002	260139		0
39566	2343	40481087	2006-08-05	2006-08-05 00:00:00	2006-08-26	2006-08-26 00:00:00	32020		\N	155973	0	444814009	40481087		0
39808	2357	40480160	2012-11-26	2012-11-26 00:00:00	2013-02-24	2013-02-24 00:00:00	32020		\N	157006	0	443165006	40480160		0
39972	2369	80180	2018-07-18	2018-07-18 00:00:00	\N	\N	32020		\N	157731	0	396275006	80180		0
40113	2380	4146173	1960-06-03	1960-06-03 00:00:00	1960-07-03	1960-07-03 00:00:00	32020		\N	158176	0	307731004	4146173		0
40290	2392	260139	1955-05-18	1955-05-18 00:00:00	1955-05-25	1955-05-25 00:00:00	32020		\N	159026	0	10509002	260139		0
40386	2396	195588	1971-11-06	1971-11-06 00:00:00	1971-12-26	1971-12-26 00:00:00	32020		\N	159306	0	38822007	195588		0
40669	2418	40481087	1986-02-23	1986-02-23 00:00:00	1986-03-02	1986-03-02 00:00:00	32020		\N	160420	0	444814009	40481087		0
40807	2427	4112343	2011-05-28	2011-05-28 00:00:00	2011-06-05	2011-06-05 00:00:00	32020		\N	160967	0	195662009	4112343		0
40967	2436	40481087	1965-05-25	1965-05-25 00:00:00	1965-06-01	1965-06-01 00:00:00	32020		\N	161517	0	444814009	40481087		0
51681	3065	260139	1976-10-19	1976-10-19 00:00:00	1976-11-02	1976-11-02 00:00:00	32020		\N	204057	0	10509002	260139		0
51794	3070	4283893	1982-06-15	1982-06-15 00:00:00	1982-09-07	1982-09-07 00:00:00	32020		\N	204320	0	36971009	4283893		0
41488	2468	4112343	1970-12-16	1970-12-16 00:00:00	1970-12-27	1970-12-27 00:00:00	32020		\N	163612	0	195662009	4112343		0
41641	2477	4155034	1967-10-22	1967-10-22 00:00:00	1967-11-12	1967-11-12 00:00:00	32020		\N	164118	0	283371005	4155034		0
41762	2485	40481087	1976-10-18	1976-10-18 00:00:00	1976-11-08	1976-11-08 00:00:00	32020		\N	164587	0	444814009	40481087		0
52498	3109	378001	1934-12-29	1934-12-29 00:00:00	1935-02-27	1935-02-27 00:00:00	32020		\N	206705	0	62106007	378001		0
52654	3118	372328	1952-07-05	1952-07-05 00:00:00	1952-09-07	1952-09-07 00:00:00	32020		\N	207532	0	65363002	372328		0
52839	3129	40481087	1985-03-27	1985-03-27 00:00:00	1985-04-17	1985-04-17 00:00:00	32020		\N	208289	0	444814009	40481087		0
52995	3137	4112343	1930-04-27	1930-04-27 00:00:00	1930-05-05	1930-05-05 00:00:00	32020		\N	208823	0	195662009	4112343		0
32036	1903	80180	2005-02-28	2005-02-28 00:00:00	\N	\N	32020		\N	126677	0	396275006	80180		0
42715	2545	375671	1961-02-23	1961-02-23 00:00:00	1961-03-25	1961-03-25 00:00:00	32020		\N	168455	0	62564004	375671		0
42830	2551	40481087	2011-12-30	2011-12-30 00:00:00	2012-01-06	2012-01-06 00:00:00	32020		\N	168883	0	444814009	40481087		0
32523	1929	4155034	2016-11-03	2016-11-03 00:00:00	2016-11-17	2016-11-17 00:00:00	32020		\N	128393	0	283371005	4155034		0
32581	1934	40481087	1963-03-21	1963-03-21 00:00:00	1963-03-28	1963-03-28 00:00:00	32020		\N	128611	0	444814009	40481087		0
43344	2580	4027663	1983-06-03	1983-06-03 00:00:00	\N	\N	32020		\N	170914	0	13200003	4027663		0
32946	1954	40481087	1954-05-29	1954-05-29 00:00:00	1954-06-19	1954-06-19 00:00:00	32020		\N	130045	0	444814009	40481087		0
33148	1966	40481087	1976-02-11	1976-02-11 00:00:00	1976-02-18	1976-02-18 00:00:00	32020		\N	130703	0	444814009	40481087		0
33301	1977	40481087	1996-01-02	1996-01-02 00:00:00	1996-01-16	1996-01-16 00:00:00	32020		\N	131544	0	444814009	40481087		0
33532	1989	40481087	1963-11-20	1963-11-20 00:00:00	1963-11-27	1963-11-27 00:00:00	32020		\N	132458	0	444814009	40481087		0
33611	1992	81151	1992-10-19	1992-10-19 00:00:00	1992-11-23	1992-11-23 00:00:00	32020		\N	132688	0	44465007	81151		0
33781	2005	4294548	2007-06-08	2007-06-08 00:00:00	2007-10-26	2007-10-26 00:00:00	32020		\N	133527	0	75498004	4294548		0
44503	2647	40481087	1978-12-09	1978-12-09 00:00:00	1978-12-23	1978-12-23 00:00:00	32020		\N	175149	0	444814009	40481087		0
34158	2028	4294548	1968-03-18	1968-03-18 00:00:00	1968-04-08	1968-04-08 00:00:00	32020		\N	134978	0	75498004	4294548		0
34318	2034	4218389	1999-07-27	1999-07-27 00:00:00	1999-08-31	1999-08-31 00:00:00	32020		\N	135490	0	39848009	4218389		0
45011	2677	378001	1986-06-22	1986-06-22 00:00:00	1986-07-22	1986-07-22 00:00:00	32020		\N	177360	0	62106007	378001		0
34591	2053	40481087	1974-01-12	1974-01-12 00:00:00	1974-02-02	1974-02-02 00:00:00	32020		\N	136516	0	444814009	40481087		0
45366	2698	4112343	2004-02-01	2004-02-01 00:00:00	2004-02-13	2004-02-13 00:00:00	32020		\N	178685	0	195662009	4112343		0
45487	2704	4112343	2003-12-22	2003-12-22 00:00:00	2003-12-29	2003-12-29 00:00:00	32020		\N	179152	0	195662009	4112343		0
35110	2084	40481087	1981-08-23	1981-08-23 00:00:00	1981-09-06	1981-09-06 00:00:00	32020		\N	138878	0	444814009	40481087		0
35270	2088	260139	1930-05-09	1930-05-09 00:00:00	1930-05-16	1930-05-16 00:00:00	32020		\N	139226	0	10509002	260139		0
46000	2740	30753	2009-07-23	2009-07-23 00:00:00	\N	\N	32020		\N	181319	0	16761005	30753		0
35678	2115	4294548	2007-04-21	2007-04-21 00:00:00	2007-08-11	2007-08-11 00:00:00	32020		\N	140710	0	75498004	4294548		0
35811	2122	372328	1978-08-25	1978-08-25 00:00:00	1978-09-30	1978-09-30 00:00:00	32020		\N	141176	0	65363002	372328		0
35935	2130	372328	1974-12-04	1974-12-04 00:00:00	1975-03-27	1975-03-27 00:00:00	32020		\N	141735	0	65363002	372328		0
36186	2145	260139	1993-09-09	1993-09-09 00:00:00	1993-09-23	1993-09-23 00:00:00	32020		\N	142814	0	10509002	260139		0
36315	2151	260139	1967-06-08	1967-06-08 00:00:00	1967-06-22	1967-06-22 00:00:00	32020		\N	143286	0	10509002	260139		0
36512	2160	4027663	1991-07-04	1991-07-04 00:00:00	\N	\N	32020		\N	143934	0	13200003	4027663		0
36643	2168	378001	1974-06-26	1974-06-26 00:00:00	1974-07-26	1974-07-26 00:00:00	32020		\N	144581	0	62106007	378001		0
36798	2176	40481087	2004-01-14	2004-01-14 00:00:00	2004-01-28	2004-01-28 00:00:00	32020		\N	145143	0	444814009	40481087		0
36987	2190	30753	1983-03-26	1983-03-26 00:00:00	\N	\N	32020		\N	146080	0	16761005	30753		0
37051	2192	4112343	1992-04-28	1992-04-28 00:00:00	1992-05-10	1992-05-10 00:00:00	32020		\N	146173	0	195662009	4112343		0
37308	2210	28060	2016-06-21	2016-06-21 00:00:00	2016-07-03	2016-07-03 00:00:00	32020		\N	147220	0	43878008	28060		0
37516	2226	372328	1942-09-20	1942-09-20 00:00:00	1943-01-01	1943-01-01 00:00:00	32020		\N	148086	0	65363002	372328		0
37608	2230	378001	1980-11-06	1980-11-06 00:00:00	1980-12-06	1980-12-06 00:00:00	32020		\N	148399	0	62106007	378001		0
37741	2237	260139	1960-06-15	1960-06-15 00:00:00	1960-06-29	1960-06-29 00:00:00	32020		\N	148848	0	10509002	260139		0
48490	2871	40481087	1963-12-26	1963-12-26 00:00:00	1964-01-02	1964-01-02 00:00:00	32020		\N	191165	0	444814009	40481087		0
48674	2883	260139	1981-05-08	1981-05-08 00:00:00	1981-05-15	1981-05-15 00:00:00	32020		\N	191785	0	10509002	260139		0
38306	2274	260139	1958-06-29	1958-06-29 00:00:00	1958-07-06	1958-07-06 00:00:00	32020		\N	151190	0	10509002	260139		0
49026	2902	80180	1991-04-10	1991-04-10 00:00:00	\N	\N	32020		\N	193270	0	396275006	80180		0
49145	2906	195588	1979-03-30	1979-03-30 00:00:00	1979-05-21	1979-05-21 00:00:00	32020		\N	193738	0	38822007	195588		0
49309	2915	4112343	2006-08-26	2006-08-26 00:00:00	2006-09-04	2006-09-04 00:00:00	32020		\N	194273	0	195662009	4112343		0
38997	2318	78272	1964-11-16	1964-11-16 00:00:00	1964-12-21	1964-12-21 00:00:00	32020		\N	154112	0	70704007	78272		0
49647	2936	81151	1976-08-17	1976-08-17 00:00:00	1976-09-07	1976-09-07 00:00:00	32020		\N	195767	0	44465007	81151		0
39234	2328	28060	1961-04-08	1961-04-08 00:00:00	1961-04-18	1961-04-18 00:00:00	32020		\N	154814	0	43878008	28060		0
39494	2341	28060	1961-05-21	1961-05-21 00:00:00	1961-06-02	1961-06-02 00:00:00	32020		\N	155785	0	43878008	28060		0
39567	2343	4027663	1986-01-06	1986-01-06 00:00:00	\N	\N	32020		\N	155964	0	13200003	4027663		0
39809	2357	4237458	2012-11-26	2012-11-26 00:00:00	2013-02-24	2013-02-24 00:00:00	32020		\N	157006	0	58150001	4237458		0
39973	2369	260139	2006-07-09	2006-07-09 00:00:00	2006-07-23	2006-07-23 00:00:00	32020		\N	157621	0	10509002	260139		0
40114	2380	260139	2008-12-15	2008-12-15 00:00:00	2008-12-29	2008-12-29 00:00:00	32020		\N	158212	0	10509002	260139		0
40291	2392	260139	2013-09-25	2013-09-25 00:00:00	2013-10-09	2013-10-09 00:00:00	32020		\N	159092	0	10509002	260139		0
40387	2396	40481087	1939-12-28	1939-12-28 00:00:00	1940-01-11	1940-01-11 00:00:00	32020		\N	159396	0	444814009	40481087		0
40670	2418	81151	1976-04-21	1976-04-21 00:00:00	1976-05-26	1976-05-26 00:00:00	32020		\N	160438	0	44465007	81151		0
40808	2427	260139	1986-04-23	1986-04-23 00:00:00	1986-05-07	1986-05-07 00:00:00	32020		\N	161031	0	10509002	260139		0
40968	2436	80180	1948-06-25	1948-06-25 00:00:00	\N	\N	32020		\N	161564	0	396275006	80180		0
51682	3065	40481087	2009-05-02	2009-05-02 00:00:00	2009-05-09	2009-05-09 00:00:00	32020		\N	204024	0	444814009	40481087		0
51795	3070	4112343	2016-06-30	2016-06-30 00:00:00	2016-07-13	2016-07-13 00:00:00	32020		\N	204363	0	195662009	4112343		0
41489	2468	260139	1966-11-06	1966-11-06 00:00:00	1966-11-13	1966-11-13 00:00:00	32020		\N	163611	0	10509002	260139		0
41642	2477	40481087	1986-09-13	1986-09-13 00:00:00	1986-09-27	1986-09-27 00:00:00	32020		\N	164208	0	444814009	40481087		0
41763	2485	4113008	2015-12-23	2015-12-23 00:00:00	2016-01-13	2016-01-13 00:00:00	32020		\N	164692	0	284549007	4113008		0
52499	3109	4112343	1930-08-22	1930-08-22 00:00:00	1930-08-31	1930-08-31 00:00:00	32020		\N	206768	0	195662009	4112343		0
52655	3118	80180	1985-12-21	1985-12-21 00:00:00	\N	\N	32020		\N	207484	0	396275006	80180		0
52840	3129	30753	2013-07-31	2013-07-31 00:00:00	\N	\N	32020		\N	208286	0	16761005	30753		0
52996	3137	4112343	1935-05-10	1935-05-10 00:00:00	1935-05-17	1935-05-17 00:00:00	32020		\N	208778	0	195662009	4112343		0
32037	1903	260139	1978-06-11	1978-06-11 00:00:00	1978-06-18	1978-06-18 00:00:00	32020		\N	126672	0	10509002	260139		0
42716	2545	255848	2008-01-06	2008-01-06 00:00:00	\N	\N	32020		\N	168411	0	233604007	255848		0
42831	2551	40481087	1995-01-02	1995-01-02 00:00:00	1995-01-23	1995-01-23 00:00:00	32020		\N	168857	0	444814009	40481087		0
32524	1929	4112343	1987-01-08	1987-01-08 00:00:00	1987-01-16	1987-01-16 00:00:00	32020		\N	128463	0	195662009	4112343		0
32582	1935	260139	2004-05-04	2004-05-04 00:00:00	2004-05-18	2004-05-18 00:00:00	32020		\N	128713	0	10509002	260139		0
43345	2580	4112343	1992-05-19	1992-05-19 00:00:00	1992-05-29	1992-05-29 00:00:00	32020		\N	170924	0	195662009	4112343		0
32947	1954	4155034	1952-12-01	1952-12-01 00:00:00	1952-12-15	1952-12-15 00:00:00	32020		\N	130034	0	283371005	4155034		0
33149	1966	4112343	1989-11-06	1989-11-06 00:00:00	1989-11-17	1989-11-17 00:00:00	32020		\N	130715	0	195662009	4112343		0
33302	1977	40481087	1975-01-29	1975-01-29 00:00:00	1975-02-12	1975-02-12 00:00:00	32020		\N	131577	0	444814009	40481087		0
43998	2619	4112343	1982-08-15	1982-08-15 00:00:00	1982-08-24	1982-08-24 00:00:00	32020		\N	173145	0	195662009	4112343		0
33612	1992	40481087	1984-04-10	1984-04-10 00:00:00	1984-04-24	1984-04-24 00:00:00	32020		\N	132712	0	444814009	40481087		0
33782	2005	4112343	2004-06-11	2004-06-11 00:00:00	2004-06-23	2004-06-23 00:00:00	32020		\N	133526	0	195662009	4112343		0
44504	2647	40486433	1973-12-19	1973-12-19 00:00:00	1989-12-17	1989-12-17 00:00:00	32020		\N	175147	0	446096008	40486433		0
34159	2028	40481087	1950-10-05	1950-10-05 00:00:00	1950-10-19	1950-10-19 00:00:00	32020		\N	135005	0	444814009	40481087		0
34319	2034	260139	1996-09-15	1996-09-15 00:00:00	1996-09-29	1996-09-29 00:00:00	32020		\N	135464	0	10509002	260139		0
45012	2677	4112343	1974-06-07	1974-06-07 00:00:00	1974-06-15	1974-06-15 00:00:00	32020		\N	177372	0	195662009	4112343		0
34592	2053	4237458	2010-03-24	2010-03-24 00:00:00	2010-04-23	2010-04-23 00:00:00	32020		\N	136571	0	58150001	4237458		0
45367	2698	4112343	2011-03-21	2011-03-21 00:00:00	2011-04-03	2011-04-03 00:00:00	32020		\N	178696	0	195662009	4112343		0
45488	2704	4112343	2002-07-16	2002-07-16 00:00:00	2002-07-26	2002-07-26 00:00:00	32020		\N	179151	0	195662009	4112343		0
35111	2084	260139	2002-02-18	2002-02-18 00:00:00	2002-02-25	2002-02-25 00:00:00	32020		\N	138875	0	10509002	260139		0
35274	2090	40481087	1979-04-01	1979-04-01 00:00:00	1979-04-08	1979-04-08 00:00:00	32020		\N	139354	0	444814009	40481087		0
46001	2740	4112343	1997-02-06	1997-02-06 00:00:00	1997-02-14	1997-02-14 00:00:00	32020		\N	181326	0	195662009	4112343		0
35679	2115	378001	1988-12-21	1988-12-21 00:00:00	1989-02-19	1989-02-19 00:00:00	32020		\N	140703	0	62106007	378001		0
35812	2122	260139	2011-07-15	2011-07-15 00:00:00	2011-07-29	2011-07-29 00:00:00	32020		\N	141196	0	10509002	260139		0
35936	2130	4283893	2001-03-29	2001-03-29 00:00:00	2001-06-21	2001-06-21 00:00:00	32020		\N	141731	0	36971009	4283893		0
36187	2145	80180	1999-09-28	1999-09-28 00:00:00	\N	\N	32020		\N	142825	0	396275006	80180		0
36316	2151	4112343	1925-07-06	1925-07-06 00:00:00	1925-07-16	1925-07-16 00:00:00	32020		\N	143306	0	195662009	4112343		0
36513	2160	40481087	1981-07-27	1981-07-27 00:00:00	1981-08-03	1981-08-03 00:00:00	32020		\N	143954	0	444814009	40481087		0
36644	2168	80180	1989-10-25	1989-10-25 00:00:00	\N	\N	32020		\N	144427	0	396275006	80180		0
36799	2176	28060	1975-02-19	1975-02-19 00:00:00	1975-03-01	1975-03-01 00:00:00	32020		\N	145158	0	43878008	28060		0
36988	2190	4266809	1983-09-22	1983-09-22 00:00:00	\N	\N	32020		\N	146080	0	397881000	4266809		0
37052	2192	40481087	1974-07-30	1974-07-30 00:00:00	1974-08-06	1974-08-06 00:00:00	32020		\N	146222	0	444814009	40481087		0
37309	2210	4112343	1954-09-05	1954-09-05 00:00:00	1954-09-17	1954-09-17 00:00:00	32020		\N	147264	0	195662009	4112343		0
47975	2847	28060	1968-12-23	1968-12-23 00:00:00	1969-01-05	1969-01-05 00:00:00	32020		\N	189108	0	43878008	28060		0
37609	2230	40481087	2003-12-23	2003-12-23 00:00:00	2004-01-13	2004-01-13 00:00:00	32020		\N	148388	0	444814009	40481087		0
37742	2237	40481087	1996-09-30	1996-09-30 00:00:00	1996-10-21	1996-10-21 00:00:00	32020		\N	148747	0	444814009	40481087		0
48491	2871	40481087	1968-07-14	1968-07-14 00:00:00	1968-07-28	1968-07-28 00:00:00	32020		\N	191100	0	444814009	40481087		0
48675	2883	4294548	1966-04-18	1966-04-18 00:00:00	1966-05-09	1966-05-09 00:00:00	32020		\N	191768	0	75498004	4294548		0
38307	2274	40481087	2009-06-01	2009-06-01 00:00:00	2009-06-22	2009-06-22 00:00:00	32020		\N	151137	0	444814009	40481087		0
49027	2902	372328	1953-02-04	1953-02-04 00:00:00	1953-06-26	1953-06-26 00:00:00	32020		\N	193313	0	65363002	372328		0
49146	2906	4155034	1940-05-09	1940-05-09 00:00:00	1940-05-30	1940-05-30 00:00:00	32020		\N	193720	0	283371005	4155034		0
49310	2915	40481087	1946-11-02	1946-11-02 00:00:00	1946-11-23	1946-11-23 00:00:00	32020		\N	194349	0	444814009	40481087		0
38998	2318	372328	1963-08-24	1963-08-24 00:00:00	1963-10-05	1963-10-05 00:00:00	32020		\N	154051	0	65363002	372328		0
49648	2936	40481087	2017-05-11	2017-05-11 00:00:00	2017-06-01	2017-06-01 00:00:00	32020		\N	195746	0	444814009	40481087		0
39235	2328	4112343	2014-07-05	2014-07-05 00:00:00	2014-07-15	2014-07-15 00:00:00	32020		\N	154821	0	195662009	4112343		0
39495	2341	313217	2002-03-28	2002-03-28 00:00:00	\N	\N	32020		\N	155811	0	49436004	313217		0
39568	2344	81893	1997-11-01	1997-11-01 00:00:00	\N	\N	32020		\N	156032	0	64766004	81893		0
39810	2357	40481087	1951-08-05	1951-08-05 00:00:00	1951-08-26	1951-08-26 00:00:00	32020		\N	157078	0	444814009	40481087		0
39974	2369	28060	2002-09-07	2002-09-07 00:00:00	2002-09-16	2002-09-16 00:00:00	32020		\N	157646	0	43878008	28060		0
40115	2380	372328	1950-08-25	1950-08-25 00:00:00	1950-09-08	1950-09-08 00:00:00	32020		\N	158192	0	65363002	372328		0
40292	2392	260139	1942-09-17	1942-09-17 00:00:00	1942-10-01	1942-10-01 00:00:00	32020		\N	159039	0	10509002	260139		0
40388	2396	372328	1921-11-21	1921-11-21 00:00:00	1922-04-26	1922-04-26 00:00:00	32020		\N	159300	0	65363002	372328		0
51135	3028	4027663	1993-04-14	1993-04-14 00:00:00	\N	\N	32020		\N	201909	0	13200003	4027663		0
40809	2427	40481087	2007-05-06	2007-05-06 00:00:00	2007-05-13	2007-05-13 00:00:00	32020		\N	161012	0	444814009	40481087		0
40969	2436	317576	2008-02-02	2008-02-02 00:00:00	\N	\N	32020		\N	161482	0	53741008	317576		0
51683	3065	4112343	2001-10-05	2001-10-05 00:00:00	2001-10-17	2001-10-17 00:00:00	32020		\N	204023	0	195662009	4112343		0
51796	3070	4112343	2014-03-30	2014-03-30 00:00:00	2014-04-10	2014-04-10 00:00:00	32020		\N	204369	0	195662009	4112343		0
41490	2468	260139	1981-08-08	1981-08-08 00:00:00	1981-08-15	1981-08-15 00:00:00	32020		\N	163593	0	10509002	260139		0
41643	2477	260139	1974-01-05	1974-01-05 00:00:00	1974-01-12	1974-01-12 00:00:00	32020		\N	164178	0	10509002	260139		0
41764	2485	4112343	1925-11-30	1925-11-30 00:00:00	1925-12-07	1925-12-07 00:00:00	32020		\N	164583	0	195662009	4112343		0
52500	3109	4112343	1983-09-08	1983-09-08 00:00:00	1983-09-16	1983-09-16 00:00:00	32020		\N	206831	0	195662009	4112343		0
52656	3118	40481087	1983-08-14	1983-08-14 00:00:00	1983-09-04	1983-09-04 00:00:00	32020		\N	207484	0	444814009	40481087		0
52841	3129	80180	2014-12-23	2014-12-23 00:00:00	\N	\N	32020		\N	208286	0	396275006	80180		0
52997	3137	28060	1919-02-27	1919-02-27 00:00:00	1919-03-10	1919-03-10 00:00:00	32020		\N	208831	0	43878008	28060		0
32038	1903	4029498	1975-06-16	1975-06-16 00:00:00	\N	\N	32020		\N	126664	0	128613002	4029498		0
42717	2545	439777	1968-07-20	1968-07-20 00:00:00	\N	\N	32020		\N	168413	0	271737000	439777		0
42832	2551	78272	2016-09-06	2016-09-06 00:00:00	2016-10-04	2016-10-04 00:00:00	32020		\N	168906	0	70704007	78272		0
32525	1929	4112343	1998-06-19	1998-06-19 00:00:00	1998-06-28	1998-06-28 00:00:00	32020		\N	128426	0	195662009	4112343		0
32583	1935	40481087	2006-03-01	2006-03-01 00:00:00	2006-03-22	2006-03-22 00:00:00	32020		\N	128744	0	444814009	40481087		0
43346	2580	260139	1980-01-03	1980-01-03 00:00:00	1980-01-17	1980-01-17 00:00:00	32020		\N	170880	0	10509002	260139		0
32948	1954	4112343	1940-06-08	1940-06-08 00:00:00	1940-06-18	1940-06-18 00:00:00	32020		\N	129947	0	195662009	4112343		0
33150	1966	28060	1992-09-19	1992-09-19 00:00:00	1992-10-02	1992-10-02 00:00:00	32020		\N	130717	0	43878008	28060		0
33303	1977	40481087	1966-04-20	1966-04-20 00:00:00	1966-05-11	1966-05-11 00:00:00	32020		\N	131509	0	444814009	40481087		0
43999	2619	4142905	1944-10-10	1944-10-10 00:00:00	1944-11-09	1944-11-09 00:00:00	32020		\N	173224	0	33737001	4142905		0
33613	1992	378001	1976-04-16	1976-04-16 00:00:00	1976-06-15	1976-06-15 00:00:00	32020		\N	132687	0	62106007	378001		0
33783	2005	40481087	2000-08-19	2000-08-19 00:00:00	2000-09-09	2000-09-09 00:00:00	32020		\N	133524	0	444814009	40481087		0
44505	2647	195588	2005-12-04	2005-12-04 00:00:00	2006-01-28	2006-01-28 00:00:00	32020		\N	175119	0	38822007	195588		0
34160	2028	260139	1967-04-02	1967-04-02 00:00:00	1967-04-16	1967-04-16 00:00:00	32020		\N	134990	0	10509002	260139		0
34320	2034	260139	1995-07-14	1995-07-14 00:00:00	1995-07-21	1995-07-21 00:00:00	32020		\N	135413	0	10509002	260139		0
45016	2679	78272	1989-08-02	1989-08-02 00:00:00	1989-08-30	1989-08-30 00:00:00	32020		\N	177463	0	70704007	78272		0
34593	2053	381316	2007-09-20	2007-09-20 00:00:00	\N	\N	32020		\N	136496	0	230690007	381316		0
45368	2698	4109685	2001-01-15	2001-01-15 00:00:00	2001-01-29	2001-01-29 00:00:00	32020		\N	178694	0	284551006	4109685		0
45489	2704	4112343	1973-07-07	1973-07-07 00:00:00	1973-07-15	1973-07-15 00:00:00	32020		\N	179148	0	195662009	4112343		0
35112	2084	372328	1967-02-16	1967-02-16 00:00:00	1967-09-20	1967-09-20 00:00:00	32020		\N	138864	0	65363002	372328		0
35275	2090	4112343	1972-04-03	1972-04-03 00:00:00	1972-04-12	1972-04-12 00:00:00	32020		\N	139353	0	195662009	4112343		0
46002	2740	257012	2015-12-23	2015-12-23 00:00:00	\N	\N	32020		\N	181275	0	40055000	257012		0
35680	2115	257012	2007-06-16	2007-06-16 00:00:00	\N	\N	32020		\N	140759	0	40055000	257012		0
35813	2122	81151	1974-10-15	1974-10-15 00:00:00	1974-10-29	1974-10-29 00:00:00	32020		\N	141213	0	44465007	81151		0
35937	2130	260139	1968-02-04	1968-02-04 00:00:00	1968-02-18	1968-02-18 00:00:00	32020		\N	141741	0	10509002	260139		0
36188	2145	260139	1978-07-27	1978-07-27 00:00:00	1978-08-03	1978-08-03 00:00:00	32020		\N	142791	0	10509002	260139		0
36317	2151	40481087	1922-11-28	1922-11-28 00:00:00	1922-12-05	1922-12-05 00:00:00	32020		\N	143305	0	444814009	40481087		0
47010	2798	40481087	2017-10-13	2017-10-13 00:00:00	2017-10-20	2017-10-20 00:00:00	32020		\N	185449	0	444814009	40481087		0
36645	2168	4266809	1989-10-25	1989-10-25 00:00:00	\N	\N	32020		\N	144427	0	397881000	4266809		0
36800	2176	4112343	1963-09-05	1963-09-05 00:00:00	1963-09-16	1963-09-16 00:00:00	32020		\N	145085	0	195662009	4112343		0
36989	2190	4218389	1982-02-10	1982-02-10 00:00:00	1982-03-10	1982-03-10 00:00:00	32020		\N	146080	0	39848009	4218389		0
37053	2192	40481087	1970-04-09	1970-04-09 00:00:00	1970-04-23	1970-04-23 00:00:00	32020		\N	146196	0	444814009	40481087		0
37310	2210	4152936	1966-07-11	1966-07-11 00:00:00	1966-08-01	1966-08-01 00:00:00	32020		\N	147197	0	283385000	4152936		0
47976	2847	40481087	1962-12-30	1962-12-30 00:00:00	1963-01-06	1963-01-06 00:00:00	32020		\N	189100	0	444814009	40481087		0
37610	2230	40481087	1984-06-24	1984-06-24 00:00:00	1984-07-01	1984-07-01 00:00:00	32020		\N	148402	0	444814009	40481087		0
37743	2237	40481087	1958-01-06	1958-01-06 00:00:00	1958-01-13	1958-01-13 00:00:00	32020		\N	148788	0	444814009	40481087		0
48492	2871	40481087	2007-11-27	2007-11-27 00:00:00	2007-12-04	2007-12-04 00:00:00	32020		\N	191083	0	444814009	40481087		0
48676	2883	40481087	1985-11-22	1985-11-22 00:00:00	1985-12-13	1985-12-13 00:00:00	32020		\N	191782	0	444814009	40481087		0
38308	2274	40481087	1996-06-22	1996-06-22 00:00:00	1996-07-06	1996-07-06 00:00:00	32020		\N	151170	0	444814009	40481087		0
49028	2902	260139	2005-02-18	2005-02-18 00:00:00	2005-03-04	2005-03-04 00:00:00	32020		\N	193353	0	10509002	260139		0
49147	2906	4112343	2009-03-26	2009-03-26 00:00:00	2009-04-08	2009-04-08 00:00:00	32020		\N	193637	0	195662009	4112343		0
49311	2915	40481087	2019-04-16	2019-04-16 00:00:00	2019-04-30	2019-04-30 00:00:00	32020		\N	194353	0	444814009	40481087		0
38999	2318	28060	1999-03-09	1999-03-09 00:00:00	1999-03-16	1999-03-16 00:00:00	32020		\N	154095	0	43878008	28060		0
49649	2936	40481087	1970-04-16	1970-04-16 00:00:00	1970-04-30	1970-04-30 00:00:00	32020		\N	195765	0	444814009	40481087		0
39236	2328	260139	2009-12-08	2009-12-08 00:00:00	2009-12-15	2009-12-15 00:00:00	32020		\N	154870	0	10509002	260139		0
39496	2341	28060	1962-06-28	1962-06-28 00:00:00	1962-07-06	1962-07-06 00:00:00	32020		\N	155851	0	43878008	28060		0
39569	2344	260139	1970-11-19	1970-11-19 00:00:00	1970-11-26	1970-11-26 00:00:00	32020		\N	156024	0	10509002	260139		0
39811	2357	81151	1999-07-10	1999-07-10 00:00:00	1999-08-07	1999-08-07 00:00:00	32020		\N	157005	0	44465007	81151		0
39975	2369	40481087	2015-04-02	2015-04-02 00:00:00	2015-04-09	2015-04-09 00:00:00	32020		\N	157656	0	444814009	40481087		0
40116	2380	40481087	2014-07-28	2014-07-28 00:00:00	2014-08-04	2014-08-04 00:00:00	32020		\N	158199	0	444814009	40481087		0
37681	2235	30753	1982-05-26	1982-05-26 00:00:00	\N	\N	32020		\N	148670	0	16761005	30753		0
40293	2392	4283893	1984-12-18	1984-12-18 00:00:00	1985-01-22	1985-01-22 00:00:00	32020		\N	159023	0	36971009	4283893		0
40389	2396	4112343	1979-02-22	1979-02-22 00:00:00	1979-03-04	1979-03-04 00:00:00	32020		\N	159385	0	195662009	4112343		0
51136	3028	4112343	1968-05-06	1968-05-06 00:00:00	1968-05-16	1968-05-16 00:00:00	32020		\N	201878	0	195662009	4112343		0
40810	2427	260139	2004-02-15	2004-02-15 00:00:00	2004-02-29	2004-02-29 00:00:00	32020		\N	161010	0	10509002	260139		0
40970	2436	4156265	2000-05-18	2000-05-18 00:00:00	2000-06-08	2000-06-08 00:00:00	32020		\N	161578	0	370247008	4156265		0
51684	3065	372328	2018-05-18	2018-05-18 00:00:00	\N	\N	32020		\N	204026	0	65363002	372328		0
51797	3070	260139	2001-09-04	2001-09-04 00:00:00	2001-09-18	2001-09-18 00:00:00	32020		\N	204387	0	10509002	260139		0
41491	2468	40481087	1983-10-24	1983-10-24 00:00:00	1983-11-07	1983-11-07 00:00:00	32020		\N	163594	0	444814009	40481087		0
41644	2477	4112343	1963-10-14	1963-10-14 00:00:00	1963-10-26	1963-10-26 00:00:00	32020		\N	164206	0	195662009	4112343		0
41765	2485	80502	2003-11-12	2003-11-12 00:00:00	\N	\N	32020		\N	164632	0	64859006	80502		0
52501	3109	4043241	1983-09-21	1983-09-21 00:00:00	\N	\N	32020		\N	206824	0	230265002	4043241		0
52657	3118	4156265	1956-07-26	1956-07-26 00:00:00	1956-08-16	1956-08-16 00:00:00	32020		\N	207401	0	370247008	4156265		0
52842	3129	40481087	1984-12-13	1984-12-13 00:00:00	1984-12-20	1984-12-20 00:00:00	32020		\N	208285	0	444814009	40481087		0
52998	3137	260139	1919-01-12	1919-01-12 00:00:00	1919-01-19	1919-01-19 00:00:00	32020		\N	208821	0	10509002	260139		0
42497	2534	80180	2011-04-02	2011-04-02 00:00:00	\N	\N	32020		\N	167472	0	396275006	80180		0
42718	2545	40481087	1975-03-16	1975-03-16 00:00:00	1975-03-23	1975-03-23 00:00:00	32020		\N	168390	0	444814009	40481087		0
42833	2551	40481087	1969-02-23	1969-02-23 00:00:00	1969-03-09	1969-03-09 00:00:00	32020		\N	168907	0	444814009	40481087		0
42995	2559	40481087	1987-11-04	1987-11-04 00:00:00	1987-11-18	1987-11-18 00:00:00	32020		\N	169595	0	444814009	40481087		0
32584	1935	260139	1980-01-12	1980-01-12 00:00:00	1980-01-26	1980-01-26 00:00:00	32020		\N	128684	0	10509002	260139		0
43347	2580	260139	1989-07-29	1989-07-29 00:00:00	1989-08-12	1989-08-12 00:00:00	32020		\N	170923	0	10509002	260139		0
32949	1954	40479768	1960-05-07	1960-05-07 00:00:00	1960-06-13	1960-06-13 00:00:00	32020		\N	130035	0	444470001	40479768		0
33151	1967	372328	1960-11-15	1960-11-15 00:00:00	1961-09-28	1961-09-28 00:00:00	32020		\N	130805	0	65363002	372328		0
33304	1977	40481087	1955-09-16	1955-09-16 00:00:00	1955-10-07	1955-10-07 00:00:00	32020		\N	131575	0	444814009	40481087		0
44000	2619	260139	1964-04-18	1964-04-18 00:00:00	1964-05-02	1964-05-02 00:00:00	32020		\N	173141	0	10509002	260139		0
33614	1992	40481087	2011-01-21	2011-01-21 00:00:00	2011-02-04	2011-02-04 00:00:00	32020		\N	132755	0	444814009	40481087		0
33784	2005	4112343	1982-09-13	1982-09-13 00:00:00	1982-09-23	1982-09-23 00:00:00	32020		\N	133480	0	195662009	4112343		0
44506	2647	40481087	1984-06-03	1984-06-03 00:00:00	1984-06-17	1984-06-17 00:00:00	32020		\N	175113	0	444814009	40481087		0
34161	2028	40481087	1995-12-20	1995-12-20 00:00:00	1996-01-10	1996-01-10 00:00:00	32020		\N	134980	0	444814009	40481087		0
34321	2034	4112343	1977-06-01	1977-06-01 00:00:00	1977-06-08	1977-06-08 00:00:00	32020		\N	135427	0	195662009	4112343		0
45017	2679	81151	2012-02-22	2012-02-22 00:00:00	2012-03-21	2012-03-21 00:00:00	32020		\N	177492	0	44465007	81151		0
34594	2053	40481087	1956-10-23	1956-10-23 00:00:00	1956-11-13	1956-11-13 00:00:00	32020		\N	136554	0	444814009	40481087		0
45369	2698	40481087	1987-02-20	1987-02-20 00:00:00	1987-02-27	1987-02-27 00:00:00	32020		\N	178684	0	444814009	40481087		0
45490	2704	4112343	2015-08-15	2015-08-15 00:00:00	2015-08-27	2015-08-27 00:00:00	32020		\N	179154	0	195662009	4112343		0
35113	2084	28060	1992-12-07	1992-12-07 00:00:00	1992-12-15	1992-12-15 00:00:00	32020		\N	138837	0	43878008	28060		0
35276	2090	4116491	1994-05-25	1994-05-25 00:00:00	1994-07-08	1994-07-08 00:00:00	32020		\N	139376	0	301011002	4116491		0
46003	2740	4059173	1996-10-14	1996-10-14 00:00:00	1997-01-12	1997-01-12 00:00:00	32020		\N	181283	0	16114001	4059173		0
35681	2115	4230399	2011-04-02	2011-04-02 00:00:00	2011-06-01	2011-06-01 00:00:00	32020		\N	140706	0	359817006	4230399		0
35814	2122	260139	2001-06-29	2001-06-29 00:00:00	2001-07-06	2001-07-06 00:00:00	32020		\N	141218	0	10509002	260139		0
35938	2130	4112343	1974-12-19	1974-12-19 00:00:00	1974-12-28	1974-12-28 00:00:00	32020		\N	141727	0	195662009	4112343		0
46647	2776	28060	1989-04-01	1989-04-01 00:00:00	1989-04-12	1989-04-12 00:00:00	32020		\N	183854	0	43878008	28060		0
36318	2151	40481087	1975-03-14	1975-03-14 00:00:00	1975-04-04	1975-04-04 00:00:00	32020		\N	143309	0	444814009	40481087		0
47011	2798	4155034	1976-07-08	1976-07-08 00:00:00	1976-07-29	1976-07-29 00:00:00	32020		\N	185431	0	283371005	4155034		0
36646	2168	40481087	1996-09-28	1996-09-28 00:00:00	1996-10-05	1996-10-05 00:00:00	32020		\N	144439	0	444814009	40481087		0
36801	2176	4112343	1961-01-10	1961-01-10 00:00:00	1961-01-17	1961-01-17 00:00:00	32020		\N	145123	0	195662009	4112343		0
36990	2190	80180	1983-09-22	1983-09-22 00:00:00	\N	\N	32020		\N	146080	0	396275006	80180		0
37054	2192	40481087	1978-02-14	1978-02-14 00:00:00	1978-03-07	1978-03-07 00:00:00	32020		\N	146224	0	444814009	40481087		0
37311	2210	28060	1978-12-26	1978-12-26 00:00:00	1979-01-06	1979-01-06 00:00:00	32020		\N	147265	0	43878008	28060		0
47977	2847	4112343	1975-07-20	1975-07-20 00:00:00	1975-07-27	1975-07-27 00:00:00	32020		\N	189109	0	195662009	4112343		0
37611	2230	4112343	2008-09-13	2008-09-13 00:00:00	2008-09-20	2008-09-20 00:00:00	32020		\N	148376	0	195662009	4112343		0
37744	2237	4027663	1958-11-04	1958-11-04 00:00:00	\N	\N	32020		\N	148788	0	13200003	4027663		0
48493	2871	40481087	1958-03-10	1958-03-10 00:00:00	1958-03-31	1958-03-31 00:00:00	32020		\N	191109	0	444814009	40481087		0
48677	2883	40481087	1998-07-17	1998-07-17 00:00:00	1998-08-07	1998-08-07 00:00:00	32020		\N	191786	0	444814009	40481087		0
38309	2274	80180	1987-06-11	1987-06-11 00:00:00	\N	\N	32020		\N	151181	0	396275006	80180		0
49029	2902	4294548	1970-05-05	1970-05-05 00:00:00	1970-09-08	1970-09-08 00:00:00	32020		\N	193361	0	75498004	4294548		0
49148	2906	80180	1965-06-11	1965-06-11 00:00:00	\N	\N	32020		\N	193713	0	396275006	80180		0
49312	2915	81151	1974-01-12	1974-01-12 00:00:00	1974-01-26	1974-01-26 00:00:00	32020		\N	194303	0	44465007	81151		0
39000	2318	198809	1969-03-09	1969-03-09 00:00:00	1969-03-09	1969-03-09 00:00:00	32020		\N	154115	0	65275009	198809		0
49650	2936	260139	1963-11-26	1963-11-26 00:00:00	1963-12-10	1963-12-10 00:00:00	32020		\N	195763	0	10509002	260139		0
39237	2328	40481087	2012-03-01	2012-03-01 00:00:00	2012-03-15	2012-03-15 00:00:00	32020		\N	154889	0	444814009	40481087		0
39497	2341	4296205	1994-10-18	1994-10-18 00:00:00	1994-11-22	1994-11-22 00:00:00	32020		\N	155804	0	403191005	4296205		0
39570	2344	28060	1968-07-02	1968-07-02 00:00:00	1968-07-13	1968-07-13 00:00:00	32020		\N	156074	0	43878008	28060		0
39812	2357	4112343	1953-01-16	1953-01-16 00:00:00	1953-01-23	1953-01-23 00:00:00	32020		\N	157079	0	195662009	4112343		0
39976	2369	4112343	1994-06-08	1994-06-08 00:00:00	1994-06-19	1994-06-19 00:00:00	32020		\N	157677	0	195662009	4112343		0
40117	2380	40481087	2007-10-17	2007-10-17 00:00:00	2007-10-24	2007-10-24 00:00:00	32020		\N	158229	0	444814009	40481087		0
40294	2392	40481087	1928-11-18	1928-11-18 00:00:00	1928-12-02	1928-12-02 00:00:00	32020		\N	159016	0	444814009	40481087		0
40390	2396	40481087	1936-04-30	1936-04-30 00:00:00	1936-05-21	1936-05-21 00:00:00	32020		\N	159294	0	444814009	40481087		0
51137	3028	40481087	2004-08-08	2004-08-08 00:00:00	2004-08-15	2004-08-15 00:00:00	32020		\N	201905	0	444814009	40481087		0
40811	2427	260139	1994-11-29	1994-11-29 00:00:00	1994-12-13	1994-12-13 00:00:00	32020		\N	161037	0	10509002	260139		0
40971	2436	134438	1930-03-19	1930-03-19 00:00:00	1931-03-16	1931-03-16 00:00:00	32020		\N	161584	0	40275004	134438		0
51685	3065	40481087	1974-12-02	1974-12-02 00:00:00	1974-12-23	1974-12-23 00:00:00	32020		\N	204056	0	444814009	40481087		0
51798	3070	4112343	1969-12-09	1969-12-09 00:00:00	1969-12-21	1969-12-21 00:00:00	32020		\N	204360	0	195662009	4112343		0
41492	2468	260139	1994-03-27	1994-03-27 00:00:00	1994-04-03	1994-04-03 00:00:00	32020		\N	163635	0	10509002	260139		0
41645	2477	4112343	2009-01-05	2009-01-05 00:00:00	2009-01-14	2009-01-14 00:00:00	32020		\N	164212	0	195662009	4112343		0
41766	2485	4059173	1990-03-11	1990-03-11 00:00:00	1990-06-09	1990-06-09 00:00:00	32020		\N	164690	0	16114001	4059173		0
52502	3109	260139	1968-07-22	1968-07-22 00:00:00	1968-08-05	1968-08-05 00:00:00	32020		\N	206772	0	10509002	260139		0
52658	3118	372328	1949-11-30	1949-11-30 00:00:00	1950-02-12	1950-02-12 00:00:00	32020		\N	207530	0	65363002	372328		0
52843	3129	260139	1972-02-13	1972-02-13 00:00:00	1972-02-20	1972-02-20 00:00:00	32020		\N	208287	0	10509002	260139		0
52999	3137	260139	1920-07-27	1920-07-27 00:00:00	1920-08-03	1920-08-03 00:00:00	32020		\N	208850	0	10509002	260139		0
42498	2534	372328	1974-10-13	1974-10-13 00:00:00	1974-12-31	1974-12-31 00:00:00	32020		\N	167450	0	65363002	372328		0
42719	2545	4112343	1952-08-20	1952-08-20 00:00:00	1952-08-29	1952-08-29 00:00:00	32020		\N	168409	0	195662009	4112343		0
42834	2551	4116491	2000-08-10	2000-08-10 00:00:00	2000-09-24	2000-09-24 00:00:00	32020		\N	168858	0	301011002	4116491		0
42996	2559	4310024	1988-08-06	1988-08-06 00:00:00	\N	\N	32020		\N	169595	0	424802006	4310024		0
32585	1935	260139	1989-12-13	1989-12-13 00:00:00	1989-12-27	1989-12-27 00:00:00	32020		\N	128742	0	10509002	260139		0
43348	2580	260139	2012-06-14	2012-06-14 00:00:00	2012-06-28	2012-06-28 00:00:00	32020		\N	170910	0	10509002	260139		0
32950	1954	4112343	1944-09-28	1944-09-28 00:00:00	1944-10-11	1944-10-11 00:00:00	32020		\N	129954	0	195662009	4112343		0
33152	1967	4112343	2010-10-16	2010-10-16 00:00:00	2010-10-24	2010-10-24 00:00:00	32020		\N	130802	0	195662009	4112343		0
33305	1977	260139	1957-08-07	1957-08-07 00:00:00	1957-08-14	1957-08-14 00:00:00	32020		\N	131508	0	10509002	260139		0
44001	2619	40481087	1980-02-26	1980-02-26 00:00:00	1980-03-11	1980-03-11 00:00:00	32020		\N	173148	0	444814009	40481087		0
33615	1992	4112343	1977-11-10	1977-11-10 00:00:00	1977-11-17	1977-11-17 00:00:00	32020		\N	132717	0	195662009	4112343		0
33785	2005	40481087	2016-12-06	2016-12-06 00:00:00	2016-12-27	2016-12-27 00:00:00	32020		\N	133512	0	444814009	40481087		0
44507	2647	40481087	1998-03-04	1998-03-04 00:00:00	1998-03-18	1998-03-18 00:00:00	32020		\N	175162	0	444814009	40481087		0
34163	2028	4029498	1977-11-27	1977-11-27 00:00:00	\N	\N	32020		\N	134950	0	128613002	4029498		0
34344	2037	4112343	1962-02-08	1962-02-08 00:00:00	1962-02-20	1962-02-20 00:00:00	32020		\N	135624	0	195662009	4112343		0
45018	2679	40481087	2013-09-29	2013-09-29 00:00:00	2013-10-06	2013-10-06 00:00:00	32020		\N	177503	0	444814009	40481087		0
34595	2053	257012	1995-05-12	1995-05-12 00:00:00	\N	\N	32020		\N	136547	0	40055000	257012		0
45370	2698	260139	2017-05-08	2017-05-08 00:00:00	2017-05-15	2017-05-15 00:00:00	32020		\N	178687	0	10509002	260139		0
45491	2704	4109685	1994-12-11	1994-12-11 00:00:00	1994-12-25	1994-12-25 00:00:00	32020		\N	179113	0	284551006	4109685		0
35114	2084	40481087	1994-04-06	1994-04-06 00:00:00	1994-04-27	1994-04-27 00:00:00	32020		\N	138855	0	444814009	40481087		0
35277	2090	4296204	2016-04-07	2016-04-07 00:00:00	2016-04-21	2016-04-21 00:00:00	32020		\N	139375	0	403190006	4296204		0
46004	2740	4112343	1978-09-06	1978-09-06 00:00:00	1978-09-13	1978-09-13 00:00:00	32020		\N	181272	0	195662009	4112343		0
35682	2115	28060	2010-08-12	2010-08-12 00:00:00	2010-08-25	2010-08-25 00:00:00	32020		\N	140753	0	43878008	28060		0
35815	2122	4112343	1980-01-18	1980-01-18 00:00:00	1980-01-27	1980-01-27 00:00:00	32020		\N	141187	0	195662009	4112343		0
35939	2130	4237458	1976-02-27	1976-02-27 00:00:00	1976-04-27	1976-04-27 00:00:00	32020		\N	141691	0	58150001	4237458		0
46648	2776	4283893	1993-09-27	1993-09-27 00:00:00	1993-12-13	1993-12-13 00:00:00	32020		\N	183767	0	36971009	4283893		0
36319	2151	4294548	1946-01-06	1946-01-06 00:00:00	1946-02-10	1946-02-10 00:00:00	32020		\N	143300	0	75498004	4294548		0
47012	2798	4112343	1996-05-01	1996-05-01 00:00:00	1996-05-10	1996-05-10 00:00:00	32020		\N	185462	0	195662009	4112343		0
36647	2168	372328	1962-06-14	1962-06-14 00:00:00	1962-08-30	1962-08-30 00:00:00	32020		\N	144441	0	65363002	372328		0
36802	2176	40481087	1973-03-02	1973-03-02 00:00:00	1973-03-23	1973-03-23 00:00:00	32020		\N	145126	0	444814009	40481087		0
36991	2190	4112343	2000-04-18	2000-04-18 00:00:00	2000-05-01	2000-05-01 00:00:00	32020		\N	146007	0	195662009	4112343		0
37055	2192	4112343	1959-01-16	1959-01-16 00:00:00	1959-01-29	1959-01-29 00:00:00	32020		\N	146220	0	195662009	4112343		0
37312	2210	40481087	1961-07-01	1961-07-01 00:00:00	1961-07-15	1961-07-15 00:00:00	32020		\N	147237	0	444814009	40481087		0
47978	2847	257012	1965-10-19	1965-10-19 00:00:00	\N	\N	32020		\N	189092	0	40055000	257012		0
37612	2230	4112343	1993-12-02	1993-12-02 00:00:00	1993-12-14	1993-12-14 00:00:00	32020		\N	148374	0	195662009	4112343		0
37745	2237	40481087	1960-11-11	1960-11-11 00:00:00	1960-11-18	1960-11-18 00:00:00	32020		\N	148811	0	444814009	40481087		0
48494	2871	40481087	1976-06-23	1976-06-23 00:00:00	1976-06-30	1976-06-30 00:00:00	32020		\N	191154	0	444814009	40481087		0
48678	2883	40481087	1969-08-17	1969-08-17 00:00:00	1969-08-24	1969-08-24 00:00:00	32020		\N	191794	0	444814009	40481087		0
38310	2274	4112343	2004-08-10	2004-08-10 00:00:00	2004-08-22	2004-08-22 00:00:00	32020		\N	151194	0	195662009	4112343		0
49030	2902	81151	1952-06-03	1952-06-03 00:00:00	1952-07-08	1952-07-08 00:00:00	32020		\N	193368	0	44465007	81151		0
49149	2906	4156265	1941-05-25	1941-05-25 00:00:00	1941-06-15	1941-06-15 00:00:00	32020		\N	193721	0	370247008	4156265		0
49313	2915	28060	1969-09-16	1969-09-16 00:00:00	1969-09-23	1969-09-23 00:00:00	32020		\N	194346	0	43878008	28060		0
39001	2318	196456	1969-03-09	1969-03-09 00:00:00	1969-03-09	1969-03-09 00:00:00	32020		\N	154115	0	235919008	196456		0
49651	2936	4230399	1975-07-24	1975-07-24 00:00:00	1975-09-22	1975-09-22 00:00:00	32020		\N	195818	0	359817006	4230399		0
39238	2328	81151	1959-06-03	1959-06-03 00:00:00	1959-06-24	1959-06-24 00:00:00	32020		\N	154898	0	44465007	81151		0
39498	2341	4112343	1959-08-19	1959-08-19 00:00:00	1959-08-27	1959-08-27 00:00:00	32020		\N	155788	0	195662009	4112343		0
39571	2344	40481087	2006-04-21	2006-04-21 00:00:00	2006-04-28	2006-04-28 00:00:00	32020		\N	156019	0	444814009	40481087		0
39813	2357	4116491	1997-12-25	1997-12-25 00:00:00	1998-02-12	1998-02-12 00:00:00	32020		\N	156942	0	301011002	4116491		0
39977	2369	4112343	1981-12-31	1981-12-31 00:00:00	1982-01-10	1982-01-10 00:00:00	32020		\N	157669	0	195662009	4112343		0
40118	2380	40481087	1965-06-15	1965-06-15 00:00:00	1965-06-29	1965-06-29 00:00:00	32020		\N	158178	0	444814009	40481087		0
40295	2392	4112343	1928-06-17	1928-06-17 00:00:00	1928-06-28	1928-06-28 00:00:00	32020		\N	159015	0	195662009	4112343		0
40391	2396	4152936	1941-04-27	1941-04-27 00:00:00	1941-05-11	1941-05-11 00:00:00	32020		\N	159402	0	283385000	4152936		0
51138	3028	4112343	2001-06-22	2001-06-22 00:00:00	2001-06-30	2001-06-30 00:00:00	32020		\N	201896	0	195662009	4112343		0
40812	2427	40481087	1958-05-10	1958-05-10 00:00:00	1958-05-17	1958-05-17 00:00:00	32020		\N	160977	0	444814009	40481087		0
40972	2436	4112343	1966-03-30	1966-03-30 00:00:00	1966-04-10	1966-04-10 00:00:00	32020		\N	161518	0	195662009	4112343		0
51686	3065	375671	2017-10-19	2017-10-19 00:00:00	2017-12-18	2017-12-18 00:00:00	32020		\N	204044	0	62564004	375671		0
51799	3070	40481087	1983-08-08	1983-08-08 00:00:00	1983-08-15	1983-08-15 00:00:00	32020		\N	204361	0	444814009	40481087		0
41493	2468	4294548	1940-10-05	1940-10-05 00:00:00	1940-11-02	1940-11-02 00:00:00	32020		\N	163601	0	75498004	4294548		0
41646	2477	40481087	1968-04-24	1968-04-24 00:00:00	1968-05-08	1968-05-08 00:00:00	32020		\N	164176	0	444814009	40481087		0
41767	2485	4112343	1937-04-10	1937-04-10 00:00:00	1937-04-23	1937-04-23 00:00:00	32020		\N	164672	0	195662009	4112343		0
52503	3109	4112343	1977-12-23	1977-12-23 00:00:00	1978-01-04	1978-01-04 00:00:00	32020		\N	206749	0	195662009	4112343		0
52659	3118	40481087	2004-06-22	2004-06-22 00:00:00	2004-07-13	2004-07-13 00:00:00	32020		\N	207458	0	444814009	40481087		0
52844	3129	40481087	1991-03-17	1991-03-17 00:00:00	1991-03-31	1991-03-31 00:00:00	32020		\N	208274	0	444814009	40481087		0
51887	3077	4266809	1992-05-03	1992-05-03 00:00:00	\N	\N	32020		\N	204723	0	397881000	4266809		0
53000	3137	4112343	1965-06-24	1965-06-24 00:00:00	1965-07-03	1965-07-03 00:00:00	32020		\N	208827	0	195662009	4112343		0
42499	2534	134438	1994-07-27	1994-07-27 00:00:00	1995-05-23	1995-05-23 00:00:00	32020		\N	167388	0	40275004	134438		0
42720	2545	4112343	1973-08-11	1973-08-11 00:00:00	1973-08-19	1973-08-19 00:00:00	32020		\N	168414	0	195662009	4112343		0
42862	2554	372328	1940-07-07	1940-07-07 00:00:00	1941-07-24	1941-07-24 00:00:00	32020		\N	169225	0	65363002	372328		0
42997	2559	372328	1962-10-05	1962-10-05 00:00:00	1962-12-15	1962-12-15 00:00:00	32020		\N	169654	0	65363002	372328		0
32586	1935	4059173	1978-03-22	1978-03-22 00:00:00	1978-04-21	1978-04-21 00:00:00	32020		\N	128739	0	16114001	4059173		0
43349	2580	40481087	1987-04-23	1987-04-23 00:00:00	1987-05-07	1987-05-07 00:00:00	32020		\N	170881	0	444814009	40481087		0
32951	1954	378001	1964-04-23	1964-04-23 00:00:00	1964-05-23	1964-05-23 00:00:00	32020		\N	130036	0	62106007	378001		0
33153	1967	40481087	1975-06-05	1975-06-05 00:00:00	1975-06-12	1975-06-12 00:00:00	32020		\N	130745	0	444814009	40481087		0
33306	1977	4146173	1948-11-22	1948-11-22 00:00:00	1949-01-21	1949-01-21 00:00:00	32020		\N	131507	0	307731004	4146173		0
44002	2619	260139	2013-02-24	2013-02-24 00:00:00	2013-03-03	2013-03-03 00:00:00	32020		\N	173166	0	10509002	260139		0
33616	1992	4027663	2009-03-14	2009-03-14 00:00:00	\N	\N	32020		\N	132744	0	13200003	4027663		0
33786	2005	372328	1976-09-07	1976-09-07 00:00:00	1977-01-15	1977-01-15 00:00:00	32020		\N	133502	0	65363002	372328		0
44508	2647	4112343	1975-10-20	1975-10-20 00:00:00	1975-10-31	1975-10-31 00:00:00	32020		\N	175110	0	195662009	4112343		0
34164	2028	4112343	1995-12-22	1995-12-22 00:00:00	1996-01-04	1996-01-04 00:00:00	32020		\N	134973	0	195662009	4112343		0
34345	2037	372328	1963-02-07	1963-02-07 00:00:00	1963-03-22	1963-03-22 00:00:00	32020		\N	135682	0	65363002	372328		0
45019	2679	40481087	1998-07-27	1998-07-27 00:00:00	1998-08-17	1998-08-17 00:00:00	32020		\N	177501	0	444814009	40481087		0
34596	2053	4112343	1958-01-19	1958-01-19 00:00:00	1958-02-01	1958-02-01 00:00:00	32020		\N	136555	0	195662009	4112343		0
45371	2698	80180	2019-04-17	2019-04-17 00:00:00	\N	\N	32020		\N	178669	0	396275006	80180		0
45492	2704	40481087	1977-03-24	1977-03-24 00:00:00	1977-04-14	1977-04-14 00:00:00	32020		\N	179150	0	444814009	40481087		0
35115	2084	260139	2015-10-25	2015-10-25 00:00:00	2015-11-01	2015-11-01 00:00:00	32020		\N	138841	0	10509002	260139		0
35278	2090	28060	2008-07-02	2008-07-02 00:00:00	2008-07-14	2008-07-14 00:00:00	32020		\N	139389	0	43878008	28060		0
46005	2740	40481087	1973-06-22	1973-06-22 00:00:00	1973-06-29	1973-06-29 00:00:00	32020		\N	181271	0	444814009	40481087		0
35683	2115	80180	2004-06-01	2004-06-01 00:00:00	\N	\N	32020		\N	140719	0	396275006	80180		0
35816	2122	4027663	2003-10-13	2003-10-13 00:00:00	\N	\N	32020		\N	141209	0	13200003	4027663		0
35940	2130	40481087	2014-06-19	2014-06-19 00:00:00	2014-06-26	2014-06-26 00:00:00	32020		\N	141706	0	444814009	40481087		0
46649	2776	4266809	2014-01-14	2014-01-14 00:00:00	\N	\N	32020		\N	183851	0	397881000	4266809		0
36320	2151	317576	1988-07-13	1988-07-13 00:00:00	\N	\N	32020		\N	143277	0	53741008	317576		0
47013	2798	4116491	1998-09-30	1998-09-30 00:00:00	1998-11-09	1998-11-09 00:00:00	32020		\N	185445	0	301011002	4116491		0
36648	2168	40481087	1991-08-11	1991-08-11 00:00:00	1991-08-18	1991-08-18 00:00:00	32020		\N	144540	0	444814009	40481087		0
36803	2176	40481087	2017-05-24	2017-05-24 00:00:00	2017-06-07	2017-06-07 00:00:00	32020		\N	145162	0	444814009	40481087		0
36992	2190	4278672	2014-09-23	2014-09-23 00:00:00	2014-12-22	2014-12-22 00:00:00	32020		\N	146083	0	65966004	4278672		0
37056	2192	4112343	1975-06-20	1975-06-20 00:00:00	1975-06-28	1975-06-28 00:00:00	32020		\N	146208	0	195662009	4112343		0
37313	2210	4112343	1945-12-11	1945-12-11 00:00:00	1945-12-19	1945-12-19 00:00:00	32020		\N	147235	0	195662009	4112343		0
47979	2847	260139	1985-06-12	1985-06-12 00:00:00	1985-06-26	1985-06-26 00:00:00	32020		\N	189111	0	10509002	260139		0
37613	2230	372328	1976-05-01	1976-05-01 00:00:00	1976-10-28	1976-10-28 00:00:00	32020		\N	148406	0	65363002	372328		0
37746	2237	4218389	1943-10-29	1943-10-29 00:00:00	1943-11-19	1943-11-19 00:00:00	32020		\N	148805	0	39848009	4218389		0
48495	2871	40481087	1993-01-06	1993-01-06 00:00:00	1993-01-20	1993-01-20 00:00:00	32020		\N	191157	0	444814009	40481087		0
48679	2883	80180	2002-06-06	2002-06-06 00:00:00	\N	\N	32020		\N	191758	0	396275006	80180		0
38311	2274	4113008	1975-03-25	1975-03-25 00:00:00	1975-04-08	1975-04-08 00:00:00	32020		\N	151208	0	284549007	4113008		0
49031	2902	257012	1970-09-01	1970-09-01 00:00:00	\N	\N	32020		\N	193264	0	40055000	257012		0
49150	2906	4112343	1924-06-13	1924-06-13 00:00:00	1924-06-25	1924-06-25 00:00:00	32020		\N	193665	0	195662009	4112343		0
49314	2915	40481087	1954-10-19	1954-10-19 00:00:00	1954-11-09	1954-11-09 00:00:00	32020		\N	194351	0	444814009	40481087		0
39002	2318	40481087	1973-04-11	1973-04-11 00:00:00	1973-05-02	1973-05-02 00:00:00	32020		\N	154118	0	444814009	40481087		0
49652	2936	40481087	1988-01-23	1988-01-23 00:00:00	1988-02-06	1988-02-06 00:00:00	32020		\N	195739	0	444814009	40481087		0
39239	2328	40481087	2004-09-23	2004-09-23 00:00:00	2004-10-14	2004-10-14 00:00:00	32020		\N	154869	0	444814009	40481087		0
39499	2341	40481087	1960-04-21	1960-04-21 00:00:00	1960-05-12	1960-05-12 00:00:00	32020		\N	155784	0	444814009	40481087		0
39572	2344	40481087	1999-10-08	1999-10-08 00:00:00	1999-10-22	1999-10-22 00:00:00	32020		\N	156018	0	444814009	40481087		0
39814	2357	80180	1973-12-26	1973-12-26 00:00:00	\N	\N	32020		\N	157077	0	396275006	80180		0
39997	2372	372328	1966-07-08	1966-07-08 00:00:00	1967-05-26	1967-05-26 00:00:00	32020		\N	157845	0	65363002	372328		0
40119	2380	378001	1983-09-01	1983-09-01 00:00:00	1983-10-01	1983-10-01 00:00:00	32020		\N	158169	0	62106007	378001		0
40296	2392	260139	1942-12-31	1942-12-31 00:00:00	1943-01-14	1943-01-14 00:00:00	32020		\N	159025	0	10509002	260139		0
40392	2396	4329847	2001-02-21	2001-02-21 00:00:00	\N	\N	32020		\N	159325	0	22298006	4329847		0
51139	3028	440448	1978-04-19	1978-04-19 00:00:00	\N	\N	32020		\N	201860	0	74400008	440448		0
40813	2427	28060	1978-09-17	1978-09-17 00:00:00	1978-09-26	1978-09-26 00:00:00	32020		\N	161036	0	43878008	28060		0
40973	2436	40481087	1913-07-16	1913-07-16 00:00:00	1913-08-06	1913-08-06 00:00:00	32020		\N	161494	0	444814009	40481087		0
51687	3065	260139	1999-02-25	1999-02-25 00:00:00	1999-03-11	1999-03-11 00:00:00	32020		\N	204004	0	10509002	260139		0
51800	3070	40481087	1973-01-18	1973-01-18 00:00:00	1973-01-25	1973-01-25 00:00:00	32020		\N	204319	0	444814009	40481087		0
41494	2468	4283893	1958-11-26	1958-11-26 00:00:00	1959-04-01	1959-04-01 00:00:00	32020		\N	163584	0	36971009	4283893		0
41647	2477	260139	1998-04-06	1998-04-06 00:00:00	1998-04-13	1998-04-13 00:00:00	32020		\N	164163	0	10509002	260139		0
41768	2485	4146173	1938-06-21	1938-06-21 00:00:00	1938-08-20	1938-08-20 00:00:00	32020		\N	164673	0	307731004	4146173		0
52504	3109	40481087	1955-04-26	1955-04-26 00:00:00	1955-05-03	1955-05-03 00:00:00	32020		\N	206771	0	444814009	40481087		0
52660	3118	40481087	1969-08-07	1969-08-07 00:00:00	1969-08-21	1969-08-21 00:00:00	32020		\N	207435	0	444814009	40481087		0
52845	3129	4283893	2007-02-07	2007-02-07 00:00:00	2007-04-04	2007-04-04 00:00:00	32020		\N	208277	0	36971009	4283893		0
53001	3137	40481087	1914-04-28	1914-04-28 00:00:00	1914-05-05	1914-05-05 00:00:00	32020		\N	208849	0	444814009	40481087		0
42500	2534	40481087	2012-01-22	2012-01-22 00:00:00	2012-02-12	2012-02-12 00:00:00	32020		\N	167402	0	444814009	40481087		0
42721	2545	257012	1972-06-27	1972-06-27 00:00:00	\N	\N	32020		\N	168439	0	40055000	257012		0
42863	2554	40481087	1959-07-25	1959-07-25 00:00:00	1959-08-01	1959-08-01 00:00:00	32020		\N	169213	0	444814009	40481087		0
42998	2559	40481087	2018-07-09	2018-07-09 00:00:00	2018-07-30	2018-07-30 00:00:00	32020		\N	169570	0	444814009	40481087		0
32587	1935	40481087	1973-10-20	1973-10-20 00:00:00	1973-11-03	1973-11-03 00:00:00	32020		\N	128710	0	444814009	40481087		0
43350	2580	321042	1979-05-07	1979-05-07 00:00:00	\N	\N	32020		\N	170920	0	410429000	321042		0
32952	1954	4112343	1976-08-16	1976-08-16 00:00:00	1976-08-23	1976-08-23 00:00:00	32020		\N	129950	0	195662009	4112343		0
44003	2619	40481087	2013-05-12	2013-05-12 00:00:00	2013-06-02	2013-06-02 00:00:00	32020		\N	173167	0	444814009	40481087		0
33617	1992	4048171	1978-03-29	1978-03-29 00:00:00	\N	\N	32020		\N	132730	0	232353008	4048171		0
33787	2005	40481087	2008-01-31	2008-01-31 00:00:00	2008-02-14	2008-02-14 00:00:00	32020		\N	133500	0	444814009	40481087		0
44511	2649	4113008	1962-05-08	1962-05-08 00:00:00	1962-05-22	1962-05-22 00:00:00	32020		\N	175265	0	284549007	4113008		0
34165	2028	4155034	2003-09-16	2003-09-16 00:00:00	2003-10-07	2003-10-07 00:00:00	32020		\N	135030	0	283371005	4155034		0
34346	2037	4112343	1968-07-19	1968-07-19 00:00:00	1968-08-01	1968-08-01 00:00:00	32020		\N	135676	0	195662009	4112343		0
45020	2679	4283893	1999-08-17	1999-08-17 00:00:00	2000-01-04	2000-01-04 00:00:00	32020		\N	177502	0	36971009	4283893		0
34597	2053	40481087	1984-02-14	1984-02-14 00:00:00	1984-02-28	1984-02-28 00:00:00	32020		\N	136546	0	444814009	40481087		0
45372	2698	81151	1989-08-02	1989-08-02 00:00:00	1989-08-16	1989-08-16 00:00:00	32020		\N	178693	0	44465007	81151		0
45493	2704	40481087	1985-03-02	1985-03-02 00:00:00	1985-03-16	1985-03-16 00:00:00	32020		\N	179130	0	444814009	40481087		0
35116	2084	260139	1986-06-03	1986-06-03 00:00:00	1986-06-17	1986-06-17 00:00:00	32020		\N	138852	0	10509002	260139		0
35279	2090	260139	1969-11-14	1969-11-14 00:00:00	1969-11-21	1969-11-21 00:00:00	32020		\N	139352	0	10509002	260139		0
46006	2740	4112343	1977-04-01	1977-04-01 00:00:00	1977-04-13	1977-04-13 00:00:00	32020		\N	181292	0	195662009	4112343		0
35684	2115	260139	1972-10-20	1972-10-20 00:00:00	1972-11-03	1972-11-03 00:00:00	32020		\N	140691	0	10509002	260139		0
35817	2122	4109685	1998-04-15	1998-04-15 00:00:00	1998-04-29	1998-04-29 00:00:00	32020		\N	141217	0	284551006	4109685		0
35941	2130	260139	1982-02-14	1982-02-14 00:00:00	1982-02-28	1982-02-28 00:00:00	32020		\N	141744	0	10509002	260139		0
46650	2776	80180	2014-01-14	2014-01-14 00:00:00	\N	\N	32020		\N	183851	0	396275006	80180		0
36321	2151	81151	1963-02-14	1963-02-14 00:00:00	1963-02-28	1963-02-28 00:00:00	32020		\N	143281	0	44465007	81151		0
47014	2798	4218389	1973-05-27	1973-05-27 00:00:00	1973-06-24	1973-06-24 00:00:00	32020		\N	185430	0	39848009	4218389		0
36649	2168	260139	1967-01-20	1967-01-20 00:00:00	1967-02-03	1967-02-03 00:00:00	32020		\N	144486	0	10509002	260139		0
36804	2176	4112343	1956-11-20	1956-11-20 00:00:00	1956-11-28	1956-11-28 00:00:00	32020		\N	145106	0	195662009	4112343		0
36993	2190	40481087	1963-01-06	1963-01-06 00:00:00	1963-01-13	1963-01-13 00:00:00	32020		\N	146010	0	444814009	40481087		0
37057	2192	4116491	2001-12-11	2001-12-11 00:00:00	2002-02-02	2002-02-02 00:00:00	32020		\N	146148	0	301011002	4116491		0
37314	2210	4112343	1971-07-23	1971-07-23 00:00:00	1971-08-02	1971-08-02 00:00:00	32020		\N	147213	0	195662009	4112343		0
47980	2847	4218389	1973-06-13	1973-06-13 00:00:00	1973-07-11	1973-07-11 00:00:00	32020		\N	189118	0	39848009	4218389		0
37614	2230	4266809	2009-01-28	2009-01-28 00:00:00	\N	\N	32020		\N	148416	0	397881000	4266809		0
37747	2237	4116491	1968-11-01	1968-11-01 00:00:00	1968-12-17	1968-12-17 00:00:00	32020		\N	148790	0	301011002	4116491		0
48496	2871	40481087	2013-02-12	2013-02-12 00:00:00	2013-02-26	2013-02-26 00:00:00	32020		\N	191158	0	444814009	40481087		0
48680	2883	4112343	2003-01-19	2003-01-19 00:00:00	2003-02-01	2003-02-01 00:00:00	32020		\N	191795	0	195662009	4112343		0
38312	2274	40481087	1979-01-27	1979-01-27 00:00:00	1979-02-17	1979-02-17 00:00:00	32020		\N	151168	0	444814009	40481087		0
49032	2902	40481087	1986-08-22	1986-08-22 00:00:00	1986-09-12	1986-09-12 00:00:00	32020		\N	193362	0	444814009	40481087		0
49151	2906	378419	2009-06-13	2009-06-13 00:00:00	\N	\N	32020		\N	193664	0	26929004	378419		0
49315	2915	4112343	2007-03-07	2007-03-07 00:00:00	2007-03-20	2007-03-20 00:00:00	32020		\N	194274	0	195662009	4112343		0
39003	2318	257012	1991-05-18	1991-05-18 00:00:00	\N	\N	32020		\N	154092	0	40055000	257012		0
49653	2936	260139	2008-02-26	2008-02-26 00:00:00	2008-03-11	2008-03-11 00:00:00	32020		\N	195783	0	10509002	260139		0
39240	2328	260139	2007-10-04	2007-10-04 00:00:00	2007-10-18	2007-10-18 00:00:00	32020		\N	154888	0	10509002	260139		0
39500	2341	80180	1986-01-03	1986-01-03 00:00:00	\N	\N	32020		\N	155807	0	396275006	80180		0
39573	2344	4266809	1999-11-21	1999-11-21 00:00:00	\N	\N	32020		\N	156018	0	397881000	4266809		0
39815	2357	4218389	1960-12-10	1960-12-10 00:00:00	1960-12-31	1960-12-31 00:00:00	32020		\N	157004	0	39848009	4218389		0
39998	2372	80180	1997-12-09	1997-12-09 00:00:00	\N	\N	32020		\N	157834	0	396275006	80180		0
40120	2380	260139	1994-03-18	1994-03-18 00:00:00	1994-03-25	1994-03-25 00:00:00	32020		\N	158228	0	10509002	260139		0
40297	2392	257012	1978-11-05	1978-11-05 00:00:00	\N	\N	32020		\N	159091	0	40055000	257012		0
40394	2396	439777	1995-10-31	1995-10-31 00:00:00	\N	\N	32020		\N	159375	0	271737000	439777		0
51140	3028	192671	2000-08-07	2000-08-07 00:00:00	\N	\N	32020		\N	201893	0	K92.2	35208414		0
40814	2427	4112343	2000-09-03	2000-09-03 00:00:00	2000-09-11	2000-09-11 00:00:00	32020		\N	161032	0	195662009	4112343		0
40974	2436	260139	1980-08-21	1980-08-21 00:00:00	1980-09-04	1980-09-04 00:00:00	32020		\N	161588	0	10509002	260139		0
51688	3065	260139	1989-09-23	1989-09-23 00:00:00	1989-09-30	1989-09-30 00:00:00	32020		\N	204036	0	10509002	260139		0
51801	3070	372328	1967-12-19	1967-12-19 00:00:00	1968-03-03	1968-03-03 00:00:00	32020		\N	204364	0	65363002	372328		0
41495	2468	4112343	1974-02-20	1974-02-20 00:00:00	1974-03-03	1974-03-03 00:00:00	32020		\N	163633	0	195662009	4112343		0
41648	2477	28060	2015-01-30	2015-01-30 00:00:00	2015-02-09	2015-02-09 00:00:00	32020		\N	164166	0	43878008	28060		0
41769	2485	4112343	1959-11-24	1959-11-24 00:00:00	1959-12-03	1959-12-03 00:00:00	32020		\N	164585	0	195662009	4112343		0
52553	3114	372328	1946-10-18	1946-10-18 00:00:00	1946-12-25	1946-12-25 00:00:00	32020		\N	207114	0	65363002	372328		0
52661	3118	28060	1950-03-03	1950-03-03 00:00:00	1950-03-16	1950-03-16 00:00:00	32020		\N	207465	0	43878008	28060		0
52867	3132	28060	1974-08-22	1974-08-22 00:00:00	1974-09-04	1974-09-04 00:00:00	32020		\N	208389	0	43878008	28060		0
53002	3137	81151	1982-05-06	1982-05-06 00:00:00	1982-06-03	1982-06-03 00:00:00	32020		\N	208835	0	44465007	81151		0
42501	2534	40481087	1980-06-11	1980-06-11 00:00:00	1980-07-02	1980-07-02 00:00:00	32020		\N	167457	0	444814009	40481087		0
42722	2545	4112343	1992-09-06	1992-09-06 00:00:00	1992-09-13	1992-09-13 00:00:00	32020		\N	168441	0	195662009	4112343		0
42864	2554	4109685	1950-08-27	1950-08-27 00:00:00	1950-09-17	1950-09-17 00:00:00	32020		\N	169197	0	284551006	4109685		0
42999	2559	40481087	1977-11-23	1977-11-23 00:00:00	1977-11-30	1977-11-30 00:00:00	32020		\N	169544	0	444814009	40481087		0
32588	1935	40481087	1997-11-04	1997-11-04 00:00:00	1997-11-11	1997-11-11 00:00:00	32020		\N	128736	0	444814009	40481087		0
43352	2580	260139	2005-05-13	2005-05-13 00:00:00	2005-05-20	2005-05-20 00:00:00	32020		\N	170883	0	10509002	260139		0
32953	1954	40481087	1944-11-01	1944-11-01 00:00:00	1944-11-08	1944-11-08 00:00:00	32020		\N	130044	0	444814009	40481087		0
33155	1967	4112343	1958-07-01	1958-07-01 00:00:00	1958-07-10	1958-07-10 00:00:00	32020		\N	130804	0	195662009	4112343		0
33308	1977	4294548	2006-09-14	2006-09-14 00:00:00	2006-10-26	2006-10-26 00:00:00	32020		\N	131545	0	75498004	4294548		0
44004	2619	40481087	1989-01-17	1989-01-17 00:00:00	1989-02-07	1989-02-07 00:00:00	32020		\N	173209	0	444814009	40481087		0
33618	1992	4294548	2014-04-27	2014-04-27 00:00:00	2014-06-22	2014-06-22 00:00:00	32020		\N	132711	0	75498004	4294548		0
33788	2005	80180	2010-01-14	2010-01-14 00:00:00	\N	\N	32020		\N	133500	0	396275006	80180		0
44512	2649	260139	1964-02-29	1964-02-29 00:00:00	1964-03-07	1964-03-07 00:00:00	32020		\N	175298	0	10509002	260139		0
34166	2028	378001	1970-04-28	1970-04-28 00:00:00	1970-05-28	1970-05-28 00:00:00	32020		\N	134949	0	62106007	378001		0
34347	2037	4027663	1990-04-08	1990-04-08 00:00:00	\N	\N	32020		\N	135650	0	13200003	4027663		0
45021	2679	4112343	1978-09-29	1978-09-29 00:00:00	1978-10-07	1978-10-07 00:00:00	32020		\N	177500	0	195662009	4112343		0
34598	2053	372328	1953-09-30	1953-09-30 00:00:00	1953-12-10	1953-12-10 00:00:00	32020		\N	136524	0	65363002	372328		0
45373	2698	4112343	1994-04-12	1994-04-12 00:00:00	1994-04-20	1994-04-20 00:00:00	32020		\N	178670	0	195662009	4112343		0
45494	2704	40481087	2015-03-30	2015-03-30 00:00:00	2015-04-20	2015-04-20 00:00:00	32020		\N	179153	0	444814009	40481087		0
35117	2084	81151	1984-03-23	1984-03-23 00:00:00	1984-04-06	1984-04-06 00:00:00	32020		\N	138834	0	44465007	81151		0
35280	2090	321042	1974-03-20	1974-03-20 00:00:00	\N	\N	32020		\N	139372	0	410429000	321042		0
46007	2740	4294548	2015-11-18	2015-11-18 00:00:00	2016-05-11	2016-05-11 00:00:00	32020		\N	181274	0	75498004	4294548		0
35685	2115	4059173	1989-12-16	1989-12-16 00:00:00	1990-03-16	1990-03-16 00:00:00	32020		\N	140704	0	16114001	4059173		0
35818	2122	40481087	2013-06-29	2013-06-29 00:00:00	2013-07-13	2013-07-13 00:00:00	32020		\N	141191	0	444814009	40481087		0
35942	2131	4112343	1953-06-16	1953-06-16 00:00:00	1953-06-28	1953-06-28 00:00:00	32020		\N	141761	0	195662009	4112343		0
46651	2776	4112343	2001-06-23	2001-06-23 00:00:00	2001-07-04	2001-07-04 00:00:00	32020		\N	183775	0	195662009	4112343		0
36322	2151	381316	1992-12-09	1992-12-09 00:00:00	\N	\N	32020		\N	143331	0	230690007	381316		0
47015	2798	260139	1988-04-21	1988-04-21 00:00:00	1988-04-28	1988-04-28 00:00:00	32020		\N	185461	0	10509002	260139		0
36650	2168	4048171	1958-09-20	1958-09-20 00:00:00	\N	\N	32020		\N	144534	0	232353008	4048171		0
36805	2176	30753	1999-09-04	1999-09-04 00:00:00	\N	\N	32020		\N	145152	0	16761005	30753		0
36994	2190	40481087	1999-02-09	1999-02-09 00:00:00	1999-03-02	1999-03-02 00:00:00	32020		\N	146006	0	444814009	40481087		0
37058	2192	260139	1975-06-30	1975-06-30 00:00:00	1975-07-07	1975-07-07 00:00:00	32020		\N	146170	0	10509002	260139		0
37315	2210	40481087	1963-02-10	1963-02-10 00:00:00	1963-03-03	1963-03-03 00:00:00	32020		\N	147168	0	444814009	40481087		0
47981	2847	4283893	1965-09-14	1965-09-14 00:00:00	1965-11-23	1965-11-23 00:00:00	32020		\N	189091	0	36971009	4283893		0
37615	2230	80180	2009-01-28	2009-01-28 00:00:00	\N	\N	32020		\N	148416	0	396275006	80180		0
37748	2237	40481087	2006-11-29	2006-11-29 00:00:00	2006-12-13	2006-12-13 00:00:00	32020		\N	148765	0	444814009	40481087		0
48497	2871	40481087	1998-12-25	1998-12-25 00:00:00	1999-01-08	1999-01-08 00:00:00	32020		\N	191167	0	444814009	40481087		0
48681	2883	260139	1994-03-14	1994-03-14 00:00:00	1994-03-28	1994-03-28 00:00:00	32020		\N	191770	0	10509002	260139		0
38313	2274	78272	1960-08-21	1960-08-21 00:00:00	1960-09-25	1960-09-25 00:00:00	32020		\N	151206	0	70704007	78272		0
49033	2902	381316	2011-02-11	2011-02-11 00:00:00	\N	\N	32020		\N	193399	0	230690007	381316		0
49152	2906	40481087	1982-05-05	1982-05-05 00:00:00	1982-05-12	1982-05-12 00:00:00	32020		\N	193618	0	444814009	40481087		0
49316	2915	4112343	1952-05-23	1952-05-23 00:00:00	1952-06-01	1952-06-01 00:00:00	32020		\N	194339	0	195662009	4112343		0
39004	2318	81151	1984-03-11	1984-03-11 00:00:00	1984-04-08	1984-04-08 00:00:00	32020		\N	154116	0	44465007	81151		0
49672	2939	257012	2000-03-29	2000-03-29 00:00:00	\N	\N	32020		\N	195999	0	40055000	257012		0
39241	2328	4285898	1999-04-04	1999-04-04 00:00:00	\N	\N	32020		\N	154884	0	68496003	4285898		0
39501	2341	4283893	2012-12-25	2012-12-25 00:00:00	2013-04-30	2013-04-30 00:00:00	32020		\N	155820	0	36971009	4283893		0
39574	2344	80180	1999-11-21	1999-11-21 00:00:00	\N	\N	32020		\N	156018	0	396275006	80180		0
39816	2357	80502	2009-02-24	2009-02-24 00:00:00	\N	\N	32020		\N	157087	0	64859006	80502		0
39999	2372	4112343	1992-04-27	1992-04-27 00:00:00	1992-05-07	1992-05-07 00:00:00	32020		\N	157843	0	195662009	4112343		0
40121	2380	372328	1952-12-26	1952-12-26 00:00:00	1953-05-09	1953-05-09 00:00:00	32020		\N	158230	0	65363002	372328		0
40298	2392	40481087	1974-08-23	1974-08-23 00:00:00	1974-08-30	1974-08-30 00:00:00	32020		\N	159041	0	444814009	40481087		0
40395	2396	372328	1924-05-21	1924-05-21 00:00:00	1924-10-29	1924-10-29 00:00:00	32020		\N	159301	0	65363002	372328		0
51141	3028	40481087	2004-02-19	2004-02-19 00:00:00	2004-03-04	2004-03-04 00:00:00	32020		\N	201914	0	444814009	40481087		0
40815	2427	4218389	1994-06-09	1994-06-09 00:00:00	1994-07-07	1994-07-07 00:00:00	32020		\N	160963	0	39848009	4218389		0
40975	2436	40481087	1960-03-27	1960-03-27 00:00:00	1960-04-03	1960-04-03 00:00:00	32020		\N	161498	0	444814009	40481087		0
51689	3065	260139	1992-09-29	1992-09-29 00:00:00	1992-10-13	1992-10-13 00:00:00	32020		\N	204037	0	10509002	260139		0
51807	3072	372328	1960-08-11	1960-08-11 00:00:00	1960-09-24	1960-09-24 00:00:00	32020		\N	204486	0	65363002	372328		0
41496	2468	40481087	1987-04-09	1987-04-09 00:00:00	1987-04-30	1987-04-30 00:00:00	32020		\N	163596	0	444814009	40481087		0
41649	2477	378001	1971-09-20	1971-09-20 00:00:00	1971-11-19	1971-11-19 00:00:00	32020		\N	164120	0	62106007	378001		0
41770	2485	4112343	1991-03-04	1991-03-04 00:00:00	1991-03-14	1991-03-14 00:00:00	32020		\N	164589	0	195662009	4112343		0
52554	3114	260139	1953-09-12	1953-09-12 00:00:00	1953-09-26	1953-09-26 00:00:00	32020		\N	207141	0	10509002	260139		0
52662	3118	40481087	2004-12-19	2004-12-19 00:00:00	2005-01-02	2005-01-02 00:00:00	32020		\N	207426	0	444814009	40481087		0
52868	3132	4278672	1995-07-01	1995-07-01 00:00:00	1995-09-29	1995-09-29 00:00:00	32020		\N	208386	0	65966004	4278672		0
53003	3137	260139	1944-01-16	1944-01-16 00:00:00	1944-01-23	1944-01-23 00:00:00	32020		\N	208825	0	10509002	260139		0
42502	2534	260139	2017-07-30	2017-07-30 00:00:00	2017-08-06	2017-08-06 00:00:00	32020		\N	167449	0	10509002	260139		0
42723	2545	40481087	1969-07-27	1969-07-27 00:00:00	1969-08-10	1969-08-10 00:00:00	32020		\N	168427	0	444814009	40481087		0
42865	2554	260139	1991-07-22	1991-07-22 00:00:00	1991-07-29	1991-07-29 00:00:00	32020		\N	169153	0	10509002	260139		0
43000	2559	4112343	1962-06-25	1962-06-25 00:00:00	1962-07-02	1962-07-02 00:00:00	32020		\N	169622	0	195662009	4112343		0
32589	1935	260139	1993-01-23	1993-01-23 00:00:00	1993-01-30	1993-01-30 00:00:00	32020		\N	128712	0	10509002	260139		0
43369	2583	4112343	1999-10-12	1999-10-12 00:00:00	1999-10-25	1999-10-25 00:00:00	32020		\N	171020	0	195662009	4112343		0
32954	1954	40481087	1984-05-16	1984-05-16 00:00:00	1984-06-06	1984-06-06 00:00:00	32020		\N	129999	0	444814009	40481087		0
33156	1967	4035415	2006-09-18	2006-09-18 00:00:00	2006-10-18	2006-10-18 00:00:00	32020		\N	130892	0	239720000	4035415		0
33309	1977	313217	2012-05-31	2012-05-31 00:00:00	\N	\N	32020		\N	131568	0	49436004	313217		0
44005	2619	4112343	1948-05-08	1948-05-08 00:00:00	1948-05-18	1948-05-18 00:00:00	32020		\N	173204	0	195662009	4112343		0
33619	1992	4134304	2015-10-24	2015-10-24 00:00:00	2015-11-23	2015-11-23 00:00:00	32020		\N	132689	0	263102004	4134304		0
33789	2005	372328	1974-05-08	1974-05-08 00:00:00	1974-07-20	1974-07-20 00:00:00	32020		\N	133482	0	65363002	372328		0
44513	2649	4112343	1963-01-16	1963-01-16 00:00:00	1963-01-27	1963-01-27 00:00:00	32020		\N	175252	0	195662009	4112343		0
34167	2028	4112343	1985-01-04	1985-01-04 00:00:00	1985-01-15	1985-01-15 00:00:00	32020		\N	134979	0	195662009	4112343		0
34348	2037	30753	1998-12-27	1998-12-27 00:00:00	\N	\N	32020		\N	135653	0	16761005	30753		0
45022	2679	257012	1999-09-07	1999-09-07 00:00:00	\N	\N	32020		\N	177464	0	40055000	257012		0
34599	2053	28060	1959-09-08	1959-09-08 00:00:00	1959-09-16	1959-09-16 00:00:00	32020		\N	136501	0	43878008	28060		0
45374	2698	4112343	2005-12-07	2005-12-07 00:00:00	2005-12-16	2005-12-16 00:00:00	32020		\N	178686	0	195662009	4112343		0
45495	2704	40481087	1975-01-04	1975-01-04 00:00:00	1975-01-25	1975-01-25 00:00:00	32020		\N	179149	0	444814009	40481087		0
35118	2084	4112343	1981-07-16	1981-07-16 00:00:00	1981-07-26	1981-07-26 00:00:00	32020		\N	138851	0	195662009	4112343		0
35282	2090	78272	1976-06-08	1976-06-08 00:00:00	1976-07-06	1976-07-06 00:00:00	32020		\N	139373	0	70704007	78272		0
46008	2740	4112343	1990-07-30	1990-07-30 00:00:00	1990-08-10	1990-08-10 00:00:00	32020		\N	181293	0	195662009	4112343		0
35686	2115	40481087	1970-08-16	1970-08-16 00:00:00	1970-09-06	1970-09-06 00:00:00	32020		\N	140755	0	444814009	40481087		0
35819	2122	30753	2013-02-02	2013-02-02 00:00:00	\N	\N	32020		\N	141174	0	16761005	30753		0
35943	2131	40481087	1958-01-25	1958-01-25 00:00:00	1958-02-15	1958-02-15 00:00:00	32020		\N	141763	0	444814009	40481087		0
46652	2776	40481087	1981-11-15	1981-11-15 00:00:00	1981-11-22	1981-11-22 00:00:00	32020		\N	183765	0	444814009	40481087		0
36323	2151	4112343	1959-06-04	1959-06-04 00:00:00	1959-06-12	1959-06-12 00:00:00	32020		\N	143303	0	195662009	4112343		0
47016	2798	40481087	2012-03-22	2012-03-22 00:00:00	2012-04-05	2012-04-05 00:00:00	32020		\N	185448	0	444814009	40481087		0
36651	2168	4112343	1993-12-20	1993-12-20 00:00:00	1993-12-28	1993-12-28 00:00:00	32020		\N	144557	0	195662009	4112343		0
36806	2176	81893	1999-05-07	1999-05-07 00:00:00	\N	\N	32020		\N	145152	0	64766004	81893		0
36995	2190	28060	2017-06-05	2017-06-05 00:00:00	2017-06-12	2017-06-12 00:00:00	32020		\N	146013	0	43878008	28060		0
37059	2192	4027663	1986-12-15	1986-12-15 00:00:00	\N	\N	32020		\N	146171	0	13200003	4027663		0
37316	2210	4218389	1975-03-17	1975-03-17 00:00:00	1975-04-21	1975-04-21 00:00:00	32020		\N	147199	0	39848009	4218389		0
47982	2847	378001	1996-08-05	1996-08-05 00:00:00	1996-09-04	1996-09-04 00:00:00	32020		\N	189121	0	62106007	378001		0
37616	2230	4237458	1985-06-13	1985-06-13 00:00:00	1985-07-13	1985-07-13 00:00:00	32020		\N	148400	0	58150001	4237458		0
37749	2237	260139	1968-02-05	1968-02-05 00:00:00	1968-02-19	1968-02-19 00:00:00	32020		\N	148789	0	10509002	260139		0
48498	2871	28060	1955-09-19	1955-09-19 00:00:00	1955-10-01	1955-10-01 00:00:00	32020		\N	191119	0	43878008	28060		0
48682	2883	4155034	1966-01-16	1966-01-16 00:00:00	1966-01-30	1966-01-30 00:00:00	32020		\N	191767	0	283371005	4155034		0
38314	2274	28060	1983-12-14	1983-12-14 00:00:00	1983-12-26	1983-12-26 00:00:00	32020		\N	151145	0	43878008	28060		0
49034	2902	260139	2017-09-03	2017-09-03 00:00:00	2017-09-10	2017-09-10 00:00:00	32020		\N	193289	0	10509002	260139		0
49176	2909	195588	1969-04-04	1969-04-04 00:00:00	1969-05-27	1969-05-27 00:00:00	32020		\N	193872	0	38822007	195588		0
49317	2915	257012	1974-12-19	1974-12-19 00:00:00	\N	\N	32020		\N	194324	0	40055000	257012		0
39005	2318	4112343	1983-06-27	1983-06-27 00:00:00	1983-07-06	1983-07-06 00:00:00	32020		\N	154090	0	195662009	4112343		0
49673	2939	40481087	2002-02-08	2002-02-08 00:00:00	2002-03-01	2002-03-01 00:00:00	32020		\N	195942	0	444814009	40481087		0
39242	2328	80180	1999-05-04	1999-05-04 00:00:00	\N	\N	32020		\N	154884	0	396275006	80180		0
39502	2341	4155034	2005-09-25	2005-09-25 00:00:00	2005-10-09	2005-10-09 00:00:00	32020		\N	155806	0	283371005	4155034		0
39575	2344	30753	1998-09-27	1998-09-27 00:00:00	\N	\N	32020		\N	156033	0	16761005	30753		0
39817	2357	372328	1941-10-19	1941-10-19 00:00:00	1942-04-21	1942-04-21 00:00:00	32020		\N	157039	0	65363002	372328		0
40000	2372	440448	1967-04-02	1967-04-02 00:00:00	\N	\N	32020		\N	157839	0	74400008	440448		0
40122	2381	78272	1961-06-10	1961-06-10 00:00:00	1961-07-08	1961-07-08 00:00:00	32020		\N	158305	0	70704007	78272		0
40299	2392	4112343	1922-06-06	1922-06-06 00:00:00	1922-06-17	1922-06-17 00:00:00	32020		\N	159043	0	195662009	4112343		0
40396	2396	4112343	1973-06-13	1973-06-13 00:00:00	1973-06-22	1973-06-22 00:00:00	32020		\N	159345	0	195662009	4112343		0
51142	3028	30753	1999-01-08	1999-01-08 00:00:00	\N	\N	32020		\N	201868	0	16761005	30753		0
40816	2427	260139	1957-07-24	1957-07-24 00:00:00	1957-07-31	1957-07-31 00:00:00	32020		\N	160966	0	10509002	260139		0
40976	2436	4112343	1953-11-21	1953-11-21 00:00:00	1953-12-01	1953-12-01 00:00:00	32020		\N	161639	0	195662009	4112343		0
51690	3065	4112343	1989-10-26	1989-10-26 00:00:00	1989-11-05	1989-11-05 00:00:00	32020		\N	204003	0	195662009	4112343		0
51808	3072	40481087	1959-08-22	1959-08-22 00:00:00	1959-09-12	1959-09-12 00:00:00	32020		\N	204499	0	444814009	40481087		0
41497	2468	40481087	1986-12-27	1986-12-27 00:00:00	1987-01-03	1987-01-03 00:00:00	32020		\N	163595	0	444814009	40481087		0
41650	2477	40481087	1991-02-09	1991-02-09 00:00:00	1991-02-16	1991-02-16 00:00:00	32020		\N	164121	0	444814009	40481087		0
41771	2485	40481087	1933-08-23	1933-08-23 00:00:00	1933-09-13	1933-09-13 00:00:00	32020		\N	164594	0	444814009	40481087		0
52555	3114	4112343	1980-09-07	1980-09-07 00:00:00	1980-09-16	1980-09-16 00:00:00	32020		\N	207113	0	195662009	4112343		0
52663	3118	40486433	1952-12-11	1952-12-11 00:00:00	1967-12-10	1967-12-10 00:00:00	32020		\N	207525	0	446096008	40486433		0
52869	3132	4112343	1995-05-05	1995-05-05 00:00:00	1995-05-14	1995-05-14 00:00:00	32020		\N	208430	0	195662009	4112343		0
53004	3137	80180	1945-04-23	1945-04-23 00:00:00	\N	\N	32020		\N	208825	0	396275006	80180		0
42503	2534	28060	2008-08-16	2008-08-16 00:00:00	2008-08-23	2008-08-23 00:00:00	32020		\N	167389	0	43878008	28060		0
42724	2545	372328	1949-09-24	1949-09-24 00:00:00	1950-07-20	1950-07-20 00:00:00	32020		\N	168432	0	65363002	372328		0
42866	2554	28060	1940-02-08	1940-02-08 00:00:00	1940-02-20	1940-02-20 00:00:00	32020		\N	169134	0	43878008	28060		0
43001	2559	372328	1961-07-18	1961-07-18 00:00:00	1961-12-09	1961-12-09 00:00:00	32020		\N	169653	0	65363002	372328		0
32590	1935	40481087	2018-09-20	2018-09-20 00:00:00	2018-10-04	2018-10-04 00:00:00	32020		\N	128686	0	444814009	40481087		0
43370	2583	4059173	1993-06-28	1993-06-28 00:00:00	1993-07-28	1993-07-28 00:00:00	32020		\N	171045	0	16114001	4059173		0
32955	1954	40481087	1942-01-03	1942-01-03 00:00:00	1942-01-10	1942-01-10 00:00:00	32020		\N	130009	0	444814009	40481087		0
33157	1967	4142905	1956-09-07	1956-09-07 00:00:00	1956-11-06	1956-11-06 00:00:00	32020		\N	130742	0	33737001	4142905		0
33310	1977	260139	1926-11-07	1926-11-07 00:00:00	1926-11-21	1926-11-21 00:00:00	32020		\N	131556	0	10509002	260139		0
44006	2619	40481087	1996-06-08	1996-06-08 00:00:00	1996-06-29	1996-06-29 00:00:00	32020		\N	173165	0	444814009	40481087		0
33663	1998	4027663	2006-09-13	2006-09-13 00:00:00	\N	\N	32020		\N	133026	0	13200003	4027663		0
33790	2006	28060	1972-02-28	1972-02-28 00:00:00	1972-03-11	1972-03-11 00:00:00	32020		\N	133619	0	43878008	28060		0
44514	2649	40481087	1999-08-12	1999-08-12 00:00:00	1999-09-02	1999-09-02 00:00:00	32020		\N	175281	0	444814009	40481087		0
34168	2028	4112343	2011-05-02	2011-05-02 00:00:00	2011-05-14	2011-05-14 00:00:00	32020		\N	134976	0	195662009	4112343		0
34349	2037	4285898	1999-09-23	1999-09-23 00:00:00	\N	\N	32020		\N	135653	0	68496003	4285898		0
45023	2679	81151	1982-11-09	1982-11-09 00:00:00	1982-12-07	1982-12-07 00:00:00	32020		\N	177462	0	44465007	81151		0
34600	2053	40481087	1981-03-04	1981-03-04 00:00:00	1981-03-25	1981-03-25 00:00:00	32020		\N	136476	0	444814009	40481087		0
45375	2698	40481087	1999-02-01	1999-02-01 00:00:00	1999-02-22	1999-02-22 00:00:00	32020		\N	178695	0	444814009	40481087		0
45496	2704	40481087	1989-07-28	1989-07-28 00:00:00	1989-08-04	1989-08-04 00:00:00	32020		\N	179116	0	444814009	40481087		0
35119	2084	4116491	2001-11-08	2001-11-08 00:00:00	2001-12-23	2001-12-23 00:00:00	32020		\N	138862	0	301011002	4116491		0
35283	2090	4112343	2006-04-30	2006-04-30 00:00:00	2006-05-13	2006-05-13 00:00:00	32020		\N	139388	0	195662009	4112343		0
46031	2743	4296204	1989-05-02	1989-05-02 00:00:00	1989-05-16	1989-05-16 00:00:00	32020		\N	181452	0	403190006	4296204		0
35687	2115	40481087	1964-08-18	1964-08-18 00:00:00	1964-09-08	1964-09-08 00:00:00	32020		\N	140740	0	444814009	40481087		0
35820	2122	4310024	2012-04-08	2012-04-08 00:00:00	\N	\N	32020		\N	141174	0	424802006	4310024		0
35944	2131	80180	1986-12-04	1986-12-04 00:00:00	\N	\N	32020		\N	141803	0	396275006	80180		0
46653	2776	4283893	1983-01-21	1983-01-21 00:00:00	1983-02-11	1983-02-11 00:00:00	32020		\N	183853	0	36971009	4283893		0
36324	2151	40481087	1979-12-16	1979-12-16 00:00:00	1979-12-23	1979-12-23 00:00:00	32020		\N	143310	0	444814009	40481087		0
47017	2798	4152936	1977-05-25	1977-05-25 00:00:00	1977-06-08	1977-06-08 00:00:00	32020		\N	185432	0	283385000	4152936		0
36652	2168	78272	2016-07-06	2016-07-06 00:00:00	2016-07-27	2016-07-27 00:00:00	32020		\N	144517	0	70704007	78272		0
36807	2176	81151	2007-01-26	2007-01-26 00:00:00	2007-02-09	2007-02-09 00:00:00	32020		\N	145139	0	44465007	81151		0
36996	2190	4027663	1976-05-01	1976-05-01 00:00:00	\N	\N	32020		\N	146042	0	13200003	4027663		0
37060	2192	260139	1986-07-11	1986-07-11 00:00:00	1986-07-25	1986-07-25 00:00:00	32020		\N	146171	0	10509002	260139		0
37317	2210	4059173	1943-08-20	1943-08-20 00:00:00	1943-11-18	1943-11-18 00:00:00	32020		\N	147195	0	16114001	4059173		0
47983	2847	28060	1975-03-09	1975-03-09 00:00:00	1975-03-18	1975-03-18 00:00:00	32020		\N	189052	0	43878008	28060		0
37617	2230	40481087	1981-08-17	1981-08-17 00:00:00	1981-08-31	1981-08-31 00:00:00	32020		\N	148363	0	444814009	40481087		0
37750	2237	4112343	1956-01-30	1956-01-30 00:00:00	1956-02-09	1956-02-09 00:00:00	32020		\N	148787	0	195662009	4112343		0
48499	2871	4112343	2003-04-21	2003-04-21 00:00:00	2003-04-28	2003-04-28 00:00:00	32020		\N	191168	0	195662009	4112343		0
48683	2883	40481087	1965-05-27	1965-05-27 00:00:00	1965-06-03	1965-06-03 00:00:00	32020		\N	191779	0	444814009	40481087		0
38315	2274	260139	1954-01-26	1954-01-26 00:00:00	1954-02-09	1954-02-09 00:00:00	32020		\N	151133	0	10509002	260139		0
49035	2902	260139	2000-09-21	2000-09-21 00:00:00	2000-10-05	2000-10-05 00:00:00	32020		\N	193300	0	10509002	260139		0
49177	2909	260139	1957-05-13	1957-05-13 00:00:00	1957-05-27	1957-05-27 00:00:00	32020		\N	193871	0	10509002	260139		0
49318	2915	40481087	1956-09-04	1956-09-04 00:00:00	1956-09-11	1956-09-11 00:00:00	32020		\N	194340	0	444814009	40481087		0
39006	2318	378001	1967-11-06	1967-11-06 00:00:00	1967-12-06	1967-12-06 00:00:00	32020		\N	154114	0	62106007	378001		0
49674	2939	4112343	1977-10-17	1977-10-17 00:00:00	1977-10-30	1977-10-30 00:00:00	32020		\N	195940	0	195662009	4112343		0
39243	2328	4266809	1999-05-04	1999-05-04 00:00:00	\N	\N	32020		\N	154884	0	397881000	4266809		0
39503	2341	40481087	1974-12-17	1974-12-17 00:00:00	1974-12-24	1974-12-24 00:00:00	32020		\N	155786	0	444814009	40481087		0
39576	2344	4156265	1969-05-27	1969-05-27 00:00:00	1969-06-17	1969-06-17 00:00:00	32020		\N	156034	0	370247008	4156265		0
39818	2357	40481087	1981-07-17	1981-07-17 00:00:00	1981-08-07	1981-08-07 00:00:00	32020		\N	157051	0	444814009	40481087		0
40001	2372	260139	1965-05-02	1965-05-02 00:00:00	1965-05-16	1965-05-16 00:00:00	32020		\N	157822	0	10509002	260139		0
40123	2381	378001	1973-11-02	1973-11-02 00:00:00	1973-12-02	1973-12-02 00:00:00	32020		\N	158306	0	62106007	378001		0
40300	2392	4152936	1926-05-12	1926-05-12 00:00:00	1926-06-02	1926-06-02 00:00:00	32020		\N	159008	0	283385000	4152936		0
40397	2396	317576	1989-02-01	1989-02-01 00:00:00	\N	\N	32020		\N	159359	0	53741008	317576		0
51144	3028	40481087	1981-01-02	1981-01-02 00:00:00	1981-01-23	1981-01-23 00:00:00	32020		\N	201879	0	444814009	40481087		0
40817	2427	4112343	1959-12-03	1959-12-03 00:00:00	1959-12-13	1959-12-13 00:00:00	32020		\N	161033	0	195662009	4112343		0
40977	2436	260139	2014-12-08	2014-12-08 00:00:00	2014-12-22	2014-12-22 00:00:00	32020		\N	161454	0	10509002	260139		0
51691	3065	40481087	1981-03-12	1981-03-12 00:00:00	1981-03-26	1981-03-26 00:00:00	32020		\N	204019	0	444814009	40481087		0
51809	3072	4294548	1999-01-09	1999-01-09 00:00:00	1999-07-10	1999-07-10 00:00:00	32020		\N	204448	0	75498004	4294548		0
41498	2468	257012	1959-01-14	1959-01-14 00:00:00	\N	\N	32020		\N	163610	0	40055000	257012		0
41651	2477	195588	2001-02-15	2001-02-15 00:00:00	2001-03-30	2001-03-30 00:00:00	32020		\N	164179	0	38822007	195588		0
41772	2485	4112343	2012-05-21	2012-05-21 00:00:00	2012-05-31	2012-05-31 00:00:00	32020		\N	164676	0	195662009	4112343		0
52556	3114	40481087	1973-05-26	1973-05-26 00:00:00	1973-06-09	1973-06-09 00:00:00	32020		\N	207181	0	444814009	40481087		0
52664	3118	4112343	1989-05-03	1989-05-03 00:00:00	1989-05-16	1989-05-16 00:00:00	32020		\N	207485	0	195662009	4112343		0
52870	3132	40481087	1993-10-01	1993-10-01 00:00:00	1993-10-22	1993-10-22 00:00:00	32020		\N	208429	0	444814009	40481087		0
53005	3137	4142905	1975-04-13	1975-04-13 00:00:00	1975-05-13	1975-05-13 00:00:00	32020		\N	208834	0	33737001	4142905		0
42504	2534	81151	2001-05-24	2001-05-24 00:00:00	2001-06-21	2001-06-21 00:00:00	32020		\N	167432	0	44465007	81151		0
42725	2545	40481087	2005-04-10	2005-04-10 00:00:00	2005-05-01	2005-05-01 00:00:00	32020		\N	168369	0	444814009	40481087		0
42867	2554	372328	1939-05-18	1939-05-18 00:00:00	1939-07-13	1939-07-13 00:00:00	32020		\N	169230	0	65363002	372328		0
43003	2561	4294548	1996-11-26	1996-11-26 00:00:00	1997-01-14	1997-01-14 00:00:00	32020		\N	169721	0	75498004	4294548		0
32591	1935	40481087	2016-06-03	2016-06-03 00:00:00	2016-06-24	2016-06-24 00:00:00	32020		\N	128737	0	444814009	40481087		0
43371	2583	257012	2018-08-20	2018-08-20 00:00:00	\N	\N	32020		\N	171028	0	40055000	257012		0
32956	1954	40481087	2004-12-06	2004-12-06 00:00:00	2004-12-20	2004-12-20 00:00:00	32020		\N	130004	0	444814009	40481087		0
33158	1967	192671	1994-05-17	1994-05-17 00:00:00	\N	\N	32020		\N	130743	0	K92.2	35208414		0
33311	1977	260139	1963-12-20	1963-12-20 00:00:00	1963-12-27	1963-12-27 00:00:00	32020		\N	131576	0	10509002	260139		0
44007	2619	260139	1980-06-27	1980-06-27 00:00:00	1980-07-04	1980-07-04 00:00:00	32020		\N	173208	0	10509002	260139		0
33664	1998	40481087	1998-08-07	1998-08-07 00:00:00	1998-08-28	1998-08-28 00:00:00	32020		\N	133034	0	444814009	40481087		0
33791	2006	81151	1955-09-28	1955-09-28 00:00:00	1955-10-12	1955-10-12 00:00:00	32020		\N	133601	0	44465007	81151		0
44515	2649	4218389	1971-01-05	1971-01-05 00:00:00	1971-02-02	1971-02-02 00:00:00	32020		\N	175266	0	39848009	4218389		0
34169	2028	40481087	1967-01-27	1967-01-27 00:00:00	1967-02-17	1967-02-17 00:00:00	32020		\N	134971	0	444814009	40481087		0
34350	2037	4266809	2000-05-20	2000-05-20 00:00:00	\N	\N	32020		\N	135634	0	397881000	4266809		0
45024	2679	4283893	1975-08-18	1975-08-18 00:00:00	1975-10-20	1975-10-20 00:00:00	32020		\N	177493	0	36971009	4283893		0
34601	2053	378001	1970-07-03	1970-07-03 00:00:00	1970-09-01	1970-09-01 00:00:00	32020		\N	136568	0	62106007	378001		0
45376	2699	40481087	2010-01-25	2010-01-25 00:00:00	2010-02-08	2010-02-08 00:00:00	32020		\N	178742	0	444814009	40481087		0
45497	2704	4116491	2004-08-05	2004-08-05 00:00:00	2004-09-21	2004-09-21 00:00:00	32020		\N	179117	0	301011002	4116491		0
35120	2084	260139	1997-04-29	1997-04-29 00:00:00	1997-05-06	1997-05-06 00:00:00	32020		\N	138839	0	10509002	260139		0
35284	2090	4237458	2004-09-07	2004-09-07 00:00:00	2004-12-06	2004-12-06 00:00:00	32020		\N	139374	0	58150001	4237458		0
46032	2743	257012	1980-01-04	1980-01-04 00:00:00	\N	\N	32020		\N	181501	0	40055000	257012		0
35688	2115	4113008	1970-12-12	1970-12-12 00:00:00	1970-12-26	1970-12-26 00:00:00	32020		\N	140702	0	284549007	4113008		0
35821	2123	260139	2018-08-27	2018-08-27 00:00:00	2018-09-10	2018-09-10 00:00:00	32020		\N	141315	0	10509002	260139		0
35945	2131	78272	1962-06-19	1962-06-19 00:00:00	1962-07-10	1962-07-10 00:00:00	32020		\N	141825	0	70704007	78272		0
46654	2776	192671	2014-02-21	2014-02-21 00:00:00	\N	\N	32020		\N	183852	0	K92.2	35208414		0
36326	2151	4329847	1999-12-08	1999-12-08 00:00:00	\N	\N	32020		\N	143282	0	22298006	4329847		0
47018	2798	40481087	1956-03-06	1956-03-06 00:00:00	1956-03-20	1956-03-20 00:00:00	32020		\N	185454	0	444814009	40481087		0
36653	2168	4218389	1964-11-10	1964-11-10 00:00:00	1964-12-15	1964-12-15 00:00:00	32020		\N	144578	0	39848009	4218389		0
36808	2176	81151	1957-07-16	1957-07-16 00:00:00	1957-08-06	1957-08-06 00:00:00	32020		\N	145096	0	44465007	81151		0
36997	2190	4112343	1995-06-05	1995-06-05 00:00:00	1995-06-13	1995-06-13 00:00:00	32020		\N	146011	0	195662009	4112343		0
37061	2192	30753	1995-02-06	1995-02-06 00:00:00	\N	\N	32020		\N	146158	0	16761005	30753		0
37318	2210	260139	1982-09-08	1982-09-08 00:00:00	1982-09-15	1982-09-15 00:00:00	32020		\N	147215	0	10509002	260139		0
47984	2847	78272	1983-10-17	1983-10-17 00:00:00	1983-11-21	1983-11-21 00:00:00	32020		\N	189119	0	70704007	78272		0
37618	2230	4112343	1997-04-30	1997-04-30 00:00:00	1997-05-10	1997-05-10 00:00:00	32020		\N	148403	0	195662009	4112343		0
37751	2237	4278672	1991-03-17	1991-03-17 00:00:00	1991-05-16	1991-05-16 00:00:00	32020		\N	148808	0	65966004	4278672		0
48500	2871	40481087	1990-09-22	1990-09-22 00:00:00	1990-10-13	1990-10-13 00:00:00	32020		\N	191072	0	444814009	40481087		0
48684	2883	4112343	1991-11-04	1991-11-04 00:00:00	1991-11-16	1991-11-16 00:00:00	32020		\N	191769	0	195662009	4112343		0
38316	2274	4112343	1983-03-10	1983-03-10 00:00:00	1983-03-18	1983-03-18 00:00:00	32020		\N	151136	0	195662009	4112343		0
49036	2902	4048171	1950-07-11	1950-07-11 00:00:00	1965-07-09	1965-07-09 00:00:00	32020		\N	193357	0	232353008	4048171		0
49178	2909	260139	1954-08-18	1954-08-18 00:00:00	1954-08-25	1954-08-25 00:00:00	32020		\N	193869	0	10509002	260139		0
49319	2915	134438	1967-05-09	1967-05-09 00:00:00	1968-01-06	1968-01-06 00:00:00	32020		\N	194345	0	40275004	134438		0
39007	2318	40481087	2001-01-28	2001-01-28 00:00:00	2001-02-18	2001-02-18 00:00:00	32020		\N	154096	0	444814009	40481087		0
49675	2939	4112343	2012-07-12	2012-07-12 00:00:00	2012-07-23	2012-07-23 00:00:00	32020		\N	195943	0	195662009	4112343		0
39244	2328	260139	1969-12-09	1969-12-09 00:00:00	1969-12-16	1969-12-16 00:00:00	32020		\N	154806	0	10509002	260139		0
39504	2341	375671	1998-10-02	1998-10-02 00:00:00	1998-11-01	1998-11-01 00:00:00	32020		\N	155805	0	62564004	375671		0
39577	2344	372328	1970-10-04	1970-10-04 00:00:00	1970-11-30	1970-11-30 00:00:00	32020		\N	156027	0	65363002	372328		0
39819	2357	28060	1981-01-24	1981-01-24 00:00:00	1981-02-03	1981-02-03 00:00:00	32020		\N	157019	0	43878008	28060		0
40003	2372	260139	1998-10-30	1998-10-30 00:00:00	1998-11-13	1998-11-13 00:00:00	32020		\N	157868	0	10509002	260139		0
40124	2381	28060	1945-05-06	1945-05-06 00:00:00	1945-05-16	1945-05-16 00:00:00	32020		\N	158345	0	43878008	28060		0
40301	2392	4152936	1937-09-02	1937-09-02 00:00:00	1937-09-16	1937-09-16 00:00:00	32020		\N	159009	0	283385000	4152936		0
40398	2396	4112343	1937-12-27	1937-12-27 00:00:00	1938-01-05	1938-01-05 00:00:00	32020		\N	159302	0	195662009	4112343		0
51145	3028	4112343	1987-11-04	1987-11-04 00:00:00	1987-11-16	1987-11-16 00:00:00	32020		\N	201894	0	195662009	4112343		0
40818	2427	40481087	2002-05-10	2002-05-10 00:00:00	2002-05-31	2002-05-31 00:00:00	32020		\N	161009	0	444814009	40481087		0
40978	2436	4296205	1922-07-27	1922-07-27 00:00:00	1922-08-24	1922-08-24 00:00:00	32020		\N	161447	0	403191005	4296205		0
51692	3065	4237458	1981-02-23	1981-02-23 00:00:00	1981-04-24	1981-04-24 00:00:00	32020		\N	204042	0	58150001	4237458		0
51810	3072	4112343	1962-03-08	1962-03-08 00:00:00	1962-03-20	1962-03-20 00:00:00	32020		\N	204428	0	195662009	4112343		0
41499	2468	4112343	1998-12-24	1998-12-24 00:00:00	1999-01-04	1999-01-04 00:00:00	32020		\N	163606	0	195662009	4112343		0
41652	2477	4218389	1982-02-24	1982-02-24 00:00:00	1982-03-31	1982-03-31 00:00:00	32020		\N	164183	0	39848009	4218389		0
41773	2485	4112343	1987-08-06	1987-08-06 00:00:00	1987-08-18	1987-08-18 00:00:00	32020		\N	164575	0	195662009	4112343		0
52557	3114	4112343	1958-01-19	1958-01-19 00:00:00	1958-02-01	1958-02-01 00:00:00	32020		\N	207142	0	195662009	4112343		0
52665	3118	261325	1983-06-05	1983-06-05 00:00:00	\N	\N	32020		\N	207508	0	87433001	261325		0
52871	3132	440086	1976-07-03	1976-07-03 00:00:00	1981-07-12	1981-07-12 00:00:00	32020		\N	208390	0	192127007	440086		0
53006	3137	28060	1927-03-18	1927-03-18 00:00:00	1927-03-27	1927-03-27 00:00:00	32020		\N	208776	0	43878008	28060		0
42505	2534	40481087	1979-04-27	1979-04-27 00:00:00	1979-05-11	1979-05-11 00:00:00	32020		\N	167456	0	444814009	40481087		0
42726	2546	195588	1993-03-23	1993-03-23 00:00:00	1993-05-03	1993-05-03 00:00:00	32020		\N	168520	0	38822007	195588		0
42868	2554	4112343	2017-08-16	2017-08-16 00:00:00	2017-08-25	2017-08-25 00:00:00	32020		\N	169202	0	195662009	4112343		0
43004	2561	28060	2018-03-06	2018-03-06 00:00:00	2018-03-15	2018-03-15 00:00:00	32020		\N	169674	0	43878008	28060		0
32592	1935	40481087	1994-05-24	1994-05-24 00:00:00	1994-06-14	1994-06-14 00:00:00	32020		\N	128743	0	444814009	40481087		0
43372	2583	4112343	1980-09-29	1980-09-29 00:00:00	1980-10-08	1980-10-08 00:00:00	32020		\N	171024	0	195662009	4112343		0
32957	1954	255848	2006-04-16	2006-04-16 00:00:00	\N	\N	32020		\N	130031	0	233604007	255848		0
33159	1967	260139	2016-03-17	2016-03-17 00:00:00	2016-03-31	2016-03-31 00:00:00	32020		\N	130829	0	10509002	260139		0
33312	1977	40481087	1973-09-07	1973-09-07 00:00:00	1973-09-28	1973-09-28 00:00:00	32020		\N	131559	0	444814009	40481087		0
44008	2619	4112343	1986-12-02	1986-12-02 00:00:00	1986-12-09	1986-12-09 00:00:00	32020		\N	173149	0	195662009	4112343		0
33665	1998	4113008	2017-05-13	2017-05-13 00:00:00	2017-05-27	2017-05-27 00:00:00	32020		\N	133015	0	284549007	4113008		0
33792	2006	378001	1947-12-09	1947-12-09 00:00:00	1948-02-07	1948-02-07 00:00:00	32020		\N	133600	0	62106007	378001		0
44516	2649	81151	2005-04-23	2005-04-23 00:00:00	2005-05-21	2005-05-21 00:00:00	32020		\N	175269	0	44465007	81151		0
34170	2028	4134304	1997-11-16	1997-11-16 00:00:00	1998-01-15	1998-01-15 00:00:00	32020		\N	134954	0	263102004	4134304		0
34351	2037	80180	2000-05-20	2000-05-20 00:00:00	\N	\N	32020		\N	135634	0	396275006	80180		0
45025	2679	78272	1981-11-09	1981-11-09 00:00:00	1981-12-14	1981-12-14 00:00:00	32020		\N	177461	0	70704007	78272		0
34602	2053	28060	1971-02-27	1971-02-27 00:00:00	1971-03-10	1971-03-10 00:00:00	32020		\N	136515	0	43878008	28060		0
45377	2699	378001	2018-12-06	2018-12-06 00:00:00	2019-02-04	2019-02-04 00:00:00	32020		\N	178713	0	62106007	378001		0
45498	2704	4218389	2018-12-19	2018-12-19 00:00:00	2019-01-16	2019-01-16 00:00:00	32020		\N	179114	0	39848009	4218389		0
35121	2084	4283893	1971-09-17	1971-09-17 00:00:00	1971-10-08	1971-10-08 00:00:00	32020		\N	138835	0	36971009	4283893		0
35285	2090	4278672	1971-03-07	1971-03-07 00:00:00	1971-06-05	1971-06-05 00:00:00	32020		\N	139371	0	65966004	4278672		0
46033	2743	260139	2004-10-24	2004-10-24 00:00:00	2004-10-31	2004-10-31 00:00:00	32020		\N	181441	0	10509002	260139		0
35689	2115	40479422	2004-08-29	2004-08-29 00:00:00	2004-10-05	2004-10-05 00:00:00	32020		\N	140705	0	444448004	40479422		0
35822	2123	372328	1953-12-20	1953-12-20 00:00:00	1954-04-02	1954-04-02 00:00:00	32020		\N	141255	0	65363002	372328		0
35946	2131	378001	2012-01-15	2012-01-15 00:00:00	2012-02-14	2012-02-14 00:00:00	32020		\N	141829	0	62106007	378001		0
46655	2776	28060	2001-04-13	2001-04-13 00:00:00	2001-04-22	2001-04-22 00:00:00	32020		\N	183855	0	43878008	28060		0
36327	2151	40481087	1980-01-29	1980-01-29 00:00:00	1980-02-05	1980-02-05 00:00:00	32020		\N	143304	0	444814009	40481087		0
47019	2798	81151	1986-08-20	1986-08-20 00:00:00	1986-09-03	1986-09-03 00:00:00	32020		\N	185433	0	44465007	81151		0
36654	2168	40481087	1956-12-21	1956-12-21 00:00:00	1957-01-04	1957-01-04 00:00:00	32020		\N	144455	0	444814009	40481087		0
36809	2176	40481087	2000-06-01	2000-06-01 00:00:00	2000-06-15	2000-06-15 00:00:00	32020		\N	145161	0	444814009	40481087		0
36998	2190	40481087	1972-12-30	1972-12-30 00:00:00	1973-01-20	1973-01-20 00:00:00	32020		\N	146027	0	444814009	40481087		0
37062	2192	80180	1996-04-01	1996-04-01 00:00:00	\N	\N	32020		\N	146158	0	396275006	80180		0
37319	2210	257012	1975-12-06	1975-12-06 00:00:00	\N	\N	32020		\N	147214	0	40055000	257012		0
47985	2847	4112343	1990-11-18	1990-11-18 00:00:00	1990-11-30	1990-11-30 00:00:00	32020		\N	189095	0	195662009	4112343		0
37619	2230	260139	2002-04-16	2002-04-16 00:00:00	2002-04-30	2002-04-30 00:00:00	32020		\N	148404	0	10509002	260139		0
37752	2237	80502	1999-10-24	1999-10-24 00:00:00	\N	\N	32020		\N	148826	0	64859006	80502		0
48501	2871	40481087	1990-11-20	1990-11-20 00:00:00	1990-12-11	1990-12-11 00:00:00	32020		\N	191156	0	444814009	40481087		0
48699	2886	40481087	2002-02-23	2002-02-23 00:00:00	2002-03-09	2002-03-09 00:00:00	32020		\N	191919	0	444814009	40481087		0
38336	2277	260139	1992-07-06	1992-07-06 00:00:00	1992-07-20	1992-07-20 00:00:00	32020		\N	151377	0	10509002	260139		0
49037	2902	372328	1950-05-29	1950-05-29 00:00:00	1951-06-15	1951-06-15 00:00:00	32020		\N	193301	0	65363002	372328		0
49179	2909	257012	1960-06-21	1960-06-21 00:00:00	\N	\N	32020		\N	193841	0	40055000	257012		0
49327	2917	260139	1941-02-10	1941-02-10 00:00:00	1941-02-17	1941-02-17 00:00:00	32020		\N	194465	0	10509002	260139		0
39008	2318	81893	2001-09-08	2001-09-08 00:00:00	\N	\N	32020		\N	154096	0	64766004	81893		0
49676	2939	372328	1963-12-24	1963-12-24 00:00:00	1964-02-04	1964-02-04 00:00:00	32020		\N	195944	0	65363002	372328		0
39245	2328	40481087	1970-07-24	1970-07-24 00:00:00	1970-07-31	1970-07-31 00:00:00	32020		\N	154808	0	444814009	40481087		0
39505	2341	260139	2010-02-23	2010-02-23 00:00:00	2010-03-02	2010-03-02 00:00:00	32020		\N	155825	0	10509002	260139		0
39578	2344	40481087	1968-01-09	1968-01-09 00:00:00	1968-01-30	1968-01-30 00:00:00	32020		\N	156043	0	444814009	40481087		0
39820	2357	40481087	2010-05-21	2010-05-21 00:00:00	2010-06-11	2010-06-11 00:00:00	32020		\N	156944	0	444814009	40481087		0
40004	2372	4283893	1994-06-27	1994-06-27 00:00:00	1994-08-08	1994-08-08 00:00:00	32020		\N	157812	0	36971009	4283893		0
40125	2381	260139	1997-11-25	1997-11-25 00:00:00	1997-12-09	1997-12-09 00:00:00	32020		\N	158351	0	10509002	260139		0
40302	2392	260139	1957-02-12	1957-02-12 00:00:00	1957-02-27	1957-02-27 00:00:00	32020		\N	159040	0	10509002	260139		0
40399	2396	381316	2000-11-08	2000-11-08 00:00:00	\N	\N	32020		\N	159376	0	230690007	381316		0
51146	3028	40481087	1976-02-29	1976-02-29 00:00:00	1976-03-21	1976-03-21 00:00:00	32020		\N	201904	0	444814009	40481087		0
40819	2427	40481087	1968-10-19	1968-10-19 00:00:00	1968-10-26	1968-10-26 00:00:00	32020		\N	160999	0	444814009	40481087		0
40979	2436	4112343	1970-03-23	1970-03-23 00:00:00	1970-04-02	1970-04-02 00:00:00	32020		\N	161587	0	195662009	4112343		0
51693	3065	40481087	1974-03-08	1974-03-08 00:00:00	1974-03-29	1974-03-29 00:00:00	32020		\N	204017	0	444814009	40481087		0
51811	3072	4112343	1974-01-27	1974-01-27 00:00:00	1974-02-05	1974-02-05 00:00:00	32020		\N	204491	0	195662009	4112343		0
41500	2468	40481087	2010-10-14	2010-10-14 00:00:00	2010-10-28	2010-10-28 00:00:00	32020		\N	163678	0	444814009	40481087		0
41653	2477	81151	1969-10-02	1969-10-02 00:00:00	1969-10-30	1969-10-30 00:00:00	32020		\N	164119	0	44465007	81151		0
41774	2485	4266809	1953-03-09	1953-03-09 00:00:00	\N	\N	32020		\N	164688	0	397881000	4266809		0
52558	3114	4152936	1980-07-21	1980-07-21 00:00:00	1980-08-11	1980-08-11 00:00:00	32020		\N	207116	0	283385000	4152936		0
52666	3118	372328	1953-12-01	1953-12-01 00:00:00	1954-09-19	1954-09-19 00:00:00	32020		\N	207533	0	65363002	372328		0
52872	3132	40481087	1994-06-25	1994-06-25 00:00:00	1994-07-16	1994-07-16 00:00:00	32020		\N	208410	0	444814009	40481087		0
53007	3137	4296205	1933-06-10	1933-06-10 00:00:00	1933-07-08	1933-07-08 00:00:00	32020		\N	208837	0	403191005	4296205		0
42506	2534	40481087	1993-06-03	1993-06-03 00:00:00	1993-06-24	1993-06-24 00:00:00	32020		\N	167447	0	444814009	40481087		0
42727	2546	40481087	1982-01-26	1982-01-26 00:00:00	1982-02-09	1982-02-09 00:00:00	32020		\N	168504	0	444814009	40481087		0
42869	2554	4112343	1963-12-17	1963-12-17 00:00:00	1963-12-24	1963-12-24 00:00:00	32020		\N	169095	0	195662009	4112343		0
43005	2561	372328	1980-10-14	1980-10-14 00:00:00	1981-10-07	1981-10-07 00:00:00	32020		\N	169708	0	65363002	372328		0
32593	1935	40481087	1998-12-15	1998-12-15 00:00:00	1998-12-29	1998-12-29 00:00:00	32020		\N	128685	0	444814009	40481087		0
43373	2583	40481087	1978-11-07	1978-11-07 00:00:00	1978-11-28	1978-11-28 00:00:00	32020		\N	171058	0	444814009	40481087		0
32958	1954	4043241	1998-12-24	1998-12-24 00:00:00	\N	\N	32020		\N	129989	0	230265002	4043241		0
33160	1967	40481087	1974-12-16	1974-12-16 00:00:00	1974-12-30	1974-12-30 00:00:00	32020		\N	130867	0	444814009	40481087		0
33313	1977	4112343	1921-12-10	1921-12-10 00:00:00	1921-12-19	1921-12-19 00:00:00	32020		\N	131555	0	195662009	4112343		0
44009	2619	40481087	1951-07-05	1951-07-05 00:00:00	1951-07-26	1951-07-26 00:00:00	32020		\N	173207	0	444814009	40481087		0
33666	1998	4112343	1983-08-13	1983-08-13 00:00:00	1983-08-25	1983-08-25 00:00:00	32020		\N	133027	0	195662009	4112343		0
33793	2006	40481087	1949-07-20	1949-07-20 00:00:00	1949-08-10	1949-08-10 00:00:00	32020		\N	133618	0	444814009	40481087		0
44517	2649	4112343	1982-04-20	1982-04-20 00:00:00	1982-04-30	1982-04-30 00:00:00	32020		\N	175299	0	195662009	4112343		0
34171	2028	4112343	1974-04-15	1974-04-15 00:00:00	1974-04-28	1974-04-28 00:00:00	32020		\N	134992	0	195662009	4112343		0
34352	2037	28060	2002-12-29	2002-12-29 00:00:00	2003-01-08	2003-01-08 00:00:00	32020		\N	135638	0	43878008	28060		0
45026	2679	260139	2016-09-07	2016-09-07 00:00:00	2016-09-21	2016-09-21 00:00:00	32020		\N	177469	0	10509002	260139		0
34603	2053	260139	1954-09-26	1954-09-26 00:00:00	1954-10-03	1954-10-03 00:00:00	32020		\N	136507	0	10509002	260139		0
45378	2699	40481087	1992-04-29	1992-04-29 00:00:00	1992-05-20	1992-05-20 00:00:00	32020		\N	178701	0	444814009	40481087		0
45499	2704	260139	2014-05-02	2014-05-02 00:00:00	2014-05-09	2014-05-09 00:00:00	32020		\N	179118	0	10509002	260139		0
35122	2084	4116491	1995-10-02	1995-10-02 00:00:00	1995-11-10	1995-11-10 00:00:00	32020		\N	138838	0	301011002	4116491		0
35286	2090	4112343	1973-10-08	1973-10-08 00:00:00	1973-10-17	1973-10-17 00:00:00	32020		\N	139386	0	195662009	4112343		0
46034	2743	28060	2008-03-19	2008-03-19 00:00:00	2008-03-26	2008-03-26 00:00:00	32020		\N	181432	0	43878008	28060		0
35690	2115	4283893	1989-06-07	1989-06-07 00:00:00	1989-07-26	1989-07-26 00:00:00	32020		\N	140752	0	36971009	4283893		0
35823	2123	260139	1967-01-24	1967-01-24 00:00:00	1967-01-31	1967-01-31 00:00:00	32020		\N	141295	0	10509002	260139		0
35947	2131	260139	2014-09-07	2014-09-07 00:00:00	2014-09-14	2014-09-14 00:00:00	32020		\N	141845	0	10509002	260139		0
46656	2776	260139	1980-09-16	1980-09-16 00:00:00	1980-09-30	1980-09-30 00:00:00	32020		\N	183860	0	10509002	260139		0
36328	2151	40481087	1951-06-02	1951-06-02 00:00:00	1951-06-23	1951-06-23 00:00:00	32020		\N	143301	0	444814009	40481087		0
47020	2798	80180	1994-02-18	1994-02-18 00:00:00	\N	\N	32020		\N	185397	0	396275006	80180		0
36655	2168	4152936	1962-10-17	1962-10-17 00:00:00	1962-11-07	1962-11-07 00:00:00	32020		\N	144576	0	283385000	4152936		0
36810	2176	80180	2000-06-30	2000-06-30 00:00:00	\N	\N	32020		\N	145161	0	396275006	80180		0
36999	2190	4112343	1978-12-07	1978-12-07 00:00:00	1978-12-16	1978-12-16 00:00:00	32020		\N	146005	0	195662009	4112343		0
37063	2192	4285898	1995-10-04	1995-10-04 00:00:00	\N	\N	32020		\N	146158	0	68496003	4285898		0
37320	2210	260139	2002-05-01	2002-05-01 00:00:00	2002-05-15	2002-05-15 00:00:00	32020		\N	147272	0	10509002	260139		0
47986	2847	4112343	1968-04-14	1968-04-14 00:00:00	1968-04-23	1968-04-23 00:00:00	32020		\N	189104	0	195662009	4112343		0
37620	2230	260139	1976-09-29	1976-09-29 00:00:00	1976-10-13	1976-10-13 00:00:00	32020		\N	148361	0	10509002	260139		0
37753	2237	317576	2005-12-04	2005-12-04 00:00:00	\N	\N	32020		\N	148757	0	53741008	317576		0
48502	2871	40481087	1951-06-18	1951-06-18 00:00:00	1951-06-25	1951-06-25 00:00:00	32020		\N	191062	0	444814009	40481087		0
48700	2886	4283893	1974-07-17	1974-07-17 00:00:00	1974-10-02	1974-10-02 00:00:00	32020		\N	191945	0	36971009	4283893		0
38337	2277	372328	1970-03-13	1970-03-13 00:00:00	1970-08-16	1970-08-16 00:00:00	32020		\N	151326	0	65363002	372328		0
49038	2902	372328	1947-11-27	1947-11-27 00:00:00	1947-12-11	1947-12-11 00:00:00	32020		\N	193312	0	65363002	372328		0
49180	2909	378001	1971-09-26	1971-09-26 00:00:00	1971-10-26	1971-10-26 00:00:00	32020		\N	193912	0	62106007	378001		0
49328	2917	40481087	1949-08-13	1949-08-13 00:00:00	1949-08-27	1949-08-27 00:00:00	32020		\N	194431	0	444814009	40481087		0
39009	2318	30753	2001-11-07	2001-11-07 00:00:00	\N	\N	32020		\N	154096	0	16761005	30753		0
49677	2939	40481087	1997-12-23	1997-12-23 00:00:00	1998-01-13	1998-01-13 00:00:00	32020		\N	195972	0	444814009	40481087		0
39246	2328	4294548	1985-12-25	1985-12-25 00:00:00	1986-01-15	1986-01-15 00:00:00	32020		\N	154865	0	75498004	4294548		0
39506	2341	40481087	1982-04-21	1982-04-21 00:00:00	1982-04-28	1982-04-28 00:00:00	32020		\N	155822	0	444814009	40481087		0
39579	2344	40481087	1988-10-18	1988-10-18 00:00:00	1988-11-08	1988-11-08 00:00:00	32020		\N	156017	0	444814009	40481087		0
39821	2357	40481087	2008-03-20	2008-03-20 00:00:00	2008-03-27	2008-03-27 00:00:00	32020		\N	156963	0	444814009	40481087		0
40005	2372	4112343	1977-05-08	1977-05-08 00:00:00	1977-05-15	1977-05-15 00:00:00	32020		\N	157866	0	195662009	4112343		0
40126	2381	40481087	1948-04-22	1948-04-22 00:00:00	1948-05-13	1948-05-13 00:00:00	32020		\N	158293	0	444814009	40481087		0
40303	2392	4112343	1956-05-13	1956-05-13 00:00:00	1956-05-22	1956-05-22 00:00:00	32020		\N	159040	0	195662009	4112343		0
40400	2396	4278672	1971-02-08	1971-02-08 00:00:00	1971-05-09	1971-05-09 00:00:00	32020		\N	159322	0	65966004	4278672		0
51147	3028	4112343	1990-04-05	1990-04-05 00:00:00	1990-04-18	1990-04-18 00:00:00	32020		\N	201880	0	195662009	4112343		0
40820	2427	260139	1968-10-01	1968-10-01 00:00:00	1968-10-15	1968-10-15 00:00:00	32020		\N	161028	0	10509002	260139		0
40980	2436	40481087	2001-05-26	2001-05-26 00:00:00	2001-06-16	2001-06-16 00:00:00	32020		\N	161451	0	444814009	40481087		0
51694	3065	4283893	2004-09-22	2004-09-22 00:00:00	2004-11-17	2004-11-17 00:00:00	32020		\N	204038	0	36971009	4283893		0
51812	3072	440086	1968-07-15	1968-07-15 00:00:00	1968-10-14	1968-10-14 00:00:00	32020		\N	204477	0	192127007	440086		0
51959	3079	40481087	1989-08-03	1989-08-03 00:00:00	1989-08-17	1989-08-17 00:00:00	32020		\N	204871	0	444814009	40481087		0
41654	2477	4116491	2003-03-30	2003-03-30 00:00:00	2003-05-08	2003-05-08 00:00:00	32020		\N	164210	0	301011002	4116491		0
41775	2485	30753	1952-05-13	1952-05-13 00:00:00	\N	\N	32020		\N	164688	0	16761005	30753		0
52559	3114	4112343	1979-07-05	1979-07-05 00:00:00	1979-07-14	1979-07-14 00:00:00	32020		\N	207123	0	195662009	4112343		0
52667	3118	40481087	1966-05-09	1966-05-09 00:00:00	1966-05-16	1966-05-16 00:00:00	32020		\N	207434	0	444814009	40481087		0
52873	3132	192671	2007-05-01	2007-05-01 00:00:00	\N	\N	32020		\N	208379	0	K92.2	35208414		0
53008	3137	40481087	1957-12-08	1957-12-08 00:00:00	1957-12-29	1957-12-29 00:00:00	32020		\N	208781	0	444814009	40481087		0
42507	2534	4278672	1974-06-15	1974-06-15 00:00:00	1974-08-14	1974-08-14 00:00:00	32020		\N	167431	0	65966004	4278672		0
42728	2546	40481087	2002-12-28	2002-12-28 00:00:00	2003-01-11	2003-01-11 00:00:00	32020		\N	168466	0	444814009	40481087		0
42870	2554	40481087	2000-01-11	2000-01-11 00:00:00	2000-01-18	2000-01-18 00:00:00	32020		\N	169126	0	444814009	40481087		0
43006	2561	40481087	2016-03-20	2016-03-20 00:00:00	2016-04-03	2016-04-03 00:00:00	32020		\N	169673	0	444814009	40481087		0
32594	1935	28060	1972-12-21	1972-12-21 00:00:00	1972-12-29	1972-12-29 00:00:00	32020		\N	128740	0	43878008	28060		0
43374	2583	372328	1973-07-20	1973-07-20 00:00:00	1973-11-19	1973-11-19 00:00:00	32020		\N	171061	0	65363002	372328		0
32959	1954	4112343	1967-06-15	1967-06-15 00:00:00	1967-06-24	1967-06-24 00:00:00	32020		\N	130048	0	195662009	4112343		0
33161	1967	78272	1985-10-17	1985-10-17 00:00:00	1985-11-07	1985-11-07 00:00:00	32020		\N	130891	0	70704007	78272		0
33314	1977	40481087	1915-12-18	1915-12-18 00:00:00	1915-12-25	1915-12-25 00:00:00	32020		\N	131571	0	444814009	40481087		0
44010	2619	40481087	1942-08-31	1942-08-31 00:00:00	1942-09-14	1942-09-14 00:00:00	32020		\N	173139	0	444814009	40481087		0
33667	1998	40481087	1985-02-05	1985-02-05 00:00:00	1985-02-12	1985-02-12 00:00:00	32020		\N	133028	0	444814009	40481087		0
33794	2006	78272	2013-04-18	2013-04-18 00:00:00	2013-05-09	2013-05-09 00:00:00	32020		\N	133606	0	70704007	78272		0
44518	2649	4027663	1982-05-28	1982-05-28 00:00:00	\N	\N	32020		\N	175299	0	13200003	4027663		0
34172	2028	4112343	1997-10-27	1997-10-27 00:00:00	1997-11-07	1997-11-07 00:00:00	32020		\N	135008	0	195662009	4112343		0
34353	2037	40481087	1991-02-01	1991-02-01 00:00:00	1991-02-08	1991-02-08 00:00:00	32020		\N	135681	0	444814009	40481087		0
45027	2679	80180	2013-01-05	2013-01-05 00:00:00	\N	\N	32020		\N	177513	0	396275006	80180		0
34604	2053	40481087	1988-02-14	1988-02-14 00:00:00	1988-02-21	1988-02-21 00:00:00	32020		\N	136477	0	444814009	40481087		0
45379	2699	260139	2018-06-03	2018-06-03 00:00:00	2018-06-17	2018-06-17 00:00:00	32020		\N	178756	0	10509002	260139		0
45500	2704	40481087	1979-11-06	1979-11-06 00:00:00	1979-11-20	1979-11-20 00:00:00	32020		\N	179121	0	444814009	40481087		0
35123	2084	40481087	1965-09-29	1965-09-29 00:00:00	1965-10-13	1965-10-13 00:00:00	32020		\N	138873	0	444814009	40481087		0
35287	2090	40481087	2002-07-04	2002-07-04 00:00:00	2002-07-18	2002-07-18 00:00:00	32020		\N	139397	0	444814009	40481087		0
46035	2743	81151	1968-02-24	1968-02-24 00:00:00	1968-03-23	1968-03-23 00:00:00	32020		\N	181450	0	44465007	81151		0
46149	2749	4112343	1999-08-14	1999-08-14 00:00:00	1999-08-23	1999-08-23 00:00:00	32020		\N	181820	0	195662009	4112343		0
35824	2123	372328	1951-01-12	1951-01-12 00:00:00	1951-03-30	1951-03-30 00:00:00	32020		\N	141254	0	65363002	372328		0
35948	2131	40481087	1977-02-10	1977-02-10 00:00:00	1977-02-24	1977-02-24 00:00:00	32020		\N	141844	0	444814009	40481087		0
46657	2777	40481087	2016-07-31	2016-07-31 00:00:00	2016-08-07	2016-08-07 00:00:00	32020		\N	183954	0	444814009	40481087		0
36329	2151	40481087	1974-11-25	1974-11-25 00:00:00	1974-12-09	1974-12-09 00:00:00	32020		\N	143258	0	444814009	40481087		0
47021	2798	40481087	1999-01-15	1999-01-15 00:00:00	1999-02-05	1999-02-05 00:00:00	32020		\N	185463	0	444814009	40481087		0
36656	2168	4051466	1960-09-19	1960-09-19 00:00:00	1976-01-04	1976-01-04 00:00:00	32020		\N	144485	0	233678006	4051466		0
36811	2176	4266809	2000-06-30	2000-06-30 00:00:00	\N	\N	32020		\N	145161	0	397881000	4266809		0
37000	2190	4296204	2008-05-06	2008-05-06 00:00:00	2008-05-27	2008-05-27 00:00:00	32020		\N	146082	0	403190006	4296204		0
37120	2199	40481087	1982-07-11	1982-07-11 00:00:00	1982-08-01	1982-08-01 00:00:00	32020		\N	146555	0	444814009	40481087		0
37321	2210	40481087	1950-08-28	1950-08-28 00:00:00	1950-09-18	1950-09-18 00:00:00	32020		\N	147263	0	444814009	40481087		0
47987	2847	40481087	1965-03-22	1965-03-22 00:00:00	1965-04-12	1965-04-12 00:00:00	32020		\N	189102	0	444814009	40481087		0
37621	2230	4027663	2000-05-10	2000-05-10 00:00:00	\N	\N	32020		\N	148385	0	13200003	4027663		0
37754	2237	4112343	1947-08-20	1947-08-20 00:00:00	1947-08-30	1947-08-30 00:00:00	32020		\N	148786	0	195662009	4112343		0
48503	2871	4112343	1978-10-16	1978-10-16 00:00:00	1978-10-28	1978-10-28 00:00:00	32020		\N	191155	0	195662009	4112343		0
48701	2886	4112343	1983-01-06	1983-01-06 00:00:00	1983-01-19	1983-01-19 00:00:00	32020		\N	191896	0	195662009	4112343		0
38338	2277	260139	1977-10-04	1977-10-04 00:00:00	1977-10-18	1977-10-18 00:00:00	32020		\N	151352	0	10509002	260139		0
49039	2902	4112343	1997-08-01	1997-08-01 00:00:00	1997-08-10	1997-08-10 00:00:00	32020		\N	193299	0	195662009	4112343		0
49181	2909	4112343	1977-04-12	1977-04-12 00:00:00	1977-04-23	1977-04-23 00:00:00	32020		\N	193858	0	195662009	4112343		0
49329	2917	40481087	2007-08-31	2007-08-31 00:00:00	2007-09-07	2007-09-07 00:00:00	32020		\N	194498	0	444814009	40481087		0
39010	2318	4112343	1967-01-17	1967-01-17 00:00:00	1967-01-26	1967-01-26 00:00:00	32020		\N	154041	0	195662009	4112343		0
49678	2939	40481087	2013-01-09	2013-01-09 00:00:00	2013-01-30	2013-01-30 00:00:00	32020		\N	196001	0	444814009	40481087		0
39247	2328	4294548	1992-09-01	1992-09-01 00:00:00	1993-01-19	1993-01-19 00:00:00	32020		\N	154866	0	75498004	4294548		0
39507	2341	4152936	1967-01-08	1967-01-08 00:00:00	1967-01-29	1967-01-29 00:00:00	32020		\N	155801	0	283385000	4152936		0
39580	2344	4112343	1989-03-26	1989-03-26 00:00:00	1989-04-08	1989-04-08 00:00:00	32020		\N	156025	0	195662009	4112343		0
39822	2357	28060	1977-07-30	1977-07-30 00:00:00	1977-08-10	1977-08-10 00:00:00	32020		\N	156935	0	43878008	28060		0
40006	2372	4112343	1991-06-22	1991-06-22 00:00:00	1991-06-29	1991-06-29 00:00:00	32020		\N	157827	0	195662009	4112343		0
40127	2381	40481087	1993-09-15	1993-09-15 00:00:00	1993-09-29	1993-09-29 00:00:00	32020		\N	158334	0	444814009	40481087		0
40304	2392	4294548	1932-08-18	1932-08-18 00:00:00	1932-09-08	1932-09-08 00:00:00	32020		\N	159017	0	75498004	4294548		0
40401	2396	4237458	2000-09-03	2000-09-03 00:00:00	2000-10-03	2000-10-03 00:00:00	32020		\N	159324	0	58150001	4237458		0
51148	3028	372328	1964-08-24	1964-08-24 00:00:00	1965-04-08	1965-04-08 00:00:00	32020		\N	201915	0	65363002	372328		0
40821	2427	40481087	2012-05-21	2012-05-21 00:00:00	2012-06-04	2012-06-04 00:00:00	32020		\N	161002	0	444814009	40481087		0
40981	2436	40481087	1917-03-19	1917-03-19 00:00:00	1917-03-26	1917-03-26 00:00:00	32020		\N	161449	0	444814009	40481087		0
51695	3065	40479422	1982-05-19	1982-05-19 00:00:00	1982-06-25	1982-06-25 00:00:00	32020		\N	204043	0	444448004	40479422		0
51813	3072	40481087	1961-12-08	1961-12-08 00:00:00	1961-12-15	1961-12-15 00:00:00	32020		\N	204427	0	444814009	40481087		0
51960	3079	4283893	2006-06-18	2006-06-18 00:00:00	2006-10-15	2006-10-15 00:00:00	32020		\N	204921	0	36971009	4283893		0
41655	2477	4112343	2010-11-09	2010-11-09 00:00:00	2010-11-18	2010-11-18 00:00:00	32020		\N	164122	0	195662009	4112343		0
41776	2485	80180	1953-03-09	1953-03-09 00:00:00	\N	\N	32020		\N	164688	0	396275006	80180		0
52560	3114	4112343	1990-06-10	1990-06-10 00:00:00	1990-06-23	1990-06-23 00:00:00	32020		\N	207133	0	195662009	4112343		0
52668	3119	78272	2012-06-16	2012-06-16 00:00:00	2012-07-07	2012-07-07 00:00:00	32020		\N	207539	0	70704007	78272		0
52874	3132	40481087	1991-07-17	1991-07-17 00:00:00	1991-08-07	1991-08-07 00:00:00	32020		\N	208428	0	444814009	40481087		0
53009	3137	4283893	1982-09-27	1982-09-27 00:00:00	1982-11-22	1982-11-22 00:00:00	32020		\N	208828	0	36971009	4283893		0
42508	2534	372328	1984-10-09	1984-10-09 00:00:00	1985-08-20	1985-08-20 00:00:00	32020		\N	167403	0	65363002	372328		0
42729	2546	260139	1989-09-12	1989-09-12 00:00:00	1989-09-19	1989-09-19 00:00:00	32020		\N	168508	0	10509002	260139		0
42871	2554	192671	1968-03-29	1968-03-29 00:00:00	\N	\N	32020		\N	169200	0	K92.2	35208414		0
43007	2561	40481087	1999-11-27	1999-11-27 00:00:00	1999-12-18	1999-12-18 00:00:00	32020		\N	169722	0	444814009	40481087		0
32595	1935	28060	1981-05-01	1981-05-01 00:00:00	1981-05-13	1981-05-13 00:00:00	32020		\N	128711	0	43878008	28060		0
43375	2583	4112343	1973-12-10	1973-12-10 00:00:00	1973-12-20	1973-12-20 00:00:00	32020		\N	171057	0	195662009	4112343		0
32960	1954	4112343	1988-05-06	1988-05-06 00:00:00	1988-05-15	1988-05-15 00:00:00	32020		\N	130051	0	195662009	4112343		0
33162	1967	40481087	1959-06-01	1959-06-01 00:00:00	1959-06-15	1959-06-15 00:00:00	32020		\N	130865	0	444814009	40481087		0
33315	1977	4109685	2007-12-09	2007-12-09 00:00:00	2007-12-23	2007-12-23 00:00:00	32020		\N	131627	0	284551006	4109685		0
44011	2619	40481087	1985-08-21	1985-08-21 00:00:00	1985-08-28	1985-08-28 00:00:00	32020		\N	173163	0	444814009	40481087		0
33668	1998	4112343	1990-01-02	1990-01-02 00:00:00	1990-01-13	1990-01-13 00:00:00	32020		\N	133033	0	195662009	4112343		0
33795	2006	4294548	1965-10-08	1965-10-08 00:00:00	1965-12-03	1965-12-03 00:00:00	32020		\N	133592	0	75498004	4294548		0
44519	2649	4112343	2012-03-19	2012-03-19 00:00:00	2012-03-31	2012-03-31 00:00:00	32020		\N	175273	0	195662009	4112343		0
34189	2030	260139	1974-04-29	1974-04-29 00:00:00	1974-05-13	1974-05-13 00:00:00	32020		\N	135118	0	10509002	260139		0
34354	2037	4218389	2002-04-03	2002-04-03 00:00:00	2002-05-01	2002-05-01 00:00:00	32020		\N	135660	0	39848009	4218389		0
45028	2679	4109685	2009-12-13	2009-12-13 00:00:00	2010-01-03	2010-01-03 00:00:00	32020		\N	177491	0	284551006	4109685		0
34605	2053	4112343	1966-03-16	1966-03-16 00:00:00	1966-03-23	1966-03-23 00:00:00	32020		\N	136514	0	195662009	4112343		0
45380	2699	40481087	1987-07-24	1987-07-24 00:00:00	1987-08-14	1987-08-14 00:00:00	32020		\N	178718	0	444814009	40481087		0
45501	2704	4112343	2014-08-05	2014-08-05 00:00:00	2014-08-16	2014-08-16 00:00:00	32020		\N	179122	0	195662009	4112343		0
35124	2084	4296204	1976-08-27	1976-08-27 00:00:00	1976-09-10	1976-09-10 00:00:00	32020		\N	138832	0	403190006	4296204		0
35288	2090	40481087	1986-03-16	1986-03-16 00:00:00	1986-03-23	1986-03-23 00:00:00	32020		\N	139396	0	444814009	40481087		0
46036	2743	40481087	1986-12-22	1986-12-22 00:00:00	1987-01-12	1987-01-12 00:00:00	32020		\N	181440	0	444814009	40481087		0
46150	2749	378001	2004-11-27	2004-11-27 00:00:00	2005-01-26	2005-01-26 00:00:00	32020		\N	181850	0	62106007	378001		0
35825	2123	4278672	2002-05-19	2002-05-19 00:00:00	2002-08-17	2002-08-17 00:00:00	32020		\N	141321	0	65966004	4278672		0
35949	2131	260139	1958-07-17	1958-07-17 00:00:00	1958-07-24	1958-07-24 00:00:00	32020		\N	141791	0	10509002	260139		0
46658	2777	40481087	2013-12-18	2013-12-18 00:00:00	2014-01-08	2014-01-08 00:00:00	32020		\N	183952	0	444814009	40481087		0
36330	2151	372328	1919-11-04	1919-11-04 00:00:00	1920-03-17	1920-03-17 00:00:00	32020		\N	143312	0	65363002	372328		0
47022	2798	4112343	1983-11-25	1983-11-25 00:00:00	1983-12-05	1983-12-05 00:00:00	32020		\N	185453	0	195662009	4112343		0
36657	2168	4310024	1987-10-06	1987-10-06 00:00:00	\N	\N	32020		\N	\N	0	424802006	4310024		0
36812	2177	372328	1969-03-13	1969-03-13 00:00:00	1969-03-27	1969-03-27 00:00:00	32020		\N	145206	0	65363002	372328		0
37001	2190	4112343	1986-03-13	1986-03-13 00:00:00	1986-03-22	1986-03-22 00:00:00	32020		\N	146000	0	195662009	4112343		0
37121	2199	4027663	2009-07-14	2009-07-14 00:00:00	\N	\N	32020		\N	146584	0	13200003	4027663		0
37322	2210	40481087	1991-11-24	1991-11-24 00:00:00	1991-12-15	1991-12-15 00:00:00	32020		\N	147205	0	444814009	40481087		0
47988	2847	40481087	1967-10-23	1967-10-23 00:00:00	1967-11-06	1967-11-06 00:00:00	32020		\N	189103	0	444814009	40481087		0
37622	2231	4112343	1977-11-29	1977-11-29 00:00:00	1977-12-08	1977-12-08 00:00:00	32020		\N	148425	0	195662009	4112343		0
37755	2237	372328	1931-10-27	1931-10-27 00:00:00	1932-04-17	1932-04-17 00:00:00	32020		\N	148767	0	65363002	372328		0
48504	2871	372328	1952-05-16	1952-05-16 00:00:00	1952-11-17	1952-11-17 00:00:00	32020		\N	191159	0	65363002	372328		0
48702	2886	372328	1952-08-02	1952-08-02 00:00:00	1952-11-17	1952-11-17 00:00:00	32020		\N	191990	0	65363002	372328		0
38339	2277	4112343	1970-07-15	1970-07-15 00:00:00	1970-07-22	1970-07-22 00:00:00	32020		\N	151351	0	195662009	4112343		0
49040	2903	260139	1979-01-26	1979-01-26 00:00:00	1979-02-02	1979-02-02 00:00:00	32020		\N	193410	0	10509002	260139		0
49182	2909	260139	1952-03-21	1952-03-21 00:00:00	1952-03-28	1952-03-28 00:00:00	32020		\N	193840	0	10509002	260139		0
49330	2917	40481087	2009-08-03	2009-08-03 00:00:00	2009-08-10	2009-08-10 00:00:00	32020		\N	194458	0	444814009	40481087		0
49469	2926	40481087	2006-02-23	2006-02-23 00:00:00	2006-03-09	2006-03-09 00:00:00	32020		\N	195145	0	444814009	40481087		0
49679	2939	260139	1974-09-29	1974-09-29 00:00:00	1974-10-06	1974-10-06 00:00:00	32020		\N	195916	0	10509002	260139		0
39248	2328	4296205	1991-01-07	1991-01-07 00:00:00	1991-02-04	1991-02-04 00:00:00	32020		\N	154899	0	403191005	4296205		0
39508	2341	4218389	2014-05-25	2014-05-25 00:00:00	2014-06-29	2014-06-29 00:00:00	32020		\N	155849	0	39848009	4218389		0
39581	2344	40481087	2004-12-30	2004-12-30 00:00:00	2005-01-20	2005-01-20 00:00:00	32020		\N	156026	0	444814009	40481087		0
39823	2357	40481087	1943-05-29	1943-05-29 00:00:00	1943-06-12	1943-06-12 00:00:00	32020		\N	157057	0	444814009	40481087		0
50465	2986	4112343	1999-03-10	1999-03-10 00:00:00	1999-03-23	1999-03-23 00:00:00	32020		\N	199285	0	195662009	4112343		0
40128	2381	4109685	1982-11-15	1982-11-15 00:00:00	1982-12-06	1982-12-06 00:00:00	32020		\N	158242	0	284551006	4109685		0
40305	2392	313217	1997-05-16	1997-05-16 00:00:00	\N	\N	32020		\N	158971	0	49436004	313217		0
40402	2396	4112343	1958-07-03	1958-07-03 00:00:00	1958-07-14	1958-07-14 00:00:00	32020		\N	159295	0	195662009	4112343		0
51149	3028	378001	1999-02-22	1999-02-22 00:00:00	1999-04-23	1999-04-23 00:00:00	32020		\N	201861	0	62106007	378001		0
40822	2427	28060	2007-09-06	2007-09-06 00:00:00	2007-09-15	2007-09-15 00:00:00	32020		\N	161000	0	43878008	28060		0
40982	2436	4278672	1990-01-20	1990-01-20 00:00:00	1990-03-21	1990-03-21 00:00:00	32020		\N	161576	0	65966004	4278672		0
51696	3065	260139	1995-04-27	1995-04-27 00:00:00	1995-05-04	1995-05-04 00:00:00	32020		\N	204073	0	10509002	260139		0
51814	3072	260139	1983-03-15	1983-03-15 00:00:00	1983-03-22	1983-03-22 00:00:00	32020		\N	204478	0	10509002	260139		0
51961	3079	260139	1965-11-28	1965-11-28 00:00:00	1965-12-12	1965-12-12 00:00:00	32020		\N	204919	0	10509002	260139		0
41656	2477	40486433	1957-03-05	1957-03-05 00:00:00	\N	\N	32020		\N	164175	0	446096008	40486433		0
41777	2485	40481087	1988-04-30	1988-04-30 00:00:00	1988-05-07	1988-05-07 00:00:00	32020		\N	164588	0	444814009	40481087		0
52561	3114	372328	1950-12-04	1950-12-04 00:00:00	1951-08-29	1951-08-29 00:00:00	32020		\N	207124	0	65363002	372328		0
52669	3119	40481087	1999-06-23	1999-06-23 00:00:00	1999-06-30	1999-06-30 00:00:00	32020		\N	207587	0	444814009	40481087		0
52875	3132	372328	1965-11-23	1965-11-23 00:00:00	1965-12-07	1965-12-07 00:00:00	32020		\N	208393	0	65363002	372328		0
53010	3137	40481087	1972-06-21	1972-06-21 00:00:00	1972-07-12	1972-07-12 00:00:00	32020		\N	208809	0	444814009	40481087		0
42509	2535	4294548	2017-11-08	2017-11-08 00:00:00	2018-02-07	2018-02-07 00:00:00	32020		\N	167498	0	75498004	4294548		0
42730	2546	260139	2014-12-13	2014-12-13 00:00:00	2014-12-20	2014-12-20 00:00:00	32020		\N	168482	0	10509002	260139		0
42872	2554	80502	2003-12-25	2003-12-25 00:00:00	\N	\N	32020		\N	169107	0	64859006	80502		0
43008	2561	40481087	1996-01-18	1996-01-18 00:00:00	1996-01-25	1996-01-25 00:00:00	32020		\N	169707	0	444814009	40481087		0
32961	1954	4296205	1972-11-07	1972-11-07 00:00:00	1972-12-12	1972-12-12 00:00:00	32020		\N	130037	0	403191005	4296205		0
33163	1967	4112343	1993-04-22	1993-04-22 00:00:00	1993-05-03	1993-05-03 00:00:00	32020		\N	130832	0	195662009	4112343		0
33316	1977	260139	1984-12-18	1984-12-18 00:00:00	1985-01-01	1985-01-01 00:00:00	32020		\N	131650	0	10509002	260139		0
44012	2619	4112343	1987-06-10	1987-06-10 00:00:00	1987-06-22	1987-06-22 00:00:00	32020		\N	173150	0	195662009	4112343		0
33669	1998	260139	2012-01-12	2012-01-12 00:00:00	2012-01-19	2012-01-19 00:00:00	32020		\N	133018	0	10509002	260139		0
33796	2006	78272	1986-08-30	1986-08-30 00:00:00	1986-09-27	1986-09-27 00:00:00	32020		\N	133602	0	70704007	78272		0
44520	2649	4112343	1993-03-05	1993-03-05 00:00:00	1993-03-16	1993-03-16 00:00:00	32020		\N	175333	0	195662009	4112343		0
34190	2030	28060	1968-11-20	1968-11-20 00:00:00	1968-12-01	1968-12-01 00:00:00	32020		\N	135116	0	43878008	28060		0
34355	2037	40481087	1995-10-23	1995-10-23 00:00:00	1995-11-13	1995-11-13 00:00:00	32020		\N	135626	0	444814009	40481087		0
45029	2679	4278672	1976-12-05	1976-12-05 00:00:00	1977-01-04	1977-01-04 00:00:00	32020		\N	177460	0	65966004	4278672		0
34606	2053	372328	1956-06-01	1956-06-01 00:00:00	1956-08-02	1956-08-02 00:00:00	32020		\N	136550	0	65363002	372328		0
45381	2699	4112343	2011-09-25	2011-09-25 00:00:00	2011-10-08	2011-10-08 00:00:00	32020		\N	178702	0	195662009	4112343		0
45502	2704	378001	1989-01-11	1989-01-11 00:00:00	1989-03-12	1989-03-12 00:00:00	32020		\N	179112	0	62106007	378001		0
35125	2084	4112343	1971-05-29	1971-05-29 00:00:00	1971-06-07	1971-06-07 00:00:00	32020		\N	138853	0	195662009	4112343		0
35289	2090	260139	2011-06-10	2011-06-10 00:00:00	2011-06-24	2011-06-24 00:00:00	32020		\N	139390	0	10509002	260139		0
46037	2743	4237458	1977-07-04	1977-07-04 00:00:00	1977-10-02	1977-10-02 00:00:00	32020		\N	181451	0	58150001	4237458		0
46151	2749	4156265	2007-10-13	2007-10-13 00:00:00	2007-10-27	2007-10-27 00:00:00	32020		\N	181829	0	370247008	4156265		0
35826	2123	260139	1991-07-25	1991-07-25 00:00:00	1991-08-08	1991-08-08 00:00:00	32020		\N	141279	0	10509002	260139		0
35950	2131	260139	1956-06-09	1956-06-09 00:00:00	1956-06-23	1956-06-23 00:00:00	32020		\N	141843	0	10509002	260139		0
46659	2777	40481087	1971-11-20	1971-11-20 00:00:00	1971-12-04	1971-12-04 00:00:00	32020		\N	183965	0	444814009	40481087		0
36331	2151	40481087	1923-12-07	1923-12-07 00:00:00	1923-12-28	1923-12-28 00:00:00	32020		\N	143268	0	444814009	40481087		0
47023	2798	40481087	1961-12-01	1961-12-01 00:00:00	1961-12-15	1961-12-15 00:00:00	32020		\N	185402	0	444814009	40481087		0
36658	2168	260139	1995-09-12	1995-09-12 00:00:00	1995-09-26	1995-09-26 00:00:00	32020		\N	144437	0	10509002	260139		0
36813	2177	372328	1971-05-17	1971-05-17 00:00:00	1972-05-03	1972-05-03 00:00:00	32020		\N	145216	0	65363002	372328		0
37002	2190	372328	1985-11-09	1985-11-09 00:00:00	1987-12-21	1987-12-21 00:00:00	32020		\N	146031	0	65363002	372328		0
37122	2199	40481087	2013-11-21	2013-11-21 00:00:00	2013-12-05	2013-12-05 00:00:00	32020		\N	146547	0	444814009	40481087		0
37323	2210	372328	1937-09-20	1937-09-20 00:00:00	1938-01-02	1938-01-02 00:00:00	32020		\N	147256	0	65363002	372328		0
47989	2847	40481087	1987-06-10	1987-06-10 00:00:00	1987-06-17	1987-06-17 00:00:00	32020		\N	189054	0	444814009	40481087		0
37623	2231	4278672	1982-09-03	1982-09-03 00:00:00	1982-11-02	1982-11-02 00:00:00	32020		\N	148428	0	65966004	4278672		0
37756	2237	372328	1934-08-18	1934-08-18 00:00:00	1934-10-28	1934-10-28 00:00:00	32020		\N	148750	0	65363002	372328		0
48505	2871	40481087	1960-08-22	1960-08-22 00:00:00	1960-09-05	1960-09-05 00:00:00	32020		\N	191110	0	444814009	40481087		0
48703	2886	372328	1953-02-15	1953-02-15 00:00:00	1953-05-18	1953-05-18 00:00:00	32020		\N	191975	0	65363002	372328		0
38340	2277	80180	2001-03-15	2001-03-15 00:00:00	\N	\N	32020		\N	151335	0	396275006	80180		0
49041	2903	4109685	1973-08-23	1973-08-23 00:00:00	1973-09-13	1973-09-13 00:00:00	32020		\N	193430	0	284551006	4109685		0
49183	2909	260139	1972-03-13	1972-03-13 00:00:00	1972-03-20	1972-03-20 00:00:00	32020		\N	193844	0	10509002	260139		0
49331	2917	313217	1989-09-13	1989-09-13 00:00:00	\N	\N	32020		\N	194453	0	49436004	313217		0
49470	2926	4027663	2010-09-11	2010-09-11 00:00:00	\N	\N	32020		\N	195161	0	13200003	4027663		0
49680	2939	40481087	1990-01-06	1990-01-06 00:00:00	1990-01-27	1990-01-27 00:00:00	32020		\N	195917	0	444814009	40481087		0
39249	2328	4112343	2003-09-21	2003-09-21 00:00:00	2003-09-28	2003-09-28 00:00:00	32020		\N	154856	0	195662009	4112343		0
49969	2953	4112343	1988-05-17	1988-05-17 00:00:00	1988-05-28	1988-05-28 00:00:00	32020		\N	197122	0	195662009	4112343		0
39582	2344	4027663	1992-03-07	1992-03-07 00:00:00	\N	\N	32020		\N	156031	0	13200003	4027663		0
39824	2357	260139	1953-07-31	1953-07-31 00:00:00	1953-08-14	1953-08-14 00:00:00	32020		\N	157080	0	10509002	260139		0
50466	2986	260139	1958-08-29	1958-08-29 00:00:00	1958-09-12	1958-09-12 00:00:00	32020		\N	199284	0	10509002	260139		0
40129	2381	4112343	1951-09-26	1951-09-26 00:00:00	1951-10-03	1951-10-03 00:00:00	32020		\N	158314	0	195662009	4112343		0
40306	2392	40481087	1922-11-06	1922-11-06 00:00:00	1922-11-13	1922-11-13 00:00:00	32020		\N	159042	0	444814009	40481087		0
40403	2396	4112343	1949-08-09	1949-08-09 00:00:00	1949-08-16	1949-08-16 00:00:00	32020		\N	159397	0	195662009	4112343		0
51150	3028	80180	2000-07-01	2000-07-01 00:00:00	\N	\N	32020		\N	201864	0	396275006	80180		0
40823	2427	260139	1998-08-29	1998-08-29 00:00:00	1998-09-12	1998-09-12 00:00:00	32020		\N	161038	0	10509002	260139		0
40983	2437	4296205	2001-11-24	2001-11-24 00:00:00	2001-12-29	2001-12-29 00:00:00	32020		\N	161669	0	403191005	4296205		0
51697	3065	372328	1974-10-28	1974-10-28 00:00:00	1974-12-05	1974-12-05 00:00:00	32020		\N	204045	0	65363002	372328		0
51815	3072	257012	2012-12-03	2012-12-03 00:00:00	\N	\N	32020		\N	204497	0	40055000	257012		0
51962	3080	40481087	1998-08-01	1998-08-01 00:00:00	1998-08-22	1998-08-22 00:00:00	32020		\N	205023	0	444814009	40481087		0
41657	2477	28060	1967-06-10	1967-06-10 00:00:00	1967-06-18	1967-06-18 00:00:00	32020		\N	164141	0	43878008	28060		0
41778	2485	4027663	1944-06-24	1944-06-24 00:00:00	\N	\N	32020		\N	164685	0	13200003	4027663		0
52562	3114	4112343	1988-07-09	1988-07-09 00:00:00	1988-07-19	1988-07-19 00:00:00	32020		\N	207182	0	195662009	4112343		0
52670	3119	40481087	1984-08-11	1984-08-11 00:00:00	1984-09-01	1984-09-01 00:00:00	32020		\N	207576	0	444814009	40481087		0
52876	3132	81151	1981-03-18	1981-03-18 00:00:00	1981-04-15	1981-04-15 00:00:00	32020		\N	208385	0	44465007	81151		0
53011	3137	28060	1981-04-13	1981-04-13 00:00:00	1981-04-21	1981-04-21 00:00:00	32020		\N	208794	0	43878008	28060		0
42510	2535	40481087	2003-01-21	2003-01-21 00:00:00	2003-01-28	2003-01-28 00:00:00	32020		\N	167522	0	444814009	40481087		0
42731	2546	372328	1976-08-19	1976-08-19 00:00:00	1976-09-02	1976-09-02 00:00:00	32020		\N	168483	0	65363002	372328		0
42873	2554	40481087	2001-11-16	2001-11-16 00:00:00	2001-12-07	2001-12-07 00:00:00	32020		\N	169221	0	444814009	40481087		0
43009	2561	40481087	2005-11-23	2005-11-23 00:00:00	2005-12-07	2005-12-07 00:00:00	32020		\N	169724	0	444814009	40481087		0
32597	1935	80180	2009-03-09	2009-03-09 00:00:00	\N	\N	32020		\N	128694	0	396275006	80180		0
43377	2583	4166224	2001-06-08	2001-06-08 00:00:00	\N	\N	32020		\N	171046	0	47693006	4166224		0
32962	1954	4152936	1981-05-29	1981-05-29 00:00:00	1981-06-12	1981-06-12 00:00:00	32020		\N	130038	0	283385000	4152936		0
33164	1967	4116491	1980-10-06	1980-10-06 00:00:00	1980-11-15	1980-11-15 00:00:00	32020		\N	130746	0	301011002	4116491		0
33317	1977	260139	1931-01-29	1931-01-29 00:00:00	1931-02-12	1931-02-12 00:00:00	32020		\N	131506	0	10509002	260139		0
44013	2619	30753	1977-04-25	1977-04-25 00:00:00	\N	\N	32020		\N	173143	0	16761005	30753		0
33670	1998	40481087	2012-09-15	2012-09-15 00:00:00	2012-09-22	2012-09-22 00:00:00	32020		\N	132991	0	444814009	40481087		0
33797	2006	40481087	1954-08-23	1954-08-23 00:00:00	1954-09-13	1954-09-13 00:00:00	32020		\N	133546	0	444814009	40481087		0
44521	2649	40481087	1983-07-17	1983-07-17 00:00:00	1983-08-07	1983-08-07 00:00:00	32020		\N	175254	0	444814009	40481087		0
34191	2030	4134304	1967-01-26	1967-01-26 00:00:00	1967-02-25	1967-02-25 00:00:00	32020		\N	135103	0	263102004	4134304		0
34356	2037	28060	1982-08-01	1982-08-01 00:00:00	1982-08-14	1982-08-14 00:00:00	32020		\N	135680	0	43878008	28060		0
45030	2679	4112343	1985-10-04	1985-10-04 00:00:00	1985-10-13	1985-10-13 00:00:00	32020		\N	177479	0	195662009	4112343		0
34607	2053	4112343	1958-06-05	1958-06-05 00:00:00	1958-06-12	1958-06-12 00:00:00	32020		\N	136500	0	195662009	4112343		0
45382	2699	80180	2012-02-20	2012-02-20 00:00:00	\N	\N	32020		\N	178702	0	396275006	80180		0
45503	2704	80180	2011-05-26	2011-05-26 00:00:00	\N	\N	32020		\N	179146	0	396275006	80180		0
35126	2084	372328	1967-10-20	1967-10-20 00:00:00	1968-09-25	1968-09-25 00:00:00	32020		\N	138880	0	65363002	372328		0
35290	2090	40481087	1985-10-03	1985-10-03 00:00:00	1985-10-10	1985-10-10 00:00:00	32020		\N	139395	0	444814009	40481087		0
46038	2743	40481087	1999-07-06	1999-07-06 00:00:00	1999-07-20	1999-07-20 00:00:00	32020		\N	181463	0	444814009	40481087		0
46152	2749	260139	2014-03-29	2014-03-29 00:00:00	2014-04-05	2014-04-05 00:00:00	32020		\N	181834	0	10509002	260139		0
35827	2123	80502	2009-06-19	2009-06-19 00:00:00	\N	\N	32020		\N	141303	0	64859006	80502		0
35951	2131	40481087	1995-10-27	1995-10-27 00:00:00	1995-11-03	1995-11-03 00:00:00	32020		\N	141794	0	444814009	40481087		0
46660	2777	378001	1978-02-16	1978-02-16 00:00:00	1978-04-17	1978-04-17 00:00:00	32020		\N	183932	0	62106007	378001		0
36332	2151	40481087	1944-06-23	1944-06-23 00:00:00	1944-07-07	1944-07-07 00:00:00	32020		\N	143307	0	444814009	40481087		0
47024	2798	372328	2015-05-19	2015-05-19 00:00:00	2015-09-20	2015-09-20 00:00:00	32020		\N	185450	0	65363002	372328		0
36659	2168	260139	1987-03-19	1987-03-19 00:00:00	1987-03-26	1987-03-26 00:00:00	32020		\N	144462	0	10509002	260139		0
36814	2177	40481087	2013-10-15	2013-10-15 00:00:00	2013-11-04	2013-11-04 00:00:00	32020		\N	145193	0	444814009	40481087		0
37003	2190	78272	1957-10-28	1957-10-28 00:00:00	1957-11-18	1957-11-18 00:00:00	32020		\N	146079	0	70704007	78272		0
37123	2199	378001	2016-01-09	2016-01-09 00:00:00	2016-03-09	2016-03-09 00:00:00	32020		\N	146579	0	62106007	378001		0
37324	2210	4294548	1948-03-28	1948-03-28 00:00:00	1948-04-04	1948-04-04 00:00:00	32020		\N	147262	0	75498004	4294548		0
47990	2847	4112343	2016-05-19	2016-05-19 00:00:00	2016-05-30	2016-05-30 00:00:00	32020		\N	189114	0	195662009	4112343		0
37624	2231	28060	2012-12-02	2012-12-02 00:00:00	2012-12-15	2012-12-15 00:00:00	32020		\N	148454	0	43878008	28060		0
37757	2237	40481087	1961-11-21	1961-11-21 00:00:00	1961-12-12	1961-12-12 00:00:00	32020		\N	148762	0	444814009	40481087		0
48506	2871	81151	1967-07-15	1967-07-15 00:00:00	1967-08-05	1967-08-05 00:00:00	32020		\N	191094	0	44465007	81151		0
48704	2886	40481087	1999-04-14	1999-04-14 00:00:00	1999-05-05	1999-05-05 00:00:00	32020		\N	191971	0	444814009	40481087		0
38341	2277	260139	2005-10-09	2005-10-09 00:00:00	2005-10-23	2005-10-23 00:00:00	32020		\N	151325	0	10509002	260139		0
49042	2903	40481087	1979-12-26	1979-12-26 00:00:00	1980-01-09	1980-01-09 00:00:00	32020		\N	193439	0	444814009	40481087		0
49184	2909	28060	1997-02-08	1997-02-08 00:00:00	1997-02-20	1997-02-20 00:00:00	32020		\N	193846	0	43878008	28060		0
49332	2917	372328	1940-04-28	1940-04-28 00:00:00	1940-08-07	1940-08-07 00:00:00	32020		\N	194459	0	65363002	372328		0
49471	2926	372328	1982-11-12	1982-11-12 00:00:00	1982-11-26	1982-11-26 00:00:00	32020		\N	195180	0	65363002	372328		0
49681	2939	80180	1997-10-31	1997-10-31 00:00:00	\N	\N	32020		\N	195924	0	396275006	80180		0
39250	2329	40481087	2001-09-19	2001-09-19 00:00:00	2001-09-26	2001-09-26 00:00:00	32020		\N	154925	0	444814009	40481087		0
49970	2953	4112343	1993-12-14	1993-12-14 00:00:00	1993-12-22	1993-12-22 00:00:00	32020		\N	197130	0	195662009	4112343		0
39583	2344	40481087	1990-02-06	1990-02-06 00:00:00	1990-02-20	1990-02-20 00:00:00	32020		\N	156075	0	444814009	40481087		0
39825	2357	4112343	1969-10-26	1969-10-26 00:00:00	1969-11-08	1969-11-08 00:00:00	32020		\N	156934	0	195662009	4112343		0
50467	2986	257012	2018-02-20	2018-02-20 00:00:00	2018-04-24	2018-04-24 00:00:00	32020		\N	199274	0	40055000	257012		0
40130	2381	4112343	1955-06-26	1955-06-26 00:00:00	1955-07-05	1955-07-05 00:00:00	32020		\N	158316	0	195662009	4112343		0
40307	2392	40481087	1995-07-06	1995-07-06 00:00:00	1995-07-13	1995-07-13 00:00:00	32020		\N	159024	0	444814009	40481087		0
40404	2396	4112343	1934-03-09	1934-03-09 00:00:00	1934-03-16	1934-03-16 00:00:00	32020		\N	159399	0	195662009	4112343		0
51151	3028	4283893	1999-11-10	1999-11-10 00:00:00	2000-02-02	2000-02-02 00:00:00	32020		\N	201864	0	36971009	4283893		0
40824	2427	4283893	2006-01-19	2006-01-19 00:00:00	2006-02-02	2006-02-02 00:00:00	32020		\N	161011	0	36971009	4283893		0
40984	2437	40481087	1983-12-18	1983-12-18 00:00:00	1984-01-01	1984-01-01 00:00:00	32020		\N	161658	0	444814009	40481087		0
51698	3065	257012	1977-01-18	1977-01-18 00:00:00	\N	\N	32020		\N	204077	0	40055000	257012		0
51816	3072	4294548	2012-11-05	2012-11-05 00:00:00	2012-12-17	2012-12-17 00:00:00	32020		\N	204494	0	75498004	4294548		0
51963	3080	40481087	1958-09-01	1958-09-01 00:00:00	1958-09-22	1958-09-22 00:00:00	32020		\N	205013	0	444814009	40481087		0
41658	2477	260139	1957-06-17	1957-06-17 00:00:00	1957-07-01	1957-07-01 00:00:00	32020		\N	164151	0	10509002	260139		0
41779	2485	4112343	1976-08-24	1976-08-24 00:00:00	1976-09-01	1976-09-01 00:00:00	32020		\N	164586	0	195662009	4112343		0
52563	3114	80180	1983-02-21	1983-02-21 00:00:00	\N	\N	32020		\N	207149	0	396275006	80180		0
52671	3119	4109685	1997-09-12	1997-09-12 00:00:00	1997-10-03	1997-10-03 00:00:00	32020		\N	207538	0	284551006	4109685		0
52877	3132	4112343	1971-10-26	1971-10-26 00:00:00	1971-11-04	1971-11-04 00:00:00	32020		\N	208388	0	195662009	4112343		0
53012	3137	195588	1943-05-17	1943-05-17 00:00:00	1943-06-28	1943-06-28 00:00:00	32020		\N	208824	0	38822007	195588		0
42511	2535	4112343	1988-08-26	1988-08-26 00:00:00	1988-09-03	1988-09-03 00:00:00	32020		\N	167553	0	195662009	4112343		0
42732	2546	4155034	1976-01-22	1976-01-22 00:00:00	1976-02-12	1976-02-12 00:00:00	32020		\N	168458	0	283371005	4155034		0
42874	2554	4294548	1978-08-01	1978-08-01 00:00:00	1978-10-31	1978-10-31 00:00:00	32020		\N	169216	0	75498004	4294548		0
43010	2561	372328	2014-02-16	2014-02-16 00:00:00	2014-12-17	2014-12-17 00:00:00	32020		\N	169675	0	65363002	372328		0
32598	1935	372328	1965-09-26	1965-09-26 00:00:00	1966-01-11	1966-01-11 00:00:00	32020		\N	128745	0	65363002	372328		0
43378	2583	4112343	1991-04-16	1991-04-16 00:00:00	1991-04-24	1991-04-24 00:00:00	32020		\N	171033	0	195662009	4112343		0
32963	1954	372328	1936-12-25	1936-12-25 00:00:00	1937-04-08	1937-04-08 00:00:00	32020		\N	129953	0	65363002	372328		0
33165	1967	4112343	2002-06-19	2002-06-19 00:00:00	2002-06-26	2002-06-26 00:00:00	32020		\N	130835	0	195662009	4112343		0
33318	1977	28060	1988-05-20	1988-05-20 00:00:00	1988-05-30	1988-05-30 00:00:00	32020		\N	131560	0	43878008	28060		0
44014	2619	80180	1978-08-18	1978-08-18 00:00:00	\N	\N	32020		\N	173143	0	396275006	80180		0
33671	1998	4310024	2013-10-11	2013-10-11 00:00:00	\N	\N	32020		\N	132991	0	424802006	4310024		0
33798	2006	4155034	2008-06-22	2008-06-22 00:00:00	2008-07-13	2008-07-13 00:00:00	32020		\N	133605	0	283371005	4155034		0
44522	2649	80180	1993-01-15	1993-01-15 00:00:00	\N	\N	32020		\N	175263	0	396275006	80180		0
34192	2030	40481087	1982-06-29	1982-06-29 00:00:00	1982-07-13	1982-07-13 00:00:00	32020		\N	135144	0	444814009	40481087		0
34357	2037	28060	1980-10-01	1980-10-01 00:00:00	1980-10-08	1980-10-08 00:00:00	32020		\N	135678	0	43878008	28060		0
45031	2679	40481087	2010-02-18	2010-02-18 00:00:00	2010-03-11	2010-03-11 00:00:00	32020		\N	177459	0	444814009	40481087		0
34608	2054	260139	1987-01-11	1987-01-11 00:00:00	1987-01-25	1987-01-25 00:00:00	32020		\N	136640	0	10509002	260139		0
45383	2699	40481087	1989-12-27	1989-12-27 00:00:00	1990-01-03	1990-01-03 00:00:00	32020		\N	178700	0	444814009	40481087		0
45504	2705	4112343	1985-04-18	1985-04-18 00:00:00	1985-04-28	1985-04-28 00:00:00	32020		\N	179180	0	195662009	4112343		0
35127	2084	80180	1999-08-17	1999-08-17 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
35291	2090	40481087	1990-01-08	1990-01-08 00:00:00	1990-01-29	1990-01-29 00:00:00	32020		\N	139355	0	444814009	40481087		0
46039	2743	4112343	1998-07-31	1998-07-31 00:00:00	1998-08-07	1998-08-07 00:00:00	32020		\N	181462	0	195662009	4112343		0
46153	2749	4112343	1961-12-16	1961-12-16 00:00:00	1961-12-25	1961-12-25 00:00:00	32020		\N	181783	0	195662009	4112343		0
35828	2123	40479422	1994-10-21	1994-10-21 00:00:00	1994-12-27	1994-12-27 00:00:00	32020		\N	141319	0	444448004	40479422		0
35952	2131	81151	2003-06-10	2003-06-10 00:00:00	2003-07-01	2003-07-01 00:00:00	32020		\N	141828	0	44465007	81151		0
46661	2777	4142905	1993-10-01	1993-10-01 00:00:00	1993-10-31	1993-10-31 00:00:00	32020		\N	183935	0	33737001	4142905		0
36333	2151	313217	1975-04-30	1975-04-30 00:00:00	\N	\N	32020		\N	143273	0	49436004	313217		0
47025	2798	4134304	1958-04-18	1958-04-18 00:00:00	1958-06-17	1958-06-17 00:00:00	32020		\N	185428	0	263102004	4134304		0
36660	2168	40481087	1986-10-04	1986-10-04 00:00:00	1986-10-18	1986-10-18 00:00:00	32020		\N	144417	0	444814009	40481087		0
36815	2177	81151	2002-09-17	2002-09-17 00:00:00	2002-10-15	2002-10-15 00:00:00	32020		\N	145185	0	44465007	81151		0
37004	2190	40481087	2011-01-26	2011-01-26 00:00:00	2011-02-02	2011-02-02 00:00:00	32020		\N	146030	0	444814009	40481087		0
37124	2199	4285898	2016-01-04	2016-01-04 00:00:00	\N	\N	32020		\N	146579	0	68496003	4285898		0
37325	2210	40481087	1991-03-10	1991-03-10 00:00:00	1991-03-24	1991-03-24 00:00:00	32020		\N	147217	0	444814009	40481087		0
47991	2847	4294548	1963-10-12	1963-10-12 00:00:00	1963-11-23	1963-11-23 00:00:00	32020		\N	189101	0	75498004	4294548		0
37625	2231	4112343	1987-11-05	1987-11-05 00:00:00	1987-11-12	1987-11-12 00:00:00	32020		\N	148419	0	195662009	4112343		0
37758	2237	260139	2001-11-01	2001-11-01 00:00:00	2001-11-15	2001-11-15 00:00:00	32020		\N	148764	0	10509002	260139		0
48507	2871	4237458	1960-11-18	1960-11-18 00:00:00	1961-01-17	1961-01-17 00:00:00	32020		\N	191093	0	58150001	4237458		0
48705	2886	440086	1959-12-09	1959-12-09 00:00:00	1960-10-26	1960-10-26 00:00:00	32020		\N	191954	0	192127007	440086		0
38342	2277	40481087	1975-11-02	1975-11-02 00:00:00	1975-11-16	1975-11-16 00:00:00	32020		\N	151339	0	444814009	40481087		0
49043	2903	40481087	1983-07-30	1983-07-30 00:00:00	1983-08-06	1983-08-06 00:00:00	32020		\N	193466	0	444814009	40481087		0
49185	2909	198809	1962-04-07	1962-04-07 00:00:00	1962-04-07	1962-04-07 00:00:00	32020		\N	193910	0	65275009	198809		0
49333	2917	40481087	1987-12-26	1987-12-26 00:00:00	1988-01-02	1988-01-02 00:00:00	32020		\N	194437	0	444814009	40481087		0
49472	2926	28060	1995-12-03	1995-12-03 00:00:00	1995-12-11	1995-12-11 00:00:00	32020		\N	195192	0	43878008	28060		0
49682	2939	4294548	2000-02-09	2000-02-09 00:00:00	2000-07-12	2000-07-12 00:00:00	32020		\N	195941	0	75498004	4294548		0
39251	2329	4237458	1982-10-25	1982-10-25 00:00:00	1983-01-23	1983-01-23 00:00:00	32020		\N	154901	0	58150001	4237458		0
49971	2953	28060	1993-11-02	1993-11-02 00:00:00	1993-11-11	1993-11-11 00:00:00	32020		\N	197129	0	43878008	28060		0
39584	2344	372328	1967-07-07	1967-07-07 00:00:00	1967-08-21	1967-08-21 00:00:00	32020		\N	156077	0	65363002	372328		0
39826	2357	260139	1957-09-26	1957-09-26 00:00:00	1957-10-10	1957-10-10 00:00:00	32020		\N	157093	0	10509002	260139		0
50468	2986	140673	2015-09-23	2015-09-23 00:00:00	\N	\N	32020		\N	199350	0	40930008	140673		0
40131	2381	4156265	2003-08-16	2003-08-16 00:00:00	2003-08-30	2003-08-30 00:00:00	32020		\N	158244	0	370247008	4156265		0
40308	2392	4112343	1976-01-22	1976-01-22 00:00:00	1976-01-29	1976-01-29 00:00:00	32020		\N	159101	0	195662009	4112343		0
40405	2396	4112343	1991-09-14	1991-09-14 00:00:00	1991-09-24	1991-09-24 00:00:00	32020		\N	159347	0	195662009	4112343		0
51152	3028	40481087	1994-03-21	1994-03-21 00:00:00	1994-04-04	1994-04-04 00:00:00	32020		\N	201881	0	444814009	40481087		0
40825	2427	4112343	1974-07-29	1974-07-29 00:00:00	1974-08-06	1974-08-06 00:00:00	32020		\N	161029	0	195662009	4112343		0
40985	2437	40481087	1972-11-04	1972-11-04 00:00:00	1972-11-18	1972-11-18 00:00:00	32020		\N	161657	0	444814009	40481087		0
51699	3065	260139	1983-12-03	1983-12-03 00:00:00	1983-12-10	1983-12-10 00:00:00	32020		\N	204020	0	10509002	260139		0
51818	3072	321042	1964-02-01	1964-02-01 00:00:00	\N	\N	32020		\N	204459	0	410429000	321042		0
51964	3080	195588	1968-12-05	1968-12-05 00:00:00	1969-01-22	1969-01-22 00:00:00	32020		\N	204988	0	38822007	195588		0
41659	2477	80180	1998-06-06	1998-06-06 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
41780	2485	372328	1999-10-14	1999-10-14 00:00:00	2000-10-25	2000-10-25 00:00:00	32020		\N	164650	0	65363002	372328		0
52564	3114	4285898	1982-06-26	1982-06-26 00:00:00	\N	\N	32020		\N	207149	0	68496003	4285898		0
52672	3119	4059173	1985-07-03	1985-07-03 00:00:00	1985-09-01	1985-09-01 00:00:00	32020		\N	207536	0	16114001	4059173		0
52878	3132	81151	1999-08-09	1999-08-09 00:00:00	1999-09-13	1999-09-13 00:00:00	32020		\N	208387	0	44465007	81151		0
53013	3137	40481087	1931-11-11	1931-11-11 00:00:00	1931-11-18	1931-11-18 00:00:00	32020		\N	208832	0	444814009	40481087		0
42512	2535	257012	2018-01-10	2018-01-10 00:00:00	\N	\N	32020		\N	167556	0	40055000	257012		0
42733	2546	40481087	2006-07-30	2006-07-30 00:00:00	2006-08-20	2006-08-20 00:00:00	32020		\N	168521	0	444814009	40481087		0
42875	2554	4112343	1968-04-05	1968-04-05 00:00:00	1968-04-15	1968-04-15 00:00:00	32020		\N	169097	0	195662009	4112343		0
43011	2561	4283893	1981-10-10	1981-10-10 00:00:00	1981-11-28	1981-11-28 00:00:00	32020		\N	169704	0	36971009	4283893		0
32599	1935	4112343	1977-10-06	1977-10-06 00:00:00	1977-10-15	1977-10-15 00:00:00	32020		\N	128735	0	195662009	4112343		0
43379	2583	4116491	2000-06-07	2000-06-07 00:00:00	2000-07-20	2000-07-20 00:00:00	32020		\N	171027	0	301011002	4116491		0
32964	1954	40481087	1997-11-30	1997-11-30 00:00:00	1997-12-21	1997-12-21 00:00:00	32020		\N	129959	0	444814009	40481087		0
33166	1967	260139	2001-12-12	2001-12-12 00:00:00	2001-12-19	2001-12-19 00:00:00	32020		\N	130828	0	10509002	260139		0
33319	1977	81151	1993-08-19	1993-08-19 00:00:00	1993-09-09	1993-09-09 00:00:00	32020		\N	131625	0	44465007	81151		0
44015	2619	28060	1948-03-24	1948-03-24 00:00:00	1948-04-06	1948-04-06 00:00:00	32020		\N	173203	0	43878008	28060		0
33672	1998	4112343	1986-11-09	1986-11-09 00:00:00	1986-11-16	1986-11-16 00:00:00	32020		\N	132990	0	195662009	4112343		0
33799	2006	28060	1961-12-11	1961-12-11 00:00:00	1961-12-21	1961-12-21 00:00:00	32020		\N	133567	0	43878008	28060		0
44523	2649	81893	1992-01-21	1992-01-21 00:00:00	\N	\N	32020		\N	175263	0	64766004	81893		0
34193	2030	260139	1990-06-22	1990-06-22 00:00:00	1990-06-29	1990-06-29 00:00:00	32020		\N	135142	0	10509002	260139		0
34358	2037	78272	1966-02-13	1966-02-13 00:00:00	1966-03-13	1966-03-13 00:00:00	32020		\N	135658	0	70704007	78272		0
45032	2680	80180	2007-10-17	2007-10-17 00:00:00	\N	\N	32020		\N	177593	0	396275006	80180		0
34609	2054	260139	1973-04-16	1973-04-16 00:00:00	1973-04-23	1973-04-23 00:00:00	32020		\N	136583	0	10509002	260139		0
45384	2699	4294548	1987-01-11	1987-01-11 00:00:00	1987-02-15	1987-02-15 00:00:00	32020		\N	178699	0	75498004	4294548		0
45505	2705	372328	1998-03-08	1998-03-08 00:00:00	1998-10-03	1998-10-03 00:00:00	32020		\N	179196	0	65363002	372328		0
35128	2084	4156265	1979-06-27	1979-06-27 00:00:00	1979-07-18	1979-07-18 00:00:00	32020		\N	138833	0	370247008	4156265		0
35292	2090	260139	1999-05-05	1999-05-05 00:00:00	1999-05-12	1999-05-12 00:00:00	32020		\N	139377	0	10509002	260139		0
46040	2743	40481087	1983-03-21	1983-03-21 00:00:00	1983-04-04	1983-04-04 00:00:00	32020		\N	181456	0	444814009	40481087		0
46154	2749	40481087	1978-09-07	1978-09-07 00:00:00	1978-09-21	1978-09-21 00:00:00	32020		\N	181831	0	444814009	40481087		0
35829	2123	4112343	1984-11-11	1984-11-11 00:00:00	1984-11-19	1984-11-19 00:00:00	32020		\N	141309	0	195662009	4112343		0
35953	2131	4084167	1962-03-30	1962-03-30 00:00:00	1962-03-30	1962-03-30 00:00:00	32020		\N	141824	0	241929008	4084167		0
46662	2777	4218389	2015-10-20	2015-10-20 00:00:00	2015-11-09	2015-11-09 00:00:00	32020		\N	183938	0	39848009	4218389		0
36334	2151	260139	1969-03-17	1969-03-17 00:00:00	1969-03-31	1969-03-31 00:00:00	32020		\N	143257	0	10509002	260139		0
47026	2798	260139	1963-06-23	1963-06-23 00:00:00	1963-07-07	1963-07-07 00:00:00	32020		\N	185444	0	10509002	260139		0
36661	2168	28060	1980-08-19	1980-08-19 00:00:00	1980-08-28	1980-08-28 00:00:00	32020		\N	144409	0	43878008	28060		0
36816	2177	4134304	1982-10-02	1982-10-02 00:00:00	1982-10-31	1982-10-31 00:00:00	32020		\N	145184	0	263102004	4134304		0
37005	2190	4112343	1961-12-23	1961-12-23 00:00:00	1962-01-01	1962-01-01 00:00:00	32020		\N	146068	0	195662009	4112343		0
37125	2199	4112343	1991-01-05	1991-01-05 00:00:00	1991-01-15	1991-01-15 00:00:00	32020		\N	146545	0	195662009	4112343		0
37326	2210	40481087	1937-12-25	1937-12-25 00:00:00	1938-01-15	1938-01-15 00:00:00	32020		\N	147234	0	444814009	40481087		0
47992	2847	40481087	1990-07-09	1990-07-09 00:00:00	1990-07-23	1990-07-23 00:00:00	32020		\N	189094	0	444814009	40481087		0
37626	2231	40481087	1979-11-26	1979-11-26 00:00:00	1979-12-03	1979-12-03 00:00:00	32020		\N	148418	0	444814009	40481087		0
37759	2237	372328	1933-09-09	1933-09-09 00:00:00	1933-10-22	1933-10-22 00:00:00	32020		\N	148845	0	65363002	372328		0
48508	2871	4112343	1972-05-08	1972-05-08 00:00:00	1972-05-17	1972-05-17 00:00:00	32020		\N	191166	0	195662009	4112343		0
48706	2886	4112343	2003-05-20	2003-05-20 00:00:00	2003-05-30	2003-05-30 00:00:00	32020		\N	191951	0	195662009	4112343		0
38343	2277	40481087	2017-09-19	2017-09-19 00:00:00	2017-10-10	2017-10-10 00:00:00	32020		\N	151354	0	444814009	40481087		0
49044	2903	4116491	1998-09-06	1998-09-06 00:00:00	1998-10-15	1998-10-15 00:00:00	32020		\N	193467	0	301011002	4116491		0
49186	2909	196456	1962-04-07	1962-04-07 00:00:00	1962-04-07	1962-04-07 00:00:00	32020		\N	193910	0	235919008	196456		0
49334	2917	4152936	2016-08-31	2016-08-31 00:00:00	2016-09-14	2016-09-14 00:00:00	32020		\N	194504	0	283385000	4152936		0
49473	2926	40481087	1991-08-06	1991-08-06 00:00:00	1991-08-20	1991-08-20 00:00:00	32020		\N	195197	0	444814009	40481087		0
49683	2939	40481087	1962-07-08	1962-07-08 00:00:00	1962-07-29	1962-07-29 00:00:00	32020		\N	195915	0	444814009	40481087		0
39252	2329	28060	1977-03-14	1977-03-14 00:00:00	1977-03-26	1977-03-26 00:00:00	32020		\N	154922	0	43878008	28060		0
49972	2953	4112343	2017-07-27	2017-07-27 00:00:00	2017-08-03	2017-08-03 00:00:00	32020		\N	197136	0	195662009	4112343		0
39585	2344	81151	1983-09-02	1983-09-02 00:00:00	1983-09-16	1983-09-16 00:00:00	32020		\N	156035	0	44465007	81151		0
39827	2357	372328	1941-03-04	1941-03-04 00:00:00	1941-04-22	1941-04-22 00:00:00	32020		\N	156945	0	65363002	372328		0
50469	2986	4112343	1946-02-06	1946-02-06 00:00:00	1946-02-17	1946-02-17 00:00:00	32020		\N	199327	0	195662009	4112343		0
40132	2381	4112343	1953-10-23	1953-10-23 00:00:00	1953-11-01	1953-11-01 00:00:00	32020		\N	158315	0	195662009	4112343		0
40309	2392	4109685	1954-10-08	1954-10-08 00:00:00	1954-10-29	1954-10-29 00:00:00	32020		\N	159011	0	284551006	4109685		0
40406	2396	4296204	1954-10-14	1954-10-14 00:00:00	1954-11-04	1954-11-04 00:00:00	32020		\N	159321	0	403190006	4296204		0
51153	3028	313217	2007-05-17	2007-05-17 00:00:00	\N	\N	32020		\N	201875	0	49436004	313217		0
40826	2427	372328	1985-10-24	1985-10-24 00:00:00	1986-04-29	1986-04-29 00:00:00	32020		\N	160981	0	65363002	372328		0
40986	2437	40481087	1964-07-23	1964-07-23 00:00:00	1964-08-13	1964-08-13 00:00:00	32020		\N	161691	0	444814009	40481087		0
51700	3065	40481087	1977-09-03	1977-09-03 00:00:00	1977-09-24	1977-09-24 00:00:00	32020		\N	204078	0	444814009	40481087		0
51819	3072	40481087	1969-05-15	1969-05-15 00:00:00	1969-05-22	1969-05-22 00:00:00	32020		\N	204446	0	444814009	40481087		0
51965	3080	80180	1981-09-18	1981-09-18 00:00:00	\N	\N	32020		\N	205038	0	396275006	80180		0
41660	2477	40481087	1970-11-03	1970-11-03 00:00:00	1970-11-17	1970-11-17 00:00:00	32020		\N	164152	0	444814009	40481087		0
41781	2485	372328	1913-08-31	1913-08-31 00:00:00	1913-10-08	1913-10-08 00:00:00	32020		\N	164599	0	65363002	372328		0
52565	3114	40481087	1976-10-27	1976-10-27 00:00:00	1976-11-10	1976-11-10 00:00:00	32020		\N	207112	0	444814009	40481087		0
52673	3119	372328	1978-02-25	1978-02-25 00:00:00	1978-05-22	1978-05-22 00:00:00	32020		\N	207590	0	65363002	372328		0
52879	3132	80180	2007-04-17	2007-04-17 00:00:00	\N	\N	32020		\N	208441	0	396275006	80180		0
53014	3137	81151	1961-02-11	1961-02-11 00:00:00	1961-02-25	1961-02-25 00:00:00	32020		\N	208838	0	44465007	81151		0
42513	2535	40481087	1994-04-17	1994-04-17 00:00:00	1994-05-01	1994-05-01 00:00:00	32020		\N	167551	0	444814009	40481087		0
42734	2546	4146173	1990-07-28	1990-07-28 00:00:00	1990-08-27	1990-08-27 00:00:00	32020		\N	168481	0	307731004	4146173		0
42876	2554	4112343	1934-09-24	1934-09-24 00:00:00	1934-10-04	1934-10-04 00:00:00	32020		\N	169133	0	195662009	4112343		0
43012	2561	4156265	1981-08-02	1981-08-02 00:00:00	1981-08-23	1981-08-23 00:00:00	32020		\N	169701	0	370247008	4156265		0
32600	1936	4116491	1983-02-12	1983-02-12 00:00:00	1983-03-20	1983-03-20 00:00:00	32020		\N	128752	0	301011002	4116491		0
43380	2583	372328	1973-01-30	1973-01-30 00:00:00	1973-05-21	1973-05-21 00:00:00	32020		\N	171029	0	65363002	372328		0
32965	1954	4112343	1982-12-22	1982-12-22 00:00:00	1983-01-02	1983-01-02 00:00:00	32020		\N	130014	0	195662009	4112343		0
33167	1967	40481087	1965-08-20	1965-08-20 00:00:00	1965-08-27	1965-08-27 00:00:00	32020		\N	130850	0	444814009	40481087		0
33320	1977	4112343	1998-04-09	1998-04-09 00:00:00	1998-04-19	1998-04-19 00:00:00	32020		\N	131514	0	195662009	4112343		0
44016	2619	40481087	1972-12-10	1972-12-10 00:00:00	1972-12-31	1972-12-31 00:00:00	32020		\N	173142	0	444814009	40481087		0
33673	1998	40481087	1989-10-26	1989-10-26 00:00:00	1989-11-16	1989-11-16 00:00:00	32020		\N	133016	0	444814009	40481087		0
33800	2006	321042	2014-01-17	2014-01-17 00:00:00	\N	\N	32020		\N	133607	0	410429000	321042		0
44524	2649	81151	1986-08-03	1986-08-03 00:00:00	1986-08-31	1986-08-31 00:00:00	32020		\N	175268	0	44465007	81151		0
34194	2030	40481087	1970-06-16	1970-06-16 00:00:00	1970-06-23	1970-06-23 00:00:00	32020		\N	135143	0	444814009	40481087		0
34359	2037	372328	1960-05-15	1960-05-15 00:00:00	1960-07-22	1960-07-22 00:00:00	32020		\N	135639	0	65363002	372328		0
45033	2680	40481087	2012-11-20	2012-11-20 00:00:00	2012-12-11	2012-12-11 00:00:00	32020		\N	177531	0	444814009	40481087		0
34610	2054	4048171	1974-06-30	1974-06-30 00:00:00	1990-06-28	1990-06-28 00:00:00	32020		\N	136584	0	232353008	4048171		0
45385	2699	40481087	1993-04-24	1993-04-24 00:00:00	1993-05-15	1993-05-15 00:00:00	32020		\N	178754	0	444814009	40481087		0
45506	2705	81151	2012-03-27	2012-03-27 00:00:00	2012-04-24	2012-04-24 00:00:00	32020		\N	179245	0	44465007	81151		0
35129	2084	260139	1977-04-25	1977-04-25 00:00:00	1977-05-09	1977-05-09 00:00:00	32020		\N	138877	0	10509002	260139		0
35293	2090	40481087	2012-08-29	2012-08-29 00:00:00	2012-09-12	2012-09-12 00:00:00	32020		\N	139378	0	444814009	40481087		0
46041	2743	4027663	1985-03-31	1985-03-31 00:00:00	\N	\N	32020		\N	181456	0	13200003	4027663		0
46155	2749	40481087	2005-05-07	2005-05-07 00:00:00	2005-05-14	2005-05-14 00:00:00	32020		\N	181833	0	444814009	40481087		0
35830	2123	40481087	1987-07-23	1987-07-23 00:00:00	1987-07-30	1987-07-30 00:00:00	32020		\N	141253	0	444814009	40481087		0
35954	2131	81151	1956-06-29	1956-06-29 00:00:00	1956-07-20	1956-07-20 00:00:00	32020		\N	141823	0	44465007	81151		0
46663	2777	40481087	2014-12-10	2014-12-10 00:00:00	2014-12-31	2014-12-31 00:00:00	32020		\N	183953	0	444814009	40481087		0
36335	2151	81151	1926-05-31	1926-05-31 00:00:00	1926-06-28	1926-06-28 00:00:00	32020		\N	143280	0	44465007	81151		0
47027	2798	40481087	1973-02-21	1973-02-21 00:00:00	1973-02-28	1973-02-28 00:00:00	32020		\N	185403	0	444814009	40481087		0
36662	2168	4285898	1989-06-27	1989-06-27 00:00:00	\N	\N	32020		\N	144584	0	68496003	4285898		0
36817	2177	260139	1971-04-16	1971-04-16 00:00:00	1971-04-23	1971-04-23 00:00:00	32020		\N	145187	0	10509002	260139		0
37006	2190	28060	1953-10-23	1953-10-23 00:00:00	1953-11-01	1953-11-01 00:00:00	32020		\N	146026	0	43878008	28060		0
37126	2199	372328	1980-05-17	1980-05-17 00:00:00	1980-06-29	1980-06-29 00:00:00	32020		\N	146562	0	65363002	372328		0
37327	2210	80180	1974-05-04	1974-05-04 00:00:00	\N	\N	32020		\N	147238	0	396275006	80180		0
47993	2847	260139	1989-12-20	1989-12-20 00:00:00	1990-01-03	1990-01-03 00:00:00	32020		\N	189105	0	10509002	260139		0
37627	2231	40481087	2016-12-12	2016-12-12 00:00:00	2016-12-26	2016-12-26 00:00:00	32020		\N	148463	0	444814009	40481087		0
37760	2237	40481087	2012-04-23	2012-04-23 00:00:00	2012-05-14	2012-05-14 00:00:00	32020		\N	148766	0	444814009	40481087		0
48509	2871	4237458	2017-03-15	2017-03-15 00:00:00	2017-04-14	2017-04-14 00:00:00	32020		\N	191095	0	58150001	4237458		0
48707	2886	4296205	2001-11-27	2001-11-27 00:00:00	2002-01-01	2002-01-01 00:00:00	32020		\N	192029	0	403191005	4296205		0
38344	2277	4278672	1977-04-05	1977-04-05 00:00:00	1977-05-05	1977-05-05 00:00:00	32020		\N	151384	0	65966004	4278672		0
49045	2903	80180	2000-05-23	2000-05-23 00:00:00	\N	\N	32020		\N	193467	0	396275006	80180		0
49187	2909	4112343	2004-06-09	2004-06-09 00:00:00	2004-06-22	2004-06-22 00:00:00	32020		\N	193860	0	195662009	4112343		0
49335	2917	40481087	1987-08-29	1987-08-29 00:00:00	1987-09-19	1987-09-19 00:00:00	32020		\N	194436	0	444814009	40481087		0
49474	2926	260139	1984-09-04	1984-09-04 00:00:00	1984-09-11	1984-09-11 00:00:00	32020		\N	195195	0	10509002	260139		0
49684	2939	28060	1954-03-03	1954-03-03 00:00:00	1954-03-16	1954-03-16 00:00:00	32020		\N	195948	0	43878008	28060		0
39253	2329	40481087	1981-10-04	1981-10-04 00:00:00	1981-10-18	1981-10-18 00:00:00	32020		\N	154930	0	444814009	40481087		0
49973	2953	4266809	2019-01-17	2019-01-17 00:00:00	\N	\N	32020		\N	197136	0	397881000	4266809		0
39586	2344	4116491	2008-03-03	2008-03-03 00:00:00	2008-04-07	2008-04-07 00:00:00	32020		\N	156076	0	301011002	4116491		0
39828	2358	4112343	1973-12-25	1973-12-25 00:00:00	1974-01-07	1974-01-07 00:00:00	32020		\N	157163	0	195662009	4112343		0
50470	2986	40481087	1967-02-20	1967-02-20 00:00:00	1967-02-27	1967-02-27 00:00:00	32020		\N	199347	0	444814009	40481087		0
40133	2381	80180	1973-04-28	1973-04-28 00:00:00	\N	\N	32020		\N	158317	0	396275006	80180		0
40310	2392	40481087	2010-08-01	2010-08-01 00:00:00	2010-08-22	2010-08-22 00:00:00	32020		\N	159103	0	444814009	40481087		0
40407	2396	260139	1967-09-19	1967-09-19 00:00:00	1967-10-03	1967-10-03 00:00:00	32020		\N	159398	0	10509002	260139		0
51154	3028	4266809	2000-07-01	2000-07-01 00:00:00	\N	\N	32020		\N	201864	0	397881000	4266809		0
40827	2427	260139	1959-10-01	1959-10-01 00:00:00	1959-10-15	1959-10-15 00:00:00	32020		\N	160980	0	10509002	260139		0
40987	2437	4278672	1963-08-11	1963-08-11 00:00:00	1963-09-10	1963-09-10 00:00:00	32020		\N	161667	0	65966004	4278672		0
51701	3065	40481087	1990-04-09	1990-04-09 00:00:00	1990-04-30	1990-04-30 00:00:00	32020		\N	204022	0	444814009	40481087		0
51820	3072	4059173	1995-11-27	1995-11-27 00:00:00	1995-12-27	1995-12-27 00:00:00	32020		\N	204461	0	16114001	4059173		0
51966	3080	4283893	1988-11-02	1988-11-02 00:00:00	1988-12-28	1988-12-28 00:00:00	32020		\N	204989	0	36971009	4283893		0
52125	3086	4155034	1982-11-11	1982-11-11 00:00:00	1982-11-25	1982-11-25 00:00:00	32020		\N	205441	0	283371005	4155034		0
41782	2485	4112343	1999-09-29	1999-09-29 00:00:00	1999-10-11	1999-10-11 00:00:00	32020		\N	164675	0	195662009	4112343		0
52566	3114	4134304	2016-04-04	2016-04-04 00:00:00	2016-05-04	2016-05-04 00:00:00	32020		\N	207118	0	263102004	4134304		0
52674	3119	260139	2008-06-27	2008-06-27 00:00:00	2008-07-04	2008-07-04 00:00:00	32020		\N	207577	0	10509002	260139		0
52880	3132	440448	1976-07-05	1976-07-05 00:00:00	\N	\N	32020		\N	208403	0	74400008	440448		0
53034	3141	260139	1979-08-25	1979-08-25 00:00:00	1979-09-08	1979-09-08 00:00:00	32020		\N	208965	0	10509002	260139		0
42514	2535	260139	1979-02-28	1979-02-28 00:00:00	1979-03-14	1979-03-14 00:00:00	32020		\N	167552	0	10509002	260139		0
42735	2546	80180	2011-09-10	2011-09-10 00:00:00	\N	\N	32020		\N	168527	0	396275006	80180		0
42877	2554	260139	1973-12-29	1973-12-29 00:00:00	1974-01-05	1974-01-05 00:00:00	32020		\N	169266	0	10509002	260139		0
43013	2561	40481087	1988-02-17	1988-02-17 00:00:00	1988-02-24	1988-02-24 00:00:00	32020		\N	169703	0	444814009	40481087		0
32601	1936	80180	1984-11-03	1984-11-03 00:00:00	\N	\N	32020		\N	128752	0	396275006	80180		0
43381	2583	4134304	1986-08-20	1986-08-20 00:00:00	1986-10-19	1986-10-19 00:00:00	32020		\N	171043	0	263102004	4134304		0
32966	1954	28060	1997-11-05	1997-11-05 00:00:00	1997-11-13	1997-11-13 00:00:00	32020		\N	130052	0	43878008	28060		0
33168	1967	4112343	2019-04-26	2019-04-26 00:00:00	2019-05-03	2019-05-03 00:00:00	32020		\N	130878	0	195662009	4112343		0
33321	1977	81151	2000-05-05	2000-05-05 00:00:00	2000-05-19	2000-05-19 00:00:00	32020		\N	131626	0	44465007	81151		0
44017	2619	4059173	1948-06-21	1948-06-21 00:00:00	1948-07-21	1948-07-21 00:00:00	32020		\N	173199	0	16114001	4059173		0
33674	1998	40481087	2016-07-10	2016-07-10 00:00:00	2016-07-17	2016-07-17 00:00:00	32020		\N	132992	0	444814009	40481087		0
33802	2006	4112343	2010-01-19	2010-01-19 00:00:00	2010-01-27	2010-01-27 00:00:00	32020		\N	133570	0	195662009	4112343		0
44525	2649	192671	1993-02-14	1993-02-14 00:00:00	\N	\N	32020		\N	175271	0	K92.2	35208414		0
34195	2030	80180	1997-11-04	1997-11-04 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
34360	2037	40481087	1962-02-11	1962-02-11 00:00:00	1962-02-25	1962-02-25 00:00:00	32020		\N	135625	0	444814009	40481087		0
45034	2680	257012	1985-09-17	1985-09-17 00:00:00	\N	\N	32020		\N	177561	0	40055000	257012		0
34611	2054	192671	2010-10-05	2010-10-05 00:00:00	\N	\N	32020		\N	136612	0	K92.2	35208414		0
45386	2699	40481087	1977-07-20	1977-07-20 00:00:00	1977-07-27	1977-07-27 00:00:00	32020		\N	178753	0	444814009	40481087		0
45507	2705	81151	1966-09-20	1966-09-20 00:00:00	1966-10-25	1966-10-25 00:00:00	32020		\N	179243	0	44465007	81151		0
35130	2084	195588	2002-01-13	2002-01-13 00:00:00	2002-02-24	2002-02-24 00:00:00	32020		\N	138879	0	38822007	195588		0
35294	2090	40481087	1980-12-06	1980-12-06 00:00:00	1980-12-20	1980-12-20 00:00:00	32020		\N	139387	0	444814009	40481087		0
46042	2743	40481087	1995-11-01	1995-11-01 00:00:00	1995-11-15	1995-11-15 00:00:00	32020		\N	181461	0	444814009	40481087		0
46156	2749	4112343	1972-08-14	1972-08-14 00:00:00	1972-08-23	1972-08-23 00:00:00	32020		\N	181791	0	195662009	4112343		0
35831	2123	260139	1974-03-12	1974-03-12 00:00:00	1974-03-19	1974-03-19 00:00:00	32020		\N	141252	0	10509002	260139		0
35955	2131	4152936	1988-06-07	1988-06-07 00:00:00	1988-06-28	1988-06-28 00:00:00	32020		\N	141827	0	283385000	4152936		0
46664	2777	40481087	1975-04-27	1975-04-27 00:00:00	1975-05-11	1975-05-11 00:00:00	32020		\N	183966	0	444814009	40481087		0
36336	2151	260139	1958-02-09	1958-02-09 00:00:00	1958-02-16	1958-02-16 00:00:00	32020		\N	143285	0	10509002	260139		0
47028	2798	40481087	2010-03-14	2010-03-14 00:00:00	2010-03-28	2010-03-28 00:00:00	32020		\N	185447	0	444814009	40481087		0
36663	2168	4218389	1988-10-10	1988-10-10 00:00:00	1988-10-31	1988-10-31 00:00:00	32020		\N	144584	0	39848009	4218389		0
36818	2177	40481087	1993-02-04	1993-02-04 00:00:00	1993-02-11	1993-02-11 00:00:00	32020		\N	145192	0	444814009	40481087		0
37007	2190	260139	1952-06-28	1952-06-28 00:00:00	1952-07-05	1952-07-05 00:00:00	32020		\N	146025	0	10509002	260139		0
37127	2199	372328	1985-06-03	1985-06-03 00:00:00	1985-07-07	1985-07-07 00:00:00	32020		\N	146550	0	65363002	372328		0
37328	2210	40481087	1973-05-07	1973-05-07 00:00:00	1973-05-14	1973-05-14 00:00:00	32020		\N	147238	0	444814009	40481087		0
47994	2847	40481087	1962-10-17	1962-10-17 00:00:00	1962-10-24	1962-10-24 00:00:00	32020		\N	189099	0	444814009	40481087		0
37628	2231	4156265	2006-12-26	2006-12-26 00:00:00	2007-01-09	2007-01-09 00:00:00	32020		\N	148429	0	370247008	4156265		0
37761	2238	4112343	1997-02-16	1997-02-16 00:00:00	1997-02-27	1997-02-27 00:00:00	32020		\N	149016	0	195662009	4112343		0
48510	2871	40481087	1956-02-07	1956-02-07 00:00:00	1956-02-14	1956-02-14 00:00:00	32020		\N	191120	0	444814009	40481087		0
48708	2886	260139	1963-10-03	1963-10-03 00:00:00	1963-10-10	1963-10-10 00:00:00	32020		\N	191944	0	10509002	260139		0
38345	2277	4278672	1971-04-07	1971-04-07 00:00:00	1971-07-06	1971-07-06 00:00:00	32020		\N	151383	0	65966004	4278672		0
49046	2903	440448	1975-09-13	1975-09-13 00:00:00	\N	\N	32020		\N	193431	0	74400008	440448		0
49188	2909	4112343	1999-01-25	1999-01-25 00:00:00	1999-02-04	1999-02-04 00:00:00	32020		\N	193895	0	195662009	4112343		0
49336	2917	40481087	1976-03-10	1976-03-10 00:00:00	1976-03-31	1976-03-31 00:00:00	32020		\N	194495	0	444814009	40481087		0
49475	2926	40481087	1991-09-28	1991-09-28 00:00:00	1991-10-12	1991-10-12 00:00:00	32020		\N	195139	0	444814009	40481087		0
49685	2939	40481087	1987-01-24	1987-01-24 00:00:00	1987-02-14	1987-02-14 00:00:00	32020		\N	195987	0	444814009	40481087		0
39254	2329	260139	2008-07-27	2008-07-27 00:00:00	2008-08-10	2008-08-10 00:00:00	32020		\N	154926	0	10509002	260139		0
49974	2953	80180	2019-01-17	2019-01-17 00:00:00	\N	\N	32020		\N	197136	0	396275006	80180		0
39601	2346	40481087	1982-08-23	1982-08-23 00:00:00	1982-08-30	1982-08-30 00:00:00	32020		\N	156128	0	444814009	40481087		0
39829	2358	372328	1977-10-04	1977-10-04 00:00:00	1978-05-30	1978-05-30 00:00:00	32020		\N	157110	0	65363002	372328		0
50471	2986	4156265	1974-12-02	1974-12-02 00:00:00	1974-12-23	1974-12-23 00:00:00	32020		\N	199354	0	370247008	4156265		0
40134	2381	4112343	1973-03-17	1973-03-17 00:00:00	1973-03-25	1973-03-25 00:00:00	32020		\N	158317	0	195662009	4112343		0
40311	2392	4112343	1967-01-27	1967-01-27 00:00:00	1967-02-06	1967-02-06 00:00:00	32020		\N	159044	0	195662009	4112343		0
40408	2396	4112343	1985-07-04	1985-07-04 00:00:00	1985-07-13	1985-07-13 00:00:00	32020		\N	159374	0	195662009	4112343		0
51155	3028	4112343	2018-07-03	2018-07-03 00:00:00	2018-07-12	2018-07-12 00:00:00	32020		\N	201906	0	195662009	4112343		0
40828	2427	80180	1984-12-23	1984-12-23 00:00:00	\N	\N	32020		\N	161049	0	396275006	80180		0
40988	2437	4112343	1991-04-07	1991-04-07 00:00:00	1991-04-17	1991-04-17 00:00:00	32020		\N	161694	0	195662009	4112343		0
51702	3065	80180	2014-05-26	2014-05-26 00:00:00	\N	\N	32020		\N	204055	0	396275006	80180		0
51821	3072	40481087	2013-08-22	2013-08-22 00:00:00	2013-09-05	2013-09-05 00:00:00	32020		\N	204481	0	444814009	40481087		0
51967	3080	4112343	1997-05-22	1997-05-22 00:00:00	1997-05-29	1997-05-29 00:00:00	32020		\N	205019	0	195662009	4112343		0
52126	3086	4112343	2009-12-04	2009-12-04 00:00:00	2009-12-13	2009-12-13 00:00:00	32020		\N	205469	0	195662009	4112343		0
41783	2485	192671	1953-04-30	1953-04-30 00:00:00	\N	\N	32020		\N	164626	0	K92.2	35208414		0
52567	3114	4027663	1972-09-11	1972-09-11 00:00:00	\N	\N	32020		\N	207195	0	13200003	4027663		0
52675	3119	80180	2015-06-27	2015-06-27 00:00:00	\N	\N	32020		\N	207559	0	396275006	80180		0
52881	3132	260139	1967-07-18	1967-07-18 00:00:00	1967-08-01	1967-08-01 00:00:00	32020		\N	208404	0	10509002	260139		0
53035	3141	192671	2010-11-18	2010-11-18 00:00:00	\N	\N	32020		\N	209008	0	K92.2	35208414		0
42515	2535	372328	1961-11-05	1961-11-05 00:00:00	1961-12-10	1961-12-10 00:00:00	32020		\N	167557	0	65363002	372328		0
42736	2546	4230399	1985-05-25	1985-05-25 00:00:00	1985-06-24	1985-06-24 00:00:00	32020		\N	168459	0	359817006	4230399		0
42878	2554	260139	1979-08-09	1979-08-09 00:00:00	1979-08-23	1979-08-23 00:00:00	32020		\N	169218	0	10509002	260139		0
43014	2561	40481087	1997-10-17	1997-10-17 00:00:00	1997-10-31	1997-10-31 00:00:00	32020		\N	169672	0	444814009	40481087		0
32602	1936	4230399	2009-07-31	2009-07-31 00:00:00	2009-08-30	2009-08-30 00:00:00	32020		\N	128759	0	359817006	4230399		0
43382	2583	80180	2006-11-23	2006-11-23 00:00:00	\N	\N	32020		\N	171054	0	396275006	80180		0
32967	1954	40481087	1984-02-25	1984-02-25 00:00:00	1984-03-10	1984-03-10 00:00:00	32020		\N	129957	0	444814009	40481087		0
33169	1967	4112343	2014-05-10	2014-05-10 00:00:00	2014-05-18	2014-05-18 00:00:00	32020		\N	130803	0	195662009	4112343		0
33322	1977	4112343	1972-05-28	1972-05-28 00:00:00	1972-06-10	1972-06-10 00:00:00	32020		\N	131588	0	195662009	4112343		0
44018	2619	260139	2010-05-30	2010-05-30 00:00:00	2010-06-13	2010-06-13 00:00:00	32020		\N	173210	0	10509002	260139		0
33675	1998	40481087	2011-08-25	2011-08-25 00:00:00	2011-09-15	2011-09-15 00:00:00	32020		\N	133029	0	444814009	40481087		0
33803	2006	28060	1948-02-08	1948-02-08 00:00:00	1948-02-19	1948-02-19 00:00:00	32020		\N	133591	0	43878008	28060		0
44526	2649	260139	2002-11-15	2002-11-15 00:00:00	2002-11-29	2002-11-29 00:00:00	32020		\N	175258	0	10509002	260139		0
34196	2030	4112343	1975-08-01	1975-08-01 00:00:00	1975-08-09	1975-08-09 00:00:00	32020		\N	135139	0	195662009	4112343		0
34361	2037	260139	1970-07-23	1970-07-23 00:00:00	1970-08-06	1970-08-06 00:00:00	32020		\N	135679	0	10509002	260139		0
45035	2680	4294548	1985-09-03	1985-09-03 00:00:00	1985-11-26	1985-11-26 00:00:00	32020		\N	177523	0	75498004	4294548		0
34612	2054	4278672	2014-07-22	2014-07-22 00:00:00	2014-10-20	2014-10-20 00:00:00	32020		\N	136590	0	65966004	4278672		0
45387	2699	260139	1980-05-13	1980-05-13 00:00:00	1980-05-20	1980-05-20 00:00:00	32020		\N	178716	0	10509002	260139		0
45508	2705	260139	1969-07-09	1969-07-09 00:00:00	1969-07-16	1969-07-16 00:00:00	32020		\N	179221	0	10509002	260139		0
35131	2084	4056621	2002-01-13	2002-01-13 00:00:00	\N	\N	32020		\N	138879	0	197927001	4056621		0
35295	2090	80180	2002-06-12	2002-06-12 00:00:00	\N	\N	32020		\N	139370	0	396275006	80180		0
46043	2743	4294548	1979-12-14	1979-12-14 00:00:00	1980-02-29	1980-02-29 00:00:00	32020		\N	181474	0	75498004	4294548		0
46157	2749	81151	1974-04-08	1974-04-08 00:00:00	1974-04-29	1974-04-29 00:00:00	32020		\N	181846	0	44465007	81151		0
35832	2123	372328	1958-01-11	1958-01-11 00:00:00	1958-04-25	1958-04-25 00:00:00	32020		\N	141231	0	65363002	372328		0
35956	2131	260139	1955-12-03	1955-12-03 00:00:00	1955-12-10	1955-12-10 00:00:00	32020		\N	141762	0	10509002	260139		0
46665	2777	40481087	2012-10-13	2012-10-13 00:00:00	2012-10-20	2012-10-20 00:00:00	32020		\N	183926	0	444814009	40481087		0
36337	2151	80180	1958-07-22	1958-07-22 00:00:00	\N	\N	32020		\N	143285	0	396275006	80180		0
47029	2798	260139	1977-12-27	1977-12-27 00:00:00	1978-01-03	1978-01-03 00:00:00	32020		\N	185452	0	10509002	260139		0
36664	2168	4156265	1963-12-02	1963-12-02 00:00:00	1963-12-16	1963-12-16 00:00:00	32020		\N	144577	0	370247008	4156265		0
36819	2177	192671	2005-07-04	2005-07-04 00:00:00	\N	\N	32020		\N	145186	0	K92.2	35208414		0
37008	2190	4156265	1988-01-08	1988-01-08 00:00:00	1988-01-22	1988-01-22 00:00:00	32020		\N	146081	0	370247008	4156265		0
37128	2199	28060	1996-01-02	1996-01-02 00:00:00	1996-01-10	1996-01-10 00:00:00	32020		\N	146588	0	43878008	28060		0
37329	2210	4059173	1985-11-24	1985-11-24 00:00:00	1986-01-23	1986-01-23 00:00:00	32020		\N	147200	0	16114001	4059173		0
47995	2847	80180	2001-11-18	2001-11-18 00:00:00	\N	\N	32020		\N	189055	0	396275006	80180		0
37629	2231	4112343	1986-08-26	1986-08-26 00:00:00	1986-09-07	1986-09-07 00:00:00	32020		\N	148435	0	195662009	4112343		0
37762	2238	40481087	1989-12-31	1989-12-31 00:00:00	1990-01-21	1990-01-21 00:00:00	32020		\N	148980	0	444814009	40481087		0
48511	2872	317576	1968-08-06	1968-08-06 00:00:00	\N	\N	32020		\N	191199	0	53741008	317576		0
48709	2886	40481087	2011-07-26	2011-07-26 00:00:00	2011-08-09	2011-08-09 00:00:00	32020		\N	191974	0	444814009	40481087		0
38346	2277	372328	1970-10-15	1970-10-15 00:00:00	1971-08-22	1971-08-22 00:00:00	32020		\N	151355	0	65363002	372328		0
49047	2903	40481087	1989-04-13	1989-04-13 00:00:00	1989-04-20	1989-04-20 00:00:00	32020		\N	193440	0	444814009	40481087		0
49189	2909	4112343	1998-08-17	1998-08-17 00:00:00	1998-08-26	1998-08-26 00:00:00	32020		\N	193859	0	195662009	4112343		0
49337	2917	372328	1939-01-20	1939-01-20 00:00:00	1939-02-03	1939-02-03 00:00:00	32020		\N	194530	0	65363002	372328		0
49476	2926	4112343	1992-12-06	1992-12-06 00:00:00	1992-12-16	1992-12-16 00:00:00	32020		\N	195191	0	195662009	4112343		0
49686	2939	195588	1994-01-10	1994-01-10 00:00:00	1994-03-02	1994-03-02 00:00:00	32020		\N	195976	0	38822007	195588		0
39255	2329	40481087	1991-08-05	1991-08-05 00:00:00	1991-08-12	1991-08-12 00:00:00	32020		\N	154913	0	444814009	40481087		0
49975	2953	4112343	2006-04-19	2006-04-19 00:00:00	2006-04-29	2006-04-29 00:00:00	32020		\N	197126	0	195662009	4112343		0
39602	2346	260139	1953-09-26	1953-09-26 00:00:00	1953-10-10	1953-10-10 00:00:00	32020		\N	156149	0	10509002	260139		0
39830	2358	192671	2007-10-15	2007-10-15 00:00:00	\N	\N	32020		\N	157132	0	K92.2	35208414		0
50472	2986	40481087	1995-12-21	1995-12-21 00:00:00	1996-01-11	1996-01-11 00:00:00	32020		\N	199349	0	444814009	40481087		0
40135	2381	4112343	1992-05-01	1992-05-01 00:00:00	1992-05-11	1992-05-11 00:00:00	32020		\N	158350	0	195662009	4112343		0
40312	2392	78272	1940-07-02	1940-07-02 00:00:00	1940-07-23	1940-07-23 00:00:00	32020		\N	159010	0	70704007	78272		0
40409	2396	372328	1923-06-20	1923-06-20 00:00:00	1923-10-24	1923-10-24 00:00:00	32020		\N	159386	0	65363002	372328		0
51156	3028	40481087	1974-12-07	1974-12-07 00:00:00	1974-12-28	1974-12-28 00:00:00	32020		\N	201863	0	444814009	40481087		0
40829	2427	260139	1972-05-11	1972-05-11 00:00:00	1972-05-18	1972-05-18 00:00:00	32020		\N	161035	0	10509002	260139		0
40989	2437	260139	1995-05-13	1995-05-13 00:00:00	1995-05-20	1995-05-20 00:00:00	32020		\N	161695	0	10509002	260139		0
51703	3065	260139	1987-10-01	1987-10-01 00:00:00	1987-10-08	1987-10-08 00:00:00	32020		\N	204021	0	10509002	260139		0
51822	3072	4112343	1998-08-14	1998-08-14 00:00:00	1998-08-26	1998-08-26 00:00:00	32020		\N	204447	0	195662009	4112343		0
51968	3080	40481087	2019-03-24	2019-03-24 00:00:00	2019-04-14	2019-04-14 00:00:00	32020		\N	205061	0	444814009	40481087		0
52127	3087	260139	1954-07-07	1954-07-07 00:00:00	1954-07-14	1954-07-14 00:00:00	32020		\N	205525	0	10509002	260139		0
41784	2485	40481087	1979-06-04	1979-06-04 00:00:00	1979-06-11	1979-06-11 00:00:00	32020		\N	164574	0	444814009	40481087		0
52568	3114	40481087	1960-06-17	1960-06-17 00:00:00	1960-06-24	1960-06-24 00:00:00	32020		\N	207111	0	444814009	40481087		0
52676	3119	40481087	2001-10-25	2001-10-25 00:00:00	2001-10-31	2001-10-31 00:00:00	32020		\N	207589	0	444814009	40481087		0
52882	3132	78272	1968-12-07	1968-12-07 00:00:00	1968-12-21	1968-12-21 00:00:00	32020		\N	208402	0	70704007	78272		0
53037	3141	260139	1984-08-02	1984-08-02 00:00:00	1984-08-09	1984-08-09 00:00:00	32020		\N	209001	0	10509002	260139		0
42516	2535	40481087	2005-02-24	2005-02-24 00:00:00	2005-03-17	2005-03-17 00:00:00	32020		\N	167497	0	444814009	40481087		0
42737	2546	372328	1976-12-31	1976-12-31 00:00:00	1977-03-04	1977-03-04 00:00:00	32020		\N	168522	0	65363002	372328		0
42879	2554	40481087	1966-11-30	1966-11-30 00:00:00	1966-12-14	1966-12-14 00:00:00	32020		\N	169262	0	444814009	40481087		0
43015	2561	40481087	2005-02-26	2005-02-26 00:00:00	2005-03-19	2005-03-19 00:00:00	32020		\N	169723	0	444814009	40481087		0
32603	1936	78272	1980-06-19	1980-06-19 00:00:00	1980-07-03	1980-07-03 00:00:00	32020		\N	128758	0	70704007	78272		0
43384	2583	28060	1973-02-01	1973-02-01 00:00:00	1973-02-09	1973-02-09 00:00:00	32020		\N	171048	0	43878008	28060		0
32968	1954	40481087	2003-10-27	2003-10-27 00:00:00	2003-11-03	2003-11-03 00:00:00	32020		\N	130015	0	444814009	40481087		0
33170	1967	4084167	1960-07-18	1960-07-18 00:00:00	1960-07-18	1960-07-18 00:00:00	32020		\N	130888	0	241929008	4084167		0
33323	1977	40481087	1950-09-21	1950-09-21 00:00:00	1950-10-05	1950-10-05 00:00:00	32020		\N	131574	0	444814009	40481087		0
44019	2619	4112343	1979-12-15	1979-12-15 00:00:00	1979-12-27	1979-12-27 00:00:00	32020		\N	173144	0	195662009	4112343		0
33676	1998	40481087	2002-09-12	2002-09-12 00:00:00	2002-10-03	2002-10-03 00:00:00	32020		\N	133017	0	444814009	40481087		0
33804	2006	4116491	1993-01-06	1993-01-06 00:00:00	1993-02-19	1993-02-19 00:00:00	32020		\N	133642	0	301011002	4116491		0
44527	2649	40481087	2009-04-01	2009-04-01 00:00:00	2009-04-08	2009-04-08 00:00:00	32020		\N	175272	0	444814009	40481087		0
44661	2657	4283893	2013-06-05	2013-06-05 00:00:00	2013-07-03	2013-07-03 00:00:00	32020		\N	175977	0	36971009	4283893		0
34362	2037	4059173	1974-01-30	1974-01-30 00:00:00	1974-04-30	1974-04-30 00:00:00	32020		\N	135659	0	16114001	4059173		0
45036	2680	40481087	2001-07-21	2001-07-21 00:00:00	2001-07-28	2001-07-28 00:00:00	32020		\N	177520	0	444814009	40481087		0
34613	2054	372328	1974-01-09	1974-01-09 00:00:00	1974-04-25	1974-04-25 00:00:00	32020		\N	136628	0	65363002	372328		0
45388	2699	260139	2013-09-05	2013-09-05 00:00:00	2013-09-19	2013-09-19 00:00:00	32020		\N	178755	0	10509002	260139		0
45509	2705	260139	2017-08-19	2017-08-19 00:00:00	2017-08-26	2017-08-26 00:00:00	32020		\N	179225	0	10509002	260139		0
35132	2084	260139	2003-10-19	2003-10-19 00:00:00	2003-10-26	2003-10-26 00:00:00	32020		\N	138863	0	10509002	260139		0
35296	2091	4152936	1988-06-25	1988-06-25 00:00:00	1988-07-16	1988-07-16 00:00:00	32020		\N	139481	0	283385000	4152936		0
46044	2743	192671	1992-04-27	1992-04-27 00:00:00	\N	\N	32020		\N	181453	0	K92.2	35208414		0
46158	2749	28060	1974-03-17	1974-03-17 00:00:00	1974-03-25	1974-03-25 00:00:00	32020		\N	181788	0	43878008	28060		0
35833	2123	4116491	2007-04-22	2007-04-22 00:00:00	2007-05-27	2007-05-27 00:00:00	32020		\N	141313	0	301011002	4116491		0
35957	2131	4112343	1993-11-28	1993-11-28 00:00:00	1993-12-08	1993-12-08 00:00:00	32020		\N	141766	0	195662009	4112343		0
46666	2777	40481087	1960-07-05	1960-07-05 00:00:00	1960-07-12	1960-07-12 00:00:00	32020		\N	183947	0	444814009	40481087		0
36338	2151	40481087	1930-01-01	1930-01-01 00:00:00	1930-01-08	1930-01-08 00:00:00	32020		\N	143269	0	444814009	40481087		0
47030	2798	4283893	1960-08-31	1960-08-31 00:00:00	1960-12-28	1960-12-28 00:00:00	32020		\N	185456	0	36971009	4283893		0
36665	2168	40481087	1987-08-20	1987-08-20 00:00:00	1987-08-27	1987-08-27 00:00:00	32020		\N	144463	0	444814009	40481087		0
36820	2177	260139	1990-09-12	1990-09-12 00:00:00	1990-09-19	1990-09-19 00:00:00	32020		\N	145189	0	10509002	260139		0
37009	2191	40481087	1972-09-13	1972-09-13 00:00:00	1972-10-04	1972-10-04 00:00:00	32020		\N	146094	0	444814009	40481087		0
37129	2199	260139	1981-05-13	1981-05-13 00:00:00	1981-05-27	1981-05-27 00:00:00	32020		\N	146544	0	10509002	260139		0
37330	2210	4166224	1969-10-19	1969-10-19 00:00:00	\N	\N	32020		\N	147198	0	47693006	4166224		0
47996	2847	40481087	2000-12-02	2000-12-02 00:00:00	2000-12-09	2000-12-09 00:00:00	32020		\N	189055	0	444814009	40481087		0
37630	2231	4218389	2010-09-20	2010-09-20 00:00:00	2010-10-11	2010-10-11 00:00:00	32020		\N	148430	0	39848009	4218389		0
37763	2238	40481087	1979-06-15	1979-06-15 00:00:00	1979-06-22	1979-06-22 00:00:00	32020		\N	148902	0	444814009	40481087		0
48512	2872	4112343	1960-01-12	1960-01-12 00:00:00	1960-01-25	1960-01-25 00:00:00	32020		\N	191218	0	195662009	4112343		0
48710	2886	260139	1956-12-10	1956-12-10 00:00:00	1956-12-24	1956-12-24 00:00:00	32020		\N	191958	0	10509002	260139		0
48805	2892	28060	1979-05-12	1979-05-12 00:00:00	1979-05-24	1979-05-24 00:00:00	32020		\N	192411	0	43878008	28060		0
49048	2903	40481087	2001-07-21	2001-07-21 00:00:00	2001-08-11	2001-08-11 00:00:00	32020		\N	193412	0	444814009	40481087		0
49190	2909	140673	1999-02-12	1999-02-12 00:00:00	\N	\N	32020		\N	193875	0	40930008	140673		0
49338	2917	378419	2017-02-15	2017-02-15 00:00:00	\N	\N	32020		\N	194482	0	26929004	378419		0
49477	2926	192671	2017-11-28	2017-11-28 00:00:00	\N	\N	32020		\N	195189	0	K92.2	35208414		0
49687	2939	4146173	1987-02-19	1987-02-19 00:00:00	1987-04-20	1987-04-20 00:00:00	32020		\N	195998	0	307731004	4146173		0
39256	2329	4112343	1996-04-01	1996-04-01 00:00:00	1996-04-08	1996-04-08 00:00:00	32020		\N	154939	0	195662009	4112343		0
49976	2953	260139	2002-03-20	2002-03-20 00:00:00	2002-04-03	2002-04-03 00:00:00	32020		\N	197125	0	10509002	260139		0
39603	2346	4112343	1958-10-28	1958-10-28 00:00:00	1958-11-05	1958-11-05 00:00:00	32020		\N	156126	0	195662009	4112343		0
39831	2358	4112343	1982-03-30	1982-03-30 00:00:00	1982-04-07	1982-04-07 00:00:00	32020		\N	157141	0	195662009	4112343		0
50473	2986	260139	1978-12-06	1978-12-06 00:00:00	1978-12-13	1978-12-13 00:00:00	32020		\N	199330	0	10509002	260139		0
40136	2381	40481087	1974-08-01	1974-08-01 00:00:00	1974-08-15	1974-08-15 00:00:00	32020		\N	158296	0	444814009	40481087		0
40313	2392	80502	1986-03-14	1986-03-14 00:00:00	\N	\N	32020		\N	159058	0	64859006	80502		0
40410	2396	4112343	1959-06-11	1959-06-11 00:00:00	1959-06-23	1959-06-23 00:00:00	32020		\N	159305	0	195662009	4112343		0
51157	3028	260139	2010-05-27	2010-05-27 00:00:00	2010-06-03	2010-06-03 00:00:00	32020		\N	201897	0	10509002	260139		0
40830	2427	4278672	2008-12-20	2008-12-20 00:00:00	2009-01-19	2009-01-19 00:00:00	32020		\N	160964	0	65966004	4278672		0
40990	2437	28060	1971-06-06	1971-06-06 00:00:00	1971-06-17	1971-06-17 00:00:00	32020		\N	161693	0	43878008	28060		0
51704	3065	40481087	1985-04-12	1985-04-12 00:00:00	1985-04-26	1985-04-26 00:00:00	32020		\N	204072	0	444814009	40481087		0
51823	3072	40481087	1986-02-28	1986-02-28 00:00:00	1986-03-14	1986-03-14 00:00:00	32020		\N	204492	0	444814009	40481087		0
51969	3080	81151	2015-09-27	2015-09-27 00:00:00	2015-10-25	2015-10-25 00:00:00	32020		\N	205011	0	44465007	81151		0
52128	3087	40481087	2017-11-18	2017-11-18 00:00:00	2017-11-25	2017-11-25 00:00:00	32020		\N	205521	0	444814009	40481087		0
41785	2485	4112343	1972-04-02	1972-04-02 00:00:00	1972-04-13	1972-04-13 00:00:00	32020		\N	164573	0	195662009	4112343		0
52569	3114	4112343	1966-10-26	1966-10-26 00:00:00	1966-11-07	1966-11-07 00:00:00	32020		\N	207120	0	195662009	4112343		0
52677	3119	4152936	1996-11-01	1996-11-01 00:00:00	1996-11-15	1996-11-15 00:00:00	32020		\N	207537	0	283385000	4152936		0
52883	3132	4112343	1983-09-20	1983-09-20 00:00:00	1983-10-01	1983-10-01 00:00:00	32020		\N	208391	0	195662009	4112343		0
53038	3141	81151	1985-08-20	1985-08-20 00:00:00	1985-09-03	1985-09-03 00:00:00	32020		\N	208989	0	44465007	81151		0
42517	2535	260139	2003-11-24	2003-11-24 00:00:00	2003-12-01	2003-12-01 00:00:00	32020		\N	167555	0	10509002	260139		0
42738	2546	440086	1987-03-25	1987-03-25 00:00:00	1993-04-02	1993-04-02 00:00:00	32020		\N	168480	0	192127007	440086		0
42880	2554	134438	1964-07-26	1964-07-26 00:00:00	1965-06-26	1965-06-26 00:00:00	32020		\N	169214	0	40275004	134438		0
43016	2561	372328	1976-11-26	1976-11-26 00:00:00	1977-02-02	1977-02-02 00:00:00	32020		\N	169727	0	65363002	372328		0
32604	1936	260139	1962-12-31	1962-12-31 00:00:00	1963-01-07	1963-01-07 00:00:00	32020		\N	128827	0	10509002	260139		0
43385	2583	4296204	1989-07-05	1989-07-05 00:00:00	1989-07-19	1989-07-19 00:00:00	32020		\N	171044	0	403190006	4296204		0
32969	1954	4059173	1949-12-17	1949-12-17 00:00:00	1950-02-15	1950-02-15 00:00:00	32020		\N	130033	0	16114001	4059173		0
33171	1967	40481087	2001-03-06	2001-03-06 00:00:00	2001-03-13	2001-03-13 00:00:00	32020		\N	130769	0	444814009	40481087		0
33324	1977	40481087	2011-04-05	2011-04-05 00:00:00	2011-04-26	2011-04-26 00:00:00	32020		\N	131546	0	444814009	40481087		0
44020	2619	4027663	1966-11-04	1966-11-04 00:00:00	\N	\N	32020		\N	173200	0	13200003	4027663		0
33677	1998	4266809	2015-10-01	2015-10-01 00:00:00	\N	\N	32020		\N	133000	0	397881000	4266809		0
33805	2006	372328	1946-02-17	1946-02-17 00:00:00	1946-04-26	1946-04-26 00:00:00	32020		\N	133645	0	65363002	372328		0
44528	2649	4112343	1998-09-18	1998-09-18 00:00:00	1998-09-27	1998-09-27 00:00:00	32020		\N	175280	0	195662009	4112343		0
44662	2657	257012	2009-03-08	2009-03-08 00:00:00	\N	\N	32020		\N	175983	0	40055000	257012		0
44821	2666	372328	1954-10-27	1954-10-27 00:00:00	1954-11-21	1954-11-21 00:00:00	32020		\N	176607	0	65363002	372328		0
45037	2680	40479422	1986-02-08	1986-02-08 00:00:00	1986-04-16	1986-04-16 00:00:00	32020		\N	177555	0	444448004	40479422		0
34614	2054	30753	2009-02-04	2009-02-04 00:00:00	\N	\N	32020		\N	136621	0	16761005	30753		0
45389	2699	260139	1971-10-15	1971-10-15 00:00:00	1971-10-29	1971-10-29 00:00:00	32020		\N	178715	0	10509002	260139		0
45510	2705	40481087	2007-07-01	2007-07-01 00:00:00	2007-07-15	2007-07-15 00:00:00	32020		\N	179223	0	444814009	40481087		0
35133	2084	40481087	1979-07-06	1979-07-06 00:00:00	1979-07-27	1979-07-27 00:00:00	32020		\N	138874	0	444814009	40481087		0
35297	2091	40481087	1967-09-08	1967-09-08 00:00:00	1967-09-15	1967-09-15 00:00:00	32020		\N	139472	0	444814009	40481087		0
46045	2743	40481087	1965-02-16	1965-02-16 00:00:00	1965-02-23	1965-02-23 00:00:00	32020		\N	181472	0	444814009	40481087		0
46159	2750	4112343	2007-09-17	2007-09-17 00:00:00	2007-09-28	2007-09-28 00:00:00	32020		\N	181959	0	195662009	4112343		0
35834	2123	40481087	2008-04-06	2008-04-06 00:00:00	2008-04-27	2008-04-27 00:00:00	32020		\N	141314	0	444814009	40481087		0
35958	2131	4109685	1978-10-14	1978-10-14 00:00:00	1978-10-28	1978-10-28 00:00:00	32020		\N	141826	0	284551006	4109685		0
46667	2777	260139	2000-08-30	2000-08-30 00:00:00	2000-09-13	2000-09-13 00:00:00	32020		\N	183968	0	10509002	260139		0
36339	2151	4294548	1919-06-13	1919-06-13 00:00:00	1919-08-08	1919-08-08 00:00:00	32020		\N	143283	0	75498004	4294548		0
47031	2798	260139	2005-09-27	2005-09-27 00:00:00	2005-10-04	2005-10-04 00:00:00	32020		\N	185446	0	10509002	260139		0
36666	2168	4112343	1973-07-17	1973-07-17 00:00:00	1973-07-25	1973-07-25 00:00:00	32020		\N	144503	0	195662009	4112343		0
36821	2177	260139	1969-07-13	1969-07-13 00:00:00	1969-07-27	1969-07-27 00:00:00	32020		\N	145214	0	10509002	260139		0
37010	2191	40481087	1991-05-05	1991-05-05 00:00:00	1991-05-12	1991-05-12 00:00:00	32020		\N	146089	0	444814009	40481087		0
37130	2199	4112343	1980-02-21	1980-02-21 00:00:00	1980-03-01	1980-03-01 00:00:00	32020		\N	146543	0	195662009	4112343		0
37331	2210	440448	1969-10-19	1969-10-19 00:00:00	\N	\N	32020		\N	147198	0	74400008	440448		0
47997	2847	4155034	1993-03-03	1993-03-03 00:00:00	1993-03-24	1993-03-24 00:00:00	32020		\N	189120	0	283371005	4155034		0
37631	2231	260139	1990-08-28	1990-08-28 00:00:00	1990-09-04	1990-09-04 00:00:00	32020		\N	148453	0	10509002	260139		0
37764	2238	4296204	2000-09-20	2000-09-20 00:00:00	2000-10-11	2000-10-11 00:00:00	32020		\N	148928	0	403190006	4296204		0
48513	2872	40481087	1990-10-02	1990-10-02 00:00:00	1990-10-09	1990-10-09 00:00:00	32020		\N	191192	0	444814009	40481087		0
48711	2886	257012	1974-09-18	1974-09-18 00:00:00	\N	\N	32020		\N	191938	0	40055000	257012		0
48806	2892	372328	1974-11-03	1974-11-03 00:00:00	1975-03-07	1975-03-07 00:00:00	32020		\N	192403	0	65363002	372328		0
49049	2903	372328	1980-03-01	1980-03-01 00:00:00	1981-03-08	1981-03-08 00:00:00	32020		\N	193443	0	65363002	372328		0
49191	2909	40481087	1992-02-08	1992-02-08 00:00:00	1992-02-29	1992-02-29 00:00:00	32020		\N	193874	0	444814009	40481087		0
49339	2917	439777	1962-08-27	1962-08-27 00:00:00	\N	\N	32020		\N	194432	0	271737000	439777		0
49478	2926	4294548	1990-07-30	1990-07-30 00:00:00	1990-08-06	1990-08-06 00:00:00	32020		\N	195175	0	75498004	4294548		0
49688	2939	78272	1964-06-21	1964-06-21 00:00:00	1964-07-19	1964-07-19 00:00:00	32020		\N	195988	0	70704007	78272		0
39257	2329	81151	1976-12-11	1976-12-11 00:00:00	1976-12-25	1976-12-25 00:00:00	32020		\N	154900	0	44465007	81151		0
49977	2953	4230399	1988-12-10	1988-12-10 00:00:00	1989-03-10	1989-03-10 00:00:00	32020		\N	197112	0	359817006	4230399		0
39604	2346	4152936	1966-04-22	1966-04-22 00:00:00	1966-05-06	1966-05-06 00:00:00	32020		\N	156216	0	283385000	4152936		0
39832	2358	40481087	1980-09-24	1980-09-24 00:00:00	1980-10-01	1980-10-01 00:00:00	32020		\N	157140	0	444814009	40481087		0
50474	2986	80180	1980-05-24	1980-05-24 00:00:00	\N	\N	32020		\N	199330	0	396275006	80180		0
40137	2381	40481087	1954-03-05	1954-03-05 00:00:00	1954-03-12	1954-03-12 00:00:00	32020		\N	158294	0	444814009	40481087		0
40314	2392	260139	1958-07-23	1958-07-23 00:00:00	1958-07-30	1958-07-30 00:00:00	32020		\N	159027	0	10509002	260139		0
40411	2396	260139	1959-01-25	1959-01-25 00:00:00	1959-02-01	1959-02-01 00:00:00	32020		\N	159296	0	10509002	260139		0
51175	3030	372328	1981-10-17	1981-10-17 00:00:00	1981-11-24	1981-11-24 00:00:00	32020		\N	202002	0	65363002	372328		0
40831	2427	40481087	1943-06-14	1943-06-14 00:00:00	1943-06-21	1943-06-21 00:00:00	32020		\N	160965	0	444814009	40481087		0
40991	2437	4112343	2008-11-14	2008-11-14 00:00:00	2008-11-24	2008-11-24 00:00:00	32020		\N	161717	0	195662009	4112343		0
51709	3067	81151	1979-08-01	1979-08-01 00:00:00	1979-08-15	1979-08-15 00:00:00	32020		\N	204185	0	44465007	81151		0
51824	3072	40481087	1959-10-21	1959-10-21 00:00:00	1959-11-11	1959-11-11 00:00:00	32020		\N	204483	0	444814009	40481087		0
51970	3080	257012	1988-11-23	1988-11-23 00:00:00	\N	\N	32020		\N	205064	0	40055000	257012		0
52129	3087	40481087	1993-12-10	1993-12-10 00:00:00	1993-12-17	1993-12-17 00:00:00	32020		\N	205564	0	444814009	40481087		0
41786	2485	40481087	2005-07-26	2005-07-26 00:00:00	2005-08-16	2005-08-16 00:00:00	32020		\N	164647	0	444814009	40481087		0
52570	3114	4112343	1963-12-31	1963-12-31 00:00:00	1964-01-09	1964-01-09 00:00:00	32020		\N	207122	0	195662009	4112343		0
52678	3119	40481087	2012-10-09	2012-10-09 00:00:00	2012-10-30	2012-10-30 00:00:00	32020		\N	207578	0	444814009	40481087		0
52885	3133	40481087	1973-06-22	1973-06-22 00:00:00	1973-07-13	1973-07-13 00:00:00	32020		\N	208501	0	444814009	40481087		0
53039	3141	81151	1981-11-11	1981-11-11 00:00:00	1981-12-09	1981-12-09 00:00:00	32020		\N	208988	0	44465007	81151		0
42518	2535	28060	1994-12-04	1994-12-04 00:00:00	1994-12-13	1994-12-13 00:00:00	32020		\N	167554	0	43878008	28060		0
42739	2546	4059173	1987-07-14	1987-07-14 00:00:00	1987-08-13	1987-08-13 00:00:00	32020		\N	168460	0	16114001	4059173		0
42881	2554	4112343	1976-05-15	1976-05-15 00:00:00	1976-05-27	1976-05-27 00:00:00	32020		\N	169267	0	195662009	4112343		0
43017	2561	40481087	1982-01-05	1982-01-05 00:00:00	1982-01-12	1982-01-12 00:00:00	32020		\N	169705	0	444814009	40481087		0
32605	1936	260139	1987-02-07	1987-02-07 00:00:00	1987-02-14	1987-02-14 00:00:00	32020		\N	128828	0	10509002	260139		0
43386	2583	40481087	1982-03-17	1982-03-17 00:00:00	1982-04-07	1982-04-07 00:00:00	32020		\N	171026	0	444814009	40481087		0
32970	1954	4112343	1995-10-08	1995-10-08 00:00:00	1995-10-15	1995-10-15 00:00:00	32020		\N	129958	0	195662009	4112343		0
33172	1967	28060	1971-06-03	1971-06-03 00:00:00	1971-06-15	1971-06-15 00:00:00	32020		\N	130782	0	43878008	28060		0
33325	1977	4112343	1917-11-18	1917-11-18 00:00:00	1917-11-27	1917-11-27 00:00:00	32020		\N	131572	0	195662009	4112343		0
44021	2619	81151	1966-02-17	1966-02-17 00:00:00	1966-03-17	1966-03-17 00:00:00	32020		\N	173200	0	44465007	81151		0
33678	1998	4285898	2015-02-03	2015-02-03 00:00:00	\N	\N	32020		\N	133000	0	68496003	4285898		0
33806	2006	260139	1950-03-30	1950-03-30 00:00:00	1950-04-13	1950-04-13 00:00:00	32020		\N	133545	0	10509002	260139		0
44529	2649	40481087	1957-08-09	1957-08-09 00:00:00	1957-08-23	1957-08-23 00:00:00	32020		\N	175251	0	444814009	40481087		0
44663	2657	4112343	1995-05-25	1995-05-25 00:00:00	1995-06-01	1995-06-01 00:00:00	32020		\N	175954	0	195662009	4112343		0
44822	2666	80180	1992-06-24	1992-06-24 00:00:00	\N	\N	32020		\N	176654	0	396275006	80180		0
45038	2680	40481087	1984-03-30	1984-03-30 00:00:00	1984-04-06	1984-04-06 00:00:00	32020		\N	177517	0	444814009	40481087		0
34615	2054	80180	2010-08-28	2010-08-28 00:00:00	\N	\N	32020		\N	136622	0	396275006	80180		0
45390	2699	4113008	1976-07-02	1976-07-02 00:00:00	1976-07-23	1976-07-23 00:00:00	32020		\N	178710	0	284549007	4113008		0
45511	2705	313217	2010-12-11	2010-12-11 00:00:00	\N	\N	32020		\N	179219	0	49436004	313217		0
35167	2087	4112343	2008-10-09	2008-10-09 00:00:00	2008-10-17	2008-10-17 00:00:00	32020		\N	139127	0	195662009	4112343		0
35298	2091	4112343	1989-11-25	1989-11-25 00:00:00	1989-12-03	1989-12-03 00:00:00	32020		\N	139433	0	195662009	4112343		0
46046	2743	260139	1961-08-31	1961-08-31 00:00:00	1961-09-14	1961-09-14 00:00:00	32020		\N	181500	0	10509002	260139		0
46160	2750	317576	2007-09-26	2007-09-26 00:00:00	\N	\N	32020		\N	181874	0	53741008	317576		0
35835	2123	40481087	1954-05-02	1954-05-02 00:00:00	1954-05-23	1954-05-23 00:00:00	32020		\N	141277	0	444814009	40481087		0
35959	2131	260139	1959-06-20	1959-06-20 00:00:00	1959-06-27	1959-06-27 00:00:00	32020		\N	141792	0	10509002	260139		0
46668	2777	260139	1968-05-21	1968-05-21 00:00:00	1968-05-28	1968-05-28 00:00:00	32020		\N	183964	0	10509002	260139		0
36340	2151	260139	1954-09-02	1954-09-02 00:00:00	1954-09-16	1954-09-16 00:00:00	32020		\N	143284	0	10509002	260139		0
47032	2798	4112343	2006-07-21	2006-07-21 00:00:00	2006-07-30	2006-07-30 00:00:00	32020		\N	185405	0	195662009	4112343		0
36684	2172	4146173	1991-05-02	1991-05-02 00:00:00	1991-06-01	1991-06-01 00:00:00	32020		\N	144713	0	307731004	4146173		0
36822	2177	40481087	1985-09-25	1985-09-25 00:00:00	1985-10-09	1985-10-09 00:00:00	32020		\N	145205	0	444814009	40481087		0
37011	2191	40481087	1979-11-29	1979-11-29 00:00:00	1979-12-06	1979-12-06 00:00:00	32020		\N	146087	0	444814009	40481087		0
37131	2199	40481087	2013-07-01	2013-07-01 00:00:00	2013-07-15	2013-07-15 00:00:00	32020		\N	146589	0	444814009	40481087		0
37332	2211	81893	2005-08-05	2005-08-05 00:00:00	\N	\N	32020		\N	147314	0	64766004	81893		0
47998	2847	260139	2009-06-09	2009-06-09 00:00:00	2009-06-23	2009-06-23 00:00:00	32020		\N	189106	0	10509002	260139		0
37632	2231	4109685	2017-07-06	2017-07-06 00:00:00	2017-07-27	2017-07-27 00:00:00	32020		\N	148472	0	284551006	4109685		0
37765	2238	4155034	2005-08-16	2005-08-16 00:00:00	2005-09-06	2005-09-06 00:00:00	32020		\N	148929	0	283371005	4155034		0
48514	2872	4156265	1992-07-14	1992-07-14 00:00:00	1992-08-04	1992-08-04 00:00:00	32020		\N	191207	0	370247008	4156265		0
48712	2886	260139	1983-11-26	1983-11-26 00:00:00	1983-12-10	1983-12-10 00:00:00	32020		\N	191897	0	10509002	260139		0
48807	2892	260139	1975-06-18	1975-06-18 00:00:00	1975-06-25	1975-06-25 00:00:00	32020		\N	192394	0	10509002	260139		0
49050	2903	4112343	2014-09-04	2014-09-04 00:00:00	2014-09-14	2014-09-14 00:00:00	32020		\N	193421	0	195662009	4112343		0
49192	2909	40481087	1991-01-31	1991-01-31 00:00:00	1991-02-07	1991-02-07 00:00:00	32020		\N	193873	0	444814009	40481087		0
49340	2917	4112343	1998-10-04	1998-10-04 00:00:00	1998-10-15	1998-10-15 00:00:00	32020		\N	194470	0	195662009	4112343		0
49479	2926	40481087	1998-12-12	1998-12-12 00:00:00	1998-12-26	1998-12-26 00:00:00	32020		\N	195140	0	444814009	40481087		0
49689	2939	4112343	2011-07-01	2011-07-01 00:00:00	2011-07-14	2011-07-14 00:00:00	32020		\N	195954	0	195662009	4112343		0
39258	2329	40481087	1973-07-07	1973-07-07 00:00:00	1973-07-28	1973-07-28 00:00:00	32020		\N	154928	0	444814009	40481087		0
49978	2953	260139	1999-02-18	1999-02-18 00:00:00	1999-02-25	1999-02-25 00:00:00	32020		\N	197147	0	10509002	260139		0
39605	2346	260139	1952-11-03	1952-11-03 00:00:00	1952-11-17	1952-11-17 00:00:00	32020		\N	156125	0	10509002	260139		0
39833	2358	78272	1984-07-29	1984-07-29 00:00:00	1984-08-19	1984-08-19 00:00:00	32020		\N	157130	0	70704007	78272		0
50475	2986	4112343	2002-01-07	2002-01-07 00:00:00	2002-01-16	2002-01-16 00:00:00	32020		\N	199286	0	195662009	4112343		0
40138	2381	40481087	1970-01-24	1970-01-24 00:00:00	1970-02-14	1970-02-14 00:00:00	32020		\N	158333	0	444814009	40481087		0
40315	2392	260139	1960-01-22	1960-01-22 00:00:00	1960-01-29	1960-01-29 00:00:00	32020		\N	159021	0	10509002	260139		0
40412	2396	260139	1972-10-23	1972-10-23 00:00:00	1972-11-06	1972-11-06 00:00:00	32020		\N	159384	0	10509002	260139		0
51176	3030	134438	2002-08-20	2002-08-20 00:00:00	2003-06-16	2003-06-16 00:00:00	32020		\N	202013	0	40275004	134438		0
40832	2427	4112343	1943-12-06	1943-12-06 00:00:00	1943-12-13	1943-12-13 00:00:00	32020		\N	160978	0	195662009	4112343		0
40992	2437	4112343	1967-10-09	1967-10-09 00:00:00	1967-10-21	1967-10-21 00:00:00	32020		\N	161692	0	195662009	4112343		0
51710	3067	192671	1976-10-06	1976-10-06 00:00:00	\N	\N	32020		\N	204183	0	K92.2	35208414		0
51825	3072	4112343	1987-11-26	1987-11-26 00:00:00	1987-12-08	1987-12-08 00:00:00	32020		\N	204493	0	195662009	4112343		0
51971	3080	260139	1980-11-29	1980-11-29 00:00:00	1980-12-06	1980-12-06 00:00:00	32020		\N	205059	0	10509002	260139		0
52130	3087	260139	1993-10-08	1993-10-08 00:00:00	1993-10-15	1993-10-15 00:00:00	32020		\N	205505	0	10509002	260139		0
41787	2485	4112343	2006-10-06	2006-10-06 00:00:00	2006-10-18	2006-10-18 00:00:00	32020		\N	164648	0	195662009	4112343		0
52571	3114	40481087	1979-10-04	1979-10-04 00:00:00	1979-10-25	1979-10-25 00:00:00	32020		\N	207132	0	444814009	40481087		0
52679	3119	4310024	2013-09-05	2013-09-05 00:00:00	\N	\N	32020		\N	207578	0	424802006	4310024		0
52886	3133	4059173	1961-01-26	1961-01-26 00:00:00	1961-03-27	1961-03-27 00:00:00	32020		\N	208507	0	16114001	4059173		0
53040	3141	40481087	1976-11-16	1976-11-16 00:00:00	1976-11-23	1976-11-23 00:00:00	32020		\N	208964	0	444814009	40481087		0
42519	2535	378001	1994-10-03	1994-10-03 00:00:00	1994-12-02	1994-12-02 00:00:00	32020		\N	167509	0	62106007	378001		0
42740	2546	260139	1990-05-19	1990-05-19 00:00:00	1990-06-02	1990-06-02 00:00:00	32020		\N	168509	0	10509002	260139		0
42882	2554	40480160	2015-12-26	2015-12-26 00:00:00	2016-03-25	2016-03-25 00:00:00	32020		\N	169199	0	443165006	40480160		0
43018	2561	257012	1981-11-14	1981-11-14 00:00:00	\N	\N	32020		\N	169714	0	40055000	257012		0
32606	1936	40481087	1953-11-21	1953-11-21 00:00:00	1953-12-12	1953-12-12 00:00:00	32020		\N	128811	0	444814009	40481087		0
43387	2583	260139	1985-10-26	1985-10-26 00:00:00	1985-11-09	1985-11-09 00:00:00	32020		\N	171019	0	10509002	260139		0
32971	1954	40481087	1960-09-22	1960-09-22 00:00:00	1960-09-29	1960-09-29 00:00:00	32020		\N	129956	0	444814009	40481087		0
33326	1977	40481087	1933-07-02	1933-07-02 00:00:00	1933-07-09	1933-07-09 00:00:00	32020		\N	131557	0	444814009	40481087		0
44022	2619	260139	2011-07-26	2011-07-26 00:00:00	2011-08-02	2011-08-02 00:00:00	32020		\N	173216	0	10509002	260139		0
33679	1998	80180	2015-10-01	2015-10-01 00:00:00	\N	\N	32020		\N	133000	0	396275006	80180		0
33807	2006	40481087	1985-01-03	1985-01-03 00:00:00	1985-01-10	1985-01-10 00:00:00	32020		\N	133594	0	444814009	40481087		0
44530	2649	81151	2011-02-19	2011-02-19 00:00:00	2011-03-12	2011-03-12 00:00:00	32020		\N	175270	0	44465007	81151		0
44664	2657	378001	1971-08-10	1971-08-10 00:00:00	1971-10-09	1971-10-09 00:00:00	32020		\N	175950	0	62106007	378001		0
44823	2666	40481087	1988-09-26	1988-09-26 00:00:00	1988-10-03	1988-10-03 00:00:00	32020		\N	176661	0	444814009	40481087		0
45039	2680	40481087	1994-06-19	1994-06-19 00:00:00	1994-07-03	1994-07-03 00:00:00	32020		\N	177563	0	444814009	40481087		0
34616	2054	28060	1979-10-13	1979-10-13 00:00:00	1979-10-21	1979-10-21 00:00:00	32020		\N	136585	0	43878008	28060		0
45391	2699	260139	1980-11-18	1980-11-18 00:00:00	1980-11-25	1980-11-25 00:00:00	32020		\N	178717	0	10509002	260139		0
45512	2705	40481087	1975-07-06	1975-07-06 00:00:00	1975-07-20	1975-07-20 00:00:00	32020		\N	179222	0	444814009	40481087		0
35168	2087	4112343	1983-03-09	1983-03-09 00:00:00	1983-03-21	1983-03-21 00:00:00	32020		\N	139007	0	195662009	4112343		0
35299	2091	28060	2010-10-31	2010-10-31 00:00:00	2010-11-13	2010-11-13 00:00:00	32020		\N	139443	0	43878008	28060		0
46047	2743	4116491	1995-03-29	1995-03-29 00:00:00	1995-05-19	1995-05-19 00:00:00	32020		\N	181502	0	301011002	4116491		0
46161	2750	4112343	1940-02-16	1940-02-16 00:00:00	1940-02-26	1940-02-26 00:00:00	32020		\N	181887	0	195662009	4112343		0
35836	2123	4094814	1995-10-23	1995-10-23 00:00:00	1995-12-22	1995-12-22 00:00:00	32020		\N	141320	0	262574004	4094814		0
35969	2133	40481087	2003-06-23	2003-06-23 00:00:00	2003-06-30	2003-06-30 00:00:00	32020		\N	141934	0	444814009	40481087		0
46669	2777	40481087	1982-08-08	1982-08-08 00:00:00	1982-08-22	1982-08-22 00:00:00	32020		\N	183950	0	444814009	40481087		0
36341	2151	4112343	1957-12-27	1957-12-27 00:00:00	1958-01-08	1958-01-08 00:00:00	32020		\N	143302	0	195662009	4112343		0
47033	2798	4112343	1978-08-11	1978-08-11 00:00:00	1978-08-21	1978-08-21 00:00:00	32020		\N	185460	0	195662009	4112343		0
36685	2172	40481087	2006-02-04	2006-02-04 00:00:00	2006-02-25	2006-02-25 00:00:00	32020		\N	144668	0	444814009	40481087		0
36823	2177	80180	2005-06-03	2005-06-03 00:00:00	\N	\N	32020		\N	145178	0	396275006	80180		0
37012	2191	4112343	1984-01-29	1984-01-29 00:00:00	1984-02-10	1984-02-10 00:00:00	32020		\N	146114	0	195662009	4112343		0
37132	2199	40481087	2005-04-03	2005-04-03 00:00:00	2005-04-17	2005-04-17 00:00:00	32020		\N	146546	0	444814009	40481087		0
37333	2211	4310024	2004-10-09	2004-10-09 00:00:00	\N	\N	32020		\N	147314	0	424802006	4310024		0
47999	2847	40481087	1976-10-28	1976-10-28 00:00:00	1976-11-18	1976-11-18 00:00:00	32020		\N	189110	0	444814009	40481087		0
37633	2231	40481087	2007-07-14	2007-07-14 00:00:00	2007-07-28	2007-07-28 00:00:00	32020		\N	148420	0	444814009	40481087		0
37766	2238	40481087	1977-07-27	1977-07-27 00:00:00	1977-08-17	1977-08-17 00:00:00	32020		\N	148932	0	444814009	40481087		0
48515	2872	260139	1988-01-03	1988-01-03 00:00:00	1988-01-10	1988-01-10 00:00:00	32020		\N	191201	0	10509002	260139		0
48713	2886	4283893	1981-09-13	1981-09-13 00:00:00	1981-10-04	1981-10-04 00:00:00	32020		\N	191947	0	36971009	4283893		0
48808	2892	260139	1997-07-18	1997-07-18 00:00:00	1997-08-01	1997-08-01 00:00:00	32020		\N	192397	0	10509002	260139		0
49051	2903	4112343	2016-08-07	2016-08-07 00:00:00	2016-08-14	2016-08-14 00:00:00	32020		\N	193422	0	195662009	4112343		0
49193	2909	40481087	1954-12-11	1954-12-11 00:00:00	1955-01-01	1955-01-01 00:00:00	32020		\N	193856	0	444814009	40481087		0
49341	2917	28060	1990-02-08	1990-02-08 00:00:00	1990-02-15	1990-02-15 00:00:00	32020		\N	194496	0	43878008	28060		0
49480	2926	30753	2016-12-03	2016-12-03 00:00:00	\N	\N	32020		\N	195177	0	16761005	30753		0
49690	2939	28060	1977-08-06	1977-08-06 00:00:00	1977-08-17	1977-08-17 00:00:00	32020		\N	195950	0	43878008	28060		0
39259	2329	80180	2014-03-22	2014-03-22 00:00:00	\N	\N	32020		\N	154921	0	396275006	80180		0
49979	2953	40481087	1999-08-31	1999-08-31 00:00:00	1999-09-14	1999-09-14 00:00:00	32020		\N	197124	0	444814009	40481087		0
39606	2346	372328	1949-09-01	1949-09-01 00:00:00	1950-01-11	1950-01-11 00:00:00	32020		\N	156156	0	65363002	372328		0
39834	2358	40481087	1981-08-03	1981-08-03 00:00:00	1981-08-17	1981-08-17 00:00:00	32020		\N	157149	0	444814009	40481087		0
50476	2986	4112343	1948-05-10	1948-05-10 00:00:00	1948-05-17	1948-05-17 00:00:00	32020		\N	199346	0	195662009	4112343		0
40139	2381	4112343	1941-12-01	1941-12-01 00:00:00	1941-12-10	1941-12-10 00:00:00	32020		\N	158284	0	195662009	4112343		0
40316	2392	40481087	2018-08-16	2018-08-16 00:00:00	2018-08-23	2018-08-23 00:00:00	32020		\N	159105	0	444814009	40481087		0
40413	2396	260139	1986-03-06	1986-03-06 00:00:00	1986-03-20	1986-03-20 00:00:00	32020		\N	159346	0	10509002	260139		0
51177	3030	4155034	2013-08-26	2013-08-26 00:00:00	2013-09-09	2013-09-09 00:00:00	32020		\N	202027	0	283371005	4155034		0
40833	2428	4112343	1984-08-03	1984-08-03 00:00:00	1984-08-12	1984-08-12 00:00:00	32020		\N	161082	0	195662009	4112343		0
40993	2437	4027663	1988-07-31	1988-07-31 00:00:00	\N	\N	32020		\N	161708	0	13200003	4027663		0
51711	3067	260139	2003-10-21	2003-10-21 00:00:00	2003-10-28	2003-10-28 00:00:00	32020		\N	204180	0	10509002	260139		0
51826	3072	40481087	1992-08-16	1992-08-16 00:00:00	1992-09-06	1992-09-06 00:00:00	32020		\N	204430	0	444814009	40481087		0
51972	3080	4156265	2002-07-16	2002-07-16 00:00:00	2002-08-06	2002-08-06 00:00:00	32020		\N	205009	0	370247008	4156265		0
52131	3087	40481087	1963-12-08	1963-12-08 00:00:00	1963-12-15	1963-12-15 00:00:00	32020		\N	205562	0	444814009	40481087		0
41788	2485	40481087	1981-02-06	1981-02-06 00:00:00	1981-02-27	1981-02-27 00:00:00	32020		\N	164674	0	444814009	40481087		0
52572	3114	4310024	1980-04-07	1980-04-07 00:00:00	\N	\N	32020		\N	207132	0	424802006	4310024		0
52680	3119	4112343	1984-09-26	1984-09-26 00:00:00	1984-10-04	1984-10-04 00:00:00	32020		\N	207584	0	195662009	4112343		0
52887	3133	4027663	1982-02-15	1982-02-15 00:00:00	\N	\N	32020		\N	208511	0	13200003	4027663		0
53041	3141	40481087	2010-08-06	2010-08-06 00:00:00	2010-08-27	2010-08-27 00:00:00	32020		\N	208971	0	444814009	40481087		0
42520	2535	28060	1962-10-08	1962-10-08 00:00:00	1962-10-16	1962-10-16 00:00:00	32020		\N	167489	0	43878008	28060		0
42741	2546	260139	1992-09-01	1992-09-01 00:00:00	1992-09-08	1992-09-08 00:00:00	32020		\N	168519	0	10509002	260139		0
42883	2554	4230399	2015-12-26	2015-12-26 00:00:00	2016-03-25	2016-03-25 00:00:00	32020		\N	169199	0	359817006	4230399		0
43019	2561	4027663	2007-10-20	2007-10-20 00:00:00	\N	\N	32020		\N	169687	0	13200003	4027663		0
32607	1936	4112343	1960-01-12	1960-01-12 00:00:00	1960-01-21	1960-01-21 00:00:00	32020		\N	128769	0	195662009	4112343		0
43388	2583	4059173	1971-07-10	1971-07-10 00:00:00	1971-10-08	1971-10-08 00:00:00	32020		\N	171042	0	16114001	4059173		0
32981	1956	4112343	1977-10-12	1977-10-12 00:00:00	1977-10-21	1977-10-21 00:00:00	32020		\N	130179	0	195662009	4112343		0
33174	1967	78272	1983-11-29	1983-11-29 00:00:00	1983-12-27	1983-12-27 00:00:00	32020		\N	130890	0	70704007	78272		0
33327	1977	40481087	2005-04-07	2005-04-07 00:00:00	2005-04-14	2005-04-14 00:00:00	32020		\N	131602	0	444814009	40481087		0
44023	2619	4310024	1976-03-31	1976-03-31 00:00:00	\N	\N	32020		\N	173189	0	424802006	4310024		0
33680	1998	260139	2017-09-21	2017-09-21 00:00:00	2017-10-05	2017-10-05 00:00:00	32020		\N	133002	0	10509002	260139		0
33808	2006	40481087	1947-11-14	1947-11-14 00:00:00	1947-11-21	1947-11-21 00:00:00	32020		\N	133544	0	444814009	40481087		0
44531	2649	40481087	2002-06-24	2002-06-24 00:00:00	2002-07-01	2002-07-01 00:00:00	32020		\N	175257	0	444814009	40481087		0
44665	2657	4112343	1977-12-20	1977-12-20 00:00:00	1977-12-31	1977-12-31 00:00:00	32020		\N	175952	0	195662009	4112343		0
44824	2666	4112343	1961-11-20	1961-11-20 00:00:00	1961-11-29	1961-11-29 00:00:00	32020		\N	176605	0	195662009	4112343		0
45040	2680	40481087	2008-12-26	2008-12-26 00:00:00	2009-01-02	2009-01-02 00:00:00	32020		\N	177521	0	444814009	40481087		0
34617	2054	4112343	1999-03-14	1999-03-14 00:00:00	1999-03-24	1999-03-24 00:00:00	32020		\N	136627	0	195662009	4112343		0
45392	2699	40481087	1999-10-20	1999-10-20 00:00:00	1999-11-10	1999-11-10 00:00:00	32020		\N	178741	0	444814009	40481087		0
45513	2705	378001	1971-09-29	1971-09-29 00:00:00	1971-11-28	1971-11-28 00:00:00	32020		\N	179244	0	62106007	378001		0
35169	2087	260139	1941-06-07	1941-06-07 00:00:00	1941-06-21	1941-06-21 00:00:00	32020		\N	139133	0	10509002	260139		0
35300	2091	81151	1979-07-29	1979-07-29 00:00:00	1979-08-12	1979-08-12 00:00:00	32020		\N	139480	0	44465007	81151		0
46048	2743	80180	1992-02-18	1992-02-18 00:00:00	\N	\N	32020		\N	181483	0	396275006	80180		0
46162	2750	80502	1993-08-11	1993-08-11 00:00:00	\N	\N	32020		\N	181919	0	64859006	80502		0
35837	2123	40481087	1959-06-01	1959-06-01 00:00:00	1959-06-15	1959-06-15 00:00:00	32020		\N	141250	0	444814009	40481087		0
35970	2133	80180	2003-08-17	2003-08-17 00:00:00	\N	\N	32020		\N	141934	0	396275006	80180		0
46670	2777	4149245	1985-11-06	1985-11-06 00:00:00	1985-12-13	1985-12-13 00:00:00	32020		\N	183933	0	30832001	4149245		0
36342	2151	40481087	1948-06-05	1948-06-05 00:00:00	1948-06-12	1948-06-12 00:00:00	32020		\N	143308	0	444814009	40481087		0
47034	2798	81151	1967-11-27	1967-11-27 00:00:00	1967-12-25	1967-12-25 00:00:00	32020		\N	185429	0	44465007	81151		0
36686	2172	372328	1984-05-29	1984-05-29 00:00:00	1984-09-22	1984-09-22 00:00:00	32020		\N	144664	0	65363002	372328		0
36824	2177	4112343	1985-07-20	1985-07-20 00:00:00	1985-07-29	1985-07-29 00:00:00	32020		\N	145215	0	195662009	4112343		0
37013	2191	260139	1981-04-23	1981-04-23 00:00:00	1981-05-07	1981-05-07 00:00:00	32020		\N	146088	0	10509002	260139		0
37133	2199	257012	2015-09-19	2015-09-19 00:00:00	\N	\N	32020		\N	146590	0	40055000	257012		0
37334	2211	4027663	1996-06-13	1996-06-13 00:00:00	\N	\N	32020		\N	147285	0	13200003	4027663		0
48000	2847	40481087	1980-08-24	1980-08-24 00:00:00	1980-09-07	1980-09-07 00:00:00	32020		\N	189053	0	444814009	40481087		0
37634	2231	440086	1977-05-07	1977-05-07 00:00:00	1988-05-14	1988-05-14 00:00:00	32020		\N	148424	0	192127007	440086		0
37767	2238	4112343	2010-09-19	2010-09-19 00:00:00	2010-10-01	2010-10-01 00:00:00	32020		\N	148926	0	195662009	4112343		0
48516	2872	4155034	1968-04-07	1968-04-07 00:00:00	1968-04-21	1968-04-21 00:00:00	32020		\N	191204	0	283371005	4155034		0
48714	2886	4109685	1965-05-26	1965-05-26 00:00:00	1965-06-09	1965-06-09 00:00:00	32020		\N	191968	0	284551006	4109685		0
48809	2892	40481087	1973-08-30	1973-08-30 00:00:00	1973-09-13	1973-09-13 00:00:00	32020		\N	192421	0	444814009	40481087		0
49052	2903	260139	1973-04-10	1973-04-10 00:00:00	1973-04-24	1973-04-24 00:00:00	32020		\N	193409	0	10509002	260139		0
49194	2909	4296204	1956-07-27	1956-07-27 00:00:00	1956-08-10	1956-08-10 00:00:00	32020		\N	193909	0	403190006	4296204		0
49342	2917	80180	1976-02-10	1976-02-10 00:00:00	\N	\N	32020		\N	194528	0	396275006	80180		0
49481	2926	40481087	2016-01-10	2016-01-10 00:00:00	2016-01-24	2016-01-24 00:00:00	32020		\N	195177	0	444814009	40481087		0
49691	2939	28060	1977-03-27	1977-03-27 00:00:00	1977-04-07	1977-04-07 00:00:00	32020		\N	195949	0	43878008	28060		0
39260	2329	40481087	2016-01-16	2016-01-16 00:00:00	2016-01-23	2016-01-23 00:00:00	32020		\N	154940	0	444814009	40481087		0
49980	2953	28060	2009-05-15	2009-05-15 00:00:00	2009-05-27	2009-05-27 00:00:00	32020		\N	197109	0	43878008	28060		0
39607	2346	260139	1972-10-10	1972-10-10 00:00:00	1972-10-24	1972-10-24 00:00:00	32020		\N	156169	0	10509002	260139		0
39835	2358	260139	1986-04-22	1986-04-22 00:00:00	1986-05-06	1986-05-06 00:00:00	32020		\N	157133	0	10509002	260139		0
50477	2986	4112343	2013-07-21	2013-07-21 00:00:00	2013-07-29	2013-07-29 00:00:00	32020		\N	199334	0	195662009	4112343		0
40140	2381	440086	1943-03-17	1943-03-17 00:00:00	1944-10-11	1944-10-11 00:00:00	32020		\N	158308	0	192127007	440086		0
40317	2392	4294548	1978-10-15	1978-10-15 00:00:00	1978-11-12	1978-11-12 00:00:00	32020		\N	159022	0	75498004	4294548		0
40414	2396	40481087	1946-12-11	1946-12-11 00:00:00	1946-12-18	1946-12-18 00:00:00	32020		\N	159303	0	444814009	40481087		0
51178	3030	40481087	2005-01-24	2005-01-24 00:00:00	2005-02-14	2005-02-14 00:00:00	32020		\N	201982	0	444814009	40481087		0
40834	2428	195588	2002-06-18	2002-06-18 00:00:00	2002-08-10	2002-08-10 00:00:00	32020		\N	161097	0	38822007	195588		0
40994	2437	40481087	1978-04-21	1978-04-21 00:00:00	1978-05-12	1978-05-12 00:00:00	32020		\N	161698	0	444814009	40481087		0
51712	3067	4116491	1982-12-08	1982-12-08 00:00:00	1983-01-27	1983-01-27 00:00:00	32020		\N	204155	0	301011002	4116491		0
51827	3072	4155034	2008-01-23	2008-01-23 00:00:00	2008-02-13	2008-02-13 00:00:00	32020		\N	204462	0	283371005	4155034		0
51973	3080	4113008	1966-07-13	1966-07-13 00:00:00	1966-08-03	1966-08-03 00:00:00	32020		\N	204968	0	284549007	4113008		0
52132	3087	4132546	1991-09-10	1991-09-10 00:00:00	\N	\N	32020		\N	205555	0	275272006	4166590		0
41789	2485	260139	1924-07-25	1924-07-25 00:00:00	1924-08-01	1924-08-01 00:00:00	32020		\N	164593	0	10509002	260139		0
52573	3114	4134304	2013-02-19	2013-02-19 00:00:00	2013-05-20	2013-05-20 00:00:00	32020		\N	207117	0	263102004	4134304		0
52681	3119	372328	1992-12-03	1992-12-03 00:00:00	1993-08-16	1993-08-16 00:00:00	32020		\N	207566	0	65363002	372328		0
52888	3133	372328	1961-09-14	1961-09-14 00:00:00	1962-02-07	1962-02-07 00:00:00	32020		\N	208460	0	65363002	372328		0
53042	3141	80180	2010-09-15	2010-09-15 00:00:00	\N	\N	32020		\N	208971	0	396275006	80180		0
42521	2535	40481087	1981-01-11	1981-01-11 00:00:00	1981-01-18	1981-01-18 00:00:00	32020		\N	167483	0	444814009	40481087		0
42742	2546	28060	1981-04-27	1981-04-27 00:00:00	1981-05-09	1981-05-09 00:00:00	32020		\N	168461	0	43878008	28060		0
42884	2554	40481087	1980-03-30	1980-03-30 00:00:00	1980-04-06	1980-04-06 00:00:00	32020		\N	169219	0	444814009	40481087		0
43020	2561	260139	1984-03-21	1984-03-21 00:00:00	1984-04-04	1984-04-04 00:00:00	32020		\N	169706	0	10509002	260139		0
32608	1936	81151	1949-10-08	1949-10-08 00:00:00	1949-11-05	1949-11-05 00:00:00	32020		\N	128761	0	44465007	81151		0
43389	2583	260139	2018-10-25	2018-10-25 00:00:00	2018-11-08	2018-11-08 00:00:00	32020		\N	171021	0	10509002	260139		0
32982	1956	40481087	2016-09-23	2016-09-23 00:00:00	2016-10-14	2016-10-14 00:00:00	32020		\N	130143	0	444814009	40481087		0
33175	1967	4296204	1969-01-02	1969-01-02 00:00:00	1969-01-16	1969-01-16 00:00:00	32020		\N	130889	0	403190006	4296204		0
33328	1977	260139	2007-04-13	2007-04-13 00:00:00	2007-04-27	2007-04-27 00:00:00	32020		\N	131603	0	10509002	260139		0
44024	2619	4112343	1949-02-16	1949-02-16 00:00:00	1949-02-24	1949-02-24 00:00:00	32020		\N	173147	0	195662009	4112343		0
33681	1998	260139	2019-02-22	2019-02-22 00:00:00	2019-03-01	2019-03-01 00:00:00	32020		\N	133030	0	10509002	260139		0
33809	2006	28060	1980-07-29	1980-07-29 00:00:00	1980-08-11	1980-08-11 00:00:00	32020		\N	133593	0	43878008	28060		0
44532	2649	78272	1972-12-23	1972-12-23 00:00:00	1973-01-13	1973-01-13 00:00:00	32020		\N	175267	0	70704007	78272		0
44666	2657	80180	2000-05-19	2000-05-19 00:00:00	\N	\N	32020		\N	175936	0	396275006	80180		0
44825	2666	4112343	1975-07-20	1975-07-20 00:00:00	1975-07-27	1975-07-27 00:00:00	32020		\N	176660	0	195662009	4112343		0
45041	2680	4294548	1993-07-25	1993-07-25 00:00:00	1993-10-17	1993-10-17 00:00:00	32020		\N	177518	0	75498004	4294548		0
34618	2054	4027663	1999-06-17	1999-06-17 00:00:00	\N	\N	32020		\N	136627	0	13200003	4027663		0
45393	2699	4116491	2008-11-07	2008-11-07 00:00:00	2008-12-14	2008-12-14 00:00:00	32020		\N	178721	0	301011002	4116491		0
45514	2705	260139	1980-12-16	1980-12-16 00:00:00	1980-12-23	1980-12-23 00:00:00	32020		\N	179179	0	10509002	260139		0
35170	2087	260139	1923-08-16	1923-08-16 00:00:00	1923-08-23	1923-08-23 00:00:00	32020		\N	139038	0	10509002	260139		0
35301	2091	260139	2013-02-05	2013-02-05 00:00:00	2013-02-19	2013-02-19 00:00:00	32020		\N	139437	0	10509002	260139		0
46049	2743	4285898	1992-01-19	1992-01-19 00:00:00	\N	\N	32020		\N	181483	0	68496003	4285898		0
48316	2863	257012	1994-10-19	1994-10-19 00:00:00	\N	\N	32020		\N	190415	0	40055000	257012		0
46163	2750	378001	1974-10-01	1974-10-01 00:00:00	1974-11-30	1974-11-30 00:00:00	32020		\N	181872	0	62106007	378001		0
35838	2123	40481087	1991-04-08	1991-04-08 00:00:00	1991-04-29	1991-04-29 00:00:00	32020		\N	141311	0	444814009	40481087		0
35971	2133	4112343	2003-11-18	2003-11-18 00:00:00	2003-12-01	2003-12-01 00:00:00	32020		\N	141935	0	195662009	4112343		0
46671	2777	81151	1969-07-13	1969-07-13 00:00:00	1969-08-03	1969-08-03 00:00:00	32020		\N	183931	0	44465007	81151		0
36343	2152	81151	1992-07-01	1992-07-01 00:00:00	1992-07-15	1992-07-15 00:00:00	32020		\N	143418	0	44465007	81151		0
47035	2798	40481087	2013-08-06	2013-08-06 00:00:00	2013-08-27	2013-08-27 00:00:00	32020		\N	185465	0	444814009	40481087		0
47155	2804	260139	1983-08-09	1983-08-09 00:00:00	1983-08-16	1983-08-16 00:00:00	32020		\N	185825	0	10509002	260139		0
36825	2177	40481087	2012-01-11	2012-01-11 00:00:00	2012-01-18	2012-01-18 00:00:00	32020		\N	145190	0	444814009	40481087		0
37014	2191	4112343	1971-12-13	1971-12-13 00:00:00	1971-12-23	1971-12-23 00:00:00	32020		\N	146086	0	195662009	4112343		0
37134	2199	4134304	1984-04-26	1984-04-26 00:00:00	1984-07-25	1984-07-25 00:00:00	32020		\N	146577	0	263102004	4134304		0
37335	2211	257012	2013-07-18	2013-07-18 00:00:00	\N	\N	32020		\N	147344	0	40055000	257012		0
48013	2849	257012	1987-03-12	1987-03-12 00:00:00	\N	\N	32020		\N	189207	0	40055000	257012		0
37635	2231	260139	1981-07-11	1981-07-11 00:00:00	1981-07-25	1981-07-25 00:00:00	32020		\N	148426	0	10509002	260139		0
37768	2238	28060	1970-12-26	1970-12-26 00:00:00	1971-01-05	1971-01-05 00:00:00	32020		\N	148974	0	43878008	28060		0
48517	2872	40481087	1981-07-05	1981-07-05 00:00:00	1981-07-12	1981-07-12 00:00:00	32020		\N	191191	0	444814009	40481087		0
48715	2886	40481087	1979-09-11	1979-09-11 00:00:00	1979-09-18	1979-09-18 00:00:00	32020		\N	191941	0	444814009	40481087		0
48810	2892	4112343	1980-05-20	1980-05-20 00:00:00	1980-05-28	1980-05-28 00:00:00	32020		\N	192420	0	195662009	4112343		0
49053	2903	260139	2011-03-11	2011-03-11 00:00:00	2011-03-25	2011-03-25 00:00:00	32020		\N	193420	0	10509002	260139		0
49195	2909	260139	1990-07-15	1990-07-15 00:00:00	1990-07-29	1990-07-29 00:00:00	32020		\N	193845	0	10509002	260139		0
49343	2917	4112343	1949-05-30	1949-05-30 00:00:00	1949-06-11	1949-06-11 00:00:00	32020		\N	194434	0	195662009	4112343		0
49482	2926	4285898	2017-03-03	2017-03-03 00:00:00	\N	\N	32020		\N	195177	0	68496003	4285898		0
49692	2939	4112343	2013-09-17	2013-09-17 00:00:00	2013-09-26	2013-09-26 00:00:00	32020		\N	196002	0	195662009	4112343		0
39261	2329	40481087	1995-09-28	1995-09-28 00:00:00	1995-10-12	1995-10-12 00:00:00	32020		\N	154931	0	444814009	40481087		0
49981	2953	4027663	2009-11-05	2009-11-05 00:00:00	\N	\N	32020		\N	197109	0	13200003	4027663		0
39608	2346	260139	1983-05-14	1983-05-14 00:00:00	1983-05-21	1983-05-21 00:00:00	32020		\N	156211	0	10509002	260139		0
39836	2358	4112343	2006-08-31	2006-08-31 00:00:00	2006-09-09	2006-09-09 00:00:00	32020		\N	157152	0	195662009	4112343		0
50479	2986	321042	1946-03-12	1946-03-12 00:00:00	\N	\N	32020		\N	199353	0	410429000	321042		0
40141	2381	40481087	2001-12-25	2001-12-25 00:00:00	2002-01-08	2002-01-08 00:00:00	32020		\N	158352	0	444814009	40481087		0
40318	2392	261325	1951-10-12	1951-10-12 00:00:00	\N	\N	32020		\N	158998	0	87433001	261325		0
40440	2402	81151	1987-01-17	1987-01-17 00:00:00	1987-02-07	1987-02-07 00:00:00	32020		\N	159670	0	44465007	81151		0
51179	3030	4112343	2013-07-04	2013-07-04 00:00:00	2013-07-17	2013-07-17 00:00:00	32020		\N	202014	0	195662009	4112343		0
40835	2428	260139	2008-02-28	2008-02-28 00:00:00	2008-03-06	2008-03-06 00:00:00	32020		\N	161103	0	10509002	260139		0
40995	2437	4112343	1998-10-10	1998-10-10 00:00:00	1998-10-19	1998-10-19 00:00:00	32020		\N	161699	0	195662009	4112343		0
51713	3067	40481087	1989-01-02	1989-01-02 00:00:00	1989-01-09	1989-01-09 00:00:00	32020		\N	204156	0	444814009	40481087		0
51828	3072	257012	1999-01-30	1999-01-30 00:00:00	1999-07-10	1999-07-10 00:00:00	32020		\N	204479	0	40055000	257012		0
51974	3080	4112343	2019-01-19	2019-01-19 00:00:00	2019-01-27	2019-01-27 00:00:00	32020		\N	204994	0	195662009	4112343		0
52133	3087	4001336	1991-09-10	1991-09-10 00:00:00	1991-10-10	1991-10-10 00:00:00	32020		\N	205555	0	110030002	4001336		0
41790	2485	372328	1914-11-02	1914-11-02 00:00:00	1914-12-09	1914-12-09 00:00:00	32020		\N	164590	0	65363002	372328		0
52574	3114	4237458	1961-02-01	1961-02-01 00:00:00	1961-05-02	1961-05-02 00:00:00	32020		\N	207115	0	58150001	4237458		0
52682	3119	260139	2000-02-02	2000-02-02 00:00:00	2000-02-16	2000-02-16 00:00:00	32020		\N	207588	0	10509002	260139		0
52889	3133	40481087	1965-10-10	1965-10-10 00:00:00	1965-10-24	1965-10-24 00:00:00	32020		\N	208444	0	444814009	40481087		0
53043	3141	378001	2012-08-26	2012-08-26 00:00:00	2012-09-25	2012-09-25 00:00:00	32020		\N	208991	0	62106007	378001		0
42522	2535	4112343	1961-10-29	1961-10-29 00:00:00	1961-11-10	1961-11-10 00:00:00	32020		\N	167488	0	195662009	4112343		0
42759	2548	40481087	1966-05-07	1966-05-07 00:00:00	1966-05-28	1966-05-28 00:00:00	32020		\N	168679	0	444814009	40481087		0
42885	2554	4112343	2007-01-28	2007-01-28 00:00:00	2007-02-09	2007-02-09 00:00:00	32020		\N	169223	0	195662009	4112343		0
43021	2561	4112343	2007-12-15	2007-12-15 00:00:00	2007-12-25	2007-12-25 00:00:00	32020		\N	169725	0	195662009	4112343		0
32609	1936	28060	1949-07-12	1949-07-12 00:00:00	1949-07-24	1949-07-24 00:00:00	32020		\N	128810	0	43878008	28060		0
43390	2583	4112343	1978-02-28	1978-02-28 00:00:00	1978-03-13	1978-03-13 00:00:00	32020		\N	171025	0	195662009	4112343		0
32983	1956	40481087	1985-07-08	1985-07-08 00:00:00	1985-07-29	1985-07-29 00:00:00	32020		\N	130151	0	444814009	40481087		0
33195	1971	372328	1973-09-14	1973-09-14 00:00:00	1974-02-22	1974-02-22 00:00:00	32020		\N	131030	0	65363002	372328		0
33329	1977	260139	1922-01-10	1922-01-10 00:00:00	1922-01-24	1922-01-24 00:00:00	32020		\N	131505	0	10509002	260139		0
44025	2619	372328	1945-10-24	1945-10-24 00:00:00	1946-10-11	1946-10-11 00:00:00	32020		\N	173217	0	65363002	372328		0
33682	1998	4112343	1998-10-30	1998-10-30 00:00:00	1998-11-06	1998-11-06 00:00:00	32020		\N	133035	0	195662009	4112343		0
33810	2006	40481087	1959-10-22	1959-10-22 00:00:00	1959-11-05	1959-11-05 00:00:00	32020		\N	133547	0	444814009	40481087		0
44533	2649	260139	2017-06-15	2017-06-15 00:00:00	2017-06-22	2017-06-22 00:00:00	32020		\N	175275	0	10509002	260139		0
44667	2657	372328	2011-07-11	2011-07-11 00:00:00	2012-06-30	2012-06-30 00:00:00	32020		\N	175939	0	65363002	372328		0
44850	2669	4294548	1978-08-05	1978-08-05 00:00:00	1978-10-21	1978-10-21 00:00:00	32020		\N	176818	0	75498004	4294548		0
45042	2680	372328	1974-01-28	1974-01-28 00:00:00	1974-02-11	1974-02-11 00:00:00	32020		\N	177545	0	65363002	372328		0
34619	2054	4278672	2019-06-26	2019-06-26 00:00:00	\N	\N	32020		\N	136591	0	65966004	4278672		0
45394	2699	81151	1973-08-03	1973-08-03 00:00:00	1973-08-17	1973-08-17 00:00:00	32020		\N	178714	0	44465007	81151		0
45515	2705	40481087	1963-07-19	1963-07-19 00:00:00	1963-08-02	1963-08-02 00:00:00	32020		\N	179220	0	444814009	40481087		0
35171	2087	81151	1974-03-04	1974-03-04 00:00:00	1974-03-18	1974-03-18 00:00:00	32020		\N	139101	0	44465007	81151		0
35302	2091	260139	1967-12-31	1967-12-31 00:00:00	1968-01-07	1968-01-07 00:00:00	32020		\N	139441	0	10509002	260139		0
46050	2743	30753	1991-12-20	1991-12-20 00:00:00	\N	\N	32020		\N	181483	0	16761005	30753		0
46164	2750	4112343	1999-02-05	1999-02-05 00:00:00	1999-02-17	1999-02-17 00:00:00	32020		\N	181957	0	195662009	4112343		0
35839	2123	260139	1954-03-28	1954-03-28 00:00:00	1954-04-11	1954-04-11 00:00:00	32020		\N	141294	0	10509002	260139		0
35972	2133	40481087	2016-04-27	2016-04-27 00:00:00	2016-05-18	2016-05-18 00:00:00	32020		\N	141930	0	444814009	40481087		0
46672	2777	80180	1999-11-07	1999-11-07 00:00:00	\N	\N	32020		\N	183936	0	396275006	80180		0
36344	2152	40481087	2012-10-10	2012-10-10 00:00:00	2012-10-17	2012-10-17 00:00:00	32020		\N	143368	0	444814009	40481087		0
47036	2798	4112343	1958-10-16	1958-10-16 00:00:00	1958-10-23	1958-10-23 00:00:00	32020		\N	185455	0	195662009	4112343		0
47156	2804	378001	1966-04-08	1966-04-08 00:00:00	1966-06-07	1966-06-07 00:00:00	32020		\N	185849	0	62106007	378001		0
47314	2815	40481087	1977-06-10	1977-06-10 00:00:00	1977-07-01	1977-07-01 00:00:00	32020		\N	186540	0	444814009	40481087		0
37015	2191	81893	2010-04-04	2010-04-04 00:00:00	\N	\N	32020		\N	146131	0	64766004	81893		0
37135	2199	4112343	1993-09-05	1993-09-05 00:00:00	1993-09-12	1993-09-12 00:00:00	32020		\N	146569	0	195662009	4112343		0
37336	2211	4112343	1981-05-30	1981-05-30 00:00:00	1981-06-06	1981-06-06 00:00:00	32020		\N	147321	0	195662009	4112343		0
48014	2849	4134304	1987-09-25	1987-09-25 00:00:00	1987-12-24	1987-12-24 00:00:00	32020		\N	189295	0	263102004	4134304		0
37636	2231	80180	2008-07-18	2008-07-18 00:00:00	\N	\N	32020		\N	148452	0	396275006	80180		0
37769	2238	4296204	1989-01-16	1989-01-16 00:00:00	1989-02-20	1989-02-20 00:00:00	32020		\N	148927	0	403190006	4296204		0
48518	2872	4329847	1999-08-17	1999-08-17 00:00:00	\N	\N	32020		\N	191227	0	22298006	4329847		0
48716	2886	4059173	1963-06-06	1963-06-06 00:00:00	1963-08-05	1963-08-05 00:00:00	32020		\N	191967	0	16114001	4059173		0
48811	2892	40481087	1985-12-08	1985-12-08 00:00:00	1985-12-15	1985-12-15 00:00:00	32020		\N	192401	0	444814009	40481087		0
49055	2903	4116491	2009-11-15	2009-11-15 00:00:00	2009-12-30	2009-12-30 00:00:00	32020		\N	193441	0	301011002	4116491		0
49196	2909	4283893	1960-04-12	1960-04-12 00:00:00	1960-07-05	1960-07-05 00:00:00	32020		\N	193893	0	36971009	4283893		0
49344	2917	4112343	2012-01-08	2012-01-08 00:00:00	2012-01-20	2012-01-20 00:00:00	32020		\N	194499	0	195662009	4112343		0
49483	2926	80180	2017-10-29	2017-10-29 00:00:00	\N	\N	32020		\N	195177	0	396275006	80180		0
49693	2939	4112343	2010-01-22	2010-01-22 00:00:00	2010-02-04	2010-02-04 00:00:00	32020		\N	196000	0	195662009	4112343		0
39262	2329	40481087	1977-10-12	1977-10-12 00:00:00	1977-10-26	1977-10-26 00:00:00	32020		\N	154923	0	444814009	40481087		0
49982	2953	28060	2012-08-10	2012-08-10 00:00:00	2012-08-20	2012-08-20 00:00:00	32020		\N	197110	0	43878008	28060		0
39609	2346	40481087	1968-02-16	1968-02-16 00:00:00	1968-03-01	1968-03-01 00:00:00	32020		\N	156127	0	444814009	40481087		0
39837	2358	30753	2006-12-21	2006-12-21 00:00:00	\N	\N	32020		\N	157152	0	16761005	30753		0
50480	2986	4294548	2017-12-05	2017-12-05 00:00:00	2018-04-24	2018-04-24 00:00:00	32020		\N	199273	0	75498004	4294548		0
40142	2381	81151	1987-07-13	1987-07-13 00:00:00	1987-08-10	1987-08-10 00:00:00	32020		\N	158243	0	44465007	81151		0
40319	2392	80180	1948-05-16	1948-05-16 00:00:00	\N	\N	32020		\N	159019	0	396275006	80180		0
40441	2402	4048171	1978-09-20	1978-09-20 00:00:00	\N	\N	32020		\N	159573	0	232353008	4048171		0
51180	3030	80180	2018-07-25	2018-07-25 00:00:00	\N	\N	32020		\N	202000	0	396275006	80180		0
40836	2428	4294548	1987-06-06	1987-06-06 00:00:00	1987-06-13	1987-06-13 00:00:00	32020		\N	161094	0	75498004	4294548		0
40996	2437	4266809	1998-10-17	1998-10-17 00:00:00	\N	\N	32020		\N	161699	0	397881000	4266809		0
51714	3067	40481087	2019-04-22	2019-04-22 00:00:00	2019-05-06	2019-05-06 00:00:00	32020		\N	204105	0	444814009	40481087		0
51829	3072	80180	2003-05-23	2003-05-23 00:00:00	\N	\N	32020		\N	204443	0	396275006	80180		0
51975	3080	4112343	1978-12-08	1978-12-08 00:00:00	1978-12-17	1978-12-17 00:00:00	32020		\N	205015	0	195662009	4112343		0
52134	3087	257012	1943-03-27	1943-03-27 00:00:00	\N	\N	32020		\N	205559	0	40055000	257012		0
41791	2485	81151	1983-12-22	1983-12-22 00:00:00	1984-01-12	1984-01-12 00:00:00	32020		\N	164620	0	44465007	81151		0
52575	3114	4112343	1958-04-03	1958-04-03 00:00:00	1958-04-15	1958-04-15 00:00:00	32020		\N	207143	0	195662009	4112343		0
52683	3119	4027663	2005-06-09	2005-06-09 00:00:00	\N	\N	32020		\N	207555	0	13200003	4027663		0
52890	3133	40481087	1981-02-01	1981-02-01 00:00:00	1981-02-08	1981-02-08 00:00:00	32020		\N	208469	0	444814009	40481087		0
53044	3141	4112343	2014-11-03	2014-11-03 00:00:00	2014-11-12	2014-11-12 00:00:00	32020		\N	209002	0	195662009	4112343		0
42523	2535	40481087	1978-06-10	1978-06-10 00:00:00	1978-06-17	1978-06-17 00:00:00	32020		\N	167536	0	444814009	40481087		0
42760	2548	4112343	2014-03-31	2014-03-31 00:00:00	2014-04-09	2014-04-09 00:00:00	32020		\N	168732	0	195662009	4112343		0
42886	2554	4112343	1969-03-14	1969-03-14 00:00:00	1969-03-21	1969-03-21 00:00:00	32020		\N	169264	0	195662009	4112343		0
43022	2561	260139	2014-04-22	2014-04-22 00:00:00	2014-05-06	2014-05-06 00:00:00	32020		\N	169726	0	10509002	260139		0
32610	1936	40481087	1960-07-13	1960-07-13 00:00:00	1960-07-27	1960-07-27 00:00:00	32020		\N	128770	0	444814009	40481087		0
43391	2583	4294548	2018-07-23	2018-07-23 00:00:00	2018-08-27	2018-08-27 00:00:00	32020		\N	171035	0	75498004	4294548		0
32984	1956	4112343	1995-07-06	1995-07-06 00:00:00	1995-07-15	1995-07-15 00:00:00	32020		\N	130126	0	195662009	4112343		0
33196	1971	372328	1972-04-27	1972-04-27 00:00:00	1972-08-18	1972-08-18 00:00:00	32020		\N	131114	0	65363002	372328		0
33330	1977	40481087	1936-02-02	1936-02-02 00:00:00	1936-02-16	1936-02-16 00:00:00	32020		\N	131648	0	444814009	40481087		0
44026	2619	40481087	1997-05-01	1997-05-01 00:00:00	1997-05-15	1997-05-15 00:00:00	32020		\N	173215	0	444814009	40481087		0
33683	1998	4112343	2014-08-17	2014-08-17 00:00:00	2014-08-28	2014-08-28 00:00:00	32020		\N	133019	0	195662009	4112343		0
33811	2006	81151	2006-06-05	2006-06-05 00:00:00	2006-07-03	2006-07-03 00:00:00	32020		\N	133604	0	44465007	81151		0
44534	2649	4112343	1960-06-19	1960-06-19 00:00:00	1960-06-29	1960-06-29 00:00:00	32020		\N	175297	0	195662009	4112343		0
44668	2657	4112343	1980-02-22	1980-02-22 00:00:00	1980-03-01	1980-03-01 00:00:00	32020		\N	175953	0	195662009	4112343		0
44851	2669	260139	1982-09-17	1982-09-17 00:00:00	1982-10-01	1982-10-01 00:00:00	32020		\N	176786	0	10509002	260139		0
45043	2680	372328	1996-05-16	1996-05-16 00:00:00	1996-10-24	1996-10-24 00:00:00	32020		\N	177579	0	65363002	372328		0
34620	2054	40481087	2012-09-25	2012-09-25 00:00:00	2012-10-02	2012-10-02 00:00:00	32020		\N	136577	0	444814009	40481087		0
45395	2699	81151	1978-07-13	1978-07-13 00:00:00	1978-08-17	1978-08-17 00:00:00	32020		\N	178711	0	44465007	81151		0
45516	2705	4155034	2013-03-20	2013-03-20 00:00:00	2013-04-03	2013-04-03 00:00:00	32020		\N	179246	0	283371005	4155034		0
35172	2087	4112343	1965-03-07	1965-03-07 00:00:00	1965-03-16	1965-03-16 00:00:00	32020		\N	139086	0	195662009	4112343		0
35303	2091	40481087	1994-06-26	1994-06-26 00:00:00	1994-07-17	1994-07-17 00:00:00	32020		\N	139434	0	444814009	40481087		0
46051	2743	372328	1964-02-15	1964-02-15 00:00:00	1964-02-29	1964-02-29 00:00:00	32020		\N	181442	0	65363002	372328		0
46165	2750	4112343	1959-07-16	1959-07-16 00:00:00	1959-07-25	1959-07-25 00:00:00	32020		\N	181945	0	195662009	4112343		0
35840	2123	260139	1961-06-06	1961-06-06 00:00:00	1961-06-13	1961-06-13 00:00:00	32020		\N	141251	0	10509002	260139		0
35973	2133	40481087	1966-01-10	1966-01-10 00:00:00	1966-01-31	1966-01-31 00:00:00	32020		\N	141895	0	444814009	40481087		0
46673	2777	4155034	1999-05-03	1999-05-03 00:00:00	1999-05-17	1999-05-17 00:00:00	32020		\N	183936	0	283371005	4155034		0
36345	2152	4112343	1991-07-07	1991-07-07 00:00:00	1991-07-16	1991-07-16 00:00:00	32020		\N	143438	0	195662009	4112343		0
47037	2798	260139	1973-03-21	1973-03-21 00:00:00	1973-04-04	1973-04-04 00:00:00	32020		\N	185459	0	10509002	260139		0
47157	2804	4109685	1965-02-28	1965-02-28 00:00:00	1965-03-14	1965-03-14 00:00:00	32020		\N	185848	0	284551006	4109685		0
47315	2815	4112343	1994-01-24	1994-01-24 00:00:00	1994-02-06	1994-02-06 00:00:00	32020		\N	186493	0	195662009	4112343		0
37016	2191	40481087	2009-08-24	2009-08-24 00:00:00	2009-09-14	2009-09-14 00:00:00	32020		\N	146131	0	444814009	40481087		0
37136	2199	40481087	2018-05-08	2018-05-08 00:00:00	2018-05-22	2018-05-22 00:00:00	32020		\N	146561	0	444814009	40481087		0
37337	2211	40481087	2010-05-15	2010-05-15 00:00:00	2010-05-22	2010-05-22 00:00:00	32020		\N	147330	0	444814009	40481087		0
48015	2849	4134304	1964-05-14	1964-05-14 00:00:00	1964-06-13	1964-06-13 00:00:00	32020		\N	189293	0	263102004	4134304		0
37637	2232	260139	2009-08-29	2009-08-29 00:00:00	2009-09-05	2009-09-05 00:00:00	32020		\N	148522	0	10509002	260139		0
37770	2238	4112343	1993-01-28	1993-01-28 00:00:00	1993-02-04	1993-02-04 00:00:00	32020		\N	148921	0	195662009	4112343		0
48520	2872	4112343	1990-11-05	1990-11-05 00:00:00	1990-11-16	1990-11-16 00:00:00	32020		\N	191220	0	195662009	4112343		0
48717	2886	4112343	1959-12-28	1959-12-28 00:00:00	1960-01-06	1960-01-06 00:00:00	32020		\N	191955	0	195662009	4112343		0
48812	2892	260139	1978-06-10	1978-06-10 00:00:00	1978-06-17	1978-06-17 00:00:00	32020		\N	192419	0	10509002	260139		0
49056	2903	4112343	1990-09-19	1990-09-19 00:00:00	1990-09-27	1990-09-27 00:00:00	32020		\N	193411	0	195662009	4112343		0
49197	2909	78272	1967-01-15	1967-01-15 00:00:00	1967-02-19	1967-02-19 00:00:00	32020		\N	193911	0	70704007	78272		0
49345	2917	4112343	1971-03-06	1971-03-06 00:00:00	1971-03-18	1971-03-18 00:00:00	32020		\N	194456	0	195662009	4112343		0
49484	2926	4266809	2017-10-29	2017-10-29 00:00:00	\N	\N	32020		\N	195177	0	397881000	4266809		0
49694	2939	4112343	1958-03-28	1958-03-28 00:00:00	1958-04-05	1958-04-05 00:00:00	32020		\N	195939	0	195662009	4112343		0
39263	2329	372328	1976-08-06	1976-08-06 00:00:00	1976-12-28	1976-12-28 00:00:00	32020		\N	154927	0	65363002	372328		0
49983	2953	4059173	1984-11-01	1984-11-01 00:00:00	1984-12-31	1984-12-31 00:00:00	32020		\N	197111	0	16114001	4059173		0
39610	2346	81893	1985-04-22	1985-04-22 00:00:00	\N	\N	32020		\N	156208	0	64766004	81893		0
39838	2358	80180	2007-09-17	2007-09-17 00:00:00	\N	\N	32020		\N	157152	0	396275006	80180		0
50481	2986	4294548	2017-07-24	2017-07-24 00:00:00	2017-08-28	2017-08-28 00:00:00	32020		\N	199331	0	75498004	4294548		0
40143	2381	4294548	2012-11-20	2012-11-20 00:00:00	\N	\N	32020		\N	158301	0	75498004	4294548		0
40320	2392	40481087	1947-07-27	1947-07-27 00:00:00	1947-08-10	1947-08-10 00:00:00	32020		\N	159019	0	444814009	40481087		0
40442	2402	40481087	2016-04-09	2016-04-09 00:00:00	2016-04-16	2016-04-16 00:00:00	32020		\N	159639	0	444814009	40481087		0
51181	3030	4113008	1995-12-31	1995-12-31 00:00:00	1996-01-14	1996-01-14 00:00:00	32020		\N	202023	0	284549007	4113008		0
51295	3041	4112343	1983-10-02	1983-10-02 00:00:00	1983-10-11	1983-10-11 00:00:00	32020		\N	202528	0	195662009	4112343		0
40997	2437	80180	1998-10-17	1998-10-17 00:00:00	\N	\N	32020		\N	161699	0	396275006	80180		0
51715	3067	321042	1960-12-20	1960-12-20 00:00:00	\N	\N	32020		\N	204175	0	410429000	321042		0
51830	3072	4112343	1969-12-09	1969-12-09 00:00:00	1969-12-17	1969-12-17 00:00:00	32020		\N	204485	0	195662009	4112343		0
51976	3080	40481087	2007-05-12	2007-05-12 00:00:00	2007-06-02	2007-06-02 00:00:00	32020		\N	204992	0	444814009	40481087		0
52135	3087	28060	1943-05-05	1943-05-05 00:00:00	1943-05-16	1943-05-16 00:00:00	32020		\N	205560	0	43878008	28060		0
41792	2485	40481087	1971-08-31	1971-08-31 00:00:00	1971-09-07	1971-09-07 00:00:00	32020		\N	164572	0	444814009	40481087		0
52576	3114	4112343	1960-02-07	1960-02-07 00:00:00	1960-02-17	1960-02-17 00:00:00	32020		\N	207144	0	195662009	4112343		0
52684	3119	40481087	1981-08-14	1981-08-14 00:00:00	1981-08-21	1981-08-21 00:00:00	32020		\N	207575	0	444814009	40481087		0
52891	3133	4112343	1965-10-19	1965-10-19 00:00:00	1965-11-01	1965-11-01 00:00:00	32020		\N	208520	0	195662009	4112343		0
53045	3141	440448	1978-02-06	1978-02-06 00:00:00	\N	\N	32020		\N	208987	0	74400008	440448		0
42524	2535	80180	1999-03-13	1999-03-13 00:00:00	\N	\N	32020		\N	167496	0	396275006	80180		0
42761	2548	260139	1985-04-29	1985-04-29 00:00:00	1985-05-13	1985-05-13 00:00:00	32020		\N	168682	0	10509002	260139		0
42887	2554	260139	1933-12-26	1933-12-26 00:00:00	1934-01-02	1934-01-02 00:00:00	32020		\N	169260	0	10509002	260139		0
43023	2561	80180	2017-08-08	2017-08-08 00:00:00	\N	\N	32020		\N	169699	0	396275006	80180		0
32611	1936	372328	1950-05-06	1950-05-06 00:00:00	1950-07-28	1950-07-28 00:00:00	32020		\N	128774	0	65363002	372328		0
43392	2583	40481087	1995-04-04	1995-04-04 00:00:00	1995-04-18	1995-04-18 00:00:00	32020		\N	171034	0	444814009	40481087		0
32985	1956	260139	1967-03-07	1967-03-07 00:00:00	1967-03-21	1967-03-21 00:00:00	32020		\N	130175	0	10509002	260139		0
33197	1971	372328	1973-01-15	1973-01-15 00:00:00	1973-02-16	1973-02-16 00:00:00	32020		\N	131115	0	65363002	372328		0
33331	1977	4109685	1990-11-12	1990-11-12 00:00:00	1990-12-03	1990-12-03 00:00:00	32020		\N	131624	0	284551006	4109685		0
44027	2619	317576	2004-10-22	2004-10-22 00:00:00	\N	\N	32020		\N	173248	0	53741008	317576		0
33684	1998	30753	2014-12-05	2014-12-05 00:00:00	\N	\N	32020		\N	133019	0	16761005	30753		0
33812	2006	260139	1959-11-28	1959-11-28 00:00:00	1959-12-05	1959-12-05 00:00:00	32020		\N	133639	0	10509002	260139		0
44535	2649	40481087	1984-02-10	1984-02-10 00:00:00	1984-02-24	1984-02-24 00:00:00	32020		\N	175332	0	444814009	40481087		0
44669	2657	40481087	2003-04-01	2003-04-01 00:00:00	2003-04-15	2003-04-15 00:00:00	32020		\N	175974	0	444814009	40481087		0
44852	2669	4218389	2018-03-08	2018-03-08 00:00:00	2018-04-12	2018-04-12 00:00:00	32020		\N	176763	0	39848009	4218389		0
45044	2680	4296204	2009-06-14	2009-06-14 00:00:00	2009-07-12	2009-07-12 00:00:00	32020		\N	177557	0	403190006	4296204		0
34621	2054	4156265	1985-05-11	1985-05-11 00:00:00	1985-05-25	1985-05-25 00:00:00	32020		\N	136572	0	370247008	4156265		0
45396	2699	4156265	1989-07-20	1989-07-20 00:00:00	1989-08-10	1989-08-10 00:00:00	32020		\N	178712	0	370247008	4156265		0
45517	2705	4218389	1965-09-27	1965-09-27 00:00:00	1965-10-25	1965-10-25 00:00:00	32020		\N	179242	0	39848009	4218389		0
35173	2087	4112343	1959-10-19	1959-10-19 00:00:00	1959-10-31	1959-10-31 00:00:00	32020		\N	139044	0	195662009	4112343		0
35304	2091	260139	1984-11-09	1984-11-09 00:00:00	1984-11-23	1984-11-23 00:00:00	32020		\N	139475	0	10509002	260139		0
46052	2743	4112343	1973-11-25	1973-11-25 00:00:00	1973-12-07	1973-12-07 00:00:00	32020		\N	181455	0	195662009	4112343		0
46166	2750	28060	1973-09-25	1973-09-25 00:00:00	1973-10-03	1973-10-03 00:00:00	32020		\N	181888	0	43878008	28060		0
35841	2123	4112343	1963-05-23	1963-05-23 00:00:00	1963-06-01	1963-06-01 00:00:00	32020		\N	141260	0	195662009	4112343		0
35974	2133	4112343	2014-02-10	2014-02-10 00:00:00	2014-02-19	2014-02-19 00:00:00	32020		\N	141937	0	195662009	4112343		0
46674	2777	260139	2004-05-02	2004-05-02 00:00:00	2004-05-09	2004-05-09 00:00:00	32020		\N	183951	0	10509002	260139		0
36346	2152	40481087	2016-11-15	2016-11-15 00:00:00	2016-12-06	2016-12-06 00:00:00	32020		\N	143371	0	444814009	40481087		0
47038	2798	257012	1960-10-05	1960-10-05 00:00:00	\N	\N	32020		\N	185457	0	40055000	257012		0
47158	2804	40481087	1964-01-10	1964-01-10 00:00:00	1964-01-17	1964-01-17 00:00:00	32020		\N	185890	0	444814009	40481087		0
47316	2815	4112343	1999-02-23	1999-02-23 00:00:00	1999-03-06	1999-03-06 00:00:00	32020		\N	186520	0	195662009	4112343		0
37017	2191	4112343	1995-03-31	1995-03-31 00:00:00	1995-04-11	1995-04-11 00:00:00	32020		\N	146130	0	195662009	4112343		0
37137	2199	4283893	2015-09-05	2015-09-05 00:00:00	2015-11-14	2015-11-14 00:00:00	32020		\N	146548	0	36971009	4283893		0
37338	2211	4283893	2013-06-06	2013-06-06 00:00:00	2013-09-05	2013-09-05 00:00:00	32020		\N	147343	0	36971009	4283893		0
48016	2849	40481087	2000-05-27	2000-05-27 00:00:00	2000-06-17	2000-06-17 00:00:00	32020		\N	189271	0	444814009	40481087		0
37638	2232	4296204	1968-02-13	1968-02-13 00:00:00	1968-03-05	1968-03-05 00:00:00	32020		\N	148473	0	403190006	4296204		0
37771	2238	4296204	2009-04-18	2009-04-18 00:00:00	2009-05-02	2009-05-02 00:00:00	32020		\N	148930	0	403190006	4296204		0
48521	2872	4113008	1954-10-27	1954-10-27 00:00:00	1954-11-17	1954-11-17 00:00:00	32020		\N	191203	0	284549007	4113008		0
48718	2886	80180	1983-04-22	1983-04-22 00:00:00	\N	\N	32020		\N	191942	0	396275006	80180		0
48813	2892	4113008	2014-03-03	2014-03-03 00:00:00	2014-03-17	2014-03-17 00:00:00	32020		\N	192418	0	284549007	4113008		0
49057	2903	4112343	1978-02-11	1978-02-11 00:00:00	1978-02-22	1978-02-22 00:00:00	32020		\N	193465	0	195662009	4112343		0
49198	2909	80180	1986-09-03	1986-09-03 00:00:00	\N	\N	32020		\N	193924	0	396275006	80180		0
49346	2917	4146173	1952-07-10	1952-07-10 00:00:00	1952-09-08	1952-09-08 00:00:00	32020		\N	194435	0	307731004	4146173		0
49485	2926	195588	2000-09-13	2000-09-13 00:00:00	2000-10-28	2000-10-28 00:00:00	32020		\N	195198	0	38822007	195588		0
49695	2939	28060	1953-03-25	1953-03-25 00:00:00	1953-04-04	1953-04-04 00:00:00	32020		\N	195986	0	43878008	28060		0
39264	2329	4112343	2012-09-13	2012-09-13 00:00:00	2012-09-24	2012-09-24 00:00:00	32020		\N	154932	0	195662009	4112343		0
49984	2953	372328	1986-04-25	1986-04-25 00:00:00	1986-10-17	1986-10-17 00:00:00	32020		\N	197127	0	65363002	372328		0
39611	2346	30753	1985-09-19	1985-09-19 00:00:00	\N	\N	32020		\N	156208	0	16761005	30753		0
39839	2358	4283893	1987-11-21	1987-11-21 00:00:00	1988-01-23	1988-01-23 00:00:00	32020		\N	157150	0	36971009	4283893		0
50482	2986	40481087	1954-03-30	1954-03-30 00:00:00	1954-04-06	1954-04-06 00:00:00	32020		\N	199283	0	444814009	40481087		0
40144	2381	81151	1948-05-14	1948-05-14 00:00:00	1948-06-18	1948-06-18 00:00:00	32020		\N	158303	0	44465007	81151		0
40321	2392	4112343	1937-01-14	1937-01-14 00:00:00	1937-01-21	1937-01-21 00:00:00	32020		\N	159018	0	195662009	4112343		0
40443	2402	372328	1977-07-10	1977-07-10 00:00:00	1977-08-22	1977-08-22 00:00:00	32020		\N	159625	0	65363002	372328		0
51182	3030	4296204	1989-04-08	1989-04-08 00:00:00	1989-05-06	1989-05-06 00:00:00	32020		\N	202022	0	403190006	4296204		0
51296	3041	40481087	1980-10-18	1980-10-18 00:00:00	1980-11-01	1980-11-01 00:00:00	32020		\N	202446	0	444814009	40481087		0
40998	2437	81893	1997-07-24	1997-07-24 00:00:00	\N	\N	32020		\N	161674	0	64766004	81893		0
51717	3067	28060	1951-06-22	1951-06-22 00:00:00	1951-07-02	1951-07-02 00:00:00	32020		\N	204098	0	43878008	28060		0
51831	3072	40481087	2019-04-12	2019-04-12 00:00:00	2019-05-03	2019-05-03 00:00:00	32020		\N	204495	0	444814009	40481087		0
51977	3080	40481087	1946-02-03	1946-02-03 00:00:00	1946-02-10	1946-02-10 00:00:00	32020		\N	204985	0	444814009	40481087		0
52136	3087	40481087	1978-02-28	1978-02-28 00:00:00	1978-03-14	1978-03-14 00:00:00	32020		\N	205532	0	444814009	40481087		0
41793	2485	4112343	1940-02-10	1940-02-10 00:00:00	1940-02-20	1940-02-20 00:00:00	32020		\N	164595	0	195662009	4112343		0
52577	3114	40481087	1957-11-02	1957-11-02 00:00:00	1957-11-23	1957-11-23 00:00:00	32020		\N	207110	0	444814009	40481087		0
52685	3119	4156265	1982-01-05	1982-01-05 00:00:00	1982-01-19	1982-01-19 00:00:00	32020		\N	207535	0	370247008	4156265		0
52892	3133	4310024	1987-08-13	1987-08-13 00:00:00	\N	\N	32020		\N	208470	0	424802006	4310024		0
53046	3141	4166224	1978-02-06	1978-02-06 00:00:00	\N	\N	32020		\N	208987	0	47693006	4166224		0
42525	2535	381316	2000-08-27	2000-08-27 00:00:00	\N	\N	32020		\N	167496	0	230690007	381316		0
42762	2548	4112343	2011-08-02	2011-08-02 00:00:00	2011-08-10	2011-08-10 00:00:00	32020		\N	168711	0	195662009	4112343		0
42888	2554	317576	1999-12-02	1999-12-02 00:00:00	\N	\N	32020		\N	169105	0	53741008	317576		0
43024	2561	30753	2017-02-09	2017-02-09 00:00:00	\N	\N	32020		\N	169699	0	16761005	30753		0
32612	1936	439777	2007-02-06	2007-02-06 00:00:00	\N	\N	32020		\N	128829	0	271737000	439777		0
43405	2586	78272	1979-01-04	1979-01-04 00:00:00	1979-01-18	1979-01-18 00:00:00	32020		\N	171221	0	70704007	78272		0
32986	1956	78272	1975-01-23	1975-01-23 00:00:00	1975-02-13	1975-02-13 00:00:00	32020		\N	130149	0	70704007	78272		0
33198	1971	30753	2011-01-23	2011-01-23 00:00:00	\N	\N	32020		\N	131013	0	16761005	30753		0
33332	1977	81151	1938-03-15	1938-03-15 00:00:00	1938-04-19	1938-04-19 00:00:00	32020		\N	131623	0	44465007	81151		0
44028	2619	372328	1941-01-29	1941-01-29 00:00:00	1941-04-18	1941-04-18 00:00:00	32020		\N	173169	0	65363002	372328		0
33685	1999	40481087	2019-02-08	2019-02-08 00:00:00	2019-02-22	2019-02-22 00:00:00	32020		\N	133139	0	444814009	40481087		0
33813	2006	4294548	1979-10-29	1979-10-29 00:00:00	1979-11-26	1979-11-26 00:00:00	32020		\N	133641	0	75498004	4294548		0
44536	2649	40481087	1958-07-28	1958-07-28 00:00:00	1958-08-18	1958-08-18 00:00:00	32020		\N	175331	0	444814009	40481087		0
44670	2657	28060	1989-08-15	1989-08-15 00:00:00	1989-08-23	1989-08-23 00:00:00	32020		\N	175973	0	43878008	28060		0
44853	2669	260139	2010-03-19	2010-03-19 00:00:00	2010-03-26	2010-03-26 00:00:00	32020		\N	176803	0	10509002	260139		0
45045	2680	260139	1981-04-09	1981-04-09 00:00:00	1981-04-23	1981-04-23 00:00:00	32020		\N	177516	0	10509002	260139		0
34624	2056	40481087	1988-10-02	1988-10-02 00:00:00	1988-10-09	1988-10-09 00:00:00	32020		\N	136708	0	444814009	40481087		0
45397	2699	28060	2007-01-08	2007-01-08 00:00:00	2007-01-15	2007-01-15 00:00:00	32020		\N	178720	0	43878008	28060		0
45518	2705	40481087	1974-03-13	1974-03-13 00:00:00	1974-04-03	1974-04-03 00:00:00	32020		\N	179195	0	444814009	40481087		0
35174	2087	260139	2004-01-20	2004-01-20 00:00:00	2004-02-03	2004-02-03 00:00:00	32020		\N	139049	0	10509002	260139		0
35305	2091	372328	2004-01-01	2004-01-01 00:00:00	2005-07-09	2005-07-09 00:00:00	32020		\N	139445	0	65363002	372328		0
46053	2743	4266809	1992-02-18	1992-02-18 00:00:00	\N	\N	32020		\N	181483	0	397881000	4266809		0
46167	2750	4112343	1978-11-07	1978-11-07 00:00:00	1978-11-20	1978-11-20 00:00:00	32020		\N	181932	0	195662009	4112343		0
35842	2123	4296204	1984-06-17	1984-06-17 00:00:00	1984-07-15	1984-07-15 00:00:00	32020		\N	141318	0	403190006	4296204		0
35975	2133	372328	1970-09-09	1970-09-09 00:00:00	1971-05-24	1971-05-24 00:00:00	32020		\N	141917	0	65363002	372328		0
46675	2777	257012	1978-02-28	1978-02-28 00:00:00	1978-03-07	1978-03-07 00:00:00	32020		\N	183939	0	40055000	257012		0
36347	2152	4112343	2016-02-29	2016-02-29 00:00:00	2016-03-08	2016-03-08 00:00:00	32020		\N	143369	0	195662009	4112343		0
47039	2798	4116491	1999-11-09	1999-11-09 00:00:00	1999-12-26	1999-12-26 00:00:00	32020		\N	185464	0	301011002	4116491		0
47159	2804	4112343	2010-05-28	2010-05-28 00:00:00	2010-06-07	2010-06-07 00:00:00	32020		\N	185859	0	195662009	4112343		0
47317	2815	260139	1993-06-12	1993-06-12 00:00:00	1993-06-26	1993-06-26 00:00:00	32020		\N	186550	0	10509002	260139		0
37018	2191	40481087	2008-02-18	2008-02-18 00:00:00	2008-02-25	2008-02-25 00:00:00	32020		\N	146119	0	444814009	40481087		0
37139	2199	4266809	2016-10-30	2016-10-30 00:00:00	\N	\N	32020		\N	146587	0	397881000	4266809		0
37339	2211	260139	1984-03-15	1984-03-15 00:00:00	1984-03-22	1984-03-22 00:00:00	32020		\N	147323	0	10509002	260139		0
48017	2849	260139	1972-12-13	1972-12-13 00:00:00	1972-12-20	1972-12-20 00:00:00	32020		\N	189205	0	10509002	260139		0
37639	2232	260139	1979-03-18	1979-03-18 00:00:00	1979-03-25	1979-03-25 00:00:00	32020		\N	148505	0	10509002	260139		0
37772	2238	40481087	2018-12-28	2018-12-28 00:00:00	2019-01-04	2019-01-04 00:00:00	32020		\N	149023	0	444814009	40481087		0
48522	2872	4112343	1968-04-15	1968-04-15 00:00:00	1968-04-23	1968-04-23 00:00:00	32020		\N	191217	0	195662009	4112343		0
48719	2886	40481087	1999-02-27	1999-02-27 00:00:00	1999-03-06	1999-03-06 00:00:00	32020		\N	191916	0	444814009	40481087		0
48814	2892	372328	1974-01-22	1974-01-22 00:00:00	1974-03-08	1974-03-08 00:00:00	32020		\N	192399	0	65363002	372328		0
49058	2903	4116491	2004-10-13	2004-10-13 00:00:00	2004-11-16	2004-11-16 00:00:00	32020		\N	193468	0	301011002	4116491		0
49199	2909	192671	1986-09-22	1986-09-22 00:00:00	\N	\N	32020		\N	193907	0	K92.2	35208414		0
49347	2917	40481087	1991-08-20	1991-08-20 00:00:00	1991-08-27	1991-08-27 00:00:00	32020		\N	194457	0	444814009	40481087		0
49486	2926	40481087	1989-08-15	1989-08-15 00:00:00	1989-08-29	1989-08-29 00:00:00	32020		\N	195196	0	444814009	40481087		0
49696	2939	4112343	1985-06-21	1985-06-21 00:00:00	1985-06-30	1985-06-30 00:00:00	32020		\N	195951	0	195662009	4112343		0
39265	2329	4112343	1978-04-23	1978-04-23 00:00:00	1978-05-03	1978-05-03 00:00:00	32020		\N	154929	0	195662009	4112343		0
49985	2953	40481087	1988-08-14	1988-08-14 00:00:00	1988-08-21	1988-08-21 00:00:00	32020		\N	197123	0	444814009	40481087		0
39612	2346	4112343	1953-07-12	1953-07-12 00:00:00	1953-07-25	1953-07-25 00:00:00	32020		\N	156166	0	195662009	4112343		0
39840	2358	40481087	1999-01-02	1999-01-02 00:00:00	1999-01-09	1999-01-09 00:00:00	32020		\N	157109	0	444814009	40481087		0
50483	2986	40481087	1966-01-10	1966-01-10 00:00:00	1966-01-17	1966-01-17 00:00:00	32020		\N	199328	0	444814009	40481087		0
40145	2381	4112343	2004-01-12	2004-01-12 00:00:00	2004-01-24	2004-01-24 00:00:00	32020		\N	158299	0	195662009	4112343		0
40322	2392	439777	1939-01-29	1939-01-29 00:00:00	\N	\N	32020		\N	159038	0	271737000	439777		0
40444	2402	40481087	2014-05-30	2014-05-30 00:00:00	2014-06-13	2014-06-13 00:00:00	32020		\N	159664	0	444814009	40481087		0
51183	3030	375671	2002-01-26	2002-01-26 00:00:00	2002-02-25	2002-02-25 00:00:00	32020		\N	202026	0	62564004	375671		0
51297	3041	40481087	1988-08-28	1988-08-28 00:00:00	1988-09-11	1988-09-11 00:00:00	32020		\N	202465	0	444814009	40481087		0
40999	2437	30753	1997-10-22	1997-10-22 00:00:00	\N	\N	32020		\N	161674	0	16761005	30753		0
51718	3067	372328	1945-09-02	1945-09-02 00:00:00	1945-12-04	1945-12-04 00:00:00	32020		\N	204198	0	65363002	372328		0
51832	3072	4156265	1975-10-22	1975-10-22 00:00:00	1975-11-12	1975-11-12 00:00:00	32020		\N	204460	0	370247008	4156265		0
51978	3080	4152936	1991-12-20	1991-12-20 00:00:00	1992-01-10	1992-01-10 00:00:00	32020		\N	204969	0	283385000	4152936		0
52137	3087	40481087	1943-09-08	1943-09-08 00:00:00	1943-09-15	1943-09-15 00:00:00	32020		\N	205524	0	444814009	40481087		0
41794	2485	40481087	2010-03-31	2010-03-31 00:00:00	2010-04-14	2010-04-14 00:00:00	32020		\N	164649	0	444814009	40481087		0
52578	3114	40481087	1950-05-08	1950-05-08 00:00:00	1950-05-15	1950-05-15 00:00:00	32020		\N	207119	0	444814009	40481087		0
52722	3123	40481087	2010-02-01	2010-02-01 00:00:00	2010-02-08	2010-02-08 00:00:00	32020		\N	207834	0	444814009	40481087		0
52893	3133	30753	1988-08-07	1988-08-07 00:00:00	\N	\N	32020		\N	208470	0	16761005	30753		0
53047	3141	4112343	2018-02-26	2018-02-26 00:00:00	2018-03-05	2018-03-05 00:00:00	32020		\N	208995	0	195662009	4112343		0
42526	2535	4112343	1998-12-26	1998-12-26 00:00:00	1999-01-08	1999-01-08 00:00:00	32020		\N	167496	0	195662009	4112343		0
42763	2548	40481087	1994-09-04	1994-09-04 00:00:00	1994-09-18	1994-09-18 00:00:00	32020		\N	168730	0	444814009	40481087		0
42889	2554	260139	1942-06-20	1942-06-20 00:00:00	1942-07-04	1942-07-04 00:00:00	32020		\N	169167	0	10509002	260139		0
43025	2561	4155034	1998-03-27	1998-03-27 00:00:00	1998-04-10	1998-04-10 00:00:00	32020		\N	169702	0	283371005	4155034		0
32613	1936	78272	2010-08-25	2010-08-25 00:00:00	2010-09-15	2010-09-15 00:00:00	32020		\N	128760	0	70704007	78272		0
43406	2586	28060	1972-09-09	1972-09-09 00:00:00	1972-09-21	1972-09-21 00:00:00	32020		\N	171206	0	43878008	28060		0
32987	1956	4155034	2002-07-21	2002-07-21 00:00:00	2002-08-11	2002-08-11 00:00:00	32020		\N	130150	0	283371005	4155034		0
33199	1971	81893	2010-07-27	2010-07-27 00:00:00	\N	\N	32020		\N	131013	0	64766004	81893		0
33333	1977	40481087	1944-08-11	1944-08-11 00:00:00	1944-08-18	1944-08-18 00:00:00	32020		\N	131558	0	444814009	40481087		0
44029	2619	4112343	2008-05-04	2008-05-04 00:00:00	2008-05-15	2008-05-15 00:00:00	32020		\N	173152	0	195662009	4112343		0
33686	1999	4296204	1996-11-12	1996-11-12 00:00:00	1996-12-17	1996-12-17 00:00:00	32020		\N	133058	0	403190006	4296204		0
33814	2006	40481087	1965-06-13	1965-06-13 00:00:00	1965-07-04	1965-07-04 00:00:00	32020		\N	133640	0	444814009	40481087		0
44547	2651	4296204	1972-11-03	1972-11-03 00:00:00	1972-11-17	1972-11-17 00:00:00	32020		\N	175420	0	403190006	4296204		0
44672	2657	321042	1970-09-05	1970-09-05 00:00:00	\N	\N	32020		\N	175949	0	410429000	321042		0
44854	2669	80180	2019-01-12	2019-01-12 00:00:00	\N	\N	32020		\N	176798	0	396275006	80180		0
45046	2680	4134304	1987-05-11	1987-05-11 00:00:00	1987-08-09	1987-08-09 00:00:00	32020		\N	177556	0	263102004	4134304		0
34625	2056	40481087	1977-09-11	1977-09-11 00:00:00	1977-10-02	1977-10-02 00:00:00	32020		\N	136707	0	444814009	40481087		0
45398	2699	40481087	1989-09-09	1989-09-09 00:00:00	1989-09-23	1989-09-23 00:00:00	32020		\N	178719	0	444814009	40481087		0
45519	2705	40481087	2006-09-11	2006-09-11 00:00:00	2006-09-25	2006-09-25 00:00:00	32020		\N	179181	0	444814009	40481087		0
35175	2087	4112343	1922-08-21	1922-08-21 00:00:00	1922-09-02	1922-09-02 00:00:00	32020		\N	139037	0	195662009	4112343		0
35306	2091	40481087	2016-02-09	2016-02-09 00:00:00	2016-02-23	2016-02-23 00:00:00	32020		\N	139438	0	444814009	40481087		0
46054	2743	4294548	2009-03-04	2009-03-04 00:00:00	2009-03-11	2009-03-11 00:00:00	32020		\N	181433	0	75498004	4294548		0
46168	2750	40481087	1972-01-13	1972-01-13 00:00:00	1972-02-03	1972-02-03 00:00:00	32020		\N	181884	0	444814009	40481087		0
35843	2123	260139	1988-12-21	1988-12-21 00:00:00	1989-01-04	1989-01-04 00:00:00	32020		\N	141310	0	10509002	260139		0
35976	2133	260139	2009-10-16	2009-10-16 00:00:00	2009-10-23	2009-10-23 00:00:00	32020		\N	141936	0	10509002	260139		0
46676	2777	260139	1975-06-04	1975-06-04 00:00:00	1975-06-11	1975-06-11 00:00:00	32020		\N	183948	0	10509002	260139		0
36348	2152	4112343	1959-06-18	1959-06-18 00:00:00	1959-06-25	1959-06-25 00:00:00	32020		\N	143435	0	195662009	4112343		0
47040	2798	40481087	1973-05-04	1973-05-04 00:00:00	1973-05-25	1973-05-25 00:00:00	32020		\N	185442	0	444814009	40481087		0
47160	2804	40479768	1983-04-09	1983-04-09 00:00:00	1983-05-16	1983-05-16 00:00:00	32020		\N	185851	0	444470001	40479768		0
47318	2815	40481087	1970-09-22	1970-09-22 00:00:00	1970-10-13	1970-10-13 00:00:00	32020		\N	186547	0	444814009	40481087		0
47486	2825	260139	2017-02-20	2017-02-20 00:00:00	2017-03-06	2017-03-06 00:00:00	32020		\N	187311	0	10509002	260139		0
37140	2199	80180	2016-10-30	2016-10-30 00:00:00	\N	\N	32020		\N	146587	0	396275006	80180		0
37340	2211	4134304	1997-02-03	1997-02-03 00:00:00	1997-03-05	1997-03-05 00:00:00	32020		\N	147320	0	263102004	4134304		0
48018	2849	40481087	1966-06-17	1966-06-17 00:00:00	1966-07-08	1966-07-08 00:00:00	32020		\N	189204	0	444814009	40481087		0
37640	2232	40481087	1971-03-07	1971-03-07 00:00:00	1971-03-21	1971-03-21 00:00:00	32020		\N	148504	0	444814009	40481087		0
37773	2238	80180	2002-07-17	2002-07-17 00:00:00	\N	\N	32020		\N	149020	0	396275006	80180		0
48523	2872	40481087	1959-02-04	1959-02-04 00:00:00	1959-02-25	1959-02-25 00:00:00	32020		\N	191179	0	444814009	40481087		0
48720	2886	4051466	1954-12-17	1954-12-17 00:00:00	1970-03-30	1970-03-30 00:00:00	32020		\N	191891	0	233678006	4051466		0
48815	2892	4113008	1990-12-22	1990-12-22 00:00:00	1991-01-12	1991-01-12 00:00:00	32020		\N	192416	0	284549007	4113008		0
49059	2903	40481087	2005-12-27	2005-12-27 00:00:00	2006-01-10	2006-01-10 00:00:00	32020		\N	193414	0	444814009	40481087		0
49200	2909	4116491	1963-02-21	1963-02-21 00:00:00	1963-04-06	1963-04-06 00:00:00	32020		\N	193894	0	301011002	4116491		0
49348	2917	40481087	1983-08-27	1983-08-27 00:00:00	1983-09-10	1983-09-10 00:00:00	32020		\N	194469	0	444814009	40481087		0
49487	2926	81151	2018-10-04	2018-10-04 00:00:00	2018-11-08	2018-11-08 00:00:00	32020		\N	195194	0	44465007	81151		0
49707	2942	4112343	1961-06-02	1961-06-02 00:00:00	1961-06-10	1961-06-10 00:00:00	32020		\N	196128	0	195662009	4112343		0
39266	2329	40481087	1979-12-21	1979-12-21 00:00:00	1980-01-04	1980-01-04 00:00:00	32020		\N	154924	0	444814009	40481087		0
49986	2953	40481087	1985-02-08	1985-02-08 00:00:00	1985-02-22	1985-02-22 00:00:00	32020		\N	197146	0	444814009	40481087		0
39613	2346	4112343	1959-09-05	1959-09-05 00:00:00	1959-09-14	1959-09-14 00:00:00	32020		\N	156167	0	195662009	4112343		0
50299	2975	260139	2017-09-23	2017-09-23 00:00:00	2017-10-07	2017-10-07 00:00:00	32020		\N	198583	0	10509002	260139		0
50484	2986	40481087	1972-04-04	1972-04-04 00:00:00	1972-04-18	1972-04-18 00:00:00	32020		\N	199348	0	444814009	40481087		0
40146	2381	260139	2003-10-29	2003-10-29 00:00:00	2003-11-12	2003-11-12 00:00:00	32020		\N	158349	0	10509002	260139		0
40323	2392	375671	2019-02-11	2019-02-11 00:00:00	2019-03-13	2019-03-13 00:00:00	32020		\N	159013	0	62564004	375671		0
40445	2402	372328	1978-03-20	1978-03-20 00:00:00	1978-08-21	1978-08-21 00:00:00	32020		\N	159679	0	65363002	372328		0
51184	3030	372328	1984-02-12	1984-02-12 00:00:00	1984-07-24	1984-07-24 00:00:00	32020		\N	201987	0	65363002	372328		0
51298	3041	4112343	1992-11-23	1992-11-23 00:00:00	1992-12-01	1992-12-01 00:00:00	32020		\N	202431	0	195662009	4112343		0
41000	2437	40481087	1973-01-25	1973-01-25 00:00:00	1973-02-08	1973-02-08 00:00:00	32020		\N	161654	0	444814009	40481087		0
51719	3067	81151	1943-02-01	1943-02-01 00:00:00	1943-03-01	1943-03-01 00:00:00	32020		\N	204173	0	44465007	81151		0
51836	3074	4112343	2009-05-30	2009-05-30 00:00:00	2009-06-08	2009-06-08 00:00:00	32020		\N	204582	0	195662009	4112343		0
51979	3080	40481087	1989-04-02	1989-04-02 00:00:00	1989-04-23	1989-04-23 00:00:00	32020		\N	204990	0	444814009	40481087		0
52138	3087	372328	1941-02-13	1941-02-13 00:00:00	1941-06-04	1941-06-04 00:00:00	32020		\N	205522	0	65363002	372328		0
41795	2486	4285898	2010-12-03	2010-12-03 00:00:00	\N	\N	32020		\N	164721	0	68496003	4285898		0
52723	3123	40481087	2004-04-04	2004-04-04 00:00:00	2004-04-25	2004-04-25 00:00:00	32020		\N	207795	0	444814009	40481087		0
52894	3133	4266809	1989-06-03	1989-06-03 00:00:00	\N	\N	32020		\N	208470	0	397881000	4266809		0
53048	3141	4112343	2010-11-13	2010-11-13 00:00:00	2010-11-23	2010-11-23 00:00:00	32020		\N	208981	0	195662009	4112343		0
42527	2535	260139	1998-10-26	1998-10-26 00:00:00	1998-11-02	1998-11-02 00:00:00	32020		\N	167495	0	10509002	260139		0
42764	2548	260139	1975-11-12	1975-11-12 00:00:00	1975-11-19	1975-11-19 00:00:00	32020		\N	168695	0	10509002	260139		0
42890	2554	257012	1957-12-07	1957-12-07 00:00:00	1978-10-31	1978-10-31 00:00:00	32020		\N	169094	0	40055000	257012		0
43033	2563	40481087	1985-03-28	1985-03-28 00:00:00	1985-04-11	1985-04-11 00:00:00	32020		\N	169805	0	444814009	40481087		0
32614	1936	40481087	2012-04-24	2012-04-24 00:00:00	2012-05-08	2012-05-08 00:00:00	32020		\N	128805	0	444814009	40481087		0
43407	2586	378001	2007-11-15	2007-11-15 00:00:00	2007-12-15	2007-12-15 00:00:00	32020		\N	171224	0	62106007	378001		0
32988	1956	260139	1996-04-23	1996-04-23 00:00:00	1996-05-07	1996-05-07 00:00:00	32020		\N	130142	0	10509002	260139		0
33200	1971	260139	1983-10-02	1983-10-02 00:00:00	1983-10-16	1983-10-16 00:00:00	32020		\N	131085	0	10509002	260139		0
33334	1977	372328	1911-11-02	1911-11-02 00:00:00	1912-01-18	1912-01-18 00:00:00	32020		\N	131547	0	65363002	372328		0
44030	2619	40481087	1976-06-18	1976-06-18 00:00:00	1976-07-09	1976-07-09 00:00:00	32020		\N	173214	0	444814009	40481087		0
33687	1999	4156265	2013-04-22	2013-04-22 00:00:00	2013-05-06	2013-05-06 00:00:00	32020		\N	133059	0	370247008	4156265		0
33815	2006	140673	2017-12-31	2017-12-31 00:00:00	\N	\N	32020		\N	133644	0	40930008	140673		0
44548	2651	4112343	1982-09-04	1982-09-04 00:00:00	1982-09-11	1982-09-11 00:00:00	32020		\N	175380	0	195662009	4112343		0
44673	2657	4112343	2002-02-25	2002-02-25 00:00:00	2002-03-05	2002-03-05 00:00:00	32020		\N	175955	0	195662009	4112343		0
44855	2669	81151	1979-10-24	1979-10-24 00:00:00	1979-11-28	1979-11-28 00:00:00	32020		\N	176762	0	44465007	81151		0
45047	2680	4112343	2013-07-02	2013-07-02 00:00:00	2013-07-11	2013-07-11 00:00:00	32020		\N	177564	0	195662009	4112343		0
34626	2056	40481087	1979-05-01	1979-05-01 00:00:00	1979-05-15	1979-05-15 00:00:00	32020		\N	136742	0	444814009	40481087		0
45428	2702	260139	1978-01-28	1978-01-28 00:00:00	1978-02-04	1978-02-04 00:00:00	32020		\N	178965	0	10509002	260139		0
45520	2705	80180	1978-03-13	1978-03-13 00:00:00	\N	\N	32020		\N	179210	0	396275006	80180		0
35176	2087	140673	1968-05-30	1968-05-30 00:00:00	\N	\N	32020		\N	139031	0	40930008	140673		0
35307	2091	260139	1995-12-27	1995-12-27 00:00:00	1996-01-10	1996-01-10 00:00:00	32020		\N	139476	0	10509002	260139		0
46067	2745	40481087	1985-02-11	1985-02-11 00:00:00	1985-02-18	1985-02-18 00:00:00	32020		\N	181563	0	444814009	40481087		0
46169	2750	40481087	1996-10-31	1996-10-31 00:00:00	1996-11-07	1996-11-07 00:00:00	32020		\N	181934	0	444814009	40481087		0
35844	2123	372328	1952-07-22	1952-07-22 00:00:00	1952-09-26	1952-09-26 00:00:00	32020		\N	141230	0	65363002	372328		0
35977	2133	40479422	1996-11-21	1996-11-21 00:00:00	1996-12-28	1996-12-28 00:00:00	32020		\N	141933	0	444448004	40479422		0
46677	2777	192671	1999-12-04	1999-12-04 00:00:00	\N	\N	32020		\N	183929	0	K92.2	35208414		0
36349	2152	28060	1949-07-14	1949-07-14 00:00:00	1949-07-25	1949-07-25 00:00:00	32020		\N	143449	0	43878008	28060		0
47041	2799	81893	2017-06-17	2017-06-17 00:00:00	\N	\N	32020		\N	185514	0	64766004	81893		0
47161	2804	4112343	1959-12-29	1959-12-29 00:00:00	1960-01-08	1960-01-08 00:00:00	32020		\N	185810	0	195662009	4112343		0
47319	2815	40481087	1968-06-22	1968-06-22 00:00:00	1968-06-29	1968-06-29 00:00:00	32020		\N	186515	0	444814009	40481087		0
47487	2825	78272	1931-01-22	1931-01-22 00:00:00	1931-02-26	1931-02-26 00:00:00	32020		\N	187259	0	70704007	78272		0
37141	2199	40481087	1998-12-14	1998-12-14 00:00:00	1998-12-28	1998-12-28 00:00:00	32020		\N	146557	0	444814009	40481087		0
37341	2211	40481087	1998-01-03	1998-01-03 00:00:00	1998-01-10	1998-01-10 00:00:00	32020		\N	147337	0	444814009	40481087		0
48019	2849	4059173	2017-10-17	2017-10-17 00:00:00	2018-01-15	2018-01-15 00:00:00	32020		\N	189298	0	16114001	4059173		0
37641	2232	260139	1999-07-18	1999-07-18 00:00:00	1999-08-01	1999-08-01 00:00:00	32020		\N	148521	0	10509002	260139		0
37774	2238	4051466	1971-08-11	1971-08-11 00:00:00	1987-11-15	1987-11-15 00:00:00	32020		\N	148888	0	233678006	4051466		0
48524	2872	40481087	1958-02-13	1958-02-13 00:00:00	1958-03-06	1958-03-06 00:00:00	32020		\N	191215	0	444814009	40481087		0
48721	2886	4112343	1991-12-06	1991-12-06 00:00:00	1991-12-15	1991-12-15 00:00:00	32020		\N	191970	0	195662009	4112343		0
48816	2892	40481087	2002-11-10	2002-11-10 00:00:00	2002-11-17	2002-11-17 00:00:00	32020		\N	192398	0	444814009	40481087		0
49060	2903	4112343	1971-07-07	1971-07-07 00:00:00	1971-07-14	1971-07-14 00:00:00	32020		\N	193408	0	195662009	4112343		0
49201	2909	258780	1969-04-13	1969-04-13 00:00:00	\N	\N	32020		\N	193872	0	185086009	258780		0
49349	2917	40481087	2003-12-27	2003-12-27 00:00:00	2004-01-10	2004-01-10 00:00:00	32020		\N	194497	0	444814009	40481087		0
49488	2926	40481087	2009-07-26	2009-07-26 00:00:00	2009-08-09	2009-08-09 00:00:00	32020		\N	195193	0	444814009	40481087		0
49708	2942	4112343	2012-10-18	2012-10-18 00:00:00	2012-10-30	2012-10-30 00:00:00	32020		\N	196222	0	195662009	4112343		0
39267	2329	372328	1973-12-27	1973-12-27 00:00:00	1974-06-18	1974-06-18 00:00:00	32020		\N	154941	0	65363002	372328		0
49987	2953	40481087	2017-03-18	2017-03-18 00:00:00	2017-03-25	2017-03-25 00:00:00	32020		\N	197148	0	444814009	40481087		0
39614	2346	40481087	2004-12-03	2004-12-03 00:00:00	2004-12-17	2004-12-17 00:00:00	32020		\N	156152	0	444814009	40481087		0
50301	2975	80180	1997-09-16	1997-09-16 00:00:00	\N	\N	32020		\N	198691	0	396275006	80180		0
50485	2986	260139	2018-06-05	2018-06-05 00:00:00	2018-06-19	2018-06-19 00:00:00	32020		\N	199336	0	10509002	260139		0
40147	2381	28060	1945-12-16	1945-12-16 00:00:00	1945-12-25	1945-12-25 00:00:00	32020		\N	158292	0	43878008	28060		0
40324	2392	4112343	2012-10-18	2012-10-18 00:00:00	2012-10-29	2012-10-29 00:00:00	32020		\N	159028	0	195662009	4112343		0
40446	2402	4112343	1984-02-19	1984-02-19 00:00:00	1984-03-03	1984-03-03 00:00:00	32020		\N	159616	0	195662009	4112343		0
51185	3030	4294548	2015-08-14	2015-08-14 00:00:00	2015-11-20	2015-11-20 00:00:00	32020		\N	202030	0	75498004	4294548		0
51299	3041	40481087	2017-04-22	2017-04-22 00:00:00	2017-05-13	2017-05-13 00:00:00	32020		\N	202509	0	444814009	40481087		0
41001	2437	81151	2018-04-04	2018-04-04 00:00:00	2018-05-02	2018-05-02 00:00:00	32020		\N	161670	0	44465007	81151		0
51720	3067	260139	1984-11-14	1984-11-14 00:00:00	1984-11-21	1984-11-21 00:00:00	32020		\N	204129	0	10509002	260139		0
51837	3074	40481087	1988-12-10	1988-12-10 00:00:00	1988-12-17	1988-12-17 00:00:00	32020		\N	204600	0	444814009	40481087		0
51980	3080	40481087	1995-01-28	1995-01-28 00:00:00	1995-02-11	1995-02-11 00:00:00	32020		\N	205017	0	444814009	40481087		0
52139	3087	4283893	1943-01-09	1943-01-09 00:00:00	1943-04-03	1943-04-03 00:00:00	32020		\N	205558	0	36971009	4283893		0
41796	2486	80180	2011-03-03	2011-03-03 00:00:00	\N	\N	32020		\N	164721	0	396275006	80180		0
52580	3114	4294548	1957-04-14	1957-04-14 00:00:00	1957-06-30	1957-06-30 00:00:00	32020		\N	207109	0	75498004	4294548		0
52724	3123	81151	1988-09-06	1988-09-06 00:00:00	1988-09-27	1988-09-27 00:00:00	32020		\N	207817	0	44465007	81151		0
52895	3133	4112343	1987-06-10	1987-06-10 00:00:00	1987-06-23	1987-06-23 00:00:00	32020		\N	208470	0	195662009	4112343		0
53049	3141	375671	1975-12-13	1975-12-13 00:00:00	1976-01-12	1976-01-12 00:00:00	32020		\N	208986	0	62564004	375671		0
42528	2535	40481087	2015-04-03	2015-04-03 00:00:00	2015-04-17	2015-04-17 00:00:00	32020		\N	167537	0	444814009	40481087		0
42765	2548	40481087	2007-08-14	2007-08-14 00:00:00	2007-09-04	2007-09-04 00:00:00	32020		\N	168710	0	444814009	40481087		0
42891	2554	40481087	1949-08-11	1949-08-11 00:00:00	1949-08-18	1949-08-18 00:00:00	32020		\N	169251	0	444814009	40481087		0
43034	2563	4146173	1977-01-22	1977-01-22 00:00:00	1977-02-21	1977-02-21 00:00:00	32020		\N	169786	0	307731004	4146173		0
32615	1936	4218389	1951-09-26	1951-09-26 00:00:00	1951-10-24	1951-10-24 00:00:00	32020		\N	128762	0	39848009	4218389		0
43408	2586	192671	2007-11-24	2007-11-24 00:00:00	\N	\N	32020		\N	171195	0	K92.2	35208414		0
32989	1956	28060	1994-01-27	1994-01-27 00:00:00	1994-02-07	1994-02-07 00:00:00	32020		\N	130204	0	43878008	28060		0
43659	2599	40481087	1992-02-20	1992-02-20 00:00:00	1992-02-27	1992-02-27 00:00:00	32020		\N	171983	0	444814009	40481087		0
33335	1977	317576	1963-12-26	1963-12-26 00:00:00	\N	\N	32020		\N	131642	0	53741008	317576		0
44031	2619	40481087	2016-07-25	2016-07-25 00:00:00	2016-08-01	2016-08-01 00:00:00	32020		\N	173168	0	444814009	40481087		0
33688	1999	40481087	2018-06-23	2018-06-23 00:00:00	2018-07-07	2018-07-07 00:00:00	32020		\N	133156	0	444814009	40481087		0
33816	2006	80180	1986-01-28	1986-01-28 00:00:00	\N	\N	32020		\N	133550	0	396275006	80180		0
44549	2651	260139	1956-04-11	1956-04-11 00:00:00	1956-04-25	1956-04-25 00:00:00	32020		\N	175485	0	10509002	260139		0
44674	2657	4112343	1968-01-29	1968-01-29 00:00:00	1968-02-10	1968-02-10 00:00:00	32020		\N	175967	0	195662009	4112343		0
44856	2669	4112343	2000-02-21	2000-02-21 00:00:00	2000-03-04	2000-03-04 00:00:00	32020		\N	176802	0	195662009	4112343		0
45048	2680	40481087	1972-05-16	1972-05-16 00:00:00	1972-05-23	1972-05-23 00:00:00	32020		\N	177522	0	444814009	40481087		0
34627	2056	28060	1981-05-17	1981-05-17 00:00:00	1981-05-28	1981-05-28 00:00:00	32020		\N	136741	0	43878008	28060		0
45429	2702	40481087	1978-07-15	1978-07-15 00:00:00	1978-07-29	1978-07-29 00:00:00	32020		\N	178959	0	444814009	40481087		0
45521	2705	260139	2011-11-24	2011-11-24 00:00:00	2011-12-08	2011-12-08 00:00:00	32020		\N	179224	0	10509002	260139		0
35177	2087	4218389	1977-09-28	1977-09-28 00:00:00	1977-10-19	1977-10-19 00:00:00	32020		\N	139102	0	39848009	4218389		0
35308	2091	40481087	1971-12-09	1971-12-09 00:00:00	1971-12-16	1971-12-16 00:00:00	32020		\N	139422	0	444814009	40481087		0
46068	2745	260139	1977-01-20	1977-01-20 00:00:00	1977-01-27	1977-01-27 00:00:00	32020		\N	181552	0	10509002	260139		0
46170	2750	372328	2001-03-29	2001-03-29 00:00:00	2001-09-26	2001-09-26 00:00:00	32020		\N	181936	0	65363002	372328		0
35845	2123	4059173	1959-05-30	1959-05-30 00:00:00	1959-08-28	1959-08-28 00:00:00	32020		\N	141317	0	16114001	4059173		0
35978	2134	4112343	2010-02-05	2010-02-05 00:00:00	2010-02-17	2010-02-17 00:00:00	32020		\N	141991	0	195662009	4112343		0
46678	2777	4283893	1978-01-31	1978-01-31 00:00:00	1978-03-07	1978-03-07 00:00:00	32020		\N	183949	0	36971009	4283893		0
36350	2152	317576	1980-01-12	1980-01-12 00:00:00	\N	\N	32020		\N	143400	0	53741008	317576		0
47042	2799	80180	2018-01-13	2018-01-13 00:00:00	\N	\N	32020		\N	185514	0	396275006	80180		0
47162	2804	378001	1982-05-14	1982-05-14 00:00:00	1982-06-13	1982-06-13 00:00:00	32020		\N	185850	0	62106007	378001		0
47320	2815	78272	2000-02-25	2000-02-25 00:00:00	2000-03-31	2000-03-31 00:00:00	32020		\N	186533	0	70704007	78272		0
47488	2825	4112343	2005-08-01	2005-08-01 00:00:00	2005-08-13	2005-08-13 00:00:00	32020		\N	187286	0	195662009	4112343		0
37142	2199	4294548	2012-06-15	2012-06-15 00:00:00	2012-07-27	2012-07-27 00:00:00	32020		\N	146558	0	75498004	4294548		0
37342	2211	40481087	2011-03-26	2011-03-26 00:00:00	2011-04-09	2011-04-09 00:00:00	32020		\N	147342	0	444814009	40481087		0
48020	2849	4294548	1987-02-05	1987-02-05 00:00:00	1987-09-24	1987-09-24 00:00:00	32020		\N	189206	0	75498004	4294548		0
37642	2232	192671	2005-12-05	2005-12-05 00:00:00	\N	\N	32020		\N	148548	0	K92.2	35208414		0
37775	2238	260139	2003-10-14	2003-10-14 00:00:00	2003-10-28	2003-10-28 00:00:00	32020		\N	148924	0	10509002	260139		0
48526	2872	321042	1971-09-07	1971-09-07 00:00:00	\N	\N	32020		\N	191205	0	410429000	321042		0
48722	2886	260139	1985-08-03	1985-08-03 00:00:00	1985-08-10	1985-08-10 00:00:00	32020		\N	191943	0	10509002	260139		0
48817	2892	81151	2002-09-11	2002-09-11 00:00:00	2002-10-02	2002-10-02 00:00:00	32020		\N	192417	0	44465007	81151		0
49061	2903	4112343	2003-11-20	2003-11-20 00:00:00	2003-11-27	2003-11-27 00:00:00	32020		\N	193413	0	195662009	4112343		0
49245	2913	4112343	1989-09-15	1989-09-15 00:00:00	1989-09-28	1989-09-28 00:00:00	32020		\N	194112	0	195662009	4112343		0
49350	2917	260139	1964-11-14	1964-11-14 00:00:00	1964-11-28	1964-11-28 00:00:00	32020		\N	194433	0	10509002	260139		0
49489	2926	4112343	2012-10-13	2012-10-13 00:00:00	2012-10-21	2012-10-21 00:00:00	32020		\N	195179	0	195662009	4112343		0
49709	2942	4084167	1966-03-23	1966-03-23 00:00:00	1966-03-23	1966-03-23 00:00:00	32020		\N	196056	0	241929008	4084167		0
39268	2330	40481087	1990-06-12	1990-06-12 00:00:00	1990-06-19	1990-06-19 00:00:00	32020		\N	154978	0	444814009	40481087		0
49988	2953	372328	2019-03-28	2019-03-28 00:00:00	\N	\N	32020		\N	197137	0	65363002	372328		0
39615	2346	4285898	1986-04-17	1986-04-17 00:00:00	\N	\N	32020		\N	156192	0	68496003	4285898		0
50302	2975	260139	1997-08-06	1997-08-06 00:00:00	1997-08-20	1997-08-20 00:00:00	32020		\N	198691	0	10509002	260139		0
50486	2986	261325	1988-10-25	1988-10-25 00:00:00	\N	\N	32020		\N	199300	0	87433001	261325		0
40148	2381	40481087	1951-01-07	1951-01-07 00:00:00	1951-01-14	1951-01-14 00:00:00	32020		\N	158346	0	444814009	40481087		0
40325	2392	260139	1984-02-24	1984-02-24 00:00:00	1984-03-09	1984-03-09 00:00:00	32020		\N	159045	0	10509002	260139		0
40447	2402	4084167	1990-08-31	1990-08-31 00:00:00	1990-08-31	1990-08-31 00:00:00	32020		\N	159672	0	241929008	4084167		0
51186	3030	40481087	2014-01-24	2014-01-24 00:00:00	2014-02-14	2014-02-14 00:00:00	32020		\N	201985	0	444814009	40481087		0
51300	3041	80180	2018-04-12	2018-04-12 00:00:00	\N	\N	32020		\N	202509	0	396275006	80180		0
41002	2437	4112343	2003-09-26	2003-09-26 00:00:00	2003-10-09	2003-10-09 00:00:00	32020		\N	161716	0	195662009	4112343		0
51721	3067	4134304	1967-03-09	1967-03-09 00:00:00	1967-04-08	1967-04-08 00:00:00	32020		\N	204177	0	263102004	4134304		0
51838	3074	40481087	1968-11-27	1968-11-27 00:00:00	1968-12-04	1968-12-04 00:00:00	32020		\N	204537	0	444814009	40481087		0
51981	3080	40481087	1959-01-27	1959-01-27 00:00:00	1959-02-03	1959-02-03 00:00:00	32020		\N	205014	0	444814009	40481087		0
52140	3087	4112343	2014-09-28	2014-09-28 00:00:00	2014-10-08	2014-10-08 00:00:00	32020		\N	205508	0	195662009	4112343		0
41797	2486	40481087	1982-10-25	1982-10-25 00:00:00	1982-11-01	1982-11-01 00:00:00	32020		\N	164752	0	444814009	40481087		0
52581	3115	40481087	1980-08-15	1980-08-15 00:00:00	1980-08-29	1980-08-29 00:00:00	32020		\N	207255	0	444814009	40481087		0
52725	3123	133834	1978-05-09	1978-05-09 00:00:00	1995-09-07	1995-09-07 00:00:00	32020		\N	207778	0	24079001	133834		0
52896	3133	80180	1989-06-03	1989-06-03 00:00:00	\N	\N	32020		\N	208470	0	396275006	80180		0
53050	3141	40481087	2012-04-26	2012-04-26 00:00:00	2012-05-03	2012-05-03 00:00:00	32020		\N	208982	0	444814009	40481087		0
42529	2535	260139	2015-02-02	2015-02-02 00:00:00	2015-02-16	2015-02-16 00:00:00	32020		\N	167523	0	10509002	260139		0
42766	2548	28060	1967-12-25	1967-12-25 00:00:00	1968-01-06	1968-01-06 00:00:00	32020		\N	168694	0	43878008	28060		0
42892	2554	40481087	1967-01-22	1967-01-22 00:00:00	1967-02-05	1967-02-05 00:00:00	32020		\N	169215	0	444814009	40481087		0
43035	2563	4059173	1979-01-12	1979-01-12 00:00:00	1979-04-12	1979-04-12 00:00:00	32020		\N	169791	0	16114001	4059173		0
32616	1936	260139	2013-08-15	2013-08-15 00:00:00	2013-08-22	2013-08-22 00:00:00	32020		\N	128773	0	10509002	260139		0
43409	2586	440086	1981-06-27	1981-06-27 00:00:00	1984-04-21	1984-04-21 00:00:00	32020		\N	171208	0	192127007	440086		0
32990	1956	80180	2005-07-29	2005-07-29 00:00:00	\N	\N	32020		\N	130117	0	396275006	80180		0
43660	2599	4142905	1984-10-28	1984-10-28 00:00:00	1984-11-27	1984-11-27 00:00:00	32020		\N	171958	0	33737001	4142905		0
33336	1977	40481087	1949-11-25	1949-11-25 00:00:00	1949-12-16	1949-12-16 00:00:00	32020		\N	131649	0	444814009	40481087		0
44032	2619	40481087	2012-11-30	2012-11-30 00:00:00	2012-12-07	2012-12-07 00:00:00	32020		\N	173231	0	444814009	40481087		0
33689	1999	40481087	2013-07-06	2013-07-06 00:00:00	2013-07-13	2013-07-13 00:00:00	32020		\N	133092	0	444814009	40481087		0
33817	2006	260139	1967-03-29	1967-03-29 00:00:00	1967-04-05	1967-04-05 00:00:00	32020		\N	133568	0	10509002	260139		0
44550	2651	260139	1951-04-27	1951-04-27 00:00:00	1951-05-04	1951-05-04 00:00:00	32020		\N	175414	0	10509002	260139		0
44675	2657	40481087	2000-01-18	2000-01-18 00:00:00	2000-02-08	2000-02-08 00:00:00	32020		\N	175936	0	444814009	40481087		0
44857	2669	40481087	2011-11-17	2011-11-17 00:00:00	2011-12-08	2011-12-08 00:00:00	32020		\N	176789	0	444814009	40481087		0
45049	2680	4112343	2003-06-10	2003-06-10 00:00:00	2003-06-21	2003-06-21 00:00:00	32020		\N	177529	0	195662009	4112343		0
34628	2056	4283893	1993-09-22	1993-09-22 00:00:00	1993-10-20	1993-10-20 00:00:00	32020		\N	136743	0	36971009	4283893		0
45430	2702	40481087	1952-04-18	1952-04-18 00:00:00	1952-04-25	1952-04-25 00:00:00	32020		\N	178995	0	444814009	40481087		0
45522	2706	40481087	1966-10-19	1966-10-19 00:00:00	1966-11-02	1966-11-02 00:00:00	32020		\N	179309	0	444814009	40481087		0
35178	2087	260139	2009-10-13	2009-10-13 00:00:00	2009-10-27	2009-10-27 00:00:00	32020		\N	139033	0	10509002	260139		0
35309	2091	40481087	2004-07-17	2004-07-17 00:00:00	2004-07-31	2004-07-31 00:00:00	32020		\N	139424	0	444814009	40481087		0
46069	2745	40481087	2011-05-21	2011-05-21 00:00:00	2011-06-04	2011-06-04 00:00:00	32020		\N	181581	0	444814009	40481087		0
46171	2750	4112343	1927-07-30	1927-07-30 00:00:00	1927-08-10	1927-08-10 00:00:00	32020		\N	181877	0	195662009	4112343		0
35846	2123	80180	1986-11-29	1986-11-29 00:00:00	\N	\N	32020		\N	141288	0	396275006	80180		0
35979	2134	440448	1997-09-01	1997-09-01 00:00:00	\N	\N	32020		\N	141963	0	74400008	440448		0
46679	2777	40481087	2017-04-13	2017-04-13 00:00:00	2017-05-04	2017-05-04 00:00:00	32020		\N	183969	0	444814009	40481087		0
36351	2152	4112343	1924-05-05	1924-05-05 00:00:00	1924-05-16	1924-05-16 00:00:00	32020		\N	143431	0	195662009	4112343		0
47043	2799	4285898	2017-10-15	2017-10-15 00:00:00	\N	\N	32020		\N	185514	0	68496003	4285898		0
47163	2804	4134304	1952-08-05	1952-08-05 00:00:00	1952-11-03	1952-11-03 00:00:00	32020		\N	185847	0	263102004	4134304		0
47321	2815	372328	1964-08-04	1964-08-04 00:00:00	1964-08-18	1964-08-18 00:00:00	32020		\N	186551	0	65363002	372328		0
47489	2825	78272	1993-06-19	1993-06-19 00:00:00	1993-07-10	1993-07-10 00:00:00	32020		\N	187333	0	70704007	78272		0
37143	2199	260139	2016-02-27	2016-02-27 00:00:00	2016-03-12	2016-03-12 00:00:00	32020		\N	146591	0	10509002	260139		0
37343	2211	4142905	1973-04-10	1973-04-10 00:00:00	1973-06-09	1973-06-09 00:00:00	32020		\N	147319	0	33737001	4142905		0
48021	2849	4059173	2003-05-04	2003-05-04 00:00:00	2003-07-03	2003-07-03 00:00:00	32020		\N	189296	0	16114001	4059173		0
37643	2232	4109685	2001-09-08	2001-09-08 00:00:00	2001-09-22	2001-09-22 00:00:00	32020		\N	148474	0	284551006	4109685		0
37776	2238	260139	1978-10-13	1978-10-13 00:00:00	1978-10-27	1978-10-27 00:00:00	32020		\N	148933	0	10509002	260139		0
48527	2872	372328	1954-03-31	1954-03-31 00:00:00	1954-08-17	1954-08-17 00:00:00	32020		\N	191194	0	65363002	372328		0
48723	2886	4112343	2011-03-04	2011-03-04 00:00:00	2011-03-12	2011-03-12 00:00:00	32020		\N	191933	0	195662009	4112343		0
48818	2892	4112343	1975-08-16	1975-08-16 00:00:00	1975-08-27	1975-08-27 00:00:00	32020		\N	192422	0	195662009	4112343		0
49062	2903	260139	1966-06-02	1966-06-02 00:00:00	1966-06-16	1966-06-16 00:00:00	32020		\N	193438	0	10509002	260139		0
49246	2913	40481087	2007-09-20	2007-09-20 00:00:00	2007-09-27	2007-09-27 00:00:00	32020		\N	194141	0	444814009	40481087		0
49351	2917	40481087	1941-10-12	1941-10-12 00:00:00	1941-10-19	1941-10-19 00:00:00	32020		\N	194466	0	444814009	40481087		0
49490	2927	4142905	1983-03-09	1983-03-09 00:00:00	1983-06-07	1983-06-07 00:00:00	32020		\N	195295	0	33737001	4142905		0
49710	2942	40481087	2018-03-31	2018-03-31 00:00:00	2018-04-21	2018-04-21 00:00:00	32020		\N	196190	0	444814009	40481087		0
39269	2330	4112343	2009-08-30	2009-08-30 00:00:00	2009-09-07	2009-09-07 00:00:00	32020		\N	154987	0	195662009	4112343		0
49999	2955	4112343	1976-09-02	1976-09-02 00:00:00	1976-09-14	1976-09-14 00:00:00	32020		\N	197275	0	195662009	4112343		0
39616	2346	40481087	2016-12-22	2016-12-22 00:00:00	2016-12-29	2016-12-29 00:00:00	32020		\N	156155	0	444814009	40481087		0
50303	2975	40481087	1988-10-06	1988-10-06 00:00:00	1988-10-13	1988-10-13 00:00:00	32020		\N	198624	0	444814009	40481087		0
50487	2987	40481087	2012-03-07	2012-03-07 00:00:00	2012-03-14	2012-03-14 00:00:00	32020		\N	199395	0	444814009	40481087		0
40149	2381	40481087	1975-10-14	1975-10-14 00:00:00	1975-10-28	1975-10-28 00:00:00	32020		\N	158319	0	444814009	40481087		0
40326	2392	260139	2011-03-24	2011-03-24 00:00:00	2011-03-31	2011-03-31 00:00:00	32020		\N	159104	0	10509002	260139		0
40448	2402	4218389	1983-03-11	1983-03-11 00:00:00	1983-04-08	1983-04-08 00:00:00	32020		\N	159668	0	39848009	4218389		0
51187	3030	81151	2001-01-17	2001-01-17 00:00:00	2001-01-31	2001-01-31 00:00:00	32020		\N	202025	0	44465007	81151		0
51301	3041	4283893	1981-08-04	1981-08-04 00:00:00	1981-10-27	1981-10-27 00:00:00	32020		\N	202485	0	36971009	4283893		0
51470	3056	40481087	1968-12-17	1968-12-17 00:00:00	1968-12-31	1968-12-31 00:00:00	32020		\N	203250	0	444814009	40481087		0
51722	3067	4134304	2015-11-09	2015-11-09 00:00:00	2015-12-09	2015-12-09 00:00:00	32020		\N	204189	0	263102004	4134304		0
51839	3074	260139	1972-09-28	1972-09-28 00:00:00	1972-10-12	1972-10-12 00:00:00	32020		\N	204538	0	10509002	260139		0
51982	3080	81151	1950-06-23	1950-06-23 00:00:00	1950-07-07	1950-07-07 00:00:00	32020		\N	204967	0	44465007	81151		0
52141	3087	192671	1976-05-08	1976-05-08 00:00:00	\N	\N	32020		\N	205572	0	K92.2	35208414		0
41798	2486	260139	1978-09-29	1978-09-29 00:00:00	1978-10-06	1978-10-06 00:00:00	32020		\N	164738	0	10509002	260139		0
52582	3115	372328	1968-04-14	1968-04-14 00:00:00	1968-06-28	1968-06-28 00:00:00	32020		\N	207262	0	65363002	372328		0
52726	3123	372328	1979-07-26	1979-07-26 00:00:00	1979-12-12	1979-12-12 00:00:00	32020		\N	207832	0	65363002	372328		0
52897	3133	372328	2011-01-24	2011-01-24 00:00:00	2011-03-23	2011-03-23 00:00:00	32020		\N	208479	0	65363002	372328		0
53051	3141	260139	1987-09-11	1987-09-11 00:00:00	1987-09-18	1987-09-18 00:00:00	32020		\N	208994	0	10509002	260139		0
42530	2535	28060	1972-09-09	1972-09-09 00:00:00	1972-09-18	1972-09-18 00:00:00	32020		\N	167482	0	43878008	28060		0
42767	2548	260139	2011-01-10	2011-01-10 00:00:00	2011-01-17	2011-01-17 00:00:00	32020		\N	168731	0	10509002	260139		0
42893	2554	4283893	1957-11-09	1957-11-09 00:00:00	1958-01-25	1958-01-25 00:00:00	32020		\N	169212	0	36971009	4283893		0
43036	2563	4152936	2000-03-06	2000-03-06 00:00:00	2000-03-27	2000-03-27 00:00:00	32020		\N	169793	0	283385000	4152936		0
32617	1936	40481087	1988-04-07	1988-04-07 00:00:00	1988-04-21	1988-04-21 00:00:00	32020		\N	128804	0	444814009	40481087		0
43410	2586	4112343	2013-07-22	2013-07-22 00:00:00	2013-07-31	2013-07-31 00:00:00	32020		\N	171192	0	195662009	4112343		0
32991	1956	260139	2016-01-07	2016-01-07 00:00:00	2016-01-14	2016-01-14 00:00:00	32020		\N	130127	0	10509002	260139		0
43675	2602	78272	2018-02-20	2018-02-20 00:00:00	2018-03-20	2018-03-20 00:00:00	32020		\N	172142	0	70704007	78272		0
33337	1977	40481087	2009-11-18	2009-11-18 00:00:00	2009-12-02	2009-12-02 00:00:00	32020		\N	131515	0	444814009	40481087		0
44033	2619	4296204	1976-06-22	1976-06-22 00:00:00	1976-07-20	1976-07-20 00:00:00	32020		\N	173201	0	403190006	4296204		0
33690	1999	40481087	2012-09-26	2012-09-26 00:00:00	2012-10-03	2012-10-03 00:00:00	32020		\N	133088	0	444814009	40481087		0
33818	2006	81151	2000-09-13	2000-09-13 00:00:00	2000-10-04	2000-10-04 00:00:00	32020		\N	133603	0	44465007	81151		0
44551	2651	260139	1952-12-26	1952-12-26 00:00:00	1953-01-02	1953-01-02 00:00:00	32020		\N	175484	0	10509002	260139		0
44676	2657	4112343	2018-07-13	2018-07-13 00:00:00	2018-07-24	2018-07-24 00:00:00	32020		\N	175938	0	195662009	4112343		0
44858	2669	257012	1978-09-23	1978-09-23 00:00:00	\N	\N	32020		\N	176799	0	40055000	257012		0
45050	2680	4152936	2017-09-19	2017-09-19 00:00:00	2017-10-03	2017-10-03 00:00:00	32020		\N	177559	0	283385000	4152936		0
34629	2056	80180	2016-02-26	2016-02-26 00:00:00	\N	\N	32020		\N	136753	0	396275006	80180		0
45431	2702	4112343	1982-12-11	1982-12-11 00:00:00	1982-12-18	1982-12-18 00:00:00	32020		\N	178960	0	195662009	4112343		0
45523	2706	4112343	1968-12-24	1968-12-24 00:00:00	1969-01-04	1969-01-04 00:00:00	32020		\N	179310	0	195662009	4112343		0
35179	2087	40481087	1974-12-12	1974-12-12 00:00:00	1975-01-02	1975-01-02 00:00:00	32020		\N	139088	0	444814009	40481087		0
35310	2091	4112343	1997-04-27	1997-04-27 00:00:00	1997-05-08	1997-05-08 00:00:00	32020		\N	139423	0	195662009	4112343		0
46070	2745	4152936	2003-12-28	2003-12-28 00:00:00	2004-01-18	2004-01-18 00:00:00	32020		\N	181576	0	283385000	4152936		0
46172	2750	4112343	1971-09-21	1971-09-21 00:00:00	1971-10-02	1971-10-02 00:00:00	32020		\N	181878	0	195662009	4112343		0
35847	2123	4112343	1952-01-08	1952-01-08 00:00:00	1952-01-17	1952-01-17 00:00:00	32020		\N	141276	0	195662009	4112343		0
35980	2134	4112343	1983-08-18	1983-08-18 00:00:00	1983-08-27	1983-08-27 00:00:00	32020		\N	141989	0	195662009	4112343		0
46680	2777	81151	1988-12-27	1988-12-27 00:00:00	1989-01-24	1989-01-24 00:00:00	32020		\N	183934	0	44465007	81151		0
36352	2152	40481087	1984-12-10	1984-12-10 00:00:00	1984-12-31	1984-12-31 00:00:00	32020		\N	143450	0	444814009	40481087		0
47044	2799	4278672	1995-05-14	1995-05-14 00:00:00	1995-06-13	1995-06-13 00:00:00	32020		\N	185476	0	65966004	4278672		0
47164	2804	260139	1956-09-14	1956-09-14 00:00:00	1956-09-21	1956-09-21 00:00:00	32020		\N	185844	0	10509002	260139		0
47322	2815	4112343	1965-08-02	1965-08-02 00:00:00	1965-08-10	1965-08-10 00:00:00	32020		\N	186546	0	195662009	4112343		0
47490	2825	372328	1927-09-12	1927-09-12 00:00:00	1927-11-29	1927-11-29 00:00:00	32020		\N	187312	0	65363002	372328		0
37144	2199	440448	1995-07-19	1995-07-19 00:00:00	\N	\N	32020		\N	146578	0	74400008	440448		0
37344	2211	4112343	1992-04-09	1992-04-09 00:00:00	1992-04-16	1992-04-16 00:00:00	32020		\N	147336	0	195662009	4112343		0
48022	2849	4112343	1951-01-28	1951-01-28 00:00:00	1951-02-04	1951-02-04 00:00:00	32020		\N	189301	0	195662009	4112343		0
37644	2232	260139	1981-07-13	1981-07-13 00:00:00	1981-07-27	1981-07-27 00:00:00	32020		\N	148537	0	10509002	260139		0
37777	2238	260139	1986-04-23	1986-04-23 00:00:00	1986-05-07	1986-05-07 00:00:00	32020		\N	148890	0	10509002	260139		0
48528	2872	80180	1998-10-11	1998-10-11 00:00:00	\N	\N	32020		\N	191190	0	396275006	80180		0
48724	2886	4112343	2004-06-24	2004-06-24 00:00:00	2004-07-05	2004-07-05 00:00:00	32020		\N	191920	0	195662009	4112343		0
48819	2892	40481087	1999-06-30	1999-06-30 00:00:00	1999-07-21	1999-07-21 00:00:00	32020		\N	192425	0	444814009	40481087		0
49063	2903	81151	2013-12-12	2013-12-12 00:00:00	2014-01-02	2014-01-02 00:00:00	32020		\N	193432	0	44465007	81151		0
49247	2913	4283893	1957-11-05	1957-11-05 00:00:00	1957-12-03	1957-12-03 00:00:00	32020		\N	194110	0	36971009	4283893		0
49352	2917	81151	2013-08-19	2013-08-19 00:00:00	2013-09-16	2013-09-16 00:00:00	32020		\N	194503	0	44465007	81151		0
49491	2927	81151	1954-05-21	1954-05-21 00:00:00	1954-06-04	1954-06-04 00:00:00	32020		\N	195293	0	44465007	81151		0
49711	2942	4112343	2002-03-07	2002-03-07 00:00:00	2002-03-18	2002-03-18 00:00:00	32020		\N	196220	0	195662009	4112343		0
39270	2330	4152936	1980-03-26	1980-03-26 00:00:00	1980-04-09	1980-04-09 00:00:00	32020		\N	155004	0	283385000	4152936		0
50000	2955	4112343	1995-01-27	1995-01-27 00:00:00	1995-02-09	1995-02-09 00:00:00	32020		\N	197242	0	195662009	4112343		0
39617	2346	40481087	1990-11-21	1990-11-21 00:00:00	1990-12-12	1990-12-12 00:00:00	32020		\N	156212	0	444814009	40481087		0
50304	2975	4112343	1973-04-13	1973-04-13 00:00:00	1973-04-24	1973-04-24 00:00:00	32020		\N	198622	0	195662009	4112343		0
50488	2987	78272	2003-09-12	2003-09-12 00:00:00	2003-10-17	2003-10-17 00:00:00	32020		\N	199424	0	70704007	78272		0
40150	2381	372328	1939-05-02	1939-05-02 00:00:00	1939-08-23	1939-08-23 00:00:00	32020		\N	158246	0	65363002	372328		0
40327	2392	81151	1974-06-16	1974-06-16 00:00:00	1974-07-07	1974-07-07 00:00:00	32020		\N	159012	0	44465007	81151		0
40449	2402	4051466	1978-09-20	1978-09-20 00:00:00	1995-12-23	1995-12-23 00:00:00	32020		\N	159573	0	233678006	4051466		0
51188	3030	4059173	1986-05-24	1986-05-24 00:00:00	1986-08-22	1986-08-22 00:00:00	32020		\N	202021	0	16114001	4059173		0
51302	3041	4112343	1993-11-28	1993-11-28 00:00:00	1993-12-10	1993-12-10 00:00:00	32020		\N	202435	0	195662009	4112343		0
51471	3056	40481087	1996-07-17	1996-07-17 00:00:00	1996-08-07	1996-08-07 00:00:00	32020		\N	203276	0	444814009	40481087		0
51723	3067	40481087	1998-06-30	1998-06-30 00:00:00	1998-07-21	1998-07-21 00:00:00	32020		\N	204116	0	444814009	40481087		0
51840	3074	40481087	1994-03-26	1994-03-26 00:00:00	1994-04-16	1994-04-16 00:00:00	32020		\N	204563	0	444814009	40481087		0
51983	3080	439777	1941-12-12	1941-12-12 00:00:00	\N	\N	32020		\N	204983	0	271737000	439777		0
52142	3087	260139	2002-03-12	2002-03-12 00:00:00	2002-03-26	2002-03-26 00:00:00	32020		\N	205494	0	10509002	260139		0
41799	2486	260139	2007-02-07	2007-02-07 00:00:00	2007-02-21	2007-02-21 00:00:00	32020		\N	164742	0	10509002	260139		0
52583	3115	28060	1974-03-15	1974-03-15 00:00:00	1974-03-26	1974-03-26 00:00:00	32020		\N	207225	0	43878008	28060		0
52727	3123	4294548	1981-02-22	1981-02-22 00:00:00	1981-03-01	1981-03-01 00:00:00	32020		\N	207806	0	75498004	4294548		0
52898	3133	40481087	1985-08-25	1985-08-25 00:00:00	1985-09-01	1985-09-01 00:00:00	32020		\N	208467	0	444814009	40481087		0
53052	3141	4113008	1998-05-28	1998-05-28 00:00:00	1998-06-11	1998-06-11 00:00:00	32020		\N	208990	0	284549007	4113008		0
42531	2535	372328	1961-03-02	1961-03-02 00:00:00	1961-04-09	1961-04-09 00:00:00	32020		\N	167524	0	65363002	372328		0
42768	2548	40481087	1995-05-23	1995-05-23 00:00:00	1995-05-30	1995-05-30 00:00:00	32020		\N	168699	0	444814009	40481087		0
42894	2554	40481087	1988-09-28	1988-09-28 00:00:00	1988-10-05	1988-10-05 00:00:00	32020		\N	169220	0	444814009	40481087		0
43037	2563	260139	1983-04-16	1983-04-16 00:00:00	1983-04-23	1983-04-23 00:00:00	32020		\N	169789	0	10509002	260139		0
32618	1936	4155034	1955-08-04	1955-08-04 00:00:00	1955-08-25	1955-08-25 00:00:00	32020		\N	128763	0	283371005	4155034		0
43411	2586	4112343	1983-05-11	1983-05-11 00:00:00	1983-05-22	1983-05-22 00:00:00	32020		\N	171156	0	195662009	4112343		0
32992	1956	4278672	1972-11-04	1972-11-04 00:00:00	1973-02-02	1973-02-02 00:00:00	32020		\N	130215	0	65966004	4278672		0
43676	2602	4155034	2014-02-27	2014-02-27 00:00:00	2014-03-13	2014-03-13 00:00:00	32020		\N	172147	0	283371005	4155034		0
43825	2610	4278672	1973-04-26	1973-04-26 00:00:00	1973-06-26	1973-06-26 00:00:00	32020		\N	172595	0	65966004	4278672		0
44034	2619	40481087	1996-01-10	1996-01-10 00:00:00	1996-01-31	1996-01-31 00:00:00	32020		\N	173151	0	444814009	40481087		0
33691	1999	440086	1991-09-20	1991-09-20 00:00:00	1992-01-03	1992-01-03 00:00:00	32020		\N	133111	0	192127007	440086		0
33819	2006	4112343	1999-08-03	1999-08-03 00:00:00	1999-08-13	1999-08-13 00:00:00	32020		\N	133643	0	195662009	4112343		0
44552	2651	40481087	1975-10-15	1975-10-15 00:00:00	1975-10-22	1975-10-22 00:00:00	32020		\N	175379	0	444814009	40481087		0
44677	2657	4294548	2009-01-18	2009-01-18 00:00:00	2009-08-16	2009-08-16 00:00:00	32020		\N	175956	0	75498004	4294548		0
44859	2669	4112343	2002-07-25	2002-07-25 00:00:00	2002-08-03	2002-08-03 00:00:00	32020		\N	176765	0	195662009	4112343		0
45051	2680	260139	1975-06-23	1975-06-23 00:00:00	1975-07-07	1975-07-07 00:00:00	32020		\N	177539	0	10509002	260139		0
34630	2056	4059173	1982-01-10	1982-01-10 00:00:00	1982-04-10	1982-04-10 00:00:00	32020		\N	136715	0	16114001	4059173		0
45432	2702	80180	1983-04-21	1983-04-21 00:00:00	\N	\N	32020		\N	178960	0	396275006	80180		0
45524	2706	28060	1973-02-14	1973-02-14 00:00:00	1973-02-23	1973-02-23 00:00:00	32020		\N	179289	0	43878008	28060		0
35180	2087	40480160	2015-01-03	2015-01-03 00:00:00	2015-04-03	2015-04-03 00:00:00	32020		\N	139105	0	443165006	40480160		0
35311	2091	4112343	1978-08-04	1978-08-04 00:00:00	1978-08-13	1978-08-13 00:00:00	32020		\N	139442	0	195662009	4112343		0
46071	2745	4296205	2007-08-28	2007-08-28 00:00:00	2007-10-02	2007-10-02 00:00:00	32020		\N	181578	0	403191005	4296205		0
46173	2750	260139	1983-01-21	1983-01-21 00:00:00	1983-02-04	1983-02-04 00:00:00	32020		\N	181933	0	10509002	260139		0
35848	2123	40481087	1987-10-07	1987-10-07 00:00:00	1987-10-21	1987-10-21 00:00:00	32020		\N	141296	0	444814009	40481087		0
35981	2134	372328	1951-07-03	1951-07-03 00:00:00	1951-08-19	1951-08-19 00:00:00	32020		\N	141992	0	65363002	372328		0
59142	3509	80180	1987-05-25	1987-05-25 00:00:00	\N	\N	32020		\N	232754	0	396275006	80180		0
46681	2777	4112343	2017-08-31	2017-08-31 00:00:00	2017-09-10	2017-09-10 00:00:00	32020		\N	183927	0	195662009	4112343		0
36353	2152	40481087	1927-11-21	1927-11-21 00:00:00	1927-11-28	1927-11-28 00:00:00	32020		\N	143432	0	444814009	40481087		0
47045	2799	4027663	2007-03-27	2007-03-27 00:00:00	\N	\N	32020		\N	185495	0	13200003	4027663		0
47165	2804	40481087	1973-11-02	1973-11-02 00:00:00	1973-11-23	1973-11-23 00:00:00	32020		\N	185879	0	444814009	40481087		0
47323	2815	40481087	2006-09-14	2006-09-14 00:00:00	2006-09-28	2006-09-28 00:00:00	32020		\N	186557	0	444814009	40481087		0
47491	2825	40481087	1951-09-05	1951-09-05 00:00:00	1951-09-19	1951-09-19 00:00:00	32020		\N	187228	0	444814009	40481087		0
37145	2200	40481087	1978-08-19	1978-08-19 00:00:00	1978-09-02	1978-09-02 00:00:00	32020		\N	146598	0	444814009	40481087		0
37345	2211	260139	2001-08-16	2001-08-16 00:00:00	2001-08-23	2001-08-23 00:00:00	32020		\N	147329	0	10509002	260139		0
48023	2849	4112343	1968-05-08	1968-05-08 00:00:00	1968-05-17	1968-05-17 00:00:00	32020		\N	189302	0	195662009	4112343		0
37645	2232	4155034	2011-12-29	2011-12-29 00:00:00	2012-01-12	2012-01-12 00:00:00	32020		\N	148475	0	283371005	4155034		0
37778	2238	4112343	1985-04-25	1985-04-25 00:00:00	1985-05-07	1985-05-07 00:00:00	32020		\N	148889	0	195662009	4112343		0
48530	2872	4112343	1959-06-07	1959-06-07 00:00:00	1959-06-14	1959-06-14 00:00:00	32020		\N	191216	0	195662009	4112343		0
48725	2886	4112343	2017-11-06	2017-11-06 00:00:00	2017-11-13	2017-11-13 00:00:00	32020		\N	191989	0	195662009	4112343		0
48820	2892	40481087	2006-12-01	2006-12-01 00:00:00	2006-12-22	2006-12-22 00:00:00	32020		\N	192402	0	444814009	40481087		0
49064	2903	372328	1965-12-03	1965-12-03 00:00:00	1966-02-20	1966-02-20 00:00:00	32020		\N	193442	0	65363002	372328		0
49248	2913	40481087	1954-02-01	1954-02-01 00:00:00	1954-02-15	1954-02-15 00:00:00	32020		\N	194094	0	444814009	40481087		0
49353	2917	40481087	1966-11-16	1966-11-16 00:00:00	1966-11-23	1966-11-23 00:00:00	32020		\N	194494	0	444814009	40481087		0
49492	2927	40481087	1988-05-21	1988-05-21 00:00:00	1988-06-04	1988-06-04 00:00:00	32020		\N	195252	0	444814009	40481087		0
49712	2942	28060	2003-01-13	2003-01-13 00:00:00	2003-01-24	2003-01-24 00:00:00	32020		\N	196221	0	43878008	28060		0
39271	2330	40481087	2002-11-18	2002-11-18 00:00:00	2002-12-09	2002-12-09 00:00:00	32020		\N	154986	0	444814009	40481087		0
50001	2955	260139	1985-12-26	1985-12-26 00:00:00	1986-01-09	1986-01-09 00:00:00	32020		\N	197237	0	10509002	260139		0
39618	2346	378001	1953-03-01	1953-03-01 00:00:00	1953-03-31	1953-03-31 00:00:00	32020		\N	156215	0	62106007	378001		0
50305	2975	40481087	2018-07-16	2018-07-16 00:00:00	2018-07-30	2018-07-30 00:00:00	32020		\N	198584	0	444814009	40481087		0
50489	2987	372328	1975-08-10	1975-08-10 00:00:00	1975-10-27	1975-10-27 00:00:00	32020		\N	199372	0	65363002	372328		0
40151	2381	4112343	1968-12-26	1968-12-26 00:00:00	1969-01-03	1969-01-03 00:00:00	32020		\N	158295	0	195662009	4112343		0
40328	2392	372328	1919-09-16	1919-09-16 00:00:00	1920-01-09	1920-01-09 00:00:00	32020		\N	159047	0	65363002	372328		0
40450	2402	260139	1980-02-26	1980-02-26 00:00:00	1980-03-04	1980-03-04 00:00:00	32020		\N	159574	0	10509002	260139		0
51189	3030	257012	2015-10-16	2015-10-16 00:00:00	\N	\N	32020		\N	201986	0	40055000	257012		0
51303	3041	257012	1981-09-08	1981-09-08 00:00:00	\N	\N	32020		\N	202486	0	40055000	257012		0
51472	3056	80180	1997-05-12	1997-05-12 00:00:00	\N	\N	32020		\N	203276	0	396275006	80180		0
51724	3067	80180	1976-07-27	1976-07-27 00:00:00	\N	\N	32020		\N	204145	0	396275006	80180		0
51841	3074	4156265	1998-11-15	1998-11-15 00:00:00	1998-12-06	1998-12-06 00:00:00	32020		\N	204573	0	370247008	4156265		0
51984	3080	378001	1994-01-29	1994-01-29 00:00:00	1994-03-30	1994-03-30 00:00:00	32020		\N	204970	0	62106007	378001		0
52143	3087	260139	1966-11-25	1966-11-25 00:00:00	1966-12-02	1966-12-02 00:00:00	32020		\N	205531	0	10509002	260139		0
41800	2486	40481087	2005-07-04	2005-07-04 00:00:00	2005-07-18	2005-07-18 00:00:00	32020		\N	164757	0	444814009	40481087		0
52584	3115	260139	1968-09-12	1968-09-12 00:00:00	1968-09-19	1968-09-19 00:00:00	32020		\N	207208	0	10509002	260139		0
52728	3123	80180	2018-04-12	2018-04-12 00:00:00	\N	\N	32020		\N	207838	0	396275006	80180		0
52899	3133	260139	2010-04-08	2010-04-08 00:00:00	2010-04-22	2010-04-22 00:00:00	32020		\N	208459	0	10509002	260139		0
53080	3144	40481087	1990-11-03	1990-11-03 00:00:00	1990-11-24	1990-11-24 00:00:00	32020		\N	209223	0	444814009	40481087		0
42532	2535	4296205	1970-10-11	1970-10-11 00:00:00	1970-11-08	1970-11-08 00:00:00	32020		\N	167519	0	403191005	4296205		0
42769	2548	40481087	2001-08-01	2001-08-01 00:00:00	2001-08-08	2001-08-08 00:00:00	32020		\N	168709	0	444814009	40481087		0
42895	2554	40481087	1969-05-30	1969-05-30 00:00:00	1969-06-13	1969-06-13 00:00:00	32020		\N	169265	0	444814009	40481087		0
43038	2563	4112343	1988-01-04	1988-01-04 00:00:00	1988-01-11	1988-01-11 00:00:00	32020		\N	169761	0	195662009	4112343		0
32619	1936	260139	1979-07-11	1979-07-11 00:00:00	1979-07-18	1979-07-18 00:00:00	32020		\N	128771	0	10509002	260139		0
43412	2586	4112343	2004-07-28	2004-07-28 00:00:00	2004-08-07	2004-08-07 00:00:00	32020		\N	171176	0	195662009	4112343		0
32995	1958	260139	2008-03-10	2008-03-10 00:00:00	2008-03-17	2008-03-17 00:00:00	32020		\N	130259	0	10509002	260139		0
43677	2602	4112343	2009-11-20	2009-11-20 00:00:00	2009-11-27	2009-11-27 00:00:00	32020		\N	172133	0	195662009	4112343		0
43826	2610	80180	1992-06-17	1992-06-17 00:00:00	\N	\N	32020		\N	172599	0	396275006	80180		0
44035	2619	4294548	1948-09-18	1948-09-18 00:00:00	1948-10-09	1948-10-09 00:00:00	32020		\N	173146	0	75498004	4294548		0
33692	1999	4134304	1991-07-12	1991-07-12 00:00:00	1991-08-11	1991-08-11 00:00:00	32020		\N	133057	0	263102004	4134304		0
33820	2006	40481087	2002-02-17	2002-02-17 00:00:00	2002-03-10	2002-03-10 00:00:00	32020		\N	133621	0	444814009	40481087		0
44553	2651	260139	1963-09-17	1963-09-17 00:00:00	1963-09-24	1963-09-24 00:00:00	32020		\N	175486	0	10509002	260139		0
44678	2657	4149245	2016-01-16	2016-01-16 00:00:00	2016-02-22	2016-02-22 00:00:00	32020		\N	175951	0	30832001	4149245		0
44860	2669	40481087	1996-11-21	1996-11-21 00:00:00	1996-11-28	1996-11-28 00:00:00	32020		\N	176764	0	444814009	40481087		0
45052	2680	4296205	2014-12-13	2014-12-13 00:00:00	2015-01-03	2015-01-03 00:00:00	32020		\N	177558	0	403191005	4296205		0
34631	2056	4035415	1990-09-25	1990-09-25 00:00:00	1990-10-25	1990-10-25 00:00:00	32020		\N	136716	0	239720000	4035415		0
45433	2702	4112343	1974-04-02	1974-04-02 00:00:00	1974-04-12	1974-04-12 00:00:00	32020		\N	178963	0	195662009	4112343		0
45525	2706	378001	2012-01-16	2012-01-16 00:00:00	2012-03-16	2012-03-16 00:00:00	32020		\N	179298	0	62106007	378001		0
35181	2087	4278672	2015-01-03	2015-01-03 00:00:00	2015-04-03	2015-04-03 00:00:00	32020		\N	139105	0	65966004	4278672		0
35312	2091	40481087	2001-09-15	2001-09-15 00:00:00	2001-09-22	2001-09-22 00:00:00	32020		\N	139435	0	444814009	40481087		0
46072	2745	28060	1972-06-17	1972-06-17 00:00:00	1972-06-30	1972-06-30 00:00:00	32020		\N	181597	0	43878008	28060		0
46174	2750	4112343	2007-11-28	2007-11-28 00:00:00	2007-12-07	2007-12-07 00:00:00	32020		\N	181923	0	195662009	4112343		0
35849	2123	260139	1980-03-30	1980-03-30 00:00:00	1980-04-06	1980-04-06 00:00:00	32020		\N	141307	0	10509002	260139		0
35982	2134	260139	2014-09-19	2014-09-19 00:00:00	2014-10-03	2014-10-03 00:00:00	32020		\N	142028	0	10509002	260139		0
46682	2777	40481087	1978-09-12	1978-09-12 00:00:00	1978-09-19	1978-09-19 00:00:00	32020		\N	183967	0	444814009	40481087		0
36354	2152	4109685	1933-07-13	1933-07-13 00:00:00	1933-07-27	1933-07-27 00:00:00	32020		\N	143415	0	284551006	4109685		0
47046	2799	40481087	1988-05-27	1988-05-27 00:00:00	1988-06-17	1988-06-17 00:00:00	32020		\N	185506	0	444814009	40481087		0
47166	2804	40481087	2002-05-30	2002-05-30 00:00:00	2002-06-13	2002-06-13 00:00:00	32020		\N	185815	0	444814009	40481087		0
47324	2815	40481087	1984-05-15	1984-05-15 00:00:00	1984-06-05	1984-06-05 00:00:00	32020		\N	186516	0	444814009	40481087		0
47492	2825	260139	1970-04-30	1970-04-30 00:00:00	1970-05-07	1970-05-07 00:00:00	32020		\N	187229	0	10509002	260139		0
37146	2200	372328	1978-01-15	1978-01-15 00:00:00	1978-05-21	1978-05-21 00:00:00	32020		\N	146601	0	65363002	372328		0
37346	2211	4112343	1984-08-22	1984-08-22 00:00:00	1984-09-03	1984-09-03 00:00:00	32020		\N	147302	0	195662009	4112343		0
48024	2849	40481087	1951-02-25	1951-02-25 00:00:00	1951-03-18	1951-03-18 00:00:00	32020		\N	189203	0	444814009	40481087		0
37646	2232	4294548	1992-06-05	1992-06-05 00:00:00	1992-07-17	1992-07-17 00:00:00	32020		\N	148525	0	75498004	4294548		0
37802	2240	4112343	2008-12-28	2008-12-28 00:00:00	2009-01-04	2009-01-04 00:00:00	32020		\N	149147	0	195662009	4112343		0
48531	2872	4166224	1979-03-07	1979-03-07 00:00:00	\N	\N	32020		\N	191206	0	47693006	4166224		0
48726	2886	40481087	1986-01-20	1986-01-20 00:00:00	1986-01-27	1986-01-27 00:00:00	32020		\N	191969	0	444814009	40481087		0
48821	2892	80180	2007-06-08	2007-06-08 00:00:00	\N	\N	32020		\N	192402	0	396275006	80180		0
49065	2903	372328	1974-09-06	1974-09-06 00:00:00	1975-04-27	1975-04-27 00:00:00	32020		\N	193415	0	65363002	372328		0
49249	2913	81151	1988-03-14	1988-03-14 00:00:00	1988-03-28	1988-03-28 00:00:00	32020		\N	194139	0	44465007	81151		0
49354	2917	40481087	1952-06-20	1952-06-20 00:00:00	1952-06-27	1952-06-27 00:00:00	32020		\N	194467	0	444814009	40481087		0
49493	2927	4294548	2012-11-18	2012-11-18 00:00:00	2013-01-06	2013-01-06 00:00:00	32020		\N	195253	0	75498004	4294548		0
49713	2942	133834	1954-11-28	1954-11-28 00:00:00	1970-11-22	1970-11-22 00:00:00	32020		\N	196126	0	24079001	133834		0
39272	2330	372328	1979-08-29	1979-08-29 00:00:00	1980-06-30	1980-06-30 00:00:00	32020		\N	154995	0	65363002	372328		0
50002	2955	40481087	2017-12-10	2017-12-10 00:00:00	2017-12-24	2017-12-24 00:00:00	32020		\N	197209	0	444814009	40481087		0
39619	2346	4027663	1976-01-30	1976-01-30 00:00:00	\N	\N	32020		\N	156164	0	13200003	4027663		0
50306	2975	260139	2004-04-06	2004-04-06 00:00:00	2004-04-13	2004-04-13 00:00:00	32020		\N	198643	0	10509002	260139		0
50490	2987	40481087	1993-03-04	1993-03-04 00:00:00	1993-03-11	1993-03-11 00:00:00	32020		\N	199393	0	444814009	40481087		0
40152	2381	40481087	1986-10-07	1986-10-07 00:00:00	1986-10-14	1986-10-14 00:00:00	32020		\N	158298	0	444814009	40481087		0
40329	2392	4035415	1916-11-30	1916-11-30 00:00:00	1916-12-30	1916-12-30 00:00:00	32020		\N	159007	0	239720000	4035415		0
40451	2402	40481087	2011-09-16	2011-09-16 00:00:00	2011-10-07	2011-10-07 00:00:00	32020		\N	159663	0	444814009	40481087		0
51190	3030	40481087	1993-09-11	1993-09-11 00:00:00	1993-09-18	1993-09-18 00:00:00	32020		\N	202012	0	444814009	40481087		0
51304	3041	4296204	1987-02-09	1987-02-09 00:00:00	1987-03-09	1987-03-09 00:00:00	32020		\N	202462	0	403190006	4296204		0
51473	3056	372328	1959-01-31	1959-01-31 00:00:00	1959-06-05	1959-06-05 00:00:00	32020		\N	203260	0	65363002	372328		0
51725	3067	260139	1991-09-10	1991-09-10 00:00:00	1991-09-17	1991-09-17 00:00:00	32020		\N	204103	0	10509002	260139		0
51842	3074	381316	1993-11-10	1993-11-10 00:00:00	\N	\N	32020		\N	204591	0	230690007	381316		0
51985	3080	40481087	1995-07-20	1995-07-20 00:00:00	1995-08-10	1995-08-10 00:00:00	32020		\N	205018	0	444814009	40481087		0
52144	3087	4112343	1992-12-09	1992-12-09 00:00:00	1992-12-20	1992-12-20 00:00:00	32020		\N	205517	0	195662009	4112343		0
41801	2486	40481087	2015-05-02	2015-05-02 00:00:00	2015-05-23	2015-05-23 00:00:00	32020		\N	164758	0	444814009	40481087		0
52585	3115	40481087	2013-01-11	2013-01-11 00:00:00	2013-01-18	2013-01-18 00:00:00	32020		\N	207213	0	444814009	40481087		0
52729	3123	40481087	2017-06-14	2017-06-14 00:00:00	2017-06-28	2017-06-28 00:00:00	32020		\N	207838	0	444814009	40481087		0
52900	3133	40481087	1976-09-03	1976-09-03 00:00:00	1976-09-17	1976-09-17 00:00:00	32020		\N	208445	0	444814009	40481087		0
53081	3144	4218389	1980-10-31	1980-10-31 00:00:00	1980-11-28	1980-11-28 00:00:00	32020		\N	209184	0	39848009	4218389		0
42533	2535	4112343	1969-02-15	1969-02-15 00:00:00	1969-02-23	1969-02-23 00:00:00	32020		\N	167481	0	195662009	4112343		0
42770	2548	4112343	1982-06-25	1982-06-25 00:00:00	1982-07-02	1982-07-02 00:00:00	32020		\N	168680	0	195662009	4112343		0
42896	2554	40481087	2016-04-01	2016-04-01 00:00:00	2016-04-22	2016-04-22 00:00:00	32020		\N	169224	0	444814009	40481087		0
43039	2563	40481087	1978-05-16	1978-05-16 00:00:00	1978-05-30	1978-05-30 00:00:00	32020		\N	169787	0	444814009	40481087		0
32620	1936	81151	1965-02-03	1965-02-03 00:00:00	1965-03-10	1965-03-10 00:00:00	32020		\N	128757	0	44465007	81151		0
43413	2586	260139	1983-12-11	1983-12-11 00:00:00	1983-12-25	1983-12-25 00:00:00	32020		\N	171144	0	10509002	260139		0
32996	1958	440086	1981-07-24	1981-07-24 00:00:00	1981-11-20	1981-11-20 00:00:00	32020		\N	130271	0	192127007	440086		0
43678	2602	321042	1964-11-04	1964-11-04 00:00:00	\N	\N	32020		\N	172145	0	410429000	321042		0
43827	2610	257012	1978-12-12	1978-12-12 00:00:00	\N	\N	32020		\N	172540	0	40055000	257012		0
44036	2619	260139	1943-09-18	1943-09-18 00:00:00	1943-10-02	1943-10-02 00:00:00	32020		\N	173140	0	10509002	260139		0
33693	1999	80180	2017-02-05	2017-02-05 00:00:00	\N	\N	32020		\N	133128	0	396275006	80180		0
33821	2006	260139	1993-10-17	1993-10-17 00:00:00	1993-10-31	1993-10-31 00:00:00	32020		\N	133569	0	10509002	260139		0
44554	2651	81151	1951-06-24	1951-06-24 00:00:00	1951-07-29	1951-07-29 00:00:00	32020		\N	175415	0	44465007	81151		0
44688	2659	4294548	1979-12-26	1979-12-26 00:00:00	1980-03-05	1980-03-05 00:00:00	32020		\N	176134	0	75498004	4294548		0
44861	2669	40481087	1987-11-10	1987-11-10 00:00:00	1987-12-01	1987-12-01 00:00:00	32020		\N	176787	0	444814009	40481087		0
45053	2680	4112343	1985-01-14	1985-01-14 00:00:00	1985-01-21	1985-01-21 00:00:00	32020		\N	177541	0	195662009	4112343		0
34632	2056	257012	1993-10-13	1993-10-13 00:00:00	\N	\N	32020		\N	136733	0	40055000	257012		0
45434	2702	4155034	1947-04-10	1947-04-10 00:00:00	1947-04-24	1947-04-24 00:00:00	32020		\N	179039	0	283371005	4155034		0
45526	2706	40481087	1990-05-23	1990-05-23 00:00:00	1990-06-13	1990-06-13 00:00:00	32020		\N	179292	0	444814009	40481087		0
35182	2087	4283893	1957-07-28	1957-07-28 00:00:00	1957-10-13	1957-10-13 00:00:00	32020		\N	139040	0	36971009	4283893		0
35313	2091	80180	2001-10-26	2001-10-26 00:00:00	\N	\N	32020		\N	139435	0	396275006	80180		0
46073	2745	4112343	2004-11-02	2004-11-02 00:00:00	2004-11-10	2004-11-10 00:00:00	32020		\N	181588	0	195662009	4112343		0
46175	2750	260139	2003-01-24	2003-01-24 00:00:00	2003-01-31	2003-01-31 00:00:00	32020		\N	181958	0	10509002	260139		0
46315	2758	313217	2005-11-18	2005-11-18 00:00:00	\N	\N	32020		\N	182395	0	49436004	313217		0
35984	2134	40481087	1983-10-12	1983-10-12 00:00:00	1983-11-02	1983-11-02 00:00:00	32020		\N	141978	0	444814009	40481087		0
46683	2777	4237458	2007-02-03	2007-02-03 00:00:00	2007-03-05	2007-03-05 00:00:00	32020		\N	183937	0	58150001	4237458		0
46819	2786	4112343	2014-10-21	2014-10-21 00:00:00	2014-10-31	2014-10-31 00:00:00	32020		\N	184539	0	195662009	4112343		0
47047	2799	4112343	1986-06-02	1986-06-02 00:00:00	1986-06-14	1986-06-14 00:00:00	32020		\N	185504	0	195662009	4112343		0
47167	2804	4112343	1999-06-14	1999-06-14 00:00:00	1999-06-24	1999-06-24 00:00:00	32020		\N	185868	0	195662009	4112343		0
47325	2815	4112343	1987-08-12	1987-08-12 00:00:00	1987-08-25	1987-08-25 00:00:00	32020		\N	186492	0	195662009	4112343		0
47493	2825	40481087	1972-10-26	1972-10-26 00:00:00	1972-11-16	1972-11-16 00:00:00	32020		\N	187270	0	444814009	40481087		0
37147	2200	4218389	1997-05-10	1997-05-10 00:00:00	1997-06-14	1997-06-14 00:00:00	32020		\N	146685	0	39848009	4218389		0
37347	2211	4112343	1989-09-08	1989-09-08 00:00:00	1989-09-20	1989-09-20 00:00:00	32020		\N	147298	0	195662009	4112343		0
48025	2849	40481087	1985-07-31	1985-07-31 00:00:00	1985-08-07	1985-08-07 00:00:00	32020		\N	189247	0	444814009	40481087		0
37647	2232	40481087	2018-05-15	2018-05-15 00:00:00	2018-05-29	2018-05-29 00:00:00	32020		\N	148527	0	444814009	40481087		0
37803	2240	4112343	2012-09-16	2012-09-16 00:00:00	2012-09-26	2012-09-26 00:00:00	32020		\N	149118	0	195662009	4112343		0
48532	2872	440448	1979-03-07	1979-03-07 00:00:00	\N	\N	32020		\N	191206	0	74400008	440448		0
48748	2889	40481087	1970-11-29	1970-11-29 00:00:00	1970-12-20	1970-12-20 00:00:00	32020		\N	192149	0	444814009	40481087		0
48822	2892	40481087	1985-04-21	1985-04-21 00:00:00	1985-05-05	1985-05-05 00:00:00	32020		\N	192396	0	444814009	40481087		0
59603	3532	30753	2006-08-27	2006-08-27 00:00:00	\N	\N	32020		\N	234625	0	16761005	30753		0
49066	2904	40481087	1977-06-06	1977-06-06 00:00:00	1977-06-20	1977-06-20 00:00:00	32020		\N	193502	0	444814009	40481087		0
49250	2913	4112343	1959-12-27	1959-12-27 00:00:00	1960-01-05	1960-01-05 00:00:00	32020		\N	194095	0	195662009	4112343		0
49355	2917	40481087	2014-02-22	2014-02-22 00:00:00	2014-03-08	2014-03-08 00:00:00	32020		\N	194471	0	444814009	40481087		0
49494	2927	378001	2007-11-28	2007-11-28 00:00:00	2007-12-28	2007-12-28 00:00:00	32020		\N	195299	0	62106007	378001		0
49714	2942	4027663	1987-07-21	1987-07-21 00:00:00	\N	\N	32020		\N	196143	0	13200003	4027663		0
39273	2330	40481087	2008-09-15	2008-09-15 00:00:00	2008-09-29	2008-09-29 00:00:00	32020		\N	154994	0	444814009	40481087		0
50003	2955	40481087	2001-02-22	2001-02-22 00:00:00	2001-03-08	2001-03-08 00:00:00	32020		\N	197225	0	444814009	40481087		0
39620	2346	372328	1946-12-03	1946-12-03 00:00:00	1947-01-15	1947-01-15 00:00:00	32020		\N	156200	0	65363002	372328		0
50307	2975	40481087	1996-09-09	1996-09-09 00:00:00	1996-09-30	1996-09-30 00:00:00	32020		\N	198690	0	444814009	40481087		0
50491	2987	28060	1992-10-01	1992-10-01 00:00:00	1992-10-13	1992-10-13 00:00:00	32020		\N	199413	0	43878008	28060		0
40153	2381	4112343	2007-10-08	2007-10-08 00:00:00	2007-10-19	2007-10-19 00:00:00	32020		\N	158300	0	195662009	4112343		0
40330	2392	260139	2019-02-17	2019-02-17 00:00:00	2019-03-03	2019-03-03 00:00:00	32020		\N	159046	0	10509002	260139		0
40452	2402	80180	2014-03-18	2014-03-18 00:00:00	\N	\N	32020		\N	159677	0	396275006	80180		0
51191	3030	40481087	1989-06-13	1989-06-13 00:00:00	1989-06-27	1989-06-27 00:00:00	32020		\N	202029	0	444814009	40481087		0
51305	3041	40481087	2013-02-23	2013-02-23 00:00:00	2013-03-09	2013-03-09 00:00:00	32020		\N	202475	0	444814009	40481087		0
51474	3056	4156265	1981-02-20	1981-02-20 00:00:00	1981-03-06	1981-03-06 00:00:00	32020		\N	203307	0	370247008	4156265		0
51726	3067	260139	1994-10-18	1994-10-18 00:00:00	1994-11-01	1994-11-01 00:00:00	32020		\N	204178	0	10509002	260139		0
51843	3074	4283893	1975-04-10	1975-04-10 00:00:00	1975-08-14	1975-08-14 00:00:00	32020		\N	204597	0	36971009	4283893		0
51986	3080	372328	1946-06-09	1946-06-09 00:00:00	1946-11-28	1946-11-28 00:00:00	32020		\N	205021	0	65363002	372328		0
52145	3087	260139	1955-12-07	1955-12-07 00:00:00	1955-12-21	1955-12-21 00:00:00	32020		\N	205502	0	10509002	260139		0
41802	2486	378001	2003-01-19	2003-01-19 00:00:00	2003-02-18	2003-02-18 00:00:00	32020		\N	164713	0	62106007	378001		0
52586	3115	4294548	2009-05-02	2009-05-02 00:00:00	2009-10-24	2009-10-24 00:00:00	32020		\N	207260	0	75498004	4294548		0
52730	3123	260139	2016-10-06	2016-10-06 00:00:00	2016-10-13	2016-10-13 00:00:00	32020		\N	207837	0	10509002	260139		0
52901	3133	372328	1958-10-21	1958-10-21 00:00:00	1959-01-28	1959-01-28 00:00:00	32020		\N	208473	0	65363002	372328		0
53082	3144	372328	1965-05-02	1965-05-02 00:00:00	1965-11-03	1965-11-03 00:00:00	32020		\N	209209	0	65363002	372328		0
42537	2537	260139	2006-10-08	2006-10-08 00:00:00	2006-10-22	2006-10-22 00:00:00	32020		\N	167675	0	10509002	260139		0
42771	2548	80180	1997-11-14	1997-11-14 00:00:00	\N	\N	32020		\N	168717	0	396275006	80180		0
42897	2554	195588	1967-07-19	1967-07-19 00:00:00	1967-08-25	1967-08-25 00:00:00	32020		\N	169263	0	38822007	195588		0
43040	2563	257012	1997-03-16	1997-03-16 00:00:00	\N	\N	32020		\N	169807	0	40055000	257012		0
32621	1936	4112343	1953-07-04	1953-07-04 00:00:00	1953-07-13	1953-07-13 00:00:00	32020		\N	128826	0	195662009	4112343		0
43414	2586	40486433	1973-07-06	1973-07-06 00:00:00	\N	\N	32020		\N	171161	0	446096008	40486433		0
32997	1958	4112343	1996-11-26	1996-11-26 00:00:00	1996-12-03	1996-12-03 00:00:00	32020		\N	130248	0	195662009	4112343		0
43680	2602	4112343	1998-04-11	1998-04-11 00:00:00	1998-04-20	1998-04-20 00:00:00	32020		\N	172160	0	195662009	4112343		0
43828	2610	40481087	1996-10-13	1996-10-13 00:00:00	1996-11-02	1996-11-02 00:00:00	32020		\N	172549	0	444814009	40481087		0
44037	2620	4112343	1966-02-03	1966-02-03 00:00:00	1966-02-15	1966-02-15 00:00:00	32020		\N	173275	0	195662009	4112343		0
33694	1999	372328	1978-06-20	1978-06-20 00:00:00	1978-09-01	1978-09-01 00:00:00	32020		\N	133043	0	65363002	372328		0
33822	2007	260139	1993-07-29	1993-07-29 00:00:00	1993-08-05	1993-08-05 00:00:00	32020		\N	133692	0	10509002	260139		0
44555	2651	40481087	2003-06-07	2003-06-07 00:00:00	2003-06-14	2003-06-14 00:00:00	32020		\N	175383	0	444814009	40481087		0
44689	2659	4237458	2017-02-20	2017-02-20 00:00:00	2017-04-21	2017-04-21 00:00:00	32020		\N	176149	0	58150001	4237458		0
44862	2669	260139	1980-05-22	1980-05-22 00:00:00	1980-05-29	1980-05-29 00:00:00	32020		\N	176784	0	10509002	260139		0
45054	2680	4112343	1977-09-13	1977-09-13 00:00:00	1977-09-22	1977-09-22 00:00:00	32020		\N	177540	0	195662009	4112343		0
34633	2056	4155034	2001-04-30	2001-04-30 00:00:00	2001-05-14	2001-05-14 00:00:00	32020		\N	136717	0	283371005	4155034		0
45435	2702	375671	1989-05-13	1989-05-13 00:00:00	1989-06-12	1989-06-12 00:00:00	32020		\N	179041	0	62564004	375671		0
45527	2706	4218389	2010-02-20	2010-02-20 00:00:00	2010-03-27	2010-03-27 00:00:00	32020		\N	179297	0	39848009	4218389		0
35183	2087	28060	1951-06-21	1951-06-21 00:00:00	1951-06-29	1951-06-29 00:00:00	32020		\N	139028	0	43878008	28060		0
35314	2091	40481087	2016-05-28	2016-05-28 00:00:00	2016-06-18	2016-06-18 00:00:00	32020		\N	139439	0	444814009	40481087		0
46074	2745	4112343	1992-09-24	1992-09-24 00:00:00	1992-10-03	1992-10-03 00:00:00	32020		\N	181553	0	195662009	4112343		0
46176	2750	4109685	1949-05-01	1949-05-01 00:00:00	1949-05-15	1949-05-15 00:00:00	32020		\N	181871	0	284551006	4109685		0
46316	2758	4146173	1983-12-07	1983-12-07 00:00:00	1984-02-05	1984-02-05 00:00:00	32020		\N	182401	0	307731004	4146173		0
35985	2134	4310024	1986-04-30	1986-04-30 00:00:00	\N	\N	32020		\N	141978	0	424802006	4310024		0
46684	2777	40481087	1988-06-28	1988-06-28 00:00:00	1988-07-12	1988-07-12 00:00:00	32020		\N	183925	0	444814009	40481087		0
46820	2786	4155034	2006-12-23	2006-12-23 00:00:00	2007-01-06	2007-01-06 00:00:00	32020		\N	184615	0	283371005	4155034		0
47048	2799	40481087	2015-05-02	2015-05-02 00:00:00	2015-05-09	2015-05-09 00:00:00	32020		\N	185474	0	444814009	40481087		0
47168	2804	40481087	2010-08-09	2010-08-09 00:00:00	2010-08-23	2010-08-23 00:00:00	32020		\N	185869	0	444814009	40481087		0
47326	2815	4116491	1998-09-05	1998-09-05 00:00:00	1998-10-12	1998-10-12 00:00:00	32020		\N	186519	0	301011002	4116491		0
47494	2825	4142905	1991-03-02	1991-03-02 00:00:00	1991-05-31	1991-05-31 00:00:00	32020		\N	187332	0	33737001	4142905		0
37148	2200	4112343	1995-09-28	1995-09-28 00:00:00	1995-10-09	1995-10-09 00:00:00	32020		\N	146639	0	195662009	4112343		0
37348	2211	440086	1985-06-16	1985-06-16 00:00:00	1986-10-19	1986-10-19 00:00:00	32020		\N	147322	0	192127007	440086		0
48026	2849	4112343	1939-04-16	1939-04-16 00:00:00	1939-04-28	1939-04-28 00:00:00	32020		\N	189277	0	195662009	4112343		0
37648	2232	4294548	1971-04-26	1971-04-26 00:00:00	1971-05-31	1971-05-31 00:00:00	32020		\N	148536	0	75498004	4294548		0
37804	2240	40481087	2014-03-31	2014-03-31 00:00:00	2014-04-07	2014-04-07 00:00:00	32020		\N	149103	0	444814009	40481087		0
48533	2872	40481087	1962-11-12	1962-11-12 00:00:00	1962-12-03	1962-12-03 00:00:00	32020		\N	191219	0	444814009	40481087		0
48749	2889	40481087	1991-11-07	1991-11-07 00:00:00	1991-11-14	1991-11-14 00:00:00	32020		\N	192150	0	444814009	40481087		0
48823	2892	4112343	2015-04-09	2015-04-09 00:00:00	2015-04-21	2015-04-21 00:00:00	32020		\N	192414	0	195662009	4112343		0
49067	2904	195588	2012-05-09	2012-05-09 00:00:00	2012-06-20	2012-06-20 00:00:00	32020		\N	193490	0	38822007	195588		0
49251	2913	4237458	1948-01-14	1948-01-14 00:00:00	1948-02-13	1948-02-13 00:00:00	32020		\N	194138	0	58150001	4237458		0
49356	2917	4112343	1966-05-14	1966-05-14 00:00:00	1966-05-27	1966-05-27 00:00:00	32020		\N	194455	0	195662009	4112343		0
49495	2927	40481087	2007-08-02	2007-08-02 00:00:00	2007-08-09	2007-08-09 00:00:00	32020		\N	195214	0	444814009	40481087		0
49715	2942	40481087	1989-11-21	1989-11-21 00:00:00	1989-12-05	1989-12-05 00:00:00	32020		\N	196092	0	444814009	40481087		0
39274	2330	40481087	1986-12-11	1986-12-11 00:00:00	1986-12-25	1986-12-25 00:00:00	32020		\N	154977	0	444814009	40481087		0
50004	2955	40481087	1984-12-05	1984-12-05 00:00:00	1984-12-26	1984-12-26 00:00:00	32020		\N	197236	0	444814009	40481087		0
39621	2346	4142905	2016-09-10	2016-09-10 00:00:00	2016-12-09	2016-12-09 00:00:00	32020		\N	156220	0	33737001	4142905		0
50308	2975	260139	1973-09-09	1973-09-09 00:00:00	1973-09-16	1973-09-16 00:00:00	32020		\N	198567	0	10509002	260139		0
50492	2987	28060	1983-02-24	1983-02-24 00:00:00	1983-03-05	1983-03-05 00:00:00	32020		\N	199411	0	43878008	28060		0
40154	2381	4112343	1938-08-08	1938-08-08 00:00:00	1938-08-18	1938-08-18 00:00:00	32020		\N	158283	0	195662009	4112343		0
40332	2394	4142905	1979-10-20	1979-10-20 00:00:00	1979-12-19	1979-12-19 00:00:00	32020		\N	159214	0	33737001	4142905		0
40453	2402	40481087	2014-02-01	2014-02-01 00:00:00	2014-02-22	2014-02-22 00:00:00	32020		\N	159677	0	444814009	40481087		0
51192	3030	260139	1984-09-03	1984-09-03 00:00:00	1984-09-17	1984-09-17 00:00:00	32020		\N	202011	0	10509002	260139		0
51306	3041	378001	2005-04-03	2005-04-03 00:00:00	2005-06-02	2005-06-02 00:00:00	32020		\N	202490	0	62106007	378001		0
51475	3056	40481087	1966-12-12	1966-12-12 00:00:00	1966-12-19	1966-12-19 00:00:00	32020		\N	203249	0	444814009	40481087		0
51727	3067	4112343	1955-07-12	1955-07-12 00:00:00	1955-07-20	1955-07-20 00:00:00	32020		\N	204100	0	195662009	4112343		0
51844	3074	4218389	1971-07-19	1971-07-19 00:00:00	1971-08-09	1971-08-09 00:00:00	32020		\N	204572	0	39848009	4218389		0
51987	3080	4237458	2014-10-02	2014-10-02 00:00:00	2014-12-01	2014-12-01 00:00:00	32020		\N	205010	0	58150001	4237458		0
52146	3087	4112343	2008-05-03	2008-05-03 00:00:00	2008-05-13	2008-05-13 00:00:00	32020		\N	205506	0	195662009	4112343		0
41803	2486	4112343	1979-10-26	1979-10-26 00:00:00	1979-11-08	1979-11-08 00:00:00	32020		\N	164739	0	195662009	4112343		0
52587	3115	321042	1991-01-04	1991-01-04 00:00:00	\N	\N	32020		\N	207279	0	410429000	321042		0
52731	3123	378001	1996-04-23	1996-04-23 00:00:00	1996-06-22	1996-06-22 00:00:00	32020		\N	207819	0	62106007	378001		0
52902	3133	372328	1964-03-28	1964-03-28 00:00:00	1965-02-24	1965-02-24 00:00:00	32020		\N	208526	0	65363002	372328		0
53083	3144	40481087	1988-11-20	1988-11-20 00:00:00	1988-12-04	1988-12-04 00:00:00	32020		\N	209203	0	444814009	40481087		0
42538	2537	80180	1990-01-23	1990-01-23 00:00:00	\N	\N	32020		\N	167694	0	396275006	80180		0
42772	2548	4218389	1998-03-14	1998-03-14 00:00:00	1998-04-18	1998-04-18 00:00:00	32020		\N	168693	0	39848009	4218389		0
42898	2554	80180	1968-02-09	1968-02-09 00:00:00	\N	\N	32020		\N	169263	0	396275006	80180		0
43041	2563	4112343	1998-04-21	1998-04-21 00:00:00	1998-05-04	1998-05-04 00:00:00	32020		\N	169797	0	195662009	4112343		0
32622	1937	257012	2006-06-18	2006-06-18 00:00:00	\N	\N	32020		\N	128907	0	40055000	257012		0
43415	2586	4112343	1989-07-22	1989-07-22 00:00:00	1989-07-30	1989-07-30 00:00:00	32020		\N	171197	0	195662009	4112343		0
32998	1958	4027663	1998-07-20	1998-07-20 00:00:00	\N	\N	32020		\N	130248	0	13200003	4027663		0
43681	2602	4109685	1992-01-03	1992-01-03 00:00:00	1992-01-24	1992-01-24 00:00:00	32020		\N	172146	0	284551006	4109685		0
43829	2610	40481087	1971-06-20	1971-06-20 00:00:00	1971-07-11	1971-07-11 00:00:00	32020		\N	172584	0	444814009	40481087		0
44038	2620	4112343	2001-11-25	2001-11-25 00:00:00	2001-12-02	2001-12-02 00:00:00	32020		\N	173276	0	195662009	4112343		0
33695	1999	372328	1982-10-10	1982-10-10 00:00:00	1983-09-30	1983-09-30 00:00:00	32020		\N	133140	0	65363002	372328		0
33823	2007	260139	2015-01-14	2015-01-14 00:00:00	2015-01-28	2015-01-28 00:00:00	32020		\N	133668	0	10509002	260139		0
44556	2651	81151	2006-07-11	2006-07-11 00:00:00	2006-07-25	2006-07-25 00:00:00	32020		\N	175423	0	44465007	81151		0
44690	2659	80180	2006-07-08	2006-07-08 00:00:00	\N	\N	32020		\N	176173	0	396275006	80180		0
44863	2669	4112343	1982-02-14	1982-02-14 00:00:00	1982-02-22	1982-02-22 00:00:00	32020		\N	176785	0	195662009	4112343		0
45055	2680	4109685	1976-09-14	1976-09-14 00:00:00	1976-09-28	1976-09-28 00:00:00	32020		\N	177554	0	284551006	4109685		0
34634	2056	372328	1987-12-10	1987-12-10 00:00:00	1988-03-02	1988-03-02 00:00:00	32020		\N	136711	0	65363002	372328		0
45436	2702	375671	1964-01-25	1964-01-25 00:00:00	1964-03-25	1964-03-25 00:00:00	32020		\N	179040	0	62564004	375671		0
45528	2706	40481087	2018-11-07	2018-11-07 00:00:00	2018-11-14	2018-11-14 00:00:00	32020		\N	179295	0	444814009	40481087		0
35184	2087	40481087	1972-09-24	1972-09-24 00:00:00	1972-10-15	1972-10-15 00:00:00	32020		\N	139032	0	444814009	40481087		0
35315	2091	4112343	1979-01-12	1979-01-12 00:00:00	1979-01-20	1979-01-20 00:00:00	32020		\N	139432	0	195662009	4112343		0
46075	2745	78272	2004-12-13	2004-12-13 00:00:00	2005-01-10	2005-01-10 00:00:00	32020		\N	181577	0	70704007	78272		0
46177	2750	260139	1997-02-03	1997-02-03 00:00:00	1997-02-17	1997-02-17 00:00:00	32020		\N	181880	0	10509002	260139		0
46317	2758	4112343	1961-07-17	1961-07-17 00:00:00	1961-07-29	1961-07-29 00:00:00	32020		\N	182479	0	195662009	4112343		0
35986	2134	40481087	1960-02-15	1960-02-15 00:00:00	1960-02-22	1960-02-22 00:00:00	32020		\N	141986	0	444814009	40481087		0
46685	2777	195588	2013-03-19	2013-03-19 00:00:00	2013-05-02	2013-05-02 00:00:00	32020		\N	183946	0	38822007	195588		0
46821	2786	81151	1987-11-05	1987-11-05 00:00:00	1987-12-03	1987-12-03 00:00:00	32020		\N	184612	0	44465007	81151		0
47049	2799	4310024	2017-01-18	2017-01-18 00:00:00	\N	\N	32020		\N	185474	0	424802006	4310024		0
47169	2804	260139	2017-08-18	2017-08-18 00:00:00	2017-09-01	2017-09-01 00:00:00	32020		\N	185828	0	10509002	260139		0
47327	2815	80180	1998-12-24	1998-12-24 00:00:00	\N	\N	32020		\N	186519	0	396275006	80180		0
47495	2825	4296204	1946-03-09	1946-03-09 00:00:00	1946-04-13	1946-04-13 00:00:00	32020		\N	187330	0	403190006	4296204		0
37149	2200	4112343	2008-03-06	2008-03-06 00:00:00	2008-03-14	2008-03-14 00:00:00	32020		\N	146627	0	195662009	4112343		0
37349	2211	40481087	1996-07-13	1996-07-13 00:00:00	1996-08-03	1996-08-03 00:00:00	32020		\N	147299	0	444814009	40481087		0
48027	2849	81151	1933-11-18	1933-11-18 00:00:00	1933-12-02	1933-12-02 00:00:00	32020		\N	189291	0	44465007	81151		0
37649	2232	40481087	1987-06-11	1987-06-11 00:00:00	1987-06-25	1987-06-25 00:00:00	32020		\N	148538	0	444814009	40481087		0
37805	2240	40481087	1997-11-13	1997-11-13 00:00:00	1997-12-04	1997-12-04 00:00:00	32020		\N	149117	0	444814009	40481087		0
48534	2872	4112343	1974-11-19	1974-11-19 00:00:00	1974-11-27	1974-11-27 00:00:00	32020		\N	191180	0	195662009	4112343		0
48750	2889	4112343	1977-08-05	1977-08-05 00:00:00	1977-08-14	1977-08-14 00:00:00	32020		\N	192142	0	195662009	4112343		0
48824	2892	28060	1981-05-24	1981-05-24 00:00:00	1981-06-02	1981-06-02 00:00:00	32020		\N	192423	0	43878008	28060		0
49068	2904	40481087	1986-12-06	1986-12-06 00:00:00	1986-12-13	1986-12-13 00:00:00	32020		\N	193503	0	444814009	40481087		0
49252	2913	257012	1957-11-26	1957-11-26 00:00:00	\N	\N	32020		\N	194124	0	40055000	257012		0
49366	2919	80180	1984-03-29	1984-03-29 00:00:00	\N	\N	32020		\N	194616	0	396275006	80180		0
49496	2927	257012	2012-12-30	2012-12-30 00:00:00	\N	\N	32020		\N	195254	0	40055000	257012		0
49716	2942	4134304	1954-05-25	1954-05-25 00:00:00	1954-06-24	1954-06-24 00:00:00	32020		\N	196054	0	263102004	4134304		0
39275	2330	80180	2008-06-27	2008-06-27 00:00:00	\N	\N	32020		\N	154973	0	396275006	80180		0
50005	2955	40481087	1988-08-14	1988-08-14 00:00:00	1988-08-21	1988-08-21 00:00:00	32020		\N	197205	0	444814009	40481087		0
39622	2346	378001	1991-11-21	1991-11-21 00:00:00	1991-12-21	1991-12-21 00:00:00	32020		\N	156219	0	62106007	378001		0
50309	2975	260139	2008-05-24	2008-05-24 00:00:00	2008-05-31	2008-05-31 00:00:00	32020		\N	198580	0	10509002	260139		0
50493	2987	80180	2015-05-02	2015-05-02 00:00:00	\N	\N	32020		\N	199367	0	396275006	80180		0
40155	2381	378001	1952-01-29	1952-01-29 00:00:00	1952-03-29	1952-03-29 00:00:00	32020		\N	158304	0	62106007	378001		0
40333	2394	28060	1919-01-23	1919-01-23 00:00:00	1919-02-02	1919-02-02 00:00:00	32020		\N	159147	0	43878008	28060		0
40454	2402	40481087	2003-03-01	2003-03-01 00:00:00	2003-03-08	2003-03-08 00:00:00	32020		\N	159638	0	444814009	40481087		0
51193	3030	378001	1999-11-24	1999-11-24 00:00:00	2000-01-23	2000-01-23 00:00:00	32020		\N	202024	0	62106007	378001		0
51307	3041	4084167	2005-08-03	2005-08-03 00:00:00	2005-08-04	2005-08-04 00:00:00	32020		\N	202491	0	241929008	4084167		0
51476	3056	4001336	2010-03-04	2010-03-04 00:00:00	2010-05-03	2010-05-03 00:00:00	32020		\N	203233	0	110030002	4001336		0
51728	3067	40481087	2017-10-15	2017-10-15 00:00:00	2017-10-22	2017-10-22 00:00:00	32020		\N	204181	0	444814009	40481087		0
51845	3074	372328	1953-12-20	1953-12-20 00:00:00	1954-02-03	1954-02-03 00:00:00	32020		\N	204541	0	65363002	372328		0
51988	3080	40481087	1950-08-23	1950-08-23 00:00:00	1950-09-06	1950-09-06 00:00:00	32020		\N	205057	0	444814009	40481087		0
52147	3087	80180	1976-04-05	1976-04-05 00:00:00	\N	\N	32020		\N	205597	0	396275006	80180		0
41804	2486	4237458	1996-12-21	1996-12-21 00:00:00	1997-02-19	1997-02-19 00:00:00	32020		\N	164712	0	58150001	4237458		0
52589	3115	4112343	2001-08-15	2001-08-15 00:00:00	2001-08-22	2001-08-22 00:00:00	32020		\N	207210	0	195662009	4112343		0
52732	3123	378001	2011-12-01	2011-12-01 00:00:00	2011-12-31	2011-12-31 00:00:00	32020		\N	207821	0	62106007	378001		0
52903	3133	378001	1965-01-05	1965-01-05 00:00:00	1965-03-06	1965-03-06 00:00:00	32020		\N	208508	0	62106007	378001		0
53084	3144	372328	1966-01-02	1966-01-02 00:00:00	1966-05-04	1966-05-04 00:00:00	32020		\N	209215	0	65363002	372328		0
42539	2537	40481087	1965-11-27	1965-11-27 00:00:00	1965-12-11	1965-12-11 00:00:00	32020		\N	167758	0	444814009	40481087		0
42773	2548	40481087	1980-10-19	1980-10-19 00:00:00	1980-11-09	1980-11-09 00:00:00	32020		\N	168696	0	444814009	40481087		0
42899	2554	40481087	1952-09-06	1952-09-06 00:00:00	1952-09-13	1952-09-13 00:00:00	32020		\N	169112	0	444814009	40481087		0
43042	2563	260139	1991-02-12	1991-02-12 00:00:00	1991-02-26	1991-02-26 00:00:00	32020		\N	169806	0	10509002	260139		0
32623	1937	4152936	1969-12-08	1969-12-08 00:00:00	1969-12-22	1969-12-22 00:00:00	32020		\N	128904	0	283385000	4152936		0
43416	2586	28060	1973-11-18	1973-11-18 00:00:00	1973-11-27	1973-11-27 00:00:00	32020		\N	171162	0	43878008	28060		0
32999	1958	4112343	1972-04-23	1972-04-23 00:00:00	1972-05-04	1972-05-04 00:00:00	32020		\N	130254	0	195662009	4112343		0
43682	2602	40481087	1961-01-28	1961-01-28 00:00:00	1961-02-11	1961-02-11 00:00:00	32020		\N	172130	0	444814009	40481087		0
43830	2610	260139	2011-11-20	2011-11-20 00:00:00	2011-12-04	2011-12-04 00:00:00	32020		\N	172611	0	10509002	260139		0
44039	2620	40481087	2001-10-09	2001-10-09 00:00:00	2001-10-30	2001-10-30 00:00:00	32020		\N	173254	0	444814009	40481087		0
33696	1999	28060	1990-03-22	1990-03-22 00:00:00	1990-04-02	1990-04-02 00:00:00	32020		\N	133070	0	43878008	28060		0
33825	2007	321042	1994-07-17	1994-07-17 00:00:00	\N	\N	32020		\N	133660	0	410429000	321042		0
44557	2651	4112343	1969-08-19	1969-08-19 00:00:00	1969-08-27	1969-08-27 00:00:00	32020		\N	175444	0	195662009	4112343		0
44691	2659	40481087	1998-05-23	1998-05-23 00:00:00	1998-05-30	1998-05-30 00:00:00	32020		\N	176120	0	444814009	40481087		0
44864	2669	4112343	2008-01-05	2008-01-05 00:00:00	2008-01-16	2008-01-16 00:00:00	32020		\N	176814	0	195662009	4112343		0
45056	2680	4112343	1991-10-20	1991-10-20 00:00:00	1991-10-30	1991-10-30 00:00:00	32020		\N	177524	0	195662009	4112343		0
34635	2056	40481087	2010-08-01	2010-08-01 00:00:00	2010-08-22	2010-08-22 00:00:00	32020		\N	136744	0	444814009	40481087		0
45437	2702	4112343	1976-12-29	1976-12-29 00:00:00	1977-01-08	1977-01-08 00:00:00	32020		\N	178964	0	195662009	4112343		0
45529	2706	81151	1975-10-03	1975-10-03 00:00:00	1975-10-17	1975-10-17 00:00:00	32020		\N	179258	0	44465007	81151		0
35185	2087	80502	1998-07-01	1998-07-01 00:00:00	\N	\N	32020		\N	139057	0	64859006	80502		0
35316	2091	4294548	2007-08-21	2007-08-21 00:00:00	2007-09-18	2007-09-18 00:00:00	32020		\N	139436	0	75498004	4294548		0
46076	2745	40481087	2005-10-06	2005-10-06 00:00:00	2005-10-13	2005-10-13 00:00:00	32020		\N	181579	0	444814009	40481087		0
46178	2750	378419	2008-03-05	2008-03-05 00:00:00	\N	\N	32020		\N	181917	0	26929004	378419		0
46318	2758	40481087	1995-02-25	1995-02-25 00:00:00	1995-03-04	1995-03-04 00:00:00	32020		\N	182403	0	444814009	40481087		0
35987	2134	40481087	1963-02-09	1963-02-09 00:00:00	1963-03-02	1963-03-02 00:00:00	32020		\N	141976	0	444814009	40481087		0
46686	2778	260139	1978-07-17	1978-07-17 00:00:00	1978-07-24	1978-07-24 00:00:00	32020		\N	184005	0	10509002	260139		0
46822	2786	192671	1959-12-27	1959-12-27 00:00:00	\N	\N	32020		\N	184618	0	K92.2	35208414		0
47050	2799	372328	1985-04-06	1985-04-06 00:00:00	1986-03-19	1986-03-19 00:00:00	32020		\N	185507	0	65363002	372328		0
47170	2804	80180	1990-06-17	1990-06-17 00:00:00	\N	\N	32020		\N	185883	0	396275006	80180		0
47328	2815	40481087	1977-10-05	1977-10-05 00:00:00	1977-10-12	1977-10-12 00:00:00	32020		\N	186549	0	444814009	40481087		0
47496	2825	40481087	1926-01-15	1926-01-15 00:00:00	1926-01-29	1926-01-29 00:00:00	32020		\N	187336	0	444814009	40481087		0
37150	2200	4278672	1991-05-12	1991-05-12 00:00:00	1991-08-10	1991-08-10 00:00:00	32020		\N	146684	0	65966004	4278672		0
37350	2211	80180	2007-01-27	2007-01-27 00:00:00	\N	\N	32020		\N	147315	0	396275006	80180		0
48028	2849	260139	1921-07-26	1921-07-26 00:00:00	1921-08-09	1921-08-09 00:00:00	32020		\N	189213	0	10509002	260139		0
37650	2232	40481087	1966-07-02	1966-07-02 00:00:00	1966-07-23	1966-07-23 00:00:00	32020		\N	148519	0	444814009	40481087		0
37806	2240	80180	2000-04-04	2000-04-04 00:00:00	\N	\N	32020		\N	149111	0	396275006	80180		0
48556	2876	80180	2004-12-18	2004-12-18 00:00:00	\N	\N	32020		\N	191358	0	396275006	80180		0
48751	2889	40481087	2005-10-20	2005-10-20 00:00:00	2005-11-03	2005-11-03 00:00:00	32020		\N	192152	0	444814009	40481087		0
48825	2892	40481087	1990-12-18	1990-12-18 00:00:00	1991-01-08	1991-01-08 00:00:00	32020		\N	192413	0	444814009	40481087		0
49069	2904	260139	2005-06-17	2005-06-17 00:00:00	2005-06-24	2005-06-24 00:00:00	32020		\N	193489	0	10509002	260139		0
49253	2913	40481087	1952-12-10	1952-12-10 00:00:00	1952-12-31	1952-12-31 00:00:00	32020		\N	194093	0	444814009	40481087		0
49367	2919	40481087	1952-02-14	1952-02-14 00:00:00	1952-02-28	1952-02-28 00:00:00	32020		\N	194585	0	444814009	40481087		0
49497	2927	40481087	1972-10-31	1972-10-31 00:00:00	1972-11-21	1972-11-21 00:00:00	32020		\N	195251	0	444814009	40481087		0
49717	2942	4112343	2015-09-17	2015-09-17 00:00:00	2015-09-25	2015-09-25 00:00:00	32020		\N	196115	0	195662009	4112343		0
39276	2330	260139	2015-10-21	2015-10-21 00:00:00	2015-10-28	2015-10-28 00:00:00	32020		\N	154988	0	10509002	260139		0
50006	2955	28060	1974-08-27	1974-08-27 00:00:00	1974-09-09	1974-09-09 00:00:00	32020		\N	197235	0	43878008	28060		0
39623	2346	4112343	1950-01-19	1950-01-19 00:00:00	1950-01-27	1950-01-27 00:00:00	32020		\N	156124	0	195662009	4112343		0
50310	2975	4059173	1965-11-18	1965-11-18 00:00:00	1965-12-18	1965-12-18 00:00:00	32020		\N	198626	0	16114001	4059173		0
50494	2987	4134304	1989-01-28	1989-01-28 00:00:00	1989-02-27	1989-02-27 00:00:00	32020		\N	199423	0	263102004	4134304		0
40156	2381	378001	1979-10-02	1979-10-02 00:00:00	1979-12-01	1979-12-01 00:00:00	32020		\N	158307	0	62106007	378001		0
40334	2394	372328	1987-05-27	1987-05-27 00:00:00	1987-10-12	1987-10-12 00:00:00	32020		\N	159203	0	65363002	372328		0
40455	2402	4112343	1977-08-10	1977-08-10 00:00:00	1977-08-20	1977-08-20 00:00:00	32020		\N	159615	0	195662009	4112343		0
51194	3030	40481087	2007-04-11	2007-04-11 00:00:00	2007-04-25	2007-04-25 00:00:00	32020		\N	201984	0	444814009	40481087		0
51308	3041	4112343	2014-05-09	2014-05-09 00:00:00	2014-05-20	2014-05-20 00:00:00	32020		\N	202477	0	195662009	4112343		0
51477	3056	4112343	2016-12-28	2016-12-28 00:00:00	2017-01-10	2017-01-10 00:00:00	32020		\N	203302	0	195662009	4112343		0
51729	3067	260139	1974-08-31	1974-08-31 00:00:00	1974-09-07	1974-09-07 00:00:00	32020		\N	204154	0	10509002	260139		0
51846	3074	4112343	1979-05-24	1979-05-24 00:00:00	1979-06-05	1979-06-05 00:00:00	32020		\N	204539	0	195662009	4112343		0
51989	3080	4112343	1951-09-17	1951-09-17 00:00:00	1951-09-29	1951-09-29 00:00:00	32020		\N	204986	0	195662009	4112343		0
52148	3087	321042	2001-02-28	2001-02-28 00:00:00	\N	\N	32020		\N	205557	0	410429000	321042		0
41805	2486	40481087	1989-03-04	1989-03-04 00:00:00	1989-03-25	1989-03-25 00:00:00	32020		\N	164724	0	444814009	40481087		0
52590	3115	372328	1968-10-26	1968-10-26 00:00:00	1969-03-21	1969-03-21 00:00:00	32020		\N	207214	0	65363002	372328		0
52733	3123	4237458	2005-11-02	2005-11-02 00:00:00	2005-12-02	2005-12-02 00:00:00	32020		\N	207820	0	58150001	4237458		0
52904	3133	4278672	1972-09-25	1972-09-25 00:00:00	1972-12-24	1972-12-24 00:00:00	32020		\N	208509	0	65966004	4278672		0
53085	3144	378001	1985-07-05	1985-07-05 00:00:00	1985-08-04	1985-08-04 00:00:00	32020		\N	209182	0	62106007	378001		0
42540	2537	4051466	1950-08-23	1950-08-23 00:00:00	1966-12-01	1966-12-01 00:00:00	32020		\N	167752	0	233678006	4051466		0
42774	2548	40481087	1986-07-19	1986-07-19 00:00:00	1986-08-09	1986-08-09 00:00:00	32020		\N	168681	0	444814009	40481087		0
42900	2554	372328	1936-06-11	1936-06-11 00:00:00	1936-07-02	1936-07-02 00:00:00	32020		\N	169128	0	65363002	372328		0
43043	2563	4156265	1986-06-04	1986-06-04 00:00:00	1986-06-18	1986-06-18 00:00:00	32020		\N	169792	0	370247008	4156265		0
32624	1937	4155034	1979-07-10	1979-07-10 00:00:00	1979-07-31	1979-07-31 00:00:00	32020		\N	128906	0	283371005	4155034		0
43417	2586	4266809	2007-09-04	2007-09-04 00:00:00	\N	\N	32020		\N	171138	0	397881000	4266809		0
33000	1958	78272	1989-09-20	1989-09-20 00:00:00	1989-10-25	1989-10-25 00:00:00	32020		\N	130243	0	70704007	78272		0
43683	2602	4310024	1985-10-20	1985-10-20 00:00:00	\N	\N	32020		\N	172108	0	424802006	4310024		0
43831	2610	40481087	1961-09-20	1961-09-20 00:00:00	1961-09-27	1961-09-27 00:00:00	32020		\N	172543	0	444814009	40481087		0
44040	2620	40481087	1979-03-20	1979-03-20 00:00:00	1979-04-03	1979-04-03 00:00:00	32020		\N	173252	0	444814009	40481087		0
33697	1999	134438	2011-09-22	2011-09-22 00:00:00	2012-07-19	2012-07-19 00:00:00	32020		\N	133113	0	40275004	134438		0
33826	2007	40481087	2004-01-31	2004-01-31 00:00:00	2004-02-14	2004-02-14 00:00:00	32020		\N	133667	0	444814009	40481087		0
44558	2651	40481087	2016-06-03	2016-06-03 00:00:00	2016-06-24	2016-06-24 00:00:00	32020		\N	175489	0	444814009	40481087		0
44692	2659	4027663	1999-06-20	1999-06-20 00:00:00	\N	\N	32020		\N	176120	0	13200003	4027663		0
44874	2672	40481087	1975-03-20	1975-03-20 00:00:00	1975-03-27	1975-03-27 00:00:00	32020		\N	177014	0	444814009	40481087		0
45057	2680	4294548	1997-02-24	1997-02-24 00:00:00	1997-04-07	1997-04-07 00:00:00	32020		\N	177526	0	75498004	4294548		0
34636	2056	260139	1994-04-09	1994-04-09 00:00:00	1994-04-23	1994-04-23 00:00:00	32020		\N	136709	0	10509002	260139		0
45438	2702	381316	1998-08-09	1998-08-09 00:00:00	\N	\N	32020		\N	179001	0	230690007	381316		0
45530	2706	4112343	1967-10-16	1967-10-16 00:00:00	1967-10-28	1967-10-28 00:00:00	32020		\N	179252	0	195662009	4112343		0
35186	2087	40481087	1946-03-09	1946-03-09 00:00:00	1946-03-23	1946-03-23 00:00:00	32020		\N	139015	0	444814009	40481087		0
35317	2091	40481087	1968-10-04	1968-10-04 00:00:00	1968-10-18	1968-10-18 00:00:00	32020		\N	139474	0	444814009	40481087		0
46077	2745	260139	1995-06-24	1995-06-24 00:00:00	1995-07-01	1995-07-01 00:00:00	32020		\N	181587	0	10509002	260139		0
46179	2750	4112343	1942-06-18	1942-06-18 00:00:00	1942-06-29	1942-06-29 00:00:00	32020		\N	181943	0	195662009	4112343		0
46319	2758	4152936	1941-12-21	1941-12-21 00:00:00	1942-01-11	1942-01-11 00:00:00	32020		\N	182454	0	283385000	4152936		0
35988	2134	40481087	1959-08-26	1959-08-26 00:00:00	1959-09-16	1959-09-16 00:00:00	32020		\N	141974	0	444814009	40481087		0
46687	2778	40481087	2004-01-14	2004-01-14 00:00:00	2004-02-04	2004-02-04 00:00:00	32020		\N	184080	0	444814009	40481087		0
46823	2786	40481087	1953-03-11	1953-03-11 00:00:00	1953-04-01	1953-04-01 00:00:00	32020		\N	184537	0	444814009	40481087		0
47051	2799	4156265	2000-05-17	2000-05-17 00:00:00	2000-05-31	2000-05-31 00:00:00	32020		\N	185477	0	370247008	4156265		0
47171	2804	4112343	1975-09-28	1975-09-28 00:00:00	1975-10-07	1975-10-07 00:00:00	32020		\N	185814	0	195662009	4112343		0
47329	2815	4112343	1969-09-20	1969-09-20 00:00:00	1969-10-02	1969-10-02 00:00:00	32020		\N	186490	0	195662009	4112343		0
47497	2825	40481087	2010-07-20	2010-07-20 00:00:00	2010-07-27	2010-07-27 00:00:00	32020		\N	187310	0	444814009	40481087		0
37151	2200	4027663	2005-06-02	2005-06-02 00:00:00	\N	\N	32020		\N	146680	0	13200003	4027663		0
47809	2839	4152936	2017-08-14	2017-08-14 00:00:00	2017-08-28	2017-08-28 00:00:00	32020		\N	188552	0	283385000	4152936		0
48029	2849	28060	1927-04-08	1927-04-08 00:00:00	1927-04-17	1927-04-17 00:00:00	32020		\N	189246	0	43878008	28060		0
37651	2232	40481087	1997-04-30	1997-04-30 00:00:00	1997-05-14	1997-05-14 00:00:00	32020		\N	148526	0	444814009	40481087		0
37807	2240	40481087	1967-07-18	1967-07-18 00:00:00	1967-08-01	1967-08-01 00:00:00	32020		\N	149115	0	444814009	40481087		0
48557	2876	4116491	2004-09-29	2004-09-29 00:00:00	2004-10-31	2004-10-31 00:00:00	32020		\N	191358	0	301011002	4116491		0
48752	2889	440448	2017-03-07	2017-03-07 00:00:00	\N	\N	32020		\N	192148	0	74400008	440448		0
48826	2892	81151	1974-09-19	1974-09-19 00:00:00	1974-10-17	1974-10-17 00:00:00	32020		\N	192415	0	44465007	81151		0
49070	2904	40481087	2008-08-21	2008-08-21 00:00:00	2008-09-11	2008-09-11 00:00:00	32020		\N	193494	0	444814009	40481087		0
49254	2913	40481087	1949-05-16	1949-05-16 00:00:00	1949-05-23	1949-05-23 00:00:00	32020		\N	194092	0	444814009	40481087		0
49368	2919	4112343	1983-10-06	1983-10-06 00:00:00	1983-10-14	1983-10-14 00:00:00	32020		\N	194563	0	195662009	4112343		0
49498	2927	30753	1981-04-09	1981-04-09 00:00:00	\N	\N	32020		\N	195248	0	16761005	30753		0
49718	2942	40481087	1962-10-15	1962-10-15 00:00:00	1962-11-05	1962-11-05 00:00:00	32020		\N	196105	0	444814009	40481087		0
39277	2330	4112343	1995-04-08	1995-04-08 00:00:00	1995-04-15	1995-04-15 00:00:00	32020		\N	154979	0	195662009	4112343		0
50007	2955	4112343	1997-12-13	1997-12-13 00:00:00	1997-12-24	1997-12-24 00:00:00	32020		\N	197238	0	195662009	4112343		0
39624	2346	40481087	1997-03-17	1997-03-17 00:00:00	1997-04-07	1997-04-07 00:00:00	32020		\N	156150	0	444814009	40481087		0
50311	2975	440448	1975-04-06	1975-04-06 00:00:00	\N	\N	32020		\N	198627	0	74400008	440448		0
50495	2987	4059173	1979-05-21	1979-05-21 00:00:00	1979-08-19	1979-08-19 00:00:00	32020		\N	199368	0	16114001	4059173		0
40157	2381	4112343	1942-10-09	1942-10-09 00:00:00	1942-10-17	1942-10-17 00:00:00	32020		\N	158285	0	195662009	4112343		0
40335	2394	378419	1983-09-19	1983-09-19 00:00:00	\N	\N	32020		\N	159178	0	26929004	378419		0
40456	2402	260139	1998-02-16	1998-02-16 00:00:00	1998-02-23	1998-02-23 00:00:00	32020		\N	159620	0	10509002	260139		0
51195	3030	40481087	2005-07-23	2005-07-23 00:00:00	2005-08-13	2005-08-13 00:00:00	32020		\N	201983	0	444814009	40481087		0
51309	3041	40481087	2019-05-10	2019-05-10 00:00:00	2019-05-24	2019-05-24 00:00:00	32020		\N	202492	0	444814009	40481087		0
51478	3056	40481087	1987-01-13	1987-01-13 00:00:00	1987-01-27	1987-01-27 00:00:00	32020		\N	203298	0	444814009	40481087		0
51730	3067	4112343	1997-11-09	1997-11-09 00:00:00	1997-11-22	1997-11-22 00:00:00	32020		\N	204179	0	195662009	4112343		0
51847	3074	40481087	1999-02-27	1999-02-27 00:00:00	1999-03-20	1999-03-20 00:00:00	32020		\N	204564	0	444814009	40481087		0
51990	3080	260139	1959-11-05	1959-11-05 00:00:00	1959-11-19	1959-11-19 00:00:00	32020		\N	205058	0	10509002	260139		0
52150	3087	40481087	2002-10-04	2002-10-04 00:00:00	2002-10-11	2002-10-11 00:00:00	32020		\N	205518	0	444814009	40481087		0
41806	2486	4027663	2004-03-14	2004-03-14 00:00:00	\N	\N	32020		\N	164741	0	13200003	4027663		0
52591	3115	260139	2000-07-06	2000-07-06 00:00:00	2000-07-20	2000-07-20 00:00:00	32020		\N	207209	0	10509002	260139		0
52734	3123	4218389	1993-07-03	1993-07-03 00:00:00	1993-08-07	1993-08-07 00:00:00	32020		\N	207818	0	39848009	4218389		0
52905	3133	4112343	2002-07-04	2002-07-04 00:00:00	2002-07-15	2002-07-15 00:00:00	32020		\N	208522	0	195662009	4112343		0
53086	3144	28060	1964-01-28	1964-01-28 00:00:00	1964-02-07	1964-02-07 00:00:00	32020		\N	209179	0	43878008	28060		0
42541	2537	40481087	1977-04-17	1977-04-17 00:00:00	1977-04-24	1977-04-24 00:00:00	32020		\N	167716	0	444814009	40481087		0
42775	2548	40481087	2015-05-01	2015-05-01 00:00:00	2015-05-08	2015-05-08 00:00:00	32020		\N	168700	0	444814009	40481087		0
42901	2554	372328	1944-11-05	1944-11-05 00:00:00	1945-07-19	1945-07-19 00:00:00	32020		\N	169129	0	65363002	372328		0
43044	2563	40479768	1972-04-11	1972-04-11 00:00:00	1972-05-18	1972-05-18 00:00:00	32020		\N	169790	0	444470001	40479768		0
32625	1937	4112343	1970-12-27	1970-12-27 00:00:00	1971-01-04	1971-01-04 00:00:00	32020		\N	128847	0	195662009	4112343		0
43418	2586	81893	2005-09-14	2005-09-14 00:00:00	\N	\N	32020		\N	171174	0	64766004	81893		0
33001	1958	372328	1979-05-16	1979-05-16 00:00:00	1979-07-24	1979-07-24 00:00:00	32020		\N	130261	0	65363002	372328		0
43684	2602	381316	1985-09-04	1985-09-04 00:00:00	\N	\N	32020		\N	172108	0	230690007	381316		0
43832	2610	372328	1960-06-20	1960-06-20 00:00:00	1960-12-09	1960-12-09 00:00:00	32020		\N	172612	0	65363002	372328		0
44041	2620	40481087	2005-04-09	2005-04-09 00:00:00	2005-04-30	2005-04-30 00:00:00	32020		\N	173277	0	444814009	40481087		0
33698	1999	260139	1981-03-08	1981-03-08 00:00:00	1981-03-22	1981-03-22 00:00:00	32020		\N	133053	0	10509002	260139		0
33827	2007	28060	1994-05-27	1994-05-27 00:00:00	1994-06-06	1994-06-06 00:00:00	32020		\N	133680	0	43878008	28060		0
44559	2651	81151	2000-11-18	2000-11-18 00:00:00	2000-12-09	2000-12-09 00:00:00	32020		\N	175422	0	44465007	81151		0
44693	2659	40481087	2016-11-30	2016-11-30 00:00:00	2016-12-21	2016-12-21 00:00:00	32020		\N	176136	0	444814009	40481087		0
44875	2672	40481087	1985-09-11	1985-09-11 00:00:00	1985-10-02	1985-10-02 00:00:00	32020		\N	177016	0	444814009	40481087		0
45058	2680	4112343	1999-04-22	1999-04-22 00:00:00	1999-04-29	1999-04-29 00:00:00	32020		\N	177528	0	195662009	4112343		0
34637	2056	4112343	2017-07-22	2017-07-22 00:00:00	2017-07-30	2017-07-30 00:00:00	32020		\N	136710	0	195662009	4112343		0
45439	2702	260139	1986-03-28	1986-03-28 00:00:00	1986-04-06	1986-04-06 00:00:00	32020		\N	178935	0	10509002	260139		0
45531	2706	4294548	2011-08-27	2011-08-27 00:00:00	2011-09-17	2011-09-17 00:00:00	32020		\N	179293	0	75498004	4294548		0
35187	2087	260139	2009-08-06	2009-08-06 00:00:00	2009-08-13	2009-08-13 00:00:00	32020		\N	139011	0	10509002	260139		0
35318	2091	372328	1965-06-12	1965-06-12 00:00:00	1965-07-24	1965-07-24 00:00:00	32020		\N	139444	0	65363002	372328		0
46078	2745	4156265	2017-09-09	2017-09-09 00:00:00	2017-09-30	2017-09-30 00:00:00	32020		\N	181605	0	370247008	4156265		0
46180	2750	4112343	1943-12-24	1943-12-24 00:00:00	1944-01-04	1944-01-04 00:00:00	32020		\N	181883	0	195662009	4112343		0
46327	2760	81151	1971-10-09	1971-10-09 00:00:00	1971-11-06	1971-11-06 00:00:00	32020		\N	182588	0	44465007	81151		0
35989	2134	260139	1955-04-15	1955-04-15 00:00:00	1955-04-22	1955-04-22 00:00:00	32020		\N	141985	0	10509002	260139		0
46688	2778	4112343	2013-07-17	2013-07-17 00:00:00	2013-07-29	2013-07-29 00:00:00	32020		\N	184068	0	195662009	4112343		0
46824	2786	4027663	1953-04-20	1953-04-20 00:00:00	\N	\N	32020		\N	184537	0	13200003	4027663		0
47052	2799	40481087	2010-12-08	2010-12-08 00:00:00	2010-12-15	2010-12-15 00:00:00	32020		\N	185500	0	444814009	40481087		0
47172	2804	4218389	1993-02-13	1993-02-13 00:00:00	1993-03-13	1993-03-13 00:00:00	32020		\N	185853	0	39848009	4218389		0
47330	2815	260139	1992-04-10	1992-04-10 00:00:00	1992-04-17	1992-04-17 00:00:00	32020		\N	186517	0	10509002	260139		0
47498	2825	4278672	2007-12-24	2007-12-24 00:00:00	2008-01-23	2008-01-23 00:00:00	32020		\N	187334	0	65966004	4278672		0
37152	2200	4296204	1982-07-07	1982-07-07 00:00:00	1982-07-28	1982-07-28 00:00:00	32020		\N	146622	0	403190006	4296204		0
47810	2839	372328	1987-08-16	1987-08-16 00:00:00	1988-01-25	1988-01-25 00:00:00	32020		\N	188526	0	65363002	372328		0
48030	2849	40481087	1978-04-11	1978-04-11 00:00:00	1978-05-02	1978-05-02 00:00:00	32020		\N	189266	0	444814009	40481087		0
37652	2232	40481087	2014-08-20	2014-08-20 00:00:00	2014-08-27	2014-08-27 00:00:00	32020		\N	148481	0	444814009	40481087		0
37808	2240	4112343	2005-09-14	2005-09-14 00:00:00	2005-09-27	2005-09-27 00:00:00	32020		\N	149101	0	195662009	4112343		0
48558	2876	372328	1964-08-05	1964-08-05 00:00:00	1964-09-17	1964-09-17 00:00:00	32020		\N	191328	0	65363002	372328		0
48753	2889	260139	1961-06-15	1961-06-15 00:00:00	1961-06-22	1961-06-22 00:00:00	32020		\N	192121	0	10509002	260139		0
48827	2893	440448	1959-05-30	1959-05-30 00:00:00	\N	\N	32020		\N	192461	0	74400008	440448		0
49071	2904	4283893	1972-12-10	1972-12-10 00:00:00	1973-04-01	1973-04-01 00:00:00	32020		\N	193501	0	36971009	4283893		0
49255	2913	80180	1979-06-05	1979-06-05 00:00:00	\N	\N	32020		\N	194140	0	396275006	80180		0
49369	2919	4112343	1956-10-10	1956-10-10 00:00:00	1956-10-18	1956-10-18 00:00:00	32020		\N	194586	0	195662009	4112343		0
49499	2927	81893	1980-12-10	1980-12-10 00:00:00	\N	\N	32020		\N	195248	0	64766004	81893		0
49719	2942	372328	1954-07-24	1954-07-24 00:00:00	1954-10-06	1954-10-06 00:00:00	32020		\N	196211	0	65363002	372328		0
39278	2330	40481087	1976-08-22	1976-08-22 00:00:00	1976-08-29	1976-08-29 00:00:00	32020		\N	154959	0	444814009	40481087		0
50008	2955	4218389	1981-12-23	1981-12-23 00:00:00	1982-01-27	1982-01-27 00:00:00	32020		\N	197250	0	39848009	4218389		0
39625	2346	4142905	1974-08-22	1974-08-22 00:00:00	1974-09-21	1974-09-21 00:00:00	32020		\N	156217	0	33737001	4142905		0
50312	2975	260139	1984-11-03	1984-11-03 00:00:00	1984-11-10	1984-11-10 00:00:00	32020		\N	198623	0	10509002	260139		0
50496	2987	4112343	1981-08-22	1981-08-22 00:00:00	1981-09-01	1981-09-01 00:00:00	32020		\N	199391	0	195662009	4112343		0
40158	2381	257012	2012-12-11	2012-12-11 00:00:00	\N	\N	32020		\N	158336	0	40055000	257012		0
40336	2394	4112343	1962-11-17	1962-11-17 00:00:00	1962-11-24	1962-11-24 00:00:00	32020		\N	159201	0	195662009	4112343		0
40457	2402	40481087	2003-05-16	2003-05-16 00:00:00	2003-05-23	2003-05-23 00:00:00	32020		\N	159622	0	444814009	40481087		0
51223	3035	4112343	1985-02-22	1985-02-22 00:00:00	1985-03-04	1985-03-04 00:00:00	32020		\N	202174	0	195662009	4112343		0
51310	3041	40486433	1980-03-09	1980-03-09 00:00:00	\N	\N	32020		\N	202464	0	446096008	40486433		0
51479	3056	40481087	1983-09-16	1983-09-16 00:00:00	1983-09-23	1983-09-23 00:00:00	32020		\N	203297	0	444814009	40481087		0
51731	3067	40481087	1952-05-05	1952-05-05 00:00:00	1952-05-19	1952-05-19 00:00:00	32020		\N	204099	0	444814009	40481087		0
51848	3074	4112343	1964-06-27	1964-06-27 00:00:00	1964-07-09	1964-07-09 00:00:00	32020		\N	204577	0	195662009	4112343		0
51991	3080	40481087	1943-05-07	1943-05-07 00:00:00	1943-05-14	1943-05-14 00:00:00	32020		\N	204984	0	444814009	40481087		0
52151	3087	40481087	1972-05-08	1972-05-08 00:00:00	1972-05-22	1972-05-22 00:00:00	32020		\N	205515	0	444814009	40481087		0
41807	2486	40481087	2003-09-16	2003-09-16 00:00:00	2003-10-07	2003-10-07 00:00:00	32020		\N	164741	0	444814009	40481087		0
52592	3115	40481087	2001-01-16	2001-01-16 00:00:00	2001-02-06	2001-02-06 00:00:00	32020		\N	207202	0	444814009	40481087		0
52735	3123	4112343	2015-01-03	2015-01-03 00:00:00	2015-01-10	2015-01-10 00:00:00	32020		\N	207799	0	195662009	4112343		0
52906	3133	40481087	2008-05-12	2008-05-12 00:00:00	2008-05-26	2008-05-26 00:00:00	32020		\N	208503	0	444814009	40481087		0
53087	3144	260139	1992-03-10	1992-03-10 00:00:00	1992-03-24	1992-03-24 00:00:00	32020		\N	209212	0	10509002	260139		0
42542	2537	4112343	1988-11-24	1988-11-24 00:00:00	1988-12-03	1988-12-03 00:00:00	32020		\N	167586	0	195662009	4112343		0
42776	2548	28060	2018-01-22	2018-01-22 00:00:00	2018-02-04	2018-02-04 00:00:00	32020		\N	168712	0	43878008	28060		0
42902	2554	40481087	1953-02-17	1953-02-17 00:00:00	1953-02-24	1953-02-24 00:00:00	32020		\N	169211	0	444814009	40481087		0
43045	2563	4112343	1972-10-11	1972-10-11 00:00:00	1972-10-22	1972-10-22 00:00:00	32020		\N	169795	0	195662009	4112343		0
32626	1937	4116491	2004-05-03	2004-05-03 00:00:00	2004-06-16	2004-06-16 00:00:00	32020		\N	128888	0	301011002	4116491		0
43419	2586	4027663	1996-06-23	1996-06-23 00:00:00	\N	\N	32020		\N	171219	0	13200003	4027663		0
33002	1958	192671	2010-10-01	2010-10-01 00:00:00	\N	\N	32020		\N	130274	0	K92.2	35208414		0
43685	2602	40481087	1984-05-19	1984-05-19 00:00:00	1984-06-09	1984-06-09 00:00:00	32020		\N	172108	0	444814009	40481087		0
43833	2610	192671	1992-07-12	1992-07-12 00:00:00	\N	\N	32020		\N	172591	0	K92.2	35208414		0
44042	2620	4112343	1992-08-01	1992-08-01 00:00:00	1992-08-10	1992-08-10 00:00:00	32020		\N	173302	0	195662009	4112343		0
44157	2626	372328	1966-07-03	1966-07-03 00:00:00	1966-12-06	1966-12-06 00:00:00	32020		\N	173719	0	65363002	372328		0
43560	2594	4266809	2015-05-07	2015-05-07 00:00:00	\N	\N	32020		\N	171715	0	397881000	4266809		0
33828	2007	40481087	1993-03-09	1993-03-09 00:00:00	1993-03-23	1993-03-23 00:00:00	32020		\N	133679	0	444814009	40481087		0
44560	2651	260139	1954-02-28	1954-02-28 00:00:00	1954-03-14	1954-03-14 00:00:00	32020		\N	175426	0	10509002	260139		0
44694	2659	257012	1975-02-16	1975-02-16 00:00:00	\N	\N	32020		\N	176115	0	40055000	257012		0
44876	2672	260139	1980-04-12	1980-04-12 00:00:00	1980-04-26	1980-04-26 00:00:00	32020		\N	177026	0	10509002	260139		0
45059	2680	260139	1978-12-18	1978-12-18 00:00:00	1979-01-01	1979-01-01 00:00:00	32020		\N	177560	0	10509002	260139		0
34638	2056	372328	1991-12-12	1991-12-12 00:00:00	1992-03-25	1992-03-25 00:00:00	32020		\N	136746	0	65363002	372328		0
45440	2702	260139	2000-02-20	2000-02-20 00:00:00	2000-02-27	2000-02-27 00:00:00	32020		\N	178936	0	10509002	260139		0
45532	2706	4109685	2001-08-22	2001-08-22 00:00:00	2001-09-05	2001-09-05 00:00:00	32020		\N	179261	0	284551006	4109685		0
35188	2087	4294548	1964-05-02	1964-05-02 00:00:00	1964-12-26	1964-12-26 00:00:00	32020		\N	139046	0	75498004	4294548		0
35319	2091	4283893	1967-10-20	1967-10-20 00:00:00	1967-11-03	1967-11-03 00:00:00	32020		\N	139473	0	36971009	4283893		0
46079	2745	80180	2012-12-25	2012-12-25 00:00:00	\N	\N	32020		\N	181575	0	396275006	80180		0
46181	2750	40481087	1925-07-13	1925-07-13 00:00:00	1925-07-27	1925-07-27 00:00:00	32020		\N	181882	0	444814009	40481087		0
46328	2760	4112343	1971-10-30	1971-10-30 00:00:00	1971-11-07	1971-11-07 00:00:00	32020		\N	182533	0	195662009	4112343		0
35990	2134	378001	1981-03-27	1981-03-27 00:00:00	1981-04-26	1981-04-26 00:00:00	32020		\N	141961	0	62106007	378001		0
46689	2778	260139	2011-04-12	2011-04-12 00:00:00	2011-04-19	2011-04-19 00:00:00	32020		\N	184081	0	10509002	260139		0
46825	2786	195588	1965-04-17	1965-04-17 00:00:00	1965-05-20	1965-05-20 00:00:00	32020		\N	184636	0	38822007	195588		0
47053	2799	4278672	1986-08-29	1986-08-29 00:00:00	1986-11-27	1986-11-27 00:00:00	32020		\N	185475	0	65966004	4278672		0
47173	2804	4112343	1975-07-22	1975-07-22 00:00:00	1975-07-29	1975-07-29 00:00:00	32020		\N	185812	0	195662009	4112343		0
47331	2815	4296204	1973-02-18	1973-02-18 00:00:00	1973-03-18	1973-03-18 00:00:00	32020		\N	186531	0	403190006	4296204		0
47499	2825	260139	1991-10-16	1991-10-16 00:00:00	1991-10-30	1991-10-30 00:00:00	32020		\N	187285	0	10509002	260139		0
37153	2200	4152936	1978-10-12	1978-10-12 00:00:00	1978-10-26	1978-10-26 00:00:00	32020		\N	146621	0	283385000	4152936		0
47811	2839	372328	1973-05-16	1973-05-16 00:00:00	1973-07-30	1973-07-30 00:00:00	32020		\N	188549	0	65363002	372328		0
48031	2849	372328	1921-09-22	1921-09-22 00:00:00	1922-01-30	1922-01-30 00:00:00	32020		\N	189273	0	65363002	372328		0
37653	2232	28060	2019-06-18	2019-06-18 00:00:00	2019-06-25	2019-06-25 00:00:00	32020		\N	148514	0	43878008	28060		0
37809	2240	260139	2004-09-16	2004-09-16 00:00:00	2004-09-23	2004-09-23 00:00:00	32020		\N	149100	0	10509002	260139		0
48559	2876	4283893	1979-09-10	1979-09-10 00:00:00	1979-10-08	1979-10-08 00:00:00	32020		\N	191342	0	36971009	4283893		0
48754	2889	80180	2002-02-23	2002-02-23 00:00:00	\N	\N	32020		\N	192151	0	396275006	80180		0
48828	2893	4059173	1973-09-11	1973-09-11 00:00:00	1973-10-11	1973-10-11 00:00:00	32020		\N	192463	0	16114001	4059173		0
49072	2904	372328	1973-07-24	1973-07-24 00:00:00	1973-10-24	1973-10-24 00:00:00	32020		\N	193495	0	65363002	372328		0
49256	2913	40481087	1978-05-26	1978-05-26 00:00:00	1978-06-16	1978-06-16 00:00:00	32020		\N	194140	0	444814009	40481087		0
49370	2919	40481087	2012-09-19	2012-09-19 00:00:00	2012-09-26	2012-09-26 00:00:00	32020		\N	194638	0	444814009	40481087		0
49500	2927	260139	1958-05-21	1958-05-21 00:00:00	1958-06-04	1958-06-04 00:00:00	32020		\N	195199	0	10509002	260139		0
49720	2942	4112343	1978-08-28	1978-08-28 00:00:00	1978-09-06	1978-09-06 00:00:00	32020		\N	196108	0	195662009	4112343		0
39290	2332	80180	1996-10-27	1996-10-27 00:00:00	\N	\N	32020		\N	155117	0	396275006	80180		0
50009	2955	260139	1975-04-30	1975-04-30 00:00:00	1975-05-07	1975-05-07 00:00:00	32020		\N	197203	0	10509002	260139		0
39626	2346	4134304	1982-08-10	1982-08-10 00:00:00	1982-11-08	1982-11-08 00:00:00	32020		\N	156218	0	263102004	4134304		0
50313	2975	4084167	1975-05-30	1975-05-30 00:00:00	1975-05-30	1975-05-30 00:00:00	32020		\N	198628	0	241929008	4084167		0
50497	2987	4112343	1992-12-13	1992-12-13 00:00:00	1992-12-25	1992-12-25 00:00:00	32020		\N	199392	0	195662009	4112343		0
40159	2381	317576	1996-05-15	1996-05-15 00:00:00	\N	\N	32020		\N	158263	0	53741008	317576		0
40337	2394	372328	1912-09-22	1912-09-22 00:00:00	1912-10-06	1912-10-06 00:00:00	32020		\N	159141	0	65363002	372328		0
40458	2404	372328	1968-01-06	1968-01-06 00:00:00	1968-05-12	1968-05-12 00:00:00	32020		\N	159770	0	65363002	372328		0
51224	3035	372328	1990-04-08	1990-04-08 00:00:00	1992-11-06	1992-11-06 00:00:00	32020		\N	202187	0	65363002	372328		0
51311	3041	4112343	2001-10-30	2001-10-30 00:00:00	2001-11-11	2001-11-11 00:00:00	32020		\N	202525	0	195662009	4112343		0
51480	3056	4112343	1972-11-18	1972-11-18 00:00:00	1972-11-25	1972-11-25 00:00:00	32020		\N	203285	0	195662009	4112343		0
51732	3067	257012	1968-04-23	1968-04-23 00:00:00	\N	\N	32020		\N	204101	0	40055000	257012		0
51849	3074	40481087	1991-03-16	1991-03-16 00:00:00	1991-04-06	1991-04-06 00:00:00	32020		\N	204601	0	444814009	40481087		0
51992	3080	40481087	2009-03-01	2009-03-01 00:00:00	2009-03-08	2009-03-08 00:00:00	32020		\N	205024	0	444814009	40481087		0
52152	3087	40481087	2009-11-07	2009-11-07 00:00:00	2009-11-28	2009-11-28 00:00:00	32020		\N	205507	0	444814009	40481087		0
41808	2486	4112343	1992-10-03	1992-10-03 00:00:00	1992-10-12	1992-10-12 00:00:00	32020		\N	164725	0	195662009	4112343		0
52593	3115	78272	1968-01-15	1968-01-15 00:00:00	1968-02-05	1968-02-05 00:00:00	32020		\N	207276	0	70704007	78272		0
52736	3123	4048171	1979-07-13	1979-07-13 00:00:00	\N	\N	32020		\N	207832	0	232353008	4048171		0
52907	3133	4112343	1999-06-09	1999-06-09 00:00:00	1999-06-17	1999-06-17 00:00:00	32020		\N	208521	0	195662009	4112343		0
53088	3144	40481087	1997-08-28	1997-08-28 00:00:00	1997-09-11	1997-09-11 00:00:00	32020		\N	209224	0	444814009	40481087		0
42543	2537	40481087	1964-03-14	1964-03-14 00:00:00	1964-03-28	1964-03-28 00:00:00	32020		\N	167628	0	444814009	40481087		0
42795	2550	28060	1986-05-02	1986-05-02 00:00:00	1986-05-09	1986-05-09 00:00:00	32020		\N	168816	0	43878008	28060		0
42903	2554	4109685	1965-12-27	1965-12-27 00:00:00	1966-01-17	1966-01-17 00:00:00	32020		\N	169198	0	284551006	4109685		0
43046	2563	80180	2009-01-22	2009-01-22 00:00:00	\N	\N	32020		\N	169773	0	396275006	80180		0
32627	1937	260139	2015-04-06	2015-04-06 00:00:00	2015-04-13	2015-04-13 00:00:00	32020		\N	128879	0	10509002	260139		0
43420	2586	4112343	1995-08-31	1995-08-31 00:00:00	1995-09-12	1995-09-12 00:00:00	32020		\N	171191	0	195662009	4112343		0
33003	1958	260139	1987-09-02	1987-09-02 00:00:00	1987-09-16	1987-09-16 00:00:00	32020		\N	130257	0	10509002	260139		0
43686	2602	40481087	1959-09-21	1959-09-21 00:00:00	1959-09-28	1959-09-28 00:00:00	32020		\N	172156	0	444814009	40481087		0
43834	2610	40481087	1990-10-01	1990-10-01 00:00:00	1990-10-08	1990-10-08 00:00:00	32020		\N	172548	0	444814009	40481087		0
44043	2620	4296204	1988-09-01	1988-09-01 00:00:00	1988-09-22	1988-09-22 00:00:00	32020		\N	173272	0	403190006	4296204		0
44158	2626	40481087	2016-12-13	2016-12-13 00:00:00	2017-01-03	2017-01-03 00:00:00	32020		\N	173733	0	444814009	40481087		0
33829	2007	4112343	2002-11-22	2002-11-22 00:00:00	2002-12-01	2002-12-01 00:00:00	32020		\N	133681	0	195662009	4112343		0
44561	2651	40481087	1992-05-26	1992-05-26 00:00:00	1992-06-16	1992-06-16 00:00:00	32020		\N	175381	0	444814009	40481087		0
44695	2659	4296204	1977-09-08	1977-09-08 00:00:00	1977-10-06	1977-10-06 00:00:00	32020		\N	176145	0	403190006	4296204		0
44877	2672	4218389	1999-11-14	1999-11-14 00:00:00	1999-12-12	1999-12-12 00:00:00	32020		\N	176983	0	39848009	4218389		0
45074	2682	260139	2014-07-16	2014-07-16 00:00:00	2014-07-30	2014-07-30 00:00:00	32020		\N	177753	0	10509002	260139		0
34639	2056	4112343	2019-02-21	2019-02-21 00:00:00	2019-02-28	2019-02-28 00:00:00	32020		\N	136745	0	195662009	4112343		0
45441	2702	4112343	1989-02-15	1989-02-15 00:00:00	1989-02-24	1989-02-24 00:00:00	32020		\N	178968	0	195662009	4112343		0
45533	2706	372328	1964-07-02	1964-07-02 00:00:00	1964-09-15	1964-09-15 00:00:00	32020		\N	179265	0	65363002	372328		0
35189	2087	4142905	1989-04-19	1989-04-19 00:00:00	1989-07-18	1989-07-18 00:00:00	32020		\N	139103	0	33737001	4142905		0
35343	2094	81151	1966-08-11	1966-08-11 00:00:00	1966-08-25	1966-08-25 00:00:00	32020		\N	139573	0	44465007	81151		0
46080	2745	40481087	1993-07-11	1993-07-11 00:00:00	1993-08-01	1993-08-01 00:00:00	32020		\N	181598	0	444814009	40481087		0
46182	2750	40481087	1962-05-22	1962-05-22 00:00:00	1962-05-29	1962-05-29 00:00:00	32020		\N	181946	0	444814009	40481087		0
46329	2760	40481087	1996-01-24	1996-01-24 00:00:00	1996-01-31	1996-01-31 00:00:00	32020		\N	182554	0	444814009	40481087		0
35991	2134	40481087	1982-04-24	1982-04-24 00:00:00	1982-05-15	1982-05-15 00:00:00	32020		\N	141977	0	444814009	40481087		0
46690	2778	40481087	1977-10-25	1977-10-25 00:00:00	1977-11-08	1977-11-08 00:00:00	32020		\N	184088	0	444814009	40481087		0
46826	2786	4146173	1954-12-25	1954-12-25 00:00:00	1955-02-23	1955-02-23 00:00:00	32020		\N	184634	0	307731004	4146173		0
47054	2799	40481087	1980-11-07	1980-11-07 00:00:00	1980-11-14	1980-11-14 00:00:00	32020		\N	185472	0	444814009	40481087		0
47174	2804	78272	1996-02-26	1996-02-26 00:00:00	1996-03-11	1996-03-11 00:00:00	32020		\N	185854	0	70704007	78272		0
47332	2815	4112343	1986-07-06	1986-07-06 00:00:00	1986-07-16	1986-07-16 00:00:00	32020		\N	186541	0	195662009	4112343		0
47500	2825	40481087	1995-09-22	1995-09-22 00:00:00	1995-10-06	1995-10-06 00:00:00	32020		\N	187339	0	444814009	40481087		0
37154	2200	40481087	2001-09-09	2001-09-09 00:00:00	2001-09-23	2001-09-23 00:00:00	32020		\N	146626	0	444814009	40481087		0
47812	2839	4027663	1999-02-14	1999-02-14 00:00:00	\N	\N	32020		\N	188545	0	13200003	4027663		0
48032	2849	4112343	1925-02-05	1925-02-05 00:00:00	1925-02-14	1925-02-14 00:00:00	32020		\N	189299	0	195662009	4112343		0
37654	2232	80180	2005-09-16	2005-09-16 00:00:00	\N	\N	32020		\N	148491	0	396275006	80180		0
37810	2240	40481087	1973-02-06	1973-02-06 00:00:00	1973-02-13	1973-02-13 00:00:00	32020		\N	149116	0	444814009	40481087		0
48560	2876	260139	1981-07-08	1981-07-08 00:00:00	1981-07-15	1981-07-15 00:00:00	32020		\N	191362	0	10509002	260139		0
48755	2889	40481087	2001-05-18	2001-05-18 00:00:00	2001-06-08	2001-06-08 00:00:00	32020		\N	192151	0	444814009	40481087		0
48830	2893	4134304	1948-03-07	1948-03-07 00:00:00	1948-06-05	1948-06-05 00:00:00	32020		\N	192516	0	263102004	4134304		0
49073	2904	4112343	1992-06-27	1992-06-27 00:00:00	1992-07-07	1992-07-07 00:00:00	32020		\N	193483	0	195662009	4112343		0
49257	2913	4112343	2003-04-19	2003-04-19 00:00:00	2003-04-29	2003-04-29 00:00:00	32020		\N	194129	0	195662009	4112343		0
49371	2919	4112343	1949-11-20	1949-11-20 00:00:00	1949-12-02	1949-12-02 00:00:00	32020		\N	194582	0	195662009	4112343		0
49501	2927	4152936	2013-10-27	2013-10-27 00:00:00	2013-11-10	2013-11-10 00:00:00	32020		\N	195301	0	283385000	4152936		0
49721	2942	4051466	1956-08-04	1956-08-04 00:00:00	1972-11-08	1972-11-08 00:00:00	32020		\N	196086	0	233678006	4051466		0
39291	2332	4285898	1996-04-30	1996-04-30 00:00:00	\N	\N	32020		\N	155117	0	68496003	4285898		0
50010	2955	4156265	2002-11-08	2002-11-08 00:00:00	2002-11-22	2002-11-22 00:00:00	32020		\N	197251	0	370247008	4156265		0
39627	2346	28060	1959-10-17	1959-10-17 00:00:00	1959-10-24	1959-10-24 00:00:00	32020		\N	156168	0	43878008	28060		0
50314	2975	81151	2000-01-19	2000-01-19 00:00:00	2000-02-16	2000-02-16 00:00:00	32020		\N	198692	0	44465007	81151		0
50498	2987	4283893	1977-08-07	1977-08-07 00:00:00	1977-09-18	1977-09-18 00:00:00	32020		\N	199369	0	36971009	4283893		0
40161	2381	321042	2013-01-30	2013-01-30 00:00:00	\N	\N	32020		\N	158245	0	410429000	321042		0
40338	2394	28060	1978-11-29	1978-11-29 00:00:00	1978-12-09	1978-12-09 00:00:00	32020		\N	159121	0	43878008	28060		0
40459	2404	260139	1987-05-15	1987-05-15 00:00:00	1987-05-22	1987-05-22 00:00:00	32020		\N	159771	0	10509002	260139		0
51225	3035	381316	2014-09-12	2014-09-12 00:00:00	\N	\N	32020		\N	202232	0	230690007	381316		0
51319	3044	4152936	1998-02-09	1998-02-09 00:00:00	1998-02-23	1998-02-23 00:00:00	32020		\N	202622	0	283385000	4152936		0
51481	3056	372328	1958-01-22	1958-01-22 00:00:00	1958-03-07	1958-03-07 00:00:00	32020		\N	203264	0	65363002	372328		0
51733	3067	40481087	1969-04-01	1969-04-01 00:00:00	1969-04-08	1969-04-08 00:00:00	32020		\N	204127	0	444814009	40481087		0
51850	3074	40481087	1967-05-14	1967-05-14 00:00:00	1967-05-28	1967-05-28 00:00:00	32020		\N	204578	0	444814009	40481087		0
51993	3080	4112343	1991-05-16	1991-05-16 00:00:00	1991-05-23	1991-05-23 00:00:00	32020		\N	205016	0	195662009	4112343		0
52153	3087	40481087	1982-11-27	1982-11-27 00:00:00	1982-12-11	1982-12-11 00:00:00	32020		\N	205503	0	444814009	40481087		0
41809	2486	372328	1974-07-20	1974-07-20 00:00:00	1974-08-30	1974-08-30 00:00:00	32020		\N	164737	0	65363002	372328		0
52594	3115	257012	2009-07-04	2009-07-04 00:00:00	\N	\N	32020		\N	207228	0	40055000	257012		0
52737	3123	4112343	2013-07-31	2013-07-31 00:00:00	2013-08-09	2013-08-09 00:00:00	32020		\N	207836	0	195662009	4112343		0
52908	3133	4112343	1960-07-03	1960-07-03 00:00:00	1960-07-16	1960-07-16 00:00:00	32020		\N	208442	0	195662009	4112343		0
53089	3144	372328	1964-07-22	1964-07-22 00:00:00	1964-08-05	1964-08-05 00:00:00	32020		\N	209226	0	65363002	372328		0
42544	2537	40481087	1999-07-19	1999-07-19 00:00:00	1999-08-02	1999-08-02 00:00:00	32020		\N	167671	0	444814009	40481087		0
42796	2550	4116491	2018-02-13	2018-02-13 00:00:00	2018-03-20	2018-03-20 00:00:00	32020		\N	168808	0	301011002	4116491		0
42904	2554	4112343	2005-09-24	2005-09-24 00:00:00	2005-10-02	2005-10-02 00:00:00	32020		\N	169222	0	195662009	4112343		0
43047	2563	4283893	1997-02-16	1997-02-16 00:00:00	1997-07-13	1997-07-13 00:00:00	32020		\N	169776	0	36971009	4283893		0
32628	1937	260139	1980-12-12	1980-12-12 00:00:00	1980-12-26	1980-12-26 00:00:00	32020		\N	128873	0	10509002	260139		0
43421	2586	80180	2007-09-04	2007-09-04 00:00:00	\N	\N	32020		\N	171138	0	396275006	80180		0
33004	1958	40481087	1980-03-18	1980-03-18 00:00:00	1980-04-01	1980-04-01 00:00:00	32020		\N	130263	0	444814009	40481087		0
43687	2602	260139	1948-11-30	1948-11-30 00:00:00	1948-12-14	1948-12-14 00:00:00	32020		\N	172071	0	10509002	260139		0
43835	2610	30753	1991-04-24	1991-04-24 00:00:00	\N	\N	32020		\N	172548	0	16761005	30753		0
44044	2620	4278672	1979-09-19	1979-09-19 00:00:00	1979-11-18	1979-11-18 00:00:00	32020		\N	173271	0	65966004	4278672		0
44159	2626	372328	1965-04-22	1965-04-22 00:00:00	1965-06-08	1965-06-08 00:00:00	32020		\N	173718	0	65363002	372328		0
33830	2007	80180	2018-08-21	2018-08-21 00:00:00	\N	\N	32020		\N	133691	0	396275006	80180		0
44562	2651	40481087	2008-09-23	2008-09-23 00:00:00	2008-10-07	2008-10-07 00:00:00	32020		\N	175384	0	444814009	40481087		0
44696	2659	260139	2006-07-18	2006-07-18 00:00:00	2006-08-01	2006-08-01 00:00:00	32020		\N	176121	0	10509002	260139		0
44878	2672	40481087	2008-12-09	2008-12-09 00:00:00	2008-12-16	2008-12-16 00:00:00	32020		\N	176942	0	444814009	40481087		0
45075	2682	372328	1978-01-20	1978-01-20 00:00:00	1978-03-17	1978-03-17 00:00:00	32020		\N	177740	0	65363002	372328		0
34646	2058	4116491	2008-10-15	2008-10-15 00:00:00	2008-11-30	2008-11-30 00:00:00	32020		\N	136914	0	301011002	4116491		0
45442	2702	4294548	1985-03-23	1985-03-23 00:00:00	1985-09-14	1985-09-14 00:00:00	32020		\N	178998	0	75498004	4294548		0
45534	2706	4112343	1999-08-09	1999-08-09 00:00:00	1999-08-16	1999-08-16 00:00:00	32020		\N	179254	0	195662009	4112343		0
35190	2087	4059173	1997-02-06	1997-02-06 00:00:00	1997-04-07	1997-04-07 00:00:00	32020		\N	139104	0	16114001	4059173		0
35344	2094	40481087	1962-12-08	1962-12-08 00:00:00	1962-12-29	1962-12-29 00:00:00	32020		\N	139603	0	444814009	40481087		0
46081	2745	28060	1988-11-04	1988-11-04 00:00:00	1988-11-13	1988-11-13 00:00:00	32020		\N	181564	0	43878008	28060		0
46183	2750	80180	1963-01-23	1963-01-23 00:00:00	\N	\N	32020		\N	181946	0	396275006	80180		0
46330	2760	40481087	1998-10-25	1998-10-25 00:00:00	1998-11-15	1998-11-15 00:00:00	32020		\N	182558	0	444814009	40481087		0
35992	2134	4027663	1980-09-03	1980-09-03 00:00:00	\N	\N	32020		\N	142002	0	13200003	4027663		0
55645	3294	80180	1985-11-23	1985-11-23 00:00:00	\N	\N	32020		\N	218844	0	396275006	80180		0
46691	2778	40481087	2009-07-15	2009-07-15 00:00:00	2009-07-29	2009-07-29 00:00:00	32020		\N	184045	0	444814009	40481087		0
46827	2786	4112343	1978-07-22	1978-07-22 00:00:00	1978-07-31	1978-07-31 00:00:00	32020		\N	184651	0	195662009	4112343		0
47055	2799	4112343	2008-05-23	2008-05-23 00:00:00	2008-05-31	2008-05-31 00:00:00	32020		\N	185499	0	195662009	4112343		0
47175	2804	40481087	1998-05-25	1998-05-25 00:00:00	1998-06-15	1998-06-15 00:00:00	32020		\N	185858	0	444814009	40481087		0
47333	2815	260139	2006-01-24	2006-01-24 00:00:00	2006-02-07	2006-02-07 00:00:00	32020		\N	186495	0	10509002	260139		0
47501	2825	40481087	1948-04-08	1948-04-08 00:00:00	1948-04-15	1948-04-15 00:00:00	32020		\N	187337	0	444814009	40481087		0
37155	2200	4310024	2011-11-28	2011-11-28 00:00:00	\N	\N	32020		\N	146682	0	424802006	4310024		0
47813	2839	260139	1977-11-22	1977-11-22 00:00:00	1977-12-06	1977-12-06 00:00:00	32020		\N	188550	0	10509002	260139		0
48033	2849	80180	1959-04-16	1959-04-16 00:00:00	\N	\N	32020		\N	189254	0	396275006	80180		0
37655	2232	260139	2016-10-13	2016-10-13 00:00:00	2016-10-20	2016-10-20 00:00:00	32020		\N	148523	0	10509002	260139		0
37811	2240	440086	1965-03-24	1965-03-24 00:00:00	1965-11-03	1965-11-03 00:00:00	32020		\N	149094	0	192127007	440086		0
48561	2876	258780	1989-08-03	1989-08-03 00:00:00	\N	\N	32020		\N	191372	0	185086009	258780		0
48756	2889	4112343	2007-10-25	2007-10-25 00:00:00	2007-11-03	2007-11-03 00:00:00	32020		\N	192176	0	195662009	4112343		0
48831	2893	4112343	1952-08-23	1952-08-23 00:00:00	1952-08-30	1952-08-30 00:00:00	32020		\N	192452	0	195662009	4112343		0
49074	2904	372328	1973-03-05	1973-03-05 00:00:00	1973-04-25	1973-04-25 00:00:00	32020		\N	193491	0	65363002	372328		0
49258	2913	260139	1964-02-20	1964-02-20 00:00:00	1964-02-27	1964-02-27 00:00:00	32020		\N	194125	0	10509002	260139		0
49372	2919	4230399	2018-03-21	2018-03-21 00:00:00	2018-05-20	2018-05-20 00:00:00	32020		\N	194613	0	359817006	4230399		0
49502	2927	4283893	1973-05-28	1973-05-28 00:00:00	1973-07-16	1973-07-16 00:00:00	32020		\N	195210	0	36971009	4283893		0
49722	2942	260139	2012-10-25	2012-10-25 00:00:00	2012-11-01	2012-11-01 00:00:00	32020		\N	196223	0	10509002	260139		0
39292	2332	81893	1995-04-06	1995-04-06 00:00:00	\N	\N	32020		\N	155117	0	64766004	81893		0
50011	2955	4112343	1991-03-02	1991-03-02 00:00:00	1991-03-15	1991-03-15 00:00:00	32020		\N	197206	0	195662009	4112343		0
39628	2346	4146173	2001-07-31	2001-07-31 00:00:00	2001-09-29	2001-09-29 00:00:00	32020		\N	156151	0	307731004	4146173		0
50315	2975	372328	1965-05-22	1965-05-22 00:00:00	1965-09-12	1965-09-12 00:00:00	32020		\N	198644	0	65363002	372328		0
50499	2987	260139	1995-07-16	1995-07-16 00:00:00	1995-07-30	1995-07-30 00:00:00	32020		\N	199394	0	10509002	260139		0
40162	2381	28060	2012-11-25	2012-11-25 00:00:00	2012-12-06	2012-12-06 00:00:00	32020		\N	158335	0	43878008	28060		0
50797	3004	40481087	2006-06-22	2006-06-22 00:00:00	2006-06-29	2006-06-29 00:00:00	32020		\N	200460	0	444814009	40481087		0
40460	2404	372328	1966-05-04	1966-05-04 00:00:00	1966-08-14	1966-08-14 00:00:00	32020		\N	159752	0	65363002	372328		0
51226	3035	4027663	1995-12-12	1995-12-12 00:00:00	\N	\N	32020		\N	202198	0	13200003	4027663		0
51320	3044	372328	1971-01-23	1971-01-23 00:00:00	1971-06-29	1971-06-29 00:00:00	32020		\N	202606	0	65363002	372328		0
51482	3056	260139	1991-01-26	1991-01-26 00:00:00	1991-02-02	1991-02-02 00:00:00	32020		\N	203291	0	10509002	260139		0
51734	3067	4134304	2010-12-05	2010-12-05 00:00:00	2011-01-04	2011-01-04 00:00:00	32020		\N	204188	0	263102004	4134304		0
51851	3074	80180	1986-07-20	1986-07-20 00:00:00	\N	\N	32020		\N	204617	0	396275006	80180		0
51994	3080	372328	2007-04-12	2007-04-12 00:00:00	2007-09-27	2007-09-27 00:00:00	32020		\N	204995	0	65363002	372328		0
52154	3087	40481087	2017-02-22	2017-02-22 00:00:00	2017-03-15	2017-03-15 00:00:00	32020		\N	205533	0	444814009	40481087		0
41810	2486	40481087	1977-05-13	1977-05-13 00:00:00	1977-06-03	1977-06-03 00:00:00	32020		\N	164751	0	444814009	40481087		0
52595	3115	4155034	1973-02-08	1973-02-08 00:00:00	1973-03-01	1973-03-01 00:00:00	32020		\N	207278	0	283371005	4155034		0
52738	3123	40481087	2015-10-27	2015-10-27 00:00:00	2015-11-17	2015-11-17 00:00:00	32020		\N	207770	0	444814009	40481087		0
52909	3133	260139	1962-09-20	1962-09-20 00:00:00	1962-10-04	1962-10-04 00:00:00	32020		\N	208519	0	10509002	260139		0
53090	3144	260139	1965-02-18	1965-02-18 00:00:00	1965-02-25	1965-02-25 00:00:00	32020		\N	209208	0	10509002	260139		0
42545	2537	4112343	1973-07-04	1973-07-04 00:00:00	1973-07-13	1973-07-13 00:00:00	32020		\N	167760	0	195662009	4112343		0
42797	2550	4112343	1993-08-03	1993-08-03 00:00:00	1993-08-15	1993-08-15 00:00:00	32020		\N	168789	0	195662009	4112343		0
42905	2555	4112343	1958-02-26	1958-02-26 00:00:00	1958-03-06	1958-03-06 00:00:00	32020		\N	169320	0	195662009	4112343		0
43048	2563	4294548	1980-08-25	1980-08-25 00:00:00	1980-09-15	1980-09-15 00:00:00	32020		\N	169788	0	75498004	4294548		0
32629	1937	40481087	1972-04-27	1972-04-27 00:00:00	1972-05-04	1972-05-04 00:00:00	32020		\N	128872	0	444814009	40481087		0
43422	2586	40481087	1995-06-28	1995-06-28 00:00:00	1995-07-12	1995-07-12 00:00:00	32020		\N	171199	0	444814009	40481087		0
33005	1958	372328	1996-02-25	1996-02-25 00:00:00	1996-10-08	1996-10-08 00:00:00	32020		\N	130262	0	65363002	372328		0
43688	2602	81151	1954-07-30	1954-07-30 00:00:00	1954-08-20	1954-08-20 00:00:00	32020		\N	172143	0	44465007	81151		0
43836	2610	81893	1990-12-24	1990-12-24 00:00:00	\N	\N	32020		\N	172548	0	64766004	81893		0
44045	2620	80180	2000-10-23	2000-10-23 00:00:00	\N	\N	32020		\N	173297	0	396275006	80180		0
44160	2626	260139	1981-11-07	1981-11-07 00:00:00	1981-11-14	1981-11-14 00:00:00	32020		\N	173710	0	10509002	260139		0
33831	2007	78272	2014-09-06	2014-09-06 00:00:00	2014-10-11	2014-10-11 00:00:00	32020		\N	133661	0	70704007	78272		0
44563	2651	81151	1957-06-27	1957-06-27 00:00:00	1957-07-25	1957-07-25 00:00:00	32020		\N	175418	0	44465007	81151		0
44697	2659	28060	1979-01-03	1979-01-03 00:00:00	1979-01-16	1979-01-16 00:00:00	32020		\N	176118	0	43878008	28060		0
44879	2672	40481087	2012-11-03	2012-11-03 00:00:00	2012-11-10	2012-11-10 00:00:00	32020		\N	176892	0	444814009	40481087		0
45076	2682	192671	2016-06-01	2016-06-01 00:00:00	\N	\N	32020		\N	177767	0	K92.2	35208414		0
34647	2058	81151	1970-04-29	1970-04-29 00:00:00	1970-05-27	1970-05-27 00:00:00	32020		\N	136799	0	44465007	81151		0
45443	2702	372328	1943-05-31	1943-05-31 00:00:00	1943-09-19	1943-09-19 00:00:00	32020		\N	178941	0	65363002	372328		0
45535	2706	40481087	1989-07-30	1989-07-30 00:00:00	1989-08-20	1989-08-20 00:00:00	32020		\N	179264	0	444814009	40481087		0
35191	2087	4294548	1944-02-17	1944-02-17 00:00:00	1944-05-11	1944-05-11 00:00:00	32020		\N	139039	0	75498004	4294548		0
35345	2094	260139	1989-12-09	1989-12-09 00:00:00	1989-12-16	1989-12-16 00:00:00	32020		\N	139595	0	10509002	260139		0
46095	2747	40481087	2001-12-31	2001-12-31 00:00:00	2002-01-07	2002-01-07 00:00:00	32020		\N	181657	0	444814009	40481087		0
46184	2750	28060	2000-09-10	2000-09-10 00:00:00	2000-09-19	2000-09-19 00:00:00	32020		\N	181922	0	43878008	28060		0
46331	2760	4310024	1999-01-12	1999-01-12 00:00:00	\N	\N	32020		\N	182558	0	424802006	4310024		0
35993	2134	260139	1978-08-21	1978-08-21 00:00:00	1978-09-04	1978-09-04 00:00:00	32020		\N	142002	0	10509002	260139		0
46692	2778	4112343	1994-05-06	1994-05-06 00:00:00	1994-05-15	1994-05-15 00:00:00	32020		\N	184044	0	195662009	4112343		0
46828	2786	4278672	2002-03-19	2002-03-19 00:00:00	2002-05-18	2002-05-18 00:00:00	32020		\N	184613	0	65966004	4278672		0
47056	2799	40481087	1995-07-17	1995-07-17 00:00:00	1995-07-24	1995-07-24 00:00:00	32020		\N	185505	0	444814009	40481087		0
47176	2804	78272	2015-06-30	2015-06-30 00:00:00	2015-07-21	2015-07-21 00:00:00	32020		\N	185856	0	70704007	78272		0
47334	2815	40481087	1973-03-06	1973-03-06 00:00:00	1973-03-27	1973-03-27 00:00:00	32020		\N	186548	0	444814009	40481087		0
47502	2825	4112343	1999-07-19	1999-07-19 00:00:00	1999-07-31	1999-07-31 00:00:00	32020		\N	187230	0	195662009	4112343		0
37156	2200	81893	2012-05-26	2012-05-26 00:00:00	\N	\N	32020		\N	146682	0	64766004	81893		0
53519	3172	80180	2012-10-28	2012-10-28 00:00:00	\N	\N	32020		\N	210885	0	396275006	80180		0
47814	2839	40481087	2015-07-27	2015-07-27 00:00:00	2015-08-17	2015-08-17 00:00:00	32020		\N	188522	0	444814009	40481087		0
48034	2849	81151	1937-08-13	1937-08-13 00:00:00	1937-09-03	1937-09-03 00:00:00	32020		\N	189292	0	44465007	81151		0
37656	2232	257012	1971-05-17	1971-05-17 00:00:00	1971-05-31	1971-05-31 00:00:00	32020		\N	148520	0	40055000	257012		0
37812	2240	40481087	2011-01-01	2011-01-01 00:00:00	2011-01-08	2011-01-08 00:00:00	32020		\N	149102	0	444814009	40481087		0
48562	2876	4142905	2011-03-23	2011-03-23 00:00:00	2011-05-22	2011-05-22 00:00:00	32020		\N	191393	0	33737001	4142905		0
48757	2889	4112343	2010-10-01	2010-10-01 00:00:00	2010-10-10	2010-10-10 00:00:00	32020		\N	192145	0	195662009	4112343		0
48832	2893	378001	1999-08-24	1999-08-24 00:00:00	1999-10-23	1999-10-23 00:00:00	32020		\N	192514	0	62106007	378001		0
49075	2904	40481087	1976-03-22	1976-03-22 00:00:00	1976-04-05	1976-04-05 00:00:00	32020		\N	193488	0	444814009	40481087		0
49259	2913	4152936	2002-05-14	2002-05-14 00:00:00	2002-06-04	2002-06-04 00:00:00	32020		\N	194108	0	283385000	4152936		0
49373	2919	28060	2007-12-09	2007-12-09 00:00:00	2007-12-20	2007-12-20 00:00:00	32020		\N	194578	0	43878008	28060		0
49503	2927	4230399	1987-05-17	1987-05-17 00:00:00	1987-07-16	1987-07-16 00:00:00	32020		\N	195296	0	359817006	4230399		0
49723	2942	440448	2005-07-17	2005-07-17 00:00:00	\N	\N	32020		\N	196060	0	74400008	440448		0
39293	2332	28060	1963-09-01	1963-09-01 00:00:00	1963-09-10	1963-09-10 00:00:00	32020		\N	155048	0	43878008	28060		0
50012	2955	372328	1974-03-05	1974-03-05 00:00:00	1974-07-16	1974-07-16 00:00:00	32020		\N	197265	0	65363002	372328		0
39629	2346	80180	1986-11-13	1986-11-13 00:00:00	\N	\N	32020		\N	156154	0	396275006	80180		0
50316	2975	4283893	2001-02-15	2001-02-15 00:00:00	2001-04-12	2001-04-12 00:00:00	32020		\N	198642	0	36971009	4283893		0
50500	2987	4112343	1989-11-30	1989-11-30 00:00:00	1989-12-12	1989-12-12 00:00:00	32020		\N	199403	0	195662009	4112343		0
40163	2381	4112343	1980-09-17	1980-09-17 00:00:00	1980-09-27	1980-09-27 00:00:00	32020		\N	158297	0	195662009	4112343		0
50798	3004	4294548	1969-12-12	1969-12-12 00:00:00	1970-04-10	1970-04-10 00:00:00	32020		\N	200498	0	75498004	4294548		0
40461	2404	40481087	2000-09-15	2000-09-15 00:00:00	2000-09-22	2000-09-22 00:00:00	32020		\N	159750	0	444814009	40481087		0
51227	3035	4112343	2016-02-04	2016-02-04 00:00:00	2016-02-11	2016-02-11 00:00:00	32020		\N	202175	0	195662009	4112343		0
51321	3044	372328	1969-07-20	1969-07-20 00:00:00	1969-09-30	1969-09-30 00:00:00	32020		\N	202605	0	65363002	372328		0
51483	3056	40481087	1974-04-13	1974-04-13 00:00:00	1974-04-27	1974-04-27 00:00:00	32020		\N	203287	0	444814009	40481087		0
51735	3067	4283893	1968-04-02	1968-04-02 00:00:00	1968-04-30	1968-04-30 00:00:00	32020		\N	204132	0	36971009	4283893		0
51852	3074	4112343	2002-12-09	2002-12-09 00:00:00	2002-12-19	2002-12-19 00:00:00	32020		\N	204602	0	195662009	4112343		0
51995	3080	4113008	2018-10-09	2018-10-09 00:00:00	2018-10-30	2018-10-30 00:00:00	32020		\N	205012	0	284549007	4113008		0
52155	3087	28060	2013-03-21	2013-03-21 00:00:00	2013-04-03	2013-04-03 00:00:00	32020		\N	205520	0	43878008	28060		0
41811	2486	40481087	1982-06-12	1982-06-12 00:00:00	1982-06-19	1982-06-19 00:00:00	32020		\N	164740	0	444814009	40481087		0
52596	3115	40481087	1984-02-19	1984-02-19 00:00:00	1984-02-26	1984-02-26 00:00:00	32020		\N	207226	0	444814009	40481087		0
52739	3123	40481087	2011-06-08	2011-06-08 00:00:00	2011-06-15	2011-06-15 00:00:00	32020		\N	207835	0	444814009	40481087		0
52910	3133	372328	1956-09-19	1956-09-19 00:00:00	1956-10-31	1956-10-31 00:00:00	32020		\N	208472	0	65363002	372328		0
53091	3144	40481087	2019-04-07	2019-04-07 00:00:00	2019-04-14	2019-04-14 00:00:00	32020		\N	209205	0	444814009	40481087		0
42546	2537	28060	1957-01-09	1957-01-09 00:00:00	1957-01-17	1957-01-17 00:00:00	32020		\N	167711	0	43878008	28060		0
42798	2550	40481087	2013-08-22	2013-08-22 00:00:00	2013-09-12	2013-09-12 00:00:00	32020		\N	168820	0	444814009	40481087		0
42906	2555	4296204	1971-04-08	1971-04-08 00:00:00	1971-05-14	1971-05-14 00:00:00	32020		\N	169313	0	403190006	4296204		0
43049	2564	4218389	1995-12-15	1995-12-15 00:00:00	1996-01-05	1996-01-05 00:00:00	32020		\N	169907	0	39848009	4218389		0
32630	1937	40481087	2013-08-28	2013-08-28 00:00:00	2013-09-11	2013-09-11 00:00:00	32020		\N	128850	0	444814009	40481087		0
43423	2586	40481087	1993-07-25	1993-07-25 00:00:00	1993-08-01	1993-08-01 00:00:00	32020		\N	171147	0	444814009	40481087		0
33006	1958	40481087	1988-04-26	1988-04-26 00:00:00	1988-05-03	1988-05-03 00:00:00	32020		\N	130247	0	444814009	40481087		0
43689	2602	30753	1986-07-17	1986-07-17 00:00:00	\N	\N	32020		\N	172132	0	16761005	30753		0
43837	2610	40481087	2005-02-26	2005-02-26 00:00:00	2005-03-19	2005-03-19 00:00:00	32020		\N	172610	0	444814009	40481087		0
44046	2620	40481087	2005-02-18	2005-02-18 00:00:00	2005-03-04	2005-03-04 00:00:00	32020		\N	173304	0	444814009	40481087		0
44161	2626	260139	2018-08-15	2018-08-15 00:00:00	2018-08-22	2018-08-22 00:00:00	32020		\N	173734	0	10509002	260139		0
33832	2007	372328	1991-11-25	1991-11-25 00:00:00	1992-10-18	1992-10-18 00:00:00	32020		\N	133682	0	65363002	372328		0
44564	2651	260139	2008-09-23	2008-09-23 00:00:00	2008-10-07	2008-10-07 00:00:00	32020		\N	175384	0	10509002	260139		0
44698	2659	4283893	1974-12-29	1974-12-29 00:00:00	1975-08-17	1975-08-17 00:00:00	32020		\N	176154	0	36971009	4283893		0
44880	2672	40481087	1996-09-24	1996-09-24 00:00:00	1996-10-15	1996-10-15 00:00:00	32020		\N	176935	0	444814009	40481087		0
45077	2682	40481087	2005-12-29	2005-12-29 00:00:00	2006-01-19	2006-01-19 00:00:00	32020		\N	177711	0	444814009	40481087		0
34648	2058	81151	1968-06-17	1968-06-17 00:00:00	1968-07-08	1968-07-08 00:00:00	32020		\N	136798	0	44465007	81151		0
45444	2702	372328	1944-09-15	1944-09-15 00:00:00	1945-09-23	1945-09-23 00:00:00	32020		\N	179010	0	65363002	372328		0
45536	2706	4142905	1973-01-16	1973-01-16 00:00:00	1973-02-15	1973-02-15 00:00:00	32020		\N	179257	0	33737001	4142905		0
35192	2087	4112343	1980-12-07	1980-12-07 00:00:00	1980-12-16	1980-12-16 00:00:00	32020		\N	139047	0	195662009	4112343		0
35346	2094	40481087	1997-08-20	1997-08-20 00:00:00	1997-09-10	1997-09-10 00:00:00	32020		\N	139637	0	444814009	40481087		0
46096	2747	260139	1988-12-28	1988-12-28 00:00:00	1989-01-11	1989-01-11 00:00:00	32020		\N	181656	0	10509002	260139		0
46185	2750	260139	1956-01-05	1956-01-05 00:00:00	1956-01-12	1956-01-12 00:00:00	32020		\N	181944	0	10509002	260139		0
46332	2760	4112343	1987-11-17	1987-11-17 00:00:00	1987-11-30	1987-11-30 00:00:00	32020		\N	182538	0	195662009	4112343		0
35994	2134	40481087	1991-08-29	1991-08-29 00:00:00	1991-09-05	1991-09-05 00:00:00	32020		\N	141990	0	444814009	40481087		0
46693	2778	4112343	1998-03-29	1998-03-29 00:00:00	1998-04-06	1998-04-06 00:00:00	32020		\N	184079	0	195662009	4112343		0
46829	2786	40480160	2002-03-19	2002-03-19 00:00:00	2002-05-18	2002-05-18 00:00:00	32020		\N	184613	0	443165006	40480160		0
47057	2799	40481087	1988-01-12	1988-01-12 00:00:00	1988-01-19	1988-01-19 00:00:00	32020		\N	185473	0	444814009	40481087		0
47177	2804	4112343	1982-07-20	1982-07-20 00:00:00	1982-07-30	1982-07-30 00:00:00	32020		\N	185824	0	195662009	4112343		0
47335	2815	260139	2002-03-23	2002-03-23 00:00:00	2002-04-06	2002-04-06 00:00:00	32020		\N	186556	0	10509002	260139		0
47503	2825	80180	1964-03-06	1964-03-06 00:00:00	\N	\N	32020		\N	187246	0	396275006	80180		0
37157	2200	440086	1980-06-08	1980-06-08 00:00:00	1985-09-08	1985-09-08 00:00:00	32020		\N	146599	0	192127007	440086		0
47815	2839	4310024	2005-04-13	2005-04-13 00:00:00	\N	\N	32020		\N	188559	0	424802006	4310024		0
48035	2849	4112343	1993-04-08	1993-04-08 00:00:00	1993-04-21	1993-04-21 00:00:00	32020		\N	189270	0	195662009	4112343		0
37657	2233	260139	2013-06-03	2013-06-03 00:00:00	2013-06-10	2013-06-10 00:00:00	32020		\N	148562	0	10509002	260139		0
37813	2240	28060	2004-06-01	2004-06-01 00:00:00	2004-06-09	2004-06-09 00:00:00	32020		\N	149144	0	43878008	28060		0
48563	2876	40481087	2014-04-25	2014-04-25 00:00:00	2014-05-02	2014-05-02 00:00:00	32020		\N	191327	0	444814009	40481087		0
48758	2889	81151	2007-06-12	2007-06-12 00:00:00	2007-07-17	2007-07-17 00:00:00	32020		\N	192147	0	44465007	81151		0
48833	2893	4283893	1986-08-20	1986-08-20 00:00:00	1987-01-28	1987-01-28 00:00:00	32020		\N	192501	0	36971009	4283893		0
49076	2904	40481087	1987-02-18	1987-02-18 00:00:00	1987-03-11	1987-03-11 00:00:00	32020		\N	193504	0	444814009	40481087		0
49260	2913	4294548	2014-12-28	2014-12-28 00:00:00	2015-03-29	2015-03-29 00:00:00	32020		\N	194113	0	75498004	4294548		0
49374	2919	40481087	2010-11-06	2010-11-06 00:00:00	2010-11-20	2010-11-20 00:00:00	32020		\N	194635	0	444814009	40481087		0
49504	2927	4059173	2010-09-13	2010-09-13 00:00:00	2010-12-12	2010-12-12 00:00:00	32020		\N	195300	0	16114001	4059173		0
49724	2942	4112343	1975-03-03	1975-03-03 00:00:00	1975-03-15	1975-03-15 00:00:00	32020		\N	196090	0	195662009	4112343		0
39294	2332	4112343	1960-09-02	1960-09-02 00:00:00	1960-09-14	1960-09-14 00:00:00	32020		\N	155045	0	195662009	4112343		0
50013	2955	40481087	2011-04-23	2011-04-23 00:00:00	2011-05-07	2011-05-07 00:00:00	32020		\N	197264	0	444814009	40481087		0
39630	2346	40481087	1986-07-15	1986-07-15 00:00:00	1986-08-05	1986-08-05 00:00:00	32020		\N	156154	0	444814009	40481087		0
50317	2975	40481087	2016-12-24	2016-12-24 00:00:00	2017-01-14	2017-01-14 00:00:00	32020		\N	198582	0	444814009	40481087		0
50501	2987	4112343	1973-07-23	1973-07-23 00:00:00	1973-07-31	1973-07-31 00:00:00	32020		\N	199402	0	195662009	4112343		0
50653	2997	78272	1994-01-29	1994-01-29 00:00:00	1994-02-12	1994-02-12 00:00:00	32020		\N	199961	0	70704007	78272		0
50799	3004	40481087	1955-09-16	1955-09-16 00:00:00	1955-09-23	1955-09-23 00:00:00	32020		\N	200454	0	444814009	40481087		0
40462	2404	40481087	1989-04-21	1989-04-21 00:00:00	1989-05-12	1989-05-12 00:00:00	32020		\N	159773	0	444814009	40481087		0
51228	3035	4294548	1991-01-21	1991-01-21 00:00:00	1991-02-11	1991-02-11 00:00:00	32020		\N	202211	0	75498004	4294548		0
51322	3044	81151	2013-09-30	2013-09-30 00:00:00	2013-11-04	2013-11-04 00:00:00	32020		\N	202624	0	44465007	81151		0
51484	3056	260139	1983-08-03	1983-08-03 00:00:00	1983-08-17	1983-08-17 00:00:00	32020		\N	203229	0	10509002	260139		0
51736	3067	4113008	1958-05-11	1958-05-11 00:00:00	1958-05-25	1958-05-25 00:00:00	32020		\N	204174	0	284549007	4113008		0
51853	3074	28060	1952-08-01	1952-08-01 00:00:00	1952-08-11	1952-08-11 00:00:00	32020		\N	204584	0	43878008	28060		0
51996	3080	4112343	1998-03-27	1998-03-27 00:00:00	1998-04-08	1998-04-08 00:00:00	32020		\N	205060	0	195662009	4112343		0
52156	3087	40481087	1998-03-01	1998-03-01 00:00:00	1998-03-22	1998-03-22 00:00:00	32020		\N	205493	0	444814009	40481087		0
41812	2487	260139	1993-09-30	1993-09-30 00:00:00	1993-10-07	1993-10-07 00:00:00	32020		\N	164762	0	10509002	260139		0
52597	3115	81893	2004-12-06	2004-12-06 00:00:00	\N	\N	32020		\N	207223	0	64766004	81893		0
52740	3123	372328	1982-12-26	1982-12-26 00:00:00	1983-03-09	1983-03-09 00:00:00	32020		\N	207779	0	65363002	372328		0
52911	3133	4112343	1995-07-14	1995-07-14 00:00:00	1995-07-27	1995-07-27 00:00:00	32020		\N	208468	0	195662009	4112343		0
53092	3144	4112343	1981-07-10	1981-07-10 00:00:00	1981-07-19	1981-07-19 00:00:00	32020		\N	209202	0	195662009	4112343		0
42547	2537	40481087	2007-05-30	2007-05-30 00:00:00	2007-06-13	2007-06-13 00:00:00	32020		\N	167729	0	444814009	40481087		0
42799	2550	4146173	2018-02-02	2018-02-02 00:00:00	2018-04-10	2018-04-10 00:00:00	32020		\N	168792	0	307731004	4146173		0
42907	2555	4112343	2000-11-21	2000-11-21 00:00:00	2000-12-04	2000-12-04 00:00:00	32020		\N	169342	0	195662009	4112343		0
43050	2564	40481087	1992-03-10	1992-03-10 00:00:00	1992-03-17	1992-03-17 00:00:00	32020		\N	169914	0	444814009	40481087		0
32631	1937	4112343	2010-09-10	2010-09-10 00:00:00	2010-09-22	2010-09-22 00:00:00	32020		\N	128849	0	195662009	4112343		0
43424	2586	4296204	1980-01-13	1980-01-13 00:00:00	1980-02-10	1980-02-10 00:00:00	32020		\N	171222	0	403190006	4296204		0
33007	1958	4152936	2004-09-11	2004-09-11 00:00:00	2004-09-25	2004-09-25 00:00:00	32020		\N	130245	0	283385000	4152936		0
43690	2602	40481087	1986-05-08	1986-05-08 00:00:00	1986-05-22	1986-05-22 00:00:00	32020		\N	172132	0	444814009	40481087		0
43838	2610	78272	1960-05-21	1960-05-21 00:00:00	1960-06-04	1960-06-04 00:00:00	32020		\N	172592	0	70704007	78272		0
44047	2620	40481087	1974-12-20	1974-12-20 00:00:00	1975-01-03	1975-01-03 00:00:00	32020		\N	173299	0	444814009	40481087		0
44162	2626	4134304	1976-01-25	1976-01-25 00:00:00	1976-03-25	1976-03-25 00:00:00	32020		\N	173742	0	263102004	4134304		0
33833	2007	40481087	1996-11-08	1996-11-08 00:00:00	1996-11-29	1996-11-29 00:00:00	32020		\N	133666	0	444814009	40481087		0
44565	2651	4237458	1952-05-24	1952-05-24 00:00:00	1952-06-23	1952-06-23 00:00:00	32020		\N	175416	0	58150001	4237458		0
44699	2659	4310024	2004-12-15	2004-12-15 00:00:00	\N	\N	32020		\N	176172	0	424802006	4310024		0
44881	2672	4112343	1964-11-26	1964-11-26 00:00:00	1964-12-05	1964-12-05 00:00:00	32020		\N	176885	0	195662009	4112343		0
45078	2682	40481087	1986-11-24	1986-11-24 00:00:00	1986-12-08	1986-12-08 00:00:00	32020		\N	177739	0	444814009	40481087		0
34649	2058	28060	2001-06-26	2001-06-26 00:00:00	2001-07-03	2001-07-03 00:00:00	32020		\N	136813	0	43878008	28060		0
45445	2702	81151	1999-09-18	1999-09-18 00:00:00	1999-10-09	1999-10-09 00:00:00	32020		\N	179042	0	44465007	81151		0
45537	2706	4113008	2000-08-06	2000-08-06 00:00:00	2000-08-27	2000-08-27 00:00:00	32020		\N	179260	0	284549007	4113008		0
45651	2712	260139	1995-10-30	1995-10-30 00:00:00	1995-11-13	1995-11-13 00:00:00	32020		\N	179828	0	10509002	260139		0
35347	2094	40481087	2012-09-29	2012-09-29 00:00:00	2012-10-06	2012-10-06 00:00:00	32020		\N	139586	0	444814009	40481087		0
46097	2747	40481087	2012-07-20	2012-07-20 00:00:00	2012-08-10	2012-08-10 00:00:00	32020		\N	181660	0	444814009	40481087		0
46186	2750	4109685	1980-07-31	1980-07-31 00:00:00	1980-08-14	1980-08-14 00:00:00	32020		\N	181873	0	284551006	4109685		0
46333	2760	40481087	1963-07-04	1963-07-04 00:00:00	1963-07-18	1963-07-18 00:00:00	32020		\N	182549	0	444814009	40481087		0
35995	2134	40481087	1959-12-20	1959-12-20 00:00:00	1960-01-10	1960-01-10 00:00:00	32020		\N	141975	0	444814009	40481087		0
46694	2778	378001	2014-12-24	2014-12-24 00:00:00	2015-02-22	2015-02-22 00:00:00	32020		\N	184026	0	62106007	378001		0
46830	2786	260139	1963-04-29	1963-04-29 00:00:00	1963-05-13	1963-05-13 00:00:00	32020		\N	184604	0	10509002	260139		0
47072	2801	4283893	1925-12-19	1925-12-19 00:00:00	1926-01-16	1926-01-16 00:00:00	32020		\N	185638	0	36971009	4283893		0
47178	2804	260139	1961-06-07	1961-06-07 00:00:00	1961-06-21	1961-06-21 00:00:00	32020		\N	185878	0	10509002	260139		0
47336	2815	4112343	1998-07-16	1998-07-16 00:00:00	1998-07-26	1998-07-26 00:00:00	32020		\N	186518	0	195662009	4112343		0
47504	2825	4112343	1960-07-02	1960-07-02 00:00:00	1960-07-11	1960-07-11 00:00:00	32020		\N	187269	0	195662009	4112343		0
37158	2200	4112343	1978-05-16	1978-05-16 00:00:00	1978-05-28	1978-05-28 00:00:00	32020		\N	146628	0	195662009	4112343		0
47816	2839	80180	2006-08-06	2006-08-06 00:00:00	\N	\N	32020		\N	188559	0	396275006	80180		0
48036	2849	40481087	2011-07-29	2011-07-29 00:00:00	2011-08-19	2011-08-19 00:00:00	32020		\N	189170	0	444814009	40481087		0
37658	2233	40481087	1972-08-07	1972-08-07 00:00:00	1972-08-28	1972-08-28 00:00:00	32020		\N	148593	0	444814009	40481087		0
37814	2240	40481087	1959-10-21	1959-10-21 00:00:00	1959-10-28	1959-10-28 00:00:00	32020		\N	149165	0	444814009	40481087		0
48564	2876	4146173	1997-02-04	1997-02-04 00:00:00	1997-04-05	1997-04-05 00:00:00	32020		\N	191363	0	307731004	4146173		0
48759	2889	4112343	1968-05-25	1968-05-25 00:00:00	1968-06-05	1968-06-05 00:00:00	32020		\N	192175	0	195662009	4112343		0
48834	2893	4059173	1956-05-15	1956-05-15 00:00:00	1956-07-14	1956-07-14 00:00:00	32020		\N	192518	0	16114001	4059173		0
49077	2904	28060	2006-05-12	2006-05-12 00:00:00	2006-05-24	2006-05-24 00:00:00	32020		\N	193485	0	43878008	28060		0
49261	2913	4112343	1973-02-27	1973-02-27 00:00:00	1973-03-09	1973-03-09 00:00:00	32020		\N	194111	0	195662009	4112343		0
49375	2919	4112343	1975-08-25	1975-08-25 00:00:00	1975-09-06	1975-09-06 00:00:00	32020		\N	194575	0	195662009	4112343		0
49505	2927	40481087	1977-06-03	1977-06-03 00:00:00	1977-06-10	1977-06-10 00:00:00	32020		\N	195200	0	444814009	40481087		0
49725	2942	4112343	1960-11-21	1960-11-21 00:00:00	1960-12-01	1960-12-01 00:00:00	32020		\N	196127	0	195662009	4112343		0
39295	2332	4310024	1995-01-06	1995-01-06 00:00:00	\N	\N	32020		\N	\N	0	424802006	4310024		0
46800	2782	381316	2002-03-06	2002-03-06 00:00:00	\N	\N	32020		\N	184443	0	230690007	381316		0
50014	2955	4112343	2016-03-31	2016-03-31 00:00:00	2016-04-08	2016-04-08 00:00:00	32020		\N	197244	0	195662009	4112343		0
39631	2346	4266809	1986-11-13	1986-11-13 00:00:00	\N	\N	32020		\N	156154	0	397881000	4266809		0
50319	2976	4029498	1955-06-23	1955-06-23 00:00:00	\N	\N	32020		\N	198734	0	128613002	4029498		0
50502	2987	192671	2015-07-03	2015-07-03 00:00:00	\N	\N	32020		\N	199401	0	K92.2	35208414		0
50654	2997	40481087	2008-04-11	2008-04-11 00:00:00	2008-05-02	2008-05-02 00:00:00	32020		\N	199926	0	444814009	40481087		0
50800	3004	40481087	1984-09-01	1984-09-01 00:00:00	1984-09-15	1984-09-15 00:00:00	32020		\N	200457	0	444814009	40481087		0
40463	2404	381316	1997-07-13	1997-07-13 00:00:00	\N	\N	32020		\N	159736	0	230690007	381316		0
51229	3035	260139	1974-08-25	1974-08-25 00:00:00	1974-09-01	1974-09-01 00:00:00	32020		\N	202180	0	10509002	260139		0
51323	3044	40481087	1994-09-02	1994-09-02 00:00:00	1994-09-23	1994-09-23 00:00:00	32020		\N	202593	0	444814009	40481087		0
51485	3056	4112343	2004-11-16	2004-11-16 00:00:00	2004-11-28	2004-11-28 00:00:00	32020		\N	203255	0	195662009	4112343		0
51737	3067	40481087	1947-01-17	1947-01-17 00:00:00	1947-01-24	1947-01-24 00:00:00	32020		\N	204126	0	444814009	40481087		0
51854	3074	40481087	1959-07-28	1959-07-28 00:00:00	1959-08-18	1959-08-18 00:00:00	32020		\N	204576	0	444814009	40481087		0
51997	3080	372328	1944-08-23	1944-08-23 00:00:00	1944-11-16	1944-11-16 00:00:00	32020		\N	205020	0	65363002	372328		0
52157	3087	40481087	2015-06-06	2015-06-06 00:00:00	2015-06-27	2015-06-27 00:00:00	32020		\N	205573	0	444814009	40481087		0
41813	2487	260139	1989-04-20	1989-04-20 00:00:00	1989-05-04	1989-05-04 00:00:00	32020		\N	164813	0	10509002	260139		0
52598	3115	30753	2005-11-01	2005-11-01 00:00:00	\N	\N	32020		\N	207223	0	16761005	30753		0
52741	3123	260139	2005-01-28	2005-01-28 00:00:00	2005-02-04	2005-02-04 00:00:00	32020		\N	207796	0	10509002	260139		0
52912	3134	40481087	1974-08-01	1974-08-01 00:00:00	1974-08-22	1974-08-22 00:00:00	32020		\N	208560	0	444814009	40481087		0
53093	3144	40481087	2003-08-06	2003-08-06 00:00:00	2003-08-20	2003-08-20 00:00:00	32020		\N	209225	0	444814009	40481087		0
42548	2537	381316	1998-09-06	1998-09-06 00:00:00	\N	\N	32020		\N	167610	0	230690007	381316		0
42800	2550	40481087	1987-07-21	1987-07-21 00:00:00	1987-08-04	1987-08-04 00:00:00	32020		\N	168832	0	444814009	40481087		0
42908	2555	40481087	1985-02-18	1985-02-18 00:00:00	1985-03-04	1985-03-04 00:00:00	32020		\N	169360	0	444814009	40481087		0
43051	2564	4218389	2009-12-22	2009-12-22 00:00:00	2010-01-19	2010-01-19 00:00:00	32020		\N	169908	0	39848009	4218389		0
32632	1937	40481087	2016-10-04	2016-10-04 00:00:00	2016-10-25	2016-10-25 00:00:00	32020		\N	128889	0	444814009	40481087		0
43425	2586	260139	2014-09-19	2014-09-19 00:00:00	2014-09-26	2014-09-26 00:00:00	32020		\N	171177	0	10509002	260139		0
33008	1958	4310024	2007-12-15	2007-12-15 00:00:00	\N	\N	32020		\N	130241	0	424802006	4310024		0
43691	2602	4285898	1986-10-15	1986-10-15 00:00:00	\N	\N	32020		\N	172132	0	68496003	4285898		0
43839	2610	40481087	1968-11-24	1968-11-24 00:00:00	1968-12-01	1968-12-01 00:00:00	32020		\N	172602	0	444814009	40481087		0
44048	2620	4278672	1992-11-05	1992-11-05 00:00:00	1993-02-03	1993-02-03 00:00:00	32020		\N	173274	0	65966004	4278672		0
44163	2626	40481087	1972-03-21	1972-03-21 00:00:00	1972-04-11	1972-04-11 00:00:00	32020		\N	173707	0	444814009	40481087		0
33834	2007	372328	1988-11-05	1988-11-05 00:00:00	1989-04-09	1989-04-09 00:00:00	32020		\N	133669	0	65363002	372328		0
44566	2651	40481087	1991-06-05	1991-06-05 00:00:00	1991-06-26	1991-06-26 00:00:00	32020		\N	175431	0	444814009	40481087		0
44700	2659	372328	1976-09-13	1976-09-13 00:00:00	1976-12-01	1976-12-01 00:00:00	32020		\N	176153	0	65363002	372328		0
44882	2672	4294548	1976-01-26	1976-01-26 00:00:00	1976-02-23	1976-02-23 00:00:00	32020		\N	177035	0	75498004	4294548		0
45079	2682	40481087	1981-11-08	1981-11-08 00:00:00	1981-11-15	1981-11-15 00:00:00	32020		\N	177709	0	444814009	40481087		0
34650	2058	40481087	1974-06-15	1974-06-15 00:00:00	1974-06-29	1974-06-29 00:00:00	32020		\N	136856	0	444814009	40481087		0
45446	2702	40481087	1979-12-30	1979-12-30 00:00:00	1980-01-13	1980-01-13 00:00:00	32020		\N	178966	0	444814009	40481087		0
45538	2706	40481087	2015-04-06	2015-04-06 00:00:00	2015-04-20	2015-04-20 00:00:00	32020		\N	179294	0	444814009	40481087		0
45652	2712	260139	1988-09-26	1988-09-26 00:00:00	1988-10-03	1988-10-03 00:00:00	32020		\N	179815	0	10509002	260139		0
35348	2094	40481087	2016-07-24	2016-07-24 00:00:00	2016-08-07	2016-08-07 00:00:00	32020		\N	139587	0	444814009	40481087		0
46098	2747	4218389	1980-06-29	1980-06-29 00:00:00	1980-07-20	1980-07-20 00:00:00	32020		\N	181718	0	39848009	4218389		0
46187	2750	4059173	1926-10-29	1926-10-29 00:00:00	1927-01-27	1927-01-27 00:00:00	32020		\N	181870	0	16114001	4059173		0
46334	2760	4266809	2001-05-31	2001-05-31 00:00:00	\N	\N	32020		\N	182583	0	397881000	4266809		0
35996	2134	4112343	1993-10-04	1993-10-04 00:00:00	1993-10-15	1993-10-15 00:00:00	32020		\N	141947	0	195662009	4112343		0
46695	2778	4048171	1979-10-30	1979-10-30 00:00:00	1995-10-28	1995-10-28 00:00:00	32020		\N	184028	0	232353008	4048171		0
46831	2786	260139	2003-11-17	2003-11-17 00:00:00	2003-12-01	2003-12-01 00:00:00	32020		\N	184620	0	10509002	260139		0
47073	2801	260139	1930-08-06	1930-08-06 00:00:00	1930-08-13	1930-08-13 00:00:00	32020		\N	185591	0	10509002	260139		0
47179	2804	378001	1999-04-25	1999-04-25 00:00:00	1999-05-25	1999-05-25 00:00:00	32020		\N	185855	0	62106007	378001		0
47337	2815	4278672	1996-01-17	1996-01-17 00:00:00	1996-04-16	1996-04-16 00:00:00	32020		\N	186532	0	65966004	4278672		0
47505	2825	375671	2014-05-21	2014-05-21 00:00:00	2014-07-20	2014-07-20 00:00:00	32020		\N	187335	0	62564004	375671		0
37159	2200	260139	1981-09-27	1981-09-27 00:00:00	1981-10-11	1981-10-11 00:00:00	32020		\N	146647	0	10509002	260139		0
47817	2839	81893	2005-08-11	2005-08-11 00:00:00	\N	\N	32020		\N	188559	0	64766004	81893		0
48037	2849	4146173	2011-03-23	2011-03-23 00:00:00	2011-05-22	2011-05-22 00:00:00	32020		\N	189169	0	307731004	4146173		0
37659	2233	4113008	2001-09-06	2001-09-06 00:00:00	2001-09-20	2001-09-20 00:00:00	32020		\N	148605	0	284549007	4113008		0
37815	2240	4155034	1966-10-05	1966-10-05 00:00:00	1966-10-19	1966-10-19 00:00:00	32020		\N	149135	0	283371005	4155034		0
48565	2876	4112343	2017-12-12	2017-12-12 00:00:00	2017-12-20	2017-12-20 00:00:00	32020		\N	191364	0	195662009	4112343		0
48760	2889	4112343	1995-02-13	1995-02-13 00:00:00	1995-02-26	1995-02-26 00:00:00	32020		\N	192165	0	195662009	4112343		0
48835	2893	28060	1980-11-25	1980-11-25 00:00:00	1980-12-07	1980-12-07 00:00:00	32020		\N	192532	0	43878008	28060		0
49078	2904	80180	2007-03-27	2007-03-27 00:00:00	\N	\N	32020		\N	193485	0	396275006	80180		0
49262	2913	4112343	1956-12-28	1956-12-28 00:00:00	1957-01-09	1957-01-09 00:00:00	32020		\N	194109	0	195662009	4112343		0
49376	2919	4112343	1969-03-02	1969-03-02 00:00:00	1969-03-12	1969-03-12 00:00:00	32020		\N	194587	0	195662009	4112343		0
49506	2927	260139	1962-07-20	1962-07-20 00:00:00	1962-07-27	1962-07-27 00:00:00	32020		\N	195209	0	10509002	260139		0
49726	2942	260139	2007-12-09	2007-12-09 00:00:00	2007-12-16	2007-12-16 00:00:00	32020		\N	196209	0	10509002	260139		0
39296	2332	40481087	1957-07-25	1957-07-25 00:00:00	1957-08-15	1957-08-15 00:00:00	32020		\N	155100	0	444814009	40481087		0
50015	2955	4112343	1995-05-13	1995-05-13 00:00:00	1995-05-24	1995-05-24 00:00:00	32020		\N	197243	0	195662009	4112343		0
39632	2346	28060	2019-02-13	2019-02-13 00:00:00	2019-02-21	2019-02-21 00:00:00	32020		\N	156172	0	43878008	28060		0
50320	2976	4266809	1995-09-26	1995-09-26 00:00:00	\N	\N	32020		\N	198773	0	397881000	4266809		0
50503	2987	260139	1989-05-30	1989-05-30 00:00:00	1989-06-13	1989-06-13 00:00:00	32020		\N	199371	0	10509002	260139		0
50655	2997	4112343	2015-12-08	2015-12-08 00:00:00	2015-12-20	2015-12-20 00:00:00	32020		\N	199941	0	195662009	4112343		0
50801	3004	40481087	1974-06-26	1974-06-26 00:00:00	1974-07-03	1974-07-03 00:00:00	32020		\N	200434	0	444814009	40481087		0
40464	2404	28060	2003-07-14	2003-07-14 00:00:00	2003-07-21	2003-07-21 00:00:00	32020		\N	159713	0	43878008	28060		0
51230	3035	372328	1968-01-28	1968-01-28 00:00:00	1968-11-29	1968-11-29 00:00:00	32020		\N	202203	0	65363002	372328		0
51324	3044	28060	2017-01-30	2017-01-30 00:00:00	2017-02-09	2017-02-09 00:00:00	32020		\N	202643	0	43878008	28060		0
51486	3056	4051466	1960-01-04	1960-01-04 00:00:00	1976-04-10	1976-04-10 00:00:00	32020		\N	203235	0	233678006	4051466		0
51738	3067	4296204	1998-03-08	1998-03-08 00:00:00	1998-03-29	1998-03-29 00:00:00	32020		\N	204186	0	403190006	4296204		0
51855	3074	372328	1996-03-24	1996-03-24 00:00:00	1996-07-24	1996-07-24 00:00:00	32020		\N	204542	0	65363002	372328		0
51998	3081	4112343	1984-09-07	1984-09-07 00:00:00	1984-09-20	1984-09-20 00:00:00	32020		\N	205100	0	195662009	4112343		0
52158	3087	260139	1984-07-18	1984-07-18 00:00:00	1984-07-25	1984-07-25 00:00:00	32020		\N	205563	0	10509002	260139		0
41814	2487	4112343	1995-12-23	1995-12-23 00:00:00	1996-01-05	1996-01-05 00:00:00	32020		\N	164790	0	195662009	4112343		0
52599	3115	4113008	2009-09-09	2009-09-09 00:00:00	2009-09-30	2009-09-30 00:00:00	32020		\N	207281	0	284549007	4113008		0
52742	3123	260139	1989-10-03	1989-10-03 00:00:00	1989-10-17	1989-10-17 00:00:00	32020		\N	207768	0	10509002	260139		0
52913	3134	40481087	1978-10-04	1978-10-04 00:00:00	1978-10-18	1978-10-18 00:00:00	32020		\N	208630	0	444814009	40481087		0
53094	3144	40481087	1998-12-11	1998-12-11 00:00:00	1998-12-25	1998-12-25 00:00:00	32020		\N	209204	0	444814009	40481087		0
42549	2537	372328	1950-11-16	1950-11-16 00:00:00	1951-01-21	1951-01-21 00:00:00	32020		\N	167766	0	65363002	372328		0
42801	2550	257012	1997-08-21	1997-08-21 00:00:00	\N	\N	32020		\N	168817	0	40055000	257012		0
42909	2555	257012	1986-12-28	1986-12-28 00:00:00	\N	\N	32020		\N	169340	0	40055000	257012		0
43052	2564	4294548	1996-05-24	1996-05-24 00:00:00	1997-04-18	1997-04-18 00:00:00	32020		\N	169915	0	75498004	4294548		0
32633	1937	40479422	1977-07-13	1977-07-13 00:00:00	1977-09-18	1977-09-18 00:00:00	32020		\N	128905	0	444448004	40479422		0
43431	2588	81151	1987-01-26	1987-01-26 00:00:00	1987-02-16	1987-02-16 00:00:00	32020		\N	171311	0	44465007	81151		0
33009	1958	80180	2010-08-01	2010-08-01 00:00:00	\N	\N	32020		\N	130276	0	396275006	80180		0
43692	2602	80180	1986-11-14	1986-11-14 00:00:00	\N	\N	32020		\N	172132	0	396275006	80180		0
43840	2610	4035415	1969-05-18	1969-05-18 00:00:00	1969-07-17	1969-07-17 00:00:00	32020		\N	172594	0	239720000	4035415		0
44049	2620	260139	2015-11-09	2015-11-09 00:00:00	2015-11-23	2015-11-23 00:00:00	32020		\N	173278	0	10509002	260139		0
44164	2626	78272	2014-01-05	2014-01-05 00:00:00	2014-01-19	2014-01-19 00:00:00	32020		\N	173744	0	70704007	78272		0
33835	2007	372328	1987-12-27	1987-12-27 00:00:00	1988-01-10	1988-01-10 00:00:00	32020		\N	133662	0	65363002	372328		0
44567	2651	4296204	2017-01-28	2017-01-28 00:00:00	2017-03-04	2017-03-04 00:00:00	32020		\N	175424	0	403190006	4296204		0
44701	2659	4237458	1979-06-19	1979-06-19 00:00:00	1979-09-17	1979-09-17 00:00:00	32020		\N	176147	0	58150001	4237458		0
44883	2672	81151	2005-08-12	2005-08-12 00:00:00	2005-09-02	2005-09-02 00:00:00	32020		\N	176984	0	44465007	81151		0
45080	2682	4237458	2017-02-04	2017-02-04 00:00:00	2017-05-05	2017-05-05 00:00:00	32020		\N	177726	0	58150001	4237458		0
34651	2058	40479422	2013-08-09	2013-08-09 00:00:00	2013-09-15	2013-09-15 00:00:00	32020		\N	136800	0	444448004	40479422		0
45447	2702	28060	2014-08-17	2014-08-17 00:00:00	2014-08-30	2014-08-30 00:00:00	32020		\N	178939	0	43878008	28060		0
45539	2706	40481087	1984-05-07	1984-05-07 00:00:00	1984-05-21	1984-05-21 00:00:00	32020		\N	179291	0	444814009	40481087		0
45653	2712	372328	1964-05-29	1964-05-29 00:00:00	1964-09-08	1964-09-08 00:00:00	32020		\N	179816	0	65363002	372328		0
35349	2094	40481087	1950-01-28	1950-01-28 00:00:00	1950-02-18	1950-02-18 00:00:00	32020		\N	139582	0	444814009	40481087		0
46099	2747	80180	2009-11-14	2009-11-14 00:00:00	\N	\N	32020		\N	181674	0	396275006	80180		0
46188	2750	40481087	1989-01-13	1989-01-13 00:00:00	1989-02-03	1989-02-03 00:00:00	32020		\N	181947	0	444814009	40481087		0
46335	2760	80180	2001-05-31	2001-05-31 00:00:00	\N	\N	32020		\N	182583	0	396275006	80180		0
35997	2134	4112343	2007-04-09	2007-04-09 00:00:00	2007-04-21	2007-04-21 00:00:00	32020		\N	142017	0	195662009	4112343		0
46696	2778	40481087	1998-11-21	1998-11-21 00:00:00	1998-12-05	1998-12-05 00:00:00	32020		\N	183978	0	444814009	40481087		0
46832	2786	372328	1935-06-24	1935-06-24 00:00:00	1936-05-23	1936-05-23 00:00:00	32020		\N	184566	0	65363002	372328		0
47074	2801	4059173	1984-03-01	1984-03-01 00:00:00	1984-05-30	1984-05-30 00:00:00	32020		\N	185615	0	16114001	4059173		0
47180	2804	4152936	1988-03-20	1988-03-20 00:00:00	1988-04-10	1988-04-10 00:00:00	32020		\N	185852	0	283385000	4152936		0
47363	2818	372328	1971-08-04	1971-08-04 00:00:00	1972-07-31	1972-07-31 00:00:00	32020		\N	186757	0	65363002	372328		0
47506	2825	40481087	2018-05-23	2018-05-23 00:00:00	2018-06-06	2018-06-06 00:00:00	32020		\N	187231	0	444814009	40481087		0
37160	2200	4266809	2014-04-16	2014-04-16 00:00:00	\N	\N	32020		\N	146659	0	397881000	4266809		0
47820	2841	4112343	1983-02-23	1983-02-23 00:00:00	1983-03-05	1983-03-05 00:00:00	32020		\N	188618	0	195662009	4112343		0
48038	2849	4237458	2004-04-28	2004-04-28 00:00:00	2004-06-27	2004-06-27 00:00:00	32020		\N	189297	0	58150001	4237458		0
37660	2233	78272	1997-06-24	1997-06-24 00:00:00	1997-07-29	1997-07-29 00:00:00	32020		\N	148604	0	70704007	78272		0
37816	2240	4112343	2016-12-05	2016-12-05 00:00:00	2016-12-12	2016-12-12 00:00:00	32020		\N	149104	0	195662009	4112343		0
48566	2876	4112343	1995-09-01	1995-09-01 00:00:00	1995-09-10	1995-09-10 00:00:00	32020		\N	191343	0	195662009	4112343		0
48762	2889	28060	1969-09-29	1969-09-29 00:00:00	1969-10-12	1969-10-12 00:00:00	32020		\N	192123	0	43878008	28060		0
48836	2893	372328	1954-06-04	1954-06-04 00:00:00	1955-06-22	1955-06-22 00:00:00	32020		\N	192505	0	65363002	372328		0
49079	2904	40481087	2007-07-01	2007-07-01 00:00:00	2007-07-22	2007-07-22 00:00:00	32020		\N	193486	0	444814009	40481087		0
49264	2914	321042	1986-09-06	1986-09-06 00:00:00	\N	\N	32020		\N	194195	0	410429000	321042		0
49377	2919	4112343	1959-06-07	1959-06-07 00:00:00	1959-06-19	1959-06-19 00:00:00	32020		\N	194601	0	195662009	4112343		0
49507	2927	40481087	1956-06-29	1956-06-29 00:00:00	1956-07-20	1956-07-20 00:00:00	32020		\N	195259	0	444814009	40481087		0
49727	2942	260139	1983-05-24	1983-05-24 00:00:00	1983-05-31	1983-05-31 00:00:00	32020		\N	196132	0	10509002	260139		0
39297	2332	40481087	2001-09-08	2001-09-08 00:00:00	2001-09-15	2001-09-15 00:00:00	32020		\N	155064	0	444814009	40481087		0
50016	2955	80180	2004-08-04	2004-08-04 00:00:00	\N	\N	32020		\N	197222	0	396275006	80180		0
39633	2347	260139	2008-01-31	2008-01-31 00:00:00	2008-02-07	2008-02-07 00:00:00	32020		\N	156226	0	10509002	260139		0
50321	2976	260139	2005-09-19	2005-09-19 00:00:00	2005-10-03	2005-10-03 00:00:00	32020		\N	198709	0	10509002	260139		0
50504	2988	381316	2012-06-24	2012-06-24 00:00:00	\N	\N	32020		\N	199457	0	230690007	381316		0
50656	2997	260139	1993-12-01	1993-12-01 00:00:00	1993-12-15	1993-12-15 00:00:00	32020		\N	199970	0	10509002	260139		0
50802	3004	4112343	2004-12-24	2004-12-24 00:00:00	2005-01-04	2005-01-04 00:00:00	32020		\N	200501	0	195662009	4112343		0
40465	2404	4283893	1969-10-23	1969-10-23 00:00:00	1969-11-06	1969-11-06 00:00:00	32020		\N	159764	0	36971009	4283893		0
51231	3035	40481087	2015-07-11	2015-07-11 00:00:00	2015-08-01	2015-08-01 00:00:00	32020		\N	202184	0	444814009	40481087		0
51325	3044	40481087	2006-09-29	2006-09-29 00:00:00	2006-10-20	2006-10-20 00:00:00	32020		\N	202642	0	444814009	40481087		0
51487	3056	40481087	1981-02-28	1981-02-28 00:00:00	1981-03-21	1981-03-21 00:00:00	32020		\N	203290	0	444814009	40481087		0
51739	3067	4112343	2009-05-26	2009-05-26 00:00:00	2009-06-06	2009-06-06 00:00:00	32020		\N	204117	0	195662009	4112343		0
51856	3074	260139	1968-04-07	1968-04-07 00:00:00	1968-04-21	1968-04-21 00:00:00	32020		\N	204595	0	10509002	260139		0
51999	3081	40481087	1958-06-07	1958-06-07 00:00:00	1958-06-14	1958-06-14 00:00:00	32020		\N	205115	0	444814009	40481087		0
52159	3087	4278672	1996-07-15	1996-07-15 00:00:00	1996-10-13	1996-10-13 00:00:00	32020		\N	205556	0	65966004	4278672		0
41815	2487	80180	1992-08-09	1992-08-09 00:00:00	\N	\N	32020		\N	164821	0	396275006	80180		0
53135	3147	258780	1972-02-14	1972-02-14 00:00:00	\N	\N	32020		\N	209418	0	185086009	258780		0
52600	3115	260139	1987-04-26	1987-04-26 00:00:00	1987-05-10	1987-05-10 00:00:00	32020		\N	207256	0	10509002	260139		0
52743	3123	40481087	1984-10-17	1984-10-17 00:00:00	1984-11-07	1984-11-07 00:00:00	32020		\N	207767	0	444814009	40481087		0
52914	3134	40481087	1926-05-07	1926-05-07 00:00:00	1926-05-28	1926-05-28 00:00:00	32020		\N	208626	0	444814009	40481087		0
53095	3144	260139	1974-11-16	1974-11-16 00:00:00	1974-11-30	1974-11-30 00:00:00	32020		\N	209181	0	10509002	260139		0
42550	2537	81151	1957-11-13	1957-11-13 00:00:00	1957-12-04	1957-12-04 00:00:00	32020		\N	167645	0	44465007	81151		0
42802	2550	4059173	1997-01-02	1997-01-02 00:00:00	1997-03-03	1997-03-03 00:00:00	32020		\N	168803	0	16114001	4059173		0
42910	2555	4156265	1969-04-28	1969-04-28 00:00:00	1969-05-19	1969-05-19 00:00:00	32020		\N	169312	0	370247008	4156265		0
43053	2564	257012	1996-06-14	1996-06-14 00:00:00	\N	\N	32020		\N	169889	0	40055000	257012		0
32634	1937	40481087	1990-07-29	1990-07-29 00:00:00	1990-08-05	1990-08-05 00:00:00	32020		\N	128875	0	444814009	40481087		0
43432	2588	81151	1979-07-02	1979-07-02 00:00:00	1979-08-06	1979-08-06 00:00:00	32020		\N	171310	0	44465007	81151		0
33010	1958	4285898	2010-03-04	2010-03-04 00:00:00	\N	\N	32020		\N	130276	0	68496003	4285898		0
43693	2602	28060	2019-06-11	2019-06-11 00:00:00	2019-06-23	2019-06-23 00:00:00	32020		\N	172161	0	43878008	28060		0
43841	2610	40481087	2017-10-21	2017-10-21 00:00:00	2017-11-04	2017-11-04 00:00:00	32020		\N	172607	0	444814009	40481087		0
44050	2620	4116491	2002-11-02	2002-11-02 00:00:00	2002-12-25	2002-12-25 00:00:00	32020		\N	173311	0	301011002	4116491		0
44165	2626	260139	2007-12-19	2007-12-19 00:00:00	2008-01-02	2008-01-02 00:00:00	32020		\N	173682	0	10509002	260139		0
44330	2636	372328	1964-03-25	1964-03-25 00:00:00	1965-03-26	1965-03-26 00:00:00	32020		\N	174425	0	65363002	372328		0
44568	2651	372328	1963-03-18	1963-03-18 00:00:00	1964-02-19	1964-02-19 00:00:00	32020		\N	175448	0	65363002	372328		0
44702	2659	81893	2005-06-13	2005-06-13 00:00:00	\N	\N	32020		\N	176158	0	64766004	81893		0
44884	2672	4112343	2008-02-29	2008-02-29 00:00:00	2008-03-12	2008-03-12 00:00:00	32020		\N	176896	0	195662009	4112343		0
45081	2682	81151	1978-05-20	1978-05-20 00:00:00	1978-06-24	1978-06-24 00:00:00	32020		\N	177724	0	44465007	81151		0
34652	2058	260139	1972-09-26	1972-09-26 00:00:00	1972-10-03	1972-10-03 00:00:00	32020		\N	136870	0	10509002	260139		0
45448	2702	4112343	2003-11-20	2003-11-20 00:00:00	2003-11-28	2003-11-28 00:00:00	32020		\N	178937	0	195662009	4112343		0
45540	2706	317576	2006-06-20	2006-06-20 00:00:00	\N	\N	32020		\N	179305	0	53741008	317576		0
45654	2712	4113008	2003-08-06	2003-08-06 00:00:00	2003-08-27	2003-08-27 00:00:00	32020		\N	179885	0	284549007	4113008		0
35350	2094	40481087	1945-12-07	1945-12-07 00:00:00	1945-12-21	1945-12-21 00:00:00	32020		\N	139592	0	444814009	40481087		0
46100	2747	28060	1994-09-23	1994-09-23 00:00:00	1994-10-04	1994-10-04 00:00:00	32020		\N	181717	0	43878008	28060		0
46189	2750	260139	1935-03-18	1935-03-18 00:00:00	1935-03-25	1935-03-25 00:00:00	32020		\N	181886	0	10509002	260139		0
46336	2760	195588	1998-03-18	1998-03-18 00:00:00	1998-04-25	1998-04-25 00:00:00	32020		\N	182555	0	38822007	195588		0
35998	2134	40481087	1960-11-25	1960-11-25 00:00:00	1960-12-16	1960-12-16 00:00:00	32020		\N	141944	0	444814009	40481087		0
46697	2778	4112343	1977-07-23	1977-07-23 00:00:00	1977-08-01	1977-08-01 00:00:00	32020		\N	184027	0	195662009	4112343		0
46833	2786	372328	1947-01-26	1947-01-26 00:00:00	1948-07-03	1948-07-03 00:00:00	32020		\N	184638	0	65363002	372328		0
47075	2801	40481087	1966-12-07	1966-12-07 00:00:00	1966-12-28	1966-12-28 00:00:00	32020		\N	185573	0	444814009	40481087		0
47181	2804	260139	1963-02-16	1963-02-16 00:00:00	1963-02-23	1963-02-23 00:00:00	32020		\N	185845	0	10509002	260139		0
47364	2818	40481087	2000-02-04	2000-02-04 00:00:00	2000-02-18	2000-02-18 00:00:00	32020		\N	186732	0	444814009	40481087		0
47507	2825	4218389	1927-03-16	1927-03-16 00:00:00	1927-04-13	1927-04-13 00:00:00	32020		\N	187258	0	39848009	4218389		0
37161	2200	80180	2014-04-16	2014-04-16 00:00:00	\N	\N	32020		\N	146659	0	396275006	80180		0
47821	2841	4237458	1981-11-01	1981-11-01 00:00:00	1981-12-31	1981-12-31 00:00:00	32020		\N	188633	0	58150001	4237458		0
48039	2849	260139	1928-09-27	1928-09-27 00:00:00	1928-10-04	1928-10-04 00:00:00	32020		\N	189300	0	10509002	260139		0
37661	2233	260139	2009-04-10	2009-04-10 00:00:00	2009-04-24	2009-04-24 00:00:00	32020		\N	148587	0	10509002	260139		0
37817	2240	4134304	1987-07-01	1987-07-01 00:00:00	1987-09-29	1987-09-29 00:00:00	32020		\N	149136	0	263102004	4134304		0
48567	2876	372328	1966-09-07	1966-09-07 00:00:00	1967-03-16	1967-03-16 00:00:00	32020		\N	191331	0	65363002	372328		0
48763	2889	40481087	1995-04-04	1995-04-04 00:00:00	1995-04-11	1995-04-11 00:00:00	32020		\N	192143	0	444814009	40481087		0
48837	2893	4109685	2009-02-02	2009-02-02 00:00:00	2009-02-16	2009-02-16 00:00:00	32020		\N	192515	0	284551006	4109685		0
49080	2904	4112343	1999-05-05	1999-05-05 00:00:00	1999-05-16	1999-05-16 00:00:00	32020		\N	193484	0	195662009	4112343		0
49265	2914	4027663	1986-09-23	1986-09-23 00:00:00	\N	\N	32020		\N	194195	0	13200003	4027663		0
49378	2919	317576	2017-12-16	2017-12-16 00:00:00	\N	\N	32020		\N	194622	0	53741008	317576		0
49508	2927	81151	1957-02-18	1957-02-18 00:00:00	1957-03-25	1957-03-25 00:00:00	32020		\N	195294	0	44465007	81151		0
49728	2942	372328	1979-01-20	1979-01-20 00:00:00	1981-12-30	1981-12-30 00:00:00	32020		\N	196192	0	65363002	372328		0
39298	2332	4027663	1987-04-13	1987-04-13 00:00:00	\N	\N	32020		\N	155051	0	13200003	4027663		0
50017	2955	4294548	1979-10-29	1979-10-29 00:00:00	1980-02-25	1980-02-25 00:00:00	32020		\N	197261	0	75498004	4294548		0
39634	2347	195588	2015-11-21	2015-11-21 00:00:00	2016-01-09	2016-01-09 00:00:00	32020		\N	156236	0	38822007	195588		0
50322	2976	40481087	1964-05-11	1964-05-11 00:00:00	1964-05-25	1964-05-25 00:00:00	32020		\N	198724	0	444814009	40481087		0
50505	2988	40481087	1979-11-08	1979-11-08 00:00:00	1979-11-29	1979-11-29 00:00:00	32020		\N	199470	0	444814009	40481087		0
50657	2997	40481087	2016-09-23	2016-09-23 00:00:00	2016-10-07	2016-10-07 00:00:00	32020		\N	199972	0	444814009	40481087		0
50803	3004	40481087	1977-11-23	1977-11-23 00:00:00	1977-11-30	1977-11-30 00:00:00	32020		\N	200466	0	444814009	40481087		0
40466	2404	4112343	1994-06-14	1994-06-14 00:00:00	1994-06-27	1994-06-27 00:00:00	32020		\N	159749	0	195662009	4112343		0
51232	3035	4278672	1968-05-27	1968-05-27 00:00:00	1968-07-26	1968-07-26 00:00:00	32020		\N	202209	0	65966004	4278672		0
51326	3044	80180	2007-09-29	2007-09-29 00:00:00	\N	\N	32020		\N	202642	0	396275006	80180		0
51488	3056	4112343	1988-09-18	1988-09-18 00:00:00	1988-09-26	1988-09-26 00:00:00	32020		\N	203231	0	195662009	4112343		0
51740	3067	260139	1970-10-09	1970-10-09 00:00:00	1970-10-23	1970-10-23 00:00:00	32020		\N	204128	0	10509002	260139		0
51857	3074	4152936	2018-07-15	2018-07-15 00:00:00	2018-07-29	2018-07-29 00:00:00	32020		\N	204575	0	283385000	4152936		0
52000	3081	4035415	1985-09-21	1985-09-21 00:00:00	1985-11-20	1985-11-20 00:00:00	32020		\N	205136	0	239720000	4035415		0
52160	3087	4112343	1968-04-05	1968-04-05 00:00:00	1968-04-18	1968-04-18 00:00:00	32020		\N	205514	0	195662009	4112343		0
41816	2487	260139	2013-01-07	2013-01-07 00:00:00	2013-01-14	2013-01-14 00:00:00	32020		\N	164806	0	10509002	260139		0
52601	3115	192671	2006-05-28	2006-05-28 00:00:00	\N	\N	32020		\N	207242	0	K92.2	35208414		0
52744	3123	4084167	1978-02-01	1978-02-01 00:00:00	1978-02-02	1978-02-02 00:00:00	32020		\N	207816	0	241929008	4084167		0
52915	3134	40481087	2017-02-19	2017-02-19 00:00:00	2017-02-26	2017-02-26 00:00:00	32020		\N	208540	0	444814009	40481087		0
53096	3144	4116491	1998-05-20	1998-05-20 00:00:00	1998-07-08	1998-07-08 00:00:00	32020		\N	209213	0	301011002	4116491		0
42551	2537	40481087	1952-01-01	1952-01-01 00:00:00	1952-01-08	1952-01-08 00:00:00	32020		\N	167709	0	444814009	40481087		0
42803	2550	4116491	2012-01-09	2012-01-09 00:00:00	2012-02-15	2012-02-15 00:00:00	32020		\N	168807	0	301011002	4116491		0
42911	2555	4156265	1995-04-08	1995-04-08 00:00:00	1995-04-22	1995-04-22 00:00:00	32020		\N	169319	0	370247008	4156265		0
43054	2564	40481087	1996-02-04	1996-02-04 00:00:00	1996-02-18	1996-02-18 00:00:00	32020		\N	169834	0	444814009	40481087		0
32635	1937	40481087	1967-07-27	1967-07-27 00:00:00	1967-08-17	1967-08-17 00:00:00	32020		\N	128887	0	444814009	40481087		0
43433	2588	260139	2010-09-28	2010-09-28 00:00:00	2010-10-12	2010-10-12 00:00:00	32020		\N	171288	0	10509002	260139		0
33011	1958	81893	2008-06-12	2008-06-12 00:00:00	\N	\N	32020		\N	130276	0	64766004	81893		0
43694	2602	372328	1948-11-28	1948-11-28 00:00:00	1949-02-09	1949-02-09 00:00:00	32020		\N	172111	0	65363002	372328		0
43842	2610	28060	1983-09-13	1983-09-13 00:00:00	1983-09-20	1983-09-20 00:00:00	32020		\N	172551	0	43878008	28060		0
44051	2620	81151	2001-06-21	2001-06-21 00:00:00	2001-07-26	2001-07-26 00:00:00	32020		\N	173255	0	44465007	81151		0
44166	2626	4278672	1968-02-06	1968-02-06 00:00:00	1968-04-06	1968-04-06 00:00:00	32020		\N	173741	0	65966004	4278672		0
44331	2636	4112343	1968-03-17	1968-03-17 00:00:00	1968-03-28	1968-03-28 00:00:00	32020		\N	174484	0	195662009	4112343		0
44569	2651	28060	1973-11-08	1973-11-08 00:00:00	1973-11-17	1973-11-17 00:00:00	32020		\N	175488	0	43878008	28060		0
44703	2659	4112343	2005-01-03	2005-01-03 00:00:00	2005-01-14	2005-01-14 00:00:00	32020		\N	176158	0	195662009	4112343		0
44885	2672	40481087	1995-06-17	1995-06-17 00:00:00	1995-06-24	1995-06-24 00:00:00	32020		\N	176889	0	444814009	40481087		0
45082	2682	4112343	1982-02-11	1982-02-11 00:00:00	1982-02-22	1982-02-22 00:00:00	32020		\N	177727	0	195662009	4112343		0
34653	2058	40481087	1994-02-20	1994-02-20 00:00:00	1994-02-27	1994-02-27 00:00:00	32020		\N	136913	0	444814009	40481087		0
45449	2702	4112343	2017-10-14	2017-10-14 00:00:00	2017-10-23	2017-10-23 00:00:00	32020		\N	178940	0	195662009	4112343		0
45541	2706	80180	2006-11-19	2006-11-19 00:00:00	\N	\N	32020		\N	179305	0	396275006	80180		0
45655	2712	372328	1968-01-30	1968-01-30 00:00:00	1968-12-10	1968-12-10 00:00:00	32020		\N	179822	0	65363002	372328		0
35351	2094	4237458	1950-07-06	1950-07-06 00:00:00	1950-10-04	1950-10-04 00:00:00	32020		\N	139572	0	58150001	4237458		0
46101	2747	4112343	2007-01-24	2007-01-24 00:00:00	2007-02-05	2007-02-05 00:00:00	32020		\N	181706	0	195662009	4112343		0
46190	2750	28060	1928-12-03	1928-12-03 00:00:00	1928-12-14	1928-12-14 00:00:00	32020		\N	181942	0	43878008	28060		0
46337	2760	40481087	1980-07-27	1980-07-27 00:00:00	1980-08-10	1980-08-10 00:00:00	32020		\N	182557	0	444814009	40481087		0
35999	2134	4146173	2006-03-14	2006-03-14 00:00:00	2006-05-13	2006-05-13 00:00:00	32020		\N	141980	0	307731004	4146173		0
46698	2778	80180	2011-07-27	2011-07-27 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
46834	2786	40481087	1929-12-25	1929-12-25 00:00:00	1930-01-08	1930-01-08 00:00:00	32020		\N	184601	0	444814009	40481087		0
47076	2801	257012	1933-05-15	1933-05-15 00:00:00	\N	\N	32020		\N	185647	0	40055000	257012		0
47182	2804	372328	1954-04-27	1954-04-27 00:00:00	1954-09-15	1954-09-15 00:00:00	32020		\N	185816	0	65363002	372328		0
47365	2818	260139	2004-04-30	2004-04-30 00:00:00	2004-05-14	2004-05-14 00:00:00	32020		\N	186721	0	10509002	260139		0
47508	2825	40481087	2009-12-29	2009-12-29 00:00:00	2010-01-12	2010-01-12 00:00:00	32020		\N	187340	0	444814009	40481087		0
37162	2200	4285898	2013-07-20	2013-07-20 00:00:00	\N	\N	32020		\N	146659	0	68496003	4285898		0
47822	2841	40481087	1950-05-28	1950-05-28 00:00:00	1950-06-11	1950-06-11 00:00:00	32020		\N	188610	0	444814009	40481087		0
48040	2849	81151	1984-10-26	1984-10-26 00:00:00	1984-11-09	1984-11-09 00:00:00	32020		\N	189294	0	44465007	81151		0
37662	2233	80180	2014-07-10	2014-07-10 00:00:00	\N	\N	32020		\N	148555	0	396275006	80180		0
37818	2240	4112343	2006-10-23	2006-10-23 00:00:00	2006-11-05	2006-11-05 00:00:00	32020		\N	149146	0	195662009	4112343		0
48568	2876	40481087	1977-09-01	1977-09-01 00:00:00	1977-09-15	1977-09-15 00:00:00	32020		\N	191341	0	444814009	40481087		0
48764	2889	4112343	1961-08-13	1961-08-13 00:00:00	1961-08-26	1961-08-26 00:00:00	32020		\N	192122	0	195662009	4112343		0
48838	2893	80180	1985-08-05	1985-08-05 00:00:00	\N	\N	32020		\N	192482	0	396275006	80180		0
49081	2905	260139	1981-02-14	1981-02-14 00:00:00	1981-02-21	1981-02-21 00:00:00	32020		\N	193538	0	10509002	260139		0
49266	2914	4112343	1999-01-20	1999-01-20 00:00:00	1999-02-01	1999-02-01 00:00:00	32020		\N	194180	0	195662009	4112343		0
49379	2919	40481087	1958-12-29	1958-12-29 00:00:00	1959-01-19	1959-01-19 00:00:00	32020		\N	194574	0	444814009	40481087		0
49509	2927	378001	1995-04-05	1995-04-05 00:00:00	1995-06-04	1995-06-04 00:00:00	32020		\N	195297	0	62106007	378001		0
49729	2942	4059173	1968-04-09	1968-04-09 00:00:00	1968-06-08	1968-06-08 00:00:00	32020		\N	196057	0	16114001	4059173		0
39299	2332	40481087	1967-10-24	1967-10-24 00:00:00	1967-10-31	1967-10-31 00:00:00	32020		\N	155049	0	444814009	40481087		0
50018	2955	260139	1983-05-02	1983-05-02 00:00:00	1983-05-09	1983-05-09 00:00:00	32020		\N	197204	0	10509002	260139		0
39635	2347	40481087	1984-04-21	1984-04-21 00:00:00	1984-05-12	1984-05-12 00:00:00	32020		\N	156251	0	444814009	40481087		0
50323	2976	40481087	1965-07-25	1965-07-25 00:00:00	1965-08-08	1965-08-08 00:00:00	32020		\N	198725	0	444814009	40481087		0
50506	2988	440086	1976-06-06	1976-06-06 00:00:00	1980-06-15	1980-06-15 00:00:00	32020		\N	199466	0	192127007	440086		0
50658	2997	80180	2016-11-09	2016-11-09 00:00:00	\N	\N	32020		\N	199972	0	396275006	80180		0
50804	3004	4296204	1992-10-22	1992-10-22 00:00:00	1992-11-05	1992-11-05 00:00:00	32020		\N	200512	0	403190006	4296204		0
40467	2404	4266809	2008-04-18	2008-04-18 00:00:00	\N	\N	32020		\N	159732	0	397881000	4266809		0
51233	3035	40481087	1976-11-04	1976-11-04 00:00:00	1976-11-11	1976-11-11 00:00:00	32020		\N	202167	0	444814009	40481087		0
51327	3044	40481087	2000-04-03	2000-04-03 00:00:00	2000-04-24	2000-04-24 00:00:00	32020		\N	202612	0	444814009	40481087		0
51489	3056	40481087	2008-11-10	2008-11-10 00:00:00	2008-12-01	2008-12-01 00:00:00	32020		\N	203257	0	444814009	40481087		0
51741	3067	372328	1941-01-12	1941-01-12 00:00:00	1941-02-25	1941-02-25 00:00:00	32020		\N	204157	0	65363002	372328		0
51858	3074	4112343	1962-05-25	1962-05-25 00:00:00	1962-06-04	1962-06-04 00:00:00	32020		\N	204536	0	195662009	4112343		0
52001	3081	260139	2015-09-03	2015-09-03 00:00:00	2015-09-17	2015-09-17 00:00:00	32020		\N	205163	0	10509002	260139		0
52161	3087	40481087	1984-11-07	1984-11-07 00:00:00	1984-11-21	1984-11-21 00:00:00	32020		\N	205516	0	444814009	40481087		0
41817	2487	4116491	1979-02-24	1979-02-24 00:00:00	1979-04-15	1979-04-15 00:00:00	32020		\N	164786	0	301011002	4116491		0
52602	3115	40481087	1998-11-29	1998-11-29 00:00:00	1998-12-20	1998-12-20 00:00:00	32020		\N	207258	0	444814009	40481087		0
52758	3125	78272	1953-06-17	1953-06-17 00:00:00	1953-07-08	1953-07-08 00:00:00	32020		\N	208003	0	70704007	78272		0
52916	3134	381316	2015-04-16	2015-04-16 00:00:00	\N	\N	32020		\N	208605	0	230690007	381316		0
53097	3144	4296204	1968-01-03	1968-01-03 00:00:00	1968-02-07	1968-02-07 00:00:00	32020		\N	209183	0	403190006	4296204		0
42552	2537	40481087	2010-12-29	2010-12-29 00:00:00	2011-01-12	2011-01-12 00:00:00	32020		\N	167625	0	444814009	40481087		0
42804	2550	4283893	1997-07-24	1997-07-24 00:00:00	1997-10-02	1997-10-02 00:00:00	32020		\N	168806	0	36971009	4283893		0
42912	2555	372328	1953-11-10	1953-11-10 00:00:00	1954-02-10	1954-02-10 00:00:00	32020		\N	169346	0	65363002	372328		0
43055	2564	260139	2002-09-24	2002-09-24 00:00:00	2002-10-08	2002-10-08 00:00:00	32020		\N	169836	0	10509002	260139		0
32636	1937	28060	1966-08-10	1966-08-10 00:00:00	1966-08-19	1966-08-19 00:00:00	32020		\N	128845	0	43878008	28060		0
43434	2588	4155034	1969-06-05	1969-06-05 00:00:00	1969-06-19	1969-06-19 00:00:00	32020		\N	171307	0	283371005	4155034		0
33012	1958	4112343	1987-12-22	1987-12-22 00:00:00	1987-12-31	1987-12-31 00:00:00	32020		\N	130272	0	195662009	4112343		0
43695	2602	80502	2009-03-25	2009-03-25 00:00:00	\N	\N	32020		\N	172092	0	64859006	80502		0
43843	2610	4027663	1983-06-30	1983-06-30 00:00:00	\N	\N	32020		\N	172628	0	13200003	4027663		0
44052	2620	260139	1989-01-31	1989-01-31 00:00:00	1989-02-14	1989-02-14 00:00:00	32020		\N	173253	0	10509002	260139		0
44167	2626	40481087	2002-02-02	2002-02-02 00:00:00	2002-02-23	2002-02-23 00:00:00	32020		\N	173715	0	444814009	40481087		0
44332	2636	4112343	2006-04-18	2006-04-18 00:00:00	2006-04-30	2006-04-30 00:00:00	32020		\N	174415	0	195662009	4112343		0
44570	2651	40481087	1962-02-04	1962-02-04 00:00:00	1962-02-25	1962-02-25 00:00:00	32020		\N	175442	0	444814009	40481087		0
44704	2659	260139	1988-03-15	1988-03-15 00:00:00	1988-03-22	1988-03-22 00:00:00	32020		\N	176152	0	10509002	260139		0
44886	2672	260139	1995-12-12	1995-12-12 00:00:00	1995-12-26	1995-12-26 00:00:00	32020		\N	176941	0	10509002	260139		0
45083	2682	4112343	1978-08-21	1978-08-21 00:00:00	1978-08-30	1978-08-30 00:00:00	32020		\N	177738	0	195662009	4112343		0
34654	2058	81893	1998-07-15	1998-07-15 00:00:00	\N	\N	32020		\N	136908	0	64766004	81893		0
45450	2702	372328	1946-10-18	1946-10-18 00:00:00	1947-10-05	1947-10-05 00:00:00	32020		\N	178974	0	65363002	372328		0
45542	2706	40481087	1964-11-08	1964-11-08 00:00:00	1964-11-22	1964-11-22 00:00:00	32020		\N	179308	0	444814009	40481087		0
45656	2712	80180	2000-08-08	2000-08-08 00:00:00	\N	\N	32020		\N	179817	0	396275006	80180		0
35352	2094	372328	1945-02-02	1945-02-02 00:00:00	1945-03-18	1945-03-18 00:00:00	32020		\N	139588	0	65363002	372328		0
46102	2747	81151	2007-02-27	2007-02-27 00:00:00	2007-03-13	2007-03-13 00:00:00	32020		\N	181720	0	44465007	81151		0
46191	2750	321042	2011-05-25	2011-05-25 00:00:00	\N	\N	32020		\N	181876	0	410429000	321042		0
46338	2760	40481087	1968-05-09	1968-05-09 00:00:00	1968-05-16	1968-05-16 00:00:00	32020		\N	182532	0	444814009	40481087		0
36000	2134	40481087	2007-09-20	2007-09-20 00:00:00	2007-10-04	2007-10-04 00:00:00	32020		\N	142018	0	444814009	40481087		0
46699	2778	28060	2017-09-07	2017-09-07 00:00:00	2017-09-15	2017-09-15 00:00:00	32020		\N	183997	0	43878008	28060		0
46835	2786	255848	2015-12-03	2015-12-03 00:00:00	\N	\N	32020		\N	184662	0	233604007	255848		0
47077	2801	4059173	1968-10-16	1968-10-16 00:00:00	1968-12-15	1968-12-15 00:00:00	32020		\N	185605	0	16114001	4059173		0
47183	2804	4112343	1997-08-14	1997-08-14 00:00:00	1997-08-21	1997-08-21 00:00:00	32020		\N	185826	0	195662009	4112343		0
47366	2818	4112343	2017-02-24	2017-02-24 00:00:00	2017-03-08	2017-03-08 00:00:00	32020		\N	186772	0	195662009	4112343		0
47509	2825	4112343	1938-10-15	1938-10-15 00:00:00	1938-10-24	1938-10-24 00:00:00	32020		\N	187282	0	195662009	4112343		0
37172	2202	260139	1997-12-24	1997-12-24 00:00:00	1997-12-31	1997-12-31 00:00:00	32020		\N	146774	0	10509002	260139		0
47823	2841	40481087	1961-11-08	1961-11-08 00:00:00	1961-11-15	1961-11-15 00:00:00	32020		\N	188587	0	444814009	40481087		0
48041	2849	40481087	1954-01-06	1954-01-06 00:00:00	1954-01-13	1954-01-13 00:00:00	32020		\N	189278	0	444814009	40481087		0
37663	2233	40481087	2015-03-15	2015-03-15 00:00:00	2015-03-29	2015-03-29 00:00:00	32020		\N	148576	0	444814009	40481087		0
37819	2240	4112343	1988-12-09	1988-12-09 00:00:00	1988-12-20	1988-12-20 00:00:00	32020		\N	149143	0	195662009	4112343		0
48569	2876	40481087	1983-11-22	1983-11-22 00:00:00	1983-11-29	1983-11-29 00:00:00	32020		\N	191326	0	444814009	40481087		0
48765	2889	378001	1997-07-04	1997-07-04 00:00:00	1997-08-03	1997-08-03 00:00:00	32020		\N	192146	0	62106007	378001		0
48839	2893	4112343	1978-04-27	1978-04-27 00:00:00	1978-05-08	1978-05-08 00:00:00	32020		\N	192500	0	195662009	4112343		0
49082	2905	4112343	2003-02-27	2003-02-27 00:00:00	2003-03-06	2003-03-06 00:00:00	32020		\N	193555	0	195662009	4112343		0
49267	2914	260139	1972-12-25	1972-12-25 00:00:00	1973-01-08	1973-01-08 00:00:00	32020		\N	194192	0	10509002	260139		0
49380	2919	260139	1981-01-14	1981-01-14 00:00:00	1981-01-21	1981-01-21 00:00:00	32020		\N	194602	0	10509002	260139		0
49510	2927	40481087	2009-05-08	2009-05-08 00:00:00	2009-05-29	2009-05-29 00:00:00	32020		\N	195276	0	444814009	40481087		0
49730	2942	4112343	2007-07-04	2007-07-04 00:00:00	2007-07-13	2007-07-13 00:00:00	32020		\N	196176	0	195662009	4112343		0
39300	2332	40481087	1963-07-02	1963-07-02 00:00:00	1963-07-09	1963-07-09 00:00:00	32020		\N	155047	0	444814009	40481087		0
50019	2955	260139	2015-05-19	2015-05-19 00:00:00	2015-06-02	2015-06-02 00:00:00	32020		\N	197226	0	10509002	260139		0
39636	2347	4112343	1974-06-06	1974-06-06 00:00:00	1974-06-15	1974-06-15 00:00:00	32020		\N	156274	0	195662009	4112343		0
50324	2976	80180	1995-09-26	1995-09-26 00:00:00	\N	\N	32020		\N	198773	0	396275006	80180		0
50507	2988	28060	1972-10-18	1972-10-18 00:00:00	1972-10-25	1972-10-25 00:00:00	32020		\N	199465	0	43878008	28060		0
50659	2997	195588	2001-09-29	2001-09-29 00:00:00	2001-11-18	2001-11-18 00:00:00	32020		\N	199940	0	38822007	195588		0
50805	3004	80180	1991-05-16	1991-05-16 00:00:00	\N	\N	32020		\N	200448	0	396275006	80180		0
40468	2404	4285898	2008-03-19	2008-03-19 00:00:00	\N	\N	32020		\N	159732	0	68496003	4285898		0
51234	3035	4266809	2004-09-30	2004-09-30 00:00:00	\N	\N	32020		\N	202208	0	397881000	4266809		0
51328	3044	4218389	1974-08-23	1974-08-23 00:00:00	1974-09-13	1974-09-13 00:00:00	32020		\N	202621	0	39848009	4218389		0
51490	3056	4112343	2000-03-28	2000-03-28 00:00:00	2000-04-08	2000-04-08 00:00:00	32020		\N	203254	0	195662009	4112343		0
51742	3067	4218389	1968-11-28	1968-11-28 00:00:00	1968-12-26	1968-12-26 00:00:00	32020		\N	204184	0	39848009	4218389		0
51859	3074	257012	1975-05-08	1975-05-08 00:00:00	\N	\N	32020		\N	204562	0	40055000	257012		0
52002	3081	4155034	2016-07-10	2016-07-10 00:00:00	2016-07-31	2016-07-31 00:00:00	32020		\N	205113	0	283371005	4155034		0
52162	3087	40481087	2004-11-07	2004-11-07 00:00:00	2004-11-28	2004-11-28 00:00:00	32020		\N	205519	0	444814009	40481087		0
41818	2487	140673	2010-02-16	2010-02-16 00:00:00	\N	\N	32020		\N	164764	0	40930008	140673		0
52603	3115	40481087	1988-12-07	1988-12-07 00:00:00	1988-12-14	1988-12-14 00:00:00	32020		\N	207257	0	444814009	40481087		0
52759	3125	81151	2014-08-28	2014-08-28 00:00:00	2014-09-25	2014-09-25 00:00:00	32020		\N	207931	0	44465007	81151		0
52917	3134	40481087	2015-04-14	2015-04-14 00:00:00	2015-04-28	2015-04-28 00:00:00	32020		\N	208605	0	444814009	40481087		0
53098	3144	372328	1967-11-25	1967-11-25 00:00:00	1968-05-08	1968-05-08 00:00:00	32020		\N	209238	0	65363002	372328		0
42553	2537	4112343	1953-05-20	1953-05-20 00:00:00	1953-05-29	1953-05-29 00:00:00	32020		\N	167710	0	195662009	4112343		0
42805	2550	4294548	2012-11-15	2012-11-15 00:00:00	2012-12-20	2012-12-20 00:00:00	32020		\N	168819	0	75498004	4294548		0
42913	2555	4112343	1976-05-02	1976-05-02 00:00:00	1976-05-09	1976-05-09 00:00:00	32020		\N	169318	0	195662009	4112343		0
43056	2564	4112343	1991-11-19	1991-11-19 00:00:00	1991-11-30	1991-11-30 00:00:00	32020		\N	169913	0	195662009	4112343		0
32637	1937	80180	2001-03-25	2001-03-25 00:00:00	\N	\N	32020		\N	128884	0	396275006	80180		0
43435	2588	260139	1967-03-06	1967-03-06 00:00:00	1967-03-13	1967-03-13 00:00:00	32020		\N	171285	0	10509002	260139		0
33013	1958	40481087	2013-01-29	2013-01-29 00:00:00	2013-02-12	2013-02-12 00:00:00	32020		\N	130260	0	444814009	40481087		0
43696	2602	4294548	1980-04-11	1980-04-11 00:00:00	1980-08-29	1980-08-29 00:00:00	32020		\N	172157	0	75498004	4294548		0
43844	2610	4112343	1967-01-27	1967-01-27 00:00:00	1967-02-05	1967-02-05 00:00:00	32020		\N	172538	0	195662009	4112343		0
44053	2620	4218389	1989-08-18	1989-08-18 00:00:00	1989-09-22	1989-09-22 00:00:00	32020		\N	173273	0	39848009	4218389		0
44168	2626	260139	1994-07-30	1994-07-30 00:00:00	1994-08-13	1994-08-13 00:00:00	32020		\N	173713	0	10509002	260139		0
44333	2636	4048171	1963-04-22	1963-04-22 00:00:00	1979-04-20	1979-04-20 00:00:00	32020		\N	174465	0	232353008	4048171		0
44571	2651	28060	2014-07-28	2014-07-28 00:00:00	2014-08-06	2014-08-06 00:00:00	32020		\N	175432	0	43878008	28060		0
44705	2659	40481087	1997-04-12	1997-04-12 00:00:00	1997-04-19	1997-04-19 00:00:00	32020		\N	176135	0	444814009	40481087		0
44887	2672	4112343	1986-08-01	1986-08-01 00:00:00	1986-08-09	1986-08-09 00:00:00	32020		\N	177038	0	195662009	4112343		0
45084	2682	40481087	2014-11-01	2014-11-01 00:00:00	2014-11-15	2014-11-15 00:00:00	32020		\N	177713	0	444814009	40481087		0
34655	2058	4310024	1998-04-16	1998-04-16 00:00:00	\N	\N	32020		\N	136908	0	424802006	4310024		0
45451	2702	372328	1944-02-16	1944-02-16 00:00:00	1944-03-19	1944-03-19 00:00:00	32020		\N	179009	0	65363002	372328		0
45543	2706	378001	1994-12-06	1994-12-06 00:00:00	1995-01-05	1995-01-05 00:00:00	32020		\N	179259	0	62106007	378001		0
45657	2712	81151	2018-03-11	2018-03-11 00:00:00	2018-04-08	2018-04-08 00:00:00	32020		\N	179886	0	44465007	81151		0
35353	2094	4266809	1985-08-16	1985-08-16 00:00:00	\N	\N	32020		\N	139585	0	397881000	4266809		0
46103	2747	4112343	2012-08-20	2012-08-20 00:00:00	2012-08-31	2012-08-31 00:00:00	32020		\N	181677	0	195662009	4112343		0
46206	2752	260139	1989-12-07	1989-12-07 00:00:00	1989-12-14	1989-12-14 00:00:00	32020		\N	182031	0	10509002	260139		0
46339	2760	40481087	1985-09-04	1985-09-04 00:00:00	1985-09-11	1985-09-11 00:00:00	32020		\N	182536	0	444814009	40481087		0
36001	2134	40481087	1967-03-16	1967-03-16 00:00:00	1967-03-23	1967-03-23 00:00:00	32020		\N	141987	0	444814009	40481087		0
46700	2778	40481087	1996-02-09	1996-02-09 00:00:00	1996-03-01	1996-03-01 00:00:00	32020		\N	183977	0	444814009	40481087		0
46836	2786	81151	2014-12-25	2014-12-25 00:00:00	2015-01-15	2015-01-15 00:00:00	32020		\N	184617	0	44465007	81151		0
47078	2801	4112343	1985-06-25	1985-06-25 00:00:00	1985-07-08	1985-07-08 00:00:00	32020		\N	185649	0	195662009	4112343		0
47184	2804	4112343	1982-01-05	1982-01-05 00:00:00	1982-01-18	1982-01-18 00:00:00	32020		\N	185813	0	195662009	4112343		0
47367	2818	4112343	2002-07-08	2002-07-08 00:00:00	2002-07-21	2002-07-21 00:00:00	32020		\N	186720	0	195662009	4112343		0
47510	2825	40481087	1968-11-27	1968-11-27 00:00:00	1968-12-11	1968-12-11 00:00:00	32020		\N	187338	0	444814009	40481087		0
37173	2202	4294548	1996-05-23	1996-05-23 00:00:00	1996-08-15	1996-08-15 00:00:00	32020		\N	146790	0	75498004	4294548		0
47825	2841	4329847	1984-10-21	1984-10-21 00:00:00	\N	\N	32020		\N	188634	0	22298006	4329847		0
48042	2849	4112343	2003-03-02	2003-03-02 00:00:00	2003-03-09	2003-03-09 00:00:00	32020		\N	189272	0	195662009	4112343		0
37664	2233	81151	1987-01-13	1987-01-13 00:00:00	1987-02-17	1987-02-17 00:00:00	32020		\N	148603	0	44465007	81151		0
37820	2240	4112343	2005-04-06	2005-04-06 00:00:00	2005-04-16	2005-04-16 00:00:00	32020		\N	149145	0	195662009	4112343		0
48570	2876	4112343	2012-08-24	2012-08-24 00:00:00	2012-09-06	2012-09-06 00:00:00	32020		\N	191360	0	195662009	4112343		0
48766	2889	4112343	2009-12-23	2009-12-23 00:00:00	2010-01-03	2010-01-03 00:00:00	32020		\N	192166	0	195662009	4112343		0
48840	2893	378001	1995-08-17	1995-08-17 00:00:00	1995-09-16	1995-09-16 00:00:00	32020		\N	192464	0	62106007	378001		0
49083	2905	4112343	2004-06-16	2004-06-16 00:00:00	2004-06-23	2004-06-23 00:00:00	32020		\N	193561	0	195662009	4112343		0
49268	2914	260139	1985-07-28	1985-07-28 00:00:00	1985-08-04	1985-08-04 00:00:00	32020		\N	194212	0	10509002	260139		0
49381	2919	440448	1965-08-17	1965-08-17 00:00:00	\N	\N	32020		\N	194611	0	74400008	440448		0
49511	2927	40481087	2000-12-20	2000-12-20 00:00:00	2000-12-27	2000-12-27 00:00:00	32020		\N	195213	0	444814009	40481087		0
49731	2942	4296204	1965-07-26	1965-07-26 00:00:00	1965-08-23	1965-08-23 00:00:00	32020		\N	196055	0	403190006	4296204		0
39301	2332	4296204	1987-01-04	1987-01-04 00:00:00	1987-01-25	1987-01-25 00:00:00	32020		\N	155125	0	403190006	4296204		0
50021	2955	321042	2017-07-25	2017-07-25 00:00:00	\N	\N	32020		\N	197252	0	410429000	321042		0
39637	2347	4112343	1975-03-13	1975-03-13 00:00:00	1975-03-24	1975-03-24 00:00:00	32020		\N	156278	0	195662009	4112343		0
50325	2976	372328	1958-01-08	1958-01-08 00:00:00	1958-05-29	1958-05-29 00:00:00	32020		\N	198753	0	65363002	372328		0
50508	2988	40481087	1991-08-13	1991-08-13 00:00:00	1991-08-27	1991-08-27 00:00:00	32020		\N	199441	0	444814009	40481087		0
50660	2997	40481087	2007-03-28	2007-03-28 00:00:00	2007-04-11	2007-04-11 00:00:00	32020		\N	199971	0	444814009	40481087		0
50806	3004	40481087	2005-10-03	2005-10-03 00:00:00	2005-10-17	2005-10-17 00:00:00	32020		\N	200468	0	444814009	40481087		0
40469	2404	80180	2008-04-18	2008-04-18 00:00:00	\N	\N	32020		\N	159732	0	396275006	80180		0
51235	3035	80180	2004-09-30	2004-09-30 00:00:00	\N	\N	32020		\N	202208	0	396275006	80180		0
51329	3044	4112343	1995-07-14	1995-07-14 00:00:00	1995-07-24	1995-07-24 00:00:00	32020		\N	202594	0	195662009	4112343		0
51491	3056	260139	1960-05-12	1960-05-12 00:00:00	1960-05-19	1960-05-19 00:00:00	32020		\N	203293	0	10509002	260139		0
51743	3067	260139	2018-07-13	2018-07-13 00:00:00	2018-07-20	2018-07-20 00:00:00	32020		\N	204104	0	10509002	260139		0
51860	3074	4112343	2002-06-02	2002-06-02 00:00:00	2002-06-09	2002-06-09 00:00:00	32020		\N	204581	0	195662009	4112343		0
52003	3081	4059173	1955-04-06	1955-04-06 00:00:00	1955-06-05	1955-06-05 00:00:00	32020		\N	205132	0	16114001	4059173		0
52163	3087	4296204	1958-08-13	1958-08-13 00:00:00	1958-09-03	1958-09-03 00:00:00	32020		\N	205554	0	403190006	4296204		0
41819	2487	260139	2007-12-27	2007-12-27 00:00:00	2008-01-03	2008-01-03 00:00:00	32020		\N	164804	0	10509002	260139		0
52604	3115	260139	2008-03-12	2008-03-12 00:00:00	2008-03-26	2008-03-26 00:00:00	32020		\N	207227	0	10509002	260139		0
52760	3125	40481087	1998-06-21	1998-06-21 00:00:00	1998-07-12	1998-07-12 00:00:00	32020		\N	207984	0	444814009	40481087		0
52918	3134	372328	1965-05-06	1965-05-06 00:00:00	1965-09-09	1965-09-09 00:00:00	32020		\N	208566	0	65363002	372328		0
53099	3144	80180	2007-05-03	2007-05-03 00:00:00	\N	\N	32020		\N	209237	0	396275006	80180		0
42554	2537	4112343	2003-04-21	2003-04-21 00:00:00	2003-05-01	2003-05-01 00:00:00	32020		\N	167672	0	195662009	4112343		0
42806	2550	80180	2019-06-26	2019-06-26 00:00:00	\N	\N	32020		\N	168793	0	396275006	80180		0
42914	2555	4112343	2009-09-21	2009-09-21 00:00:00	2009-10-03	2009-10-03 00:00:00	32020		\N	169325	0	195662009	4112343		0
43057	2564	4112343	2012-10-28	2012-10-28 00:00:00	2012-11-09	2012-11-09 00:00:00	32020		\N	169891	0	195662009	4112343		0
32638	1937	4283893	2006-05-21	2006-05-21 00:00:00	2006-07-30	2006-07-30 00:00:00	32020		\N	128878	0	36971009	4283893		0
43436	2588	40481087	1991-09-05	1991-09-05 00:00:00	1991-09-19	1991-09-19 00:00:00	32020		\N	171287	0	444814009	40481087		0
33014	1958	4112343	1995-04-24	1995-04-24 00:00:00	1995-05-05	1995-05-05 00:00:00	32020		\N	130258	0	195662009	4112343		0
43697	2602	260139	1972-10-17	1972-10-17 00:00:00	1972-10-24	1972-10-24 00:00:00	32020		\N	172107	0	10509002	260139		0
43845	2610	40481087	1971-04-30	1971-04-30 00:00:00	1971-05-14	1971-05-14 00:00:00	32020		\N	172583	0	444814009	40481087		0
44054	2620	4059173	1973-03-24	1973-03-24 00:00:00	1973-05-23	1973-05-23 00:00:00	32020		\N	173270	0	16114001	4059173		0
44169	2626	260139	1974-03-08	1974-03-08 00:00:00	1974-03-15	1974-03-15 00:00:00	32020		\N	173711	0	10509002	260139		0
44334	2636	260139	2011-11-11	2011-11-11 00:00:00	2011-11-18	2011-11-18 00:00:00	32020		\N	174468	0	10509002	260139		0
44572	2651	4278672	1956-04-03	1956-04-03 00:00:00	1956-07-02	1956-07-02 00:00:00	32020		\N	175417	0	65966004	4278672		0
44706	2659	40481087	1978-12-08	1978-12-08 00:00:00	1978-12-22	1978-12-22 00:00:00	32020		\N	176117	0	444814009	40481087		0
44888	2672	195588	1977-11-19	1977-11-19 00:00:00	1977-12-29	1977-12-29 00:00:00	32020		\N	177015	0	38822007	195588		0
45085	2682	260139	1977-03-06	1977-03-06 00:00:00	1977-03-13	1977-03-13 00:00:00	32020		\N	177737	0	10509002	260139		0
34656	2058	4266809	2000-08-03	2000-08-03 00:00:00	\N	\N	32020		\N	136808	0	397881000	4266809		0
45452	2702	4116491	1980-10-03	1980-10-03 00:00:00	1980-11-24	1980-11-24 00:00:00	32020		\N	178997	0	301011002	4116491		0
45548	2708	372328	1954-09-05	1954-09-05 00:00:00	1954-11-15	1954-11-15 00:00:00	32020		\N	179391	0	65363002	372328		0
45658	2712	40481087	1988-01-14	1988-01-14 00:00:00	1988-02-04	1988-02-04 00:00:00	32020		\N	179819	0	444814009	40481087		0
35354	2094	40481087	1985-06-05	1985-06-05 00:00:00	1985-06-19	1985-06-19 00:00:00	32020		\N	139585	0	444814009	40481087		0
46104	2747	260139	1974-03-05	1974-03-05 00:00:00	1974-03-19	1974-03-19 00:00:00	32020		\N	181714	0	10509002	260139		0
46207	2752	40481087	1983-04-24	1983-04-24 00:00:00	1983-05-01	1983-05-01 00:00:00	32020		\N	182030	0	444814009	40481087		0
46340	2760	40481087	1966-02-24	1966-02-24 00:00:00	1966-03-17	1966-03-17 00:00:00	32020		\N	182553	0	444814009	40481087		0
36002	2134	381316	2017-04-02	2017-04-02 00:00:00	\N	\N	32020		\N	141957	0	230690007	381316		0
46701	2778	81151	1986-10-01	1986-10-01 00:00:00	1986-10-22	1986-10-22 00:00:00	32020		\N	184025	0	44465007	81151		0
46837	2786	4112343	1961-08-07	1961-08-07 00:00:00	1961-08-18	1961-08-18 00:00:00	32020		\N	184602	0	195662009	4112343		0
47079	2801	4294548	1923-06-17	1923-06-17 00:00:00	1923-06-24	1923-06-24 00:00:00	32020		\N	185637	0	75498004	4294548		0
47189	2806	40481087	1975-11-18	1975-11-18 00:00:00	1975-12-09	1975-12-09 00:00:00	32020		\N	185988	0	444814009	40481087		0
47368	2818	260139	1978-08-04	1978-08-04 00:00:00	1978-08-11	1978-08-11 00:00:00	32020		\N	186745	0	10509002	260139		0
47511	2825	4109685	1975-09-08	1975-09-08 00:00:00	1975-09-22	1975-09-22 00:00:00	32020		\N	187331	0	284551006	4109685		0
37174	2202	40481087	1978-06-06	1978-06-06 00:00:00	1978-06-20	1978-06-20 00:00:00	32020		\N	146788	0	444814009	40481087		0
47826	2841	4296205	1950-04-22	1950-04-22 00:00:00	1950-05-20	1950-05-20 00:00:00	32020		\N	188631	0	403191005	4296205		0
48043	2849	40481087	1976-01-23	1976-01-23 00:00:00	1976-02-13	1976-02-13 00:00:00	32020		\N	189280	0	444814009	40481087		0
37665	2233	40481087	1973-11-30	1973-11-30 00:00:00	1973-12-07	1973-12-07 00:00:00	32020		\N	148581	0	444814009	40481087		0
37821	2240	40481087	1965-09-03	1965-09-03 00:00:00	1965-09-17	1965-09-17 00:00:00	32020		\N	149140	0	444814009	40481087		0
48571	2876	4112343	1971-03-03	1971-03-03 00:00:00	1971-03-10	1971-03-10 00:00:00	32020		\N	191340	0	195662009	4112343		0
48767	2890	260139	1991-07-13	1991-07-13 00:00:00	1991-07-27	1991-07-27 00:00:00	32020		\N	192222	0	10509002	260139		0
48841	2893	40481087	2005-10-21	2005-10-21 00:00:00	2005-11-11	2005-11-11 00:00:00	32020		\N	192460	0	444814009	40481087		0
49084	2905	40481087	2004-07-21	2004-07-21 00:00:00	2004-07-28	2004-07-28 00:00:00	32020		\N	193562	0	444814009	40481087		0
49269	2914	372328	1959-09-01	1959-09-01 00:00:00	1960-09-10	1960-09-10 00:00:00	32020		\N	194174	0	65363002	372328		0
49382	2919	260139	2007-11-03	2007-11-03 00:00:00	2007-11-10	2007-11-10 00:00:00	32020		\N	194590	0	10509002	260139		0
49512	2927	260139	1945-04-10	1945-04-10 00:00:00	1945-04-24	1945-04-24 00:00:00	32020		\N	195275	0	10509002	260139		0
49732	2942	372328	1957-09-20	1957-09-20 00:00:00	1958-07-09	1958-07-09 00:00:00	32020		\N	196191	0	65363002	372328		0
39302	2332	40481087	1963-04-11	1963-04-11 00:00:00	1963-04-25	1963-04-25 00:00:00	32020		\N	155081	0	444814009	40481087		0
50022	2955	4112343	2005-02-01	2005-02-01 00:00:00	2005-02-13	2005-02-13 00:00:00	32020		\N	197263	0	195662009	4112343		0
39638	2347	81151	1980-03-04	1980-03-04 00:00:00	1980-03-18	1980-03-18 00:00:00	32020		\N	156222	0	44465007	81151		0
50326	2976	260139	1966-08-26	1966-08-26 00:00:00	1966-09-09	1966-09-09 00:00:00	32020		\N	198704	0	10509002	260139		0
50509	2988	4112343	2003-02-07	2003-02-07 00:00:00	2003-02-15	2003-02-15 00:00:00	32020		\N	199493	0	195662009	4112343		0
50661	2997	4149245	2004-12-16	2004-12-16 00:00:00	2005-01-22	2005-01-22 00:00:00	32020		\N	199962	0	30832001	4149245		0
50807	3004	260139	2008-07-17	2008-07-17 00:00:00	2008-07-31	2008-07-31 00:00:00	32020		\N	200502	0	10509002	260139		0
40470	2404	40481087	2017-08-02	2017-08-02 00:00:00	2017-08-16	2017-08-16 00:00:00	32020		\N	159774	0	444814009	40481087		0
51236	3035	28060	2007-11-08	2007-11-08 00:00:00	2007-11-15	2007-11-15 00:00:00	32020		\N	202183	0	43878008	28060		0
51330	3044	28060	1977-10-21	1977-10-21 00:00:00	1977-11-03	1977-11-03 00:00:00	32020		\N	202604	0	43878008	28060		0
51492	3056	28060	1964-02-22	1964-02-22 00:00:00	1964-03-02	1964-03-02 00:00:00	32020		\N	203238	0	43878008	28060		0
51744	3067	439777	1969-12-11	1969-12-11 00:00:00	\N	\N	32020		\N	204102	0	271737000	439777		0
51861	3074	4112343	1981-06-25	1981-06-25 00:00:00	1981-07-02	1981-07-02 00:00:00	32020		\N	204599	0	195662009	4112343		0
52004	3081	40481087	1971-06-14	1971-06-14 00:00:00	1971-06-28	1971-06-28 00:00:00	32020		\N	205116	0	444814009	40481087		0
52164	3088	4112343	1998-05-30	1998-05-30 00:00:00	1998-06-10	1998-06-10 00:00:00	32020		\N	205684	0	195662009	4112343		0
41820	2487	40481087	1978-02-19	1978-02-19 00:00:00	1978-03-12	1978-03-12 00:00:00	32020		\N	164789	0	444814009	40481087		0
52605	3115	80180	2006-04-30	2006-04-30 00:00:00	\N	\N	32020		\N	207259	0	396275006	80180		0
52761	3125	4112343	1968-05-07	1968-05-07 00:00:00	1968-05-16	1968-05-16 00:00:00	32020		\N	207926	0	195662009	4112343		0
52919	3134	4112343	2006-11-12	2006-11-12 00:00:00	2006-11-25	2006-11-25 00:00:00	32020		\N	208604	0	195662009	4112343		0
53100	3145	372328	1975-04-06	1975-04-06 00:00:00	1975-08-10	1975-08-10 00:00:00	32020		\N	209270	0	65363002	372328		0
42556	2537	4029498	1960-08-13	1960-08-13 00:00:00	\N	\N	32020		\N	167646	0	128613002	4029498		0
42807	2550	40481087	1986-06-07	1986-06-07 00:00:00	1986-06-21	1986-06-21 00:00:00	32020		\N	168788	0	444814009	40481087		0
42915	2555	4112343	1978-06-02	1978-06-02 00:00:00	1978-06-09	1978-06-09 00:00:00	32020		\N	169322	0	195662009	4112343		0
43058	2564	260139	1993-08-23	1993-08-23 00:00:00	1993-09-06	1993-09-06 00:00:00	32020		\N	169851	0	10509002	260139		0
32639	1937	4134304	1968-10-14	1968-10-14 00:00:00	1968-11-13	1968-11-13 00:00:00	32020		\N	128903	0	263102004	4134304		0
43437	2588	372328	2008-06-10	2008-06-10 00:00:00	2008-09-14	2008-09-14 00:00:00	32020		\N	171289	0	65363002	372328		0
33015	1958	28060	1981-05-19	1981-05-19 00:00:00	1981-05-26	1981-05-26 00:00:00	32020		\N	130255	0	43878008	28060		0
43698	2602	257012	1980-05-09	1980-05-09 00:00:00	\N	\N	32020		\N	172073	0	40055000	257012		0
43846	2610	4283893	1978-11-07	1978-11-07 00:00:00	1980-01-22	1980-01-22 00:00:00	32020		\N	172539	0	36971009	4283893		0
44055	2620	4218389	2005-03-07	2005-03-07 00:00:00	2005-04-11	2005-04-11 00:00:00	32020		\N	173256	0	39848009	4218389		0
44170	2626	40481087	1986-07-03	1986-07-03 00:00:00	1986-07-10	1986-07-10 00:00:00	32020		\N	173731	0	444814009	40481087		0
44335	2636	260139	2015-12-12	2015-12-12 00:00:00	2015-12-19	2015-12-19 00:00:00	32020		\N	174416	0	10509002	260139		0
44573	2651	372328	1951-05-25	1951-05-25 00:00:00	1952-05-14	1952-05-14 00:00:00	32020		\N	175447	0	65363002	372328		0
44707	2659	4109685	2015-03-12	2015-03-12 00:00:00	2015-04-02	2015-04-02 00:00:00	32020		\N	176148	0	284551006	4109685		0
44889	2672	4109685	1972-02-18	1972-02-18 00:00:00	1972-03-10	1972-03-10 00:00:00	32020		\N	176981	0	284551006	4109685		0
45086	2682	4112343	2009-02-17	2009-02-17 00:00:00	2009-02-24	2009-02-24 00:00:00	32020		\N	177758	0	195662009	4112343		0
34657	2058	80180	2000-08-03	2000-08-03 00:00:00	\N	\N	32020		\N	136808	0	396275006	80180		0
45453	2702	40481087	1941-12-12	1941-12-12 00:00:00	1942-01-02	1942-01-02 00:00:00	32020		\N	178961	0	444814009	40481087		0
45549	2708	40481087	2009-11-21	2009-11-21 00:00:00	2009-12-05	2009-12-05 00:00:00	32020		\N	179390	0	444814009	40481087		0
45659	2712	372328	1966-04-01	1966-04-01 00:00:00	1966-06-07	1966-06-07 00:00:00	32020		\N	179859	0	65363002	372328		0
35355	2094	80180	1985-08-16	1985-08-16 00:00:00	\N	\N	32020		\N	139585	0	396275006	80180		0
46105	2747	4112343	2008-05-01	2008-05-01 00:00:00	2008-05-09	2008-05-09 00:00:00	32020		\N	181707	0	195662009	4112343		0
46208	2752	4112343	1955-11-23	1955-11-23 00:00:00	1955-12-05	1955-12-05 00:00:00	32020		\N	182109	0	195662009	4112343		0
46341	2760	40481087	1974-01-23	1974-01-23 00:00:00	1974-02-13	1974-02-13 00:00:00	32020		\N	182534	0	444814009	40481087		0
36003	2134	260139	2013-11-14	2013-11-14 00:00:00	2013-11-21	2013-11-21 00:00:00	32020		\N	141981	0	10509002	260139		0
46702	2779	40481087	1998-07-24	1998-07-24 00:00:00	1998-08-07	1998-08-07 00:00:00	32020		\N	184156	0	444814009	40481087		0
46838	2786	80502	1993-08-21	1993-08-21 00:00:00	\N	\N	32020		\N	184659	0	64859006	80502		0
47080	2801	78272	1925-02-01	1925-02-01 00:00:00	1925-03-08	1925-03-08 00:00:00	32020		\N	185602	0	70704007	78272		0
47190	2806	40479422	1983-03-06	1983-03-06 00:00:00	1983-05-12	1983-05-12 00:00:00	32020		\N	185961	0	444448004	40479422		0
47369	2818	372328	1970-02-21	1970-02-21 00:00:00	1970-05-11	1970-05-11 00:00:00	32020		\N	186723	0	65363002	372328		0
47512	2825	40481087	1925-11-30	1925-11-30 00:00:00	1925-12-07	1925-12-07 00:00:00	32020		\N	187268	0	444814009	40481087		0
37175	2202	40481087	1999-11-03	1999-11-03 00:00:00	1999-11-10	1999-11-10 00:00:00	32020		\N	146781	0	444814009	40481087		0
47827	2841	80180	1990-11-03	1990-11-03 00:00:00	\N	\N	32020		\N	188595	0	396275006	80180		0
48044	2849	260139	1933-01-13	1933-01-13 00:00:00	1933-01-20	1933-01-20 00:00:00	32020		\N	189276	0	10509002	260139		0
37666	2233	260139	1986-01-03	1986-01-03 00:00:00	1986-01-10	1986-01-10 00:00:00	32020		\N	148585	0	10509002	260139		0
37828	2242	260139	2001-08-02	2001-08-02 00:00:00	2001-08-09	2001-08-09 00:00:00	32020		\N	149236	0	10509002	260139		0
48572	2876	4152936	2016-05-25	2016-05-25 00:00:00	2016-06-15	2016-06-15 00:00:00	32020		\N	191394	0	283385000	4152936		0
48768	2890	40481087	2011-03-26	2011-03-26 00:00:00	2011-04-09	2011-04-09 00:00:00	32020		\N	192200	0	444814009	40481087		0
48842	2893	4283893	1975-01-03	1975-01-03 00:00:00	1975-03-14	1975-03-14 00:00:00	32020		\N	192531	0	36971009	4283893		0
49085	2905	260139	2012-12-03	2012-12-03 00:00:00	2012-12-10	2012-12-10 00:00:00	32020		\N	193601	0	10509002	260139		0
49270	2914	260139	2008-06-05	2008-06-05 00:00:00	2008-06-19	2008-06-19 00:00:00	32020		\N	194214	0	10509002	260139		0
49383	2919	4112343	1951-04-28	1951-04-28 00:00:00	1951-05-09	1951-05-09 00:00:00	32020		\N	194583	0	195662009	4112343		0
49513	2927	260139	2004-07-05	2004-07-05 00:00:00	2004-07-19	2004-07-19 00:00:00	32020		\N	195206	0	10509002	260139		0
49733	2942	40481087	2014-03-07	2014-03-07 00:00:00	2014-03-14	2014-03-14 00:00:00	32020		\N	196224	0	444814009	40481087		0
39303	2332	260139	1975-12-31	1975-12-31 00:00:00	1976-01-07	1976-01-07 00:00:00	32020		\N	155063	0	10509002	260139		0
50023	2955	28060	2012-07-10	2012-07-10 00:00:00	2012-07-19	2012-07-19 00:00:00	32020		\N	197208	0	43878008	28060		0
39639	2347	40481087	1989-04-21	1989-04-21 00:00:00	1989-05-05	1989-05-05 00:00:00	32020		\N	156275	0	444814009	40481087		0
50327	2976	261325	1979-07-05	1979-07-05 00:00:00	\N	\N	32020		\N	198729	0	87433001	261325		0
50510	2988	81151	2003-01-18	2003-01-18 00:00:00	2003-02-01	2003-02-01 00:00:00	32020		\N	199428	0	44465007	81151		0
50686	3000	40481087	2004-04-24	2004-04-24 00:00:00	2004-05-01	2004-05-01 00:00:00	32020		\N	200143	0	444814009	40481087		0
50820	3007	28060	1967-11-20	1967-11-20 00:00:00	1967-12-01	1967-12-01 00:00:00	32020		\N	200629	0	43878008	28060		0
40471	2404	4109685	1998-08-10	1998-08-10 00:00:00	1998-08-31	1998-08-31 00:00:00	32020		\N	159763	0	284551006	4109685		0
51237	3035	40481087	1968-02-04	1968-02-04 00:00:00	1968-02-11	1968-02-11 00:00:00	32020		\N	202185	0	444814009	40481087		0
51331	3044	4112343	1991-06-26	1991-06-26 00:00:00	1991-07-04	1991-07-04 00:00:00	32020		\N	202626	0	195662009	4112343		0
51493	3056	372328	1962-11-16	1962-11-16 00:00:00	1962-12-14	1962-12-14 00:00:00	32020		\N	203261	0	65363002	372328		0
51745	3067	4155034	2009-12-26	2009-12-26 00:00:00	2010-01-09	2010-01-09 00:00:00	32020		\N	204187	0	283371005	4155034		0
51862	3074	4218389	2005-09-30	2005-09-30 00:00:00	2005-10-21	2005-10-21 00:00:00	32020		\N	204574	0	39848009	4218389		0
52005	3081	260139	1969-09-20	1969-09-20 00:00:00	1969-09-27	1969-09-27 00:00:00	32020		\N	205157	0	10509002	260139		0
52165	3088	4218389	1978-10-21	1978-10-21 00:00:00	1978-11-18	1978-11-18 00:00:00	32020		\N	205638	0	39848009	4218389		0
41821	2487	4112343	1966-03-16	1966-03-16 00:00:00	1966-03-29	1966-03-29 00:00:00	32020		\N	164812	0	195662009	4112343		0
52606	3115	4116491	2006-01-10	2006-01-10 00:00:00	2006-03-03	2006-03-03 00:00:00	32020		\N	207259	0	301011002	4116491		0
52762	3125	40481087	1959-10-23	1959-10-23 00:00:00	1959-10-30	1959-10-30 00:00:00	32020		\N	207932	0	444814009	40481087		0
52920	3134	40481087	2002-07-05	2002-07-05 00:00:00	2002-07-26	2002-07-26 00:00:00	32020		\N	208564	0	444814009	40481087		0
53101	3145	260139	2005-05-08	2005-05-08 00:00:00	2005-05-15	2005-05-15 00:00:00	32020		\N	209287	0	10509002	260139		0
42557	2537	4296204	1991-03-11	1991-03-11 00:00:00	1991-04-01	1991-04-01 00:00:00	32020		\N	167706	0	403190006	4296204		0
42808	2550	40481087	1993-07-11	1993-07-11 00:00:00	1993-07-25	1993-07-25 00:00:00	32020		\N	168833	0	444814009	40481087		0
42916	2555	4112343	1985-10-30	1985-10-30 00:00:00	1985-11-08	1985-11-08 00:00:00	32020		\N	169339	0	195662009	4112343		0
43059	2564	80180	2018-12-24	2018-12-24 00:00:00	\N	\N	32020		\N	169872	0	396275006	80180		0
32640	1937	195588	2009-06-15	2009-06-15 00:00:00	2009-07-19	2009-07-19 00:00:00	32020		\N	128908	0	38822007	195588		0
43438	2588	4059173	1978-06-07	1978-06-07 00:00:00	1978-09-05	1978-09-05 00:00:00	32020		\N	171309	0	16114001	4059173		0
33016	1958	81151	2003-09-12	2003-09-12 00:00:00	2003-10-17	2003-10-17 00:00:00	32020		\N	130244	0	44465007	81151		0
43699	2602	378001	1963-02-04	1963-02-04 00:00:00	1963-03-06	1963-03-06 00:00:00	32020		\N	172144	0	62106007	378001		0
43847	2611	4112343	1985-05-03	1985-05-03 00:00:00	1985-05-13	1985-05-13 00:00:00	32020		\N	172702	0	195662009	4112343		0
44056	2621	4294548	2009-03-20	2009-03-20 00:00:00	2009-04-03	2009-04-03 00:00:00	32020		\N	173321	0	75498004	4294548		0
44171	2626	40481087	1992-11-11	1992-11-11 00:00:00	1992-12-02	1992-12-02 00:00:00	32020		\N	173732	0	444814009	40481087		0
44336	2636	4112343	2001-08-01	2001-08-01 00:00:00	2001-08-08	2001-08-08 00:00:00	32020		\N	174423	0	195662009	4112343		0
44574	2651	40481087	1966-11-10	1966-11-10 00:00:00	1966-11-24	1966-11-24 00:00:00	32020		\N	175378	0	444814009	40481087		0
44708	2659	4152936	1978-08-02	1978-08-02 00:00:00	1978-08-23	1978-08-23 00:00:00	32020		\N	176146	0	283385000	4152936		0
44890	2672	40481087	2002-09-22	2002-09-22 00:00:00	2002-10-06	2002-10-06 00:00:00	32020		\N	176890	0	444814009	40481087		0
45087	2682	81151	1989-09-24	1989-09-24 00:00:00	1989-10-29	1989-10-29 00:00:00	32020		\N	177725	0	44465007	81151		0
34658	2058	40481087	1999-11-05	1999-11-05 00:00:00	1999-11-12	1999-11-12 00:00:00	32020		\N	136808	0	444814009	40481087		0
45454	2702	260139	1992-11-09	1992-11-09 00:00:00	1992-11-23	1992-11-23 00:00:00	32020		\N	178973	0	10509002	260139		0
45550	2708	260139	1965-09-29	1965-09-29 00:00:00	1965-10-06	1965-10-06 00:00:00	32020		\N	179360	0	10509002	260139		0
45660	2712	40479422	1998-11-23	1998-11-23 00:00:00	1998-12-30	1998-12-30 00:00:00	32020		\N	179884	0	444448004	40479422		0
35356	2094	28060	1950-08-08	1950-08-08 00:00:00	1950-08-21	1950-08-21 00:00:00	32020		\N	139601	0	43878008	28060		0
46106	2747	40481087	2009-05-08	2009-05-08 00:00:00	2009-05-29	2009-05-29 00:00:00	32020		\N	181708	0	444814009	40481087		0
46209	2752	4112343	1998-04-21	1998-04-21 00:00:00	1998-04-30	1998-04-30 00:00:00	32020		\N	182062	0	195662009	4112343		0
46342	2760	40481087	1967-12-13	1967-12-13 00:00:00	1968-01-03	1968-01-03 00:00:00	32020		\N	182531	0	444814009	40481087		0
36004	2134	40481087	1980-11-10	1980-11-10 00:00:00	1980-11-24	1980-11-24 00:00:00	32020		\N	141945	0	444814009	40481087		0
46703	2779	372328	1976-03-18	1976-03-18 00:00:00	1976-10-31	1976-10-31 00:00:00	32020		\N	184203	0	65363002	372328		0
46839	2786	40481087	1985-03-11	1985-03-11 00:00:00	1985-03-25	1985-03-25 00:00:00	32020		\N	184562	0	444814009	40481087		0
47081	2801	4112343	1983-04-26	1983-04-26 00:00:00	1983-05-05	1983-05-05 00:00:00	32020		\N	185596	0	195662009	4112343		0
47191	2806	40481087	2001-09-11	2001-09-11 00:00:00	2001-09-25	2001-09-25 00:00:00	32020		\N	185948	0	444814009	40481087		0
47370	2818	4155034	1985-07-12	1985-07-12 00:00:00	1985-07-26	1985-07-26 00:00:00	32020		\N	186729	0	283371005	4155034		0
47525	2827	4230399	1987-05-28	1987-05-28 00:00:00	1987-08-26	1987-08-26 00:00:00	32020		\N	187513	0	359817006	4230399		0
37176	2202	40481087	1993-09-24	1993-09-24 00:00:00	1993-10-01	1993-10-01 00:00:00	32020		\N	146773	0	444814009	40481087		0
47828	2841	317576	1983-09-11	1983-09-11 00:00:00	\N	\N	32020		\N	188599	0	53741008	317576		0
48076	2853	4059173	1962-08-26	1962-08-26 00:00:00	1962-09-25	1962-09-25 00:00:00	32020		\N	189542	0	16114001	4059173		0
37667	2233	4116491	1998-01-25	1998-01-25 00:00:00	1998-03-10	1998-03-10 00:00:00	32020		\N	148586	0	301011002	4116491		0
37829	2242	40481087	1962-04-28	1962-04-28 00:00:00	1962-05-19	1962-05-19 00:00:00	32020		\N	149209	0	444814009	40481087		0
48573	2876	4155034	1967-05-22	1967-05-22 00:00:00	1967-06-12	1967-06-12 00:00:00	32020		\N	191392	0	283371005	4155034		0
48769	2890	260139	2013-08-12	2013-08-12 00:00:00	2013-08-19	2013-08-19 00:00:00	32020		\N	192202	0	10509002	260139		0
48843	2893	257012	1975-01-17	1975-01-17 00:00:00	\N	\N	32020		\N	192541	0	40055000	257012		0
51054	3023	80180	2018-02-02	2018-02-02 00:00:00	\N	\N	32020		\N	201513	0	396275006	80180		0
49086	2905	260139	2015-05-31	2015-05-31 00:00:00	2015-06-14	2015-06-14 00:00:00	32020		\N	193602	0	10509002	260139		0
49271	2914	260139	1977-12-19	1977-12-19 00:00:00	1977-12-26	1977-12-26 00:00:00	32020		\N	194173	0	10509002	260139		0
49384	2919	381316	1996-06-15	1996-06-15 00:00:00	\N	\N	32020		\N	194646	0	230690007	381316		0
49514	2927	260139	1990-12-31	1990-12-31 00:00:00	1991-01-14	1991-01-14 00:00:00	32020		\N	195203	0	10509002	260139		0
49734	2942	313217	2016-09-28	2016-09-28 00:00:00	\N	\N	32020		\N	196074	0	49436004	313217		0
39304	2332	4294548	1958-05-20	1958-05-20 00:00:00	1958-06-10	1958-06-10 00:00:00	32020		\N	155101	0	75498004	4294548		0
50024	2955	260139	1998-01-10	1998-01-10 00:00:00	1998-01-17	1998-01-17 00:00:00	32020		\N	197207	0	10509002	260139		0
39640	2347	317576	2002-02-25	2002-02-25 00:00:00	\N	\N	32020		\N	156246	0	53741008	317576		0
50328	2976	4112343	1957-01-31	1957-01-31 00:00:00	1957-02-09	1957-02-09 00:00:00	32020		\N	198745	0	195662009	4112343		0
50511	2988	372328	1965-10-22	1965-10-22 00:00:00	1965-11-14	1965-11-14 00:00:00	32020		\N	199473	0	65363002	372328		0
50687	3000	4027663	1974-04-10	1974-04-10 00:00:00	\N	\N	32020		\N	200210	0	13200003	4027663		0
50821	3007	440448	1998-05-18	1998-05-18 00:00:00	\N	\N	32020		\N	200602	0	74400008	440448		0
40472	2404	4027663	1998-11-27	1998-11-27 00:00:00	\N	\N	32020		\N	159763	0	13200003	4027663		0
51238	3035	260139	2017-02-26	2017-02-26 00:00:00	2017-03-05	2017-03-05 00:00:00	32020		\N	202213	0	10509002	260139		0
51332	3044	40481087	1974-06-30	1974-06-30 00:00:00	1974-07-14	1974-07-14 00:00:00	32020		\N	202641	0	444814009	40481087		0
51494	3056	4112343	1977-09-01	1977-09-01 00:00:00	1977-09-14	1977-09-14 00:00:00	32020		\N	203288	0	195662009	4112343		0
51746	3067	260139	1971-07-21	1971-07-21 00:00:00	1971-08-04	1971-08-04 00:00:00	32020		\N	204153	0	10509002	260139		0
51863	3074	4112343	2001-11-18	2001-11-18 00:00:00	2001-11-30	2001-11-30 00:00:00	32020		\N	204580	0	195662009	4112343		0
52006	3081	260139	2005-10-30	2005-10-30 00:00:00	2005-11-06	2005-11-06 00:00:00	32020		\N	205122	0	10509002	260139		0
52166	3088	80180	1980-08-21	1980-08-21 00:00:00	\N	\N	32020		\N	205618	0	396275006	80180		0
41822	2487	260139	1965-06-24	1965-06-24 00:00:00	1965-07-01	1965-07-01 00:00:00	32020		\N	164788	0	10509002	260139		0
52607	3115	260139	1973-04-27	1973-04-27 00:00:00	1973-05-04	1973-05-04 00:00:00	32020		\N	207254	0	10509002	260139		0
52763	3125	4294548	1975-12-05	1975-12-05 00:00:00	1976-01-02	1976-01-02 00:00:00	32020		\N	207936	0	75498004	4294548		0
52921	3134	260139	1977-08-22	1977-08-22 00:00:00	1977-08-29	1977-08-29 00:00:00	32020		\N	208628	0	10509002	260139		0
53102	3145	440086	1980-08-27	1980-08-27 00:00:00	1980-11-05	1980-11-05 00:00:00	32020		\N	209290	0	192127007	440086		0
42558	2537	4112343	1958-01-15	1958-01-15 00:00:00	1958-01-22	1958-01-22 00:00:00	32020		\N	167754	0	195662009	4112343		0
42809	2550	40481087	2000-09-22	2000-09-22 00:00:00	2000-10-13	2000-10-13 00:00:00	32020		\N	168818	0	444814009	40481087		0
42917	2555	80180	1990-11-13	1990-11-13 00:00:00	\N	\N	32020		\N	169278	0	396275006	80180		0
43060	2564	4142905	1986-06-05	1986-06-05 00:00:00	1986-07-05	1986-07-05 00:00:00	32020		\N	169906	0	33737001	4142905		0
32641	1937	4112343	1965-03-06	1965-03-06 00:00:00	1965-03-15	1965-03-15 00:00:00	32020		\N	128871	0	195662009	4112343		0
43439	2588	80180	2002-04-03	2002-04-03 00:00:00	\N	\N	32020		\N	171279	0	396275006	80180		0
33021	1960	40481087	1937-06-06	1937-06-06 00:00:00	1937-06-27	1937-06-27 00:00:00	32020		\N	130334	0	444814009	40481087		0
43700	2602	40481087	1991-05-01	1991-05-01 00:00:00	1991-05-08	1991-05-08 00:00:00	32020		\N	172109	0	444814009	40481087		0
43848	2611	4112343	2009-08-06	2009-08-06 00:00:00	2009-08-14	2009-08-14 00:00:00	32020		\N	172631	0	195662009	4112343		0
44057	2621	4285898	1994-04-03	1994-04-03 00:00:00	\N	\N	32020		\N	173334	0	68496003	4285898		0
44172	2626	4059173	1991-08-04	1991-08-04 00:00:00	1991-09-03	1991-09-03 00:00:00	32020		\N	173743	0	16114001	4059173		0
44337	2636	40481087	1997-05-03	1997-05-03 00:00:00	1997-05-17	1997-05-17 00:00:00	32020		\N	174467	0	444814009	40481087		0
44575	2651	4218389	1977-07-24	1977-07-24 00:00:00	1977-08-21	1977-08-21 00:00:00	32020		\N	175421	0	39848009	4218389		0
44722	2661	4112343	2007-10-29	2007-10-29 00:00:00	2007-11-09	2007-11-09 00:00:00	32020		\N	176355	0	195662009	4112343		0
44891	2672	28060	2005-06-02	2005-06-02 00:00:00	2005-06-10	2005-06-10 00:00:00	32020		\N	176925	0	43878008	28060		0
45088	2682	260139	2017-12-04	2017-12-04 00:00:00	2017-12-11	2017-12-11 00:00:00	32020		\N	177754	0	10509002	260139		0
34659	2058	381316	2017-11-15	2017-11-15 00:00:00	\N	\N	32020		\N	136827	0	230690007	381316		0
45455	2702	28060	2007-10-10	2007-10-10 00:00:00	2007-10-20	2007-10-20 00:00:00	32020		\N	178938	0	43878008	28060		0
45551	2708	4112343	1990-05-02	1990-05-02 00:00:00	1990-05-13	1990-05-13 00:00:00	32020		\N	179353	0	195662009	4112343		0
45661	2712	260139	1980-07-01	1980-07-01 00:00:00	1980-07-08	1980-07-08 00:00:00	32020		\N	179826	0	10509002	260139		0
35357	2094	81151	2014-08-04	2014-08-04 00:00:00	2014-08-18	2014-08-18 00:00:00	32020		\N	139575	0	44465007	81151		0
46107	2747	440086	1983-06-09	1983-06-09 00:00:00	1983-11-10	1983-11-10 00:00:00	32020		\N	181716	0	192127007	440086		0
46210	2752	4155034	1954-04-01	1954-04-01 00:00:00	1954-04-15	1954-04-15 00:00:00	32020		\N	182113	0	283371005	4155034		0
46343	2760	378001	2015-06-18	2015-06-18 00:00:00	2015-07-18	2015-07-18 00:00:00	32020		\N	182589	0	62106007	378001		0
36005	2134	40481087	1967-07-29	1967-07-29 00:00:00	1967-08-12	1967-08-12 00:00:00	32020		\N	141988	0	444814009	40481087		0
46704	2779	4112343	1996-12-02	1996-12-02 00:00:00	1996-12-11	1996-12-11 00:00:00	32020		\N	184164	0	195662009	4112343		0
46840	2786	81151	1956-01-19	1956-01-19 00:00:00	1956-02-09	1956-02-09 00:00:00	32020		\N	184609	0	44465007	81151		0
47082	2801	260139	1959-04-13	1959-04-13 00:00:00	1959-04-20	1959-04-20 00:00:00	32020		\N	185655	0	10509002	260139		0
47192	2806	257012	1989-01-29	1989-01-29 00:00:00	\N	\N	32020		\N	185976	0	40055000	257012		0
47371	2818	4112343	1980-01-15	1980-01-15 00:00:00	1980-01-24	1980-01-24 00:00:00	32020		\N	186754	0	195662009	4112343		0
47526	2827	4112343	1978-02-14	1978-02-14 00:00:00	1978-02-23	1978-02-23 00:00:00	32020		\N	187447	0	195662009	4112343		0
37177	2202	4112343	1978-02-20	1978-02-20 00:00:00	1978-03-01	1978-03-01 00:00:00	32020		\N	146787	0	195662009	4112343		0
47829	2841	4112343	1953-03-09	1953-03-09 00:00:00	1953-03-18	1953-03-18 00:00:00	32020		\N	188611	0	195662009	4112343		0
48077	2853	4112343	1993-02-13	1993-02-13 00:00:00	1993-02-22	1993-02-22 00:00:00	32020		\N	189513	0	195662009	4112343		0
37668	2233	40481087	1978-08-19	1978-08-19 00:00:00	1978-09-02	1978-09-02 00:00:00	32020		\N	148597	0	444814009	40481087		0
37830	2242	4109685	1969-02-02	1969-02-02 00:00:00	1969-02-16	1969-02-16 00:00:00	32020		\N	149230	0	284551006	4109685		0
48574	2876	4112343	2008-06-04	2008-06-04 00:00:00	2008-06-13	2008-06-13 00:00:00	32020		\N	191330	0	195662009	4112343		0
48770	2890	4134304	1970-08-23	1970-08-23 00:00:00	1970-10-22	1970-10-22 00:00:00	32020		\N	192211	0	263102004	4134304		0
48844	2893	78272	1966-07-22	1966-07-22 00:00:00	1966-08-19	1966-08-19 00:00:00	32020		\N	192462	0	70704007	78272		0
49087	2905	260139	1987-10-07	1987-10-07 00:00:00	1987-10-14	1987-10-14 00:00:00	32020		\N	193539	0	10509002	260139		0
49272	2914	439777	1956-09-30	1956-09-30 00:00:00	\N	\N	32020		\N	194189	0	271737000	439777		0
49385	2919	40481087	1987-12-25	1987-12-25 00:00:00	1988-01-15	1988-01-15 00:00:00	32020		\N	194576	0	444814009	40481087		0
49515	2927	260139	1950-05-06	1950-05-06 00:00:00	1950-05-20	1950-05-20 00:00:00	32020		\N	195258	0	10509002	260139		0
49735	2942	260139	1992-04-27	1992-04-27 00:00:00	1992-05-04	1992-05-04 00:00:00	32020		\N	196169	0	10509002	260139		0
39305	2332	4112343	2001-12-08	2001-12-08 00:00:00	2001-12-15	2001-12-15 00:00:00	32020		\N	155072	0	195662009	4112343		0
50025	2955	4112343	1974-02-17	1974-02-17 00:00:00	1974-02-25	1974-02-25 00:00:00	32020		\N	197202	0	195662009	4112343		0
39641	2347	378001	1984-06-25	1984-06-25 00:00:00	1984-08-24	1984-08-24 00:00:00	32020		\N	156223	0	62106007	378001		0
50329	2976	4112343	1981-04-05	1981-04-05 00:00:00	1981-04-14	1981-04-14 00:00:00	32020		\N	198705	0	195662009	4112343		0
50512	2988	4112343	1999-05-14	1999-05-14 00:00:00	1999-05-26	1999-05-26 00:00:00	32020		\N	199443	0	195662009	4112343		0
50688	3000	40481087	2011-06-28	2011-06-28 00:00:00	2011-07-12	2011-07-12 00:00:00	32020		\N	200152	0	444814009	40481087		0
50822	3007	40481087	2006-12-12	2006-12-12 00:00:00	2007-01-02	2007-01-02 00:00:00	32020		\N	200589	0	444814009	40481087		0
40473	2404	40481087	1994-08-19	1994-08-19 00:00:00	1994-09-09	1994-09-09 00:00:00	32020		\N	159767	0	444814009	40481087		0
51239	3035	4218389	1972-04-06	1972-04-06 00:00:00	1972-04-27	1972-04-27 00:00:00	32020		\N	202210	0	39848009	4218389		0
51333	3044	40481087	2010-03-10	2010-03-10 00:00:00	2010-03-24	2010-03-24 00:00:00	32020		\N	202595	0	444814009	40481087		0
51495	3057	40481087	1975-08-04	1975-08-04 00:00:00	1975-08-18	1975-08-18 00:00:00	32020		\N	203337	0	444814009	40481087		0
51755	3069	4155034	1971-12-13	1971-12-13 00:00:00	1971-12-27	1971-12-27 00:00:00	32020		\N	204310	0	283371005	4155034		0
51864	3074	4112343	2009-04-18	2009-04-18 00:00:00	2009-04-29	2009-04-29 00:00:00	32020		\N	204540	0	195662009	4112343		0
52007	3081	4112343	1980-08-19	1980-08-19 00:00:00	1980-08-28	1980-08-28 00:00:00	32020		\N	205118	0	195662009	4112343		0
52167	3088	40481087	1979-06-17	1979-06-17 00:00:00	1979-06-24	1979-06-24 00:00:00	32020		\N	205618	0	444814009	40481087		0
41823	2487	4112343	2000-11-27	2000-11-27 00:00:00	2000-12-05	2000-12-05 00:00:00	32020		\N	164763	0	195662009	4112343		0
52608	3115	4278672	1972-01-15	1972-01-15 00:00:00	1972-03-15	1972-03-15 00:00:00	32020		\N	207277	0	65966004	4278672		0
52764	3125	40481087	2017-07-27	2017-07-27 00:00:00	2017-08-17	2017-08-17 00:00:00	32020		\N	207986	0	444814009	40481087		0
52922	3134	4156265	1981-10-24	1981-10-24 00:00:00	1981-11-14	1981-11-14 00:00:00	32020		\N	208556	0	370247008	4156265		0
53103	3145	40481087	2018-02-23	2018-02-23 00:00:00	2018-03-16	2018-03-16 00:00:00	32020		\N	209269	0	444814009	40481087		0
42559	2537	40486433	1951-08-23	1951-08-23 00:00:00	\N	\N	32020		\N	167662	0	446096008	40486433		0
42810	2550	375671	1984-01-11	1984-01-11 00:00:00	1984-02-10	1984-02-10 00:00:00	32020		\N	168802	0	62564004	375671		0
42918	2555	40481087	1977-12-07	1977-12-07 00:00:00	1977-12-21	1977-12-21 00:00:00	32020		\N	169361	0	444814009	40481087		0
43061	2564	40481087	1985-06-11	1985-06-11 00:00:00	1985-06-18	1985-06-18 00:00:00	32020		\N	169896	0	444814009	40481087		0
32642	1937	40481087	1989-04-12	1989-04-12 00:00:00	1989-04-26	1989-04-26 00:00:00	32020		\N	128874	0	444814009	40481087		0
43440	2588	260139	1985-09-16	1985-09-16 00:00:00	1985-09-30	1985-09-30 00:00:00	32020		\N	171277	0	10509002	260139		0
33022	1960	4218389	1973-08-17	1973-08-17 00:00:00	1973-09-21	1973-09-21 00:00:00	32020		\N	130332	0	39848009	4218389		0
43701	2602	4112343	1958-06-13	1958-06-13 00:00:00	1958-06-23	1958-06-23 00:00:00	32020		\N	172105	0	195662009	4112343		0
43849	2611	40481087	1994-07-12	1994-07-12 00:00:00	1994-07-19	1994-07-19 00:00:00	32020		\N	172630	0	444814009	40481087		0
44058	2621	80180	1994-07-02	1994-07-02 00:00:00	\N	\N	32020		\N	173334	0	396275006	80180		0
44173	2626	4112343	1975-06-13	1975-06-13 00:00:00	1975-06-23	1975-06-23 00:00:00	32020		\N	173708	0	195662009	4112343		0
44338	2636	260139	1973-09-06	1973-09-06 00:00:00	1973-09-13	1973-09-13 00:00:00	32020		\N	174485	0	10509002	260139		0
44576	2651	260139	1969-11-20	1969-11-20 00:00:00	1969-12-04	1969-12-04 00:00:00	32020		\N	175487	0	10509002	260139		0
44723	2661	40481087	1970-06-17	1970-06-17 00:00:00	1970-07-08	1970-07-08 00:00:00	32020		\N	176270	0	444814009	40481087		0
44892	2672	260139	1958-08-17	1958-08-17 00:00:00	1958-08-31	1958-08-31 00:00:00	32020		\N	176962	0	10509002	260139		0
45089	2682	80180	2016-05-25	2016-05-25 00:00:00	\N	\N	32020		\N	177723	0	396275006	80180		0
34660	2058	40481087	1974-05-02	1974-05-02 00:00:00	1974-05-09	1974-05-09 00:00:00	32020		\N	136828	0	444814009	40481087		0
45456	2702	4112343	1968-07-21	1968-07-21 00:00:00	1968-07-30	1968-07-30 00:00:00	32020		\N	178996	0	195662009	4112343		0
45552	2708	4283893	2003-11-20	2003-11-20 00:00:00	2004-02-12	2004-02-12 00:00:00	32020		\N	179356	0	36971009	4283893		0
45662	2712	81151	1978-04-07	1978-04-07 00:00:00	1978-05-12	1978-05-12 00:00:00	32020		\N	179883	0	44465007	81151		0
35358	2094	4112343	1992-12-21	1992-12-21 00:00:00	1992-12-29	1992-12-29 00:00:00	32020		\N	139636	0	195662009	4112343		0
46108	2747	260139	2008-12-09	2008-12-09 00:00:00	2008-12-23	2008-12-23 00:00:00	32020		\N	181676	0	10509002	260139		0
46211	2752	40481087	1972-04-01	1972-04-01 00:00:00	1972-04-15	1972-04-15 00:00:00	32020		\N	182061	0	444814009	40481087		0
46344	2760	30753	1999-10-09	1999-10-09 00:00:00	\N	\N	32020		\N	182561	0	16761005	30753		0
36006	2134	4285898	1987-12-21	1987-12-21 00:00:00	\N	\N	32020		\N	142035	0	68496003	4285898		0
46705	2779	4278672	2006-02-07	2006-02-07 00:00:00	2006-05-08	2006-05-08 00:00:00	32020		\N	184100	0	65966004	4278672		0
46841	2786	40481087	1927-06-19	1927-06-19 00:00:00	1927-07-03	1927-07-03 00:00:00	32020		\N	184633	0	444814009	40481087		0
47083	2801	4112343	1939-05-11	1939-05-11 00:00:00	1939-05-20	1939-05-20 00:00:00	32020		\N	185592	0	195662009	4112343		0
47193	2806	40481087	1990-08-13	1990-08-13 00:00:00	1990-09-03	1990-09-03 00:00:00	32020		\N	186006	0	444814009	40481087		0
47372	2818	260139	1975-03-07	1975-03-07 00:00:00	1975-03-14	1975-03-14 00:00:00	32020		\N	186731	0	10509002	260139		0
47527	2827	40481087	1985-08-22	1985-08-22 00:00:00	1985-08-29	1985-08-29 00:00:00	32020		\N	187471	0	444814009	40481087		0
37178	2202	4109685	1987-06-30	1987-06-30 00:00:00	1987-07-14	1987-07-14 00:00:00	32020		\N	146808	0	284551006	4109685		0
47830	2841	40481087	1952-12-05	1952-12-05 00:00:00	1952-12-26	1952-12-26 00:00:00	32020		\N	188609	0	444814009	40481087		0
48078	2853	260139	1973-04-13	1973-04-13 00:00:00	1973-04-20	1973-04-20 00:00:00	32020		\N	189505	0	10509002	260139		0
37669	2233	260139	1973-01-28	1973-01-28 00:00:00	1973-02-04	1973-02-04 00:00:00	32020		\N	148549	0	10509002	260139		0
37831	2242	257012	2015-07-09	2015-07-09 00:00:00	\N	\N	32020		\N	149265	0	40055000	257012		0
48576	2878	260139	2000-07-20	2000-07-20 00:00:00	2000-08-03	2000-08-03 00:00:00	32020		\N	191433	0	10509002	260139		0
48771	2890	40481087	1979-10-20	1979-10-20 00:00:00	1979-10-27	1979-10-27 00:00:00	32020		\N	192228	0	444814009	40481087		0
48845	2893	81151	1952-06-14	1952-06-14 00:00:00	1952-07-05	1952-07-05 00:00:00	32020		\N	192517	0	44465007	81151		0
49088	2905	195588	2006-11-18	2006-11-18 00:00:00	2007-01-08	2007-01-08 00:00:00	32020		\N	193542	0	38822007	195588		0
49273	2914	4112343	1991-01-07	1991-01-07 00:00:00	1991-01-17	1991-01-17 00:00:00	32020		\N	194213	0	195662009	4112343		0
49386	2919	4112343	1976-10-01	1976-10-01 00:00:00	1976-10-10	1976-10-10 00:00:00	32020		\N	194562	0	195662009	4112343		0
49516	2927	4112343	1994-11-18	1994-11-18 00:00:00	1994-11-29	1994-11-29 00:00:00	32020		\N	195211	0	195662009	4112343		0
49736	2942	80180	1998-10-01	1998-10-01 00:00:00	\N	\N	32020		\N	196205	0	396275006	80180		0
39306	2332	40481087	2006-07-28	2006-07-28 00:00:00	2006-08-18	2006-08-18 00:00:00	32020		\N	155086	0	444814009	40481087		0
50026	2955	4112343	2018-10-26	2018-10-26 00:00:00	2018-11-04	2018-11-04 00:00:00	32020		\N	197227	0	195662009	4112343		0
39642	2347	260139	2006-08-01	2006-08-01 00:00:00	2006-08-08	2006-08-08 00:00:00	32020		\N	156235	0	10509002	260139		0
50330	2976	40481087	1993-01-22	1993-01-22 00:00:00	1993-01-29	1993-01-29 00:00:00	32020		\N	198727	0	444814009	40481087		0
50513	2988	4283893	2017-11-16	2017-11-16 00:00:00	2017-11-30	2017-11-30 00:00:00	32020		\N	199472	0	36971009	4283893		0
50689	3000	40479422	1975-08-28	1975-08-28 00:00:00	1975-11-03	1975-11-03 00:00:00	32020		\N	200179	0	444448004	40479422		0
50823	3007	80180	2007-08-28	2007-08-28 00:00:00	\N	\N	32020		\N	200589	0	396275006	80180		0
40474	2404	4112343	1969-11-17	1969-11-17 00:00:00	1969-11-28	1969-11-28 00:00:00	32020		\N	159729	0	195662009	4112343		0
51240	3035	4112343	1966-04-10	1966-04-10 00:00:00	1966-04-20	1966-04-20 00:00:00	32020		\N	202231	0	195662009	4112343		0
51334	3044	4296205	2012-10-07	2012-10-07 00:00:00	2012-11-04	2012-11-04 00:00:00	32020		\N	202623	0	403191005	4296205		0
51496	3057	372328	1950-10-12	1950-10-12 00:00:00	1951-06-18	1951-06-18 00:00:00	32020		\N	203367	0	65363002	372328		0
51756	3069	4112343	2017-07-07	2017-07-07 00:00:00	2017-07-16	2017-07-16 00:00:00	32020		\N	204256	0	195662009	4112343		0
51866	3076	80180	1989-02-06	1989-02-06 00:00:00	\N	\N	32020		\N	204679	0	396275006	80180		0
52008	3081	40481087	1977-06-04	1977-06-04 00:00:00	1977-06-18	1977-06-18 00:00:00	32020		\N	205117	0	444814009	40481087		0
52168	3088	4109685	1993-03-04	1993-03-04 00:00:00	1993-03-25	1993-03-25 00:00:00	32020		\N	205639	0	284551006	4109685		0
41824	2487	40481087	1997-05-08	1997-05-08 00:00:00	1997-05-29	1997-05-29 00:00:00	32020		\N	164803	0	444814009	40481087		0
52609	3115	28060	1987-03-20	1987-03-20 00:00:00	1987-03-28	1987-03-28 00:00:00	32020		\N	207201	0	43878008	28060		0
52765	3125	4112343	1955-06-10	1955-06-10 00:00:00	1955-06-18	1955-06-18 00:00:00	32020		\N	207994	0	195662009	4112343		0
52923	3134	40481087	1924-06-17	1924-06-17 00:00:00	1924-07-08	1924-07-08 00:00:00	32020		\N	208537	0	444814009	40481087		0
53104	3145	40481087	1991-05-13	1991-05-13 00:00:00	1991-06-03	1991-06-03 00:00:00	32020		\N	209286	0	444814009	40481087		0
42560	2537	440086	1959-08-14	1959-08-14 00:00:00	1965-08-22	1965-08-22 00:00:00	32020		\N	167617	0	192127007	440086		0
42811	2550	78272	2001-07-10	2001-07-10 00:00:00	2001-07-31	2001-07-31 00:00:00	32020		\N	168804	0	70704007	78272		0
42919	2555	372328	1955-09-04	1955-09-04 00:00:00	1956-02-22	1956-02-22 00:00:00	32020		\N	169347	0	65363002	372328		0
43062	2564	78272	1983-05-31	1983-05-31 00:00:00	1983-06-21	1983-06-21 00:00:00	32020		\N	169847	0	70704007	78272		0
32679	1941	40481087	2017-07-23	2017-07-23 00:00:00	2017-07-30	2017-07-30 00:00:00	32020		\N	129040	0	444814009	40481087		0
43441	2588	260139	1981-05-01	1981-05-01 00:00:00	1981-05-08	1981-05-08 00:00:00	32020		\N	171286	0	10509002	260139		0
33023	1960	4059173	2007-01-26	2007-01-26 00:00:00	2007-03-27	2007-03-27 00:00:00	32020		\N	130333	0	16114001	4059173		0
43702	2602	40480160	2017-01-26	2017-01-26 00:00:00	2017-04-26	2017-04-26 00:00:00	32020		\N	172148	0	443165006	40480160		0
43850	2611	28060	2002-03-15	2002-03-15 00:00:00	2002-03-28	2002-03-28 00:00:00	32020		\N	172668	0	43878008	28060		0
44059	2621	4310024	1992-03-14	1992-03-14 00:00:00	\N	\N	32020		\N	173334	0	424802006	4310024		0
44174	2626	372328	2018-05-07	2018-05-07 00:00:00	2018-07-31	2018-07-31 00:00:00	32020		\N	173721	0	65363002	372328		0
44339	2636	260139	2017-08-22	2017-08-22 00:00:00	2017-09-05	2017-09-05 00:00:00	32020		\N	174469	0	10509002	260139		0
44577	2651	80180	1989-07-24	1989-07-24 00:00:00	\N	\N	32020		\N	175471	0	396275006	80180		0
44724	2661	4051466	1967-09-18	1967-09-18 00:00:00	1983-12-25	1983-12-25 00:00:00	32020		\N	176267	0	233678006	4051466		0
44893	2672	4152936	1962-01-27	1962-01-27 00:00:00	1962-02-10	1962-02-10 00:00:00	32020		\N	176980	0	283385000	4152936		0
45090	2682	4112343	1995-10-13	1995-10-13 00:00:00	1995-10-26	1995-10-26 00:00:00	32020		\N	177710	0	195662009	4112343		0
34661	2058	4283893	2014-10-31	2014-10-31 00:00:00	2014-11-21	2014-11-21 00:00:00	32020		\N	136814	0	36971009	4283893		0
45457	2702	4112343	1995-12-21	1995-12-21 00:00:00	1995-12-29	1995-12-29 00:00:00	32020		\N	179032	0	195662009	4112343		0
45553	2708	257012	1963-01-08	1963-01-08 00:00:00	\N	\N	32020		\N	179416	0	40055000	257012		0
45663	2712	40481087	1987-07-18	1987-07-18 00:00:00	1987-08-08	1987-08-08 00:00:00	32020		\N	179818	0	444814009	40481087		0
45855	2731	372328	1960-12-08	1960-12-08 00:00:00	1961-03-20	1961-03-20 00:00:00	32020		\N	180825	0	65363002	372328		0
46109	2747	372328	1978-01-25	1978-01-25 00:00:00	1978-03-19	1978-03-19 00:00:00	32020		\N	181663	0	65363002	372328		0
46212	2752	260139	2010-04-15	2010-04-15 00:00:00	2010-04-29	2010-04-29 00:00:00	32020		\N	182064	0	10509002	260139		0
46345	2760	40481087	1999-03-23	1999-03-23 00:00:00	1999-04-13	1999-04-13 00:00:00	32020		\N	182561	0	444814009	40481087		0
36007	2134	80180	1988-02-19	1988-02-19 00:00:00	\N	\N	32020		\N	142035	0	396275006	80180		0
46706	2779	260139	1988-12-11	1988-12-11 00:00:00	1988-12-18	1988-12-18 00:00:00	32020		\N	184094	0	10509002	260139		0
46842	2786	4266809	1959-10-11	1959-10-11 00:00:00	\N	\N	32020		\N	184573	0	397881000	4266809		0
47084	2801	260139	1931-06-16	1931-06-16 00:00:00	1931-06-30	1931-06-30 00:00:00	32020		\N	185640	0	10509002	260139		0
47194	2806	372328	1958-05-20	1958-05-20 00:00:00	1959-04-02	1959-04-02 00:00:00	32020		\N	185956	0	65363002	372328		0
47373	2818	260139	1997-10-01	1997-10-01 00:00:00	1997-10-15	1997-10-15 00:00:00	32020		\N	186756	0	10509002	260139		0
47528	2827	80180	1958-04-08	1958-04-08 00:00:00	\N	\N	32020		\N	187494	0	396275006	80180		0
37179	2202	372328	1974-01-09	1974-01-09 00:00:00	1974-03-21	1974-03-21 00:00:00	32020		\N	146756	0	65363002	372328		0
47831	2841	4134304	1986-10-06	1986-10-06 00:00:00	1986-12-05	1986-12-05 00:00:00	32020		\N	188635	0	263102004	4134304		0
48079	2853	40481087	1994-01-20	1994-01-20 00:00:00	1994-01-27	1994-01-27 00:00:00	32020		\N	189532	0	444814009	40481087		0
37670	2233	40481087	1975-03-08	1975-03-08 00:00:00	1975-03-29	1975-03-29 00:00:00	32020		\N	148582	0	444814009	40481087		0
37832	2242	28060	1980-10-22	1980-10-22 00:00:00	1980-11-04	1980-11-04 00:00:00	32020		\N	149234	0	43878008	28060		0
48577	2878	4112343	2002-12-30	2002-12-30 00:00:00	2003-01-10	2003-01-10 00:00:00	32020		\N	191441	0	195662009	4112343		0
48772	2890	4283893	1982-05-19	1982-05-19 00:00:00	1982-11-03	1982-11-03 00:00:00	32020		\N	192229	0	36971009	4283893		0
48846	2893	4112343	1952-01-18	1952-01-18 00:00:00	1952-01-25	1952-01-25 00:00:00	32020		\N	192453	0	195662009	4112343		0
49089	2905	260139	2007-06-24	2007-06-24 00:00:00	2007-07-01	2007-07-01 00:00:00	32020		\N	193600	0	10509002	260139		0
49274	2914	40481087	1965-11-07	1965-11-07 00:00:00	1965-11-21	1965-11-21 00:00:00	32020		\N	194172	0	444814009	40481087		0
49387	2919	4112343	1975-04-13	1975-04-13 00:00:00	1975-04-23	1975-04-23 00:00:00	32020		\N	194588	0	195662009	4112343		0
49517	2927	40481087	1991-04-29	1991-04-29 00:00:00	1991-05-06	1991-05-06 00:00:00	32020		\N	195204	0	444814009	40481087		0
49737	2943	4156265	1946-10-14	1946-10-14 00:00:00	1946-11-04	1946-11-04 00:00:00	32020		\N	196248	0	370247008	4156265		0
39307	2332	372328	1958-12-11	1958-12-11 00:00:00	1959-04-04	1959-04-04 00:00:00	32020		\N	155087	0	65363002	372328		0
50027	2955	4112343	2003-04-30	2003-04-30 00:00:00	2003-05-10	2003-05-10 00:00:00	32020		\N	197262	0	195662009	4112343		0
39643	2347	4112343	2015-02-26	2015-02-26 00:00:00	2015-03-11	2015-03-11 00:00:00	32020		\N	156255	0	195662009	4112343		0
50331	2976	4112343	1956-08-20	1956-08-20 00:00:00	1956-09-02	1956-09-02 00:00:00	32020		\N	198744	0	195662009	4112343		0
50514	2988	4112343	1974-01-20	1974-01-20 00:00:00	1974-02-02	1974-02-02 00:00:00	32020		\N	199482	0	195662009	4112343		0
50690	3000	40481087	2007-11-21	2007-11-21 00:00:00	2007-11-28	2007-11-28 00:00:00	32020		\N	200198	0	444814009	40481087		0
50824	3007	257012	1981-03-31	1981-03-31 00:00:00	\N	\N	32020		\N	200576	0	40055000	257012		0
40475	2404	4134304	1968-08-21	1968-08-21 00:00:00	1968-11-19	1968-11-19 00:00:00	32020		\N	159758	0	263102004	4134304		0
51241	3035	260139	1995-04-07	1995-04-07 00:00:00	1995-04-14	1995-04-14 00:00:00	32020		\N	202182	0	10509002	260139		0
51335	3044	4112343	1972-12-04	1972-12-04 00:00:00	1972-12-14	1972-12-14 00:00:00	32020		\N	202625	0	195662009	4112343		0
51497	3057	372328	1941-05-30	1941-05-30 00:00:00	1942-04-27	1942-04-27 00:00:00	32020		\N	203366	0	65363002	372328		0
51757	3069	260139	1991-02-12	1991-02-12 00:00:00	1991-02-26	1991-02-26 00:00:00	32020		\N	204247	0	10509002	260139		0
51867	3076	372328	1952-05-16	1952-05-16 00:00:00	1952-11-05	1952-11-05 00:00:00	32020		\N	204664	0	65363002	372328		0
52009	3081	80180	1984-05-08	1984-05-08 00:00:00	\N	\N	32020		\N	205171	0	396275006	80180		0
52169	3088	40481087	1953-09-04	1953-09-04 00:00:00	1953-09-11	1953-09-11 00:00:00	32020		\N	205608	0	444814009	40481087		0
41825	2487	28060	1961-04-17	1961-04-17 00:00:00	1961-04-29	1961-04-29 00:00:00	32020		\N	164785	0	43878008	28060		0
52610	3115	4109685	1994-10-07	1994-10-07 00:00:00	1994-10-28	1994-10-28 00:00:00	32020		\N	207280	0	284551006	4109685		0
52766	3125	40481087	2008-09-23	2008-09-23 00:00:00	2008-10-07	2008-10-07 00:00:00	32020		\N	207985	0	444814009	40481087		0
52924	3134	40481087	1978-04-11	1978-04-11 00:00:00	1978-05-02	1978-05-02 00:00:00	32020		\N	208629	0	444814009	40481087		0
53105	3145	40481087	2001-09-15	2001-09-15 00:00:00	2001-09-29	2001-09-29 00:00:00	32020		\N	209268	0	444814009	40481087		0
42561	2537	372328	1948-08-11	1948-08-11 00:00:00	1948-10-24	1948-10-24 00:00:00	32020		\N	167742	0	65363002	372328		0
42812	2550	40481087	1996-05-17	1996-05-17 00:00:00	1996-05-24	1996-05-24 00:00:00	32020		\N	168834	0	444814009	40481087		0
42920	2555	40481087	2015-01-13	2015-01-13 00:00:00	2015-02-03	2015-02-03 00:00:00	32020		\N	169327	0	444814009	40481087		0
43063	2564	4112343	2005-08-22	2005-08-22 00:00:00	2005-09-03	2005-09-03 00:00:00	32020		\N	169837	0	195662009	4112343		0
32680	1941	80180	2009-11-23	2009-11-23 00:00:00	\N	\N	32020		\N	129102	0	396275006	80180		0
43442	2588	439777	2016-08-17	2016-08-17 00:00:00	\N	\N	32020		\N	171266	0	271737000	439777		0
33024	1960	4112343	1958-11-16	1958-11-16 00:00:00	1958-11-25	1958-11-25 00:00:00	32020		\N	130338	0	195662009	4112343		0
43703	2602	4142905	2017-01-26	2017-01-26 00:00:00	2017-04-26	2017-04-26 00:00:00	32020		\N	172148	0	33737001	4142905		0
43851	2611	40481087	1955-02-03	1955-02-03 00:00:00	1955-02-24	1955-02-24 00:00:00	32020		\N	172657	0	444814009	40481087		0
44060	2621	4266809	1994-07-02	1994-07-02 00:00:00	\N	\N	32020		\N	173334	0	397881000	4266809		0
44175	2626	80180	2000-03-09	2000-03-09 00:00:00	\N	\N	32020		\N	173690	0	396275006	80180		0
44340	2636	81151	2013-04-26	2013-04-26 00:00:00	2013-05-31	2013-05-31 00:00:00	32020		\N	174420	0	44465007	81151		0
44578	2651	40481087	1995-11-05	1995-11-05 00:00:00	1995-11-19	1995-11-19 00:00:00	32020		\N	175446	0	444814009	40481087		0
44725	2661	4112343	1990-08-19	1990-08-19 00:00:00	1990-08-28	1990-08-28 00:00:00	32020		\N	176326	0	195662009	4112343		0
44894	2672	260139	1978-07-13	1978-07-13 00:00:00	1978-07-20	1978-07-20 00:00:00	32020		\N	177025	0	10509002	260139		0
45091	2682	260139	1974-08-10	1974-08-10 00:00:00	1974-08-24	1974-08-24 00:00:00	32020		\N	177708	0	10509002	260139		0
34662	2058	4283893	1972-12-31	1972-12-31 00:00:00	1973-01-28	1973-01-28 00:00:00	32020		\N	136871	0	36971009	4283893		0
45458	2702	257012	1985-04-27	1985-04-27 00:00:00	\N	\N	32020		\N	178969	0	40055000	257012		0
45554	2708	260139	1968-03-05	1968-03-05 00:00:00	1968-03-12	1968-03-12 00:00:00	32020		\N	179417	0	10509002	260139		0
45664	2712	4112343	2008-01-25	2008-01-25 00:00:00	2008-02-07	2008-02-07 00:00:00	32020		\N	179821	0	195662009	4112343		0
45856	2731	260139	1969-02-21	1969-02-21 00:00:00	1969-03-07	1969-03-07 00:00:00	32020		\N	180755	0	10509002	260139		0
46110	2747	4112343	2005-05-23	2005-05-23 00:00:00	2005-06-02	2005-06-02 00:00:00	32020		\N	181659	0	195662009	4112343		0
46213	2752	40481087	2016-08-31	2016-08-31 00:00:00	2016-09-21	2016-09-21 00:00:00	32020		\N	182105	0	444814009	40481087		0
46346	2760	4285898	2000-07-05	2000-07-05 00:00:00	\N	\N	32020		\N	182561	0	68496003	4285898		0
36008	2134	4266809	1988-02-19	1988-02-19 00:00:00	\N	\N	32020		\N	142035	0	397881000	4266809		0
46707	2779	134438	1994-11-16	1994-11-16 00:00:00	1995-10-17	1995-10-17 00:00:00	32020		\N	184171	0	40275004	134438		0
46843	2786	30753	1958-10-16	1958-10-16 00:00:00	\N	\N	32020		\N	184573	0	16761005	30753		0
47085	2801	40481087	1951-08-25	1951-08-25 00:00:00	1951-09-08	1951-09-08 00:00:00	32020		\N	185593	0	444814009	40481087		0
47195	2806	4278672	2009-05-25	2009-05-25 00:00:00	2009-07-24	2009-07-24 00:00:00	32020		\N	185962	0	65966004	4278672		0
47374	2818	4112343	2010-10-20	2010-10-20 00:00:00	2010-10-28	2010-10-28 00:00:00	32020		\N	186747	0	195662009	4112343		0
47529	2827	313217	2000-12-26	2000-12-26 00:00:00	\N	\N	32020		\N	187456	0	49436004	313217		0
37180	2202	257012	2016-12-17	2016-12-17 00:00:00	\N	\N	32020		\N	146755	0	40055000	257012		0
47832	2841	40481087	1962-08-18	1962-08-18 00:00:00	1962-09-01	1962-09-01 00:00:00	32020		\N	188588	0	444814009	40481087		0
48080	2853	40481087	1983-05-10	1983-05-10 00:00:00	1983-05-31	1983-05-31 00:00:00	32020		\N	189522	0	444814009	40481087		0
37671	2233	40481087	1984-02-12	1984-02-12 00:00:00	1984-02-19	1984-02-19 00:00:00	32020		\N	148584	0	444814009	40481087		0
37833	2242	4155034	1996-07-24	1996-07-24 00:00:00	1996-08-14	1996-08-14 00:00:00	32020		\N	149231	0	283371005	4155034		0
48578	2878	81151	1984-03-06	1984-03-06 00:00:00	1984-03-27	1984-03-27 00:00:00	32020		\N	191470	0	44465007	81151		0
48773	2890	4112343	1983-02-17	1983-02-17 00:00:00	1983-03-01	1983-03-01 00:00:00	32020		\N	192197	0	195662009	4112343		0
48847	2893	4112343	1966-01-23	1966-01-23 00:00:00	1966-02-03	1966-02-03 00:00:00	32020		\N	192456	0	195662009	4112343		0
49090	2905	4112343	1967-03-01	1967-03-01 00:00:00	1967-03-09	1967-03-09 00:00:00	32020		\N	193553	0	195662009	4112343		0
49275	2914	4296204	1960-05-07	1960-05-07 00:00:00	1960-05-28	1960-05-28 00:00:00	32020		\N	194194	0	403190006	4296204		0
49388	2919	260139	1951-11-10	1951-11-10 00:00:00	1951-11-17	1951-11-17 00:00:00	32020		\N	194584	0	10509002	260139		0
49518	2927	372328	1942-10-21	1942-10-21 00:00:00	1943-01-01	1943-01-01 00:00:00	32020		\N	195255	0	65363002	372328		0
49738	2943	372328	1915-07-26	1915-07-26 00:00:00	1915-08-09	1915-08-09 00:00:00	32020		\N	196282	0	65363002	372328		0
39308	2332	4112343	1984-10-22	1984-10-22 00:00:00	1984-11-03	1984-11-03 00:00:00	32020		\N	155050	0	195662009	4112343		0
50028	2955	40481087	1978-08-16	1978-08-16 00:00:00	1978-08-30	1978-08-30 00:00:00	32020		\N	197240	0	444814009	40481087		0
39644	2347	4156265	2001-11-23	2001-11-23 00:00:00	2001-12-14	2001-12-14 00:00:00	32020		\N	156224	0	370247008	4156265		0
50332	2976	4285898	1995-01-29	1995-01-29 00:00:00	\N	\N	32020		\N	198761	0	68496003	4285898		0
50515	2988	81151	1972-09-15	1972-09-15 00:00:00	1972-09-29	1972-09-29 00:00:00	32020		\N	199425	0	44465007	81151		0
50691	3000	4310024	1981-01-03	1981-01-03 00:00:00	\N	\N	32020		\N	200169	0	424802006	4310024		0
50825	3007	40481087	1970-06-26	1970-06-26 00:00:00	1970-07-03	1970-07-03 00:00:00	32020		\N	200585	0	444814009	40481087		0
40476	2404	4146173	2002-06-11	2002-06-11 00:00:00	2002-08-10	2002-08-10 00:00:00	32020		\N	159768	0	307731004	4146173		0
51242	3035	4109685	1978-02-25	1978-02-25 00:00:00	1978-03-18	1978-03-18 00:00:00	32020		\N	202172	0	284551006	4109685		0
51351	3047	260139	1990-03-26	1990-03-26 00:00:00	1990-04-09	1990-04-09 00:00:00	32020		\N	202752	0	10509002	260139		0
51498	3057	4112343	1973-08-20	1973-08-20 00:00:00	1973-08-31	1973-08-31 00:00:00	32020		\N	203336	0	195662009	4112343		0
51758	3069	40481087	1983-04-05	1983-04-05 00:00:00	1983-04-19	1983-04-19 00:00:00	32020		\N	204255	0	444814009	40481087		0
51869	3076	321042	1952-11-26	1952-11-26 00:00:00	\N	\N	32020		\N	204704	0	410429000	321042		0
52010	3081	4285898	1984-01-09	1984-01-09 00:00:00	\N	\N	32020		\N	205171	0	68496003	4285898		0
52170	3088	28060	1940-05-12	1940-05-12 00:00:00	1940-05-23	1940-05-23 00:00:00	32020		\N	205683	0	43878008	28060		0
41826	2487	260139	2003-12-22	2003-12-22 00:00:00	2004-01-05	2004-01-05 00:00:00	32020		\N	164791	0	10509002	260139		0
52611	3115	4027663	1995-01-13	1995-01-13 00:00:00	\N	\N	32020		\N	207280	0	13200003	4027663		0
52767	3125	4113008	2011-09-29	2011-09-29 00:00:00	2011-10-13	2011-10-13 00:00:00	32020		\N	207930	0	284549007	4113008		0
52925	3134	4155034	2001-08-01	2001-08-01 00:00:00	2001-08-22	2001-08-22 00:00:00	32020		\N	208558	0	283371005	4155034		0
53106	3145	80180	2010-12-03	2010-12-03 00:00:00	\N	\N	32020		\N	209260	0	396275006	80180		0
42562	2537	40481087	1957-05-20	1957-05-20 00:00:00	1957-06-10	1957-06-10 00:00:00	32020		\N	167616	0	444814009	40481087		0
42813	2551	40481087	1983-02-14	1983-02-14 00:00:00	1983-02-28	1983-02-28 00:00:00	32020		\N	168897	0	444814009	40481087		0
42921	2555	372328	1953-04-02	1953-04-02 00:00:00	1953-08-13	1953-08-13 00:00:00	32020		\N	169345	0	65363002	372328		0
43064	2564	372328	1979-07-07	1979-07-07 00:00:00	1979-07-28	1979-07-28 00:00:00	32020		\N	169893	0	65363002	372328		0
32681	1941	81151	2009-04-28	2009-04-28 00:00:00	2009-05-19	2009-05-19 00:00:00	32020		\N	129102	0	44465007	81151		0
43443	2588	260139	1966-06-22	1966-06-22 00:00:00	1966-06-29	1966-06-29 00:00:00	32020		\N	171284	0	10509002	260139		0
33025	1960	28060	1983-05-27	1983-05-27 00:00:00	1983-06-06	1983-06-06 00:00:00	32020		\N	130341	0	43878008	28060		0
43704	2602	28060	1994-11-15	1994-11-15 00:00:00	1994-11-25	1994-11-25 00:00:00	32020		\N	172159	0	43878008	28060		0
43852	2611	40481087	1987-06-25	1987-06-25 00:00:00	1987-07-16	1987-07-16 00:00:00	32020		\N	172646	0	444814009	40481087		0
44061	2621	30753	1993-07-07	1993-07-07 00:00:00	\N	\N	32020		\N	173334	0	16761005	30753		0
44176	2626	4112343	1988-07-01	1988-07-01 00:00:00	1988-07-09	1988-07-09 00:00:00	32020		\N	173717	0	195662009	4112343		0
44341	2636	260139	1989-12-25	1989-12-25 00:00:00	1990-01-01	1990-01-01 00:00:00	32020		\N	174466	0	10509002	260139		0
44579	2651	40481087	1999-12-03	1999-12-03 00:00:00	1999-12-17	1999-12-17 00:00:00	32020		\N	175382	0	444814009	40481087		0
44726	2661	260139	2015-11-02	2015-11-02 00:00:00	2015-11-09	2015-11-09 00:00:00	32020		\N	176363	0	10509002	260139		0
44895	2672	4027663	1983-11-18	1983-11-18 00:00:00	\N	\N	32020		\N	176977	0	13200003	4027663		0
45092	2682	40481087	2004-11-08	2004-11-08 00:00:00	2004-11-29	2004-11-29 00:00:00	32020		\N	177757	0	444814009	40481087		0
34663	2058	40481087	1987-12-26	1987-12-26 00:00:00	1988-01-16	1988-01-16 00:00:00	32020		\N	136857	0	444814009	40481087		0
45459	2703	260139	1976-10-19	1976-10-19 00:00:00	1976-11-02	1976-11-02 00:00:00	32020		\N	179083	0	10509002	260139		0
45555	2708	40481087	1972-12-08	1972-12-08 00:00:00	1972-12-22	1972-12-22 00:00:00	32020		\N	179418	0	444814009	40481087		0
45665	2712	260139	1978-11-13	1978-11-13 00:00:00	1978-11-20	1978-11-20 00:00:00	32020		\N	179814	0	10509002	260139		0
45857	2731	4109685	2008-04-04	2008-04-04 00:00:00	2008-04-25	2008-04-25 00:00:00	32020		\N	180795	0	284551006	4109685		0
46111	2747	260139	1984-02-20	1984-02-20 00:00:00	1984-02-27	1984-02-27 00:00:00	32020		\N	181655	0	10509002	260139		0
46214	2752	4156265	1960-01-14	1960-01-14 00:00:00	1960-01-28	1960-01-28 00:00:00	32020		\N	182114	0	370247008	4156265		0
46347	2760	81151	1961-01-06	1961-01-06 00:00:00	1961-02-03	1961-02-03 00:00:00	32020		\N	182592	0	44465007	81151		0
36009	2134	81893	1986-11-26	1986-11-26 00:00:00	\N	\N	32020		\N	142035	0	64766004	81893		0
46708	2779	40481087	2016-05-31	2016-05-31 00:00:00	2016-06-07	2016-06-07 00:00:00	32020		\N	184132	0	444814009	40481087		0
46844	2786	4310024	1958-05-19	1958-05-19 00:00:00	\N	\N	32020		\N	184573	0	424802006	4310024		0
47086	2801	40481087	2000-09-09	2000-09-09 00:00:00	2000-09-30	2000-09-30 00:00:00	32020		\N	185652	0	444814009	40481087		0
47196	2806	4112343	1972-02-19	1972-02-19 00:00:00	1972-03-02	1972-03-02 00:00:00	32020		\N	185974	0	195662009	4112343		0
47375	2818	4112343	1985-12-24	1985-12-24 00:00:00	1986-01-02	1986-01-02 00:00:00	32020		\N	186746	0	195662009	4112343		0
47530	2827	372328	1924-02-11	1924-02-11 00:00:00	1924-05-06	1924-05-06 00:00:00	32020		\N	187519	0	65363002	372328		0
37181	2202	4283893	2016-11-26	2016-11-26 00:00:00	2017-02-25	2017-02-25 00:00:00	32020		\N	146782	0	36971009	4283893		0
47833	2841	40481087	1954-01-26	1954-01-26 00:00:00	1954-02-09	1954-02-09 00:00:00	32020		\N	188586	0	444814009	40481087		0
48081	2853	4155034	1980-05-23	1980-05-23 00:00:00	1980-06-13	1980-06-13 00:00:00	32020		\N	189580	0	283371005	4155034		0
37672	2233	28060	1976-01-15	1976-01-15 00:00:00	1976-01-27	1976-01-27 00:00:00	32020		\N	148583	0	43878008	28060		0
37834	2242	40481087	1984-03-23	1984-03-23 00:00:00	1984-03-30	1984-03-30 00:00:00	32020		\N	149221	0	444814009	40481087		0
48579	2878	40481087	2012-11-12	2012-11-12 00:00:00	2012-12-03	2012-12-03 00:00:00	32020		\N	191443	0	444814009	40481087		0
48774	2890	40481087	1973-10-28	1973-10-28 00:00:00	1973-11-11	1973-11-11 00:00:00	32020		\N	192234	0	444814009	40481087		0
48848	2893	260139	1949-05-25	1949-05-25 00:00:00	1949-06-01	1949-06-01 00:00:00	32020		\N	192451	0	10509002	260139		0
49091	2905	81893	1998-03-15	1998-03-15 00:00:00	\N	\N	32020		\N	193540	0	64766004	81893		0
49276	2914	4112343	1992-10-09	1992-10-09 00:00:00	1992-10-20	1992-10-20 00:00:00	32020		\N	194179	0	195662009	4112343		0
49389	2919	40481087	2004-11-22	2004-11-22 00:00:00	2004-11-29	2004-11-29 00:00:00	32020		\N	194577	0	444814009	40481087		0
49519	2927	378001	1999-04-14	1999-04-14 00:00:00	1999-06-13	1999-06-13 00:00:00	32020		\N	195298	0	62106007	378001		0
49739	2943	4218389	1995-12-15	1995-12-15 00:00:00	1996-01-12	1996-01-12 00:00:00	32020		\N	196324	0	39848009	4218389		0
39309	2332	4278672	1988-11-15	1988-11-15 00:00:00	1988-12-15	1988-12-15 00:00:00	32020		\N	155126	0	65966004	4278672		0
50029	2955	260139	1980-04-21	1980-04-21 00:00:00	1980-04-28	1980-04-28 00:00:00	32020		\N	197241	0	10509002	260139		0
39645	2347	4027663	2001-11-24	2001-11-24 00:00:00	\N	\N	32020		\N	156224	0	13200003	4027663		0
50333	2976	4112343	2011-01-24	2011-01-24 00:00:00	2011-02-05	2011-02-05 00:00:00	32020		\N	198706	0	195662009	4112343		0
50516	2988	4112343	1998-06-10	1998-06-10 00:00:00	1998-06-17	1998-06-17 00:00:00	32020		\N	199442	0	195662009	4112343		0
50692	3000	81893	1981-03-04	1981-03-04 00:00:00	\N	\N	32020		\N	200169	0	64766004	81893		0
50826	3007	40481087	2004-01-05	2004-01-05 00:00:00	2004-01-19	2004-01-19 00:00:00	32020		\N	200621	0	444814009	40481087		0
40477	2404	4156265	1980-06-24	1980-06-24 00:00:00	1980-07-15	1980-07-15 00:00:00	32020		\N	159761	0	370247008	4156265		0
51243	3035	260139	1999-09-21	1999-09-21 00:00:00	1999-09-28	1999-09-28 00:00:00	32020		\N	202212	0	10509002	260139		0
51352	3047	372328	1975-02-11	1975-02-11 00:00:00	1975-07-02	1975-07-02 00:00:00	32020		\N	202756	0	65363002	372328		0
51499	3057	4112343	1966-07-16	1966-07-16 00:00:00	1966-07-24	1966-07-24 00:00:00	32020		\N	203362	0	195662009	4112343		0
51759	3069	4113008	1991-06-13	1991-06-13 00:00:00	1991-06-27	1991-06-27 00:00:00	32020		\N	204313	0	284549007	4113008		0
51870	3076	4113008	2004-09-18	2004-09-18 00:00:00	2004-10-09	2004-10-09 00:00:00	32020		\N	204646	0	284549007	4113008		0
52011	3081	81893	1983-08-12	1983-08-12 00:00:00	\N	\N	32020		\N	205171	0	64766004	81893		0
52171	3088	40481087	1982-05-16	1982-05-16 00:00:00	1982-06-06	1982-06-06 00:00:00	32020		\N	205611	0	444814009	40481087		0
41827	2487	4112343	2009-08-22	2009-08-22 00:00:00	2009-08-30	2009-08-30 00:00:00	32020		\N	164805	0	195662009	4112343		0
63105	3728	40481087	2013-07-03	2013-07-03 00:00:00	2013-07-17	2013-07-17 00:00:00	32020		\N	247731	0	444814009	40481087		0
52768	3125	260139	1972-04-19	1972-04-19 00:00:00	1972-04-26	1972-04-26 00:00:00	32020		\N	207946	0	10509002	260139		0
52926	3134	81151	1924-08-09	1924-08-09 00:00:00	1924-09-13	1924-09-13 00:00:00	32020		\N	208553	0	44465007	81151		0
53107	3145	260139	1987-09-01	1987-09-01 00:00:00	1987-09-08	1987-09-08 00:00:00	32020		\N	209256	0	10509002	260139		0
42563	2537	81151	1952-05-22	1952-05-22 00:00:00	1952-06-12	1952-06-12 00:00:00	32020		\N	167643	0	44465007	81151		0
42814	2551	28060	1970-06-22	1970-06-22 00:00:00	1970-07-02	1970-07-02 00:00:00	32020		\N	168896	0	43878008	28060		0
42922	2555	40481087	1972-07-23	1972-07-23 00:00:00	1972-07-30	1972-07-30 00:00:00	32020		\N	169321	0	444814009	40481087		0
43065	2564	28060	1991-08-06	1991-08-06 00:00:00	1991-08-17	1991-08-17 00:00:00	32020		\N	169888	0	43878008	28060		0
32682	1941	4294548	2004-02-13	2004-02-13 00:00:00	2004-03-05	2004-03-05 00:00:00	32020		\N	129104	0	75498004	4294548		0
43444	2588	4112343	1999-03-09	1999-03-09 00:00:00	1999-03-19	1999-03-19 00:00:00	32020		\N	171278	0	195662009	4112343		0
33026	1960	4310024	1969-01-24	1969-01-24 00:00:00	\N	\N	32020		\N	130339	0	424802006	4310024		0
43705	2602	40481087	1956-05-27	1956-05-27 00:00:00	1956-06-03	1956-06-03 00:00:00	32020		\N	172140	0	444814009	40481087		0
43853	2611	40481087	1955-08-03	1955-08-03 00:00:00	1955-08-10	1955-08-10 00:00:00	32020		\N	172701	0	444814009	40481087		0
44062	2621	40481087	1980-07-29	1980-07-29 00:00:00	1980-08-05	1980-08-05 00:00:00	32020		\N	173391	0	444814009	40481087		0
44177	2626	40481087	2001-08-22	2001-08-22 00:00:00	2001-08-29	2001-08-29 00:00:00	32020		\N	173714	0	444814009	40481087		0
44342	2636	80180	2002-04-25	2002-04-25 00:00:00	\N	\N	32020		\N	174481	0	396275006	80180		0
44580	2651	4051466	1948-09-24	1948-09-24 00:00:00	1966-03-02	1966-03-02 00:00:00	32020		\N	175435	0	233678006	4051466		0
44727	2661	40481087	2008-01-27	2008-01-27 00:00:00	2008-02-17	2008-02-17 00:00:00	32020		\N	176356	0	444814009	40481087		0
44896	2672	378001	1980-04-27	1980-04-27 00:00:00	1980-06-26	1980-06-26 00:00:00	32020		\N	176982	0	62106007	378001		0
45093	2682	260139	2009-12-01	2009-12-01 00:00:00	2009-12-08	2009-12-08 00:00:00	32020		\N	177712	0	10509002	260139		0
34664	2058	4112343	2016-03-19	2016-03-19 00:00:00	2016-03-26	2016-03-26 00:00:00	32020		\N	136915	0	195662009	4112343		0
45460	2703	4027663	2003-02-24	2003-02-24 00:00:00	\N	\N	32020		\N	179063	0	13200003	4027663		0
45556	2708	4112343	2013-03-30	2013-03-30 00:00:00	2013-04-06	2013-04-06 00:00:00	32020		\N	179362	0	195662009	4112343		0
45666	2712	372328	1966-09-05	1966-09-05 00:00:00	1966-12-06	1966-12-06 00:00:00	32020		\N	179860	0	65363002	372328		0
45858	2731	260139	2012-11-20	2012-11-20 00:00:00	2012-12-04	2012-12-04 00:00:00	32020		\N	180769	0	10509002	260139		0
46112	2747	372328	1976-02-21	1976-02-21 00:00:00	1976-03-06	1976-03-06 00:00:00	32020		\N	181662	0	65363002	372328		0
46215	2752	4112343	2018-09-29	2018-09-29 00:00:00	2018-10-09	2018-10-09 00:00:00	32020		\N	182038	0	195662009	4112343		0
46348	2760	40481087	1985-04-22	1985-04-22 00:00:00	1985-04-29	1985-04-29 00:00:00	32020		\N	182535	0	444814009	40481087		0
36010	2134	30753	1987-03-26	1987-03-26 00:00:00	\N	\N	32020		\N	142035	0	16761005	30753		0
46709	2779	80180	2015-04-23	2015-04-23 00:00:00	\N	\N	32020		\N	184196	0	396275006	80180		0
46845	2786	80180	1959-10-11	1959-10-11 00:00:00	\N	\N	32020		\N	184573	0	396275006	80180		0
47087	2801	28060	1928-12-24	1928-12-24 00:00:00	1929-01-02	1929-01-02 00:00:00	32020		\N	185569	0	43878008	28060		0
47197	2806	317576	1985-03-07	1985-03-07 00:00:00	\N	\N	32020		\N	185970	0	53741008	317576		0
47376	2818	260139	1971-07-18	1971-07-18 00:00:00	1971-07-25	1971-07-25 00:00:00	32020		\N	186718	0	10509002	260139		0
47531	2827	4112343	1946-12-20	1946-12-20 00:00:00	1947-01-01	1947-01-01 00:00:00	32020		\N	187443	0	195662009	4112343		0
37182	2202	4294548	2011-06-19	2011-06-19 00:00:00	2011-07-17	2011-07-17 00:00:00	32020		\N	146754	0	75498004	4294548		0
47834	2841	4112343	1968-01-01	1968-01-01 00:00:00	1968-01-10	1968-01-10 00:00:00	32020		\N	188612	0	195662009	4112343		0
48082	2853	4112343	2014-11-28	2014-11-28 00:00:00	2014-12-10	2014-12-10 00:00:00	32020		\N	189525	0	195662009	4112343		0
37678	2235	40481087	2001-08-01	2001-08-01 00:00:00	2001-08-08	2001-08-08 00:00:00	32020		\N	148692	0	444814009	40481087		0
37835	2242	260139	1976-02-23	1976-02-23 00:00:00	1976-03-08	1976-03-08 00:00:00	32020		\N	149233	0	10509002	260139		0
48580	2878	40481087	2015-12-23	2015-12-23 00:00:00	2015-12-30	2015-12-30 00:00:00	32020		\N	191413	0	444814009	40481087		0
48775	2890	4112343	2016-09-15	2016-09-15 00:00:00	2016-09-23	2016-09-23 00:00:00	32020		\N	192224	0	195662009	4112343		0
48849	2893	4112343	1994-04-30	1994-04-30 00:00:00	1994-05-11	1994-05-11 00:00:00	32020		\N	192534	0	195662009	4112343		0
49092	2905	40481087	1997-02-13	1997-02-13 00:00:00	1997-02-20	1997-02-20 00:00:00	32020		\N	193540	0	444814009	40481087		0
49277	2914	4113008	1991-03-17	1991-03-17 00:00:00	1991-04-07	1991-04-07 00:00:00	32020		\N	194196	0	284549007	4113008		0
49390	2919	261325	2006-09-30	2006-09-30 00:00:00	\N	\N	32020		\N	194624	0	87433001	261325		0
49520	2927	40481087	1943-03-25	1943-03-25 00:00:00	1943-04-01	1943-04-01 00:00:00	32020		\N	195250	0	444814009	40481087		0
49740	2943	260139	1977-08-02	1977-08-02 00:00:00	1977-08-16	1977-08-16 00:00:00	32020		\N	196321	0	10509002	260139		0
39310	2332	440086	1968-04-17	1968-04-17 00:00:00	1975-04-26	1975-04-26 00:00:00	32020		\N	155062	0	192127007	440086		0
50030	2955	28060	1969-12-29	1969-12-29 00:00:00	1970-01-07	1970-01-07 00:00:00	32020		\N	197274	0	43878008	28060		0
39646	2347	40481087	1990-02-07	1990-02-07 00:00:00	1990-02-14	1990-02-14 00:00:00	32020		\N	156276	0	444814009	40481087		0
50334	2976	4027663	1987-06-15	1987-06-15 00:00:00	\N	\N	32020		\N	198772	0	13200003	4027663		0
50517	2988	4310024	1998-07-01	1998-07-01 00:00:00	\N	\N	32020		\N	199442	0	424802006	4310024		0
50693	3000	30753	1982-01-28	1982-01-28 00:00:00	\N	\N	32020		\N	200169	0	16761005	30753		0
50827	3007	4230399	1979-07-21	1979-07-21 00:00:00	1979-09-19	1979-09-19 00:00:00	32020		\N	200600	0	359817006	4230399		0
40478	2404	40481087	1979-02-26	1979-02-26 00:00:00	1979-03-12	1979-03-12 00:00:00	32020		\N	159765	0	444814009	40481087		0
51244	3035	260139	1986-10-30	1986-10-30 00:00:00	1986-11-06	1986-11-06 00:00:00	32020		\N	202168	0	10509002	260139		0
51353	3047	28060	1976-11-06	1976-11-06 00:00:00	1976-11-16	1976-11-16 00:00:00	32020		\N	202718	0	43878008	28060		0
51500	3057	4278672	1966-12-28	1966-12-28 00:00:00	1967-03-28	1967-03-28 00:00:00	32020		\N	203385	0	65966004	4278672		0
51760	3069	4112343	1997-02-05	1997-02-05 00:00:00	1997-02-18	1997-02-18 00:00:00	32020		\N	204248	0	195662009	4112343		0
51871	3076	4109685	2012-11-24	2012-11-24 00:00:00	2012-12-15	2012-12-15 00:00:00	32020		\N	204648	0	284551006	4109685		0
52012	3081	4266809	1984-05-08	1984-05-08 00:00:00	\N	\N	32020		\N	205171	0	397881000	4266809		0
52172	3088	4156265	1970-03-16	1970-03-16 00:00:00	1970-04-06	1970-04-06 00:00:00	32020		\N	205637	0	370247008	4156265		0
41828	2487	4112343	1998-12-22	1998-12-22 00:00:00	1999-01-04	1999-01-04 00:00:00	32020		\N	164814	0	195662009	4112343		0
63106	3728	81151	1984-09-09	1984-09-09 00:00:00	1984-09-23	1984-09-23 00:00:00	32020		\N	247751	0	44465007	81151		0
52769	3125	260139	1979-06-22	1979-06-22 00:00:00	1979-07-06	1979-07-06 00:00:00	32020		\N	207937	0	10509002	260139		0
52927	3134	313217	2007-02-15	2007-02-15 00:00:00	\N	\N	32020		\N	208597	0	49436004	313217		0
53108	3145	4142905	1974-05-11	1974-05-11 00:00:00	1974-06-10	1974-06-10 00:00:00	32020		\N	209300	0	33737001	4142905		0
42564	2537	372328	1949-04-22	1949-04-22 00:00:00	1949-07-24	1949-07-24 00:00:00	32020		\N	167743	0	65363002	372328		0
42815	2551	375671	1984-02-06	1984-02-06 00:00:00	1984-03-07	1984-03-07 00:00:00	32020		\N	168904	0	62564004	375671		0
42923	2555	260139	2013-08-10	2013-08-10 00:00:00	2013-08-24	2013-08-24 00:00:00	32020		\N	169289	0	10509002	260139		0
43066	2564	4296204	1978-08-11	1978-08-11 00:00:00	1978-08-25	1978-08-25 00:00:00	32020		\N	169846	0	403190006	4296204		0
32683	1941	372328	1975-05-14	1975-05-14 00:00:00	1975-07-24	1975-07-24 00:00:00	32020		\N	129105	0	65363002	372328		0
43445	2588	40481087	1989-04-29	1989-04-29 00:00:00	1989-05-13	1989-05-13 00:00:00	32020		\N	171264	0	444814009	40481087		0
33027	1960	4112343	1968-08-05	1968-08-05 00:00:00	1968-08-12	1968-08-12 00:00:00	32020		\N	130339	0	195662009	4112343		0
43706	2602	260139	2006-02-28	2006-02-28 00:00:00	2006-03-14	2006-03-14 00:00:00	32020		\N	172074	0	10509002	260139		0
43854	2611	80180	1990-06-29	1990-06-29 00:00:00	\N	\N	32020		\N	172679	0	396275006	80180		0
44063	2621	40481087	1987-04-26	1987-04-26 00:00:00	1987-05-17	1987-05-17 00:00:00	32020		\N	173353	0	444814009	40481087		0
44178	2626	4112343	1981-01-26	1981-01-26 00:00:00	1981-02-06	1981-02-06 00:00:00	32020		\N	173712	0	195662009	4112343		0
44343	2636	4109685	2018-07-04	2018-07-04 00:00:00	2018-07-18	2018-07-18 00:00:00	32020		\N	174421	0	284551006	4109685		0
44605	2654	40481087	2015-05-15	2015-05-15 00:00:00	2015-06-05	2015-06-05 00:00:00	32020		\N	175718	0	444814009	40481087		0
44728	2661	40481087	1967-12-04	1967-12-04 00:00:00	1967-12-25	1967-12-25 00:00:00	32020		\N	176268	0	444814009	40481087		0
44897	2672	4146173	1951-11-21	1951-11-21 00:00:00	1951-12-21	1951-12-21 00:00:00	32020		\N	176961	0	307731004	4146173		0
45094	2682	40481087	2011-08-28	2011-08-28 00:00:00	2011-09-11	2011-09-11 00:00:00	32020		\N	177759	0	444814009	40481087		0
34665	2058	4027663	1992-10-19	1992-10-19 00:00:00	\N	\N	32020		\N	136909	0	13200003	4027663		0
45461	2703	4296204	1987-05-24	1987-05-24 00:00:00	1987-06-14	1987-06-14 00:00:00	32020		\N	179105	0	403190006	4296204		0
45557	2708	40481087	2012-04-02	2012-04-02 00:00:00	2012-04-09	2012-04-09 00:00:00	32020		\N	179358	0	444814009	40481087		0
45667	2712	4112343	1998-04-04	1998-04-04 00:00:00	1998-04-16	1998-04-16 00:00:00	32020		\N	179820	0	195662009	4112343		0
45859	2731	4112343	1963-05-01	1963-05-01 00:00:00	1963-05-10	1963-05-10 00:00:00	32020		\N	180745	0	195662009	4112343		0
46113	2747	260139	2019-04-30	2019-04-30 00:00:00	2019-05-07	2019-05-07 00:00:00	32020		\N	181678	0	10509002	260139		0
46216	2752	195588	1972-03-12	1972-03-12 00:00:00	1972-04-22	1972-04-22 00:00:00	32020		\N	182061	0	38822007	195588		0
46349	2760	372328	1961-12-23	1961-12-23 00:00:00	1962-03-08	1962-03-08 00:00:00	32020		\N	182563	0	65363002	372328		0
36011	2134	260139	1997-02-08	1997-02-08 00:00:00	1997-02-22	1997-02-22 00:00:00	32020		\N	142003	0	10509002	260139		0
46710	2779	372328	2019-05-19	2019-05-19 00:00:00	\N	\N	32020		\N	184133	0	65363002	372328		0
46846	2786	4109685	1966-03-16	1966-03-16 00:00:00	1966-03-30	1966-03-30 00:00:00	32020		\N	184611	0	284551006	4109685		0
47088	2801	378419	1996-07-05	1996-07-05 00:00:00	\N	\N	32020		\N	185644	0	26929004	378419		0
47198	2806	40481087	1978-02-03	1978-02-03 00:00:00	1978-02-17	1978-02-17 00:00:00	32020		\N	186004	0	444814009	40481087		0
47377	2818	40481087	1987-12-10	1987-12-10 00:00:00	1987-12-31	1987-12-31 00:00:00	32020		\N	186719	0	444814009	40481087		0
47532	2827	28060	1923-01-21	1923-01-21 00:00:00	1923-02-03	1923-02-03 00:00:00	32020		\N	187440	0	43878008	28060		0
37183	2202	40481087	1974-11-12	1974-11-12 00:00:00	1974-11-19	1974-11-19 00:00:00	32020		\N	146753	0	444814009	40481087		0
47835	2841	40481087	1988-01-27	1988-01-27 00:00:00	1988-02-10	1988-02-10 00:00:00	32020		\N	188590	0	444814009	40481087		0
48083	2853	40481087	1993-02-12	1993-02-12 00:00:00	1993-02-19	1993-02-19 00:00:00	32020		\N	189523	0	444814009	40481087		0
37679	2235	372328	1955-07-17	1955-07-17 00:00:00	1955-11-09	1955-11-09 00:00:00	32020		\N	148679	0	65363002	372328		0
37836	2242	80180	1964-09-16	1964-09-16 00:00:00	\N	\N	32020		\N	149249	0	396275006	80180		0
48581	2878	4112343	1998-05-13	1998-05-13 00:00:00	1998-05-23	1998-05-23 00:00:00	32020		\N	191462	0	195662009	4112343		0
48776	2890	40481087	2003-06-22	2003-06-22 00:00:00	2003-06-29	2003-06-29 00:00:00	32020		\N	192198	0	444814009	40481087		0
48850	2893	40481087	1964-09-15	1964-09-15 00:00:00	1964-09-22	1964-09-22 00:00:00	32020		\N	192455	0	444814009	40481087		0
49093	2905	372328	1971-08-04	1971-08-04 00:00:00	1971-11-08	1971-11-08 00:00:00	32020		\N	193544	0	65363002	372328		0
49278	2914	372328	1958-06-17	1958-06-17 00:00:00	1958-09-06	1958-09-06 00:00:00	32020		\N	194215	0	65363002	372328		0
49405	2921	372328	1940-07-18	1940-07-18 00:00:00	1940-09-24	1940-09-24 00:00:00	32020		\N	194698	0	65363002	372328		0
49521	2927	4266809	1982-07-03	1982-07-03 00:00:00	\N	\N	32020		\N	195265	0	397881000	4266809		0
49741	2943	4112343	1915-09-28	1915-09-28 00:00:00	1915-10-09	1915-10-09 00:00:00	32020		\N	196332	0	195662009	4112343		0
39311	2332	192671	1996-12-04	1996-12-04 00:00:00	\N	\N	32020		\N	155091	0	K92.2	35208414		0
50037	2957	4230399	2017-08-15	2017-08-15 00:00:00	2017-09-14	2017-09-14 00:00:00	32020		\N	197395	0	359817006	4230399		0
39647	2347	260139	1982-03-25	1982-03-25 00:00:00	1982-04-08	1982-04-08 00:00:00	32020		\N	156250	0	10509002	260139		0
50335	2976	260139	2013-07-04	2013-07-04 00:00:00	2013-07-11	2013-07-11 00:00:00	32020		\N	198728	0	10509002	260139		0
50518	2988	4112343	2011-10-04	2011-10-04 00:00:00	2011-10-13	2011-10-13 00:00:00	32020		\N	199444	0	195662009	4112343		0
50694	3000	4152936	1996-11-08	1996-11-08 00:00:00	1996-11-29	1996-11-29 00:00:00	32020		\N	200182	0	283385000	4152936		0
50828	3007	78272	1969-04-09	1969-04-09 00:00:00	1969-05-14	1969-05-14 00:00:00	32020		\N	200599	0	70704007	78272		0
40479	2404	4112343	2016-10-13	2016-10-13 00:00:00	2016-10-24	2016-10-24 00:00:00	32020		\N	159769	0	195662009	4112343		0
51245	3035	40481087	1979-07-07	1979-07-07 00:00:00	1979-07-14	1979-07-14 00:00:00	32020		\N	202181	0	444814009	40481087		0
51354	3047	81151	1989-04-28	1989-04-28 00:00:00	1989-05-26	1989-05-26 00:00:00	32020		\N	202741	0	44465007	81151		0
51501	3057	4155034	1992-02-13	1992-02-13 00:00:00	1992-03-05	1992-03-05 00:00:00	32020		\N	203387	0	283371005	4155034		0
51761	3069	375671	2008-02-12	2008-02-12 00:00:00	2008-04-12	2008-04-12 00:00:00	32020		\N	204315	0	62564004	375671		0
51872	3076	4146173	1983-02-15	1983-02-15 00:00:00	1983-03-17	1983-03-17 00:00:00	32020		\N	204637	0	307731004	4146173		0
52013	3081	40481087	1954-01-18	1954-01-18 00:00:00	1954-02-01	1954-02-01 00:00:00	32020		\N	205138	0	444814009	40481087		0
52173	3088	260139	1964-08-11	1964-08-11 00:00:00	1964-08-25	1964-08-25 00:00:00	32020		\N	205610	0	10509002	260139		0
41829	2487	260139	1980-11-17	1980-11-17 00:00:00	1980-12-01	1980-12-01 00:00:00	32020		\N	164802	0	10509002	260139		0
63107	3728	4059173	2007-07-30	2007-07-30 00:00:00	2007-09-28	2007-09-28 00:00:00	32020		\N	247697	0	16114001	4059173		0
52770	3125	4027663	1976-06-21	1976-06-21 00:00:00	\N	\N	32020		\N	207996	0	13200003	4027663		0
52928	3134	80180	1963-09-04	1963-09-04 00:00:00	\N	\N	32020		\N	208529	0	396275006	80180		0
53109	3145	40481087	1984-04-15	1984-04-15 00:00:00	1984-05-06	1984-05-06 00:00:00	32020		\N	209293	0	444814009	40481087		0
42565	2537	40481087	1990-06-22	1990-06-22 00:00:00	1990-06-29	1990-06-29 00:00:00	32020		\N	167721	0	444814009	40481087		0
42816	2551	40481087	1976-03-09	1976-03-09 00:00:00	1976-03-16	1976-03-16 00:00:00	32020		\N	168908	0	444814009	40481087		0
42924	2555	40481087	1998-12-21	1998-12-21 00:00:00	1999-01-04	1999-01-04 00:00:00	32020		\N	169341	0	444814009	40481087		0
43067	2564	440086	1986-08-19	1986-08-19 00:00:00	1989-02-28	1989-02-28 00:00:00	32020		\N	169898	0	192127007	440086		0
32684	1941	372328	1973-03-17	1973-03-17 00:00:00	1973-05-24	1973-05-24 00:00:00	32020		\N	129092	0	65363002	372328		0
43446	2588	261325	2012-10-14	2012-10-14 00:00:00	\N	\N	32020		\N	171263	0	87433001	261325		0
33028	1960	81893	1969-08-22	1969-08-22 00:00:00	\N	\N	32020		\N	130339	0	64766004	81893		0
43707	2602	260139	1959-08-18	1959-08-18 00:00:00	1959-08-25	1959-08-25 00:00:00	32020		\N	172106	0	10509002	260139		0
43855	2611	4113008	2016-08-27	2016-08-27 00:00:00	2016-09-17	2016-09-17 00:00:00	32020		\N	172655	0	284549007	4113008		0
44064	2621	40481087	1986-11-07	1986-11-07 00:00:00	1986-11-21	1986-11-21 00:00:00	32020		\N	173352	0	444814009	40481087		0
44179	2626	28060	2003-12-20	2003-12-20 00:00:00	2004-01-02	2004-01-02 00:00:00	32020		\N	173716	0	43878008	28060		0
44344	2636	4218389	1975-06-26	1975-06-26 00:00:00	1975-07-31	1975-07-31 00:00:00	32020		\N	174418	0	39848009	4218389		0
44606	2654	4283893	1959-07-12	1959-07-12 00:00:00	1959-08-02	1959-08-02 00:00:00	32020		\N	175686	0	36971009	4283893		0
44729	2661	4112343	2009-07-05	2009-07-05 00:00:00	2009-07-16	2009-07-16 00:00:00	32020		\N	176312	0	195662009	4112343		0
44898	2672	40481087	1991-02-09	1991-02-09 00:00:00	1991-03-02	1991-03-02 00:00:00	32020		\N	177043	0	444814009	40481087		0
45108	2684	4294548	1998-12-13	1998-12-13 00:00:00	1999-02-14	1999-02-14 00:00:00	32020		\N	177823	0	75498004	4294548		0
34682	2060	260139	1964-02-04	1964-02-04 00:00:00	1964-02-18	1964-02-18 00:00:00	32020		\N	136995	0	10509002	260139		0
45462	2703	372328	1977-07-15	1977-07-15 00:00:00	1977-08-07	1977-08-07 00:00:00	32020		\N	179085	0	65363002	372328		0
45558	2708	80180	1988-10-16	1988-10-16 00:00:00	\N	\N	32020		\N	179431	0	396275006	80180		0
45668	2712	4278672	1968-01-09	1968-01-09 00:00:00	1968-02-08	1968-02-08 00:00:00	32020		\N	179881	0	65966004	4278672		0
45860	2731	4156265	1977-07-01	1977-07-01 00:00:00	1977-07-15	1977-07-15 00:00:00	32020		\N	180819	0	370247008	4156265		0
46114	2747	40481087	2013-11-10	2013-11-10 00:00:00	2013-11-24	2013-11-24 00:00:00	32020		\N	181661	0	444814009	40481087		0
46217	2752	372328	1952-06-10	1952-06-10 00:00:00	1952-08-24	1952-08-24 00:00:00	32020		\N	182106	0	65363002	372328		0
46350	2760	4294548	2007-07-07	2007-07-07 00:00:00	2007-08-25	2007-08-25 00:00:00	32020		\N	182559	0	75498004	4294548		0
36012	2134	4218389	2000-08-14	2000-08-14 00:00:00	2000-09-11	2000-09-11 00:00:00	32020		\N	141964	0	39848009	4218389		0
46711	2779	4218389	2005-03-16	2005-03-16 00:00:00	2005-04-13	2005-04-13 00:00:00	32020		\N	184099	0	39848009	4218389		0
46847	2786	4283893	1924-03-01	1924-03-01 00:00:00	1924-04-26	1924-04-26 00:00:00	32020		\N	184632	0	36971009	4283893		0
47089	2801	4218389	1928-02-21	1928-02-21 00:00:00	1928-03-20	1928-03-20 00:00:00	32020		\N	185604	0	39848009	4218389		0
47199	2806	260139	1985-02-28	1985-02-28 00:00:00	1985-03-14	1985-03-14 00:00:00	32020		\N	185992	0	10509002	260139		0
47378	2818	260139	2014-03-16	2014-03-16 00:00:00	2014-03-23	2014-03-23 00:00:00	32020		\N	186771	0	10509002	260139		0
47533	2827	378419	1990-10-30	1990-10-30 00:00:00	\N	\N	32020		\N	187529	0	26929004	378419		0
37184	2202	40481087	2018-05-26	2018-05-26 00:00:00	2018-06-02	2018-06-02 00:00:00	32020		\N	146775	0	444814009	40481087		0
47836	2841	4218389	1979-12-14	1979-12-14 00:00:00	1980-01-11	1980-01-11 00:00:00	32020		\N	188632	0	39848009	4218389		0
48084	2853	40481087	2008-06-18	2008-06-18 00:00:00	2008-07-02	2008-07-02 00:00:00	32020		\N	189514	0	444814009	40481087		0
37680	2235	81151	1968-11-03	1968-11-03 00:00:00	1968-12-01	1968-12-01 00:00:00	32020		\N	148637	0	44465007	81151		0
37837	2242	40481087	2003-06-24	2003-06-24 00:00:00	2003-07-15	2003-07-15 00:00:00	32020		\N	149237	0	444814009	40481087		0
48582	2878	28060	1986-10-16	1986-10-16 00:00:00	1986-10-29	1986-10-29 00:00:00	32020		\N	191459	0	43878008	28060		0
48777	2890	260139	1985-01-08	1985-01-08 00:00:00	1985-01-15	1985-01-15 00:00:00	32020		\N	192201	0	10509002	260139		0
48851	2893	4112343	1999-08-14	1999-08-14 00:00:00	1999-08-27	1999-08-27 00:00:00	32020		\N	192504	0	195662009	4112343		0
49094	2905	260139	1995-08-29	1995-08-29 00:00:00	1995-09-12	1995-09-12 00:00:00	32020		\N	193598	0	10509002	260139		0
49279	2914	30753	1996-05-13	1996-05-13 00:00:00	\N	\N	32020		\N	194161	0	16761005	30753		0
49406	2921	40481087	1995-12-24	1995-12-24 00:00:00	1995-12-31	1995-12-31 00:00:00	32020		\N	194724	0	444814009	40481087		0
49522	2927	80180	1982-07-03	1982-07-03 00:00:00	\N	\N	32020		\N	195265	0	396275006	80180		0
49742	2943	4156265	1936-08-16	1936-08-16 00:00:00	1936-09-06	1936-09-06 00:00:00	32020		\N	196247	0	370247008	4156265		0
39312	2332	260139	1957-05-21	1957-05-21 00:00:00	1957-06-04	1957-06-04 00:00:00	32020		\N	155046	0	10509002	260139		0
50038	2957	40480160	2017-08-15	2017-08-15 00:00:00	2017-09-14	2017-09-14 00:00:00	32020		\N	197395	0	443165006	40480160		0
39648	2347	40481087	1994-04-03	1994-04-03 00:00:00	1994-04-17	1994-04-17 00:00:00	32020		\N	156225	0	444814009	40481087		0
50336	2976	260139	2011-05-06	2011-05-06 00:00:00	2011-05-20	2011-05-20 00:00:00	32020		\N	198736	0	10509002	260139		0
50519	2988	4109685	2008-12-01	2008-12-01 00:00:00	2008-12-15	2008-12-15 00:00:00	32020		\N	199429	0	284551006	4109685		0
50695	3000	81151	2010-04-20	2010-04-20 00:00:00	2010-05-25	2010-05-25 00:00:00	32020		\N	200183	0	44465007	81151		0
50829	3007	40481087	2011-04-08	2011-04-08 00:00:00	2011-04-15	2011-04-15 00:00:00	32020		\N	200638	0	444814009	40481087		0
40480	2404	81151	1975-12-04	1975-12-04 00:00:00	1975-12-18	1975-12-18 00:00:00	32020		\N	159760	0	44465007	81151		0
51246	3035	4112343	1984-04-17	1984-04-17 00:00:00	1984-04-26	1984-04-26 00:00:00	32020		\N	202173	0	195662009	4112343		0
51355	3047	4112343	1990-06-10	1990-06-10 00:00:00	1990-06-21	1990-06-21 00:00:00	32020		\N	202721	0	195662009	4112343		0
51502	3057	4296204	2004-10-28	2004-10-28 00:00:00	2004-11-11	2004-11-11 00:00:00	32020		\N	203388	0	403190006	4296204		0
51762	3069	4155034	1997-04-26	1997-04-26 00:00:00	1997-05-10	1997-05-10 00:00:00	32020		\N	204314	0	283371005	4155034		0
51873	3076	81151	2010-12-07	2010-12-07 00:00:00	2011-01-04	2011-01-04 00:00:00	32020		\N	204647	0	44465007	81151		0
52014	3081	40481087	1979-06-17	1979-06-17 00:00:00	1979-07-08	1979-07-08 00:00:00	32020		\N	205098	0	444814009	40481087		0
52174	3088	4113008	1963-06-07	1963-06-07 00:00:00	1963-06-21	1963-06-21 00:00:00	32020		\N	205636	0	284549007	4113008		0
41830	2487	260139	1986-05-17	1986-05-17 00:00:00	1986-05-24	1986-05-24 00:00:00	32020		\N	164761	0	10509002	260139		0
63108	3728	4112343	1984-06-13	1984-06-13 00:00:00	1984-06-21	1984-06-21 00:00:00	32020		\N	247698	0	195662009	4112343		0
52771	3125	372328	1976-05-29	1976-05-29 00:00:00	1976-09-23	1976-09-23 00:00:00	32020		\N	207996	0	65363002	372328		0
52929	3134	40481087	2017-09-02	2017-09-02 00:00:00	2017-09-16	2017-09-16 00:00:00	32020		\N	208580	0	444814009	40481087		0
53110	3145	40481087	1988-10-19	1988-10-19 00:00:00	1988-11-02	1988-11-02 00:00:00	32020		\N	209266	0	444814009	40481087		0
42582	2540	192671	1975-01-29	1975-01-29 00:00:00	\N	\N	32020		\N	167926	0	K92.2	35208414		0
42817	2551	40481087	1964-10-25	1964-10-25 00:00:00	1964-11-08	1964-11-08 00:00:00	32020		\N	168895	0	444814009	40481087		0
42925	2555	40481087	2011-04-07	2011-04-07 00:00:00	2011-04-28	2011-04-28 00:00:00	32020		\N	169343	0	444814009	40481087		0
43068	2564	40481087	1991-03-24	1991-03-24 00:00:00	1991-04-07	1991-04-07 00:00:00	32020		\N	169887	0	444814009	40481087		0
32685	1941	40481087	1997-12-27	1997-12-27 00:00:00	1998-01-10	1998-01-10 00:00:00	32020		\N	129103	0	444814009	40481087		0
43447	2588	4112343	1993-07-02	1993-07-02 00:00:00	1993-07-10	1993-07-10 00:00:00	32020		\N	171265	0	195662009	4112343		0
33029	1960	40481087	1958-08-14	1958-08-14 00:00:00	1958-08-28	1958-08-28 00:00:00	32020		\N	130323	0	444814009	40481087		0
43708	2602	4027663	1979-09-22	1979-09-22 00:00:00	\N	\N	32020		\N	172125	0	13200003	4027663		0
43856	2611	4112343	1953-11-06	1953-11-06 00:00:00	1953-11-17	1953-11-17 00:00:00	32020		\N	172682	0	195662009	4112343		0
44065	2621	4112343	2006-11-13	2006-11-13 00:00:00	2006-11-25	2006-11-25 00:00:00	32020		\N	173395	0	195662009	4112343		0
44217	2630	4134304	2013-03-30	2013-03-30 00:00:00	2013-04-29	2013-04-29 00:00:00	32020		\N	173997	0	263102004	4134304		0
44345	2636	40481087	2010-07-16	2010-07-16 00:00:00	2010-07-23	2010-07-23 00:00:00	32020		\N	174424	0	444814009	40481087		0
44607	2654	40481087	1974-02-18	1974-02-18 00:00:00	1974-02-25	1974-02-25 00:00:00	32020		\N	175701	0	444814009	40481087		0
44730	2661	4296204	1969-06-17	1969-06-17 00:00:00	1969-07-08	1969-07-08 00:00:00	32020		\N	176281	0	403190006	4296204		0
44899	2672	81893	1993-07-13	1993-07-13 00:00:00	\N	\N	32020		\N	176924	0	64766004	81893		0
45109	2684	4112343	2012-04-18	2012-04-18 00:00:00	2012-04-29	2012-04-29 00:00:00	32020		\N	177888	0	195662009	4112343		0
34683	2060	195588	1996-11-25	1996-11-25 00:00:00	1997-01-03	1997-01-03 00:00:00	32020		\N	136998	0	38822007	195588		0
45463	2703	4283893	1974-07-06	1974-07-06 00:00:00	1974-11-09	1974-11-09 00:00:00	32020		\N	179049	0	36971009	4283893		0
45559	2708	4155034	1987-05-17	1987-05-17 00:00:00	1987-06-07	1987-06-07 00:00:00	32020		\N	179431	0	283371005	4155034		0
45688	2715	4218389	1971-08-20	1971-08-20 00:00:00	1971-09-10	1971-09-10 00:00:00	32020		\N	179966	0	39848009	4218389		0
45861	2731	260139	1964-02-22	1964-02-22 00:00:00	1964-03-07	1964-03-07 00:00:00	32020		\N	180820	0	10509002	260139		0
46115	2747	40481087	1999-05-30	1999-05-30 00:00:00	1999-06-06	1999-06-06 00:00:00	32020		\N	181658	0	444814009	40481087		0
46218	2752	372328	1960-01-15	1960-01-15 00:00:00	1960-08-14	1960-08-14 00:00:00	32020		\N	182024	0	65363002	372328		0
46351	2760	40481087	2011-01-15	2011-01-15 00:00:00	2011-01-22	2011-01-22 00:00:00	32020		\N	182537	0	444814009	40481087		0
36013	2134	378001	1989-01-14	1989-01-14 00:00:00	1989-02-13	1989-02-13 00:00:00	32020		\N	141962	0	62106007	378001		0
46712	2779	4278672	1976-11-13	1976-11-13 00:00:00	1977-01-12	1977-01-12 00:00:00	32020		\N	184098	0	65966004	4278672		0
46848	2786	378419	2002-10-12	2002-10-12 00:00:00	\N	\N	32020		\N	184597	0	26929004	378419		0
47090	2801	4059173	2002-03-25	2002-03-25 00:00:00	\N	\N	32020		\N	185617	0	16114001	4059173		0
47200	2806	40481087	2013-07-22	2013-07-22 00:00:00	2013-08-05	2013-08-05 00:00:00	32020		\N	186008	0	444814009	40481087		0
47379	2818	4112343	2010-03-13	2010-03-13 00:00:00	2010-03-20	2010-03-20 00:00:00	32020		\N	186722	0	195662009	4112343		0
47534	2827	4296204	1936-11-04	1936-11-04 00:00:00	1936-12-02	1936-12-02 00:00:00	32020		\N	187509	0	403190006	4296204		0
47643	2832	40481087	1995-04-10	1995-04-10 00:00:00	1995-04-17	1995-04-17 00:00:00	32020		\N	188007	0	444814009	40481087		0
47837	2842	260139	2017-02-12	2017-02-12 00:00:00	2017-02-26	2017-02-26 00:00:00	32020		\N	188667	0	10509002	260139		0
48085	2853	80180	1999-06-13	1999-06-13 00:00:00	\N	\N	32020		\N	189552	0	396275006	80180		0
37838	2242	40481087	1977-07-06	1977-07-06 00:00:00	1977-07-20	1977-07-20 00:00:00	32020		\N	149220	0	444814009	40481087		0
48583	2878	40481087	1997-01-06	1997-01-06 00:00:00	1997-01-13	1997-01-13 00:00:00	32020		\N	191461	0	444814009	40481087		0
48778	2890	4112343	2015-03-16	2015-03-16 00:00:00	2015-03-24	2015-03-24 00:00:00	32020		\N	192223	0	195662009	4112343		0
48852	2893	4001336	1957-07-09	1957-07-09 00:00:00	1957-09-07	1957-09-07 00:00:00	32020		\N	192519	0	110030002	4001336		0
49095	2905	372328	1972-01-07	1972-01-07 00:00:00	1972-11-13	1972-11-13 00:00:00	32020		\N	193564	0	65363002	372328		0
49280	2914	81893	1995-06-18	1995-06-18 00:00:00	\N	\N	32020		\N	194161	0	64766004	81893		0
49407	2921	258780	1975-06-10	1975-06-10 00:00:00	\N	\N	32020		\N	194754	0	185086009	258780		0
49523	2927	4027663	1975-04-16	1975-04-16 00:00:00	\N	\N	32020		\N	195246	0	13200003	4027663		0
49743	2943	40481087	1946-03-14	1946-03-14 00:00:00	1946-03-28	1946-03-28 00:00:00	32020		\N	196291	0	444814009	40481087		0
39313	2332	40481087	1960-04-05	1960-04-05 00:00:00	1960-04-19	1960-04-19 00:00:00	32020		\N	155061	0	444814009	40481087		0
50039	2957	40481087	1996-02-14	1996-02-14 00:00:00	1996-03-06	1996-03-06 00:00:00	32020		\N	197345	0	444814009	40481087		0
39649	2347	4310024	2010-01-21	2010-01-21 00:00:00	\N	\N	32020		\N	156244	0	424802006	4310024		0
50337	2976	4112343	1984-03-02	1984-03-02 00:00:00	1984-03-15	1984-03-15 00:00:00	32020		\N	198726	0	195662009	4112343		0
50520	2988	4027663	1990-06-03	1990-06-03 00:00:00	\N	\N	32020		\N	199453	0	13200003	4027663		0
50696	3000	4112343	1961-07-18	1961-07-18 00:00:00	1961-07-30	1961-07-30 00:00:00	32020		\N	200185	0	195662009	4112343		0
50830	3007	4112343	1968-07-02	1968-07-02 00:00:00	1968-07-13	1968-07-13 00:00:00	32020		\N	200637	0	195662009	4112343		0
40481	2404	28060	1979-11-07	1979-11-07 00:00:00	1979-11-16	1979-11-16 00:00:00	32020		\N	159712	0	43878008	28060		0
51274	3040	440086	1984-02-21	1984-02-21 00:00:00	1990-03-01	1990-03-01 00:00:00	32020		\N	202372	0	192127007	440086		0
51356	3047	257012	2002-08-24	2002-08-24 00:00:00	2002-11-16	2002-11-16 00:00:00	32020		\N	202754	0	40055000	257012		0
51503	3057	4112343	1995-03-28	1995-03-28 00:00:00	1995-04-10	1995-04-10 00:00:00	32020		\N	203380	0	195662009	4112343		0
51763	3069	4112343	1966-09-20	1966-09-20 00:00:00	1966-10-02	1966-10-02 00:00:00	32020		\N	204244	0	195662009	4112343		0
51874	3076	4278672	1967-07-27	1967-07-27 00:00:00	1967-08-26	1967-08-26 00:00:00	32020		\N	204641	0	65966004	4278672		0
52015	3081	40481087	1949-02-15	1949-02-15 00:00:00	1949-03-08	1949-03-08 00:00:00	32020		\N	205155	0	444814009	40481087		0
52175	3088	40481087	2014-01-12	2014-01-12 00:00:00	2014-02-02	2014-02-02 00:00:00	32020		\N	205685	0	444814009	40481087		0
41831	2487	4112343	1963-08-19	1963-08-19 00:00:00	1963-08-28	1963-08-28 00:00:00	32020		\N	164787	0	195662009	4112343		0
63109	3728	81151	1987-08-09	1987-08-09 00:00:00	1987-08-23	1987-08-23 00:00:00	32020		\N	247752	0	44465007	81151		0
52772	3125	81151	1986-12-22	1986-12-22 00:00:00	1987-01-19	1987-01-19 00:00:00	32020		\N	208007	0	44465007	81151		0
52930	3134	40481087	2001-08-18	2001-08-18 00:00:00	2001-09-01	2001-09-01 00:00:00	32020		\N	208563	0	444814009	40481087		0
53111	3145	4112343	1973-04-19	1973-04-19 00:00:00	1973-04-30	1973-04-30 00:00:00	32020		\N	209262	0	195662009	4112343		0
42583	2540	4156265	1996-11-04	1996-11-04 00:00:00	1996-11-25	1996-11-25 00:00:00	32020		\N	167989	0	370247008	4156265		0
42818	2551	4056621	2000-10-29	2000-10-29 00:00:00	\N	\N	32020		\N	168898	0	197927001	4056621		0
42926	2555	40481087	1971-10-13	1971-10-13 00:00:00	1971-10-20	1971-10-20 00:00:00	32020		\N	169288	0	444814009	40481087		0
43069	2564	40481087	2015-04-19	2015-04-19 00:00:00	2015-05-10	2015-05-10 00:00:00	32020		\N	169892	0	444814009	40481087		0
32686	1941	4059173	1988-12-14	1988-12-14 00:00:00	1989-01-13	1989-01-13 00:00:00	32020		\N	129100	0	16114001	4059173		0
43448	2588	4112343	1994-11-17	1994-11-17 00:00:00	1994-11-27	1994-11-27 00:00:00	32020		\N	171246	0	195662009	4112343		0
33030	1960	195588	1951-07-03	1951-07-03 00:00:00	1951-08-21	1951-08-21 00:00:00	32020		\N	130322	0	38822007	195588		0
43709	2603	4294548	2019-05-13	2019-05-13 00:00:00	2019-06-03	2019-06-03 00:00:00	32020		\N	172185	0	75498004	4294548		0
43857	2611	260139	1961-07-04	1961-07-04 00:00:00	1961-07-18	1961-07-18 00:00:00	32020		\N	172683	0	10509002	260139		0
44066	2621	28060	1957-12-04	1957-12-04 00:00:00	1957-12-17	1957-12-17 00:00:00	32020		\N	173350	0	43878008	28060		0
44218	2630	40481087	1973-09-15	1973-09-15 00:00:00	1973-10-06	1973-10-06 00:00:00	32020		\N	173946	0	444814009	40481087		0
44346	2636	4112343	1962-10-05	1962-10-05 00:00:00	1962-10-14	1962-10-14 00:00:00	32020		\N	174464	0	195662009	4112343		0
44608	2654	372328	1949-11-02	1949-11-02 00:00:00	1950-10-26	1950-10-26 00:00:00	32020		\N	175661	0	65363002	372328		0
44731	2661	40481087	1998-11-19	1998-11-19 00:00:00	1998-12-10	1998-12-10 00:00:00	32020		\N	176280	0	444814009	40481087		0
44900	2672	4285898	1994-06-08	1994-06-08 00:00:00	\N	\N	32020		\N	176924	0	68496003	4285898		0
45110	2684	260139	1985-06-07	1985-06-07 00:00:00	1985-06-21	1985-06-21 00:00:00	32020		\N	177885	0	10509002	260139		0
34684	2060	80180	2009-09-08	2009-09-08 00:00:00	\N	\N	32020		\N	136999	0	396275006	80180		0
45464	2703	40481087	1984-11-26	1984-11-26 00:00:00	1984-12-03	1984-12-03 00:00:00	32020		\N	179097	0	444814009	40481087		0
45560	2708	4146173	2002-03-30	2002-03-30 00:00:00	2002-04-29	2002-04-29 00:00:00	32020		\N	179422	0	307731004	4146173		0
45689	2715	40481087	2006-01-03	2006-01-03 00:00:00	2006-01-17	2006-01-17 00:00:00	32020		\N	180047	0	444814009	40481087		0
45862	2731	195588	2008-06-29	2008-06-29 00:00:00	2008-08-05	2008-08-05 00:00:00	32020		\N	180758	0	38822007	195588		0
46116	2747	28060	1995-09-30	1995-09-30 00:00:00	1995-10-10	1995-10-10 00:00:00	32020		\N	181694	0	43878008	28060		0
46219	2752	28060	2008-06-09	2008-06-09 00:00:00	2008-06-20	2008-06-20 00:00:00	32020		\N	182063	0	43878008	28060		0
46352	2760	4237458	1970-07-16	1970-07-16 00:00:00	1970-10-14	1970-10-14 00:00:00	32020		\N	182593	0	58150001	4237458		0
36014	2135	4112343	2006-10-10	2006-10-10 00:00:00	2006-10-18	2006-10-18 00:00:00	32020		\N	142096	0	195662009	4112343		0
46713	2779	40481087	1992-05-31	1992-05-31 00:00:00	1992-06-21	1992-06-21 00:00:00	32020		\N	184091	0	444814009	40481087		0
46849	2786	40481087	1944-03-30	1944-03-30 00:00:00	1944-04-20	1944-04-20 00:00:00	32020		\N	184536	0	444814009	40481087		0
47091	2801	28060	1926-04-30	1926-04-30 00:00:00	1926-05-08	1926-05-08 00:00:00	32020		\N	185639	0	43878008	28060		0
47201	2806	4116491	1987-04-08	1987-04-08 00:00:00	1987-05-19	1987-05-19 00:00:00	32020		\N	185975	0	301011002	4116491		0
47380	2818	4296204	1971-11-18	1971-11-18 00:00:00	1971-12-02	1971-12-02 00:00:00	32020		\N	186727	0	403190006	4296204		0
47535	2827	40481087	1941-01-11	1941-01-11 00:00:00	1941-02-01	1941-02-01 00:00:00	32020		\N	187442	0	444814009	40481087		0
47644	2832	4294548	2015-07-13	2015-07-13 00:00:00	2015-08-31	2015-08-31 00:00:00	32020		\N	187987	0	75498004	4294548		0
47838	2842	40481087	2001-07-25	2001-07-25 00:00:00	2001-08-08	2001-08-08 00:00:00	32020		\N	188698	0	444814009	40481087		0
48086	2853	40481087	2009-03-06	2009-03-06 00:00:00	2009-03-20	2009-03-20 00:00:00	32020		\N	189534	0	444814009	40481087		0
37682	2235	81893	1982-01-26	1982-01-26 00:00:00	\N	\N	32020		\N	148670	0	64766004	81893		0
37839	2242	81151	1939-08-04	1939-08-04 00:00:00	1939-09-08	1939-09-08 00:00:00	32020		\N	149263	0	44465007	81151		0
48584	2878	4266809	2019-04-02	2019-04-02 00:00:00	\N	\N	32020		\N	191453	0	397881000	4266809		0
48779	2890	80180	2001-12-13	2001-12-13 00:00:00	\N	\N	32020		\N	192220	0	396275006	80180		0
48853	2893	40481087	1990-05-20	1990-05-20 00:00:00	1990-06-03	1990-06-03 00:00:00	32020		\N	192543	0	444814009	40481087		0
49096	2905	4112343	2010-08-23	2010-08-23 00:00:00	2010-08-31	2010-08-31 00:00:00	32020		\N	193563	0	195662009	4112343		0
49281	2914	4112343	1960-05-10	1960-05-10 00:00:00	1960-05-18	1960-05-18 00:00:00	32020		\N	194190	0	195662009	4112343		0
49408	2921	40481087	1991-05-27	1991-05-27 00:00:00	1991-06-10	1991-06-10 00:00:00	32020		\N	194709	0	444814009	40481087		0
54648	3236	80180	1958-05-12	1958-05-12 00:00:00	\N	\N	32020		\N	215045	0	396275006	80180		0
49535	2929	260139	2004-10-05	2004-10-05 00:00:00	2004-10-19	2004-10-19 00:00:00	32020		\N	195412	0	10509002	260139		0
49744	2943	4294548	1916-09-12	1916-09-12 00:00:00	1916-10-24	1916-10-24 00:00:00	32020		\N	196337	0	75498004	4294548		0
39314	2332	260139	1960-06-11	1960-06-11 00:00:00	1960-06-20	1960-06-20 00:00:00	32020		\N	155061	0	10509002	260139		0
50040	2957	40481087	1967-01-13	1967-01-13 00:00:00	1967-01-20	1967-01-20 00:00:00	32020		\N	197352	0	444814009	40481087		0
39650	2347	4237458	1974-03-06	1974-03-06 00:00:00	1974-05-05	1974-05-05 00:00:00	32020		\N	156221	0	58150001	4237458		0
50371	2980	4112343	1977-02-21	1977-02-21 00:00:00	1977-03-02	1977-03-02 00:00:00	32020		\N	198959	0	195662009	4112343		0
50521	2988	4285898	2000-09-18	2000-09-18 00:00:00	\N	\N	32020		\N	199431	0	68496003	4285898		0
50697	3000	40481087	2010-01-22	2010-01-22 00:00:00	2010-01-29	2010-01-29 00:00:00	32020		\N	200232	0	444814009	40481087		0
50831	3007	4112343	1977-02-09	1977-02-09 00:00:00	1977-02-22	1977-02-22 00:00:00	32020		\N	200586	0	195662009	4112343		0
40482	2404	81151	1974-01-22	1974-01-22 00:00:00	1974-02-12	1974-02-12 00:00:00	32020		\N	159759	0	44465007	81151		0
51275	3040	40481087	2017-08-24	2017-08-24 00:00:00	2017-09-14	2017-09-14 00:00:00	32020		\N	202387	0	444814009	40481087		0
51357	3047	260139	1993-09-28	1993-09-28 00:00:00	1993-10-05	1993-10-05 00:00:00	32020		\N	202753	0	10509002	260139		0
51504	3057	81151	1978-06-28	1978-06-28 00:00:00	1978-07-26	1978-07-26 00:00:00	32020		\N	203386	0	44465007	81151		0
51764	3069	4156265	1968-02-11	1968-02-11 00:00:00	1968-03-03	1968-03-03 00:00:00	32020		\N	204308	0	370247008	4156265		0
51875	3076	4113008	1978-04-21	1978-04-21 00:00:00	1978-05-12	1978-05-12 00:00:00	32020		\N	204643	0	284549007	4113008		0
52016	3081	375671	1990-07-27	1990-07-27 00:00:00	1990-09-25	1990-09-25 00:00:00	32020		\N	205137	0	62564004	375671		0
52176	3088	40481087	1955-09-06	1955-09-06 00:00:00	1955-09-13	1955-09-13 00:00:00	32020		\N	205617	0	444814009	40481087		0
52291	3096	372328	1964-10-17	1964-10-17 00:00:00	1964-11-29	1964-11-29 00:00:00	32020		\N	206102	0	65363002	372328		0
63110	3728	260139	2012-05-03	2012-05-03 00:00:00	2012-05-17	2012-05-17 00:00:00	32020		\N	247719	0	10509002	260139		0
52773	3125	80180	1985-01-05	1985-01-05 00:00:00	\N	\N	32020		\N	207976	0	396275006	80180		0
52931	3134	40481087	2005-02-07	2005-02-07 00:00:00	2005-02-28	2005-02-28 00:00:00	32020		\N	208565	0	444814009	40481087		0
53112	3145	4278672	1976-03-01	1976-03-01 00:00:00	1976-05-30	1976-05-30 00:00:00	32020		\N	209301	0	65966004	4278672		0
42584	2540	81151	1962-08-04	1962-08-04 00:00:00	1962-08-25	1962-08-25 00:00:00	32020		\N	167985	0	44465007	81151		0
42819	2551	4116491	2000-10-29	2000-10-29 00:00:00	2000-12-11	2000-12-11 00:00:00	32020		\N	168898	0	301011002	4116491		0
42927	2555	4283893	1986-11-02	1986-11-02 00:00:00	1987-01-25	1987-01-25 00:00:00	32020		\N	169362	0	36971009	4283893		0
43075	2566	4112343	1943-09-05	1943-09-05 00:00:00	1943-09-14	1943-09-14 00:00:00	32020		\N	170006	0	195662009	4112343		0
32687	1941	260139	1995-03-13	1995-03-13 00:00:00	1995-03-27	1995-03-27 00:00:00	32020		\N	129037	0	10509002	260139		0
43449	2588	28060	1994-09-04	1994-09-04 00:00:00	1994-09-17	1994-09-17 00:00:00	32020		\N	171245	0	43878008	28060		0
33031	1960	40481087	1939-03-10	1939-03-10 00:00:00	1939-03-17	1939-03-17 00:00:00	32020		\N	130318	0	444814009	40481087		0
43710	2603	28060	1965-09-16	1965-09-16 00:00:00	1965-09-28	1965-09-28 00:00:00	32020		\N	172168	0	43878008	28060		0
43858	2611	28060	1974-07-14	1974-07-14 00:00:00	1974-07-27	1974-07-27 00:00:00	32020		\N	172645	0	43878008	28060		0
44067	2621	4112343	1957-01-24	1957-01-24 00:00:00	1957-02-06	1957-02-06 00:00:00	32020		\N	173331	0	195662009	4112343		0
44219	2630	260139	2007-09-18	2007-09-18 00:00:00	2007-09-25	2007-09-25 00:00:00	32020		\N	173935	0	10509002	260139		0
44347	2636	4329847	2019-03-08	2019-03-08 00:00:00	\N	\N	32020		\N	174490	0	22298006	4329847		0
44609	2654	81151	1945-06-26	1945-06-26 00:00:00	1945-07-31	1945-07-31 00:00:00	32020		\N	175720	0	44465007	81151		0
44732	2661	80180	2005-01-19	2005-01-19 00:00:00	\N	\N	32020		\N	176343	0	396275006	80180		0
44901	2672	30753	1994-04-09	1994-04-09 00:00:00	\N	\N	32020		\N	176924	0	16761005	30753		0
45111	2684	4218389	1999-06-28	1999-06-28 00:00:00	1999-07-26	1999-07-26 00:00:00	32020		\N	177895	0	39848009	4218389		0
34685	2060	40481087	1977-12-12	1977-12-12 00:00:00	1977-12-26	1977-12-26 00:00:00	32020		\N	136997	0	444814009	40481087		0
45465	2703	40481087	1987-12-25	1987-12-25 00:00:00	1988-01-15	1988-01-15 00:00:00	32020		\N	179098	0	444814009	40481087		0
45561	2708	260139	1959-07-12	1959-07-12 00:00:00	1959-07-26	1959-07-26 00:00:00	32020		\N	179349	0	10509002	260139		0
45691	2715	40481087	2003-08-24	2003-08-24 00:00:00	2003-09-07	2003-09-07 00:00:00	32020		\N	180015	0	444814009	40481087		0
45863	2731	260139	1986-09-21	1986-09-21 00:00:00	1986-10-05	1986-10-05 00:00:00	32020		\N	180742	0	10509002	260139		0
46117	2747	28060	1980-10-28	1980-10-28 00:00:00	1980-11-04	1980-11-04 00:00:00	32020		\N	181715	0	43878008	28060		0
46220	2752	40481087	1986-02-22	1986-02-22 00:00:00	1986-03-01	1986-03-01 00:00:00	32020		\N	182103	0	444814009	40481087		0
46353	2760	40481087	1978-08-25	1978-08-25 00:00:00	1978-09-01	1978-09-01 00:00:00	32020		\N	182591	0	444814009	40481087		0
36015	2135	81151	2004-05-09	2004-05-09 00:00:00	2004-05-30	2004-05-30 00:00:00	32020		\N	142104	0	44465007	81151		0
46714	2779	40481087	2013-11-22	2013-11-22 00:00:00	2013-12-06	2013-12-06 00:00:00	32020		\N	184157	0	444814009	40481087		0
46850	2786	257012	1924-03-15	1924-03-15 00:00:00	\N	\N	32020		\N	184582	0	40055000	257012		0
47092	2801	255848	2002-04-05	2002-04-05 00:00:00	\N	\N	32020		\N	185618	0	233604007	255848		0
47202	2806	80180	1996-03-21	1996-03-21 00:00:00	\N	\N	32020		\N	185932	0	396275006	80180		0
47381	2818	4296204	1969-11-23	1969-11-23 00:00:00	1969-12-28	1969-12-28 00:00:00	32020		\N	186726	0	403190006	4296204		0
47536	2827	4112343	1952-08-06	1952-08-06 00:00:00	1952-08-15	1952-08-15 00:00:00	32020		\N	187470	0	195662009	4112343		0
47645	2832	40481087	1976-05-24	1976-05-24 00:00:00	1976-06-07	1976-06-07 00:00:00	32020		\N	187883	0	444814009	40481087		0
47839	2842	4112343	1985-03-02	1985-03-02 00:00:00	1985-03-09	1985-03-09 00:00:00	32020		\N	188645	0	195662009	4112343		0
48087	2853	4112343	1995-11-27	1995-11-27 00:00:00	1995-12-06	1995-12-06 00:00:00	32020		\N	189507	0	195662009	4112343		0
48141	2858	40481087	2005-01-25	2005-01-25 00:00:00	2005-02-01	2005-02-01 00:00:00	32020		\N	189815	0	444814009	40481087		0
37840	2242	381316	2013-12-21	2013-12-21 00:00:00	\N	\N	32020		\N	149279	0	230690007	381316		0
48585	2878	40481087	2018-06-23	2018-06-23 00:00:00	2018-07-07	2018-07-07 00:00:00	32020		\N	191453	0	444814009	40481087		0
48780	2890	195588	2009-11-26	2009-11-26 00:00:00	2010-01-15	2010-01-15 00:00:00	32020		\N	192199	0	38822007	195588		0
48854	2893	260139	1946-05-18	1946-05-18 00:00:00	1946-06-01	1946-06-01 00:00:00	32020		\N	192497	0	10509002	260139		0
49097	2905	78272	2007-08-25	2007-08-25 00:00:00	2007-09-08	2007-09-08 00:00:00	32020		\N	193572	0	70704007	78272		0
49282	2914	4112343	2019-04-19	2019-04-19 00:00:00	2019-04-27	2019-04-27 00:00:00	32020		\N	194181	0	195662009	4112343		0
49409	2921	40481087	2011-01-19	2011-01-19 00:00:00	2011-02-09	2011-02-09 00:00:00	32020		\N	194697	0	444814009	40481087		0
49536	2929	40479768	1990-10-22	1990-10-22 00:00:00	1990-12-28	1990-12-28 00:00:00	32020		\N	195377	0	444470001	40479768		0
49745	2943	40481087	1993-10-19	1993-10-19 00:00:00	1993-10-26	1993-10-26 00:00:00	32020		\N	196271	0	444814009	40481087		0
39315	2332	4278672	1967-08-26	1967-08-26 00:00:00	1967-10-25	1967-10-25 00:00:00	32020		\N	155123	0	65966004	4278672		0
50041	2957	4113008	1956-10-13	1956-10-13 00:00:00	1956-11-02	1956-11-02 00:00:00	32020		\N	197394	0	284549007	4113008		0
39651	2347	4285898	2012-04-10	2012-04-10 00:00:00	\N	\N	32020		\N	156248	0	68496003	4285898		0
50372	2980	40481087	1979-04-28	1979-04-28 00:00:00	1979-05-05	1979-05-05 00:00:00	32020		\N	198918	0	444814009	40481087		0
50522	2988	80180	2001-07-15	2001-07-15 00:00:00	\N	\N	32020		\N	199431	0	396275006	80180		0
54328	3218	4266809	1992-10-04	1992-10-04 00:00:00	\N	\N	32020		\N	213824	0	397881000	4266809		0
50698	3000	260139	1951-07-01	1951-07-01 00:00:00	1951-07-15	1951-07-15 00:00:00	32020		\N	200184	0	10509002	260139		0
50832	3007	28060	2016-12-03	2016-12-03 00:00:00	2016-12-15	2016-12-15 00:00:00	32020		\N	200639	0	43878008	28060		0
40483	2404	4112343	1987-04-09	1987-04-09 00:00:00	1987-04-18	1987-04-18 00:00:00	32020		\N	159748	0	195662009	4112343		0
51276	3040	260139	2011-10-02	2011-10-02 00:00:00	2011-10-09	2011-10-09 00:00:00	32020		\N	202371	0	10509002	260139		0
51358	3047	80180	2017-10-28	2017-10-28 00:00:00	\N	\N	32020		\N	202751	0	396275006	80180		0
51505	3057	4112343	2008-09-01	2008-09-01 00:00:00	2008-09-13	2008-09-13 00:00:00	32020		\N	203338	0	195662009	4112343		0
51765	3069	260139	1971-04-28	1971-04-28 00:00:00	1971-05-05	1971-05-05 00:00:00	32020		\N	204245	0	10509002	260139		0
51876	3076	40481087	1970-04-13	1970-04-13 00:00:00	1970-04-20	1970-04-20 00:00:00	32020		\N	204658	0	444814009	40481087		0
52017	3081	28060	1957-06-27	1957-06-27 00:00:00	1957-07-08	1957-07-08 00:00:00	32020		\N	205140	0	43878008	28060		0
52177	3088	40481087	1998-09-17	1998-09-17 00:00:00	1998-10-01	1998-10-01 00:00:00	32020		\N	205626	0	444814009	40481087		0
52292	3096	372328	1965-04-28	1965-04-28 00:00:00	1965-05-30	1965-05-30 00:00:00	32020		\N	206103	0	65363002	372328		0
63111	3728	4283893	1982-11-24	1982-11-24 00:00:00	1983-01-26	1983-01-26 00:00:00	32020		\N	247716	0	36971009	4283893		0
52774	3125	4266809	1985-01-05	1985-01-05 00:00:00	\N	\N	32020		\N	207976	0	397881000	4266809		0
52932	3134	40481087	1973-03-11	1973-03-11 00:00:00	1973-04-01	1973-04-01 00:00:00	32020		\N	208552	0	444814009	40481087		0
53113	3145	40481087	1974-11-14	1974-11-14 00:00:00	1974-11-28	1974-11-28 00:00:00	32020		\N	209255	0	444814009	40481087		0
42585	2540	81151	1985-05-31	1985-05-31 00:00:00	1985-07-05	1985-07-05 00:00:00	32020		\N	167988	0	44465007	81151		0
42820	2551	260139	2008-02-08	2008-02-08 00:00:00	2008-02-22	2008-02-22 00:00:00	32020		\N	168866	0	10509002	260139		0
42928	2555	40481087	1959-10-23	1959-10-23 00:00:00	1959-11-05	1959-11-05 00:00:00	32020		\N	169359	0	444814009	40481087		0
43076	2566	40481087	1985-12-07	1985-12-07 00:00:00	1985-12-14	1985-12-14 00:00:00	32020		\N	169965	0	444814009	40481087		0
32688	1941	40481087	2016-03-09	2016-03-09 00:00:00	2016-03-23	2016-03-23 00:00:00	32020		\N	129039	0	444814009	40481087		0
43450	2588	4218389	1972-06-03	1972-06-03 00:00:00	1972-07-08	1972-07-08 00:00:00	32020		\N	171308	0	39848009	4218389		0
33032	1960	260139	1955-09-27	1955-09-27 00:00:00	1955-10-11	1955-10-11 00:00:00	32020		\N	130373	0	10509002	260139		0
43711	2603	40481087	2013-12-20	2013-12-20 00:00:00	2014-01-03	2014-01-03 00:00:00	32020		\N	172195	0	444814009	40481087		0
43859	2611	40481087	2017-06-15	2017-06-15 00:00:00	2017-07-06	2017-07-06 00:00:00	32020		\N	172633	0	444814009	40481087		0
44068	2621	4156265	1983-07-08	1983-07-08 00:00:00	1983-07-29	1983-07-29 00:00:00	32020		\N	173400	0	370247008	4156265		0
44220	2630	4294548	1979-06-12	1979-06-12 00:00:00	1979-09-04	1979-09-04 00:00:00	32020		\N	173931	0	75498004	4294548		0
44349	2636	40481087	1992-10-26	1992-10-26 00:00:00	1992-11-16	1992-11-16 00:00:00	32020		\N	174488	0	444814009	40481087		0
44610	2654	4134304	2010-03-09	2010-03-09 00:00:00	2010-06-07	2010-06-07 00:00:00	32020		\N	175727	0	263102004	4134304		0
44733	2661	4112343	1974-10-19	1974-10-19 00:00:00	1974-10-28	1974-10-28 00:00:00	32020		\N	176382	0	195662009	4112343		0
44902	2672	28060	1953-07-15	1953-07-15 00:00:00	1953-07-23	1953-07-23 00:00:00	32020		\N	176882	0	43878008	28060		0
45112	2684	4112343	1998-11-06	1998-11-06 00:00:00	1998-11-16	1998-11-16 00:00:00	32020		\N	177878	0	195662009	4112343		0
34686	2060	40481087	1995-02-09	1995-02-09 00:00:00	1995-02-16	1995-02-16 00:00:00	32020		\N	137038	0	444814009	40481087		0
45466	2703	81151	2006-08-15	2006-08-15 00:00:00	2006-08-29	2006-08-29 00:00:00	32020		\N	179108	0	44465007	81151		0
45562	2708	81151	1994-11-18	1994-11-18 00:00:00	1994-12-16	1994-12-16 00:00:00	32020		\N	179433	0	44465007	81151		0
45692	2715	78272	1970-07-21	1970-07-21 00:00:00	1970-08-25	1970-08-25 00:00:00	32020		\N	179965	0	70704007	78272		0
45864	2731	260139	1977-09-16	1977-09-16 00:00:00	1977-09-30	1977-09-30 00:00:00	32020		\N	180822	0	10509002	260139		0
46118	2747	81151	1990-01-29	1990-01-29 00:00:00	1990-02-26	1990-02-26 00:00:00	32020		\N	181719	0	44465007	81151		0
46221	2752	260139	1954-04-03	1954-04-03 00:00:00	1954-04-10	1954-04-10 00:00:00	32020		\N	182101	0	10509002	260139		0
46354	2760	40481087	1964-05-19	1964-05-19 00:00:00	1964-06-02	1964-06-02 00:00:00	32020		\N	182552	0	444814009	40481087		0
36016	2135	4112343	1966-06-12	1966-06-12 00:00:00	1966-06-20	1966-06-20 00:00:00	32020		\N	142160	0	195662009	4112343		0
46715	2779	40481087	1993-11-18	1993-11-18 00:00:00	1993-12-09	1993-12-09 00:00:00	32020		\N	184092	0	444814009	40481087		0
46851	2786	4278672	1939-07-17	1939-07-17 00:00:00	1939-10-15	1939-10-15 00:00:00	32020		\N	184608	0	65966004	4278672		0
47093	2801	4027663	1955-02-09	1955-02-09 00:00:00	\N	\N	32020		\N	185631	0	13200003	4027663		0
47203	2806	40481087	1962-12-04	1962-12-04 00:00:00	1962-12-25	1962-12-25 00:00:00	32020		\N	185973	0	444814009	40481087		0
47382	2818	40481087	1986-08-05	1986-08-05 00:00:00	1986-08-12	1986-08-12 00:00:00	32020		\N	186755	0	444814009	40481087		0
47537	2827	260139	1984-03-23	1984-03-23 00:00:00	1984-04-06	1984-04-06 00:00:00	32020		\N	187518	0	10509002	260139		0
47646	2832	40481087	1989-03-19	1989-03-19 00:00:00	1989-04-02	1989-04-02 00:00:00	32020		\N	187894	0	444814009	40481087		0
47840	2842	260139	1995-04-23	1995-04-23 00:00:00	1995-04-30	1995-04-30 00:00:00	32020		\N	188697	0	10509002	260139		0
48088	2853	40481087	1978-07-22	1978-07-22 00:00:00	1978-08-12	1978-08-12 00:00:00	32020		\N	189547	0	444814009	40481087		0
48142	2858	4113008	1979-07-01	1979-07-01 00:00:00	1979-07-15	1979-07-15 00:00:00	32020		\N	189902	0	284549007	4113008		0
37841	2242	4278672	1942-05-25	1942-05-25 00:00:00	1942-08-23	1942-08-23 00:00:00	32020		\N	149229	0	65966004	4278672		0
48586	2878	80180	2019-04-02	2019-04-02 00:00:00	\N	\N	32020		\N	191453	0	396275006	80180		0
48781	2890	257012	1982-06-23	1982-06-23 00:00:00	\N	\N	32020		\N	192230	0	40055000	257012		0
48855	2893	4112343	1972-07-13	1972-07-13 00:00:00	1972-07-24	1972-07-24 00:00:00	32020		\N	192499	0	195662009	4112343		0
49098	2905	40481087	1983-10-07	1983-10-07 00:00:00	1983-10-28	1983-10-28 00:00:00	32020		\N	193595	0	444814009	40481087		0
49283	2914	80180	1997-03-09	1997-03-09 00:00:00	\N	\N	32020		\N	194232	0	396275006	80180		0
49410	2921	40481087	1968-09-29	1968-09-29 00:00:00	1968-10-20	1968-10-20 00:00:00	32020		\N	194723	0	444814009	40481087		0
49537	2929	40481087	2001-10-22	2001-10-22 00:00:00	2001-10-29	2001-10-29 00:00:00	32020		\N	195390	0	444814009	40481087		0
49746	2943	260139	1971-01-28	1971-01-28 00:00:00	1971-02-04	1971-02-04 00:00:00	32020		\N	196320	0	10509002	260139		0
39316	2332	260139	1997-03-05	1997-03-05 00:00:00	1997-03-19	1997-03-19 00:00:00	32020		\N	155085	0	10509002	260139		0
50042	2957	4112343	1988-04-04	1988-04-04 00:00:00	1988-04-11	1988-04-11 00:00:00	32020		\N	197301	0	195662009	4112343		0
39652	2347	80180	2012-09-07	2012-09-07 00:00:00	\N	\N	32020		\N	156248	0	396275006	80180		0
50373	2980	78272	1973-12-08	1973-12-08 00:00:00	1974-01-12	1974-01-12 00:00:00	32020		\N	198941	0	70704007	78272		0
50523	2988	4149245	1993-01-03	1993-01-03 00:00:00	1993-03-11	1993-03-11 00:00:00	32020		\N	199427	0	30832001	4149245		0
50699	3000	378001	1952-12-21	1952-12-21 00:00:00	1953-02-19	1953-02-19 00:00:00	32020		\N	200175	0	62106007	378001		0
50834	3007	260139	1983-01-28	1983-01-28 00:00:00	1983-02-04	1983-02-04 00:00:00	32020		\N	200577	0	10509002	260139		0
40484	2404	40481087	1987-11-30	1987-11-30 00:00:00	1987-12-21	1987-12-21 00:00:00	32020		\N	159772	0	444814009	40481087		0
51277	3040	40481087	1972-10-27	1972-10-27 00:00:00	1972-11-03	1972-11-03 00:00:00	32020		\N	202399	0	444814009	40481087		0
51359	3047	40481087	2013-04-27	2013-04-27 00:00:00	2013-05-11	2013-05-11 00:00:00	32020		\N	202729	0	444814009	40481087		0
51506	3057	28060	1942-03-08	1942-03-08 00:00:00	1942-03-15	1942-03-15 00:00:00	32020		\N	203353	0	43878008	28060		0
51766	3069	40481087	1995-08-23	1995-08-23 00:00:00	1995-09-13	1995-09-13 00:00:00	32020		\N	204289	0	444814009	40481087		0
51877	3076	4113008	1997-03-08	1997-03-08 00:00:00	1997-03-29	1997-03-29 00:00:00	32020		\N	204645	0	284549007	4113008		0
52018	3081	378001	1965-06-12	1965-06-12 00:00:00	1965-07-12	1965-07-12 00:00:00	32020		\N	205133	0	62106007	378001		0
52178	3088	40481087	2004-10-08	2004-10-08 00:00:00	2004-10-22	2004-10-22 00:00:00	32020		\N	205627	0	444814009	40481087		0
52293	3096	4112343	2012-06-20	2012-06-20 00:00:00	2012-07-01	2012-07-01 00:00:00	32020		\N	206055	0	195662009	4112343		0
63112	3728	4112343	1990-02-24	1990-02-24 00:00:00	1990-03-05	1990-03-05 00:00:00	32020		\N	247729	0	195662009	4112343		0
52775	3125	81893	1984-02-10	1984-02-10 00:00:00	\N	\N	32020		\N	207976	0	64766004	81893		0
52933	3134	4218389	1966-11-07	1966-11-07 00:00:00	1966-12-12	1966-12-12 00:00:00	32020		\N	208555	0	39848009	4218389		0
53114	3145	40481087	2012-12-08	2012-12-08 00:00:00	2012-12-15	2012-12-15 00:00:00	32020		\N	209276	0	444814009	40481087		0
42586	2540	40481087	1941-09-03	1941-09-03 00:00:00	1941-09-24	1941-09-24 00:00:00	32020		\N	167961	0	444814009	40481087		0
42821	2551	260139	1991-01-09	1991-01-09 00:00:00	1991-01-23	1991-01-23 00:00:00	32020		\N	168877	0	10509002	260139		0
42929	2555	4112343	2016-08-11	2016-08-11 00:00:00	2016-08-18	2016-08-18 00:00:00	32020		\N	169328	0	195662009	4112343		0
43077	2566	40481087	1957-12-11	1957-12-11 00:00:00	1958-01-01	1958-01-01 00:00:00	32020		\N	169964	0	444814009	40481087		0
32689	1941	260139	1988-11-25	1988-11-25 00:00:00	1988-12-09	1988-12-09 00:00:00	32020		\N	129056	0	10509002	260139		0
43451	2588	81151	2016-07-13	2016-07-13 00:00:00	2016-07-27	2016-07-27 00:00:00	32020		\N	171298	0	44465007	81151		0
33033	1960	260139	1983-10-04	1983-10-04 00:00:00	1983-10-11	1983-10-11 00:00:00	32020		\N	130374	0	10509002	260139		0
43712	2603	260139	1980-02-11	1980-02-11 00:00:00	1980-02-25	1980-02-25 00:00:00	32020		\N	172232	0	10509002	260139		0
43860	2611	78272	1977-12-28	1977-12-28 00:00:00	1978-01-18	1978-01-18 00:00:00	32020		\N	172654	0	70704007	78272		0
44069	2621	260139	1984-07-12	1984-07-12 00:00:00	1984-07-26	1984-07-26 00:00:00	32020		\N	173381	0	10509002	260139		0
44221	2630	81893	1997-11-05	1997-11-05 00:00:00	\N	\N	32020		\N	174005	0	64766004	81893		0
44350	2636	4155034	1995-12-13	1995-12-13 00:00:00	1995-12-27	1995-12-27 00:00:00	32020		\N	174419	0	283371005	4155034		0
44611	2654	260139	2015-03-31	2015-03-31 00:00:00	2015-04-07	2015-04-07 00:00:00	32020		\N	175717	0	10509002	260139		0
44734	2661	260139	1989-10-31	1989-10-31 00:00:00	1989-11-07	1989-11-07 00:00:00	32020		\N	176323	0	10509002	260139		0
44903	2672	40481087	2001-05-30	2001-05-30 00:00:00	2001-06-20	2001-06-20 00:00:00	32020		\N	176906	0	444814009	40481087		0
45113	2684	4027663	1986-02-06	1986-02-06 00:00:00	\N	\N	32020		\N	177858	0	13200003	4027663		0
34687	2060	378001	2008-11-07	2008-11-07 00:00:00	2008-12-07	2008-12-07 00:00:00	32020		\N	137031	0	62106007	378001		0
45467	2703	4218389	1999-08-10	1999-08-10 00:00:00	1999-08-31	1999-08-31 00:00:00	32020		\N	179106	0	39848009	4218389		0
45563	2708	4048695	1986-05-20	1986-05-20 00:00:00	1986-07-21	1986-07-21 00:00:00	32020		\N	179430	0	15724005	4048695		0
45693	2715	4084167	1974-01-31	1974-01-31 00:00:00	1974-01-31	1974-01-31 00:00:00	32020		\N	179967	0	241929008	4084167		0
45865	2731	4278672	1970-12-16	1970-12-16 00:00:00	1971-01-15	1971-01-15 00:00:00	32020		\N	180816	0	65966004	4278672		0
46136	2749	260139	1991-03-21	1991-03-21 00:00:00	1991-03-28	1991-03-28 00:00:00	32020		\N	181819	0	10509002	260139		0
46222	2752	4059173	1969-03-02	1969-03-02 00:00:00	1969-05-01	1969-05-01 00:00:00	32020		\N	182116	0	16114001	4059173		0
46355	2760	260139	1972-10-07	1972-10-07 00:00:00	1972-10-21	1972-10-21 00:00:00	32020		\N	182551	0	10509002	260139		0
36017	2135	4278672	1961-06-28	1961-06-28 00:00:00	1961-09-26	1961-09-26 00:00:00	32020		\N	142100	0	65966004	4278672		0
46716	2779	40481087	1990-05-12	1990-05-12 00:00:00	1990-06-02	1990-06-02 00:00:00	32020		\N	184170	0	444814009	40481087		0
46852	2786	4294548	1972-08-27	1972-08-27 00:00:00	1972-10-08	1972-10-08 00:00:00	32020		\N	184605	0	75498004	4294548		0
47094	2801	4283893	1933-04-17	1933-04-17 00:00:00	1933-05-22	1933-05-22 00:00:00	32020		\N	185570	0	36971009	4283893		0
47204	2806	4113008	1957-09-22	1957-09-22 00:00:00	1957-10-13	1957-10-13 00:00:00	32020		\N	185958	0	284549007	4113008		0
47383	2818	81151	1977-09-01	1977-09-01 00:00:00	1977-09-22	1977-09-22 00:00:00	32020		\N	186728	0	44465007	81151		0
47538	2827	257012	1968-03-05	1968-03-05 00:00:00	\N	\N	32020		\N	187495	0	40055000	257012		0
47647	2832	4048695	2017-12-08	2017-12-08 00:00:00	2018-02-08	2018-02-08 00:00:00	32020		\N	187903	0	15724005	4048695		0
47841	2842	80180	1995-12-05	1995-12-05 00:00:00	\N	\N	32020		\N	188697	0	396275006	80180		0
48089	2853	260139	1988-06-02	1988-06-02 00:00:00	1988-06-09	1988-06-09 00:00:00	32020		\N	189512	0	10509002	260139		0
48143	2858	40481087	1942-05-28	1942-05-28 00:00:00	1942-06-18	1942-06-18 00:00:00	32020		\N	189778	0	444814009	40481087		0
37842	2242	4112343	1929-09-28	1929-09-28 00:00:00	1929-10-07	1929-10-07 00:00:00	32020		\N	149232	0	195662009	4112343		0
48587	2878	4112343	2003-12-10	2003-12-10 00:00:00	2003-12-17	2003-12-17 00:00:00	32020		\N	191463	0	195662009	4112343		0
48782	2890	372328	1964-02-26	1964-02-26 00:00:00	1964-05-15	1964-05-15 00:00:00	32020		\N	192203	0	65363002	372328		0
48856	2893	4112343	2006-10-22	2006-10-22 00:00:00	2006-11-01	2006-11-01 00:00:00	32020		\N	192520	0	195662009	4112343		0
49099	2905	4027663	1991-11-22	1991-11-22 00:00:00	\N	\N	32020		\N	193597	0	13200003	4027663		0
49284	2914	4116491	1979-09-25	1979-09-25 00:00:00	1979-11-17	1979-11-17 00:00:00	32020		\N	194193	0	301011002	4116491		0
49411	2921	78272	1941-05-14	1941-05-14 00:00:00	1941-06-04	1941-06-04 00:00:00	32020		\N	194736	0	70704007	78272		0
49538	2929	372328	1975-10-11	1975-10-11 00:00:00	1975-10-25	1975-10-25 00:00:00	32020		\N	195395	0	65363002	372328		0
49747	2943	260139	2003-03-23	2003-03-23 00:00:00	2003-04-06	2003-04-06 00:00:00	32020		\N	196295	0	10509002	260139		0
39317	2332	4278672	1964-08-11	1964-08-11 00:00:00	1964-09-10	1964-09-10 00:00:00	32020		\N	155122	0	65966004	4278672		0
50043	2957	260139	2007-01-10	2007-01-10 00:00:00	2007-01-24	2007-01-24 00:00:00	32020		\N	197357	0	10509002	260139		0
39653	2347	4266809	2012-09-07	2012-09-07 00:00:00	\N	\N	32020		\N	156248	0	397881000	4266809		0
50374	2980	40481087	2016-03-26	2016-03-26 00:00:00	2016-04-09	2016-04-09 00:00:00	32020		\N	198922	0	444814009	40481087		0
50524	2988	40481087	1968-03-10	1968-03-10 00:00:00	1968-03-31	1968-03-31 00:00:00	32020		\N	199489	0	444814009	40481087		0
50700	3000	4112343	1991-10-20	1991-10-20 00:00:00	1991-11-01	1991-11-01 00:00:00	32020		\N	200151	0	195662009	4112343		0
50835	3007	4112343	1978-03-22	1978-03-22 00:00:00	1978-04-03	1978-04-03 00:00:00	32020		\N	200631	0	195662009	4112343		0
40485	2404	4035415	1986-11-11	1986-11-11 00:00:00	1986-12-11	1986-12-11 00:00:00	32020		\N	159762	0	239720000	4035415		0
51278	3040	40481087	2019-03-16	2019-03-16 00:00:00	2019-04-06	2019-04-06 00:00:00	32020		\N	202388	0	444814009	40481087		0
51360	3047	4283893	2002-07-20	2002-07-20 00:00:00	2002-11-16	2002-11-16 00:00:00	32020		\N	202714	0	36971009	4283893		0
51507	3057	260139	1941-04-15	1941-04-15 00:00:00	1941-04-29	1941-04-29 00:00:00	32020		\N	203358	0	10509002	260139		0
51767	3069	4278672	1969-01-27	1969-01-27 00:00:00	1969-03-28	1969-03-28 00:00:00	32020		\N	204309	0	65966004	4278672		0
51878	3076	40481087	1959-12-15	1959-12-15 00:00:00	1959-12-29	1959-12-29 00:00:00	32020		\N	204657	0	444814009	40481087		0
52019	3081	4112343	1968-04-15	1968-04-15 00:00:00	1968-04-25	1968-04-25 00:00:00	32020		\N	205097	0	195662009	4112343		0
52179	3088	378419	2017-02-10	2017-02-10 00:00:00	\N	\N	32020		\N	205682	0	26929004	378419		0
52294	3096	40481087	1970-02-27	1970-02-27 00:00:00	1970-03-06	1970-03-06 00:00:00	32020		\N	206091	0	444814009	40481087		0
63113	3728	40481087	1988-03-22	1988-03-22 00:00:00	1988-04-12	1988-04-12 00:00:00	32020		\N	247756	0	444814009	40481087		0
52776	3125	260139	1954-04-15	1954-04-15 00:00:00	1954-04-29	1954-04-29 00:00:00	32020		\N	207993	0	10509002	260139		0
52934	3134	40481087	1961-05-30	1961-05-30 00:00:00	1961-06-20	1961-06-20 00:00:00	32020		\N	208627	0	444814009	40481087		0
53115	3145	40481087	1975-11-02	1975-11-02 00:00:00	1975-11-23	1975-11-23 00:00:00	32020		\N	209289	0	444814009	40481087		0
42587	2540	440086	1947-12-20	1947-12-20 00:00:00	1949-04-23	1949-04-23 00:00:00	32020		\N	167871	0	192127007	440086		0
42822	2551	260139	1985-10-29	1985-10-29 00:00:00	1985-11-05	1985-11-05 00:00:00	32020		\N	168909	0	10509002	260139		0
42930	2555	40481087	1988-08-23	1988-08-23 00:00:00	1988-09-06	1988-09-06 00:00:00	32020		\N	169364	0	444814009	40481087		0
43078	2566	378001	2003-03-25	2003-03-25 00:00:00	2003-04-24	2003-04-24 00:00:00	32020		\N	170036	0	62106007	378001		0
32690	1941	378001	1995-09-09	1995-09-09 00:00:00	1995-11-08	1995-11-08 00:00:00	32020		\N	129101	0	62106007	378001		0
43452	2589	40481087	2000-03-15	2000-03-15 00:00:00	2000-04-05	2000-04-05 00:00:00	32020		\N	171313	0	444814009	40481087		0
33034	1960	4112343	1987-10-15	1987-10-15 00:00:00	1987-10-25	1987-10-25 00:00:00	32020		\N	130375	0	195662009	4112343		0
43713	2603	40481087	1982-01-25	1982-01-25 00:00:00	1982-02-15	1982-02-15 00:00:00	32020		\N	172223	0	444814009	40481087		0
43861	2611	40481087	2013-08-17	2013-08-17 00:00:00	2013-09-07	2013-09-07 00:00:00	32020		\N	172632	0	444814009	40481087		0
44070	2621	260139	2004-01-26	2004-01-26 00:00:00	2004-02-09	2004-02-09 00:00:00	32020		\N	173394	0	10509002	260139		0
44222	2630	80180	1999-07-28	1999-07-28 00:00:00	\N	\N	32020		\N	174005	0	396275006	80180		0
44351	2636	4112343	1996-08-29	1996-08-29 00:00:00	1996-09-11	1996-09-11 00:00:00	32020		\N	174414	0	195662009	4112343		0
44612	2654	4156265	1989-12-05	1989-12-05 00:00:00	1989-12-26	1989-12-26 00:00:00	32020		\N	175724	0	370247008	4156265		0
44735	2661	40481087	1983-12-13	1983-12-13 00:00:00	1984-01-03	1984-01-03 00:00:00	32020		\N	176298	0	444814009	40481087		0
44904	2672	4112343	1986-05-17	1986-05-17 00:00:00	1986-05-30	1986-05-30 00:00:00	32020		\N	176985	0	195662009	4112343		0
45114	2684	4112343	1986-01-03	1986-01-03 00:00:00	1986-01-11	1986-01-11 00:00:00	32020		\N	177858	0	195662009	4112343		0
34688	2060	260139	2004-08-10	2004-08-10 00:00:00	2004-08-17	2004-08-17 00:00:00	32020		\N	137039	0	10509002	260139		0
45468	2703	4112343	1977-07-16	1977-07-16 00:00:00	1977-07-28	1977-07-28 00:00:00	32020		\N	179084	0	195662009	4112343		0
45564	2708	260139	1993-02-07	1993-02-07 00:00:00	1993-02-14	1993-02-14 00:00:00	32020		\N	179421	0	10509002	260139		0
45694	2715	260139	1966-06-14	1966-06-14 00:00:00	1966-06-28	1966-06-28 00:00:00	32020		\N	180037	0	10509002	260139		0
45866	2731	4112343	1999-02-17	1999-02-17 00:00:00	1999-02-28	1999-02-28 00:00:00	32020		\N	180743	0	195662009	4112343		0
46137	2749	80180	1994-04-08	1994-04-08 00:00:00	\N	\N	32020		\N	181809	0	396275006	80180		0
46223	2752	81151	1967-03-22	1967-03-22 00:00:00	1967-04-12	1967-04-12 00:00:00	32020		\N	182115	0	44465007	81151		0
46356	2760	4027663	1990-03-20	1990-03-20 00:00:00	\N	\N	32020		\N	182575	0	13200003	4027663		0
36018	2135	40481087	1981-06-24	1981-06-24 00:00:00	1981-07-15	1981-07-15 00:00:00	32020		\N	142163	0	444814009	40481087		0
46717	2780	372328	1956-12-21	1956-12-21 00:00:00	1957-03-27	1957-03-27 00:00:00	32020		\N	184229	0	65363002	372328		0
46853	2786	40480160	2009-07-24	2009-07-24 00:00:00	2009-08-23	2009-08-23 00:00:00	32020		\N	184616	0	443165006	40480160		0
47095	2801	40481087	1957-03-15	1957-03-15 00:00:00	1957-04-05	1957-04-05 00:00:00	32020		\N	185571	0	444814009	40481087		0
47205	2806	78272	1964-07-08	1964-07-08 00:00:00	1964-08-12	1964-08-12 00:00:00	32020		\N	185959	0	70704007	78272		0
47384	2818	80180	2009-11-03	2009-11-03 00:00:00	\N	\N	32020		\N	186768	0	396275006	80180		0
47539	2827	81151	1999-06-24	1999-06-24 00:00:00	1999-07-29	1999-07-29 00:00:00	32020		\N	187514	0	44465007	81151		0
47648	2832	4112343	1988-04-15	1988-04-15 00:00:00	1988-04-24	1988-04-24 00:00:00	32020		\N	187884	0	195662009	4112343		0
47842	2842	4109685	1979-11-09	1979-11-09 00:00:00	1979-11-23	1979-11-23 00:00:00	32020		\N	188708	0	284551006	4109685		0
48090	2853	40481087	1968-03-04	1968-03-04 00:00:00	1968-03-18	1968-03-18 00:00:00	32020		\N	189545	0	444814009	40481087		0
48144	2858	40481087	1999-02-19	1999-02-19 00:00:00	1999-03-12	1999-03-12 00:00:00	32020		\N	189747	0	444814009	40481087		0
37843	2242	4112343	1948-08-18	1948-08-18 00:00:00	1948-08-27	1948-08-27 00:00:00	32020		\N	149299	0	195662009	4112343		0
48588	2878	40481087	2005-10-06	2005-10-06 00:00:00	2005-10-13	2005-10-13 00:00:00	32020		\N	191412	0	444814009	40481087		0
48783	2890	40481087	1973-07-17	1973-07-17 00:00:00	1973-07-24	1973-07-24 00:00:00	32020		\N	192233	0	444814009	40481087		0
48857	2893	4112343	1970-11-10	1970-11-10 00:00:00	1970-11-17	1970-11-17 00:00:00	32020		\N	192540	0	195662009	4112343		0
49100	2905	40481087	1990-01-01	1990-01-01 00:00:00	1990-01-15	1990-01-15 00:00:00	32020		\N	193597	0	444814009	40481087		0
49285	2914	192671	1997-05-23	1997-05-23 00:00:00	\N	\N	32020		\N	194178	0	K92.2	35208414		0
49412	2921	4112343	1960-05-18	1960-05-18 00:00:00	1960-05-28	1960-05-28 00:00:00	32020		\N	194695	0	195662009	4112343		0
49539	2929	4112343	1994-01-06	1994-01-06 00:00:00	1994-01-15	1994-01-15 00:00:00	32020		\N	195366	0	195662009	4112343		0
49748	2943	4112343	2005-03-26	2005-03-26 00:00:00	2005-04-07	2005-04-07 00:00:00	32020		\N	196363	0	195662009	4112343		0
39318	2332	4109685	1978-07-29	1978-07-29 00:00:00	1978-08-19	1978-08-19 00:00:00	32020		\N	155124	0	284551006	4109685		0
50044	2957	40481087	1949-06-29	1949-06-29 00:00:00	1949-07-06	1949-07-06 00:00:00	32020		\N	197374	0	444814009	40481087		0
39654	2347	30753	2011-11-12	2011-11-12 00:00:00	\N	\N	32020		\N	156283	0	16761005	30753		0
50375	2980	40481087	2008-05-06	2008-05-06 00:00:00	2008-05-13	2008-05-13 00:00:00	32020		\N	198892	0	444814009	40481087		0
50525	2988	81151	1975-08-15	1975-08-15 00:00:00	1975-09-05	1975-09-05 00:00:00	32020		\N	199426	0	44465007	81151		0
50701	3000	4112343	1987-04-03	1987-04-03 00:00:00	1987-04-11	1987-04-11 00:00:00	32020		\N	200150	0	195662009	4112343		0
50836	3007	4294548	1981-01-13	1981-01-13 00:00:00	1981-04-28	1981-04-28 00:00:00	32020		\N	200633	0	75498004	4294548		0
40486	2404	40481087	1982-05-01	1982-05-01 00:00:00	1982-05-22	1982-05-22 00:00:00	32020		\N	159766	0	444814009	40481087		0
51279	3040	260139	1987-04-24	1987-04-24 00:00:00	1987-05-01	1987-05-01 00:00:00	32020		\N	202402	0	10509002	260139		0
51361	3047	372328	1978-02-16	1978-02-16 00:00:00	1978-07-12	1978-07-12 00:00:00	32020		\N	202717	0	65363002	372328		0
51508	3057	28060	1949-01-08	1949-01-08 00:00:00	1949-01-15	1949-01-15 00:00:00	32020		\N	203334	0	43878008	28060		0
51768	3069	28060	1967-07-30	1967-07-30 00:00:00	1967-08-08	1967-08-08 00:00:00	32020		\N	204285	0	43878008	28060		0
51879	3076	260139	1983-06-05	1983-06-05 00:00:00	1983-06-12	1983-06-12 00:00:00	32020		\N	204659	0	10509002	260139		0
52020	3081	40481087	1954-10-08	1954-10-08 00:00:00	1954-10-22	1954-10-22 00:00:00	32020		\N	205139	0	444814009	40481087		0
52180	3088	28060	1950-08-02	1950-08-02 00:00:00	1950-08-15	1950-08-15 00:00:00	32020		\N	205641	0	43878008	28060		0
52295	3096	4112343	2019-02-07	2019-02-07 00:00:00	2019-02-19	2019-02-19 00:00:00	32020		\N	206095	0	195662009	4112343		0
63114	3728	40481087	2000-12-30	2000-12-30 00:00:00	2001-01-13	2001-01-13 00:00:00	32020		\N	247718	0	444814009	40481087		0
52777	3125	4112343	1962-04-16	1962-04-16 00:00:00	1962-04-23	1962-04-23 00:00:00	32020		\N	207933	0	195662009	4112343		0
52935	3134	4283893	1998-10-09	1998-10-09 00:00:00	1998-11-27	1998-11-27 00:00:00	32020		\N	208631	0	36971009	4283893		0
53116	3145	4001336	1990-12-13	1990-12-13 00:00:00	1991-02-11	1991-02-11 00:00:00	32020		\N	209302	0	110030002	4001336		0
42588	2540	4112343	1968-02-12	1968-02-12 00:00:00	1968-02-22	1968-02-22 00:00:00	32020		\N	167995	0	195662009	4112343		0
42823	2551	4112343	1978-02-24	1978-02-24 00:00:00	1978-03-05	1978-03-05 00:00:00	32020		\N	168856	0	195662009	4112343		0
42931	2555	260139	2004-09-22	2004-09-22 00:00:00	2004-09-29	2004-09-29 00:00:00	32020		\N	169324	0	10509002	260139		0
43079	2566	4237458	2015-11-22	2015-11-22 00:00:00	2016-01-21	2016-01-21 00:00:00	32020		\N	169984	0	58150001	4237458		0
32691	1941	40481087	1987-10-29	1987-10-29 00:00:00	1987-11-12	1987-11-12 00:00:00	32020		\N	129036	0	444814009	40481087		0
43453	2589	4112343	1995-05-02	1995-05-02 00:00:00	1995-05-12	1995-05-12 00:00:00	32020		\N	171346	0	195662009	4112343		0
43493	2591	4112343	1992-08-12	1992-08-12 00:00:00	1992-08-19	1992-08-19 00:00:00	32020		\N	171427	0	195662009	4112343		0
43714	2603	4237458	1983-01-30	1983-01-30 00:00:00	1983-04-30	1983-04-30 00:00:00	32020		\N	172182	0	58150001	4237458		0
43862	2611	28060	2008-08-26	2008-08-26 00:00:00	2008-09-08	2008-09-08 00:00:00	32020		\N	172669	0	43878008	28060		0
44071	2621	40481087	1990-03-11	1990-03-11 00:00:00	1990-03-25	1990-03-25 00:00:00	32020		\N	173392	0	444814009	40481087		0
44223	2630	30753	1998-01-04	1998-01-04 00:00:00	\N	\N	32020		\N	174005	0	16761005	30753		0
44352	2636	4112343	1997-07-12	1997-07-12 00:00:00	1997-07-20	1997-07-20 00:00:00	32020		\N	174422	0	195662009	4112343		0
44613	2654	80180	1983-04-18	1983-04-18 00:00:00	\N	\N	32020		\N	175747	0	396275006	80180		0
44736	2661	4084167	1976-06-10	1976-06-10 00:00:00	1976-06-11	1976-06-11 00:00:00	32020		\N	176282	0	241929008	4084167		0
44905	2672	40481087	1961-03-11	1961-03-11 00:00:00	1961-03-25	1961-03-25 00:00:00	32020		\N	176884	0	444814009	40481087		0
45115	2684	40481087	1996-11-09	1996-11-09 00:00:00	1996-11-16	1996-11-16 00:00:00	32020		\N	177887	0	444814009	40481087		0
34689	2060	40481087	1986-03-31	1986-03-31 00:00:00	1986-04-21	1986-04-21 00:00:00	32020		\N	137005	0	444814009	40481087		0
45469	2703	81151	2014-10-07	2014-10-07 00:00:00	2014-10-28	2014-10-28 00:00:00	32020		\N	179110	0	44465007	81151		0
45565	2708	40481087	1995-10-20	1995-10-20 00:00:00	1995-10-27	1995-10-27 00:00:00	32020		\N	179354	0	444814009	40481087		0
45695	2715	4294548	1973-02-14	1973-02-14 00:00:00	1973-06-06	1973-06-06 00:00:00	32020		\N	180002	0	75498004	4294548		0
45867	2731	372328	1966-02-24	1966-02-24 00:00:00	1966-06-27	1966-06-27 00:00:00	32020		\N	180747	0	65363002	372328		0
46138	2749	40481087	1985-12-20	1985-12-20 00:00:00	1986-01-10	1986-01-10 00:00:00	32020		\N	181789	0	444814009	40481087		0
46224	2752	80180	1992-03-27	1992-03-27 00:00:00	\N	\N	32020		\N	182045	0	396275006	80180		0
46357	2760	260139	1993-07-01	1993-07-01 00:00:00	1993-07-08	1993-07-08 00:00:00	32020		\N	182539	0	10509002	260139		0
36019	2135	260139	1967-05-12	1967-05-12 00:00:00	1967-05-19	1967-05-19 00:00:00	32020		\N	142161	0	10509002	260139		0
46719	2780	40481087	1956-09-22	1956-09-22 00:00:00	1956-09-29	1956-09-29 00:00:00	32020		\N	184217	0	444814009	40481087		0
46854	2786	4278672	2009-07-24	2009-07-24 00:00:00	2009-08-23	2009-08-23 00:00:00	32020		\N	184616	0	65966004	4278672		0
47096	2801	80180	1966-02-21	1966-02-21 00:00:00	\N	\N	32020		\N	185589	0	396275006	80180		0
47206	2806	4294548	1988-11-27	1988-11-27 00:00:00	1989-03-12	1989-03-12 00:00:00	32020		\N	185946	0	75498004	4294548		0
47385	2818	4109685	1989-04-06	1989-04-06 00:00:00	1989-04-27	1989-04-27 00:00:00	32020		\N	186730	0	284551006	4109685		0
47540	2827	255848	2001-10-02	2001-10-02 00:00:00	\N	\N	32020		\N	187515	0	233604007	255848		0
47649	2832	195588	2008-02-04	2008-02-04 00:00:00	2008-03-28	2008-03-28 00:00:00	32020		\N	187936	0	38822007	195588		0
47843	2842	40481087	1963-12-04	1963-12-04 00:00:00	1963-12-25	1963-12-25 00:00:00	32020		\N	188641	0	444814009	40481087		0
48091	2853	81151	1982-07-03	1982-07-03 00:00:00	1982-07-24	1982-07-24 00:00:00	32020		\N	189581	0	44465007	81151		0
48145	2858	40481087	2000-12-08	2000-12-08 00:00:00	2000-12-15	2000-12-15 00:00:00	32020		\N	189883	0	444814009	40481087		0
37844	2242	40481087	1958-09-02	1958-09-02 00:00:00	1958-09-09	1958-09-09 00:00:00	32020		\N	149219	0	444814009	40481087		0
48589	2878	192671	2019-04-10	2019-04-10 00:00:00	\N	\N	32020		\N	191471	0	K92.2	35208414		0
48784	2891	40481087	2007-11-16	2007-11-16 00:00:00	2007-11-30	2007-11-30 00:00:00	32020		\N	192291	0	444814009	40481087		0
48858	2893	81151	1997-08-06	1997-08-06 00:00:00	1997-09-03	1997-09-03 00:00:00	32020		\N	192465	0	44465007	81151		0
49101	2905	4296204	2014-05-04	2014-05-04 00:00:00	2014-05-18	2014-05-18 00:00:00	32020		\N	193552	0	403190006	4296204		0
49286	2914	4283893	1956-09-04	1956-09-04 00:00:00	1956-10-16	1956-10-16 00:00:00	32020		\N	194170	0	36971009	4283893		0
49413	2921	4112343	2005-08-20	2005-08-20 00:00:00	2005-08-28	2005-08-28 00:00:00	32020		\N	194710	0	195662009	4112343		0
49540	2929	4283893	2010-05-13	2010-05-13 00:00:00	2010-07-29	2010-07-29 00:00:00	32020		\N	195394	0	36971009	4283893		0
49749	2943	260139	1917-09-15	1917-09-15 00:00:00	1917-09-29	1917-09-29 00:00:00	32020		\N	196349	0	10509002	260139		0
39319	2332	260139	1994-12-30	1994-12-30 00:00:00	1995-01-13	1995-01-13 00:00:00	32020		\N	155071	0	10509002	260139		0
50045	2957	40481087	1953-08-15	1953-08-15 00:00:00	1953-08-29	1953-08-29 00:00:00	32020		\N	197351	0	444814009	40481087		0
39663	2349	40481087	2000-08-10	2000-08-10 00:00:00	2000-08-24	2000-08-24 00:00:00	32020		\N	156450	0	444814009	40481087		0
50376	2980	372328	1975-12-10	1975-12-10 00:00:00	1976-07-18	1976-07-18 00:00:00	32020		\N	198923	0	65363002	372328		0
50526	2988	4283893	1986-08-02	1986-08-02 00:00:00	1986-08-30	1986-08-30 00:00:00	32020		\N	199492	0	36971009	4283893		0
50702	3000	4112343	2012-05-17	2012-05-17 00:00:00	2012-05-26	2012-05-26 00:00:00	32020		\N	200153	0	195662009	4112343		0
50837	3007	40481087	2016-01-26	2016-01-26 00:00:00	2016-02-02	2016-02-02 00:00:00	32020		\N	200590	0	444814009	40481087		0
40492	2406	372328	1946-02-22	1946-02-22 00:00:00	1946-05-16	1946-05-16 00:00:00	32020		\N	159852	0	65363002	372328		0
51280	3040	40481087	2011-01-05	2011-01-05 00:00:00	2011-01-19	2011-01-19 00:00:00	32020		\N	202370	0	444814009	40481087		0
51362	3047	78272	2008-05-16	2008-05-16 00:00:00	2008-05-30	2008-05-30 00:00:00	32020		\N	202742	0	70704007	78272		0
51509	3057	40481087	1960-05-28	1960-05-28 00:00:00	1960-06-18	1960-06-18 00:00:00	32020		\N	203335	0	444814009	40481087		0
51769	3069	372328	1963-04-08	1963-04-08 00:00:00	1963-07-24	1963-07-24 00:00:00	32020		\N	204301	0	65363002	372328		0
51880	3076	40481087	1996-09-09	1996-09-09 00:00:00	1996-09-16	1996-09-16 00:00:00	32020		\N	204638	0	444814009	40481087		0
52021	3081	4294548	1987-10-01	1987-10-01 00:00:00	1987-11-19	1987-11-19 00:00:00	32020		\N	205143	0	75498004	4294548		0
52181	3088	4112343	1952-01-08	1952-01-08 00:00:00	1952-01-21	1952-01-21 00:00:00	32020		\N	205616	0	195662009	4112343		0
52296	3096	40481087	2012-11-15	2012-11-15 00:00:00	2012-12-06	2012-12-06 00:00:00	32020		\N	206093	0	444814009	40481087		0
63115	3728	40481087	2007-02-19	2007-02-19 00:00:00	2007-02-26	2007-02-26 00:00:00	32020		\N	247730	0	444814009	40481087		0
52778	3125	81151	1963-12-27	1963-12-27 00:00:00	1964-01-31	1964-01-31 00:00:00	32020		\N	208005	0	44465007	81151		0
52936	3134	4237458	1988-12-07	1988-12-07 00:00:00	1989-03-07	1989-03-07 00:00:00	32020		\N	208557	0	58150001	4237458		0
53117	3145	4155034	2001-12-15	2001-12-15 00:00:00	2002-01-05	2002-01-05 00:00:00	32020		\N	209303	0	283371005	4155034		0
42589	2540	4155034	1953-11-28	1953-11-28 00:00:00	1953-12-19	1953-12-19 00:00:00	32020		\N	167984	0	283371005	4155034		0
42824	2551	260139	2017-03-04	2017-03-04 00:00:00	2017-03-18	2017-03-18 00:00:00	32020		\N	168899	0	10509002	260139		0
42932	2555	28060	2011-06-26	2011-06-26 00:00:00	2011-07-08	2011-07-08 00:00:00	32020		\N	169326	0	43878008	28060		0
43080	2566	372328	1942-03-27	1942-03-27 00:00:00	1942-09-29	1942-09-29 00:00:00	32020		\N	170043	0	65363002	372328		0
32692	1941	372328	1976-04-19	1976-04-19 00:00:00	1976-07-22	1976-07-22 00:00:00	32020		\N	129041	0	65363002	372328		0
43454	2589	4152936	1998-01-02	1998-01-02 00:00:00	1998-01-16	1998-01-16 00:00:00	32020		\N	171329	0	283385000	4152936		0
43494	2591	4112343	2002-07-01	2002-07-01 00:00:00	2002-07-10	2002-07-10 00:00:00	32020		\N	171485	0	195662009	4112343		0
43715	2603	28060	1988-10-12	1988-10-12 00:00:00	1988-10-22	1988-10-22 00:00:00	32020		\N	172224	0	43878008	28060		0
43863	2611	40481087	2018-12-03	2018-12-03 00:00:00	2018-12-24	2018-12-24 00:00:00	32020		\N	172647	0	444814009	40481087		0
44072	2621	4218389	1989-04-28	1989-04-28 00:00:00	1989-06-02	1989-06-02 00:00:00	32020		\N	173401	0	39848009	4218389		0
44224	2630	4266809	1999-07-28	1999-07-28 00:00:00	\N	\N	32020		\N	174005	0	397881000	4266809		0
44353	2636	317576	1997-07-04	1997-07-04 00:00:00	\N	\N	32020		\N	174450	0	53741008	317576		0
44614	2654	40481087	1955-08-09	1955-08-09 00:00:00	1955-08-23	1955-08-23 00:00:00	32020		\N	175711	0	444814009	40481087		0
44737	2661	4109685	2006-12-21	2006-12-21 00:00:00	2007-01-04	2007-01-04 00:00:00	32020		\N	176232	0	284551006	4109685		0
44906	2672	4266809	1995-03-05	1995-03-05 00:00:00	\N	\N	32020		\N	176996	0	397881000	4266809		0
45116	2684	30753	1995-03-01	1995-03-01 00:00:00	\N	\N	32020		\N	177860	0	16761005	30753		0
34690	2060	4112343	1985-03-14	1985-03-14 00:00:00	1985-03-26	1985-03-26 00:00:00	32020		\N	137009	0	195662009	4112343		0
45471	2703	4029498	1974-03-03	1974-03-03 00:00:00	\N	\N	32020		\N	179053	0	128613002	4029498		0
45566	2708	4294548	1962-11-27	1962-11-27 00:00:00	1963-01-22	1963-01-22 00:00:00	32020		\N	179350	0	75498004	4294548		0
45696	2715	4112343	2003-08-28	2003-08-28 00:00:00	2003-09-10	2003-09-10 00:00:00	32020		\N	180057	0	195662009	4112343		0
45868	2731	4155034	1984-06-08	1984-06-08 00:00:00	1984-06-29	1984-06-29 00:00:00	32020		\N	180789	0	283371005	4155034		0
46139	2749	372328	1961-05-16	1961-05-16 00:00:00	1961-05-30	1961-05-30 00:00:00	32020		\N	181823	0	65363002	372328		0
46225	2752	4112343	1997-06-09	1997-06-09 00:00:00	1997-06-22	1997-06-22 00:00:00	32020		\N	182037	0	195662009	4112343		0
46358	2760	28060	1963-05-29	1963-05-29 00:00:00	1963-06-11	1963-06-11 00:00:00	32020		\N	182548	0	43878008	28060		0
36020	2135	260139	1953-02-06	1953-02-06 00:00:00	1953-02-20	1953-02-20 00:00:00	32020		\N	142126	0	10509002	260139		0
46720	2780	28060	1958-12-30	1958-12-30 00:00:00	1959-01-11	1959-01-11 00:00:00	32020		\N	184219	0	43878008	28060		0
46855	2786	40481087	1962-06-21	1962-06-21 00:00:00	1962-07-12	1962-07-12 00:00:00	32020		\N	184603	0	444814009	40481087		0
47097	2801	30753	1964-11-28	1964-11-28 00:00:00	\N	\N	32020		\N	185589	0	16761005	30753		0
47207	2806	80502	2013-06-13	2013-06-13 00:00:00	\N	\N	32020		\N	185935	0	64859006	80502		0
47386	2818	4112343	1977-04-16	1977-04-16 00:00:00	1977-04-27	1977-04-27 00:00:00	32020		\N	186744	0	195662009	4112343		0
47541	2827	28060	1934-10-14	1934-10-14 00:00:00	1934-10-21	1934-10-21 00:00:00	32020		\N	187468	0	43878008	28060		0
47650	2833	4152936	1979-12-20	1979-12-20 00:00:00	1980-01-10	1980-01-10 00:00:00	32020		\N	188075	0	283385000	4152936		0
47844	2842	440086	1971-09-22	1971-09-22 00:00:00	1971-12-22	1971-12-22 00:00:00	32020		\N	188648	0	192127007	440086		0
48092	2853	4112343	1994-11-17	1994-11-17 00:00:00	1994-11-28	1994-11-28 00:00:00	32020		\N	189524	0	195662009	4112343		0
48146	2858	4218389	1944-09-20	1944-09-20 00:00:00	1944-10-18	1944-10-18 00:00:00	32020		\N	189900	0	39848009	4218389		0
37845	2242	4112343	1986-09-07	1986-09-07 00:00:00	1986-09-18	1986-09-18 00:00:00	32020		\N	149235	0	195662009	4112343		0
48590	2878	4112343	1981-09-21	1981-09-21 00:00:00	1981-09-30	1981-09-30 00:00:00	32020		\N	191469	0	195662009	4112343		0
48785	2891	4112343	2019-05-11	2019-05-11 00:00:00	2019-05-19	2019-05-19 00:00:00	32020		\N	192328	0	195662009	4112343		0
48859	2894	260139	1986-05-08	1986-05-08 00:00:00	1986-05-22	1986-05-22 00:00:00	32020		\N	192637	0	10509002	260139		0
49102	2905	375671	1999-10-06	1999-10-06 00:00:00	1999-11-05	1999-11-05 00:00:00	32020		\N	193571	0	62564004	375671		0
49287	2914	260139	1962-09-26	1962-09-26 00:00:00	1962-10-10	1962-10-10 00:00:00	32020		\N	194191	0	10509002	260139		0
49414	2921	372328	1941-05-26	1941-05-26 00:00:00	1941-08-26	1941-08-26 00:00:00	32020		\N	194776	0	65363002	372328		0
49541	2929	40481087	1990-10-17	1990-10-17 00:00:00	1990-10-24	1990-10-24 00:00:00	32020		\N	195411	0	444814009	40481087		0
49750	2943	4296205	1920-02-14	1920-02-14 00:00:00	1920-03-13	1920-03-13 00:00:00	32020		\N	196244	0	403191005	4296205		0
39320	2333	4112343	1921-12-27	1921-12-27 00:00:00	1922-01-05	1922-01-05 00:00:00	32020		\N	155129	0	195662009	4112343		0
50046	2957	40481087	1986-03-09	1986-03-09 00:00:00	1986-03-23	1986-03-23 00:00:00	32020		\N	197354	0	444814009	40481087		0
39664	2349	372328	1972-10-06	1972-10-06 00:00:00	1972-12-17	1972-12-17 00:00:00	32020		\N	156453	0	65363002	372328		0
50377	2980	81151	1980-02-10	1980-02-10 00:00:00	1980-02-24	1980-02-24 00:00:00	32020		\N	198974	0	44465007	81151		0
50527	2988	260139	1972-09-16	1972-09-16 00:00:00	1972-09-23	1972-09-23 00:00:00	32020		\N	199464	0	10509002	260139		0
50703	3000	40481087	1976-04-15	1976-04-15 00:00:00	1976-05-06	1976-05-06 00:00:00	32020		\N	200141	0	444814009	40481087		0
50838	3007	40481087	1983-05-26	1983-05-26 00:00:00	1983-06-16	1983-06-16 00:00:00	32020		\N	200587	0	444814009	40481087		0
40493	2406	4112343	1964-03-05	1964-03-05 00:00:00	1964-03-14	1964-03-14 00:00:00	32020		\N	159830	0	195662009	4112343		0
51281	3040	4112343	2000-05-15	2000-05-15 00:00:00	2000-05-26	2000-05-26 00:00:00	32020		\N	202369	0	195662009	4112343		0
51363	3047	81893	2015-12-08	2015-12-08 00:00:00	\N	\N	32020		\N	202776	0	64766004	81893		0
51510	3057	4112343	1938-10-28	1938-10-28 00:00:00	1938-11-05	1938-11-05 00:00:00	32020		\N	203357	0	195662009	4112343		0
51770	3069	4109685	1977-05-29	1977-05-29 00:00:00	1977-06-19	1977-06-19 00:00:00	32020		\N	204311	0	284551006	4109685		0
51881	3076	81151	1993-05-23	1993-05-23 00:00:00	1993-06-27	1993-06-27 00:00:00	32020		\N	204644	0	44465007	81151		0
52022	3081	260139	1984-05-14	1984-05-14 00:00:00	1984-05-21	1984-05-21 00:00:00	32020		\N	205099	0	10509002	260139		0
52182	3088	28060	1960-09-08	1960-09-08 00:00:00	1960-09-15	1960-09-15 00:00:00	32020		\N	205609	0	43878008	28060		0
52297	3096	40481087	1987-10-12	1987-10-12 00:00:00	1987-10-19	1987-10-19 00:00:00	32020		\N	206051	0	444814009	40481087		0
63116	3728	40481087	1995-04-12	1995-04-12 00:00:00	1995-04-26	1995-04-26 00:00:00	32020		\N	247717	0	444814009	40481087		0
52779	3125	260139	1962-10-20	1962-10-20 00:00:00	1962-11-03	1962-11-03 00:00:00	32020		\N	207934	0	10509002	260139		0
52937	3134	81151	1949-06-04	1949-06-04 00:00:00	1949-07-09	1949-07-09 00:00:00	32020		\N	208554	0	44465007	81151		0
53118	3145	40481087	1989-09-07	1989-09-07 00:00:00	1989-09-14	1989-09-14 00:00:00	32020		\N	209265	0	444814009	40481087		0
42590	2540	4296204	1997-11-20	1997-11-20 00:00:00	1997-12-11	1997-12-11 00:00:00	32020		\N	167990	0	403190006	4296204		0
42825	2551	4112343	1998-04-20	1998-04-20 00:00:00	1998-04-28	1998-04-28 00:00:00	32020		\N	168878	0	195662009	4112343		0
42933	2555	372328	1950-06-07	1950-06-07 00:00:00	1950-08-17	1950-08-17 00:00:00	32020		\N	169344	0	65363002	372328		0
43081	2566	4112343	2002-02-17	2002-02-17 00:00:00	2002-02-26	2002-02-26 00:00:00	32020		\N	169998	0	195662009	4112343		0
32693	1941	40481087	2011-09-03	2011-09-03 00:00:00	2011-09-24	2011-09-24 00:00:00	32020		\N	129057	0	444814009	40481087		0
43455	2589	40481087	1995-07-22	1995-07-22 00:00:00	1995-08-12	1995-08-12 00:00:00	32020		\N	171338	0	444814009	40481087		0
43495	2591	372328	1981-11-02	1981-11-02 00:00:00	1982-06-23	1982-06-23 00:00:00	32020		\N	171460	0	65363002	372328		0
43716	2603	372328	1962-11-23	1962-11-23 00:00:00	1963-04-24	1963-04-24 00:00:00	32020		\N	172236	0	65363002	372328		0
43864	2611	260139	1955-06-29	1955-06-29 00:00:00	1955-07-13	1955-07-13 00:00:00	32020		\N	172700	0	10509002	260139		0
44073	2621	40481087	1964-05-14	1964-05-14 00:00:00	1964-06-04	1964-06-04 00:00:00	32020		\N	173332	0	444814009	40481087		0
44225	2630	440086	1968-12-17	1968-12-17 00:00:00	1971-02-16	1971-02-16 00:00:00	32020		\N	173963	0	192127007	440086		0
44354	2636	40481087	1991-04-09	1991-04-09 00:00:00	1991-04-30	1991-04-30 00:00:00	32020		\N	174487	0	444814009	40481087		0
44615	2654	260139	1980-06-16	1980-06-16 00:00:00	1980-06-23	1980-06-23 00:00:00	32020		\N	175714	0	10509002	260139		0
44738	2661	257012	1981-02-07	1981-02-07 00:00:00	\N	\N	32020		\N	176255	0	40055000	257012		0
44907	2672	80180	1995-03-05	1995-03-05 00:00:00	\N	\N	32020		\N	176996	0	396275006	80180		0
45117	2684	195588	1995-02-04	1995-02-04 00:00:00	1995-03-16	1995-03-16 00:00:00	32020		\N	177860	0	38822007	195588		0
34691	2060	4112343	1988-01-12	1988-01-12 00:00:00	1988-01-20	1988-01-20 00:00:00	32020		\N	137006	0	195662009	4112343		0
45472	2703	4266809	2014-04-12	2014-04-12 00:00:00	\N	\N	32020		\N	179096	0	397881000	4266809		0
45567	2708	81151	2010-02-16	2010-02-16 00:00:00	2010-03-02	2010-03-02 00:00:00	32020		\N	179435	0	44465007	81151		0
45697	2715	40481087	1978-07-17	1978-07-17 00:00:00	1978-08-07	1978-08-07 00:00:00	32020		\N	180005	0	444814009	40481087		0
45869	2731	260139	1990-07-01	1990-07-01 00:00:00	1990-07-15	1990-07-15 00:00:00	32020		\N	180823	0	10509002	260139		0
46140	2749	4112343	1968-12-22	1968-12-22 00:00:00	1969-01-01	1969-01-01 00:00:00	32020		\N	181784	0	195662009	4112343		0
46226	2752	81151	1982-10-20	1982-10-20 00:00:00	1982-11-17	1982-11-17 00:00:00	32020		\N	182117	0	44465007	81151		0
46359	2760	40481087	1964-07-07	1964-07-07 00:00:00	1964-07-28	1964-07-28 00:00:00	32020		\N	182550	0	444814009	40481087		0
36021	2135	134438	1968-02-04	1968-02-04 00:00:00	1969-01-05	1969-01-05 00:00:00	32020		\N	142072	0	40275004	134438		0
46721	2780	260139	1993-12-13	1993-12-13 00:00:00	1993-12-20	1993-12-20 00:00:00	32020		\N	184209	0	10509002	260139		0
46856	2786	40481087	1994-01-16	1994-01-16 00:00:00	1994-01-23	1994-01-23 00:00:00	32020		\N	184538	0	444814009	40481087		0
47098	2801	4266809	1966-02-21	1966-02-21 00:00:00	\N	\N	32020		\N	185589	0	397881000	4266809		0
47208	2806	4112343	1955-08-08	1955-08-08 00:00:00	1955-08-16	1955-08-16 00:00:00	32020		\N	185921	0	195662009	4112343		0
47397	2821	81151	1961-01-18	1961-01-18 00:00:00	1961-02-08	1961-02-08 00:00:00	32020		\N	186850	0	44465007	81151		0
47542	2827	4112343	1926-10-16	1926-10-16 00:00:00	1926-10-25	1926-10-25 00:00:00	32020		\N	187516	0	195662009	4112343		0
47651	2833	40481087	1951-05-01	1951-05-01 00:00:00	1951-05-22	1951-05-22 00:00:00	32020		\N	188048	0	444814009	40481087		0
47845	2842	4112343	1983-04-29	1983-04-29 00:00:00	1983-05-08	1983-05-08 00:00:00	32020		\N	188702	0	195662009	4112343		0
48093	2853	40481087	1974-09-21	1974-09-21 00:00:00	1974-10-05	1974-10-05 00:00:00	32020		\N	189549	0	444814009	40481087		0
48147	2858	4112343	1914-07-26	1914-07-26 00:00:00	1914-08-04	1914-08-04 00:00:00	32020		\N	189738	0	195662009	4112343		0
37846	2242	4294548	2015-05-21	2015-05-21 00:00:00	2015-08-27	2015-08-27 00:00:00	32020		\N	149222	0	75498004	4294548		0
48591	2878	4112343	1996-10-08	1996-10-08 00:00:00	1996-10-17	1996-10-17 00:00:00	32020		\N	191460	0	195662009	4112343		0
48786	2891	4109685	1982-08-07	1982-08-07 00:00:00	1982-08-28	1982-08-28 00:00:00	32020		\N	192314	0	284551006	4109685		0
48860	2894	40479422	1932-07-30	1932-07-30 00:00:00	1932-10-05	1932-10-05 00:00:00	32020		\N	192622	0	444448004	40479422		0
49103	2905	4266809	1999-10-06	1999-10-06 00:00:00	\N	\N	32020		\N	193571	0	397881000	4266809		0
49288	2915	78272	1950-12-02	1950-12-02 00:00:00	1950-12-23	1950-12-23 00:00:00	32020		\N	194300	0	70704007	78272		0
49415	2921	78272	1964-07-03	1964-07-03 00:00:00	1964-07-17	1964-07-17 00:00:00	32020		\N	194737	0	70704007	78272		0
49542	2929	260139	1992-10-13	1992-10-13 00:00:00	1992-10-20	1992-10-20 00:00:00	32020		\N	195365	0	10509002	260139		0
49751	2943	4142905	1929-09-22	1929-09-22 00:00:00	1929-10-22	1929-10-22 00:00:00	32020		\N	196245	0	33737001	4142905		0
39321	2333	4112343	1945-01-18	1945-01-18 00:00:00	1945-01-26	1945-01-26 00:00:00	32020		\N	155236	0	195662009	4112343		0
50047	2957	4112343	1977-06-21	1977-06-21 00:00:00	1977-06-29	1977-06-29 00:00:00	32020		\N	197353	0	195662009	4112343		0
39665	2349	4112343	2013-12-01	2013-12-01 00:00:00	2013-12-13	2013-12-13 00:00:00	32020		\N	156452	0	195662009	4112343		0
50378	2980	4294548	1974-05-13	1974-05-13 00:00:00	1975-05-12	1975-05-12 00:00:00	32020		\N	198976	0	75498004	4294548		0
50528	2988	40481087	1967-01-22	1967-01-22 00:00:00	1967-02-05	1967-02-05 00:00:00	32020		\N	199481	0	444814009	40481087		0
50704	3000	4112343	2012-09-25	2012-09-25 00:00:00	2012-10-02	2012-10-02 00:00:00	32020		\N	200199	0	195662009	4112343		0
50839	3007	40481087	1998-01-21	1998-01-21 00:00:00	1998-01-28	1998-01-28 00:00:00	32020		\N	200619	0	444814009	40481087		0
40494	2406	4112343	1985-01-15	1985-01-15 00:00:00	1985-01-25	1985-01-25 00:00:00	32020		\N	159844	0	195662009	4112343		0
51282	3040	40481087	1988-05-26	1988-05-26 00:00:00	1988-06-02	1988-06-02 00:00:00	32020		\N	202403	0	444814009	40481087		0
51364	3047	30753	2016-05-06	2016-05-06 00:00:00	\N	\N	32020		\N	202776	0	16761005	30753		0
51511	3057	40481087	1945-01-01	1945-01-01 00:00:00	1945-01-08	1945-01-08 00:00:00	32020		\N	203361	0	444814009	40481087		0
51771	3069	40481087	2011-07-13	2011-07-13 00:00:00	2011-07-20	2011-07-20 00:00:00	32020		\N	204250	0	444814009	40481087		0
51882	3076	40481087	1958-10-21	1958-10-21 00:00:00	1958-11-11	1958-11-11 00:00:00	32020		\N	204650	0	444814009	40481087		0
52023	3081	381316	2011-09-07	2011-09-07 00:00:00	\N	\N	32020		\N	205094	0	230690007	381316		0
52183	3088	439777	1999-03-30	1999-03-30 00:00:00	\N	\N	32020		\N	205619	0	271737000	439777		0
52298	3096	40481087	2013-05-13	2013-05-13 00:00:00	2013-05-27	2013-05-27 00:00:00	32020		\N	206072	0	444814009	40481087		0
63117	3728	260139	2005-11-19	2005-11-19 00:00:00	2005-11-26	2005-11-26 00:00:00	32020		\N	247741	0	10509002	260139		0
52780	3125	4112343	1966-07-02	1966-07-02 00:00:00	1966-07-14	1966-07-14 00:00:00	32020		\N	207924	0	195662009	4112343		0
52938	3134	40481087	2003-09-26	2003-09-26 00:00:00	2003-10-10	2003-10-10 00:00:00	32020		\N	208579	0	444814009	40481087		0
63579	3754	28060	1990-03-03	1990-03-03 00:00:00	1990-03-14	1990-03-14 00:00:00	32020		\N	249446	0	43878008	28060		0
42591	2540	4296205	1950-11-30	1950-11-30 00:00:00	1950-12-14	1950-12-14 00:00:00	32020		\N	167925	0	403191005	4296205		0
42826	2551	80180	1998-06-27	1998-06-27 00:00:00	\N	\N	32020		\N	168878	0	396275006	80180		0
42934	2556	260139	1970-06-13	1970-06-13 00:00:00	1970-06-27	1970-06-27 00:00:00	32020		\N	169417	0	10509002	260139		0
43082	2566	40481087	1959-05-02	1959-05-02 00:00:00	1959-05-23	1959-05-23 00:00:00	32020		\N	169938	0	444814009	40481087		0
32694	1941	40481087	1982-05-16	1982-05-16 00:00:00	1982-05-23	1982-05-23 00:00:00	32020		\N	129063	0	444814009	40481087		0
43456	2589	4296204	2016-10-08	2016-10-08 00:00:00	2016-10-22	2016-10-22 00:00:00	32020		\N	171330	0	403190006	4296204		0
43496	2591	4294548	1971-09-18	1971-09-18 00:00:00	1972-07-22	1972-07-22 00:00:00	32020		\N	171454	0	75498004	4294548		0
43717	2603	4112343	1988-05-02	1988-05-02 00:00:00	1988-05-11	1988-05-11 00:00:00	32020		\N	172184	0	195662009	4112343		0
43865	2611	40481087	1988-02-17	1988-02-17 00:00:00	1988-03-09	1988-03-09 00:00:00	32020		\N	172685	0	444814009	40481087		0
44074	2621	378001	1957-07-21	1957-07-21 00:00:00	1957-09-19	1957-09-19 00:00:00	32020		\N	173396	0	62106007	378001		0
44226	2630	40481087	2012-03-13	2012-03-13 00:00:00	2012-03-27	2012-03-27 00:00:00	32020		\N	174020	0	444814009	40481087		0
44355	2636	260139	2014-11-15	2014-11-15 00:00:00	2014-11-29	2014-11-29 00:00:00	32020		\N	174489	0	10509002	260139		0
44616	2654	81151	1988-12-19	1988-12-19 00:00:00	1989-01-09	1989-01-09 00:00:00	32020		\N	175723	0	44465007	81151		0
44739	2661	4048171	1968-09-17	1968-09-17 00:00:00	1993-07-16	1993-07-16 00:00:00	32020		\N	176239	0	232353008	4048171		0
44908	2672	372328	1956-05-28	1956-05-28 00:00:00	1956-11-11	1956-11-11 00:00:00	32020		\N	176943	0	65363002	372328		0
45118	2684	80180	1995-09-27	1995-09-27 00:00:00	\N	\N	32020		\N	177860	0	396275006	80180		0
34692	2060	28060	1993-09-10	1993-09-10 00:00:00	1993-09-20	1993-09-20 00:00:00	32020		\N	137037	0	43878008	28060		0
45473	2703	80180	2014-04-12	2014-04-12 00:00:00	\N	\N	32020		\N	179096	0	396275006	80180		0
45568	2708	4112343	1996-11-09	1996-11-09 00:00:00	1996-11-20	1996-11-20 00:00:00	32020		\N	179355	0	195662009	4112343		0
45698	2715	80180	1999-05-25	1999-05-25 00:00:00	\N	\N	32020		\N	180056	0	396275006	80180		0
45870	2731	4112343	2000-09-24	2000-09-24 00:00:00	2000-10-05	2000-10-05 00:00:00	32020		\N	180744	0	195662009	4112343		0
46141	2749	78272	1980-08-09	1980-08-09 00:00:00	1980-09-13	1980-09-13 00:00:00	32020		\N	181848	0	70704007	78272		0
46227	2752	260139	1956-07-14	1956-07-14 00:00:00	1956-07-21	1956-07-21 00:00:00	32020		\N	182059	0	10509002	260139		0
46360	2760	40481087	1978-01-30	1978-01-30 00:00:00	1978-02-20	1978-02-20 00:00:00	32020		\N	182556	0	444814009	40481087		0
36022	2135	78272	2011-05-24	2011-05-24 00:00:00	2011-06-07	2011-06-07 00:00:00	32020		\N	142105	0	70704007	78272		0
46722	2780	192671	2001-12-20	2001-12-20 00:00:00	\N	\N	32020		\N	184231	0	K92.2	35208414		0
46857	2786	4296205	1957-03-05	1957-03-05 00:00:00	1957-04-02	1957-04-02 00:00:00	32020		\N	184610	0	403191005	4296205		0
47099	2801	4112343	1945-06-19	1945-06-19 00:00:00	1945-06-29	1945-06-29 00:00:00	32020		\N	185648	0	195662009	4112343		0
47209	2806	40481087	1968-11-02	1968-11-02 00:00:00	1968-11-16	1968-11-16 00:00:00	32020		\N	186003	0	444814009	40481087		0
47398	2821	260139	1946-04-02	1946-04-02 00:00:00	1946-04-09	1946-04-09 00:00:00	32020		\N	186867	0	10509002	260139		0
47543	2827	260139	1971-01-22	1971-01-22 00:00:00	1971-01-29	1971-01-29 00:00:00	32020		\N	187446	0	10509002	260139		0
47652	2833	40481087	1994-05-15	1994-05-15 00:00:00	1994-05-29	1994-05-29 00:00:00	32020		\N	188051	0	444814009	40481087		0
47846	2842	40481087	1990-12-15	1990-12-15 00:00:00	1990-12-22	1990-12-22 00:00:00	32020		\N	188665	0	444814009	40481087		0
48094	2853	4294548	1982-10-28	1982-10-28 00:00:00	1982-12-02	1982-12-02 00:00:00	32020		\N	189550	0	75498004	4294548		0
48148	2858	378001	2005-11-15	2005-11-15 00:00:00	2005-12-15	2005-12-15 00:00:00	32020		\N	189776	0	62106007	378001		0
37847	2242	4112343	2010-09-14	2010-09-14 00:00:00	2010-09-26	2010-09-26 00:00:00	32020		\N	149210	0	195662009	4112343		0
48592	2878	40481087	1997-03-20	1997-03-20 00:00:00	1997-04-10	1997-04-10 00:00:00	32020		\N	191431	0	444814009	40481087		0
48787	2891	40481087	1992-05-29	1992-05-29 00:00:00	1992-06-19	1992-06-19 00:00:00	32020		\N	192337	0	444814009	40481087		0
48861	2894	372328	1924-08-16	1924-08-16 00:00:00	1925-01-17	1925-01-17 00:00:00	32020		\N	192652	0	65363002	372328		0
49104	2905	80180	1999-10-06	1999-10-06 00:00:00	\N	\N	32020		\N	193571	0	396275006	80180		0
49289	2915	4112343	2005-06-20	2005-06-20 00:00:00	2005-06-28	2005-06-28 00:00:00	32020		\N	194243	0	195662009	4112343		0
49416	2921	4112343	1988-04-04	1988-04-04 00:00:00	1988-04-17	1988-04-17 00:00:00	32020		\N	194768	0	195662009	4112343		0
49543	2929	40481087	2009-05-26	2009-05-26 00:00:00	2009-06-09	2009-06-09 00:00:00	32020		\N	195391	0	444814009	40481087		0
49752	2943	4142905	2008-02-08	2008-02-08 00:00:00	2008-05-08	2008-05-08 00:00:00	32020		\N	196326	0	33737001	4142905		0
39322	2333	378001	1934-01-19	1934-01-19 00:00:00	1934-03-20	1934-03-20 00:00:00	32020		\N	155157	0	62106007	378001		0
50048	2957	260139	1954-02-15	1954-02-15 00:00:00	1954-03-01	1954-03-01 00:00:00	32020		\N	197305	0	10509002	260139		0
39666	2349	257012	1992-10-09	1992-10-09 00:00:00	\N	\N	32020		\N	156352	0	40055000	257012		0
50379	2980	4112343	2014-06-17	2014-06-17 00:00:00	2014-06-25	2014-06-25 00:00:00	32020		\N	198895	0	195662009	4112343		0
50529	2988	260139	2006-12-22	2006-12-22 00:00:00	2007-01-05	2007-01-05 00:00:00	32020		\N	199494	0	10509002	260139		0
50705	3000	4112343	1976-11-12	1976-11-12 00:00:00	1976-11-25	1976-11-25 00:00:00	32020		\N	200196	0	195662009	4112343		0
50840	3007	4112343	2000-04-19	2000-04-19 00:00:00	2000-04-30	2000-04-30 00:00:00	32020		\N	200620	0	195662009	4112343		0
40495	2406	40481087	1953-11-17	1953-11-17 00:00:00	1953-11-24	1953-11-24 00:00:00	32020		\N	159850	0	444814009	40481087		0
51283	3040	4059173	1976-08-31	1976-08-31 00:00:00	1976-11-29	1976-11-29 00:00:00	32020		\N	202412	0	16114001	4059173		0
51365	3047	40481087	1999-10-22	1999-10-22 00:00:00	1999-10-29	1999-10-29 00:00:00	32020		\N	202713	0	444814009	40481087		0
51512	3057	260139	1979-11-10	1979-11-10 00:00:00	1979-11-17	1979-11-17 00:00:00	32020		\N	203363	0	10509002	260139		0
51772	3069	80180	2001-10-25	2001-10-25 00:00:00	\N	\N	32020		\N	204249	0	396275006	80180		0
51883	3076	78272	1974-03-22	1974-03-22 00:00:00	1974-04-12	1974-04-12 00:00:00	32020		\N	204642	0	70704007	78272		0
52024	3081	192671	1984-05-30	1984-05-30 00:00:00	\N	\N	32020		\N	205178	0	K92.2	35208414		0
52184	3088	260139	1947-12-30	1947-12-30 00:00:00	1948-01-06	1948-01-06 00:00:00	32020		\N	205640	0	10509002	260139		0
52299	3096	40481087	2010-10-13	2010-10-13 00:00:00	2010-10-20	2010-10-20 00:00:00	32020		\N	206092	0	444814009	40481087		0
63118	3728	80180	2011-01-21	2011-01-21 00:00:00	\N	\N	32020		\N	247754	0	396275006	80180		0
52781	3125	81151	1957-07-17	1957-07-17 00:00:00	1957-07-31	1957-07-31 00:00:00	32020		\N	208004	0	44465007	81151		0
52939	3134	4112343	1996-06-06	1996-06-06 00:00:00	1996-06-18	1996-06-18 00:00:00	32020		\N	208561	0	195662009	4112343		0
63580	3754	40481087	1966-01-18	1966-01-18 00:00:00	1966-01-25	1966-01-25 00:00:00	32020		\N	249442	0	444814009	40481087		0
42592	2540	28060	1994-05-22	1994-05-22 00:00:00	1994-06-01	1994-06-01 00:00:00	32020		\N	167882	0	43878008	28060		0
42827	2551	4218389	1990-07-04	1990-07-04 00:00:00	1990-07-25	1990-07-25 00:00:00	32020		\N	168905	0	39848009	4218389		0
42935	2556	4112343	1981-05-17	1981-05-17 00:00:00	1981-05-24	1981-05-24 00:00:00	32020		\N	169420	0	195662009	4112343		0
43083	2566	260139	1946-09-18	1946-09-18 00:00:00	1946-09-25	1946-09-25 00:00:00	32020		\N	169995	0	10509002	260139		0
32695	1941	440086	1986-02-12	1986-02-12 00:00:00	1987-01-28	1987-01-28 00:00:00	32020		\N	129064	0	192127007	440086		0
43457	2589	260139	1993-07-29	1993-07-29 00:00:00	1993-08-12	1993-08-12 00:00:00	32020		\N	171337	0	10509002	260139		0
43497	2591	4310024	1972-05-02	1972-05-02 00:00:00	\N	\N	32020		\N	171482	0	424802006	4310024		0
43718	2603	40481087	1961-05-29	1961-05-29 00:00:00	1961-06-19	1961-06-19 00:00:00	32020		\N	172166	0	444814009	40481087		0
43866	2611	4112343	1954-12-14	1954-12-14 00:00:00	1954-12-21	1954-12-21 00:00:00	32020		\N	172656	0	195662009	4112343		0
44075	2621	40481087	1958-10-21	1958-10-21 00:00:00	1958-11-04	1958-11-04 00:00:00	32020		\N	173351	0	444814009	40481087		0
44227	2630	40481087	2006-10-29	2006-10-29 00:00:00	2006-11-05	2006-11-05 00:00:00	32020		\N	174012	0	444814009	40481087		0
44453	2644	260139	2006-05-26	2006-05-26 00:00:00	2006-06-02	2006-06-02 00:00:00	32020		\N	174973	0	10509002	260139		0
44617	2654	78272	2004-08-09	2004-08-09 00:00:00	2004-09-06	2004-09-06 00:00:00	32020		\N	175726	0	70704007	78272		0
44740	2661	40481087	2016-08-08	2016-08-08 00:00:00	2016-08-29	2016-08-29 00:00:00	32020		\N	176333	0	444814009	40481087		0
44909	2672	4112343	2012-09-19	2012-09-19 00:00:00	2012-09-30	2012-09-30 00:00:00	32020		\N	176891	0	195662009	4112343		0
45119	2684	78272	1977-02-09	1977-02-09 00:00:00	1977-02-23	1977-02-23 00:00:00	32020		\N	177894	0	70704007	78272		0
34693	2060	40481087	1996-05-18	1996-05-18 00:00:00	1996-06-01	1996-06-01 00:00:00	32020		\N	137008	0	444814009	40481087		0
45474	2703	40481087	1975-09-10	1975-09-10 00:00:00	1975-09-24	1975-09-24 00:00:00	32020		\N	179050	0	444814009	40481087		0
45569	2708	40481087	2005-07-15	2005-07-15 00:00:00	2005-08-05	2005-08-05 00:00:00	32020		\N	179389	0	444814009	40481087		0
45699	2715	40481087	1997-10-02	1997-10-02 00:00:00	1997-10-16	1997-10-16 00:00:00	32020		\N	180056	0	444814009	40481087		0
45871	2731	260139	1973-05-25	1973-05-25 00:00:00	1973-06-01	1973-06-01 00:00:00	32020		\N	180740	0	10509002	260139		0
46142	2749	4278672	1966-08-18	1966-08-18 00:00:00	1966-11-16	1966-11-16 00:00:00	32020		\N	181845	0	65966004	4278672		0
46228	2752	4112343	1962-01-05	1962-01-05 00:00:00	1962-01-12	1962-01-12 00:00:00	32020		\N	182102	0	195662009	4112343		0
46361	2760	372328	1959-11-13	1959-11-13 00:00:00	1960-03-03	1960-03-03 00:00:00	32020		\N	182562	0	65363002	372328		0
46481	2768	4112343	1995-11-20	1995-11-20 00:00:00	1995-11-27	1995-11-27 00:00:00	32020		\N	183136	0	195662009	4112343		0
46723	2780	28060	1958-06-10	1958-06-10 00:00:00	1958-06-18	1958-06-18 00:00:00	32020		\N	184233	0	43878008	28060		0
46858	2786	40480160	2004-01-08	2004-01-08 00:00:00	2004-03-08	2004-03-08 00:00:00	32020		\N	184614	0	443165006	40480160		0
47100	2801	372328	1923-11-09	1923-11-09 00:00:00	1924-01-25	1924-01-25 00:00:00	32020		\N	185653	0	65363002	372328		0
47210	2806	40481087	2011-10-09	2011-10-09 00:00:00	2011-10-23	2011-10-23 00:00:00	32020		\N	186007	0	444814009	40481087		0
47399	2821	260139	1999-03-26	1999-03-26 00:00:00	1999-04-02	1999-04-02 00:00:00	32020		\N	186932	0	10509002	260139		0
47544	2827	4294548	1968-01-16	1968-01-16 00:00:00	1968-04-02	1968-04-02 00:00:00	32020		\N	187507	0	75498004	4294548		0
47653	2833	4112343	1936-12-09	1936-12-09 00:00:00	1936-12-17	1936-12-17 00:00:00	32020		\N	188097	0	195662009	4112343		0
47847	2842	4237458	1964-08-24	1964-08-24 00:00:00	1964-11-22	1964-11-22 00:00:00	32020		\N	188647	0	58150001	4237458		0
48095	2853	28060	1965-07-10	1965-07-10 00:00:00	1965-07-23	1965-07-23 00:00:00	32020		\N	189504	0	43878008	28060		0
48149	2858	4155034	1950-07-19	1950-07-19 00:00:00	1950-08-02	1950-08-02 00:00:00	32020		\N	189901	0	283371005	4155034		0
37848	2242	40481087	1934-08-09	1934-08-09 00:00:00	1934-08-30	1934-08-30 00:00:00	32020		\N	149203	0	444814009	40481087		0
48593	2878	372328	1982-05-16	1982-05-16 00:00:00	1982-08-01	1982-08-01 00:00:00	32020		\N	191465	0	65363002	372328		0
48788	2891	260139	1996-05-05	1996-05-05 00:00:00	1996-05-12	1996-05-12 00:00:00	32020		\N	192324	0	10509002	260139		0
48862	2894	378419	1999-11-13	1999-11-13 00:00:00	\N	\N	32020		\N	192618	0	26929004	378419		0
49105	2905	260139	2019-06-17	2019-06-17 00:00:00	2019-07-01	2019-07-01 00:00:00	32020		\N	193603	0	10509002	260139		0
49290	2915	4112343	1986-11-13	1986-11-13 00:00:00	1986-11-24	1986-11-24 00:00:00	32020		\N	194326	0	195662009	4112343		0
49417	2921	80180	1979-05-25	1979-05-25 00:00:00	\N	\N	32020		\N	194755	0	396275006	80180		0
49544	2929	40481087	1998-12-17	1998-12-17 00:00:00	1998-12-31	1998-12-31 00:00:00	32020		\N	195367	0	444814009	40481087		0
49753	2943	40481087	2000-10-25	2000-10-25 00:00:00	2000-11-08	2000-11-08 00:00:00	32020		\N	196362	0	444814009	40481087		0
39323	2333	195588	1967-08-30	1967-08-30 00:00:00	1967-10-14	1967-10-14 00:00:00	32020		\N	155204	0	38822007	195588		0
50049	2957	260139	1991-12-03	1991-12-03 00:00:00	1991-12-10	1991-12-10 00:00:00	32020		\N	197355	0	10509002	260139		0
39667	2349	81151	1973-03-05	1973-03-05 00:00:00	1973-04-09	1973-04-09 00:00:00	32020		\N	156410	0	44465007	81151		0
50380	2980	372328	1975-02-22	1975-02-22 00:00:00	1975-07-13	1975-07-13 00:00:00	32020		\N	198896	0	65363002	372328		0
50530	2988	4112343	1979-08-08	1979-08-08 00:00:00	1979-08-17	1979-08-17 00:00:00	32020		\N	199491	0	195662009	4112343		0
50706	3000	4156265	1965-12-13	1965-12-13 00:00:00	1966-01-03	1966-01-03 00:00:00	32020		\N	200177	0	370247008	4156265		0
50841	3007	4112343	1970-05-07	1970-05-07 00:00:00	1970-05-15	1970-05-15 00:00:00	32020		\N	200630	0	195662009	4112343		0
40496	2406	40481087	1954-01-31	1954-01-31 00:00:00	1954-02-07	1954-02-07 00:00:00	32020		\N	159805	0	444814009	40481087		0
51284	3040	260139	2010-07-01	2010-07-01 00:00:00	2010-07-08	2010-07-08 00:00:00	32020		\N	202404	0	10509002	260139		0
51366	3047	4310024	2015-05-12	2015-05-12 00:00:00	\N	\N	32020		\N	202773	0	424802006	4310024		0
51513	3057	4112343	1991-06-30	1991-06-30 00:00:00	1991-07-13	1991-07-13 00:00:00	32020		\N	203365	0	195662009	4112343		0
51773	3069	40481087	2000-12-23	2000-12-23 00:00:00	2000-12-30	2000-12-30 00:00:00	32020		\N	204249	0	444814009	40481087		0
51884	3076	4142905	2017-10-20	2017-10-20 00:00:00	2017-11-19	2017-11-19 00:00:00	32020		\N	204649	0	33737001	4142905		0
52025	3081	4112343	1974-09-08	1974-09-08 00:00:00	1974-09-16	1974-09-16 00:00:00	32020		\N	205142	0	195662009	4112343		0
52188	3090	4294548	1980-11-09	1980-11-09 00:00:00	1980-11-23	1980-11-23 00:00:00	32020		\N	205707	0	75498004	4294548		0
52300	3096	4113008	2015-02-22	2015-02-22 00:00:00	2015-03-15	2015-03-15 00:00:00	32020		\N	206079	0	284549007	4113008		0
63119	3728	40481087	1988-01-07	1988-01-07 00:00:00	1988-01-14	1988-01-14 00:00:00	32020		\N	247728	0	444814009	40481087		0
52782	3125	40481087	1982-05-05	1982-05-05 00:00:00	1982-05-19	1982-05-19 00:00:00	32020		\N	207928	0	444814009	40481087		0
52940	3134	40481087	1988-03-06	1988-03-06 00:00:00	1988-03-27	1988-03-27 00:00:00	32020		\N	208624	0	444814009	40481087		0
63581	3754	81151	2019-05-15	2019-05-15 00:00:00	2019-05-29	2019-05-29 00:00:00	32020		\N	249554	0	44465007	81151		0
42593	2540	4112343	1992-09-15	1992-09-15 00:00:00	1992-09-28	1992-09-28 00:00:00	32020		\N	167881	0	195662009	4112343		0
42828	2551	372328	1959-03-19	1959-03-19 00:00:00	1959-04-30	1959-04-30 00:00:00	32020		\N	168879	0	65363002	372328		0
42936	2556	40481087	1998-08-06	1998-08-06 00:00:00	1998-08-27	1998-08-27 00:00:00	32020		\N	169388	0	444814009	40481087		0
43084	2566	4218389	2012-01-07	2012-01-07 00:00:00	2012-02-11	2012-02-11 00:00:00	32020		\N	170037	0	39848009	4218389		0
32696	1941	4059173	1981-11-21	1981-11-21 00:00:00	1981-12-21	1981-12-21 00:00:00	32020		\N	129099	0	16114001	4059173		0
43458	2589	4283893	1998-09-01	1998-09-01 00:00:00	1998-10-13	1998-10-13 00:00:00	32020		\N	171344	0	36971009	4283893		0
43498	2591	257012	1971-11-06	1971-11-06 00:00:00	\N	\N	32020		\N	171480	0	40055000	257012		0
43719	2603	40481087	2008-01-05	2008-01-05 00:00:00	2008-01-12	2008-01-12 00:00:00	32020		\N	172234	0	444814009	40481087		0
43867	2611	40481087	2015-07-04	2015-07-04 00:00:00	2015-07-18	2015-07-18 00:00:00	32020		\N	172670	0	444814009	40481087		0
44076	2621	260139	1986-01-29	1986-01-29 00:00:00	1986-02-12	1986-02-12 00:00:00	32020		\N	173382	0	10509002	260139		0
44228	2630	40481087	1993-01-15	1993-01-15 00:00:00	1993-02-05	1993-02-05 00:00:00	32020		\N	173933	0	444814009	40481087		0
44454	2644	372328	1985-05-28	1985-05-28 00:00:00	1986-01-27	1986-01-27 00:00:00	32020		\N	174964	0	65363002	372328		0
44618	2654	378001	1997-11-14	1997-11-14 00:00:00	1997-12-14	1997-12-14 00:00:00	32020		\N	175725	0	62106007	378001		0
44741	2661	4112343	1966-02-07	1966-02-07 00:00:00	1966-02-20	1966-02-20 00:00:00	32020		\N	176266	0	195662009	4112343		0
44910	2673	4218389	2017-07-07	2017-07-07 00:00:00	2017-08-11	2017-08-11 00:00:00	32020		\N	177101	0	39848009	4218389		0
45120	2684	4112343	2014-12-17	2014-12-17 00:00:00	2014-12-29	2014-12-29 00:00:00	32020		\N	177825	0	195662009	4112343		0
34694	2060	372328	1968-06-10	1968-06-10 00:00:00	1968-11-20	1968-11-20 00:00:00	32020		\N	137012	0	65363002	372328		0
45475	2703	257012	1974-10-05	1974-10-05 00:00:00	\N	\N	32020		\N	179082	0	40055000	257012		0
45570	2708	260139	1983-08-03	1983-08-03 00:00:00	1983-08-10	1983-08-10 00:00:00	32020		\N	179351	0	10509002	260139		0
45700	2715	257012	1973-03-14	1973-03-14 00:00:00	\N	\N	32020		\N	180039	0	40055000	257012		0
45872	2731	81151	2001-07-19	2001-07-19 00:00:00	2001-08-09	2001-08-09 00:00:00	32020		\N	180793	0	44465007	81151		0
46143	2749	40481087	2018-01-13	2018-01-13 00:00:00	2018-01-27	2018-01-27 00:00:00	32020		\N	181792	0	444814009	40481087		0
46229	2752	257012	1993-12-18	1993-12-18 00:00:00	1994-05-21	1994-05-21 00:00:00	32020		\N	182033	0	40055000	257012		0
46362	2761	4112343	1997-05-12	1997-05-12 00:00:00	1997-05-23	1997-05-23 00:00:00	32020		\N	182627	0	195662009	4112343		0
46482	2768	260139	2002-08-26	2002-08-26 00:00:00	2002-09-09	2002-09-09 00:00:00	32020		\N	183123	0	10509002	260139		0
46724	2780	40481087	2014-07-26	2014-07-26 00:00:00	2014-08-09	2014-08-09 00:00:00	32020		\N	184224	0	444814009	40481087		0
46859	2786	4059173	2004-01-08	2004-01-08 00:00:00	2004-03-08	2004-03-08 00:00:00	32020		\N	184614	0	16114001	4059173		0
47101	2801	4112343	1990-02-09	1990-02-09 00:00:00	1990-02-17	1990-02-17 00:00:00	32020		\N	185651	0	195662009	4112343		0
47211	2806	4134304	1982-01-10	1982-01-10 00:00:00	1982-04-10	1982-04-10 00:00:00	32020		\N	185960	0	263102004	4134304		0
47400	2821	28060	1927-03-14	1927-03-14 00:00:00	1927-03-23	1927-03-23 00:00:00	32020		\N	186947	0	43878008	28060		0
47545	2827	81151	1984-04-08	1984-04-08 00:00:00	1984-05-13	1984-05-13 00:00:00	32020		\N	187512	0	44465007	81151		0
47654	2833	378419	2008-02-18	2008-02-18 00:00:00	\N	\N	32020		\N	188019	0	26929004	378419		0
47848	2842	260139	1989-07-14	1989-07-14 00:00:00	1989-07-23	1989-07-23 00:00:00	32020		\N	188677	0	10509002	260139		0
48096	2853	4112343	1974-01-09	1974-01-09 00:00:00	1974-01-20	1974-01-20 00:00:00	32020		\N	189546	0	195662009	4112343		0
48150	2858	4152936	2018-04-12	2018-04-12 00:00:00	2018-04-26	2018-04-26 00:00:00	32020		\N	189896	0	283385000	4152936		0
48307	2862	40481087	1980-03-17	1980-03-17 00:00:00	1980-04-07	1980-04-07 00:00:00	32020		\N	190269	0	444814009	40481087		0
48594	2878	4152936	1994-06-01	1994-06-01 00:00:00	1994-06-22	1994-06-22 00:00:00	32020		\N	191451	0	283385000	4152936		0
48789	2891	78272	2017-02-07	2017-02-07 00:00:00	2017-02-28	2017-02-28 00:00:00	32020		\N	192316	0	70704007	78272		0
48863	2894	4112343	1996-02-06	1996-02-06 00:00:00	1996-02-18	1996-02-18 00:00:00	32020		\N	192585	0	195662009	4112343		0
49106	2905	4112343	1986-05-15	1986-05-15 00:00:00	1986-05-25	1986-05-25 00:00:00	32020		\N	193596	0	195662009	4112343		0
49291	2915	40481087	1999-11-06	1999-11-06 00:00:00	1999-11-20	1999-11-20 00:00:00	32020		\N	194272	0	444814009	40481087		0
49418	2921	40481087	1970-10-16	1970-10-16 00:00:00	1970-10-23	1970-10-23 00:00:00	32020		\N	194707	0	444814009	40481087		0
49545	2929	40481087	1989-09-02	1989-09-02 00:00:00	1989-09-16	1989-09-16 00:00:00	32020		\N	195393	0	444814009	40481087		0
49754	2943	4112343	1989-02-19	1989-02-19 00:00:00	1989-03-01	1989-03-01 00:00:00	32020		\N	196322	0	195662009	4112343		0
39324	2333	40481087	1985-08-20	1985-08-20 00:00:00	1985-09-10	1985-09-10 00:00:00	32020		\N	155134	0	444814009	40481087		0
50050	2957	40481087	1950-09-04	1950-09-04 00:00:00	1950-09-24	1950-09-24 00:00:00	32020		\N	197373	0	444814009	40481087		0
39668	2349	4027663	1997-04-03	1997-04-03 00:00:00	\N	\N	32020		\N	156389	0	13200003	4027663		0
50381	2980	260139	1983-05-22	1983-05-22 00:00:00	1983-05-29	1983-05-29 00:00:00	32020		\N	199000	0	10509002	260139		0
50531	2988	260139	2002-10-22	2002-10-22 00:00:00	2002-11-05	2002-11-05 00:00:00	32020		\N	199471	0	10509002	260139		0
50707	3000	4134304	1961-04-08	1961-04-08 00:00:00	1961-07-07	1961-07-07 00:00:00	32020		\N	200176	0	263102004	4134304		0
50842	3007	78272	2006-09-18	2006-09-18 00:00:00	2006-10-02	2006-10-02 00:00:00	32020		\N	200603	0	70704007	78272		0
40497	2406	260139	1954-09-07	1954-09-07 00:00:00	1954-09-21	1954-09-21 00:00:00	32020		\N	159812	0	10509002	260139		0
51285	3040	4112343	1990-08-22	1990-08-22 00:00:00	1990-09-03	1990-09-03 00:00:00	32020		\N	202367	0	195662009	4112343		0
51367	3047	40481087	1985-09-09	1985-09-09 00:00:00	1985-09-30	1985-09-30 00:00:00	32020		\N	202720	0	444814009	40481087		0
51514	3057	381316	2016-10-24	2016-10-24 00:00:00	\N	\N	32020		\N	203431	0	230690007	381316		0
51774	3069	4283893	1977-09-27	1977-09-27 00:00:00	1978-01-24	1978-01-24 00:00:00	32020		\N	204300	0	36971009	4283893		0
51885	3077	260139	2013-04-01	2013-04-01 00:00:00	2013-04-08	2013-04-08 00:00:00	32020		\N	204750	0	10509002	260139		0
52026	3081	4112343	1970-09-15	1970-09-15 00:00:00	1970-09-27	1970-09-27 00:00:00	32020		\N	205158	0	195662009	4112343		0
52189	3090	260139	1989-10-28	1989-10-28 00:00:00	1989-11-11	1989-11-11 00:00:00	32020		\N	205755	0	10509002	260139		0
52301	3096	4112343	1999-03-15	1999-03-15 00:00:00	1999-03-27	1999-03-27 00:00:00	32020		\N	206053	0	195662009	4112343		0
63120	3728	4155034	1995-04-13	1995-04-13 00:00:00	1995-05-04	1995-05-04 00:00:00	32020		\N	247696	0	283371005	4155034		0
52783	3125	81151	2003-03-10	2003-03-10 00:00:00	2003-04-14	2003-04-14 00:00:00	32020		\N	207929	0	44465007	81151		0
52941	3134	260139	1974-03-22	1974-03-22 00:00:00	1974-04-05	1974-04-05 00:00:00	32020		\N	208559	0	10509002	260139		0
63582	3754	40481087	2011-10-05	2011-10-05 00:00:00	2011-10-26	2011-10-26 00:00:00	32020		\N	249556	0	444814009	40481087		0
42594	2540	40481087	1939-03-18	1939-03-18 00:00:00	1939-04-08	1939-04-08 00:00:00	32020		\N	167887	0	444814009	40481087		0
53287	3157	4112343	1970-06-07	1970-06-07 00:00:00	1970-06-19	1970-06-19 00:00:00	32020		\N	209892	0	195662009	4112343		0
42937	2556	260139	1982-07-01	1982-07-01 00:00:00	1982-07-15	1982-07-15 00:00:00	32020		\N	169394	0	10509002	260139		0
43085	2566	28060	1947-10-24	1947-10-24 00:00:00	1947-10-31	1947-10-31 00:00:00	32020		\N	170007	0	43878008	28060		0
32697	1941	260139	1997-03-18	1997-03-18 00:00:00	1997-04-01	1997-04-01 00:00:00	32020		\N	129038	0	10509002	260139		0
43459	2589	80180	2015-10-30	2015-10-30 00:00:00	\N	\N	32020		\N	171328	0	396275006	80180		0
43499	2591	372328	2017-02-19	2017-02-19 00:00:00	2017-04-12	2017-04-12 00:00:00	32020		\N	171430	0	65363002	372328		0
43720	2603	4113008	2012-03-28	2012-03-28 00:00:00	2012-04-18	2012-04-18 00:00:00	32020		\N	172169	0	284549007	4113008		0
43868	2611	40481087	1981-08-29	1981-08-29 00:00:00	1981-09-19	1981-09-19 00:00:00	32020		\N	172684	0	444814009	40481087		0
44077	2621	4155034	1966-09-16	1966-09-16 00:00:00	1966-10-07	1966-10-07 00:00:00	32020		\N	173398	0	283371005	4155034		0
44229	2630	260139	2008-08-22	2008-08-22 00:00:00	2008-08-29	2008-08-29 00:00:00	32020		\N	173952	0	10509002	260139		0
44455	2644	260139	2018-10-28	2018-10-28 00:00:00	2018-11-04	2018-11-04 00:00:00	32020		\N	174963	0	10509002	260139		0
44619	2654	260139	1968-05-21	1968-05-21 00:00:00	1968-06-04	1968-06-04 00:00:00	32020		\N	175713	0	10509002	260139		0
44742	2661	4283893	1981-01-17	1981-01-17 00:00:00	1981-03-21	1981-03-21 00:00:00	32020		\N	176297	0	36971009	4283893		0
44911	2673	257012	2003-08-06	2003-08-06 00:00:00	\N	\N	32020		\N	177074	0	40055000	257012		0
45121	2684	4112343	2005-11-10	2005-11-10 00:00:00	2005-11-19	2005-11-19 00:00:00	32020		\N	177879	0	195662009	4112343		0
45153	2685	4112343	2011-12-20	2011-12-20 00:00:00	2011-12-28	2011-12-28 00:00:00	32020		\N	177946	0	195662009	4112343		0
45476	2703	81151	2008-09-17	2008-09-17 00:00:00	2008-10-08	2008-10-08 00:00:00	32020		\N	179109	0	44465007	81151		0
45571	2708	4237458	1973-01-28	1973-01-28 00:00:00	1973-04-28	1973-04-28 00:00:00	32020		\N	179429	0	58150001	4237458		0
45701	2715	4112343	2006-09-28	2006-09-28 00:00:00	2006-10-11	2006-10-11 00:00:00	32020		\N	180016	0	195662009	4112343		0
45873	2731	40481087	1966-01-20	1966-01-20 00:00:00	1966-02-03	1966-02-03 00:00:00	32020		\N	180754	0	444814009	40481087		0
46144	2749	4112343	2006-02-19	2006-02-19 00:00:00	2006-02-27	2006-02-27 00:00:00	32020		\N	181822	0	195662009	4112343		0
46230	2752	140673	2004-03-04	2004-03-04 00:00:00	\N	\N	32020		\N	182104	0	40930008	140673		0
46363	2761	80180	2017-07-04	2017-07-04 00:00:00	\N	\N	32020		\N	182667	0	396275006	80180		0
46483	2768	40481087	1975-08-06	1975-08-06 00:00:00	1975-08-13	1975-08-13 00:00:00	32020		\N	183134	0	444814009	40481087		0
46725	2780	260139	2008-02-07	2008-02-07 00:00:00	2008-02-14	2008-02-14 00:00:00	32020		\N	184237	0	10509002	260139		0
46860	2786	372328	2004-02-10	2004-02-10 00:00:00	2004-12-11	2004-12-11 00:00:00	32020		\N	184622	0	65363002	372328		0
47102	2801	40481087	1957-07-10	1957-07-10 00:00:00	1957-07-31	1957-07-31 00:00:00	32020		\N	185594	0	444814009	40481087		0
47262	2812	378001	1939-07-01	1939-07-01 00:00:00	1939-08-30	1939-08-30 00:00:00	32020		\N	186281	0	62106007	378001		0
47401	2821	257012	1925-08-25	1925-08-25 00:00:00	\N	\N	32020		\N	186916	0	40055000	257012		0
47546	2827	260139	1945-07-21	1945-07-21 00:00:00	1945-08-04	1945-08-04 00:00:00	32020		\N	187469	0	10509002	260139		0
47655	2833	4112343	1972-05-05	1972-05-05 00:00:00	1972-05-14	1972-05-14 00:00:00	32020		\N	188021	0	195662009	4112343		0
47849	2842	260139	1973-01-10	1973-01-10 00:00:00	1973-01-17	1973-01-17 00:00:00	32020		\N	188644	0	10509002	260139		0
48097	2853	257012	1982-11-18	1982-11-18 00:00:00	\N	\N	32020		\N	189506	0	40055000	257012		0
48151	2858	4112343	2013-07-12	2013-07-12 00:00:00	2013-07-24	2013-07-24 00:00:00	32020		\N	189885	0	195662009	4112343		0
48308	2862	40481087	2010-05-16	2010-05-16 00:00:00	2010-05-30	2010-05-30 00:00:00	32020		\N	190312	0	444814009	40481087		0
48595	2878	40481087	1998-11-09	1998-11-09 00:00:00	1998-11-16	1998-11-16 00:00:00	32020		\N	191411	0	444814009	40481087		0
48790	2891	4112343	1977-02-08	1977-02-08 00:00:00	1977-02-18	1977-02-18 00:00:00	32020		\N	192344	0	195662009	4112343		0
48864	2894	40481087	1994-11-26	1994-11-26 00:00:00	1994-12-03	1994-12-03 00:00:00	32020		\N	192584	0	444814009	40481087		0
49107	2905	4285898	1998-12-10	1998-12-10 00:00:00	\N	\N	32020		\N	193559	0	68496003	4285898		0
49292	2915	40481087	1947-04-01	1947-04-01 00:00:00	1947-04-22	1947-04-22 00:00:00	32020		\N	194291	0	444814009	40481087		0
49419	2921	81151	2005-11-09	2005-11-09 00:00:00	2005-11-30	2005-11-30 00:00:00	32020		\N	194717	0	44465007	81151		0
49546	2929	80180	2014-08-22	2014-08-22 00:00:00	\N	\N	32020		\N	195388	0	396275006	80180		0
49755	2943	40481087	1972-08-12	1972-08-12 00:00:00	1972-08-19	1972-08-19 00:00:00	32020		\N	196360	0	444814009	40481087		0
39325	2333	260139	1953-09-18	1953-09-18 00:00:00	1953-09-25	1953-09-25 00:00:00	32020		\N	155238	0	10509002	260139		0
50051	2957	40481087	1973-05-26	1973-05-26 00:00:00	1973-06-09	1973-06-09 00:00:00	32020		\N	197299	0	444814009	40481087		0
39669	2349	4134304	1987-02-09	1987-02-09 00:00:00	1987-05-10	1987-05-10 00:00:00	32020		\N	156412	0	263102004	4134304		0
50382	2980	40481087	1984-04-16	1984-04-16 00:00:00	1984-05-07	1984-05-07 00:00:00	32020		\N	198967	0	444814009	40481087		0
50532	2989	4294548	1976-06-02	1976-06-02 00:00:00	1976-06-09	1976-06-09 00:00:00	32020		\N	199553	0	75498004	4294548		0
50708	3000	4112343	2013-04-03	2013-04-03 00:00:00	2013-04-12	2013-04-12 00:00:00	32020		\N	200200	0	195662009	4112343		0
50843	3007	260139	1999-06-20	1999-06-20 00:00:00	1999-06-27	1999-06-27 00:00:00	32020		\N	200578	0	10509002	260139		0
40498	2406	40481087	1980-08-27	1980-08-27 00:00:00	1980-09-10	1980-09-10 00:00:00	32020		\N	159832	0	444814009	40481087		0
51286	3040	80180	2010-09-27	2010-09-27 00:00:00	\N	\N	32020		\N	202410	0	396275006	80180		0
51368	3047	4112343	1993-01-07	1993-01-07 00:00:00	1993-01-20	1993-01-20 00:00:00	32020		\N	202722	0	195662009	4112343		0
51515	3057	40481087	1985-12-01	1985-12-01 00:00:00	1985-12-08	1985-12-08 00:00:00	32020		\N	203364	0	444814009	40481087		0
51775	3069	40479422	1986-08-01	1986-08-01 00:00:00	1986-10-07	1986-10-07 00:00:00	32020		\N	204312	0	444448004	40479422		0
51886	3077	80180	1992-05-03	1992-05-03 00:00:00	\N	\N	32020		\N	204723	0	396275006	80180		0
52027	3081	4027663	1976-01-16	1976-01-16 00:00:00	\N	\N	32020		\N	205169	0	13200003	4027663		0
52190	3090	80180	2001-02-02	2001-02-02 00:00:00	\N	\N	32020		\N	205742	0	396275006	80180		0
52302	3096	4112343	2016-07-11	2016-07-11 00:00:00	2016-07-19	2016-07-19 00:00:00	32020		\N	206094	0	195662009	4112343		0
63134	3730	40481087	1992-01-02	1992-01-02 00:00:00	1992-01-16	1992-01-16 00:00:00	32020		\N	247846	0	444814009	40481087		0
52784	3125	40481087	1985-02-09	1985-02-09 00:00:00	1985-02-23	1985-02-23 00:00:00	32020		\N	207995	0	444814009	40481087		0
52942	3134	4283893	2016-11-24	2016-11-24 00:00:00	2016-12-15	2016-12-15 00:00:00	32020		\N	208539	0	36971009	4283893		0
63583	3754	40481087	1963-06-20	1963-06-20 00:00:00	1963-06-27	1963-06-27 00:00:00	32020		\N	249502	0	444814009	40481087		0
42595	2540	81893	1973-11-08	1973-11-08 00:00:00	\N	\N	32020		\N	167987	0	64766004	81893		0
53288	3158	4278672	1964-05-22	1964-05-22 00:00:00	1964-06-21	1964-06-21 00:00:00	32020		\N	209945	0	65966004	4278672		0
42938	2556	260139	1978-05-14	1978-05-14 00:00:00	1978-05-21	1978-05-21 00:00:00	32020		\N	169419	0	10509002	260139		0
43086	2566	4059173	2014-01-01	2014-01-01 00:00:00	2014-03-02	2014-03-02 00:00:00	32020		\N	170038	0	16114001	4059173		0
32698	1941	4155034	1974-01-11	1974-01-11 00:00:00	1974-02-01	1974-02-01 00:00:00	32020		\N	129098	0	283371005	4155034		0
43460	2589	257012	1998-09-29	1998-09-29 00:00:00	\N	\N	32020		\N	171312	0	40055000	257012		0
43500	2591	372328	1963-11-26	1963-11-26 00:00:00	1966-05-25	1966-05-25 00:00:00	32020		\N	171459	0	65363002	372328		0
43721	2603	40481087	1996-06-08	1996-06-08 00:00:00	1996-06-29	1996-06-29 00:00:00	32020		\N	172194	0	444814009	40481087		0
43873	2613	260139	1965-08-05	1965-08-05 00:00:00	1965-08-12	1965-08-12 00:00:00	32020		\N	172746	0	10509002	260139		0
44078	2621	4027663	1986-08-18	1986-08-18 00:00:00	\N	\N	32020		\N	173370	0	13200003	4027663		0
44230	2630	260139	1980-04-27	1980-04-27 00:00:00	1980-05-04	1980-05-04 00:00:00	32020		\N	173949	0	10509002	260139		0
44456	2644	4112343	1985-01-19	1985-01-19 00:00:00	1985-01-29	1985-01-29 00:00:00	32020		\N	174974	0	195662009	4112343		0
44620	2654	260139	1955-01-06	1955-01-06 00:00:00	1955-01-20	1955-01-20 00:00:00	32020		\N	175710	0	10509002	260139		0
44743	2661	4112343	1976-10-21	1976-10-21 00:00:00	1976-10-30	1976-10-30 00:00:00	32020		\N	176296	0	195662009	4112343		0
44912	2673	80180	2016-08-16	2016-08-16 00:00:00	\N	\N	32020		\N	177063	0	396275006	80180		0
45122	2684	260139	2014-07-23	2014-07-23 00:00:00	2014-08-06	2014-08-06 00:00:00	32020		\N	177889	0	10509002	260139		0
45154	2686	4112343	2013-08-23	2013-08-23 00:00:00	2013-09-04	2013-09-04 00:00:00	32020		\N	178033	0	195662009	4112343		0
45477	2703	192671	2014-05-11	2014-05-11 00:00:00	\N	\N	32020		\N	179069	0	K92.2	35208414		0
45572	2708	40481087	1980-05-20	1980-05-20 00:00:00	1980-06-03	1980-06-03 00:00:00	32020		\N	179361	0	444814009	40481087		0
45703	2715	4329847	2017-11-23	2017-11-23 00:00:00	\N	\N	32020		\N	179971	0	22298006	4329847		0
45874	2731	81151	1975-07-14	1975-07-14 00:00:00	1975-08-11	1975-08-11 00:00:00	32020		\N	180818	0	44465007	81151		0
46145	2749	4156265	1983-05-31	1983-05-31 00:00:00	1983-06-21	1983-06-21 00:00:00	32020		\N	181849	0	370247008	4156265		0
46231	2752	4294548	1993-09-25	1993-09-25 00:00:00	1994-05-21	1994-05-21 00:00:00	32020		\N	182032	0	75498004	4294548		0
46364	2761	260139	2011-07-06	2011-07-06 00:00:00	2011-07-13	2011-07-13 00:00:00	32020		\N	182638	0	10509002	260139		0
46484	2768	4152936	1988-02-15	1988-02-15 00:00:00	1988-03-07	1988-03-07 00:00:00	32020		\N	183163	0	283385000	4152936		0
46726	2780	372328	1956-02-17	1956-02-17 00:00:00	1956-04-25	1956-04-25 00:00:00	32020		\N	184228	0	65363002	372328		0
46861	2786	4059173	1926-03-13	1926-03-13 00:00:00	1926-05-12	1926-05-12 00:00:00	32020		\N	184606	0	16114001	4059173		0
47103	2801	78272	1977-07-31	1977-07-31 00:00:00	1977-09-04	1977-09-04 00:00:00	32020		\N	185606	0	70704007	78272		0
47263	2812	40481087	1959-06-19	1959-06-19 00:00:00	1959-07-10	1959-07-10 00:00:00	32020		\N	186320	0	444814009	40481087		0
47402	2821	378001	1991-06-29	1991-06-29 00:00:00	1991-07-29	1991-07-29 00:00:00	32020		\N	186854	0	62106007	378001		0
47547	2827	378001	1945-03-20	1945-03-20 00:00:00	1945-05-19	1945-05-19 00:00:00	32020		\N	187510	0	62106007	378001		0
47656	2833	260139	1980-04-01	1980-04-01 00:00:00	1980-04-08	1980-04-08 00:00:00	32020		\N	188037	0	10509002	260139		0
47850	2842	40481087	2004-11-27	2004-11-27 00:00:00	2004-12-18	2004-12-18 00:00:00	32020		\N	188699	0	444814009	40481087		0
48098	2853	4112343	1963-07-26	1963-07-26 00:00:00	1963-08-04	1963-08-04 00:00:00	32020		\N	189548	0	195662009	4112343		0
48152	2858	40481087	2017-10-22	2017-10-22 00:00:00	2017-10-29	2017-10-29 00:00:00	32020		\N	189839	0	444814009	40481087		0
48309	2862	4112343	1989-07-29	1989-07-29 00:00:00	1989-08-05	1989-08-05 00:00:00	32020		\N	190272	0	195662009	4112343		0
48596	2878	4112343	2016-11-10	2016-11-10 00:00:00	2016-11-20	2016-11-20 00:00:00	32020		\N	191464	0	195662009	4112343		0
48791	2891	257012	1979-12-25	1979-12-25 00:00:00	\N	\N	32020		\N	192355	0	40055000	257012		0
48865	2894	78272	1956-07-01	1956-07-01 00:00:00	1956-07-29	1956-07-29 00:00:00	32020		\N	192598	0	70704007	78272		0
49108	2905	372328	1974-06-06	1974-06-06 00:00:00	1974-11-25	1974-11-25 00:00:00	32020		\N	193587	0	65363002	372328		0
49293	2915	40481087	1993-05-18	1993-05-18 00:00:00	1993-06-01	1993-06-01 00:00:00	32020		\N	194400	0	444814009	40481087		0
49420	2921	40481087	1985-05-14	1985-05-14 00:00:00	1985-05-21	1985-05-21 00:00:00	32020		\N	194708	0	444814009	40481087		0
49547	2929	4112343	1999-02-21	1999-02-21 00:00:00	1999-03-01	1999-03-01 00:00:00	32020		\N	195389	0	195662009	4112343		0
49756	2943	4134304	1997-02-05	1997-02-05 00:00:00	1997-03-07	1997-03-07 00:00:00	32020		\N	196325	0	263102004	4134304		0
39326	2333	80180	1957-04-13	1957-04-13 00:00:00	\N	\N	32020		\N	155186	0	396275006	80180		0
50052	2957	260139	1949-06-24	1949-06-24 00:00:00	1949-07-08	1949-07-08 00:00:00	32020		\N	197372	0	10509002	260139		0
39670	2349	4112343	2016-09-01	2016-09-01 00:00:00	2016-09-11	2016-09-11 00:00:00	32020		\N	156334	0	195662009	4112343		0
50383	2980	372328	1974-06-06	1974-06-06 00:00:00	1974-11-24	1974-11-24 00:00:00	32020		\N	198995	0	65363002	372328		0
50534	2989	4156265	2010-07-16	2010-07-16 00:00:00	2010-08-06	2010-08-06 00:00:00	32020		\N	199591	0	370247008	4156265		0
50709	3000	372328	1948-09-13	1948-09-13 00:00:00	1948-12-24	1948-12-24 00:00:00	32020		\N	200154	0	65363002	372328		0
50844	3007	40481087	2010-08-21	2010-08-21 00:00:00	2010-09-04	2010-09-04 00:00:00	32020		\N	200622	0	444814009	40481087		0
40499	2406	4112343	1982-03-21	1982-03-21 00:00:00	1982-03-28	1982-03-28 00:00:00	32020		\N	159843	0	195662009	4112343		0
51287	3040	4294548	1978-10-13	1978-10-13 00:00:00	1978-10-27	1978-10-27 00:00:00	32020		\N	202365	0	75498004	4294548		0
51369	3047	4116491	2007-07-18	2007-07-18 00:00:00	2007-08-18	2007-08-18 00:00:00	32020		\N	202723	0	301011002	4116491		0
51516	3057	80180	1973-06-14	1973-06-14 00:00:00	\N	\N	32020		\N	203349	0	396275006	80180		0
51776	3069	257012	1977-12-06	1977-12-06 00:00:00	\N	\N	32020		\N	204287	0	40055000	257012		0
52028	3081	4218389	1976-07-14	1976-07-14 00:00:00	1976-08-11	1976-08-11 00:00:00	32020		\N	205134	0	39848009	4218389		0
52191	3090	40481087	1966-03-05	1966-03-05 00:00:00	1966-03-26	1966-03-26 00:00:00	32020		\N	205706	0	444814009	40481087		0
52303	3096	4112343	1968-05-02	1968-05-02 00:00:00	1968-05-11	1968-05-11 00:00:00	32020		\N	206100	0	195662009	4112343		0
63135	3730	257012	1984-03-23	1984-03-23 00:00:00	\N	\N	32020		\N	247811	0	40055000	257012		0
52785	3125	4112343	2017-10-18	2017-10-18 00:00:00	2017-10-28	2017-10-28 00:00:00	32020		\N	207949	0	195662009	4112343		0
52943	3134	28060	1945-09-20	1945-09-20 00:00:00	1945-09-30	1945-09-30 00:00:00	32020		\N	208538	0	43878008	28060		0
63584	3754	40481087	2017-01-29	2017-01-29 00:00:00	2017-02-05	2017-02-05 00:00:00	32020		\N	249541	0	444814009	40481087		0
42596	2540	4310024	1973-01-12	1973-01-12 00:00:00	\N	\N	32020		\N	167987	0	424802006	4310024		0
53289	3158	260139	1985-10-20	1985-10-20 00:00:00	1985-11-03	1985-11-03 00:00:00	32020		\N	209965	0	10509002	260139		0
42939	2556	4112343	2012-01-16	2012-01-16 00:00:00	2012-01-25	2012-01-25 00:00:00	32020		\N	169396	0	195662009	4112343		0
43087	2566	40481087	2016-08-26	2016-08-26 00:00:00	2016-09-16	2016-09-16 00:00:00	32020		\N	170039	0	444814009	40481087		0
32699	1941	40481087	1979-12-16	1979-12-16 00:00:00	1979-12-23	1979-12-23 00:00:00	32020		\N	129071	0	444814009	40481087		0
43461	2589	4112343	1990-04-15	1990-04-15 00:00:00	1990-04-26	1990-04-26 00:00:00	32020		\N	171331	0	195662009	4112343		0
43501	2591	4294548	1954-12-07	1954-12-07 00:00:00	1954-12-14	1954-12-14 00:00:00	32020		\N	171509	0	75498004	4294548		0
43722	2603	80180	1996-09-03	1996-09-03 00:00:00	\N	\N	32020		\N	172194	0	396275006	80180		0
43874	2613	4152936	1958-11-23	1958-11-23 00:00:00	1958-12-07	1958-12-07 00:00:00	32020		\N	172816	0	283385000	4152936		0
44079	2621	4112343	1961-01-03	1961-01-03 00:00:00	1961-01-11	1961-01-11 00:00:00	32020		\N	173380	0	195662009	4112343		0
44231	2630	4112343	1991-03-03	1991-03-03 00:00:00	1991-03-11	1991-03-11 00:00:00	32020		\N	173932	0	195662009	4112343		0
44457	2644	40481087	2004-03-20	2004-03-20 00:00:00	2004-03-27	2004-03-27 00:00:00	32020		\N	174972	0	444814009	40481087		0
44621	2654	40481087	2014-03-31	2014-03-31 00:00:00	2014-04-14	2014-04-14 00:00:00	32020		\N	175660	0	444814009	40481087		0
44744	2661	40481087	1991-09-30	1991-09-30 00:00:00	1991-10-21	1991-10-21 00:00:00	32020		\N	176374	0	444814009	40481087		0
44913	2673	40481087	2015-06-24	2015-06-24 00:00:00	2015-07-15	2015-07-15 00:00:00	32020		\N	177063	0	444814009	40481087		0
45123	2684	40481087	1961-03-19	1961-03-19 00:00:00	1961-04-02	1961-04-02 00:00:00	32020		\N	177891	0	444814009	40481087		0
45155	2686	4152936	1998-06-27	1998-06-27 00:00:00	1998-07-11	1998-07-11 00:00:00	32020		\N	178073	0	283385000	4152936		0
45478	2703	40481087	1998-07-26	1998-07-26 00:00:00	1998-08-09	1998-08-09 00:00:00	32020		\N	179099	0	444814009	40481087		0
45573	2708	78272	1993-11-02	1993-11-02 00:00:00	1993-11-23	1993-11-23 00:00:00	32020		\N	179432	0	70704007	78272		0
45704	2715	440448	1989-01-08	1989-01-08 00:00:00	\N	\N	32020		\N	179969	0	74400008	440448		0
45875	2731	40481087	2009-05-08	2009-05-08 00:00:00	2009-05-15	2009-05-15 00:00:00	32020		\N	180824	0	444814009	40481087		0
46146	2749	40481087	1967-06-23	1967-06-23 00:00:00	1967-06-30	1967-06-30 00:00:00	32020		\N	181830	0	444814009	40481087		0
46232	2752	260139	1964-12-08	1964-12-08 00:00:00	1964-12-15	1964-12-15 00:00:00	32020		\N	182060	0	10509002	260139		0
46365	2761	260139	1982-09-08	1982-09-08 00:00:00	1982-09-15	1982-09-15 00:00:00	32020		\N	182646	0	10509002	260139		0
46485	2768	28060	2006-04-04	2006-04-04 00:00:00	2006-04-16	2006-04-16 00:00:00	32020		\N	183142	0	43878008	28060		0
46727	2780	260139	1979-05-05	1979-05-05 00:00:00	1979-05-12	1979-05-12 00:00:00	32020		\N	184235	0	10509002	260139		0
46862	2786	4152936	1936-09-16	1936-09-16 00:00:00	1936-09-30	1936-09-30 00:00:00	32020		\N	184607	0	283385000	4152936		0
47104	2801	4296204	1985-03-26	1985-03-26 00:00:00	1985-04-23	1985-04-23 00:00:00	32020		\N	185616	0	403190006	4296204		0
47264	2812	40481087	1981-08-26	1981-08-26 00:00:00	1981-09-02	1981-09-02 00:00:00	32020		\N	186303	0	444814009	40481087		0
47403	2821	260139	1936-11-05	1936-11-05 00:00:00	1936-11-19	1936-11-19 00:00:00	32020		\N	186917	0	10509002	260139		0
47548	2827	4152936	1968-03-19	1968-03-19 00:00:00	1968-04-02	1968-04-02 00:00:00	32020		\N	187511	0	283385000	4152936		0
47657	2833	28060	2001-09-22	2001-09-22 00:00:00	2001-09-30	2001-09-30 00:00:00	32020		\N	188024	0	43878008	28060		0
47851	2842	260139	2002-02-23	2002-02-23 00:00:00	2002-03-02	2002-03-02 00:00:00	32020		\N	188650	0	10509002	260139		0
48099	2853	4112343	2014-09-17	2014-09-17 00:00:00	2014-09-25	2014-09-25 00:00:00	32020		\N	189536	0	195662009	4112343		0
48153	2858	4283893	1929-01-18	1929-01-18 00:00:00	1929-04-26	1929-04-26 00:00:00	32020		\N	189906	0	36971009	4283893		0
48310	2862	40481087	2012-11-21	2012-11-21 00:00:00	2012-12-12	2012-12-12 00:00:00	32020		\N	190274	0	444814009	40481087		0
48597	2878	4218389	1993-07-08	1993-07-08 00:00:00	1993-08-05	1993-08-05 00:00:00	32020		\N	191450	0	39848009	4218389		0
48792	2891	4283893	1979-11-27	1979-11-27 00:00:00	1980-02-26	1980-02-26 00:00:00	32020		\N	192345	0	36971009	4283893		0
48866	2894	40479422	1997-02-13	1997-02-13 00:00:00	1997-04-21	1997-04-21 00:00:00	32020		\N	192603	0	444448004	40479422		0
49109	2905	4112343	2004-04-03	2004-04-03 00:00:00	2004-04-14	2004-04-14 00:00:00	32020		\N	193541	0	195662009	4112343		0
49294	2915	40481087	2016-03-02	2016-03-02 00:00:00	2016-03-23	2016-03-23 00:00:00	32020		\N	194383	0	444814009	40481087		0
49421	2921	40481087	1950-10-19	1950-10-19 00:00:00	1950-10-26	1950-10-26 00:00:00	32020		\N	194721	0	444814009	40481087		0
49576	2933	40481087	1981-10-25	1981-10-25 00:00:00	1981-11-15	1981-11-15 00:00:00	32020		\N	195630	0	444814009	40481087		0
49757	2943	4112343	1982-12-09	1982-12-09 00:00:00	1982-12-20	1982-12-20 00:00:00	32020		\N	196270	0	195662009	4112343		0
39327	2333	4156265	1999-10-16	1999-10-16 00:00:00	1999-10-30	1999-10-30 00:00:00	32020		\N	155166	0	370247008	4156265		0
50053	2957	40481087	1954-03-02	1954-03-02 00:00:00	1954-03-16	1954-03-16 00:00:00	32020		\N	197298	0	444814009	40481087		0
39671	2349	28060	1973-05-07	1973-05-07 00:00:00	1973-05-20	1973-05-20 00:00:00	32020		\N	156365	0	43878008	28060		0
50384	2980	260139	2013-01-03	2013-01-03 00:00:00	2013-01-17	2013-01-17 00:00:00	32020		\N	198894	0	10509002	260139		0
50535	2989	378001	1959-02-02	1959-02-02 00:00:00	1959-03-04	1959-03-04 00:00:00	32020		\N	199585	0	62106007	378001		0
50710	3000	81151	1994-09-29	1994-09-29 00:00:00	1994-10-20	1994-10-20 00:00:00	32020		\N	200181	0	44465007	81151		0
50845	3007	40481087	1970-04-13	1970-04-13 00:00:00	1970-04-20	1970-04-20 00:00:00	32020		\N	200613	0	444814009	40481087		0
40500	2406	81151	1958-01-20	1958-01-20 00:00:00	1958-02-17	1958-02-17 00:00:00	32020		\N	159827	0	44465007	81151		0
51288	3040	40481087	1973-05-08	1973-05-08 00:00:00	1973-05-22	1973-05-22 00:00:00	32020		\N	202386	0	444814009	40481087		0
51370	3047	4027663	2005-07-18	2005-07-18 00:00:00	\N	\N	32020		\N	202716	0	13200003	4027663		0
51517	3057	4059173	2017-10-04	2017-10-04 00:00:00	2017-12-03	2017-12-03 00:00:00	32020		\N	203389	0	16114001	4059173		0
51777	3070	4146173	1967-08-21	1967-08-21 00:00:00	1967-10-27	1967-10-27 00:00:00	32020		\N	204366	0	307731004	4146173		0
51888	3077	78272	1991-09-16	1991-09-16 00:00:00	1991-09-30	1991-09-30 00:00:00	32020		\N	204723	0	70704007	78272		0
52029	3081	81151	1978-06-02	1978-06-02 00:00:00	1978-06-30	1978-06-30 00:00:00	32020		\N	205135	0	44465007	81151		0
52192	3090	260139	1978-04-11	1978-04-11 00:00:00	1978-04-25	1978-04-25 00:00:00	32020		\N	205728	0	10509002	260139		0
52304	3096	40481087	2003-04-26	2003-04-26 00:00:00	2003-05-17	2003-05-17 00:00:00	32020		\N	206070	0	444814009	40481087		0
63136	3730	4294548	1984-02-03	1984-02-03 00:00:00	1984-06-15	1984-06-15 00:00:00	32020		\N	247856	0	75498004	4294548		0
52786	3125	372328	1951-12-25	1951-12-25 00:00:00	1952-03-06	1952-03-06 00:00:00	32020		\N	207988	0	65363002	372328		0
52944	3134	257012	1998-11-13	1998-11-13 00:00:00	\N	\N	32020		\N	208562	0	40055000	257012		0
63593	3756	28060	1948-09-07	1948-09-07 00:00:00	1948-09-16	1948-09-16 00:00:00	32020		\N	249668	0	43878008	28060		0
42597	2540	4155034	1972-12-21	1972-12-21 00:00:00	1973-01-04	1973-01-04 00:00:00	32020		\N	167987	0	283371005	4155034		0
53290	3158	40481087	1977-06-24	1977-06-24 00:00:00	1977-07-08	1977-07-08 00:00:00	32020		\N	209942	0	444814009	40481087		0
42940	2556	4155034	1991-05-28	1991-05-28 00:00:00	1991-06-11	1991-06-11 00:00:00	32020		\N	169378	0	283371005	4155034		0
43088	2566	195588	1982-10-13	1982-10-13 00:00:00	1982-11-22	1982-11-22 00:00:00	32020		\N	169996	0	38822007	195588		0
43161	2570	40481087	1942-04-12	1942-04-12 00:00:00	1942-04-26	1942-04-26 00:00:00	32020		\N	170265	0	444814009	40481087		0
43462	2590	4134304	1967-06-20	1967-06-20 00:00:00	1967-08-19	1967-08-19 00:00:00	32020		\N	171405	0	263102004	4134304		0
43502	2591	4112343	2003-04-07	2003-04-07 00:00:00	2003-04-17	2003-04-17 00:00:00	32020		\N	171456	0	195662009	4112343		0
43723	2603	40481087	1991-09-04	1991-09-04 00:00:00	1991-09-25	1991-09-25 00:00:00	32020		\N	172233	0	444814009	40481087		0
43875	2613	40481087	1989-04-07	1989-04-07 00:00:00	1989-04-28	1989-04-28 00:00:00	32020		\N	172749	0	444814009	40481087		0
44080	2621	28060	1994-11-17	1994-11-17 00:00:00	1994-11-26	1994-11-26 00:00:00	32020		\N	173340	0	43878008	28060		0
44232	2630	81151	1992-07-29	1992-07-29 00:00:00	1992-08-12	1992-08-12 00:00:00	32020		\N	174029	0	44465007	81151		0
44458	2644	40481087	1988-06-07	1988-06-07 00:00:00	1988-06-21	1988-06-21 00:00:00	32020		\N	174962	0	444814009	40481087		0
44622	2654	4283893	1985-01-04	1985-01-04 00:00:00	1985-02-22	1985-02-22 00:00:00	32020		\N	175687	0	36971009	4283893		0
44745	2661	4112343	1966-08-21	1966-08-21 00:00:00	1966-08-29	1966-08-29 00:00:00	32020		\N	176322	0	195662009	4112343		0
44914	2673	40481087	1979-06-06	1979-06-06 00:00:00	1979-06-13	1979-06-13 00:00:00	32020		\N	177112	0	444814009	40481087		0
45124	2684	40481087	1989-01-30	1989-01-30 00:00:00	1989-02-13	1989-02-13 00:00:00	32020		\N	177886	0	444814009	40481087		0
45156	2686	4112343	1971-06-13	1971-06-13 00:00:00	1971-06-22	1971-06-22 00:00:00	32020		\N	178049	0	195662009	4112343		0
45479	2703	40481087	1978-08-18	1978-08-18 00:00:00	1978-08-25	1978-08-25 00:00:00	32020		\N	179051	0	444814009	40481087		0
45574	2708	4218389	2000-05-18	2000-05-18 00:00:00	2000-06-08	2000-06-08 00:00:00	32020		\N	179434	0	39848009	4218389		0
45705	2715	28060	1974-10-01	1974-10-01 00:00:00	1974-10-11	1974-10-11 00:00:00	32020		\N	180003	0	43878008	28060		0
45876	2731	81151	1986-03-21	1986-03-21 00:00:00	1986-04-11	1986-04-11 00:00:00	32020		\N	180790	0	44465007	81151		0
46147	2749	81151	1978-09-05	1978-09-05 00:00:00	1978-09-19	1978-09-19 00:00:00	32020		\N	181847	0	44465007	81151		0
46268	2757	4112343	1977-12-11	1977-12-11 00:00:00	1977-12-19	1977-12-19 00:00:00	32020		\N	182369	0	195662009	4112343		0
46366	2761	40481087	1990-03-31	1990-03-31 00:00:00	1990-04-07	1990-04-07 00:00:00	32020		\N	182626	0	444814009	40481087		0
46486	2768	4109685	1972-07-24	1972-07-24 00:00:00	1972-08-07	1972-08-07 00:00:00	32020		\N	183162	0	284551006	4109685		0
46728	2780	80180	2001-09-23	2001-09-23 00:00:00	\N	\N	32020		\N	184222	0	396275006	80180		0
46873	2788	4283893	2014-10-22	2014-10-22 00:00:00	2014-11-19	2014-11-19 00:00:00	32020		\N	184733	0	36971009	4283893		0
47105	2801	378001	1927-02-26	1927-02-26 00:00:00	1927-04-27	1927-04-27 00:00:00	32020		\N	185603	0	62106007	378001		0
47265	2812	40481087	1978-10-21	1978-10-21 00:00:00	1978-11-04	1978-11-04 00:00:00	32020		\N	186278	0	444814009	40481087		0
47404	2821	4112343	1971-03-25	1971-03-25 00:00:00	1971-04-05	1971-04-05 00:00:00	32020		\N	186862	0	195662009	4112343		0
47549	2827	195588	1968-05-20	1968-05-20 00:00:00	1968-07-11	1968-07-11 00:00:00	32020		\N	187508	0	38822007	195588		0
47658	2833	372328	1977-08-04	1977-08-04 00:00:00	1977-10-24	1977-10-24 00:00:00	32020		\N	188027	0	65363002	372328		0
47852	2842	81151	1970-03-26	1970-03-26 00:00:00	1970-04-30	1970-04-30 00:00:00	32020		\N	188707	0	44465007	81151		0
48100	2853	4112343	2010-10-21	2010-10-21 00:00:00	2010-11-03	2010-11-03 00:00:00	32020		\N	189535	0	195662009	4112343		0
48154	2858	4112343	1967-09-18	1967-09-18 00:00:00	1967-09-26	1967-09-26 00:00:00	32020		\N	189743	0	195662009	4112343		0
48311	2863	4310024	2004-03-02	2004-03-02 00:00:00	\N	\N	32020		\N	\N	0	424802006	4310024		0
48598	2878	260139	1999-12-14	1999-12-14 00:00:00	1999-12-21	1999-12-21 00:00:00	32020		\N	191432	0	10509002	260139		0
48793	2891	260139	2000-09-21	2000-09-21 00:00:00	2000-10-05	2000-10-05 00:00:00	32020		\N	192326	0	10509002	260139		0
48867	2894	40481087	1946-02-28	1946-02-28 00:00:00	1946-03-14	1946-03-14 00:00:00	32020		\N	192625	0	444814009	40481087		0
49110	2905	4112343	1971-08-19	1971-08-19 00:00:00	1971-08-30	1971-08-30 00:00:00	32020		\N	193554	0	195662009	4112343		0
49295	2915	40481087	1985-08-30	1985-08-30 00:00:00	1985-09-20	1985-09-20 00:00:00	32020		\N	194294	0	444814009	40481087		0
49422	2921	4230399	1989-05-07	1989-05-07 00:00:00	1989-07-06	1989-07-06 00:00:00	32020		\N	194716	0	359817006	4230399		0
49577	2933	81151	1978-06-13	1978-06-13 00:00:00	1978-06-27	1978-06-27 00:00:00	32020		\N	195604	0	44465007	81151		0
49758	2943	78272	1970-05-02	1970-05-02 00:00:00	1970-05-30	1970-05-30 00:00:00	32020		\N	196249	0	70704007	78272		0
39328	2333	81151	2001-07-21	2001-07-21 00:00:00	2001-08-25	2001-08-25 00:00:00	32020		\N	155167	0	44465007	81151		0
50054	2957	40481087	1999-01-20	1999-01-20 00:00:00	1999-02-03	1999-02-03 00:00:00	32020		\N	197302	0	444814009	40481087		0
39672	2349	80180	2004-12-22	2004-12-22 00:00:00	\N	\N	32020		\N	156407	0	396275006	80180		0
50385	2980	40481087	1998-01-02	1998-01-02 00:00:00	1998-01-09	1998-01-09 00:00:00	32020		\N	198940	0	444814009	40481087		0
50536	2989	4218389	2002-05-24	2002-05-24 00:00:00	2002-06-28	2002-06-28 00:00:00	32020		\N	199590	0	39848009	4218389		0
50711	3000	81151	1976-10-28	1976-10-28 00:00:00	1976-12-02	1976-12-02 00:00:00	32020		\N	200180	0	44465007	81151		0
50846	3007	40481087	1992-10-22	1992-10-22 00:00:00	1992-11-12	1992-11-12 00:00:00	32020		\N	200588	0	444814009	40481087		0
40501	2406	260139	1949-01-08	1949-01-08 00:00:00	1949-01-15	1949-01-15 00:00:00	32020		\N	159829	0	10509002	260139		0
51289	3040	40481087	1980-01-26	1980-01-26 00:00:00	1980-02-09	1980-02-09 00:00:00	32020		\N	202401	0	444814009	40481087		0
51371	3047	40481087	1977-01-06	1977-01-06 00:00:00	1977-01-20	1977-01-20 00:00:00	32020		\N	202719	0	444814009	40481087		0
51518	3057	40480160	2017-10-04	2017-10-04 00:00:00	2017-12-03	2017-12-03 00:00:00	32020		\N	203389	0	443165006	40480160		0
51778	3070	40481087	1993-07-30	1993-07-30 00:00:00	1993-08-20	1993-08-20 00:00:00	32020		\N	204321	0	444814009	40481087		0
51889	3077	40481087	1966-11-27	1966-11-27 00:00:00	1966-12-11	1966-12-11 00:00:00	32020		\N	204765	0	444814009	40481087		0
52030	3081	260139	1975-05-31	1975-05-31 00:00:00	1975-06-14	1975-06-14 00:00:00	32020		\N	205159	0	10509002	260139		0
52193	3090	40481087	1981-04-27	1981-04-27 00:00:00	1981-05-18	1981-05-18 00:00:00	32020		\N	205729	0	444814009	40481087		0
52305	3096	313217	2011-10-02	2011-10-02 00:00:00	\N	\N	32020		\N	206066	0	49436004	313217		0
63137	3730	81151	1980-04-14	1980-04-14 00:00:00	1980-05-19	1980-05-19 00:00:00	32020		\N	247806	0	44465007	81151		0
52787	3125	40481087	2019-04-15	2019-04-15 00:00:00	2019-05-06	2019-05-06 00:00:00	32020		\N	207987	0	444814009	40481087		0
52945	3134	4112343	2002-01-20	2002-01-20 00:00:00	2002-02-02	2002-02-02 00:00:00	32020		\N	208632	0	195662009	4112343		0
63594	3756	4218389	1958-09-09	1958-09-09 00:00:00	1958-10-07	1958-10-07 00:00:00	32020		\N	249713	0	39848009	4218389		0
42598	2540	40481087	2003-08-27	2003-08-27 00:00:00	2003-09-03	2003-09-03 00:00:00	32020		\N	167927	0	444814009	40481087		0
53291	3158	4112343	1996-08-31	1996-08-31 00:00:00	1996-09-08	1996-09-08 00:00:00	32020		\N	209959	0	195662009	4112343		0
42941	2556	80180	2004-06-03	2004-06-03 00:00:00	\N	\N	32020		\N	169385	0	396275006	80180		0
43089	2566	81151	2000-08-02	2000-08-02 00:00:00	2000-09-06	2000-09-06 00:00:00	32020		\N	170035	0	44465007	81151		0
43162	2570	40481087	2017-04-14	2017-04-14 00:00:00	2017-04-28	2017-04-28 00:00:00	32020		\N	170184	0	444814009	40481087		0
43463	2590	4310024	2000-05-04	2000-05-04 00:00:00	\N	\N	32020		\N	171398	0	424802006	4310024		0
43503	2591	4112343	1959-05-25	1959-05-25 00:00:00	1959-06-03	1959-06-03 00:00:00	32020		\N	171489	0	195662009	4112343		0
43724	2603	40481087	1962-02-20	1962-02-20 00:00:00	1962-03-06	1962-03-06 00:00:00	32020		\N	172167	0	444814009	40481087		0
43876	2613	4112343	2004-10-29	2004-10-29 00:00:00	2004-11-06	2004-11-06 00:00:00	32020		\N	172775	0	195662009	4112343		0
44081	2621	4149245	1999-06-10	1999-06-10 00:00:00	1999-08-16	1999-08-16 00:00:00	32020		\N	173402	0	30832001	4149245		0
44233	2630	4296205	2007-04-26	2007-04-26 00:00:00	2007-05-31	2007-05-31 00:00:00	32020		\N	173996	0	403191005	4296205		0
44459	2644	372328	1980-11-07	1980-11-07 00:00:00	1981-01-19	1981-01-19 00:00:00	32020		\N	174995	0	65363002	372328		0
44623	2654	4027663	1972-10-27	1972-10-27 00:00:00	\N	\N	32020		\N	175677	0	13200003	4027663		0
44746	2662	40479422	2002-07-05	2002-07-05 00:00:00	2002-08-11	2002-08-11 00:00:00	32020		\N	176431	0	444448004	40479422		0
44915	2673	4283893	2003-05-28	2003-05-28 00:00:00	2004-07-21	2004-07-21 00:00:00	32020		\N	177073	0	36971009	4283893		0
45125	2684	260139	1991-04-25	1991-04-25 00:00:00	1991-05-09	1991-05-09 00:00:00	32020		\N	177859	0	10509002	260139		0
45157	2686	260139	2001-04-17	2001-04-17 00:00:00	2001-05-01	2001-05-01 00:00:00	32020		\N	178029	0	10509002	260139		0
45480	2703	4285898	2013-10-14	2013-10-14 00:00:00	\N	\N	32020		\N	179081	0	68496003	4285898		0
45575	2709	40481087	2013-03-20	2013-03-20 00:00:00	2013-04-03	2013-04-03 00:00:00	32020		\N	179490	0	444814009	40481087		0
45706	2715	317576	1979-04-26	1979-04-26 00:00:00	\N	\N	32020		\N	180087	0	53741008	317576		0
45877	2731	4112343	2017-01-12	2017-01-12 00:00:00	2017-01-23	2017-01-23 00:00:00	32020		\N	180771	0	195662009	4112343		0
46148	2749	260139	1966-09-19	1966-09-19 00:00:00	1966-09-26	1966-09-26 00:00:00	32020		\N	181800	0	10509002	260139		0
46269	2757	40481087	2014-09-27	2014-09-27 00:00:00	2014-10-18	2014-10-18 00:00:00	32020		\N	182349	0	444814009	40481087		0
46367	2761	40481087	1989-04-20	1989-04-20 00:00:00	1989-04-27	1989-04-27 00:00:00	32020		\N	182637	0	444814009	40481087		0
46487	2768	4155034	2010-09-08	2010-09-08 00:00:00	2010-09-29	2010-09-29 00:00:00	32020		\N	183164	0	283371005	4155034		0
46729	2780	439777	2001-01-06	2001-01-06 00:00:00	\N	\N	32020		\N	184222	0	271737000	439777		0
46874	2788	40481087	2008-12-10	2008-12-10 00:00:00	2008-12-17	2008-12-17 00:00:00	32020		\N	184732	0	444814009	40481087		0
47106	2801	4112343	1988-11-07	1988-11-07 00:00:00	1988-11-14	1988-11-14 00:00:00	32020		\N	185581	0	195662009	4112343		0
47266	2812	4230399	1947-06-19	1947-06-19 00:00:00	1947-08-18	1947-08-18 00:00:00	32020		\N	186282	0	359817006	4230399		0
47405	2821	4112343	1991-12-17	1991-12-17 00:00:00	1991-12-29	1991-12-29 00:00:00	32020		\N	186864	0	195662009	4112343		0
47550	2827	40481087	1980-09-01	1980-09-01 00:00:00	1980-09-08	1980-09-08 00:00:00	32020		\N	187496	0	444814009	40481087		0
47659	2833	40481087	2005-10-20	2005-10-20 00:00:00	2005-11-03	2005-11-03 00:00:00	32020		\N	188052	0	444814009	40481087		0
47853	2842	4112343	1970-06-25	1970-06-25 00:00:00	1970-07-02	1970-07-02 00:00:00	32020		\N	188700	0	195662009	4112343		0
48101	2853	260139	1964-08-16	1964-08-16 00:00:00	1964-08-30	1964-08-30 00:00:00	32020		\N	189544	0	10509002	260139		0
48155	2858	40481087	1982-05-09	1982-05-09 00:00:00	1982-05-23	1982-05-23 00:00:00	32020		\N	189783	0	444814009	40481087		0
48312	2863	30753	2005-01-26	2005-01-26 00:00:00	\N	\N	32020		\N	\N	0	16761005	30753		0
48599	2878	28060	1986-08-08	1986-08-08 00:00:00	1986-08-16	1986-08-16 00:00:00	32020		\N	191452	0	43878008	28060		0
48794	2891	40481087	2002-07-15	2002-07-15 00:00:00	2002-08-05	2002-08-05 00:00:00	32020		\N	192327	0	444814009	40481087		0
48868	2894	4112343	1925-06-29	1925-06-29 00:00:00	1925-07-06	1925-07-06 00:00:00	32020		\N	192632	0	195662009	4112343		0
49111	2906	4294548	1992-11-24	1992-11-24 00:00:00	1993-05-18	1993-05-18 00:00:00	32020		\N	193619	0	75498004	4294548		0
49296	2915	4155034	1955-10-28	1955-10-28 00:00:00	1955-11-18	1955-11-18 00:00:00	32020		\N	194302	0	283371005	4155034		0
49423	2921	40481087	1945-08-26	1945-08-26 00:00:00	1945-09-09	1945-09-09 00:00:00	32020		\N	194694	0	444814009	40481087		0
49578	2933	28060	1957-10-31	1957-10-31 00:00:00	1957-11-08	1957-11-08 00:00:00	32020		\N	195615	0	43878008	28060		0
49759	2943	4278672	1931-08-13	1931-08-13 00:00:00	1931-10-12	1931-10-12 00:00:00	32020		\N	196246	0	65966004	4278672		0
39329	2333	255848	2010-04-03	2010-04-03 00:00:00	\N	\N	32020		\N	155255	0	233604007	255848		0
50055	2957	80180	1985-05-14	1985-05-14 00:00:00	\N	\N	32020		\N	197314	0	396275006	80180		0
39673	2349	4266809	2004-12-22	2004-12-22 00:00:00	\N	\N	32020		\N	156407	0	397881000	4266809		0
50386	2980	40481087	2004-12-11	2004-12-11 00:00:00	2004-12-18	2004-12-18 00:00:00	32020		\N	198921	0	444814009	40481087		0
50537	2989	28060	1958-10-02	1958-10-02 00:00:00	1958-10-13	1958-10-13 00:00:00	32020		\N	199542	0	43878008	28060		0
50712	3000	4296205	1970-11-08	1970-11-08 00:00:00	1970-11-22	1970-11-22 00:00:00	32020		\N	200178	0	403191005	4296205		0
50847	3007	372328	1967-01-20	1967-01-20 00:00:00	1967-05-03	1967-05-03 00:00:00	32020		\N	200579	0	65363002	372328		0
40502	2406	372328	1947-04-11	1947-04-11 00:00:00	1947-11-20	1947-11-20 00:00:00	32020		\N	159845	0	65363002	372328		0
51290	3040	260139	1985-06-17	1985-06-17 00:00:00	1985-07-01	1985-07-01 00:00:00	32020		\N	202373	0	10509002	260139		0
51372	3047	40481087	1985-06-14	1985-06-14 00:00:00	1985-07-05	1985-07-05 00:00:00	32020		\N	202727	0	444814009	40481087		0
51519	3057	80502	1997-03-03	1997-03-03 00:00:00	\N	\N	32020		\N	203418	0	64859006	80502		0
51779	3070	4134304	2008-04-24	2008-04-24 00:00:00	2008-05-24	2008-05-24 00:00:00	32020		\N	204326	0	263102004	4134304		0
51890	3077	4113008	1975-03-16	1975-03-16 00:00:00	1975-03-30	1975-03-30 00:00:00	32020		\N	204720	0	284549007	4113008		0
52031	3081	40481087	1957-10-12	1957-10-12 00:00:00	1957-11-02	1957-11-02 00:00:00	32020		\N	205114	0	444814009	40481087		0
52194	3090	28060	2002-07-31	2002-07-31 00:00:00	2002-08-07	2002-08-07 00:00:00	32020		\N	205756	0	43878008	28060		0
52306	3096	4278672	1968-09-26	1968-09-26 00:00:00	1968-12-25	1968-12-25 00:00:00	32020		\N	206036	0	65966004	4278672		0
63138	3730	40481087	1957-10-17	1957-10-17 00:00:00	1957-11-07	1957-11-07 00:00:00	32020		\N	247842	0	444814009	40481087		0
52788	3125	260139	1967-08-20	1967-08-20 00:00:00	1967-09-03	1967-09-03 00:00:00	32020		\N	207925	0	10509002	260139		0
52946	3134	40481087	1969-01-15	1969-01-15 00:00:00	1969-01-22	1969-01-22 00:00:00	32020		\N	208551	0	444814009	40481087		0
63595	3756	4112343	1947-01-22	1947-01-22 00:00:00	1947-01-31	1947-01-31 00:00:00	32020		\N	249640	0	195662009	4112343		0
42599	2540	40481087	2002-05-08	2002-05-08 00:00:00	2002-05-29	2002-05-29 00:00:00	32020		\N	167983	0	444814009	40481087		0
53292	3158	4294548	2000-03-15	2000-03-15 00:00:00	2000-04-05	2000-04-05 00:00:00	32020		\N	209960	0	75498004	4294548		0
42942	2556	40481087	1978-09-04	1978-09-04 00:00:00	1978-09-11	1978-09-11 00:00:00	32020		\N	169387	0	444814009	40481087		0
43090	2566	40481087	1965-08-25	1965-08-25 00:00:00	1965-09-08	1965-09-08 00:00:00	32020		\N	169939	0	444814009	40481087		0
43163	2570	4112343	1998-11-06	1998-11-06 00:00:00	1998-11-15	1998-11-15 00:00:00	32020		\N	170172	0	195662009	4112343		0
43464	2590	81893	2000-08-02	2000-08-02 00:00:00	\N	\N	32020		\N	171398	0	64766004	81893		0
43504	2591	4112343	1987-01-01	1987-01-01 00:00:00	1987-01-08	1987-01-08 00:00:00	32020		\N	171496	0	195662009	4112343		0
43725	2603	378001	1961-04-20	1961-04-20 00:00:00	1961-05-20	1961-05-20 00:00:00	32020		\N	172180	0	62106007	378001		0
43877	2613	4113008	1974-10-14	1974-10-14 00:00:00	1974-11-04	1974-11-04 00:00:00	32020		\N	172817	0	284549007	4113008		0
44082	2621	4112343	1999-04-08	1999-04-08 00:00:00	1999-04-21	1999-04-21 00:00:00	32020		\N	173393	0	195662009	4112343		0
44234	2630	4278672	1978-01-14	1978-01-14 00:00:00	1978-02-13	1978-02-13 00:00:00	32020		\N	174028	0	65966004	4278672		0
44460	2644	40481087	2009-06-07	2009-06-07 00:00:00	2009-06-21	2009-06-21 00:00:00	32020		\N	174975	0	444814009	40481087		0
44624	2654	375671	1979-05-04	1979-05-04 00:00:00	1979-07-03	1979-07-03 00:00:00	32020		\N	175721	0	62564004	375671		0
44747	2662	372328	1980-05-31	1980-05-31 00:00:00	1980-10-03	1980-10-03 00:00:00	32020		\N	176434	0	65363002	372328		0
44916	2673	260139	2007-10-30	2007-10-30 00:00:00	2007-11-13	2007-11-13 00:00:00	32020		\N	177051	0	10509002	260139		0
45126	2684	372328	1962-08-06	1962-08-06 00:00:00	1963-01-20	1963-01-20 00:00:00	32020		\N	177862	0	65363002	372328		0
45158	2686	40481087	1997-08-09	1997-08-09 00:00:00	1997-08-23	1997-08-23 00:00:00	32020		\N	178051	0	444814009	40481087		0
45481	2703	4310024	2012-06-21	2012-06-21 00:00:00	\N	\N	32020		\N	179081	0	424802006	4310024		0
45576	2709	192671	1984-04-03	1984-04-03 00:00:00	\N	\N	32020		\N	179452	0	K92.2	35208414		0
45707	2715	4112343	1975-07-11	1975-07-11 00:00:00	1975-07-24	1975-07-24 00:00:00	32020		\N	180004	0	195662009	4112343		0
45878	2731	378001	1991-03-14	1991-03-14 00:00:00	1991-05-13	1991-05-13 00:00:00	32020		\N	180792	0	62106007	378001		0
56659	3362	378001	2011-12-03	2011-12-03 00:00:00	2012-02-01	2012-02-01 00:00:00	32020		\N	222895	0	62106007	378001		0
46270	2757	40481087	2007-08-05	2007-08-05 00:00:00	2007-08-26	2007-08-26 00:00:00	32020		\N	182372	0	444814009	40481087		0
46368	2761	260139	2006-11-20	2006-11-20 00:00:00	2006-11-27	2006-11-27 00:00:00	32020		\N	182622	0	10509002	260139		0
46488	2768	4112343	1984-05-06	1984-05-06 00:00:00	1984-05-19	1984-05-19 00:00:00	32020		\N	183171	0	195662009	4112343		0
46730	2780	260139	1968-04-16	1968-04-16 00:00:00	1968-04-30	1968-04-30 00:00:00	32020		\N	184227	0	10509002	260139		0
46875	2788	80180	2018-06-27	2018-06-27 00:00:00	\N	\N	32020		\N	184746	0	396275006	80180		0
47107	2801	260139	1971-02-17	1971-02-17 00:00:00	1971-02-24	1971-02-24 00:00:00	32020		\N	185657	0	10509002	260139		0
47267	2812	40481087	1977-08-11	1977-08-11 00:00:00	1977-08-18	1977-08-18 00:00:00	32020		\N	186311	0	444814009	40481087		0
47406	2821	4112343	1950-05-18	1950-05-18 00:00:00	1950-05-27	1950-05-27 00:00:00	32020		\N	186868	0	195662009	4112343		0
47551	2827	4112343	1953-10-10	1953-10-10 00:00:00	1953-10-21	1953-10-21 00:00:00	32020		\N	187444	0	195662009	4112343		0
47660	2833	260139	1947-06-15	1947-06-15 00:00:00	1947-06-22	1947-06-22 00:00:00	32020		\N	188034	0	10509002	260139		0
47854	2842	40481087	1967-05-13	1967-05-13 00:00:00	1967-05-27	1967-05-27 00:00:00	32020		\N	188642	0	444814009	40481087		0
48102	2853	28060	1964-08-29	1964-08-29 00:00:00	1964-09-09	1964-09-09 00:00:00	32020		\N	189503	0	43878008	28060		0
48156	2858	4112343	1930-08-27	1930-08-27 00:00:00	1930-09-05	1930-09-05 00:00:00	32020		\N	189823	0	195662009	4112343		0
48313	2863	40486433	1966-09-20	1966-09-20 00:00:00	\N	\N	32020		\N	190423	0	446096008	40486433		0
48600	2878	4027663	2011-08-17	2011-08-17 00:00:00	\N	\N	32020		\N	191420	0	13200003	4027663		0
48795	2891	80180	2014-05-01	2014-05-01 00:00:00	\N	\N	32020		\N	192299	0	396275006	80180		0
48869	2894	4149245	1998-03-17	1998-03-17 00:00:00	1998-05-23	1998-05-23 00:00:00	32020		\N	192604	0	30832001	4149245		0
49112	2906	4294548	1999-08-24	1999-08-24 00:00:00	1999-10-12	1999-10-12 00:00:00	32020		\N	193635	0	75498004	4294548		0
49297	2915	4112343	1949-04-13	1949-04-13 00:00:00	1949-04-22	1949-04-22 00:00:00	32020		\N	194350	0	195662009	4112343		0
49424	2921	4112343	1956-02-27	1956-02-27 00:00:00	1956-03-08	1956-03-08 00:00:00	32020		\N	194722	0	195662009	4112343		0
49579	2933	40481087	1986-04-02	1986-04-02 00:00:00	1986-04-23	1986-04-23 00:00:00	32020		\N	195595	0	444814009	40481087		0
49760	2943	4112343	1972-09-21	1972-09-21 00:00:00	1972-09-29	1972-09-29 00:00:00	32020		\N	196293	0	195662009	4112343		0
39330	2333	4156265	1951-03-31	1951-03-31 00:00:00	1951-04-14	1951-04-14 00:00:00	32020		\N	155161	0	370247008	4156265		0
50056	2957	195588	1978-06-17	1978-06-17 00:00:00	1978-08-08	1978-08-08 00:00:00	32020		\N	197300	0	38822007	195588		0
39674	2349	81893	2003-11-28	2003-11-28 00:00:00	\N	\N	32020		\N	156407	0	64766004	81893		0
50387	2980	257012	1974-07-15	1974-07-15 00:00:00	\N	\N	32020		\N	198916	0	40055000	257012		0
50538	2989	81151	1956-04-13	1956-04-13 00:00:00	1956-05-18	1956-05-18 00:00:00	32020		\N	199584	0	44465007	81151		0
50713	3000	4112343	1951-07-01	1951-07-01 00:00:00	1951-07-09	1951-07-09 00:00:00	32020		\N	200184	0	195662009	4112343		0
50848	3007	4112343	1987-05-18	1987-05-18 00:00:00	1987-05-27	1987-05-27 00:00:00	32020		\N	200636	0	195662009	4112343		0
40503	2406	4283893	1991-09-19	1991-09-19 00:00:00	1992-01-09	1992-01-09 00:00:00	32020		\N	159833	0	36971009	4283893		0
51291	3040	40481087	1993-12-12	1993-12-12 00:00:00	1993-12-26	1993-12-26 00:00:00	32020		\N	202368	0	444814009	40481087		0
51373	3048	40481087	2002-06-12	2002-06-12 00:00:00	2002-07-03	2002-07-03 00:00:00	32020		\N	202796	0	444814009	40481087		0
51520	3057	40481087	1991-09-17	1991-09-17 00:00:00	1991-09-24	1991-09-24 00:00:00	32020		\N	203359	0	444814009	40481087		0
51780	3070	192671	2000-01-19	2000-01-19 00:00:00	\N	\N	32020		\N	204357	0	K92.2	35208414		0
51891	3077	381316	2014-06-11	2014-06-11 00:00:00	\N	\N	32020		\N	204737	0	230690007	381316		0
52032	3082	40481087	2008-02-29	2008-02-29 00:00:00	2008-03-21	2008-03-21 00:00:00	32020		\N	205249	0	444814009	40481087		0
52195	3090	78272	1994-11-17	1994-11-17 00:00:00	1994-12-08	1994-12-08 00:00:00	32020		\N	205772	0	70704007	78272		0
52307	3096	260139	1997-08-27	1997-08-27 00:00:00	1997-09-03	1997-09-03 00:00:00	32020		\N	206052	0	10509002	260139		0
63139	3730	40481087	1993-12-14	1993-12-14 00:00:00	1993-12-21	1993-12-21 00:00:00	32020		\N	247872	0	444814009	40481087		0
63253	3736	40481087	1983-02-01	1983-02-01 00:00:00	1983-02-08	1983-02-08 00:00:00	32020		\N	248349	0	444814009	40481087		0
52947	3135	260139	1990-09-08	1990-09-08 00:00:00	1990-09-22	1990-09-22 00:00:00	32020		\N	208668	0	10509002	260139		0
63596	3756	4218389	1957-07-25	1957-07-25 00:00:00	1957-08-15	1957-08-15 00:00:00	32020		\N	249712	0	39848009	4218389		0
42600	2540	372328	1969-02-02	1969-02-02 00:00:00	1971-02-23	1971-02-23 00:00:00	32020		\N	167997	0	65363002	372328		0
53293	3158	4109685	1963-04-14	1963-04-14 00:00:00	1963-04-28	1963-04-28 00:00:00	32020		\N	209944	0	284551006	4109685		0
42943	2556	192671	2004-08-16	2004-08-16 00:00:00	\N	\N	32020		\N	169427	0	K92.2	35208414		0
43091	2566	40481087	1945-01-30	1945-01-30 00:00:00	1945-02-20	1945-02-20 00:00:00	32020		\N	169962	0	444814009	40481087		0
43164	2570	40481087	1985-10-28	1985-10-28 00:00:00	1985-11-11	1985-11-11 00:00:00	32020		\N	170272	0	444814009	40481087		0
43465	2590	40481087	2011-01-11	2011-01-11 00:00:00	2011-01-25	2011-01-25 00:00:00	32020		\N	171420	0	444814009	40481087		0
43505	2591	4237458	2004-02-15	2004-02-15 00:00:00	2004-05-15	2004-05-15 00:00:00	32020		\N	171448	0	58150001	4237458		0
43726	2603	372328	1960-10-22	1960-10-22 00:00:00	1961-02-01	1961-02-01 00:00:00	32020		\N	172235	0	65363002	372328		0
43878	2613	4112343	2007-06-27	2007-06-27 00:00:00	2007-07-09	2007-07-09 00:00:00	32020		\N	172807	0	195662009	4112343		0
44083	2621	40481087	1977-03-05	1977-03-05 00:00:00	1977-03-12	1977-03-12 00:00:00	32020		\N	173333	0	444814009	40481087		0
44235	2630	81151	2014-04-24	2014-04-24 00:00:00	2014-05-29	2014-05-29 00:00:00	32020		\N	173998	0	44465007	81151		0
44461	2644	40481087	2002-02-13	2002-02-13 00:00:00	2002-02-20	2002-02-20 00:00:00	32020		\N	174983	0	444814009	40481087		0
44625	2654	4112343	1985-06-09	1985-06-09 00:00:00	1985-06-18	1985-06-18 00:00:00	32020		\N	175702	0	195662009	4112343		0
44748	2662	4035415	2018-02-17	2018-02-17 00:00:00	2018-03-20	2018-03-20 00:00:00	32020		\N	176432	0	239720000	4035415		0
44917	2673	40481087	2007-07-11	2007-07-11 00:00:00	2007-08-01	2007-08-01 00:00:00	32020		\N	177059	0	444814009	40481087		0
45127	2684	78272	1969-12-27	1969-12-27 00:00:00	1970-01-17	1970-01-17 00:00:00	32020		\N	177846	0	70704007	78272		0
45159	2686	40481087	2014-01-27	2014-01-27 00:00:00	2014-02-03	2014-02-03 00:00:00	32020		\N	178054	0	444814009	40481087		0
45482	2703	4109685	2015-08-24	2015-08-24 00:00:00	2015-09-07	2015-09-07 00:00:00	32020		\N	179111	0	284551006	4109685		0
45577	2709	40481087	2017-10-30	2017-10-30 00:00:00	2017-11-13	2017-11-13 00:00:00	32020		\N	179495	0	444814009	40481087		0
45708	2715	4059173	1990-09-30	1990-09-30 00:00:00	1990-12-29	1990-12-29 00:00:00	32020		\N	179970	0	16114001	4059173		0
45879	2731	40481087	2014-07-24	2014-07-24 00:00:00	2014-07-31	2014-07-31 00:00:00	32020		\N	180770	0	444814009	40481087		0
48423	2867	80180	2014-12-24	2014-12-24 00:00:00	\N	\N	32020		\N	190705	0	396275006	80180		0
56660	3362	4155034	1994-04-17	1994-04-17 00:00:00	1994-05-08	1994-05-08 00:00:00	32020		\N	222893	0	283371005	4155034		0
46271	2757	4294548	2006-04-19	2006-04-19 00:00:00	2006-07-19	2006-07-19 00:00:00	32020		\N	182353	0	75498004	4294548		0
46369	2761	40481087	2007-08-14	2007-08-14 00:00:00	2007-08-21	2007-08-21 00:00:00	32020		\N	182623	0	444814009	40481087		0
46489	2768	372328	1973-12-16	1973-12-16 00:00:00	1974-05-21	1974-05-21 00:00:00	32020		\N	183125	0	65363002	372328		0
46731	2780	81151	1997-07-11	1997-07-11 00:00:00	1997-07-25	1997-07-25 00:00:00	32020		\N	184247	0	44465007	81151		0
46876	2788	40481087	1993-03-13	1993-03-13 00:00:00	1993-03-20	1993-03-20 00:00:00	32020		\N	184737	0	444814009	40481087		0
47108	2801	4112343	1986-12-04	1986-12-04 00:00:00	1986-12-17	1986-12-17 00:00:00	32020		\N	185650	0	195662009	4112343		0
47268	2812	40481087	2014-03-19	2014-03-19 00:00:00	2014-04-09	2014-04-09 00:00:00	32020		\N	186321	0	444814009	40481087		0
47407	2821	4112343	1933-05-24	1933-05-24 00:00:00	1933-05-31	1933-05-31 00:00:00	32020		\N	186858	0	195662009	4112343		0
47552	2827	40481087	1989-10-16	1989-10-16 00:00:00	1989-10-23	1989-10-23 00:00:00	32020		\N	187449	0	444814009	40481087		0
47661	2833	40481087	2008-06-29	2008-06-29 00:00:00	2008-07-06	2008-07-06 00:00:00	32020		\N	188088	0	444814009	40481087		0
47855	2842	40481087	1968-01-31	1968-01-31 00:00:00	1968-02-07	1968-02-07 00:00:00	32020		\N	188643	0	444814009	40481087		0
48103	2853	260139	1995-03-24	1995-03-24 00:00:00	1995-04-07	1995-04-07 00:00:00	32020		\N	189533	0	10509002	260139		0
48157	2858	4278672	1998-01-05	1998-01-05 00:00:00	1998-02-04	1998-02-04 00:00:00	32020		\N	189904	0	65966004	4278672		0
48314	2863	40481087	2019-05-01	2019-05-01 00:00:00	2019-05-08	2019-05-08 00:00:00	32020		\N	190330	0	444814009	40481087		0
48601	2878	40481087	2004-05-24	2004-05-24 00:00:00	2004-06-07	2004-06-07 00:00:00	32020		\N	191442	0	444814009	40481087		0
48796	2891	4218389	2012-08-11	2012-08-11 00:00:00	2012-09-01	2012-09-01 00:00:00	32020		\N	192282	0	39848009	4218389		0
48870	2894	4218389	1929-11-08	1929-11-08 00:00:00	1929-12-13	1929-12-13 00:00:00	32020		\N	192621	0	39848009	4218389		0
49113	2906	4035415	1956-11-23	1956-11-23 00:00:00	1957-01-22	1957-01-22 00:00:00	32020		\N	193722	0	239720000	4035415		0
49298	2915	28060	2012-07-23	2012-07-23 00:00:00	2012-08-01	2012-08-01 00:00:00	32020		\N	194245	0	43878008	28060		0
49425	2921	372328	1941-01-22	1941-01-22 00:00:00	1941-02-25	1941-02-25 00:00:00	32020		\N	194769	0	65363002	372328		0
49580	2933	40481087	2000-09-30	2000-09-30 00:00:00	2000-10-21	2000-10-21 00:00:00	32020		\N	195616	0	444814009	40481087		0
49761	2943	40481087	2002-05-11	2002-05-11 00:00:00	2002-06-01	2002-06-01 00:00:00	32020		\N	196272	0	444814009	40481087		0
39331	2333	4283893	1987-09-09	1987-09-09 00:00:00	1987-09-30	1987-09-30 00:00:00	32020		\N	155193	0	36971009	4283893		0
50057	2957	4294548	1989-08-13	1989-08-13 00:00:00	1989-08-20	1989-08-20 00:00:00	32020		\N	197309	0	75498004	4294548		0
50134	2961	81151	2004-03-06	2004-03-06 00:00:00	2004-04-03	2004-04-03 00:00:00	32020		\N	197768	0	44465007	81151		0
50388	2980	40481087	2009-08-15	2009-08-15 00:00:00	2009-08-22	2009-08-22 00:00:00	32020		\N	198893	0	444814009	40481087		0
50539	2989	440448	1987-06-16	1987-06-16 00:00:00	\N	\N	32020		\N	199588	0	74400008	440448		0
50714	3000	40481087	1977-12-03	1977-12-03 00:00:00	1977-12-17	1977-12-17 00:00:00	32020		\N	200231	0	444814009	40481087		0
50849	3007	40481087	1984-10-13	1984-10-13 00:00:00	1984-10-27	1984-10-27 00:00:00	32020		\N	200635	0	444814009	40481087		0
50969	3017	40481087	2007-02-28	2007-02-28 00:00:00	2007-03-07	2007-03-07 00:00:00	32020		\N	201257	0	444814009	40481087		0
51292	3040	40481087	1985-05-22	1985-05-22 00:00:00	1985-06-05	1985-06-05 00:00:00	32020		\N	202366	0	444814009	40481087		0
51374	3048	80180	2008-08-24	2008-08-24 00:00:00	\N	\N	32020		\N	202792	0	396275006	80180		0
51521	3057	372328	1938-07-28	1938-07-28 00:00:00	1938-12-12	1938-12-12 00:00:00	32020		\N	203356	0	65363002	372328		0
51781	3070	4310024	1997-01-15	1997-01-15 00:00:00	\N	\N	32020		\N	204341	0	424802006	4310024		0
51892	3077	317576	2013-11-20	2013-11-20 00:00:00	\N	\N	32020		\N	204737	0	53741008	317576		0
52033	3082	40481087	2009-05-24	2009-05-24 00:00:00	2009-05-31	2009-05-31 00:00:00	32020		\N	205250	0	444814009	40481087		0
52196	3090	260139	2006-02-07	2006-02-07 00:00:00	2006-02-21	2006-02-21 00:00:00	32020		\N	205750	0	10509002	260139		0
52308	3096	4112343	1998-09-03	1998-09-03 00:00:00	1998-09-15	1998-09-15 00:00:00	32020		\N	206069	0	195662009	4112343		0
63140	3730	40481087	1965-10-04	1965-10-04 00:00:00	1965-10-18	1965-10-18 00:00:00	32020		\N	247855	0	444814009	40481087		0
63254	3736	260139	1985-07-31	1985-07-31 00:00:00	1985-08-07	1985-08-07 00:00:00	32020		\N	248259	0	10509002	260139		0
52948	3135	4310024	2004-01-22	2004-01-22 00:00:00	\N	\N	32020		\N	208663	0	424802006	4310024		0
63597	3756	81151	1960-11-25	1960-11-25 00:00:00	1960-12-16	1960-12-16 00:00:00	32020		\N	249714	0	44465007	81151		0
42601	2540	4027663	1966-12-15	1966-12-15 00:00:00	\N	\N	32020		\N	167912	0	13200003	4027663		0
53294	3158	260139	1950-11-20	1950-11-20 00:00:00	1950-11-27	1950-11-27 00:00:00	32020		\N	209994	0	10509002	260139		0
42944	2556	40481087	2006-04-24	2006-04-24 00:00:00	2006-05-15	2006-05-15 00:00:00	32020		\N	169421	0	444814009	40481087		0
43092	2566	40481087	2008-06-25	2008-06-25 00:00:00	2008-07-02	2008-07-02 00:00:00	32020		\N	170024	0	444814009	40481087		0
43165	2570	40481087	2010-11-04	2010-11-04 00:00:00	2010-11-11	2010-11-11 00:00:00	32020		\N	170263	0	444814009	40481087		0
43466	2590	81151	1979-01-18	1979-01-18 00:00:00	1979-02-22	1979-02-22 00:00:00	32020		\N	171406	0	44465007	81151		0
43506	2591	4112343	1985-07-31	1985-07-31 00:00:00	1985-08-07	1985-08-07 00:00:00	32020		\N	171484	0	195662009	4112343		0
43727	2603	40481087	1968-03-10	1968-03-10 00:00:00	1968-03-31	1968-03-31 00:00:00	32020		\N	172193	0	444814009	40481087		0
43879	2613	260139	1990-11-19	1990-11-19 00:00:00	1990-12-03	1990-12-03 00:00:00	32020		\N	172768	0	10509002	260139		0
44084	2621	78272	1969-09-21	1969-09-21 00:00:00	1969-10-19	1969-10-19 00:00:00	32020		\N	173399	0	70704007	78272		0
44236	2630	4112343	2017-04-10	2017-04-10 00:00:00	2017-04-21	2017-04-21 00:00:00	32020		\N	174021	0	195662009	4112343		0
44462	2644	80180	2014-11-19	2014-11-19 00:00:00	\N	\N	32020		\N	174982	0	396275006	80180		0
44626	2654	40479422	1983-04-13	1983-04-13 00:00:00	1983-06-19	1983-06-19 00:00:00	32020		\N	175722	0	444448004	40479422		0
44749	2662	80180	2016-07-02	2016-07-02 00:00:00	\N	\N	32020		\N	176408	0	396275006	80180		0
44918	2673	4112343	1979-06-30	1979-06-30 00:00:00	1979-07-07	1979-07-07 00:00:00	32020		\N	177131	0	195662009	4112343		0
45128	2684	378001	1962-03-09	1962-03-09 00:00:00	1962-05-08	1962-05-08 00:00:00	32020		\N	177844	0	62106007	378001		0
45160	2686	40481087	2014-07-12	2014-07-12 00:00:00	2014-08-02	2014-08-02 00:00:00	32020		\N	177999	0	444814009	40481087		0
45483	2703	28060	1979-09-20	1979-09-20 00:00:00	1979-09-28	1979-09-28 00:00:00	32020		\N	179052	0	43878008	28060		0
45578	2709	260139	2019-03-15	2019-03-15 00:00:00	2019-03-22	2019-03-22 00:00:00	32020		\N	179496	0	10509002	260139		0
45709	2715	372328	1966-11-09	1966-11-09 00:00:00	1966-12-29	1966-12-29 00:00:00	32020		\N	180038	0	65363002	372328		0
45880	2731	40481087	1993-08-01	1993-08-01 00:00:00	1993-08-22	1993-08-22 00:00:00	32020		\N	180757	0	444814009	40481087		0
56661	3362	4218389	1960-04-05	1960-04-05 00:00:00	1960-05-03	1960-05-03 00:00:00	32020		\N	222890	0	39848009	4218389		0
46272	2757	4278672	1978-03-06	1978-03-06 00:00:00	1978-06-04	1978-06-04 00:00:00	32020		\N	182336	0	65966004	4278672		0
46370	2761	40481087	1983-02-09	1983-02-09 00:00:00	1983-02-16	1983-02-16 00:00:00	32020		\N	182647	0	444814009	40481087		0
46490	2768	4027663	1998-06-03	1998-06-03 00:00:00	\N	\N	32020		\N	183178	0	13200003	4027663		0
46732	2780	81151	2014-10-24	2014-10-24 00:00:00	2014-11-14	2014-11-14 00:00:00	32020		\N	184232	0	44465007	81151		0
46877	2788	40479768	2017-11-24	2017-11-24 00:00:00	2018-01-30	2018-01-30 00:00:00	32020		\N	184724	0	444470001	40479768		0
47109	2801	4112343	1979-02-05	1979-02-05 00:00:00	1979-02-13	1979-02-13 00:00:00	32020		\N	185574	0	195662009	4112343		0
47269	2812	40481087	1958-10-25	1958-10-25 00:00:00	1958-11-15	1958-11-15 00:00:00	32020		\N	186301	0	444814009	40481087		0
47408	2821	4283893	1996-06-13	1996-06-13 00:00:00	1996-10-10	1996-10-10 00:00:00	32020		\N	186930	0	36971009	4283893		0
47553	2827	4294548	1927-09-29	1927-09-29 00:00:00	1927-10-13	1927-10-13 00:00:00	32020		\N	187506	0	75498004	4294548		0
47662	2833	4112343	1947-12-09	1947-12-09 00:00:00	1947-12-22	1947-12-22 00:00:00	32020		\N	188035	0	195662009	4112343		0
47856	2842	40481087	2000-10-06	2000-10-06 00:00:00	2000-10-20	2000-10-20 00:00:00	32020		\N	188666	0	444814009	40481087		0
48121	2857	4094814	1987-07-08	1987-07-08 00:00:00	1987-10-06	1987-10-06 00:00:00	32020		\N	189699	0	262574004	4094814		0
48158	2858	4059173	1986-02-07	1986-02-07 00:00:00	1986-04-08	1986-04-08 00:00:00	32020		\N	189903	0	16114001	4059173		0
48315	2863	4027663	1995-09-06	1995-09-06 00:00:00	\N	\N	32020		\N	190415	0	13200003	4027663		0
59097	3505	28060	2003-06-06	2003-06-06 00:00:00	2003-06-16	2003-06-16 00:00:00	32020		\N	232413	0	43878008	28060		0
48797	2891	4116491	1995-11-17	1995-11-17 00:00:00	1996-01-09	1996-01-09 00:00:00	32020		\N	192323	0	301011002	4116491		0
48871	2894	260139	1986-11-30	1986-11-30 00:00:00	1986-12-07	1986-12-07 00:00:00	32020		\N	192658	0	10509002	260139		0
49114	2906	28060	1947-07-11	1947-07-11 00:00:00	1947-07-24	1947-07-24 00:00:00	32020		\N	193657	0	43878008	28060		0
49299	2915	4112343	1969-11-25	1969-11-25 00:00:00	1969-12-08	1969-12-08 00:00:00	32020		\N	194292	0	195662009	4112343		0
49446	2925	80180	1998-12-21	1998-12-21 00:00:00	\N	\N	32020		\N	195067	0	396275006	80180		0
49581	2933	80180	1998-07-30	1998-07-30 00:00:00	\N	\N	32020		\N	195610	0	396275006	80180		0
49762	2943	40481087	1984-11-22	1984-11-22 00:00:00	1984-11-29	1984-11-29 00:00:00	32020		\N	196361	0	444814009	40481087		0
39332	2333	40481087	1992-06-12	1992-06-12 00:00:00	1992-06-19	1992-06-19 00:00:00	32020		\N	155245	0	444814009	40481087		0
50058	2957	195588	1977-04-26	1977-04-26 00:00:00	1977-06-17	1977-06-17 00:00:00	32020		\N	197307	0	38822007	195588		0
50135	2961	40481087	1990-10-28	1990-10-28 00:00:00	1990-11-18	1990-11-18 00:00:00	32020		\N	197710	0	444814009	40481087		0
50389	2980	80180	2007-11-25	2007-11-25 00:00:00	\N	\N	32020		\N	198913	0	396275006	80180		0
50540	2989	260139	1993-11-10	1993-11-10 00:00:00	1993-11-24	1993-11-24 00:00:00	32020		\N	199576	0	10509002	260139		0
50715	3000	40481087	1971-08-20	1971-08-20 00:00:00	1971-09-03	1971-09-03 00:00:00	32020		\N	200140	0	444814009	40481087		0
50850	3007	4155034	1989-11-25	1989-11-25 00:00:00	1989-12-16	1989-12-16 00:00:00	32020		\N	200601	0	283371005	4155034		0
50970	3017	4112343	1973-08-21	1973-08-21 00:00:00	1973-09-02	1973-09-02 00:00:00	32020		\N	201210	0	195662009	4112343		0
51293	3040	40481087	1973-08-26	1973-08-26 00:00:00	1973-09-02	1973-09-02 00:00:00	32020		\N	202364	0	444814009	40481087		0
51375	3048	40481087	1995-07-27	1995-07-27 00:00:00	1995-08-10	1995-08-10 00:00:00	32020		\N	202810	0	444814009	40481087		0
51522	3057	4112343	1941-09-24	1941-09-24 00:00:00	1941-10-05	1941-10-05 00:00:00	32020		\N	203360	0	195662009	4112343		0
51782	3070	30753	1998-10-07	1998-10-07 00:00:00	\N	\N	32020		\N	204342	0	16761005	30753		0
51893	3077	4027663	1980-05-21	1980-05-21 00:00:00	\N	\N	32020		\N	204722	0	13200003	4027663		0
52034	3082	378001	1979-02-06	1979-02-06 00:00:00	1979-04-07	1979-04-07 00:00:00	32020		\N	205226	0	62106007	378001		0
52197	3090	40481087	1980-07-19	1980-07-19 00:00:00	1980-08-02	1980-08-02 00:00:00	32020		\N	205749	0	444814009	40481087		0
52309	3096	4278672	1970-12-15	1970-12-15 00:00:00	1971-02-13	1971-02-13 00:00:00	32020		\N	206037	0	65966004	4278672		0
63141	3730	40481087	1982-01-28	1982-01-28 00:00:00	1982-02-04	1982-02-04 00:00:00	32020		\N	247844	0	444814009	40481087		0
63256	3736	321042	2006-06-28	2006-06-28 00:00:00	\N	\N	32020		\N	248300	0	410429000	321042		0
52949	3135	260139	1978-12-24	1978-12-24 00:00:00	1979-01-07	1979-01-07 00:00:00	32020		\N	208666	0	10509002	260139		0
63598	3756	40481087	1984-11-14	1984-11-14 00:00:00	1984-11-28	1984-11-28 00:00:00	32020		\N	249609	0	444814009	40481087		0
42602	2540	4218389	1942-08-23	1942-08-23 00:00:00	1942-09-13	1942-09-13 00:00:00	32020		\N	167924	0	39848009	4218389		0
53295	3158	40481087	1957-03-24	1957-03-24 00:00:00	1957-04-07	1957-04-07 00:00:00	32020		\N	210008	0	444814009	40481087		0
42945	2556	260139	1975-09-07	1975-09-07 00:00:00	1975-09-21	1975-09-21 00:00:00	32020		\N	169418	0	10509002	260139		0
43093	2566	80180	1978-12-03	1978-12-03 00:00:00	\N	\N	32020		\N	169982	0	396275006	80180		0
43166	2570	195588	1993-08-21	1993-08-21 00:00:00	1993-10-15	1993-10-15 00:00:00	32020		\N	170273	0	38822007	195588		0
43467	2590	4112343	1965-06-05	1965-06-05 00:00:00	1965-06-15	1965-06-15 00:00:00	32020		\N	171417	0	195662009	4112343		0
43507	2591	40481087	2009-06-16	2009-06-16 00:00:00	2009-06-30	2009-06-30 00:00:00	32020		\N	171467	0	444814009	40481087		0
43728	2603	4218389	1975-05-07	1975-05-07 00:00:00	1975-06-11	1975-06-11 00:00:00	32020		\N	172181	0	39848009	4218389		0
43880	2613	378001	1956-03-08	1956-03-08 00:00:00	1956-05-07	1956-05-07 00:00:00	32020		\N	172815	0	62106007	378001		0
44085	2621	4112343	2009-03-15	2009-03-15 00:00:00	2009-03-23	2009-03-23 00:00:00	32020		\N	173383	0	195662009	4112343		0
44237	2630	260139	1975-05-01	1975-05-01 00:00:00	1975-05-15	1975-05-15 00:00:00	32020		\N	173930	0	10509002	260139		0
44473	2646	4112343	1992-05-24	1992-05-24 00:00:00	1992-06-05	1992-06-05 00:00:00	32020		\N	175045	0	195662009	4112343		0
44627	2654	4112343	2007-03-29	2007-03-29 00:00:00	2007-04-08	2007-04-08 00:00:00	32020		\N	175716	0	195662009	4112343		0
44750	2662	40481087	1991-07-26	1991-07-26 00:00:00	1991-08-09	1991-08-09 00:00:00	32020		\N	176392	0	444814009	40481087		0
44919	2673	40481087	2007-11-05	2007-11-05 00:00:00	2007-11-12	2007-11-12 00:00:00	32020		\N	177052	0	444814009	40481087		0
45129	2684	40481087	1985-10-28	1985-10-28 00:00:00	1985-11-11	1985-11-11 00:00:00	32020		\N	177857	0	444814009	40481087		0
45161	2686	260139	1969-09-07	1969-09-07 00:00:00	1969-09-14	1969-09-14 00:00:00	32020		\N	178005	0	10509002	260139		0
45484	2703	260139	1986-02-17	1986-02-17 00:00:00	1986-03-03	1986-03-03 00:00:00	32020		\N	179087	0	10509002	260139		0
45579	2709	40481087	1974-05-24	1974-05-24 00:00:00	1974-05-31	1974-05-31 00:00:00	32020		\N	179463	0	444814009	40481087		0
45710	2715	4059173	1982-05-15	1982-05-15 00:00:00	1982-07-14	1982-07-14 00:00:00	32020		\N	179968	0	16114001	4059173		0
45881	2731	40481087	2016-12-25	2016-12-25 00:00:00	2017-01-01	2017-01-01 00:00:00	32020		\N	180764	0	444814009	40481087		0
56662	3362	40481087	1976-04-13	1976-04-13 00:00:00	1976-04-20	1976-04-20 00:00:00	32020		\N	222863	0	444814009	40481087		0
46273	2757	4296204	1974-02-27	1974-02-27 00:00:00	1974-03-27	1974-03-27 00:00:00	32020		\N	182334	0	403190006	4296204		0
46371	2761	28060	1985-07-24	1985-07-24 00:00:00	1985-07-31	1985-07-31 00:00:00	32020		\N	182648	0	43878008	28060		0
46491	2768	30753	2009-05-21	2009-05-21 00:00:00	\N	\N	32020		\N	183166	0	16761005	30753		0
46733	2780	40481087	1992-11-20	1992-11-20 00:00:00	1992-11-27	1992-11-27 00:00:00	32020		\N	184221	0	444814009	40481087		0
46878	2788	81151	1980-01-08	1980-01-08 00:00:00	1980-02-12	1980-02-12 00:00:00	32020		\N	184723	0	44465007	81151		0
47110	2801	4283893	1966-03-25	1966-03-25 00:00:00	1966-06-03	1966-06-03 00:00:00	32020		\N	185572	0	36971009	4283893		0
47270	2812	372328	1940-04-26	1940-04-26 00:00:00	1940-05-10	1940-05-10 00:00:00	32020		\N	186314	0	65363002	372328		0
47409	2821	4027663	1952-05-24	1952-05-24 00:00:00	\N	\N	32020		\N	186963	0	13200003	4027663		0
47571	2829	40481087	2007-11-29	2007-11-29 00:00:00	2007-12-06	2007-12-06 00:00:00	32020		\N	187646	0	444814009	40481087		0
47663	2833	40481087	2001-04-28	2001-04-28 00:00:00	2001-05-05	2001-05-05 00:00:00	32020		\N	188038	0	444814009	40481087		0
47857	2842	4112343	1996-02-12	1996-02-12 00:00:00	1996-02-20	1996-02-20 00:00:00	32020		\N	188703	0	195662009	4112343		0
48122	2857	4112343	1970-10-19	1970-10-19 00:00:00	1970-10-27	1970-10-27 00:00:00	32020		\N	189684	0	195662009	4112343		0
48159	2858	4112343	1950-07-26	1950-07-26 00:00:00	1950-08-08	1950-08-08 00:00:00	32020		\N	189798	0	195662009	4112343		0
59122	3508	372328	1957-10-24	1957-10-24 00:00:00	1958-02-05	1958-02-05 00:00:00	32020		\N	232628	0	65363002	372328		0
48798	2891	378001	1976-12-06	1976-12-06 00:00:00	1977-02-04	1977-02-04 00:00:00	32020		\N	192313	0	62106007	378001		0
48872	2894	81151	1967-07-02	1967-07-02 00:00:00	1967-07-30	1967-07-30 00:00:00	32020		\N	192599	0	44465007	81151		0
49115	2906	81151	2014-02-25	2014-02-25 00:00:00	2014-03-18	2014-03-18 00:00:00	32020		\N	193645	0	44465007	81151		0
49300	2915	4237458	1954-10-03	1954-10-03 00:00:00	1955-01-01	1955-01-01 00:00:00	32020		\N	194301	0	58150001	4237458		0
49447	2925	40481087	2017-09-14	2017-09-14 00:00:00	2017-10-05	2017-10-05 00:00:00	32020		\N	195131	0	444814009	40481087		0
49582	2933	192671	1998-10-16	1998-10-16 00:00:00	\N	\N	32020		\N	195638	0	K92.2	35208414		0
49763	2943	4112343	1931-03-20	1931-03-20 00:00:00	1931-03-28	1931-03-28 00:00:00	32020		\N	196334	0	195662009	4112343		0
39333	2333	4156265	1998-10-30	1998-10-30 00:00:00	1998-11-20	1998-11-20 00:00:00	32020		\N	155165	0	370247008	4156265		0
50059	2957	4146173	1970-02-22	1970-02-22 00:00:00	1970-03-24	1970-03-24 00:00:00	32020		\N	197306	0	307731004	4146173		0
50136	2961	4294548	1972-01-29	1972-01-29 00:00:00	1972-03-25	1972-03-25 00:00:00	32020		\N	197703	0	75498004	4294548		0
50390	2980	4218389	1981-02-18	1981-02-18 00:00:00	1981-03-18	1981-03-18 00:00:00	32020		\N	198975	0	39848009	4218389		0
50541	2989	378001	1967-11-24	1967-11-24 00:00:00	1968-01-23	1968-01-23 00:00:00	32020		\N	199587	0	62106007	378001		0
50716	3000	40481087	1979-07-15	1979-07-15 00:00:00	1979-07-29	1979-07-29 00:00:00	32020		\N	200142	0	444814009	40481087		0
50867	3010	40481087	1981-12-20	1981-12-20 00:00:00	1982-01-03	1982-01-03 00:00:00	32020		\N	200793	0	444814009	40481087		0
50971	3017	40481087	1985-11-16	1985-11-16 00:00:00	1985-11-23	1985-11-23 00:00:00	32020		\N	201214	0	444814009	40481087		0
51294	3041	40481087	2008-07-07	2008-07-07 00:00:00	2008-07-14	2008-07-14 00:00:00	32020		\N	202527	0	444814009	40481087		0
51376	3048	192671	2008-09-03	2008-09-03 00:00:00	\N	\N	32020		\N	202811	0	K92.2	35208414		0
51529	3059	4112343	2007-03-10	2007-03-10 00:00:00	2007-03-19	2007-03-19 00:00:00	32020		\N	203483	0	195662009	4112343		0
51783	3070	4285898	1999-07-04	1999-07-04 00:00:00	\N	\N	32020		\N	204342	0	68496003	4285898		0
51894	3077	4035415	1979-11-18	1979-11-18 00:00:00	1979-12-18	1979-12-18 00:00:00	32020		\N	204722	0	239720000	4035415		0
52035	3082	257012	1998-04-05	1998-04-05 00:00:00	\N	\N	32020		\N	205237	0	40055000	257012		0
52198	3090	260139	2005-03-06	2005-03-06 00:00:00	2005-03-13	2005-03-13 00:00:00	32020		\N	205709	0	10509002	260139		0
52310	3096	375671	2008-01-30	2008-01-30 00:00:00	2008-03-30	2008-03-30 00:00:00	32020		\N	206077	0	62564004	375671		0
63142	3730	4112343	1958-11-23	1958-11-23 00:00:00	1958-12-01	1958-12-01 00:00:00	32020		\N	247843	0	195662009	4112343		0
63257	3736	40481087	2004-08-08	2004-08-08 00:00:00	2004-08-29	2004-08-29 00:00:00	32020		\N	248288	0	444814009	40481087		0
52950	3135	40481087	1977-06-01	1977-06-01 00:00:00	1977-06-15	1977-06-15 00:00:00	32020		\N	208705	0	444814009	40481087		0
63599	3756	4112343	2004-08-09	2004-08-09 00:00:00	2004-08-21	2004-08-21 00:00:00	32020		\N	249650	0	195662009	4112343		0
42603	2540	4294548	1963-09-06	1963-09-06 00:00:00	1964-01-10	1964-01-10 00:00:00	32020		\N	167878	0	75498004	4294548		0
53296	3158	28060	1986-02-25	1986-02-25 00:00:00	1986-03-09	1986-03-09 00:00:00	32020		\N	209917	0	43878008	28060		0
42946	2556	4218389	1981-09-12	1981-09-12 00:00:00	1981-10-17	1981-10-17 00:00:00	32020		\N	169377	0	39848009	4218389		0
43094	2566	30753	1978-09-04	1978-09-04 00:00:00	\N	\N	32020		\N	169982	0	16761005	30753		0
43167	2570	4112343	1967-11-09	1967-11-09 00:00:00	1967-11-17	1967-11-17 00:00:00	32020		\N	170195	0	195662009	4112343		0
43468	2590	372328	1963-04-14	1963-04-14 00:00:00	1963-06-25	1963-06-25 00:00:00	32020		\N	171361	0	65363002	372328		0
43508	2591	4134304	1947-09-12	1947-09-12 00:00:00	1947-12-11	1947-12-11 00:00:00	32020		\N	171447	0	263102004	4134304		0
43729	2603	4112343	1962-04-19	1962-04-19 00:00:00	1962-05-02	1962-05-02 00:00:00	32020		\N	172231	0	195662009	4112343		0
43881	2613	40481087	1986-03-10	1986-03-10 00:00:00	1986-03-17	1986-03-17 00:00:00	32020		\N	172806	0	444814009	40481087		0
44086	2621	4156265	1964-10-12	1964-10-12 00:00:00	1964-10-26	1964-10-26 00:00:00	32020		\N	173397	0	370247008	4156265		0
44238	2630	260139	2015-09-04	2015-09-04 00:00:00	2015-09-18	2015-09-18 00:00:00	32020		\N	173937	0	10509002	260139		0
44474	2646	260139	2002-02-21	2002-02-21 00:00:00	2002-02-28	2002-02-28 00:00:00	32020		\N	175092	0	10509002	260139		0
44628	2654	4112343	2011-02-20	2011-02-20 00:00:00	2011-03-05	2011-03-05 00:00:00	32020		\N	175689	0	195662009	4112343		0
44751	2662	40481087	2017-10-13	2017-10-13 00:00:00	2017-10-27	2017-10-27 00:00:00	32020		\N	176401	0	444814009	40481087		0
44920	2673	4112343	2010-03-27	2010-03-27 00:00:00	2010-04-06	2010-04-06 00:00:00	32020		\N	177060	0	195662009	4112343		0
45130	2684	321042	1967-05-21	1967-05-21 00:00:00	\N	\N	32020		\N	177845	0	410429000	321042		0
45162	2686	260139	1962-01-10	1962-01-10 00:00:00	1962-01-24	1962-01-24 00:00:00	32020		\N	178048	0	10509002	260139		0
55943	3313	40481087	2017-03-08	2017-03-08 00:00:00	2017-03-29	2017-03-29 00:00:00	32020		\N	219988	0	444814009	40481087		0
45580	2709	260139	1943-12-17	1943-12-17 00:00:00	1943-12-24	1943-12-24 00:00:00	32020		\N	179440	0	10509002	260139		0
45711	2715	260139	1997-03-18	1997-03-18 00:00:00	1997-03-25	1997-03-25 00:00:00	32020		\N	180046	0	10509002	260139		0
45882	2731	81151	1990-03-21	1990-03-21 00:00:00	1990-04-18	1990-04-18 00:00:00	32020		\N	180791	0	44465007	81151		0
56663	3362	28060	1979-05-23	1979-05-23 00:00:00	1979-06-02	1979-06-02 00:00:00	32020		\N	222927	0	43878008	28060		0
46274	2757	40481087	2006-10-26	2006-10-26 00:00:00	2006-11-02	2006-11-02 00:00:00	32020		\N	182355	0	444814009	40481087		0
46372	2761	372328	1984-09-25	1984-09-25 00:00:00	1985-04-29	1985-04-29 00:00:00	32020		\N	182639	0	65363002	372328		0
46492	2768	260139	1980-07-13	1980-07-13 00:00:00	1980-07-20	1980-07-20 00:00:00	32020		\N	183135	0	10509002	260139		0
46734	2780	40481087	1994-01-27	1994-01-27 00:00:00	1994-02-03	1994-02-03 00:00:00	32020		\N	184210	0	444814009	40481087		0
46879	2788	40481087	2005-10-18	2005-10-18 00:00:00	2005-10-25	2005-10-25 00:00:00	32020		\N	184706	0	444814009	40481087		0
47111	2802	80180	1983-01-17	1983-01-17 00:00:00	\N	\N	32020		\N	185713	0	396275006	80180		0
47271	2812	81151	1991-07-12	1991-07-12 00:00:00	1991-08-09	1991-08-09 00:00:00	32020		\N	186318	0	44465007	81151		0
47410	2821	4218389	2000-06-11	2000-06-11 00:00:00	2000-07-02	2000-07-02 00:00:00	32020		\N	186855	0	39848009	4218389		0
47572	2829	372328	1951-01-02	1951-01-02 00:00:00	1951-02-12	1951-02-12 00:00:00	32020		\N	187639	0	65363002	372328		0
47664	2833	40481087	1959-09-13	1959-09-13 00:00:00	1959-09-27	1959-09-27 00:00:00	32020		\N	188036	0	444814009	40481087		0
47858	2842	40481087	2012-04-17	2012-04-17 00:00:00	2012-05-01	2012-05-01 00:00:00	32020		\N	188704	0	444814009	40481087		0
48123	2857	4112343	2011-05-19	2011-05-19 00:00:00	2011-05-27	2011-05-27 00:00:00	32020		\N	189723	0	195662009	4112343		0
48160	2858	40481087	1947-05-24	1947-05-24 00:00:00	1947-05-31	1947-05-31 00:00:00	32020		\N	189779	0	444814009	40481087		0
48317	2863	80180	2006-04-21	2006-04-21 00:00:00	\N	\N	32020		\N	190409	0	396275006	80180		0
59123	3508	40481087	1984-02-15	1984-02-15 00:00:00	1984-03-07	1984-03-07 00:00:00	32020		\N	232663	0	444814009	40481087		0
48799	2891	372328	1978-12-26	1978-12-26 00:00:00	1979-11-08	1979-11-08 00:00:00	32020		\N	192329	0	65363002	372328		0
48873	2894	372328	1927-11-03	1927-11-03 00:00:00	1928-01-28	1928-01-28 00:00:00	32020		\N	192661	0	65363002	372328		0
49116	2906	40481087	1925-12-08	1925-12-08 00:00:00	1925-12-22	1925-12-22 00:00:00	32020		\N	193688	0	444814009	40481087		0
49301	2915	80180	1981-11-14	1981-11-14 00:00:00	\N	\N	32020		\N	194363	0	396275006	80180		0
49448	2925	28060	1999-11-05	1999-11-05 00:00:00	1999-11-13	1999-11-13 00:00:00	32020		\N	195009	0	43878008	28060		0
49583	2933	4112343	1956-09-25	1956-09-25 00:00:00	1956-10-04	1956-10-04 00:00:00	32020		\N	195628	0	195662009	4112343		0
49764	2943	4112343	2018-05-30	2018-05-30 00:00:00	2018-06-09	2018-06-09 00:00:00	32020		\N	196281	0	195662009	4112343		0
39334	2333	4112343	2007-02-02	2007-02-02 00:00:00	2007-02-13	2007-02-13 00:00:00	32020		\N	155208	0	195662009	4112343		0
50060	2957	80502	2008-02-02	2008-02-02 00:00:00	\N	\N	32020		\N	197327	0	64859006	80502		0
50137	2961	40481087	2019-03-08	2019-03-08 00:00:00	2019-03-16	2019-03-16 00:00:00	32020		\N	197756	0	444814009	40481087		0
50391	2980	260139	1993-01-11	1993-01-11 00:00:00	1993-01-18	1993-01-18 00:00:00	32020		\N	198890	0	10509002	260139		0
50542	2989	40481087	1954-11-29	1954-11-29 00:00:00	1954-12-06	1954-12-06 00:00:00	32020		\N	199540	0	444814009	40481087		0
50717	3000	260139	2003-03-24	2003-03-24 00:00:00	2003-03-31	2003-03-31 00:00:00	32020		\N	200197	0	10509002	260139		0
50868	3010	4112343	1979-02-04	1979-02-04 00:00:00	1979-02-17	1979-02-17 00:00:00	32020		\N	200781	0	195662009	4112343		0
50972	3017	4112343	1999-03-22	1999-03-22 00:00:00	1999-04-03	1999-04-03 00:00:00	32020		\N	201229	0	195662009	4112343		0
61753	3647	40481087	1943-10-20	1943-10-20 00:00:00	1943-11-03	1943-11-03 00:00:00	32020		\N	242668	0	444814009	40481087		0
51377	3048	4294548	1977-12-31	1977-12-31 00:00:00	1978-01-21	1978-01-21 00:00:00	32020		\N	202795	0	75498004	4294548		0
51530	3059	4112343	1979-08-18	1979-08-18 00:00:00	1979-08-27	1979-08-27 00:00:00	32020		\N	203505	0	195662009	4112343		0
51784	3070	80180	1999-12-31	1999-12-31 00:00:00	\N	\N	32020		\N	204342	0	396275006	80180		0
51895	3077	40481087	1995-10-07	1995-10-07 00:00:00	1995-10-21	1995-10-21 00:00:00	32020		\N	204801	0	444814009	40481087		0
52036	3082	40481087	1989-03-13	1989-03-13 00:00:00	1989-03-20	1989-03-20 00:00:00	32020		\N	205241	0	444814009	40481087		0
52199	3090	40481087	1988-11-16	1988-11-16 00:00:00	1988-12-07	1988-12-07 00:00:00	32020		\N	205730	0	444814009	40481087		0
52311	3096	4059173	1979-08-30	1979-08-30 00:00:00	1979-11-28	1979-11-28 00:00:00	32020		\N	206038	0	16114001	4059173		0
63143	3730	372328	1954-09-28	1954-09-28 00:00:00	1954-12-09	1954-12-09 00:00:00	32020		\N	247879	0	65363002	372328		0
63258	3736	40481087	2014-10-09	2014-10-09 00:00:00	2014-10-30	2014-10-30 00:00:00	32020		\N	248330	0	444814009	40481087		0
52951	3135	260139	2005-05-02	2005-05-02 00:00:00	2005-05-09	2005-05-09 00:00:00	32020		\N	208697	0	10509002	260139		0
63600	3756	28060	1949-09-14	1949-09-14 00:00:00	1949-09-24	1949-09-24 00:00:00	32020		\N	249622	0	43878008	28060		0
42604	2540	257012	1963-09-20	1963-09-20 00:00:00	\N	\N	32020		\N	167993	0	40055000	257012		0
53297	3158	80180	1990-02-06	1990-02-06 00:00:00	\N	\N	32020		\N	209982	0	396275006	80180		0
42947	2556	4296205	2007-12-14	2007-12-14 00:00:00	2008-01-18	2008-01-18 00:00:00	32020		\N	169428	0	403191005	4296205		0
43095	2566	4310024	1977-06-11	1977-06-11 00:00:00	\N	\N	32020		\N	169982	0	424802006	4310024		0
43168	2570	4112343	1945-04-05	1945-04-05 00:00:00	1945-04-12	1945-04-12 00:00:00	32020		\N	170163	0	195662009	4112343		0
43469	2590	4027663	1992-10-08	1992-10-08 00:00:00	\N	\N	32020		\N	171359	0	13200003	4027663		0
43509	2591	81893	1973-02-26	1973-02-26 00:00:00	\N	\N	32020		\N	171494	0	64766004	81893		0
43730	2603	140673	2014-05-12	2014-05-12 00:00:00	\N	\N	32020		\N	172225	0	40930008	140673		0
43882	2613	40481087	2016-05-13	2016-05-13 00:00:00	2016-05-27	2016-05-27 00:00:00	32020		\N	172785	0	444814009	40481087		0
44087	2621	260139	1966-11-03	1966-11-03 00:00:00	1966-11-10	1966-11-10 00:00:00	32020		\N	173339	0	10509002	260139		0
44239	2630	40481087	2005-11-04	2005-11-04 00:00:00	2005-11-25	2005-11-25 00:00:00	32020		\N	173951	0	444814009	40481087		0
44475	2646	40481087	1985-01-23	1985-01-23 00:00:00	1985-02-13	1985-02-13 00:00:00	32020		\N	175063	0	444814009	40481087		0
44629	2654	4112343	1951-08-27	1951-08-27 00:00:00	1951-09-04	1951-09-04 00:00:00	32020		\N	175658	0	195662009	4112343		0
44752	2662	375671	1981-06-11	1981-06-11 00:00:00	1981-07-11	1981-07-11 00:00:00	32020		\N	176429	0	62564004	375671		0
44921	2673	4112343	2001-03-28	2001-03-28 00:00:00	2001-04-10	2001-04-10 00:00:00	32020		\N	177072	0	195662009	4112343		0
45132	2684	4134304	2014-04-08	2014-04-08 00:00:00	2014-06-07	2014-06-07 00:00:00	32020		\N	177896	0	263102004	4134304		0
45163	2686	260139	1996-10-24	1996-10-24 00:00:00	1996-11-07	1996-11-07 00:00:00	32020		\N	178028	0	10509002	260139		0
55944	3313	4112343	1974-05-06	1974-05-06 00:00:00	1974-05-16	1974-05-16 00:00:00	32020		\N	219967	0	195662009	4112343		0
45581	2709	40481087	2003-04-23	2003-04-23 00:00:00	2003-05-07	2003-05-07 00:00:00	32020		\N	179444	0	444814009	40481087		0
45759	2721	260139	1990-06-10	1990-06-10 00:00:00	1990-06-17	1990-06-17 00:00:00	32020		\N	180329	0	10509002	260139		0
45883	2731	4152936	1972-09-06	1972-09-06 00:00:00	1972-09-27	1972-09-27 00:00:00	32020		\N	180817	0	283385000	4152936		0
56664	3362	28060	1984-01-17	1984-01-17 00:00:00	1984-01-25	1984-01-25 00:00:00	32020		\N	222928	0	43878008	28060		0
46275	2757	80180	2007-07-14	2007-07-14 00:00:00	\N	\N	32020		\N	182355	0	396275006	80180		0
46373	2761	378001	2004-06-12	2004-06-12 00:00:00	2004-08-11	2004-08-11 00:00:00	32020		\N	182645	0	62106007	378001		0
46506	2770	4112343	1933-11-22	1933-11-22 00:00:00	1933-11-29	1933-11-29 00:00:00	32020		\N	183331	0	195662009	4112343		0
46735	2780	40481087	1987-08-30	1987-08-30 00:00:00	1987-09-13	1987-09-13 00:00:00	32020		\N	184236	0	444814009	40481087		0
46880	2788	40481087	1990-12-05	1990-12-05 00:00:00	1990-12-19	1990-12-19 00:00:00	32020		\N	184736	0	444814009	40481087		0
47112	2802	4109685	1981-11-17	1981-11-17 00:00:00	1981-12-01	1981-12-01 00:00:00	32020		\N	185713	0	284551006	4109685		0
47272	2812	4035415	2000-04-23	2000-04-23 00:00:00	2000-06-22	2000-06-22 00:00:00	32020		\N	186319	0	239720000	4035415		0
47411	2821	40481087	1998-01-10	1998-01-10 00:00:00	1998-01-17	1998-01-17 00:00:00	32020		\N	186897	0	444814009	40481087		0
47573	2829	372328	1952-06-06	1952-06-06 00:00:00	1952-08-11	1952-08-11 00:00:00	32020		\N	187640	0	65363002	372328		0
47665	2833	40481087	1985-12-15	1985-12-15 00:00:00	1986-01-05	1986-01-05 00:00:00	32020		\N	188050	0	444814009	40481087		0
47859	2842	260139	1982-06-19	1982-06-19 00:00:00	1982-07-03	1982-07-03 00:00:00	32020		\N	188649	0	10509002	260139		0
48124	2857	40481087	1965-11-10	1965-11-10 00:00:00	1965-11-17	1965-11-17 00:00:00	32020		\N	189682	0	444814009	40481087		0
48161	2858	40481087	2006-06-03	2006-06-03 00:00:00	2006-06-10	2006-06-10 00:00:00	32020		\N	189884	0	444814009	40481087		0
48318	2863	4112343	1964-03-12	1964-03-12 00:00:00	1964-03-22	1964-03-22 00:00:00	32020		\N	190422	0	195662009	4112343		0
59124	3508	40481087	2014-01-07	2014-01-07 00:00:00	2014-01-14	2014-01-14 00:00:00	32020		\N	232673	0	444814009	40481087		0
48800	2891	260139	2011-03-13	2011-03-13 00:00:00	2011-03-27	2011-03-27 00:00:00	32020		\N	192372	0	10509002	260139		0
48874	2894	40481087	2001-06-07	2001-06-07 00:00:00	2001-06-14	2001-06-14 00:00:00	32020		\N	192649	0	444814009	40481087		0
49117	2906	28060	1962-10-04	1962-10-04 00:00:00	1962-10-16	1962-10-16 00:00:00	32020		\N	193616	0	43878008	28060		0
49302	2915	4112343	1955-03-19	1955-03-19 00:00:00	1955-03-31	1955-03-31 00:00:00	32020		\N	194344	0	195662009	4112343		0
49449	2925	4296205	2007-06-17	2007-06-17 00:00:00	2007-07-22	2007-07-22 00:00:00	32020		\N	195025	0	403191005	4296205		0
49584	2933	378001	2018-06-27	2018-06-27 00:00:00	2018-08-26	2018-08-26 00:00:00	32020		\N	195583	0	62106007	378001		0
49765	2943	40481087	1938-01-09	1938-01-09 00:00:00	1938-01-16	1938-01-16 00:00:00	32020		\N	196336	0	444814009	40481087		0
39335	2333	260139	1997-10-03	1997-10-03 00:00:00	1997-10-10	1997-10-10 00:00:00	32020		\N	155207	0	10509002	260139		0
50061	2957	4112343	1948-08-29	1948-08-29 00:00:00	1948-09-07	1948-09-07 00:00:00	32020		\N	197371	0	195662009	4112343		0
50138	2961	40481087	1995-07-05	1995-07-05 00:00:00	1995-07-19	1995-07-19 00:00:00	32020		\N	197705	0	444814009	40481087		0
50392	2980	40486433	1973-12-25	1973-12-25 00:00:00	1990-12-23	1990-12-23 00:00:00	32020		\N	198914	0	446096008	40486433		0
50543	2989	40479422	1960-01-28	1960-01-28 00:00:00	1960-03-05	1960-03-05 00:00:00	32020		\N	199586	0	444448004	40479422		0
50718	3000	4266809	1983-09-20	1983-09-20 00:00:00	\N	\N	32020		\N	200223	0	397881000	4266809		0
50869	3010	4278672	1989-05-22	1989-05-22 00:00:00	1989-07-21	1989-07-21 00:00:00	32020		\N	200799	0	65966004	4278672		0
50973	3017	4237458	1960-07-01	1960-07-01 00:00:00	1960-09-29	1960-09-29 00:00:00	32020		\N	201237	0	58150001	4237458		0
61754	3647	4156265	1941-05-28	1941-05-28 00:00:00	1941-06-11	1941-06-11 00:00:00	32020		\N	242663	0	370247008	4156265		0
51378	3048	40481087	2004-03-01	2004-03-01 00:00:00	2004-03-22	2004-03-22 00:00:00	32020		\N	202812	0	444814009	40481087		0
51531	3059	4294548	1974-04-06	1974-04-06 00:00:00	1974-05-18	1974-05-18 00:00:00	32020		\N	203520	0	75498004	4294548		0
51785	3070	260139	1986-12-11	1986-12-11 00:00:00	1986-12-18	1986-12-18 00:00:00	32020		\N	204362	0	10509002	260139		0
51896	3077	4112343	1975-03-13	1975-03-13 00:00:00	1975-03-21	1975-03-21 00:00:00	32020		\N	204781	0	195662009	4112343		0
52037	3082	40481087	2007-10-04	2007-10-04 00:00:00	2007-10-25	2007-10-25 00:00:00	32020		\N	205183	0	444814009	40481087		0
52200	3090	4109685	1980-09-10	1980-09-10 00:00:00	1980-10-01	1980-10-01 00:00:00	32020		\N	205727	0	284551006	4109685		0
52312	3096	372328	1968-08-12	1968-08-12 00:00:00	1968-12-01	1968-12-01 00:00:00	32020		\N	206104	0	65363002	372328		0
63144	3730	260139	2007-01-24	2007-01-24 00:00:00	2007-02-07	2007-02-07 00:00:00	32020		\N	247877	0	10509002	260139		0
63259	3736	4113008	1991-12-31	1991-12-31 00:00:00	1992-01-21	1992-01-21 00:00:00	32020		\N	248333	0	284549007	4113008		0
52952	3135	260139	2003-08-03	2003-08-03 00:00:00	2003-08-10	2003-08-10 00:00:00	32020		\N	208687	0	10509002	260139		0
63601	3756	260139	1974-01-01	1974-01-01 00:00:00	1974-01-08	1974-01-08 00:00:00	32020		\N	249680	0	10509002	260139		0
42605	2540	40481087	1996-04-16	1996-04-16 00:00:00	1996-04-30	1996-04-30 00:00:00	32020		\N	167981	0	444814009	40481087		0
53298	3158	4237458	1977-04-01	1977-04-01 00:00:00	1977-06-30	1977-06-30 00:00:00	32020		\N	209949	0	58150001	4237458		0
42971	2559	4112343	1996-03-15	1996-03-15 00:00:00	1996-03-28	1996-03-28 00:00:00	32020		\N	169581	0	195662009	4112343		0
43096	2566	40481087	1980-02-10	1980-02-10 00:00:00	1980-03-02	1980-03-02 00:00:00	32020		\N	169940	0	444814009	40481087		0
43169	2570	378001	1966-11-21	1966-11-21 00:00:00	1967-01-20	1967-01-20 00:00:00	32020		\N	170198	0	62106007	378001		0
43470	2590	4294548	1991-01-20	1991-01-20 00:00:00	1991-06-23	1991-06-23 00:00:00	32020		\N	171359	0	75498004	4294548		0
43510	2591	4112343	1977-09-28	1977-09-28 00:00:00	1977-10-09	1977-10-09 00:00:00	32020		\N	171483	0	195662009	4112343		0
43731	2604	40481087	1960-10-22	1960-10-22 00:00:00	1960-11-05	1960-11-05 00:00:00	32020		\N	172245	0	444814009	40481087		0
43884	2613	40481087	1983-11-29	1983-11-29 00:00:00	1983-12-13	1983-12-13 00:00:00	32020		\N	172805	0	444814009	40481087		0
44088	2622	4112343	1996-03-24	1996-03-24 00:00:00	1996-04-05	1996-04-05 00:00:00	32020		\N	173427	0	195662009	4112343		0
44240	2630	4112343	1972-12-23	1972-12-23 00:00:00	1973-01-04	1973-01-04 00:00:00	32020		\N	174010	0	195662009	4112343		0
44476	2646	4278672	1988-04-29	1988-04-29 00:00:00	1988-07-28	1988-07-28 00:00:00	32020		\N	175083	0	65966004	4278672		0
44630	2654	40481087	1964-01-16	1964-01-16 00:00:00	1964-02-06	1964-02-06 00:00:00	32020		\N	175712	0	444814009	40481087		0
44753	2662	40481087	1993-07-05	1993-07-05 00:00:00	1993-07-12	1993-07-12 00:00:00	32020		\N	176393	0	444814009	40481087		0
44922	2673	4146173	2006-04-06	2006-04-06 00:00:00	2006-05-06	2006-05-06 00:00:00	32020		\N	177075	0	307731004	4146173		0
45133	2684	40481087	2001-09-06	2001-09-06 00:00:00	2001-09-13	2001-09-13 00:00:00	32020		\N	177861	0	444814009	40481087		0
45164	2686	4112343	2016-04-08	2016-04-08 00:00:00	2016-04-17	2016-04-17 00:00:00	32020		\N	178000	0	195662009	4112343		0
55945	3313	260139	1967-01-29	1967-01-29 00:00:00	1967-02-12	1967-02-12 00:00:00	32020		\N	219977	0	10509002	260139		0
45582	2709	40481087	1953-05-23	1953-05-23 00:00:00	1953-06-13	1953-06-13 00:00:00	32020		\N	179492	0	444814009	40481087		0
45760	2721	40481087	2016-06-14	2016-06-14 00:00:00	2016-06-28	2016-06-28 00:00:00	32020		\N	180330	0	444814009	40481087		0
45884	2731	4112343	1978-08-22	1978-08-22 00:00:00	1978-09-02	1978-09-02 00:00:00	32020		\N	180741	0	195662009	4112343		0
56665	3362	40481087	1967-04-18	1967-04-18 00:00:00	1967-05-09	1967-05-09 00:00:00	32020		\N	222855	0	444814009	40481087		0
46276	2757	4294548	1982-05-29	1982-05-29 00:00:00	1982-06-19	1982-06-19 00:00:00	32020		\N	182352	0	75498004	4294548		0
46374	2761	28060	1992-12-23	1992-12-23 00:00:00	1992-12-31	1992-12-31 00:00:00	32020		\N	182621	0	43878008	28060		0
46507	2770	260139	1996-04-07	1996-04-07 00:00:00	1996-04-14	1996-04-14 00:00:00	32020		\N	183247	0	10509002	260139		0
46736	2780	372328	1960-04-10	1960-04-10 00:00:00	1960-12-28	1960-12-28 00:00:00	32020		\N	184238	0	65363002	372328		0
46881	2788	372328	1983-03-23	1983-03-23 00:00:00	1984-03-04	1984-03-04 00:00:00	32020		\N	184699	0	65363002	372328		0
47113	2802	4112343	1941-03-13	1941-03-13 00:00:00	1941-03-25	1941-03-25 00:00:00	32020		\N	185735	0	195662009	4112343		0
47273	2812	80180	1970-12-15	1970-12-15 00:00:00	\N	\N	32020		\N	186355	0	396275006	80180		0
47412	2821	28060	1993-06-25	1993-06-25 00:00:00	1993-07-08	1993-07-08 00:00:00	32020		\N	186866	0	43878008	28060		0
47574	2829	40481087	2018-07-17	2018-07-17 00:00:00	2018-07-24	2018-07-24 00:00:00	32020		\N	187637	0	444814009	40481087		0
47666	2833	28060	1940-04-03	1940-04-03 00:00:00	1940-04-15	1940-04-15 00:00:00	32020		\N	188087	0	43878008	28060		0
47860	2843	40481087	1983-11-18	1983-11-18 00:00:00	1983-12-02	1983-12-02 00:00:00	32020		\N	188776	0	444814009	40481087		0
48125	2857	4146173	1988-08-01	1988-08-01 00:00:00	1988-08-31	1988-08-31 00:00:00	32020		\N	189717	0	307731004	4146173		0
48162	2858	4283893	1987-12-27	1987-12-27 00:00:00	1988-01-10	1988-01-10 00:00:00	32020		\N	189784	0	36971009	4283893		0
48319	2863	28060	2015-05-07	2015-05-07 00:00:00	2015-05-16	2015-05-16 00:00:00	32020		\N	190416	0	43878008	28060		0
59125	3508	4230399	2019-05-02	2019-05-02 00:00:00	\N	\N	32020		\N	232693	0	359817006	4230399		0
48801	2891	260139	1974-10-20	1974-10-20 00:00:00	1974-10-27	1974-10-27 00:00:00	32020		\N	192343	0	10509002	260139		0
48875	2894	372328	1923-09-04	1923-09-04 00:00:00	1924-01-19	1924-01-19 00:00:00	32020		\N	192651	0	65363002	372328		0
49118	2906	40481087	1968-03-20	1968-03-20 00:00:00	1968-03-27	1968-03-27 00:00:00	32020		\N	193690	0	444814009	40481087		0
59761	3541	28060	2018-09-27	2018-09-27 00:00:00	2018-10-08	2018-10-08 00:00:00	32020		\N	235213	0	43878008	28060		0
49450	2925	4149245	2015-03-12	2015-03-12 00:00:00	2015-05-18	2015-05-18 00:00:00	32020		\N	195026	0	30832001	4149245		0
49585	2933	4112343	2011-07-24	2011-07-24 00:00:00	2011-07-31	2011-07-31 00:00:00	32020		\N	195617	0	195662009	4112343		0
49766	2943	80180	1952-11-08	1952-11-08 00:00:00	\N	\N	32020		\N	196292	0	396275006	80180		0
39336	2333	40481087	1938-06-16	1938-06-16 00:00:00	1938-06-23	1938-06-23 00:00:00	32020		\N	155200	0	444814009	40481087		0
50062	2957	40481087	1996-11-09	1996-11-09 00:00:00	1996-11-23	1996-11-23 00:00:00	32020		\N	197356	0	444814009	40481087		0
50139	2961	28060	1987-12-10	1987-12-10 00:00:00	1987-12-18	1987-12-18 00:00:00	32020		\N	197704	0	43878008	28060		0
50427	2985	40481087	1983-01-21	1983-01-21 00:00:00	1983-02-11	1983-02-11 00:00:00	32020		\N	199231	0	444814009	40481087		0
50544	2989	260139	1986-11-16	1986-11-16 00:00:00	1986-11-30	1986-11-30 00:00:00	32020		\N	199545	0	10509002	260139		0
50719	3000	4285898	1982-11-24	1982-11-24 00:00:00	\N	\N	32020		\N	200223	0	68496003	4285898		0
50870	3010	4218389	1996-08-13	1996-08-13 00:00:00	1996-09-10	1996-09-10 00:00:00	32020		\N	200800	0	39848009	4218389		0
50974	3017	260139	2003-03-28	2003-03-28 00:00:00	2003-04-11	2003-04-11 00:00:00	32020		\N	201256	0	10509002	260139		0
61755	3647	260139	1950-12-08	1950-12-08 00:00:00	1950-12-15	1950-12-15 00:00:00	32020		\N	242677	0	10509002	260139		0
51379	3048	4283893	2015-02-28	2015-02-28 00:00:00	2015-05-09	2015-05-09 00:00:00	32020		\N	202813	0	36971009	4283893		0
51532	3059	4155034	2012-06-28	2012-06-28 00:00:00	2012-07-19	2012-07-19 00:00:00	32020		\N	203513	0	283371005	4155034		0
51786	3070	260139	2011-10-07	2011-10-07 00:00:00	2011-10-14	2011-10-14 00:00:00	32020		\N	204389	0	10509002	260139		0
54842	3246	30753	2015-11-07	2015-11-07 00:00:00	\N	\N	32020		\N	215806	0	16761005	30753		0
51897	3077	28060	1987-07-03	1987-07-03 00:00:00	1987-07-15	1987-07-15 00:00:00	32020		\N	204782	0	43878008	28060		0
52038	3082	4294548	1998-03-08	1998-03-08 00:00:00	1998-04-19	1998-04-19 00:00:00	32020		\N	205242	0	75498004	4294548		0
52201	3090	4156265	2003-05-25	2003-05-25 00:00:00	2003-06-15	2003-06-15 00:00:00	32020		\N	205773	0	370247008	4156265		0
52313	3096	40481087	1990-02-13	1990-02-13 00:00:00	1990-02-27	1990-02-27 00:00:00	32020		\N	206101	0	444814009	40481087		0
63145	3730	4299128	2011-06-06	2011-06-06 00:00:00	2011-07-11	2011-07-11 00:00:00	32020		\N	247809	0	403192003	4299128		0
63260	3736	260139	1969-01-11	1969-01-11 00:00:00	1969-01-25	1969-01-25 00:00:00	32020		\N	248314	0	10509002	260139		0
52953	3135	260139	1979-12-27	1979-12-27 00:00:00	1980-01-03	1980-01-03 00:00:00	32020		\N	208685	0	10509002	260139		0
63602	3756	4112343	1999-05-07	1999-05-07 00:00:00	1999-05-19	1999-05-19 00:00:00	32020		\N	249649	0	195662009	4112343		0
42606	2540	260139	1971-08-23	1971-08-23 00:00:00	1971-09-06	1971-09-06 00:00:00	32020		\N	167880	0	10509002	260139		0
53299	3158	4218389	1967-04-07	1967-04-07 00:00:00	1967-05-12	1967-05-12 00:00:00	32020		\N	209946	0	39848009	4218389		0
42972	2559	4218389	1988-10-05	1988-10-05 00:00:00	1988-11-09	1988-11-09 00:00:00	32020		\N	169520	0	39848009	4218389		0
43097	2566	4027663	1968-10-16	1968-10-16 00:00:00	\N	\N	32020		\N	169979	0	13200003	4027663		0
43170	2570	260139	1936-10-17	1936-10-17 00:00:00	1936-10-24	1936-10-24 00:00:00	32020		\N	170192	0	10509002	260139		0
43471	2590	78272	1980-02-17	1980-02-17 00:00:00	1980-03-09	1980-03-09 00:00:00	32020		\N	171407	0	70704007	78272		0
43511	2591	260139	1997-12-12	1997-12-12 00:00:00	1997-12-26	1997-12-26 00:00:00	32020		\N	171511	0	10509002	260139		0
43732	2604	260139	1966-02-18	1966-02-18 00:00:00	1966-03-04	1966-03-04 00:00:00	32020		\N	172253	0	10509002	260139		0
43885	2613	40481087	1979-10-05	1979-10-05 00:00:00	1979-10-12	1979-10-12 00:00:00	32020		\N	172766	0	444814009	40481087		0
44089	2622	195588	1975-12-12	1975-12-12 00:00:00	1976-01-14	1976-01-14 00:00:00	32020		\N	173439	0	38822007	195588		0
44241	2630	40481087	1988-11-24	1988-11-24 00:00:00	1988-12-01	1988-12-01 00:00:00	32020		\N	173950	0	444814009	40481087		0
44477	2646	260139	1982-02-19	1982-02-19 00:00:00	1982-02-26	1982-02-26 00:00:00	32020		\N	175074	0	10509002	260139		0
55124	3263	378001	1966-07-15	1966-07-15 00:00:00	1966-09-13	1966-09-13 00:00:00	32020		\N	216900	0	62106007	378001		0
44754	2662	260139	1995-10-28	1995-10-28 00:00:00	1995-11-10	1995-11-10 00:00:00	32020		\N	176394	0	10509002	260139		0
44923	2673	40481087	2011-09-27	2011-09-27 00:00:00	2011-10-04	2011-10-04 00:00:00	32020		\N	177061	0	444814009	40481087		0
45134	2685	4218389	1950-07-17	1950-07-17 00:00:00	1950-08-07	1950-08-07 00:00:00	32020		\N	177897	0	39848009	4218389		0
45165	2686	4112343	2015-12-26	2015-12-26 00:00:00	2016-01-07	2016-01-07 00:00:00	32020		\N	178034	0	195662009	4112343		0
55946	3313	260139	1958-08-05	1958-08-05 00:00:00	1958-08-12	1958-08-12 00:00:00	32020		\N	219986	0	10509002	260139		0
45583	2709	4134304	1984-03-03	1984-03-03 00:00:00	1984-06-01	1984-06-01 00:00:00	32020		\N	179449	0	263102004	4134304		0
45761	2721	260139	2013-04-07	2013-04-07 00:00:00	2013-04-14	2013-04-14 00:00:00	32020		\N	180310	0	10509002	260139		0
45885	2731	372328	1961-07-18	1961-07-18 00:00:00	1961-09-18	1961-09-18 00:00:00	32020		\N	180826	0	65363002	372328		0
56666	3362	78272	2010-12-10	2010-12-10 00:00:00	2011-01-07	2011-01-07 00:00:00	32020		\N	222894	0	70704007	78272		0
46277	2757	4112343	2000-07-25	2000-07-25 00:00:00	2000-08-02	2000-08-02 00:00:00	32020		\N	182370	0	195662009	4112343		0
46391	2764	260139	1977-04-07	1977-04-07 00:00:00	1977-04-21	1977-04-21 00:00:00	32020		\N	182748	0	10509002	260139		0
46508	2770	40481087	1987-09-23	1987-09-23 00:00:00	1987-10-07	1987-10-07 00:00:00	32020		\N	183334	0	444814009	40481087		0
46737	2780	4112343	2013-02-27	2013-02-27 00:00:00	2013-03-07	2013-03-07 00:00:00	32020		\N	184223	0	195662009	4112343		0
46882	2788	40481087	1986-12-07	1986-12-07 00:00:00	1986-12-21	1986-12-21 00:00:00	32020		\N	184704	0	444814009	40481087		0
47114	2802	260139	1947-01-28	1947-01-28 00:00:00	1947-02-04	1947-02-04 00:00:00	32020		\N	185763	0	10509002	260139		0
47274	2812	260139	1999-07-20	1999-07-20 00:00:00	1999-08-03	1999-08-03 00:00:00	32020		\N	186312	0	10509002	260139		0
47413	2821	372328	1923-07-24	1923-07-24 00:00:00	1923-11-06	1923-11-06 00:00:00	32020		\N	186936	0	65363002	372328		0
47575	2829	40481087	2015-03-07	2015-03-07 00:00:00	2015-03-14	2015-03-14 00:00:00	32020		\N	187635	0	444814009	40481087		0
47667	2833	40481087	1986-07-11	1986-07-11 00:00:00	1986-07-18	1986-07-18 00:00:00	32020		\N	188023	0	444814009	40481087		0
47861	2843	40481087	1974-08-05	1974-08-05 00:00:00	1974-08-12	1974-08-12 00:00:00	32020		\N	188775	0	444814009	40481087		0
48126	2857	40481087	1969-02-08	1969-02-08 00:00:00	1969-02-22	1969-02-22 00:00:00	32020		\N	189683	0	444814009	40481087		0
48163	2858	372328	1911-06-15	1911-06-15 00:00:00	1911-08-29	1911-08-29 00:00:00	32020		\N	189840	0	65363002	372328		0
48320	2863	40481087	1968-10-14	1968-10-14 00:00:00	1968-10-28	1968-10-28 00:00:00	32020		\N	190424	0	444814009	40481087		0
59126	3508	4230399	1966-08-08	1966-08-08 00:00:00	1966-10-07	1966-10-07 00:00:00	32020		\N	232692	0	359817006	4230399		0
48802	2891	81151	1993-10-29	1993-10-29 00:00:00	1993-11-19	1993-11-19 00:00:00	32020		\N	192315	0	44465007	81151		0
48876	2894	40481087	1941-09-05	1941-09-05 00:00:00	1941-09-19	1941-09-19 00:00:00	32020		\N	192633	0	444814009	40481087		0
49119	2906	40481087	1971-09-15	1971-09-15 00:00:00	1971-09-22	1971-09-22 00:00:00	32020		\N	193617	0	444814009	40481087		0
59762	3541	78272	1991-04-01	1991-04-01 00:00:00	1991-04-15	1991-04-15 00:00:00	32020		\N	235216	0	70704007	78272		0
49451	2925	372328	1980-09-06	1980-09-06 00:00:00	1982-03-14	1982-03-14 00:00:00	32020		\N	195012	0	65363002	372328		0
49586	2933	81151	1958-08-29	1958-08-29 00:00:00	1958-09-26	1958-09-26 00:00:00	32020		\N	195603	0	44465007	81151		0
49767	2943	40481087	1952-07-30	1952-07-30 00:00:00	1952-08-20	1952-08-20 00:00:00	32020		\N	196292	0	444814009	40481087		0
39337	2333	260139	1941-12-17	1941-12-17 00:00:00	1941-12-31	1941-12-31 00:00:00	32020		\N	155223	0	10509002	260139		0
50063	2957	40481087	1963-07-05	1963-07-05 00:00:00	1963-07-26	1963-07-26 00:00:00	32020		\N	197342	0	444814009	40481087		0
50140	2961	40481087	1977-10-04	1977-10-04 00:00:00	1977-10-11	1977-10-11 00:00:00	32020		\N	197708	0	444814009	40481087		0
50428	2985	40481087	1983-08-18	1983-08-18 00:00:00	1983-08-25	1983-08-25 00:00:00	32020		\N	199263	0	444814009	40481087		0
50545	2989	4142905	1998-10-12	1998-10-12 00:00:00	1998-11-11	1998-11-11 00:00:00	32020		\N	199589	0	33737001	4142905		0
50720	3000	80180	1983-09-20	1983-09-20 00:00:00	\N	\N	32020		\N	200223	0	396275006	80180		0
50871	3010	28060	1964-12-12	1964-12-12 00:00:00	1964-12-22	1964-12-22 00:00:00	32020		\N	200794	0	43878008	28060		0
50975	3017	4116491	2002-08-05	2002-08-05 00:00:00	2002-09-23	2002-09-23 00:00:00	32020		\N	201254	0	301011002	4116491		0
61756	3647	40481087	1988-11-28	1988-11-28 00:00:00	1988-12-05	1988-12-05 00:00:00	32020		\N	242623	0	444814009	40481087		0
51380	3048	257012	2015-04-04	2015-04-04 00:00:00	\N	\N	32020		\N	202814	0	40055000	257012		0
51533	3059	80180	2012-11-29	2012-11-29 00:00:00	\N	\N	32020		\N	203513	0	396275006	80180		0
51787	3070	40481087	1969-08-16	1969-08-16 00:00:00	1969-08-30	1969-08-30 00:00:00	32020		\N	204367	0	444814009	40481087		0
51898	3077	4218389	1965-04-18	1965-04-18 00:00:00	1965-05-16	1965-05-16 00:00:00	32020		\N	204717	0	39848009	4218389		0
52039	3082	4112343	1982-10-19	1982-10-19 00:00:00	1982-10-27	1982-10-27 00:00:00	32020		\N	205248	0	195662009	4112343		0
52202	3090	4112343	2008-02-08	2008-02-08 00:00:00	2008-02-16	2008-02-16 00:00:00	32020		\N	205757	0	195662009	4112343		0
52314	3096	80180	1997-07-31	1997-07-31 00:00:00	\N	\N	32020		\N	206047	0	396275006	80180		0
63146	3730	4112343	1954-05-03	1954-05-03 00:00:00	1954-05-15	1954-05-15 00:00:00	32020		\N	247832	0	195662009	4112343		0
63261	3736	40481087	1963-12-16	1963-12-16 00:00:00	1964-01-06	1964-01-06 00:00:00	32020		\N	248272	0	444814009	40481087		0
52954	3135	4112343	1998-01-25	1998-01-25 00:00:00	1998-02-07	1998-02-07 00:00:00	32020		\N	208696	0	195662009	4112343		0
63603	3756	40481087	1995-02-01	1995-02-01 00:00:00	1995-02-22	1995-02-22 00:00:00	32020		\N	249681	0	444814009	40481087		0
42607	2540	378419	2018-04-10	2018-04-10 00:00:00	\N	\N	32020		\N	167902	0	26929004	378419		0
53300	3158	4294548	2001-07-08	2001-07-08 00:00:00	2001-07-15	2001-07-15 00:00:00	32020		\N	209966	0	75498004	4294548		0
42973	2559	4112343	1968-01-15	1968-01-15 00:00:00	1968-01-26	1968-01-26 00:00:00	32020		\N	169603	0	195662009	4112343		0
43098	2566	40481087	2007-03-17	2007-03-17 00:00:00	2007-03-24	2007-03-24 00:00:00	32020		\N	169999	0	444814009	40481087		0
43171	2570	40481087	2004-01-31	2004-01-31 00:00:00	2004-02-07	2004-02-07 00:00:00	32020		\N	170173	0	444814009	40481087		0
43472	2590	40481087	1964-07-12	1964-07-12 00:00:00	1964-07-19	1964-07-19 00:00:00	32020		\N	171415	0	444814009	40481087		0
43512	2591	260139	1947-04-26	1947-04-26 00:00:00	1947-05-10	1947-05-10 00:00:00	32020		\N	171488	0	10509002	260139		0
43733	2604	40481087	2015-06-02	2015-06-02 00:00:00	2015-06-16	2015-06-16 00:00:00	32020		\N	172303	0	444814009	40481087		0
43886	2613	40481087	1963-11-03	1963-11-03 00:00:00	1963-11-17	1963-11-17 00:00:00	32020		\N	172764	0	444814009	40481087		0
44090	2622	260139	1941-05-16	1941-05-16 00:00:00	1941-05-30	1941-05-30 00:00:00	32020		\N	173471	0	10509002	260139		0
44242	2630	4027663	1990-12-12	1990-12-12 00:00:00	\N	\N	32020		\N	173950	0	13200003	4027663		0
44478	2646	260139	1980-02-13	1980-02-13 00:00:00	1980-02-20	1980-02-20 00:00:00	32020		\N	175090	0	10509002	260139		0
55125	3263	257012	1967-09-24	1967-09-24 00:00:00	\N	\N	32020		\N	216911	0	40055000	257012		0
44755	2662	4156265	2000-09-29	2000-09-29 00:00:00	2000-10-13	2000-10-13 00:00:00	32020		\N	176430	0	370247008	4156265		0
44924	2673	4112343	1979-12-08	1979-12-08 00:00:00	1979-12-16	1979-12-16 00:00:00	32020		\N	177132	0	195662009	4112343		0
45135	2685	4112343	2013-09-19	2013-09-19 00:00:00	2013-10-02	2013-10-02 00:00:00	32020		\N	177939	0	195662009	4112343		0
45166	2686	80180	1995-02-28	1995-02-28 00:00:00	\N	\N	32020		\N	177988	0	396275006	80180		0
55947	3313	372328	1956-12-25	1956-12-25 00:00:00	1957-06-28	1957-06-28 00:00:00	32020		\N	219983	0	65363002	372328		0
45584	2709	372328	1943-12-15	1943-12-15 00:00:00	1945-01-02	1945-01-02 00:00:00	32020		\N	179529	0	65363002	372328		0
45762	2721	260139	1971-04-26	1971-04-26 00:00:00	1971-05-10	1971-05-10 00:00:00	32020		\N	180327	0	10509002	260139		0
45886	2731	321042	2007-07-09	2007-07-09 00:00:00	\N	\N	32020		\N	180794	0	410429000	321042		0
56667	3362	40481087	1962-10-28	1962-10-28 00:00:00	1962-11-04	1962-11-04 00:00:00	32020		\N	222861	0	444814009	40481087		0
46278	2757	257012	1974-06-26	1974-06-26 00:00:00	2006-07-19	2006-07-19 00:00:00	32020		\N	182332	0	40055000	257012		0
46392	2764	40481087	2011-05-21	2011-05-21 00:00:00	2011-05-28	2011-05-28 00:00:00	32020		\N	182783	0	444814009	40481087		0
46509	2770	4112343	1981-04-26	1981-04-26 00:00:00	1981-05-06	1981-05-06 00:00:00	32020		\N	183367	0	195662009	4112343		0
46738	2780	4112343	1958-10-17	1958-10-17 00:00:00	1958-10-28	1958-10-28 00:00:00	32020		\N	184218	0	195662009	4112343		0
46883	2788	4112343	1979-01-14	1979-01-14 00:00:00	1979-01-24	1979-01-24 00:00:00	32020		\N	184730	0	195662009	4112343		0
47115	2802	4218389	1944-03-12	1944-03-12 00:00:00	1944-04-09	1944-04-09 00:00:00	32020		\N	185708	0	39848009	4218389		0
47275	2812	260139	1971-10-13	1971-10-13 00:00:00	1971-10-27	1971-10-27 00:00:00	32020		\N	186302	0	10509002	260139		0
47414	2821	40481087	1964-09-15	1964-09-15 00:00:00	1964-09-22	1964-09-22 00:00:00	32020		\N	186869	0	444814009	40481087		0
47576	2829	4112343	1989-01-08	1989-01-08 00:00:00	1989-01-15	1989-01-15 00:00:00	32020		\N	187660	0	195662009	4112343		0
47668	2833	4112343	1967-07-14	1967-07-14 00:00:00	1967-07-27	1967-07-27 00:00:00	32020		\N	188049	0	195662009	4112343		0
47862	2843	40481087	1962-12-22	1962-12-22 00:00:00	1962-12-29	1962-12-29 00:00:00	32020		\N	188759	0	444814009	40481087		0
48127	2857	260139	1965-11-02	1965-11-02 00:00:00	1965-11-16	1965-11-16 00:00:00	32020		\N	189708	0	10509002	260139		0
48164	2858	260139	1977-03-02	1977-03-02 00:00:00	1977-03-16	1977-03-16 00:00:00	32020		\N	189744	0	10509002	260139		0
48321	2863	4283893	1994-09-21	1994-09-21 00:00:00	1994-11-30	1994-11-30 00:00:00	32020		\N	190372	0	36971009	4283893		0
59127	3508	372328	1958-09-03	1958-09-03 00:00:00	1958-11-05	1958-11-05 00:00:00	32020		\N	232633	0	65363002	372328		0
48803	2891	40481087	1999-04-20	1999-04-20 00:00:00	1999-04-27	1999-04-27 00:00:00	32020		\N	192325	0	444814009	40481087		0
48877	2894	4112343	2005-03-03	2005-03-03 00:00:00	2005-03-16	2005-03-16 00:00:00	32020		\N	192587	0	195662009	4112343		0
49120	2906	4112343	1931-12-20	1931-12-20 00:00:00	1931-12-30	1931-12-30 00:00:00	32020		\N	193614	0	195662009	4112343		0
59763	3541	40481087	1973-06-04	1973-06-04 00:00:00	1973-06-25	1973-06-25 00:00:00	32020		\N	235175	0	444814009	40481087		0
49452	2925	40481087	1981-09-11	1981-09-11 00:00:00	1981-09-25	1981-09-25 00:00:00	32020		\N	195091	0	444814009	40481087		0
49587	2933	372328	1955-11-13	1955-11-13 00:00:00	1956-04-30	1956-04-30 00:00:00	32020		\N	195625	0	65363002	372328		0
49768	2943	4112343	2000-02-06	2000-02-06 00:00:00	2000-02-18	2000-02-18 00:00:00	32020		\N	196294	0	195662009	4112343		0
39338	2333	40481087	1969-03-07	1969-03-07 00:00:00	1969-03-28	1969-03-28 00:00:00	32020		\N	155190	0	444814009	40481087		0
50064	2957	260139	1981-11-30	1981-11-30 00:00:00	1981-12-14	1981-12-14 00:00:00	32020		\N	197308	0	10509002	260139		0
50141	2961	260139	1994-06-29	1994-06-29 00:00:00	1994-07-13	1994-07-13 00:00:00	32020		\N	197752	0	10509002	260139		0
50429	2985	4112343	1968-06-26	1968-06-26 00:00:00	1968-07-07	1968-07-07 00:00:00	32020		\N	199236	0	195662009	4112343		0
50546	2989	4112343	1971-04-10	1971-04-10 00:00:00	1971-04-22	1971-04-22 00:00:00	32020		\N	199551	0	195662009	4112343		0
50721	3001	4310024	1979-07-10	1979-07-10 00:00:00	\N	\N	32020		\N	200301	0	424802006	4310024		0
50872	3010	260139	2008-09-30	2008-09-30 00:00:00	2008-10-07	2008-10-07 00:00:00	32020		\N	200784	0	10509002	260139		0
50976	3017	4112343	1969-07-31	1969-07-31 00:00:00	1969-08-09	1969-08-09 00:00:00	32020		\N	201272	0	195662009	4112343		0
61757	3647	4294548	1997-04-20	1997-04-20 00:00:00	1997-06-29	1997-06-29 00:00:00	32020		\N	242625	0	75498004	4294548		0
51381	3048	378001	2014-11-11	2014-11-11 00:00:00	2015-01-10	2015-01-10 00:00:00	32020		\N	202797	0	62106007	378001		0
51534	3059	40481087	2001-11-04	2001-11-04 00:00:00	2001-11-25	2001-11-25 00:00:00	32020		\N	203494	0	444814009	40481087		0
51788	3070	4027663	1991-09-19	1991-09-19 00:00:00	\N	\N	32020		\N	204339	0	13200003	4027663		0
51899	3077	375671	2006-04-14	2006-04-14 00:00:00	2006-05-14	2006-05-14 00:00:00	32020		\N	204724	0	62564004	375671		0
52040	3082	260139	1997-05-19	1997-05-19 00:00:00	1997-05-26	1997-05-26 00:00:00	32020		\N	205230	0	10509002	260139		0
52203	3090	260139	1961-09-21	1961-09-21 00:00:00	1961-10-05	1961-10-05 00:00:00	32020		\N	205705	0	10509002	260139		0
52315	3096	4278672	2016-04-08	2016-04-08 00:00:00	2016-07-07	2016-07-07 00:00:00	32020		\N	206080	0	65966004	4278672		0
63148	3730	321042	1994-07-28	1994-07-28 00:00:00	\N	\N	32020		\N	247807	0	410429000	321042		0
63262	3736	28060	1985-04-12	1985-04-12 00:00:00	1985-04-24	1985-04-24 00:00:00	32020		\N	248315	0	43878008	28060		0
63413	3745	40481087	1957-07-23	1957-07-23 00:00:00	1957-07-30	1957-07-30 00:00:00	32020		\N	248913	0	444814009	40481087		0
63604	3756	440448	2017-12-03	2017-12-03 00:00:00	\N	\N	32020		\N	249666	0	74400008	440448		0
42608	2540	40481087	1964-06-15	1964-06-15 00:00:00	1964-06-22	1964-06-22 00:00:00	32020		\N	167879	0	444814009	40481087		0
53301	3158	381316	2002-01-10	2002-01-10 00:00:00	\N	\N	32020		\N	209966	0	230690007	381316		0
42974	2559	4109685	2012-05-07	2012-05-07 00:00:00	2012-05-21	2012-05-21 00:00:00	32020		\N	169521	0	284551006	4109685		0
43099	2566	4112343	2015-03-21	2015-03-21 00:00:00	2015-04-03	2015-04-03 00:00:00	32020		\N	169942	0	195662009	4112343		0
43193	2572	4283893	2005-10-16	2005-10-16 00:00:00	2005-11-13	2005-11-13 00:00:00	32020		\N	170390	0	36971009	4283893		0
43473	2590	78272	1966-06-27	1966-06-27 00:00:00	1966-07-25	1966-07-25 00:00:00	32020		\N	171404	0	70704007	78272		0
43513	2591	4112343	1970-09-07	1970-09-07 00:00:00	1970-09-18	1970-09-18 00:00:00	32020		\N	171453	0	195662009	4112343		0
43734	2604	4152936	1962-01-08	1962-01-08 00:00:00	1962-01-22	1962-01-22 00:00:00	32020		\N	172311	0	283385000	4152936		0
43887	2613	4283893	1978-10-06	1978-10-06 00:00:00	1978-11-03	1978-11-03 00:00:00	32020		\N	172747	0	36971009	4283893		0
44091	2622	192671	1975-05-22	1975-05-22 00:00:00	\N	\N	32020		\N	173410	0	K92.2	35208414		0
44243	2630	4112343	2007-02-18	2007-02-18 00:00:00	2007-03-03	2007-03-03 00:00:00	32020		\N	173934	0	195662009	4112343		0
44479	2646	4112343	1998-07-05	1998-07-05 00:00:00	1998-07-16	1998-07-16 00:00:00	32020		\N	175091	0	195662009	4112343		0
55126	3263	40481087	1962-01-29	1962-01-29 00:00:00	1962-02-12	1962-02-12 00:00:00	32020		\N	216917	0	444814009	40481087		0
44756	2662	372328	1979-04-22	1979-04-22 00:00:00	1979-07-06	1979-07-06 00:00:00	32020		\N	176400	0	65363002	372328		0
44925	2673	4230399	2009-03-21	2009-03-21 00:00:00	2009-05-20	2009-05-20 00:00:00	32020		\N	177100	0	359817006	4230399		0
45136	2685	260139	1982-12-14	1982-12-14 00:00:00	1982-12-28	1982-12-28 00:00:00	32020		\N	177936	0	10509002	260139		0
45167	2686	4109685	1967-12-02	1967-12-02 00:00:00	1967-12-16	1967-12-16 00:00:00	32020		\N	178070	0	284551006	4109685		0
55948	3313	40481087	1983-08-27	1983-08-27 00:00:00	1983-09-17	1983-09-17 00:00:00	32020		\N	219969	0	444814009	40481087		0
45585	2709	40481087	1947-05-07	1947-05-07 00:00:00	1947-05-28	1947-05-28 00:00:00	32020		\N	179441	0	444814009	40481087		0
45763	2721	40481087	1976-10-21	1976-10-21 00:00:00	1976-11-11	1976-11-11 00:00:00	32020		\N	180328	0	444814009	40481087		0
45888	2731	80180	2003-07-21	2003-07-21 00:00:00	\N	\N	32020		\N	180812	0	396275006	80180		0
56668	3362	28060	1965-06-26	1965-06-26 00:00:00	1965-07-04	1965-07-04 00:00:00	32020		\N	222882	0	43878008	28060		0
46279	2757	4278672	1976-02-15	1976-02-15 00:00:00	1976-04-15	1976-04-15 00:00:00	32020		\N	182335	0	65966004	4278672		0
46393	2764	4310024	2008-09-14	2008-09-14 00:00:00	\N	\N	32020		\N	182790	0	424802006	4310024		0
46510	2770	40481087	1951-01-21	1951-01-21 00:00:00	1951-01-28	1951-01-28 00:00:00	32020		\N	183364	0	444814009	40481087		0
46739	2780	260139	2018-08-21	2018-08-21 00:00:00	2018-08-28	2018-08-28 00:00:00	32020		\N	184211	0	10509002	260139		0
46884	2788	40481087	2006-01-02	2006-01-02 00:00:00	2006-01-16	2006-01-16 00:00:00	32020		\N	184731	0	444814009	40481087		0
47116	2802	40481087	1948-01-27	1948-01-27 00:00:00	1948-02-03	1948-02-03 00:00:00	32020		\N	185723	0	444814009	40481087		0
47276	2812	4112343	2014-11-25	2014-11-25 00:00:00	2014-12-02	2014-12-02 00:00:00	32020		\N	186313	0	195662009	4112343		0
47415	2821	4112343	1947-06-19	1947-06-19 00:00:00	1947-07-02	1947-07-02 00:00:00	32020		\N	186894	0	195662009	4112343		0
47577	2829	260139	1959-01-21	1959-01-21 00:00:00	1959-02-04	1959-02-04 00:00:00	32020		\N	187631	0	10509002	260139		0
47669	2833	260139	2011-08-28	2011-08-28 00:00:00	2011-09-04	2011-09-04 00:00:00	32020		\N	188025	0	10509002	260139		0
47863	2843	4112343	1988-04-15	1988-04-15 00:00:00	1988-04-28	1988-04-28 00:00:00	32020		\N	188777	0	195662009	4112343		0
48128	2857	40481087	2005-08-09	2005-08-09 00:00:00	2005-08-23	2005-08-23 00:00:00	32020		\N	189713	0	444814009	40481087		0
48165	2858	40481087	1964-09-02	1964-09-02 00:00:00	1964-09-16	1964-09-16 00:00:00	32020		\N	189781	0	444814009	40481087		0
48322	2863	28060	1961-11-14	1961-11-14 00:00:00	1961-11-21	1961-11-21 00:00:00	32020		\N	190421	0	43878008	28060		0
59128	3508	4294548	1978-12-10	1978-12-10 00:00:00	1979-03-04	1979-03-04 00:00:00	32020		\N	232641	0	75498004	4294548		0
48804	2892	4294548	1986-06-21	1986-06-21 00:00:00	1986-07-05	1986-07-05 00:00:00	32020		\N	192424	0	75498004	4294548		0
48878	2894	80180	1958-04-23	1958-04-23 00:00:00	\N	\N	32020		\N	192635	0	396275006	80180		0
49121	2906	372328	2009-09-30	2009-09-30 00:00:00	2010-06-19	2010-06-19 00:00:00	32020		\N	193646	0	65363002	372328		0
59764	3541	4112343	1992-02-22	1992-02-22 00:00:00	1992-03-05	1992-03-05 00:00:00	32020		\N	235177	0	195662009	4112343		0
49453	2925	372328	2001-05-04	2001-05-04 00:00:00	2002-01-20	2002-01-20 00:00:00	32020		\N	195132	0	65363002	372328		0
49588	2933	40481087	2004-11-08	2004-11-08 00:00:00	2004-11-22	2004-11-22 00:00:00	32020		\N	195632	0	444814009	40481087		0
49769	2943	40481087	1915-02-01	1915-02-01 00:00:00	1915-02-15	1915-02-15 00:00:00	32020		\N	196348	0	444814009	40481087		0
39339	2333	40481087	1931-01-01	1931-01-01 00:00:00	1931-01-15	1931-01-15 00:00:00	32020		\N	155188	0	444814009	40481087		0
50065	2957	28060	1958-02-20	1958-02-20 00:00:00	1958-03-01	1958-03-01 00:00:00	32020		\N	197341	0	43878008	28060		0
50142	2961	40481087	1982-03-24	1982-03-24 00:00:00	1982-04-07	1982-04-07 00:00:00	32020		\N	197750	0	444814009	40481087		0
50430	2985	372328	1966-06-19	1966-06-19 00:00:00	1966-09-24	1966-09-24 00:00:00	32020		\N	199211	0	65363002	372328		0
50547	2989	81893	1996-03-09	1996-03-09 00:00:00	\N	\N	32020		\N	199568	0	64766004	81893		0
50722	3001	40481087	1967-10-01	1967-10-01 00:00:00	1967-10-15	1967-10-15 00:00:00	32020		\N	200283	0	444814009	40481087		0
50873	3010	381316	2015-03-18	2015-03-18 00:00:00	\N	\N	32020		\N	200792	0	230690007	381316		0
50977	3017	40481087	1973-04-30	1973-04-30 00:00:00	1973-05-07	1973-05-07 00:00:00	32020		\N	201273	0	444814009	40481087		0
61758	3647	4156265	1991-09-01	1991-09-01 00:00:00	1991-09-22	1991-09-22 00:00:00	32020		\N	242665	0	370247008	4156265		0
51382	3049	4155034	2017-06-20	2017-06-20 00:00:00	2017-07-11	2017-07-11 00:00:00	32020		\N	202878	0	283371005	4155034		0
51535	3059	4283893	2012-12-18	2012-12-18 00:00:00	2013-02-12	2013-02-12 00:00:00	32020		\N	203507	0	36971009	4283893		0
51789	3070	40481087	1981-09-19	1981-09-19 00:00:00	1981-10-10	1981-10-10 00:00:00	32020		\N	204384	0	444814009	40481087		0
51900	3077	40481087	1953-12-08	1953-12-08 00:00:00	1953-12-22	1953-12-22 00:00:00	32020		\N	204797	0	444814009	40481087		0
52041	3082	4112343	2006-05-07	2006-05-07 00:00:00	2006-05-15	2006-05-15 00:00:00	32020		\N	205243	0	195662009	4112343		0
52204	3090	4112343	1999-04-07	1999-04-07 00:00:00	1999-04-17	1999-04-17 00:00:00	32020		\N	205708	0	195662009	4112343		0
52320	3098	40481087	1998-03-18	1998-03-18 00:00:00	1998-03-25	1998-03-25 00:00:00	32020		\N	206164	0	444814009	40481087		0
63149	3730	4237458	2002-07-23	2002-07-23 00:00:00	2002-10-21	2002-10-21 00:00:00	32020		\N	247808	0	58150001	4237458		0
63263	3736	28060	1968-02-26	1968-02-26 00:00:00	1968-03-10	1968-03-10 00:00:00	32020		\N	248256	0	43878008	28060		0
63414	3745	80502	1990-05-09	1990-05-09 00:00:00	\N	\N	32020		\N	248869	0	64859006	80502		0
63605	3756	381316	2006-02-04	2006-02-04 00:00:00	\N	\N	32020		\N	249690	0	230690007	381316		0
42609	2540	260139	1990-10-27	1990-10-27 00:00:00	1990-11-03	1990-11-03 00:00:00	32020		\N	167980	0	10509002	260139		0
53302	3158	4112343	1958-12-04	1958-12-04 00:00:00	1958-12-15	1958-12-15 00:00:00	32020		\N	210009	0	195662009	4112343		0
42975	2559	260139	1980-02-19	1980-02-19 00:00:00	1980-02-26	1980-02-26 00:00:00	32020		\N	169593	0	10509002	260139		0
43100	2566	78272	1958-11-13	1958-11-13 00:00:00	1958-12-11	1958-12-11 00:00:00	32020		\N	170034	0	70704007	78272		0
43194	2572	4027663	1999-06-17	1999-06-17 00:00:00	\N	\N	32020		\N	170386	0	13200003	4027663		0
43474	2590	78272	1990-10-04	1990-10-04 00:00:00	1990-11-01	1990-11-01 00:00:00	32020		\N	171409	0	70704007	78272		0
43514	2591	4027663	1962-06-09	1962-06-09 00:00:00	\N	\N	32020		\N	171502	0	13200003	4027663		0
43735	2604	4112343	1989-08-23	1989-08-23 00:00:00	1989-09-05	1989-09-05 00:00:00	32020		\N	172300	0	195662009	4112343		0
43888	2613	260139	1967-06-15	1967-06-15 00:00:00	1967-06-22	1967-06-22 00:00:00	32020		\N	172765	0	10509002	260139		0
44092	2622	40481087	2018-07-24	2018-07-24 00:00:00	2018-08-14	2018-08-14 00:00:00	32020		\N	173411	0	444814009	40481087		0
44244	2630	257012	1979-07-03	1979-07-03 00:00:00	\N	\N	32020		\N	173947	0	40055000	257012		0
44480	2646	372328	1977-12-23	1977-12-23 00:00:00	1978-06-16	1978-06-16 00:00:00	32020		\N	175093	0	65363002	372328		0
55127	3263	4156265	2002-11-03	2002-11-03 00:00:00	2002-11-17	2002-11-17 00:00:00	32020		\N	216902	0	370247008	4156265		0
51104	3026	257012	1998-01-14	1998-01-14 00:00:00	\N	\N	32020		\N	201770	0	40055000	257012		0
44757	2663	4112343	2010-05-10	2010-05-10 00:00:00	2010-05-21	2010-05-21 00:00:00	32020		\N	176486	0	195662009	4112343		0
44926	2673	4048171	1982-02-13	1982-02-13 00:00:00	1996-02-12	1996-02-12 00:00:00	32020		\N	177113	0	232353008	4048171		0
45137	2685	80180	1981-01-05	1981-01-05 00:00:00	\N	\N	32020		\N	177959	0	396275006	80180		0
45168	2686	4113008	1972-10-20	1972-10-20 00:00:00	1972-11-10	1972-11-10 00:00:00	32020		\N	178071	0	284549007	4113008		0
55949	3313	40481087	2009-05-23	2009-05-23 00:00:00	2009-06-13	2009-06-13 00:00:00	32020		\N	219972	0	444814009	40481087		0
45586	2709	4112343	1950-12-09	1950-12-09 00:00:00	1950-12-17	1950-12-17 00:00:00	32020		\N	179491	0	195662009	4112343		0
45764	2721	4001336	2018-05-22	2018-05-22 00:00:00	2018-07-21	2018-07-21 00:00:00	32020		\N	180348	0	110030002	4001336		0
45889	2731	40481087	1980-11-25	1980-11-25 00:00:00	1980-12-02	1980-12-02 00:00:00	32020		\N	180756	0	444814009	40481087		0
56669	3362	4112343	2004-08-09	2004-08-09 00:00:00	2004-08-16	2004-08-16 00:00:00	32020		\N	222900	0	195662009	4112343		0
46280	2757	4294548	1974-06-05	1974-06-05 00:00:00	1974-07-03	1974-07-03 00:00:00	32020		\N	182337	0	75498004	4294548		0
46394	2764	80180	2009-10-09	2009-10-09 00:00:00	\N	\N	32020		\N	182790	0	396275006	80180		0
46511	2770	4142905	2004-11-04	2004-11-04 00:00:00	2004-12-04	2004-12-04 00:00:00	32020		\N	183305	0	33737001	4142905		0
46740	2780	440448	1957-01-18	1957-01-18 00:00:00	\N	\N	32020		\N	184246	0	74400008	440448		0
46885	2788	440086	1991-03-16	1991-03-16 00:00:00	1991-04-20	1991-04-20 00:00:00	32020		\N	184698	0	192127007	440086		0
47117	2802	440086	1948-09-07	1948-09-07 00:00:00	1956-09-15	1956-09-15 00:00:00	32020		\N	185752	0	192127007	440086		0
47277	2812	40481087	1992-08-11	1992-08-11 00:00:00	1992-09-01	1992-09-01 00:00:00	32020		\N	186279	0	444814009	40481087		0
47416	2821	78272	1937-07-02	1937-07-02 00:00:00	1937-07-23	1937-07-23 00:00:00	32020		\N	186849	0	70704007	78272		0
47578	2829	260139	1992-08-11	1992-08-11 00:00:00	1992-08-18	1992-08-18 00:00:00	32020		\N	187661	0	10509002	260139		0
47670	2833	4112343	1978-06-13	1978-06-13 00:00:00	1978-06-21	1978-06-21 00:00:00	32020		\N	188022	0	195662009	4112343		0
47864	2843	4112343	1959-12-04	1959-12-04 00:00:00	1959-12-12	1959-12-12 00:00:00	32020		\N	188719	0	195662009	4112343		0
48129	2857	80180	2006-03-16	2006-03-16 00:00:00	\N	\N	32020		\N	189713	0	396275006	80180		0
48166	2858	40481087	1913-03-15	1913-03-15 00:00:00	1913-04-05	1913-04-05 00:00:00	32020		\N	189737	0	444814009	40481087		0
48323	2863	260139	1990-03-18	1990-03-18 00:00:00	1990-04-01	1990-04-01 00:00:00	32020		\N	190429	0	10509002	260139		0
59129	3508	372328	1961-09-20	1961-09-20 00:00:00	1961-11-08	1961-11-08 00:00:00	32020		\N	232629	0	65363002	372328		0
59276	3516	4112343	1965-06-25	1965-06-25 00:00:00	1965-07-07	1965-07-07 00:00:00	32020		\N	233332	0	195662009	4112343		0
48879	2894	40481087	1956-10-23	1956-10-23 00:00:00	1956-11-06	1956-11-06 00:00:00	32020		\N	192635	0	444814009	40481087		0
49122	2906	260139	1970-03-14	1970-03-14 00:00:00	1970-03-21	1970-03-21 00:00:00	32020		\N	193746	0	10509002	260139		0
59765	3541	260139	2014-08-18	2014-08-18 00:00:00	2014-09-01	2014-09-01 00:00:00	32020		\N	235174	0	10509002	260139		0
49454	2925	4112343	2013-07-22	2013-07-22 00:00:00	2013-08-04	2013-08-04 00:00:00	32020		\N	195080	0	195662009	4112343		0
49589	2933	40481087	1955-06-25	1955-06-25 00:00:00	1955-07-09	1955-07-09 00:00:00	32020		\N	195623	0	444814009	40481087		0
49770	2943	260139	1994-05-30	1994-05-30 00:00:00	1994-06-06	1994-06-06 00:00:00	32020		\N	196323	0	10509002	260139		0
39340	2333	81151	1990-03-20	1990-03-20 00:00:00	1990-04-24	1990-04-24 00:00:00	32020		\N	155163	0	44465007	81151		0
50066	2957	40481087	1990-05-25	1990-05-25 00:00:00	1990-06-08	1990-06-08 00:00:00	32020		\N	197344	0	444814009	40481087		0
50143	2961	40481087	1996-08-21	1996-08-21 00:00:00	1996-09-04	1996-09-04 00:00:00	32020		\N	197753	0	444814009	40481087		0
50431	2985	4112343	1996-07-08	1996-07-08 00:00:00	1996-07-16	1996-07-16 00:00:00	32020		\N	199251	0	195662009	4112343		0
50548	2989	260139	1966-08-20	1966-08-20 00:00:00	1966-09-03	1966-09-03 00:00:00	32020		\N	199543	0	10509002	260139		0
50723	3001	40481087	1967-01-21	1967-01-21 00:00:00	1967-01-28	1967-01-28 00:00:00	32020		\N	200239	0	444814009	40481087		0
50874	3010	81151	1973-07-24	1973-07-24 00:00:00	1973-08-14	1973-08-14 00:00:00	32020		\N	200797	0	44465007	81151		0
50978	3017	4112343	1960-10-02	1960-10-02 00:00:00	1960-10-12	1960-10-12 00:00:00	32020		\N	201239	0	195662009	4112343		0
61759	3647	40481087	2003-09-04	2003-09-04 00:00:00	2003-09-11	2003-09-11 00:00:00	32020		\N	242721	0	444814009	40481087		0
51383	3049	260139	1997-10-14	1997-10-14 00:00:00	1997-10-28	1997-10-28 00:00:00	32020		\N	202849	0	10509002	260139		0
51536	3059	4112343	2009-05-09	2009-05-09 00:00:00	2009-05-22	2009-05-22 00:00:00	32020		\N	203476	0	195662009	4112343		0
51790	3070	4112343	1994-09-29	1994-09-29 00:00:00	1994-10-08	1994-10-08 00:00:00	32020		\N	204386	0	195662009	4112343		0
51901	3077	4146173	1976-12-19	1976-12-19 00:00:00	1977-01-18	1977-01-18 00:00:00	32020		\N	204800	0	307731004	4146173		0
52042	3082	260139	2001-11-03	2001-11-03 00:00:00	2001-11-10	2001-11-10 00:00:00	32020		\N	205231	0	10509002	260139		0
52228	3092	28060	1970-07-20	1970-07-20 00:00:00	1970-08-01	1970-08-01 00:00:00	32020		\N	205865	0	43878008	28060		0
52321	3098	439777	1958-09-22	1958-09-22 00:00:00	\N	\N	32020		\N	206146	0	271737000	439777		0
63150	3730	80180	1989-08-10	1989-08-10 00:00:00	\N	\N	32020		\N	247819	0	396275006	80180		0
63264	3736	28060	1965-05-16	1965-05-16 00:00:00	1965-05-26	1965-05-26 00:00:00	32020		\N	248273	0	43878008	28060		0
63415	3745	440448	1935-03-13	1935-03-13 00:00:00	\N	\N	32020		\N	248875	0	74400008	440448		0
63606	3756	260139	1968-12-13	1968-12-13 00:00:00	1968-12-27	1968-12-27 00:00:00	32020		\N	249624	0	10509002	260139		0
42610	2540	40481087	2012-06-23	2012-06-23 00:00:00	2012-06-30	2012-06-30 00:00:00	32020		\N	167928	0	444814009	40481087		0
53303	3158	81151	1971-09-18	1971-09-18 00:00:00	1971-10-16	1971-10-16 00:00:00	32020		\N	209947	0	44465007	81151		0
42976	2559	4218389	2014-01-11	2014-01-11 00:00:00	2014-02-01	2014-02-01 00:00:00	32020		\N	169522	0	39848009	4218389		0
43101	2566	372328	1941-02-15	1941-02-15 00:00:00	1941-04-01	1941-04-01 00:00:00	32020		\N	169947	0	65363002	372328		0
43195	2572	4116491	2019-06-12	2019-06-12 00:00:00	\N	\N	32020		\N	170391	0	301011002	4116491		0
43475	2590	40481087	1963-05-20	1963-05-20 00:00:00	1963-06-10	1963-06-10 00:00:00	32020		\N	171368	0	444814009	40481087		0
43515	2591	260139	1951-04-29	1951-04-29 00:00:00	1951-05-13	1951-05-13 00:00:00	32020		\N	171479	0	10509002	260139		0
43736	2604	4152936	2017-05-18	2017-05-18 00:00:00	2017-06-01	2017-06-01 00:00:00	32020		\N	172299	0	283385000	4152936		0
43889	2613	372328	1960-04-16	1960-04-16 00:00:00	1960-09-23	1960-09-23 00:00:00	32020		\N	172776	0	65363002	372328		0
44093	2622	372328	1931-10-04	1931-10-04 00:00:00	1932-01-16	1932-01-16 00:00:00	32020		\N	173412	0	65363002	372328		0
44245	2630	4112343	1962-01-09	1962-01-09 00:00:00	1962-01-16	1962-01-16 00:00:00	32020		\N	173982	0	195662009	4112343		0
44481	2646	40481087	1995-12-23	1995-12-23 00:00:00	1996-01-13	1996-01-13 00:00:00	32020		\N	175046	0	444814009	40481087		0
55128	3263	40481087	1999-12-07	1999-12-07 00:00:00	1999-12-28	1999-12-28 00:00:00	32020		\N	216913	0	444814009	40481087		0
44758	2663	40481087	2013-06-06	2013-06-06 00:00:00	2013-06-27	2013-06-27 00:00:00	32020		\N	176479	0	444814009	40481087		0
44927	2673	40481087	1995-11-21	1995-11-21 00:00:00	1995-11-28	1995-11-28 00:00:00	32020		\N	177164	0	444814009	40481087		0
45138	2685	81151	1992-04-12	1992-04-12 00:00:00	1992-05-10	1992-05-10 00:00:00	32020		\N	177899	0	44465007	81151		0
45169	2686	260139	1956-11-01	1956-11-01 00:00:00	1956-11-08	1956-11-08 00:00:00	32020		\N	178047	0	10509002	260139		0
55950	3313	80180	1991-12-28	1991-12-28 00:00:00	\N	\N	32020		\N	220020	0	396275006	80180		0
45587	2709	4112343	2003-04-11	2003-04-11 00:00:00	2003-04-24	2003-04-24 00:00:00	32020		\N	179488	0	195662009	4112343		0
45765	2721	40481087	2018-08-22	2018-08-22 00:00:00	2018-09-05	2018-09-05 00:00:00	32020		\N	180312	0	444814009	40481087		0
45890	2732	78272	1980-02-02	1980-02-02 00:00:00	1980-03-01	1980-03-01 00:00:00	32020		\N	180928	0	70704007	78272		0
56670	3362	40481087	1975-04-29	1975-04-29 00:00:00	1975-05-13	1975-05-13 00:00:00	32020		\N	222862	0	444814009	40481087		0
46281	2757	381316	2017-01-20	2017-01-20 00:00:00	\N	\N	32020		\N	182378	0	230690007	381316		0
46395	2764	4285898	2009-09-09	2009-09-09 00:00:00	\N	\N	32020		\N	182790	0	68496003	4285898		0
46512	2770	260139	1941-12-08	1941-12-08 00:00:00	1941-12-22	1941-12-22 00:00:00	32020		\N	183310	0	10509002	260139		0
46741	2780	40481087	1962-06-05	1962-06-05 00:00:00	1962-06-19	1962-06-19 00:00:00	32020		\N	184220	0	444814009	40481087		0
46897	2790	4001336	1959-12-15	1959-12-15 00:00:00	1960-01-14	1960-01-14 00:00:00	32020		\N	184870	0	110030002	4001336		0
47118	2802	40481087	1949-10-01	1949-10-01 00:00:00	1949-10-08	1949-10-08 00:00:00	32020		\N	185729	0	444814009	40481087		0
47278	2812	4152936	1962-08-29	1962-08-29 00:00:00	1962-09-12	1962-09-12 00:00:00	32020		\N	186283	0	283385000	4152936		0
47417	2821	40481087	1973-11-22	1973-11-22 00:00:00	1973-12-06	1973-12-06 00:00:00	32020		\N	186951	0	444814009	40481087		0
47579	2829	40481087	2017-08-08	2017-08-08 00:00:00	2017-08-15	2017-08-15 00:00:00	32020		\N	187665	0	444814009	40481087		0
47671	2833	81151	1975-12-13	1975-12-13 00:00:00	1976-01-10	1976-01-10 00:00:00	32020		\N	188074	0	44465007	81151		0
47865	2843	40481087	2008-04-13	2008-04-13 00:00:00	2008-04-20	2008-04-20 00:00:00	32020		\N	188792	0	444814009	40481087		0
48130	2857	260139	1969-08-02	1969-08-02 00:00:00	1969-08-09	1969-08-09 00:00:00	32020		\N	189732	0	10509002	260139		0
48167	2858	4134304	1912-03-11	1912-03-11 00:00:00	1912-04-10	1912-04-10 00:00:00	32020		\N	189897	0	263102004	4134304		0
48324	2863	372328	1963-10-04	1963-10-04 00:00:00	1964-02-20	1964-02-20 00:00:00	32020		\N	190376	0	65363002	372328		0
59130	3508	257012	1979-02-25	1979-02-25 00:00:00	\N	\N	32020		\N	232652	0	40055000	257012		0
59277	3516	4218389	1966-03-08	1966-03-08 00:00:00	1966-04-05	1966-04-05 00:00:00	32020		\N	233366	0	39848009	4218389		0
48880	2894	4296205	2004-09-18	2004-09-18 00:00:00	2004-10-23	2004-10-23 00:00:00	32020		\N	192606	0	403191005	4296205		0
49123	2906	372328	1924-11-08	1924-11-08 00:00:00	1924-12-20	1924-12-20 00:00:00	32020		\N	193742	0	65363002	372328		0
59766	3541	40481087	2016-12-05	2016-12-05 00:00:00	2016-12-19	2016-12-19 00:00:00	32020		\N	235195	0	444814009	40481087		0
49455	2925	260139	1983-02-10	1983-02-10 00:00:00	1983-02-17	1983-02-17 00:00:00	32020		\N	195092	0	10509002	260139		0
49590	2933	4112343	1954-07-25	1954-07-25 00:00:00	1954-08-04	1954-08-04 00:00:00	32020		\N	195594	0	195662009	4112343		0
49771	2943	4109685	1917-03-17	1917-03-17 00:00:00	1917-03-31	1917-03-31 00:00:00	32020		\N	196243	0	284551006	4109685		0
39341	2333	4113008	1940-09-12	1940-09-12 00:00:00	1940-09-26	1940-09-26 00:00:00	32020		\N	155159	0	284549007	4113008		0
50079	2959	40481087	2001-04-19	2001-04-19 00:00:00	2001-05-10	2001-05-10 00:00:00	32020		\N	197541	0	444814009	40481087		0
50144	2961	40481087	1999-09-28	1999-09-28 00:00:00	1999-10-05	1999-10-05 00:00:00	32020		\N	197714	0	444814009	40481087		0
50432	2985	4112343	1968-12-05	1968-12-05 00:00:00	1968-12-16	1968-12-16 00:00:00	32020		\N	199227	0	195662009	4112343		0
50549	2989	40481087	1968-03-03	1968-03-03 00:00:00	1968-03-24	1968-03-24 00:00:00	32020		\N	199574	0	444814009	40481087		0
50724	3001	4113008	1980-12-15	1980-12-15 00:00:00	1981-01-05	1981-01-05 00:00:00	32020		\N	200329	0	284549007	4113008		0
50875	3010	260139	2000-01-07	2000-01-07 00:00:00	2000-01-14	2000-01-14 00:00:00	32020		\N	200767	0	10509002	260139		0
50979	3017	260139	1966-03-03	1966-03-03 00:00:00	1966-03-10	1966-03-10 00:00:00	32020		\N	201209	0	10509002	260139		0
61760	3647	81151	1947-04-11	1947-04-11 00:00:00	1947-04-25	1947-04-25 00:00:00	32020		\N	242664	0	44465007	81151		0
51384	3049	4112343	2006-08-27	2006-08-27 00:00:00	2006-09-07	2006-09-07 00:00:00	32020		\N	202850	0	195662009	4112343		0
51537	3059	81151	1978-05-07	1978-05-07 00:00:00	1978-05-28	1978-05-28 00:00:00	32020		\N	203532	0	44465007	81151		0
51791	3070	4112343	1978-06-08	1978-06-08 00:00:00	1978-06-21	1978-06-21 00:00:00	32020		\N	204383	0	195662009	4112343		0
51902	3077	40481087	2006-03-05	2006-03-05 00:00:00	2006-03-12	2006-03-12 00:00:00	32020		\N	204763	0	444814009	40481087		0
52043	3082	40481087	1979-05-15	1979-05-15 00:00:00	1979-05-29	1979-05-29 00:00:00	32020		\N	205181	0	444814009	40481087		0
52229	3092	372328	1961-01-07	1961-01-07 00:00:00	1961-07-12	1961-07-12 00:00:00	32020		\N	205894	0	65363002	372328		0
52322	3098	4294548	1984-06-08	1984-06-08 00:00:00	1984-06-22	1984-06-22 00:00:00	32020		\N	206196	0	75498004	4294548		0
63151	3730	4112343	1994-12-06	1994-12-06 00:00:00	1994-12-18	1994-12-18 00:00:00	32020		\N	247873	0	195662009	4112343		0
63265	3736	40481087	1961-05-17	1961-05-17 00:00:00	1961-05-24	1961-05-24 00:00:00	32020		\N	248344	0	444814009	40481087		0
63416	3745	4084167	1931-03-07	1931-03-07 00:00:00	1931-03-07	1931-03-07 00:00:00	32020		\N	248872	0	241929008	4084167		0
63607	3756	4112343	2003-10-27	2003-10-27 00:00:00	2003-11-09	2003-11-09 00:00:00	32020		\N	249626	0	195662009	4112343		0
42611	2540	81151	1972-02-04	1972-02-04 00:00:00	1972-02-25	1972-02-25 00:00:00	32020		\N	167986	0	44465007	81151		0
53304	3158	4113008	1974-05-03	1974-05-03 00:00:00	1974-05-17	1974-05-17 00:00:00	32020		\N	209948	0	284549007	4113008		0
42977	2559	40481087	1979-12-27	1979-12-27 00:00:00	1980-01-17	1980-01-17 00:00:00	32020		\N	169624	0	444814009	40481087		0
43102	2566	40481087	2003-04-16	2003-04-16 00:00:00	2003-04-30	2003-04-30 00:00:00	32020		\N	169941	0	444814009	40481087		0
43196	2572	4112343	2014-05-28	2014-05-28 00:00:00	2014-06-05	2014-06-05 00:00:00	32020		\N	170364	0	195662009	4112343		0
43476	2590	372328	1968-06-28	1968-06-28 00:00:00	1968-10-01	1968-10-01 00:00:00	32020		\N	171370	0	65363002	372328		0
43516	2591	4294548	1960-04-11	1960-04-11 00:00:00	1960-05-09	1960-05-09 00:00:00	32020		\N	171452	0	75498004	4294548		0
43737	2604	28060	1991-02-28	1991-02-28 00:00:00	1991-03-11	1991-03-11 00:00:00	32020		\N	172255	0	43878008	28060		0
43890	2613	4112343	1982-05-03	1982-05-03 00:00:00	1982-05-12	1982-05-12 00:00:00	32020		\N	172767	0	195662009	4112343		0
44094	2622	378001	2015-08-05	2015-08-05 00:00:00	2015-09-04	2015-09-04 00:00:00	32020		\N	173405	0	62106007	378001		0
44246	2631	40481087	2010-09-05	2010-09-05 00:00:00	2010-09-26	2010-09-26 00:00:00	32020		\N	174103	0	444814009	40481087		0
44482	2646	4112343	1979-03-21	1979-03-21 00:00:00	1979-03-30	1979-03-30 00:00:00	32020		\N	175044	0	195662009	4112343		0
55129	3263	30753	1983-11-04	1983-11-04 00:00:00	\N	\N	32020		\N	216934	0	16761005	30753		0
44759	2663	40481087	2005-10-26	2005-10-26 00:00:00	2005-11-09	2005-11-09 00:00:00	32020		\N	176446	0	444814009	40481087		0
44928	2673	195588	2014-01-29	2014-01-29 00:00:00	2014-03-19	2014-03-19 00:00:00	32020		\N	177062	0	38822007	195588		0
45139	2685	28060	1989-05-05	1989-05-05 00:00:00	1989-05-17	1989-05-17 00:00:00	32020		\N	177908	0	43878008	28060		0
45170	2686	260139	1966-07-12	1966-07-12 00:00:00	1966-07-26	1966-07-26 00:00:00	32020		\N	177984	0	10509002	260139		0
55951	3313	260139	1994-03-15	1994-03-15 00:00:00	1994-03-22	1994-03-22 00:00:00	32020		\N	219981	0	10509002	260139		0
45588	2709	40481087	1999-01-24	1999-01-24 00:00:00	1999-02-07	1999-02-07 00:00:00	32020		\N	179493	0	444814009	40481087		0
45766	2721	372328	1971-11-20	1971-11-20 00:00:00	1972-10-21	1972-10-21 00:00:00	32020		\N	180331	0	65363002	372328		0
45891	2732	78272	1987-07-23	1987-07-23 00:00:00	1987-08-06	1987-08-06 00:00:00	32020		\N	180929	0	70704007	78272		0
56671	3362	4112343	1979-10-01	1979-10-01 00:00:00	1979-10-08	1979-10-08 00:00:00	32020		\N	222864	0	195662009	4112343		0
46282	2758	4112343	1979-07-18	1979-07-18 00:00:00	1979-07-26	1979-07-26 00:00:00	32020		\N	182390	0	195662009	4112343		0
46396	2764	40481087	2008-09-14	2008-09-14 00:00:00	2008-09-28	2008-09-28 00:00:00	32020		\N	182790	0	444814009	40481087		0
46513	2770	4112343	1951-07-04	1951-07-04 00:00:00	1951-07-17	1951-07-17 00:00:00	32020		\N	183365	0	195662009	4112343		0
46742	2780	40481087	1973-03-02	1973-03-02 00:00:00	1973-03-09	1973-03-09 00:00:00	32020		\N	184234	0	444814009	40481087		0
46898	2790	4132546	1959-12-15	1959-12-15 00:00:00	\N	\N	32020		\N	184870	0	275272006	4166590		0
47119	2802	260139	1971-05-16	1971-05-16 00:00:00	1971-05-23	1971-05-23 00:00:00	32020		\N	185741	0	10509002	260139		0
47279	2812	260139	2012-11-24	2012-11-24 00:00:00	2012-12-08	2012-12-08 00:00:00	32020		\N	186304	0	10509002	260139		0
47418	2821	378419	2001-11-13	2001-11-13 00:00:00	\N	\N	32020		\N	186944	0	26929004	378419		0
47580	2829	4112343	1979-05-17	1979-05-17 00:00:00	1979-05-30	1979-05-30 00:00:00	32020		\N	187663	0	195662009	4112343		0
47672	2833	80180	1977-05-21	1977-05-21 00:00:00	\N	\N	32020		\N	188074	0	396275006	80180		0
47866	2843	81151	2001-07-06	2001-07-06 00:00:00	2001-08-03	2001-08-03 00:00:00	32020		\N	188742	0	44465007	81151		0
48131	2857	78272	1989-07-27	1989-07-27 00:00:00	1989-08-17	1989-08-17 00:00:00	32020		\N	189700	0	70704007	78272		0
48168	2858	80809	1988-03-02	1988-03-02 00:00:00	\N	\N	32020		\N	189801	0	69896004	80809		0
48325	2863	81151	1972-02-19	1972-02-19 00:00:00	1972-03-11	1972-03-11 00:00:00	32020		\N	190389	0	44465007	81151		0
59131	3508	260139	1961-11-04	1961-11-04 00:00:00	1961-11-11	1961-11-11 00:00:00	32020		\N	232632	0	10509002	260139		0
59278	3516	40481087	2015-11-29	2015-11-29 00:00:00	2015-12-20	2015-12-20 00:00:00	32020		\N	233314	0	444814009	40481087		0
48881	2894	28060	1966-08-01	1966-08-01 00:00:00	1966-08-11	1966-08-11 00:00:00	32020		\N	192636	0	43878008	28060		0
49124	2906	4278672	1934-08-25	1934-08-25 00:00:00	1934-10-24	1934-10-24 00:00:00	32020		\N	193718	0	65966004	4278672		0
59767	3541	40481087	1979-10-28	1979-10-28 00:00:00	1979-11-18	1979-11-18 00:00:00	32020		\N	235211	0	444814009	40481087		0
49456	2925	4109685	1963-10-22	1963-10-22 00:00:00	1963-11-04	1963-11-04 00:00:00	32020		\N	195024	0	284551006	4109685		0
49591	2933	40481087	1987-09-20	1987-09-20 00:00:00	1987-10-04	1987-10-04 00:00:00	32020		\N	195631	0	444814009	40481087		0
49772	2944	4294548	2013-07-13	2013-07-13 00:00:00	2013-11-23	2013-11-23 00:00:00	32020		\N	196428	0	75498004	4294548		0
39342	2333	4112343	1966-02-24	1966-02-24 00:00:00	1966-03-07	1966-03-07 00:00:00	32020		\N	155203	0	195662009	4112343		0
50080	2959	40481087	2018-11-16	2018-11-16 00:00:00	2018-11-23	2018-11-23 00:00:00	32020		\N	197542	0	444814009	40481087		0
50145	2961	372328	1976-11-27	1976-11-27 00:00:00	1977-09-11	1977-09-11 00:00:00	32020		\N	197729	0	65363002	372328		0
50433	2985	372328	1976-10-16	1976-10-16 00:00:00	1976-11-13	1976-11-13 00:00:00	32020		\N	199213	0	65363002	372328		0
50550	2989	40481087	1974-10-26	1974-10-26 00:00:00	1974-11-02	1974-11-02 00:00:00	32020		\N	199552	0	444814009	40481087		0
50725	3001	4266809	1981-12-26	1981-12-26 00:00:00	\N	\N	32020		\N	200329	0	397881000	4266809		0
50876	3010	4112343	1975-03-04	1975-03-04 00:00:00	1975-03-12	1975-03-12 00:00:00	32020		\N	200780	0	195662009	4112343		0
50980	3017	4112343	2011-10-14	2011-10-14 00:00:00	2011-10-22	2011-10-22 00:00:00	32020		\N	201215	0	195662009	4112343		0
61761	3647	440086	1943-10-20	1943-10-20 00:00:00	1946-02-27	1946-02-27 00:00:00	32020		\N	242668	0	192127007	440086		0
51385	3049	260139	1988-05-22	1988-05-22 00:00:00	1988-06-05	1988-06-05 00:00:00	32020		\N	202854	0	10509002	260139		0
51538	3059	4134304	2008-09-17	2008-09-17 00:00:00	2008-10-17	2008-10-17 00:00:00	32020		\N	203512	0	263102004	4134304		0
51792	3070	40481087	2004-05-02	2004-05-02 00:00:00	2004-05-16	2004-05-16 00:00:00	32020		\N	204388	0	444814009	40481087		0
51903	3077	40481087	1953-06-27	1953-06-27 00:00:00	1953-07-04	1953-07-04 00:00:00	32020		\N	204773	0	444814009	40481087		0
52044	3082	4134304	1998-03-28	1998-03-28 00:00:00	1998-04-27	1998-04-27 00:00:00	32020		\N	205229	0	263102004	4134304		0
52230	3092	321042	1995-09-20	1995-09-20 00:00:00	\N	\N	32020		\N	205906	0	410429000	321042		0
52323	3098	192671	1996-02-18	1996-02-18 00:00:00	\N	\N	32020		\N	206163	0	K92.2	35208414		0
63152	3730	4116491	2005-05-04	2005-05-04 00:00:00	2005-06-05	2005-06-05 00:00:00	32020		\N	247848	0	301011002	4116491		0
63266	3736	28060	1964-06-09	1964-06-09 00:00:00	1964-06-17	1964-06-17 00:00:00	32020		\N	248312	0	43878008	28060		0
63417	3745	4084167	1935-05-19	1935-05-19 00:00:00	1935-05-19	1935-05-19 00:00:00	32020		\N	248876	0	241929008	4084167		0
63608	3756	260139	1946-02-03	1946-02-03 00:00:00	1946-02-10	1946-02-10 00:00:00	32020		\N	249639	0	10509002	260139		0
42612	2540	80180	1975-01-02	1975-01-02 00:00:00	\N	\N	32020		\N	167913	0	396275006	80180		0
53305	3158	4112343	1949-12-24	1949-12-24 00:00:00	1949-12-31	1949-12-31 00:00:00	32020		\N	209993	0	195662009	4112343		0
42978	2559	4112343	1982-08-12	1982-08-12 00:00:00	1982-08-24	1982-08-24 00:00:00	32020		\N	169524	0	195662009	4112343		0
43103	2566	40481087	1995-01-31	1995-01-31 00:00:00	1995-02-21	1995-02-21 00:00:00	32020		\N	169997	0	444814009	40481087		0
43197	2572	4112343	1979-08-05	1979-08-05 00:00:00	1979-08-14	1979-08-14 00:00:00	32020		\N	170388	0	195662009	4112343		0
43477	2590	40481087	1965-01-24	1965-01-24 00:00:00	1965-01-31	1965-01-31 00:00:00	32020		\N	171416	0	444814009	40481087		0
43517	2591	40481087	1956-03-14	1956-03-14 00:00:00	1956-03-28	1956-03-28 00:00:00	32020		\N	171510	0	444814009	40481087		0
43738	2604	81151	1986-05-21	1986-05-21 00:00:00	1986-06-18	1986-06-18 00:00:00	32020		\N	172313	0	44465007	81151		0
43891	2613	440448	2003-05-03	2003-05-03 00:00:00	\N	\N	32020		\N	172818	0	74400008	440448		0
44095	2622	4112343	1990-01-13	1990-01-13 00:00:00	1990-01-22	1990-01-22 00:00:00	32020		\N	173477	0	195662009	4112343		0
44247	2631	192671	1993-01-08	1993-01-08 00:00:00	\N	\N	32020		\N	174030	0	K92.2	35208414		0
44483	2646	321042	2007-12-14	2007-12-14 00:00:00	\N	\N	32020		\N	175085	0	410429000	321042		0
55130	3263	81893	1982-12-09	1982-12-09 00:00:00	\N	\N	32020		\N	216934	0	64766004	81893		0
44760	2663	260139	1965-07-23	1965-07-23 00:00:00	1965-07-30	1965-07-30 00:00:00	32020		\N	176475	0	10509002	260139		0
44929	2674	4218389	2006-12-29	2006-12-29 00:00:00	2007-01-26	2007-01-26 00:00:00	32020		\N	177229	0	39848009	4218389		0
45140	2685	372328	1943-01-25	1943-01-25 00:00:00	1943-03-04	1943-03-04 00:00:00	32020		\N	177911	0	65363002	372328		0
45171	2686	40481087	2005-05-01	2005-05-01 00:00:00	2005-05-08	2005-05-08 00:00:00	32020		\N	178032	0	444814009	40481087		0
55952	3313	372328	1956-03-16	1956-03-16 00:00:00	1956-03-30	1956-03-30 00:00:00	32020		\N	219989	0	65363002	372328		0
45589	2709	40481087	1958-03-27	1958-03-27 00:00:00	1958-04-10	1958-04-10 00:00:00	32020		\N	179487	0	444814009	40481087		0
45767	2721	80180	2010-07-23	2010-07-23 00:00:00	\N	\N	32020		\N	180322	0	396275006	80180		0
45892	2732	40481087	1975-03-14	1975-03-14 00:00:00	1975-04-04	1975-04-04 00:00:00	32020		\N	180911	0	444814009	40481087		0
56672	3362	40481087	2001-06-01	2001-06-01 00:00:00	2001-06-08	2001-06-08 00:00:00	32020		\N	222884	0	444814009	40481087		0
46283	2758	372328	1942-01-02	1942-01-02 00:00:00	1942-02-06	1942-02-06 00:00:00	32020		\N	182408	0	65363002	372328		0
46397	2764	372328	1977-12-01	1977-12-01 00:00:00	1978-04-21	1978-04-21 00:00:00	32020		\N	182784	0	65363002	372328		0
46514	2770	4112343	1951-05-22	1951-05-22 00:00:00	1951-06-02	1951-06-02 00:00:00	32020		\N	183230	0	195662009	4112343		0
46743	2781	260139	1985-05-02	1985-05-02 00:00:00	1985-05-09	1985-05-09 00:00:00	32020		\N	184291	0	10509002	260139		0
46899	2790	260139	1986-01-28	1986-01-28 00:00:00	1986-02-04	1986-02-04 00:00:00	32020		\N	184876	0	10509002	260139		0
47120	2802	4112343	1957-10-05	1957-10-05 00:00:00	1957-10-14	1957-10-14 00:00:00	32020		\N	185738	0	195662009	4112343		0
47280	2813	4112343	1944-09-17	1944-09-17 00:00:00	1944-09-30	1944-09-30 00:00:00	32020		\N	186407	0	195662009	4112343		0
47419	2821	4283893	1927-09-11	1927-09-11 00:00:00	1927-11-13	1927-11-13 00:00:00	32020		\N	186919	0	36971009	4283893		0
47581	2829	4278672	1978-02-09	1978-02-09 00:00:00	1978-04-10	1978-04-10 00:00:00	32020		\N	187670	0	65966004	4278672		0
47673	2833	134438	1968-10-12	1968-10-12 00:00:00	1970-06-04	1970-06-04 00:00:00	32020		\N	188020	0	40275004	134438		0
47867	2843	40481087	2015-11-17	2015-11-17 00:00:00	2015-12-01	2015-12-01 00:00:00	32020		\N	188765	0	444814009	40481087		0
48132	2857	40481087	1980-11-26	1980-11-26 00:00:00	1980-12-10	1980-12-10 00:00:00	32020		\N	189685	0	444814009	40481087		0
48169	2858	257012	1929-02-22	1929-02-22 00:00:00	\N	\N	32020		\N	189777	0	40055000	257012		0
48326	2863	4112343	1969-08-27	1969-08-27 00:00:00	1969-09-04	1969-09-04 00:00:00	32020		\N	190426	0	195662009	4112343		0
59132	3508	260139	1996-03-21	1996-03-21 00:00:00	1996-03-28	1996-03-28 00:00:00	32020		\N	232625	0	10509002	260139		0
59279	3516	260139	1954-04-20	1954-04-20 00:00:00	1954-05-04	1954-05-04 00:00:00	32020		\N	233331	0	10509002	260139		0
48882	2894	4112343	1974-06-15	1974-06-15 00:00:00	1974-06-28	1974-06-28 00:00:00	32020		\N	192648	0	195662009	4112343		0
49125	2906	40481087	1951-07-27	1951-07-27 00:00:00	1951-08-10	1951-08-10 00:00:00	32020		\N	193615	0	444814009	40481087		0
59768	3541	4152936	1978-12-07	1978-12-07 00:00:00	1978-12-21	1978-12-21 00:00:00	32020		\N	235214	0	283385000	4152936		0
49457	2925	28060	1973-12-09	1973-12-09 00:00:00	1973-12-18	1973-12-18 00:00:00	32020		\N	194996	0	43878008	28060		0
49592	2933	40481087	2017-08-23	2017-08-23 00:00:00	2017-08-30	2017-08-30 00:00:00	32020		\N	195596	0	444814009	40481087		0
49773	2944	260139	1998-03-08	1998-03-08 00:00:00	1998-03-15	1998-03-15 00:00:00	32020		\N	196405	0	10509002	260139		0
49801	2945	260139	1981-06-25	1981-06-25 00:00:00	1981-07-09	1981-07-09 00:00:00	32020		\N	196541	0	10509002	260139		0
50081	2959	440086	1978-12-20	1978-12-20 00:00:00	1980-12-17	1980-12-17 00:00:00	32020		\N	197472	0	192127007	440086		0
50146	2961	260139	2005-12-28	2005-12-28 00:00:00	2006-01-04	2006-01-04 00:00:00	32020		\N	197706	0	10509002	260139		0
50434	2985	4134304	1990-10-09	1990-10-09 00:00:00	1991-01-07	1991-01-07 00:00:00	32020		\N	199189	0	263102004	4134304		0
50551	2989	260139	1972-03-14	1972-03-14 00:00:00	1972-03-28	1972-03-28 00:00:00	32020		\N	199575	0	10509002	260139		0
50726	3001	80180	1981-12-26	1981-12-26 00:00:00	\N	\N	32020		\N	200329	0	396275006	80180		0
50877	3010	40481087	2005-11-07	2005-11-07 00:00:00	2005-11-14	2005-11-14 00:00:00	32020		\N	200734	0	444814009	40481087		0
50981	3017	40481087	2004-03-16	2004-03-16 00:00:00	2004-04-06	2004-04-06 00:00:00	32020		\N	201277	0	444814009	40481087		0
61762	3647	372328	1956-05-09	1956-05-09 00:00:00	1956-06-13	1956-06-13 00:00:00	32020		\N	242605	0	65363002	372328		0
51386	3049	4112343	2014-10-10	2014-10-10 00:00:00	2014-10-23	2014-10-23 00:00:00	32020		\N	202851	0	195662009	4112343		0
51539	3059	4112343	1987-12-15	1987-12-15 00:00:00	1987-12-25	1987-12-25 00:00:00	32020		\N	203503	0	195662009	4112343		0
62251	3676	260139	1979-10-23	1979-10-23 00:00:00	1979-10-30	1979-10-30 00:00:00	32020		\N	244497	0	10509002	260139		0
51904	3077	4109685	1972-03-10	1972-03-10 00:00:00	1972-03-31	1972-03-31 00:00:00	32020		\N	204719	0	284551006	4109685		0
52046	3082	321042	1988-05-04	1988-05-04 00:00:00	\N	\N	32020		\N	205228	0	410429000	321042		0
52232	3092	4112343	2017-07-08	2017-07-08 00:00:00	2017-07-19	2017-07-19 00:00:00	32020		\N	205843	0	195662009	4112343		0
52324	3098	4112343	1987-09-21	1987-09-21 00:00:00	1987-09-29	1987-09-29 00:00:00	32020		\N	206145	0	195662009	4112343		0
63153	3730	4112343	1983-01-26	1983-01-26 00:00:00	1983-02-03	1983-02-03 00:00:00	32020		\N	247845	0	195662009	4112343		0
63267	3736	4112343	1954-09-20	1954-09-20 00:00:00	1954-10-01	1954-10-01 00:00:00	32020		\N	248271	0	195662009	4112343		0
63418	3745	4112343	1941-07-30	1941-07-30 00:00:00	1941-08-11	1941-08-11 00:00:00	32020		\N	248954	0	195662009	4112343		0
63609	3756	80180	1976-06-25	1976-06-25 00:00:00	\N	\N	32020		\N	249633	0	396275006	80180		0
42613	2540	4283893	1986-12-03	1986-12-03 00:00:00	1987-02-25	1987-02-25 00:00:00	32020		\N	167939	0	36971009	4283893		0
53306	3158	260139	1979-02-12	1979-02-12 00:00:00	1979-02-26	1979-02-26 00:00:00	32020		\N	209916	0	10509002	260139		0
42979	2559	4027663	1983-02-09	1983-02-09 00:00:00	\N	\N	32020		\N	169524	0	13200003	4027663		0
43104	2566	40481087	1952-03-23	1952-03-23 00:00:00	1952-04-06	1952-04-06 00:00:00	32020		\N	169963	0	444814009	40481087		0
43198	2572	260139	2015-02-04	2015-02-04 00:00:00	2015-02-11	2015-02-11 00:00:00	32020		\N	170377	0	10509002	260139		0
43478	2590	260139	1994-01-03	1994-01-03 00:00:00	1994-01-10	1994-01-10 00:00:00	32020		\N	171418	0	10509002	260139		0
43518	2591	4285898	1974-05-22	1974-05-22 00:00:00	\N	\N	32020		\N	171507	0	68496003	4285898		0
43739	2604	4112343	1986-03-04	1986-03-04 00:00:00	1986-03-11	1986-03-11 00:00:00	32020		\N	172254	0	195662009	4112343		0
43892	2613	40481087	2018-06-25	2018-06-25 00:00:00	2018-07-09	2018-07-09 00:00:00	32020		\N	172808	0	444814009	40481087		0
44096	2622	4112343	1933-05-27	1933-05-27 00:00:00	1933-06-05	1933-06-05 00:00:00	32020		\N	173469	0	195662009	4112343		0
44248	2631	4112343	1962-02-02	1962-02-02 00:00:00	1962-02-13	1962-02-13 00:00:00	32020		\N	174050	0	195662009	4112343		0
44485	2646	4155034	1991-05-14	1991-05-14 00:00:00	1991-05-28	1991-05-28 00:00:00	32020		\N	175084	0	283371005	4155034		0
55131	3263	4310024	1982-04-13	1982-04-13 00:00:00	\N	\N	32020		\N	216934	0	424802006	4310024		0
44761	2663	4112343	1974-10-19	1974-10-19 00:00:00	1974-10-29	1974-10-29 00:00:00	32020		\N	176452	0	195662009	4112343		0
44930	2674	260139	1983-03-01	1983-03-01 00:00:00	1983-03-08	1983-03-08 00:00:00	32020		\N	177225	0	10509002	260139		0
45141	2685	40481087	1989-06-27	1989-06-27 00:00:00	1989-07-11	1989-07-11 00:00:00	32020		\N	177945	0	444814009	40481087		0
45172	2686	40481087	1989-10-29	1989-10-29 00:00:00	1989-11-19	1989-11-19 00:00:00	32020		\N	178050	0	444814009	40481087		0
55953	3313	4156265	2010-11-03	2010-11-03 00:00:00	2010-11-17	2010-11-17 00:00:00	32020		\N	219998	0	370247008	4156265		0
45590	2709	28060	1973-01-01	1973-01-01 00:00:00	1973-01-14	1973-01-14 00:00:00	32020		\N	179462	0	43878008	28060		0
45768	2721	313217	2017-04-22	2017-04-22 00:00:00	\N	\N	32020		\N	180323	0	49436004	313217		0
45893	2732	40481087	2001-07-14	2001-07-14 00:00:00	2001-07-28	2001-07-28 00:00:00	32020		\N	180859	0	444814009	40481087		0
56673	3362	40481087	2013-07-10	2013-07-10 00:00:00	2013-07-17	2013-07-17 00:00:00	32020		\N	222931	0	444814009	40481087		0
46284	2758	4112343	2000-03-08	2000-03-08 00:00:00	2000-03-21	2000-03-21 00:00:00	32020		\N	182404	0	195662009	4112343		0
46398	2764	40481087	2003-02-01	2003-02-01 00:00:00	2003-02-08	2003-02-08 00:00:00	32020		\N	182744	0	444814009	40481087		0
46515	2770	40481087	1934-04-23	1934-04-23 00:00:00	1934-05-14	1934-05-14 00:00:00	32020		\N	183387	0	444814009	40481087		0
46744	2781	28060	1987-07-24	1987-07-24 00:00:00	1987-08-05	1987-08-05 00:00:00	32020		\N	184292	0	43878008	28060		0
46900	2790	4155034	1999-09-19	1999-09-19 00:00:00	1999-10-03	1999-10-03 00:00:00	32020		\N	184874	0	283371005	4155034		0
47121	2802	4112343	1944-04-11	1944-04-11 00:00:00	1944-04-20	1944-04-20 00:00:00	32020		\N	185762	0	195662009	4112343		0
47281	2813	313217	2013-10-18	2013-10-18 00:00:00	\N	\N	32020		\N	186458	0	49436004	313217		0
47420	2821	4112343	1960-08-05	1960-08-05 00:00:00	1960-08-15	1960-08-15 00:00:00	32020		\N	186895	0	195662009	4112343		0
47582	2829	40481087	1996-10-27	1996-10-27 00:00:00	1996-11-17	1996-11-17 00:00:00	32020		\N	187664	0	444814009	40481087		0
47674	2834	4310024	1970-07-15	1970-07-15 00:00:00	\N	\N	32020		\N	188163	0	424802006	4310024		0
47868	2843	4278672	1990-12-31	1990-12-31 00:00:00	1991-03-31	1991-03-31 00:00:00	32020		\N	188741	0	65966004	4278672		0
48133	2857	28060	1968-03-22	1968-03-22 00:00:00	1968-03-30	1968-03-30 00:00:00	32020		\N	189709	0	43878008	28060		0
48170	2858	40481087	1943-02-21	1943-02-21 00:00:00	1943-03-07	1943-03-07 00:00:00	32020		\N	189797	0	444814009	40481087		0
48327	2863	4237458	1988-05-16	1988-05-16 00:00:00	1988-08-14	1988-08-14 00:00:00	32020		\N	190390	0	58150001	4237458		0
59133	3508	260139	2013-03-10	2013-03-10 00:00:00	2013-03-17	2013-03-17 00:00:00	32020		\N	232627	0	10509002	260139		0
59280	3516	40481087	2005-09-27	2005-09-27 00:00:00	2005-10-04	2005-10-04 00:00:00	32020		\N	233393	0	444814009	40481087		0
48883	2894	378001	1934-07-27	1934-07-27 00:00:00	1934-09-25	1934-09-25 00:00:00	32020		\N	192597	0	62106007	378001		0
49126	2906	80502	2014-07-12	2014-07-12 00:00:00	\N	\N	32020		\N	193623	0	64859006	80502		0
59769	3541	4146173	2015-09-11	2015-09-11 00:00:00	2015-10-11	2015-10-11 00:00:00	32020		\N	235222	0	307731004	4146173		0
49458	2925	40481087	2011-06-22	2011-06-22 00:00:00	2011-07-13	2011-07-13 00:00:00	32020		\N	195101	0	444814009	40481087		0
49593	2933	4112343	1978-07-08	1978-07-08 00:00:00	1978-07-16	1978-07-16 00:00:00	32020		\N	195629	0	195662009	4112343		0
49774	2944	81151	1991-07-02	1991-07-02 00:00:00	1991-08-06	1991-08-06 00:00:00	32020		\N	196396	0	44465007	81151		0
49802	2945	40481087	1964-06-13	1964-06-13 00:00:00	1964-07-04	1964-07-04 00:00:00	32020		\N	196538	0	444814009	40481087		0
50082	2959	4084167	1972-05-15	1972-05-15 00:00:00	1972-05-15	1972-05-15 00:00:00	32020		\N	197601	0	241929008	4084167		0
50147	2961	4066995	1999-05-02	1999-05-02 00:00:00	1999-06-02	1999-06-02 00:00:00	32020		\N	197767	0	1734006	4066995		0
50435	2985	40481087	2019-05-01	2019-05-01 00:00:00	2019-05-08	2019-05-08 00:00:00	32020		\N	199220	0	444814009	40481087		0
50552	2989	40481087	1993-01-16	1993-01-16 00:00:00	1993-01-23	1993-01-23 00:00:00	32020		\N	199554	0	444814009	40481087		0
50727	3001	4285898	1981-01-30	1981-01-30 00:00:00	\N	\N	32020		\N	200329	0	68496003	4285898		0
50878	3010	40481087	1989-03-30	1989-03-30 00:00:00	1989-04-13	1989-04-13 00:00:00	32020		\N	200782	0	444814009	40481087		0
50982	3017	257012	1974-01-05	1974-01-05 00:00:00	\N	\N	32020		\N	201274	0	40055000	257012		0
61763	3647	30753	1968-12-07	1968-12-07 00:00:00	\N	\N	32020		\N	242692	0	16761005	30753		0
51387	3049	4218389	2011-07-24	2011-07-24 00:00:00	2011-08-21	2011-08-21 00:00:00	32020		\N	202877	0	39848009	4218389		0
51540	3059	4156265	2013-05-15	2013-05-15 00:00:00	2013-05-29	2013-05-29 00:00:00	32020		\N	203514	0	370247008	4156265		0
62252	3676	4112343	2000-05-25	2000-05-25 00:00:00	2000-06-05	2000-06-05 00:00:00	32020		\N	244499	0	195662009	4112343		0
51905	3077	40481087	2018-09-13	2018-09-13 00:00:00	2018-09-20	2018-09-20 00:00:00	32020		\N	204740	0	444814009	40481087		0
52047	3082	4112343	1977-08-04	1977-08-04 00:00:00	1977-08-15	1977-08-15 00:00:00	32020		\N	205179	0	195662009	4112343		0
52233	3092	260139	1965-08-05	1965-08-05 00:00:00	1965-08-12	1965-08-12 00:00:00	32020		\N	205882	0	10509002	260139		0
52325	3098	40481087	1988-06-09	1988-06-09 00:00:00	1988-06-30	1988-06-30 00:00:00	32020		\N	206197	0	444814009	40481087		0
63154	3730	4116491	2002-03-20	2002-03-20 00:00:00	2002-05-05	2002-05-05 00:00:00	32020		\N	247847	0	301011002	4116491		0
63268	3736	40481087	1966-10-11	1966-10-11 00:00:00	1966-10-18	1966-10-18 00:00:00	32020		\N	248346	0	444814009	40481087		0
63419	3745	40481087	1950-10-29	1950-10-29 00:00:00	1950-11-19	1950-11-19 00:00:00	32020		\N	248948	0	444814009	40481087		0
63610	3756	81151	1964-07-28	1964-07-28 00:00:00	1964-08-25	1964-08-25 00:00:00	32020		\N	249715	0	44465007	81151		0
42614	2540	260139	1991-11-30	1991-11-30 00:00:00	1991-12-07	1991-12-07 00:00:00	32020		\N	167996	0	10509002	260139		0
53307	3158	440086	1963-08-22	1963-08-22 00:00:00	1967-03-30	1967-03-30 00:00:00	32020		\N	210010	0	192127007	440086		0
42980	2559	372328	1958-07-15	1958-07-15 00:00:00	1958-10-25	1958-10-25 00:00:00	32020		\N	169615	0	65363002	372328		0
43105	2566	40481087	1970-09-17	1970-09-17 00:00:00	1970-09-24	1970-09-24 00:00:00	32020		\N	170008	0	444814009	40481087		0
43199	2572	40481087	1995-10-24	1995-10-24 00:00:00	1995-10-31	1995-10-31 00:00:00	32020		\N	170346	0	444814009	40481087		0
43479	2590	40481087	1998-04-26	1998-04-26 00:00:00	1998-05-10	1998-05-10 00:00:00	32020		\N	171419	0	444814009	40481087		0
43519	2591	80180	1974-08-20	1974-08-20 00:00:00	\N	\N	32020		\N	171507	0	396275006	80180		0
43740	2604	260139	2016-11-21	2016-11-21 00:00:00	2016-12-05	2016-12-05 00:00:00	32020		\N	172279	0	10509002	260139		0
43893	2613	80809	2016-04-27	2016-04-27 00:00:00	\N	\N	32020		\N	172751	0	69896004	80809		0
44097	2622	40481087	2011-12-02	2011-12-02 00:00:00	2011-12-23	2011-12-23 00:00:00	32020		\N	173491	0	444814009	40481087		0
44249	2631	372328	1954-09-24	1954-09-24 00:00:00	1954-10-17	1954-10-17 00:00:00	32020		\N	174068	0	65363002	372328		0
44486	2646	80180	2009-07-18	2009-07-18 00:00:00	\N	\N	32020		\N	175080	0	396275006	80180		0
55132	3263	81151	2011-06-03	2011-06-03 00:00:00	2011-06-24	2011-06-24 00:00:00	32020		\N	216904	0	44465007	81151		0
44762	2663	260139	1980-12-20	1980-12-20 00:00:00	1981-01-03	1981-01-03 00:00:00	32020		\N	176477	0	10509002	260139		0
44931	2674	260139	1989-02-03	1989-02-03 00:00:00	1989-02-10	1989-02-10 00:00:00	32020		\N	177226	0	10509002	260139		0
45142	2685	258780	1965-01-28	1965-01-28 00:00:00	\N	\N	32020		\N	177954	0	185086009	258780		0
45173	2686	4218389	2009-12-10	2009-12-10 00:00:00	2010-01-14	2010-01-14 00:00:00	32020		\N	178074	0	39848009	4218389		0
55954	3313	40481087	2018-11-26	2018-11-26 00:00:00	2018-12-17	2018-12-17 00:00:00	32020		\N	219974	0	444814009	40481087		0
45591	2709	40481087	1975-04-04	1975-04-04 00:00:00	1975-04-25	1975-04-25 00:00:00	32020		\N	179464	0	444814009	40481087		0
45769	2721	40481087	1973-01-19	1973-01-19 00:00:00	1973-02-02	1973-02-02 00:00:00	32020		\N	180308	0	444814009	40481087		0
45894	2732	4294548	1978-06-26	1978-06-26 00:00:00	1978-07-17	1978-07-17 00:00:00	32020		\N	180891	0	75498004	4294548		0
56674	3362	257012	1990-01-19	1990-01-19 00:00:00	\N	\N	32020		\N	222930	0	40055000	257012		0
46285	2758	4027663	1972-02-22	1972-02-22 00:00:00	\N	\N	32020		\N	182422	0	13200003	4027663		0
46399	2764	4027663	2003-08-17	2003-08-17 00:00:00	\N	\N	32020		\N	182744	0	13200003	4027663		0
46516	2770	4084167	1948-02-04	1948-02-04 00:00:00	1948-02-04	1948-02-04 00:00:00	32020		\N	183303	0	241929008	4084167		0
46745	2781	40481087	1988-10-10	1988-10-10 00:00:00	1988-10-17	1988-10-17 00:00:00	32020		\N	184296	0	444814009	40481087		0
46901	2790	40481087	2003-10-22	2003-10-22 00:00:00	2003-11-05	2003-11-05 00:00:00	32020		\N	184900	0	444814009	40481087		0
47122	2802	4112343	1963-09-15	1963-09-15 00:00:00	1963-09-28	1963-09-28 00:00:00	32020		\N	185764	0	195662009	4112343		0
47282	2813	372328	1961-09-26	1961-09-26 00:00:00	1962-10-05	1962-10-05 00:00:00	32020		\N	186370	0	65363002	372328		0
47421	2821	260139	1960-12-12	1960-12-12 00:00:00	1960-12-21	1960-12-21 00:00:00	32020		\N	186895	0	10509002	260139		0
47583	2829	40481087	1961-01-02	1961-01-02 00:00:00	1961-01-16	1961-01-16 00:00:00	32020		\N	187662	0	444814009	40481087		0
47675	2834	4285898	1971-05-11	1971-05-11 00:00:00	\N	\N	32020		\N	188163	0	68496003	4285898		0
47869	2843	4112343	2008-10-11	2008-10-11 00:00:00	2008-10-24	2008-10-24 00:00:00	32020		\N	188764	0	195662009	4112343		0
48134	2857	40481087	2014-10-10	2014-10-10 00:00:00	2014-10-24	2014-10-24 00:00:00	32020		\N	189724	0	444814009	40481087		0
48171	2858	4035415	1936-02-04	1936-02-04 00:00:00	1936-03-05	1936-03-05 00:00:00	32020		\N	189899	0	239720000	4035415		0
48328	2863	40481087	2010-11-25	2010-11-25 00:00:00	2010-12-16	2010-12-16 00:00:00	32020		\N	190374	0	444814009	40481087		0
59134	3508	260139	2010-12-25	2010-12-25 00:00:00	2011-01-08	2011-01-08 00:00:00	32020		\N	232626	0	10509002	260139		0
59281	3516	40481087	1979-12-21	1979-12-21 00:00:00	1980-01-11	1980-01-11 00:00:00	32020		\N	233334	0	444814009	40481087		0
48884	2894	40481087	1942-05-23	1942-05-23 00:00:00	1942-06-13	1942-06-13 00:00:00	32020		\N	192634	0	444814009	40481087		0
49127	2906	195588	1982-05-20	1982-05-20 00:00:00	1982-06-20	1982-06-20 00:00:00	32020		\N	193739	0	38822007	195588		0
59770	3541	40481087	1995-05-04	1995-05-04 00:00:00	1995-05-11	1995-05-11 00:00:00	32020		\N	235172	0	444814009	40481087		0
49459	2925	40481087	1979-03-10	1979-03-10 00:00:00	1979-03-17	1979-03-17 00:00:00	32020		\N	195087	0	444814009	40481087		0
49594	2933	4112343	1958-01-09	1958-01-09 00:00:00	1958-01-22	1958-01-22 00:00:00	32020		\N	195624	0	195662009	4112343		0
49775	2944	4027663	1987-01-24	1987-01-24 00:00:00	\N	\N	32020		\N	196445	0	13200003	4027663		0
49803	2945	28060	1945-10-19	1945-10-19 00:00:00	1945-11-01	1945-11-01 00:00:00	32020		\N	196520	0	43878008	28060		0
50083	2959	4112343	1985-11-04	1985-11-04 00:00:00	1985-11-12	1985-11-12 00:00:00	32020		\N	197483	0	195662009	4112343		0
50148	2961	44782520	1999-05-02	1999-05-02 00:00:00	\N	\N	32020		\N	197767	0	698754002	44782520		0
50436	2985	372328	1967-06-21	1967-06-21 00:00:00	1967-09-23	1967-09-23 00:00:00	32020		\N	199221	0	65363002	372328		0
50553	2989	40481087	2014-02-09	2014-02-09 00:00:00	2014-02-16	2014-02-16 00:00:00	32020		\N	199577	0	444814009	40481087		0
50728	3001	40481087	2012-12-30	2012-12-30 00:00:00	2013-01-06	2013-01-06 00:00:00	32020		\N	200287	0	444814009	40481087		0
50879	3010	40481087	1982-03-10	1982-03-10 00:00:00	1982-03-31	1982-03-31 00:00:00	32020		\N	200770	0	444814009	40481087		0
50983	3017	4283893	1974-06-22	1974-06-22 00:00:00	1974-07-20	1974-07-20 00:00:00	32020		\N	201212	0	36971009	4283893		0
61764	3647	80180	1970-01-01	1970-01-01 00:00:00	\N	\N	32020		\N	242692	0	396275006	80180		0
51388	3049	40481087	1981-12-01	1981-12-01 00:00:00	1981-12-15	1981-12-15 00:00:00	32020		\N	202846	0	444814009	40481087		0
51541	3059	440448	1990-04-15	1990-04-15 00:00:00	\N	\N	32020		\N	203511	0	74400008	440448		0
62253	3676	40481087	1975-12-24	1975-12-24 00:00:00	1976-01-14	1976-01-14 00:00:00	32020		\N	244545	0	444814009	40481087		0
51906	3077	4112343	2016-06-14	2016-06-14 00:00:00	2016-06-24	2016-06-24 00:00:00	32020		\N	204751	0	195662009	4112343		0
52048	3082	4109685	1970-10-07	1970-10-07 00:00:00	1970-10-21	1970-10-21 00:00:00	32020		\N	205225	0	284551006	4109685		0
52234	3092	81151	2007-06-08	2007-06-08 00:00:00	2007-06-22	2007-06-22 00:00:00	32020		\N	205907	0	44465007	81151		0
52326	3098	40481087	1982-12-24	1982-12-24 00:00:00	1983-01-07	1983-01-07 00:00:00	32020		\N	206144	0	444814009	40481087		0
63155	3730	4218389	2019-03-31	2019-03-31 00:00:00	2019-04-21	2019-04-21 00:00:00	32020		\N	247810	0	39848009	4218389		0
63269	3736	40481087	1952-01-05	1952-01-05 00:00:00	1952-01-26	1952-01-26 00:00:00	32020		\N	248254	0	444814009	40481087		0
63420	3746	4112343	1969-06-11	1969-06-11 00:00:00	1969-06-21	1969-06-21 00:00:00	32020		\N	248984	0	195662009	4112343		0
63611	3756	81151	1988-07-20	1988-07-20 00:00:00	1988-08-10	1988-08-10 00:00:00	32020		\N	249663	0	44465007	81151		0
42615	2541	40481087	1993-07-27	1993-07-27 00:00:00	1993-08-03	1993-08-03 00:00:00	32020		\N	168032	0	444814009	40481087		0
53308	3158	4112343	1994-11-24	1994-11-24 00:00:00	1994-12-07	1994-12-07 00:00:00	32020		\N	209918	0	195662009	4112343		0
42981	2559	40481087	2003-09-17	2003-09-17 00:00:00	2003-10-08	2003-10-08 00:00:00	32020		\N	169614	0	444814009	40481087		0
43106	2566	40481087	2015-08-02	2015-08-02 00:00:00	2015-08-23	2015-08-23 00:00:00	32020		\N	170049	0	444814009	40481087		0
43200	2572	40481087	1986-01-31	1986-01-31 00:00:00	1986-02-07	1986-02-07 00:00:00	32020		\N	170389	0	444814009	40481087		0
43480	2590	30753	2001-06-28	2001-06-28 00:00:00	\N	\N	32020		\N	171360	0	16761005	30753		0
43520	2591	4266809	1974-08-20	1974-08-20 00:00:00	\N	\N	32020		\N	171507	0	397881000	4266809		0
43741	2604	40481087	2011-01-26	2011-01-26 00:00:00	2011-02-02	2011-02-02 00:00:00	32020		\N	172262	0	444814009	40481087		0
43894	2613	28060	1960-09-17	1960-09-17 00:00:00	1960-09-24	1960-09-24 00:00:00	32020		\N	172752	0	43878008	28060		0
44098	2622	28060	1942-12-17	1942-12-17 00:00:00	1942-12-27	1942-12-27 00:00:00	32020		\N	173488	0	43878008	28060		0
44250	2631	4043241	2012-09-30	2012-09-30 00:00:00	\N	\N	32020		\N	174036	0	230265002	4043241		0
44487	2646	260139	2008-11-25	2008-11-25 00:00:00	2008-12-02	2008-12-02 00:00:00	32020		\N	175075	0	10509002	260139		0
55133	3263	40481087	2005-08-07	2005-08-07 00:00:00	2005-08-28	2005-08-28 00:00:00	32020		\N	216942	0	444814009	40481087		0
44763	2663	40481087	2015-09-22	2015-09-22 00:00:00	2015-10-06	2015-10-06 00:00:00	32020		\N	176447	0	444814009	40481087		0
44932	2674	28060	1973-02-14	1973-02-14 00:00:00	1973-02-25	1973-02-25 00:00:00	32020		\N	177211	0	43878008	28060		0
45143	2685	260139	1943-02-25	1943-02-25 00:00:00	1943-03-04	1943-03-04 00:00:00	32020		\N	177923	0	10509002	260139		0
45174	2686	40481087	1999-05-21	1999-05-21 00:00:00	1999-05-28	1999-05-28 00:00:00	32020		\N	178007	0	444814009	40481087		0
55955	3313	260139	1978-03-31	1978-03-31 00:00:00	1978-04-07	1978-04-07 00:00:00	32020		\N	220035	0	10509002	260139		0
45592	2709	4112343	2008-01-31	2008-01-31 00:00:00	2008-02-12	2008-02-12 00:00:00	32020		\N	179494	0	195662009	4112343		0
45770	2721	40481087	1999-02-07	1999-02-07 00:00:00	1999-02-14	1999-02-14 00:00:00	32020		\N	180309	0	444814009	40481087		0
45895	2732	78272	1978-12-18	1978-12-18 00:00:00	1979-01-08	1979-01-08 00:00:00	32020		\N	180927	0	70704007	78272		0
56675	3362	40481087	1973-09-10	1973-09-10 00:00:00	1973-10-01	1973-10-01 00:00:00	32020		\N	222897	0	444814009	40481087		0
46286	2758	4112343	1975-08-19	1975-08-19 00:00:00	1975-08-27	1975-08-27 00:00:00	32020		\N	182488	0	195662009	4112343		0
46400	2764	40481087	1994-04-26	1994-04-26 00:00:00	1994-05-10	1994-05-10 00:00:00	32020		\N	182782	0	444814009	40481087		0
46517	2770	260139	1961-10-09	1961-10-09 00:00:00	1961-10-23	1961-10-23 00:00:00	32020		\N	183389	0	10509002	260139		0
46746	2781	40481087	2014-09-19	2014-09-19 00:00:00	2014-10-10	2014-10-10 00:00:00	32020		\N	184316	0	444814009	40481087		0
46902	2790	4112343	1958-03-08	1958-03-08 00:00:00	1958-03-17	1958-03-17 00:00:00	32020		\N	184867	0	195662009	4112343		0
47123	2802	4329847	1997-12-13	1997-12-13 00:00:00	\N	\N	32020		\N	185715	0	22298006	4329847		0
47283	2813	40481087	1939-10-11	1939-10-11 00:00:00	1939-10-25	1939-10-25 00:00:00	32020		\N	186430	0	444814009	40481087		0
47422	2821	40481087	1993-06-09	1993-06-09 00:00:00	1993-06-23	1993-06-23 00:00:00	32020		\N	186865	0	444814009	40481087		0
47584	2829	4112343	1966-05-06	1966-05-06 00:00:00	1966-05-13	1966-05-13 00:00:00	32020		\N	187658	0	195662009	4112343		0
47676	2834	80180	1972-01-06	1972-01-06 00:00:00	\N	\N	32020		\N	188163	0	396275006	80180		0
47870	2843	40481087	1975-08-13	1975-08-13 00:00:00	1975-08-27	1975-08-27 00:00:00	32020		\N	188760	0	444814009	40481087		0
48135	2857	4113008	1967-08-24	1967-08-24 00:00:00	1967-09-07	1967-09-07 00:00:00	32020		\N	189669	0	284549007	4113008		0
48172	2858	40481087	2004-02-02	2004-02-02 00:00:00	2004-02-23	2004-02-23 00:00:00	32020		\N	189748	0	444814009	40481087		0
48329	2863	40481087	2019-03-09	2019-03-09 00:00:00	2019-03-23	2019-03-23 00:00:00	32020		\N	190375	0	444814009	40481087		0
59135	3508	260139	1971-12-20	1971-12-20 00:00:00	1971-12-27	1971-12-27 00:00:00	32020		\N	232662	0	10509002	260139		0
59282	3516	40481087	2017-10-15	2017-10-15 00:00:00	2017-11-05	2017-11-05 00:00:00	32020		\N	233329	0	444814009	40481087		0
48885	2894	40479422	1923-01-07	1923-01-07 00:00:00	1923-02-13	1923-02-13 00:00:00	32020		\N	192620	0	444448004	40479422		0
49128	2906	260139	1977-03-24	1977-03-24 00:00:00	1977-04-07	1977-04-07 00:00:00	32020		\N	193747	0	10509002	260139		0
59771	3541	40481087	2006-11-14	2006-11-14 00:00:00	2006-11-21	2006-11-21 00:00:00	32020		\N	235173	0	444814009	40481087		0
49460	2925	28060	2011-02-17	2011-02-17 00:00:00	2011-03-02	2011-03-02 00:00:00	32020		\N	195011	0	43878008	28060		0
49595	2933	317576	2011-10-10	2011-10-10 00:00:00	\N	\N	32020		\N	195614	0	53741008	317576		0
49776	2944	40481087	2007-06-26	2007-06-26 00:00:00	2007-07-10	2007-07-10 00:00:00	32020		\N	196423	0	444814009	40481087		0
49804	2945	40481087	1997-08-23	1997-08-23 00:00:00	1997-09-06	1997-09-06 00:00:00	32020		\N	196525	0	444814009	40481087		0
50084	2959	4051466	1973-12-28	1973-12-28 00:00:00	1993-02-23	1993-02-23 00:00:00	32020		\N	197474	0	233678006	4051466		0
50149	2961	4112343	1985-05-14	1985-05-14 00:00:00	1985-05-24	1985-05-24 00:00:00	32020		\N	197709	0	195662009	4112343		0
50437	2985	40481087	1988-04-21	1988-04-21 00:00:00	1988-04-28	1988-04-28 00:00:00	32020		\N	199238	0	444814009	40481087		0
50554	2989	80180	1998-02-27	1998-02-27 00:00:00	\N	\N	32020		\N	199524	0	396275006	80180		0
50729	3001	28060	1995-01-04	1995-01-04 00:00:00	1995-01-15	1995-01-15 00:00:00	32020		\N	200271	0	43878008	28060		0
50880	3010	4112343	1975-11-08	1975-11-08 00:00:00	1975-11-20	1975-11-20 00:00:00	32020		\N	200765	0	195662009	4112343		0
50984	3017	372328	1958-04-13	1958-04-13 00:00:00	1958-07-25	1958-07-25 00:00:00	32020		\N	201258	0	65363002	372328		0
61765	3647	40481087	2014-02-22	2014-02-22 00:00:00	2014-03-08	2014-03-08 00:00:00	32020		\N	242723	0	444814009	40481087		0
51389	3049	260139	1997-09-05	1997-09-05 00:00:00	1997-09-12	1997-09-12 00:00:00	32020		\N	202848	0	10509002	260139		0
51542	3059	4112343	2001-11-13	2001-11-13 00:00:00	2001-11-21	2001-11-21 00:00:00	32020		\N	203474	0	195662009	4112343		0
62254	3676	4283893	1981-02-24	1981-02-24 00:00:00	1981-06-16	1981-06-16 00:00:00	32020		\N	244508	0	36971009	4283893		0
51907	3077	4218389	1963-03-02	1963-03-02 00:00:00	1963-03-30	1963-03-30 00:00:00	32020		\N	204716	0	39848009	4218389		0
52049	3082	4134304	1980-03-02	1980-03-02 00:00:00	1980-05-31	1980-05-31 00:00:00	32020		\N	205227	0	263102004	4134304		0
52235	3092	260139	1982-04-27	1982-04-27 00:00:00	1982-05-04	1982-05-04 00:00:00	32020		\N	205867	0	10509002	260139		0
52327	3098	4112343	1972-02-28	1972-02-28 00:00:00	1972-03-12	1972-03-12 00:00:00	32020		\N	206143	0	195662009	4112343		0
63156	3730	40481087	2004-10-03	2004-10-03 00:00:00	2004-10-10	2004-10-10 00:00:00	32020		\N	247875	0	444814009	40481087		0
63270	3736	260139	1962-06-07	1962-06-07 00:00:00	1962-06-14	1962-06-14 00:00:00	32020		\N	248311	0	10509002	260139		0
63421	3746	40481087	1957-04-08	1957-04-08 00:00:00	1957-04-15	1957-04-15 00:00:00	32020		\N	249039	0	444814009	40481087		0
63612	3756	4112343	2009-08-28	2009-08-28 00:00:00	2009-09-04	2009-09-04 00:00:00	32020		\N	249643	0	195662009	4112343		0
42616	2541	260139	1989-04-28	1989-04-28 00:00:00	1989-05-05	1989-05-05 00:00:00	32020		\N	168052	0	10509002	260139		0
53309	3158	4132546	1956-05-20	1956-05-20 00:00:00	\N	\N	32020		\N	209943	0	275272006	4166590		0
42982	2559	40481087	1986-04-21	1986-04-21 00:00:00	1986-05-05	1986-05-05 00:00:00	32020		\N	169583	0	444814009	40481087		0
43107	2567	40481087	1993-08-25	1993-08-25 00:00:00	1993-09-01	1993-09-01 00:00:00	32020		\N	170097	0	444814009	40481087		0
43201	2572	4155034	1971-05-15	1971-05-15 00:00:00	1971-05-29	1971-05-29 00:00:00	32020		\N	170366	0	283371005	4155034		0
43481	2590	260139	2000-12-06	2000-12-06 00:00:00	2000-12-13	2000-12-13 00:00:00	32020		\N	171360	0	10509002	260139		0
43521	2591	4283893	1996-01-17	1996-01-17 00:00:00	1996-03-20	1996-03-20 00:00:00	32020		\N	171428	0	36971009	4283893		0
43742	2604	40481087	1979-11-20	1979-11-20 00:00:00	1979-12-04	1979-12-04 00:00:00	32020		\N	172276	0	444814009	40481087		0
43895	2613	4112343	1984-06-04	1984-06-04 00:00:00	1984-06-12	1984-06-12 00:00:00	32020		\N	172748	0	195662009	4112343		0
44099	2622	28060	1950-06-04	1950-06-04 00:00:00	1950-06-12	1950-06-12 00:00:00	32020		\N	173473	0	43878008	28060		0
44251	2631	80180	1992-10-19	1992-10-19 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
44488	2646	260139	1986-11-16	1986-11-16 00:00:00	1986-11-23	1986-11-23 00:00:00	32020		\N	175064	0	10509002	260139		0
55134	3263	260139	2004-06-13	2004-06-13 00:00:00	2004-06-20	2004-06-20 00:00:00	32020		\N	216963	0	10509002	260139		0
44764	2663	4027663	1991-08-25	1991-08-25 00:00:00	\N	\N	32020		\N	176445	0	13200003	4027663		0
44933	2674	40481087	1998-04-10	1998-04-10 00:00:00	1998-04-17	1998-04-17 00:00:00	32020		\N	177227	0	444814009	40481087		0
45144	2685	260139	1952-10-13	1952-10-13 00:00:00	1952-10-27	1952-10-27 00:00:00	32020		\N	177944	0	10509002	260139		0
45175	2686	4112343	1956-11-02	1956-11-02 00:00:00	1956-11-12	1956-11-12 00:00:00	32020		\N	178015	0	195662009	4112343		0
55956	3313	28060	1956-07-17	1956-07-17 00:00:00	1956-07-25	1956-07-25 00:00:00	32020		\N	219985	0	43878008	28060		0
45593	2709	4237458	2017-10-06	2017-10-06 00:00:00	2017-12-05	2017-12-05 00:00:00	32020		\N	179451	0	58150001	4237458		0
45771	2721	40481087	2015-12-25	2015-12-25 00:00:00	2016-01-08	2016-01-08 00:00:00	32020		\N	180350	0	444814009	40481087		0
45896	2732	40481087	2003-02-23	2003-02-23 00:00:00	2003-03-16	2003-03-16 00:00:00	32020		\N	180842	0	444814009	40481087		0
56676	3362	40481087	1989-08-18	1989-08-18 00:00:00	1989-09-01	1989-09-01 00:00:00	32020		\N	222929	0	444814009	40481087		0
46287	2758	372328	1950-09-24	1950-09-24 00:00:00	1951-03-16	1951-03-16 00:00:00	32020		\N	182409	0	65363002	372328		0
46401	2764	375671	2013-12-22	2013-12-22 00:00:00	2014-01-21	2014-01-21 00:00:00	32020		\N	182779	0	62564004	375671		0
46518	2770	40481087	1986-04-04	1986-04-04 00:00:00	1986-04-25	1986-04-25 00:00:00	32020		\N	183333	0	444814009	40481087		0
46747	2781	40481087	2013-02-07	2013-02-07 00:00:00	2013-02-21	2013-02-21 00:00:00	32020		\N	184319	0	444814009	40481087		0
46903	2790	40481087	1992-09-27	1992-09-27 00:00:00	1992-10-11	1992-10-11 00:00:00	32020		\N	184899	0	444814009	40481087		0
47125	2802	4134304	1965-01-01	1965-01-01 00:00:00	1965-04-01	1965-04-01 00:00:00	32020		\N	185711	0	263102004	4134304		0
47284	2813	40481087	1946-09-23	1946-09-23 00:00:00	1946-10-14	1946-10-14 00:00:00	32020		\N	186377	0	444814009	40481087		0
47423	2821	40481087	1973-03-01	1973-03-01 00:00:00	1973-03-22	1973-03-22 00:00:00	32020		\N	186863	0	444814009	40481087		0
47585	2829	4112343	1963-03-12	1963-03-12 00:00:00	1963-03-19	1963-03-19 00:00:00	32020		\N	187657	0	195662009	4112343		0
47677	2834	260139	1980-07-03	1980-07-03 00:00:00	1980-07-17	1980-07-17 00:00:00	32020		\N	188187	0	10509002	260139		0
47871	2843	81151	1964-10-04	1964-10-04 00:00:00	1964-10-18	1964-10-18 00:00:00	32020		\N	188739	0	44465007	81151		0
48136	2857	4112343	1992-11-15	1992-11-15 00:00:00	1992-11-22	1992-11-22 00:00:00	32020		\N	189712	0	195662009	4112343		0
48173	2858	4112343	2002-10-26	2002-10-26 00:00:00	2002-11-04	2002-11-04 00:00:00	32020		\N	189956	0	195662009	4112343		0
48330	2863	40481087	2003-09-21	2003-09-21 00:00:00	2003-09-28	2003-09-28 00:00:00	32020		\N	190373	0	444814009	40481087		0
59136	3508	80180	1995-11-09	1995-11-09 00:00:00	\N	\N	32020		\N	232649	0	396275006	80180		0
59283	3516	192671	1978-04-15	1978-04-15 00:00:00	\N	\N	32020		\N	233370	0	K92.2	35208414		0
48886	2894	81151	1993-11-10	1993-11-10 00:00:00	1993-12-01	1993-12-01 00:00:00	32020		\N	192601	0	44465007	81151		0
49129	2906	78272	1982-04-30	1982-04-30 00:00:00	1982-05-14	1982-05-14 00:00:00	32020		\N	193725	0	70704007	78272		0
59772	3541	80180	2010-07-17	2010-07-17 00:00:00	\N	\N	32020		\N	235187	0	396275006	80180		0
49461	2925	4112343	1962-03-01	1962-03-01 00:00:00	1962-03-11	1962-03-11 00:00:00	32020		\N	195089	0	195662009	4112343		0
49607	2935	40481087	2015-06-17	2015-06-17 00:00:00	2015-07-08	2015-07-08 00:00:00	32020		\N	195717	0	444814009	40481087		0
49777	2944	40481087	2002-08-25	2002-08-25 00:00:00	2002-09-15	2002-09-15 00:00:00	32020		\N	196427	0	444814009	40481087		0
49805	2945	40481087	1954-10-27	1954-10-27 00:00:00	1954-11-17	1954-11-17 00:00:00	32020		\N	196513	0	444814009	40481087		0
50085	2959	80180	2009-12-27	2009-12-27 00:00:00	\N	\N	32020		\N	197597	0	396275006	80180		0
50150	2961	4166224	1972-09-26	1972-09-26 00:00:00	\N	\N	32020		\N	197766	0	47693006	4166224		0
50438	2985	40481087	1981-02-07	1981-02-07 00:00:00	1981-02-21	1981-02-21 00:00:00	32020		\N	199229	0	444814009	40481087		0
50555	2989	4285898	1997-04-03	1997-04-03 00:00:00	\N	\N	32020		\N	199524	0	68496003	4285898		0
50730	3001	81151	1958-10-09	1958-10-09 00:00:00	1958-11-13	1958-11-13 00:00:00	32020		\N	200327	0	44465007	81151		0
50881	3010	4237458	1980-10-06	1980-10-06 00:00:00	1980-12-05	1980-12-05 00:00:00	32020		\N	200798	0	58150001	4237458		0
50985	3017	4294548	1977-09-07	1977-09-07 00:00:00	1978-01-25	1978-01-25 00:00:00	32020		\N	201213	0	75498004	4294548		0
61766	3647	4112343	1989-10-13	1989-10-13 00:00:00	1989-10-26	1989-10-26 00:00:00	32020		\N	242719	0	195662009	4112343		0
51390	3049	4329847	1986-12-05	1986-12-05 00:00:00	\N	\N	32020		\N	202874	0	22298006	4329847		0
51543	3059	4283893	1989-10-03	1989-10-03 00:00:00	1989-11-28	1989-11-28 00:00:00	32020		\N	203493	0	36971009	4283893		0
62255	3676	260139	2005-07-07	2005-07-07 00:00:00	2005-07-21	2005-07-21 00:00:00	32020		\N	244551	0	10509002	260139		0
51908	3077	4112343	1973-12-06	1973-12-06 00:00:00	1973-12-17	1973-12-17 00:00:00	32020		\N	204762	0	195662009	4112343		0
52050	3082	40481087	1983-10-14	1983-10-14 00:00:00	1983-11-04	1983-11-04 00:00:00	32020		\N	205182	0	444814009	40481087		0
52236	3092	4027663	1984-07-19	1984-07-19 00:00:00	\N	\N	32020		\N	205858	0	13200003	4027663		0
52328	3098	260139	2016-06-11	2016-06-11 00:00:00	2016-06-18	2016-06-18 00:00:00	32020		\N	206199	0	10509002	260139		0
63157	3730	40481087	1987-04-06	1987-04-06 00:00:00	1987-04-20	1987-04-20 00:00:00	32020		\N	247812	0	444814009	40481087		0
63271	3736	260139	1964-09-13	1964-09-13 00:00:00	1964-09-20	1964-09-20 00:00:00	32020		\N	248313	0	10509002	260139		0
63422	3746	4112343	1956-03-06	1956-03-06 00:00:00	1956-03-17	1956-03-17 00:00:00	32020		\N	249038	0	195662009	4112343		0
63614	3756	4134304	1953-06-16	1953-06-16 00:00:00	1953-08-15	1953-08-15 00:00:00	32020		\N	249711	0	263102004	4134304		0
61913	3655	4329847	2010-12-16	2010-12-16 00:00:00	\N	\N	32020		\N	243260	0	22298006	4329847		0
42617	2541	40481087	1990-01-31	1990-01-31 00:00:00	1990-02-07	1990-02-07 00:00:00	32020		\N	168017	0	444814009	40481087		0
53310	3158	4001336	1956-05-20	1956-05-20 00:00:00	1956-07-19	1956-07-19 00:00:00	32020		\N	209943	0	110030002	4001336		0
42983	2559	260139	1960-12-02	1960-12-02 00:00:00	1960-12-09	1960-12-09 00:00:00	32020		\N	169523	0	10509002	260139		0
43108	2567	4112343	1978-11-09	1978-11-09 00:00:00	1978-11-19	1978-11-19 00:00:00	32020		\N	170077	0	195662009	4112343		0
43202	2572	4109685	2011-10-17	2011-10-17 00:00:00	2011-11-07	2011-11-07 00:00:00	32020		\N	170369	0	284551006	4109685		0
43482	2590	80180	2002-09-21	2002-09-21 00:00:00	\N	\N	32020		\N	171360	0	396275006	80180		0
43522	2591	260139	2017-11-22	2017-11-22 00:00:00	2017-11-29	2017-11-29 00:00:00	32020		\N	171458	0	10509002	260139		0
43743	2604	4113008	2000-07-02	2000-07-02 00:00:00	2000-07-16	2000-07-16 00:00:00	32020		\N	172315	0	284549007	4113008		0
43896	2613	260139	2001-01-27	2001-01-27 00:00:00	2001-02-10	2001-02-10 00:00:00	32020		\N	172750	0	10509002	260139		0
44100	2622	4027663	1963-10-31	1963-10-31 00:00:00	\N	\N	32020		\N	173461	0	13200003	4027663		0
44252	2631	4266809	1992-10-19	1992-10-19 00:00:00	\N	\N	32020		\N	\N	0	397881000	4266809		0
54947	3250	260139	1986-08-15	1986-08-15 00:00:00	1986-08-22	1986-08-22 00:00:00	32020		\N	216077	0	10509002	260139		0
55135	3263	4112343	1999-05-21	1999-05-21 00:00:00	1999-06-01	1999-06-01 00:00:00	32020		\N	216931	0	195662009	4112343		0
44765	2663	40481087	2015-11-14	2015-11-14 00:00:00	2015-12-05	2015-12-05 00:00:00	32020		\N	176454	0	444814009	40481087		0
44934	2674	4112343	2000-02-20	2000-02-20 00:00:00	2000-03-02	2000-03-02 00:00:00	32020		\N	177228	0	195662009	4112343		0
45145	2685	372328	1966-07-01	1966-07-01 00:00:00	1968-01-04	1968-01-04 00:00:00	32020		\N	177967	0	65363002	372328		0
45176	2686	4112343	1962-05-18	1962-05-18 00:00:00	1962-05-27	1962-05-27 00:00:00	32020		\N	177983	0	195662009	4112343		0
55957	3313	4296205	1997-06-23	1997-06-23 00:00:00	1997-07-14	1997-07-14 00:00:00	32020		\N	219997	0	403191005	4296205		0
45594	2709	4278672	1944-11-07	1944-11-07 00:00:00	1944-12-07	1944-12-07 00:00:00	32020		\N	179447	0	65966004	4278672		0
45772	2721	4218389	1989-10-16	1989-10-16 00:00:00	1989-11-20	1989-11-20 00:00:00	32020		\N	180347	0	39848009	4218389		0
45897	2732	4116491	1992-08-01	1992-08-01 00:00:00	1992-09-01	1992-09-01 00:00:00	32020		\N	180934	0	301011002	4116491		0
56677	3362	4283893	1990-01-05	1990-01-05 00:00:00	1990-03-02	1990-03-02 00:00:00	32020		\N	222898	0	36971009	4283893		0
46288	2758	40481087	2006-01-14	2006-01-14 00:00:00	2006-01-28	2006-01-28 00:00:00	32020		\N	182438	0	444814009	40481087		0
46402	2764	439777	2015-08-14	2015-08-14 00:00:00	\N	\N	32020		\N	182791	0	271737000	439777		0
46519	2770	40481087	1992-01-22	1992-01-22 00:00:00	1992-02-05	1992-02-05 00:00:00	32020		\N	183293	0	444814009	40481087		0
46748	2781	4310024	2014-02-13	2014-02-13 00:00:00	\N	\N	32020		\N	184340	0	424802006	4310024		0
46904	2790	40481087	2013-04-22	2013-04-22 00:00:00	2013-04-29	2013-04-29 00:00:00	32020		\N	184887	0	444814009	40481087		0
47126	2802	81151	1951-11-20	1951-11-20 00:00:00	1951-12-11	1951-12-11 00:00:00	32020		\N	185710	0	44465007	81151		0
47285	2813	40481087	1957-04-28	1957-04-28 00:00:00	1957-05-12	1957-05-12 00:00:00	32020		\N	186431	0	444814009	40481087		0
47424	2821	40481087	1920-07-07	1920-07-07 00:00:00	1920-07-14	1920-07-14 00:00:00	32020		\N	186918	0	444814009	40481087		0
47586	2829	140673	2017-08-18	2017-08-18 00:00:00	\N	\N	32020		\N	187647	0	40930008	140673		0
47678	2834	40481087	1945-06-17	1945-06-17 00:00:00	1945-06-24	1945-06-24 00:00:00	32020		\N	188111	0	444814009	40481087		0
47872	2843	378001	1975-12-20	1975-12-20 00:00:00	1976-01-19	1976-01-19 00:00:00	32020		\N	188740	0	62106007	378001		0
48137	2857	4109685	1979-12-02	1979-12-02 00:00:00	1979-12-16	1979-12-16 00:00:00	32020		\N	189670	0	284551006	4109685		0
48174	2858	4112343	1962-11-02	1962-11-02 00:00:00	1962-11-11	1962-11-11 00:00:00	32020		\N	189742	0	195662009	4112343		0
48331	2864	40481087	2014-10-19	2014-10-19 00:00:00	2014-10-26	2014-10-26 00:00:00	32020		\N	190531	0	444814009	40481087		0
59137	3509	40481087	1958-11-24	1958-11-24 00:00:00	1958-12-01	1958-12-01 00:00:00	32020		\N	232781	0	444814009	40481087		0
59284	3516	440448	1950-07-26	1950-07-26 00:00:00	\N	\N	32020		\N	233365	0	74400008	440448		0
48887	2894	4059173	1995-10-22	1995-10-22 00:00:00	1996-01-20	1996-01-20 00:00:00	32020		\N	192602	0	16114001	4059173		0
49130	2906	40481087	1949-06-25	1949-06-25 00:00:00	1949-07-02	1949-07-02 00:00:00	32020		\N	193745	0	444814009	40481087		0
59773	3541	40481087	1968-04-10	1968-04-10 00:00:00	1968-04-24	1968-04-24 00:00:00	32020		\N	235170	0	444814009	40481087		0
49462	2925	40481087	1984-08-15	1984-08-15 00:00:00	1984-09-05	1984-09-05 00:00:00	32020		\N	194997	0	444814009	40481087		0
49608	2935	4237458	1984-12-21	1984-12-21 00:00:00	1985-01-20	1985-01-20 00:00:00	32020		\N	195678	0	58150001	4237458		0
49778	2944	4218389	1976-03-01	1976-03-01 00:00:00	1976-03-22	1976-03-22 00:00:00	32020		\N	196395	0	39848009	4218389		0
49806	2945	40481087	1951-11-20	1951-11-20 00:00:00	1951-12-04	1951-12-04 00:00:00	32020		\N	196543	0	444814009	40481087		0
50086	2959	260139	2018-06-03	2018-06-03 00:00:00	2018-06-17	2018-06-17 00:00:00	32020		\N	197584	0	10509002	260139		0
50151	2961	440448	1972-09-26	1972-09-26 00:00:00	\N	\N	32020		\N	197766	0	74400008	440448		0
50439	2985	260139	2006-05-01	2006-05-01 00:00:00	2006-05-08	2006-05-08 00:00:00	32020		\N	199209	0	10509002	260139		0
50556	2989	4112343	1980-04-05	1980-04-05 00:00:00	1980-04-13	1980-04-13 00:00:00	32020		\N	199544	0	195662009	4112343		0
50731	3001	40481087	2002-12-01	2002-12-01 00:00:00	2002-12-15	2002-12-15 00:00:00	32020		\N	200286	0	444814009	40481087		0
50882	3010	192671	2004-03-09	2004-03-09 00:00:00	\N	\N	32020		\N	200795	0	K92.2	35208414		0
50986	3017	80180	1991-04-30	1991-04-30 00:00:00	\N	\N	32020		\N	201270	0	396275006	80180		0
61793	3650	40481087	1932-07-07	1932-07-07 00:00:00	1932-07-21	1932-07-21 00:00:00	32020		\N	242939	0	444814009	40481087		0
51391	3049	40481087	1993-11-21	1993-11-21 00:00:00	1993-11-28	1993-11-28 00:00:00	32020		\N	202847	0	444814009	40481087		0
51544	3059	372328	1975-03-13	1975-03-13 00:00:00	1975-03-27	1975-03-27 00:00:00	32020		\N	203477	0	65363002	372328		0
62256	3676	40481087	2009-02-13	2009-02-13 00:00:00	2009-02-20	2009-02-20 00:00:00	32020		\N	244535	0	444814009	40481087		0
51909	3077	260139	2007-10-09	2007-10-09 00:00:00	2007-10-23	2007-10-23 00:00:00	32020		\N	204768	0	10509002	260139		0
52051	3082	4112343	1987-02-06	1987-02-06 00:00:00	1987-02-14	1987-02-14 00:00:00	32020		\N	205236	0	195662009	4112343		0
52237	3092	40481087	1988-12-28	1988-12-28 00:00:00	1989-01-04	1989-01-04 00:00:00	32020		\N	205884	0	444814009	40481087		0
52329	3098	260139	1991-07-21	1991-07-21 00:00:00	1991-08-04	1991-08-04 00:00:00	32020		\N	206205	0	10509002	260139		0
63158	3731	28060	1976-09-11	1976-09-11 00:00:00	1976-09-22	1976-09-22 00:00:00	32020		\N	247912	0	43878008	28060		0
63272	3736	40481087	2004-11-04	2004-11-04 00:00:00	2004-11-11	2004-11-11 00:00:00	32020		\N	248275	0	444814009	40481087		0
63423	3746	260139	1999-12-24	1999-12-24 00:00:00	2000-01-07	2000-01-07 00:00:00	32020		\N	249031	0	10509002	260139		0
63615	3756	40481087	1947-07-23	1947-07-23 00:00:00	1947-07-30	1947-07-30 00:00:00	32020		\N	249621	0	444814009	40481087		0
42618	2541	80180	2017-12-07	2017-12-07 00:00:00	\N	\N	32020		\N	168049	0	396275006	80180		0
53311	3158	4112343	1950-08-01	1950-08-01 00:00:00	1950-08-14	1950-08-14 00:00:00	32020		\N	209906	0	195662009	4112343		0
42984	2559	4112343	2004-06-18	2004-06-18 00:00:00	2004-06-30	2004-06-30 00:00:00	32020		\N	169582	0	195662009	4112343		0
43109	2567	40481087	2009-05-17	2009-05-17 00:00:00	2009-05-31	2009-05-31 00:00:00	32020		\N	170083	0	444814009	40481087		0
43203	2572	4112343	1996-04-17	1996-04-17 00:00:00	1996-04-30	1996-04-30 00:00:00	32020		\N	170376	0	195662009	4112343		0
43483	2590	4218389	1981-01-03	1981-01-03 00:00:00	1981-01-24	1981-01-24 00:00:00	32020		\N	171408	0	39848009	4218389		0
43523	2591	40481087	2012-04-23	2012-04-23 00:00:00	2012-05-14	2012-05-14 00:00:00	32020		\N	171429	0	444814009	40481087		0
62077	3666	80180	2000-11-05	2000-11-05 00:00:00	\N	\N	32020		\N	243929	0	396275006	80180		0
43744	2604	4296204	1997-08-19	1997-08-19 00:00:00	1997-09-16	1997-09-16 00:00:00	32020		\N	172314	0	403190006	4296204		0
43897	2613	260139	1957-10-01	1957-10-01 00:00:00	1957-10-15	1957-10-15 00:00:00	32020		\N	172763	0	10509002	260139		0
44101	2622	4237458	1998-10-03	1998-10-03 00:00:00	1998-11-02	1998-11-02 00:00:00	32020		\N	173404	0	58150001	4237458		0
44253	2631	4296205	1960-07-24	1960-07-24 00:00:00	1960-08-21	1960-08-21 00:00:00	32020		\N	174074	0	403191005	4296205		0
54948	3250	4283893	1987-09-22	1987-09-22 00:00:00	1987-10-27	1987-10-27 00:00:00	32020		\N	216052	0	36971009	4283893		0
55136	3263	192671	1985-04-21	1985-04-21 00:00:00	\N	\N	32020		\N	216908	0	K92.2	35208414		0
44766	2663	4283893	2014-05-29	2014-05-29 00:00:00	2014-07-24	2014-07-24 00:00:00	32020		\N	176480	0	36971009	4283893		0
44935	2674	80180	2013-07-01	2013-07-01 00:00:00	\N	\N	32020		\N	177181	0	396275006	80180		0
45146	2685	40481087	1997-02-05	1997-02-05 00:00:00	1997-02-26	1997-02-26 00:00:00	32020		\N	177937	0	444814009	40481087		0
45177	2686	40481087	1985-08-24	1985-08-24 00:00:00	1985-09-14	1985-09-14 00:00:00	32020		\N	178016	0	444814009	40481087		0
55958	3313	4237458	1960-07-23	1960-07-23 00:00:00	1960-08-22	1960-08-22 00:00:00	32020		\N	219995	0	58150001	4237458		0
45595	2709	28060	1953-08-04	1953-08-04 00:00:00	1953-08-13	1953-08-13 00:00:00	32020		\N	179486	0	43878008	28060		0
45773	2721	40481087	1979-11-05	1979-11-05 00:00:00	1979-11-12	1979-11-12 00:00:00	32020		\N	180349	0	444814009	40481087		0
45898	2732	80180	2004-03-21	2004-03-21 00:00:00	\N	\N	32020		\N	180837	0	396275006	80180		0
56678	3362	4112343	2011-08-12	2011-08-12 00:00:00	2011-08-23	2011-08-23 00:00:00	32020		\N	222886	0	195662009	4112343		0
46289	2758	40481087	1989-04-16	1989-04-16 00:00:00	1989-05-07	1989-05-07 00:00:00	32020		\N	182402	0	444814009	40481087		0
46403	2764	378001	1999-07-09	1999-07-09 00:00:00	1999-09-07	1999-09-07 00:00:00	32020		\N	182778	0	62106007	378001		0
46520	2770	4112343	1947-07-30	1947-07-30 00:00:00	1947-08-08	1947-08-08 00:00:00	32020		\N	183311	0	195662009	4112343		0
46749	2781	260139	2014-01-18	2014-01-18 00:00:00	2014-01-25	2014-01-25 00:00:00	32020		\N	184315	0	10509002	260139		0
46905	2790	4059173	2009-04-13	2009-04-13 00:00:00	2009-06-12	2009-06-12 00:00:00	32020		\N	184875	0	16114001	4059173		0
47127	2802	28060	1953-09-01	1953-09-01 00:00:00	1953-09-14	1953-09-14 00:00:00	32020		\N	185705	0	43878008	28060		0
47286	2813	4112343	1954-07-29	1954-07-29 00:00:00	1954-08-07	1954-08-07 00:00:00	32020		\N	186378	0	195662009	4112343		0
47425	2821	4266809	1959-02-12	1959-02-12 00:00:00	\N	\N	32020		\N	186965	0	397881000	4266809		0
47587	2829	40481087	1984-04-20	1984-04-20 00:00:00	1984-04-27	1984-04-27 00:00:00	32020		\N	187636	0	444814009	40481087		0
47679	2834	317576	1948-05-08	1948-05-08 00:00:00	\N	\N	32020		\N	188149	0	53741008	317576		0
47873	2843	260139	1961-06-11	1961-06-11 00:00:00	1961-06-18	1961-06-18 00:00:00	32020		\N	188758	0	10509002	260139		0
48138	2857	28060	1979-01-15	1979-01-15 00:00:00	1979-01-26	1979-01-26 00:00:00	32020		\N	189722	0	43878008	28060		0
48175	2858	4112343	1962-04-23	1962-04-23 00:00:00	1962-05-04	1962-05-04 00:00:00	32020		\N	189741	0	195662009	4112343		0
48332	2864	40481087	1958-01-23	1958-01-23 00:00:00	1958-01-30	1958-01-30 00:00:00	32020		\N	190509	0	444814009	40481087		0
59138	3509	372328	1946-02-08	1946-02-08 00:00:00	1946-12-27	1946-12-27 00:00:00	32020		\N	232763	0	65363002	372328		0
59285	3516	439777	1964-07-21	1964-07-21 00:00:00	\N	\N	32020		\N	233294	0	271737000	439777		0
48888	2894	4112343	1974-04-04	1974-04-04 00:00:00	1974-04-12	1974-04-12 00:00:00	32020		\N	192626	0	195662009	4112343		0
49131	2906	192671	1965-07-06	1965-07-06 00:00:00	\N	\N	32020		\N	193727	0	K92.2	35208414		0
59774	3542	40481087	1988-05-30	1988-05-30 00:00:00	1988-06-06	1988-06-06 00:00:00	32020		\N	235235	0	444814009	40481087		0
49463	2925	133834	1963-05-02	1963-05-02 00:00:00	1977-03-24	1977-03-24 00:00:00	32020		\N	194994	0	24079001	133834		0
49609	2935	80180	2013-08-16	2013-08-16 00:00:00	\N	\N	32020		\N	195714	0	396275006	80180		0
49779	2944	372328	1960-03-31	1960-03-31 00:00:00	1960-05-08	1960-05-08 00:00:00	32020		\N	196429	0	65363002	372328		0
49807	2945	40481087	2002-11-30	2002-11-30 00:00:00	2002-12-07	2002-12-07 00:00:00	32020		\N	196526	0	444814009	40481087		0
50087	2959	260139	1993-02-24	1993-02-24 00:00:00	1993-03-10	1993-03-10 00:00:00	32020		\N	197538	0	10509002	260139		0
50181	2965	4112343	1985-10-15	1985-10-15 00:00:00	1985-10-24	1985-10-24 00:00:00	32020		\N	197910	0	195662009	4112343		0
50440	2985	40481087	1968-11-29	1968-11-29 00:00:00	1968-12-06	1968-12-06 00:00:00	32020		\N	199206	0	444814009	40481087		0
50557	2989	4112343	1963-09-04	1963-09-04 00:00:00	1963-09-17	1963-09-17 00:00:00	32020		\N	199573	0	195662009	4112343		0
50732	3001	40481087	1977-08-30	1977-08-30 00:00:00	1977-09-13	1977-09-13 00:00:00	32020		\N	200240	0	444814009	40481087		0
50883	3010	80180	2003-12-26	2003-12-26 00:00:00	\N	\N	32020		\N	200753	0	396275006	80180		0
50987	3017	40481087	1999-09-16	1999-09-16 00:00:00	1999-09-30	1999-09-30 00:00:00	32020		\N	201253	0	444814009	40481087		0
61794	3650	4112343	1991-05-30	1991-05-30 00:00:00	1991-06-07	1991-06-07 00:00:00	32020		\N	242904	0	195662009	4112343		0
51392	3049	40481087	2011-12-31	2011-12-31 00:00:00	2012-01-21	2012-01-21 00:00:00	32020		\N	202855	0	444814009	40481087		0
51545	3059	40481087	2017-04-01	2017-04-01 00:00:00	2017-04-22	2017-04-22 00:00:00	32020		\N	203484	0	444814009	40481087		0
62257	3676	28060	1989-08-07	1989-08-07 00:00:00	1989-08-18	1989-08-18 00:00:00	32020		\N	244498	0	43878008	28060		0
51910	3077	4142905	1968-01-01	1968-01-01 00:00:00	1968-03-01	1968-03-01 00:00:00	32020		\N	204718	0	33737001	4142905		0
52052	3082	40481087	1976-09-13	1976-09-13 00:00:00	1976-09-20	1976-09-20 00:00:00	32020		\N	205246	0	444814009	40481087		0
52238	3092	4142905	1964-05-24	1964-05-24 00:00:00	1964-08-22	1964-08-22 00:00:00	32020		\N	205905	0	33737001	4142905		0
52330	3098	4109685	2009-01-02	2009-01-02 00:00:00	2009-01-16	2009-01-16 00:00:00	32020		\N	206194	0	284551006	4109685		0
63159	3731	40481087	1996-06-21	1996-06-21 00:00:00	1996-07-12	1996-07-12 00:00:00	32020		\N	247951	0	444814009	40481087		0
63273	3736	4112343	1986-01-22	1986-01-22 00:00:00	1986-02-03	1986-02-03 00:00:00	32020		\N	248316	0	195662009	4112343		0
63424	3746	372328	1957-06-28	1957-06-28 00:00:00	1958-04-17	1958-04-17 00:00:00	32020		\N	248992	0	65363002	372328		0
63616	3756	372328	1941-02-19	1941-02-19 00:00:00	1941-03-29	1941-03-29 00:00:00	32020		\N	249651	0	65363002	372328		0
42619	2541	260139	1999-02-23	1999-02-23 00:00:00	1999-03-09	1999-03-09 00:00:00	32020		\N	168033	0	10509002	260139		0
53312	3158	40481087	1961-12-19	1961-12-19 00:00:00	1962-01-09	1962-01-09 00:00:00	32020		\N	209908	0	444814009	40481087		0
42985	2559	260139	1970-02-21	1970-02-21 00:00:00	1970-03-07	1970-03-07 00:00:00	32020		\N	169604	0	10509002	260139		0
43110	2567	260139	1978-05-01	1978-05-01 00:00:00	1978-05-08	1978-05-08 00:00:00	32020		\N	170096	0	10509002	260139		0
43204	2572	4218389	1999-10-29	1999-10-29 00:00:00	1999-11-19	1999-11-19 00:00:00	32020		\N	170368	0	39848009	4218389		0
43484	2591	4112343	1971-11-14	1971-11-14 00:00:00	1971-11-26	1971-11-26 00:00:00	32020		\N	171491	0	195662009	4112343		0
43542	2594	40481087	1989-04-01	1989-04-01 00:00:00	1989-04-08	1989-04-08 00:00:00	32020		\N	171712	0	444814009	40481087		0
43745	2604	260139	1978-10-03	1978-10-03 00:00:00	1978-10-10	1978-10-10 00:00:00	32020		\N	172247	0	10509002	260139		0
43898	2613	4112343	2018-09-11	2018-09-11 00:00:00	2018-09-18	2018-09-18 00:00:00	32020		\N	172786	0	195662009	4112343		0
44102	2622	378001	1963-07-18	1963-07-18 00:00:00	1963-08-17	1963-08-17 00:00:00	32020		\N	173407	0	62106007	378001		0
44254	2631	260139	1991-10-20	1991-10-20 00:00:00	1991-11-03	1991-11-03 00:00:00	32020		\N	174102	0	10509002	260139		0
54965	3253	40481087	1974-03-06	1974-03-06 00:00:00	1974-03-20	1974-03-20 00:00:00	32020		\N	216344	0	444814009	40481087		0
55137	3263	28060	1985-04-23	1985-04-23 00:00:00	1985-05-03	1985-05-03 00:00:00	32020		\N	216878	0	43878008	28060		0
44767	2663	30753	2001-08-17	2001-08-17 00:00:00	\N	\N	32020		\N	176470	0	16761005	30753		0
44936	2674	260139	1987-01-01	1987-01-01 00:00:00	1987-01-15	1987-01-15 00:00:00	32020		\N	177183	0	10509002	260139		0
45147	2685	4283893	1994-09-21	1994-09-21 00:00:00	1994-10-12	1994-10-12 00:00:00	32020		\N	177909	0	36971009	4283893		0
45178	2686	40481087	2010-07-18	2010-07-18 00:00:00	2010-08-08	2010-08-08 00:00:00	32020		\N	178053	0	444814009	40481087		0
55959	3313	4155034	1976-08-28	1976-08-28 00:00:00	1976-09-11	1976-09-11 00:00:00	32020		\N	219996	0	283371005	4155034		0
45596	2709	4155034	1970-09-22	1970-09-22 00:00:00	1970-10-13	1970-10-13 00:00:00	32020		\N	179448	0	283371005	4155034		0
45792	2724	4112343	1975-04-01	1975-04-01 00:00:00	1975-04-14	1975-04-14 00:00:00	32020		\N	180497	0	195662009	4112343		0
45899	2732	28060	2014-01-30	2014-01-30 00:00:00	2014-02-10	2014-02-10 00:00:00	32020		\N	180880	0	43878008	28060		0
56679	3362	260139	2004-11-08	2004-11-08 00:00:00	2004-11-22	2004-11-22 00:00:00	32020		\N	222885	0	10509002	260139		0
46290	2758	40481087	1959-09-29	1959-09-29 00:00:00	1959-10-13	1959-10-13 00:00:00	32020		\N	182487	0	444814009	40481087		0
46404	2764	40481087	1988-12-10	1988-12-10 00:00:00	1988-12-17	1988-12-17 00:00:00	32020		\N	182781	0	444814009	40481087		0
46521	2770	40481087	2000-05-01	2000-05-01 00:00:00	2000-05-22	2000-05-22 00:00:00	32020		\N	183344	0	444814009	40481087		0
46750	2781	372328	1986-01-26	1986-01-26 00:00:00	1986-03-14	1986-03-14 00:00:00	32020		\N	184293	0	65363002	372328		0
46906	2790	28060	1967-08-28	1967-08-28 00:00:00	1967-09-06	1967-09-06 00:00:00	32020		\N	184868	0	43878008	28060		0
47128	2802	40481087	1949-02-04	1949-02-04 00:00:00	1949-02-25	1949-02-25 00:00:00	32020		\N	185736	0	444814009	40481087		0
47287	2813	78272	1936-07-16	1936-07-16 00:00:00	1936-08-20	1936-08-20 00:00:00	32020		\N	186415	0	70704007	78272		0
47426	2821	4310024	1957-08-21	1957-08-21 00:00:00	\N	\N	32020		\N	186965	0	424802006	4310024		0
47588	2829	4113008	1990-09-04	1990-09-04 00:00:00	1990-09-18	1990-09-18 00:00:00	32020		\N	187671	0	284549007	4113008		0
47680	2834	4112343	1965-03-17	1965-03-17 00:00:00	1965-03-27	1965-03-27 00:00:00	32020		\N	188178	0	195662009	4112343		0
47874	2843	375671	2006-09-06	2006-09-06 00:00:00	2006-10-06	2006-10-06 00:00:00	32020		\N	188743	0	62564004	375671		0
48139	2857	260139	1984-11-27	1984-11-27 00:00:00	1984-12-04	1984-12-04 00:00:00	32020		\N	189686	0	10509002	260139		0
48176	2858	4112343	1910-11-20	1910-11-20 00:00:00	1910-11-29	1910-11-29 00:00:00	32020		\N	189873	0	195662009	4112343		0
48333	2864	40481087	1977-04-29	1977-04-29 00:00:00	1977-05-06	1977-05-06 00:00:00	32020		\N	190466	0	444814009	40481087		0
59139	3509	4116491	1972-01-09	1972-01-09 00:00:00	1972-02-17	1972-02-17 00:00:00	32020		\N	232703	0	301011002	4116491		0
59286	3516	257012	1953-05-28	1953-05-28 00:00:00	\N	\N	32020		\N	233292	0	40055000	257012		0
48889	2894	4237458	1991-02-24	1991-02-24 00:00:00	1991-04-25	1991-04-25 00:00:00	32020		\N	192600	0	58150001	4237458		0
49132	2906	40481087	1985-05-31	1985-05-31 00:00:00	1985-06-14	1985-06-14 00:00:00	32020		\N	193692	0	444814009	40481087		0
59775	3542	28060	1938-01-02	1938-01-02 00:00:00	1938-01-13	1938-01-13 00:00:00	32020		\N	235232	0	43878008	28060		0
49464	2925	40481087	1992-06-04	1992-06-04 00:00:00	1992-06-25	1992-06-25 00:00:00	32020		\N	195083	0	444814009	40481087		0
49610	2935	372328	1978-06-26	1978-06-26 00:00:00	1978-09-13	1978-09-13 00:00:00	32020		\N	195728	0	65363002	372328		0
49780	2944	257012	2013-09-14	2013-09-14 00:00:00	\N	\N	32020		\N	196413	0	40055000	257012		0
49808	2945	40481087	1992-10-20	1992-10-20 00:00:00	1992-11-10	1992-11-10 00:00:00	32020		\N	196528	0	444814009	40481087		0
50088	2959	78272	2005-01-22	2005-01-22 00:00:00	2005-02-05	2005-02-05 00:00:00	32020		\N	197606	0	70704007	78272		0
50182	2965	440086	1982-02-20	1982-02-20 00:00:00	1988-02-29	1988-02-29 00:00:00	32020		\N	198003	0	192127007	440086		0
50441	2985	81151	1989-01-26	1989-01-26 00:00:00	1989-02-16	1989-02-16 00:00:00	32020		\N	199188	0	44465007	81151		0
50558	2989	4027663	1986-06-15	1986-06-15 00:00:00	\N	\N	32020		\N	199536	0	13200003	4027663		0
50733	3001	4112343	1990-11-11	1990-11-11 00:00:00	1990-11-24	1990-11-24 00:00:00	32020		\N	200316	0	195662009	4112343		0
50884	3010	4112343	2012-05-13	2012-05-13 00:00:00	2012-05-24	2012-05-24 00:00:00	32020		\N	200773	0	195662009	4112343		0
50988	3017	40481087	1975-03-23	1975-03-23 00:00:00	1975-04-13	1975-04-13 00:00:00	32020		\N	201226	0	444814009	40481087		0
61795	3650	4285898	1964-01-12	1964-01-12 00:00:00	\N	\N	32020		\N	242991	0	68496003	4285898		0
51393	3049	78272	2005-10-18	2005-10-18 00:00:00	2005-11-22	2005-11-22 00:00:00	32020		\N	202876	0	70704007	78272		0
51547	3059	4112343	1972-08-08	1972-08-08 00:00:00	1972-08-20	1972-08-20 00:00:00	32020		\N	203502	0	195662009	4112343		0
62258	3676	260139	1997-03-31	1997-03-31 00:00:00	1997-04-14	1997-04-14 00:00:00	32020		\N	244550	0	10509002	260139		0
51911	3077	257012	1972-04-20	1972-04-20 00:00:00	\N	\N	32020		\N	204761	0	40055000	257012		0
52053	3082	372328	1967-12-22	1967-12-22 00:00:00	1968-01-05	1968-01-05 00:00:00	32020		\N	205239	0	65363002	372328		0
52239	3092	4112343	1976-06-04	1976-06-04 00:00:00	1976-06-12	1976-06-12 00:00:00	32020		\N	205866	0	195662009	4112343		0
52331	3098	40481087	2002-07-07	2002-07-07 00:00:00	2002-07-28	2002-07-28 00:00:00	32020		\N	206206	0	444814009	40481087		0
63160	3731	4112343	1985-07-09	1985-07-09 00:00:00	1985-07-16	1985-07-16 00:00:00	32020		\N	247915	0	195662009	4112343		0
63274	3736	372328	1952-02-29	1952-02-29 00:00:00	1952-05-14	1952-05-14 00:00:00	32020		\N	248322	0	65363002	372328		0
63425	3746	4278672	2012-11-02	2012-11-02 00:00:00	2012-12-02	2012-12-02 00:00:00	32020		\N	249066	0	65966004	4278672		0
63617	3756	40481087	1970-01-06	1970-01-06 00:00:00	1970-01-27	1970-01-27 00:00:00	32020		\N	249625	0	444814009	40481087		0
42620	2541	4112343	1984-10-13	1984-10-13 00:00:00	1984-10-26	1984-10-26 00:00:00	32020		\N	168050	0	195662009	4112343		0
53313	3159	28060	1975-07-03	1975-07-03 00:00:00	1975-07-15	1975-07-15 00:00:00	32020		\N	210037	0	43878008	28060		0
42986	2559	372328	1960-06-16	1960-06-16 00:00:00	1960-07-23	1960-07-23 00:00:00	32020		\N	169633	0	65363002	372328		0
43111	2567	260139	1977-11-14	1977-11-14 00:00:00	1977-11-21	1977-11-21 00:00:00	32020		\N	170076	0	10509002	260139		0
43205	2572	378001	1978-02-21	1978-02-21 00:00:00	1978-03-23	1978-03-23 00:00:00	32020		\N	170367	0	62106007	378001		0
43485	2591	260139	1987-12-17	1987-12-17 00:00:00	1987-12-24	1987-12-24 00:00:00	32020		\N	171497	0	10509002	260139		0
43543	2594	192671	2015-05-22	2015-05-22 00:00:00	\N	\N	32020		\N	171728	0	K92.2	35208414		0
43746	2604	372328	1957-04-04	1957-04-04 00:00:00	1957-05-18	1957-05-18 00:00:00	32020		\N	172280	0	65363002	372328		0
43899	2613	80180	1996-09-14	1996-09-14 00:00:00	\N	\N	32020		\N	172798	0	396275006	80180		0
44103	2622	378001	1997-09-08	1997-09-08 00:00:00	1997-10-08	1997-10-08 00:00:00	32020		\N	173409	0	62106007	378001		0
44255	2631	4112343	2005-08-27	2005-08-27 00:00:00	2005-09-04	2005-09-04 00:00:00	32020		\N	174065	0	195662009	4112343		0
54966	3253	40481087	1987-01-23	1987-01-23 00:00:00	1987-01-30	1987-01-30 00:00:00	32020		\N	216289	0	444814009	40481087		0
55138	3263	4112343	1968-08-05	1968-08-05 00:00:00	1968-08-18	1968-08-18 00:00:00	32020		\N	216876	0	195662009	4112343		0
44768	2663	4266809	2002-09-11	2002-09-11 00:00:00	\N	\N	32020		\N	176470	0	397881000	4266809		0
44937	2674	192671	2013-09-06	2013-09-06 00:00:00	\N	\N	32020		\N	177219	0	K92.2	35208414		0
45148	2685	40481087	2002-05-08	2002-05-08 00:00:00	2002-05-22	2002-05-22 00:00:00	32020		\N	177938	0	444814009	40481087		0
45179	2686	40481087	1970-05-26	1970-05-26 00:00:00	1970-06-16	1970-06-16 00:00:00	32020		\N	177985	0	444814009	40481087		0
55960	3313	4146173	1992-04-20	1992-04-20 00:00:00	1992-06-19	1992-06-19 00:00:00	32020		\N	219979	0	307731004	4146173		0
45597	2709	260139	2002-11-16	2002-11-16 00:00:00	2002-11-30	2002-11-30 00:00:00	32020		\N	179443	0	10509002	260139		0
45793	2724	4112343	1955-08-19	1955-08-19 00:00:00	1955-08-31	1955-08-31 00:00:00	32020		\N	180490	0	195662009	4112343		0
45900	2732	4112343	2013-11-16	2013-11-16 00:00:00	2013-11-28	2013-11-28 00:00:00	32020		\N	180833	0	195662009	4112343		0
56680	3362	260139	1966-09-02	1966-09-02 00:00:00	1966-09-09	1966-09-09 00:00:00	32020		\N	222854	0	10509002	260139		0
46291	2758	28060	1947-03-12	1947-03-12 00:00:00	1947-03-25	1947-03-25 00:00:00	32020		\N	182475	0	43878008	28060		0
46405	2764	40481087	2000-10-14	2000-10-14 00:00:00	2000-11-04	2000-11-04 00:00:00	32020		\N	182789	0	444814009	40481087		0
46522	2770	260139	1991-01-30	1991-01-30 00:00:00	1991-02-06	1991-02-06 00:00:00	32020		\N	183320	0	10509002	260139		0
46751	2781	40481087	1980-05-06	1980-05-06 00:00:00	1980-05-27	1980-05-27 00:00:00	32020		\N	184290	0	444814009	40481087		0
46907	2790	4116491	1989-07-15	1989-07-15 00:00:00	1989-09-03	1989-09-03 00:00:00	32020		\N	184898	0	301011002	4116491		0
47129	2802	4283893	1975-01-19	1975-01-19 00:00:00	1975-05-25	1975-05-25 00:00:00	32020		\N	185758	0	36971009	4283893		0
47288	2813	40481087	1975-06-13	1975-06-13 00:00:00	1975-07-04	1975-07-04 00:00:00	32020		\N	186409	0	444814009	40481087		0
47427	2821	80180	1959-02-12	1959-02-12 00:00:00	\N	\N	32020		\N	186965	0	396275006	80180		0
47589	2829	4112343	1961-05-12	1961-05-12 00:00:00	1961-05-19	1961-05-19 00:00:00	32020		\N	187632	0	195662009	4112343		0
47681	2834	372328	1938-11-30	1938-11-30 00:00:00	1939-04-01	1939-04-01 00:00:00	32020		\N	188167	0	65363002	372328		0
47875	2843	372328	1962-07-17	1962-07-17 00:00:00	1962-12-27	1962-12-27 00:00:00	32020		\N	188794	0	65363002	372328		0
48140	2857	4134304	1980-10-12	1980-10-12 00:00:00	1980-12-10	1980-12-10 00:00:00	32020		\N	189671	0	263102004	4134304		0
48177	2858	81151	2004-11-29	2004-11-29 00:00:00	2004-12-20	2004-12-20 00:00:00	32020		\N	189775	0	44465007	81151		0
48334	2864	260139	1990-06-10	1990-06-10 00:00:00	1990-06-17	1990-06-17 00:00:00	32020		\N	190511	0	10509002	260139		0
59140	3509	4156265	1953-11-03	1953-11-03 00:00:00	1953-11-17	1953-11-17 00:00:00	32020		\N	232696	0	370247008	4156265		0
59287	3516	40481087	2014-03-20	2014-03-20 00:00:00	2014-04-03	2014-04-03 00:00:00	32020		\N	233300	0	444814009	40481087		0
48890	2895	260139	1962-02-08	1962-02-08 00:00:00	1962-02-22	1962-02-22 00:00:00	32020		\N	192700	0	10509002	260139		0
49133	2906	40481087	1938-04-26	1938-04-26 00:00:00	1938-05-17	1938-05-17 00:00:00	32020		\N	193744	0	444814009	40481087		0
59776	3542	4156265	1957-05-09	1957-05-09 00:00:00	1957-05-23	1957-05-23 00:00:00	32020		\N	235322	0	370247008	4156265		0
49465	2925	372328	1961-02-03	1961-02-03 00:00:00	1961-03-19	1961-03-19 00:00:00	32020		\N	195081	0	65363002	372328		0
49611	2935	28060	2001-01-27	2001-01-27 00:00:00	2001-02-09	2001-02-09 00:00:00	32020		\N	195686	0	43878008	28060		0
49781	2944	260139	2010-10-07	2010-10-07 00:00:00	2010-10-21	2010-10-21 00:00:00	32020		\N	196412	0	10509002	260139		0
49809	2945	372328	1950-11-18	1950-11-18 00:00:00	1951-07-03	1951-07-03 00:00:00	32020		\N	196468	0	65363002	372328		0
50089	2959	321042	1997-10-07	1997-10-07 00:00:00	\N	\N	32020		\N	197605	0	410429000	321042		0
50183	2965	378001	2015-06-09	2015-06-09 00:00:00	2015-08-08	2015-08-08 00:00:00	32020		\N	197988	0	62106007	378001		0
50442	2985	260139	2017-10-12	2017-10-12 00:00:00	2017-10-26	2017-10-26 00:00:00	32020		\N	199219	0	10509002	260139		0
50559	2989	4112343	1962-02-27	1962-02-27 00:00:00	1962-03-09	1962-03-09 00:00:00	32020		\N	199528	0	195662009	4112343		0
50734	3001	28060	1959-07-03	1959-07-03 00:00:00	1959-07-12	1959-07-12 00:00:00	32020		\N	200269	0	43878008	28060		0
50885	3010	40481087	1996-08-10	1996-08-10 00:00:00	1996-08-17	1996-08-17 00:00:00	32020		\N	200772	0	444814009	40481087		0
50989	3017	260139	2000-11-08	2000-11-08 00:00:00	2000-11-15	2000-11-15 00:00:00	32020		\N	201276	0	10509002	260139		0
61796	3650	80180	1964-08-09	1964-08-09 00:00:00	\N	\N	32020		\N	242991	0	396275006	80180		0
51394	3049	40481087	2015-02-10	2015-02-10 00:00:00	2015-02-17	2015-02-17 00:00:00	32020		\N	202836	0	444814009	40481087		0
51548	3059	40481087	2005-08-12	2005-08-12 00:00:00	2005-08-19	2005-08-19 00:00:00	32020		\N	203482	0	444814009	40481087		0
62259	3676	40481087	2007-02-27	2007-02-27 00:00:00	2007-03-20	2007-03-20 00:00:00	32020		\N	244510	0	444814009	40481087		0
51912	3077	40481087	1955-10-18	1955-10-18 00:00:00	1955-11-01	1955-11-01 00:00:00	32020		\N	204764	0	444814009	40481087		0
52054	3082	80180	2004-03-12	2004-03-12 00:00:00	\N	\N	32020		\N	205220	0	396275006	80180		0
52240	3092	80180	1994-06-02	1994-06-02 00:00:00	\N	\N	32020		\N	205837	0	396275006	80180		0
52332	3098	4059173	2019-06-23	2019-06-23 00:00:00	\N	\N	32020		\N	206195	0	16114001	4059173		0
63161	3731	257012	1980-02-10	1980-02-10 00:00:00	\N	\N	32020		\N	247948	0	40055000	257012		0
63275	3736	40481087	1974-01-06	1974-01-06 00:00:00	1974-01-20	1974-01-20 00:00:00	32020		\N	248348	0	444814009	40481087		0
63426	3746	257012	1985-03-19	1985-03-19 00:00:00	\N	\N	32020		\N	248979	0	40055000	257012		0
63618	3756	28060	1948-05-27	1948-05-27 00:00:00	1948-06-08	1948-06-08 00:00:00	32020		\N	249667	0	43878008	28060		0
42621	2541	40481087	1981-06-05	1981-06-05 00:00:00	1981-06-26	1981-06-26 00:00:00	32020		\N	168015	0	444814009	40481087		0
53314	3159	260139	1971-05-25	1971-05-25 00:00:00	1971-06-08	1971-06-08 00:00:00	32020		\N	210089	0	10509002	260139		0
42987	2559	40481087	1976-09-17	1976-09-17 00:00:00	1976-09-24	1976-09-24 00:00:00	32020		\N	169605	0	444814009	40481087		0
43112	2567	4112343	2008-01-20	2008-01-20 00:00:00	2008-01-31	2008-01-31 00:00:00	32020		\N	170100	0	195662009	4112343		0
43206	2572	260139	2005-01-18	2005-01-18 00:00:00	2005-01-25	2005-01-25 00:00:00	32020		\N	170347	0	10509002	260139		0
43486	2591	192671	1974-09-16	1974-09-16 00:00:00	\N	\N	32020		\N	171450	0	K92.2	35208414		0
43544	2594	40481087	1981-02-16	1981-02-16 00:00:00	1981-03-09	1981-03-09 00:00:00	32020		\N	171729	0	444814009	40481087		0
43747	2604	4112343	2000-04-28	2000-04-28 00:00:00	2000-05-11	2000-05-11 00:00:00	32020		\N	172278	0	195662009	4112343		0
43907	2615	40481087	1964-01-11	1964-01-11 00:00:00	1964-01-18	1964-01-18 00:00:00	32020		\N	172849	0	444814009	40481087		0
44104	2622	4152936	2018-05-21	2018-05-21 00:00:00	2018-06-04	2018-06-04 00:00:00	32020		\N	173406	0	283385000	4152936		0
44256	2631	40481087	1968-12-18	1968-12-18 00:00:00	1969-01-08	1969-01-08 00:00:00	32020		\N	174064	0	444814009	40481087		0
54967	3253	4112343	1989-02-21	1989-02-21 00:00:00	1989-03-04	1989-03-04 00:00:00	32020		\N	216370	0	195662009	4112343		0
55139	3263	260139	2011-02-15	2011-02-15 00:00:00	2011-02-22	2011-02-22 00:00:00	32020		\N	216943	0	10509002	260139		0
44769	2663	81893	2001-05-19	2001-05-19 00:00:00	\N	\N	32020		\N	176470	0	64766004	81893		0
44938	2674	260139	2007-03-23	2007-03-23 00:00:00	2007-03-30	2007-03-30 00:00:00	32020		\N	177205	0	10509002	260139		0
45149	2685	4112343	1967-06-19	1967-06-19 00:00:00	1967-06-29	1967-06-29 00:00:00	32020		\N	177907	0	195662009	4112343		0
45180	2686	40481087	1994-09-03	1994-09-03 00:00:00	1994-09-17	1994-09-17 00:00:00	32020		\N	177995	0	444814009	40481087		0
55961	3313	40481087	1977-10-01	1977-10-01 00:00:00	1977-10-22	1977-10-22 00:00:00	32020		\N	219968	0	444814009	40481087		0
45598	2709	40481087	2017-02-17	2017-02-17 00:00:00	2017-02-24	2017-02-24 00:00:00	32020		\N	179470	0	444814009	40481087		0
45794	2724	28060	1957-01-24	1957-01-24 00:00:00	1957-02-01	1957-02-01 00:00:00	32020		\N	180491	0	43878008	28060		0
45901	2732	4048171	1973-08-13	1973-08-13 00:00:00	1993-07-15	1993-07-15 00:00:00	32020		\N	180910	0	232353008	4048171		0
56681	3362	4112343	1957-09-22	1957-09-22 00:00:00	1957-10-03	1957-10-03 00:00:00	32020		\N	222881	0	195662009	4112343		0
46292	2758	4112343	1985-11-08	1985-11-08 00:00:00	1985-11-18	1985-11-18 00:00:00	32020		\N	182480	0	195662009	4112343		0
46406	2765	40481087	1974-06-14	1974-06-14 00:00:00	1974-06-28	1974-06-28 00:00:00	32020		\N	182940	0	444814009	40481087		0
46523	2770	4112343	1940-11-21	1940-11-21 00:00:00	1940-12-02	1940-12-02 00:00:00	32020		\N	183309	0	195662009	4112343		0
46752	2781	40481087	1983-08-15	1983-08-15 00:00:00	1983-09-05	1983-09-05 00:00:00	32020		\N	184294	0	444814009	40481087		0
46908	2790	4112343	1994-01-17	1994-01-17 00:00:00	1994-01-27	1994-01-27 00:00:00	32020		\N	184877	0	195662009	4112343		0
47130	2802	4296204	1973-06-18	1973-06-18 00:00:00	1973-07-02	1973-07-02 00:00:00	32020		\N	185712	0	403190006	4296204		0
47289	2813	4112343	2009-09-20	2009-09-20 00:00:00	2009-10-02	2009-10-02 00:00:00	32020		\N	186381	0	195662009	4112343		0
47428	2821	372328	1920-07-01	1920-07-01 00:00:00	1920-09-07	1920-09-07 00:00:00	32020		\N	186935	0	65363002	372328		0
47590	2829	4112343	1968-01-05	1968-01-05 00:00:00	1968-01-12	1968-01-12 00:00:00	32020		\N	187633	0	195662009	4112343		0
47682	2834	260139	1970-06-10	1970-06-10 00:00:00	1970-06-24	1970-06-24 00:00:00	32020		\N	188186	0	10509002	260139		0
47876	2843	260139	2001-05-29	2001-05-29 00:00:00	2001-06-12	2001-06-12 00:00:00	32020		\N	188780	0	10509002	260139		0
58630	3477	80180	1997-01-08	1997-01-08 00:00:00	\N	\N	32020		\N	230736	0	396275006	80180		0
48178	2858	4112343	1957-09-03	1957-09-03 00:00:00	1957-09-13	1957-09-13 00:00:00	32020		\N	189799	0	195662009	4112343		0
48335	2864	40481087	1987-10-15	1987-10-15 00:00:00	1987-10-22	1987-10-22 00:00:00	32020		\N	190467	0	444814009	40481087		0
59141	3509	4218389	1949-12-26	1949-12-26 00:00:00	1950-01-23	1950-01-23 00:00:00	32020		\N	232695	0	39848009	4218389		0
59288	3516	28060	1947-05-04	1947-05-04 00:00:00	1947-05-17	1947-05-17 00:00:00	32020		\N	233311	0	43878008	28060		0
48891	2895	260139	2013-06-10	2013-06-10 00:00:00	2013-06-24	2013-06-24 00:00:00	32020		\N	192740	0	10509002	260139		0
49134	2906	4152936	1971-03-15	1971-03-15 00:00:00	1971-03-29	1971-03-29 00:00:00	32020		\N	193724	0	283385000	4152936		0
59777	3542	4112343	1964-09-07	1964-09-07 00:00:00	1964-09-20	1964-09-20 00:00:00	32020		\N	235234	0	195662009	4112343		0
49466	2925	260139	2001-04-25	2001-04-25 00:00:00	2001-05-09	2001-05-09 00:00:00	32020		\N	195010	0	10509002	260139		0
49612	2935	81151	1994-03-18	1994-03-18 00:00:00	1994-04-01	1994-04-01 00:00:00	32020		\N	195680	0	44465007	81151		0
49782	2944	4310024	1996-02-21	1996-02-21 00:00:00	\N	\N	32020		\N	196454	0	424802006	4310024		0
49810	2945	4112343	1951-07-29	1951-07-29 00:00:00	1951-08-09	1951-08-09 00:00:00	32020		\N	196479	0	195662009	4112343		0
50091	2959	4059173	1986-09-29	1986-09-29 00:00:00	1986-12-28	1986-12-28 00:00:00	32020		\N	197604	0	16114001	4059173		0
50184	2965	4112343	1992-09-20	1992-09-20 00:00:00	1992-10-01	1992-10-01 00:00:00	32020		\N	197939	0	195662009	4112343		0
50443	2985	80180	2001-12-23	2001-12-23 00:00:00	\N	\N	32020		\N	199215	0	396275006	80180		0
50566	2991	260139	1990-12-14	1990-12-14 00:00:00	1990-12-28	1990-12-28 00:00:00	32020		\N	199644	0	10509002	260139		0
50735	3001	4112343	2015-10-28	2015-10-28 00:00:00	2015-11-06	2015-11-06 00:00:00	32020		\N	200288	0	195662009	4112343		0
50886	3010	28060	1984-07-24	1984-07-24 00:00:00	1984-08-06	1984-08-06 00:00:00	32020		\N	200771	0	43878008	28060		0
50990	3017	40481087	1984-03-29	1984-03-29 00:00:00	1984-04-19	1984-04-19 00:00:00	32020		\N	201228	0	444814009	40481087		0
61797	3650	4112343	1961-11-25	1961-11-25 00:00:00	1961-12-05	1961-12-05 00:00:00	32020		\N	242991	0	195662009	4112343		0
51395	3049	40481087	2014-12-13	2014-12-13 00:00:00	2015-01-03	2015-01-03 00:00:00	32020		\N	202852	0	444814009	40481087		0
51549	3059	4112343	2006-06-02	2006-06-02 00:00:00	2006-06-12	2006-06-12 00:00:00	32020		\N	203496	0	195662009	4112343		0
62260	3676	260139	1975-10-19	1975-10-19 00:00:00	1975-11-02	1975-11-02 00:00:00	32020		\N	244547	0	10509002	260139		0
51913	3077	40481087	1963-07-30	1963-07-30 00:00:00	1963-08-06	1963-08-06 00:00:00	32020		\N	204760	0	444814009	40481087		0
52055	3083	4112343	2011-02-23	2011-02-23 00:00:00	2011-03-02	2011-03-02 00:00:00	32020		\N	205266	0	195662009	4112343		0
52241	3092	4285898	1994-01-03	1994-01-03 00:00:00	\N	\N	32020		\N	205837	0	68496003	4285898		0
52333	3098	80180	1995-12-02	1995-12-02 00:00:00	\N	\N	32020		\N	206193	0	396275006	80180		0
63162	3731	4112343	1989-01-28	1989-01-28 00:00:00	1989-02-08	1989-02-08 00:00:00	32020		\N	247939	0	195662009	4112343		0
63276	3736	40481087	1964-12-08	1964-12-08 00:00:00	1964-12-15	1964-12-15 00:00:00	32020		\N	248345	0	444814009	40481087		0
63427	3746	81151	1947-10-19	1947-10-19 00:00:00	1947-11-09	1947-11-09 00:00:00	32020		\N	249063	0	44465007	81151		0
63619	3756	40481087	2018-04-28	2018-04-28 00:00:00	2018-05-19	2018-05-19 00:00:00	32020		\N	249612	0	444814009	40481087		0
42622	2541	260139	2011-08-08	2011-08-08 00:00:00	2011-08-15	2011-08-15 00:00:00	32020		\N	168034	0	10509002	260139		0
53315	3159	40481087	1989-04-17	1989-04-17 00:00:00	1989-05-08	1989-05-08 00:00:00	32020		\N	210075	0	444814009	40481087		0
42988	2559	40481087	2003-05-06	2003-05-06 00:00:00	2003-05-13	2003-05-13 00:00:00	32020		\N	169568	0	444814009	40481087		0
43113	2567	81151	1984-12-05	1984-12-05 00:00:00	1984-12-26	1984-12-26 00:00:00	32020		\N	170094	0	44465007	81151		0
43207	2572	81893	2008-08-08	2008-08-08 00:00:00	\N	\N	32020		\N	170401	0	64766004	81893		0
43487	2591	80502	2012-03-14	2012-03-14 00:00:00	\N	\N	32020		\N	171547	0	64859006	80502		0
43545	2594	4112343	1994-05-13	1994-05-13 00:00:00	1994-05-23	1994-05-23 00:00:00	32020		\N	171714	0	195662009	4112343		0
43748	2604	372328	1957-10-15	1957-10-15 00:00:00	1958-02-15	1958-02-15 00:00:00	32020		\N	172317	0	65363002	372328		0
43908	2615	4112343	1980-06-27	1980-06-27 00:00:00	1980-07-04	1980-07-04 00:00:00	32020		\N	172852	0	195662009	4112343		0
44105	2622	30753	1974-09-18	1974-09-18 00:00:00	\N	\N	32020		\N	173453	0	16761005	30753		0
44257	2631	4112343	1960-02-29	1960-02-29 00:00:00	1960-03-12	1960-03-12 00:00:00	32020		\N	174080	0	195662009	4112343		0
54968	3253	40486433	1972-05-25	1972-05-25 00:00:00	\N	\N	32020		\N	216320	0	446096008	40486433		0
55140	3263	40481087	1978-09-12	1978-09-12 00:00:00	1978-10-03	1978-10-03 00:00:00	32020		\N	216941	0	444814009	40481087		0
44770	2663	80180	2002-09-11	2002-09-11 00:00:00	\N	\N	32020		\N	176470	0	396275006	80180		0
44939	2674	4112343	1989-02-04	1989-02-04 00:00:00	1989-02-15	1989-02-15 00:00:00	32020		\N	177184	0	195662009	4112343		0
45150	2685	4156265	1974-09-30	1974-09-30 00:00:00	1974-10-14	1974-10-14 00:00:00	32020		\N	177898	0	370247008	4156265		0
45181	2686	40481087	1975-01-29	1975-01-29 00:00:00	1975-02-12	1975-02-12 00:00:00	32020		\N	178006	0	444814009	40481087		0
55962	3313	4112343	2014-12-14	2014-12-14 00:00:00	2014-12-26	2014-12-26 00:00:00	32020		\N	219973	0	195662009	4112343		0
45599	2709	378419	2012-01-17	2012-01-17 00:00:00	\N	\N	32020		\N	179468	0	26929004	378419		0
45795	2724	28060	1974-11-17	1974-11-17 00:00:00	1974-11-29	1974-11-29 00:00:00	32020		\N	180496	0	43878008	28060		0
45902	2732	372328	1981-12-02	1981-12-02 00:00:00	1982-09-02	1982-09-02 00:00:00	32020		\N	180881	0	65363002	372328		0
56682	3362	4156265	1986-12-11	1986-12-11 00:00:00	1986-12-25	1986-12-25 00:00:00	32020		\N	222892	0	370247008	4156265		0
46293	2758	4112343	1959-04-10	1959-04-10 00:00:00	1959-04-19	1959-04-19 00:00:00	32020		\N	182477	0	195662009	4112343		0
46407	2765	80180	1974-06-26	1974-06-26 00:00:00	\N	\N	32020		\N	182940	0	396275006	80180		0
46524	2770	4029498	1945-03-31	1945-03-31 00:00:00	\N	\N	32020		\N	183302	0	128613002	4029498		0
46753	2781	81151	1988-10-12	1988-10-12 00:00:00	1988-10-26	1988-10-26 00:00:00	32020		\N	184329	0	44465007	81151		0
46909	2790	4112343	1983-05-28	1983-05-28 00:00:00	1983-06-10	1983-06-10 00:00:00	32020		\N	184869	0	195662009	4112343		0
47131	2802	40481087	1964-11-23	1964-11-23 00:00:00	1964-12-07	1964-12-07 00:00:00	32020		\N	185740	0	444814009	40481087		0
47290	2813	40481087	2011-05-18	2011-05-18 00:00:00	2011-06-01	2011-06-01 00:00:00	32020		\N	186410	0	444814009	40481087		0
47429	2821	4112343	1921-08-28	1921-08-28 00:00:00	1921-09-10	1921-09-10 00:00:00	32020		\N	186946	0	195662009	4112343		0
47591	2829	80180	1988-01-13	1988-01-13 00:00:00	\N	\N	32020		\N	187624	0	396275006	80180		0
47683	2834	4027663	1964-04-17	1964-04-17 00:00:00	\N	\N	32020		\N	188137	0	13200003	4027663		0
47877	2843	439777	2005-07-26	2005-07-26 00:00:00	\N	\N	32020		\N	188762	0	271737000	439777		0
58631	3477	4112343	2000-05-23	2000-05-23 00:00:00	2000-05-31	2000-05-31 00:00:00	32020		\N	230677	0	195662009	4112343		0
48179	2858	4283893	2017-02-19	2017-02-19 00:00:00	2017-08-14	2017-08-14 00:00:00	32020		\N	189959	0	36971009	4283893		0
48336	2864	78272	1951-08-22	1951-08-22 00:00:00	1951-09-19	1951-09-19 00:00:00	32020		\N	190560	0	70704007	78272		0
59289	3516	40479422	2017-03-08	2017-03-08 00:00:00	2017-05-14	2017-05-14 00:00:00	32020		\N	233369	0	444448004	40479422		0
48892	2895	372328	1962-04-16	1962-04-16 00:00:00	1963-02-24	1963-02-24 00:00:00	32020		\N	192722	0	65363002	372328		0
49135	2906	257012	1993-03-02	1993-03-02 00:00:00	\N	\N	32020		\N	193693	0	40055000	257012		0
59778	3542	40481087	2016-01-10	2016-01-10 00:00:00	2016-01-24	2016-01-24 00:00:00	32020		\N	235266	0	444814009	40481087		0
49467	2926	260139	1990-10-12	1990-10-12 00:00:00	1990-10-26	1990-10-26 00:00:00	32020		\N	195155	0	10509002	260139		0
49613	2935	81151	2004-02-08	2004-02-08 00:00:00	2004-02-22	2004-02-22 00:00:00	32020		\N	195681	0	44465007	81151		0
49783	2944	4218389	1970-11-09	1970-11-09 00:00:00	1970-11-30	1970-11-30 00:00:00	32020		\N	196393	0	39848009	4218389		0
49811	2945	372328	1998-06-26	1998-06-26 00:00:00	1998-08-04	1998-08-04 00:00:00	32020		\N	196529	0	65363002	372328		0
50092	2959	4084167	1977-09-17	1977-09-17 00:00:00	1977-09-17	1977-09-17 00:00:00	32020		\N	197603	0	241929008	4084167		0
50185	2965	40481087	1987-01-04	1987-01-04 00:00:00	1987-01-11	1987-01-11 00:00:00	32020		\N	197922	0	444814009	40481087		0
50444	2985	40481087	2001-06-19	2001-06-19 00:00:00	2001-07-10	2001-07-10 00:00:00	32020		\N	199215	0	444814009	40481087		0
50567	2991	4156265	1984-04-27	1984-04-27 00:00:00	1984-05-11	1984-05-11 00:00:00	32020		\N	199628	0	370247008	4156265		0
50736	3001	375671	1949-03-09	1949-03-09 00:00:00	1949-05-08	1949-05-08 00:00:00	32020		\N	200325	0	62564004	375671		0
50887	3010	78272	1972-07-31	1972-07-31 00:00:00	1972-08-28	1972-08-28 00:00:00	32020		\N	200796	0	70704007	78272		0
50991	3017	4283893	1973-12-08	1973-12-08 00:00:00	1974-02-16	1974-02-16 00:00:00	32020		\N	201211	0	36971009	4283893		0
61798	3650	81893	1962-12-18	1962-12-18 00:00:00	\N	\N	32020		\N	242991	0	64766004	81893		0
51397	3049	321042	1991-07-12	1991-07-12 00:00:00	\N	\N	32020		\N	202875	0	410429000	321042		0
51550	3059	260139	1978-01-09	1978-01-09 00:00:00	1978-01-16	1978-01-16 00:00:00	32020		\N	203473	0	10509002	260139		0
62261	3676	40481087	1986-04-28	1986-04-28 00:00:00	1986-05-12	1986-05-12 00:00:00	32020		\N	244509	0	444814009	40481087		0
51914	3077	4112343	1983-02-10	1983-02-10 00:00:00	1983-02-23	1983-02-23 00:00:00	32020		\N	204767	0	195662009	4112343		0
52056	3083	4112343	1972-06-18	1972-06-18 00:00:00	1972-06-26	1972-06-26 00:00:00	32020		\N	205325	0	195662009	4112343		0
52242	3092	30753	1993-10-05	1993-10-05 00:00:00	\N	\N	32020		\N	205837	0	16761005	30753		0
52334	3098	78272	1994-07-15	1994-07-15 00:00:00	1994-08-19	1994-08-19 00:00:00	32020		\N	206193	0	70704007	78272		0
63163	3731	80180	2008-03-03	2008-03-03 00:00:00	\N	\N	32020		\N	247887	0	396275006	80180		0
63277	3736	372328	1954-03-05	1954-03-05 00:00:00	1954-05-12	1954-05-12 00:00:00	32020		\N	248331	0	65363002	372328		0
63428	3746	40481087	1989-09-22	1989-09-22 00:00:00	1989-10-06	1989-10-06 00:00:00	32020		\N	249042	0	444814009	40481087		0
63620	3756	261325	2003-04-26	2003-04-26 00:00:00	\N	\N	32020		\N	249689	0	87433001	261325		0
42623	2541	4112343	2000-06-05	2000-06-05 00:00:00	2000-06-18	2000-06-18 00:00:00	32020		\N	168044	0	195662009	4112343		0
53316	3159	4237458	1970-06-27	1970-06-27 00:00:00	1970-07-27	1970-07-27 00:00:00	32020		\N	210080	0	58150001	4237458		0
42989	2559	40481087	2008-12-15	2008-12-15 00:00:00	2008-12-29	2008-12-29 00:00:00	32020		\N	169569	0	444814009	40481087		0
43114	2567	80180	2014-02-01	2014-02-01 00:00:00	\N	\N	32020		\N	170091	0	396275006	80180		0
43208	2572	30753	2009-04-05	2009-04-05 00:00:00	\N	\N	32020		\N	170401	0	16761005	30753		0
43488	2591	40481087	1975-07-16	1975-07-16 00:00:00	1975-07-30	1975-07-30 00:00:00	32020		\N	171495	0	444814009	40481087		0
43546	2594	372328	1975-07-26	1975-07-26 00:00:00	1975-11-05	1975-11-05 00:00:00	32020		\N	171716	0	65363002	372328		0
43749	2604	40481087	2013-04-30	2013-04-30 00:00:00	2013-05-07	2013-05-07 00:00:00	32020		\N	172257	0	444814009	40481087		0
43909	2615	40481087	1992-06-09	1992-06-09 00:00:00	1992-06-30	1992-06-30 00:00:00	32020		\N	172853	0	444814009	40481087		0
44106	2622	4310024	1973-09-23	1973-09-23 00:00:00	\N	\N	32020		\N	173453	0	424802006	4310024		0
44258	2631	4027663	1981-05-05	1981-05-05 00:00:00	\N	\N	32020		\N	174042	0	13200003	4027663		0
54969	3253	28060	1972-04-09	1972-04-09 00:00:00	1972-04-22	1972-04-22 00:00:00	32020		\N	216329	0	43878008	28060		0
55141	3263	80180	1985-01-27	1985-01-27 00:00:00	\N	\N	32020		\N	216882	0	396275006	80180		0
44771	2663	4112343	2004-08-26	2004-08-26 00:00:00	2004-09-07	2004-09-07 00:00:00	32020		\N	176453	0	195662009	4112343		0
44940	2674	375671	2008-12-16	2008-12-16 00:00:00	2009-01-15	2009-01-15 00:00:00	32020		\N	177230	0	62564004	375671		0
45151	2685	260139	1967-12-17	1967-12-17 00:00:00	1967-12-31	1967-12-31 00:00:00	32020		\N	177955	0	10509002	260139		0
45182	2686	260139	2005-07-09	2005-07-09 00:00:00	2005-07-23	2005-07-23 00:00:00	32020		\N	177997	0	10509002	260139		0
55963	3313	40481087	1986-10-08	1986-10-08 00:00:00	1986-10-15	1986-10-15 00:00:00	32020		\N	219987	0	444814009	40481087		0
45600	2709	260139	2013-10-12	2013-10-12 00:00:00	2013-10-26	2013-10-26 00:00:00	32020		\N	179465	0	10509002	260139		0
45796	2724	28060	1994-12-30	1994-12-30 00:00:00	1995-01-07	1995-01-07 00:00:00	32020		\N	180443	0	43878008	28060		0
45903	2732	40481087	1988-10-28	1988-10-28 00:00:00	1988-11-11	1988-11-11 00:00:00	32020		\N	180878	0	444814009	40481087		0
56683	3362	4109685	2013-11-22	2013-11-22 00:00:00	2013-12-13	2013-12-13 00:00:00	32020		\N	222896	0	284551006	4109685		0
46294	2758	40481087	1994-11-12	1994-11-12 00:00:00	1994-11-19	1994-11-19 00:00:00	32020		\N	182437	0	444814009	40481087		0
46408	2765	40481087	1956-09-25	1956-09-25 00:00:00	1956-10-09	1956-10-09 00:00:00	32020		\N	182876	0	444814009	40481087		0
46526	2770	378001	2007-07-22	2007-07-22 00:00:00	2007-08-21	2007-08-21 00:00:00	32020		\N	183306	0	62106007	378001		0
46754	2781	4294548	1989-04-22	1989-04-22 00:00:00	1989-05-06	1989-05-06 00:00:00	32020		\N	184314	0	75498004	4294548		0
46910	2790	80180	1985-08-30	1985-08-30 00:00:00	\N	\N	32020		\N	184873	0	396275006	80180		0
47132	2802	4112343	1955-06-07	1955-06-07 00:00:00	1955-06-17	1955-06-17 00:00:00	32020		\N	185737	0	195662009	4112343		0
47291	2813	4294548	2014-12-21	2014-12-21 00:00:00	2015-03-08	2015-03-08 00:00:00	32020		\N	186382	0	75498004	4294548		0
47430	2821	260139	2003-11-13	2003-11-13 00:00:00	2003-11-20	2003-11-20 00:00:00	32020		\N	186933	0	10509002	260139		0
47592	2829	260139	1992-10-18	1992-10-18 00:00:00	1992-11-01	1992-11-01 00:00:00	32020		\N	187634	0	10509002	260139		0
47685	2834	40481087	1976-08-15	1976-08-15 00:00:00	1976-08-29	1976-08-29 00:00:00	32020		\N	188191	0	444814009	40481087		0
47878	2843	260139	1998-01-06	1998-01-06 00:00:00	1998-01-13	1998-01-13 00:00:00	32020		\N	188791	0	10509002	260139		0
58632	3477	40481087	1961-06-05	1961-06-05 00:00:00	1961-06-26	1961-06-26 00:00:00	32020		\N	230647	0	444814009	40481087		0
48180	2858	4278672	1925-09-29	1925-09-29 00:00:00	1925-10-29	1925-10-29 00:00:00	32020		\N	189898	0	65966004	4278672		0
48337	2864	195588	1961-04-21	1961-04-21 00:00:00	1961-06-14	1961-06-14 00:00:00	32020		\N	190496	0	38822007	195588		0
59143	3509	40481087	2016-03-12	2016-03-12 00:00:00	2016-03-26	2016-03-26 00:00:00	32020		\N	232785	0	444814009	40481087		0
59290	3516	40481087	1982-11-04	1982-11-04 00:00:00	1982-11-18	1982-11-18 00:00:00	32020		\N	233297	0	444814009	40481087		0
48893	2895	260139	1959-12-13	1959-12-13 00:00:00	1959-12-20	1959-12-20 00:00:00	32020		\N	192736	0	10509002	260139		0
49136	2906	4146173	1929-01-16	1929-01-16 00:00:00	1929-03-24	1929-03-24 00:00:00	32020		\N	193743	0	307731004	4146173		0
59779	3542	4294548	1994-12-12	1994-12-12 00:00:00	1994-12-26	1994-12-26 00:00:00	32020		\N	235260	0	75498004	4294548		0
49468	2926	4112343	1992-08-25	1992-08-25 00:00:00	1992-09-05	1992-09-05 00:00:00	32020		\N	195190	0	195662009	4112343		0
49614	2935	40481087	2007-10-14	2007-10-14 00:00:00	2007-10-28	2007-10-28 00:00:00	32020		\N	195692	0	444814009	40481087		0
49784	2944	40481087	1962-04-27	1962-04-27 00:00:00	1962-05-04	1962-05-04 00:00:00	32020		\N	196379	0	444814009	40481087		0
49812	2945	40481087	1979-03-05	1979-03-05 00:00:00	1979-03-19	1979-03-19 00:00:00	32020		\N	196524	0	444814009	40481087		0
50093	2959	260139	1977-08-19	1977-08-19 00:00:00	1977-08-26	1977-08-26 00:00:00	32020		\N	197470	0	10509002	260139		0
50186	2965	40481087	1990-05-01	1990-05-01 00:00:00	1990-05-08	1990-05-08 00:00:00	32020		\N	197912	0	444814009	40481087		0
50445	2985	4156265	1979-08-26	1979-08-26 00:00:00	1979-09-16	1979-09-16 00:00:00	32020		\N	199187	0	370247008	4156265		0
50568	2991	4112343	1980-07-20	1980-07-20 00:00:00	1980-07-30	1980-07-30 00:00:00	32020		\N	199622	0	195662009	4112343		0
50737	3001	40481087	2016-11-25	2016-11-25 00:00:00	2016-12-09	2016-12-09 00:00:00	32020		\N	200317	0	444814009	40481087		0
50888	3011	4112343	1980-01-10	1980-01-10 00:00:00	1980-01-20	1980-01-20 00:00:00	32020		\N	200822	0	195662009	4112343		0
50992	3017	4112343	2005-05-05	2005-05-05 00:00:00	2005-05-15	2005-05-15 00:00:00	32020		\N	201230	0	195662009	4112343		0
61799	3650	260139	2013-12-17	2013-12-17 00:00:00	2013-12-31	2013-12-31 00:00:00	32020		\N	242995	0	10509002	260139		0
51399	3049	4112343	1998-03-31	1998-03-31 00:00:00	1998-04-07	1998-04-07 00:00:00	32020		\N	202889	0	195662009	4112343		0
51551	3059	378001	1989-08-28	1989-08-28 00:00:00	1989-09-27	1989-09-27 00:00:00	32020		\N	203533	0	62106007	378001		0
62265	3678	4112343	2004-04-08	2004-04-08 00:00:00	2004-04-15	2004-04-15 00:00:00	32020		\N	244583	0	195662009	4112343		0
51915	3077	78272	1978-02-12	1978-02-12 00:00:00	1978-02-26	1978-02-26 00:00:00	32020		\N	204721	0	70704007	78272		0
52057	3083	4112343	1988-10-14	1988-10-14 00:00:00	1988-10-25	1988-10-25 00:00:00	32020		\N	205323	0	195662009	4112343		0
52243	3092	4109685	2011-07-31	2011-07-31 00:00:00	2011-08-21	2011-08-21 00:00:00	32020		\N	205841	0	284551006	4109685		0
52335	3098	260139	1973-12-04	1973-12-04 00:00:00	1973-12-18	1973-12-18 00:00:00	32020		\N	206148	0	10509002	260139		0
63164	3731	40481087	2006-03-13	2006-03-13 00:00:00	2006-03-27	2006-03-27 00:00:00	32020		\N	247887	0	444814009	40481087		0
63278	3736	4112343	1967-09-16	1967-09-16 00:00:00	1967-09-26	1967-09-26 00:00:00	32020		\N	248347	0	195662009	4112343		0
63429	3746	40481087	1980-10-28	1980-10-28 00:00:00	1980-11-11	1980-11-11 00:00:00	32020		\N	248978	0	444814009	40481087		0
63621	3756	4237458	1950-07-02	1950-07-02 00:00:00	1950-08-01	1950-08-01 00:00:00	32020		\N	249710	0	58150001	4237458		0
42624	2541	40481087	2017-05-08	2017-05-08 00:00:00	2017-05-29	2017-05-29 00:00:00	32020		\N	168062	0	444814009	40481087		0
53317	3159	372328	1959-10-23	1959-10-23 00:00:00	1959-12-03	1959-12-03 00:00:00	32020		\N	210094	0	65363002	372328		0
42990	2559	260139	1986-03-13	1986-03-13 00:00:00	1986-03-20	1986-03-20 00:00:00	32020		\N	169594	0	10509002	260139		0
43115	2567	260139	1986-10-24	1986-10-24 00:00:00	1986-10-31	1986-10-31 00:00:00	32020		\N	170082	0	10509002	260139		0
43209	2572	4285898	2009-06-04	2009-06-04 00:00:00	\N	\N	32020		\N	170401	0	68496003	4285898		0
43489	2591	4146173	1944-06-29	1944-06-29 00:00:00	1944-07-29	1944-07-29 00:00:00	32020		\N	171515	0	307731004	4146173		0
43547	2594	4112343	1979-07-29	1979-07-29 00:00:00	1979-08-09	1979-08-09 00:00:00	32020		\N	171680	0	195662009	4112343		0
43750	2604	4218389	1973-01-24	1973-01-24 00:00:00	1973-02-28	1973-02-28 00:00:00	32020		\N	172312	0	39848009	4218389		0
43910	2615	4027663	1975-11-09	1975-11-09 00:00:00	\N	\N	32020		\N	172865	0	13200003	4027663		0
44107	2622	4113008	1964-07-12	1964-07-12 00:00:00	1964-08-02	1964-08-02 00:00:00	32020		\N	173408	0	284549007	4113008		0
44259	2631	260139	1963-04-12	1963-04-12 00:00:00	1963-04-19	1963-04-19 00:00:00	32020		\N	174051	0	10509002	260139		0
54970	3253	4237458	1980-04-26	1980-04-26 00:00:00	1980-05-26	1980-05-26 00:00:00	32020		\N	216242	0	58150001	4237458		0
55142	3263	4112343	1947-09-10	1947-09-10 00:00:00	1947-09-21	1947-09-21 00:00:00	32020		\N	216874	0	195662009	4112343		0
44772	2663	40481087	1998-03-23	1998-03-23 00:00:00	1998-03-30	1998-03-30 00:00:00	32020		\N	176484	0	444814009	40481087		0
44941	2674	4155034	1996-08-09	1996-08-09 00:00:00	1996-08-23	1996-08-23 00:00:00	32020		\N	177218	0	283371005	4155034		0
45152	2685	40481087	2012-05-07	2012-05-07 00:00:00	2012-05-14	2012-05-14 00:00:00	32020		\N	177966	0	444814009	40481087		0
45183	2686	40481087	1999-10-01	1999-10-01 00:00:00	1999-10-22	1999-10-22 00:00:00	32020		\N	177996	0	444814009	40481087		0
55964	3313	28060	1958-02-18	1958-02-18 00:00:00	1958-02-27	1958-02-27 00:00:00	32020		\N	219976	0	43878008	28060		0
45601	2709	81151	1942-12-20	1942-12-20 00:00:00	1943-01-17	1943-01-17 00:00:00	32020		\N	179446	0	44465007	81151		0
45797	2724	81151	1962-09-13	1962-09-13 00:00:00	1962-10-04	1962-10-04 00:00:00	32020		\N	180434	0	44465007	81151		0
45904	2732	40481087	2016-01-02	2016-01-02 00:00:00	2016-01-16	2016-01-16 00:00:00	32020		\N	180863	0	444814009	40481087		0
56684	3362	40481087	1995-07-12	1995-07-12 00:00:00	1995-07-26	1995-07-26 00:00:00	32020		\N	222899	0	444814009	40481087		0
46295	2758	372328	1942-07-06	1942-07-06 00:00:00	1942-08-07	1942-08-07 00:00:00	32020		\N	182439	0	65363002	372328		0
46409	2765	4280726	1939-05-28	1939-05-28 00:00:00	1953-05-26	1953-05-26 00:00:00	32020		\N	182906	0	367498001	4280726		0
46527	2770	4112343	1953-07-08	1953-07-08 00:00:00	1953-07-18	1953-07-18 00:00:00	32020		\N	183398	0	195662009	4112343		0
46755	2781	28060	1990-04-22	1990-04-22 00:00:00	1990-04-30	1990-04-30 00:00:00	32020		\N	184297	0	43878008	28060		0
46911	2790	81151	1984-12-01	1984-12-01 00:00:00	1985-01-05	1985-01-05 00:00:00	32020		\N	184873	0	44465007	81151		0
47133	2802	28060	1940-10-02	1940-10-02 00:00:00	1940-10-11	1940-10-11 00:00:00	32020		\N	185704	0	43878008	28060		0
47292	2813	40481087	1997-09-01	1997-09-01 00:00:00	1997-09-22	1997-09-22 00:00:00	32020		\N	186380	0	444814009	40481087		0
47431	2821	4155034	1962-01-04	1962-01-04 00:00:00	1962-01-18	1962-01-18 00:00:00	32020		\N	186851	0	283371005	4155034		0
47593	2829	440086	1958-09-02	1958-09-02 00:00:00	1968-09-09	1968-09-09 00:00:00	32020		\N	187630	0	192127007	440086		0
47686	2834	372328	1941-10-17	1941-10-17 00:00:00	1942-04-04	1942-04-04 00:00:00	32020		\N	188127	0	65363002	372328		0
47879	2843	260139	1960-02-29	1960-02-29 00:00:00	1960-03-07	1960-03-07 00:00:00	32020		\N	188730	0	10509002	260139		0
58633	3477	4218389	1995-11-25	1995-11-25 00:00:00	1995-12-23	1995-12-23 00:00:00	32020		\N	230721	0	39848009	4218389		0
48181	2858	260139	2010-05-30	2010-05-30 00:00:00	2010-06-13	2010-06-13 00:00:00	32020		\N	189958	0	10509002	260139		0
48338	2864	40481087	1995-09-14	1995-09-14 00:00:00	1995-09-21	1995-09-21 00:00:00	32020		\N	190513	0	444814009	40481087		0
59144	3509	40481087	1956-04-16	1956-04-16 00:00:00	1956-04-30	1956-04-30 00:00:00	32020		\N	232737	0	444814009	40481087		0
59291	3516	80180	1978-04-09	1978-04-09 00:00:00	\N	\N	32020		\N	233379	0	396275006	80180		0
48894	2895	40481087	1994-05-10	1994-05-10 00:00:00	1994-05-31	1994-05-31 00:00:00	32020		\N	192721	0	444814009	40481087		0
59595	3532	4278672	1977-07-05	1977-07-05 00:00:00	1977-10-03	1977-10-03 00:00:00	32020		\N	234628	0	65966004	4278672		0
59780	3542	40481087	1993-02-08	1993-02-08 00:00:00	1993-02-15	1993-02-15 00:00:00	32020		\N	235259	0	444814009	40481087		0
59927	3550	372328	1986-05-12	1986-05-12 00:00:00	1986-06-28	1986-06-28 00:00:00	32020		\N	235730	0	65363002	372328		0
49615	2935	40481087	2000-12-22	2000-12-22 00:00:00	2001-01-12	2001-01-12 00:00:00	32020		\N	195691	0	444814009	40481087		0
49785	2944	4112343	2000-01-03	2000-01-03 00:00:00	2000-01-13	2000-01-13 00:00:00	32020		\N	196422	0	195662009	4112343		0
49813	2945	80180	1981-11-25	1981-11-25 00:00:00	\N	\N	32020		\N	196474	0	396275006	80180		0
50094	2959	4059173	1975-03-31	1975-03-31 00:00:00	1975-06-29	1975-06-29 00:00:00	32020		\N	197602	0	16114001	4059173		0
50187	2965	40481087	1976-11-15	1976-11-15 00:00:00	1976-11-22	1976-11-22 00:00:00	32020		\N	197920	0	444814009	40481087		0
50446	2985	372328	1968-07-19	1968-07-19 00:00:00	1968-09-28	1968-09-28 00:00:00	32020		\N	199212	0	65363002	372328		0
50569	2991	40481087	2016-06-22	2016-06-22 00:00:00	2016-07-13	2016-07-13 00:00:00	32020		\N	199670	0	444814009	40481087		0
50738	3001	4112343	2019-02-21	2019-02-21 00:00:00	2019-03-03	2019-03-03 00:00:00	32020		\N	200241	0	195662009	4112343		0
50889	3011	81151	1978-01-19	1978-01-19 00:00:00	1978-02-02	1978-02-02 00:00:00	32020		\N	200801	0	44465007	81151		0
54081	3201	30753	1975-06-01	1975-06-01 00:00:00	\N	\N	32020		\N	212913	0	16761005	30753		0
50996	3019	4218389	2000-10-28	2000-10-28 00:00:00	2000-12-02	2000-12-02 00:00:00	32020		\N	201348	0	39848009	4218389		0
61800	3650	260139	1992-02-28	1992-02-28 00:00:00	1992-03-13	1992-03-13 00:00:00	32020		\N	242944	0	10509002	260139		0
51400	3049	317576	1980-03-28	1980-03-28 00:00:00	\N	\N	32020		\N	202861	0	53741008	317576		0
51552	3059	257012	1989-10-31	1989-10-31 00:00:00	\N	\N	32020		\N	203504	0	40055000	257012		0
62266	3678	4059173	2009-10-30	2009-10-30 00:00:00	2009-11-29	2009-11-29 00:00:00	32020		\N	244602	0	16114001	4059173		0
51916	3077	192671	1992-05-08	1992-05-08 00:00:00	\N	\N	32020		\N	204715	0	K92.2	35208414		0
52058	3083	40481087	1957-01-03	1957-01-03 00:00:00	1957-01-17	1957-01-17 00:00:00	32020		\N	205260	0	444814009	40481087		0
52244	3092	40481087	2004-08-11	2004-08-11 00:00:00	2004-09-01	2004-09-01 00:00:00	32020		\N	205842	0	444814009	40481087		0
52336	3098	260139	2012-02-09	2012-02-09 00:00:00	2012-02-23	2012-02-23 00:00:00	32020		\N	206198	0	10509002	260139		0
63165	3731	372328	1990-01-09	1990-01-09 00:00:00	1990-02-10	1990-02-10 00:00:00	32020		\N	247921	0	65363002	372328		0
63279	3736	4112343	1986-12-01	1986-12-01 00:00:00	1986-12-08	1986-12-08 00:00:00	32020		\N	248260	0	195662009	4112343		0
63430	3746	40481087	2005-10-17	2005-10-17 00:00:00	2005-11-07	2005-11-07 00:00:00	32020		\N	249032	0	444814009	40481087		0
63622	3756	260139	1943-11-07	1943-11-07 00:00:00	1943-11-21	1943-11-21 00:00:00	32020		\N	249608	0	10509002	260139		0
42625	2541	4112343	2014-05-08	2014-05-08 00:00:00	2014-05-20	2014-05-20 00:00:00	32020		\N	168054	0	195662009	4112343		0
53318	3159	4116491	2014-06-11	2014-06-11 00:00:00	2014-07-12	2014-07-12 00:00:00	32020		\N	210027	0	301011002	4116491		0
42991	2559	80180	1990-03-29	1990-03-29 00:00:00	\N	\N	32020		\N	169527	0	396275006	80180		0
43116	2567	4112343	2018-07-09	2018-07-09 00:00:00	2018-07-16	2018-07-16 00:00:00	32020		\N	170079	0	195662009	4112343		0
43210	2572	80180	2009-07-04	2009-07-04 00:00:00	\N	\N	32020		\N	170401	0	396275006	80180		0
43490	2591	4155034	1943-06-14	1943-06-14 00:00:00	1943-07-05	1943-07-05 00:00:00	32020		\N	171449	0	283371005	4155034		0
43548	2594	260139	1993-07-03	1993-07-03 00:00:00	1993-07-10	1993-07-10 00:00:00	32020		\N	171700	0	10509002	260139		0
43751	2604	40481087	1965-02-21	1965-02-21 00:00:00	1965-02-28	1965-02-28 00:00:00	32020		\N	172275	0	444814009	40481087		0
43911	2615	40481087	2015-10-03	2015-10-03 00:00:00	2015-10-17	2015-10-17 00:00:00	32020		\N	172930	0	444814009	40481087		0
44108	2622	4112343	1971-02-08	1971-02-08 00:00:00	1971-02-19	1971-02-19 00:00:00	32020		\N	173475	0	195662009	4112343		0
44260	2631	40481087	1983-08-23	1983-08-23 00:00:00	1983-08-30	1983-08-30 00:00:00	32020		\N	174081	0	444814009	40481087		0
54971	3253	80180	2005-12-31	2005-12-31 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
55143	3263	40481087	1973-05-28	1973-05-28 00:00:00	1973-06-04	1973-06-04 00:00:00	32020		\N	216877	0	444814009	40481087		0
44773	2663	4142905	1972-03-17	1972-03-17 00:00:00	1972-05-16	1972-05-16 00:00:00	32020		\N	176439	0	33737001	4142905		0
44942	2674	81893	2011-11-09	2011-11-09 00:00:00	\N	\N	32020		\N	177192	0	64766004	81893		0
55611	3293	4285898	1950-03-27	1950-03-27 00:00:00	\N	\N	32020		\N	218672	0	68496003	4285898		0
45184	2686	4278672	1994-03-20	1994-03-20 00:00:00	1994-06-18	1994-06-18 00:00:00	32020		\N	178072	0	65966004	4278672		0
55965	3314	28060	1989-06-24	1989-06-24 00:00:00	1989-07-07	1989-07-07 00:00:00	32020		\N	220077	0	43878008	28060		0
45602	2709	80180	1984-01-14	1984-01-14 00:00:00	\N	\N	32020		\N	179546	0	396275006	80180		0
45798	2724	4112343	1961-07-13	1961-07-13 00:00:00	1961-07-26	1961-07-26 00:00:00	32020		\N	180513	0	195662009	4112343		0
45905	2732	40481087	2008-07-23	2008-07-23 00:00:00	2008-08-06	2008-08-06 00:00:00	32020		\N	180862	0	444814009	40481087		0
56685	3362	80180	1996-05-31	1996-05-31 00:00:00	\N	\N	32020		\N	222899	0	396275006	80180		0
46296	2758	4294548	1952-11-13	1952-11-13 00:00:00	1953-09-24	1953-09-24 00:00:00	32020		\N	182431	0	75498004	4294548		0
46410	2765	372328	1938-04-24	1938-04-24 00:00:00	1939-05-02	1939-05-02 00:00:00	32020		\N	182950	0	65363002	372328		0
46528	2770	4294548	1978-09-25	1978-09-25 00:00:00	1978-11-13	1978-11-13 00:00:00	32020		\N	183390	0	75498004	4294548		0
46756	2781	80180	2016-12-29	2016-12-29 00:00:00	\N	\N	32020		\N	184320	0	396275006	80180		0
46912	2790	4278672	1973-07-02	1973-07-02 00:00:00	1973-08-01	1973-08-01 00:00:00	32020		\N	184872	0	65966004	4278672		0
47134	2802	372328	1952-08-06	1952-08-06 00:00:00	1952-10-18	1952-10-18 00:00:00	32020		\N	185760	0	65363002	372328		0
47293	2813	372328	1937-09-09	1937-09-09 00:00:00	1937-12-31	1937-12-31 00:00:00	32020		\N	186412	0	65363002	372328		0
47432	2821	4152936	1977-11-25	1977-11-25 00:00:00	1977-12-09	1977-12-09 00:00:00	32020		\N	186852	0	283385000	4152936		0
47594	2829	40481087	1958-08-02	1958-08-02 00:00:00	1958-08-09	1958-08-09 00:00:00	32020		\N	187656	0	444814009	40481087		0
47687	2834	4112343	1999-10-11	1999-10-11 00:00:00	1999-10-21	1999-10-21 00:00:00	32020		\N	188125	0	195662009	4112343		0
47880	2843	40481087	1990-05-08	1990-05-08 00:00:00	1990-05-22	1990-05-22 00:00:00	32020		\N	188778	0	444814009	40481087		0
58634	3477	40481087	1993-06-28	1993-06-28 00:00:00	1993-07-05	1993-07-05 00:00:00	32020		\N	230710	0	444814009	40481087		0
48182	2858	317576	2014-07-09	2014-07-09 00:00:00	\N	\N	32020		\N	189870	0	53741008	317576		0
48339	2864	40481087	1999-05-11	1999-05-11 00:00:00	1999-05-18	1999-05-18 00:00:00	32020		\N	190540	0	444814009	40481087		0
59145	3509	40481087	2011-06-18	2011-06-18 00:00:00	2011-07-09	2011-07-09 00:00:00	32020		\N	232784	0	444814009	40481087		0
59292	3516	4230399	1981-12-12	1981-12-12 00:00:00	1982-02-10	1982-02-10 00:00:00	32020		\N	233367	0	359817006	4230399		0
48895	2895	134438	1985-12-22	1985-12-22 00:00:00	1987-03-22	1987-03-22 00:00:00	32020		\N	192714	0	40275004	134438		0
59596	3532	4112343	2017-02-12	2017-02-12 00:00:00	2017-02-23	2017-02-23 00:00:00	32020		\N	234593	0	195662009	4112343		0
59781	3542	372328	1938-03-29	1938-03-29 00:00:00	1938-06-11	1938-06-11 00:00:00	32020		\N	235237	0	65363002	372328		0
59928	3550	40481087	1986-08-16	1986-08-16 00:00:00	1986-09-06	1986-09-06 00:00:00	32020		\N	235712	0	444814009	40481087		0
49616	2935	4134304	1981-01-11	1981-01-11 00:00:00	1981-03-12	1981-03-12 00:00:00	32020		\N	195677	0	263102004	4134304		0
49786	2944	260139	1965-12-01	1965-12-01 00:00:00	1965-12-15	1965-12-15 00:00:00	32020		\N	196426	0	10509002	260139		0
49814	2945	40481087	1988-10-02	1988-10-02 00:00:00	1988-10-23	1988-10-23 00:00:00	32020		\N	196545	0	444814009	40481087		0
50095	2960	4112343	1982-01-31	1982-01-31 00:00:00	1982-02-08	1982-02-08 00:00:00	32020		\N	197664	0	195662009	4112343		0
50188	2965	4142905	1971-02-18	1971-02-18 00:00:00	1971-04-19	1971-04-19 00:00:00	32020		\N	197983	0	33737001	4142905		0
50447	2985	260139	1994-12-03	1994-12-03 00:00:00	1994-12-17	1994-12-17 00:00:00	32020		\N	199208	0	10509002	260139		0
50570	2991	40481087	1993-02-10	1993-02-10 00:00:00	1993-03-03	1993-03-03 00:00:00	32020		\N	199669	0	444814009	40481087		0
50739	3001	4112343	1969-04-23	1969-04-23 00:00:00	1969-05-02	1969-05-02 00:00:00	32020		\N	200237	0	195662009	4112343		0
50890	3011	40481087	1980-02-29	1980-02-29 00:00:00	1980-03-07	1980-03-07 00:00:00	32020		\N	200851	0	444814009	40481087		0
50997	3019	40481087	1978-03-09	1978-03-09 00:00:00	1978-03-30	1978-03-30 00:00:00	32020		\N	201332	0	444814009	40481087		0
61801	3650	4218389	1928-05-20	1928-05-20 00:00:00	1928-06-10	1928-06-10 00:00:00	32020		\N	242934	0	39848009	4218389		0
51401	3049	80180	2014-08-02	2014-08-02 00:00:00	\N	\N	32020		\N	202890	0	396275006	80180		0
51553	3059	372328	1972-07-07	1972-07-07 00:00:00	1972-09-24	1972-09-24 00:00:00	32020		\N	203485	0	65363002	372328		0
62267	3678	4142905	2018-03-17	2018-03-17 00:00:00	2018-06-15	2018-06-15 00:00:00	32020		\N	244603	0	33737001	4142905		0
51917	3077	4294548	1972-03-23	1972-03-23 00:00:00	1972-05-04	1972-05-04 00:00:00	32020		\N	204799	0	75498004	4294548		0
52059	3083	195588	1990-04-19	1990-04-19 00:00:00	1990-06-08	1990-06-08 00:00:00	32020		\N	205262	0	38822007	195588		0
52245	3092	40481087	1967-04-01	1967-04-01 00:00:00	1967-04-15	1967-04-15 00:00:00	32020		\N	205883	0	444814009	40481087		0
52337	3098	4112343	1963-08-29	1963-08-29 00:00:00	1963-09-09	1963-09-09 00:00:00	32020		\N	206147	0	195662009	4112343		0
63166	3731	260139	1978-10-28	1978-10-28 00:00:00	1978-11-04	1978-11-04 00:00:00	32020		\N	247913	0	10509002	260139		0
63280	3736	80180	1987-07-20	1987-07-20 00:00:00	\N	\N	32020		\N	248260	0	396275006	80180		0
63431	3746	40481087	1968-03-24	1968-03-24 00:00:00	1968-03-31	1968-03-31 00:00:00	32020		\N	248982	0	444814009	40481087		0
63623	3756	260139	1970-04-07	1970-04-07 00:00:00	1970-04-21	1970-04-21 00:00:00	32020		\N	249679	0	10509002	260139		0
42626	2541	4218389	1991-08-06	1991-08-06 00:00:00	1991-08-27	1991-08-27 00:00:00	32020		\N	168020	0	39848009	4218389		0
53319	3159	4112343	1964-06-30	1964-06-30 00:00:00	1964-07-07	1964-07-07 00:00:00	32020		\N	210036	0	195662009	4112343		0
42992	2559	4112343	1965-10-15	1965-10-15 00:00:00	1965-10-25	1965-10-25 00:00:00	32020		\N	169623	0	195662009	4112343		0
43117	2567	260139	2018-01-10	2018-01-10 00:00:00	2018-01-17	2018-01-17 00:00:00	32020		\N	170078	0	10509002	260139		0
43222	2574	81893	2003-01-18	2003-01-18 00:00:00	\N	\N	32020		\N	170491	0	64766004	81893		0
43491	2591	40481087	1936-09-23	1936-09-23 00:00:00	1936-10-07	1936-10-07 00:00:00	32020		\N	171477	0	444814009	40481087		0
43549	2594	372328	1980-11-08	1980-11-08 00:00:00	1981-03-04	1981-03-04 00:00:00	32020		\N	171683	0	65363002	372328		0
43752	2604	260139	2011-05-19	2011-05-19 00:00:00	2011-05-26	2011-05-26 00:00:00	32020		\N	172316	0	10509002	260139		0
43912	2615	4149245	1987-05-04	1987-05-04 00:00:00	1987-07-10	1987-07-10 00:00:00	32020		\N	172919	0	30832001	4149245		0
44109	2622	4112343	1953-01-30	1953-01-30 00:00:00	1953-02-09	1953-02-09 00:00:00	32020		\N	173426	0	195662009	4112343		0
44261	2631	372328	1955-07-14	1955-07-14 00:00:00	1956-04-22	1956-04-22 00:00:00	32020		\N	174082	0	65363002	372328		0
54972	3253	40481087	1996-10-18	1996-10-18 00:00:00	1996-10-25	1996-10-25 00:00:00	32020		\N	216290	0	444814009	40481087		0
55144	3263	4027663	1975-10-17	1975-10-17 00:00:00	\N	\N	32020		\N	216877	0	13200003	4027663		0
44774	2663	4156265	2018-05-15	2018-05-15 00:00:00	2018-06-05	2018-06-05 00:00:00	32020		\N	176440	0	370247008	4156265		0
44943	2674	4027663	2005-04-14	2005-04-14 00:00:00	\N	\N	32020		\N	177206	0	13200003	4027663		0
55612	3293	260139	1912-08-14	1912-08-14 00:00:00	1912-08-28	1912-08-28 00:00:00	32020		\N	218744	0	10509002	260139		0
45185	2686	28060	2011-03-25	2011-03-25 00:00:00	2011-04-04	2011-04-04 00:00:00	32020		\N	177998	0	43878008	28060		0
55966	3314	4112343	1990-09-04	1990-09-04 00:00:00	1990-09-11	1990-09-11 00:00:00	32020		\N	220119	0	195662009	4112343		0
45603	2709	40481087	1952-04-08	1952-04-08 00:00:00	1952-04-22	1952-04-22 00:00:00	32020		\N	179461	0	444814009	40481087		0
45799	2724	4112343	1983-07-17	1983-07-17 00:00:00	1983-07-27	1983-07-27 00:00:00	32020		\N	180478	0	195662009	4112343		0
45906	2732	260139	1972-07-23	1972-07-23 00:00:00	1972-07-30	1972-07-30 00:00:00	32020		\N	180909	0	10509002	260139		0
56686	3362	81151	1981-09-10	1981-09-10 00:00:00	1981-10-08	1981-10-08 00:00:00	32020		\N	222891	0	44465007	81151		0
46297	2758	40481087	1944-02-17	1944-02-17 00:00:00	1944-02-24	1944-02-24 00:00:00	32020		\N	182387	0	444814009	40481087		0
46411	2765	28060	1956-07-26	1956-07-26 00:00:00	1956-08-03	1956-08-03 00:00:00	32020		\N	182875	0	43878008	28060		0
46529	2770	4059173	2009-10-09	2009-10-09 00:00:00	2009-11-08	2009-11-08 00:00:00	32020		\N	183307	0	16114001	4059173		0
46757	2781	40481087	2016-04-09	2016-04-09 00:00:00	2016-04-30	2016-04-30 00:00:00	32020		\N	184320	0	444814009	40481087		0
46913	2790	78272	1966-07-11	1966-07-11 00:00:00	1966-08-08	1966-08-08 00:00:00	32020		\N	184871	0	70704007	78272		0
47135	2802	372328	1943-02-16	1943-02-16 00:00:00	1943-03-27	1943-03-27 00:00:00	32020		\N	185765	0	65363002	372328		0
47294	2813	260139	1940-05-27	1940-05-27 00:00:00	1940-06-03	1940-06-03 00:00:00	32020		\N	186406	0	10509002	260139		0
47433	2821	255848	2010-06-29	2010-06-29 00:00:00	\N	\N	32020		\N	186958	0	233604007	255848		0
47595	2829	40481087	2018-09-29	2018-09-29 00:00:00	2018-10-13	2018-10-13 00:00:00	32020		\N	187638	0	444814009	40481087		0
47688	2834	4152936	1985-01-12	1985-01-12 00:00:00	1985-02-02	1985-02-02 00:00:00	32020		\N	188164	0	283385000	4152936		0
47881	2843	375671	2010-07-17	2010-07-17 00:00:00	2010-09-15	2010-09-15 00:00:00	32020		\N	188744	0	62564004	375671		0
58635	3477	4027663	1990-03-21	1990-03-21 00:00:00	\N	\N	32020		\N	230715	0	13200003	4027663		0
48183	2858	40481087	1950-03-20	1950-03-20 00:00:00	1950-04-10	1950-04-10 00:00:00	32020		\N	189780	0	444814009	40481087		0
48340	2864	40481087	1956-06-17	1956-06-17 00:00:00	1956-06-24	1956-06-24 00:00:00	32020		\N	190465	0	444814009	40481087		0
59146	3509	81151	1989-12-18	1989-12-18 00:00:00	1990-01-15	1990-01-15 00:00:00	32020		\N	232793	0	44465007	81151		0
59293	3516	4283893	1953-04-23	1953-04-23 00:00:00	1953-06-18	1953-06-18 00:00:00	32020		\N	233320	0	36971009	4283893		0
48896	2895	40481087	1974-10-02	1974-10-02 00:00:00	1974-10-16	1974-10-16 00:00:00	32020		\N	192737	0	444814009	40481087		0
59597	3532	260139	1995-10-31	1995-10-31 00:00:00	1995-11-14	1995-11-14 00:00:00	32020		\N	234598	0	10509002	260139		0
59782	3542	4113008	1993-01-14	1993-01-14 00:00:00	1993-02-04	1993-02-04 00:00:00	32020		\N	235323	0	284549007	4113008		0
59929	3550	28060	1988-07-02	1988-07-02 00:00:00	1988-07-10	1988-07-10 00:00:00	32020		\N	235746	0	43878008	28060		0
49617	2935	4109685	1987-01-10	1987-01-10 00:00:00	1987-01-24	1987-01-24 00:00:00	32020		\N	195679	0	284551006	4109685		0
49787	2944	81151	1969-10-10	1969-10-10 00:00:00	1969-11-14	1969-11-14 00:00:00	32020		\N	196392	0	44465007	81151		0
49815	2945	4112343	1991-02-13	1991-02-13 00:00:00	1991-02-25	1991-02-25 00:00:00	32020		\N	196546	0	195662009	4112343		0
50096	2960	260139	1958-10-16	1958-10-16 00:00:00	1958-10-23	1958-10-23 00:00:00	32020		\N	197662	0	10509002	260139		0
50189	2965	260139	2008-11-28	2008-11-28 00:00:00	2008-12-05	2008-12-05 00:00:00	32020		\N	197900	0	10509002	260139		0
50448	2985	4112343	1978-03-02	1978-03-02 00:00:00	1978-03-14	1978-03-14 00:00:00	32020		\N	199228	0	195662009	4112343		0
50571	2991	4109685	2018-10-01	2018-10-01 00:00:00	2018-10-15	2018-10-15 00:00:00	32020		\N	199630	0	284551006	4109685		0
50740	3001	40481087	1952-11-06	1952-11-06 00:00:00	1952-11-13	1952-11-13 00:00:00	32020		\N	200236	0	444814009	40481087		0
50891	3011	4112343	1975-08-07	1975-08-07 00:00:00	1975-08-18	1975-08-18 00:00:00	32020		\N	200837	0	195662009	4112343		0
50998	3019	372328	1991-08-19	1991-08-19 00:00:00	1992-06-10	1992-06-10 00:00:00	32020		\N	201316	0	65363002	372328		0
61802	3650	381316	2014-07-04	2014-07-04 00:00:00	\N	\N	32020		\N	242920	0	230690007	381316		0
51402	3049	4112343	2013-10-03	2013-10-03 00:00:00	2013-10-12	2013-10-12 00:00:00	32020		\N	202890	0	195662009	4112343		0
51554	3059	4146173	2005-08-04	2005-08-04 00:00:00	2005-10-03	2005-10-03 00:00:00	32020		\N	203495	0	307731004	4146173		0
62268	3678	4027663	2007-11-15	2007-11-15 00:00:00	\N	\N	32020		\N	244598	0	13200003	4027663		0
51918	3077	4134304	1954-06-17	1954-06-17 00:00:00	1954-08-16	1954-08-16 00:00:00	32020		\N	204779	0	263102004	4134304		0
52060	3083	40481087	2010-03-05	2010-03-05 00:00:00	2010-03-12	2010-03-12 00:00:00	32020		\N	205334	0	444814009	40481087		0
52246	3092	4112343	1963-10-17	1963-10-17 00:00:00	1963-10-24	1963-10-24 00:00:00	32020		\N	205864	0	195662009	4112343		0
52338	3100	260139	1990-06-11	1990-06-11 00:00:00	1990-06-18	1990-06-18 00:00:00	32020		\N	206218	0	10509002	260139		0
63167	3731	372328	1974-06-20	1974-06-20 00:00:00	1974-08-31	1974-08-31 00:00:00	32020		\N	247920	0	65363002	372328		0
63281	3736	40481087	2006-05-11	2006-05-11 00:00:00	2006-05-25	2006-05-25 00:00:00	32020		\N	248321	0	444814009	40481087		0
63432	3746	260139	1985-04-14	1985-04-14 00:00:00	1985-04-28	1985-04-28 00:00:00	32020		\N	248980	0	10509002	260139		0
63624	3756	372328	1944-09-09	1944-09-09 00:00:00	1944-11-11	1944-11-11 00:00:00	32020		\N	249613	0	65363002	372328		0
42627	2541	4112343	2017-05-05	2017-05-05 00:00:00	2017-05-18	2017-05-18 00:00:00	32020		\N	168061	0	195662009	4112343		0
53320	3159	40481087	2014-09-27	2014-09-27 00:00:00	2014-10-04	2014-10-04 00:00:00	32020		\N	210077	0	444814009	40481087		0
42993	2559	40481087	2018-02-16	2018-02-16 00:00:00	2018-03-02	2018-03-02 00:00:00	32020		\N	169632	0	444814009	40481087		0
43118	2567	4218389	2018-08-30	2018-08-30 00:00:00	2018-10-04	2018-10-04 00:00:00	32020		\N	170095	0	39848009	4218389		0
43223	2574	30753	2003-08-17	2003-08-17 00:00:00	\N	\N	32020		\N	170491	0	16761005	30753		0
43492	2591	40481087	1952-01-25	1952-01-25 00:00:00	1952-02-15	1952-02-15 00:00:00	32020		\N	171508	0	444814009	40481087		0
43550	2594	40481087	1993-01-26	1993-01-26 00:00:00	1993-02-16	1993-02-16 00:00:00	32020		\N	171713	0	444814009	40481087		0
43753	2604	4112343	1996-10-08	1996-10-08 00:00:00	1996-10-15	1996-10-15 00:00:00	32020		\N	172277	0	195662009	4112343		0
43913	2615	81893	1985-07-04	1985-07-04 00:00:00	\N	\N	32020		\N	172927	0	64766004	81893		0
44110	2622	40481087	1976-03-01	1976-03-01 00:00:00	1976-03-22	1976-03-22 00:00:00	32020		\N	173440	0	444814009	40481087		0
44262	2631	40481087	1973-12-20	1973-12-20 00:00:00	1974-01-03	1974-01-03 00:00:00	32020		\N	174101	0	444814009	40481087		0
54973	3253	4112343	2004-02-16	2004-02-16 00:00:00	2004-02-25	2004-02-25 00:00:00	32020		\N	216368	0	195662009	4112343		0
55145	3263	4059173	2018-01-18	2018-01-18 00:00:00	2018-02-17	2018-02-17 00:00:00	32020		\N	216905	0	16114001	4059173		0
44775	2663	28060	1965-12-21	1965-12-21 00:00:00	1966-01-01	1966-01-01 00:00:00	32020		\N	176476	0	43878008	28060		0
44944	2674	4283893	2003-06-28	2003-06-28 00:00:00	2003-07-26	2003-07-26 00:00:00	32020		\N	177206	0	36971009	4283893		0
55613	3293	257012	1927-03-10	1927-03-10 00:00:00	\N	\N	32020		\N	218659	0	40055000	257012		0
45188	2688	260139	1964-06-12	1964-06-12 00:00:00	1964-06-26	1964-06-26 00:00:00	32020		\N	178091	0	10509002	260139		0
55967	3314	4112343	2016-04-10	2016-04-10 00:00:00	2016-04-22	2016-04-22 00:00:00	32020		\N	220122	0	195662009	4112343		0
45604	2709	28060	2008-03-14	2008-03-14 00:00:00	2008-03-21	2008-03-21 00:00:00	32020		\N	179489	0	43878008	28060		0
45800	2724	40481087	2004-02-12	2004-02-12 00:00:00	2004-02-19	2004-02-19 00:00:00	32020		\N	180479	0	444814009	40481087		0
45938	2736	4112343	1976-05-04	1976-05-04 00:00:00	1976-05-15	1976-05-15 00:00:00	32020		\N	181117	0	195662009	4112343		0
56687	3362	40481087	1971-12-23	1971-12-23 00:00:00	1972-01-13	1972-01-13 00:00:00	32020		\N	222883	0	444814009	40481087		0
46298	2758	4112343	1954-11-16	1954-11-16 00:00:00	1954-11-29	1954-11-29 00:00:00	32020		\N	182434	0	195662009	4112343		0
46412	2765	4112343	2001-02-11	2001-02-11 00:00:00	2001-02-24	2001-02-24 00:00:00	32020		\N	183001	0	195662009	4112343		0
46530	2770	257012	1978-10-16	1978-10-16 00:00:00	\N	\N	32020		\N	183400	0	40055000	257012		0
46758	2781	4027663	2008-03-21	2008-03-21 00:00:00	\N	\N	32020		\N	184302	0	13200003	4027663		0
46914	2790	4112343	1953-05-21	1953-05-21 00:00:00	1953-06-01	1953-06-01 00:00:00	32020		\N	184927	0	195662009	4112343		0
47136	2802	40481087	1961-11-24	1961-11-24 00:00:00	1961-12-01	1961-12-01 00:00:00	32020		\N	185755	0	444814009	40481087		0
47295	2813	4218389	1994-02-17	1994-02-17 00:00:00	1994-03-10	1994-03-10 00:00:00	32020		\N	186416	0	39848009	4218389		0
47434	2821	4294548	1937-01-16	1937-01-16 00:00:00	1937-05-01	1937-05-01 00:00:00	32020		\N	186949	0	75498004	4294548		0
47596	2830	80180	2007-12-22	2007-12-22 00:00:00	\N	\N	32020		\N	187768	0	396275006	80180		0
47689	2834	4112343	1947-08-02	1947-08-02 00:00:00	1947-08-15	1947-08-15 00:00:00	32020		\N	188185	0	195662009	4112343		0
47882	2843	40481087	1999-03-11	1999-03-11 00:00:00	1999-03-25	1999-03-25 00:00:00	32020		\N	188779	0	444814009	40481087		0
58636	3477	4283893	1979-03-16	1979-03-16 00:00:00	1979-06-08	1979-06-08 00:00:00	32020		\N	230713	0	36971009	4283893		0
48184	2858	4112343	1911-12-25	1911-12-25 00:00:00	1912-01-04	1912-01-04 00:00:00	32020		\N	189905	0	195662009	4112343		0
48341	2864	40481087	1947-09-21	1947-09-21 00:00:00	1947-09-28	1947-09-28 00:00:00	32020		\N	190493	0	444814009	40481087		0
59147	3509	28060	1956-06-27	1956-06-27 00:00:00	1956-07-06	1956-07-06 00:00:00	32020		\N	232735	0	43878008	28060		0
59294	3516	4112343	2008-08-15	2008-08-15 00:00:00	2008-08-28	2008-08-28 00:00:00	32020		\N	233327	0	195662009	4112343		0
48897	2895	40481087	1960-07-14	1960-07-14 00:00:00	1960-07-28	1960-07-28 00:00:00	32020		\N	192712	0	444814009	40481087		0
59598	3532	4027663	1996-07-05	1996-07-05 00:00:00	\N	\N	32020		\N	234598	0	13200003	4027663		0
59783	3542	260139	1948-06-05	1948-06-05 00:00:00	1948-06-12	1948-06-12 00:00:00	32020		\N	235233	0	10509002	260139		0
59930	3550	4155034	2012-07-04	2012-07-04 00:00:00	2012-07-25	2012-07-25 00:00:00	32020		\N	235758	0	283371005	4155034		0
49618	2935	4155034	2018-06-08	2018-06-08 00:00:00	2018-06-22	2018-06-22 00:00:00	32020		\N	195682	0	283371005	4155034		0
49788	2944	260139	1981-09-02	1981-09-02 00:00:00	1981-09-16	1981-09-16 00:00:00	32020		\N	196404	0	10509002	260139		0
49816	2945	40481087	1997-10-11	1997-10-11 00:00:00	1997-10-18	1997-10-18 00:00:00	32020		\N	196547	0	444814009	40481087		0
50097	2960	4112343	2016-04-13	2016-04-13 00:00:00	2016-04-25	2016-04-25 00:00:00	32020		\N	197617	0	195662009	4112343		0
50190	2965	80180	2003-09-03	2003-09-03 00:00:00	\N	\N	32020		\N	197932	0	396275006	80180		0
50449	2985	260139	1981-04-16	1981-04-16 00:00:00	1981-04-30	1981-04-30 00:00:00	32020		\N	199207	0	10509002	260139		0
50572	2991	40481087	2005-02-07	2005-02-07 00:00:00	2005-02-14	2005-02-14 00:00:00	32020		\N	199645	0	444814009	40481087		0
50741	3001	4152936	1986-09-06	1986-09-06 00:00:00	1986-09-27	1986-09-27 00:00:00	32020		\N	200330	0	283385000	4152936		0
50892	3011	4113008	1983-04-07	1983-04-07 00:00:00	1983-04-28	1983-04-28 00:00:00	32020		\N	200802	0	284549007	4113008		0
50999	3019	4027663	2004-04-27	2004-04-27 00:00:00	\N	\N	32020		\N	201342	0	13200003	4027663		0
61803	3650	28060	2015-07-03	2015-07-03 00:00:00	2015-07-14	2015-07-14 00:00:00	32020		\N	242949	0	43878008	28060		0
51439	3053	40481087	1994-09-05	1994-09-05 00:00:00	1994-09-12	1994-09-12 00:00:00	32020		\N	203125	0	444814009	40481087		0
51555	3060	40481087	2011-11-19	2011-11-19 00:00:00	2011-12-10	2011-12-10 00:00:00	32020		\N	203547	0	444814009	40481087		0
62269	3678	40481087	1998-09-29	1998-09-29 00:00:00	1998-10-13	1998-10-13 00:00:00	32020		\N	244582	0	444814009	40481087		0
51919	3077	4116491	2011-05-28	2011-05-28 00:00:00	2011-07-14	2011-07-14 00:00:00	32020		\N	204769	0	301011002	4116491		0
52061	3083	4112343	1969-07-20	1969-07-20 00:00:00	1969-08-01	1969-08-01 00:00:00	32020		\N	205331	0	195662009	4112343		0
52247	3092	81151	1956-05-22	1956-05-22 00:00:00	1956-06-05	1956-06-05 00:00:00	32020		\N	205904	0	44465007	81151		0
52339	3100	40481087	2003-01-24	2003-01-24 00:00:00	2003-02-14	2003-02-14 00:00:00	32020		\N	206276	0	444814009	40481087		0
63168	3731	4112343	2012-04-11	2012-04-11 00:00:00	2012-04-20	2012-04-20 00:00:00	32020		\N	247941	0	195662009	4112343		0
63282	3736	4112343	1959-03-27	1959-03-27 00:00:00	1959-04-05	1959-04-05 00:00:00	32020		\N	248255	0	195662009	4112343		0
63433	3746	375671	1945-08-30	1945-08-30 00:00:00	1945-10-29	1945-10-29 00:00:00	32020		\N	249062	0	62564004	375671		0
63625	3756	40481087	1985-10-01	1985-10-01 00:00:00	1985-10-15	1985-10-15 00:00:00	32020		\N	249642	0	444814009	40481087		0
42628	2541	260139	1994-04-11	1994-04-11 00:00:00	1994-04-18	1994-04-18 00:00:00	32020		\N	168053	0	10509002	260139		0
53321	3159	4112343	1970-11-17	1970-11-17 00:00:00	1970-11-25	1970-11-25 00:00:00	32020		\N	210024	0	195662009	4112343		0
42994	2559	4285898	1989-09-30	1989-09-30 00:00:00	\N	\N	32020		\N	169576	0	68496003	4285898		0
43119	2567	372328	1980-10-27	1980-10-27 00:00:00	1981-05-23	1981-05-23 00:00:00	32020		\N	170080	0	65363002	372328		0
43224	2574	372328	1961-05-04	1961-05-04 00:00:00	1961-06-14	1961-06-14 00:00:00	32020		\N	170510	0	65363002	372328		0
53951	3194	260139	1980-11-29	1980-11-29 00:00:00	1980-12-06	1980-12-06 00:00:00	32020		\N	212465	0	10509002	260139		0
43551	2594	40481087	1984-07-30	1984-07-30 00:00:00	1984-08-20	1984-08-20 00:00:00	32020		\N	171711	0	444814009	40481087		0
43754	2604	80180	1997-08-12	1997-08-12 00:00:00	\N	\N	32020		\N	172277	0	396275006	80180		0
43914	2615	4112343	1984-04-17	1984-04-17 00:00:00	1984-04-28	1984-04-28 00:00:00	32020		\N	172927	0	195662009	4112343		0
60220	3565	4310024	1980-03-25	1980-03-25 00:00:00	\N	\N	32020		\N	236787	0	424802006	4310024		0
44111	2622	40481087	2008-01-01	2008-01-01 00:00:00	2008-01-15	2008-01-15 00:00:00	32020		\N	173429	0	444814009	40481087		0
44263	2631	30753	1991-06-27	1991-06-27 00:00:00	\N	\N	32020		\N	174090	0	16761005	30753		0
54974	3253	4134304	2012-02-08	2012-02-08 00:00:00	2012-03-09	2012-03-09 00:00:00	32020		\N	216244	0	263102004	4134304		0
55146	3263	4112343	1987-08-25	1987-08-25 00:00:00	1987-09-04	1987-09-04 00:00:00	32020		\N	216912	0	195662009	4112343		0
44776	2663	80809	2007-08-21	2007-08-21 00:00:00	2011-05-02	2011-05-02 00:00:00	32020		\N	176485	0	69896004	80809		0
44945	2674	260139	1971-05-25	1971-05-25 00:00:00	1971-06-01	1971-06-01 00:00:00	32020		\N	177182	0	10509002	260139		0
55614	3293	4112343	1982-03-01	1982-03-01 00:00:00	1982-03-09	1982-03-09 00:00:00	32020		\N	218670	0	195662009	4112343		0
45189	2688	40481087	2007-06-12	2007-06-12 00:00:00	2007-06-26	2007-06-26 00:00:00	32020		\N	178094	0	444814009	40481087		0
55968	3314	260139	2007-07-16	2007-07-16 00:00:00	2007-07-30	2007-07-30 00:00:00	32020		\N	220067	0	10509002	260139		0
45614	2711	260139	1966-11-06	1966-11-06 00:00:00	1966-11-22	1966-11-22 00:00:00	32020		\N	179657	0	10509002	260139		0
45801	2724	40481087	1977-07-28	1977-07-28 00:00:00	1977-08-11	1977-08-11 00:00:00	32020		\N	180441	0	444814009	40481087		0
45939	2736	28060	2019-06-12	2019-06-12 00:00:00	2019-06-23	2019-06-23 00:00:00	32020		\N	181129	0	43878008	28060		0
56688	3363	260139	1972-06-10	1972-06-10 00:00:00	1972-06-17	1972-06-17 00:00:00	32020		\N	222987	0	10509002	260139		0
46299	2758	257012	1952-12-18	1952-12-18 00:00:00	\N	\N	32020		\N	182476	0	40055000	257012		0
46413	2765	81151	1960-02-24	1960-02-24 00:00:00	1960-03-23	1960-03-23 00:00:00	32020		\N	182890	0	44465007	81151		0
46531	2770	80180	1972-06-12	1972-06-12 00:00:00	\N	\N	32020		\N	183276	0	396275006	80180		0
46759	2781	4113008	1996-01-18	1996-01-18 00:00:00	1996-02-01	1996-02-01 00:00:00	32020		\N	184330	0	284549007	4113008		0
46915	2790	80502	2013-04-11	2013-04-11 00:00:00	\N	\N	32020		\N	184866	0	64859006	80502		0
47137	2802	4296205	1949-12-09	1949-12-09 00:00:00	1949-12-30	1949-12-30 00:00:00	32020		\N	185709	0	403191005	4296205		0
47296	2813	4283893	1934-10-02	1934-10-02 00:00:00	1934-11-13	1934-11-13 00:00:00	32020		\N	186428	0	36971009	4283893		0
47435	2821	4283893	1925-04-28	1925-04-28 00:00:00	1925-10-13	1925-10-13 00:00:00	32020		\N	186915	0	36971009	4283893		0
47597	2830	40481087	1995-07-30	1995-07-30 00:00:00	1995-08-13	1995-08-13 00:00:00	32020		\N	187753	0	444814009	40481087		0
47690	2834	372328	1938-07-18	1938-07-18 00:00:00	1938-10-01	1938-10-01 00:00:00	32020		\N	188112	0	65363002	372328		0
47883	2843	80180	2000-01-09	2000-01-09 00:00:00	\N	\N	32020		\N	188779	0	396275006	80180		0
58637	3477	4112343	1976-04-22	1976-04-22 00:00:00	1976-05-04	1976-05-04 00:00:00	32020		\N	230689	0	195662009	4112343		0
48185	2858	372328	1979-07-04	1979-07-04 00:00:00	1980-03-25	1980-03-25 00:00:00	32020		\N	189787	0	65363002	372328		0
48342	2864	40481087	1983-08-21	1983-08-21 00:00:00	1983-08-28	1983-08-28 00:00:00	32020		\N	190510	0	444814009	40481087		0
59148	3509	28060	1976-09-21	1976-09-21 00:00:00	1976-10-04	1976-10-04 00:00:00	32020		\N	232738	0	43878008	28060		0
59295	3516	260139	1949-01-07	1949-01-07 00:00:00	1949-01-21	1949-01-21 00:00:00	32020		\N	233312	0	10509002	260139		0
48898	2895	4294548	2019-05-26	2019-05-26 00:00:00	\N	\N	32020		\N	192741	0	75498004	4294548		0
59599	3532	81151	2017-01-27	2017-01-27 00:00:00	2017-02-17	2017-02-17 00:00:00	32020		\N	234633	0	44465007	81151		0
59784	3542	80502	2017-09-23	2017-09-23 00:00:00	\N	\N	32020		\N	235247	0	64859006	80502		0
59931	3550	4112343	1993-09-06	1993-09-06 00:00:00	1993-09-18	1993-09-18 00:00:00	32020		\N	235736	0	195662009	4112343		0
49619	2935	40481087	2012-10-07	2012-10-07 00:00:00	2012-10-21	2012-10-21 00:00:00	32020		\N	195727	0	444814009	40481087		0
49789	2944	81151	1972-09-20	1972-09-20 00:00:00	1972-10-18	1972-10-18 00:00:00	32020		\N	196394	0	44465007	81151		0
49817	2945	260139	2007-12-31	2007-12-31 00:00:00	2008-01-07	2008-01-07 00:00:00	32020		\N	196527	0	10509002	260139		0
50098	2960	40481087	1968-08-30	1968-08-30 00:00:00	1968-09-06	1968-09-06 00:00:00	32020		\N	197630	0	444814009	40481087		0
50191	2965	4112343	2006-11-19	2006-11-19 00:00:00	2006-12-02	2006-12-02 00:00:00	32020		\N	197974	0	195662009	4112343		0
50450	2985	40481087	1987-06-14	1987-06-14 00:00:00	1987-06-21	1987-06-21 00:00:00	32020		\N	199237	0	444814009	40481087		0
50573	2991	260139	1968-02-22	1968-02-22 00:00:00	1968-03-07	1968-03-07 00:00:00	32020		\N	199631	0	10509002	260139		0
50742	3001	40481087	1951-04-03	1951-04-03 00:00:00	1951-04-10	1951-04-10 00:00:00	32020		\N	200234	0	444814009	40481087		0
50893	3011	40481087	1995-09-21	1995-09-21 00:00:00	1995-10-05	1995-10-05 00:00:00	32020		\N	200823	0	444814009	40481087		0
51000	3019	4237458	1992-04-15	1992-04-15 00:00:00	1992-05-15	1992-05-15 00:00:00	32020		\N	201346	0	58150001	4237458		0
61804	3650	260139	1935-04-03	1935-04-03 00:00:00	1935-04-17	1935-04-17 00:00:00	32020		\N	242940	0	10509002	260139		0
51440	3053	40481087	2018-12-21	2018-12-21 00:00:00	2018-12-28	2018-12-28 00:00:00	32020		\N	203115	0	444814009	40481087		0
51556	3060	4278672	2012-03-29	2012-03-29 00:00:00	2012-04-28	2012-04-28 00:00:00	32020		\N	203631	0	65966004	4278672		0
62270	3678	260139	1985-09-23	1985-09-23 00:00:00	1985-09-30	1985-09-30 00:00:00	32020		\N	244580	0	10509002	260139		0
51936	3079	40481087	1944-01-25	1944-01-25 00:00:00	1944-02-01	1944-02-01 00:00:00	32020		\N	204918	0	444814009	40481087		0
52062	3083	4156265	1997-02-15	1997-02-15 00:00:00	1997-03-01	1997-03-01 00:00:00	32020		\N	205351	0	370247008	4156265		0
52248	3092	40481087	1999-10-14	1999-10-14 00:00:00	1999-10-28	1999-10-28 00:00:00	32020		\N	205868	0	444814009	40481087		0
52340	3100	378001	1974-10-07	1974-10-07 00:00:00	1974-11-06	1974-11-06 00:00:00	32020		\N	206242	0	62106007	378001		0
63169	3731	260139	2011-08-22	2011-08-22 00:00:00	2011-09-05	2011-09-05 00:00:00	32020		\N	247918	0	10509002	260139		0
63283	3736	40481087	1989-06-08	1989-06-08 00:00:00	1989-06-15	1989-06-15 00:00:00	32020		\N	248329	0	444814009	40481087		0
63434	3746	4112343	2013-06-01	2013-06-01 00:00:00	2013-06-10	2013-06-10 00:00:00	32020		\N	249044	0	195662009	4112343		0
63626	3756	4278672	2001-08-02	2001-08-02 00:00:00	2001-10-01	2001-10-01 00:00:00	32020		\N	249664	0	65966004	4278672		0
42629	2541	260139	2007-09-27	2007-09-27 00:00:00	2007-10-11	2007-10-11 00:00:00	32020		\N	168060	0	10509002	260139		0
53322	3159	40481087	2002-07-04	2002-07-04 00:00:00	2002-07-18	2002-07-18 00:00:00	32020		\N	210092	0	444814009	40481087		0
53453	3168	40481087	2003-05-24	2003-05-24 00:00:00	2003-05-31	2003-05-31 00:00:00	32020		\N	210644	0	444814009	40481087		0
43120	2567	260139	2011-10-21	2011-10-21 00:00:00	2011-11-04	2011-11-04 00:00:00	32020		\N	170084	0	10509002	260139		0
43225	2574	192671	2005-08-01	2005-08-01 00:00:00	\N	\N	32020		\N	170512	0	K92.2	35208414		0
53952	3194	40481087	1952-11-25	1952-11-25 00:00:00	1952-12-09	1952-12-09 00:00:00	32020		\N	212453	0	444814009	40481087		0
43552	2594	4112343	1978-09-22	1978-09-22 00:00:00	1978-09-30	1978-09-30 00:00:00	32020		\N	171697	0	195662009	4112343		0
43755	2604	40481087	1964-08-25	1964-08-25 00:00:00	1964-09-15	1964-09-15 00:00:00	32020		\N	172274	0	444814009	40481087		0
43915	2615	4112343	1986-03-22	1986-03-22 00:00:00	1986-03-31	1986-03-31 00:00:00	32020		\N	172897	0	195662009	4112343		0
44112	2622	40481087	1992-10-01	1992-10-01 00:00:00	1992-10-15	1992-10-15 00:00:00	32020		\N	173443	0	444814009	40481087		0
44264	2631	40481087	1988-06-09	1988-06-09 00:00:00	1988-06-23	1988-06-23 00:00:00	32020		\N	174052	0	444814009	40481087		0
54975	3253	4112343	2005-09-19	2005-09-19 00:00:00	2005-09-29	2005-09-29 00:00:00	32020		\N	216295	0	195662009	4112343		0
55147	3263	40481087	2007-02-27	2007-02-27 00:00:00	2007-03-06	2007-03-06 00:00:00	32020		\N	216964	0	444814009	40481087		0
44777	2663	260139	1973-04-20	1973-04-20 00:00:00	1973-04-27	1973-04-27 00:00:00	32020		\N	176443	0	10509002	260139		0
44946	2674	40481087	2005-10-22	2005-10-22 00:00:00	2005-10-29	2005-10-29 00:00:00	32020		\N	177204	0	444814009	40481087		0
55615	3293	4142905	1996-11-07	1996-11-07 00:00:00	1997-02-05	1997-02-05 00:00:00	32020		\N	218695	0	33737001	4142905		0
45190	2688	372328	1964-08-17	1964-08-17 00:00:00	1964-12-27	1964-12-27 00:00:00	32020		\N	178096	0	65363002	372328		0
55969	3314	4112343	1966-05-21	1966-05-21 00:00:00	1966-05-29	1966-05-29 00:00:00	32020		\N	220116	0	195662009	4112343		0
45615	2711	40481087	2016-11-08	2016-11-08 00:00:00	2016-11-15	2016-11-15 00:00:00	32020		\N	179798	0	444814009	40481087		0
45802	2724	40481087	1983-03-21	1983-03-21 00:00:00	1983-04-04	1983-04-04 00:00:00	32020		\N	180484	0	444814009	40481087		0
45940	2736	40481087	2000-04-27	2000-04-27 00:00:00	2000-05-18	2000-05-18 00:00:00	32020		\N	181105	0	444814009	40481087		0
56689	3363	375671	1966-04-08	1966-04-08 00:00:00	1966-06-07	1966-06-07 00:00:00	32020		\N	222952	0	62564004	375671		0
46300	2758	78272	1943-12-02	1943-12-02 00:00:00	1943-12-23	1943-12-23 00:00:00	32020		\N	182455	0	70704007	78272		0
46414	2765	81151	2016-12-06	2016-12-06 00:00:00	2017-01-03	2017-01-03 00:00:00	32020		\N	182885	0	44465007	81151		0
46532	2770	260139	1973-06-10	1973-06-10 00:00:00	1973-06-17	1973-06-17 00:00:00	32020		\N	183313	0	10509002	260139		0
46760	2781	40481087	1985-08-01	1985-08-01 00:00:00	1985-08-22	1985-08-22 00:00:00	32020		\N	184295	0	444814009	40481087		0
46916	2790	40481087	2018-02-08	2018-02-08 00:00:00	2018-02-22	2018-02-22 00:00:00	32020		\N	184892	0	444814009	40481087		0
47138	2802	4155034	1993-01-02	1993-01-02 00:00:00	1993-01-16	1993-01-16 00:00:00	32020		\N	185714	0	283371005	4155034		0
47297	2813	40481087	1976-01-09	1976-01-09 00:00:00	1976-01-16	1976-01-16 00:00:00	32020		\N	186379	0	444814009	40481087		0
47436	2821	4283893	1980-03-13	1980-03-13 00:00:00	1980-04-10	1980-04-10 00:00:00	32020		\N	186870	0	36971009	4283893		0
47598	2830	4112343	1983-06-29	1983-06-29 00:00:00	1983-07-06	1983-07-06 00:00:00	32020		\N	187785	0	195662009	4112343		0
47691	2834	260139	1964-06-02	1964-06-02 00:00:00	1964-06-09	1964-06-09 00:00:00	32020		\N	188189	0	10509002	260139		0
47884	2843	40481087	1981-06-04	1981-06-04 00:00:00	1981-06-25	1981-06-25 00:00:00	32020		\N	188790	0	444814009	40481087		0
58638	3477	4112343	1977-11-27	1977-11-27 00:00:00	1977-12-08	1977-12-08 00:00:00	32020		\N	230611	0	195662009	4112343		0
48186	2858	80180	1953-05-26	1953-05-26 00:00:00	\N	\N	32020		\N	189761	0	396275006	80180		0
48343	2864	80180	1976-04-02	1976-04-02 00:00:00	\N	\N	32020		\N	190565	0	396275006	80180		0
59149	3509	4278672	2011-03-26	2011-03-26 00:00:00	2011-06-24	2011-06-24 00:00:00	32020		\N	232794	0	65966004	4278672		0
59296	3516	260139	2002-05-05	2002-05-05 00:00:00	2002-05-19	2002-05-19 00:00:00	32020		\N	233299	0	10509002	260139		0
48899	2895	4296204	2013-01-21	2013-01-21 00:00:00	2013-02-04	2013-02-04 00:00:00	32020		\N	192681	0	403190006	4296204		0
59600	3532	4283893	1975-10-20	1975-10-20 00:00:00	1975-12-29	1975-12-29 00:00:00	32020		\N	234643	0	36971009	4283893		0
59785	3542	40481087	1990-03-06	1990-03-06 00:00:00	1990-03-20	1990-03-20 00:00:00	32020		\N	235258	0	444814009	40481087		0
59932	3550	78272	1985-07-16	1985-07-16 00:00:00	1985-07-30	1985-07-30 00:00:00	32020		\N	235755	0	70704007	78272		0
49620	2935	40481087	1999-12-09	1999-12-09 00:00:00	1999-12-23	1999-12-23 00:00:00	32020		\N	195690	0	444814009	40481087		0
49790	2944	4149245	2006-10-16	2006-10-16 00:00:00	2006-12-22	2006-12-22 00:00:00	32020		\N	196397	0	30832001	4149245		0
49818	2945	40481087	1954-07-30	1954-07-30 00:00:00	1954-08-20	1954-08-20 00:00:00	32020		\N	196521	0	444814009	40481087		0
50099	2960	40481087	1985-03-15	1985-03-15 00:00:00	1985-04-05	1985-04-05 00:00:00	32020		\N	197692	0	444814009	40481087		0
50192	2965	40481087	1975-11-02	1975-11-02 00:00:00	1975-11-16	1975-11-16 00:00:00	32020		\N	197919	0	444814009	40481087		0
50451	2985	40481087	2000-11-09	2000-11-09 00:00:00	2000-11-16	2000-11-16 00:00:00	32020		\N	199214	0	444814009	40481087		0
50574	2991	40481087	1967-03-03	1967-03-03 00:00:00	1967-03-24	1967-03-24 00:00:00	32020		\N	199621	0	444814009	40481087		0
50743	3001	4112343	1957-08-28	1957-08-28 00:00:00	1957-09-10	1957-09-10 00:00:00	32020		\N	200235	0	195662009	4112343		0
50894	3011	260139	2014-05-12	2014-05-12 00:00:00	2014-05-19	2014-05-19 00:00:00	32020		\N	200854	0	10509002	260139		0
51001	3019	40481087	2016-07-13	2016-07-13 00:00:00	2016-07-27	2016-07-27 00:00:00	32020		\N	201350	0	444814009	40481087		0
61805	3650	4027663	1956-07-22	1956-07-22 00:00:00	\N	\N	32020		\N	242975	0	13200003	4027663		0
51441	3053	4146173	1988-06-20	1988-06-20 00:00:00	1988-07-20	1988-07-20 00:00:00	32020		\N	203109	0	307731004	4146173		0
51557	3060	260139	2000-08-19	2000-08-19 00:00:00	2000-09-02	2000-09-02 00:00:00	32020		\N	203659	0	10509002	260139		0
62271	3678	372328	1986-08-19	1986-08-19 00:00:00	1987-05-04	1987-05-04 00:00:00	32020		\N	244590	0	65363002	372328		0
51937	3079	4112343	1986-04-28	1986-04-28 00:00:00	1986-05-08	1986-05-08 00:00:00	32020		\N	204896	0	195662009	4112343		0
52063	3083	260139	1955-12-21	1955-12-21 00:00:00	1955-12-28	1955-12-28 00:00:00	32020		\N	205259	0	10509002	260139		0
52249	3092	40481087	2000-01-05	2000-01-05 00:00:00	2000-01-26	2000-01-26 00:00:00	32020		\N	205869	0	444814009	40481087		0
52341	3100	4152936	1951-10-03	1951-10-03 00:00:00	1951-10-24	1951-10-24 00:00:00	32020		\N	206240	0	283385000	4152936		0
63170	3731	40481087	2009-10-15	2009-10-15 00:00:00	2009-11-05	2009-11-05 00:00:00	32020		\N	247940	0	444814009	40481087		0
63284	3736	40481087	1972-05-24	1972-05-24 00:00:00	1972-06-07	1972-06-07 00:00:00	32020		\N	248257	0	444814009	40481087		0
63435	3746	4218389	1970-01-12	1970-01-12 00:00:00	1970-02-16	1970-02-16 00:00:00	32020		\N	249064	0	39848009	4218389		0
63627	3757	317576	2018-10-17	2018-10-17 00:00:00	\N	\N	32020		\N	249802	0	53741008	317576		0
42630	2541	192671	2017-12-17	2017-12-17 00:00:00	\N	\N	32020		\N	168045	0	K92.2	35208414		0
53323	3159	4112343	2004-01-12	2004-01-12 00:00:00	2004-01-24	2004-01-24 00:00:00	32020		\N	210040	0	195662009	4112343		0
53454	3168	81151	2003-02-17	2003-02-17 00:00:00	2003-03-17	2003-03-17 00:00:00	32020		\N	210649	0	44465007	81151		0
43131	2570	4112343	1991-12-29	1991-12-29 00:00:00	1992-01-08	1992-01-08 00:00:00	32020		\N	170180	0	195662009	4112343		0
43226	2574	4112343	1972-02-09	1972-02-09 00:00:00	1972-02-17	1972-02-17 00:00:00	32020		\N	170450	0	195662009	4112343		0
53953	3194	134438	1968-06-15	1968-06-15 00:00:00	1969-04-15	1969-04-15 00:00:00	32020		\N	212462	0	40275004	134438		0
43553	2594	28060	1975-03-30	1975-03-30 00:00:00	1975-04-08	1975-04-08 00:00:00	32020		\N	171688	0	43878008	28060		0
43756	2604	28060	1994-07-27	1994-07-27 00:00:00	1994-08-07	1994-08-07 00:00:00	32020		\N	172301	0	43878008	28060		0
43916	2615	4285898	1986-11-26	1986-11-26 00:00:00	\N	\N	32020		\N	172897	0	68496003	4285898		0
44113	2622	4116491	1982-01-12	1982-01-12 00:00:00	1982-03-09	1982-03-09 00:00:00	32020		\N	173441	0	301011002	4116491		0
44265	2631	40481087	2015-10-06	2015-10-06 00:00:00	2015-10-13	2015-10-13 00:00:00	32020		\N	174067	0	444814009	40481087		0
54976	3253	4112343	1984-12-17	1984-12-17 00:00:00	1984-12-29	1984-12-29 00:00:00	32020		\N	216326	0	195662009	4112343		0
55148	3263	4112343	1995-11-25	1995-11-25 00:00:00	1995-12-05	1995-12-05 00:00:00	32020		\N	216930	0	195662009	4112343		0
44778	2663	4112343	2011-11-14	2011-11-14 00:00:00	2011-11-26	2011-11-26 00:00:00	32020		\N	176487	0	195662009	4112343		0
44947	2675	372328	1966-01-22	1966-01-22 00:00:00	1967-01-15	1967-01-15 00:00:00	32020		\N	177302	0	65363002	372328		0
55616	3293	4283893	1948-12-14	1948-12-14 00:00:00	1949-01-18	1949-01-18 00:00:00	32020		\N	218663	0	36971009	4283893		0
45191	2688	372328	1963-01-17	1963-01-17 00:00:00	1963-02-24	1963-02-24 00:00:00	32020		\N	178126	0	65363002	372328		0
55970	3314	4237458	1976-08-25	1976-08-25 00:00:00	1976-11-22	1976-11-22 00:00:00	32020		\N	220084	0	58150001	4237458		0
45616	2711	260139	1980-02-05	1980-02-05 00:00:00	1980-02-12	1980-02-12 00:00:00	32020		\N	179621	0	10509002	260139		0
45803	2724	80502	2015-04-19	2015-04-19 00:00:00	\N	\N	32020		\N	180462	0	64859006	80502		0
45941	2736	80180	2015-07-11	2015-07-11 00:00:00	\N	\N	32020		\N	181149	0	396275006	80180		0
56690	3363	4112343	2009-11-25	2009-11-25 00:00:00	2009-12-05	2009-12-05 00:00:00	32020		\N	222989	0	195662009	4112343		0
46301	2758	4112343	1947-01-27	1947-01-27 00:00:00	1947-02-06	1947-02-06 00:00:00	32020		\N	182400	0	195662009	4112343		0
46415	2765	260139	1984-06-10	1984-06-10 00:00:00	1984-06-24	1984-06-24 00:00:00	32020		\N	182919	0	10509002	260139		0
46533	2770	4296204	2001-10-23	2001-10-23 00:00:00	2001-11-20	2001-11-20 00:00:00	32020		\N	183304	0	403190006	4296204		0
46761	2782	80180	1955-03-30	1955-03-30 00:00:00	\N	\N	32020		\N	184355	0	396275006	80180		0
46917	2790	28060	1982-11-18	1982-11-18 00:00:00	1982-11-27	1982-11-27 00:00:00	32020		\N	184891	0	43878008	28060		0
47139	2802	40481087	1983-10-16	1983-10-16 00:00:00	1983-10-30	1983-10-30 00:00:00	32020		\N	185707	0	444814009	40481087		0
47298	2813	28060	1947-05-21	1947-05-21 00:00:00	1947-06-03	1947-06-03 00:00:00	32020		\N	186408	0	43878008	28060		0
47437	2821	40481087	1965-06-26	1965-06-26 00:00:00	1965-07-03	1965-07-03 00:00:00	32020		\N	186861	0	444814009	40481087		0
47599	2830	4084167	1988-12-02	1988-12-02 00:00:00	1988-12-02	1988-12-02 00:00:00	32020		\N	187723	0	241929008	4084167		0
47692	2834	4112343	1968-01-14	1968-01-14 00:00:00	1968-01-24	1968-01-24 00:00:00	32020		\N	188190	0	195662009	4112343		0
47885	2843	4146173	2016-09-13	2016-09-13 00:00:00	2016-10-13	2016-10-13 00:00:00	32020		\N	188793	0	307731004	4146173		0
58639	3477	260139	2010-08-18	2010-08-18 00:00:00	2010-09-01	2010-09-01 00:00:00	32020		\N	230610	0	10509002	260139		0
48187	2858	260139	1991-02-19	1991-02-19 00:00:00	1991-03-05	1991-03-05 00:00:00	32020		\N	189891	0	10509002	260139		0
48344	2864	4294548	1994-06-26	1994-06-26 00:00:00	1995-01-08	1995-01-08 00:00:00	32020		\N	190499	0	75498004	4294548		0
59150	3509	4109685	1984-04-27	1984-04-27 00:00:00	1984-05-18	1984-05-18 00:00:00	32020		\N	232792	0	284551006	4109685		0
59297	3516	40481087	2012-12-03	2012-12-03 00:00:00	2012-12-17	2012-12-17 00:00:00	32020		\N	233328	0	444814009	40481087		0
48900	2895	40481087	1972-08-17	1972-08-17 00:00:00	1972-09-07	1972-09-07 00:00:00	32020		\N	192718	0	444814009	40481087		0
59601	3532	80180	2007-06-23	2007-06-23 00:00:00	\N	\N	32020		\N	234625	0	396275006	80180		0
59786	3542	40479768	2002-09-15	2002-09-15 00:00:00	2002-11-21	2002-11-21 00:00:00	32020		\N	235324	0	444470001	40479768		0
59934	3552	260139	1978-03-21	1978-03-21 00:00:00	1978-03-28	1978-03-28 00:00:00	32020		\N	235838	0	10509002	260139		0
49621	2935	372328	1980-10-02	1980-10-02 00:00:00	1981-03-18	1981-03-18 00:00:00	32020		\N	195729	0	65363002	372328		0
49791	2944	81893	1997-01-16	1997-01-16 00:00:00	\N	\N	32020		\N	196398	0	64766004	81893		0
49819	2945	4109685	1979-12-05	1979-12-05 00:00:00	1979-12-19	1979-12-19 00:00:00	32020		\N	196485	0	284551006	4109685		0
50100	2960	80180	1988-10-12	1988-10-12 00:00:00	\N	\N	32020		\N	197632	0	396275006	80180		0
50193	2965	4112343	2012-10-05	2012-10-05 00:00:00	2012-10-13	2012-10-13 00:00:00	32020		\N	197902	0	195662009	4112343		0
50452	2985	40481087	1993-02-07	1993-02-07 00:00:00	1993-02-14	1993-02-14 00:00:00	32020		\N	199250	0	444814009	40481087		0
50575	2991	260139	1996-04-14	1996-04-14 00:00:00	1996-04-21	1996-04-21 00:00:00	32020		\N	199632	0	10509002	260139		0
50744	3001	372328	1952-06-27	1952-06-27 00:00:00	1953-02-03	1953-02-03 00:00:00	32020		\N	200243	0	65363002	372328		0
50895	3011	4112343	1978-09-05	1978-09-05 00:00:00	1978-09-14	1978-09-14 00:00:00	32020		\N	200852	0	195662009	4112343		0
51002	3019	260139	2001-03-01	2001-03-01 00:00:00	2001-03-15	2001-03-15 00:00:00	32020		\N	201333	0	10509002	260139		0
61806	3650	4283893	1978-04-12	1978-04-12 00:00:00	1978-07-12	1978-07-12 00:00:00	32020		\N	242902	0	36971009	4283893		0
51442	3053	40481087	1994-01-12	1994-01-12 00:00:00	1994-02-02	1994-02-02 00:00:00	32020		\N	203143	0	444814009	40481087		0
51558	3060	40481087	1932-11-25	1932-11-25 00:00:00	1932-12-02	1932-12-02 00:00:00	32020		\N	203553	0	444814009	40481087		0
62272	3678	372328	1988-12-24	1988-12-24 00:00:00	1989-05-15	1989-05-15 00:00:00	32020		\N	244591	0	65363002	372328		0
51938	3079	40481087	2012-02-25	2012-02-25 00:00:00	2012-03-03	2012-03-03 00:00:00	32020		\N	204898	0	444814009	40481087		0
52064	3083	4109685	2004-10-20	2004-10-20 00:00:00	2004-11-03	2004-11-03 00:00:00	32020		\N	205352	0	284551006	4109685		0
52250	3092	40481087	2013-07-24	2013-07-24 00:00:00	2013-08-14	2013-08-14 00:00:00	32020		\N	205885	0	444814009	40481087		0
52342	3100	40481087	2009-10-19	2009-10-19 00:00:00	2009-11-09	2009-11-09 00:00:00	32020		\N	206277	0	444814009	40481087		0
63171	3731	4059173	1989-03-31	1989-03-31 00:00:00	1989-04-30	1989-04-30 00:00:00	32020		\N	247937	0	16114001	4059173		0
63285	3736	257012	1999-07-13	1999-07-13 00:00:00	\N	\N	32020		\N	248274	0	40055000	257012		0
63436	3746	40481087	2014-09-29	2014-09-29 00:00:00	2014-10-13	2014-10-13 00:00:00	32020		\N	249045	0	444814009	40481087		0
63628	3757	40481087	1946-02-22	1946-02-22 00:00:00	1946-03-15	1946-03-15 00:00:00	32020		\N	249764	0	444814009	40481087		0
42631	2541	40481087	1988-02-29	1988-02-29 00:00:00	1988-03-07	1988-03-07 00:00:00	32020		\N	168051	0	444814009	40481087		0
53324	3159	4112343	1966-01-02	1966-01-02 00:00:00	1966-01-09	1966-01-09 00:00:00	32020		\N	210021	0	195662009	4112343		0
53455	3168	4112343	1997-02-06	1997-02-06 00:00:00	1997-02-15	1997-02-15 00:00:00	32020		\N	210652	0	195662009	4112343		0
43132	2570	40481087	1976-11-13	1976-11-13 00:00:00	1976-11-20	1976-11-20 00:00:00	32020		\N	170268	0	444814009	40481087		0
43227	2574	4113008	1976-02-19	1976-02-19 00:00:00	1976-03-04	1976-03-04 00:00:00	32020		\N	170494	0	284549007	4113008		0
53954	3194	260139	1974-08-24	1974-08-24 00:00:00	1974-08-31	1974-08-31 00:00:00	32020		\N	212456	0	10509002	260139		0
43554	2594	260139	1977-02-17	1977-02-17 00:00:00	1977-02-24	1977-02-24 00:00:00	32020		\N	171720	0	10509002	260139		0
43757	2604	40481087	1969-03-17	1969-03-17 00:00:00	1969-04-07	1969-04-07 00:00:00	32020		\N	172246	0	444814009	40481087		0
43917	2615	30753	1986-04-30	1986-04-30 00:00:00	\N	\N	32020		\N	172897	0	16761005	30753		0
44114	2622	40481087	1946-09-20	1946-09-20 00:00:00	1946-10-11	1946-10-11 00:00:00	32020		\N	173460	0	444814009	40481087		0
44266	2631	40481087	2015-03-11	2015-03-11 00:00:00	2015-04-01	2015-04-01 00:00:00	32020		\N	174066	0	444814009	40481087		0
54977	3253	4112343	1987-03-23	1987-03-23 00:00:00	1987-03-31	1987-03-31 00:00:00	32020		\N	216328	0	195662009	4112343		0
55149	3263	4112343	2009-07-09	2009-07-09 00:00:00	2009-07-17	2009-07-17 00:00:00	32020		\N	216914	0	195662009	4112343		0
44779	2663	40481087	1988-10-28	1988-10-28 00:00:00	1988-11-04	1988-11-04 00:00:00	32020		\N	176478	0	444814009	40481087		0
44948	2675	260139	1976-05-31	1976-05-31 00:00:00	1976-06-07	1976-06-07 00:00:00	32020		\N	177289	0	10509002	260139		0
55617	3293	4112343	1921-09-23	1921-09-23 00:00:00	1921-10-05	1921-10-05 00:00:00	32020		\N	218658	0	195662009	4112343		0
45192	2688	40481087	1971-11-08	1971-11-08 00:00:00	1971-11-15	1971-11-15 00:00:00	32020		\N	178092	0	444814009	40481087		0
55971	3314	40481087	1964-10-04	1964-10-04 00:00:00	1964-10-25	1964-10-25 00:00:00	32020		\N	220065	0	444814009	40481087		0
45617	2711	260139	1996-04-09	1996-04-09 00:00:00	1996-04-23	1996-04-23 00:00:00	32020		\N	179668	0	10509002	260139		0
45804	2724	4112343	1969-11-27	1969-11-27 00:00:00	1969-12-09	1969-12-09 00:00:00	32020		\N	180483	0	195662009	4112343		0
45942	2736	4112343	2004-11-16	2004-11-16 00:00:00	2004-11-24	2004-11-24 00:00:00	32020		\N	181115	0	195662009	4112343		0
56691	3363	4112343	1963-03-31	1963-03-31 00:00:00	1963-04-12	1963-04-12 00:00:00	32020		\N	222942	0	195662009	4112343		0
46302	2758	4112343	1960-03-15	1960-03-15 00:00:00	1960-03-23	1960-03-23 00:00:00	32020		\N	182478	0	195662009	4112343		0
46416	2765	40481087	1935-09-20	1935-09-20 00:00:00	1935-10-11	1935-10-11 00:00:00	32020		\N	182904	0	444814009	40481087		0
46534	2770	4112343	1938-11-18	1938-11-18 00:00:00	1938-12-01	1938-12-01 00:00:00	32020		\N	183363	0	195662009	4112343		0
46762	2782	4285898	1954-08-02	1954-08-02 00:00:00	\N	\N	32020		\N	184355	0	68496003	4285898		0
46931	2792	4278672	1961-09-16	1961-09-16 00:00:00	1961-11-15	1961-11-15 00:00:00	32020		\N	185033	0	65966004	4278672		0
47140	2802	40481087	1960-11-14	1960-11-14 00:00:00	1960-11-21	1960-11-21 00:00:00	32020		\N	185724	0	444814009	40481087		0
47299	2813	257012	2015-02-08	2015-02-08 00:00:00	\N	\N	32020		\N	186411	0	40055000	257012		0
47438	2821	4278672	2005-05-07	2005-05-07 00:00:00	2005-06-06	2005-06-06 00:00:00	32020		\N	186856	0	65966004	4278672		0
47600	2830	4112343	2017-12-13	2017-12-13 00:00:00	2017-12-22	2017-12-22 00:00:00	32020		\N	187772	0	195662009	4112343		0
47693	2834	192671	1972-03-16	1972-03-16 00:00:00	\N	\N	32020		\N	188166	0	K92.2	35208414		0
47886	2844	4027663	1982-02-28	1982-02-28 00:00:00	\N	\N	32020		\N	188812	0	13200003	4027663		0
58640	3477	40481087	2018-11-23	2018-11-23 00:00:00	2018-12-07	2018-12-07 00:00:00	32020		\N	230622	0	444814009	40481087		0
48188	2858	260139	1982-02-23	1982-02-23 00:00:00	1982-03-02	1982-03-02 00:00:00	32020		\N	189782	0	10509002	260139		0
48345	2864	260139	1969-08-27	1969-08-27 00:00:00	1969-09-10	1969-09-10 00:00:00	32020		\N	190498	0	10509002	260139		0
59151	3509	4112343	1988-06-18	1988-06-18 00:00:00	1988-06-27	1988-06-27 00:00:00	32020		\N	232705	0	195662009	4112343		0
59298	3516	4043241	2010-09-09	2010-09-09 00:00:00	\N	\N	32020		\N	233362	0	230265002	4043241		0
48901	2895	80180	1997-05-06	1997-05-06 00:00:00	\N	\N	32020		\N	192710	0	396275006	80180		0
59602	3532	4285898	2007-01-24	2007-01-24 00:00:00	\N	\N	32020		\N	234625	0	68496003	4285898		0
59787	3542	4112343	1992-09-12	1992-09-12 00:00:00	1992-09-25	1992-09-25 00:00:00	32020		\N	235264	0	195662009	4112343		0
59935	3552	40481087	1993-06-15	1993-06-15 00:00:00	1993-06-29	1993-06-29 00:00:00	32020		\N	235822	0	444814009	40481087		0
49622	2935	4294548	1980-05-22	1980-05-22 00:00:00	1980-06-12	1980-06-12 00:00:00	32020		\N	195700	0	75498004	4294548		0
49792	2944	80180	1997-09-13	1997-09-13 00:00:00	\N	\N	32020		\N	196398	0	396275006	80180		0
49820	2945	4112343	1998-11-02	1998-11-02 00:00:00	1998-11-11	1998-11-11 00:00:00	32020		\N	196458	0	195662009	4112343		0
50101	2960	4283893	1988-08-25	1988-08-25 00:00:00	1988-09-22	1988-09-22 00:00:00	32020		\N	197632	0	36971009	4283893		0
50194	2965	4278672	1987-09-06	1987-09-06 00:00:00	1987-10-06	1987-10-06 00:00:00	32020		\N	197985	0	65966004	4278672		0
50453	2985	372328	1964-12-12	1964-12-12 00:00:00	1964-12-26	1964-12-26 00:00:00	32020		\N	199268	0	65363002	372328		0
50576	2991	378001	1981-05-13	1981-05-13 00:00:00	1981-06-12	1981-06-12 00:00:00	32020		\N	199666	0	62106007	378001		0
50745	3001	378001	2000-11-12	2000-11-12 00:00:00	2000-12-12	2000-12-12 00:00:00	32020		\N	200331	0	62106007	378001		0
50896	3011	4112343	1994-10-05	1994-10-05 00:00:00	1994-10-15	1994-10-15 00:00:00	32020		\N	200853	0	195662009	4112343		0
51003	3019	192671	2015-11-29	2015-11-29 00:00:00	\N	\N	32020		\N	201331	0	K92.2	35208414		0
61807	3650	4112343	1938-10-10	1938-10-10 00:00:00	1938-10-17	1938-10-17 00:00:00	32020		\N	242899	0	195662009	4112343		0
51443	3053	4156265	2009-03-02	2009-03-02 00:00:00	2009-03-16	2009-03-16 00:00:00	32020		\N	203108	0	370247008	4156265		0
51559	3060	4112343	1937-05-11	1937-05-11 00:00:00	1937-05-24	1937-05-24 00:00:00	32020		\N	203542	0	195662009	4112343		0
62273	3678	40481087	2018-03-10	2018-03-10 00:00:00	2018-03-17	2018-03-17 00:00:00	32020		\N	244568	0	444814009	40481087		0
51939	3079	260139	1957-05-16	1957-05-16 00:00:00	1957-05-30	1957-05-30 00:00:00	32020		\N	204869	0	10509002	260139		0
52065	3083	4156265	1969-09-05	1969-09-05 00:00:00	1969-09-19	1969-09-19 00:00:00	32020		\N	205270	0	370247008	4156265		0
52251	3092	372328	1955-10-25	1955-10-25 00:00:00	1956-01-04	1956-01-04 00:00:00	32020		\N	205870	0	65363002	372328		0
52343	3100	4285898	1989-06-20	1989-06-20 00:00:00	\N	\N	32020		\N	206290	0	68496003	4285898		0
63172	3731	260139	1999-10-16	1999-10-16 00:00:00	1999-10-23	1999-10-23 00:00:00	32020		\N	247917	0	10509002	260139		0
63286	3736	40481087	1991-02-11	1991-02-11 00:00:00	1991-02-18	1991-02-18 00:00:00	32020		\N	248317	0	444814009	40481087		0
63437	3746	192671	1987-02-28	1987-02-28 00:00:00	\N	\N	32020		\N	249022	0	K92.2	35208414		0
63629	3757	4112343	1968-07-13	1968-07-13 00:00:00	1968-07-21	1968-07-21 00:00:00	32020		\N	249768	0	195662009	4112343		0
42632	2541	4237458	2003-11-06	2003-11-06 00:00:00	2003-12-06	2003-12-06 00:00:00	32020		\N	168022	0	58150001	4237458		0
53325	3159	40481087	1974-11-16	1974-11-16 00:00:00	1974-11-30	1974-11-30 00:00:00	32020		\N	210074	0	444814009	40481087		0
53456	3168	81151	2007-10-22	2007-10-22 00:00:00	2007-11-19	2007-11-19 00:00:00	32020		\N	210650	0	44465007	81151		0
43133	2570	4266809	1971-03-06	1971-03-06 00:00:00	\N	\N	32020		\N	170211	0	397881000	4266809		0
43228	2574	4027663	1992-12-26	1992-12-26 00:00:00	\N	\N	32020		\N	170481	0	13200003	4027663		0
53955	3194	4109685	1950-07-03	1950-07-03 00:00:00	1950-07-24	1950-07-24 00:00:00	32020		\N	212458	0	284551006	4109685		0
43555	2594	81893	2014-03-13	2014-03-13 00:00:00	\N	\N	32020		\N	171715	0	64766004	81893		0
43758	2604	4112343	1995-03-07	1995-03-07 00:00:00	1995-03-14	1995-03-14 00:00:00	32020		\N	172256	0	195662009	4112343		0
43918	2615	260139	1979-12-29	1979-12-29 00:00:00	1980-01-05	1980-01-05 00:00:00	32020		\N	172896	0	10509002	260139		0
44115	2622	195588	1971-10-29	1971-10-29 00:00:00	1971-12-13	1971-12-13 00:00:00	32020		\N	173476	0	38822007	195588		0
44286	2633	40481087	1963-12-12	1963-12-12 00:00:00	1963-12-26	1963-12-26 00:00:00	32020		\N	174196	0	444814009	40481087		0
54978	3253	40481087	1983-11-27	1983-11-27 00:00:00	1983-12-04	1983-12-04 00:00:00	32020		\N	216324	0	444814009	40481087		0
55150	3263	4294548	1967-07-23	1967-07-23 00:00:00	1967-11-19	1967-11-19 00:00:00	32020		\N	216961	0	75498004	4294548		0
44780	2663	40481087	1989-01-11	1989-01-11 00:00:00	1989-02-01	1989-02-01 00:00:00	32020		\N	176444	0	444814009	40481087		0
44949	2675	260139	2005-12-29	2005-12-29 00:00:00	2006-01-12	2006-01-12 00:00:00	32020		\N	177282	0	10509002	260139		0
55618	3293	40481087	1969-07-28	1969-07-28 00:00:00	1969-08-18	1969-08-18 00:00:00	32020		\N	218732	0	444814009	40481087		0
45193	2688	4112343	2017-08-13	2017-08-13 00:00:00	2017-08-20	2017-08-20 00:00:00	32020		\N	178148	0	195662009	4112343		0
55972	3314	192671	2003-09-23	2003-09-23 00:00:00	\N	\N	32020		\N	220115	0	K92.2	35208414		0
45618	2711	4027663	1980-06-18	1980-06-18 00:00:00	\N	\N	32020		\N	\N	0	13200003	4027663		0
45805	2724	440086	1961-05-21	1961-05-21 00:00:00	1963-07-07	1963-07-07 00:00:00	32020		\N	180521	0	192127007	440086		0
45943	2736	40481087	1998-12-14	1998-12-14 00:00:00	1998-12-28	1998-12-28 00:00:00	32020		\N	181094	0	444814009	40481087		0
56692	3363	4283893	1956-05-09	1956-05-09 00:00:00	1956-06-06	1956-06-06 00:00:00	32020		\N	222954	0	36971009	4283893		0
46303	2758	81893	1979-02-15	1979-02-15 00:00:00	\N	\N	32020		\N	182456	0	64766004	81893		0
46417	2765	4112343	1966-08-23	1966-08-23 00:00:00	1966-08-31	1966-08-31 00:00:00	32020		\N	182899	0	195662009	4112343		0
46535	2770	40481087	1958-05-13	1958-05-13 00:00:00	1958-06-03	1958-06-03 00:00:00	32020		\N	183399	0	444814009	40481087		0
46763	2782	30753	1954-04-04	1954-04-04 00:00:00	\N	\N	32020		\N	184355	0	16761005	30753		0
46932	2792	40481087	1981-04-01	1981-04-01 00:00:00	1981-04-15	1981-04-15 00:00:00	32020		\N	185046	0	444814009	40481087		0
47141	2802	317576	1987-06-27	1987-06-27 00:00:00	\N	\N	32020		\N	185700	0	53741008	317576		0
47300	2813	80180	1967-11-01	1967-11-01 00:00:00	\N	\N	32020		\N	186451	0	396275006	80180		0
47439	2821	4283893	2006-04-10	2006-04-10 00:00:00	2006-07-31	2006-07-31 00:00:00	32020		\N	186921	0	36971009	4283893		0
47601	2830	40481087	2009-12-19	2009-12-19 00:00:00	2009-12-26	2009-12-26 00:00:00	32020		\N	187755	0	444814009	40481087		0
47694	2834	4329847	1999-12-04	1999-12-04 00:00:00	\N	\N	32020		\N	188165	0	22298006	4329847		0
47887	2844	4112343	1981-05-15	1981-05-15 00:00:00	1981-05-22	1981-05-22 00:00:00	32020		\N	188812	0	195662009	4112343		0
58641	3477	257012	1979-04-20	1979-04-20 00:00:00	\N	\N	32020		\N	230690	0	40055000	257012		0
48189	2858	40481087	1959-05-02	1959-05-02 00:00:00	1959-05-23	1959-05-23 00:00:00	32020		\N	189824	0	444814009	40481087		0
48346	2864	260139	2015-04-07	2015-04-07 00:00:00	2015-04-14	2015-04-14 00:00:00	32020		\N	190532	0	10509002	260139		0
59152	3509	260139	1961-03-08	1961-03-08 00:00:00	1961-03-22	1961-03-22 00:00:00	32020		\N	232782	0	10509002	260139		0
59299	3516	260139	1984-06-10	1984-06-10 00:00:00	1984-06-24	1984-06-24 00:00:00	32020		\N	233325	0	10509002	260139		0
48902	2895	78272	2003-05-25	2003-05-25 00:00:00	2003-06-29	2003-06-29 00:00:00	32020		\N	192679	0	70704007	78272		0
59788	3542	4112343	2007-12-08	2007-12-08 00:00:00	2007-12-20	2007-12-20 00:00:00	32020		\N	235265	0	195662009	4112343		0
59936	3552	80180	1992-05-25	1992-05-25 00:00:00	\N	\N	32020		\N	235833	0	396275006	80180		0
49623	2935	260139	2002-04-22	2002-04-22 00:00:00	2002-04-29	2002-04-29 00:00:00	32020		\N	195687	0	10509002	260139		0
49793	2944	4285898	1997-08-14	1997-08-14 00:00:00	\N	\N	32020		\N	196398	0	68496003	4285898		0
49821	2945	4112343	1950-05-21	1950-05-21 00:00:00	1950-06-03	1950-06-03 00:00:00	32020		\N	196478	0	195662009	4112343		0
50102	2960	4112343	1998-02-18	1998-02-18 00:00:00	1998-03-03	1998-03-03 00:00:00	32020		\N	197619	0	195662009	4112343		0
50195	2965	4296204	1978-03-13	1978-03-13 00:00:00	1978-03-27	1978-03-27 00:00:00	32020		\N	197984	0	403190006	4296204		0
50454	2985	4142905	2016-07-13	2016-07-13 00:00:00	2016-10-11	2016-10-11 00:00:00	32020		\N	199192	0	33737001	4142905		0
50577	2991	80180	1998-10-16	1998-10-16 00:00:00	\N	\N	32020		\N	199661	0	396275006	80180		0
50746	3001	260139	1961-12-03	1961-12-03 00:00:00	1961-12-10	1961-12-10 00:00:00	32020		\N	200270	0	10509002	260139		0
50897	3011	372328	1980-01-09	1980-01-09 00:00:00	1981-01-20	1981-01-20 00:00:00	32020		\N	200825	0	65363002	372328		0
51004	3019	78272	1995-03-01	1995-03-01 00:00:00	1995-03-29	1995-03-29 00:00:00	32020		\N	201347	0	70704007	78272		0
61808	3650	260139	2002-06-08	2002-06-08 00:00:00	2002-06-22	2002-06-22 00:00:00	32020		\N	242945	0	10509002	260139		0
51444	3053	439777	1987-01-08	1987-01-08 00:00:00	\N	\N	32020		\N	203142	0	271737000	439777		0
51560	3060	260139	1925-06-24	1925-06-24 00:00:00	1925-07-01	1925-07-01 00:00:00	32020		\N	203554	0	10509002	260139		0
62274	3678	40481087	1995-03-23	1995-03-23 00:00:00	1995-04-13	1995-04-13 00:00:00	32020		\N	244587	0	444814009	40481087		0
51940	3079	4112343	1972-04-14	1972-04-14 00:00:00	1972-04-25	1972-04-25 00:00:00	32020		\N	204920	0	195662009	4112343		0
52066	3083	80180	1994-07-07	1994-07-07 00:00:00	\N	\N	32020		\N	205263	0	396275006	80180		0
52252	3093	4109685	1973-05-16	1973-05-16 00:00:00	1973-06-06	1973-06-06 00:00:00	32020		\N	205970	0	284551006	4109685		0
52344	3100	80180	1989-10-18	1989-10-18 00:00:00	\N	\N	32020		\N	206290	0	396275006	80180		0
63173	3731	260139	2016-09-15	2016-09-15 00:00:00	2016-09-22	2016-09-22 00:00:00	32020		\N	247919	0	10509002	260139		0
63287	3736	40481087	2012-07-29	2012-07-29 00:00:00	2012-08-12	2012-08-12 00:00:00	32020		\N	248276	0	444814009	40481087		0
63438	3746	80502	2014-06-12	2014-06-12 00:00:00	\N	\N	32020		\N	249073	0	64859006	80502		0
63630	3757	4112343	1952-09-26	1952-09-26 00:00:00	1952-10-04	1952-10-04 00:00:00	32020		\N	249725	0	195662009	4112343		0
42633	2541	81151	1997-01-27	1997-01-27 00:00:00	1997-02-10	1997-02-10 00:00:00	32020		\N	168021	0	44465007	81151		0
53326	3159	40481087	2008-10-21	2008-10-21 00:00:00	2008-10-28	2008-10-28 00:00:00	32020		\N	210093	0	444814009	40481087		0
53457	3168	4142905	1981-12-09	1981-12-09 00:00:00	1982-01-08	1982-01-08 00:00:00	32020		\N	210647	0	33737001	4142905		0
43134	2570	4285898	1970-12-06	1970-12-06 00:00:00	\N	\N	32020		\N	170211	0	68496003	4285898		0
43229	2574	260139	1978-12-31	1978-12-31 00:00:00	1979-01-14	1979-01-14 00:00:00	32020		\N	170485	0	10509002	260139		0
53956	3194	4156265	1954-05-04	1954-05-04 00:00:00	1954-05-18	1954-05-18 00:00:00	32020		\N	212459	0	370247008	4156265		0
43556	2594	260139	2013-05-23	2013-05-23 00:00:00	2013-06-06	2013-06-06 00:00:00	32020		\N	171715	0	10509002	260139		0
43796	2609	260139	1960-07-21	1960-07-21 00:00:00	1960-07-28	1960-07-28 00:00:00	32020		\N	172496	0	10509002	260139		0
43919	2615	4134304	1992-03-15	1992-03-15 00:00:00	1992-06-13	1992-06-13 00:00:00	32020		\N	172939	0	263102004	4134304		0
44116	2622	40481087	1941-05-03	1941-05-03 00:00:00	1941-05-10	1941-05-10 00:00:00	32020		\N	173470	0	444814009	40481087		0
44287	2633	4027663	1973-10-09	1973-10-09 00:00:00	\N	\N	32020		\N	174257	0	13200003	4027663		0
54979	3253	40481087	2013-08-04	2013-08-04 00:00:00	2013-08-18	2013-08-18 00:00:00	32020		\N	216296	0	444814009	40481087		0
55151	3263	321042	2007-09-11	2007-09-11 00:00:00	\N	\N	32020		\N	216903	0	410429000	321042		0
44804	2666	40481087	1966-07-12	1966-07-12 00:00:00	1966-07-19	1966-07-19 00:00:00	32020		\N	176647	0	444814009	40481087		0
44951	2675	80180	2002-01-04	2002-01-04 00:00:00	\N	\N	32020		\N	177241	0	396275006	80180		0
55619	3293	40481087	1936-06-23	1936-06-23 00:00:00	1936-07-14	1936-07-14 00:00:00	32020		\N	218745	0	444814009	40481087		0
45194	2688	260139	1970-01-27	1970-01-27 00:00:00	1970-02-10	1970-02-10 00:00:00	32020		\N	178144	0	10509002	260139		0
55973	3314	4112343	1970-07-10	1970-07-10 00:00:00	1970-07-20	1970-07-20 00:00:00	32020		\N	220073	0	195662009	4112343		0
45619	2711	4059173	2015-11-03	2015-11-03 00:00:00	2016-01-02	2016-01-02 00:00:00	32020		\N	179616	0	16114001	4059173		0
45806	2724	78272	1959-11-23	1959-11-23 00:00:00	1959-12-28	1959-12-28 00:00:00	32020		\N	180433	0	70704007	78272		0
45944	2736	40481087	1975-04-16	1975-04-16 00:00:00	1975-05-07	1975-05-07 00:00:00	32020		\N	181116	0	444814009	40481087		0
56693	3363	40481087	1968-04-13	1968-04-13 00:00:00	1968-04-20	1968-04-20 00:00:00	32020		\N	222955	0	444814009	40481087		0
46304	2758	4109685	1978-06-22	1978-06-22 00:00:00	1978-07-06	1978-07-06 00:00:00	32020		\N	182456	0	284551006	4109685		0
46418	2765	40481087	1968-06-01	1968-06-01 00:00:00	1968-06-08	1968-06-08 00:00:00	32020		\N	182877	0	444814009	40481087		0
46536	2770	40481087	1984-02-23	1984-02-23 00:00:00	1984-03-08	1984-03-08 00:00:00	32020		\N	183314	0	444814009	40481087		0
46764	2782	4112343	1935-12-19	1935-12-19 00:00:00	1935-12-30	1935-12-30 00:00:00	32020		\N	184343	0	195662009	4112343		0
46933	2792	440086	1965-10-05	1965-10-05 00:00:00	1966-05-10	1966-05-10 00:00:00	32020		\N	185026	0	192127007	440086		0
47142	2802	257012	1975-03-02	1975-03-02 00:00:00	\N	\N	32020		\N	185759	0	40055000	257012		0
47301	2813	317576	2017-03-03	2017-03-03 00:00:00	\N	\N	32020		\N	186469	0	53741008	317576		0
47440	2821	260139	1983-11-07	1983-11-07 00:00:00	1983-11-14	1983-11-14 00:00:00	32020		\N	186952	0	10509002	260139		0
47602	2830	317009	2006-08-11	2006-08-11 00:00:00	\N	\N	32020		\N	187767	0	195967001	317009		0
47695	2834	260139	1990-06-26	1990-06-26 00:00:00	1990-07-03	1990-07-03 00:00:00	32020		\N	188188	0	10509002	260139		0
47888	2844	260139	1967-05-24	1967-05-24 00:00:00	1967-05-31	1967-05-31 00:00:00	32020		\N	188803	0	10509002	260139		0
58642	3477	40481087	2008-12-03	2008-12-03 00:00:00	2008-12-24	2008-12-24 00:00:00	32020		\N	230609	0	444814009	40481087		0
48190	2858	40481087	2003-12-08	2003-12-08 00:00:00	2003-12-29	2003-12-29 00:00:00	32020		\N	189814	0	444814009	40481087		0
48347	2864	260139	2012-03-19	2012-03-19 00:00:00	2012-04-02	2012-04-02 00:00:00	32020		\N	190515	0	10509002	260139		0
59153	3509	4156265	1973-06-10	1973-06-10 00:00:00	1973-06-24	1973-06-24 00:00:00	32020		\N	232791	0	370247008	4156265		0
59300	3516	28060	1957-09-25	1957-09-25 00:00:00	1957-10-04	1957-10-04 00:00:00	32020		\N	233321	0	43878008	28060		0
48903	2895	81151	2005-05-19	2005-05-19 00:00:00	2005-06-02	2005-06-02 00:00:00	32020		\N	192680	0	44465007	81151		0
59604	3532	4266809	2007-06-23	2007-06-23 00:00:00	\N	\N	32020		\N	234625	0	397881000	4266809		0
59789	3542	40481087	1961-06-23	1961-06-23 00:00:00	1961-07-14	1961-07-14 00:00:00	32020		\N	235263	0	444814009	40481087		0
59937	3552	257012	1980-11-11	1980-11-11 00:00:00	\N	\N	32020		\N	235845	0	40055000	257012		0
49624	2936	40481087	1990-08-31	1990-08-31 00:00:00	1990-09-07	1990-09-07 00:00:00	32020		\N	195740	0	444814009	40481087		0
49794	2944	260139	2016-05-30	2016-05-30 00:00:00	2016-06-13	2016-06-13 00:00:00	32020		\N	196424	0	10509002	260139		0
49822	2945	260139	1964-11-05	1964-11-05 00:00:00	1964-11-12	1964-11-12 00:00:00	32020		\N	196539	0	10509002	260139		0
50103	2960	260139	2011-11-16	2011-11-16 00:00:00	2011-11-23	2011-11-23 00:00:00	32020		\N	197687	0	10509002	260139		0
50196	2965	4112343	1979-07-07	1979-07-07 00:00:00	1979-07-17	1979-07-17 00:00:00	32020		\N	197921	0	195662009	4112343		0
50455	2985	260139	1969-10-18	1969-10-18 00:00:00	1969-10-25	1969-10-25 00:00:00	32020		\N	199249	0	10509002	260139		0
50578	2991	4155034	1989-09-12	1989-09-12 00:00:00	1989-10-03	1989-10-03 00:00:00	32020		\N	199629	0	283371005	4155034		0
50747	3001	375671	2002-10-03	2002-10-03 00:00:00	2002-11-02	2002-11-02 00:00:00	32020		\N	200332	0	62564004	375671		0
50898	3011	40481087	1975-07-11	1975-07-11 00:00:00	1975-07-18	1975-07-18 00:00:00	32020		\N	200850	0	444814009	40481087		0
51005	3019	40481087	1997-07-26	1997-07-26 00:00:00	1997-08-16	1997-08-16 00:00:00	32020		\N	201349	0	444814009	40481087		0
61809	3650	4149245	1984-12-13	1984-12-13 00:00:00	1985-01-19	1985-01-19 00:00:00	32020		\N	242936	0	30832001	4149245		0
51445	3053	4116491	2014-01-01	2014-01-01 00:00:00	2014-02-17	2014-02-17 00:00:00	32020		\N	203096	0	301011002	4116491		0
51561	3060	40481087	1924-10-02	1924-10-02 00:00:00	1924-10-09	1924-10-09 00:00:00	32020		\N	203551	0	444814009	40481087		0
62275	3678	4112343	1997-11-28	1997-11-28 00:00:00	1997-12-07	1997-12-07 00:00:00	32020		\N	244581	0	195662009	4112343		0
51941	3079	4134304	1979-05-24	1979-05-24 00:00:00	1979-06-23	1979-06-23 00:00:00	32020		\N	204964	0	263102004	4134304		0
52067	3083	195588	1994-06-07	1994-06-07 00:00:00	1994-07-28	1994-07-28 00:00:00	32020		\N	205263	0	38822007	195588		0
52253	3093	40481087	2017-06-08	2017-06-08 00:00:00	2017-06-15	2017-06-15 00:00:00	32020		\N	205944	0	444814009	40481087		0
52345	3100	40481087	1995-05-08	1995-05-08 00:00:00	1995-05-29	1995-05-29 00:00:00	32020		\N	206275	0	444814009	40481087		0
63174	3731	4134304	1991-05-20	1991-05-20 00:00:00	1991-08-18	1991-08-18 00:00:00	32020		\N	247938	0	263102004	4134304		0
63288	3736	40481087	1978-01-06	1978-01-06 00:00:00	1978-01-20	1978-01-20 00:00:00	32020		\N	248258	0	444814009	40481087		0
63439	3746	80180	1987-02-11	1987-02-11 00:00:00	\N	\N	32020		\N	249015	0	396275006	80180		0
63631	3757	4146173	1973-04-23	1973-04-23 00:00:00	1973-06-22	1973-06-22 00:00:00	32020		\N	249769	0	307731004	4146173		0
42634	2541	372328	1977-06-20	1977-06-20 00:00:00	1977-09-05	1977-09-05 00:00:00	32020		\N	168063	0	65363002	372328		0
53327	3159	80180	2000-01-26	2000-01-26 00:00:00	\N	\N	32020		\N	210030	0	396275006	80180		0
53458	3168	4230399	2008-10-14	2008-10-14 00:00:00	2009-01-12	2009-01-12 00:00:00	32020		\N	210651	0	359817006	4230399		0
43135	2570	80180	1971-03-06	1971-03-06 00:00:00	\N	\N	32020		\N	170211	0	396275006	80180		0
43230	2574	28060	1975-05-04	1975-05-04 00:00:00	1975-05-16	1975-05-16 00:00:00	32020		\N	170507	0	43878008	28060		0
53957	3195	4112343	2007-01-24	2007-01-24 00:00:00	2007-02-05	2007-02-05 00:00:00	32020		\N	212544	0	195662009	4112343		0
43557	2594	4285898	2015-01-07	2015-01-07 00:00:00	\N	\N	32020		\N	171715	0	68496003	4285898		0
43797	2609	40481087	1959-11-29	1959-11-29 00:00:00	1959-12-13	1959-12-13 00:00:00	32020		\N	172470	0	444814009	40481087		0
43920	2615	40481087	2016-11-17	2016-11-17 00:00:00	2016-12-08	2016-12-08 00:00:00	32020		\N	172931	0	444814009	40481087		0
44117	2622	40481087	1969-06-20	1969-06-20 00:00:00	1969-06-27	1969-06-27 00:00:00	32020		\N	173474	0	444814009	40481087		0
44288	2633	375671	1965-05-14	1965-05-14 00:00:00	1965-07-13	1965-07-13 00:00:00	32020		\N	174227	0	62564004	375671		0
54980	3253	440086	1981-05-16	1981-05-16 00:00:00	1988-05-24	1988-05-24 00:00:00	32020		\N	216323	0	192127007	440086		0
55153	3263	378001	1995-09-11	1995-09-11 00:00:00	1995-10-11	1995-10-11 00:00:00	32020		\N	216901	0	62106007	378001		0
44805	2666	4112343	1952-05-13	1952-05-13 00:00:00	1952-05-25	1952-05-25 00:00:00	32020		\N	176621	0	195662009	4112343		0
44952	2675	381316	2012-08-19	2012-08-19 00:00:00	\N	\N	32020		\N	177310	0	230690007	381316		0
55620	3293	28060	1996-11-07	1996-11-07 00:00:00	1996-11-19	1996-11-19 00:00:00	32020		\N	218734	0	43878008	28060		0
45195	2688	40481087	1984-10-29	1984-10-29 00:00:00	1984-11-12	1984-11-12 00:00:00	32020		\N	178145	0	444814009	40481087		0
55974	3314	372328	1964-01-30	1964-01-30 00:00:00	1964-02-13	1964-02-13 00:00:00	32020		\N	220090	0	65363002	372328		0
45620	2711	4112343	1953-05-15	1953-05-15 00:00:00	1953-05-28	1953-05-28 00:00:00	32020		\N	179648	0	195662009	4112343		0
45807	2724	80180	1999-11-23	1999-11-23 00:00:00	\N	\N	32020		\N	180437	0	396275006	80180		0
45945	2736	372328	1970-05-03	1970-05-03 00:00:00	1970-07-15	1970-07-15 00:00:00	32020		\N	181106	0	65363002	372328		0
56694	3363	4310024	1993-09-17	1993-09-17 00:00:00	\N	\N	32020		\N	222980	0	424802006	4310024		0
46305	2758	4310024	1978-06-20	1978-06-20 00:00:00	\N	\N	32020		\N	182456	0	424802006	4310024		0
46419	2765	260139	1949-06-04	1949-06-04 00:00:00	1949-06-18	1949-06-18 00:00:00	32020		\N	182938	0	10509002	260139		0
46537	2770	260139	1952-01-28	1952-01-28 00:00:00	1952-02-11	1952-02-11 00:00:00	32020		\N	183397	0	10509002	260139		0
46765	2782	40481087	1989-07-25	1989-07-25 00:00:00	1989-08-15	1989-08-15 00:00:00	32020		\N	184437	0	444814009	40481087		0
46934	2792	4112343	1963-10-16	1963-10-16 00:00:00	1963-10-24	1963-10-24 00:00:00	32020		\N	185025	0	195662009	4112343		0
47143	2802	4112343	1984-07-12	1984-07-12 00:00:00	1984-07-19	1984-07-19 00:00:00	32020		\N	185685	0	195662009	4112343		0
47302	2813	40481087	1944-03-09	1944-03-09 00:00:00	1944-03-30	1944-03-30 00:00:00	32020		\N	186376	0	444814009	40481087		0
47441	2821	4278672	1990-05-05	1990-05-05 00:00:00	1990-06-04	1990-06-04 00:00:00	32020		\N	186853	0	65966004	4278672		0
47603	2830	4146173	1989-11-05	1989-11-05 00:00:00	1990-01-04	1990-01-04 00:00:00	32020		\N	187760	0	307731004	4146173		0
47696	2835	81151	2018-01-29	2018-01-29 00:00:00	2018-03-05	2018-03-05 00:00:00	32020		\N	188347	0	44465007	81151		0
47889	2844	260139	1959-09-19	1959-09-19 00:00:00	1959-09-26	1959-09-26 00:00:00	32020		\N	188826	0	10509002	260139		0
58643	3477	40481087	2006-08-17	2006-08-17 00:00:00	2006-09-07	2006-09-07 00:00:00	32020		\N	230608	0	444814009	40481087		0
48191	2858	28060	1918-05-20	1918-05-20 00:00:00	1918-05-30	1918-05-30 00:00:00	32020		\N	189822	0	43878008	28060		0
48348	2864	372328	1945-02-24	1945-02-24 00:00:00	1945-04-12	1945-04-12 00:00:00	32020		\N	190533	0	65363002	372328		0
59154	3509	40481087	1946-04-01	1946-04-01 00:00:00	1946-04-08	1946-04-08 00:00:00	32020		\N	232733	0	444814009	40481087		0
59301	3516	4283893	1967-03-14	1967-03-14 00:00:00	1967-05-23	1967-05-23 00:00:00	32020		\N	233322	0	36971009	4283893		0
48904	2895	372328	1966-04-09	1966-04-09 00:00:00	1967-03-19	1967-03-19 00:00:00	32020		\N	192742	0	65363002	372328		0
59605	3532	81893	2006-06-28	2006-06-28 00:00:00	\N	\N	32020		\N	234625	0	64766004	81893		0
59790	3542	4155034	2009-05-18	2009-05-18 00:00:00	2009-06-08	2009-06-08 00:00:00	32020		\N	235325	0	283371005	4155034		0
59938	3552	260139	1964-02-14	1964-02-14 00:00:00	1964-02-21	1964-02-21 00:00:00	32020		\N	235843	0	10509002	260139		0
49625	2936	40481087	1997-01-10	1997-01-10 00:00:00	1997-01-17	1997-01-17 00:00:00	32020		\N	195745	0	444814009	40481087		0
49795	2944	40481087	2001-02-16	2001-02-16 00:00:00	2001-02-23	2001-02-23 00:00:00	32020		\N	196406	0	444814009	40481087		0
49823	2945	81151	1974-03-01	1974-03-01 00:00:00	1974-04-05	1974-04-05 00:00:00	32020		\N	196484	0	44465007	81151		0
50104	2960	4112343	1969-08-12	1969-08-12 00:00:00	1969-08-23	1969-08-23 00:00:00	32020		\N	197631	0	195662009	4112343		0
50197	2965	40481087	1999-03-31	1999-03-31 00:00:00	1999-04-07	1999-04-07 00:00:00	32020		\N	198014	0	444814009	40481087		0
50456	2985	81151	1993-01-26	1993-01-26 00:00:00	1993-02-09	1993-02-09 00:00:00	32020		\N	199190	0	44465007	81151		0
50579	2991	4112343	1976-07-27	1976-07-27 00:00:00	1976-08-07	1976-08-07 00:00:00	32020		\N	199668	0	195662009	4112343		0
50748	3001	4027663	1974-02-11	1974-02-11 00:00:00	\N	\N	32020		\N	200299	0	13200003	4027663		0
50899	3011	28060	2003-04-02	2003-04-02 00:00:00	2003-04-09	2003-04-09 00:00:00	32020		\N	200824	0	43878008	28060		0
51006	3019	4310024	2014-02-19	2014-02-19 00:00:00	\N	\N	32020		\N	201345	0	424802006	4310024		0
61810	3650	260139	2000-03-21	2000-03-21 00:00:00	2000-03-28	2000-03-28 00:00:00	32020		\N	242994	0	10509002	260139		0
51446	3053	40481087	2002-02-23	2002-02-23 00:00:00	2002-03-02	2002-03-02 00:00:00	32020		\N	203126	0	444814009	40481087		0
51562	3060	4112343	1985-07-01	1985-07-01 00:00:00	1985-07-10	1985-07-10 00:00:00	32020		\N	203612	0	195662009	4112343		0
54386	3221	80180	2000-06-11	2000-06-11 00:00:00	\N	\N	32020		\N	214057	0	396275006	80180		0
62276	3678	260139	2016-02-16	2016-02-16 00:00:00	2016-02-23	2016-02-23 00:00:00	32020		\N	244589	0	10509002	260139		0
51942	3079	260139	1995-08-30	1995-08-30 00:00:00	1995-09-13	1995-09-13 00:00:00	32020		\N	204872	0	10509002	260139		0
52068	3083	260139	1951-05-30	1951-05-30 00:00:00	1951-06-13	1951-06-13 00:00:00	32020		\N	205329	0	10509002	260139		0
52254	3093	4112343	1998-04-28	1998-04-28 00:00:00	1998-05-11	1998-05-11 00:00:00	32020		\N	205930	0	195662009	4112343		0
52346	3100	260139	1959-12-22	1959-12-22 00:00:00	1959-12-29	1959-12-29 00:00:00	32020		\N	206217	0	10509002	260139		0
63175	3731	4294548	1980-01-27	1980-01-27 00:00:00	1980-05-11	1980-05-11 00:00:00	32020		\N	247922	0	75498004	4294548		0
63289	3736	40481087	1986-01-02	1986-01-02 00:00:00	1986-01-16	1986-01-16 00:00:00	32020		\N	248328	0	444814009	40481087		0
63440	3746	30753	1985-09-19	1985-09-19 00:00:00	\N	\N	32020		\N	249015	0	16761005	30753		0
63632	3757	40481087	1967-07-15	1967-07-15 00:00:00	1967-07-29	1967-07-29 00:00:00	32020		\N	249734	0	444814009	40481087		0
42635	2541	260139	1987-03-01	1987-03-01 00:00:00	1987-03-08	1987-03-08 00:00:00	32020		\N	168016	0	10509002	260139		0
53328	3159	381316	2001-05-03	2001-05-03 00:00:00	\N	\N	32020		\N	210030	0	230690007	381316		0
53459	3168	260139	2003-10-17	2003-10-17 00:00:00	2003-10-24	2003-10-24 00:00:00	32020		\N	210613	0	10509002	260139		0
43136	2570	40481087	1970-07-22	1970-07-22 00:00:00	1970-08-12	1970-08-12 00:00:00	32020		\N	170211	0	444814009	40481087		0
43231	2574	80180	2005-05-08	2005-05-08 00:00:00	\N	\N	32020		\N	170470	0	396275006	80180		0
53958	3195	380378	1953-11-21	1953-11-21 00:00:00	\N	\N	32020		\N	212563	0	84757009	380378		0
43558	2594	80180	2015-05-07	2015-05-07 00:00:00	\N	\N	32020		\N	171715	0	396275006	80180		0
43798	2609	440086	1967-04-30	1967-04-30 00:00:00	1976-05-07	1976-05-07 00:00:00	32020		\N	172497	0	192127007	440086		0
43921	2615	260139	1993-01-28	1993-01-28 00:00:00	1993-02-11	1993-02-11 00:00:00	32020		\N	172929	0	10509002	260139		0
44118	2622	40481087	1933-09-28	1933-09-28 00:00:00	1933-10-05	1933-10-05 00:00:00	32020		\N	173459	0	444814009	40481087		0
44289	2633	40481087	1991-12-13	1991-12-13 00:00:00	1991-12-20	1991-12-20 00:00:00	32020		\N	174234	0	444814009	40481087		0
54981	3253	133834	1972-05-15	1972-05-15 00:00:00	\N	\N	32020		\N	216288	0	24079001	133834		0
55154	3263	40481087	1997-04-02	1997-04-02 00:00:00	1997-04-16	1997-04-16 00:00:00	32020		\N	216962	0	444814009	40481087		0
44806	2666	4152936	1955-12-19	1955-12-19 00:00:00	1956-01-09	1956-01-09 00:00:00	32020		\N	176681	0	283385000	4152936		0
44953	2675	4218389	1996-10-20	1996-10-20 00:00:00	1996-11-10	1996-11-10 00:00:00	32020		\N	177235	0	39848009	4218389		0
55621	3293	28060	1940-02-14	1940-02-14 00:00:00	1940-02-23	1940-02-23 00:00:00	32020		\N	218661	0	43878008	28060		0
45196	2688	40481087	1973-05-15	1973-05-15 00:00:00	1973-05-22	1973-05-22 00:00:00	32020		\N	178150	0	444814009	40481087		0
55975	3314	28060	1980-04-30	1980-04-30 00:00:00	1980-05-10	1980-05-10 00:00:00	32020		\N	220075	0	43878008	28060		0
45621	2711	260139	1968-05-27	1968-05-27 00:00:00	1968-06-03	1968-06-03 00:00:00	32020		\N	179631	0	10509002	260139		0
45808	2724	4116491	1989-05-14	1989-05-14 00:00:00	1989-07-13	1989-07-13 00:00:00	32020		\N	180486	0	301011002	4116491		0
45946	2736	4294548	1981-09-07	1981-09-07 00:00:00	1982-11-01	1982-11-01 00:00:00	32020		\N	181100	0	75498004	4294548		0
56695	3363	30753	1994-07-14	1994-07-14 00:00:00	\N	\N	32020		\N	222980	0	16761005	30753		0
46306	2758	372328	1940-08-28	1940-08-28 00:00:00	1940-11-08	1940-11-08 00:00:00	32020		\N	182407	0	65363002	372328		0
46420	2765	378419	2016-12-27	2016-12-27 00:00:00	\N	\N	32020		\N	182837	0	26929004	378419		0
46538	2770	4294548	1951-03-08	1951-03-08 00:00:00	1951-03-29	1951-03-29 00:00:00	32020		\N	183312	0	75498004	4294548		0
46766	2782	40481087	1943-02-18	1943-02-18 00:00:00	1943-03-04	1943-03-04 00:00:00	32020		\N	184435	0	444814009	40481087		0
46935	2792	40481087	1973-09-19	1973-09-19 00:00:00	1973-10-03	1973-10-03 00:00:00	32020		\N	185045	0	444814009	40481087		0
47144	2802	260139	1961-03-24	1961-03-24 00:00:00	1961-04-07	1961-04-07 00:00:00	32020		\N	185739	0	10509002	260139		0
47303	2813	40481087	1937-01-08	1937-01-08 00:00:00	1937-01-15	1937-01-15 00:00:00	32020		\N	186429	0	444814009	40481087		0
47442	2821	40481087	1928-07-18	1928-07-18 00:00:00	1928-07-25	1928-07-25 00:00:00	32020		\N	186948	0	444814009	40481087		0
47604	2830	40481087	1996-08-12	1996-08-12 00:00:00	1996-08-26	1996-08-26 00:00:00	32020		\N	187754	0	444814009	40481087		0
47697	2835	381316	1988-07-05	1988-07-05 00:00:00	\N	\N	32020		\N	188306	0	230690007	381316		0
47890	2844	40481087	1981-03-21	1981-03-21 00:00:00	1981-04-11	1981-04-11 00:00:00	32020		\N	188811	0	444814009	40481087		0
58644	3477	4112343	1968-02-22	1968-02-22 00:00:00	1968-03-04	1968-03-04 00:00:00	32020		\N	230687	0	195662009	4112343		0
48192	2858	40481087	1978-08-09	1978-08-09 00:00:00	1978-08-23	1978-08-23 00:00:00	32020		\N	189886	0	444814009	40481087		0
48349	2864	260139	1998-09-01	1998-09-01 00:00:00	1998-09-08	1998-09-08 00:00:00	32020		\N	190469	0	10509002	260139		0
59155	3509	4112343	1946-10-25	1946-10-25 00:00:00	1946-11-04	1946-11-04 00:00:00	32020		\N	232736	0	195662009	4112343		0
59302	3516	4112343	1946-06-25	1946-06-25 00:00:00	1946-07-05	1946-07-05 00:00:00	32020		\N	233291	0	195662009	4112343		0
48905	2895	372328	1961-11-01	1961-11-01 00:00:00	1961-12-17	1961-12-17 00:00:00	32020		\N	192715	0	65363002	372328		0
59606	3532	4112343	1989-12-13	1989-12-13 00:00:00	1989-12-26	1989-12-26 00:00:00	32020		\N	234634	0	195662009	4112343		0
59791	3542	80180	1980-08-05	1980-08-05 00:00:00	\N	\N	32020		\N	235285	0	396275006	80180		0
59939	3552	260139	1961-04-24	1961-04-24 00:00:00	1961-05-08	1961-05-08 00:00:00	32020		\N	235785	0	10509002	260139		0
49626	2936	40481087	1995-08-03	1995-08-03 00:00:00	1995-08-10	1995-08-10 00:00:00	32020		\N	195744	0	444814009	40481087		0
49796	2945	261325	1967-09-19	1967-09-19 00:00:00	\N	\N	32020		\N	196537	0	87433001	261325		0
49824	2945	28060	1992-03-25	1992-03-25 00:00:00	1992-04-04	1992-04-04 00:00:00	32020		\N	196542	0	43878008	28060		0
50105	2960	4156265	2009-03-24	2009-03-24 00:00:00	2009-04-07	2009-04-07 00:00:00	32020		\N	197610	0	370247008	4156265		0
50198	2965	260139	1985-02-06	1985-02-06 00:00:00	1985-02-13	1985-02-13 00:00:00	32020		\N	197909	0	10509002	260139		0
50457	2985	321042	1967-06-17	1967-06-17 00:00:00	\N	\N	32020		\N	199186	0	410429000	321042		0
50580	2991	4112343	1966-06-05	1966-06-05 00:00:00	1966-06-17	1966-06-17 00:00:00	32020		\N	199667	0	195662009	4112343		0
50749	3001	40481087	1958-04-25	1958-04-25 00:00:00	1958-05-02	1958-05-02 00:00:00	32020		\N	200268	0	444814009	40481087		0
50900	3011	4112343	2014-09-09	2014-09-09 00:00:00	2014-09-22	2014-09-22 00:00:00	32020		\N	200838	0	195662009	4112343		0
51007	3019	81893	2014-03-21	2014-03-21 00:00:00	\N	\N	32020		\N	201345	0	64766004	81893		0
61811	3650	372328	1931-06-04	1931-06-04 00:00:00	1932-03-18	1932-03-18 00:00:00	32020		\N	242946	0	65363002	372328		0
51447	3053	4134304	1997-10-31	1997-10-31 00:00:00	1998-01-29	1998-01-29 00:00:00	32020		\N	203107	0	263102004	4134304		0
51563	3060	40481087	1925-04-16	1925-04-16 00:00:00	1925-04-30	1925-04-30 00:00:00	32020		\N	203552	0	444814009	40481087		0
62277	3678	4285898	2016-11-02	2016-11-02 00:00:00	\N	\N	32020		\N	244589	0	68496003	4285898		0
51943	3079	40481087	1997-08-14	1997-08-14 00:00:00	1997-08-28	1997-08-28 00:00:00	32020		\N	204907	0	444814009	40481087		0
52069	3083	4283893	1987-03-06	1987-03-06 00:00:00	1987-04-10	1987-04-10 00:00:00	32020		\N	205322	0	36971009	4283893		0
52255	3093	4283893	2012-04-25	2012-04-25 00:00:00	2012-06-27	2012-06-27 00:00:00	32020		\N	205943	0	36971009	4283893		0
52347	3100	372328	1952-03-31	1952-03-31 00:00:00	1952-05-15	1952-05-15 00:00:00	32020		\N	206219	0	65363002	372328		0
63176	3731	81151	1988-04-14	1988-04-14 00:00:00	1988-05-05	1988-05-05 00:00:00	32020		\N	247936	0	44465007	81151		0
63290	3736	4112343	1957-02-21	1957-02-21 00:00:00	1957-03-06	1957-03-06 00:00:00	32020		\N	248343	0	195662009	4112343		0
63441	3746	4285898	1986-05-17	1986-05-17 00:00:00	\N	\N	32020		\N	249015	0	68496003	4285898		0
63633	3757	260139	1959-05-11	1959-05-11 00:00:00	1959-05-25	1959-05-25 00:00:00	32020		\N	249767	0	10509002	260139		0
42636	2541	381316	1998-08-10	1998-08-10 00:00:00	\N	\N	32020		\N	168027	0	230690007	381316		0
53329	3159	78272	2015-06-01	2015-06-01 00:00:00	2015-06-29	2015-06-29 00:00:00	32020		\N	210082	0	70704007	78272		0
53460	3168	80180	2015-09-27	2015-09-27 00:00:00	\N	\N	32020		\N	210642	0	396275006	80180		0
43137	2570	30753	1970-10-07	1970-10-07 00:00:00	\N	\N	32020		\N	170211	0	16761005	30753		0
43232	2574	40481087	1995-07-29	1995-07-29 00:00:00	1995-08-05	1995-08-05 00:00:00	32020		\N	170451	0	444814009	40481087		0
53960	3195	4029498	1953-11-21	1953-11-21 00:00:00	\N	\N	32020		\N	212563	0	128613002	4029498		0
43559	2594	30753	2014-11-08	2014-11-08 00:00:00	\N	\N	32020		\N	171715	0	16761005	30753		0
43799	2609	260139	2017-03-02	2017-03-02 00:00:00	2017-03-09	2017-03-09 00:00:00	32020		\N	172476	0	10509002	260139		0
43922	2615	40481087	1963-01-23	1963-01-23 00:00:00	1963-02-06	1963-02-06 00:00:00	32020		\N	172848	0	444814009	40481087		0
44119	2622	4266809	1975-03-17	1975-03-17 00:00:00	\N	\N	32020		\N	173467	0	397881000	4266809		0
44290	2633	372328	1951-11-17	1951-11-17 00:00:00	1952-09-25	1952-09-25 00:00:00	32020		\N	174222	0	65363002	372328		0
54982	3253	4296205	2018-08-05	2018-08-05 00:00:00	2018-08-19	2018-08-19 00:00:00	32020		\N	216247	0	403191005	4296205		0
55155	3263	40481087	1955-07-06	1955-07-06 00:00:00	1955-07-27	1955-07-27 00:00:00	32020		\N	216909	0	444814009	40481087		0
44807	2666	81151	1959-12-19	1959-12-19 00:00:00	1960-01-23	1960-01-23 00:00:00	32020		\N	176682	0	44465007	81151		0
44954	2675	260139	1993-02-19	1993-02-19 00:00:00	1993-02-26	1993-02-26 00:00:00	32020		\N	177290	0	10509002	260139		0
55622	3294	4283893	1995-08-26	1995-08-26 00:00:00	1995-11-04	1995-11-04 00:00:00	32020		\N	218857	0	36971009	4283893		0
45197	2688	40481087	1987-07-06	1987-07-06 00:00:00	1987-07-13	1987-07-13 00:00:00	32020		\N	178146	0	444814009	40481087		0
55976	3314	4116491	2009-08-27	2009-08-27 00:00:00	2009-10-18	2009-10-18 00:00:00	32020		\N	220093	0	301011002	4116491		0
45622	2711	28060	2018-06-09	2018-06-09 00:00:00	2018-06-19	2018-06-19 00:00:00	32020		\N	179800	0	43878008	28060		0
45809	2724	4112343	2010-12-17	2010-12-17 00:00:00	2010-12-27	2010-12-27 00:00:00	32020		\N	180463	0	195662009	4112343		0
45947	2736	4294548	2005-01-01	2005-01-01 00:00:00	2005-03-05	2005-03-05 00:00:00	32020		\N	181095	0	75498004	4294548		0
56696	3363	372328	1951-05-01	1951-05-01 00:00:00	1951-06-08	1951-06-08 00:00:00	32020		\N	222957	0	65363002	372328		0
46307	2758	260139	2012-02-07	2012-02-07 00:00:00	2012-02-21	2012-02-21 00:00:00	32020		\N	182490	0	10509002	260139		0
46421	2765	440448	1994-05-08	1994-05-08 00:00:00	\N	\N	32020		\N	182893	0	74400008	440448		0
46539	2770	40481087	1956-08-06	1956-08-06 00:00:00	1956-08-13	1956-08-13 00:00:00	32020		\N	183366	0	444814009	40481087		0
46767	2782	4027663	1944-11-12	1944-11-12 00:00:00	\N	\N	32020		\N	184435	0	13200003	4027663		0
46936	2792	40481087	2006-12-05	2006-12-05 00:00:00	2006-12-12	2006-12-12 00:00:00	32020		\N	185047	0	444814009	40481087		0
57603	3417	81151	1948-04-13	1948-04-13 00:00:00	1948-05-04	1948-05-04 00:00:00	32020		\N	226623	0	44465007	81151		0
47304	2813	4142905	2015-07-18	2015-07-18 00:00:00	2015-09-16	2015-09-16 00:00:00	32020		\N	186417	0	33737001	4142905		0
47443	2822	4156265	1983-07-06	1983-07-06 00:00:00	1983-07-27	1983-07-27 00:00:00	32020		\N	187030	0	370247008	4156265		0
47605	2830	40481087	1974-09-19	1974-09-19 00:00:00	1974-10-10	1974-10-10 00:00:00	32020		\N	187685	0	444814009	40481087		0
47698	2835	40481087	1969-04-18	1969-04-18 00:00:00	1969-05-02	1969-05-02 00:00:00	32020		\N	188319	0	444814009	40481087		0
47891	2844	40481087	1987-10-15	1987-10-15 00:00:00	1987-11-05	1987-11-05 00:00:00	32020		\N	188867	0	444814009	40481087		0
58645	3477	440086	1972-03-25	1972-03-25 00:00:00	1972-07-01	1972-07-01 00:00:00	32020		\N	230648	0	192127007	440086		0
48193	2859	4296204	1992-05-23	1992-05-23 00:00:00	1992-06-13	1992-06-13 00:00:00	32020		\N	190015	0	403190006	4296204		0
48350	2864	40481087	2017-12-15	2017-12-15 00:00:00	2018-01-05	2018-01-05 00:00:00	32020		\N	190517	0	444814009	40481087		0
59156	3509	40481087	2013-08-06	2013-08-06 00:00:00	2013-08-20	2013-08-20 00:00:00	32020		\N	232707	0	444814009	40481087		0
59303	3516	4112343	1979-04-13	1979-04-13 00:00:00	1979-04-22	1979-04-22 00:00:00	32020		\N	233295	0	195662009	4112343		0
48906	2895	4112343	2007-08-07	2007-08-07 00:00:00	2007-08-17	2007-08-17 00:00:00	32020		\N	192694	0	195662009	4112343		0
59607	3532	40481087	1999-08-04	1999-08-04 00:00:00	1999-08-18	1999-08-18 00:00:00	32020		\N	234646	0	444814009	40481087		0
59792	3542	4112343	1941-01-28	1941-01-28 00:00:00	1941-02-06	1941-02-06 00:00:00	32020		\N	235319	0	195662009	4112343		0
59940	3552	4112343	1982-08-05	1982-08-05 00:00:00	1982-08-16	1982-08-16 00:00:00	32020		\N	235804	0	195662009	4112343		0
49627	2936	40481087	1977-02-27	1977-02-27 00:00:00	1977-03-20	1977-03-20 00:00:00	32020		\N	195753	0	444814009	40481087		0
49797	2945	4112343	1964-01-21	1964-01-21 00:00:00	1964-02-03	1964-02-03 00:00:00	32020		\N	196482	0	195662009	4112343		0
49825	2945	40481087	1957-11-07	1957-11-07 00:00:00	1957-11-28	1957-11-28 00:00:00	32020		\N	196480	0	444814009	40481087		0
50106	2960	28060	1969-05-06	1969-05-06 00:00:00	1969-05-13	1969-05-13 00:00:00	32020		\N	197612	0	43878008	28060		0
50199	2965	260139	2000-08-15	2000-08-15 00:00:00	2000-08-29	2000-08-29 00:00:00	32020		\N	197899	0	10509002	260139		0
50459	2985	260139	1982-11-28	1982-11-28 00:00:00	1982-12-05	1982-12-05 00:00:00	32020		\N	199230	0	10509002	260139		0
50581	2992	40481087	1976-11-01	1976-11-01 00:00:00	1976-11-08	1976-11-08 00:00:00	32020		\N	199711	0	444814009	40481087		0
50750	3001	40481087	1984-02-13	1984-02-13 00:00:00	1984-02-20	1984-02-20 00:00:00	32020		\N	200284	0	444814009	40481087		0
50901	3011	40481087	2017-12-16	2017-12-16 00:00:00	2018-01-06	2018-01-06 00:00:00	32020		\N	200832	0	444814009	40481087		0
51008	3019	80180	2015-10-12	2015-10-12 00:00:00	\N	\N	32020		\N	201361	0	396275006	80180		0
61812	3650	260139	1968-09-18	1968-09-18 00:00:00	1968-10-02	1968-10-02 00:00:00	32020		\N	242942	0	10509002	260139		0
51448	3053	40481087	2001-04-13	2001-04-13 00:00:00	2001-04-20	2001-04-20 00:00:00	32020		\N	203145	0	444814009	40481087		0
51564	3060	372328	1926-12-14	1926-12-14 00:00:00	1927-03-05	1927-03-05 00:00:00	32020		\N	203670	0	65363002	372328		0
62278	3678	80180	2017-07-30	2017-07-30 00:00:00	\N	\N	32020		\N	244589	0	396275006	80180		0
51944	3079	372328	1934-07-14	1934-07-14 00:00:00	1934-09-27	1934-09-27 00:00:00	32020		\N	204940	0	65363002	372328		0
52070	3083	28060	1962-01-19	1962-01-19 00:00:00	1962-01-27	1962-01-27 00:00:00	32020		\N	205318	0	43878008	28060		0
52256	3093	28060	1983-01-27	1983-01-27 00:00:00	1983-02-05	1983-02-05 00:00:00	32020		\N	205928	0	43878008	28060		0
52348	3100	372328	1952-09-12	1952-09-12 00:00:00	1952-11-13	1952-11-13 00:00:00	32020		\N	206245	0	65363002	372328		0
63177	3731	40481087	1995-11-25	1995-11-25 00:00:00	1995-12-16	1995-12-16 00:00:00	32020		\N	247950	0	444814009	40481087		0
63291	3736	4294548	1999-06-15	1999-06-15 00:00:00	1999-07-27	1999-07-27 00:00:00	32020		\N	248318	0	75498004	4294548		0
63442	3746	40481087	2007-01-09	2007-01-09 00:00:00	2007-01-30	2007-01-30 00:00:00	32020		\N	248981	0	444814009	40481087		0
63634	3757	260139	2004-11-20	2004-11-20 00:00:00	2004-12-04	2004-12-04 00:00:00	32020		\N	249780	0	10509002	260139		0
42637	2542	4112343	1984-05-23	1984-05-23 00:00:00	1984-06-05	1984-06-05 00:00:00	32020		\N	168105	0	195662009	4112343		0
53330	3159	4237458	1994-12-18	1994-12-18 00:00:00	1995-02-16	1995-02-16 00:00:00	32020		\N	210081	0	58150001	4237458		0
53461	3168	28060	1988-09-07	1988-09-07 00:00:00	1988-09-18	1988-09-18 00:00:00	32020		\N	210643	0	43878008	28060		0
43138	2570	4112343	1947-12-29	1947-12-29 00:00:00	1948-01-06	1948-01-06 00:00:00	32020		\N	170165	0	195662009	4112343		0
43233	2574	4112343	1996-12-04	1996-12-04 00:00:00	1996-12-15	1996-12-15 00:00:00	32020		\N	170508	0	195662009	4112343		0
53961	3195	4134304	1962-04-13	1962-04-13 00:00:00	1962-05-13	1962-05-13 00:00:00	32020		\N	212591	0	263102004	4134304		0
43800	2609	4113008	1961-04-16	1961-04-16 00:00:00	1961-05-07	1961-05-07 00:00:00	32020		\N	172493	0	284549007	4113008		0
43923	2615	40481087	1980-02-07	1980-02-07 00:00:00	1980-02-21	1980-02-21 00:00:00	32020		\N	172851	0	444814009	40481087		0
44120	2622	80180	1975-03-17	1975-03-17 00:00:00	\N	\N	32020		\N	173467	0	396275006	80180		0
44291	2633	372328	1948-05-13	1948-05-13 00:00:00	1948-06-24	1948-06-24 00:00:00	32020		\N	174264	0	65363002	372328		0
54983	3253	40481087	1976-05-17	1976-05-17 00:00:00	1976-05-31	1976-05-31 00:00:00	32020		\N	216322	0	444814009	40481087		0
55156	3263	378001	1949-07-30	1949-07-30 00:00:00	1949-09-28	1949-09-28 00:00:00	32020		\N	216906	0	62106007	378001		0
44808	2666	4112343	2016-12-21	2016-12-21 00:00:00	2016-12-28	2016-12-28 00:00:00	32020		\N	176606	0	195662009	4112343		0
44955	2675	260139	1993-09-25	1993-09-25 00:00:00	1993-10-02	1993-10-02 00:00:00	32020		\N	177270	0	10509002	260139		0
55623	3294	4112343	2015-04-10	2015-04-10 00:00:00	2015-04-18	2015-04-18 00:00:00	32020		\N	218811	0	195662009	4112343		0
45198	2688	40481087	2001-09-21	2001-09-21 00:00:00	2001-10-05	2001-10-05 00:00:00	32020		\N	178124	0	444814009	40481087		0
55977	3314	260139	1986-08-05	1986-08-05 00:00:00	1986-08-12	1986-08-12 00:00:00	32020		\N	220076	0	10509002	260139		0
45623	2711	4043241	2010-11-15	2010-11-15 00:00:00	\N	\N	32020		\N	179812	0	230265002	4043241		0
45810	2724	4112343	1979-08-22	1979-08-22 00:00:00	1979-09-02	1979-09-02 00:00:00	32020		\N	180498	0	195662009	4112343		0
45948	2736	257012	1981-11-16	1981-11-16 00:00:00	\N	\N	32020		\N	181092	0	40055000	257012		0
56697	3363	4027663	1985-02-21	1985-02-21 00:00:00	\N	\N	32020		\N	222978	0	13200003	4027663		0
46308	2758	260139	1996-01-08	1996-01-08 00:00:00	1996-01-22	1996-01-22 00:00:00	32020		\N	182481	0	10509002	260139		0
46422	2765	4112343	1936-05-15	1936-05-15 00:00:00	1936-05-25	1936-05-25 00:00:00	32020		\N	182905	0	195662009	4112343		0
46540	2770	4112343	1935-06-23	1935-06-23 00:00:00	1935-07-04	1935-07-04 00:00:00	32020		\N	183332	0	195662009	4112343		0
46768	2782	4113008	1945-07-03	1945-07-03 00:00:00	1945-07-24	1945-07-24 00:00:00	32020		\N	184404	0	284549007	4113008		0
46937	2792	4059173	1958-11-01	1958-11-01 00:00:00	1958-12-01	1958-12-01 00:00:00	32020		\N	185032	0	16114001	4059173		0
57604	3417	40481087	2010-10-03	2010-10-03 00:00:00	2010-10-17	2010-10-17 00:00:00	32020		\N	226672	0	444814009	40481087		0
47305	2813	260139	1980-06-14	1980-06-14 00:00:00	1980-06-21	1980-06-21 00:00:00	32020		\N	186432	0	10509002	260139		0
47444	2822	260139	1990-09-16	1990-09-16 00:00:00	1990-09-30	1990-09-30 00:00:00	32020		\N	186986	0	10509002	260139		0
47606	2830	260139	1992-06-18	1992-06-18 00:00:00	1992-07-02	1992-07-02 00:00:00	32020		\N	187704	0	10509002	260139		0
47699	2835	4283893	1938-05-27	1938-05-27 00:00:00	1938-09-09	1938-09-09 00:00:00	32020		\N	188315	0	36971009	4283893		0
47892	2844	40481087	1975-07-08	1975-07-08 00:00:00	1975-07-15	1975-07-15 00:00:00	32020		\N	188828	0	444814009	40481087		0
58646	3477	40481087	1987-06-01	1987-06-01 00:00:00	1987-06-22	1987-06-22 00:00:00	32020		\N	230649	0	444814009	40481087		0
48194	2859	4112343	1994-12-21	1994-12-21 00:00:00	1994-12-31	1994-12-31 00:00:00	32020		\N	190004	0	195662009	4112343		0
48351	2864	257012	1994-07-31	1994-07-31 00:00:00	\N	\N	32020		\N	190500	0	40055000	257012		0
59157	3509	260139	1965-05-11	1965-05-11 00:00:00	1965-05-18	1965-05-18 00:00:00	32020		\N	232761	0	10509002	260139		0
59304	3516	260139	1956-11-01	1956-11-01 00:00:00	1956-11-08	1956-11-08 00:00:00	32020		\N	233293	0	10509002	260139		0
48907	2895	260139	2000-03-21	2000-03-21 00:00:00	2000-04-04	2000-04-04 00:00:00	32020		\N	192739	0	10509002	260139		0
59608	3532	4112343	1976-09-10	1976-09-10 00:00:00	1976-09-23	1976-09-23 00:00:00	32020		\N	234590	0	195662009	4112343		0
59793	3542	4113008	1950-11-21	1950-11-21 00:00:00	1950-12-12	1950-12-12 00:00:00	32020		\N	235238	0	284549007	4113008		0
59941	3552	4296205	1979-06-25	1979-06-25 00:00:00	1979-07-23	1979-07-23 00:00:00	32020		\N	235861	0	403191005	4296205		0
49628	2936	28060	1967-03-09	1967-03-09 00:00:00	1967-03-17	1967-03-17 00:00:00	32020		\N	195764	0	43878008	28060		0
49798	2945	40481087	1972-07-18	1972-07-18 00:00:00	1972-08-01	1972-08-01 00:00:00	32020		\N	196514	0	444814009	40481087		0
49826	2945	4156265	1950-08-20	1950-08-20 00:00:00	1950-09-03	1950-09-03 00:00:00	32020		\N	196516	0	370247008	4156265		0
50107	2960	4283893	1993-05-08	1993-05-08 00:00:00	1993-08-07	1993-08-07 00:00:00	32020		\N	197615	0	36971009	4283893		0
50200	2965	4142905	1988-08-01	1988-08-01 00:00:00	1988-08-31	1988-08-31 00:00:00	32020		\N	197986	0	33737001	4142905		0
50460	2985	40481087	2005-04-29	2005-04-29 00:00:00	2005-05-20	2005-05-20 00:00:00	32020		\N	199216	0	444814009	40481087		0
50582	2992	4112343	1992-11-30	1992-11-30 00:00:00	1992-12-13	1992-12-13 00:00:00	32020		\N	199695	0	195662009	4112343		0
50751	3001	81151	1970-07-13	1970-07-13 00:00:00	1970-08-10	1970-08-10 00:00:00	32020		\N	200328	0	44465007	81151		0
50902	3011	4155034	2003-03-14	2003-03-14 00:00:00	2003-04-04	2003-04-04 00:00:00	32020		\N	200849	0	283371005	4155034		0
51009	3019	4266809	2015-10-12	2015-10-12 00:00:00	\N	\N	32020		\N	201361	0	397881000	4266809		0
61813	3650	28060	1938-05-31	1938-05-31 00:00:00	1938-06-10	1938-06-10 00:00:00	32020		\N	242965	0	43878008	28060		0
51449	3053	4116491	2015-02-17	2015-02-17 00:00:00	2015-04-01	2015-04-01 00:00:00	32020		\N	203128	0	301011002	4116491		0
51565	3060	4112343	1999-12-07	1999-12-07 00:00:00	1999-12-15	1999-12-15 00:00:00	32020		\N	203641	0	195662009	4112343		0
62279	3678	28060	1982-03-27	1982-03-27 00:00:00	1982-04-06	1982-04-06 00:00:00	32020		\N	244579	0	43878008	28060		0
51945	3079	78272	1971-03-02	1971-03-02 00:00:00	1971-03-16	1971-03-16 00:00:00	32020		\N	204962	0	70704007	78272		0
52071	3083	4278672	1964-02-04	1964-02-04 00:00:00	1964-05-04	1964-05-04 00:00:00	32020		\N	205269	0	65966004	4278672		0
52257	3093	4112343	1979-02-01	1979-02-01 00:00:00	1979-02-13	1979-02-13 00:00:00	32020		\N	205913	0	195662009	4112343		0
52349	3100	4112343	1954-11-17	1954-11-17 00:00:00	1954-11-27	1954-11-27 00:00:00	32020		\N	206255	0	195662009	4112343		0
63178	3731	40481087	2000-02-27	2000-02-27 00:00:00	2000-03-05	2000-03-05 00:00:00	32020		\N	247952	0	444814009	40481087		0
63292	3736	4112343	2002-06-18	2002-06-18 00:00:00	2002-07-01	2002-07-01 00:00:00	32020		\N	248320	0	195662009	4112343		0
63443	3746	4294548	1985-02-26	1985-02-26 00:00:00	1985-04-09	1985-04-09 00:00:00	32020		\N	249041	0	75498004	4294548		0
63635	3757	4112343	1988-11-06	1988-11-06 00:00:00	1988-11-16	1988-11-16 00:00:00	32020		\N	249727	0	195662009	4112343		0
42638	2542	260139	2005-04-04	2005-04-04 00:00:00	2005-04-11	2005-04-11 00:00:00	32020		\N	168155	0	10509002	260139		0
53331	3159	4112343	1976-12-08	1976-12-08 00:00:00	1976-12-20	1976-12-20 00:00:00	32020		\N	210090	0	195662009	4112343		0
53462	3168	4278672	2010-12-03	2010-12-03 00:00:00	2011-03-03	2011-03-03 00:00:00	32020		\N	210622	0	65966004	4278672		0
43139	2570	40481087	1936-07-24	1936-07-24 00:00:00	1936-08-07	1936-08-07 00:00:00	32020		\N	170177	0	444814009	40481087		0
43234	2574	81151	1982-08-31	1982-08-31 00:00:00	1982-09-28	1982-09-28 00:00:00	32020		\N	170495	0	44465007	81151		0
53962	3195	40481087	2009-02-28	2009-02-28 00:00:00	2009-03-07	2009-03-07 00:00:00	32020		\N	212574	0	444814009	40481087		0
43561	2594	4027663	2004-02-19	2004-02-19 00:00:00	\N	\N	32020		\N	171682	0	13200003	4027663		0
43801	2609	40481087	1993-12-04	1993-12-04 00:00:00	1993-12-18	1993-12-18 00:00:00	32020		\N	172502	0	444814009	40481087		0
43924	2615	260139	1953-10-16	1953-10-16 00:00:00	1953-10-30	1953-10-30 00:00:00	32020		\N	172902	0	10509002	260139		0
44121	2622	4285898	1975-02-15	1975-02-15 00:00:00	\N	\N	32020		\N	173467	0	68496003	4285898		0
44292	2633	40481087	1997-05-18	1997-05-18 00:00:00	1997-06-08	1997-06-08 00:00:00	32020		\N	174235	0	444814009	40481087		0
54984	3253	4051466	1974-05-25	1974-05-25 00:00:00	1989-09-05	1989-09-05 00:00:00	32020		\N	216321	0	233678006	4051466		0
55157	3263	4109685	1962-04-23	1962-04-23 00:00:00	1962-05-07	1962-05-07 00:00:00	32020		\N	216907	0	284551006	4109685		0
44809	2666	4112343	1992-08-08	1992-08-08 00:00:00	1992-08-18	1992-08-18 00:00:00	32020		\N	176662	0	195662009	4112343		0
44956	2675	40481087	1986-12-09	1986-12-09 00:00:00	1986-12-30	1986-12-30 00:00:00	32020		\N	177269	0	444814009	40481087		0
55624	3294	40481087	1974-06-12	1974-06-12 00:00:00	1974-07-03	1974-07-03 00:00:00	32020		\N	218855	0	444814009	40481087		0
45199	2688	378001	2013-03-28	2013-03-28 00:00:00	2013-04-27	2013-04-27 00:00:00	32020		\N	178164	0	62106007	378001		0
55978	3314	260139	2008-12-21	2008-12-21 00:00:00	2009-01-04	2009-01-04 00:00:00	32020		\N	220087	0	10509002	260139		0
45624	2711	372328	1955-09-28	1955-09-28 00:00:00	1956-05-28	1956-05-28 00:00:00	32020		\N	179801	0	65363002	372328		0
45811	2724	40481087	1985-01-01	1985-01-01 00:00:00	1985-01-15	1985-01-15 00:00:00	32020		\N	180485	0	444814009	40481087		0
45949	2736	372328	1974-06-24	1974-06-24 00:00:00	1974-07-17	1974-07-17 00:00:00	32020		\N	181107	0	65363002	372328		0
56698	3363	4283893	2011-08-11	2011-08-11 00:00:00	2011-12-01	2011-12-01 00:00:00	32020		\N	222937	0	36971009	4283893		0
46309	2758	4112343	2013-01-01	2013-01-01 00:00:00	2013-01-12	2013-01-12 00:00:00	32020		\N	182406	0	195662009	4112343		0
46423	2765	378001	2015-12-12	2015-12-12 00:00:00	2016-02-10	2016-02-10 00:00:00	32020		\N	182895	0	62106007	378001		0
46541	2770	381316	2015-08-15	2015-08-15 00:00:00	\N	\N	32020		\N	183245	0	230690007	381316		0
46769	2782	257012	1997-12-25	1997-12-25 00:00:00	\N	\N	32020		\N	184424	0	40055000	257012		0
46938	2792	260139	2008-05-21	2008-05-21 00:00:00	2008-05-28	2008-05-28 00:00:00	32020		\N	185048	0	10509002	260139		0
57605	3417	4112343	1925-09-01	1925-09-01 00:00:00	1925-09-08	1925-09-08 00:00:00	32020		\N	226579	0	195662009	4112343		0
47306	2813	4112343	1942-03-18	1942-03-18 00:00:00	1942-03-30	1942-03-30 00:00:00	32020		\N	186368	0	195662009	4112343		0
47445	2822	372328	1976-12-18	1976-12-18 00:00:00	1977-03-02	1977-03-02 00:00:00	32020		\N	186989	0	65363002	372328		0
47607	2830	4112343	2008-02-06	2008-02-06 00:00:00	2008-02-18	2008-02-18 00:00:00	32020		\N	187689	0	195662009	4112343		0
47700	2835	40481087	1961-07-31	1961-07-31 00:00:00	1961-08-07	1961-08-07 00:00:00	32020		\N	188317	0	444814009	40481087		0
47893	2844	40481087	1976-07-14	1976-07-14 00:00:00	1976-07-21	1976-07-21 00:00:00	32020		\N	188884	0	444814009	40481087		0
58647	3477	4112343	2006-01-02	2006-01-02 00:00:00	2006-01-13	2006-01-13 00:00:00	32020		\N	230679	0	195662009	4112343		0
48195	2859	40481087	1955-02-16	1955-02-16 00:00:00	1955-03-09	1955-03-09 00:00:00	32020		\N	190058	0	444814009	40481087		0
48352	2864	4112343	1994-09-27	1994-09-27 00:00:00	1994-10-08	1994-10-08 00:00:00	32020		\N	190501	0	195662009	4112343		0
59158	3509	81151	1962-04-18	1962-04-18 00:00:00	1962-05-09	1962-05-09 00:00:00	32020		\N	232698	0	44465007	81151		0
59305	3516	255848	2017-12-31	2017-12-31 00:00:00	\N	\N	32020		\N	233391	0	233604007	255848		0
48908	2895	40481087	1963-02-22	1963-02-22 00:00:00	1963-03-01	1963-03-01 00:00:00	32020		\N	192690	0	444814009	40481087		0
59609	3532	378001	2011-05-29	2011-05-29 00:00:00	2011-06-28	2011-06-28 00:00:00	32020		\N	234632	0	62106007	378001		0
59794	3542	4278672	2010-07-03	2010-07-03 00:00:00	2010-09-01	2010-09-01 00:00:00	32020		\N	235326	0	65966004	4278672		0
59942	3552	260139	2018-01-13	2018-01-13 00:00:00	2018-01-20	2018-01-20 00:00:00	32020		\N	235852	0	10509002	260139		0
49629	2936	80180	1999-10-16	1999-10-16 00:00:00	\N	\N	32020		\N	195741	0	396275006	80180		0
49799	2945	4112343	1957-12-09	1957-12-09 00:00:00	1957-12-21	1957-12-21 00:00:00	32020		\N	196522	0	195662009	4112343		0
49827	2945	4112343	2002-02-25	2002-02-25 00:00:00	2002-03-09	2002-03-09 00:00:00	32020		\N	196459	0	195662009	4112343		0
50108	2960	4283893	2012-12-14	2012-12-14 00:00:00	2013-02-01	2013-02-01 00:00:00	32020		\N	197622	0	36971009	4283893		0
50201	2965	372328	1972-04-28	1972-04-28 00:00:00	1972-07-31	1972-07-31 00:00:00	32020		\N	197977	0	65363002	372328		0
50461	2985	4218389	2008-12-17	2008-12-17 00:00:00	2009-01-21	2009-01-21 00:00:00	32020		\N	199191	0	39848009	4218389		0
50583	2992	40481087	2009-05-03	2009-05-03 00:00:00	2009-05-24	2009-05-24 00:00:00	32020		\N	199753	0	444814009	40481087		0
50752	3001	40481087	1980-01-08	1980-01-08 00:00:00	1980-01-15	1980-01-15 00:00:00	32020		\N	200315	0	444814009	40481087		0
50903	3011	80180	2009-02-15	2009-02-15 00:00:00	\N	\N	32020		\N	200813	0	396275006	80180		0
51010	3019	4112343	1988-05-08	1988-05-08 00:00:00	1988-05-21	1988-05-21 00:00:00	32020		\N	201353	0	195662009	4112343		0
61814	3650	4112343	1971-10-17	1971-10-17 00:00:00	1971-10-28	1971-10-28 00:00:00	32020		\N	242988	0	195662009	4112343		0
51450	3053	4109685	1982-11-05	1982-11-05 00:00:00	1982-11-19	1982-11-19 00:00:00	32020		\N	203124	0	284551006	4109685		0
51566	3060	260139	1987-03-09	1987-03-09 00:00:00	1987-03-16	1987-03-16 00:00:00	32020		\N	203544	0	10509002	260139		0
62280	3678	4112343	2014-09-07	2014-09-07 00:00:00	2014-09-15	2014-09-15 00:00:00	32020		\N	244588	0	195662009	4112343		0
51946	3079	40481087	2014-09-27	2014-09-27 00:00:00	2014-10-04	2014-10-04 00:00:00	32020		\N	204909	0	444814009	40481087		0
52072	3083	40481087	1983-11-24	1983-11-24 00:00:00	1983-12-15	1983-12-15 00:00:00	32020		\N	205321	0	444814009	40481087		0
52258	3093	4112343	1989-11-02	1989-11-02 00:00:00	1989-11-09	1989-11-09 00:00:00	32020		\N	205954	0	195662009	4112343		0
52350	3100	4027663	1982-11-29	1982-11-29 00:00:00	\N	\N	32020		\N	206233	0	13200003	4027663		0
63179	3731	40479768	1984-07-27	1984-07-27 00:00:00	1984-09-02	1984-09-02 00:00:00	32020		\N	247955	0	444470001	40479768		0
63301	3739	440086	1979-08-11	1979-08-11 00:00:00	1985-08-19	1985-08-19 00:00:00	32020		\N	248444	0	192127007	440086		0
63444	3746	260139	1945-01-04	1945-01-04 00:00:00	1945-01-18	1945-01-18 00:00:00	32020		\N	248977	0	10509002	260139		0
63636	3757	260139	1973-01-12	1973-01-12 00:00:00	1973-01-19	1973-01-19 00:00:00	32020		\N	249726	0	10509002	260139		0
42639	2542	4294548	2006-07-24	2006-07-24 00:00:00	2006-08-14	2006-08-14 00:00:00	32020		\N	168156	0	75498004	4294548		0
53332	3159	260139	2002-08-01	2002-08-01 00:00:00	2002-08-15	2002-08-15 00:00:00	32020		\N	210076	0	10509002	260139		0
53463	3168	4059173	1987-03-13	1987-03-13 00:00:00	1987-06-11	1987-06-11 00:00:00	32020		\N	210648	0	16114001	4059173		0
43140	2570	40481087	1990-05-09	1990-05-09 00:00:00	1990-05-23	1990-05-23 00:00:00	32020		\N	170213	0	444814009	40481087		0
43235	2574	81151	1973-01-30	1973-01-30 00:00:00	1973-03-06	1973-03-06 00:00:00	32020		\N	170493	0	44465007	81151		0
53963	3195	4112343	1979-06-24	1979-06-24 00:00:00	1979-07-04	1979-07-04 00:00:00	32020		\N	212565	0	195662009	4112343		0
43562	2594	260139	2002-04-25	2002-04-25 00:00:00	2002-05-09	2002-05-09 00:00:00	32020		\N	171682	0	10509002	260139		0
43802	2609	440448	1967-05-02	1967-05-02 00:00:00	\N	\N	32020		\N	172494	0	74400008	440448		0
43925	2615	4156265	1956-02-02	1956-02-02 00:00:00	1956-02-16	1956-02-16 00:00:00	32020		\N	172917	0	370247008	4156265		0
44122	2622	260139	1991-08-04	1991-08-04 00:00:00	1991-08-18	1991-08-18 00:00:00	32020		\N	173442	0	10509002	260139		0
44293	2633	40481087	1978-11-01	1978-11-01 00:00:00	1978-11-15	1978-11-15 00:00:00	32020		\N	174233	0	444814009	40481087		0
54985	3254	40481087	1977-05-13	1977-05-13 00:00:00	1977-06-03	1977-06-03 00:00:00	32020		\N	216430	0	444814009	40481087		0
55193	3268	40481087	2004-01-06	2004-01-06 00:00:00	2004-01-20	2004-01-20 00:00:00	32020		\N	217174	0	444814009	40481087		0
44810	2666	81151	1953-01-05	1953-01-05 00:00:00	1953-02-02	1953-02-02 00:00:00	32020		\N	176680	0	44465007	81151		0
44957	2675	40481087	1980-12-20	1980-12-20 00:00:00	1981-01-03	1981-01-03 00:00:00	32020		\N	177277	0	444814009	40481087		0
55625	3294	4112343	1997-11-18	1997-11-18 00:00:00	1997-11-29	1997-11-29 00:00:00	32020		\N	218809	0	195662009	4112343		0
45200	2688	81151	1975-09-09	1975-09-09 00:00:00	1975-10-14	1975-10-14 00:00:00	32020		\N	178163	0	44465007	81151		0
55979	3314	4116491	2015-10-17	2015-10-17 00:00:00	2015-12-06	2015-12-06 00:00:00	32020		\N	220089	0	301011002	4116491		0
45625	2711	40481087	2000-09-02	2000-09-02 00:00:00	2000-09-09	2000-09-09 00:00:00	32020		\N	179729	0	444814009	40481087		0
45812	2724	439777	2013-05-08	2013-05-08 00:00:00	\N	\N	32020		\N	180487	0	271737000	439777		0
45950	2736	372328	1982-08-04	1982-08-04 00:00:00	1983-06-01	1983-06-01 00:00:00	32020		\N	181130	0	65363002	372328		0
56699	3363	40481087	1978-07-29	1978-07-29 00:00:00	1978-08-05	1978-08-05 00:00:00	32020		\N	222988	0	444814009	40481087		0
46310	2758	4266809	1980-06-09	1980-06-09 00:00:00	\N	\N	32020		\N	182489	0	397881000	4266809		0
46424	2765	4112343	1949-03-21	1949-03-21 00:00:00	1949-04-03	1949-04-03 00:00:00	32020		\N	182918	0	195662009	4112343		0
46542	2771	260139	1920-09-15	1920-09-15 00:00:00	1920-09-29	1920-09-29 00:00:00	32020		\N	183508	0	10509002	260139		0
46770	2782	40481087	1987-05-08	1987-05-08 00:00:00	1987-05-29	1987-05-29 00:00:00	32020		\N	184347	0	444814009	40481087		0
46939	2792	4109685	2008-07-25	2008-07-25 00:00:00	2008-08-15	2008-08-15 00:00:00	32020		\N	185041	0	284551006	4109685		0
57606	3417	4142905	2014-06-17	2014-06-17 00:00:00	2014-07-17	2014-07-17 00:00:00	32020		\N	226626	0	33737001	4142905		0
47307	2813	260139	2002-08-10	2002-08-10 00:00:00	2002-08-24	2002-08-24 00:00:00	32020		\N	186433	0	10509002	260139		0
47446	2822	80180	2011-11-30	2011-11-30 00:00:00	\N	\N	32020		\N	187026	0	396275006	80180		0
47608	2830	78272	1987-10-03	1987-10-03 00:00:00	1987-10-17	1987-10-17 00:00:00	32020		\N	187722	0	70704007	78272		0
47701	2835	375671	1935-03-08	1935-03-08 00:00:00	1935-04-07	1935-04-07 00:00:00	32020		\N	188339	0	62564004	375671		0
47894	2844	40480160	2019-04-25	2019-04-25 00:00:00	2019-05-25	2019-05-25 00:00:00	32020		\N	188893	0	443165006	40480160		0
58648	3477	192671	1997-02-12	1997-02-12 00:00:00	\N	\N	32020		\N	230685	0	K92.2	35208414		0
48196	2859	4112343	1953-05-29	1953-05-29 00:00:00	1953-06-05	1953-06-05 00:00:00	32020		\N	190032	0	195662009	4112343		0
48353	2864	4112343	2015-06-15	2015-06-15 00:00:00	2015-06-23	2015-06-23 00:00:00	32020		\N	190471	0	195662009	4112343		0
59159	3509	81151	1943-01-11	1943-01-11 00:00:00	1943-02-01	1943-02-01 00:00:00	32020		\N	232694	0	44465007	81151		0
59306	3516	4112343	1999-10-20	1999-10-20 00:00:00	1999-10-28	1999-10-28 00:00:00	32020		\N	233326	0	195662009	4112343		0
48909	2895	4112343	1975-06-04	1975-06-04 00:00:00	1975-06-11	1975-06-11 00:00:00	32020		\N	192691	0	195662009	4112343		0
59610	3532	40481087	2002-08-10	2002-08-10 00:00:00	2002-08-31	2002-08-31 00:00:00	32020		\N	234647	0	444814009	40481087		0
59795	3542	4112343	1990-05-09	1990-05-09 00:00:00	1990-05-22	1990-05-22 00:00:00	32020		\N	235236	0	195662009	4112343		0
59943	3552	4283893	1984-01-07	1984-01-07 00:00:00	1984-05-26	1984-05-26 00:00:00	32020		\N	235789	0	36971009	4283893		0
49630	2936	4112343	1999-10-14	1999-10-14 00:00:00	1999-10-24	1999-10-24 00:00:00	32020		\N	195741	0	195662009	4112343		0
49800	2945	40481087	1991-12-13	1991-12-13 00:00:00	1991-12-20	1991-12-20 00:00:00	32020		\N	196515	0	444814009	40481087		0
49828	2945	4218389	2010-12-06	2010-12-06 00:00:00	2011-01-10	2011-01-10 00:00:00	32020		\N	196486	0	39848009	4218389		0
50109	2960	372328	1957-11-19	1957-11-19 00:00:00	1958-01-09	1958-01-09 00:00:00	32020		\N	197695	0	65363002	372328		0
50202	2965	40481087	2011-12-05	2011-12-05 00:00:00	2011-12-19	2011-12-19 00:00:00	32020		\N	197901	0	444814009	40481087		0
50462	2985	40481087	2016-03-02	2016-03-02 00:00:00	2016-03-09	2016-03-09 00:00:00	32020		\N	199267	0	444814009	40481087		0
50584	2992	260139	1966-08-29	1966-08-29 00:00:00	1966-09-12	1966-09-12 00:00:00	32020		\N	199693	0	10509002	260139		0
50753	3001	372328	1951-06-27	1951-06-27 00:00:00	1952-01-29	1952-01-29 00:00:00	32020		\N	200242	0	65363002	372328		0
50912	3013	4112343	1984-03-13	1984-03-13 00:00:00	1984-03-24	1984-03-24 00:00:00	32020		\N	200933	0	195662009	4112343		0
51011	3020	40481087	2007-04-04	2007-04-04 00:00:00	2007-04-11	2007-04-11 00:00:00	32020		\N	201382	0	444814009	40481087		0
61815	3650	260139	2007-01-31	2007-01-31 00:00:00	2007-02-14	2007-02-14 00:00:00	32020		\N	242992	0	10509002	260139		0
51451	3053	4112343	1992-11-15	1992-11-15 00:00:00	1992-11-28	1992-11-28 00:00:00	32020		\N	203095	0	195662009	4112343		0
51567	3060	40481087	1964-08-20	1964-08-20 00:00:00	1964-09-10	1964-09-10 00:00:00	32020		\N	203572	0	444814009	40481087		0
62281	3678	81893	2016-01-07	2016-01-07 00:00:00	\N	\N	32020		\N	244588	0	64766004	81893		0
51947	3079	40481087	1948-11-12	1948-11-12 00:00:00	1948-12-03	1948-12-03 00:00:00	32020		\N	204868	0	444814009	40481087		0
52073	3083	40481087	1963-02-07	1963-02-07 00:00:00	1963-02-14	1963-02-14 00:00:00	32020		\N	205324	0	444814009	40481087		0
52259	3093	4156265	1981-02-24	1981-02-24 00:00:00	1981-03-10	1981-03-10 00:00:00	32020		\N	205971	0	370247008	4156265		0
52351	3100	40481087	1987-03-07	1987-03-07 00:00:00	1987-03-14	1987-03-14 00:00:00	32020		\N	206244	0	444814009	40481087		0
63180	3732	4112343	2010-11-01	2010-11-01 00:00:00	2010-11-11	2010-11-11 00:00:00	32020		\N	247980	0	195662009	4112343		0
63302	3739	28060	2001-10-28	2001-10-28 00:00:00	2001-11-08	2001-11-08 00:00:00	32020		\N	248450	0	43878008	28060		0
63445	3746	40481087	1969-02-02	1969-02-02 00:00:00	1969-02-23	1969-02-23 00:00:00	32020		\N	248983	0	444814009	40481087		0
63637	3757	4112343	1997-05-06	1997-05-06 00:00:00	1997-05-14	1997-05-14 00:00:00	32020		\N	249771	0	195662009	4112343		0
42640	2542	80180	2003-03-07	2003-03-07 00:00:00	\N	\N	32020		\N	168183	0	396275006	80180		0
53333	3159	4112343	2012-11-11	2012-11-11 00:00:00	2012-11-18	2012-11-18 00:00:00	32020		\N	210041	0	195662009	4112343		0
53464	3168	40481087	2018-07-05	2018-07-05 00:00:00	2018-07-26	2018-07-26 00:00:00	32020		\N	210615	0	444814009	40481087		0
43141	2570	4112343	1982-10-02	1982-10-02 00:00:00	1982-10-14	1982-10-14 00:00:00	32020		\N	170271	0	195662009	4112343		0
43236	2574	440086	1968-01-02	1968-01-02 00:00:00	1979-01-09	1979-01-09 00:00:00	32020		\N	170497	0	192127007	440086		0
53964	3195	260139	1968-02-13	1968-02-13 00:00:00	1968-02-20	1968-02-20 00:00:00	32020		\N	212511	0	10509002	260139		0
43563	2594	28060	1983-07-30	1983-07-30 00:00:00	1983-08-08	1983-08-08 00:00:00	32020		\N	171681	0	43878008	28060		0
43803	2609	40481087	1986-02-14	1986-02-14 00:00:00	1986-03-07	1986-03-07 00:00:00	32020		\N	172501	0	444814009	40481087		0
43926	2615	4294548	1966-08-13	1966-08-13 00:00:00	1966-09-10	1966-09-10 00:00:00	32020		\N	172850	0	75498004	4294548		0
44123	2622	28060	1945-06-15	1945-06-15 00:00:00	1945-06-28	1945-06-28 00:00:00	32020		\N	173472	0	43878008	28060		0
44294	2633	440086	1958-10-13	1958-10-13 00:00:00	1965-10-21	1965-10-21 00:00:00	32020		\N	174194	0	192127007	440086		0
54986	3254	372328	1964-04-07	1964-04-07 00:00:00	1964-05-10	1964-05-10 00:00:00	32020		\N	216448	0	65363002	372328		0
55194	3268	257012	1992-09-11	1992-09-11 00:00:00	\N	\N	32020		\N	217166	0	40055000	257012		0
44811	2666	4283893	2018-01-19	2018-01-19 00:00:00	2018-02-16	2018-02-16 00:00:00	32020		\N	176623	0	36971009	4283893		0
44958	2675	260139	2013-12-13	2013-12-13 00:00:00	2013-12-20	2013-12-20 00:00:00	32020		\N	177274	0	10509002	260139		0
55626	3294	260139	2008-09-09	2008-09-09 00:00:00	2008-09-16	2008-09-16 00:00:00	32020		\N	218822	0	10509002	260139		0
45201	2688	260139	2008-12-27	2008-12-27 00:00:00	2009-01-10	2009-01-10 00:00:00	32020		\N	178152	0	10509002	260139		0
55980	3314	440086	1969-09-06	1969-09-06 00:00:00	1980-09-13	1980-09-13 00:00:00	32020		\N	220117	0	192127007	440086		0
45626	2711	4112343	2008-02-21	2008-02-21 00:00:00	2008-02-29	2008-02-29 00:00:00	32020		\N	179730	0	195662009	4112343		0
45813	2724	28060	1969-04-19	1969-04-19 00:00:00	1969-04-29	1969-04-29 00:00:00	32020		\N	180482	0	43878008	28060		0
45951	2736	4109685	2019-05-16	2019-05-16 00:00:00	2019-06-06	2019-06-06 00:00:00	32020		\N	181079	0	284551006	4109685		0
56700	3363	4237458	1958-06-28	1958-06-28 00:00:00	1958-09-26	1958-09-26 00:00:00	32020		\N	222950	0	58150001	4237458		0
46311	2758	4112343	1979-12-26	1979-12-26 00:00:00	1980-01-07	1980-01-07 00:00:00	32020		\N	182489	0	195662009	4112343		0
46425	2765	4112343	1963-11-28	1963-11-28 00:00:00	1963-12-05	1963-12-05 00:00:00	32020		\N	182898	0	195662009	4112343		0
46543	2771	4112343	1969-10-11	1969-10-11 00:00:00	1969-10-19	1969-10-19 00:00:00	32020		\N	183527	0	195662009	4112343		0
46771	2782	4112343	1967-09-04	1967-09-04 00:00:00	1967-09-13	1967-09-13 00:00:00	32020		\N	184362	0	195662009	4112343		0
46940	2792	4155034	1972-03-22	1972-03-22 00:00:00	1972-04-05	1972-04-05 00:00:00	32020		\N	185034	0	283371005	4155034		0
57607	3417	40480160	2014-06-17	2014-06-17 00:00:00	2014-07-17	2014-07-17 00:00:00	32020		\N	226626	0	443165006	40480160		0
57769	3427	372328	1970-06-09	1970-06-09 00:00:00	1971-03-17	1971-03-17 00:00:00	32020		\N	227179	0	65363002	372328		0
47447	2822	40481087	1977-03-26	1977-03-26 00:00:00	1977-04-02	1977-04-02 00:00:00	32020		\N	187033	0	444814009	40481087		0
47609	2830	260139	1982-07-02	1982-07-02 00:00:00	1982-07-09	1982-07-09 00:00:00	32020		\N	187708	0	10509002	260139		0
47702	2835	4116491	1957-11-01	1957-11-01 00:00:00	1957-12-14	1957-12-14 00:00:00	32020		\N	188352	0	301011002	4116491		0
47895	2844	4230399	2019-04-25	2019-04-25 00:00:00	2019-05-25	2019-05-25 00:00:00	32020		\N	188893	0	359817006	4230399		0
58649	3477	4283893	2005-08-08	2005-08-08 00:00:00	2005-11-14	2005-11-14 00:00:00	32020		\N	230621	0	36971009	4283893		0
48197	2859	40481087	1988-05-31	1988-05-31 00:00:00	1988-06-21	1988-06-21 00:00:00	32020		\N	190003	0	444814009	40481087		0
48354	2864	4112343	2014-06-06	2014-06-06 00:00:00	2014-06-19	2014-06-19 00:00:00	32020		\N	190530	0	195662009	4112343		0
59160	3509	4112343	1987-11-10	1987-11-10 00:00:00	1987-11-19	1987-11-19 00:00:00	32020		\N	232704	0	195662009	4112343		0
59308	3516	40481087	1969-03-22	1969-03-22 00:00:00	1969-04-12	1969-04-12 00:00:00	32020		\N	233323	0	444814009	40481087		0
48910	2895	40481087	1962-02-27	1962-02-27 00:00:00	1962-03-20	1962-03-20 00:00:00	32020		\N	192701	0	444814009	40481087		0
59611	3532	372328	1973-09-13	1973-09-13 00:00:00	1973-12-16	1973-12-16 00:00:00	32020		\N	234636	0	65363002	372328		0
59796	3542	40481087	1944-02-01	1944-02-01 00:00:00	1944-02-15	1944-02-15 00:00:00	32020		\N	235320	0	444814009	40481087		0
59944	3552	4112343	1997-05-30	1997-05-30 00:00:00	1997-06-06	1997-06-06 00:00:00	32020		\N	235792	0	195662009	4112343		0
49631	2936	40481087	1993-12-15	1993-12-15 00:00:00	1994-01-05	1994-01-05 00:00:00	32020		\N	195756	0	444814009	40481087		0
60259	3566	4112343	2008-05-02	2008-05-02 00:00:00	2008-05-13	2008-05-13 00:00:00	32020		\N	236971	0	195662009	4112343		0
49829	2945	260139	1984-10-10	1984-10-10 00:00:00	1984-10-24	1984-10-24 00:00:00	32020		\N	196544	0	10509002	260139		0
50110	2960	257012	1993-07-17	1993-07-17 00:00:00	\N	\N	32020		\N	197665	0	40055000	257012		0
50203	2965	372328	1970-06-23	1970-06-23 00:00:00	1970-08-03	1970-08-03 00:00:00	32020		\N	197976	0	65363002	372328		0
50463	2986	28060	1949-10-12	1949-10-12 00:00:00	1949-10-24	1949-10-24 00:00:00	32020		\N	199319	0	43878008	28060		0
50585	2992	372328	1962-12-03	1962-12-03 00:00:00	1963-07-12	1963-07-12 00:00:00	32020		\N	199729	0	65363002	372328		0
50754	3001	40481087	1982-11-05	1982-11-05 00:00:00	1982-11-12	1982-11-12 00:00:00	32020		\N	200238	0	444814009	40481087		0
50913	3013	4109685	1952-06-19	1952-06-19 00:00:00	1952-07-03	1952-07-03 00:00:00	32020		\N	200963	0	284551006	4109685		0
51012	3020	4112343	1975-08-27	1975-08-27 00:00:00	1975-09-09	1975-09-09 00:00:00	32020		\N	201390	0	195662009	4112343		0
61816	3650	260139	1977-01-29	1977-01-29 00:00:00	1977-02-12	1977-02-12 00:00:00	32020		\N	242989	0	10509002	260139		0
51452	3053	4112343	2016-12-20	2016-12-20 00:00:00	2017-01-02	2017-01-02 00:00:00	32020		\N	203129	0	195662009	4112343		0
51568	3060	40481087	1962-12-02	1962-12-02 00:00:00	1962-12-23	1962-12-23 00:00:00	32020		\N	203666	0	444814009	40481087		0
62282	3678	4310024	2015-02-11	2015-02-11 00:00:00	\N	\N	32020		\N	244588	0	424802006	4310024		0
51948	3079	4296205	2014-04-04	2014-04-04 00:00:00	2014-05-09	2014-05-09 00:00:00	32020		\N	204966	0	403191005	4296205		0
52074	3083	4218389	1979-06-29	1979-06-29 00:00:00	1979-07-20	1979-07-20 00:00:00	32020		\N	205350	0	39848009	4218389		0
52260	3093	260139	2016-07-30	2016-07-30 00:00:00	2016-08-06	2016-08-06 00:00:00	32020		\N	205910	0	10509002	260139		0
52352	3100	30753	1988-11-22	1988-11-22 00:00:00	\N	\N	32020		\N	206244	0	16761005	30753		0
63181	3732	4112343	1961-07-16	1961-07-16 00:00:00	1961-07-23	1961-07-23 00:00:00	32020		\N	247998	0	195662009	4112343		0
63303	3739	4237458	2006-06-11	2006-06-11 00:00:00	2006-08-10	2006-08-10 00:00:00	32020		\N	248442	0	58150001	4237458		0
63446	3746	195588	1991-11-27	1991-11-27 00:00:00	1992-01-17	1992-01-17 00:00:00	32020		\N	249030	0	38822007	195588		0
63638	3757	40481087	1973-10-01	1973-10-01 00:00:00	1973-10-08	1973-10-08 00:00:00	32020		\N	249770	0	444814009	40481087		0
42641	2542	260139	1989-02-14	1989-02-14 00:00:00	1989-02-21	1989-02-21 00:00:00	32020		\N	168124	0	10509002	260139		0
53334	3159	40481087	2009-02-03	2009-02-03 00:00:00	2009-02-17	2009-02-17 00:00:00	32020		\N	210026	0	444814009	40481087		0
53465	3168	40481087	2015-10-30	2015-10-30 00:00:00	2015-11-13	2015-11-13 00:00:00	32020		\N	210624	0	444814009	40481087		0
43142	2570	372328	2004-03-22	2004-03-22 00:00:00	2005-03-31	2005-03-31 00:00:00	32020		\N	170215	0	65363002	372328		0
43237	2574	40481087	2015-03-29	2015-03-29 00:00:00	2015-04-12	2015-04-12 00:00:00	32020		\N	170460	0	444814009	40481087		0
53965	3195	28060	1962-03-30	1962-03-30 00:00:00	1962-04-10	1962-04-10 00:00:00	32020		\N	212515	0	43878008	28060		0
43564	2594	4237458	1979-09-03	1979-09-03 00:00:00	1979-10-03	1979-10-03 00:00:00	32020		\N	171726	0	58150001	4237458		0
43804	2609	4156265	1967-08-04	1967-08-04 00:00:00	1967-08-25	1967-08-25 00:00:00	32020		\N	172495	0	370247008	4156265		0
43927	2615	40481087	1953-04-23	1953-04-23 00:00:00	1953-05-07	1953-05-07 00:00:00	32020		\N	172925	0	444814009	40481087		0
44124	2624	372328	1993-08-26	1993-08-26 00:00:00	1996-03-14	1996-03-14 00:00:00	32020		\N	173605	0	65363002	372328		0
44295	2633	80180	1981-08-28	1981-08-28 00:00:00	\N	\N	32020		\N	174254	0	396275006	80180		0
54987	3254	81151	1974-09-04	1974-09-04 00:00:00	1974-09-18	1974-09-18 00:00:00	32020		\N	216451	0	44465007	81151		0
55195	3268	4155034	2013-07-25	2013-07-25 00:00:00	2013-08-15	2013-08-15 00:00:00	32020		\N	217214	0	283371005	4155034		0
44812	2666	40481087	1958-02-01	1958-02-01 00:00:00	1958-02-15	1958-02-15 00:00:00	32020		\N	176604	0	444814009	40481087		0
44959	2675	372328	1963-02-18	1963-02-18 00:00:00	1963-07-07	1963-07-07 00:00:00	32020		\N	177245	0	65363002	372328		0
55627	3294	260139	2015-08-13	2015-08-13 00:00:00	2015-08-27	2015-08-27 00:00:00	32020		\N	218823	0	10509002	260139		0
45202	2688	4112343	2005-04-21	2005-04-21 00:00:00	2005-05-03	2005-05-03 00:00:00	32020		\N	178125	0	195662009	4112343		0
55981	3314	4310024	2002-04-26	2002-04-26 00:00:00	\N	\N	32020		\N	220066	0	424802006	4310024		0
45627	2711	28060	1957-05-10	1957-05-10 00:00:00	1957-05-23	1957-05-23 00:00:00	32020		\N	179719	0	43878008	28060		0
45814	2724	4155034	1997-10-30	1997-10-30 00:00:00	1997-11-20	1997-11-20 00:00:00	32020		\N	180435	0	283371005	4155034		0
45952	2736	40481087	2016-01-12	2016-01-12 00:00:00	2016-01-19	2016-01-19 00:00:00	32020		\N	181128	0	444814009	40481087		0
56701	3363	40481087	1996-02-03	1996-02-03 00:00:00	1996-02-10	1996-02-10 00:00:00	32020		\N	222995	0	444814009	40481087		0
46312	2758	80180	1980-06-09	1980-06-09 00:00:00	\N	\N	32020		\N	182489	0	396275006	80180		0
46426	2765	260139	1989-04-07	1989-04-07 00:00:00	1989-04-14	1989-04-14 00:00:00	32020		\N	182942	0	10509002	260139		0
46544	2771	40481087	2015-02-05	2015-02-05 00:00:00	2015-02-19	2015-02-19 00:00:00	32020		\N	183547	0	444814009	40481087		0
46772	2782	4296205	1964-01-07	1964-01-07 00:00:00	1964-01-28	1964-01-28 00:00:00	32020		\N	184407	0	403191005	4296205		0
46941	2792	4027663	1990-09-29	1990-09-29 00:00:00	\N	\N	32020		\N	185017	0	13200003	4027663		0
57608	3417	4112343	2008-09-03	2008-09-03 00:00:00	2008-09-13	2008-09-13 00:00:00	32020		\N	226620	0	195662009	4112343		0
57770	3427	4278672	2013-01-04	2013-01-04 00:00:00	2013-04-04	2013-04-04 00:00:00	32020		\N	227229	0	65966004	4278672		0
47448	2822	4112343	1998-03-01	1998-03-01 00:00:00	1998-03-14	1998-03-14 00:00:00	32020		\N	187011	0	195662009	4112343		0
47610	2830	4084167	1985-11-12	1985-11-12 00:00:00	1985-11-12	1985-11-12 00:00:00	32020		\N	187721	0	241929008	4084167		0
47703	2835	257012	1938-06-24	1938-06-24 00:00:00	\N	\N	32020		\N	188236	0	40055000	257012		0
47896	2844	40481087	2015-10-16	2015-10-16 00:00:00	2015-10-30	2015-10-30 00:00:00	32020		\N	188843	0	444814009	40481087		0
58650	3477	40481087	1964-10-17	1964-10-17 00:00:00	1964-11-07	1964-11-07 00:00:00	32020		\N	230599	0	444814009	40481087		0
48198	2859	40481087	1950-09-26	1950-09-26 00:00:00	1950-10-03	1950-10-03 00:00:00	32020		\N	190021	0	444814009	40481087		0
48355	2864	260139	1954-09-06	1954-09-06 00:00:00	1954-09-13	1954-09-13 00:00:00	32020		\N	190495	0	10509002	260139		0
59161	3509	260139	1961-09-20	1961-09-20 00:00:00	1961-09-27	1961-09-27 00:00:00	32020		\N	232783	0	10509002	260139		0
59309	3516	4237458	1996-09-24	1996-09-24 00:00:00	1996-11-23	1996-11-23 00:00:00	32020		\N	233368	0	58150001	4237458		0
48911	2895	260139	1968-01-29	1968-01-29 00:00:00	1968-02-07	1968-02-07 00:00:00	32020		\N	192745	0	10509002	260139		0
59612	3532	40481087	1971-07-13	1971-07-13 00:00:00	1971-08-03	1971-08-03 00:00:00	32020		\N	234589	0	444814009	40481087		0
59797	3543	4116491	2013-07-01	2013-07-01 00:00:00	2013-08-16	2013-08-16 00:00:00	32020		\N	235372	0	301011002	4116491		0
59945	3552	40481087	1985-03-01	1985-03-01 00:00:00	1985-03-22	1985-03-22 00:00:00	32020		\N	235846	0	444814009	40481087		0
49632	2936	260139	1971-03-03	1971-03-03 00:00:00	1971-03-10	1971-03-10 00:00:00	32020		\N	195766	0	10509002	260139		0
60260	3566	4112343	2000-02-03	2000-02-03 00:00:00	2000-02-11	2000-02-11 00:00:00	32020		\N	236969	0	195662009	4112343		0
49830	2945	40481087	1964-09-07	1964-09-07 00:00:00	1964-09-21	1964-09-21 00:00:00	32020		\N	196523	0	444814009	40481087		0
50111	2960	28060	1955-03-07	1955-03-07 00:00:00	1955-03-14	1955-03-14 00:00:00	32020		\N	197611	0	43878008	28060		0
50204	2965	4048171	1972-03-01	1972-03-01 00:00:00	1993-07-12	1993-07-12 00:00:00	32020		\N	197965	0	232353008	4048171		0
50464	2986	40481087	1971-09-10	1971-09-10 00:00:00	1971-10-01	1971-10-01 00:00:00	32020		\N	199329	0	444814009	40481087		0
50586	2992	4112343	1958-03-13	1958-03-13 00:00:00	1958-03-23	1958-03-23 00:00:00	32020		\N	199692	0	195662009	4112343		0
50755	3001	260139	2013-02-02	2013-02-02 00:00:00	2013-02-16	2013-02-16 00:00:00	32020		\N	200275	0	10509002	260139		0
50914	3013	81151	1971-11-12	1971-11-12 00:00:00	1971-12-17	1971-12-17 00:00:00	32020		\N	200966	0	44465007	81151		0
51013	3020	4112343	1974-11-15	1974-11-15 00:00:00	1974-11-26	1974-11-26 00:00:00	32020		\N	201381	0	195662009	4112343		0
61817	3650	80502	1997-05-30	1997-05-30 00:00:00	\N	\N	32020		\N	242923	0	64859006	80502		0
51453	3053	80180	2018-07-24	2018-07-24 00:00:00	\N	\N	32020		\N	203129	0	396275006	80180		0
51569	3060	40481087	1932-03-08	1932-03-08 00:00:00	1932-03-22	1932-03-22 00:00:00	32020		\N	203569	0	444814009	40481087		0
62283	3678	260139	2008-10-01	2008-10-01 00:00:00	2008-10-08	2008-10-08 00:00:00	32020		\N	244595	0	10509002	260139		0
51949	3079	40481087	1959-03-20	1959-03-20 00:00:00	1959-03-27	1959-03-27 00:00:00	32020		\N	204939	0	444814009	40481087		0
52075	3083	40481087	1975-07-20	1975-07-20 00:00:00	1975-08-03	1975-08-03 00:00:00	32020		\N	205332	0	444814009	40481087		0
52261	3093	40481087	1996-10-19	1996-10-19 00:00:00	1996-11-09	1996-11-09 00:00:00	32020		\N	205929	0	444814009	40481087		0
52353	3100	4310024	1988-06-25	1988-06-25 00:00:00	\N	\N	32020		\N	206244	0	424802006	4310024		0
63182	3732	81893	1992-10-30	1992-10-30 00:00:00	\N	\N	32020		\N	248007	0	64766004	81893		0
63304	3739	4218389	1968-09-07	1968-09-07 00:00:00	1968-09-28	1968-09-28 00:00:00	32020		\N	248441	0	39848009	4218389		0
63447	3746	4027663	1974-12-01	1974-12-01 00:00:00	\N	\N	32020		\N	249033	0	13200003	4027663		0
63639	3757	4146173	1946-02-16	1946-02-16 00:00:00	1946-04-17	1946-04-17 00:00:00	32020		\N	249716	0	307731004	4146173		0
42642	2542	192671	2003-04-24	2003-04-24 00:00:00	\N	\N	32020		\N	168202	0	K92.2	35208414		0
53335	3159	40481087	1993-10-21	1993-10-21 00:00:00	1993-11-11	1993-11-11 00:00:00	32020		\N	210025	0	444814009	40481087		0
53477	3170	81151	1967-10-08	1967-10-08 00:00:00	1967-11-12	1967-11-12 00:00:00	32020		\N	210714	0	44465007	81151		0
43143	2570	4152936	1958-08-21	1958-08-21 00:00:00	1958-09-04	1958-09-04 00:00:00	32020		\N	170197	0	283385000	4152936		0
43238	2574	4112343	1976-06-11	1976-06-11 00:00:00	1976-06-20	1976-06-20 00:00:00	32020		\N	170459	0	195662009	4112343		0
53966	3195	192671	1984-10-22	1984-10-22 00:00:00	\N	\N	32020		\N	212590	0	K92.2	35208414		0
43565	2594	378001	1984-10-06	1984-10-06 00:00:00	1984-11-05	1984-11-05 00:00:00	32020		\N	171727	0	62106007	378001		0
43805	2609	40481087	1997-11-04	1997-11-04 00:00:00	1997-11-11	1997-11-11 00:00:00	32020		\N	172478	0	444814009	40481087		0
43928	2615	378001	1969-07-07	1969-07-07 00:00:00	1969-09-05	1969-09-05 00:00:00	32020		\N	172918	0	62106007	378001		0
44125	2624	81151	2018-12-26	2018-12-26 00:00:00	2019-01-09	2019-01-09 00:00:00	32020		\N	173625	0	44465007	81151		0
44296	2633	4285898	1981-03-31	1981-03-31 00:00:00	\N	\N	32020		\N	174254	0	68496003	4285898		0
54988	3254	4218389	1978-03-31	1978-03-31 00:00:00	1978-05-05	1978-05-05 00:00:00	32020		\N	216452	0	39848009	4218389		0
55196	3268	80180	2009-04-17	2009-04-17 00:00:00	\N	\N	32020		\N	217183	0	396275006	80180		0
44813	2666	260139	2007-06-11	2007-06-11 00:00:00	2007-06-18	2007-06-18 00:00:00	32020		\N	176622	0	10509002	260139		0
44960	2675	4294548	1992-08-06	1992-08-06 00:00:00	1992-08-13	1992-08-13 00:00:00	32020		\N	177281	0	75498004	4294548		0
55629	3294	40481087	1997-09-02	1997-09-02 00:00:00	1997-09-16	1997-09-16 00:00:00	32020		\N	218815	0	444814009	40481087		0
45203	2688	4112343	2014-09-14	2014-09-14 00:00:00	2014-09-24	2014-09-24 00:00:00	32020		\N	178147	0	195662009	4112343		0
55982	3314	4112343	1999-12-11	1999-12-11 00:00:00	1999-12-19	1999-12-19 00:00:00	32020		\N	220066	0	195662009	4112343		0
45628	2711	40481087	1993-10-10	1993-10-10 00:00:00	1993-10-31	1993-10-31 00:00:00	32020		\N	179727	0	444814009	40481087		0
45815	2724	4296205	2011-07-10	2011-07-10 00:00:00	2011-07-24	2011-07-24 00:00:00	32020		\N	180436	0	403191005	4296205		0
45963	2739	4152936	1986-07-23	1986-07-23 00:00:00	1986-08-06	1986-08-06 00:00:00	32020		\N	181239	0	283385000	4152936		0
56702	3363	28060	1965-08-02	1965-08-02 00:00:00	1965-08-15	1965-08-15 00:00:00	32020		\N	222992	0	43878008	28060		0
46313	2758	28060	2012-05-21	2012-05-21 00:00:00	2012-06-03	2012-06-03 00:00:00	32020		\N	182405	0	43878008	28060		0
46427	2765	4112343	2007-08-26	2007-08-26 00:00:00	2007-09-04	2007-09-04 00:00:00	32020		\N	183002	0	195662009	4112343		0
46545	2771	4112343	2001-06-24	2001-06-24 00:00:00	2001-07-03	2001-07-03 00:00:00	32020		\N	183546	0	195662009	4112343		0
46773	2782	4112343	1958-07-22	1958-07-22 00:00:00	1958-08-04	1958-08-04 00:00:00	32020		\N	184344	0	195662009	4112343		0
46942	2792	40481087	2014-07-10	2014-07-10 00:00:00	2014-07-17	2014-07-17 00:00:00	32020		\N	185029	0	444814009	40481087		0
57609	3417	378001	1999-06-06	1999-06-06 00:00:00	1999-07-06	1999-07-06 00:00:00	32020		\N	226625	0	62106007	378001		0
57771	3427	375671	1974-03-02	1974-03-02 00:00:00	1974-04-01	1974-04-01 00:00:00	32020		\N	227227	0	62564004	375671		0
47449	2822	4112343	1999-06-10	1999-06-10 00:00:00	1999-06-17	1999-06-17 00:00:00	32020		\N	187012	0	195662009	4112343		0
47611	2830	40481087	2000-10-09	2000-10-09 00:00:00	2000-10-30	2000-10-30 00:00:00	32020		\N	187766	0	444814009	40481087		0
47704	2835	4112343	1977-04-12	1977-04-12 00:00:00	1977-04-21	1977-04-21 00:00:00	32020		\N	188261	0	195662009	4112343		0
47897	2844	4112343	1982-08-19	1982-08-19 00:00:00	1982-08-26	1982-08-26 00:00:00	32020		\N	188885	0	195662009	4112343		0
58651	3477	260139	1969-03-18	1969-03-18 00:00:00	1969-03-25	1969-03-25 00:00:00	32020		\N	230600	0	10509002	260139		0
48199	2859	80180	1976-10-24	1976-10-24 00:00:00	\N	\N	32020		\N	190034	0	396275006	80180		0
48356	2864	28060	1947-02-15	1947-02-15 00:00:00	1947-02-25	1947-02-25 00:00:00	32020		\N	190492	0	43878008	28060		0
59162	3509	372328	1942-12-12	1942-12-12 00:00:00	1943-03-26	1943-03-26 00:00:00	32020		\N	232708	0	65363002	372328		0
59310	3516	4112343	1993-09-09	1993-09-09 00:00:00	1993-09-18	1993-09-18 00:00:00	32020		\N	233392	0	195662009	4112343		0
48912	2895	28060	1967-07-06	1967-07-06 00:00:00	1967-07-14	1967-07-14 00:00:00	32020		\N	192745	0	43878008	28060		0
59613	3532	372328	1972-09-29	1972-09-29 00:00:00	1972-12-17	1972-12-17 00:00:00	32020		\N	234650	0	65363002	372328		0
59798	3543	260139	1975-05-19	1975-05-19 00:00:00	1975-06-02	1975-06-02 00:00:00	32020		\N	235368	0	10509002	260139		0
59946	3552	372328	1958-10-19	1958-10-19 00:00:00	1959-04-23	1959-04-23 00:00:00	32020		\N	235854	0	65363002	372328		0
49633	2936	40481087	1993-09-27	1993-09-27 00:00:00	1993-10-11	1993-10-11 00:00:00	32020		\N	195781	0	444814009	40481087		0
60261	3566	4112343	1991-11-04	1991-11-04 00:00:00	1991-11-13	1991-11-13 00:00:00	32020		\N	236961	0	195662009	4112343		0
49831	2945	260139	1973-11-18	1973-11-18 00:00:00	1973-12-02	1973-12-02 00:00:00	32020		\N	196540	0	10509002	260139		0
50112	2960	28060	1956-03-19	1956-03-19 00:00:00	1956-03-29	1956-03-29 00:00:00	32020		\N	197629	0	43878008	28060		0
50205	2965	372328	1971-04-30	1971-04-30 00:00:00	1971-08-02	1971-08-02 00:00:00	32020		\N	197903	0	65363002	372328		0
60955	3609	40481087	2012-06-16	2012-06-16 00:00:00	2012-06-23	2012-06-23 00:00:00	32020		\N	239756	0	444814009	40481087		0
50587	2992	260139	1983-11-09	1983-11-09 00:00:00	1983-11-16	1983-11-16 00:00:00	32020		\N	199712	0	10509002	260139		0
50756	3001	4155034	1956-11-27	1956-11-27 00:00:00	1956-12-18	1956-12-18 00:00:00	32020		\N	200326	0	283371005	4155034		0
50915	3013	28060	1997-09-24	1997-09-24 00:00:00	1997-10-03	1997-10-03 00:00:00	32020		\N	200941	0	43878008	28060		0
51014	3020	4109685	1963-01-01	1963-01-01 00:00:00	1963-01-15	1963-01-15 00:00:00	32020		\N	201371	0	284551006	4109685		0
61818	3650	4109685	1986-12-10	1986-12-10 00:00:00	1986-12-24	1986-12-24 00:00:00	32020		\N	242937	0	284551006	4109685		0
51454	3053	4112343	2003-01-09	2003-01-09 00:00:00	2003-01-18	2003-01-18 00:00:00	32020		\N	203146	0	195662009	4112343		0
51570	3060	4278672	1994-08-26	1994-08-26 00:00:00	1994-09-25	1994-09-25 00:00:00	32020		\N	203627	0	65966004	4278672		0
62284	3678	4112343	1992-12-13	1992-12-13 00:00:00	1992-12-22	1992-12-22 00:00:00	32020		\N	244594	0	195662009	4112343		0
51950	3079	81151	2003-07-17	2003-07-17 00:00:00	2003-07-31	2003-07-31 00:00:00	32020		\N	204965	0	44465007	81151		0
52076	3083	4112343	1952-05-27	1952-05-27 00:00:00	1952-06-09	1952-06-09 00:00:00	32020		\N	205330	0	195662009	4112343		0
52262	3093	4116491	1998-06-19	1998-06-19 00:00:00	1998-08-05	1998-08-05 00:00:00	32020		\N	205915	0	301011002	4116491		0
52354	3100	81893	1988-10-23	1988-10-23 00:00:00	\N	\N	32020		\N	206244	0	64766004	81893		0
63183	3732	4310024	1992-03-04	1992-03-04 00:00:00	\N	\N	32020		\N	248007	0	424802006	4310024		0
63305	3739	4278672	2009-08-24	2009-08-24 00:00:00	2009-10-23	2009-10-23 00:00:00	32020		\N	248443	0	65966004	4278672		0
63448	3746	440086	1956-12-05	1956-12-05 00:00:00	1961-12-14	1961-12-14 00:00:00	32020		\N	249028	0	192127007	440086		0
63640	3757	260139	2009-08-19	2009-08-19 00:00:00	2009-08-26	2009-08-26 00:00:00	32020		\N	249717	0	10509002	260139		0
42643	2542	4113008	1998-11-23	1998-11-23 00:00:00	1998-12-07	1998-12-07 00:00:00	32020		\N	168092	0	284549007	4113008		0
53336	3159	40481087	1966-11-17	1966-11-17 00:00:00	1966-11-24	1966-11-24 00:00:00	32020		\N	210073	0	444814009	40481087		0
53478	3170	260139	1968-02-22	1968-02-22 00:00:00	1968-03-07	1968-03-07 00:00:00	32020		\N	210732	0	10509002	260139		0
43144	2570	381316	1992-11-19	1992-11-19 00:00:00	\N	\N	32020		\N	170241	0	230690007	381316		0
43239	2574	378001	2007-01-19	2007-01-19 00:00:00	2007-02-18	2007-02-18 00:00:00	32020		\N	170496	0	62106007	378001		0
53967	3195	260139	1990-03-19	1990-03-19 00:00:00	1990-04-02	1990-04-02 00:00:00	32020		\N	212513	0	10509002	260139		0
43566	2594	40481087	1986-06-20	1986-06-20 00:00:00	1986-07-11	1986-07-11 00:00:00	32020		\N	171699	0	444814009	40481087		0
43806	2609	4112343	1989-01-06	1989-01-06 00:00:00	1989-01-13	1989-01-13 00:00:00	32020		\N	172477	0	195662009	4112343		0
43929	2615	40481087	2006-03-19	2006-03-19 00:00:00	2006-04-02	2006-04-02 00:00:00	32020		\N	172855	0	444814009	40481087		0
44126	2624	4112343	2002-10-06	2002-10-06 00:00:00	2002-10-16	2002-10-16 00:00:00	32020		\N	173593	0	195662009	4112343		0
44297	2633	4266809	1981-08-28	1981-08-28 00:00:00	\N	\N	32020		\N	174254	0	397881000	4266809		0
54989	3254	80180	2005-02-08	2005-02-08 00:00:00	\N	\N	32020		\N	216457	0	396275006	80180		0
55197	3268	4112343	1991-02-09	1991-02-09 00:00:00	1991-02-21	1991-02-21 00:00:00	32020		\N	217173	0	195662009	4112343		0
44814	2666	81151	1971-11-21	1971-11-21 00:00:00	1971-12-12	1971-12-12 00:00:00	32020		\N	176683	0	44465007	81151		0
44961	2675	4294548	2012-10-18	2012-10-18 00:00:00	2012-11-08	2012-11-08 00:00:00	32020		\N	177273	0	75498004	4294548		0
55630	3294	40481087	1976-08-24	1976-08-24 00:00:00	1976-08-31	1976-08-31 00:00:00	32020		\N	218814	0	444814009	40481087		0
45204	2688	40481087	1989-10-05	1989-10-05 00:00:00	1989-10-19	1989-10-19 00:00:00	32020		\N	178123	0	444814009	40481087		0
55983	3314	4112343	1995-03-22	1995-03-22 00:00:00	1995-04-03	1995-04-03 00:00:00	32020		\N	220121	0	195662009	4112343		0
45629	2711	40481087	1999-10-09	1999-10-09 00:00:00	1999-10-30	1999-10-30 00:00:00	32020		\N	179794	0	444814009	40481087		0
56275	3335	257012	1990-02-01	1990-02-01 00:00:00	\N	\N	32020		\N	221275	0	40055000	257012		0
45964	2739	4027663	1985-03-10	1985-03-10 00:00:00	\N	\N	32020		\N	181258	0	13200003	4027663		0
56703	3363	81151	1969-02-21	1969-02-21 00:00:00	1969-03-14	1969-03-14 00:00:00	32020		\N	222953	0	44465007	81151		0
46314	2758	4112343	1976-06-24	1976-06-24 00:00:00	1976-07-01	1976-07-01 00:00:00	32020		\N	182435	0	195662009	4112343		0
46428	2765	261325	2005-10-25	2005-10-25 00:00:00	\N	\N	32020		\N	182914	0	87433001	261325		0
46546	2771	378001	1996-03-01	1996-03-01 00:00:00	1996-04-30	1996-04-30 00:00:00	32020		\N	183477	0	62106007	378001		0
46774	2782	40481087	1923-04-09	1923-04-09 00:00:00	1923-04-30	1923-04-30 00:00:00	32020		\N	184342	0	444814009	40481087		0
46943	2792	260139	2012-04-26	2012-04-26 00:00:00	2012-05-03	2012-05-03 00:00:00	32020		\N	184996	0	10509002	260139		0
57610	3417	4112343	1925-03-21	1925-03-21 00:00:00	1925-03-31	1925-03-31 00:00:00	32020		\N	226578	0	195662009	4112343		0
57772	3427	372328	1967-01-01	1967-01-01 00:00:00	1967-03-15	1967-03-15 00:00:00	32020		\N	227214	0	65363002	372328		0
47450	2822	40481087	1993-12-11	1993-12-11 00:00:00	1993-12-18	1993-12-18 00:00:00	32020		\N	186996	0	444814009	40481087		0
47612	2830	28060	1986-01-24	1986-01-24 00:00:00	1986-01-31	1986-01-31 00:00:00	32020		\N	187806	0	43878008	28060		0
47705	2835	4112343	1982-05-04	1982-05-04 00:00:00	1982-05-14	1982-05-14 00:00:00	32020		\N	188214	0	195662009	4112343		0
47898	2844	4112343	1988-03-28	1988-03-28 00:00:00	1988-04-09	1988-04-09 00:00:00	32020		\N	188806	0	195662009	4112343		0
58652	3477	40481087	1967-04-04	1967-04-04 00:00:00	1967-04-11	1967-04-11 00:00:00	32020		\N	230686	0	444814009	40481087		0
48200	2859	40481087	1975-08-22	1975-08-22 00:00:00	1975-09-05	1975-09-05 00:00:00	32020		\N	190034	0	444814009	40481087		0
48357	2864	40481087	1980-05-26	1980-05-26 00:00:00	1980-06-02	1980-06-02 00:00:00	32020		\N	190552	0	444814009	40481087		0
59163	3509	40481087	1947-02-07	1947-02-07 00:00:00	1947-02-28	1947-02-28 00:00:00	32020		\N	232734	0	444814009	40481087		0
59311	3516	4112343	1976-04-14	1976-04-14 00:00:00	1976-04-27	1976-04-27 00:00:00	32020		\N	233324	0	195662009	4112343		0
48913	2895	260139	1968-06-23	1968-06-23 00:00:00	1968-07-07	1968-07-07 00:00:00	32020		\N	192717	0	10509002	260139		0
59614	3532	4112343	2002-11-04	2002-11-04 00:00:00	2002-11-11	2002-11-11 00:00:00	32020		\N	234600	0	195662009	4112343		0
59799	3543	375671	1966-12-14	1966-12-14 00:00:00	1967-01-13	1967-01-13 00:00:00	32020		\N	235328	0	62564004	375671		0
59947	3552	4283893	1980-09-16	1980-09-16 00:00:00	1980-11-18	1980-11-18 00:00:00	32020		\N	235788	0	36971009	4283893		0
49634	2936	4112343	1978-02-21	1978-02-21 00:00:00	1978-03-04	1978-03-04 00:00:00	32020		\N	195817	0	195662009	4112343		0
60262	3566	260139	1977-02-23	1977-02-23 00:00:00	1977-03-02	1977-03-02 00:00:00	32020		\N	236911	0	10509002	260139		0
49832	2945	40481087	1959-05-27	1959-05-27 00:00:00	1959-06-03	1959-06-03 00:00:00	32020		\N	196481	0	444814009	40481087		0
50113	2960	81151	1970-02-14	1970-02-14 00:00:00	1970-03-14	1970-03-14 00:00:00	32020		\N	197607	0	44465007	81151		0
50206	2965	4218389	2012-05-27	2012-05-27 00:00:00	2012-06-24	2012-06-24 00:00:00	32020		\N	197987	0	39848009	4218389		0
60956	3609	78272	1990-03-06	1990-03-06 00:00:00	1990-03-27	1990-03-27 00:00:00	32020		\N	239787	0	70704007	78272		0
50588	2992	81151	2009-04-12	2009-04-12 00:00:00	2009-05-03	2009-05-03 00:00:00	32020		\N	199767	0	44465007	81151		0
50757	3001	260139	1998-12-27	1998-12-27 00:00:00	1999-01-10	1999-01-10 00:00:00	32020		\N	200273	0	10509002	260139		0
50916	3013	4059173	1963-12-24	1963-12-24 00:00:00	1964-02-22	1964-02-22 00:00:00	32020		\N	200965	0	16114001	4059173		0
51015	3020	80180	1996-04-12	1996-04-12 00:00:00	\N	\N	32020		\N	201429	0	396275006	80180		0
61819	3650	4112343	1953-04-16	1953-04-16 00:00:00	1953-04-29	1953-04-29 00:00:00	32020		\N	242990	0	195662009	4112343		0
51455	3053	4112343	2006-10-01	2006-10-01 00:00:00	2006-10-12	2006-10-12 00:00:00	32020		\N	203127	0	195662009	4112343		0
51571	3060	260139	1994-03-18	1994-03-18 00:00:00	1994-03-25	1994-03-25 00:00:00	32020		\N	203658	0	10509002	260139		0
62285	3678	260139	1980-06-06	1980-06-06 00:00:00	1980-06-20	1980-06-20 00:00:00	32020		\N	244578	0	10509002	260139		0
51951	3079	40481087	1982-03-01	1982-03-01 00:00:00	1982-03-08	1982-03-08 00:00:00	32020		\N	204870	0	444814009	40481087		0
52077	3083	4112343	2006-07-09	2006-07-09 00:00:00	2006-07-16	2006-07-16 00:00:00	32020		\N	205265	0	195662009	4112343		0
52263	3093	40481087	2000-04-18	2000-04-18 00:00:00	2000-04-25	2000-04-25 00:00:00	32020		\N	205955	0	444814009	40481087		0
52355	3100	4218389	2007-04-17	2007-04-17 00:00:00	2007-05-08	2007-05-08 00:00:00	32020		\N	206236	0	39848009	4218389		0
63184	3732	40481087	1969-03-15	1969-03-15 00:00:00	1969-03-22	1969-03-22 00:00:00	32020		\N	247978	0	444814009	40481087		0
63306	3739	40481087	1968-04-16	1968-04-16 00:00:00	1968-04-23	1968-04-23 00:00:00	32020		\N	248425	0	444814009	40481087		0
63449	3746	4112343	1990-02-17	1990-02-17 00:00:00	1990-02-28	1990-02-28 00:00:00	32020		\N	249043	0	195662009	4112343		0
63641	3757	4142905	1957-09-14	1957-09-14 00:00:00	1957-12-13	1957-12-13 00:00:00	32020		\N	249762	0	33737001	4142905		0
42644	2542	40481087	1966-06-23	1966-06-23 00:00:00	1966-06-30	1966-06-30 00:00:00	32020		\N	168203	0	444814009	40481087		0
53337	3159	40481087	1961-08-19	1961-08-19 00:00:00	1961-09-09	1961-09-09 00:00:00	32020		\N	210020	0	444814009	40481087		0
53479	3170	40481087	1964-12-11	1964-12-11 00:00:00	1964-12-18	1964-12-18 00:00:00	32020		\N	210724	0	444814009	40481087		0
43145	2570	4278672	2015-05-22	2015-05-22 00:00:00	2015-07-21	2015-07-21 00:00:00	32020		\N	170200	0	65966004	4278672		0
43240	2574	40481087	1970-07-24	1970-07-24 00:00:00	1970-07-31	1970-07-31 00:00:00	32020		\N	170506	0	444814009	40481087		0
53968	3195	40481087	2015-12-10	2015-12-10 00:00:00	2015-12-31	2015-12-31 00:00:00	32020		\N	212545	0	444814009	40481087		0
43567	2594	40481087	1977-12-21	1977-12-21 00:00:00	1977-12-28	1977-12-28 00:00:00	32020		\N	171679	0	444814009	40481087		0
43807	2609	40481087	1967-05-03	1967-05-03 00:00:00	1967-05-17	1967-05-17 00:00:00	32020		\N	172461	0	444814009	40481087		0
43930	2615	40481087	1997-07-02	1997-07-02 00:00:00	1997-07-09	1997-07-09 00:00:00	32020		\N	172905	0	444814009	40481087		0
44127	2624	80180	2006-06-18	2006-06-18 00:00:00	\N	\N	32020		\N	173603	0	396275006	80180		0
44298	2633	4310024	1980-07-04	1980-07-04 00:00:00	\N	\N	32020		\N	174254	0	424802006	4310024		0
54990	3254	40481087	2004-11-28	2004-11-28 00:00:00	2004-12-05	2004-12-05 00:00:00	32020		\N	216457	0	444814009	40481087		0
55198	3268	4283893	1992-08-14	1992-08-14 00:00:00	1992-10-30	1992-10-30 00:00:00	32020		\N	217186	0	36971009	4283893		0
44815	2666	40481087	2013-05-31	2013-05-31 00:00:00	2013-06-07	2013-06-07 00:00:00	32020		\N	176650	0	444814009	40481087		0
44962	2675	40481087	1963-12-24	1963-12-24 00:00:00	1963-12-31	1963-12-31 00:00:00	32020		\N	177265	0	444814009	40481087		0
55631	3294	28060	1993-09-29	1993-09-29 00:00:00	1993-10-09	1993-10-09 00:00:00	32020		\N	218832	0	43878008	28060		0
45205	2688	378001	1963-09-14	1963-09-14 00:00:00	1963-10-14	1963-10-14 00:00:00	32020		\N	178161	0	62106007	378001		0
55984	3314	80180	2003-07-20	2003-07-20 00:00:00	\N	\N	32020		\N	220105	0	396275006	80180		0
45630	2711	260139	1972-05-18	1972-05-18 00:00:00	1972-05-25	1972-05-25 00:00:00	32020		\N	179775	0	10509002	260139		0
56276	3335	4283893	1990-01-11	1990-01-11 00:00:00	1990-02-22	1990-02-22 00:00:00	32020		\N	221246	0	36971009	4283893		0
45965	2739	4285898	1992-02-27	1992-02-27 00:00:00	\N	\N	32020		\N	181225	0	68496003	4285898		0
56704	3363	257012	2011-09-15	2011-09-15 00:00:00	\N	\N	32020		\N	222938	0	40055000	257012		0
56773	3367	40481087	1969-10-02	1969-10-02 00:00:00	1969-10-23	1969-10-23 00:00:00	32020		\N	223306	0	444814009	40481087		0
46430	2765	81151	1949-11-29	1949-11-29 00:00:00	1949-12-27	1949-12-27 00:00:00	32020		\N	182887	0	44465007	81151		0
46547	2771	4152936	1990-09-08	1990-09-08 00:00:00	1990-09-29	1990-09-29 00:00:00	32020		\N	183475	0	283385000	4152936		0
46775	2782	260139	1987-06-20	1987-06-20 00:00:00	1987-07-04	1987-07-04 00:00:00	32020		\N	184423	0	10509002	260139		0
46944	2792	372328	1975-05-12	1975-05-12 00:00:00	1976-02-16	1976-02-16 00:00:00	32020		\N	185031	0	65363002	372328		0
57611	3417	80180	1948-12-28	1948-12-28 00:00:00	\N	\N	32020		\N	226605	0	396275006	80180		0
57773	3427	372328	1969-11-29	1969-11-29 00:00:00	1970-03-11	1970-03-11 00:00:00	32020		\N	227178	0	65363002	372328		0
47451	2822	4296204	1977-11-13	1977-11-13 00:00:00	1977-12-04	1977-12-04 00:00:00	32020		\N	187029	0	403190006	4296204		0
47613	2830	4283893	1978-05-30	1978-05-30 00:00:00	1978-09-05	1978-09-05 00:00:00	32020		\N	187707	0	36971009	4283893		0
47706	2835	40481087	1931-07-24	1931-07-24 00:00:00	1931-08-14	1931-08-14 00:00:00	32020		\N	188349	0	444814009	40481087		0
47899	2844	4112343	2006-07-11	2006-07-11 00:00:00	2006-07-23	2006-07-23 00:00:00	32020		\N	188807	0	195662009	4112343		0
58653	3477	134438	1986-03-29	1986-03-29 00:00:00	1988-05-21	1988-05-21 00:00:00	32020		\N	230631	0	40275004	134438		0
48201	2859	4266809	1976-10-24	1976-10-24 00:00:00	\N	\N	32020		\N	190034	0	397881000	4266809		0
48358	2864	4112343	1963-05-26	1963-05-26 00:00:00	1963-06-08	1963-06-08 00:00:00	32020		\N	190497	0	195662009	4112343		0
59164	3509	4112343	1948-02-01	1948-02-01 00:00:00	1948-02-09	1948-02-09 00:00:00	32020		\N	232702	0	195662009	4112343		0
59330	3518	4152936	1974-11-14	1974-11-14 00:00:00	1974-11-28	1974-11-28 00:00:00	32020		\N	233581	0	283385000	4152936		0
48914	2895	260139	1984-05-20	1984-05-20 00:00:00	1984-05-27	1984-05-27 00:00:00	32020		\N	192738	0	10509002	260139		0
59615	3533	372328	1969-02-04	1969-02-04 00:00:00	1969-11-26	1969-11-26 00:00:00	32020		\N	234693	0	65363002	372328		0
59800	3543	4112343	1981-12-28	1981-12-28 00:00:00	1982-01-08	1982-01-08 00:00:00	32020		\N	235348	0	195662009	4112343		0
59948	3552	4146173	1965-07-01	1965-07-01 00:00:00	1965-08-07	1965-08-07 00:00:00	32020		\N	235786	0	307731004	4146173		0
60093	3560	40481087	1981-10-04	1981-10-04 00:00:00	1981-10-11	1981-10-11 00:00:00	32020		\N	236368	0	444814009	40481087		0
60263	3566	378001	2016-05-20	2016-05-20 00:00:00	2016-06-19	2016-06-19 00:00:00	32020		\N	236953	0	62106007	378001		0
49833	2945	40481087	2006-04-28	2006-04-28 00:00:00	2006-05-12	2006-05-12 00:00:00	32020		\N	196460	0	444814009	40481087		0
50114	2960	40481087	2017-01-19	2017-01-19 00:00:00	2017-01-26	2017-01-26 00:00:00	32020		\N	197694	0	444814009	40481087		0
50207	2966	317576	2013-11-23	2013-11-23 00:00:00	\N	\N	32020		\N	198110	0	53741008	317576		0
60957	3609	4112343	2013-02-23	2013-02-23 00:00:00	2013-03-03	2013-03-03 00:00:00	32020		\N	239748	0	195662009	4112343		0
50589	2992	4218389	1983-01-10	1983-01-10 00:00:00	1983-02-07	1983-02-07 00:00:00	32020		\N	199765	0	39848009	4218389		0
50758	3001	40481087	2001-09-25	2001-09-25 00:00:00	2001-10-02	2001-10-02 00:00:00	32020		\N	200274	0	444814009	40481087		0
50917	3013	4112343	1985-04-19	1985-04-19 00:00:00	1985-04-28	1985-04-28 00:00:00	32020		\N	200934	0	195662009	4112343		0
51016	3020	40481087	1964-06-02	1964-06-02 00:00:00	1964-06-09	1964-06-09 00:00:00	32020		\N	201379	0	444814009	40481087		0
61820	3650	4237458	1940-11-04	1940-11-04 00:00:00	1940-12-04	1940-12-04 00:00:00	32020		\N	242935	0	58150001	4237458		0
51456	3053	40481087	2007-03-12	2007-03-12 00:00:00	2007-03-19	2007-03-19 00:00:00	32020		\N	203147	0	444814009	40481087		0
51572	3060	40481087	2004-01-09	2004-01-09 00:00:00	2004-01-23	2004-01-23 00:00:00	32020		\N	203669	0	444814009	40481087		0
62286	3678	4112343	2013-04-29	2013-04-29 00:00:00	2013-05-11	2013-05-11 00:00:00	32020		\N	244597	0	195662009	4112343		0
51952	3079	440086	1947-04-17	1947-04-17 00:00:00	1951-04-26	1951-04-26 00:00:00	32020		\N	204867	0	192127007	440086		0
52078	3083	4112343	1978-01-31	1978-01-31 00:00:00	1978-02-07	1978-02-07 00:00:00	32020		\N	205326	0	195662009	4112343		0
52264	3093	4112343	1973-03-19	1973-03-19 00:00:00	1973-03-31	1973-03-31 00:00:00	32020		\N	205940	0	195662009	4112343		0
52356	3100	260139	1964-09-10	1964-09-10 00:00:00	1964-09-24	1964-09-24 00:00:00	32020		\N	206243	0	10509002	260139		0
63185	3732	40481087	1956-01-18	1956-01-18 00:00:00	1956-01-25	1956-01-25 00:00:00	32020		\N	247997	0	444814009	40481087		0
63307	3739	4112343	1973-09-04	1973-09-04 00:00:00	1973-09-12	1973-09-12 00:00:00	32020		\N	248438	0	195662009	4112343		0
63450	3746	375671	1978-04-05	1978-04-05 00:00:00	1978-05-05	1978-05-05 00:00:00	32020		\N	249065	0	62564004	375671		0
63642	3757	40481087	1954-10-06	1954-10-06 00:00:00	1954-10-13	1954-10-13 00:00:00	32020		\N	249733	0	444814009	40481087		0
42645	2542	4278672	1978-05-12	1978-05-12 00:00:00	1978-07-11	1978-07-11 00:00:00	32020		\N	168090	0	65966004	4278672		0
53338	3159	40481087	1986-06-06	1986-06-06 00:00:00	1986-06-27	1986-06-27 00:00:00	32020		\N	210038	0	444814009	40481087		0
53480	3170	372328	1951-07-20	1951-07-20 00:00:00	1951-08-31	1951-08-31 00:00:00	32020		\N	210699	0	65363002	372328		0
43146	2570	4112343	1975-11-09	1975-11-09 00:00:00	1975-11-22	1975-11-22 00:00:00	32020		\N	170267	0	195662009	4112343		0
43241	2576	40481087	1996-12-13	1996-12-13 00:00:00	1996-12-20	1996-12-20 00:00:00	32020		\N	170558	0	444814009	40481087		0
53969	3195	4112343	1959-04-01	1959-04-01 00:00:00	1959-04-11	1959-04-11 00:00:00	32020		\N	212564	0	195662009	4112343		0
43568	2594	4112343	1981-05-01	1981-05-01 00:00:00	1981-05-09	1981-05-09 00:00:00	32020		\N	171710	0	195662009	4112343		0
43808	2609	4112343	1974-12-08	1974-12-08 00:00:00	1974-12-19	1974-12-19 00:00:00	32020		\N	172474	0	195662009	4112343		0
43931	2615	40481087	1996-08-16	1996-08-16 00:00:00	1996-08-30	1996-08-30 00:00:00	32020		\N	172904	0	444814009	40481087		0
44128	2624	40481087	2006-02-16	2006-02-16 00:00:00	2006-02-23	2006-02-23 00:00:00	32020		\N	173603	0	444814009	40481087		0
44299	2633	30753	1980-12-01	1980-12-01 00:00:00	\N	\N	32020		\N	174254	0	16761005	30753		0
54991	3254	4112343	2008-07-21	2008-07-21 00:00:00	2008-08-03	2008-08-03 00:00:00	32020		\N	216433	0	195662009	4112343		0
55199	3268	4112343	1984-10-02	1984-10-02 00:00:00	1984-10-10	1984-10-10 00:00:00	32020		\N	217164	0	195662009	4112343		0
44816	2666	4112343	2000-06-08	2000-06-08 00:00:00	2000-06-17	2000-06-17 00:00:00	32020		\N	176649	0	195662009	4112343		0
44963	2675	4112343	2001-04-14	2001-04-14 00:00:00	2001-04-23	2001-04-23 00:00:00	32020		\N	177292	0	195662009	4112343		0
55632	3294	4283893	1992-10-14	1992-10-14 00:00:00	1992-11-04	1992-11-04 00:00:00	32020		\N	218808	0	36971009	4283893		0
45206	2688	4112343	1984-12-08	1984-12-08 00:00:00	1984-12-21	1984-12-21 00:00:00	32020		\N	178122	0	195662009	4112343		0
55985	3314	4266809	2003-07-20	2003-07-20 00:00:00	\N	\N	32020		\N	220105	0	397881000	4266809		0
45631	2711	4112343	1998-07-30	1998-07-30 00:00:00	1998-08-09	1998-08-09 00:00:00	32020		\N	179669	0	195662009	4112343		0
56277	3335	40481087	1985-08-20	1985-08-20 00:00:00	1985-08-27	1985-08-27 00:00:00	32020		\N	221273	0	444814009	40481087		0
45966	2739	80180	1992-03-28	1992-03-28 00:00:00	\N	\N	32020		\N	181225	0	396275006	80180		0
56705	3363	81151	1964-05-27	1964-05-27 00:00:00	1964-06-17	1964-06-17 00:00:00	32020		\N	222951	0	44465007	81151		0
56774	3367	4059173	1976-02-24	1976-02-24 00:00:00	1976-04-24	1976-04-24 00:00:00	32020		\N	223279	0	16114001	4059173		0
46431	2765	81151	1978-01-18	1978-01-18 00:00:00	1978-02-01	1978-02-01 00:00:00	32020		\N	182891	0	44465007	81151		0
46548	2771	40481087	1973-08-06	1973-08-06 00:00:00	1973-08-20	1973-08-20 00:00:00	32020		\N	183528	0	444814009	40481087		0
46776	2782	260139	1952-02-01	1952-02-01 00:00:00	1952-02-08	1952-02-08 00:00:00	32020		\N	184442	0	10509002	260139		0
46945	2792	4310024	1999-07-24	1999-07-24 00:00:00	\N	\N	32020		\N	185011	0	424802006	4310024		0
57612	3417	40481087	1948-05-10	1948-05-10 00:00:00	1948-05-17	1948-05-17 00:00:00	32020		\N	226605	0	444814009	40481087		0
57774	3427	260139	2014-04-28	2014-04-28 00:00:00	2014-05-12	2014-05-12 00:00:00	32020		\N	227201	0	10509002	260139		0
47452	2822	378001	2017-07-28	2017-07-28 00:00:00	2017-09-26	2017-09-26 00:00:00	32020		\N	187031	0	62106007	378001		0
47614	2830	257012	1978-07-25	1978-07-25 00:00:00	\N	\N	32020		\N	187759	0	40055000	257012		0
47707	2835	81151	1988-11-11	1988-11-11 00:00:00	1988-11-25	1988-11-25 00:00:00	32020		\N	188343	0	44465007	81151		0
47900	2844	260139	1978-08-03	1978-08-03 00:00:00	1978-08-10	1978-08-10 00:00:00	32020		\N	188866	0	10509002	260139		0
58654	3477	4112343	1988-03-18	1988-03-18 00:00:00	1988-03-25	1988-03-25 00:00:00	32020		\N	230632	0	195662009	4112343		0
48202	2859	40481087	1982-07-04	1982-07-04 00:00:00	1982-07-25	1982-07-25 00:00:00	32020		\N	190063	0	444814009	40481087		0
48359	2864	260139	2005-01-03	2005-01-03 00:00:00	2005-01-17	2005-01-17 00:00:00	32020		\N	190514	0	10509002	260139		0
59165	3509	40481087	2002-11-18	2002-11-18 00:00:00	2002-11-25	2002-11-25 00:00:00	32020		\N	232762	0	444814009	40481087		0
59331	3518	40481087	2006-10-20	2006-10-20 00:00:00	2006-11-10	2006-11-10 00:00:00	32020		\N	233535	0	444814009	40481087		0
48915	2895	4112343	1976-08-08	1976-08-08 00:00:00	1976-08-18	1976-08-18 00:00:00	32020		\N	192719	0	195662009	4112343		0
59616	3533	81151	1973-07-13	1973-07-13 00:00:00	1973-08-03	1973-08-03 00:00:00	32020		\N	234662	0	44465007	81151		0
59801	3543	40481087	2016-09-25	2016-09-25 00:00:00	2016-10-16	2016-10-16 00:00:00	32020		\N	235374	0	444814009	40481087		0
59949	3552	260139	2016-08-30	2016-08-30 00:00:00	2016-09-06	2016-09-06 00:00:00	32020		\N	235851	0	10509002	260139		0
60094	3560	257012	1971-11-23	1971-11-23 00:00:00	\N	\N	32020		\N	236337	0	40055000	257012		0
60264	3566	260139	1965-09-08	1965-09-08 00:00:00	1965-09-22	1965-09-22 00:00:00	32020		\N	236910	0	10509002	260139		0
49834	2945	4112343	1948-10-17	1948-10-17 00:00:00	1948-10-24	1948-10-24 00:00:00	32020		\N	196512	0	195662009	4112343		0
50115	2960	81151	1996-02-10	1996-02-10 00:00:00	1996-03-02	1996-03-02 00:00:00	32020		\N	197609	0	44465007	81151		0
50208	2966	4112343	2005-07-08	2005-07-08 00:00:00	2005-07-20	2005-07-20 00:00:00	32020		\N	198048	0	195662009	4112343		0
60958	3609	40481087	1979-05-12	1979-05-12 00:00:00	1979-06-02	1979-06-02 00:00:00	32020		\N	239753	0	444814009	40481087		0
50590	2992	4218389	1979-05-12	1979-05-12 00:00:00	1979-06-09	1979-06-09 00:00:00	32020		\N	199763	0	39848009	4218389		0
50759	3002	260139	2014-11-27	2014-11-27 00:00:00	2014-12-11	2014-12-11 00:00:00	32020		\N	200348	0	10509002	260139		0
50918	3013	260139	2007-05-02	2007-05-02 00:00:00	2007-05-09	2007-05-09 00:00:00	32020		\N	200974	0	10509002	260139		0
51017	3020	258780	2001-01-17	2001-01-17 00:00:00	\N	\N	32020		\N	201407	0	185086009	258780		0
61821	3650	4112343	1940-11-06	1940-11-06 00:00:00	1940-11-18	1940-11-18 00:00:00	32020		\N	242900	0	195662009	4112343		0
61919	3655	4112343	1999-10-07	1999-10-07 00:00:00	1999-10-19	1999-10-19 00:00:00	32020		\N	243279	0	195662009	4112343		0
51573	3060	4112343	1971-12-29	1971-12-29 00:00:00	1972-01-09	1972-01-09 00:00:00	32020		\N	203543	0	195662009	4112343		0
62287	3678	372328	1978-06-15	1978-06-15 00:00:00	1978-10-30	1978-10-30 00:00:00	32020		\N	244610	0	65363002	372328		0
51953	3079	40481087	1937-04-05	1937-04-05 00:00:00	1937-04-26	1937-04-26 00:00:00	32020		\N	204938	0	444814009	40481087		0
52079	3083	28060	1996-11-13	1996-11-13 00:00:00	1996-11-24	1996-11-24 00:00:00	32020		\N	205264	0	43878008	28060		0
52265	3093	260139	2019-03-26	2019-03-26 00:00:00	2019-04-02	2019-04-02 00:00:00	32020		\N	205945	0	10509002	260139		0
52357	3100	260139	1986-03-03	1986-03-03 00:00:00	1986-03-17	1986-03-17 00:00:00	32020		\N	206257	0	10509002	260139		0
63186	3732	4112343	1972-09-25	1972-09-25 00:00:00	1972-10-07	1972-10-07 00:00:00	32020		\N	247957	0	195662009	4112343		0
63308	3739	28060	2000-09-19	2000-09-19 00:00:00	2000-10-01	2000-10-01 00:00:00	32020		\N	248446	0	43878008	28060		0
63451	3746	4112343	1970-07-18	1970-07-18 00:00:00	1970-07-29	1970-07-29 00:00:00	32020		\N	249040	0	195662009	4112343		0
63643	3757	4112343	1947-01-15	1947-01-15 00:00:00	1947-01-24	1947-01-24 00:00:00	32020		\N	249732	0	195662009	4112343		0
42646	2542	4112343	1986-02-26	1986-02-26 00:00:00	1986-03-07	1986-03-07 00:00:00	32020		\N	168167	0	195662009	4112343		0
53339	3159	4112343	1985-07-07	1985-07-07 00:00:00	1985-07-16	1985-07-16 00:00:00	32020		\N	210091	0	195662009	4112343		0
53481	3170	40481087	1965-06-23	1965-06-23 00:00:00	1965-07-07	1965-07-07 00:00:00	32020		\N	210731	0	444814009	40481087		0
43147	2570	40481087	2003-06-19	2003-06-19 00:00:00	2003-06-26	2003-06-26 00:00:00	32020		\N	170182	0	444814009	40481087		0
43242	2576	260139	2018-09-05	2018-09-05 00:00:00	2018-09-12	2018-09-12 00:00:00	32020		\N	170561	0	10509002	260139		0
53970	3195	81151	2001-12-14	2001-12-14 00:00:00	2002-01-18	2002-01-18 00:00:00	32020		\N	212592	0	44465007	81151		0
43569	2596	40479422	2017-03-26	2017-03-26 00:00:00	2017-06-01	2017-06-01 00:00:00	32020		\N	171765	0	444448004	40479422		0
43810	2609	80180	1993-07-12	1993-07-12 00:00:00	\N	\N	32020		\N	172515	0	396275006	80180		0
43932	2615	40481087	2004-10-06	2004-10-06 00:00:00	2004-10-20	2004-10-20 00:00:00	32020		\N	172899	0	444814009	40481087		0
44129	2624	40481087	1993-01-28	1993-01-28 00:00:00	1993-02-18	1993-02-18 00:00:00	32020		\N	173577	0	444814009	40481087		0
44300	2633	4112343	1957-08-28	1957-08-28 00:00:00	1957-09-09	1957-09-09 00:00:00	32020		\N	174193	0	195662009	4112343		0
54992	3254	40481087	2001-07-17	2001-07-17 00:00:00	2001-08-07	2001-08-07 00:00:00	32020		\N	216432	0	444814009	40481087		0
55200	3268	375671	1977-02-04	1977-02-04 00:00:00	1977-04-05	1977-04-05 00:00:00	32020		\N	217213	0	62564004	375671		0
44817	2666	40481087	1953-10-10	1953-10-10 00:00:00	1953-10-17	1953-10-17 00:00:00	32020		\N	176646	0	444814009	40481087		0
44964	2675	260139	1969-06-18	1969-06-18 00:00:00	1969-07-02	1969-07-02 00:00:00	32020		\N	177276	0	10509002	260139		0
55633	3294	378001	2014-07-07	2014-07-07 00:00:00	2014-09-05	2014-09-05 00:00:00	32020		\N	218852	0	62106007	378001		0
45207	2688	4112343	1974-11-16	1974-11-16 00:00:00	1974-11-27	1974-11-27 00:00:00	32020		\N	178151	0	195662009	4112343		0
55986	3314	4001336	1978-11-12	1978-11-12 00:00:00	1978-12-12	1978-12-12 00:00:00	32020		\N	220085	0	110030002	4001336		0
45632	2711	40486433	1953-07-02	1953-07-02 00:00:00	\N	\N	32020		\N	179649	0	446096008	40486433		0
56278	3335	4296205	2013-02-15	2013-02-15 00:00:00	2013-03-01	2013-03-01 00:00:00	32020		\N	221226	0	403191005	4296205		0
45967	2739	4266809	1992-03-28	1992-03-28 00:00:00	\N	\N	32020		\N	181225	0	397881000	4266809		0
56706	3363	40481087	2004-11-30	2004-11-30 00:00:00	2004-12-07	2004-12-07 00:00:00	32020		\N	222996	0	444814009	40481087		0
56775	3367	80180	2002-10-10	2002-10-10 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
46432	2765	4134304	1946-11-15	1946-11-15 00:00:00	1947-02-13	1947-02-13 00:00:00	32020		\N	182884	0	263102004	4134304		0
46549	2771	196456	1974-09-02	1974-09-02 00:00:00	1974-09-02	1974-09-02 00:00:00	32020		\N	183474	0	235919008	196456		0
46777	2782	372328	1921-08-10	1921-08-10 00:00:00	1921-10-26	1921-10-26 00:00:00	32020		\N	184428	0	65363002	372328		0
46946	2792	372328	1962-07-24	1962-07-24 00:00:00	1962-09-17	1962-09-17 00:00:00	32020		\N	185030	0	65363002	372328		0
57613	3417	40481087	1993-09-10	1993-09-10 00:00:00	1993-09-24	1993-09-24 00:00:00	32020		\N	226618	0	444814009	40481087		0
57775	3427	260139	1973-12-27	1973-12-27 00:00:00	1974-01-03	1974-01-03 00:00:00	32020		\N	227208	0	10509002	260139		0
47453	2822	4112343	2007-12-05	2007-12-05 00:00:00	2007-12-18	2007-12-18 00:00:00	32020		\N	186979	0	195662009	4112343		0
47615	2830	28060	2015-05-16	2015-05-16 00:00:00	2015-05-25	2015-05-25 00:00:00	32020		\N	187743	0	43878008	28060		0
47708	2835	40481087	1932-06-14	1932-06-14 00:00:00	1932-06-21	1932-06-21 00:00:00	32020		\N	188235	0	444814009	40481087		0
47901	2844	4112343	2002-09-19	2002-09-19 00:00:00	2002-09-27	2002-09-27 00:00:00	32020		\N	188814	0	195662009	4112343		0
58655	3477	40481087	2017-01-16	2017-01-16 00:00:00	2017-01-23	2017-01-23 00:00:00	32020		\N	230691	0	444814009	40481087		0
48203	2859	260139	1948-06-02	1948-06-02 00:00:00	1948-06-09	1948-06-09 00:00:00	32020		\N	190030	0	10509002	260139		0
48360	2864	4112343	2013-05-04	2013-05-04 00:00:00	2013-05-11	2013-05-11 00:00:00	32020		\N	190516	0	195662009	4112343		0
59166	3509	4134304	2015-12-30	2015-12-30 00:00:00	2016-03-29	2016-03-29 00:00:00	32020		\N	232795	0	263102004	4134304		0
59332	3518	4112343	1982-10-05	1982-10-05 00:00:00	1982-10-14	1982-10-14 00:00:00	32020		\N	233555	0	195662009	4112343		0
48916	2896	260139	2013-07-27	2013-07-27 00:00:00	2013-08-03	2013-08-03 00:00:00	32020		\N	192823	0	10509002	260139		0
59617	3533	192671	2001-01-13	2001-01-13 00:00:00	\N	\N	32020		\N	234721	0	K92.2	35208414		0
59802	3543	195588	2018-08-15	2018-08-15 00:00:00	2018-09-20	2018-09-20 00:00:00	32020		\N	235349	0	38822007	195588		0
59950	3552	40481087	1993-09-06	1993-09-06 00:00:00	1993-09-27	1993-09-27 00:00:00	32020		\N	235823	0	444814009	40481087		0
60095	3560	4278672	1988-04-12	1988-04-12 00:00:00	1988-05-12	1988-05-12 00:00:00	32020		\N	236409	0	65966004	4278672		0
60265	3567	40481087	1992-03-11	1992-03-11 00:00:00	1992-03-25	1992-03-25 00:00:00	32020		\N	237048	0	444814009	40481087		0
49852	2947	4027663	2008-05-13	2008-05-13 00:00:00	\N	\N	32020		\N	196694	0	13200003	4027663		0
50116	2960	4112343	1961-12-30	1961-12-30 00:00:00	1962-01-12	1962-01-12 00:00:00	32020		\N	197654	0	195662009	4112343		0
50209	2966	4109685	1989-01-07	1989-01-07 00:00:00	1989-01-21	1989-01-21 00:00:00	32020		\N	198046	0	284551006	4109685		0
60959	3609	260139	1992-03-01	1992-03-01 00:00:00	1992-03-08	1992-03-08 00:00:00	32020		\N	239746	0	10509002	260139		0
50591	2992	4112343	2002-10-08	2002-10-08 00:00:00	2002-10-16	2002-10-16 00:00:00	32020		\N	199696	0	195662009	4112343		0
50760	3002	80180	2012-11-05	2012-11-05 00:00:00	\N	\N	32020		\N	200380	0	396275006	80180		0
50919	3013	80180	1992-10-02	1992-10-02 00:00:00	\N	\N	32020		\N	200904	0	396275006	80180		0
51018	3020	372328	1959-01-04	1959-01-04 00:00:00	1959-06-10	1959-06-10 00:00:00	32020		\N	201396	0	65363002	372328		0
61822	3650	40481087	1951-10-16	1951-10-16 00:00:00	1951-10-23	1951-10-23 00:00:00	32020		\N	242986	0	444814009	40481087		0
61920	3655	40481087	1937-06-27	1937-06-27 00:00:00	1937-07-18	1937-07-18 00:00:00	32020		\N	243261	0	444814009	40481087		0
51574	3060	260139	1968-02-25	1968-02-25 00:00:00	1968-03-03	1968-03-03 00:00:00	32020		\N	203609	0	10509002	260139		0
62300	3680	260139	2000-10-25	2000-10-25 00:00:00	2000-11-08	2000-11-08 00:00:00	32020		\N	244773	0	10509002	260139		0
51954	3079	4152936	1975-08-22	1975-08-22 00:00:00	1975-09-12	1975-09-12 00:00:00	32020		\N	204963	0	283385000	4152936		0
52080	3083	4155034	1952-02-23	1952-02-23 00:00:00	1952-03-08	1952-03-08 00:00:00	32020		\N	205267	0	283371005	4155034		0
52266	3093	80180	2009-11-03	2009-11-03 00:00:00	\N	\N	32020		\N	205961	0	396275006	80180		0
52358	3100	372328	1954-06-06	1954-06-06 00:00:00	1954-11-11	1954-11-11 00:00:00	32020		\N	206278	0	65363002	372328		0
63187	3732	4149245	2015-11-09	2015-11-09 00:00:00	2015-12-16	2015-12-16 00:00:00	32020		\N	247988	0	30832001	4149245		0
63309	3739	260139	2005-05-27	2005-05-27 00:00:00	2005-06-03	2005-06-03 00:00:00	32020		\N	248439	0	10509002	260139		0
63455	3748	440086	1991-03-10	1991-03-10 00:00:00	1997-03-18	1997-03-18 00:00:00	32020		\N	249142	0	192127007	440086		0
63644	3757	81151	1956-08-22	1956-08-22 00:00:00	1956-09-19	1956-09-19 00:00:00	32020		\N	249761	0	44465007	81151		0
42647	2542	260139	2001-06-15	2001-06-15 00:00:00	2001-06-22	2001-06-22 00:00:00	32020		\N	168113	0	10509002	260139		0
53340	3159	40481087	1967-03-02	1967-03-02 00:00:00	1967-03-23	1967-03-23 00:00:00	32020		\N	210022	0	444814009	40481087		0
53482	3170	260139	1979-05-15	1979-05-15 00:00:00	1979-05-29	1979-05-29 00:00:00	32020		\N	210744	0	10509002	260139		0
43148	2570	4113008	2009-06-08	2009-06-08 00:00:00	2009-06-22	2009-06-22 00:00:00	32020		\N	170199	0	284549007	4113008		0
43243	2576	257012	1990-11-11	1990-11-11 00:00:00	\N	\N	32020		\N	170527	0	40055000	257012		0
53971	3195	4134304	2006-11-23	2006-11-23 00:00:00	2006-12-23	2006-12-23 00:00:00	32020		\N	212593	0	263102004	4134304		0
43570	2596	4134304	1983-09-21	1983-09-21 00:00:00	1983-12-20	1983-12-20 00:00:00	32020		\N	171762	0	263102004	4134304		0
43811	2609	40481087	1978-10-25	1978-10-25 00:00:00	1978-11-15	1978-11-15 00:00:00	32020		\N	172475	0	444814009	40481087		0
43933	2615	260139	1961-04-28	1961-04-28 00:00:00	1961-05-05	1961-05-05 00:00:00	32020		\N	172926	0	10509002	260139		0
44130	2624	4155034	1973-08-05	1973-08-05 00:00:00	1973-08-26	1973-08-26 00:00:00	32020		\N	173623	0	283371005	4155034		0
44301	2633	372328	1951-01-19	1951-01-19 00:00:00	1951-03-22	1951-03-22 00:00:00	32020		\N	174247	0	65363002	372328		0
54993	3254	372328	1963-12-31	1963-12-31 00:00:00	1964-03-08	1964-03-08 00:00:00	32020		\N	216434	0	65363002	372328		0
55201	3268	260139	2014-06-10	2014-06-10 00:00:00	2014-06-17	2014-06-17 00:00:00	32020		\N	217176	0	10509002	260139		0
44818	2666	260139	1955-07-25	1955-07-25 00:00:00	1955-08-01	1955-08-01 00:00:00	32020		\N	176603	0	10509002	260139		0
44965	2675	4112343	2006-12-25	2006-12-25 00:00:00	2007-01-04	2007-01-04 00:00:00	32020		\N	177272	0	195662009	4112343		0
55634	3294	40481087	2003-05-25	2003-05-25 00:00:00	2003-06-01	2003-06-01 00:00:00	32020		\N	218810	0	444814009	40481087		0
45208	2688	4112343	1985-04-24	1985-04-24 00:00:00	1985-05-02	1985-05-02 00:00:00	32020		\N	178093	0	195662009	4112343		0
55987	3314	4112343	2010-10-26	2010-10-26 00:00:00	2010-11-06	2010-11-06 00:00:00	32020		\N	220068	0	195662009	4112343		0
45633	2711	81893	1988-07-11	1988-07-11 00:00:00	\N	\N	32020		\N	179626	0	64766004	81893		0
56279	3335	4142905	1987-07-04	1987-07-04 00:00:00	1987-08-03	1987-08-03 00:00:00	32020		\N	221300	0	33737001	4142905		0
45968	2739	30753	1991-07-02	1991-07-02 00:00:00	\N	\N	32020		\N	181225	0	16761005	30753		0
56707	3363	4283893	1973-10-26	1973-10-26 00:00:00	1973-12-14	1973-12-14 00:00:00	32020		\N	222943	0	36971009	4283893		0
56776	3367	81151	2015-05-01	2015-05-01 00:00:00	2015-05-22	2015-05-22 00:00:00	32020		\N	223285	0	44465007	81151		0
46433	2765	378001	1956-12-11	1956-12-11 00:00:00	1957-01-10	1957-01-10 00:00:00	32020		\N	182889	0	62106007	378001		0
46550	2771	198809	1974-09-02	1974-09-02 00:00:00	1974-09-02	1974-09-02 00:00:00	32020		\N	183474	0	65275009	198809		0
46778	2782	28060	1922-02-08	1922-02-08 00:00:00	1922-02-20	1922-02-20 00:00:00	32020		\N	184439	0	43878008	28060		0
46947	2792	4112343	2011-02-26	2011-02-26 00:00:00	2011-03-11	2011-03-11 00:00:00	32020		\N	184992	0	195662009	4112343		0
57614	3417	260139	1989-03-28	1989-03-28 00:00:00	1989-04-04	1989-04-04 00:00:00	32020		\N	226654	0	10509002	260139		0
57776	3427	260139	1976-12-20	1976-12-20 00:00:00	1977-01-03	1977-01-03 00:00:00	32020		\N	227216	0	10509002	260139		0
47454	2822	40481087	1993-03-16	1993-03-16 00:00:00	1993-04-06	1993-04-06 00:00:00	32020		\N	186995	0	444814009	40481087		0
47616	2830	133834	1974-10-18	1974-10-18 00:00:00	\N	\N	32020		\N	187804	0	24079001	133834		0
47709	2835	260139	2004-11-11	2004-11-11 00:00:00	2004-11-18	2004-11-18 00:00:00	32020		\N	188216	0	10509002	260139		0
47902	2844	80502	2018-07-02	2018-07-02 00:00:00	\N	\N	32020		\N	188899	0	64859006	80502		0
58656	3477	40481087	1987-11-28	1987-11-28 00:00:00	1987-12-19	1987-12-19 00:00:00	32020		\N	230650	0	444814009	40481087		0
48204	2859	4278672	1969-08-22	1969-08-22 00:00:00	1969-11-20	1969-11-20 00:00:00	32020		\N	190014	0	65966004	4278672		0
48361	2864	28060	1941-02-17	1941-02-17 00:00:00	1941-02-28	1941-02-28 00:00:00	32020		\N	190551	0	43878008	28060		0
59167	3509	4113008	1954-12-12	1954-12-12 00:00:00	1954-12-26	1954-12-26 00:00:00	32020		\N	232697	0	284549007	4113008		0
59333	3518	260139	2018-08-24	2018-08-24 00:00:00	2018-08-31	2018-08-31 00:00:00	32020		\N	233597	0	10509002	260139		0
48917	2896	260139	1987-05-23	1987-05-23 00:00:00	1987-05-30	1987-05-30 00:00:00	32020		\N	192765	0	10509002	260139		0
59618	3533	40481087	1978-05-11	1978-05-11 00:00:00	1978-06-01	1978-06-01 00:00:00	32020		\N	234657	0	444814009	40481087		0
59803	3543	4152936	1961-04-30	1961-04-30 00:00:00	1961-05-14	1961-05-14 00:00:00	32020		\N	235327	0	283385000	4152936		0
59951	3552	4112343	2009-08-05	2009-08-05 00:00:00	2009-08-17	2009-08-17 00:00:00	32020		\N	235794	0	195662009	4112343		0
60096	3560	40481087	1971-03-18	1971-03-18 00:00:00	1971-03-25	1971-03-25 00:00:00	32020		\N	236352	0	444814009	40481087		0
60266	3567	40481087	2010-07-15	2010-07-15 00:00:00	2010-07-22	2010-07-22 00:00:00	32020		\N	237007	0	444814009	40481087		0
49853	2947	4112343	1989-08-04	1989-08-04 00:00:00	1989-08-16	1989-08-16 00:00:00	32020		\N	196702	0	195662009	4112343		0
50117	2960	40481087	1976-08-30	1976-08-30 00:00:00	1976-09-06	1976-09-06 00:00:00	32020		\N	197614	0	444814009	40481087		0
50210	2966	4296205	1963-10-02	1963-10-02 00:00:00	1963-10-16	1963-10-16 00:00:00	32020		\N	198044	0	403191005	4296205		0
60960	3609	4112343	1995-11-21	1995-11-21 00:00:00	1995-12-01	1995-12-01 00:00:00	32020		\N	239743	0	195662009	4112343		0
50592	2992	260139	2000-10-07	2000-10-07 00:00:00	2000-10-14	2000-10-14 00:00:00	32020		\N	199743	0	10509002	260139		0
50761	3002	40481087	2011-12-27	2011-12-27 00:00:00	2012-01-10	2012-01-10 00:00:00	32020		\N	200380	0	444814009	40481087		0
50920	3013	372328	1962-09-17	1962-09-17 00:00:00	1963-06-25	1963-06-25 00:00:00	32020		\N	200896	0	65363002	372328		0
51019	3020	260139	1959-02-23	1959-02-23 00:00:00	1959-03-02	1959-03-02 00:00:00	32020		\N	201363	0	10509002	260139		0
61823	3650	40481087	2015-03-20	2015-03-20 00:00:00	2015-03-27	2015-03-27 00:00:00	32020		\N	242905	0	444814009	40481087		0
61921	3655	4283893	2003-07-04	2003-07-04 00:00:00	2003-09-05	2003-09-05 00:00:00	32020		\N	243280	0	36971009	4283893		0
51575	3060	260139	1991-11-21	1991-11-21 00:00:00	1991-11-28	1991-11-28 00:00:00	32020		\N	203657	0	10509002	260139		0
62301	3680	81151	1994-03-15	1994-03-15 00:00:00	1994-04-05	1994-04-05 00:00:00	32020		\N	244719	0	44465007	81151		0
51955	3079	257012	2006-09-17	2006-09-17 00:00:00	\N	\N	32020		\N	204873	0	40055000	257012		0
52081	3083	4278672	2013-02-19	2013-02-19 00:00:00	2013-04-20	2013-04-20 00:00:00	32020		\N	205353	0	65966004	4278672		0
52267	3093	4155034	1984-11-19	1984-11-19 00:00:00	1984-12-10	1984-12-10 00:00:00	32020		\N	205972	0	283371005	4155034		0
52359	3100	81151	1967-11-29	1967-11-29 00:00:00	1967-12-13	1967-12-13 00:00:00	32020		\N	206241	0	44465007	81151		0
63188	3732	4283893	1993-02-20	1993-02-20 00:00:00	1993-05-15	1993-05-15 00:00:00	32020		\N	248014	0	36971009	4283893		0
63310	3739	4112343	1973-04-26	1973-04-26 00:00:00	1973-05-03	1973-05-03 00:00:00	32020		\N	248421	0	195662009	4112343		0
63456	3748	40481087	2004-11-04	2004-11-04 00:00:00	2004-11-25	2004-11-25 00:00:00	32020		\N	249099	0	444814009	40481087		0
63645	3757	81151	2004-11-06	2004-11-06 00:00:00	2004-11-20	2004-11-20 00:00:00	32020		\N	249763	0	44465007	81151		0
42648	2542	4059173	1974-12-29	1974-12-29 00:00:00	1975-03-29	1975-03-29 00:00:00	32020		\N	168089	0	16114001	4059173		0
53341	3159	40481087	1970-02-14	1970-02-14 00:00:00	1970-03-07	1970-03-07 00:00:00	32020		\N	210023	0	444814009	40481087		0
53483	3170	4094814	1990-04-15	1990-04-15 00:00:00	\N	\N	32020		\N	210715	0	262574004	4094814		0
43149	2570	40481087	1979-11-10	1979-11-10 00:00:00	1979-12-01	1979-12-01 00:00:00	32020		\N	170269	0	444814009	40481087		0
43244	2576	28060	1993-09-27	1993-09-27 00:00:00	1993-10-06	1993-10-06 00:00:00	32020		\N	170557	0	43878008	28060		0
53972	3195	4149245	2015-09-07	2015-09-07 00:00:00	2015-11-13	2015-11-13 00:00:00	32020		\N	212594	0	30832001	4149245		0
43571	2596	260139	1988-12-07	1988-12-07 00:00:00	1988-12-14	1988-12-14 00:00:00	32020		\N	171813	0	10509002	260139		0
43812	2609	40481087	2000-08-03	2000-08-03 00:00:00	2000-08-10	2000-08-10 00:00:00	32020		\N	172498	0	444814009	40481087		0
43934	2615	80180	1987-01-25	1987-01-25 00:00:00	\N	\N	32020		\N	172928	0	396275006	80180		0
44131	2624	440086	1975-01-02	1975-01-02 00:00:00	1977-06-09	1977-06-09 00:00:00	32020		\N	173578	0	192127007	440086		0
44302	2633	4112343	1991-08-27	1991-08-27 00:00:00	1991-09-07	1991-09-07 00:00:00	32020		\N	174197	0	195662009	4112343		0
54994	3254	40481087	1968-06-15	1968-06-15 00:00:00	1968-06-29	1968-06-29 00:00:00	32020		\N	216456	0	444814009	40481087		0
55202	3268	4112343	2003-02-21	2003-02-21 00:00:00	2003-03-03	2003-03-03 00:00:00	32020		\N	217187	0	195662009	4112343		0
44819	2666	4112343	1980-04-05	1980-04-05 00:00:00	1980-04-12	1980-04-12 00:00:00	32020		\N	176648	0	195662009	4112343		0
44966	2675	81151	1964-09-10	1964-09-10 00:00:00	1964-09-24	1964-09-24 00:00:00	32020		\N	177231	0	44465007	81151		0
55635	3294	40481087	1969-05-27	1969-05-27 00:00:00	1969-06-03	1969-06-03 00:00:00	32020		\N	218806	0	444814009	40481087		0
45209	2688	80180	2001-08-25	2001-08-25 00:00:00	\N	\N	32020		\N	178139	0	396275006	80180		0
55988	3314	40481087	2013-07-28	2013-07-28 00:00:00	2013-08-04	2013-08-04 00:00:00	32020		\N	220069	0	444814009	40481087		0
45634	2711	80180	1989-09-04	1989-09-04 00:00:00	\N	\N	32020		\N	179626	0	396275006	80180		0
56280	3335	40481087	2007-04-27	2007-04-27 00:00:00	2007-05-04	2007-05-04 00:00:00	32020		\N	221277	0	444814009	40481087		0
45969	2739	372328	1957-03-20	1957-03-20 00:00:00	1958-02-26	1958-02-26 00:00:00	32020		\N	181191	0	65363002	372328		0
56708	3363	40481087	1983-05-19	1983-05-19 00:00:00	1983-06-02	1983-06-02 00:00:00	32020		\N	222956	0	444814009	40481087		0
56777	3367	40481087	1984-11-08	1984-11-08 00:00:00	1984-11-29	1984-11-29 00:00:00	32020		\N	223302	0	444814009	40481087		0
46434	2765	40481087	1958-06-10	1958-06-10 00:00:00	1958-06-17	1958-06-17 00:00:00	32020		\N	182939	0	444814009	40481087		0
46551	2771	40481087	1967-06-23	1967-06-23 00:00:00	1967-06-30	1967-06-30 00:00:00	32020		\N	183457	0	444814009	40481087		0
46779	2782	78272	1936-08-21	1936-08-21 00:00:00	1936-09-18	1936-09-18 00:00:00	32020		\N	184403	0	70704007	78272		0
46948	2792	260139	1962-10-12	1962-10-12 00:00:00	1962-10-19	1962-10-19 00:00:00	32020		\N	185024	0	10509002	260139		0
57615	3417	260139	1980-01-29	1980-01-29 00:00:00	1980-02-12	1980-02-12 00:00:00	32020		\N	226593	0	10509002	260139		0
57777	3427	4112343	2005-04-21	2005-04-21 00:00:00	2005-04-28	2005-04-28 00:00:00	32020		\N	227198	0	195662009	4112343		0
47455	2822	260139	2016-02-27	2016-02-27 00:00:00	2016-03-05	2016-03-05 00:00:00	32020		\N	186988	0	10509002	260139		0
47617	2830	40481087	1978-10-11	1978-10-11 00:00:00	1978-10-18	1978-10-18 00:00:00	32020		\N	187784	0	444814009	40481087		0
47710	2835	40481087	1980-02-11	1980-02-11 00:00:00	1980-02-25	1980-02-25 00:00:00	32020		\N	188212	0	444814009	40481087		0
47903	2844	4283893	2006-10-19	2006-10-19 00:00:00	2007-02-22	2007-02-22 00:00:00	32020		\N	188841	0	36971009	4283893		0
58679	3481	321042	2001-05-12	2001-05-12 00:00:00	\N	\N	32020		\N	230885	0	410429000	321042		0
48205	2859	372328	1945-01-15	1945-01-15 00:00:00	1945-05-21	1945-05-21 00:00:00	32020		\N	189982	0	65363002	372328		0
48362	2864	4112343	1942-12-22	1942-12-22 00:00:00	1943-01-03	1943-01-03 00:00:00	32020		\N	190463	0	195662009	4112343		0
59168	3510	4218389	1956-02-16	1956-02-16 00:00:00	1956-03-22	1956-03-22 00:00:00	32020		\N	232797	0	39848009	4218389		0
59334	3518	40481087	1970-02-16	1970-02-16 00:00:00	1970-03-09	1970-03-09 00:00:00	32020		\N	233553	0	444814009	40481087		0
48918	2896	4218389	2016-01-19	2016-01-19 00:00:00	2016-02-09	2016-02-09 00:00:00	32020		\N	192869	0	39848009	4218389		0
59619	3533	81151	1996-07-03	1996-07-03 00:00:00	1996-08-07	1996-08-07 00:00:00	32020		\N	234719	0	44465007	81151		0
59804	3543	4149245	1978-07-14	1978-07-14 00:00:00	1978-09-19	1978-09-19 00:00:00	32020		\N	235330	0	30832001	4149245		0
59952	3552	40481087	2002-05-16	2002-05-16 00:00:00	2002-06-06	2002-06-06 00:00:00	32020		\N	235793	0	444814009	40481087		0
60097	3560	81151	1978-03-01	1978-03-01 00:00:00	1978-03-15	1978-03-15 00:00:00	32020		\N	236411	0	44465007	81151		0
60267	3567	80180	2004-05-10	2004-05-10 00:00:00	\N	\N	32020		\N	236991	0	396275006	80180		0
49854	2947	4218389	1981-10-12	1981-10-12 00:00:00	1981-11-15	1981-11-15 00:00:00	32020		\N	196698	0	39848009	4218389		0
50118	2960	40481087	2005-04-27	2005-04-27 00:00:00	2005-05-18	2005-05-18 00:00:00	32020		\N	197620	0	444814009	40481087		0
50211	2966	40481087	2018-02-05	2018-02-05 00:00:00	2018-02-26	2018-02-26 00:00:00	32020		\N	198052	0	444814009	40481087		0
60961	3609	4266809	2018-08-05	2018-08-05 00:00:00	\N	\N	32020		\N	239789	0	397881000	4266809		0
50593	2992	28060	1968-09-27	1968-09-27 00:00:00	1968-10-04	1968-10-04 00:00:00	32020		\N	199685	0	43878008	28060		0
50762	3002	40481087	1983-07-18	1983-07-18 00:00:00	1983-08-01	1983-08-01 00:00:00	32020		\N	200385	0	444814009	40481087		0
50921	3013	40481087	1963-07-27	1963-07-27 00:00:00	1963-08-03	1963-08-03 00:00:00	32020		\N	200973	0	444814009	40481087		0
51020	3020	260139	1991-12-19	1991-12-19 00:00:00	1991-12-26	1991-12-26 00:00:00	32020		\N	201393	0	10509002	260139		0
61824	3650	40481087	1985-06-10	1985-06-10 00:00:00	1985-06-17	1985-06-17 00:00:00	32020		\N	242903	0	444814009	40481087		0
61922	3655	372328	1936-05-26	1936-05-26 00:00:00	1936-07-09	1936-07-09 00:00:00	32020		\N	243254	0	65363002	372328		0
51576	3060	4112343	2017-08-14	2017-08-14 00:00:00	2017-08-24	2017-08-24 00:00:00	32020		\N	203548	0	195662009	4112343		0
62302	3680	4218389	2018-06-19	2018-06-19 00:00:00	2018-07-24	2018-07-24 00:00:00	32020		\N	244721	0	39848009	4218389		0
51956	3079	80180	1972-11-26	1972-11-26 00:00:00	\N	\N	32020		\N	204929	0	396275006	80180		0
52082	3083	4278672	1955-04-22	1955-04-22 00:00:00	1955-07-21	1955-07-21 00:00:00	32020		\N	205268	0	65966004	4278672		0
52268	3093	40481087	2011-11-28	2011-11-28 00:00:00	2011-12-19	2011-12-19 00:00:00	32020		\N	205909	0	444814009	40481087		0
52381	3103	40481087	2001-11-11	2001-11-11 00:00:00	2001-11-18	2001-11-18 00:00:00	32020		\N	206450	0	444814009	40481087		0
63189	3732	4266809	1993-12-24	1993-12-24 00:00:00	\N	\N	32020		\N	248014	0	397881000	4266809		0
63311	3739	28060	2014-12-15	2014-12-15 00:00:00	2014-12-27	2014-12-27 00:00:00	32020		\N	248423	0	43878008	28060		0
63457	3748	4112343	2005-08-29	2005-08-29 00:00:00	2005-09-05	2005-09-05 00:00:00	32020		\N	249144	0	195662009	4112343		0
63646	3757	372328	1947-02-11	1947-02-11 00:00:00	1947-07-30	1947-07-30 00:00:00	32020		\N	249728	0	65363002	372328		0
42649	2542	40481087	1975-03-29	1975-03-29 00:00:00	1975-04-12	1975-04-12 00:00:00	32020		\N	168187	0	444814009	40481087		0
53342	3159	372328	1963-11-12	1963-11-12 00:00:00	1964-06-04	1964-06-04 00:00:00	32020		\N	210095	0	65363002	372328		0
53484	3170	4112343	1975-10-23	1975-10-23 00:00:00	1975-11-04	1975-11-04 00:00:00	32020		\N	210725	0	195662009	4112343		0
43150	2570	4027663	1963-08-15	1963-08-15 00:00:00	\N	\N	32020		\N	170260	0	13200003	4027663		0
43245	2576	4155034	1993-10-25	1993-10-25 00:00:00	1993-11-15	1993-11-15 00:00:00	32020		\N	170548	0	283371005	4155034		0
53973	3195	4112343	1976-10-26	1976-10-26 00:00:00	1976-11-03	1976-11-03 00:00:00	32020		\N	212512	0	195662009	4112343		0
43572	2596	260139	1985-06-18	1985-06-18 00:00:00	1985-06-25	1985-06-25 00:00:00	32020		\N	171770	0	10509002	260139		0
43813	2609	28060	2013-04-11	2013-04-11 00:00:00	2013-04-22	2013-04-22 00:00:00	32020		\N	172499	0	43878008	28060		0
43935	2615	40481087	1987-01-24	1987-01-24 00:00:00	1987-01-31	1987-01-31 00:00:00	32020		\N	172928	0	444814009	40481087		0
44132	2624	40481087	1992-06-06	1992-06-06 00:00:00	1992-06-27	1992-06-27 00:00:00	32020		\N	173550	0	444814009	40481087		0
44303	2633	40481087	1970-10-14	1970-10-14 00:00:00	1970-11-04	1970-11-04 00:00:00	32020		\N	174232	0	444814009	40481087		0
54995	3254	40481087	1990-01-20	1990-01-20 00:00:00	1990-02-10	1990-02-10 00:00:00	32020		\N	216431	0	444814009	40481087		0
55203	3268	81151	1970-07-06	1970-07-06 00:00:00	1970-08-10	1970-08-10 00:00:00	32020		\N	217212	0	44465007	81151		0
44820	2666	4112343	1954-08-15	1954-08-15 00:00:00	1954-08-25	1954-08-25 00:00:00	32020		\N	176602	0	195662009	4112343		0
44967	2675	4278672	1978-02-13	1978-02-13 00:00:00	1978-04-14	1978-04-14 00:00:00	32020		\N	177232	0	65966004	4278672		0
55636	3294	4112343	1971-08-25	1971-08-25 00:00:00	1971-09-05	1971-09-05 00:00:00	32020		\N	218854	0	195662009	4112343		0
45210	2688	4294548	2010-12-16	2010-12-16 00:00:00	2010-12-23	2010-12-23 00:00:00	32020		\N	178153	0	75498004	4294548		0
55989	3314	4296204	2012-04-18	2012-04-18 00:00:00	2012-05-09	2012-05-09 00:00:00	32020		\N	220128	0	403190006	4296204		0
45635	2711	30753	1988-08-10	1988-08-10 00:00:00	\N	\N	32020		\N	179626	0	16761005	30753		0
56281	3335	40481087	1997-11-18	1997-11-18 00:00:00	1997-12-09	1997-12-09 00:00:00	32020		\N	221276	0	444814009	40481087		0
45970	2739	260139	1988-07-22	1988-07-22 00:00:00	1988-08-05	1988-08-05 00:00:00	32020		\N	181217	0	10509002	260139		0
56709	3363	192671	1995-10-29	1995-10-29 00:00:00	\N	\N	32020		\N	222985	0	K92.2	35208414		0
56778	3367	260139	2001-05-24	2001-05-24 00:00:00	2001-06-07	2001-06-07 00:00:00	32020		\N	223298	0	10509002	260139		0
46435	2765	4112343	1981-12-13	1981-12-13 00:00:00	1981-12-20	1981-12-20 00:00:00	32020		\N	182900	0	195662009	4112343		0
46552	2771	40481087	1955-12-27	1955-12-27 00:00:00	1956-01-17	1956-01-17 00:00:00	32020		\N	183526	0	444814009	40481087		0
46780	2782	28060	1956-01-04	1956-01-04 00:00:00	1956-01-15	1956-01-15 00:00:00	32020		\N	184361	0	43878008	28060		0
46949	2792	4112343	1959-09-28	1959-09-28 00:00:00	1959-10-06	1959-10-06 00:00:00	32020		\N	185042	0	195662009	4112343		0
57616	3417	260139	1957-07-22	1957-07-22 00:00:00	1957-08-05	1957-08-05 00:00:00	32020		\N	226581	0	10509002	260139		0
57778	3428	40481087	1967-05-11	1967-05-11 00:00:00	1967-05-25	1967-05-25 00:00:00	32020		\N	227264	0	444814009	40481087		0
47456	2822	260139	2001-09-04	2001-09-04 00:00:00	2001-09-11	2001-09-11 00:00:00	32020		\N	186987	0	10509002	260139		0
47618	2830	372328	1976-12-29	1976-12-29 00:00:00	1977-01-12	1977-01-12 00:00:00	32020		\N	187773	0	65363002	372328		0
47711	2835	28060	1981-10-28	1981-10-28 00:00:00	1981-11-04	1981-11-04 00:00:00	32020		\N	188270	0	43878008	28060		0
47904	2844	40481087	1979-10-09	1979-10-09 00:00:00	1979-10-23	1979-10-23 00:00:00	32020		\N	188804	0	444814009	40481087		0
58681	3481	378001	2006-04-08	2006-04-08 00:00:00	2006-06-07	2006-06-07 00:00:00	32020		\N	230886	0	62106007	378001		0
48206	2859	40481087	1964-09-22	1964-09-22 00:00:00	1964-09-29	1964-09-29 00:00:00	32020		\N	190059	0	444814009	40481087		0
48363	2864	40481087	2012-05-17	2012-05-17 00:00:00	2012-05-24	2012-05-24 00:00:00	32020		\N	190541	0	444814009	40481087		0
59169	3510	80502	2015-11-27	2015-11-27 00:00:00	\N	\N	32020		\N	232847	0	64859006	80502		0
59335	3518	260139	2006-11-16	2006-11-16 00:00:00	2006-11-23	2006-11-23 00:00:00	32020		\N	233596	0	10509002	260139		0
48919	2896	260139	2017-09-29	2017-09-29 00:00:00	2017-10-13	2017-10-13 00:00:00	32020		\N	192804	0	10509002	260139		0
59620	3533	40481087	1987-11-16	1987-11-16 00:00:00	1987-11-30	1987-11-30 00:00:00	32020		\N	234679	0	444814009	40481087		0
59805	3543	40481087	1974-06-18	1974-06-18 00:00:00	1974-06-25	1974-06-25 00:00:00	32020		\N	235347	0	444814009	40481087		0
59953	3552	260139	2014-01-23	2014-01-23 00:00:00	2014-02-06	2014-02-06 00:00:00	32020		\N	235807	0	10509002	260139		0
60098	3560	260139	2016-11-27	2016-11-27 00:00:00	2016-12-04	2016-12-04 00:00:00	32020		\N	236358	0	10509002	260139		0
60268	3567	4112343	2003-07-22	2003-07-22 00:00:00	2003-08-04	2003-08-04 00:00:00	32020		\N	236991	0	195662009	4112343		0
49855	2947	4048695	2000-07-05	2000-07-05 00:00:00	2000-08-06	2000-08-06 00:00:00	32020		\N	196733	0	15724005	4048695		0
50119	2960	28060	2011-02-25	2011-02-25 00:00:00	2011-03-07	2011-03-07 00:00:00	32020		\N	197621	0	43878008	28060		0
50212	2966	40481087	1968-04-15	1968-04-15 00:00:00	1968-04-22	1968-04-22 00:00:00	32020		\N	198060	0	444814009	40481087		0
60962	3609	4155034	2017-06-24	2017-06-24 00:00:00	2017-07-15	2017-07-15 00:00:00	32020		\N	239789	0	283371005	4155034		0
50594	2992	260139	2016-06-30	2016-06-30 00:00:00	2016-07-14	2016-07-14 00:00:00	32020		\N	199745	0	10509002	260139		0
50763	3002	192671	2013-01-01	2013-01-01 00:00:00	\N	\N	32020		\N	200365	0	K92.2	35208414		0
50922	3013	78272	1960-01-23	1960-01-23 00:00:00	1960-02-13	1960-02-13 00:00:00	32020		\N	200964	0	70704007	78272		0
51021	3020	260139	1981-10-29	1981-10-29 00:00:00	1981-11-05	1981-11-05 00:00:00	32020		\N	201391	0	10509002	260139		0
61825	3650	28060	1961-09-18	1961-09-18 00:00:00	1961-09-25	1961-09-25 00:00:00	32020		\N	242901	0	43878008	28060		0
61923	3655	40481087	1942-07-14	1942-07-14 00:00:00	1942-07-21	1942-07-21 00:00:00	32020		\N	243313	0	444814009	40481087		0
51577	3060	40481087	1965-08-11	1965-08-11 00:00:00	1965-09-01	1965-09-01 00:00:00	32020		\N	203667	0	444814009	40481087		0
62303	3680	81151	1995-04-30	1995-04-30 00:00:00	1995-05-21	1995-05-21 00:00:00	32020		\N	244720	0	44465007	81151		0
51957	3079	28060	1934-06-18	1934-06-18 00:00:00	1934-06-30	1934-06-30 00:00:00	32020		\N	204937	0	43878008	28060		0
52083	3083	40481087	1994-03-10	1994-03-10 00:00:00	1994-03-24	1994-03-24 00:00:00	32020		\N	205327	0	444814009	40481087		0
52269	3093	378001	1988-07-22	1988-07-22 00:00:00	1988-08-21	1988-08-21 00:00:00	32020		\N	205973	0	62106007	378001		0
52382	3103	40481087	2000-08-19	2000-08-19 00:00:00	2000-09-09	2000-09-09 00:00:00	32020		\N	206449	0	444814009	40481087		0
63190	3732	4285898	1993-11-24	1993-11-24 00:00:00	\N	\N	32020		\N	248014	0	68496003	4285898		0
63312	3739	4112343	1979-07-17	1979-07-17 00:00:00	1979-07-28	1979-07-28 00:00:00	32020		\N	248427	0	195662009	4112343		0
63458	3748	4112343	1981-01-03	1981-01-03 00:00:00	1981-01-13	1981-01-13 00:00:00	32020		\N	249126	0	195662009	4112343		0
63647	3757	80180	1985-02-01	1985-02-01 00:00:00	\N	\N	32020		\N	249786	0	396275006	80180		0
42650	2542	40481087	1990-08-28	1990-08-28 00:00:00	1990-09-11	1990-09-11 00:00:00	32020		\N	168128	0	444814009	40481087		0
53353	3161	260139	1978-05-26	1978-05-26 00:00:00	1978-06-09	1978-06-09 00:00:00	32020		\N	210251	0	10509002	260139		0
53485	3170	40481087	1956-07-12	1956-07-12 00:00:00	1956-07-19	1956-07-19 00:00:00	32020		\N	210729	0	444814009	40481087		0
43151	2570	260139	1954-02-23	1954-02-23 00:00:00	1954-03-09	1954-03-09 00:00:00	32020		\N	170178	0	10509002	260139		0
43246	2576	372328	1980-10-03	1980-10-03 00:00:00	1981-01-15	1981-01-15 00:00:00	32020		\N	170541	0	65363002	372328		0
53974	3195	4112343	2002-12-03	2002-12-03 00:00:00	2002-12-15	2002-12-15 00:00:00	32020		\N	212566	0	195662009	4112343		0
43573	2596	4142905	1977-04-25	1977-04-25 00:00:00	1977-05-25	1977-05-25 00:00:00	32020		\N	171761	0	33737001	4142905		0
43814	2609	40481087	2010-02-24	2010-02-24 00:00:00	2010-03-10	2010-03-10 00:00:00	32020		\N	172479	0	444814009	40481087		0
43936	2615	4266809	1987-01-25	1987-01-25 00:00:00	\N	\N	32020		\N	172928	0	397881000	4266809		0
44133	2624	4112343	2012-09-11	2012-09-11 00:00:00	2012-09-24	2012-09-24 00:00:00	32020		\N	173552	0	195662009	4112343		0
44304	2633	4112343	1970-05-06	1970-05-06 00:00:00	1970-05-16	1970-05-16 00:00:00	32020		\N	174231	0	195662009	4112343		0
54996	3254	372328	1967-03-26	1967-03-26 00:00:00	1967-05-07	1967-05-07 00:00:00	32020		\N	216449	0	65363002	372328		0
55204	3268	40481087	1975-06-17	1975-06-17 00:00:00	1975-07-08	1975-07-08 00:00:00	32020		\N	217178	0	444814009	40481087		0
55282	3275	195588	2003-05-07	2003-05-07 00:00:00	2003-06-24	2003-06-24 00:00:00	32020		\N	217649	0	38822007	195588		0
44968	2675	40481087	1979-08-08	1979-08-08 00:00:00	1979-08-22	1979-08-22 00:00:00	32020		\N	177267	0	444814009	40481087		0
55637	3294	40481087	1952-03-15	1952-03-15 00:00:00	1952-03-22	1952-03-22 00:00:00	32020		\N	218805	0	444814009	40481087		0
45211	2688	78272	1973-06-23	1973-06-23 00:00:00	1973-07-21	1973-07-21 00:00:00	32020		\N	178162	0	70704007	78272		0
55990	3314	40481087	1993-07-14	1993-07-14 00:00:00	1993-07-21	1993-07-21 00:00:00	32020		\N	220120	0	444814009	40481087		0
45636	2711	4109685	1988-05-07	1988-05-07 00:00:00	1988-05-28	1988-05-28 00:00:00	32020		\N	179612	0	284551006	4109685		0
56282	3335	81151	1984-01-23	1984-01-23 00:00:00	1984-02-20	1984-02-20 00:00:00	32020		\N	221298	0	44465007	81151		0
45971	2739	40481087	1990-08-24	1990-08-24 00:00:00	1990-09-07	1990-09-07 00:00:00	32020		\N	181261	0	444814009	40481087		0
56710	3363	4266809	1995-08-08	1995-08-08 00:00:00	\N	\N	32020		\N	222967	0	397881000	4266809		0
56779	3367	40481087	2004-12-19	2004-12-19 00:00:00	2005-01-02	2005-01-02 00:00:00	32020		\N	223310	0	444814009	40481087		0
46436	2765	4296204	1993-04-13	1993-04-13 00:00:00	1993-04-27	1993-04-27 00:00:00	32020		\N	182892	0	403190006	4296204		0
46553	2771	40481087	1989-05-06	1989-05-06 00:00:00	1989-05-13	1989-05-13 00:00:00	32020		\N	183458	0	444814009	40481087		0
46781	2782	40481087	1929-05-06	1929-05-06 00:00:00	1929-05-27	1929-05-27 00:00:00	32020		\N	184440	0	444814009	40481087		0
46950	2792	40481087	1959-05-08	1959-05-08 00:00:00	1959-05-29	1959-05-29 00:00:00	32020		\N	184987	0	444814009	40481087		0
57617	3418	4112343	1974-05-09	1974-05-09 00:00:00	1974-05-20	1974-05-20 00:00:00	32020		\N	226733	0	195662009	4112343		0
57779	3428	4112343	1970-06-05	1970-06-05 00:00:00	1970-06-15	1970-06-15 00:00:00	32020		\N	227248	0	195662009	4112343		0
47457	2822	260139	1996-09-30	1996-09-30 00:00:00	1996-10-14	1996-10-14 00:00:00	32020		\N	186997	0	10509002	260139		0
47627	2832	257012	2015-08-10	2015-08-10 00:00:00	\N	\N	32020		\N	187938	0	40055000	257012		0
47712	2835	40481087	1949-09-02	1949-09-02 00:00:00	1949-09-23	1949-09-23 00:00:00	32020		\N	188351	0	444814009	40481087		0
47905	2844	257012	2006-11-30	2006-11-30 00:00:00	\N	\N	32020		\N	188842	0	40055000	257012		0
58682	3481	4112343	2014-08-17	2014-08-17 00:00:00	2014-08-24	2014-08-24 00:00:00	32020		\N	230854	0	195662009	4112343		0
48207	2859	4283893	1967-04-25	1967-04-25 00:00:00	1967-06-27	1967-06-27 00:00:00	32020		\N	189964	0	36971009	4283893		0
48364	2864	28060	1955-02-25	1955-02-25 00:00:00	1955-03-07	1955-03-07 00:00:00	32020		\N	190550	0	43878008	28060		0
59170	3510	28060	1996-05-19	1996-05-19 00:00:00	1996-05-31	1996-05-31 00:00:00	32020		\N	232930	0	43878008	28060		0
59336	3518	4027663	1987-03-24	1987-03-24 00:00:00	\N	\N	32020		\N	233607	0	13200003	4027663		0
48920	2896	40481087	1987-10-02	1987-10-02 00:00:00	1987-10-09	1987-10-09 00:00:00	32020		\N	192870	0	444814009	40481087		0
59621	3533	4027663	1990-11-22	1990-11-22 00:00:00	\N	\N	32020		\N	234691	0	13200003	4027663		0
59806	3543	4112343	2008-12-19	2008-12-19 00:00:00	2008-12-27	2008-12-27 00:00:00	32020		\N	235371	0	195662009	4112343		0
59954	3552	260139	2002-10-31	2002-10-31 00:00:00	2002-11-07	2002-11-07 00:00:00	32020		\N	235824	0	10509002	260139		0
60099	3560	40481087	1961-11-02	1961-11-02 00:00:00	1961-11-09	1961-11-09 00:00:00	32020		\N	236336	0	444814009	40481087		0
60269	3567	378001	1995-10-30	1995-10-30 00:00:00	1995-12-29	1995-12-29 00:00:00	32020		\N	236999	0	62106007	378001		0
49856	2947	40481087	1983-07-13	1983-07-13 00:00:00	1983-07-20	1983-07-20 00:00:00	32020		\N	196701	0	444814009	40481087		0
50120	2960	4112343	1956-01-11	1956-01-11 00:00:00	1956-01-18	1956-01-18 00:00:00	32020		\N	197661	0	195662009	4112343		0
50213	2966	4218389	1976-11-06	1976-11-06 00:00:00	1976-12-11	1976-12-11 00:00:00	32020		\N	198045	0	39848009	4218389		0
60963	3609	80180	2018-08-05	2018-08-05 00:00:00	\N	\N	32020		\N	239789	0	396275006	80180		0
50595	2992	80180	1991-12-29	1991-12-29 00:00:00	\N	\N	32020		\N	199721	0	396275006	80180		0
50764	3002	372328	1975-04-07	1975-04-07 00:00:00	1975-06-10	1975-06-10 00:00:00	32020		\N	200349	0	65363002	372328		0
50923	3013	28060	1963-05-06	1963-05-06 00:00:00	1963-05-14	1963-05-14 00:00:00	32020		\N	200938	0	43878008	28060		0
51022	3020	317576	1961-12-13	1961-12-13 00:00:00	\N	\N	32020		\N	201425	0	53741008	317576		0
61826	3650	257012	1978-06-14	1978-06-14 00:00:00	\N	\N	32020		\N	242993	0	40055000	257012		0
61924	3655	81151	1997-08-04	1997-08-04 00:00:00	1997-08-25	1997-08-25 00:00:00	32020		\N	243259	0	44465007	81151		0
51578	3060	4112343	1944-05-20	1944-05-20 00:00:00	1944-05-27	1944-05-27 00:00:00	32020		\N	203557	0	195662009	4112343		0
62304	3680	133834	1982-01-24	1982-01-24 00:00:00	\N	\N	32020		\N	244726	0	24079001	133834		0
51958	3079	4112343	1979-08-20	1979-08-20 00:00:00	1979-09-01	1979-09-01 00:00:00	32020		\N	204906	0	195662009	4112343		0
52084	3083	4112343	1976-09-07	1976-09-07 00:00:00	1976-09-19	1976-09-19 00:00:00	32020		\N	205333	0	195662009	4112343		0
52270	3093	40481087	2008-02-04	2008-02-04 00:00:00	2008-02-11	2008-02-11 00:00:00	32020		\N	205942	0	444814009	40481087		0
52383	3103	4278672	1987-12-10	1987-12-10 00:00:00	1988-01-09	1988-01-09 00:00:00	32020		\N	206456	0	65966004	4278672		0
63191	3732	80180	1993-12-24	1993-12-24 00:00:00	\N	\N	32020		\N	248014	0	396275006	80180		0
63313	3739	40481087	2014-10-25	2014-10-25 00:00:00	2014-11-15	2014-11-15 00:00:00	32020		\N	248465	0	444814009	40481087		0
63459	3748	80180	2015-10-30	2015-10-30 00:00:00	\N	\N	32020		\N	249136	0	396275006	80180		0
63655	3759	4112343	1973-02-26	1973-02-26 00:00:00	1973-03-10	1973-03-10 00:00:00	32020		\N	249881	0	195662009	4112343		0
42651	2542	260139	1994-10-11	1994-10-11 00:00:00	1994-10-18	1994-10-18 00:00:00	32020		\N	168198	0	10509002	260139		0
53354	3161	4112343	2007-07-12	2007-07-12 00:00:00	2007-07-19	2007-07-19 00:00:00	32020		\N	210244	0	195662009	4112343		0
53486	3170	40481087	1953-03-04	1953-03-04 00:00:00	1953-03-25	1953-03-25 00:00:00	32020		\N	210719	0	444814009	40481087		0
43152	2570	40481087	1980-08-03	1980-08-03 00:00:00	1980-08-24	1980-08-24 00:00:00	32020		\N	170270	0	444814009	40481087		0
43247	2576	40481087	1985-06-16	1985-06-16 00:00:00	1985-07-07	1985-07-07 00:00:00	32020		\N	170552	0	444814009	40481087		0
53975	3195	40481087	2005-10-17	2005-10-17 00:00:00	2005-11-07	2005-11-07 00:00:00	32020		\N	212514	0	444814009	40481087		0
43574	2596	375671	1987-07-02	1987-07-02 00:00:00	1987-08-01	1987-08-01 00:00:00	32020		\N	171763	0	62564004	375671		0
43815	2609	40481087	1966-07-14	1966-07-14 00:00:00	1966-07-28	1966-07-28 00:00:00	32020		\N	172472	0	444814009	40481087		0
43937	2615	4109685	2010-05-10	2010-05-10 00:00:00	2010-05-24	2010-05-24 00:00:00	32020		\N	172940	0	284551006	4109685		0
44134	2624	372328	1972-08-10	1972-08-10 00:00:00	1972-12-14	1972-12-14 00:00:00	32020		\N	173604	0	65363002	372328		0
44305	2633	40481087	1956-05-30	1956-05-30 00:00:00	1956-06-20	1956-06-20 00:00:00	32020		\N	174218	0	444814009	40481087		0
54997	3254	40481087	1987-12-17	1987-12-17 00:00:00	1987-12-24	1987-12-24 00:00:00	32020		\N	216446	0	444814009	40481087		0
55205	3268	260139	1974-10-15	1974-10-15 00:00:00	1974-10-29	1974-10-29 00:00:00	32020		\N	217201	0	10509002	260139		0
55283	3275	4112343	1965-06-16	1965-06-16 00:00:00	1965-06-28	1965-06-28 00:00:00	32020		\N	217646	0	195662009	4112343		0
44969	2675	4113008	1992-01-01	1992-01-01 00:00:00	1992-01-15	1992-01-15 00:00:00	32020		\N	177233	0	284549007	4113008		0
55638	3294	4112343	2003-08-31	2003-08-31 00:00:00	2003-09-08	2003-09-08 00:00:00	32020		\N	218858	0	195662009	4112343		0
45212	2688	40481087	2015-12-03	2015-12-03 00:00:00	2015-12-17	2015-12-17 00:00:00	32020		\N	178154	0	444814009	40481087		0
55991	3314	260139	1999-08-01	1999-08-01 00:00:00	1999-08-08	1999-08-08 00:00:00	32020		\N	220078	0	10509002	260139		0
45637	2711	4112343	1959-10-13	1959-10-13 00:00:00	1959-10-22	1959-10-22 00:00:00	32020		\N	179771	0	195662009	4112343		0
56295	3337	4112343	1972-03-28	1972-03-28 00:00:00	1972-04-10	1972-04-10 00:00:00	32020		\N	221420	0	195662009	4112343		0
45972	2739	372328	1956-05-31	1956-05-31 00:00:00	1956-08-22	1956-08-22 00:00:00	32020		\N	181190	0	65363002	372328		0
56711	3363	80180	1995-08-08	1995-08-08 00:00:00	\N	\N	32020		\N	222967	0	396275006	80180		0
56780	3367	4112343	2014-07-10	2014-07-10 00:00:00	2014-07-19	2014-07-19 00:00:00	32020		\N	223311	0	195662009	4112343		0
46437	2765	4155034	1998-01-31	1998-01-31 00:00:00	1998-02-14	1998-02-14 00:00:00	32020		\N	182894	0	283371005	4155034		0
46554	2771	381316	1991-10-18	1991-10-18 00:00:00	\N	\N	32020		\N	183504	0	230690007	381316		0
46782	2782	40481087	1991-03-15	1991-03-15 00:00:00	1991-03-29	1991-03-29 00:00:00	32020		\N	184348	0	444814009	40481087		0
46951	2792	4059173	1994-01-10	1994-01-10 00:00:00	1994-04-10	1994-04-10 00:00:00	32020		\N	185040	0	16114001	4059173		0
57618	3418	40481087	1972-08-16	1972-08-16 00:00:00	1972-08-30	1972-08-30 00:00:00	32020		\N	226713	0	444814009	40481087		0
57780	3428	260139	1976-12-20	1976-12-20 00:00:00	1976-12-27	1976-12-27 00:00:00	32020		\N	227253	0	10509002	260139		0
47458	2822	260139	1980-06-01	1980-06-01 00:00:00	1980-06-08	1980-06-08 00:00:00	32020		\N	187034	0	10509002	260139		0
47628	2832	40481087	1999-07-08	1999-07-08 00:00:00	1999-07-29	1999-07-29 00:00:00	32020		\N	187908	0	444814009	40481087		0
47713	2835	4283893	2010-02-27	2010-02-27 00:00:00	2010-04-03	2010-04-03 00:00:00	32020		\N	188323	0	36971009	4283893		0
47906	2844	4112343	1949-11-01	1949-11-01 00:00:00	1949-11-14	1949-11-14 00:00:00	32020		\N	188879	0	195662009	4112343		0
58683	3481	40481087	1988-05-05	1988-05-05 00:00:00	1988-05-12	1988-05-12 00:00:00	32020		\N	230862	0	444814009	40481087		0
48208	2859	40481087	2002-03-20	2002-03-20 00:00:00	2002-03-27	2002-03-27 00:00:00	32020		\N	190036	0	444814009	40481087		0
48365	2864	260139	2013-05-05	2013-05-05 00:00:00	2013-05-19	2013-05-19 00:00:00	32020		\N	190470	0	10509002	260139		0
59171	3510	4112343	1993-10-18	1993-10-18 00:00:00	1993-10-31	1993-10-31 00:00:00	32020		\N	232830	0	195662009	4112343		0
59337	3518	80180	1994-03-12	1994-03-12 00:00:00	\N	\N	32020		\N	233561	0	396275006	80180		0
48921	2896	80180	2002-03-05	2002-03-05 00:00:00	\N	\N	32020		\N	192861	0	396275006	80180		0
59622	3533	260139	1994-10-09	1994-10-09 00:00:00	1994-10-23	1994-10-23 00:00:00	32020		\N	234680	0	10509002	260139		0
59807	3543	4112343	1975-05-19	1975-05-19 00:00:00	1975-06-01	1975-06-01 00:00:00	32020		\N	235368	0	195662009	4112343		0
59955	3552	372328	1957-07-13	1957-07-13 00:00:00	1957-10-24	1957-10-24 00:00:00	32020		\N	235853	0	65363002	372328		0
60100	3560	260139	2012-04-28	2012-04-28 00:00:00	2012-05-12	2012-05-12 00:00:00	32020		\N	236372	0	10509002	260139		0
60270	3567	4294548	2016-09-15	2016-09-15 00:00:00	2016-10-06	2016-10-06 00:00:00	32020		\N	236992	0	75498004	4294548		0
49857	2947	30753	2017-11-02	2017-11-02 00:00:00	\N	\N	32020		\N	196724	0	16761005	30753		0
50121	2960	40481087	1997-09-21	1997-09-21 00:00:00	1997-09-28	1997-09-28 00:00:00	32020		\N	197616	0	444814009	40481087		0
50214	2966	4112343	1983-12-17	1983-12-17 00:00:00	1983-12-29	1983-12-29 00:00:00	32020		\N	198059	0	195662009	4112343		0
60964	3609	4112343	2007-05-17	2007-05-17 00:00:00	2007-05-30	2007-05-30 00:00:00	32020		\N	239755	0	195662009	4112343		0
50596	2992	4146173	1993-07-14	1993-07-14 00:00:00	1993-08-13	1993-08-13 00:00:00	32020		\N	199694	0	307731004	4146173		0
50765	3002	78272	1981-12-09	1981-12-09 00:00:00	1982-01-13	1982-01-13 00:00:00	32020		\N	200334	0	70704007	78272		0
50924	3013	40481087	2009-12-06	2009-12-06 00:00:00	2009-12-27	2009-12-27 00:00:00	32020		\N	200906	0	444814009	40481087		0
51023	3020	40481087	1993-08-26	1993-08-26 00:00:00	1993-09-09	1993-09-09 00:00:00	32020		\N	201365	0	444814009	40481087		0
61827	3650	260139	1931-03-08	1931-03-08 00:00:00	1931-03-15	1931-03-15 00:00:00	32020		\N	242964	0	10509002	260139		0
61925	3655	40481087	1979-11-23	1979-11-23 00:00:00	1979-11-30	1979-11-30 00:00:00	32020		\N	243278	0	444814009	40481087		0
51579	3060	4218389	2010-03-19	2010-03-19 00:00:00	2010-04-09	2010-04-09 00:00:00	32020		\N	203630	0	39848009	4218389		0
62305	3680	4280726	1983-04-09	1983-04-09 00:00:00	\N	\N	32020		\N	244727	0	367498001	4280726		0
62417	3689	28060	1998-10-16	1998-10-16 00:00:00	1998-10-23	1998-10-23 00:00:00	32020		\N	245232	0	43878008	28060		0
52085	3083	4112343	1977-06-19	1977-06-19 00:00:00	1977-07-02	1977-07-02 00:00:00	32020		\N	205320	0	195662009	4112343		0
52271	3093	40481087	2006-06-02	2006-06-02 00:00:00	2006-06-09	2006-06-09 00:00:00	32020		\N	205917	0	444814009	40481087		0
52384	3103	40481087	2003-10-19	2003-10-19 00:00:00	2003-11-01	2003-11-01 00:00:00	32020		\N	206402	0	444814009	40481087		0
63192	3732	381316	2016-09-18	2016-09-18 00:00:00	\N	\N	32020		\N	247982	0	230690007	381316		0
63314	3739	4112343	2005-03-26	2005-03-26 00:00:00	2005-04-08	2005-04-08 00:00:00	32020		\N	248422	0	195662009	4112343		0
63460	3748	4112343	1992-03-17	1992-03-17 00:00:00	1992-03-24	1992-03-24 00:00:00	32020		\N	249143	0	195662009	4112343		0
63656	3759	372328	1964-11-07	1964-11-07 00:00:00	1965-01-17	1965-01-17 00:00:00	32020		\N	249927	0	65363002	372328		0
42652	2542	134438	1986-06-01	1986-06-01 00:00:00	1987-05-03	1987-05-03 00:00:00	32020		\N	168106	0	40275004	134438		0
53355	3161	40481087	1960-10-14	1960-10-14 00:00:00	1960-10-21	1960-10-21 00:00:00	32020		\N	210213	0	444814009	40481087		0
53487	3170	4112343	1969-12-25	1969-12-25 00:00:00	1970-01-06	1970-01-06 00:00:00	32020		\N	210720	0	195662009	4112343		0
43153	2570	40481087	1989-01-02	1989-01-02 00:00:00	1989-01-09	1989-01-09 00:00:00	32020		\N	170166	0	444814009	40481087		0
43248	2576	372328	1981-12-11	1981-12-11 00:00:00	1982-04-15	1982-04-15 00:00:00	32020		\N	170542	0	65363002	372328		0
53976	3195	4112343	2018-06-08	2018-06-08 00:00:00	2018-06-16	2018-06-16 00:00:00	32020		\N	212575	0	195662009	4112343		0
43575	2596	40481087	1976-08-14	1976-08-14 00:00:00	1976-08-21	1976-08-21 00:00:00	32020		\N	171810	0	444814009	40481087		0
43816	2609	372328	1961-11-12	1961-11-12 00:00:00	1962-01-26	1962-01-26 00:00:00	32020		\N	172480	0	65363002	372328		0
43938	2615	40481087	2010-02-16	2010-02-16 00:00:00	2010-02-23	2010-02-23 00:00:00	32020		\N	172856	0	444814009	40481087		0
44135	2624	40481087	1984-02-29	1984-02-29 00:00:00	1984-03-14	1984-03-14 00:00:00	32020		\N	173601	0	444814009	40481087		0
44306	2633	40481087	1960-04-05	1960-04-05 00:00:00	1960-04-26	1960-04-26 00:00:00	32020		\N	174195	0	444814009	40481087		0
54998	3254	4116491	1984-11-25	1984-11-25 00:00:00	1985-01-08	1985-01-08 00:00:00	32020		\N	216410	0	301011002	4116491		0
55206	3268	40481087	2005-07-18	2005-07-18 00:00:00	2005-08-01	2005-08-01 00:00:00	32020		\N	217175	0	444814009	40481087		0
55284	3275	40481087	1984-08-07	1984-08-07 00:00:00	1984-08-21	1984-08-21 00:00:00	32020		\N	217648	0	444814009	40481087		0
44970	2675	40481087	1984-06-22	1984-06-22 00:00:00	1984-07-13	1984-07-13 00:00:00	32020		\N	177268	0	444814009	40481087		0
55639	3294	4112343	1981-01-19	1981-01-19 00:00:00	1981-02-01	1981-02-01 00:00:00	32020		\N	218856	0	195662009	4112343		0
45220	2690	40481087	1949-07-03	1949-07-03 00:00:00	1949-07-24	1949-07-24 00:00:00	32020		\N	178227	0	444814009	40481087		0
55992	3314	260139	2019-01-18	2019-01-18 00:00:00	2019-01-25	2019-01-25 00:00:00	32020		\N	220094	0	10509002	260139		0
45638	2711	260139	1952-12-14	1952-12-14 00:00:00	1952-12-28	1952-12-28 00:00:00	32020		\N	179707	0	10509002	260139		0
56296	3337	260139	2019-06-10	2019-06-10 00:00:00	2019-06-17	2019-06-17 00:00:00	32020		\N	221358	0	10509002	260139		0
45973	2739	4283893	1995-07-22	1995-07-22 00:00:00	1995-09-02	1995-09-02 00:00:00	32020		\N	181262	0	36971009	4283893		0
56712	3363	4285898	1995-05-10	1995-05-10 00:00:00	\N	\N	32020		\N	222967	0	68496003	4285898		0
56781	3367	260139	1992-04-23	1992-04-23 00:00:00	1992-04-30	1992-04-30 00:00:00	32020		\N	223308	0	10509002	260139		0
46438	2765	28060	2013-07-08	2013-07-08 00:00:00	2013-07-15	2013-07-15 00:00:00	32020		\N	182988	0	43878008	28060		0
46555	2771	40481087	1952-06-30	1952-06-30 00:00:00	1952-07-07	1952-07-07 00:00:00	32020		\N	183456	0	444814009	40481087		0
46783	2782	80502	2000-03-22	2000-03-22 00:00:00	\N	\N	32020		\N	184397	0	64859006	80502		0
46952	2792	4285898	2001-07-13	2001-07-13 00:00:00	\N	\N	32020		\N	185036	0	68496003	4285898		0
57619	3418	4112343	2012-06-17	2012-06-17 00:00:00	2012-06-25	2012-06-25 00:00:00	32020		\N	226723	0	195662009	4112343		0
57781	3428	257012	1987-06-12	1987-06-12 00:00:00	\N	\N	32020		\N	227286	0	40055000	257012		0
57935	3436	40481087	2014-05-19	2014-05-19 00:00:00	2014-06-09	2014-06-09 00:00:00	32020		\N	227883	0	444814009	40481087		0
47629	2832	260139	2000-04-13	2000-04-13 00:00:00	2000-04-27	2000-04-27 00:00:00	32020		\N	187935	0	10509002	260139		0
47714	2835	378001	1933-05-17	1933-05-17 00:00:00	1933-06-16	1933-06-16 00:00:00	32020		\N	188338	0	62106007	378001		0
47907	2844	4112343	2000-11-30	2000-11-30 00:00:00	2000-12-08	2000-12-08 00:00:00	32020		\N	188870	0	195662009	4112343		0
58684	3481	81151	1987-02-03	1987-02-03 00:00:00	1987-02-17	1987-02-17 00:00:00	32020		\N	230874	0	44465007	81151		0
48209	2859	372328	1943-10-08	1943-10-08 00:00:00	1943-11-22	1943-11-22 00:00:00	32020		\N	190005	0	65363002	372328		0
48366	2864	4112343	1947-03-29	1947-03-29 00:00:00	1947-04-06	1947-04-06 00:00:00	32020		\N	190464	0	195662009	4112343		0
59172	3510	260139	1983-01-22	1983-01-22 00:00:00	1983-02-05	1983-02-05 00:00:00	32020		\N	232859	0	10509002	260139		0
59338	3518	4266809	1994-03-12	1994-03-12 00:00:00	\N	\N	32020		\N	233561	0	397881000	4266809		0
48922	2896	40481087	2001-10-01	2001-10-01 00:00:00	2001-10-22	2001-10-22 00:00:00	32020		\N	192861	0	444814009	40481087		0
59623	3533	4113008	2000-04-18	2000-04-18 00:00:00	2000-05-09	2000-05-09 00:00:00	32020		\N	234720	0	284549007	4113008		0
59808	3543	372328	1960-05-05	1960-05-05 00:00:00	1960-06-21	1960-06-21 00:00:00	32020		\N	235375	0	65363002	372328		0
59956	3552	4152936	2017-05-04	2017-05-04 00:00:00	2017-05-18	2017-05-18 00:00:00	32020		\N	235862	0	283385000	4152936		0
60101	3560	4283893	1971-09-28	1971-09-28 00:00:00	1971-12-21	1971-12-21 00:00:00	32020		\N	236349	0	36971009	4283893		0
60271	3567	260139	2002-06-29	2002-06-29 00:00:00	2002-07-13	2002-07-13 00:00:00	32020		\N	237050	0	10509002	260139		0
49858	2947	4310024	2016-09-08	2016-09-08 00:00:00	\N	\N	32020		\N	196724	0	424802006	4310024		0
50122	2960	40481087	1985-01-29	1985-01-29 00:00:00	1985-02-05	1985-02-05 00:00:00	32020		\N	197655	0	444814009	40481087		0
50215	2966	260139	2016-11-23	2016-11-23 00:00:00	2016-12-07	2016-12-07 00:00:00	32020		\N	198105	0	10509002	260139		0
60965	3609	81151	1983-09-04	1983-09-04 00:00:00	1983-09-25	1983-09-25 00:00:00	32020		\N	239785	0	44465007	81151		0
50597	2992	4109685	2007-07-01	2007-07-01 00:00:00	2007-07-22	2007-07-22 00:00:00	32020		\N	199766	0	284551006	4109685		0
50766	3002	4112343	2004-02-01	2004-02-01 00:00:00	2004-02-11	2004-02-11 00:00:00	32020		\N	200347	0	195662009	4112343		0
50925	3013	260139	1982-05-15	1982-05-15 00:00:00	1982-05-22	1982-05-22 00:00:00	32020		\N	200932	0	10509002	260139		0
51024	3020	260139	1969-03-20	1969-03-20 00:00:00	1969-03-27	1969-03-27 00:00:00	32020		\N	201392	0	10509002	260139		0
61828	3650	4218389	1992-05-26	1992-05-26 00:00:00	1992-06-16	1992-06-16 00:00:00	32020		\N	242938	0	39848009	4218389		0
61926	3655	40481087	1956-10-03	1956-10-03 00:00:00	1956-10-10	1956-10-10 00:00:00	32020		\N	243265	0	444814009	40481087		0
51580	3060	40481087	1972-10-15	1972-10-15 00:00:00	1972-11-05	1972-11-05 00:00:00	32020		\N	203656	0	444814009	40481087		0
62306	3680	260139	1984-09-04	1984-09-04 00:00:00	1984-09-18	1984-09-18 00:00:00	32020		\N	244728	0	10509002	260139		0
62418	3689	28060	1988-10-19	1988-10-19 00:00:00	1988-10-26	1988-10-26 00:00:00	32020		\N	245219	0	43878008	28060		0
52086	3083	40481087	1962-10-25	1962-10-25 00:00:00	1962-11-01	1962-11-01 00:00:00	32020		\N	205261	0	444814009	40481087		0
52272	3093	260139	2011-02-28	2011-02-28 00:00:00	2011-03-14	2011-03-14 00:00:00	32020		\N	205908	0	10509002	260139		0
52385	3103	4132546	1993-08-11	1993-08-11 00:00:00	\N	\N	32020		\N	206457	0	275272006	4166590		0
63193	3732	4155034	1985-06-09	1985-06-09 00:00:00	1985-06-23	1985-06-23 00:00:00	32020		\N	247984	0	283371005	4155034		0
63315	3739	4112343	2007-07-14	2007-07-14 00:00:00	2007-07-23	2007-07-23 00:00:00	32020		\N	248463	0	195662009	4112343		0
63461	3748	40481087	2011-04-30	2011-04-30 00:00:00	2011-05-14	2011-05-14 00:00:00	32020		\N	249110	0	444814009	40481087		0
63657	3759	260139	1966-03-03	1966-03-03 00:00:00	1966-03-17	1966-03-17 00:00:00	32020		\N	249944	0	10509002	260139		0
42653	2542	40481087	1970-05-12	1970-05-12 00:00:00	1970-05-19	1970-05-19 00:00:00	32020		\N	168103	0	444814009	40481087		0
53356	3161	40481087	1995-01-27	1995-01-27 00:00:00	1995-02-10	1995-02-10 00:00:00	32020		\N	210176	0	444814009	40481087		0
53488	3170	80180	1985-08-30	1985-08-30 00:00:00	\N	\N	32020		\N	210763	0	396275006	80180		0
43154	2570	40481087	1984-05-14	1984-05-14 00:00:00	1984-05-28	1984-05-28 00:00:00	32020		\N	170212	0	444814009	40481087		0
43249	2576	80180	2019-04-12	2019-04-12 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
53977	3195	260139	2006-10-21	2006-10-21 00:00:00	2006-11-04	2006-11-04 00:00:00	32020		\N	212573	0	10509002	260139		0
43576	2596	4266809	2004-06-06	2004-06-06 00:00:00	\N	\N	32020		\N	171805	0	397881000	4266809		0
43817	2609	321042	2018-12-14	2018-12-14 00:00:00	\N	\N	32020		\N	172469	0	410429000	321042		0
43939	2616	80180	1987-12-08	1987-12-08 00:00:00	\N	\N	32020		\N	173020	0	396275006	80180		0
44136	2624	30753	2005-10-21	2005-10-21 00:00:00	\N	\N	32020		\N	173570	0	16761005	30753		0
44307	2633	4112343	1999-10-27	1999-10-27 00:00:00	1999-11-08	1999-11-08 00:00:00	32020		\N	174221	0	195662009	4112343		0
54999	3254	40481087	2006-09-01	2006-09-01 00:00:00	2006-09-08	2006-09-08 00:00:00	32020		\N	216447	0	444814009	40481087		0
55207	3268	260139	1988-11-23	1988-11-23 00:00:00	1988-12-07	1988-12-07 00:00:00	32020		\N	217165	0	10509002	260139		0
55285	3275	4112343	1971-02-07	1971-02-07 00:00:00	1971-02-16	1971-02-16 00:00:00	32020		\N	217628	0	195662009	4112343		0
44971	2675	4109685	2006-06-21	2006-06-21 00:00:00	2006-07-05	2006-07-05 00:00:00	32020		\N	177236	0	284551006	4109685		0
55640	3294	40481087	2018-12-27	2018-12-27 00:00:00	2019-01-10	2019-01-10 00:00:00	32020		\N	218816	0	444814009	40481087		0
45221	2690	4112343	1993-04-03	1993-04-03 00:00:00	1993-04-12	1993-04-12 00:00:00	32020		\N	178231	0	195662009	4112343		0
55993	3314	40481087	1993-03-01	1993-03-01 00:00:00	1993-03-08	1993-03-08 00:00:00	32020		\N	220086	0	444814009	40481087		0
45639	2711	40481087	1982-02-26	1982-02-26 00:00:00	1982-03-05	1982-03-05 00:00:00	32020		\N	179637	0	444814009	40481087		0
56297	3337	40481087	2007-05-23	2007-05-23 00:00:00	2007-06-13	2007-06-13 00:00:00	32020		\N	221417	0	444814009	40481087		0
45974	2739	4112343	1998-11-10	1998-11-10 00:00:00	1998-11-17	1998-11-17 00:00:00	32020		\N	181263	0	195662009	4112343		0
56713	3363	260139	1985-04-30	1985-04-30 00:00:00	1985-05-14	1985-05-14 00:00:00	32020		\N	222994	0	10509002	260139		0
56782	3367	28060	2015-10-13	2015-10-13 00:00:00	2015-10-25	2015-10-25 00:00:00	32020		\N	223342	0	43878008	28060		0
46439	2765	4113008	1952-12-11	1952-12-11 00:00:00	1953-01-01	1953-01-01 00:00:00	32020		\N	182888	0	284549007	4113008		0
46557	2771	4029498	1972-09-01	1972-09-01 00:00:00	\N	\N	32020		\N	183473	0	128613002	4029498		0
46784	2782	40481087	1939-08-24	1939-08-24 00:00:00	1939-08-31	1939-08-31 00:00:00	32020		\N	184418	0	444814009	40481087		0
46953	2792	81893	2000-04-19	2000-04-19 00:00:00	\N	\N	32020		\N	185036	0	64766004	81893		0
57620	3418	4027663	1968-10-10	1968-10-10 00:00:00	\N	\N	32020		\N	226720	0	13200003	4027663		0
57782	3428	4112343	1999-04-17	1999-04-17 00:00:00	1999-04-26	1999-04-26 00:00:00	32020		\N	227267	0	195662009	4112343		0
57936	3436	4112343	1968-05-11	1968-05-11 00:00:00	1968-05-18	1968-05-18 00:00:00	32020		\N	227857	0	195662009	4112343		0
47630	2832	40481087	1977-08-06	1977-08-06 00:00:00	1977-08-13	1977-08-13 00:00:00	32020		\N	187973	0	444814009	40481087		0
47715	2835	4112343	1929-03-31	1929-03-31 00:00:00	1929-04-13	1929-04-13 00:00:00	32020		\N	188348	0	195662009	4112343		0
47908	2844	4310024	1990-04-27	1990-04-27 00:00:00	\N	\N	32020		\N	188820	0	424802006	4310024		0
58685	3481	40481087	2002-04-03	2002-04-03 00:00:00	2002-04-24	2002-04-24 00:00:00	32020		\N	230838	0	444814009	40481087		0
48210	2859	28060	1951-06-13	1951-06-13 00:00:00	1951-06-25	1951-06-25 00:00:00	32020		\N	190022	0	43878008	28060		0
48367	2864	4059173	1949-08-02	1949-08-02 00:00:00	1949-10-31	1949-10-31 00:00:00	32020		\N	190549	0	16114001	4059173		0
59173	3510	260139	1970-02-12	1970-02-12 00:00:00	1970-02-19	1970-02-19 00:00:00	32020		\N	232813	0	10509002	260139		0
59339	3518	4285898	1993-10-13	1993-10-13 00:00:00	\N	\N	32020		\N	233561	0	68496003	4285898		0
48923	2896	40481087	1981-04-16	1981-04-16 00:00:00	1981-04-30	1981-04-30 00:00:00	32020		\N	192782	0	444814009	40481087		0
59624	3533	81151	1972-06-04	1972-06-04 00:00:00	1972-06-18	1972-06-18 00:00:00	32020		\N	234661	0	44465007	81151		0
59809	3543	40481087	2004-04-02	2004-04-02 00:00:00	2004-04-23	2004-04-23 00:00:00	32020		\N	235370	0	444814009	40481087		0
59957	3552	40481087	1999-11-02	1999-11-02 00:00:00	1999-11-23	1999-11-23 00:00:00	32020		\N	235806	0	444814009	40481087		0
60102	3560	4109685	1987-02-26	1987-02-26 00:00:00	1987-03-19	1987-03-19 00:00:00	32020		\N	236412	0	284551006	4109685		0
60272	3567	40481087	2011-02-25	2011-02-25 00:00:00	2011-03-11	2011-03-11 00:00:00	32020		\N	237008	0	444814009	40481087		0
49859	2947	81893	2017-08-04	2017-08-04 00:00:00	\N	\N	32020		\N	196724	0	64766004	81893		0
50123	2960	4112343	1999-08-28	1999-08-28 00:00:00	1999-09-09	1999-09-09 00:00:00	32020		\N	197666	0	195662009	4112343		0
50216	2966	40481087	2015-11-26	2015-11-26 00:00:00	2015-12-10	2015-12-10 00:00:00	32020		\N	198144	0	444814009	40481087		0
60966	3609	4155034	1982-10-18	1982-10-18 00:00:00	1982-11-08	1982-11-08 00:00:00	32020		\N	239784	0	283371005	4155034		0
50598	2992	381316	2011-08-19	2011-08-19 00:00:00	\N	\N	32020		\N	199719	0	230690007	381316		0
50767	3002	40481087	1998-04-22	1998-04-22 00:00:00	1998-05-13	1998-05-13 00:00:00	32020		\N	200386	0	444814009	40481087		0
50926	3013	372328	1951-09-23	1951-09-23 00:00:00	1951-11-06	1951-11-06 00:00:00	32020		\N	200954	0	65363002	372328		0
51025	3020	4112343	2005-09-05	2005-09-05 00:00:00	2005-09-16	2005-09-16 00:00:00	32020		\N	201394	0	195662009	4112343		0
61829	3650	4112343	1980-06-13	1980-06-13 00:00:00	1980-06-25	1980-06-25 00:00:00	32020		\N	242943	0	195662009	4112343		0
61927	3655	4112343	1945-01-11	1945-01-11 00:00:00	1945-01-19	1945-01-19 00:00:00	32020		\N	243291	0	195662009	4112343		0
51581	3060	4112343	1952-11-14	1952-11-14 00:00:00	1952-11-24	1952-11-24 00:00:00	32020		\N	203606	0	195662009	4112343		0
62307	3680	28060	1999-11-17	1999-11-17 00:00:00	1999-11-29	1999-11-29 00:00:00	32020		\N	244702	0	43878008	28060		0
62419	3689	4112343	1992-10-06	1992-10-06 00:00:00	1992-10-13	1992-10-13 00:00:00	32020		\N	245231	0	195662009	4112343		0
52087	3084	4134304	2006-10-13	2006-10-13 00:00:00	2006-12-12	2006-12-12 00:00:00	32020		\N	205355	0	263102004	4134304		0
52273	3093	4112343	2003-11-13	2003-11-13 00:00:00	2003-11-25	2003-11-25 00:00:00	32020		\N	205916	0	195662009	4112343		0
52386	3103	4001336	1993-08-11	1993-08-11 00:00:00	1993-09-10	1993-09-10 00:00:00	32020		\N	206457	0	110030002	4001336		0
63194	3732	40481087	1960-12-08	1960-12-08 00:00:00	1960-12-22	1960-12-22 00:00:00	32020		\N	248013	0	444814009	40481087		0
63316	3739	80180	2007-02-15	2007-02-15 00:00:00	\N	\N	32020		\N	248451	0	396275006	80180		0
63462	3748	260139	2009-06-14	2009-06-14 00:00:00	2009-06-21	2009-06-21 00:00:00	32020		\N	249146	0	10509002	260139		0
63658	3759	4112343	1982-06-08	1982-06-08 00:00:00	1982-06-16	1982-06-16 00:00:00	32020		\N	249948	0	195662009	4112343		0
42654	2542	4112343	2000-03-26	2000-03-26 00:00:00	2000-04-04	2000-04-04 00:00:00	32020		\N	168209	0	195662009	4112343		0
53357	3161	372328	1953-03-14	1953-03-14 00:00:00	1953-04-22	1953-04-22 00:00:00	32020		\N	210241	0	65363002	372328		0
53489	3170	40481087	1986-07-14	1986-07-14 00:00:00	1986-08-04	1986-08-04 00:00:00	32020		\N	210707	0	444814009	40481087		0
43155	2570	4112343	1957-05-19	1957-05-19 00:00:00	1957-05-31	1957-05-31 00:00:00	32020		\N	170266	0	195662009	4112343		0
43250	2576	4112343	1997-03-22	1997-03-22 00:00:00	1997-04-01	1997-04-01 00:00:00	32020		\N	170559	0	195662009	4112343		0
53978	3195	372328	1951-02-10	1951-02-10 00:00:00	1951-04-02	1951-04-02 00:00:00	32020		\N	212517	0	65363002	372328		0
43577	2596	80180	2004-06-06	2004-06-06 00:00:00	\N	\N	32020		\N	171805	0	396275006	80180		0
43819	2609	4278672	1960-03-22	1960-03-22 00:00:00	1960-04-21	1960-04-21 00:00:00	32020		\N	172492	0	65966004	4278672		0
43940	2616	4112343	1963-09-27	1963-09-27 00:00:00	1963-10-10	1963-10-10 00:00:00	32020		\N	173010	0	195662009	4112343		0
44137	2624	4310024	2005-04-24	2005-04-24 00:00:00	\N	\N	32020		\N	173570	0	424802006	4310024		0
44308	2633	4112343	2002-09-27	2002-09-27 00:00:00	2002-10-07	2002-10-07 00:00:00	32020		\N	174200	0	195662009	4112343		0
55000	3254	4112343	2018-10-14	2018-10-14 00:00:00	2018-10-22	2018-10-22 00:00:00	32020		\N	216411	0	195662009	4112343		0
55208	3268	4112343	1974-09-15	1974-09-15 00:00:00	1974-09-22	1974-09-22 00:00:00	32020		\N	217172	0	195662009	4112343		0
55286	3275	195588	1997-03-31	1997-03-31 00:00:00	1997-05-08	1997-05-08 00:00:00	32020		\N	217611	0	38822007	195588		0
44972	2675	440448	1996-01-23	1996-01-23 00:00:00	\N	\N	32020		\N	177234	0	74400008	440448		0
55641	3294	4134304	2017-08-20	2017-08-20 00:00:00	2017-09-19	2017-09-19 00:00:00	32020		\N	218853	0	263102004	4134304		0
45222	2690	4310024	1982-11-21	1982-11-21 00:00:00	\N	\N	32020		\N	178251	0	424802006	4310024		0
55994	3314	40481087	2006-11-15	2006-11-15 00:00:00	2006-11-22	2006-11-22 00:00:00	32020		\N	220092	0	444814009	40481087		0
45640	2711	4278672	1979-05-25	1979-05-25 00:00:00	1979-06-24	1979-06-24 00:00:00	32020		\N	179610	0	65966004	4278672		0
56298	3337	40481087	1985-02-04	1985-02-04 00:00:00	1985-02-18	1985-02-18 00:00:00	32020		\N	221390	0	444814009	40481087		0
45975	2739	4112343	1962-03-31	1962-03-31 00:00:00	1962-04-13	1962-04-13 00:00:00	32020		\N	181210	0	195662009	4112343		0
56714	3363	40481087	2018-09-03	2018-09-03 00:00:00	2018-09-10	2018-09-10 00:00:00	32020		\N	222946	0	444814009	40481087		0
56783	3367	4112343	1967-07-23	1967-07-23 00:00:00	1967-08-03	1967-08-03 00:00:00	32020		\N	223297	0	195662009	4112343		0
46440	2765	40481087	1974-09-05	1974-09-05 00:00:00	1974-09-19	1974-09-19 00:00:00	32020		\N	182941	0	444814009	40481087		0
46558	2771	378001	1972-03-16	1972-03-16 00:00:00	1972-05-15	1972-05-15 00:00:00	32020		\N	183472	0	62106007	378001		0
46785	2782	4112343	1959-10-30	1959-10-30 00:00:00	1959-11-11	1959-11-11 00:00:00	32020		\N	184436	0	195662009	4112343		0
46954	2792	30753	2000-08-17	2000-08-17 00:00:00	\N	\N	32020		\N	185036	0	16761005	30753		0
57621	3418	4112343	2000-09-04	2000-09-04 00:00:00	2000-09-17	2000-09-17 00:00:00	32020		\N	226717	0	195662009	4112343		0
57783	3428	260139	1973-03-20	1973-03-20 00:00:00	1973-04-03	1973-04-03 00:00:00	32020		\N	227265	0	10509002	260139		0
57937	3436	4112343	1987-04-06	1987-04-06 00:00:00	1987-04-18	1987-04-18 00:00:00	32020		\N	227894	0	195662009	4112343		0
47631	2832	40481087	2011-03-05	2011-03-05 00:00:00	2011-03-19	2011-03-19 00:00:00	32020		\N	187985	0	444814009	40481087		0
47716	2835	40481087	1965-05-10	1965-05-10 00:00:00	1965-05-31	1965-05-31 00:00:00	32020		\N	188353	0	444814009	40481087		0
47909	2844	260139	1951-08-22	1951-08-22 00:00:00	1951-08-29	1951-08-29 00:00:00	32020		\N	188880	0	10509002	260139		0
58686	3481	40481087	1984-02-28	1984-02-28 00:00:00	1984-03-20	1984-03-20 00:00:00	32020		\N	230850	0	444814009	40481087		0
48211	2859	260139	1966-01-17	1966-01-17 00:00:00	1966-01-31	1966-01-31 00:00:00	32020		\N	190060	0	10509002	260139		0
48368	2865	4112343	2004-01-04	2004-01-04 00:00:00	2004-01-13	2004-01-13 00:00:00	32020		\N	190578	0	195662009	4112343		0
59174	3510	260139	1997-08-06	1997-08-06 00:00:00	1997-08-20	1997-08-20 00:00:00	32020		\N	232831	0	10509002	260139		0
59340	3518	78272	1967-06-12	1967-06-12 00:00:00	1967-07-10	1967-07-10 00:00:00	32020		\N	233579	0	70704007	78272		0
48924	2896	4109685	1999-09-24	1999-09-24 00:00:00	1999-10-15	1999-10-15 00:00:00	32020		\N	192867	0	284551006	4109685		0
59625	3533	4112343	1978-02-06	1978-02-06 00:00:00	1978-02-18	1978-02-18 00:00:00	32020		\N	234678	0	195662009	4112343		0
59810	3543	40481087	1987-04-26	1987-04-26 00:00:00	1987-05-03	1987-05-03 00:00:00	32020		\N	235369	0	444814009	40481087		0
59958	3553	40481087	1997-01-05	1997-01-05 00:00:00	1997-01-12	1997-01-12 00:00:00	32020		\N	235877	0	444814009	40481087		0
60103	3560	40481087	1963-04-11	1963-04-11 00:00:00	1963-05-02	1963-05-02 00:00:00	32020		\N	236351	0	444814009	40481087		0
60273	3567	260139	1991-12-21	1991-12-21 00:00:00	1992-01-04	1992-01-04 00:00:00	32020		\N	237047	0	10509002	260139		0
49860	2947	40481087	1997-05-16	1997-05-16 00:00:00	1997-05-23	1997-05-23 00:00:00	32020		\N	196711	0	444814009	40481087		0
50124	2960	4112343	2008-05-25	2008-05-25 00:00:00	2008-06-06	2008-06-06 00:00:00	32020		\N	197693	0	195662009	4112343		0
50217	2966	40481087	1991-10-25	1991-10-25 00:00:00	1991-11-08	1991-11-08 00:00:00	32020		\N	198086	0	444814009	40481087		0
60967	3609	372328	1977-02-16	1977-02-16 00:00:00	1977-05-06	1977-05-06 00:00:00	32020		\N	239771	0	65363002	372328		0
50599	2992	4113008	1981-01-29	1981-01-29 00:00:00	1981-02-19	1981-02-19 00:00:00	32020		\N	199764	0	284549007	4113008		0
50768	3002	4294548	1976-03-28	1976-03-28 00:00:00	1976-04-18	1976-04-18 00:00:00	32020		\N	200387	0	75498004	4294548		0
50927	3013	4112343	1962-12-25	1962-12-25 00:00:00	1963-01-02	1963-01-02 00:00:00	32020		\N	200937	0	195662009	4112343		0
51026	3020	4112343	1959-03-27	1959-03-27 00:00:00	1959-04-05	1959-04-05 00:00:00	32020		\N	201364	0	195662009	4112343		0
61830	3650	260139	2017-03-07	2017-03-07 00:00:00	2017-03-21	2017-03-21 00:00:00	32020		\N	242996	0	10509002	260139		0
61952	3658	260139	1998-01-10	1998-01-10 00:00:00	1998-01-24	1998-01-24 00:00:00	32020		\N	243440	0	10509002	260139		0
51582	3060	40479768	1945-09-05	1945-09-05 00:00:00	1945-10-12	1945-10-12 00:00:00	32020		\N	203626	0	444470001	40479768		0
62308	3680	372328	1985-01-01	1985-01-01 00:00:00	1985-09-24	1985-09-24 00:00:00	32020		\N	244703	0	65363002	372328		0
62420	3689	81151	1984-09-28	1984-09-28 00:00:00	1984-10-26	1984-10-26 00:00:00	32020		\N	245226	0	44465007	81151		0
52088	3084	40481087	1980-07-15	1980-07-15 00:00:00	1980-08-05	1980-08-05 00:00:00	32020		\N	205380	0	444814009	40481087		0
52274	3093	40481087	1999-05-05	1999-05-05 00:00:00	1999-05-19	1999-05-19 00:00:00	32020		\N	205941	0	444814009	40481087		0
52387	3103	372328	1978-11-06	1978-11-06 00:00:00	1978-11-20	1978-11-20 00:00:00	32020		\N	206408	0	65363002	372328		0
63195	3732	4296204	1999-01-09	1999-01-09 00:00:00	1999-02-06	1999-02-06 00:00:00	32020		\N	247986	0	403190006	4296204		0
63317	3739	28060	2007-02-01	2007-02-01 00:00:00	2007-02-12	2007-02-12 00:00:00	32020		\N	248451	0	43878008	28060		0
63463	3748	4112343	2014-04-22	2014-04-22 00:00:00	2014-05-01	2014-05-01 00:00:00	32020		\N	249100	0	195662009	4112343		0
63659	3759	4152936	1982-08-05	1982-08-05 00:00:00	1982-08-19	1982-08-19 00:00:00	32020		\N	249933	0	283385000	4152936		0
42655	2542	4112343	1965-12-18	1965-12-18 00:00:00	1965-12-25	1965-12-25 00:00:00	32020		\N	168074	0	195662009	4112343		0
53358	3161	192671	1990-01-04	1990-01-04 00:00:00	\N	\N	32020		\N	210250	0	K92.2	35208414		0
53490	3170	40481087	1972-05-06	1972-05-06 00:00:00	1972-05-20	1972-05-20 00:00:00	32020		\N	210723	0	444814009	40481087		0
43156	2570	4278672	1946-09-23	1946-09-23 00:00:00	1946-12-22	1946-12-22 00:00:00	32020		\N	170196	0	65966004	4278672		0
43251	2576	4112343	1982-01-28	1982-01-28 00:00:00	1982-02-08	1982-02-08 00:00:00	32020		\N	170538	0	195662009	4112343		0
53979	3195	40481087	1949-03-30	1949-03-30 00:00:00	1949-04-20	1949-04-20 00:00:00	32020		\N	212510	0	444814009	40481087		0
43578	2596	4112343	1979-08-24	1979-08-24 00:00:00	1979-09-03	1979-09-03 00:00:00	32020		\N	171811	0	195662009	4112343		0
43820	2610	4134304	1964-04-13	1964-04-13 00:00:00	1964-05-14	1964-05-14 00:00:00	32020		\N	172593	0	263102004	4134304		0
43941	2616	4283893	1990-03-06	1990-03-06 00:00:00	1990-05-01	1990-05-01 00:00:00	32020		\N	173013	0	36971009	4283893		0
44138	2624	4112343	2009-09-11	2009-09-11 00:00:00	2009-09-24	2009-09-24 00:00:00	32020		\N	173594	0	195662009	4112343		0
44309	2633	4109685	1991-11-24	1991-11-24 00:00:00	1991-12-08	1991-12-08 00:00:00	32020		\N	174228	0	284551006	4109685		0
55001	3254	40481087	1975-11-28	1975-11-28 00:00:00	1975-12-19	1975-12-19 00:00:00	32020		\N	216454	0	444814009	40481087		0
55209	3268	4156265	2018-05-21	2018-05-21 00:00:00	2018-06-11	2018-06-11 00:00:00	32020		\N	217215	0	370247008	4156265		0
55287	3275	40481087	1977-05-12	1977-05-12 00:00:00	1977-05-19	1977-05-19 00:00:00	32020		\N	217580	0	444814009	40481087		0
44973	2675	40481087	1999-10-12	1999-10-12 00:00:00	1999-10-19	1999-10-19 00:00:00	32020		\N	177291	0	444814009	40481087		0
55642	3294	440448	1977-10-13	1977-10-13 00:00:00	\N	\N	32020		\N	218850	0	74400008	440448		0
45223	2690	372328	1949-06-27	1949-06-27 00:00:00	1949-09-08	1949-09-08 00:00:00	32020		\N	178242	0	65363002	372328		0
55995	3314	4027663	1996-08-30	1996-08-30 00:00:00	\N	\N	32020		\N	220102	0	13200003	4027663		0
45641	2711	4051466	1953-07-02	1953-07-02 00:00:00	1969-10-08	1969-10-08 00:00:00	32020		\N	179649	0	233678006	4051466		0
56299	3337	4112343	1991-08-31	1991-08-31 00:00:00	1991-09-12	1991-09-12 00:00:00	32020		\N	221369	0	195662009	4112343		0
45976	2739	4146173	1997-03-11	1997-03-11 00:00:00	1997-04-10	1997-04-10 00:00:00	32020		\N	181213	0	307731004	4146173		0
56715	3363	81151	1956-05-04	1956-05-04 00:00:00	1956-06-08	1956-06-08 00:00:00	32020		\N	222949	0	44465007	81151		0
56784	3367	372328	1968-02-06	1968-02-06 00:00:00	1969-02-17	1969-02-17 00:00:00	32020		\N	223332	0	65363002	372328		0
46441	2765	260139	1994-08-17	1994-08-17 00:00:00	1994-08-31	1994-08-31 00:00:00	32020		\N	182998	0	10509002	260139		0
46559	2771	4156265	1961-08-27	1961-08-27 00:00:00	1961-09-10	1961-09-10 00:00:00	32020		\N	183471	0	370247008	4156265		0
46786	2782	313217	1977-01-26	1977-01-26 00:00:00	\N	\N	32020		\N	184359	0	49436004	313217		0
46955	2792	372328	1958-02-04	1958-02-04 00:00:00	1958-03-17	1958-03-17 00:00:00	32020		\N	184997	0	65363002	372328		0
57622	3418	40481087	2007-02-01	2007-02-01 00:00:00	2007-02-08	2007-02-08 00:00:00	32020		\N	226753	0	444814009	40481087		0
57784	3428	4112343	2007-05-15	2007-05-15 00:00:00	2007-05-28	2007-05-28 00:00:00	32020		\N	227268	0	195662009	4112343		0
57938	3436	40481087	1983-05-14	1983-05-14 00:00:00	1983-06-04	1983-06-04 00:00:00	32020		\N	227878	0	444814009	40481087		0
47632	2832	4112343	1989-11-17	1989-11-17 00:00:00	1989-11-28	1989-11-28 00:00:00	32020		\N	187944	0	195662009	4112343		0
47717	2835	78272	1914-12-02	1914-12-02 00:00:00	1914-12-23	1914-12-23 00:00:00	32020		\N	188300	0	70704007	78272		0
47910	2844	260139	1964-11-11	1964-11-11 00:00:00	1964-11-25	1964-11-25 00:00:00	32020		\N	188827	0	10509002	260139		0
58687	3481	40481087	2011-07-12	2011-07-12 00:00:00	2011-07-19	2011-07-19 00:00:00	32020		\N	230845	0	444814009	40481087		0
48212	2859	4112343	1972-07-28	1972-07-28 00:00:00	1972-08-05	1972-08-05 00:00:00	32020		\N	190061	0	195662009	4112343		0
48369	2865	40481087	1980-01-02	1980-01-02 00:00:00	1980-01-16	1980-01-16 00:00:00	32020		\N	190626	0	444814009	40481087		0
59175	3510	28060	1935-09-07	1935-09-07 00:00:00	1935-09-18	1935-09-18 00:00:00	32020		\N	232959	0	43878008	28060		0
59341	3518	40481087	1968-05-08	1968-05-08 00:00:00	1968-05-22	1968-05-22 00:00:00	32020		\N	233552	0	444814009	40481087		0
48925	2896	4156265	1989-02-04	1989-02-04 00:00:00	1989-02-18	1989-02-18 00:00:00	32020		\N	192866	0	370247008	4156265		0
59626	3533	4112343	2003-07-09	2003-07-09 00:00:00	2003-07-21	2003-07-21 00:00:00	32020		\N	234710	0	195662009	4112343		0
59811	3543	78272	1994-09-25	1994-09-25 00:00:00	1994-10-30	1994-10-30 00:00:00	32020		\N	235331	0	70704007	78272		0
59959	3553	378419	2006-06-24	2006-06-24 00:00:00	\N	\N	32020		\N	235918	0	26929004	378419		0
60104	3560	28060	1994-05-22	1994-05-22 00:00:00	1994-06-04	1994-06-04 00:00:00	32020		\N	236370	0	43878008	28060		0
60274	3567	40481087	1991-08-01	1991-08-01 00:00:00	1991-08-08	1991-08-08 00:00:00	32020		\N	236989	0	444814009	40481087		0
49861	2947	4218389	1998-09-09	1998-09-09 00:00:00	1998-10-14	1998-10-14 00:00:00	32020		\N	196700	0	39848009	4218389		0
50125	2960	4296204	1993-02-11	1993-02-11 00:00:00	1993-02-25	1993-02-25 00:00:00	32020		\N	197608	0	403190006	4296204		0
50218	2966	4296204	2002-06-12	2002-06-12 00:00:00	2002-07-17	2002-07-17 00:00:00	32020		\N	198047	0	403190006	4296204		0
60968	3609	4112343	2009-05-04	2009-05-04 00:00:00	2009-05-14	2009-05-14 00:00:00	32020		\N	239769	0	195662009	4112343		0
50600	2992	4059173	2012-05-17	2012-05-17 00:00:00	2012-08-15	2012-08-15 00:00:00	32020		\N	199768	0	16114001	4059173		0
50769	3002	4112343	1980-04-28	1980-04-28 00:00:00	1980-05-05	1980-05-05 00:00:00	32020		\N	200384	0	195662009	4112343		0
50928	3013	4112343	1968-05-19	1968-05-19 00:00:00	1968-06-01	1968-06-01 00:00:00	32020		\N	200931	0	195662009	4112343		0
51027	3020	40481087	1972-12-30	1972-12-30 00:00:00	1973-01-06	1973-01-06 00:00:00	32020		\N	201380	0	444814009	40481087		0
61831	3650	260139	1955-09-30	1955-09-30 00:00:00	1955-10-14	1955-10-14 00:00:00	32020		\N	242987	0	10509002	260139		0
61953	3658	40481087	1977-08-25	1977-08-25 00:00:00	1977-09-15	1977-09-15 00:00:00	32020		\N	243435	0	444814009	40481087		0
51583	3060	260139	1932-12-16	1932-12-16 00:00:00	1932-12-23	1932-12-23 00:00:00	32020		\N	203570	0	10509002	260139		0
62309	3680	260139	2006-07-29	2006-07-29 00:00:00	2006-08-12	2006-08-12 00:00:00	32020		\N	244715	0	10509002	260139		0
62421	3689	40481087	1983-08-27	1983-08-27 00:00:00	1983-09-03	1983-09-03 00:00:00	32020		\N	245218	0	444814009	40481087		0
52089	3084	260139	1982-03-03	1982-03-03 00:00:00	1982-03-17	1982-03-17 00:00:00	32020		\N	205366	0	10509002	260139		0
52290	3096	4059173	2011-01-14	2011-01-14 00:00:00	2011-02-13	2011-02-13 00:00:00	32020		\N	206078	0	16114001	4059173		0
52388	3103	372328	2011-01-23	2011-01-23 00:00:00	2012-01-10	2012-01-10 00:00:00	32020		\N	206454	0	65363002	372328		0
63196	3732	378001	2011-10-31	2011-10-31 00:00:00	2011-11-30	2011-11-30 00:00:00	32020		\N	247987	0	62106007	378001		0
63318	3739	28060	1971-01-26	1971-01-26 00:00:00	1971-02-03	1971-02-03 00:00:00	32020		\N	248426	0	43878008	28060		0
63464	3748	40481087	1983-10-23	1983-10-23 00:00:00	1983-10-30	1983-10-30 00:00:00	32020		\N	249140	0	444814009	40481087		0
63660	3759	4142905	1974-07-18	1974-07-18 00:00:00	1974-09-16	1974-09-16 00:00:00	32020		\N	249932	0	33737001	4142905		0
42656	2542	28060	2006-12-30	2006-12-30 00:00:00	2007-01-11	2007-01-11 00:00:00	32020		\N	168114	0	43878008	28060		0
53359	3161	260139	2018-03-22	2018-03-22 00:00:00	2018-03-29	2018-03-29 00:00:00	32020		\N	210216	0	10509002	260139		0
53491	3170	4278672	1962-05-07	1962-05-07 00:00:00	1962-07-06	1962-07-06 00:00:00	32020		\N	210713	0	65966004	4278672		0
43157	2570	40481087	1951-06-13	1951-06-13 00:00:00	1951-06-27	1951-06-27 00:00:00	32020		\N	170193	0	444814009	40481087		0
43252	2576	40481087	1990-01-19	1990-01-19 00:00:00	1990-02-09	1990-02-09 00:00:00	32020		\N	170539	0	444814009	40481087		0
53980	3195	372328	1951-10-29	1951-10-29 00:00:00	1952-03-31	1952-03-31 00:00:00	32020		\N	212576	0	65363002	372328		0
43579	2596	40481087	2010-12-23	2010-12-23 00:00:00	2011-01-06	2011-01-06 00:00:00	32020		\N	171808	0	444814009	40481087		0
43821	2610	40481087	1988-06-15	1988-06-15 00:00:00	1988-07-06	1988-07-06 00:00:00	32020		\N	172585	0	444814009	40481087		0
43942	2616	372328	1953-09-17	1953-09-17 00:00:00	1953-11-03	1953-11-03 00:00:00	32020		\N	172945	0	65363002	372328		0
44139	2624	4116491	1990-12-29	1990-12-29 00:00:00	1991-02-12	1991-02-12 00:00:00	32020		\N	173592	0	301011002	4116491		0
44310	2633	40481087	1964-08-30	1964-08-30 00:00:00	1964-09-06	1964-09-06 00:00:00	32020		\N	174219	0	444814009	40481087		0
55002	3254	40481087	1976-09-22	1976-09-22 00:00:00	1976-10-06	1976-10-06 00:00:00	32020		\N	216455	0	444814009	40481087		0
55215	3270	372328	1974-11-30	1974-11-30 00:00:00	1975-03-06	1975-03-06 00:00:00	32020		\N	217280	0	65363002	372328		0
55288	3275	40481087	1994-07-09	1994-07-09 00:00:00	1994-07-16	1994-07-16 00:00:00	32020		\N	217582	0	444814009	40481087		0
44974	2675	4112343	2000-02-07	2000-02-07 00:00:00	2000-02-15	2000-02-15 00:00:00	32020		\N	177271	0	195662009	4112343		0
55643	3294	81151	2010-06-30	2010-06-30 00:00:00	2010-07-28	2010-07-28 00:00:00	32020		\N	218851	0	44465007	81151		0
45224	2690	40481087	1992-08-28	1992-08-28 00:00:00	1992-09-18	1992-09-18 00:00:00	32020		\N	178194	0	444814009	40481087		0
55996	3315	40481087	1975-11-08	1975-11-08 00:00:00	1975-11-22	1975-11-22 00:00:00	32020		\N	220136	0	444814009	40481087		0
45642	2711	40481087	2002-03-11	2002-03-11 00:00:00	2002-03-18	2002-03-18 00:00:00	32020		\N	179777	0	444814009	40481087		0
56300	3337	321042	1983-12-05	1983-12-05 00:00:00	\N	\N	32020		\N	221351	0	410429000	321042		0
45977	2739	4043241	2009-04-22	2009-04-22 00:00:00	\N	\N	32020		\N	181247	0	230265002	4043241		0
56716	3364	40481087	1982-03-04	1982-03-04 00:00:00	1982-03-11	1982-03-11 00:00:00	32020		\N	223138	0	444814009	40481087		0
56785	3367	4112343	1965-12-19	1965-12-19 00:00:00	1965-12-27	1965-12-27 00:00:00	32020		\N	223299	0	195662009	4112343		0
46442	2765	372328	1937-06-05	1937-06-05 00:00:00	1937-10-26	1937-10-26 00:00:00	32020		\N	183003	0	65363002	372328		0
46560	2771	260139	1973-12-22	1973-12-22 00:00:00	1973-12-29	1973-12-29 00:00:00	32020		\N	183529	0	10509002	260139		0
46787	2782	4113008	1956-06-03	1956-06-03 00:00:00	1956-06-17	1956-06-17 00:00:00	32020		\N	184406	0	284549007	4113008		0
46956	2792	80180	2001-12-10	2001-12-10 00:00:00	\N	\N	32020		\N	185056	0	396275006	80180		0
57623	3418	378419	2019-03-03	2019-03-03 00:00:00	\N	\N	32020		\N	226740	0	26929004	378419		0
57785	3428	40481087	1975-02-19	1975-02-19 00:00:00	1975-03-12	1975-03-12 00:00:00	32020		\N	227266	0	444814009	40481087		0
57939	3436	81151	1970-03-05	1970-03-05 00:00:00	1970-03-26	1970-03-26 00:00:00	32020		\N	227853	0	44465007	81151		0
47633	2832	4112343	2014-03-07	2014-03-07 00:00:00	2014-03-14	2014-03-14 00:00:00	32020		\N	187937	0	195662009	4112343		0
47718	2835	40481087	1963-06-05	1963-06-05 00:00:00	1963-06-12	1963-06-12 00:00:00	32020		\N	188238	0	444814009	40481087		0
47911	2844	260139	1953-02-07	1953-02-07 00:00:00	1953-02-21	1953-02-21 00:00:00	32020		\N	188810	0	10509002	260139		0
58688	3481	80180	2014-06-05	2014-06-05 00:00:00	\N	\N	32020		\N	230845	0	396275006	80180		0
48213	2859	4027663	1969-06-08	1969-06-08 00:00:00	\N	\N	32020		\N	189995	0	13200003	4027663		0
48370	2865	4112343	2007-08-28	2007-08-28 00:00:00	2007-09-07	2007-09-07 00:00:00	32020		\N	190602	0	195662009	4112343		0
59176	3510	4146173	1990-06-20	1990-06-20 00:00:00	1990-07-20	1990-07-20 00:00:00	32020		\N	232801	0	307731004	4146173		0
59342	3518	4310024	1992-04-21	1992-04-21 00:00:00	\N	\N	32020		\N	233560	0	424802006	4310024		0
48926	2896	260139	1985-06-29	1985-06-29 00:00:00	1985-07-06	1985-07-06 00:00:00	32020		\N	192835	0	10509002	260139		0
59627	3533	30753	1999-05-14	1999-05-14 00:00:00	\N	\N	32020		\N	234669	0	16761005	30753		0
59812	3543	80180	1993-10-24	1993-10-24 00:00:00	\N	\N	32020		\N	235373	0	396275006	80180		0
59960	3553	260139	1948-05-01	1948-05-01 00:00:00	1948-05-15	1948-05-15 00:00:00	32020		\N	235871	0	10509002	260139		0
60105	3560	80180	1994-08-14	1994-08-14 00:00:00	\N	\N	32020		\N	236406	0	396275006	80180		0
60275	3567	40481087	2005-11-19	2005-11-19 00:00:00	2005-12-03	2005-12-03 00:00:00	32020		\N	237041	0	444814009	40481087		0
49862	2947	4156265	1991-03-28	1991-03-28 00:00:00	1991-04-19	1991-04-19 00:00:00	32020		\N	196699	0	370247008	4156265		0
50126	2960	4112343	1976-06-20	1976-06-20 00:00:00	1976-06-29	1976-06-29 00:00:00	32020		\N	197613	0	195662009	4112343		0
50219	2966	4294548	2014-11-05	2014-11-05 00:00:00	2015-07-22	2015-07-22 00:00:00	32020		\N	198151	0	75498004	4294548		0
60969	3609	40481087	2015-10-12	2015-10-12 00:00:00	2015-10-19	2015-10-19 00:00:00	32020		\N	239770	0	444814009	40481087		0
50601	2992	40481087	1969-03-20	1969-03-20 00:00:00	1969-04-10	1969-04-10 00:00:00	32020		\N	199686	0	444814009	40481087		0
50770	3002	4112343	2014-01-22	2014-01-22 00:00:00	2014-02-03	2014-02-03 00:00:00	32020		\N	200336	0	195662009	4112343		0
50929	3013	40481087	1982-02-02	1982-02-02 00:00:00	1982-02-23	1982-02-23 00:00:00	32020		\N	200940	0	444814009	40481087		0
51028	3020	372328	1957-06-01	1957-06-01 00:00:00	1957-09-11	1957-09-11 00:00:00	32020		\N	201395	0	65363002	372328		0
61832	3651	4112343	2014-01-31	2014-01-31 00:00:00	2014-02-10	2014-02-10 00:00:00	32020		\N	243070	0	195662009	4112343		0
61954	3658	260139	1983-02-08	1983-02-08 00:00:00	1983-02-15	1983-02-15 00:00:00	32020		\N	243479	0	10509002	260139		0
51584	3060	381316	2003-01-25	2003-01-25 00:00:00	\N	\N	32020		\N	203629	0	230690007	381316		0
62310	3680	4084167	1979-11-29	1979-11-29 00:00:00	1979-11-29	1979-11-29 00:00:00	32020		\N	244780	0	241929008	4084167		0
62422	3689	260139	1963-07-23	1963-07-23 00:00:00	1963-08-06	1963-08-06 00:00:00	32020		\N	245228	0	10509002	260139		0
52090	3084	321042	2015-10-21	2015-10-21 00:00:00	\N	\N	32020		\N	205356	0	410429000	321042		0
62756	3707	81893	2006-07-16	2006-07-16 00:00:00	\N	\N	32020		\N	246422	0	64766004	81893		0
52389	3103	40481087	2005-10-27	2005-10-27 00:00:00	2005-11-16	2005-11-16 00:00:00	32020		\N	206403	0	444814009	40481087		0
63197	3732	4278672	1958-04-02	1958-04-02 00:00:00	1958-07-01	1958-07-01 00:00:00	32020		\N	247983	0	65966004	4278672		0
63319	3739	4112343	1983-09-07	1983-09-07 00:00:00	1983-09-17	1983-09-17 00:00:00	32020		\N	248445	0	195662009	4112343		0
63465	3748	4218389	2012-11-15	2012-11-15 00:00:00	2012-12-13	2012-12-13 00:00:00	32020		\N	249096	0	39848009	4218389		0
63661	3759	4152936	1987-03-26	1987-03-26 00:00:00	1987-04-16	1987-04-16 00:00:00	32020		\N	249879	0	283385000	4152936		0
42657	2542	4112343	2017-04-22	2017-04-22 00:00:00	2017-05-01	2017-05-01 00:00:00	32020		\N	168115	0	195662009	4112343		0
53360	3161	4112343	1953-04-06	1953-04-06 00:00:00	1953-04-15	1953-04-15 00:00:00	32020		\N	210242	0	195662009	4112343		0
53492	3170	372328	1954-09-14	1954-09-14 00:00:00	1954-11-26	1954-11-26 00:00:00	32020		\N	210708	0	65363002	372328		0
43158	2570	40481087	1939-09-26	1939-09-26 00:00:00	1939-10-17	1939-10-17 00:00:00	32020		\N	170162	0	444814009	40481087		0
43253	2576	4152936	2015-04-24	2015-04-24 00:00:00	2015-05-15	2015-05-15 00:00:00	32020		\N	170549	0	283385000	4152936		0
53981	3195	80180	1984-10-09	1984-10-09 00:00:00	\N	\N	32020		\N	212554	0	396275006	80180		0
43580	2596	378001	2004-07-02	2004-07-02 00:00:00	2004-08-31	2004-08-31 00:00:00	32020		\N	171764	0	62106007	378001		0
43822	2610	4112343	1964-05-01	1964-05-01 00:00:00	1964-05-12	1964-05-12 00:00:00	32020		\N	172537	0	195662009	4112343		0
43943	2616	372328	1955-08-01	1955-08-01 00:00:00	1955-11-01	1955-11-01 00:00:00	32020		\N	172981	0	65363002	372328		0
44140	2624	40481087	2017-07-01	2017-07-01 00:00:00	2017-07-22	2017-07-22 00:00:00	32020		\N	173595	0	444814009	40481087		0
44311	2633	40481087	1996-01-05	1996-01-05 00:00:00	1996-01-19	1996-01-19 00:00:00	32020		\N	174220	0	444814009	40481087		0
55003	3254	4112343	1964-02-01	1964-02-01 00:00:00	1964-02-10	1964-02-10 00:00:00	32020		\N	216453	0	195662009	4112343		0
55216	3270	28060	1983-05-16	1983-05-16 00:00:00	1983-05-26	1983-05-26 00:00:00	32020		\N	217306	0	43878008	28060		0
55289	3275	40481087	1960-06-13	1960-06-13 00:00:00	1960-07-04	1960-07-04 00:00:00	32020		\N	217626	0	444814009	40481087		0
44975	2675	40481087	1974-08-12	1974-08-12 00:00:00	1974-08-26	1974-08-26 00:00:00	32020		\N	177266	0	444814009	40481087		0
55644	3294	40481087	2006-10-18	2006-10-18 00:00:00	2006-10-25	2006-10-25 00:00:00	32020		\N	218859	0	444814009	40481087		0
45225	2690	40481087	1970-06-17	1970-06-17 00:00:00	1970-07-08	1970-07-08 00:00:00	32020		\N	178229	0	444814009	40481087		0
55997	3315	81151	1968-06-28	1968-06-28 00:00:00	1968-08-02	1968-08-02 00:00:00	32020		\N	220129	0	44465007	81151		0
45643	2711	133834	1950-12-30	1950-12-30 00:00:00	\N	\N	32020		\N	179718	0	24079001	133834		0
56302	3337	40481087	2007-11-17	2007-11-17 00:00:00	2007-12-01	2007-12-01 00:00:00	32020		\N	221370	0	444814009	40481087		0
45978	2739	40481087	1975-10-14	1975-10-14 00:00:00	1975-11-04	1975-11-04 00:00:00	32020		\N	181211	0	444814009	40481087		0
56717	3364	4285898	2008-07-06	2008-07-06 00:00:00	\N	\N	32020		\N	223048	0	68496003	4285898		0
56786	3367	81151	1997-07-06	1997-07-06 00:00:00	1997-07-20	1997-07-20 00:00:00	32020		\N	223282	0	44465007	81151		0
46443	2765	4112343	2013-08-17	2013-08-17 00:00:00	2013-08-28	2013-08-28 00:00:00	32020		\N	182846	0	195662009	4112343		0
46561	2771	4112343	1939-02-25	1939-02-25 00:00:00	1939-03-07	1939-03-07 00:00:00	32020		\N	183427	0	195662009	4112343		0
46788	2782	4112343	1995-04-01	1995-04-01 00:00:00	1995-04-14	1995-04-14 00:00:00	32020		\N	184349	0	195662009	4112343		0
46957	2792	28060	1968-12-28	1968-12-28 00:00:00	1969-01-04	1969-01-04 00:00:00	32020		\N	184990	0	43878008	28060		0
57624	3418	28060	1980-12-17	1980-12-17 00:00:00	1980-12-30	1980-12-30 00:00:00	32020		\N	226715	0	43878008	28060		0
57786	3428	4043241	2017-05-31	2017-05-31 00:00:00	\N	\N	32020		\N	227299	0	230265002	4043241		0
57940	3436	260139	1971-07-30	1971-07-30 00:00:00	1971-08-13	1971-08-13 00:00:00	32020		\N	227877	0	10509002	260139		0
47634	2832	40481087	1986-11-30	1986-11-30 00:00:00	1986-12-21	1986-12-21 00:00:00	32020		\N	187974	0	444814009	40481087		0
47719	2835	4149245	1989-10-21	1989-10-21 00:00:00	1989-11-27	1989-11-27 00:00:00	32020		\N	188344	0	30832001	4149245		0
47912	2844	4112343	1995-08-05	1995-08-05 00:00:00	1995-08-15	1995-08-15 00:00:00	32020		\N	188868	0	195662009	4112343		0
58689	3481	4156265	1981-04-09	1981-04-09 00:00:00	1981-04-30	1981-04-30 00:00:00	32020		\N	230872	0	370247008	4156265		0
48214	2859	4112343	1948-03-19	1948-03-19 00:00:00	1948-03-26	1948-03-26 00:00:00	32020		\N	190057	0	195662009	4112343		0
48371	2865	372328	1971-02-26	1971-02-26 00:00:00	1971-07-05	1971-07-05 00:00:00	32020		\N	190580	0	65363002	372328		0
59177	3510	4310024	1970-01-23	1970-01-23 00:00:00	\N	\N	32020		\N	232889	0	424802006	4310024		0
59343	3518	28060	1987-05-16	1987-05-16 00:00:00	1987-05-26	1987-05-26 00:00:00	32020		\N	233556	0	43878008	28060		0
48927	2896	40486433	1974-03-29	1974-03-29 00:00:00	1988-03-27	1988-03-27 00:00:00	32020		\N	192763	0	446096008	40486433		0
59628	3533	81893	1999-04-14	1999-04-14 00:00:00	\N	\N	32020		\N	234669	0	64766004	81893		0
59813	3543	40481087	1993-10-07	1993-10-07 00:00:00	1993-10-21	1993-10-21 00:00:00	32020		\N	235373	0	444814009	40481087		0
59961	3553	439777	1982-10-26	1982-10-26 00:00:00	\N	\N	32020		\N	235891	0	271737000	439777		0
60106	3560	4112343	1999-06-11	1999-06-11 00:00:00	1999-06-21	1999-06-21 00:00:00	32020		\N	236385	0	195662009	4112343		0
60276	3567	260139	2012-03-03	2012-03-03 00:00:00	2012-03-17	2012-03-17 00:00:00	32020		\N	237052	0	10509002	260139		0
49863	2947	80180	2018-09-28	2018-09-28 00:00:00	\N	\N	32020		\N	196678	0	396275006	80180		0
50127	2961	4112343	1978-04-25	1978-04-25 00:00:00	1978-05-06	1978-05-06 00:00:00	32020		\N	197748	0	195662009	4112343		0
50220	2966	40481087	2007-10-24	2007-10-24 00:00:00	2007-11-07	2007-11-07 00:00:00	32020		\N	198100	0	444814009	40481087		0
60970	3609	440086	1983-11-27	1983-11-27 00:00:00	1992-12-04	1992-12-04 00:00:00	32020		\N	239744	0	192127007	440086		0
50602	2992	81151	1971-10-30	1971-10-30 00:00:00	1971-11-20	1971-11-20 00:00:00	32020		\N	199762	0	44465007	81151		0
50771	3002	40481087	2007-05-03	2007-05-03 00:00:00	2007-05-24	2007-05-24 00:00:00	32020		\N	200338	0	444814009	40481087		0
50930	3013	4112343	2012-04-18	2012-04-18 00:00:00	2012-04-30	2012-04-30 00:00:00	32020		\N	200895	0	195662009	4112343		0
51029	3022	4278672	1985-04-09	1985-04-09 00:00:00	1985-06-08	1985-06-08 00:00:00	32020		\N	201467	0	65966004	4278672		0
61833	3651	4112343	2005-06-06	2005-06-06 00:00:00	2005-06-15	2005-06-15 00:00:00	32020		\N	243049	0	195662009	4112343		0
61955	3658	4294548	1991-10-09	1991-10-09 00:00:00	1992-01-01	1992-01-01 00:00:00	32020		\N	243436	0	75498004	4294548		0
51585	3060	81151	2002-09-13	2002-09-13 00:00:00	2002-09-27	2002-09-27 00:00:00	32020		\N	203629	0	44465007	81151		0
62311	3680	40481087	2006-12-13	2006-12-13 00:00:00	2006-12-20	2006-12-20 00:00:00	32020		\N	244774	0	444814009	40481087		0
62423	3689	40481087	2007-08-02	2007-08-02 00:00:00	2007-08-23	2007-08-23 00:00:00	32020		\N	245212	0	444814009	40481087		0
52092	3084	4112343	2019-06-14	2019-06-14 00:00:00	2019-06-21	2019-06-21 00:00:00	32020		\N	205386	0	195662009	4112343		0
62757	3707	80180	2008-07-05	2008-07-05 00:00:00	\N	\N	32020		\N	246422	0	396275006	80180		0
52390	3103	40481087	2013-01-13	2013-01-13 00:00:00	2013-01-27	2013-01-27 00:00:00	32020		\N	206439	0	444814009	40481087		0
63198	3732	81151	1997-12-17	1997-12-17 00:00:00	1998-01-14	1998-01-14 00:00:00	32020		\N	247985	0	44465007	81151		0
63340	3742	28060	1995-04-02	1995-04-02 00:00:00	1995-04-14	1995-04-14 00:00:00	32020		\N	248671	0	43878008	28060		0
63466	3748	372328	1983-02-20	1983-02-20 00:00:00	1984-02-21	1984-02-21 00:00:00	32020		\N	249101	0	65363002	372328		0
63662	3759	257012	1971-10-05	1971-10-05 00:00:00	\N	\N	32020		\N	249934	0	40055000	257012		0
42658	2542	260139	2018-12-30	2018-12-30 00:00:00	2019-01-06	2019-01-06 00:00:00	32020		\N	168116	0	10509002	260139		0
53361	3161	40481087	1953-03-14	1953-03-14 00:00:00	1953-03-28	1953-03-28 00:00:00	32020		\N	210241	0	444814009	40481087		0
53493	3170	260139	1987-10-01	1987-10-01 00:00:00	1987-10-15	1987-10-15 00:00:00	32020		\N	210745	0	10509002	260139		0
43159	2570	4112343	1976-11-20	1976-11-20 00:00:00	1976-12-01	1976-12-01 00:00:00	32020		\N	170179	0	195662009	4112343		0
43254	2576	40481087	2009-02-06	2009-02-06 00:00:00	2009-02-20	2009-02-20 00:00:00	32020		\N	170530	0	444814009	40481087		0
53982	3195	40481087	1968-06-17	1968-06-17 00:00:00	1968-06-24	1968-06-24 00:00:00	32020		\N	212516	0	444814009	40481087		0
43581	2596	4218389	1969-08-14	1969-08-14 00:00:00	1969-09-04	1969-09-04 00:00:00	32020		\N	171816	0	39848009	4218389		0
43823	2610	4112343	2013-11-11	2013-11-11 00:00:00	2013-11-24	2013-11-24 00:00:00	32020		\N	172586	0	195662009	4112343		0
43944	2616	40481087	1982-10-17	1982-10-17 00:00:00	1982-11-07	1982-11-07 00:00:00	32020		\N	173012	0	444814009	40481087		0
44141	2624	260139	2007-03-11	2007-03-11 00:00:00	2007-03-18	2007-03-18 00:00:00	32020		\N	173551	0	10509002	260139		0
44312	2633	4278672	2018-02-19	2018-02-19 00:00:00	2018-05-20	2018-05-20 00:00:00	32020		\N	174229	0	65966004	4278672		0
55022	3258	4112343	1998-07-23	1998-07-23 00:00:00	1998-08-04	1998-08-04 00:00:00	32020		\N	216581	0	195662009	4112343		0
55217	3270	80180	2005-10-03	2005-10-03 00:00:00	\N	\N	32020		\N	217307	0	396275006	80180		0
55290	3275	260139	1996-10-21	1996-10-21 00:00:00	1996-11-04	1996-11-04 00:00:00	32020		\N	217610	0	10509002	260139		0
44984	2677	4156265	2014-02-24	2014-02-24 00:00:00	2014-03-18	2014-03-18 00:00:00	32020		\N	177361	0	370247008	4156265		0
45226	2690	40481087	1953-08-26	1953-08-26 00:00:00	1953-09-09	1953-09-09 00:00:00	32020		\N	178237	0	444814009	40481087		0
55998	3315	4109685	1983-03-08	1983-03-08 00:00:00	1983-03-22	1983-03-22 00:00:00	32020		\N	220131	0	284551006	4109685		0
45644	2711	40481087	1975-06-21	1975-06-21 00:00:00	1975-06-28	1975-06-28 00:00:00	32020		\N	179746	0	444814009	40481087		0
56303	3337	260139	1982-07-03	1982-07-03 00:00:00	1982-07-17	1982-07-17 00:00:00	32020		\N	221415	0	10509002	260139		0
45979	2739	4112343	1954-12-09	1954-12-09 00:00:00	1954-12-21	1954-12-21 00:00:00	32020		\N	181269	0	195662009	4112343		0
56718	3364	80180	2009-02-01	2009-02-01 00:00:00	\N	\N	32020		\N	223048	0	396275006	80180		0
56787	3367	375671	2007-09-26	2007-09-26 00:00:00	2007-11-25	2007-11-25 00:00:00	32020		\N	223283	0	62564004	375671		0
46444	2765	381316	2005-01-11	2005-01-11 00:00:00	\N	\N	32020		\N	182832	0	230690007	381316		0
46562	2771	4112343	1917-12-06	1917-12-06 00:00:00	1917-12-16	1917-12-16 00:00:00	32020		\N	183416	0	195662009	4112343		0
46789	2782	4112343	1983-03-26	1983-03-26 00:00:00	1983-04-03	1983-04-03 00:00:00	32020		\N	184346	0	195662009	4112343		0
57437	3409	4112343	2017-03-13	2017-03-13 00:00:00	2017-03-20	2017-03-20 00:00:00	32020		\N	226065	0	195662009	4112343		0
57625	3418	80180	1977-07-30	1977-07-30 00:00:00	\N	\N	32020		\N	226787	0	396275006	80180		0
57787	3428	40481087	2019-03-16	2019-03-16 00:00:00	2019-04-06	2019-04-06 00:00:00	32020		\N	227290	0	444814009	40481087		0
57941	3436	28060	1987-01-23	1987-01-23 00:00:00	1987-02-01	1987-02-01 00:00:00	32020		\N	227863	0	43878008	28060		0
47635	2832	4146173	1990-10-31	1990-10-31 00:00:00	1990-12-30	1990-12-30 00:00:00	32020		\N	187895	0	307731004	4146173		0
47720	2835	4112343	2006-12-06	2006-12-06 00:00:00	2006-12-15	2006-12-15 00:00:00	32020		\N	188322	0	195662009	4112343		0
47913	2844	260139	1986-09-07	1986-09-07 00:00:00	1986-09-14	1986-09-14 00:00:00	32020		\N	188805	0	10509002	260139		0
58690	3481	81151	1986-03-05	1986-03-05 00:00:00	1986-04-09	1986-04-09 00:00:00	32020		\N	230873	0	44465007	81151		0
48215	2859	40481087	1995-09-10	1995-09-10 00:00:00	1995-09-17	1995-09-17 00:00:00	32020		\N	190065	0	444814009	40481087		0
48372	2865	260139	2002-07-31	2002-07-31 00:00:00	2002-08-07	2002-08-07 00:00:00	32020		\N	190600	0	10509002	260139		0
59178	3510	4059173	1951-02-12	1951-02-12 00:00:00	1951-04-13	1951-04-13 00:00:00	32020		\N	232796	0	16114001	4059173		0
59344	3518	40481087	1961-10-16	1961-10-16 00:00:00	1961-11-06	1961-11-06 00:00:00	32020		\N	233592	0	444814009	40481087		0
48928	2896	4112343	1984-01-05	1984-01-05 00:00:00	1984-01-15	1984-01-15 00:00:00	32020		\N	192764	0	195662009	4112343		0
59629	3533	40481087	2007-01-24	2007-01-24 00:00:00	2007-02-07	2007-02-07 00:00:00	32020		\N	234658	0	444814009	40481087		0
59814	3543	317576	1992-09-29	1992-09-29 00:00:00	\N	\N	32020		\N	235385	0	53741008	317576		0
59962	3553	81151	1934-07-20	1934-07-20 00:00:00	1934-08-24	1934-08-24 00:00:00	32020		\N	235863	0	44465007	81151		0
60107	3560	260139	1976-07-11	1976-07-11 00:00:00	1976-07-25	1976-07-25 00:00:00	32020		\N	236356	0	10509002	260139		0
60277	3567	4112343	2017-04-06	2017-04-06 00:00:00	2017-04-17	2017-04-17 00:00:00	32020		\N	237053	0	195662009	4112343		0
49864	2947	4266809	2018-09-28	2018-09-28 00:00:00	\N	\N	32020		\N	196678	0	397881000	4266809		0
50128	2961	80180	2007-11-01	2007-11-01 00:00:00	\N	\N	32020		\N	197726	0	396275006	80180		0
50221	2966	80180	2001-02-19	2001-02-19 00:00:00	\N	\N	32020		\N	198119	0	396275006	80180		0
60971	3609	4296205	1986-07-11	1986-07-11 00:00:00	1986-07-25	1986-07-25 00:00:00	32020		\N	239786	0	403191005	4296205		0
50603	2992	372328	1958-03-12	1958-03-12 00:00:00	1958-06-27	1958-06-27 00:00:00	32020		\N	199754	0	65363002	372328		0
50772	3002	372328	1977-03-01	1977-03-01 00:00:00	1977-06-07	1977-06-07 00:00:00	32020		\N	200350	0	65363002	372328		0
50931	3013	372328	1962-03-13	1962-03-13 00:00:00	1962-06-19	1962-06-19 00:00:00	32020		\N	200955	0	65363002	372328		0
51030	3022	4296204	1975-04-20	1975-04-20 00:00:00	1975-05-25	1975-05-25 00:00:00	32020		\N	201466	0	403190006	4296204		0
61834	3651	40481087	1974-09-20	1974-09-20 00:00:00	1974-10-11	1974-10-11 00:00:00	32020		\N	243066	0	444814009	40481087		0
61956	3658	40481087	2019-01-09	2019-01-09 00:00:00	2019-01-23	2019-01-23 00:00:00	32020		\N	243442	0	444814009	40481087		0
51586	3060	4278672	1998-06-06	1998-06-06 00:00:00	1998-09-04	1998-09-04 00:00:00	32020		\N	203628	0	65966004	4278672		0
62312	3680	80180	2018-05-13	2018-05-13 00:00:00	\N	\N	32020		\N	244768	0	396275006	80180		0
62424	3689	260139	1959-09-10	1959-09-10 00:00:00	1959-09-17	1959-09-17 00:00:00	32020		\N	245209	0	10509002	260139		0
52093	3084	372328	1978-04-22	1978-04-22 00:00:00	1978-08-02	1978-08-02 00:00:00	32020		\N	205401	0	65363002	372328		0
62758	3707	4285898	2008-02-06	2008-02-06 00:00:00	\N	\N	32020		\N	246422	0	68496003	4285898		0
52391	3103	4113008	1983-03-15	1983-03-15 00:00:00	1983-04-05	1983-04-05 00:00:00	32020		\N	206455	0	284549007	4113008		0
63199	3732	4112343	1980-01-02	1980-01-02 00:00:00	1980-01-12	1980-01-12 00:00:00	32020		\N	247979	0	195662009	4112343		0
63341	3742	4027663	2001-08-06	2001-08-06 00:00:00	\N	\N	32020		\N	248664	0	13200003	4027663		0
63467	3748	260139	2008-08-09	2008-08-09 00:00:00	2008-08-16	2008-08-16 00:00:00	32020		\N	249145	0	10509002	260139		0
63663	3759	260139	1977-11-14	1977-11-14 00:00:00	1977-11-28	1977-11-28 00:00:00	32020		\N	249947	0	10509002	260139		0
42659	2542	40481087	1969-03-21	1969-03-21 00:00:00	1969-04-11	1969-04-11 00:00:00	32020		\N	168075	0	444814009	40481087		0
53362	3161	4109685	1970-07-08	1970-07-08 00:00:00	1970-07-29	1970-07-29 00:00:00	32020		\N	210203	0	284551006	4109685		0
53494	3170	4112343	1960-01-05	1960-01-05 00:00:00	1960-01-15	1960-01-15 00:00:00	32020		\N	210722	0	195662009	4112343		0
43160	2570	40481087	2005-10-05	2005-10-05 00:00:00	2005-10-26	2005-10-26 00:00:00	32020		\N	170274	0	444814009	40481087		0
43255	2576	260139	2002-12-09	2002-12-09 00:00:00	2002-12-16	2002-12-16 00:00:00	32020		\N	170540	0	10509002	260139		0
53983	3196	40481087	1980-02-11	1980-02-11 00:00:00	1980-02-25	1980-02-25 00:00:00	32020		\N	212626	0	444814009	40481087		0
43582	2596	372328	1969-05-31	1969-05-31 00:00:00	1969-10-04	1969-10-04 00:00:00	32020		\N	171756	0	65363002	372328		0
43824	2610	4278672	2000-09-02	2000-09-02 00:00:00	2000-11-30	2000-11-30 00:00:00	32020		\N	172596	0	65966004	4278672		0
43945	2616	80502	2012-01-10	2012-01-10 00:00:00	\N	\N	32020		\N	173007	0	64859006	80502		0
44142	2624	40481087	1976-01-28	1976-01-28 00:00:00	1976-02-04	1976-02-04 00:00:00	32020		\N	173587	0	444814009	40481087		0
44313	2633	40481087	1954-10-18	1954-10-18 00:00:00	1954-11-01	1954-11-01 00:00:00	32020		\N	174199	0	444814009	40481087		0
55023	3258	81151	1990-09-14	1990-09-14 00:00:00	1990-09-28	1990-09-28 00:00:00	32020		\N	216548	0	44465007	81151		0
55218	3270	81893	2004-04-11	2004-04-11 00:00:00	\N	\N	32020		\N	217349	0	64766004	81893		0
55291	3275	260139	2002-06-01	2002-06-01 00:00:00	2002-06-15	2002-06-15 00:00:00	32020		\N	217631	0	10509002	260139		0
44985	2677	28060	1981-12-08	1981-12-08 00:00:00	1981-12-17	1981-12-17 00:00:00	32020		\N	177343	0	43878008	28060		0
55646	3294	40481087	1975-10-02	1975-10-02 00:00:00	1975-10-23	1975-10-23 00:00:00	32020		\N	218807	0	444814009	40481087		0
45227	2690	372328	1951-07-30	1951-07-30 00:00:00	1951-09-06	1951-09-06 00:00:00	32020		\N	178196	0	65363002	372328		0
55999	3315	4112343	1981-05-05	1981-05-05 00:00:00	1981-05-12	1981-05-12 00:00:00	32020		\N	220137	0	195662009	4112343		0
45645	2711	40481087	1992-02-20	1992-02-20 00:00:00	1992-03-12	1992-03-12 00:00:00	32020		\N	179755	0	444814009	40481087		0
56304	3337	260139	1991-08-29	1991-08-29 00:00:00	1991-09-12	1991-09-12 00:00:00	32020		\N	221359	0	10509002	260139		0
45980	2739	260139	1969-07-24	1969-07-24 00:00:00	1969-07-31	1969-07-31 00:00:00	32020		\N	181187	0	10509002	260139		0
56719	3364	40481087	2017-03-09	2017-03-09 00:00:00	2017-03-16	2017-03-16 00:00:00	32020		\N	223024	0	444814009	40481087		0
56788	3367	4155034	2010-10-10	2010-10-10 00:00:00	2010-10-24	2010-10-24 00:00:00	32020		\N	223284	0	283371005	4155034		0
46445	2765	260139	1978-07-18	1978-07-18 00:00:00	1978-08-01	1978-08-01 00:00:00	32020		\N	182878	0	10509002	260139		0
46563	2771	40481087	2018-09-06	2018-09-06 00:00:00	2018-09-13	2018-09-13 00:00:00	32020		\N	183489	0	444814009	40481087		0
46790	2782	4112343	1957-08-10	1957-08-10 00:00:00	1957-08-22	1957-08-22 00:00:00	32020		\N	184420	0	195662009	4112343		0
57438	3409	4112343	2017-05-21	2017-05-21 00:00:00	2017-06-02	2017-06-02 00:00:00	32020		\N	226059	0	195662009	4112343		0
57626	3418	4266809	1977-07-30	1977-07-30 00:00:00	\N	\N	32020		\N	226787	0	397881000	4266809		0
57788	3428	260139	2003-10-25	2003-10-25 00:00:00	2003-11-08	2003-11-08 00:00:00	32020		\N	227250	0	10509002	260139		0
57942	3436	40481087	2015-10-08	2015-10-08 00:00:00	2015-10-22	2015-10-22 00:00:00	32020		\N	227865	0	444814009	40481087		0
47636	2832	80180	2000-06-25	2000-06-25 00:00:00	\N	\N	32020		\N	187954	0	396275006	80180		0
47721	2835	81151	1956-07-15	1956-07-15 00:00:00	1956-08-19	1956-08-19 00:00:00	32020		\N	188340	0	44465007	81151		0
47914	2844	4112343	2000-10-20	2000-10-20 00:00:00	2000-10-28	2000-10-28 00:00:00	32020		\N	188869	0	195662009	4112343		0
58691	3481	4155034	2007-07-02	2007-07-02 00:00:00	2007-07-16	2007-07-16 00:00:00	32020		\N	230887	0	283371005	4155034		0
48216	2859	28060	2005-04-08	2005-04-08 00:00:00	2005-04-17	2005-04-17 00:00:00	32020		\N	189981	0	43878008	28060		0
48373	2865	80180	2003-03-11	2003-03-11 00:00:00	\N	\N	32020		\N	190600	0	396275006	80180		0
59179	3510	40481087	1973-04-18	1973-04-18 00:00:00	1973-04-25	1973-04-25 00:00:00	32020		\N	232904	0	444814009	40481087		0
59345	3518	40481087	1977-12-06	1977-12-06 00:00:00	1977-12-20	1977-12-20 00:00:00	32020		\N	233554	0	444814009	40481087		0
48929	2896	40481087	1974-08-31	1974-08-31 00:00:00	1974-09-14	1974-09-14 00:00:00	32020		\N	192834	0	444814009	40481087		0
59630	3533	372328	1963-04-23	1963-04-23 00:00:00	1963-05-07	1963-05-07 00:00:00	32020		\N	234663	0	65363002	372328		0
59815	3543	40481087	1959-01-18	1959-01-18 00:00:00	1959-02-01	1959-02-01 00:00:00	32020		\N	235346	0	444814009	40481087		0
59963	3553	4112343	1959-10-01	1959-10-01 00:00:00	1959-10-13	1959-10-13 00:00:00	32020		\N	235905	0	195662009	4112343		0
60108	3560	40481087	1999-07-24	1999-07-24 00:00:00	1999-08-14	1999-08-14 00:00:00	32020		\N	236371	0	444814009	40481087		0
60278	3567	4112343	2010-03-01	2010-03-01 00:00:00	2010-03-10	2010-03-10 00:00:00	32020		\N	237051	0	195662009	4112343		0
49865	2947	260139	1987-08-13	1987-08-13 00:00:00	1987-08-20	1987-08-20 00:00:00	32020		\N	196679	0	10509002	260139		0
50129	2961	257012	1972-02-26	1972-02-26 00:00:00	\N	\N	32020		\N	197749	0	40055000	257012		0
50222	2966	40481087	2018-11-02	2018-11-02 00:00:00	2018-11-23	2018-11-23 00:00:00	32020		\N	198053	0	444814009	40481087		0
60972	3609	4112343	1998-01-22	1998-01-22 00:00:00	1998-01-31	1998-01-31 00:00:00	32020		\N	239747	0	195662009	4112343		0
50604	2992	40481087	1994-02-15	1994-02-15 00:00:00	1994-02-22	1994-02-22 00:00:00	32020		\N	199742	0	444814009	40481087		0
50773	3002	40481087	2008-02-25	2008-02-25 00:00:00	2008-03-10	2008-03-10 00:00:00	32020		\N	200379	0	444814009	40481087		0
50932	3013	4142905	2014-05-05	2014-05-05 00:00:00	2014-08-03	2014-08-03 00:00:00	32020		\N	200967	0	33737001	4142905		0
51031	3022	4283893	1982-02-20	1982-02-20 00:00:00	1982-04-10	1982-04-10 00:00:00	32020		\N	201492	0	36971009	4283893		0
61835	3651	4112343	1996-08-06	1996-08-06 00:00:00	1996-08-19	1996-08-19 00:00:00	32020		\N	243047	0	195662009	4112343		0
61957	3658	375671	1965-07-11	1965-07-11 00:00:00	1965-09-09	1965-09-09 00:00:00	32020		\N	243494	0	62564004	375671		0
51587	3060	40481087	1967-01-23	1967-01-23 00:00:00	1967-02-06	1967-02-06 00:00:00	32020		\N	203608	0	444814009	40481087		0
62313	3680	40481087	1986-09-30	1986-09-30 00:00:00	1986-10-21	1986-10-21 00:00:00	32020		\N	244677	0	444814009	40481087		0
62425	3689	4112343	1971-09-23	1971-09-23 00:00:00	1971-10-01	1971-10-01 00:00:00	32020		\N	245216	0	195662009	4112343		0
52094	3084	4035415	2017-04-18	2017-04-18 00:00:00	2017-05-18	2017-05-18 00:00:00	32020		\N	205357	0	239720000	4035415		0
62759	3707	4310024	2006-01-17	2006-01-17 00:00:00	\N	\N	32020		\N	246422	0	424802006	4310024		0
52392	3103	260139	1984-10-08	1984-10-08 00:00:00	1984-10-22	1984-10-22 00:00:00	32020		\N	206446	0	10509002	260139		0
63200	3732	4027663	1982-07-10	1982-07-10 00:00:00	\N	\N	32020		\N	247979	0	13200003	4027663		0
63342	3742	4112343	2017-12-18	2017-12-18 00:00:00	2017-12-30	2017-12-30 00:00:00	32020		\N	248641	0	195662009	4112343		0
63468	3748	4048695	1984-12-11	1984-12-11 00:00:00	1985-01-11	1985-01-11 00:00:00	32020		\N	249094	0	15724005	4048695		0
63664	3759	4294548	1971-09-07	1971-09-07 00:00:00	1972-04-04	1972-04-04 00:00:00	32020		\N	249965	0	75498004	4294548		0
42660	2542	4134304	1980-03-02	1980-03-02 00:00:00	1980-04-01	1980-04-01 00:00:00	32020		\N	168091	0	263102004	4134304		0
53363	3161	372328	1953-09-19	1953-09-19 00:00:00	1953-10-21	1953-10-21 00:00:00	32020		\N	210221	0	65363002	372328		0
53495	3170	40481087	1953-06-30	1953-06-30 00:00:00	1953-07-21	1953-07-21 00:00:00	32020		\N	210728	0	444814009	40481087		0
53619	3177	4059173	1993-10-04	1993-10-04 00:00:00	1993-11-03	1993-11-03 00:00:00	32020		\N	211234	0	16114001	4059173		0
43256	2576	4112343	1982-04-11	1982-04-11 00:00:00	1982-04-24	1982-04-24 00:00:00	32020		\N	170526	0	195662009	4112343		0
53984	3196	40481087	2018-08-01	2018-08-01 00:00:00	2018-08-22	2018-08-22 00:00:00	32020		\N	212618	0	444814009	40481087		0
43583	2596	4134304	1974-04-11	1974-04-11 00:00:00	1974-05-11	1974-05-11 00:00:00	32020		\N	171817	0	263102004	4134304		0
54283	3216	40481087	1981-10-04	1981-10-04 00:00:00	1981-10-18	1981-10-18 00:00:00	32020		\N	213687	0	444814009	40481087		0
43946	2616	257012	1990-04-10	1990-04-10 00:00:00	\N	\N	32020		\N	173024	0	40055000	257012		0
44143	2624	4027663	1998-12-27	1998-12-27 00:00:00	\N	\N	32020		\N	173602	0	13200003	4027663		0
44314	2633	40481087	2014-11-13	2014-11-13 00:00:00	2014-11-20	2014-11-20 00:00:00	32020		\N	174198	0	444814009	40481087		0
55024	3258	4112343	2012-08-20	2012-08-20 00:00:00	2012-08-30	2012-08-30 00:00:00	32020		\N	216623	0	195662009	4112343		0
55219	3270	260139	2019-05-09	2019-05-09 00:00:00	2019-05-16	2019-05-16 00:00:00	32020		\N	217356	0	10509002	260139		0
55292	3275	4134304	1973-09-28	1973-09-28 00:00:00	1973-11-27	1973-11-27 00:00:00	32020		\N	217602	0	263102004	4134304		0
44986	2677	440086	1985-04-11	1985-04-11 00:00:00	1987-08-14	1987-08-14 00:00:00	32020		\N	177344	0	192127007	440086		0
55647	3295	4112343	2007-08-06	2007-08-06 00:00:00	2007-08-16	2007-08-16 00:00:00	32020		\N	218886	0	195662009	4112343		0
45228	2690	4112343	1962-04-17	1962-04-17 00:00:00	1962-04-29	1962-04-29 00:00:00	32020		\N	178238	0	195662009	4112343		0
56000	3315	4112343	1969-07-27	1969-07-27 00:00:00	1969-08-05	1969-08-05 00:00:00	32020		\N	220165	0	195662009	4112343		0
45646	2712	4296204	1968-12-04	1968-12-04 00:00:00	1968-12-25	1968-12-25 00:00:00	32020		\N	179882	0	403190006	4296204		0
56305	3337	4237458	1977-08-26	1977-08-26 00:00:00	1977-09-25	1977-09-25 00:00:00	32020		\N	221350	0	58150001	4237458		0
45981	2739	4112343	1989-01-24	1989-01-24 00:00:00	1989-02-01	1989-02-01 00:00:00	32020		\N	181218	0	195662009	4112343		0
56720	3364	40481087	2003-01-26	2003-01-26 00:00:00	2003-02-02	2003-02-02 00:00:00	32020		\N	223089	0	444814009	40481087		0
56789	3367	40481087	1964-11-29	1964-11-29 00:00:00	1964-12-20	1964-12-20 00:00:00	32020		\N	223286	0	444814009	40481087		0
46449	2767	439777	1951-04-05	1951-04-05 00:00:00	\N	\N	32020		\N	183068	0	271737000	439777		0
46564	2771	260139	1913-07-30	1913-07-30 00:00:00	1913-08-06	1913-08-06 00:00:00	32020		\N	183415	0	10509002	260139		0
46791	2782	4294548	1997-11-27	1997-11-27 00:00:00	1998-05-14	1998-05-14 00:00:00	32020		\N	184350	0	75498004	4294548		0
57439	3409	260139	2001-12-27	2001-12-27 00:00:00	2002-01-10	2002-01-10 00:00:00	32020		\N	226074	0	10509002	260139		0
57627	3418	260139	1991-07-09	1991-07-09 00:00:00	1991-07-23	1991-07-23 00:00:00	32020		\N	226716	0	10509002	260139		0
57789	3428	4283893	1987-05-15	1987-05-15 00:00:00	1987-07-10	1987-07-10 00:00:00	32020		\N	227255	0	36971009	4283893		0
57943	3436	4112343	2014-08-28	2014-08-28 00:00:00	2014-09-06	2014-09-06 00:00:00	32020		\N	227891	0	195662009	4112343		0
47637	2832	372328	1988-10-11	1988-10-11 00:00:00	1990-04-22	1990-04-22 00:00:00	32020		\N	188001	0	65363002	372328		0
47722	2835	4112343	1948-02-06	1948-02-06 00:00:00	1948-02-19	1948-02-19 00:00:00	32020		\N	188259	0	195662009	4112343		0
47915	2844	28060	1967-02-14	1967-02-14 00:00:00	1967-02-27	1967-02-27 00:00:00	32020		\N	188883	0	43878008	28060		0
58692	3481	40481087	1996-12-31	1996-12-31 00:00:00	1997-01-21	1997-01-21 00:00:00	32020		\N	230852	0	444814009	40481087		0
48217	2859	378001	1966-01-10	1966-01-10 00:00:00	1966-02-09	1966-02-09 00:00:00	32020		\N	190013	0	62106007	378001		0
48374	2865	4218389	1970-08-16	1970-08-16 00:00:00	1970-09-20	1970-09-20 00:00:00	32020		\N	190571	0	39848009	4218389		0
59180	3510	4112343	1943-06-10	1943-06-10 00:00:00	1943-06-23	1943-06-23 00:00:00	32020		\N	232900	0	195662009	4112343		0
59346	3518	81151	1981-09-29	1981-09-29 00:00:00	1981-11-03	1981-11-03 00:00:00	32020		\N	233583	0	44465007	81151		0
48930	2896	372328	1970-10-14	1970-10-14 00:00:00	1971-02-28	1971-02-28 00:00:00	32020		\N	192805	0	65363002	372328		0
59631	3533	260139	2000-05-25	2000-05-25 00:00:00	2000-06-08	2000-06-08 00:00:00	32020		\N	234709	0	10509002	260139		0
59826	3545	40481087	2018-05-12	2018-05-12 00:00:00	2018-05-26	2018-05-26 00:00:00	32020		\N	235451	0	444814009	40481087		0
59964	3553	260139	1977-05-13	1977-05-13 00:00:00	1977-05-20	1977-05-20 00:00:00	32020		\N	235926	0	10509002	260139		0
60109	3560	40481087	1968-12-07	1968-12-07 00:00:00	1968-12-21	1968-12-21 00:00:00	32020		\N	236348	0	444814009	40481087		0
60279	3567	40481087	2001-07-13	2001-07-13 00:00:00	2001-08-03	2001-08-03 00:00:00	32020		\N	236990	0	444814009	40481087		0
49866	2947	40481087	2004-03-23	2004-03-23 00:00:00	2004-04-07	2004-04-07 00:00:00	32020		\N	196681	0	444814009	40481087		0
50130	2961	28060	1982-12-12	1982-12-12 00:00:00	1982-12-21	1982-12-21 00:00:00	32020		\N	197751	0	43878008	28060		0
50223	2966	257012	2014-12-03	2014-12-03 00:00:00	\N	\N	32020		\N	198049	0	40055000	257012		0
60973	3609	4296204	1992-01-16	1992-01-16 00:00:00	1992-02-06	1992-02-06 00:00:00	32020		\N	239788	0	403190006	4296204		0
50605	2992	28060	1998-07-19	1998-07-19 00:00:00	1998-07-28	1998-07-28 00:00:00	32020		\N	199688	0	43878008	28060		0
50774	3002	4296204	1975-03-25	1975-03-25 00:00:00	1975-04-15	1975-04-15 00:00:00	32020		\N	200333	0	403190006	4296204		0
50933	3013	40481087	1962-06-12	1962-06-12 00:00:00	1962-06-26	1962-06-26 00:00:00	32020		\N	200936	0	444814009	40481087		0
51032	3022	78272	2003-03-27	2003-03-27 00:00:00	2003-04-24	2003-04-24 00:00:00	32020		\N	201469	0	70704007	78272		0
61836	3651	80180	1995-10-07	1995-10-07 00:00:00	\N	\N	32020		\N	243029	0	396275006	80180		0
61958	3658	4152936	1980-05-14	1980-05-14 00:00:00	1980-05-28	1980-05-28 00:00:00	32020		\N	243507	0	283385000	4152936		0
51588	3060	40481087	1931-01-27	1931-01-27 00:00:00	1931-02-03	1931-02-03 00:00:00	32020		\N	203556	0	444814009	40481087		0
62373	3686	81151	2016-10-01	2016-10-01 00:00:00	2016-10-29	2016-10-29 00:00:00	32020		\N	245055	0	44465007	81151		0
62426	3689	40481087	2010-08-15	2010-08-15 00:00:00	2010-08-22	2010-08-22 00:00:00	32020		\N	245236	0	444814009	40481087		0
52095	3084	80180	2017-05-02	2017-05-02 00:00:00	\N	\N	32020		\N	205357	0	396275006	80180		0
62760	3707	260139	1984-09-10	1984-09-10 00:00:00	1984-09-17	1984-09-17 00:00:00	32020		\N	246459	0	10509002	260139		0
52393	3103	40481087	2009-04-09	2009-04-09 00:00:00	2009-04-30	2009-04-30 00:00:00	32020		\N	206451	0	444814009	40481087		0
63201	3733	40481087	1999-07-27	1999-07-27 00:00:00	1999-08-03	1999-08-03 00:00:00	32020		\N	248057	0	444814009	40481087		0
63343	3742	40481087	1988-04-02	1988-04-02 00:00:00	1988-04-16	1988-04-16 00:00:00	32020		\N	248639	0	444814009	40481087		0
63469	3748	4059173	1987-11-27	1987-11-27 00:00:00	1987-12-27	1987-12-27 00:00:00	32020		\N	249095	0	16114001	4059173		0
63665	3759	134438	1983-08-12	1983-08-12 00:00:00	1984-04-14	1984-04-14 00:00:00	32020		\N	249967	0	40275004	134438		0
42661	2542	4116491	2015-05-18	2015-05-18 00:00:00	2015-06-24	2015-06-24 00:00:00	32020		\N	168199	0	301011002	4116491		0
53364	3161	372328	1951-06-15	1951-06-15 00:00:00	1951-08-22	1951-08-22 00:00:00	32020		\N	210253	0	65363002	372328		0
53496	3170	260139	1972-12-18	1972-12-18 00:00:00	1972-12-25	1972-12-25 00:00:00	32020		\N	210721	0	10509002	260139		0
53620	3177	40481087	1916-08-24	1916-08-24 00:00:00	1916-09-14	1916-09-14 00:00:00	32020		\N	211245	0	444814009	40481087		0
43257	2576	40481087	2003-02-22	2003-02-22 00:00:00	2003-03-01	2003-03-01 00:00:00	32020		\N	170560	0	444814009	40481087		0
53985	3196	372328	1975-08-23	1975-08-23 00:00:00	1976-03-23	1976-03-23 00:00:00	32020		\N	212600	0	65363002	372328		0
43584	2596	372328	1967-03-28	1967-03-28 00:00:00	1967-07-08	1967-07-08 00:00:00	32020		\N	171751	0	65363002	372328		0
54284	3216	40481087	2005-09-04	2005-09-04 00:00:00	2005-09-18	2005-09-18 00:00:00	32020		\N	213714	0	444814009	40481087		0
43947	2616	40481087	2005-07-28	2005-07-28 00:00:00	2005-08-04	2005-08-04 00:00:00	32020		\N	172943	0	444814009	40481087		0
44144	2624	439777	1996-12-27	1996-12-27 00:00:00	\N	\N	32020		\N	173602	0	271737000	439777		0
44315	2633	40481087	2003-12-13	2003-12-13 00:00:00	2004-01-03	2004-01-03 00:00:00	32020		\N	174245	0	444814009	40481087		0
55025	3258	440086	1995-05-31	1995-05-31 00:00:00	1999-06-09	1999-06-09 00:00:00	32020		\N	216556	0	192127007	440086		0
55220	3270	4112343	1976-04-25	1976-04-25 00:00:00	1976-05-07	1976-05-07 00:00:00	32020		\N	217300	0	195662009	4112343		0
55293	3275	4156265	1985-10-25	1985-10-25 00:00:00	1985-11-08	1985-11-08 00:00:00	32020		\N	217603	0	370247008	4156265		0
55445	3285	40481087	1959-05-21	1959-05-21 00:00:00	1959-05-28	1959-05-28 00:00:00	32020		\N	218169	0	444814009	40481087		0
55648	3295	260139	1997-11-01	1997-11-01 00:00:00	1997-11-15	1997-11-15 00:00:00	32020		\N	218973	0	10509002	260139		0
45229	2690	40481087	1977-11-03	1977-11-03 00:00:00	1977-11-10	1977-11-10 00:00:00	32020		\N	178230	0	444814009	40481087		0
56001	3315	4112343	2002-02-07	2002-02-07 00:00:00	2002-02-16	2002-02-16 00:00:00	32020		\N	220208	0	195662009	4112343		0
45647	2712	40481087	2008-04-07	2008-04-07 00:00:00	2008-04-21	2008-04-21 00:00:00	32020		\N	179830	0	444814009	40481087		0
56306	3337	40481087	1984-07-23	1984-07-23 00:00:00	1984-07-30	1984-07-30 00:00:00	32020		\N	221389	0	444814009	40481087		0
45982	2739	28060	1960-03-25	1960-03-25 00:00:00	1960-04-07	1960-04-07 00:00:00	32020		\N	181209	0	43878008	28060		0
56721	3364	372328	1980-08-02	1980-08-02 00:00:00	1981-06-04	1981-06-04 00:00:00	32020		\N	223092	0	65363002	372328		0
56790	3367	260139	1965-12-19	1965-12-19 00:00:00	1966-01-02	1966-01-02 00:00:00	32020		\N	223299	0	10509002	260139		0
46450	2767	196456	1939-05-23	1939-05-23 00:00:00	1939-05-24	1939-05-24 00:00:00	32020		\N	183063	0	235919008	196456		0
46565	2771	4112343	1942-05-22	1942-05-22 00:00:00	1942-06-01	1942-06-01 00:00:00	32020		\N	183453	0	195662009	4112343		0
46792	2782	4112343	1940-11-04	1940-11-04 00:00:00	1940-11-11	1940-11-11 00:00:00	32020		\N	184434	0	195662009	4112343		0
57440	3409	28060	1955-12-27	1955-12-27 00:00:00	1956-01-06	1956-01-06 00:00:00	32020		\N	226125	0	43878008	28060		0
57628	3418	260139	2008-12-27	2008-12-27 00:00:00	2009-01-03	2009-01-03 00:00:00	32020		\N	226719	0	10509002	260139		0
57790	3428	40481087	1998-01-21	1998-01-21 00:00:00	1998-02-11	1998-02-11 00:00:00	32020		\N	227288	0	444814009	40481087		0
57944	3436	260139	1996-02-07	1996-02-07 00:00:00	1996-02-21	1996-02-21 00:00:00	32020		\N	227895	0	10509002	260139		0
47638	2832	4142905	2003-04-26	2003-04-26 00:00:00	2003-07-25	2003-07-25 00:00:00	32020		\N	187902	0	33737001	4142905		0
47723	2835	260139	2013-10-12	2013-10-12 00:00:00	2013-10-19	2013-10-19 00:00:00	32020		\N	188272	0	10509002	260139		0
47916	2844	40481087	2002-01-28	2002-01-28 00:00:00	2002-02-04	2002-02-04 00:00:00	32020		\N	188813	0	444814009	40481087		0
58693	3481	40481087	1999-09-16	1999-09-16 00:00:00	1999-10-07	1999-10-07 00:00:00	32020		\N	230853	0	444814009	40481087		0
48218	2859	40481087	1946-08-30	1946-08-30 00:00:00	1946-09-20	1946-09-20 00:00:00	32020		\N	190020	0	444814009	40481087		0
48375	2865	4112343	1981-06-29	1981-06-29 00:00:00	1981-07-08	1981-07-08 00:00:00	32020		\N	190577	0	195662009	4112343		0
59181	3510	4155034	1960-03-31	1960-03-31 00:00:00	1960-04-14	1960-04-14 00:00:00	32020		\N	232798	0	283371005	4155034		0
60717	3593	313217	2017-06-14	2017-06-14 00:00:00	\N	\N	32020		\N	238652	0	49436004	313217		0
59347	3518	260139	2014-06-29	2014-06-29 00:00:00	2014-07-06	2014-07-06 00:00:00	32020		\N	233536	0	10509002	260139		0
48931	2896	4134304	2014-10-26	2014-10-26 00:00:00	2014-12-25	2014-12-25 00:00:00	32020		\N	192868	0	263102004	4134304		0
59632	3533	80180	2001-01-03	2001-01-03 00:00:00	\N	\N	32020		\N	234709	0	396275006	80180		0
59827	3545	40481087	1994-09-11	1994-09-11 00:00:00	1994-09-18	1994-09-18 00:00:00	32020		\N	235483	0	444814009	40481087		0
59965	3553	40481087	1941-03-23	1941-03-23 00:00:00	1941-04-13	1941-04-13 00:00:00	32020		\N	235869	0	444814009	40481087		0
60110	3560	40481087	1979-07-21	1979-07-21 00:00:00	1979-08-11	1979-08-11 00:00:00	32020		\N	236367	0	444814009	40481087		0
60280	3567	372328	1972-11-29	1972-11-29 00:00:00	1973-06-14	1973-06-14 00:00:00	32020		\N	237054	0	65363002	372328		0
49884	2949	40481087	2003-05-04	2003-05-04 00:00:00	2003-05-11	2003-05-11 00:00:00	32020		\N	196869	0	444814009	40481087		0
50131	2961	4294548	2004-08-14	2004-08-14 00:00:00	2004-09-18	2004-09-18 00:00:00	32020		\N	197711	0	75498004	4294548		0
50224	2966	192671	2001-02-25	2001-02-25 00:00:00	\N	\N	32020		\N	198165	0	K92.2	35208414		0
60974	3609	4112343	1987-02-25	1987-02-25 00:00:00	1987-03-05	1987-03-05 00:00:00	32020		\N	239745	0	195662009	4112343		0
50606	2992	260139	1995-03-19	1995-03-19 00:00:00	1995-03-26	1995-03-26 00:00:00	32020		\N	199687	0	10509002	260139		0
50775	3002	372328	1974-03-30	1974-03-30 00:00:00	1974-06-11	1974-06-11 00:00:00	32020		\N	200381	0	65363002	372328		0
50934	3013	4294548	1953-09-17	1953-09-17 00:00:00	1953-10-22	1953-10-22 00:00:00	32020		\N	200935	0	75498004	4294548		0
51033	3022	372328	1972-12-01	1972-12-01 00:00:00	1973-01-12	1973-01-12 00:00:00	32020		\N	201448	0	65363002	372328		0
61837	3651	78272	1975-07-04	1975-07-04 00:00:00	1975-07-25	1975-07-25 00:00:00	32020		\N	243044	0	70704007	78272		0
61959	3658	40481087	1985-02-13	1985-02-13 00:00:00	1985-03-06	1985-03-06 00:00:00	32020		\N	243497	0	444814009	40481087		0
51589	3060	40481087	1966-05-07	1966-05-07 00:00:00	1966-05-21	1966-05-21 00:00:00	32020		\N	203607	0	444814009	40481087		0
62374	3686	4283893	1973-11-25	1973-11-25 00:00:00	1974-01-06	1974-01-06 00:00:00	32020		\N	245024	0	36971009	4283893		0
62427	3689	4112343	2016-10-02	2016-10-02 00:00:00	2016-10-11	2016-10-11 00:00:00	32020		\N	245238	0	195662009	4112343		0
52096	3084	40481087	2003-07-24	2003-07-24 00:00:00	2003-08-14	2003-08-14 00:00:00	32020		\N	205368	0	444814009	40481087		0
62761	3707	372328	1973-11-19	1973-11-19 00:00:00	1974-06-10	1974-06-10 00:00:00	32020		\N	246439	0	65363002	372328		0
52394	3103	381316	2018-05-16	2018-05-16 00:00:00	\N	\N	32020		\N	206438	0	230690007	381316		0
63202	3733	40481087	1988-06-11	1988-06-11 00:00:00	1988-06-18	1988-06-18 00:00:00	32020		\N	248075	0	444814009	40481087		0
63344	3742	40481087	1988-06-24	1988-06-24 00:00:00	1988-07-15	1988-07-15 00:00:00	32020		\N	248668	0	444814009	40481087		0
63470	3748	4113008	2015-12-28	2015-12-28 00:00:00	2016-01-11	2016-01-11 00:00:00	32020		\N	249097	0	284549007	4113008		0
63666	3759	4112343	1978-09-13	1978-09-13 00:00:00	1978-09-26	1978-09-26 00:00:00	32020		\N	249935	0	195662009	4112343		0
42662	2543	4112343	2001-08-12	2001-08-12 00:00:00	2001-08-20	2001-08-20 00:00:00	32020		\N	168253	0	195662009	4112343		0
53365	3161	4152936	1960-06-25	1960-06-25 00:00:00	1960-07-09	1960-07-09 00:00:00	32020		\N	210248	0	283385000	4152936		0
53497	3170	81151	1958-06-13	1958-06-13 00:00:00	1958-06-27	1958-06-27 00:00:00	32020		\N	210712	0	44465007	81151		0
53621	3177	81151	1924-12-04	1924-12-04 00:00:00	1924-12-18	1924-12-18 00:00:00	32020		\N	211226	0	44465007	81151		0
43258	2576	78272	2017-04-04	2017-04-04 00:00:00	2017-04-18	2017-04-18 00:00:00	32020		\N	170550	0	70704007	78272		0
53986	3196	28060	2011-01-10	2011-01-10 00:00:00	2011-01-19	2011-01-19 00:00:00	32020		\N	212617	0	43878008	28060		0
43585	2596	372328	1968-03-04	1968-03-04 00:00:00	1968-04-06	1968-04-06 00:00:00	32020		\N	171814	0	65363002	372328		0
54285	3216	192671	1995-12-22	1995-12-22 00:00:00	\N	\N	32020		\N	213686	0	K92.2	35208414		0
43948	2616	260139	1997-03-12	1997-03-12 00:00:00	1997-03-26	1997-03-26 00:00:00	32020		\N	172954	0	10509002	260139		0
44145	2624	4218389	2015-09-15	2015-09-15 00:00:00	2015-10-13	2015-10-13 00:00:00	32020		\N	173624	0	39848009	4218389		0
44316	2633	372328	1950-03-16	1950-03-16 00:00:00	1950-09-21	1950-09-21 00:00:00	32020		\N	174265	0	65363002	372328		0
55026	3258	40481087	2009-04-19	2009-04-19 00:00:00	2009-04-26	2009-04-26 00:00:00	32020		\N	216613	0	444814009	40481087		0
55221	3270	440086	1981-03-23	1981-03-23 00:00:00	1987-06-01	1987-06-01 00:00:00	32020		\N	217301	0	192127007	440086		0
55294	3275	4112343	2012-01-27	2012-01-27 00:00:00	2012-02-04	2012-02-04 00:00:00	32020		\N	217583	0	195662009	4112343		0
55446	3285	28060	1978-11-13	1978-11-13 00:00:00	1978-11-22	1978-11-22 00:00:00	32020		\N	218211	0	43878008	28060		0
55649	3295	260139	1960-05-24	1960-05-24 00:00:00	1960-06-07	1960-06-07 00:00:00	32020		\N	218924	0	10509002	260139		0
45230	2690	4109685	1997-04-30	1997-04-30 00:00:00	1997-05-21	1997-05-21 00:00:00	32020		\N	178254	0	284551006	4109685		0
56002	3315	40481087	2017-06-10	2017-06-10 00:00:00	2017-07-01	2017-07-01 00:00:00	32020		\N	220155	0	444814009	40481087		0
45648	2712	40481087	2007-08-29	2007-08-29 00:00:00	2007-09-05	2007-09-05 00:00:00	32020		\N	179829	0	444814009	40481087		0
56307	3337	378001	1992-09-06	1992-09-06 00:00:00	1992-11-05	1992-11-05 00:00:00	32020		\N	221352	0	62106007	378001		0
56449	3347	40481087	1979-08-10	1979-08-10 00:00:00	1979-08-31	1979-08-31 00:00:00	32020		\N	222061	0	444814009	40481087		0
56722	3364	4112343	2011-09-19	2011-09-19 00:00:00	2011-09-28	2011-09-28 00:00:00	32020		\N	223154	0	195662009	4112343		0
56791	3367	260139	2017-08-17	2017-08-17 00:00:00	2017-08-24	2017-08-24 00:00:00	32020		\N	223343	0	10509002	260139		0
46451	2767	198809	1939-05-23	1939-05-23 00:00:00	1939-05-24	1939-05-24 00:00:00	32020		\N	183063	0	65275009	198809		0
46566	2771	80180	1946-09-23	1946-09-23 00:00:00	\N	\N	32020		\N	183543	0	396275006	80180		0
46793	2782	4112343	1932-07-28	1932-07-28 00:00:00	1932-08-04	1932-08-04 00:00:00	32020		\N	184441	0	195662009	4112343		0
57441	3409	4237458	2011-04-26	2011-04-26 00:00:00	2011-07-25	2011-07-25 00:00:00	32020		\N	226124	0	58150001	4237458		0
57629	3418	40481087	2010-02-01	2010-02-01 00:00:00	2010-02-15	2010-02-15 00:00:00	32020		\N	226754	0	444814009	40481087		0
57791	3428	4294548	2015-03-21	2015-03-21 00:00:00	2015-06-27	2015-06-27 00:00:00	32020		\N	227289	0	75498004	4294548		0
57945	3436	40481087	2010-09-16	2010-09-16 00:00:00	2010-09-30	2010-09-30 00:00:00	32020		\N	227864	0	444814009	40481087		0
47639	2832	134438	1994-02-14	1994-02-14 00:00:00	1994-10-15	1994-10-15 00:00:00	32020		\N	187975	0	40275004	134438		0
47724	2835	40481087	2014-05-16	2014-05-16 00:00:00	2014-05-30	2014-05-30 00:00:00	32020		\N	188324	0	444814009	40481087		0
47917	2844	40481087	1955-08-08	1955-08-08 00:00:00	1955-08-22	1955-08-22 00:00:00	32020		\N	188825	0	444814009	40481087		0
58694	3481	317576	1995-06-24	1995-06-24 00:00:00	\N	\N	32020		\N	230870	0	53741008	317576		0
48219	2859	40481087	1995-02-20	1995-02-20 00:00:00	1995-03-06	1995-03-06 00:00:00	32020		\N	190064	0	444814009	40481087		0
48376	2865	4112343	1969-01-25	1969-01-25 00:00:00	1969-02-01	1969-02-01 00:00:00	32020		\N	190625	0	195662009	4112343		0
59182	3510	4152936	1982-04-19	1982-04-19 00:00:00	1982-05-03	1982-05-03 00:00:00	32020		\N	232799	0	283385000	4152936		0
59348	3518	4112343	1963-02-05	1963-02-05 00:00:00	1963-02-15	1963-02-15 00:00:00	32020		\N	233551	0	195662009	4112343		0
48932	2896	192671	2002-05-25	2002-05-25 00:00:00	\N	\N	32020		\N	192788	0	K92.2	35208414		0
59633	3533	40481087	2016-12-24	2016-12-24 00:00:00	2017-01-14	2017-01-14 00:00:00	32020		\N	234681	0	444814009	40481087		0
59828	3545	260139	1973-03-24	1973-03-24 00:00:00	1973-03-31	1973-03-31 00:00:00	32020		\N	235495	0	10509002	260139		0
59966	3553	192671	1966-11-08	1966-11-08 00:00:00	\N	\N	32020		\N	235864	0	K92.2	35208414		0
60111	3561	4112343	1965-08-24	1965-08-24 00:00:00	1965-09-04	1965-09-04 00:00:00	32020		\N	236504	0	195662009	4112343		0
60281	3568	28060	1984-01-15	1984-01-15 00:00:00	1984-01-28	1984-01-28 00:00:00	32020		\N	237095	0	43878008	28060		0
49885	2949	40481087	1969-06-21	1969-06-21 00:00:00	1969-06-28	1969-06-28 00:00:00	32020		\N	196838	0	444814009	40481087		0
50132	2961	195588	2017-09-14	2017-09-14 00:00:00	2017-10-16	2017-10-16 00:00:00	32020		\N	197707	0	38822007	195588		0
50228	2969	4112343	1978-05-29	1978-05-29 00:00:00	1978-06-06	1978-06-06 00:00:00	32020		\N	198206	0	195662009	4112343		0
60975	3609	28060	2008-07-26	2008-07-26 00:00:00	2008-08-03	2008-08-03 00:00:00	32020		\N	239791	0	43878008	28060		0
50607	2992	260139	2006-01-02	2006-01-02 00:00:00	2006-01-09	2006-01-09 00:00:00	32020		\N	199698	0	10509002	260139		0
50780	3004	40481087	2016-12-12	2016-12-12 00:00:00	2016-12-26	2016-12-26 00:00:00	32020		\N	200489	0	444814009	40481087		0
50935	3013	260139	2005-02-22	2005-02-22 00:00:00	2005-03-08	2005-03-08 00:00:00	32020		\N	200905	0	10509002	260139		0
51034	3022	260139	1991-07-18	1991-07-18 00:00:00	1991-07-25	1991-07-25 00:00:00	32020		\N	201446	0	10509002	260139		0
61838	3651	4278672	1973-02-14	1973-02-14 00:00:00	1973-05-15	1973-05-15 00:00:00	32020		\N	243043	0	65966004	4278672		0
61960	3658	80180	1999-06-13	1999-06-13 00:00:00	\N	\N	32020		\N	243441	0	396275006	80180		0
51590	3060	40481087	1992-09-11	1992-09-11 00:00:00	1992-10-02	1992-10-02 00:00:00	32020		\N	203545	0	444814009	40481087		0
62375	3686	4283893	2017-07-21	2017-07-21 00:00:00	2017-09-01	2017-09-01 00:00:00	32020		\N	245038	0	36971009	4283893		0
62428	3689	80180	1987-05-11	1987-05-11 00:00:00	\N	\N	32020		\N	245193	0	396275006	80180		0
52097	3084	40481087	1982-05-02	1982-05-02 00:00:00	1982-05-16	1982-05-16 00:00:00	32020		\N	205396	0	444814009	40481087		0
62762	3707	28060	1980-10-03	1980-10-03 00:00:00	1980-10-14	1980-10-14 00:00:00	32020		\N	246435	0	43878008	28060		0
52395	3103	40481087	2018-10-07	2018-10-07 00:00:00	2018-10-28	2018-10-28 00:00:00	32020		\N	206440	0	444814009	40481087		0
63203	3733	4112343	1987-01-13	1987-01-13 00:00:00	1987-01-24	1987-01-24 00:00:00	32020		\N	248056	0	195662009	4112343		0
63345	3742	4310024	2007-12-03	2007-12-03 00:00:00	\N	\N	32020		\N	248655	0	424802006	4310024		0
63471	3748	28060	1992-10-22	1992-10-22 00:00:00	1992-11-01	1992-11-01 00:00:00	32020		\N	249098	0	43878008	28060		0
63667	3759	40481087	1970-09-15	1970-09-15 00:00:00	1970-10-06	1970-10-06 00:00:00	32020		\N	249964	0	444814009	40481087		0
53123	3147	78272	1964-08-09	1964-08-09 00:00:00	1964-09-06	1964-09-06 00:00:00	32020		\N	209352	0	70704007	78272		0
53366	3161	260139	1990-04-26	1990-04-26 00:00:00	1990-05-10	1990-05-10 00:00:00	32020		\N	210214	0	10509002	260139		0
53498	3170	4112343	1975-02-10	1975-02-10 00:00:00	1975-02-21	1975-02-21 00:00:00	32020		\N	210697	0	195662009	4112343		0
53622	3177	260139	1985-09-03	1985-09-03 00:00:00	1985-09-10	1985-09-10 00:00:00	32020		\N	211344	0	10509002	260139		0
43259	2576	4283893	1990-10-14	1990-10-14 00:00:00	1990-12-09	1990-12-09 00:00:00	32020		\N	170528	0	36971009	4283893		0
53987	3196	40481087	1996-12-02	1996-12-02 00:00:00	1996-12-16	1996-12-16 00:00:00	32020		\N	212630	0	444814009	40481087		0
43586	2596	260139	2018-11-09	2018-11-09 00:00:00	2018-11-23	2018-11-23 00:00:00	32020		\N	171747	0	10509002	260139		0
54286	3216	40481087	1961-10-18	1961-10-18 00:00:00	1961-11-01	1961-11-01 00:00:00	32020		\N	213751	0	444814009	40481087		0
43949	2616	40481087	1973-05-14	1973-05-14 00:00:00	1973-05-28	1973-05-28 00:00:00	32020		\N	172993	0	444814009	40481087		0
44156	2626	28060	1968-11-03	1968-11-03 00:00:00	1968-11-15	1968-11-15 00:00:00	32020		\N	173706	0	43878008	28060		0
54781	3241	381316	1990-08-16	1990-08-16 00:00:00	\N	\N	32020		\N	215469	0	230690007	381316		0
55027	3258	372328	1985-03-31	1985-03-31 00:00:00	1985-05-08	1985-05-08 00:00:00	32020		\N	216624	0	65363002	372328		0
55222	3270	4278672	1976-02-23	1976-02-23 00:00:00	1976-04-23	1976-04-23 00:00:00	32020		\N	217350	0	65966004	4278672		0
55295	3275	260139	1993-04-02	1993-04-02 00:00:00	1993-04-09	1993-04-09 00:00:00	32020		\N	217609	0	10509002	260139		0
55447	3285	4112343	1988-04-06	1988-04-06 00:00:00	1988-04-13	1988-04-13 00:00:00	32020		\N	218172	0	195662009	4112343		0
55650	3295	28060	1978-11-10	1978-11-10 00:00:00	1978-11-18	1978-11-18 00:00:00	32020		\N	218970	0	43878008	28060		0
45231	2690	4156265	1996-03-22	1996-03-22 00:00:00	1996-04-05	1996-04-05 00:00:00	32020		\N	178253	0	370247008	4156265		0
56003	3315	40481087	2001-06-17	2001-06-17 00:00:00	2001-06-24	2001-06-24 00:00:00	32020		\N	220203	0	444814009	40481087		0
45649	2712	40481087	1988-09-08	1988-09-08 00:00:00	1988-09-29	1988-09-29 00:00:00	32020		\N	179827	0	444814009	40481087		0
56308	3337	40481087	1981-02-13	1981-02-13 00:00:00	1981-03-06	1981-03-06 00:00:00	32020		\N	221388	0	444814009	40481087		0
56450	3347	257012	1957-01-04	1957-01-04 00:00:00	\N	\N	32020		\N	222033	0	40055000	257012		0
56723	3364	28060	1982-12-05	1982-12-05 00:00:00	1982-12-18	1982-12-18 00:00:00	32020		\N	223080	0	43878008	28060		0
56792	3367	260139	2000-08-18	2000-08-18 00:00:00	2000-08-25	2000-08-25 00:00:00	32020		\N	223309	0	10509002	260139		0
46452	2767	40481087	1976-08-04	1976-08-04 00:00:00	1976-08-11	1976-08-11 00:00:00	32020		\N	183029	0	444814009	40481087		0
46567	2771	4112343	1994-05-12	1994-05-12 00:00:00	1994-05-21	1994-05-21 00:00:00	32020		\N	183545	0	195662009	4112343		0
46794	2782	4149245	1955-05-03	1955-05-03 00:00:00	1955-07-09	1955-07-09 00:00:00	32020		\N	184405	0	30832001	4149245		0
57442	3409	4112343	1961-01-24	1961-01-24 00:00:00	1961-02-02	1961-02-02 00:00:00	32020		\N	226139	0	195662009	4112343		0
57630	3418	372328	1949-07-17	1949-07-17 00:00:00	1949-10-02	1949-10-02 00:00:00	32020		\N	226734	0	65363002	372328		0
57792	3428	4152936	2010-06-03	2010-06-03 00:00:00	2010-06-24	2010-06-24 00:00:00	32020		\N	227263	0	283385000	4152936		0
57946	3436	260139	1992-07-18	1992-07-18 00:00:00	1992-07-25	1992-07-25 00:00:00	32020		\N	227880	0	10509002	260139		0
47640	2832	4112343	2003-03-23	2003-03-23 00:00:00	2003-03-31	2003-03-31 00:00:00	32020		\N	187933	0	195662009	4112343		0
47725	2835	40481087	1968-11-20	1968-11-20 00:00:00	1968-12-11	1968-12-11 00:00:00	32020		\N	188211	0	444814009	40481087		0
47918	2844	4059173	1960-10-31	1960-10-31 00:00:00	1961-01-29	1961-01-29 00:00:00	32020		\N	188892	0	16114001	4059173		0
58695	3481	4329847	2015-04-04	2015-04-04 00:00:00	\N	\N	32020		\N	230888	0	22298006	4329847		0
48220	2859	28060	1951-09-27	1951-09-27 00:00:00	1951-10-04	1951-10-04 00:00:00	32020		\N	190023	0	43878008	28060		0
48377	2865	372328	1974-01-20	1974-01-20 00:00:00	1975-01-20	1975-01-20 00:00:00	32020		\N	190627	0	65363002	372328		0
59183	3510	40481087	1999-07-16	1999-07-16 00:00:00	1999-07-30	1999-07-30 00:00:00	32020		\N	232931	0	444814009	40481087		0
59350	3518	81151	1968-08-03	1968-08-03 00:00:00	1968-08-17	1968-08-17 00:00:00	32020		\N	233580	0	44465007	81151		0
48933	2896	81151	1972-11-02	1972-11-02 00:00:00	1972-11-30	1972-11-30 00:00:00	32020		\N	192865	0	44465007	81151		0
59654	3536	260139	2005-12-09	2005-12-09 00:00:00	2005-12-16	2005-12-16 00:00:00	32020		\N	234828	0	10509002	260139		0
59829	3545	260139	1998-09-13	1998-09-13 00:00:00	1998-09-20	1998-09-20 00:00:00	32020		\N	235448	0	10509002	260139		0
59967	3553	372328	1944-08-26	1944-08-26 00:00:00	1944-12-09	1944-12-09 00:00:00	32020		\N	235895	0	65363002	372328		0
60112	3561	4001336	1954-08-08	1954-08-08 00:00:00	1954-09-07	1954-09-07 00:00:00	32020		\N	236471	0	110030002	4001336		0
60282	3568	4218389	1975-06-27	1975-06-27 00:00:00	1975-08-01	1975-08-01 00:00:00	32020		\N	237101	0	39848009	4218389		0
49886	2949	4112343	2019-04-11	2019-04-11 00:00:00	2019-04-21	2019-04-21 00:00:00	32020		\N	196848	0	195662009	4112343		0
60591	3582	40481087	1965-02-17	1965-02-17 00:00:00	1965-03-10	1965-03-10 00:00:00	32020		\N	238090	0	444814009	40481087		0
50229	2969	80180	2009-05-25	2009-05-25 00:00:00	\N	\N	32020		\N	198222	0	396275006	80180		0
60976	3609	192671	2018-09-11	2018-09-11 00:00:00	\N	\N	32020		\N	239802	0	K92.2	35208414		0
50608	2992	4112343	2005-01-04	2005-01-04 00:00:00	2005-01-12	2005-01-12 00:00:00	32020		\N	199697	0	195662009	4112343		0
50781	3004	257012	1970-01-30	1970-01-30 00:00:00	\N	\N	32020		\N	200456	0	40055000	257012		0
50936	3013	372328	1986-12-21	1986-12-21 00:00:00	1988-06-28	1988-06-28 00:00:00	32020		\N	200897	0	65363002	372328		0
51035	3022	40481087	1990-09-03	1990-09-03 00:00:00	1990-09-17	1990-09-17 00:00:00	32020		\N	201445	0	444814009	40481087		0
61839	3651	40481087	1991-08-11	1991-08-11 00:00:00	1991-08-25	1991-08-25 00:00:00	32020		\N	243046	0	444814009	40481087		0
61961	3658	40481087	1998-07-28	1998-07-28 00:00:00	1998-08-18	1998-08-18 00:00:00	32020		\N	243441	0	444814009	40481087		0
51591	3060	40481087	1978-01-14	1978-01-14 00:00:00	1978-01-28	1978-01-28 00:00:00	32020		\N	203610	0	444814009	40481087		0
62376	3686	30753	2008-08-06	2008-08-06 00:00:00	\N	\N	32020		\N	245078	0	16761005	30753		0
62429	3689	28060	1961-12-01	1961-12-01 00:00:00	1961-12-10	1961-12-10 00:00:00	32020		\N	245227	0	43878008	28060		0
52098	3084	4112343	1993-10-04	1993-10-04 00:00:00	1993-10-16	1993-10-16 00:00:00	32020		\N	205381	0	195662009	4112343		0
62763	3707	4112343	2014-06-20	2014-06-20 00:00:00	2014-06-30	2014-06-30 00:00:00	32020		\N	246465	0	195662009	4112343		0
52396	3103	80180	2019-01-20	2019-01-20 00:00:00	\N	\N	32020		\N	206440	0	396275006	80180		0
63204	3733	40481087	2006-02-05	2006-02-05 00:00:00	2006-02-19	2006-02-19 00:00:00	32020		\N	248045	0	444814009	40481087		0
63346	3742	81893	2008-06-30	2008-06-30 00:00:00	\N	\N	32020		\N	248655	0	64766004	81893		0
63472	3748	40481087	1990-11-27	1990-11-27 00:00:00	1990-12-11	1990-12-11 00:00:00	32020		\N	249141	0	444814009	40481087		0
63668	3759	260139	2010-07-05	2010-07-05 00:00:00	2010-07-19	2010-07-19 00:00:00	32020		\N	249975	0	10509002	260139		0
53124	3147	260139	2008-06-18	2008-06-18 00:00:00	2008-07-02	2008-07-02 00:00:00	32020		\N	209396	0	10509002	260139		0
53367	3161	40481087	1958-07-08	1958-07-08 00:00:00	1958-07-22	1958-07-22 00:00:00	32020		\N	210212	0	444814009	40481087		0
53499	3170	260139	1974-04-20	1974-04-20 00:00:00	1974-04-27	1974-04-27 00:00:00	32020		\N	210743	0	10509002	260139		0
53623	3177	4027663	1941-07-13	1941-07-13 00:00:00	\N	\N	32020		\N	211241	0	13200003	4027663		0
43260	2577	40481087	2014-10-23	2014-10-23 00:00:00	2014-11-13	2014-11-13 00:00:00	32020		\N	170690	0	444814009	40481087		0
53988	3196	4112343	1998-05-24	1998-05-24 00:00:00	1998-06-03	1998-06-03 00:00:00	32020		\N	212614	0	195662009	4112343		0
43587	2596	260139	1980-10-21	1980-10-21 00:00:00	1980-11-04	1980-11-04 00:00:00	32020		\N	171812	0	10509002	260139		0
54287	3216	4294548	1999-05-25	1999-05-25 00:00:00	1999-06-29	1999-06-29 00:00:00	32020		\N	213710	0	75498004	4294548		0
43950	2616	81151	1996-02-23	1996-02-23 00:00:00	1996-03-22	1996-03-22 00:00:00	32020		\N	172965	0	44465007	81151		0
54616	3234	4112343	1987-10-09	1987-10-09 00:00:00	1987-10-22	1987-10-22 00:00:00	32020		\N	214926	0	195662009	4112343		0
54782	3241	375671	1995-11-02	1995-11-02 00:00:00	1996-01-01	1996-01-01 00:00:00	32020		\N	215443	0	62564004	375671		0
55028	3258	4237458	1995-07-09	1995-07-09 00:00:00	1995-10-07	1995-10-07 00:00:00	32020		\N	216551	0	58150001	4237458		0
55223	3270	28060	2006-12-20	2006-12-20 00:00:00	2007-01-02	2007-01-02 00:00:00	32020		\N	217331	0	43878008	28060		0
55296	3275	260139	1973-10-30	1973-10-30 00:00:00	1973-11-06	1973-11-06 00:00:00	32020		\N	217629	0	10509002	260139		0
55448	3285	40481087	1997-10-03	1997-10-03 00:00:00	1997-10-17	1997-10-17 00:00:00	32020		\N	218221	0	444814009	40481087		0
55651	3295	81151	1957-12-18	1957-12-18 00:00:00	1958-01-01	1958-01-01 00:00:00	32020		\N	218895	0	44465007	81151		0
45232	2690	4027663	1973-09-24	1973-09-24 00:00:00	\N	\N	32020		\N	\N	0	13200003	4027663		0
56004	3315	4112343	2013-02-07	2013-02-07 00:00:00	2013-02-18	2013-02-18 00:00:00	32020		\N	220154	0	195662009	4112343		0
45650	2712	40481087	1974-03-15	1974-03-15 00:00:00	1974-03-22	1974-03-22 00:00:00	32020		\N	179874	0	444814009	40481087		0
56309	3337	40481087	1986-03-23	1986-03-23 00:00:00	1986-04-06	1986-04-06 00:00:00	32020		\N	221416	0	444814009	40481087		0
56451	3347	260139	2002-08-31	2002-08-31 00:00:00	2002-09-14	2002-09-14 00:00:00	32020		\N	222082	0	10509002	260139		0
56724	3364	4027663	2001-06-18	2001-06-18 00:00:00	\N	\N	32020		\N	223064	0	13200003	4027663		0
56799	3370	260139	2019-04-20	2019-04-20 00:00:00	2019-05-04	2019-05-04 00:00:00	32020		\N	223509	0	10509002	260139		0
46453	2767	4134304	1971-04-05	1971-04-05 00:00:00	1971-05-05	1971-05-05 00:00:00	32020		\N	183064	0	263102004	4134304		0
46568	2771	321042	1955-11-11	1955-11-11 00:00:00	\N	\N	32020		\N	183470	0	410429000	321042		0
46795	2782	378419	1996-04-24	1996-04-24 00:00:00	\N	\N	32020		\N	184378	0	26929004	378419		0
57443	3409	4109685	1984-06-04	1984-06-04 00:00:00	1984-06-18	1984-06-18 00:00:00	32020		\N	226121	0	284551006	4109685		0
57631	3418	4116491	1974-10-09	1974-10-09 00:00:00	1974-11-24	1974-11-24 00:00:00	32020		\N	226751	0	301011002	4116491		0
57793	3428	80180	2006-09-02	2006-09-02 00:00:00	\N	\N	32020		\N	227282	0	396275006	80180		0
57947	3436	260139	1979-04-12	1979-04-12 00:00:00	1979-04-19	1979-04-19 00:00:00	32020		\N	227862	0	10509002	260139		0
47641	2832	4283893	1996-08-18	1996-08-18 00:00:00	1996-09-15	1996-09-15 00:00:00	32020		\N	187965	0	36971009	4283893		0
47726	2835	4112343	1968-08-14	1968-08-14 00:00:00	1968-08-24	1968-08-24 00:00:00	32020		\N	188269	0	195662009	4112343		0
47919	2844	40481087	1959-12-08	1959-12-08 00:00:00	1959-12-22	1959-12-22 00:00:00	32020		\N	188881	0	444814009	40481087		0
58697	3481	40481087	1989-06-12	1989-06-12 00:00:00	1989-07-03	1989-07-03 00:00:00	32020		\N	230851	0	444814009	40481087		0
48221	2859	40481087	1979-06-24	1979-06-24 00:00:00	1979-07-15	1979-07-15 00:00:00	32020		\N	190062	0	444814009	40481087		0
48378	2865	4112343	1998-09-20	1998-09-20 00:00:00	1998-09-30	1998-09-30 00:00:00	32020		\N	190616	0	195662009	4112343		0
59184	3510	4112343	2004-10-18	2004-10-18 00:00:00	2004-10-26	2004-10-26 00:00:00	32020		\N	232944	0	195662009	4112343		0
59351	3518	440448	2016-03-17	2016-03-17 00:00:00	\N	\N	32020		\N	233584	0	74400008	440448		0
48934	2897	372328	1962-09-22	1962-09-22 00:00:00	1962-11-10	1962-11-10 00:00:00	32020		\N	192892	0	65363002	372328		0
59655	3536	40481087	1982-01-27	1982-01-27 00:00:00	1982-02-03	1982-02-03 00:00:00	32020		\N	234814	0	444814009	40481087		0
59830	3545	40481087	2000-07-18	2000-07-18 00:00:00	2000-08-08	2000-08-08 00:00:00	32020		\N	235449	0	444814009	40481087		0
59968	3553	28060	1937-11-21	1937-11-21 00:00:00	1937-11-30	1937-11-30 00:00:00	32020		\N	235868	0	43878008	28060		0
60113	3561	4112343	1953-08-16	1953-08-16 00:00:00	1953-08-25	1953-08-25 00:00:00	32020		\N	236484	0	195662009	4112343		0
60283	3568	260139	1986-06-21	1986-06-21 00:00:00	1986-07-05	1986-07-05 00:00:00	32020		\N	237105	0	10509002	260139		0
49887	2949	4112343	1992-04-04	1992-04-04 00:00:00	1992-04-16	1992-04-16 00:00:00	32020		\N	196846	0	195662009	4112343		0
60592	3582	4294548	1969-07-24	1969-07-24 00:00:00	1969-08-07	1969-08-07 00:00:00	32020		\N	238167	0	75498004	4294548		0
50230	2969	40481087	2002-11-28	2002-11-28 00:00:00	2002-12-12	2002-12-12 00:00:00	32020		\N	198251	0	444814009	40481087		0
60977	3609	4027663	2006-11-21	2006-11-21 00:00:00	\N	\N	32020		\N	239796	0	13200003	4027663		0
50609	2992	40481087	1973-05-25	1973-05-25 00:00:00	1973-06-15	1973-06-15 00:00:00	32020		\N	199710	0	444814009	40481087		0
50782	3004	378001	1961-04-08	1961-04-08 00:00:00	1961-05-08	1961-05-08 00:00:00	32020		\N	200511	0	62106007	378001		0
50937	3014	372328	1978-07-17	1978-07-17 00:00:00	1979-06-16	1979-06-16 00:00:00	32020		\N	200998	0	65363002	372328		0
51036	3022	40481087	1998-10-28	1998-10-28 00:00:00	1998-11-11	1998-11-11 00:00:00	32020		\N	201453	0	444814009	40481087		0
61840	3651	28060	1985-02-23	1985-02-23 00:00:00	1985-03-06	1985-03-06 00:00:00	32020		\N	243045	0	43878008	28060		0
61962	3658	260139	1992-12-10	1992-12-10 00:00:00	1992-12-17	1992-12-17 00:00:00	32020		\N	243439	0	10509002	260139		0
51592	3060	4027663	1952-03-22	1952-03-22 00:00:00	\N	\N	32020		\N	203617	0	13200003	4027663		0
62377	3686	260139	1985-02-25	1985-02-25 00:00:00	1985-03-04	1985-03-04 00:00:00	32020		\N	245083	0	10509002	260139		0
62430	3689	40481087	1978-04-09	1978-04-09 00:00:00	1978-04-16	1978-04-16 00:00:00	32020		\N	245217	0	444814009	40481087		0
52099	3084	4155034	1980-08-09	1980-08-09 00:00:00	1980-08-30	1980-08-30 00:00:00	32020		\N	205354	0	283371005	4155034		0
62764	3707	4027663	1999-06-23	1999-06-23 00:00:00	\N	\N	32020		\N	246444	0	13200003	4027663		0
52397	3103	372328	1982-05-04	1982-05-04 00:00:00	1982-05-26	1982-05-26 00:00:00	32020		\N	206453	0	65363002	372328		0
63205	3733	40481087	2006-06-27	2006-06-27 00:00:00	2006-07-11	2006-07-11 00:00:00	32020		\N	248046	0	444814009	40481087		0
63347	3742	372328	1972-07-04	1972-07-04 00:00:00	1972-07-18	1972-07-18 00:00:00	32020		\N	248682	0	65363002	372328		0
63487	3750	260139	1977-08-22	1977-08-22 00:00:00	1977-09-05	1977-09-05 00:00:00	32020		\N	249224	0	10509002	260139		0
63669	3759	40481087	2010-05-16	2010-05-16 00:00:00	2010-05-23	2010-05-23 00:00:00	32020		\N	249858	0	444814009	40481087		0
53125	3147	28060	1953-06-20	1953-06-20 00:00:00	1953-06-28	1953-06-28 00:00:00	32020		\N	209357	0	43878008	28060		0
53368	3161	4112343	1975-09-18	1975-09-18 00:00:00	1975-09-27	1975-09-27 00:00:00	32020		\N	210243	0	195662009	4112343		0
53500	3170	40481087	1951-01-28	1951-01-28 00:00:00	1951-02-04	1951-02-04 00:00:00	32020		\N	210727	0	444814009	40481087		0
53624	3177	40481087	1970-07-17	1970-07-17 00:00:00	1970-07-31	1970-07-31 00:00:00	32020		\N	211310	0	444814009	40481087		0
43261	2577	260139	1992-01-17	1992-01-17 00:00:00	1992-01-31	1992-01-31 00:00:00	32020		\N	170675	0	10509002	260139		0
53989	3196	40481087	1979-05-18	1979-05-18 00:00:00	1979-06-08	1979-06-08 00:00:00	32020		\N	212598	0	444814009	40481087		0
43588	2596	40481087	2016-03-17	2016-03-17 00:00:00	2016-03-31	2016-03-31 00:00:00	32020		\N	171746	0	444814009	40481087		0
54288	3216	40481087	2018-10-05	2018-10-05 00:00:00	2018-10-12	2018-10-12 00:00:00	32020		\N	213735	0	444814009	40481087		0
43951	2616	40481087	2002-01-04	2002-01-04 00:00:00	2002-01-18	2002-01-18 00:00:00	32020		\N	173014	0	444814009	40481087		0
54617	3234	40481087	1988-03-02	1988-03-02 00:00:00	1988-03-23	1988-03-23 00:00:00	32020		\N	214971	0	444814009	40481087		0
54783	3241	40481087	1973-05-02	1973-05-02 00:00:00	1973-05-16	1973-05-16 00:00:00	32020		\N	215450	0	444814009	40481087		0
55029	3258	40481087	1994-08-29	1994-08-29 00:00:00	1994-09-05	1994-09-05 00:00:00	32020		\N	216578	0	444814009	40481087		0
55224	3270	28060	1985-01-02	1985-01-02 00:00:00	1985-01-10	1985-01-10 00:00:00	32020		\N	217255	0	43878008	28060		0
55297	3275	4112343	1982-03-24	1982-03-24 00:00:00	1982-04-03	1982-04-03 00:00:00	32020		\N	217581	0	195662009	4112343		0
55449	3285	80180	1997-11-25	1997-11-25 00:00:00	\N	\N	32020		\N	218221	0	396275006	80180		0
55652	3295	40481087	1998-12-20	1998-12-20 00:00:00	1998-12-27	1998-12-27 00:00:00	32020		\N	218929	0	444814009	40481087		0
45234	2690	4329847	2001-08-02	2001-08-02 00:00:00	\N	\N	32020		\N	178255	0	22298006	4329847		0
56005	3315	40481087	1980-07-05	1980-07-05 00:00:00	1980-07-19	1980-07-19 00:00:00	32020		\N	220202	0	444814009	40481087		0
56142	3325	372328	1966-01-16	1966-01-16 00:00:00	1966-05-25	1966-05-25 00:00:00	32020		\N	220726	0	65363002	372328		0
56310	3337	80180	2007-02-15	2007-02-15 00:00:00	\N	\N	32020		\N	221400	0	396275006	80180		0
56452	3347	4112343	1969-09-02	1969-09-02 00:00:00	1969-09-15	1969-09-15 00:00:00	32020		\N	222036	0	195662009	4112343		0
56725	3364	4112343	1993-10-10	1993-10-10 00:00:00	1993-10-21	1993-10-21 00:00:00	32020		\N	223073	0	195662009	4112343		0
56800	3370	4156265	1984-06-21	1984-06-21 00:00:00	1984-07-12	1984-07-12 00:00:00	32020		\N	223393	0	370247008	4156265		0
46454	2767	260139	1984-03-28	1984-03-28 00:00:00	1984-04-04	1984-04-04 00:00:00	32020		\N	183071	0	10509002	260139		0
46570	2771	40481087	1947-04-09	1947-04-09 00:00:00	1947-04-30	1947-04-30 00:00:00	32020		\N	183454	0	444814009	40481087		0
46796	2782	40481087	1959-01-16	1959-01-16 00:00:00	1959-01-30	1959-01-30 00:00:00	32020		\N	184421	0	444814009	40481087		0
57444	3409	4134304	2005-01-27	2005-01-27 00:00:00	2005-02-26	2005-02-26 00:00:00	32020		\N	226123	0	263102004	4134304		0
57632	3418	40481087	2011-02-15	2011-02-15 00:00:00	2011-03-08	2011-03-08 00:00:00	32020		\N	226755	0	444814009	40481087		0
57794	3428	4237458	2004-06-04	2004-06-04 00:00:00	2004-08-03	2004-08-03 00:00:00	32020		\N	227262	0	58150001	4237458		0
57948	3436	40481087	1970-09-22	1970-09-22 00:00:00	1970-10-13	1970-10-13 00:00:00	32020		\N	227876	0	444814009	40481087		0
47642	2832	4283893	2014-06-06	2014-06-06 00:00:00	2014-08-08	2014-08-08 00:00:00	32020		\N	187986	0	36971009	4283893		0
47727	2835	80502	1993-05-04	1993-05-04 00:00:00	\N	\N	32020		\N	188308	0	64859006	80502		0
47920	2844	4112343	2002-02-04	2002-02-04 00:00:00	2002-02-17	2002-02-17 00:00:00	32020		\N	188871	0	195662009	4112343		0
58708	3483	4152936	1953-11-20	1953-11-20 00:00:00	1953-12-04	1953-12-04 00:00:00	32020		\N	231116	0	283385000	4152936		0
48222	2859	81893	1975-06-02	1975-06-02 00:00:00	\N	\N	32020		\N	189988	0	64766004	81893		0
48379	2865	4112343	2008-12-03	2008-12-03 00:00:00	2008-12-15	2008-12-15 00:00:00	32020		\N	190617	0	195662009	4112343		0
59185	3510	4112343	1962-05-27	1962-05-27 00:00:00	1962-06-03	1962-06-03 00:00:00	32020		\N	232812	0	195662009	4112343		0
59352	3518	40481087	1995-11-24	1995-11-24 00:00:00	1995-12-08	1995-12-08 00:00:00	32020		\N	233595	0	444814009	40481087		0
48935	2897	28060	1983-12-13	1983-12-13 00:00:00	1983-12-21	1983-12-21 00:00:00	32020		\N	192889	0	43878008	28060		0
59656	3536	40486433	1967-11-13	1967-11-13 00:00:00	1982-11-11	1982-11-11 00:00:00	32020		\N	234874	0	446096008	40486433		0
59831	3545	260139	1974-10-03	1974-10-03 00:00:00	1974-10-17	1974-10-17 00:00:00	32020		\N	235445	0	10509002	260139		0
59969	3553	4112343	1945-03-24	1945-03-24 00:00:00	1945-04-02	1945-04-02 00:00:00	32020		\N	235870	0	195662009	4112343		0
60114	3561	28060	1983-03-14	1983-03-14 00:00:00	1983-03-26	1983-03-26 00:00:00	32020		\N	236512	0	43878008	28060		0
60284	3568	40481087	1988-06-11	1988-06-11 00:00:00	1988-07-02	1988-07-02 00:00:00	32020		\N	237069	0	444814009	40481087		0
49888	2949	40481087	2003-01-04	2003-01-04 00:00:00	2003-01-25	2003-01-25 00:00:00	32020		\N	196847	0	444814009	40481087		0
60593	3582	4237458	2014-12-17	2014-12-17 00:00:00	2015-03-17	2015-03-17 00:00:00	32020		\N	238126	0	58150001	4237458		0
50231	2969	40481087	1993-11-10	1993-11-10 00:00:00	1993-11-17	1993-11-17 00:00:00	32020		\N	198207	0	444814009	40481087		0
60978	3610	40481087	1979-08-14	1979-08-14 00:00:00	1979-08-28	1979-08-28 00:00:00	32020		\N	239889	0	444814009	40481087		0
50610	2992	40481087	2014-04-04	2014-04-04 00:00:00	2014-04-11	2014-04-11 00:00:00	32020		\N	199699	0	444814009	40481087		0
50783	3004	4283893	1997-04-29	1997-04-29 00:00:00	1997-06-10	1997-06-10 00:00:00	32020		\N	200500	0	36971009	4283893		0
50938	3014	80180	2012-11-06	2012-11-06 00:00:00	\N	\N	32020		\N	201023	0	396275006	80180		0
51037	3022	260139	1976-03-16	1976-03-16 00:00:00	1976-03-30	1976-03-30 00:00:00	32020		\N	201477	0	10509002	260139		0
61841	3651	40481087	1975-03-17	1975-03-17 00:00:00	1975-03-31	1975-03-31 00:00:00	32020		\N	243010	0	444814009	40481087		0
61963	3658	4113008	1977-05-09	1977-05-09 00:00:00	1977-05-30	1977-05-30 00:00:00	32020		\N	243506	0	284549007	4113008		0
51593	3060	40481087	2017-01-19	2017-01-19 00:00:00	2017-01-26	2017-01-26 00:00:00	32020		\N	203642	0	444814009	40481087		0
62378	3686	40481087	1997-06-12	1997-06-12 00:00:00	1997-06-26	1997-06-26 00:00:00	32020		\N	245029	0	444814009	40481087		0
62431	3689	260139	1956-07-28	1956-07-28 00:00:00	1956-08-04	1956-08-04 00:00:00	32020		\N	245234	0	10509002	260139		0
52100	3084	4112343	2008-06-15	2008-06-15 00:00:00	2008-06-23	2008-06-23 00:00:00	32020		\N	205398	0	195662009	4112343		0
62765	3707	372328	1969-09-28	1969-09-28 00:00:00	1969-12-08	1969-12-08 00:00:00	32020		\N	246447	0	65363002	372328		0
52398	3103	260139	2015-06-19	2015-06-19 00:00:00	2015-06-26	2015-06-26 00:00:00	32020		\N	206452	0	10509002	260139		0
63206	3733	4112343	2003-06-01	2003-06-01 00:00:00	2003-06-08	2003-06-08 00:00:00	32020		\N	248044	0	195662009	4112343		0
63348	3742	40481087	1985-09-02	1985-09-02 00:00:00	1985-09-09	1985-09-09 00:00:00	32020		\N	248679	0	444814009	40481087		0
63488	3750	28060	1977-11-23	1977-11-23 00:00:00	1977-12-02	1977-12-02 00:00:00	32020		\N	249225	0	43878008	28060		0
63670	3759	4116491	1987-08-04	1987-08-04 00:00:00	1987-09-17	1987-09-17 00:00:00	32020		\N	249883	0	301011002	4116491		0
53126	3147	40481087	1973-02-02	1973-02-02 00:00:00	1973-02-23	1973-02-23 00:00:00	32020		\N	209430	0	444814009	40481087		0
53369	3161	78272	1957-09-11	1957-09-11 00:00:00	1957-10-09	1957-10-09 00:00:00	32020		\N	210247	0	70704007	78272		0
53625	3177	4230399	2002-07-19	2002-07-19 00:00:00	2002-08-18	2002-08-18 00:00:00	32020		\N	211349	0	359817006	4230399		0
43262	2577	4048171	1975-05-19	1975-05-19 00:00:00	1993-07-17	1993-07-17 00:00:00	32020		\N	170612	0	232353008	4048171		0
53990	3196	40481087	1974-10-21	1974-10-21 00:00:00	1974-11-04	1974-11-04 00:00:00	32020		\N	212611	0	444814009	40481087		0
43589	2596	260139	1978-04-14	1978-04-14 00:00:00	1978-04-28	1978-04-28 00:00:00	32020		\N	171768	0	10509002	260139		0
54289	3216	40481087	2014-03-12	2014-03-12 00:00:00	2014-04-02	2014-04-02 00:00:00	32020		\N	213733	0	444814009	40481087		0
43952	2616	40481087	1988-09-15	1988-09-15 00:00:00	1988-10-06	1988-10-06 00:00:00	32020		\N	173023	0	444814009	40481087		0
54618	3234	4112343	2002-03-07	2002-03-07 00:00:00	2002-03-17	2002-03-17 00:00:00	32020		\N	214929	0	195662009	4112343		0
54784	3241	4294548	1973-08-23	1973-08-23 00:00:00	1973-09-06	1973-09-06 00:00:00	32020		\N	215485	0	75498004	4294548		0
55030	3258	4112343	2005-11-27	2005-11-27 00:00:00	2005-12-07	2005-12-07 00:00:00	32020		\N	216557	0	195662009	4112343		0
55225	3270	4112343	1981-01-14	1981-01-14 00:00:00	1981-01-25	1981-01-25 00:00:00	32020		\N	217259	0	195662009	4112343		0
55298	3275	80180	1992-02-21	1992-02-21 00:00:00	\N	\N	32020		\N	217644	0	396275006	80180		0
55450	3285	40481087	1980-01-27	1980-01-27 00:00:00	1980-02-10	1980-02-10 00:00:00	32020		\N	218212	0	444814009	40481087		0
55653	3295	260139	1956-04-07	1956-04-07 00:00:00	1956-04-14	1956-04-14 00:00:00	32020		\N	218877	0	10509002	260139		0
45235	2690	260139	1972-08-17	1972-08-17 00:00:00	1972-08-31	1972-08-31 00:00:00	32020		\N	178240	0	10509002	260139		0
56006	3315	40481087	1966-01-18	1966-01-18 00:00:00	1966-01-25	1966-01-25 00:00:00	32020		\N	220168	0	444814009	40481087		0
56143	3325	4112343	2005-03-11	2005-03-11 00:00:00	2005-03-24	2005-03-24 00:00:00	32020		\N	220745	0	195662009	4112343		0
56311	3337	260139	2010-07-24	2010-07-24 00:00:00	2010-07-31	2010-07-31 00:00:00	32020		\N	221371	0	10509002	260139		0
56453	3347	4112343	1963-07-26	1963-07-26 00:00:00	1963-08-04	1963-08-04 00:00:00	32020		\N	222035	0	195662009	4112343		0
56726	3364	40481087	1985-05-02	1985-05-02 00:00:00	1985-05-23	1985-05-23 00:00:00	32020		\N	223077	0	444814009	40481087		0
56801	3370	80180	2011-10-30	2011-10-30 00:00:00	\N	\N	32020		\N	223465	0	396275006	80180		0
46455	2767	260139	1947-03-31	1947-03-31 00:00:00	1947-04-07	1947-04-07 00:00:00	32020		\N	183048	0	10509002	260139		0
46571	2771	4156265	1946-11-23	1946-11-23 00:00:00	1946-12-14	1946-12-14 00:00:00	32020		\N	183469	0	370247008	4156265		0
46797	2782	40481087	1933-11-10	1933-11-10 00:00:00	1933-11-17	1933-11-17 00:00:00	32020		\N	184433	0	444814009	40481087		0
57445	3409	378001	1958-07-30	1958-07-30 00:00:00	1958-09-28	1958-09-28 00:00:00	32020		\N	226137	0	62106007	378001		0
57633	3418	4283893	1949-06-22	1949-06-22 00:00:00	1949-07-13	1949-07-13 00:00:00	32020		\N	226750	0	36971009	4283893		0
57795	3428	260139	1978-07-22	1978-07-22 00:00:00	1978-08-05	1978-08-05 00:00:00	32020		\N	227249	0	10509002	260139		0
57949	3436	4296205	1976-04-23	1976-04-23 00:00:00	1976-05-21	1976-05-21 00:00:00	32020		\N	227854	0	403191005	4296205		0
58101	3442	4112343	1974-06-11	1974-06-11 00:00:00	1974-06-22	1974-06-22 00:00:00	32020		\N	228446	0	195662009	4112343		0
47728	2835	40480160	2012-01-31	2012-01-31 00:00:00	2012-03-31	2012-03-31 00:00:00	32020		\N	188346	0	443165006	40480160		0
47921	2844	80180	1992-01-17	1992-01-17 00:00:00	\N	\N	32020		\N	188860	0	396275006	80180		0
58709	3483	440086	1962-01-22	1962-01-22 00:00:00	1964-10-12	1964-10-12 00:00:00	32020		\N	231091	0	192127007	440086		0
48223	2859	4112343	1973-08-02	1973-08-02 00:00:00	1973-08-12	1973-08-12 00:00:00	32020		\N	189965	0	195662009	4112343		0
48380	2865	4112343	1993-06-06	1993-06-06 00:00:00	1993-06-14	1993-06-14 00:00:00	32020		\N	190599	0	195662009	4112343		0
59186	3510	260139	1975-08-05	1975-08-05 00:00:00	1975-08-19	1975-08-19 00:00:00	32020		\N	232913	0	10509002	260139		0
59353	3518	40479422	1978-09-08	1978-09-08 00:00:00	1978-10-15	1978-10-15 00:00:00	32020		\N	233582	0	444448004	40479422		0
48936	2897	40481087	1996-07-09	1996-07-09 00:00:00	1996-07-23	1996-07-23 00:00:00	32020		\N	192924	0	444814009	40481087		0
59657	3536	28060	1974-06-24	1974-06-24 00:00:00	1974-07-04	1974-07-04 00:00:00	32020		\N	234840	0	43878008	28060		0
59832	3545	40481087	1975-12-30	1975-12-30 00:00:00	1976-01-13	1976-01-13 00:00:00	32020		\N	235446	0	444814009	40481087		0
59970	3553	40481087	2001-03-30	2001-03-30 00:00:00	2001-04-06	2001-04-06 00:00:00	32020		\N	235908	0	444814009	40481087		0
60115	3561	313217	1973-04-16	1973-04-16 00:00:00	\N	\N	32020		\N	236440	0	49436004	313217		0
60285	3568	260139	1977-07-15	1977-07-15 00:00:00	1977-07-22	1977-07-22 00:00:00	32020		\N	237094	0	10509002	260139		0
49889	2949	4283893	1980-09-03	1980-09-03 00:00:00	1981-01-07	1981-01-07 00:00:00	32020		\N	196864	0	36971009	4283893		0
60594	3582	4266809	2001-07-30	2001-07-30 00:00:00	\N	\N	32020		\N	238141	0	397881000	4266809		0
50232	2969	40481087	1997-08-05	1997-08-05 00:00:00	1997-08-26	1997-08-26 00:00:00	32020		\N	198249	0	444814009	40481087		0
60979	3610	40481087	1991-08-30	1991-08-30 00:00:00	1991-09-13	1991-09-13 00:00:00	32020		\N	239811	0	444814009	40481087		0
50611	2992	40481087	2008-08-15	2008-08-15 00:00:00	2008-08-29	2008-08-29 00:00:00	32020		\N	199744	0	444814009	40481087		0
50784	3004	28060	1957-08-01	1957-08-01 00:00:00	1957-08-14	1957-08-14 00:00:00	32020		\N	200463	0	43878008	28060		0
50939	3014	40481087	1982-12-18	1982-12-18 00:00:00	1983-01-08	1983-01-08 00:00:00	32020		\N	201016	0	444814009	40481087		0
51038	3022	81151	1991-12-04	1991-12-04 00:00:00	1991-12-25	1991-12-25 00:00:00	32020		\N	201468	0	44465007	81151		0
61842	3651	260139	1992-01-07	1992-01-07 00:00:00	1992-01-21	1992-01-21 00:00:00	32020		\N	243051	0	10509002	260139		0
61964	3658	260139	2017-01-17	2017-01-17 00:00:00	2017-01-31	2017-01-31 00:00:00	32020		\N	243459	0	10509002	260139		0
51594	3060	40481087	1984-04-04	1984-04-04 00:00:00	1984-04-18	1984-04-18 00:00:00	32020		\N	203611	0	444814009	40481087		0
62379	3686	40481087	2012-05-03	2012-05-03 00:00:00	2012-05-10	2012-05-10 00:00:00	32020		\N	245037	0	444814009	40481087		0
62432	3689	40481087	1984-08-06	1984-08-06 00:00:00	1984-08-27	1984-08-27 00:00:00	32020		\N	245230	0	444814009	40481087		0
52101	3084	4112343	2010-01-17	2010-01-17 00:00:00	2010-01-28	2010-01-28 00:00:00	32020		\N	205399	0	195662009	4112343		0
62766	3707	40481087	2014-03-07	2014-03-07 00:00:00	2014-03-21	2014-03-21 00:00:00	32020		\N	246438	0	444814009	40481087		0
52406	3105	4112343	2001-07-15	2001-07-15 00:00:00	2001-07-24	2001-07-24 00:00:00	32020		\N	206490	0	195662009	4112343		0
63207	3733	372328	1976-09-06	1976-09-06 00:00:00	1976-10-19	1976-10-19 00:00:00	32020		\N	248027	0	65363002	372328		0
63349	3742	260139	1993-09-14	1993-09-14 00:00:00	1993-09-28	1993-09-28 00:00:00	32020		\N	248640	0	10509002	260139		0
63489	3750	28060	2001-10-16	2001-10-16 00:00:00	2001-10-25	2001-10-25 00:00:00	32020		\N	249228	0	43878008	28060		0
63671	3759	81151	2008-12-21	2008-12-21 00:00:00	2009-01-25	2009-01-25 00:00:00	32020		\N	249880	0	44465007	81151		0
53127	3147	378001	1990-01-21	1990-01-21 00:00:00	1990-02-20	1990-02-20 00:00:00	32020		\N	209427	0	62106007	378001		0
53370	3161	40481087	2011-04-24	2011-04-24 00:00:00	2011-05-08	2011-05-08 00:00:00	32020		\N	210245	0	444814009	40481087		0
53520	3172	40479768	1999-01-09	1999-01-09 00:00:00	1999-02-15	1999-02-15 00:00:00	32020		\N	210821	0	444470001	40479768		0
53626	3177	40480160	2002-07-19	2002-07-19 00:00:00	2002-08-18	2002-08-18 00:00:00	32020		\N	211349	0	443165006	40480160		0
43263	2577	4027663	2003-05-05	2003-05-05 00:00:00	\N	\N	32020		\N	170667	0	13200003	4027663		0
53991	3196	260139	1984-12-18	1984-12-18 00:00:00	1984-12-25	1984-12-25 00:00:00	32020		\N	212612	0	10509002	260139		0
43590	2596	4112343	1990-04-12	1990-04-12 00:00:00	1990-04-22	1990-04-22 00:00:00	32020		\N	171777	0	195662009	4112343		0
54290	3216	40481087	2017-11-17	2017-11-17 00:00:00	2017-12-01	2017-12-01 00:00:00	32020		\N	213734	0	444814009	40481087		0
43953	2616	4294548	1996-01-07	1996-01-07 00:00:00	1996-03-31	1996-03-31 00:00:00	32020		\N	173025	0	75498004	4294548		0
54619	3234	260139	2005-10-27	2005-10-27 00:00:00	2005-11-02	2005-11-02 00:00:00	32020		\N	214973	0	10509002	260139		0
54785	3241	40481087	2006-05-25	2006-05-25 00:00:00	2006-06-15	2006-06-15 00:00:00	32020		\N	215502	0	444814009	40481087		0
55031	3258	28060	2010-09-15	2010-09-15 00:00:00	2010-09-28	2010-09-28 00:00:00	32020		\N	216614	0	43878008	28060		0
55226	3270	4027663	1996-03-19	1996-03-19 00:00:00	\N	\N	32020		\N	217351	0	13200003	4027663		0
55299	3275	40481087	1977-03-14	1977-03-14 00:00:00	1977-04-04	1977-04-04 00:00:00	32020		\N	217630	0	444814009	40481087		0
55451	3285	4283893	2010-06-19	2010-06-19 00:00:00	2010-11-06	2010-11-06 00:00:00	32020		\N	218215	0	36971009	4283893		0
55654	3295	4112343	1981-11-04	1981-11-04 00:00:00	1981-11-16	1981-11-16 00:00:00	32020		\N	218927	0	195662009	4112343		0
45236	2690	28060	1961-11-06	1961-11-06 00:00:00	1961-11-14	1961-11-14 00:00:00	32020		\N	178207	0	43878008	28060		0
56007	3315	4283893	2015-03-31	2015-03-31 00:00:00	2015-04-14	2015-04-14 00:00:00	32020		\N	220171	0	36971009	4283893		0
56144	3325	4112343	2005-07-26	2005-07-26 00:00:00	2005-08-06	2005-08-06 00:00:00	32020		\N	220729	0	195662009	4112343		0
56325	3339	4059173	1999-04-05	1999-04-05 00:00:00	1999-07-04	1999-07-04 00:00:00	32020		\N	221541	0	16114001	4059173		0
56454	3347	40481087	2001-04-20	2001-04-20 00:00:00	2001-05-11	2001-05-11 00:00:00	32020		\N	222081	0	444814009	40481087		0
56727	3364	134438	2000-06-25	2000-06-25 00:00:00	2001-07-21	2001-07-21 00:00:00	32020		\N	223088	0	40275004	134438		0
56802	3370	40481087	1975-02-18	1975-02-18 00:00:00	1975-02-25	1975-02-25 00:00:00	32020		\N	223467	0	444814009	40481087		0
46456	2767	4218389	1973-02-23	1973-02-23 00:00:00	1973-03-23	1973-03-23 00:00:00	32020		\N	183065	0	39848009	4218389		0
46572	2771	40481087	1956-04-22	1956-04-22 00:00:00	1956-05-13	1956-05-13 00:00:00	32020		\N	183487	0	444814009	40481087		0
46798	2782	81893	1953-09-06	1953-09-06 00:00:00	\N	\N	32020		\N	184419	0	64766004	81893		0
57446	3409	372328	1968-05-06	1968-05-06 00:00:00	1968-05-20	1968-05-20 00:00:00	32020		\N	226126	0	65363002	372328		0
57634	3418	4109685	2005-11-20	2005-11-20 00:00:00	2005-12-04	2005-12-04 00:00:00	32020		\N	226756	0	284551006	4109685		0
57796	3428	4112343	2009-10-15	2009-10-15 00:00:00	2009-10-28	2009-10-28 00:00:00	32020		\N	227252	0	195662009	4112343		0
57950	3436	4112343	1975-03-16	1975-03-16 00:00:00	1975-03-24	1975-03-24 00:00:00	32020		\N	227859	0	195662009	4112343		0
58102	3442	81151	2011-07-15	2011-07-15 00:00:00	2011-08-19	2011-08-19 00:00:00	32020		\N	228418	0	44465007	81151		0
47729	2835	4237458	2012-01-31	2012-01-31 00:00:00	2012-03-31	2012-03-31 00:00:00	32020		\N	188346	0	58150001	4237458		0
47922	2844	81893	1990-11-23	1990-11-23 00:00:00	\N	\N	32020		\N	188860	0	64766004	81893		0
58710	3483	28060	1963-11-29	1963-11-29 00:00:00	1963-12-07	1963-12-07 00:00:00	32020		\N	231077	0	43878008	28060		0
48224	2859	40481087	1949-08-10	1949-08-10 00:00:00	1949-08-24	1949-08-24 00:00:00	32020		\N	190031	0	444814009	40481087		0
48381	2865	378001	2003-03-31	2003-03-31 00:00:00	2003-04-30	2003-04-30 00:00:00	32020		\N	190572	0	62106007	378001		0
59187	3510	4112343	1974-10-30	1974-10-30 00:00:00	1974-11-10	1974-11-10 00:00:00	32020		\N	232902	0	195662009	4112343		0
59354	3518	4112343	1984-03-20	1984-03-20 00:00:00	1984-03-31	1984-03-31 00:00:00	32020		\N	233594	0	195662009	4112343		0
48937	2897	4109685	1968-12-19	1968-12-19 00:00:00	1969-01-02	1969-01-02 00:00:00	32020		\N	192940	0	284551006	4109685		0
59658	3536	4112343	2017-10-16	2017-10-16 00:00:00	2017-10-26	2017-10-26 00:00:00	32020		\N	234860	0	195662009	4112343		0
59833	3545	4112343	1991-02-19	1991-02-19 00:00:00	1991-03-02	1991-03-02 00:00:00	32020		\N	235447	0	195662009	4112343		0
59971	3553	4112343	1983-08-08	1983-08-08 00:00:00	1983-08-18	1983-08-18 00:00:00	32020		\N	235892	0	195662009	4112343		0
60116	3561	260139	2002-06-13	2002-06-13 00:00:00	2002-06-27	2002-06-27 00:00:00	32020		\N	236519	0	10509002	260139		0
60286	3568	78272	1984-03-16	1984-03-16 00:00:00	1984-04-06	1984-04-06 00:00:00	32020		\N	237102	0	70704007	78272		0
49890	2949	80180	1986-04-02	1986-04-02 00:00:00	\N	\N	32020		\N	196836	0	396275006	80180		0
60595	3582	40481087	2001-05-15	2001-05-15 00:00:00	2001-06-05	2001-06-05 00:00:00	32020		\N	238141	0	444814009	40481087		0
50233	2969	81151	2007-01-24	2007-01-24 00:00:00	2007-02-28	2007-02-28 00:00:00	32020		\N	198213	0	44465007	81151		0
60980	3610	40481087	2001-12-18	2001-12-18 00:00:00	2002-01-08	2002-01-08 00:00:00	32020		\N	239812	0	444814009	40481087		0
50612	2993	40481087	2002-09-16	2002-09-16 00:00:00	2002-09-30	2002-09-30 00:00:00	32020		\N	199796	0	444814009	40481087		0
50785	3004	372328	1951-01-01	1951-01-01 00:00:00	1951-03-13	1951-03-13 00:00:00	32020		\N	200471	0	65363002	372328		0
50940	3014	40481087	2005-09-24	2005-09-24 00:00:00	2005-10-01	2005-10-01 00:00:00	32020		\N	200996	0	444814009	40481087		0
51039	3022	260139	2003-02-08	2003-02-08 00:00:00	2003-02-15	2003-02-15 00:00:00	32020		\N	201454	0	10509002	260139		0
61843	3651	4112343	1979-08-15	1979-08-15 00:00:00	1979-08-23	1979-08-23 00:00:00	32020		\N	243068	0	195662009	4112343		0
61965	3658	4156265	2005-05-17	2005-05-17 00:00:00	2005-05-31	2005-05-31 00:00:00	32020		\N	243508	0	370247008	4156265		0
51595	3060	30753	1960-08-12	1960-08-12 00:00:00	\N	\N	32020		\N	203620	0	16761005	30753		0
62380	3686	28060	1980-01-17	1980-01-17 00:00:00	1980-01-26	1980-01-26 00:00:00	32020		\N	245066	0	43878008	28060		0
62433	3689	4112343	1987-12-07	1987-12-07 00:00:00	1987-12-20	1987-12-20 00:00:00	32020		\N	245235	0	195662009	4112343		0
52102	3084	4112343	1995-03-13	1995-03-13 00:00:00	1995-03-25	1995-03-25 00:00:00	32020		\N	205367	0	195662009	4112343		0
62767	3707	260139	1986-10-08	1986-10-08 00:00:00	1986-10-15	1986-10-15 00:00:00	32020		\N	246460	0	10509002	260139		0
52407	3105	4112343	2018-03-31	2018-03-31 00:00:00	2018-04-08	2018-04-08 00:00:00	32020		\N	206502	0	195662009	4112343		0
63208	3733	134438	1997-11-12	1997-11-12 00:00:00	1998-11-07	1998-11-07 00:00:00	32020		\N	248043	0	40275004	134438		0
63350	3742	40481087	1996-09-01	1996-09-01 00:00:00	1996-09-22	1996-09-22 00:00:00	32020		\N	248681	0	444814009	40481087		0
63490	3750	80180	1993-11-10	1993-11-10 00:00:00	\N	\N	32020		\N	249236	0	396275006	80180		0
63672	3759	4266809	2009-03-16	2009-03-16 00:00:00	\N	\N	32020		\N	249880	0	397881000	4266809		0
53128	3147	257012	2017-06-14	2017-06-14 00:00:00	\N	\N	32020		\N	209340	0	40055000	257012		0
53371	3161	40481087	2016-11-13	2016-11-13 00:00:00	2016-11-27	2016-11-27 00:00:00	32020		\N	210215	0	444814009	40481087		0
53521	3172	4237458	2004-09-16	2004-09-16 00:00:00	2004-11-15	2004-11-15 00:00:00	32020		\N	210822	0	58150001	4237458		0
53627	3177	4112343	2006-02-24	2006-02-24 00:00:00	2006-03-05	2006-03-05 00:00:00	32020		\N	211346	0	195662009	4112343		0
43264	2577	372328	1976-08-24	1976-08-24 00:00:00	1977-01-22	1977-01-22 00:00:00	32020		\N	170707	0	65363002	372328		0
53992	3196	372328	1972-08-24	1972-08-24 00:00:00	1972-09-07	1972-09-07 00:00:00	32020		\N	212622	0	65363002	372328		0
43591	2596	260139	1967-10-25	1967-10-25 00:00:00	1967-11-08	1967-11-08 00:00:00	32020		\N	171767	0	10509002	260139		0
54291	3216	4059173	1958-06-01	1958-06-01 00:00:00	1958-07-31	1958-07-31 00:00:00	32020		\N	213705	0	16114001	4059173		0
43954	2616	81151	2017-04-01	2017-04-01 00:00:00	2017-04-29	2017-04-29 00:00:00	32020		\N	172966	0	44465007	81151		0
54621	3234	4329847	2010-01-18	2010-01-18 00:00:00	\N	\N	32020		\N	214997	0	22298006	4329847		0
54786	3241	40481087	1986-09-30	1986-09-30 00:00:00	1986-10-21	1986-10-21 00:00:00	32020		\N	215477	0	444814009	40481087		0
55032	3258	372328	1983-03-25	1983-03-25 00:00:00	1983-05-11	1983-05-11 00:00:00	32020		\N	216615	0	65363002	372328		0
55227	3270	4218389	1995-06-13	1995-06-13 00:00:00	1995-07-18	1995-07-18 00:00:00	32020		\N	217351	0	39848009	4218389		0
55300	3275	4112343	1967-08-18	1967-08-18 00:00:00	1967-08-26	1967-08-26 00:00:00	32020		\N	217627	0	195662009	4112343		0
55452	3285	260139	1996-02-26	1996-02-26 00:00:00	1996-03-11	1996-03-11 00:00:00	32020		\N	218231	0	10509002	260139		0
55655	3295	372328	1944-03-31	1944-03-31 00:00:00	1944-04-14	1944-04-14 00:00:00	32020		\N	218975	0	65363002	372328		0
45237	2690	40481087	1971-11-08	1971-11-08 00:00:00	1971-11-29	1971-11-29 00:00:00	32020		\N	178239	0	444814009	40481087		0
56008	3315	260139	1962-10-30	1962-10-30 00:00:00	1962-11-13	1962-11-13 00:00:00	32020		\N	220167	0	10509002	260139		0
56145	3325	40481087	2002-01-17	2002-01-17 00:00:00	2002-02-07	2002-02-07 00:00:00	32020		\N	220714	0	444814009	40481087		0
56326	3339	80180	1995-11-23	1995-11-23 00:00:00	\N	\N	32020		\N	221511	0	396275006	80180		0
56455	3347	4294548	1956-12-07	1956-12-07 00:00:00	1957-01-25	1957-01-25 00:00:00	32020		\N	222015	0	75498004	4294548		0
56728	3364	4296204	1986-06-02	1986-06-02 00:00:00	1986-06-16	1986-06-16 00:00:00	32020		\N	223106	0	403190006	4296204		0
56803	3370	260139	2003-05-17	2003-05-17 00:00:00	2003-05-31	2003-05-31 00:00:00	32020		\N	223403	0	10509002	260139		0
46457	2767	4156265	2004-01-17	2004-01-17 00:00:00	2004-01-31	2004-01-31 00:00:00	32020		\N	183067	0	370247008	4156265		0
46573	2771	4112343	1995-09-15	1995-09-15 00:00:00	1995-09-22	1995-09-22 00:00:00	32020		\N	183459	0	195662009	4112343		0
46799	2782	4112343	1953-02-07	1953-02-07 00:00:00	1953-02-16	1953-02-16 00:00:00	32020		\N	184419	0	195662009	4112343		0
57447	3409	78272	1966-11-15	1966-11-15 00:00:00	1966-12-06	1966-12-06 00:00:00	32020		\N	226120	0	70704007	78272		0
57635	3418	40481087	1965-03-29	1965-03-29 00:00:00	1965-04-19	1965-04-19 00:00:00	32020		\N	226714	0	444814009	40481087		0
57797	3428	40481087	1966-10-28	1966-10-28 00:00:00	1966-11-04	1966-11-04 00:00:00	32020		\N	227285	0	444814009	40481087		0
57951	3437	260139	1976-12-28	1976-12-28 00:00:00	1977-01-04	1977-01-04 00:00:00	32020		\N	227969	0	10509002	260139		0
58103	3442	260139	1974-12-05	1974-12-05 00:00:00	1974-12-19	1974-12-19 00:00:00	32020		\N	228447	0	10509002	260139		0
47730	2835	40481087	1919-08-17	1919-08-17 00:00:00	1919-08-24	1919-08-24 00:00:00	32020		\N	188232	0	444814009	40481087		0
47923	2844	4266809	1992-01-17	1992-01-17 00:00:00	\N	\N	32020		\N	188860	0	397881000	4266809		0
58711	3483	40481087	1999-05-15	1999-05-15 00:00:00	1999-06-05	1999-06-05 00:00:00	32020		\N	231040	0	444814009	40481087		0
48225	2859	372328	1955-12-25	1955-12-25 00:00:00	1956-06-25	1956-06-25 00:00:00	32020		\N	189967	0	65363002	372328		0
48382	2865	40481087	1987-07-17	1987-07-17 00:00:00	1987-08-07	1987-08-07 00:00:00	32020		\N	190624	0	444814009	40481087		0
59188	3510	40481087	1987-04-19	1987-04-19 00:00:00	1987-04-26	1987-04-26 00:00:00	32020		\N	232860	0	444814009	40481087		0
59355	3518	4112343	1983-02-12	1983-02-12 00:00:00	1983-02-21	1983-02-21 00:00:00	32020		\N	233593	0	195662009	4112343		0
48938	2897	4218389	1983-07-28	1983-07-28 00:00:00	1983-08-25	1983-08-25 00:00:00	32020		\N	192943	0	39848009	4218389		0
59659	3536	4112343	1996-06-23	1996-06-23 00:00:00	1996-07-06	1996-07-06 00:00:00	32020		\N	234815	0	195662009	4112343		0
59834	3545	260139	1997-02-11	1997-02-11 00:00:00	1997-02-18	1997-02-18 00:00:00	32020		\N	235497	0	10509002	260139		0
59972	3553	4310024	1965-03-29	1965-03-29 00:00:00	\N	\N	32020		\N	235943	0	424802006	4310024		0
60117	3561	40481087	2007-03-15	2007-03-15 00:00:00	2007-03-22	2007-03-22 00:00:00	32020		\N	236561	0	444814009	40481087		0
60287	3568	4230399	2002-07-31	2002-07-31 00:00:00	2002-08-30	2002-08-30 00:00:00	32020		\N	237070	0	359817006	4230399		0
49891	2949	28060	1970-09-11	1970-09-11 00:00:00	1970-09-24	1970-09-24 00:00:00	32020		\N	196839	0	43878008	28060		0
60596	3582	80180	2001-07-30	2001-07-30 00:00:00	\N	\N	32020		\N	238141	0	396275006	80180		0
50234	2969	260139	1982-04-24	1982-04-24 00:00:00	1982-05-01	1982-05-01 00:00:00	32020		\N	198202	0	10509002	260139		0
60981	3610	80180	1985-02-10	1985-02-10 00:00:00	\N	\N	32020		\N	239880	0	396275006	80180		0
50613	2993	4155034	1989-02-03	1989-02-03 00:00:00	1989-02-24	1989-02-24 00:00:00	32020		\N	199828	0	283371005	4155034		0
50786	3004	260139	2018-04-04	2018-04-04 00:00:00	2018-04-11	2018-04-11 00:00:00	32020		\N	200470	0	10509002	260139		0
50941	3014	372328	1974-04-26	1974-04-26 00:00:00	1974-06-08	1974-06-08 00:00:00	32020		\N	200989	0	65363002	372328		0
51040	3022	40481087	2016-06-16	2016-06-16 00:00:00	2016-06-30	2016-06-30 00:00:00	32020		\N	201493	0	444814009	40481087		0
61844	3651	260139	2009-10-03	2009-10-03 00:00:00	2009-10-10	2009-10-10 00:00:00	32020		\N	243069	0	10509002	260139		0
61966	3658	4112343	1969-05-07	1969-05-07 00:00:00	1969-05-14	1969-05-14 00:00:00	32020		\N	243496	0	195662009	4112343		0
51596	3060	4310024	1959-07-19	1959-07-19 00:00:00	\N	\N	32020		\N	203620	0	424802006	4310024		0
62381	3686	78272	2000-12-26	2000-12-26 00:00:00	2001-01-23	2001-01-23 00:00:00	32020		\N	245053	0	70704007	78272		0
62434	3689	40481087	2011-08-23	2011-08-23 00:00:00	2011-08-30	2011-08-30 00:00:00	32020		\N	245237	0	444814009	40481087		0
52103	3084	40481087	1996-12-06	1996-12-06 00:00:00	1996-12-20	1996-12-20 00:00:00	32020		\N	205382	0	444814009	40481087		0
62768	3707	40481087	2003-12-24	2003-12-24 00:00:00	2003-12-31	2003-12-31 00:00:00	32020		\N	246408	0	444814009	40481087		0
52408	3105	4218389	1970-11-22	1970-11-22 00:00:00	1970-12-20	1970-12-20 00:00:00	32020		\N	206480	0	39848009	4218389		0
63209	3733	260139	2003-04-10	2003-04-10 00:00:00	2003-04-24	2003-04-24 00:00:00	32020		\N	248058	0	10509002	260139		0
63351	3742	80180	2010-09-18	2010-09-18 00:00:00	\N	\N	32020		\N	248656	0	396275006	80180		0
63491	3750	4285898	1993-10-11	1993-10-11 00:00:00	\N	\N	32020		\N	249236	0	68496003	4285898		0
63673	3759	80180	2009-03-16	2009-03-16 00:00:00	\N	\N	32020		\N	249880	0	396275006	80180		0
53129	3147	40481087	1977-02-10	1977-02-10 00:00:00	1977-02-17	1977-02-17 00:00:00	32020		\N	209392	0	444814009	40481087		0
53372	3161	80180	1989-10-23	1989-10-23 00:00:00	\N	\N	32020		\N	210234	0	396275006	80180		0
53522	3172	40481087	2000-02-11	2000-02-11 00:00:00	2000-03-03	2000-03-03 00:00:00	32020		\N	210861	0	444814009	40481087		0
53628	3177	372328	1917-03-16	1917-03-16 00:00:00	1917-06-27	1917-06-27 00:00:00	32020		\N	211333	0	65363002	372328		0
43265	2577	4112343	1976-12-19	1976-12-19 00:00:00	1976-12-26	1976-12-26 00:00:00	32020		\N	170604	0	195662009	4112343		0
53993	3196	260139	1995-10-31	1995-10-31 00:00:00	1995-11-07	1995-11-07 00:00:00	32020		\N	212629	0	10509002	260139		0
43592	2596	4027663	1994-10-22	1994-10-22 00:00:00	\N	\N	32020		\N	171744	0	13200003	4027663		0
54292	3216	4113008	1961-08-14	1961-08-14 00:00:00	1961-09-04	1961-09-04 00:00:00	32020		\N	213706	0	284549007	4113008		0
43955	2616	40481087	2008-12-21	2008-12-21 00:00:00	2009-01-11	2009-01-11 00:00:00	32020		\N	172979	0	444814009	40481087		0
54622	3234	40481087	2000-03-11	2000-03-11 00:00:00	2000-03-18	2000-03-18 00:00:00	32020		\N	214928	0	444814009	40481087		0
54787	3241	260139	2003-10-11	2003-10-11 00:00:00	2003-10-25	2003-10-25 00:00:00	32020		\N	215556	0	10509002	260139		0
55033	3258	4278672	1994-06-14	1994-06-14 00:00:00	1994-08-13	1994-08-13 00:00:00	32020		\N	216550	0	65966004	4278672		0
55228	3270	40481087	1990-10-13	1990-10-13 00:00:00	1990-10-20	1990-10-20 00:00:00	32020		\N	217330	0	444814009	40481087		0
55301	3275	40481087	1981-09-02	1981-09-02 00:00:00	1981-09-16	1981-09-16 00:00:00	32020		\N	217647	0	444814009	40481087		0
55453	3285	40481087	1978-11-21	1978-11-21 00:00:00	1978-11-28	1978-11-28 00:00:00	32020		\N	218220	0	444814009	40481087		0
55656	3295	4134304	2009-02-23	2009-02-23 00:00:00	2009-03-25	2009-03-25 00:00:00	32020		\N	218897	0	263102004	4134304		0
45238	2690	260139	1956-11-19	1956-11-19 00:00:00	1956-11-26	1956-11-26 00:00:00	32020		\N	178228	0	10509002	260139		0
56009	3315	195588	2004-04-15	2004-04-15 00:00:00	2004-05-22	2004-05-22 00:00:00	32020		\N	220144	0	38822007	195588		0
56146	3325	4283893	1973-12-27	1973-12-27 00:00:00	1974-02-14	1974-02-14 00:00:00	32020		\N	220712	0	36971009	4283893		0
56327	3339	40481087	1971-01-19	1971-01-19 00:00:00	1971-02-02	1971-02-02 00:00:00	32020		\N	221476	0	444814009	40481087		0
56456	3347	80180	1992-06-19	1992-06-19 00:00:00	\N	\N	32020		\N	222095	0	396275006	80180		0
56729	3364	4230399	1994-12-01	1994-12-01 00:00:00	1995-03-01	1995-03-01 00:00:00	32020		\N	223107	0	359817006	4230399		0
56804	3370	81151	1974-06-16	1974-06-16 00:00:00	1974-06-30	1974-06-30 00:00:00	32020		\N	223390	0	44465007	81151		0
46458	2767	4149245	1975-01-12	1975-01-12 00:00:00	1975-02-18	1975-02-18 00:00:00	32020		\N	183066	0	30832001	4149245		0
46574	2771	81151	1940-03-08	1940-03-08 00:00:00	1940-03-29	1940-03-29 00:00:00	32020		\N	183468	0	44465007	81151		0
57448	3409	40481087	2018-09-28	2018-09-28 00:00:00	2018-10-19	2018-10-19 00:00:00	32020		\N	226061	0	444814009	40481087		0
57636	3418	28060	1990-06-14	1990-06-14 00:00:00	1990-06-25	1990-06-25 00:00:00	32020		\N	226752	0	43878008	28060		0
57802	3430	80180	2003-06-20	2003-06-20 00:00:00	\N	\N	32020		\N	227335	0	396275006	80180		0
57952	3437	40481087	1970-10-26	1970-10-26 00:00:00	1970-11-09	1970-11-09 00:00:00	32020		\N	228031	0	444814009	40481087		0
58104	3442	40481087	2018-03-04	2018-03-04 00:00:00	2018-03-11	2018-03-11 00:00:00	32020		\N	228413	0	444814009	40481087		0
47731	2835	260139	1966-05-12	1966-05-12 00:00:00	1966-05-19	1966-05-19 00:00:00	32020		\N	188260	0	10509002	260139		0
47924	2845	260139	1965-08-11	1965-08-11 00:00:00	1965-08-25	1965-08-25 00:00:00	32020		\N	188900	0	10509002	260139		0
58712	3483	40481087	2016-02-03	2016-02-03 00:00:00	2016-02-17	2016-02-17 00:00:00	32020		\N	231044	0	444814009	40481087		0
48226	2859	4112343	2014-02-03	2014-02-03 00:00:00	2014-02-11	2014-02-11 00:00:00	32020		\N	189966	0	195662009	4112343		0
48383	2865	372328	1970-06-17	1970-06-17 00:00:00	1970-07-01	1970-07-01 00:00:00	32020		\N	190579	0	65363002	372328		0
59189	3510	40481087	2008-07-21	2008-07-21 00:00:00	2008-08-04	2008-08-04 00:00:00	32020		\N	232933	0	444814009	40481087		0
59426	3526	257012	1961-12-12	1961-12-12 00:00:00	\N	\N	32020		\N	233990	0	40055000	257012		0
48939	2897	260139	1979-03-17	1979-03-17 00:00:00	1979-03-31	1979-03-31 00:00:00	32020		\N	192888	0	10509002	260139		0
59660	3536	4310024	1998-01-27	1998-01-27 00:00:00	\N	\N	32020		\N	234815	0	424802006	4310024		0
59835	3545	4230399	1983-05-29	1983-05-29 00:00:00	1983-08-27	1983-08-27 00:00:00	32020		\N	235438	0	359817006	4230399		0
59973	3553	4112343	1952-02-07	1952-02-07 00:00:00	1952-02-19	1952-02-19 00:00:00	32020		\N	235874	0	195662009	4112343		0
60118	3561	4112343	1948-09-24	1948-09-24 00:00:00	1948-10-07	1948-10-07 00:00:00	32020		\N	236508	0	195662009	4112343		0
60288	3568	40481087	1997-09-21	1997-09-21 00:00:00	1997-10-05	1997-10-05 00:00:00	32020		\N	237106	0	444814009	40481087		0
49892	2949	372328	1950-10-23	1950-10-23 00:00:00	1951-01-02	1951-01-02 00:00:00	32020		\N	196870	0	65363002	372328		0
60597	3582	40481087	1970-09-10	1970-09-10 00:00:00	1970-10-01	1970-10-01 00:00:00	32020		\N	238150	0	444814009	40481087		0
50235	2969	40481087	2002-06-10	2002-06-10 00:00:00	2002-06-24	2002-06-24 00:00:00	32020		\N	198204	0	444814009	40481087		0
60982	3610	4112343	2003-07-05	2003-07-05 00:00:00	2003-07-13	2003-07-13 00:00:00	32020		\N	239865	0	195662009	4112343		0
50614	2993	40481087	1974-11-25	1974-11-25 00:00:00	1974-12-09	1974-12-09 00:00:00	32020		\N	199786	0	444814009	40481087		0
50787	3004	40481087	1982-05-17	1982-05-17 00:00:00	1982-06-07	1982-06-07 00:00:00	32020		\N	200467	0	444814009	40481087		0
50942	3014	378001	1989-01-11	1989-01-11 00:00:00	1989-02-10	1989-02-10 00:00:00	32020		\N	201000	0	62106007	378001		0
51041	3022	257012	1982-03-13	1982-03-13 00:00:00	\N	\N	32020		\N	201479	0	40055000	257012		0
61845	3651	40481087	1977-03-27	1977-03-27 00:00:00	1977-04-17	1977-04-17 00:00:00	32020		\N	243067	0	444814009	40481087		0
61967	3658	4112343	1986-08-16	1986-08-16 00:00:00	1986-08-28	1986-08-28 00:00:00	32020		\N	243480	0	195662009	4112343		0
51597	3060	4266809	1961-02-08	1961-02-08 00:00:00	\N	\N	32020		\N	203620	0	397881000	4266809		0
62382	3686	40481087	2009-07-29	2009-07-29 00:00:00	2009-08-12	2009-08-12 00:00:00	32020		\N	245027	0	444814009	40481087		0
62435	3689	313217	2011-04-04	2011-04-04 00:00:00	\N	\N	32020		\N	245243	0	49436004	313217		0
52104	3084	40481087	2005-04-12	2005-04-12 00:00:00	2005-04-26	2005-04-26 00:00:00	32020		\N	205397	0	444814009	40481087		0
62769	3707	40481087	2013-03-27	2013-03-27 00:00:00	2013-04-03	2013-04-03 00:00:00	32020		\N	246464	0	444814009	40481087		0
52409	3105	260139	2007-09-10	2007-09-10 00:00:00	2007-09-17	2007-09-17 00:00:00	32020		\N	206508	0	10509002	260139		0
63210	3733	375671	2011-10-08	2011-10-08 00:00:00	2011-12-07	2011-12-07 00:00:00	32020		\N	248042	0	62564004	375671		0
63352	3742	30753	2009-04-26	2009-04-26 00:00:00	\N	\N	32020		\N	248656	0	16761005	30753		0
63492	3750	30753	1993-09-11	1993-09-11 00:00:00	\N	\N	32020		\N	249236	0	16761005	30753		0
63674	3759	30753	2008-06-19	2008-06-19 00:00:00	\N	\N	32020		\N	249943	0	16761005	30753		0
53130	3147	375671	1969-09-10	1969-09-10 00:00:00	1969-10-10	1969-10-10 00:00:00	32020		\N	209353	0	62564004	375671		0
53373	3161	4237458	1979-11-09	1979-11-09 00:00:00	1980-01-08	1980-01-08 00:00:00	32020		\N	210204	0	58150001	4237458		0
53523	3172	40481087	1993-07-31	1993-07-31 00:00:00	1993-08-07	1993-08-07 00:00:00	32020		\N	210834	0	444814009	40481087		0
53629	3177	4112343	1949-04-21	1949-04-21 00:00:00	1949-05-02	1949-05-02 00:00:00	32020		\N	211354	0	195662009	4112343		0
43266	2577	260139	1988-09-21	1988-09-21 00:00:00	1988-10-05	1988-10-05 00:00:00	32020		\N	170650	0	10509002	260139		0
53994	3196	40481087	1990-10-19	1990-10-19 00:00:00	1990-11-09	1990-11-09 00:00:00	32020		\N	212628	0	444814009	40481087		0
43593	2596	40481087	1994-01-24	1994-01-24 00:00:00	1994-02-14	1994-02-14 00:00:00	32020		\N	171744	0	444814009	40481087		0
54293	3216	4112343	1994-11-20	1994-11-20 00:00:00	1994-11-28	1994-11-28 00:00:00	32020		\N	213732	0	195662009	4112343		0
43956	2616	260139	2018-12-10	2018-12-10 00:00:00	2018-12-24	2018-12-24 00:00:00	32020		\N	172980	0	10509002	260139		0
54623	3234	4112343	1975-11-12	1975-11-12 00:00:00	1975-11-23	1975-11-23 00:00:00	32020		\N	214924	0	195662009	4112343		0
54788	3241	4027663	1991-03-23	1991-03-23 00:00:00	\N	\N	32020		\N	215515	0	13200003	4027663		0
55034	3258	4112343	1992-01-04	1992-01-04 00:00:00	1992-01-12	1992-01-12 00:00:00	32020		\N	216553	0	195662009	4112343		0
55229	3270	40481087	2016-06-11	2016-06-11 00:00:00	2016-06-25	2016-06-25 00:00:00	32020		\N	217332	0	444814009	40481087		0
55306	3277	260139	1971-07-24	1971-07-24 00:00:00	1971-08-07	1971-08-07 00:00:00	32020		\N	217696	0	10509002	260139		0
55454	3285	4112343	1995-09-21	1995-09-21 00:00:00	1995-10-01	1995-10-01 00:00:00	32020		\N	218230	0	195662009	4112343		0
55657	3295	4112343	2005-03-03	2005-03-03 00:00:00	2005-03-16	2005-03-16 00:00:00	32020		\N	218931	0	195662009	4112343		0
45239	2690	28060	1992-01-24	1992-01-24 00:00:00	1992-02-06	1992-02-06 00:00:00	32020		\N	178241	0	43878008	28060		0
56010	3315	40481087	1981-04-24	1981-04-24 00:00:00	1981-05-01	1981-05-01 00:00:00	32020		\N	220169	0	444814009	40481087		0
56147	3325	4112343	1979-06-18	1979-06-18 00:00:00	1979-06-30	1979-06-30 00:00:00	32020		\N	220694	0	195662009	4112343		0
56328	3339	28060	1969-02-14	1969-02-14 00:00:00	1969-02-21	1969-02-21 00:00:00	32020		\N	221475	0	43878008	28060		0
56457	3347	260139	1982-02-18	1982-02-18 00:00:00	1982-02-25	1982-02-25 00:00:00	32020		\N	222068	0	10509002	260139		0
56730	3364	4112343	1980-03-06	1980-03-06 00:00:00	1980-03-19	1980-03-19 00:00:00	32020		\N	223039	0	195662009	4112343		0
56805	3370	40481087	2012-09-07	2012-09-07 00:00:00	2012-09-21	2012-09-21 00:00:00	32020		\N	223508	0	444814009	40481087		0
46459	2767	40481087	1964-04-17	1964-04-17 00:00:00	1964-05-08	1964-05-08 00:00:00	32020		\N	183050	0	444814009	40481087		0
46575	2771	313217	1978-01-20	1978-01-20 00:00:00	\N	\N	32020		\N	183520	0	49436004	313217		0
46801	2782	260139	1962-11-19	1962-11-19 00:00:00	1962-11-26	1962-11-26 00:00:00	32020		\N	184345	0	10509002	260139		0
57449	3409	4134304	1957-05-06	1957-05-06 00:00:00	1957-08-04	1957-08-04 00:00:00	32020		\N	226136	0	263102004	4134304		0
57637	3418	40481087	1998-10-20	1998-10-20 00:00:00	1998-11-10	1998-11-10 00:00:00	32020		\N	226718	0	444814009	40481087		0
57803	3430	40481087	2015-04-30	2015-04-30 00:00:00	2015-05-14	2015-05-14 00:00:00	32020		\N	227356	0	444814009	40481087		0
57953	3437	4112343	1965-09-05	1965-09-05 00:00:00	1965-09-15	1965-09-15 00:00:00	32020		\N	227987	0	195662009	4112343		0
58105	3442	260139	1965-03-19	1965-03-19 00:00:00	1965-03-26	1965-03-26 00:00:00	32020		\N	228397	0	10509002	260139		0
47732	2835	4296205	1983-01-28	1983-01-28 00:00:00	1983-02-11	1983-02-11 00:00:00	32020		\N	188342	0	403191005	4296205		0
47925	2845	4266809	1994-10-12	1994-10-12 00:00:00	\N	\N	32020		\N	188949	0	397881000	4266809		0
58713	3483	40481087	2010-09-09	2010-09-09 00:00:00	2010-09-23	2010-09-23 00:00:00	32020		\N	231042	0	444814009	40481087		0
48227	2859	260139	1944-01-08	1944-01-08 00:00:00	1944-01-15	1944-01-15 00:00:00	32020		\N	189962	0	10509002	260139		0
48384	2865	372328	2003-03-24	2003-03-24 00:00:00	2005-08-08	2005-08-08 00:00:00	32020		\N	190603	0	65363002	372328		0
59190	3510	4112343	1980-04-16	1980-04-16 00:00:00	1980-04-25	1980-04-25 00:00:00	32020		\N	232914	0	195662009	4112343		0
59427	3526	260139	1994-03-07	1994-03-07 00:00:00	1994-03-14	1994-03-14 00:00:00	32020		\N	233954	0	10509002	260139		0
48940	2897	260139	1985-12-30	1985-12-30 00:00:00	1986-01-13	1986-01-13 00:00:00	32020		\N	192938	0	10509002	260139		0
59661	3536	4116491	2009-12-11	2009-12-11 00:00:00	2010-01-20	2010-01-20 00:00:00	32020		\N	234856	0	301011002	4116491		0
59836	3545	40481087	1995-08-21	1995-08-21 00:00:00	1995-09-04	1995-09-04 00:00:00	32020		\N	235496	0	444814009	40481087		0
59974	3553	40481087	1976-08-12	1976-08-12 00:00:00	1976-08-26	1976-08-26 00:00:00	32020		\N	235907	0	444814009	40481087		0
60119	3561	260139	1925-02-12	1925-02-12 00:00:00	1925-02-19	1925-02-19 00:00:00	32020		\N	236498	0	10509002	260139		0
60289	3568	4112343	2000-09-01	2000-09-01 00:00:00	2000-09-08	2000-09-08 00:00:00	32020		\N	237107	0	195662009	4112343		0
49893	2949	40481087	1962-03-31	1962-03-31 00:00:00	1962-04-21	1962-04-21 00:00:00	32020		\N	196862	0	444814009	40481087		0
60598	3582	4112343	1983-04-08	1983-04-08 00:00:00	1983-04-18	1983-04-18 00:00:00	32020		\N	238168	0	195662009	4112343		0
50236	2969	81151	1977-09-18	1977-09-18 00:00:00	1977-10-16	1977-10-16 00:00:00	32020		\N	198245	0	44465007	81151		0
60983	3610	4112343	1978-10-19	1978-10-19 00:00:00	1978-10-30	1978-10-30 00:00:00	32020		\N	239888	0	195662009	4112343		0
50615	2993	261325	2004-08-28	2004-08-28 00:00:00	\N	\N	32020		\N	199774	0	87433001	261325		0
50788	3004	260139	2001-12-06	2001-12-06 00:00:00	2001-12-20	2001-12-20 00:00:00	32020		\N	200488	0	10509002	260139		0
50943	3014	4294548	1990-12-13	1990-12-13 00:00:00	1991-02-21	1991-02-21 00:00:00	32020		\N	201036	0	75498004	4294548		0
51042	3022	28060	1975-04-24	1975-04-24 00:00:00	1975-05-07	1975-05-07 00:00:00	32020		\N	201491	0	43878008	28060		0
61846	3651	40481087	1968-01-20	1968-01-20 00:00:00	1968-01-27	1968-01-27 00:00:00	32020		\N	243009	0	444814009	40481087		0
61968	3658	4112343	1968-09-25	1968-09-25 00:00:00	1968-10-07	1968-10-07 00:00:00	32020		\N	243457	0	195662009	4112343		0
51598	3060	80180	1961-02-08	1961-02-08 00:00:00	\N	\N	32020		\N	203620	0	396275006	80180		0
62383	3686	4266809	2009-10-30	2009-10-30 00:00:00	\N	\N	32020		\N	245027	0	397881000	4266809		0
62436	3689	4112343	2005-06-21	2005-06-21 00:00:00	2005-06-28	2005-06-28 00:00:00	32020		\N	245220	0	195662009	4112343		0
52105	3084	40481087	1980-01-21	1980-01-21 00:00:00	1980-02-11	1980-02-11 00:00:00	32020		\N	205395	0	444814009	40481087		0
62770	3707	40481087	2012-06-30	2012-06-30 00:00:00	2012-07-21	2012-07-21 00:00:00	32020		\N	246463	0	444814009	40481087		0
52410	3105	4155034	2004-07-15	2004-07-15 00:00:00	2004-08-05	2004-08-05 00:00:00	32020		\N	206482	0	283371005	4155034		0
63211	3733	372328	1979-05-07	1979-05-07 00:00:00	1979-10-16	1979-10-16 00:00:00	32020		\N	248076	0	65363002	372328		0
63353	3742	260139	2003-03-27	2003-03-27 00:00:00	2003-04-10	2003-04-10 00:00:00	32020		\N	248635	0	10509002	260139		0
63493	3750	4266809	1993-11-10	1993-11-10 00:00:00	\N	\N	32020		\N	249236	0	397881000	4266809		0
63675	3759	4027663	1997-08-01	1997-08-01 00:00:00	\N	\N	32020		\N	249974	0	13200003	4027663		0
53131	3147	80180	1983-09-19	1983-09-19 00:00:00	\N	\N	32020		\N	209419	0	396275006	80180		0
53374	3161	4218389	1963-08-23	1963-08-23 00:00:00	1963-09-13	1963-09-13 00:00:00	32020		\N	210249	0	39848009	4218389		0
53524	3172	40481087	1978-07-19	1978-07-19 00:00:00	1978-08-02	1978-08-02 00:00:00	32020		\N	210867	0	444814009	40481087		0
53630	3177	40481087	1922-12-05	1922-12-05 00:00:00	1922-12-19	1922-12-19 00:00:00	32020		\N	211247	0	444814009	40481087		0
43267	2577	4112343	1975-07-03	1975-07-03 00:00:00	1975-07-15	1975-07-15 00:00:00	32020		\N	170613	0	195662009	4112343		0
53995	3196	260139	1978-04-27	1978-04-27 00:00:00	1978-05-04	1978-05-04 00:00:00	32020		\N	212597	0	10509002	260139		0
43594	2596	4155034	2018-03-28	2018-03-28 00:00:00	2018-04-11	2018-04-11 00:00:00	32020		\N	171766	0	283371005	4155034		0
54294	3216	4285898	1995-04-03	1995-04-03 00:00:00	\N	\N	32020		\N	213732	0	68496003	4285898		0
43957	2616	81151	1975-08-07	1975-08-07 00:00:00	1975-09-11	1975-09-11 00:00:00	32020		\N	172964	0	44465007	81151		0
54624	3234	4283893	2004-04-02	2004-04-02 00:00:00	2004-05-15	2004-05-15 00:00:00	32020		\N	214972	0	36971009	4283893		0
54789	3241	257012	2013-01-15	2013-01-15 00:00:00	\N	\N	32020		\N	215513	0	40055000	257012		0
55035	3258	80180	2019-01-15	2019-01-15 00:00:00	\N	\N	32020		\N	216612	0	396275006	80180		0
55230	3270	4112343	1984-01-24	1984-01-24 00:00:00	1984-02-05	1984-02-05 00:00:00	32020		\N	217252	0	195662009	4112343		0
55307	3277	40481087	1987-04-09	1987-04-09 00:00:00	1987-04-30	1987-04-30 00:00:00	32020		\N	217721	0	444814009	40481087		0
55455	3285	321042	2011-03-12	2011-03-12 00:00:00	\N	\N	32020		\N	218180	0	410429000	321042		0
55658	3295	4113008	1964-11-25	1964-11-25 00:00:00	1964-12-16	1964-12-16 00:00:00	32020		\N	218896	0	284549007	4113008		0
45240	2690	40481087	1952-12-10	1952-12-10 00:00:00	1952-12-24	1952-12-24 00:00:00	32020		\N	178193	0	444814009	40481087		0
56011	3315	4113008	1977-07-16	1977-07-16 00:00:00	1977-08-06	1977-08-06 00:00:00	32020		\N	220130	0	284549007	4113008		0
56148	3325	28060	1974-05-02	1974-05-02 00:00:00	1974-05-14	1974-05-14 00:00:00	32020		\N	220692	0	43878008	28060		0
56329	3339	4112343	2017-07-27	2017-07-27 00:00:00	2017-08-09	2017-08-09 00:00:00	32020		\N	221529	0	195662009	4112343		0
56458	3347	40479422	1993-10-22	1993-10-22 00:00:00	1993-11-28	1993-11-28 00:00:00	32020		\N	222019	0	444448004	40479422		0
56731	3364	4310024	2007-02-12	2007-02-12 00:00:00	\N	\N	32020		\N	223135	0	424802006	4310024		0
56806	3370	40481087	1998-08-08	1998-08-08 00:00:00	1998-08-22	1998-08-22 00:00:00	32020		\N	223482	0	444814009	40481087		0
46460	2767	80180	1970-10-17	1970-10-17 00:00:00	\N	\N	32020		\N	183109	0	396275006	80180		0
46576	2771	4094814	1914-07-23	1914-07-23 00:00:00	1914-10-21	1914-10-21 00:00:00	32020		\N	183467	0	262574004	4094814		0
57280	3399	4112343	1983-05-12	1983-05-12 00:00:00	1983-05-21	1983-05-21 00:00:00	32020		\N	225503	0	195662009	4112343		0
57450	3409	195588	2002-06-04	2002-06-04 00:00:00	2002-07-15	2002-07-15 00:00:00	32020		\N	226095	0	38822007	195588		0
57649	3420	4146173	1968-08-09	1968-08-09 00:00:00	1968-09-08	1968-09-08 00:00:00	32020		\N	226842	0	307731004	4146173		0
57804	3430	40481087	1973-09-24	1973-09-24 00:00:00	1973-10-01	1973-10-01 00:00:00	32020		\N	227353	0	444814009	40481087		0
57954	3437	28060	1916-05-09	1916-05-09 00:00:00	1916-05-16	1916-05-16 00:00:00	32020		\N	227980	0	43878008	28060		0
58106	3442	40481087	1966-08-09	1966-08-09 00:00:00	1966-08-30	1966-08-30 00:00:00	32020		\N	228444	0	444814009	40481087		0
47733	2835	40481087	2010-11-06	2010-11-06 00:00:00	2010-11-27	2010-11-27 00:00:00	32020		\N	188262	0	444814009	40481087		0
47926	2845	80180	1994-10-12	1994-10-12 00:00:00	\N	\N	32020		\N	188949	0	396275006	80180		0
58714	3483	260139	1965-10-20	1965-10-20 00:00:00	1965-10-27	1965-10-27 00:00:00	32020		\N	231059	0	10509002	260139		0
48228	2859	378001	1956-07-01	1956-07-01 00:00:00	1956-08-30	1956-08-30 00:00:00	32020		\N	190012	0	62106007	378001		0
48385	2866	4112343	2003-05-16	2003-05-16 00:00:00	2003-05-26	2003-05-26 00:00:00	32020		\N	190652	0	195662009	4112343		0
59191	3510	28060	1952-05-09	1952-05-09 00:00:00	1952-05-17	1952-05-17 00:00:00	32020		\N	232962	0	43878008	28060		0
59428	3526	4296204	2012-05-10	2012-05-10 00:00:00	2012-06-14	2012-06-14 00:00:00	32020		\N	233987	0	403190006	4296204		0
48941	2897	80180	2003-11-06	2003-11-06 00:00:00	\N	\N	32020		\N	192908	0	396275006	80180		0
59662	3536	4112343	2009-04-17	2009-04-17 00:00:00	2009-04-29	2009-04-29 00:00:00	32020		\N	234855	0	195662009	4112343		0
59837	3545	372328	1988-10-13	1988-10-13 00:00:00	1989-04-26	1989-04-26 00:00:00	32020		\N	235452	0	65363002	372328		0
59975	3553	40481087	1955-04-07	1955-04-07 00:00:00	1955-04-28	1955-04-28 00:00:00	32020		\N	235873	0	444814009	40481087		0
60120	3561	4112343	1972-02-04	1972-02-04 00:00:00	1972-02-15	1972-02-15 00:00:00	32020		\N	236517	0	195662009	4112343		0
60290	3568	80180	2012-12-04	2012-12-04 00:00:00	\N	\N	32020		\N	237086	0	396275006	80180		0
49894	2949	40481087	1981-08-10	1981-08-10 00:00:00	1981-08-31	1981-08-31 00:00:00	32020		\N	196866	0	444814009	40481087		0
60599	3582	40481087	2006-07-14	2006-07-14 00:00:00	2006-07-21	2006-07-21 00:00:00	32020		\N	238139	0	444814009	40481087		0
50237	2969	81151	1969-12-31	1969-12-31 00:00:00	1970-01-28	1970-01-28 00:00:00	32020		\N	198244	0	44465007	81151		0
60984	3610	4296205	2017-06-26	2017-06-26 00:00:00	2017-07-10	2017-07-10 00:00:00	32020		\N	239885	0	403191005	4296205		0
50616	2993	40481087	1974-06-16	1974-06-16 00:00:00	1974-06-23	1974-06-23 00:00:00	32020		\N	199777	0	444814009	40481087		0
50789	3004	4112343	1976-04-13	1976-04-13 00:00:00	1976-04-22	1976-04-22 00:00:00	32020		\N	200499	0	195662009	4112343		0
50944	3014	4283893	1995-11-01	1995-11-01 00:00:00	1995-12-06	1995-12-06 00:00:00	32020		\N	200995	0	36971009	4283893		0
51043	3022	81151	2011-11-08	2011-11-08 00:00:00	2011-11-22	2011-11-22 00:00:00	32020		\N	201470	0	44465007	81151		0
61847	3651	40481087	1969-07-28	1969-07-28 00:00:00	1969-08-11	1969-08-11 00:00:00	32020		\N	243065	0	444814009	40481087		0
61969	3658	4146173	1968-06-25	1968-06-25 00:00:00	1968-08-24	1968-08-24 00:00:00	32020		\N	243489	0	307731004	4146173		0
51599	3060	4112343	1934-10-07	1934-10-07 00:00:00	1934-10-20	1934-10-20 00:00:00	32020		\N	203605	0	195662009	4112343		0
62384	3686	260139	1991-11-29	1991-11-29 00:00:00	1991-12-06	1991-12-06 00:00:00	32020		\N	245085	0	10509002	260139		0
62437	3689	260139	2014-07-10	2014-07-10 00:00:00	2014-07-17	2014-07-17 00:00:00	32020		\N	245221	0	10509002	260139		0
52108	3086	260139	1987-01-30	1987-01-30 00:00:00	1987-02-06	1987-02-06 00:00:00	32020		\N	205468	0	10509002	260139		0
62771	3707	260139	2002-08-23	2002-08-23 00:00:00	2002-09-06	2002-09-06 00:00:00	32020		\N	246462	0	10509002	260139		0
52411	3105	372328	1971-12-17	1971-12-17 00:00:00	1971-12-31	1971-12-31 00:00:00	32020		\N	206493	0	65363002	372328		0
63212	3733	78272	1980-07-17	1980-07-17 00:00:00	1980-08-21	1980-08-21 00:00:00	32020		\N	248074	0	70704007	78272		0
63354	3742	28060	1984-08-04	1984-08-04 00:00:00	1984-08-11	1984-08-11 00:00:00	32020		\N	248667	0	43878008	28060		0
63494	3750	40481087	1972-11-23	1972-11-23 00:00:00	1972-11-30	1972-11-30 00:00:00	32020		\N	249243	0	444814009	40481087		0
63676	3759	4112343	1997-01-02	1997-01-02 00:00:00	1997-01-12	1997-01-12 00:00:00	32020		\N	249974	0	195662009	4112343		0
53132	3147	372328	1962-09-03	1962-09-03 00:00:00	1963-01-21	1963-01-21 00:00:00	32020		\N	209397	0	65363002	372328		0
53375	3161	372328	1967-05-11	1967-05-11 00:00:00	1967-06-28	1967-06-28 00:00:00	32020		\N	210254	0	65363002	372328		0
53525	3172	40481087	2009-12-23	2009-12-23 00:00:00	2010-01-13	2010-01-13 00:00:00	32020		\N	210837	0	444814009	40481087		0
53631	3177	4109685	1934-10-27	1934-10-27 00:00:00	1934-11-17	1934-11-17 00:00:00	32020		\N	211227	0	284551006	4109685		0
43268	2577	80180	2012-03-18	2012-03-18 00:00:00	\N	\N	32020		\N	170670	0	396275006	80180		0
53996	3196	260139	2004-01-19	2004-01-19 00:00:00	2004-02-02	2004-02-02 00:00:00	32020		\N	212616	0	10509002	260139		0
43595	2596	4112343	2014-06-17	2014-06-17 00:00:00	2014-06-28	2014-06-28 00:00:00	32020		\N	171809	0	195662009	4112343		0
54295	3216	80180	1995-10-30	1995-10-30 00:00:00	\N	\N	32020		\N	213732	0	396275006	80180		0
43958	2616	260139	1987-04-24	1987-04-24 00:00:00	1987-05-08	1987-05-08 00:00:00	32020		\N	172953	0	10509002	260139		0
54625	3234	4218389	1980-04-06	1980-04-06 00:00:00	1980-04-28	1980-04-28 00:00:00	32020		\N	214996	0	39848009	4218389		0
54790	3242	260139	1988-04-24	1988-04-24 00:00:00	1988-05-08	1988-05-08 00:00:00	32020		\N	215618	0	10509002	260139		0
55036	3258	4116491	2008-05-27	2008-05-27 00:00:00	2008-07-07	2008-07-07 00:00:00	32020		\N	216561	0	301011002	4116491		0
55242	3272	40481087	1974-09-14	1974-09-14 00:00:00	1974-10-05	1974-10-05 00:00:00	32020		\N	217417	0	444814009	40481087		0
55308	3277	260139	1990-03-06	1990-03-06 00:00:00	1990-03-13	1990-03-13 00:00:00	32020		\N	217702	0	10509002	260139		0
55457	3285	40481087	1978-02-25	1978-02-25 00:00:00	1978-03-18	1978-03-18 00:00:00	32020		\N	218228	0	444814009	40481087		0
55659	3295	4266809	1983-03-22	1983-03-22 00:00:00	\N	\N	32020		\N	218971	0	397881000	4266809		0
45241	2690	4266809	1983-12-16	1983-12-16 00:00:00	\N	\N	32020		\N	178252	0	397881000	4266809		0
56012	3315	40479422	2006-09-17	2006-09-17 00:00:00	2006-10-24	2006-10-24 00:00:00	32020		\N	220132	0	444448004	40479422		0
56149	3325	40481087	2009-11-02	2009-11-02 00:00:00	2009-11-16	2009-11-16 00:00:00	32020		\N	220724	0	444814009	40481087		0
56330	3339	40481087	1999-09-13	1999-09-13 00:00:00	1999-10-04	1999-10-04 00:00:00	32020		\N	221534	0	444814009	40481087		0
56459	3347	4112343	1963-03-17	1963-03-17 00:00:00	1963-03-25	1963-03-25 00:00:00	32020		\N	222038	0	195662009	4112343		0
56732	3364	81893	2007-04-13	2007-04-13 00:00:00	\N	\N	32020		\N	223135	0	64766004	81893		0
56807	3370	257012	2003-10-28	2003-10-28 00:00:00	\N	\N	32020		\N	223404	0	40055000	257012		0
46461	2767	80502	1996-06-05	1996-06-05 00:00:00	\N	\N	32020		\N	183042	0	64859006	80502		0
46577	2771	40481087	1933-12-18	1933-12-18 00:00:00	1934-01-08	1934-01-08 00:00:00	32020		\N	183509	0	444814009	40481087		0
57281	3399	4218389	2019-01-29	2019-01-29 00:00:00	2019-02-19	2019-02-19 00:00:00	32020		\N	225521	0	39848009	4218389		0
57451	3409	40481087	1987-12-21	1987-12-21 00:00:00	1988-01-04	1988-01-04 00:00:00	32020		\N	226092	0	444814009	40481087		0
57650	3420	4112343	1991-08-07	1991-08-07 00:00:00	1991-08-18	1991-08-18 00:00:00	32020		\N	226871	0	195662009	4112343		0
57805	3430	372328	1964-01-31	1964-01-31 00:00:00	1964-06-20	1964-06-20 00:00:00	32020		\N	227379	0	65363002	372328		0
57955	3437	4001336	1988-10-30	1988-10-30 00:00:00	\N	\N	32020		\N	227922	0	110030002	4001336		0
58107	3442	372328	1962-02-02	1962-02-02 00:00:00	1962-05-20	1962-05-20 00:00:00	32020		\N	228386	0	65363002	372328		0
47734	2835	4112343	1938-05-16	1938-05-16 00:00:00	1938-05-26	1938-05-26 00:00:00	32020		\N	188333	0	195662009	4112343		0
47927	2845	4116491	2015-11-03	2015-11-03 00:00:00	2015-12-05	2015-12-05 00:00:00	32020		\N	188962	0	301011002	4116491		0
58715	3483	4296205	1978-02-26	1978-02-26 00:00:00	1978-03-19	1978-03-19 00:00:00	32020		\N	231118	0	403191005	4296205		0
48229	2860	4112343	2013-06-28	2013-06-28 00:00:00	2013-07-06	2013-07-06 00:00:00	32020		\N	190139	0	195662009	4112343		0
48386	2866	40481087	2009-07-02	2009-07-02 00:00:00	2009-07-23	2009-07-23 00:00:00	32020		\N	190653	0	444814009	40481087		0
59192	3510	80180	1971-11-14	1971-11-14 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
69887	4134	40481087	1980-07-11	1980-07-11 00:00:00	1980-08-01	1980-08-01 00:00:00	32020		\N	274831	0	444814009	40481087		0
48942	2897	81893	2001-07-19	2001-07-19 00:00:00	\N	\N	32020		\N	192897	0	64766004	81893		0
59663	3536	257012	2006-12-02	2006-12-02 00:00:00	\N	\N	32020		\N	234852	0	40055000	257012		0
59838	3545	192671	2012-03-07	2012-03-07 00:00:00	\N	\N	32020		\N	235493	0	K92.2	35208414		0
59976	3553	40481087	1978-12-19	1978-12-19 00:00:00	1979-01-02	1979-01-02 00:00:00	32020		\N	235927	0	444814009	40481087		0
60121	3561	4218389	1979-04-29	1979-04-29 00:00:00	1979-05-20	1979-05-20 00:00:00	32020		\N	236474	0	39848009	4218389		0
60291	3568	40481087	2004-08-06	2004-08-06 00:00:00	2004-08-27	2004-08-27 00:00:00	32020		\N	237058	0	444814009	40481087		0
49895	2949	372328	1951-03-03	1951-03-03 00:00:00	1951-04-03	1951-04-03 00:00:00	32020		\N	196859	0	65363002	372328		0
60600	3582	4027663	1990-05-19	1990-05-19 00:00:00	\N	\N	32020		\N	238140	0	13200003	4027663		0
50238	2969	40481087	2018-08-17	2018-08-17 00:00:00	2018-08-24	2018-08-24 00:00:00	32020		\N	198252	0	444814009	40481087		0
60985	3610	40481087	1949-12-05	1949-12-05 00:00:00	1949-12-12	1949-12-12 00:00:00	32020		\N	239809	0	444814009	40481087		0
50617	2993	4296205	2007-12-17	2007-12-17 00:00:00	2008-01-07	2008-01-07 00:00:00	32020		\N	199830	0	403191005	4296205		0
50790	3004	4294548	1991-12-14	1991-12-14 00:00:00	1992-01-04	1992-01-04 00:00:00	32020		\N	200458	0	75498004	4294548		0
50945	3014	260139	1998-01-21	1998-01-21 00:00:00	1998-01-28	1998-01-28 00:00:00	32020		\N	201037	0	10509002	260139		0
51044	3022	80180	2012-04-15	2012-04-15 00:00:00	\N	\N	32020		\N	201475	0	396275006	80180		0
61848	3651	4283893	1998-07-27	1998-07-27 00:00:00	1998-09-21	1998-09-21 00:00:00	32020		\N	243048	0	36971009	4283893		0
61970	3658	4278672	1972-09-02	1972-09-02 00:00:00	1972-10-02	1972-10-02 00:00:00	32020		\N	243505	0	65966004	4278672		0
51600	3060	4112343	1955-06-15	1955-06-15 00:00:00	1955-06-22	1955-06-22 00:00:00	32020		\N	203571	0	195662009	4112343		0
62385	3686	4112343	2016-08-16	2016-08-16 00:00:00	2016-08-27	2016-08-27 00:00:00	32020		\N	245068	0	195662009	4112343		0
62448	3691	78272	1988-03-20	1988-03-20 00:00:00	1988-04-03	1988-04-03 00:00:00	32020		\N	245329	0	70704007	78272		0
52109	3086	80180	2004-09-06	2004-09-06 00:00:00	\N	\N	32020		\N	205483	0	396275006	80180		0
62772	3707	40481087	2009-12-20	2009-12-20 00:00:00	2010-01-03	2010-01-03 00:00:00	32020		\N	246410	0	444814009	40481087		0
52412	3105	4294548	2007-03-06	2007-03-06 00:00:00	2007-04-03	2007-04-03 00:00:00	32020		\N	206491	0	75498004	4294548		0
63213	3733	372328	1981-04-08	1981-04-08 00:00:00	1981-10-27	1981-10-27 00:00:00	32020		\N	248048	0	65363002	372328		0
63355	3742	4112343	1988-03-25	1988-03-25 00:00:00	1988-04-07	1988-04-07 00:00:00	32020		\N	248680	0	195662009	4112343		0
63495	3750	260139	1987-11-13	1987-11-13 00:00:00	1987-11-27	1987-11-27 00:00:00	32020		\N	249245	0	10509002	260139		0
63677	3759	40481087	1980-06-26	1980-06-26 00:00:00	1980-07-17	1980-07-17 00:00:00	32020		\N	249882	0	444814009	40481087		0
53133	3147	81151	1988-11-29	1988-11-29 00:00:00	1988-12-27	1988-12-27 00:00:00	32020		\N	209355	0	44465007	81151		0
53376	3161	4146173	1996-03-14	1996-03-14 00:00:00	1996-05-13	1996-05-13 00:00:00	32020		\N	210252	0	307731004	4146173		0
53526	3172	260139	1980-02-06	1980-02-06 00:00:00	1980-02-13	1980-02-13 00:00:00	32020		\N	210850	0	10509002	260139		0
53632	3177	260139	1946-07-10	1946-07-10 00:00:00	1946-07-17	1946-07-17 00:00:00	32020		\N	211249	0	10509002	260139		0
43269	2577	30753	2011-03-24	2011-03-24 00:00:00	\N	\N	32020		\N	170670	0	16761005	30753		0
53997	3196	40481087	1987-09-23	1987-09-23 00:00:00	1987-09-30	1987-09-30 00:00:00	32020		\N	212613	0	444814009	40481087		0
43596	2597	260139	2008-10-05	2008-10-05 00:00:00	2008-10-12	2008-10-12 00:00:00	32020		\N	171848	0	10509002	260139		0
54296	3216	4266809	1995-10-30	1995-10-30 00:00:00	\N	\N	32020		\N	213732	0	397881000	4266809		0
43959	2616	372328	1954-11-28	1954-11-28 00:00:00	1955-05-03	1955-05-03 00:00:00	32020		\N	172946	0	65363002	372328		0
54626	3234	372328	1949-06-19	1949-06-19 00:00:00	1949-10-03	1949-10-03 00:00:00	32020		\N	214945	0	65363002	372328		0
54791	3242	4112343	1999-02-23	1999-02-23 00:00:00	1999-03-04	1999-03-04 00:00:00	32020		\N	215633	0	195662009	4112343		0
55037	3258	4296205	1993-04-15	1993-04-15 00:00:00	1993-05-20	1993-05-20 00:00:00	32020		\N	216549	0	403191005	4296205		0
55243	3272	40481087	1999-04-02	1999-04-02 00:00:00	1999-04-16	1999-04-16 00:00:00	32020		\N	217442	0	444814009	40481087		0
55309	3277	4283893	2003-07-27	2003-07-27 00:00:00	2003-08-17	2003-08-17 00:00:00	32020		\N	217686	0	36971009	4283893		0
55458	3285	40481087	1980-04-16	1980-04-16 00:00:00	1980-04-30	1980-04-30 00:00:00	32020		\N	218229	0	444814009	40481087		0
55660	3295	30753	1982-05-26	1982-05-26 00:00:00	\N	\N	32020		\N	218971	0	16761005	30753		0
45242	2690	30753	1983-06-19	1983-06-19 00:00:00	\N	\N	32020		\N	178252	0	16761005	30753		0
56013	3315	81151	2013-12-16	2013-12-16 00:00:00	2014-01-20	2014-01-20 00:00:00	32020		\N	220133	0	44465007	81151		0
56150	3325	260139	1963-09-16	1963-09-16 00:00:00	1963-09-23	1963-09-23 00:00:00	32020		\N	220741	0	10509002	260139		0
56331	3339	4059173	1967-08-07	1967-08-07 00:00:00	1967-11-05	1967-11-05 00:00:00	32020		\N	221539	0	16114001	4059173		0
56460	3347	40481087	1959-09-21	1959-09-21 00:00:00	1959-10-05	1959-10-05 00:00:00	32020		\N	222034	0	444814009	40481087		0
56733	3364	4116491	2007-06-17	2007-06-17 00:00:00	2007-07-18	2007-07-18 00:00:00	32020		\N	223090	0	301011002	4116491		0
56808	3370	4218389	1990-10-09	1990-10-09 00:00:00	1990-10-30	1990-10-30 00:00:00	32020		\N	223394	0	39848009	4218389		0
46462	2767	40481087	2000-08-26	2000-08-26 00:00:00	2000-09-02	2000-09-02 00:00:00	32020		\N	183030	0	444814009	40481087		0
46578	2771	372328	1915-01-19	1915-01-19 00:00:00	1915-09-03	1915-09-03 00:00:00	32020		\N	183548	0	65363002	372328		0
57282	3399	4112343	1987-01-30	1987-01-30 00:00:00	1987-02-07	1987-02-07 00:00:00	32020		\N	225487	0	195662009	4112343		0
57452	3409	195588	2004-07-14	2004-07-14 00:00:00	2004-09-01	2004-09-01 00:00:00	32020		\N	226096	0	38822007	195588		0
57651	3420	40481087	1984-04-29	1984-04-29 00:00:00	1984-05-13	1984-05-13 00:00:00	32020		\N	226845	0	444814009	40481087		0
57806	3430	260139	1975-03-06	1975-03-06 00:00:00	1975-03-13	1975-03-13 00:00:00	32020		\N	227391	0	10509002	260139		0
57956	3437	260139	1980-05-19	1980-05-19 00:00:00	1980-06-02	1980-06-02 00:00:00	32020		\N	227942	0	10509002	260139		0
58108	3442	4283893	1983-10-27	1983-10-27 00:00:00	1983-11-24	1983-11-24 00:00:00	32020		\N	228448	0	36971009	4283893		0
47735	2835	260139	1998-01-23	1998-01-23 00:00:00	1998-02-06	1998-02-06 00:00:00	32020		\N	188321	0	10509002	260139		0
47928	2845	378001	1994-01-21	1994-01-21 00:00:00	1994-03-22	1994-03-22 00:00:00	32020		\N	188984	0	62106007	378001		0
58716	3483	40481087	1956-03-07	1956-03-07 00:00:00	1956-03-28	1956-03-28 00:00:00	32020		\N	231090	0	444814009	40481087		0
48230	2860	4283893	1968-09-11	1968-09-11 00:00:00	1968-11-27	1968-11-27 00:00:00	32020		\N	190152	0	36971009	4283893		0
48387	2866	261325	1998-04-26	1998-04-26 00:00:00	\N	\N	32020		\N	190675	0	87433001	261325		0
59193	3510	30753	1971-03-19	1971-03-19 00:00:00	\N	\N	32020		\N	\N	0	16761005	30753		0
69888	4134	40481087	1979-09-15	1979-09-15 00:00:00	1979-10-06	1979-10-06 00:00:00	32020		\N	274825	0	444814009	40481087		0
48943	2897	40481087	1965-01-28	1965-01-28 00:00:00	1965-02-04	1965-02-04 00:00:00	32020		\N	192936	0	444814009	40481087		0
59664	3536	40481087	2003-11-06	2003-11-06 00:00:00	2003-11-13	2003-11-13 00:00:00	32020		\N	234850	0	444814009	40481087		0
59839	3545	260139	1985-05-15	1985-05-15 00:00:00	1985-05-29	1985-05-29 00:00:00	32020		\N	235482	0	10509002	260139		0
59977	3553	260139	1990-03-05	1990-03-05 00:00:00	1990-03-19	1990-03-19 00:00:00	32020		\N	235893	0	10509002	260139		0
60122	3561	192671	1944-01-20	1944-01-20 00:00:00	\N	\N	32020		\N	236418	0	K92.2	35208414		0
60292	3568	40481087	1987-07-04	1987-07-04 00:00:00	1987-07-11	1987-07-11 00:00:00	32020		\N	237055	0	444814009	40481087		0
49896	2949	40481087	1969-03-24	1969-03-24 00:00:00	1969-04-14	1969-04-14 00:00:00	32020		\N	196831	0	444814009	40481087		0
60601	3582	378001	2003-01-19	2003-01-19 00:00:00	2003-02-18	2003-02-18 00:00:00	32020		\N	238124	0	62106007	378001		0
50239	2969	81151	1967-11-07	1967-11-07 00:00:00	1967-12-12	1967-12-12 00:00:00	32020		\N	198243	0	44465007	81151		0
60986	3610	4116491	1966-05-01	1966-05-01 00:00:00	1966-06-22	1966-06-22 00:00:00	32020		\N	239862	0	301011002	4116491		0
50618	2993	4112343	1987-08-22	1987-08-22 00:00:00	1987-09-01	1987-09-01 00:00:00	32020		\N	199799	0	195662009	4112343		0
50791	3004	28060	1958-10-12	1958-10-12 00:00:00	1958-10-22	1958-10-22 00:00:00	32020		\N	200464	0	43878008	28060		0
50946	3014	40481087	1985-02-01	1985-02-01 00:00:00	1985-02-08	1985-02-08 00:00:00	32020		\N	200994	0	444814009	40481087		0
51045	3022	4146173	1978-11-05	1978-11-05 00:00:00	1979-01-11	1979-01-11 00:00:00	32020		\N	201478	0	307731004	4146173		0
61849	3651	257012	1998-09-14	1998-09-14 00:00:00	\N	\N	32020		\N	243052	0	40055000	257012		0
61971	3658	40481087	1996-06-15	1996-06-15 00:00:00	1996-06-29	1996-06-29 00:00:00	32020		\N	243499	0	444814009	40481087		0
51601	3060	40481087	1982-01-16	1982-01-16 00:00:00	1982-02-06	1982-02-06 00:00:00	32020		\N	203668	0	444814009	40481087		0
62386	3686	4134304	1991-01-18	1991-01-18 00:00:00	1991-04-18	1991-04-18 00:00:00	32020		\N	245052	0	263102004	4134304		0
62449	3691	4152936	1989-12-24	1989-12-24 00:00:00	1990-01-14	1990-01-14 00:00:00	32020		\N	245330	0	283385000	4152936		0
52110	3086	4112343	1974-07-14	1974-07-14 00:00:00	1974-07-24	1974-07-24 00:00:00	32020		\N	205427	0	195662009	4112343		0
62773	3707	40481087	1982-09-26	1982-09-26 00:00:00	1982-10-10	1982-10-10 00:00:00	32020		\N	246436	0	444814009	40481087		0
52413	3105	440086	1984-01-23	1984-01-23 00:00:00	1984-06-04	1984-06-04 00:00:00	32020		\N	206510	0	192127007	440086		0
63214	3733	260139	1984-04-28	1984-04-28 00:00:00	1984-05-12	1984-05-12 00:00:00	32020		\N	248055	0	10509002	260139		0
63356	3742	40481087	1992-06-28	1992-06-28 00:00:00	1992-07-19	1992-07-19 00:00:00	32020		\N	248670	0	444814009	40481087		0
63496	3750	40481087	2008-12-10	2008-12-10 00:00:00	2008-12-24	2008-12-24 00:00:00	32020		\N	249257	0	444814009	40481087		0
63678	3759	4112343	2005-09-01	2005-09-01 00:00:00	2005-09-09	2005-09-09 00:00:00	32020		\N	249926	0	195662009	4112343		0
53134	3147	40481087	1947-12-12	1947-12-12 00:00:00	1947-12-19	1947-12-19 00:00:00	32020		\N	209339	0	444814009	40481087		0
53424	3167	372328	1960-09-03	1960-09-03 00:00:00	1960-11-13	1960-11-13 00:00:00	32020		\N	210570	0	65363002	372328		0
53527	3172	260139	2005-01-23	2005-01-23 00:00:00	2005-01-30	2005-01-30 00:00:00	32020		\N	210853	0	10509002	260139		0
53633	3177	4112343	1980-04-25	1980-04-25 00:00:00	1980-05-08	1980-05-08 00:00:00	32020		\N	211312	0	195662009	4112343		0
43270	2577	4266809	2012-03-18	2012-03-18 00:00:00	\N	\N	32020		\N	170670	0	397881000	4266809		0
53998	3196	28060	1989-06-28	1989-06-28 00:00:00	1989-07-08	1989-07-08 00:00:00	32020		\N	212647	0	43878008	28060		0
43597	2597	4112343	2003-09-10	2003-09-10 00:00:00	2003-09-23	2003-09-23 00:00:00	32020		\N	171834	0	195662009	4112343		0
54297	3216	4112343	2015-05-31	2015-05-31 00:00:00	2015-06-08	2015-06-08 00:00:00	32020		\N	213715	0	195662009	4112343		0
43960	2616	40481087	2003-09-15	2003-09-15 00:00:00	2003-09-29	2003-09-29 00:00:00	32020		\N	172978	0	444814009	40481087		0
54627	3234	40481087	1955-05-09	1955-05-09 00:00:00	1955-05-23	1955-05-23 00:00:00	32020		\N	214923	0	444814009	40481087		0
54792	3242	40481087	1986-12-05	1986-12-05 00:00:00	1986-12-26	1986-12-26 00:00:00	32020		\N	215630	0	444814009	40481087		0
55038	3258	4112343	1996-10-18	1996-10-18 00:00:00	1996-10-30	1996-10-30 00:00:00	32020		\N	216580	0	195662009	4112343		0
55244	3272	4112343	1982-11-17	1982-11-17 00:00:00	1982-11-26	1982-11-26 00:00:00	32020		\N	217440	0	195662009	4112343		0
55310	3277	28060	1974-06-20	1974-06-20 00:00:00	1974-06-29	1974-06-29 00:00:00	32020		\N	217701	0	43878008	28060		0
55459	3285	40481087	1978-05-25	1978-05-25 00:00:00	1978-06-15	1978-06-15 00:00:00	32020		\N	218219	0	444814009	40481087		0
55661	3295	4285898	1982-06-25	1982-06-25 00:00:00	\N	\N	32020		\N	218971	0	68496003	4285898		0
45243	2690	80180	1983-12-16	1983-12-16 00:00:00	\N	\N	32020		\N	178252	0	396275006	80180		0
56014	3315	40481087	1984-02-21	1984-02-21 00:00:00	1984-03-13	1984-03-13 00:00:00	32020		\N	220206	0	444814009	40481087		0
56151	3325	4112343	1984-01-21	1984-01-21 00:00:00	1984-01-29	1984-01-29 00:00:00	32020		\N	220743	0	195662009	4112343		0
56332	3339	40481087	2011-08-07	2011-08-07 00:00:00	2011-08-28	2011-08-28 00:00:00	32020		\N	221528	0	444814009	40481087		0
56461	3347	40481087	1956-06-12	1956-06-12 00:00:00	1956-07-03	1956-07-03 00:00:00	32020		\N	222064	0	444814009	40481087		0
56734	3364	4112343	1988-01-24	1988-01-24 00:00:00	1988-02-06	1988-02-06 00:00:00	32020		\N	223109	0	195662009	4112343		0
56809	3370	4112343	2000-04-22	2000-04-22 00:00:00	2000-04-29	2000-04-29 00:00:00	32020		\N	223483	0	195662009	4112343		0
46463	2767	4112343	1943-04-14	1943-04-14 00:00:00	1943-04-22	1943-04-22 00:00:00	32020		\N	183021	0	195662009	4112343		0
46579	2771	40481087	1948-07-28	1948-07-28 00:00:00	1948-08-11	1948-08-11 00:00:00	32020		\N	183455	0	444814009	40481087		0
57283	3399	4112343	2018-10-03	2018-10-03 00:00:00	2018-10-12	2018-10-12 00:00:00	32020		\N	225493	0	195662009	4112343		0
57453	3409	40481087	1980-02-04	1980-02-04 00:00:00	1980-02-25	1980-02-25 00:00:00	32020		\N	226072	0	444814009	40481087		0
57652	3420	260139	2002-07-29	2002-07-29 00:00:00	2002-08-05	2002-08-05 00:00:00	32020		\N	226887	0	10509002	260139		0
57807	3430	40481087	1966-05-20	1966-05-20 00:00:00	1966-05-27	1966-05-27 00:00:00	32020		\N	227395	0	444814009	40481087		0
57957	3437	4296205	1972-11-25	1972-11-25 00:00:00	1972-12-23	1972-12-23 00:00:00	32020		\N	227921	0	403191005	4296205		0
58109	3442	375671	1969-04-26	1969-04-26 00:00:00	1969-05-26	1969-05-26 00:00:00	32020		\N	228417	0	62564004	375671		0
47736	2835	4112343	1968-05-05	1968-05-05 00:00:00	1968-05-15	1968-05-15 00:00:00	32020		\N	188210	0	195662009	4112343		0
47929	2845	4296205	2001-04-14	2001-04-14 00:00:00	2001-05-12	2001-05-12 00:00:00	32020		\N	188985	0	403191005	4296205		0
58717	3483	40481087	1984-09-08	1984-09-08 00:00:00	1984-09-22	1984-09-22 00:00:00	32020		\N	231111	0	444814009	40481087		0
48231	2860	4112343	1944-12-03	1944-12-03 00:00:00	1944-12-13	1944-12-13 00:00:00	32020		\N	190131	0	195662009	4112343		0
48388	2866	40481087	2010-04-27	2010-04-27 00:00:00	2010-05-04	2010-05-04 00:00:00	32020		\N	190654	0	444814009	40481087		0
59194	3510	40481087	1958-05-15	1958-05-15 00:00:00	1958-05-29	1958-05-29 00:00:00	32020		\N	232901	0	444814009	40481087		0
69889	4134	4112343	1972-12-14	1972-12-14 00:00:00	1972-12-21	1972-12-21 00:00:00	32020		\N	274895	0	195662009	4112343		0
48944	2897	78272	1970-11-23	1970-11-23 00:00:00	1970-12-28	1970-12-28 00:00:00	32020		\N	192941	0	70704007	78272		0
59665	3536	4112343	1971-01-01	1971-01-01 00:00:00	1971-01-08	1971-01-08 00:00:00	32020		\N	234825	0	195662009	4112343		0
59840	3545	40481087	2011-07-21	2011-07-21 00:00:00	2011-08-11	2011-08-11 00:00:00	32020		\N	235450	0	444814009	40481087		0
59978	3553	4027663	1958-11-01	1958-11-01 00:00:00	\N	\N	32020		\N	235941	0	13200003	4027663		0
60123	3561	4112343	1917-08-23	1917-08-23 00:00:00	1917-09-03	1917-09-03 00:00:00	32020		\N	236505	0	195662009	4112343		0
60293	3568	372328	1971-11-28	1971-11-28 00:00:00	1972-05-04	1972-05-04 00:00:00	32020		\N	237111	0	65363002	372328		0
49897	2949	4218389	1995-12-03	1995-12-03 00:00:00	1995-12-31	1995-12-31 00:00:00	32020		\N	196880	0	39848009	4218389		0
60602	3582	4112343	1998-03-17	1998-03-17 00:00:00	1998-03-29	1998-03-29 00:00:00	32020		\N	238091	0	195662009	4112343		0
50240	2969	4112343	1987-08-01	1987-08-01 00:00:00	1987-08-08	1987-08-08 00:00:00	32020		\N	198203	0	195662009	4112343		0
60987	3610	40481087	1974-10-26	1974-10-26 00:00:00	1974-11-02	1974-11-02 00:00:00	32020		\N	239869	0	444814009	40481087		0
50619	2993	4112343	1981-07-16	1981-07-16 00:00:00	1981-07-23	1981-07-23 00:00:00	32020		\N	199778	0	195662009	4112343		0
50792	3004	40481087	1965-08-07	1965-08-07 00:00:00	1965-08-28	1965-08-28 00:00:00	32020		\N	200433	0	444814009	40481087		0
50947	3014	40481087	2017-03-22	2017-03-22 00:00:00	2017-04-12	2017-04-12 00:00:00	32020		\N	200988	0	444814009	40481087		0
51046	3022	40481087	1994-09-04	1994-09-04 00:00:00	1994-09-11	1994-09-11 00:00:00	32020		\N	201447	0	444814009	40481087		0
61850	3652	372328	1974-04-07	1974-04-07 00:00:00	1974-05-19	1974-05-19 00:00:00	32020		\N	243130	0	65363002	372328		0
61972	3658	192671	1999-09-01	1999-09-01 00:00:00	\N	\N	32020		\N	243454	0	K92.2	35208414		0
51602	3060	4112343	1995-03-22	1995-03-22 00:00:00	1995-03-31	1995-03-31 00:00:00	32020		\N	203546	0	195662009	4112343		0
62387	3686	192671	2009-12-16	2009-12-16 00:00:00	\N	\N	32020		\N	245081	0	K92.2	35208414		0
62450	3691	40481087	1999-09-01	1999-09-01 00:00:00	1999-09-08	1999-09-08 00:00:00	32020		\N	245346	0	444814009	40481087		0
52111	3086	40481087	1971-03-22	1971-03-22 00:00:00	1971-04-12	1971-04-12 00:00:00	32020		\N	205442	0	444814009	40481087		0
62774	3707	40481087	1986-12-24	1986-12-24 00:00:00	1986-12-31	1986-12-31 00:00:00	32020		\N	246461	0	444814009	40481087		0
52414	3105	40481087	1977-08-23	1977-08-23 00:00:00	1977-09-13	1977-09-13 00:00:00	32020		\N	206498	0	444814009	40481087		0
63215	3733	80180	2011-03-22	2011-03-22 00:00:00	\N	\N	32020		\N	248052	0	396275006	80180		0
63357	3742	40481087	1989-01-16	1989-01-16 00:00:00	1989-02-06	1989-02-06 00:00:00	32020		\N	248669	0	444814009	40481087		0
63497	3750	4112343	1979-04-29	1979-04-29 00:00:00	1979-05-06	1979-05-06 00:00:00	32020		\N	249248	0	195662009	4112343		0
63692	3761	40481087	1973-02-23	1973-02-23 00:00:00	1973-03-09	1973-03-09 00:00:00	32020		\N	250062	0	444814009	40481087		0
53425	3167	260139	1966-07-06	1966-07-06 00:00:00	1966-07-20	1966-07-20 00:00:00	32020		\N	210529	0	10509002	260139		0
53528	3172	260139	2015-12-20	2015-12-20 00:00:00	2016-01-03	2016-01-03 00:00:00	32020		\N	210871	0	10509002	260139		0
53635	3177	321042	2003-01-08	2003-01-08 00:00:00	\N	\N	32020		\N	211350	0	410429000	321042		0
43271	2577	378001	2015-02-13	2015-02-13 00:00:00	2015-03-15	2015-03-15 00:00:00	32020		\N	170637	0	62106007	378001		0
53999	3196	4283893	2002-04-24	2002-04-24 00:00:00	2002-06-19	2002-06-19 00:00:00	32020		\N	212649	0	36971009	4283893		0
43598	2597	40481087	1999-11-14	1999-11-14 00:00:00	1999-12-05	1999-12-05 00:00:00	32020		\N	171838	0	444814009	40481087		0
54298	3216	4113008	1963-07-26	1963-07-26 00:00:00	1963-08-09	1963-08-09 00:00:00	32020		\N	213707	0	284549007	4113008		0
43961	2616	4112343	2009-10-08	2009-10-08 00:00:00	2009-10-21	2009-10-21 00:00:00	32020		\N	172944	0	195662009	4112343		0
54628	3234	260139	1977-06-24	1977-06-24 00:00:00	1977-07-08	1977-07-08 00:00:00	32020		\N	214932	0	10509002	260139		0
54793	3242	40481087	1994-10-18	1994-10-18 00:00:00	1994-11-08	1994-11-08 00:00:00	32020		\N	215619	0	444814009	40481087		0
55039	3258	40481087	2009-10-02	2009-10-02 00:00:00	2009-10-16	2009-10-16 00:00:00	32020		\N	216622	0	444814009	40481087		0
55245	3272	40481087	1972-11-23	1972-11-23 00:00:00	1972-12-14	1972-12-14 00:00:00	32020		\N	217466	0	444814009	40481087		0
55311	3277	4134304	1997-10-25	1997-10-25 00:00:00	1998-01-23	1998-01-23 00:00:00	32020		\N	217692	0	263102004	4134304		0
55460	3285	257012	2010-07-17	2010-07-17 00:00:00	\N	\N	32020		\N	218174	0	40055000	257012		0
55662	3295	40481087	1982-05-21	1982-05-21 00:00:00	1982-06-04	1982-06-04 00:00:00	32020		\N	218971	0	444814009	40481087		0
45244	2690	4112343	1949-06-01	1949-06-01 00:00:00	1949-06-11	1949-06-11 00:00:00	32020		\N	178226	0	195662009	4112343		0
56015	3315	4112343	2008-05-19	2008-05-19 00:00:00	2008-05-31	2008-05-31 00:00:00	32020		\N	220170	0	195662009	4112343		0
56152	3325	28060	1981-03-24	1981-03-24 00:00:00	1981-04-03	1981-04-03 00:00:00	32020		\N	220713	0	43878008	28060		0
56333	3339	372328	1963-01-25	1963-01-25 00:00:00	1963-03-19	1963-03-19 00:00:00	32020		\N	221479	0	65363002	372328		0
56462	3347	81151	1986-02-26	1986-02-26 00:00:00	1986-03-12	1986-03-12 00:00:00	32020		\N	222017	0	44465007	81151		0
56735	3364	372328	1981-10-02	1981-10-02 00:00:00	1982-06-10	1982-06-10 00:00:00	32020		\N	223066	0	65363002	372328		0
56810	3370	4283893	2005-12-28	2005-12-28 00:00:00	2006-05-03	2006-05-03 00:00:00	32020		\N	223487	0	36971009	4283893		0
46464	2767	260139	1942-08-06	1942-08-06 00:00:00	1942-08-20	1942-08-20 00:00:00	32020		\N	183074	0	10509002	260139		0
46580	2771	4278672	2013-09-28	2013-09-28 00:00:00	2013-10-28	2013-10-28 00:00:00	32020		\N	183478	0	65966004	4278672		0
57284	3399	260139	1987-01-18	1987-01-18 00:00:00	1987-01-25	1987-01-25 00:00:00	32020		\N	225510	0	10509002	260139		0
57454	3409	40481087	2016-02-06	2016-02-06 00:00:00	2016-02-20	2016-02-20 00:00:00	32020		\N	226078	0	444814009	40481087		0
57653	3420	40481087	1997-07-03	1997-07-03 00:00:00	1997-07-10	1997-07-10 00:00:00	32020		\N	226868	0	444814009	40481087		0
57808	3430	4112343	2017-04-23	2017-04-23 00:00:00	2017-05-03	2017-05-03 00:00:00	32020		\N	227396	0	195662009	4112343		0
57958	3437	4112343	1956-06-03	1956-06-03 00:00:00	1956-06-11	1956-06-11 00:00:00	32020		\N	228008	0	195662009	4112343		0
58110	3442	40481087	2004-11-29	2004-11-29 00:00:00	2004-12-06	2004-12-06 00:00:00	32020		\N	228431	0	444814009	40481087		0
47737	2835	4112343	1917-05-24	1917-05-24 00:00:00	1917-05-31	1917-05-31 00:00:00	32020		\N	188312	0	195662009	4112343		0
47930	2845	378001	1964-01-29	1964-01-29 00:00:00	1964-03-29	1964-03-29 00:00:00	32020		\N	188982	0	62106007	378001		0
58718	3483	372328	1955-10-11	1955-10-11 00:00:00	1955-12-31	1955-12-31 00:00:00	32020		\N	231114	0	65363002	372328		0
48232	2860	80809	2006-10-01	2006-10-01 00:00:00	\N	\N	32020		\N	190105	0	69896004	80809		0
48389	2866	40481087	1985-02-05	1985-02-05 00:00:00	1985-02-12	1985-02-12 00:00:00	32020		\N	190664	0	444814009	40481087		0
59195	3510	4027663	1960-03-01	1960-03-01 00:00:00	\N	\N	32020		\N	232901	0	13200003	4027663		0
69890	4134	260139	1987-05-24	1987-05-24 00:00:00	1987-06-07	1987-06-07 00:00:00	32020		\N	274863	0	10509002	260139		0
48945	2897	40481087	2018-08-10	2018-08-10 00:00:00	2018-08-31	2018-08-31 00:00:00	32020		\N	192950	0	444814009	40481087		0
59666	3536	4116491	2016-03-28	2016-03-28 00:00:00	2016-05-17	2016-05-17 00:00:00	32020		\N	234845	0	301011002	4116491		0
59841	3545	80180	2011-12-13	2011-12-13 00:00:00	\N	\N	32020		\N	235450	0	396275006	80180		0
59979	3553	4112343	1962-02-02	1962-02-02 00:00:00	1962-02-11	1962-02-11 00:00:00	32020		\N	235906	0	195662009	4112343		0
60124	3561	260139	1949-02-12	1949-02-12 00:00:00	1949-02-19	1949-02-19 00:00:00	32020		\N	236509	0	10509002	260139		0
60294	3568	40481087	2005-10-28	2005-10-28 00:00:00	2005-11-11	2005-11-11 00:00:00	32020		\N	237109	0	444814009	40481087		0
49898	2949	4134304	1960-03-04	1960-03-04 00:00:00	1960-05-03	1960-05-03 00:00:00	32020		\N	196878	0	263102004	4134304		0
60603	3582	260139	2017-02-14	2017-02-14 00:00:00	2017-02-28	2017-02-28 00:00:00	32020		\N	238109	0	10509002	260139		0
50241	2969	4112343	1970-06-28	1970-06-28 00:00:00	1970-07-07	1970-07-07 00:00:00	32020		\N	198201	0	195662009	4112343		0
60988	3610	40481087	1955-02-12	1955-02-12 00:00:00	1955-03-05	1955-03-05 00:00:00	32020		\N	239886	0	444814009	40481087		0
50620	2993	40481087	2003-02-03	2003-02-03 00:00:00	2003-02-17	2003-02-17 00:00:00	32020		\N	199802	0	444814009	40481087		0
50793	3004	40481087	1995-10-21	1995-10-21 00:00:00	1995-10-28	1995-10-28 00:00:00	32020		\N	200459	0	444814009	40481087		0
50948	3014	40481087	1990-02-20	1990-02-20 00:00:00	1990-03-13	1990-03-13 00:00:00	32020		\N	201035	0	444814009	40481087		0
51047	3022	372328	1976-08-24	1976-08-24 00:00:00	1977-04-01	1977-04-01 00:00:00	32020		\N	201449	0	65363002	372328		0
61851	3652	4116491	2011-08-31	2011-08-31 00:00:00	2011-10-20	2011-10-20 00:00:00	32020		\N	243123	0	301011002	4116491		0
61973	3658	40481087	1966-04-12	1966-04-12 00:00:00	1966-04-19	1966-04-19 00:00:00	32020		\N	243495	0	444814009	40481087		0
51603	3060	260139	1928-07-23	1928-07-23 00:00:00	1928-08-06	1928-08-06 00:00:00	32020		\N	203568	0	10509002	260139		0
62388	3686	40481087	1980-12-06	1980-12-06 00:00:00	1980-12-27	1980-12-27 00:00:00	32020		\N	245082	0	444814009	40481087		0
62451	3691	260139	1984-01-05	1984-01-05 00:00:00	1984-01-19	1984-01-19 00:00:00	32020		\N	245353	0	10509002	260139		0
52112	3086	4112343	1993-12-14	1993-12-14 00:00:00	1993-12-27	1993-12-27 00:00:00	32020		\N	205428	0	195662009	4112343		0
62775	3707	81151	1975-09-27	1975-09-27 00:00:00	1975-11-01	1975-11-01 00:00:00	32020		\N	246453	0	44465007	81151		0
52415	3105	260139	1981-12-26	1981-12-26 00:00:00	1982-01-02	1982-01-02 00:00:00	32020		\N	206509	0	10509002	260139		0
63216	3734	40481087	1983-01-16	1983-01-16 00:00:00	1983-01-30	1983-01-30 00:00:00	32020		\N	248177	0	444814009	40481087		0
63358	3743	372328	1980-04-14	1980-04-14 00:00:00	1980-07-20	1980-07-20 00:00:00	32020		\N	248707	0	65363002	372328		0
63498	3750	378001	1981-06-01	1981-06-01 00:00:00	1981-07-31	1981-07-31 00:00:00	32020		\N	249193	0	62106007	378001		0
63693	3761	78272	1958-01-11	1958-01-11 00:00:00	1958-02-08	1958-02-08 00:00:00	32020		\N	250042	0	70704007	78272		0
53136	3147	4112343	1962-10-04	1962-10-04 00:00:00	1962-10-12	1962-10-12 00:00:00	32020		\N	209359	0	195662009	4112343		0
53426	3167	4112343	1978-09-14	1978-09-14 00:00:00	1978-09-26	1978-09-26 00:00:00	32020		\N	210531	0	195662009	4112343		0
53529	3172	4112343	1991-09-30	1991-09-30 00:00:00	1991-10-13	1991-10-13 00:00:00	32020		\N	210860	0	195662009	4112343		0
53636	3177	4035415	1964-02-18	1964-02-18 00:00:00	1964-03-19	1964-03-19 00:00:00	32020		\N	211230	0	239720000	4035415		0
43272	2577	133834	1973-09-16	1973-09-16 00:00:00	\N	\N	32020		\N	170609	0	24079001	133834		0
54000	3196	40481087	1984-04-11	1984-04-11 00:00:00	1984-05-02	1984-05-02 00:00:00	32020		\N	212599	0	444814009	40481087		0
43599	2597	260139	2001-06-05	2001-06-05 00:00:00	2001-06-12	2001-06-12 00:00:00	32020		\N	171839	0	10509002	260139		0
54299	3216	372328	1956-03-26	1956-03-26 00:00:00	1956-05-29	1956-05-29 00:00:00	32020		\N	213716	0	65363002	372328		0
43962	2616	4112343	2002-07-04	2002-07-04 00:00:00	2002-07-14	2002-07-14 00:00:00	32020		\N	172942	0	195662009	4112343		0
54629	3234	372328	1952-12-16	1952-12-16 00:00:00	1953-10-12	1953-10-12 00:00:00	32020		\N	214933	0	65363002	372328		0
54794	3242	40481087	2004-09-23	2004-09-23 00:00:00	2004-10-14	2004-10-14 00:00:00	32020		\N	215621	0	444814009	40481087		0
55040	3258	260139	1990-12-23	1990-12-23 00:00:00	1990-12-30	1990-12-30 00:00:00	32020		\N	216559	0	10509002	260139		0
55246	3272	4285898	2004-04-21	2004-04-21 00:00:00	\N	\N	32020		\N	217446	0	68496003	4285898		0
55312	3277	80180	2004-09-12	2004-09-12 00:00:00	\N	\N	32020		\N	217707	0	396275006	80180		0
55461	3285	40481087	1970-08-19	1970-08-19 00:00:00	1970-09-02	1970-09-02 00:00:00	32020		\N	218226	0	444814009	40481087		0
55663	3295	80180	1983-03-22	1983-03-22 00:00:00	\N	\N	32020		\N	218971	0	396275006	80180		0
45245	2690	317576	1971-06-03	1971-06-03 00:00:00	\N	\N	32020		\N	178205	0	53741008	317576		0
56016	3315	80180	1990-10-11	1990-10-11 00:00:00	\N	\N	32020		\N	220207	0	396275006	80180		0
56153	3325	40481087	2019-02-02	2019-02-02 00:00:00	2019-02-09	2019-02-09 00:00:00	32020		\N	220746	0	444814009	40481087		0
56334	3339	440086	1970-10-10	1970-10-10 00:00:00	1977-10-18	1977-10-18 00:00:00	32020		\N	221526	0	192127007	440086		0
56463	3347	4112343	1956-10-05	1956-10-05 00:00:00	1956-10-16	1956-10-16 00:00:00	32020		\N	222065	0	195662009	4112343		0
56736	3364	260139	1983-09-17	1983-09-17 00:00:00	1983-10-01	1983-10-01 00:00:00	32020		\N	223081	0	10509002	260139		0
56811	3370	4112343	1990-05-05	1990-05-05 00:00:00	1990-05-12	1990-05-12 00:00:00	32020		\N	223453	0	195662009	4112343		0
46465	2767	40481087	1988-02-17	1988-02-17 00:00:00	1988-02-24	1988-02-24 00:00:00	32020		\N	183075	0	444814009	40481087		0
46593	2774	260139	1975-04-23	1975-04-23 00:00:00	1975-05-07	1975-05-07 00:00:00	32020		\N	183640	0	10509002	260139		0
57285	3399	80180	2016-08-13	2016-08-13 00:00:00	\N	\N	32020		\N	225446	0	396275006	80180		0
57455	3409	28060	2011-06-01	2011-06-01 00:00:00	2011-06-09	2011-06-09 00:00:00	32020		\N	226097	0	43878008	28060		0
57654	3420	81151	1975-09-02	1975-09-02 00:00:00	1975-09-23	1975-09-23 00:00:00	32020		\N	226882	0	44465007	81151		0
57809	3430	317576	2001-03-17	2001-03-17 00:00:00	\N	\N	32020		\N	227371	0	53741008	317576		0
57959	3437	40481087	1951-02-15	1951-02-15 00:00:00	1951-03-01	1951-03-01 00:00:00	32020		\N	227939	0	444814009	40481087		0
58111	3442	40481087	1999-12-05	1999-12-05 00:00:00	1999-12-19	1999-12-19 00:00:00	32020		\N	228410	0	444814009	40481087		0
47738	2835	4112343	1936-09-07	1936-09-07 00:00:00	1936-09-20	1936-09-20 00:00:00	32020		\N	188314	0	195662009	4112343		0
47931	2845	40481087	2012-02-05	2012-02-05 00:00:00	2012-02-26	2012-02-26 00:00:00	32020		\N	188939	0	444814009	40481087		0
58719	3483	260139	2006-06-25	2006-06-25 00:00:00	2006-07-09	2006-07-09 00:00:00	32020		\N	231089	0	10509002	260139		0
48233	2860	260139	1976-06-27	1976-06-27 00:00:00	1976-07-13	1976-07-13 00:00:00	32020		\N	190072	0	10509002	260139		0
48390	2866	4112343	1992-05-30	1992-05-30 00:00:00	1992-06-10	1992-06-10 00:00:00	32020		\N	190687	0	195662009	4112343		0
59196	3510	4146173	2001-07-22	2001-07-22 00:00:00	2001-09-20	2001-09-20 00:00:00	32020		\N	232832	0	307731004	4146173		0
69891	4134	4237458	1959-08-13	1959-08-13 00:00:00	1959-10-12	1959-10-12 00:00:00	32020		\N	274820	0	58150001	4237458		0
48946	2897	40481087	1984-07-26	1984-07-26 00:00:00	1984-08-09	1984-08-09 00:00:00	32020		\N	192949	0	444814009	40481087		0
59667	3536	4056621	2016-03-28	2016-03-28 00:00:00	\N	\N	32020		\N	234845	0	197927001	4056621		0
59842	3545	40481087	1972-08-01	1972-08-01 00:00:00	1972-08-08	1972-08-08 00:00:00	32020		\N	235494	0	444814009	40481087		0
59980	3553	260139	1952-11-12	1952-11-12 00:00:00	1952-11-26	1952-11-26 00:00:00	32020		\N	235924	0	10509002	260139		0
60125	3561	40481087	1954-11-30	1954-11-30 00:00:00	1954-12-14	1954-12-14 00:00:00	32020		\N	236503	0	444814009	40481087		0
60295	3568	4112343	2016-05-21	2016-05-21 00:00:00	2016-06-03	2016-06-03 00:00:00	32020		\N	237110	0	195662009	4112343		0
49899	2949	260139	1978-12-11	1978-12-11 00:00:00	1978-12-25	1978-12-25 00:00:00	32020		\N	196857	0	10509002	260139		0
60604	3582	40481087	1987-08-12	1987-08-12 00:00:00	1987-08-19	1987-08-19 00:00:00	32020		\N	238169	0	444814009	40481087		0
50242	2969	4156265	2002-02-28	2002-02-28 00:00:00	2002-03-21	2002-03-21 00:00:00	32020		\N	198247	0	370247008	4156265		0
60989	3610	80809	2017-04-18	2017-04-18 00:00:00	\N	\N	32020		\N	239893	0	69896004	80809		0
50621	2993	40481087	1971-03-19	1971-03-19 00:00:00	1971-03-26	1971-03-26 00:00:00	32020		\N	199779	0	444814009	40481087		0
50794	3004	4112343	2008-01-23	2008-01-23 00:00:00	2008-02-02	2008-02-02 00:00:00	32020		\N	200469	0	195662009	4112343		0
50949	3014	81151	1984-04-02	1984-04-02 00:00:00	1984-05-08	1984-05-08 00:00:00	32020		\N	200999	0	44465007	81151		0
51048	3022	4112343	1990-05-20	1990-05-20 00:00:00	1990-05-27	1990-05-27 00:00:00	32020		\N	201444	0	195662009	4112343		0
61852	3652	80180	2009-05-23	2009-05-23 00:00:00	\N	\N	32020		\N	243110	0	396275006	80180		0
61974	3658	257012	1991-11-06	1991-11-06 00:00:00	\N	\N	32020		\N	243481	0	40055000	257012		0
51604	3060	40481087	1930-11-05	1930-11-05 00:00:00	1930-11-19	1930-11-19 00:00:00	32020		\N	203555	0	444814009	40481087		0
62389	3686	378001	1982-12-31	1982-12-31 00:00:00	1983-03-01	1983-03-01 00:00:00	32020		\N	245051	0	62106007	378001		0
62452	3691	378001	1970-11-20	1970-11-20 00:00:00	1970-12-20	1970-12-20 00:00:00	32020		\N	245328	0	62106007	378001		0
52113	3086	260139	1980-05-27	1980-05-27 00:00:00	1980-06-03	1980-06-03 00:00:00	32020		\N	205435	0	10509002	260139		0
62776	3707	40481087	1994-06-27	1994-06-27 00:00:00	1994-07-18	1994-07-18 00:00:00	32020		\N	246407	0	444814009	40481087		0
52416	3105	40481087	2014-10-02	2014-10-02 00:00:00	2014-10-16	2014-10-16 00:00:00	32020		\N	206501	0	444814009	40481087		0
63217	3734	257012	1955-01-24	1955-01-24 00:00:00	\N	\N	32020		\N	248125	0	40055000	257012		0
63359	3743	372328	1978-07-10	1978-07-10 00:00:00	1978-10-22	1978-10-22 00:00:00	32020		\N	248733	0	65363002	372328		0
63499	3750	4134304	1999-03-20	1999-03-20 00:00:00	1999-06-18	1999-06-18 00:00:00	32020		\N	249241	0	263102004	4134304		0
63694	3761	372328	1957-11-12	1957-11-12 00:00:00	1958-03-29	1958-03-29 00:00:00	32020		\N	250076	0	65363002	372328		0
53137	3147	4112343	1970-01-04	1970-01-04 00:00:00	1970-01-11	1970-01-11 00:00:00	32020		\N	209414	0	195662009	4112343		0
53427	3167	4112343	2005-06-21	2005-06-21 00:00:00	2005-06-30	2005-06-30 00:00:00	32020		\N	210587	0	195662009	4112343		0
53530	3172	40481087	2016-12-14	2016-12-14 00:00:00	2016-12-28	2016-12-28 00:00:00	32020		\N	210823	0	444814009	40481087		0
53637	3177	260139	1936-05-16	1936-05-16 00:00:00	1936-05-30	1936-05-30 00:00:00	32020		\N	211266	0	10509002	260139		0
43273	2577	4310024	2010-02-27	2010-02-27 00:00:00	\N	\N	32020		\N	170669	0	424802006	4310024		0
54001	3196	80180	2008-05-22	2008-05-22 00:00:00	\N	\N	32020		\N	212609	0	396275006	80180		0
43600	2597	40481087	1971-06-30	1971-06-30 00:00:00	1971-07-21	1971-07-21 00:00:00	32020		\N	171830	0	444814009	40481087		0
54300	3216	4112343	2004-10-08	2004-10-08 00:00:00	2004-10-21	2004-10-21 00:00:00	32020		\N	213713	0	195662009	4112343		0
43963	2616	4112343	1966-03-02	1966-03-02 00:00:00	1966-03-11	1966-03-11 00:00:00	32020		\N	173011	0	195662009	4112343		0
54630	3234	317576	1955-05-03	1955-05-03 00:00:00	\N	\N	32020		\N	214953	0	53741008	317576		0
54795	3242	40481087	1994-02-24	1994-02-24 00:00:00	1994-03-17	1994-03-17 00:00:00	32020		\N	215632	0	444814009	40481087		0
55041	3258	4218389	1997-10-26	1997-10-26 00:00:00	1997-11-23	1997-11-23 00:00:00	32020		\N	216552	0	39848009	4218389		0
55247	3272	80180	2004-09-18	2004-09-18 00:00:00	\N	\N	32020		\N	217446	0	396275006	80180		0
55313	3277	40481087	1991-12-11	1991-12-11 00:00:00	1991-12-18	1991-12-18 00:00:00	32020		\N	217722	0	444814009	40481087		0
55462	3285	372328	1962-06-27	1962-06-27 00:00:00	1962-10-20	1962-10-20 00:00:00	32020		\N	218176	0	65363002	372328		0
55664	3295	378001	1951-01-24	1951-01-24 00:00:00	1951-02-23	1951-02-23 00:00:00	32020		\N	218893	0	62106007	378001		0
45262	2692	40481087	1972-05-18	1972-05-18 00:00:00	1972-06-01	1972-06-01 00:00:00	32020		\N	178352	0	444814009	40481087		0
56017	3315	4112343	1981-11-11	1981-11-11 00:00:00	1981-11-23	1981-11-23 00:00:00	32020		\N	220205	0	195662009	4112343		0
56154	3325	28060	2007-10-29	2007-10-29 00:00:00	2007-11-08	2007-11-08 00:00:00	32020		\N	220715	0	43878008	28060		0
56335	3339	40481087	1978-09-30	1978-09-30 00:00:00	1978-10-14	1978-10-14 00:00:00	32020		\N	221477	0	444814009	40481087		0
56464	3347	4116491	2005-05-02	2005-05-02 00:00:00	2005-06-18	2005-06-18 00:00:00	32020		\N	222024	0	301011002	4116491		0
56737	3364	78272	2012-07-29	2012-07-29 00:00:00	2012-08-26	2012-08-26 00:00:00	32020		\N	223108	0	70704007	78272		0
56812	3370	4156265	1977-06-14	1977-06-14 00:00:00	1977-06-28	1977-06-28 00:00:00	32020		\N	223392	0	370247008	4156265		0
46466	2767	260139	1961-08-01	1961-08-01 00:00:00	1961-08-15	1961-08-15 00:00:00	32020		\N	183022	0	10509002	260139		0
46594	2774	28060	2004-04-06	2004-04-06 00:00:00	2004-04-13	2004-04-13 00:00:00	32020		\N	183660	0	43878008	28060		0
57286	3399	4285898	2015-12-16	2015-12-16 00:00:00	\N	\N	32020		\N	225446	0	68496003	4285898		0
57456	3409	4112343	2010-04-28	2010-04-28 00:00:00	2010-05-05	2010-05-05 00:00:00	32020		\N	226057	0	195662009	4112343		0
57655	3420	40481087	1983-03-10	1983-03-10 00:00:00	1983-03-24	1983-03-24 00:00:00	32020		\N	226906	0	444814009	40481087		0
57810	3430	4134304	1972-10-15	1972-10-15 00:00:00	1973-01-13	1973-01-13 00:00:00	32020		\N	227329	0	263102004	4134304		0
57960	3437	260139	1980-11-30	1980-11-30 00:00:00	1980-12-14	1980-12-14 00:00:00	32020		\N	227970	0	10509002	260139		0
58112	3442	260139	2006-06-12	2006-06-12 00:00:00	2006-06-26	2006-06-26 00:00:00	32020		\N	228411	0	10509002	260139		0
47739	2835	378001	1927-08-17	1927-08-17 00:00:00	1927-10-16	1927-10-16 00:00:00	32020		\N	188301	0	62106007	378001		0
47932	2845	28060	1953-10-30	1953-10-30 00:00:00	1953-11-08	1953-11-08 00:00:00	32020		\N	188904	0	43878008	28060		0
58720	3483	40481087	2001-03-04	2001-03-04 00:00:00	2001-03-11	2001-03-11 00:00:00	32020		\N	231064	0	444814009	40481087		0
48234	2860	4283893	2006-09-01	2006-09-01 00:00:00	2006-09-22	2006-09-22 00:00:00	32020		\N	190128	0	36971009	4283893		0
48391	2866	4112343	1979-06-24	1979-06-24 00:00:00	1979-07-04	1979-07-04 00:00:00	32020		\N	190662	0	195662009	4112343		0
59197	3510	260139	1935-10-06	1935-10-06 00:00:00	1935-10-13	1935-10-13 00:00:00	32020		\N	232960	0	10509002	260139		0
69892	4134	80180	1988-11-15	1988-11-15 00:00:00	\N	\N	32020		\N	274901	0	396275006	80180		0
48947	2897	440086	1974-06-01	1974-06-01 00:00:00	1978-06-10	1978-06-10 00:00:00	32020		\N	192947	0	192127007	440086		0
59668	3536	4294548	2006-11-04	2006-11-04 00:00:00	2007-03-31	2007-03-31 00:00:00	32020		\N	234843	0	75498004	4294548		0
59843	3545	78272	2010-09-02	2010-09-02 00:00:00	2010-10-07	2010-10-07 00:00:00	32020		\N	235440	0	70704007	78272		0
59981	3553	4112343	1973-08-14	1973-08-14 00:00:00	1973-08-26	1973-08-26 00:00:00	32020		\N	235875	0	195662009	4112343		0
60126	3561	260139	2007-08-24	2007-08-24 00:00:00	2007-08-31	2007-08-31 00:00:00	32020		\N	236488	0	10509002	260139		0
60296	3568	260139	1976-04-24	1976-04-24 00:00:00	1976-05-08	1976-05-08 00:00:00	32020		\N	237066	0	10509002	260139		0
49900	2949	4218389	2010-05-30	2010-05-30 00:00:00	2010-07-04	2010-07-04 00:00:00	32020		\N	196815	0	39848009	4218389		0
60605	3582	192671	2001-10-27	2001-10-27 00:00:00	\N	\N	32020		\N	238165	0	K92.2	35208414		0
50243	2969	40481087	2006-01-30	2006-01-30 00:00:00	2006-02-13	2006-02-13 00:00:00	32020		\N	198223	0	444814009	40481087		0
60990	3610	40481087	1997-08-21	1997-08-21 00:00:00	1997-09-04	1997-09-04 00:00:00	32020		\N	239891	0	444814009	40481087		0
50622	2993	375671	1982-07-10	1982-07-10 00:00:00	1982-08-09	1982-08-09 00:00:00	32020		\N	199827	0	62564004	375671		0
50795	3004	4112343	1961-10-08	1961-10-08 00:00:00	1961-10-16	1961-10-16 00:00:00	32020		\N	200455	0	195662009	4112343		0
50950	3014	40481087	1992-10-20	1992-10-20 00:00:00	1992-11-09	1992-11-09 00:00:00	32020		\N	200986	0	444814009	40481087		0
51049	3023	4116491	2008-10-17	2008-10-17 00:00:00	2008-12-06	2008-12-06 00:00:00	32020		\N	201536	0	301011002	4116491		0
61853	3652	4112343	1981-05-03	1981-05-03 00:00:00	1981-05-14	1981-05-14 00:00:00	32020		\N	243099	0	195662009	4112343		0
61975	3658	372328	1962-07-27	1962-07-27 00:00:00	1962-11-11	1962-11-11 00:00:00	32020		\N	243483	0	65363002	372328		0
62085	3666	4113008	2013-06-02	2013-06-02 00:00:00	2013-06-23	2013-06-23 00:00:00	32020		\N	243869	0	284549007	4113008		0
62390	3686	378001	2011-01-01	2011-01-01 00:00:00	2011-01-31	2011-01-31 00:00:00	32020		\N	245054	0	62106007	378001		0
62453	3691	40481087	2007-02-04	2007-02-04 00:00:00	2007-02-11	2007-02-11 00:00:00	32020		\N	245297	0	444814009	40481087		0
52114	3086	40481087	1971-07-17	1971-07-17 00:00:00	1971-07-24	1971-07-24 00:00:00	32020		\N	205425	0	444814009	40481087		0
62777	3707	40481087	2002-02-13	2002-02-13 00:00:00	2002-02-27	2002-02-27 00:00:00	32020		\N	246437	0	444814009	40481087		0
52417	3105	260139	2016-07-02	2016-07-02 00:00:00	2016-07-16	2016-07-16 00:00:00	32020		\N	206492	0	10509002	260139		0
63218	3734	4112343	1957-10-31	1957-10-31 00:00:00	1957-11-13	1957-11-13 00:00:00	32020		\N	248096	0	195662009	4112343		0
63360	3743	260139	1990-05-18	1990-05-18 00:00:00	1990-05-25	1990-05-25 00:00:00	32020		\N	248732	0	10509002	260139		0
63500	3750	28060	1981-01-29	1981-01-29 00:00:00	1981-02-11	1981-02-11 00:00:00	32020		\N	249226	0	43878008	28060		0
63695	3761	4112343	1960-12-09	1960-12-09 00:00:00	1960-12-20	1960-12-20 00:00:00	32020		\N	250095	0	195662009	4112343		0
53138	3147	4112343	1955-08-20	1955-08-20 00:00:00	1955-08-30	1955-08-30 00:00:00	32020		\N	209370	0	195662009	4112343		0
53428	3167	40481087	2013-01-07	2013-01-07 00:00:00	2013-01-28	2013-01-28 00:00:00	32020		\N	210590	0	444814009	40481087		0
53531	3172	40481087	2018-09-27	2018-09-27 00:00:00	2018-10-04	2018-10-04 00:00:00	32020		\N	210824	0	444814009	40481087		0
53638	3177	40481087	1996-11-09	1996-11-09 00:00:00	1996-11-23	1996-11-23 00:00:00	32020		\N	211319	0	444814009	40481087		0
43274	2577	4156265	2013-02-02	2013-02-02 00:00:00	2013-02-23	2013-02-23 00:00:00	32020		\N	170636	0	370247008	4156265		0
54002	3196	4266809	2008-05-22	2008-05-22 00:00:00	\N	\N	32020		\N	212609	0	397881000	4266809		0
43601	2597	260139	1996-06-04	1996-06-04 00:00:00	1996-06-18	1996-06-18 00:00:00	32020		\N	171832	0	10509002	260139		0
54301	3216	4218389	1974-02-12	1974-02-12 00:00:00	1974-03-19	1974-03-19 00:00:00	32020		\N	213708	0	39848009	4218389		0
43964	2616	81151	1974-06-29	1974-06-29 00:00:00	1974-07-13	1974-07-13 00:00:00	32020		\N	172963	0	44465007	81151		0
54631	3234	28060	1976-09-20	1976-09-20 00:00:00	1976-10-02	1976-10-02 00:00:00	32020		\N	214925	0	43878008	28060		0
54796	3242	80180	2015-11-25	2015-11-25 00:00:00	\N	\N	32020		\N	215641	0	396275006	80180		0
55042	3258	260139	1989-08-22	1989-08-22 00:00:00	1989-08-29	1989-08-29 00:00:00	32020		\N	216555	0	10509002	260139		0
55248	3272	4283893	2003-03-16	2003-03-16 00:00:00	2003-12-28	2003-12-28 00:00:00	32020		\N	217412	0	36971009	4283893		0
55314	3277	372328	1965-08-23	1965-08-23 00:00:00	1965-11-12	1965-11-12 00:00:00	32020		\N	217714	0	65363002	372328		0
55463	3285	4112343	1994-09-13	1994-09-13 00:00:00	1994-09-23	1994-09-23 00:00:00	32020		\N	218214	0	195662009	4112343		0
55665	3295	40481087	1999-05-02	1999-05-02 00:00:00	1999-05-16	1999-05-16 00:00:00	32020		\N	218918	0	444814009	40481087		0
45263	2692	4113008	1959-07-17	1959-07-17 00:00:00	1959-07-31	1959-07-31 00:00:00	32020		\N	178361	0	284549007	4113008		0
56018	3315	4146173	2003-08-04	2003-08-04 00:00:00	2003-10-03	2003-10-03 00:00:00	32020		\N	220209	0	307731004	4146173		0
56155	3325	81151	1965-05-07	1965-05-07 00:00:00	1965-06-11	1965-06-11 00:00:00	32020		\N	220695	0	44465007	81151		0
56336	3339	78272	1961-08-03	1961-08-03 00:00:00	1961-09-07	1961-09-07 00:00:00	32020		\N	221538	0	70704007	78272		0
56465	3347	40481087	1961-11-12	1961-11-12 00:00:00	1961-12-03	1961-12-03 00:00:00	32020		\N	222067	0	444814009	40481087		0
56738	3364	28060	2013-10-18	2013-10-18 00:00:00	2013-10-30	2013-10-30 00:00:00	32020		\N	223065	0	43878008	28060		0
56813	3370	4112343	1976-06-08	1976-06-08 00:00:00	1976-06-16	1976-06-16 00:00:00	32020		\N	223396	0	195662009	4112343		0
46467	2767	260139	1957-11-11	1957-11-11 00:00:00	1957-11-18	1957-11-18 00:00:00	32020		\N	183049	0	10509002	260139		0
46595	2774	40481087	1950-06-15	1950-06-15 00:00:00	1950-06-29	1950-06-29 00:00:00	32020		\N	183723	0	444814009	40481087		0
57287	3399	30753	2015-02-19	2015-02-19 00:00:00	\N	\N	32020		\N	225446	0	16761005	30753		0
57457	3409	260139	1985-10-25	1985-10-25 00:00:00	1985-11-01	1985-11-01 00:00:00	32020		\N	226091	0	10509002	260139		0
57656	3420	378001	2000-02-12	2000-02-12 00:00:00	2000-04-12	2000-04-12 00:00:00	32020		\N	226911	0	62106007	378001		0
57811	3430	40481087	2012-08-16	2012-08-16 00:00:00	2012-09-06	2012-09-06 00:00:00	32020		\N	227343	0	444814009	40481087		0
57961	3437	40481087	1982-05-15	1982-05-15 00:00:00	1982-06-05	1982-06-05 00:00:00	32020		\N	227943	0	444814009	40481087		0
58113	3442	40481087	1962-03-13	1962-03-13 00:00:00	1962-03-27	1962-03-27 00:00:00	32020		\N	228396	0	444814009	40481087		0
47740	2835	40481087	1948-07-26	1948-07-26 00:00:00	1948-08-02	1948-08-02 00:00:00	32020		\N	188237	0	444814009	40481087		0
47933	2845	40481087	1973-07-13	1973-07-13 00:00:00	1973-07-20	1973-07-20 00:00:00	32020		\N	188910	0	444814009	40481087		0
58721	3483	40481087	1970-05-05	1970-05-05 00:00:00	1970-05-26	1970-05-26 00:00:00	32020		\N	231061	0	444814009	40481087		0
48235	2860	257012	1968-10-09	1968-10-09 00:00:00	1968-11-27	1968-11-27 00:00:00	32020		\N	190150	0	40055000	257012		0
48392	2866	372328	1967-09-01	1967-09-01 00:00:00	1967-10-15	1967-10-15 00:00:00	32020		\N	190655	0	65363002	372328		0
59198	3510	40481087	1991-01-13	1991-01-13 00:00:00	1991-01-20	1991-01-20 00:00:00	32020		\N	232912	0	444814009	40481087		0
69893	4134	4112343	1985-07-02	1985-07-02 00:00:00	1985-07-15	1985-07-15 00:00:00	32020		\N	274862	0	195662009	4112343		0
48948	2897	40481087	2004-04-21	2004-04-21 00:00:00	2004-05-12	2004-05-12 00:00:00	32020		\N	192927	0	444814009	40481087		0
59669	3536	4109685	1994-11-24	1994-11-24 00:00:00	1994-12-08	1994-12-08 00:00:00	32020		\N	234807	0	284551006	4109685		0
59844	3545	372328	1973-01-21	1973-01-21 00:00:00	1973-02-04	1973-02-04 00:00:00	32020		\N	235498	0	65363002	372328		0
59982	3553	4112343	1952-12-19	1952-12-19 00:00:00	1953-01-01	1953-01-01 00:00:00	32020		\N	235872	0	195662009	4112343		0
60127	3561	378001	1970-06-15	1970-06-15 00:00:00	1970-08-14	1970-08-14 00:00:00	32020		\N	236473	0	62106007	378001		0
60297	3568	372328	1970-02-23	1970-02-23 00:00:00	1970-05-07	1970-05-07 00:00:00	32020		\N	237075	0	65363002	372328		0
49901	2949	257012	1980-10-01	1980-10-01 00:00:00	\N	\N	32020		\N	196867	0	40055000	257012		0
60606	3583	4084167	1975-07-05	1975-07-05 00:00:00	1975-07-05	1975-07-05 00:00:00	32020		\N	238242	0	241929008	4084167		0
50244	2969	4112343	1985-11-28	1985-11-28 00:00:00	1985-12-07	1985-12-07 00:00:00	32020		\N	198248	0	195662009	4112343		0
60991	3610	40481087	1950-06-19	1950-06-19 00:00:00	1950-07-03	1950-07-03 00:00:00	32020		\N	239810	0	444814009	40481087		0
50623	2993	4152936	2017-01-19	2017-01-19 00:00:00	2017-02-09	2017-02-09 00:00:00	32020		\N	199831	0	283385000	4152936		0
50796	3004	4112343	1968-12-11	1968-12-11 00:00:00	1968-12-19	1968-12-19 00:00:00	32020		\N	200497	0	195662009	4112343		0
50951	3014	4112343	1990-11-29	1990-11-29 00:00:00	1990-12-09	1990-12-09 00:00:00	32020		\N	201018	0	195662009	4112343		0
51050	3023	4027663	2010-10-17	2010-10-17 00:00:00	\N	\N	32020		\N	201511	0	13200003	4027663		0
61854	3652	40481087	2007-03-02	2007-03-02 00:00:00	2007-03-23	2007-03-23 00:00:00	32020		\N	243101	0	444814009	40481087		0
61988	3660	4112343	1978-02-04	1978-02-04 00:00:00	1978-02-14	1978-02-14 00:00:00	32020		\N	243584	0	195662009	4112343		0
62086	3666	40481087	2005-09-24	2005-09-24 00:00:00	2005-10-01	2005-10-01 00:00:00	32020		\N	243861	0	444814009	40481087		0
62391	3686	40481087	1983-05-13	1983-05-13 00:00:00	1983-05-20	1983-05-20 00:00:00	32020		\N	245028	0	444814009	40481087		0
62454	3691	81151	1959-07-02	1959-07-02 00:00:00	1959-07-16	1959-07-16 00:00:00	32020		\N	245350	0	44465007	81151		0
52115	3086	40481087	2010-05-04	2010-05-04 00:00:00	2010-05-18	2010-05-18 00:00:00	32020		\N	205470	0	444814009	40481087		0
62778	3707	40481087	2004-05-07	2004-05-07 00:00:00	2004-05-14	2004-05-14 00:00:00	32020		\N	246409	0	444814009	40481087		0
52418	3105	40481087	1987-10-13	1987-10-13 00:00:00	1987-10-20	1987-10-20 00:00:00	32020		\N	206511	0	444814009	40481087		0
63219	3734	260139	1950-04-10	1950-04-10 00:00:00	1950-04-24	1950-04-24 00:00:00	32020		\N	248121	0	10509002	260139		0
63361	3743	260139	1981-11-22	1981-11-22 00:00:00	1981-11-29	1981-11-29 00:00:00	32020		\N	248692	0	10509002	260139		0
63501	3750	4112343	2005-09-05	2005-09-05 00:00:00	2005-09-15	2005-09-15 00:00:00	32020		\N	249229	0	195662009	4112343		0
63696	3761	260139	1958-10-10	1958-10-10 00:00:00	1958-10-24	1958-10-24 00:00:00	32020		\N	250051	0	10509002	260139		0
53139	3147	4059173	1955-01-29	1955-01-29 00:00:00	1955-04-29	1955-04-29 00:00:00	32020		\N	209351	0	16114001	4059173		0
53429	3167	4112343	2016-12-16	2016-12-16 00:00:00	2016-12-24	2016-12-24 00:00:00	32020		\N	210591	0	195662009	4112343		0
53532	3172	4155034	1982-12-20	1982-12-20 00:00:00	1983-01-03	1983-01-03 00:00:00	32020		\N	210820	0	283371005	4155034		0
53639	3177	260139	2008-06-05	2008-06-05 00:00:00	2008-06-19	2008-06-19 00:00:00	32020		\N	211321	0	10509002	260139		0
43275	2577	4084167	1991-02-07	1991-02-07 00:00:00	1991-02-07	1991-02-07 00:00:00	32020		\N	170635	0	241929008	4084167		0
54003	3196	40481087	1993-01-02	1993-01-02 00:00:00	1993-01-16	1993-01-16 00:00:00	32020		\N	212648	0	444814009	40481087		0
43602	2597	40481087	1997-02-24	1997-02-24 00:00:00	1997-03-17	1997-03-17 00:00:00	32020		\N	171836	0	444814009	40481087		0
54302	3216	4310024	1993-07-12	1993-07-12 00:00:00	\N	\N	32020		\N	213701	0	424802006	4310024		0
43965	2617	40481087	2008-09-18	2008-09-18 00:00:00	2008-09-25	2008-09-25 00:00:00	32020		\N	173083	0	444814009	40481087		0
54632	3234	4294548	1953-11-30	1953-11-30 00:00:00	1953-12-14	1953-12-14 00:00:00	32020		\N	214922	0	75498004	4294548		0
54797	3242	260139	1982-01-09	1982-01-09 00:00:00	1982-01-16	1982-01-16 00:00:00	32020		\N	215616	0	10509002	260139		0
55043	3258	40481087	1996-04-05	1996-04-05 00:00:00	1996-04-19	1996-04-19 00:00:00	32020		\N	216579	0	444814009	40481087		0
55249	3272	257012	2003-05-04	2003-05-04 00:00:00	2003-12-28	2003-12-28 00:00:00	32020		\N	217469	0	40055000	257012		0
55315	3277	4112343	1978-05-11	1978-05-11 00:00:00	1978-05-24	1978-05-24 00:00:00	32020		\N	217720	0	195662009	4112343		0
55464	3285	28060	1963-01-26	1963-01-26 00:00:00	1963-02-04	1963-02-04 00:00:00	32020		\N	218170	0	43878008	28060		0
55666	3295	40481087	1997-03-31	1997-03-31 00:00:00	1997-04-21	1997-04-21 00:00:00	32020		\N	218972	0	444814009	40481087		0
45264	2692	317576	1995-12-11	1995-12-11 00:00:00	\N	\N	32020		\N	178359	0	53741008	317576		0
56019	3315	40481087	1966-05-02	1966-05-02 00:00:00	1966-05-23	1966-05-23 00:00:00	32020		\N	220135	0	444814009	40481087		0
56156	3325	40481087	1985-07-23	1985-07-23 00:00:00	1985-08-06	1985-08-06 00:00:00	32020		\N	220723	0	444814009	40481087		0
56337	3339	260139	2012-09-13	2012-09-13 00:00:00	2012-09-27	2012-09-27 00:00:00	32020		\N	221478	0	10509002	260139		0
56466	3347	40481087	1986-07-18	1986-07-18 00:00:00	1986-08-01	1986-08-01 00:00:00	32020		\N	222023	0	444814009	40481087		0
56739	3364	40481087	2012-08-19	2012-08-19 00:00:00	2012-08-26	2012-08-26 00:00:00	32020		\N	223091	0	444814009	40481087		0
56814	3370	4294548	2003-09-30	2003-09-30 00:00:00	2003-12-30	2003-12-30 00:00:00	32020		\N	223484	0	75498004	4294548		0
46468	2767	260139	2002-12-27	2002-12-27 00:00:00	2003-01-10	2003-01-10 00:00:00	32020		\N	183076	0	10509002	260139		0
46596	2774	4112343	1968-11-02	1968-11-02 00:00:00	1968-11-15	1968-11-15 00:00:00	32020		\N	183657	0	195662009	4112343		0
57288	3399	40481087	1987-06-26	1987-06-26 00:00:00	1987-07-10	1987-07-10 00:00:00	32020		\N	225511	0	444814009	40481087		0
57458	3409	260139	1982-05-27	1982-05-27 00:00:00	1982-06-03	1982-06-03 00:00:00	32020		\N	226090	0	10509002	260139		0
57657	3420	4112343	1997-06-19	1997-06-19 00:00:00	1997-07-02	1997-07-02 00:00:00	32020		\N	226872	0	195662009	4112343		0
57812	3430	40481087	2000-03-25	2000-03-25 00:00:00	2000-04-15	2000-04-15 00:00:00	32020		\N	227342	0	444814009	40481087		0
57962	3437	40481087	1924-04-02	1924-04-02 00:00:00	1924-04-16	1924-04-16 00:00:00	32020		\N	228006	0	444814009	40481087		0
58114	3442	4116491	1999-06-03	1999-06-03 00:00:00	1999-07-19	1999-07-19 00:00:00	32020		\N	228400	0	301011002	4116491		0
47741	2835	40481087	1997-04-01	1997-04-01 00:00:00	1997-04-08	1997-04-08 00:00:00	32020		\N	188271	0	444814009	40481087		0
47934	2845	260139	1961-01-19	1961-01-19 00:00:00	1961-02-02	1961-02-02 00:00:00	32020		\N	188905	0	10509002	260139		0
58722	3483	80180	1988-12-31	1988-12-31 00:00:00	\N	\N	32020		\N	231004	0	396275006	80180		0
48236	2860	80180	1982-05-25	1982-05-25 00:00:00	\N	\N	32020		\N	190116	0	396275006	80180		0
48393	2866	28060	1970-01-29	1970-01-29 00:00:00	1970-02-09	1970-02-09 00:00:00	32020		\N	190645	0	43878008	28060		0
59199	3510	4112343	2019-05-15	2019-05-15 00:00:00	2019-05-22	2019-05-22 00:00:00	32020		\N	232833	0	195662009	4112343		0
69894	4134	28060	1985-08-18	1985-08-18 00:00:00	1985-08-29	1985-08-29 00:00:00	32020		\N	274897	0	43878008	28060		0
48949	2897	4112343	1998-03-11	1998-03-11 00:00:00	1998-03-24	1998-03-24 00:00:00	32020		\N	192925	0	195662009	4112343		0
59670	3536	40481087	1969-02-15	1969-02-15 00:00:00	1969-03-01	1969-03-01 00:00:00	32020		\N	234848	0	444814009	40481087		0
59845	3545	78272	1994-07-30	1994-07-30 00:00:00	1994-08-27	1994-08-27 00:00:00	32020		\N	235439	0	70704007	78272		0
59983	3553	260139	1973-09-24	1973-09-24 00:00:00	1973-10-01	1973-10-01 00:00:00	32020		\N	235925	0	10509002	260139		0
60128	3561	40481087	1965-11-14	1965-11-14 00:00:00	1965-11-28	1965-11-28 00:00:00	32020		\N	236485	0	444814009	40481087		0
60298	3568	4294548	1978-11-15	1978-11-15 00:00:00	1979-02-07	1979-02-07 00:00:00	32020		\N	237067	0	75498004	4294548		0
49902	2949	4059173	1956-05-24	1956-05-24 00:00:00	1956-06-23	1956-06-23 00:00:00	32020		\N	196877	0	16114001	4059173		0
60607	3583	4112343	1989-08-21	1989-08-21 00:00:00	1989-08-29	1989-08-29 00:00:00	32020		\N	238235	0	195662009	4112343		0
50245	2969	40481087	1976-05-01	1976-05-01 00:00:00	1976-05-08	1976-05-08 00:00:00	32020		\N	198205	0	444814009	40481087		0
60992	3610	260139	1992-07-14	1992-07-14 00:00:00	1992-07-28	1992-07-28 00:00:00	32020		\N	239890	0	10509002	260139		0
50624	2993	40481087	2001-02-23	2001-02-23 00:00:00	2001-03-16	2001-03-16 00:00:00	32020		\N	199801	0	444814009	40481087		0
61255	3622	195588	1970-05-12	1970-05-12 00:00:00	1970-06-23	1970-06-23 00:00:00	32020		\N	240791	0	38822007	195588		0
50952	3014	40479422	2013-06-05	2013-06-05 00:00:00	2013-08-11	2013-08-11 00:00:00	32020		\N	201001	0	444448004	40479422		0
51051	3023	40481087	2013-01-09	2013-01-09 00:00:00	2013-01-16	2013-01-16 00:00:00	32020		\N	201519	0	444814009	40481087		0
61855	3652	260139	2015-03-04	2015-03-04 00:00:00	2015-03-11	2015-03-11 00:00:00	32020		\N	243129	0	10509002	260139		0
61989	3660	40481087	2011-09-16	2011-09-16 00:00:00	2011-09-30	2011-09-30 00:00:00	32020		\N	243561	0	444814009	40481087		0
62087	3666	260139	1971-10-30	1971-10-30 00:00:00	1971-11-06	1971-11-06 00:00:00	32020		\N	243880	0	10509002	260139		0
62392	3686	4285898	2009-07-02	2009-07-02 00:00:00	\N	\N	32020		\N	245046	0	68496003	4285898		0
62455	3691	372328	1957-05-29	1957-05-29 00:00:00	1957-07-19	1957-07-19 00:00:00	32020		\N	245359	0	65363002	372328		0
52116	3086	4112343	1971-10-14	1971-10-14 00:00:00	1971-10-26	1971-10-26 00:00:00	32020		\N	205443	0	195662009	4112343		0
62779	3707	372328	1970-04-07	1970-04-07 00:00:00	1970-06-08	1970-06-08 00:00:00	32020		\N	246466	0	65363002	372328		0
52419	3105	372328	1972-02-29	1972-02-29 00:00:00	1972-07-03	1972-07-03 00:00:00	32020		\N	206494	0	65363002	372328		0
63220	3734	260139	1957-03-07	1957-03-07 00:00:00	1957-03-14	1957-03-14 00:00:00	32020		\N	248095	0	10509002	260139		0
63362	3743	80180	2017-10-23	2017-10-23 00:00:00	\N	\N	32020		\N	248719	0	396275006	80180		0
63502	3750	372328	1960-12-18	1960-12-18 00:00:00	1961-04-01	1961-04-01 00:00:00	32020		\N	249238	0	65363002	372328		0
63697	3761	4112343	2003-06-12	2003-06-12 00:00:00	2003-06-21	2003-06-21 00:00:00	32020		\N	250075	0	195662009	4112343		0
53140	3147	40481087	1998-02-20	1998-02-20 00:00:00	1998-02-27	1998-02-27 00:00:00	32020		\N	209432	0	444814009	40481087		0
53430	3167	372328	1964-11-22	1964-11-22 00:00:00	1965-05-16	1965-05-16 00:00:00	32020		\N	210597	0	65363002	372328		0
53533	3172	372328	1983-04-19	1983-04-19 00:00:00	1983-11-10	1983-11-10 00:00:00	32020		\N	210863	0	65363002	372328		0
53640	3177	260139	2006-04-08	2006-04-08 00:00:00	2006-04-15	2006-04-15 00:00:00	32020		\N	211272	0	10509002	260139		0
43276	2577	28060	1976-01-15	1976-01-15 00:00:00	1976-01-23	1976-01-23 00:00:00	32020		\N	170619	0	43878008	28060		0
54004	3196	4112343	2012-09-14	2012-09-14 00:00:00	2012-09-26	2012-09-26 00:00:00	32020		\N	212621	0	195662009	4112343		0
43603	2597	81893	2009-02-07	2009-02-07 00:00:00	\N	\N	32020		\N	171863	0	64766004	81893		0
54303	3216	260139	2002-06-13	2002-06-13 00:00:00	2002-06-27	2002-06-27 00:00:00	32020		\N	213712	0	10509002	260139		0
43966	2617	40481087	1984-04-12	1984-04-12 00:00:00	1984-05-03	1984-05-03 00:00:00	32020		\N	173045	0	444814009	40481087		0
54633	3234	80180	1990-02-03	1990-02-03 00:00:00	\N	\N	32020		\N	214938	0	396275006	80180		0
54798	3242	260139	2002-10-04	2002-10-04 00:00:00	2002-10-18	2002-10-18 00:00:00	32020		\N	215620	0	10509002	260139		0
55044	3258	4112343	1991-04-27	1991-04-27 00:00:00	1991-05-06	1991-05-06 00:00:00	32020		\N	216560	0	195662009	4112343		0
55250	3272	372328	1971-08-03	1971-08-03 00:00:00	1971-08-17	1971-08-17 00:00:00	32020		\N	217474	0	65363002	372328		0
55316	3277	4112343	1963-07-08	1963-07-08 00:00:00	1963-07-15	1963-07-15 00:00:00	32020		\N	217719	0	195662009	4112343		0
55465	3285	260139	1981-04-15	1981-04-15 00:00:00	1981-04-29	1981-04-29 00:00:00	32020		\N	218213	0	10509002	260139		0
55667	3295	40481087	1978-08-25	1978-08-25 00:00:00	1978-09-01	1978-09-01 00:00:00	32020		\N	218969	0	444814009	40481087		0
45265	2692	4001336	1960-08-24	1960-08-24 00:00:00	1960-10-23	1960-10-23 00:00:00	32020		\N	178362	0	110030002	4001336		0
56020	3315	40481087	2013-12-24	2013-12-24 00:00:00	2013-12-31	2013-12-31 00:00:00	32020		\N	220210	0	444814009	40481087		0
56157	3325	80180	2004-12-23	2004-12-23 00:00:00	\N	\N	32020		\N	220738	0	396275006	80180		0
56338	3339	260139	1993-06-17	1993-06-17 00:00:00	1993-06-24	1993-06-24 00:00:00	32020		\N	221504	0	10509002	260139		0
56467	3347	40481087	2007-03-20	2007-03-20 00:00:00	2007-04-10	2007-04-10 00:00:00	32020		\N	222040	0	444814009	40481087		0
56740	3365	4112343	2017-03-09	2017-03-09 00:00:00	2017-03-19	2017-03-19 00:00:00	32020		\N	223201	0	195662009	4112343		0
56815	3370	372328	1977-05-01	1977-05-01 00:00:00	1977-09-04	1977-09-04 00:00:00	32020		\N	223488	0	65363002	372328		0
46469	2767	40481087	1975-05-13	1975-05-13 00:00:00	1975-06-03	1975-06-03 00:00:00	32020		\N	183070	0	444814009	40481087		0
46597	2774	260139	1952-01-18	1952-01-18 00:00:00	1952-01-25	1952-01-25 00:00:00	32020		\N	183724	0	10509002	260139		0
57289	3399	40481087	1997-05-22	1997-05-22 00:00:00	1997-06-12	1997-06-12 00:00:00	32020		\N	225471	0	444814009	40481087		0
57459	3409	40481087	1968-03-18	1968-03-18 00:00:00	1968-04-01	1968-04-01 00:00:00	32020		\N	226089	0	444814009	40481087		0
57658	3420	260139	1993-04-22	1993-04-22 00:00:00	1993-04-29	1993-04-29 00:00:00	32020		\N	226867	0	10509002	260139		0
57813	3430	4146173	1995-08-16	1995-08-16 00:00:00	1995-10-15	1995-10-15 00:00:00	32020		\N	227355	0	307731004	4146173		0
57963	3437	40481087	1943-07-05	1943-07-05 00:00:00	1943-07-12	1943-07-12 00:00:00	32020		\N	228007	0	444814009	40481087		0
58115	3442	4112343	1967-07-07	1967-07-07 00:00:00	1967-07-14	1967-07-14 00:00:00	32020		\N	228428	0	195662009	4112343		0
47742	2835	40481087	2005-01-02	2005-01-02 00:00:00	2005-01-16	2005-01-16 00:00:00	32020		\N	188217	0	444814009	40481087		0
47935	2845	40481087	1966-03-31	1966-03-31 00:00:00	1966-04-14	1966-04-14 00:00:00	32020		\N	188909	0	444814009	40481087		0
58723	3483	40481087	1970-08-01	1970-08-01 00:00:00	1970-08-15	1970-08-15 00:00:00	32020		\N	231087	0	444814009	40481087		0
48237	2860	40481087	2014-01-20	2014-01-20 00:00:00	2014-01-27	2014-01-27 00:00:00	32020		\N	190159	0	444814009	40481087		0
48394	2866	40481087	1994-09-29	1994-09-29 00:00:00	1994-10-13	1994-10-13 00:00:00	32020		\N	190680	0	444814009	40481087		0
59200	3510	4048171	1937-03-14	1937-03-14 00:00:00	1954-03-12	1954-03-12 00:00:00	32020		\N	232903	0	232353008	4048171		0
69895	4134	78272	2014-09-23	2014-09-23 00:00:00	2014-10-07	2014-10-07 00:00:00	32020		\N	274822	0	70704007	78272		0
48950	2897	40481087	2012-11-13	2012-11-13 00:00:00	2012-11-20	2012-11-20 00:00:00	32020		\N	192966	0	444814009	40481087		0
59671	3536	4112343	1999-08-24	1999-08-24 00:00:00	1999-09-04	1999-09-04 00:00:00	32020		\N	234816	0	195662009	4112343		0
59846	3545	4112343	1996-01-09	1996-01-09 00:00:00	1996-01-20	1996-01-20 00:00:00	32020		\N	235484	0	195662009	4112343		0
59984	3553	4112343	1951-01-04	1951-01-04 00:00:00	1951-01-12	1951-01-12 00:00:00	32020		\N	235923	0	195662009	4112343		0
60129	3561	4112343	1972-08-16	1972-08-16 00:00:00	1972-08-25	1972-08-25 00:00:00	32020		\N	236511	0	195662009	4112343		0
60299	3568	257012	1978-12-13	1978-12-13 00:00:00	\N	\N	32020		\N	237104	0	40055000	257012		0
49903	2949	40479768	1974-10-17	1974-10-17 00:00:00	1974-11-23	1974-11-23 00:00:00	32020		\N	196879	0	444470001	40479768		0
60608	3583	4048171	1973-11-11	1973-11-11 00:00:00	\N	\N	32020		\N	238240	0	232353008	4048171		0
50246	2969	260139	2000-11-03	2000-11-03 00:00:00	2000-11-17	2000-11-17 00:00:00	32020		\N	198250	0	10509002	260139		0
60993	3610	4112343	2012-12-24	2012-12-24 00:00:00	2013-01-01	2013-01-01 00:00:00	32020		\N	239845	0	195662009	4112343		0
50625	2993	40481087	2015-05-20	2015-05-20 00:00:00	2015-06-03	2015-06-03 00:00:00	32020		\N	199803	0	444814009	40481087		0
61256	3622	313217	1999-10-27	1999-10-27 00:00:00	\N	\N	32020		\N	240697	0	49436004	313217		0
50953	3014	257012	1991-02-07	1991-02-07 00:00:00	\N	\N	32020		\N	200985	0	40055000	257012		0
51052	3023	40481087	1999-09-29	1999-09-29 00:00:00	1999-10-20	1999-10-20 00:00:00	32020		\N	201535	0	444814009	40481087		0
61856	3652	4112343	1977-09-22	1977-09-22 00:00:00	1977-10-04	1977-10-04 00:00:00	32020		\N	243078	0	195662009	4112343		0
61990	3660	195588	1998-08-16	1998-08-16 00:00:00	1998-09-30	1998-09-30 00:00:00	32020		\N	243595	0	38822007	195588		0
62088	3667	80180	2007-01-22	2007-01-22 00:00:00	\N	\N	32020		\N	243970	0	396275006	80180		0
62393	3686	4027663	2000-11-11	2000-11-11 00:00:00	\N	\N	32020		\N	245075	0	13200003	4027663		0
62456	3691	40481087	2015-12-23	2015-12-23 00:00:00	2016-01-13	2016-01-13 00:00:00	32020		\N	245358	0	444814009	40481087		0
52117	3086	260139	2014-10-22	2014-10-22 00:00:00	2014-11-05	2014-11-05 00:00:00	32020		\N	205446	0	10509002	260139		0
62780	3708	260139	1998-06-30	1998-06-30 00:00:00	1998-07-14	1998-07-14 00:00:00	32020		\N	246524	0	10509002	260139		0
52420	3105	81151	2000-10-13	2000-10-13 00:00:00	2000-11-03	2000-11-03 00:00:00	32020		\N	206481	0	44465007	81151		0
63221	3734	4116491	1987-07-08	1987-07-08 00:00:00	1987-08-26	1987-08-26 00:00:00	32020		\N	248152	0	301011002	4116491		0
63363	3743	4059173	1979-07-05	1979-07-05 00:00:00	1979-10-03	1979-10-03 00:00:00	32020		\N	248689	0	16114001	4059173		0
63503	3750	4112343	1990-01-27	1990-01-27 00:00:00	1990-02-03	1990-02-03 00:00:00	32020		\N	249227	0	195662009	4112343		0
63698	3761	40481087	2007-09-15	2007-09-15 00:00:00	2007-09-22	2007-09-22 00:00:00	32020		\N	250069	0	444814009	40481087		0
53141	3147	4283893	1959-05-13	1959-05-13 00:00:00	1959-06-10	1959-06-10 00:00:00	32020		\N	209371	0	36971009	4283893		0
53431	3167	4283893	1990-05-25	1990-05-25 00:00:00	1990-08-31	1990-08-31 00:00:00	32020		\N	210594	0	36971009	4283893		0
53534	3172	4112343	1997-02-15	1997-02-15 00:00:00	1997-02-28	1997-02-28 00:00:00	32020		\N	210835	0	195662009	4112343		0
53641	3177	4112343	1948-02-12	1948-02-12 00:00:00	1948-02-25	1948-02-25 00:00:00	32020		\N	211353	0	195662009	4112343		0
43277	2577	4113008	1986-07-03	1986-07-03 00:00:00	1986-07-24	1986-07-24 00:00:00	32020		\N	170634	0	284549007	4113008		0
54005	3196	260139	2011-09-07	2011-09-07 00:00:00	2011-09-14	2011-09-14 00:00:00	32020		\N	212620	0	10509002	260139		0
43604	2597	30753	2009-09-05	2009-09-05 00:00:00	\N	\N	32020		\N	171863	0	16761005	30753		0
54304	3217	4109685	1992-01-19	1992-01-19 00:00:00	1992-02-09	1992-02-09 00:00:00	32020		\N	213809	0	284551006	4109685		0
43967	2617	4112343	1962-08-18	1962-08-18 00:00:00	1962-08-29	1962-08-29 00:00:00	32020		\N	173058	0	195662009	4112343		0
54634	3234	40481087	1957-09-14	1957-09-14 00:00:00	1957-10-05	1957-10-05 00:00:00	32020		\N	214930	0	444814009	40481087		0
54799	3242	4112343	1989-07-03	1989-07-03 00:00:00	1989-07-14	1989-07-14 00:00:00	32020		\N	215593	0	195662009	4112343		0
55045	3258	28060	1989-04-26	1989-04-26 00:00:00	1989-05-03	1989-05-03 00:00:00	32020		\N	216558	0	43878008	28060		0
55251	3272	40481087	1971-07-12	1971-07-12 00:00:00	1971-07-26	1971-07-26 00:00:00	32020		\N	217416	0	444814009	40481087		0
55317	3277	81151	1998-11-19	1998-11-19 00:00:00	1998-12-10	1998-12-10 00:00:00	32020		\N	217693	0	44465007	81151		0
55474	3287	4296204	1965-02-20	1965-02-20 00:00:00	1965-03-20	1965-03-20 00:00:00	32020		\N	218350	0	403190006	4296204		0
55668	3295	40481087	1965-12-18	1965-12-18 00:00:00	1966-01-01	1966-01-01 00:00:00	32020		\N	218925	0	444814009	40481087		0
45266	2692	4283893	1992-09-23	1992-09-23 00:00:00	1992-10-28	1992-10-28 00:00:00	32020		\N	178315	0	36971009	4283893		0
56065	3320	81151	1978-02-07	1978-02-07 00:00:00	1978-02-21	1978-02-21 00:00:00	32020		\N	220478	0	44465007	81151		0
56158	3325	28060	1964-06-12	1964-06-12 00:00:00	1964-06-22	1964-06-22 00:00:00	32020		\N	220742	0	43878008	28060		0
56339	3339	28060	1960-10-08	1960-10-08 00:00:00	1960-10-18	1960-10-18 00:00:00	32020		\N	221501	0	43878008	28060		0
56468	3347	4218389	1990-10-17	1990-10-17 00:00:00	1990-11-07	1990-11-07 00:00:00	32020		\N	222018	0	39848009	4218389		0
56741	3365	4112343	1973-11-01	1973-11-01 00:00:00	1973-11-14	1973-11-14 00:00:00	32020		\N	223172	0	195662009	4112343		0
56816	3370	260139	2005-05-04	2005-05-04 00:00:00	2005-05-18	2005-05-18 00:00:00	32020		\N	223486	0	10509002	260139		0
46470	2767	40481087	1974-02-24	1974-02-24 00:00:00	1974-03-10	1974-03-10 00:00:00	32020		\N	183069	0	444814009	40481087		0
46598	2774	40481087	1947-02-05	1947-02-05 00:00:00	1947-02-26	1947-02-26 00:00:00	32020		\N	183639	0	444814009	40481087		0
57290	3399	4112343	1990-10-23	1990-10-23 00:00:00	1990-11-02	1990-11-02 00:00:00	32020		\N	225488	0	195662009	4112343		0
57460	3409	40481087	2000-09-01	2000-09-01 00:00:00	2000-09-08	2000-09-08 00:00:00	32020		\N	226073	0	444814009	40481087		0
57659	3420	40481087	2013-01-03	2013-01-03 00:00:00	2013-01-24	2013-01-24 00:00:00	32020		\N	226891	0	444814009	40481087		0
57814	3430	40481087	1963-09-10	1963-09-10 00:00:00	1963-09-24	1963-09-24 00:00:00	32020		\N	227394	0	444814009	40481087		0
57964	3437	4299128	1920-03-16	1920-03-16 00:00:00	1920-04-13	1920-04-13 00:00:00	32020		\N	228018	0	403192003	4299128		0
58116	3442	80180	2001-03-24	2001-03-24 00:00:00	\N	\N	32020		\N	228424	0	396275006	80180		0
47743	2835	4296204	1963-02-14	1963-02-14 00:00:00	1963-03-14	1963-03-14 00:00:00	32020		\N	188341	0	403190006	4296204		0
47936	2845	4112343	1994-12-16	1994-12-16 00:00:00	1994-12-26	1994-12-26 00:00:00	32020		\N	188902	0	195662009	4112343		0
58724	3483	4112343	1968-04-15	1968-04-15 00:00:00	1968-04-24	1968-04-24 00:00:00	32020		\N	231086	0	195662009	4112343		0
48238	2860	4134304	2001-11-01	2001-11-01 00:00:00	2001-12-01	2001-12-01 00:00:00	32020		\N	190130	0	263102004	4134304		0
48395	2866	40481087	1977-02-13	1977-02-13 00:00:00	1977-02-27	1977-02-27 00:00:00	32020		\N	190674	0	444814009	40481087		0
59218	3513	4113008	2016-07-08	2016-07-08 00:00:00	2016-07-29	2016-07-29 00:00:00	32020		\N	233120	0	284549007	4113008		0
69896	4134	4112343	2018-10-19	2018-10-19 00:00:00	2018-10-31	2018-10-31 00:00:00	32020		\N	274899	0	195662009	4112343		0
48951	2897	40481087	1994-02-27	1994-02-27 00:00:00	1994-03-13	1994-03-13 00:00:00	32020		\N	192965	0	444814009	40481087		0
59672	3536	80180	2000-01-17	2000-01-17 00:00:00	\N	\N	32020		\N	234816	0	396275006	80180		0
59857	3547	4112343	2009-06-28	2009-06-28 00:00:00	2009-07-05	2009-07-05 00:00:00	32020		\N	235595	0	195662009	4112343		0
59985	3553	40481087	2007-05-12	2007-05-12 00:00:00	2007-05-26	2007-05-26 00:00:00	32020		\N	235929	0	444814009	40481087		0
60130	3561	40481087	2014-04-19	2014-04-19 00:00:00	2014-05-10	2014-05-10 00:00:00	32020		\N	236521	0	444814009	40481087		0
60300	3569	4027663	1990-10-27	1990-10-27 00:00:00	\N	\N	32020		\N	237176	0	13200003	4027663		0
49904	2949	40481087	1991-06-16	1991-06-16 00:00:00	1991-06-30	1991-06-30 00:00:00	32020		\N	196858	0	444814009	40481087		0
60609	3583	81151	2003-02-10	2003-02-10 00:00:00	2003-03-17	2003-03-17 00:00:00	32020		\N	238207	0	44465007	81151		0
50247	2969	4113008	1986-03-03	1986-03-03 00:00:00	1986-03-24	1986-03-24 00:00:00	32020		\N	198246	0	284549007	4113008		0
60994	3610	260139	2003-12-05	2003-12-05 00:00:00	2003-12-12	2003-12-12 00:00:00	32020		\N	239892	0	10509002	260139		0
50626	2993	40481087	1990-02-23	1990-02-23 00:00:00	1990-03-16	1990-03-16 00:00:00	32020		\N	199795	0	444814009	40481087		0
61257	3622	4112343	2000-07-29	2000-07-29 00:00:00	2000-08-10	2000-08-10 00:00:00	32020		\N	240665	0	195662009	4112343		0
50954	3014	260139	2000-03-19	2000-03-19 00:00:00	2000-03-26	2000-03-26 00:00:00	32020		\N	200987	0	10509002	260139		0
51053	3023	378001	1982-11-18	1982-11-18 00:00:00	1982-12-18	1982-12-18 00:00:00	32020		\N	201507	0	62106007	378001		0
61857	3652	4294548	2010-07-11	2010-07-11 00:00:00	2010-07-25	2010-07-25 00:00:00	32020		\N	243116	0	75498004	4294548		0
61991	3660	40481087	2016-02-15	2016-02-15 00:00:00	2016-02-29	2016-02-29 00:00:00	32020		\N	243569	0	444814009	40481087		0
62089	3667	28060	1977-09-15	1977-09-15 00:00:00	1977-09-27	1977-09-27 00:00:00	32020		\N	243945	0	43878008	28060		0
62394	3686	40481087	1982-03-29	1982-03-29 00:00:00	1982-04-12	1982-04-12 00:00:00	32020		\N	245025	0	444814009	40481087		0
62457	3691	40481087	1970-06-27	1970-06-27 00:00:00	1970-07-11	1970-07-11 00:00:00	32020		\N	245339	0	444814009	40481087		0
52118	3086	28060	1982-05-27	1982-05-27 00:00:00	1982-06-03	1982-06-03 00:00:00	32020		\N	205444	0	43878008	28060		0
62781	3708	260139	1984-07-20	1984-07-20 00:00:00	1984-07-27	1984-07-27 00:00:00	32020		\N	246565	0	10509002	260139		0
52421	3105	40481087	1996-04-11	1996-04-11 00:00:00	1996-04-25	1996-04-25 00:00:00	32020		\N	206500	0	444814009	40481087		0
63222	3734	4112343	1989-04-04	1989-04-04 00:00:00	1989-04-16	1989-04-16 00:00:00	32020		\N	248153	0	195662009	4112343		0
63364	3743	4112343	1986-03-02	1986-03-02 00:00:00	1986-03-15	1986-03-15 00:00:00	32020		\N	248694	0	195662009	4112343		0
63504	3750	372328	1974-02-25	1974-02-25 00:00:00	1974-12-07	1974-12-07 00:00:00	32020		\N	249259	0	65363002	372328		0
63699	3761	40481087	1987-06-11	1987-06-11 00:00:00	1987-06-18	1987-06-18 00:00:00	32020		\N	250064	0	444814009	40481087		0
53142	3147	378001	1977-08-29	1977-08-29 00:00:00	1977-10-28	1977-10-28 00:00:00	32020		\N	209354	0	62106007	378001		0
53432	3167	40481087	2008-09-07	2008-09-07 00:00:00	2008-09-21	2008-09-21 00:00:00	32020		\N	210596	0	444814009	40481087		0
53535	3172	40481087	1991-09-28	1991-09-28 00:00:00	1991-10-05	1991-10-05 00:00:00	32020		\N	210869	0	444814009	40481087		0
53642	3177	80180	1950-04-27	1950-04-27 00:00:00	\N	\N	32020		\N	211297	0	396275006	80180		0
43278	2577	40481087	1983-04-27	1983-04-27 00:00:00	1983-05-04	1983-05-04 00:00:00	32020		\N	170606	0	444814009	40481087		0
54006	3196	4112343	2006-04-26	2006-04-26 00:00:00	2006-05-05	2006-05-05 00:00:00	32020		\N	212619	0	195662009	4112343		0
43605	2597	80180	2010-08-31	2010-08-31 00:00:00	\N	\N	32020		\N	171863	0	396275006	80180		0
54305	3217	4112343	1989-07-06	1989-07-06 00:00:00	1989-07-17	1989-07-17 00:00:00	32020		\N	213780	0	195662009	4112343		0
43968	2617	4156265	2016-06-05	2016-06-05 00:00:00	2016-06-26	2016-06-26 00:00:00	32020		\N	173099	0	370247008	4156265		0
54635	3234	4112343	1972-07-21	1972-07-21 00:00:00	1972-07-29	1972-07-29 00:00:00	32020		\N	214931	0	195662009	4112343		0
54800	3242	28060	2014-09-13	2014-09-13 00:00:00	2014-09-25	2014-09-25 00:00:00	32020		\N	215634	0	43878008	28060		0
55046	3259	4112343	2008-03-08	2008-03-08 00:00:00	2008-03-16	2008-03-16 00:00:00	32020		\N	216653	0	195662009	4112343		0
55252	3272	81151	1987-04-11	1987-04-11 00:00:00	1987-05-09	1987-05-09 00:00:00	32020		\N	217477	0	44465007	81151		0
55318	3277	4278672	2017-06-24	2017-06-24 00:00:00	2017-09-22	2017-09-22 00:00:00	32020		\N	217742	0	65966004	4278672		0
55475	3287	4283893	1963-05-12	1963-05-12 00:00:00	1963-09-22	1963-09-22 00:00:00	32020		\N	218290	0	36971009	4283893		0
55669	3295	4112343	1986-09-22	1986-09-22 00:00:00	1986-09-29	1986-09-29 00:00:00	32020		\N	218928	0	195662009	4112343		0
45267	2692	40481087	1994-10-27	1994-10-27 00:00:00	1994-11-17	1994-11-17 00:00:00	32020		\N	178338	0	444814009	40481087		0
56066	3320	40481087	1976-08-23	1976-08-23 00:00:00	1976-09-13	1976-09-13 00:00:00	32020		\N	220459	0	444814009	40481087		0
56159	3325	372328	1964-05-12	1964-05-12 00:00:00	1964-05-26	1964-05-26 00:00:00	32020		\N	220725	0	65363002	372328		0
56340	3339	40481087	1991-05-08	1991-05-08 00:00:00	1991-05-22	1991-05-22 00:00:00	32020		\N	221503	0	444814009	40481087		0
56469	3347	260139	1984-12-13	1984-12-13 00:00:00	1984-12-27	1984-12-27 00:00:00	32020		\N	222037	0	10509002	260139		0
56742	3365	260139	2001-05-06	2001-05-06 00:00:00	2001-05-13	2001-05-13 00:00:00	32020		\N	223156	0	10509002	260139		0
56817	3370	40481087	1984-05-08	1984-05-08 00:00:00	1984-05-15	1984-05-15 00:00:00	32020		\N	223451	0	444814009	40481087		0
46471	2767	378419	2019-04-10	2019-04-10 00:00:00	\N	\N	32020		\N	183027	0	26929004	378419		0
46599	2774	40481087	2018-06-02	2018-06-02 00:00:00	2018-06-23	2018-06-23 00:00:00	32020		\N	183661	0	444814009	40481087		0
57291	3399	4027663	2008-02-01	2008-02-01 00:00:00	\N	\N	32020		\N	225443	0	13200003	4027663		0
57461	3409	40481087	2003-07-02	2003-07-02 00:00:00	2003-07-09	2003-07-09 00:00:00	32020		\N	226064	0	444814009	40481087		0
57660	3420	4112343	1970-08-13	1970-08-13 00:00:00	1970-08-25	1970-08-25 00:00:00	32020		\N	226883	0	195662009	4112343		0
57815	3430	381316	2011-10-08	2011-10-08 00:00:00	\N	\N	32020		\N	227336	0	230690007	381316		0
57965	3437	260139	1971-05-20	1971-05-20 00:00:00	1971-05-27	1971-05-27 00:00:00	32020		\N	228032	0	10509002	260139		0
58117	3442	4218389	2014-08-03	2014-08-03 00:00:00	2014-08-24	2014-08-24 00:00:00	32020		\N	228419	0	39848009	4218389		0
47744	2835	40481087	1981-07-25	1981-07-25 00:00:00	1981-08-01	1981-08-01 00:00:00	32020		\N	188213	0	444814009	40481087		0
47937	2845	195588	2009-09-18	2009-09-18 00:00:00	2009-11-04	2009-11-04 00:00:00	32020		\N	188960	0	38822007	195588		0
58725	3483	4112343	1984-06-14	1984-06-14 00:00:00	1984-06-24	1984-06-24 00:00:00	32020		\N	231063	0	195662009	4112343		0
48239	2860	195588	2001-11-25	2001-11-25 00:00:00	2001-12-31	2001-12-31 00:00:00	32020		\N	190154	0	38822007	195588		0
48396	2866	378001	2005-02-13	2005-02-13 00:00:00	2005-04-14	2005-04-14 00:00:00	32020		\N	190696	0	62106007	378001		0
59219	3513	4112343	1974-01-10	1974-01-10 00:00:00	1974-01-17	1974-01-17 00:00:00	32020		\N	233123	0	195662009	4112343		0
69897	4134	4109685	1956-07-15	1956-07-15 00:00:00	1956-07-29	1956-07-29 00:00:00	32020		\N	274819	0	284551006	4109685		0
48952	2897	4218389	2001-03-23	2001-03-23 00:00:00	2001-04-13	2001-04-13 00:00:00	32020		\N	192944	0	39848009	4218389		0
59673	3536	4027663	1990-10-31	1990-10-31 00:00:00	\N	\N	32020		\N	234841	0	13200003	4027663		0
59858	3547	40481087	1975-09-20	1975-09-20 00:00:00	1975-10-04	1975-10-04 00:00:00	32020		\N	235544	0	444814009	40481087		0
59986	3553	255848	2012-09-20	2012-09-20 00:00:00	\N	\N	32020		\N	235968	0	233604007	255848		0
60131	3561	4283893	1947-02-22	1947-02-22 00:00:00	1947-05-10	1947-05-10 00:00:00	32020		\N	236554	0	36971009	4283893		0
60301	3569	192671	1999-10-03	1999-10-03 00:00:00	\N	\N	32020		\N	237187	0	K92.2	35208414		0
49905	2949	4156265	2006-08-05	2006-08-05 00:00:00	2006-08-19	2006-08-19 00:00:00	32020		\N	196881	0	370247008	4156265		0
60610	3583	80180	2002-11-12	2002-11-12 00:00:00	\N	\N	32020		\N	238179	0	396275006	80180		0
50248	2970	260139	1981-02-23	1981-02-23 00:00:00	1981-03-02	1981-03-02 00:00:00	32020		\N	198317	0	10509002	260139		0
60995	3610	260139	2001-01-01	2001-01-01 00:00:00	2001-01-08	2001-01-08 00:00:00	32020		\N	239843	0	10509002	260139		0
50627	2993	40481087	1994-11-29	1994-11-29 00:00:00	1994-12-20	1994-12-20 00:00:00	32020		\N	199800	0	444814009	40481087		0
61258	3622	40481087	2007-09-24	2007-09-24 00:00:00	2007-10-15	2007-10-15 00:00:00	32020		\N	240679	0	444814009	40481087		0
50955	3014	40481087	2013-10-25	2013-10-25 00:00:00	2013-11-01	2013-11-01 00:00:00	32020		\N	200997	0	444814009	40481087		0
61858	3652	4112343	1987-04-16	1987-04-16 00:00:00	1987-04-26	1987-04-26 00:00:00	32020		\N	243080	0	195662009	4112343		0
61992	3660	4112343	1988-01-27	1988-01-27 00:00:00	1988-02-08	1988-02-08 00:00:00	32020		\N	243563	0	195662009	4112343		0
62090	3667	81151	1972-03-16	1972-03-16 00:00:00	1972-04-06	1972-04-06 00:00:00	32020		\N	243975	0	44465007	81151		0
62395	3686	260139	1972-09-25	1972-09-25 00:00:00	1972-10-09	1972-10-09 00:00:00	32020		\N	245065	0	10509002	260139		0
62458	3691	260139	1969-07-26	1969-07-26 00:00:00	1969-08-02	1969-08-02 00:00:00	32020		\N	245352	0	10509002	260139		0
52119	3086	4294548	1972-09-23	1972-09-23 00:00:00	1972-10-14	1972-10-14 00:00:00	32020		\N	205426	0	75498004	4294548		0
62782	3708	4059173	1988-09-12	1988-09-12 00:00:00	1988-10-12	1988-10-12 00:00:00	32020		\N	246508	0	16114001	4059173		0
52422	3105	372328	1972-12-30	1972-12-30 00:00:00	1973-07-02	1973-07-02 00:00:00	32020		\N	206495	0	65363002	372328		0
63223	3734	4112343	1990-02-14	1990-02-14 00:00:00	1990-02-22	1990-02-22 00:00:00	32020		\N	248154	0	195662009	4112343		0
63365	3743	40481087	1980-05-22	1980-05-22 00:00:00	1980-06-12	1980-06-12 00:00:00	32020		\N	248691	0	444814009	40481087		0
63505	3750	40481087	1980-09-21	1980-09-21 00:00:00	1980-10-05	1980-10-05 00:00:00	32020		\N	249249	0	444814009	40481087		0
63700	3761	4112343	1960-07-21	1960-07-21 00:00:00	1960-07-28	1960-07-28 00:00:00	32020		\N	250094	0	195662009	4112343		0
53143	3147	260139	1992-02-24	1992-02-24 00:00:00	1992-03-02	1992-03-02 00:00:00	32020		\N	209431	0	10509002	260139		0
53433	3167	80180	2002-08-14	2002-08-14 00:00:00	\N	\N	32020		\N	210545	0	396275006	80180		0
53536	3172	4112343	1977-07-23	1977-07-23 00:00:00	1977-07-30	1977-07-30 00:00:00	32020		\N	210833	0	195662009	4112343		0
53643	3177	260139	1986-09-08	1986-09-08 00:00:00	1986-09-15	1986-09-15 00:00:00	32020		\N	211318	0	10509002	260139		0
43279	2578	260139	1972-12-31	1972-12-31 00:00:00	1973-01-07	1973-01-07 00:00:00	32020		\N	170752	0	10509002	260139		0
54007	3196	4027663	1999-03-31	1999-03-31 00:00:00	\N	\N	32020		\N	212604	0	13200003	4027663		0
43606	2597	260139	1981-08-30	1981-08-30 00:00:00	1981-09-13	1981-09-13 00:00:00	32020		\N	171825	0	10509002	260139		0
54306	3217	80180	2018-10-14	2018-10-14 00:00:00	\N	\N	32020		\N	213800	0	396275006	80180		0
43969	2617	4112343	2018-07-10	2018-07-10 00:00:00	2018-07-19	2018-07-19 00:00:00	32020		\N	173061	0	195662009	4112343		0
54636	3234	40481087	1992-12-04	1992-12-04 00:00:00	1992-12-11	1992-12-11 00:00:00	32020		\N	214927	0	444814009	40481087		0
54801	3242	260139	1985-04-02	1985-04-02 00:00:00	1985-04-09	1985-04-09 00:00:00	32020		\N	215617	0	10509002	260139		0
55047	3259	40481087	1967-12-25	1967-12-25 00:00:00	1968-01-08	1968-01-08 00:00:00	32020		\N	216674	0	444814009	40481087		0
55253	3272	260139	1988-01-07	1988-01-07 00:00:00	1988-01-14	1988-01-14 00:00:00	32020		\N	217441	0	10509002	260139		0
55319	3277	40481087	2015-12-28	2015-12-28 00:00:00	2016-01-11	2016-01-11 00:00:00	32020		\N	217688	0	444814009	40481087		0
55476	3287	40481087	1983-10-11	1983-10-11 00:00:00	1983-10-25	1983-10-25 00:00:00	32020		\N	218294	0	444814009	40481087		0
55670	3295	40481087	2010-06-10	2010-06-10 00:00:00	2010-07-01	2010-07-01 00:00:00	32020		\N	218932	0	444814009	40481087		0
45268	2692	40481087	1948-02-24	1948-02-24 00:00:00	1948-03-02	1948-03-02 00:00:00	32020		\N	178327	0	444814009	40481087		0
56067	3320	4112343	1974-10-28	1974-10-28 00:00:00	1974-11-04	1974-11-04 00:00:00	32020		\N	220458	0	195662009	4112343		0
56160	3325	40481087	1975-08-17	1975-08-17 00:00:00	1975-09-07	1975-09-07 00:00:00	32020		\N	220693	0	444814009	40481087		0
56341	3339	4113008	1987-06-23	1987-06-23 00:00:00	1987-07-07	1987-07-07 00:00:00	32020		\N	221540	0	284549007	4113008		0
56470	3347	4152936	2008-06-10	2008-06-10 00:00:00	2008-07-01	2008-07-01 00:00:00	32020		\N	222021	0	283385000	4152936		0
56743	3365	40481087	2014-03-18	2014-03-18 00:00:00	2014-04-08	2014-04-08 00:00:00	32020		\N	223176	0	444814009	40481087		0
56818	3370	40481087	1978-09-16	1978-09-16 00:00:00	1978-09-30	1978-09-30 00:00:00	32020		\N	223412	0	444814009	40481087		0
46472	2767	260139	1967-03-01	1967-03-01 00:00:00	1967-03-15	1967-03-15 00:00:00	32020		\N	183051	0	10509002	260139		0
46600	2774	40481087	2004-01-27	2004-01-27 00:00:00	2004-02-03	2004-02-03 00:00:00	32020		\N	183658	0	444814009	40481087		0
57292	3399	4278672	2000-04-09	2000-04-09 00:00:00	2000-06-08	2000-06-08 00:00:00	32020		\N	225520	0	65966004	4278672		0
57462	3409	81151	2002-11-11	2002-11-11 00:00:00	2002-12-09	2002-12-09 00:00:00	32020		\N	226122	0	44465007	81151		0
57661	3420	81151	1982-12-15	1982-12-15 00:00:00	1983-01-12	1983-01-12 00:00:00	32020		\N	226910	0	44465007	81151		0
57816	3430	40481087	1988-01-15	1988-01-15 00:00:00	1988-01-29	1988-01-29 00:00:00	32020		\N	227378	0	444814009	40481087		0
57966	3437	4027663	1943-04-20	1943-04-20 00:00:00	\N	\N	32020		\N	228014	0	13200003	4027663		0
58118	3442	40481087	2017-06-10	2017-06-10 00:00:00	2017-07-01	2017-07-01 00:00:00	32020		\N	228412	0	444814009	40481087		0
47745	2835	40481087	1924-10-02	1924-10-02 00:00:00	1924-10-23	1924-10-23 00:00:00	32020		\N	188233	0	444814009	40481087		0
47938	2845	40481087	2003-05-23	2003-05-23 00:00:00	2003-06-13	2003-06-13 00:00:00	32020		\N	188958	0	444814009	40481087		0
58726	3483	4146173	2000-11-23	2000-11-23 00:00:00	2000-12-23	2000-12-23 00:00:00	32020		\N	231088	0	307731004	4146173		0
48240	2860	40481087	1968-06-21	1968-06-21 00:00:00	1968-07-05	1968-07-05 00:00:00	32020		\N	190134	0	444814009	40481087		0
48397	2866	4027663	1995-07-31	1995-07-31 00:00:00	\N	\N	32020		\N	190639	0	13200003	4027663		0
59220	3513	4112343	2002-10-17	2002-10-17 00:00:00	2002-10-28	2002-10-28 00:00:00	32020		\N	233142	0	195662009	4112343		0
69898	4134	4278672	1960-09-06	1960-09-06 00:00:00	1960-11-05	1960-11-05 00:00:00	32020		\N	274821	0	65966004	4278672		0
48953	2897	4230399	2017-11-15	2017-11-15 00:00:00	2017-12-15	2017-12-15 00:00:00	32020		\N	192945	0	359817006	4230399		0
59674	3536	40481087	1990-05-27	1990-05-27 00:00:00	1990-06-10	1990-06-10 00:00:00	32020		\N	234841	0	444814009	40481087		0
59859	3547	260139	2004-07-04	2004-07-04 00:00:00	2004-07-18	2004-07-18 00:00:00	32020		\N	235570	0	10509002	260139		0
59987	3553	80180	1966-09-20	1966-09-20 00:00:00	\N	\N	32020		\N	235944	0	396275006	80180		0
60132	3561	30753	1942-11-14	1942-11-14 00:00:00	\N	\N	32020		\N	236457	0	16761005	30753		0
60302	3569	4113008	1966-01-26	1966-01-26 00:00:00	1966-02-16	1966-02-16 00:00:00	32020		\N	237186	0	284549007	4113008		0
49906	2949	260139	1964-05-13	1964-05-13 00:00:00	1964-05-20	1964-05-20 00:00:00	32020		\N	196863	0	10509002	260139		0
60611	3583	4142905	2018-12-23	2018-12-23 00:00:00	2019-03-23	2019-03-23 00:00:00	32020		\N	238208	0	33737001	4142905		0
50249	2970	260139	2003-10-05	2003-10-05 00:00:00	2003-10-12	2003-10-12 00:00:00	32020		\N	198291	0	10509002	260139		0
60996	3610	40481087	1945-03-10	1945-03-10 00:00:00	1945-03-24	1945-03-24 00:00:00	32020		\N	239868	0	444814009	40481087		0
50628	2993	80180	2012-09-15	2012-09-15 00:00:00	\N	\N	32020		\N	199792	0	396275006	80180		0
61259	3622	4112343	2004-04-02	2004-04-02 00:00:00	2004-04-15	2004-04-15 00:00:00	32020		\N	240734	0	195662009	4112343		0
61421	3629	4112343	1995-11-03	1995-11-03 00:00:00	1995-11-10	1995-11-10 00:00:00	32020		\N	241461	0	195662009	4112343		0
51055	3023	4266809	2018-02-02	2018-02-02 00:00:00	\N	\N	32020		\N	201513	0	397881000	4266809		0
61859	3652	40481087	2006-05-22	2006-05-22 00:00:00	2006-05-29	2006-05-29 00:00:00	32020		\N	243082	0	444814009	40481087		0
61993	3660	81151	1988-12-14	1988-12-14 00:00:00	1989-01-04	1989-01-04 00:00:00	32020		\N	243604	0	44465007	81151		0
62091	3667	28060	1968-07-06	1968-07-06 00:00:00	1968-07-19	1968-07-19 00:00:00	32020		\N	243934	0	43878008	28060		0
62396	3686	80180	2009-10-30	2009-10-30 00:00:00	\N	\N	32020		\N	245027	0	396275006	80180		0
62459	3691	81151	1955-09-07	1955-09-07 00:00:00	1955-09-21	1955-09-21 00:00:00	32020		\N	245349	0	44465007	81151		0
52120	3086	372328	1971-11-30	1971-11-30 00:00:00	1972-03-01	1972-03-01 00:00:00	32020		\N	205471	0	65363002	372328		0
62783	3708	40481087	2014-05-20	2014-05-20 00:00:00	2014-05-27	2014-05-27 00:00:00	32020		\N	246477	0	444814009	40481087		0
52423	3105	40481087	2018-06-06	2018-06-06 00:00:00	2018-06-13	2018-06-13 00:00:00	32020		\N	206503	0	444814009	40481087		0
63224	3734	4109685	1949-07-12	1949-07-12 00:00:00	1949-07-26	1949-07-26 00:00:00	32020		\N	248170	0	284551006	4109685		0
63366	3743	40481087	2008-12-21	2008-12-21 00:00:00	2008-12-28	2008-12-28 00:00:00	32020		\N	248706	0	444814009	40481087		0
63506	3750	40481087	2008-07-15	2008-07-15 00:00:00	2008-08-05	2008-08-05 00:00:00	32020		\N	249230	0	444814009	40481087		0
63701	3761	4112343	1960-09-27	1960-09-27 00:00:00	1960-10-08	1960-10-08 00:00:00	32020		\N	250066	0	195662009	4112343		0
53144	3147	40481087	1948-09-21	1948-09-21 00:00:00	1948-09-28	1948-09-28 00:00:00	32020		\N	209390	0	444814009	40481087		0
53434	3167	4266809	2002-08-14	2002-08-14 00:00:00	\N	\N	32020		\N	210545	0	397881000	4266809		0
53537	3172	40481087	2002-12-23	2002-12-23 00:00:00	2003-01-06	2003-01-06 00:00:00	32020		\N	210836	0	444814009	40481087		0
53644	3177	4112343	1968-02-06	1968-02-06 00:00:00	1968-02-13	1968-02-13 00:00:00	32020		\N	211316	0	195662009	4112343		0
43280	2578	372328	2003-04-06	2003-04-06 00:00:00	2004-10-21	2004-10-21 00:00:00	32020		\N	170738	0	65363002	372328		0
54008	3196	192671	2008-07-06	2008-07-06 00:00:00	\N	\N	32020		\N	212606	0	K92.2	35208414		0
43607	2597	4112343	1983-12-13	1983-12-13 00:00:00	1983-12-21	1983-12-21 00:00:00	32020		\N	171827	0	195662009	4112343		0
54307	3217	260139	1995-12-24	1995-12-24 00:00:00	1995-12-31	1995-12-31 00:00:00	32020		\N	213791	0	10509002	260139		0
43970	2617	4283893	2009-04-30	2009-04-30 00:00:00	2009-08-06	2009-08-06 00:00:00	32020		\N	173064	0	36971009	4283893		0
54637	3234	40481087	2009-01-24	2009-01-24 00:00:00	2009-02-14	2009-02-14 00:00:00	32020		\N	214974	0	444814009	40481087		0
54802	3242	40481087	1981-09-16	1981-09-16 00:00:00	1981-09-23	1981-09-23 00:00:00	32020		\N	215592	0	444814009	40481087		0
55048	3259	40481087	1995-02-16	1995-02-16 00:00:00	1995-03-02	1995-03-02 00:00:00	32020		\N	216685	0	444814009	40481087		0
55254	3272	4027663	1996-06-02	1996-06-02 00:00:00	\N	\N	32020		\N	217480	0	13200003	4027663		0
55320	3277	81151	1967-11-11	1967-11-11 00:00:00	1967-12-02	1967-12-02 00:00:00	32020		\N	217691	0	44465007	81151		0
55477	3287	4112343	1997-11-17	1997-11-17 00:00:00	1997-11-30	1997-11-30 00:00:00	32020		\N	218367	0	195662009	4112343		0
55671	3295	40481087	1947-03-13	1947-03-13 00:00:00	1947-03-20	1947-03-20 00:00:00	32020		\N	218916	0	444814009	40481087		0
45269	2692	4109685	1996-02-17	1996-02-17 00:00:00	1996-03-09	1996-03-09 00:00:00	32020		\N	178363	0	284551006	4109685		0
56068	3320	40481087	2009-11-11	2009-11-11 00:00:00	2009-11-25	2009-11-25 00:00:00	32020		\N	220487	0	444814009	40481087		0
56189	3330	4112343	2015-05-01	2015-05-01 00:00:00	2015-05-12	2015-05-12 00:00:00	32020		\N	220991	0	195662009	4112343		0
56342	3339	28060	1968-08-09	1968-08-09 00:00:00	1968-08-16	1968-08-16 00:00:00	32020		\N	221532	0	43878008	28060		0
56471	3347	40481087	1960-03-08	1960-03-08 00:00:00	1960-03-15	1960-03-15 00:00:00	32020		\N	222066	0	444814009	40481087		0
56744	3365	4112343	1993-09-10	1993-09-10 00:00:00	1993-09-21	1993-09-21 00:00:00	32020		\N	223155	0	195662009	4112343		0
56819	3370	4084167	1977-01-31	1977-01-31 00:00:00	1977-01-31	1977-01-31 00:00:00	32020		\N	223391	0	241929008	4084167		0
46473	2767	4112343	1940-04-18	1940-04-18 00:00:00	1940-04-27	1940-04-27 00:00:00	32020		\N	183047	0	195662009	4112343		0
46601	2774	40481087	1985-08-19	1985-08-19 00:00:00	1985-08-26	1985-08-26 00:00:00	32020		\N	183659	0	444814009	40481087		0
57293	3399	4112343	1996-11-02	1996-11-02 00:00:00	1996-11-10	1996-11-10 00:00:00	32020		\N	225492	0	195662009	4112343		0
57463	3409	4112343	1959-07-21	1959-07-21 00:00:00	1959-08-02	1959-08-02 00:00:00	32020		\N	226056	0	195662009	4112343		0
57662	3420	4134304	2003-01-27	2003-01-27 00:00:00	2003-02-26	2003-02-26 00:00:00	32020		\N	226912	0	263102004	4134304		0
57817	3430	4152936	2005-09-22	2005-09-22 00:00:00	2005-10-13	2005-10-13 00:00:00	32020		\N	227363	0	283385000	4152936		0
57967	3437	4294548	1945-05-09	1945-05-09 00:00:00	1945-05-30	1945-05-30 00:00:00	32020		\N	227938	0	75498004	4294548		0
58119	3442	40481087	1971-12-08	1971-12-08 00:00:00	1971-12-22	1971-12-22 00:00:00	32020		\N	228445	0	444814009	40481087		0
47746	2835	4134304	1913-11-07	1913-11-07 00:00:00	1913-12-07	1913-12-07 00:00:00	32020		\N	188299	0	263102004	4134304		0
47939	2845	81893	1993-08-18	1993-08-18 00:00:00	\N	\N	32020		\N	188948	0	64766004	81893		0
58727	3483	4278672	1970-05-09	1970-05-09 00:00:00	1970-07-08	1970-07-08 00:00:00	32020		\N	231117	0	65966004	4278672		0
48241	2860	28060	1949-10-21	1949-10-21 00:00:00	1949-11-02	1949-11-02 00:00:00	32020		\N	190123	0	43878008	28060		0
48398	2866	4112343	1969-12-22	1969-12-22 00:00:00	1969-12-29	1969-12-29 00:00:00	32020		\N	190644	0	195662009	4112343		0
59221	3513	260139	1974-04-10	1974-04-10 00:00:00	1974-04-17	1974-04-17 00:00:00	32020		\N	233124	0	10509002	260139		0
69917	4137	4112343	1964-01-11	1964-01-11 00:00:00	1964-01-21	1964-01-21 00:00:00	32020		\N	274991	0	195662009	4112343		0
48954	2897	40481087	2005-03-13	2005-03-13 00:00:00	2005-03-20	2005-03-20 00:00:00	32020		\N	192939	0	444814009	40481087		0
59675	3536	195588	2016-01-19	2016-01-19 00:00:00	2016-03-07	2016-03-07 00:00:00	32020		\N	234857	0	38822007	195588		0
59860	3547	260139	2009-10-05	2009-10-05 00:00:00	2009-10-12	2009-10-12 00:00:00	32020		\N	235596	0	10509002	260139		0
59988	3553	4266809	1966-09-20	1966-09-20 00:00:00	\N	\N	32020		\N	235944	0	397881000	4266809		0
60133	3561	4059173	2010-06-11	2010-06-11 00:00:00	2010-07-11	2010-07-11 00:00:00	32020		\N	236537	0	16114001	4059173		0
60303	3569	4112343	1999-08-12	1999-08-12 00:00:00	1999-08-24	1999-08-24 00:00:00	32020		\N	237180	0	195662009	4112343		0
49907	2949	4112343	2002-02-27	2002-02-27 00:00:00	2002-03-07	2002-03-07 00:00:00	32020		\N	196797	0	195662009	4112343		0
60612	3583	372328	1971-01-24	1971-01-24 00:00:00	1971-04-13	1971-04-13 00:00:00	32020		\N	238171	0	65363002	372328		0
50250	2970	28060	1980-01-31	1980-01-31 00:00:00	1980-02-11	1980-02-11 00:00:00	32020		\N	198305	0	43878008	28060		0
60997	3610	4152936	1987-06-20	1987-06-20 00:00:00	1987-07-04	1987-07-04 00:00:00	32020		\N	239884	0	283385000	4152936		0
61089	3615	260139	1970-07-13	1970-07-13 00:00:00	1970-07-20	1970-07-20 00:00:00	32020		\N	240213	0	10509002	260139		0
61260	3622	372328	1922-12-20	1922-12-20 00:00:00	1923-01-31	1923-01-31 00:00:00	32020		\N	240782	0	65363002	372328		0
61422	3629	40481087	1982-10-12	1982-10-12 00:00:00	1982-10-26	1982-10-26 00:00:00	32020		\N	241496	0	444814009	40481087		0
51056	3023	260139	2014-04-05	2014-04-05 00:00:00	2014-04-12	2014-04-12 00:00:00	32020		\N	201514	0	10509002	260139		0
61860	3652	28060	1978-04-06	1978-04-06 00:00:00	1978-04-16	1978-04-16 00:00:00	32020		\N	243079	0	43878008	28060		0
61994	3660	4218389	2017-10-09	2017-10-09 00:00:00	2017-11-13	2017-11-13 00:00:00	32020		\N	243608	0	39848009	4218389		0
62092	3667	372328	1972-05-15	1972-05-15 00:00:00	1972-06-13	1972-06-13 00:00:00	32020		\N	243938	0	65363002	372328		0
62397	3686	260139	2013-02-15	2013-02-15 00:00:00	2013-03-01	2013-03-01 00:00:00	32020		\N	245086	0	10509002	260139		0
62460	3691	40481087	2015-06-05	2015-06-05 00:00:00	2015-06-19	2015-06-19 00:00:00	32020		\N	245299	0	444814009	40481087		0
52121	3086	40481087	2016-06-20	2016-06-20 00:00:00	2016-07-04	2016-07-04 00:00:00	32020		\N	205447	0	444814009	40481087		0
62784	3708	4051466	1979-05-20	1979-05-20 00:00:00	1996-08-24	1996-08-24 00:00:00	32020		\N	246469	0	233678006	4051466		0
52424	3105	260139	1990-06-04	1990-06-04 00:00:00	1990-06-18	1990-06-18 00:00:00	32020		\N	206507	0	10509002	260139		0
63225	3734	4112343	2007-05-25	2007-05-25 00:00:00	2007-06-05	2007-06-05 00:00:00	32020		\N	248178	0	195662009	4112343		0
63367	3743	40481087	1992-10-19	1992-10-19 00:00:00	1992-11-09	1992-11-09 00:00:00	32020		\N	248695	0	444814009	40481087		0
63507	3750	4230399	2012-01-11	2012-01-11 00:00:00	2012-03-11	2012-03-11 00:00:00	32020		\N	249242	0	359817006	4230399		0
63702	3761	4294548	1980-08-27	1980-08-27 00:00:00	1980-10-08	1980-10-08 00:00:00	32020		\N	250096	0	75498004	4294548		0
53145	3147	81151	1993-12-31	1993-12-31 00:00:00	1994-01-14	1994-01-14 00:00:00	32020		\N	209428	0	44465007	81151		0
53435	3167	28060	1985-04-26	1985-04-26 00:00:00	1985-05-06	1985-05-06 00:00:00	32020		\N	210585	0	43878008	28060		0
53538	3172	4112343	1985-08-21	1985-08-21 00:00:00	1985-08-29	1985-08-29 00:00:00	32020		\N	210868	0	195662009	4112343		0
53645	3177	81151	1975-05-21	1975-05-21 00:00:00	1975-06-11	1975-06-11 00:00:00	32020		\N	211232	0	44465007	81151		0
43281	2578	40481087	2014-12-04	2014-12-04 00:00:00	2014-12-25	2014-12-25 00:00:00	32020		\N	170754	0	444814009	40481087		0
54009	3196	4218389	2000-11-25	2000-11-25 00:00:00	2000-12-30	2000-12-30 00:00:00	32020		\N	212605	0	39848009	4218389		0
43608	2597	40481087	2014-08-09	2014-08-09 00:00:00	2014-08-30	2014-08-30 00:00:00	32020		\N	171841	0	444814009	40481087		0
54308	3217	40481087	1987-03-25	1987-03-25 00:00:00	1987-04-08	1987-04-08 00:00:00	32020		\N	213801	0	444814009	40481087		0
43971	2617	260139	1956-09-16	1956-09-16 00:00:00	1956-09-23	1956-09-23 00:00:00	32020		\N	173042	0	10509002	260139		0
54638	3234	40481087	1954-04-22	1954-04-22 00:00:00	1954-05-07	1954-05-07 00:00:00	32020		\N	214970	0	444814009	40481087		0
54803	3242	4278672	1988-03-06	1988-03-06 00:00:00	1988-05-05	1988-05-05 00:00:00	32020		\N	215643	0	65966004	4278672		0
55049	3259	81151	1974-08-11	1974-08-11 00:00:00	1974-09-08	1974-09-08 00:00:00	32020		\N	216672	0	44465007	81151		0
55255	3272	372328	1972-01-14	1972-01-14 00:00:00	1972-05-16	1972-05-16 00:00:00	32020		\N	217420	0	65363002	372328		0
55321	3277	40481087	2012-08-24	2012-08-24 00:00:00	2012-09-07	2012-09-07 00:00:00	32020		\N	217687	0	444814009	40481087		0
55478	3287	4294548	2004-05-11	2004-05-11 00:00:00	2004-07-06	2004-07-06 00:00:00	32020		\N	218377	0	75498004	4294548		0
55672	3295	40481087	1971-04-14	1971-04-14 00:00:00	1971-04-28	1971-04-28 00:00:00	32020		\N	218967	0	444814009	40481087		0
45270	2692	372328	1950-07-04	1950-07-04 00:00:00	1950-10-23	1950-10-23 00:00:00	32020		\N	178330	0	65363002	372328		0
56069	3320	40481087	1998-04-15	1998-04-15 00:00:00	1998-05-06	1998-05-06 00:00:00	32020		\N	220445	0	444814009	40481087		0
56190	3330	40481087	2005-03-30	2005-03-30 00:00:00	2005-04-06	2005-04-06 00:00:00	32020		\N	220977	0	444814009	40481087		0
56343	3339	4112343	2003-06-27	2003-06-27 00:00:00	2003-07-10	2003-07-10 00:00:00	32020		\N	221527	0	195662009	4112343		0
56472	3347	40481087	1994-03-28	1994-03-28 00:00:00	1994-04-18	1994-04-18 00:00:00	32020		\N	222039	0	444814009	40481087		0
56745	3365	260139	2012-08-14	2012-08-14 00:00:00	2012-08-21	2012-08-21 00:00:00	32020		\N	223174	0	10509002	260139		0
56820	3370	260139	2015-01-14	2015-01-14 00:00:00	2015-01-28	2015-01-28 00:00:00	32020		\N	223406	0	10509002	260139		0
46474	2768	40481087	1972-01-04	1972-01-04 00:00:00	1972-01-18	1972-01-18 00:00:00	32020		\N	183168	0	444814009	40481087		0
46602	2774	260139	1968-03-03	1968-03-03 00:00:00	1968-03-17	1968-03-17 00:00:00	32020		\N	183656	0	10509002	260139		0
57294	3399	40481087	1990-07-29	1990-07-29 00:00:00	1990-08-19	1990-08-19 00:00:00	32020		\N	225504	0	444814009	40481087		0
57464	3410	260139	2007-02-01	2007-02-01 00:00:00	2007-02-08	2007-02-08 00:00:00	32020		\N	226209	0	10509002	260139		0
57663	3420	40481087	1983-12-27	1983-12-27 00:00:00	1984-01-10	1984-01-10 00:00:00	32020		\N	226885	0	444814009	40481087		0
57818	3430	40481087	1986-03-04	1986-03-04 00:00:00	1986-03-18	1986-03-18 00:00:00	32020		\N	227392	0	444814009	40481087		0
57968	3437	4112343	1966-02-13	1966-02-13 00:00:00	1966-02-22	1966-02-22 00:00:00	32020		\N	227988	0	195662009	4112343		0
58120	3443	40481087	1993-06-20	1993-06-20 00:00:00	1993-07-04	1993-07-04 00:00:00	32020		\N	228510	0	444814009	40481087		0
47747	2835	260139	1915-10-29	1915-10-29 00:00:00	1915-11-05	1915-11-05 00:00:00	32020		\N	188231	0	10509002	260139		0
47940	2845	375671	1972-07-15	1972-07-15 00:00:00	1972-08-14	1972-08-14 00:00:00	32020		\N	188983	0	62564004	375671		0
58728	3483	40481087	2007-10-25	2007-10-25 00:00:00	2007-11-15	2007-11-15 00:00:00	32020		\N	231065	0	444814009	40481087		0
48242	2860	260139	2004-09-01	2004-09-01 00:00:00	2004-09-08	2004-09-08 00:00:00	32020		\N	190127	0	10509002	260139		0
48399	2866	378001	2002-03-01	2002-03-01 00:00:00	2002-04-30	2002-04-30 00:00:00	32020		\N	190695	0	62106007	378001		0
59222	3513	4156265	1985-02-09	1985-02-09 00:00:00	1985-02-23	1985-02-23 00:00:00	32020		\N	233117	0	370247008	4156265		0
69918	4137	4113008	2002-12-14	2002-12-14 00:00:00	2002-12-28	2002-12-28 00:00:00	32020		\N	275052	0	284549007	4113008		0
48955	2897	260139	1977-02-21	1977-02-21 00:00:00	1977-02-28	1977-02-28 00:00:00	32020		\N	192948	0	10509002	260139		0
59676	3536	4146173	1971-02-28	1971-02-28 00:00:00	1971-03-30	1971-03-30 00:00:00	32020		\N	234826	0	307731004	4146173		0
59861	3547	4112343	1982-10-23	1982-10-23 00:00:00	1982-11-03	1982-11-03 00:00:00	32020		\N	235548	0	195662009	4112343		0
59989	3553	260139	1942-09-08	1942-09-08 00:00:00	1942-09-15	1942-09-15 00:00:00	32020		\N	235922	0	10509002	260139		0
60134	3561	4112343	2011-07-01	2011-07-01 00:00:00	2011-07-14	2011-07-14 00:00:00	32020		\N	236489	0	195662009	4112343		0
60304	3569	80180	1999-09-10	1999-09-10 00:00:00	\N	\N	32020		\N	237180	0	396275006	80180		0
49908	2949	40481087	1991-10-07	1991-10-07 00:00:00	1991-10-28	1991-10-28 00:00:00	32020		\N	196845	0	444814009	40481087		0
60613	3583	4084167	1971-11-20	1971-11-20 00:00:00	1971-11-20	1971-11-20 00:00:00	32020		\N	238241	0	241929008	4084167		0
50251	2970	4112343	1990-07-03	1990-07-03 00:00:00	1990-07-12	1990-07-12 00:00:00	32020		\N	198319	0	195662009	4112343		0
60998	3610	40481087	2009-03-07	2009-03-07 00:00:00	2009-03-21	2009-03-21 00:00:00	32020		\N	239844	0	444814009	40481087		0
61090	3615	4112343	2018-08-15	2018-08-15 00:00:00	2018-08-28	2018-08-28 00:00:00	32020		\N	240221	0	195662009	4112343		0
61261	3622	260139	2019-03-26	2019-03-26 00:00:00	2019-04-09	2019-04-09 00:00:00	32020		\N	240667	0	10509002	260139		0
61423	3629	372328	1959-07-20	1959-07-20 00:00:00	1959-10-26	1959-10-26 00:00:00	32020		\N	241489	0	65363002	372328		0
51057	3023	81893	2016-06-12	2016-06-12 00:00:00	\N	\N	32020		\N	201554	0	64766004	81893		0
61861	3652	40481087	1992-11-27	1992-11-27 00:00:00	1992-12-11	1992-12-11 00:00:00	32020		\N	243121	0	444814009	40481087		0
61995	3660	4112343	2010-07-16	2010-07-16 00:00:00	2010-07-24	2010-07-24 00:00:00	32020		\N	243560	0	195662009	4112343		0
62093	3667	4112343	2014-07-11	2014-07-11 00:00:00	2014-07-19	2014-07-19 00:00:00	32020		\N	243957	0	195662009	4112343		0
62415	3689	4142905	1963-11-17	1963-11-17 00:00:00	1964-01-16	1964-01-16 00:00:00	32020		\N	245225	0	33737001	4142905		0
62461	3691	4146173	1967-02-09	1967-02-09 00:00:00	1967-03-11	1967-03-11 00:00:00	32020		\N	245338	0	307731004	4146173		0
52122	3086	4112343	1985-12-18	1985-12-18 00:00:00	1985-12-25	1985-12-25 00:00:00	32020		\N	205437	0	195662009	4112343		0
62785	3708	4084167	1978-01-08	1978-01-08 00:00:00	1978-01-08	1978-01-08 00:00:00	32020		\N	246505	0	241929008	4084167		0
52425	3105	80180	2008-07-05	2008-07-05 00:00:00	\N	\N	32020		\N	206518	0	396275006	80180		0
63226	3734	80180	1986-02-28	1986-02-28 00:00:00	\N	\N	32020		\N	248111	0	396275006	80180		0
63368	3743	40481087	1980-01-08	1980-01-08 00:00:00	1980-01-15	1980-01-15 00:00:00	32020		\N	248690	0	444814009	40481087		0
63508	3750	372328	1961-09-28	1961-09-28 00:00:00	1961-12-30	1961-12-30 00:00:00	32020		\N	249217	0	65363002	372328		0
63703	3761	40481087	1973-04-16	1973-04-16 00:00:00	1973-04-30	1973-04-30 00:00:00	32020		\N	250053	0	444814009	40481087		0
53146	3147	40481087	1990-11-14	1990-11-14 00:00:00	1990-11-21	1990-11-21 00:00:00	32020		\N	209395	0	444814009	40481087		0
53436	3167	257012	1990-06-15	1990-06-15 00:00:00	\N	\N	32020		\N	210586	0	40055000	257012		0
53539	3172	4112343	2016-09-17	2016-09-17 00:00:00	2016-09-26	2016-09-26 00:00:00	32020		\N	210862	0	195662009	4112343		0
53646	3177	40481087	1954-01-14	1954-01-14 00:00:00	1954-01-28	1954-01-28 00:00:00	32020		\N	211267	0	444814009	40481087		0
43282	2578	80180	2008-04-04	2008-04-04 00:00:00	\N	\N	32020		\N	170753	0	396275006	80180		0
54010	3196	257012	2002-05-15	2002-05-15 00:00:00	\N	\N	32020		\N	212615	0	40055000	257012		0
43609	2597	4112343	1976-11-23	1976-11-23 00:00:00	1976-11-30	1976-11-30 00:00:00	32020		\N	171831	0	195662009	4112343		0
54309	3217	260139	2006-06-09	2006-06-09 00:00:00	2006-06-16	2006-06-16 00:00:00	32020		\N	213781	0	10509002	260139		0
43972	2617	40481087	2006-04-11	2006-04-11 00:00:00	2006-04-25	2006-04-25 00:00:00	32020		\N	173063	0	444814009	40481087		0
54804	3242	40481087	2013-07-08	2013-07-08 00:00:00	2013-07-22	2013-07-22 00:00:00	32020		\N	215622	0	444814009	40481087		0
55050	3259	40481087	1976-12-29	1976-12-29 00:00:00	1977-01-12	1977-01-12 00:00:00	32020		\N	216642	0	444814009	40481087		0
55256	3272	4112343	1979-07-26	1979-07-26 00:00:00	1979-08-03	1979-08-03 00:00:00	32020		\N	217467	0	195662009	4112343		0
55322	3277	4113008	2013-12-21	2013-12-21 00:00:00	2014-01-11	2014-01-11 00:00:00	32020		\N	217694	0	284549007	4113008		0
55479	3287	257012	1963-06-09	1963-06-09 00:00:00	\N	\N	32020		\N	218327	0	40055000	257012		0
55673	3295	4027663	1972-05-03	1972-05-03 00:00:00	\N	\N	32020		\N	218967	0	13200003	4027663		0
45271	2692	260139	1982-10-16	1982-10-16 00:00:00	1982-10-30	1982-10-30 00:00:00	32020		\N	178337	0	10509002	260139		0
56070	3320	80180	1999-02-02	1999-02-02 00:00:00	\N	\N	32020		\N	220445	0	396275006	80180		0
56191	3330	372328	1975-04-30	1975-04-30 00:00:00	1975-09-14	1975-09-14 00:00:00	32020		\N	220992	0	65363002	372328		0
56344	3339	40481087	1982-11-30	1982-11-30 00:00:00	1982-12-14	1982-12-14 00:00:00	32020		\N	221502	0	444814009	40481087		0
56473	3347	4237458	2011-02-16	2011-02-16 00:00:00	2011-04-17	2011-04-17 00:00:00	32020		\N	222022	0	58150001	4237458		0
56746	3365	78272	1968-03-28	1968-03-28 00:00:00	1968-05-02	1968-05-02 00:00:00	32020		\N	223178	0	70704007	78272		0
56821	3371	4112343	2000-09-07	2000-09-07 00:00:00	2000-09-17	2000-09-17 00:00:00	32020		\N	223649	0	195662009	4112343		0
46475	2768	40481087	1992-09-04	1992-09-04 00:00:00	1992-09-18	1992-09-18 00:00:00	32020		\N	183122	0	444814009	40481087		0
46603	2774	4112343	1995-07-12	1995-07-12 00:00:00	1995-07-21	1995-07-21 00:00:00	32020		\N	183704	0	195662009	4112343		0
57295	3399	4112343	2010-08-01	2010-08-01 00:00:00	2010-08-12	2010-08-12 00:00:00	32020		\N	225538	0	195662009	4112343		0
57465	3410	40481087	1984-06-02	1984-06-02 00:00:00	1984-06-09	1984-06-09 00:00:00	32020		\N	226190	0	444814009	40481087		0
57664	3420	40481087	1984-02-16	1984-02-16 00:00:00	1984-02-23	1984-02-23 00:00:00	32020		\N	226886	0	444814009	40481087		0
57819	3430	261325	1989-03-04	1989-03-04 00:00:00	\N	\N	32020		\N	227354	0	87433001	261325		0
57969	3437	40481087	1946-12-26	1946-12-26 00:00:00	1947-01-02	1947-01-02 00:00:00	32020		\N	227986	0	444814009	40481087		0
58121	3443	4116491	2006-03-01	2006-03-01 00:00:00	2006-04-17	2006-04-17 00:00:00	32020		\N	228484	0	301011002	4116491		0
47748	2835	40481087	1983-12-27	1983-12-27 00:00:00	1984-01-03	1984-01-03 00:00:00	32020		\N	188320	0	444814009	40481087		0
47941	2845	81151	1955-06-19	1955-06-19 00:00:00	1955-07-24	1955-07-24 00:00:00	32020		\N	188980	0	44465007	81151		0
58729	3483	4112343	1976-12-11	1976-12-11 00:00:00	1976-12-19	1976-12-19 00:00:00	32020		\N	231024	0	195662009	4112343		0
48243	2860	260139	1952-02-24	1952-02-24 00:00:00	1952-03-02	1952-03-02 00:00:00	32020		\N	190148	0	10509002	260139		0
48400	2866	81151	2018-10-03	2018-10-03 00:00:00	2018-10-31	2018-10-31 00:00:00	32020		\N	190697	0	44465007	81151		0
59223	3513	195588	2010-04-23	2010-04-23 00:00:00	2010-06-08	2010-06-08 00:00:00	32020		\N	233157	0	38822007	195588		0
69919	4137	4109685	2006-08-09	2006-08-09 00:00:00	2006-08-23	2006-08-23 00:00:00	32020		\N	275053	0	284551006	4109685		0
48956	2897	372328	1965-11-24	1965-11-24 00:00:00	1966-05-21	1966-05-21 00:00:00	32020		\N	192951	0	65363002	372328		0
59677	3536	192671	2000-02-18	2000-02-18 00:00:00	\N	\N	32020		\N	234830	0	K92.2	35208414		0
59862	3547	40481087	2016-06-23	2016-06-23 00:00:00	2016-07-14	2016-07-14 00:00:00	32020		\N	235580	0	444814009	40481087		0
59990	3553	28060	1984-08-13	1984-08-13 00:00:00	1984-08-25	1984-08-25 00:00:00	32020		\N	235876	0	43878008	28060		0
60135	3561	4134304	1967-04-02	1967-04-02 00:00:00	1967-05-02	1967-05-02 00:00:00	32020		\N	236472	0	263102004	4134304		0
60305	3569	30753	1998-05-18	1998-05-18 00:00:00	\N	\N	32020		\N	237132	0	16761005	30753		0
49909	2950	40481087	2006-11-28	2006-11-28 00:00:00	2006-12-12	2006-12-12 00:00:00	32020		\N	196983	0	444814009	40481087		0
60614	3583	260139	1988-01-26	1988-01-26 00:00:00	1988-02-09	1988-02-09 00:00:00	32020		\N	238260	0	10509002	260139		0
50252	2970	4134304	2015-01-15	2015-01-15 00:00:00	2015-02-14	2015-02-14 00:00:00	32020		\N	198343	0	263102004	4134304		0
60999	3610	40481087	2013-07-04	2013-07-04 00:00:00	2013-07-18	2013-07-18 00:00:00	32020		\N	239866	0	444814009	40481087		0
61091	3615	80180	1983-12-11	1983-12-11 00:00:00	\N	\N	32020		\N	240162	0	396275006	80180		0
61262	3623	40481087	1979-02-10	1979-02-10 00:00:00	1979-02-17	1979-02-17 00:00:00	32020		\N	240885	0	444814009	40481087		0
61424	3629	78272	1990-02-27	1990-02-27 00:00:00	1990-03-13	1990-03-13 00:00:00	32020		\N	241472	0	70704007	78272		0
51058	3023	260139	2017-06-26	2017-06-26 00:00:00	2017-07-03	2017-07-03 00:00:00	32020		\N	201520	0	10509002	260139		0
61862	3652	28060	2002-05-11	2002-05-11 00:00:00	2002-05-21	2002-05-21 00:00:00	32020		\N	243081	0	43878008	28060		0
61996	3660	260139	2005-04-28	2005-04-28 00:00:00	2005-05-05	2005-05-05 00:00:00	32020		\N	243565	0	10509002	260139		0
62094	3667	260139	2007-10-05	2007-10-05 00:00:00	2007-10-19	2007-10-19 00:00:00	32020		\N	243956	0	10509002	260139		0
62416	3689	260139	1975-03-10	1975-03-10 00:00:00	1975-03-24	1975-03-24 00:00:00	32020		\N	245229	0	10509002	260139		0
62462	3691	40481087	2011-02-26	2011-02-26 00:00:00	2011-03-19	2011-03-19 00:00:00	32020		\N	245357	0	444814009	40481087		0
52123	3086	4112343	1981-09-18	1981-09-18 00:00:00	1981-09-28	1981-09-28 00:00:00	32020		\N	205436	0	195662009	4112343		0
62786	3708	260139	1979-03-06	1979-03-06 00:00:00	1979-03-20	1979-03-20 00:00:00	32020		\N	246564	0	10509002	260139		0
52426	3105	40481087	1981-05-03	1981-05-03 00:00:00	1981-05-10	1981-05-10 00:00:00	32020		\N	206505	0	444814009	40481087		0
63227	3734	4112343	1976-03-10	1976-03-10 00:00:00	1976-03-23	1976-03-23 00:00:00	32020		\N	248176	0	195662009	4112343		0
63369	3743	4294548	1983-08-01	1983-08-01 00:00:00	1983-10-31	1983-10-31 00:00:00	32020		\N	248693	0	75498004	4294548		0
63509	3750	4310024	1993-05-14	1993-05-14 00:00:00	\N	\N	32020		\N	249194	0	424802006	4310024		0
63704	3761	372328	1959-07-22	1959-07-22 00:00:00	1959-09-26	1959-09-26 00:00:00	32020		\N	250077	0	65363002	372328		0
53147	3147	372328	1949-10-27	1949-10-27 00:00:00	1949-11-10	1949-11-10 00:00:00	32020		\N	209341	0	65363002	372328		0
53437	3167	81151	1974-01-23	1974-01-23 00:00:00	1974-02-13	1974-02-13 00:00:00	32020		\N	210549	0	44465007	81151		0
53540	3172	40481087	2003-03-14	2003-03-14 00:00:00	2003-03-21	2003-03-21 00:00:00	32020		\N	210852	0	444814009	40481087		0
53647	3177	4112343	1968-07-13	1968-07-13 00:00:00	1968-07-26	1968-07-26 00:00:00	32020		\N	211251	0	195662009	4112343		0
43283	2578	260139	2008-03-06	2008-03-06 00:00:00	2008-03-20	2008-03-20 00:00:00	32020		\N	170753	0	10509002	260139		0
54011	3196	260139	1983-09-16	1983-09-16 00:00:00	1983-09-23	1983-09-23 00:00:00	32020		\N	212627	0	10509002	260139		0
43610	2597	81151	1973-01-12	1973-01-12 00:00:00	1973-01-26	1973-01-26 00:00:00	32020		\N	171855	0	44465007	81151		0
54310	3217	260139	1993-08-13	1993-08-13 00:00:00	1993-08-27	1993-08-27 00:00:00	32020		\N	213802	0	10509002	260139		0
43973	2617	80180	1987-07-15	1987-07-15 00:00:00	\N	\N	32020		\N	173074	0	396275006	80180		0
54649	3236	260139	1953-08-06	1953-08-06 00:00:00	1953-08-20	1953-08-20 00:00:00	32020		\N	215126	0	10509002	260139		0
54813	3244	81151	1980-04-02	1980-04-02 00:00:00	1980-04-23	1980-04-23 00:00:00	32020		\N	215745	0	44465007	81151		0
55051	3259	372328	1967-12-02	1967-12-02 00:00:00	1968-04-05	1968-04-05 00:00:00	32020		\N	216688	0	65363002	372328		0
55257	3272	40481087	2001-03-14	2001-03-14 00:00:00	2001-03-21	2001-03-21 00:00:00	32020		\N	217468	0	444814009	40481087		0
55323	3277	40481087	2012-06-06	2012-06-06 00:00:00	2012-06-20	2012-06-20 00:00:00	32020		\N	217723	0	444814009	40481087		0
55480	3287	40481087	1982-03-29	1982-03-29 00:00:00	1982-04-12	1982-04-12 00:00:00	32020		\N	218389	0	444814009	40481087		0
55674	3295	313217	1990-10-08	1990-10-08 00:00:00	\N	\N	32020		\N	218937	0	49436004	313217		0
45272	2692	4112343	1974-07-13	1974-07-13 00:00:00	1974-07-25	1974-07-25 00:00:00	32020		\N	178336	0	195662009	4112343		0
56071	3320	260139	1967-03-09	1967-03-09 00:00:00	1967-03-23	1967-03-23 00:00:00	32020		\N	220436	0	10509002	260139		0
56192	3330	4027663	2007-09-29	2007-09-29 00:00:00	\N	\N	32020		\N	221007	0	13200003	4027663		0
56345	3339	372328	1970-02-10	1970-02-10 00:00:00	1970-09-01	1970-09-01 00:00:00	32020		\N	221530	0	65363002	372328		0
56474	3347	40481087	1980-11-02	1980-11-02 00:00:00	1980-11-09	1980-11-09 00:00:00	32020		\N	222062	0	444814009	40481087		0
56747	3365	440086	1971-07-16	1971-07-16 00:00:00	1973-01-26	1973-01-26 00:00:00	32020		\N	223180	0	192127007	440086		0
56822	3371	40481087	2006-05-30	2006-05-30 00:00:00	2006-06-06	2006-06-06 00:00:00	32020		\N	223571	0	444814009	40481087		0
46476	2768	40481087	1985-04-30	1985-04-30 00:00:00	1985-05-07	1985-05-07 00:00:00	32020		\N	183170	0	444814009	40481087		0
46604	2774	4296204	2007-03-20	2007-03-20 00:00:00	2007-04-17	2007-04-17 00:00:00	32020		\N	183691	0	403190006	4296204		0
57296	3399	40481087	2005-02-08	2005-02-08 00:00:00	2005-02-15	2005-02-15 00:00:00	32020		\N	225439	0	444814009	40481087		0
57466	3410	40481087	1996-05-03	1996-05-03 00:00:00	1996-05-17	1996-05-17 00:00:00	32020		\N	226207	0	444814009	40481087		0
57665	3420	40481087	1987-04-04	1987-04-04 00:00:00	1987-04-18	1987-04-18 00:00:00	32020		\N	226846	0	444814009	40481087		0
57820	3430	40481087	1989-02-28	1989-02-28 00:00:00	1989-03-14	1989-03-14 00:00:00	32020		\N	227354	0	444814009	40481087		0
57970	3437	4285898	1954-09-04	1954-09-04 00:00:00	\N	\N	32020		\N	227954	0	68496003	4285898		0
58122	3443	40481087	2010-04-29	2010-04-29 00:00:00	2010-05-20	2010-05-20 00:00:00	32020		\N	228459	0	444814009	40481087		0
47749	2835	40481087	2016-09-23	2016-09-23 00:00:00	2016-10-14	2016-10-14 00:00:00	32020		\N	188325	0	444814009	40481087		0
47942	2845	4027663	1983-09-25	1983-09-25 00:00:00	\N	\N	32020		\N	188901	0	13200003	4027663		0
58730	3483	40481087	2001-11-11	2001-11-11 00:00:00	2001-11-18	2001-11-18 00:00:00	32020		\N	231113	0	444814009	40481087		0
48244	2860	4116491	1996-10-03	1996-10-03 00:00:00	1996-11-26	1996-11-26 00:00:00	32020		\N	190103	0	301011002	4116491		0
48401	2866	372328	1969-08-05	1969-08-05 00:00:00	1970-01-11	1970-01-11 00:00:00	32020		\N	190666	0	65363002	372328		0
59224	3513	192671	2008-01-02	2008-01-02 00:00:00	\N	\N	32020		\N	233127	0	K92.2	35208414		0
69920	4137	40481087	1971-11-26	1971-11-26 00:00:00	1971-12-03	1971-12-03 00:00:00	32020		\N	274992	0	444814009	40481087		0
48957	2897	4294548	2013-06-23	2013-06-23 00:00:00	2013-06-30	2013-06-30 00:00:00	32020		\N	192890	0	75498004	4294548		0
59678	3536	4113008	2006-08-07	2006-08-07 00:00:00	2006-08-28	2006-08-28 00:00:00	32020		\N	234808	0	284549007	4113008		0
59863	3547	378001	1996-07-26	1996-07-26 00:00:00	1996-08-25	1996-08-25 00:00:00	32020		\N	235541	0	62106007	378001		0
59991	3553	4112343	1937-06-08	1937-06-08 00:00:00	1937-06-20	1937-06-20 00:00:00	32020		\N	235932	0	195662009	4112343		0
60136	3561	40481087	1925-05-12	1925-05-12 00:00:00	1925-05-19	1925-05-19 00:00:00	32020		\N	236495	0	444814009	40481087		0
60306	3569	4310024	1997-05-23	1997-05-23 00:00:00	\N	\N	32020		\N	237132	0	424802006	4310024		0
49910	2950	40481087	1977-12-15	1977-12-15 00:00:00	1977-12-29	1977-12-29 00:00:00	32020		\N	196980	0	444814009	40481087		0
60615	3583	4112343	1999-03-12	1999-03-12 00:00:00	1999-03-22	1999-03-22 00:00:00	32020		\N	238271	0	195662009	4112343		0
50253	2970	4310024	2003-11-03	2003-11-03 00:00:00	\N	\N	32020		\N	198353	0	424802006	4310024		0
61000	3610	260139	1985-08-31	1985-08-31 00:00:00	1985-09-07	1985-09-07 00:00:00	32020		\N	239842	0	10509002	260139		0
61092	3615	260139	2011-01-02	2011-01-02 00:00:00	2011-01-09	2011-01-09 00:00:00	32020		\N	240203	0	10509002	260139		0
61263	3623	372328	1954-06-10	1954-06-10 00:00:00	1955-01-30	1955-01-30 00:00:00	32020		\N	240872	0	65363002	372328		0
61425	3629	260139	1994-11-18	1994-11-18 00:00:00	1994-12-02	1994-12-02 00:00:00	32020		\N	241497	0	10509002	260139		0
51059	3023	40481087	2009-01-08	2009-01-08 00:00:00	2009-01-22	2009-01-22 00:00:00	32020		\N	201540	0	444814009	40481087		0
61863	3652	257012	1999-08-05	1999-08-05 00:00:00	\N	\N	32020		\N	243122	0	40055000	257012		0
61997	3660	40481087	2001-12-14	2001-12-14 00:00:00	2001-12-28	2001-12-28 00:00:00	32020		\N	243559	0	444814009	40481087		0
62095	3667	4112343	1995-03-29	1995-03-29 00:00:00	1995-04-10	1995-04-10 00:00:00	32020		\N	243937	0	195662009	4112343		0
72875	4330	40481087	1983-07-22	1983-07-22 00:00:00	1983-07-29	1983-07-29 00:00:00	32020		\N	287187	0	444814009	40481087		0
62463	3691	4156265	2012-07-17	2012-07-17 00:00:00	2012-08-07	2012-08-07 00:00:00	32020		\N	245332	0	370247008	4156265		0
52124	3086	372328	1971-07-12	1971-07-12 00:00:00	1971-09-01	1971-09-01 00:00:00	32020		\N	205448	0	65363002	372328		0
62787	3708	80180	2015-06-18	2015-06-18 00:00:00	\N	\N	32020		\N	246528	0	396275006	80180		0
52427	3105	372328	1975-04-23	1975-04-23 00:00:00	1976-01-12	1976-01-12 00:00:00	32020		\N	206531	0	65363002	372328		0
63228	3734	4278672	1966-02-27	1966-02-27 00:00:00	1966-05-28	1966-05-28 00:00:00	32020		\N	248171	0	65966004	4278672		0
63370	3743	260139	2018-09-26	2018-09-26 00:00:00	2018-10-10	2018-10-10 00:00:00	32020		\N	248697	0	10509002	260139		0
63510	3750	4296204	1993-04-29	1993-04-29 00:00:00	1993-05-20	1993-05-20 00:00:00	32020		\N	249194	0	403190006	4296204		0
63705	3761	260139	1991-06-06	1991-06-06 00:00:00	1991-06-13	1991-06-13 00:00:00	32020		\N	250067	0	10509002	260139		0
53148	3147	4156265	2014-07-28	2014-07-28 00:00:00	2014-08-18	2014-08-18 00:00:00	32020		\N	209429	0	370247008	4156265		0
53438	3167	4152936	1979-02-17	1979-02-17 00:00:00	1979-03-03	1979-03-03 00:00:00	32020		\N	210550	0	283385000	4152936		0
53541	3172	260139	1986-11-21	1986-11-21 00:00:00	1986-11-28	1986-11-28 00:00:00	32020		\N	210851	0	10509002	260139		0
53648	3177	80502	1976-10-20	1976-10-20 00:00:00	\N	\N	32020		\N	211302	0	64859006	80502		0
43284	2578	4146173	1975-05-03	1975-05-03 00:00:00	1975-07-02	1975-07-02 00:00:00	32020		\N	170739	0	307731004	4146173		0
54025	3199	81151	1980-08-22	1980-08-22 00:00:00	1980-09-19	1980-09-19 00:00:00	32020		\N	212768	0	44465007	81151		0
43611	2597	28060	2016-02-05	2016-02-05 00:00:00	2016-02-14	2016-02-14 00:00:00	32020		\N	171835	0	43878008	28060		0
54311	3217	260139	1999-07-28	1999-07-28 00:00:00	1999-08-11	1999-08-11 00:00:00	32020		\N	213803	0	10509002	260139		0
43974	2617	40481087	1996-02-06	1996-02-06 00:00:00	1996-02-13	1996-02-13 00:00:00	32020		\N	173062	0	444814009	40481087		0
54650	3236	80502	2014-09-05	2014-09-05 00:00:00	\N	\N	32020		\N	215106	0	64859006	80502		0
54814	3244	4116491	2013-04-08	2013-04-08 00:00:00	2013-05-27	2013-05-27 00:00:00	32020		\N	215720	0	301011002	4116491		0
55052	3259	4112343	1980-11-12	1980-11-12 00:00:00	1980-11-23	1980-11-23 00:00:00	32020		\N	216643	0	195662009	4112343		0
55258	3272	40481087	2007-08-15	2007-08-15 00:00:00	2007-08-29	2007-08-29 00:00:00	32020		\N	217473	0	444814009	40481087		0
55324	3278	81151	1970-07-25	1970-07-25 00:00:00	1970-08-08	1970-08-08 00:00:00	32020		\N	217744	0	44465007	81151		0
55481	3287	372328	1949-02-01	1949-02-01 00:00:00	1949-06-20	1949-06-20 00:00:00	32020		\N	218295	0	65363002	372328		0
55675	3295	40481087	1999-06-23	1999-06-23 00:00:00	1999-06-30	1999-06-30 00:00:00	32020		\N	218919	0	444814009	40481087		0
45273	2692	4112343	1958-04-26	1958-04-26 00:00:00	1958-05-04	1958-05-04 00:00:00	32020		\N	178349	0	195662009	4112343		0
56072	3320	260139	1970-02-13	1970-02-13 00:00:00	1970-02-20	1970-02-20 00:00:00	32020		\N	220443	0	10509002	260139		0
56193	3330	4155034	2007-08-24	2007-08-24 00:00:00	2007-09-14	2007-09-14 00:00:00	32020		\N	221007	0	283371005	4155034		0
56346	3342	40481087	1929-04-11	1929-04-11 00:00:00	1929-04-25	1929-04-25 00:00:00	32020		\N	221604	0	444814009	40481087		0
56475	3347	4112343	1999-08-12	1999-08-12 00:00:00	1999-08-19	1999-08-19 00:00:00	32020		\N	222063	0	195662009	4112343		0
56748	3365	4112343	1978-07-23	1978-07-23 00:00:00	1978-07-30	1978-07-30 00:00:00	32020		\N	223173	0	195662009	4112343		0
56823	3371	28060	1988-12-11	1988-12-11 00:00:00	1988-12-21	1988-12-21 00:00:00	32020		\N	223606	0	43878008	28060		0
46477	2768	28060	1974-11-13	1974-11-13 00:00:00	1974-11-22	1974-11-22 00:00:00	32020		\N	183169	0	43878008	28060		0
46605	2774	260139	1941-04-17	1941-04-17 00:00:00	1941-04-24	1941-04-24 00:00:00	32020		\N	183655	0	10509002	260139		0
57307	3401	40481087	1960-12-16	1960-12-16 00:00:00	1960-12-23	1960-12-23 00:00:00	32020		\N	225592	0	444814009	40481087		0
57467	3410	40481087	2009-03-06	2009-03-06 00:00:00	2009-03-27	2009-03-27 00:00:00	32020		\N	226166	0	444814009	40481087		0
57666	3420	260139	1973-06-15	1973-06-15 00:00:00	1973-06-29	1973-06-29 00:00:00	32020		\N	226844	0	10509002	260139		0
57821	3431	40481087	1969-10-10	1969-10-10 00:00:00	1969-10-24	1969-10-24 00:00:00	32020		\N	227448	0	444814009	40481087		0
57971	3437	80180	1955-03-03	1955-03-03 00:00:00	\N	\N	32020		\N	227954	0	396275006	80180		0
58123	3443	30753	2011-05-25	2011-05-25 00:00:00	\N	\N	32020		\N	228459	0	16761005	30753		0
47750	2835	80180	1950-10-19	1950-10-19 00:00:00	\N	\N	32020		\N	188286	0	396275006	80180		0
47943	2845	4112343	1982-03-12	1982-03-12 00:00:00	1982-03-21	1982-03-21 00:00:00	32020		\N	188901	0	195662009	4112343		0
58731	3483	81151	1996-11-09	1996-11-09 00:00:00	1996-12-14	1996-12-14 00:00:00	32020		\N	231119	0	44465007	81151		0
48245	2860	372328	1946-01-24	1946-01-24 00:00:00	1946-06-14	1946-06-14 00:00:00	32020		\N	190160	0	65363002	372328		0
48402	2866	40481087	1984-08-25	1984-08-25 00:00:00	1984-09-01	1984-09-01 00:00:00	32020		\N	190663	0	444814009	40481087		0
59225	3513	260139	1991-02-18	1991-02-18 00:00:00	1991-02-25	1991-02-25 00:00:00	32020		\N	233130	0	10509002	260139		0
69921	4137	372328	1966-06-17	1966-06-17 00:00:00	1967-01-11	1967-01-11 00:00:00	32020		\N	274986	0	65363002	372328		0
48958	2897	4027663	1992-05-27	1992-05-27 00:00:00	\N	\N	32020		\N	192920	0	13200003	4027663		0
59679	3536	40481087	2019-02-04	2019-02-04 00:00:00	2019-02-18	2019-02-18 00:00:00	32020		\N	234875	0	444814009	40481087		0
59864	3547	4112343	1997-04-20	1997-04-20 00:00:00	1997-04-29	1997-04-29 00:00:00	32020		\N	235585	0	195662009	4112343		0
60018	3556	40481087	2017-10-07	2017-10-07 00:00:00	2017-10-21	2017-10-21 00:00:00	32020		\N	236105	0	444814009	40481087		0
60137	3561	80180	1943-11-09	1943-11-09 00:00:00	\N	\N	32020		\N	236507	0	396275006	80180		0
60307	3569	257012	2006-01-04	2006-01-04 00:00:00	\N	\N	32020		\N	237161	0	40055000	257012		0
49911	2950	80180	1978-04-26	1978-04-26 00:00:00	\N	\N	32020		\N	196980	0	396275006	80180		0
60616	3583	4218389	1985-10-07	1985-10-07 00:00:00	1985-11-11	1985-11-11 00:00:00	32020		\N	238206	0	39848009	4218389		0
50254	2970	4266809	2004-11-27	2004-11-27 00:00:00	\N	\N	32020		\N	198353	0	397881000	4266809		0
61001	3610	4112343	1961-08-07	1961-08-07 00:00:00	1961-08-15	1961-08-15 00:00:00	32020		\N	239887	0	195662009	4112343		0
61093	3615	378001	1993-07-16	1993-07-16 00:00:00	1993-09-14	1993-09-14 00:00:00	32020		\N	240218	0	62106007	378001		0
61264	3623	4112343	1982-04-10	1982-04-10 00:00:00	1982-04-18	1982-04-18 00:00:00	32020		\N	240888	0	195662009	4112343		0
61426	3629	4294548	1973-04-26	1973-04-26 00:00:00	1973-07-05	1973-07-05 00:00:00	32020		\N	241455	0	75498004	4294548		0
51060	3023	28060	1995-07-15	1995-07-15 00:00:00	1995-07-26	1995-07-26 00:00:00	32020		\N	201539	0	43878008	28060		0
61864	3652	4294548	1999-06-17	1999-06-17 00:00:00	1999-12-16	1999-12-16 00:00:00	32020		\N	243100	0	75498004	4294548		0
61998	3660	4278672	1992-06-17	1992-06-17 00:00:00	1992-09-15	1992-09-15 00:00:00	32020		\N	243605	0	65966004	4278672		0
62096	3667	4059173	2000-02-14	2000-02-14 00:00:00	2000-04-14	2000-04-14 00:00:00	32020		\N	243978	0	16114001	4059173		0
72876	4330	40481087	1971-05-25	1971-05-25 00:00:00	1971-06-15	1971-06-15 00:00:00	32020		\N	287211	0	444814009	40481087		0
62464	3691	4112343	2002-10-15	2002-10-15 00:00:00	2002-10-27	2002-10-27 00:00:00	32020		\N	245343	0	195662009	4112343		0
62583	3697	260139	1960-07-05	1960-07-05 00:00:00	1960-07-19	1960-07-19 00:00:00	32020		\N	245799	0	10509002	260139		0
62788	3708	4112343	1992-05-12	1992-05-12 00:00:00	1992-05-22	1992-05-22 00:00:00	32020		\N	246520	0	195662009	4112343		0
52428	3106	4218389	1957-03-03	1957-03-03 00:00:00	1957-03-31	1957-03-31 00:00:00	32020		\N	206616	0	39848009	4218389		0
63229	3734	4059173	1977-01-30	1977-01-30 00:00:00	1977-03-01	1977-03-01 00:00:00	32020		\N	248172	0	16114001	4059173		0
63371	3744	80180	2004-12-09	2004-12-09 00:00:00	\N	\N	32020		\N	248861	0	396275006	80180		0
63511	3750	40481087	1974-10-27	1974-10-27 00:00:00	1974-11-17	1974-11-17 00:00:00	32020		\N	249247	0	444814009	40481087		0
63706	3761	40481087	2012-01-08	2012-01-08 00:00:00	2012-01-15	2012-01-15 00:00:00	32020		\N	250114	0	444814009	40481087		0
53149	3147	260139	1947-11-09	1947-11-09 00:00:00	1947-11-23	1947-11-23 00:00:00	32020		\N	209356	0	10509002	260139		0
53439	3167	40481087	2003-05-30	2003-05-30 00:00:00	2003-06-06	2003-06-06 00:00:00	32020		\N	210534	0	444814009	40481087		0
53552	3174	257012	1998-12-12	1998-12-12 00:00:00	\N	\N	32020		\N	210977	0	40055000	257012		0
53649	3177	40481087	1991-08-19	1991-08-19 00:00:00	1991-09-02	1991-09-02 00:00:00	32020		\N	211271	0	444814009	40481087		0
43285	2578	81151	1990-12-10	1990-12-10 00:00:00	1990-12-24	1990-12-24 00:00:00	32020		\N	170763	0	44465007	81151		0
54026	3199	40481087	1985-04-27	1985-04-27 00:00:00	1985-05-11	1985-05-11 00:00:00	32020		\N	212772	0	444814009	40481087		0
43612	2597	4112343	1983-09-27	1983-09-27 00:00:00	1983-10-10	1983-10-10 00:00:00	32020		\N	171826	0	195662009	4112343		0
54312	3217	4109685	1998-05-08	1998-05-08 00:00:00	1998-05-29	1998-05-29 00:00:00	32020		\N	213810	0	284551006	4109685		0
43975	2617	4112343	1972-05-22	1972-05-22 00:00:00	1972-05-29	1972-05-29 00:00:00	32020		\N	173027	0	195662009	4112343		0
54651	3236	40481087	1944-07-12	1944-07-12 00:00:00	1944-08-02	1944-08-02 00:00:00	32020		\N	215062	0	444814009	40481087		0
54815	3244	40481087	2016-05-10	2016-05-10 00:00:00	2016-05-17	2016-05-17 00:00:00	32020		\N	215722	0	444814009	40481087		0
55053	3259	80180	1999-10-11	1999-10-11 00:00:00	\N	\N	32020		\N	216678	0	396275006	80180		0
65737	3887	40481087	2012-05-04	2012-05-04 00:00:00	2012-05-25	2012-05-25 00:00:00	32020		\N	258345	0	444814009	40481087		0
55325	3278	192671	1994-02-17	1994-02-17 00:00:00	\N	\N	32020		\N	217749	0	K92.2	35208414		0
55482	3287	4112343	1971-12-20	1971-12-20 00:00:00	1972-01-01	1972-01-01 00:00:00	32020		\N	218330	0	195662009	4112343		0
55676	3295	4294548	1996-01-27	1996-01-27 00:00:00	1996-07-27	1996-07-27 00:00:00	32020		\N	218885	0	75498004	4294548		0
45274	2692	40481087	1952-01-18	1952-01-18 00:00:00	1952-02-01	1952-02-01 00:00:00	32020		\N	178329	0	444814009	40481087		0
56073	3320	28060	2012-10-01	2012-10-01 00:00:00	2012-10-13	2012-10-13 00:00:00	32020		\N	220446	0	43878008	28060		0
56194	3330	260139	2009-06-02	2009-06-02 00:00:00	2009-06-09	2009-06-09 00:00:00	32020		\N	220956	0	10509002	260139		0
56347	3342	40481087	1997-09-20	1997-09-20 00:00:00	1997-10-04	1997-10-04 00:00:00	32020		\N	221579	0	444814009	40481087		0
56476	3347	4218389	2005-04-29	2005-04-29 00:00:00	2005-05-27	2005-05-27 00:00:00	32020		\N	222020	0	39848009	4218389		0
56749	3365	40481087	1988-09-14	1988-09-14 00:00:00	1988-09-21	1988-09-21 00:00:00	32020		\N	223214	0	444814009	40481087		0
56824	3371	80180	2011-04-23	2011-04-23 00:00:00	\N	\N	32020		\N	223666	0	396275006	80180		0
46478	2768	80180	2010-07-15	2010-07-15 00:00:00	\N	\N	32020		\N	183124	0	396275006	80180		0
46606	2774	317576	1997-12-26	1997-12-26 00:00:00	\N	\N	32020		\N	183650	0	53741008	317576		0
57308	3401	81151	2002-02-21	2002-02-21 00:00:00	2002-03-21	2002-03-21 00:00:00	32020		\N	225626	0	44465007	81151		0
57468	3410	40481087	1985-11-06	1985-11-06 00:00:00	1985-11-20	1985-11-20 00:00:00	32020		\N	226165	0	444814009	40481087		0
57667	3420	4059173	1969-09-03	1969-09-03 00:00:00	1969-10-03	1969-10-03 00:00:00	32020		\N	226881	0	16114001	4059173		0
57822	3431	372328	1966-06-21	1966-06-21 00:00:00	1966-09-14	1966-09-14 00:00:00	32020		\N	227445	0	65363002	372328		0
57972	3437	4112343	1960-10-19	1960-10-19 00:00:00	1960-10-29	1960-10-29 00:00:00	32020		\N	227940	0	195662009	4112343		0
58124	3443	4285898	2012-02-18	2012-02-18 00:00:00	\N	\N	32020		\N	228459	0	68496003	4285898		0
47751	2836	4116491	2007-08-26	2007-08-26 00:00:00	2007-10-05	2007-10-05 00:00:00	32020		\N	188404	0	301011002	4116491		0
47944	2845	260139	2014-02-10	2014-02-10 00:00:00	2014-02-24	2014-02-24 00:00:00	32020		\N	188940	0	10509002	260139		0
58732	3483	192671	1989-01-07	1989-01-07 00:00:00	\N	\N	32020		\N	231109	0	K92.2	35208414		0
48246	2860	28060	1953-11-14	1953-11-14 00:00:00	1953-11-21	1953-11-21 00:00:00	32020		\N	190133	0	43878008	28060		0
48403	2866	40481087	1982-02-10	1982-02-10 00:00:00	1982-03-03	1982-03-03 00:00:00	32020		\N	190686	0	444814009	40481087		0
59226	3513	40481087	2016-04-07	2016-04-07 00:00:00	2016-04-21	2016-04-21 00:00:00	32020		\N	233159	0	444814009	40481087		0
69922	4137	4283893	2002-10-07	2002-10-07 00:00:00	2002-11-18	2002-11-18 00:00:00	32020		\N	274999	0	36971009	4283893		0
48959	2897	40481087	1961-01-07	1961-01-07 00:00:00	1961-01-14	1961-01-14 00:00:00	32020		\N	192946	0	444814009	40481087		0
59680	3536	4285898	1999-07-21	1999-07-21 00:00:00	\N	\N	32020		\N	234868	0	68496003	4285898		0
59865	3547	4112343	1977-03-09	1977-03-09 00:00:00	1977-03-20	1977-03-20 00:00:00	32020		\N	235564	0	195662009	4112343		0
60019	3556	260139	2000-08-22	2000-08-22 00:00:00	2000-08-29	2000-08-29 00:00:00	32020		\N	236120	0	10509002	260139		0
60138	3561	4266809	1943-11-09	1943-11-09 00:00:00	\N	\N	32020		\N	236507	0	397881000	4266809		0
60308	3569	4285898	1999-03-14	1999-03-14 00:00:00	\N	\N	32020		\N	237123	0	68496003	4285898		0
49912	2950	4112343	2011-09-15	2011-09-15 00:00:00	2011-09-28	2011-09-28 00:00:00	32020		\N	196900	0	195662009	4112343		0
60637	3589	4112343	1990-10-13	1990-10-13 00:00:00	1990-10-26	1990-10-26 00:00:00	32020		\N	238428	0	195662009	4112343		0
50255	2970	81893	2004-01-02	2004-01-02 00:00:00	\N	\N	32020		\N	198353	0	64766004	81893		0
61002	3610	4112343	2001-04-06	2001-04-06 00:00:00	2001-04-15	2001-04-15 00:00:00	32020		\N	239864	0	195662009	4112343		0
61094	3615	40481087	1963-01-22	1963-01-22 00:00:00	1963-02-12	1963-02-12 00:00:00	32020		\N	240201	0	444814009	40481087		0
61265	3623	40481087	1953-12-30	1953-12-30 00:00:00	1954-01-13	1954-01-13 00:00:00	32020		\N	240891	0	444814009	40481087		0
61427	3629	40481087	2018-09-26	2018-09-26 00:00:00	2018-10-03	2018-10-03 00:00:00	32020		\N	241462	0	444814009	40481087		0
51061	3023	78272	1993-04-24	1993-04-24 00:00:00	1993-05-29	1993-05-29 00:00:00	32020		\N	201508	0	70704007	78272		0
61865	3652	40481087	1975-07-08	1975-07-08 00:00:00	1975-07-22	1975-07-22 00:00:00	32020		\N	243098	0	444814009	40481087		0
61999	3660	40481087	1999-08-28	1999-08-28 00:00:00	1999-09-18	1999-09-18 00:00:00	32020		\N	243558	0	444814009	40481087		0
62097	3667	260139	1985-11-14	1985-11-14 00:00:00	1985-11-21	1985-11-21 00:00:00	32020		\N	243946	0	10509002	260139		0
72877	4330	372328	1946-01-21	1946-01-21 00:00:00	1946-03-30	1946-03-30 00:00:00	32020		\N	287216	0	65363002	372328		0
62465	3691	40481087	2003-08-27	2003-08-27 00:00:00	2003-09-17	2003-09-17 00:00:00	32020		\N	245347	0	444814009	40481087		0
62584	3697	195588	1978-05-02	1978-05-02 00:00:00	1978-06-27	1978-06-27 00:00:00	32020		\N	245801	0	38822007	195588		0
62789	3708	372328	1981-05-12	1981-05-12 00:00:00	1982-03-19	1982-03-19 00:00:00	32020		\N	246484	0	65363002	372328		0
52429	3106	40481087	1960-06-26	1960-06-26 00:00:00	1960-07-17	1960-07-17 00:00:00	32020		\N	206546	0	444814009	40481087		0
63230	3734	40481087	1960-05-09	1960-05-09 00:00:00	1960-05-23	1960-05-23 00:00:00	32020		\N	248123	0	444814009	40481087		0
63372	3744	40479768	1994-12-17	1994-12-17 00:00:00	1995-02-22	1995-02-22 00:00:00	32020		\N	248852	0	444470001	40479768		0
63512	3750	260139	2003-11-24	2003-11-24 00:00:00	2003-12-01	2003-12-01 00:00:00	32020		\N	249250	0	10509002	260139		0
63707	3761	40481087	1992-07-15	1992-07-15 00:00:00	1992-07-29	1992-07-29 00:00:00	32020		\N	250068	0	444814009	40481087		0
53150	3147	260139	1980-01-01	1980-01-01 00:00:00	1980-01-15	1980-01-15 00:00:00	32020		\N	209360	0	10509002	260139		0
53440	3167	28060	2011-09-29	2011-09-29 00:00:00	2011-10-10	2011-10-10 00:00:00	32020		\N	210589	0	43878008	28060		0
53553	3174	28060	1991-12-18	1991-12-18 00:00:00	1991-12-26	1991-12-26 00:00:00	32020		\N	210976	0	43878008	28060		0
53650	3177	4296205	1942-03-10	1942-03-10 00:00:00	1942-03-24	1942-03-24 00:00:00	32020		\N	211228	0	403191005	4296205		0
43286	2578	4112343	1988-11-09	1988-11-09 00:00:00	1988-11-21	1988-11-21 00:00:00	32020		\N	170740	0	195662009	4112343		0
54027	3199	372328	1983-06-29	1983-06-29 00:00:00	1984-02-15	1984-02-15 00:00:00	32020		\N	212761	0	65363002	372328		0
43613	2597	4112343	2012-02-12	2012-02-12 00:00:00	2012-02-23	2012-02-23 00:00:00	32020		\N	171840	0	195662009	4112343		0
54313	3217	4112343	2006-12-08	2006-12-08 00:00:00	2006-12-19	2006-12-19 00:00:00	32020		\N	213766	0	195662009	4112343		0
43976	2617	40481087	1997-04-14	1997-04-14 00:00:00	1997-04-28	1997-04-28 00:00:00	32020		\N	173030	0	444814009	40481087		0
54652	3236	4112343	1998-09-23	1998-09-23 00:00:00	1998-10-06	1998-10-06 00:00:00	32020		\N	215113	0	195662009	4112343		0
54816	3244	260139	1985-09-14	1985-09-14 00:00:00	1985-09-28	1985-09-28 00:00:00	32020		\N	215689	0	10509002	260139		0
55054	3259	78272	1982-03-30	1982-03-30 00:00:00	1982-04-20	1982-04-20 00:00:00	32020		\N	216673	0	70704007	78272		0
65738	3887	40481087	1975-08-23	1975-08-23 00:00:00	1975-08-30	1975-08-30 00:00:00	32020		\N	258366	0	444814009	40481087		0
55326	3278	4112343	2018-12-02	2018-12-02 00:00:00	2018-12-13	2018-12-13 00:00:00	32020		\N	217786	0	195662009	4112343		0
55483	3287	321042	1967-07-10	1967-07-10 00:00:00	\N	\N	32020		\N	218352	0	410429000	321042		0
55677	3295	40481087	1944-08-06	1944-08-06 00:00:00	1944-08-20	1944-08-20 00:00:00	32020		\N	218902	0	444814009	40481087		0
45275	2692	80180	1986-01-21	1986-01-21 00:00:00	\N	\N	32020		\N	178313	0	396275006	80180		0
56074	3320	260139	2000-12-10	2000-12-10 00:00:00	2000-12-24	2000-12-24 00:00:00	32020		\N	220486	0	10509002	260139		0
56195	3330	81151	1975-06-29	1975-06-29 00:00:00	1975-07-13	1975-07-13 00:00:00	32020		\N	221006	0	44465007	81151		0
56348	3342	40481087	1980-10-15	1980-10-15 00:00:00	1980-10-22	1980-10-22 00:00:00	32020		\N	221668	0	444814009	40481087		0
56493	3352	4112343	1989-07-08	1989-07-08 00:00:00	1989-07-19	1989-07-19 00:00:00	32020		\N	222285	0	195662009	4112343		0
56750	3365	80180	2006-01-23	2006-01-23 00:00:00	\N	\N	32020		\N	223157	0	396275006	80180		0
56825	3371	40481087	2014-09-28	2014-09-28 00:00:00	2014-10-05	2014-10-05 00:00:00	32020		\N	223542	0	444814009	40481087		0
46479	2768	4266809	2010-07-15	2010-07-15 00:00:00	\N	\N	32020		\N	183124	0	397881000	4266809		0
46607	2774	260139	1995-12-03	1995-12-03 00:00:00	1995-12-17	1995-12-17 00:00:00	32020		\N	183705	0	10509002	260139		0
57309	3401	4112343	2001-12-01	2001-12-01 00:00:00	2001-12-09	2001-12-09 00:00:00	32020		\N	225595	0	195662009	4112343		0
57469	3410	4112343	1969-04-05	1969-04-05 00:00:00	1969-04-18	1969-04-18 00:00:00	32020		\N	226193	0	195662009	4112343		0
57668	3420	40481087	1970-02-05	1970-02-05 00:00:00	1970-02-12	1970-02-12 00:00:00	32020		\N	226904	0	444814009	40481087		0
57823	3431	4112343	1972-05-01	1972-05-01 00:00:00	1972-05-09	1972-05-09 00:00:00	32020		\N	227458	0	195662009	4112343		0
57973	3437	40481087	1937-03-10	1937-03-10 00:00:00	1937-03-31	1937-03-31 00:00:00	32020		\N	227937	0	444814009	40481087		0
58125	3443	372328	1978-07-02	1978-07-02 00:00:00	1978-08-16	1978-08-16 00:00:00	32020		\N	228458	0	65363002	372328		0
47752	2836	40481087	2014-08-20	2014-08-20 00:00:00	2014-08-27	2014-08-27 00:00:00	32020		\N	188407	0	444814009	40481087		0
47945	2845	78272	1961-03-24	1961-03-24 00:00:00	1961-04-14	1961-04-14 00:00:00	32020		\N	188981	0	70704007	78272		0
58733	3483	4112343	2017-09-03	2017-09-03 00:00:00	2017-09-14	2017-09-14 00:00:00	32020		\N	231045	0	195662009	4112343		0
48247	2860	4112343	1977-03-21	1977-03-21 00:00:00	1977-03-29	1977-03-29 00:00:00	32020		\N	190151	0	195662009	4112343		0
48404	2866	80180	2005-10-21	2005-10-21 00:00:00	\N	\N	32020		\N	190665	0	396275006	80180		0
59227	3513	4112343	2010-08-20	2010-08-20 00:00:00	2010-09-01	2010-09-01 00:00:00	32020		\N	233158	0	195662009	4112343		0
69923	4137	40481087	1972-08-07	1972-08-07 00:00:00	1972-08-28	1972-08-28 00:00:00	32020		\N	275048	0	444814009	40481087		0
48960	2897	28060	1967-07-29	1967-07-29 00:00:00	1967-08-05	1967-08-05 00:00:00	32020		\N	192963	0	43878008	28060		0
59681	3536	4116491	2006-10-27	2006-10-27 00:00:00	2006-12-12	2006-12-12 00:00:00	32020		\N	234851	0	301011002	4116491		0
59866	3547	372328	1973-12-13	1973-12-13 00:00:00	1974-06-17	1974-06-17 00:00:00	32020		\N	235581	0	65363002	372328		0
60020	3556	257012	1984-04-26	1984-04-26 00:00:00	\N	\N	32020		\N	236119	0	40055000	257012		0
60139	3561	4285898	1943-10-10	1943-10-10 00:00:00	\N	\N	32020		\N	236507	0	68496003	4285898		0
60309	3569	381316	1987-07-14	1987-07-14 00:00:00	\N	\N	32020		\N	237140	0	230690007	381316		0
49913	2950	40481087	1944-09-04	1944-09-04 00:00:00	1944-09-18	1944-09-18 00:00:00	32020		\N	196960	0	444814009	40481087		0
60638	3589	4094814	1983-11-14	1983-11-14 00:00:00	1984-01-13	1984-01-13 00:00:00	32020		\N	238447	0	262574004	4094814		0
50256	2970	80180	2004-11-27	2004-11-27 00:00:00	\N	\N	32020		\N	198353	0	396275006	80180		0
61003	3610	40481087	2009-10-25	2009-10-25 00:00:00	2009-11-15	2009-11-15 00:00:00	32020		\N	239831	0	444814009	40481087		0
61095	3615	4112343	2017-05-09	2017-05-09 00:00:00	2017-05-20	2017-05-20 00:00:00	32020		\N	240172	0	195662009	4112343		0
61266	3623	40481087	2009-04-04	2009-04-04 00:00:00	2009-04-11	2009-04-11 00:00:00	32020		\N	240870	0	444814009	40481087		0
61428	3629	80180	2000-07-27	2000-07-27 00:00:00	\N	\N	32020		\N	241452	0	396275006	80180		0
51062	3023	372328	1985-11-02	1985-11-02 00:00:00	1986-10-04	1986-10-04 00:00:00	32020		\N	201537	0	65363002	372328		0
61866	3652	81151	1992-06-01	1992-06-01 00:00:00	1992-06-15	1992-06-15 00:00:00	32020		\N	243112	0	44465007	81151		0
62000	3660	40481087	1979-10-21	1979-10-21 00:00:00	1979-11-04	1979-11-04 00:00:00	32020		\N	243562	0	444814009	40481087		0
62098	3667	40481087	2000-11-11	2000-11-11 00:00:00	2000-12-02	2000-12-02 00:00:00	32020		\N	243955	0	444814009	40481087		0
72878	4330	372328	1948-04-18	1948-04-18 00:00:00	1948-05-29	1948-05-29 00:00:00	32020		\N	287242	0	65363002	372328		0
62466	3691	40481087	1971-06-15	1971-06-15 00:00:00	1971-06-22	1971-06-22 00:00:00	32020		\N	245341	0	444814009	40481087		0
62585	3697	4094814	2002-08-21	2002-08-21 00:00:00	2002-10-20	2002-10-20 00:00:00	32020		\N	245774	0	262574004	4094814		0
62790	3708	4112343	2007-01-27	2007-01-27 00:00:00	2007-02-06	2007-02-06 00:00:00	32020		\N	246527	0	195662009	4112343		0
52430	3106	260139	2012-12-28	2012-12-28 00:00:00	2013-01-11	2013-01-11 00:00:00	32020		\N	206602	0	10509002	260139		0
63231	3734	40481087	1954-06-25	1954-06-25 00:00:00	1954-07-09	1954-07-09 00:00:00	32020		\N	248149	0	444814009	40481087		0
63373	3744	81893	2003-08-17	2003-08-17 00:00:00	\N	\N	32020		\N	248796	0	64766004	81893		0
63513	3750	4112343	1990-10-05	1990-10-05 00:00:00	1990-10-13	1990-10-13 00:00:00	32020		\N	249246	0	195662009	4112343		0
63708	3761	4035415	1994-08-28	1994-08-28 00:00:00	1994-10-27	1994-10-27 00:00:00	32020		\N	250043	0	239720000	4035415		0
53151	3147	28060	1948-07-05	1948-07-05 00:00:00	1948-07-12	1948-07-12 00:00:00	32020		\N	209413	0	43878008	28060		0
53441	3167	4155034	1996-01-03	1996-01-03 00:00:00	1996-01-24	1996-01-24 00:00:00	32020		\N	210551	0	283371005	4155034		0
53554	3174	80180	2014-12-19	2014-12-19 00:00:00	\N	\N	32020		\N	210943	0	396275006	80180		0
53651	3177	4152936	1959-04-24	1959-04-24 00:00:00	1959-05-15	1959-05-15 00:00:00	32020		\N	211229	0	283385000	4152936		0
43287	2578	40481087	2018-01-14	2018-01-14 00:00:00	2018-01-21	2018-01-21 00:00:00	32020		\N	170717	0	444814009	40481087		0
54028	3199	440448	2006-01-25	2006-01-25 00:00:00	\N	\N	32020		\N	212771	0	74400008	440448		0
43614	2597	40481087	1997-06-24	1997-06-24 00:00:00	1997-07-08	1997-07-08 00:00:00	32020		\N	171882	0	444814009	40481087		0
54314	3217	28060	1997-04-18	1997-04-18 00:00:00	1997-04-27	1997-04-27 00:00:00	32020		\N	213765	0	43878008	28060		0
43977	2617	40481087	1973-07-26	1973-07-26 00:00:00	1973-08-09	1973-08-09 00:00:00	32020		\N	173028	0	444814009	40481087		0
54653	3236	28060	1942-03-14	1942-03-14 00:00:00	1942-03-23	1942-03-23 00:00:00	32020		\N	215089	0	43878008	28060		0
54817	3244	4112343	2001-05-05	2001-05-05 00:00:00	2001-05-12	2001-05-12 00:00:00	32020		\N	215714	0	195662009	4112343		0
55055	3259	78272	1966-08-25	1966-08-25 00:00:00	1966-09-22	1966-09-22 00:00:00	32020		\N	216695	0	70704007	78272		0
65739	3887	40481087	1990-06-18	1990-06-18 00:00:00	1990-07-09	1990-07-09 00:00:00	32020		\N	258342	0	444814009	40481087		0
55327	3278	4112343	2017-07-02	2017-07-02 00:00:00	2017-07-09	2017-07-09 00:00:00	32020		\N	217785	0	195662009	4112343		0
55485	3287	40481087	1950-02-14	1950-02-14 00:00:00	1950-02-21	1950-02-21 00:00:00	32020		\N	218308	0	444814009	40481087		0
55678	3295	260139	1944-06-01	1944-06-01 00:00:00	1944-06-08	1944-06-08 00:00:00	32020		\N	218872	0	10509002	260139		0
45276	2692	40481087	1967-06-15	1967-06-15 00:00:00	1967-07-06	1967-07-06 00:00:00	32020		\N	178351	0	444814009	40481087		0
56075	3320	40481087	1985-02-06	1985-02-06 00:00:00	1985-02-13	1985-02-13 00:00:00	32020		\N	220444	0	444814009	40481087		0
56196	3330	4310024	2016-01-25	2016-01-25 00:00:00	\N	\N	32020		\N	220981	0	424802006	4310024		0
56349	3342	4294548	2002-06-18	2002-06-18 00:00:00	2002-08-06	2002-08-06 00:00:00	32020		\N	221636	0	75498004	4294548		0
56494	3352	30753	2002-05-07	2002-05-07 00:00:00	\N	\N	32020		\N	222304	0	16761005	30753		0
56751	3365	372328	2005-08-11	2005-08-11 00:00:00	2006-05-26	2006-05-26 00:00:00	32020		\N	223157	0	65363002	372328		0
56826	3371	372328	1979-04-15	1979-04-15 00:00:00	1979-07-20	1979-07-20 00:00:00	32020		\N	223651	0	65363002	372328		0
46480	2768	28060	2009-10-30	2009-10-30 00:00:00	2009-11-11	2009-11-11 00:00:00	32020		\N	183124	0	43878008	28060		0
46608	2774	372328	1941-01-16	1941-01-16 00:00:00	1941-02-28	1941-02-28 00:00:00	32020		\N	183681	0	65363002	372328		0
57310	3401	28060	2007-05-13	2007-05-13 00:00:00	2007-05-21	2007-05-21 00:00:00	32020		\N	225597	0	43878008	28060		0
57470	3410	4116491	1995-04-08	1995-04-08 00:00:00	1995-05-29	1995-05-29 00:00:00	32020		\N	226197	0	301011002	4116491		0
57669	3420	40481087	2002-08-14	2002-08-14 00:00:00	2002-08-21	2002-08-21 00:00:00	32020		\N	226888	0	444814009	40481087		0
57824	3431	4112343	1968-09-23	1968-09-23 00:00:00	1968-10-01	1968-10-01 00:00:00	32020		\N	227447	0	195662009	4112343		0
57974	3437	4109685	1936-03-20	1936-03-20 00:00:00	1936-04-03	1936-04-03 00:00:00	32020		\N	227923	0	284551006	4109685		0
58126	3443	4027663	2003-03-02	2003-03-02 00:00:00	\N	\N	32020		\N	228461	0	13200003	4027663		0
47753	2836	40481087	2012-02-17	2012-02-17 00:00:00	2012-02-24	2012-02-24 00:00:00	32020		\N	188357	0	444814009	40481087		0
47946	2845	4112343	2015-04-24	2015-04-24 00:00:00	2015-05-07	2015-05-07 00:00:00	32020		\N	188961	0	195662009	4112343		0
58734	3483	40481087	1985-06-27	1985-06-27 00:00:00	1985-07-18	1985-07-18 00:00:00	32020		\N	231112	0	444814009	40481087		0
48248	2860	4059173	1945-05-29	1945-05-29 00:00:00	1945-08-27	1945-08-27 00:00:00	32020		\N	190129	0	16114001	4059173		0
48405	2866	4285898	2005-09-21	2005-09-21 00:00:00	\N	\N	32020		\N	190665	0	68496003	4285898		0
59228	3513	195588	2008-03-10	2008-03-10 00:00:00	2008-04-23	2008-04-23 00:00:00	32020		\N	233131	0	38822007	195588		0
69924	4137	40481087	1999-03-27	1999-03-27 00:00:00	1999-04-17	1999-04-17 00:00:00	32020		\N	274983	0	444814009	40481087		0
48961	2897	4218389	1979-03-16	1979-03-16 00:00:00	1979-04-20	1979-04-20 00:00:00	32020		\N	192942	0	39848009	4218389		0
59682	3536	4112343	1975-09-29	1975-09-29 00:00:00	1975-10-11	1975-10-11 00:00:00	32020		\N	234827	0	195662009	4112343		0
59867	3547	40481087	1994-05-29	1994-05-29 00:00:00	1994-06-12	1994-06-12 00:00:00	32020		\N	235549	0	444814009	40481087		0
60021	3556	40481087	1995-07-14	1995-07-14 00:00:00	1995-07-28	1995-07-28 00:00:00	32020		\N	236147	0	444814009	40481087		0
60140	3561	40481087	1943-07-20	1943-07-20 00:00:00	1943-08-10	1943-08-10 00:00:00	32020		\N	236507	0	444814009	40481087		0
60310	3569	260139	1995-06-02	1995-06-02 00:00:00	1995-06-16	1995-06-16 00:00:00	32020		\N	237160	0	10509002	260139		0
49914	2950	4237458	2014-02-11	2014-02-11 00:00:00	2014-04-12	2014-04-12 00:00:00	32020		\N	196943	0	58150001	4237458		0
60639	3589	260139	2007-03-16	2007-03-16 00:00:00	2007-03-30	2007-03-30 00:00:00	32020		\N	238459	0	10509002	260139		0
50257	2970	4285898	2004-10-28	2004-10-28 00:00:00	\N	\N	32020		\N	198353	0	68496003	4285898		0
61014	3612	4116491	2008-05-12	2008-05-12 00:00:00	2008-07-11	2008-07-11 00:00:00	32020		\N	239987	0	301011002	4116491		0
61096	3615	4116491	1982-08-23	1982-08-23 00:00:00	1982-10-14	1982-10-14 00:00:00	32020		\N	240202	0	301011002	4116491		0
61267	3623	4112343	2012-04-23	2012-04-23 00:00:00	2012-05-04	2012-05-04 00:00:00	32020		\N	240871	0	195662009	4112343		0
61429	3629	257012	1973-05-31	1973-05-31 00:00:00	\N	\N	32020		\N	241491	0	40055000	257012		0
51064	3025	439777	1988-11-15	1988-11-15 00:00:00	\N	\N	32020		\N	201604	0	271737000	439777		0
61867	3652	372328	1975-10-11	1975-10-11 00:00:00	1976-02-15	1976-02-15 00:00:00	32020		\N	243131	0	65363002	372328		0
62001	3660	81151	1979-03-18	1979-03-18 00:00:00	1979-04-15	1979-04-15 00:00:00	32020		\N	243602	0	44465007	81151		0
62099	3667	4116491	2000-07-02	2000-07-02 00:00:00	2000-08-07	2000-08-07 00:00:00	32020		\N	243985	0	301011002	4116491		0
72879	4330	40481087	1971-07-21	1971-07-21 00:00:00	1971-08-11	1971-08-11 00:00:00	32020		\N	287237	0	444814009	40481087		0
62467	3691	40481087	1987-11-03	1987-11-03 00:00:00	1987-11-24	1987-11-24 00:00:00	32020		\N	245317	0	444814009	40481087		0
62586	3697	4116491	1974-03-18	1974-03-18 00:00:00	1974-05-03	1974-05-03 00:00:00	32020		\N	245770	0	301011002	4116491		0
62791	3708	4112343	2006-08-18	2006-08-18 00:00:00	2006-08-29	2006-08-29 00:00:00	32020		\N	246562	0	195662009	4112343		0
52431	3106	40481087	1996-05-29	1996-05-29 00:00:00	1996-06-05	1996-06-05 00:00:00	32020		\N	206600	0	444814009	40481087		0
63232	3734	40481087	1966-09-28	1966-09-28 00:00:00	1966-10-05	1966-10-05 00:00:00	32020		\N	248175	0	444814009	40481087		0
63374	3744	40481087	1975-10-04	1975-10-04 00:00:00	1975-10-18	1975-10-18 00:00:00	32020		\N	248791	0	444814009	40481087		0
63514	3750	4112343	2010-09-20	2010-09-20 00:00:00	2010-09-30	2010-09-30 00:00:00	32020		\N	249258	0	195662009	4112343		0
63709	3761	40481087	1989-09-14	1989-09-14 00:00:00	1989-09-21	1989-09-21 00:00:00	32020		\N	250074	0	444814009	40481087		0
53152	3147	4283893	2017-04-26	2017-04-26 00:00:00	2017-06-21	2017-06-21 00:00:00	32020		\N	209373	0	36971009	4283893		0
53442	3167	260139	2017-08-25	2017-08-25 00:00:00	2017-09-08	2017-09-08 00:00:00	32020		\N	210579	0	10509002	260139		0
53555	3174	40481087	2012-10-25	2012-10-25 00:00:00	2012-11-15	2012-11-15 00:00:00	32020		\N	210943	0	444814009	40481087		0
53652	3177	4283893	1968-05-21	1968-05-21 00:00:00	1969-01-14	1969-01-14 00:00:00	32020		\N	211269	0	36971009	4283893		0
43288	2578	4218389	2015-06-16	2015-06-16 00:00:00	2015-07-14	2015-07-14 00:00:00	32020		\N	170764	0	39848009	4218389		0
54029	3199	4112343	2015-07-17	2015-07-17 00:00:00	2015-07-30	2015-07-30 00:00:00	32020		\N	212738	0	195662009	4112343		0
43615	2597	40481087	2018-01-18	2018-01-18 00:00:00	2018-02-01	2018-02-01 00:00:00	32020		\N	171865	0	444814009	40481087		0
54315	3217	40481087	2017-02-04	2017-02-04 00:00:00	2017-02-25	2017-02-25 00:00:00	32020		\N	213804	0	444814009	40481087		0
43978	2617	4112343	1995-05-30	1995-05-30 00:00:00	1995-06-09	1995-06-09 00:00:00	32020		\N	173029	0	195662009	4112343		0
54654	3236	4296205	1958-10-29	1958-10-29 00:00:00	1958-11-26	1958-11-26 00:00:00	32020		\N	215027	0	403191005	4296205		0
54818	3244	4218389	1997-05-24	1997-05-24 00:00:00	1997-06-28	1997-06-28 00:00:00	32020		\N	215746	0	39848009	4218389		0
55056	3259	260139	1969-12-08	1969-12-08 00:00:00	1969-12-22	1969-12-22 00:00:00	32020		\N	216670	0	10509002	260139		0
65740	3887	40481087	2005-09-12	2005-09-12 00:00:00	2005-09-19	2005-09-19 00:00:00	32020		\N	258344	0	444814009	40481087		0
55328	3278	81893	1992-11-06	1992-11-06 00:00:00	\N	\N	32020		\N	217770	0	64766004	81893		0
55486	3287	378001	1946-05-01	1946-05-01 00:00:00	1946-06-30	1946-06-30 00:00:00	32020		\N	218349	0	62106007	378001		0
55679	3295	4112343	1975-04-20	1975-04-20 00:00:00	1975-04-29	1975-04-29 00:00:00	32020		\N	218884	0	195662009	4112343		0
45277	2692	40481087	1970-08-28	1970-08-28 00:00:00	1970-09-18	1970-09-18 00:00:00	32020		\N	178326	0	444814009	40481087		0
56076	3320	260139	2015-06-30	2015-06-30 00:00:00	2015-07-07	2015-07-07 00:00:00	32020		\N	220447	0	10509002	260139		0
56197	3330	80180	2018-01-14	2018-01-14 00:00:00	\N	\N	32020		\N	221005	0	396275006	80180		0
56350	3342	378001	1935-08-07	1935-08-07 00:00:00	1935-10-06	1935-10-06 00:00:00	32020		\N	221631	0	62106007	378001		0
56495	3352	4285898	2002-08-05	2002-08-05 00:00:00	\N	\N	32020		\N	222304	0	68496003	4285898		0
56752	3365	4112343	2013-03-14	2013-03-14 00:00:00	2013-03-27	2013-03-27 00:00:00	32020		\N	223175	0	195662009	4112343		0
56827	3371	372328	1977-10-17	1977-10-17 00:00:00	1978-01-20	1978-01-20 00:00:00	32020		\N	223634	0	65363002	372328		0
56939	3378	40481087	2017-08-07	2017-08-07 00:00:00	2017-08-14	2017-08-14 00:00:00	32020		\N	224133	0	444814009	40481087		0
46609	2774	4230399	2011-03-27	2011-03-27 00:00:00	2011-04-26	2011-04-26 00:00:00	32020		\N	183692	0	359817006	4230399		0
57311	3401	40481087	1970-03-04	1970-03-04 00:00:00	1970-03-11	1970-03-11 00:00:00	32020		\N	225615	0	444814009	40481087		0
57471	3410	40481087	1979-04-05	1979-04-05 00:00:00	1979-04-26	1979-04-26 00:00:00	32020		\N	226178	0	444814009	40481087		0
57670	3420	28060	1980-01-22	1980-01-22 00:00:00	1980-02-04	1980-02-04 00:00:00	32020		\N	226866	0	43878008	28060		0
57825	3431	40481087	1983-06-18	1983-06-18 00:00:00	1983-07-02	1983-07-02 00:00:00	32020		\N	227415	0	444814009	40481087		0
57975	3437	192671	1955-04-23	1955-04-23 00:00:00	\N	\N	32020		\N	227967	0	K92.2	35208414		0
58127	3443	40481087	1979-02-01	1979-02-01 00:00:00	1979-02-15	1979-02-15 00:00:00	32020		\N	228508	0	444814009	40481087		0
47754	2836	440086	1993-08-29	1993-08-29 00:00:00	1998-09-07	1998-09-07 00:00:00	32020		\N	188397	0	192127007	440086		0
47947	2845	4112343	2009-05-13	2009-05-13 00:00:00	2009-05-23	2009-05-23 00:00:00	32020		\N	188959	0	195662009	4112343		0
58735	3483	40481087	1972-06-13	1972-06-13 00:00:00	1972-07-04	1972-07-04 00:00:00	32020		\N	231023	0	444814009	40481087		0
48249	2860	372328	1955-09-25	1955-09-25 00:00:00	1955-12-02	1955-12-02 00:00:00	32020		\N	190161	0	65363002	372328		0
48406	2866	81893	2004-11-25	2004-11-25 00:00:00	\N	\N	32020		\N	190677	0	64766004	81893		0
59229	3513	40481087	1985-10-12	1985-10-12 00:00:00	1985-10-19	1985-10-19 00:00:00	32020		\N	233104	0	444814009	40481087		0
69925	4137	260139	2013-08-05	2013-08-05 00:00:00	2013-08-19	2013-08-19 00:00:00	32020		\N	275020	0	10509002	260139		0
48962	2897	260139	1974-06-22	1974-06-22 00:00:00	1974-06-29	1974-06-29 00:00:00	32020		\N	192937	0	10509002	260139		0
59683	3536	260139	1990-11-16	1990-11-16 00:00:00	1990-11-30	1990-11-30 00:00:00	32020		\N	234842	0	10509002	260139		0
59868	3547	40481087	1986-05-25	1986-05-25 00:00:00	1986-06-01	1986-06-01 00:00:00	32020		\N	235568	0	444814009	40481087		0
60022	3556	4156265	2002-01-03	2002-01-03 00:00:00	2002-01-17	2002-01-17 00:00:00	32020		\N	236130	0	370247008	4156265		0
60141	3561	260139	1977-07-15	1977-07-15 00:00:00	1977-07-22	1977-07-22 00:00:00	32020		\N	236487	0	10509002	260139		0
60311	3569	40481087	1982-10-12	1982-10-12 00:00:00	1982-10-26	1982-10-26 00:00:00	32020		\N	237129	0	444814009	40481087		0
49915	2950	378001	2003-05-05	2003-05-05 00:00:00	2003-07-04	2003-07-04 00:00:00	32020		\N	196941	0	62106007	378001		0
60640	3589	40481087	2016-01-30	2016-01-30 00:00:00	2016-02-20	2016-02-20 00:00:00	32020		\N	238446	0	444814009	40481087		0
50258	2970	28060	2017-05-23	2017-05-23 00:00:00	2017-05-30	2017-05-30 00:00:00	32020		\N	198390	0	43878008	28060		0
61015	3612	4218389	1993-01-25	1993-01-25 00:00:00	1993-02-22	1993-02-22 00:00:00	32020		\N	240001	0	39848009	4218389		0
61097	3615	4112343	1960-10-16	1960-10-16 00:00:00	1960-10-25	1960-10-25 00:00:00	32020		\N	240211	0	195662009	4112343		0
61268	3623	28060	1956-06-27	1956-06-27 00:00:00	1956-07-10	1956-07-10 00:00:00	32020		\N	240887	0	43878008	28060		0
61430	3629	260139	2014-03-24	2014-03-24 00:00:00	2014-03-31	2014-03-31 00:00:00	32020		\N	241459	0	10509002	260139		0
51065	3025	4294548	1986-11-01	1986-11-01 00:00:00	1986-12-27	1986-12-27 00:00:00	32020		\N	201603	0	75498004	4294548		0
61868	3652	4112343	2018-01-28	2018-01-28 00:00:00	2018-02-08	2018-02-08 00:00:00	32020		\N	243124	0	195662009	4112343		0
62002	3660	260139	2003-03-14	2003-03-14 00:00:00	2003-03-21	2003-03-21 00:00:00	32020		\N	243596	0	10509002	260139		0
62100	3667	4294548	1972-03-11	1972-03-11 00:00:00	1972-06-10	1972-06-10 00:00:00	32020		\N	243980	0	75498004	4294548		0
72880	4330	4155034	1995-12-31	1995-12-31 00:00:00	1996-01-14	1996-01-14 00:00:00	32020		\N	287263	0	283371005	4155034		0
62468	3691	4112343	2000-02-13	2000-02-13 00:00:00	2000-02-26	2000-02-26 00:00:00	32020		\N	245319	0	195662009	4112343		0
62587	3697	81151	2017-01-09	2017-01-09 00:00:00	2017-02-13	2017-02-13 00:00:00	32020		\N	245777	0	44465007	81151		0
62792	3708	40486433	1981-05-19	1981-05-19 00:00:00	\N	\N	32020		\N	246500	0	446096008	40486433		0
52432	3106	260139	1973-05-11	1973-05-11 00:00:00	1973-05-25	1973-05-25 00:00:00	32020		\N	206610	0	10509002	260139		0
63233	3734	28060	1981-04-30	1981-04-30 00:00:00	1981-05-12	1981-05-12 00:00:00	32020		\N	248097	0	43878008	28060		0
63375	3744	372328	1975-07-14	1975-07-14 00:00:00	1976-07-18	1976-07-18 00:00:00	32020		\N	248786	0	65363002	372328		0
63515	3750	4027663	1986-01-16	1986-01-16 00:00:00	\N	\N	32020		\N	249268	0	13200003	4027663		0
63710	3761	4112343	1959-11-14	1959-11-14 00:00:00	1959-11-22	1959-11-22 00:00:00	32020		\N	250065	0	195662009	4112343		0
53153	3147	4112343	1962-05-26	1962-05-26 00:00:00	1962-06-04	1962-06-04 00:00:00	32020		\N	209372	0	195662009	4112343		0
53443	3167	260139	1983-02-11	1983-02-11 00:00:00	1983-02-25	1983-02-25 00:00:00	32020		\N	210593	0	10509002	260139		0
53556	3174	4218389	2000-01-02	2000-01-02 00:00:00	2000-02-06	2000-02-06 00:00:00	32020		\N	210955	0	39848009	4218389		0
53653	3177	192671	1950-07-05	1950-07-05 00:00:00	\N	\N	32020		\N	211352	0	K92.2	35208414		0
43289	2578	4112343	1990-08-14	1990-08-14 00:00:00	1990-08-26	1990-08-26 00:00:00	32020		\N	170716	0	195662009	4112343		0
54030	3199	4112343	1976-03-17	1976-03-17 00:00:00	1976-03-30	1976-03-30 00:00:00	32020		\N	212760	0	195662009	4112343		0
43616	2597	40481087	1990-12-15	1990-12-15 00:00:00	1990-12-22	1990-12-22 00:00:00	32020		\N	171846	0	444814009	40481087		0
54316	3217	4112343	1993-07-27	1993-07-27 00:00:00	1993-08-03	1993-08-03 00:00:00	32020		\N	213790	0	195662009	4112343		0
43979	2617	317576	2014-09-06	2014-09-06 00:00:00	\N	\N	32020		\N	173057	0	53741008	317576		0
54655	3236	4059173	1988-07-26	1988-07-26 00:00:00	1988-10-24	1988-10-24 00:00:00	32020		\N	215029	0	16114001	4059173		0
54819	3244	4112343	1986-01-13	1986-01-13 00:00:00	1986-01-23	1986-01-23 00:00:00	32020		\N	215712	0	195662009	4112343		0
55057	3259	260139	1977-07-15	1977-07-15 00:00:00	1977-07-29	1977-07-29 00:00:00	32020		\N	216684	0	10509002	260139		0
65741	3887	4116491	1977-06-20	1977-06-20 00:00:00	1977-07-23	1977-07-23 00:00:00	32020		\N	258341	0	301011002	4116491		0
55329	3278	4310024	1992-09-07	1992-09-07 00:00:00	\N	\N	32020		\N	217770	0	424802006	4310024		0
55487	3287	192671	1980-07-02	1980-07-02 00:00:00	\N	\N	32020		\N	218313	0	K92.2	35208414		0
55680	3295	40481087	2006-07-31	2006-07-31 00:00:00	2006-08-21	2006-08-21 00:00:00	32020		\N	218974	0	444814009	40481087		0
45278	2692	40481087	1956-02-15	1956-02-15 00:00:00	1956-03-07	1956-03-07 00:00:00	32020		\N	178325	0	444814009	40481087		0
56077	3320	40481087	2016-05-28	2016-05-28 00:00:00	2016-06-11	2016-06-11 00:00:00	32020		\N	220437	0	444814009	40481087		0
56198	3330	81151	2013-03-16	2013-03-16 00:00:00	2013-04-20	2013-04-20 00:00:00	32020		\N	221008	0	44465007	81151		0
56351	3342	40481087	1921-11-30	1921-11-30 00:00:00	1921-12-14	1921-12-14 00:00:00	32020		\N	221573	0	444814009	40481087		0
56496	3352	260139	1998-03-31	1998-03-31 00:00:00	1998-04-14	1998-04-14 00:00:00	32020		\N	222269	0	10509002	260139		0
56753	3365	4113008	2017-02-14	2017-02-14 00:00:00	2017-03-07	2017-03-07 00:00:00	32020		\N	223179	0	284549007	4113008		0
56828	3371	40481087	1977-12-25	1977-12-25 00:00:00	1978-01-15	1978-01-15 00:00:00	32020		\N	223599	0	444814009	40481087		0
56940	3378	80180	1994-12-03	1994-12-03 00:00:00	\N	\N	32020		\N	224200	0	396275006	80180		0
46610	2774	28060	1978-08-28	1978-08-28 00:00:00	1978-09-08	1978-09-08 00:00:00	32020		\N	183726	0	43878008	28060		0
57312	3401	4112343	1971-03-19	1971-03-19 00:00:00	1971-03-28	1971-03-28 00:00:00	32020		\N	225601	0	195662009	4112343		0
57472	3410	260139	2018-03-14	2018-03-14 00:00:00	2018-03-21	2018-03-21 00:00:00	32020		\N	226179	0	10509002	260139		0
57671	3420	260139	2005-10-20	2005-10-20 00:00:00	2005-10-27	2005-10-27 00:00:00	32020		\N	226890	0	10509002	260139		0
57826	3431	4051466	1964-10-16	1964-10-16 00:00:00	1982-01-19	1982-01-19 00:00:00	32020		\N	227454	0	233678006	4051466		0
57976	3437	40481087	1917-11-23	1917-11-23 00:00:00	1917-12-07	1917-12-07 00:00:00	32020		\N	227981	0	444814009	40481087		0
58128	3443	260139	1981-09-16	1981-09-16 00:00:00	1981-09-23	1981-09-23 00:00:00	32020		\N	228480	0	10509002	260139		0
47755	2836	4294548	1995-08-19	1995-08-19 00:00:00	1995-10-28	1995-10-28 00:00:00	32020		\N	188398	0	75498004	4294548		0
47948	2846	4156265	1990-04-20	1990-04-20 00:00:00	1990-05-04	1990-05-04 00:00:00	32020		\N	188991	0	370247008	4156265		0
58736	3483	81151	2018-07-22	2018-07-22 00:00:00	2018-08-26	2018-08-26 00:00:00	32020		\N	231120	0	44465007	81151		0
48250	2860	40481087	1972-10-16	1972-10-16 00:00:00	1972-10-30	1972-10-30 00:00:00	32020		\N	190136	0	444814009	40481087		0
48407	2866	40481087	1976-11-18	1976-11-18 00:00:00	1976-12-09	1976-12-09 00:00:00	32020		\N	190673	0	444814009	40481087		0
59230	3513	4112343	1979-04-24	1979-04-24 00:00:00	1979-05-06	1979-05-06 00:00:00	32020		\N	233128	0	195662009	4112343		0
69926	4137	261325	2012-02-01	2012-02-01 00:00:00	\N	\N	32020		\N	275026	0	87433001	261325		0
48963	2897	4310024	2000-11-21	2000-11-21 00:00:00	\N	\N	32020		\N	192923	0	424802006	4310024		0
59684	3536	40481087	2016-02-20	2016-02-20 00:00:00	2016-03-12	2016-03-12 00:00:00	32020		\N	234857	0	444814009	40481087		0
59869	3547	372328	1976-02-07	1976-02-07 00:00:00	1976-06-28	1976-06-28 00:00:00	32020		\N	235571	0	65363002	372328		0
60023	3556	4112343	2017-01-27	2017-01-27 00:00:00	2017-02-03	2017-02-03 00:00:00	32020		\N	236149	0	195662009	4112343		0
60142	3561	257012	1911-12-12	1911-12-12 00:00:00	\N	\N	32020		\N	236415	0	40055000	257012		0
60312	3569	80502	2018-12-11	2018-12-11 00:00:00	\N	\N	32020		\N	237138	0	64859006	80502		0
49916	2950	4112343	1948-11-15	1948-11-15 00:00:00	1948-11-23	1948-11-23 00:00:00	32020		\N	196882	0	195662009	4112343		0
60641	3589	80180	2016-11-06	2016-11-06 00:00:00	\N	\N	32020		\N	238446	0	396275006	80180		0
50259	2970	40481087	2008-11-25	2008-11-25 00:00:00	2008-12-02	2008-12-02 00:00:00	32020		\N	198387	0	444814009	40481087		0
61016	3612	40481087	2018-01-08	2018-01-08 00:00:00	2018-01-29	2018-01-29 00:00:00	32020		\N	239988	0	444814009	40481087		0
61098	3615	4294548	2016-08-19	2016-08-19 00:00:00	2016-10-14	2016-10-14 00:00:00	32020		\N	240204	0	75498004	4294548		0
61269	3623	440448	2009-06-05	2009-06-05 00:00:00	\N	\N	32020		\N	240937	0	74400008	440448		0
61431	3629	4294548	1986-11-09	1986-11-09 00:00:00	1986-12-07	1986-12-07 00:00:00	32020		\N	241457	0	75498004	4294548		0
51066	3025	378001	1976-04-08	1976-04-08 00:00:00	1976-05-08	1976-05-08 00:00:00	32020		\N	201584	0	62106007	378001		0
61876	3654	260139	1985-04-06	1985-04-06 00:00:00	1985-04-20	1985-04-20 00:00:00	32020		\N	243201	0	10509002	260139		0
62003	3660	4109685	1999-12-22	1999-12-22 00:00:00	2000-01-12	2000-01-12 00:00:00	32020		\N	243607	0	284551006	4109685		0
62101	3667	257012	1972-06-03	1972-06-03 00:00:00	\N	\N	32020		\N	243981	0	40055000	257012		0
72881	4330	260139	1964-03-30	1964-03-30 00:00:00	1964-04-07	1964-04-07 00:00:00	32020		\N	287224	0	10509002	260139		0
62469	3691	4134304	2011-06-23	2011-06-23 00:00:00	2011-09-21	2011-09-21 00:00:00	32020		\N	245331	0	263102004	4134304		0
62588	3697	4027663	1985-03-15	1985-03-15 00:00:00	\N	\N	32020		\N	245793	0	13200003	4027663		0
62793	3708	4112343	1983-04-16	1983-04-16 00:00:00	1983-04-26	1983-04-26 00:00:00	32020		\N	246502	0	195662009	4112343		0
52433	3106	192671	1990-05-10	1990-05-10 00:00:00	\N	\N	32020		\N	206555	0	K92.2	35208414		0
63234	3734	40481087	2011-11-27	2011-11-27 00:00:00	2011-12-04	2011-12-04 00:00:00	32020		\N	248112	0	444814009	40481087		0
63376	3744	4112343	1998-01-14	1998-01-14 00:00:00	1998-01-22	1998-01-22 00:00:00	32020		\N	248748	0	195662009	4112343		0
63521	3752	4296204	1963-07-14	1963-07-14 00:00:00	1963-07-28	1963-07-28 00:00:00	32020		\N	249364	0	403190006	4296204		0
63711	3761	260139	1987-05-29	1987-05-29 00:00:00	1987-06-12	1987-06-12 00:00:00	32020		\N	250063	0	10509002	260139		0
53154	3147	40481087	1978-02-21	1978-02-21 00:00:00	1978-03-14	1978-03-14 00:00:00	32020		\N	209394	0	444814009	40481087		0
53444	3167	260139	1990-11-06	1990-11-06 00:00:00	1990-11-13	1990-11-13 00:00:00	32020		\N	210533	0	10509002	260139		0
53557	3174	4112343	2001-10-18	2001-10-18 00:00:00	2001-10-30	2001-10-30 00:00:00	32020		\N	210978	0	195662009	4112343		0
53654	3177	260139	1980-02-21	1980-02-21 00:00:00	1980-02-28	1980-02-28 00:00:00	32020		\N	211311	0	10509002	260139		0
43290	2578	40481087	1996-11-13	1996-11-13 00:00:00	1996-12-04	1996-12-04 00:00:00	32020		\N	170736	0	444814009	40481087		0
54031	3199	4166224	2006-01-25	2006-01-25 00:00:00	\N	\N	32020		\N	212771	0	47693006	4166224		0
43617	2597	81151	1999-06-07	1999-06-07 00:00:00	1999-06-28	1999-06-28 00:00:00	32020		\N	171859	0	44465007	81151		0
54317	3218	40481087	2004-12-12	2004-12-12 00:00:00	2005-01-02	2005-01-02 00:00:00	32020		\N	213825	0	444814009	40481087		0
43980	2617	260139	2001-01-23	2001-01-23 00:00:00	2001-02-06	2001-02-06 00:00:00	32020		\N	173082	0	10509002	260139		0
54656	3236	4112343	1931-08-25	1931-08-25 00:00:00	1931-09-07	1931-09-07 00:00:00	32020		\N	215059	0	195662009	4112343		0
54820	3244	260139	1996-09-10	1996-09-10 00:00:00	1996-09-17	1996-09-17 00:00:00	32020		\N	215701	0	10509002	260139		0
55058	3259	372328	1966-12-23	1966-12-23 00:00:00	1967-01-06	1967-01-06 00:00:00	32020		\N	216687	0	65363002	372328		0
65742	3887	4112343	1977-04-02	1977-04-02 00:00:00	1977-04-13	1977-04-13 00:00:00	32020		\N	258367	0	195662009	4112343		0
55330	3278	80180	1994-01-30	1994-01-30 00:00:00	\N	\N	32020		\N	217770	0	396275006	80180		0
55488	3287	4294548	2012-05-24	2012-05-24 00:00:00	2012-06-14	2012-06-14 00:00:00	32020		\N	218368	0	75498004	4294548		0
55681	3295	4278672	1952-01-19	1952-01-19 00:00:00	1952-02-18	1952-02-18 00:00:00	32020		\N	218894	0	65966004	4278672		0
45279	2692	4329847	1998-06-29	1998-06-29 00:00:00	\N	\N	32020		\N	178364	0	22298006	4329847		0
56078	3320	28060	1977-04-23	1977-04-23 00:00:00	1977-05-04	1977-05-04 00:00:00	32020		\N	220485	0	43878008	28060		0
56199	3330	40481087	1994-08-27	1994-08-27 00:00:00	1994-09-17	1994-09-17 00:00:00	32020		\N	220982	0	444814009	40481087		0
56352	3342	40481087	1987-06-26	1987-06-26 00:00:00	1987-07-10	1987-07-10 00:00:00	32020		\N	221578	0	444814009	40481087		0
56497	3352	4112343	2012-06-20	2012-06-20 00:00:00	2012-06-27	2012-06-27 00:00:00	32020		\N	222306	0	195662009	4112343		0
56768	3367	4001336	1971-03-22	1971-03-22 00:00:00	1971-05-21	1971-05-21 00:00:00	32020		\N	223278	0	110030002	4001336		0
56829	3371	372328	1979-08-19	1979-08-19 00:00:00	1980-07-25	1980-07-25 00:00:00	32020		\N	223635	0	65363002	372328		0
56941	3378	40481087	1965-04-17	1965-04-17 00:00:00	1965-05-01	1965-05-01 00:00:00	32020		\N	224121	0	444814009	40481087		0
46611	2774	40481087	1972-12-05	1972-12-05 00:00:00	1972-12-19	1972-12-19 00:00:00	32020		\N	183725	0	444814009	40481087		0
57313	3401	40481087	1999-02-12	1999-02-12 00:00:00	1999-03-05	1999-03-05 00:00:00	32020		\N	225603	0	444814009	40481087		0
57473	3410	372328	1964-08-13	1964-08-13 00:00:00	1964-09-23	1964-09-23 00:00:00	32020		\N	226210	0	65363002	372328		0
57672	3420	4112343	1998-12-27	1998-12-27 00:00:00	1999-01-08	1999-01-08 00:00:00	32020		\N	226873	0	195662009	4112343		0
57827	3431	28060	1971-11-19	1971-11-19 00:00:00	1971-12-02	1971-12-02 00:00:00	32020		\N	227457	0	43878008	28060		0
57977	3437	4218389	1938-03-24	1938-03-24 00:00:00	1938-04-28	1938-04-28 00:00:00	32020		\N	227924	0	39848009	4218389		0
58129	3443	40481087	2006-03-29	2006-03-29 00:00:00	2006-04-13	2006-04-13 00:00:00	32020		\N	228484	0	444814009	40481087		0
47756	2836	192671	2019-03-21	2019-03-21 00:00:00	\N	\N	32020		\N	188371	0	K92.2	35208414		0
47949	2846	4230399	1982-04-18	1982-04-18 00:00:00	1982-05-18	1982-05-18 00:00:00	32020		\N	188989	0	359817006	4230399		0
58737	3483	260139	2015-06-04	2015-06-04 00:00:00	2015-06-18	2015-06-18 00:00:00	32020		\N	231043	0	10509002	260139		0
48251	2860	40481087	1952-10-28	1952-10-28 00:00:00	1952-11-04	1952-11-04 00:00:00	32020		\N	190149	0	444814009	40481087		0
48408	2866	192671	2006-01-05	2006-01-05 00:00:00	\N	\N	32020		\N	190672	0	K92.2	35208414		0
59231	3513	4266809	2007-12-01	2007-12-01 00:00:00	\N	\N	32020		\N	233119	0	397881000	4266809		0
69927	4137	372328	1963-01-15	1963-01-15 00:00:00	1963-07-03	1963-07-03 00:00:00	32020		\N	274995	0	65363002	372328		0
48964	2897	4112343	2001-12-06	2001-12-06 00:00:00	2001-12-17	2001-12-17 00:00:00	32020		\N	192926	0	195662009	4112343		0
59685	3537	257012	2015-04-13	2015-04-13 00:00:00	\N	\N	32020		\N	234898	0	40055000	257012		0
59870	3547	257012	1981-08-18	1981-08-18 00:00:00	\N	\N	32020		\N	235567	0	40055000	257012		0
60024	3556	4156265	2000-01-23	2000-01-23 00:00:00	2000-02-13	2000-02-13 00:00:00	32020		\N	236129	0	370247008	4156265		0
60143	3561	4027663	1936-01-25	1936-01-25 00:00:00	\N	\N	32020		\N	236454	0	13200003	4027663		0
60313	3569	40481087	1967-07-11	1967-07-11 00:00:00	1967-07-25	1967-07-25 00:00:00	32020		\N	237127	0	444814009	40481087		0
49917	2950	4134304	1982-04-15	1982-04-15 00:00:00	1982-06-14	1982-06-14 00:00:00	32020		\N	196937	0	263102004	4134304		0
60642	3589	4112343	1991-06-25	1991-06-25 00:00:00	1991-07-08	1991-07-08 00:00:00	32020		\N	238399	0	195662009	4112343		0
50260	2970	40481087	2005-07-31	2005-07-31 00:00:00	2005-08-07	2005-08-07 00:00:00	32020		\N	198292	0	444814009	40481087		0
61017	3612	40481087	1961-09-16	1961-09-16 00:00:00	1961-09-23	1961-09-23 00:00:00	32020		\N	239954	0	444814009	40481087		0
61099	3615	4152936	2006-10-06	2006-10-06 00:00:00	2006-10-27	2006-10-27 00:00:00	32020		\N	240219	0	283385000	4152936		0
61270	3623	40481087	1989-07-20	1989-07-20 00:00:00	1989-07-27	1989-07-27 00:00:00	32020		\N	240924	0	444814009	40481087		0
61432	3629	4112343	1989-01-26	1989-01-26 00:00:00	1989-02-04	1989-02-04 00:00:00	32020		\N	241492	0	195662009	4112343		0
51067	3025	4283893	1969-12-22	1969-12-22 00:00:00	1970-06-01	1970-06-01 00:00:00	32020		\N	201686	0	36971009	4283893		0
61877	3654	28060	1983-02-13	1983-02-13 00:00:00	1983-02-25	1983-02-25 00:00:00	32020		\N	243240	0	43878008	28060		0
62004	3660	78272	1997-03-23	1997-03-23 00:00:00	1997-04-06	1997-04-06 00:00:00	32020		\N	243606	0	70704007	78272		0
62102	3667	40481087	1976-11-24	1976-11-24 00:00:00	1976-12-01	1976-12-01 00:00:00	32020		\N	243982	0	444814009	40481087		0
72882	4330	4112343	2004-03-29	2004-03-29 00:00:00	2004-04-07	2004-04-07 00:00:00	32020		\N	287214	0	195662009	4112343		0
62470	3691	4112343	1990-05-08	1990-05-08 00:00:00	1990-05-17	1990-05-17 00:00:00	32020		\N	245342	0	195662009	4112343		0
62589	3697	81151	2009-07-15	2009-07-15 00:00:00	2009-07-29	2009-07-29 00:00:00	32020		\N	245775	0	44465007	81151		0
62794	3708	40481087	1992-02-09	1992-02-09 00:00:00	1992-02-16	1992-02-16 00:00:00	32020		\N	246519	0	444814009	40481087		0
52434	3106	4112343	2010-05-12	2010-05-12 00:00:00	2010-05-20	2010-05-20 00:00:00	32020		\N	206601	0	195662009	4112343		0
63235	3734	4112343	2019-01-07	2019-01-07 00:00:00	2019-01-16	2019-01-16 00:00:00	32020		\N	248129	0	195662009	4112343		0
63377	3744	4112343	1992-09-30	1992-09-30 00:00:00	1992-10-11	1992-10-11 00:00:00	32020		\N	248792	0	195662009	4112343		0
63522	3752	372328	1959-06-05	1959-06-05 00:00:00	1959-11-19	1959-11-19 00:00:00	32020		\N	249323	0	65363002	372328		0
63712	3761	28060	1957-02-16	1957-02-16 00:00:00	1957-02-24	1957-02-24 00:00:00	32020		\N	250050	0	43878008	28060		0
53170	3149	4134304	2012-11-22	2012-11-22 00:00:00	2012-12-22	2012-12-22 00:00:00	32020		\N	209567	0	263102004	4134304		0
53445	3167	4112343	1973-08-30	1973-08-30 00:00:00	1973-09-07	1973-09-07 00:00:00	32020		\N	210530	0	195662009	4112343		0
53558	3174	4112343	1998-05-25	1998-05-25 00:00:00	1998-06-05	1998-06-05 00:00:00	32020		\N	210956	0	195662009	4112343		0
53655	3177	313217	2012-05-09	2012-05-09 00:00:00	\N	\N	32020		\N	211369	0	49436004	313217		0
43291	2578	40481087	2010-11-28	2010-11-28 00:00:00	2010-12-19	2010-12-19 00:00:00	32020		\N	170737	0	444814009	40481087		0
54032	3199	40481087	2015-12-29	2015-12-29 00:00:00	2016-01-19	2016-01-19 00:00:00	32020		\N	212731	0	444814009	40481087		0
43618	2597	40481087	1999-02-26	1999-02-26 00:00:00	1999-03-12	1999-03-12 00:00:00	32020		\N	171847	0	444814009	40481087		0
54318	3218	40481087	1997-01-19	1997-01-19 00:00:00	1997-02-09	1997-02-09 00:00:00	32020		\N	213836	0	444814009	40481087		0
43981	2617	260139	1969-08-28	1969-08-28 00:00:00	1969-09-04	1969-09-04 00:00:00	32020		\N	173059	0	10509002	260139		0
54657	3236	260139	1948-05-26	1948-05-26 00:00:00	1948-06-09	1948-06-09 00:00:00	32020		\N	215091	0	10509002	260139		0
54821	3244	260139	2007-09-26	2007-09-26 00:00:00	2007-10-03	2007-10-03 00:00:00	32020		\N	215719	0	10509002	260139		0
55059	3259	40481087	1997-02-26	1997-02-26 00:00:00	1997-03-19	1997-03-19 00:00:00	32020		\N	216664	0	444814009	40481087		0
65743	3887	260139	1975-06-22	1975-06-22 00:00:00	1975-06-29	1975-06-29 00:00:00	32020		\N	258340	0	10509002	260139		0
55331	3278	30753	1993-01-05	1993-01-05 00:00:00	\N	\N	32020		\N	217770	0	16761005	30753		0
55489	3287	40481087	1974-09-20	1974-09-20 00:00:00	1974-10-11	1974-10-11 00:00:00	32020		\N	218334	0	444814009	40481087		0
55682	3295	4112343	2003-06-03	2003-06-03 00:00:00	2003-06-11	2003-06-11 00:00:00	32020		\N	218930	0	195662009	4112343		0
45281	2693	40481087	1975-08-29	1975-08-29 00:00:00	1975-09-19	1975-09-19 00:00:00	32020		\N	178402	0	444814009	40481087		0
56079	3321	40481087	1979-06-18	1979-06-18 00:00:00	1979-07-09	1979-07-09 00:00:00	32020		\N	220511	0	444814009	40481087		0
56209	3332	40481087	1969-09-10	1969-09-10 00:00:00	1969-09-24	1969-09-24 00:00:00	32020		\N	221067	0	444814009	40481087		0
56353	3342	313217	2005-03-30	2005-03-30 00:00:00	\N	\N	32020		\N	221627	0	49436004	313217		0
56498	3352	4296205	1984-10-22	1984-10-22 00:00:00	1984-11-12	1984-11-12 00:00:00	32020		\N	222260	0	403191005	4296205		0
56769	3367	260139	2009-10-06	2009-10-06 00:00:00	2009-10-13	2009-10-13 00:00:00	32020		\N	223288	0	10509002	260139		0
56830	3371	4112343	1990-01-17	1990-01-17 00:00:00	1990-01-29	1990-01-29 00:00:00	32020		\N	223615	0	195662009	4112343		0
56942	3378	4112343	1989-02-15	1989-02-15 00:00:00	1989-02-27	1989-02-27 00:00:00	32020		\N	224126	0	195662009	4112343		0
46612	2774	4156265	2016-10-26	2016-10-26 00:00:00	2016-11-16	2016-11-16 00:00:00	32020		\N	183727	0	370247008	4156265		0
57314	3401	80180	1997-08-02	1997-08-02 00:00:00	\N	\N	32020		\N	225632	0	396275006	80180		0
57474	3410	81151	1978-02-06	1978-02-06 00:00:00	1978-03-06	1978-03-06 00:00:00	32020		\N	226175	0	44465007	81151		0
57673	3420	28060	1970-01-02	1970-01-02 00:00:00	1970-01-14	1970-01-14 00:00:00	32020		\N	226843	0	43878008	28060		0
57828	3431	4218389	1981-09-05	1981-09-05 00:00:00	1981-09-26	1981-09-26 00:00:00	32020		\N	227479	0	39848009	4218389		0
57978	3437	372328	1977-05-16	1977-05-16 00:00:00	1978-01-14	1978-01-14 00:00:00	32020		\N	227925	0	65363002	372328		0
58130	3443	260139	1994-05-20	1994-05-20 00:00:00	1994-06-03	1994-06-03 00:00:00	32020		\N	228511	0	10509002	260139		0
47757	2836	81151	1998-09-09	1998-09-09 00:00:00	1998-10-14	1998-10-14 00:00:00	32020		\N	188375	0	44465007	81151		0
47950	2846	81151	1978-03-26	1978-03-26 00:00:00	1978-04-09	1978-04-09 00:00:00	32020		\N	188986	0	44465007	81151		0
58738	3483	40481087	1969-08-24	1969-08-24 00:00:00	1969-08-31	1969-08-31 00:00:00	32020		\N	231060	0	444814009	40481087		0
48252	2860	4112343	1980-02-13	1980-02-13 00:00:00	1980-02-21	1980-02-21 00:00:00	32020		\N	190137	0	195662009	4112343		0
48409	2866	40481087	1987-10-09	1987-10-09 00:00:00	1987-10-30	1987-10-30 00:00:00	32020		\N	190646	0	444814009	40481087		0
59232	3513	80180	2007-12-01	2007-12-01 00:00:00	\N	\N	32020		\N	233119	0	396275006	80180		0
69928	4137	260139	2004-04-01	2004-04-01 00:00:00	2004-04-15	2004-04-15 00:00:00	32020		\N	274984	0	10509002	260139		0
48965	2897	4285898	2003-04-10	2003-04-10 00:00:00	\N	\N	32020		\N	192926	0	68496003	4285898		0
59686	3537	372328	1967-12-21	1967-12-21 00:00:00	1968-06-16	1968-06-16 00:00:00	32020		\N	234956	0	65363002	372328		0
59871	3547	372328	1972-10-30	1972-10-30 00:00:00	1972-12-18	1972-12-18 00:00:00	32020		\N	235586	0	65363002	372328		0
60025	3556	372328	1987-09-28	1987-09-28 00:00:00	1988-07-25	1988-07-25 00:00:00	32020		\N	236144	0	65363002	372328		0
60144	3561	4113008	1998-08-22	1998-08-22 00:00:00	1998-09-12	1998-09-12 00:00:00	32020		\N	236476	0	284549007	4113008		0
60314	3569	260139	1972-07-25	1972-07-25 00:00:00	1972-08-01	1972-08-01 00:00:00	32020		\N	237128	0	10509002	260139		0
49918	2950	40481087	1943-03-15	1943-03-15 00:00:00	1943-04-05	1943-04-05 00:00:00	32020		\N	196954	0	444814009	40481087		0
60643	3589	4084167	1998-03-30	1998-03-30 00:00:00	1998-03-31	1998-03-31 00:00:00	32020		\N	238448	0	241929008	4084167		0
50261	2970	40481087	1999-12-03	1999-12-03 00:00:00	1999-12-24	1999-12-24 00:00:00	32020		\N	198370	0	444814009	40481087		0
61018	3612	260139	2013-10-20	2013-10-20 00:00:00	2013-11-03	2013-11-03 00:00:00	32020		\N	239958	0	10509002	260139		0
61100	3615	40481087	1974-03-25	1974-03-25 00:00:00	1974-04-08	1974-04-08 00:00:00	32020		\N	240243	0	444814009	40481087		0
61271	3623	40481087	1993-07-15	1993-07-15 00:00:00	1993-07-22	1993-07-22 00:00:00	32020		\N	240886	0	444814009	40481087		0
61433	3629	4112343	1975-08-27	1975-08-27 00:00:00	1975-09-04	1975-09-04 00:00:00	32020		\N	241495	0	195662009	4112343		0
51068	3025	372328	1946-10-22	1946-10-22 00:00:00	1947-02-03	1947-02-03 00:00:00	32020		\N	201644	0	65363002	372328		0
61878	3654	4112343	2016-01-16	2016-01-16 00:00:00	2016-01-27	2016-01-27 00:00:00	32020		\N	243242	0	195662009	4112343		0
62005	3660	260139	2006-06-30	2006-06-30 00:00:00	2006-07-14	2006-07-14 00:00:00	32020		\N	243586	0	10509002	260139		0
62103	3667	4155034	1977-09-28	1977-09-28 00:00:00	1977-10-12	1977-10-12 00:00:00	32020		\N	243977	0	283371005	4155034		0
72883	4330	40481087	1959-07-22	1959-07-22 00:00:00	1959-07-29	1959-07-29 00:00:00	32020		\N	287268	0	444814009	40481087		0
62471	3691	80180	1991-01-16	1991-01-16 00:00:00	\N	\N	32020		\N	245342	0	396275006	80180		0
62590	3697	372328	1982-07-26	1982-07-26 00:00:00	1982-09-25	1982-09-25 00:00:00	32020		\N	245755	0	65363002	372328		0
62795	3708	40481087	2007-03-05	2007-03-05 00:00:00	2007-03-19	2007-03-19 00:00:00	32020		\N	246481	0	444814009	40481087		0
52435	3106	78272	1951-07-05	1951-07-05 00:00:00	1951-08-02	1951-08-02 00:00:00	32020		\N	206615	0	70704007	78272		0
63236	3734	40481087	1991-12-14	1991-12-14 00:00:00	1992-01-04	1992-01-04 00:00:00	32020		\N	248128	0	444814009	40481087		0
63378	3744	372328	1971-05-22	1971-05-22 00:00:00	1971-06-05	1971-06-05 00:00:00	32020		\N	248836	0	65363002	372328		0
63523	3752	4027663	1989-12-04	1989-12-04 00:00:00	\N	\N	32020		\N	249386	0	13200003	4027663		0
63713	3761	40481087	1959-12-08	1959-12-08 00:00:00	1959-12-29	1959-12-29 00:00:00	32020		\N	250052	0	444814009	40481087		0
53171	3149	40481087	1961-02-20	1961-02-20 00:00:00	1961-03-13	1961-03-13 00:00:00	32020		\N	209541	0	444814009	40481087		0
53446	3167	30753	2001-09-18	2001-09-18 00:00:00	\N	\N	32020		\N	210561	0	16761005	30753		0
53559	3174	4294548	1998-10-10	1998-10-10 00:00:00	1998-12-19	1998-12-19 00:00:00	32020		\N	210957	0	75498004	4294548		0
53656	3177	381316	2012-05-30	2012-05-30 00:00:00	\N	\N	32020		\N	211369	0	230690007	381316		0
43292	2578	4112343	1971-01-28	1971-01-28 00:00:00	1971-02-09	1971-02-09 00:00:00	32020		\N	170714	0	195662009	4112343		0
54033	3199	260139	2012-04-14	2012-04-14 00:00:00	2012-04-21	2012-04-21 00:00:00	32020		\N	212736	0	10509002	260139		0
43619	2597	40481087	1999-01-06	1999-01-06 00:00:00	1999-01-20	1999-01-20 00:00:00	32020		\N	171837	0	444814009	40481087		0
54319	3218	192671	1992-11-29	1992-11-29 00:00:00	\N	\N	32020		\N	213847	0	K92.2	35208414		0
43982	2617	372328	1953-12-30	1953-12-30 00:00:00	1954-01-13	1954-01-13 00:00:00	32020		\N	173065	0	65363002	372328		0
54658	3236	40481087	1943-03-31	1943-03-31 00:00:00	1943-04-14	1943-04-14 00:00:00	32020		\N	215090	0	444814009	40481087		0
54822	3244	40481087	1977-03-06	1977-03-06 00:00:00	1977-03-27	1977-03-27 00:00:00	32020		\N	215688	0	444814009	40481087		0
55060	3259	4112343	1981-12-21	1981-12-21 00:00:00	1981-12-31	1981-12-31 00:00:00	32020		\N	216663	0	195662009	4112343		0
65744	3887	4109685	1984-11-14	1984-11-14 00:00:00	1984-11-28	1984-11-28 00:00:00	32020		\N	258404	0	284551006	4109685		0
55332	3278	260139	1988-08-20	1988-08-20 00:00:00	1988-09-03	1988-09-03 00:00:00	32020		\N	217779	0	10509002	260139		0
55490	3287	40481087	1996-12-20	1996-12-20 00:00:00	1997-01-10	1997-01-10 00:00:00	32020		\N	218332	0	444814009	40481087		0
55683	3296	260139	1944-05-17	1944-05-17 00:00:00	1944-05-24	1944-05-24 00:00:00	32020		\N	219062	0	10509002	260139		0
45282	2693	260139	1995-10-15	1995-10-15 00:00:00	1995-10-22	1995-10-22 00:00:00	32020		\N	178428	0	10509002	260139		0
56080	3321	80180	2011-06-30	2011-06-30 00:00:00	\N	\N	32020		\N	220513	0	396275006	80180		0
56210	3332	40481087	2011-09-21	2011-09-21 00:00:00	2011-10-05	2011-10-05 00:00:00	32020		\N	221129	0	444814009	40481087		0
56354	3342	4152936	1923-07-24	1923-07-24 00:00:00	1923-08-14	1923-08-14 00:00:00	32020		\N	221628	0	283385000	4152936		0
56499	3352	80180	2003-07-01	2003-07-01 00:00:00	\N	\N	32020		\N	222270	0	396275006	80180		0
56770	3367	81151	1994-06-17	1994-06-17 00:00:00	1994-07-22	1994-07-22 00:00:00	32020		\N	223281	0	44465007	81151		0
56831	3371	4112343	2006-08-18	2006-08-18 00:00:00	2006-08-26	2006-08-26 00:00:00	32020		\N	223572	0	195662009	4112343		0
56943	3378	4237458	2017-04-20	2017-04-20 00:00:00	2017-05-20	2017-05-20 00:00:00	32020		\N	224120	0	58150001	4237458		0
46613	2774	40481087	2010-11-06	2010-11-06 00:00:00	2010-11-13	2010-11-13 00:00:00	32020		\N	183641	0	444814009	40481087		0
57315	3401	260139	1982-08-02	1982-08-02 00:00:00	1982-08-09	1982-08-09 00:00:00	32020		\N	225616	0	10509002	260139		0
57475	3410	4156265	1965-05-10	1965-05-10 00:00:00	1965-05-31	1965-05-31 00:00:00	32020		\N	226176	0	370247008	4156265		0
57674	3420	80180	1998-11-10	1998-11-10 00:00:00	\N	\N	32020		\N	226868	0	396275006	80180		0
57829	3431	4112343	1993-08-31	1993-08-31 00:00:00	1993-09-10	1993-09-10 00:00:00	32020		\N	227400	0	195662009	4112343		0
57979	3437	4112343	1974-05-13	1974-05-13 00:00:00	1974-05-25	1974-05-25 00:00:00	32020		\N	227941	0	195662009	4112343		0
58131	3443	78272	2018-11-28	2018-11-28 00:00:00	2018-12-26	2018-12-26 00:00:00	32020		\N	228486	0	70704007	78272		0
47758	2836	257012	1995-10-14	1995-10-14 00:00:00	\N	\N	32020		\N	188355	0	40055000	257012		0
47951	2846	372328	1973-07-20	1973-07-20 00:00:00	1973-09-02	1973-09-02 00:00:00	32020		\N	189039	0	65363002	372328		0
58739	3483	40481087	1955-05-19	1955-05-19 00:00:00	1955-06-02	1955-06-02 00:00:00	32020		\N	231012	0	444814009	40481087		0
48253	2860	40481087	1991-05-30	1991-05-30 00:00:00	1991-06-20	1991-06-20 00:00:00	32020		\N	190138	0	444814009	40481087		0
48410	2867	4112343	1989-06-19	1989-06-19 00:00:00	1989-06-28	1989-06-28 00:00:00	32020		\N	190742	0	195662009	4112343		0
59233	3513	81151	2007-02-12	2007-02-12 00:00:00	2007-02-26	2007-02-26 00:00:00	32020		\N	233119	0	44465007	81151		0
69929	4137	260139	1976-08-23	1976-08-23 00:00:00	1976-08-30	1976-08-30 00:00:00	32020		\N	274993	0	10509002	260139		0
48966	2897	40481087	1977-08-05	1977-08-05 00:00:00	1977-08-26	1977-08-26 00:00:00	32020		\N	192964	0	444814009	40481087		0
59687	3537	133834	1961-12-29	1961-12-29 00:00:00	1978-12-30	1978-12-30 00:00:00	32020		\N	234908	0	24079001	133834		0
59872	3547	81151	2018-01-23	2018-01-23 00:00:00	2018-02-13	2018-02-13 00:00:00	32020		\N	235543	0	44465007	81151		0
60026	3556	40481087	1994-02-19	1994-02-19 00:00:00	1994-03-12	1994-03-12 00:00:00	32020		\N	236142	0	444814009	40481087		0
60145	3561	40481087	2001-07-17	2001-07-17 00:00:00	2001-08-07	2001-08-07 00:00:00	32020		\N	236518	0	444814009	40481087		0
60315	3569	378001	1959-10-30	1959-10-30 00:00:00	1959-12-29	1959-12-29 00:00:00	32020		\N	237185	0	62106007	378001		0
49919	2950	40481087	2010-05-19	2010-05-19 00:00:00	2010-05-26	2010-05-26 00:00:00	32020		\N	196974	0	444814009	40481087		0
60644	3589	40481087	2018-06-16	2018-06-16 00:00:00	2018-06-23	2018-06-23 00:00:00	32020		\N	238460	0	444814009	40481087		0
50262	2970	134438	1999-04-15	1999-04-15 00:00:00	1999-12-13	1999-12-13 00:00:00	32020		\N	198349	0	40275004	134438		0
61019	3612	195588	2003-12-09	2003-12-09 00:00:00	2004-01-15	2004-01-15 00:00:00	32020		\N	239938	0	38822007	195588		0
61101	3615	4218389	2007-11-21	2007-11-21 00:00:00	2007-12-19	2007-12-19 00:00:00	32020		\N	240220	0	39848009	4218389		0
61272	3623	372328	1952-04-04	1952-04-04 00:00:00	1952-07-20	1952-07-20 00:00:00	32020		\N	240925	0	65363002	372328		0
61434	3629	4294548	1982-04-17	1982-04-17 00:00:00	1982-06-05	1982-06-05 00:00:00	32020		\N	241456	0	75498004	4294548		0
51069	3025	4112343	1992-02-08	1992-02-08 00:00:00	1992-02-18	1992-02-18 00:00:00	32020		\N	201595	0	195662009	4112343		0
61879	3654	40481087	1981-01-07	1981-01-07 00:00:00	1981-01-28	1981-01-28 00:00:00	32020		\N	243186	0	444814009	40481087		0
62006	3660	4116491	1997-07-16	1997-07-16 00:00:00	1997-08-16	1997-08-16 00:00:00	32020		\N	243585	0	301011002	4116491		0
62104	3667	260139	1985-02-02	1985-02-02 00:00:00	1985-02-16	1985-02-16 00:00:00	32020		\N	243983	0	10509002	260139		0
72884	4330	4112343	1951-07-27	1951-07-27 00:00:00	1951-08-03	1951-08-03 00:00:00	32020		\N	287181	0	195662009	4112343		0
62472	3691	260139	2005-08-28	2005-08-28 00:00:00	2005-09-04	2005-09-04 00:00:00	32020		\N	245348	0	10509002	260139		0
62591	3698	4296204	1963-04-02	1963-04-02 00:00:00	1963-04-30	1963-04-30 00:00:00	32020		\N	245838	0	403190006	4296204		0
62796	3708	4142905	2003-07-26	2003-07-26 00:00:00	2003-09-24	2003-09-24 00:00:00	32020		\N	246495	0	33737001	4142905		0
52436	3106	4112343	1963-07-03	1963-07-03 00:00:00	1963-07-15	1963-07-15 00:00:00	32020		\N	206567	0	195662009	4112343		0
63237	3734	4296205	1978-03-26	1978-03-26 00:00:00	1978-04-09	1978-04-09 00:00:00	32020		\N	248173	0	403191005	4296205		0
63379	3744	134438	2002-12-27	2002-12-27 00:00:00	2004-02-21	2004-02-21 00:00:00	32020		\N	248793	0	40275004	134438		0
63524	3752	4310024	1995-07-01	1995-07-01 00:00:00	\N	\N	32020		\N	249307	0	424802006	4310024		0
63714	3761	4112343	2009-08-19	2009-08-19 00:00:00	2009-08-28	2009-08-28 00:00:00	32020		\N	250098	0	195662009	4112343		0
53172	3149	4112343	2006-11-24	2006-11-24 00:00:00	2006-12-07	2006-12-07 00:00:00	32020		\N	209504	0	195662009	4112343		0
53447	3167	4027663	1992-05-28	1992-05-28 00:00:00	\N	\N	32020		\N	210558	0	13200003	4027663		0
53560	3174	40481087	1994-03-09	1994-03-09 00:00:00	1994-03-30	1994-03-30 00:00:00	32020		\N	210941	0	444814009	40481087		0
53657	3177	4112343	1932-01-27	1932-01-27 00:00:00	1932-02-04	1932-02-04 00:00:00	32020		\N	211265	0	195662009	4112343		0
43293	2578	260139	1971-12-21	1971-12-21 00:00:00	1971-12-28	1971-12-28 00:00:00	32020		\N	170751	0	10509002	260139		0
54034	3199	40481087	1979-03-07	1979-03-07 00:00:00	1979-03-21	1979-03-21 00:00:00	32020		\N	212739	0	444814009	40481087		0
43620	2597	4296204	1990-06-26	1990-06-26 00:00:00	1990-07-24	1990-07-24 00:00:00	32020		\N	171857	0	403190006	4296204		0
54320	3218	4112343	1985-07-02	1985-07-02 00:00:00	1985-07-11	1985-07-11 00:00:00	32020		\N	213814	0	195662009	4112343		0
43983	2617	40481087	1979-11-12	1979-11-12 00:00:00	1979-11-26	1979-11-26 00:00:00	32020		\N	173044	0	444814009	40481087		0
54659	3236	260139	1987-03-27	1987-03-27 00:00:00	1987-04-10	1987-04-10 00:00:00	32020		\N	215060	0	10509002	260139		0
54823	3244	4152936	1974-04-13	1974-04-13 00:00:00	1974-05-04	1974-05-04 00:00:00	32020		\N	215744	0	283385000	4152936		0
55061	3259	4112343	1990-08-17	1990-08-17 00:00:00	1990-08-25	1990-08-25 00:00:00	32020		\N	216644	0	195662009	4112343		0
65745	3887	260139	1963-09-19	1963-09-19 00:00:00	1963-09-26	1963-09-26 00:00:00	32020		\N	258387	0	10509002	260139		0
55333	3278	4112343	1976-10-05	1976-10-05 00:00:00	1976-10-18	1976-10-18 00:00:00	32020		\N	217750	0	195662009	4112343		0
55491	3287	4146173	1988-11-05	1988-11-05 00:00:00	1988-12-12	1988-12-12 00:00:00	32020		\N	218391	0	307731004	4146173		0
55684	3296	40481087	2000-04-24	2000-04-24 00:00:00	2000-05-08	2000-05-08 00:00:00	32020		\N	219025	0	444814009	40481087		0
45283	2693	40481087	1976-09-22	1976-09-22 00:00:00	1976-10-06	1976-10-06 00:00:00	32020		\N	178374	0	444814009	40481087		0
56081	3321	40481087	2011-06-02	2011-06-02 00:00:00	2011-06-09	2011-06-09 00:00:00	32020		\N	220513	0	444814009	40481087		0
56211	3332	4112343	1977-02-26	1977-02-26 00:00:00	1977-03-07	1977-03-07 00:00:00	32020		\N	221099	0	195662009	4112343		0
56355	3342	260139	1938-11-26	1938-11-26 00:00:00	1938-12-10	1938-12-10 00:00:00	32020		\N	221561	0	10509002	260139		0
56500	3352	40481087	2003-02-26	2003-02-26 00:00:00	2003-03-05	2003-03-05 00:00:00	32020		\N	222270	0	444814009	40481087		0
56771	3367	4218389	1993-05-25	1993-05-25 00:00:00	1993-06-22	1993-06-22 00:00:00	32020		\N	223280	0	39848009	4218389		0
56832	3371	81151	1985-09-19	1985-09-19 00:00:00	1985-10-10	1985-10-10 00:00:00	32020		\N	223671	0	44465007	81151		0
56944	3378	372328	1959-12-07	1959-12-07 00:00:00	1959-12-21	1959-12-21 00:00:00	32020		\N	224153	0	65363002	372328		0
46614	2774	260139	1946-11-01	1946-11-01 00:00:00	1946-11-08	1946-11-08 00:00:00	32020		\N	183638	0	10509002	260139		0
57316	3401	78272	1994-07-21	1994-07-21 00:00:00	1994-08-04	1994-08-04 00:00:00	32020		\N	225624	0	70704007	78272		0
57476	3410	4112343	2017-10-11	2017-10-11 00:00:00	2017-10-21	2017-10-21 00:00:00	32020		\N	226191	0	195662009	4112343		0
57675	3420	40481087	2001-05-25	2001-05-25 00:00:00	2001-06-15	2001-06-15 00:00:00	32020		\N	226875	0	444814009	40481087		0
57830	3431	4116491	1988-10-03	1988-10-03 00:00:00	1988-11-05	1988-11-05 00:00:00	32020		\N	227399	0	301011002	4116491		0
57980	3437	40481087	1915-03-19	1915-03-19 00:00:00	1915-04-02	1915-04-02 00:00:00	32020		\N	227968	0	444814009	40481087		0
58132	3443	80180	2012-05-19	2012-05-19 00:00:00	\N	\N	32020		\N	228516	0	396275006	80180		0
47759	2836	4218389	2012-01-04	2012-01-04 00:00:00	2012-02-08	2012-02-08 00:00:00	32020		\N	188376	0	39848009	4218389		0
47952	2846	78272	1996-12-28	1996-12-28 00:00:00	1997-02-01	1997-02-01 00:00:00	32020		\N	188992	0	70704007	78272		0
58754	3486	4278672	1991-09-04	1991-09-04 00:00:00	1991-11-03	1991-11-03 00:00:00	32020		\N	231298	0	65966004	4278672		0
48254	2860	40481087	1999-09-11	1999-09-11 00:00:00	1999-10-02	1999-10-02 00:00:00	32020		\N	190104	0	444814009	40481087		0
48411	2867	40481087	1990-10-19	1990-10-19 00:00:00	1990-11-09	1990-11-09 00:00:00	32020		\N	190724	0	444814009	40481087		0
59234	3513	4142905	1979-08-10	1979-08-10 00:00:00	1979-10-09	1979-10-09 00:00:00	32020		\N	233116	0	33737001	4142905		0
69930	4137	4112343	2018-01-09	2018-01-09 00:00:00	2018-01-21	2018-01-21 00:00:00	32020		\N	274994	0	195662009	4112343		0
48967	2898	372328	1982-07-22	1982-07-22 00:00:00	1982-12-21	1982-12-21 00:00:00	32020		\N	193111	0	65363002	372328		0
59688	3537	81151	1978-08-14	1978-08-14 00:00:00	1978-09-11	1978-09-11 00:00:00	32020		\N	234965	0	44465007	81151		0
59873	3547	260139	1987-02-16	1987-02-16 00:00:00	1987-02-23	1987-02-23 00:00:00	32020		\N	235569	0	10509002	260139		0
60027	3556	40481087	2009-03-24	2009-03-24 00:00:00	2009-04-14	2009-04-14 00:00:00	32020		\N	236148	0	444814009	40481087		0
60146	3561	4156265	1997-09-12	1997-09-12 00:00:00	1997-09-26	1997-09-26 00:00:00	32020		\N	236475	0	370247008	4156265		0
60316	3569	4112343	2006-11-17	2006-11-17 00:00:00	2006-11-24	2006-11-24 00:00:00	32020		\N	237183	0	195662009	4112343		0
49920	2950	4155034	1983-06-09	1983-06-09 00:00:00	1983-06-23	1983-06-23 00:00:00	32020		\N	196938	0	283371005	4155034		0
60645	3589	372328	1985-09-24	1985-09-24 00:00:00	1985-12-09	1985-12-09 00:00:00	32020		\N	238481	0	65363002	372328		0
50263	2970	4027663	1996-04-08	1996-04-08 00:00:00	\N	\N	32020		\N	198320	0	13200003	4027663		0
61020	3612	40481087	2000-07-13	2000-07-13 00:00:00	2000-08-03	2000-08-03 00:00:00	32020		\N	239974	0	444814009	40481087		0
61102	3615	4027663	1976-08-24	1976-08-24 00:00:00	\N	\N	32020		\N	240155	0	13200003	4027663		0
61273	3623	4218389	1990-07-31	1990-07-31 00:00:00	1990-08-28	1990-08-28 00:00:00	32020		\N	240935	0	39848009	4218389		0
61435	3629	260139	1988-09-30	1988-09-30 00:00:00	1988-10-07	1988-10-07 00:00:00	32020		\N	241458	0	10509002	260139		0
51070	3025	257012	1970-03-16	1970-03-16 00:00:00	\N	\N	32020		\N	201687	0	40055000	257012		0
61880	3654	80180	2004-10-17	2004-10-17 00:00:00	\N	\N	32020		\N	243241	0	396275006	80180		0
62007	3660	4113008	1987-11-29	1987-11-29 00:00:00	1987-12-20	1987-12-20 00:00:00	32020		\N	243603	0	284549007	4113008		0
62105	3667	4152936	1974-10-23	1974-10-23 00:00:00	1974-11-13	1974-11-13 00:00:00	32020		\N	243976	0	283385000	4152936		0
72885	4330	80502	2006-02-18	2006-02-18 00:00:00	\N	\N	32020		\N	287247	0	64859006	80502		0
62473	3691	4296204	1964-03-21	1964-03-21 00:00:00	1964-04-25	1964-04-25 00:00:00	32020		\N	245327	0	403190006	4296204		0
62592	3698	40481087	2007-12-03	2007-12-03 00:00:00	2007-12-10	2007-12-10 00:00:00	32020		\N	245876	0	444814009	40481087		0
62797	3708	198199	1999-05-08	1999-05-08 00:00:00	1999-06-12	1999-06-12 00:00:00	32020		\N	246525	0	45816000	198199		0
52437	3106	260139	1973-12-23	1973-12-23 00:00:00	1973-12-30	1973-12-30 00:00:00	32020		\N	206556	0	10509002	260139		0
63238	3734	4294548	1954-11-15	1954-11-15 00:00:00	1955-02-28	1955-02-28 00:00:00	32020		\N	248122	0	75498004	4294548		0
63380	3744	260139	2009-10-27	2009-10-27 00:00:00	2009-11-03	2009-11-03 00:00:00	32020		\N	248815	0	10509002	260139		0
63525	3752	40481087	1995-03-05	1995-03-05 00:00:00	1995-03-12	1995-03-12 00:00:00	32020		\N	249307	0	444814009	40481087		0
63715	3761	372328	1959-10-26	1959-10-26 00:00:00	1960-03-26	1960-03-26 00:00:00	32020		\N	250078	0	65363002	372328		0
53173	3149	40481087	2017-04-08	2017-04-08 00:00:00	2017-04-29	2017-04-29 00:00:00	32020		\N	209506	0	444814009	40481087		0
53448	3167	40481087	2005-07-04	2005-07-04 00:00:00	2005-07-18	2005-07-18 00:00:00	32020		\N	210588	0	444814009	40481087		0
53561	3174	260139	1994-12-23	1994-12-23 00:00:00	1995-01-06	1995-01-06 00:00:00	32020		\N	210942	0	10509002	260139		0
53658	3177	372328	1918-03-24	1918-03-24 00:00:00	1918-06-26	1918-06-26 00:00:00	32020		\N	211334	0	65363002	372328		0
43294	2579	28060	1956-05-01	1956-05-01 00:00:00	1956-05-14	1956-05-14 00:00:00	32020		\N	170769	0	43878008	28060		0
54036	3199	378001	1998-05-18	1998-05-18 00:00:00	1998-07-17	1998-07-17 00:00:00	32020		\N	212770	0	62106007	378001		0
43621	2597	378001	1993-06-08	1993-06-08 00:00:00	1993-08-07	1993-08-07 00:00:00	32020		\N	171858	0	62106007	378001		0
54321	3218	372328	1957-10-23	1957-10-23 00:00:00	1958-01-05	1958-01-05 00:00:00	32020		\N	213879	0	65363002	372328		0
43984	2617	4283893	2001-02-15	2001-02-15 00:00:00	2001-03-29	2001-03-29 00:00:00	32020		\N	173031	0	36971009	4283893		0
54660	3236	260139	2003-06-27	2003-06-27 00:00:00	2003-07-12	2003-07-12 00:00:00	32020		\N	215100	0	10509002	260139		0
54824	3244	134438	1991-04-21	1991-04-21 00:00:00	1993-03-14	1993-03-14 00:00:00	32020		\N	215717	0	40275004	134438		0
55062	3259	4112343	2003-05-22	2003-05-22 00:00:00	2003-06-02	2003-06-02 00:00:00	32020		\N	216686	0	195662009	4112343		0
65746	3887	192671	1990-06-23	1990-06-23 00:00:00	\N	\N	32020		\N	258361	0	K92.2	35208414		0
55334	3278	4112343	2012-04-13	2012-04-13 00:00:00	2012-04-25	2012-04-25 00:00:00	32020		\N	217780	0	195662009	4112343		0
55492	3287	80180	1980-04-17	1980-04-17 00:00:00	\N	\N	32020		\N	218342	0	396275006	80180		0
55685	3296	4112343	2010-08-18	2010-08-18 00:00:00	2010-08-28	2010-08-28 00:00:00	32020		\N	219026	0	195662009	4112343		0
45284	2693	260139	1962-01-27	1962-01-27 00:00:00	1962-02-10	1962-02-10 00:00:00	32020		\N	178421	0	10509002	260139		0
56082	3321	4152936	1991-03-17	1991-03-17 00:00:00	1991-03-31	1991-03-31 00:00:00	32020		\N	220501	0	283385000	4152936		0
56212	3332	40481087	2006-11-23	2006-11-23 00:00:00	2006-12-07	2006-12-07 00:00:00	32020		\N	221102	0	444814009	40481087		0
56356	3342	260139	1977-08-13	1977-08-13 00:00:00	1977-08-20	1977-08-20 00:00:00	32020		\N	221609	0	10509002	260139		0
56501	3352	40481087	2008-10-12	2008-10-12 00:00:00	2008-11-02	2008-11-02 00:00:00	32020		\N	222286	0	444814009	40481087		0
56772	3367	4112343	1977-10-11	1977-10-11 00:00:00	1977-10-21	1977-10-21 00:00:00	32020		\N	223307	0	195662009	4112343		0
56833	3371	40481087	1998-01-20	1998-01-20 00:00:00	1998-02-03	1998-02-03 00:00:00	32020		\N	223648	0	444814009	40481087		0
56945	3378	80809	1996-07-10	1996-07-10 00:00:00	2000-08-18	2000-08-18 00:00:00	32020		\N	224148	0	69896004	80809		0
46615	2774	4218389	1981-11-26	1981-11-26 00:00:00	1981-12-31	1981-12-31 00:00:00	32020		\N	183690	0	39848009	4218389		0
57317	3401	4149245	1965-10-14	1965-10-14 00:00:00	1965-12-20	1965-12-20 00:00:00	32020		\N	225623	0	30832001	4149245		0
57477	3410	28060	1980-07-03	1980-07-03 00:00:00	1980-07-14	1980-07-14 00:00:00	32020		\N	226189	0	43878008	28060		0
57676	3420	4112343	1972-10-15	1972-10-15 00:00:00	1972-10-26	1972-10-26 00:00:00	32020		\N	226905	0	195662009	4112343		0
57831	3431	78272	1967-06-16	1967-06-16 00:00:00	1967-07-07	1967-07-07 00:00:00	32020		\N	227474	0	70704007	78272		0
57981	3437	4112343	1927-01-23	1927-01-23 00:00:00	1927-02-04	1927-02-04 00:00:00	32020		\N	227983	0	195662009	4112343		0
58133	3443	40481087	1982-08-08	1982-08-08 00:00:00	1982-08-29	1982-08-29 00:00:00	32020		\N	228456	0	444814009	40481087		0
47760	2836	4116491	2008-10-04	2008-10-04 00:00:00	2008-11-22	2008-11-22 00:00:00	32020		\N	188405	0	301011002	4116491		0
47953	2846	4278672	1981-02-22	1981-02-22 00:00:00	1981-05-23	1981-05-23 00:00:00	32020		\N	188988	0	65966004	4278672		0
58755	3486	40481087	2006-07-07	2006-07-07 00:00:00	2006-07-14	2006-07-14 00:00:00	32020		\N	231265	0	444814009	40481087		0
48255	2861	372328	1965-05-28	1965-05-28 00:00:00	1965-10-11	1965-10-11 00:00:00	32020		\N	190176	0	65363002	372328		0
48412	2867	4112343	1979-09-13	1979-09-13 00:00:00	1979-09-26	1979-09-26 00:00:00	32020		\N	190740	0	195662009	4112343		0
59235	3513	40481087	2019-02-12	2019-02-12 00:00:00	2019-03-05	2019-03-05 00:00:00	32020		\N	233160	0	444814009	40481087		0
69931	4137	260139	1973-02-23	1973-02-23 00:00:00	1973-03-09	1973-03-09 00:00:00	32020		\N	275019	0	10509002	260139		0
48968	2898	4116491	2012-01-08	2012-01-08 00:00:00	2012-02-16	2012-02-16 00:00:00	32020		\N	193098	0	301011002	4116491		0
59689	3537	40481087	1970-07-16	1970-07-16 00:00:00	1970-07-23	1970-07-23 00:00:00	32020		\N	234906	0	444814009	40481087		0
59874	3547	80180	2014-05-23	2014-05-23 00:00:00	\N	\N	32020		\N	235579	0	396275006	80180		0
60028	3556	4134304	1994-01-24	1994-01-24 00:00:00	1994-04-24	1994-04-24 00:00:00	32020		\N	236128	0	263102004	4134304		0
60147	3561	40481087	1967-11-24	1967-11-24 00:00:00	1967-12-15	1967-12-15 00:00:00	32020		\N	236559	0	444814009	40481087		0
60317	3569	260139	2015-08-13	2015-08-13 00:00:00	2015-08-27	2015-08-27 00:00:00	32020		\N	237184	0	10509002	260139		0
49921	2950	40481087	1994-02-24	1994-02-24 00:00:00	1994-03-03	1994-03-03 00:00:00	32020		\N	196972	0	444814009	40481087		0
60646	3589	4112343	2009-02-04	2009-02-04 00:00:00	2009-02-14	2009-02-14 00:00:00	32020		\N	238445	0	195662009	4112343		0
50264	2970	40481087	1996-02-18	1996-02-18 00:00:00	1996-02-25	1996-02-25 00:00:00	32020		\N	198320	0	444814009	40481087		0
61021	3612	40481087	1977-05-10	1977-05-10 00:00:00	1977-05-24	1977-05-24 00:00:00	32020		\N	239970	0	444814009	40481087		0
61103	3615	260139	1997-09-25	1997-09-25 00:00:00	1997-10-09	1997-10-09 00:00:00	32020		\N	240180	0	10509002	260139		0
61274	3623	40481087	1974-03-18	1974-03-18 00:00:00	1974-04-01	1974-04-01 00:00:00	32020		\N	240884	0	444814009	40481087		0
61436	3629	4237458	1965-09-29	1965-09-29 00:00:00	1965-12-28	1965-12-28 00:00:00	32020		\N	241470	0	58150001	4237458		0
51071	3025	372328	1948-08-26	1948-08-26 00:00:00	1948-11-01	1948-11-01 00:00:00	32020		\N	201677	0	65363002	372328		0
61881	3654	4112343	2004-06-07	2004-06-07 00:00:00	2004-06-17	2004-06-17 00:00:00	32020		\N	243241	0	195662009	4112343		0
62008	3660	80180	2009-09-26	2009-09-26 00:00:00	\N	\N	32020		\N	243600	0	396275006	80180		0
62106	3667	81151	2010-01-22	2010-01-22 00:00:00	2010-02-12	2010-02-12 00:00:00	32020		\N	243979	0	44465007	81151		0
72886	4330	260139	2000-01-04	2000-01-04 00:00:00	2000-01-11	2000-01-11 00:00:00	32020		\N	287213	0	10509002	260139		0
62474	3691	28060	1999-01-04	1999-01-04 00:00:00	1999-01-16	1999-01-16 00:00:00	32020		\N	245318	0	43878008	28060		0
62593	3698	40481087	1954-03-26	1954-03-26 00:00:00	1954-04-02	1954-04-02 00:00:00	32020		\N	245851	0	444814009	40481087		0
62798	3708	192671	2015-08-07	2015-08-07 00:00:00	\N	\N	32020		\N	246499	0	K92.2	35208414		0
52438	3106	260139	2008-05-15	2008-05-15 00:00:00	2008-05-22	2008-05-22 00:00:00	32020		\N	206570	0	10509002	260139		0
63239	3734	4283893	1984-09-29	1984-09-29 00:00:00	1985-01-12	1985-01-12 00:00:00	32020		\N	248151	0	36971009	4283893		0
63381	3744	4152936	2019-01-17	2019-01-17 00:00:00	2019-01-31	2019-01-31 00:00:00	32020		\N	248853	0	283385000	4152936		0
63526	3752	4059173	1959-08-04	1959-08-04 00:00:00	1959-09-03	1959-09-03 00:00:00	32020		\N	249363	0	16114001	4059173		0
63716	3761	80180	1990-11-29	1990-11-29 00:00:00	\N	\N	32020		\N	250109	0	396275006	80180		0
53174	3149	260139	2001-01-31	2001-01-31 00:00:00	2001-02-14	2001-02-14 00:00:00	32020		\N	209526	0	10509002	260139		0
53449	3167	4218389	2006-08-29	2006-08-29 00:00:00	2006-09-26	2006-09-26 00:00:00	32020		\N	210552	0	39848009	4218389		0
53562	3174	40481087	1992-06-20	1992-06-20 00:00:00	1992-07-11	1992-07-11 00:00:00	32020		\N	210940	0	444814009	40481087		0
53659	3177	40480160	1985-12-15	1985-12-15 00:00:00	1986-03-15	1986-03-15 00:00:00	32020		\N	211233	0	443165006	40480160		0
43295	2579	4116491	1981-04-13	1981-04-13 00:00:00	1981-05-14	1981-05-14 00:00:00	32020		\N	170771	0	301011002	4116491		0
54037	3199	4112343	2010-07-04	2010-07-04 00:00:00	2010-07-12	2010-07-12 00:00:00	32020		\N	212742	0	195662009	4112343		0
43622	2597	4134304	1983-12-30	1983-12-30 00:00:00	1984-01-29	1984-01-29 00:00:00	32020		\N	171856	0	263102004	4134304		0
54322	3218	4278672	1994-01-03	1994-01-03 00:00:00	1994-04-03	1994-04-03 00:00:00	32020		\N	213812	0	65966004	4278672		0
43985	2617	4112343	1965-04-18	1965-04-18 00:00:00	1965-04-27	1965-04-27 00:00:00	32020		\N	173043	0	195662009	4112343		0
54661	3236	260139	1933-05-15	1933-05-15 00:00:00	1933-05-22	1933-05-22 00:00:00	32020		\N	215088	0	10509002	260139		0
54825	3244	4112343	2013-06-10	2013-06-10 00:00:00	2013-06-22	2013-06-22 00:00:00	32020		\N	215733	0	195662009	4112343		0
55063	3259	372328	1980-01-03	1980-01-03 00:00:00	1980-08-08	1980-08-08 00:00:00	32020		\N	216689	0	65363002	372328		0
65747	3887	260139	1982-11-28	1982-11-28 00:00:00	1982-12-12	1982-12-12 00:00:00	32020		\N	258403	0	10509002	260139		0
55335	3278	4218389	1986-11-12	1986-11-12 00:00:00	1986-12-03	1986-12-03 00:00:00	32020		\N	217746	0	39848009	4218389		0
55493	3287	40481087	1957-03-24	1957-03-24 00:00:00	1957-04-07	1957-04-07 00:00:00	32020		\N	218326	0	444814009	40481087		0
55686	3296	4112343	1939-04-16	1939-04-16 00:00:00	1939-04-25	1939-04-25 00:00:00	32020		\N	219084	0	195662009	4112343		0
45285	2693	4113008	1972-10-30	1972-10-30 00:00:00	1972-11-20	1972-11-20 00:00:00	32020		\N	178365	0	284549007	4113008		0
56083	3321	40481087	1985-10-26	1985-10-26 00:00:00	1985-11-02	1985-11-02 00:00:00	32020		\N	220522	0	444814009	40481087		0
56213	3332	4112343	2011-05-06	2011-05-06 00:00:00	2011-05-14	2011-05-14 00:00:00	32020		\N	221128	0	195662009	4112343		0
56357	3342	260139	1927-06-04	1927-06-04 00:00:00	1927-06-18	1927-06-18 00:00:00	32020		\N	221588	0	10509002	260139		0
56502	3352	4112343	1972-04-09	1972-04-09 00:00:00	1972-04-21	1972-04-21 00:00:00	32020		\N	222305	0	195662009	4112343		0
67231	3973	40481087	1998-06-29	1998-06-29 00:00:00	1998-07-13	1998-07-13 00:00:00	32020		\N	264172	0	444814009	40481087		0
56834	3371	440086	1988-08-11	1988-08-11 00:00:00	1993-08-20	1993-08-20 00:00:00	32020		\N	223605	0	192127007	440086		0
56946	3378	4146173	2019-01-10	2019-01-10 00:00:00	2019-02-09	2019-02-09 00:00:00	32020		\N	224152	0	307731004	4146173		0
46616	2774	260139	1971-07-11	1971-07-11 00:00:00	1971-07-25	1971-07-25 00:00:00	32020		\N	183703	0	10509002	260139		0
57318	3401	40481087	1968-02-20	1968-02-20 00:00:00	1968-03-05	1968-03-05 00:00:00	32020		\N	225593	0	444814009	40481087		0
57478	3410	81151	1973-03-20	1973-03-20 00:00:00	1973-04-03	1973-04-03 00:00:00	32020		\N	226177	0	44465007	81151		0
57677	3420	40481087	1973-05-05	1973-05-05 00:00:00	1973-05-26	1973-05-26 00:00:00	32020		\N	226884	0	444814009	40481087		0
57832	3431	4112343	1987-01-24	1987-01-24 00:00:00	1987-02-02	1987-02-02 00:00:00	32020		\N	227471	0	195662009	4112343		0
57982	3437	378001	1966-01-31	1966-01-31 00:00:00	1966-04-01	1966-04-01 00:00:00	32020		\N	227920	0	62106007	378001		0
58134	3443	4112343	1986-06-23	1986-06-23 00:00:00	1986-07-03	1986-07-03 00:00:00	32020		\N	228481	0	195662009	4112343		0
47761	2836	40481087	2018-01-14	2018-01-14 00:00:00	2018-01-28	2018-01-28 00:00:00	32020		\N	188401	0	444814009	40481087		0
72564	4309	30753	1993-05-21	1993-05-21 00:00:00	\N	\N	32020		\N	285888	0	16761005	30753		0
47954	2846	4112343	1986-06-06	1986-06-06 00:00:00	1986-06-16	1986-06-16 00:00:00	32020		\N	189005	0	195662009	4112343		0
58756	3486	440086	1973-12-21	1973-12-21 00:00:00	1976-03-26	1976-03-26 00:00:00	32020		\N	231205	0	192127007	440086		0
48256	2861	257012	1965-03-26	1965-03-26 00:00:00	\N	\N	32020		\N	190179	0	40055000	257012		0
48413	2867	40481087	2003-09-03	2003-09-03 00:00:00	2003-09-17	2003-09-17 00:00:00	32020		\N	190703	0	444814009	40481087		0
59236	3513	4027663	2000-03-12	2000-03-12 00:00:00	\N	\N	32020		\N	233126	0	13200003	4027663		0
69932	4137	4218389	1999-04-06	1999-04-06 00:00:00	1999-05-04	1999-05-04 00:00:00	32020		\N	275051	0	39848009	4218389		0
48969	2898	372328	1979-09-13	1979-09-13 00:00:00	1979-12-25	1979-12-25 00:00:00	32020		\N	193073	0	65363002	372328		0
59690	3537	260139	1990-12-22	1990-12-22 00:00:00	1990-12-29	1990-12-29 00:00:00	32020		\N	234897	0	10509002	260139		0
59875	3547	4283893	1981-07-21	1981-07-21 00:00:00	1981-10-13	1981-10-13 00:00:00	32020		\N	235545	0	36971009	4283893		0
60029	3556	192671	2013-10-15	2013-10-15 00:00:00	\N	\N	32020		\N	236131	0	K92.2	35208414		0
60148	3561	40481087	1917-10-28	1917-10-28 00:00:00	1917-11-11	1917-11-11 00:00:00	32020		\N	236494	0	444814009	40481087		0
60318	3569	260139	2005-07-04	2005-07-04 00:00:00	2005-07-11	2005-07-11 00:00:00	32020		\N	237181	0	10509002	260139		0
49922	2950	40481087	1959-04-01	1959-04-01 00:00:00	1959-04-15	1959-04-15 00:00:00	32020		\N	196970	0	444814009	40481087		0
60647	3589	372328	1983-02-17	1983-02-17 00:00:00	1983-06-07	1983-06-07 00:00:00	32020		\N	238410	0	65363002	372328		0
50265	2970	40481087	1998-10-20	1998-10-20 00:00:00	1998-11-03	1998-11-03 00:00:00	32020		\N	198348	0	444814009	40481087		0
61022	3612	4059173	1991-12-02	1991-12-02 00:00:00	1992-03-01	1992-03-01 00:00:00	32020		\N	240000	0	16114001	4059173		0
61104	3615	378001	1956-08-24	1956-08-24 00:00:00	1956-10-23	1956-10-23 00:00:00	32020		\N	240215	0	62106007	378001		0
61275	3623	40481087	1994-06-26	1994-06-26 00:00:00	1994-07-10	1994-07-10 00:00:00	32020		\N	240894	0	444814009	40481087		0
61437	3629	40481087	1975-01-04	1975-01-04 00:00:00	1975-01-18	1975-01-18 00:00:00	32020		\N	241488	0	444814009	40481087		0
51072	3025	317576	1949-10-31	1949-10-31 00:00:00	\N	\N	32020		\N	201680	0	53741008	317576		0
61882	3654	30753	2004-08-18	2004-08-18 00:00:00	\N	\N	32020		\N	243241	0	16761005	30753		0
62009	3660	4112343	1976-11-30	1976-11-30 00:00:00	1976-12-07	1976-12-07 00:00:00	32020		\N	243583	0	195662009	4112343		0
62107	3667	4112343	1998-10-22	1998-10-22 00:00:00	1998-11-01	1998-11-01 00:00:00	32020		\N	243948	0	195662009	4112343		0
72887	4330	30753	1986-01-01	1986-01-01 00:00:00	\N	\N	32020		\N	287273	0	16761005	30753		0
62507	3694	375671	1990-02-11	1990-02-11 00:00:00	1990-03-13	1990-03-13 00:00:00	32020		\N	245563	0	62564004	375671		0
62594	3698	260139	1960-07-04	1960-07-04 00:00:00	1960-07-11	1960-07-11 00:00:00	32020		\N	245827	0	10509002	260139		0
62799	3708	372328	1980-10-24	1980-10-24 00:00:00	1981-03-13	1981-03-13 00:00:00	32020		\N	246539	0	65363002	372328		0
52439	3106	40481087	1968-04-28	1968-04-28 00:00:00	1968-05-12	1968-05-12 00:00:00	32020		\N	206547	0	444814009	40481087		0
63240	3734	4230399	2006-07-11	2006-07-11 00:00:00	2006-08-10	2006-08-10 00:00:00	32020		\N	248174	0	359817006	4230399		0
63382	3744	4310024	2003-06-18	2003-06-18 00:00:00	\N	\N	32020		\N	248824	0	424802006	4310024		0
63527	3752	40481087	2002-05-10	2002-05-10 00:00:00	2002-05-31	2002-05-31 00:00:00	32020		\N	249344	0	444814009	40481087		0
63717	3761	260139	2002-03-18	2002-03-18 00:00:00	2002-04-01	2002-04-01 00:00:00	32020		\N	250055	0	10509002	260139		0
53175	3149	260139	1992-05-22	1992-05-22 00:00:00	1992-06-05	1992-06-05 00:00:00	32020		\N	209488	0	10509002	260139		0
53450	3167	40481087	1965-05-16	1965-05-16 00:00:00	1965-05-30	1965-05-30 00:00:00	32020		\N	210575	0	444814009	40481087		0
53563	3174	260139	1989-08-29	1989-08-29 00:00:00	1989-09-12	1989-09-12 00:00:00	32020		\N	210975	0	10509002	260139		0
53660	3177	4134304	1985-12-15	1985-12-15 00:00:00	1986-03-15	1986-03-15 00:00:00	32020		\N	211233	0	263102004	4134304		0
43296	2579	40481087	1999-08-30	1999-08-30 00:00:00	1999-09-20	1999-09-20 00:00:00	32020		\N	170814	0	444814009	40481087		0
54038	3199	40481087	2017-10-18	2017-10-18 00:00:00	2017-11-08	2017-11-08 00:00:00	32020		\N	212732	0	444814009	40481087		0
43623	2597	40481087	2002-02-28	2002-02-28 00:00:00	2002-03-07	2002-03-07 00:00:00	32020		\N	171833	0	444814009	40481087		0
54323	3218	40481087	2003-04-26	2003-04-26 00:00:00	2003-05-17	2003-05-17 00:00:00	32020		\N	213863	0	444814009	40481087		0
43986	2617	81151	1955-11-20	1955-11-20 00:00:00	1955-12-18	1955-12-18 00:00:00	32020		\N	173081	0	44465007	81151		0
54662	3236	4113008	1993-06-28	1993-06-28 00:00:00	1993-07-12	1993-07-12 00:00:00	32020		\N	215031	0	284549007	4113008		0
54826	3244	80180	2013-07-27	2013-07-27 00:00:00	\N	\N	32020		\N	215733	0	396275006	80180		0
55064	3259	192671	1999-11-21	1999-11-21 00:00:00	\N	\N	32020		\N	216671	0	K92.2	35208414		0
65748	3887	4027663	1983-06-19	1983-06-19 00:00:00	\N	\N	32020		\N	258403	0	13200003	4027663		0
55336	3278	40481087	2004-08-22	2004-08-22 00:00:00	2004-09-05	2004-09-05 00:00:00	32020		\N	217756	0	444814009	40481087		0
55494	3287	372328	1946-04-01	1946-04-01 00:00:00	1946-06-17	1946-06-17 00:00:00	32020		\N	218394	0	65363002	372328		0
55687	3296	4112343	1972-06-12	1972-06-12 00:00:00	1972-06-19	1972-06-19 00:00:00	32020		\N	219099	0	195662009	4112343		0
45286	2693	260139	1967-09-22	1967-09-22 00:00:00	1967-10-06	1967-10-06 00:00:00	32020		\N	178425	0	10509002	260139		0
56084	3321	372328	2014-04-10	2014-04-10 00:00:00	2017-01-30	2017-01-30 00:00:00	32020		\N	220527	0	65363002	372328		0
56214	3332	4266809	1999-04-16	1999-04-16 00:00:00	\N	\N	32020		\N	221127	0	397881000	4266809		0
56358	3342	4116491	1932-07-01	1932-07-01 00:00:00	1932-08-06	1932-08-06 00:00:00	32020		\N	221589	0	301011002	4116491		0
56503	3352	4134304	1981-02-10	1981-02-10 00:00:00	1981-03-12	1981-03-12 00:00:00	32020		\N	222259	0	263102004	4134304		0
67232	3973	4112343	1976-10-13	1976-10-13 00:00:00	1976-10-25	1976-10-25 00:00:00	32020		\N	264236	0	195662009	4112343		0
56835	3371	40481087	1975-11-22	1975-11-22 00:00:00	1975-11-29	1975-11-29 00:00:00	32020		\N	223573	0	444814009	40481087		0
56947	3378	28060	1978-11-10	1978-11-10 00:00:00	1978-11-22	1978-11-22 00:00:00	32020		\N	224124	0	43878008	28060		0
46617	2774	80180	1977-09-29	1977-09-29 00:00:00	\N	\N	32020		\N	183689	0	396275006	80180		0
57319	3401	40481087	2002-06-25	2002-06-25 00:00:00	2002-07-16	2002-07-16 00:00:00	32020		\N	225596	0	444814009	40481087		0
57479	3410	372328	1966-09-13	1966-09-13 00:00:00	1967-03-22	1967-03-22 00:00:00	32020		\N	226211	0	65363002	372328		0
57683	3422	321042	1973-11-12	1973-11-12 00:00:00	\N	\N	32020		\N	226979	0	410429000	321042		0
57833	3431	4152936	2000-08-17	2000-08-17 00:00:00	2000-09-07	2000-09-07 00:00:00	32020		\N	227482	0	283385000	4152936		0
57983	3437	4142905	1921-03-09	1921-03-09 00:00:00	1921-05-08	1921-05-08 00:00:00	32020		\N	228019	0	33737001	4142905		0
58135	3443	40481087	1994-02-04	1994-02-04 00:00:00	1994-02-25	1994-02-25 00:00:00	32020		\N	228457	0	444814009	40481087		0
47762	2836	80180	2019-01-10	2019-01-10 00:00:00	\N	\N	32020		\N	188401	0	396275006	80180		0
47955	2846	40481087	1988-12-31	1988-12-31 00:00:00	1989-01-07	1989-01-07 00:00:00	32020		\N	189035	0	444814009	40481087		0
58757	3486	4112343	2005-05-07	2005-05-07 00:00:00	2005-05-14	2005-05-14 00:00:00	32020		\N	231240	0	195662009	4112343		0
48257	2861	40481087	1993-05-10	1993-05-10 00:00:00	1993-05-24	1993-05-24 00:00:00	32020		\N	190173	0	444814009	40481087		0
48414	2867	81151	1979-06-11	1979-06-11 00:00:00	1979-06-25	1979-06-25 00:00:00	32020		\N	190698	0	44465007	81151		0
59237	3513	40481087	1998-03-22	1998-03-22 00:00:00	1998-04-05	1998-04-05 00:00:00	32020		\N	233126	0	444814009	40481087		0
69933	4137	378001	1997-03-17	1997-03-17 00:00:00	1997-04-16	1997-04-16 00:00:00	32020		\N	275050	0	62106007	378001		0
48970	2898	372328	1982-04-19	1982-04-19 00:00:00	1982-06-22	1982-06-22 00:00:00	32020		\N	193100	0	65363002	372328		0
59691	3537	4278672	1980-08-01	1980-08-01 00:00:00	1980-08-31	1980-08-31 00:00:00	32020		\N	234966	0	65966004	4278672		0
59876	3547	81151	2001-03-02	2001-03-02 00:00:00	2001-03-23	2001-03-23 00:00:00	32020		\N	235542	0	44465007	81151		0
60030	3556	4283893	1984-03-22	1984-03-22 00:00:00	1984-05-17	1984-05-17 00:00:00	32020		\N	236121	0	36971009	4283893		0
60149	3561	375671	1927-08-30	1927-08-30 00:00:00	1927-09-29	1927-09-29 00:00:00	32020		\N	236469	0	62564004	375671		0
60319	3569	4294548	2005-11-30	2005-11-30 00:00:00	2006-04-12	2006-04-12 00:00:00	32020		\N	237130	0	75498004	4294548		0
49923	2950	4112343	1991-11-06	1991-11-06 00:00:00	1991-11-17	1991-11-17 00:00:00	32020		\N	196883	0	195662009	4112343		0
60648	3589	40481087	2019-02-26	2019-02-26 00:00:00	2019-03-20	2019-03-20 00:00:00	32020		\N	238409	0	444814009	40481087		0
50266	2970	4112343	1980-06-14	1980-06-14 00:00:00	1980-06-22	1980-06-22 00:00:00	32020		\N	198306	0	195662009	4112343		0
61023	3612	260139	1982-06-24	1982-06-24 00:00:00	1982-07-08	1982-07-08 00:00:00	32020		\N	239960	0	10509002	260139		0
61105	3615	4112343	1967-12-29	1967-12-29 00:00:00	1968-01-10	1968-01-10 00:00:00	32020		\N	240242	0	195662009	4112343		0
61276	3623	4027663	1976-06-12	1976-06-12 00:00:00	\N	\N	32020		\N	240867	0	13200003	4027663		0
61438	3629	28060	1961-02-24	1961-02-24 00:00:00	1961-03-09	1961-03-09 00:00:00	32020		\N	241490	0	43878008	28060		0
51073	3025	40481087	1989-07-21	1989-07-21 00:00:00	1989-08-04	1989-08-04 00:00:00	32020		\N	201614	0	444814009	40481087		0
61883	3654	4155034	1973-05-23	1973-05-23 00:00:00	1973-06-06	1973-06-06 00:00:00	32020		\N	243222	0	283371005	4155034		0
62010	3661	40481087	1982-09-18	1982-09-18 00:00:00	1982-10-02	1982-10-02 00:00:00	32020		\N	243670	0	444814009	40481087		0
62108	3667	40481087	1986-08-20	1986-08-20 00:00:00	1986-09-03	1986-09-03 00:00:00	32020		\N	243947	0	444814009	40481087		0
72888	4330	4278672	1968-09-04	1968-09-04 00:00:00	1968-11-03	1968-11-03 00:00:00	32020		\N	287260	0	65966004	4278672		0
62508	3694	260139	2017-09-14	2017-09-14 00:00:00	2017-09-21	2017-09-21 00:00:00	32020		\N	245527	0	10509002	260139		0
62595	3698	260139	2000-02-03	2000-02-03 00:00:00	2000-02-10	2000-02-10 00:00:00	32020		\N	245875	0	10509002	260139		0
62800	3708	40481087	1977-07-20	1977-07-20 00:00:00	1977-07-27	1977-07-27 00:00:00	32020		\N	246549	0	444814009	40481087		0
52440	3106	4283893	1982-07-07	1982-07-07 00:00:00	1982-08-04	1982-08-04 00:00:00	32020		\N	206548	0	36971009	4283893		0
63241	3734	260139	1952-11-04	1952-11-04 00:00:00	1952-11-18	1952-11-18 00:00:00	32020		\N	248094	0	10509002	260139		0
63383	3744	4027663	1996-12-21	1996-12-21 00:00:00	\N	\N	32020		\N	248848	0	13200003	4027663		0
63528	3752	192671	1997-12-31	1997-12-31 00:00:00	\N	\N	32020		\N	249294	0	K92.2	35208414		0
63718	3761	260139	1981-11-29	1981-11-29 00:00:00	1981-12-06	1981-12-06 00:00:00	32020		\N	250054	0	10509002	260139		0
53176	3149	260139	1982-08-05	1982-08-05 00:00:00	1982-08-12	1982-08-12 00:00:00	32020		\N	209487	0	10509002	260139		0
53451	3167	4035415	2011-09-30	2011-09-30 00:00:00	2011-10-30	2011-10-30 00:00:00	32020		\N	210553	0	239720000	4035415		0
53564	3174	40481087	2005-01-22	2005-01-22 00:00:00	2005-01-29	2005-01-29 00:00:00	32020		\N	210979	0	444814009	40481087		0
53661	3177	30753	1949-01-02	1949-01-02 00:00:00	\N	\N	32020		\N	211250	0	16761005	30753		0
43297	2579	40481087	2001-10-16	2001-10-16 00:00:00	2001-10-23	2001-10-23 00:00:00	32020		\N	170849	0	444814009	40481087		0
54039	3199	80180	2009-06-11	2009-06-11 00:00:00	\N	\N	32020		\N	212778	0	396275006	80180		0
43624	2597	4027663	2002-11-16	2002-11-16 00:00:00	\N	\N	32020		\N	171833	0	13200003	4027663		0
54324	3218	260139	1973-09-30	1973-09-30 00:00:00	1973-10-07	1973-10-07 00:00:00	32020		\N	213860	0	10509002	260139		0
43987	2617	78272	2001-03-21	2001-03-21 00:00:00	2001-04-25	2001-04-25 00:00:00	32020		\N	173098	0	70704007	78272		0
54663	3236	4112343	1951-11-03	1951-11-03 00:00:00	1951-11-12	1951-11-12 00:00:00	32020		\N	215063	0	195662009	4112343		0
54828	3246	372328	1984-08-15	1984-08-15 00:00:00	1984-10-01	1984-10-01 00:00:00	32020		\N	215796	0	65363002	372328		0
55065	3259	40481087	2011-08-08	2011-08-08 00:00:00	2011-08-22	2011-08-22 00:00:00	32020		\N	216665	0	444814009	40481087		0
65749	3887	30753	1989-12-09	1989-12-09 00:00:00	\N	\N	32020		\N	258391	0	16761005	30753		0
55337	3278	4112343	1966-03-21	1966-03-21 00:00:00	1966-03-31	1966-03-31 00:00:00	32020		\N	217754	0	195662009	4112343		0
55495	3287	4152936	1966-12-10	1966-12-10 00:00:00	1966-12-31	1966-12-31 00:00:00	32020		\N	218351	0	283385000	4152936		0
55688	3296	40481087	1985-03-21	1985-03-21 00:00:00	1985-04-11	1985-04-11 00:00:00	32020		\N	219088	0	444814009	40481087		0
45287	2693	195588	1983-12-16	1983-12-16 00:00:00	1984-01-31	1984-01-31 00:00:00	32020		\N	178427	0	38822007	195588		0
56085	3321	260139	2013-02-16	2013-02-16 00:00:00	2013-02-23	2013-02-23 00:00:00	32020		\N	220496	0	10509002	260139		0
56215	3332	40481087	1999-03-22	1999-03-22 00:00:00	1999-03-29	1999-03-29 00:00:00	32020		\N	221127	0	444814009	40481087		0
56359	3342	30753	1949-08-21	1949-08-21 00:00:00	\N	\N	32020		\N	221550	0	16761005	30753		0
56504	3352	4112343	1964-12-23	1964-12-23 00:00:00	1964-12-31	1964-12-31 00:00:00	32020		\N	222268	0	195662009	4112343		0
67233	3973	4296204	1970-05-16	1970-05-16 00:00:00	1970-05-30	1970-05-30 00:00:00	32020		\N	264216	0	403190006	4296204		0
56836	3371	372328	1981-04-21	1981-04-21 00:00:00	1981-07-31	1981-07-31 00:00:00	32020		\N	223636	0	65363002	372328		0
56948	3378	260139	1970-05-05	1970-05-05 00:00:00	1970-05-19	1970-05-19 00:00:00	32020		\N	224197	0	10509002	260139		0
46618	2774	81151	1977-04-07	1977-04-07 00:00:00	1977-04-21	1977-04-21 00:00:00	32020		\N	183689	0	44465007	81151		0
57320	3401	4112343	1977-10-23	1977-10-23 00:00:00	1977-11-03	1977-11-03 00:00:00	32020		\N	225602	0	195662009	4112343		0
57480	3410	4112343	1993-08-06	1993-08-06 00:00:00	1993-08-17	1993-08-17 00:00:00	32020		\N	226196	0	195662009	4112343		0
57685	3422	40481087	2016-11-27	2016-11-27 00:00:00	2016-12-18	2016-12-18 00:00:00	32020		\N	227004	0	444814009	40481087		0
57834	3431	381316	2001-10-17	2001-10-17 00:00:00	\N	\N	32020		\N	227443	0	230690007	381316		0
57984	3437	4134304	1915-03-13	1915-03-13 00:00:00	1915-05-12	1915-05-12 00:00:00	32020		\N	228017	0	263102004	4134304		0
58136	3443	40481087	1989-04-29	1989-04-29 00:00:00	1989-05-06	1989-05-06 00:00:00	32020		\N	228483	0	444814009	40481087		0
47763	2836	81151	1991-11-24	1991-11-24 00:00:00	1991-12-15	1991-12-15 00:00:00	32020		\N	188374	0	44465007	81151		0
47956	2846	40481087	1999-09-19	1999-09-19 00:00:00	1999-10-10	1999-10-10 00:00:00	32020		\N	188994	0	444814009	40481087		0
58758	3486	28060	1964-01-17	1964-01-17 00:00:00	1964-01-26	1964-01-26 00:00:00	32020		\N	231226	0	43878008	28060		0
48258	2861	4155034	1982-03-30	1982-03-30 00:00:00	1982-04-20	1982-04-20 00:00:00	32020		\N	190183	0	283371005	4155034		0
48415	2867	260139	2003-10-05	2003-10-05 00:00:00	2003-10-19	2003-10-19 00:00:00	32020		\N	190704	0	10509002	260139		0
59238	3513	4155034	1992-12-13	1992-12-13 00:00:00	1992-12-27	1992-12-27 00:00:00	32020		\N	233118	0	283371005	4155034		0
69934	4137	40481087	1964-04-14	1964-04-14 00:00:00	1964-04-28	1964-04-28 00:00:00	32020		\N	275047	0	444814009	40481087		0
59429	3526	4142905	1972-08-17	1972-08-17 00:00:00	1972-09-16	1972-09-16 00:00:00	32020		\N	234003	0	33737001	4142905		0
59692	3537	81151	1974-12-05	1974-12-05 00:00:00	1975-01-02	1975-01-02 00:00:00	32020		\N	234963	0	44465007	81151		0
59877	3547	192671	2014-07-17	2014-07-17 00:00:00	\N	\N	32020		\N	235600	0	K92.2	35208414		0
60031	3556	40481087	1988-05-31	1988-05-31 00:00:00	1988-06-14	1988-06-14 00:00:00	32020		\N	236141	0	444814009	40481087		0
60150	3561	4112343	1974-04-19	1974-04-19 00:00:00	1974-04-28	1974-04-28 00:00:00	32020		\N	236486	0	195662009	4112343		0
60320	3569	260139	1977-01-14	1977-01-14 00:00:00	1977-01-28	1977-01-28 00:00:00	32020		\N	237178	0	10509002	260139		0
49924	2950	4218389	1999-04-05	1999-04-05 00:00:00	1999-04-26	1999-04-26 00:00:00	32020		\N	196940	0	39848009	4218389		0
60660	3592	40481087	1981-10-26	1981-10-26 00:00:00	1981-11-09	1981-11-09 00:00:00	32020		\N	238570	0	444814009	40481087		0
50267	2970	40481087	1977-12-14	1977-12-14 00:00:00	1977-12-28	1977-12-28 00:00:00	32020		\N	198322	0	444814009	40481087		0
61024	3612	40481087	1998-01-10	1998-01-10 00:00:00	1998-01-17	1998-01-17 00:00:00	32020		\N	239937	0	444814009	40481087		0
61106	3615	4112343	1965-08-31	1965-08-31 00:00:00	1965-09-07	1965-09-07 00:00:00	32020		\N	240212	0	195662009	4112343		0
61277	3623	4296204	1966-03-18	1966-03-18 00:00:00	1966-04-08	1966-04-08 00:00:00	32020		\N	240934	0	403190006	4296204		0
61439	3629	372328	1957-06-13	1957-06-13 00:00:00	1957-10-28	1957-10-28 00:00:00	32020		\N	241463	0	65363002	372328		0
51074	3025	260139	1996-05-16	1996-05-16 00:00:00	1996-05-30	1996-05-30 00:00:00	32020		\N	201675	0	10509002	260139		0
61884	3654	4296204	2016-10-18	2016-10-18 00:00:00	2016-11-21	2016-11-21 00:00:00	32020		\N	243224	0	403190006	4296204		0
62011	3661	30753	2014-12-25	2014-12-25 00:00:00	\N	\N	32020		\N	243691	0	16761005	30753		0
62109	3667	40481087	1990-03-24	1990-03-24 00:00:00	1990-03-31	1990-03-31 00:00:00	32020		\N	243984	0	444814009	40481087		0
72889	4331	40481087	2012-10-05	2012-10-05 00:00:00	2012-10-26	2012-10-26 00:00:00	32020		\N	287299	0	444814009	40481087		0
62509	3694	4112343	1996-04-14	1996-04-14 00:00:00	1996-04-21	1996-04-21 00:00:00	32020		\N	245517	0	195662009	4112343		0
62596	3698	260139	1996-03-16	1996-03-16 00:00:00	1996-03-23	1996-03-23 00:00:00	32020		\N	245858	0	10509002	260139		0
62801	3708	40481087	1984-07-28	1984-07-28 00:00:00	1984-08-11	1984-08-11 00:00:00	32020		\N	246504	0	444814009	40481087		0
52441	3106	40481087	2006-05-20	2006-05-20 00:00:00	2006-05-27	2006-05-27 00:00:00	32020		\N	206569	0	444814009	40481087		0
63242	3734	4112343	2019-05-20	2019-05-20 00:00:00	2019-05-30	2019-05-30 00:00:00	32020		\N	248156	0	195662009	4112343		0
63384	3744	4112343	2012-01-13	2012-01-13 00:00:00	2012-01-22	2012-01-22 00:00:00	32020		\N	248785	0	195662009	4112343		0
63529	3752	195588	1995-12-03	1995-12-03 00:00:00	1996-01-14	1996-01-14 00:00:00	32020		\N	249308	0	38822007	195588		0
63719	3761	372328	1961-11-16	1961-11-16 00:00:00	1962-04-07	1962-04-07 00:00:00	32020		\N	250115	0	65363002	372328		0
53177	3149	4134304	1961-12-13	1961-12-13 00:00:00	1962-01-12	1962-01-12 00:00:00	32020		\N	209565	0	263102004	4134304		0
53452	3168	260139	2012-06-09	2012-06-09 00:00:00	2012-06-16	2012-06-16 00:00:00	32020		\N	210614	0	10509002	260139		0
53565	3175	28060	1999-05-16	1999-05-16 00:00:00	1999-05-28	1999-05-28 00:00:00	32020		\N	211007	0	43878008	28060		0
53662	3177	4116491	1948-09-04	1948-09-04 00:00:00	1948-10-25	1948-10-25 00:00:00	32020		\N	211250	0	301011002	4116491		0
43298	2579	80180	1992-04-30	1992-04-30 00:00:00	\N	\N	32020		\N	170842	0	396275006	80180		0
54040	3199	40481087	2003-09-12	2003-09-12 00:00:00	2003-10-03	2003-10-03 00:00:00	32020		\N	212741	0	444814009	40481087		0
43625	2598	81151	1988-08-22	1988-08-22 00:00:00	1988-09-26	1988-09-26 00:00:00	32020		\N	171922	0	44465007	81151		0
54325	3218	40481087	1973-06-26	1973-06-26 00:00:00	1973-07-17	1973-07-17 00:00:00	32020		\N	213859	0	444814009	40481087		0
43988	2617	257012	2009-07-30	2009-07-30 00:00:00	\N	\N	32020		\N	173084	0	40055000	257012		0
54664	3236	4218389	1979-12-06	1979-12-06 00:00:00	1980-01-10	1980-01-10 00:00:00	32020		\N	215028	0	39848009	4218389		0
54829	3246	4027663	2009-10-14	2009-10-14 00:00:00	\N	\N	32020		\N	215824	0	13200003	4027663		0
55066	3260	260139	1994-03-31	1994-03-31 00:00:00	1994-04-14	1994-04-14 00:00:00	32020		\N	216706	0	10509002	260139		0
65750	3887	4266809	1990-04-08	1990-04-08 00:00:00	\N	\N	32020		\N	258391	0	397881000	4266809		0
55338	3278	78272	2011-02-25	2011-02-25 00:00:00	2011-04-01	2011-04-01 00:00:00	32020		\N	217747	0	70704007	78272		0
55496	3287	4116491	1988-06-29	1988-06-29 00:00:00	1988-08-17	1988-08-17 00:00:00	32020		\N	218390	0	301011002	4116491		0
55689	3296	372328	1937-11-02	1937-11-02 00:00:00	1937-12-03	1937-12-03 00:00:00	32020		\N	218991	0	65363002	372328		0
45288	2693	4056621	1983-12-16	1983-12-16 00:00:00	\N	\N	32020		\N	178427	0	197927001	4056621		0
56086	3321	40481087	2014-01-31	2014-01-31 00:00:00	2014-02-07	2014-02-07 00:00:00	32020		\N	220503	0	444814009	40481087		0
56216	3332	80180	1999-04-16	1999-04-16 00:00:00	\N	\N	32020		\N	221127	0	396275006	80180		0
56360	3342	4310024	1949-02-22	1949-02-22 00:00:00	\N	\N	32020		\N	221550	0	424802006	4310024		0
56505	3352	192671	2003-08-02	2003-08-02 00:00:00	\N	\N	32020		\N	222324	0	K92.2	35208414		0
67234	3973	4112343	1991-10-07	1991-10-07 00:00:00	1991-10-15	1991-10-15 00:00:00	32020		\N	264179	0	195662009	4112343		0
56837	3371	78272	1983-12-01	1983-12-01 00:00:00	1983-12-29	1983-12-29 00:00:00	32020		\N	223670	0	70704007	78272		0
56949	3378	372328	1961-09-11	1961-09-11 00:00:00	1962-06-30	1962-06-30 00:00:00	32020		\N	224167	0	65363002	372328		0
46619	2774	4112343	1945-02-25	1945-02-25 00:00:00	1945-03-05	1945-03-05 00:00:00	32020		\N	183637	0	195662009	4112343		0
57321	3401	81151	1995-05-31	1995-05-31 00:00:00	1995-06-28	1995-06-28 00:00:00	32020		\N	225625	0	44465007	81151		0
57481	3410	40481087	1999-04-08	1999-04-08 00:00:00	1999-04-22	1999-04-22 00:00:00	32020		\N	226208	0	444814009	40481087		0
57686	3422	4294548	1970-01-09	1970-01-09 00:00:00	1970-02-20	1970-02-20 00:00:00	32020		\N	226985	0	75498004	4294548		0
57835	3431	80180	1999-05-19	1999-05-19 00:00:00	\N	\N	32020		\N	227405	0	396275006	80180		0
57985	3437	40481087	1928-07-03	1928-07-03 00:00:00	1928-07-17	1928-07-17 00:00:00	32020		\N	227984	0	444814009	40481087		0
58137	3443	4294548	1992-10-22	1992-10-22 00:00:00	1992-12-16	1992-12-16 00:00:00	32020		\N	228509	0	75498004	4294548		0
47764	2836	40481087	2002-04-13	2002-04-13 00:00:00	2002-05-04	2002-05-04 00:00:00	32020		\N	188399	0	444814009	40481087		0
47957	2846	40481087	2017-05-13	2017-05-13 00:00:00	2017-06-03	2017-06-03 00:00:00	32020		\N	189015	0	444814009	40481087		0
58759	3486	80180	2000-12-24	2000-12-24 00:00:00	\N	\N	32020		\N	231264	0	396275006	80180		0
48259	2861	4283893	1965-03-05	1965-03-05 00:00:00	1965-04-16	1965-04-16 00:00:00	32020		\N	190226	0	36971009	4283893		0
48416	2867	4112343	1982-11-11	1982-11-11 00:00:00	1982-11-21	1982-11-21 00:00:00	32020		\N	190701	0	195662009	4112343		0
59239	3513	4112343	1985-12-04	1985-12-04 00:00:00	1985-12-12	1985-12-12 00:00:00	32020		\N	233129	0	195662009	4112343		0
69935	4137	40481087	1987-04-17	1987-04-17 00:00:00	1987-04-24	1987-04-24 00:00:00	32020		\N	275049	0	444814009	40481087		0
59430	3526	40481087	1950-05-05	1950-05-05 00:00:00	1950-05-12	1950-05-12 00:00:00	32020		\N	233943	0	444814009	40481087		0
59693	3537	4112343	1989-10-30	1989-10-30 00:00:00	1989-11-08	1989-11-08 00:00:00	32020		\N	234970	0	195662009	4112343		0
59878	3547	40481087	1980-02-15	1980-02-15 00:00:00	1980-02-22	1980-02-22 00:00:00	32020		\N	235566	0	444814009	40481087		0
60032	3556	40481087	2003-01-26	2003-01-26 00:00:00	2003-02-16	2003-02-16 00:00:00	32020		\N	236104	0	444814009	40481087		0
60151	3561	4283893	1945-02-07	1945-02-07 00:00:00	1945-03-28	1945-03-28 00:00:00	32020		\N	236500	0	36971009	4283893		0
60321	3569	40481087	1964-11-09	1964-11-09 00:00:00	1964-11-16	1964-11-16 00:00:00	32020		\N	237189	0	444814009	40481087		0
49925	2950	28060	1993-01-13	1993-01-13 00:00:00	1993-01-20	1993-01-20 00:00:00	32020		\N	196989	0	43878008	28060		0
60661	3592	4142905	1978-09-07	1978-09-07 00:00:00	1978-11-06	1978-11-06 00:00:00	32020		\N	238591	0	33737001	4142905		0
50268	2970	40481087	1991-10-07	1991-10-07 00:00:00	1991-10-14	1991-10-14 00:00:00	32020		\N	198347	0	444814009	40481087		0
61025	3612	28060	1996-01-11	1996-01-11 00:00:00	1996-01-20	1996-01-20 00:00:00	32020		\N	239936	0	43878008	28060		0
61107	3615	40481087	1980-10-08	1980-10-08 00:00:00	1980-10-22	1980-10-22 00:00:00	32020		\N	240170	0	444814009	40481087		0
61278	3623	40481087	1996-08-05	1996-08-05 00:00:00	1996-08-12	1996-08-12 00:00:00	32020		\N	240858	0	444814009	40481087		0
61440	3630	40481087	1986-07-31	1986-07-31 00:00:00	1986-08-21	1986-08-21 00:00:00	32020		\N	241560	0	444814009	40481087		0
51075	3025	4112343	1985-05-01	1985-05-01 00:00:00	1985-05-14	1985-05-14 00:00:00	32020		\N	201717	0	195662009	4112343		0
61885	3654	4027663	1998-06-26	1998-06-26 00:00:00	\N	\N	32020		\N	243213	0	13200003	4027663		0
62012	3661	4285898	2015-03-25	2015-03-25 00:00:00	\N	\N	32020		\N	243691	0	68496003	4285898		0
62110	3667	40481087	1971-05-26	1971-05-26 00:00:00	1971-06-09	1971-06-09 00:00:00	32020		\N	243935	0	444814009	40481087		0
72890	4331	40481087	1977-09-07	1977-09-07 00:00:00	1977-09-14	1977-09-14 00:00:00	32020		\N	287328	0	444814009	40481087		0
62510	3694	81893	1993-10-27	1993-10-27 00:00:00	\N	\N	32020		\N	245564	0	64766004	81893		0
62597	3698	28060	2004-06-26	2004-06-26 00:00:00	2004-07-05	2004-07-05 00:00:00	32020		\N	245830	0	43878008	28060		0
62802	3708	4112343	1996-10-29	1996-10-29 00:00:00	1996-11-06	1996-11-06 00:00:00	32020		\N	246570	0	195662009	4112343		0
52442	3106	40481087	1966-08-23	1966-08-23 00:00:00	1966-08-30	1966-08-30 00:00:00	32020		\N	206568	0	444814009	40481087		0
73705	4380	260139	1977-04-23	1977-04-23 00:00:00	1977-04-30	1977-04-30 00:00:00	32020		\N	291030	0	10509002	260139		0
63385	3744	4237458	1990-11-08	1990-11-08 00:00:00	1991-02-06	1991-02-06 00:00:00	32020		\N	248851	0	58150001	4237458		0
63530	3752	4112343	1966-03-14	1966-03-14 00:00:00	1966-03-26	1966-03-26 00:00:00	32020		\N	249296	0	195662009	4112343		0
74219	4408	80180	2017-09-05	2017-09-05 00:00:00	\N	\N	32020		\N	293029	0	396275006	80180		0
53178	3149	28060	1968-10-17	1968-10-17 00:00:00	1968-10-30	1968-10-30 00:00:00	32020		\N	209524	0	43878008	28060		0
63911	3776	4112343	2008-01-23	2008-01-23 00:00:00	2008-01-30	2008-01-30 00:00:00	32020		\N	250985	0	195662009	4112343		0
53566	3175	4116491	2006-11-11	2006-11-11 00:00:00	2006-12-24	2006-12-24 00:00:00	32020		\N	211020	0	301011002	4116491		0
53663	3177	4230399	2008-02-18	2008-02-18 00:00:00	2008-03-19	2008-03-19 00:00:00	32020		\N	211351	0	359817006	4230399		0
43299	2579	4266809	1992-04-30	1992-04-30 00:00:00	\N	\N	32020		\N	170842	0	397881000	4266809		0
54041	3199	378001	1986-05-21	1986-05-21 00:00:00	1986-07-20	1986-07-20 00:00:00	32020		\N	212769	0	62106007	378001		0
43626	2598	260139	1994-02-24	1994-02-24 00:00:00	1994-03-03	1994-03-03 00:00:00	32020		\N	171894	0	10509002	260139		0
54326	3218	372328	1960-10-21	1960-10-21 00:00:00	1961-10-08	1961-10-08 00:00:00	32020		\N	213817	0	65363002	372328		0
43989	2617	378001	1970-08-31	1970-08-31 00:00:00	1970-09-30	1970-09-30 00:00:00	32020		\N	173097	0	62106007	378001		0
54665	3236	4278672	2013-10-09	2013-10-09 00:00:00	2013-11-08	2013-11-08 00:00:00	32020		\N	215033	0	65966004	4278672		0
54830	3246	192671	2017-02-16	2017-02-16 00:00:00	\N	\N	32020		\N	215818	0	K92.2	35208414		0
55067	3260	260139	1983-02-02	1983-02-02 00:00:00	1983-02-09	1983-02-09 00:00:00	32020		\N	216759	0	10509002	260139		0
65751	3887	80180	1990-04-08	1990-04-08 00:00:00	\N	\N	32020		\N	258391	0	396275006	80180		0
55339	3278	4237458	1977-02-02	1977-02-02 00:00:00	1977-03-04	1977-03-04 00:00:00	32020		\N	217745	0	58150001	4237458		0
55497	3287	40481087	2009-12-16	2009-12-16 00:00:00	2009-12-30	2009-12-30 00:00:00	32020		\N	218393	0	444814009	40481087		0
55690	3296	40481087	2018-06-22	2018-06-22 00:00:00	2018-07-06	2018-07-06 00:00:00	32020		\N	218989	0	444814009	40481087		0
45289	2693	257012	1972-04-04	1972-04-04 00:00:00	\N	\N	32020		\N	178373	0	40055000	257012		0
56087	3321	4146173	2013-05-04	2013-05-04 00:00:00	2013-07-10	2013-07-10 00:00:00	32020		\N	220497	0	307731004	4146173		0
56217	3332	260139	1976-07-31	1976-07-31 00:00:00	1976-08-07	1976-08-07 00:00:00	32020		\N	221069	0	10509002	260139		0
56361	3342	40481087	1947-12-26	1947-12-26 00:00:00	1948-01-16	1948-01-16 00:00:00	32020		\N	221550	0	444814009	40481087		0
56506	3352	78272	1975-06-28	1975-06-28 00:00:00	1975-07-12	1975-07-12 00:00:00	32020		\N	222258	0	70704007	78272		0
67235	3973	4310024	2002-02-12	2002-02-12 00:00:00	\N	\N	32020		\N	264199	0	424802006	4310024		0
56838	3371	40481087	1983-02-25	1983-02-25 00:00:00	1983-03-11	1983-03-11 00:00:00	32020		\N	223625	0	444814009	40481087		0
56951	3378	321042	2014-05-10	2014-05-10 00:00:00	\N	\N	32020		\N	224131	0	410429000	321042		0
46620	2774	40481087	2015-05-28	2015-05-28 00:00:00	2015-06-11	2015-06-11 00:00:00	32020		\N	183680	0	444814009	40481087		0
57322	3401	372328	1962-10-30	1962-10-30 00:00:00	1963-07-28	1963-07-28 00:00:00	32020		\N	225648	0	65363002	372328		0
57482	3410	28060	1970-10-14	1970-10-14 00:00:00	1970-10-23	1970-10-23 00:00:00	32020		\N	226206	0	43878008	28060		0
57687	3422	80180	2001-08-27	2001-08-27 00:00:00	\N	\N	32020		\N	227013	0	396275006	80180		0
57836	3431	4152936	1975-11-22	1975-11-22 00:00:00	1975-12-06	1975-12-06 00:00:00	32020		\N	227475	0	283385000	4152936		0
57986	3437	40481087	1921-04-25	1921-04-25 00:00:00	1921-05-09	1921-05-09 00:00:00	32020		\N	228004	0	444814009	40481087		0
58138	3443	372328	1981-10-28	1981-10-28 00:00:00	1982-09-29	1982-09-29 00:00:00	32020		\N	228498	0	65363002	372328		0
47765	2836	4294548	1999-10-14	1999-10-14 00:00:00	1999-11-18	1999-11-18 00:00:00	32020		\N	188403	0	75498004	4294548		0
47958	2846	80180	2017-08-28	2017-08-28 00:00:00	\N	\N	32020		\N	189015	0	396275006	80180		0
58760	3486	40481087	2010-01-30	2010-01-30 00:00:00	2010-02-13	2010-02-13 00:00:00	32020		\N	231241	0	444814009	40481087		0
48260	2861	4112343	1981-11-27	1981-11-27 00:00:00	1981-12-04	1981-12-04 00:00:00	32020		\N	190195	0	195662009	4112343		0
48417	2867	4134304	1988-06-07	1988-06-07 00:00:00	1988-07-07	1988-07-07 00:00:00	32020		\N	190700	0	263102004	4134304		0
59240	3513	372328	1976-07-26	1976-07-26 00:00:00	1976-10-24	1976-10-24 00:00:00	32020		\N	233105	0	65363002	372328		0
69936	4137	4296204	2013-02-17	2013-02-17 00:00:00	2013-03-17	2013-03-17 00:00:00	32020		\N	275054	0	403190006	4296204		0
59431	3526	4283893	1961-10-31	1961-10-31 00:00:00	1961-12-26	1961-12-26 00:00:00	32020		\N	233905	0	36971009	4283893		0
59694	3537	40481087	1985-04-12	1985-04-12 00:00:00	1985-04-26	1985-04-26 00:00:00	32020		\N	234896	0	444814009	40481087		0
59879	3547	4059173	1977-12-03	1977-12-03 00:00:00	1978-01-02	1978-01-02 00:00:00	32020		\N	235540	0	16114001	4059173		0
60033	3556	40481087	1983-09-24	1983-09-24 00:00:00	1983-10-15	1983-10-15 00:00:00	32020		\N	236118	0	444814009	40481087		0
60152	3561	4112343	1930-04-01	1930-04-01 00:00:00	1930-04-09	1930-04-09 00:00:00	32020		\N	236506	0	195662009	4112343		0
60322	3569	260139	2011-07-15	2011-07-15 00:00:00	2011-07-22	2011-07-22 00:00:00	32020		\N	237162	0	10509002	260139		0
49926	2950	40481087	1955-10-29	1955-10-29 00:00:00	1955-11-12	1955-11-12 00:00:00	32020		\N	196969	0	444814009	40481087		0
60662	3592	4116491	2016-01-15	2016-01-15 00:00:00	2016-02-25	2016-02-25 00:00:00	32020		\N	238618	0	301011002	4116491		0
50269	2970	40481087	2008-01-02	2008-01-02 00:00:00	2008-01-23	2008-01-23 00:00:00	32020		\N	198386	0	444814009	40481087		0
61026	3612	260139	1995-05-15	1995-05-15 00:00:00	1995-05-22	1995-05-22 00:00:00	32020		\N	239935	0	10509002	260139		0
61108	3615	81151	1960-09-02	1960-09-02 00:00:00	1960-10-07	1960-10-07 00:00:00	32020		\N	240216	0	44465007	81151		0
61279	3623	4109685	2013-01-30	2013-01-30 00:00:00	2013-02-13	2013-02-13 00:00:00	32020		\N	240940	0	284551006	4109685		0
61441	3630	260139	2015-09-15	2015-09-15 00:00:00	2015-09-22	2015-09-22 00:00:00	32020		\N	241517	0	10509002	260139		0
51076	3025	40481087	1961-12-13	1961-12-13 00:00:00	1961-12-27	1961-12-27 00:00:00	32020		\N	201563	0	444814009	40481087		0
61886	3654	4001336	1974-07-01	1974-07-01 00:00:00	1974-07-31	1974-07-31 00:00:00	32020		\N	243223	0	110030002	4001336		0
62013	3661	81893	2014-04-29	2014-04-29 00:00:00	\N	\N	32020		\N	243690	0	64766004	81893		0
62111	3667	260139	2012-12-04	2012-12-04 00:00:00	2012-12-18	2012-12-18 00:00:00	32020		\N	243949	0	10509002	260139		0
72891	4331	40481087	2004-07-30	2004-07-30 00:00:00	2004-08-06	2004-08-06 00:00:00	32020		\N	287283	0	444814009	40481087		0
62511	3694	4310024	1993-05-30	1993-05-30 00:00:00	\N	\N	32020		\N	245564	0	424802006	4310024		0
62598	3698	28060	1963-12-07	1963-12-07 00:00:00	1963-12-17	1963-12-17 00:00:00	32020		\N	245856	0	43878008	28060		0
62803	3708	4113008	2011-01-15	2011-01-15 00:00:00	2011-02-05	2011-02-05 00:00:00	32020		\N	246498	0	284549007	4113008		0
52443	3106	80180	1990-03-22	1990-03-22 00:00:00	\N	\N	32020		\N	206581	0	396275006	80180		0
73706	4380	4142905	1970-05-19	1970-05-19 00:00:00	1970-07-18	1970-07-18 00:00:00	32020		\N	290995	0	33737001	4142905		0
63386	3744	40481087	2018-01-14	2018-01-14 00:00:00	2018-01-28	2018-01-28 00:00:00	32020		\N	248816	0	444814009	40481087		0
63531	3752	372328	1962-11-05	1962-11-05 00:00:00	1962-11-19	1962-11-19 00:00:00	32020		\N	249356	0	65363002	372328		0
74220	4408	4112343	2015-09-07	2015-09-07 00:00:00	2015-09-15	2015-09-15 00:00:00	32020		\N	293029	0	195662009	4112343		0
53179	3149	80180	1989-10-31	1989-10-31 00:00:00	\N	\N	32020		\N	209534	0	396275006	80180		0
63912	3776	4149245	2010-11-20	2010-11-20 00:00:00	2011-01-26	2011-01-26 00:00:00	32020		\N	250981	0	30832001	4149245		0
53567	3175	375671	1978-05-17	1978-05-17 00:00:00	1978-06-16	1978-06-16 00:00:00	32020		\N	211052	0	62564004	375671		0
53664	3177	40480160	2008-02-18	2008-02-18 00:00:00	2008-03-19	2008-03-19 00:00:00	32020		\N	211351	0	443165006	40480160		0
43300	2579	4116491	1987-05-13	1987-05-13 00:00:00	1987-06-24	1987-06-24 00:00:00	32020		\N	170794	0	301011002	4116491		0
54042	3199	372328	1975-08-19	1975-08-19 00:00:00	1976-01-07	1976-01-07 00:00:00	32020		\N	212733	0	65363002	372328		0
43627	2598	40481087	1986-09-07	1986-09-07 00:00:00	1986-09-14	1986-09-14 00:00:00	32020		\N	171889	0	444814009	40481087		0
54327	3218	80180	1992-10-04	1992-10-04 00:00:00	\N	\N	32020		\N	213824	0	396275006	80180		0
54449	3224	40481087	1987-10-14	1987-10-14 00:00:00	1987-10-21	1987-10-21 00:00:00	32020		\N	214398	0	444814009	40481087		0
54666	3236	4278672	1930-07-28	1930-07-28 00:00:00	1930-10-26	1930-10-26 00:00:00	32020		\N	215026	0	65966004	4278672		0
54831	3246	440086	1989-10-19	1989-10-19 00:00:00	1997-10-27	1997-10-27 00:00:00	32020		\N	215790	0	192127007	440086		0
55068	3260	4112343	1987-10-21	1987-10-21 00:00:00	1987-10-30	1987-10-30 00:00:00	32020		\N	216760	0	195662009	4112343		0
65752	3887	4285898	1990-03-09	1990-03-09 00:00:00	\N	\N	32020		\N	258391	0	68496003	4285898		0
55340	3278	4027663	1986-04-12	1986-04-12 00:00:00	\N	\N	32020		\N	217768	0	13200003	4027663		0
55498	3287	40481087	2016-07-31	2016-07-31 00:00:00	2016-08-07	2016-08-07 00:00:00	32020		\N	218369	0	444814009	40481087		0
55691	3296	192671	1980-07-15	1980-07-15 00:00:00	\N	\N	32020		\N	219061	0	K92.2	35208414		0
45290	2693	260139	2014-01-03	2014-01-03 00:00:00	2014-01-17	2014-01-17 00:00:00	32020		\N	178430	0	10509002	260139		0
56088	3321	40481087	2007-05-09	2007-05-09 00:00:00	2007-05-16	2007-05-16 00:00:00	32020		\N	220526	0	444814009	40481087		0
56218	3332	40481087	1987-02-03	1987-02-03 00:00:00	1987-02-17	1987-02-17 00:00:00	32020		\N	221087	0	444814009	40481087		0
56362	3342	81893	1949-05-23	1949-05-23 00:00:00	\N	\N	32020		\N	221550	0	64766004	81893		0
56507	3352	4027663	1993-10-16	1993-10-16 00:00:00	\N	\N	32020		\N	222301	0	13200003	4027663		0
67236	3973	81893	2002-04-13	2002-04-13 00:00:00	\N	\N	32020		\N	264199	0	64766004	81893		0
56839	3371	40481087	1996-05-09	1996-05-09 00:00:00	1996-05-23	1996-05-23 00:00:00	32020		\N	223569	0	444814009	40481087		0
56952	3378	4112343	1974-07-22	1974-07-22 00:00:00	1974-07-30	1974-07-30 00:00:00	32020		\N	224198	0	195662009	4112343		0
46621	2774	40481087	1940-05-27	1940-05-27 00:00:00	1940-06-03	1940-06-03 00:00:00	32020		\N	183636	0	444814009	40481087		0
57323	3401	4146173	1983-11-16	1983-11-16 00:00:00	1983-12-16	1983-12-16 00:00:00	32020		\N	225594	0	307731004	4146173		0
57483	3410	80180	2002-06-20	2002-06-20 00:00:00	\N	\N	32020		\N	226161	0	396275006	80180		0
57688	3422	40481087	1999-08-04	1999-08-04 00:00:00	1999-08-18	1999-08-18 00:00:00	32020		\N	227013	0	444814009	40481087		0
57837	3431	28060	1967-10-15	1967-10-15 00:00:00	1967-10-28	1967-10-28 00:00:00	32020		\N	227446	0	43878008	28060		0
57987	3437	195588	1946-04-19	1946-04-19 00:00:00	1946-05-23	1946-05-23 00:00:00	32020		\N	227985	0	38822007	195588		0
58139	3444	4116491	1996-10-16	1996-10-16 00:00:00	1996-11-24	1996-11-24 00:00:00	32020		\N	228539	0	301011002	4116491		0
47766	2836	28060	2001-02-02	2001-02-02 00:00:00	2001-02-13	2001-02-13 00:00:00	32020		\N	188387	0	43878008	28060		0
47959	2846	4155034	1984-02-07	1984-02-07 00:00:00	1984-02-21	1984-02-21 00:00:00	32020		\N	188990	0	283371005	4155034		0
58761	3486	4112343	1974-09-03	1974-09-03 00:00:00	1974-09-12	1974-09-12 00:00:00	32020		\N	231231	0	195662009	4112343		0
48261	2861	40481087	1995-09-18	1995-09-18 00:00:00	1995-10-09	1995-10-09 00:00:00	32020		\N	190174	0	444814009	40481087		0
48418	2867	257012	1992-12-25	1992-12-25 00:00:00	1993-01-22	1993-01-22 00:00:00	32020		\N	190702	0	40055000	257012		0
59241	3513	40481087	1975-05-11	1975-05-11 00:00:00	1975-06-01	1975-06-01 00:00:00	32020		\N	233103	0	444814009	40481087		0
69937	4137	80180	2002-07-09	2002-07-09 00:00:00	\N	\N	32020		\N	275017	0	396275006	80180		0
59432	3526	4112343	2013-06-01	2013-06-01 00:00:00	2013-06-14	2013-06-14 00:00:00	32020		\N	233946	0	195662009	4112343		0
59695	3537	4084167	1962-06-20	1962-06-20 00:00:00	1962-06-20	1962-06-20 00:00:00	32020		\N	234981	0	241929008	4084167		0
59887	3549	40481087	2002-02-20	2002-02-20 00:00:00	2002-03-06	2002-03-06 00:00:00	32020		\N	235685	0	444814009	40481087		0
60034	3556	80180	2013-10-01	2013-10-01 00:00:00	\N	\N	32020		\N	236116	0	396275006	80180		0
60153	3561	4112343	1946-10-23	1946-10-23 00:00:00	1946-11-03	1946-11-03 00:00:00	32020		\N	236497	0	195662009	4112343		0
60323	3569	4112343	1979-09-18	1979-09-18 00:00:00	1979-09-25	1979-09-25 00:00:00	32020		\N	237179	0	195662009	4112343		0
49927	2950	4218389	2005-06-23	2005-06-23 00:00:00	2005-07-28	2005-07-28 00:00:00	32020		\N	196942	0	39848009	4218389		0
60663	3592	4112343	2017-06-29	2017-06-29 00:00:00	2017-07-07	2017-07-07 00:00:00	32020		\N	238633	0	195662009	4112343		0
50270	2970	40481087	1994-06-06	1994-06-06 00:00:00	1994-06-20	1994-06-20 00:00:00	32020		\N	198323	0	444814009	40481087		0
61027	3612	28060	2017-06-02	2017-06-02 00:00:00	2017-06-13	2017-06-13 00:00:00	32020		\N	239963	0	43878008	28060		0
61109	3615	4112343	1951-11-22	1951-11-22 00:00:00	1951-12-02	1951-12-02 00:00:00	32020		\N	240177	0	195662009	4112343		0
61280	3623	78272	2011-04-15	2011-04-15 00:00:00	2011-05-06	2011-05-06 00:00:00	32020		\N	240938	0	70704007	78272		0
61442	3630	40481087	1970-08-11	1970-08-11 00:00:00	1970-08-25	1970-08-25 00:00:00	32020		\N	241564	0	444814009	40481087		0
51077	3025	40481087	1991-10-28	1991-10-28 00:00:00	1991-11-04	1991-11-04 00:00:00	32020		\N	201594	0	444814009	40481087		0
61887	3654	4132546	1974-07-01	1974-07-01 00:00:00	\N	\N	32020		\N	243223	0	275272006	4166590		0
62014	3661	40481087	2013-08-18	2013-08-18 00:00:00	2013-08-25	2013-08-25 00:00:00	32020		\N	243690	0	444814009	40481087		0
62112	3667	260139	1978-03-16	1978-03-16 00:00:00	1978-03-30	1978-03-30 00:00:00	32020		\N	243965	0	10509002	260139		0
72892	4331	4112343	2005-01-09	2005-01-09 00:00:00	2005-01-17	2005-01-17 00:00:00	32020		\N	287329	0	195662009	4112343		0
62512	3694	30753	1994-03-26	1994-03-26 00:00:00	\N	\N	32020		\N	245564	0	16761005	30753		0
62599	3698	375671	2006-01-14	2006-01-14 00:00:00	2006-03-15	2006-03-15 00:00:00	32020		\N	245839	0	62564004	375671		0
62851	3714	260139	1963-01-21	1963-01-21 00:00:00	1963-01-28	1963-01-28 00:00:00	32020		\N	246766	0	10509002	260139		0
52444	3106	372328	1952-01-01	1952-01-01 00:00:00	1952-06-16	1952-06-16 00:00:00	32020		\N	206603	0	65363002	372328		0
73707	4380	192671	2001-10-25	2001-10-25 00:00:00	\N	\N	32020		\N	291070	0	K92.2	35208414		0
63387	3744	260139	1979-09-18	1979-09-18 00:00:00	1979-10-02	1979-10-02 00:00:00	32020		\N	248747	0	10509002	260139		0
63532	3752	4112343	1989-01-28	1989-01-28 00:00:00	1989-02-07	1989-02-07 00:00:00	32020		\N	249343	0	195662009	4112343		0
74221	4408	40481087	1995-10-05	1995-10-05 00:00:00	1995-10-12	1995-10-12 00:00:00	32020		\N	293021	0	444814009	40481087		0
53180	3149	40481087	1984-01-18	1984-01-18 00:00:00	1984-02-08	1984-02-08 00:00:00	32020		\N	209542	0	444814009	40481087		0
63913	3776	40481087	1996-05-09	1996-05-09 00:00:00	1996-05-16	1996-05-16 00:00:00	32020		\N	250947	0	444814009	40481087		0
53568	3175	4112343	1957-01-07	1957-01-07 00:00:00	1957-01-16	1957-01-16 00:00:00	32020		\N	211017	0	195662009	4112343		0
53665	3177	195588	1946-07-12	1946-07-12 00:00:00	1946-09-05	1946-09-05 00:00:00	32020		\N	211314	0	38822007	195588		0
43301	2579	260139	1961-05-05	1961-05-05 00:00:00	1961-05-12	1961-05-12 00:00:00	32020		\N	170807	0	10509002	260139		0
54043	3199	260139	2009-12-28	2009-12-28 00:00:00	2010-01-11	2010-01-11 00:00:00	32020		\N	212735	0	10509002	260139		0
43628	2598	4152936	2011-11-16	2011-11-16 00:00:00	2011-12-07	2011-12-07 00:00:00	32020		\N	171937	0	283385000	4152936		0
54450	3224	40481087	1963-03-05	1963-03-05 00:00:00	1963-03-26	1963-03-26 00:00:00	32020		\N	214368	0	444814009	40481087		0
54667	3236	40481087	1976-01-22	1976-01-22 00:00:00	1976-02-12	1976-02-12 00:00:00	32020		\N	215110	0	444814009	40481087		0
54832	3246	4112343	2001-06-30	2001-06-30 00:00:00	2001-07-07	2001-07-07 00:00:00	32020		\N	215805	0	195662009	4112343		0
55069	3260	40481087	1976-02-26	1976-02-26 00:00:00	1976-03-18	1976-03-18 00:00:00	32020		\N	216754	0	444814009	40481087		0
65753	3887	4112343	1957-09-20	1957-09-20 00:00:00	1957-09-27	1957-09-27 00:00:00	32020		\N	258401	0	195662009	4112343		0
55341	3278	4152936	2015-10-07	2015-10-07 00:00:00	2015-10-21	2015-10-21 00:00:00	32020		\N	217748	0	283385000	4152936		0
55499	3287	260139	2009-07-31	2009-07-31 00:00:00	2009-08-07	2009-08-07 00:00:00	32020		\N	218392	0	10509002	260139		0
55692	3296	257012	1998-01-14	1998-01-14 00:00:00	\N	\N	32020		\N	219101	0	40055000	257012		0
45291	2693	40481087	2000-01-18	2000-01-18 00:00:00	2000-01-25	2000-01-25 00:00:00	32020		\N	178407	0	444814009	40481087		0
56089	3321	40481087	2018-04-26	2018-04-26 00:00:00	2018-05-17	2018-05-17 00:00:00	32020		\N	220504	0	444814009	40481087		0
56219	3332	40481087	2016-08-13	2016-08-13 00:00:00	2016-09-03	2016-09-03 00:00:00	32020		\N	221076	0	444814009	40481087		0
56363	3342	40480160	2011-10-11	2011-10-11 00:00:00	2012-01-09	2012-01-09 00:00:00	32020		\N	221569	0	443165006	40480160		0
56508	3352	4112343	1966-11-22	1966-11-22 00:00:00	1966-12-04	1966-12-04 00:00:00	32020		\N	222292	0	195662009	4112343		0
67237	3973	30753	2002-09-10	2002-09-10 00:00:00	\N	\N	32020		\N	264199	0	16761005	30753		0
56840	3371	372328	1977-07-05	1977-07-05 00:00:00	1977-07-19	1977-07-19 00:00:00	32020		\N	223650	0	65363002	372328		0
56953	3378	257012	1966-12-29	1966-12-29 00:00:00	\N	\N	32020		\N	224173	0	40055000	257012		0
46622	2774	372328	1941-04-29	1941-04-29 00:00:00	1941-05-30	1941-05-30 00:00:00	32020		\N	183682	0	65363002	372328		0
57324	3401	260139	1960-07-13	1960-07-13 00:00:00	1960-07-27	1960-07-27 00:00:00	32020		\N	225600	0	10509002	260139		0
57484	3410	40481087	1979-06-03	1979-06-03 00:00:00	1979-06-24	1979-06-24 00:00:00	32020		\N	226194	0	444814009	40481087		0
57689	3422	4294548	1987-09-21	1987-09-21 00:00:00	1987-10-05	1987-10-05 00:00:00	32020		\N	226960	0	75498004	4294548		0
57838	3432	4218389	1986-09-25	1986-09-25 00:00:00	1986-10-16	1986-10-16 00:00:00	32020		\N	227488	0	39848009	4218389		0
57988	3438	192671	1947-03-07	1947-03-07 00:00:00	\N	\N	32020		\N	228045	0	K92.2	35208414		0
58140	3444	28060	1958-01-12	1958-01-12 00:00:00	1958-01-20	1958-01-20 00:00:00	32020		\N	228536	0	43878008	28060		0
47767	2836	4278672	1984-02-13	1984-02-13 00:00:00	1984-04-13	1984-04-13 00:00:00	32020		\N	188372	0	65966004	4278672		0
47960	2846	4112343	1982-02-14	1982-02-14 00:00:00	1982-02-25	1982-02-25 00:00:00	32020		\N	189032	0	195662009	4112343		0
58762	3486	40481087	2003-09-02	2003-09-02 00:00:00	2003-09-23	2003-09-23 00:00:00	32020		\N	231192	0	444814009	40481087		0
48262	2861	40481087	1974-12-15	1974-12-15 00:00:00	1974-12-29	1974-12-29 00:00:00	32020		\N	190180	0	444814009	40481087		0
48419	2867	40481087	2007-07-06	2007-07-06 00:00:00	2007-07-20	2007-07-20 00:00:00	32020		\N	190747	0	444814009	40481087		0
59242	3514	40481087	1978-03-10	1978-03-10 00:00:00	1978-03-17	1978-03-17 00:00:00	32020		\N	233183	0	444814009	40481087		0
69938	4137	40481087	2018-09-01	2018-09-01 00:00:00	2018-09-22	2018-09-22 00:00:00	32020		\N	274985	0	444814009	40481087		0
59433	3526	372328	1953-08-22	1953-08-22 00:00:00	1953-12-01	1953-12-01 00:00:00	32020		\N	233997	0	65363002	372328		0
59696	3537	372328	1989-11-23	1989-11-23 00:00:00	1992-11-08	1992-11-08 00:00:00	32020		\N	234957	0	65363002	372328		0
59888	3549	4113008	2015-05-31	2015-05-31 00:00:00	2015-06-21	2015-06-21 00:00:00	32020		\N	235632	0	284549007	4113008		0
60040	3558	4112343	1965-05-27	1965-05-27 00:00:00	1965-06-07	1965-06-07 00:00:00	32020		\N	236226	0	195662009	4112343		0
60154	3561	40481087	1974-11-15	1974-11-15 00:00:00	1974-11-29	1974-11-29 00:00:00	32020		\N	236560	0	444814009	40481087		0
60324	3569	4283893	2008-08-06	2008-08-06 00:00:00	2008-10-22	2008-10-22 00:00:00	32020		\N	237198	0	36971009	4283893		0
49928	2950	4112343	1952-11-23	1952-11-23 00:00:00	1952-12-03	1952-12-03 00:00:00	32020		\N	196955	0	195662009	4112343		0
60664	3592	81151	1973-12-11	1973-12-11 00:00:00	1974-01-01	1974-01-01 00:00:00	32020		\N	238590	0	44465007	81151		0
50271	2970	260139	2018-09-25	2018-09-25 00:00:00	2018-10-02	2018-10-02 00:00:00	32020		\N	198293	0	10509002	260139		0
61028	3612	4116491	2007-03-22	2007-03-22 00:00:00	2007-05-13	2007-05-13 00:00:00	32020		\N	239957	0	301011002	4116491		0
61110	3615	4112343	1994-12-23	1994-12-23 00:00:00	1995-01-03	1995-01-03 00:00:00	32020		\N	240181	0	195662009	4112343		0
61281	3623	4112343	2000-12-10	2000-12-10 00:00:00	2000-12-18	2000-12-18 00:00:00	32020		\N	240848	0	195662009	4112343		0
61443	3630	372328	1959-04-06	1959-04-06 00:00:00	1960-03-23	1960-03-23 00:00:00	32020		\N	241562	0	65363002	372328		0
51078	3025	375671	1994-11-30	1994-11-30 00:00:00	1995-01-29	1995-01-29 00:00:00	32020		\N	201585	0	62564004	375671		0
61888	3654	257012	1971-10-25	1971-10-25 00:00:00	\N	\N	32020		\N	243200	0	40055000	257012		0
62015	3661	28060	1986-07-04	1986-07-04 00:00:00	1986-07-11	1986-07-11 00:00:00	32020		\N	243673	0	43878008	28060		0
62113	3667	28060	1976-04-11	1976-04-11 00:00:00	1976-04-21	1976-04-21 00:00:00	32020		\N	243936	0	43878008	28060		0
72893	4331	4155034	1989-10-27	1989-10-27 00:00:00	1989-11-10	1989-11-10 00:00:00	32020		\N	287326	0	283371005	4155034		0
62513	3694	81151	1993-04-26	1993-04-26 00:00:00	1993-05-24	1993-05-24 00:00:00	32020		\N	245564	0	44465007	81151		0
62600	3698	260139	1952-10-28	1952-10-28 00:00:00	1952-11-11	1952-11-11 00:00:00	32020		\N	245894	0	10509002	260139		0
62852	3714	4155034	1964-01-09	1964-01-09 00:00:00	1964-01-23	1964-01-23 00:00:00	32020		\N	246848	0	283371005	4155034		0
62915	3717	4294548	2006-06-12	2006-06-12 00:00:00	2006-06-26	2006-06-26 00:00:00	32020		\N	246980	0	75498004	4294548		0
73708	4380	80180	2001-09-28	2001-09-28 00:00:00	\N	\N	32020		\N	291004	0	396275006	80180		0
63388	3744	260139	2016-03-03	2016-03-03 00:00:00	2016-03-10	2016-03-10 00:00:00	32020		\N	248835	0	10509002	260139		0
63533	3752	40481087	1986-07-06	1986-07-06 00:00:00	1986-07-13	1986-07-13 00:00:00	32020		\N	249297	0	444814009	40481087		0
74222	4408	4155034	2014-05-29	2014-05-29 00:00:00	2014-06-19	2014-06-19 00:00:00	32020		\N	293001	0	283371005	4155034		0
53181	3149	4218389	1958-02-11	1958-02-11 00:00:00	1958-03-04	1958-03-04 00:00:00	32020		\N	209563	0	39848009	4218389		0
63914	3777	260139	2012-04-09	2012-04-09 00:00:00	2012-04-23	2012-04-23 00:00:00	32020		\N	251026	0	10509002	260139		0
53569	3175	372328	1959-08-09	1959-08-09 00:00:00	1959-11-10	1959-11-10 00:00:00	32020		\N	211031	0	65363002	372328		0
53666	3177	4112343	1928-01-21	1928-01-21 00:00:00	1928-01-30	1928-01-30 00:00:00	32020		\N	211248	0	195662009	4112343		0
43302	2579	28060	1962-11-13	1962-11-13 00:00:00	1962-11-25	1962-11-25 00:00:00	32020		\N	170846	0	43878008	28060		0
54044	3199	260139	1989-05-08	1989-05-08 00:00:00	1989-05-15	1989-05-15 00:00:00	32020		\N	212734	0	10509002	260139		0
43629	2598	40481087	1977-05-29	1977-05-29 00:00:00	1977-06-19	1977-06-19 00:00:00	32020		\N	171924	0	444814009	40481087		0
54329	3218	40481087	1992-03-27	1992-03-27 00:00:00	1992-04-17	1992-04-17 00:00:00	32020		\N	213824	0	444814009	40481087		0
54451	3224	40481087	1969-06-30	1969-06-30 00:00:00	1969-07-21	1969-07-21 00:00:00	32020		\N	214396	0	444814009	40481087		0
54668	3236	4296204	1992-07-05	1992-07-05 00:00:00	1992-08-02	1992-08-02 00:00:00	32020		\N	215030	0	403190006	4296204		0
54833	3246	260139	2009-05-16	2009-05-16 00:00:00	2009-05-30	2009-05-30 00:00:00	32020		\N	215780	0	10509002	260139		0
55070	3260	4112343	1974-07-21	1974-07-21 00:00:00	1974-07-28	1974-07-28 00:00:00	32020		\N	216729	0	195662009	4112343		0
65754	3887	260139	1973-05-08	1973-05-08 00:00:00	1973-05-22	1973-05-22 00:00:00	32020		\N	258339	0	10509002	260139		0
55342	3278	40481087	2003-10-07	2003-10-07 00:00:00	2003-10-21	2003-10-21 00:00:00	32020		\N	217751	0	444814009	40481087		0
55500	3287	40481087	1981-04-12	1981-04-12 00:00:00	1981-04-26	1981-04-26 00:00:00	32020		\N	218293	0	444814009	40481087		0
55693	3296	40481087	1979-05-07	1979-05-07 00:00:00	1979-05-14	1979-05-14 00:00:00	32020		\N	218993	0	444814009	40481087		0
45292	2693	40481087	1991-02-13	1991-02-13 00:00:00	1991-02-27	1991-02-27 00:00:00	32020		\N	178406	0	444814009	40481087		0
56090	3321	40481087	1982-01-01	1982-01-01 00:00:00	1982-01-08	1982-01-08 00:00:00	32020		\N	220495	0	444814009	40481087		0
56220	3332	260139	1987-12-15	1987-12-15 00:00:00	1987-12-29	1987-12-29 00:00:00	32020		\N	221088	0	10509002	260139		0
56364	3342	4230399	2011-10-11	2011-10-11 00:00:00	2012-01-09	2012-01-09 00:00:00	32020		\N	221569	0	359817006	4230399		0
56509	3352	28060	1972-09-22	1972-09-22 00:00:00	1972-10-04	1972-10-04 00:00:00	32020		\N	222293	0	43878008	28060		0
67238	3973	4112343	2012-08-07	2012-08-07 00:00:00	2012-08-18	2012-08-18 00:00:00	32020		\N	264174	0	195662009	4112343		0
56841	3371	28060	1984-01-26	1984-01-26 00:00:00	1984-02-03	1984-02-03 00:00:00	32020		\N	223604	0	43878008	28060		0
56954	3378	260139	1965-10-08	1965-10-08 00:00:00	1965-10-22	1965-10-22 00:00:00	32020		\N	224122	0	10509002	260139		0
46632	2776	40481087	2016-01-04	2016-01-04 00:00:00	2016-01-11	2016-01-11 00:00:00	32020		\N	183812	0	444814009	40481087		0
57337	3403	40481087	1994-10-19	1994-10-19 00:00:00	1994-11-02	1994-11-02 00:00:00	32020		\N	225712	0	444814009	40481087		0
57485	3410	4112343	1967-03-02	1967-03-02 00:00:00	1967-03-14	1967-03-14 00:00:00	32020		\N	226192	0	195662009	4112343		0
57690	3422	260139	1981-03-21	1981-03-21 00:00:00	1981-04-04	1981-04-04 00:00:00	32020		\N	227025	0	10509002	260139		0
57839	3432	4218389	1964-06-03	1964-06-03 00:00:00	1964-06-24	1964-06-24 00:00:00	32020		\N	227485	0	39848009	4218389		0
57989	3438	40481087	1988-09-14	1988-09-14 00:00:00	1988-10-05	1988-10-05 00:00:00	32020		\N	228111	0	444814009	40481087		0
58141	3444	40481087	2015-07-29	2015-07-29 00:00:00	2015-08-19	2015-08-19 00:00:00	32020		\N	228589	0	444814009	40481087		0
47768	2836	28060	1985-08-09	1985-08-09 00:00:00	1985-08-22	1985-08-22 00:00:00	32020		\N	188386	0	43878008	28060		0
47961	2846	4283893	1987-09-03	1987-09-03 00:00:00	1987-10-01	1987-10-01 00:00:00	32020		\N	189034	0	36971009	4283893		0
58763	3486	4112343	1961-06-18	1961-06-18 00:00:00	1961-06-27	1961-06-27 00:00:00	32020		\N	231253	0	195662009	4112343		0
48263	2861	378001	2014-05-16	2014-05-16 00:00:00	2014-07-15	2014-07-15 00:00:00	32020		\N	190246	0	62106007	378001		0
48420	2867	40481087	2010-01-10	2010-01-10 00:00:00	2010-01-24	2010-01-24 00:00:00	32020		\N	190748	0	444814009	40481087		0
59243	3514	260139	1994-02-23	1994-02-23 00:00:00	1994-03-09	1994-03-09 00:00:00	32020		\N	233185	0	10509002	260139		0
69949	4139	40481087	1991-11-14	1991-11-14 00:00:00	1991-11-21	1991-11-21 00:00:00	32020		\N	275102	0	444814009	40481087		0
59434	3526	4112343	1986-07-16	1986-07-16 00:00:00	1986-07-26	1986-07-26 00:00:00	32020		\N	233910	0	195662009	4112343		0
59697	3537	260139	2008-06-03	2008-06-03 00:00:00	2008-06-10	2008-06-10 00:00:00	32020		\N	234939	0	10509002	260139		0
59889	3549	40481087	2004-07-02	2004-07-02 00:00:00	2004-07-09	2004-07-09 00:00:00	32020		\N	235656	0	444814009	40481087		0
60041	3558	4112343	1993-10-05	1993-10-05 00:00:00	1993-10-15	1993-10-15 00:00:00	32020		\N	236228	0	195662009	4112343		0
60155	3561	4294548	1951-10-23	1951-10-23 00:00:00	1952-01-08	1952-01-08 00:00:00	32020		\N	236502	0	75498004	4294548		0
60325	3570	4112343	1987-12-09	1987-12-09 00:00:00	1987-12-22	1987-12-22 00:00:00	32020		\N	237290	0	195662009	4112343		0
49929	2950	40481087	1987-12-12	1987-12-12 00:00:00	1987-12-19	1987-12-19 00:00:00	32020		\N	196897	0	444814009	40481087		0
60665	3592	4112343	1966-05-23	1966-05-23 00:00:00	1966-06-04	1966-06-04 00:00:00	32020		\N	238584	0	195662009	4112343		0
50272	2970	40481087	2009-01-06	2009-01-06 00:00:00	2009-01-27	2009-01-27 00:00:00	32020		\N	198388	0	444814009	40481087		0
61029	3612	28060	1967-07-12	1967-07-12 00:00:00	1967-07-22	1967-07-22 00:00:00	32020		\N	239933	0	43878008	28060		0
61111	3616	40481087	2016-09-11	2016-09-11 00:00:00	2016-10-02	2016-10-02 00:00:00	32020		\N	240274	0	444814009	40481087		0
61282	3623	260139	2005-01-06	2005-01-06 00:00:00	2005-01-20	2005-01-20 00:00:00	32020		\N	240869	0	10509002	260139		0
61444	3630	4112343	1980-02-21	1980-02-21 00:00:00	1980-03-03	1980-03-03 00:00:00	32020		\N	241559	0	195662009	4112343		0
51079	3025	4329847	2002-10-14	2002-10-14 00:00:00	\N	\N	32020		\N	201587	0	22298006	4329847		0
61889	3654	4294548	1971-09-06	1971-09-06 00:00:00	1971-11-21	1971-11-21 00:00:00	32020		\N	243225	0	75498004	4294548		0
62016	3661	4027663	2007-02-05	2007-02-05 00:00:00	\N	\N	32020		\N	243668	0	13200003	4027663		0
62114	3668	4112343	1997-10-06	1997-10-06 00:00:00	1997-10-15	1997-10-15 00:00:00	32020		\N	244011	0	195662009	4112343		0
72894	4331	378001	1976-09-05	1976-09-05 00:00:00	1976-11-04	1976-11-04 00:00:00	32020		\N	287325	0	62106007	378001		0
62514	3694	78272	1958-11-30	1958-11-30 00:00:00	1958-12-21	1958-12-21 00:00:00	32020		\N	245557	0	70704007	78272		0
62601	3698	40481087	1996-10-04	1996-10-04 00:00:00	1996-10-25	1996-10-25 00:00:00	32020		\N	245884	0	444814009	40481087		0
62853	3714	4112343	1982-02-21	1982-02-21 00:00:00	1982-03-04	1982-03-04 00:00:00	32020		\N	246759	0	195662009	4112343		0
62916	3717	40481087	1998-11-01	1998-11-01 00:00:00	1998-11-15	1998-11-15 00:00:00	32020		\N	247047	0	444814009	40481087		0
73709	4380	40481087	1991-04-07	1991-04-07 00:00:00	1991-04-14	1991-04-14 00:00:00	32020		\N	291065	0	444814009	40481087		0
63389	3744	260139	1971-06-23	1971-06-23 00:00:00	1971-06-30	1971-06-30 00:00:00	32020		\N	248790	0	10509002	260139		0
63534	3752	4112343	2013-04-05	2013-04-05 00:00:00	2013-04-14	2013-04-14 00:00:00	32020		\N	249322	0	195662009	4112343		0
74223	4408	4237458	2011-07-14	2011-07-14 00:00:00	2011-09-12	2011-09-12 00:00:00	32020		\N	293000	0	58150001	4237458		0
53182	3149	40481087	1993-02-27	1993-02-27 00:00:00	1993-03-06	1993-03-06 00:00:00	32020		\N	209525	0	444814009	40481087		0
63915	3777	4296205	2005-01-27	2005-01-27 00:00:00	2005-02-24	2005-02-24 00:00:00	32020		\N	251034	0	403191005	4296205		0
53570	3175	28060	1987-02-12	1987-02-12 00:00:00	1987-02-22	1987-02-22 00:00:00	32020		\N	211002	0	43878008	28060		0
53667	3177	4310024	1948-02-07	1948-02-07 00:00:00	\N	\N	32020		\N	211315	0	424802006	4310024		0
43303	2579	4112343	1968-12-24	1968-12-24 00:00:00	1969-01-06	1969-01-06 00:00:00	32020		\N	170847	0	195662009	4112343		0
54045	3199	40481087	2014-09-12	2014-09-12 00:00:00	2014-09-26	2014-09-26 00:00:00	32020		\N	212737	0	444814009	40481087		0
43630	2598	4278672	1986-09-02	1986-09-02 00:00:00	1986-10-02	1986-10-02 00:00:00	32020		\N	171921	0	65966004	4278672		0
54330	3218	4310024	1990-07-17	1990-07-17 00:00:00	\N	\N	32020		\N	213851	0	424802006	4310024		0
54452	3224	28060	1960-03-19	1960-03-19 00:00:00	1960-04-01	1960-04-01 00:00:00	32020		\N	214395	0	43878008	28060		0
54669	3236	40481087	1964-02-26	1964-02-26 00:00:00	1964-03-18	1964-03-18 00:00:00	32020		\N	215066	0	444814009	40481087		0
54834	3246	372328	1981-05-14	1981-05-14 00:00:00	1981-09-28	1981-09-28 00:00:00	32020		\N	215794	0	65363002	372328		0
55071	3260	4156265	1983-09-09	1983-09-09 00:00:00	1983-09-23	1983-09-23 00:00:00	32020		\N	216750	0	370247008	4156265		0
65755	3887	81151	1957-06-20	1957-06-20 00:00:00	1957-07-18	1957-07-18 00:00:00	32020		\N	258362	0	44465007	81151		0
55343	3278	4134304	1969-05-01	1969-05-01 00:00:00	1969-07-30	1969-07-30 00:00:00	32020		\N	217743	0	263102004	4134304		0
55501	3287	40481087	1996-04-27	1996-04-27 00:00:00	1996-05-18	1996-05-18 00:00:00	32020		\N	218335	0	444814009	40481087		0
55694	3296	40481087	1950-07-20	1950-07-20 00:00:00	1950-08-10	1950-08-10 00:00:00	32020		\N	219086	0	444814009	40481087		0
45293	2693	40481087	1979-12-29	1979-12-29 00:00:00	1980-01-05	1980-01-05 00:00:00	32020		\N	178367	0	444814009	40481087		0
56091	3321	28060	1977-06-26	1977-06-26 00:00:00	1977-07-03	1977-07-03 00:00:00	32020		\N	220524	0	43878008	28060		0
56221	3332	40481087	1962-12-31	1962-12-31 00:00:00	1963-01-07	1963-01-07 00:00:00	32020		\N	221060	0	444814009	40481087		0
56365	3342	260139	1952-11-13	1952-11-13 00:00:00	1952-11-20	1952-11-20 00:00:00	32020		\N	221666	0	10509002	260139		0
56510	3352	4112343	2017-06-03	2017-06-03 00:00:00	2017-06-12	2017-06-12 00:00:00	32020		\N	222307	0	195662009	4112343		0
74065	4398	80180	1998-07-27	1998-07-27 00:00:00	\N	\N	32020		\N	292435	0	396275006	80180		0
67239	3973	260139	1984-09-01	1984-09-01 00:00:00	1984-09-08	1984-09-08 00:00:00	32020		\N	264167	0	10509002	260139		0
56842	3371	4296204	1996-08-13	1996-08-13 00:00:00	1996-09-03	1996-09-03 00:00:00	32020		\N	223672	0	403190006	4296204		0
56982	3381	4112343	1988-01-08	1988-01-08 00:00:00	1988-01-19	1988-01-19 00:00:00	32020		\N	224389	0	195662009	4112343		0
46633	2776	4283893	1986-07-31	1986-07-31 00:00:00	1986-09-25	1986-09-25 00:00:00	32020		\N	183766	0	36971009	4283893		0
57338	3403	4112343	1980-11-01	1980-11-01 00:00:00	1980-11-08	1980-11-08 00:00:00	32020		\N	225740	0	195662009	4112343		0
57516	3413	40481087	1982-06-23	1982-06-23 00:00:00	1982-07-14	1982-07-14 00:00:00	32020		\N	226377	0	444814009	40481087		0
57691	3422	40481087	1978-08-16	1978-08-16 00:00:00	1978-09-06	1978-09-06 00:00:00	32020		\N	227023	0	444814009	40481087		0
57840	3432	257012	1952-06-19	1952-06-19 00:00:00	\N	\N	32020		\N	227525	0	40055000	257012		0
57990	3438	40481087	1991-04-28	1991-04-28 00:00:00	1991-05-12	1991-05-12 00:00:00	32020		\N	228097	0	444814009	40481087		0
58142	3444	40481087	1974-12-11	1974-12-11 00:00:00	1975-01-01	1975-01-01 00:00:00	32020		\N	228555	0	444814009	40481087		0
47769	2836	260139	1994-12-19	1994-12-19 00:00:00	1994-12-26	1994-12-26 00:00:00	32020		\N	188354	0	10509002	260139		0
47962	2846	372328	1977-10-11	1977-10-11 00:00:00	1978-06-11	1978-06-11 00:00:00	32020		\N	188995	0	65363002	372328		0
58764	3486	81151	1974-12-06	1974-12-06 00:00:00	1975-01-03	1975-01-03 00:00:00	32020		\N	231295	0	44465007	81151		0
48264	2861	378001	1978-05-20	1978-05-20 00:00:00	1978-06-19	1978-06-19 00:00:00	32020		\N	190182	0	62106007	378001		0
48421	2867	4283893	1992-11-06	1992-11-06 00:00:00	1993-01-22	1993-01-22 00:00:00	32020		\N	190725	0	36971009	4283893		0
59244	3514	439777	1997-08-13	1997-08-13 00:00:00	\N	\N	32020		\N	233216	0	271737000	439777		0
69950	4139	40481087	2010-02-03	2010-02-03 00:00:00	2010-02-24	2010-02-24 00:00:00	32020		\N	275155	0	444814009	40481087		0
59435	3526	4112343	1979-07-15	1979-07-15 00:00:00	1979-07-22	1979-07-22 00:00:00	32020		\N	233909	0	195662009	4112343		0
59698	3537	4156265	1966-01-30	1966-01-30 00:00:00	1966-02-20	1966-02-20 00:00:00	32020		\N	234982	0	370247008	4156265		0
59890	3549	4134304	2012-02-16	2012-02-16 00:00:00	2012-03-17	2012-03-17 00:00:00	32020		\N	235631	0	263102004	4134304		0
60042	3558	80180	1994-12-09	1994-12-09 00:00:00	\N	\N	32020		\N	236228	0	396275006	80180		0
60156	3561	4112343	2013-08-06	2013-08-06 00:00:00	2013-08-16	2013-08-16 00:00:00	32020		\N	236490	0	195662009	4112343		0
60326	3570	80180	1988-06-08	1988-06-08 00:00:00	\N	\N	32020		\N	237290	0	396275006	80180		0
49930	2950	372328	1936-08-09	1936-08-09 00:00:00	1936-10-19	1936-10-19 00:00:00	32020		\N	196985	0	65363002	372328		0
60666	3592	260139	1986-05-09	1986-05-09 00:00:00	1986-05-16	1986-05-16 00:00:00	32020		\N	238587	0	10509002	260139		0
50273	2970	81151	1993-01-19	1993-01-19 00:00:00	1993-02-09	1993-02-09 00:00:00	32020		\N	198342	0	44465007	81151		0
61030	3612	260139	1994-06-21	1994-06-21 00:00:00	1994-07-05	1994-07-05 00:00:00	32020		\N	239972	0	10509002	260139		0
61112	3616	4112343	1970-08-18	1970-08-18 00:00:00	1970-08-31	1970-08-31 00:00:00	32020		\N	240298	0	195662009	4112343		0
61283	3623	4112343	1955-01-21	1955-01-21 00:00:00	1955-02-01	1955-02-01 00:00:00	32020		\N	240922	0	195662009	4112343		0
61445	3630	40481087	1979-10-14	1979-10-14 00:00:00	1979-10-28	1979-10-28 00:00:00	32020		\N	241516	0	444814009	40481087		0
51081	3025	40481087	1949-02-26	1949-02-26 00:00:00	1949-03-12	1949-03-12 00:00:00	32020		\N	201684	0	444814009	40481087		0
61890	3654	260139	1977-11-23	1977-11-23 00:00:00	1977-12-07	1977-12-07 00:00:00	32020		\N	243185	0	10509002	260139		0
62017	3661	40481087	1994-03-27	1994-03-27 00:00:00	1994-04-17	1994-04-17 00:00:00	32020		\N	243655	0	444814009	40481087		0
62115	3668	4112343	1989-09-19	1989-09-19 00:00:00	1989-10-02	1989-10-02 00:00:00	32020		\N	244034	0	195662009	4112343		0
72895	4331	40481087	2005-09-09	2005-09-09 00:00:00	2005-09-16	2005-09-16 00:00:00	32020		\N	287319	0	444814009	40481087		0
62515	3694	4237458	1995-02-13	1995-02-13 00:00:00	1995-04-14	1995-04-14 00:00:00	32020		\N	245565	0	58150001	4237458		0
62602	3698	80180	1992-02-09	1992-02-09 00:00:00	\N	\N	32020		\N	245824	0	396275006	80180		0
62854	3714	78272	1965-02-16	1965-02-16 00:00:00	1965-03-02	1965-03-02 00:00:00	32020		\N	246849	0	70704007	78272		0
62917	3717	260139	1989-04-10	1989-04-10 00:00:00	1989-04-17	1989-04-17 00:00:00	32020		\N	247066	0	10509002	260139		0
73710	4380	40481087	1993-06-30	1993-06-30 00:00:00	1993-07-21	1993-07-21 00:00:00	32020		\N	291023	0	444814009	40481087		0
63390	3745	372328	2012-06-10	2012-06-10 00:00:00	2012-09-12	2012-09-12 00:00:00	32020		\N	248916	0	65363002	372328		0
63535	3752	78272	2002-10-01	2002-10-01 00:00:00	2002-10-29	2002-10-29 00:00:00	32020		\N	249366	0	70704007	78272		0
74224	4408	4294548	1986-09-30	1986-09-30 00:00:00	1986-12-23	1986-12-23 00:00:00	32020		\N	293048	0	75498004	4294548		0
53183	3149	4112343	2009-02-25	2009-02-25 00:00:00	2009-03-06	2009-03-06 00:00:00	32020		\N	209544	0	195662009	4112343		0
63916	3777	30753	2016-11-09	2016-11-09 00:00:00	\N	\N	32020		\N	251040	0	16761005	30753		0
53571	3175	40481087	1994-08-07	1994-08-07 00:00:00	1994-08-28	1994-08-28 00:00:00	32020		\N	211019	0	444814009	40481087		0
53668	3177	4112343	1955-02-04	1955-02-04 00:00:00	1955-02-12	1955-02-12 00:00:00	32020		\N	211268	0	195662009	4112343		0
43304	2579	40481087	2017-06-21	2017-06-21 00:00:00	2017-06-28	2017-06-28 00:00:00	32020		\N	170776	0	444814009	40481087		0
54046	3200	28060	2001-01-21	2001-01-21 00:00:00	2001-02-03	2001-02-03 00:00:00	32020		\N	212834	0	43878008	28060		0
43631	2598	40481087	1995-12-22	1995-12-22 00:00:00	1995-12-29	1995-12-29 00:00:00	32020		\N	171928	0	444814009	40481087		0
54331	3218	4155034	1997-03-18	1997-03-18 00:00:00	1997-04-01	1997-04-01 00:00:00	32020		\N	213813	0	283371005	4155034		0
54453	3224	40481087	1975-07-27	1975-07-27 00:00:00	1975-08-10	1975-08-10 00:00:00	32020		\N	214370	0	444814009	40481087		0
54670	3236	4112343	2008-02-17	2008-02-17 00:00:00	2008-02-24	2008-02-24 00:00:00	32020		\N	215055	0	195662009	4112343		0
54835	3246	4112343	1988-01-10	1988-01-10 00:00:00	1988-01-22	1988-01-22 00:00:00	32020		\N	215812	0	195662009	4112343		0
55072	3260	40481087	1977-09-16	1977-09-16 00:00:00	1977-09-30	1977-09-30 00:00:00	32020		\N	216720	0	444814009	40481087		0
65756	3887	260139	1980-09-01	1980-09-01 00:00:00	1980-09-08	1980-09-08 00:00:00	32020		\N	258389	0	10509002	260139		0
55344	3278	372328	2001-09-10	2001-09-10 00:00:00	2002-04-29	2002-04-29 00:00:00	32020		\N	217787	0	65363002	372328		0
55502	3287	40481087	1967-05-10	1967-05-10 00:00:00	1967-05-24	1967-05-24 00:00:00	32020		\N	218387	0	444814009	40481087		0
55695	3296	81151	1963-09-04	1963-09-04 00:00:00	1963-10-02	1963-10-02 00:00:00	32020		\N	219092	0	44465007	81151		0
45294	2693	40481087	1977-11-09	1977-11-09 00:00:00	1977-11-16	1977-11-16 00:00:00	32020		\N	178404	0	444814009	40481087		0
56092	3321	40481087	1997-10-05	1997-10-05 00:00:00	1997-10-26	1997-10-26 00:00:00	32020		\N	220523	0	444814009	40481087		0
56222	3332	40481087	2016-05-19	2016-05-19 00:00:00	2016-06-09	2016-06-09 00:00:00	32020		\N	221075	0	444814009	40481087		0
56366	3342	81151	1926-10-18	1926-10-18 00:00:00	1926-11-22	1926-11-22 00:00:00	32020		\N	221630	0	44465007	81151		0
56511	3352	4310024	2001-05-12	2001-05-12 00:00:00	\N	\N	32020		\N	222303	0	424802006	4310024		0
67240	3973	40481087	2007-04-03	2007-04-03 00:00:00	2007-04-10	2007-04-10 00:00:00	32020		\N	264173	0	444814009	40481087		0
56843	3371	260139	1999-08-11	1999-08-11 00:00:00	1999-08-18	1999-08-18 00:00:00	32020		\N	223570	0	10509002	260139		0
56983	3381	28060	1972-03-09	1972-03-09 00:00:00	1972-03-17	1972-03-17 00:00:00	32020		\N	224381	0	43878008	28060		0
46634	2776	81893	2012-03-25	2012-03-25 00:00:00	\N	\N	32020		\N	183850	0	64766004	81893		0
57339	3403	4283893	2007-10-30	2007-10-30 00:00:00	2007-11-27	2007-11-27 00:00:00	32020		\N	225757	0	36971009	4283893		0
57517	3413	4283893	1980-05-14	1980-05-14 00:00:00	1980-06-25	1980-06-25 00:00:00	32020		\N	226420	0	36971009	4283893		0
57692	3422	78272	1977-11-21	1977-11-21 00:00:00	1977-12-26	1977-12-26 00:00:00	32020		\N	226980	0	70704007	78272		0
57841	3432	260139	1994-12-01	1994-12-01 00:00:00	1994-12-08	1994-12-08 00:00:00	32020		\N	227530	0	10509002	260139		0
57991	3438	4283893	1939-04-25	1939-04-25 00:00:00	1939-05-16	1939-05-16 00:00:00	32020		\N	228074	0	36971009	4283893		0
58143	3444	4112343	1961-07-06	1961-07-06 00:00:00	1961-07-18	1961-07-18 00:00:00	32020		\N	228521	0	195662009	4112343		0
47770	2836	195588	2010-11-22	2010-11-22 00:00:00	2011-01-12	2011-01-12 00:00:00	32020		\N	188388	0	38822007	195588		0
47963	2846	195588	2016-06-14	2016-06-14 00:00:00	2016-08-09	2016-08-09 00:00:00	32020		\N	189037	0	38822007	195588		0
69252	4100	257012	2014-05-16	2014-05-16 00:00:00	\N	\N	32020		\N	272452	0	40055000	257012		0
48265	2861	372328	1966-11-05	1966-11-05 00:00:00	1967-04-10	1967-04-10 00:00:00	32020		\N	190210	0	65363002	372328		0
48422	2867	378001	1985-07-23	1985-07-23 00:00:00	1985-08-22	1985-08-22 00:00:00	32020		\N	190699	0	62106007	378001		0
59245	3514	4283893	1988-08-26	1988-08-26 00:00:00	1988-10-07	1988-10-07 00:00:00	32020		\N	233196	0	36971009	4283893		0
69951	4139	28060	1989-01-18	1989-01-18 00:00:00	1989-01-31	1989-01-31 00:00:00	32020		\N	275134	0	43878008	28060		0
59436	3526	4278672	2000-11-09	2000-11-09 00:00:00	2000-12-09	2000-12-09 00:00:00	32020		\N	234005	0	65966004	4278672		0
59699	3537	40481087	1987-03-24	1987-03-24 00:00:00	1987-04-14	1987-04-14 00:00:00	32020		\N	234969	0	444814009	40481087		0
59891	3549	4112343	1981-11-07	1981-11-07 00:00:00	1981-11-20	1981-11-20 00:00:00	32020		\N	235678	0	195662009	4112343		0
60043	3558	195588	1992-03-19	1992-03-19 00:00:00	1992-04-26	1992-04-26 00:00:00	32020		\N	236219	0	38822007	195588		0
60157	3561	4283893	1911-10-31	1911-10-31 00:00:00	1912-01-23	1912-01-23 00:00:00	32020		\N	236414	0	36971009	4283893		0
60327	3570	4113008	1966-12-06	1966-12-06 00:00:00	1966-12-27	1966-12-27 00:00:00	32020		\N	237225	0	284549007	4113008		0
49931	2950	40481087	1995-01-05	1995-01-05 00:00:00	1995-01-26	1995-01-26 00:00:00	32020		\N	196990	0	444814009	40481087		0
60667	3592	40481087	2005-11-08	2005-11-08 00:00:00	2005-11-29	2005-11-29 00:00:00	32020		\N	238632	0	444814009	40481087		0
50274	2970	378001	1990-01-05	1990-01-05 00:00:00	1990-03-06	1990-03-06 00:00:00	32020		\N	198341	0	62106007	378001		0
61031	3612	4112343	1989-07-08	1989-07-08 00:00:00	1989-07-15	1989-07-15 00:00:00	32020		\N	239955	0	195662009	4112343		0
61113	3616	4027663	1983-02-19	1983-02-19 00:00:00	\N	\N	32020		\N	240271	0	13200003	4027663		0
61284	3623	40481087	1964-08-23	1964-08-23 00:00:00	1964-08-30	1964-08-30 00:00:00	32020		\N	240863	0	444814009	40481087		0
61446	3630	28060	1965-05-30	1965-05-30 00:00:00	1965-06-07	1965-06-07 00:00:00	32020		\N	241563	0	43878008	28060		0
51082	3025	260139	1979-09-01	1979-09-01 00:00:00	1979-09-08	1979-09-08 00:00:00	32020		\N	201716	0	10509002	260139		0
61891	3654	4112343	1971-10-31	1971-10-31 00:00:00	1971-11-10	1971-11-10 00:00:00	32020		\N	243238	0	195662009	4112343		0
62018	3661	260139	1980-08-02	1980-08-02 00:00:00	1980-08-16	1980-08-16 00:00:00	32020		\N	243642	0	10509002	260139		0
62116	3668	4109685	1993-06-27	1993-06-27 00:00:00	1993-07-11	1993-07-11 00:00:00	32020		\N	244031	0	284551006	4109685		0
72896	4331	40481087	2014-02-25	2014-02-25 00:00:00	2014-03-04	2014-03-04 00:00:00	32020		\N	287300	0	444814009	40481087		0
62516	3694	4027663	1987-04-02	1987-04-02 00:00:00	\N	\N	32020		\N	245520	0	13200003	4027663		0
62603	3698	28060	1966-09-03	1966-09-03 00:00:00	1966-09-15	1966-09-15 00:00:00	32020		\N	245828	0	43878008	28060		0
62855	3714	192671	1958-09-08	1958-09-08 00:00:00	\N	\N	32020		\N	246786	0	K92.2	35208414		0
62918	3717	40481087	1991-07-18	1991-07-18 00:00:00	1991-08-01	1991-08-01 00:00:00	32020		\N	246961	0	444814009	40481087		0
73711	4380	28060	1994-06-08	1994-06-08 00:00:00	1994-06-20	1994-06-20 00:00:00	32020		\N	291041	0	43878008	28060		0
63391	3745	260139	1944-02-28	1944-02-28 00:00:00	1944-03-13	1944-03-13 00:00:00	32020		\N	248909	0	10509002	260139		0
63536	3752	372328	1960-04-17	1960-04-17 00:00:00	1960-05-19	1960-05-19 00:00:00	32020		\N	249355	0	65363002	372328		0
74225	4408	40481087	1990-05-15	1990-05-15 00:00:00	1990-05-29	1990-05-29 00:00:00	32020		\N	293041	0	444814009	40481087		0
53184	3149	4112343	1996-10-04	1996-10-04 00:00:00	1996-10-14	1996-10-14 00:00:00	32020		\N	209543	0	195662009	4112343		0
63917	3777	80180	2018-07-02	2018-07-02 00:00:00	\N	\N	32020		\N	251040	0	396275006	80180		0
53572	3175	4237458	1995-02-01	1995-02-01 00:00:00	1995-03-03	1995-03-03 00:00:00	32020		\N	211054	0	58150001	4237458		0
53669	3177	260139	1920-02-01	1920-02-01 00:00:00	1920-02-08	1920-02-08 00:00:00	32020		\N	211246	0	10509002	260139		0
43305	2579	381316	1978-07-02	1978-07-02 00:00:00	\N	\N	32020		\N	170793	0	230690007	381316		0
54047	3200	78272	1958-01-21	1958-01-21 00:00:00	1958-02-18	1958-02-18 00:00:00	32020		\N	212826	0	70704007	78272		0
43632	2598	372328	1976-02-27	1976-02-27 00:00:00	1976-06-15	1976-06-15 00:00:00	32020		\N	171939	0	65363002	372328		0
54332	3218	40481087	1962-01-06	1962-01-06 00:00:00	1962-01-20	1962-01-20 00:00:00	32020		\N	213832	0	444814009	40481087		0
54454	3224	260139	1971-01-18	1971-01-18 00:00:00	1971-02-01	1971-02-01 00:00:00	32020		\N	214369	0	10509002	260139		0
54671	3236	4112343	2008-07-26	2008-07-26 00:00:00	2008-08-04	2008-08-04 00:00:00	32020		\N	215061	0	195662009	4112343		0
54836	3246	372328	1981-10-28	1981-10-28 00:00:00	1982-03-29	1982-03-29 00:00:00	32020		\N	215795	0	65363002	372328		0
55073	3260	4112343	2010-02-02	2010-02-02 00:00:00	2010-02-11	2010-02-11 00:00:00	32020		\N	216709	0	195662009	4112343		0
65757	3887	81151	1960-05-03	1960-05-03 00:00:00	1960-05-24	1960-05-24 00:00:00	32020		\N	258363	0	44465007	81151		0
55345	3278	40481087	2016-12-08	2016-12-08 00:00:00	2016-12-29	2016-12-29 00:00:00	32020		\N	217757	0	444814009	40481087		0
55503	3287	4283893	1971-06-07	1971-06-07 00:00:00	1971-08-30	1971-08-30 00:00:00	32020		\N	218329	0	36971009	4283893		0
55696	3296	40481087	1993-11-04	1993-11-04 00:00:00	1993-11-18	1993-11-18 00:00:00	32020		\N	219089	0	444814009	40481087		0
45295	2693	4283893	1972-01-25	1972-01-25 00:00:00	1972-04-11	1972-04-11 00:00:00	32020		\N	178422	0	36971009	4283893		0
56093	3321	4109685	1982-11-15	1982-11-15 00:00:00	1982-11-29	1982-11-29 00:00:00	32020		\N	220500	0	284551006	4109685		0
56223	3332	40481087	1990-08-06	1990-08-06 00:00:00	1990-08-27	1990-08-27 00:00:00	32020		\N	221073	0	444814009	40481087		0
56367	3342	260139	1995-09-17	1995-09-17 00:00:00	1995-10-01	1995-10-01 00:00:00	32020		\N	221611	0	10509002	260139		0
56512	3352	261325	1998-12-18	1998-12-18 00:00:00	\N	\N	32020		\N	222303	0	87433001	261325		0
67241	3973	40481087	1995-01-06	1995-01-06 00:00:00	1995-01-27	1995-01-27 00:00:00	32020		\N	264223	0	444814009	40481087		0
56844	3371	4278672	1982-12-06	1982-12-06 00:00:00	1983-01-05	1983-01-05 00:00:00	32020		\N	223669	0	65966004	4278672		0
56984	3381	28060	1982-01-25	1982-01-25 00:00:00	1982-02-05	1982-02-05 00:00:00	32020		\N	224365	0	43878008	28060		0
46635	2776	4027663	2002-07-06	2002-07-06 00:00:00	\N	\N	32020		\N	183786	0	13200003	4027663		0
57340	3403	80180	2008-08-08	2008-08-08 00:00:00	\N	\N	32020		\N	225757	0	396275006	80180		0
57518	3413	40481087	1989-06-14	1989-06-14 00:00:00	1989-06-21	1989-06-21 00:00:00	32020		\N	226381	0	444814009	40481087		0
57693	3422	40481087	1980-10-04	1980-10-04 00:00:00	1980-10-18	1980-10-18 00:00:00	32020		\N	226954	0	444814009	40481087		0
57842	3432	40481087	1954-09-08	1954-09-08 00:00:00	1954-09-15	1954-09-15 00:00:00	32020		\N	227562	0	444814009	40481087		0
57992	3438	4294548	1930-04-20	1930-04-20 00:00:00	1930-05-04	1930-05-04 00:00:00	32020		\N	228113	0	75498004	4294548		0
58144	3444	4294548	1963-09-01	1963-09-01 00:00:00	1963-09-15	1963-09-15 00:00:00	32020		\N	228617	0	75498004	4294548		0
47771	2836	4112343	2011-02-05	2011-02-05 00:00:00	2011-02-16	2011-02-16 00:00:00	32020		\N	188406	0	195662009	4112343		0
47964	2846	40481087	2010-04-23	2010-04-23 00:00:00	2010-05-14	2010-05-14 00:00:00	32020		\N	189014	0	444814009	40481087		0
69253	4100	4112343	2009-10-12	2009-10-12 00:00:00	2009-10-22	2009-10-22 00:00:00	32020		\N	272415	0	195662009	4112343		0
48266	2861	4059173	1977-04-25	1977-04-25 00:00:00	1977-07-24	1977-07-24 00:00:00	32020		\N	190181	0	16114001	4059173		0
59246	3514	4113008	1975-09-13	1975-09-13 00:00:00	1975-10-04	1975-10-04 00:00:00	32020		\N	233211	0	284549007	4113008		0
69952	4139	4035415	2006-06-30	2006-06-30 00:00:00	2006-08-29	2006-08-29 00:00:00	32020		\N	275167	0	239720000	4035415		0
59437	3526	40481087	1977-03-18	1977-03-18 00:00:00	1977-04-08	1977-04-08 00:00:00	32020		\N	233992	0	444814009	40481087		0
59700	3537	40481087	2007-02-27	2007-02-27 00:00:00	2007-03-13	2007-03-13 00:00:00	32020		\N	234953	0	444814009	40481087		0
59892	3549	40481087	1958-01-09	1958-01-09 00:00:00	1958-01-23	1958-01-23 00:00:00	32020		\N	235682	0	444814009	40481087		0
60044	3558	40481087	1973-04-20	1973-04-20 00:00:00	1973-05-11	1973-05-11 00:00:00	32020		\N	236227	0	444814009	40481087		0
60158	3561	260139	1930-09-23	1930-09-23 00:00:00	1930-09-30	1930-09-30 00:00:00	32020		\N	236496	0	10509002	260139		0
60328	3570	4294548	2017-05-20	2017-05-20 00:00:00	2017-06-10	2017-06-10 00:00:00	32020		\N	237231	0	75498004	4294548		0
49932	2950	4112343	1936-07-11	1936-07-11 00:00:00	1936-07-18	1936-07-18 00:00:00	32020		\N	196894	0	195662009	4112343		0
60668	3592	4027663	1990-01-21	1990-01-21 00:00:00	\N	\N	32020		\N	238610	0	13200003	4027663		0
50275	2970	4283893	1987-02-18	1987-02-18 00:00:00	1987-04-22	1987-04-22 00:00:00	32020		\N	198346	0	36971009	4283893		0
61032	3612	4230399	1974-04-05	1974-04-05 00:00:00	1974-06-04	1974-06-04 00:00:00	32020		\N	239999	0	359817006	4230399		0
61114	3616	4112343	1982-04-04	1982-04-04 00:00:00	1982-04-14	1982-04-14 00:00:00	32020		\N	240271	0	195662009	4112343		0
61285	3623	40481087	1985-05-21	1985-05-21 00:00:00	1985-06-04	1985-06-04 00:00:00	32020		\N	240889	0	444814009	40481087		0
61447	3630	372328	1956-06-06	1956-06-06 00:00:00	1956-06-20	1956-06-20 00:00:00	32020		\N	241573	0	65363002	372328		0
51083	3025	80180	1984-08-03	1984-08-03 00:00:00	\N	\N	32020		\N	201573	0	396275006	80180		0
61892	3654	372328	1973-11-18	1973-11-18 00:00:00	1973-12-02	1973-12-02 00:00:00	32020		\N	243187	0	65363002	372328		0
62019	3661	80180	2016-02-18	2016-02-18 00:00:00	\N	\N	32020		\N	243692	0	396275006	80180		0
62117	3668	40481087	2007-04-12	2007-04-12 00:00:00	2007-04-26	2007-04-26 00:00:00	32020		\N	244042	0	444814009	40481087		0
72897	4331	40481087	1979-01-13	1979-01-13 00:00:00	1979-02-03	1979-02-03 00:00:00	32020		\N	287318	0	444814009	40481087		0
62517	3694	4152936	1984-02-22	1984-02-22 00:00:00	1984-03-14	1984-03-14 00:00:00	32020		\N	245562	0	283385000	4152936		0
62604	3698	4112343	1954-08-18	1954-08-18 00:00:00	1954-08-25	1954-08-25 00:00:00	32020		\N	245852	0	195662009	4112343		0
62856	3714	372328	1925-12-28	1925-12-28 00:00:00	1926-01-20	1926-01-20 00:00:00	32020		\N	246799	0	65363002	372328		0
62919	3717	4155034	1992-10-11	1992-10-11 00:00:00	1992-10-25	1992-10-25 00:00:00	32020		\N	246969	0	283371005	4155034		0
73712	4380	4218389	1980-04-26	1980-04-26 00:00:00	1980-05-17	1980-05-17 00:00:00	32020		\N	290996	0	39848009	4218389		0
63392	3745	40479768	1997-02-23	1997-02-23 00:00:00	1997-04-01	1997-04-01 00:00:00	32020		\N	248878	0	444470001	40479768		0
63537	3752	4142905	1997-12-26	1997-12-26 00:00:00	1998-03-26	1998-03-26 00:00:00	32020		\N	249365	0	33737001	4142905		0
74226	4408	40481087	2007-10-18	2007-10-18 00:00:00	2007-10-25	2007-10-25 00:00:00	32020		\N	293022	0	444814009	40481087		0
53185	3149	4132546	1959-02-27	1959-02-27 00:00:00	\N	\N	32020		\N	209564	0	275272006	4166590		0
63918	3777	4285898	2017-10-05	2017-10-05 00:00:00	\N	\N	32020		\N	251040	0	68496003	4285898		0
53573	3175	4156265	1993-12-24	1993-12-24 00:00:00	1994-01-07	1994-01-07 00:00:00	32020		\N	211053	0	370247008	4156265		0
53670	3177	40481087	1920-10-30	1920-10-30 00:00:00	1920-11-06	1920-11-06 00:00:00	32020		\N	211343	0	444814009	40481087		0
43306	2579	4027663	1985-04-12	1985-04-12 00:00:00	\N	\N	32020		\N	170839	0	13200003	4027663		0
54048	3200	80180	1985-01-29	1985-01-29 00:00:00	\N	\N	32020		\N	212803	0	396275006	80180		0
43633	2598	260139	2007-04-25	2007-04-25 00:00:00	2007-05-02	2007-05-02 00:00:00	32020		\N	171929	0	10509002	260139		0
54333	3218	81151	1966-01-09	1966-01-09 00:00:00	1966-01-30	1966-01-30 00:00:00	32020		\N	213811	0	44465007	81151		0
54464	3226	4283893	1997-05-22	1997-05-22 00:00:00	1997-07-17	1997-07-17 00:00:00	32020		\N	214458	0	36971009	4283893		0
54672	3236	260139	1940-04-17	1940-04-17 00:00:00	1940-05-01	1940-05-01 00:00:00	32020		\N	215125	0	10509002	260139		0
54837	3246	4112343	1997-06-05	1997-06-05 00:00:00	1997-06-17	1997-06-17 00:00:00	32020		\N	215791	0	195662009	4112343		0
55074	3260	81893	1996-08-16	1996-08-16 00:00:00	\N	\N	32020		\N	216700	0	64766004	81893		0
65758	3887	260139	1977-05-20	1977-05-20 00:00:00	1977-06-03	1977-06-03 00:00:00	32020		\N	258402	0	10509002	260139		0
55346	3279	195588	2015-09-27	2015-09-27 00:00:00	2015-11-01	2015-11-01 00:00:00	32020		\N	217917	0	38822007	195588		0
55504	3287	40481087	1999-10-05	1999-10-05 00:00:00	1999-10-26	1999-10-26 00:00:00	32020		\N	218333	0	444814009	40481087		0
55697	3296	260139	2004-07-04	2004-07-04 00:00:00	2004-07-18	2004-07-18 00:00:00	32020		\N	219068	0	10509002	260139		0
45296	2693	80180	1997-05-27	1997-05-27 00:00:00	\N	\N	32020		\N	178415	0	396275006	80180		0
56094	3321	81151	1980-01-09	1980-01-09 00:00:00	1980-01-30	1980-01-30 00:00:00	32020		\N	220499	0	44465007	81151		0
56224	3332	372328	1964-04-03	1964-04-03 00:00:00	1964-05-12	1964-05-12 00:00:00	32020		\N	221052	0	65363002	372328		0
56368	3342	40481087	1952-10-29	1952-10-29 00:00:00	1952-11-12	1952-11-12 00:00:00	32020		\N	221608	0	444814009	40481087		0
56513	3352	40481087	1972-10-17	1972-10-17 00:00:00	1972-11-07	1972-11-07 00:00:00	32020		\N	222294	0	444814009	40481087		0
67264	3976	40481087	2000-02-08	2000-02-08 00:00:00	2000-02-15	2000-02-15 00:00:00	32020		\N	264347	0	444814009	40481087		0
56845	3371	4109685	1998-06-25	1998-06-25 00:00:00	1998-07-16	1998-07-16 00:00:00	32020		\N	223600	0	284551006	4109685		0
56985	3381	372328	1973-12-07	1973-12-07 00:00:00	1974-05-13	1974-05-13 00:00:00	32020		\N	224390	0	65363002	372328		0
46636	2776	372328	1991-07-21	1991-07-21 00:00:00	1991-11-24	1991-11-24 00:00:00	32020		\N	183794	0	65363002	372328		0
57341	3403	372328	1982-10-19	1982-10-19 00:00:00	1983-05-02	1983-05-02 00:00:00	32020		\N	225721	0	65363002	372328		0
57519	3413	4112343	1998-06-16	1998-06-16 00:00:00	1998-06-26	1998-06-26 00:00:00	32020		\N	226421	0	195662009	4112343		0
57695	3422	380378	1978-12-16	1978-12-16 00:00:00	\N	\N	32020		\N	226981	0	84757009	380378		0
57843	3432	260139	1951-12-10	1951-12-10 00:00:00	1951-12-17	1951-12-17 00:00:00	32020		\N	227561	0	10509002	260139		0
57993	3438	28060	1957-11-20	1957-11-20 00:00:00	1957-11-27	1957-11-27 00:00:00	32020		\N	228095	0	43878008	28060		0
58145	3444	40481087	1978-09-19	1978-09-19 00:00:00	1978-09-26	1978-09-26 00:00:00	32020		\N	228566	0	444814009	40481087		0
47772	2836	4113008	1986-02-02	1986-02-02 00:00:00	1986-02-23	1986-02-23 00:00:00	32020		\N	188373	0	284549007	4113008		0
47965	2846	40481087	1987-01-17	1987-01-17 00:00:00	1987-01-31	1987-01-31 00:00:00	32020		\N	189021	0	444814009	40481087		0
69254	4100	192671	1980-03-19	1980-03-19 00:00:00	\N	\N	32020		\N	272405	0	K92.2	35208414		0
48267	2861	40481087	2010-06-18	2010-06-18 00:00:00	2010-06-25	2010-06-25 00:00:00	32020		\N	190188	0	444814009	40481087		0
48424	2867	40481087	2013-04-15	2013-04-15 00:00:00	2013-05-06	2013-05-06 00:00:00	32020		\N	190705	0	444814009	40481087		0
59247	3514	4112343	1987-01-04	1987-01-04 00:00:00	1987-01-11	1987-01-11 00:00:00	32020		\N	233215	0	195662009	4112343		0
69953	4139	30753	2010-12-21	2010-12-21 00:00:00	\N	\N	32020		\N	275152	0	16761005	30753		0
59438	3526	4027663	1977-12-20	1977-12-20 00:00:00	\N	\N	32020		\N	233992	0	13200003	4027663		0
59701	3537	4112343	1998-06-25	1998-06-25 00:00:00	1998-07-02	1998-07-02 00:00:00	32020		\N	234911	0	195662009	4112343		0
59893	3549	28060	1997-01-13	1997-01-13 00:00:00	1997-01-23	1997-01-23 00:00:00	32020		\N	235642	0	43878008	28060		0
60045	3558	81151	1964-01-01	1964-01-01 00:00:00	1964-01-15	1964-01-15 00:00:00	32020		\N	236215	0	44465007	81151		0
60159	3561	40481087	1958-11-01	1958-11-01 00:00:00	1958-11-15	1958-11-15 00:00:00	32020		\N	236557	0	444814009	40481087		0
60329	3570	4112343	1950-01-31	1950-01-31 00:00:00	1950-02-08	1950-02-08 00:00:00	32020		\N	237286	0	195662009	4112343		0
49933	2950	28060	1983-08-12	1983-08-12 00:00:00	1983-08-19	1983-08-19 00:00:00	32020		\N	196982	0	43878008	28060		0
60669	3592	4112343	2014-11-03	2014-11-03 00:00:00	2014-11-11	2014-11-11 00:00:00	32020		\N	238572	0	195662009	4112343		0
50276	2970	40481087	2014-12-03	2014-12-03 00:00:00	2014-12-17	2014-12-17 00:00:00	32020		\N	198260	0	444814009	40481087		0
61033	3612	260139	2000-04-30	2000-04-30 00:00:00	2000-05-14	2000-05-14 00:00:00	32020		\N	239973	0	10509002	260139		0
61115	3616	40481087	2001-11-03	2001-11-03 00:00:00	2001-11-10	2001-11-10 00:00:00	32020		\N	240272	0	444814009	40481087		0
61286	3623	260139	1951-01-12	1951-01-12 00:00:00	1951-01-19	1951-01-19 00:00:00	32020		\N	240890	0	10509002	260139		0
61448	3630	4294548	1996-01-09	1996-01-09 00:00:00	1996-01-23	1996-01-23 00:00:00	32020		\N	241561	0	75498004	4294548		0
51084	3025	40481087	1982-02-04	1982-02-04 00:00:00	1982-02-18	1982-02-18 00:00:00	32020		\N	201573	0	444814009	40481087		0
61893	3654	40481087	2007-03-20	2007-03-20 00:00:00	2007-04-03	2007-04-03 00:00:00	32020		\N	243204	0	444814009	40481087		0
62020	3661	40481087	1984-03-30	1984-03-30 00:00:00	1984-04-13	1984-04-13 00:00:00	32020		\N	243672	0	444814009	40481087		0
62118	3668	4112343	1996-04-30	1996-04-30 00:00:00	1996-05-10	1996-05-10 00:00:00	32020		\N	244010	0	195662009	4112343		0
72898	4331	372328	1981-12-08	1981-12-08 00:00:00	1982-11-12	1982-11-12 00:00:00	32020		\N	287301	0	65363002	372328		0
62518	3694	372328	1961-06-17	1961-06-17 00:00:00	1962-07-03	1962-07-03 00:00:00	32020		\N	245482	0	65363002	372328		0
62605	3698	40481087	1971-02-10	1971-02-10 00:00:00	1971-03-03	1971-03-03 00:00:00	32020		\N	245849	0	444814009	40481087		0
62857	3714	313217	2005-11-09	2005-11-09 00:00:00	\N	\N	32020		\N	246875	0	49436004	313217		0
62920	3717	378001	1986-07-15	1986-07-15 00:00:00	1986-09-13	1986-09-13 00:00:00	32020		\N	246968	0	62106007	378001		0
73713	4380	40481087	2009-06-15	2009-06-15 00:00:00	2009-06-22	2009-06-22 00:00:00	32020		\N	291026	0	444814009	40481087		0
63393	3745	4112343	1934-06-22	1934-06-22 00:00:00	1934-07-04	1934-07-04 00:00:00	32020		\N	248908	0	195662009	4112343		0
63538	3752	4112343	1959-04-07	1959-04-07 00:00:00	1959-04-19	1959-04-19 00:00:00	32020		\N	249342	0	195662009	4112343		0
74227	4408	4155034	2019-02-23	2019-02-23 00:00:00	2019-03-09	2019-03-09 00:00:00	32020		\N	293002	0	283371005	4155034		0
53186	3149	4001336	1959-02-27	1959-02-27 00:00:00	1959-03-29	1959-03-29 00:00:00	32020		\N	209564	0	110030002	4001336		0
63919	3777	192671	2018-09-19	2018-09-19 00:00:00	\N	\N	32020		\N	251031	0	K92.2	35208414		0
53574	3175	4112343	1993-04-04	1993-04-04 00:00:00	1993-04-15	1993-04-15 00:00:00	32020		\N	211006	0	195662009	4112343		0
53671	3177	28060	1931-11-14	1931-11-14 00:00:00	1931-11-25	1931-11-25 00:00:00	32020		\N	211264	0	43878008	28060		0
43307	2579	4146173	1978-03-05	1978-03-05 00:00:00	1978-04-04	1978-04-04 00:00:00	32020		\N	170813	0	307731004	4146173		0
54049	3200	4278672	2013-08-19	2013-08-19 00:00:00	2013-11-17	2013-11-17 00:00:00	32020		\N	212828	0	65966004	4278672		0
43634	2598	80180	2008-07-18	2008-07-18 00:00:00	\N	\N	32020		\N	171929	0	396275006	80180		0
54334	3218	4283893	1987-07-01	1987-07-01 00:00:00	1987-07-15	1987-07-15 00:00:00	32020		\N	213861	0	36971009	4283893		0
54465	3226	4285898	2011-11-10	2011-11-10 00:00:00	\N	\N	32020		\N	214453	0	68496003	4285898		0
54673	3236	381316	2016-07-15	2016-07-15 00:00:00	\N	\N	32020		\N	215114	0	230690007	381316		0
54838	3246	260139	2002-10-10	2002-10-10 00:00:00	2002-10-17	2002-10-17 00:00:00	32020		\N	215779	0	10509002	260139		0
55075	3260	4310024	1995-12-20	1995-12-20 00:00:00	\N	\N	32020		\N	216700	0	424802006	4310024		0
65763	3889	4155034	2010-05-04	2010-05-04 00:00:00	2010-05-18	2010-05-18 00:00:00	32020		\N	258518	0	283371005	4155034		0
55347	3279	4278672	1995-03-27	1995-03-27 00:00:00	1995-06-25	1995-06-25 00:00:00	32020		\N	217921	0	65966004	4278672		0
55517	3289	40481087	1960-12-02	1960-12-02 00:00:00	1960-12-23	1960-12-23 00:00:00	32020		\N	218523	0	444814009	40481087		0
55698	3296	440448	1938-09-26	1938-09-26 00:00:00	\N	\N	32020		\N	219090	0	74400008	440448		0
45297	2693	195588	1983-10-08	1983-10-08 00:00:00	1983-11-11	1983-11-11 00:00:00	32020		\N	178368	0	38822007	195588		0
56095	3321	4294548	2000-06-18	2000-06-18 00:00:00	2000-08-06	2000-08-06 00:00:00	32020		\N	220525	0	75498004	4294548		0
56225	3332	260139	1982-03-25	1982-03-25 00:00:00	1982-04-01	1982-04-01 00:00:00	32020		\N	221072	0	10509002	260139		0
56369	3342	40481087	1944-08-30	1944-08-30 00:00:00	1944-09-06	1944-09-06 00:00:00	32020		\N	221606	0	444814009	40481087		0
56514	3352	372328	1976-09-20	1976-09-20 00:00:00	1976-10-22	1976-10-22 00:00:00	32020		\N	222308	0	65363002	372328		0
67265	3976	81151	2003-03-24	2003-03-24 00:00:00	2003-04-28	2003-04-28 00:00:00	32020		\N	264351	0	44465007	81151		0
56846	3371	4112343	1981-02-17	1981-02-17 00:00:00	1981-02-24	1981-02-24 00:00:00	32020		\N	223602	0	195662009	4112343		0
56986	3381	260139	1986-10-10	1986-10-10 00:00:00	1986-10-24	1986-10-24 00:00:00	32020		\N	224366	0	10509002	260139		0
46637	2776	40481087	2014-10-22	2014-10-22 00:00:00	2014-11-05	2014-11-05 00:00:00	32020		\N	183885	0	444814009	40481087		0
57342	3403	4310024	2006-05-21	2006-05-21 00:00:00	\N	\N	32020		\N	225744	0	424802006	4310024		0
57520	3413	260139	1982-08-23	1982-08-23 00:00:00	1982-08-30	1982-08-30 00:00:00	32020		\N	226378	0	10509002	260139		0
57696	3422	4029498	1978-12-16	1978-12-16 00:00:00	\N	\N	32020		\N	226981	0	128613002	4029498		0
57844	3432	4278672	1967-05-10	1967-05-10 00:00:00	1967-08-08	1967-08-08 00:00:00	32020		\N	227486	0	65966004	4278672		0
57994	3438	378419	1986-09-20	1986-09-20 00:00:00	\N	\N	32020		\N	228067	0	26929004	378419		0
58146	3444	4112343	1995-02-08	1995-02-08 00:00:00	1995-02-21	1995-02-21 00:00:00	32020		\N	228524	0	195662009	4112343		0
47773	2836	28060	2009-06-04	2009-06-04 00:00:00	2009-06-12	2009-06-12 00:00:00	32020		\N	188400	0	43878008	28060		0
47966	2846	28060	1979-06-21	1979-06-21 00:00:00	1979-06-29	1979-06-29 00:00:00	32020		\N	188993	0	43878008	28060		0
69255	4100	28060	1949-09-01	1949-09-01 00:00:00	1949-09-14	1949-09-14 00:00:00	32020		\N	272454	0	43878008	28060		0
48268	2861	40481087	2002-11-26	2002-11-26 00:00:00	2002-12-03	2002-12-03 00:00:00	32020		\N	190208	0	444814009	40481087		0
48425	2868	372328	1967-05-12	1967-05-12 00:00:00	1967-09-20	1967-09-20 00:00:00	32020		\N	190776	0	65363002	372328		0
59248	3514	81151	1982-05-30	1982-05-30 00:00:00	1982-06-27	1982-06-27 00:00:00	32020		\N	233212	0	44465007	81151		0
69954	4139	80180	2011-09-17	2011-09-17 00:00:00	\N	\N	32020		\N	275152	0	396275006	80180		0
59439	3526	40481087	1957-03-11	1957-03-11 00:00:00	1957-03-18	1957-03-18 00:00:00	32020		\N	233949	0	444814009	40481087		0
59702	3537	4027663	1992-06-17	1992-06-17 00:00:00	\N	\N	32020		\N	\N	0	13200003	4027663		0
59894	3549	4112343	2001-05-18	2001-05-18 00:00:00	2001-05-25	2001-05-25 00:00:00	32020		\N	235655	0	195662009	4112343		0
60046	3558	4155034	2011-03-09	2011-03-09 00:00:00	2011-03-23	2011-03-23 00:00:00	32020		\N	236217	0	283371005	4155034		0
60160	3561	4134304	1943-12-04	1943-12-04 00:00:00	1944-01-03	1944-01-03 00:00:00	32020		\N	236470	0	263102004	4134304		0
60330	3570	4112343	1995-02-28	1995-02-28 00:00:00	1995-03-12	1995-03-12 00:00:00	32020		\N	237278	0	195662009	4112343		0
49934	2950	81151	1986-09-05	1986-09-05 00:00:00	1986-10-10	1986-10-10 00:00:00	32020		\N	196939	0	44465007	81151		0
60670	3592	4283893	2006-01-05	2006-01-05 00:00:00	2006-02-09	2006-02-09 00:00:00	32020		\N	238595	0	36971009	4283893		0
50297	2975	4059173	2011-01-19	2011-01-19 00:00:00	2011-04-19	2011-04-19 00:00:00	32020		\N	198693	0	16114001	4059173		0
61034	3612	80180	2004-09-24	2004-09-24 00:00:00	\N	\N	32020		\N	239956	0	396275006	80180		0
61116	3616	80180	1991-09-05	1991-09-05 00:00:00	\N	\N	32020		\N	240261	0	396275006	80180		0
61287	3623	78272	1961-02-07	1961-02-07 00:00:00	1961-03-14	1961-03-14 00:00:00	32020		\N	240896	0	70704007	78272		0
61449	3630	80180	1992-05-23	1992-05-23 00:00:00	\N	\N	32020		\N	241525	0	396275006	80180		0
51085	3025	134438	1971-11-27	1971-11-27 00:00:00	1974-04-20	1974-04-20 00:00:00	32020		\N	201648	0	40275004	134438		0
61894	3654	260139	1994-02-07	1994-02-07 00:00:00	1994-02-21	1994-02-21 00:00:00	32020		\N	243202	0	10509002	260139		0
62021	3661	40481087	1981-02-03	1981-02-03 00:00:00	1981-02-17	1981-02-17 00:00:00	32020		\N	243653	0	444814009	40481087		0
62119	3668	81151	2008-08-17	2008-08-17 00:00:00	2008-09-07	2008-09-07 00:00:00	32020		\N	244022	0	44465007	81151		0
72899	4331	80180	2017-03-24	2017-03-24 00:00:00	\N	\N	32020		\N	287297	0	396275006	80180		0
62519	3694	260139	1961-06-18	1961-06-18 00:00:00	1961-07-02	1961-07-02 00:00:00	32020		\N	245475	0	10509002	260139		0
62606	3698	40481087	2014-04-14	2014-04-14 00:00:00	2014-04-28	2014-04-28 00:00:00	32020		\N	245885	0	444814009	40481087		0
62858	3714	78272	1940-03-05	1940-03-05 00:00:00	1940-03-26	1940-03-26 00:00:00	32020		\N	246845	0	70704007	78272		0
62921	3717	4112343	2010-02-02	2010-02-02 00:00:00	2010-02-11	2010-02-11 00:00:00	32020		\N	246992	0	195662009	4112343		0
73714	4380	260139	1971-09-13	1971-09-13 00:00:00	1971-09-20	1971-09-20 00:00:00	32020		\N	291028	0	10509002	260139		0
63395	3745	4059173	1933-03-01	1933-03-01 00:00:00	1933-03-31	1933-03-31 00:00:00	32020		\N	248874	0	16114001	4059173		0
63539	3752	40481087	1973-11-27	1973-11-27 00:00:00	1973-12-04	1973-12-04 00:00:00	32020		\N	249302	0	444814009	40481087		0
74228	4408	40481087	1993-07-19	1993-07-19 00:00:00	1993-08-09	1993-08-09 00:00:00	32020		\N	293015	0	444814009	40481087		0
53187	3149	40479422	1965-10-23	1965-10-23 00:00:00	1965-12-29	1965-12-29 00:00:00	32020		\N	209566	0	444448004	40479422		0
63920	3777	260139	2000-03-05	2000-03-05 00:00:00	2000-03-12	2000-03-12 00:00:00	32020		\N	251025	0	10509002	260139		0
53575	3175	40481087	2001-02-01	2001-02-01 00:00:00	2001-02-22	2001-02-22 00:00:00	32020		\N	211027	0	444814009	40481087		0
53672	3177	257012	1968-07-02	1968-07-02 00:00:00	\N	\N	32020		\N	211308	0	40055000	257012		0
43308	2579	260139	1996-10-06	1996-10-06 00:00:00	1996-10-13	1996-10-13 00:00:00	32020		\N	170772	0	10509002	260139		0
54050	3200	40481087	2002-03-01	2002-03-01 00:00:00	2002-03-22	2002-03-22 00:00:00	32020		\N	212875	0	444814009	40481087		0
43635	2598	40481087	2016-06-20	2016-06-20 00:00:00	2016-07-04	2016-07-04 00:00:00	32020		\N	171896	0	444814009	40481087		0
54335	3218	4112343	2017-09-07	2017-09-07 00:00:00	2017-09-19	2017-09-19 00:00:00	32020		\N	213816	0	195662009	4112343		0
54466	3226	30753	2010-12-15	2010-12-15 00:00:00	\N	\N	32020		\N	214453	0	16761005	30753		0
54674	3236	4112343	2016-06-27	2016-06-27 00:00:00	2016-07-04	2016-07-04 00:00:00	32020		\N	215114	0	195662009	4112343		0
54839	3246	80180	2016-12-31	2016-12-31 00:00:00	\N	\N	32020		\N	215778	0	396275006	80180		0
55076	3260	260139	1989-10-07	1989-10-07 00:00:00	1989-10-21	1989-10-21 00:00:00	32020		\N	216705	0	10509002	260139		0
65764	3889	4113008	1949-06-11	1949-06-11 00:00:00	1949-07-02	1949-07-02 00:00:00	32020		\N	258516	0	284549007	4113008		0
55348	3279	40481087	1955-02-02	1955-02-02 00:00:00	1955-02-16	1955-02-16 00:00:00	32020		\N	217899	0	444814009	40481087		0
55518	3289	260139	1989-06-07	1989-06-07 00:00:00	1989-06-14	1989-06-14 00:00:00	32020		\N	218530	0	10509002	260139		0
55699	3296	4166224	1938-09-26	1938-09-26 00:00:00	\N	\N	32020		\N	219090	0	47693006	4166224		0
45298	2693	4112343	1959-01-14	1959-01-14 00:00:00	1959-01-27	1959-01-27 00:00:00	32020		\N	178420	0	195662009	4112343		0
56096	3321	4112343	2005-10-08	2005-10-08 00:00:00	2005-10-17	2005-10-17 00:00:00	32020		\N	220512	0	195662009	4112343		0
56226	3332	40481087	1982-07-13	1982-07-13 00:00:00	1982-07-20	1982-07-20 00:00:00	32020		\N	221101	0	444814009	40481087		0
56370	3342	40481087	1960-01-28	1960-01-28 00:00:00	1960-02-04	1960-02-04 00:00:00	32020		\N	221667	0	444814009	40481087		0
56515	3352	40481087	1973-04-11	1973-04-11 00:00:00	1973-04-25	1973-04-25 00:00:00	32020		\N	222283	0	444814009	40481087		0
67266	3976	4112343	2018-10-13	2018-10-13 00:00:00	2018-10-23	2018-10-23 00:00:00	32020		\N	264360	0	195662009	4112343		0
56847	3371	4112343	1982-07-21	1982-07-21 00:00:00	1982-08-02	1982-08-02 00:00:00	32020		\N	223574	0	195662009	4112343		0
56987	3381	80180	2011-01-15	2011-01-15 00:00:00	\N	\N	32020		\N	224362	0	396275006	80180		0
46638	2776	40481087	2002-11-01	2002-11-01 00:00:00	2002-11-15	2002-11-15 00:00:00	32020		\N	183768	0	444814009	40481087		0
57343	3403	4218389	2005-11-22	2005-11-22 00:00:00	2005-12-13	2005-12-13 00:00:00	32020		\N	225744	0	39848009	4218389		0
57521	3413	80180	2001-07-07	2001-07-07 00:00:00	\N	\N	32020		\N	226405	0	396275006	80180		0
57697	3422	134438	1993-12-19	1993-12-19 00:00:00	1994-10-20	1994-10-20 00:00:00	32020		\N	226986	0	40275004	134438		0
57845	3432	4113008	1992-07-16	1992-07-16 00:00:00	1992-07-30	1992-07-30 00:00:00	32020		\N	227489	0	284549007	4113008		0
57995	3438	40481087	1920-02-13	1920-02-13 00:00:00	1920-03-05	1920-03-05 00:00:00	32020		\N	228071	0	444814009	40481087		0
58147	3444	40481087	1954-04-10	1954-04-10 00:00:00	1954-05-01	1954-05-01 00:00:00	32020		\N	228518	0	444814009	40481087		0
47774	2837	40481087	1994-09-02	1994-09-02 00:00:00	1994-09-09	1994-09-09 00:00:00	32020		\N	188418	0	444814009	40481087		0
47967	2846	4059173	1979-12-30	1979-12-30 00:00:00	1980-03-29	1980-03-29 00:00:00	32020		\N	188987	0	16114001	4059173		0
69256	4100	4112343	2013-12-31	2013-12-31 00:00:00	2014-01-11	2014-01-11 00:00:00	32020		\N	272456	0	195662009	4112343		0
48269	2861	4112343	1970-03-15	1970-03-15 00:00:00	1970-03-26	1970-03-26 00:00:00	32020		\N	190206	0	195662009	4112343		0
48426	2868	375671	2001-03-03	2001-03-03 00:00:00	2001-04-02	2001-04-02 00:00:00	32020		\N	190819	0	62564004	375671		0
59249	3514	81151	1987-03-03	1987-03-03 00:00:00	1987-03-17	1987-03-17 00:00:00	32020		\N	233213	0	44465007	81151		0
69955	4139	4285898	2011-01-20	2011-01-20 00:00:00	\N	\N	32020		\N	275152	0	68496003	4285898		0
59440	3526	4296204	1961-12-24	1961-12-24 00:00:00	1962-01-07	1962-01-07 00:00:00	32020		\N	234000	0	403190006	4296204		0
59703	3537	4294548	2012-04-21	2012-04-21 00:00:00	2012-05-26	2012-05-26 00:00:00	32020		\N	234954	0	75498004	4294548		0
59895	3549	4112343	1972-01-19	1972-01-19 00:00:00	1972-01-26	1972-01-26 00:00:00	32020		\N	235666	0	195662009	4112343		0
60047	3558	258780	2015-05-02	2015-05-02 00:00:00	\N	\N	32020		\N	236189	0	185086009	258780		0
60161	3561	81893	1941-12-19	1941-12-19 00:00:00	\N	\N	32020		\N	236417	0	64766004	81893		0
60331	3570	260139	1957-01-16	1957-01-16 00:00:00	1957-01-23	1957-01-23 00:00:00	32020		\N	237287	0	10509002	260139		0
49935	2950	40481087	2001-04-29	2001-04-29 00:00:00	2001-05-20	2001-05-20 00:00:00	32020		\N	196973	0	444814009	40481087		0
60671	3592	40481087	1992-03-18	1992-03-18 00:00:00	1992-03-25	1992-03-25 00:00:00	32020		\N	238588	0	444814009	40481087		0
50298	2975	4294548	1976-03-01	1976-03-01 00:00:00	1976-03-08	1976-03-08 00:00:00	32020		\N	198660	0	75498004	4294548		0
61035	3612	4116491	2004-02-12	2004-02-12 00:00:00	2004-03-22	2004-03-22 00:00:00	32020		\N	239956	0	301011002	4116491		0
61117	3616	40481087	1991-06-09	1991-06-09 00:00:00	1991-06-30	1991-06-30 00:00:00	32020		\N	240261	0	444814009	40481087		0
61288	3623	28060	1964-05-01	1964-05-01 00:00:00	1964-05-11	1964-05-11 00:00:00	32020		\N	240892	0	43878008	28060		0
61450	3630	260139	1964-06-25	1964-06-25 00:00:00	1964-07-09	1964-07-09 00:00:00	32020		\N	241571	0	10509002	260139		0
51086	3025	4218389	1996-02-23	1996-02-23 00:00:00	1996-03-15	1996-03-15 00:00:00	32020		\N	201586	0	39848009	4218389		0
61895	3654	260139	1975-01-14	1975-01-14 00:00:00	1975-01-21	1975-01-21 00:00:00	32020		\N	243184	0	10509002	260139		0
62022	3661	195588	2011-03-19	2011-03-19 00:00:00	2011-05-10	2011-05-10 00:00:00	32020		\N	243623	0	38822007	195588		0
62120	3668	378001	1989-05-19	1989-05-19 00:00:00	1989-06-18	1989-06-18 00:00:00	32020		\N	244028	0	62106007	378001		0
72900	4331	40481087	2009-08-31	2009-08-31 00:00:00	2009-09-14	2009-09-14 00:00:00	32020		\N	287298	0	444814009	40481087		0
62520	3694	4109685	1961-11-05	1961-11-05 00:00:00	1961-11-19	1961-11-19 00:00:00	32020		\N	245558	0	284551006	4109685		0
62607	3698	372328	1952-10-26	1952-10-26 00:00:00	1953-02-10	1953-02-10 00:00:00	32020		\N	245878	0	65363002	372328		0
62859	3714	4112343	1924-05-09	1924-05-09 00:00:00	1924-05-19	1924-05-19 00:00:00	32020		\N	246851	0	195662009	4112343		0
62922	3717	260139	1989-11-14	1989-11-14 00:00:00	1989-11-21	1989-11-21 00:00:00	32020		\N	247078	0	10509002	260139		0
73715	4380	4112343	1986-04-28	1986-04-28 00:00:00	1986-05-07	1986-05-07 00:00:00	32020		\N	291021	0	195662009	4112343		0
63396	3745	4296205	1932-03-01	1932-03-01 00:00:00	1932-04-05	1932-04-05 00:00:00	32020		\N	248873	0	403191005	4296205		0
63540	3752	4266809	1997-11-17	1997-11-17 00:00:00	\N	\N	32020		\N	249321	0	397881000	4266809		0
74229	4408	257012	1986-10-21	1986-10-21 00:00:00	\N	\N	32020		\N	293020	0	40055000	257012		0
53188	3149	40481087	1951-10-24	1951-10-24 00:00:00	1951-11-07	1951-11-07 00:00:00	32020		\N	209486	0	444814009	40481087		0
63921	3777	4283893	1996-07-27	1996-07-27 00:00:00	1996-11-30	1996-11-30 00:00:00	32020		\N	251002	0	36971009	4283893		0
53576	3175	4294548	1960-09-14	1960-09-14 00:00:00	1960-09-28	1960-09-28 00:00:00	32020		\N	211018	0	75498004	4294548		0
53673	3178	4283893	1992-04-27	1992-04-27 00:00:00	1992-11-23	1992-11-23 00:00:00	32020		\N	211373	0	36971009	4283893		0
43309	2579	40481087	2008-02-10	2008-02-10 00:00:00	2008-03-02	2008-03-02 00:00:00	32020		\N	170775	0	444814009	40481087		0
54051	3200	4112343	1992-04-14	1992-04-14 00:00:00	1992-04-23	1992-04-23 00:00:00	32020		\N	212874	0	195662009	4112343		0
43636	2598	40481087	1998-11-20	1998-11-20 00:00:00	1998-11-27	1998-11-27 00:00:00	32020		\N	171903	0	444814009	40481087		0
54336	3218	40481087	1998-06-09	1998-06-09 00:00:00	1998-06-16	1998-06-16 00:00:00	32020		\N	213815	0	444814009	40481087		0
54467	3226	192671	2012-08-04	2012-08-04 00:00:00	\N	\N	32020		\N	214447	0	K92.2	35208414		0
54675	3236	4112343	1953-10-03	1953-10-03 00:00:00	1953-10-16	1953-10-16 00:00:00	32020		\N	215064	0	195662009	4112343		0
54840	3246	260139	2012-07-29	2012-07-29 00:00:00	2012-08-05	2012-08-05 00:00:00	32020		\N	215792	0	10509002	260139		0
55077	3260	4027663	1989-03-26	1989-03-26 00:00:00	\N	\N	32020		\N	216740	0	13200003	4027663		0
65765	3889	260139	1943-11-12	1943-11-12 00:00:00	1943-11-26	1943-11-26 00:00:00	32020		\N	258496	0	10509002	260139		0
55349	3279	260139	1958-07-11	1958-07-11 00:00:00	1958-07-25	1958-07-25 00:00:00	32020		\N	217895	0	10509002	260139		0
55519	3289	40481087	1986-11-26	1986-11-26 00:00:00	1986-12-17	1986-12-17 00:00:00	32020		\N	218461	0	444814009	40481087		0
55700	3296	40481087	1958-02-07	1958-02-07 00:00:00	1958-02-28	1958-02-28 00:00:00	32020		\N	219042	0	444814009	40481087		0
45299	2693	372328	1963-06-20	1963-06-20 00:00:00	1963-09-24	1963-09-24 00:00:00	32020		\N	178378	0	65363002	372328		0
66567	3939	40481087	2012-08-01	2012-08-01 00:00:00	2012-08-15	2012-08-15 00:00:00	32020		\N	261820	0	444814009	40481087		0
56227	3332	372328	1962-04-30	1962-04-30 00:00:00	1962-05-14	1962-05-14 00:00:00	32020		\N	221089	0	65363002	372328		0
56371	3342	80502	1989-11-01	1989-11-01 00:00:00	\N	\N	32020		\N	221595	0	64859006	80502		0
56516	3352	40481087	2018-08-21	2018-08-21 00:00:00	2018-09-04	2018-09-04 00:00:00	32020		\N	222271	0	444814009	40481087		0
67267	3976	40481087	1998-10-24	1998-10-24 00:00:00	1998-11-07	1998-11-07 00:00:00	32020		\N	264346	0	444814009	40481087		0
56878	3375	440448	1967-03-04	1967-03-04 00:00:00	\N	\N	32020		\N	223886	0	74400008	440448		0
56988	3381	40481087	2013-05-18	2013-05-18 00:00:00	2013-06-01	2013-06-01 00:00:00	32020		\N	224368	0	444814009	40481087		0
46639	2776	372328	1984-11-21	1984-11-21 00:00:00	1985-10-20	1985-10-20 00:00:00	32020		\N	183816	0	65363002	372328		0
57344	3403	81151	1986-07-21	1986-07-21 00:00:00	1986-08-04	1986-08-04 00:00:00	32020		\N	225743	0	44465007	81151		0
57522	3413	4112343	1999-12-20	1999-12-20 00:00:00	1999-12-28	1999-12-28 00:00:00	32020		\N	226412	0	195662009	4112343		0
57698	3422	260139	1980-05-10	1980-05-10 00:00:00	1980-05-17	1980-05-17 00:00:00	32020		\N	227024	0	10509002	260139		0
57846	3432	4112343	2017-08-31	2017-08-31 00:00:00	2017-09-10	2017-09-10 00:00:00	32020		\N	227500	0	195662009	4112343		0
57996	3438	260139	1977-08-11	1977-08-11 00:00:00	1977-08-18	1977-08-18 00:00:00	32020		\N	228116	0	10509002	260139		0
58148	3444	372328	1941-02-04	1941-02-04 00:00:00	1941-04-07	1941-04-07 00:00:00	32020		\N	228581	0	65363002	372328		0
47775	2837	375671	1988-05-09	1988-05-09 00:00:00	1988-06-08	1988-06-08 00:00:00	32020		\N	188458	0	62564004	375671		0
47968	2846	260139	2003-11-21	2003-11-21 00:00:00	2003-12-05	2003-12-05 00:00:00	32020		\N	189013	0	10509002	260139		0
69257	4100	4283893	2014-04-11	2014-04-11 00:00:00	2014-09-12	2014-09-12 00:00:00	32020		\N	272416	0	36971009	4283893		0
48270	2861	4112343	1980-10-17	1980-10-17 00:00:00	1980-10-30	1980-10-30 00:00:00	32020		\N	190171	0	195662009	4112343		0
48427	2868	40481087	1985-07-09	1985-07-09 00:00:00	1985-07-16	1985-07-16 00:00:00	32020		\N	190763	0	444814009	40481087		0
59251	3514	40481087	2004-03-23	2004-03-23 00:00:00	2004-03-30	2004-03-30 00:00:00	32020		\N	233188	0	444814009	40481087		0
69956	4139	4266809	2011-09-17	2011-09-17 00:00:00	\N	\N	32020		\N	275152	0	397881000	4266809		0
59441	3526	4134304	1964-09-23	1964-09-23 00:00:00	1964-10-23	1964-10-23 00:00:00	32020		\N	234001	0	263102004	4134304		0
59704	3537	260139	1998-10-09	1998-10-09 00:00:00	1998-10-23	1998-10-23 00:00:00	32020		\N	234938	0	10509002	260139		0
59896	3549	4283893	1990-06-23	1990-06-23 00:00:00	1990-10-20	1990-10-20 00:00:00	32020		\N	235668	0	36971009	4283893		0
60048	3558	372328	1961-01-16	1961-01-16 00:00:00	1961-03-04	1961-03-04 00:00:00	32020		\N	236229	0	65363002	372328		0
60162	3561	4112343	1940-08-15	1940-08-15 00:00:00	1940-08-22	1940-08-22 00:00:00	32020		\N	236417	0	195662009	4112343		0
60332	3570	260139	1952-04-19	1952-04-19 00:00:00	1952-04-26	1952-04-26 00:00:00	32020		\N	237264	0	10509002	260139		0
49936	2950	40481087	2007-10-16	2007-10-16 00:00:00	2007-10-30	2007-10-30 00:00:00	32020		\N	196899	0	444814009	40481087		0
60672	3592	80180	2001-07-07	2001-07-07 00:00:00	\N	\N	32020		\N	238627	0	396275006	80180		0
60767	3598	40481087	1945-02-25	1945-02-25 00:00:00	1945-03-18	1945-03-18 00:00:00	32020		\N	238921	0	444814009	40481087		0
61036	3612	4056621	2004-02-12	2004-02-12 00:00:00	\N	\N	32020		\N	239956	0	197927001	4056621		0
61118	3616	4112343	1969-01-11	1969-01-11 00:00:00	1969-01-22	1969-01-22 00:00:00	32020		\N	240260	0	195662009	4112343		0
61289	3623	40481087	2002-12-16	2002-12-16 00:00:00	2002-12-30	2002-12-30 00:00:00	32020		\N	240868	0	444814009	40481087		0
61451	3630	4112343	1963-09-30	1963-09-30 00:00:00	1963-10-07	1963-10-07 00:00:00	32020		\N	241515	0	195662009	4112343		0
51087	3025	372328	1950-05-25	1950-05-25 00:00:00	1950-11-06	1950-11-06 00:00:00	32020		\N	201645	0	65363002	372328		0
61896	3654	40481087	1998-07-07	1998-07-07 00:00:00	1998-07-28	1998-07-28 00:00:00	32020		\N	243203	0	444814009	40481087		0
62023	3661	4051466	1982-02-18	1982-02-18 00:00:00	1997-06-01	1997-06-01 00:00:00	32020		\N	243669	0	233678006	4051466		0
62121	3668	4116491	2006-08-23	2006-08-23 00:00:00	2006-10-15	2006-10-15 00:00:00	32020		\N	244016	0	301011002	4116491		0
72907	4333	192671	1994-08-13	1994-08-13 00:00:00	\N	\N	32020		\N	287398	0	K92.2	35208414		0
62521	3694	80180	1995-11-16	1995-11-16 00:00:00	\N	\N	32020		\N	245516	0	396275006	80180		0
62608	3698	40481087	1968-08-24	1968-08-24 00:00:00	1968-09-14	1968-09-14 00:00:00	32020		\N	245857	0	444814009	40481087		0
62860	3714	4112343	1929-06-25	1929-06-25 00:00:00	1929-07-03	1929-07-03 00:00:00	32020		\N	246853	0	195662009	4112343		0
62923	3717	80180	2014-01-19	2014-01-19 00:00:00	\N	\N	32020		\N	247073	0	396275006	80180		0
73716	4380	40481087	2018-01-13	2018-01-13 00:00:00	2018-02-03	2018-02-03 00:00:00	32020		\N	291067	0	444814009	40481087		0
63397	3745	260139	1984-05-13	1984-05-13 00:00:00	1984-05-20	1984-05-20 00:00:00	32020		\N	248956	0	10509002	260139		0
63541	3752	4056621	1996-02-18	1996-02-18 00:00:00	\N	\N	32020		\N	249321	0	197927001	4056621		0
74230	4408	372328	1982-05-17	1982-05-17 00:00:00	1982-07-01	1982-07-01 00:00:00	32020		\N	293018	0	65363002	372328		0
53189	3149	40481087	1953-12-31	1953-12-31 00:00:00	1954-01-21	1954-01-21 00:00:00	32020		\N	209490	0	444814009	40481087		0
63922	3777	257012	1996-11-23	1996-11-23 00:00:00	\N	\N	32020		\N	251003	0	40055000	257012		0
53577	3175	4112343	1992-07-28	1992-07-28 00:00:00	1992-08-06	1992-08-06 00:00:00	32020		\N	211049	0	195662009	4112343		0
53674	3178	40481087	1979-09-25	1979-09-25 00:00:00	1979-10-02	1979-10-02 00:00:00	32020		\N	211371	0	444814009	40481087		0
43310	2579	440448	2008-04-07	2008-04-07 00:00:00	\N	\N	32020		\N	170792	0	74400008	440448		0
54052	3200	4112343	1950-01-05	1950-01-05 00:00:00	1950-01-16	1950-01-16 00:00:00	32020		\N	212788	0	195662009	4112343		0
43637	2598	4112343	2001-12-13	2001-12-13 00:00:00	2001-12-23	2001-12-23 00:00:00	32020		\N	171926	0	195662009	4112343		0
54337	3218	40481087	1993-09-07	1993-09-07 00:00:00	1993-09-28	1993-09-28 00:00:00	32020		\N	213862	0	444814009	40481087		0
54468	3226	4156265	1984-04-06	1984-04-06 00:00:00	1984-04-27	1984-04-27 00:00:00	32020		\N	214449	0	370247008	4156265		0
54676	3236	4156265	1994-06-07	1994-06-07 00:00:00	1994-06-21	1994-06-21 00:00:00	32020		\N	215032	0	370247008	4156265		0
54841	3246	260139	2013-07-03	2013-07-03 00:00:00	2013-07-10	2013-07-10 00:00:00	32020		\N	215806	0	10509002	260139		0
55078	3260	4218389	1996-09-14	1996-09-14 00:00:00	1996-10-05	1996-10-05 00:00:00	32020		\N	216751	0	39848009	4218389		0
65766	3889	372328	1941-06-23	1941-06-23 00:00:00	1941-08-17	1941-08-17 00:00:00	32020		\N	258497	0	65363002	372328		0
55350	3279	40481087	1972-03-16	1972-03-16 00:00:00	1972-03-30	1972-03-30 00:00:00	32020		\N	217897	0	444814009	40481087		0
55520	3289	81893	1993-08-10	1993-08-10 00:00:00	\N	\N	32020		\N	218537	0	64766004	81893		0
55701	3296	4059173	1949-02-19	1949-02-19 00:00:00	1949-03-21	1949-03-21 00:00:00	32020		\N	219091	0	16114001	4059173		0
45300	2693	260139	1977-08-27	1977-08-27 00:00:00	1977-09-03	1977-09-03 00:00:00	32020		\N	178403	0	10509002	260139		0
66568	3939	40481087	2005-11-09	2005-11-09 00:00:00	2005-11-30	2005-11-30 00:00:00	32020		\N	261865	0	444814009	40481087		0
56228	3332	78272	1983-01-01	1983-01-01 00:00:00	1983-01-22	1983-01-22 00:00:00	32020		\N	221132	0	70704007	78272		0
56372	3342	4155034	1968-07-14	1968-07-14 00:00:00	1968-07-28	1968-07-28 00:00:00	32020		\N	221566	0	283371005	4155034		0
56517	3353	260139	1955-04-02	1955-04-02 00:00:00	1955-04-16	1955-04-16 00:00:00	32020		\N	222390	0	10509002	260139		0
67268	3976	372328	1966-12-28	1966-12-28 00:00:00	1967-03-23	1967-03-23 00:00:00	32020		\N	264361	0	65363002	372328		0
56879	3375	4166224	1967-03-04	1967-03-04 00:00:00	\N	\N	32020		\N	223886	0	47693006	4166224		0
56989	3381	4112343	2008-08-19	2008-08-19 00:00:00	2008-08-30	2008-08-30 00:00:00	32020		\N	224350	0	195662009	4112343		0
46640	2776	372328	1982-01-28	1982-01-28 00:00:00	1982-10-03	1982-10-03 00:00:00	32020		\N	183815	0	65363002	372328		0
57345	3403	30753	2007-10-13	2007-10-13 00:00:00	\N	\N	32020		\N	225764	0	16761005	30753		0
57523	3413	40481087	2006-10-27	2006-10-27 00:00:00	2006-11-17	2006-11-17 00:00:00	32020		\N	226413	0	444814009	40481087		0
57699	3422	28060	2012-09-19	2012-09-19 00:00:00	2012-09-29	2012-09-29 00:00:00	32020		\N	227029	0	43878008	28060		0
57847	3432	4112343	2008-08-24	2008-08-24 00:00:00	2008-09-01	2008-09-01 00:00:00	32020		\N	227499	0	195662009	4112343		0
57997	3438	4112343	1916-08-10	1916-08-10 00:00:00	1916-08-23	1916-08-23 00:00:00	32020		\N	228070	0	195662009	4112343		0
58149	3444	28060	1954-02-10	1954-02-10 00:00:00	1954-02-20	1954-02-20 00:00:00	32020		\N	228615	0	43878008	28060		0
47776	2837	40481087	2018-05-12	2018-05-12 00:00:00	2018-05-26	2018-05-26 00:00:00	32020		\N	188477	0	444814009	40481087		0
47969	2846	260139	2001-08-24	2001-08-24 00:00:00	2001-08-31	2001-08-31 00:00:00	32020		\N	189036	0	10509002	260139		0
69258	4100	378001	1943-12-30	1943-12-30 00:00:00	1944-01-29	1944-01-29 00:00:00	32020		\N	272464	0	62106007	378001		0
48271	2861	40481087	2015-12-05	2015-12-05 00:00:00	2015-12-26	2015-12-26 00:00:00	32020		\N	190198	0	444814009	40481087		0
48428	2868	40481087	1965-06-03	1965-06-03 00:00:00	1965-06-17	1965-06-17 00:00:00	32020		\N	190796	0	444814009	40481087		0
59252	3514	260139	1989-09-09	1989-09-09 00:00:00	1989-09-16	1989-09-16 00:00:00	32020		\N	233187	0	10509002	260139		0
69957	4139	4296204	2016-01-23	2016-01-23 00:00:00	2016-02-27	2016-02-27 00:00:00	32020		\N	275165	0	403190006	4296204		0
59442	3526	4218389	1966-10-13	1966-10-13 00:00:00	1966-11-17	1966-11-17 00:00:00	32020		\N	234002	0	39848009	4218389		0
59705	3537	40481087	2004-11-17	2004-11-17 00:00:00	2004-12-01	2004-12-01 00:00:00	32020		\N	234952	0	444814009	40481087		0
59897	3549	260139	1986-08-03	1986-08-03 00:00:00	1986-08-17	1986-08-17 00:00:00	32020		\N	235667	0	10509002	260139		0
60049	3558	40481087	1984-05-18	1984-05-18 00:00:00	1984-06-08	1984-06-08 00:00:00	32020		\N	236175	0	444814009	40481087		0
60163	3562	4112343	1975-02-20	1975-02-20 00:00:00	1975-02-27	1975-02-27 00:00:00	32020		\N	236604	0	195662009	4112343		0
60333	3570	4134304	1961-10-03	1961-10-03 00:00:00	1961-12-02	1961-12-02 00:00:00	32020		\N	237224	0	263102004	4134304		0
49937	2950	4112343	1949-01-26	1949-01-26 00:00:00	1949-02-08	1949-02-08 00:00:00	32020		\N	196895	0	195662009	4112343		0
60673	3592	40481087	2018-07-14	2018-07-14 00:00:00	2018-07-28	2018-07-28 00:00:00	32020		\N	238596	0	444814009	40481087		0
60768	3598	4112343	1977-06-02	1977-06-02 00:00:00	1977-06-14	1977-06-14 00:00:00	32020		\N	238924	0	195662009	4112343		0
61037	3612	4112343	1985-06-20	1985-06-20 00:00:00	1985-06-28	1985-06-28 00:00:00	32020		\N	239961	0	195662009	4112343		0
61119	3616	4152936	2019-06-01	2019-06-01 00:00:00	2019-06-15	2019-06-15 00:00:00	32020		\N	240294	0	283385000	4152936		0
61290	3623	81151	2012-03-01	2012-03-01 00:00:00	2012-04-05	2012-04-05 00:00:00	32020		\N	240939	0	44465007	81151		0
61452	3630	4142905	1979-05-07	1979-05-07 00:00:00	1979-08-05	1979-08-05 00:00:00	32020		\N	241555	0	33737001	4142905		0
51088	3025	78272	1953-10-15	1953-10-15 00:00:00	1953-11-05	1953-11-05 00:00:00	32020		\N	201582	0	70704007	78272		0
61897	3655	40481087	1951-01-13	1951-01-13 00:00:00	1951-01-27	1951-01-27 00:00:00	32020		\N	243250	0	444814009	40481087		0
62024	3661	260139	1988-01-13	1988-01-13 00:00:00	1988-01-27	1988-01-27 00:00:00	32020		\N	243654	0	10509002	260139		0
62122	3668	372328	1991-12-13	1991-12-13 00:00:00	1992-09-13	1992-09-13 00:00:00	32020		\N	244044	0	65363002	372328		0
72908	4333	260139	1970-12-27	1970-12-27 00:00:00	1971-01-03	1971-01-03 00:00:00	32020		\N	287355	0	10509002	260139		0
62522	3694	40481087	1995-10-08	1995-10-08 00:00:00	1995-10-22	1995-10-22 00:00:00	32020		\N	245516	0	444814009	40481087		0
62609	3698	4112343	1975-11-28	1975-11-28 00:00:00	1975-12-06	1975-12-06 00:00:00	32020		\N	245853	0	195662009	4112343		0
62861	3714	4112343	1958-07-14	1958-07-14 00:00:00	1958-07-26	1958-07-26 00:00:00	32020		\N	246796	0	195662009	4112343		0
62924	3717	372328	1981-03-13	1981-03-13 00:00:00	1981-04-18	1981-04-18 00:00:00	32020		\N	247051	0	65363002	372328		0
73717	4380	40481087	1991-06-19	1991-06-19 00:00:00	1991-07-03	1991-07-03 00:00:00	32020		\N	291022	0	444814009	40481087		0
63398	3745	4112343	1955-12-29	1955-12-29 00:00:00	1956-01-09	1956-01-09 00:00:00	32020		\N	248912	0	195662009	4112343		0
63542	3752	81893	1996-04-26	1996-04-26 00:00:00	\N	\N	32020		\N	249321	0	64766004	81893		0
74231	4408	372328	1984-07-20	1984-07-20 00:00:00	1984-12-27	1984-12-27 00:00:00	32020		\N	293023	0	65363002	372328		0
53190	3150	4237458	1957-01-22	1957-01-22 00:00:00	1957-02-21	1957-02-21 00:00:00	32020		\N	209568	0	58150001	4237458		0
63923	3777	40481087	2001-03-14	2001-03-14 00:00:00	2001-03-28	2001-03-28 00:00:00	32020		\N	251042	0	444814009	40481087		0
53578	3175	372328	1954-11-19	1954-11-19 00:00:00	1955-02-01	1955-02-01 00:00:00	32020		\N	211039	0	65363002	372328		0
53675	3178	4112343	1958-12-04	1958-12-04 00:00:00	1958-12-11	1958-12-11 00:00:00	32020		\N	211417	0	195662009	4112343		0
43311	2579	260139	2000-03-31	2000-03-31 00:00:00	2000-04-14	2000-04-14 00:00:00	32020		\N	170773	0	10509002	260139		0
54053	3200	4112343	1963-09-17	1963-09-17 00:00:00	1963-09-28	1963-09-28 00:00:00	32020		\N	212789	0	195662009	4112343		0
43638	2598	40481087	2004-02-05	2004-02-05 00:00:00	2004-02-19	2004-02-19 00:00:00	32020		\N	171911	0	444814009	40481087		0
54338	3218	40481087	1993-04-18	1993-04-18 00:00:00	1993-05-02	1993-05-02 00:00:00	32020		\N	213834	0	444814009	40481087		0
54469	3226	4027663	1999-09-29	1999-09-29 00:00:00	\N	\N	32020		\N	\N	0	13200003	4027663		0
54677	3236	260139	1952-02-05	1952-02-05 00:00:00	1952-02-12	1952-02-12 00:00:00	32020		\N	215054	0	10509002	260139		0
55079	3260	4112343	1999-02-03	1999-02-03 00:00:00	1999-02-16	1999-02-16 00:00:00	32020		\N	216707	0	195662009	4112343		0
65767	3889	40481087	2018-12-16	2018-12-16 00:00:00	2018-12-23	2018-12-23 00:00:00	32020		\N	258506	0	444814009	40481087		0
55351	3279	40481087	1970-10-25	1970-10-25 00:00:00	1970-11-15	1970-11-15 00:00:00	32020		\N	217896	0	444814009	40481087		0
55521	3289	28060	1993-04-20	1993-04-20 00:00:00	1993-05-03	1993-05-03 00:00:00	32020		\N	218537	0	43878008	28060		0
55702	3296	260139	1998-04-22	1998-04-22 00:00:00	1998-04-29	1998-04-29 00:00:00	32020		\N	219024	0	10509002	260139		0
45301	2693	4283893	1979-01-18	1979-01-18 00:00:00	1979-05-24	1979-05-24 00:00:00	32020		\N	178426	0	36971009	4283893		0
66569	3939	40481087	1992-01-24	1992-01-24 00:00:00	1992-02-07	1992-02-07 00:00:00	32020		\N	261864	0	444814009	40481087		0
56229	3332	4059173	1969-07-22	1969-07-22 00:00:00	1969-10-20	1969-10-20 00:00:00	32020		\N	221130	0	16114001	4059173		0
56373	3342	81151	1924-08-08	1924-08-08 00:00:00	1924-08-29	1924-08-29 00:00:00	32020		\N	221629	0	44465007	81151		0
56518	3353	4059173	1937-11-19	1937-11-19 00:00:00	1937-12-19	1937-12-19 00:00:00	32020		\N	222424	0	16114001	4059173		0
67269	3976	4027663	1997-04-09	1997-04-09 00:00:00	\N	\N	32020		\N	264332	0	13200003	4027663		0
56881	3375	40481087	2007-10-12	2007-10-12 00:00:00	2007-10-26	2007-10-26 00:00:00	32020		\N	223872	0	444814009	40481087		0
56990	3381	81151	2007-01-15	2007-01-15 00:00:00	2007-02-19	2007-02-19 00:00:00	32020		\N	224398	0	44465007	81151		0
46641	2776	4285898	2013-02-18	2013-02-18 00:00:00	\N	\N	32020		\N	183859	0	68496003	4285898		0
57346	3403	4112343	2011-04-11	2011-04-11 00:00:00	2011-04-20	2011-04-20 00:00:00	32020		\N	225758	0	195662009	4112343		0
57524	3413	4112343	1977-12-24	1977-12-24 00:00:00	1978-01-04	1978-01-04 00:00:00	32020		\N	226375	0	195662009	4112343		0
57700	3422	257012	1970-01-30	1970-01-30 00:00:00	\N	\N	32020		\N	226958	0	40055000	257012		0
57848	3432	4112343	2001-06-06	2001-06-06 00:00:00	2001-06-18	2001-06-18 00:00:00	32020		\N	227545	0	195662009	4112343		0
57998	3438	80502	1989-06-17	1989-06-17 00:00:00	\N	\N	32020		\N	228104	0	64859006	80502		0
58150	3444	40481087	1954-10-03	1954-10-03 00:00:00	1954-10-10	1954-10-10 00:00:00	32020		\N	228616	0	444814009	40481087		0
47777	2837	40481087	2001-11-10	2001-11-10 00:00:00	2001-11-17	2001-11-17 00:00:00	32020		\N	188451	0	444814009	40481087		0
47970	2846	4112343	2017-09-16	2017-09-16 00:00:00	2017-09-26	2017-09-26 00:00:00	32020		\N	189038	0	195662009	4112343		0
69259	4100	4112343	2003-06-07	2003-06-07 00:00:00	2003-06-14	2003-06-14 00:00:00	32020		\N	272395	0	195662009	4112343		0
48272	2861	80180	2006-10-10	2006-10-10 00:00:00	\N	\N	32020		\N	190232	0	396275006	80180		0
48429	2868	80180	2003-10-15	2003-10-15 00:00:00	\N	\N	32020		\N	190783	0	396275006	80180		0
59253	3514	260139	1981-06-14	1981-06-14 00:00:00	1981-06-21	1981-06-21 00:00:00	32020		\N	233184	0	10509002	260139		0
69958	4139	372328	1971-07-04	1971-07-04 00:00:00	1971-10-15	1971-10-15 00:00:00	32020		\N	275137	0	65363002	372328		0
59443	3526	40481087	1968-03-12	1968-03-12 00:00:00	1968-03-26	1968-03-26 00:00:00	32020		\N	233907	0	444814009	40481087		0
59706	3537	80180	2002-04-01	2002-04-01 00:00:00	\N	\N	32020		\N	234951	0	396275006	80180		0
59898	3549	40481087	1959-05-23	1959-05-23 00:00:00	1959-06-13	1959-06-13 00:00:00	32020		\N	235665	0	444814009	40481087		0
60050	3558	260139	1964-02-02	1964-02-02 00:00:00	1964-02-09	1964-02-09 00:00:00	32020		\N	236218	0	10509002	260139		0
60164	3562	4146173	1986-11-18	1986-11-18 00:00:00	1987-01-17	1987-01-17 00:00:00	32020		\N	236591	0	307731004	4146173		0
60334	3570	40481087	1998-11-08	1998-11-08 00:00:00	1998-11-22	1998-11-22 00:00:00	32020		\N	237279	0	444814009	40481087		0
49938	2950	4113008	1955-04-16	1955-04-16 00:00:00	1955-05-07	1955-05-07 00:00:00	32020		\N	196936	0	284549007	4113008		0
60674	3592	40481087	1983-03-11	1983-03-11 00:00:00	1983-04-01	1983-04-01 00:00:00	32020		\N	238616	0	444814009	40481087		0
60769	3598	40481087	2007-03-06	2007-03-06 00:00:00	2007-03-20	2007-03-20 00:00:00	32020		\N	239013	0	444814009	40481087		0
61038	3612	78272	2009-02-28	2009-02-28 00:00:00	2009-03-28	2009-03-28 00:00:00	32020		\N	240002	0	70704007	78272		0
61120	3616	40481087	2000-07-20	2000-07-20 00:00:00	2000-08-03	2000-08-03 00:00:00	32020		\N	240262	0	444814009	40481087		0
61292	3623	81151	1999-03-14	1999-03-14 00:00:00	1999-04-18	1999-04-18 00:00:00	32020		\N	240936	0	44465007	81151		0
61453	3630	4278672	2009-02-12	2009-02-12 00:00:00	2009-03-14	2009-03-14 00:00:00	32020		\N	241557	0	65966004	4278672		0
51089	3025	4112343	1994-03-10	1994-03-10 00:00:00	1994-03-18	1994-03-18 00:00:00	32020		\N	201696	0	195662009	4112343		0
61898	3655	4112343	2008-03-09	2008-03-09 00:00:00	2008-03-20	2008-03-20 00:00:00	32020		\N	243272	0	195662009	4112343		0
62025	3661	4112343	2002-08-29	2002-08-29 00:00:00	2002-09-09	2002-09-09 00:00:00	32020		\N	243684	0	195662009	4112343		0
62123	3668	4218389	2016-02-28	2016-02-28 00:00:00	2016-03-27	2016-03-27 00:00:00	32020		\N	244023	0	39848009	4218389		0
72909	4333	260139	1980-01-17	1980-01-17 00:00:00	1980-01-31	1980-01-31 00:00:00	32020		\N	287357	0	10509002	260139		0
62523	3694	4152936	2006-07-15	2006-07-15 00:00:00	2006-08-05	2006-08-05 00:00:00	32020		\N	245526	0	283385000	4152936		0
62610	3698	260139	2009-06-24	2009-06-24 00:00:00	2009-07-08	2009-07-08 00:00:00	32020		\N	245877	0	10509002	260139		0
62862	3714	40481087	1981-10-16	1981-10-16 00:00:00	1981-10-30	1981-10-30 00:00:00	32020		\N	246758	0	444814009	40481087		0
62925	3717	28060	1999-06-22	1999-06-22 00:00:00	1999-07-02	1999-07-02 00:00:00	32020		\N	246978	0	43878008	28060		0
73718	4380	78272	2014-04-19	2014-04-19 00:00:00	2014-05-10	2014-05-10 00:00:00	32020		\N	290997	0	70704007	78272		0
63399	3745	4294548	1986-03-02	1986-03-02 00:00:00	1986-03-23	1986-03-23 00:00:00	32020		\N	248920	0	75498004	4294548		0
63543	3752	80180	1997-11-17	1997-11-17 00:00:00	\N	\N	32020		\N	249321	0	396275006	80180		0
74232	4408	260139	1989-10-09	1989-10-09 00:00:00	1989-10-23	1989-10-23 00:00:00	32020		\N	293040	0	10509002	260139		0
53191	3150	40481087	1976-07-16	1976-07-16 00:00:00	1976-08-06	1976-08-06 00:00:00	32020		\N	209593	0	444814009	40481087		0
63924	3777	372328	1987-07-10	1987-07-10 00:00:00	1987-10-01	1987-10-01 00:00:00	32020		\N	251046	0	65363002	372328		0
53579	3175	4218389	1996-10-23	1996-10-23 00:00:00	1996-11-27	1996-11-27 00:00:00	32020		\N	211055	0	39848009	4218389		0
53676	3178	260139	2018-09-04	2018-09-04 00:00:00	2018-09-18	2018-09-18 00:00:00	32020		\N	211377	0	10509002	260139		0
43312	2579	40481087	1970-12-14	1970-12-14 00:00:00	1970-12-21	1970-12-21 00:00:00	32020		\N	170812	0	444814009	40481087		0
54054	3200	4112343	2018-11-05	2018-11-05 00:00:00	2018-11-12	2018-11-12 00:00:00	32020		\N	212854	0	195662009	4112343		0
43639	2598	260139	2003-07-17	2003-07-17 00:00:00	2003-07-26	2003-07-26 00:00:00	32020		\N	171891	0	10509002	260139		0
54339	3218	4027663	1982-10-22	1982-10-22 00:00:00	\N	\N	32020		\N	213833	0	13200003	4027663		0
54470	3226	40481087	1971-04-30	1971-04-30 00:00:00	1971-05-07	1971-05-07 00:00:00	32020		\N	214439	0	444814009	40481087		0
54678	3236	313217	1982-12-24	1982-12-24 00:00:00	\N	\N	32020		\N	215073	0	49436004	313217		0
54843	3246	4310024	2014-11-12	2014-11-12 00:00:00	\N	\N	32020		\N	215806	0	424802006	4310024		0
55080	3260	40481087	2008-08-03	2008-08-03 00:00:00	2008-08-10	2008-08-10 00:00:00	32020		\N	216756	0	444814009	40481087		0
65768	3889	260139	1958-04-16	1958-04-16 00:00:00	1958-04-23	1958-04-23 00:00:00	32020		\N	258453	0	10509002	260139		0
55352	3279	28060	1966-08-29	1966-08-29 00:00:00	1966-09-11	1966-09-11 00:00:00	32020		\N	217883	0	43878008	28060		0
55522	3289	4218389	1961-06-24	1961-06-24 00:00:00	1961-07-15	1961-07-15 00:00:00	32020		\N	218489	0	39848009	4218389		0
55703	3296	78272	1971-03-24	1971-03-24 00:00:00	1971-04-21	1971-04-21 00:00:00	32020		\N	219094	0	70704007	78272		0
45302	2693	4283893	2011-08-03	2011-08-03 00:00:00	2011-09-07	2011-09-07 00:00:00	32020		\N	178429	0	36971009	4283893		0
66570	3939	4112343	1995-07-27	1995-07-27 00:00:00	1995-08-04	1995-08-04 00:00:00	32020		\N	261818	0	195662009	4112343		0
56230	3332	81893	1998-01-21	1998-01-21 00:00:00	\N	\N	32020		\N	221120	0	64766004	81893		0
56374	3342	4294548	1912-05-27	1912-05-27 00:00:00	1912-06-17	1912-06-17 00:00:00	32020		\N	221570	0	75498004	4294548		0
56519	3353	4112343	1993-11-28	1993-11-28 00:00:00	1993-12-10	1993-12-10 00:00:00	32020		\N	222391	0	195662009	4112343		0
67270	3976	4112343	2007-09-27	2007-09-27 00:00:00	2007-10-07	2007-10-07 00:00:00	32020		\N	264358	0	195662009	4112343		0
56882	3375	28060	1993-03-14	1993-03-14 00:00:00	1993-03-26	1993-03-26 00:00:00	32020		\N	223854	0	43878008	28060		0
56991	3381	260139	2007-01-29	2007-01-29 00:00:00	2007-02-05	2007-02-05 00:00:00	32020		\N	224367	0	10509002	260139		0
46642	2776	4155034	2013-02-23	2013-02-23 00:00:00	2013-03-16	2013-03-16 00:00:00	32020		\N	183859	0	283371005	4155034		0
57347	3403	192671	2008-09-05	2008-09-05 00:00:00	\N	\N	32020		\N	225746	0	K92.2	35208414		0
57525	3413	4112343	1976-07-18	1976-07-18 00:00:00	1976-07-29	1976-07-29 00:00:00	32020		\N	226374	0	195662009	4112343		0
57701	3422	4155034	1990-01-22	1990-01-22 00:00:00	1990-02-05	1990-02-05 00:00:00	32020		\N	226984	0	283371005	4155034		0
57849	3432	40481087	1976-05-13	1976-05-13 00:00:00	1976-05-27	1976-05-27 00:00:00	32020		\N	227529	0	444814009	40481087		0
57999	3438	4027663	1939-04-10	1939-04-10 00:00:00	\N	\N	32020		\N	228073	0	13200003	4027663		0
58151	3444	372328	1940-05-23	1940-05-23 00:00:00	1940-10-07	1940-10-07 00:00:00	32020		\N	228580	0	65363002	372328		0
47778	2837	4112343	2001-04-08	2001-04-08 00:00:00	2001-04-19	2001-04-19 00:00:00	32020		\N	188419	0	195662009	4112343		0
47971	2846	4112343	1993-05-12	1993-05-12 00:00:00	1993-05-24	1993-05-24 00:00:00	32020		\N	189022	0	195662009	4112343		0
69260	4100	375671	1951-03-23	1951-03-23 00:00:00	1951-04-22	1951-04-22 00:00:00	32020		\N	272465	0	62564004	375671		0
48273	2861	260139	2010-11-25	2010-11-25 00:00:00	2010-12-09	2010-12-09 00:00:00	32020		\N	190189	0	10509002	260139		0
48430	2868	317576	2002-10-16	2002-10-16 00:00:00	\N	\N	32020		\N	190783	0	53741008	317576		0
59254	3514	4112343	1978-05-31	1978-05-31 00:00:00	1978-06-09	1978-06-09 00:00:00	32020		\N	233195	0	195662009	4112343		0
69959	4139	260139	2017-05-04	2017-05-04 00:00:00	2017-05-11	2017-05-11 00:00:00	32020		\N	275157	0	10509002	260139		0
59444	3526	28060	1955-01-13	1955-01-13 00:00:00	1955-01-20	1955-01-20 00:00:00	32020		\N	233906	0	43878008	28060		0
59707	3537	4112343	2001-10-16	2001-10-16 00:00:00	2001-10-29	2001-10-29 00:00:00	32020		\N	234951	0	195662009	4112343		0
59899	3549	40481087	1989-12-10	1989-12-10 00:00:00	1989-12-17	1989-12-17 00:00:00	32020		\N	235681	0	444814009	40481087		0
60051	3558	28060	2010-02-06	2010-02-06 00:00:00	2010-02-16	2010-02-16 00:00:00	32020		\N	236220	0	43878008	28060		0
60165	3562	4156265	2005-11-06	2005-11-06 00:00:00	2005-11-27	2005-11-27 00:00:00	32020		\N	236609	0	370247008	4156265		0
60335	3570	378001	2013-02-14	2013-02-14 00:00:00	2013-03-16	2013-03-16 00:00:00	32020		\N	237228	0	62106007	378001		0
49939	2950	4116491	1964-10-06	1964-10-06 00:00:00	1964-12-01	1964-12-01 00:00:00	32020		\N	196971	0	301011002	4116491		0
60675	3592	40481087	1987-05-18	1987-05-18 00:00:00	1987-06-08	1987-06-08 00:00:00	32020		\N	238617	0	444814009	40481087		0
60770	3598	40481087	2008-02-21	2008-02-21 00:00:00	2008-03-06	2008-03-06 00:00:00	32020		\N	238951	0	444814009	40481087		0
61039	3613	440448	1989-01-23	1989-01-23 00:00:00	\N	\N	32020		\N	240021	0	74400008	440448		0
61121	3616	4059173	1975-11-23	1975-11-23 00:00:00	1976-02-21	1976-02-21 00:00:00	32020		\N	240291	0	16114001	4059173		0
61293	3623	4285898	1988-04-25	1988-04-25 00:00:00	\N	\N	32020		\N	240906	0	68496003	4285898		0
61454	3630	40481087	1968-07-08	1968-07-08 00:00:00	1968-07-15	1968-07-15 00:00:00	32020		\N	241558	0	444814009	40481087		0
51090	3025	260139	2001-01-14	2001-01-14 00:00:00	2001-01-21	2001-01-21 00:00:00	32020		\N	201620	0	10509002	260139		0
61899	3655	40481087	1980-06-05	1980-06-05 00:00:00	1980-06-26	1980-06-26 00:00:00	32020		\N	243267	0	444814009	40481087		0
62026	3661	4294548	1995-10-16	1995-10-16 00:00:00	1995-11-13	1995-11-13 00:00:00	32020		\N	243621	0	75498004	4294548		0
62124	3668	4218389	2001-08-26	2001-08-26 00:00:00	2001-09-23	2001-09-23 00:00:00	32020		\N	244021	0	39848009	4218389		0
72910	4333	40481087	1973-05-04	1973-05-04 00:00:00	1973-05-18	1973-05-18 00:00:00	32020		\N	287400	0	444814009	40481087		0
62524	3694	40481087	1972-05-26	1972-05-26 00:00:00	1972-06-09	1972-06-09 00:00:00	32020		\N	245539	0	444814009	40481087		0
62611	3698	260139	1989-05-05	1989-05-05 00:00:00	1989-05-12	1989-05-12 00:00:00	32020		\N	245829	0	10509002	260139		0
62863	3714	4112343	1937-08-24	1937-08-24 00:00:00	1937-09-01	1937-09-01 00:00:00	32020		\N	246791	0	195662009	4112343		0
62926	3717	78272	2008-10-31	2008-10-31 00:00:00	2008-11-28	2008-11-28 00:00:00	32020		\N	246970	0	70704007	78272		0
73719	4380	440086	1977-04-17	1977-04-17 00:00:00	1978-01-29	1978-01-29 00:00:00	32020		\N	291029	0	192127007	440086		0
63400	3745	261325	1992-05-20	1992-05-20 00:00:00	\N	\N	32020		\N	248870	0	87433001	261325		0
63544	3752	195588	1996-02-18	1996-02-18 00:00:00	1996-03-26	1996-03-26 00:00:00	32020		\N	249321	0	38822007	195588		0
74233	4408	4112343	1995-06-10	1995-06-10 00:00:00	1995-06-22	1995-06-22 00:00:00	32020		\N	293016	0	195662009	4112343		0
53192	3150	260139	1955-01-20	1955-01-20 00:00:00	1955-01-27	1955-01-27 00:00:00	32020		\N	209582	0	10509002	260139		0
63925	3777	4112343	2004-11-10	2004-11-10 00:00:00	2004-11-18	2004-11-18 00:00:00	32020		\N	251043	0	195662009	4112343		0
53580	3175	4112343	2009-09-03	2009-09-03 00:00:00	2009-09-15	2009-09-15 00:00:00	32020		\N	211028	0	195662009	4112343		0
53677	3178	40481087	2007-05-27	2007-05-27 00:00:00	2007-06-10	2007-06-10 00:00:00	32020		\N	211423	0	444814009	40481087		0
43313	2579	372328	1953-11-11	1953-11-11 00:00:00	1954-03-28	1954-03-28 00:00:00	32020		\N	170851	0	65363002	372328		0
54055	3200	40481087	2018-10-31	2018-10-31 00:00:00	2018-11-07	2018-11-07 00:00:00	32020		\N	212793	0	444814009	40481087		0
43640	2598	40481087	1985-04-17	1985-04-17 00:00:00	1985-05-08	1985-05-08 00:00:00	32020		\N	171887	0	444814009	40481087		0
54340	3218	40481087	1980-05-17	1980-05-17 00:00:00	1980-05-31	1980-05-31 00:00:00	32020		\N	213833	0	444814009	40481087		0
54471	3226	40481087	1992-05-16	1992-05-16 00:00:00	1992-05-23	1992-05-23 00:00:00	32020		\N	214495	0	444814009	40481087		0
54679	3236	40481087	2008-08-13	2008-08-13 00:00:00	2008-08-20	2008-08-20 00:00:00	32020		\N	215129	0	444814009	40481087		0
54844	3246	78272	2010-01-03	2010-01-03 00:00:00	2010-01-31	2010-01-31 00:00:00	32020		\N	215821	0	70704007	78272		0
55081	3260	4113008	2013-06-08	2013-06-08 00:00:00	2013-06-22	2013-06-22 00:00:00	32020		\N	216753	0	284549007	4113008		0
65769	3889	40481087	1952-01-02	1952-01-02 00:00:00	1952-01-09	1952-01-09 00:00:00	32020		\N	258469	0	444814009	40481087		0
55353	3279	80180	1993-05-11	1993-05-11 00:00:00	\N	\N	32020		\N	217915	0	396275006	80180		0
55523	3289	80180	1995-09-29	1995-09-29 00:00:00	\N	\N	32020		\N	218485	0	396275006	80180		0
55704	3296	80180	1980-06-26	1980-06-26 00:00:00	\N	\N	32020		\N	219038	0	396275006	80180		0
45303	2693	4218389	2006-03-27	2006-03-27 00:00:00	2006-04-17	2006-04-17 00:00:00	32020		\N	178366	0	39848009	4218389		0
66571	3939	40481087	1980-04-05	1980-04-05 00:00:00	1980-04-26	1980-04-26 00:00:00	32020		\N	261857	0	444814009	40481087		0
56231	3332	4310024	1997-08-24	1997-08-24 00:00:00	\N	\N	32020		\N	221120	0	424802006	4310024		0
56375	3342	4134304	1979-07-01	1979-07-01 00:00:00	1979-07-31	1979-07-31 00:00:00	32020		\N	221567	0	263102004	4134304		0
56520	3353	260139	1978-08-02	1978-08-02 00:00:00	1978-08-16	1978-08-16 00:00:00	32020		\N	222383	0	10509002	260139		0
67271	3976	4266809	2007-09-24	2007-09-24 00:00:00	\N	\N	32020		\N	264358	0	397881000	4266809		0
56883	3375	260139	2007-02-24	2007-02-24 00:00:00	2007-03-03	2007-03-03 00:00:00	32020		\N	223855	0	10509002	260139		0
56992	3381	372328	1979-04-19	1979-04-19 00:00:00	1979-12-03	1979-12-03 00:00:00	32020		\N	224352	0	65363002	372328		0
46643	2776	40481087	2016-05-16	2016-05-16 00:00:00	2016-06-06	2016-06-06 00:00:00	32020		\N	183818	0	444814009	40481087		0
57348	3403	4027663	2000-03-23	2000-03-23 00:00:00	\N	\N	32020		\N	225756	0	13200003	4027663		0
57526	3413	40481087	1977-09-10	1977-09-10 00:00:00	1977-10-01	1977-10-01 00:00:00	32020		\N	226419	0	444814009	40481087		0
57702	3422	4112343	2003-02-24	2003-02-24 00:00:00	2003-03-09	2003-03-09 00:00:00	32020		\N	226987	0	195662009	4112343		0
57850	3432	40481087	2001-02-22	2001-02-22 00:00:00	2001-03-08	2001-03-08 00:00:00	32020		\N	227531	0	444814009	40481087		0
58000	3438	40481087	1988-06-02	1988-06-02 00:00:00	1988-06-09	1988-06-09 00:00:00	32020		\N	228096	0	444814009	40481087		0
58152	3444	195588	1999-11-24	1999-11-24 00:00:00	2000-01-22	2000-01-22 00:00:00	32020		\N	228540	0	38822007	195588		0
47779	2837	40481087	1979-02-28	1979-02-28 00:00:00	1979-03-07	1979-03-07 00:00:00	32020		\N	188416	0	444814009	40481087		0
47972	2847	40481087	1994-09-08	1994-09-08 00:00:00	1994-09-29	1994-09-29 00:00:00	32020		\N	189113	0	444814009	40481087		0
69261	4100	260139	1979-06-13	1979-06-13 00:00:00	1979-06-27	1979-06-27 00:00:00	32020		\N	272412	0	10509002	260139		0
48274	2861	40481087	1998-03-02	1998-03-02 00:00:00	1998-03-16	1998-03-16 00:00:00	32020		\N	190175	0	444814009	40481087		0
48431	2868	40481087	2008-01-12	2008-01-12 00:00:00	2008-01-19	2008-01-19 00:00:00	32020		\N	190807	0	444814009	40481087		0
59255	3514	40481087	2015-12-07	2015-12-07 00:00:00	2015-12-14	2015-12-14 00:00:00	32020		\N	233167	0	444814009	40481087		0
69960	4139	4027663	2000-10-29	2000-10-29 00:00:00	\N	\N	32020		\N	275108	0	13200003	4027663		0
59445	3526	81151	1974-05-09	1974-05-09 00:00:00	1974-05-30	1974-05-30 00:00:00	32020		\N	234004	0	44465007	81151		0
59708	3537	81893	2000-07-10	2000-07-10 00:00:00	\N	\N	32020		\N	234923	0	64766004	81893		0
59900	3549	4112343	1982-04-20	1982-04-20 00:00:00	1982-04-28	1982-04-28 00:00:00	32020		\N	235679	0	195662009	4112343		0
60052	3558	4112343	2009-11-22	2009-11-22 00:00:00	2009-12-04	2009-12-04 00:00:00	32020		\N	236239	0	195662009	4112343		0
60166	3562	4112343	2000-10-27	2000-10-27 00:00:00	2000-11-08	2000-11-08 00:00:00	32020		\N	236598	0	195662009	4112343		0
60336	3570	40481087	1968-10-18	1968-10-18 00:00:00	1968-10-25	1968-10-25 00:00:00	32020		\N	237268	0	444814009	40481087		0
49940	2950	4156265	1949-11-29	1949-11-29 00:00:00	1949-12-13	1949-12-13 00:00:00	32020		\N	196935	0	370247008	4156265		0
60676	3592	81151	1989-01-12	1989-01-12 00:00:00	1989-01-26	1989-01-26 00:00:00	32020		\N	238592	0	44465007	81151		0
60771	3598	260139	1950-05-25	1950-05-25 00:00:00	1950-06-01	1950-06-01 00:00:00	32020		\N	238922	0	10509002	260139		0
61040	3613	40481087	1998-09-15	1998-09-15 00:00:00	1998-09-22	1998-09-22 00:00:00	32020		\N	240042	0	444814009	40481087		0
61122	3616	40481087	1960-12-16	1960-12-16 00:00:00	1961-01-06	1961-01-06 00:00:00	32020		\N	240316	0	444814009	40481087		0
61294	3623	80180	1988-07-24	1988-07-24 00:00:00	\N	\N	32020		\N	240906	0	396275006	80180		0
61455	3630	40481087	2017-04-08	2017-04-08 00:00:00	2017-04-15	2017-04-15 00:00:00	32020		\N	241566	0	444814009	40481087		0
51091	3025	260139	1992-08-31	1992-08-31 00:00:00	1992-09-07	1992-09-07 00:00:00	32020		\N	201631	0	10509002	260139		0
61900	3655	257012	2003-07-18	2003-07-18 00:00:00	2003-09-05	2003-09-05 00:00:00	32020		\N	243329	0	40055000	257012		0
62027	3661	195588	2008-02-05	2008-02-05 00:00:00	2008-03-19	2008-03-19 00:00:00	32020		\N	243689	0	38822007	195588		0
62125	3668	81151	1996-04-26	1996-04-26 00:00:00	1996-05-24	1996-05-24 00:00:00	32020		\N	244032	0	44465007	81151		0
72911	4333	378001	2018-06-11	2018-06-11 00:00:00	2018-07-11	2018-07-11 00:00:00	32020		\N	287414	0	62106007	378001		0
62525	3694	4059173	1972-12-21	1972-12-21 00:00:00	1973-01-20	1973-01-20 00:00:00	32020		\N	245561	0	16114001	4059173		0
62612	3698	4112343	1982-01-07	1982-01-07 00:00:00	1982-01-19	1982-01-19 00:00:00	32020		\N	245874	0	195662009	4112343		0
62864	3714	260139	1985-10-03	1985-10-03 00:00:00	1985-10-17	1985-10-17 00:00:00	32020		\N	246792	0	10509002	260139		0
62927	3717	4112343	1999-09-04	1999-09-04 00:00:00	1999-09-13	1999-09-13 00:00:00	32020		\N	246979	0	195662009	4112343		0
73720	4380	260139	2006-06-26	2006-06-26 00:00:00	2006-07-10	2006-07-10 00:00:00	32020		\N	291066	0	10509002	260139		0
63401	3745	40481087	2014-04-21	2014-04-21 00:00:00	2014-05-12	2014-05-12 00:00:00	32020		\N	248950	0	444814009	40481087		0
63545	3752	4285898	1997-06-20	1997-06-20 00:00:00	\N	\N	32020		\N	249321	0	68496003	4285898		0
74234	4409	81151	1976-12-27	1976-12-27 00:00:00	1977-01-17	1977-01-17 00:00:00	32020		\N	293127	0	44465007	81151		0
53193	3150	28060	1950-07-25	1950-07-25 00:00:00	1950-08-06	1950-08-06 00:00:00	32020		\N	209570	0	43878008	28060		0
63926	3777	40479768	1990-04-25	1990-04-25 00:00:00	1990-07-01	1990-07-01 00:00:00	32020		\N	251032	0	444470001	40479768		0
53581	3175	80180	1999-05-02	1999-05-02 00:00:00	\N	\N	32020		\N	211046	0	396275006	80180		0
53678	3178	4112343	2003-05-03	2003-05-03 00:00:00	2003-05-12	2003-05-12 00:00:00	32020		\N	211421	0	195662009	4112343		0
43314	2579	40481087	1982-01-19	1982-01-19 00:00:00	1982-02-09	1982-02-09 00:00:00	32020		\N	170810	0	444814009	40481087		0
54056	3200	260139	2012-03-13	2012-03-13 00:00:00	2012-03-27	2012-03-27 00:00:00	32020		\N	212824	0	10509002	260139		0
43641	2598	260139	2017-04-29	2017-04-29 00:00:00	2017-05-13	2017-05-13 00:00:00	32020		\N	171938	0	10509002	260139		0
54341	3218	4112343	2010-05-03	2010-05-03 00:00:00	2010-05-15	2010-05-15 00:00:00	32020		\N	213878	0	195662009	4112343		0
54472	3226	372328	1971-02-23	1971-02-23 00:00:00	1971-07-18	1971-07-18 00:00:00	32020		\N	214497	0	65363002	372328		0
54680	3236	40481087	1987-12-16	1987-12-16 00:00:00	1987-12-23	1987-12-23 00:00:00	32020		\N	215127	0	444814009	40481087		0
54845	3246	40481087	1997-12-17	1997-12-17 00:00:00	1998-01-07	1998-01-07 00:00:00	32020		\N	215811	0	444814009	40481087		0
55082	3260	40481087	1970-08-14	1970-08-14 00:00:00	1970-08-21	1970-08-21 00:00:00	32020		\N	216719	0	444814009	40481087		0
65770	3889	40481087	2002-09-30	2002-09-30 00:00:00	2002-10-21	2002-10-21 00:00:00	32020		\N	258479	0	444814009	40481087		0
55354	3279	4112343	2006-12-06	2006-12-06 00:00:00	2006-12-14	2006-12-14 00:00:00	32020		\N	217923	0	195662009	4112343		0
55524	3289	4112343	1993-10-02	1993-10-02 00:00:00	1993-10-14	1993-10-14 00:00:00	32020		\N	218485	0	195662009	4112343		0
55705	3296	40481087	1963-08-05	1963-08-05 00:00:00	1963-08-12	1963-08-12 00:00:00	32020		\N	219021	0	444814009	40481087		0
45304	2693	28060	1961-04-17	1961-04-17 00:00:00	1961-04-24	1961-04-24 00:00:00	32020		\N	178401	0	43878008	28060		0
66572	3939	40481087	2004-03-04	2004-03-04 00:00:00	2004-03-11	2004-03-11 00:00:00	32020		\N	261819	0	444814009	40481087		0
56232	3332	4056621	1980-01-28	1980-01-28 00:00:00	\N	\N	32020		\N	221070	0	197927001	4056621		0
56376	3342	372328	1910-02-02	1910-02-02 00:00:00	1910-03-16	1910-03-16 00:00:00	32020		\N	221648	0	65363002	372328		0
56521	3353	372328	1927-11-12	1927-11-12 00:00:00	1927-12-03	1927-12-03 00:00:00	32020		\N	222421	0	65363002	372328		0
67272	3976	80180	2007-09-24	2007-09-24 00:00:00	\N	\N	32020		\N	264358	0	396275006	80180		0
56884	3375	260139	1983-06-03	1983-06-03 00:00:00	1983-06-17	1983-06-17 00:00:00	32020		\N	223898	0	10509002	260139		0
56993	3381	4112343	1972-12-13	1972-12-13 00:00:00	1972-12-25	1972-12-25 00:00:00	32020		\N	224382	0	195662009	4112343		0
46644	2776	260139	1987-03-01	1987-03-01 00:00:00	1987-03-08	1987-03-08 00:00:00	32020		\N	183774	0	10509002	260139		0
57349	3403	4112343	1997-06-15	1997-06-15 00:00:00	1997-06-22	1997-06-22 00:00:00	32020		\N	225756	0	195662009	4112343		0
57527	3413	4278672	1975-08-08	1975-08-08 00:00:00	1975-09-07	1975-09-07 00:00:00	32020		\N	226402	0	65966004	4278672		0
57703	3422	4283893	2011-09-11	2011-09-11 00:00:00	2011-12-18	2011-12-18 00:00:00	32020		\N	227014	0	36971009	4283893		0
57851	3432	4112343	2008-04-13	2008-04-13 00:00:00	2008-04-22	2008-04-22 00:00:00	32020		\N	227546	0	195662009	4112343		0
58001	3438	195588	1938-04-10	1938-04-10 00:00:00	1938-06-02	1938-06-02 00:00:00	32020		\N	228109	0	38822007	195588		0
58153	3444	4112343	1981-01-31	1981-01-31 00:00:00	1981-02-11	1981-02-11 00:00:00	32020		\N	228556	0	195662009	4112343		0
47780	2837	40481087	1993-07-16	1993-07-16 00:00:00	1993-07-30	1993-07-30 00:00:00	32020		\N	188438	0	444814009	40481087		0
47973	2847	28060	1989-11-12	1989-11-12 00:00:00	1989-11-19	1989-11-19 00:00:00	32020		\N	189112	0	43878008	28060		0
69262	4100	80180	1979-12-21	1979-12-21 00:00:00	\N	\N	32020		\N	272412	0	396275006	80180		0
48275	2861	40481087	2009-02-04	2009-02-04 00:00:00	2009-02-18	2009-02-18 00:00:00	32020		\N	190209	0	444814009	40481087		0
48432	2868	4059173	1969-02-05	1969-02-05 00:00:00	1969-04-06	1969-04-06 00:00:00	32020		\N	190817	0	16114001	4059173		0
59256	3514	80180	2014-03-02	2014-03-02 00:00:00	\N	\N	32020		\N	233209	0	396275006	80180		0
69961	4139	40481087	2000-02-29	2000-02-29 00:00:00	2000-03-21	2000-03-21 00:00:00	32020		\N	275108	0	444814009	40481087		0
59446	3526	80180	1986-06-06	1986-06-06 00:00:00	\N	\N	32020		\N	233970	0	396275006	80180		0
59709	3537	4283893	2015-01-19	2015-01-19 00:00:00	2015-05-25	2015-05-25 00:00:00	32020		\N	234971	0	36971009	4283893		0
59901	3549	4027663	1986-05-28	1986-05-28 00:00:00	\N	\N	32020		\N	235688	0	13200003	4027663		0
60053	3558	4001336	1993-04-12	1993-04-12 00:00:00	1993-05-12	1993-05-12 00:00:00	32020		\N	236216	0	110030002	4001336		0
60167	3562	4112343	2016-10-27	2016-10-27 00:00:00	2016-11-08	2016-11-08 00:00:00	32020		\N	236593	0	195662009	4112343		0
60337	3570	40481087	1975-08-11	1975-08-11 00:00:00	1975-08-25	1975-08-25 00:00:00	32020		\N	237229	0	444814009	40481087		0
49941	2950	40481087	2007-12-08	2007-12-08 00:00:00	2007-12-22	2007-12-22 00:00:00	32020		\N	196991	0	444814009	40481087		0
60677	3592	40481087	1973-09-25	1973-09-25 00:00:00	1973-10-02	1973-10-02 00:00:00	32020		\N	238615	0	444814009	40481087		0
60772	3598	4112343	1956-06-23	1956-06-23 00:00:00	1956-07-05	1956-07-05 00:00:00	32020		\N	238948	0	195662009	4112343		0
61041	3613	4027663	2002-01-18	2002-01-18 00:00:00	\N	\N	32020		\N	240057	0	13200003	4027663		0
61123	3616	40481087	2002-07-15	2002-07-15 00:00:00	2002-07-29	2002-07-29 00:00:00	32020		\N	240315	0	444814009	40481087		0
61295	3623	81893	1986-12-02	1986-12-02 00:00:00	\N	\N	32020		\N	240906	0	64766004	81893		0
61456	3630	4156265	1986-06-29	1986-06-29 00:00:00	1986-07-13	1986-07-13 00:00:00	32020		\N	241556	0	370247008	4156265		0
51092	3025	40481087	1947-05-26	1947-05-26 00:00:00	1947-06-02	1947-06-02 00:00:00	32020		\N	201683	0	444814009	40481087		0
61901	3655	40481087	1937-12-21	1937-12-21 00:00:00	1937-12-28	1937-12-28 00:00:00	32020		\N	243262	0	444814009	40481087		0
62028	3661	257012	1995-11-06	1995-11-06 00:00:00	\N	\N	32020		\N	243636	0	40055000	257012		0
62126	3668	80180	2013-12-04	2013-12-04 00:00:00	\N	\N	32020		\N	244007	0	396275006	80180		0
72912	4333	30753	1993-06-08	1993-06-08 00:00:00	\N	\N	32020		\N	287367	0	16761005	30753		0
62526	3694	40481087	2017-06-20	2017-06-20 00:00:00	2017-06-27	2017-06-27 00:00:00	32020		\N	245542	0	444814009	40481087		0
62613	3698	40481087	1980-08-17	1980-08-17 00:00:00	1980-08-24	1980-08-24 00:00:00	32020		\N	245850	0	444814009	40481087		0
62865	3714	4218389	1949-07-07	1949-07-07 00:00:00	1949-08-04	1949-08-04 00:00:00	32020		\N	246846	0	39848009	4218389		0
62928	3717	4112343	1977-07-05	1977-07-05 00:00:00	1977-07-15	1977-07-15 00:00:00	32020		\N	246995	0	195662009	4112343		0
73721	4380	4112343	2002-09-09	2002-09-09 00:00:00	2002-09-19	2002-09-19 00:00:00	32020		\N	291024	0	195662009	4112343		0
63402	3745	40481087	1972-12-13	1972-12-13 00:00:00	1972-12-20	1972-12-20 00:00:00	32020		\N	248914	0	444814009	40481087		0
63551	3754	4149245	2017-05-18	2017-05-18 00:00:00	2017-06-24	2017-06-24 00:00:00	32020		\N	249553	0	30832001	4149245		0
74235	4409	40481087	1978-02-22	1978-02-22 00:00:00	1978-03-01	1978-03-01 00:00:00	32020		\N	293091	0	444814009	40481087		0
53194	3150	260139	1945-07-25	1945-07-25 00:00:00	1945-08-08	1945-08-08 00:00:00	32020		\N	209572	0	10509002	260139		0
63927	3777	4152936	1992-04-21	1992-04-21 00:00:00	1992-05-05	1992-05-05 00:00:00	32020		\N	251033	0	283385000	4152936		0
53582	3175	260139	2010-07-09	2010-07-09 00:00:00	2010-07-23	2010-07-23 00:00:00	32020		\N	211030	0	10509002	260139		0
53679	3178	4112343	1980-06-12	1980-06-12 00:00:00	1980-06-20	1980-06-20 00:00:00	32020		\N	211425	0	195662009	4112343		0
43315	2579	378001	1998-09-16	1998-09-16 00:00:00	1998-10-16	1998-10-16 00:00:00	32020		\N	170791	0	62106007	378001		0
54057	3200	260139	1961-09-03	1961-09-03 00:00:00	1961-09-17	1961-09-17 00:00:00	32020		\N	212831	0	10509002	260139		0
43642	2598	4112343	1998-01-20	1998-01-20 00:00:00	1998-02-01	1998-02-01 00:00:00	32020		\N	171925	0	195662009	4112343		0
54342	3218	40481087	2010-04-13	2010-04-13 00:00:00	2010-04-27	2010-04-27 00:00:00	32020		\N	213877	0	444814009	40481087		0
54473	3226	80180	2012-07-07	2012-07-07 00:00:00	\N	\N	32020		\N	214496	0	396275006	80180		0
54681	3237	40481087	1931-10-04	1931-10-04 00:00:00	1931-10-11	1931-10-11 00:00:00	32020		\N	215196	0	444814009	40481087		0
54846	3246	260139	1982-02-10	1982-02-10 00:00:00	1982-02-17	1982-02-17 00:00:00	32020		\N	215803	0	10509002	260139		0
55083	3260	378001	2005-07-20	2005-07-20 00:00:00	2005-09-18	2005-09-18 00:00:00	32020		\N	216752	0	62106007	378001		0
65771	3889	81151	1961-12-26	1961-12-26 00:00:00	1962-01-16	1962-01-16 00:00:00	32020		\N	258517	0	44465007	81151		0
55355	3279	260139	1998-11-14	1998-11-14 00:00:00	1998-11-28	1998-11-28 00:00:00	32020		\N	217869	0	10509002	260139		0
55525	3289	30753	1994-06-06	1994-06-06 00:00:00	\N	\N	32020		\N	218485	0	16761005	30753		0
55706	3296	4112343	2003-12-08	2003-12-08 00:00:00	2003-12-19	2003-12-19 00:00:00	32020		\N	219067	0	195662009	4112343		0
45305	2693	40481087	1959-09-18	1959-09-18 00:00:00	1959-09-25	1959-09-25 00:00:00	32020		\N	178372	0	444814009	40481087		0
66573	3939	4027663	2005-01-12	2005-01-12 00:00:00	\N	\N	32020		\N	261819	0	13200003	4027663		0
56233	3332	4116491	1980-01-28	1980-01-28 00:00:00	1980-03-10	1980-03-10 00:00:00	32020		\N	221070	0	301011002	4116491		0
56377	3342	40481087	1947-09-29	1947-09-29 00:00:00	1947-10-20	1947-10-20 00:00:00	32020		\N	221607	0	444814009	40481087		0
56522	3353	4296204	1991-05-02	1991-05-02 00:00:00	1991-06-06	1991-06-06 00:00:00	32020		\N	222451	0	403190006	4296204		0
67273	3976	4152936	1977-05-25	1977-05-25 00:00:00	1977-06-08	1977-06-08 00:00:00	32020		\N	264350	0	283385000	4152936		0
56885	3375	372328	1958-02-03	1958-02-03 00:00:00	1959-02-13	1959-02-13 00:00:00	32020		\N	223856	0	65363002	372328		0
56994	3381	4112343	2005-04-21	2005-04-21 00:00:00	2005-05-03	2005-05-03 00:00:00	32020		\N	224384	0	195662009	4112343		0
46645	2776	134438	2005-07-12	2005-07-12 00:00:00	2006-05-09	2006-05-09 00:00:00	32020		\N	183861	0	40275004	134438		0
57350	3403	81151	1980-03-03	1980-03-03 00:00:00	1980-03-24	1980-03-24 00:00:00	32020		\N	225742	0	44465007	81151		0
57528	3413	28060	1983-02-09	1983-02-09 00:00:00	1983-02-21	1983-02-21 00:00:00	32020		\N	226379	0	43878008	28060		0
57704	3422	260139	1995-09-20	1995-09-20 00:00:00	1995-10-04	1995-10-04 00:00:00	32020		\N	226961	0	10509002	260139		0
57852	3432	4029498	1953-11-08	1953-11-08 00:00:00	\N	\N	32020		\N	227483	0	128613002	4029498		0
58002	3438	255848	1991-12-23	1991-12-23 00:00:00	\N	\N	32020		\N	228046	0	233604007	255848		0
58154	3444	40481087	1953-12-26	1953-12-26 00:00:00	1954-01-02	1954-01-02 00:00:00	32020		\N	228535	0	444814009	40481087		0
47781	2837	4112343	1969-08-18	1969-08-18 00:00:00	1969-08-30	1969-08-30 00:00:00	32020		\N	188460	0	195662009	4112343		0
47974	2847	40481087	1978-09-15	1978-09-15 00:00:00	1978-09-29	1978-09-29 00:00:00	32020		\N	189093	0	444814009	40481087		0
69263	4100	40481087	1965-12-12	1965-12-12 00:00:00	1965-12-19	1965-12-19 00:00:00	32020		\N	272407	0	444814009	40481087		0
48276	2861	78272	2019-06-19	2019-06-19 00:00:00	\N	\N	32020		\N	190247	0	70704007	78272		0
48433	2868	4112343	1968-02-12	1968-02-12 00:00:00	1968-02-24	1968-02-24 00:00:00	32020		\N	190801	0	195662009	4112343		0
59257	3514	4112343	1985-09-01	1985-09-01 00:00:00	1985-09-09	1985-09-09 00:00:00	32020		\N	233186	0	195662009	4112343		0
69962	4139	40481087	1986-11-18	1986-11-18 00:00:00	1986-12-02	1986-12-02 00:00:00	32020		\N	275107	0	444814009	40481087		0
59447	3526	4266809	1986-06-06	1986-06-06 00:00:00	\N	\N	32020		\N	233970	0	397881000	4266809		0
59710	3537	40481087	1994-01-15	1994-01-15 00:00:00	1994-02-05	1994-02-05 00:00:00	32020		\N	234950	0	444814009	40481087		0
59902	3549	4285898	1995-05-16	1995-05-16 00:00:00	\N	\N	32020		\N	235702	0	68496003	4285898		0
60054	3558	4112343	1977-07-18	1977-07-18 00:00:00	1977-07-28	1977-07-28 00:00:00	32020		\N	236183	0	195662009	4112343		0
60168	3562	40481087	1992-09-05	1992-09-05 00:00:00	1992-09-26	1992-09-26 00:00:00	32020		\N	236617	0	444814009	40481087		0
60338	3570	40481087	1990-07-04	1990-07-04 00:00:00	1990-07-18	1990-07-18 00:00:00	32020		\N	237276	0	444814009	40481087		0
49942	2950	4112343	1959-09-01	1959-09-01 00:00:00	1959-09-13	1959-09-13 00:00:00	32020		\N	196979	0	195662009	4112343		0
60678	3592	257012	1969-10-19	1969-10-19 00:00:00	\N	\N	32020		\N	238613	0	40055000	257012		0
60773	3598	40481087	1967-07-18	1967-07-18 00:00:00	1967-07-25	1967-07-25 00:00:00	32020		\N	238929	0	444814009	40481087		0
61042	3613	375671	1999-05-24	1999-05-24 00:00:00	1999-06-23	1999-06-23 00:00:00	32020		\N	240041	0	62564004	375671		0
61124	3616	372328	1964-02-13	1964-02-13 00:00:00	1965-02-16	1965-02-16 00:00:00	32020		\N	240264	0	65363002	372328		0
61296	3623	30753	1987-07-30	1987-07-30 00:00:00	\N	\N	32020		\N	240906	0	16761005	30753		0
61457	3631	4109685	2006-04-19	2006-04-19 00:00:00	2006-05-03	2006-05-03 00:00:00	32020		\N	241582	0	284551006	4109685		0
51093	3025	378001	1955-09-26	1955-09-26 00:00:00	1955-10-26	1955-10-26 00:00:00	32020		\N	201583	0	62106007	378001		0
61902	3655	317576	2006-08-31	2006-08-31 00:00:00	\N	\N	32020		\N	243290	0	53741008	317576		0
62029	3661	4112343	1992-08-09	1992-08-09 00:00:00	1992-08-19	1992-08-19 00:00:00	32020		\N	243620	0	195662009	4112343		0
62127	3668	40481087	2012-10-01	2012-10-01 00:00:00	2012-10-15	2012-10-15 00:00:00	32020		\N	244007	0	444814009	40481087		0
72913	4333	40481087	1974-10-18	1974-10-18 00:00:00	1974-11-01	1974-11-01 00:00:00	32020		\N	287356	0	444814009	40481087		0
62527	3694	40481087	2010-01-13	2010-01-13 00:00:00	2010-01-20	2010-01-20 00:00:00	32020		\N	245541	0	444814009	40481087		0
62614	3699	40481087	2007-11-01	2007-11-01 00:00:00	2007-11-15	2007-11-15 00:00:00	32020		\N	245927	0	444814009	40481087		0
62866	3714	260139	1973-04-24	1973-04-24 00:00:00	1973-05-08	1973-05-08 00:00:00	32020		\N	246797	0	10509002	260139		0
62929	3717	4112343	2003-11-25	2003-11-25 00:00:00	2003-12-04	2003-12-04 00:00:00	32020		\N	247049	0	195662009	4112343		0
73722	4380	40481087	1986-12-29	1986-12-29 00:00:00	1987-01-19	1987-01-19 00:00:00	32020		\N	291040	0	444814009	40481087		0
63403	3745	80180	1973-03-21	1973-03-21 00:00:00	\N	\N	32020		\N	248914	0	396275006	80180		0
63552	3754	4112343	2000-09-20	2000-09-20 00:00:00	2000-10-03	2000-10-03 00:00:00	32020		\N	249464	0	195662009	4112343		0
74236	4409	80180	2005-06-28	2005-06-28 00:00:00	\N	\N	32020		\N	293135	0	396275006	80180		0
53195	3150	28060	1947-01-01	1947-01-01 00:00:00	1947-01-11	1947-01-11 00:00:00	32020		\N	209569	0	43878008	28060		0
63928	3777	40481087	2014-11-22	2014-11-22 00:00:00	2014-12-06	2014-12-06 00:00:00	32020		\N	251027	0	444814009	40481087		0
53583	3175	260139	1989-11-17	1989-11-17 00:00:00	1989-11-24	1989-11-24 00:00:00	32020		\N	211003	0	10509002	260139		0
53680	3178	4112343	1996-05-28	1996-05-28 00:00:00	1996-06-07	1996-06-07 00:00:00	32020		\N	211408	0	195662009	4112343		0
43316	2579	40481087	1967-12-07	1967-12-07 00:00:00	1967-12-21	1967-12-21 00:00:00	32020		\N	170809	0	444814009	40481087		0
54058	3200	40481087	1970-12-23	1970-12-23 00:00:00	1971-01-06	1971-01-06 00:00:00	32020		\N	212790	0	444814009	40481087		0
43643	2598	40481087	1988-03-13	1988-03-13 00:00:00	1988-03-27	1988-03-27 00:00:00	32020		\N	171927	0	444814009	40481087		0
54343	3219	40481087	2003-02-09	2003-02-09 00:00:00	2003-03-02	2003-03-02 00:00:00	32020		\N	213912	0	444814009	40481087		0
54474	3226	40481087	2012-02-05	2012-02-05 00:00:00	2012-02-12	2012-02-12 00:00:00	32020		\N	214496	0	444814009	40481087		0
54682	3237	40481087	1986-08-20	1986-08-20 00:00:00	1986-09-10	1986-09-10 00:00:00	32020		\N	215199	0	444814009	40481087		0
54847	3246	40481087	1986-08-21	1986-08-21 00:00:00	1986-09-11	1986-09-11 00:00:00	32020		\N	215789	0	444814009	40481087		0
55084	3260	40481087	1999-11-04	1999-11-04 00:00:00	1999-11-18	1999-11-18 00:00:00	32020		\N	216761	0	444814009	40481087		0
65772	3889	81151	2018-05-06	2018-05-06 00:00:00	2018-05-27	2018-05-27 00:00:00	32020		\N	258519	0	44465007	81151		0
55356	3279	260139	2016-08-04	2016-08-04 00:00:00	2016-08-18	2016-08-18 00:00:00	32020		\N	217918	0	10509002	260139		0
55526	3289	4134304	1966-12-16	1966-12-16 00:00:00	1967-01-15	1967-01-15 00:00:00	32020		\N	218490	0	263102004	4134304		0
55707	3296	28060	1949-09-29	1949-09-29 00:00:00	1949-10-08	1949-10-08 00:00:00	32020		\N	218992	0	43878008	28060		0
45306	2693	4112343	2019-02-23	2019-02-23 00:00:00	2019-03-03	2019-03-03 00:00:00	32020		\N	178391	0	195662009	4112343		0
66574	3939	4266809	2011-12-02	2011-12-02 00:00:00	\N	\N	32020		\N	261849	0	397881000	4266809		0
56234	3332	4296204	1981-03-21	1981-03-21 00:00:00	1981-04-11	1981-04-11 00:00:00	32020		\N	221131	0	403190006	4296204		0
56378	3342	4112343	1914-03-17	1914-03-17 00:00:00	1914-03-30	1914-03-30 00:00:00	32020		\N	221572	0	195662009	4112343		0
56523	3353	40481087	1990-09-29	1990-09-29 00:00:00	1990-10-13	1990-10-13 00:00:00	32020		\N	222417	0	444814009	40481087		0
67274	3976	4112343	1994-05-22	1994-05-22 00:00:00	1994-06-03	1994-06-03 00:00:00	32020		\N	264345	0	195662009	4112343		0
56886	3375	28060	1988-07-22	1988-07-22 00:00:00	1988-08-04	1988-08-04 00:00:00	32020		\N	223881	0	43878008	28060		0
56995	3381	260139	1974-08-23	1974-08-23 00:00:00	1974-09-06	1974-09-06 00:00:00	32020		\N	224364	0	10509002	260139		0
46646	2776	372328	1978-05-28	1978-05-28 00:00:00	1978-06-18	1978-06-18 00:00:00	32020		\N	183793	0	65363002	372328		0
57351	3403	4296204	2012-10-07	2012-10-07 00:00:00	2012-11-11	2012-11-11 00:00:00	32020		\N	225745	0	403190006	4296204		0
57529	3413	4112343	1973-06-23	1973-06-23 00:00:00	1973-07-03	1973-07-03 00:00:00	32020		\N	226372	0	195662009	4112343		0
57705	3422	260139	2006-08-18	2006-08-18 00:00:00	2006-09-01	2006-09-01 00:00:00	32020		\N	227028	0	10509002	260139		0
57854	3432	4112343	1995-10-20	1995-10-20 00:00:00	1995-11-01	1995-11-01 00:00:00	32020		\N	227563	0	195662009	4112343		0
58003	3438	40481087	1919-09-27	1919-09-27 00:00:00	1919-10-11	1919-10-11 00:00:00	32020		\N	228107	0	444814009	40481087		0
58155	3444	40481087	1993-02-16	1993-02-16 00:00:00	1993-02-23	1993-02-23 00:00:00	32020		\N	228577	0	444814009	40481087		0
47782	2837	40481087	2012-01-17	2012-01-17 00:00:00	2012-02-07	2012-02-07 00:00:00	32020		\N	188475	0	444814009	40481087		0
58441	3462	40481087	1966-10-27	1966-10-27 00:00:00	1966-11-17	1966-11-17 00:00:00	32020		\N	229681	0	444814009	40481087		0
69264	4100	260139	1947-10-11	1947-10-11 00:00:00	1947-10-25	1947-10-25 00:00:00	32020		\N	272453	0	10509002	260139		0
48277	2861	28060	1964-07-05	1964-07-05 00:00:00	1964-07-13	1964-07-13 00:00:00	32020		\N	190204	0	43878008	28060		0
48434	2868	260139	1966-02-22	1966-02-22 00:00:00	1966-03-01	1966-03-01 00:00:00	32020		\N	190797	0	10509002	260139		0
59258	3514	440448	2015-08-11	2015-08-11 00:00:00	\N	\N	32020		\N	233214	0	74400008	440448		0
69963	4139	4278672	2010-08-22	2010-08-22 00:00:00	2010-10-21	2010-10-21 00:00:00	32020		\N	275164	0	65966004	4278672		0
59448	3526	4112343	1990-10-07	1990-10-07 00:00:00	1990-10-15	1990-10-15 00:00:00	32020		\N	233953	0	195662009	4112343		0
59711	3537	78272	2015-08-28	2015-08-28 00:00:00	2015-09-11	2015-09-11 00:00:00	32020		\N	234967	0	70704007	78272		0
59903	3549	80180	1995-06-15	1995-06-15 00:00:00	\N	\N	32020		\N	235702	0	396275006	80180		0
60055	3558	4112343	1974-10-19	1974-10-19 00:00:00	1974-10-31	1974-10-31 00:00:00	32020		\N	236182	0	195662009	4112343		0
60169	3562	4112343	2003-11-24	2003-11-24 00:00:00	2003-12-04	2003-12-04 00:00:00	32020		\N	236571	0	195662009	4112343		0
60339	3570	257012	1956-08-07	1956-08-07 00:00:00	\N	\N	32020		\N	237271	0	40055000	257012		0
49943	2950	378419	2011-10-03	2011-10-03 00:00:00	\N	\N	32020		\N	196910	0	26929004	378419		0
60679	3592	260139	2007-04-01	2007-04-01 00:00:00	2007-04-15	2007-04-15 00:00:00	32020		\N	238571	0	10509002	260139		0
60774	3598	28060	1980-09-10	1980-09-10 00:00:00	1980-09-21	1980-09-21 00:00:00	32020		\N	238925	0	43878008	28060		0
61043	3613	4285898	2009-11-07	2009-11-07 00:00:00	\N	\N	32020		\N	240023	0	68496003	4285898		0
61125	3616	81893	1990-06-12	1990-06-12 00:00:00	\N	\N	32020		\N	240283	0	64766004	81893		0
61297	3623	4152936	1958-02-02	1958-02-02 00:00:00	1958-02-23	1958-02-23 00:00:00	32020		\N	240895	0	283385000	4152936		0
61458	3631	4112343	1991-09-02	1991-09-02 00:00:00	1991-09-14	1991-09-14 00:00:00	32020		\N	241584	0	195662009	4112343		0
51094	3026	4112343	1987-09-04	1987-09-04 00:00:00	1987-09-12	1987-09-12 00:00:00	32020		\N	201766	0	195662009	4112343		0
61903	3655	4112343	1949-05-12	1949-05-12 00:00:00	1949-05-19	1949-05-19 00:00:00	32020		\N	243249	0	195662009	4112343		0
62067	3666	81151	1965-08-31	1965-08-31 00:00:00	1965-09-21	1965-09-21 00:00:00	32020		\N	243866	0	44465007	81151		0
62128	3668	81151	2018-01-16	2018-01-16 00:00:00	2018-02-13	2018-02-13 00:00:00	32020		\N	244024	0	44465007	81151		0
72914	4333	260139	1995-12-10	1995-12-10 00:00:00	1995-12-17	1995-12-17 00:00:00	32020		\N	287358	0	10509002	260139		0
62528	3694	260139	2019-01-24	2019-01-24 00:00:00	2019-02-07	2019-02-07 00:00:00	32020		\N	245481	0	10509002	260139		0
62615	3699	372328	1976-10-16	1976-10-16 00:00:00	1977-06-16	1977-06-16 00:00:00	32020		\N	245931	0	65363002	372328		0
62867	3714	40481087	2007-11-06	2007-11-06 00:00:00	2007-11-13	2007-11-13 00:00:00	32020		\N	246761	0	444814009	40481087		0
62930	3717	260139	1977-07-04	1977-07-04 00:00:00	1977-07-11	1977-07-11 00:00:00	32020		\N	247075	0	10509002	260139		0
73723	4380	260139	1999-01-29	1999-01-29 00:00:00	1999-02-05	1999-02-05 00:00:00	32020		\N	291034	0	10509002	260139		0
63404	3745	40481087	1985-01-21	1985-01-21 00:00:00	1985-01-28	1985-01-28 00:00:00	32020		\N	248919	0	444814009	40481087		0
63553	3754	40481087	1995-04-20	1995-04-20 00:00:00	1995-04-27	1995-04-27 00:00:00	32020		\N	249499	0	444814009	40481087		0
74237	4409	40481087	1985-12-31	1985-12-31 00:00:00	1986-01-14	1986-01-14 00:00:00	32020		\N	293093	0	444814009	40481087		0
53196	3150	4112343	1967-08-10	1967-08-10 00:00:00	1967-08-23	1967-08-23 00:00:00	32020		\N	209583	0	195662009	4112343		0
63929	3777	40481087	2010-12-15	2010-12-15 00:00:00	2011-01-05	2011-01-05 00:00:00	32020		\N	251004	0	444814009	40481087		0
53584	3175	40481087	2009-09-13	2009-09-13 00:00:00	2009-09-27	2009-09-27 00:00:00	32020		\N	211029	0	444814009	40481087		0
53681	3178	78272	1962-09-11	1962-09-11 00:00:00	1962-10-09	1962-10-09 00:00:00	32020		\N	211387	0	70704007	78272		0
43317	2579	192671	1992-06-03	1992-06-03 00:00:00	\N	\N	32020		\N	170783	0	K92.2	35208414		0
54059	3200	372328	1948-04-13	1948-04-13 00:00:00	1948-07-29	1948-07-29 00:00:00	32020		\N	212835	0	65363002	372328		0
43644	2598	28060	1985-09-09	1985-09-09 00:00:00	1985-09-22	1985-09-22 00:00:00	32020		\N	171888	0	43878008	28060		0
54344	3219	4230399	1996-08-27	1996-08-27 00:00:00	1996-09-26	1996-09-26 00:00:00	32020		\N	213930	0	359817006	4230399		0
54475	3226	4266809	2012-07-07	2012-07-07 00:00:00	\N	\N	32020		\N	214496	0	397881000	4266809		0
54683	3237	40481087	1934-02-04	1934-02-04 00:00:00	1934-02-25	1934-02-25 00:00:00	32020		\N	215218	0	444814009	40481087		0
54848	3246	4094814	2017-02-23	2017-02-23 00:00:00	\N	\N	32020		\N	215822	0	262574004	4094814		0
55085	3260	4266809	1998-06-07	1998-06-07 00:00:00	\N	\N	32020		\N	216737	0	397881000	4266809		0
65773	3889	313217	2003-10-12	2003-10-12 00:00:00	\N	\N	32020		\N	258492	0	49436004	313217		0
55357	3279	4112343	1994-03-04	1994-03-04 00:00:00	1994-03-13	1994-03-13 00:00:00	32020		\N	217868	0	195662009	4112343		0
55527	3289	372328	1957-07-15	1957-07-15 00:00:00	1957-11-29	1957-11-29 00:00:00	32020		\N	218506	0	65363002	372328		0
55708	3296	4112343	1944-11-27	1944-11-27 00:00:00	1944-12-07	1944-12-07 00:00:00	32020		\N	218984	0	195662009	4112343		0
55777	3301	40481087	1983-12-02	1983-12-02 00:00:00	1983-12-09	1983-12-09 00:00:00	32020		\N	219282	0	444814009	40481087		0
66575	3939	80180	2011-12-02	2011-12-02 00:00:00	\N	\N	32020		\N	261849	0	396275006	80180		0
56235	3332	40481087	1973-04-12	1973-04-12 00:00:00	1973-04-26	1973-04-26 00:00:00	32020		\N	221051	0	444814009	40481087		0
56379	3342	260139	1997-02-01	1997-02-01 00:00:00	1997-02-08	1997-02-08 00:00:00	32020		\N	221635	0	10509002	260139		0
56524	3353	40481087	1991-01-20	1991-01-20 00:00:00	1991-02-03	1991-02-03 00:00:00	32020		\N	222336	0	444814009	40481087		0
67275	3976	40481087	1970-09-05	1970-09-05 00:00:00	1970-09-26	1970-09-26 00:00:00	32020		\N	264385	0	444814009	40481087		0
56887	3375	4112343	2011-02-23	2011-02-23 00:00:00	2011-03-07	2011-03-07 00:00:00	32020		\N	223882	0	195662009	4112343		0
56996	3381	372328	1974-10-10	1974-10-10 00:00:00	1974-11-11	1974-11-11 00:00:00	32020		\N	224370	0	65363002	372328		0
57105	3389	260139	1976-08-28	1976-08-28 00:00:00	1976-09-11	1976-09-11 00:00:00	32020		\N	224770	0	10509002	260139		0
57352	3403	40481087	1971-12-21	1971-12-21 00:00:00	1972-01-11	1972-01-11 00:00:00	32020		\N	225733	0	444814009	40481087		0
57530	3413	40481087	1969-03-20	1969-03-20 00:00:00	1969-03-27	1969-03-27 00:00:00	32020		\N	226397	0	444814009	40481087		0
57706	3422	40481087	1995-06-04	1995-06-04 00:00:00	1995-06-18	1995-06-18 00:00:00	32020		\N	226957	0	444814009	40481087		0
57855	3432	4218389	1974-12-29	1974-12-29 00:00:00	1975-01-26	1975-01-26 00:00:00	32020		\N	227487	0	39848009	4218389		0
58004	3438	40481087	1913-11-27	1913-11-27 00:00:00	1913-12-18	1913-12-18 00:00:00	32020		\N	228069	0	444814009	40481087		0
58156	3444	4112343	2003-03-13	2003-03-13 00:00:00	2003-03-20	2003-03-20 00:00:00	32020		\N	228587	0	195662009	4112343		0
47783	2837	4112343	1974-05-09	1974-05-09 00:00:00	1974-05-22	1974-05-22 00:00:00	32020		\N	188435	0	195662009	4112343		0
58442	3462	378001	2001-01-28	2001-01-28 00:00:00	2001-02-27	2001-02-27 00:00:00	32020		\N	229769	0	62106007	378001		0
69265	4100	40481087	1966-09-20	1966-09-20 00:00:00	1966-10-11	1966-10-11 00:00:00	32020		\N	272381	0	444814009	40481087		0
48278	2861	4134304	1987-12-20	1987-12-20 00:00:00	1988-01-19	1988-01-19 00:00:00	32020		\N	190244	0	263102004	4134304		0
48435	2868	372328	1967-10-20	1967-10-20 00:00:00	1968-09-25	1968-09-25 00:00:00	32020		\N	190809	0	65363002	372328		0
69721	4124	4112343	1988-05-30	1988-05-30 00:00:00	1988-06-12	1988-06-12 00:00:00	32020		\N	274205	0	195662009	4112343		0
69964	4139	4152936	2007-09-23	2007-09-23 00:00:00	2007-10-07	2007-10-07 00:00:00	32020		\N	275163	0	283385000	4152936		0
59449	3526	40481087	1982-04-17	1982-04-17 00:00:00	1982-04-24	1982-04-24 00:00:00	32020		\N	233952	0	444814009	40481087		0
59712	3537	4048171	1963-07-02	1963-07-02 00:00:00	\N	\N	32020		\N	234895	0	232353008	4048171		0
59904	3549	40481087	2000-06-04	2000-06-04 00:00:00	2000-06-25	2000-06-25 00:00:00	32020		\N	235684	0	444814009	40481087		0
60056	3558	40481087	2004-05-01	2004-05-01 00:00:00	2004-05-22	2004-05-22 00:00:00	32020		\N	236177	0	444814009	40481087		0
60170	3562	28060	1997-02-04	1997-02-04 00:00:00	1997-02-11	1997-02-11 00:00:00	32020		\N	236618	0	43878008	28060		0
60340	3570	40481087	2004-06-29	2004-06-29 00:00:00	2004-07-20	2004-07-20 00:00:00	32020		\N	237280	0	444814009	40481087		0
49944	2950	40481087	2014-06-13	2014-06-13 00:00:00	2014-07-04	2014-07-04 00:00:00	32020		\N	196984	0	444814009	40481087		0
60680	3592	378001	1972-01-21	1972-01-21 00:00:00	1972-03-21	1972-03-21 00:00:00	32020		\N	238589	0	62106007	378001		0
60775	3598	40481087	1992-06-22	1992-06-22 00:00:00	1992-07-06	1992-07-06 00:00:00	32020		\N	238932	0	444814009	40481087		0
61044	3613	30753	2009-03-12	2009-03-12 00:00:00	\N	\N	32020		\N	240023	0	16761005	30753		0
61126	3616	4112343	1967-02-09	1967-02-09 00:00:00	1967-02-20	1967-02-20 00:00:00	32020		\N	240270	0	195662009	4112343		0
61298	3624	4112343	2012-12-03	2012-12-03 00:00:00	2012-12-13	2012-12-13 00:00:00	32020		\N	240947	0	195662009	4112343		0
61459	3631	260139	1994-03-03	1994-03-03 00:00:00	1994-03-10	1994-03-10 00:00:00	32020		\N	241604	0	10509002	260139		0
51095	3026	4294548	1997-12-10	1997-12-10 00:00:00	1998-02-04	1998-02-04 00:00:00	32020		\N	201769	0	75498004	4294548		0
61904	3655	40481087	1987-08-13	1987-08-13 00:00:00	1987-08-20	1987-08-20 00:00:00	32020		\N	243269	0	444814009	40481087		0
62068	3666	4112343	2017-01-21	2017-01-21 00:00:00	2017-01-28	2017-01-28 00:00:00	32020		\N	243917	0	195662009	4112343		0
62129	3668	4142905	1992-07-02	1992-07-02 00:00:00	1992-08-31	1992-08-31 00:00:00	32020		\N	244030	0	33737001	4142905		0
72915	4333	80180	1994-06-03	1994-06-03 00:00:00	\N	\N	32020		\N	287379	0	396275006	80180		0
62529	3694	4112343	1988-01-14	1988-01-14 00:00:00	1988-01-23	1988-01-23 00:00:00	32020		\N	245480	0	195662009	4112343		0
62616	3699	4112343	1985-07-16	1985-07-16 00:00:00	1985-07-23	1985-07-23 00:00:00	32020		\N	245929	0	195662009	4112343		0
62868	3714	260139	1963-03-31	1963-03-31 00:00:00	1963-04-14	1963-04-14 00:00:00	32020		\N	246757	0	10509002	260139		0
62931	3718	78272	1972-09-18	1972-09-18 00:00:00	1972-10-16	1972-10-16 00:00:00	32020		\N	247143	0	70704007	78272		0
73724	4380	260139	1983-07-27	1983-07-27 00:00:00	1983-08-10	1983-08-10 00:00:00	32020		\N	291047	0	10509002	260139		0
63405	3745	372328	1930-06-10	1930-06-10 00:00:00	1930-08-20	1930-08-20 00:00:00	32020		\N	248934	0	65363002	372328		0
63554	3754	372328	1961-04-25	1961-04-25 00:00:00	1961-06-13	1961-06-13 00:00:00	32020		\N	249542	0	65363002	372328		0
74238	4409	28060	1969-06-24	1969-06-24 00:00:00	1969-07-06	1969-07-06 00:00:00	32020		\N	293090	0	43878008	28060		0
53197	3150	4112343	1946-04-23	1946-04-23 00:00:00	1946-05-05	1946-05-05 00:00:00	32020		\N	209612	0	195662009	4112343		0
63930	3777	4310024	2015-05-19	2015-05-19 00:00:00	\N	\N	32020		\N	251045	0	424802006	4310024		0
53585	3175	40481087	1957-07-11	1957-07-11 00:00:00	1957-07-25	1957-07-25 00:00:00	32020		\N	211001	0	444814009	40481087		0
53682	3178	40481087	1989-03-20	1989-03-20 00:00:00	1989-04-10	1989-04-10 00:00:00	32020		\N	211426	0	444814009	40481087		0
43318	2579	260139	2006-01-14	2006-01-14 00:00:00	2006-01-28	2006-01-28 00:00:00	32020		\N	170850	0	10509002	260139		0
54060	3200	260139	1983-09-04	1983-09-04 00:00:00	1983-09-11	1983-09-11 00:00:00	32020		\N	212832	0	10509002	260139		0
43645	2598	4113008	1992-07-07	1992-07-07 00:00:00	1992-07-28	1992-07-28 00:00:00	32020		\N	171923	0	284549007	4113008		0
54345	3219	40481087	1984-12-02	1984-12-02 00:00:00	1984-12-09	1984-12-09 00:00:00	32020		\N	213888	0	444814009	40481087		0
54476	3226	40481087	2017-11-20	2017-11-20 00:00:00	2017-12-11	2017-12-11 00:00:00	32020		\N	214488	0	444814009	40481087		0
54684	3237	375671	1964-08-31	1964-08-31 00:00:00	1964-09-30	1964-09-30 00:00:00	32020		\N	215152	0	62564004	375671		0
54849	3246	4237458	1984-06-27	1984-06-27 00:00:00	1984-08-26	1984-08-26 00:00:00	32020		\N	215819	0	58150001	4237458		0
55086	3260	80180	1998-06-07	1998-06-07 00:00:00	\N	\N	32020		\N	216737	0	396275006	80180		0
65774	3889	28060	1966-02-25	1966-02-25 00:00:00	1966-03-07	1966-03-07 00:00:00	32020		\N	258478	0	43878008	28060		0
55358	3279	78272	2010-02-06	2010-02-06 00:00:00	2010-02-20	2010-02-20 00:00:00	32020		\N	217816	0	70704007	78272		0
55528	3289	440086	1965-12-20	1965-12-20 00:00:00	1966-08-29	1966-08-29 00:00:00	32020		\N	218527	0	192127007	440086		0
55710	3296	380378	1966-09-18	1966-09-18 00:00:00	\N	\N	32020		\N	219093	0	84757009	380378		0
55778	3301	28060	1939-11-27	1939-11-27 00:00:00	1939-12-09	1939-12-09 00:00:00	32020		\N	219303	0	43878008	28060		0
66576	3939	40481087	2017-08-11	2017-08-11 00:00:00	2017-09-01	2017-09-01 00:00:00	32020		\N	261858	0	444814009	40481087		0
56236	3332	4112343	1971-03-17	1971-03-17 00:00:00	1971-03-27	1971-03-27 00:00:00	32020		\N	221068	0	195662009	4112343		0
56380	3342	4112343	1971-10-11	1971-10-11 00:00:00	1971-10-21	1971-10-21 00:00:00	32020		\N	221564	0	195662009	4112343		0
56525	3353	28060	1962-05-02	1962-05-02 00:00:00	1962-05-10	1962-05-10 00:00:00	32020		\N	222334	0	43878008	28060		0
67276	3976	4112343	1964-04-13	1964-04-13 00:00:00	1964-04-21	1964-04-21 00:00:00	32020		\N	264379	0	195662009	4112343		0
56888	3375	4112343	1976-12-06	1976-12-06 00:00:00	1976-12-19	1976-12-19 00:00:00	32020		\N	223912	0	195662009	4112343		0
56997	3381	40481087	1981-10-20	1981-10-20 00:00:00	1981-11-03	1981-11-03 00:00:00	32020		\N	224383	0	444814009	40481087		0
57106	3389	40481087	1978-04-10	1978-04-10 00:00:00	1978-04-17	1978-04-17 00:00:00	32020		\N	224762	0	444814009	40481087		0
57387	3407	40481087	2013-07-26	2013-07-26 00:00:00	2013-08-09	2013-08-09 00:00:00	32020		\N	225954	0	444814009	40481087		0
57531	3413	260139	1974-09-13	1974-09-13 00:00:00	1974-09-20	1974-09-20 00:00:00	32020		\N	226418	0	10509002	260139		0
57707	3422	28060	1975-03-08	1975-03-08 00:00:00	1975-03-19	1975-03-19 00:00:00	32020		\N	226953	0	43878008	28060		0
57856	3432	372328	1957-04-04	1957-04-04 00:00:00	1957-10-25	1957-10-25 00:00:00	32020		\N	227502	0	65363002	372328		0
58005	3438	4310024	1945-10-05	1945-10-05 00:00:00	\N	\N	32020		\N	228115	0	424802006	4310024		0
58157	3444	80180	1970-12-12	1970-12-12 00:00:00	\N	\N	32020		\N	228554	0	396275006	80180		0
47784	2837	260139	1998-09-23	1998-09-23 00:00:00	1998-10-02	1998-10-02 00:00:00	32020		\N	188439	0	10509002	260139		0
58443	3462	257012	1961-05-27	1961-05-27 00:00:00	\N	\N	32020		\N	229678	0	40055000	257012		0
69266	4100	381316	2008-08-27	2008-08-27 00:00:00	\N	\N	32020		\N	272433	0	230690007	381316		0
48279	2861	4112343	2013-11-13	2013-11-13 00:00:00	2013-11-24	2013-11-24 00:00:00	32020		\N	190196	0	195662009	4112343		0
48436	2868	260139	2009-05-31	2009-05-31 00:00:00	2009-06-07	2009-06-07 00:00:00	32020		\N	190808	0	10509002	260139		0
69722	4125	4237458	1992-06-14	1992-06-14 00:00:00	1992-07-14	1992-07-14 00:00:00	32020		\N	274215	0	58150001	4237458		0
69965	4139	4116491	1996-10-30	1996-10-30 00:00:00	1996-12-16	1996-12-16 00:00:00	32020		\N	275103	0	301011002	4116491		0
59450	3526	4283893	2003-04-10	2003-04-10 00:00:00	2003-08-21	2003-08-21 00:00:00	32020		\N	233994	0	36971009	4283893		0
59713	3537	378001	1975-10-29	1975-10-29 00:00:00	1975-11-28	1975-11-28 00:00:00	32020		\N	234964	0	62106007	378001		0
59905	3549	40481087	2018-02-02	2018-02-02 00:00:00	2018-02-23	2018-02-23 00:00:00	32020		\N	235694	0	444814009	40481087		0
60057	3559	80180	1991-08-06	1991-08-06 00:00:00	\N	\N	32020		\N	236288	0	396275006	80180		0
60171	3562	81151	1975-06-16	1975-06-16 00:00:00	1975-07-14	1975-07-14 00:00:00	32020		\N	236606	0	44465007	81151		0
60341	3570	378001	1990-03-17	1990-03-17 00:00:00	1990-05-16	1990-05-16 00:00:00	32020		\N	237227	0	62106007	378001		0
49945	2951	260139	1983-09-21	1983-09-21 00:00:00	1983-09-28	1983-09-28 00:00:00	32020		\N	197047	0	10509002	260139		0
60681	3592	4294548	1969-09-21	1969-09-21 00:00:00	1969-12-07	1969-12-07 00:00:00	32020		\N	238568	0	75498004	4294548		0
60776	3598	80180	1980-07-05	1980-07-05 00:00:00	\N	\N	32020		\N	238966	0	396275006	80180		0
61045	3613	40481087	2009-01-05	2009-01-05 00:00:00	2009-01-12	2009-01-12 00:00:00	32020		\N	240023	0	444814009	40481087		0
61127	3616	4218389	1997-10-28	1997-10-28 00:00:00	1997-11-18	1997-11-18 00:00:00	32020		\N	240292	0	39848009	4218389		0
61299	3624	40481087	1994-09-16	1994-09-16 00:00:00	1994-10-07	1994-10-07 00:00:00	32020		\N	240995	0	444814009	40481087		0
61460	3631	260139	1978-09-10	1978-09-10 00:00:00	1978-09-17	1978-09-17 00:00:00	32020		\N	241616	0	10509002	260139		0
51096	3026	40479768	2019-05-31	2019-05-31 00:00:00	\N	\N	32020		\N	201730	0	444470001	40479768		0
61905	3655	4112343	1989-07-02	1989-07-02 00:00:00	1989-07-13	1989-07-13 00:00:00	32020		\N	243251	0	195662009	4112343		0
62069	3666	4112343	1969-04-29	1969-04-29 00:00:00	1969-05-12	1969-05-12 00:00:00	32020		\N	243859	0	195662009	4112343		0
62130	3668	40481087	1996-08-18	1996-08-18 00:00:00	1996-09-01	1996-09-01 00:00:00	32020		\N	244015	0	444814009	40481087		0
72916	4333	4112343	1996-11-10	1996-11-10 00:00:00	1996-11-17	1996-11-17 00:00:00	32020		\N	287418	0	195662009	4112343		0
62530	3694	40481087	1993-03-26	1993-03-26 00:00:00	1993-04-16	1993-04-16 00:00:00	32020		\N	245514	0	444814009	40481087		0
62617	3699	4112343	2010-01-25	2010-01-25 00:00:00	2010-02-06	2010-02-06 00:00:00	32020		\N	245898	0	195662009	4112343		0
62869	3714	78272	1956-06-28	1956-06-28 00:00:00	1956-07-19	1956-07-19 00:00:00	32020		\N	246847	0	70704007	78272		0
62932	3718	4112343	1979-06-28	1979-06-28 00:00:00	1979-07-07	1979-07-07 00:00:00	32020		\N	247108	0	195662009	4112343		0
73725	4381	260139	1987-10-23	1987-10-23 00:00:00	1987-11-06	1987-11-06 00:00:00	32020		\N	291106	0	10509002	260139		0
63406	3745	260139	2003-12-03	2003-12-03 00:00:00	2003-12-17	2003-12-17 00:00:00	32020		\N	248915	0	10509002	260139		0
63555	3754	372328	1964-12-24	1964-12-24 00:00:00	1965-06-01	1965-06-01 00:00:00	32020		\N	249557	0	65363002	372328		0
74239	4409	81151	1983-07-15	1983-07-15 00:00:00	1983-08-19	1983-08-19 00:00:00	32020		\N	293128	0	44465007	81151		0
53198	3150	40481087	1955-08-09	1955-08-09 00:00:00	1955-08-30	1955-08-30 00:00:00	32020		\N	209613	0	444814009	40481087		0
63931	3777	40481087	2015-01-14	2015-01-14 00:00:00	2015-01-21	2015-01-21 00:00:00	32020		\N	251045	0	444814009	40481087		0
53586	3175	28060	1954-02-25	1954-02-25 00:00:00	1954-03-08	1954-03-08 00:00:00	32020		\N	211048	0	43878008	28060		0
53683	3178	80180	1994-07-30	1994-07-30 00:00:00	\N	\N	32020		\N	211374	0	396275006	80180		0
43319	2579	40481087	2006-11-01	2006-11-01 00:00:00	2006-11-08	2006-11-08 00:00:00	32020		\N	170774	0	444814009	40481087		0
54061	3200	28060	1980-01-05	1980-01-05 00:00:00	1980-01-15	1980-01-15 00:00:00	32020		\N	212791	0	43878008	28060		0
43646	2599	4112343	1984-01-29	1984-01-29 00:00:00	1984-02-09	1984-02-09 00:00:00	32020		\N	171989	0	195662009	4112343		0
54346	3219	260139	1994-05-16	1994-05-16 00:00:00	1994-05-30	1994-05-30 00:00:00	32020		\N	213909	0	10509002	260139		0
54477	3226	260139	1995-10-09	1995-10-09 00:00:00	1995-10-16	1995-10-16 00:00:00	32020		\N	214456	0	10509002	260139		0
54685	3237	80180	1964-09-15	1964-09-15 00:00:00	\N	\N	32020		\N	215152	0	396275006	80180		0
54850	3246	4218389	1990-04-27	1990-04-27 00:00:00	1990-05-18	1990-05-18 00:00:00	32020		\N	215820	0	39848009	4218389		0
55087	3260	40481087	2002-08-09	2002-08-09 00:00:00	2002-08-30	2002-08-30 00:00:00	32020		\N	216762	0	444814009	40481087		0
65775	3889	80180	1976-03-21	1976-03-21 00:00:00	\N	\N	32020		\N	258465	0	396275006	80180		0
55359	3279	260139	1966-09-14	1966-09-14 00:00:00	1966-09-28	1966-09-28 00:00:00	32020		\N	217884	0	10509002	260139		0
55529	3289	372328	1957-12-29	1957-12-29 00:00:00	1958-05-30	1958-05-30 00:00:00	32020		\N	218507	0	65363002	372328		0
55711	3296	4029498	1966-09-18	1966-09-18 00:00:00	\N	\N	32020		\N	219093	0	128613002	4029498		0
55779	3301	78272	1988-11-06	1988-11-06 00:00:00	1988-11-27	1988-11-27 00:00:00	32020		\N	219286	0	70704007	78272		0
66577	3939	260139	2008-09-28	2008-09-28 00:00:00	2008-10-05	2008-10-05 00:00:00	32020		\N	261866	0	10509002	260139		0
56237	3332	260139	1974-11-24	1974-11-24 00:00:00	1974-12-01	1974-12-01 00:00:00	32020		\N	221125	0	10509002	260139		0
56381	3342	4283893	2002-11-09	2002-11-09 00:00:00	2003-03-08	2003-03-08 00:00:00	32020		\N	221580	0	36971009	4283893		0
56526	3353	260139	1947-01-27	1947-01-27 00:00:00	1947-02-03	1947-02-03 00:00:00	32020		\N	222414	0	10509002	260139		0
67277	3976	260139	1996-03-13	1996-03-13 00:00:00	1996-03-27	1996-03-27 00:00:00	32020		\N	264328	0	10509002	260139		0
56889	3375	40481087	2000-06-01	2000-06-01 00:00:00	2000-06-15	2000-06-15 00:00:00	32020		\N	223871	0	444814009	40481087		0
56998	3381	260139	2015-07-24	2015-07-24 00:00:00	2015-08-07	2015-08-07 00:00:00	32020		\N	224385	0	10509002	260139		0
57107	3389	4278672	1973-01-15	1973-01-15 00:00:00	1973-02-14	1973-02-14 00:00:00	32020		\N	224743	0	65966004	4278672		0
57388	3407	4296204	1999-07-15	1999-07-15 00:00:00	1999-08-05	1999-08-05 00:00:00	32020		\N	225977	0	403190006	4296204		0
57532	3413	40481087	1977-05-22	1977-05-22 00:00:00	1977-06-05	1977-06-05 00:00:00	32020		\N	226398	0	444814009	40481087		0
57708	3422	40481087	2006-12-16	2006-12-16 00:00:00	2006-12-30	2006-12-30 00:00:00	32020		\N	227002	0	444814009	40481087		0
57857	3432	40481087	2006-04-17	2006-04-17 00:00:00	2006-05-08	2006-05-08 00:00:00	32020		\N	227532	0	444814009	40481087		0
58006	3438	260139	1944-01-03	1944-01-03 00:00:00	1944-01-10	1944-01-10 00:00:00	32020		\N	228115	0	10509002	260139		0
58158	3444	4112343	1955-01-18	1955-01-18 00:00:00	1955-01-25	1955-01-25 00:00:00	32020		\N	228519	0	195662009	4112343		0
47785	2837	4112343	1998-03-15	1998-03-15 00:00:00	1998-03-23	1998-03-23 00:00:00	32020		\N	188439	0	195662009	4112343		0
58444	3462	4294548	1996-08-08	1996-08-08 00:00:00	1997-02-20	1997-02-20 00:00:00	32020		\N	229686	0	75498004	4294548		0
69267	4100	78272	1952-03-17	1952-03-17 00:00:00	1952-04-21	1952-04-21 00:00:00	32020		\N	272466	0	70704007	78272		0
48280	2861	4112343	1992-05-12	1992-05-12 00:00:00	1992-05-20	1992-05-20 00:00:00	32020		\N	190207	0	195662009	4112343		0
48437	2868	4112343	1969-08-21	1969-08-21 00:00:00	1969-09-03	1969-09-03 00:00:00	32020		\N	190802	0	195662009	4112343		0
69723	4125	81151	1969-07-10	1969-07-10 00:00:00	1969-07-24	1969-07-24 00:00:00	32020		\N	274211	0	44465007	81151		0
69966	4139	4059173	1994-11-30	1994-11-30 00:00:00	1995-02-28	1995-02-28 00:00:00	32020		\N	275166	0	16114001	4059173		0
59451	3526	4285898	1986-01-07	1986-01-07 00:00:00	\N	\N	32020		\N	233969	0	68496003	4285898		0
59722	3539	4112343	2004-09-23	2004-09-23 00:00:00	2004-10-03	2004-10-03 00:00:00	32020		\N	235083	0	195662009	4112343		0
59906	3549	40481087	1963-09-27	1963-09-27 00:00:00	1963-10-18	1963-10-18 00:00:00	32020		\N	235676	0	444814009	40481087		0
60058	3559	4112343	2017-10-13	2017-10-13 00:00:00	2017-10-22	2017-10-22 00:00:00	32020		\N	236246	0	195662009	4112343		0
60172	3562	40481087	1980-09-23	1980-09-23 00:00:00	1980-10-07	1980-10-07 00:00:00	32020		\N	236615	0	444814009	40481087		0
60342	3570	40481087	1989-08-15	1989-08-15 00:00:00	1989-08-29	1989-08-29 00:00:00	32020		\N	237273	0	444814009	40481087		0
49946	2951	40481087	2006-11-29	2006-11-29 00:00:00	2006-12-20	2006-12-20 00:00:00	32020		\N	197034	0	444814009	40481087		0
60682	3592	4112343	1967-07-31	1967-07-31 00:00:00	1967-08-10	1967-08-10 00:00:00	32020		\N	238585	0	195662009	4112343		0
60777	3598	195588	1978-03-18	1978-03-18 00:00:00	1978-05-04	1978-05-04 00:00:00	32020		\N	238965	0	38822007	195588		0
61046	3613	40481087	1988-11-23	1988-11-23 00:00:00	1988-11-30	1988-11-30 00:00:00	32020		\N	240032	0	444814009	40481087		0
61128	3616	372328	1960-05-15	1960-05-15 00:00:00	1960-08-02	1960-08-02 00:00:00	32020		\N	240263	0	65363002	372328		0
61300	3624	4218389	1984-12-07	1984-12-07 00:00:00	1984-12-28	1984-12-28 00:00:00	32020		\N	241011	0	39848009	4218389		0
61461	3631	4112343	1980-05-17	1980-05-17 00:00:00	1980-05-28	1980-05-28 00:00:00	32020		\N	241628	0	195662009	4112343		0
51097	3026	40481087	1965-06-08	1965-06-08 00:00:00	1965-06-22	1965-06-22 00:00:00	32020		\N	201757	0	444814009	40481087		0
61906	3655	260139	1972-01-15	1972-01-15 00:00:00	1972-01-22	1972-01-22 00:00:00	32020		\N	243277	0	10509002	260139		0
62070	3666	260139	1979-12-16	1979-12-16 00:00:00	1979-12-30	1979-12-30 00:00:00	32020		\N	243881	0	10509002	260139		0
62131	3668	260139	2000-08-30	2000-08-30 00:00:00	2000-09-06	2000-09-06 00:00:00	32020		\N	244006	0	10509002	260139		0
72917	4333	4113008	1980-05-03	1980-05-03 00:00:00	1980-05-17	1980-05-17 00:00:00	32020		\N	287411	0	284549007	4113008		0
62531	3694	4112343	1978-02-20	1978-02-20 00:00:00	1978-03-05	1978-03-05 00:00:00	32020		\N	245497	0	195662009	4112343		0
62618	3699	4112343	2017-06-01	2017-06-01 00:00:00	2017-06-12	2017-06-12 00:00:00	32020		\N	245948	0	195662009	4112343		0
62870	3714	4059173	1937-01-20	1937-01-20 00:00:00	1937-03-21	1937-03-21 00:00:00	32020		\N	246844	0	16114001	4059173		0
62933	3718	81893	2001-10-11	2001-10-11 00:00:00	\N	\N	32020		\N	247124	0	64766004	81893		0
73726	4381	40481087	1989-11-26	1989-11-26 00:00:00	1989-12-03	1989-12-03 00:00:00	32020		\N	291093	0	444814009	40481087		0
63407	3745	40481087	2008-08-31	2008-08-31 00:00:00	2008-09-14	2008-09-14 00:00:00	32020		\N	248949	0	444814009	40481087		0
63556	3754	28060	1965-05-25	1965-05-25 00:00:00	1965-06-01	1965-06-01 00:00:00	32020		\N	249441	0	43878008	28060		0
74240	4409	40481087	1976-08-08	1976-08-08 00:00:00	1976-08-22	1976-08-22 00:00:00	32020		\N	293119	0	444814009	40481087		0
53199	3150	4112343	1980-06-18	1980-06-18 00:00:00	1980-06-30	1980-06-30 00:00:00	32020		\N	209594	0	195662009	4112343		0
63932	3777	81893	2016-01-14	2016-01-14 00:00:00	\N	\N	32020		\N	251045	0	64766004	81893		0
53587	3175	4112343	1954-05-09	1954-05-09 00:00:00	1954-05-22	1954-05-22 00:00:00	32020		\N	211016	0	195662009	4112343		0
53684	3178	40481087	1994-02-21	1994-02-21 00:00:00	1994-02-28	1994-02-28 00:00:00	32020		\N	211374	0	444814009	40481087		0
43321	2579	4285898	1991-11-02	1991-11-02 00:00:00	\N	\N	32020		\N	170811	0	68496003	4285898		0
54062	3200	4230399	2014-09-13	2014-09-13 00:00:00	2014-11-12	2014-11-12 00:00:00	32020		\N	212829	0	359817006	4230399		0
43647	2599	372328	1980-09-14	1980-09-14 00:00:00	1981-01-03	1981-01-03 00:00:00	32020		\N	171991	0	65363002	372328		0
54347	3219	81151	1990-08-24	1990-08-24 00:00:00	1990-09-28	1990-09-28 00:00:00	32020		\N	213929	0	44465007	81151		0
54478	3226	260139	2008-06-25	2008-06-25 00:00:00	2008-07-02	2008-07-02 00:00:00	32020		\N	214477	0	10509002	260139		0
54686	3237	4112343	2009-12-01	2009-12-01 00:00:00	2009-12-12	2009-12-12 00:00:00	32020		\N	215191	0	195662009	4112343		0
54851	3246	260139	1984-12-14	1984-12-14 00:00:00	1984-12-21	1984-12-21 00:00:00	32020		\N	215804	0	10509002	260139		0
55088	3260	4152936	1968-11-05	1968-11-05 00:00:00	1968-11-26	1968-11-26 00:00:00	32020		\N	216749	0	283385000	4152936		0
65776	3889	40481087	2010-01-15	2010-01-15 00:00:00	2010-01-29	2010-01-29 00:00:00	32020		\N	258471	0	444814009	40481087		0
55360	3279	4112343	1971-01-21	1971-01-21 00:00:00	1971-02-02	1971-02-02 00:00:00	32020		\N	217902	0	195662009	4112343		0
55530	3289	4048695	1968-01-10	1968-01-10 00:00:00	1968-03-12	1968-03-12 00:00:00	32020		\N	218491	0	15724005	4048695		0
55712	3296	260139	1948-10-02	1948-10-02 00:00:00	1948-10-09	1948-10-09 00:00:00	32020		\N	219085	0	10509002	260139		0
55780	3301	4278672	2011-05-31	2011-05-31 00:00:00	2011-07-30	2011-07-30 00:00:00	32020		\N	219287	0	65966004	4278672		0
66578	3939	28060	1982-12-22	1982-12-22 00:00:00	1982-12-30	1982-12-30 00:00:00	32020		\N	261813	0	43878008	28060		0
56238	3332	4149245	2014-06-08	2014-06-08 00:00:00	2014-08-14	2014-08-14 00:00:00	32020		\N	221133	0	30832001	4149245		0
56382	3342	40481087	1938-12-10	1938-12-10 00:00:00	1938-12-24	1938-12-24 00:00:00	32020		\N	221549	0	444814009	40481087		0
56527	3353	260139	1947-12-14	1947-12-14 00:00:00	1947-12-28	1947-12-28 00:00:00	32020		\N	222415	0	10509002	260139		0
67278	3976	40481087	1972-03-26	1972-03-26 00:00:00	1972-04-09	1972-04-09 00:00:00	32020		\N	264386	0	444814009	40481087		0
56890	3375	372328	1956-11-19	1956-11-19 00:00:00	1957-02-08	1957-02-08 00:00:00	32020		\N	223883	0	65363002	372328		0
56999	3381	260139	2018-06-05	2018-06-05 00:00:00	2018-06-12	2018-06-12 00:00:00	32020		\N	224369	0	10509002	260139		0
57108	3389	4112343	1996-02-15	1996-02-15 00:00:00	1996-02-22	1996-02-22 00:00:00	32020		\N	224764	0	195662009	4112343		0
57389	3407	372328	1964-06-18	1964-06-18 00:00:00	1964-07-02	1964-07-02 00:00:00	32020		\N	225984	0	65363002	372328		0
57533	3413	260139	2009-03-12	2009-03-12 00:00:00	2009-03-19	2009-03-19 00:00:00	32020		\N	226400	0	10509002	260139		0
57709	3422	372328	1988-09-24	1988-09-24 00:00:00	1990-09-24	1990-09-24 00:00:00	32020		\N	227030	0	65363002	372328		0
57858	3432	4278672	2007-09-10	2007-09-10 00:00:00	2007-11-09	2007-11-09 00:00:00	32020		\N	227490	0	65966004	4278672		0
58007	3438	260139	1927-01-03	1927-01-03 00:00:00	1927-01-10	1927-01-10 00:00:00	32020		\N	228072	0	10509002	260139		0
58159	3444	40481087	1949-05-15	1949-05-15 00:00:00	1949-05-29	1949-05-29 00:00:00	32020		\N	228614	0	444814009	40481087		0
47786	2837	40481087	1977-06-26	1977-06-26 00:00:00	1977-07-03	1977-07-03 00:00:00	32020		\N	188436	0	444814009	40481087		0
58445	3462	28060	1975-01-27	1975-01-27 00:00:00	1975-02-07	1975-02-07 00:00:00	32020		\N	229682	0	43878008	28060		0
69268	4100	40481087	1975-09-03	1975-09-03 00:00:00	1975-09-17	1975-09-17 00:00:00	32020		\N	272382	0	444814009	40481087		0
48281	2861	260139	1989-04-24	1989-04-24 00:00:00	1989-05-08	1989-05-08 00:00:00	32020		\N	190185	0	10509002	260139		0
48438	2868	4109685	1970-03-02	1970-03-02 00:00:00	1970-03-16	1970-03-16 00:00:00	32020		\N	190818	0	284551006	4109685		0
69724	4125	260139	2015-05-20	2015-05-20 00:00:00	2015-05-27	2015-05-27 00:00:00	32020		\N	274264	0	10509002	260139		0
69967	4139	40481087	1999-07-20	1999-07-20 00:00:00	1999-07-27	1999-07-27 00:00:00	32020		\N	275113	0	444814009	40481087		0
59452	3526	4310024	1984-11-13	1984-11-13 00:00:00	\N	\N	32020		\N	233969	0	424802006	4310024		0
59723	3539	40481087	1981-07-15	1981-07-15 00:00:00	1981-07-29	1981-07-29 00:00:00	32020		\N	235103	0	444814009	40481087		0
59907	3549	40481087	1986-07-13	1986-07-13 00:00:00	1986-07-20	1986-07-20 00:00:00	32020		\N	235680	0	444814009	40481087		0
60059	3559	81151	1978-10-26	1978-10-26 00:00:00	1978-11-16	1978-11-16 00:00:00	32020		\N	236260	0	44465007	81151		0
60173	3562	4278672	1974-07-21	1974-07-21 00:00:00	1974-08-20	1974-08-20 00:00:00	32020		\N	236605	0	65966004	4278672		0
60343	3570	372328	1953-03-14	1953-03-14 00:00:00	1953-11-15	1953-11-15 00:00:00	32020		\N	237274	0	65363002	372328		0
49947	2951	40481087	2013-05-24	2013-05-24 00:00:00	2013-05-31	2013-05-31 00:00:00	32020		\N	196998	0	444814009	40481087		0
60683	3592	4285898	2001-04-08	2001-04-08 00:00:00	\N	\N	32020		\N	238594	0	68496003	4285898		0
60778	3598	28060	1963-02-03	1963-02-03 00:00:00	1963-02-15	1963-02-15 00:00:00	32020		\N	238928	0	43878008	28060		0
61047	3613	28060	1981-04-29	1981-04-29 00:00:00	1981-05-11	1981-05-11 00:00:00	32020		\N	240022	0	43878008	28060		0
61129	3616	40481087	2015-03-02	2015-03-02 00:00:00	2015-03-16	2015-03-16 00:00:00	32020		\N	240273	0	444814009	40481087		0
61301	3624	4112343	2016-08-27	2016-08-27 00:00:00	2016-09-06	2016-09-06 00:00:00	32020		\N	240948	0	195662009	4112343		0
61462	3631	80180	2010-08-06	2010-08-06 00:00:00	\N	\N	32020		\N	241578	0	396275006	80180		0
51098	3026	40481087	1987-02-14	1987-02-14 00:00:00	1987-02-28	1987-02-28 00:00:00	32020		\N	201765	0	444814009	40481087		0
61907	3655	4112343	1997-03-06	1997-03-06 00:00:00	1997-03-19	1997-03-19 00:00:00	32020		\N	243252	0	195662009	4112343		0
62071	3666	4296204	1979-10-08	1979-10-08 00:00:00	1979-10-29	1979-10-29 00:00:00	32020		\N	243868	0	403190006	4296204		0
62132	3668	4278672	1991-05-09	1991-05-09 00:00:00	1991-07-08	1991-07-08 00:00:00	32020		\N	244029	0	65966004	4278672		0
72918	4333	440448	1980-08-22	1980-08-22 00:00:00	\N	\N	32020		\N	287412	0	74400008	440448		0
62532	3694	313217	2016-02-23	2016-02-23 00:00:00	\N	\N	32020		\N	245555	0	49436004	313217		0
62619	3699	4027663	2001-07-07	2001-07-07 00:00:00	\N	\N	32020		\N	245907	0	13200003	4027663		0
62871	3714	40481087	2011-10-31	2011-10-31 00:00:00	2011-11-21	2011-11-21 00:00:00	32020		\N	246798	0	444814009	40481087		0
62934	3718	30753	2001-11-10	2001-11-10 00:00:00	\N	\N	32020		\N	247124	0	16761005	30753		0
73727	4381	40481087	1970-09-07	1970-09-07 00:00:00	1970-09-14	1970-09-14 00:00:00	32020		\N	291103	0	444814009	40481087		0
63408	3745	378001	1953-08-13	1953-08-13 00:00:00	1953-10-12	1953-10-12 00:00:00	32020		\N	248877	0	62106007	378001		0
63557	3754	28060	1963-02-18	1963-02-18 00:00:00	1963-03-03	1963-03-03 00:00:00	32020		\N	249501	0	43878008	28060		0
74241	4409	40481087	2001-05-03	2001-05-03 00:00:00	2001-05-24	2001-05-24 00:00:00	32020		\N	293095	0	444814009	40481087		0
53200	3150	372328	1939-11-23	1939-11-23 00:00:00	1940-01-04	1940-01-04 00:00:00	32020		\N	209585	0	65363002	372328		0
63933	3777	4027663	2010-04-20	2010-04-20 00:00:00	\N	\N	32020		\N	251014	0	13200003	4027663		0
53588	3176	378001	1990-04-10	1990-04-10 00:00:00	1990-06-09	1990-06-09 00:00:00	32020		\N	211124	0	62106007	378001		0
53685	3178	4266809	1994-07-30	1994-07-30 00:00:00	\N	\N	32020		\N	211374	0	397881000	4266809		0
43322	2579	40481087	1990-06-05	1990-06-05 00:00:00	1990-06-12	1990-06-12 00:00:00	32020		\N	170811	0	444814009	40481087		0
54063	3200	4112343	1993-02-20	1993-02-20 00:00:00	1993-03-03	1993-03-03 00:00:00	32020		\N	212833	0	195662009	4112343		0
43648	2599	4112343	2018-12-25	2018-12-25 00:00:00	2019-01-03	2019-01-03 00:00:00	32020		\N	171976	0	195662009	4112343		0
54348	3219	4112343	1986-12-28	1986-12-28 00:00:00	1987-01-10	1987-01-10 00:00:00	32020		\N	213918	0	195662009	4112343		0
54479	3226	28060	1971-01-09	1971-01-09 00:00:00	1971-01-19	1971-01-19 00:00:00	32020		\N	214455	0	43878008	28060		0
54687	3237	4109685	1928-05-02	1928-05-02 00:00:00	1928-05-23	1928-05-23 00:00:00	32020		\N	215148	0	284551006	4109685		0
54857	3248	40481087	2000-04-26	2000-04-26 00:00:00	2000-05-17	2000-05-17 00:00:00	32020		\N	215921	0	444814009	40481087		0
55089	3260	81151	1961-04-27	1961-04-27 00:00:00	1961-05-18	1961-05-18 00:00:00	32020		\N	216747	0	44465007	81151		0
65777	3889	40481087	1994-10-23	1994-10-23 00:00:00	1994-11-06	1994-11-06 00:00:00	32020		\N	258454	0	444814009	40481087		0
55361	3279	4094814	1972-10-23	1972-10-23 00:00:00	1972-12-22	1972-12-22 00:00:00	32020		\N	217919	0	262574004	4094814		0
55531	3289	260139	1986-10-13	1986-10-13 00:00:00	1986-10-20	1986-10-20 00:00:00	32020		\N	218535	0	10509002	260139		0
55713	3296	4237458	2019-02-08	2019-02-08 00:00:00	2019-04-09	2019-04-09 00:00:00	32020		\N	219097	0	58150001	4237458		0
55781	3301	378001	1965-03-14	1965-03-14 00:00:00	1965-04-13	1965-04-13 00:00:00	32020		\N	219262	0	62106007	378001		0
66597	3941	260139	1969-06-20	1969-06-20 00:00:00	1969-06-27	1969-06-27 00:00:00	32020		\N	262058	0	10509002	260139		0
56239	3332	28060	1998-06-19	1998-06-19 00:00:00	1998-06-28	1998-06-28 00:00:00	32020		\N	221126	0	43878008	28060		0
56383	3342	40481087	1967-04-04	1967-04-04 00:00:00	1967-04-18	1967-04-18 00:00:00	32020		\N	221563	0	444814009	40481087		0
56528	3353	4027663	1949-12-21	1949-12-21 00:00:00	\N	\N	32020		\N	222356	0	13200003	4027663		0
67279	3976	40481087	1965-06-12	1965-06-12 00:00:00	1965-06-26	1965-06-26 00:00:00	32020		\N	264323	0	444814009	40481087		0
56891	3375	80180	1995-09-11	1995-09-11 00:00:00	\N	\N	32020		\N	223880	0	396275006	80180		0
57000	3381	4112343	1979-12-23	1979-12-23 00:00:00	1980-01-02	1980-01-02 00:00:00	32020		\N	224337	0	195662009	4112343		0
57109	3389	80180	1996-06-08	1996-06-08 00:00:00	\N	\N	32020		\N	224764	0	396275006	80180		0
57390	3407	40481087	2016-05-04	2016-05-04 00:00:00	2016-05-25	2016-05-25 00:00:00	32020		\N	225935	0	444814009	40481087		0
57534	3413	40481087	1985-03-08	1985-03-08 00:00:00	1985-03-29	1985-03-29 00:00:00	32020		\N	226399	0	444814009	40481087		0
57710	3423	260139	1992-04-16	1992-04-16 00:00:00	1992-04-30	1992-04-30 00:00:00	32020		\N	227064	0	10509002	260139		0
57859	3432	80180	1994-06-16	1994-06-16 00:00:00	\N	\N	32020		\N	227517	0	396275006	80180		0
58008	3438	439777	1980-03-30	1980-03-30 00:00:00	\N	\N	32020		\N	228075	0	271737000	439777		0
58160	3444	40481087	1987-10-04	1987-10-04 00:00:00	1987-10-11	1987-10-11 00:00:00	32020		\N	228538	0	444814009	40481087		0
47787	2837	40481087	1984-06-13	1984-06-13 00:00:00	1984-06-27	1984-06-27 00:00:00	32020		\N	188461	0	444814009	40481087		0
58446	3462	40481087	2010-03-12	2010-03-12 00:00:00	2010-03-26	2010-03-26 00:00:00	32020		\N	229688	0	444814009	40481087		0
69269	4100	40481087	1978-05-11	1978-05-11 00:00:00	1978-05-25	1978-05-25 00:00:00	32020		\N	272408	0	444814009	40481087		0
48282	2861	28060	1999-01-16	1999-01-16 00:00:00	1999-01-29	1999-01-29 00:00:00	32020		\N	190186	0	43878008	28060		0
48439	2868	372328	1966-06-21	1966-06-21 00:00:00	1966-09-14	1966-09-14 00:00:00	32020		\N	190803	0	65363002	372328		0
69725	4125	4237458	1978-01-08	1978-01-08 00:00:00	1978-04-08	1978-04-08 00:00:00	32020		\N	274212	0	58150001	4237458		0
69968	4139	4112343	1971-12-03	1971-12-03 00:00:00	1971-12-16	1971-12-16 00:00:00	32020		\N	275133	0	195662009	4112343		0
59453	3526	260139	2015-01-05	2015-01-05 00:00:00	2015-01-19	2015-01-19 00:00:00	32020		\N	233912	0	10509002	260139		0
59724	3539	260139	1983-06-01	1983-06-01 00:00:00	1983-06-15	1983-06-15 00:00:00	32020		\N	235094	0	10509002	260139		0
59908	3549	4112343	1999-07-15	1999-07-15 00:00:00	1999-07-24	1999-07-24 00:00:00	32020		\N	235683	0	195662009	4112343		0
60060	3559	4112343	1996-06-08	1996-06-08 00:00:00	1996-06-18	1996-06-18 00:00:00	32020		\N	236277	0	195662009	4112343		0
60174	3562	4027663	2002-08-13	2002-08-13 00:00:00	\N	\N	32020		\N	236589	0	13200003	4027663		0
60344	3570	40481087	1971-11-18	1971-11-18 00:00:00	1971-11-25	1971-11-25 00:00:00	32020		\N	237267	0	444814009	40481087		0
49948	2951	372328	1959-11-11	1959-11-11 00:00:00	1960-01-24	1960-01-24 00:00:00	32020		\N	197059	0	65363002	372328		0
60684	3592	30753	2000-11-09	2000-11-09 00:00:00	\N	\N	32020		\N	238594	0	16761005	30753		0
60779	3598	40481087	1954-03-07	1954-03-07 00:00:00	1954-03-21	1954-03-21 00:00:00	32020		\N	238926	0	444814009	40481087		0
61048	3613	4112343	2013-07-04	2013-07-04 00:00:00	2013-07-13	2013-07-13 00:00:00	32020		\N	240047	0	195662009	4112343		0
61130	3616	81151	2013-05-28	2013-05-28 00:00:00	2013-07-02	2013-07-02 00:00:00	32020		\N	240293	0	44465007	81151		0
61302	3624	78272	1958-07-01	1958-07-01 00:00:00	1958-07-29	1958-07-29 00:00:00	32020		\N	240941	0	70704007	78272		0
61463	3631	40481087	1994-02-05	1994-02-05 00:00:00	1994-02-12	1994-02-12 00:00:00	32020		\N	241585	0	444814009	40481087		0
51099	3026	80180	1996-04-27	1996-04-27 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
61908	3655	4112343	1972-08-17	1972-08-17 00:00:00	1972-08-27	1972-08-27 00:00:00	32020		\N	243266	0	195662009	4112343		0
62072	3666	4112343	2013-03-27	2013-03-27 00:00:00	2013-04-08	2013-04-08 00:00:00	32020		\N	243862	0	195662009	4112343		0
62133	3668	260139	1976-09-26	1976-09-26 00:00:00	1976-10-03	1976-10-03 00:00:00	32020		\N	244014	0	10509002	260139		0
72919	4333	40481087	1994-10-16	1994-10-16 00:00:00	1994-11-06	1994-11-06 00:00:00	32020		\N	287388	0	444814009	40481087		0
62534	3694	4029498	1969-04-06	1969-04-06 00:00:00	\N	\N	32020		\N	245559	0	128613002	4029498		0
62620	3699	257012	1996-12-14	1996-12-14 00:00:00	\N	\N	32020		\N	245947	0	40055000	257012		0
62872	3714	40481087	1994-07-03	1994-07-03 00:00:00	1994-07-10	1994-07-10 00:00:00	32020		\N	246760	0	444814009	40481087		0
62935	3718	80180	2002-03-10	2002-03-10 00:00:00	\N	\N	32020		\N	247124	0	396275006	80180		0
73728	4381	4237458	1973-02-22	1973-02-22 00:00:00	1973-05-23	1973-05-23 00:00:00	32020		\N	291143	0	58150001	4237458		0
63409	3745	4230399	2018-05-16	2018-05-16 00:00:00	2018-08-14	2018-08-14 00:00:00	32020		\N	248880	0	359817006	4230399		0
63558	3754	40481087	2013-04-27	2013-04-27 00:00:00	2013-05-11	2013-05-11 00:00:00	32020		\N	249534	0	444814009	40481087		0
74242	4409	40481087	2001-06-30	2001-06-30 00:00:00	2001-07-21	2001-07-21 00:00:00	32020		\N	293124	0	444814009	40481087		0
53202	3150	4027663	1968-04-19	1968-04-19 00:00:00	\N	\N	32020		\N	209578	0	13200003	4027663		0
63934	3778	372328	1965-11-28	1965-11-28 00:00:00	1965-12-12	1965-12-12 00:00:00	32020		\N	251082	0	65363002	372328		0
53589	3176	40481087	1973-12-24	1973-12-24 00:00:00	1974-01-07	1974-01-07 00:00:00	32020		\N	211083	0	444814009	40481087		0
53686	3178	257012	1992-05-18	1992-05-18 00:00:00	\N	\N	32020		\N	211427	0	40055000	257012		0
43323	2579	4278672	1961-08-31	1961-08-31 00:00:00	1961-09-30	1961-09-30 00:00:00	32020		\N	170790	0	65966004	4278672		0
54064	3200	78272	1981-03-19	1981-03-19 00:00:00	1981-04-09	1981-04-09 00:00:00	32020		\N	212827	0	70704007	78272		0
43649	2599	40481087	2019-06-12	2019-06-12 00:00:00	\N	\N	32020		\N	171990	0	444814009	40481087		0
54349	3219	4059173	2005-11-08	2005-11-08 00:00:00	2006-02-06	2006-02-06 00:00:00	32020		\N	213931	0	16114001	4059173		0
54480	3226	78272	1980-07-05	1980-07-05 00:00:00	1980-07-26	1980-07-26 00:00:00	32020		\N	214448	0	70704007	78272		0
54688	3237	260139	1928-07-02	1928-07-02 00:00:00	1928-07-16	1928-07-16 00:00:00	32020		\N	215195	0	10509002	260139		0
54858	3248	28060	1958-09-07	1958-09-07 00:00:00	1958-09-18	1958-09-18 00:00:00	32020		\N	215844	0	43878008	28060		0
55090	3260	40481087	1980-02-26	1980-02-26 00:00:00	1980-03-11	1980-03-11 00:00:00	32020		\N	216721	0	444814009	40481087		0
65778	3889	4112343	1939-04-07	1939-04-07 00:00:00	1939-04-14	1939-04-14 00:00:00	32020		\N	258495	0	195662009	4112343		0
55362	3279	40481087	1957-01-13	1957-01-13 00:00:00	1957-02-03	1957-02-03 00:00:00	32020		\N	217881	0	444814009	40481087		0
55532	3289	4112343	1978-07-29	1978-07-29 00:00:00	1978-08-05	1978-08-05 00:00:00	32020		\N	218534	0	195662009	4112343		0
55714	3296	40481087	2014-11-27	2014-11-27 00:00:00	2014-12-04	2014-12-04 00:00:00	32020		\N	219027	0	444814009	40481087		0
55782	3301	4112343	1949-08-21	1949-08-21 00:00:00	1949-08-29	1949-08-29 00:00:00	32020		\N	219263	0	195662009	4112343		0
66598	3941	40481087	2019-01-15	2019-01-15 00:00:00	2019-01-29	2019-01-29 00:00:00	32020		\N	262062	0	444814009	40481087		0
56240	3332	4027663	1989-11-29	1989-11-29 00:00:00	\N	\N	32020		\N	221057	0	13200003	4027663		0
56384	3342	4027663	1943-06-29	1943-06-29 00:00:00	\N	\N	32020		\N	221684	0	13200003	4027663		0
56529	3353	81151	1943-10-19	1943-10-19 00:00:00	1943-11-09	1943-11-09 00:00:00	32020		\N	222425	0	44465007	81151		0
67280	3976	378001	2014-10-27	2014-10-27 00:00:00	2014-12-26	2014-12-26 00:00:00	32020		\N	264352	0	62106007	378001		0
56892	3375	40481087	1978-02-04	1978-02-04 00:00:00	1978-02-18	1978-02-18 00:00:00	32020		\N	223911	0	444814009	40481087		0
57001	3381	40481087	2008-03-24	2008-03-24 00:00:00	2008-04-07	2008-04-07 00:00:00	32020		\N	224349	0	444814009	40481087		0
57110	3389	28060	2003-03-28	2003-03-28 00:00:00	2003-04-10	2003-04-10 00:00:00	32020		\N	224779	0	43878008	28060		0
57391	3407	4116491	1985-01-19	1985-01-19 00:00:00	1985-03-01	1985-03-01 00:00:00	32020		\N	225960	0	301011002	4116491		0
57535	3413	40481087	1979-08-28	1979-08-28 00:00:00	1979-09-11	1979-09-11 00:00:00	32020		\N	226411	0	444814009	40481087		0
57711	3423	40481087	1981-12-09	1981-12-09 00:00:00	1981-12-23	1981-12-23 00:00:00	32020		\N	227033	0	444814009	40481087		0
57860	3432	372328	1955-01-22	1955-01-22 00:00:00	1955-04-15	1955-04-15 00:00:00	32020		\N	227501	0	65363002	372328		0
58009	3438	4218389	1965-10-20	1965-10-20 00:00:00	1965-11-10	1965-11-10 00:00:00	32020		\N	228135	0	39848009	4218389		0
58161	3444	381316	2018-10-29	2018-10-29 00:00:00	\N	\N	32020		\N	228576	0	230690007	381316		0
47788	2837	4112343	1978-09-01	1978-09-01 00:00:00	1978-09-08	1978-09-08 00:00:00	32020		\N	188415	0	195662009	4112343		0
58447	3462	80180	1995-03-09	1995-03-09 00:00:00	\N	\N	32020		\N	229702	0	396275006	80180		0
69270	4100	40481087	2007-08-27	2007-08-27 00:00:00	2007-09-10	2007-09-10 00:00:00	32020		\N	272414	0	444814009	40481087		0
48283	2861	260139	1999-06-29	1999-06-29 00:00:00	1999-07-13	1999-07-13 00:00:00	32020		\N	190187	0	10509002	260139		0
48440	2868	4329847	2016-02-10	2016-02-10 00:00:00	\N	\N	32020		\N	190820	0	22298006	4329847		0
69726	4125	40481087	1985-11-15	1985-11-15 00:00:00	1985-11-22	1985-11-22 00:00:00	32020		\N	274262	0	444814009	40481087		0
69969	4139	4112343	2016-04-10	2016-04-10 00:00:00	2016-04-18	2016-04-18 00:00:00	32020		\N	275136	0	195662009	4112343		0
59454	3526	4112343	1951-10-20	1951-10-20 00:00:00	1951-10-27	1951-10-27 00:00:00	32020		\N	233948	0	195662009	4112343		0
59725	3539	4112343	1999-06-07	1999-06-07 00:00:00	1999-06-20	1999-06-20 00:00:00	32020		\N	235104	0	195662009	4112343		0
59909	3549	40481087	1972-04-12	1972-04-12 00:00:00	1972-04-19	1972-04-19 00:00:00	32020		\N	235677	0	444814009	40481087		0
60061	3559	40481087	1994-01-04	1994-01-04 00:00:00	1994-01-25	1994-01-25 00:00:00	32020		\N	236293	0	444814009	40481087		0
60175	3562	81151	1990-01-01	1990-01-01 00:00:00	1990-01-29	1990-01-29 00:00:00	32020		\N	236608	0	44465007	81151		0
60345	3570	4112343	1994-06-22	1994-06-22 00:00:00	1994-07-02	1994-07-02 00:00:00	32020		\N	237277	0	195662009	4112343		0
49949	2951	260139	1963-08-23	1963-08-23 00:00:00	1963-09-06	1963-09-06 00:00:00	32020		\N	197021	0	10509002	260139		0
60685	3592	260139	1998-11-27	1998-11-27 00:00:00	1998-12-11	1998-12-11 00:00:00	32020		\N	238594	0	10509002	260139		0
60780	3598	4112343	1984-07-19	1984-07-19 00:00:00	1984-07-29	1984-07-29 00:00:00	32020		\N	238931	0	195662009	4112343		0
61049	3613	80180	2010-06-05	2010-06-05 00:00:00	\N	\N	32020		\N	240018	0	396275006	80180		0
61131	3616	4116491	2004-02-14	2004-02-14 00:00:00	2004-04-05	2004-04-05 00:00:00	32020		\N	240302	0	301011002	4116491		0
61303	3624	81151	1963-11-30	1963-11-30 00:00:00	1963-12-14	1963-12-14 00:00:00	32020		\N	240942	0	44465007	81151		0
61464	3631	4296204	1980-04-30	1980-04-30 00:00:00	1980-06-04	1980-06-04 00:00:00	32020		\N	241580	0	403190006	4296204		0
51100	3026	40481087	1999-12-05	1999-12-05 00:00:00	1999-12-19	1999-12-19 00:00:00	32020		\N	201776	0	444814009	40481087		0
61909	3655	28060	1948-11-02	1948-11-02 00:00:00	1948-11-11	1948-11-11 00:00:00	32020		\N	243292	0	43878008	28060		0
62073	3666	4112343	1989-02-08	1989-02-08 00:00:00	1989-02-16	1989-02-16 00:00:00	32020		\N	243916	0	195662009	4112343		0
62134	3668	372328	1975-09-30	1975-09-30 00:00:00	1975-12-07	1975-12-07 00:00:00	32020		\N	244008	0	65363002	372328		0
72920	4333	372328	1955-11-15	1955-11-15 00:00:00	1956-02-02	1956-02-02 00:00:00	32020		\N	287419	0	65363002	372328		0
62535	3694	4134304	1971-08-29	1971-08-29 00:00:00	1971-11-27	1971-11-27 00:00:00	32020		\N	245560	0	263102004	4134304		0
62621	3699	40481087	1988-03-26	1988-03-26 00:00:00	1988-04-16	1988-04-16 00:00:00	32020		\N	245946	0	444814009	40481087		0
62873	3714	4218389	1966-03-27	1966-03-27 00:00:00	1966-04-24	1966-04-24 00:00:00	32020		\N	246850	0	39848009	4218389		0
62936	3718	4112343	1977-02-27	1977-02-27 00:00:00	1977-03-08	1977-03-08 00:00:00	32020		\N	247107	0	195662009	4112343		0
73729	4381	372328	1967-01-01	1967-01-01 00:00:00	1967-05-09	1967-05-09 00:00:00	32020		\N	291095	0	65363002	372328		0
63410	3745	40480160	2018-05-16	2018-05-16 00:00:00	2018-08-14	2018-08-14 00:00:00	32020		\N	248880	0	443165006	40480160		0
63559	3754	4218389	1961-09-22	1961-09-22 00:00:00	1961-10-27	1961-10-27 00:00:00	32020		\N	249511	0	39848009	4218389		0
74243	4409	40481087	2017-02-07	2017-02-07 00:00:00	2017-02-28	2017-02-28 00:00:00	32020		\N	293110	0	444814009	40481087		0
53203	3150	260139	1955-12-24	1955-12-24 00:00:00	1956-01-07	1956-01-07 00:00:00	32020		\N	209606	0	10509002	260139		0
63935	3778	40481087	1972-08-31	1972-08-31 00:00:00	1972-09-14	1972-09-14 00:00:00	32020		\N	251087	0	444814009	40481087		0
53590	3176	78272	1982-04-10	1982-04-10 00:00:00	1982-04-24	1982-04-24 00:00:00	32020		\N	211122	0	70704007	78272		0
53687	3178	4112343	1961-12-28	1961-12-28 00:00:00	1962-01-04	1962-01-04 00:00:00	32020		\N	211404	0	195662009	4112343		0
43324	2579	40481087	1972-07-18	1972-07-18 00:00:00	1972-08-01	1972-08-01 00:00:00	32020		\N	170770	0	444814009	40481087		0
54065	3200	40481087	2015-07-19	2015-07-19 00:00:00	2015-08-09	2015-08-09 00:00:00	32020		\N	212853	0	444814009	40481087		0
43650	2599	4109685	1979-12-19	1979-12-19 00:00:00	1980-01-02	1980-01-02 00:00:00	32020		\N	171955	0	284551006	4109685		0
54351	3219	4112343	2014-10-16	2014-10-16 00:00:00	2014-10-27	2014-10-27 00:00:00	32020		\N	213913	0	195662009	4112343		0
54481	3226	40481087	1995-11-10	1995-11-10 00:00:00	1995-11-24	1995-11-24 00:00:00	32020		\N	214457	0	444814009	40481087		0
54689	3237	78272	1959-01-16	1959-01-16 00:00:00	1959-01-30	1959-01-30 00:00:00	32020		\N	215151	0	70704007	78272		0
54859	3248	4112343	2017-03-08	2017-03-08 00:00:00	2017-03-15	2017-03-15 00:00:00	32020		\N	215929	0	195662009	4112343		0
55091	3260	40481087	2000-03-26	2000-03-26 00:00:00	2000-04-16	2000-04-16 00:00:00	32020		\N	216722	0	444814009	40481087		0
65779	3889	40481087	1940-07-05	1940-07-05 00:00:00	1940-07-26	1940-07-26 00:00:00	32020		\N	258451	0	444814009	40481087		0
55363	3279	4059173	1974-08-14	1974-08-14 00:00:00	1974-10-13	1974-10-13 00:00:00	32020		\N	217920	0	16114001	4059173		0
55533	3289	4027663	1983-12-16	1983-12-16 00:00:00	\N	\N	32020		\N	218453	0	13200003	4027663		0
55715	3296	40481087	1994-06-23	1994-06-23 00:00:00	1994-07-14	1994-07-14 00:00:00	32020		\N	219100	0	444814009	40481087		0
55783	3301	4027663	1963-03-30	1963-03-30 00:00:00	\N	\N	32020		\N	219313	0	13200003	4027663		0
66599	3941	40481087	1982-01-20	1982-01-20 00:00:00	1982-01-27	1982-01-27 00:00:00	32020		\N	261999	0	444814009	40481087		0
56241	3332	4116491	1979-12-02	1979-12-02 00:00:00	1980-01-07	1980-01-07 00:00:00	32020		\N	221100	0	301011002	4116491		0
56385	3342	40481087	1982-04-23	1982-04-23 00:00:00	1982-05-14	1982-05-14 00:00:00	32020		\N	221634	0	444814009	40481087		0
56530	3353	4112343	2012-07-03	2012-07-03 00:00:00	2012-07-12	2012-07-12 00:00:00	32020		\N	222392	0	195662009	4112343		0
67281	3976	28060	1989-09-03	1989-09-03 00:00:00	1989-09-13	1989-09-13 00:00:00	32020		\N	264344	0	43878008	28060		0
56893	3375	260139	2014-11-23	2014-11-23 00:00:00	2014-12-07	2014-12-07 00:00:00	32020		\N	223873	0	10509002	260139		0
57002	3381	78272	1988-01-11	1988-01-11 00:00:00	1988-01-25	1988-01-25 00:00:00	32020		\N	224397	0	70704007	78272		0
57111	3389	40481087	1991-06-15	1991-06-15 00:00:00	1991-06-29	1991-06-29 00:00:00	32020		\N	224763	0	444814009	40481087		0
57392	3407	30753	2004-11-05	2004-11-05 00:00:00	\N	\N	32020		\N	225966	0	16761005	30753		0
57536	3413	78272	2017-02-28	2017-02-28 00:00:00	2017-03-14	2017-03-14 00:00:00	32020		\N	226404	0	70704007	78272		0
57712	3423	4112343	1992-10-27	1992-10-27 00:00:00	1992-11-05	1992-11-05 00:00:00	32020		\N	227035	0	195662009	4112343		0
57861	3432	260139	1989-09-30	1989-09-30 00:00:00	1989-10-07	1989-10-07 00:00:00	32020		\N	227523	0	10509002	260139		0
58010	3438	4142905	1924-06-27	1924-06-27 00:00:00	1924-08-26	1924-08-26 00:00:00	32020		\N	228133	0	33737001	4142905		0
58162	3444	40481087	2012-08-17	2012-08-17 00:00:00	2012-09-07	2012-09-07 00:00:00	32020		\N	228588	0	444814009	40481087		0
47789	2837	80180	2008-01-10	2008-01-10 00:00:00	\N	\N	32020		\N	188471	0	396275006	80180		0
58448	3462	4112343	1987-08-16	1987-08-16 00:00:00	1987-08-27	1987-08-27 00:00:00	32020		\N	229741	0	195662009	4112343		0
69271	4100	78272	1957-08-23	1957-08-23 00:00:00	1957-09-20	1957-09-20 00:00:00	32020		\N	272467	0	70704007	78272		0
48284	2861	81151	2005-03-20	2005-03-20 00:00:00	2005-04-03	2005-04-03 00:00:00	32020		\N	190245	0	44465007	81151		0
48442	2868	40481087	1987-08-11	1987-08-11 00:00:00	1987-08-25	1987-08-25 00:00:00	32020		\N	190798	0	444814009	40481087		0
69727	4125	260139	2017-11-03	2017-11-03 00:00:00	2017-11-10	2017-11-10 00:00:00	32020		\N	274219	0	10509002	260139		0
69994	4142	260139	2000-07-05	2000-07-05 00:00:00	2000-07-12	2000-07-12 00:00:00	32020		\N	275337	0	10509002	260139		0
59455	3526	4112343	2009-04-12	2009-04-12 00:00:00	2009-04-22	2009-04-22 00:00:00	32020		\N	233995	0	195662009	4112343		0
59726	3539	372328	1983-12-27	1983-12-27 00:00:00	1984-05-18	1984-05-18 00:00:00	32020		\N	235106	0	65363002	372328		0
59910	3550	4112343	2018-05-14	2018-05-14 00:00:00	2018-05-22	2018-05-22 00:00:00	32020		\N	235740	0	195662009	4112343		0
60062	3559	4278672	1953-06-20	1953-06-20 00:00:00	1953-07-20	1953-07-20 00:00:00	32020		\N	236257	0	65966004	4278672		0
60176	3562	80180	2014-03-28	2014-03-28 00:00:00	\N	\N	32020		\N	236613	0	396275006	80180		0
60346	3570	4283893	1956-07-03	1956-07-03 00:00:00	1956-08-14	1956-08-14 00:00:00	32020		\N	237265	0	36971009	4283893		0
49950	2951	40481087	1959-11-17	1959-11-17 00:00:00	1959-12-01	1959-12-01 00:00:00	32020		\N	197020	0	444814009	40481087		0
60686	3592	40481087	1995-06-13	1995-06-13 00:00:00	1995-06-27	1995-06-27 00:00:00	32020		\N	238593	0	444814009	40481087		0
60781	3598	4059173	1985-02-19	1985-02-19 00:00:00	1985-04-20	1985-04-20 00:00:00	32020		\N	238944	0	16114001	4059173		0
61050	3613	4266809	2010-06-05	2010-06-05 00:00:00	\N	\N	32020		\N	240018	0	397881000	4266809		0
61132	3616	4112343	1998-10-19	1998-10-19 00:00:00	1998-10-27	1998-10-27 00:00:00	32020		\N	240314	0	195662009	4112343		0
61304	3624	4112343	1961-01-19	1961-01-19 00:00:00	1961-02-01	1961-02-01 00:00:00	32020		\N	240992	0	195662009	4112343		0
61465	3631	40481087	1993-04-20	1993-04-20 00:00:00	1993-05-04	1993-05-04 00:00:00	32020		\N	241595	0	444814009	40481087		0
51101	3026	372328	1958-07-06	1958-07-06 00:00:00	1958-11-30	1958-11-30 00:00:00	32020		\N	201779	0	65363002	372328		0
61910	3655	260139	1940-10-04	1940-10-04 00:00:00	1940-10-18	1940-10-18 00:00:00	32020		\N	243248	0	10509002	260139		0
62074	3666	372328	1962-09-16	1962-09-16 00:00:00	1962-12-06	1962-12-06 00:00:00	32020		\N	243863	0	65363002	372328		0
62173	3672	28060	1967-09-26	1967-09-26 00:00:00	1967-10-07	1967-10-07 00:00:00	32020		\N	244285	0	43878008	28060		0
72921	4333	40481087	2018-11-25	2018-11-25 00:00:00	2018-12-09	2018-12-09 00:00:00	32020		\N	287359	0	444814009	40481087		0
62536	3694	440086	1965-04-07	1965-04-07 00:00:00	1966-02-09	1966-02-09 00:00:00	32020		\N	245510	0	192127007	440086		0
62622	3699	40481087	1991-08-05	1991-08-05 00:00:00	1991-08-26	1991-08-26 00:00:00	32020		\N	245897	0	444814009	40481087		0
62874	3714	381316	2005-09-21	2005-09-21 00:00:00	\N	\N	32020		\N	246840	0	230690007	381316		0
62937	3718	378001	2017-05-07	2017-05-07 00:00:00	2017-07-06	2017-07-06 00:00:00	32020		\N	247136	0	62106007	378001		0
73730	4381	4112343	1993-05-26	1993-05-26 00:00:00	1993-06-07	1993-06-07 00:00:00	32020		\N	291113	0	195662009	4112343		0
63411	3745	40481087	1969-07-04	1969-07-04 00:00:00	1969-07-25	1969-07-25 00:00:00	32020		\N	248918	0	444814009	40481087		0
63560	3754	40481087	1967-02-24	1967-02-24 00:00:00	1967-03-03	1967-03-03 00:00:00	32020		\N	249422	0	444814009	40481087		0
74244	4409	260139	2016-09-29	2016-09-29 00:00:00	2016-10-13	2016-10-13 00:00:00	32020		\N	293109	0	10509002	260139		0
53204	3150	81893	1974-03-14	1974-03-14 00:00:00	\N	\N	32020		\N	209622	0	64766004	81893		0
63936	3778	4112343	1988-06-03	1988-06-03 00:00:00	1988-06-11	1988-06-11 00:00:00	32020		\N	251088	0	195662009	4112343		0
53591	3176	80180	2007-10-11	2007-10-11 00:00:00	\N	\N	32020		\N	211119	0	396275006	80180		0
53688	3178	260139	1972-04-22	1972-04-22 00:00:00	1972-05-06	1972-05-06 00:00:00	32020		\N	211370	0	10509002	260139		0
43325	2580	4112343	2000-08-04	2000-08-04 00:00:00	2000-08-13	2000-08-13 00:00:00	32020		\N	170909	0	195662009	4112343		0
54066	3200	40481087	1986-12-20	1986-12-20 00:00:00	1987-01-10	1987-01-10 00:00:00	32020		\N	212873	0	444814009	40481087		0
43651	2599	4059173	1983-01-07	1983-01-07 00:00:00	1983-02-06	1983-02-06 00:00:00	32020		\N	171957	0	16114001	4059173		0
54352	3219	260139	2018-12-11	2018-12-11 00:00:00	2018-12-18	2018-12-18 00:00:00	32020		\N	213894	0	10509002	260139		0
54482	3226	257012	1997-07-10	1997-07-10 00:00:00	\N	\N	32020		\N	214487	0	40055000	257012		0
54690	3237	4112343	1971-10-13	1971-10-13 00:00:00	1971-10-22	1971-10-22 00:00:00	32020		\N	215223	0	195662009	4112343		0
54860	3248	80180	1983-04-20	1983-04-20 00:00:00	\N	\N	32020		\N	215869	0	396275006	80180		0
55092	3260	4112343	2003-03-31	2003-03-31 00:00:00	2003-04-08	2003-04-08 00:00:00	32020		\N	216708	0	195662009	4112343		0
65780	3889	4112343	1998-11-18	1998-11-18 00:00:00	1998-12-01	1998-12-01 00:00:00	32020		\N	258455	0	195662009	4112343		0
55364	3279	260139	2010-07-28	2010-07-28 00:00:00	2010-08-04	2010-08-04 00:00:00	32020		\N	217924	0	10509002	260139		0
55534	3289	372328	1960-10-18	1960-10-18 00:00:00	1960-12-02	1960-12-02 00:00:00	32020		\N	218463	0	65363002	372328		0
55716	3296	4112343	1948-08-21	1948-08-21 00:00:00	1948-09-01	1948-09-01 00:00:00	32020		\N	218985	0	195662009	4112343		0
55784	3301	40481087	2008-07-12	2008-07-12 00:00:00	2008-08-02	2008-08-02 00:00:00	32020		\N	219284	0	444814009	40481087		0
66600	3941	195588	1992-01-15	1992-01-15 00:00:00	1992-02-17	1992-02-17 00:00:00	32020		\N	262039	0	38822007	195588		0
56242	3332	40481087	1968-04-18	1968-04-18 00:00:00	1968-05-09	1968-05-09 00:00:00	32020		\N	221097	0	444814009	40481087		0
56386	3342	257012	2002-12-14	2002-12-14 00:00:00	\N	\N	32020		\N	221612	0	40055000	257012		0
56531	3353	4112343	2005-07-29	2005-07-29 00:00:00	2005-08-08	2005-08-08 00:00:00	32020		\N	222420	0	195662009	4112343		0
67282	3976	40481087	1976-09-21	1976-09-21 00:00:00	1976-09-28	1976-09-28 00:00:00	32020		\N	264343	0	444814009	40481087		0
56894	3376	40481087	1990-01-29	1990-01-29 00:00:00	1990-02-05	1990-02-05 00:00:00	32020		\N	223957	0	444814009	40481087		0
57003	3381	372328	1972-05-04	1972-05-04 00:00:00	1972-08-14	1972-08-14 00:00:00	32020		\N	224351	0	65363002	372328		0
57112	3389	260139	2005-02-04	2005-02-04 00:00:00	2005-02-18	2005-02-18 00:00:00	32020		\N	224789	0	10509002	260139		0
57393	3407	4266809	2005-08-02	2005-08-02 00:00:00	\N	\N	32020		\N	225966	0	397881000	4266809		0
57537	3413	4112343	1988-05-28	1988-05-28 00:00:00	1988-06-06	1988-06-06 00:00:00	32020		\N	226380	0	195662009	4112343		0
57713	3423	40481087	1994-03-22	1994-03-22 00:00:00	1994-04-05	1994-04-05 00:00:00	32020		\N	227036	0	444814009	40481087		0
57862	3432	4112343	2012-09-13	2012-09-13 00:00:00	2012-09-24	2012-09-24 00:00:00	32020		\N	227564	0	195662009	4112343		0
58011	3438	260139	1918-03-02	1918-03-02 00:00:00	1918-03-16	1918-03-16 00:00:00	32020		\N	228094	0	10509002	260139		0
58163	3444	28060	1989-09-28	1989-09-28 00:00:00	1989-10-05	1989-10-05 00:00:00	32020		\N	228567	0	43878008	28060		0
47790	2837	260139	1992-04-19	1992-04-19 00:00:00	1992-05-03	1992-05-03 00:00:00	32020		\N	188437	0	10509002	260139		0
58449	3462	40481087	2019-06-16	2019-06-16 00:00:00	2019-06-23	2019-06-23 00:00:00	32020		\N	229758	0	444814009	40481087		0
69272	4101	40481087	1992-07-09	1992-07-09 00:00:00	1992-07-16	1992-07-16 00:00:00	32020		\N	272475	0	444814009	40481087		0
48285	2861	4112343	1970-04-28	1970-04-28 00:00:00	1970-05-11	1970-05-11 00:00:00	32020		\N	190227	0	195662009	4112343		0
48443	2869	40481087	1961-04-06	1961-04-06 00:00:00	1961-04-13	1961-04-13 00:00:00	32020		\N	190833	0	444814009	40481087		0
69728	4125	372328	1971-06-30	1971-06-30 00:00:00	1971-08-24	1971-08-24 00:00:00	32020		\N	274248	0	65363002	372328		0
69995	4142	40481087	2001-11-29	2001-11-29 00:00:00	2001-12-13	2001-12-13 00:00:00	32020		\N	275306	0	444814009	40481087		0
59456	3526	372328	1951-05-21	1951-05-21 00:00:00	1951-06-04	1951-06-04 00:00:00	32020		\N	233947	0	65363002	372328		0
59727	3539	260139	1998-08-02	1998-08-02 00:00:00	1998-08-16	1998-08-16 00:00:00	32020		\N	235099	0	10509002	260139		0
59911	3550	40481087	2013-02-04	2013-02-04 00:00:00	2013-02-18	2013-02-18 00:00:00	32020		\N	235739	0	444814009	40481087		0
60063	3559	40481087	2011-07-24	2011-07-24 00:00:00	2011-07-31	2011-07-31 00:00:00	32020		\N	236296	0	444814009	40481087		0
60177	3562	4310024	2012-07-06	2012-07-06 00:00:00	\N	\N	32020		\N	236583	0	424802006	4310024		0
60347	3570	28060	1968-03-09	1968-03-09 00:00:00	1968-03-21	1968-03-21 00:00:00	32020		\N	237288	0	43878008	28060		0
49951	2951	260139	1968-10-24	1968-10-24 00:00:00	1968-10-31	1968-10-31 00:00:00	32020		\N	197031	0	10509002	260139		0
60687	3592	40481087	1965-10-30	1965-10-30 00:00:00	1965-11-06	1965-11-06 00:00:00	32020		\N	238630	0	444814009	40481087		0
60782	3598	378001	1958-03-13	1958-03-13 00:00:00	1958-04-12	1958-04-12 00:00:00	32020		\N	238943	0	62106007	378001		0
61051	3613	81893	2008-09-13	2008-09-13 00:00:00	\N	\N	32020		\N	240059	0	64766004	81893		0
61133	3616	4294548	1961-09-08	1961-09-08 00:00:00	1961-12-08	1961-12-08 00:00:00	32020		\N	240312	0	75498004	4294548		0
61305	3624	4112343	1963-11-21	1963-11-21 00:00:00	1963-11-28	1963-11-28 00:00:00	32020		\N	240963	0	195662009	4112343		0
61466	3631	4112343	1977-12-15	1977-12-15 00:00:00	1977-12-26	1977-12-26 00:00:00	32020		\N	241593	0	195662009	4112343		0
51102	3026	40481087	1972-12-19	1972-12-19 00:00:00	1973-01-02	1973-01-02 00:00:00	32020		\N	201758	0	444814009	40481087		0
61911	3655	40481087	1972-01-20	1972-01-20 00:00:00	1972-01-27	1972-01-27 00:00:00	32020		\N	243264	0	444814009	40481087		0
62075	3666	4146173	1997-10-24	1997-10-24 00:00:00	1997-12-23	1997-12-23 00:00:00	32020		\N	243884	0	307731004	4146173		0
62174	3672	260139	1986-02-07	1986-02-07 00:00:00	1986-02-21	1986-02-21 00:00:00	32020		\N	244289	0	10509002	260139		0
72922	4333	40481087	2012-04-15	2012-04-15 00:00:00	2012-04-22	2012-04-22 00:00:00	32020		\N	287389	0	444814009	40481087		0
62537	3695	372328	1985-05-29	1985-05-29 00:00:00	1986-01-20	1986-01-20 00:00:00	32020		\N	245613	0	65363002	372328		0
62623	3699	4294548	1996-11-02	1996-11-02 00:00:00	1996-12-21	1996-12-21 00:00:00	32020		\N	245926	0	75498004	4294548		0
62875	3714	257012	1936-04-10	1936-04-10 00:00:00	\N	\N	32020		\N	246789	0	40055000	257012		0
62938	3718	4043241	2016-10-31	2016-10-31 00:00:00	\N	\N	32020		\N	247148	0	230265002	4043241		0
73731	4381	40479422	1965-04-28	1965-04-28 00:00:00	1965-06-04	1965-06-04 00:00:00	32020		\N	291142	0	444448004	40479422		0
63412	3745	78272	2013-04-07	2013-04-07 00:00:00	2013-05-12	2013-05-12 00:00:00	32020		\N	248879	0	70704007	78272		0
63561	3754	40481087	1995-12-31	1995-12-31 00:00:00	1996-01-14	1996-01-14 00:00:00	32020		\N	249462	0	444814009	40481087		0
74245	4409	4112343	1975-08-08	1975-08-08 00:00:00	1975-08-21	1975-08-21 00:00:00	32020		\N	293118	0	195662009	4112343		0
53205	3150	30753	1974-11-09	1974-11-09 00:00:00	\N	\N	32020		\N	209622	0	16761005	30753		0
63937	3778	4310024	1997-12-25	1997-12-25 00:00:00	\N	\N	32020		\N	251089	0	424802006	4310024		0
53592	3176	40481087	1999-06-11	1999-06-11 00:00:00	1999-06-25	1999-06-25 00:00:00	32020		\N	211200	0	444814009	40481087		0
53689	3178	4112343	1977-02-18	1977-02-18 00:00:00	1977-02-27	1977-02-27 00:00:00	32020		\N	211419	0	195662009	4112343		0
43326	2580	4112343	1962-08-04	1962-08-04 00:00:00	1962-08-13	1962-08-13 00:00:00	32020		\N	170929	0	195662009	4112343		0
54067	3200	28060	1951-02-12	1951-02-12 00:00:00	1951-02-21	1951-02-21 00:00:00	32020		\N	212830	0	43878008	28060		0
43652	2599	78272	1986-08-19	1986-08-19 00:00:00	1986-09-16	1986-09-16 00:00:00	32020		\N	171959	0	70704007	78272		0
54353	3219	260139	1985-05-24	1985-05-24 00:00:00	1985-05-31	1985-05-31 00:00:00	32020		\N	213908	0	10509002	260139		0
54483	3226	4112343	1969-10-02	1969-10-02 00:00:00	1969-10-13	1969-10-13 00:00:00	32020		\N	214438	0	195662009	4112343		0
54691	3237	4112343	1985-09-10	1985-09-10 00:00:00	1985-09-21	1985-09-21 00:00:00	32020		\N	215198	0	195662009	4112343		0
54861	3248	313217	2007-03-30	2007-03-30 00:00:00	\N	\N	32020		\N	215888	0	49436004	313217		0
55093	3260	4294548	2016-10-05	2016-10-05 00:00:00	2016-11-16	2016-11-16 00:00:00	32020		\N	216757	0	75498004	4294548		0
65781	3889	260139	2004-03-09	2004-03-09 00:00:00	2004-03-16	2004-03-16 00:00:00	32020		\N	258456	0	10509002	260139		0
55365	3279	372328	1955-07-25	1955-07-25 00:00:00	1955-09-06	1955-09-06 00:00:00	32020		\N	217888	0	65363002	372328		0
55535	3289	372328	1958-10-27	1958-10-27 00:00:00	1958-11-28	1958-11-28 00:00:00	32020		\N	218508	0	65363002	372328		0
55717	3296	378419	2018-08-17	2018-08-17 00:00:00	\N	\N	32020		\N	219050	0	26929004	378419		0
55785	3301	4112343	1954-02-07	1954-02-07 00:00:00	1954-02-14	1954-02-14 00:00:00	32020		\N	219305	0	195662009	4112343		0
66601	3941	192671	1999-08-10	1999-08-10 00:00:00	\N	\N	32020		\N	262038	0	K92.2	35208414		0
56243	3332	4112343	2002-04-09	2002-04-09 00:00:00	2002-04-20	2002-04-20 00:00:00	32020		\N	221074	0	195662009	4112343		0
56387	3342	4134304	1981-07-20	1981-07-20 00:00:00	1981-09-18	1981-09-18 00:00:00	32020		\N	221568	0	263102004	4134304		0
56532	3353	81151	1983-01-18	1983-01-18 00:00:00	1983-02-22	1983-02-22 00:00:00	32020		\N	222449	0	44465007	81151		0
67283	3976	260139	2018-04-15	2018-04-15 00:00:00	2018-04-22	2018-04-22 00:00:00	32020		\N	264399	0	10509002	260139		0
56895	3376	78272	1982-10-21	1982-10-21 00:00:00	1982-11-11	1982-11-11 00:00:00	32020		\N	224002	0	70704007	78272		0
57004	3382	372328	1963-02-10	1963-02-10 00:00:00	1963-04-25	1963-04-25 00:00:00	32020		\N	224440	0	65363002	372328		0
57113	3389	4283893	2001-04-15	2001-04-15 00:00:00	2001-05-27	2001-05-27 00:00:00	32020		\N	224746	0	36971009	4283893		0
57394	3407	4285898	2005-01-04	2005-01-04 00:00:00	\N	\N	32020		\N	225966	0	68496003	4285898		0
57538	3413	4237458	2007-04-22	2007-04-22 00:00:00	2007-05-22	2007-05-22 00:00:00	32020		\N	226403	0	58150001	4237458		0
57714	3423	40481087	2016-11-27	2016-11-27 00:00:00	2016-12-11	2016-12-11 00:00:00	32020		\N	227065	0	444814009	40481087		0
57863	3432	4283893	1952-05-15	1952-05-15 00:00:00	1952-09-11	1952-09-11 00:00:00	32020		\N	227524	0	36971009	4283893		0
58012	3438	80180	1946-12-29	1946-12-29 00:00:00	\N	\N	32020		\N	228122	0	396275006	80180		0
58164	3444	260139	1978-06-04	1978-06-04 00:00:00	1978-06-11	1978-06-11 00:00:00	32020		\N	228537	0	10509002	260139		0
47791	2837	440448	1996-07-28	1996-07-28 00:00:00	\N	\N	32020		\N	188459	0	74400008	440448		0
58450	3462	40481087	2002-01-02	2002-01-02 00:00:00	2002-01-23	2002-01-23 00:00:00	32020		\N	229687	0	444814009	40481087		0
69273	4101	30753	1998-12-09	1998-12-09 00:00:00	\N	\N	32020		\N	272488	0	16761005	30753		0
48286	2861	4283893	1968-06-07	1968-06-07 00:00:00	1968-07-12	1968-07-12 00:00:00	32020		\N	190205	0	36971009	4283893		0
48444	2869	40481087	1980-05-29	1980-05-29 00:00:00	1980-06-12	1980-06-12 00:00:00	32020		\N	190862	0	444814009	40481087		0
69729	4125	40481087	2012-08-05	2012-08-05 00:00:00	2012-08-26	2012-08-26 00:00:00	32020		\N	274247	0	444814009	40481087		0
69996	4142	40481087	2014-06-18	2014-06-18 00:00:00	2014-07-02	2014-07-02 00:00:00	32020		\N	275327	0	444814009	40481087		0
59457	3526	40481087	1962-01-31	1962-01-31 00:00:00	1962-02-07	1962-02-07 00:00:00	32020		\N	233950	0	444814009	40481087		0
59728	3539	260139	2000-10-14	2000-10-14 00:00:00	2000-10-28	2000-10-28 00:00:00	32020		\N	235105	0	10509002	260139		0
59912	3550	28060	2019-05-20	2019-05-20 00:00:00	2019-05-29	2019-05-29 00:00:00	32020		\N	235729	0	43878008	28060		0
60064	3559	4109685	1951-06-17	1951-06-17 00:00:00	1951-07-01	1951-07-01 00:00:00	32020		\N	236256	0	284551006	4109685		0
60178	3562	4218389	1983-10-30	1983-10-30 00:00:00	1983-12-04	1983-12-04 00:00:00	32020		\N	236607	0	39848009	4218389		0
60348	3570	40481087	1978-02-16	1978-02-16 00:00:00	1978-03-09	1978-03-09 00:00:00	32020		\N	237289	0	444814009	40481087		0
49952	2951	260139	1965-03-06	1965-03-06 00:00:00	1965-03-13	1965-03-13 00:00:00	32020		\N	197058	0	10509002	260139		0
60688	3592	40481087	1984-05-04	1984-05-04 00:00:00	1984-05-25	1984-05-25 00:00:00	32020		\N	238631	0	444814009	40481087		0
60783	3598	4218389	2006-01-30	2006-01-30 00:00:00	2006-03-06	2006-03-06 00:00:00	32020		\N	238945	0	39848009	4218389		0
61052	3613	372328	1981-01-15	1981-01-15 00:00:00	1982-01-10	1982-01-10 00:00:00	32020		\N	240043	0	65363002	372328		0
61134	3616	40481087	1979-11-10	1979-11-10 00:00:00	1979-12-01	1979-12-01 00:00:00	32020		\N	240299	0	444814009	40481087		0
61306	3624	378001	1969-07-15	1969-07-15 00:00:00	1969-08-14	1969-08-14 00:00:00	32020		\N	240943	0	62106007	378001		0
61467	3631	260139	2015-03-22	2015-03-22 00:00:00	2015-03-29	2015-03-29 00:00:00	32020		\N	241607	0	10509002	260139		0
51103	3026	260139	2010-03-28	2010-03-28 00:00:00	2010-04-04	2010-04-04 00:00:00	32020		\N	201771	0	10509002	260139		0
61912	3655	40481087	1983-11-13	1983-11-13 00:00:00	1983-11-27	1983-11-27 00:00:00	32020		\N	243268	0	444814009	40481087		0
62076	3666	4112343	1966-07-30	1966-07-30 00:00:00	1966-08-12	1966-08-12 00:00:00	32020		\N	243911	0	195662009	4112343		0
62175	3672	372328	1965-06-05	1965-06-05 00:00:00	1965-08-23	1965-08-23 00:00:00	32020		\N	244330	0	65363002	372328		0
72923	4333	40481087	2002-01-19	2002-01-19 00:00:00	2002-02-02	2002-02-02 00:00:00	32020		\N	287428	0	444814009	40481087		0
62538	3695	81151	2010-04-09	2010-04-09 00:00:00	2010-05-14	2010-05-14 00:00:00	32020		\N	245566	0	44465007	81151		0
62624	3699	4310024	2011-04-01	2011-04-01 00:00:00	\N	\N	32020		\N	245911	0	424802006	4310024		0
62876	3714	4112343	1997-09-15	1997-09-15 00:00:00	1997-09-26	1997-09-26 00:00:00	32020		\N	246793	0	195662009	4112343		0
62939	3718	4027663	1991-10-19	1991-10-19 00:00:00	\N	\N	32020		\N	247086	0	13200003	4027663		0
73732	4381	40481087	2013-08-01	2013-08-01 00:00:00	2013-08-15	2013-08-15 00:00:00	32020		\N	291075	0	444814009	40481087		0
73871	4388	260139	1981-06-03	1981-06-03 00:00:00	1981-06-10	1981-06-10 00:00:00	32020		\N	291736	0	10509002	260139		0
63562	3754	80180	2005-03-10	2005-03-10 00:00:00	\N	\N	32020		\N	249551	0	396275006	80180		0
74246	4409	28060	1968-11-13	1968-11-13 00:00:00	1968-11-23	1968-11-23 00:00:00	32020		\N	293081	0	43878008	28060		0
53206	3150	4285898	1975-01-08	1975-01-08 00:00:00	\N	\N	32020		\N	209622	0	68496003	4285898		0
63938	3778	4112343	1997-03-10	1997-03-10 00:00:00	1997-03-21	1997-03-21 00:00:00	32020		\N	251089	0	195662009	4112343		0
53593	3176	40481087	2018-10-07	2018-10-07 00:00:00	2018-10-14	2018-10-14 00:00:00	32020		\N	211221	0	444814009	40481087		0
53690	3178	30753	1993-02-05	1993-02-05 00:00:00	\N	\N	32020		\N	211452	0	16761005	30753		0
53801	3183	4278672	2017-05-30	2017-05-30 00:00:00	2017-06-29	2017-06-29 00:00:00	32020		\N	211919	0	65966004	4278672		0
54068	3201	4218389	1981-02-27	1981-02-27 00:00:00	1981-03-27	1981-03-27 00:00:00	32020		\N	212919	0	39848009	4218389		0
43653	2599	260139	1981-09-10	1981-09-10 00:00:00	1981-09-24	1981-09-24 00:00:00	32020		\N	171946	0	10509002	260139		0
54354	3219	40481087	2011-08-24	2011-08-24 00:00:00	2011-09-07	2011-09-07 00:00:00	32020		\N	213919	0	444814009	40481087		0
54484	3226	4218389	1995-03-01	1995-03-01 00:00:00	1995-04-05	1995-04-05 00:00:00	32020		\N	214450	0	39848009	4218389		0
54692	3237	40481087	1931-06-24	1931-06-24 00:00:00	1931-07-01	1931-07-01 00:00:00	32020		\N	215230	0	444814009	40481087		0
54862	3248	4109685	1968-09-29	1968-09-29 00:00:00	1968-10-13	1968-10-13 00:00:00	32020		\N	215879	0	284551006	4109685		0
55094	3260	260139	1998-02-07	1998-02-07 00:00:00	1998-02-21	1998-02-21 00:00:00	32020		\N	216755	0	10509002	260139		0
65782	3889	260139	1964-02-23	1964-02-23 00:00:00	1964-03-08	1964-03-08 00:00:00	32020		\N	258477	0	10509002	260139		0
55366	3279	40481087	1959-01-31	1959-01-31 00:00:00	1959-02-21	1959-02-21 00:00:00	32020		\N	217882	0	444814009	40481087		0
55536	3289	40481087	2017-09-27	2017-09-27 00:00:00	2017-10-18	2017-10-18 00:00:00	32020		\N	218462	0	444814009	40481087		0
55718	3296	40481087	1964-12-13	1964-12-13 00:00:00	1964-12-27	1964-12-27 00:00:00	32020		\N	219087	0	444814009	40481087		0
55786	3301	4109685	2016-12-30	2016-12-30 00:00:00	2017-01-13	2017-01-13 00:00:00	32020		\N	219288	0	284551006	4109685		0
66602	3941	40481087	2016-03-03	2016-03-03 00:00:00	2016-03-24	2016-03-24 00:00:00	32020		\N	262044	0	444814009	40481087		0
56244	3334	40481087	1976-04-19	1976-04-19 00:00:00	1976-04-26	1976-04-26 00:00:00	32020		\N	221162	0	444814009	40481087		0
56388	3342	4266809	1950-04-18	1950-04-18 00:00:00	\N	\N	32020		\N	221685	0	397881000	4266809		0
56533	3353	4112343	1983-01-04	1983-01-04 00:00:00	1983-01-12	1983-01-12 00:00:00	32020		\N	222357	0	195662009	4112343		0
67284	3976	4059173	1969-01-16	1969-01-16 00:00:00	1969-02-15	1969-02-15 00:00:00	32020		\N	264348	0	16114001	4059173		0
56896	3376	260139	1979-10-20	1979-10-20 00:00:00	1979-10-27	1979-10-27 00:00:00	32020		\N	223955	0	10509002	260139		0
57005	3382	4112343	1967-06-20	1967-06-20 00:00:00	1967-07-02	1967-07-02 00:00:00	32020		\N	224462	0	195662009	4112343		0
57114	3389	40481087	2007-04-01	2007-04-01 00:00:00	2007-04-22	2007-04-22 00:00:00	32020		\N	224781	0	444814009	40481087		0
57395	3407	80180	2005-08-02	2005-08-02 00:00:00	\N	\N	32020		\N	225966	0	396275006	80180		0
57539	3413	40481087	2014-09-15	2014-09-15 00:00:00	2014-10-06	2014-10-06 00:00:00	32020		\N	226423	0	444814009	40481087		0
57715	3423	40481087	2007-09-25	2007-09-25 00:00:00	2007-10-02	2007-10-02 00:00:00	32020		\N	227043	0	444814009	40481087		0
57864	3432	40481087	1955-12-17	1955-12-17 00:00:00	1955-12-24	1955-12-24 00:00:00	32020		\N	227526	0	444814009	40481087		0
58013	3438	4146173	1942-07-23	1942-07-23 00:00:00	1942-09-21	1942-09-21 00:00:00	32020		\N	228110	0	307731004	4146173		0
58165	3444	4112343	1979-02-02	1979-02-02 00:00:00	1979-02-10	1979-02-10 00:00:00	32020		\N	228523	0	195662009	4112343		0
47792	2837	4112343	1991-06-04	1991-06-04 00:00:00	1991-06-17	1991-06-17 00:00:00	32020		\N	188417	0	195662009	4112343		0
58451	3462	372328	1969-12-05	1969-12-05 00:00:00	1970-10-02	1970-10-02 00:00:00	32020		\N	229716	0	65363002	372328		0
69274	4101	80180	1999-06-07	1999-06-07 00:00:00	\N	\N	32020		\N	272488	0	396275006	80180		0
48287	2861	4294548	1976-01-02	1976-01-02 00:00:00	1976-04-30	1976-04-30 00:00:00	32020		\N	190223	0	75498004	4294548		0
48445	2869	260139	1968-11-20	1968-11-20 00:00:00	1968-11-27	1968-11-27 00:00:00	32020		\N	190888	0	10509002	260139		0
69730	4125	4109685	1987-11-17	1987-11-17 00:00:00	1987-12-08	1987-12-08 00:00:00	32020		\N	274213	0	284551006	4109685		0
69997	4142	4113008	2015-10-19	2015-10-19 00:00:00	2015-11-09	2015-11-09 00:00:00	32020		\N	275293	0	284549007	4113008		0
59458	3527	4112343	1978-03-26	1978-03-26 00:00:00	1978-04-03	1978-04-03 00:00:00	32020		\N	234052	0	195662009	4112343		0
59729	3539	4294548	1998-12-05	1998-12-05 00:00:00	1998-12-26	1998-12-26 00:00:00	32020		\N	235100	0	75498004	4294548		0
59913	3550	81151	1994-10-11	1994-10-11 00:00:00	1994-11-08	1994-11-08 00:00:00	32020		\N	235756	0	44465007	81151		0
60065	3559	81151	1967-04-08	1967-04-08 00:00:00	1967-04-29	1967-04-29 00:00:00	32020		\N	236258	0	44465007	81151		0
60179	3562	40481087	1983-04-04	1983-04-04 00:00:00	1983-04-18	1983-04-18 00:00:00	32020		\N	236597	0	444814009	40481087		0
60349	3570	260139	1963-11-19	1963-11-19 00:00:00	1963-11-26	1963-11-26 00:00:00	32020		\N	237266	0	10509002	260139		0
49953	2951	40481087	1965-05-27	1965-05-27 00:00:00	1965-06-10	1965-06-10 00:00:00	32020		\N	196997	0	444814009	40481087		0
60689	3593	40481087	2004-04-01	2004-04-01 00:00:00	2004-04-08	2004-04-08 00:00:00	32020		\N	238676	0	444814009	40481087		0
60784	3598	4112343	1979-10-04	1979-10-04 00:00:00	1979-10-12	1979-10-12 00:00:00	32020		\N	238966	0	195662009	4112343		0
61054	3613	372328	1977-10-16	1977-10-16 00:00:00	1978-01-01	1978-01-01 00:00:00	32020		\N	240033	0	65363002	372328		0
61135	3616	260139	2012-03-15	2012-03-15 00:00:00	2012-03-22	2012-03-22 00:00:00	32020		\N	240303	0	10509002	260139		0
61307	3624	78272	2011-06-01	2011-06-01 00:00:00	2011-06-22	2011-06-22 00:00:00	32020		\N	241013	0	70704007	78272		0
61468	3631	40481087	2000-07-15	2000-07-15 00:00:00	2000-07-22	2000-07-22 00:00:00	32020		\N	241605	0	444814009	40481087		0
62176	3672	4283893	2003-05-18	2003-05-18 00:00:00	2004-05-23	2004-05-23 00:00:00	32020		\N	244298	0	36971009	4283893		0
72924	4333	81151	2011-12-01	2011-12-01 00:00:00	2011-12-15	2011-12-15 00:00:00	32020		\N	287413	0	44465007	81151		0
62539	3695	372328	1981-10-26	1981-10-26 00:00:00	1982-01-11	1982-01-11 00:00:00	32020		\N	245593	0	65363002	372328		0
62625	3699	81893	2012-01-26	2012-01-26 00:00:00	\N	\N	32020		\N	245911	0	64766004	81893		0
62877	3714	80180	1958-07-28	1958-07-28 00:00:00	\N	\N	32020		\N	246832	0	396275006	80180		0
62940	3718	260139	1989-08-01	1989-08-01 00:00:00	1989-08-08	1989-08-08 00:00:00	32020		\N	247138	0	10509002	260139		0
73733	4381	40481087	2000-03-02	2000-03-02 00:00:00	2000-03-09	2000-03-09 00:00:00	32020		\N	291108	0	444814009	40481087		0
73872	4388	4051466	1970-08-26	1970-08-26 00:00:00	1985-12-06	1985-12-06 00:00:00	32020		\N	291686	0	233678006	4051466		0
63563	3754	4266809	2005-03-10	2005-03-10 00:00:00	\N	\N	32020		\N	249551	0	397881000	4266809		0
74247	4409	4283893	1981-01-19	1981-01-19 00:00:00	1981-04-20	1981-04-20 00:00:00	32020		\N	293120	0	36971009	4283893		0
53207	3150	80180	1975-06-07	1975-06-07 00:00:00	\N	\N	32020		\N	209622	0	396275006	80180		0
63939	3778	40481087	1966-04-06	1966-04-06 00:00:00	1966-04-27	1966-04-27 00:00:00	32020		\N	251056	0	444814009	40481087		0
53594	3176	372328	1973-09-24	1973-09-24 00:00:00	1973-11-10	1973-11-10 00:00:00	32020		\N	211154	0	65363002	372328		0
53691	3178	372328	1984-08-07	1984-08-07 00:00:00	1985-05-18	1985-05-18 00:00:00	32020		\N	211394	0	65363002	372328		0
53802	3183	260139	1998-02-11	1998-02-11 00:00:00	1998-02-25	1998-02-25 00:00:00	32020		\N	211933	0	10509002	260139		0
54069	3201	4112343	1971-10-14	1971-10-14 00:00:00	1971-10-25	1971-10-25 00:00:00	32020		\N	212897	0	195662009	4112343		0
43654	2599	4218389	1981-11-22	1981-11-22 00:00:00	1981-12-13	1981-12-13 00:00:00	32020		\N	171956	0	39848009	4218389		0
54355	3219	80180	2018-04-24	2018-04-24 00:00:00	\N	\N	32020		\N	213892	0	396275006	80180		0
54485	3226	40481087	1974-04-30	1974-04-30 00:00:00	1974-05-07	1974-05-07 00:00:00	32020		\N	214440	0	444814009	40481087		0
54693	3237	78272	2012-02-19	2012-02-19 00:00:00	2012-03-11	2012-03-11 00:00:00	32020		\N	215155	0	70704007	78272		0
54863	3248	372328	1948-02-12	1948-02-12 00:00:00	1948-06-18	1948-06-18 00:00:00	32020		\N	215930	0	65363002	372328		0
55095	3260	78272	1964-11-28	1964-11-28 00:00:00	1964-12-26	1964-12-26 00:00:00	32020		\N	216748	0	70704007	78272		0
65783	3889	40481087	1961-09-25	1961-09-25 00:00:00	1961-10-09	1961-10-09 00:00:00	32020		\N	258470	0	444814009	40481087		0
55367	3279	40481087	1977-07-10	1977-07-10 00:00:00	1977-07-31	1977-07-31 00:00:00	32020		\N	217843	0	444814009	40481087		0
55537	3289	40481087	2004-01-25	2004-01-25 00:00:00	2004-02-01	2004-02-01 00:00:00	32020		\N	218531	0	444814009	40481087		0
55719	3296	4283893	1997-12-03	1997-12-03 00:00:00	1998-05-27	1998-05-27 00:00:00	32020		\N	218994	0	36971009	4283893		0
55787	3301	4112343	1984-06-06	1984-06-06 00:00:00	1984-06-14	1984-06-14 00:00:00	32020		\N	219265	0	195662009	4112343		0
66603	3941	260139	1986-05-31	1986-05-31 00:00:00	1986-06-14	1986-06-14 00:00:00	32020		\N	262060	0	10509002	260139		0
56245	3334	28060	1959-12-13	1959-12-13 00:00:00	1959-12-22	1959-12-22 00:00:00	32020		\N	221145	0	43878008	28060		0
56389	3342	4285898	1950-01-18	1950-01-18 00:00:00	\N	\N	32020		\N	221685	0	68496003	4285898		0
56534	3353	40481087	1942-03-18	1942-03-18 00:00:00	1942-04-01	1942-04-01 00:00:00	32020		\N	222355	0	444814009	40481087		0
67285	3976	4112343	1967-09-07	1967-09-07 00:00:00	1967-09-16	1967-09-16 00:00:00	32020		\N	264356	0	195662009	4112343		0
56897	3376	260139	1963-10-23	1963-10-23 00:00:00	1963-11-06	1963-11-06 00:00:00	32020		\N	223953	0	10509002	260139		0
57006	3382	4112343	1968-07-28	1968-07-28 00:00:00	1968-08-07	1968-08-07 00:00:00	32020		\N	224417	0	195662009	4112343		0
57115	3389	4112343	2010-03-14	2010-03-14 00:00:00	2010-03-27	2010-03-27 00:00:00	32020		\N	224747	0	195662009	4112343		0
57396	3407	4112343	1966-11-09	1966-11-09 00:00:00	1966-11-19	1966-11-19 00:00:00	32020		\N	225980	0	195662009	4112343		0
57540	3413	257012	1980-06-11	1980-06-11 00:00:00	\N	\N	32020		\N	226376	0	40055000	257012		0
57716	3423	40481087	2012-12-05	2012-12-05 00:00:00	2012-12-12	2012-12-12 00:00:00	32020		\N	227039	0	444814009	40481087		0
57878	3434	260139	1978-08-22	1978-08-22 00:00:00	1978-09-05	1978-09-05 00:00:00	32020		\N	227727	0	10509002	260139		0
58014	3438	4142905	1934-09-03	1934-09-03 00:00:00	1934-10-03	1934-10-03 00:00:00	32020		\N	228134	0	33737001	4142905		0
58166	3444	260139	2013-08-07	2013-08-07 00:00:00	2013-08-21	2013-08-21 00:00:00	32020		\N	228578	0	10509002	260139		0
47793	2837	40481087	2011-09-05	2011-09-05 00:00:00	2011-09-12	2011-09-12 00:00:00	32020		\N	188452	0	444814009	40481087		0
58452	3462	4146173	1985-06-14	1985-06-14 00:00:00	1985-08-20	1985-08-20 00:00:00	32020		\N	229739	0	307731004	4146173		0
69275	4101	4112343	1978-05-17	1978-05-17 00:00:00	1978-05-30	1978-05-30 00:00:00	32020		\N	272511	0	195662009	4112343		0
48288	2862	40481087	1994-11-22	1994-11-22 00:00:00	1994-11-29	1994-11-29 00:00:00	32020		\N	190283	0	444814009	40481087		0
48446	2869	257012	1993-09-27	1993-09-27 00:00:00	\N	\N	32020		\N	190847	0	40055000	257012		0
69732	4125	321042	1988-10-25	1988-10-25 00:00:00	\N	\N	32020		\N	274214	0	410429000	321042		0
69998	4142	40481087	1993-02-17	1993-02-17 00:00:00	1993-03-10	1993-03-10 00:00:00	32020		\N	275304	0	444814009	40481087		0
59459	3527	4084167	1962-03-10	1962-03-10 00:00:00	1962-03-10	1962-03-10 00:00:00	32020		\N	234045	0	241929008	4084167		0
59730	3539	40481087	2006-01-25	2006-01-25 00:00:00	2006-02-01	2006-02-01 00:00:00	32020		\N	235095	0	444814009	40481087		0
59914	3550	260139	1995-10-03	1995-10-03 00:00:00	1995-10-10	1995-10-10 00:00:00	32020		\N	235704	0	10509002	260139		0
60066	3559	4112343	1959-11-21	1959-11-21 00:00:00	1959-11-28	1959-11-28 00:00:00	32020		\N	236274	0	195662009	4112343		0
60180	3562	257012	1998-08-11	1998-08-11 00:00:00	\N	\N	32020		\N	236570	0	40055000	257012		0
60350	3570	78272	1950-09-26	1950-09-26 00:00:00	1950-10-31	1950-10-31 00:00:00	32020		\N	237223	0	70704007	78272		0
49954	2951	40481087	1961-04-29	1961-04-29 00:00:00	1961-05-13	1961-05-13 00:00:00	32020		\N	197057	0	444814009	40481087		0
60690	3593	28060	1965-04-06	1965-04-06 00:00:00	1965-04-15	1965-04-15 00:00:00	32020		\N	238667	0	43878008	28060		0
60786	3598	4329847	2014-12-14	2014-12-14 00:00:00	\N	\N	32020		\N	238946	0	22298006	4329847		0
61055	3613	28060	1991-10-18	1991-10-18 00:00:00	1991-10-26	1991-10-26 00:00:00	32020		\N	240045	0	43878008	28060		0
61138	3618	4112343	1993-09-08	1993-09-08 00:00:00	1993-09-18	1993-09-18 00:00:00	32020		\N	240356	0	195662009	4112343		0
61308	3624	4296205	1981-02-12	1981-02-12 00:00:00	1981-02-26	1981-02-26 00:00:00	32020		\N	241010	0	403191005	4296205		0
61469	3631	4237458	1981-03-31	1981-03-31 00:00:00	1981-04-30	1981-04-30 00:00:00	32020		\N	241581	0	58150001	4237458		0
51105	3026	378001	1999-06-15	1999-06-15 00:00:00	1999-08-14	1999-08-14 00:00:00	32020		\N	201728	0	62106007	378001		0
61915	3655	260139	2002-02-02	2002-02-02 00:00:00	2002-02-16	2002-02-16 00:00:00	32020		\N	243270	0	10509002	260139		0
62078	3666	378001	1969-07-02	1969-07-02 00:00:00	1969-08-31	1969-08-31 00:00:00	32020		\N	243867	0	62106007	378001		0
62177	3672	40481087	2011-07-24	2011-07-24 00:00:00	2011-07-31	2011-07-31 00:00:00	32020		\N	244329	0	444814009	40481087		0
72925	4333	4296204	1968-04-15	1968-04-15 00:00:00	1968-05-06	1968-05-06 00:00:00	32020		\N	287410	0	403190006	4296204		0
62540	3695	372328	1982-12-07	1982-12-07 00:00:00	1983-01-10	1983-01-10 00:00:00	32020		\N	245642	0	65363002	372328		0
62626	3699	30753	2012-09-22	2012-09-22 00:00:00	\N	\N	32020		\N	245925	0	16761005	30753		0
62878	3714	40481087	2017-06-28	2017-06-28 00:00:00	2017-07-12	2017-07-12 00:00:00	32020		\N	246762	0	444814009	40481087		0
62941	3718	260139	1973-10-15	1973-10-15 00:00:00	1973-10-22	1973-10-22 00:00:00	32020		\N	247106	0	10509002	260139		0
73734	4381	40481087	1995-01-15	1995-01-15 00:00:00	1995-01-22	1995-01-22 00:00:00	32020		\N	291107	0	444814009	40481087		0
73873	4388	4152936	1971-03-02	1971-03-02 00:00:00	1971-03-16	1971-03-16 00:00:00	32020		\N	291636	0	283385000	4152936		0
63564	3754	40481087	1977-11-27	1977-11-27 00:00:00	1977-12-11	1977-12-11 00:00:00	32020		\N	249445	0	444814009	40481087		0
74248	4409	4112343	2002-11-05	2002-11-05 00:00:00	2002-11-18	2002-11-18 00:00:00	32020		\N	293084	0	195662009	4112343		0
53208	3150	40481087	1957-08-26	1957-08-26 00:00:00	1957-09-16	1957-09-16 00:00:00	32020		\N	209592	0	444814009	40481087		0
63940	3778	4112343	1995-08-07	1995-08-07 00:00:00	1995-08-15	1995-08-15 00:00:00	32020		\N	251057	0	195662009	4112343		0
53595	3176	4116491	2000-11-26	2000-11-26 00:00:00	2001-01-25	2001-01-25 00:00:00	32020		\N	211107	0	301011002	4116491		0
53692	3178	313217	2006-09-23	2006-09-23 00:00:00	\N	\N	32020		\N	211447	0	49436004	313217		0
53803	3183	4059173	1988-05-02	1988-05-02 00:00:00	1988-06-01	1988-06-01 00:00:00	32020		\N	211926	0	16114001	4059173		0
54070	3201	40481087	1980-07-18	1980-07-18 00:00:00	1980-07-25	1980-07-25 00:00:00	32020		\N	212898	0	444814009	40481087		0
43655	2599	372328	1988-08-24	1988-08-24 00:00:00	1988-11-05	1988-11-05 00:00:00	32020		\N	172006	0	65363002	372328		0
54356	3219	260139	1997-09-15	1997-09-15 00:00:00	1997-09-29	1997-09-29 00:00:00	32020		\N	213911	0	10509002	260139		0
54486	3226	260139	1982-01-28	1982-01-28 00:00:00	1982-02-11	1982-02-11 00:00:00	32020		\N	214494	0	10509002	260139		0
54694	3237	40481087	1950-06-03	1950-06-03 00:00:00	1950-06-24	1950-06-24 00:00:00	32020		\N	215222	0	444814009	40481087		0
54864	3248	4112343	1951-08-12	1951-08-12 00:00:00	1951-08-19	1951-08-19 00:00:00	32020		\N	215892	0	195662009	4112343		0
55096	3260	372328	1962-01-22	1962-01-22 00:00:00	1962-03-10	1962-03-10 00:00:00	32020		\N	216758	0	65363002	372328		0
65784	3889	40481087	2005-01-15	2005-01-15 00:00:00	2005-02-05	2005-02-05 00:00:00	32020		\N	258457	0	444814009	40481087		0
55368	3279	40481087	1981-12-12	1981-12-12 00:00:00	1982-01-02	1982-01-02 00:00:00	32020		\N	217903	0	444814009	40481087		0
55538	3289	4112343	2005-07-14	2005-07-14 00:00:00	2005-07-24	2005-07-24 00:00:00	32020		\N	218516	0	195662009	4112343		0
55721	3296	4237458	2016-02-24	2016-02-24 00:00:00	2016-05-24	2016-05-24 00:00:00	32020		\N	219096	0	58150001	4237458		0
55788	3301	4112343	2005-02-07	2005-02-07 00:00:00	2005-02-20	2005-02-20 00:00:00	32020		\N	219268	0	195662009	4112343		0
66604	3941	260139	1964-10-30	1964-10-30 00:00:00	1964-11-13	1964-11-13 00:00:00	32020		\N	262045	0	10509002	260139		0
56246	3334	4112343	1981-07-01	1981-07-01 00:00:00	1981-07-14	1981-07-14 00:00:00	32020		\N	221163	0	195662009	4112343		0
56390	3342	80180	1950-04-18	1950-04-18 00:00:00	\N	\N	32020		\N	221685	0	396275006	80180		0
56535	3353	40481087	1935-03-10	1935-03-10 00:00:00	1935-03-17	1935-03-17 00:00:00	32020		\N	222406	0	444814009	40481087		0
67286	3976	40481087	1988-07-03	1988-07-03 00:00:00	1988-07-10	1988-07-10 00:00:00	32020		\N	264326	0	444814009	40481087		0
56898	3376	4278672	2017-10-08	2017-10-08 00:00:00	2017-11-07	2017-11-07 00:00:00	32020		\N	224003	0	65966004	4278672		0
57007	3382	4109685	1965-12-17	1965-12-17 00:00:00	1966-01-07	1966-01-07 00:00:00	32020		\N	224400	0	284551006	4109685		0
57116	3389	372328	1963-02-21	1963-02-21 00:00:00	1963-08-12	1963-08-12 00:00:00	32020		\N	224791	0	65363002	372328		0
57397	3407	81151	2010-04-30	2010-04-30 00:00:00	2010-05-21	2010-05-21 00:00:00	32020		\N	225979	0	44465007	81151		0
57541	3414	40481087	2007-03-12	2007-03-12 00:00:00	2007-03-26	2007-03-26 00:00:00	32020		\N	226490	0	444814009	40481087		0
57717	3423	40481087	1990-01-29	1990-01-29 00:00:00	1990-02-05	1990-02-05 00:00:00	32020		\N	227056	0	444814009	40481087		0
57879	3434	4296204	1961-02-20	1961-02-20 00:00:00	1961-03-06	1961-03-06 00:00:00	32020		\N	227682	0	403190006	4296204		0
58015	3439	4155034	1962-04-02	1962-04-02 00:00:00	1962-04-23	1962-04-23 00:00:00	32020		\N	228138	0	283371005	4155034		0
58167	3444	40481087	1982-12-13	1982-12-13 00:00:00	1982-12-27	1982-12-27 00:00:00	32020		\N	228557	0	444814009	40481087		0
47795	2837	260139	2015-01-23	2015-01-23 00:00:00	2015-01-30	2015-01-30 00:00:00	32020		\N	188476	0	10509002	260139		0
58453	3462	4294548	1987-01-21	1987-01-21 00:00:00	1987-02-04	1987-02-04 00:00:00	32020		\N	229731	0	75498004	4294548		0
69276	4101	260139	1980-06-08	1980-06-08 00:00:00	1980-06-22	1980-06-22 00:00:00	32020		\N	272516	0	10509002	260139		0
48289	2862	4027663	1995-08-19	1995-08-19 00:00:00	\N	\N	32020		\N	190283	0	13200003	4027663		0
48447	2869	40481087	2016-08-26	2016-08-26 00:00:00	2016-09-09	2016-09-09 00:00:00	32020		\N	190894	0	444814009	40481087		0
69733	4125	260139	1972-08-25	1972-08-25 00:00:00	1972-09-01	1972-09-01 00:00:00	32020		\N	274245	0	10509002	260139		0
69999	4142	40481087	2013-01-31	2013-01-31 00:00:00	2013-02-14	2013-02-14 00:00:00	32020		\N	275322	0	444814009	40481087		0
59460	3527	4266809	2002-03-25	2002-03-25 00:00:00	\N	\N	32020		\N	234042	0	397881000	4266809		0
59731	3539	260139	2011-08-19	2011-08-19 00:00:00	2011-09-02	2011-09-02 00:00:00	32020		\N	235102	0	10509002	260139		0
59915	3550	4112343	1993-05-01	1993-05-01 00:00:00	1993-05-08	1993-05-08 00:00:00	32020		\N	235747	0	195662009	4112343		0
60067	3559	372328	1950-05-23	1950-05-23 00:00:00	1950-08-04	1950-08-04 00:00:00	32020		\N	236247	0	65363002	372328		0
60181	3562	4283893	1998-06-02	1998-06-02 00:00:00	1998-09-01	1998-09-01 00:00:00	32020		\N	236592	0	36971009	4283893		0
60351	3570	4113008	1980-09-14	1980-09-14 00:00:00	1980-10-05	1980-10-05 00:00:00	32020		\N	237226	0	284549007	4113008		0
49955	2951	4237458	1986-04-07	1986-04-07 00:00:00	1986-05-07	1986-05-07 00:00:00	32020		\N	197009	0	58150001	4237458		0
60691	3593	4109685	1984-01-01	1984-01-01 00:00:00	1984-01-22	1984-01-22 00:00:00	32020		\N	238687	0	284551006	4109685		0
60787	3598	4112343	1980-10-24	1980-10-24 00:00:00	1980-11-06	1980-11-06 00:00:00	32020		\N	238954	0	195662009	4112343		0
61056	3614	4112343	2002-04-09	2002-04-09 00:00:00	2002-04-20	2002-04-20 00:00:00	32020		\N	240149	0	195662009	4112343		0
61139	3618	260139	1956-12-23	1956-12-23 00:00:00	1957-01-06	1957-01-06 00:00:00	32020		\N	240450	0	10509002	260139		0
61309	3624	40481087	2018-04-10	2018-04-10 00:00:00	2018-05-01	2018-05-01 00:00:00	32020		\N	240949	0	444814009	40481087		0
61470	3631	40481087	2002-02-20	2002-02-20 00:00:00	2002-03-06	2002-03-06 00:00:00	32020		\N	241606	0	444814009	40481087		0
51106	3026	4112343	1984-02-06	1984-02-06 00:00:00	1984-02-18	1984-02-18 00:00:00	32020		\N	201739	0	195662009	4112343		0
61916	3655	381316	2001-12-13	2001-12-13 00:00:00	\N	\N	32020		\N	243245	0	230690007	381316		0
62079	3666	4112343	1999-03-27	1999-03-27 00:00:00	1999-04-09	1999-04-09 00:00:00	32020		\N	243876	0	195662009	4112343		0
62178	3672	260139	2009-03-09	2009-03-09 00:00:00	2009-03-16	2009-03-16 00:00:00	32020		\N	244309	0	10509002	260139		0
72926	4333	40481087	1987-01-06	1987-01-06 00:00:00	1987-01-20	1987-01-20 00:00:00	32020		\N	287417	0	444814009	40481087		0
62541	3695	40481087	2011-12-24	2011-12-24 00:00:00	2011-12-31	2011-12-31 00:00:00	32020		\N	245641	0	444814009	40481087		0
62627	3699	4266809	2014-01-15	2014-01-15 00:00:00	\N	\N	32020		\N	245925	0	397881000	4266809		0
62879	3714	4283893	1936-01-10	1936-01-10 00:00:00	1936-06-05	1936-06-05 00:00:00	32020		\N	246794	0	36971009	4283893		0
62942	3718	372328	1970-10-11	1970-10-11 00:00:00	1971-10-11	1971-10-11 00:00:00	32020		\N	247097	0	65363002	372328		0
73735	4381	372328	1967-11-05	1967-11-05 00:00:00	1968-05-07	1968-05-07 00:00:00	32020		\N	291096	0	65363002	372328		0
73874	4388	81151	1970-04-01	1970-04-01 00:00:00	1970-05-06	1970-05-06 00:00:00	32020		\N	291635	0	44465007	81151		0
63565	3754	40481087	1971-08-09	1971-08-09 00:00:00	1971-08-23	1971-08-23 00:00:00	32020		\N	249488	0	444814009	40481087		0
74249	4409	372328	1967-07-18	1967-07-18 00:00:00	1967-09-28	1967-09-28 00:00:00	32020		\N	293059	0	65363002	372328		0
53209	3150	4146173	1940-04-21	1940-04-21 00:00:00	1940-05-21	1940-05-21 00:00:00	32020		\N	209571	0	307731004	4146173		0
63941	3778	40481087	2008-01-15	2008-01-15 00:00:00	2008-01-22	2008-01-22 00:00:00	32020		\N	251052	0	444814009	40481087		0
53596	3176	4112343	1985-09-05	1985-09-05 00:00:00	1985-09-17	1985-09-17 00:00:00	32020		\N	211165	0	195662009	4112343		0
53693	3178	260139	1999-08-19	1999-08-19 00:00:00	1999-09-02	1999-09-02 00:00:00	32020		\N	211375	0	10509002	260139		0
53804	3183	40481087	1994-03-29	1994-03-29 00:00:00	1994-04-19	1994-04-19 00:00:00	32020		\N	211897	0	444814009	40481087		0
54071	3201	4134304	1953-06-19	1953-06-19 00:00:00	1953-07-19	1953-07-19 00:00:00	32020		\N	212916	0	263102004	4134304		0
43656	2599	81151	2001-03-01	2001-03-01 00:00:00	2001-03-22	2001-03-22 00:00:00	32020		\N	171970	0	44465007	81151		0
54357	3219	28060	1983-05-04	1983-05-04 00:00:00	1983-05-16	1983-05-16 00:00:00	32020		\N	213887	0	43878008	28060		0
54487	3226	28060	2004-10-24	2004-10-24 00:00:00	2004-11-03	2004-11-03 00:00:00	32020		\N	214476	0	43878008	28060		0
54695	3237	81151	1954-06-20	1954-06-20 00:00:00	1954-07-11	1954-07-11 00:00:00	32020		\N	215150	0	44465007	81151		0
54865	3248	4112343	1964-12-09	1964-12-09 00:00:00	1964-12-20	1964-12-20 00:00:00	32020		\N	215894	0	195662009	4112343		0
65588	3879	372328	1987-02-19	1987-02-19 00:00:00	1988-05-12	1988-05-12 00:00:00	32020		\N	257663	0	65363002	372328		0
65785	3889	40481087	2016-02-02	2016-02-02 00:00:00	2016-02-23	2016-02-23 00:00:00	32020		\N	258458	0	444814009	40481087		0
55369	3279	372328	1957-11-28	1957-11-28 00:00:00	1958-01-14	1958-01-14 00:00:00	32020		\N	217870	0	65363002	372328		0
55539	3289	40481087	1972-04-29	1972-04-29 00:00:00	1972-05-06	1972-05-06 00:00:00	32020		\N	218460	0	444814009	40481087		0
55722	3296	372328	1937-07-22	1937-07-22 00:00:00	1937-09-03	1937-09-03 00:00:00	32020		\N	218990	0	65363002	372328		0
55789	3301	40481087	2006-05-10	2006-05-10 00:00:00	2006-05-17	2006-05-17 00:00:00	32020		\N	219283	0	444814009	40481087		0
66605	3941	40481087	2013-08-18	2013-08-18 00:00:00	2013-09-08	2013-09-08 00:00:00	32020		\N	262061	0	444814009	40481087		0
56247	3334	4112343	1981-12-12	1981-12-12 00:00:00	1981-12-20	1981-12-20 00:00:00	32020		\N	221164	0	195662009	4112343		0
56391	3342	40481087	1913-03-19	1913-03-19 00:00:00	1913-04-09	1913-04-09 00:00:00	32020		\N	221571	0	444814009	40481087		0
56536	3353	372328	1930-04-21	1930-04-21 00:00:00	1930-12-13	1930-12-13 00:00:00	32020		\N	222393	0	65363002	372328		0
67287	3976	28060	1988-10-27	1988-10-27 00:00:00	1988-11-03	1988-11-03 00:00:00	32020		\N	264327	0	43878008	28060		0
56899	3376	40481087	1976-01-15	1976-01-15 00:00:00	1976-01-22	1976-01-22 00:00:00	32020		\N	223929	0	444814009	40481087		0
57008	3382	40481087	1998-10-14	1998-10-14 00:00:00	1998-10-28	1998-10-28 00:00:00	32020		\N	224420	0	444814009	40481087		0
57117	3389	4112343	2013-12-08	2013-12-08 00:00:00	2013-12-17	2013-12-17 00:00:00	32020		\N	224790	0	195662009	4112343		0
57398	3407	4027663	1994-01-17	1994-01-17 00:00:00	\N	\N	32020		\N	225996	0	13200003	4027663		0
57542	3414	372328	1971-08-06	1971-08-06 00:00:00	1972-03-02	1972-03-02 00:00:00	32020		\N	226426	0	65363002	372328		0
57718	3423	4156265	1986-10-28	1986-10-28 00:00:00	1986-11-18	1986-11-18 00:00:00	32020		\N	227093	0	370247008	4156265		0
57880	3434	372328	1950-05-12	1950-05-12 00:00:00	1950-09-28	1950-09-28 00:00:00	32020		\N	227698	0	65363002	372328		0
58016	3439	4237458	1967-01-02	1967-01-02 00:00:00	1967-04-02	1967-04-02 00:00:00	32020		\N	228168	0	58150001	4237458		0
58168	3444	40481087	1986-02-15	1986-02-15 00:00:00	1986-03-08	1986-03-08 00:00:00	32020		\N	228558	0	444814009	40481087		0
47796	2837	40481087	1975-09-21	1975-09-21 00:00:00	1975-09-28	1975-09-28 00:00:00	32020		\N	188414	0	444814009	40481087		0
58454	3462	4112343	1961-11-18	1961-11-18 00:00:00	1961-11-25	1961-11-25 00:00:00	32020		\N	229710	0	195662009	4112343		0
69277	4101	40481087	2011-12-10	2011-12-10 00:00:00	2011-12-24	2011-12-24 00:00:00	32020		\N	272513	0	444814009	40481087		0
48290	2862	40481087	2015-07-10	2015-07-10 00:00:00	2015-07-24	2015-07-24 00:00:00	32020		\N	190266	0	444814009	40481087		0
48448	2869	4112343	1999-01-11	1999-01-11 00:00:00	1999-01-20	1999-01-20 00:00:00	32020		\N	190836	0	195662009	4112343		0
69734	4125	80180	2006-11-28	2006-11-28 00:00:00	\N	\N	32020		\N	274271	0	396275006	80180		0
70000	4142	4152936	2013-12-14	2013-12-14 00:00:00	2013-12-28	2013-12-28 00:00:00	32020		\N	275292	0	283385000	4152936		0
59461	3527	30753	2001-09-26	2001-09-26 00:00:00	\N	\N	32020		\N	234042	0	16761005	30753		0
59732	3539	4112343	2006-04-29	2006-04-29 00:00:00	2006-05-10	2006-05-10 00:00:00	32020		\N	235101	0	195662009	4112343		0
59916	3550	260139	1991-07-17	1991-07-17 00:00:00	1991-07-24	1991-07-24 00:00:00	32020		\N	235713	0	10509002	260139		0
60068	3559	260139	1956-10-20	1956-10-20 00:00:00	1956-11-03	1956-11-03 00:00:00	32020		\N	236244	0	10509002	260139		0
60205	3565	40481087	1964-10-26	1964-10-26 00:00:00	1964-11-02	1964-11-02 00:00:00	32020		\N	236718	0	444814009	40481087		0
60352	3570	260139	1990-02-09	1990-02-09 00:00:00	1990-02-16	1990-02-16 00:00:00	32020		\N	237291	0	10509002	260139		0
49956	2951	372328	1964-01-03	1964-01-03 00:00:00	1964-09-06	1964-09-06 00:00:00	32020		\N	197036	0	65363002	372328		0
60692	3593	4112343	1957-06-25	1957-06-25 00:00:00	1957-07-06	1957-07-06 00:00:00	32020		\N	238644	0	195662009	4112343		0
60788	3598	378001	1955-03-29	1955-03-29 00:00:00	1955-04-28	1955-04-28 00:00:00	32020		\N	238942	0	62106007	378001		0
61057	3614	260139	1992-07-05	1992-07-05 00:00:00	1992-07-12	1992-07-12 00:00:00	32020		\N	240137	0	10509002	260139		0
61140	3618	378001	1969-03-30	1969-03-30 00:00:00	1969-04-29	1969-04-29 00:00:00	32020		\N	240342	0	62106007	378001		0
61310	3624	260139	1983-08-02	1983-08-02 00:00:00	1983-08-09	1983-08-09 00:00:00	32020		\N	240945	0	10509002	260139		0
61471	3631	40481087	1980-11-03	1980-11-03 00:00:00	1980-11-17	1980-11-17 00:00:00	32020		\N	241594	0	444814009	40481087		0
51107	3026	260139	1971-01-22	1971-01-22 00:00:00	1971-02-05	1971-02-05 00:00:00	32020		\N	201759	0	10509002	260139		0
61917	3655	40481087	1960-01-30	1960-01-30 00:00:00	1960-02-13	1960-02-13 00:00:00	32020		\N	243263	0	444814009	40481087		0
62080	3666	40481087	1984-09-09	1984-09-09 00:00:00	1984-09-23	1984-09-23 00:00:00	32020		\N	243915	0	444814009	40481087		0
62179	3672	80180	2002-02-21	2002-02-21 00:00:00	\N	\N	32020		\N	244266	0	396275006	80180		0
72927	4333	81151	1959-08-26	1959-08-26 00:00:00	1959-09-30	1959-09-30 00:00:00	32020		\N	287409	0	44465007	81151		0
62542	3695	4156265	2015-11-14	2015-11-14 00:00:00	2015-12-05	2015-12-05 00:00:00	32020		\N	245567	0	370247008	4156265		0
62628	3699	80180	2014-01-15	2014-01-15 00:00:00	\N	\N	32020		\N	245925	0	396275006	80180		0
62880	3714	80502	2012-12-19	2012-12-19 00:00:00	\N	\N	32020		\N	246855	0	64859006	80502		0
62943	3718	372328	1966-03-24	1966-03-24 00:00:00	1966-07-04	1966-07-04 00:00:00	32020		\N	247083	0	65363002	372328		0
73736	4381	4112343	1980-11-19	1980-11-19 00:00:00	1980-11-27	1980-11-27 00:00:00	32020		\N	291105	0	195662009	4112343		0
73875	4388	4278672	1975-01-15	1975-01-15 00:00:00	1975-03-16	1975-03-16 00:00:00	32020		\N	291638	0	65966004	4278672		0
63566	3754	81893	2003-01-20	2003-01-20 00:00:00	\N	\N	32020		\N	249481	0	64766004	81893		0
74250	4409	257012	1981-02-23	1981-02-23 00:00:00	\N	\N	32020		\N	293082	0	40055000	257012		0
53255	3157	40481087	2004-10-29	2004-10-29 00:00:00	2004-11-12	2004-11-12 00:00:00	32020		\N	209895	0	444814009	40481087		0
63942	3778	40481087	2017-03-12	2017-03-12 00:00:00	2017-03-19	2017-03-19 00:00:00	32020		\N	251062	0	444814009	40481087		0
53597	3176	134438	2001-12-03	2001-12-03 00:00:00	2002-09-05	2002-09-05 00:00:00	32020		\N	211201	0	40275004	134438		0
53694	3178	81893	1992-03-12	1992-03-12 00:00:00	\N	\N	32020		\N	211372	0	64766004	81893		0
53805	3183	134438	2014-02-07	2014-02-07 00:00:00	2014-11-07	2014-11-07 00:00:00	32020		\N	211924	0	40275004	134438		0
54072	3201	4112343	1956-11-04	1956-11-04 00:00:00	1956-11-11	1956-11-11 00:00:00	32020		\N	212920	0	195662009	4112343		0
43657	2599	80180	2011-05-05	2011-05-05 00:00:00	\N	\N	32020		\N	172005	0	396275006	80180		0
54358	3219	440448	2015-01-11	2015-01-11 00:00:00	\N	\N	32020		\N	213932	0	74400008	440448		0
54488	3226	40481087	1978-12-06	1978-12-06 00:00:00	1978-12-20	1978-12-20 00:00:00	32020		\N	214486	0	444814009	40481087		0
54696	3237	28060	1928-06-05	1928-06-05 00:00:00	1928-06-17	1928-06-17 00:00:00	32020		\N	215217	0	43878008	28060		0
54866	3248	4112343	2011-04-27	2011-04-27 00:00:00	2011-05-06	2011-05-06 00:00:00	32020		\N	215858	0	195662009	4112343		0
65589	3879	4283893	1942-01-07	1942-01-07 00:00:00	1942-02-11	1942-02-11 00:00:00	32020		\N	257695	0	36971009	4283893		0
61523	3636	257012	1994-04-10	1994-04-10 00:00:00	\N	\N	32020		\N	241803	0	40055000	257012		0
65786	3889	260139	1954-02-03	1954-02-03 00:00:00	1954-02-10	1954-02-10 00:00:00	32020		\N	258452	0	10509002	260139		0
55370	3279	40481087	1995-05-30	1995-05-30 00:00:00	1995-06-20	1995-06-20 00:00:00	32020		\N	217885	0	444814009	40481087		0
55540	3289	260139	1991-06-05	1991-06-05 00:00:00	1991-06-12	1991-06-12 00:00:00	32020		\N	218536	0	10509002	260139		0
55723	3296	40481087	1972-02-24	1972-02-24 00:00:00	1972-03-09	1972-03-09 00:00:00	32020		\N	219098	0	444814009	40481087		0
55790	3301	80180	1974-05-11	1974-05-11 00:00:00	\N	\N	32020		\N	219317	0	396275006	80180		0
66606	3941	4027663	1990-01-15	1990-01-15 00:00:00	\N	\N	32020		\N	262014	0	13200003	4027663		0
56248	3334	4112343	1986-02-28	1986-02-28 00:00:00	1986-03-10	1986-03-10 00:00:00	32020		\N	221165	0	195662009	4112343		0
56392	3342	40481087	1955-08-08	1955-08-08 00:00:00	1955-08-15	1955-08-15 00:00:00	32020		\N	221562	0	444814009	40481087		0
56537	3353	4237458	1971-06-20	1971-06-20 00:00:00	1971-07-20	1971-07-20 00:00:00	32020		\N	222448	0	58150001	4237458		0
67288	3976	4310024	2006-01-02	2006-01-02 00:00:00	\N	\N	32020		\N	264369	0	424802006	4310024		0
56900	3376	40481087	1991-12-04	1991-12-04 00:00:00	1991-12-25	1991-12-25 00:00:00	32020		\N	224012	0	444814009	40481087		0
57009	3382	4278672	1992-04-20	1992-04-20 00:00:00	1992-05-20	1992-05-20 00:00:00	32020		\N	224401	0	65966004	4278672		0
57118	3389	40481087	2010-08-12	2010-08-12 00:00:00	2010-09-02	2010-09-02 00:00:00	32020		\N	224748	0	444814009	40481087		0
57399	3407	4112343	2016-06-23	2016-06-23 00:00:00	2016-07-05	2016-07-05 00:00:00	32020		\N	225983	0	195662009	4112343		0
57543	3414	4156265	1974-11-18	1974-11-18 00:00:00	1974-12-09	1974-12-09 00:00:00	32020		\N	226451	0	370247008	4156265		0
57719	3423	260139	2010-10-25	2010-10-25 00:00:00	2010-11-01	2010-11-01 00:00:00	32020		\N	227059	0	10509002	260139		0
57881	3434	4113008	2009-04-23	2009-04-23 00:00:00	2009-05-14	2009-05-14 00:00:00	32020		\N	227685	0	284549007	4113008		0
58017	3439	4112343	1968-06-13	1968-06-13 00:00:00	1968-06-20	1968-06-20 00:00:00	32020		\N	228141	0	195662009	4112343		0
58169	3444	40481087	1966-07-07	1966-07-07 00:00:00	1966-07-21	1966-07-21 00:00:00	32020		\N	228565	0	444814009	40481087		0
47797	2837	260139	2008-10-11	2008-10-11 00:00:00	2008-10-25	2008-10-25 00:00:00	32020		\N	188420	0	10509002	260139		0
58455	3462	4112343	2016-10-18	2016-10-18 00:00:00	2016-10-28	2016-10-28 00:00:00	32020		\N	229737	0	195662009	4112343		0
69278	4101	28060	2008-08-16	2008-08-16 00:00:00	2008-08-28	2008-08-28 00:00:00	32020		\N	272535	0	43878008	28060		0
48291	2862	40481087	1977-02-09	1977-02-09 00:00:00	1977-02-23	1977-02-23 00:00:00	32020		\N	190264	0	444814009	40481087		0
48449	2869	4296204	2000-12-03	2000-12-03 00:00:00	2000-12-24	2000-12-24 00:00:00	32020		\N	190828	0	403190006	4296204		0
69735	4125	4112343	1976-07-04	1976-07-04 00:00:00	1976-07-12	1976-07-12 00:00:00	32020		\N	274229	0	195662009	4112343		0
70001	4142	80180	2019-01-21	2019-01-21 00:00:00	\N	\N	32020		\N	275318	0	396275006	80180		0
59462	3527	80180	2002-03-25	2002-03-25 00:00:00	\N	\N	32020		\N	234042	0	396275006	80180		0
59733	3539	81151	1996-03-23	1996-03-23 00:00:00	1996-04-13	1996-04-13 00:00:00	32020		\N	235092	0	44465007	81151		0
59917	3550	40481087	1993-03-02	1993-03-02 00:00:00	1993-03-16	1993-03-16 00:00:00	32020		\N	235728	0	444814009	40481087		0
60069	3559	260139	1977-05-22	1977-05-22 00:00:00	1977-05-29	1977-05-29 00:00:00	32020		\N	236278	0	10509002	260139		0
60206	3565	28060	1947-12-17	1947-12-17 00:00:00	1947-12-30	1947-12-30 00:00:00	32020		\N	236725	0	43878008	28060		0
60353	3571	80180	2007-02-01	2007-02-01 00:00:00	\N	\N	32020		\N	237420	0	396275006	80180		0
49957	2951	40481087	2018-07-11	2018-07-11 00:00:00	2018-08-01	2018-08-01 00:00:00	32020		\N	197035	0	444814009	40481087		0
60693	3593	4112343	1966-09-08	1966-09-08 00:00:00	1966-09-17	1966-09-17 00:00:00	32020		\N	238717	0	195662009	4112343		0
60789	3598	40481087	1996-01-10	1996-01-10 00:00:00	1996-01-24	1996-01-24 00:00:00	32020		\N	238950	0	444814009	40481087		0
61058	3614	4294548	1993-07-02	1993-07-02 00:00:00	1993-07-09	1993-07-09 00:00:00	32020		\N	240113	0	75498004	4294548		0
61141	3618	4112343	1971-05-28	1971-05-28 00:00:00	1971-06-08	1971-06-08 00:00:00	32020		\N	240374	0	195662009	4112343		0
61311	3624	80180	1982-08-14	1982-08-14 00:00:00	\N	\N	32020		\N	240993	0	396275006	80180		0
61472	3631	260139	1989-05-24	1989-05-24 00:00:00	1989-05-31	1989-05-31 00:00:00	32020		\N	241603	0	10509002	260139		0
51108	3026	40481087	1975-05-20	1975-05-20 00:00:00	1975-06-10	1975-06-10 00:00:00	32020		\N	201738	0	444814009	40481087		0
61918	3655	80180	1975-12-08	1975-12-08 00:00:00	\N	\N	32020		\N	243327	0	396275006	80180		0
62081	3666	28060	1972-05-27	1972-05-27 00:00:00	1972-06-06	1972-06-06 00:00:00	32020		\N	243874	0	43878008	28060		0
62180	3672	40481087	1985-08-11	1985-08-11 00:00:00	1985-08-25	1985-08-25 00:00:00	32020		\N	244288	0	444814009	40481087		0
72928	4333	260139	1983-08-27	1983-08-27 00:00:00	1983-09-10	1983-09-10 00:00:00	32020		\N	287416	0	10509002	260139		0
62543	3695	4048171	1985-02-09	1985-02-09 00:00:00	1999-02-08	1999-02-08 00:00:00	32020		\N	245610	0	232353008	4048171		0
62629	3699	4285898	2013-05-20	2013-05-20 00:00:00	\N	\N	32020		\N	245925	0	68496003	4285898		0
62881	3714	4112343	2019-06-06	2019-06-06 00:00:00	2019-06-19	2019-06-19 00:00:00	32020		\N	246768	0	195662009	4112343		0
62944	3718	260139	1994-02-02	1994-02-02 00:00:00	1994-02-09	1994-02-09 00:00:00	32020		\N	247129	0	10509002	260139		0
73737	4381	4112343	2016-03-25	2016-03-25 00:00:00	2016-04-06	2016-04-06 00:00:00	32020		\N	291076	0	195662009	4112343		0
73876	4388	28060	1967-05-02	1967-05-02 00:00:00	1967-05-09	1967-05-09 00:00:00	32020		\N	291658	0	43878008	28060		0
63567	3754	28060	1970-11-18	1970-11-18 00:00:00	1970-11-26	1970-11-26 00:00:00	32020		\N	249487	0	43878008	28060		0
74251	4409	40481087	1992-11-28	1992-11-28 00:00:00	1992-12-12	1992-12-12 00:00:00	32020		\N	293122	0	444814009	40481087		0
53256	3157	4283893	1996-01-05	1996-01-05 00:00:00	1996-01-19	1996-01-19 00:00:00	32020		\N	209866	0	36971009	4283893		0
63943	3778	4112343	1999-06-11	1999-06-11 00:00:00	1999-06-22	1999-06-22 00:00:00	32020		\N	251060	0	195662009	4112343		0
53598	3176	40481087	1983-11-11	1983-11-11 00:00:00	1983-11-25	1983-11-25 00:00:00	32020		\N	211085	0	444814009	40481087		0
53695	3178	40481087	1992-01-02	1992-01-02 00:00:00	1992-01-23	1992-01-23 00:00:00	32020		\N	211372	0	444814009	40481087		0
53806	3183	4084167	1981-08-07	1981-08-07 00:00:00	1981-08-07	1981-08-07 00:00:00	32020		\N	211925	0	241929008	4084167		0
54073	3201	78272	1941-04-25	1941-04-25 00:00:00	1941-05-23	1941-05-23 00:00:00	32020		\N	212915	0	70704007	78272		0
43658	2599	4112343	1990-12-06	1990-12-06 00:00:00	1990-12-18	1990-12-18 00:00:00	32020		\N	171975	0	195662009	4112343		0
54367	3221	4112343	1975-12-09	1975-12-09 00:00:00	1975-12-20	1975-12-20 00:00:00	32020		\N	214087	0	195662009	4112343		0
54489	3226	40481087	1976-10-02	1976-10-02 00:00:00	1976-10-09	1976-10-09 00:00:00	32020		\N	214493	0	444814009	40481087		0
54697	3237	378419	2006-04-26	2006-04-26 00:00:00	\N	\N	32020		\N	215200	0	26929004	378419		0
54867	3248	40481087	1999-05-13	1999-05-13 00:00:00	1999-05-27	1999-05-27 00:00:00	32020		\N	215855	0	444814009	40481087		0
65590	3879	40481087	1976-01-21	1976-01-21 00:00:00	1976-02-04	1976-02-04 00:00:00	32020		\N	257666	0	444814009	40481087		0
65787	3890	40481087	1969-06-24	1969-06-24 00:00:00	1969-07-01	1969-07-01 00:00:00	32020		\N	258550	0	444814009	40481087		0
55371	3279	372328	1956-05-03	1956-05-03 00:00:00	1956-09-04	1956-09-04 00:00:00	32020		\N	217889	0	65363002	372328		0
55541	3289	260139	2007-04-04	2007-04-04 00:00:00	2007-04-11	2007-04-11 00:00:00	32020		\N	218486	0	10509002	260139		0
55724	3296	40481087	1959-05-30	1959-05-30 00:00:00	1959-06-20	1959-06-20 00:00:00	32020		\N	219063	0	444814009	40481087		0
55791	3301	4285898	1974-01-11	1974-01-11 00:00:00	\N	\N	32020		\N	219317	0	68496003	4285898		0
66607	3941	81151	2017-02-07	2017-02-07 00:00:00	2017-02-28	2017-02-28 00:00:00	32020		\N	261997	0	44465007	81151		0
56249	3334	4059173	1946-10-20	1946-10-20 00:00:00	1947-01-18	1947-01-18 00:00:00	32020		\N	221157	0	16114001	4059173		0
57198	3394	80180	1999-10-09	1999-10-09 00:00:00	\N	\N	32020		\N	225177	0	396275006	80180		0
56393	3342	4112343	1936-02-06	1936-02-06 00:00:00	1936-02-16	1936-02-16 00:00:00	32020		\N	221548	0	195662009	4112343		0
56538	3353	40481087	1942-11-03	1942-11-03 00:00:00	1942-11-17	1942-11-17 00:00:00	32020		\N	222408	0	444814009	40481087		0
67289	3976	40481087	2005-04-16	2005-04-16 00:00:00	2005-05-07	2005-05-07 00:00:00	32020		\N	264369	0	444814009	40481087		0
56901	3376	4112343	1981-03-28	1981-03-28 00:00:00	1981-04-05	1981-04-05 00:00:00	32020		\N	224028	0	195662009	4112343		0
57010	3382	4283893	1991-11-27	1991-11-27 00:00:00	1991-12-25	1991-12-25 00:00:00	32020		\N	224418	0	36971009	4283893		0
57119	3389	372328	1961-01-18	1961-01-18 00:00:00	1961-02-01	1961-02-01 00:00:00	32020		\N	224782	0	65363002	372328		0
57400	3407	40481087	2002-02-05	2002-02-05 00:00:00	2002-02-19	2002-02-19 00:00:00	32020		\N	225934	0	444814009	40481087		0
57544	3414	40481087	2000-09-16	2000-09-16 00:00:00	2000-10-07	2000-10-07 00:00:00	32020		\N	226487	0	444814009	40481087		0
57720	3423	4155034	1989-12-02	1989-12-02 00:00:00	1989-12-16	1989-12-16 00:00:00	32020		\N	227094	0	283371005	4155034		0
57882	3434	4112343	1994-05-20	1994-05-20 00:00:00	1994-05-27	1994-05-27 00:00:00	32020		\N	227728	0	195662009	4112343		0
58018	3439	260139	1972-06-20	1972-06-20 00:00:00	1972-07-04	1972-07-04 00:00:00	32020		\N	228142	0	10509002	260139		0
58170	3444	40481087	2018-01-14	2018-01-14 00:00:00	2018-01-21	2018-01-21 00:00:00	32020		\N	228590	0	444814009	40481087		0
47798	2837	4112343	2018-10-18	2018-10-18 00:00:00	2018-10-27	2018-10-27 00:00:00	32020		\N	188464	0	195662009	4112343		0
58456	3462	4112343	1996-08-23	1996-08-23 00:00:00	1996-08-30	1996-08-30 00:00:00	32020		\N	229734	0	195662009	4112343		0
69279	4101	4116491	1983-02-21	1983-02-21 00:00:00	1983-04-04	1983-04-04 00:00:00	32020		\N	272532	0	301011002	4116491		0
48292	2862	260139	2008-10-08	2008-10-08 00:00:00	2008-10-15	2008-10-15 00:00:00	32020		\N	190271	0	10509002	260139		0
48450	2869	81151	1951-11-18	1951-11-18 00:00:00	1951-12-09	1951-12-09 00:00:00	32020		\N	190821	0	44465007	81151		0
69736	4125	40481087	2009-10-05	2009-10-05 00:00:00	2009-10-12	2009-10-12 00:00:00	32020		\N	274246	0	444814009	40481087		0
70002	4142	78272	1998-12-12	1998-12-12 00:00:00	1999-01-02	1999-01-02 00:00:00	32020		\N	275291	0	70704007	78272		0
59463	3527	260139	1969-06-03	1969-06-03 00:00:00	1969-06-17	1969-06-17 00:00:00	32020		\N	234019	0	10509002	260139		0
59734	3539	372328	1984-09-15	1984-09-15 00:00:00	1984-11-16	1984-11-16 00:00:00	32020		\N	235084	0	65363002	372328		0
59918	3550	4112343	1992-07-23	1992-07-23 00:00:00	1992-07-31	1992-07-31 00:00:00	32020		\N	235727	0	195662009	4112343		0
60070	3559	4112343	1978-07-31	1978-07-31 00:00:00	1978-08-08	1978-08-08 00:00:00	32020		\N	236267	0	195662009	4112343		0
60207	3565	40481087	1965-06-06	1965-06-06 00:00:00	1965-06-20	1965-06-20 00:00:00	32020		\N	236727	0	444814009	40481087		0
60354	3571	40481087	2004-11-18	2004-11-18 00:00:00	2004-12-02	2004-12-02 00:00:00	32020		\N	237313	0	444814009	40481087		0
49958	2951	80180	1999-12-26	1999-12-26 00:00:00	\N	\N	32020		\N	197068	0	396275006	80180		0
60694	3593	192671	1988-03-27	1988-03-27 00:00:00	\N	\N	32020		\N	238707	0	K92.2	35208414		0
60790	3598	317576	1996-04-07	1996-04-07 00:00:00	\N	\N	32020		\N	239010	0	53741008	317576		0
61059	3614	4112343	2010-11-07	2010-11-07 00:00:00	2010-11-15	2010-11-15 00:00:00	32020		\N	240145	0	195662009	4112343		0
61142	3618	40481087	1922-07-05	1922-07-05 00:00:00	1922-07-26	1922-07-26 00:00:00	32020		\N	240424	0	444814009	40481087		0
61312	3624	40481087	1982-07-08	1982-07-08 00:00:00	1982-07-22	1982-07-22 00:00:00	32020		\N	240993	0	444814009	40481087		0
61474	3633	378001	2004-10-21	2004-10-21 00:00:00	2004-11-20	2004-11-20 00:00:00	32020		\N	241653	0	62106007	378001		0
51109	3026	260139	1955-03-25	1955-03-25 00:00:00	1955-04-08	1955-04-08 00:00:00	32020		\N	201803	0	10509002	260139		0
72377	4295	260139	2009-04-09	2009-04-09 00:00:00	2009-04-23	2009-04-23 00:00:00	32020		\N	285045	0	10509002	260139		0
62082	3666	260139	1991-08-22	1991-08-22 00:00:00	1991-09-05	1991-09-05 00:00:00	32020		\N	243860	0	10509002	260139		0
62181	3672	440448	1986-03-13	1986-03-13 00:00:00	\N	\N	32020		\N	244327	0	74400008	440448		0
72929	4333	40481087	1997-05-03	1997-05-03 00:00:00	1997-05-10	1997-05-10 00:00:00	32020		\N	287427	0	444814009	40481087		0
62544	3695	4218389	2008-03-29	2008-03-29 00:00:00	2008-04-19	2008-04-19 00:00:00	32020		\N	245607	0	39848009	4218389		0
62630	3699	28060	1974-11-29	1974-11-29 00:00:00	1974-12-10	1974-12-10 00:00:00	32020		\N	245896	0	43878008	28060		0
62882	3714	4230399	2007-02-18	2007-02-18 00:00:00	2007-04-19	2007-04-19 00:00:00	32020		\N	246787	0	359817006	4230399		0
62945	3718	81151	2003-12-03	2003-12-03 00:00:00	2003-12-17	2003-12-17 00:00:00	32020		\N	247145	0	44465007	81151		0
73738	4381	40481087	1975-10-26	1975-10-26 00:00:00	1975-11-16	1975-11-16 00:00:00	32020		\N	291104	0	444814009	40481087		0
73877	4388	372328	1968-05-11	1968-05-11 00:00:00	1968-07-27	1968-07-27 00:00:00	32020		\N	291633	0	65363002	372328		0
63568	3754	40481087	1971-03-19	1971-03-19 00:00:00	1971-04-02	1971-04-02 00:00:00	32020		\N	249443	0	444814009	40481087		0
74252	4409	4112343	2011-10-04	2011-10-04 00:00:00	2011-10-17	2011-10-17 00:00:00	32020		\N	293107	0	195662009	4112343		0
53257	3157	4294548	2008-01-02	2008-01-02 00:00:00	2008-04-16	2008-04-16 00:00:00	32020		\N	209835	0	75498004	4294548		0
63944	3778	4266809	2000-01-14	2000-01-14 00:00:00	\N	\N	32020		\N	251060	0	397881000	4266809		0
53599	3176	260139	1997-06-30	1997-06-30 00:00:00	1997-07-07	1997-07-07 00:00:00	32020		\N	211150	0	10509002	260139		0
53696	3178	198809	2014-03-13	2014-03-13 00:00:00	2014-03-14	2014-03-14 00:00:00	32020		\N	211388	0	65275009	198809		0
53807	3183	40481087	1996-07-31	1996-07-31 00:00:00	1996-08-14	1996-08-14 00:00:00	32020		\N	211908	0	444814009	40481087		0
54074	3201	4113008	1973-04-19	1973-04-19 00:00:00	1973-05-10	1973-05-10 00:00:00	32020		\N	212918	0	284549007	4113008		0
54133	3207	40481087	2001-03-03	2001-03-03 00:00:00	2001-03-17	2001-03-17 00:00:00	32020		\N	213175	0	444814009	40481087		0
54368	3221	28060	1986-03-01	1986-03-01 00:00:00	1986-03-14	1986-03-14 00:00:00	32020		\N	214109	0	43878008	28060		0
54490	3226	4113008	2008-05-26	2008-05-26 00:00:00	2008-06-16	2008-06-16 00:00:00	32020		\N	214451	0	284549007	4113008		0
54698	3237	81151	1951-08-21	1951-08-21 00:00:00	1951-09-04	1951-09-04 00:00:00	32020		\N	215149	0	44465007	81151		0
54868	3248	4218389	1961-05-04	1961-05-04 00:00:00	1961-06-08	1961-06-08 00:00:00	32020		\N	215878	0	39848009	4218389		0
65591	3879	4230399	2003-06-03	2003-06-03 00:00:00	2003-08-02	2003-08-02 00:00:00	32020		\N	257728	0	359817006	4230399		0
65788	3890	40481087	1997-11-20	1997-11-20 00:00:00	1997-12-11	1997-12-11 00:00:00	32020		\N	258593	0	444814009	40481087		0
55372	3279	40481087	1967-07-15	1967-07-15 00:00:00	1967-08-05	1967-08-05 00:00:00	32020		\N	217901	0	444814009	40481087		0
55542	3289	4310024	1993-01-12	1993-01-12 00:00:00	\N	\N	32020		\N	218455	0	424802006	4310024		0
55728	3298	81151	2018-06-28	2018-06-28 00:00:00	2018-07-26	2018-07-26 00:00:00	32020		\N	219146	0	44465007	81151		0
55805	3304	40481087	1997-09-09	1997-09-09 00:00:00	1997-09-23	1997-09-23 00:00:00	32020		\N	219454	0	444814009	40481087		0
66608	3941	40481087	2006-03-01	2006-03-01 00:00:00	2006-03-08	2006-03-08 00:00:00	32020		\N	262049	0	444814009	40481087		0
56250	3334	40481087	1981-08-03	1981-08-03 00:00:00	1981-08-10	1981-08-10 00:00:00	32020		\N	221146	0	444814009	40481087		0
56394	3342	40481087	2015-11-08	2015-11-08 00:00:00	2015-11-15	2015-11-15 00:00:00	32020		\N	221637	0	444814009	40481087		0
56539	3353	4112343	1939-03-18	1939-03-18 00:00:00	1939-03-31	1939-03-31 00:00:00	32020		\N	222354	0	195662009	4112343		0
67290	3976	40481087	2002-12-09	2002-12-09 00:00:00	2002-12-23	2002-12-23 00:00:00	32020		\N	264359	0	444814009	40481087		0
56902	3376	4294548	1979-09-12	1979-09-12 00:00:00	1979-10-17	1979-10-17 00:00:00	32020		\N	223994	0	75498004	4294548		0
57011	3382	40481087	2018-06-24	2018-06-24 00:00:00	2018-07-15	2018-07-15 00:00:00	32020		\N	224463	0	444814009	40481087		0
57120	3389	4112343	1998-02-12	1998-02-12 00:00:00	1998-02-21	1998-02-21 00:00:00	32020		\N	224778	0	195662009	4112343		0
57401	3407	4112343	1984-01-31	1984-01-31 00:00:00	1984-02-08	1984-02-08 00:00:00	32020		\N	225982	0	195662009	4112343		0
57545	3414	260139	1969-08-17	1969-08-17 00:00:00	1969-08-31	1969-08-31 00:00:00	32020		\N	226446	0	10509002	260139		0
57721	3423	28060	1993-08-03	1993-08-03 00:00:00	1993-08-15	1993-08-15 00:00:00	32020		\N	227057	0	43878008	28060		0
57883	3434	40479768	1951-06-06	1951-06-06 00:00:00	1951-08-12	1951-08-12 00:00:00	32020		\N	227681	0	444470001	40479768		0
58019	3439	4112343	1957-08-16	1957-08-16 00:00:00	1957-08-29	1957-08-29 00:00:00	32020		\N	228208	0	195662009	4112343		0
58171	3444	260139	2019-03-03	2019-03-03 00:00:00	2019-03-17	2019-03-17 00:00:00	32020		\N	228579	0	10509002	260139		0
47804	2839	40481087	2001-09-25	2001-09-25 00:00:00	2001-10-02	2001-10-02 00:00:00	32020		\N	188536	0	444814009	40481087		0
58457	3462	4294548	1961-04-29	1961-04-29 00:00:00	1961-12-16	1961-12-16 00:00:00	32020		\N	229708	0	75498004	4294548		0
69280	4101	4112343	1968-11-05	1968-11-05 00:00:00	1968-11-17	1968-11-17 00:00:00	32020		\N	272509	0	195662009	4112343		0
48293	2862	28060	1968-01-05	1968-01-05 00:00:00	1968-01-16	1968-01-16 00:00:00	32020		\N	190282	0	43878008	28060		0
48451	2869	313217	2009-12-15	2009-12-15 00:00:00	\N	\N	32020		\N	190830	0	49436004	313217		0
69737	4125	40481087	1994-03-15	1994-03-15 00:00:00	1994-03-22	1994-03-22 00:00:00	32020		\N	274217	0	444814009	40481087		0
70003	4142	4112343	2007-08-02	2007-08-02 00:00:00	2007-08-09	2007-08-09 00:00:00	32020		\N	275307	0	195662009	4112343		0
59464	3527	81151	1974-02-19	1974-02-19 00:00:00	1974-03-12	1974-03-12 00:00:00	32020		\N	234049	0	44465007	81151		0
59735	3539	80180	2016-06-21	2016-06-21 00:00:00	\N	\N	32020		\N	235093	0	396275006	80180		0
59919	3550	4027663	2009-07-15	2009-07-15 00:00:00	\N	\N	32020		\N	235733	0	13200003	4027663		0
60071	3559	40481087	1961-07-14	1961-07-14 00:00:00	1961-07-28	1961-07-28 00:00:00	32020		\N	236275	0	444814009	40481087		0
60208	3565	4112343	1986-06-03	1986-06-03 00:00:00	1986-06-10	1986-06-10 00:00:00	32020		\N	236730	0	195662009	4112343		0
60355	3571	40481087	1984-08-06	1984-08-06 00:00:00	1984-08-20	1984-08-20 00:00:00	32020		\N	237379	0	444814009	40481087		0
49959	2951	4059173	1963-10-21	1963-10-21 00:00:00	1964-01-19	1964-01-19 00:00:00	32020		\N	197007	0	16114001	4059173		0
60695	3593	4112343	1974-06-08	1974-06-08 00:00:00	1974-06-19	1974-06-19 00:00:00	32020		\N	238674	0	195662009	4112343		0
60791	3598	40481087	1964-01-07	1964-01-07 00:00:00	1964-01-28	1964-01-28 00:00:00	32020		\N	238949	0	444814009	40481087		0
61060	3614	372328	1953-12-01	1953-12-01 00:00:00	1954-04-11	1954-04-11 00:00:00	32020		\N	240118	0	65363002	372328		0
61143	3618	4112343	1961-11-04	1961-11-04 00:00:00	1961-11-15	1961-11-15 00:00:00	32020		\N	240452	0	195662009	4112343		0
61313	3624	4283893	1953-10-01	1953-10-01 00:00:00	1953-12-03	1953-12-03 00:00:00	32020		\N	240990	0	36971009	4283893		0
61475	3633	40481087	2012-07-10	2012-07-10 00:00:00	2012-07-24	2012-07-24 00:00:00	32020		\N	241689	0	444814009	40481087		0
51110	3026	4294548	2003-07-10	2003-07-10 00:00:00	2003-09-04	2003-09-04 00:00:00	32020		\N	201741	0	75498004	4294548		0
72378	4295	40481087	2019-01-16	2019-01-16 00:00:00	2019-01-23	2019-01-23 00:00:00	32020		\N	285064	0	444814009	40481087		0
62083	3666	4294548	1989-11-04	1989-11-04 00:00:00	1989-12-09	1989-12-09 00:00:00	32020		\N	243882	0	75498004	4294548		0
62182	3672	257012	2003-06-29	2003-06-29 00:00:00	\N	\N	32020		\N	244275	0	40055000	257012		0
72930	4333	4027663	1982-08-20	1982-08-20 00:00:00	\N	\N	32020		\N	287399	0	13200003	4027663		0
62545	3695	4112343	2013-05-12	2013-05-12 00:00:00	2013-05-21	2013-05-21 00:00:00	32020		\N	245581	0	195662009	4112343		0
62631	3699	40481087	2015-04-12	2015-04-12 00:00:00	2015-05-03	2015-05-03 00:00:00	32020		\N	245914	0	444814009	40481087		0
62883	3714	4218389	1928-07-15	1928-07-15 00:00:00	1928-08-05	1928-08-05 00:00:00	32020		\N	246843	0	39848009	4218389		0
62946	3718	40481087	1987-12-05	1987-12-05 00:00:00	1987-12-12	1987-12-12 00:00:00	32020		\N	247096	0	444814009	40481087		0
73739	4381	4112343	1965-02-28	1965-02-28 00:00:00	1965-03-10	1965-03-10 00:00:00	32020		\N	291147	0	195662009	4112343		0
73878	4388	80180	2007-12-28	2007-12-28 00:00:00	\N	\N	32020		\N	291742	0	396275006	80180		0
63569	3754	4112343	1966-06-28	1966-06-28 00:00:00	1966-07-10	1966-07-10 00:00:00	32020		\N	249421	0	195662009	4112343		0
74253	4409	4283893	2008-09-18	2008-09-18 00:00:00	2008-12-18	2008-12-18 00:00:00	32020		\N	293056	0	36971009	4283893		0
53258	3157	260139	1984-06-17	1984-06-17 00:00:00	1984-07-01	1984-07-01 00:00:00	32020		\N	209845	0	10509002	260139		0
63945	3778	80180	2000-01-14	2000-01-14 00:00:00	\N	\N	32020		\N	251060	0	396275006	80180		0
53600	3176	260139	1979-04-28	1979-04-28 00:00:00	1979-05-12	1979-05-12 00:00:00	32020		\N	211084	0	10509002	260139		0
53697	3178	196456	2014-03-13	2014-03-13 00:00:00	2014-03-14	2014-03-14 00:00:00	32020		\N	211388	0	235919008	196456		0
53808	3183	4294548	1983-03-06	1983-03-06 00:00:00	1983-03-20	1983-03-20 00:00:00	32020		\N	211920	0	75498004	4294548		0
54075	3201	381316	1984-12-26	1984-12-26 00:00:00	\N	\N	32020		\N	212903	0	230690007	381316		0
54134	3207	40481087	1972-06-19	1972-06-19 00:00:00	1972-06-26	1972-06-26 00:00:00	32020		\N	213156	0	444814009	40481087		0
54369	3221	260139	1977-02-07	1977-02-07 00:00:00	1977-02-14	1977-02-14 00:00:00	32020		\N	214093	0	10509002	260139		0
54491	3226	372328	1983-09-13	1983-09-13 00:00:00	1984-02-19	1984-02-19 00:00:00	32020		\N	214498	0	65363002	372328		0
54699	3237	40481087	1950-03-05	1950-03-05 00:00:00	1950-03-26	1950-03-26 00:00:00	32020		\N	215187	0	444814009	40481087		0
54869	3248	78272	1946-06-08	1946-06-08 00:00:00	1946-06-22	1946-06-22 00:00:00	32020		\N	215927	0	70704007	78272		0
65592	3879	81151	1946-08-21	1946-08-21 00:00:00	1946-09-25	1946-09-25 00:00:00	32020		\N	257655	0	44465007	81151		0
65789	3890	40481087	1953-08-23	1953-08-23 00:00:00	1953-09-13	1953-09-13 00:00:00	32020		\N	258547	0	444814009	40481087		0
55373	3280	4218389	1952-10-07	1952-10-07 00:00:00	1952-11-04	1952-11-04 00:00:00	32020		\N	218033	0	39848009	4218389		0
55543	3290	4283893	1974-12-05	1974-12-05 00:00:00	1975-08-28	1975-08-28 00:00:00	32020		\N	218592	0	36971009	4283893		0
55729	3298	4112343	1972-12-10	1972-12-10 00:00:00	1972-12-20	1972-12-20 00:00:00	32020		\N	219125	0	195662009	4112343		0
55806	3304	4152936	1986-05-29	1986-05-29 00:00:00	1986-06-19	1986-06-19 00:00:00	32020		\N	219486	0	283385000	4152936		0
66609	3941	40481087	1992-01-14	1992-01-14 00:00:00	1992-01-21	1992-01-21 00:00:00	32020		\N	262047	0	444814009	40481087		0
56251	3334	80180	1981-08-07	1981-08-07 00:00:00	\N	\N	32020		\N	221146	0	396275006	80180		0
56395	3342	4112343	1978-04-19	1978-04-19 00:00:00	1978-04-29	1978-04-29 00:00:00	32020		\N	221633	0	195662009	4112343		0
56540	3353	81151	1954-03-16	1954-03-16 00:00:00	1954-04-20	1954-04-20 00:00:00	32020		\N	222427	0	44465007	81151		0
67291	3976	260139	1976-07-09	1976-07-09 00:00:00	1976-07-16	1976-07-16 00:00:00	32020		\N	264338	0	10509002	260139		0
56903	3376	80180	1994-05-06	1994-05-06 00:00:00	\N	\N	32020		\N	224034	0	396275006	80180		0
57012	3382	4112343	1969-10-03	1969-10-03 00:00:00	1969-10-10	1969-10-10 00:00:00	32020		\N	224436	0	195662009	4112343		0
57121	3389	4278672	1976-07-28	1976-07-28 00:00:00	1976-09-26	1976-09-26 00:00:00	32020		\N	224744	0	65966004	4278672		0
57402	3407	4310024	2003-11-11	2003-11-11 00:00:00	\N	\N	32020		\N	225943	0	424802006	4310024		0
57546	3414	4112343	2001-08-13	2001-08-13 00:00:00	2001-08-23	2001-08-23 00:00:00	32020		\N	226488	0	195662009	4112343		0
57722	3423	40481087	2004-02-19	2004-02-19 00:00:00	2004-03-11	2004-03-11 00:00:00	32020		\N	227041	0	444814009	40481087		0
57884	3434	378001	1949-05-17	1949-05-17 00:00:00	1949-06-16	1949-06-16 00:00:00	32020		\N	227680	0	62106007	378001		0
58020	3439	4112343	1968-05-04	1968-05-04 00:00:00	1968-05-11	1968-05-11 00:00:00	32020		\N	228209	0	195662009	4112343		0
58172	3444	40481087	1956-05-10	1956-05-10 00:00:00	1956-05-31	1956-05-31 00:00:00	32020		\N	228520	0	444814009	40481087		0
47805	2839	378001	2010-11-19	2010-11-19 00:00:00	2011-01-18	2011-01-18 00:00:00	32020		\N	188535	0	62106007	378001		0
58458	3462	4112343	1980-11-09	1980-11-09 00:00:00	1980-11-19	1980-11-19 00:00:00	32020		\N	229712	0	195662009	4112343		0
81009	4805	192671	2003-08-18	2003-08-18 00:00:00	\N	\N	32020		\N	319699	0	K92.2	35208414		0
69281	4101	4112343	2016-05-21	2016-05-21 00:00:00	2016-06-01	2016-06-01 00:00:00	32020		\N	272526	0	195662009	4112343		0
48294	2862	260139	1994-03-16	1994-03-16 00:00:00	1994-03-23	1994-03-23 00:00:00	32020		\N	190273	0	10509002	260139		0
48452	2869	81151	1974-03-04	1974-03-04 00:00:00	1974-03-25	1974-03-25 00:00:00	32020		\N	190826	0	44465007	81151		0
69738	4125	40481087	1983-11-30	1983-11-30 00:00:00	1983-12-21	1983-12-21 00:00:00	32020		\N	274230	0	444814009	40481087		0
70004	4142	40481087	2000-12-19	2000-12-19 00:00:00	2000-12-26	2000-12-26 00:00:00	32020		\N	275324	0	444814009	40481087		0
59465	3527	40481087	2002-07-10	2002-07-10 00:00:00	2002-07-24	2002-07-24 00:00:00	32020		\N	234034	0	444814009	40481087		0
59736	3539	81151	2015-12-30	2015-12-30 00:00:00	2016-01-20	2016-01-20 00:00:00	32020		\N	235093	0	44465007	81151		0
59920	3550	4296205	2005-08-12	2005-08-12 00:00:00	2005-09-09	2005-09-09 00:00:00	32020		\N	235757	0	403191005	4296205		0
60072	3559	40481087	2002-09-17	2002-09-17 00:00:00	2002-10-01	2002-10-01 00:00:00	32020		\N	236295	0	444814009	40481087		0
60209	3565	40481087	2005-10-16	2005-10-16 00:00:00	2005-10-23	2005-10-23 00:00:00	32020		\N	236796	0	444814009	40481087		0
60356	3571	257012	2000-11-15	2000-11-15 00:00:00	\N	\N	32020		\N	237419	0	40055000	257012		0
49960	2951	28060	1962-03-31	1962-03-31 00:00:00	1962-04-09	1962-04-09 00:00:00	32020		\N	197064	0	43878008	28060		0
60696	3593	4112343	1960-11-20	1960-11-20 00:00:00	1960-11-27	1960-11-27 00:00:00	32020		\N	238645	0	195662009	4112343		0
60792	3598	372328	1948-07-28	1948-07-28 00:00:00	1949-03-06	1949-03-06 00:00:00	32020		\N	239014	0	65363002	372328		0
61061	3614	260139	1990-10-06	1990-10-06 00:00:00	1990-10-13	1990-10-13 00:00:00	32020		\N	240105	0	10509002	260139		0
61144	3618	40481087	1916-12-21	1916-12-21 00:00:00	1916-12-28	1916-12-28 00:00:00	32020		\N	240394	0	444814009	40481087		0
61314	3624	40481087	1948-10-30	1948-10-30 00:00:00	1948-11-20	1948-11-20 00:00:00	32020		\N	240964	0	444814009	40481087		0
61476	3633	40481087	1995-07-31	1995-07-31 00:00:00	1995-08-07	1995-08-07 00:00:00	32020		\N	241688	0	444814009	40481087		0
51111	3026	260139	1995-11-03	1995-11-03 00:00:00	1995-11-17	1995-11-17 00:00:00	32020		\N	201768	0	10509002	260139		0
72379	4295	260139	2017-03-02	2017-03-02 00:00:00	2017-03-09	2017-03-09 00:00:00	32020		\N	285063	0	10509002	260139		0
62084	3666	40481087	1984-06-27	1984-06-27 00:00:00	1984-07-04	1984-07-04 00:00:00	32020		\N	243914	0	444814009	40481087		0
62183	3672	260139	1982-08-27	1982-08-27 00:00:00	1982-09-10	1982-09-10 00:00:00	32020		\N	244305	0	10509002	260139		0
72932	4333	40481087	1956-01-19	1956-01-19 00:00:00	1956-01-26	1956-01-26 00:00:00	32020		\N	287354	0	444814009	40481087		0
62546	3695	80180	2013-11-17	2013-11-17 00:00:00	\N	\N	32020		\N	245581	0	396275006	80180		0
62632	3699	4109685	1994-10-12	1994-10-12 00:00:00	1994-11-02	1994-11-02 00:00:00	32020		\N	245928	0	284551006	4109685		0
62884	3714	260139	1924-06-07	1924-06-07 00:00:00	1924-06-14	1924-06-14 00:00:00	32020		\N	246852	0	10509002	260139		0
62947	3718	4112343	1987-03-11	1987-03-11 00:00:00	1987-03-22	1987-03-22 00:00:00	32020		\N	247137	0	195662009	4112343		0
73740	4381	40481087	1988-12-16	1988-12-16 00:00:00	1988-12-23	1988-12-23 00:00:00	32020		\N	291082	0	444814009	40481087		0
73879	4388	40481087	1990-11-10	1990-11-10 00:00:00	1990-11-24	1990-11-24 00:00:00	32020		\N	291662	0	444814009	40481087		0
63570	3754	378001	1989-05-15	1989-05-15 00:00:00	1989-07-14	1989-07-14 00:00:00	32020		\N	249420	0	62106007	378001		0
74254	4409	4112343	1983-09-06	1983-09-06 00:00:00	1983-09-13	1983-09-13 00:00:00	32020		\N	293083	0	195662009	4112343		0
53259	3157	40481087	1985-08-09	1985-08-09 00:00:00	1985-08-23	1985-08-23 00:00:00	32020		\N	209846	0	444814009	40481087		0
63946	3778	4285898	1999-12-15	1999-12-15 00:00:00	\N	\N	32020		\N	251060	0	68496003	4285898		0
53601	3176	4112343	2012-03-03	2012-03-03 00:00:00	2012-03-16	2012-03-16 00:00:00	32020		\N	211100	0	195662009	4112343		0
53698	3178	40481087	1967-01-25	1967-01-25 00:00:00	1967-02-15	1967-02-15 00:00:00	32020		\N	211405	0	444814009	40481087		0
53809	3183	28060	1992-05-27	1992-05-27 00:00:00	1992-06-09	1992-06-09 00:00:00	32020		\N	211931	0	43878008	28060		0
54076	3201	195588	1968-08-11	1968-08-11 00:00:00	1968-09-15	1968-09-15 00:00:00	32020		\N	212894	0	38822007	195588		0
54135	3207	40481087	1965-10-03	1965-10-03 00:00:00	1965-10-17	1965-10-17 00:00:00	32020		\N	213213	0	444814009	40481087		0
54370	3221	260139	1967-09-09	1967-09-09 00:00:00	1967-09-23	1967-09-23 00:00:00	32020		\N	214061	0	10509002	260139		0
54492	3227	40481087	1980-03-07	1980-03-07 00:00:00	1980-03-14	1980-03-14 00:00:00	32020		\N	214528	0	444814009	40481087		0
54700	3237	4296205	1986-05-08	1986-05-08 00:00:00	1986-06-05	1986-06-05 00:00:00	32020		\N	215154	0	403191005	4296205		0
54870	3248	28060	2007-04-03	2007-04-03 00:00:00	2007-04-15	2007-04-15 00:00:00	32020		\N	215857	0	43878008	28060		0
65593	3879	372328	1941-02-06	1941-02-06 00:00:00	1941-02-20	1941-02-20 00:00:00	32020		\N	257719	0	65363002	372328		0
65790	3890	4112343	1995-07-04	1995-07-04 00:00:00	1995-07-12	1995-07-12 00:00:00	32020		\N	258554	0	195662009	4112343		0
55374	3280	40481087	1967-06-02	1967-06-02 00:00:00	1967-06-16	1967-06-16 00:00:00	32020		\N	217975	0	444814009	40481087		0
55544	3290	375671	2006-05-07	2006-05-07 00:00:00	2006-07-06	2006-07-06 00:00:00	32020		\N	218620	0	62564004	375671		0
55730	3298	4152936	1972-08-09	1972-08-09 00:00:00	1972-08-30	1972-08-30 00:00:00	32020		\N	219143	0	283385000	4152936		0
55807	3304	4156265	1964-11-29	1964-11-29 00:00:00	1964-12-20	1964-12-20 00:00:00	32020		\N	219483	0	370247008	4156265		0
66610	3941	195588	1993-02-16	1993-02-16 00:00:00	1993-03-22	1993-03-22 00:00:00	32020		\N	262000	0	38822007	195588		0
56252	3334	40481087	1955-04-12	1955-04-12 00:00:00	1955-05-03	1955-05-03 00:00:00	32020		\N	221175	0	444814009	40481087		0
56396	3342	40481087	1936-12-22	1936-12-22 00:00:00	1937-01-12	1937-01-12 00:00:00	32020		\N	221605	0	444814009	40481087		0
56541	3353	260139	1976-11-01	1976-11-01 00:00:00	1976-11-08	1976-11-08 00:00:00	32020		\N	222382	0	10509002	260139		0
67292	3976	81151	1976-06-08	1976-06-08 00:00:00	1976-06-29	1976-06-29 00:00:00	32020		\N	264349	0	44465007	81151		0
56904	3376	40481087	1961-03-21	1961-03-21 00:00:00	1961-03-28	1961-03-28 00:00:00	32020		\N	223928	0	444814009	40481087		0
57013	3382	40481087	1995-10-11	1995-10-11 00:00:00	1995-10-25	1995-10-25 00:00:00	32020		\N	224419	0	444814009	40481087		0
57135	3391	28060	1990-09-09	1990-09-09 00:00:00	1990-09-17	1990-09-17 00:00:00	32020		\N	224926	0	43878008	28060		0
57403	3407	4152936	2006-05-30	2006-05-30 00:00:00	2006-06-20	2006-06-20 00:00:00	32020		\N	225978	0	283385000	4152936		0
57547	3414	40481087	2018-06-03	2018-06-03 00:00:00	2018-06-24	2018-06-24 00:00:00	32020		\N	226477	0	444814009	40481087		0
57723	3423	378001	1977-01-04	1977-01-04 00:00:00	1977-03-05	1977-03-05 00:00:00	32020		\N	227091	0	62106007	378001		0
57885	3434	260139	1968-09-06	1968-09-06 00:00:00	1968-09-13	1968-09-13 00:00:00	32020		\N	227726	0	10509002	260139		0
58021	3439	28060	1999-07-23	1999-07-23 00:00:00	1999-07-30	1999-07-30 00:00:00	32020		\N	228211	0	43878008	28060		0
58173	3444	40481087	1949-09-03	1949-09-03 00:00:00	1949-09-10	1949-09-10 00:00:00	32020		\N	228534	0	444814009	40481087		0
47806	2839	260139	2012-11-06	2012-11-06 00:00:00	2012-11-13	2012-11-13 00:00:00	32020		\N	188521	0	10509002	260139		0
58459	3462	4112343	1990-06-15	1990-06-15 00:00:00	1990-06-22	1990-06-22 00:00:00	32020		\N	229683	0	195662009	4112343		0
69282	4101	4112343	1961-08-21	1961-08-21 00:00:00	1961-08-30	1961-08-30 00:00:00	32020		\N	272473	0	195662009	4112343		0
48295	2862	40481087	1998-10-18	1998-10-18 00:00:00	1998-11-07	1998-11-07 00:00:00	32020		\N	190265	0	444814009	40481087		0
48453	2869	260139	1991-05-06	1991-05-06 00:00:00	1991-05-20	1991-05-20 00:00:00	32020		\N	190863	0	10509002	260139		0
69739	4125	40481087	1974-04-22	1974-04-22 00:00:00	1974-05-13	1974-05-13 00:00:00	32020		\N	274261	0	444814009	40481087		0
70005	4142	40481087	2006-11-23	2006-11-23 00:00:00	2006-12-14	2006-12-14 00:00:00	32020		\N	275285	0	444814009	40481087		0
59466	3527	4112343	2018-08-01	2018-08-01 00:00:00	2018-08-08	2018-08-08 00:00:00	32020		\N	234135	0	195662009	4112343		0
59737	3540	40481087	1983-11-09	1983-11-09 00:00:00	1983-11-30	1983-11-30 00:00:00	32020		\N	235113	0	444814009	40481087		0
59921	3550	40481087	1990-01-26	1990-01-26 00:00:00	1990-02-09	1990-02-09 00:00:00	32020		\N	235726	0	444814009	40481087		0
60073	3559	40481087	1969-04-24	1969-04-24 00:00:00	1969-05-08	1969-05-08 00:00:00	32020		\N	236245	0	444814009	40481087		0
60210	3565	439777	1976-02-25	1976-02-25 00:00:00	\N	\N	32020		\N	236785	0	271737000	439777		0
60357	3571	4112343	2014-04-15	2014-04-15 00:00:00	2014-04-26	2014-04-26 00:00:00	32020		\N	237315	0	195662009	4112343		0
49961	2951	40481087	1984-12-02	1984-12-02 00:00:00	1984-12-16	1984-12-16 00:00:00	32020		\N	197032	0	444814009	40481087		0
60697	3593	4266809	1988-02-29	1988-02-29 00:00:00	\N	\N	32020		\N	238688	0	397881000	4266809		0
60793	3598	40481087	1993-01-09	1993-01-09 00:00:00	1993-01-16	1993-01-16 00:00:00	32020		\N	238956	0	444814009	40481087		0
61062	3614	260139	1952-09-17	1952-09-17 00:00:00	1952-10-01	1952-10-01 00:00:00	32020		\N	240140	0	10509002	260139		0
61145	3618	4112343	1984-10-26	1984-10-26 00:00:00	1984-11-07	1984-11-07 00:00:00	32020		\N	240376	0	195662009	4112343		0
61315	3624	372328	1948-08-04	1948-08-04 00:00:00	1948-12-09	1948-12-09 00:00:00	32020		\N	240972	0	65363002	372328		0
61477	3633	40481087	2016-02-13	2016-02-13 00:00:00	2016-03-05	2016-03-05 00:00:00	32020		\N	241663	0	444814009	40481087		0
51112	3026	260139	1966-06-09	1966-06-09 00:00:00	1966-06-16	1966-06-16 00:00:00	32020		\N	201804	0	10509002	260139		0
72380	4295	4266809	2007-09-28	2007-09-28 00:00:00	\N	\N	32020		\N	285096	0	397881000	4266809		0
72543	4308	40481087	1981-10-07	1981-10-07 00:00:00	1981-10-28	1981-10-28 00:00:00	32020		\N	285824	0	444814009	40481087		0
62184	3672	40481087	1969-09-21	1969-09-21 00:00:00	1969-09-28	1969-09-28 00:00:00	32020		\N	244286	0	444814009	40481087		0
72965	4337	4294548	1978-12-04	1978-12-04 00:00:00	1979-02-26	1979-02-26 00:00:00	32020		\N	287590	0	75498004	4294548		0
62547	3695	260139	1987-03-31	1987-03-31 00:00:00	1987-04-14	1987-04-14 00:00:00	32020		\N	245664	0	10509002	260139		0
62633	3699	439777	1999-07-08	1999-07-08 00:00:00	\N	\N	32020		\N	245930	0	271737000	439777		0
62885	3714	260139	1950-03-10	1950-03-10 00:00:00	1950-03-24	1950-03-24 00:00:00	32020		\N	246795	0	10509002	260139		0
62948	3718	4112343	1985-05-07	1985-05-07 00:00:00	1985-05-16	1985-05-16 00:00:00	32020		\N	247109	0	195662009	4112343		0
73741	4381	40481087	2007-02-09	2007-02-09 00:00:00	2007-02-16	2007-02-16 00:00:00	32020		\N	291073	0	444814009	40481087		0
73880	4388	378001	1987-06-11	1987-06-11 00:00:00	1987-08-10	1987-08-10 00:00:00	32020		\N	291640	0	62106007	378001		0
63571	3754	40481087	2011-01-18	2011-01-18 00:00:00	2011-02-01	2011-02-01 00:00:00	32020		\N	249555	0	444814009	40481087		0
74255	4409	4112343	1982-09-28	1982-09-28 00:00:00	1982-10-09	1982-10-09 00:00:00	32020		\N	293121	0	195662009	4112343		0
53260	3157	4266809	1986-05-12	1986-05-12 00:00:00	\N	\N	32020		\N	209846	0	397881000	4266809		0
63947	3778	4155034	2003-12-09	2003-12-09 00:00:00	2003-12-23	2003-12-23 00:00:00	32020		\N	251059	0	283371005	4155034		0
53602	3176	4146173	1998-02-27	1998-02-27 00:00:00	1998-03-29	1998-03-29 00:00:00	32020		\N	211199	0	307731004	4146173		0
53699	3178	40481087	1974-08-14	1974-08-14 00:00:00	1974-08-21	1974-08-21 00:00:00	32020		\N	211418	0	444814009	40481087		0
53810	3183	260139	1982-05-06	1982-05-06 00:00:00	1982-05-13	1982-05-13 00:00:00	32020		\N	211929	0	10509002	260139		0
54077	3201	40481087	1949-10-17	1949-10-17 00:00:00	1949-10-24	1949-10-24 00:00:00	32020		\N	212892	0	444814009	40481087		0
54136	3207	4112343	2011-12-21	2011-12-21 00:00:00	2011-12-29	2011-12-29 00:00:00	32020		\N	213183	0	195662009	4112343		0
54371	3221	4112343	2012-02-27	2012-02-27 00:00:00	2012-03-07	2012-03-07 00:00:00	32020		\N	214088	0	195662009	4112343		0
54493	3227	372328	1984-05-24	1984-05-24 00:00:00	1985-03-19	1985-03-19 00:00:00	32020		\N	214533	0	65363002	372328		0
54701	3237	40481087	1949-08-25	1949-08-25 00:00:00	1949-09-01	1949-09-01 00:00:00	32020		\N	215221	0	444814009	40481087		0
54871	3248	4112343	1963-05-07	1963-05-07 00:00:00	1963-05-15	1963-05-15 00:00:00	32020		\N	215845	0	195662009	4112343		0
65594	3879	260139	1984-10-05	1984-10-05 00:00:00	1984-10-12	1984-10-12 00:00:00	32020		\N	257744	0	10509002	260139		0
65791	3890	260139	1976-09-07	1976-09-07 00:00:00	1976-09-21	1976-09-21 00:00:00	32020		\N	258592	0	10509002	260139		0
55375	3280	4237458	1954-09-25	1954-09-25 00:00:00	1954-10-25	1954-10-25 00:00:00	32020		\N	218034	0	58150001	4237458		0
55545	3290	4155034	1997-12-06	1997-12-06 00:00:00	1997-12-20	1997-12-20 00:00:00	32020		\N	218619	0	283371005	4155034		0
55731	3298	40481087	2006-09-07	2006-09-07 00:00:00	2006-09-28	2006-09-28 00:00:00	32020		\N	219132	0	444814009	40481087		0
55808	3304	40481087	1988-04-29	1988-04-29 00:00:00	1988-05-06	1988-05-06 00:00:00	32020		\N	219451	0	444814009	40481087		0
66611	3941	4112343	2014-07-05	2014-07-05 00:00:00	2014-07-17	2014-07-17 00:00:00	32020		\N	262043	0	195662009	4112343		0
56253	3334	372328	1951-01-27	1951-01-27 00:00:00	1951-10-11	1951-10-11 00:00:00	32020		\N	221148	0	65363002	372328		0
56397	3343	40481087	2018-03-19	2018-03-19 00:00:00	2018-03-26	2018-03-26 00:00:00	32020		\N	221789	0	444814009	40481087		0
56542	3353	80502	1995-11-25	1995-11-25 00:00:00	\N	\N	32020		\N	222384	0	64859006	80502		0
67293	3976	260139	1985-10-29	1985-10-29 00:00:00	1985-11-05	1985-11-05 00:00:00	32020		\N	264387	0	10509002	260139		0
56905	3376	192671	1994-07-02	1994-07-02 00:00:00	\N	\N	32020		\N	224071	0	K92.2	35208414		0
57014	3382	260139	1962-05-18	1962-05-18 00:00:00	1962-05-25	1962-05-25 00:00:00	32020		\N	224411	0	10509002	260139		0
57136	3391	40481087	1982-08-27	1982-08-27 00:00:00	1982-09-10	1982-09-10 00:00:00	32020		\N	224922	0	444814009	40481087		0
57404	3407	40481087	1980-02-02	1980-02-02 00:00:00	1980-02-23	1980-02-23 00:00:00	32020		\N	225981	0	444814009	40481087		0
57548	3414	260139	2013-10-27	2013-10-27 00:00:00	2013-11-10	2013-11-10 00:00:00	32020		\N	226476	0	10509002	260139		0
57724	3423	40481087	2004-05-16	2004-05-16 00:00:00	2004-06-06	2004-06-06 00:00:00	32020		\N	227042	0	444814009	40481087		0
57886	3434	4112343	1989-09-29	1989-09-29 00:00:00	1989-10-11	1989-10-11 00:00:00	32020		\N	227691	0	195662009	4112343		0
58022	3439	260139	1970-02-22	1970-02-22 00:00:00	1970-03-01	1970-03-01 00:00:00	32020		\N	228186	0	10509002	260139		0
58174	3444	4112343	1962-09-15	1962-09-15 00:00:00	1962-09-25	1962-09-25 00:00:00	32020		\N	228564	0	195662009	4112343		0
47807	2839	81151	1984-06-17	1984-06-17 00:00:00	1984-07-08	1984-07-08 00:00:00	32020		\N	188551	0	44465007	81151		0
58460	3462	40481087	1968-11-12	1968-11-12 00:00:00	1968-11-19	1968-11-19 00:00:00	32020		\N	229711	0	444814009	40481087		0
69283	4101	28060	1963-09-20	1963-09-20 00:00:00	1963-10-01	1963-10-01 00:00:00	32020		\N	272507	0	43878008	28060		0
48296	2862	78272	2000-12-25	2000-12-25 00:00:00	2001-01-22	2001-01-22 00:00:00	32020		\N	190262	0	70704007	78272		0
48454	2869	4112343	2009-12-25	2009-12-25 00:00:00	2010-01-03	2010-01-03 00:00:00	32020		\N	190893	0	195662009	4112343		0
69740	4125	4112343	2007-02-02	2007-02-02 00:00:00	2007-02-12	2007-02-12 00:00:00	32020		\N	274218	0	195662009	4112343		0
70006	4142	4112343	2004-03-08	2004-03-08 00:00:00	2004-03-19	2004-03-19 00:00:00	32020		\N	275284	0	195662009	4112343		0
59467	3527	4112343	2018-03-22	2018-03-22 00:00:00	2018-04-01	2018-04-01 00:00:00	32020		\N	234024	0	195662009	4112343		0
59738	3540	4218389	1988-02-14	1988-02-14 00:00:00	1988-03-06	1988-03-06 00:00:00	32020		\N	235122	0	39848009	4218389		0
59922	3550	81893	2016-02-09	2016-02-09 00:00:00	\N	\N	32020		\N	235719	0	64766004	81893		0
60074	3559	378001	2010-09-29	2010-09-29 00:00:00	2010-10-29	2010-10-29 00:00:00	32020		\N	236263	0	62106007	378001		0
60211	3565	40481087	1958-03-28	1958-03-28 00:00:00	1958-04-11	1958-04-11 00:00:00	32020		\N	236728	0	444814009	40481087		0
60358	3571	40481087	1996-04-26	1996-04-26 00:00:00	1996-05-03	1996-05-03 00:00:00	32020		\N	237418	0	444814009	40481087		0
49962	2951	40481087	1986-11-14	1986-11-14 00:00:00	1986-12-05	1986-12-05 00:00:00	32020		\N	197048	0	444814009	40481087		0
60698	3593	4113008	1987-09-03	1987-09-03 00:00:00	1987-09-24	1987-09-24 00:00:00	32020		\N	238688	0	284549007	4113008		0
60794	3598	40481087	1959-08-31	1959-08-31 00:00:00	1959-09-21	1959-09-21 00:00:00	32020		\N	238964	0	444814009	40481087		0
61063	3614	28060	1958-06-11	1958-06-11 00:00:00	1958-06-20	1958-06-20 00:00:00	32020		\N	240136	0	43878008	28060		0
61146	3618	255848	1994-07-29	1994-07-29 00:00:00	\N	\N	32020		\N	240341	0	233604007	255848		0
61316	3624	40481087	1989-06-23	1989-06-23 00:00:00	1989-07-07	1989-07-07 00:00:00	32020		\N	240994	0	444814009	40481087		0
61478	3633	40481087	1987-05-08	1987-05-08 00:00:00	1987-05-15	1987-05-15 00:00:00	32020		\N	241639	0	444814009	40481087		0
51113	3026	4109685	1980-05-11	1980-05-11 00:00:00	1980-05-25	1980-05-25 00:00:00	32020		\N	201792	0	284551006	4109685		0
72381	4295	4285898	2007-05-31	2007-05-31 00:00:00	\N	\N	32020		\N	285096	0	68496003	4285898		0
72544	4309	40481087	2016-06-07	2016-06-07 00:00:00	2016-06-14	2016-06-14 00:00:00	32020		\N	285896	0	444814009	40481087		0
62185	3672	40481087	1976-09-29	1976-09-29 00:00:00	1976-10-20	1976-10-20 00:00:00	32020		\N	244297	0	444814009	40481087		0
72966	4337	80180	2006-02-13	2006-02-13 00:00:00	\N	\N	32020		\N	287624	0	396275006	80180		0
62548	3695	321042	2007-02-12	2007-02-12 00:00:00	\N	\N	32020		\N	245606	0	410429000	321042		0
62634	3699	4112343	2008-08-23	2008-08-23 00:00:00	2008-09-01	2008-09-01 00:00:00	32020		\N	245913	0	195662009	4112343		0
62910	3717	40481087	2006-11-30	2006-11-30 00:00:00	2006-12-21	2006-12-21 00:00:00	32020		\N	246991	0	444814009	40481087		0
62949	3718	4237458	1974-08-07	1974-08-07 00:00:00	1974-10-06	1974-10-06 00:00:00	32020		\N	247144	0	58150001	4237458		0
73742	4381	378001	2008-07-18	2008-07-18 00:00:00	2008-08-17	2008-08-17 00:00:00	32020		\N	291144	0	62106007	378001		0
73881	4388	372328	1970-09-15	1970-09-15 00:00:00	1971-07-31	1971-07-31 00:00:00	32020		\N	291665	0	65363002	372328		0
63572	3754	260139	1995-11-25	1995-11-25 00:00:00	1995-12-02	1995-12-02 00:00:00	32020		\N	249500	0	10509002	260139		0
74256	4409	321042	1999-10-28	1999-10-28 00:00:00	\N	\N	32020		\N	293129	0	410429000	321042		0
53261	3157	4285898	1985-11-13	1985-11-13 00:00:00	\N	\N	32020		\N	209846	0	68496003	4285898		0
63948	3778	40481087	1997-01-12	1997-01-12 00:00:00	1997-02-02	1997-02-02 00:00:00	32020		\N	251058	0	444814009	40481087		0
53603	3176	372328	1976-05-28	1976-05-28 00:00:00	1976-11-13	1976-11-13 00:00:00	32020		\N	211155	0	65363002	372328		0
53700	3178	192671	1994-10-06	1994-10-06 00:00:00	\N	\N	32020		\N	211446	0	K92.2	35208414		0
53811	3183	4294548	2014-12-28	2014-12-28 00:00:00	2015-02-08	2015-02-08 00:00:00	32020		\N	211943	0	75498004	4294548		0
54078	3201	372328	1941-03-26	1941-03-26 00:00:00	1941-07-30	1941-07-30 00:00:00	32020		\N	212904	0	65363002	372328		0
54137	3207	4237458	1960-10-01	1960-10-01 00:00:00	1960-12-30	1960-12-30 00:00:00	32020		\N	213203	0	58150001	4237458		0
54372	3221	40481087	2003-10-28	2003-10-28 00:00:00	2003-11-11	2003-11-11 00:00:00	32020		\N	214111	0	444814009	40481087		0
54494	3227	372328	1974-11-26	1974-11-26 00:00:00	1975-09-09	1975-09-09 00:00:00	32020		\N	214532	0	65363002	372328		0
54702	3237	40481087	1936-11-18	1936-11-18 00:00:00	1936-11-25	1936-11-25 00:00:00	32020		\N	215219	0	444814009	40481087		0
54872	3248	40481087	1954-07-05	1954-07-05 00:00:00	1954-07-19	1954-07-19 00:00:00	32020		\N	215917	0	444814009	40481087		0
65595	3879	40481087	2014-04-26	2014-04-26 00:00:00	2014-05-17	2014-05-17 00:00:00	32020		\N	257747	0	444814009	40481087		0
65792	3890	378001	1975-11-19	1975-11-19 00:00:00	1975-12-19	1975-12-19 00:00:00	32020		\N	258572	0	62106007	378001		0
55376	3280	4112343	1959-08-04	1959-08-04 00:00:00	1959-08-11	1959-08-11 00:00:00	32020		\N	218004	0	195662009	4112343		0
55546	3290	40481087	2015-04-14	2015-04-14 00:00:00	2015-04-21	2015-04-21 00:00:00	32020		\N	218599	0	444814009	40481087		0
55732	3298	80180	2006-10-30	2006-10-30 00:00:00	\N	\N	32020		\N	219132	0	396275006	80180		0
55809	3304	260139	1984-10-17	1984-10-17 00:00:00	1984-10-31	1984-10-31 00:00:00	32020		\N	219426	0	10509002	260139		0
66612	3941	40481087	1983-06-26	1983-06-26 00:00:00	1983-07-10	1983-07-10 00:00:00	32020		\N	262059	0	444814009	40481087		0
56254	3334	260139	1954-04-13	1954-04-13 00:00:00	1954-04-27	1954-04-27 00:00:00	32020		\N	221144	0	10509002	260139		0
56398	3343	80180	2019-05-17	2019-05-17 00:00:00	\N	\N	32020		\N	221802	0	396275006	80180		0
56543	3353	260139	1962-04-23	1962-04-23 00:00:00	1962-04-30	1962-04-30 00:00:00	32020		\N	222416	0	10509002	260139		0
67294	3976	4278672	2017-11-10	2017-11-10 00:00:00	2018-01-09	2018-01-09 00:00:00	32020		\N	264353	0	65966004	4278672		0
56906	3376	378001	1980-10-01	1980-10-01 00:00:00	1980-10-31	1980-10-31 00:00:00	32020		\N	224001	0	62106007	378001		0
57015	3382	4155034	1963-12-07	1963-12-07 00:00:00	1963-12-28	1963-12-28 00:00:00	32020		\N	224399	0	283371005	4155034		0
57137	3391	4283893	1986-11-07	1986-11-07 00:00:00	1987-03-13	1987-03-13 00:00:00	32020		\N	224913	0	36971009	4283893		0
57405	3407	4112343	1969-11-04	1969-11-04 00:00:00	1969-11-13	1969-11-13 00:00:00	32020		\N	225933	0	195662009	4112343		0
57549	3414	80180	2004-04-04	2004-04-04 00:00:00	\N	\N	32020		\N	226489	0	396275006	80180		0
57725	3423	4285898	2011-07-05	2011-07-05 00:00:00	\N	\N	32020		\N	227076	0	68496003	4285898		0
57887	3434	378001	2002-09-27	2002-09-27 00:00:00	2002-11-26	2002-11-26 00:00:00	32020		\N	227684	0	62106007	378001		0
58023	3439	40481087	1961-06-03	1961-06-03 00:00:00	1961-06-17	1961-06-17 00:00:00	32020		\N	228167	0	444814009	40481087		0
58175	3444	4146173	1969-11-17	1969-11-17 00:00:00	1970-01-16	1970-01-16 00:00:00	32020		\N	228522	0	307731004	4146173		0
47808	2839	4035415	1986-04-29	1986-04-29 00:00:00	1986-06-28	1986-06-28 00:00:00	32020		\N	188534	0	239720000	4035415		0
58461	3462	260139	1994-09-26	1994-09-26 00:00:00	1994-10-03	1994-10-03 00:00:00	32020		\N	229733	0	10509002	260139		0
69284	4101	380378	1960-02-27	1960-02-27 00:00:00	\N	\N	32020		\N	272468	0	84757009	380378		0
48297	2862	260139	2016-08-06	2016-08-06 00:00:00	2016-08-13	2016-08-13 00:00:00	32020		\N	190284	0	10509002	260139		0
48455	2869	4001336	1975-02-18	1975-02-18 00:00:00	1975-04-19	1975-04-19 00:00:00	32020		\N	190827	0	110030002	4001336		0
69745	4127	4109685	1948-07-23	1948-07-23 00:00:00	1948-08-13	1948-08-13 00:00:00	32020		\N	274310	0	284551006	4109685		0
70007	4142	40481087	2001-08-01	2001-08-01 00:00:00	2001-08-22	2001-08-22 00:00:00	32020		\N	275325	0	444814009	40481087		0
59468	3527	4156265	1971-04-22	1971-04-22 00:00:00	1971-05-06	1971-05-06 00:00:00	32020		\N	234048	0	370247008	4156265		0
59739	3540	28060	1975-11-23	1975-11-23 00:00:00	1975-12-04	1975-12-04 00:00:00	32020		\N	235112	0	43878008	28060		0
59923	3550	4266809	2016-11-05	2016-11-05 00:00:00	\N	\N	32020		\N	235719	0	397881000	4266809		0
60075	3559	4112343	2001-03-26	2001-03-26 00:00:00	2001-04-08	2001-04-08 00:00:00	32020		\N	236294	0	195662009	4112343		0
60212	3565	4116491	1966-02-27	1966-02-27 00:00:00	1966-04-10	1966-04-10 00:00:00	32020		\N	236714	0	301011002	4116491		0
60359	3571	4112343	1988-08-01	1988-08-01 00:00:00	1988-08-13	1988-08-13 00:00:00	32020		\N	237332	0	195662009	4112343		0
49963	2951	260139	2017-09-10	2017-09-10 00:00:00	2017-09-17	2017-09-17 00:00:00	32020		\N	197049	0	10509002	260139		0
60699	3593	4285898	1988-01-30	1988-01-30 00:00:00	\N	\N	32020		\N	238688	0	68496003	4285898		0
60795	3598	260139	2004-03-21	2004-03-21 00:00:00	2004-04-04	2004-04-04 00:00:00	32020		\N	239012	0	10509002	260139		0
61064	3614	255848	2011-03-21	2011-03-21 00:00:00	\N	\N	32020		\N	240061	0	233604007	255848		0
61147	3618	260139	1960-07-13	1960-07-13 00:00:00	1960-07-27	1960-07-27 00:00:00	32020		\N	240451	0	10509002	260139		0
61317	3624	260139	1957-03-10	1957-03-10 00:00:00	1957-03-17	1957-03-17 00:00:00	32020		\N	240991	0	10509002	260139		0
61479	3633	80180	2017-05-02	2017-05-02 00:00:00	\N	\N	32020		\N	241648	0	396275006	80180		0
51114	3026	4278672	1971-07-28	1971-07-28 00:00:00	1971-10-26	1971-10-26 00:00:00	32020		\N	201791	0	65966004	4278672		0
72382	4295	80180	2007-09-28	2007-09-28 00:00:00	\N	\N	32020		\N	285096	0	396275006	80180		0
72545	4309	378001	1988-09-02	1988-09-02 00:00:00	1988-10-02	1988-10-02 00:00:00	32020		\N	285945	0	62106007	378001		0
62186	3672	4112343	1975-08-27	1975-08-27 00:00:00	1975-09-03	1975-09-03 00:00:00	32020		\N	244287	0	195662009	4112343		0
72967	4337	40481087	2000-11-01	2000-11-01 00:00:00	2000-11-08	2000-11-08 00:00:00	32020		\N	287565	0	444814009	40481087		0
62550	3695	260139	2008-11-30	2008-11-30 00:00:00	2008-12-14	2008-12-14 00:00:00	32020		\N	245592	0	10509002	260139		0
62635	3700	257012	1975-07-04	1975-07-04 00:00:00	2011-09-26	2011-09-26 00:00:00	32020		\N	246023	0	40055000	257012		0
62911	3717	40481087	2014-11-14	2014-11-14 00:00:00	2014-12-05	2014-12-05 00:00:00	32020		\N	247050	0	444814009	40481087		0
62950	3719	40481087	1968-11-03	1968-11-03 00:00:00	1968-11-24	1968-11-24 00:00:00	32020		\N	247207	0	444814009	40481087		0
73743	4381	260139	2012-11-18	2012-11-18 00:00:00	2012-12-04	2012-12-04 00:00:00	32020		\N	291109	0	10509002	260139		0
73882	4388	40481087	1991-04-02	1991-04-02 00:00:00	1991-04-23	1991-04-23 00:00:00	32020		\N	291738	0	444814009	40481087		0
63573	3754	4112343	1973-07-17	1973-07-17 00:00:00	1973-07-28	1973-07-28 00:00:00	32020		\N	249444	0	195662009	4112343		0
74258	4409	28060	1978-11-07	1978-11-07 00:00:00	1978-11-16	1978-11-16 00:00:00	32020		\N	293053	0	43878008	28060		0
53262	3157	80180	1986-05-12	1986-05-12 00:00:00	\N	\N	32020		\N	209846	0	396275006	80180		0
63949	3778	260139	2003-01-15	2003-01-15 00:00:00	2003-01-22	2003-01-22 00:00:00	32020		\N	251061	0	10509002	260139		0
53604	3176	260139	2000-08-17	2000-08-17 00:00:00	2000-08-31	2000-08-31 00:00:00	32020		\N	211151	0	10509002	260139		0
53701	3178	372328	1956-12-11	1956-12-11 00:00:00	1957-03-02	1957-03-02 00:00:00	32020		\N	211378	0	65363002	372328		0
53812	3183	4112343	1982-07-06	1982-07-06 00:00:00	1982-07-16	1982-07-16 00:00:00	32020		\N	211930	0	195662009	4112343		0
54079	3201	4285898	1975-09-29	1975-09-29 00:00:00	\N	\N	32020		\N	212913	0	68496003	4285898		0
54138	3207	440086	1972-12-07	1972-12-07 00:00:00	1975-01-30	1975-01-30 00:00:00	32020		\N	213214	0	192127007	440086		0
54373	3221	81151	1974-09-01	1974-09-01 00:00:00	1974-09-15	1974-09-15 00:00:00	32020		\N	214132	0	44465007	81151		0
54495	3227	40481087	2011-02-19	2011-02-19 00:00:00	2011-03-05	2011-03-05 00:00:00	32020		\N	214531	0	444814009	40481087		0
54703	3237	4112343	1948-04-04	1948-04-04 00:00:00	1948-04-15	1948-04-15 00:00:00	32020		\N	215220	0	195662009	4112343		0
54873	3248	4112343	1959-04-19	1959-04-19 00:00:00	1959-04-26	1959-04-26 00:00:00	32020		\N	215852	0	195662009	4112343		0
65596	3879	40481087	1986-03-18	1986-03-18 00:00:00	1986-04-01	1986-04-01 00:00:00	32020		\N	257732	0	444814009	40481087		0
65793	3890	40481087	1973-10-13	1973-10-13 00:00:00	1973-10-20	1973-10-20 00:00:00	32020		\N	258590	0	444814009	40481087		0
55377	3280	4296204	1991-05-17	1991-05-17 00:00:00	1991-06-14	1991-06-14 00:00:00	32020		\N	218039	0	403190006	4296204		0
55547	3290	40481087	2018-11-07	2018-11-07 00:00:00	2018-11-28	2018-11-28 00:00:00	32020		\N	218576	0	444814009	40481087		0
55733	3298	260139	1985-05-04	1985-05-04 00:00:00	1985-05-18	1985-05-18 00:00:00	32020		\N	219147	0	10509002	260139		0
55810	3304	80180	2001-05-19	2001-05-19 00:00:00	\N	\N	32020		\N	219442	0	396275006	80180		0
66613	3941	40481087	1988-05-22	1988-05-22 00:00:00	1988-05-29	1988-05-29 00:00:00	32020		\N	262046	0	444814009	40481087		0
56255	3334	81151	2001-10-31	2001-10-31 00:00:00	2001-12-05	2001-12-05 00:00:00	32020		\N	221159	0	44465007	81151		0
56399	3343	4152936	2017-04-07	2017-04-07 00:00:00	2017-04-28	2017-04-28 00:00:00	32020		\N	221701	0	283385000	4152936		0
56544	3353	30753	1958-05-13	1958-05-13 00:00:00	\N	\N	32020		\N	222440	0	16761005	30753		0
67328	3980	4112343	1981-12-20	1981-12-20 00:00:00	1982-01-02	1982-01-02 00:00:00	32020		\N	264614	0	195662009	4112343		0
56907	3376	4112343	1966-08-19	1966-08-19 00:00:00	1966-08-31	1966-08-31 00:00:00	32020		\N	224008	0	195662009	4112343		0
57016	3382	4113008	2018-06-24	2018-06-24 00:00:00	2018-07-08	2018-07-08 00:00:00	32020		\N	224461	0	284549007	4113008		0
57138	3391	40481087	2018-02-23	2018-02-23 00:00:00	2018-03-09	2018-03-09 00:00:00	32020		\N	224910	0	444814009	40481087		0
57406	3408	4285898	2008-02-18	2008-02-18 00:00:00	\N	\N	32020		\N	226047	0	68496003	4285898		0
57550	3414	4112343	2003-10-16	2003-10-16 00:00:00	2003-10-23	2003-10-23 00:00:00	32020		\N	226489	0	195662009	4112343		0
57726	3423	4112343	2011-09-24	2011-09-24 00:00:00	2011-10-06	2011-10-06 00:00:00	32020		\N	227060	0	195662009	4112343		0
57888	3434	28060	1994-07-30	1994-07-30 00:00:00	1994-08-12	1994-08-12 00:00:00	32020		\N	227746	0	43878008	28060		0
58024	3439	4001336	1954-08-14	1954-08-14 00:00:00	1954-10-13	1954-10-13 00:00:00	32020		\N	228136	0	110030002	4001336		0
58196	3446	4029498	1957-12-09	1957-12-09 00:00:00	\N	\N	32020		\N	228777	0	128613002	4029498		0
58292	3454	4296205	2019-03-12	2019-03-12 00:00:00	2019-04-16	2019-04-16 00:00:00	32020		\N	229144	0	403191005	4296205		0
58462	3462	4152936	2018-04-29	2018-04-29 00:00:00	2018-05-13	2018-05-13 00:00:00	32020		\N	229770	0	283385000	4152936		0
69285	4101	378001	1975-07-06	1975-07-06 00:00:00	1975-08-05	1975-08-05 00:00:00	32020		\N	272471	0	62106007	378001		0
48298	2862	260139	1972-05-03	1972-05-03 00:00:00	1972-05-10	1972-05-10 00:00:00	32020		\N	190263	0	10509002	260139		0
48456	2869	4142905	1962-09-19	1962-09-19 00:00:00	1962-10-19	1962-10-19 00:00:00	32020		\N	190824	0	33737001	4142905		0
69746	4127	80180	1988-02-04	1988-02-04 00:00:00	\N	\N	32020		\N	274386	0	396275006	80180		0
70008	4142	260139	2003-08-28	2003-08-28 00:00:00	2003-09-11	2003-09-11 00:00:00	32020		\N	275321	0	10509002	260139		0
59469	3527	260139	1987-09-13	1987-09-13 00:00:00	1987-09-20	1987-09-20 00:00:00	32020		\N	234053	0	10509002	260139		0
59740	3540	260139	1994-10-19	1994-10-19 00:00:00	1994-11-02	1994-11-02 00:00:00	32020		\N	235114	0	10509002	260139		0
59924	3550	80180	2016-11-05	2016-11-05 00:00:00	\N	\N	32020		\N	235719	0	396275006	80180		0
60076	3559	4112343	1955-11-27	1955-11-27 00:00:00	1955-12-09	1955-12-09 00:00:00	32020		\N	236273	0	195662009	4112343		0
60213	3565	40481087	2001-01-10	2001-01-10 00:00:00	2001-01-31	2001-01-31 00:00:00	32020		\N	236731	0	444814009	40481087		0
60360	3571	4134304	2005-05-27	2005-05-27 00:00:00	2005-07-26	2005-07-26 00:00:00	32020		\N	237439	0	263102004	4134304		0
49964	2951	4113008	1983-08-07	1983-08-07 00:00:00	1983-08-21	1983-08-21 00:00:00	32020		\N	197008	0	284549007	4113008		0
60700	3593	80180	1988-02-29	1988-02-29 00:00:00	\N	\N	32020		\N	238688	0	396275006	80180		0
60796	3598	4237458	1945-01-20	1945-01-20 00:00:00	1945-03-21	1945-03-21 00:00:00	32020		\N	238941	0	58150001	4237458		0
61065	3614	40481087	1953-02-26	1953-02-26 00:00:00	1953-03-12	1953-03-12 00:00:00	32020		\N	240135	0	444814009	40481087		0
61148	3618	40481087	1966-08-01	1966-08-01 00:00:00	1966-08-22	1966-08-22 00:00:00	32020		\N	240428	0	444814009	40481087		0
61318	3624	4112343	2003-08-02	2003-08-02 00:00:00	2003-08-11	2003-08-11 00:00:00	32020		\N	240946	0	195662009	4112343		0
61480	3633	40481087	1993-08-18	1993-08-18 00:00:00	1993-09-01	1993-09-01 00:00:00	32020		\N	241655	0	444814009	40481087		0
51115	3026	28060	1971-12-26	1971-12-26 00:00:00	1972-01-07	1972-01-07 00:00:00	32020		\N	201761	0	43878008	28060		0
72397	4297	372328	1976-11-03	1976-11-03 00:00:00	1976-12-11	1976-12-11 00:00:00	32020		\N	285199	0	65363002	372328		0
72546	4309	4027663	1985-07-27	1985-07-27 00:00:00	\N	\N	32020		\N	285942	0	13200003	4027663		0
62188	3672	4278672	1976-01-09	1976-01-09 00:00:00	1976-02-08	1976-02-08 00:00:00	32020		\N	244326	0	65966004	4278672		0
72968	4337	260139	2016-07-06	2016-07-06 00:00:00	2016-07-13	2016-07-13 00:00:00	32020		\N	287567	0	10509002	260139		0
62551	3695	192671	2013-12-22	2013-12-22 00:00:00	\N	\N	32020		\N	245608	0	K92.2	35208414		0
62636	3700	4283893	2011-07-18	2011-07-18 00:00:00	2011-09-26	2011-09-26 00:00:00	32020		\N	245983	0	36971009	4283893		0
62912	3717	40481087	1981-04-19	1981-04-19 00:00:00	1981-05-03	1981-05-03 00:00:00	32020		\N	247076	0	444814009	40481087		0
62951	3719	4112343	1998-10-21	1998-10-21 00:00:00	1998-10-30	1998-10-30 00:00:00	32020		\N	247151	0	195662009	4112343		0
73744	4381	4294548	2012-10-23	2012-10-23 00:00:00	2012-11-27	2012-11-27 00:00:00	32020		\N	291109	0	75498004	4294548		0
68082	4021	80180	1992-05-22	1992-05-22 00:00:00	\N	\N	32020		\N	267280	0	396275006	80180		0
73883	4388	4109685	1974-01-29	1974-01-29 00:00:00	1974-02-19	1974-02-19 00:00:00	32020		\N	291637	0	284551006	4109685		0
63574	3754	40481087	1964-05-01	1964-05-01 00:00:00	1964-05-22	1964-05-22 00:00:00	32020		\N	249440	0	444814009	40481087		0
74259	4409	40481087	2013-08-31	2013-08-31 00:00:00	2013-09-21	2013-09-21 00:00:00	32020		\N	293108	0	444814009	40481087		0
53263	3157	78272	2000-08-17	2000-08-17 00:00:00	2000-09-07	2000-09-07 00:00:00	32020		\N	209880	0	70704007	78272		0
63950	3778	30753	1999-02-18	1999-02-18 00:00:00	\N	\N	32020		\N	251103	0	16761005	30753		0
53605	3176	40481087	2014-05-16	2014-05-16 00:00:00	2014-05-23	2014-05-23 00:00:00	32020		\N	211191	0	444814009	40481087		0
53702	3178	40481087	1978-10-07	1978-10-07 00:00:00	1978-10-21	1978-10-21 00:00:00	32020		\N	211424	0	444814009	40481087		0
53813	3183	4230399	1999-07-04	1999-07-04 00:00:00	1999-09-02	1999-09-02 00:00:00	32020		\N	211918	0	359817006	4230399		0
54080	3201	80180	1976-07-25	1976-07-25 00:00:00	\N	\N	32020		\N	212913	0	396275006	80180		0
54139	3207	260139	1968-07-22	1968-07-22 00:00:00	1968-08-05	1968-08-05 00:00:00	32020		\N	213191	0	10509002	260139		0
54374	3221	440086	1970-05-30	1970-05-30 00:00:00	1972-01-08	1972-01-08 00:00:00	32020		\N	214072	0	192127007	440086		0
54496	3227	40479422	1998-07-23	1998-07-23 00:00:00	1998-08-29	1998-08-29 00:00:00	32020		\N	214543	0	444448004	40479422		0
54704	3237	260139	1981-12-04	1981-12-04 00:00:00	1981-12-18	1981-12-18 00:00:00	32020		\N	215224	0	10509002	260139		0
54874	3248	40481087	1967-04-09	1967-04-09 00:00:00	1967-04-16	1967-04-16 00:00:00	32020		\N	215846	0	444814009	40481087		0
65597	3879	4112343	1975-11-29	1975-11-29 00:00:00	1975-12-10	1975-12-10 00:00:00	32020		\N	257743	0	195662009	4112343		0
65794	3890	4283893	1968-04-03	1968-04-03 00:00:00	1968-04-24	1968-04-24 00:00:00	32020		\N	258549	0	36971009	4283893		0
55378	3280	80180	1986-12-18	1986-12-18 00:00:00	\N	\N	32020		\N	217986	0	396275006	80180		0
55548	3290	78272	1991-01-07	1991-01-07 00:00:00	1991-02-11	1991-02-11 00:00:00	32020		\N	218618	0	70704007	78272		0
55734	3298	81151	1979-12-06	1979-12-06 00:00:00	1979-12-20	1979-12-20 00:00:00	32020		\N	219145	0	44465007	81151		0
55811	3304	192671	2001-06-08	2001-06-08 00:00:00	\N	\N	32020		\N	219439	0	K92.2	35208414		0
66614	3941	4266809	1999-08-01	1999-08-01 00:00:00	\N	\N	32020		\N	262017	0	397881000	4266809		0
56256	3334	81151	2017-09-12	2017-09-12 00:00:00	2017-10-03	2017-10-03 00:00:00	32020		\N	221160	0	44465007	81151		0
56400	3343	4296204	2016-03-08	2016-03-08 00:00:00	2016-04-12	2016-04-12 00:00:00	32020		\N	221700	0	403190006	4296204		0
56545	3353	4112343	1992-12-21	1992-12-21 00:00:00	1992-12-30	1992-12-30 00:00:00	32020		\N	222358	0	195662009	4112343		0
67329	3980	372328	1980-02-28	1980-02-28 00:00:00	1980-10-12	1980-10-12 00:00:00	32020		\N	264565	0	65363002	372328		0
56908	3376	4112343	2018-07-08	2018-07-08 00:00:00	2018-07-18	2018-07-18 00:00:00	32020		\N	224041	0	195662009	4112343		0
57017	3382	40481087	1980-10-04	1980-10-04 00:00:00	1980-10-18	1980-10-18 00:00:00	32020		\N	224438	0	444814009	40481087		0
57139	3391	40481087	1999-08-18	1999-08-18 00:00:00	1999-09-08	1999-09-08 00:00:00	32020		\N	224908	0	444814009	40481087		0
57407	3408	80180	2008-10-15	2008-10-15 00:00:00	\N	\N	32020		\N	226047	0	396275006	80180		0
57551	3414	260139	1994-07-24	1994-07-24 00:00:00	1994-08-07	1994-08-07 00:00:00	32020		\N	226486	0	10509002	260139		0
57727	3423	80180	2012-01-31	2012-01-31 00:00:00	\N	\N	32020		\N	227060	0	396275006	80180		0
57889	3434	440086	1957-04-20	1957-04-20 00:00:00	1957-05-18	1957-05-18 00:00:00	32020		\N	227689	0	192127007	440086		0
58025	3439	78272	1964-12-08	1964-12-08 00:00:00	1965-01-12	1965-01-12 00:00:00	32020		\N	228139	0	70704007	78272		0
58197	3446	260139	1968-09-23	1968-09-23 00:00:00	1968-09-30	1968-09-30 00:00:00	32020		\N	228808	0	10509002	260139		0
58293	3454	4155034	2005-09-07	2005-09-07 00:00:00	2005-09-21	2005-09-21 00:00:00	32020		\N	229143	0	283371005	4155034		0
58463	3462	4294548	1992-07-05	1992-07-05 00:00:00	1992-09-20	1992-09-20 00:00:00	32020		\N	229732	0	75498004	4294548		0
69286	4101	260139	2014-08-08	2014-08-08 00:00:00	2014-08-15	2014-08-15 00:00:00	32020		\N	272525	0	10509002	260139		0
48299	2862	40481087	1984-11-17	1984-11-17 00:00:00	1984-12-08	1984-12-08 00:00:00	32020		\N	190270	0	444814009	40481087		0
48457	2869	260139	1976-04-27	1976-04-27 00:00:00	1976-05-11	1976-05-11 00:00:00	32020		\N	190890	0	10509002	260139		0
69747	4127	372328	1949-04-19	1949-04-19 00:00:00	1949-06-05	1949-06-05 00:00:00	32020		\N	274336	0	65363002	372328		0
70009	4142	40481087	2009-06-06	2009-06-06 00:00:00	2009-06-13	2009-06-13 00:00:00	32020		\N	275326	0	444814009	40481087		0
59470	3527	28060	1975-06-28	1975-06-28 00:00:00	1975-07-08	1975-07-08 00:00:00	32020		\N	234051	0	43878008	28060		0
59741	3540	192671	2013-07-26	2013-07-26 00:00:00	\N	\N	32020		\N	235169	0	K92.2	35208414		0
59925	3550	40481087	2004-01-23	2004-01-23 00:00:00	2004-02-13	2004-02-13 00:00:00	32020		\N	235737	0	444814009	40481087		0
60077	3559	40481087	1952-03-19	1952-03-19 00:00:00	1952-03-26	1952-03-26 00:00:00	32020		\N	236264	0	444814009	40481087		0
60214	3565	4112343	1971-05-12	1971-05-12 00:00:00	1971-05-19	1971-05-19 00:00:00	32020		\N	236729	0	195662009	4112343		0
60361	3571	40481087	1972-03-29	1972-03-29 00:00:00	1972-04-12	1972-04-12 00:00:00	32020		\N	237410	0	444814009	40481087		0
60425	3573	40481087	1940-10-21	1940-10-21 00:00:00	1940-11-11	1940-11-11 00:00:00	32020		\N	237516	0	444814009	40481087		0
60701	3593	40481087	1954-03-18	1954-03-18 00:00:00	1954-04-08	1954-04-08 00:00:00	32020		\N	238643	0	444814009	40481087		0
60797	3598	372328	1947-10-07	1947-10-07 00:00:00	1948-02-29	1948-02-29 00:00:00	32020		\N	238933	0	65363002	372328		0
61066	3614	40481087	1951-06-22	1951-06-22 00:00:00	1951-06-29	1951-06-29 00:00:00	32020		\N	240139	0	444814009	40481087		0
61149	3618	40481087	1993-07-06	1993-07-06 00:00:00	1993-07-27	1993-07-27 00:00:00	32020		\N	240347	0	444814009	40481087		0
61319	3624	372328	1946-12-31	1946-12-31 00:00:00	1947-03-13	1947-03-13 00:00:00	32020		\N	240971	0	65363002	372328		0
61481	3633	40481087	2005-02-07	2005-02-07 00:00:00	2005-02-28	2005-02-28 00:00:00	32020		\N	241662	0	444814009	40481087		0
51116	3026	28060	2018-08-26	2018-08-26 00:00:00	2018-09-06	2018-09-06 00:00:00	32020		\N	201793	0	43878008	28060		0
72398	4297	4296204	1986-04-19	1986-04-19 00:00:00	1986-05-24	1986-05-24 00:00:00	32020		\N	285177	0	403190006	4296204		0
72547	4309	4112343	1985-08-24	1985-08-24 00:00:00	1985-09-05	1985-09-05 00:00:00	32020		\N	285887	0	195662009	4112343		0
62189	3672	260139	1979-06-23	1979-06-23 00:00:00	1979-07-07	1979-07-07 00:00:00	32020		\N	244300	0	10509002	260139		0
72969	4337	257012	1979-01-15	1979-01-15 00:00:00	\N	\N	32020		\N	287591	0	40055000	257012		0
62552	3695	4109685	1992-09-28	1992-09-28 00:00:00	1992-10-19	1992-10-19 00:00:00	32020		\N	245604	0	284551006	4109685		0
62637	3700	40481087	1997-10-31	1997-10-31 00:00:00	1997-11-14	1997-11-14 00:00:00	32020		\N	245964	0	444814009	40481087		0
62913	3717	40481087	2003-07-29	2003-07-29 00:00:00	2003-08-19	2003-08-19 00:00:00	32020		\N	247048	0	444814009	40481087		0
62952	3719	4027663	1993-12-31	1993-12-31 00:00:00	\N	\N	32020		\N	247185	0	13200003	4027663		0
73745	4381	40481087	1983-10-24	1983-10-24 00:00:00	1983-11-07	1983-11-07 00:00:00	32020		\N	291081	0	444814009	40481087		0
73884	4388	4112343	1966-09-22	1966-09-22 00:00:00	1966-10-03	1966-10-03 00:00:00	32020		\N	291657	0	195662009	4112343		0
63575	3754	4027663	1992-12-28	1992-12-28 00:00:00	\N	\N	32020		\N	249496	0	13200003	4027663		0
74260	4409	4283893	1993-03-19	1993-03-19 00:00:00	1993-05-21	1993-05-21 00:00:00	32020		\N	293055	0	36971009	4283893		0
53264	3157	4310024	1983-07-27	1983-07-27 00:00:00	\N	\N	32020		\N	209863	0	424802006	4310024		0
63951	3778	4027663	1990-09-28	1990-09-28 00:00:00	\N	\N	32020		\N	251100	0	13200003	4027663		0
53606	3176	4134304	1992-04-29	1992-04-29 00:00:00	1992-06-28	1992-06-28 00:00:00	32020		\N	211125	0	263102004	4134304		0
53703	3178	40481087	2007-01-28	2007-01-28 00:00:00	2007-02-18	2007-02-18 00:00:00	32020		\N	211422	0	444814009	40481087		0
53814	3183	40481087	2007-11-22	2007-11-22 00:00:00	2007-11-29	2007-11-29 00:00:00	32020		\N	211923	0	444814009	40481087		0
54140	3207	40481087	1963-06-26	1963-06-26 00:00:00	1963-07-10	1963-07-10 00:00:00	32020		\N	213155	0	444814009	40481087		0
54375	3221	40481087	2011-06-11	2011-06-11 00:00:00	2011-06-18	2011-06-18 00:00:00	32020		\N	214112	0	444814009	40481087		0
54497	3227	4112343	1982-03-07	1982-03-07 00:00:00	1982-03-15	1982-03-15 00:00:00	32020		\N	214502	0	195662009	4112343		0
54705	3237	4146173	1945-10-21	1945-10-21 00:00:00	1945-12-20	1945-12-20 00:00:00	32020		\N	215197	0	307731004	4146173		0
54875	3248	40481087	2018-03-21	2018-03-21 00:00:00	2018-04-11	2018-04-11 00:00:00	32020		\N	215898	0	444814009	40481087		0
65598	3879	4112343	1977-02-06	1977-02-06 00:00:00	1977-02-19	1977-02-19 00:00:00	32020		\N	257691	0	195662009	4112343		0
65795	3890	40481087	2019-01-12	2019-01-12 00:00:00	2019-02-02	2019-02-02 00:00:00	32020		\N	258561	0	444814009	40481087		0
55379	3280	4156265	1969-08-28	1969-08-28 00:00:00	1969-09-11	1969-09-11 00:00:00	32020		\N	218037	0	370247008	4156265		0
55549	3290	40481087	1990-12-10	1990-12-10 00:00:00	1990-12-17	1990-12-17 00:00:00	32020		\N	218597	0	444814009	40481087		0
55735	3298	28060	1984-06-02	1984-06-02 00:00:00	1984-06-13	1984-06-13 00:00:00	32020		\N	219163	0	43878008	28060		0
55812	3304	372328	1963-09-06	1963-09-06 00:00:00	1963-12-18	1963-12-18 00:00:00	32020		\N	219449	0	65363002	372328		0
66615	3941	80180	1999-08-01	1999-08-01 00:00:00	\N	\N	32020		\N	262017	0	396275006	80180		0
56257	3334	40481087	2000-06-07	2000-06-07 00:00:00	2000-06-14	2000-06-14 00:00:00	32020		\N	221177	0	444814009	40481087		0
56401	3343	4084167	1993-04-11	1993-04-11 00:00:00	1993-04-11	1993-04-11 00:00:00	32020		\N	221862	0	241929008	4084167		0
56546	3353	80180	1959-04-08	1959-04-08 00:00:00	\N	\N	32020		\N	222379	0	396275006	80180		0
67330	3980	4112343	2001-08-01	2001-08-01 00:00:00	2001-08-12	2001-08-12 00:00:00	32020		\N	264581	0	195662009	4112343		0
56909	3376	4230399	1964-03-29	1964-03-29 00:00:00	1964-06-27	1964-06-27 00:00:00	32020		\N	224000	0	359817006	4230399		0
57018	3382	80180	2003-08-29	2003-08-29 00:00:00	\N	\N	32020		\N	224424	0	396275006	80180		0
57140	3391	40481087	1990-11-29	1990-11-29 00:00:00	1990-12-06	1990-12-06 00:00:00	32020		\N	224905	0	444814009	40481087		0
57408	3408	4266809	2008-10-15	2008-10-15 00:00:00	\N	\N	32020		\N	226047	0	397881000	4266809		0
57552	3414	40481087	2007-07-29	2007-07-29 00:00:00	2007-08-12	2007-08-12 00:00:00	32020		\N	226475	0	444814009	40481087		0
57728	3423	28060	1988-12-04	1988-12-04 00:00:00	1988-12-14	1988-12-14 00:00:00	32020		\N	227063	0	43878008	28060		0
57890	3434	4142905	1965-08-12	1965-08-12 00:00:00	1965-11-10	1965-11-10 00:00:00	32020		\N	227683	0	33737001	4142905		0
58026	3439	40481087	1984-12-09	1984-12-09 00:00:00	1984-12-16	1984-12-16 00:00:00	32020		\N	228187	0	444814009	40481087		0
58198	3446	40481087	1997-11-19	1997-11-19 00:00:00	1997-12-10	1997-12-10 00:00:00	32020		\N	228851	0	444814009	40481087		0
58294	3454	4027663	2008-02-29	2008-02-29 00:00:00	\N	\N	32020		\N	229143	0	13200003	4027663		0
58464	3462	4112343	1969-05-20	1969-05-20 00:00:00	1969-05-27	1969-05-27 00:00:00	32020		\N	229730	0	195662009	4112343		0
69287	4101	4218389	1973-08-17	1973-08-17 00:00:00	1973-09-14	1973-09-14 00:00:00	32020		\N	272470	0	39848009	4218389		0
48300	2862	4285898	2005-12-03	2005-12-03 00:00:00	\N	\N	32020		\N	190309	0	68496003	4285898		0
48458	2869	40481087	1989-03-05	1989-03-05 00:00:00	1989-03-26	1989-03-26 00:00:00	32020		\N	190835	0	444814009	40481087		0
69748	4127	4152936	1994-03-16	1994-03-16 00:00:00	1994-04-06	1994-04-06 00:00:00	32020		\N	274343	0	283385000	4152936		0
70010	4142	4112343	1988-06-08	1988-06-08 00:00:00	1988-06-19	1988-06-19 00:00:00	32020		\N	275319	0	195662009	4112343		0
59471	3527	4112343	1962-11-08	1962-11-08 00:00:00	1962-11-15	1962-11-15 00:00:00	32020		\N	234087	0	195662009	4112343		0
59742	3540	4112343	1977-10-25	1977-10-25 00:00:00	1977-11-01	1977-11-01 00:00:00	32020		\N	235142	0	195662009	4112343		0
59926	3550	4294548	2014-09-19	2014-09-19 00:00:00	2014-10-31	2014-10-31 00:00:00	32020		\N	235748	0	75498004	4294548		0
60078	3559	378001	2001-03-20	2001-03-20 00:00:00	2001-04-19	2001-04-19 00:00:00	32020		\N	236262	0	62106007	378001		0
60215	3565	80180	1982-05-14	1982-05-14 00:00:00	\N	\N	32020		\N	236787	0	396275006	80180		0
60362	3571	4294548	2000-08-16	2000-08-16 00:00:00	2001-02-28	2001-02-28 00:00:00	32020		\N	237375	0	75498004	4294548		0
60426	3573	4112343	2004-01-12	2004-01-12 00:00:00	2004-01-22	2004-01-22 00:00:00	32020		\N	237585	0	195662009	4112343		0
60702	3593	40481087	1988-05-26	1988-05-26 00:00:00	1988-06-02	1988-06-02 00:00:00	32020		\N	238703	0	444814009	40481087		0
60798	3599	260139	1974-12-22	1974-12-22 00:00:00	1975-01-05	1975-01-05 00:00:00	32020		\N	239048	0	10509002	260139		0
61067	3614	260139	2008-03-30	2008-03-30 00:00:00	2008-04-13	2008-04-13 00:00:00	32020		\N	240115	0	10509002	260139		0
61150	3618	40481087	1958-05-17	1958-05-17 00:00:00	1958-06-07	1958-06-07 00:00:00	32020		\N	240427	0	444814009	40481087		0
61320	3624	260139	2001-03-22	2001-03-22 00:00:00	2001-03-29	2001-03-29 00:00:00	32020		\N	240970	0	10509002	260139		0
61482	3633	4230399	1979-10-03	1979-10-03 00:00:00	1980-01-01	1980-01-01 00:00:00	32020		\N	241652	0	359817006	4230399		0
51117	3026	28060	2004-08-09	2004-08-09 00:00:00	2004-08-21	2004-08-21 00:00:00	32020		\N	201777	0	43878008	28060		0
72399	4297	4116491	2018-12-26	2018-12-26 00:00:00	2019-02-16	2019-02-16 00:00:00	32020		\N	285198	0	301011002	4116491		0
72548	4309	4218389	1994-08-02	1994-08-02 00:00:00	1994-09-06	1994-09-06 00:00:00	32020		\N	285946	0	39848009	4218389		0
62190	3672	4027663	1993-03-10	1993-03-10 00:00:00	\N	\N	32020		\N	244319	0	13200003	4027663		0
72970	4337	40481087	1965-01-10	1965-01-10 00:00:00	1965-01-24	1965-01-24 00:00:00	32020		\N	287586	0	444814009	40481087		0
62553	3695	196456	1996-03-20	1996-03-20 00:00:00	1996-03-20	1996-03-20 00:00:00	32020		\N	245605	0	235919008	196456		0
62638	3700	260139	1973-12-23	1973-12-23 00:00:00	1974-01-06	1974-01-06 00:00:00	32020		\N	245970	0	10509002	260139		0
62914	3717	440086	1983-05-07	1983-05-07 00:00:00	1983-08-06	1983-08-06 00:00:00	32020		\N	247077	0	192127007	440086		0
62953	3719	4142905	2004-06-04	2004-06-04 00:00:00	2004-09-02	2004-09-02 00:00:00	32020		\N	247169	0	33737001	4142905		0
73746	4381	80180	2005-11-04	2005-11-04 00:00:00	\N	\N	32020		\N	291140	0	396275006	80180		0
73895	4390	40481087	1974-07-06	1974-07-06 00:00:00	1974-07-20	1974-07-20 00:00:00	32020		\N	291816	0	444814009	40481087		0
63576	3754	81151	1968-03-24	1968-03-24 00:00:00	1968-04-21	1968-04-21 00:00:00	32020		\N	249512	0	44465007	81151		0
74261	4409	40481087	1997-05-05	1997-05-05 00:00:00	1997-05-26	1997-05-26 00:00:00	32020		\N	293094	0	444814009	40481087		0
53265	3157	4113008	2011-02-12	2011-02-12 00:00:00	2011-03-05	2011-03-05 00:00:00	32020		\N	209881	0	284549007	4113008		0
63952	3779	4112343	1978-09-05	1978-09-05 00:00:00	1978-09-13	1978-09-13 00:00:00	32020		\N	251111	0	195662009	4112343		0
53607	3176	28060	1984-02-01	1984-02-01 00:00:00	1984-02-10	1984-02-10 00:00:00	32020		\N	211148	0	43878008	28060		0
53704	3178	4027663	1986-03-19	1986-03-19 00:00:00	\N	\N	32020		\N	211439	0	13200003	4027663		0
53815	3183	260139	2004-11-30	2004-11-30 00:00:00	2004-12-07	2004-12-07 00:00:00	32020		\N	211899	0	10509002	260139		0
54082	3201	4310024	1974-01-07	1974-01-07 00:00:00	\N	\N	32020		\N	212913	0	424802006	4310024		0
54141	3207	40481087	1999-10-26	1999-10-26 00:00:00	1999-11-02	1999-11-02 00:00:00	32020		\N	213154	0	444814009	40481087		0
54376	3221	440448	1967-06-02	1967-06-02 00:00:00	\N	\N	32020		\N	214131	0	74400008	440448		0
54498	3227	40481087	2007-04-29	2007-04-29 00:00:00	2007-05-06	2007-05-06 00:00:00	32020		\N	214513	0	444814009	40481087		0
54706	3237	4112343	2004-02-17	2004-02-17 00:00:00	2004-02-29	2004-02-29 00:00:00	32020		\N	215190	0	195662009	4112343		0
54876	3248	30753	1981-12-26	1981-12-26 00:00:00	\N	\N	32020		\N	215868	0	16761005	30753		0
65599	3879	4112343	1956-05-03	1956-05-03 00:00:00	1956-05-11	1956-05-11 00:00:00	32020		\N	257658	0	195662009	4112343		0
65796	3890	40481087	1990-02-20	1990-02-20 00:00:00	1990-03-13	1990-03-13 00:00:00	32020		\N	258552	0	444814009	40481087		0
55380	3280	378001	1964-09-02	1964-09-02 00:00:00	1964-10-02	1964-10-02 00:00:00	32020		\N	218035	0	62106007	378001		0
55550	3290	4294548	1971-07-28	1971-07-28 00:00:00	1971-08-04	1971-08-04 00:00:00	32020		\N	218545	0	75498004	4294548		0
55736	3298	28060	1984-04-22	1984-04-22 00:00:00	1984-04-30	1984-04-30 00:00:00	32020		\N	219126	0	43878008	28060		0
55813	3304	260139	1997-06-06	1997-06-06 00:00:00	1997-06-13	1997-06-13 00:00:00	32020		\N	219447	0	10509002	260139		0
66616	3941	260139	1963-12-19	1963-12-19 00:00:00	1964-01-02	1964-01-02 00:00:00	32020		\N	261998	0	10509002	260139		0
56258	3334	40481087	2019-04-11	2019-04-11 00:00:00	2019-04-18	2019-04-18 00:00:00	32020		\N	221178	0	444814009	40481087		0
56402	3343	4112343	1999-05-03	1999-05-03 00:00:00	1999-05-12	1999-05-12 00:00:00	32020		\N	221785	0	195662009	4112343		0
56547	3353	40481087	1958-08-01	1958-08-01 00:00:00	1958-08-15	1958-08-15 00:00:00	32020		\N	222379	0	444814009	40481087		0
67331	3980	40481087	1995-11-13	1995-11-13 00:00:00	1995-12-04	1995-12-04 00:00:00	32020		\N	264615	0	444814009	40481087		0
56910	3376	4112343	1994-12-25	1994-12-25 00:00:00	1995-01-07	1995-01-07 00:00:00	32020		\N	224055	0	195662009	4112343		0
57019	3382	4112343	1979-04-08	1979-04-08 00:00:00	1979-04-16	1979-04-16 00:00:00	32020		\N	224414	0	195662009	4112343		0
57141	3391	260139	2008-07-16	2008-07-16 00:00:00	2008-07-30	2008-07-30 00:00:00	32020		\N	224909	0	10509002	260139		0
57409	3408	30753	2007-07-23	2007-07-23 00:00:00	\N	\N	32020		\N	226047	0	16761005	30753		0
57553	3414	378001	2016-10-29	2016-10-29 00:00:00	2016-11-28	2016-11-28 00:00:00	32020		\N	226452	0	62106007	378001		0
57729	3423	81151	1979-12-20	1979-12-20 00:00:00	1980-01-03	1980-01-03 00:00:00	32020		\N	227092	0	44465007	81151		0
57891	3434	40481087	1992-01-22	1992-01-22 00:00:00	1992-02-05	1992-02-05 00:00:00	32020		\N	227692	0	444814009	40481087		0
58027	3439	4283893	1997-04-19	1997-04-19 00:00:00	1997-05-17	1997-05-17 00:00:00	32020		\N	228217	0	36971009	4283893		0
58199	3446	440086	1951-12-11	1951-12-11 00:00:00	1953-07-28	1953-07-28 00:00:00	32020		\N	228867	0	192127007	440086		0
58295	3454	372328	1983-04-06	1983-04-06 00:00:00	1983-06-13	1983-06-13 00:00:00	32020		\N	229190	0	65363002	372328		0
58465	3462	40481087	2008-07-27	2008-07-27 00:00:00	2008-08-10	2008-08-10 00:00:00	32020		\N	229715	0	444814009	40481087		0
69288	4101	4156265	1987-12-30	1987-12-30 00:00:00	1988-01-20	1988-01-20 00:00:00	32020		\N	272524	0	370247008	4156265		0
48301	2862	30753	2005-09-05	2005-09-05 00:00:00	\N	\N	32020		\N	190309	0	16761005	30753		0
48459	2869	40479422	1954-10-24	1954-10-24 00:00:00	1954-12-30	1954-12-30 00:00:00	32020		\N	190822	0	444448004	40479422		0
69749	4127	260139	1976-07-05	1976-07-05 00:00:00	1976-07-19	1976-07-19 00:00:00	32020		\N	274339	0	10509002	260139		0
70011	4142	40481087	1999-04-16	1999-04-16 00:00:00	1999-04-23	1999-04-23 00:00:00	32020		\N	275305	0	444814009	40481087		0
59472	3527	40481087	2017-03-19	2017-03-19 00:00:00	2017-03-26	2017-03-26 00:00:00	32020		\N	234037	0	444814009	40481087		0
59743	3540	4134304	1976-09-14	1976-09-14 00:00:00	1976-11-13	1976-11-13 00:00:00	32020		\N	235121	0	263102004	4134304		0
70385	4168	40481087	1986-08-28	1986-08-28 00:00:00	1986-09-11	1986-09-11 00:00:00	32020		\N	277044	0	444814009	40481087		0
60079	3559	40481087	2010-08-28	2010-08-28 00:00:00	2010-09-18	2010-09-18 00:00:00	32020		\N	236269	0	444814009	40481087		0
60216	3565	4285898	1982-03-15	1982-03-15 00:00:00	\N	\N	32020		\N	236787	0	68496003	4285898		0
60363	3571	4112343	1979-06-02	1979-06-02 00:00:00	1979-06-15	1979-06-15 00:00:00	32020		\N	237385	0	195662009	4112343		0
60427	3573	80502	2003-10-18	2003-10-18 00:00:00	\N	\N	32020		\N	237525	0	64859006	80502		0
60703	3593	4218389	2017-08-17	2017-08-17 00:00:00	2017-09-07	2017-09-07 00:00:00	32020		\N	238689	0	39848009	4218389		0
60799	3599	40481087	1998-11-14	1998-11-14 00:00:00	1998-11-21	1998-11-21 00:00:00	32020		\N	239055	0	444814009	40481087		0
61068	3614	40481087	2009-11-17	2009-11-17 00:00:00	2009-12-08	2009-12-08 00:00:00	32020		\N	240138	0	444814009	40481087		0
61151	3618	4059173	1982-06-20	1982-06-20 00:00:00	1982-09-18	1982-09-18 00:00:00	32020		\N	240343	0	16114001	4059173		0
61321	3624	4155034	2008-05-26	2008-05-26 00:00:00	2008-06-16	2008-06-16 00:00:00	32020		\N	241012	0	283371005	4155034		0
61483	3633	4109685	1975-02-12	1975-02-12 00:00:00	1975-02-26	1975-02-26 00:00:00	32020		\N	241651	0	284551006	4109685		0
51118	3026	4112343	2011-12-17	2011-12-17 00:00:00	2011-12-29	2011-12-29 00:00:00	32020		\N	201778	0	195662009	4112343		0
72400	4297	260139	1977-12-13	1977-12-13 00:00:00	1977-12-27	1977-12-27 00:00:00	32020		\N	285185	0	10509002	260139		0
72549	4309	40481087	1961-07-03	1961-07-03 00:00:00	1961-07-24	1961-07-24 00:00:00	32020		\N	285893	0	444814009	40481087		0
62191	3672	4112343	2008-01-17	2008-01-17 00:00:00	2008-01-27	2008-01-27 00:00:00	32020		\N	244308	0	195662009	4112343		0
72971	4337	4218389	1966-12-01	1966-12-01 00:00:00	1967-01-05	1967-01-05 00:00:00	32020		\N	287615	0	39848009	4218389		0
62554	3695	198809	1996-03-20	1996-03-20 00:00:00	1996-03-20	1996-03-20 00:00:00	32020		\N	245605	0	65275009	198809		0
62639	3700	4027663	1996-08-23	1996-08-23 00:00:00	\N	\N	32020		\N	246021	0	13200003	4027663		0
73389	4364	4112343	2013-01-31	2013-01-31 00:00:00	2013-02-10	2013-02-10 00:00:00	32020		\N	289470	0	195662009	4112343		0
62954	3719	40481087	1983-05-20	1983-05-20 00:00:00	1983-06-03	1983-06-03 00:00:00	32020		\N	247193	0	444814009	40481087		0
73747	4381	372328	1965-03-29	1965-03-29 00:00:00	1965-05-11	1965-05-11 00:00:00	32020		\N	291094	0	65363002	372328		0
73896	4390	4001336	1961-12-22	1961-12-22 00:00:00	1962-02-20	1962-02-20 00:00:00	32020		\N	291788	0	110030002	4001336		0
63577	3754	4156265	1986-07-16	1986-07-16 00:00:00	1986-07-30	1986-07-30 00:00:00	32020		\N	249513	0	370247008	4156265		0
74262	4409	40481087	1998-08-24	1998-08-24 00:00:00	1998-09-07	1998-09-07 00:00:00	32020		\N	293123	0	444814009	40481087		0
53266	3157	372328	1955-07-01	1955-07-01 00:00:00	1955-12-09	1955-12-09 00:00:00	32020		\N	209886	0	65363002	372328		0
63953	3779	260139	1975-08-07	1975-08-07 00:00:00	1975-08-14	1975-08-14 00:00:00	32020		\N	251144	0	10509002	260139		0
53608	3176	40481087	1981-09-22	1981-09-22 00:00:00	1981-10-13	1981-10-13 00:00:00	32020		\N	211197	0	444814009	40481087		0
53705	3179	4112343	1928-02-04	1928-02-04 00:00:00	1928-02-14	1928-02-14 00:00:00	32020		\N	211511	0	195662009	4112343		0
53816	3183	80180	2017-07-14	2017-07-14 00:00:00	\N	\N	32020		\N	211934	0	396275006	80180		0
54083	3201	4266809	1976-07-25	1976-07-25 00:00:00	\N	\N	32020		\N	212913	0	397881000	4266809		0
54142	3207	78272	1990-07-01	1990-07-01 00:00:00	1990-07-29	1990-07-29 00:00:00	32020		\N	213205	0	70704007	78272		0
54377	3221	260139	2001-01-29	2001-01-29 00:00:00	2001-02-05	2001-02-05 00:00:00	32020		\N	214110	0	10509002	260139		0
54499	3227	4112343	1994-03-14	1994-03-14 00:00:00	1994-03-25	1994-03-25 00:00:00	32020		\N	214512	0	195662009	4112343		0
54707	3237	4134304	1971-01-27	1971-01-27 00:00:00	1971-02-26	1971-02-26 00:00:00	32020		\N	215153	0	263102004	4134304		0
54877	3248	260139	1986-11-06	1986-11-06 00:00:00	1986-11-20	1986-11-20 00:00:00	32020		\N	215897	0	10509002	260139		0
65600	3879	4218389	1941-11-03	1941-11-03 00:00:00	1941-12-01	1941-12-01 00:00:00	32020		\N	257653	0	39848009	4218389		0
65797	3890	192671	1993-03-25	1993-03-25 00:00:00	\N	\N	32020		\N	258556	0	K92.2	35208414		0
55381	3280	80502	2011-11-10	2011-11-10 00:00:00	\N	\N	32020		\N	217974	0	64859006	80502		0
55551	3290	192671	2004-06-29	2004-06-29 00:00:00	\N	\N	32020		\N	218561	0	K92.2	35208414		0
55737	3298	40481087	1976-11-24	1976-11-24 00:00:00	1976-12-08	1976-12-08 00:00:00	32020		\N	219140	0	444814009	40481087		0
55814	3304	40481087	1992-03-24	1992-03-24 00:00:00	1992-03-31	1992-03-31 00:00:00	32020		\N	219453	0	444814009	40481087		0
66617	3941	40481087	2001-12-03	2001-12-03 00:00:00	2001-12-17	2001-12-17 00:00:00	32020		\N	262048	0	444814009	40481087		0
56259	3334	40481087	1950-10-06	1950-10-06 00:00:00	1950-10-27	1950-10-27 00:00:00	32020		\N	221143	0	444814009	40481087		0
56403	3343	4112343	1983-08-02	1983-08-02 00:00:00	1983-08-14	1983-08-14 00:00:00	32020		\N	221772	0	195662009	4112343		0
56548	3353	4134304	1948-05-16	1948-05-16 00:00:00	1948-06-15	1948-06-15 00:00:00	32020		\N	222426	0	263102004	4134304		0
67332	3980	40481087	2000-03-16	2000-03-16 00:00:00	2000-04-06	2000-04-06 00:00:00	32020		\N	264563	0	444814009	40481087		0
56911	3376	4112343	1977-04-07	1977-04-07 00:00:00	1977-04-14	1977-04-14 00:00:00	32020		\N	223954	0	195662009	4112343		0
57020	3382	28060	2014-07-10	2014-07-10 00:00:00	2014-07-23	2014-07-23 00:00:00	32020		\N	224447	0	43878008	28060		0
57142	3391	4237458	2005-12-25	2005-12-25 00:00:00	2006-01-24	2006-01-24 00:00:00	32020		\N	224901	0	58150001	4237458		0
57410	3408	81151	2010-01-06	2010-01-06 00:00:00	2010-01-27	2010-01-27 00:00:00	32020		\N	226023	0	44465007	81151		0
57554	3414	40481087	1981-09-14	1981-09-14 00:00:00	1981-09-21	1981-09-21 00:00:00	32020		\N	226448	0	444814009	40481087		0
57730	3423	440448	2007-03-14	2007-03-14 00:00:00	\N	\N	32020		\N	227096	0	74400008	440448		0
57892	3434	80180	1983-11-05	1983-11-05 00:00:00	\N	\N	32020		\N	227738	0	396275006	80180		0
58028	3439	372328	1957-01-30	1957-01-30 00:00:00	1957-08-15	1957-08-15 00:00:00	32020		\N	228219	0	65363002	372328		0
58200	3446	40481087	2004-11-11	2004-11-11 00:00:00	2004-11-18	2004-11-18 00:00:00	32020		\N	228788	0	444814009	40481087		0
58296	3454	378001	1994-04-08	1994-04-08 00:00:00	1994-05-08	1994-05-08 00:00:00	32020		\N	229141	0	62106007	378001		0
58466	3462	375671	1989-06-30	1989-06-30 00:00:00	1989-07-30	1989-07-30 00:00:00	32020		\N	229768	0	62564004	375671		0
69289	4101	260139	1978-05-24	1978-05-24 00:00:00	1978-05-31	1978-05-31 00:00:00	32020		\N	272515	0	10509002	260139		0
48302	2862	4310024	2004-06-12	2004-06-12 00:00:00	\N	\N	32020		\N	190309	0	424802006	4310024		0
48460	2869	80180	1989-02-06	1989-02-06 00:00:00	\N	\N	32020		\N	190854	0	396275006	80180		0
69750	4127	4112343	2018-10-27	2018-10-27 00:00:00	2018-11-08	2018-11-08 00:00:00	32020		\N	274348	0	195662009	4112343		0
70012	4142	28060	1992-10-28	1992-10-28 00:00:00	1992-11-04	1992-11-04 00:00:00	32020		\N	275320	0	43878008	28060		0
59473	3527	40481087	1996-09-26	1996-09-26 00:00:00	1996-10-03	1996-10-03 00:00:00	32020		\N	234073	0	444814009	40481087		0
59744	3540	4113008	2019-06-13	2019-06-13 00:00:00	\N	\N	32020		\N	235125	0	284549007	4113008		0
70386	4168	4283893	1975-09-14	1975-09-14 00:00:00	1975-10-12	1975-10-12 00:00:00	32020		\N	277043	0	36971009	4283893		0
60080	3559	4112343	1969-05-11	1969-05-11 00:00:00	1969-05-18	1969-05-18 00:00:00	32020		\N	236266	0	195662009	4112343		0
60217	3565	40481087	1979-06-14	1979-06-14 00:00:00	1979-06-28	1979-06-28 00:00:00	32020		\N	236787	0	444814009	40481087		0
60364	3571	4112343	1994-06-16	1994-06-16 00:00:00	1994-06-25	1994-06-25 00:00:00	32020		\N	237374	0	195662009	4112343		0
60428	3573	4156265	2010-11-27	2010-11-27 00:00:00	2010-12-18	2010-12-18 00:00:00	32020		\N	237631	0	370247008	4156265		0
60704	3593	40481087	2003-11-18	2003-11-18 00:00:00	2003-11-25	2003-11-25 00:00:00	32020		\N	238675	0	444814009	40481087		0
60800	3599	81151	1973-03-30	1973-03-30 00:00:00	1973-04-27	1973-04-27 00:00:00	32020		\N	239082	0	44465007	81151		0
61069	3614	372328	1974-06-25	1974-06-25 00:00:00	1977-07-10	1977-07-10 00:00:00	32020		\N	240107	0	65363002	372328		0
61152	3618	4112343	1952-12-08	1952-12-08 00:00:00	1952-12-17	1952-12-17 00:00:00	32020		\N	240447	0	195662009	4112343		0
61322	3624	40481087	2013-11-03	2013-11-03 00:00:00	2013-11-24	2013-11-24 00:00:00	32020		\N	240997	0	444814009	40481087		0
61484	3633	40481087	2001-01-13	2001-01-13 00:00:00	2001-01-20	2001-01-20 00:00:00	32020		\N	241683	0	444814009	40481087		0
51119	3026	4278672	2017-05-11	2017-05-11 00:00:00	2017-08-09	2017-08-09 00:00:00	32020		\N	201729	0	65966004	4278672		0
72401	4297	372328	1974-10-28	1974-10-28 00:00:00	1974-12-14	1974-12-14 00:00:00	32020		\N	285190	0	65363002	372328		0
72550	4309	40481087	1969-11-30	1969-11-30 00:00:00	1969-12-07	1969-12-07 00:00:00	32020		\N	285895	0	444814009	40481087		0
62192	3672	40481087	2000-03-15	2000-03-15 00:00:00	2000-03-29	2000-03-29 00:00:00	32020		\N	244328	0	444814009	40481087		0
72972	4337	260139	1962-04-07	1962-04-07 00:00:00	1962-04-14	1962-04-14 00:00:00	32020		\N	287600	0	10509002	260139		0
62561	3697	4112343	1953-07-12	1953-07-12 00:00:00	1953-07-24	1953-07-24 00:00:00	32020		\N	245768	0	195662009	4112343		0
62640	3700	40481087	2015-03-15	2015-03-15 00:00:00	2015-03-29	2015-03-29 00:00:00	32020		\N	245998	0	444814009	40481087		0
73390	4364	40481087	2013-06-03	2013-06-03 00:00:00	2013-06-24	2013-06-24 00:00:00	32020		\N	289497	0	444814009	40481087		0
62955	3719	78272	1989-11-17	1989-11-17 00:00:00	1989-12-22	1989-12-22 00:00:00	32020		\N	247167	0	70704007	78272		0
73748	4381	40481087	1982-06-19	1982-06-19 00:00:00	1982-06-26	1982-06-26 00:00:00	32020		\N	291083	0	444814009	40481087		0
73897	4390	4132546	1961-12-22	1961-12-22 00:00:00	\N	\N	32020		\N	291788	0	275272006	4166590		0
63578	3754	40481087	1996-03-23	1996-03-23 00:00:00	1996-03-30	1996-03-30 00:00:00	32020		\N	249463	0	444814009	40481087		0
74263	4409	378001	1970-01-03	1970-01-03 00:00:00	1970-03-04	1970-03-04 00:00:00	32020		\N	293126	0	62106007	378001		0
53267	3157	257012	2008-03-26	2008-03-26 00:00:00	\N	\N	32020		\N	209836	0	40055000	257012		0
63954	3779	78272	2003-06-10	2003-06-10 00:00:00	2003-07-08	2003-07-08 00:00:00	32020		\N	251147	0	70704007	78272		0
53609	3176	78272	1989-02-16	1989-02-16 00:00:00	1989-03-16	1989-03-16 00:00:00	32020		\N	211123	0	70704007	78272		0
53706	3179	81151	1925-10-30	1925-10-30 00:00:00	1925-11-20	1925-11-20 00:00:00	32020		\N	211526	0	44465007	81151		0
53817	3183	260139	1993-10-19	1993-10-19 00:00:00	1993-11-02	1993-11-02 00:00:00	32020		\N	211921	0	10509002	260139		0
54084	3201	260139	1958-08-25	1958-08-25 00:00:00	1958-09-01	1958-09-01 00:00:00	32020		\N	212921	0	10509002	260139		0
54143	3207	81151	1982-11-05	1982-11-05 00:00:00	1982-12-10	1982-12-10 00:00:00	32020		\N	213204	0	44465007	81151		0
54378	3221	4218389	1992-07-12	1992-07-12 00:00:00	1992-08-16	1992-08-16 00:00:00	32020		\N	214133	0	39848009	4218389		0
54500	3227	80180	2004-10-04	2004-10-04 00:00:00	\N	\N	32020		\N	214520	0	396275006	80180		0
54708	3237	260139	2000-01-17	2000-01-17 00:00:00	2000-01-31	2000-01-31 00:00:00	32020		\N	215176	0	10509002	260139		0
54878	3248	260139	2004-02-29	2004-02-29 00:00:00	2004-03-07	2004-03-07 00:00:00	32020		\N	215922	0	10509002	260139		0
65601	3879	260139	1996-10-13	1996-10-13 00:00:00	1996-10-20	1996-10-20 00:00:00	32020		\N	257659	0	10509002	260139		0
65798	3890	4112343	1987-01-19	1987-01-19 00:00:00	1987-02-01	1987-02-01 00:00:00	32020		\N	258559	0	195662009	4112343		0
55382	3280	40481087	1966-08-06	1966-08-06 00:00:00	1966-08-27	1966-08-27 00:00:00	32020		\N	218030	0	444814009	40481087		0
55552	3290	40481087	1984-08-18	1984-08-18 00:00:00	1984-08-25	1984-08-25 00:00:00	32020		\N	218595	0	444814009	40481087		0
55738	3298	40481087	1993-03-20	1993-03-20 00:00:00	1993-04-10	1993-04-10 00:00:00	32020		\N	219148	0	444814009	40481087		0
55815	3304	260139	1990-08-03	1990-08-03 00:00:00	1990-08-10	1990-08-10 00:00:00	32020		\N	219446	0	10509002	260139		0
66618	3941	4310024	1997-12-09	1997-12-09 00:00:00	\N	\N	32020		\N	262035	0	424802006	4310024		0
56260	3334	378001	1961-09-01	1961-09-01 00:00:00	1961-10-31	1961-10-31 00:00:00	32020		\N	221158	0	62106007	378001		0
56404	3343	4051466	1978-06-13	1978-06-13 00:00:00	1995-09-12	1995-09-12 00:00:00	32020		\N	221805	0	233678006	4051466		0
56549	3353	4156265	1983-12-19	1983-12-19 00:00:00	1984-01-09	1984-01-09 00:00:00	32020		\N	222450	0	370247008	4156265		0
67333	3980	4134304	1986-04-18	1986-04-18 00:00:00	1986-05-18	1986-05-18 00:00:00	32020		\N	264578	0	263102004	4134304		0
56912	3376	40481087	1967-08-31	1967-08-31 00:00:00	1967-09-21	1967-09-21 00:00:00	32020		\N	223993	0	444814009	40481087		0
57021	3382	260139	1978-11-01	1978-11-01 00:00:00	1978-11-08	1978-11-08 00:00:00	32020		\N	224413	0	10509002	260139		0
57143	3391	257012	1986-12-12	1986-12-12 00:00:00	\N	\N	32020		\N	224923	0	40055000	257012		0
57411	3408	372328	1971-10-25	1971-10-25 00:00:00	1971-12-13	1971-12-13 00:00:00	32020		\N	226001	0	65363002	372328		0
57555	3414	260139	1985-03-05	1985-03-05 00:00:00	1985-03-12	1985-03-12 00:00:00	32020		\N	226485	0	10509002	260139		0
57731	3423	40481087	2010-05-27	2010-05-27 00:00:00	2010-06-10	2010-06-10 00:00:00	32020		\N	227058	0	444814009	40481087		0
57893	3434	4112343	1961-08-16	1961-08-16 00:00:00	1961-08-29	1961-08-29 00:00:00	32020		\N	227687	0	195662009	4112343		0
58029	3439	40481087	2003-01-14	2003-01-14 00:00:00	2003-01-28	2003-01-28 00:00:00	32020		\N	228193	0	444814009	40481087		0
58201	3446	4109685	2000-09-20	2000-09-20 00:00:00	2000-10-04	2000-10-04 00:00:00	32020		\N	228785	0	284551006	4109685		0
58297	3454	40481087	1997-05-29	1997-05-29 00:00:00	1997-06-12	1997-06-12 00:00:00	32020		\N	229162	0	444814009	40481087		0
58467	3462	40481087	1992-04-13	1992-04-13 00:00:00	1992-04-27	1992-04-27 00:00:00	32020		\N	229684	0	444814009	40481087		0
69290	4101	372328	1965-09-28	1965-09-28 00:00:00	1966-10-15	1966-10-15 00:00:00	32020		\N	272517	0	65363002	372328		0
48303	2862	80180	2006-04-03	2006-04-03 00:00:00	\N	\N	32020		\N	190309	0	396275006	80180		0
48461	2869	40481087	2004-10-13	2004-10-13 00:00:00	2004-10-20	2004-10-20 00:00:00	32020		\N	190892	0	444814009	40481087		0
69751	4127	4112343	1991-08-23	1991-08-23 00:00:00	1991-09-05	1991-09-05 00:00:00	32020		\N	274335	0	195662009	4112343		0
70013	4143	81151	1996-06-27	1996-06-27 00:00:00	1996-07-11	1996-07-11 00:00:00	32020		\N	275404	0	44465007	81151		0
59474	3527	40481087	2005-04-14	2005-04-14 00:00:00	2005-05-05	2005-05-05 00:00:00	32020		\N	234035	0	444814009	40481087		0
59745	3540	260139	1984-05-06	1984-05-06 00:00:00	1984-05-13	1984-05-13 00:00:00	32020		\N	235134	0	10509002	260139		0
70387	4168	40481087	1998-08-31	1998-08-31 00:00:00	1998-09-07	1998-09-07 00:00:00	32020		\N	277039	0	444814009	40481087		0
60081	3559	40481087	2015-01-20	2015-01-20 00:00:00	2015-02-03	2015-02-03 00:00:00	32020		\N	236318	0	444814009	40481087		0
60218	3565	81893	1980-07-23	1980-07-23 00:00:00	\N	\N	32020		\N	236787	0	64766004	81893		0
60365	3571	40481087	2013-02-24	2013-02-24 00:00:00	2013-03-17	2013-03-17 00:00:00	32020		\N	237314	0	444814009	40481087		0
60429	3573	40481087	1942-03-15	1942-03-15 00:00:00	1942-04-05	1942-04-05 00:00:00	32020		\N	237518	0	444814009	40481087		0
60705	3593	40481087	1973-06-21	1973-06-21 00:00:00	1973-07-05	1973-07-05 00:00:00	32020		\N	238668	0	444814009	40481087		0
60801	3599	40481087	1983-08-23	1983-08-23 00:00:00	1983-08-30	1983-08-30 00:00:00	32020		\N	239047	0	444814009	40481087		0
61070	3614	80180	1989-11-03	1989-11-03 00:00:00	\N	\N	32020		\N	240095	0	396275006	80180		0
61153	3618	80180	1953-01-31	1953-01-31 00:00:00	\N	\N	32020		\N	240447	0	396275006	80180		0
61323	3624	40481087	1967-09-29	1967-09-29 00:00:00	1967-10-20	1967-10-20 00:00:00	32020		\N	240966	0	444814009	40481087		0
61485	3633	4112343	1985-04-04	1985-04-04 00:00:00	1985-04-11	1985-04-11 00:00:00	32020		\N	241681	0	195662009	4112343		0
51120	3026	4112343	1996-05-10	1996-05-10 00:00:00	1996-05-19	1996-05-19 00:00:00	32020		\N	201775	0	195662009	4112343		0
72402	4297	4112343	1973-10-06	1973-10-06 00:00:00	1973-10-14	1973-10-14 00:00:00	32020		\N	285166	0	195662009	4112343		0
72551	4309	378001	2015-12-15	2015-12-15 00:00:00	2016-02-13	2016-02-13 00:00:00	32020		\N	285947	0	62106007	378001		0
62212	3675	40481087	1969-08-12	1969-08-12 00:00:00	1969-08-19	1969-08-19 00:00:00	32020		\N	244430	0	444814009	40481087		0
72973	4337	260139	1977-02-07	1977-02-07 00:00:00	1977-02-21	1977-02-21 00:00:00	32020		\N	287589	0	10509002	260139		0
62562	3697	40481087	1981-07-11	1981-07-11 00:00:00	1981-07-18	1981-07-18 00:00:00	32020		\N	245782	0	444814009	40481087		0
62641	3700	372328	1982-07-31	1982-07-31 00:00:00	1982-10-13	1982-10-13 00:00:00	32020		\N	245999	0	65363002	372328		0
73391	4364	40481087	1983-08-19	1983-08-19 00:00:00	1983-08-26	1983-08-26 00:00:00	32020		\N	289450	0	444814009	40481087		0
62956	3719	378001	1974-05-10	1974-05-10 00:00:00	1974-06-09	1974-06-09 00:00:00	32020		\N	247204	0	62106007	378001		0
73749	4381	40481087	2017-02-03	2017-02-03 00:00:00	2017-02-10	2017-02-10 00:00:00	32020		\N	291077	0	444814009	40481087		0
73898	4390	260139	1985-09-13	1985-09-13 00:00:00	1985-09-27	1985-09-27 00:00:00	32020		\N	291817	0	10509002	260139		0
74041	4398	378001	1991-09-02	1991-09-02 00:00:00	1991-11-01	1991-11-01 00:00:00	32020		\N	292434	0	62106007	378001		0
74264	4409	40481087	1990-02-28	1990-02-28 00:00:00	1990-03-07	1990-03-07 00:00:00	32020		\N	293054	0	444814009	40481087		0
53268	3157	81151	1966-09-17	1966-09-17 00:00:00	1966-10-15	1966-10-15 00:00:00	32020		\N	209879	0	44465007	81151		0
63955	3779	40481087	1996-02-24	1996-02-24 00:00:00	1996-03-09	1996-03-09 00:00:00	32020		\N	251113	0	444814009	40481087		0
53610	3176	4146173	1994-04-19	1994-04-19 00:00:00	1994-06-18	1994-06-18 00:00:00	32020		\N	211106	0	307731004	4146173		0
53707	3179	40481087	1929-11-16	1929-11-16 00:00:00	1929-11-23	1929-11-23 00:00:00	32020		\N	211501	0	444814009	40481087		0
53818	3183	372328	1983-04-29	1983-04-29 00:00:00	1983-07-17	1983-07-17 00:00:00	32020		\N	211900	0	65363002	372328		0
54085	3201	4112343	1959-06-02	1959-06-02 00:00:00	1959-06-15	1959-06-15 00:00:00	32020		\N	212893	0	195662009	4112343		0
54144	3207	28060	1971-02-09	1971-02-09 00:00:00	1971-02-22	1971-02-22 00:00:00	32020		\N	213147	0	43878008	28060		0
54379	3221	260139	1977-04-16	1977-04-16 00:00:00	1977-04-30	1977-04-30 00:00:00	32020		\N	214069	0	10509002	260139		0
54501	3227	260139	1976-01-22	1976-01-22 00:00:00	1976-02-05	1976-02-05 00:00:00	32020		\N	214530	0	10509002	260139		0
54709	3238	260139	1986-02-27	1986-02-27 00:00:00	1986-03-13	1986-03-13 00:00:00	32020		\N	215276	0	10509002	260139		0
54879	3248	4112343	1954-03-08	1954-03-08 00:00:00	1954-03-21	1954-03-21 00:00:00	32020		\N	215928	0	195662009	4112343		0
65602	3879	4116491	1971-01-15	1971-01-15 00:00:00	1971-03-05	1971-03-05 00:00:00	32020		\N	257690	0	301011002	4116491		0
65799	3890	372328	1955-07-07	1955-07-07 00:00:00	1955-12-27	1955-12-27 00:00:00	32020		\N	258570	0	65363002	372328		0
55383	3280	261325	2016-12-08	2016-12-08 00:00:00	\N	\N	32020		\N	218000	0	87433001	261325		0
55553	3290	260139	1970-03-29	1970-03-29 00:00:00	1970-04-05	1970-04-05 00:00:00	32020		\N	218548	0	10509002	260139		0
55739	3298	372328	1975-11-22	1975-11-22 00:00:00	1976-07-25	1976-07-25 00:00:00	32020		\N	219164	0	65363002	372328		0
55816	3304	40481087	1981-12-04	1981-12-04 00:00:00	1981-12-25	1981-12-25 00:00:00	32020		\N	219425	0	444814009	40481087		0
66619	3941	4112343	1965-06-13	1965-06-13 00:00:00	1965-06-20	1965-06-20 00:00:00	32020		\N	262057	0	195662009	4112343		0
56261	3334	4112343	2000-07-27	2000-07-27 00:00:00	2000-08-03	2000-08-03 00:00:00	32020		\N	221147	0	195662009	4112343		0
56405	3343	4112343	1991-06-06	1991-06-06 00:00:00	1991-06-13	1991-06-13 00:00:00	32020		\N	221870	0	195662009	4112343		0
56550	3353	260139	1933-03-03	1933-03-03 00:00:00	1933-03-10	1933-03-10 00:00:00	32020		\N	222389	0	10509002	260139		0
67334	3980	40481087	1986-05-04	1986-05-04 00:00:00	1986-05-25	1986-05-25 00:00:00	32020		\N	264561	0	444814009	40481087		0
56913	3376	260139	1961-11-11	1961-11-11 00:00:00	1961-11-25	1961-11-25 00:00:00	32020		\N	224007	0	10509002	260139		0
57022	3382	4112343	1990-01-19	1990-01-19 00:00:00	1990-01-31	1990-01-31 00:00:00	32020		\N	224415	0	195662009	4112343		0
57144	3391	40481087	2011-12-12	2011-12-12 00:00:00	2011-12-19	2011-12-19 00:00:00	32020		\N	224888	0	444814009	40481087		0
57412	3408	260139	1997-01-13	1997-01-13 00:00:00	1997-01-20	1997-01-20 00:00:00	32020		\N	226007	0	10509002	260139		0
57556	3414	378001	1971-12-04	1971-12-04 00:00:00	1972-02-02	1972-02-02 00:00:00	32020		\N	226450	0	62106007	378001		0
57733	3423	4112343	1998-11-19	1998-11-19 00:00:00	1998-11-29	1998-11-29 00:00:00	32020		\N	227040	0	195662009	4112343		0
57894	3434	4112343	1964-04-05	1964-04-05 00:00:00	1964-04-12	1964-04-12 00:00:00	32020		\N	227695	0	195662009	4112343		0
58030	3439	28060	1983-06-06	1983-06-06 00:00:00	1983-06-19	1983-06-19 00:00:00	32020		\N	228143	0	43878008	28060		0
58202	3446	372328	1944-09-08	1944-09-08 00:00:00	1944-11-20	1944-11-20 00:00:00	32020		\N	228769	0	65363002	372328		0
58298	3454	40481087	2010-10-31	2010-10-31 00:00:00	2010-11-14	2010-11-14 00:00:00	32020		\N	229179	0	444814009	40481087		0
58487	3464	4059173	1997-04-15	1997-04-15 00:00:00	1997-05-15	1997-05-15 00:00:00	32020		\N	229947	0	16114001	4059173		0
69291	4101	40481087	1966-07-30	1966-07-30 00:00:00	1966-08-20	1966-08-20 00:00:00	32020		\N	272508	0	444814009	40481087		0
48304	2862	4156265	1999-03-15	1999-03-15 00:00:00	1999-04-06	1999-04-06 00:00:00	32020		\N	190261	0	370247008	4156265		0
48462	2869	4112343	2018-01-23	2018-01-23 00:00:00	2018-01-31	2018-01-31 00:00:00	32020		\N	190849	0	195662009	4112343		0
69752	4127	4112343	1967-10-13	1967-10-13 00:00:00	1967-10-25	1967-10-25 00:00:00	32020		\N	274313	0	195662009	4112343		0
70014	4143	375671	1968-07-24	1968-07-24 00:00:00	1968-08-23	1968-08-23 00:00:00	32020		\N	275403	0	62564004	375671		0
59475	3527	40481087	2013-08-27	2013-08-27 00:00:00	2013-09-17	2013-09-17 00:00:00	32020		\N	234074	0	444814009	40481087		0
59746	3540	4112343	1982-05-10	1982-05-10 00:00:00	1982-05-18	1982-05-18 00:00:00	32020		\N	235143	0	195662009	4112343		0
70388	4168	40481087	1981-07-03	1981-07-03 00:00:00	1981-07-17	1981-07-17 00:00:00	32020		\N	277023	0	444814009	40481087		0
60082	3559	260139	1983-04-29	1983-04-29 00:00:00	1983-05-13	1983-05-13 00:00:00	32020		\N	236276	0	10509002	260139		0
60219	3565	4266809	1982-05-14	1982-05-14 00:00:00	\N	\N	32020		\N	236787	0	397881000	4266809		0
60366	3571	40481087	1999-04-27	1999-04-27 00:00:00	1999-05-18	1999-05-18 00:00:00	32020		\N	237363	0	444814009	40481087		0
60430	3573	4134304	1936-02-19	1936-02-19 00:00:00	1936-03-20	1936-03-20 00:00:00	32020		\N	237623	0	263102004	4134304		0
60706	3593	40481087	2006-11-30	2006-11-30 00:00:00	2006-12-14	2006-12-14 00:00:00	32020		\N	238718	0	444814009	40481087		0
60802	3599	28060	1979-10-10	1979-10-10 00:00:00	1979-10-22	1979-10-22 00:00:00	32020		\N	239065	0	43878008	28060		0
61071	3614	40481087	1955-09-07	1955-09-07 00:00:00	1955-09-21	1955-09-21 00:00:00	32020		\N	240147	0	444814009	40481087		0
61154	3618	4283893	1994-04-29	1994-04-29 00:00:00	1994-06-24	1994-06-24 00:00:00	32020		\N	240457	0	36971009	4283893		0
61324	3624	372328	1950-08-31	1950-08-31 00:00:00	1951-06-14	1951-06-14 00:00:00	32020		\N	240973	0	65363002	372328		0
61486	3633	372328	1973-09-20	1973-09-20 00:00:00	1973-11-04	1973-11-04 00:00:00	32020		\N	241685	0	65363002	372328		0
51121	3026	40481087	1975-03-01	1975-03-01 00:00:00	1975-03-15	1975-03-15 00:00:00	32020		\N	201805	0	444814009	40481087		0
72403	4297	4152936	1979-11-01	1979-11-01 00:00:00	1979-11-22	1979-11-22 00:00:00	32020		\N	285176	0	283385000	4152936		0
72552	4309	260139	1963-01-20	1963-01-20 00:00:00	1963-02-03	1963-02-03 00:00:00	32020		\N	285894	0	10509002	260139		0
62213	3675	257012	1978-05-09	1978-05-09 00:00:00	\N	\N	32020		\N	244445	0	40055000	257012		0
72974	4337	40481087	1981-04-22	1981-04-22 00:00:00	1981-04-29	1981-04-29 00:00:00	32020		\N	287639	0	444814009	40481087		0
62563	3697	4152936	1988-10-12	1988-10-12 00:00:00	1988-11-02	1988-11-02 00:00:00	32020		\N	245720	0	283385000	4152936		0
62642	3700	4156265	1981-01-21	1981-01-21 00:00:00	1981-02-04	1981-02-04 00:00:00	32020		\N	246008	0	370247008	4156265		0
73392	4364	260139	2012-11-15	2012-11-15 00:00:00	2012-11-22	2012-11-22 00:00:00	32020		\N	289469	0	10509002	260139		0
62957	3719	40481087	2005-09-09	2005-09-09 00:00:00	2005-09-16	2005-09-16 00:00:00	32020		\N	247152	0	444814009	40481087		0
73750	4381	260139	1972-04-23	1972-04-23 00:00:00	1972-05-07	1972-05-07 00:00:00	32020		\N	291148	0	10509002	260139		0
73899	4390	80180	1994-10-15	1994-10-15 00:00:00	\N	\N	32020		\N	291829	0	396275006	80180		0
74042	4398	4237458	1961-02-06	1961-02-06 00:00:00	1961-05-07	1961-05-07 00:00:00	32020		\N	292430	0	58150001	4237458		0
74272	4411	4116491	1990-04-05	1990-04-05 00:00:00	1990-05-27	1990-05-27 00:00:00	32020		\N	293202	0	301011002	4116491		0
53269	3157	28060	1965-12-20	1965-12-20 00:00:00	1965-12-28	1965-12-28 00:00:00	32020		\N	209814	0	43878008	28060		0
63956	3779	4112343	1985-12-08	1985-12-08 00:00:00	1985-12-15	1985-12-15 00:00:00	32020		\N	251112	0	195662009	4112343		0
53611	3176	40481087	1976-05-02	1976-05-02 00:00:00	1976-05-09	1976-05-09 00:00:00	32020		\N	211146	0	444814009	40481087		0
53708	3179	378419	1993-07-31	1993-07-31 00:00:00	\N	\N	32020		\N	211469	0	26929004	378419		0
53819	3183	4283893	1994-09-21	1994-09-21 00:00:00	1994-10-05	1994-10-05 00:00:00	32020		\N	211922	0	36971009	4283893		0
54086	3201	4156265	1964-09-19	1964-09-19 00:00:00	1964-10-03	1964-10-03 00:00:00	32020		\N	212917	0	370247008	4156265		0
54145	3207	40481087	1984-01-31	1984-01-31 00:00:00	1984-02-14	1984-02-14 00:00:00	32020		\N	213208	0	444814009	40481087		0
54380	3221	372328	1965-05-21	1965-05-21 00:00:00	1965-11-06	1965-11-06 00:00:00	32020		\N	214094	0	65363002	372328		0
54502	3227	260139	1990-04-26	1990-04-26 00:00:00	1990-05-03	1990-05-03 00:00:00	32020		\N	214503	0	10509002	260139		0
54710	3238	80180	2006-12-09	2006-12-09 00:00:00	\N	\N	32020		\N	215318	0	396275006	80180		0
54880	3248	40481087	1991-11-28	1991-11-28 00:00:00	1991-12-12	1991-12-12 00:00:00	32020		\N	215920	0	444814009	40481087		0
65603	3879	4294548	1996-01-18	1996-01-18 00:00:00	1996-04-25	1996-04-25 00:00:00	32020		\N	257745	0	75498004	4294548		0
65800	3890	40481087	1984-07-29	1984-07-29 00:00:00	1984-08-12	1984-08-12 00:00:00	32020		\N	258551	0	444814009	40481087		0
55384	3280	40481087	1962-09-13	1962-09-13 00:00:00	1962-09-27	1962-09-27 00:00:00	32020		\N	218029	0	444814009	40481087		0
55554	3290	4027663	1997-03-26	1997-03-26 00:00:00	\N	\N	32020		\N	218567	0	13200003	4027663		0
55740	3298	4109685	1976-01-12	1976-01-12 00:00:00	1976-01-26	1976-01-26 00:00:00	32020		\N	219144	0	284551006	4109685		0
55817	3304	28060	1998-11-27	1998-11-27 00:00:00	1998-12-08	1998-12-08 00:00:00	32020		\N	219463	0	43878008	28060		0
66620	3941	40481087	1994-07-16	1994-07-16 00:00:00	1994-08-06	1994-08-06 00:00:00	32020		\N	262040	0	444814009	40481087		0
56262	3334	28060	2019-04-27	2019-04-27 00:00:00	2019-05-07	2019-05-07 00:00:00	32020		\N	221179	0	43878008	28060		0
56406	3343	40481087	2004-05-15	2004-05-15 00:00:00	2004-05-29	2004-05-29 00:00:00	32020		\N	221741	0	444814009	40481087		0
56551	3353	40481087	1975-10-22	1975-10-22 00:00:00	1975-11-12	1975-11-12 00:00:00	32020		\N	222381	0	444814009	40481087		0
67335	3980	4109685	1977-07-13	1977-07-13 00:00:00	1977-08-03	1977-08-03 00:00:00	32020		\N	264589	0	284551006	4109685		0
56925	3378	40481087	1979-02-12	1979-02-12 00:00:00	1979-02-19	1979-02-19 00:00:00	32020		\N	224166	0	444814009	40481087		0
57023	3382	28060	2013-05-02	2013-05-02 00:00:00	2013-05-13	2013-05-13 00:00:00	32020		\N	224446	0	43878008	28060		0
57145	3391	260139	2015-08-05	2015-08-05 00:00:00	2015-08-19	2015-08-19 00:00:00	32020		\N	224929	0	10509002	260139		0
57413	3408	257012	1997-05-27	1997-05-27 00:00:00	\N	\N	32020		\N	225998	0	40055000	257012		0
57557	3414	40481087	2010-10-31	2010-10-31 00:00:00	2010-11-07	2010-11-07 00:00:00	32020		\N	226461	0	444814009	40481087		0
57734	3423	40481087	1981-02-14	1981-02-14 00:00:00	1981-03-07	1981-03-07 00:00:00	32020		\N	227078	0	444814009	40481087		0
57895	3434	372328	1954-01-10	1954-01-10 00:00:00	1954-04-08	1954-04-08 00:00:00	32020		\N	227756	0	65363002	372328		0
58031	3439	81151	2009-02-20	2009-02-20 00:00:00	2009-03-20	2009-03-20 00:00:00	32020		\N	228170	0	44465007	81151		0
58203	3446	260139	2015-10-04	2015-10-04 00:00:00	2015-10-18	2015-10-18 00:00:00	32020		\N	228768	0	10509002	260139		0
58299	3454	40481087	2011-10-17	2011-10-17 00:00:00	2011-10-31	2011-10-31 00:00:00	32020		\N	229154	0	444814009	40481087		0
58488	3464	40481087	2008-02-09	2008-02-09 00:00:00	2008-02-16	2008-02-16 00:00:00	32020		\N	229996	0	444814009	40481087		0
69292	4101	4112343	1988-01-23	1988-01-23 00:00:00	1988-01-30	1988-01-30 00:00:00	32020		\N	272512	0	195662009	4112343		0
48305	2862	28060	1967-10-28	1967-10-28 00:00:00	1967-11-04	1967-11-04 00:00:00	32020		\N	190267	0	43878008	28060		0
48463	2869	4294548	1993-07-12	1993-07-12 00:00:00	1993-11-01	1993-11-01 00:00:00	32020		\N	190846	0	75498004	4294548		0
69753	4127	4152936	1985-08-09	1985-08-09 00:00:00	1985-08-30	1985-08-30 00:00:00	32020		\N	274342	0	283385000	4152936		0
70015	4143	378001	1964-09-13	1964-09-13 00:00:00	1964-11-12	1964-11-12 00:00:00	32020		\N	275402	0	62106007	378001		0
59476	3527	381316	2013-11-28	2013-11-28 00:00:00	\N	\N	32020		\N	234074	0	230690007	381316		0
59747	3540	4218389	2005-02-05	2005-02-05 00:00:00	2005-02-26	2005-02-26 00:00:00	32020		\N	235123	0	39848009	4218389		0
70433	4173	40481087	1986-11-13	1986-11-13 00:00:00	1986-11-27	1986-11-27 00:00:00	32020		\N	277342	0	444814009	40481087		0
60083	3559	4218389	1975-11-13	1975-11-13 00:00:00	1975-12-11	1975-12-11 00:00:00	32020		\N	236259	0	39848009	4218389		0
60367	3571	260139	2001-04-04	2001-04-04 00:00:00	2001-04-11	2001-04-11 00:00:00	32020		\N	237312	0	10509002	260139		0
60431	3573	4112343	1989-12-28	1989-12-28 00:00:00	1990-01-05	1990-01-05 00:00:00	32020		\N	237584	0	195662009	4112343		0
60707	3593	260139	1961-09-29	1961-09-29 00:00:00	1961-10-13	1961-10-13 00:00:00	32020		\N	238666	0	10509002	260139		0
60803	3599	40481087	1982-07-10	1982-07-10 00:00:00	1982-07-24	1982-07-24 00:00:00	32020		\N	239050	0	444814009	40481087		0
61072	3614	4112343	1986-05-12	1986-05-12 00:00:00	1986-05-24	1986-05-24 00:00:00	32020		\N	240104	0	195662009	4112343		0
61155	3618	195588	1931-01-17	1931-01-17 00:00:00	1931-02-19	1931-02-19 00:00:00	32020		\N	240449	0	38822007	195588		0
61325	3624	4112343	2004-12-06	2004-12-06 00:00:00	2004-12-13	2004-12-13 00:00:00	32020		\N	240996	0	195662009	4112343		0
61487	3633	28060	1982-06-08	1982-06-08 00:00:00	1982-06-15	1982-06-15 00:00:00	32020		\N	241679	0	43878008	28060		0
51122	3026	4112343	1992-02-19	1992-02-19 00:00:00	1992-02-27	1992-02-27 00:00:00	32020		\N	201767	0	195662009	4112343		0
72404	4297	80180	2017-02-14	2017-02-14 00:00:00	\N	\N	32020		\N	285174	0	396275006	80180		0
72553	4309	40481087	1987-06-11	1987-06-11 00:00:00	1987-06-18	1987-06-18 00:00:00	32020		\N	285870	0	444814009	40481087		0
62214	3675	40481087	2019-02-27	2019-02-27 00:00:00	2019-03-13	2019-03-13 00:00:00	32020		\N	244448	0	444814009	40481087		0
72975	4337	260139	1964-12-31	1964-12-31 00:00:00	1965-01-14	1965-01-14 00:00:00	32020		\N	287637	0	10509002	260139		0
62564	3697	372328	1957-01-21	1957-01-21 00:00:00	1957-03-09	1957-03-09 00:00:00	32020		\N	245783	0	65363002	372328		0
62643	3700	4294548	1992-07-13	1992-07-13 00:00:00	1992-10-19	1992-10-19 00:00:00	32020		\N	246005	0	75498004	4294548		0
73393	4364	40481087	1998-08-12	1998-08-12 00:00:00	1998-09-02	1998-09-02 00:00:00	32020		\N	289463	0	444814009	40481087		0
62958	3719	40481087	1964-02-09	1964-02-09 00:00:00	1964-02-23	1964-02-23 00:00:00	32020		\N	247206	0	444814009	40481087		0
73751	4381	260139	1992-08-29	1992-08-29 00:00:00	1992-09-12	1992-09-12 00:00:00	32020		\N	291112	0	10509002	260139		0
73900	4390	260139	1994-06-10	1994-06-10 00:00:00	1994-06-24	1994-06-24 00:00:00	32020		\N	291829	0	10509002	260139		0
74043	4398	4237458	1970-08-23	1970-08-23 00:00:00	1970-11-21	1970-11-21 00:00:00	32020		\N	292432	0	58150001	4237458		0
74273	4411	260139	1962-01-16	1962-01-16 00:00:00	1962-01-23	1962-01-23 00:00:00	32020		\N	293229	0	10509002	260139		0
53270	3157	40481087	1971-12-02	1971-12-02 00:00:00	1971-12-16	1971-12-16 00:00:00	32020		\N	209893	0	444814009	40481087		0
63957	3779	4266809	2003-01-16	2003-01-16 00:00:00	\N	\N	32020		\N	251160	0	397881000	4266809		0
53612	3176	40481087	1972-10-08	1972-10-08 00:00:00	1972-10-22	1972-10-22 00:00:00	32020		\N	211196	0	444814009	40481087		0
53709	3179	40481087	1972-07-15	1972-07-15 00:00:00	1972-08-05	1972-08-05 00:00:00	32020		\N	211513	0	444814009	40481087		0
53820	3184	4112343	2011-01-11	2011-01-11 00:00:00	2011-01-20	2011-01-20 00:00:00	32020		\N	211963	0	195662009	4112343		0
54087	3201	4027663	1967-08-12	1967-08-12 00:00:00	\N	\N	32020		\N	212917	0	13200003	4027663		0
54146	3207	372328	1963-08-12	1963-08-12 00:00:00	1963-11-21	1963-11-21 00:00:00	32020		\N	213176	0	65363002	372328		0
54381	3221	372328	1967-01-30	1967-01-30 00:00:00	1967-05-06	1967-05-06 00:00:00	32020		\N	214113	0	65363002	372328		0
54503	3227	4142905	1986-02-26	1986-02-26 00:00:00	1986-04-27	1986-04-27 00:00:00	32020		\N	214542	0	33737001	4142905		0
54711	3238	81151	2006-03-11	2006-03-11 00:00:00	2006-04-01	2006-04-01 00:00:00	32020		\N	215318	0	44465007	81151		0
54881	3248	40481087	1984-08-21	1984-08-21 00:00:00	1984-09-11	1984-09-11 00:00:00	32020		\N	215853	0	444814009	40481087		0
65604	3879	134438	1965-12-14	1965-12-14 00:00:00	1967-03-11	1967-03-11 00:00:00	32020		\N	257742	0	40275004	134438		0
65801	3890	4112343	1974-12-12	1974-12-12 00:00:00	1974-12-19	1974-12-19 00:00:00	32020		\N	258558	0	195662009	4112343		0
55385	3280	4112343	1968-12-24	1968-12-24 00:00:00	1968-12-31	1968-12-31 00:00:00	32020		\N	218031	0	195662009	4112343		0
55555	3290	4296204	2017-12-05	2017-12-05 00:00:00	2017-12-19	2017-12-19 00:00:00	32020		\N	218621	0	403190006	4296204		0
55742	3300	40481087	2018-08-29	2018-08-29 00:00:00	2018-09-05	2018-09-05 00:00:00	32020		\N	219221	0	444814009	40481087		0
55818	3304	40481087	2012-03-19	2012-03-19 00:00:00	2012-04-02	2012-04-02 00:00:00	32020		\N	219455	0	444814009	40481087		0
66621	3941	40481087	2005-04-09	2005-04-09 00:00:00	2005-04-30	2005-04-30 00:00:00	32020		\N	262041	0	444814009	40481087		0
56263	3335	4112343	2008-08-30	2008-08-30 00:00:00	2008-09-08	2008-09-08 00:00:00	32020		\N	221264	0	195662009	4112343		0
56407	3343	4084167	1978-11-25	1978-11-25 00:00:00	1978-11-25	1978-11-25 00:00:00	32020		\N	221860	0	241929008	4084167		0
56552	3353	28060	1979-04-14	1979-04-14 00:00:00	1979-04-23	1979-04-23 00:00:00	32020		\N	222335	0	43878008	28060		0
67336	3980	40481087	2002-10-28	2002-10-28 00:00:00	2002-11-04	2002-11-04 00:00:00	32020		\N	264582	0	444814009	40481087		0
56926	3378	40481087	2003-11-10	2003-11-10 00:00:00	2003-11-17	2003-11-17 00:00:00	32020		\N	224128	0	444814009	40481087		0
57024	3382	40481087	1973-05-23	1973-05-23 00:00:00	1973-06-06	1973-06-06 00:00:00	32020		\N	224412	0	444814009	40481087		0
57146	3391	4283893	2001-04-09	2001-04-09 00:00:00	2001-04-30	2001-04-30 00:00:00	32020		\N	224927	0	36971009	4283893		0
57414	3408	4112343	2011-06-06	2011-06-06 00:00:00	2011-06-14	2011-06-14 00:00:00	32020		\N	226008	0	195662009	4112343		0
57558	3414	4112343	1993-01-13	1993-01-13 00:00:00	1993-01-23	1993-01-23 00:00:00	32020		\N	226460	0	195662009	4112343		0
57735	3423	40481087	1984-06-15	1984-06-15 00:00:00	1984-06-22	1984-06-22 00:00:00	32020		\N	227034	0	444814009	40481087		0
57896	3434	28060	1964-01-19	1964-01-19 00:00:00	1964-02-01	1964-02-01 00:00:00	32020		\N	227694	0	43878008	28060		0
58032	3439	4112343	1952-05-27	1952-05-27 00:00:00	1952-06-09	1952-06-09 00:00:00	32020		\N	228140	0	195662009	4112343		0
58204	3446	40481087	1991-11-23	1991-11-23 00:00:00	1991-12-14	1991-12-14 00:00:00	32020		\N	228812	0	444814009	40481087		0
58300	3454	372328	1986-09-02	1986-09-02 00:00:00	1987-02-09	1987-02-09 00:00:00	32020		\N	229177	0	65363002	372328		0
58489	3464	192671	2017-07-22	2017-07-22 00:00:00	\N	\N	32020		\N	229946	0	K92.2	35208414		0
69293	4101	4027663	1988-02-20	1988-02-20 00:00:00	\N	\N	32020		\N	272512	0	13200003	4027663		0
48306	2862	4218389	1974-12-16	1974-12-16 00:00:00	1975-01-20	1975-01-20 00:00:00	32020		\N	190260	0	39848009	4218389		0
48464	2869	4134304	2013-01-20	2013-01-20 00:00:00	2013-02-19	2013-02-19 00:00:00	32020		\N	190829	0	263102004	4134304		0
69754	4127	40481087	1953-10-30	1953-10-30 00:00:00	1953-11-13	1953-11-13 00:00:00	32020		\N	274312	0	444814009	40481087		0
70016	4143	372328	1963-04-22	1963-04-22 00:00:00	1963-09-06	1963-09-06 00:00:00	32020		\N	275381	0	65363002	372328		0
59477	3527	4278672	1963-04-04	1963-04-04 00:00:00	1963-07-03	1963-07-03 00:00:00	32020		\N	234046	0	65966004	4278672		0
59748	3540	4112343	2005-04-18	2005-04-18 00:00:00	2005-04-25	2005-04-25 00:00:00	32020		\N	235135	0	195662009	4112343		0
70434	4173	372328	1964-11-06	1964-11-06 00:00:00	1965-01-20	1965-01-20 00:00:00	32020		\N	277332	0	65363002	372328		0
60084	3559	4278672	1995-09-18	1995-09-18 00:00:00	1995-11-17	1995-11-17 00:00:00	32020		\N	236261	0	65966004	4278672		0
60221	3565	372328	1945-12-24	1945-12-24 00:00:00	1946-02-09	1946-02-09 00:00:00	32020		\N	236733	0	65363002	372328		0
60368	3571	40481087	1979-03-07	1979-03-07 00:00:00	1979-03-28	1979-03-28 00:00:00	32020		\N	237384	0	444814009	40481087		0
60432	3573	4112343	1958-10-01	1958-10-01 00:00:00	1958-10-10	1958-10-10 00:00:00	32020		\N	237520	0	195662009	4112343		0
60708	3593	372328	1957-12-18	1957-12-18 00:00:00	1958-03-05	1958-03-05 00:00:00	32020		\N	238677	0	65363002	372328		0
60804	3599	260139	2018-08-29	2018-08-29 00:00:00	2018-09-05	2018-09-05 00:00:00	32020		\N	239033	0	10509002	260139		0
61073	3614	40481087	1960-10-30	1960-10-30 00:00:00	1960-11-13	1960-11-13 00:00:00	32020		\N	240103	0	444814009	40481087		0
61156	3618	260139	1943-03-21	1943-03-21 00:00:00	1943-03-28	1943-03-28 00:00:00	32020		\N	240425	0	10509002	260139		0
61326	3625	372328	1957-11-05	1957-11-05 00:00:00	1958-06-24	1958-06-24 00:00:00	32020		\N	241077	0	65363002	372328		0
61488	3633	40481087	1984-06-24	1984-06-24 00:00:00	1984-07-15	1984-07-15 00:00:00	32020		\N	241682	0	444814009	40481087		0
61587	3639	40481087	1984-07-07	1984-07-07 00:00:00	1984-07-28	1984-07-28 00:00:00	32020		\N	242066	0	444814009	40481087		0
72405	4297	40481087	1999-06-01	1999-06-01 00:00:00	1999-06-22	1999-06-22 00:00:00	32020		\N	285196	0	444814009	40481087		0
72554	4309	40481087	1971-04-07	1971-04-07 00:00:00	1971-04-28	1971-04-28 00:00:00	32020		\N	285869	0	444814009	40481087		0
62215	3675	40481087	1998-10-26	1998-10-26 00:00:00	1998-11-09	1998-11-09 00:00:00	32020		\N	244412	0	444814009	40481087		0
72976	4337	4112343	1996-10-04	1996-10-04 00:00:00	1996-10-17	1996-10-17 00:00:00	32020		\N	287641	0	195662009	4112343		0
62565	3697	30753	1993-03-08	1993-03-08 00:00:00	\N	\N	32020		\N	245723	0	16761005	30753		0
62644	3700	4112343	2000-09-29	2000-09-29 00:00:00	2000-10-06	2000-10-06 00:00:00	32020		\N	245965	0	195662009	4112343		0
73394	4364	4112343	1961-09-05	1961-09-05 00:00:00	1961-09-18	1961-09-18 00:00:00	32020		\N	289454	0	195662009	4112343		0
62959	3719	4112343	1978-07-28	1978-07-28 00:00:00	1978-08-04	1978-08-04 00:00:00	32020		\N	247209	0	195662009	4112343		0
73752	4381	40481087	1997-06-16	1997-06-16 00:00:00	1997-07-07	1997-07-07 00:00:00	32020		\N	291072	0	444814009	40481087		0
73901	4390	260139	1962-11-19	1962-11-19 00:00:00	1962-12-03	1962-12-03 00:00:00	32020		\N	291812	0	10509002	260139		0
74044	4398	28060	2013-08-17	2013-08-17 00:00:00	2013-08-28	2013-08-28 00:00:00	32020		\N	292454	0	43878008	28060		0
74274	4411	4112343	1961-03-18	1961-03-18 00:00:00	1961-03-30	1961-03-30 00:00:00	32020		\N	293177	0	195662009	4112343		0
53271	3157	81151	1953-07-29	1953-07-29 00:00:00	1953-08-26	1953-08-26 00:00:00	32020		\N	209876	0	44465007	81151		0
63958	3779	4285898	2002-07-20	2002-07-20 00:00:00	\N	\N	32020		\N	251160	0	68496003	4285898		0
53613	3176	40481087	1981-06-05	1981-06-05 00:00:00	1981-06-19	1981-06-19 00:00:00	32020		\N	211147	0	444814009	40481087		0
53710	3179	4027663	1948-10-24	1948-10-24 00:00:00	\N	\N	32020		\N	211505	0	13200003	4027663		0
53821	3184	4112343	2015-12-26	2015-12-26 00:00:00	2016-01-06	2016-01-06 00:00:00	32020		\N	211976	0	195662009	4112343		0
64589	3820	257012	1979-02-09	1979-02-09 00:00:00	\N	\N	32020		\N	253604	0	40055000	257012		0
54148	3207	80180	1995-08-19	1995-08-19 00:00:00	\N	\N	32020		\N	213206	0	396275006	80180		0
54382	3221	4142905	1966-03-17	1966-03-17 00:00:00	1966-04-16	1966-04-16 00:00:00	32020		\N	214130	0	33737001	4142905		0
54504	3227	40481087	2017-11-30	2017-11-30 00:00:00	2017-12-21	2017-12-21 00:00:00	32020		\N	214515	0	444814009	40481087		0
54712	3238	40481087	1987-01-17	1987-01-17 00:00:00	1987-02-07	1987-02-07 00:00:00	32020		\N	215289	0	444814009	40481087		0
54882	3248	4112343	1955-08-14	1955-08-14 00:00:00	1955-08-23	1955-08-23 00:00:00	32020		\N	215918	0	195662009	4112343		0
65605	3879	192671	1981-05-08	1981-05-08 00:00:00	\N	\N	32020		\N	257656	0	K92.2	35208414		0
65802	3890	260139	1962-09-29	1962-09-29 00:00:00	1962-10-13	1962-10-13 00:00:00	32020		\N	258557	0	10509002	260139		0
55386	3280	4112343	1999-01-25	1999-01-25 00:00:00	1999-02-01	1999-02-01 00:00:00	32020		\N	218044	0	195662009	4112343		0
55556	3290	40481087	1973-08-14	1973-08-14 00:00:00	1973-09-04	1973-09-04 00:00:00	32020		\N	218550	0	444814009	40481087		0
55743	3300	40481087	2005-07-22	2005-07-22 00:00:00	2005-08-05	2005-08-05 00:00:00	32020		\N	219247	0	444814009	40481087		0
55819	3304	260139	2012-05-14	2012-05-14 00:00:00	2012-05-28	2012-05-28 00:00:00	32020		\N	219448	0	10509002	260139		0
66622	3941	40481087	2008-12-28	2008-12-28 00:00:00	2009-01-04	2009-01-04 00:00:00	32020		\N	262042	0	444814009	40481087		0
56264	3335	4059173	1986-04-10	1986-04-10 00:00:00	1986-06-09	1986-06-09 00:00:00	32020		\N	221299	0	16114001	4059173		0
56408	3343	260139	2001-03-30	2001-03-30 00:00:00	2001-04-06	2001-04-06 00:00:00	32020		\N	221786	0	10509002	260139		0
56553	3353	260139	2012-06-20	2012-06-20 00:00:00	2012-06-27	2012-06-27 00:00:00	32020		\N	222359	0	10509002	260139		0
67337	3980	40481087	1988-06-22	1988-06-22 00:00:00	1988-07-13	1988-07-13 00:00:00	32020		\N	264600	0	444814009	40481087		0
56927	3378	4112343	2011-04-17	2011-04-17 00:00:00	2011-04-28	2011-04-28 00:00:00	32020		\N	224132	0	195662009	4112343		0
57025	3382	4218389	2005-07-11	2005-07-11 00:00:00	2005-08-01	2005-08-01 00:00:00	32020		\N	224402	0	39848009	4218389		0
57147	3391	40481087	1983-03-16	1983-03-16 00:00:00	1983-03-23	1983-03-23 00:00:00	32020		\N	224904	0	444814009	40481087		0
57415	3408	372328	1974-08-29	1974-08-29 00:00:00	1975-06-23	1975-06-23 00:00:00	32020		\N	226050	0	65363002	372328		0
57559	3414	260139	1981-05-01	1981-05-01 00:00:00	1981-05-08	1981-05-08 00:00:00	32020		\N	226468	0	10509002	260139		0
57736	3423	4027663	2005-03-13	2005-03-13 00:00:00	\N	\N	32020		\N	227095	0	13200003	4027663		0
57897	3434	260139	1973-06-21	1973-06-21 00:00:00	1973-07-05	1973-07-05 00:00:00	32020		\N	227696	0	10509002	260139		0
58033	3439	80180	1995-05-06	1995-05-06 00:00:00	\N	\N	32020		\N	228153	0	396275006	80180		0
58205	3446	40481087	1977-06-24	1977-06-24 00:00:00	1977-07-01	1977-07-01 00:00:00	32020		\N	228766	0	444814009	40481087		0
58301	3454	4142905	1997-02-21	1997-02-21 00:00:00	1997-05-22	1997-05-22 00:00:00	32020		\N	229142	0	33737001	4142905		0
58490	3464	40481087	2014-12-16	2014-12-16 00:00:00	2014-12-23	2014-12-23 00:00:00	32020		\N	229944	0	444814009	40481087		0
69294	4101	378001	1962-01-17	1962-01-17 00:00:00	1962-03-18	1962-03-18 00:00:00	32020		\N	272469	0	62106007	378001		0
58765	3486	40481087	1971-08-02	1971-08-02 00:00:00	1971-08-16	1971-08-16 00:00:00	32020		\N	231228	0	444814009	40481087		0
48465	2869	40481087	1972-06-14	1972-06-14 00:00:00	1972-07-05	1972-07-05 00:00:00	32020		\N	190834	0	444814009	40481087		0
69755	4127	260139	1965-11-22	1965-11-22 00:00:00	1965-12-06	1965-12-06 00:00:00	32020		\N	274338	0	10509002	260139		0
70017	4143	4112343	1978-12-01	1978-12-01 00:00:00	1978-12-08	1978-12-08 00:00:00	32020		\N	275345	0	195662009	4112343		0
59478	3527	4112343	2012-08-05	2012-08-05 00:00:00	2012-08-18	2012-08-18 00:00:00	32020		\N	234036	0	195662009	4112343		0
59749	3540	372328	1974-07-27	1974-07-27 00:00:00	1974-10-07	1974-10-07 00:00:00	32020		\N	235136	0	65363002	372328		0
70435	4173	40481087	1965-02-01	1965-02-01 00:00:00	1965-02-22	1965-02-22 00:00:00	32020		\N	277360	0	444814009	40481087		0
60085	3560	260139	1980-06-12	1980-06-12 00:00:00	1980-06-19	1980-06-19 00:00:00	32020		\N	236353	0	10509002	260139		0
60222	3565	260139	2000-04-04	2000-04-04 00:00:00	2000-04-11	2000-04-11 00:00:00	32020		\N	236715	0	10509002	260139		0
60369	3571	28060	1977-05-28	1977-05-28 00:00:00	1977-06-08	1977-06-08 00:00:00	32020		\N	237378	0	43878008	28060		0
60433	3573	40481087	1989-02-18	1989-02-18 00:00:00	1989-03-11	1989-03-11 00:00:00	32020		\N	237544	0	444814009	40481087		0
60709	3593	4294548	1967-11-01	1967-11-01 00:00:00	1967-12-13	1967-12-13 00:00:00	32020		\N	238701	0	75498004	4294548		0
60805	3599	80180	2006-06-10	2006-06-10 00:00:00	\N	\N	32020		\N	239044	0	396275006	80180		0
61074	3614	4112343	1992-07-22	1992-07-22 00:00:00	1992-07-29	1992-07-29 00:00:00	32020		\N	240106	0	195662009	4112343		0
61157	3618	40481087	1946-12-19	1946-12-19 00:00:00	1947-01-09	1947-01-09 00:00:00	32020		\N	240426	0	444814009	40481087		0
61327	3625	4112343	1970-01-10	1970-01-10 00:00:00	1970-01-18	1970-01-18 00:00:00	32020		\N	241036	0	195662009	4112343		0
61489	3633	40481087	2005-12-31	2005-12-31 00:00:00	2006-01-07	2006-01-07 00:00:00	32020		\N	241656	0	444814009	40481087		0
61588	3639	40481087	1982-05-19	1982-05-19 00:00:00	1982-06-09	1982-06-09 00:00:00	32020		\N	242032	0	444814009	40481087		0
72406	4297	40481087	2010-08-10	2010-08-10 00:00:00	2010-08-31	2010-08-31 00:00:00	32020		\N	285160	0	444814009	40481087		0
72555	4309	372328	1954-12-02	1954-12-02 00:00:00	1955-01-12	1955-01-12 00:00:00	32020		\N	285872	0	65363002	372328		0
62216	3675	4112343	2001-07-05	2001-07-05 00:00:00	2001-07-18	2001-07-18 00:00:00	32020		\N	244434	0	195662009	4112343		0
72977	4337	4296204	1963-03-31	1963-03-31 00:00:00	1963-04-21	1963-04-21 00:00:00	32020		\N	287613	0	403190006	4296204		0
62566	3697	80180	1993-06-06	1993-06-06 00:00:00	\N	\N	32020		\N	245723	0	396275006	80180		0
62645	3700	40481087	1987-06-28	1987-06-28 00:00:00	1987-07-05	1987-07-05 00:00:00	32020		\N	246003	0	444814009	40481087		0
73395	4364	4112343	2007-07-20	2007-07-20 00:00:00	2007-07-31	2007-07-31 00:00:00	32020		\N	289465	0	195662009	4112343		0
62960	3719	40481087	1998-02-20	1998-02-20 00:00:00	1998-03-13	1998-03-13 00:00:00	32020		\N	247195	0	444814009	40481087		0
73753	4381	4112343	1994-11-01	1994-11-01 00:00:00	1994-11-13	1994-11-13 00:00:00	32020		\N	291071	0	195662009	4112343		0
73902	4390	4112343	2009-02-11	2009-02-11 00:00:00	2009-02-24	2009-02-24 00:00:00	32020		\N	291922	0	195662009	4112343		0
74045	4398	40481087	2009-04-09	2009-04-09 00:00:00	2009-04-16	2009-04-16 00:00:00	32020		\N	292466	0	444814009	40481087		0
74275	4411	4112343	1994-12-04	1994-12-04 00:00:00	1994-12-15	1994-12-15 00:00:00	32020		\N	293181	0	195662009	4112343		0
53272	3157	40481087	1956-12-16	1956-12-16 00:00:00	1956-12-23	1956-12-23 00:00:00	32020		\N	209831	0	444814009	40481087		0
63959	3779	80180	2003-01-16	2003-01-16 00:00:00	\N	\N	32020		\N	251160	0	396275006	80180		0
53614	3176	381316	2014-01-04	2014-01-04 00:00:00	\N	\N	32020		\N	211121	0	230690007	381316		0
53711	3179	40481087	1922-11-22	1922-11-22 00:00:00	1922-11-29	1922-11-29 00:00:00	32020		\N	211500	0	444814009	40481087		0
53822	3184	260139	2004-12-02	2004-12-02 00:00:00	2004-12-16	2004-12-16 00:00:00	32020		\N	211959	0	10509002	260139		0
64590	3820	28060	1968-11-10	1968-11-10 00:00:00	1968-11-21	1968-11-21 00:00:00	32020		\N	253658	0	43878008	28060		0
54149	3207	321042	1994-12-01	1994-12-01 00:00:00	\N	\N	32020		\N	213206	0	410429000	321042		0
54383	3221	40481087	1974-05-13	1974-05-13 00:00:00	1974-05-27	1974-05-27 00:00:00	32020		\N	214086	0	444814009	40481087		0
54505	3227	4112343	2009-09-05	2009-09-05 00:00:00	2009-09-18	2009-09-18 00:00:00	32020		\N	214525	0	195662009	4112343		0
54713	3238	4149245	1997-05-20	1997-05-20 00:00:00	1997-07-26	1997-07-26 00:00:00	32020		\N	215317	0	30832001	4149245		0
54883	3248	4112343	1975-06-27	1975-06-27 00:00:00	1975-07-04	1975-07-04 00:00:00	32020		\N	215895	0	195662009	4112343		0
65606	3879	260139	1969-06-10	1969-06-10 00:00:00	1969-06-17	1969-06-17 00:00:00	32020		\N	257665	0	10509002	260139		0
65803	3890	4112343	1990-04-19	1990-04-19 00:00:00	1990-04-27	1990-04-27 00:00:00	32020		\N	258553	0	195662009	4112343		0
55387	3280	257012	1952-01-16	1952-01-16 00:00:00	\N	\N	32020		\N	218002	0	40055000	257012		0
55557	3290	260139	1985-01-18	1985-01-18 00:00:00	1985-02-01	1985-02-01 00:00:00	32020		\N	218609	0	10509002	260139		0
55744	3300	4112343	1997-02-02	1997-02-02 00:00:00	1997-02-14	1997-02-14 00:00:00	32020		\N	219193	0	195662009	4112343		0
55820	3304	4059173	1977-07-15	1977-07-15 00:00:00	1977-10-13	1977-10-13 00:00:00	32020		\N	219485	0	16114001	4059173		0
66623	3942	372328	1978-09-17	1978-09-17 00:00:00	1978-12-28	1978-12-28 00:00:00	32020		\N	262100	0	65363002	372328		0
56265	3335	440086	1979-03-25	1979-03-25 00:00:00	1979-09-02	1979-09-02 00:00:00	32020		\N	221237	0	192127007	440086		0
56409	3343	40481087	2007-05-19	2007-05-19 00:00:00	2007-06-09	2007-06-09 00:00:00	32020		\N	221743	0	444814009	40481087		0
56554	3353	4112343	1996-11-28	1996-11-28 00:00:00	1996-12-11	1996-12-11 00:00:00	32020		\N	222419	0	195662009	4112343		0
67338	3980	4112343	1988-06-02	1988-06-02 00:00:00	1988-06-09	1988-06-09 00:00:00	32020		\N	264580	0	195662009	4112343		0
56928	3378	28060	1998-12-10	1998-12-10 00:00:00	1998-12-18	1998-12-18 00:00:00	32020		\N	224127	0	43878008	28060		0
57026	3382	4112343	1975-08-13	1975-08-13 00:00:00	1975-08-23	1975-08-23 00:00:00	32020		\N	224437	0	195662009	4112343		0
57148	3391	4283893	1994-07-26	1994-07-26 00:00:00	1994-10-04	1994-10-04 00:00:00	32020		\N	224914	0	36971009	4283893		0
57416	3408	40481087	2015-12-06	2015-12-06 00:00:00	2015-12-27	2015-12-27 00:00:00	32020		\N	226000	0	444814009	40481087		0
57560	3414	260139	1982-04-05	1982-04-05 00:00:00	1982-04-19	1982-04-19 00:00:00	32020		\N	226449	0	10509002	260139		0
57737	3423	78272	2004-12-27	2004-12-27 00:00:00	2005-01-24	2005-01-24 00:00:00	32020		\N	227095	0	70704007	78272		0
57898	3434	260139	2001-04-11	2001-04-11 00:00:00	2001-04-25	2001-04-25 00:00:00	32020		\N	227693	0	10509002	260139		0
58034	3439	260139	1988-04-26	1988-04-26 00:00:00	1988-05-03	1988-05-03 00:00:00	32020		\N	228188	0	10509002	260139		0
58206	3446	81151	1981-01-07	1981-01-07 00:00:00	1981-01-28	1981-01-28 00:00:00	32020		\N	228782	0	44465007	81151		0
58302	3454	40481087	2014-09-19	2014-09-19 00:00:00	2014-10-10	2014-10-10 00:00:00	32020		\N	229189	0	444814009	40481087		0
58491	3464	40481087	1984-06-01	1984-06-01 00:00:00	1984-06-08	1984-06-08 00:00:00	32020		\N	229955	0	444814009	40481087		0
69295	4101	81893	1998-01-13	1998-01-13 00:00:00	\N	\N	32020		\N	272487	0	64766004	81893		0
58766	3486	40481087	1965-09-03	1965-09-03 00:00:00	1965-09-24	1965-09-24 00:00:00	32020		\N	231227	0	444814009	40481087		0
48466	2869	4059173	1960-07-31	1960-07-31 00:00:00	1960-08-30	1960-08-30 00:00:00	32020		\N	190823	0	16114001	4059173		0
69756	4127	40481087	2019-03-23	2019-03-23 00:00:00	2019-04-13	2019-04-13 00:00:00	32020		\N	274315	0	444814009	40481087		0
70018	4143	4112343	2006-09-27	2006-09-27 00:00:00	2006-10-05	2006-10-05 00:00:00	32020		\N	275393	0	195662009	4112343		0
59479	3527	4142905	1979-01-15	1979-01-15 00:00:00	1979-04-15	1979-04-15 00:00:00	32020		\N	234050	0	33737001	4142905		0
59750	3540	375671	2016-10-26	2016-10-26 00:00:00	2016-11-25	2016-11-25 00:00:00	32020		\N	235124	0	62564004	375671		0
70436	4173	4134304	1973-03-24	1973-03-24 00:00:00	1973-04-23	1973-04-23 00:00:00	32020		\N	277373	0	263102004	4134304		0
60086	3560	40481087	1990-12-25	1990-12-25 00:00:00	1991-01-01	1991-01-01 00:00:00	32020		\N	236369	0	444814009	40481087		0
60223	3565	78272	1973-11-30	1973-11-30 00:00:00	1973-12-14	1973-12-14 00:00:00	32020		\N	236740	0	70704007	78272		0
60370	3571	4112343	1980-12-10	1980-12-10 00:00:00	1980-12-23	1980-12-23 00:00:00	32020		\N	237343	0	195662009	4112343		0
60434	3573	4112343	1941-01-18	1941-01-18 00:00:00	1941-01-30	1941-01-30 00:00:00	32020		\N	237539	0	195662009	4112343		0
60710	3593	40481087	2008-02-13	2008-02-13 00:00:00	2008-03-05	2008-03-05 00:00:00	32020		\N	238719	0	444814009	40481087		0
60806	3599	4146173	2015-03-16	2015-03-16 00:00:00	2015-05-22	2015-05-22 00:00:00	32020		\N	239072	0	307731004	4146173		0
61075	3614	372328	1952-11-07	1952-11-07 00:00:00	1953-04-05	1953-04-05 00:00:00	32020		\N	240117	0	65363002	372328		0
61158	3618	4155034	1936-01-02	1936-01-02 00:00:00	1936-01-23	1936-01-23 00:00:00	32020		\N	240397	0	283371005	4155034		0
61328	3625	260139	1964-10-15	1964-10-15 00:00:00	1964-10-29	1964-10-29 00:00:00	32020		\N	241075	0	10509002	260139		0
61490	3633	40481087	1983-01-09	1983-01-09 00:00:00	1983-01-23	1983-01-23 00:00:00	32020		\N	241680	0	444814009	40481087		0
61589	3639	4112343	2009-09-21	2009-09-21 00:00:00	2009-10-01	2009-10-01 00:00:00	32020		\N	242039	0	195662009	4112343		0
72407	4297	40481087	2005-03-27	2005-03-27 00:00:00	2005-04-03	2005-04-03 00:00:00	32020		\N	285179	0	444814009	40481087		0
72556	4309	40481087	1968-05-27	1968-05-27 00:00:00	1968-06-03	1968-06-03 00:00:00	32020		\N	285886	0	444814009	40481087		0
62217	3675	40481087	1986-01-14	1986-01-14 00:00:00	1986-02-04	1986-02-04 00:00:00	32020		\N	244411	0	444814009	40481087		0
72978	4337	4116491	2004-05-29	2004-05-29 00:00:00	2004-07-22	2004-07-22 00:00:00	32020		\N	287566	0	301011002	4116491		0
62567	3697	4266809	1993-06-06	1993-06-06 00:00:00	\N	\N	32020		\N	245723	0	397881000	4266809		0
62646	3700	40481087	1973-12-31	1973-12-31 00:00:00	1974-01-07	1974-01-07 00:00:00	32020		\N	245962	0	444814009	40481087		0
73396	4364	40481087	2010-06-07	2010-06-07 00:00:00	2010-06-21	2010-06-21 00:00:00	32020		\N	289452	0	444814009	40481087		0
62961	3719	260139	1964-02-04	1964-02-04 00:00:00	1964-02-11	1964-02-11 00:00:00	32020		\N	247156	0	10509002	260139		0
73754	4382	40481087	1992-07-23	1992-07-23 00:00:00	1992-08-06	1992-08-06 00:00:00	32020		\N	291183	0	444814009	40481087		0
73903	4390	260139	2006-11-18	2006-11-18 00:00:00	2006-12-02	2006-12-02 00:00:00	32020		\N	291921	0	10509002	260139		0
74046	4398	4237458	1990-08-08	1990-08-08 00:00:00	1990-09-07	1990-09-07 00:00:00	32020		\N	292433	0	58150001	4237458		0
74276	4411	4027663	1975-04-09	1975-04-09 00:00:00	\N	\N	32020		\N	293237	0	13200003	4027663		0
53273	3157	40481087	2002-05-23	2002-05-23 00:00:00	2002-06-06	2002-06-06 00:00:00	32020		\N	209894	0	444814009	40481087		0
63960	3779	4310024	2001-06-25	2001-06-25 00:00:00	\N	\N	32020		\N	251159	0	424802006	4310024		0
53615	3176	4296204	2006-10-13	2006-10-13 00:00:00	2006-11-03	2006-11-03 00:00:00	32020		\N	211225	0	403190006	4296204		0
53712	3179	40481087	1978-11-03	1978-11-03 00:00:00	1978-11-17	1978-11-17 00:00:00	32020		\N	211491	0	444814009	40481087		0
53823	3184	260139	2017-08-11	2017-08-11 00:00:00	2017-08-18	2017-08-18 00:00:00	32020		\N	211964	0	10509002	260139		0
64591	3820	4112343	1992-05-21	1992-05-21 00:00:00	1992-06-03	1992-06-03 00:00:00	32020		\N	253617	0	195662009	4112343		0
54150	3207	40481087	1993-07-02	1993-07-02 00:00:00	1993-07-23	1993-07-23 00:00:00	32020		\N	213209	0	444814009	40481087		0
54385	3221	28060	1970-02-26	1970-02-26 00:00:00	1970-03-07	1970-03-07 00:00:00	32020		\N	214071	0	43878008	28060		0
54506	3227	4112343	1974-03-02	1974-03-02 00:00:00	1974-03-15	1974-03-15 00:00:00	32020		\N	214529	0	195662009	4112343		0
54714	3238	260139	1974-06-21	1974-06-21 00:00:00	1974-06-28	1974-06-28 00:00:00	32020		\N	215261	0	10509002	260139		0
54884	3248	4112343	2002-07-13	2002-07-13 00:00:00	2002-07-24	2002-07-24 00:00:00	32020		\N	215856	0	195662009	4112343		0
65607	3879	81151	1944-09-16	1944-09-16 00:00:00	1944-09-30	1944-09-30 00:00:00	32020		\N	257654	0	44465007	81151		0
65804	3890	28060	1960-03-16	1960-03-16 00:00:00	1960-03-29	1960-03-29 00:00:00	32020		\N	258548	0	43878008	28060		0
55388	3280	4218389	1982-12-02	1982-12-02 00:00:00	1982-12-30	1982-12-30 00:00:00	32020		\N	218038	0	39848009	4218389		0
55558	3290	40481087	1989-10-03	1989-10-03 00:00:00	1989-10-10	1989-10-10 00:00:00	32020		\N	218610	0	444814009	40481087		0
55745	3300	4112343	2003-07-27	2003-07-27 00:00:00	2003-08-07	2003-08-07 00:00:00	32020		\N	219246	0	195662009	4112343		0
55821	3304	4237458	1975-06-26	1975-06-26 00:00:00	1975-07-26	1975-07-26 00:00:00	32020		\N	219484	0	58150001	4237458		0
66624	3942	4112343	1991-09-29	1991-09-29 00:00:00	1991-10-12	1991-10-12 00:00:00	32020		\N	262112	0	195662009	4112343		0
56266	3335	260139	2014-05-27	2014-05-27 00:00:00	2014-06-03	2014-06-03 00:00:00	32020		\N	221244	0	10509002	260139		0
56410	3343	4112343	2005-07-13	2005-07-13 00:00:00	2005-07-21	2005-07-21 00:00:00	32020		\N	221742	0	195662009	4112343		0
56555	3353	260139	1930-03-03	1930-03-03 00:00:00	1930-03-17	1930-03-17 00:00:00	32020		\N	222368	0	10509002	260139		0
67339	3980	80180	2015-02-04	2015-02-04 00:00:00	\N	\N	32020		\N	264602	0	396275006	80180		0
56929	3378	4283893	1966-12-01	1966-12-01 00:00:00	1967-01-26	1967-01-26 00:00:00	32020		\N	224115	0	36971009	4283893		0
57027	3383	40481087	1998-02-08	1998-02-08 00:00:00	1998-02-15	1998-02-15 00:00:00	32020		\N	224482	0	444814009	40481087		0
57149	3391	4146173	1997-06-03	1997-06-03 00:00:00	1997-08-09	1997-08-09 00:00:00	32020		\N	224920	0	307731004	4146173		0
57417	3408	40481087	1988-12-14	1988-12-14 00:00:00	1989-01-04	1989-01-04 00:00:00	32020		\N	225997	0	444814009	40481087		0
57561	3414	40481087	1993-04-26	1993-04-26 00:00:00	1993-05-17	1993-05-17 00:00:00	32020		\N	226436	0	444814009	40481087		0
57738	3423	40481087	1977-04-13	1977-04-13 00:00:00	1977-04-27	1977-04-27 00:00:00	32020		\N	227038	0	444814009	40481087		0
57899	3434	40481087	1952-11-06	1952-11-06 00:00:00	1952-11-27	1952-11-27 00:00:00	32020		\N	227688	0	444814009	40481087		0
58035	3439	81151	1955-09-08	1955-09-08 00:00:00	1955-10-06	1955-10-06 00:00:00	32020		\N	228137	0	44465007	81151		0
58207	3446	380378	1958-04-07	1958-04-07 00:00:00	\N	\N	32020		\N	228778	0	84757009	380378		0
58303	3454	260139	2014-08-24	2014-08-24 00:00:00	2014-08-31	2014-08-31 00:00:00	32020		\N	229148	0	10509002	260139		0
58492	3464	4134304	2004-01-09	2004-01-09 00:00:00	2004-04-08	2004-04-08 00:00:00	32020		\N	229948	0	263102004	4134304		0
69296	4101	4112343	1984-04-01	1984-04-01 00:00:00	1984-04-12	1984-04-12 00:00:00	32020		\N	272534	0	195662009	4112343		0
58767	3486	40481087	1972-01-18	1972-01-18 00:00:00	1972-02-08	1972-02-08 00:00:00	32020		\N	231276	0	444814009	40481087		0
48467	2869	40481087	1983-04-06	1983-04-06 00:00:00	1983-04-27	1983-04-27 00:00:00	32020		\N	190891	0	444814009	40481087		0
69757	4127	4112343	2000-11-18	2000-11-18 00:00:00	2000-11-26	2000-11-26 00:00:00	32020		\N	274314	0	195662009	4112343		0
70019	4143	372328	1968-11-08	1968-11-08 00:00:00	1969-09-26	1969-09-26 00:00:00	32020		\N	275382	0	65363002	372328		0
59480	3527	4294548	2001-05-19	2001-05-19 00:00:00	2001-06-09	2001-06-09 00:00:00	32020		\N	234140	0	75498004	4294548		0
59751	3540	372328	1976-06-28	1976-06-28 00:00:00	1977-01-03	1977-01-03 00:00:00	32020		\N	235152	0	65363002	372328		0
70437	4173	4112343	1989-10-26	1989-10-26 00:00:00	1989-11-05	1989-11-05 00:00:00	32020		\N	277330	0	195662009	4112343		0
60087	3560	4112343	1985-04-27	1985-04-27 00:00:00	1985-05-07	1985-05-07 00:00:00	32020		\N	236354	0	195662009	4112343		0
60224	3565	4112343	1963-03-15	1963-03-15 00:00:00	1963-03-22	1963-03-22 00:00:00	32020		\N	236717	0	195662009	4112343		0
60371	3571	4084167	1972-12-16	1972-12-16 00:00:00	1972-12-17	1972-12-17 00:00:00	32020		\N	237407	0	241929008	4084167		0
60435	3573	30753	1962-01-08	1962-01-08 00:00:00	\N	\N	32020		\N	237612	0	16761005	30753		0
60711	3593	4112343	1985-01-02	1985-01-02 00:00:00	1985-01-11	1985-01-11 00:00:00	32020		\N	238670	0	195662009	4112343		0
60807	3599	260139	2012-11-19	2012-11-19 00:00:00	2012-11-26	2012-11-26 00:00:00	32020		\N	239051	0	10509002	260139		0
61076	3614	260139	1952-03-13	1952-03-13 00:00:00	1952-03-20	1952-03-20 00:00:00	32020		\N	240146	0	10509002	260139		0
61159	3618	40481087	1944-09-03	1944-09-03 00:00:00	1944-09-24	1944-09-24 00:00:00	32020		\N	240345	0	444814009	40481087		0
61329	3625	40481087	2016-07-12	2016-07-12 00:00:00	2016-07-19	2016-07-19 00:00:00	32020		\N	241042	0	444814009	40481087		0
61491	3633	4112343	2012-02-21	2012-02-21 00:00:00	2012-03-04	2012-03-04 00:00:00	32020		\N	241657	0	195662009	4112343		0
61590	3639	4283893	2004-10-28	2004-10-28 00:00:00	2005-06-23	2005-06-23 00:00:00	32020		\N	242110	0	36971009	4283893		0
72408	4297	4134304	1978-09-07	1978-09-07 00:00:00	1978-11-06	1978-11-06 00:00:00	32020		\N	285175	0	263102004	4134304		0
72557	4309	4266809	1994-01-16	1994-01-16 00:00:00	\N	\N	32020		\N	285932	0	397881000	4266809		0
62218	3675	40481087	2000-09-05	2000-09-05 00:00:00	2000-09-19	2000-09-19 00:00:00	32020		\N	244479	0	444814009	40481087		0
72979	4337	40481087	1998-05-04	1998-05-04 00:00:00	1998-05-11	1998-05-11 00:00:00	32020		\N	287564	0	444814009	40481087		0
62568	3697	40481087	1957-10-25	1957-10-25 00:00:00	1957-11-01	1957-11-01 00:00:00	32020		\N	245779	0	444814009	40481087		0
62647	3700	4112343	1988-11-20	1988-11-20 00:00:00	1988-11-30	1988-11-30 00:00:00	32020		\N	245995	0	195662009	4112343		0
73397	4364	40481087	1972-10-01	1972-10-01 00:00:00	1972-10-08	1972-10-08 00:00:00	32020		\N	289468	0	444814009	40481087		0
62962	3719	4278672	1968-11-07	1968-11-07 00:00:00	1968-12-07	1968-12-07 00:00:00	32020		\N	247203	0	65966004	4278672		0
73755	4382	4112343	1967-08-31	1967-08-31 00:00:00	1967-09-11	1967-09-11 00:00:00	32020		\N	291267	0	195662009	4112343		0
73904	4390	260139	2004-12-20	2004-12-20 00:00:00	2004-12-27	2004-12-27 00:00:00	32020		\N	291927	0	10509002	260139		0
74047	4398	40481087	2008-09-13	2008-09-13 00:00:00	2008-10-04	2008-10-04 00:00:00	32020		\N	292452	0	444814009	40481087		0
74277	4411	4134304	1953-10-31	1953-10-31 00:00:00	1953-11-30	1953-11-30 00:00:00	32020		\N	293249	0	263102004	4134304		0
53274	3157	372328	1957-10-29	1957-10-29 00:00:00	1958-06-20	1958-06-20 00:00:00	32020		\N	209867	0	65363002	372328		0
63961	3779	28060	1970-07-07	1970-07-07 00:00:00	1970-07-18	1970-07-18 00:00:00	32020		\N	251110	0	43878008	28060		0
53616	3176	40481087	1978-10-03	1978-10-03 00:00:00	1978-10-10	1978-10-10 00:00:00	32020		\N	211164	0	444814009	40481087		0
53713	3179	40481087	1925-01-22	1925-01-22 00:00:00	1925-02-05	1925-02-05 00:00:00	32020		\N	211510	0	444814009	40481087		0
53824	3184	4296204	1978-04-02	1978-04-02 00:00:00	1978-04-30	1978-04-30 00:00:00	32020		\N	211991	0	403190006	4296204		0
64592	3820	81151	2015-08-31	2015-08-31 00:00:00	2015-09-28	2015-09-28 00:00:00	32020		\N	253656	0	44465007	81151		0
54151	3207	372328	1962-10-12	1962-10-12 00:00:00	1962-11-15	1962-11-15 00:00:00	32020		\N	213184	0	65363002	372328		0
54507	3227	40481087	2013-12-25	2013-12-25 00:00:00	2014-01-15	2014-01-15 00:00:00	32020		\N	214514	0	444814009	40481087		0
54715	3238	4112343	1985-06-06	1985-06-06 00:00:00	1985-06-16	1985-06-16 00:00:00	32020		\N	215275	0	195662009	4112343		0
54885	3248	4048695	2014-10-12	2014-10-12 00:00:00	2014-12-13	2014-12-13 00:00:00	32020		\N	215880	0	15724005	4048695		0
65608	3879	195588	1966-12-07	1966-12-07 00:00:00	1967-01-16	1967-01-16 00:00:00	32020		\N	257664	0	38822007	195588		0
65805	3890	40481087	2012-03-03	2012-03-03 00:00:00	2012-03-10	2012-03-10 00:00:00	32020		\N	258560	0	444814009	40481087		0
55389	3280	40481087	1971-07-04	1971-07-04 00:00:00	1971-07-18	1971-07-18 00:00:00	32020		\N	218032	0	444814009	40481087		0
55559	3290	257012	1974-12-19	1974-12-19 00:00:00	\N	\N	32020		\N	218546	0	40055000	257012		0
55746	3300	440448	1986-08-06	1986-08-06 00:00:00	\N	\N	32020		\N	219258	0	74400008	440448		0
55822	3304	28060	1985-10-13	1985-10-13 00:00:00	1985-10-21	1985-10-21 00:00:00	32020		\N	219450	0	43878008	28060		0
66625	3942	4237458	1989-06-21	1989-06-21 00:00:00	1989-07-21	1989-07-21 00:00:00	32020		\N	262086	0	58150001	4237458		0
56267	3335	40481087	1980-09-15	1980-09-15 00:00:00	1980-10-06	1980-10-06 00:00:00	32020		\N	221240	0	444814009	40481087		0
56411	3343	440086	1985-06-04	1985-06-04 00:00:00	1988-05-10	1988-05-10 00:00:00	32020		\N	221806	0	192127007	440086		0
56556	3353	40480160	1998-11-26	1998-11-26 00:00:00	1999-01-25	1999-01-25 00:00:00	32020		\N	222452	0	443165006	40480160		0
67340	3980	4116491	1992-10-22	1992-10-22 00:00:00	1992-11-26	1992-11-26 00:00:00	32020		\N	264562	0	301011002	4116491		0
56930	3378	28060	1977-05-03	1977-05-03 00:00:00	1977-05-16	1977-05-16 00:00:00	32020		\N	224123	0	43878008	28060		0
57028	3383	4134304	1988-04-06	1988-04-06 00:00:00	1988-05-06	1988-05-06 00:00:00	32020		\N	224491	0	263102004	4134304		0
57150	3391	80180	2019-05-29	2019-05-29 00:00:00	\N	\N	32020		\N	224882	0	396275006	80180		0
57418	3408	4027663	2000-06-29	2000-06-29 00:00:00	\N	\N	32020		\N	226022	0	13200003	4027663		0
57562	3414	40481087	1978-05-10	1978-05-10 00:00:00	1978-05-24	1978-05-24 00:00:00	32020		\N	226459	0	444814009	40481087		0
57756	3427	440086	1975-04-04	1975-04-04 00:00:00	1984-04-11	1984-04-11 00:00:00	32020		\N	227210	0	192127007	440086		0
57900	3434	40481087	1958-11-04	1958-11-04 00:00:00	1958-11-11	1958-11-11 00:00:00	32020		\N	227704	0	444814009	40481087		0
58036	3439	40481087	1960-05-19	1960-05-19 00:00:00	1960-06-02	1960-06-02 00:00:00	32020		\N	228184	0	444814009	40481087		0
58208	3446	28060	1991-10-18	1991-10-18 00:00:00	1991-10-27	1991-10-27 00:00:00	32020		\N	228850	0	43878008	28060		0
58304	3454	40481087	2013-07-28	2013-07-28 00:00:00	2013-08-18	2013-08-18 00:00:00	32020		\N	229147	0	444814009	40481087		0
58493	3464	40481087	2016-02-23	2016-02-23 00:00:00	2016-03-01	2016-03-01 00:00:00	32020		\N	229921	0	444814009	40481087		0
69297	4101	28060	1971-06-08	1971-06-08 00:00:00	1971-06-20	1971-06-20 00:00:00	32020		\N	272510	0	43878008	28060		0
58768	3486	260139	1971-03-06	1971-03-06 00:00:00	1971-03-20	1971-03-20 00:00:00	32020		\N	231254	0	10509002	260139		0
48468	2869	40481087	1968-07-13	1968-07-13 00:00:00	1968-07-27	1968-07-27 00:00:00	32020		\N	190844	0	444814009	40481087		0
69758	4127	257012	1955-01-18	1955-01-18 00:00:00	\N	\N	32020		\N	274334	0	40055000	257012		0
70020	4143	134438	1980-10-01	1980-10-01 00:00:00	1981-08-27	1981-08-27 00:00:00	32020		\N	275379	0	40275004	134438		0
59481	3527	40481087	1964-08-01	1964-08-01 00:00:00	1964-08-22	1964-08-22 00:00:00	32020		\N	234018	0	444814009	40481087		0
59752	3540	80180	2013-07-07	2013-07-07 00:00:00	\N	\N	32020		\N	235163	0	396275006	80180		0
70438	4173	4156265	2008-08-17	2008-08-17 00:00:00	2008-09-07	2008-09-07 00:00:00	32020		\N	277375	0	370247008	4156265		0
60088	3560	260139	1991-08-22	1991-08-22 00:00:00	1991-08-29	1991-08-29 00:00:00	32020		\N	236357	0	10509002	260139		0
60225	3565	4112343	2000-04-14	2000-04-14 00:00:00	2000-04-25	2000-04-25 00:00:00	32020		\N	236716	0	195662009	4112343		0
60372	3571	378001	2006-07-21	2006-07-21 00:00:00	2006-09-19	2006-09-19 00:00:00	32020		\N	237440	0	62106007	378001		0
60436	3573	4285898	1962-12-04	1962-12-04 00:00:00	\N	\N	32020		\N	237612	0	68496003	4285898		0
60712	3593	4027663	1977-03-13	1977-03-13 00:00:00	\N	\N	32020		\N	238695	0	13200003	4027663		0
60808	3599	4296204	1976-11-07	1976-11-07 00:00:00	1976-12-05	1976-12-05 00:00:00	32020		\N	239083	0	403190006	4296204		0
61077	3614	4112343	1967-07-06	1967-07-06 00:00:00	1967-07-19	1967-07-19 00:00:00	32020		\N	240142	0	195662009	4112343		0
61160	3618	40481087	1991-02-20	1991-02-20 00:00:00	1991-03-13	1991-03-13 00:00:00	32020		\N	240346	0	444814009	40481087		0
61330	3625	81151	2011-08-26	2011-08-26 00:00:00	2011-09-16	2011-09-16 00:00:00	32020		\N	241059	0	44465007	81151		0
61492	3633	4112343	2013-02-28	2013-02-28 00:00:00	2013-03-11	2013-03-11 00:00:00	32020		\N	241658	0	195662009	4112343		0
61591	3639	4112343	1979-01-14	1979-01-14 00:00:00	1979-01-21	1979-01-21 00:00:00	32020		\N	242031	0	195662009	4112343		0
72409	4297	260139	2008-01-28	2008-01-28 00:00:00	2008-02-04	2008-02-04 00:00:00	32020		\N	285159	0	10509002	260139		0
72558	4309	4285898	1993-10-18	1993-10-18 00:00:00	\N	\N	32020		\N	285932	0	68496003	4285898		0
62219	3675	40481087	2012-11-18	2012-11-18 00:00:00	2012-11-25	2012-11-25 00:00:00	32020		\N	244436	0	444814009	40481087		0
72980	4337	4112343	1974-08-04	1974-08-04 00:00:00	1974-08-15	1974-08-15 00:00:00	32020		\N	287588	0	195662009	4112343		0
62569	3697	4149245	1955-02-01	1955-02-01 00:00:00	1955-03-10	1955-03-10 00:00:00	32020		\N	245719	0	30832001	4149245		0
62648	3700	40481087	1976-06-11	1976-06-11 00:00:00	1976-06-18	1976-06-18 00:00:00	32020		\N	246024	0	444814009	40481087		0
73398	4364	28060	1961-03-26	1961-03-26 00:00:00	1961-04-04	1961-04-04 00:00:00	32020		\N	289449	0	43878008	28060		0
62963	3719	81151	1999-06-03	1999-06-03 00:00:00	1999-07-01	1999-07-01 00:00:00	32020		\N	247168	0	44465007	81151		0
73756	4382	4283893	2008-04-13	2008-04-13 00:00:00	2008-07-06	2008-07-06 00:00:00	32020		\N	291271	0	36971009	4283893		0
73905	4390	4113008	1973-02-13	1973-02-13 00:00:00	1973-03-06	1973-03-06 00:00:00	32020		\N	291790	0	284549007	4113008		0
74048	4398	81151	1962-03-03	1962-03-03 00:00:00	1962-04-07	1962-04-07 00:00:00	32020		\N	292431	0	44465007	81151		0
74278	4411	4116491	1996-05-25	1996-05-25 00:00:00	1996-07-13	1996-07-13 00:00:00	32020		\N	293190	0	301011002	4116491		0
53275	3157	372328	2011-12-09	2011-12-09 00:00:00	2012-01-27	2012-01-27 00:00:00	32020		\N	209887	0	65363002	372328		0
63962	3779	40481087	1981-02-10	1981-02-10 00:00:00	1981-02-17	1981-02-17 00:00:00	32020		\N	251145	0	444814009	40481087		0
53617	3177	260139	1984-03-27	1984-03-27 00:00:00	1984-04-10	1984-04-10 00:00:00	32020		\N	211252	0	10509002	260139		0
53714	3179	260139	1970-04-09	1970-04-09 00:00:00	1970-04-23	1970-04-23 00:00:00	32020		\N	211461	0	10509002	260139		0
53825	3184	372328	1995-11-16	1995-11-16 00:00:00	1998-08-13	1998-08-13 00:00:00	32020		\N	211961	0	65363002	372328		0
64593	3820	260139	2015-12-11	2015-12-11 00:00:00	2015-12-18	2015-12-18 00:00:00	32020		\N	253615	0	10509002	260139		0
54152	3207	372328	1961-06-28	1961-06-28 00:00:00	1961-11-16	1961-11-16 00:00:00	32020		\N	213127	0	65363002	372328		0
54387	3222	4237458	1959-04-20	1959-04-20 00:00:00	1959-05-20	1959-05-20 00:00:00	32020		\N	214154	0	58150001	4237458		0
54513	3229	80180	2019-04-14	2019-04-14 00:00:00	\N	\N	32020		\N	214629	0	396275006	80180		0
54716	3238	372328	1968-03-23	1968-03-23 00:00:00	1968-05-06	1968-05-06 00:00:00	32020		\N	215290	0	65363002	372328		0
54886	3248	198809	2016-06-26	2016-06-26 00:00:00	2016-06-26	2016-06-26 00:00:00	32020		\N	215881	0	65275009	198809		0
65609	3879	4112343	1945-06-16	1945-06-16 00:00:00	1945-06-27	1945-06-27 00:00:00	32020		\N	257696	0	195662009	4112343		0
65806	3890	80180	1993-01-28	1993-01-28 00:00:00	\N	\N	32020		\N	258569	0	396275006	80180		0
55390	3280	40481087	1991-04-22	1991-04-22 00:00:00	1991-04-29	1991-04-29 00:00:00	32020		\N	217976	0	444814009	40481087		0
55560	3290	40481087	1982-09-12	1982-09-12 00:00:00	1982-09-19	1982-09-19 00:00:00	32020		\N	218586	0	444814009	40481087		0
55747	3300	4166224	1986-08-06	1986-08-06 00:00:00	\N	\N	32020		\N	219258	0	47693006	4166224		0
55823	3304	40481087	1973-12-18	1973-12-18 00:00:00	1974-01-08	1974-01-08 00:00:00	32020		\N	219417	0	444814009	40481087		0
66626	3942	40481087	2009-01-12	2009-01-12 00:00:00	2009-01-26	2009-01-26 00:00:00	32020		\N	262097	0	444814009	40481087		0
56268	3335	375671	1999-09-29	1999-09-29 00:00:00	1999-11-28	1999-11-28 00:00:00	32020		\N	221301	0	62564004	375671		0
56412	3343	4084167	1977-07-01	1977-07-01 00:00:00	1977-07-01	1977-07-01 00:00:00	32020		\N	221859	0	241929008	4084167		0
56557	3353	4278672	1998-11-26	1998-11-26 00:00:00	1999-01-25	1999-01-25 00:00:00	32020		\N	222452	0	65966004	4278672		0
67341	3980	40481087	1997-02-02	1997-02-02 00:00:00	1997-02-23	1997-02-23 00:00:00	32020		\N	264616	0	444814009	40481087		0
56931	3378	78272	1961-03-01	1961-03-01 00:00:00	1961-03-15	1961-03-15 00:00:00	32020		\N	224129	0	70704007	78272		0
57029	3383	4112343	1988-11-04	1988-11-04 00:00:00	1988-11-15	1988-11-15 00:00:00	32020		\N	224477	0	195662009	4112343		0
57151	3391	4059173	2009-12-04	2009-12-04 00:00:00	2010-02-02	2010-02-02 00:00:00	32020		\N	224902	0	16114001	4059173		0
57419	3408	4109685	1999-06-12	1999-06-12 00:00:00	1999-07-03	1999-07-03 00:00:00	32020		\N	226022	0	284551006	4109685		0
57563	3414	4112343	2015-01-06	2015-01-06 00:00:00	2015-01-17	2015-01-17 00:00:00	32020		\N	226491	0	195662009	4112343		0
57757	3427	78272	2008-04-02	2008-04-02 00:00:00	2008-04-30	2008-04-30 00:00:00	32020		\N	227228	0	70704007	78272		0
57901	3435	40481087	2017-12-14	2017-12-14 00:00:00	2017-12-28	2017-12-28 00:00:00	32020		\N	227798	0	444814009	40481087		0
58037	3439	4112343	1998-03-17	1998-03-17 00:00:00	1998-03-26	1998-03-26 00:00:00	32020		\N	228192	0	195662009	4112343		0
58209	3446	4294548	1971-08-05	1971-08-05 00:00:00	1971-12-16	1971-12-16 00:00:00	32020		\N	228765	0	75498004	4294548		0
58305	3454	40481087	1998-02-13	1998-02-13 00:00:00	1998-02-27	1998-02-27 00:00:00	32020		\N	229163	0	444814009	40481087		0
58494	3464	80180	2017-04-25	2017-04-25 00:00:00	\N	\N	32020		\N	229921	0	396275006	80180		0
69299	4101	4029498	1960-02-27	1960-02-27 00:00:00	\N	\N	32020		\N	272468	0	128613002	4029498		0
58769	3486	4218389	1988-09-21	1988-09-21 00:00:00	1988-10-19	1988-10-19 00:00:00	32020		\N	231297	0	39848009	4218389		0
48469	2869	260139	1970-03-04	1970-03-04 00:00:00	1970-03-11	1970-03-11 00:00:00	32020		\N	190889	0	10509002	260139		0
69759	4127	381316	2012-04-01	2012-04-01 00:00:00	\N	\N	32020		\N	274344	0	230690007	381316		0
70021	4143	30753	1999-06-12	1999-06-12 00:00:00	\N	\N	32020		\N	275401	0	16761005	30753		0
59482	3527	28060	1971-07-03	1971-07-03 00:00:00	1971-07-15	1971-07-15 00:00:00	32020		\N	234089	0	43878008	28060		0
59753	3540	40481087	1980-01-02	1980-01-02 00:00:00	1980-01-23	1980-01-23 00:00:00	32020		\N	235150	0	444814009	40481087		0
70439	4173	4112343	1987-06-29	1987-06-29 00:00:00	1987-07-08	1987-07-08 00:00:00	32020		\N	277343	0	195662009	4112343		0
60089	3560	40481087	2014-06-02	2014-06-02 00:00:00	2014-06-09	2014-06-09 00:00:00	32020		\N	236399	0	444814009	40481087		0
60226	3565	4218389	1950-01-02	1950-01-02 00:00:00	1950-01-30	1950-01-30 00:00:00	32020		\N	236738	0	39848009	4218389		0
60373	3571	260139	1980-10-07	1980-10-07 00:00:00	1980-10-14	1980-10-14 00:00:00	32020		\N	237342	0	10509002	260139		0
60437	3573	260139	1968-11-30	1968-11-30 00:00:00	1968-12-07	1968-12-07 00:00:00	32020		\N	237578	0	10509002	260139		0
60713	3593	81893	1987-06-04	1987-06-04 00:00:00	\N	\N	32020		\N	238699	0	64766004	81893		0
60809	3599	372328	1971-06-09	1971-06-09 00:00:00	1972-04-21	1972-04-21 00:00:00	32020		\N	239052	0	65363002	372328		0
61078	3614	439777	2009-06-11	2009-06-11 00:00:00	\N	\N	32020		\N	240143	0	271737000	439777		0
61161	3618	4112343	1980-04-10	1980-04-10 00:00:00	1980-04-18	1980-04-18 00:00:00	32020		\N	240453	0	195662009	4112343		0
61331	3625	40481087	1954-10-14	1954-10-14 00:00:00	1954-10-21	1954-10-21 00:00:00	32020		\N	241043	0	444814009	40481087		0
61493	3634	40481087	1986-05-08	1986-05-08 00:00:00	1986-05-22	1986-05-22 00:00:00	32020		\N	241732	0	444814009	40481087		0
61592	3639	4112343	1966-05-24	1966-05-24 00:00:00	1966-06-05	1966-06-05 00:00:00	32020		\N	242064	0	195662009	4112343		0
72410	4297	28060	1975-04-08	1975-04-08 00:00:00	1975-04-16	1975-04-16 00:00:00	32020		\N	285184	0	43878008	28060		0
72559	4309	80180	1994-01-16	1994-01-16 00:00:00	\N	\N	32020		\N	285932	0	396275006	80180		0
62220	3675	4112343	1974-10-24	1974-10-24 00:00:00	1974-11-03	1974-11-03 00:00:00	32020		\N	244432	0	195662009	4112343		0
72981	4337	372328	1961-08-08	1961-08-08 00:00:00	1961-09-15	1961-09-15 00:00:00	32020		\N	287594	0	65363002	372328		0
62570	3697	40481087	1959-08-28	1959-08-28 00:00:00	1959-09-18	1959-09-18 00:00:00	32020		\N	245780	0	444814009	40481087		0
62649	3700	372328	1978-08-04	1978-08-04 00:00:00	1978-09-20	1978-09-20 00:00:00	32020		\N	245987	0	65363002	372328		0
73399	4364	260139	2019-01-08	2019-01-08 00:00:00	2019-01-15	2019-01-15 00:00:00	32020		\N	289458	0	10509002	260139		0
62964	3719	4283893	1968-01-08	1968-01-08 00:00:00	1968-04-01	1968-04-01 00:00:00	32020		\N	247220	0	36971009	4283893		0
73757	4382	80180	1994-05-03	1994-05-03 00:00:00	\N	\N	32020		\N	291224	0	396275006	80180		0
73906	4390	260139	1997-02-21	1997-02-21 00:00:00	1997-02-28	1997-02-28 00:00:00	32020		\N	291919	0	10509002	260139		0
74049	4398	4294548	2008-04-25	2008-04-25 00:00:00	2008-06-06	2008-06-06 00:00:00	32020		\N	292390	0	75498004	4294548		0
74279	4411	40481087	2008-03-14	2008-03-14 00:00:00	2008-04-04	2008-04-04 00:00:00	32020		\N	293165	0	444814009	40481087		0
53276	3157	4112343	1957-03-11	1957-03-11 00:00:00	1957-03-22	1957-03-22 00:00:00	32020		\N	209812	0	195662009	4112343		0
63963	3779	4027663	1995-03-29	1995-03-29 00:00:00	\N	\N	32020		\N	251135	0	13200003	4027663		0
53618	3177	40480160	1993-10-04	1993-10-04 00:00:00	1993-11-03	1993-11-03 00:00:00	32020		\N	211234	0	443165006	40480160		0
53715	3179	4059173	1932-10-14	1932-10-14 00:00:00	1933-01-12	1933-01-12 00:00:00	32020		\N	211527	0	16114001	4059173		0
53826	3184	40481087	1966-02-12	1966-02-12 00:00:00	1966-02-26	1966-02-26 00:00:00	32020		\N	211957	0	444814009	40481087		0
64594	3820	4109685	1998-03-07	1998-03-07 00:00:00	1998-03-21	1998-03-21 00:00:00	32020		\N	253653	0	284551006	4109685		0
54153	3208	4112343	2004-01-19	2004-01-19 00:00:00	2004-01-27	2004-01-27 00:00:00	32020		\N	213273	0	195662009	4112343		0
54388	3222	4294548	1964-09-16	1964-09-16 00:00:00	1965-01-27	1965-01-27 00:00:00	32020		\N	214137	0	75498004	4294548		0
54514	3229	40481087	2019-01-20	2019-01-20 00:00:00	2019-02-10	2019-02-10 00:00:00	32020		\N	214629	0	444814009	40481087		0
54717	3238	40481087	1986-08-31	1986-08-31 00:00:00	1986-09-14	1986-09-14 00:00:00	32020		\N	215299	0	444814009	40481087		0
54887	3248	196456	2016-06-26	2016-06-26 00:00:00	2016-06-26	2016-06-26 00:00:00	32020		\N	215881	0	235919008	196456		0
65610	3879	40481087	1986-05-10	1986-05-10 00:00:00	1986-05-31	1986-05-31 00:00:00	32020		\N	257693	0	444814009	40481087		0
65807	3890	40481087	1991-12-08	1991-12-08 00:00:00	1991-12-15	1991-12-15 00:00:00	32020		\N	258569	0	444814009	40481087		0
55391	3280	4294548	1951-11-21	1951-11-21 00:00:00	1952-04-02	1952-04-02 00:00:00	32020		\N	218028	0	75498004	4294548		0
55561	3290	28060	1979-09-09	1979-09-09 00:00:00	1979-09-22	1979-09-22 00:00:00	32020		\N	218585	0	43878008	28060		0
55748	3300	260139	1983-05-03	1983-05-03 00:00:00	1983-05-10	1983-05-10 00:00:00	32020		\N	219217	0	10509002	260139		0
55824	3304	40481087	2010-01-13	2010-01-13 00:00:00	2010-01-20	2010-01-20 00:00:00	32020		\N	219465	0	444814009	40481087		0
66627	3942	81151	2004-09-05	2004-09-05 00:00:00	2004-10-10	2004-10-10 00:00:00	32020		\N	262088	0	44465007	81151		0
56269	3335	260139	1975-05-12	1975-05-12 00:00:00	1975-05-26	1975-05-26 00:00:00	32020		\N	221283	0	10509002	260139		0
56413	3343	4048171	1980-06-12	1980-06-12 00:00:00	\N	\N	32020		\N	221731	0	232353008	4048171		0
56558	3355	28060	1966-12-02	1966-12-02 00:00:00	1966-12-10	1966-12-10 00:00:00	32020		\N	222481	0	43878008	28060		0
67342	3980	28060	2016-08-27	2016-08-27 00:00:00	2016-09-07	2016-09-07 00:00:00	32020		\N	264564	0	43878008	28060		0
56932	3378	260139	2000-06-12	2000-06-12 00:00:00	2000-06-26	2000-06-26 00:00:00	32020		\N	224150	0	10509002	260139		0
57030	3383	40481087	1993-10-13	1993-10-13 00:00:00	1993-10-27	1993-10-27 00:00:00	32020		\N	224478	0	444814009	40481087		0
57152	3391	260139	1994-10-19	1994-10-19 00:00:00	1994-10-26	1994-10-26 00:00:00	32020		\N	224906	0	10509002	260139		0
57420	3408	40481087	1980-10-07	1980-10-07 00:00:00	1980-10-21	1980-10-21 00:00:00	32020		\N	226036	0	444814009	40481087		0
57564	3414	4112343	2013-04-06	2013-04-06 00:00:00	2013-04-15	2013-04-15 00:00:00	32020		\N	226437	0	195662009	4112343		0
57758	3427	28060	1974-07-24	1974-07-24 00:00:00	1974-07-31	1974-07-31 00:00:00	32020		\N	227209	0	43878008	28060		0
57902	3435	40481087	2011-06-07	2011-06-07 00:00:00	2011-06-14	2011-06-14 00:00:00	32020		\N	227775	0	444814009	40481087		0
58038	3439	40481087	1977-02-28	1977-02-28 00:00:00	1977-03-14	1977-03-14 00:00:00	32020		\N	228216	0	444814009	40481087		0
58210	3446	260139	1959-12-01	1959-12-01 00:00:00	1959-12-08	1959-12-08 00:00:00	32020		\N	228807	0	10509002	260139		0
58306	3454	260139	1998-02-27	1998-02-27 00:00:00	1998-03-13	1998-03-13 00:00:00	32020		\N	229146	0	10509002	260139		0
58495	3464	134438	2009-05-14	2009-05-14 00:00:00	2010-04-15	2010-04-15 00:00:00	32020		\N	229997	0	40275004	134438		0
69300	4102	40481087	1987-03-26	1987-03-26 00:00:00	1987-04-02	1987-04-02 00:00:00	32020		\N	272594	0	444814009	40481087		0
58770	3486	260139	1988-02-24	1988-02-24 00:00:00	1988-03-02	1988-03-02 00:00:00	32020		\N	231239	0	10509002	260139		0
48470	2869	78272	1968-12-16	1968-12-16 00:00:00	1968-12-30	1968-12-30 00:00:00	32020		\N	190825	0	70704007	78272		0
69760	4127	81151	2011-11-03	2011-11-03 00:00:00	2011-12-01	2011-12-01 00:00:00	32020		\N	274344	0	44465007	81151		0
70022	4143	4027663	1990-09-22	1990-09-22 00:00:00	\N	\N	32020		\N	275366	0	13200003	4027663		0
59483	3527	4027663	1994-07-05	1994-07-05 00:00:00	\N	\N	32020		\N	234072	0	13200003	4027663		0
59754	3540	4112343	2016-05-28	2016-05-28 00:00:00	2016-06-06	2016-06-06 00:00:00	32020		\N	235126	0	195662009	4112343		0
70440	4173	378001	1986-10-12	1986-10-12 00:00:00	1986-12-11	1986-12-11 00:00:00	32020		\N	277374	0	62106007	378001		0
60090	3560	40481087	1961-01-08	1961-01-08 00:00:00	1961-01-29	1961-01-29 00:00:00	32020		\N	236350	0	444814009	40481087		0
60227	3565	40481087	1962-02-10	1962-02-10 00:00:00	1962-03-03	1962-03-03 00:00:00	32020		\N	236713	0	444814009	40481087		0
60374	3571	260139	2017-07-17	2017-07-17 00:00:00	2017-07-31	2017-07-31 00:00:00	32020		\N	237316	0	10509002	260139		0
60438	3573	4152936	1937-03-15	1937-03-15 00:00:00	1937-03-29	1937-03-29 00:00:00	32020		\N	237624	0	283385000	4152936		0
60714	3593	4112343	1980-06-19	1980-06-19 00:00:00	1980-06-26	1980-06-26 00:00:00	32020		\N	238669	0	195662009	4112343		0
60810	3599	40481087	1976-05-19	1976-05-19 00:00:00	1976-06-02	1976-06-02 00:00:00	32020		\N	239049	0	444814009	40481087		0
61079	3614	4296204	1967-12-19	1967-12-19 00:00:00	1968-01-23	1968-01-23 00:00:00	32020		\N	240098	0	403190006	4296204		0
61162	3618	257012	1994-05-20	1994-05-20 00:00:00	\N	\N	32020		\N	240357	0	40055000	257012		0
61332	3625	80502	2013-09-10	2013-09-10 00:00:00	\N	\N	32020		\N	241115	0	64859006	80502		0
61494	3634	4027663	1997-02-16	1997-02-16 00:00:00	\N	\N	32020		\N	241705	0	13200003	4027663		0
61593	3639	255848	2010-03-27	2010-03-27 00:00:00	\N	\N	32020		\N	242058	0	233604007	255848		0
72411	4297	372328	1984-03-04	1984-03-04 00:00:00	1985-02-02	1985-02-02 00:00:00	32020		\N	285197	0	65363002	372328		0
72560	4309	40481087	2004-11-08	2004-11-08 00:00:00	2004-11-29	2004-11-29 00:00:00	32020		\N	285889	0	444814009	40481087		0
62221	3675	80180	2008-11-22	2008-11-22 00:00:00	\N	\N	32020		\N	244471	0	396275006	80180		0
72982	4337	372328	1961-11-14	1961-11-14 00:00:00	1962-02-16	1962-02-16 00:00:00	32020		\N	287580	0	65363002	372328		0
62571	3697	260139	1986-09-10	1986-09-10 00:00:00	1986-09-17	1986-09-17 00:00:00	32020		\N	245802	0	10509002	260139		0
62650	3700	40481087	1998-07-17	1998-07-17 00:00:00	1998-07-24	1998-07-24 00:00:00	32020		\N	246006	0	444814009	40481087		0
73400	4364	260139	2007-05-28	2007-05-28 00:00:00	2007-06-04	2007-06-04 00:00:00	32020		\N	289451	0	10509002	260139		0
62965	3719	260139	1986-11-19	1986-11-19 00:00:00	1986-12-03	1986-12-03 00:00:00	32020		\N	247194	0	10509002	260139		0
73758	4382	28060	1984-12-22	1984-12-22 00:00:00	1985-01-02	1985-01-02 00:00:00	32020		\N	291251	0	43878008	28060		0
73907	4390	4112343	2014-03-18	2014-03-18 00:00:00	2014-03-30	2014-03-30 00:00:00	32020		\N	291895	0	195662009	4112343		0
74050	4398	257012	1986-10-07	1986-10-07 00:00:00	\N	\N	32020		\N	292446	0	40055000	257012		0
74280	4411	4112343	1971-05-10	1971-05-10 00:00:00	1971-05-21	1971-05-21 00:00:00	32020		\N	293201	0	195662009	4112343		0
53277	3157	4112343	1965-01-13	1965-01-13 00:00:00	1965-01-20	1965-01-20 00:00:00	32020		\N	209813	0	195662009	4112343		0
63964	3779	40481087	1991-09-28	1991-09-28 00:00:00	1991-10-12	1991-10-12 00:00:00	32020		\N	251136	0	444814009	40481087		0
64077	3786	4112343	1979-05-13	1979-05-13 00:00:00	1979-05-21	1979-05-21 00:00:00	32020		\N	251669	0	195662009	4112343		0
53716	3179	378001	1943-08-18	1943-08-18 00:00:00	1943-10-17	1943-10-17 00:00:00	32020		\N	211528	0	62106007	378001		0
53827	3184	40481087	2006-05-15	2006-05-15 00:00:00	2006-05-22	2006-05-22 00:00:00	32020		\N	211974	0	444814009	40481087		0
64595	3820	40481087	2004-07-22	2004-07-22 00:00:00	2004-07-29	2004-07-29 00:00:00	32020		\N	253605	0	444814009	40481087		0
54154	3208	40481087	1968-03-17	1968-03-17 00:00:00	1968-03-31	1968-03-31 00:00:00	32020		\N	213266	0	444814009	40481087		0
54389	3222	372328	1952-01-27	1952-01-27 00:00:00	1952-03-11	1952-03-11 00:00:00	32020		\N	214178	0	65363002	372328		0
54515	3229	4113008	2003-12-29	2003-12-29 00:00:00	2004-01-19	2004-01-19 00:00:00	32020		\N	214638	0	284549007	4113008		0
54718	3238	261325	2017-03-06	2017-03-06 00:00:00	\N	\N	32020		\N	215272	0	87433001	261325		0
54888	3248	4027663	1972-07-06	1972-07-06 00:00:00	\N	\N	32020		\N	215865	0	13200003	4027663		0
65611	3879	40481087	1961-02-08	1961-02-08 00:00:00	1961-03-01	1961-03-01 00:00:00	32020		\N	257697	0	444814009	40481087		0
65808	3891	4051466	1984-11-30	1984-11-30 00:00:00	2002-03-05	2002-03-05 00:00:00	32020		\N	258627	0	233678006	4051466		0
55392	3280	78272	1967-09-17	1967-09-17 00:00:00	1967-10-08	1967-10-08 00:00:00	32020		\N	218036	0	70704007	78272		0
55562	3290	4310024	2002-05-24	2002-05-24 00:00:00	\N	\N	32020		\N	218541	0	424802006	4310024		0
55749	3300	28060	1997-04-17	1997-04-17 00:00:00	1997-04-28	1997-04-28 00:00:00	32020		\N	219194	0	43878008	28060		0
55825	3304	28060	1989-03-05	1989-03-05 00:00:00	1989-03-16	1989-03-16 00:00:00	32020		\N	219427	0	43878008	28060		0
66628	3942	4112343	1981-04-08	1981-04-08 00:00:00	1981-04-20	1981-04-20 00:00:00	32020		\N	262077	0	195662009	4112343		0
56270	3335	378001	1973-03-21	1973-03-21 00:00:00	1973-05-20	1973-05-20 00:00:00	32020		\N	221297	0	62106007	378001		0
56414	3343	378001	1985-02-19	1985-02-19 00:00:00	1985-03-21	1985-03-21 00:00:00	32020		\N	221861	0	62106007	378001		0
56559	3355	4134304	1977-11-15	1977-11-15 00:00:00	1978-02-13	1978-02-13 00:00:00	32020		\N	222506	0	263102004	4134304		0
67343	3980	40481087	2017-05-25	2017-05-25 00:00:00	2017-06-15	2017-06-15 00:00:00	32020		\N	264595	0	444814009	40481087		0
56933	3378	4112343	1975-01-29	1975-01-29 00:00:00	1975-02-11	1975-02-11 00:00:00	32020		\N	224175	0	195662009	4112343		0
57031	3383	40481087	2010-02-20	2010-02-20 00:00:00	2010-03-06	2010-03-06 00:00:00	32020		\N	224485	0	444814009	40481087		0
57153	3392	40481087	1996-08-12	1996-08-12 00:00:00	1996-09-02	1996-09-02 00:00:00	32020		\N	224977	0	444814009	40481087		0
57421	3408	40481087	2003-12-13	2003-12-13 00:00:00	2004-01-03	2004-01-03 00:00:00	32020		\N	225999	0	444814009	40481087		0
57565	3415	4112343	1997-12-30	1997-12-30 00:00:00	1998-01-11	1998-01-11 00:00:00	32020		\N	226497	0	195662009	4112343		0
57759	3427	40481087	1968-09-01	1968-09-01 00:00:00	1968-09-22	1968-09-22 00:00:00	32020		\N	227188	0	444814009	40481087		0
57903	3435	80180	2016-06-29	2016-06-29 00:00:00	\N	\N	32020		\N	227788	0	396275006	80180		0
58039	3439	4112343	1990-08-15	1990-08-15 00:00:00	1990-08-25	1990-08-25 00:00:00	32020		\N	228210	0	195662009	4112343		0
58211	3446	440448	1953-12-12	1953-12-12 00:00:00	\N	\N	32020		\N	228776	0	74400008	440448		0
58307	3454	372328	1983-09-11	1983-09-11 00:00:00	1983-11-14	1983-11-14 00:00:00	32020		\N	229149	0	65363002	372328		0
58496	3464	195588	2005-05-08	2005-05-08 00:00:00	2005-06-11	2005-06-11 00:00:00	32020		\N	229957	0	38822007	195588		0
69301	4102	4156265	1972-02-14	1972-02-14 00:00:00	1972-03-06	1972-03-06 00:00:00	32020		\N	272578	0	370247008	4156265		0
58771	3486	4112343	1980-04-14	1980-04-14 00:00:00	1980-04-27	1980-04-27 00:00:00	32020		\N	231291	0	195662009	4112343		0
48471	2869	372328	1953-11-07	1953-11-07 00:00:00	1954-03-30	1954-03-30 00:00:00	32020		\N	190895	0	65363002	372328		0
69761	4127	40481087	2011-10-16	2011-10-16 00:00:00	2011-10-23	2011-10-23 00:00:00	32020		\N	274347	0	444814009	40481087		0
70023	4143	80180	2000-12-03	2000-12-03 00:00:00	\N	\N	32020		\N	275355	0	396275006	80180		0
59484	3527	40481087	1994-03-19	1994-03-19 00:00:00	1994-04-02	1994-04-02 00:00:00	32020		\N	234072	0	444814009	40481087		0
59755	3541	4112343	1983-06-17	1983-06-17 00:00:00	1983-06-27	1983-06-27 00:00:00	32020		\N	235171	0	195662009	4112343		0
70441	4173	4112343	1985-11-22	1985-11-22 00:00:00	1985-12-02	1985-12-02 00:00:00	32020		\N	277363	0	195662009	4112343		0
60091	3560	4109685	2017-04-10	2017-04-10 00:00:00	2017-05-01	2017-05-01 00:00:00	32020		\N	236410	0	284551006	4109685		0
60228	3565	4112343	1999-10-02	1999-10-02 00:00:00	1999-10-15	1999-10-15 00:00:00	32020		\N	236719	0	195662009	4112343		0
60375	3571	4134304	1983-10-20	1983-10-20 00:00:00	1984-01-18	1984-01-18 00:00:00	32020		\N	237438	0	263102004	4134304		0
60439	3573	4278672	1957-07-12	1957-07-12 00:00:00	1957-09-10	1957-09-10 00:00:00	32020		\N	237626	0	65966004	4278672		0
60715	3593	40481087	2008-08-11	2008-08-11 00:00:00	2008-08-18	2008-08-18 00:00:00	32020		\N	238720	0	444814009	40481087		0
60811	3599	4112343	1966-07-06	1966-07-06 00:00:00	1966-07-16	1966-07-16 00:00:00	32020		\N	239031	0	195662009	4112343		0
61080	3614	81151	1993-04-11	1993-04-11 00:00:00	1993-05-16	1993-05-16 00:00:00	32020		\N	240099	0	44465007	81151		0
61163	3618	4296204	1926-12-22	1926-12-22 00:00:00	1927-01-19	1927-01-19 00:00:00	32020		\N	240396	0	403190006	4296204		0
61333	3625	372328	1954-11-20	1954-11-20 00:00:00	1954-12-21	1954-12-21 00:00:00	32020		\N	241086	0	65363002	372328		0
61495	3634	260139	2008-04-06	2008-04-06 00:00:00	2008-04-20	2008-04-20 00:00:00	32020		\N	241698	0	10509002	260139		0
61594	3639	81151	1980-12-24	1980-12-24 00:00:00	1981-01-07	1981-01-07 00:00:00	32020		\N	242123	0	44465007	81151		0
72412	4297	4294548	1983-10-20	1983-10-20 00:00:00	1983-11-10	1983-11-10 00:00:00	32020		\N	285187	0	75498004	4294548		0
72561	4309	260139	1981-08-05	1981-08-05 00:00:00	1981-08-12	1981-08-12 00:00:00	32020		\N	285891	0	10509002	260139		0
62222	3675	4283893	1978-03-14	1978-03-14 00:00:00	1978-07-18	1978-07-18 00:00:00	32020		\N	244409	0	36971009	4283893		0
72983	4337	381316	1991-02-22	1991-02-22 00:00:00	\N	\N	32020		\N	287563	0	230690007	381316		0
62572	3697	260139	1987-04-16	1987-04-16 00:00:00	1987-04-23	1987-04-23 00:00:00	32020		\N	245803	0	10509002	260139		0
62652	3700	440448	2011-08-22	2011-08-22 00:00:00	\N	\N	32020		\N	246011	0	74400008	440448		0
73401	4364	372328	1952-09-21	1952-09-21 00:00:00	1952-12-07	1952-12-07 00:00:00	32020		\N	289456	0	65363002	372328		0
62966	3719	40481087	1966-09-15	1966-09-15 00:00:00	1966-10-06	1966-10-06 00:00:00	32020		\N	247157	0	444814009	40481087		0
73759	4382	260139	1968-06-13	1968-06-13 00:00:00	1968-06-20	1968-06-20 00:00:00	32020		\N	291180	0	10509002	260139		0
73908	4390	4112343	2012-02-13	2012-02-13 00:00:00	2012-02-25	2012-02-25 00:00:00	32020		\N	291891	0	195662009	4112343		0
74051	4398	40481087	1964-08-25	1964-08-25 00:00:00	1964-09-01	1964-09-01 00:00:00	32020		\N	292444	0	444814009	40481087		0
74281	4411	4112343	2003-05-15	2003-05-15 00:00:00	2003-05-28	2003-05-28 00:00:00	32020		\N	293203	0	195662009	4112343		0
53278	3157	4027663	1978-06-28	1978-06-28 00:00:00	\N	\N	32020		\N	209862	0	13200003	4027663		0
63965	3779	4218389	2012-06-20	2012-06-20 00:00:00	2012-07-18	2012-07-18 00:00:00	32020		\N	251148	0	39848009	4218389		0
64078	3786	4112343	1985-06-06	1985-06-06 00:00:00	1985-06-13	1985-06-13 00:00:00	32020		\N	251713	0	195662009	4112343		0
53717	3179	4155034	1944-09-11	1944-09-11 00:00:00	1944-09-25	1944-09-25 00:00:00	32020		\N	211529	0	283371005	4155034		0
53828	3184	372328	2004-01-14	2004-01-14 00:00:00	2004-02-05	2004-02-05 00:00:00	32020		\N	212008	0	65363002	372328		0
64596	3820	40481087	2007-10-21	2007-10-21 00:00:00	2007-11-04	2007-11-04 00:00:00	32020		\N	253606	0	444814009	40481087		0
54155	3208	40481087	1996-03-09	1996-03-09 00:00:00	1996-03-23	1996-03-23 00:00:00	32020		\N	213250	0	444814009	40481087		0
54390	3222	260139	1958-08-25	1958-08-25 00:00:00	1958-09-01	1958-09-01 00:00:00	32020		\N	214213	0	10509002	260139		0
54516	3229	4112343	1991-04-10	1991-04-10 00:00:00	1991-04-23	1991-04-23 00:00:00	32020		\N	214591	0	195662009	4112343		0
54719	3238	40481087	1979-12-15	1979-12-15 00:00:00	1979-12-29	1979-12-29 00:00:00	32020		\N	215288	0	444814009	40481087		0
54889	3248	40481087	1986-02-12	1986-02-12 00:00:00	1986-02-19	1986-02-19 00:00:00	32020		\N	215854	0	444814009	40481087		0
65612	3879	40481087	1983-12-31	1983-12-31 00:00:00	1984-01-21	1984-01-21 00:00:00	32020		\N	257692	0	444814009	40481087		0
65809	3891	4155034	2007-10-14	2007-10-14 00:00:00	2007-11-04	2007-11-04 00:00:00	32020		\N	258754	0	283371005	4155034		0
55393	3280	372328	2001-05-12	2001-05-12 00:00:00	2001-09-13	2001-09-13 00:00:00	32020		\N	218045	0	65363002	372328		0
55563	3290	28060	1998-06-26	1998-06-26 00:00:00	1998-07-04	1998-07-04 00:00:00	32020		\N	218611	0	43878008	28060		0
55750	3300	80180	2016-08-16	2016-08-16 00:00:00	\N	\N	32020		\N	219248	0	396275006	80180		0
55826	3304	40481087	2009-07-01	2009-07-01 00:00:00	2009-07-08	2009-07-08 00:00:00	32020		\N	219464	0	444814009	40481087		0
66629	3942	4283893	2015-08-02	2015-08-02 00:00:00	2015-08-30	2015-08-30 00:00:00	32020		\N	262098	0	36971009	4283893		0
56271	3335	81151	2005-03-31	2005-03-31 00:00:00	2005-04-28	2005-04-28 00:00:00	32020		\N	221302	0	44465007	81151		0
56415	3343	260139	1995-11-26	1995-11-26 00:00:00	1995-12-03	1995-12-03 00:00:00	32020		\N	221765	0	10509002	260139		0
56560	3355	40481087	1968-12-09	1968-12-09 00:00:00	1968-12-30	1968-12-30 00:00:00	32020		\N	222477	0	444814009	40481087		0
67350	3982	372328	1988-11-18	1988-11-18 00:00:00	1989-10-13	1989-10-13 00:00:00	32020		\N	264714	0	65363002	372328		0
56934	3378	40481087	1978-08-01	1978-08-01 00:00:00	1978-08-08	1978-08-08 00:00:00	32020		\N	224116	0	444814009	40481087		0
57032	3383	4112343	2016-09-11	2016-09-11 00:00:00	2016-09-23	2016-09-23 00:00:00	32020		\N	224484	0	195662009	4112343		0
57154	3392	4112343	1973-08-28	1973-08-28 00:00:00	1973-09-05	1973-09-05 00:00:00	32020		\N	224966	0	195662009	4112343		0
57422	3408	4112343	1976-10-29	1976-10-29 00:00:00	1976-11-07	1976-11-07 00:00:00	32020		\N	226035	0	195662009	4112343		0
57566	3415	4134304	1979-11-22	1979-11-22 00:00:00	1980-02-20	1980-02-20 00:00:00	32020		\N	226551	0	263102004	4134304		0
57760	3427	40481087	1995-09-04	1995-09-04 00:00:00	1995-09-11	1995-09-11 00:00:00	32020		\N	227212	0	444814009	40481087		0
57904	3435	260139	1985-09-01	1985-09-01 00:00:00	1985-09-15	1985-09-15 00:00:00	32020		\N	227810	0	10509002	260139		0
58040	3439	40481087	2000-10-03	2000-10-03 00:00:00	2000-10-17	2000-10-17 00:00:00	32020		\N	228218	0	444814009	40481087		0
58212	3446	4112343	1996-01-05	1996-01-05 00:00:00	1996-01-14	1996-01-14 00:00:00	32020		\N	228813	0	195662009	4112343		0
58308	3454	80180	2016-10-19	2016-10-19 00:00:00	\N	\N	32020		\N	229180	0	396275006	80180		0
58497	3464	40481087	1998-11-29	1998-11-29 00:00:00	1998-12-20	1998-12-20 00:00:00	32020		\N	229956	0	444814009	40481087		0
69302	4102	80809	1997-03-14	1997-03-14 00:00:00	2001-12-18	2001-12-18 00:00:00	32020		\N	272558	0	69896004	80809		0
58772	3486	4112343	1990-09-12	1990-09-12 00:00:00	1990-09-20	1990-09-20 00:00:00	32020		\N	231300	0	195662009	4112343		0
58931	3495	4152936	1995-10-10	1995-10-10 00:00:00	1995-10-31	1995-10-31 00:00:00	32020		\N	231815	0	283385000	4152936		0
69762	4127	81151	1951-08-28	1951-08-28 00:00:00	1951-10-02	1951-10-02 00:00:00	32020		\N	274311	0	44465007	81151		0
70024	4143	4285898	2000-05-07	2000-05-07 00:00:00	\N	\N	32020		\N	275355	0	68496003	4285898		0
59485	3527	40481087	2015-07-16	2015-07-16 00:00:00	2015-07-23	2015-07-23 00:00:00	32020		\N	234075	0	444814009	40481087		0
59756	3541	260139	1998-10-25	1998-10-25 00:00:00	1998-11-08	1998-11-08 00:00:00	32020		\N	235192	0	10509002	260139		0
70442	4173	40481087	1984-07-13	1984-07-13 00:00:00	1984-07-20	1984-07-20 00:00:00	32020		\N	277370	0	444814009	40481087		0
60092	3560	40481087	1986-08-22	1986-08-22 00:00:00	1986-09-12	1986-09-12 00:00:00	32020		\N	236355	0	444814009	40481087		0
60229	3565	260139	2019-03-10	2019-03-10 00:00:00	2019-03-24	2019-03-24 00:00:00	32020		\N	236788	0	10509002	260139		0
60376	3571	4048171	1975-08-30	1975-08-30 00:00:00	\N	\N	32020		\N	237382	0	232353008	4048171		0
60440	3573	260139	2010-06-13	2010-06-13 00:00:00	2010-06-20	2010-06-20 00:00:00	32020		\N	237546	0	10509002	260139		0
60716	3593	40481087	1972-12-25	1972-12-25 00:00:00	1973-01-15	1973-01-15 00:00:00	32020		\N	238646	0	444814009	40481087		0
60812	3599	40481087	2001-02-15	2001-02-15 00:00:00	2001-03-08	2001-03-08 00:00:00	32020		\N	239032	0	444814009	40481087		0
61081	3614	4059173	1951-05-17	1951-05-17 00:00:00	1951-08-15	1951-08-15 00:00:00	32020		\N	240097	0	16114001	4059173		0
61164	3618	4112343	1972-12-01	1972-12-01 00:00:00	1972-12-14	1972-12-14 00:00:00	32020		\N	240375	0	195662009	4112343		0
61334	3625	81151	1955-03-06	1955-03-06 00:00:00	1955-04-10	1955-04-10 00:00:00	32020		\N	241055	0	44465007	81151		0
61496	3634	4237458	2002-10-17	2002-10-17 00:00:00	2003-01-15	2003-01-15 00:00:00	32020		\N	241745	0	58150001	4237458		0
61595	3639	260139	1929-03-07	1929-03-07 00:00:00	1929-03-21	1929-03-21 00:00:00	32020		\N	242027	0	10509002	260139		0
72413	4297	198809	1991-02-19	1991-02-19 00:00:00	1991-02-19	1991-02-19 00:00:00	32020		\N	285178	0	65275009	198809		0
72562	4309	40481087	1996-03-11	1996-03-11 00:00:00	1996-03-18	1996-03-18 00:00:00	32020		\N	285892	0	444814009	40481087		0
62223	3675	4237458	1968-04-11	1968-04-11 00:00:00	1968-06-10	1968-06-10 00:00:00	32020		\N	244428	0	58150001	4237458		0
72984	4337	40481087	1991-01-14	1991-01-14 00:00:00	1991-02-04	1991-02-04 00:00:00	32020		\N	287563	0	444814009	40481087		0
62573	3697	78272	2015-02-28	2015-02-28 00:00:00	2015-03-21	2015-03-21 00:00:00	32020		\N	245776	0	70704007	78272		0
62653	3700	4146173	2008-06-12	2008-06-12 00:00:00	2008-07-12	2008-07-12 00:00:00	32020		\N	245980	0	307731004	4146173		0
73402	4364	40479768	1963-09-24	1963-09-24 00:00:00	1963-10-31	1963-10-31 00:00:00	32020		\N	289423	0	444470001	40479768		0
62967	3719	4043241	2012-01-03	2012-01-03 00:00:00	\N	\N	32020		\N	247188	0	230265002	4043241		0
73760	4382	260139	1955-08-17	1955-08-17 00:00:00	1955-08-31	1955-08-31 00:00:00	32020		\N	291207	0	10509002	260139		0
73909	4390	81151	2009-04-22	2009-04-22 00:00:00	2009-05-20	2009-05-20 00:00:00	32020		\N	291937	0	44465007	81151		0
74052	4398	260139	1984-02-07	1984-02-07 00:00:00	1984-02-21	1984-02-21 00:00:00	32020		\N	292389	0	10509002	260139		0
74282	4411	4112343	1951-10-22	1951-10-22 00:00:00	1951-11-02	1951-11-02 00:00:00	32020		\N	293176	0	195662009	4112343		0
53279	3157	4112343	2002-11-27	2002-11-27 00:00:00	2002-12-05	2002-12-05 00:00:00	32020		\N	209884	0	195662009	4112343		0
63966	3779	378001	1995-12-19	1995-12-19 00:00:00	1996-02-17	1996-02-17 00:00:00	32020		\N	251146	0	62106007	378001		0
64079	3786	4112343	1974-03-27	1974-03-27 00:00:00	1974-04-06	1974-04-06 00:00:00	32020		\N	251710	0	195662009	4112343		0
53718	3179	4285898	1958-01-10	1958-01-10 00:00:00	\N	\N	32020		\N	211490	0	68496003	4285898		0
53829	3184	4109685	1997-06-19	1997-06-19 00:00:00	1997-07-10	1997-07-10 00:00:00	32020		\N	211992	0	284551006	4109685		0
64597	3820	378001	1986-02-03	1986-02-03 00:00:00	1986-03-05	1986-03-05 00:00:00	32020		\N	253651	0	62106007	378001		0
54156	3208	4142905	1975-10-02	1975-10-02 00:00:00	1975-11-01	1975-11-01 00:00:00	32020		\N	213245	0	33737001	4142905		0
54391	3222	40481087	2013-12-04	2013-12-04 00:00:00	2013-12-11	2013-12-11 00:00:00	32020		\N	214218	0	444814009	40481087		0
54517	3229	40481087	1988-07-29	1988-07-29 00:00:00	1988-08-12	1988-08-12 00:00:00	32020		\N	214625	0	444814009	40481087		0
54720	3238	4237458	1972-11-27	1972-11-27 00:00:00	1972-12-27	1972-12-27 00:00:00	32020		\N	215316	0	58150001	4237458		0
54890	3248	40481087	1956-08-13	1956-08-13 00:00:00	1956-08-27	1956-08-27 00:00:00	32020		\N	215893	0	444814009	40481087		0
65613	3879	80502	2010-04-08	2010-04-08 00:00:00	\N	\N	32020		\N	257704	0	64859006	80502		0
65810	3891	4059173	1984-09-14	1984-09-14 00:00:00	1984-12-13	1984-12-13 00:00:00	32020		\N	258716	0	16114001	4059173		0
55394	3280	372328	1957-03-15	1957-03-15 00:00:00	1957-08-01	1957-08-01 00:00:00	32020		\N	218007	0	65363002	372328		0
55564	3290	4112343	2011-07-28	2011-07-28 00:00:00	2011-08-08	2011-08-08 00:00:00	32020		\N	218598	0	195662009	4112343		0
55751	3300	439777	2016-07-27	2016-07-27 00:00:00	\N	\N	32020		\N	219248	0	271737000	439777		0
55844	3307	40481087	1996-03-12	1996-03-12 00:00:00	1996-04-02	1996-04-02 00:00:00	32020		\N	219617	0	444814009	40481087		0
66630	3942	81151	1993-03-02	1993-03-02 00:00:00	1993-04-06	1993-04-06 00:00:00	32020		\N	262087	0	44465007	81151		0
56272	3335	80180	2011-01-01	2011-01-01 00:00:00	\N	\N	32020		\N	221235	0	396275006	80180		0
66899	3956	40481087	1976-05-20	1976-05-20 00:00:00	1976-05-27	1976-05-27 00:00:00	32020		\N	262962	0	444814009	40481087		0
56561	3355	260139	2002-02-08	2002-02-08 00:00:00	2002-02-15	2002-02-15 00:00:00	32020		\N	222464	0	10509002	260139		0
67351	3982	260139	1956-02-23	1956-02-23 00:00:00	1956-03-08	1956-03-08 00:00:00	32020		\N	264647	0	10509002	260139		0
56935	3378	378001	1998-11-26	1998-11-26 00:00:00	1999-01-25	1999-01-25 00:00:00	32020		\N	224130	0	62106007	378001		0
57033	3383	4113008	1995-09-27	1995-09-27 00:00:00	1995-10-18	1995-10-18 00:00:00	32020		\N	224492	0	284549007	4113008		0
57155	3392	372328	1969-04-19	1969-04-19 00:00:00	1969-05-10	1969-05-10 00:00:00	32020		\N	224992	0	65363002	372328		0
57423	3408	28060	1992-08-30	1992-08-30 00:00:00	1992-09-11	1992-09-11 00:00:00	32020		\N	226033	0	43878008	28060		0
57567	3415	260139	1999-06-20	1999-06-20 00:00:00	1999-06-27	1999-06-27 00:00:00	32020		\N	226498	0	10509002	260139		0
57761	3427	260139	1993-08-15	1993-08-15 00:00:00	1993-08-29	1993-08-29 00:00:00	32020		\N	227177	0	10509002	260139		0
57905	3435	4113008	2014-04-27	2014-04-27 00:00:00	2014-05-18	2014-05-18 00:00:00	32020		\N	227835	0	284549007	4113008		0
58041	3439	4142905	1969-02-20	1969-02-20 00:00:00	1969-04-21	1969-04-21 00:00:00	32020		\N	228169	0	33737001	4142905		0
58213	3446	372328	1954-10-29	1954-10-29 00:00:00	1955-09-19	1955-09-19 00:00:00	32020		\N	228815	0	65363002	372328		0
58309	3454	4266809	2016-10-19	2016-10-19 00:00:00	\N	\N	32020		\N	229180	0	397881000	4266809		0
58498	3464	372328	1981-04-09	1981-04-09 00:00:00	1981-07-22	1981-07-22 00:00:00	32020		\N	229986	0	65363002	372328		0
69303	4102	4112343	1972-08-16	1972-08-16 00:00:00	1972-08-26	1972-08-26 00:00:00	32020		\N	272596	0	195662009	4112343		0
58773	3486	40481087	2004-12-24	2004-12-24 00:00:00	2005-01-07	2005-01-07 00:00:00	32020		\N	231193	0	444814009	40481087		0
58932	3495	260139	2002-12-01	2002-12-01 00:00:00	2002-12-08	2002-12-08 00:00:00	32020		\N	231852	0	10509002	260139		0
69763	4127	81151	1957-06-02	1957-06-02 00:00:00	1957-07-07	1957-07-07 00:00:00	32020		\N	274340	0	44465007	81151		0
70025	4143	40481087	1961-12-04	1961-12-04 00:00:00	1961-12-18	1961-12-18 00:00:00	32020		\N	275378	0	444814009	40481087		0
59486	3527	4084167	1963-04-09	1963-04-09 00:00:00	1963-04-09	1963-04-09 00:00:00	32020		\N	234047	0	241929008	4084167		0
59757	3541	4296204	2000-06-26	2000-06-26 00:00:00	2000-07-31	2000-07-31 00:00:00	32020		\N	235217	0	403190006	4296204		0
70443	4173	4112343	2014-07-28	2014-07-28 00:00:00	2014-08-07	2014-08-07 00:00:00	32020		\N	277331	0	195662009	4112343		0
70613	4190	4294548	1995-10-18	1995-10-18 00:00:00	1995-11-01	1995-11-01 00:00:00	32020		\N	278070	0	75498004	4294548		0
60230	3565	260139	1977-06-12	1977-06-12 00:00:00	1977-06-19	1977-06-19 00:00:00	32020		\N	236786	0	10509002	260139		0
60377	3571	40481087	1975-11-01	1975-11-01 00:00:00	1975-11-15	1975-11-15 00:00:00	32020		\N	237409	0	444814009	40481087		0
60441	3573	40481087	1956-12-20	1956-12-20 00:00:00	1957-01-03	1957-01-03 00:00:00	32020		\N	237541	0	444814009	40481087		0
60821	3601	40481087	1998-07-24	1998-07-24 00:00:00	1998-07-31	1998-07-31 00:00:00	32020		\N	239246	0	444814009	40481087		0
61082	3614	4043241	2004-07-25	2004-07-25 00:00:00	\N	\N	32020		\N	240067	0	230265002	4043241		0
61165	3618	4112343	1987-01-30	1987-01-30 00:00:00	1987-02-09	1987-02-09 00:00:00	32020		\N	240454	0	195662009	4112343		0
61335	3625	313217	2012-09-04	2012-09-04 00:00:00	\N	\N	32020		\N	241072	0	49436004	313217		0
61497	3634	372328	1974-05-03	1974-05-03 00:00:00	1975-02-03	1975-02-03 00:00:00	32020		\N	241707	0	65363002	372328		0
61596	3639	317576	2007-07-07	2007-07-07 00:00:00	\N	\N	32020		\N	242080	0	53741008	317576		0
72414	4297	196456	1991-02-19	1991-02-19 00:00:00	1991-02-19	1991-02-19 00:00:00	32020		\N	285178	0	235919008	196456		0
72563	4309	4218389	1967-10-25	1967-10-25 00:00:00	1967-11-22	1967-11-22 00:00:00	32020		\N	285944	0	39848009	4218389		0
62224	3675	192671	2009-01-09	2009-01-09 00:00:00	\N	\N	32020		\N	244429	0	K92.2	35208414		0
72985	4337	260139	1984-09-13	1984-09-13 00:00:00	1984-09-20	1984-09-20 00:00:00	32020		\N	287585	0	10509002	260139		0
62574	3697	4112343	1971-05-23	1971-05-23 00:00:00	1971-05-30	1971-05-30 00:00:00	32020		\N	245781	0	195662009	4112343		0
62654	3700	4283893	1975-06-06	1975-06-06 00:00:00	1975-07-11	1975-07-11 00:00:00	32020		\N	246002	0	36971009	4283893		0
73403	4364	260139	2005-03-18	2005-03-18 00:00:00	2005-04-01	2005-04-01 00:00:00	32020		\N	289464	0	10509002	260139		0
62968	3719	28060	1972-05-21	1972-05-21 00:00:00	1972-05-29	1972-05-29 00:00:00	32020		\N	247208	0	43878008	28060		0
73761	4382	4051466	1955-01-05	1955-01-05 00:00:00	1972-04-05	1972-04-05 00:00:00	32020		\N	291260	0	233678006	4051466		0
73910	4390	40481087	2002-08-29	2002-08-29 00:00:00	2002-09-19	2002-09-19 00:00:00	32020		\N	291893	0	444814009	40481087		0
74053	4398	40481087	1960-05-20	1960-05-20 00:00:00	1960-06-10	1960-06-10 00:00:00	32020		\N	292386	0	444814009	40481087		0
74283	4411	40481087	2001-10-31	2001-10-31 00:00:00	2001-11-14	2001-11-14 00:00:00	32020		\N	293232	0	444814009	40481087		0
53280	3157	40481087	1960-07-12	1960-07-12 00:00:00	1960-07-26	1960-07-26 00:00:00	32020		\N	209882	0	444814009	40481087		0
63967	3779	40481087	2001-08-15	2001-08-15 00:00:00	2001-08-29	2001-08-29 00:00:00	32020		\N	251126	0	444814009	40481087		0
64080	3786	4112343	1961-10-27	1961-10-27 00:00:00	1961-11-06	1961-11-06 00:00:00	32020		\N	251667	0	195662009	4112343		0
53719	3179	80180	1958-12-06	1958-12-06 00:00:00	\N	\N	32020		\N	211490	0	396275006	80180		0
53831	3184	372328	1966-05-24	1966-05-24 00:00:00	1967-02-16	1967-02-16 00:00:00	32020		\N	212002	0	65363002	372328		0
64598	3820	260139	1979-09-05	1979-09-05 00:00:00	1979-09-19	1979-09-19 00:00:00	32020		\N	253614	0	10509002	260139		0
54157	3208	4112343	2003-09-08	2003-09-08 00:00:00	2003-09-20	2003-09-20 00:00:00	32020		\N	213267	0	195662009	4112343		0
54392	3222	260139	2017-05-19	2017-05-19 00:00:00	2017-05-26	2017-05-26 00:00:00	32020		\N	214164	0	10509002	260139		0
54518	3229	40481087	2001-10-30	2001-10-30 00:00:00	2001-11-13	2001-11-13 00:00:00	32020		\N	214594	0	444814009	40481087		0
54721	3238	28060	2009-01-13	2009-01-13 00:00:00	2009-01-24	2009-01-24 00:00:00	32020		\N	215262	0	43878008	28060		0
54891	3248	372328	1946-07-08	1946-07-08 00:00:00	1946-09-20	1946-09-20 00:00:00	32020		\N	215924	0	65363002	372328		0
65615	3879	4029498	2015-11-25	2015-11-25 00:00:00	\N	\N	32020		\N	257729	0	128613002	4029498		0
65811	3891	40481087	1984-06-13	1984-06-13 00:00:00	1984-06-20	1984-06-20 00:00:00	32020		\N	258721	0	444814009	40481087		0
55395	3280	260139	1974-02-15	1974-02-15 00:00:00	1974-03-01	1974-03-01 00:00:00	32020		\N	218042	0	10509002	260139		0
55565	3290	40481087	1998-12-10	1998-12-10 00:00:00	1998-12-24	1998-12-24 00:00:00	32020		\N	218612	0	444814009	40481087		0
55752	3300	4051466	1985-08-11	1985-08-11 00:00:00	2001-11-15	2001-11-15 00:00:00	32020		\N	219236	0	233678006	4051466		0
55845	3307	4059173	1982-03-17	1982-03-17 00:00:00	1982-04-16	1982-04-16 00:00:00	32020		\N	219578	0	16114001	4059173		0
66631	3942	80180	2019-05-30	2019-05-30 00:00:00	\N	\N	32020		\N	262099	0	396275006	80180		0
56273	3335	4112343	2002-12-17	2002-12-17 00:00:00	2002-12-28	2002-12-28 00:00:00	32020		\N	221243	0	195662009	4112343		0
66900	3956	40481087	1951-01-03	1951-01-03 00:00:00	1951-01-10	1951-01-10 00:00:00	32020		\N	262974	0	444814009	40481087		0
56562	3355	40481087	2007-07-22	2007-07-22 00:00:00	2007-08-12	2007-08-12 00:00:00	32020		\N	222513	0	444814009	40481087		0
67352	3982	40481087	1963-07-12	1963-07-12 00:00:00	1963-08-02	1963-08-02 00:00:00	32020		\N	264748	0	444814009	40481087		0
56936	3378	40481087	1989-04-06	1989-04-06 00:00:00	1989-04-20	1989-04-20 00:00:00	32020		\N	224117	0	444814009	40481087		0
57034	3383	372328	1989-05-31	1989-05-31 00:00:00	1989-09-21	1989-09-21 00:00:00	32020		\N	224479	0	65363002	372328		0
57156	3392	260139	1968-04-25	1968-04-25 00:00:00	1968-05-09	1968-05-09 00:00:00	32020		\N	224988	0	10509002	260139		0
57424	3408	78272	1998-05-04	1998-05-04 00:00:00	1998-05-18	1998-05-18 00:00:00	32020		\N	226021	0	70704007	78272		0
57568	3415	4112343	1980-03-07	1980-03-07 00:00:00	1980-03-16	1980-03-16 00:00:00	32020		\N	226514	0	195662009	4112343		0
57762	3427	40481087	1995-10-16	1995-10-16 00:00:00	1995-10-23	1995-10-23 00:00:00	32020		\N	227213	0	444814009	40481087		0
57906	3435	4278672	2009-04-23	2009-04-23 00:00:00	2009-07-22	2009-07-22 00:00:00	32020		\N	227834	0	65966004	4278672		0
58042	3439	313217	2015-12-10	2015-12-10 00:00:00	\N	\N	32020		\N	228145	0	49436004	313217		0
58214	3446	257012	1971-09-09	1971-09-09 00:00:00	\N	\N	32020		\N	228849	0	40055000	257012		0
58310	3454	4112343	2015-08-17	2015-08-17 00:00:00	2015-08-24	2015-08-24 00:00:00	32020		\N	229180	0	195662009	4112343		0
58499	3464	4112343	1983-08-30	1983-08-30 00:00:00	1983-09-11	1983-09-11 00:00:00	32020		\N	229903	0	195662009	4112343		0
69304	4102	4112343	1973-04-25	1973-04-25 00:00:00	1973-05-02	1973-05-02 00:00:00	32020		\N	272591	0	195662009	4112343		0
58774	3486	260139	1969-08-05	1969-08-05 00:00:00	1969-08-12	1969-08-12 00:00:00	32020		\N	231201	0	10509002	260139		0
58969	3501	40481087	1964-04-05	1964-04-05 00:00:00	1964-04-27	1964-04-27 00:00:00	32020		\N	232134	0	444814009	40481087		0
69764	4127	260139	2005-09-27	2005-09-27 00:00:00	2005-10-11	2005-10-11 00:00:00	32020		\N	274346	0	10509002	260139		0
70026	4143	4112343	1971-03-31	1971-03-31 00:00:00	1971-04-09	1971-04-09 00:00:00	32020		\N	275344	0	195662009	4112343		0
59487	3527	40481087	1989-08-16	1989-08-16 00:00:00	1989-09-06	1989-09-06 00:00:00	32020		\N	234091	0	444814009	40481087		0
59758	3541	4112343	2013-07-14	2013-07-14 00:00:00	2013-07-24	2013-07-24 00:00:00	32020		\N	235193	0	195662009	4112343		0
70444	4173	4112343	1965-10-06	1965-10-06 00:00:00	1965-10-13	1965-10-13 00:00:00	32020		\N	277340	0	195662009	4112343		0
70614	4190	4280726	1976-08-05	1976-08-05 00:00:00	\N	\N	32020		\N	278094	0	367498001	4280726		0
60231	3565	40481087	2008-03-16	2008-03-16 00:00:00	2008-04-06	2008-04-06 00:00:00	32020		\N	236732	0	444814009	40481087		0
60378	3571	4112343	1984-11-05	1984-11-05 00:00:00	1984-11-16	1984-11-16 00:00:00	32020		\N	237345	0	195662009	4112343		0
60442	3573	28060	1941-07-02	1941-07-02 00:00:00	1941-07-15	1941-07-15 00:00:00	32020		\N	237517	0	43878008	28060		0
60718	3593	78272	2018-09-02	2018-09-02 00:00:00	2018-09-30	2018-09-30 00:00:00	32020		\N	238690	0	70704007	78272		0
60822	3601	4112343	1992-10-11	1992-10-11 00:00:00	1992-10-19	1992-10-19 00:00:00	32020		\N	239145	0	195662009	4112343		0
61083	3614	260139	1959-11-25	1959-11-25 00:00:00	1959-12-02	1959-12-02 00:00:00	32020		\N	240141	0	10509002	260139		0
61166	3618	260139	1916-08-20	1916-08-20 00:00:00	1916-08-27	1916-08-27 00:00:00	32020		\N	240344	0	10509002	260139		0
61336	3625	4237458	1968-07-21	1968-07-21 00:00:00	1968-08-20	1968-08-20 00:00:00	32020		\N	241057	0	58150001	4237458		0
61498	3634	4156265	2000-11-12	2000-11-12 00:00:00	2000-11-26	2000-11-26 00:00:00	32020		\N	241744	0	370247008	4156265		0
61597	3639	260139	1994-03-15	1994-03-15 00:00:00	1994-03-22	1994-03-22 00:00:00	32020		\N	242160	0	10509002	260139		0
72415	4297	4283893	1990-06-14	1990-06-14 00:00:00	1990-07-12	1990-07-12 00:00:00	32020		\N	285194	0	36971009	4283893		0
62225	3675	260139	2018-02-28	2018-02-28 00:00:00	2018-03-07	2018-03-07 00:00:00	32020		\N	244415	0	10509002	260139		0
72986	4337	192671	2006-04-26	2006-04-26 00:00:00	\N	\N	32020		\N	287617	0	K92.2	35208414		0
62575	3697	4283893	1981-10-23	1981-10-23 00:00:00	1981-12-11	1981-12-11 00:00:00	32020		\N	245772	0	36971009	4283893		0
62655	3700	372328	1971-04-02	1971-04-02 00:00:00	1971-08-11	1971-08-11 00:00:00	32020		\N	245968	0	65363002	372328		0
73404	4364	40481087	1955-04-16	1955-04-16 00:00:00	1955-04-30	1955-04-30 00:00:00	32020		\N	289466	0	444814009	40481087		0
62969	3719	40481087	1976-08-11	1976-08-11 00:00:00	1976-08-18	1976-08-18 00:00:00	32020		\N	247160	0	444814009	40481087		0
73762	4382	4109685	2017-03-03	2017-03-03 00:00:00	2017-03-17	2017-03-17 00:00:00	32020		\N	291175	0	284551006	4109685		0
73911	4390	81151	2001-05-29	2001-05-29 00:00:00	2001-07-03	2001-07-03 00:00:00	32020		\N	291792	0	44465007	81151		0
74054	4398	40481087	1973-06-22	1973-06-22 00:00:00	1973-07-06	1973-07-06 00:00:00	32020		\N	292445	0	444814009	40481087		0
74284	4411	260139	1946-03-13	1946-03-13 00:00:00	1946-03-20	1946-03-20 00:00:00	32020		\N	293185	0	10509002	260139		0
53281	3157	4134304	1964-07-29	1964-07-29 00:00:00	1964-10-27	1964-10-27 00:00:00	32020		\N	209878	0	263102004	4134304		0
63968	3779	372328	1975-02-07	1975-02-07 00:00:00	1975-03-15	1975-03-15 00:00:00	32020		\N	251109	0	65363002	372328		0
64081	3786	40481087	2002-10-03	2002-10-03 00:00:00	2002-10-17	2002-10-17 00:00:00	32020		\N	251672	0	444814009	40481087		0
53720	3179	40481087	1957-12-19	1957-12-19 00:00:00	1958-01-09	1958-01-09 00:00:00	32020		\N	211490	0	444814009	40481087		0
53832	3184	4146173	2008-10-10	2008-10-10 00:00:00	2008-11-09	2008-11-09 00:00:00	32020		\N	212001	0	307731004	4146173		0
64599	3820	40481087	1979-06-29	1979-06-29 00:00:00	1979-07-13	1979-07-13 00:00:00	32020		\N	253613	0	444814009	40481087		0
54158	3208	40481087	2015-03-14	2015-03-14 00:00:00	2015-03-28	2015-03-28 00:00:00	32020		\N	213252	0	444814009	40481087		0
54393	3222	4112343	2015-09-06	2015-09-06 00:00:00	2015-09-14	2015-09-14 00:00:00	32020		\N	214141	0	195662009	4112343		0
54519	3229	372328	1984-03-13	1984-03-13 00:00:00	1984-05-18	1984-05-18 00:00:00	32020		\N	214596	0	65363002	372328		0
54722	3238	4112343	1981-09-14	1981-09-14 00:00:00	1981-09-22	1981-09-22 00:00:00	32020		\N	215298	0	195662009	4112343		0
54892	3248	4116491	1989-07-02	1989-07-02 00:00:00	1989-08-22	1989-08-22 00:00:00	32020		\N	215919	0	301011002	4116491		0
65616	3879	80180	1981-03-23	1981-03-23 00:00:00	\N	\N	32020		\N	257699	0	396275006	80180		0
65812	3891	40481087	1988-11-03	1988-11-03 00:00:00	1988-11-24	1988-11-24 00:00:00	32020		\N	258723	0	444814009	40481087		0
55396	3280	40481087	1978-07-16	1978-07-16 00:00:00	1978-07-23	1978-07-23 00:00:00	32020		\N	218006	0	444814009	40481087		0
55566	3290	40481087	2011-03-10	2011-03-10 00:00:00	2011-03-31	2011-03-31 00:00:00	32020		\N	218575	0	444814009	40481087		0
55754	3300	40481087	2004-06-08	2004-06-08 00:00:00	2004-06-22	2004-06-22 00:00:00	32020		\N	219195	0	444814009	40481087		0
55846	3307	81151	1981-01-30	1981-01-30 00:00:00	1981-02-20	1981-02-20 00:00:00	32020		\N	219577	0	44465007	81151		0
66632	3942	40481087	2019-03-21	2019-03-21 00:00:00	2019-03-28	2019-03-28 00:00:00	32020		\N	262099	0	444814009	40481087		0
56274	3335	4283893	1977-10-04	1977-10-04 00:00:00	1977-10-25	1977-10-25 00:00:00	32020		\N	221245	0	36971009	4283893		0
66901	3956	4112343	1934-08-20	1934-08-20 00:00:00	1934-09-01	1934-09-01 00:00:00	32020		\N	262972	0	195662009	4112343		0
56563	3355	80180	2007-10-09	2007-10-09 00:00:00	\N	\N	32020		\N	222513	0	396275006	80180		0
67353	3982	40481087	2008-10-16	2008-10-16 00:00:00	2008-11-06	2008-11-06 00:00:00	32020		\N	264732	0	444814009	40481087		0
56937	3378	4112343	1988-04-06	1988-04-06 00:00:00	1988-04-19	1988-04-19 00:00:00	32020		\N	224125	0	195662009	4112343		0
57035	3383	192671	2018-08-30	2018-08-30 00:00:00	\N	\N	32020		\N	224534	0	K92.2	35208414		0
57157	3392	4116491	1996-12-23	1996-12-23 00:00:00	1997-01-28	1997-01-28 00:00:00	32020		\N	224990	0	301011002	4116491		0
57425	3408	81151	1984-02-19	1984-02-19 00:00:00	1984-03-18	1984-03-18 00:00:00	32020		\N	226020	0	44465007	81151		0
57569	3415	40481087	2007-11-20	2007-11-20 00:00:00	2007-12-04	2007-12-04 00:00:00	32020		\N	226499	0	444814009	40481087		0
57763	3427	257012	2012-07-23	2012-07-23 00:00:00	\N	\N	32020		\N	227217	0	40055000	257012		0
57907	3435	81151	1977-05-15	1977-05-15 00:00:00	1977-06-12	1977-06-12 00:00:00	32020		\N	227832	0	44465007	81151		0
58043	3440	81151	1998-09-20	1998-09-20 00:00:00	1998-10-25	1998-10-25 00:00:00	32020		\N	228228	0	44465007	81151		0
58215	3446	4112343	1984-04-29	1984-04-29 00:00:00	1984-05-12	1984-05-12 00:00:00	32020		\N	228810	0	195662009	4112343		0
58311	3454	260139	1995-10-02	1995-10-02 00:00:00	1995-10-09	1995-10-09 00:00:00	32020		\N	229196	0	10509002	260139		0
58526	3469	4296205	1983-02-26	1983-02-26 00:00:00	1983-03-26	1983-03-26 00:00:00	32020		\N	230250	0	403191005	4296205		0
69305	4102	40481087	1996-06-21	1996-06-21 00:00:00	1996-07-12	1996-07-12 00:00:00	32020		\N	272620	0	444814009	40481087		0
58775	3486	260139	1995-12-30	1995-12-30 00:00:00	1996-01-13	1996-01-13 00:00:00	32020		\N	231292	0	10509002	260139		0
58970	3501	4134304	1994-03-19	1994-03-19 00:00:00	1994-06-18	1994-06-18 00:00:00	32020		\N	232060	0	263102004	4134304		0
69765	4127	378001	1975-01-04	1975-01-04 00:00:00	1975-02-03	1975-02-03 00:00:00	32020		\N	274341	0	62106007	378001		0
70027	4143	40481087	1969-08-17	1969-08-17 00:00:00	1969-08-31	1969-08-31 00:00:00	32020		\N	275343	0	444814009	40481087		0
59488	3528	375671	2008-03-11	2008-03-11 00:00:00	2008-05-10	2008-05-10 00:00:00	32020		\N	234283	0	62564004	375671		0
59759	3541	4112343	1988-01-04	1988-01-04 00:00:00	1988-01-13	1988-01-13 00:00:00	32020		\N	235176	0	195662009	4112343		0
70445	4173	28060	1977-11-23	1977-11-23 00:00:00	1977-12-03	1977-12-03 00:00:00	32020		\N	277341	0	43878008	28060		0
70615	4190	40481087	1996-06-05	1996-06-05 00:00:00	1996-06-12	1996-06-12 00:00:00	32020		\N	278112	0	444814009	40481087		0
60232	3565	260139	1955-11-21	1955-11-21 00:00:00	1955-11-28	1955-11-28 00:00:00	32020		\N	236775	0	10509002	260139		0
60379	3571	133834	1976-04-06	1976-04-06 00:00:00	1989-05-10	1989-05-10 00:00:00	32020		\N	237411	0	24079001	133834		0
60443	3573	4112343	1996-11-02	1996-11-02 00:00:00	1996-11-15	1996-11-15 00:00:00	32020		\N	237545	0	195662009	4112343		0
60719	3593	260139	1974-06-17	1974-06-17 00:00:00	1974-07-01	1974-07-01 00:00:00	32020		\N	238702	0	10509002	260139		0
60823	3601	4116491	1980-06-13	1980-06-13 00:00:00	1980-07-28	1980-07-28 00:00:00	32020		\N	239176	0	301011002	4116491		0
61084	3614	258780	2003-07-20	2003-07-20 00:00:00	\N	\N	32020		\N	240077	0	185086009	258780		0
61167	3618	375671	1956-06-06	1956-06-06 00:00:00	1956-08-05	1956-08-05 00:00:00	32020		\N	240398	0	62564004	375671		0
61337	3625	40481087	2010-10-20	2010-10-20 00:00:00	2010-11-03	2010-11-03 00:00:00	32020		\N	241041	0	444814009	40481087		0
61499	3634	40481087	1990-08-07	1990-08-07 00:00:00	1990-08-21	1990-08-21 00:00:00	32020		\N	241746	0	444814009	40481087		0
61598	3639	260139	2002-09-06	2002-09-06 00:00:00	2002-09-20	2002-09-20 00:00:00	32020		\N	242172	0	10509002	260139		0
72416	4297	40481087	2000-02-25	2000-02-25 00:00:00	2000-03-17	2000-03-17 00:00:00	32020		\N	285189	0	444814009	40481087		0
72565	4309	28060	1990-12-12	1990-12-12 00:00:00	1990-12-22	1990-12-22 00:00:00	32020		\N	285888	0	43878008	28060		0
62226	3675	4156265	1990-08-14	1990-08-14 00:00:00	1990-09-04	1990-09-04 00:00:00	32020		\N	244484	0	370247008	4156265		0
72987	4337	40481087	2010-10-25	2010-10-25 00:00:00	2010-11-01	2010-11-01 00:00:00	32020		\N	287593	0	444814009	40481087		0
62576	3697	4112343	1996-11-17	1996-11-17 00:00:00	1996-11-24	1996-11-24 00:00:00	32020		\N	245730	0	195662009	4112343		0
62656	3700	4134304	1970-06-11	1970-06-11 00:00:00	1970-08-10	1970-08-10 00:00:00	32020		\N	245971	0	263102004	4134304		0
73405	4364	81151	1967-05-13	1967-05-13 00:00:00	1967-06-17	1967-06-17 00:00:00	32020		\N	289424	0	44465007	81151		0
62970	3719	195588	2014-12-26	2014-12-26 00:00:00	2015-01-29	2015-01-29 00:00:00	32020		\N	247198	0	38822007	195588		0
73763	4382	40481087	1994-09-03	1994-09-03 00:00:00	1994-09-17	1994-09-17 00:00:00	32020		\N	291269	0	444814009	40481087		0
73912	4390	4283893	1969-09-01	1969-09-01 00:00:00	1969-10-27	1969-10-27 00:00:00	32020		\N	291803	0	36971009	4283893		0
74055	4398	260139	2005-05-23	2005-05-23 00:00:00	2005-06-06	2005-06-06 00:00:00	32020		\N	292465	0	10509002	260139		0
74285	4411	4283893	1966-05-11	1966-05-11 00:00:00	1966-08-03	1966-08-03 00:00:00	32020		\N	293199	0	36971009	4283893		0
53282	3157	372328	1952-12-31	1952-12-31 00:00:00	1953-03-13	1953-03-13 00:00:00	32020		\N	209848	0	65363002	372328		0
63998	3783	40481087	1999-02-28	1999-02-28 00:00:00	1999-03-14	1999-03-14 00:00:00	32020		\N	251366	0	444814009	40481087		0
64082	3786	40481087	2011-01-11	2011-01-11 00:00:00	2011-02-01	2011-02-01 00:00:00	32020		\N	251701	0	444814009	40481087		0
53721	3179	260139	1988-12-19	1988-12-19 00:00:00	1988-12-26	1988-12-26 00:00:00	32020		\N	211488	0	10509002	260139		0
53833	3184	40481087	2004-04-28	2004-04-28 00:00:00	2004-05-19	2004-05-19 00:00:00	32020		\N	212000	0	444814009	40481087		0
64600	3820	78272	1977-11-12	1977-11-12 00:00:00	1977-12-17	1977-12-17 00:00:00	32020		\N	253650	0	70704007	78272		0
54159	3208	40481087	1984-07-12	1984-07-12 00:00:00	1984-08-02	1984-08-02 00:00:00	32020		\N	213222	0	444814009	40481087		0
54394	3222	378001	1998-09-22	1998-09-22 00:00:00	1998-11-21	1998-11-21 00:00:00	32020		\N	214156	0	62106007	378001		0
54520	3229	4112343	2005-03-29	2005-03-29 00:00:00	2005-04-06	2005-04-06 00:00:00	32020		\N	214608	0	195662009	4112343		0
54723	3238	40481087	1974-05-26	1974-05-26 00:00:00	1974-06-09	1974-06-09 00:00:00	32020		\N	215260	0	444814009	40481087		0
54893	3249	375671	1983-07-28	1983-07-28 00:00:00	1983-08-27	1983-08-27 00:00:00	32020		\N	215987	0	62564004	375671		0
65617	3879	81151	1951-02-01	1951-02-01 00:00:00	1951-03-08	1951-03-08 00:00:00	32020		\N	257727	0	44465007	81151		0
65813	3891	4084167	1998-01-04	1998-01-04 00:00:00	1998-01-04	1998-01-04 00:00:00	32020		\N	258753	0	241929008	4084167		0
55397	3280	40481087	2006-03-16	2006-03-16 00:00:00	2006-03-30	2006-03-30 00:00:00	32020		\N	217978	0	444814009	40481087		0
55567	3290	260139	1990-01-10	1990-01-10 00:00:00	1990-01-24	1990-01-24 00:00:00	32020		\N	218596	0	10509002	260139		0
55755	3300	4116491	2018-07-27	2018-07-27 00:00:00	2018-09-26	2018-09-26 00:00:00	32020		\N	219240	0	301011002	4116491		0
55847	3307	40481087	1998-07-29	1998-07-29 00:00:00	1998-08-19	1998-08-19 00:00:00	32020		\N	219618	0	444814009	40481087		0
66633	3943	28060	1954-12-02	1954-12-02 00:00:00	1954-12-15	1954-12-15 00:00:00	32020		\N	262133	0	43878008	28060		0
66733	3949	440086	1977-03-15	1977-03-15 00:00:00	1979-04-03	1979-04-03 00:00:00	32020		\N	262476	0	192127007	440086		0
66902	3956	28060	1928-07-31	1928-07-31 00:00:00	1928-08-07	1928-08-07 00:00:00	32020		\N	262939	0	43878008	28060		0
56564	3355	40481087	1990-01-27	1990-01-27 00:00:00	1990-02-17	1990-02-17 00:00:00	32020		\N	222463	0	444814009	40481087		0
67354	3982	381316	2018-04-27	2018-04-27 00:00:00	\N	\N	32020		\N	264663	0	230690007	381316		0
56938	3378	40481087	2010-04-23	2010-04-23 00:00:00	2010-05-07	2010-05-07 00:00:00	32020		\N	224151	0	444814009	40481087		0
57036	3383	4112343	2005-11-19	2005-11-19 00:00:00	2005-11-27	2005-11-27 00:00:00	32020		\N	224483	0	195662009	4112343		0
57158	3392	4112343	1987-03-14	1987-03-14 00:00:00	1987-03-24	1987-03-24 00:00:00	32020		\N	224976	0	195662009	4112343		0
57426	3408	4283893	1997-04-01	1997-04-01 00:00:00	1997-07-08	1997-07-08 00:00:00	32020		\N	226038	0	36971009	4283893		0
57570	3415	260139	1985-10-22	1985-10-22 00:00:00	1985-10-29	1985-10-29 00:00:00	32020		\N	226547	0	10509002	260139		0
57764	3427	40481087	1986-01-27	1986-01-27 00:00:00	1986-02-17	1986-02-17 00:00:00	32020		\N	227211	0	444814009	40481087		0
57908	3435	372328	1979-12-24	1979-12-24 00:00:00	1980-04-05	1980-04-05 00:00:00	32020		\N	227801	0	65363002	372328		0
58044	3440	40481087	1960-10-13	1960-10-13 00:00:00	1960-10-27	1960-10-27 00:00:00	32020		\N	228258	0	444814009	40481087		0
58216	3446	4218389	1977-01-23	1977-01-23 00:00:00	1977-02-27	1977-02-27 00:00:00	32020		\N	228781	0	39848009	4218389		0
58312	3454	372328	1984-07-11	1984-07-11 00:00:00	1984-08-13	1984-08-13 00:00:00	32020		\N	229191	0	65363002	372328		0
58527	3469	40481087	1959-09-01	1959-09-01 00:00:00	1959-09-15	1959-09-15 00:00:00	32020		\N	230210	0	444814009	40481087		0
69306	4102	260139	1974-08-11	1974-08-11 00:00:00	1974-08-25	1974-08-25 00:00:00	32020		\N	272582	0	10509002	260139		0
58776	3486	378001	1986-09-02	1986-09-02 00:00:00	1986-10-02	1986-10-02 00:00:00	32020		\N	231296	0	62106007	378001		0
58971	3501	378001	1998-05-12	1998-05-12 00:00:00	1998-07-11	1998-07-11 00:00:00	32020		\N	232062	0	62106007	378001		0
69766	4127	4283893	1954-12-14	1954-12-14 00:00:00	1955-03-08	1955-03-08 00:00:00	32020		\N	274370	0	36971009	4283893		0
70028	4143	260139	1991-04-26	1991-04-26 00:00:00	1991-05-10	1991-05-10 00:00:00	32020		\N	275380	0	10509002	260139		0
59489	3528	40481087	1965-02-05	1965-02-05 00:00:00	1965-02-26	1965-02-26 00:00:00	32020		\N	234229	0	444814009	40481087		0
59760	3541	81151	1987-04-08	1987-04-08 00:00:00	1987-04-22	1987-04-22 00:00:00	32020		\N	235215	0	44465007	81151		0
70446	4173	4278672	1964-06-09	1964-06-09 00:00:00	1964-08-08	1964-08-08 00:00:00	32020		\N	277372	0	65966004	4278672		0
70616	4190	40481087	1997-01-14	1997-01-14 00:00:00	1997-01-21	1997-01-21 00:00:00	32020		\N	278096	0	444814009	40481087		0
60233	3565	260139	1951-08-27	1951-08-27 00:00:00	1951-09-03	1951-09-03 00:00:00	32020		\N	236712	0	10509002	260139		0
60380	3572	28060	1970-12-04	1970-12-04 00:00:00	1970-12-13	1970-12-13 00:00:00	32020		\N	237450	0	43878008	28060		0
60444	3573	4134304	1934-10-27	1934-10-27 00:00:00	1935-01-25	1935-01-25 00:00:00	32020		\N	237622	0	263102004	4134304		0
60720	3593	4142905	1953-03-14	1953-03-14 00:00:00	1953-04-13	1953-04-13 00:00:00	32020		\N	238686	0	33737001	4142905		0
60824	3601	40481087	1978-02-13	1978-02-13 00:00:00	1978-02-20	1978-02-20 00:00:00	32020		\N	239231	0	444814009	40481087		0
61085	3615	40481087	1990-07-08	1990-07-08 00:00:00	1990-07-29	1990-07-29 00:00:00	32020		\N	240244	0	444814009	40481087		0
61168	3618	372328	1913-07-05	1913-07-05 00:00:00	1913-12-27	1913-12-27 00:00:00	32020		\N	240359	0	65363002	372328		0
61338	3625	4283893	1991-02-05	1991-02-05 00:00:00	1991-04-02	1991-04-02 00:00:00	32020		\N	241038	0	36971009	4283893		0
61500	3634	28060	1995-07-13	1995-07-13 00:00:00	1995-07-25	1995-07-25 00:00:00	32020		\N	241733	0	43878008	28060		0
61599	3639	257012	1936-12-23	1936-12-23 00:00:00	\N	\N	32020		\N	242059	0	40055000	257012		0
72417	4297	81151	1999-11-12	1999-11-12 00:00:00	1999-12-03	1999-12-03 00:00:00	32020		\N	285149	0	44465007	81151		0
72566	4309	260139	2018-12-28	2018-12-28 00:00:00	2019-01-04	2019-01-04 00:00:00	32020		\N	285890	0	10509002	260139		0
62227	3675	4112343	2000-03-27	2000-03-27 00:00:00	2000-04-08	2000-04-08 00:00:00	32020		\N	244447	0	195662009	4112343		0
72988	4337	378001	1967-12-01	1967-12-01 00:00:00	1968-01-30	1968-01-30 00:00:00	32020		\N	287616	0	62106007	378001		0
62577	3697	40481087	1964-03-23	1964-03-23 00:00:00	1964-04-06	1964-04-06 00:00:00	32020		\N	245769	0	444814009	40481087		0
62657	3700	4296205	2010-04-03	2010-04-03 00:00:00	2010-04-24	2010-04-24 00:00:00	32020		\N	246010	0	403191005	4296205		0
73406	4364	40481087	2011-05-23	2011-05-23 00:00:00	2011-06-06	2011-06-06 00:00:00	32020		\N	289453	0	444814009	40481087		0
62971	3719	4278672	1985-10-09	1985-10-09 00:00:00	1985-12-08	1985-12-08 00:00:00	32020		\N	247166	0	65966004	4278672		0
73764	4382	78272	1975-12-20	1975-12-20 00:00:00	1976-01-10	1976-01-10 00:00:00	32020		\N	291168	0	70704007	78272		0
73913	4390	4112343	2002-12-30	2002-12-30 00:00:00	2003-01-10	2003-01-10 00:00:00	32020		\N	291890	0	195662009	4112343		0
74056	4398	28060	1965-01-31	1965-01-31 00:00:00	1965-02-13	1965-02-13 00:00:00	32020		\N	292436	0	43878008	28060		0
74286	4411	260139	2002-07-08	2002-07-08 00:00:00	2002-07-15	2002-07-15 00:00:00	32020		\N	293183	0	10509002	260139		0
53283	3157	4112343	1972-01-13	1972-01-13 00:00:00	1972-01-25	1972-01-25 00:00:00	32020		\N	209865	0	195662009	4112343		0
63999	3783	260139	2003-10-06	2003-10-06 00:00:00	2003-10-13	2003-10-13 00:00:00	32020		\N	251303	0	10509002	260139		0
64083	3786	40481087	1967-10-16	1967-10-16 00:00:00	1967-10-23	1967-10-23 00:00:00	32020		\N	251697	0	444814009	40481087		0
53722	3179	260139	1987-06-13	1987-06-13 00:00:00	1987-06-27	1987-06-27 00:00:00	32020		\N	211514	0	10509002	260139		0
53834	3184	372328	1963-03-22	1963-03-22 00:00:00	1963-08-08	1963-08-08 00:00:00	32020		\N	211960	0	65363002	372328		0
64601	3820	40481087	1995-02-27	1995-02-27 00:00:00	1995-03-06	1995-03-06 00:00:00	32020		\N	253618	0	444814009	40481087		0
54160	3208	317576	2008-01-18	2008-01-18 00:00:00	\N	\N	32020		\N	213281	0	53741008	317576		0
54395	3222	40481087	1994-06-03	1994-06-03 00:00:00	1994-06-24	1994-06-24 00:00:00	32020		\N	214161	0	444814009	40481087		0
54521	3229	4155034	2014-11-22	2014-11-22 00:00:00	2014-12-13	2014-12-13 00:00:00	32020		\N	214641	0	283371005	4155034		0
54725	3240	372328	1948-06-28	1948-06-28 00:00:00	1948-12-29	1948-12-29 00:00:00	32020		\N	215390	0	65363002	372328		0
54894	3249	40481087	1967-11-09	1967-11-09 00:00:00	1967-11-30	1967-11-30 00:00:00	32020		\N	215994	0	444814009	40481087		0
65618	3879	257012	1942-02-04	1942-02-04 00:00:00	\N	\N	32020		\N	257657	0	40055000	257012		0
65814	3891	40481087	1998-08-09	1998-08-09 00:00:00	1998-08-30	1998-08-30 00:00:00	32020		\N	258674	0	444814009	40481087		0
55398	3280	28060	2000-07-26	2000-07-26 00:00:00	2000-08-05	2000-08-05 00:00:00	32020		\N	217977	0	43878008	28060		0
55568	3290	40481087	1981-02-03	1981-02-03 00:00:00	1981-02-10	1981-02-10 00:00:00	32020		\N	218594	0	444814009	40481087		0
55756	3300	40481087	1999-11-11	1999-11-11 00:00:00	1999-11-25	1999-11-25 00:00:00	32020		\N	219187	0	444814009	40481087		0
55848	3307	4112343	1991-11-06	1991-11-06 00:00:00	1991-11-17	1991-11-17 00:00:00	32020		\N	219558	0	195662009	4112343		0
66634	3943	40481087	1992-04-27	1992-04-27 00:00:00	1992-05-18	1992-05-18 00:00:00	32020		\N	262141	0	444814009	40481087		0
66734	3949	260139	1976-01-11	1976-01-11 00:00:00	1976-01-18	1976-01-18 00:00:00	32020		\N	262439	0	10509002	260139		0
66903	3956	40481087	1957-01-31	1957-01-31 00:00:00	1957-02-21	1957-02-21 00:00:00	32020		\N	262995	0	444814009	40481087		0
56565	3355	4112343	1978-06-24	1978-06-24 00:00:00	1978-07-02	1978-07-02 00:00:00	32020		\N	222483	0	195662009	4112343		0
67355	3982	4283893	1965-11-26	1965-11-26 00:00:00	1966-02-11	1966-02-11 00:00:00	32020		\N	264750	0	36971009	4283893		0
67397	3984	28060	1968-01-21	1968-01-21 00:00:00	1968-02-01	1968-02-01 00:00:00	32020		\N	264822	0	43878008	28060		0
57037	3383	4112343	2016-03-05	2016-03-05 00:00:00	2016-03-13	2016-03-13 00:00:00	32020		\N	224524	0	195662009	4112343		0
57159	3392	40481087	1976-02-16	1976-02-16 00:00:00	1976-02-23	1976-02-23 00:00:00	32020		\N	224989	0	444814009	40481087		0
57427	3408	40481087	1977-01-03	1977-01-03 00:00:00	1977-01-17	1977-01-17 00:00:00	32020		\N	226049	0	444814009	40481087		0
57571	3415	40481087	1977-11-06	1977-11-06 00:00:00	1977-11-27	1977-11-27 00:00:00	32020		\N	226512	0	444814009	40481087		0
57765	3427	40479422	1970-02-14	1970-02-14 00:00:00	1970-04-22	1970-04-22 00:00:00	32020		\N	227245	0	444448004	40479422		0
57909	3435	40481087	1979-06-10	1979-06-10 00:00:00	1979-06-24	1979-06-24 00:00:00	32020		\N	227809	0	444814009	40481087		0
58045	3440	4112343	1950-03-02	1950-03-02 00:00:00	1950-03-10	1950-03-10 00:00:00	32020		\N	228319	0	195662009	4112343		0
58217	3446	4218389	1975-02-28	1975-02-28 00:00:00	1975-04-04	1975-04-04 00:00:00	32020		\N	228780	0	39848009	4218389		0
58313	3455	372328	1971-03-17	1971-03-17 00:00:00	1971-05-03	1971-05-03 00:00:00	32020		\N	229206	0	65363002	372328		0
58528	3469	4112343	1986-03-06	1986-03-06 00:00:00	1986-03-15	1986-03-15 00:00:00	32020		\N	230221	0	195662009	4112343		0
69307	4102	80180	2006-06-25	2006-06-25 00:00:00	\N	\N	32020		\N	272550	0	396275006	80180		0
58777	3486	4112343	1986-08-26	1986-08-26 00:00:00	1986-09-02	1986-09-02 00:00:00	32020		\N	231284	0	195662009	4112343		0
58972	3501	40481087	2005-03-20	2005-03-20 00:00:00	2005-04-04	2005-04-04 00:00:00	32020		\N	232091	0	444814009	40481087		0
69767	4127	260139	1973-06-24	1973-06-24 00:00:00	1973-07-01	1973-07-01 00:00:00	32020		\N	274371	0	10509002	260139		0
70029	4143	28060	1997-04-05	1997-04-05 00:00:00	1997-04-13	1997-04-13 00:00:00	32020		\N	275370	0	43878008	28060		0
59490	3528	40481087	2005-05-29	2005-05-29 00:00:00	2005-06-05	2005-06-05 00:00:00	32020		\N	234193	0	444814009	40481087		0
70220	4159	28060	1977-01-09	1977-01-09 00:00:00	1977-01-21	1977-01-21 00:00:00	32020		\N	276367	0	43878008	28060		0
70447	4173	372328	1967-03-11	1967-03-11 00:00:00	1967-04-12	1967-04-12 00:00:00	32020		\N	277333	0	65363002	372328		0
70617	4190	4294548	2018-08-09	2018-08-09 00:00:00	2018-12-20	2018-12-20 00:00:00	32020		\N	278098	0	75498004	4294548		0
60234	3565	4027663	1971-02-26	1971-02-26 00:00:00	\N	\N	32020		\N	236746	0	13200003	4027663		0
60381	3572	40481087	1958-01-15	1958-01-15 00:00:00	1958-01-22	1958-01-22 00:00:00	32020		\N	237461	0	444814009	40481087		0
60445	3573	4112343	1938-06-24	1938-06-24 00:00:00	1938-07-02	1938-07-02 00:00:00	32020		\N	237574	0	195662009	4112343		0
60730	3595	4112343	1996-08-09	1996-08-09 00:00:00	1996-08-18	1996-08-18 00:00:00	32020		\N	238837	0	195662009	4112343		0
60825	3601	40481087	1979-11-17	1979-11-17 00:00:00	1979-11-24	1979-11-24 00:00:00	32020		\N	239175	0	444814009	40481087		0
61086	3615	260139	1977-06-15	1977-06-15 00:00:00	1977-06-29	1977-06-29 00:00:00	32020		\N	240214	0	10509002	260139		0
61169	3618	378419	1989-02-25	1989-02-25 00:00:00	\N	\N	32020		\N	240349	0	26929004	378419		0
61339	3625	260139	1991-09-10	1991-09-10 00:00:00	1991-09-24	1991-09-24 00:00:00	32020		\N	241063	0	10509002	260139		0
61501	3634	40481087	2018-03-04	2018-03-04 00:00:00	2018-03-25	2018-03-25 00:00:00	32020		\N	241729	0	444814009	40481087		0
61600	3639	4112343	1960-07-11	1960-07-11 00:00:00	1960-07-20	1960-07-20 00:00:00	32020		\N	242062	0	195662009	4112343		0
72422	4299	40481087	2004-11-25	2004-11-25 00:00:00	2004-12-09	2004-12-09 00:00:00	32020		\N	285255	0	444814009	40481087		0
72567	4309	372328	1963-09-27	1963-09-27 00:00:00	1964-02-05	1964-02-05 00:00:00	32020		\N	285897	0	65363002	372328		0
62228	3675	40481087	2012-02-26	2012-02-26 00:00:00	2012-03-18	2012-03-18 00:00:00	32020		\N	244413	0	444814009	40481087		0
72989	4337	40481087	1976-11-29	1976-11-29 00:00:00	1976-12-06	1976-12-06 00:00:00	32020		\N	287561	0	444814009	40481087		0
62578	3697	40481087	2005-07-14	2005-07-14 00:00:00	2005-08-04	2005-08-04 00:00:00	32020		\N	245752	0	444814009	40481087		0
62658	3700	372328	1970-03-13	1970-03-13 00:00:00	1970-08-05	1970-08-05 00:00:00	32020		\N	245967	0	65363002	372328		0
73407	4364	372328	1956-01-21	1956-01-21 00:00:00	1956-12-16	1956-12-16 00:00:00	32020		\N	289459	0	65363002	372328		0
62972	3719	40481087	1972-01-14	1972-01-14 00:00:00	1972-01-28	1972-01-28 00:00:00	32020		\N	247158	0	444814009	40481087		0
73765	4382	40481087	1991-11-07	1991-11-07 00:00:00	1991-11-21	1991-11-21 00:00:00	32020		\N	291268	0	444814009	40481087		0
73914	4390	81151	1966-05-30	1966-05-30 00:00:00	1966-06-20	1966-06-20 00:00:00	32020		\N	291789	0	44465007	81151		0
74057	4398	372328	1963-05-10	1963-05-10 00:00:00	1964-02-22	1964-02-22 00:00:00	32020		\N	292391	0	65363002	372328		0
74287	4411	81151	2003-03-13	2003-03-13 00:00:00	2003-03-27	2003-03-27 00:00:00	32020		\N	293250	0	44465007	81151		0
53284	3157	4112343	2000-10-26	2000-10-26 00:00:00	2000-11-03	2000-11-03 00:00:00	32020		\N	209847	0	195662009	4112343		0
64000	3783	4112343	1946-06-05	1946-06-05 00:00:00	1946-06-18	1946-06-18 00:00:00	32020		\N	251386	0	195662009	4112343		0
64084	3786	78272	1998-06-10	1998-06-10 00:00:00	1998-07-15	1998-07-15 00:00:00	32020		\N	251664	0	70704007	78272		0
53723	3179	40481087	1971-12-04	1971-12-04 00:00:00	1971-12-11	1971-12-11 00:00:00	32020		\N	211462	0	444814009	40481087		0
53835	3184	260139	1989-07-27	1989-07-27 00:00:00	1989-08-10	1989-08-10 00:00:00	32020		\N	211998	0	10509002	260139		0
64602	3820	78272	2013-09-12	2013-09-12 00:00:00	2013-10-10	2013-10-10 00:00:00	32020		\N	253655	0	70704007	78272		0
54161	3208	40481087	2001-03-05	2001-03-05 00:00:00	2001-03-19	2001-03-19 00:00:00	32020		\N	213251	0	444814009	40481087		0
54396	3222	80180	1993-03-12	1993-03-12 00:00:00	\N	\N	32020		\N	214208	0	396275006	80180		0
54522	3229	257012	2001-01-17	2001-01-17 00:00:00	\N	\N	32020		\N	214593	0	40055000	257012		0
54726	3240	28060	1970-12-16	1970-12-16 00:00:00	1970-12-25	1970-12-25 00:00:00	32020		\N	215352	0	43878008	28060		0
54895	3249	4112343	1958-03-12	1958-03-12 00:00:00	1958-03-22	1958-03-22 00:00:00	32020		\N	215945	0	195662009	4112343		0
65630	3881	40481087	2019-05-25	2019-05-25 00:00:00	2019-06-15	2019-06-15 00:00:00	32020		\N	257934	0	444814009	40481087		0
65815	3891	40481087	1984-04-23	1984-04-23 00:00:00	1984-05-07	1984-05-07 00:00:00	32020		\N	258720	0	444814009	40481087		0
55399	3280	40481087	1965-12-19	1965-12-19 00:00:00	1966-01-02	1966-01-02 00:00:00	32020		\N	218012	0	444814009	40481087		0
55569	3290	40481087	1972-01-10	1972-01-10 00:00:00	1972-01-17	1972-01-17 00:00:00	32020		\N	218549	0	444814009	40481087		0
55757	3300	81151	2009-10-12	2009-10-12 00:00:00	2009-10-26	2009-10-26 00:00:00	32020		\N	219259	0	44465007	81151		0
55849	3307	28060	1995-05-03	1995-05-03 00:00:00	1995-05-15	1995-05-15 00:00:00	32020		\N	219616	0	43878008	28060		0
66635	3943	40481087	1984-02-17	1984-02-17 00:00:00	1984-03-02	1984-03-02 00:00:00	32020		\N	262177	0	444814009	40481087		0
66735	3949	40481087	1992-07-15	1992-07-15 00:00:00	1992-07-22	1992-07-22 00:00:00	32020		\N	262483	0	444814009	40481087		0
66904	3957	4155034	1988-04-01	1988-04-01 00:00:00	1988-04-22	1988-04-22 00:00:00	32020		\N	263063	0	283371005	4155034		0
56566	3355	4218389	1995-06-14	1995-06-14 00:00:00	1995-07-05	1995-07-05 00:00:00	32020		\N	222508	0	39848009	4218389		0
67356	3982	195588	1968-11-03	1968-11-03 00:00:00	1968-12-06	1968-12-06 00:00:00	32020		\N	264751	0	38822007	195588		0
67398	3984	40481087	1963-06-12	1963-06-12 00:00:00	1963-07-03	1963-07-03 00:00:00	32020		\N	264842	0	444814009	40481087		0
57038	3383	80180	2018-06-03	2018-06-03 00:00:00	\N	\N	32020		\N	224502	0	396275006	80180		0
57160	3392	4112343	2010-06-19	2010-06-19 00:00:00	2010-06-27	2010-06-27 00:00:00	32020		\N	224991	0	195662009	4112343		0
57428	3408	4112343	1992-05-20	1992-05-20 00:00:00	1992-05-29	1992-05-29 00:00:00	32020		\N	226037	0	195662009	4112343		0
57572	3415	4146173	1983-09-02	1983-09-02 00:00:00	1983-10-09	1983-10-09 00:00:00	32020		\N	226518	0	307731004	4146173		0
57766	3427	4299128	2018-08-06	2018-08-06 00:00:00	2018-08-20	2018-08-20 00:00:00	32020		\N	227230	0	403192003	4299128		0
57910	3435	4112343	2002-12-17	2002-12-17 00:00:00	2002-12-24	2002-12-24 00:00:00	32020		\N	227771	0	195662009	4112343		0
58046	3440	260139	1954-02-18	1954-02-18 00:00:00	1954-03-04	1954-03-04 00:00:00	32020		\N	228320	0	10509002	260139		0
58218	3446	260139	1970-10-21	1970-10-21 00:00:00	1970-11-04	1970-11-04 00:00:00	32020		\N	228786	0	10509002	260139		0
58314	3455	40481087	1989-11-13	1989-11-13 00:00:00	1989-12-04	1989-12-04 00:00:00	32020		\N	229234	0	444814009	40481087		0
58529	3469	40481087	1961-06-14	1961-06-14 00:00:00	1961-06-28	1961-06-28 00:00:00	32020		\N	230256	0	444814009	40481087		0
69308	4102	40481087	1974-12-09	1974-12-09 00:00:00	1974-12-23	1974-12-23 00:00:00	32020		\N	272617	0	444814009	40481087		0
58778	3486	260139	1994-04-01	1994-04-01 00:00:00	1994-04-08	1994-04-08 00:00:00	32020		\N	231191	0	10509002	260139		0
58973	3501	40481087	1991-09-20	1991-09-20 00:00:00	1991-10-04	1991-10-04 00:00:00	32020		\N	232068	0	444814009	40481087		0
69780	4129	40481087	1983-06-23	1983-06-23 00:00:00	1983-07-14	1983-07-14 00:00:00	32020		\N	274447	0	444814009	40481087		0
70030	4143	4112343	1965-06-13	1965-06-13 00:00:00	1965-06-26	1965-06-26 00:00:00	32020		\N	275405	0	195662009	4112343		0
59491	3528	4112343	1982-10-14	1982-10-14 00:00:00	1982-10-22	1982-10-22 00:00:00	32020		\N	234166	0	195662009	4112343		0
70221	4159	40481087	2008-07-09	2008-07-09 00:00:00	2008-07-23	2008-07-23 00:00:00	32020		\N	276310	0	444814009	40481087		0
70448	4173	40481087	1976-06-02	1976-06-02 00:00:00	1976-06-16	1976-06-16 00:00:00	32020		\N	277361	0	444814009	40481087		0
70618	4190	4112343	1989-05-04	1989-05-04 00:00:00	1989-05-14	1989-05-14 00:00:00	32020		\N	278081	0	195662009	4112343		0
60235	3565	40481087	1958-07-17	1958-07-17 00:00:00	1958-07-24	1958-07-24 00:00:00	32020		\N	236726	0	444814009	40481087		0
60382	3572	4266809	1993-08-29	1993-08-29 00:00:00	\N	\N	32020		\N	237509	0	397881000	4266809		0
60446	3573	192671	1963-12-21	1963-12-21 00:00:00	\N	\N	32020		\N	237632	0	K92.2	35208414		0
60731	3595	40481087	1962-03-15	1962-03-15 00:00:00	1962-03-22	1962-03-22 00:00:00	32020		\N	238775	0	444814009	40481087		0
60826	3601	133834	1961-04-16	1961-04-16 00:00:00	1976-09-24	1976-09-24 00:00:00	32020		\N	239227	0	24079001	133834		0
61087	3615	4237458	1962-05-30	1962-05-30 00:00:00	1962-06-29	1962-06-29 00:00:00	32020		\N	240217	0	58150001	4237458		0
61170	3618	81151	1923-05-14	1923-05-14 00:00:00	1923-06-11	1923-06-11 00:00:00	32020		\N	240395	0	44465007	81151		0
61340	3625	140673	2010-06-30	2010-06-30 00:00:00	\N	\N	32020		\N	241040	0	40930008	140673		0
61502	3634	4278672	1982-04-21	1982-04-21 00:00:00	1982-07-20	1982-07-20 00:00:00	32020		\N	241743	0	65966004	4278672		0
61601	3639	4294548	1987-02-21	1987-02-21 00:00:00	1987-05-09	1987-05-09 00:00:00	32020		\N	242033	0	75498004	4294548		0
72423	4299	4027663	2005-02-03	2005-02-03 00:00:00	\N	\N	32020		\N	285255	0	13200003	4027663		0
72568	4309	372328	1970-11-30	1970-11-30 00:00:00	1971-03-17	1971-03-17 00:00:00	32020		\N	285935	0	65363002	372328		0
62229	3675	260139	1998-11-16	1998-11-16 00:00:00	1998-11-23	1998-11-23 00:00:00	32020		\N	244478	0	10509002	260139		0
72990	4337	40481087	1962-01-10	1962-01-10 00:00:00	1962-01-17	1962-01-17 00:00:00	32020		\N	287636	0	444814009	40481087		0
62579	3697	40481087	2011-04-10	2011-04-10 00:00:00	2011-04-24	2011-04-24 00:00:00	32020		\N	245733	0	444814009	40481087		0
62659	3700	378001	1991-09-10	1991-09-10 00:00:00	1991-10-10	1991-10-10 00:00:00	32020		\N	246009	0	62106007	378001		0
73408	4364	40481087	1962-10-28	1962-10-28 00:00:00	1962-11-18	1962-11-18 00:00:00	32020		\N	289455	0	444814009	40481087		0
62973	3719	80180	2003-08-16	2003-08-16 00:00:00	\N	\N	32020		\N	247196	0	396275006	80180		0
73766	4382	4155034	2000-06-16	2000-06-16 00:00:00	2000-06-30	2000-06-30 00:00:00	32020		\N	291171	0	283371005	4155034		0
73915	4390	40481087	2004-05-17	2004-05-17 00:00:00	2004-05-24	2004-05-24 00:00:00	32020		\N	291894	0	444814009	40481087		0
74058	4398	4112343	2017-08-11	2017-08-11 00:00:00	2017-08-18	2017-08-18 00:00:00	32020		\N	292467	0	195662009	4112343		0
74288	4411	40481087	1980-09-22	1980-09-22 00:00:00	1980-10-13	1980-10-13 00:00:00	32020		\N	293189	0	444814009	40481087		0
53285	3157	4142905	1960-03-22	1960-03-22 00:00:00	1960-06-20	1960-06-20 00:00:00	32020		\N	209877	0	33737001	4142905		0
64001	3783	80180	1984-04-09	1984-04-09 00:00:00	\N	\N	32020		\N	251392	0	396275006	80180		0
64085	3786	40481087	1960-08-05	1960-08-05 00:00:00	1960-08-26	1960-08-26 00:00:00	32020		\N	251707	0	444814009	40481087		0
53724	3179	260139	1996-02-04	1996-02-04 00:00:00	1996-02-11	1996-02-11 00:00:00	32020		\N	211515	0	10509002	260139		0
53836	3184	4166224	2000-02-23	2000-02-23 00:00:00	\N	\N	32020		\N	211993	0	47693006	4166224		0
64603	3820	81151	1989-08-16	1989-08-16 00:00:00	1989-09-20	1989-09-20 00:00:00	32020		\N	253652	0	44465007	81151		0
54162	3208	4113008	1992-09-07	1992-09-07 00:00:00	1992-09-21	1992-09-21 00:00:00	32020		\N	213247	0	284549007	4113008		0
54397	3222	260139	2015-06-10	2015-06-10 00:00:00	2015-06-24	2015-06-24 00:00:00	32020		\N	214219	0	10509002	260139		0
54523	3229	375671	2000-12-14	2000-12-14 00:00:00	2001-01-13	2001-01-13 00:00:00	32020		\N	214637	0	62564004	375671		0
54727	3240	260139	1992-10-28	1992-10-28 00:00:00	1992-11-11	1992-11-11 00:00:00	32020		\N	215346	0	10509002	260139		0
54896	3249	40481087	2015-09-06	2015-09-06 00:00:00	2015-09-13	2015-09-13 00:00:00	32020		\N	215968	0	444814009	40481087		0
65631	3881	372328	1960-06-30	1960-06-30 00:00:00	1960-08-05	1960-08-05 00:00:00	32020		\N	257917	0	65363002	372328		0
65816	3891	40481087	2005-04-01	2005-04-01 00:00:00	2005-04-08	2005-04-08 00:00:00	32020		\N	258691	0	444814009	40481087		0
55409	3283	192671	2016-07-03	2016-07-03 00:00:00	\N	\N	32020		\N	218109	0	K92.2	35208414		0
55570	3290	4112343	1987-12-10	1987-12-10 00:00:00	1987-12-17	1987-12-17 00:00:00	32020		\N	218587	0	195662009	4112343		0
55758	3300	4112343	1982-10-05	1982-10-05 00:00:00	1982-10-18	1982-10-18 00:00:00	32020		\N	219235	0	195662009	4112343		0
55850	3307	40481087	2006-04-11	2006-04-11 00:00:00	2006-04-18	2006-04-18 00:00:00	32020		\N	219581	0	444814009	40481087		0
66636	3943	40481087	2012-02-27	2012-02-27 00:00:00	2012-03-19	2012-03-19 00:00:00	32020		\N	262153	0	444814009	40481087		0
66736	3949	4152936	2009-12-12	2009-12-12 00:00:00	2009-12-26	2009-12-26 00:00:00	32020		\N	262520	0	283385000	4152936		0
66905	3957	80180	1998-08-02	1998-08-02 00:00:00	\N	\N	32020		\N	263119	0	396275006	80180		0
56567	3355	4112343	1969-06-16	1969-06-16 00:00:00	1969-06-26	1969-06-26 00:00:00	32020		\N	222493	0	195662009	4112343		0
67357	3982	4112343	1987-06-04	1987-06-04 00:00:00	1987-06-14	1987-06-14 00:00:00	32020		\N	264713	0	195662009	4112343		0
67399	3984	78272	2006-10-19	2006-10-19 00:00:00	2006-11-23	2006-11-23 00:00:00	32020		\N	264886	0	70704007	78272		0
57039	3383	4156265	2014-11-07	2014-11-07 00:00:00	2014-11-28	2014-11-28 00:00:00	32020		\N	224493	0	370247008	4156265		0
57161	3392	260139	2013-09-12	2013-09-12 00:00:00	2013-09-19	2013-09-19 00:00:00	32020		\N	224978	0	10509002	260139		0
57429	3408	40481087	1970-08-08	1970-08-08 00:00:00	1970-08-29	1970-08-29 00:00:00	32020		\N	226034	0	444814009	40481087		0
57573	3415	4109685	2015-08-22	2015-08-22 00:00:00	2015-09-05	2015-09-05 00:00:00	32020		\N	226552	0	284551006	4109685		0
57767	3427	4283893	2012-07-02	2012-07-02 00:00:00	2012-09-03	2012-09-03 00:00:00	32020		\N	227199	0	36971009	4283893		0
57911	3435	4112343	2014-09-26	2014-09-26 00:00:00	2014-10-07	2014-10-07 00:00:00	32020		\N	227778	0	195662009	4112343		0
58047	3440	80180	1980-10-21	1980-10-21 00:00:00	\N	\N	32020		\N	228248	0	396275006	80180		0
58219	3446	4113008	2006-09-03	2006-09-03 00:00:00	2006-09-24	2006-09-24 00:00:00	32020		\N	228801	0	284549007	4113008		0
58315	3455	260139	2000-05-15	2000-05-15 00:00:00	2000-05-29	2000-05-29 00:00:00	32020		\N	229250	0	10509002	260139		0
58530	3469	260139	2015-09-18	2015-09-18 00:00:00	2015-10-02	2015-10-02 00:00:00	32020		\N	230213	0	10509002	260139		0
69309	4102	192671	2006-08-10	2006-08-10 00:00:00	\N	\N	32020		\N	272622	0	K92.2	35208414		0
58779	3486	4237458	2012-04-16	2012-04-16 00:00:00	2012-07-15	2012-07-15 00:00:00	32020		\N	231299	0	58150001	4237458		0
58974	3501	375671	1970-12-29	1970-12-29 00:00:00	1971-01-28	1971-01-28 00:00:00	32020		\N	232057	0	62564004	375671		0
69781	4129	40481087	1948-09-01	1948-09-01 00:00:00	1948-09-15	1948-09-15 00:00:00	32020		\N	274509	0	444814009	40481087		0
70039	4145	40481087	1986-06-03	1986-06-03 00:00:00	1986-06-10	1986-06-10 00:00:00	32020		\N	275469	0	444814009	40481087		0
59492	3528	4029498	1958-11-03	1958-11-03 00:00:00	\N	\N	32020		\N	234247	0	128613002	4029498		0
70222	4159	4112343	1987-01-30	1987-01-30 00:00:00	1987-02-11	1987-02-11 00:00:00	32020		\N	276368	0	195662009	4112343		0
70449	4173	40481087	2013-07-02	2013-07-02 00:00:00	2013-07-09	2013-07-09 00:00:00	32020		\N	277365	0	444814009	40481087		0
70619	4190	257012	2018-11-01	2018-11-01 00:00:00	\N	\N	32020		\N	278099	0	40055000	257012		0
60236	3565	81151	1957-11-19	1957-11-19 00:00:00	1957-12-24	1957-12-24 00:00:00	32020		\N	236739	0	44465007	81151		0
60383	3572	80180	1993-08-29	1993-08-29 00:00:00	\N	\N	32020		\N	237509	0	396275006	80180		0
60447	3573	378001	1956-08-16	1956-08-16 00:00:00	1956-09-15	1956-09-15 00:00:00	32020		\N	237625	0	62106007	378001		0
60732	3595	372328	1951-08-02	1951-08-02 00:00:00	1951-09-20	1951-09-20 00:00:00	32020		\N	238784	0	65363002	372328		0
60827	3601	81151	1974-03-02	1974-03-02 00:00:00	1974-04-06	1974-04-06 00:00:00	32020		\N	239218	0	44465007	81151		0
61088	3615	40481087	1954-09-10	1954-09-10 00:00:00	1954-10-01	1954-10-01 00:00:00	32020		\N	240200	0	444814009	40481087		0
61200	3621	4230399	1963-12-08	1963-12-08 00:00:00	1964-03-07	1964-03-07 00:00:00	32020		\N	240632	0	359817006	4230399		0
61341	3625	4112343	1960-10-08	1960-10-08 00:00:00	1960-10-19	1960-10-19 00:00:00	32020		\N	241116	0	195662009	4112343		0
61503	3634	80180	2007-03-31	2007-03-31 00:00:00	\N	\N	32020		\N	241725	0	396275006	80180		0
61602	3639	378419	2001-01-13	2001-01-13 00:00:00	\N	\N	32020		\N	242045	0	26929004	378419		0
72424	4299	81151	1989-05-23	1989-05-23 00:00:00	1989-06-20	1989-06-20 00:00:00	32020		\N	285234	0	44465007	81151		0
72578	4312	40481087	1990-04-04	1990-04-04 00:00:00	1990-04-11	1990-04-11 00:00:00	32020		\N	286198	0	444814009	40481087		0
62230	3675	4112343	1968-04-13	1968-04-13 00:00:00	1968-04-26	1968-04-26 00:00:00	32020		\N	244407	0	195662009	4112343		0
72991	4337	4112343	1987-02-11	1987-02-11 00:00:00	1987-02-21	1987-02-21 00:00:00	32020		\N	287640	0	195662009	4112343		0
62580	3697	40481087	1960-11-17	1960-11-17 00:00:00	1960-12-01	1960-12-01 00:00:00	32020		\N	245800	0	444814009	40481087		0
62660	3700	4112343	1983-09-04	1983-09-04 00:00:00	1983-09-14	1983-09-14 00:00:00	32020		\N	245963	0	195662009	4112343		0
73409	4364	4134304	1960-10-09	1960-10-09 00:00:00	1960-11-08	1960-11-08 00:00:00	32020		\N	289422	0	263102004	4134304		0
62974	3719	30753	2002-07-22	2002-07-22 00:00:00	\N	\N	32020		\N	247196	0	16761005	30753		0
73767	4382	4027663	1983-12-22	1983-12-22 00:00:00	\N	\N	32020		\N	291276	0	13200003	4027663		0
73916	4390	372328	1970-11-29	1970-11-29 00:00:00	1971-01-15	1971-01-15 00:00:00	32020		\N	291835	0	65363002	372328		0
74059	4398	260139	1993-04-15	1993-04-15 00:00:00	1993-04-22	1993-04-22 00:00:00	32020		\N	292451	0	10509002	260139		0
74289	4411	4285898	1983-06-26	1983-06-26 00:00:00	\N	\N	32020		\N	293189	0	68496003	4285898		0
53286	3157	195588	2008-06-20	2008-06-20 00:00:00	2008-08-01	2008-08-01 00:00:00	32020		\N	209837	0	38822007	195588		0
64002	3783	260139	1969-03-21	1969-03-21 00:00:00	1969-04-04	1969-04-04 00:00:00	32020		\N	251367	0	10509002	260139		0
64086	3786	260139	1964-12-08	1964-12-08 00:00:00	1964-12-15	1964-12-15 00:00:00	32020		\N	251709	0	10509002	260139		0
53725	3179	40481087	1944-12-27	1944-12-27 00:00:00	1945-01-17	1945-01-17 00:00:00	32020		\N	211503	0	444814009	40481087		0
53837	3184	440448	2000-02-23	2000-02-23 00:00:00	\N	\N	32020		\N	211993	0	74400008	440448		0
64604	3820	40481087	2017-08-19	2017-08-19 00:00:00	2017-09-09	2017-09-09 00:00:00	32020		\N	253616	0	444814009	40481087		0
54163	3208	4296205	2016-02-09	2016-02-09 00:00:00	2016-02-23	2016-02-23 00:00:00	32020		\N	213249	0	403191005	4296205		0
54398	3222	4283893	1996-06-21	1996-06-21 00:00:00	1996-09-27	1996-09-27 00:00:00	32020		\N	214162	0	36971009	4283893		0
54524	3229	4112343	2017-09-02	2017-09-02 00:00:00	2017-09-13	2017-09-13 00:00:00	32020		\N	214609	0	195662009	4112343		0
54728	3240	40481087	1975-04-21	1975-04-21 00:00:00	1975-05-12	1975-05-12 00:00:00	32020		\N	215343	0	444814009	40481087		0
54897	3249	4112343	1966-04-02	1966-04-02 00:00:00	1966-04-10	1966-04-10 00:00:00	32020		\N	216007	0	195662009	4112343		0
65632	3881	28060	2011-07-11	2011-07-11 00:00:00	2011-07-20	2011-07-20 00:00:00	32020		\N	257916	0	43878008	28060		0
65817	3891	4112343	1988-10-24	1988-10-24 00:00:00	1988-11-05	1988-11-05 00:00:00	32020		\N	258722	0	195662009	4112343		0
55410	3283	4142905	1987-11-24	1987-11-24 00:00:00	1988-02-22	1988-02-22 00:00:00	32020		\N	218107	0	33737001	4142905		0
55571	3290	4266809	2004-06-12	2004-06-12 00:00:00	\N	\N	32020		\N	218613	0	397881000	4266809		0
55759	3300	40481087	2008-07-29	2008-07-29 00:00:00	2008-08-12	2008-08-12 00:00:00	32020		\N	219239	0	444814009	40481087		0
55851	3307	40481087	2001-07-09	2001-07-09 00:00:00	2001-07-30	2001-07-30 00:00:00	32020		\N	219619	0	444814009	40481087		0
66637	3943	40481087	2016-04-27	2016-04-27 00:00:00	2016-05-18	2016-05-18 00:00:00	32020		\N	262190	0	444814009	40481087		0
66737	3949	260139	2003-01-28	2003-01-28 00:00:00	2003-02-04	2003-02-04 00:00:00	32020		\N	262511	0	10509002	260139		0
66906	3957	40481087	1998-02-20	1998-02-20 00:00:00	1998-03-06	1998-03-06 00:00:00	32020		\N	263119	0	444814009	40481087		0
56568	3355	4278672	1986-07-31	1986-07-31 00:00:00	1986-10-29	1986-10-29 00:00:00	32020		\N	222507	0	65966004	4278672		0
67358	3982	4112343	1950-04-13	1950-04-13 00:00:00	1950-04-26	1950-04-26 00:00:00	32020		\N	264652	0	195662009	4112343		0
67400	3984	4218389	2016-01-05	2016-01-05 00:00:00	2016-02-02	2016-02-02 00:00:00	32020		\N	264887	0	39848009	4218389		0
57057	3386	440086	1976-11-29	1976-11-29 00:00:00	1986-12-07	1986-12-07 00:00:00	32020		\N	224644	0	192127007	440086		0
57162	3392	4112343	2016-06-27	2016-06-27 00:00:00	2016-07-10	2016-07-10 00:00:00	32020		\N	224969	0	195662009	4112343		0
57430	3409	28060	1955-11-17	1955-11-17 00:00:00	1955-11-25	1955-11-25 00:00:00	32020		\N	226063	0	43878008	28060		0
57574	3415	260139	2005-11-12	2005-11-12 00:00:00	2005-11-26	2005-11-26 00:00:00	32020		\N	226549	0	10509002	260139		0
57768	3427	80180	2000-11-13	2000-11-13 00:00:00	\N	\N	32020		\N	227221	0	396275006	80180		0
57912	3435	40481087	2004-11-02	2004-11-02 00:00:00	2004-11-23	2004-11-23 00:00:00	32020		\N	227777	0	444814009	40481087		0
58048	3440	260139	1942-10-07	1942-10-07 00:00:00	1942-10-14	1942-10-14 00:00:00	32020		\N	228327	0	10509002	260139		0
58220	3446	260139	1958-07-29	1958-07-29 00:00:00	1958-08-05	1958-08-05 00:00:00	32020		\N	228835	0	10509002	260139		0
58316	3455	4278672	2014-08-19	2014-08-19 00:00:00	2014-09-18	2014-09-18 00:00:00	32020		\N	229261	0	65966004	4278672		0
58531	3469	4218389	1998-08-30	1998-08-30 00:00:00	1998-10-04	1998-10-04 00:00:00	32020		\N	230255	0	39848009	4218389		0
69310	4102	28060	1979-09-09	1979-09-09 00:00:00	1979-09-18	1979-09-18 00:00:00	32020		\N	272618	0	43878008	28060		0
58789	3488	260139	1960-04-20	1960-04-20 00:00:00	1960-05-04	1960-05-04 00:00:00	32020		\N	231340	0	10509002	260139		0
58975	3501	81151	1993-04-02	1993-04-02 00:00:00	1993-04-24	1993-04-24 00:00:00	32020		\N	232059	0	44465007	81151		0
69782	4129	40481087	1962-01-04	1962-01-04 00:00:00	1962-01-25	1962-01-25 00:00:00	32020		\N	274518	0	444814009	40481087		0
70040	4145	40481087	1979-12-16	1979-12-16 00:00:00	1979-12-30	1979-12-30 00:00:00	32020		\N	275493	0	444814009	40481087		0
59494	3528	4059173	2015-05-04	2015-05-04 00:00:00	2015-06-03	2015-06-03 00:00:00	32020		\N	234284	0	16114001	4059173		0
70223	4159	4283893	1991-03-18	1991-03-18 00:00:00	1991-08-12	1991-08-12 00:00:00	32020		\N	276308	0	36971009	4283893		0
70450	4173	4152936	2012-06-18	2012-06-18 00:00:00	2012-07-02	2012-07-02 00:00:00	32020		\N	277328	0	283385000	4152936		0
70620	4190	440448	1977-07-31	1977-07-31 00:00:00	\N	\N	32020		\N	278063	0	74400008	440448		0
60237	3566	40481087	1952-01-28	1952-01-28 00:00:00	1952-02-11	1952-02-11 00:00:00	32020		\N	236925	0	444814009	40481087		0
60384	3572	260139	2009-10-11	2009-10-11 00:00:00	2009-10-25	2009-10-25 00:00:00	32020		\N	237463	0	10509002	260139		0
60448	3573	81151	1970-04-05	1970-04-05 00:00:00	1970-04-19	1970-04-19 00:00:00	32020		\N	237627	0	44465007	81151		0
60733	3595	4112343	2017-07-03	2017-07-03 00:00:00	2017-07-14	2017-07-14 00:00:00	32020		\N	238850	0	195662009	4112343		0
60828	3601	4051466	1962-06-25	1962-06-25 00:00:00	1978-09-29	1978-09-29 00:00:00	32020		\N	239234	0	233678006	4051466		0
71547	4243	80180	2007-09-26	2007-09-26 00:00:00	\N	\N	32020		\N	281812	0	396275006	80180		0
61201	3621	192671	1955-11-19	1955-11-19 00:00:00	\N	\N	32020		\N	240660	0	K92.2	35208414		0
61342	3625	4113008	1960-01-14	1960-01-14 00:00:00	1960-02-04	1960-02-04 00:00:00	32020		\N	241056	0	284549007	4113008		0
61504	3634	4285898	2006-11-01	2006-11-01 00:00:00	\N	\N	32020		\N	241725	0	68496003	4285898		0
61603	3639	4112343	1928-02-14	1928-02-14 00:00:00	1928-02-27	1928-02-27 00:00:00	32020		\N	242125	0	195662009	4112343		0
72425	4299	260139	1978-03-18	1978-03-18 00:00:00	1978-04-01	1978-04-01 00:00:00	32020		\N	285254	0	10509002	260139		0
72579	4312	40481087	1995-03-25	1995-03-25 00:00:00	1995-04-08	1995-04-08 00:00:00	32020		\N	286054	0	444814009	40481087		0
62231	3675	4112343	1995-08-09	1995-08-09 00:00:00	1995-08-18	1995-08-18 00:00:00	32020		\N	244477	0	195662009	4112343		0
72992	4337	4112343	2006-07-29	2006-07-29 00:00:00	2006-08-07	2006-08-07 00:00:00	32020		\N	287592	0	195662009	4112343		0
62581	3697	40481087	1988-10-11	1988-10-11 00:00:00	1988-11-01	1988-11-01 00:00:00	32020		\N	245773	0	444814009	40481087		0
62661	3700	80180	2005-04-13	2005-04-13 00:00:00	\N	\N	32020		\N	246027	0	396275006	80180		0
73410	4364	4112343	1958-08-25	1958-08-25 00:00:00	1958-09-07	1958-09-07 00:00:00	32020		\N	289467	0	195662009	4112343		0
62975	3719	4283893	2002-01-26	2002-01-26 00:00:00	2002-06-22	2002-06-22 00:00:00	32020		\N	247196	0	36971009	4283893		0
73768	4382	257012	2008-05-11	2008-05-11 00:00:00	\N	\N	32020		\N	291150	0	40055000	257012		0
73917	4390	4218389	1986-01-27	1986-01-27 00:00:00	1986-02-17	1986-02-17 00:00:00	32020		\N	291791	0	39848009	4218389		0
74060	4398	4112343	1994-05-14	1994-05-14 00:00:00	1994-05-26	1994-05-26 00:00:00	32020		\N	292447	0	195662009	4112343		0
74290	4411	81893	1982-05-02	1982-05-02 00:00:00	\N	\N	32020		\N	293189	0	64766004	81893		0
63775	3767	260139	2000-11-29	2000-11-29 00:00:00	2000-12-06	2000-12-06 00:00:00	32020		\N	250339	0	10509002	260139		0
64003	3783	40481087	1972-10-19	1972-10-19 00:00:00	1972-10-26	1972-10-26 00:00:00	32020		\N	251428	0	444814009	40481087		0
64087	3786	81151	2017-10-08	2017-10-08 00:00:00	2017-11-12	2017-11-12 00:00:00	32020		\N	251666	0	44465007	81151		0
53726	3179	40481087	1974-06-04	1974-06-04 00:00:00	1974-06-18	1974-06-18 00:00:00	32020		\N	211463	0	444814009	40481087		0
53838	3184	260139	1973-01-29	1973-01-29 00:00:00	1973-02-12	1973-02-12 00:00:00	32020		\N	211973	0	10509002	260139		0
64605	3820	28060	1968-07-05	1968-07-05 00:00:00	1968-07-12	1968-07-12 00:00:00	32020		\N	253657	0	43878008	28060		0
54164	3208	80180	2011-04-21	2011-04-21 00:00:00	\N	\N	32020		\N	213282	0	396275006	80180		0
54399	3222	381316	2012-10-30	2012-10-30 00:00:00	\N	\N	32020		\N	214201	0	230690007	381316		0
54525	3229	4001336	2008-11-23	2008-11-23 00:00:00	2008-12-23	2008-12-23 00:00:00	32020		\N	214639	0	110030002	4001336		0
54729	3240	372328	1951-01-18	1951-01-18 00:00:00	1952-01-09	1952-01-09 00:00:00	32020		\N	215351	0	65363002	372328		0
54898	3249	40481087	2001-07-12	2001-07-12 00:00:00	2001-07-26	2001-07-26 00:00:00	32020		\N	215965	0	444814009	40481087		0
65633	3881	40481087	2013-02-03	2013-02-03 00:00:00	2013-02-17	2013-02-17 00:00:00	32020		\N	257889	0	444814009	40481087		0
65818	3891	4112343	2004-08-17	2004-08-17 00:00:00	2004-08-30	2004-08-30 00:00:00	32020		\N	258642	0	195662009	4112343		0
55411	3283	4294548	1993-09-21	1993-09-21 00:00:00	1993-10-12	1993-10-12 00:00:00	32020		\N	218138	0	75498004	4294548		0
55572	3290	40481087	2003-01-09	2003-01-09 00:00:00	2003-01-16	2003-01-16 00:00:00	32020		\N	218613	0	444814009	40481087		0
55760	3301	372328	1938-10-02	1938-10-02 00:00:00	1938-12-13	1938-12-13 00:00:00	32020		\N	219270	0	65363002	372328		0
55852	3307	80180	2003-07-05	2003-07-05 00:00:00	\N	\N	32020		\N	219619	0	396275006	80180		0
66638	3943	4112343	1960-03-19	1960-03-19 00:00:00	1960-03-31	1960-03-31 00:00:00	32020		\N	262134	0	195662009	4112343		0
66738	3949	80180	2003-07-27	2003-07-27 00:00:00	\N	\N	32020		\N	262511	0	396275006	80180		0
66907	3957	40481087	1972-06-14	1972-06-14 00:00:00	1972-06-21	1972-06-21 00:00:00	32020		\N	263046	0	444814009	40481087		0
56569	3355	4112343	1980-12-22	1980-12-22 00:00:00	1981-01-02	1981-01-02 00:00:00	32020		\N	222510	0	195662009	4112343		0
67359	3982	378001	1979-05-10	1979-05-10 00:00:00	1979-07-09	1979-07-09 00:00:00	32020		\N	264674	0	62106007	378001		0
67401	3984	260139	1958-03-26	1958-03-26 00:00:00	1958-04-02	1958-04-02 00:00:00	32020		\N	264804	0	10509002	260139		0
57058	3386	40481087	1993-04-06	1993-04-06 00:00:00	1993-04-13	1993-04-13 00:00:00	32020		\N	224618	0	444814009	40481087		0
57163	3392	4112343	2006-09-26	2006-09-26 00:00:00	2006-10-05	2006-10-05 00:00:00	32020		\N	224961	0	195662009	4112343		0
57431	3409	40481087	1998-09-14	1998-09-14 00:00:00	1998-10-05	1998-10-05 00:00:00	32020		\N	226094	0	444814009	40481087		0
57575	3415	28060	2008-05-22	2008-05-22 00:00:00	2008-05-29	2008-05-29 00:00:00	32020		\N	226502	0	43878008	28060		0
68244	4032	260139	1979-01-31	1979-01-31 00:00:00	1979-02-07	1979-02-07 00:00:00	32020		\N	268242	0	10509002	260139		0
57913	3435	40481087	1991-11-26	1991-11-26 00:00:00	1991-12-03	1991-12-03 00:00:00	32020		\N	227770	0	444814009	40481087		0
58049	3440	4112343	1962-03-11	1962-03-11 00:00:00	1962-03-18	1962-03-18 00:00:00	32020		\N	228259	0	195662009	4112343		0
58221	3446	4112343	1990-07-14	1990-07-14 00:00:00	1990-07-22	1990-07-22 00:00:00	32020		\N	228811	0	195662009	4112343		0
58317	3455	40481087	2009-11-28	2009-11-28 00:00:00	2009-12-12	2009-12-12 00:00:00	32020		\N	229204	0	444814009	40481087		0
58532	3469	78272	1969-04-19	1969-04-19 00:00:00	1969-05-10	1969-05-10 00:00:00	32020		\N	230294	0	70704007	78272		0
69311	4102	4294548	2007-09-22	2007-09-22 00:00:00	2007-12-22	2007-12-22 00:00:00	32020		\N	272568	0	75498004	4294548		0
58790	3488	4155034	1990-06-13	1990-06-13 00:00:00	1990-07-04	1990-07-04 00:00:00	32020		\N	231357	0	283371005	4155034		0
58976	3501	40481087	1974-10-28	1974-10-28 00:00:00	1974-11-18	1974-11-18 00:00:00	32020		\N	232083	0	444814009	40481087		0
69783	4129	4283893	1969-01-18	1969-01-18 00:00:00	1969-03-01	1969-03-01 00:00:00	32020		\N	274519	0	36971009	4283893		0
70041	4145	372328	1975-05-03	1975-05-03 00:00:00	1975-06-15	1975-06-15 00:00:00	32020		\N	275549	0	65363002	372328		0
59495	3528	4112343	1963-10-12	1963-10-12 00:00:00	1963-10-23	1963-10-23 00:00:00	32020		\N	234228	0	195662009	4112343		0
70224	4159	4296204	2012-01-14	2012-01-14 00:00:00	2012-02-11	2012-02-11 00:00:00	32020		\N	276365	0	403190006	4296204		0
70451	4173	40481087	2018-05-20	2018-05-20 00:00:00	2018-05-27	2018-05-27 00:00:00	32020		\N	277366	0	444814009	40481087		0
70621	4190	40481087	2019-04-25	2019-04-25 00:00:00	2019-05-02	2019-05-02 00:00:00	32020		\N	278097	0	444814009	40481087		0
60238	3566	260139	2005-07-31	2005-07-31 00:00:00	2005-08-14	2005-08-14 00:00:00	32020		\N	236970	0	10509002	260139		0
60385	3572	40481087	2005-01-11	2005-01-11 00:00:00	2005-01-18	2005-01-18 00:00:00	32020		\N	237481	0	444814009	40481087		0
60449	3573	4109685	1978-09-04	1978-09-04 00:00:00	1978-09-25	1978-09-25 00:00:00	32020		\N	237628	0	284551006	4109685		0
60734	3595	378001	1968-11-05	1968-11-05 00:00:00	1969-01-04	1969-01-04 00:00:00	32020		\N	238830	0	62106007	378001		0
60829	3601	40481087	1989-06-12	1989-06-12 00:00:00	1989-07-03	1989-07-03 00:00:00	32020		\N	239152	0	444814009	40481087		0
71548	4243	372328	1972-06-15	1972-06-15 00:00:00	1972-12-29	1972-12-29 00:00:00	32020		\N	281853	0	65363002	372328		0
61202	3621	260139	1993-11-01	1993-11-01 00:00:00	1993-11-15	1993-11-15 00:00:00	32020		\N	240583	0	10509002	260139		0
61343	3625	28060	1965-10-18	1965-10-18 00:00:00	1965-10-30	1965-10-30 00:00:00	32020		\N	241035	0	43878008	28060		0
61505	3634	30753	2006-04-05	2006-04-05 00:00:00	\N	\N	32020		\N	241725	0	16761005	30753		0
61604	3639	260139	1954-06-03	1954-06-03 00:00:00	1954-06-17	1954-06-17 00:00:00	32020		\N	242061	0	10509002	260139		0
72426	4299	4156265	2011-11-20	2011-11-20 00:00:00	2011-12-11	2011-12-11 00:00:00	32020		\N	285236	0	370247008	4156265		0
72580	4312	80180	1995-07-29	1995-07-29 00:00:00	\N	\N	32020		\N	286054	0	396275006	80180		0
62232	3675	260139	1970-03-03	1970-03-03 00:00:00	1970-03-17	1970-03-17 00:00:00	32020		\N	244431	0	10509002	260139		0
72993	4338	4112343	1989-01-09	1989-01-09 00:00:00	1989-01-21	1989-01-21 00:00:00	32020		\N	287688	0	195662009	4112343		0
62582	3697	4112343	2002-06-29	2002-06-29 00:00:00	2002-07-08	2002-07-08 00:00:00	32020		\N	245731	0	195662009	4112343		0
62662	3700	4266809	2005-04-13	2005-04-13 00:00:00	\N	\N	32020		\N	246027	0	397881000	4266809		0
73411	4364	80180	1987-05-16	1987-05-16 00:00:00	\N	\N	32020		\N	289439	0	396275006	80180		0
62976	3719	40481087	2010-03-01	2010-03-01 00:00:00	2010-03-22	2010-03-22 00:00:00	32020		\N	247197	0	444814009	40481087		0
73769	4382	28060	2016-04-07	2016-04-07 00:00:00	2016-04-18	2016-04-18 00:00:00	32020		\N	291240	0	43878008	28060		0
73918	4390	372328	1963-07-28	1963-07-28 00:00:00	1963-12-06	1963-12-06 00:00:00	32020		\N	291902	0	65363002	372328		0
74061	4398	40481087	2019-04-22	2019-04-22 00:00:00	2019-05-13	2019-05-13 00:00:00	32020		\N	292449	0	444814009	40481087		0
74291	4411	4310024	1981-08-05	1981-08-05 00:00:00	\N	\N	32020		\N	293189	0	424802006	4310024		0
63776	3767	40481087	2004-02-15	2004-02-15 00:00:00	2004-02-22	2004-02-22 00:00:00	32020		\N	250340	0	444814009	40481087		0
64004	3783	81151	2016-01-25	2016-01-25 00:00:00	2016-02-29	2016-02-29 00:00:00	32020		\N	251385	0	44465007	81151		0
64088	3786	81151	2007-06-28	2007-06-28 00:00:00	2007-08-02	2007-08-02 00:00:00	32020		\N	251665	0	44465007	81151		0
53727	3179	40481087	1996-03-24	1996-03-24 00:00:00	1996-04-07	1996-04-07 00:00:00	32020		\N	211472	0	444814009	40481087		0
53839	3184	40481087	2002-01-26	2002-01-26 00:00:00	2002-02-02	2002-02-02 00:00:00	32020		\N	211999	0	444814009	40481087		0
64606	3820	4294548	1979-01-12	1979-01-12 00:00:00	1979-05-25	1979-05-25 00:00:00	32020		\N	253659	0	75498004	4294548		0
54165	3208	4152936	2001-03-08	2001-03-08 00:00:00	2001-03-29	2001-03-29 00:00:00	32020		\N	213248	0	283385000	4152936		0
54400	3222	4152936	2007-08-06	2007-08-06 00:00:00	2007-08-27	2007-08-27 00:00:00	32020		\N	214157	0	283385000	4152936		0
54526	3229	40481087	1991-01-05	1991-01-05 00:00:00	1991-01-12	1991-01-12 00:00:00	32020		\N	214620	0	444814009	40481087		0
54730	3240	40481087	1962-04-23	1962-04-23 00:00:00	1962-04-30	1962-04-30 00:00:00	32020		\N	215372	0	444814009	40481087		0
54899	3249	40481087	2006-05-06	2006-05-06 00:00:00	2006-05-20	2006-05-20 00:00:00	32020		\N	215950	0	444814009	40481087		0
65634	3881	40481087	1958-05-18	1958-05-18 00:00:00	1958-06-08	1958-06-08 00:00:00	32020		\N	257886	0	444814009	40481087		0
65819	3891	40481087	2018-12-04	2018-12-04 00:00:00	2018-12-18	2018-12-18 00:00:00	32020		\N	258644	0	444814009	40481087		0
55412	3283	80180	2016-05-25	2016-05-25 00:00:00	\N	\N	32020		\N	218122	0	396275006	80180		0
55573	3290	80180	2004-06-12	2004-06-12 00:00:00	\N	\N	32020		\N	218613	0	396275006	80180		0
55761	3301	40481087	1938-12-06	1938-12-06 00:00:00	1938-12-20	1938-12-20 00:00:00	32020		\N	219280	0	444814009	40481087		0
55853	3307	40481087	1995-12-27	1995-12-27 00:00:00	1996-01-03	1996-01-03 00:00:00	32020		\N	219599	0	444814009	40481087		0
66639	3943	40481087	2013-11-16	2013-11-16 00:00:00	2013-11-30	2013-11-30 00:00:00	32020		\N	262143	0	444814009	40481087		0
66739	3950	40481087	2007-01-09	2007-01-09 00:00:00	2007-01-16	2007-01-16 00:00:00	32020		\N	262539	0	444814009	40481087		0
66908	3957	4112343	2013-06-19	2013-06-19 00:00:00	2013-07-02	2013-07-02 00:00:00	32020		\N	263089	0	195662009	4112343		0
56570	3355	40481087	1974-07-28	1974-07-28 00:00:00	1974-08-18	1974-08-18 00:00:00	32020		\N	222479	0	444814009	40481087		0
67360	3982	40481087	1976-01-29	1976-01-29 00:00:00	1976-02-05	1976-02-05 00:00:00	32020		\N	264711	0	444814009	40481087		0
67402	3984	372328	1955-12-13	1955-12-13 00:00:00	1956-05-30	1956-05-30 00:00:00	32020		\N	264823	0	65363002	372328		0
57059	3386	372328	1974-11-14	1974-11-14 00:00:00	1975-11-23	1975-11-23 00:00:00	32020		\N	224659	0	65363002	372328		0
57164	3392	80180	2002-02-10	2002-02-10 00:00:00	\N	\N	32020		\N	224971	0	396275006	80180		0
57432	3409	40481087	2017-12-19	2017-12-19 00:00:00	2017-12-26	2017-12-26 00:00:00	32020		\N	226060	0	444814009	40481087		0
57576	3415	28060	2008-09-28	2008-09-28 00:00:00	2008-10-06	2008-10-06 00:00:00	32020		\N	226532	0	43878008	28060		0
68245	4032	4278672	1961-01-18	1961-01-18 00:00:00	1961-04-18	1961-04-18 00:00:00	32020		\N	268267	0	65966004	4278672		0
57914	3435	40481087	2009-06-05	2009-06-05 00:00:00	2009-06-12	2009-06-12 00:00:00	32020		\N	227773	0	444814009	40481087		0
58050	3440	40481087	1958-08-04	1958-08-04 00:00:00	1958-08-18	1958-08-18 00:00:00	32020		\N	228276	0	444814009	40481087		0
58222	3446	40481087	1947-07-30	1947-07-30 00:00:00	1947-08-06	1947-08-06 00:00:00	32020		\N	228829	0	444814009	40481087		0
58318	3455	4116491	1998-05-19	1998-05-19 00:00:00	1998-07-18	1998-07-18 00:00:00	32020		\N	229242	0	301011002	4116491		0
58533	3469	4109685	1953-08-27	1953-08-27 00:00:00	1953-09-10	1953-09-10 00:00:00	32020		\N	230293	0	284551006	4109685		0
69312	4102	4237458	1981-08-14	1981-08-14 00:00:00	1981-11-12	1981-11-12 00:00:00	32020		\N	272580	0	58150001	4237458		0
58791	3488	260139	1990-04-05	1990-04-05 00:00:00	1990-04-12	1990-04-12 00:00:00	32020		\N	231417	0	10509002	260139		0
58977	3501	28060	1961-01-27	1961-01-27 00:00:00	1961-02-09	1961-02-09 00:00:00	32020		\N	232066	0	43878008	28060		0
69784	4129	40481087	2013-06-07	2013-06-07 00:00:00	2013-06-14	2013-06-14 00:00:00	32020		\N	274522	0	444814009	40481087		0
70042	4145	260139	2017-07-22	2017-07-22 00:00:00	2017-08-05	2017-08-05 00:00:00	32020		\N	275545	0	10509002	260139		0
59496	3528	4112343	2006-05-10	2006-05-10 00:00:00	2006-05-17	2006-05-17 00:00:00	32020		\N	234150	0	195662009	4112343		0
70225	4159	40481087	1994-08-03	1994-08-03 00:00:00	1994-08-17	1994-08-17 00:00:00	32020		\N	276309	0	444814009	40481087		0
70452	4173	40481087	1963-10-20	1963-10-20 00:00:00	1963-11-03	1963-11-03 00:00:00	32020		\N	277371	0	444814009	40481087		0
70622	4190	4113008	1987-01-13	1987-01-13 00:00:00	1987-02-03	1987-02-03 00:00:00	32020		\N	278064	0	284549007	4113008		0
60239	3566	28060	1986-05-20	1986-05-20 00:00:00	1986-05-30	1986-05-30 00:00:00	32020		\N	236921	0	43878008	28060		0
60386	3572	81151	2004-01-05	2004-01-05 00:00:00	2004-02-09	2004-02-09 00:00:00	32020		\N	237445	0	44465007	81151		0
60450	3573	4027663	1955-04-20	1955-04-20 00:00:00	\N	\N	32020		\N	237610	0	13200003	4027663		0
60735	3595	378001	2006-06-15	2006-06-15 00:00:00	2006-07-15	2006-07-15 00:00:00	32020		\N	238834	0	62106007	378001		0
60830	3601	260139	1971-05-18	1971-05-18 00:00:00	1971-05-25	1971-05-25 00:00:00	32020		\N	239149	0	10509002	260139		0
71549	4243	4283893	2015-05-24	2015-05-24 00:00:00	2015-12-13	2015-12-13 00:00:00	32020		\N	281829	0	36971009	4283893		0
61203	3621	378419	1991-05-11	1991-05-11 00:00:00	\N	\N	32020		\N	240646	0	26929004	378419		0
61344	3625	260139	1987-04-26	1987-04-26 00:00:00	1987-05-03	1987-05-03 00:00:00	32020		\N	241062	0	10509002	260139		0
61512	3636	4112343	1998-02-25	1998-02-25 00:00:00	1998-03-08	1998-03-08 00:00:00	32020		\N	241867	0	195662009	4112343		0
61605	3639	260139	1978-03-01	1978-03-01 00:00:00	1978-03-08	1978-03-08 00:00:00	32020		\N	242169	0	10509002	260139		0
72427	4299	28060	1993-01-10	1993-01-10 00:00:00	1993-01-17	1993-01-17 00:00:00	32020		\N	285277	0	43878008	28060		0
72581	4312	372328	1982-01-06	1982-01-06 00:00:00	1984-09-19	1984-09-19 00:00:00	32020		\N	286061	0	65363002	372328		0
62233	3675	4112343	2017-12-03	2017-12-03 00:00:00	2017-12-16	2017-12-16 00:00:00	32020		\N	244437	0	195662009	4112343		0
72994	4338	4027663	1990-07-04	1990-07-04 00:00:00	\N	\N	32020		\N	287688	0	13200003	4027663		0
73041	4340	4218389	1977-04-29	1977-04-29 00:00:00	1977-05-20	1977-05-20 00:00:00	32020		\N	287779	0	39848009	4218389		0
62663	3700	40481087	2010-07-26	2010-07-26 00:00:00	2010-08-16	2010-08-16 00:00:00	32020		\N	245982	0	444814009	40481087		0
73412	4365	40481087	1968-12-21	1968-12-21 00:00:00	1969-01-04	1969-01-04 00:00:00	32020		\N	289563	0	444814009	40481087		0
62977	3719	192671	2003-11-03	2003-11-03 00:00:00	\N	\N	32020		\N	247205	0	K92.2	35208414		0
73770	4382	260139	2010-08-13	2010-08-13 00:00:00	2010-08-20	2010-08-20 00:00:00	32020		\N	291257	0	10509002	260139		0
73919	4390	40481087	1999-05-17	1999-05-17 00:00:00	1999-06-07	1999-06-07 00:00:00	32020		\N	291926	0	444814009	40481087		0
74062	4398	28060	1964-01-25	1964-01-25 00:00:00	1964-02-03	1964-02-03 00:00:00	32020		\N	292462	0	43878008	28060		0
74292	4411	260139	1977-07-15	1977-07-15 00:00:00	1977-07-22	1977-07-22 00:00:00	32020		\N	293180	0	10509002	260139		0
63777	3767	4112343	2003-04-09	2003-04-09 00:00:00	2003-04-18	2003-04-18 00:00:00	32020		\N	250367	0	195662009	4112343		0
64005	3783	4059173	2008-11-02	2008-11-02 00:00:00	2008-12-02	2008-12-02 00:00:00	32020		\N	251384	0	16114001	4059173		0
64089	3786	28060	2013-05-01	2013-05-01 00:00:00	2013-05-12	2013-05-12 00:00:00	32020		\N	251717	0	43878008	28060		0
53728	3179	80502	1979-12-29	1979-12-29 00:00:00	\N	\N	32020		\N	211522	0	64859006	80502		0
53840	3184	80180	2003-10-08	2003-10-08 00:00:00	\N	\N	32020		\N	211999	0	396275006	80180		0
64607	3820	192671	2005-08-10	2005-08-10 00:00:00	\N	\N	32020		\N	253603	0	K92.2	35208414		0
54166	3208	372328	1990-03-17	1990-03-17 00:00:00	1993-03-19	1993-03-19 00:00:00	32020		\N	213255	0	65363002	372328		0
54401	3222	260139	1959-04-30	1959-04-30 00:00:00	1959-05-14	1959-05-14 00:00:00	32020		\N	214136	0	10509002	260139		0
54527	3229	378001	2010-11-13	2010-11-13 00:00:00	2011-01-12	2011-01-12 00:00:00	32020		\N	214640	0	62106007	378001		0
54731	3240	4112343	1975-05-06	1975-05-06 00:00:00	1975-05-17	1975-05-17 00:00:00	32020		\N	215335	0	195662009	4112343		0
54900	3249	372328	1957-08-13	1957-08-13 00:00:00	1957-10-20	1957-10-20 00:00:00	32020		\N	216022	0	65363002	372328		0
65635	3881	40481087	1964-09-12	1964-09-12 00:00:00	1964-10-03	1964-10-03 00:00:00	32020		\N	257944	0	444814009	40481087		0
65820	3891	80180	2019-06-03	2019-06-03 00:00:00	\N	\N	32020		\N	258644	0	396275006	80180		0
55413	3283	4266809	2016-05-25	2016-05-25 00:00:00	\N	\N	32020		\N	218122	0	397881000	4266809		0
55580	3293	4112343	1927-10-08	1927-10-08 00:00:00	1927-10-20	1927-10-20 00:00:00	32020		\N	218660	0	195662009	4112343		0
55762	3301	40481087	1950-06-27	1950-06-27 00:00:00	1950-07-04	1950-07-04 00:00:00	32020		\N	219304	0	444814009	40481087		0
55854	3307	4059173	1972-09-15	1972-09-15 00:00:00	1972-10-15	1972-10-15 00:00:00	32020		\N	219553	0	16114001	4059173		0
66640	3943	372328	1956-05-23	1956-05-23 00:00:00	1957-01-24	1957-01-24 00:00:00	32020		\N	262144	0	65363002	372328		0
66740	3950	81893	2013-01-13	2013-01-13 00:00:00	\N	\N	32020		\N	262560	0	64766004	81893		0
66909	3957	40481087	2016-01-03	2016-01-03 00:00:00	2016-01-10	2016-01-10 00:00:00	32020		\N	263121	0	444814009	40481087		0
56571	3355	40481087	1979-08-27	1979-08-27 00:00:00	1979-09-17	1979-09-17 00:00:00	32020		\N	222494	0	444814009	40481087		0
67361	3982	80180	1977-11-21	1977-11-21 00:00:00	\N	\N	32020		\N	264711	0	396275006	80180		0
67403	3984	4112343	1967-08-11	1967-08-11 00:00:00	1967-08-22	1967-08-22 00:00:00	32020		\N	264807	0	195662009	4112343		0
57060	3386	4283893	2004-11-20	2004-11-20 00:00:00	2004-12-04	2004-12-04 00:00:00	32020		\N	224641	0	36971009	4283893		0
57165	3392	4112343	2005-09-19	2005-09-19 00:00:00	2005-09-28	2005-09-28 00:00:00	32020		\N	224960	0	195662009	4112343		0
57433	3409	4112343	1992-07-21	1992-07-21 00:00:00	1992-07-28	1992-07-28 00:00:00	32020		\N	226093	0	195662009	4112343		0
57577	3415	40481087	1997-10-20	1997-10-20 00:00:00	1997-11-03	1997-11-03 00:00:00	32020		\N	226496	0	444814009	40481087		0
68246	4032	4113008	1953-04-16	1953-04-16 00:00:00	1953-04-30	1953-04-30 00:00:00	32020		\N	268265	0	284549007	4113008		0
57915	3435	4134304	2018-04-27	2018-04-27 00:00:00	2018-05-27	2018-05-27 00:00:00	32020		\N	227830	0	263102004	4134304		0
58051	3440	4278672	1959-12-20	1959-12-20 00:00:00	1960-02-18	1960-02-18 00:00:00	32020		\N	228294	0	65966004	4278672		0
58223	3446	260139	1972-08-01	1972-08-01 00:00:00	1972-08-08	1972-08-08 00:00:00	32020		\N	228809	0	10509002	260139		0
58319	3455	80180	2009-11-02	2009-11-02 00:00:00	\N	\N	32020		\N	229227	0	396275006	80180		0
58534	3469	4112343	1956-08-14	1956-08-14 00:00:00	1956-08-22	1956-08-22 00:00:00	32020		\N	230240	0	195662009	4112343		0
69313	4102	4112343	1997-12-13	1997-12-13 00:00:00	1997-12-20	1997-12-20 00:00:00	32020		\N	272567	0	195662009	4112343		0
58792	3488	80180	1992-05-30	1992-05-30 00:00:00	\N	\N	32020		\N	231343	0	396275006	80180		0
58978	3501	4027663	1975-11-27	1975-11-27 00:00:00	\N	\N	32020		\N	232044	0	13200003	4027663		0
69785	4129	4112343	1977-04-19	1977-04-19 00:00:00	1977-04-26	1977-04-26 00:00:00	32020		\N	274446	0	195662009	4112343		0
70043	4145	4059173	1992-04-03	1992-04-03 00:00:00	1992-06-02	1992-06-02 00:00:00	32020		\N	275464	0	16114001	4059173		0
59497	3528	40481087	1980-07-16	1980-07-16 00:00:00	1980-07-30	1980-07-30 00:00:00	32020		\N	234261	0	444814009	40481087		0
70226	4159	40481087	2014-07-01	2014-07-01 00:00:00	2014-07-22	2014-07-22 00:00:00	32020		\N	276351	0	444814009	40481087		0
70453	4173	80180	2002-10-23	2002-10-23 00:00:00	\N	\N	32020		\N	277357	0	396275006	80180		0
70623	4190	40481087	1993-09-14	1993-09-14 00:00:00	1993-09-21	1993-09-21 00:00:00	32020		\N	278069	0	444814009	40481087		0
60240	3566	80180	1988-06-23	1988-06-23 00:00:00	\N	\N	32020		\N	236921	0	396275006	80180		0
60387	3572	40481087	1964-10-22	1964-10-22 00:00:00	1964-11-12	1964-11-12 00:00:00	32020		\N	237470	0	444814009	40481087		0
60459	3576	257012	2013-02-24	2013-02-24 00:00:00	\N	\N	32020		\N	237718	0	40055000	257012		0
60736	3595	4294548	1976-08-14	1976-08-14 00:00:00	1976-11-06	1976-11-06 00:00:00	32020		\N	238800	0	75498004	4294548		0
60831	3601	80180	1992-03-27	1992-03-27 00:00:00	\N	\N	32020		\N	239155	0	396275006	80180		0
71550	4243	4294548	2002-08-02	2002-08-02 00:00:00	2002-09-20	2002-09-20 00:00:00	32020		\N	281814	0	75498004	4294548		0
67980	4017	317576	2000-04-20	2000-04-20 00:00:00	\N	\N	32020		\N	266929	0	53741008	317576		0
61204	3621	40481087	1977-11-07	1977-11-07 00:00:00	1977-11-28	1977-11-28 00:00:00	32020		\N	240612	0	444814009	40481087		0
61345	3625	40481087	1986-04-20	1986-04-20 00:00:00	1986-04-27	1986-04-27 00:00:00	32020		\N	241121	0	444814009	40481087		0
61513	3636	4278672	1981-12-24	1981-12-24 00:00:00	1982-01-23	1982-01-23 00:00:00	32020		\N	241832	0	65966004	4278672		0
61606	3639	40481087	1948-12-26	1948-12-26 00:00:00	1949-01-09	1949-01-09 00:00:00	32020		\N	242060	0	444814009	40481087		0
72428	4299	4112343	1978-11-15	1978-11-15 00:00:00	1978-11-23	1978-11-23 00:00:00	32020		\N	285284	0	195662009	4112343		0
72582	4312	260139	2005-09-02	2005-09-02 00:00:00	2005-09-16	2005-09-16 00:00:00	32020		\N	286060	0	10509002	260139		0
62234	3675	372328	1967-11-13	1967-11-13 00:00:00	1967-12-25	1967-12-25 00:00:00	32020		\N	244454	0	65363002	372328		0
72995	4338	40481087	2006-09-01	2006-09-01 00:00:00	2006-09-15	2006-09-15 00:00:00	32020		\N	287689	0	444814009	40481087		0
73042	4340	4112343	1973-06-23	1973-06-23 00:00:00	1973-07-01	1973-07-01 00:00:00	32020		\N	287774	0	195662009	4112343		0
62664	3700	40479768	1971-07-06	1971-07-06 00:00:00	1971-09-11	1971-09-11 00:00:00	32020		\N	245972	0	444470001	40479768		0
73413	4365	40481087	1955-02-10	1955-02-10 00:00:00	1955-02-24	1955-02-24 00:00:00	32020		\N	289537	0	444814009	40481087		0
62978	3719	257012	1968-02-12	1968-02-12 00:00:00	\N	\N	32020		\N	247149	0	40055000	257012		0
73771	4382	4156265	1964-10-27	1964-10-27 00:00:00	1964-11-17	1964-11-17 00:00:00	32020		\N	291167	0	370247008	4156265		0
73920	4390	40481087	1967-03-27	1967-03-27 00:00:00	1967-04-10	1967-04-10 00:00:00	32020		\N	291794	0	444814009	40481087		0
74063	4398	4283893	1986-07-01	1986-07-01 00:00:00	1986-10-14	1986-10-14 00:00:00	32020		\N	292437	0	36971009	4283893		0
74293	4411	4112343	1978-09-14	1978-09-14 00:00:00	1978-09-27	1978-09-27 00:00:00	32020		\N	293188	0	195662009	4112343		0
63778	3767	372328	1986-10-08	1986-10-08 00:00:00	1987-01-23	1987-01-23 00:00:00	32020		\N	250341	0	65363002	372328		0
64006	3783	4084167	1948-09-25	1948-09-25 00:00:00	1948-09-25	1948-09-25 00:00:00	32020		\N	251450	0	241929008	4084167		0
64090	3786	4112343	1992-03-12	1992-03-12 00:00:00	1992-03-23	1992-03-23 00:00:00	32020		\N	251715	0	195662009	4112343		0
53729	3179	4310024	1956-01-21	1956-01-21 00:00:00	\N	\N	32020		\N	211498	0	424802006	4310024		0
53875	3189	40481087	2006-02-25	2006-02-25 00:00:00	2006-03-11	2006-03-11 00:00:00	32020		\N	212237	0	444814009	40481087		0
64608	3820	372328	1967-08-07	1967-08-07 00:00:00	1967-10-27	1967-10-27 00:00:00	32020		\N	253620	0	65363002	372328		0
54167	3208	81151	1986-04-07	1986-04-07 00:00:00	1986-05-12	1986-05-12 00:00:00	32020		\N	213246	0	44465007	81151		0
54402	3222	4112343	1971-03-19	1971-03-19 00:00:00	1971-03-28	1971-03-28 00:00:00	32020		\N	214139	0	195662009	4112343		0
54528	3229	40481087	1994-05-04	1994-05-04 00:00:00	1994-05-18	1994-05-18 00:00:00	32020		\N	214621	0	444814009	40481087		0
54732	3240	40481087	1969-03-03	1969-03-03 00:00:00	1969-03-17	1969-03-17 00:00:00	32020		\N	215342	0	444814009	40481087		0
54901	3249	40481087	1997-12-16	1997-12-16 00:00:00	1997-12-23	1997-12-23 00:00:00	32020		\N	216012	0	444814009	40481087		0
65636	3881	81151	1978-12-23	1978-12-23 00:00:00	1979-01-20	1979-01-20 00:00:00	32020		\N	257919	0	44465007	81151		0
65821	3891	260139	2002-08-12	2002-08-12 00:00:00	2002-08-19	2002-08-19 00:00:00	32020		\N	258690	0	10509002	260139		0
55414	3283	40481087	2008-10-18	2008-10-18 00:00:00	2008-11-08	2008-11-08 00:00:00	32020		\N	218103	0	444814009	40481087		0
55581	3293	28060	1958-05-22	1958-05-22 00:00:00	1958-06-04	1958-06-04 00:00:00	32020		\N	218702	0	43878008	28060		0
55763	3301	40481087	1972-12-10	1972-12-10 00:00:00	1972-12-24	1972-12-24 00:00:00	32020		\N	219264	0	444814009	40481087		0
55855	3307	40481087	2008-06-13	2008-06-13 00:00:00	2008-07-04	2008-07-04 00:00:00	32020		\N	219559	0	444814009	40481087		0
66641	3943	40481087	1978-08-31	1978-08-31 00:00:00	1978-09-07	1978-09-07 00:00:00	32020		\N	262168	0	444814009	40481087		0
66741	3950	4112343	1999-07-16	1999-07-16 00:00:00	1999-07-25	1999-07-25 00:00:00	32020		\N	262538	0	195662009	4112343		0
66910	3957	40481087	2010-05-11	2010-05-11 00:00:00	2010-05-25	2010-05-25 00:00:00	32020		\N	263120	0	444814009	40481087		0
56572	3355	4112343	1967-10-10	1967-10-10 00:00:00	1967-10-22	1967-10-22 00:00:00	32020		\N	222482	0	195662009	4112343		0
67362	3982	4156265	1995-09-13	1995-09-13 00:00:00	1995-10-04	1995-10-04 00:00:00	32020		\N	264675	0	370247008	4156265		0
67404	3984	372328	1956-08-28	1956-08-28 00:00:00	1956-11-28	1956-11-28 00:00:00	32020		\N	264846	0	65363002	372328		0
57061	3386	4310024	2005-05-21	2005-05-21 00:00:00	\N	\N	32020		\N	224641	0	424802006	4310024		0
57166	3392	4112343	1979-11-04	1979-11-04 00:00:00	1979-11-17	1979-11-17 00:00:00	32020		\N	224967	0	195662009	4112343		0
57434	3409	40481087	2005-05-04	2005-05-04 00:00:00	2005-05-25	2005-05-25 00:00:00	32020		\N	226077	0	444814009	40481087		0
57578	3415	4112343	1974-09-21	1974-09-21 00:00:00	1974-10-04	1974-10-04 00:00:00	32020		\N	226517	0	195662009	4112343		0
68247	4032	40481087	1996-07-27	1996-07-27 00:00:00	1996-08-03	1996-08-03 00:00:00	32020		\N	268274	0	444814009	40481087		0
57916	3435	260139	1989-08-23	1989-08-23 00:00:00	1989-09-06	1989-09-06 00:00:00	32020		\N	227811	0	10509002	260139		0
58052	3440	4112343	2004-04-07	2004-04-07 00:00:00	2004-04-19	2004-04-19 00:00:00	32020		\N	228325	0	195662009	4112343		0
58224	3446	260139	2007-02-25	2007-02-25 00:00:00	2007-03-11	2007-03-11 00:00:00	32020		\N	228789	0	10509002	260139		0
58320	3455	40481087	1979-08-08	1979-08-08 00:00:00	1979-08-29	1979-08-29 00:00:00	32020		\N	229233	0	444814009	40481087		0
58535	3469	40479422	1993-03-22	1993-03-22 00:00:00	1993-04-28	1993-04-28 00:00:00	32020		\N	230254	0	444448004	40479422		0
69314	4102	4112343	1973-11-29	1973-11-29 00:00:00	1973-12-07	1973-12-07 00:00:00	32020		\N	272592	0	195662009	4112343		0
58793	3488	261325	1988-07-29	1988-07-29 00:00:00	\N	\N	32020		\N	231407	0	87433001	261325		0
58979	3501	40481087	1956-04-26	1956-04-26 00:00:00	1956-05-11	1956-05-11 00:00:00	32020		\N	232065	0	444814009	40481087		0
69786	4129	4112343	1978-04-24	1978-04-24 00:00:00	1978-05-07	1978-05-07 00:00:00	32020		\N	274520	0	195662009	4112343		0
70044	4145	4112343	1994-02-05	1994-02-05 00:00:00	1994-02-17	1994-02-17 00:00:00	32020		\N	275532	0	195662009	4112343		0
59498	3528	260139	2011-11-04	2011-11-04 00:00:00	2011-11-11	2011-11-11 00:00:00	32020		\N	234240	0	10509002	260139		0
70227	4159	4156265	2000-09-01	2000-09-01 00:00:00	2000-09-22	2000-09-22 00:00:00	32020		\N	276363	0	370247008	4156265		0
70454	4173	40481087	2007-09-12	2007-09-12 00:00:00	2007-09-26	2007-09-26 00:00:00	32020		\N	277364	0	444814009	40481087		0
70625	4190	40481087	2005-08-12	2005-08-12 00:00:00	2005-08-19	2005-08-19 00:00:00	32020		\N	278071	0	444814009	40481087		0
60241	3566	4152936	1957-03-21	1957-03-21 00:00:00	1957-04-04	1957-04-04 00:00:00	32020		\N	236949	0	283385000	4152936		0
60388	3572	257012	1967-03-28	1967-03-28 00:00:00	\N	\N	32020		\N	237448	0	40055000	257012		0
60460	3576	372328	1969-07-28	1969-07-28 00:00:00	1969-12-20	1969-12-20 00:00:00	32020		\N	237719	0	65363002	372328		0
60737	3595	40481087	2011-05-26	2011-05-26 00:00:00	2011-06-09	2011-06-09 00:00:00	32020		\N	238783	0	444814009	40481087		0
60832	3601	260139	1984-10-01	1984-10-01 00:00:00	1984-10-15	1984-10-15 00:00:00	32020		\N	239180	0	10509002	260139		0
71551	4243	372328	1969-12-23	1969-12-23 00:00:00	1970-06-26	1970-06-26 00:00:00	32020		\N	281844	0	65363002	372328		0
61205	3621	4218389	1960-05-06	1960-05-06 00:00:00	1960-05-27	1960-05-27 00:00:00	32020		\N	240631	0	39848009	4218389		0
61346	3625	4294548	1998-10-29	1998-10-29 00:00:00	1999-01-14	1999-01-14 00:00:00	32020		\N	241064	0	75498004	4294548		0
61514	3636	378001	1979-12-05	1979-12-05 00:00:00	1980-01-04	1980-01-04 00:00:00	32020		\N	241831	0	62106007	378001		0
61607	3639	260139	1998-06-27	1998-06-27 00:00:00	1998-07-04	1998-07-04 00:00:00	32020		\N	242161	0	10509002	260139		0
72429	4299	4285898	2012-12-23	2012-12-23 00:00:00	\N	\N	32020		\N	285247	0	68496003	4285898		0
72583	4312	257012	2001-10-31	2001-10-31 00:00:00	\N	\N	32020		\N	286181	0	40055000	257012		0
62235	3675	4112343	1988-10-24	1988-10-24 00:00:00	1988-11-01	1988-11-01 00:00:00	32020		\N	244446	0	195662009	4112343		0
72996	4338	260139	2014-04-26	2014-04-26 00:00:00	2014-05-10	2014-05-10 00:00:00	32020		\N	287667	0	10509002	260139		0
73043	4340	40481087	2011-03-18	2011-03-18 00:00:00	2011-04-08	2011-04-08 00:00:00	32020		\N	287778	0	444814009	40481087		0
62665	3700	40481087	2007-06-12	2007-06-12 00:00:00	2007-07-03	2007-07-03 00:00:00	32020		\N	245986	0	444814009	40481087		0
73414	4365	260139	2005-12-09	2005-12-09 00:00:00	2005-12-23	2005-12-23 00:00:00	32020		\N	289524	0	10509002	260139		0
62979	3720	40481087	1984-09-01	1984-09-01 00:00:00	1984-09-15	1984-09-15 00:00:00	32020		\N	247234	0	444814009	40481087		0
73772	4382	4310024	1991-08-17	1991-08-17 00:00:00	\N	\N	32020		\N	291182	0	424802006	4310024		0
73921	4390	372328	1962-08-19	1962-08-19 00:00:00	1962-11-30	1962-11-30 00:00:00	32020		\N	291896	0	65363002	372328		0
74064	4398	40481087	2010-12-14	2010-12-14 00:00:00	2010-12-28	2010-12-28 00:00:00	32020		\N	292453	0	444814009	40481087		0
74294	4411	4278672	2014-11-24	2014-11-24 00:00:00	2014-12-24	2014-12-24 00:00:00	32020		\N	293251	0	65966004	4278672		0
63779	3767	40481087	1987-09-12	1987-09-12 00:00:00	1987-10-03	1987-10-03 00:00:00	32020		\N	250337	0	444814009	40481087		0
64007	3783	260139	1946-03-06	1946-03-06 00:00:00	1946-03-20	1946-03-20 00:00:00	32020		\N	251426	0	10509002	260139		0
64091	3786	4109685	1991-10-01	1991-10-01 00:00:00	1991-10-15	1991-10-15 00:00:00	32020		\N	251663	0	284551006	4109685		0
53730	3179	40481087	1939-10-11	1939-10-11 00:00:00	1939-10-18	1939-10-18 00:00:00	32020		\N	211487	0	444814009	40481087		0
53876	3189	4112343	1987-12-08	1987-12-08 00:00:00	1987-12-17	1987-12-17 00:00:00	32020		\N	212232	0	195662009	4112343		0
64609	3820	80180	2005-07-23	2005-07-23 00:00:00	\N	\N	32020		\N	253678	0	396275006	80180		0
54168	3208	260139	1997-01-11	1997-01-11 00:00:00	1997-01-25	1997-01-25 00:00:00	32020		\N	213272	0	10509002	260139		0
54403	3222	40481087	1957-12-23	1957-12-23 00:00:00	1958-01-13	1958-01-13 00:00:00	32020		\N	214159	0	444814009	40481087		0
54529	3229	4112343	1999-01-15	1999-01-15 00:00:00	1999-01-26	1999-01-26 00:00:00	32020		\N	214592	0	195662009	4112343		0
54733	3240	4112343	2005-05-11	2005-05-11 00:00:00	2005-05-24	2005-05-24 00:00:00	32020		\N	215353	0	195662009	4112343		0
54902	3249	4156265	1988-07-01	1988-07-01 00:00:00	1988-07-15	1988-07-15 00:00:00	32020		\N	215988	0	370247008	4156265		0
65637	3881	4134304	1960-11-27	1960-11-27 00:00:00	1961-01-26	1961-01-26 00:00:00	32020		\N	257918	0	263102004	4134304		0
65822	3891	4112343	2018-09-19	2018-09-19 00:00:00	2018-10-01	2018-10-01 00:00:00	32020		\N	258696	0	195662009	4112343		0
55415	3283	4237458	1981-02-28	1981-02-28 00:00:00	1981-05-29	1981-05-29 00:00:00	32020		\N	218106	0	58150001	4237458		0
55582	3293	4294548	1927-02-24	1927-02-24 00:00:00	1927-03-17	1927-03-17 00:00:00	32020		\N	218699	0	75498004	4294548		0
55764	3301	260139	1985-01-27	1985-01-27 00:00:00	1985-02-10	1985-02-10 00:00:00	32020		\N	219266	0	10509002	260139		0
55856	3307	378001	1967-10-12	1967-10-12 00:00:00	1967-12-10	1967-12-10 00:00:00	32020		\N	219552	0	62106007	378001		0
66642	3943	4112343	2005-11-22	2005-11-22 00:00:00	2005-11-29	2005-11-29 00:00:00	32020		\N	262169	0	195662009	4112343		0
66742	3950	192671	2015-01-14	2015-01-14 00:00:00	\N	\N	32020		\N	262576	0	K92.2	35208414		0
66911	3957	378001	1983-05-28	1983-05-28 00:00:00	1983-07-27	1983-07-27 00:00:00	32020		\N	263145	0	62106007	378001		0
56573	3355	40481087	1971-03-25	1971-03-25 00:00:00	1971-04-08	1971-04-08 00:00:00	32020		\N	222478	0	444814009	40481087		0
67363	3982	4112343	1988-02-11	1988-02-11 00:00:00	1988-02-22	1988-02-22 00:00:00	32020		\N	264752	0	195662009	4112343		0
67405	3984	4112343	1958-04-04	1958-04-04 00:00:00	1958-04-13	1958-04-13 00:00:00	32020		\N	264820	0	195662009	4112343		0
57062	3386	40481087	2005-12-06	2005-12-06 00:00:00	2005-12-13	2005-12-13 00:00:00	32020		\N	224634	0	444814009	40481087		0
57167	3392	40481087	1984-09-15	1984-09-15 00:00:00	1984-10-06	1984-10-06 00:00:00	32020		\N	224968	0	444814009	40481087		0
57435	3409	372328	1960-08-18	1960-08-18 00:00:00	1961-04-13	1961-04-13 00:00:00	32020		\N	226062	0	65363002	372328		0
57579	3415	80180	2005-04-14	2005-04-14 00:00:00	\N	\N	32020		\N	226529	0	396275006	80180		0
68248	4032	40481087	1971-11-09	1971-11-09 00:00:00	1971-11-30	1971-11-30 00:00:00	32020		\N	268278	0	444814009	40481087		0
57917	3435	40481087	1987-05-22	1987-05-22 00:00:00	1987-06-12	1987-06-12 00:00:00	32020		\N	227797	0	444814009	40481087		0
58053	3440	4152936	2004-12-22	2004-12-22 00:00:00	2005-01-05	2005-01-05 00:00:00	32020		\N	228229	0	283385000	4152936		0
58226	3446	40481087	1998-05-17	1998-05-17 00:00:00	1998-06-07	1998-06-07 00:00:00	32020		\N	228767	0	444814009	40481087		0
58321	3455	4112343	1991-03-17	1991-03-17 00:00:00	1991-03-26	1991-03-26 00:00:00	32020		\N	229202	0	195662009	4112343		0
58536	3469	372328	2001-11-30	2001-11-30 00:00:00	2002-10-02	2002-10-02 00:00:00	32020		\N	230243	0	65363002	372328		0
69315	4102	40479422	1997-09-19	1997-09-19 00:00:00	1997-10-26	1997-10-26 00:00:00	32020		\N	272581	0	444448004	40479422		0
58794	3488	40481087	1974-01-22	1974-01-22 00:00:00	1974-02-05	1974-02-05 00:00:00	32020		\N	231342	0	444814009	40481087		0
58980	3501	260139	1961-05-15	1961-05-15 00:00:00	1961-05-22	1961-05-22 00:00:00	32020		\N	232121	0	10509002	260139		0
69787	4129	4112343	2018-11-16	2018-11-16 00:00:00	2018-11-26	2018-11-26 00:00:00	32020		\N	274510	0	195662009	4112343		0
70045	4145	4112343	1983-08-23	1983-08-23 00:00:00	1983-08-30	1983-08-30 00:00:00	32020		\N	275494	0	195662009	4112343		0
59499	3528	80180	1998-03-13	1998-03-13 00:00:00	\N	\N	32020		\N	234282	0	396275006	80180		0
70228	4159	4059173	1972-10-30	1972-10-30 00:00:00	1973-01-28	1973-01-28 00:00:00	32020		\N	276384	0	16114001	4059173		0
70455	4173	40481087	1997-01-11	1997-01-11 00:00:00	1997-02-01	1997-02-01 00:00:00	32020		\N	277308	0	444814009	40481087		0
70626	4190	80180	2013-08-09	2013-08-09 00:00:00	\N	\N	32020		\N	278111	0	396275006	80180		0
60242	3566	4112343	1963-08-23	1963-08-23 00:00:00	1963-09-05	1963-09-05 00:00:00	32020		\N	236918	0	195662009	4112343		0
60389	3572	372328	1958-07-22	1958-07-22 00:00:00	1958-08-27	1958-08-27 00:00:00	32020		\N	237482	0	65363002	372328		0
60461	3576	4109685	1991-04-04	1991-04-04 00:00:00	1991-04-25	1991-04-25 00:00:00	32020		\N	237712	0	284551006	4109685		0
60738	3595	78272	1989-08-08	1989-08-08 00:00:00	1989-09-12	1989-09-12 00:00:00	32020		\N	238833	0	70704007	78272		0
60833	3601	4084167	1976-03-25	1976-03-25 00:00:00	1976-03-25	1976-03-25 00:00:00	32020		\N	239219	0	241929008	4084167		0
71552	4243	4109685	1987-02-08	1987-02-08 00:00:00	1987-02-22	1987-02-22 00:00:00	32020		\N	281802	0	284551006	4109685		0
61206	3621	4112343	1950-09-19	1950-09-19 00:00:00	1950-10-02	1950-10-02 00:00:00	32020		\N	240620	0	195662009	4112343		0
61347	3625	4112343	1981-04-08	1981-04-08 00:00:00	1981-04-18	1981-04-18 00:00:00	32020		\N	241120	0	195662009	4112343		0
61515	3636	4294548	1994-03-27	1994-03-27 00:00:00	1994-05-08	1994-05-08 00:00:00	32020		\N	241807	0	75498004	4294548		0
61608	3639	4283893	1973-10-22	1973-10-22 00:00:00	1974-05-06	1974-05-06 00:00:00	32020		\N	242166	0	36971009	4283893		0
72430	4299	40481087	2012-12-18	2012-12-18 00:00:00	2013-01-01	2013-01-01 00:00:00	32020		\N	285247	0	444814009	40481087		0
72584	4312	133834	1961-02-14	1961-02-14 00:00:00	1977-06-17	1977-06-17 00:00:00	32020		\N	286107	0	24079001	133834		0
62236	3675	40481087	2014-06-24	2014-06-24 00:00:00	2014-07-15	2014-07-15 00:00:00	32020		\N	244414	0	444814009	40481087		0
72997	4338	78272	1993-01-28	1993-01-28 00:00:00	1993-02-25	1993-02-25 00:00:00	32020		\N	287672	0	70704007	78272		0
73044	4340	192671	2010-04-28	2010-04-28 00:00:00	\N	\N	32020		\N	287783	0	K92.2	35208414		0
62666	3700	40481087	1991-04-20	1991-04-20 00:00:00	1991-05-11	1991-05-11 00:00:00	32020		\N	246004	0	444814009	40481087		0
73415	4365	372328	1963-06-11	1963-06-11 00:00:00	1964-05-04	1964-05-04 00:00:00	32020		\N	289564	0	65363002	372328		0
62980	3720	4112343	1963-02-20	1963-02-20 00:00:00	1963-03-05	1963-03-05 00:00:00	32020		\N	247292	0	195662009	4112343		0
73773	4382	260139	1965-06-16	1965-06-16 00:00:00	1965-06-30	1965-06-30 00:00:00	32020		\N	291266	0	10509002	260139		0
73922	4390	40481087	1970-05-31	1970-05-31 00:00:00	1970-06-21	1970-06-21 00:00:00	32020		\N	291815	0	444814009	40481087		0
74295	4411	4283893	2006-12-23	2006-12-23 00:00:00	2007-05-12	2007-05-12 00:00:00	32020		\N	293184	0	36971009	4283893		0
63780	3767	80180	2018-10-20	2018-10-20 00:00:00	\N	\N	32020		\N	250352	0	396275006	80180		0
64008	3783	195588	1999-04-05	1999-04-05 00:00:00	1999-05-11	1999-05-11 00:00:00	32020		\N	251331	0	38822007	195588		0
64092	3786	40481087	1966-09-30	1966-09-30 00:00:00	1966-10-14	1966-10-14 00:00:00	32020		\N	251668	0	444814009	40481087		0
53731	3179	381316	1987-05-23	1987-05-23 00:00:00	\N	\N	32020		\N	211539	0	230690007	381316		0
53877	3189	440086	1973-06-14	1973-06-14 00:00:00	1975-01-02	1975-01-02 00:00:00	32020		\N	212219	0	192127007	440086		0
64610	3820	4155034	2002-12-25	2002-12-25 00:00:00	2003-01-08	2003-01-08 00:00:00	32020		\N	253654	0	283371005	4155034		0
54172	3211	4218389	1992-02-07	1992-02-07 00:00:00	1992-03-06	1992-03-06 00:00:00	32020		\N	213362	0	39848009	4218389		0
54404	3222	375671	1993-11-17	1993-11-17 00:00:00	1993-12-17	1993-12-17 00:00:00	32020		\N	214155	0	62564004	375671		0
54530	3229	4294548	2000-12-20	2000-12-20 00:00:00	2001-01-24	2001-01-24 00:00:00	32020		\N	214627	0	75498004	4294548		0
54734	3240	4296204	2000-02-05	2000-02-05 00:00:00	2000-02-26	2000-02-26 00:00:00	32020		\N	215437	0	403190006	4296204		0
54903	3249	372328	1959-06-12	1959-06-12 00:00:00	1959-12-20	1959-12-20 00:00:00	32020		\N	215970	0	65363002	372328		0
65638	3881	40481087	1977-08-24	1977-08-24 00:00:00	1977-09-14	1977-09-14 00:00:00	32020		\N	257883	0	444814009	40481087		0
65823	3891	4237458	1986-11-03	1986-11-03 00:00:00	1987-01-02	1987-01-02 00:00:00	32020		\N	258751	0	58150001	4237458		0
55416	3283	40481087	2002-07-16	2002-07-16 00:00:00	2002-07-30	2002-07-30 00:00:00	32020		\N	218139	0	444814009	40481087		0
55583	3293	40481087	1995-02-12	1995-02-12 00:00:00	1995-02-19	1995-02-19 00:00:00	32020		\N	218664	0	444814009	40481087		0
55765	3301	40481087	2010-01-29	2010-01-29 00:00:00	2010-02-05	2010-02-05 00:00:00	32020		\N	219339	0	444814009	40481087		0
55857	3307	4237458	1975-08-31	1975-08-31 00:00:00	1975-09-30	1975-09-30 00:00:00	32020		\N	219554	0	58150001	4237458		0
66643	3943	4112343	1983-11-26	1983-11-26 00:00:00	1983-12-05	1983-12-05 00:00:00	32020		\N	262176	0	195662009	4112343		0
66743	3950	372328	1979-09-14	1979-09-14 00:00:00	1980-09-04	1980-09-04 00:00:00	32020		\N	262577	0	65363002	372328		0
66912	3957	4112343	1964-03-10	1964-03-10 00:00:00	1964-03-18	1964-03-18 00:00:00	32020		\N	263134	0	195662009	4112343		0
56574	3355	40481087	2004-03-09	2004-03-09 00:00:00	2004-03-30	2004-03-30 00:00:00	32020		\N	222496	0	444814009	40481087		0
67364	3982	40481087	1987-12-10	1987-12-10 00:00:00	1987-12-31	1987-12-31 00:00:00	32020		\N	264656	0	444814009	40481087		0
67406	3984	4146173	2011-09-28	2011-09-28 00:00:00	2011-10-28	2011-10-28 00:00:00	32020		\N	264803	0	307731004	4146173		0
57063	3386	28060	2012-04-06	2012-04-06 00:00:00	2012-04-17	2012-04-17 00:00:00	32020		\N	224636	0	43878008	28060		0
57168	3392	372328	1974-11-10	1974-11-10 00:00:00	1974-11-24	1974-11-24 00:00:00	32020		\N	224970	0	65363002	372328		0
57436	3409	80180	1999-08-19	1999-08-19 00:00:00	\N	\N	32020		\N	226105	0	396275006	80180		0
57580	3415	40481087	1972-08-05	1972-08-05 00:00:00	1972-08-26	1972-08-26 00:00:00	32020		\N	226546	0	444814009	40481087		0
68249	4032	257012	1950-02-06	1950-02-06 00:00:00	\N	\N	32020		\N	268276	0	40055000	257012		0
57918	3435	4278672	2019-05-22	2019-05-22 00:00:00	\N	\N	32020		\N	227831	0	65966004	4278672		0
58054	3440	40481087	1965-11-09	1965-11-09 00:00:00	1965-11-16	1965-11-16 00:00:00	32020		\N	228277	0	444814009	40481087		0
58227	3446	80180	1989-02-19	1989-02-19 00:00:00	\N	\N	32020		\N	228759	0	396275006	80180		0
58322	3455	4296205	2012-08-08	2012-08-08 00:00:00	2012-08-29	2012-08-29 00:00:00	32020		\N	229260	0	403191005	4296205		0
58537	3469	4112343	1968-08-20	1968-08-20 00:00:00	1968-09-02	1968-09-02 00:00:00	32020		\N	230296	0	195662009	4112343		0
69316	4102	4155034	1977-11-12	1977-11-12 00:00:00	1977-12-03	1977-12-03 00:00:00	32020		\N	272579	0	283371005	4155034		0
58795	3488	40481087	2000-09-18	2000-09-18 00:00:00	2000-09-25	2000-09-25 00:00:00	32020		\N	231385	0	444814009	40481087		0
58981	3501	4146173	2005-02-03	2005-02-03 00:00:00	2005-03-05	2005-03-05 00:00:00	32020		\N	232090	0	307731004	4146173		0
69788	4129	28060	1955-03-05	1955-03-05 00:00:00	1955-03-15	1955-03-15 00:00:00	32020		\N	274444	0	43878008	28060		0
70046	4145	80180	2009-07-18	2009-07-18 00:00:00	\N	\N	32020		\N	275511	0	396275006	80180		0
59500	3528	81151	1997-07-09	1997-07-09 00:00:00	1997-08-06	1997-08-06 00:00:00	32020		\N	234282	0	44465007	81151		0
70229	4159	378001	1975-12-14	1975-12-14 00:00:00	1976-01-13	1976-01-13 00:00:00	32020		\N	276385	0	62106007	378001		0
70456	4173	372328	1977-02-18	1977-02-18 00:00:00	1977-06-08	1977-06-08 00:00:00	32020		\N	277344	0	65363002	372328		0
70627	4190	40481087	2002-08-02	2002-08-02 00:00:00	2002-08-23	2002-08-23 00:00:00	32020		\N	278113	0	444814009	40481087		0
60243	3566	4112343	1979-07-17	1979-07-17 00:00:00	1979-07-28	1979-07-28 00:00:00	32020		\N	236831	0	195662009	4112343		0
60390	3572	4155034	1975-01-11	1975-01-11 00:00:00	1975-02-01	1975-02-01 00:00:00	32020		\N	237442	0	283371005	4155034		0
60462	3576	260139	1992-03-25	1992-03-25 00:00:00	1992-04-01	1992-04-01 00:00:00	32020		\N	237716	0	10509002	260139		0
60739	3595	40481087	2006-12-20	2006-12-20 00:00:00	2006-12-27	2006-12-27 00:00:00	32020		\N	238838	0	444814009	40481087		0
60834	3601	40486433	1964-06-24	1964-06-24 00:00:00	\N	\N	32020		\N	239133	0	446096008	40486433		0
71553	4243	4112343	1998-09-01	1998-09-01 00:00:00	1998-09-10	1998-09-10 00:00:00	32020		\N	281840	0	195662009	4112343		0
61207	3621	4112343	1956-06-06	1956-06-06 00:00:00	1956-06-19	1956-06-19 00:00:00	32020		\N	240609	0	195662009	4112343		0
61348	3625	4112343	1962-04-15	1962-04-15 00:00:00	1962-04-22	1962-04-22 00:00:00	32020		\N	241061	0	195662009	4112343		0
61516	3636	28060	1993-03-12	1993-03-12 00:00:00	1993-03-21	1993-03-21 00:00:00	32020		\N	241836	0	43878008	28060		0
61609	3639	4112343	1958-03-05	1958-03-05 00:00:00	1958-03-12	1958-03-12 00:00:00	32020		\N	242028	0	195662009	4112343		0
72431	4299	80180	2013-08-20	2013-08-20 00:00:00	\N	\N	32020		\N	285247	0	396275006	80180		0
72585	4312	4109685	1989-09-08	1989-09-08 00:00:00	1989-09-29	1989-09-29 00:00:00	32020		\N	286124	0	284551006	4109685		0
62237	3675	4112343	2012-07-22	2012-07-22 00:00:00	2012-07-30	2012-07-30 00:00:00	32020		\N	244435	0	195662009	4112343		0
72998	4338	4294548	1979-03-23	1979-03-23 00:00:00	1979-05-18	1979-05-18 00:00:00	32020		\N	287673	0	75498004	4294548		0
73045	4340	4112343	2005-06-05	2005-06-05 00:00:00	2005-06-13	2005-06-13 00:00:00	32020		\N	287770	0	195662009	4112343		0
62667	3701	40481087	2005-02-22	2005-02-22 00:00:00	2005-03-08	2005-03-08 00:00:00	32020		\N	246042	0	444814009	40481087		0
73416	4365	4146173	1990-04-04	1990-04-04 00:00:00	1990-06-03	1990-06-03 00:00:00	32020		\N	289521	0	307731004	4146173		0
62981	3720	260139	2008-05-09	2008-05-09 00:00:00	2008-05-16	2008-05-16 00:00:00	32020		\N	247287	0	10509002	260139		0
73774	4382	28060	1974-10-07	1974-10-07 00:00:00	1974-10-15	1974-10-15 00:00:00	32020		\N	291181	0	43878008	28060		0
73923	4390	192671	1994-11-21	1994-11-21 00:00:00	\N	\N	32020		\N	291912	0	K92.2	35208414		0
74066	4398	4218389	1998-04-28	1998-04-28 00:00:00	1998-05-26	1998-05-26 00:00:00	32020		\N	292435	0	39848009	4218389		0
74296	4411	40481087	2011-08-24	2011-08-24 00:00:00	2011-09-07	2011-09-07 00:00:00	32020		\N	293191	0	444814009	40481087		0
63781	3767	28060	2017-09-20	2017-09-20 00:00:00	2017-10-02	2017-10-02 00:00:00	32020		\N	250352	0	43878008	28060		0
64009	3783	40481087	2015-02-26	2015-02-26 00:00:00	2015-03-12	2015-03-12 00:00:00	32020		\N	251304	0	444814009	40481087		0
64093	3786	4112343	1981-09-11	1981-09-11 00:00:00	1981-09-21	1981-09-21 00:00:00	32020		\N	251711	0	195662009	4112343		0
53732	3179	4112343	1933-11-15	1933-11-15 00:00:00	1933-11-23	1933-11-23 00:00:00	32020		\N	211512	0	195662009	4112343		0
53878	3189	4109685	1973-01-05	1973-01-05 00:00:00	1973-01-26	1973-01-26 00:00:00	32020		\N	212270	0	284551006	4109685		0
64622	3822	260139	1972-08-31	1972-08-31 00:00:00	1972-09-14	1972-09-14 00:00:00	32020		\N	253879	0	10509002	260139		0
54173	3211	4112343	1998-04-19	1998-04-19 00:00:00	1998-04-26	1998-04-26 00:00:00	32020		\N	213367	0	195662009	4112343		0
54405	3222	257012	1964-10-07	1964-10-07 00:00:00	\N	\N	32020		\N	214160	0	40055000	257012		0
54531	3229	4283893	2018-05-25	2018-05-25 00:00:00	2018-06-15	2018-06-15 00:00:00	32020		\N	214628	0	36971009	4283893		0
54735	3240	40481087	1977-01-13	1977-01-13 00:00:00	1977-01-27	1977-01-27 00:00:00	32020		\N	215344	0	444814009	40481087		0
54904	3249	4112343	2012-12-22	2012-12-22 00:00:00	2013-01-03	2013-01-03 00:00:00	32020		\N	215951	0	195662009	4112343		0
65639	3881	40481087	1981-04-24	1981-04-24 00:00:00	1981-05-01	1981-05-01 00:00:00	32020		\N	257888	0	444814009	40481087		0
65824	3891	40481087	1996-03-26	1996-03-26 00:00:00	1996-04-16	1996-04-16 00:00:00	32020		\N	258757	0	444814009	40481087		0
55417	3283	260139	2001-12-12	2001-12-12 00:00:00	2001-12-19	2001-12-19 00:00:00	32020		\N	218111	0	10509002	260139		0
55584	3293	372328	1994-03-23	1994-03-23 00:00:00	1994-05-21	1994-05-21 00:00:00	32020		\N	218712	0	65363002	372328		0
55766	3301	4112343	1992-12-30	1992-12-30 00:00:00	1993-01-08	1993-01-08 00:00:00	32020		\N	219332	0	195662009	4112343		0
55858	3307	40481087	1968-01-17	1968-01-17 00:00:00	1968-01-24	1968-01-24 00:00:00	32020		\N	219551	0	444814009	40481087		0
66644	3943	78272	1961-09-24	1961-09-24 00:00:00	1961-10-15	1961-10-15 00:00:00	32020		\N	262135	0	70704007	78272		0
66744	3950	4152936	1979-06-07	1979-06-07 00:00:00	1979-06-28	1979-06-28 00:00:00	32020		\N	262523	0	283385000	4152936		0
66913	3957	4116491	2002-09-10	2002-09-10 00:00:00	2002-10-25	2002-10-25 00:00:00	32020		\N	263049	0	301011002	4116491		0
56575	3355	4112343	1997-10-07	1997-10-07 00:00:00	1997-10-16	1997-10-16 00:00:00	32020		\N	222495	0	195662009	4112343		0
67365	3982	4112343	2016-06-26	2016-06-26 00:00:00	2016-07-09	2016-07-09 00:00:00	32020		\N	264658	0	195662009	4112343		0
67407	3984	78272	1970-06-25	1970-06-25 00:00:00	1970-07-30	1970-07-30 00:00:00	32020		\N	264885	0	70704007	78272		0
57064	3386	80180	2007-09-08	2007-09-08 00:00:00	\N	\N	32020		\N	224619	0	396275006	80180		0
57169	3392	40481087	1974-01-28	1974-01-28 00:00:00	1974-02-18	1974-02-18 00:00:00	32020		\N	224959	0	444814009	40481087		0
67908	4013	40481087	1984-12-26	1984-12-26 00:00:00	1985-01-16	1985-01-16 00:00:00	32020		\N	266641	0	444814009	40481087		0
57581	3415	4112343	1991-08-19	1991-08-19 00:00:00	1991-09-01	1991-09-01 00:00:00	32020		\N	226548	0	195662009	4112343		0
68250	4032	260139	2002-11-03	2002-11-03 00:00:00	2002-11-10	2002-11-10 00:00:00	32020		\N	268282	0	10509002	260139		0
57919	3435	4218389	1983-11-08	1983-11-08 00:00:00	1983-12-06	1983-12-06 00:00:00	32020		\N	227833	0	39848009	4218389		0
58055	3440	140673	2015-02-20	2015-02-20 00:00:00	\N	\N	32020		\N	228239	0	40930008	140673		0
58228	3446	4112343	1982-11-22	1982-11-22 00:00:00	1982-12-03	1982-12-03 00:00:00	32020		\N	228787	0	195662009	4112343		0
58323	3455	40481087	1971-02-21	1971-02-21 00:00:00	1971-03-14	1971-03-14 00:00:00	32020		\N	229249	0	444814009	40481087		0
58538	3469	40481087	2000-01-13	2000-01-13 00:00:00	2000-01-20	2000-01-20 00:00:00	32020		\N	230222	0	444814009	40481087		0
69317	4102	4146173	1983-12-02	1983-12-02 00:00:00	1984-01-01	1984-01-01 00:00:00	32020		\N	272619	0	307731004	4146173		0
58796	3488	4112343	1966-06-29	1966-06-29 00:00:00	1966-07-06	1966-07-06 00:00:00	32020		\N	231381	0	195662009	4112343		0
58982	3501	260139	1949-11-24	1949-11-24 00:00:00	1949-12-01	1949-12-01 00:00:00	32020		\N	232119	0	10509002	260139		0
69789	4129	4113008	1992-04-05	1992-04-05 00:00:00	1992-04-26	1992-04-26 00:00:00	32020		\N	274463	0	284549007	4113008		0
70047	4145	134438	2006-07-06	2006-07-06 00:00:00	2008-04-02	2008-04-02 00:00:00	32020		\N	275512	0	40275004	134438		0
59501	3528	260139	1961-12-19	1961-12-19 00:00:00	1962-01-02	1962-01-02 00:00:00	32020		\N	234243	0	10509002	260139		0
70230	4159	4116491	2015-01-13	2015-01-13 00:00:00	2015-03-07	2015-03-07 00:00:00	32020		\N	276333	0	301011002	4116491		0
70457	4173	28060	1974-03-03	1974-03-03 00:00:00	1974-03-11	1974-03-11 00:00:00	32020		\N	277369	0	43878008	28060		0
70628	4190	4109685	2000-08-23	2000-08-23 00:00:00	2000-09-13	2000-09-13 00:00:00	32020		\N	278065	0	284551006	4109685		0
60244	3566	4218389	1975-10-27	1975-10-27 00:00:00	1975-12-01	1975-12-01 00:00:00	32020		\N	236950	0	39848009	4218389		0
60391	3572	381316	2014-04-09	2014-04-09 00:00:00	\N	\N	32020		\N	237477	0	230690007	381316		0
60463	3576	40481087	1995-08-17	1995-08-17 00:00:00	1995-08-24	1995-08-24 00:00:00	32020		\N	237717	0	444814009	40481087		0
60740	3595	372328	1952-07-16	1952-07-16 00:00:00	1952-09-18	1952-09-18 00:00:00	32020		\N	238839	0	65363002	372328		0
60835	3601	4113008	1992-06-26	1992-06-26 00:00:00	1992-07-10	1992-07-10 00:00:00	32020		\N	239224	0	284549007	4113008		0
71554	4243	40481087	1979-11-30	1979-11-30 00:00:00	1979-12-07	1979-12-07 00:00:00	32020		\N	281825	0	444814009	40481087		0
61208	3621	260139	1930-01-23	1930-01-23 00:00:00	1930-01-30	1930-01-30 00:00:00	32020		\N	240591	0	10509002	260139		0
61349	3625	4294548	1975-03-10	1975-03-10 00:00:00	1975-05-12	1975-05-12 00:00:00	32020		\N	241076	0	75498004	4294548		0
61517	3636	40481087	2001-06-07	2001-06-07 00:00:00	2001-06-14	2001-06-14 00:00:00	32020		\N	241857	0	444814009	40481087		0
61610	3639	40481087	1980-03-09	1980-03-09 00:00:00	1980-03-23	1980-03-23 00:00:00	32020		\N	242170	0	444814009	40481087		0
72432	4299	40481087	1974-10-09	1974-10-09 00:00:00	1974-10-16	1974-10-16 00:00:00	32020		\N	285270	0	444814009	40481087		0
72586	4312	372328	1959-12-15	1959-12-15 00:00:00	1960-02-24	1960-02-24 00:00:00	32020		\N	286056	0	65363002	372328		0
62238	3675	40481087	1987-01-07	1987-01-07 00:00:00	1987-01-21	1987-01-21 00:00:00	32020		\N	244475	0	444814009	40481087		0
72999	4338	4112343	1983-08-23	1983-08-23 00:00:00	1983-09-05	1983-09-05 00:00:00	32020		\N	287687	0	195662009	4112343		0
73055	4342	80180	1993-02-16	1993-02-16 00:00:00	\N	\N	32020		\N	287884	0	396275006	80180		0
62668	3701	4112343	2011-11-07	2011-11-07 00:00:00	2011-11-18	2011-11-18 00:00:00	32020		\N	246081	0	195662009	4112343		0
73417	4365	40481087	1971-10-31	1971-10-31 00:00:00	1971-11-13	1971-11-13 00:00:00	32020		\N	289518	0	444814009	40481087		0
62982	3720	4155034	2013-01-01	2013-01-01 00:00:00	2013-01-15	2013-01-15 00:00:00	32020		\N	247321	0	283371005	4155034		0
73775	4382	4112343	2007-06-10	2007-06-10 00:00:00	2007-06-23	2007-06-23 00:00:00	32020		\N	291256	0	195662009	4112343		0
73924	4390	4112343	2000-09-30	2000-09-30 00:00:00	2000-10-07	2000-10-07 00:00:00	32020		\N	291920	0	195662009	4112343		0
74067	4398	260139	1996-09-05	1996-09-05 00:00:00	1996-09-19	1996-09-19 00:00:00	32020		\N	292448	0	10509002	260139		0
74297	4411	80180	1984-01-22	1984-01-22 00:00:00	\N	\N	32020		\N	293271	0	396275006	80180		0
63782	3767	378001	2013-11-15	2013-11-15 00:00:00	2014-01-14	2014-01-14 00:00:00	32020		\N	250386	0	62106007	378001		0
64010	3783	260139	1982-08-16	1982-08-16 00:00:00	1982-08-23	1982-08-23 00:00:00	32020		\N	251368	0	10509002	260139		0
64094	3786	40481087	1996-08-19	1996-08-19 00:00:00	1996-08-26	1996-08-26 00:00:00	32020		\N	251671	0	444814009	40481087		0
53733	3179	255848	2002-02-14	2002-02-14 00:00:00	\N	\N	32020		\N	211482	0	233604007	255848		0
53879	3189	80180	2000-03-29	2000-03-29 00:00:00	\N	\N	32020		\N	212300	0	396275006	80180		0
64623	3822	4294548	1980-05-06	1980-05-06 00:00:00	1980-05-27	1980-05-27 00:00:00	32020		\N	253883	0	75498004	4294548		0
54174	3211	40481087	1989-07-07	1989-07-07 00:00:00	1989-07-14	1989-07-14 00:00:00	32020		\N	213341	0	444814009	40481087		0
54406	3222	372328	1956-04-19	1956-04-19 00:00:00	1956-12-18	1956-12-18 00:00:00	32020		\N	214220	0	65363002	372328		0
54532	3230	4283893	2002-09-03	2002-09-03 00:00:00	2002-11-05	2002-11-05 00:00:00	32020		\N	214656	0	36971009	4283893		0
54736	3240	40481087	1959-05-27	1959-05-27 00:00:00	1959-06-03	1959-06-03 00:00:00	32020		\N	215409	0	444814009	40481087		0
54905	3249	80180	2002-02-18	2002-02-18 00:00:00	\N	\N	32020		\N	215983	0	396275006	80180		0
65640	3881	28060	1958-07-14	1958-07-14 00:00:00	1958-07-25	1958-07-25 00:00:00	32020		\N	257943	0	43878008	28060		0
65825	3892	40481087	1977-01-07	1977-01-07 00:00:00	1977-01-21	1977-01-21 00:00:00	32020		\N	258822	0	444814009	40481087		0
55418	3283	4059173	2018-10-12	2018-10-12 00:00:00	2018-11-11	2018-11-11 00:00:00	32020		\N	218108	0	16114001	4059173		0
55585	3293	4278672	2000-10-17	2000-10-17 00:00:00	2000-12-16	2000-12-16 00:00:00	32020		\N	218696	0	65966004	4278672		0
55767	3301	40481087	1991-12-03	1991-12-03 00:00:00	1991-12-17	1991-12-17 00:00:00	32020		\N	219307	0	444814009	40481087		0
55859	3307	4112343	1967-07-16	1967-07-16 00:00:00	1967-07-28	1967-07-28 00:00:00	32020		\N	219550	0	195662009	4112343		0
66645	3943	80180	1990-07-24	1990-07-24 00:00:00	\N	\N	32020		\N	262187	0	396275006	80180		0
66745	3950	260139	2001-12-11	2001-12-11 00:00:00	2001-12-25	2001-12-25 00:00:00	32020		\N	262591	0	10509002	260139		0
66914	3957	40481087	1993-12-01	1993-12-01 00:00:00	1993-12-22	1993-12-22 00:00:00	32020		\N	263118	0	444814009	40481087		0
56576	3355	372328	1963-05-03	1963-05-03 00:00:00	1963-06-14	1963-06-14 00:00:00	32020		\N	222465	0	65363002	372328		0
67366	3982	28060	1965-02-20	1965-02-20 00:00:00	1965-02-27	1965-02-27 00:00:00	32020		\N	264654	0	43878008	28060		0
67408	3984	260139	2008-10-16	2008-10-16 00:00:00	2008-10-30	2008-10-30 00:00:00	32020		\N	264844	0	10509002	260139		0
57065	3386	40481087	2006-07-18	2006-07-18 00:00:00	2006-07-25	2006-07-25 00:00:00	32020		\N	224619	0	444814009	40481087		0
57187	3394	260139	2003-12-01	2003-12-01 00:00:00	2003-12-08	2003-12-08 00:00:00	32020		\N	225165	0	10509002	260139		0
67909	4013	372328	1980-04-25	1980-04-25 00:00:00	1980-11-02	1980-11-02 00:00:00	32020		\N	266684	0	65363002	372328		0
57582	3415	260139	1992-01-28	1992-01-28 00:00:00	1992-02-04	1992-02-04 00:00:00	32020		\N	226519	0	10509002	260139		0
68251	4032	260139	2001-05-22	2001-05-22 00:00:00	2001-06-05	2001-06-05 00:00:00	32020		\N	268281	0	10509002	260139		0
57920	3435	4112343	1994-02-18	1994-02-18 00:00:00	1994-03-02	1994-03-02 00:00:00	32020		\N	227776	0	195662009	4112343		0
58056	3440	4296205	1959-01-10	1959-01-10 00:00:00	1959-01-24	1959-01-24 00:00:00	32020		\N	228293	0	403191005	4296205		0
58229	3446	81151	1995-11-02	1995-11-02 00:00:00	1995-11-16	1995-11-16 00:00:00	32020		\N	228784	0	44465007	81151		0
58324	3455	4029498	1991-05-21	1991-05-21 00:00:00	\N	\N	32020		\N	229257	0	128613002	4029498		0
58539	3469	40481087	2010-07-01	2010-07-01 00:00:00	2010-07-22	2010-07-22 00:00:00	32020		\N	230212	0	444814009	40481087		0
69318	4102	260139	1969-09-28	1969-09-28 00:00:00	1969-10-05	1969-10-05 00:00:00	32020		\N	272590	0	10509002	260139		0
58797	3488	372328	1954-04-20	1954-04-20 00:00:00	1954-05-28	1954-05-28 00:00:00	32020		\N	231345	0	65363002	372328		0
58983	3501	4112343	1949-12-25	1949-12-25 00:00:00	1950-01-07	1950-01-07 00:00:00	32020		\N	232064	0	195662009	4112343		0
69790	4129	40481087	2008-05-14	2008-05-14 00:00:00	2008-05-28	2008-05-28 00:00:00	32020		\N	274449	0	444814009	40481087		0
70048	4145	40481087	1995-06-29	1995-06-29 00:00:00	1995-07-13	1995-07-13 00:00:00	32020		\N	275496	0	444814009	40481087		0
59502	3528	81151	1993-08-31	1993-08-31 00:00:00	1993-09-28	1993-09-28 00:00:00	32020		\N	234281	0	44465007	81151		0
70231	4159	80180	1991-10-06	1991-10-06 00:00:00	\N	\N	32020		\N	276362	0	396275006	80180		0
70458	4173	260139	1983-01-03	1983-01-03 00:00:00	1983-01-10	1983-01-10 00:00:00	32020		\N	277362	0	10509002	260139		0
70629	4190	40481087	2009-09-04	2009-09-04 00:00:00	2009-09-18	2009-09-18 00:00:00	32020		\N	278114	0	444814009	40481087		0
60245	3566	4112343	1982-06-29	1982-06-29 00:00:00	1982-07-09	1982-07-09 00:00:00	32020		\N	236870	0	195662009	4112343		0
60392	3572	40481087	1999-06-22	1999-06-22 00:00:00	1999-07-06	1999-07-06 00:00:00	32020		\N	237480	0	444814009	40481087		0
60464	3576	4112343	1978-07-13	1978-07-13 00:00:00	1978-07-24	1978-07-24 00:00:00	32020		\N	237714	0	195662009	4112343		0
60741	3595	81151	1951-05-04	1951-05-04 00:00:00	1951-06-08	1951-06-08 00:00:00	32020		\N	238829	0	44465007	81151		0
60836	3601	40481087	2003-05-13	2003-05-13 00:00:00	2003-05-27	2003-05-27 00:00:00	32020		\N	239247	0	444814009	40481087		0
71555	4243	260139	1989-12-26	1989-12-26 00:00:00	1990-01-09	1990-01-09 00:00:00	32020		\N	281850	0	10509002	260139		0
61209	3621	4142905	1989-01-16	1989-01-16 00:00:00	1989-03-17	1989-03-17 00:00:00	32020		\N	240634	0	33737001	4142905		0
61350	3625	372328	1954-06-09	1954-06-09 00:00:00	1954-09-21	1954-09-21 00:00:00	32020		\N	241085	0	65363002	372328		0
61518	3636	440086	1985-07-11	1985-07-11 00:00:00	1986-05-08	1986-05-08 00:00:00	32020		\N	241798	0	192127007	440086		0
61611	3639	40481087	1975-10-04	1975-10-04 00:00:00	1975-10-25	1975-10-25 00:00:00	32020		\N	242129	0	444814009	40481087		0
72433	4299	78272	1973-12-08	1973-12-08 00:00:00	1973-12-22	1973-12-22 00:00:00	32020		\N	285232	0	70704007	78272		0
72587	4312	260139	1994-04-02	1994-04-02 00:00:00	1994-04-16	1994-04-16 00:00:00	32020		\N	286171	0	10509002	260139		0
62239	3675	4112343	1994-12-01	1994-12-01 00:00:00	1994-12-08	1994-12-08 00:00:00	32020		\N	244476	0	195662009	4112343		0
73000	4338	4266809	1998-01-18	1998-01-18 00:00:00	\N	\N	32020		\N	287698	0	397881000	4266809		0
73056	4342	4112343	2009-07-28	2009-07-28 00:00:00	2009-08-09	2009-08-09 00:00:00	32020		\N	287878	0	195662009	4112343		0
62669	3701	80180	1994-05-10	1994-05-10 00:00:00	\N	\N	32020		\N	246072	0	396275006	80180		0
73418	4365	4156265	1976-03-12	1976-03-12 00:00:00	1976-03-26	1976-03-26 00:00:00	32020		\N	289585	0	370247008	4156265		0
62983	3720	4112343	1966-01-19	1966-01-19 00:00:00	1966-02-01	1966-02-01 00:00:00	32020		\N	247293	0	195662009	4112343		0
73776	4382	40481087	1962-01-16	1962-01-16 00:00:00	1962-02-06	1962-02-06 00:00:00	32020		\N	291203	0	444814009	40481087		0
73925	4390	4294548	1962-12-23	1962-12-23 00:00:00	1963-02-10	1963-02-10 00:00:00	32020		\N	291793	0	75498004	4294548		0
74068	4398	40481087	1997-07-24	1997-07-24 00:00:00	1997-08-14	1997-08-14 00:00:00	32020		\N	292464	0	444814009	40481087		0
74298	4411	4266809	1984-01-22	1984-01-22 00:00:00	\N	\N	32020		\N	293271	0	397881000	4266809		0
63783	3767	192671	2018-12-06	2018-12-06 00:00:00	\N	\N	32020		\N	250387	0	K92.2	35208414		0
64011	3783	260139	1974-06-22	1974-06-22 00:00:00	1974-07-06	1974-07-06 00:00:00	32020		\N	251430	0	10509002	260139		0
64095	3786	260139	1981-04-12	1981-04-12 00:00:00	1981-04-19	1981-04-19 00:00:00	32020		\N	251670	0	10509002	260139		0
53734	3179	4112343	1922-05-23	1922-05-23 00:00:00	1922-06-02	1922-06-02 00:00:00	32020		\N	211486	0	195662009	4112343		0
53880	3189	4218389	1987-10-17	1987-10-17 00:00:00	1987-11-07	1987-11-07 00:00:00	32020		\N	212272	0	39848009	4218389		0
64624	3822	4296204	1945-08-21	1945-08-21 00:00:00	1945-09-11	1945-09-11 00:00:00	32020		\N	253893	0	403190006	4296204		0
54175	3211	4152936	1965-06-09	1965-06-09 00:00:00	1965-06-23	1965-06-23 00:00:00	32020		\N	213358	0	283385000	4152936		0
54407	3222	40481087	1953-09-23	1953-09-23 00:00:00	1953-10-07	1953-10-07 00:00:00	32020		\N	214158	0	444814009	40481087		0
54533	3230	4027663	1987-08-16	1987-08-16 00:00:00	\N	\N	32020		\N	214714	0	13200003	4027663		0
54737	3240	40481087	1970-12-14	1970-12-14 00:00:00	1971-01-04	1971-01-04 00:00:00	32020		\N	215410	0	444814009	40481087		0
54906	3249	40481087	1984-10-13	1984-10-13 00:00:00	1984-10-20	1984-10-20 00:00:00	32020		\N	215964	0	444814009	40481087		0
65641	3881	4112343	1982-06-02	1982-06-02 00:00:00	1982-06-15	1982-06-15 00:00:00	32020		\N	257945	0	195662009	4112343		0
65826	3892	81151	2014-04-03	2014-04-03 00:00:00	2014-04-17	2014-04-17 00:00:00	32020		\N	258774	0	44465007	81151		0
55419	3283	40481087	1993-06-04	1993-06-04 00:00:00	1993-06-18	1993-06-18 00:00:00	32020		\N	218085	0	444814009	40481087		0
55586	3293	4059173	1944-02-27	1944-02-27 00:00:00	1944-03-28	1944-03-28 00:00:00	32020		\N	218665	0	16114001	4059173		0
55768	3301	28060	1996-07-08	1996-07-08 00:00:00	1996-07-21	1996-07-21 00:00:00	32020		\N	219267	0	43878008	28060		0
55860	3307	195588	2009-10-11	2009-10-11 00:00:00	2009-11-10	2009-11-10 00:00:00	32020		\N	219582	0	38822007	195588		0
66646	3943	260139	2013-05-20	2013-05-20 00:00:00	2013-05-27	2013-05-27 00:00:00	32020		\N	262142	0	10509002	260139		0
66746	3950	440448	2008-09-23	2008-09-23 00:00:00	\N	\N	32020		\N	262526	0	74400008	440448		0
66915	3957	260139	1994-01-22	1994-01-22 00:00:00	1994-01-29	1994-01-29 00:00:00	32020		\N	263087	0	10509002	260139		0
56577	3355	28060	1975-07-26	1975-07-26 00:00:00	1975-08-06	1975-08-06 00:00:00	32020		\N	222480	0	43878008	28060		0
67367	3982	260139	1942-03-06	1942-03-06 00:00:00	1942-03-13	1942-03-13 00:00:00	32020		\N	264646	0	10509002	260139		0
67409	3984	40481087	2009-10-05	2009-10-05 00:00:00	2009-10-26	2009-10-26 00:00:00	32020		\N	264802	0	444814009	40481087		0
57066	3386	4142905	1984-12-31	1984-12-31 00:00:00	1985-03-01	1985-03-01 00:00:00	32020		\N	224629	0	33737001	4142905		0
57188	3394	372328	1978-02-13	1978-02-13 00:00:00	1978-12-16	1978-12-16 00:00:00	32020		\N	225144	0	65363002	372328		0
67910	4013	260139	1984-06-28	1984-06-28 00:00:00	1984-07-05	1984-07-05 00:00:00	32020		\N	266647	0	10509002	260139		0
57584	3417	260139	2004-02-25	2004-02-25 00:00:00	2004-03-03	2004-03-03 00:00:00	32020		\N	226619	0	10509002	260139		0
68252	4032	4112343	1971-02-26	1971-02-26 00:00:00	1971-03-09	1971-03-09 00:00:00	32020		\N	268231	0	195662009	4112343		0
57921	3435	372328	1978-04-10	1978-04-10 00:00:00	1978-09-30	1978-09-30 00:00:00	32020		\N	227800	0	65363002	372328		0
58057	3440	40481087	1987-03-14	1987-03-14 00:00:00	1987-03-28	1987-03-28 00:00:00	32020		\N	228331	0	444814009	40481087		0
58230	3446	4156265	1982-10-20	1982-10-20 00:00:00	1982-11-10	1982-11-10 00:00:00	32020		\N	228783	0	370247008	4156265		0
58326	3455	81151	2017-09-02	2017-09-02 00:00:00	2017-10-07	2017-10-07 00:00:00	32020		\N	229218	0	44465007	81151		0
58540	3469	40481087	2016-02-27	2016-02-27 00:00:00	2016-03-19	2016-03-19 00:00:00	32020		\N	230275	0	444814009	40481087		0
69319	4102	4146173	1973-10-27	1973-10-27 00:00:00	1973-12-03	1973-12-03 00:00:00	32020		\N	272597	0	307731004	4146173		0
58798	3488	28060	1993-03-19	1993-03-19 00:00:00	1993-03-30	1993-03-30 00:00:00	32020		\N	231383	0	43878008	28060		0
58984	3501	4112343	1990-03-12	1990-03-12 00:00:00	1990-03-23	1990-03-23 00:00:00	32020		\N	232067	0	195662009	4112343		0
69791	4129	40481087	1967-04-06	1967-04-06 00:00:00	1967-04-20	1967-04-20 00:00:00	32020		\N	274445	0	444814009	40481087		0
70049	4145	4112343	2010-05-28	2010-05-28 00:00:00	2010-06-10	2010-06-10 00:00:00	32020		\N	275544	0	195662009	4112343		0
59503	3528	260139	1994-05-17	1994-05-17 00:00:00	1994-05-24	1994-05-24 00:00:00	32020		\N	234192	0	10509002	260139		0
70232	4159	78272	1991-08-22	1991-08-22 00:00:00	1991-09-19	1991-09-19 00:00:00	32020		\N	276362	0	70704007	78272		0
70475	4176	260139	1977-09-29	1977-09-29 00:00:00	1977-10-06	1977-10-06 00:00:00	32020		\N	277492	0	10509002	260139		0
70630	4191	4112343	1958-11-10	1958-11-10 00:00:00	1958-11-20	1958-11-20 00:00:00	32020		\N	278123	0	195662009	4112343		0
60246	3566	260139	1992-01-01	1992-01-01 00:00:00	1992-01-15	1992-01-15 00:00:00	32020		\N	236963	0	10509002	260139		0
60393	3572	372328	1956-11-16	1956-11-16 00:00:00	1957-02-27	1957-02-27 00:00:00	32020		\N	237464	0	65363002	372328		0
60465	3576	260139	2005-11-12	2005-11-12 00:00:00	2005-11-19	2005-11-19 00:00:00	32020		\N	237749	0	10509002	260139		0
60742	3595	260139	1957-07-03	1957-07-03 00:00:00	1957-07-10	1957-07-10 00:00:00	32020		\N	238774	0	10509002	260139		0
60837	3601	4218389	1979-01-15	1979-01-15 00:00:00	1979-02-05	1979-02-05 00:00:00	32020		\N	239221	0	39848009	4218389		0
71556	4243	4112343	1992-10-24	1992-10-24 00:00:00	1992-10-31	1992-10-31 00:00:00	32020		\N	281826	0	195662009	4112343		0
61210	3621	260139	1972-02-28	1972-02-28 00:00:00	1972-03-06	1972-03-06 00:00:00	32020		\N	240611	0	10509002	260139		0
61351	3625	439777	1997-07-03	1997-07-03 00:00:00	\N	\N	32020		\N	241122	0	271737000	439777		0
61519	3636	4113008	2017-03-18	2017-03-18 00:00:00	2017-04-08	2017-04-08 00:00:00	32020		\N	241835	0	284549007	4113008		0
61612	3639	4059173	1931-12-21	1931-12-21 00:00:00	1932-02-19	1932-02-19 00:00:00	32020		\N	242120	0	16114001	4059173		0
72434	4299	40481087	2015-05-28	2015-05-28 00:00:00	2015-06-11	2015-06-11 00:00:00	32020		\N	285257	0	444814009	40481087		0
72588	4312	4109685	1999-04-10	1999-04-10 00:00:00	1999-05-01	1999-05-01 00:00:00	32020		\N	286125	0	284551006	4109685		0
62240	3676	40481087	1973-11-05	1973-11-05 00:00:00	1973-11-26	1973-11-26 00:00:00	32020		\N	244546	0	444814009	40481087		0
73001	4338	80180	1998-01-18	1998-01-18 00:00:00	\N	\N	32020		\N	287698	0	396275006	80180		0
73057	4342	4084167	1993-01-30	1993-01-30 00:00:00	1993-01-30	1993-01-30 00:00:00	32020		\N	287845	0	241929008	4084167		0
62670	3701	260139	1968-05-06	1968-05-06 00:00:00	1968-05-20	1968-05-20 00:00:00	32020		\N	246030	0	10509002	260139		0
73419	4365	40481087	1974-07-10	1974-07-10 00:00:00	1974-07-31	1974-07-31 00:00:00	32020		\N	289519	0	444814009	40481087		0
62984	3720	40481087	2000-08-11	2000-08-11 00:00:00	2000-08-25	2000-08-25 00:00:00	32020		\N	247285	0	444814009	40481087		0
73777	4382	4112343	1963-05-10	1963-05-10 00:00:00	1963-05-23	1963-05-23 00:00:00	32020		\N	291205	0	195662009	4112343		0
73926	4391	28060	1983-09-19	1983-09-19 00:00:00	1983-09-30	1983-09-30 00:00:00	32020		\N	291960	0	43878008	28060		0
74069	4398	40481087	1980-08-04	1980-08-04 00:00:00	1980-08-25	1980-08-25 00:00:00	32020		\N	292388	0	444814009	40481087		0
74299	4411	260139	1993-08-16	1993-08-16 00:00:00	1993-08-23	1993-08-23 00:00:00	32020		\N	293231	0	10509002	260139		0
63784	3767	28060	1986-05-13	1986-05-13 00:00:00	1986-05-23	1986-05-23 00:00:00	32020		\N	250349	0	43878008	28060		0
64012	3783	40481087	1998-04-21	1998-04-21 00:00:00	1998-04-28	1998-04-28 00:00:00	32020		\N	251341	0	444814009	40481087		0
64096	3786	439777	2015-11-25	2015-11-25 00:00:00	\N	\N	32020		\N	251654	0	271737000	439777		0
53756	3181	4059173	2018-11-15	2018-11-15 00:00:00	2019-02-13	2019-02-13 00:00:00	32020		\N	211691	0	16114001	4059173		0
53881	3189	4294548	2017-09-15	2017-09-15 00:00:00	2017-11-03	2017-11-03 00:00:00	32020		\N	212244	0	75498004	4294548		0
64625	3822	4112343	1986-02-20	1986-02-20 00:00:00	1986-03-02	1986-03-02 00:00:00	32020		\N	253815	0	195662009	4112343		0
54176	3211	4112343	1966-02-22	1966-02-22 00:00:00	1966-03-01	1966-03-01 00:00:00	32020		\N	213314	0	195662009	4112343		0
54408	3222	260139	2011-01-03	2011-01-03 00:00:00	2011-01-10	2011-01-10 00:00:00	32020		\N	214217	0	10509002	260139		0
54534	3230	4109685	2006-02-16	2006-02-16 00:00:00	2006-03-02	2006-03-02 00:00:00	32020		\N	214646	0	284551006	4109685		0
54738	3240	260139	2006-07-10	2006-07-10 00:00:00	2006-07-24	2006-07-24 00:00:00	32020		\N	215349	0	10509002	260139		0
54907	3249	4112343	1959-12-13	1959-12-13 00:00:00	1959-12-20	1959-12-20 00:00:00	32020		\N	215959	0	195662009	4112343		0
65642	3881	78272	1998-05-31	1998-05-31 00:00:00	1998-06-21	1998-06-21 00:00:00	32020		\N	257922	0	70704007	78272		0
65827	3892	260139	2019-02-02	2019-02-02 00:00:00	2019-02-16	2019-02-16 00:00:00	32020		\N	258784	0	10509002	260139		0
55420	3283	372328	1980-07-03	1980-07-03 00:00:00	1980-12-19	1980-12-19 00:00:00	32020		\N	218114	0	65363002	372328		0
55587	3293	40481087	1941-11-24	1941-11-24 00:00:00	1941-12-15	1941-12-15 00:00:00	32020		\N	218662	0	444814009	40481087		0
55769	3301	4059173	1948-06-11	1948-06-11 00:00:00	1948-07-11	1948-07-11 00:00:00	32020		\N	219261	0	16114001	4059173		0
55861	3307	257012	1979-08-16	1979-08-16 00:00:00	\N	\N	32020		\N	219597	0	40055000	257012		0
66647	3943	4112343	1977-08-31	1977-08-31 00:00:00	1977-09-11	1977-09-11 00:00:00	32020		\N	262140	0	195662009	4112343		0
66748	3950	378001	2016-09-16	2016-09-16 00:00:00	2016-10-16	2016-10-16 00:00:00	32020		\N	262527	0	62106007	378001		0
66916	3957	40481087	1966-10-01	1966-10-01 00:00:00	1966-10-08	1966-10-08 00:00:00	32020		\N	263136	0	444814009	40481087		0
56578	3355	4059173	2017-05-10	2017-05-10 00:00:00	2017-07-09	2017-07-09 00:00:00	32020		\N	222509	0	16114001	4059173		0
67368	3982	4112343	1964-03-15	1964-03-15 00:00:00	1964-03-26	1964-03-26 00:00:00	32020		\N	264705	0	195662009	4112343		0
67410	3984	313217	2014-11-26	2014-11-26 00:00:00	\N	\N	32020		\N	264884	0	49436004	313217		0
57067	3386	78272	1974-08-02	1974-08-02 00:00:00	1974-08-23	1974-08-23 00:00:00	32020		\N	224626	0	70704007	78272		0
57189	3394	372328	1971-02-03	1971-02-03 00:00:00	1971-09-18	1971-09-18 00:00:00	32020		\N	225122	0	65363002	372328		0
67911	4013	4112343	1996-05-12	1996-05-12 00:00:00	1996-05-22	1996-05-22 00:00:00	32020		\N	266650	0	195662009	4112343		0
57585	3417	40481087	1979-04-05	1979-04-05 00:00:00	1979-04-19	1979-04-19 00:00:00	32020		\N	226592	0	444814009	40481087		0
68253	4032	78272	1989-08-19	1989-08-19 00:00:00	1989-09-23	1989-09-23 00:00:00	32020		\N	268269	0	70704007	78272		0
57922	3435	40481087	2008-10-10	2008-10-10 00:00:00	2008-10-31	2008-10-31 00:00:00	32020		\N	227772	0	444814009	40481087		0
58058	3440	40481087	2017-09-05	2017-09-05 00:00:00	2017-09-12	2017-09-12 00:00:00	32020		\N	228240	0	444814009	40481087		0
58231	3446	4134304	1950-08-08	1950-08-08 00:00:00	1950-09-07	1950-09-07 00:00:00	32020		\N	228827	0	263102004	4134304		0
58327	3455	28060	1983-01-15	1983-01-15 00:00:00	1983-01-26	1983-01-26 00:00:00	32020		\N	229201	0	43878008	28060		0
58541	3469	372328	1958-06-08	1958-06-08 00:00:00	1958-09-17	1958-09-17 00:00:00	32020		\N	230214	0	65363002	372328		0
69340	4105	28060	2001-07-04	2001-07-04 00:00:00	2001-07-14	2001-07-14 00:00:00	32020		\N	272777	0	43878008	28060		0
58799	3488	40481087	1954-04-26	1954-04-26 00:00:00	1954-05-17	1954-05-17 00:00:00	32020		\N	231400	0	444814009	40481087		0
58985	3501	378001	1974-11-08	1974-11-08 00:00:00	1974-12-08	1974-12-08 00:00:00	32020		\N	232058	0	62106007	378001		0
69792	4129	40481087	1961-07-18	1961-07-18 00:00:00	1961-08-01	1961-08-01 00:00:00	32020		\N	274517	0	444814009	40481087		0
70050	4145	260139	1993-11-25	1993-11-25 00:00:00	1993-12-09	1993-12-09 00:00:00	32020		\N	275495	0	10509002	260139		0
59504	3528	4112343	1991-10-16	1991-10-16 00:00:00	1991-10-23	1991-10-23 00:00:00	32020		\N	234173	0	195662009	4112343		0
70233	4159	81151	2006-06-23	2006-06-23 00:00:00	2006-07-14	2006-07-14 00:00:00	32020		\N	276364	0	44465007	81151		0
70476	4176	260139	1945-03-07	1945-03-07 00:00:00	1945-03-14	1945-03-14 00:00:00	32020		\N	277444	0	10509002	260139		0
70631	4191	40481087	1975-11-26	1975-11-26 00:00:00	1975-12-10	1975-12-10 00:00:00	32020		\N	278164	0	444814009	40481087		0
60247	3566	4280726	1953-07-29	1953-07-29 00:00:00	\N	\N	32020		\N	236851	0	367498001	4280726		0
60394	3572	4294548	1967-03-07	1967-03-07 00:00:00	1967-05-16	1967-05-16 00:00:00	32020		\N	237478	0	75498004	4294548		0
60466	3576	40481087	1989-09-01	1989-09-01 00:00:00	1989-09-08	1989-09-08 00:00:00	32020		\N	237748	0	444814009	40481087		0
60743	3595	257012	1976-09-18	1976-09-18 00:00:00	\N	\N	32020		\N	238801	0	40055000	257012		0
60838	3601	80809	2000-06-08	2000-06-08 00:00:00	2005-01-13	2005-01-13 00:00:00	32020		\N	239183	0	69896004	80809		0
71557	4243	257012	2015-06-28	2015-06-28 00:00:00	\N	\N	32020		\N	281830	0	40055000	257012		0
61211	3621	375671	1937-06-22	1937-06-22 00:00:00	1937-07-22	1937-07-22 00:00:00	32020		\N	240658	0	62564004	375671		0
61352	3625	80180	1997-07-18	1997-07-18 00:00:00	\N	\N	32020		\N	241122	0	396275006	80180		0
61520	3636	81893	2009-10-28	2009-10-28 00:00:00	\N	\N	32020		\N	241827	0	64766004	81893		0
61613	3639	260139	1964-10-17	1964-10-17 00:00:00	1964-10-31	1964-10-31 00:00:00	32020		\N	242126	0	10509002	260139		0
72435	4299	260139	2015-02-02	2015-02-02 00:00:00	2015-02-16	2015-02-16 00:00:00	32020		\N	285256	0	10509002	260139		0
72589	4312	4109685	2019-05-16	2019-05-16 00:00:00	2019-05-30	2019-05-30 00:00:00	32020		\N	286126	0	284551006	4109685		0
62241	3676	257012	1981-04-28	1981-04-28 00:00:00	\N	\N	32020		\N	244548	0	40055000	257012		0
73002	4338	4285898	1997-06-22	1997-06-22 00:00:00	\N	\N	32020		\N	287698	0	68496003	4285898		0
73058	4342	372328	1958-06-30	1958-06-30 00:00:00	1958-09-12	1958-09-12 00:00:00	32020		\N	287850	0	65363002	372328		0
62671	3701	4112343	2011-07-29	2011-07-29 00:00:00	2011-08-06	2011-08-06 00:00:00	32020		\N	246045	0	195662009	4112343		0
73420	4365	260139	1989-08-27	1989-08-27 00:00:00	1989-09-03	1989-09-03 00:00:00	32020		\N	289520	0	10509002	260139		0
62985	3720	4278672	1968-09-10	1968-09-10 00:00:00	1968-12-09	1968-12-09 00:00:00	32020		\N	247308	0	65966004	4278672		0
73778	4382	260139	1967-01-22	1967-01-22 00:00:00	1967-01-29	1967-01-29 00:00:00	32020		\N	291178	0	10509002	260139		0
73927	4391	40481087	1954-08-06	1954-08-06 00:00:00	1954-08-27	1954-08-27 00:00:00	32020		\N	292010	0	444814009	40481087		0
74070	4398	372328	1960-01-13	1960-01-13 00:00:00	1960-03-26	1960-03-26 00:00:00	32020		\N	292455	0	65363002	372328		0
74300	4411	257012	1966-06-08	1966-06-08 00:00:00	\N	\N	32020		\N	293178	0	40055000	257012		0
63785	3767	260139	2016-03-13	2016-03-13 00:00:00	2016-03-20	2016-03-20 00:00:00	32020		\N	250351	0	10509002	260139		0
64013	3783	260139	1985-07-21	1985-07-21 00:00:00	1985-07-28	1985-07-28 00:00:00	32020		\N	251369	0	10509002	260139		0
64097	3786	4112343	1997-06-28	1997-06-28 00:00:00	1997-07-07	1997-07-07 00:00:00	32020		\N	251700	0	195662009	4112343		0
53757	3181	80180	1987-11-19	1987-11-19 00:00:00	\N	\N	32020		\N	211624	0	396275006	80180		0
53882	3189	372328	1965-09-14	1965-09-14 00:00:00	1965-11-24	1965-11-24 00:00:00	32020		\N	212238	0	65363002	372328		0
64626	3822	80180	1986-09-30	1986-09-30 00:00:00	\N	\N	32020		\N	253815	0	396275006	80180		0
54177	3211	40481087	1995-07-11	1995-07-11 00:00:00	1995-07-25	1995-07-25 00:00:00	32020		\N	213316	0	444814009	40481087		0
54409	3222	260139	2002-11-21	2002-11-21 00:00:00	2002-11-28	2002-11-28 00:00:00	32020		\N	214140	0	10509002	260139		0
54535	3230	4152936	1961-08-22	1961-08-22 00:00:00	1961-09-12	1961-09-12 00:00:00	32020		\N	214642	0	283385000	4152936		0
54739	3240	78272	2015-07-07	2015-07-07 00:00:00	2015-07-21	2015-07-21 00:00:00	32020		\N	215438	0	70704007	78272		0
54908	3249	81151	1998-08-22	1998-08-22 00:00:00	1998-09-19	1998-09-19 00:00:00	32020		\N	215989	0	44465007	81151		0
65643	3881	80180	1992-08-31	1992-08-31 00:00:00	\N	\N	32020		\N	257930	0	396275006	80180		0
65828	3892	4112343	1967-06-06	1967-06-06 00:00:00	1967-06-19	1967-06-19 00:00:00	32020		\N	258775	0	195662009	4112343		0
55421	3283	4310024	2014-09-03	2014-09-03 00:00:00	\N	\N	32020		\N	218092	0	424802006	4310024		0
55588	3293	4112343	1935-07-24	1935-07-24 00:00:00	1935-08-06	1935-08-06 00:00:00	32020		\N	218701	0	195662009	4112343		0
55770	3301	28060	1976-08-02	1976-08-02 00:00:00	1976-08-13	1976-08-13 00:00:00	32020		\N	219331	0	43878008	28060		0
55862	3307	4112343	1968-08-25	1968-08-25 00:00:00	1968-09-04	1968-09-04 00:00:00	32020		\N	219579	0	195662009	4112343		0
66648	3943	4218389	1968-03-12	1968-03-12 00:00:00	1968-04-09	1968-04-09 00:00:00	32020		\N	262136	0	39848009	4218389		0
66749	3950	78272	1981-06-17	1981-06-17 00:00:00	1981-07-22	1981-07-22 00:00:00	32020		\N	262524	0	70704007	78272		0
66917	3957	40481087	1991-02-18	1991-02-18 00:00:00	1991-03-11	1991-03-11 00:00:00	32020		\N	263047	0	444814009	40481087		0
56579	3355	40481087	1994-01-03	1994-01-03 00:00:00	1994-01-24	1994-01-24 00:00:00	32020		\N	222512	0	444814009	40481087		0
67369	3982	260139	1986-09-22	1986-09-22 00:00:00	1986-09-29	1986-09-29 00:00:00	32020		\N	264655	0	10509002	260139		0
67411	3984	260139	1961-03-19	1961-03-19 00:00:00	1961-03-26	1961-03-26 00:00:00	32020		\N	264805	0	10509002	260139		0
57068	3386	40481087	1984-01-28	1984-01-28 00:00:00	1984-02-18	1984-02-18 00:00:00	32020		\N	224616	0	444814009	40481087		0
57190	3394	40481087	2002-12-02	2002-12-02 00:00:00	2002-12-23	2002-12-23 00:00:00	32020		\N	225114	0	444814009	40481087		0
67912	4013	372328	1978-12-17	1978-12-17 00:00:00	1979-10-28	1979-10-28 00:00:00	32020		\N	266633	0	65363002	372328		0
57586	3417	4116491	1950-04-07	1950-04-07 00:00:00	1950-05-14	1950-05-14 00:00:00	32020		\N	226606	0	301011002	4116491		0
68254	4032	40481087	2005-06-22	2005-06-22 00:00:00	2005-07-13	2005-07-13 00:00:00	32020		\N	268245	0	444814009	40481087		0
57923	3435	40481087	2010-01-16	2010-01-16 00:00:00	2010-02-06	2010-02-06 00:00:00	32020		\N	227774	0	444814009	40481087		0
58059	3440	4146173	1995-09-29	1995-09-29 00:00:00	1995-11-05	1995-11-05 00:00:00	32020		\N	228262	0	307731004	4146173		0
58232	3446	4278672	1965-05-21	1965-05-21 00:00:00	1965-06-20	1965-06-20 00:00:00	32020		\N	228779	0	65966004	4278672		0
58328	3455	4112343	2008-06-10	2008-06-10 00:00:00	2008-06-19	2008-06-19 00:00:00	32020		\N	229203	0	195662009	4112343		0
58542	3469	260139	2001-07-18	2001-07-18 00:00:00	2001-08-01	2001-08-01 00:00:00	32020		\N	230257	0	10509002	260139		0
69341	4105	4112343	2009-05-18	2009-05-18 00:00:00	2009-05-26	2009-05-26 00:00:00	32020		\N	272760	0	195662009	4112343		0
58800	3488	4283893	1997-07-14	1997-07-14 00:00:00	1997-09-29	1997-09-29 00:00:00	32020		\N	231415	0	36971009	4283893		0
58986	3501	28060	1957-09-01	1957-09-01 00:00:00	1957-09-13	1957-09-13 00:00:00	32020		\N	232120	0	43878008	28060		0
69793	4129	40481087	1995-08-15	1995-08-15 00:00:00	1995-08-29	1995-08-29 00:00:00	32020		\N	274448	0	444814009	40481087		0
70051	4145	4109685	2012-09-15	2012-09-15 00:00:00	2012-09-29	2012-09-29 00:00:00	32020		\N	275465	0	284551006	4109685		0
59505	3528	40481087	2014-08-23	2014-08-23 00:00:00	2014-09-06	2014-09-06 00:00:00	32020		\N	234151	0	444814009	40481087		0
70234	4159	260139	1967-04-02	1967-04-02 00:00:00	1967-04-09	1967-04-09 00:00:00	32020		\N	276366	0	10509002	260139		0
70477	4176	40481087	1978-07-25	1978-07-25 00:00:00	1978-08-15	1978-08-15 00:00:00	32020		\N	277493	0	444814009	40481087		0
70632	4191	4112343	1962-03-21	1962-03-21 00:00:00	1962-03-29	1962-03-29 00:00:00	32020		\N	278150	0	195662009	4112343		0
60248	3566	4283893	1994-05-28	1994-05-28 00:00:00	1994-07-09	1994-07-09 00:00:00	32020		\N	236850	0	36971009	4283893		0
60395	3572	30753	1992-06-05	1992-06-05 00:00:00	\N	\N	32020		\N	237508	0	16761005	30753		0
60467	3576	260139	1978-12-26	1978-12-26 00:00:00	1979-01-02	1979-01-02 00:00:00	32020		\N	237692	0	10509002	260139		0
60744	3595	40481087	1981-07-21	1981-07-21 00:00:00	1981-07-28	1981-07-28 00:00:00	32020		\N	238835	0	444814009	40481087		0
60839	3601	4294548	2017-05-21	2017-05-21 00:00:00	2017-07-09	2017-07-09 00:00:00	32020		\N	239252	0	75498004	4294548		0
71558	4243	4112343	1970-09-07	1970-09-07 00:00:00	1970-09-16	1970-09-16 00:00:00	32020		\N	281839	0	195662009	4112343		0
61212	3621	260139	1967-07-03	1967-07-03 00:00:00	1967-07-10	1967-07-10 00:00:00	32020		\N	240579	0	10509002	260139		0
61353	3625	257012	1975-04-28	1975-04-28 00:00:00	\N	\N	32020		\N	241118	0	40055000	257012		0
61521	3636	4027663	2003-07-07	2003-07-07 00:00:00	\N	\N	32020		\N	241820	0	13200003	4027663		0
61614	3639	260139	1995-08-15	1995-08-15 00:00:00	1995-08-29	1995-08-29 00:00:00	32020		\N	242034	0	10509002	260139		0
72436	4299	372328	1985-09-06	1985-09-06 00:00:00	1986-05-18	1986-05-18 00:00:00	32020		\N	285248	0	65363002	372328		0
72590	4312	4084167	1978-06-09	1978-06-09 00:00:00	1978-06-10	1978-06-10 00:00:00	32020		\N	286123	0	241929008	4084167		0
62242	3676	4237458	1973-07-29	1973-07-29 00:00:00	1973-08-28	1973-08-28 00:00:00	32020		\N	244485	0	58150001	4237458		0
73003	4338	40481087	2007-06-20	2007-06-20 00:00:00	2007-07-04	2007-07-04 00:00:00	32020		\N	287690	0	444814009	40481087		0
73059	4342	378001	1964-12-25	1964-12-25 00:00:00	1965-01-24	1965-01-24 00:00:00	32020		\N	287843	0	62106007	378001		0
62672	3701	40481087	1971-11-22	1971-11-22 00:00:00	1971-12-13	1971-12-13 00:00:00	32020		\N	246031	0	444814009	40481087		0
73421	4365	313217	2001-07-23	2001-07-23 00:00:00	\N	\N	32020		\N	289578	0	49436004	313217		0
62986	3720	372328	1956-12-02	1956-12-02 00:00:00	1957-03-12	1957-03-12 00:00:00	32020		\N	247240	0	65363002	372328		0
73779	4382	4152936	1985-12-18	1985-12-18 00:00:00	1986-01-01	1986-01-01 00:00:00	32020		\N	291169	0	283385000	4152936		0
73928	4391	40481087	1991-03-05	1991-03-05 00:00:00	1991-03-12	1991-03-12 00:00:00	32020		\N	291962	0	444814009	40481087		0
74083	4401	4116491	2004-12-26	2004-12-26 00:00:00	2005-01-30	2005-01-30 00:00:00	32020		\N	292592	0	301011002	4116491		0
74301	4411	4134304	1950-01-20	1950-01-20 00:00:00	1950-03-21	1950-03-21 00:00:00	32020		\N	293248	0	263102004	4134304		0
63786	3767	81893	2016-11-29	2016-11-29 00:00:00	\N	\N	32020		\N	250351	0	64766004	81893		0
64014	3783	4294548	2011-10-04	2011-10-04 00:00:00	2011-11-08	2011-11-08 00:00:00	32020		\N	251314	0	75498004	4294548		0
64098	3786	4112343	1966-12-12	1966-12-12 00:00:00	1966-12-23	1966-12-23 00:00:00	32020		\N	251712	0	195662009	4112343		0
53758	3181	260139	1994-12-27	1994-12-27 00:00:00	1995-01-10	1995-01-10 00:00:00	32020		\N	211676	0	10509002	260139		0
53883	3189	40481087	1984-08-15	1984-08-15 00:00:00	1984-08-22	1984-08-22 00:00:00	32020		\N	212223	0	444814009	40481087		0
64627	3822	4112343	1953-01-11	1953-01-11 00:00:00	1953-01-24	1953-01-24 00:00:00	32020		\N	253898	0	195662009	4112343		0
54178	3211	4112343	1974-02-01	1974-02-01 00:00:00	1974-02-10	1974-02-10 00:00:00	32020		\N	213365	0	195662009	4112343		0
54410	3223	4112343	1986-06-06	1986-06-06 00:00:00	1986-06-18	1986-06-18 00:00:00	32020		\N	214327	0	195662009	4112343		0
54536	3230	80180	1997-08-03	1997-08-03 00:00:00	\N	\N	32020		\N	214715	0	396275006	80180		0
54740	3240	381316	2008-10-08	2008-10-08 00:00:00	\N	\N	32020		\N	215384	0	230690007	381316		0
54909	3249	260139	1962-09-17	1962-09-17 00:00:00	1962-09-24	1962-09-24 00:00:00	32020		\N	215960	0	10509002	260139		0
65644	3881	78272	1981-12-05	1981-12-05 00:00:00	1981-12-26	1981-12-26 00:00:00	32020		\N	257920	0	70704007	78272		0
65829	3892	40481087	2014-05-29	2014-05-29 00:00:00	2014-06-05	2014-06-05 00:00:00	32020		\N	258782	0	444814009	40481087		0
55422	3283	40481087	2013-12-19	2013-12-19 00:00:00	2014-01-02	2014-01-02 00:00:00	32020		\N	218092	0	444814009	40481087		0
55589	3293	40481087	1969-03-10	1969-03-10 00:00:00	1969-03-24	1969-03-24 00:00:00	32020		\N	218669	0	444814009	40481087		0
55771	3301	40481087	2011-09-03	2011-09-03 00:00:00	2011-09-10	2011-09-10 00:00:00	32020		\N	219340	0	444814009	40481087		0
55863	3307	4283893	1979-08-02	1979-08-02 00:00:00	1979-10-18	1979-10-18 00:00:00	32020		\N	219580	0	36971009	4283893		0
66649	3943	40481087	1966-03-11	1966-03-11 00:00:00	1966-03-18	1966-03-18 00:00:00	32020		\N	262166	0	444814009	40481087		0
66750	3950	4278672	1971-09-26	1971-09-26 00:00:00	1971-12-25	1971-12-25 00:00:00	32020		\N	262521	0	65966004	4278672		0
66918	3957	372328	1980-07-12	1980-07-12 00:00:00	1981-10-29	1981-10-29 00:00:00	32020		\N	263122	0	65363002	372328		0
56580	3355	28060	1964-09-28	1964-09-28 00:00:00	1964-10-10	1964-10-10 00:00:00	32020		\N	222492	0	43878008	28060		0
67370	3982	260139	1984-05-16	1984-05-16 00:00:00	1984-05-30	1984-05-30 00:00:00	32020		\N	264712	0	10509002	260139		0
67412	3984	260139	1989-08-31	1989-08-31 00:00:00	1989-09-14	1989-09-14 00:00:00	32020		\N	264837	0	10509002	260139		0
57069	3386	40481087	1994-06-16	1994-06-16 00:00:00	1994-07-07	1994-07-07 00:00:00	32020		\N	224640	0	444814009	40481087		0
57191	3394	4112343	1967-08-27	1967-08-27 00:00:00	1967-09-03	1967-09-03 00:00:00	32020		\N	225141	0	195662009	4112343		0
67913	4013	40481087	2017-01-14	2017-01-14 00:00:00	2017-02-04	2017-02-04 00:00:00	32020		\N	266669	0	444814009	40481087		0
57587	3417	40480160	2018-03-28	2018-03-28 00:00:00	2018-06-26	2018-06-26 00:00:00	32020		\N	226627	0	443165006	40480160		0
68255	4032	4296204	2001-10-20	2001-10-20 00:00:00	2001-11-10	2001-11-10 00:00:00	32020		\N	268212	0	403190006	4296204		0
57924	3436	260139	1969-04-19	1969-04-19 00:00:00	1969-05-03	1969-05-03 00:00:00	32020		\N	227875	0	10509002	260139		0
58060	3440	4112343	1993-07-11	1993-07-11 00:00:00	1993-07-21	1993-07-21 00:00:00	32020		\N	228324	0	195662009	4112343		0
58233	3446	378001	2005-08-09	2005-08-09 00:00:00	2005-09-08	2005-09-08 00:00:00	32020		\N	228800	0	62106007	378001		0
58329	3455	4112343	2006-03-11	2006-03-11 00:00:00	2006-03-19	2006-03-19 00:00:00	32020		\N	229243	0	195662009	4112343		0
58543	3469	260139	2006-11-11	2006-11-11 00:00:00	2006-11-25	2006-11-25 00:00:00	32020		\N	230242	0	10509002	260139		0
69342	4105	260139	1993-06-20	1993-06-20 00:00:00	1993-07-04	1993-07-04 00:00:00	32020		\N	272710	0	10509002	260139		0
58801	3488	257012	1997-08-11	1997-08-11 00:00:00	\N	\N	32020		\N	231384	0	40055000	257012		0
58987	3501	260139	2012-02-03	2012-02-03 00:00:00	2012-02-17	2012-02-17 00:00:00	32020		\N	232084	0	10509002	260139		0
69794	4129	40481087	2008-02-29	2008-02-29 00:00:00	2008-03-07	2008-03-07 00:00:00	32020		\N	274521	0	444814009	40481087		0
70052	4145	40481087	2000-02-23	2000-02-23 00:00:00	2000-03-08	2000-03-08 00:00:00	32020		\N	275497	0	444814009	40481087		0
59506	3528	4112343	1989-02-18	1989-02-18 00:00:00	1989-02-27	1989-02-27 00:00:00	32020		\N	234262	0	195662009	4112343		0
70235	4159	4283893	1989-07-07	1989-07-07 00:00:00	1989-08-18	1989-08-18 00:00:00	32020		\N	276338	0	36971009	4283893		0
70478	4176	372328	1918-10-01	1918-10-01 00:00:00	1918-12-12	1918-12-12 00:00:00	32020		\N	277501	0	65363002	372328		0
70633	4191	321042	2013-07-26	2013-07-26 00:00:00	\N	\N	32020		\N	278185	0	410429000	321042		0
60249	3566	81151	1996-02-14	1996-02-14 00:00:00	1996-03-06	1996-03-06 00:00:00	32020		\N	236952	0	44465007	81151		0
60396	3572	4237458	1984-01-20	1984-01-20 00:00:00	1984-02-19	1984-02-19 00:00:00	32020		\N	237444	0	58150001	4237458		0
60468	3576	40481087	1997-10-29	1997-10-29 00:00:00	1997-11-19	1997-11-19 00:00:00	32020		\N	237694	0	444814009	40481087		0
60745	3595	4134304	1985-06-09	1985-06-09 00:00:00	1985-09-07	1985-09-07 00:00:00	32020		\N	238831	0	263102004	4134304		0
60840	3601	4296204	1976-11-21	1976-11-21 00:00:00	1976-12-26	1976-12-26 00:00:00	32020		\N	239220	0	403190006	4296204		0
71559	4243	4112343	2018-03-15	2018-03-15 00:00:00	2018-03-26	2018-03-26 00:00:00	32020		\N	281816	0	195662009	4112343		0
61213	3621	4112343	1984-11-21	1984-11-21 00:00:00	1984-11-29	1984-11-29 00:00:00	32020		\N	240638	0	195662009	4112343		0
61354	3625	4112343	1962-05-26	1962-05-26 00:00:00	1962-06-02	1962-06-02 00:00:00	32020		\N	241034	0	195662009	4112343		0
61522	3636	4294548	1998-01-23	1998-01-23 00:00:00	1998-05-15	1998-05-15 00:00:00	32020		\N	241808	0	75498004	4294548		0
61615	3639	313217	2004-01-31	2004-01-31 00:00:00	\N	\N	32020		\N	242079	0	49436004	313217		0
72437	4299	40481087	2002-03-29	2002-03-29 00:00:00	2002-04-05	2002-04-05 00:00:00	32020		\N	285246	0	444814009	40481087		0
72591	4312	40481087	1969-07-23	1969-07-23 00:00:00	1969-07-30	1969-07-30 00:00:00	32020		\N	286138	0	444814009	40481087		0
62243	3676	372328	1971-06-10	1971-06-10 00:00:00	1971-07-22	1971-07-22 00:00:00	32020		\N	244501	0	65363002	372328		0
73004	4338	4310024	1996-01-29	1996-01-29 00:00:00	\N	\N	32020		\N	287697	0	424802006	4310024		0
73060	4342	4310024	1992-03-23	1992-03-23 00:00:00	\N	\N	32020		\N	287912	0	424802006	4310024		0
62673	3701	4155034	1962-05-13	1962-05-13 00:00:00	1962-06-03	1962-06-03 00:00:00	32020		\N	246066	0	283371005	4155034		0
73423	4365	4029498	1982-07-15	1982-07-15 00:00:00	\N	\N	32020		\N	289586	0	128613002	4029498		0
62987	3720	40481087	2001-06-30	2001-06-30 00:00:00	2001-07-14	2001-07-14 00:00:00	32020		\N	247236	0	444814009	40481087		0
73780	4383	260139	1971-02-06	1971-02-06 00:00:00	1971-02-13	1971-02-13 00:00:00	32020		\N	291337	0	10509002	260139		0
73929	4391	28060	1955-07-06	1955-07-06 00:00:00	1955-07-16	1955-07-16 00:00:00	32020		\N	292011	0	43878008	28060		0
74084	4401	40481087	1990-01-17	1990-01-17 00:00:00	1990-01-24	1990-01-24 00:00:00	32020		\N	292537	0	444814009	40481087		0
74302	4411	40481087	1968-09-28	1968-09-28 00:00:00	1968-10-05	1968-10-05 00:00:00	32020		\N	293200	0	444814009	40481087		0
63787	3767	4027663	2010-02-09	2010-02-09 00:00:00	\N	\N	32020		\N	250344	0	13200003	4027663		0
64015	3783	4112343	2001-05-31	2001-05-31 00:00:00	2001-06-13	2001-06-13 00:00:00	32020		\N	251332	0	195662009	4112343		0
64099	3786	4112343	2011-03-29	2011-03-29 00:00:00	2011-04-10	2011-04-10 00:00:00	32020		\N	251702	0	195662009	4112343		0
53759	3181	40481087	1974-07-17	1974-07-17 00:00:00	1974-08-07	1974-08-07 00:00:00	32020		\N	211732	0	444814009	40481087		0
53884	3189	4112343	1982-03-01	1982-03-01 00:00:00	1982-03-08	1982-03-08 00:00:00	32020		\N	212255	0	195662009	4112343		0
64628	3822	4146173	1974-03-25	1974-03-25 00:00:00	1974-04-24	1974-04-24 00:00:00	32020		\N	253867	0	307731004	4146173		0
54179	3211	372328	1958-11-13	1958-11-13 00:00:00	1959-05-01	1959-05-01 00:00:00	32020		\N	213334	0	65363002	372328		0
54411	3223	4237458	1929-02-11	1929-02-11 00:00:00	1929-03-13	1929-03-13 00:00:00	32020		\N	214308	0	58150001	4237458		0
54537	3230	260139	1993-03-05	1993-03-05 00:00:00	1993-03-19	1993-03-19 00:00:00	32020		\N	214679	0	10509002	260139		0
54741	3240	40481087	1979-08-24	1979-08-24 00:00:00	1979-09-07	1979-09-07 00:00:00	32020		\N	215412	0	444814009	40481087		0
54910	3249	40481087	2016-01-19	2016-01-19 00:00:00	2016-02-02	2016-02-02 00:00:00	32020		\N	215969	0	444814009	40481087		0
65645	3881	260139	1998-01-13	1998-01-13 00:00:00	1998-01-20	1998-01-20 00:00:00	32020		\N	257947	0	10509002	260139		0
65830	3892	40481087	1972-09-13	1972-09-13 00:00:00	1972-10-04	1972-10-04 00:00:00	32020		\N	258781	0	444814009	40481087		0
55423	3283	40481087	2003-04-05	2003-04-05 00:00:00	2003-04-12	2003-04-12 00:00:00	32020		\N	218112	0	444814009	40481087		0
55590	3293	40481087	1934-02-15	1934-02-15 00:00:00	1934-03-01	1934-03-01 00:00:00	32020		\N	218700	0	444814009	40481087		0
55772	3301	40481087	1974-07-26	1974-07-26 00:00:00	1974-08-16	1974-08-16 00:00:00	32020		\N	219306	0	444814009	40481087		0
55864	3308	4112343	1977-08-03	1977-08-03 00:00:00	1977-08-10	1977-08-10 00:00:00	32020		\N	219639	0	195662009	4112343		0
66650	3943	40481087	2005-06-05	2005-06-05 00:00:00	2005-06-26	2005-06-26 00:00:00	32020		\N	262152	0	444814009	40481087		0
66751	3950	260139	2016-05-12	2016-05-12 00:00:00	2016-05-26	2016-05-26 00:00:00	32020		\N	262533	0	10509002	260139		0
66919	3957	4152936	2001-12-10	2001-12-10 00:00:00	2001-12-24	2001-12-24 00:00:00	32020		\N	263064	0	283385000	4152936		0
67065	3966	4027663	1994-12-03	1994-12-03 00:00:00	\N	\N	32020		\N	263683	0	13200003	4027663		0
67371	3982	378419	2011-11-11	2011-11-11 00:00:00	\N	\N	32020		\N	264704	0	26929004	378419		0
67413	3984	78272	1969-05-17	1969-05-17 00:00:00	1969-05-31	1969-05-31 00:00:00	32020		\N	264818	0	70704007	78272		0
57070	3386	4027663	1996-11-24	1996-11-24 00:00:00	\N	\N	32020		\N	224640	0	13200003	4027663		0
57192	3394	40481087	2017-05-15	2017-05-15 00:00:00	2017-06-05	2017-06-05 00:00:00	32020		\N	225121	0	444814009	40481087		0
67914	4013	378001	2008-02-22	2008-02-22 00:00:00	2008-04-22	2008-04-22 00:00:00	32020		\N	266666	0	62106007	378001		0
57588	3417	4230399	2018-03-28	2018-03-28 00:00:00	2018-06-26	2018-06-26 00:00:00	32020		\N	226627	0	359817006	4230399		0
68256	4032	80180	1991-01-22	1991-01-22 00:00:00	\N	\N	32020		\N	268195	0	396275006	80180		0
57925	3436	80180	2003-02-20	2003-02-20 00:00:00	\N	\N	32020		\N	227918	0	396275006	80180		0
58061	3440	372328	1945-11-19	1945-11-19 00:00:00	1946-02-12	1946-02-12 00:00:00	32020		\N	228241	0	65363002	372328		0
58234	3446	378419	2016-12-05	2016-12-05 00:00:00	\N	\N	32020		\N	228881	0	26929004	378419		0
58330	3456	81151	1978-10-07	1978-10-07 00:00:00	1978-10-28	1978-10-28 00:00:00	32020		\N	229295	0	44465007	81151		0
58544	3469	81151	1991-06-17	1991-06-17 00:00:00	1991-07-01	1991-07-01 00:00:00	32020		\N	230253	0	44465007	81151		0
69343	4105	260139	2009-02-16	2009-02-16 00:00:00	2009-02-23	2009-02-23 00:00:00	32020		\N	272730	0	10509002	260139		0
58802	3488	81151	1978-05-12	1978-05-12 00:00:00	1978-06-16	1978-06-16 00:00:00	32020		\N	231356	0	44465007	81151		0
58988	3501	40481087	1967-02-15	1967-02-15 00:00:00	1967-03-01	1967-03-01 00:00:00	32020		\N	232081	0	444814009	40481087		0
69795	4129	4112343	1989-11-07	1989-11-07 00:00:00	1989-11-15	1989-11-15 00:00:00	32020		\N	274454	0	195662009	4112343		0
80511	4771	28060	1956-12-05	1956-12-05 00:00:00	1956-12-12	1956-12-12 00:00:00	32020		\N	317755	0	43878008	28060		0
59507	3528	40481087	1990-04-18	1990-04-18 00:00:00	1990-05-09	1990-05-09 00:00:00	32020		\N	234244	0	444814009	40481087		0
70236	4159	40481087	1967-02-04	1967-02-04 00:00:00	1967-02-25	1967-02-25 00:00:00	32020		\N	276381	0	444814009	40481087		0
70479	4176	260139	1923-07-09	1923-07-09 00:00:00	1923-07-23	1923-07-23 00:00:00	32020		\N	277525	0	10509002	260139		0
70635	4191	372328	1961-08-25	1961-08-25 00:00:00	1962-07-27	1962-07-27 00:00:00	32020		\N	278174	0	65363002	372328		0
60250	3566	4112343	1981-05-20	1981-05-20 00:00:00	1981-06-01	1981-06-01 00:00:00	32020		\N	236869	0	195662009	4112343		0
60397	3572	372328	2010-01-01	2010-01-01 00:00:00	2010-04-14	2010-04-14 00:00:00	32020		\N	237483	0	65363002	372328		0
60469	3576	4112343	1984-02-26	1984-02-26 00:00:00	1984-03-05	1984-03-05 00:00:00	32020		\N	237747	0	195662009	4112343		0
60746	3595	260139	1980-04-19	1980-04-19 00:00:00	1980-05-03	1980-05-03 00:00:00	32020		\N	238847	0	10509002	260139		0
60841	3601	439777	2018-06-04	2018-06-04 00:00:00	\N	\N	32020		\N	239253	0	271737000	439777		0
71560	4243	40481087	1999-09-19	1999-09-19 00:00:00	1999-10-10	1999-10-10 00:00:00	32020		\N	281860	0	444814009	40481087		0
61214	3621	4278672	1929-08-03	1929-08-03 00:00:00	1929-09-02	1929-09-02 00:00:00	32020		\N	240657	0	65966004	4278672		0
61355	3625	4112343	1979-12-29	1979-12-29 00:00:00	1980-01-10	1980-01-10 00:00:00	32020		\N	241119	0	195662009	4112343		0
61616	3639	260139	1999-12-27	1999-12-27 00:00:00	2000-01-10	2000-01-10 00:00:00	32020		\N	242171	0	10509002	260139		0
72438	4299	260139	1982-01-12	1982-01-12 00:00:00	1982-01-19	1982-01-19 00:00:00	32020		\N	285245	0	10509002	260139		0
72592	4312	4112343	1987-07-09	1987-07-09 00:00:00	1987-07-19	1987-07-19 00:00:00	32020		\N	286209	0	195662009	4112343		0
62244	3676	40481087	1989-10-01	1989-10-01 00:00:00	1989-10-08	1989-10-08 00:00:00	32020		\N	244549	0	444814009	40481087		0
73005	4338	4278672	1966-06-05	1966-06-05 00:00:00	1966-07-05	1966-07-05 00:00:00	32020		\N	287670	0	65966004	4278672		0
73061	4342	81893	1992-05-22	1992-05-22 00:00:00	\N	\N	32020		\N	287924	0	64766004	81893		0
62674	3701	4112343	1955-07-23	1955-07-23 00:00:00	1955-08-05	1955-08-05 00:00:00	32020		\N	246055	0	195662009	4112343		0
73424	4365	380378	1982-07-15	1982-07-15 00:00:00	\N	\N	32020		\N	289586	0	84757009	380378		0
62988	3720	81151	1957-02-19	1957-02-19 00:00:00	1957-03-12	1957-03-12 00:00:00	32020		\N	247307	0	44465007	81151		0
73781	4383	78272	1990-10-13	1990-10-13 00:00:00	1990-10-27	1990-10-27 00:00:00	32020		\N	291357	0	70704007	78272		0
73930	4391	192671	1978-08-14	1978-08-14 00:00:00	\N	\N	32020		\N	291997	0	K92.2	35208414		0
74085	4401	80180	2009-02-08	2009-02-08 00:00:00	\N	\N	32020		\N	292587	0	396275006	80180		0
74303	4411	40481087	1952-06-16	1952-06-16 00:00:00	1952-07-07	1952-07-07 00:00:00	32020		\N	293197	0	444814009	40481087		0
63788	3767	372328	1988-08-15	1988-08-15 00:00:00	1989-01-20	1989-01-20 00:00:00	32020		\N	250382	0	65363002	372328		0
64016	3783	260139	2006-04-01	2006-04-01 00:00:00	2006-04-08	2006-04-08 00:00:00	32020		\N	251342	0	10509002	260139		0
64100	3786	4112343	2013-12-09	2013-12-09 00:00:00	2013-12-17	2013-12-17 00:00:00	32020		\N	251718	0	195662009	4112343		0
53760	3181	260139	1977-11-06	1977-11-06 00:00:00	1977-11-20	1977-11-20 00:00:00	32020		\N	211733	0	10509002	260139		0
53885	3189	4112343	2005-04-20	2005-04-20 00:00:00	2005-04-30	2005-04-30 00:00:00	32020		\N	212236	0	195662009	4112343		0
64629	3822	4113008	1964-06-03	1964-06-03 00:00:00	1964-06-17	1964-06-17 00:00:00	32020		\N	253833	0	284549007	4113008		0
54180	3211	40481087	1963-01-30	1963-01-30 00:00:00	1963-02-13	1963-02-13 00:00:00	32020		\N	213364	0	444814009	40481087		0
54412	3223	440448	1949-07-12	1949-07-12 00:00:00	\N	\N	32020		\N	214310	0	74400008	440448		0
54538	3230	40481087	1962-02-25	1962-02-25 00:00:00	1962-03-04	1962-03-04 00:00:00	32020		\N	214653	0	444814009	40481087		0
54742	3240	80180	1981-08-07	1981-08-07 00:00:00	\N	\N	32020		\N	215421	0	396275006	80180		0
54911	3249	4112343	1990-04-27	1990-04-27 00:00:00	1990-05-09	1990-05-09 00:00:00	32020		\N	216010	0	195662009	4112343		0
65646	3881	40481087	1981-12-03	1981-12-03 00:00:00	1981-12-24	1981-12-24 00:00:00	32020		\N	257884	0	444814009	40481087		0
65831	3892	40481087	1970-08-05	1970-08-05 00:00:00	1970-08-19	1970-08-19 00:00:00	32020		\N	258776	0	444814009	40481087		0
55424	3283	372328	1981-10-15	1981-10-15 00:00:00	1981-12-18	1981-12-18 00:00:00	32020		\N	218142	0	65363002	372328		0
55591	3293	4112343	1984-07-30	1984-07-30 00:00:00	1984-08-11	1984-08-11 00:00:00	32020		\N	218733	0	195662009	4112343		0
55773	3301	4112343	1995-04-01	1995-04-01 00:00:00	1995-04-14	1995-04-14 00:00:00	32020		\N	219338	0	195662009	4112343		0
55865	3308	40481087	1981-10-12	1981-10-12 00:00:00	1981-10-19	1981-10-19 00:00:00	32020		\N	219641	0	444814009	40481087		0
66651	3943	260139	1985-03-01	1985-03-01 00:00:00	1985-03-15	1985-03-15 00:00:00	32020		\N	262150	0	10509002	260139		0
66752	3950	40481087	1990-04-26	1990-04-26 00:00:00	1990-05-17	1990-05-17 00:00:00	32020		\N	262585	0	444814009	40481087		0
66920	3957	4237458	1964-05-07	1964-05-07 00:00:00	1964-08-05	1964-08-05 00:00:00	32020		\N	263144	0	58150001	4237458		0
67066	3966	4112343	1975-09-08	1975-09-08 00:00:00	1975-09-17	1975-09-17 00:00:00	32020		\N	263630	0	195662009	4112343		0
67372	3982	260139	1952-08-18	1952-08-18 00:00:00	1952-09-01	1952-09-01 00:00:00	32020		\N	264653	0	10509002	260139		0
67414	3984	260139	1963-12-13	1963-12-13 00:00:00	1963-12-27	1963-12-27 00:00:00	32020		\N	264821	0	10509002	260139		0
57071	3386	28060	1982-06-04	1982-06-04 00:00:00	1982-06-12	1982-06-12 00:00:00	32020		\N	224610	0	43878008	28060		0
57193	3394	260139	2018-12-29	2018-12-29 00:00:00	2019-01-05	2019-01-05 00:00:00	32020		\N	225166	0	10509002	260139		0
67915	4013	4112343	2011-03-06	2011-03-06 00:00:00	2011-03-16	2011-03-16 00:00:00	32020		\N	266651	0	195662009	4112343		0
57589	3417	28060	1947-04-17	1947-04-17 00:00:00	1947-04-26	1947-04-26 00:00:00	32020		\N	226604	0	43878008	28060		0
68257	4032	40481087	1974-04-24	1974-04-24 00:00:00	1974-05-01	1974-05-01 00:00:00	32020		\N	268279	0	444814009	40481087		0
57926	3436	40481087	2014-10-15	2014-10-15 00:00:00	2014-11-05	2014-11-05 00:00:00	32020		\N	227843	0	444814009	40481087		0
58062	3440	372328	2009-07-11	2009-07-11 00:00:00	2009-08-25	2009-08-25 00:00:00	32020		\N	228265	0	65363002	372328		0
68725	4067	4152936	1977-06-23	1977-06-23 00:00:00	1977-07-14	1977-07-14 00:00:00	32020		\N	270200	0	283385000	4152936		0
58331	3456	4285898	1981-08-17	1981-08-17 00:00:00	\N	\N	32020		\N	229284	0	68496003	4285898		0
58545	3469	134438	1984-09-30	1984-09-30 00:00:00	1987-11-14	1987-11-14 00:00:00	32020		\N	230211	0	40275004	134438		0
69344	4105	28060	1950-05-24	1950-05-24 00:00:00	1950-06-06	1950-06-06 00:00:00	32020		\N	272757	0	43878008	28060		0
58803	3488	4112343	1965-08-22	1965-08-22 00:00:00	1965-09-01	1965-09-01 00:00:00	32020		\N	231341	0	195662009	4112343		0
58989	3501	4112343	1991-12-14	1991-12-14 00:00:00	1991-12-25	1991-12-25 00:00:00	32020		\N	232136	0	195662009	4112343		0
69796	4129	4278672	1988-08-24	1988-08-24 00:00:00	1988-10-23	1988-10-23 00:00:00	32020		\N	274462	0	65966004	4278672		0
80512	4771	4296205	1984-08-05	1984-08-05 00:00:00	1984-09-02	1984-09-02 00:00:00	32020		\N	317773	0	403191005	4296205		0
59508	3529	40481087	1949-12-20	1949-12-20 00:00:00	1950-01-10	1950-01-10 00:00:00	32020		\N	234438	0	444814009	40481087		0
70237	4159	4116491	2017-04-24	2017-04-24 00:00:00	2017-06-07	2017-06-07 00:00:00	32020		\N	276334	0	301011002	4116491		0
70480	4176	4109685	1927-11-13	1927-11-13 00:00:00	1927-11-27	1927-11-27 00:00:00	32020		\N	277542	0	284551006	4109685		0
70636	4191	80180	1996-10-25	1996-10-25 00:00:00	\N	\N	32020		\N	278152	0	396275006	80180		0
60251	3566	378001	1985-09-09	1985-09-09 00:00:00	1985-11-08	1985-11-08 00:00:00	32020		\N	236951	0	62106007	378001		0
60398	3572	40481087	2010-08-28	2010-08-28 00:00:00	2010-09-11	2010-09-11 00:00:00	32020		\N	237495	0	444814009	40481087		0
60470	3576	4142905	1972-10-10	1972-10-10 00:00:00	1972-11-09	1972-11-09 00:00:00	32020		\N	237709	0	33737001	4142905		0
60747	3595	260139	1973-03-31	1973-03-31 00:00:00	1973-04-14	1973-04-14 00:00:00	32020		\N	238779	0	10509002	260139		0
60842	3601	81151	2011-12-28	2011-12-28 00:00:00	2012-02-01	2012-02-01 00:00:00	32020		\N	239212	0	44465007	81151		0
71561	4243	4112343	1999-11-07	1999-11-07 00:00:00	1999-11-19	1999-11-19 00:00:00	32020		\N	281828	0	195662009	4112343		0
61215	3621	40481087	1976-01-05	1976-01-05 00:00:00	1976-01-12	1976-01-12 00:00:00	32020		\N	240592	0	444814009	40481087		0
61356	3625	4001336	2016-04-22	2016-04-22 00:00:00	2016-05-22	2016-05-22 00:00:00	32020		\N	241060	0	110030002	4001336		0
61524	3636	80180	2010-10-23	2010-10-23 00:00:00	\N	\N	32020		\N	241810	0	396275006	80180		0
61617	3639	28060	1958-11-08	1958-11-08 00:00:00	1958-11-15	1958-11-15 00:00:00	32020		\N	242029	0	43878008	28060		0
72439	4299	40481087	2007-01-07	2007-01-07 00:00:00	2007-01-14	2007-01-14 00:00:00	32020		\N	285286	0	444814009	40481087		0
72593	4312	372328	1963-04-09	1963-04-09 00:00:00	1963-08-14	1963-08-14 00:00:00	32020		\N	286110	0	65363002	372328		0
62245	3676	40481087	2011-01-18	2011-01-18 00:00:00	2011-01-25	2011-01-25 00:00:00	32020		\N	244500	0	444814009	40481087		0
73006	4338	4112343	2011-10-09	2011-10-09 00:00:00	2011-10-21	2011-10-21 00:00:00	32020		\N	287675	0	195662009	4112343		0
73062	4342	78272	1975-07-01	1975-07-01 00:00:00	1975-07-15	1975-07-15 00:00:00	32020		\N	287844	0	70704007	78272		0
62675	3701	40481087	1979-07-09	1979-07-09 00:00:00	1979-07-30	1979-07-30 00:00:00	32020		\N	246032	0	444814009	40481087		0
73425	4365	40481087	1989-03-22	1989-03-22 00:00:00	1989-03-29	1989-03-29 00:00:00	32020		\N	289509	0	444814009	40481087		0
62989	3720	260139	1957-11-17	1957-11-17 00:00:00	1957-11-24	1957-11-24 00:00:00	32020		\N	247271	0	10509002	260139		0
73782	4383	4218389	1992-07-18	1992-07-18 00:00:00	1992-08-22	1992-08-22 00:00:00	32020		\N	291358	0	39848009	4218389		0
73931	4391	260139	1947-12-04	1947-12-04 00:00:00	1947-12-18	1947-12-18 00:00:00	32020		\N	292016	0	10509002	260139		0
74086	4401	4112343	2013-01-26	2013-01-26 00:00:00	2013-02-02	2013-02-02 00:00:00	32020		\N	292593	0	195662009	4112343		0
74304	4411	4112343	1947-01-08	1947-01-08 00:00:00	1947-01-15	1947-01-15 00:00:00	32020		\N	293175	0	195662009	4112343		0
63789	3767	4112343	2011-08-07	2011-08-07 00:00:00	2011-08-19	2011-08-19 00:00:00	32020		\N	250350	0	195662009	4112343		0
64017	3783	40481087	1959-02-17	1959-02-17 00:00:00	1959-03-03	1959-03-03 00:00:00	32020		\N	251388	0	444814009	40481087		0
64101	3786	4112343	2017-08-02	2017-08-02 00:00:00	2017-08-14	2017-08-14 00:00:00	32020		\N	251644	0	195662009	4112343		0
53761	3181	192671	1987-12-16	1987-12-16 00:00:00	\N	\N	32020		\N	211686	0	K92.2	35208414		0
53886	3189	4278672	2015-10-11	2015-10-11 00:00:00	2015-12-10	2015-12-10 00:00:00	32020		\N	212275	0	65966004	4278672		0
64630	3822	40481087	2008-10-31	2008-10-31 00:00:00	2008-11-07	2008-11-07 00:00:00	32020		\N	253884	0	444814009	40481087		0
54181	3211	4278672	1966-04-19	1966-04-19 00:00:00	1966-07-18	1966-07-18 00:00:00	32020		\N	213359	0	65966004	4278672		0
54413	3223	260139	1944-02-09	1944-02-09 00:00:00	1944-02-16	1944-02-16 00:00:00	32020		\N	214323	0	10509002	260139		0
54539	3230	4112343	1966-12-28	1966-12-28 00:00:00	1967-01-07	1967-01-07 00:00:00	32020		\N	214677	0	195662009	4112343		0
54743	3240	378001	1967-03-18	1967-03-18 00:00:00	1967-05-17	1967-05-17 00:00:00	32020		\N	215432	0	62106007	378001		0
54912	3249	440086	1967-07-12	1967-07-12 00:00:00	1967-08-09	1967-08-09 00:00:00	32020		\N	215947	0	192127007	440086		0
65647	3881	4112343	1994-01-15	1994-01-15 00:00:00	1994-01-22	1994-01-22 00:00:00	32020		\N	257946	0	195662009	4112343		0
65832	3892	4027663	1993-06-22	1993-06-22 00:00:00	\N	\N	32020		\N	258814	0	13200003	4027663		0
55425	3283	4112343	2004-03-30	2004-03-30 00:00:00	2004-04-06	2004-04-06 00:00:00	32020		\N	218140	0	195662009	4112343		0
55592	3293	381316	2006-11-25	2006-11-25 00:00:00	\N	\N	32020		\N	218743	0	230690007	381316		0
55774	3301	78272	1973-01-31	1973-01-31 00:00:00	1973-02-28	1973-02-28 00:00:00	32020		\N	219285	0	70704007	78272		0
55866	3308	372328	1948-11-14	1948-11-14 00:00:00	1949-01-17	1949-01-17 00:00:00	32020		\N	219645	0	65363002	372328		0
66652	3943	40481087	1976-05-31	1976-05-31 00:00:00	1976-06-07	1976-06-07 00:00:00	32020		\N	262175	0	444814009	40481087		0
66753	3950	40481087	1999-03-09	1999-03-09 00:00:00	1999-03-16	1999-03-16 00:00:00	32020		\N	262598	0	444814009	40481087		0
66921	3957	4112343	1988-08-13	1988-08-13 00:00:00	1988-08-25	1988-08-25 00:00:00	32020		\N	263101	0	195662009	4112343		0
67067	3966	192671	2003-05-31	2003-05-31 00:00:00	\N	\N	32020		\N	263666	0	K92.2	35208414		0
67373	3982	260139	1940-08-03	1940-08-03 00:00:00	1940-08-17	1940-08-17 00:00:00	32020		\N	264708	0	10509002	260139		0
67415	3984	4112343	2005-12-16	2005-12-16 00:00:00	2005-12-27	2005-12-27 00:00:00	32020		\N	264843	0	195662009	4112343		0
57072	3386	372328	1970-10-22	1970-10-22 00:00:00	1970-11-05	1970-11-05 00:00:00	32020		\N	224643	0	65363002	372328		0
57194	3394	40481087	1997-02-21	1997-02-21 00:00:00	1997-03-07	1997-03-07 00:00:00	32020		\N	225164	0	444814009	40481087		0
67916	4013	4112343	1989-04-20	1989-04-20 00:00:00	1989-05-01	1989-05-01 00:00:00	32020		\N	266668	0	195662009	4112343		0
57590	3417	80502	1999-09-04	1999-09-04 00:00:00	\N	\N	32020		\N	226701	0	64859006	80502		0
68258	4032	4142905	1960-02-23	1960-02-23 00:00:00	1960-03-24	1960-03-24 00:00:00	32020		\N	268266	0	33737001	4142905		0
57927	3436	40481087	1967-08-24	1967-08-24 00:00:00	1967-08-31	1967-08-31 00:00:00	32020		\N	227874	0	444814009	40481087		0
58063	3440	40481087	2004-07-22	2004-07-22 00:00:00	2004-08-05	2004-08-05 00:00:00	32020		\N	228326	0	444814009	40481087		0
68726	4067	380378	1971-03-27	1971-03-27 00:00:00	\N	\N	32020		\N	270199	0	84757009	380378		0
58332	3456	30753	1980-11-20	1980-11-20 00:00:00	\N	\N	32020		\N	229284	0	16761005	30753		0
58546	3469	40481087	1967-11-02	1967-11-02 00:00:00	1967-11-23	1967-11-23 00:00:00	32020		\N	230295	0	444814009	40481087		0
69345	4105	4112343	2007-10-13	2007-10-13 00:00:00	2007-10-22	2007-10-22 00:00:00	32020		\N	272712	0	195662009	4112343		0
58804	3488	40481087	1981-04-06	1981-04-06 00:00:00	1981-04-20	1981-04-20 00:00:00	32020		\N	231382	0	444814009	40481087		0
58990	3501	4218389	1968-02-17	1968-02-17 00:00:00	1968-03-23	1968-03-23 00:00:00	32020		\N	232078	0	39848009	4218389		0
69797	4129	80180	1983-10-05	1983-10-05 00:00:00	\N	\N	32020		\N	274447	0	396275006	80180		0
80513	4771	40481087	2003-08-13	2003-08-13 00:00:00	2003-09-03	2003-09-03 00:00:00	32020		\N	317760	0	444814009	40481087		0
59509	3529	81151	1947-04-11	1947-04-11 00:00:00	1947-04-25	1947-04-25 00:00:00	32020		\N	234285	0	44465007	81151		0
70238	4159	195588	2016-03-06	2016-03-06 00:00:00	2016-04-24	2016-04-24 00:00:00	32020		\N	276352	0	38822007	195588		0
70481	4176	40481087	1968-05-09	1968-05-09 00:00:00	1968-05-23	1968-05-23 00:00:00	32020		\N	277549	0	444814009	40481087		0
70637	4191	40481087	1995-01-03	1995-01-03 00:00:00	1995-01-24	1995-01-24 00:00:00	32020		\N	278152	0	444814009	40481087		0
60252	3566	40481087	2010-12-31	2010-12-31 00:00:00	2011-01-14	2011-01-14 00:00:00	32020		\N	236982	0	444814009	40481087		0
60399	3572	4027663	1986-03-14	1986-03-14 00:00:00	\N	\N	32020		\N	237473	0	13200003	4027663		0
60471	3576	80180	2000-05-21	2000-05-21 00:00:00	\N	\N	32020		\N	237736	0	396275006	80180		0
60748	3595	40481087	2010-08-13	2010-08-13 00:00:00	2010-08-20	2010-08-20 00:00:00	32020		\N	238782	0	444814009	40481087		0
60843	3601	40481087	1985-01-05	1985-01-05 00:00:00	1985-01-26	1985-01-26 00:00:00	32020		\N	239181	0	444814009	40481087		0
71562	4243	40481087	1983-10-22	1983-10-22 00:00:00	1983-11-12	1983-11-12 00:00:00	32020		\N	281849	0	444814009	40481087		0
61216	3621	260139	1924-11-29	1924-11-29 00:00:00	1924-12-13	1924-12-13 00:00:00	32020		\N	240635	0	10509002	260139		0
61357	3625	4132546	2016-04-22	2016-04-22 00:00:00	\N	\N	32020		\N	241060	0	275272006	4166590		0
61525	3636	260139	1993-11-17	1993-11-17 00:00:00	1993-12-01	1993-12-01 00:00:00	32020		\N	241780	0	10509002	260139		0
61618	3639	40481087	1972-12-11	1972-12-11 00:00:00	1972-12-18	1972-12-18 00:00:00	32020		\N	242165	0	444814009	40481087		0
72440	4299	81151	1974-11-17	1974-11-17 00:00:00	1974-12-08	1974-12-08 00:00:00	32020		\N	285233	0	44465007	81151		0
72594	4312	40481087	1963-02-03	1963-02-03 00:00:00	1963-02-17	1963-02-17 00:00:00	32020		\N	286192	0	444814009	40481087		0
62246	3676	80180	2015-09-22	2015-09-22 00:00:00	\N	\N	32020		\N	244543	0	396275006	80180		0
73007	4338	4109685	1973-02-28	1973-02-28 00:00:00	1973-03-14	1973-03-14 00:00:00	32020		\N	287671	0	284551006	4109685		0
73063	4342	40481087	2005-10-24	2005-10-24 00:00:00	2005-11-14	2005-11-14 00:00:00	32020		\N	287888	0	444814009	40481087		0
62676	3701	260139	1980-06-14	1980-06-14 00:00:00	1980-06-23	1980-06-23 00:00:00	32020		\N	246032	0	10509002	260139		0
73426	4365	4112343	2013-01-12	2013-01-12 00:00:00	2013-01-23	2013-01-23 00:00:00	32020		\N	289540	0	195662009	4112343		0
62990	3720	4112343	1975-06-16	1975-06-16 00:00:00	1975-06-27	1975-06-27 00:00:00	32020		\N	247272	0	195662009	4112343		0
73783	4383	4112343	1984-10-05	1984-10-05 00:00:00	1984-10-15	1984-10-15 00:00:00	32020		\N	291287	0	195662009	4112343		0
73932	4391	81151	2011-10-10	2011-10-10 00:00:00	2011-10-24	2011-10-24 00:00:00	32020		\N	291941	0	44465007	81151		0
74087	4401	40481087	1985-03-16	1985-03-16 00:00:00	1985-03-23	1985-03-23 00:00:00	32020		\N	292591	0	444814009	40481087		0
74305	4411	28060	2017-06-15	2017-06-15 00:00:00	2017-06-26	2017-06-26 00:00:00	32020		\N	293166	0	43878008	28060		0
63790	3767	260139	1997-03-15	1997-03-15 00:00:00	1997-03-29	1997-03-29 00:00:00	32020		\N	250381	0	10509002	260139		0
64018	3783	4112343	1986-02-07	1986-02-07 00:00:00	1986-02-16	1986-02-16 00:00:00	32020		\N	251346	0	195662009	4112343		0
64102	3786	260139	1982-07-13	1982-07-13 00:00:00	1982-07-27	1982-07-27 00:00:00	32020		\N	251643	0	10509002	260139		0
53762	3181	260139	1966-12-25	1966-12-25 00:00:00	1967-01-01	1967-01-01 00:00:00	32020		\N	211808	0	10509002	260139		0
53887	3189	378001	1999-08-06	1999-08-06 00:00:00	1999-09-05	1999-09-05 00:00:00	32020		\N	212273	0	62106007	378001		0
64631	3822	4112343	1959-09-03	1959-09-03 00:00:00	1959-09-12	1959-09-12 00:00:00	32020		\N	253899	0	195662009	4112343		0
54182	3211	260139	1961-06-02	1961-06-02 00:00:00	1961-06-16	1961-06-16 00:00:00	32020		\N	213363	0	10509002	260139		0
54414	3223	255848	1998-07-03	1998-07-03 00:00:00	\N	\N	32020		\N	214333	0	233604007	255848		0
54540	3230	4296204	1962-09-07	1962-09-07 00:00:00	1962-10-05	1962-10-05 00:00:00	32020		\N	214643	0	403190006	4296204		0
54744	3240	4283893	1976-08-13	1976-08-13 00:00:00	1976-11-05	1976-11-05 00:00:00	32020		\N	215411	0	36971009	4283893		0
54913	3249	4059173	1999-09-14	1999-09-14 00:00:00	1999-10-14	1999-10-14 00:00:00	32020		\N	215990	0	16114001	4059173		0
65648	3881	260139	2015-11-28	2015-11-28 00:00:00	2015-12-12	2015-12-12 00:00:00	32020		\N	257890	0	10509002	260139		0
65833	3892	40481087	1987-05-07	1987-05-07 00:00:00	1987-05-14	1987-05-14 00:00:00	32020		\N	258823	0	444814009	40481087		0
55426	3283	195588	2005-07-07	2005-07-07 00:00:00	2005-08-17	2005-08-17 00:00:00	32020		\N	218110	0	38822007	195588		0
55593	3293	4218389	1984-10-29	1984-10-29 00:00:00	1984-11-26	1984-11-26 00:00:00	32020		\N	218667	0	39848009	4218389		0
55775	3301	4112343	1970-08-22	1970-08-22 00:00:00	1970-09-01	1970-09-01 00:00:00	32020		\N	219329	0	195662009	4112343		0
55867	3308	40481087	1987-11-22	1987-11-22 00:00:00	1987-12-13	1987-12-13 00:00:00	32020		\N	219644	0	444814009	40481087		0
66653	3943	40479768	1973-03-14	1973-03-14 00:00:00	1973-04-20	1973-04-20 00:00:00	32020		\N	262137	0	444470001	40479768		0
66754	3950	40481087	2011-08-31	2011-08-31 00:00:00	2011-09-21	2011-09-21 00:00:00	32020		\N	262592	0	444814009	40481087		0
66922	3957	260139	2006-08-22	2006-08-22 00:00:00	2006-09-05	2006-09-05 00:00:00	32020		\N	263088	0	10509002	260139		0
67068	3966	4294548	2016-09-30	2016-09-30 00:00:00	2016-12-16	2016-12-16 00:00:00	32020		\N	263637	0	75498004	4294548		0
67374	3982	257012	1965-12-17	1965-12-17 00:00:00	\N	\N	32020		\N	264728	0	40055000	257012		0
67416	3984	260139	1975-05-09	1975-05-09 00:00:00	1975-05-16	1975-05-16 00:00:00	32020		\N	264808	0	10509002	260139		0
57073	3386	40481087	1981-08-18	1981-08-18 00:00:00	1981-09-01	1981-09-01 00:00:00	32020		\N	224639	0	444814009	40481087		0
57195	3394	4112343	1982-06-17	1982-06-17 00:00:00	1982-06-27	1982-06-27 00:00:00	32020		\N	225142	0	195662009	4112343		0
67917	4013	260139	2008-11-10	2008-11-10 00:00:00	2008-11-17	2008-11-17 00:00:00	32020		\N	266664	0	10509002	260139		0
57591	3417	4113008	1937-04-20	1937-04-20 00:00:00	1937-05-11	1937-05-11 00:00:00	32020		\N	226622	0	284549007	4113008		0
68259	4032	4112343	1989-12-14	1989-12-14 00:00:00	1989-12-22	1989-12-22 00:00:00	32020		\N	268273	0	195662009	4112343		0
57928	3436	192671	2003-05-03	2003-05-03 00:00:00	\N	\N	32020		\N	227919	0	K92.2	35208414		0
58064	3440	4134304	2015-10-29	2015-10-29 00:00:00	2015-11-28	2015-11-28 00:00:00	32020		\N	228232	0	263102004	4134304		0
68727	4067	4029498	1971-03-27	1971-03-27 00:00:00	\N	\N	32020		\N	270199	0	128613002	4029498		0
58333	3456	81893	1980-02-24	1980-02-24 00:00:00	\N	\N	32020		\N	229284	0	64766004	81893		0
58547	3469	4134304	1986-02-08	1986-02-08 00:00:00	1986-05-09	1986-05-09 00:00:00	32020		\N	230251	0	263102004	4134304		0
69346	4105	260139	1957-05-14	1957-05-14 00:00:00	1957-05-28	1957-05-28 00:00:00	32020		\N	272696	0	10509002	260139		0
58805	3488	260139	2000-01-19	2000-01-19 00:00:00	2000-01-26	2000-01-26 00:00:00	32020		\N	231416	0	10509002	260139		0
58991	3501	40481087	2003-03-09	2003-03-09 00:00:00	2003-03-23	2003-03-23 00:00:00	32020		\N	232089	0	444814009	40481087		0
69798	4129	28060	1950-11-14	1950-11-14 00:00:00	1950-11-23	1950-11-23 00:00:00	32020		\N	274452	0	43878008	28060		0
80514	4771	40481087	1992-05-23	1992-05-23 00:00:00	1992-06-06	1992-06-06 00:00:00	32020		\N	317737	0	444814009	40481087		0
59510	3529	260139	1993-04-11	1993-04-11 00:00:00	1993-04-18	1993-04-18 00:00:00	32020		\N	234407	0	10509002	260139		0
70239	4159	257012	1991-05-06	1991-05-06 00:00:00	\N	\N	32020		\N	276328	0	40055000	257012		0
70482	4176	378001	2007-09-17	2007-09-17 00:00:00	2007-11-16	2007-11-16 00:00:00	32020		\N	277545	0	62106007	378001		0
70638	4191	4112343	1961-04-12	1961-04-12 00:00:00	1961-04-22	1961-04-22 00:00:00	32020		\N	278136	0	195662009	4112343		0
60253	3566	440086	1958-07-21	1958-07-21 00:00:00	1961-04-10	1961-04-10 00:00:00	32020		\N	236922	0	192127007	440086		0
60400	3572	372328	1959-02-23	1959-02-23 00:00:00	1959-08-26	1959-08-26 00:00:00	32020		\N	237465	0	65363002	372328		0
60472	3576	4035415	2010-11-11	2010-11-11 00:00:00	2010-12-11	2010-12-11 00:00:00	32020		\N	237713	0	239720000	4035415		0
60749	3595	260139	1999-11-02	1999-11-02 00:00:00	1999-11-16	1999-11-16 00:00:00	32020		\N	238790	0	10509002	260139		0
60844	3601	40481087	1967-05-13	1967-05-13 00:00:00	1967-06-03	1967-06-03 00:00:00	32020		\N	239139	0	444814009	40481087		0
71563	4243	40481087	1979-05-22	1979-05-22 00:00:00	1979-05-29	1979-05-29 00:00:00	32020		\N	281859	0	444814009	40481087		0
61217	3621	40481087	1980-10-20	1980-10-20 00:00:00	1980-11-10	1980-11-10 00:00:00	32020		\N	240580	0	444814009	40481087		0
61358	3625	40481087	1964-05-07	1964-05-07 00:00:00	1964-05-28	1964-05-28 00:00:00	32020		\N	241044	0	444814009	40481087		0
61526	3636	260139	2006-05-03	2006-05-03 00:00:00	2006-05-17	2006-05-17 00:00:00	32020		\N	241783	0	10509002	260139		0
61619	3639	260139	1960-09-29	1960-09-29 00:00:00	1960-10-06	1960-10-06 00:00:00	32020		\N	242063	0	10509002	260139		0
72441	4299	4112343	1995-02-09	1995-02-09 00:00:00	1995-02-17	1995-02-17 00:00:00	32020		\N	285285	0	195662009	4112343		0
72595	4312	4112343	1963-08-28	1963-08-28 00:00:00	1963-09-10	1963-09-10 00:00:00	32020		\N	286109	0	195662009	4112343		0
62247	3676	260139	1978-05-22	1978-05-22 00:00:00	1978-05-29	1978-05-29 00:00:00	32020		\N	244507	0	10509002	260139		0
73008	4338	372328	2011-12-06	2011-12-06 00:00:00	2013-10-19	2013-10-19 00:00:00	32020		\N	287646	0	65363002	372328		0
73064	4342	260139	1998-08-05	1998-08-05 00:00:00	1998-08-12	1998-08-12 00:00:00	32020		\N	287877	0	10509002	260139		0
62677	3701	260139	2004-10-01	2004-10-01 00:00:00	2004-10-08	2004-10-08 00:00:00	32020		\N	246080	0	10509002	260139		0
73427	4365	260139	1958-03-18	1958-03-18 00:00:00	1958-04-01	1958-04-01 00:00:00	32020		\N	289541	0	10509002	260139		0
62991	3720	4296204	1996-09-13	1996-09-13 00:00:00	1996-09-27	1996-09-27 00:00:00	32020		\N	247320	0	403190006	4296204		0
73784	4383	40481087	1970-10-13	1970-10-13 00:00:00	1970-10-27	1970-10-27 00:00:00	32020		\N	291305	0	444814009	40481087		0
73933	4391	4048171	1945-02-13	1945-02-13 00:00:00	1960-02-12	1960-02-12 00:00:00	32020		\N	291945	0	232353008	4048171		0
74088	4401	40481087	1989-01-10	1989-01-10 00:00:00	1989-01-17	1989-01-17 00:00:00	32020		\N	292547	0	444814009	40481087		0
74306	4411	40481087	1979-02-16	1979-02-16 00:00:00	1979-02-23	1979-02-23 00:00:00	32020		\N	293230	0	444814009	40481087		0
63791	3767	4112343	2019-06-28	2019-06-28 00:00:00	\N	\N	32020		\N	250353	0	195662009	4112343		0
64019	3783	40481087	1953-05-05	1953-05-05 00:00:00	1953-05-12	1953-05-12 00:00:00	32020		\N	251387	0	444814009	40481087		0
64103	3786	80180	1995-04-19	1995-04-19 00:00:00	\N	\N	32020		\N	251675	0	396275006	80180		0
53763	3181	40481087	1956-04-17	1956-04-17 00:00:00	1956-04-24	1956-04-24 00:00:00	32020		\N	211807	0	444814009	40481087		0
53888	3189	260139	2002-12-01	2002-12-01 00:00:00	2002-12-15	2002-12-15 00:00:00	32020		\N	212234	0	10509002	260139		0
64632	3822	4059173	1988-07-09	1988-07-09 00:00:00	1988-10-07	1988-10-07 00:00:00	32020		\N	253836	0	16114001	4059173		0
54183	3211	28060	2009-03-31	2009-03-31 00:00:00	2009-04-12	2009-04-12 00:00:00	32020		\N	213333	0	43878008	28060		0
54415	3223	260139	1923-07-14	1923-07-14 00:00:00	1923-07-28	1923-07-28 00:00:00	32020		\N	214258	0	10509002	260139		0
54541	3230	40481087	2000-07-16	2000-07-16 00:00:00	2000-08-06	2000-08-06 00:00:00	32020		\N	214671	0	444814009	40481087		0
54745	3240	40481087	2006-11-21	2006-11-21 00:00:00	2006-11-28	2006-11-28 00:00:00	32020		\N	215388	0	444814009	40481087		0
54914	3249	28060	2008-02-04	2008-02-04 00:00:00	2008-02-15	2008-02-15 00:00:00	32020		\N	216015	0	43878008	28060		0
65649	3881	40481087	1998-11-04	1998-11-04 00:00:00	1998-11-11	1998-11-11 00:00:00	32020		\N	257948	0	444814009	40481087		0
65834	3892	4294548	1973-04-09	1973-04-09 00:00:00	1973-05-21	1973-05-21 00:00:00	32020		\N	258821	0	75498004	4294548		0
55427	3283	40481087	1998-05-26	1998-05-26 00:00:00	1998-06-02	1998-06-02 00:00:00	32020		\N	218102	0	444814009	40481087		0
55594	3293	4027663	1943-03-09	1943-03-09 00:00:00	\N	\N	32020		\N	218770	0	13200003	4027663		0
55776	3301	260139	1975-11-19	1975-11-19 00:00:00	1975-11-26	1975-11-26 00:00:00	32020		\N	219330	0	10509002	260139		0
55868	3308	260139	1991-02-05	1991-02-05 00:00:00	1991-02-19	1991-02-19 00:00:00	32020		\N	219642	0	10509002	260139		0
66654	3943	40481087	2004-02-22	2004-02-22 00:00:00	2004-03-07	2004-03-07 00:00:00	32020		\N	262151	0	444814009	40481087		0
66755	3950	40481087	1984-01-09	1984-01-09 00:00:00	1984-01-23	1984-01-23 00:00:00	32020		\N	262584	0	444814009	40481087		0
66923	3957	260139	1971-03-04	1971-03-04 00:00:00	1971-03-11	1971-03-11 00:00:00	32020		\N	263099	0	10509002	260139		0
67069	3966	4152936	1977-06-29	1977-06-29 00:00:00	1977-07-13	1977-07-13 00:00:00	32020		\N	263663	0	283385000	4152936		0
67375	3982	81151	2010-06-17	2010-06-17 00:00:00	2010-07-15	2010-07-15 00:00:00	32020		\N	264676	0	44465007	81151		0
67417	3984	260139	1965-05-23	1965-05-23 00:00:00	1965-05-30	1965-05-30 00:00:00	32020		\N	264806	0	10509002	260139		0
57074	3386	4113008	2019-02-04	2019-02-04 00:00:00	2019-02-18	2019-02-18 00:00:00	32020		\N	224633	0	284549007	4113008		0
57196	3394	260139	2016-02-17	2016-02-17 00:00:00	2016-03-02	2016-03-02 00:00:00	32020		\N	225120	0	10509002	260139		0
67918	4013	40481087	2002-02-08	2002-02-08 00:00:00	2002-03-01	2002-03-01 00:00:00	32020		\N	266642	0	444814009	40481087		0
57592	3417	28060	1917-04-18	1917-04-18 00:00:00	1917-04-29	1917-04-29 00:00:00	32020		\N	226602	0	43878008	28060		0
68260	4032	4112343	1968-01-29	1968-01-29 00:00:00	1968-02-11	1968-02-11 00:00:00	32020		\N	268218	0	195662009	4112343		0
57929	3436	4112343	1967-06-03	1967-06-03 00:00:00	1967-06-13	1967-06-13 00:00:00	32020		\N	227890	0	195662009	4112343		0
58065	3440	40481087	1949-02-01	1949-02-01 00:00:00	1949-02-15	1949-02-15 00:00:00	32020		\N	228328	0	444814009	40481087		0
68729	4067	4112343	2015-08-27	2015-08-27 00:00:00	2015-09-06	2015-09-06 00:00:00	32020		\N	270208	0	195662009	4112343		0
58334	3456	4218389	1977-08-22	1977-08-22 00:00:00	1977-09-12	1977-09-12 00:00:00	32020		\N	229294	0	39848009	4218389		0
58548	3469	372328	1956-11-09	1956-11-09 00:00:00	1957-09-11	1957-09-11 00:00:00	32020		\N	230276	0	65363002	372328		0
69347	4105	372328	1951-10-12	1951-10-12 00:00:00	1952-02-23	1952-02-23 00:00:00	32020		\N	272778	0	65363002	372328		0
58806	3488	372328	1959-10-14	1959-10-14 00:00:00	1960-02-05	1960-02-05 00:00:00	32020		\N	231388	0	65363002	372328		0
58992	3501	4296204	1995-07-13	1995-07-13 00:00:00	1995-07-27	1995-07-27 00:00:00	32020		\N	232061	0	403190006	4296204		0
69799	4130	4112343	2017-10-15	2017-10-15 00:00:00	2017-10-22	2017-10-22 00:00:00	32020		\N	274610	0	195662009	4112343		0
80515	4771	40481087	1977-05-23	1977-05-23 00:00:00	1977-06-06	1977-06-06 00:00:00	32020		\N	317759	0	444814009	40481087		0
59511	3529	4283893	1945-01-28	1945-01-28 00:00:00	1945-03-11	1945-03-11 00:00:00	32020		\N	234443	0	36971009	4283893		0
70240	4159	4112343	2005-11-04	2005-11-04 00:00:00	2005-11-11	2005-11-11 00:00:00	32020		\N	276331	0	195662009	4112343		0
70483	4176	40481087	1953-10-08	1953-10-08 00:00:00	1953-10-29	1953-10-29 00:00:00	32020		\N	277548	0	444814009	40481087		0
70639	4191	260139	1973-08-24	1973-08-24 00:00:00	1973-08-31	1973-08-31 00:00:00	32020		\N	278151	0	10509002	260139		0
60254	3566	40481087	1980-07-10	1980-07-10 00:00:00	1980-07-31	1980-07-31 00:00:00	32020		\N	236919	0	444814009	40481087		0
60401	3572	378001	1958-03-11	1958-03-11 00:00:00	1958-04-10	1958-04-10 00:00:00	32020		\N	237441	0	62106007	378001		0
60473	3576	4294548	2013-01-27	2013-01-27 00:00:00	2013-07-14	2013-07-14 00:00:00	32020		\N	237695	0	75498004	4294548		0
60750	3595	80180	1993-10-20	1993-10-20 00:00:00	\N	\N	32020		\N	238807	0	396275006	80180		0
60845	3601	260139	1971-09-24	1971-09-24 00:00:00	1971-10-08	1971-10-08 00:00:00	32020		\N	239150	0	10509002	260139		0
71564	4243	40481087	2017-08-09	2017-08-09 00:00:00	2017-08-30	2017-08-30 00:00:00	32020		\N	281843	0	444814009	40481087		0
61218	3621	4112343	1924-12-29	1924-12-29 00:00:00	1925-01-09	1925-01-09 00:00:00	32020		\N	240590	0	195662009	4112343		0
61359	3625	260139	1979-10-20	1979-10-20 00:00:00	1979-11-03	1979-11-03 00:00:00	32020		\N	241037	0	10509002	260139		0
61527	3636	372328	1973-10-07	1973-10-07 00:00:00	1973-12-21	1973-12-21 00:00:00	32020		\N	241843	0	65363002	372328		0
61620	3639	80180	1957-01-18	1957-01-18 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
72442	4299	40481087	1973-07-20	1973-07-20 00:00:00	1973-08-10	1973-08-10 00:00:00	32020		\N	285283	0	444814009	40481087		0
72596	4312	40486433	1962-09-22	1962-09-22 00:00:00	\N	\N	32020		\N	286210	0	446096008	40486433		0
62248	3676	40481087	1994-09-19	1994-09-19 00:00:00	1994-09-26	1994-09-26 00:00:00	32020		\N	244525	0	444814009	40481087		0
73009	4338	4112343	2005-04-28	2005-04-28 00:00:00	2005-05-10	2005-05-10 00:00:00	32020		\N	287674	0	195662009	4112343		0
73065	4342	4112343	2013-02-04	2013-02-04 00:00:00	2013-02-16	2013-02-16 00:00:00	32020		\N	287956	0	195662009	4112343		0
62678	3701	4112343	2005-11-15	2005-11-15 00:00:00	2005-11-24	2005-11-24 00:00:00	32020		\N	246129	0	195662009	4112343		0
73428	4365	40481087	1991-07-18	1991-07-18 00:00:00	1991-08-01	1991-08-01 00:00:00	32020		\N	289539	0	444814009	40481087		0
62992	3720	40481087	1997-04-16	1997-04-16 00:00:00	1997-04-23	1997-04-23 00:00:00	32020		\N	247235	0	444814009	40481087		0
73785	4383	4155034	1970-09-07	1970-09-07 00:00:00	1970-09-28	1970-09-28 00:00:00	32020		\N	291334	0	283371005	4155034		0
73934	4391	4035415	2012-09-18	2012-09-18 00:00:00	2012-10-18	2012-10-18 00:00:00	32020		\N	291942	0	239720000	4035415		0
74089	4401	40481087	1995-11-29	1995-11-29 00:00:00	1995-12-06	1995-12-06 00:00:00	32020		\N	292549	0	444814009	40481087		0
74307	4411	260139	1951-04-24	1951-04-24 00:00:00	1951-05-01	1951-05-01 00:00:00	32020		\N	293227	0	10509002	260139		0
63792	3767	372328	1989-07-19	1989-07-19 00:00:00	1990-01-26	1990-01-26 00:00:00	32020		\N	250383	0	65363002	372328		0
64020	3783	4084167	1940-12-01	1940-12-01 00:00:00	1940-12-01	1940-12-01 00:00:00	32020		\N	251449	0	241929008	4084167		0
64104	3787	40481087	1993-08-20	1993-08-20 00:00:00	1993-09-03	1993-09-03 00:00:00	32020		\N	251765	0	444814009	40481087		0
53764	3181	78272	1964-11-04	1964-11-04 00:00:00	1964-11-25	1964-11-25 00:00:00	32020		\N	211654	0	70704007	78272		0
53889	3189	40481087	1972-03-18	1972-03-18 00:00:00	1972-04-01	1972-04-01 00:00:00	32020		\N	212218	0	444814009	40481087		0
64633	3822	4112343	1978-03-21	1978-03-21 00:00:00	1978-04-02	1978-04-02 00:00:00	32020		\N	253847	0	195662009	4112343		0
54184	3211	4152936	1970-05-12	1970-05-12 00:00:00	1970-06-02	1970-06-02 00:00:00	32020		\N	213361	0	283385000	4152936		0
54416	3223	40481087	1953-01-02	1953-01-02 00:00:00	1953-01-23	1953-01-23 00:00:00	32020		\N	214241	0	444814009	40481087		0
54542	3230	40481087	2005-03-31	2005-03-31 00:00:00	2005-04-14	2005-04-14 00:00:00	32020		\N	214687	0	444814009	40481087		0
54746	3240	4059173	1951-05-27	1951-05-27 00:00:00	1951-08-25	1951-08-25 00:00:00	32020		\N	215430	0	16114001	4059173		0
54915	3249	372328	1973-06-16	1973-06-16 00:00:00	1973-08-26	1973-08-26 00:00:00	32020		\N	216017	0	65363002	372328		0
65650	3881	40481087	1975-03-15	1975-03-15 00:00:00	1975-03-29	1975-03-29 00:00:00	32020		\N	257882	0	444814009	40481087		0
65835	3892	81893	1999-09-14	1999-09-14 00:00:00	\N	\N	32020		\N	258830	0	64766004	81893		0
55428	3283	4027663	2008-07-06	2008-07-06 00:00:00	\N	\N	32020		\N	218119	0	13200003	4027663		0
55595	3293	40481087	1923-09-23	1923-09-23 00:00:00	1923-10-07	1923-10-07 00:00:00	32020		\N	218704	0	444814009	40481087		0
66235	3920	40481087	2003-01-10	2003-01-10 00:00:00	2003-01-31	2003-01-31 00:00:00	32020		\N	260688	0	444814009	40481087		0
55869	3308	4112343	1957-06-20	1957-06-20 00:00:00	1957-06-30	1957-06-30 00:00:00	32020		\N	219663	0	195662009	4112343		0
66655	3943	4134304	2018-07-23	2018-07-23 00:00:00	2018-10-21	2018-10-21 00:00:00	32020		\N	262139	0	263102004	4134304		0
66756	3950	4285898	2014-02-07	2014-02-07 00:00:00	\N	\N	32020		\N	262540	0	68496003	4285898		0
66924	3957	260139	1989-11-26	1989-11-26 00:00:00	1989-12-10	1989-12-10 00:00:00	32020		\N	263139	0	10509002	260139		0
67070	3966	40481087	1996-07-05	1996-07-05 00:00:00	1996-07-19	1996-07-19 00:00:00	32020		\N	263705	0	444814009	40481087		0
67376	3982	260139	2007-12-10	2007-12-10 00:00:00	2007-12-24	2007-12-24 00:00:00	32020		\N	264731	0	10509002	260139		0
67431	3986	40481087	2001-07-29	2001-07-29 00:00:00	2001-08-19	2001-08-19 00:00:00	32020		\N	264987	0	444814009	40481087		0
57075	3386	4116491	2009-11-21	2009-11-21 00:00:00	2009-12-24	2009-12-24 00:00:00	32020		\N	224635	0	301011002	4116491		0
57197	3394	40481087	1971-09-06	1971-09-06 00:00:00	1971-09-13	1971-09-13 00:00:00	32020		\N	225112	0	444814009	40481087		0
67919	4013	80180	2015-04-26	2015-04-26 00:00:00	\N	\N	32020		\N	266663	0	396275006	80180		0
57593	3417	40481087	2016-03-25	2016-03-25 00:00:00	2016-04-15	2016-04-15 00:00:00	32020		\N	226657	0	444814009	40481087		0
68261	4032	375671	1979-09-11	1979-09-11 00:00:00	1979-11-10	1979-11-10 00:00:00	32020		\N	268268	0	62564004	375671		0
57930	3436	372328	1965-03-31	1965-03-31 00:00:00	1965-08-09	1965-08-09 00:00:00	32020		\N	227844	0	65363002	372328		0
58066	3440	28060	1980-12-12	1980-12-12 00:00:00	1980-12-22	1980-12-22 00:00:00	32020		\N	228260	0	43878008	28060		0
68730	4067	28060	1987-01-04	1987-01-04 00:00:00	1987-01-15	1987-01-15 00:00:00	32020		\N	270203	0	43878008	28060		0
58335	3456	372328	1943-07-08	1943-07-08 00:00:00	1943-08-19	1943-08-19 00:00:00	32020		\N	229300	0	65363002	372328		0
58549	3469	80180	1991-04-15	1991-04-15 00:00:00	\N	\N	32020		\N	230252	0	396275006	80180		0
69348	4105	80180	1983-04-12	1983-04-12 00:00:00	\N	\N	32020		\N	272746	0	396275006	80180		0
58807	3488	372328	1955-05-23	1955-05-23 00:00:00	1955-07-29	1955-07-29 00:00:00	32020		\N	231346	0	65363002	372328		0
58993	3501	4112343	1997-07-01	1997-07-01 00:00:00	1997-07-10	1997-07-10 00:00:00	32020		\N	232048	0	195662009	4112343		0
69800	4130	81151	1998-11-19	1998-11-19 00:00:00	1998-12-24	1998-12-24 00:00:00	32020		\N	274665	0	44465007	81151		0
80516	4771	4294548	1957-07-08	1957-07-08 00:00:00	1957-07-22	1957-07-22 00:00:00	32020		\N	317736	0	75498004	4294548		0
59512	3529	4112343	1972-01-04	1972-01-04 00:00:00	1972-01-15	1972-01-15 00:00:00	32020		\N	234396	0	195662009	4112343		0
70241	4160	260139	2004-05-13	2004-05-13 00:00:00	2004-05-27	2004-05-27 00:00:00	32020		\N	276457	0	10509002	260139		0
70484	4176	381316	2003-10-23	2003-10-23 00:00:00	\N	\N	32020		\N	277487	0	230690007	381316		0
70640	4191	28060	1977-07-10	1977-07-10 00:00:00	1977-07-22	1977-07-22 00:00:00	32020		\N	278126	0	43878008	28060		0
60255	3566	40481087	2013-08-10	2013-08-10 00:00:00	2013-08-17	2013-08-17 00:00:00	32020		\N	236853	0	444814009	40481087		0
60402	3572	192671	1993-11-20	1993-11-20 00:00:00	\N	\N	32020		\N	237446	0	K92.2	35208414		0
60474	3576	40481087	2011-05-16	2011-05-16 00:00:00	2011-05-30	2011-05-30 00:00:00	32020		\N	237720	0	444814009	40481087		0
60751	3595	4156265	1987-07-29	1987-07-29 00:00:00	1987-08-19	1987-08-19 00:00:00	32020		\N	238832	0	370247008	4156265		0
60846	3601	260139	2011-08-26	2011-08-26 00:00:00	2011-09-09	2011-09-09 00:00:00	32020		\N	239251	0	10509002	260139		0
71573	4246	40481087	1971-03-08	1971-03-08 00:00:00	1971-03-29	1971-03-29 00:00:00	32020		\N	281954	0	444814009	40481087		0
61219	3621	80180	1955-08-27	1955-08-27 00:00:00	\N	\N	32020		\N	240574	0	396275006	80180		0
61360	3625	4113008	2000-07-03	2000-07-03 00:00:00	2000-07-24	2000-07-24 00:00:00	32020		\N	241058	0	284549007	4113008		0
61528	3636	4294548	1999-04-15	1999-04-15 00:00:00	1999-08-12	1999-08-12 00:00:00	32020		\N	241856	0	75498004	4294548		0
61621	3639	372328	1924-05-31	1924-05-31 00:00:00	1924-07-19	1924-07-19 00:00:00	32020		\N	242040	0	65363002	372328		0
72443	4299	4218389	1996-10-11	1996-10-11 00:00:00	1996-11-08	1996-11-08 00:00:00	32020		\N	285235	0	39848009	4218389		0
72597	4312	4084167	1961-02-07	1961-02-07 00:00:00	1961-02-08	1961-02-08 00:00:00	32020		\N	286132	0	241929008	4084167		0
62249	3676	321042	1997-02-13	1997-02-13 00:00:00	\N	\N	32020		\N	244486	0	410429000	321042		0
73010	4338	40481087	1975-11-24	1975-11-24 00:00:00	1975-12-01	1975-12-01 00:00:00	32020		\N	287645	0	444814009	40481087		0
73066	4342	4113008	2015-08-05	2015-08-05 00:00:00	2015-08-26	2015-08-26 00:00:00	32020		\N	287847	0	284549007	4113008		0
62679	3701	40479422	1984-12-18	1984-12-18 00:00:00	1985-01-24	1985-01-24 00:00:00	32020		\N	246068	0	444448004	40479422		0
73429	4365	4296205	1985-07-08	1985-07-08 00:00:00	1985-07-29	1985-07-29 00:00:00	32020		\N	289590	0	403191005	4296205		0
62993	3720	40481087	2008-02-13	2008-02-13 00:00:00	2008-03-05	2008-03-05 00:00:00	32020		\N	247246	0	444814009	40481087		0
73786	4383	40481087	2014-06-12	2014-06-12 00:00:00	2014-07-03	2014-07-03 00:00:00	32020		\N	291328	0	444814009	40481087		0
73935	4391	40481087	1961-10-22	1961-10-22 00:00:00	1961-10-29	1961-10-29 00:00:00	32020		\N	291947	0	444814009	40481087		0
74090	4401	40481087	2016-05-07	2016-05-07 00:00:00	2016-05-14	2016-05-14 00:00:00	32020		\N	292540	0	444814009	40481087		0
74308	4411	4112343	2002-01-09	2002-01-09 00:00:00	2002-01-19	2002-01-19 00:00:00	32020		\N	293182	0	195662009	4112343		0
63793	3767	4112343	1998-06-20	1998-06-20 00:00:00	1998-07-01	1998-07-01 00:00:00	32020		\N	250338	0	195662009	4112343		0
64021	3783	81151	2005-09-21	2005-09-21 00:00:00	2005-10-19	2005-10-19 00:00:00	32020		\N	251452	0	44465007	81151		0
64105	3787	260139	1978-07-16	1978-07-16 00:00:00	1978-07-23	1978-07-23 00:00:00	32020		\N	251733	0	10509002	260139		0
53765	3181	372328	1951-10-14	1951-10-14 00:00:00	1951-12-21	1951-12-21 00:00:00	32020		\N	211776	0	65363002	372328		0
53890	3189	4112343	1968-08-31	1968-08-31 00:00:00	1968-09-09	1968-09-09 00:00:00	32020		\N	212217	0	195662009	4112343		0
64634	3822	28060	1948-01-12	1948-01-12 00:00:00	1948-01-24	1948-01-24 00:00:00	32020		\N	253862	0	43878008	28060		0
54185	3211	28060	1963-10-19	1963-10-19 00:00:00	1963-11-01	1963-11-01 00:00:00	32020		\N	213330	0	43878008	28060		0
54417	3223	40481087	1992-03-13	1992-03-13 00:00:00	1992-03-20	1992-03-20 00:00:00	32020		\N	214284	0	444814009	40481087		0
54543	3230	40481087	1977-05-21	1977-05-21 00:00:00	1977-06-11	1977-06-11 00:00:00	32020		\N	214669	0	444814009	40481087		0
54747	3240	4109685	1963-02-23	1963-02-23 00:00:00	1963-03-09	1963-03-09 00:00:00	32020		\N	215431	0	284551006	4109685		0
54916	3249	40481087	1974-09-17	1974-09-17 00:00:00	1974-10-08	1974-10-08 00:00:00	32020		\N	215963	0	444814009	40481087		0
65651	3881	317576	1986-11-07	1986-11-07 00:00:00	\N	\N	32020		\N	257907	0	53741008	317576		0
65836	3892	30753	2000-08-09	2000-08-09 00:00:00	\N	\N	32020		\N	258831	0	16761005	30753		0
55437	3285	78272	1964-05-17	1964-05-17 00:00:00	1964-06-14	1964-06-14 00:00:00	32020		\N	218177	0	70704007	78272		0
55596	3293	372328	1917-04-19	1917-04-19 00:00:00	1918-03-02	1918-03-02 00:00:00	32020		\N	218710	0	65363002	372328		0
66236	3920	260139	1999-01-16	1999-01-16 00:00:00	1999-01-30	1999-01-30 00:00:00	32020		\N	260672	0	10509002	260139		0
55870	3308	40481087	1954-05-11	1954-05-11 00:00:00	1954-06-01	1954-06-01 00:00:00	32020		\N	219658	0	444814009	40481087		0
66656	3943	4142905	1986-02-11	1986-02-11 00:00:00	1986-03-13	1986-03-13 00:00:00	32020		\N	262138	0	33737001	4142905		0
66757	3950	40481087	2013-08-12	2013-08-12 00:00:00	2013-09-02	2013-09-02 00:00:00	32020		\N	262540	0	444814009	40481087		0
66925	3957	261325	1996-12-19	1996-12-19 00:00:00	\N	\N	32020		\N	263068	0	87433001	261325		0
67071	3966	257012	1971-07-02	1971-07-02 00:00:00	\N	\N	32020		\N	263684	0	40055000	257012		0
67377	3982	260139	2015-01-17	2015-01-17 00:00:00	2015-01-24	2015-01-24 00:00:00	32020		\N	264754	0	10509002	260139		0
67432	3986	81151	2011-08-06	2011-08-06 00:00:00	2011-09-03	2011-09-03 00:00:00	32020		\N	265024	0	44465007	81151		0
57076	3386	4112343	1973-04-10	1973-04-10 00:00:00	1973-04-21	1973-04-21 00:00:00	32020		\N	224678	0	195662009	4112343		0
67920	4013	40481087	2006-01-27	2006-01-27 00:00:00	2006-02-03	2006-02-03 00:00:00	32020		\N	266630	0	444814009	40481087		0
57594	3417	4112343	1916-10-09	1916-10-09 00:00:00	1916-10-17	1916-10-17 00:00:00	32020		\N	226577	0	195662009	4112343		0
68262	4032	40481087	1962-08-09	1962-08-09 00:00:00	1962-08-23	1962-08-23 00:00:00	32020		\N	268230	0	444814009	40481087		0
57931	3436	4116491	1997-11-03	1997-11-03 00:00:00	1997-12-19	1997-12-19 00:00:00	32020		\N	227881	0	301011002	4116491		0
58067	3440	40481087	1998-11-02	1998-11-02 00:00:00	1998-11-16	1998-11-16 00:00:00	32020		\N	228333	0	444814009	40481087		0
68731	4067	4112343	2013-07-26	2013-07-26 00:00:00	2013-08-06	2013-08-06 00:00:00	32020		\N	270207	0	195662009	4112343		0
58336	3456	4027663	1972-12-02	1972-12-02 00:00:00	\N	\N	32020		\N	229278	0	13200003	4027663		0
58550	3469	78272	1989-06-22	1989-06-22 00:00:00	1989-07-27	1989-07-27 00:00:00	32020		\N	230252	0	70704007	78272		0
69349	4105	40481087	1953-09-10	1953-09-10 00:00:00	1953-09-24	1953-09-24 00:00:00	32020		\N	272758	0	444814009	40481087		0
58808	3488	4218389	1967-12-08	1967-12-08 00:00:00	1968-01-05	1968-01-05 00:00:00	32020		\N	231355	0	39848009	4218389		0
58994	3501	260139	1962-08-16	1962-08-16 00:00:00	1962-08-23	1962-08-23 00:00:00	32020		\N	232080	0	10509002	260139		0
69801	4130	40481087	1993-07-20	1993-07-20 00:00:00	1993-08-03	1993-08-03 00:00:00	32020		\N	274658	0	444814009	40481087		0
80517	4771	4112343	1963-04-26	1963-04-26 00:00:00	1963-05-07	1963-05-07 00:00:00	32020		\N	317756	0	195662009	4112343		0
59513	3529	40481087	2011-02-14	2011-02-14 00:00:00	2011-02-21	2011-02-21 00:00:00	32020		\N	234307	0	444814009	40481087		0
70242	4160	260139	2015-07-09	2015-07-09 00:00:00	2015-07-23	2015-07-23 00:00:00	32020		\N	276459	0	10509002	260139		0
70485	4176	260139	1979-01-01	1979-01-01 00:00:00	1979-01-15	1979-01-15 00:00:00	32020		\N	277528	0	10509002	260139		0
70641	4191	4112343	1981-10-03	1981-10-03 00:00:00	1981-10-16	1981-10-16 00:00:00	32020		\N	278127	0	195662009	4112343		0
60256	3566	40481087	2004-03-23	2004-03-23 00:00:00	2004-03-30	2004-03-30 00:00:00	32020		\N	236981	0	444814009	40481087		0
60403	3572	78272	1980-02-05	1980-02-05 00:00:00	1980-03-11	1980-03-11 00:00:00	32020		\N	237443	0	70704007	78272		0
60475	3576	40481087	1976-05-27	1976-05-27 00:00:00	1976-06-17	1976-06-17 00:00:00	32020		\N	237745	0	444814009	40481087		0
71215	4223	4113008	2004-05-23	2004-05-23 00:00:00	2004-06-13	2004-06-13 00:00:00	32020		\N	280366	0	284549007	4113008		0
60847	3601	4084167	1965-01-18	1965-01-18 00:00:00	1965-01-18	1965-01-18 00:00:00	32020		\N	239217	0	241929008	4084167		0
71574	4246	260139	1989-05-02	1989-05-02 00:00:00	1989-05-09	1989-05-09 00:00:00	32020		\N	281951	0	10509002	260139		0
61220	3621	4113008	1973-12-15	1973-12-15 00:00:00	1974-01-05	1974-01-05 00:00:00	32020		\N	240633	0	284549007	4113008		0
61361	3626	260139	2012-04-04	2012-04-04 00:00:00	2012-04-18	2012-04-18 00:00:00	32020		\N	241125	0	10509002	260139		0
61529	3636	260139	1997-10-13	1997-10-13 00:00:00	1997-10-27	1997-10-27 00:00:00	32020		\N	241866	0	10509002	260139		0
61622	3639	4112343	1930-06-19	1930-06-19 00:00:00	1930-06-29	1930-06-29 00:00:00	32020		\N	242030	0	195662009	4112343		0
72444	4299	4112343	2003-05-07	2003-05-07 00:00:00	2003-05-19	2003-05-19 00:00:00	32020		\N	285278	0	195662009	4112343		0
72598	4312	4294548	2001-10-10	2001-10-10 00:00:00	2001-11-21	2001-11-21 00:00:00	32020		\N	286055	0	75498004	4294548		0
72709	4320	260139	2019-02-26	2019-02-26 00:00:00	2019-03-05	2019-03-05 00:00:00	32020		\N	286685	0	10509002	260139		0
73011	4338	28060	1967-12-01	1967-12-01 00:00:00	1967-12-14	1967-12-14 00:00:00	32020		\N	287644	0	43878008	28060		0
73067	4342	260139	1964-01-02	1964-01-02 00:00:00	1964-01-09	1964-01-09 00:00:00	32020		\N	287942	0	10509002	260139		0
62680	3701	4112343	1969-02-18	1969-02-18 00:00:00	1969-02-25	1969-02-25 00:00:00	32020		\N	246126	0	195662009	4112343		0
73430	4365	378001	1983-06-19	1983-06-19 00:00:00	1983-07-19	1983-07-19 00:00:00	32020		\N	289588	0	62106007	378001		0
62994	3720	260139	1967-01-07	1967-01-07 00:00:00	1967-01-14	1967-01-14 00:00:00	32020		\N	247282	0	10509002	260139		0
73787	4383	4134304	1975-06-04	1975-06-04 00:00:00	1975-09-02	1975-09-02 00:00:00	32020		\N	291335	0	263102004	4134304		0
73936	4391	4027663	1969-01-31	1969-01-31 00:00:00	\N	\N	32020		\N	291998	0	13200003	4027663		0
74091	4401	4112343	2010-11-25	2010-11-25 00:00:00	2010-12-07	2010-12-07 00:00:00	32020		\N	292567	0	195662009	4112343		0
74309	4411	4283893	1953-10-05	1953-10-05 00:00:00	1953-11-09	1953-11-09 00:00:00	32020		\N	293198	0	36971009	4283893		0
63806	3769	4218389	1970-05-05	1970-05-05 00:00:00	1970-06-02	1970-06-02 00:00:00	32020		\N	250505	0	39848009	4218389		0
64022	3783	40481087	2008-09-27	2008-09-27 00:00:00	2008-10-11	2008-10-11 00:00:00	32020		\N	251313	0	444814009	40481087		0
64106	3787	440448	1981-11-07	1981-11-07 00:00:00	\N	\N	32020		\N	251787	0	74400008	440448		0
53766	3181	4280726	1956-09-19	1956-09-19 00:00:00	\N	\N	32020		\N	211719	0	367498001	4280726		0
53891	3189	40481087	1993-08-10	1993-08-10 00:00:00	1993-08-24	1993-08-24 00:00:00	32020		\N	212233	0	444814009	40481087		0
64635	3822	28060	1958-02-28	1958-02-28 00:00:00	1958-03-10	1958-03-10 00:00:00	32020		\N	253865	0	43878008	28060		0
54186	3211	40481087	2018-10-09	2018-10-09 00:00:00	2018-10-30	2018-10-30 00:00:00	32020		\N	213342	0	444814009	40481087		0
54419	3223	81151	1981-06-06	1981-06-06 00:00:00	1981-06-20	1981-06-20 00:00:00	32020		\N	214311	0	44465007	81151		0
54544	3230	372328	1957-08-13	1957-08-13 00:00:00	1958-01-29	1958-01-29 00:00:00	32020		\N	214688	0	65363002	372328		0
54748	3240	372328	1947-09-15	1947-09-15 00:00:00	1947-12-31	1947-12-31 00:00:00	32020		\N	215350	0	65363002	372328		0
54917	3249	28060	2000-06-19	2000-06-19 00:00:00	2000-06-27	2000-06-27 00:00:00	32020		\N	216013	0	43878008	28060		0
65652	3881	40481087	1978-02-19	1978-02-19 00:00:00	1978-03-05	1978-03-05 00:00:00	32020		\N	257887	0	444814009	40481087		0
65837	3892	80180	2001-10-03	2001-10-03 00:00:00	\N	\N	32020		\N	258831	0	396275006	80180		0
55438	3285	4112343	2019-06-11	2019-06-11 00:00:00	2019-06-21	2019-06-21 00:00:00	32020		\N	218222	0	195662009	4112343		0
55597	3293	4310024	1948-07-05	1948-07-05 00:00:00	\N	\N	32020		\N	218771	0	424802006	4310024		0
66237	3920	4294548	1986-05-03	1986-05-03 00:00:00	1986-05-10	1986-05-10 00:00:00	32020		\N	260671	0	75498004	4294548		0
55871	3308	317576	1981-04-27	1981-04-27 00:00:00	\N	\N	32020		\N	219681	0	53741008	317576		0
66657	3943	4112343	2005-04-16	2005-04-16 00:00:00	2005-04-23	2005-04-23 00:00:00	32020		\N	262189	0	195662009	4112343		0
66758	3950	260139	1976-08-01	1976-08-01 00:00:00	1976-08-15	1976-08-15 00:00:00	32020		\N	262586	0	10509002	260139		0
66926	3957	4112343	2016-09-18	2016-09-18 00:00:00	2016-09-30	2016-09-30 00:00:00	32020		\N	263050	0	195662009	4112343		0
67072	3966	4283893	2009-06-03	2009-06-03 00:00:00	2009-07-01	2009-07-01 00:00:00	32020		\N	263696	0	36971009	4283893		0
67390	3984	372328	2004-07-19	2004-07-19 00:00:00	2004-12-29	2004-12-29 00:00:00	32020		\N	264824	0	65363002	372328		0
67433	3986	4109685	1987-04-11	1987-04-11 00:00:00	1987-04-25	1987-04-25 00:00:00	32020		\N	265020	0	284551006	4109685		0
57077	3386	40481087	1979-01-16	1979-01-16 00:00:00	1979-01-23	1979-01-23 00:00:00	32020		\N	224645	0	444814009	40481087		0
57199	3394	4278672	1980-02-16	1980-02-16 00:00:00	1980-05-16	1980-05-16 00:00:00	32020		\N	225156	0	65966004	4278672		0
67921	4013	40481087	1984-07-02	1984-07-02 00:00:00	1984-07-23	1984-07-23 00:00:00	32020		\N	266640	0	444814009	40481087		0
57595	3417	40481087	1928-07-01	1928-07-01 00:00:00	1928-07-08	1928-07-08 00:00:00	32020		\N	226580	0	444814009	40481087		0
68263	4032	40481087	1998-01-31	1998-01-31 00:00:00	1998-02-21	1998-02-21 00:00:00	32020		\N	268244	0	444814009	40481087		0
57932	3436	4112343	1963-04-13	1963-04-13 00:00:00	1963-04-21	1963-04-21 00:00:00	32020		\N	227872	0	195662009	4112343		0
58068	3440	4112343	2013-12-02	2013-12-02 00:00:00	2013-12-15	2013-12-15 00:00:00	32020		\N	228263	0	195662009	4112343		0
68732	4067	260139	2012-08-19	2012-08-19 00:00:00	2012-09-02	2012-09-02 00:00:00	32020		\N	270251	0	10509002	260139		0
58337	3456	78272	1949-10-04	1949-10-04 00:00:00	1949-10-18	1949-10-18 00:00:00	32020		\N	229293	0	70704007	78272		0
58551	3470	40481087	1978-08-04	1978-08-04 00:00:00	1978-08-18	1978-08-18 00:00:00	32020		\N	230302	0	444814009	40481087		0
69350	4105	260139	1995-09-13	1995-09-13 00:00:00	1995-09-27	1995-09-27 00:00:00	32020		\N	272776	0	10509002	260139		0
58809	3488	40481087	1973-07-11	1973-07-11 00:00:00	1973-07-18	1973-07-18 00:00:00	32020		\N	231413	0	444814009	40481087		0
58995	3501	40481087	1988-03-17	1988-03-17 00:00:00	1988-03-31	1988-03-31 00:00:00	32020		\N	232135	0	444814009	40481087		0
69802	4130	372328	1965-06-17	1965-06-17 00:00:00	1965-07-29	1965-07-29 00:00:00	32020		\N	274594	0	65363002	372328		0
80518	4771	4112343	1981-10-03	1981-10-03 00:00:00	1981-10-13	1981-10-13 00:00:00	32020		\N	317745	0	195662009	4112343		0
59514	3529	40481087	1948-10-30	1948-10-30 00:00:00	1948-11-20	1948-11-20 00:00:00	32020		\N	234316	0	444814009	40481087		0
70243	4160	378001	1972-11-14	1972-11-14 00:00:00	1972-12-14	1972-12-14 00:00:00	32020		\N	276449	0	62106007	378001		0
70486	4176	40481087	1933-11-17	1933-11-17 00:00:00	1933-12-01	1933-12-01 00:00:00	32020		\N	277443	0	444814009	40481087		0
70642	4191	260139	1999-08-15	1999-08-15 00:00:00	1999-08-29	1999-08-29 00:00:00	32020		\N	278129	0	10509002	260139		0
60257	3566	40481087	1955-04-01	1955-04-01 00:00:00	1955-04-15	1955-04-15 00:00:00	32020		\N	236807	0	444814009	40481087		0
60404	3572	372328	1969-10-02	1969-10-02 00:00:00	1970-04-01	1970-04-01 00:00:00	32020		\N	237451	0	65363002	372328		0
60476	3576	40481087	1988-01-18	1988-01-18 00:00:00	1988-02-01	1988-02-01 00:00:00	32020		\N	237715	0	444814009	40481087		0
71216	4223	28060	1971-06-22	1971-06-22 00:00:00	1971-07-03	1971-07-03 00:00:00	32020		\N	280424	0	43878008	28060		0
60848	3601	4112343	1969-01-30	1969-01-30 00:00:00	1969-02-10	1969-02-10 00:00:00	32020		\N	239172	0	195662009	4112343		0
71575	4246	28060	1973-05-10	1973-05-10 00:00:00	1973-05-18	1973-05-18 00:00:00	32020		\N	281955	0	43878008	28060		0
61221	3621	4112343	1945-09-05	1945-09-05 00:00:00	1945-09-13	1945-09-13 00:00:00	32020		\N	240608	0	195662009	4112343		0
61362	3626	372328	1979-03-18	1979-03-18 00:00:00	1980-03-08	1980-03-08 00:00:00	32020		\N	241133	0	65363002	372328		0
61530	3636	40481087	1984-04-20	1984-04-20 00:00:00	1984-05-11	1984-05-11 00:00:00	32020		\N	241797	0	444814009	40481087		0
61623	3639	4112343	2005-01-05	2005-01-05 00:00:00	2005-01-12	2005-01-12 00:00:00	32020		\N	242162	0	195662009	4112343		0
72463	4304	40481087	1968-07-08	1968-07-08 00:00:00	1968-07-15	1968-07-15 00:00:00	32020		\N	285457	0	444814009	40481087		0
72599	4312	260139	1982-10-16	1982-10-16 00:00:00	1982-10-23	1982-10-23 00:00:00	32020		\N	286089	0	10509002	260139		0
72710	4320	4266809	2010-02-07	2010-02-07 00:00:00	\N	\N	32020		\N	286654	0	397881000	4266809		0
73020	4340	4112343	1985-04-16	1985-04-16 00:00:00	1985-04-24	1985-04-24 00:00:00	32020		\N	287775	0	195662009	4112343		0
73068	4342	372328	1959-02-09	1959-02-09 00:00:00	1959-06-12	1959-06-12 00:00:00	32020		\N	287889	0	65363002	372328		0
62681	3701	260139	1986-03-26	1986-03-26 00:00:00	1986-04-02	1986-04-02 00:00:00	32020		\N	246033	0	10509002	260139		0
73431	4365	80180	1991-05-29	1991-05-29 00:00:00	\N	\N	32020		\N	289522	0	396275006	80180		0
62995	3720	372328	1954-07-05	1954-07-05 00:00:00	1954-09-14	1954-09-14 00:00:00	32020		\N	247239	0	65363002	372328		0
73788	4383	40481087	1998-05-02	1998-05-02 00:00:00	1998-05-16	1998-05-16 00:00:00	32020		\N	291321	0	444814009	40481087		0
73937	4391	40481087	1957-08-18	1957-08-18 00:00:00	1957-09-08	1957-09-08 00:00:00	32020		\N	291946	0	444814009	40481087		0
74092	4401	260139	2011-05-25	2011-05-25 00:00:00	2011-06-08	2011-06-08 00:00:00	32020		\N	292539	0	10509002	260139		0
74310	4412	40481087	2004-05-28	2004-05-28 00:00:00	2004-06-11	2004-06-11 00:00:00	32020		\N	293350	0	444814009	40481087		0
63807	3769	40481087	1976-10-11	1976-10-11 00:00:00	1976-10-18	1976-10-18 00:00:00	32020		\N	250543	0	444814009	40481087		0
64023	3783	257012	2017-04-27	2017-04-27 00:00:00	\N	\N	32020		\N	251408	0	40055000	257012		0
64107	3787	40481087	1977-02-16	1977-02-16 00:00:00	1977-03-09	1977-03-09 00:00:00	32020		\N	251772	0	444814009	40481087		0
53767	3181	4051466	1953-09-20	1953-09-20 00:00:00	1970-12-22	1970-12-22 00:00:00	32020		\N	211630	0	233678006	4051466		0
53892	3189	40479422	1985-09-20	1985-09-20 00:00:00	1985-11-26	1985-11-26 00:00:00	32020		\N	212271	0	444448004	40479422		0
64636	3822	192671	1986-11-13	1986-11-13 00:00:00	\N	\N	32020		\N	253824	0	K92.2	35208414		0
54187	3211	40481087	2006-04-02	2006-04-02 00:00:00	2006-04-09	2006-04-09 00:00:00	32020		\N	213368	0	444814009	40481087		0
54420	3223	260139	1945-02-12	1945-02-12 00:00:00	1945-02-19	1945-02-19 00:00:00	32020		\N	214324	0	10509002	260139		0
54545	3230	260139	2018-04-02	2018-04-02 00:00:00	2018-04-16	2018-04-16 00:00:00	32020		\N	214657	0	10509002	260139		0
54749	3240	4283893	1949-03-13	1949-03-13 00:00:00	1949-10-09	1949-10-09 00:00:00	32020		\N	215407	0	36971009	4283893		0
54918	3249	4142905	2008-02-29	2008-02-29 00:00:00	2008-03-30	2008-03-30 00:00:00	32020		\N	215992	0	33737001	4142905		0
65653	3881	4112343	2000-01-25	2000-01-25 00:00:00	2000-02-06	2000-02-06 00:00:00	32020		\N	257949	0	195662009	4112343		0
65838	3892	4285898	2000-12-07	2000-12-07 00:00:00	\N	\N	32020		\N	258831	0	68496003	4285898		0
55439	3285	4112343	1998-02-19	1998-02-19 00:00:00	1998-03-02	1998-03-02 00:00:00	32020		\N	218173	0	195662009	4112343		0
55598	3293	134438	1941-03-16	1941-03-16 00:00:00	1943-07-04	1943-07-04 00:00:00	32020		\N	218706	0	40275004	134438		0
66238	3920	28060	1976-07-07	1976-07-07 00:00:00	1976-07-16	1976-07-16 00:00:00	32020		\N	260634	0	43878008	28060		0
55873	3308	4329847	1996-11-18	1996-11-18 00:00:00	\N	\N	32020		\N	219656	0	22298006	4329847		0
66658	3943	260139	1962-08-21	1962-08-21 00:00:00	1962-08-28	1962-08-28 00:00:00	32020		\N	262165	0	10509002	260139		0
66759	3950	40481087	2012-06-25	2012-06-25 00:00:00	2012-07-09	2012-07-09 00:00:00	32020		\N	262593	0	444814009	40481087		0
66927	3957	40481087	1996-12-12	1996-12-12 00:00:00	1996-12-19	1996-12-19 00:00:00	32020		\N	263048	0	444814009	40481087		0
67073	3966	4112343	1976-03-19	1976-03-19 00:00:00	1976-03-30	1976-03-30 00:00:00	32020		\N	263631	0	195662009	4112343		0
67391	3984	80180	1995-02-01	1995-02-01 00:00:00	\N	\N	32020		\N	264864	0	396275006	80180		0
67434	3986	40481087	1970-03-14	1970-03-14 00:00:00	1970-03-28	1970-03-28 00:00:00	32020		\N	264981	0	444814009	40481087		0
57078	3386	4155034	1986-02-24	1986-02-24 00:00:00	1986-03-17	1986-03-17 00:00:00	32020		\N	224630	0	283371005	4155034		0
57200	3394	4112343	1986-02-07	1986-02-07 00:00:00	1986-02-18	1986-02-18 00:00:00	32020		\N	225147	0	195662009	4112343		0
67922	4013	372328	1975-11-12	1975-11-12 00:00:00	1976-01-25	1976-01-25 00:00:00	32020		\N	266632	0	65363002	372328		0
57596	3417	260139	1914-09-20	1914-09-20 00:00:00	1914-09-27	1914-09-27 00:00:00	32020		\N	226652	0	10509002	260139		0
68264	4032	260139	1985-08-21	1985-08-21 00:00:00	1985-09-04	1985-09-04 00:00:00	32020		\N	268243	0	10509002	260139		0
57933	3436	260139	1964-08-05	1964-08-05 00:00:00	1964-08-12	1964-08-12 00:00:00	32020		\N	227856	0	10509002	260139		0
58069	3440	40481087	1986-09-02	1986-09-02 00:00:00	1986-09-09	1986-09-09 00:00:00	32020		\N	228330	0	444814009	40481087		0
68733	4067	4112343	2008-06-09	2008-06-09 00:00:00	2008-06-19	2008-06-19 00:00:00	32020		\N	270206	0	195662009	4112343		0
58338	3456	40481087	1990-02-09	1990-02-09 00:00:00	1990-02-16	1990-02-16 00:00:00	32020		\N	229309	0	444814009	40481087		0
58552	3470	260139	2008-12-20	2008-12-20 00:00:00	2008-12-27	2008-12-27 00:00:00	32020		\N	230351	0	10509002	260139		0
69351	4105	257012	1948-02-10	1948-02-10 00:00:00	\N	\N	32020		\N	272719	0	40055000	257012		0
58810	3488	4278672	1991-06-29	1991-06-29 00:00:00	1991-07-29	1991-07-29 00:00:00	32020		\N	231358	0	65966004	4278672		0
58996	3501	372328	1950-06-22	1950-06-22 00:00:00	1950-11-09	1950-11-09 00:00:00	32020		\N	232085	0	65363002	372328		0
69803	4130	40481087	1987-03-31	1987-03-31 00:00:00	1987-04-14	1987-04-14 00:00:00	32020		\N	274580	0	444814009	40481087		0
80519	4771	4116491	1981-02-14	1981-02-14 00:00:00	1981-04-08	1981-04-08 00:00:00	32020		\N	317775	0	301011002	4116491		0
59515	3529	4146173	1998-12-21	1998-12-21 00:00:00	1999-01-20	1999-01-20 00:00:00	32020		\N	234425	0	307731004	4146173		0
70244	4160	4134304	1978-05-17	1978-05-17 00:00:00	1978-07-16	1978-07-16 00:00:00	32020		\N	276450	0	263102004	4134304		0
70487	4176	40481087	1954-12-30	1954-12-30 00:00:00	1955-01-13	1955-01-13 00:00:00	32020		\N	277491	0	444814009	40481087		0
70643	4191	4112343	2012-09-05	2012-09-05 00:00:00	2012-09-12	2012-09-12 00:00:00	32020		\N	278137	0	195662009	4112343		0
60258	3566	78272	1954-06-07	1954-06-07 00:00:00	1954-07-05	1954-07-05 00:00:00	32020		\N	236948	0	70704007	78272		0
60405	3572	40481087	1972-12-24	1972-12-24 00:00:00	1972-12-31	1972-12-31 00:00:00	32020		\N	237493	0	444814009	40481087		0
60477	3576	260139	1994-11-19	1994-11-19 00:00:00	1994-11-26	1994-11-26 00:00:00	32020		\N	237711	0	10509002	260139		0
71217	4224	40481087	1965-01-06	1965-01-06 00:00:00	1965-01-27	1965-01-27 00:00:00	32020		\N	280531	0	444814009	40481087		0
60864	3603	40481087	1997-03-10	1997-03-10 00:00:00	1997-03-24	1997-03-24 00:00:00	32020		\N	239367	0	444814009	40481087		0
71576	4246	4285898	2004-07-16	2004-07-16 00:00:00	\N	\N	32020		\N	281967	0	68496003	4285898		0
61222	3621	28060	1932-03-07	1932-03-07 00:00:00	1932-03-14	1932-03-14 00:00:00	32020		\N	240618	0	43878008	28060		0
61363	3626	4112343	1982-06-23	1982-06-23 00:00:00	1982-07-01	1982-07-01 00:00:00	32020		\N	241131	0	195662009	4112343		0
61531	3636	4112343	2004-04-19	2004-04-19 00:00:00	2004-04-29	2004-04-29 00:00:00	32020		\N	241858	0	195662009	4112343		0
61624	3639	4283893	1936-12-02	1936-12-02 00:00:00	1937-03-24	1937-03-24 00:00:00	32020		\N	242156	0	36971009	4283893		0
72465	4304	4029498	1977-09-08	1977-09-08 00:00:00	\N	\N	32020		\N	285471	0	128613002	4029498		0
72600	4312	4112343	2009-08-13	2009-08-13 00:00:00	2009-08-24	2009-08-24 00:00:00	32020		\N	286172	0	195662009	4112343		0
72711	4320	80180	2010-02-07	2010-02-07 00:00:00	\N	\N	32020		\N	286654	0	396275006	80180		0
73021	4340	257012	1984-06-16	1984-06-16 00:00:00	\N	\N	32020		\N	287768	0	40055000	257012		0
73069	4342	4112343	1964-06-01	1964-06-01 00:00:00	1964-06-10	1964-06-10 00:00:00	32020		\N	287943	0	195662009	4112343		0
62682	3701	4296204	1966-12-09	1966-12-09 00:00:00	1966-12-23	1966-12-23 00:00:00	32020		\N	246067	0	403190006	4296204		0
73432	4365	4294548	1990-08-01	1990-08-01 00:00:00	1990-09-12	1990-09-12 00:00:00	32020		\N	289522	0	75498004	4294548		0
62996	3720	260139	2010-10-04	2010-10-04 00:00:00	2010-10-11	2010-10-11 00:00:00	32020		\N	247247	0	10509002	260139		0
73789	4383	260139	1976-03-30	1976-03-30 00:00:00	1976-04-06	1976-04-06 00:00:00	32020		\N	291324	0	10509002	260139		0
73938	4391	81151	1987-02-20	1987-02-20 00:00:00	1987-03-20	1987-03-20 00:00:00	32020		\N	291940	0	44465007	81151		0
74093	4401	4051466	1973-01-10	1973-01-10 00:00:00	1990-01-20	1990-01-20 00:00:00	32020		\N	292577	0	233678006	4051466		0
74311	4412	40481087	1995-07-02	1995-07-02 00:00:00	1995-07-23	1995-07-23 00:00:00	32020		\N	293373	0	444814009	40481087		0
63808	3769	78272	2003-11-06	2003-11-06 00:00:00	2003-11-20	2003-11-20 00:00:00	32020		\N	250506	0	70704007	78272		0
64024	3783	40481087	2013-04-10	2013-04-10 00:00:00	2013-05-01	2013-05-01 00:00:00	32020		\N	251407	0	444814009	40481087		0
64108	3787	378001	2011-08-05	2011-08-05 00:00:00	2011-09-04	2011-09-04 00:00:00	32020		\N	251788	0	62106007	378001		0
53768	3181	40481087	2004-08-27	2004-08-27 00:00:00	2004-09-10	2004-09-10 00:00:00	32020		\N	211679	0	444814009	40481087		0
53893	3189	4094814	2003-03-18	2003-03-18 00:00:00	2003-05-17	2003-05-17 00:00:00	32020		\N	212274	0	262574004	4094814		0
64637	3822	378001	1965-07-12	1965-07-12 00:00:00	1965-08-11	1965-08-11 00:00:00	32020		\N	253834	0	62106007	378001		0
54188	3211	4113008	1968-06-07	1968-06-07 00:00:00	1968-06-21	1968-06-21 00:00:00	32020		\N	213360	0	284549007	4113008		0
54421	3223	260139	1925-11-24	1925-11-24 00:00:00	1925-12-01	1925-12-01 00:00:00	32020		\N	214259	0	10509002	260139		0
54546	3230	4278672	1967-02-11	1967-02-11 00:00:00	1967-05-12	1967-05-12 00:00:00	32020		\N	214644	0	65966004	4278672		0
54750	3240	4152936	1969-05-06	1969-05-06 00:00:00	1969-05-20	1969-05-20 00:00:00	32020		\N	215433	0	283385000	4152936		0
54919	3249	4112343	1963-03-05	1963-03-05 00:00:00	1963-03-15	1963-03-15 00:00:00	32020		\N	215946	0	195662009	4112343		0
65654	3881	260139	2017-04-10	2017-04-10 00:00:00	2017-04-24	2017-04-24 00:00:00	32020		\N	257950	0	10509002	260139		0
65839	3892	4109685	1970-12-15	1970-12-15 00:00:00	1971-01-05	1971-01-05 00:00:00	32020		\N	258772	0	284551006	4109685		0
55440	3285	4113008	1970-11-10	1970-11-10 00:00:00	1970-11-24	1970-11-24 00:00:00	32020		\N	218178	0	284549007	4113008		0
55599	3293	4112343	1917-08-19	1917-08-19 00:00:00	1917-08-31	1917-08-31 00:00:00	32020		\N	218698	0	195662009	4112343		0
66239	3921	372328	1994-02-23	1994-02-23 00:00:00	1994-09-21	1994-09-21 00:00:00	32020		\N	260723	0	65363002	372328		0
55874	3308	372328	1947-10-08	1947-10-08 00:00:00	1948-01-19	1948-01-19 00:00:00	32020		\N	219672	0	65363002	372328		0
66659	3943	4112343	1977-12-14	1977-12-14 00:00:00	1977-12-24	1977-12-24 00:00:00	32020		\N	262167	0	195662009	4112343		0
66760	3950	4310024	2012-07-17	2012-07-17 00:00:00	\N	\N	32020		\N	262593	0	424802006	4310024		0
66928	3957	40481087	1966-11-15	1966-11-15 00:00:00	1966-12-06	1966-12-06 00:00:00	32020		\N	263137	0	444814009	40481087		0
67074	3966	195588	2016-11-27	2016-11-27 00:00:00	2017-01-15	2017-01-15 00:00:00	32020		\N	263638	0	38822007	195588		0
67392	3984	260139	1957-05-07	1957-05-07 00:00:00	1957-05-21	1957-05-21 00:00:00	32020		\N	264819	0	10509002	260139		0
67435	3986	260139	2005-10-17	2005-10-17 00:00:00	2005-10-31	2005-10-31 00:00:00	32020		\N	265015	0	10509002	260139		0
57079	3386	4155034	1990-11-12	1990-11-12 00:00:00	1990-12-03	1990-12-03 00:00:00	32020		\N	224632	0	283371005	4155034		0
57201	3394	40481087	2001-07-21	2001-07-21 00:00:00	2001-08-04	2001-08-04 00:00:00	32020		\N	225143	0	444814009	40481087		0
67923	4013	260139	1988-01-10	1988-01-10 00:00:00	1988-01-24	1988-01-24 00:00:00	32020		\N	266667	0	10509002	260139		0
57597	3417	40481087	1945-09-11	1945-09-11 00:00:00	1945-09-18	1945-09-18 00:00:00	32020		\N	226617	0	444814009	40481087		0
68265	4032	4156265	2014-01-27	2014-01-27 00:00:00	2014-02-17	2014-02-17 00:00:00	32020		\N	268214	0	370247008	4156265		0
57934	3436	78272	1995-09-09	1995-09-09 00:00:00	1995-09-30	1995-09-30 00:00:00	32020		\N	227855	0	70704007	78272		0
58070	3440	81151	1973-04-24	1973-04-24 00:00:00	1973-05-15	1973-05-15 00:00:00	32020		\N	228296	0	44465007	81151		0
68779	4071	40481087	1953-04-06	1953-04-06 00:00:00	1953-04-20	1953-04-20 00:00:00	32020		\N	270607	0	444814009	40481087		0
58339	3456	260139	1978-11-11	1978-11-11 00:00:00	1978-11-25	1978-11-25 00:00:00	32020		\N	229308	0	10509002	260139		0
58553	3470	257012	1976-01-14	1976-01-14 00:00:00	\N	\N	32020		\N	230300	0	40055000	257012		0
69352	4105	260139	1947-12-03	1947-12-03 00:00:00	1947-12-17	1947-12-17 00:00:00	32020		\N	272756	0	10509002	260139		0
58811	3488	40481087	2015-02-18	2015-02-18 00:00:00	2015-03-04	2015-03-04 00:00:00	32020		\N	231386	0	444814009	40481087		0
58997	3501	4156265	1969-01-17	1969-01-17 00:00:00	1969-02-07	1969-02-07 00:00:00	32020		\N	232079	0	370247008	4156265		0
69804	4130	257012	2008-02-12	2008-02-12 00:00:00	2008-06-10	2008-06-10 00:00:00	32020		\N	274645	0	40055000	257012		0
80520	4771	40481087	1966-08-13	1966-08-13 00:00:00	1966-08-20	1966-08-20 00:00:00	32020		\N	317757	0	444814009	40481087		0
59516	3529	40481087	1965-02-26	1965-02-26 00:00:00	1965-03-12	1965-03-12 00:00:00	32020		\N	234303	0	444814009	40481087		0
70245	4160	40481087	2000-10-07	2000-10-07 00:00:00	2000-10-14	2000-10-14 00:00:00	32020		\N	276456	0	444814009	40481087		0
70488	4176	4112343	1991-02-08	1991-02-08 00:00:00	1991-02-15	1991-02-15 00:00:00	32020		\N	277447	0	195662009	4112343		0
70644	4191	4112343	1986-12-21	1986-12-21 00:00:00	1986-12-31	1986-12-31 00:00:00	32020		\N	278128	0	195662009	4112343		0
70717	4197	4059173	2007-02-22	2007-02-22 00:00:00	2007-04-23	2007-04-23 00:00:00	32020		\N	278526	0	16114001	4059173		0
60406	3573	260139	1926-06-12	1926-06-12 00:00:00	1926-06-26	1926-06-26 00:00:00	32020		\N	237571	0	10509002	260139		0
60478	3576	260139	1967-11-08	1967-11-08 00:00:00	1967-11-22	1967-11-22 00:00:00	32020		\N	237743	0	10509002	260139		0
71218	4224	372328	1951-02-12	1951-02-12 00:00:00	1951-12-26	1951-12-26 00:00:00	32020		\N	280556	0	65363002	372328		0
60866	3603	133834	1967-11-05	1967-11-05 00:00:00	1983-08-13	1983-08-13 00:00:00	32020		\N	239358	0	24079001	133834		0
71577	4246	80180	2005-01-12	2005-01-12 00:00:00	\N	\N	32020		\N	281967	0	396275006	80180		0
61223	3621	260139	1959-02-28	1959-02-28 00:00:00	1959-03-07	1959-03-07 00:00:00	32020		\N	240637	0	10509002	260139		0
61364	3626	40481087	1994-10-12	1994-10-12 00:00:00	1994-10-19	1994-10-19 00:00:00	32020		\N	241148	0	444814009	40481087		0
61532	3636	40481087	1986-05-08	1986-05-08 00:00:00	1986-05-29	1986-05-29 00:00:00	32020		\N	241779	0	444814009	40481087		0
61625	3639	378001	1975-02-24	1975-02-24 00:00:00	1975-03-26	1975-03-26 00:00:00	32020		\N	242122	0	62106007	378001		0
72466	4304	380378	1978-01-26	1978-01-26 00:00:00	\N	\N	32020		\N	285472	0	84757009	380378		0
72601	4312	4112343	1989-11-09	1989-11-09 00:00:00	1989-11-22	1989-11-22 00:00:00	32020		\N	286216	0	195662009	4112343		0
72712	4320	30753	2009-08-11	2009-08-11 00:00:00	\N	\N	32020		\N	286654	0	16761005	30753		0
73022	4340	28060	1978-11-03	1978-11-03 00:00:00	1978-11-16	1978-11-16 00:00:00	32020		\N	287747	0	43878008	28060		0
73070	4342	4112343	1989-12-27	1989-12-27 00:00:00	1990-01-06	1990-01-06 00:00:00	32020		\N	287944	0	195662009	4112343		0
62683	3701	260139	1955-08-20	1955-08-20 00:00:00	1955-09-03	1955-09-03 00:00:00	32020		\N	246029	0	10509002	260139		0
73433	4365	40481087	2011-06-23	2011-06-23 00:00:00	2011-07-07	2011-07-07 00:00:00	32020		\N	289525	0	444814009	40481087		0
62997	3720	4283893	1980-10-10	1980-10-10 00:00:00	1980-11-14	1980-11-14 00:00:00	32020		\N	247243	0	36971009	4283893		0
73790	4383	4112343	1991-09-11	1991-09-11 00:00:00	1991-09-24	1991-09-24 00:00:00	32020		\N	291288	0	195662009	4112343		0
73939	4391	4237458	2016-11-26	2016-11-26 00:00:00	2017-02-24	2017-02-24 00:00:00	32020		\N	291943	0	58150001	4237458		0
74094	4401	4112343	1974-03-13	1974-03-13 00:00:00	1974-03-24	1974-03-24 00:00:00	32020		\N	292544	0	195662009	4112343		0
74312	4412	78272	1967-03-14	1967-03-14 00:00:00	1967-03-28	1967-03-28 00:00:00	32020		\N	293283	0	70704007	78272		0
63809	3769	40481087	1989-05-31	1989-05-31 00:00:00	1989-06-07	1989-06-07 00:00:00	32020		\N	250523	0	444814009	40481087		0
64025	3783	40481087	1960-08-01	1960-08-01 00:00:00	1960-08-15	1960-08-15 00:00:00	32020		\N	251345	0	444814009	40481087		0
64109	3787	4278672	1966-06-18	1966-06-18 00:00:00	1966-08-17	1966-08-17 00:00:00	32020		\N	251785	0	65966004	4278672		0
53769	3181	28060	1984-07-23	1984-07-23 00:00:00	1984-08-03	1984-08-03 00:00:00	32020		\N	211663	0	43878008	28060		0
53894	3189	40481087	1973-12-01	1973-12-01 00:00:00	1973-12-08	1973-12-08 00:00:00	32020		\N	212296	0	444814009	40481087		0
64638	3822	4112343	1952-01-05	1952-01-05 00:00:00	1952-01-15	1952-01-15 00:00:00	32020		\N	253864	0	195662009	4112343		0
54189	3211	28060	1972-02-29	1972-02-29 00:00:00	1972-03-10	1972-03-10 00:00:00	32020		\N	213315	0	43878008	28060		0
54422	3223	4296204	1938-04-25	1938-04-25 00:00:00	1938-05-23	1938-05-23 00:00:00	32020		\N	214309	0	403190006	4296204		0
54547	3230	257012	2002-10-08	2002-10-08 00:00:00	\N	\N	32020		\N	214673	0	40055000	257012		0
54751	3240	4112343	2006-07-19	2006-07-19 00:00:00	2006-07-31	2006-07-31 00:00:00	32020		\N	215383	0	195662009	4112343		0
54920	3249	40481087	1978-09-22	1978-09-22 00:00:00	1978-10-06	1978-10-06 00:00:00	32020		\N	216009	0	444814009	40481087		0
65655	3881	260139	2013-01-03	2013-01-03 00:00:00	2013-01-10	2013-01-10 00:00:00	32020		\N	257885	0	10509002	260139		0
65840	3892	40481087	2015-09-04	2015-09-04 00:00:00	2015-09-11	2015-09-11 00:00:00	32020		\N	258783	0	444814009	40481087		0
55441	3285	40481087	1965-10-02	1965-10-02 00:00:00	1965-10-09	1965-10-09 00:00:00	32020		\N	218171	0	444814009	40481087		0
55600	3293	4112343	2005-09-06	2005-09-06 00:00:00	2005-09-19	2005-09-19 00:00:00	32020		\N	218709	0	195662009	4112343		0
66240	3921	260139	2008-02-25	2008-02-25 00:00:00	2008-03-10	2008-03-10 00:00:00	32020		\N	260727	0	10509002	260139		0
55875	3308	260139	1977-08-02	1977-08-02 00:00:00	1977-08-16	1977-08-16 00:00:00	32020		\N	219640	0	10509002	260139		0
66682	3946	4112343	2001-08-02	2001-08-02 00:00:00	2001-08-12	2001-08-12 00:00:00	32020		\N	262357	0	195662009	4112343		0
66761	3950	440086	1981-09-28	1981-09-28 00:00:00	1982-08-23	1982-08-23 00:00:00	32020		\N	262553	0	192127007	440086		0
66929	3957	260139	1978-08-31	1978-08-31 00:00:00	1978-09-07	1978-09-07 00:00:00	32020		\N	263086	0	10509002	260139		0
67075	3966	4310024	2001-03-31	2001-03-31 00:00:00	\N	\N	32020		\N	263670	0	424802006	4310024		0
67393	3984	81151	1964-08-27	1964-08-27 00:00:00	1964-09-10	1964-09-10 00:00:00	32020		\N	264817	0	44465007	81151		0
67436	3986	81151	2007-07-23	2007-07-23 00:00:00	2007-08-27	2007-08-27 00:00:00	32020		\N	265022	0	44465007	81151		0
57080	3386	4113008	1988-12-31	1988-12-31 00:00:00	1989-01-21	1989-01-21 00:00:00	32020		\N	224631	0	284549007	4113008		0
57202	3394	260139	1972-11-25	1972-11-25 00:00:00	1972-12-02	1972-12-02 00:00:00	32020		\N	225162	0	10509002	260139		0
67924	4013	40481087	2005-08-10	2005-08-10 00:00:00	2005-08-24	2005-08-24 00:00:00	32020		\N	266644	0	444814009	40481087		0
57598	3417	4237458	1980-06-15	1980-06-15 00:00:00	1980-07-15	1980-07-15 00:00:00	32020		\N	226624	0	58150001	4237458		0
68266	4032	40481087	1958-06-19	1958-06-19 00:00:00	1958-06-26	1958-06-26 00:00:00	32020		\N	268188	0	444814009	40481087		0
68410	4044	81151	1997-03-18	1997-03-18 00:00:00	1997-04-08	1997-04-08 00:00:00	32020		\N	268991	0	44465007	81151		0
58071	3440	40481087	1944-04-03	1944-04-03 00:00:00	1944-04-24	1944-04-24 00:00:00	32020		\N	228318	0	444814009	40481087		0
68780	4071	40481087	1964-08-27	1964-08-27 00:00:00	1964-09-03	1964-09-03 00:00:00	32020		\N	270610	0	444814009	40481087		0
58340	3456	28060	1952-06-07	1952-06-07 00:00:00	1952-06-20	1952-06-20 00:00:00	32020		\N	229287	0	43878008	28060		0
58554	3470	4294548	1986-07-25	1986-07-25 00:00:00	1986-10-03	1986-10-03 00:00:00	32020		\N	230350	0	75498004	4294548		0
69353	4105	40481087	1985-03-24	1985-03-24 00:00:00	1985-04-14	1985-04-14 00:00:00	32020		\N	272775	0	444814009	40481087		0
58812	3488	440086	1965-02-16	1965-02-16 00:00:00	1965-03-16	1965-03-16 00:00:00	32020		\N	231380	0	192127007	440086		0
58998	3501	30753	1983-12-15	1983-12-15 00:00:00	\N	\N	32020		\N	232126	0	16761005	30753		0
69805	4130	372328	1967-07-24	1967-07-24 00:00:00	1967-10-26	1967-10-26 00:00:00	32020		\N	274661	0	65363002	372328		0
80521	4771	40481087	1976-05-06	1976-05-06 00:00:00	1976-05-20	1976-05-20 00:00:00	32020		\N	317758	0	444814009	40481087		0
59517	3529	4112343	1957-05-13	1957-05-13 00:00:00	1957-05-24	1957-05-24 00:00:00	32020		\N	234319	0	195662009	4112343		0
70246	4160	260139	1991-05-14	1991-05-14 00:00:00	1991-05-21	1991-05-21 00:00:00	32020		\N	276415	0	10509002	260139		0
70489	4176	40481087	2001-08-16	2001-08-16 00:00:00	2001-08-23	2001-08-23 00:00:00	32020		\N	277552	0	444814009	40481087		0
70645	4191	4112343	1989-11-19	1989-11-19 00:00:00	1989-12-02	1989-12-02 00:00:00	32020		\N	278165	0	195662009	4112343		0
70718	4197	372328	1988-06-14	1988-06-14 00:00:00	1988-08-21	1988-08-21 00:00:00	32020		\N	278487	0	65363002	372328		0
60407	3573	40481087	1957-09-05	1957-09-05 00:00:00	1957-09-19	1957-09-19 00:00:00	32020		\N	237581	0	444814009	40481087		0
60479	3576	40481087	2017-07-30	2017-07-30 00:00:00	2017-08-20	2017-08-20 00:00:00	32020		\N	237697	0	444814009	40481087		0
71219	4224	4048171	1951-01-15	1951-01-15 00:00:00	1993-07-14	1993-07-14 00:00:00	32020		\N	280442	0	232353008	4048171		0
60867	3603	28060	1973-10-01	1973-10-01 00:00:00	1973-10-11	1973-10-11 00:00:00	32020		\N	239355	0	43878008	28060		0
71578	4246	28060	1974-01-16	1974-01-16 00:00:00	1974-01-28	1974-01-28 00:00:00	32020		\N	281986	0	43878008	28060		0
61224	3621	372328	1927-05-30	1927-05-30 00:00:00	1928-01-28	1928-01-28 00:00:00	32020		\N	240622	0	65363002	372328		0
61365	3626	81151	1988-08-06	1988-08-06 00:00:00	1988-08-27	1988-08-27 00:00:00	32020		\N	241124	0	44465007	81151		0
61533	3636	378001	2014-12-29	2014-12-29 00:00:00	2015-02-27	2015-02-27 00:00:00	32020		\N	241834	0	62106007	378001		0
61626	3639	40481087	1999-02-11	1999-02-11 00:00:00	1999-02-18	1999-02-18 00:00:00	32020		\N	242035	0	444814009	40481087		0
72467	4304	40481087	2002-09-22	2002-09-22 00:00:00	2002-09-29	2002-09-29 00:00:00	32020		\N	285480	0	444814009	40481087		0
72602	4312	40481087	1989-12-20	1989-12-20 00:00:00	1989-12-27	1989-12-27 00:00:00	32020		\N	286145	0	444814009	40481087		0
72713	4320	40481087	2019-02-02	2019-02-02 00:00:00	2019-02-23	2019-02-23 00:00:00	32020		\N	286665	0	444814009	40481087		0
73023	4340	40481087	1997-12-26	1997-12-26 00:00:00	1998-01-02	1998-01-02 00:00:00	32020		\N	287763	0	444814009	40481087		0
73071	4342	28060	1980-04-02	1980-04-02 00:00:00	1980-04-15	1980-04-15 00:00:00	32020		\N	287976	0	43878008	28060		0
62684	3701	40481087	1967-02-25	1967-02-25 00:00:00	1967-03-11	1967-03-11 00:00:00	32020		\N	246035	0	444814009	40481087		0
73434	4365	28060	1960-03-23	1960-03-23 00:00:00	1960-04-05	1960-04-05 00:00:00	32020		\N	289517	0	43878008	28060		0
62998	3720	28060	2002-09-02	2002-09-02 00:00:00	2002-09-13	2002-09-13 00:00:00	32020		\N	247286	0	43878008	28060		0
73791	4383	28060	1981-07-27	1981-07-27 00:00:00	1981-08-03	1981-08-03 00:00:00	32020		\N	291339	0	43878008	28060		0
73940	4391	28060	1953-11-03	1953-11-03 00:00:00	1953-11-10	1953-11-10 00:00:00	32020		\N	292009	0	43878008	28060		0
74095	4401	40481087	2004-12-17	2004-12-17 00:00:00	2004-12-31	2004-12-31 00:00:00	32020		\N	292581	0	444814009	40481087		0
74313	4412	4112343	1981-12-06	1981-12-06 00:00:00	1981-12-19	1981-12-19 00:00:00	32020		\N	293340	0	195662009	4112343		0
63810	3769	80180	1990-09-04	1990-09-04 00:00:00	\N	\N	32020		\N	250511	0	396275006	80180		0
64026	3783	4112343	2006-01-22	2006-01-22 00:00:00	2006-02-02	2006-02-02 00:00:00	32020		\N	251405	0	195662009	4112343		0
64110	3787	40481087	2004-10-02	2004-10-02 00:00:00	2004-10-09	2004-10-09 00:00:00	32020		\N	251775	0	444814009	40481087		0
53770	3181	40481087	1989-12-10	1989-12-10 00:00:00	1989-12-31	1989-12-31 00:00:00	32020		\N	211665	0	444814009	40481087		0
53895	3189	40481087	1984-04-20	1984-04-20 00:00:00	1984-05-11	1984-05-11 00:00:00	32020		\N	212231	0	444814009	40481087		0
64639	3822	40481087	1974-11-22	1974-11-22 00:00:00	1974-11-29	1974-11-29 00:00:00	32020		\N	253882	0	444814009	40481087		0
54190	3211	40481087	2004-09-12	2004-09-12 00:00:00	2004-10-03	2004-10-03 00:00:00	32020		\N	213373	0	444814009	40481087		0
54423	3223	40481087	1967-09-14	1967-09-14 00:00:00	1967-09-28	1967-09-28 00:00:00	32020		\N	214263	0	444814009	40481087		0
54548	3230	260139	1987-11-05	1987-11-05 00:00:00	1987-11-12	1987-11-12 00:00:00	32020		\N	214672	0	10509002	260139		0
54752	3240	81151	1976-08-11	1976-08-11 00:00:00	1976-09-08	1976-09-08 00:00:00	32020		\N	215436	0	44465007	81151		0
54921	3249	40481087	1960-10-01	1960-10-01 00:00:00	1960-10-15	1960-10-15 00:00:00	32020		\N	216006	0	444814009	40481087		0
65656	3881	4112343	1974-10-31	1974-10-31 00:00:00	1974-11-10	1974-11-10 00:00:00	32020		\N	257881	0	195662009	4112343		0
65841	3892	40481087	1963-03-03	1963-03-03 00:00:00	1963-03-10	1963-03-10 00:00:00	32020		\N	258791	0	444814009	40481087		0
55442	3285	4155034	1980-06-04	1980-06-04 00:00:00	1980-06-18	1980-06-18 00:00:00	32020		\N	218179	0	283371005	4155034		0
55601	3293	4113008	1990-12-25	1990-12-25 00:00:00	1991-01-08	1991-01-08 00:00:00	32020		\N	218668	0	284549007	4113008		0
66241	3921	4278672	1986-08-17	1986-08-17 00:00:00	1986-09-16	1986-09-16 00:00:00	32020		\N	260703	0	65966004	4278672		0
55876	3308	4109685	1952-09-09	1952-09-09 00:00:00	1952-09-30	1952-09-30 00:00:00	32020		\N	219654	0	284551006	4109685		0
66683	3946	260139	1999-01-04	1999-01-04 00:00:00	1999-01-11	1999-01-11 00:00:00	32020		\N	262343	0	10509002	260139		0
66762	3950	378001	2003-06-27	2003-06-27 00:00:00	2003-07-27	2003-07-27 00:00:00	32020		\N	262525	0	62106007	378001		0
66930	3957	260139	1978-10-09	1978-10-09 00:00:00	1978-10-23	1978-10-23 00:00:00	32020		\N	263100	0	10509002	260139		0
67076	3966	4112343	1989-11-02	1989-11-02 00:00:00	1989-11-09	1989-11-09 00:00:00	32020		\N	263634	0	195662009	4112343		0
67394	3984	4278672	2018-07-21	2018-07-21 00:00:00	2018-08-20	2018-08-20 00:00:00	32020		\N	264888	0	65966004	4278672		0
67437	3986	4109685	2014-08-18	2014-08-18 00:00:00	2014-09-08	2014-09-08 00:00:00	32020		\N	265025	0	284551006	4109685		0
57081	3386	81151	1978-07-08	1978-07-08 00:00:00	1978-08-05	1978-08-05 00:00:00	32020		\N	224628	0	44465007	81151		0
57203	3394	260139	1975-11-19	1975-11-19 00:00:00	1975-11-26	1975-11-26 00:00:00	32020		\N	225163	0	10509002	260139		0
67925	4013	372328	1977-07-18	1977-07-18 00:00:00	1977-10-23	1977-10-23 00:00:00	32020		\N	266683	0	65363002	372328		0
57599	3417	260139	1995-08-02	1995-08-02 00:00:00	1995-08-09	1995-08-09 00:00:00	32020		\N	226655	0	10509002	260139		0
68267	4032	4294548	1950-01-09	1950-01-09 00:00:00	1950-03-27	1950-03-27 00:00:00	32020		\N	268215	0	75498004	4294548		0
68411	4044	40481087	2010-07-30	2010-07-30 00:00:00	2010-08-13	2010-08-13 00:00:00	32020		\N	268924	0	444814009	40481087		0
58072	3440	4112343	1988-01-28	1988-01-28 00:00:00	1988-02-04	1988-02-04 00:00:00	32020		\N	228323	0	195662009	4112343		0
68781	4071	4112343	2010-03-01	2010-03-01 00:00:00	2010-03-13	2010-03-13 00:00:00	32020		\N	270568	0	195662009	4112343		0
58341	3456	40481087	1951-11-01	1951-11-01 00:00:00	1951-11-22	1951-11-22 00:00:00	32020		\N	229270	0	444814009	40481087		0
58555	3470	4112343	1999-08-16	1999-08-16 00:00:00	1999-08-26	1999-08-26 00:00:00	32020		\N	230323	0	195662009	4112343		0
69354	4105	40481087	1977-04-26	1977-04-26 00:00:00	1977-05-10	1977-05-10 00:00:00	32020		\N	272721	0	444814009	40481087		0
58813	3488	40481087	1994-01-19	1994-01-19 00:00:00	1994-01-26	1994-01-26 00:00:00	32020		\N	231414	0	444814009	40481087		0
58999	3501	80180	1985-03-09	1985-03-09 00:00:00	\N	\N	32020		\N	232126	0	396275006	80180		0
69806	4130	313217	2014-05-08	2014-05-08 00:00:00	\N	\N	32020		\N	274604	0	49436004	313217		0
80522	4771	40481087	2006-06-28	2006-06-28 00:00:00	2006-07-12	2006-07-12 00:00:00	32020		\N	317767	0	444814009	40481087		0
59518	3529	80502	2004-08-04	2004-08-04 00:00:00	\N	\N	32020		\N	234354	0	64859006	80502		0
70247	4160	4152936	2011-11-18	2011-11-18 00:00:00	2011-12-02	2011-12-02 00:00:00	32020		\N	276452	0	283385000	4152936		0
70490	4176	260139	1972-12-01	1972-12-01 00:00:00	1972-12-08	1972-12-08 00:00:00	32020		\N	277445	0	10509002	260139		0
70646	4191	4283893	1959-04-07	1959-04-07 00:00:00	1959-05-19	1959-05-19 00:00:00	32020		\N	278135	0	36971009	4283893		0
70719	4197	40481087	2010-12-22	2010-12-22 00:00:00	2011-01-05	2011-01-05 00:00:00	32020		\N	278508	0	444814009	40481087		0
60408	3573	40481087	1982-07-28	1982-07-28 00:00:00	1982-08-18	1982-08-18 00:00:00	32020		\N	237543	0	444814009	40481087		0
60480	3576	40481087	1983-08-17	1983-08-17 00:00:00	1983-09-07	1983-09-07 00:00:00	32020		\N	237746	0	444814009	40481087		0
71220	4224	40479422	1950-11-14	1950-11-14 00:00:00	1951-01-20	1951-01-20 00:00:00	32020		\N	280589	0	444448004	40479422		0
60868	3603	40481087	1967-08-06	1967-08-06 00:00:00	1967-08-20	1967-08-20 00:00:00	32020		\N	239373	0	444814009	40481087		0
71579	4246	40481087	1969-07-02	1969-07-02 00:00:00	1969-07-09	1969-07-09 00:00:00	32020		\N	281953	0	444814009	40481087		0
61225	3621	261325	1969-07-12	1969-07-12 00:00:00	\N	\N	32020		\N	240650	0	87433001	261325		0
61366	3626	4112343	2005-08-31	2005-08-31 00:00:00	2005-09-11	2005-09-11 00:00:00	32020		\N	241139	0	195662009	4112343		0
61534	3636	4112343	1999-09-30	1999-09-30 00:00:00	1999-10-12	1999-10-12 00:00:00	32020		\N	241869	0	195662009	4112343		0
61627	3639	4112343	1973-01-02	1973-01-02 00:00:00	1973-01-11	1973-01-11 00:00:00	32020		\N	242157	0	195662009	4112343		0
72468	4304	40481087	2011-11-20	2011-11-20 00:00:00	2011-12-11	2011-12-11 00:00:00	32020		\N	285509	0	444814009	40481087		0
72603	4312	40481087	2008-11-22	2008-11-22 00:00:00	2008-11-29	2008-11-29 00:00:00	32020		\N	286182	0	444814009	40481087		0
72714	4320	4116491	2016-03-17	2016-03-17 00:00:00	2016-05-04	2016-05-04 00:00:00	32020		\N	286683	0	301011002	4116491		0
73024	4340	40481087	1992-02-03	1992-02-03 00:00:00	1992-02-17	1992-02-17 00:00:00	32020		\N	287761	0	444814009	40481087		0
73072	4342	40481087	1989-03-11	1989-03-11 00:00:00	1989-03-25	1989-03-25 00:00:00	32020		\N	287963	0	444814009	40481087		0
62685	3701	78272	1996-07-23	1996-07-23 00:00:00	1996-08-27	1996-08-27 00:00:00	32020		\N	246070	0	70704007	78272		0
73435	4365	372328	1954-05-08	1954-05-08 00:00:00	1954-06-28	1954-06-28 00:00:00	32020		\N	289526	0	65363002	372328		0
62999	3720	4142905	1979-01-16	1979-01-16 00:00:00	1979-02-15	1979-02-15 00:00:00	32020		\N	247309	0	33737001	4142905		0
73792	4383	260139	2000-03-12	2000-03-12 00:00:00	2000-03-19	2000-03-19 00:00:00	32020		\N	291326	0	10509002	260139		0
73941	4391	4109685	1952-11-06	1952-11-06 00:00:00	1952-11-20	1952-11-20 00:00:00	32020		\N	291939	0	284551006	4109685		0
74096	4401	40481087	1997-02-06	1997-02-06 00:00:00	1997-02-20	1997-02-20 00:00:00	32020		\N	292538	0	444814009	40481087		0
74314	4412	40481087	1996-07-24	1996-07-24 00:00:00	1996-07-31	1996-07-31 00:00:00	32020		\N	293386	0	444814009	40481087		0
63811	3769	260139	2019-03-20	2019-03-20 00:00:00	2019-04-03	2019-04-03 00:00:00	32020		\N	250580	0	10509002	260139		0
64027	3783	4112343	1960-11-20	1960-11-20 00:00:00	1960-12-03	1960-12-03 00:00:00	32020		\N	251427	0	195662009	4112343		0
64111	3787	260139	1986-02-14	1986-02-14 00:00:00	1986-02-28	1986-02-28 00:00:00	32020		\N	251764	0	10509002	260139		0
53771	3181	40481087	1999-06-21	1999-06-21 00:00:00	1999-07-12	1999-07-12 00:00:00	32020		\N	211682	0	444814009	40481087		0
53899	3191	4155034	1968-09-28	1968-09-28 00:00:00	1968-10-12	1968-10-12 00:00:00	32020		\N	212386	0	283371005	4155034		0
64640	3822	313217	2015-04-27	2015-04-27 00:00:00	\N	\N	32020		\N	253846	0	49436004	313217		0
54191	3211	40481087	1994-01-26	1994-01-26 00:00:00	1994-02-09	1994-02-09 00:00:00	32020		\N	213331	0	444814009	40481087		0
54424	3223	4152936	1997-11-23	1997-11-23 00:00:00	1997-12-14	1997-12-14 00:00:00	32020		\N	214312	0	283385000	4152936		0
54549	3230	4112343	2009-02-07	2009-02-07 00:00:00	2009-02-20	2009-02-20 00:00:00	32020		\N	214680	0	195662009	4112343		0
54753	3240	257012	1949-04-17	1949-04-17 00:00:00	\N	\N	32020		\N	215408	0	40055000	257012		0
54922	3249	375671	2005-12-11	2005-12-11 00:00:00	2006-01-10	2006-01-10 00:00:00	32020		\N	215991	0	62564004	375671		0
65657	3881	40481087	2018-08-28	2018-08-28 00:00:00	2018-09-18	2018-09-18 00:00:00	32020		\N	257933	0	444814009	40481087		0
65842	3892	4112343	1972-03-09	1972-03-09 00:00:00	1972-03-16	1972-03-16 00:00:00	32020		\N	258798	0	195662009	4112343		0
55443	3285	260139	1962-07-28	1962-07-28 00:00:00	1962-08-04	1962-08-04 00:00:00	32020		\N	218218	0	10509002	260139		0
55602	3293	81151	1975-11-11	1975-11-11 00:00:00	1975-12-16	1975-12-16 00:00:00	32020		\N	218666	0	44465007	81151		0
66242	3921	4230399	1999-07-10	1999-07-10 00:00:00	1999-09-08	1999-09-08 00:00:00	32020		\N	260704	0	359817006	4230399		0
55877	3308	81151	1977-12-18	1977-12-18 00:00:00	1978-01-22	1978-01-22 00:00:00	32020		\N	219655	0	44465007	81151		0
66684	3946	28060	2013-03-15	2013-03-15 00:00:00	2013-03-25	2013-03-25 00:00:00	32020		\N	262309	0	43878008	28060		0
66763	3950	40481087	1980-06-15	1980-06-15 00:00:00	1980-06-22	1980-06-22 00:00:00	32020		\N	262528	0	444814009	40481087		0
66931	3957	4294548	2019-04-01	2019-04-01 00:00:00	2019-04-15	2019-04-15 00:00:00	32020		\N	263051	0	75498004	4294548		0
67077	3966	4112343	1968-12-30	1968-12-30 00:00:00	1969-01-09	1969-01-09 00:00:00	32020		\N	263709	0	195662009	4112343		0
67395	3984	40481087	1975-08-07	1975-08-07 00:00:00	1975-08-28	1975-08-28 00:00:00	32020		\N	264836	0	444814009	40481087		0
67438	3986	4029498	2009-08-13	2009-08-13 00:00:00	\N	\N	32020		\N	265023	0	128613002	4029498		0
57082	3386	4218389	1976-05-14	1976-05-14 00:00:00	1976-06-18	1976-06-18 00:00:00	32020		\N	224627	0	39848009	4218389		0
57204	3394	40481087	1993-05-28	1993-05-28 00:00:00	1993-06-04	1993-06-04 00:00:00	32020		\N	225119	0	444814009	40481087		0
67926	4013	4112343	1976-09-09	1976-09-09 00:00:00	1976-09-21	1976-09-21 00:00:00	32020		\N	266639	0	195662009	4112343		0
57600	3417	40481087	1918-11-05	1918-11-05 00:00:00	1918-11-12	1918-11-12 00:00:00	32020		\N	226653	0	444814009	40481087		0
68268	4032	4112343	1975-03-20	1975-03-20 00:00:00	1975-03-30	1975-03-30 00:00:00	32020		\N	268189	0	195662009	4112343		0
68412	4044	40481087	1987-07-03	1987-07-03 00:00:00	1987-07-24	1987-07-24 00:00:00	32020		\N	268951	0	444814009	40481087		0
58073	3440	4112343	1999-04-24	1999-04-24 00:00:00	1999-05-03	1999-05-03 00:00:00	32020		\N	228238	0	195662009	4112343		0
68782	4071	260139	2003-12-07	2003-12-07 00:00:00	2003-12-14	2003-12-14 00:00:00	32020		\N	270590	0	10509002	260139		0
58342	3456	372328	1946-10-11	1946-10-11 00:00:00	1946-11-14	1946-11-14 00:00:00	32020		\N	229289	0	65363002	372328		0
58556	3470	260139	1969-04-12	1969-04-12 00:00:00	1969-04-19	1969-04-19 00:00:00	32020		\N	230299	0	10509002	260139		0
69355	4105	4283893	1948-01-06	1948-01-06 00:00:00	1948-03-02	1948-03-02 00:00:00	32020		\N	272718	0	36971009	4283893		0
58814	3488	372328	1957-06-18	1957-06-18 00:00:00	1957-07-26	1957-07-26 00:00:00	32020		\N	231387	0	65363002	372328		0
59000	3501	81893	1983-04-19	1983-04-19 00:00:00	\N	\N	32020		\N	232126	0	64766004	81893		0
69807	4130	4218389	1995-12-07	1995-12-07 00:00:00	1996-01-04	1996-01-04 00:00:00	32020		\N	274664	0	39848009	4218389		0
80523	4771	372328	1958-08-24	1958-08-24 00:00:00	1958-12-27	1958-12-27 00:00:00	32020		\N	317762	0	65363002	372328		0
59519	3529	375671	2002-10-01	2002-10-01 00:00:00	2002-10-31	2002-10-31 00:00:00	32020		\N	234451	0	62564004	375671		0
70248	4160	4116491	1989-06-28	1989-06-28 00:00:00	1989-08-08	1989-08-08 00:00:00	32020		\N	276455	0	301011002	4116491		0
70491	4176	4152936	2010-07-03	2010-07-03 00:00:00	2010-07-17	2010-07-17 00:00:00	32020		\N	277546	0	283385000	4152936		0
70647	4191	317576	2010-09-03	2010-09-03 00:00:00	\N	\N	32020		\N	278166	0	53741008	317576		0
70720	4197	381316	2011-02-20	2011-02-20 00:00:00	\N	\N	32020		\N	278508	0	230690007	381316		0
60409	3573	40481087	1949-06-04	1949-06-04 00:00:00	1949-06-25	1949-06-25 00:00:00	32020		\N	237519	0	444814009	40481087		0
60481	3576	40481087	1987-02-26	1987-02-26 00:00:00	1987-03-19	1987-03-19 00:00:00	32020		\N	237710	0	444814009	40481087		0
71221	4224	4266809	1986-01-19	1986-01-19 00:00:00	\N	\N	32020		\N	280561	0	397881000	4266809		0
60869	3603	260139	2009-07-26	2009-07-26 00:00:00	2009-08-02	2009-08-02 00:00:00	32020		\N	239369	0	10509002	260139		0
71580	4246	4027663	1996-12-20	1996-12-20 00:00:00	\N	\N	32020		\N	281981	0	13200003	4027663		0
61226	3621	4283893	1991-04-24	1991-04-24 00:00:00	1991-05-29	1991-05-29 00:00:00	32020		\N	240581	0	36971009	4283893		0
61367	3626	4112343	1980-04-24	1980-04-24 00:00:00	1980-05-01	1980-05-01 00:00:00	32020		\N	241130	0	195662009	4112343		0
61535	3636	4112343	1978-11-11	1978-11-11 00:00:00	1978-11-24	1978-11-24 00:00:00	32020		\N	241788	0	195662009	4112343		0
61628	3639	4155034	1961-02-16	1961-02-16 00:00:00	1961-03-09	1961-03-09 00:00:00	32020		\N	242121	0	283371005	4155034		0
72469	4304	40481087	1969-04-16	1969-04-16 00:00:00	1969-05-07	1969-05-07 00:00:00	32020		\N	285479	0	444814009	40481087		0
72604	4312	195588	1987-09-09	1987-09-09 00:00:00	1987-10-11	1987-10-11 00:00:00	32020		\N	286197	0	38822007	195588		0
72715	4320	372328	1973-04-03	1973-04-03 00:00:00	1973-09-02	1973-09-02 00:00:00	32020		\N	286667	0	65363002	372328		0
73025	4340	4027663	2001-09-15	2001-09-15 00:00:00	\N	\N	32020		\N	287809	0	13200003	4027663		0
73073	4342	4112343	2010-11-06	2010-11-06 00:00:00	2010-11-14	2010-11-14 00:00:00	32020		\N	287879	0	195662009	4112343		0
62686	3701	4134304	1955-12-16	1955-12-16 00:00:00	1956-02-14	1956-02-14 00:00:00	32020		\N	246065	0	263102004	4134304		0
73436	4365	381316	2016-01-10	2016-01-10 00:00:00	\N	\N	32020		\N	289584	0	230690007	381316		0
63000	3720	40481087	1977-10-30	1977-10-30 00:00:00	1977-11-20	1977-11-20 00:00:00	32020		\N	247283	0	444814009	40481087		0
73793	4383	4296205	2008-01-22	2008-01-22 00:00:00	2008-02-26	2008-02-26 00:00:00	32020		\N	291360	0	403191005	4296205		0
73942	4391	4142905	1945-12-13	1945-12-13 00:00:00	1946-03-13	1946-03-13 00:00:00	32020		\N	291938	0	33737001	4142905		0
74097	4401	4113008	2017-05-04	2017-05-04 00:00:00	2017-05-25	2017-05-25 00:00:00	32020		\N	292565	0	284549007	4113008		0
74315	4412	440448	2010-07-22	2010-07-22 00:00:00	\N	\N	32020		\N	293287	0	74400008	440448		0
63812	3769	40481087	1985-08-08	1985-08-08 00:00:00	1985-08-15	1985-08-15 00:00:00	32020		\N	250545	0	444814009	40481087		0
64028	3783	372328	1943-06-19	1943-06-19 00:00:00	1943-09-10	1943-09-10 00:00:00	32020		\N	251409	0	65363002	372328		0
64113	3787	40481087	1976-12-29	1976-12-29 00:00:00	1977-01-12	1977-01-12 00:00:00	32020		\N	251774	0	444814009	40481087		0
61417	3628	257012	1942-11-16	1942-11-16 00:00:00	\N	\N	32020		\N	241369	0	40055000	257012		0
53772	3181	40481087	1953-12-07	1953-12-07 00:00:00	1953-12-21	1953-12-21 00:00:00	32020		\N	211695	0	444814009	40481087		0
53900	3191	4237458	1969-11-06	1969-11-06 00:00:00	1970-01-05	1970-01-05 00:00:00	32020		\N	212387	0	58150001	4237458		0
64641	3822	40481087	2001-03-15	2001-03-15 00:00:00	2001-04-05	2001-04-05 00:00:00	32020		\N	253849	0	444814009	40481087		0
54192	3211	40481087	1979-11-22	1979-11-22 00:00:00	1979-11-29	1979-11-29 00:00:00	32020		\N	213366	0	444814009	40481087		0
54425	3223	4278672	1919-08-03	1919-08-03 00:00:00	1919-11-01	1919-11-01 00:00:00	32020		\N	214307	0	65966004	4278672		0
54550	3230	4112343	1969-03-30	1969-03-30 00:00:00	1969-04-07	1969-04-07 00:00:00	32020		\N	214655	0	195662009	4112343		0
54754	3240	260139	2010-09-09	2010-09-09 00:00:00	2010-09-16	2010-09-16 00:00:00	32020		\N	215389	0	10509002	260139		0
54923	3249	40481087	1964-03-07	1964-03-07 00:00:00	1964-03-21	1964-03-21 00:00:00	32020		\N	215961	0	444814009	40481087		0
65658	3881	321042	1997-01-03	1997-01-03 00:00:00	\N	\N	32020		\N	257921	0	410429000	321042		0
65843	3892	4155034	2013-02-23	2013-02-23 00:00:00	2013-03-09	2013-03-09 00:00:00	32020		\N	258773	0	283371005	4155034		0
55444	3285	40481087	1972-09-28	1972-09-28 00:00:00	1972-10-19	1972-10-19 00:00:00	32020		\N	218227	0	444814009	40481087		0
55603	3293	40481087	1999-03-05	1999-03-05 00:00:00	1999-03-26	1999-03-26 00:00:00	32020		\N	218736	0	444814009	40481087		0
66243	3921	4296204	2004-08-12	2004-08-12 00:00:00	2004-09-02	2004-09-02 00:00:00	32020		\N	260705	0	403190006	4296204		0
55878	3308	28060	1960-11-14	1960-11-14 00:00:00	1960-11-27	1960-11-27 00:00:00	32020		\N	219664	0	43878008	28060		0
66685	3946	40481087	1973-04-22	1973-04-22 00:00:00	1973-04-29	1973-04-29 00:00:00	32020		\N	262313	0	444814009	40481087		0
66764	3950	4266809	2014-12-04	2014-12-04 00:00:00	\N	\N	32020		\N	262580	0	397881000	4266809		0
66932	3958	40481087	1969-07-07	1969-07-07 00:00:00	1969-07-14	1969-07-14 00:00:00	32020		\N	263156	0	444814009	40481087		0
67078	3966	80180	2003-05-20	2003-05-20 00:00:00	\N	\N	32020		\N	263706	0	396275006	80180		0
67396	3984	4112343	1959-04-11	1959-04-11 00:00:00	1959-04-23	1959-04-23 00:00:00	32020		\N	264841	0	195662009	4112343		0
67440	3986	40481087	2017-10-31	2017-10-31 00:00:00	2017-11-14	2017-11-14 00:00:00	32020		\N	264988	0	444814009	40481087		0
57083	3386	40481087	2018-07-01	2018-07-01 00:00:00	2018-07-08	2018-07-08 00:00:00	32020		\N	224642	0	444814009	40481087		0
57205	3394	381316	2010-08-21	2010-08-21 00:00:00	\N	\N	32020		\N	225139	0	230690007	381316		0
67927	4013	40481087	1989-12-29	1989-12-29 00:00:00	1990-01-05	1990-01-05 00:00:00	32020		\N	266648	0	444814009	40481087		0
57601	3417	40481087	1970-05-30	1970-05-30 00:00:00	1970-06-13	1970-06-13 00:00:00	32020		\N	226669	0	444814009	40481087		0
68269	4032	4294548	1977-10-18	1977-10-18 00:00:00	1978-01-24	1978-01-24 00:00:00	32020		\N	268232	0	75498004	4294548		0
68413	4044	40481087	1975-12-12	1975-12-12 00:00:00	1975-12-26	1975-12-26 00:00:00	32020		\N	268939	0	444814009	40481087		0
58074	3440	378001	1943-03-05	1943-03-05 00:00:00	1943-04-04	1943-04-04 00:00:00	32020		\N	228290	0	62106007	378001		0
68783	4071	40481087	1978-04-13	1978-04-13 00:00:00	1978-04-27	1978-04-27 00:00:00	32020		\N	270578	0	444814009	40481087		0
58343	3456	4112343	1962-12-29	1962-12-29 00:00:00	1963-01-11	1963-01-11 00:00:00	32020		\N	229307	0	195662009	4112343		0
58557	3470	4149245	1998-08-03	1998-08-03 00:00:00	1998-10-09	1998-10-09 00:00:00	32020		\N	230329	0	30832001	4149245		0
69356	4105	40481087	1979-10-03	1979-10-03 00:00:00	1979-10-17	1979-10-17 00:00:00	32020		\N	272708	0	444814009	40481087		0
58815	3489	40481087	2005-04-23	2005-04-23 00:00:00	2005-05-07	2005-05-07 00:00:00	32020		\N	231470	0	444814009	40481087		0
59001	3501	4152936	2017-12-27	2017-12-27 00:00:00	2018-01-17	2018-01-17 00:00:00	32020		\N	232063	0	283385000	4152936		0
69808	4130	4048171	1966-11-26	1966-11-26 00:00:00	\N	\N	32020		\N	274558	0	232353008	4048171		0
80524	4771	80180	1994-09-29	1994-09-29 00:00:00	\N	\N	32020		\N	317782	0	396275006	80180		0
59520	3529	4112343	1947-08-13	1947-08-13 00:00:00	1947-08-21	1947-08-21 00:00:00	32020		\N	234300	0	195662009	4112343		0
70249	4160	4116491	1993-08-07	1993-08-07 00:00:00	1993-09-18	1993-09-18 00:00:00	32020		\N	276416	0	301011002	4116491		0
70492	4176	4112343	2005-12-31	2005-12-31 00:00:00	2006-01-09	2006-01-09 00:00:00	32020		\N	277449	0	195662009	4112343		0
70648	4191	40481087	1958-11-17	1958-11-17 00:00:00	1958-12-01	1958-12-01 00:00:00	32020		\N	278124	0	444814009	40481087		0
70721	4197	4149245	2009-12-08	2009-12-08 00:00:00	2010-02-13	2010-02-13 00:00:00	32020		\N	278540	0	30832001	4149245		0
60410	3573	40481087	1967-03-07	1967-03-07 00:00:00	1967-03-14	1967-03-14 00:00:00	32020		\N	237583	0	444814009	40481087		0
60482	3576	40481087	1996-01-26	1996-01-26 00:00:00	1996-02-02	1996-02-02 00:00:00	32020		\N	237693	0	444814009	40481087		0
71222	4224	80180	1986-01-19	1986-01-19 00:00:00	\N	\N	32020		\N	280561	0	396275006	80180		0
60870	3603	40481087	1968-06-20	1968-06-20 00:00:00	1968-06-27	1968-06-27 00:00:00	32020		\N	239359	0	444814009	40481087		0
71581	4246	4112343	1967-05-01	1967-05-01 00:00:00	1967-05-11	1967-05-11 00:00:00	32020		\N	281984	0	195662009	4112343		0
61227	3621	4156265	1950-01-15	1950-01-15 00:00:00	1950-01-29	1950-01-29 00:00:00	32020		\N	240659	0	370247008	4156265		0
61368	3626	372328	1977-02-05	1977-02-05 00:00:00	1977-02-26	1977-02-26 00:00:00	32020		\N	241132	0	65363002	372328		0
61536	3636	4112343	2010-04-02	2010-04-02 00:00:00	2010-04-15	2010-04-15 00:00:00	32020		\N	241784	0	195662009	4112343		0
61640	3641	40481087	1987-04-14	1987-04-14 00:00:00	1987-05-05	1987-05-05 00:00:00	32020		\N	242269	0	444814009	40481087		0
72470	4304	260139	1993-10-30	1993-10-30 00:00:00	1993-11-06	1993-11-06 00:00:00	32020		\N	285486	0	10509002	260139		0
72605	4312	4051466	1963-09-22	1963-09-22 00:00:00	1981-09-16	1981-09-16 00:00:00	32020		\N	286193	0	233678006	4051466		0
72716	4320	40481087	2015-11-05	2015-11-05 00:00:00	2015-11-12	2015-11-12 00:00:00	32020		\N	286678	0	444814009	40481087		0
73026	4340	4283893	1984-05-12	1984-05-12 00:00:00	1984-08-04	1984-08-04 00:00:00	32020		\N	287767	0	36971009	4283893		0
73074	4342	4112343	1971-05-06	1971-05-06 00:00:00	1971-05-16	1971-05-16 00:00:00	32020		\N	287957	0	195662009	4112343		0
62687	3701	28060	1959-12-16	1959-12-16 00:00:00	1959-12-25	1959-12-25 00:00:00	32020		\N	246057	0	43878008	28060		0
73437	4365	4112343	1952-01-21	1952-01-21 00:00:00	1952-02-01	1952-02-01 00:00:00	32020		\N	289507	0	195662009	4112343		0
63001	3720	4112343	1980-12-01	1980-12-01 00:00:00	1980-12-10	1980-12-10 00:00:00	32020		\N	247284	0	195662009	4112343		0
73794	4383	4294548	1983-06-20	1983-06-20 00:00:00	1983-07-25	1983-07-25 00:00:00	32020		\N	291325	0	75498004	4294548		0
73943	4391	372328	1941-11-04	1941-11-04 00:00:00	1942-01-16	1942-01-16 00:00:00	32020		\N	291948	0	65363002	372328		0
74098	4401	81151	1971-11-20	1971-11-20 00:00:00	1971-12-11	1971-12-11 00:00:00	32020		\N	292562	0	44465007	81151		0
74316	4412	4166224	2010-07-22	2010-07-22 00:00:00	\N	\N	32020		\N	293287	0	47693006	4166224		0
63813	3769	260139	1957-04-25	1957-04-25 00:00:00	1957-05-09	1957-05-09 00:00:00	32020		\N	250537	0	10509002	260139		0
64030	3783	4029498	1952-04-02	1952-04-02 00:00:00	\N	\N	32020		\N	251451	0	128613002	4029498		0
64114	3787	40481087	2000-08-02	2000-08-02 00:00:00	2000-08-16	2000-08-16 00:00:00	32020		\N	251734	0	444814009	40481087		0
53773	3181	4218389	1989-04-09	1989-04-09 00:00:00	1989-04-30	1989-04-30 00:00:00	32020		\N	211687	0	39848009	4218389		0
53901	3191	4112343	1960-03-31	1960-03-31 00:00:00	1960-04-11	1960-04-11 00:00:00	32020		\N	212332	0	195662009	4112343		0
64642	3822	4112343	1973-11-30	1973-11-30 00:00:00	1973-12-10	1973-12-10 00:00:00	32020		\N	253880	0	195662009	4112343		0
54193	3211	40481087	1985-02-08	1985-02-08 00:00:00	1985-02-22	1985-02-22 00:00:00	32020		\N	213340	0	444814009	40481087		0
54426	3223	40481087	1985-04-03	1985-04-03 00:00:00	1985-04-10	1985-04-10 00:00:00	32020		\N	214242	0	444814009	40481087		0
54551	3230	4142905	1991-10-03	1991-10-03 00:00:00	1991-12-02	1991-12-02 00:00:00	32020		\N	214645	0	33737001	4142905		0
54755	3240	260139	1990-12-30	1990-12-30 00:00:00	1991-01-06	1991-01-06 00:00:00	32020		\N	215345	0	10509002	260139		0
54924	3249	260139	2001-08-10	2001-08-10 00:00:00	2001-08-17	2001-08-17 00:00:00	32020		\N	215966	0	10509002	260139		0
65672	3884	40481087	1973-04-29	1973-04-29 00:00:00	1973-05-20	1973-05-20 00:00:00	32020		\N	258143	0	444814009	40481087		0
65844	3892	4112343	1977-06-22	1977-06-22 00:00:00	1977-06-29	1977-06-29 00:00:00	32020		\N	258799	0	195662009	4112343		0
65903	3895	80180	1958-05-20	1958-05-20 00:00:00	\N	\N	32020		\N	259102	0	396275006	80180		0
55604	3293	4112343	1920-11-16	1920-11-16 00:00:00	1920-11-26	1920-11-26 00:00:00	32020		\N	218703	0	195662009	4112343		0
66244	3921	4112343	2008-09-21	2008-09-21 00:00:00	2008-10-01	2008-10-01 00:00:00	32020		\N	260728	0	195662009	4112343		0
55879	3308	260139	1979-11-17	1979-11-17 00:00:00	1979-11-24	1979-11-24 00:00:00	32020		\N	219643	0	10509002	260139		0
66686	3946	4112343	1965-02-14	1965-02-14 00:00:00	1965-02-24	1965-02-24 00:00:00	32020		\N	262305	0	195662009	4112343		0
66765	3950	80180	2014-12-04	2014-12-04 00:00:00	\N	\N	32020		\N	262580	0	396275006	80180		0
66933	3958	260139	2017-06-26	2017-06-26 00:00:00	2017-07-10	2017-07-10 00:00:00	32020		\N	263150	0	10509002	260139		0
67079	3966	4285898	2002-10-22	2002-10-22 00:00:00	\N	\N	32020		\N	263706	0	68496003	4285898		0
77855	4613	4116491	1987-05-17	1987-05-17 00:00:00	1987-07-03	1987-07-03 00:00:00	32020		\N	307265	0	301011002	4116491		0
67441	3986	40481087	1990-08-01	1990-08-01 00:00:00	1990-08-22	1990-08-22 00:00:00	32020		\N	265013	0	444814009	40481087		0
57098	3389	40481087	1991-10-06	1991-10-06 00:00:00	1991-10-13	1991-10-13 00:00:00	32020		\N	224800	0	444814009	40481087		0
57234	3397	257012	1971-05-27	1971-05-27 00:00:00	\N	\N	32020		\N	225290	0	40055000	257012		0
67928	4013	40481087	2005-04-22	2005-04-22 00:00:00	2005-05-06	2005-05-06 00:00:00	32020		\N	266643	0	444814009	40481087		0
57602	3417	40481087	1943-07-28	1943-07-28 00:00:00	1943-08-18	1943-08-18 00:00:00	32020		\N	226603	0	444814009	40481087		0
68270	4032	313217	2010-07-20	2010-07-20 00:00:00	\N	\N	32020		\N	268200	0	49436004	313217		0
68414	4044	260139	2008-06-06	2008-06-06 00:00:00	2008-06-13	2008-06-13 00:00:00	32020		\N	268923	0	10509002	260139		0
58075	3440	4152936	2014-09-20	2014-09-20 00:00:00	2014-10-04	2014-10-04 00:00:00	32020		\N	228231	0	283385000	4152936		0
68784	4071	40481087	1977-09-01	1977-09-01 00:00:00	1977-09-08	1977-09-08 00:00:00	32020		\N	270613	0	444814009	40481087		0
58344	3456	260139	1959-01-17	1959-01-17 00:00:00	1959-01-24	1959-01-24 00:00:00	32020		\N	229297	0	10509002	260139		0
58558	3470	78272	2013-01-23	2013-01-23 00:00:00	2013-02-06	2013-02-06 00:00:00	32020		\N	230297	0	70704007	78272		0
69357	4105	40481087	2004-12-19	2004-12-19 00:00:00	2005-01-02	2005-01-02 00:00:00	32020		\N	272711	0	444814009	40481087		0
58816	3489	40481087	2004-03-29	2004-03-29 00:00:00	2004-04-05	2004-04-05 00:00:00	32020		\N	231474	0	444814009	40481087		0
59002	3501	4112343	2014-10-13	2014-10-13 00:00:00	2014-10-22	2014-10-22 00:00:00	32020		\N	232092	0	195662009	4112343		0
69809	4130	4294548	2008-01-15	2008-01-15 00:00:00	2008-06-10	2008-06-10 00:00:00	32020		\N	274660	0	75498004	4294548		0
80525	4771	4112343	2015-12-16	2015-12-16 00:00:00	2015-12-23	2015-12-23 00:00:00	32020		\N	317761	0	195662009	4112343		0
59521	3529	4112343	1962-03-14	1962-03-14 00:00:00	1962-03-23	1962-03-23 00:00:00	32020		\N	234302	0	195662009	4112343		0
70250	4160	40481087	1970-03-23	1970-03-23 00:00:00	1970-03-30	1970-03-30 00:00:00	32020		\N	276454	0	444814009	40481087		0
70493	4176	260139	1983-05-01	1983-05-01 00:00:00	1983-05-15	1983-05-15 00:00:00	32020		\N	277530	0	10509002	260139		0
70649	4191	40481087	1977-07-07	1977-07-07 00:00:00	1977-07-28	1977-07-28 00:00:00	32020		\N	278125	0	444814009	40481087		0
70739	4199	4116491	1957-05-31	1957-05-31 00:00:00	1957-07-04	1957-07-04 00:00:00	32020		\N	278635	0	301011002	4116491		0
60411	3573	40481087	1931-04-24	1931-04-24 00:00:00	1931-05-15	1931-05-15 00:00:00	32020		\N	237572	0	444814009	40481087		0
60483	3577	4310024	1994-05-20	1994-05-20 00:00:00	\N	\N	32020		\N	237794	0	424802006	4310024		0
71223	4224	4310024	1984-08-27	1984-08-27 00:00:00	\N	\N	32020		\N	280560	0	424802006	4310024		0
60871	3603	80180	2004-03-23	2004-03-23 00:00:00	\N	\N	32020		\N	239322	0	396275006	80180		0
71582	4246	40481087	1968-11-08	1968-11-08 00:00:00	1968-11-29	1968-11-29 00:00:00	32020		\N	281950	0	444814009	40481087		0
61228	3621	372328	1923-07-06	1923-07-06 00:00:00	1923-07-20	1923-07-20 00:00:00	32020		\N	240560	0	65363002	372328		0
61369	3626	40481087	2014-03-17	2014-03-17 00:00:00	2014-03-31	2014-03-31 00:00:00	32020		\N	241140	0	444814009	40481087		0
61537	3636	260139	2010-02-10	2010-02-10 00:00:00	2010-02-17	2010-02-17 00:00:00	32020		\N	241841	0	10509002	260139		0
61641	3641	40481087	1959-05-30	1959-05-30 00:00:00	1959-06-20	1959-06-20 00:00:00	32020		\N	242337	0	444814009	40481087		0
72471	4304	40481087	1994-07-23	1994-07-23 00:00:00	1994-07-30	1994-07-30 00:00:00	32020		\N	285487	0	444814009	40481087		0
72606	4312	40481087	1968-10-26	1968-10-26 00:00:00	1968-11-16	1968-11-16 00:00:00	32020		\N	286137	0	444814009	40481087		0
72717	4320	198809	1970-05-14	1970-05-14 00:00:00	1970-05-14	1970-05-14 00:00:00	32020		\N	286692	0	65275009	198809		0
73027	4340	378001	1995-10-04	1995-10-04 00:00:00	1995-12-03	1995-12-03 00:00:00	32020		\N	287781	0	62106007	378001		0
73075	4342	4084167	1958-10-28	1958-10-28 00:00:00	1958-10-28	1958-10-28 00:00:00	32020		\N	287842	0	241929008	4084167		0
62688	3701	81151	1986-09-16	1986-09-16 00:00:00	1986-10-14	1986-10-14 00:00:00	32020		\N	246069	0	44465007	81151		0
73438	4365	28060	1993-12-09	1993-12-09 00:00:00	1993-12-20	1993-12-20 00:00:00	32020		\N	289523	0	43878008	28060		0
63002	3720	81893	1988-08-20	1988-08-20 00:00:00	\N	\N	32020		\N	247317	0	64766004	81893		0
73795	4383	40481087	2002-09-23	2002-09-23 00:00:00	2002-10-07	2002-10-07 00:00:00	32020		\N	291327	0	444814009	40481087		0
73944	4391	30753	1977-09-21	1977-09-21 00:00:00	\N	\N	32020		\N	292001	0	16761005	30753		0
74099	4401	4112343	1993-03-15	1993-03-15 00:00:00	1993-03-28	1993-03-28 00:00:00	32020		\N	292548	0	195662009	4112343		0
74317	4412	40481087	1966-12-20	1966-12-20 00:00:00	1967-01-10	1967-01-10 00:00:00	32020		\N	293278	0	444814009	40481087		0
63814	3769	260139	1964-02-10	1964-02-10 00:00:00	1964-02-24	1964-02-24 00:00:00	32020		\N	250535	0	10509002	260139		0
64031	3783	4112343	2008-07-24	2008-07-24 00:00:00	2008-08-04	2008-08-04 00:00:00	32020		\N	251389	0	195662009	4112343		0
64115	3787	317576	2013-04-13	2013-04-13 00:00:00	\N	\N	32020		\N	251748	0	53741008	317576		0
53774	3181	4113008	1982-04-25	1982-04-25 00:00:00	1982-05-16	1982-05-16 00:00:00	32020		\N	211657	0	284549007	4113008		0
53902	3191	40481087	2002-04-08	2002-04-08 00:00:00	2002-04-29	2002-04-29 00:00:00	32020		\N	212376	0	444814009	40481087		0
64643	3822	40481087	1980-03-07	1980-03-07 00:00:00	1980-03-28	1980-03-28 00:00:00	32020		\N	253848	0	444814009	40481087		0
54194	3211	4112343	1996-04-18	1996-04-18 00:00:00	1996-04-27	1996-04-27 00:00:00	32020		\N	213332	0	195662009	4112343		0
54427	3223	40481087	1952-11-12	1952-11-12 00:00:00	1952-11-26	1952-11-26 00:00:00	32020		\N	214306	0	444814009	40481087		0
54552	3231	40481087	1981-05-10	1981-05-10 00:00:00	1981-05-24	1981-05-24 00:00:00	32020		\N	214775	0	444814009	40481087		0
54756	3241	40481087	1977-11-22	1977-11-22 00:00:00	1977-11-29	1977-11-29 00:00:00	32020		\N	215487	0	444814009	40481087		0
54925	3249	372328	1972-03-16	1972-03-16 00:00:00	1972-08-20	1972-08-20 00:00:00	32020		\N	215952	0	65363002	372328		0
65673	3884	40481087	2002-02-05	2002-02-05 00:00:00	2002-02-19	2002-02-19 00:00:00	32020		\N	258154	0	444814009	40481087		0
65845	3892	4112343	1968-06-15	1968-06-15 00:00:00	1968-06-25	1968-06-25 00:00:00	32020		\N	258792	0	195662009	4112343		0
65904	3895	260139	1974-04-02	1974-04-02 00:00:00	1974-04-16	1974-04-16 00:00:00	32020		\N	259051	0	10509002	260139		0
55605	3293	260139	1960-12-12	1960-12-12 00:00:00	1960-12-19	1960-12-19 00:00:00	32020		\N	218679	0	10509002	260139		0
66245	3921	4294548	1987-08-09	1987-08-09 00:00:00	1987-09-20	1987-09-20 00:00:00	32020		\N	260696	0	75498004	4294548		0
55880	3308	4112343	1950-08-14	1950-08-14 00:00:00	1950-08-22	1950-08-22 00:00:00	32020		\N	219657	0	195662009	4112343		0
68826	4072	440448	2004-08-31	2004-08-31 00:00:00	\N	\N	32020		\N	270690	0	74400008	440448		0
66687	3946	4155034	1964-01-01	1964-01-01 00:00:00	1964-01-15	1964-01-15 00:00:00	32020		\N	262352	0	283371005	4155034		0
66766	3950	40481087	1987-11-12	1987-11-12 00:00:00	1987-12-03	1987-12-03 00:00:00	32020		\N	262597	0	444814009	40481087		0
66934	3958	192671	2001-12-09	2001-12-09 00:00:00	\N	\N	32020		\N	263146	0	K92.2	35208414		0
67080	3966	81893	2001-10-27	2001-10-27 00:00:00	\N	\N	32020		\N	263706	0	64766004	81893		0
77856	4613	40481087	2018-07-18	2018-07-18 00:00:00	2018-08-08	2018-08-08 00:00:00	32020		\N	307318	0	444814009	40481087		0
67442	3986	40481087	1968-01-26	1968-01-26 00:00:00	1968-02-16	1968-02-16 00:00:00	32020		\N	264980	0	444814009	40481087		0
57099	3389	40481087	1994-09-04	1994-09-04 00:00:00	1994-09-11	1994-09-11 00:00:00	32020		\N	224801	0	444814009	40481087		0
57235	3397	4027663	1972-06-10	1972-06-10 00:00:00	\N	\N	32020		\N	225290	0	13200003	4027663		0
67929	4013	4112343	1990-05-29	1990-05-29 00:00:00	1990-06-11	1990-06-11 00:00:00	32020		\N	266649	0	195662009	4112343		0
68061	4020	28060	2011-07-31	2011-07-31 00:00:00	2011-08-09	2011-08-09 00:00:00	32020		\N	267223	0	43878008	28060		0
68271	4032	260139	1987-02-19	1987-02-19 00:00:00	1987-03-05	1987-03-05 00:00:00	32020		\N	268272	0	10509002	260139		0
68415	4044	40481087	1975-10-21	1975-10-21 00:00:00	1975-11-04	1975-11-04 00:00:00	32020		\N	268938	0	444814009	40481087		0
58076	3440	4134304	1944-01-29	1944-01-29 00:00:00	1944-02-28	1944-02-28 00:00:00	32020		\N	228291	0	263102004	4134304		0
68785	4071	4112343	2011-04-09	2011-04-09 00:00:00	2011-04-20	2011-04-20 00:00:00	32020		\N	270591	0	195662009	4112343		0
58345	3456	4112343	1950-08-03	1950-08-03 00:00:00	1950-08-14	1950-08-14 00:00:00	32020		\N	229305	0	195662009	4112343		0
58559	3470	4112343	1979-12-16	1979-12-16 00:00:00	1979-12-28	1979-12-28 00:00:00	32020		\N	230318	0	195662009	4112343		0
69358	4105	40481087	1988-05-04	1988-05-04 00:00:00	1988-05-11	1988-05-11 00:00:00	32020		\N	272709	0	444814009	40481087		0
58817	3489	40481087	2013-10-31	2013-10-31 00:00:00	2013-11-14	2013-11-14 00:00:00	32020		\N	231476	0	444814009	40481087		0
59037	3504	4059173	1939-11-15	1939-11-15 00:00:00	1940-01-14	1940-01-14 00:00:00	32020		\N	232334	0	16114001	4059173		0
69810	4130	260139	2019-05-17	2019-05-17 00:00:00	2019-05-31	2019-05-31 00:00:00	32020		\N	274647	0	10509002	260139		0
80526	4771	28060	1962-07-15	1962-07-15 00:00:00	1962-07-28	1962-07-28 00:00:00	32020		\N	317774	0	43878008	28060		0
59522	3529	40481087	2012-03-25	2012-03-25 00:00:00	2012-04-08	2012-04-08 00:00:00	32020		\N	234308	0	444814009	40481087		0
70251	4160	372328	1964-01-26	1964-01-26 00:00:00	1964-04-02	1964-04-02 00:00:00	32020		\N	276418	0	65363002	372328		0
70494	4176	4112343	1979-02-14	1979-02-14 00:00:00	1979-02-26	1979-02-26 00:00:00	32020		\N	277551	0	195662009	4112343		0
70650	4191	4116491	2010-08-03	2010-08-03 00:00:00	2010-09-18	2010-09-18 00:00:00	32020		\N	278166	0	301011002	4116491		0
70740	4199	4112343	1953-06-06	1953-06-06 00:00:00	1953-06-15	1953-06-15 00:00:00	32020		\N	278683	0	195662009	4112343		0
60412	3573	4152936	1989-03-31	1989-03-31 00:00:00	1989-04-21	1989-04-21 00:00:00	32020		\N	237629	0	283385000	4152936		0
60484	3577	40481087	1993-10-07	1993-10-07 00:00:00	1993-10-28	1993-10-28 00:00:00	32020		\N	237794	0	444814009	40481087		0
71224	4224	4285898	1985-10-21	1985-10-21 00:00:00	\N	\N	32020		\N	280560	0	68496003	4285898		0
60872	3603	4112343	2002-09-24	2002-09-24 00:00:00	2002-10-06	2002-10-06 00:00:00	32020		\N	239322	0	195662009	4112343		0
71583	4246	260139	1969-10-14	1969-10-14 00:00:00	1969-10-28	1969-10-28 00:00:00	32020		\N	281985	0	10509002	260139		0
61229	3622	260139	2005-01-23	2005-01-23 00:00:00	2005-02-06	2005-02-06 00:00:00	32020		\N	240678	0	10509002	260139		0
61370	3626	80180	2016-07-25	2016-07-25 00:00:00	\N	\N	32020		\N	241163	0	396275006	80180		0
61538	3636	260139	1979-03-12	1979-03-12 00:00:00	1979-03-26	1979-03-26 00:00:00	32020		\N	241804	0	10509002	260139		0
61642	3641	40481087	1992-11-29	1992-11-29 00:00:00	1992-12-06	1992-12-06 00:00:00	32020		\N	242340	0	444814009	40481087		0
72472	4304	4027663	1991-09-05	1991-09-05 00:00:00	\N	\N	32020		\N	285475	0	13200003	4027663		0
72607	4312	40481087	1998-04-30	1998-04-30 00:00:00	1998-05-21	1998-05-21 00:00:00	32020		\N	286059	0	444814009	40481087		0
72718	4320	196456	1970-05-14	1970-05-14 00:00:00	1970-05-14	1970-05-14 00:00:00	32020		\N	286692	0	235919008	196456		0
73028	4340	260139	2002-03-20	2002-03-20 00:00:00	2002-03-27	2002-03-27 00:00:00	32020		\N	287769	0	10509002	260139		0
73076	4342	40481087	1977-10-25	1977-10-25 00:00:00	1977-11-01	1977-11-01 00:00:00	32020		\N	287975	0	444814009	40481087		0
62689	3701	4156265	2000-01-09	2000-01-09 00:00:00	2000-01-30	2000-01-30 00:00:00	32020		\N	246100	0	370247008	4156265		0
73439	4366	260139	1982-05-02	1982-05-02 00:00:00	1982-05-16	1982-05-16 00:00:00	32020		\N	289664	0	10509002	260139		0
63003	3720	4027663	1980-03-30	1980-03-30 00:00:00	\N	\N	32020		\N	247315	0	13200003	4027663		0
73796	4383	4112343	1975-05-18	1975-05-18 00:00:00	1975-05-26	1975-05-26 00:00:00	32020		\N	291338	0	195662009	4112343		0
73945	4391	4112343	2013-10-23	2013-10-23 00:00:00	2013-11-03	2013-11-03 00:00:00	32020		\N	291963	0	195662009	4112343		0
74100	4401	78272	2012-03-10	2012-03-10 00:00:00	2012-03-31	2012-03-31 00:00:00	32020		\N	292564	0	70704007	78272		0
74318	4412	40481087	2010-12-10	2010-12-10 00:00:00	2010-12-31	2010-12-31 00:00:00	32020		\N	293314	0	444814009	40481087		0
63815	3769	40481087	1971-06-06	1971-06-06 00:00:00	1971-06-20	1971-06-20 00:00:00	32020		\N	250536	0	444814009	40481087		0
64032	3783	28060	1953-05-15	1953-05-15 00:00:00	1953-05-28	1953-05-28 00:00:00	32020		\N	251282	0	43878008	28060		0
64116	3787	4112343	2008-12-23	2008-12-23 00:00:00	2009-01-02	2009-01-02 00:00:00	32020		\N	251766	0	195662009	4112343		0
53775	3181	4294548	2001-06-06	2001-06-06 00:00:00	2001-09-05	2001-09-05 00:00:00	32020		\N	211760	0	75498004	4294548		0
53903	3191	81151	1995-04-15	1995-04-15 00:00:00	1995-05-20	1995-05-20 00:00:00	32020		\N	212389	0	44465007	81151		0
64644	3822	372328	1947-04-13	1947-04-13 00:00:00	1947-09-01	1947-09-01 00:00:00	32020		\N	253868	0	65363002	372328		0
54195	3211	80180	1996-11-03	1996-11-03 00:00:00	\N	\N	32020		\N	213332	0	396275006	80180		0
54428	3223	40481087	1995-02-11	1995-02-11 00:00:00	1995-02-25	1995-02-25 00:00:00	32020		\N	214251	0	444814009	40481087		0
54553	3231	40481087	1968-02-29	1968-02-29 00:00:00	1968-03-21	1968-03-21 00:00:00	32020		\N	214739	0	444814009	40481087		0
54757	3241	40481087	1979-05-02	1979-05-02 00:00:00	1979-05-23	1979-05-23 00:00:00	32020		\N	215465	0	444814009	40481087		0
54926	3249	4112343	1967-02-06	1967-02-06 00:00:00	1967-02-13	1967-02-13 00:00:00	32020		\N	215993	0	195662009	4112343		0
65674	3884	257012	1992-01-02	1992-01-02 00:00:00	\N	\N	32020		\N	258075	0	40055000	257012		0
65846	3892	4112343	1984-01-27	1984-01-27 00:00:00	1984-02-07	1984-02-07 00:00:00	32020		\N	258800	0	195662009	4112343		0
65905	3895	4035415	1953-06-30	1953-06-30 00:00:00	1953-07-30	1953-07-30 00:00:00	32020		\N	259022	0	239720000	4035415		0
55606	3293	4237458	2005-06-23	2005-06-23 00:00:00	2005-07-23	2005-07-23 00:00:00	32020		\N	218697	0	58150001	4237458		0
66246	3921	4283893	1982-12-14	1982-12-14 00:00:00	1983-01-25	1983-01-25 00:00:00	32020		\N	260724	0	36971009	4283893		0
55881	3308	372328	1949-09-14	1949-09-14 00:00:00	1950-01-16	1950-01-16 00:00:00	32020		\N	219673	0	65363002	372328		0
66688	3946	4112343	1963-10-07	1963-10-07 00:00:00	1963-10-20	1963-10-20 00:00:00	32020		\N	262339	0	195662009	4112343		0
66767	3950	4027663	2004-09-22	2004-09-22 00:00:00	\N	\N	32020		\N	262532	0	13200003	4027663		0
66935	3958	378001	1964-03-26	1964-03-26 00:00:00	1964-05-25	1964-05-25 00:00:00	32020		\N	263171	0	62106007	378001		0
67081	3966	40481087	2001-06-02	2001-06-02 00:00:00	2001-06-09	2001-06-09 00:00:00	32020		\N	263706	0	444814009	40481087		0
77857	4613	28060	2005-10-07	2005-10-07 00:00:00	2005-10-16	2005-10-16 00:00:00	32020		\N	307273	0	43878008	28060		0
67443	3986	4112343	2000-04-01	2000-04-01 00:00:00	2000-04-12	2000-04-12 00:00:00	32020		\N	264984	0	195662009	4112343		0
57100	3389	40481087	1977-08-16	1977-08-16 00:00:00	1977-09-06	1977-09-06 00:00:00	32020		\N	224787	0	444814009	40481087		0
57236	3397	4142905	1957-12-06	1957-12-06 00:00:00	1958-02-04	1958-02-04 00:00:00	32020		\N	225348	0	33737001	4142905		0
67930	4014	372328	1983-10-14	1983-10-14 00:00:00	1984-04-22	1984-04-22 00:00:00	32020		\N	266810	0	65363002	372328		0
68062	4020	4112343	1975-10-06	1975-10-06 00:00:00	1975-10-18	1975-10-18 00:00:00	32020		\N	267196	0	195662009	4112343		0
68272	4032	28060	2007-06-22	2007-06-22 00:00:00	2007-07-04	2007-07-04 00:00:00	32020		\N	268283	0	43878008	28060		0
68416	4044	260139	1973-03-09	1973-03-09 00:00:00	1973-03-16	1973-03-16 00:00:00	32020		\N	268970	0	10509002	260139		0
58077	3440	260139	1957-10-16	1957-10-16 00:00:00	1957-10-23	1957-10-23 00:00:00	32020		\N	228275	0	10509002	260139		0
68786	4071	40481087	2015-03-26	2015-03-26 00:00:00	2015-04-16	2015-04-16 00:00:00	32020		\N	270569	0	444814009	40481087		0
58346	3456	40481087	1986-05-12	1986-05-12 00:00:00	1986-05-26	1986-05-26 00:00:00	32020		\N	229299	0	444814009	40481087		0
58560	3470	260139	2009-03-29	2009-03-29 00:00:00	2009-04-05	2009-04-05 00:00:00	32020		\N	230345	0	10509002	260139		0
69359	4105	381316	2019-02-16	2019-02-16 00:00:00	\N	\N	32020		\N	272705	0	230690007	381316		0
58818	3489	4116491	1990-10-24	1990-10-24 00:00:00	1990-12-02	1990-12-02 00:00:00	32020		\N	231469	0	301011002	4116491		0
59038	3504	4134304	1937-12-25	1937-12-25 00:00:00	1938-01-24	1938-01-24 00:00:00	32020		\N	232333	0	263102004	4134304		0
69811	4130	372328	1968-03-24	1968-03-24 00:00:00	1968-04-25	1968-04-25 00:00:00	32020		\N	274662	0	65363002	372328		0
80534	4773	4112343	2002-11-01	2002-11-01 00:00:00	2002-11-10	2002-11-10 00:00:00	32020		\N	317851	0	195662009	4112343		0
59523	3529	378001	1979-04-07	1979-04-07 00:00:00	1979-05-07	1979-05-07 00:00:00	32020		\N	234288	0	62106007	378001		0
70253	4160	321042	1965-11-25	1965-11-25 00:00:00	\N	\N	32020		\N	276447	0	410429000	321042		0
70495	4176	4296204	1942-12-08	1942-12-08 00:00:00	1943-01-05	1943-01-05 00:00:00	32020		\N	277543	0	403190006	4296204		0
70651	4191	381316	2004-09-17	2004-09-17 00:00:00	\N	\N	32020		\N	278156	0	230690007	381316		0
70741	4199	40481087	2004-10-06	2004-10-06 00:00:00	2004-10-13	2004-10-13 00:00:00	32020		\N	278690	0	444814009	40481087		0
60413	3573	372328	1928-03-02	1928-03-02 00:00:00	1928-12-29	1928-12-29 00:00:00	32020		\N	237547	0	65363002	372328		0
60485	3577	40481087	2013-03-02	2013-03-02 00:00:00	2013-03-09	2013-03-09 00:00:00	32020		\N	237773	0	444814009	40481087		0
71225	4224	40481087	2003-08-09	2003-08-09 00:00:00	2003-08-30	2003-08-30 00:00:00	32020		\N	280454	0	444814009	40481087		0
60873	3603	4048171	1970-02-12	1970-02-12 00:00:00	\N	\N	32020		\N	239354	0	232353008	4048171		0
71584	4246	4112343	2002-04-03	2002-04-03 00:00:00	2002-04-16	2002-04-16 00:00:00	32020		\N	281957	0	195662009	4112343		0
61230	3622	321042	1953-04-22	1953-04-22 00:00:00	\N	\N	32020		\N	240710	0	410429000	321042		0
61383	3628	4112343	2005-07-07	2005-07-07 00:00:00	2005-07-19	2005-07-19 00:00:00	32020		\N	241365	0	195662009	4112343		0
61539	3636	260139	2002-07-22	2002-07-22 00:00:00	2002-08-05	2002-08-05 00:00:00	32020		\N	241840	0	10509002	260139		0
61643	3641	260139	2000-06-24	2000-06-24 00:00:00	2000-07-08	2000-07-08 00:00:00	32020		\N	242341	0	10509002	260139		0
72473	4304	28060	1996-05-24	1996-05-24 00:00:00	1996-06-03	1996-06-03 00:00:00	32020		\N	285519	0	43878008	28060		0
72608	4313	4266809	1980-01-27	1980-01-27 00:00:00	\N	\N	32020		\N	286227	0	397881000	4266809		0
72719	4321	40481087	1982-10-24	1982-10-24 00:00:00	1982-11-07	1982-11-07 00:00:00	32020		\N	286703	0	444814009	40481087		0
73029	4340	372328	1976-04-04	1976-04-04 00:00:00	1976-08-27	1976-08-27 00:00:00	32020		\N	287750	0	65363002	372328		0
73077	4342	4296204	2014-07-20	2014-07-20 00:00:00	2014-08-10	2014-08-10 00:00:00	32020		\N	287846	0	403190006	4296204		0
62690	3701	257012	1997-10-03	1997-10-03 00:00:00	\N	\N	32020		\N	246040	0	40055000	257012		0
73440	4366	260139	1996-11-12	1996-11-12 00:00:00	1996-11-26	1996-11-26 00:00:00	32020		\N	289616	0	10509002	260139		0
63004	3720	4294548	1999-07-19	1999-07-19 00:00:00	1999-08-09	1999-08-09 00:00:00	32020		\N	247275	0	75498004	4294548		0
73797	4383	4218389	2004-05-21	2004-05-21 00:00:00	2004-06-11	2004-06-11 00:00:00	32020		\N	291359	0	39848009	4218389		0
73946	4391	378419	2015-06-26	2015-06-26 00:00:00	\N	\N	32020		\N	291958	0	26929004	378419		0
74110	4403	4112343	1959-09-23	1959-09-23 00:00:00	1959-10-04	1959-10-04 00:00:00	32020		\N	292654	0	195662009	4112343		0
74319	4412	4113008	2007-01-18	2007-01-18 00:00:00	2007-02-01	2007-02-01 00:00:00	32020		\N	293286	0	284549007	4113008		0
63816	3769	40481087	1974-03-12	1974-03-12 00:00:00	1974-03-19	1974-03-19 00:00:00	32020		\N	250521	0	444814009	40481087		0
64033	3783	4112343	1973-06-01	1973-06-01 00:00:00	1973-06-13	1973-06-13 00:00:00	32020		\N	251429	0	195662009	4112343		0
64117	3787	4112343	2004-07-02	2004-07-02 00:00:00	2004-07-14	2004-07-14 00:00:00	32020		\N	251735	0	195662009	4112343		0
53776	3181	257012	2001-07-11	2001-07-11 00:00:00	\N	\N	32020		\N	211721	0	40055000	257012		0
53904	3191	40481087	2008-01-03	2008-01-03 00:00:00	2008-01-17	2008-01-17 00:00:00	32020		\N	212336	0	444814009	40481087		0
64645	3822	317576	2009-03-23	2009-03-23 00:00:00	\N	\N	32020		\N	253896	0	53741008	317576		0
54196	3211	260139	2001-11-19	2001-11-19 00:00:00	2001-12-03	2001-12-03 00:00:00	32020		\N	213317	0	10509002	260139		0
54429	3223	4112343	1981-10-06	1981-10-06 00:00:00	1981-10-13	1981-10-13 00:00:00	32020		\N	214314	0	195662009	4112343		0
54554	3231	260139	1960-04-27	1960-04-27 00:00:00	1960-05-11	1960-05-11 00:00:00	32020		\N	214774	0	10509002	260139		0
54758	3241	4237458	1965-03-09	1965-03-09 00:00:00	1965-06-07	1965-06-07 00:00:00	32020		\N	215439	0	58150001	4237458		0
54927	3249	4112343	2004-09-08	2004-09-08 00:00:00	2004-09-19	2004-09-19 00:00:00	32020		\N	215967	0	195662009	4112343		0
65675	3884	4294548	1991-12-05	1991-12-05 00:00:00	1992-03-26	1992-03-26 00:00:00	32020		\N	258183	0	75498004	4294548		0
65847	3893	378001	1975-07-26	1975-07-26 00:00:00	1975-09-24	1975-09-24 00:00:00	32020		\N	258876	0	62106007	378001		0
65906	3895	40481087	2005-09-19	2005-09-19 00:00:00	2005-09-26	2005-09-26 00:00:00	32020		\N	259091	0	444814009	40481087		0
55607	3293	4112343	1927-11-23	1927-11-23 00:00:00	1927-12-01	1927-12-01 00:00:00	32020		\N	218705	0	195662009	4112343		0
66247	3921	4027663	2007-11-05	2007-11-05 00:00:00	\N	\N	32020		\N	260714	0	13200003	4027663		0
55882	3308	81151	1951-07-19	1951-07-19 00:00:00	1951-08-16	1951-08-16 00:00:00	32020		\N	219653	0	44465007	81151		0
66689	3946	4266809	2003-02-25	2003-02-25 00:00:00	\N	\N	32020		\N	262326	0	397881000	4266809		0
66768	3950	4112343	1981-08-08	1981-08-08 00:00:00	1981-08-18	1981-08-18 00:00:00	32020		\N	262582	0	195662009	4112343		0
66936	3958	4027663	1992-08-06	1992-08-06 00:00:00	\N	\N	32020		\N	263168	0	13200003	4027663		0
67082	3966	4266809	2003-05-20	2003-05-20 00:00:00	\N	\N	32020		\N	263706	0	397881000	4266809		0
77858	4613	4059173	1990-03-13	1990-03-13 00:00:00	1990-04-12	1990-04-12 00:00:00	32020		\N	307232	0	16114001	4059173		0
67444	3986	40481087	1983-06-23	1983-06-23 00:00:00	1983-06-30	1983-06-30 00:00:00	32020		\N	264986	0	444814009	40481087		0
57101	3389	4112343	2004-09-02	2004-09-02 00:00:00	2004-09-09	2004-09-09 00:00:00	32020		\N	224780	0	195662009	4112343		0
57237	3397	40481087	1995-01-17	1995-01-17 00:00:00	1995-02-07	1995-02-07 00:00:00	32020		\N	225337	0	444814009	40481087		0
67931	4014	4112343	1975-02-18	1975-02-18 00:00:00	1975-03-02	1975-03-02 00:00:00	32020		\N	266693	0	195662009	4112343		0
68063	4020	4112343	1987-01-19	1987-01-19 00:00:00	1987-01-27	1987-01-27 00:00:00	32020		\N	267221	0	195662009	4112343		0
68273	4032	4152936	2010-12-23	2010-12-23 00:00:00	2011-01-13	2011-01-13 00:00:00	32020		\N	268213	0	283385000	4152936		0
68417	4044	260139	1975-01-19	1975-01-19 00:00:00	1975-02-02	1975-02-02 00:00:00	32020		\N	268922	0	10509002	260139		0
58078	3440	4113008	1981-09-21	1981-09-21 00:00:00	1981-10-12	1981-10-12 00:00:00	32020		\N	228227	0	284549007	4113008		0
68787	4071	372328	1952-11-01	1952-11-01 00:00:00	1953-01-08	1953-01-08 00:00:00	32020		\N	270629	0	65363002	372328		0
58347	3456	40481087	1970-08-22	1970-08-22 00:00:00	1970-08-29	1970-08-29 00:00:00	32020		\N	229298	0	444814009	40481087		0
58561	3470	378001	2008-02-19	2008-02-19 00:00:00	2008-03-20	2008-03-20 00:00:00	32020		\N	230330	0	62106007	378001		0
69360	4105	4156265	1960-09-24	1960-09-24 00:00:00	1960-10-15	1960-10-15 00:00:00	32020		\N	272706	0	370247008	4156265		0
58819	3489	4283893	1973-01-31	1973-01-31 00:00:00	1973-03-28	1973-03-28 00:00:00	32020		\N	231446	0	36971009	4283893		0
59039	3504	4296204	1993-12-01	1993-12-01 00:00:00	1993-12-29	1993-12-29 00:00:00	32020		\N	232335	0	403190006	4296204		0
69812	4130	260139	1986-07-28	1986-07-28 00:00:00	1986-08-11	1986-08-11 00:00:00	32020		\N	274527	0	10509002	260139		0
80535	4773	4294548	1959-05-30	1959-05-30 00:00:00	1959-09-12	1959-09-12 00:00:00	32020		\N	317868	0	75498004	4294548		0
59524	3529	4280726	1949-05-02	1949-05-02 00:00:00	1993-07-14	1993-07-14 00:00:00	32020		\N	234434	0	367498001	4280726		0
70254	4160	40481087	1991-09-05	1991-09-05 00:00:00	1991-09-19	1991-09-19 00:00:00	32020		\N	276475	0	444814009	40481087		0
70496	4176	4112343	1984-03-03	1984-03-03 00:00:00	1984-03-13	1984-03-13 00:00:00	32020		\N	277446	0	195662009	4112343		0
70679	4194	28060	2010-03-06	2010-03-06 00:00:00	2010-03-17	2010-03-17 00:00:00	32020		\N	278380	0	43878008	28060		0
70742	4199	4116491	1955-04-24	1955-04-24 00:00:00	1955-06-01	1955-06-01 00:00:00	32020		\N	278634	0	301011002	4116491		0
60414	3573	80180	1963-09-30	1963-09-30 00:00:00	\N	\N	32020		\N	237521	0	396275006	80180		0
60486	3577	80180	1996-05-09	1996-05-09 00:00:00	\N	\N	32020		\N	237812	0	396275006	80180		0
71226	4224	4112343	2008-04-13	2008-04-13 00:00:00	2008-04-26	2008-04-26 00:00:00	32020		\N	280455	0	195662009	4112343		0
60874	3603	4112343	1986-07-07	1986-07-07 00:00:00	1986-07-19	1986-07-19 00:00:00	32020		\N	239416	0	195662009	4112343		0
71585	4246	372328	1972-04-30	1972-04-30 00:00:00	1972-11-22	1972-11-22 00:00:00	32020		\N	281923	0	65363002	372328		0
61232	3622	40481087	2006-07-19	2006-07-19 00:00:00	2006-07-26	2006-07-26 00:00:00	32020		\N	240666	0	444814009	40481087		0
61384	3628	260139	1999-03-10	1999-03-10 00:00:00	1999-03-24	1999-03-24 00:00:00	32020		\N	241299	0	10509002	260139		0
61540	3636	4218389	1993-04-25	1993-04-25 00:00:00	1993-05-23	1993-05-23 00:00:00	32020		\N	241833	0	39848009	4218389		0
61644	3641	4218389	1987-01-03	1987-01-03 00:00:00	1987-01-31	1987-01-31 00:00:00	32020		\N	242314	0	39848009	4218389		0
72474	4304	260139	1988-05-03	1988-05-03 00:00:00	1988-05-17	1988-05-17 00:00:00	32020		\N	285458	0	10509002	260139		0
72609	4313	4285898	1979-05-02	1979-05-02 00:00:00	\N	\N	32020		\N	286227	0	68496003	4285898		0
72720	4321	260139	1991-03-23	1991-03-23 00:00:00	1991-03-30	1991-03-30 00:00:00	32020		\N	286763	0	10509002	260139		0
73030	4340	40481087	1973-09-22	1973-09-22 00:00:00	1973-09-29	1973-09-29 00:00:00	32020		\N	287766	0	444814009	40481087		0
73078	4342	40481087	1997-08-15	1997-08-15 00:00:00	1997-08-29	1997-08-29 00:00:00	32020		\N	287955	0	444814009	40481087		0
62691	3701	260139	1995-10-30	1995-10-30 00:00:00	1995-11-06	1995-11-06 00:00:00	32020		\N	246039	0	10509002	260139		0
73441	4366	40481087	1983-06-30	1983-06-30 00:00:00	1983-07-21	1983-07-21 00:00:00	32020		\N	289666	0	444814009	40481087		0
63005	3720	40481087	1971-12-11	1971-12-11 00:00:00	1971-12-25	1971-12-25 00:00:00	32020		\N	247242	0	444814009	40481087		0
73798	4383	4112343	1983-06-27	1983-06-27 00:00:00	1983-07-10	1983-07-10 00:00:00	32020		\N	291286	0	195662009	4112343		0
73947	4391	80180	1978-06-18	1978-06-18 00:00:00	\N	\N	32020		\N	291972	0	396275006	80180		0
74111	4403	4296205	1964-06-02	1964-06-02 00:00:00	1964-06-16	1964-06-16 00:00:00	32020		\N	292708	0	403191005	4296205		0
74320	4412	40481087	2000-12-15	2000-12-15 00:00:00	2001-01-05	2001-01-05 00:00:00	32020		\N	293404	0	444814009	40481087		0
63817	3769	260139	1954-04-02	1954-04-02 00:00:00	1954-04-09	1954-04-09 00:00:00	32020		\N	250518	0	10509002	260139		0
64034	3783	4283893	2017-03-09	2017-03-09 00:00:00	2017-06-15	2017-06-15 00:00:00	32020		\N	251305	0	36971009	4283893		0
64118	3787	4152936	1980-11-01	1980-11-01 00:00:00	1980-11-15	1980-11-15 00:00:00	32020		\N	251786	0	283385000	4152936		0
53777	3181	4155034	2001-05-27	2001-05-27 00:00:00	2001-06-17	2001-06-17 00:00:00	32020		\N	211688	0	283371005	4155034		0
53905	3191	4112343	1996-10-13	1996-10-13 00:00:00	1996-10-25	1996-10-25 00:00:00	32020		\N	212333	0	195662009	4112343		0
64646	3822	4296204	1969-05-22	1969-05-22 00:00:00	1969-06-19	1969-06-19 00:00:00	32020		\N	253835	0	403190006	4296204		0
54197	3212	260139	1991-09-30	1991-09-30 00:00:00	1991-10-14	1991-10-14 00:00:00	32020		\N	213401	0	10509002	260139		0
54430	3223	40481087	1953-08-30	1953-08-30 00:00:00	1953-09-20	1953-09-20 00:00:00	32020		\N	214262	0	444814009	40481087		0
54555	3231	4112343	1983-03-11	1983-03-11 00:00:00	1983-03-23	1983-03-23 00:00:00	32020		\N	214717	0	195662009	4112343		0
54759	3241	192671	1998-09-14	1998-09-14 00:00:00	\N	\N	32020		\N	215454	0	K92.2	35208414		0
54928	3249	40481087	1974-03-06	1974-03-06 00:00:00	1974-03-13	1974-03-13 00:00:00	32020		\N	216008	0	444814009	40481087		0
65676	3884	4112343	2014-04-18	2014-04-18 00:00:00	2014-04-30	2014-04-30 00:00:00	32020		\N	258191	0	195662009	4112343		0
65848	3893	4296205	1978-11-07	1978-11-07 00:00:00	1978-11-21	1978-11-21 00:00:00	32020		\N	258877	0	403191005	4296205		0
65907	3895	260139	2008-07-08	2008-07-08 00:00:00	2008-07-15	2008-07-15 00:00:00	32020		\N	259076	0	10509002	260139		0
55608	3293	260139	1998-10-02	1998-10-02 00:00:00	1998-10-16	1998-10-16 00:00:00	32020		\N	218735	0	10509002	260139		0
66248	3921	192671	2014-09-04	2014-09-04 00:00:00	\N	\N	32020		\N	260702	0	K92.2	35208414		0
55883	3308	80180	1984-06-15	1984-06-15 00:00:00	\N	\N	32020		\N	219682	0	396275006	80180		0
66690	3946	4285898	2002-11-27	2002-11-27 00:00:00	\N	\N	32020		\N	262326	0	68496003	4285898		0
66769	3950	4218389	1972-10-20	1972-10-20 00:00:00	1972-11-10	1972-11-10 00:00:00	32020		\N	262522	0	39848009	4218389		0
66937	3958	4296205	1965-04-20	1965-04-20 00:00:00	1965-05-11	1965-05-11 00:00:00	32020		\N	263172	0	403191005	4296205		0
67083	3967	260139	2013-02-25	2013-02-25 00:00:00	2013-03-11	2013-03-11 00:00:00	32020		\N	263774	0	10509002	260139		0
77859	4613	378001	1997-07-04	1997-07-04 00:00:00	1997-09-02	1997-09-02 00:00:00	32020		\N	307233	0	62106007	378001		0
67445	3986	28060	1967-02-27	1967-02-27 00:00:00	1967-03-08	1967-03-08 00:00:00	32020		\N	264985	0	43878008	28060		0
57102	3389	40481087	1966-06-29	1966-06-29 00:00:00	1966-07-06	1966-07-06 00:00:00	32020		\N	224761	0	444814009	40481087		0
57238	3397	4112343	2010-04-24	2010-04-24 00:00:00	2010-05-01	2010-05-01 00:00:00	32020		\N	225314	0	195662009	4112343		0
67932	4014	40481087	1976-07-21	1976-07-21 00:00:00	1976-08-04	1976-08-04 00:00:00	32020		\N	266730	0	444814009	40481087		0
68064	4020	4296205	1972-09-08	1972-09-08 00:00:00	1972-09-22	1972-09-22 00:00:00	32020		\N	267236	0	403191005	4296205		0
68274	4033	4294548	2009-03-06	2009-03-06 00:00:00	2009-05-09	2009-05-09 00:00:00	32020		\N	268384	0	75498004	4294548		0
68418	4044	4218389	2017-01-23	2017-01-23 00:00:00	2017-02-27	2017-02-27 00:00:00	32020		\N	268992	0	39848009	4218389		0
58079	3440	4059173	1955-05-31	1955-05-31 00:00:00	1955-06-30	1955-06-30 00:00:00	32020		\N	228292	0	16114001	4059173		0
68788	4071	80180	1998-08-07	1998-08-07 00:00:00	\N	\N	32020		\N	270638	0	396275006	80180		0
58348	3456	40481087	1956-11-04	1956-11-04 00:00:00	1956-11-25	1956-11-25 00:00:00	32020		\N	229306	0	444814009	40481087		0
58562	3470	4155034	1991-10-18	1991-10-18 00:00:00	1991-11-08	1991-11-08 00:00:00	32020		\N	230328	0	283371005	4155034		0
69361	4105	4112343	2010-02-24	2010-02-24 00:00:00	2010-03-05	2010-03-05 00:00:00	32020		\N	272731	0	195662009	4112343		0
58820	3489	80180	2012-08-09	2012-08-09 00:00:00	\N	\N	32020		\N	231458	0	396275006	80180		0
59040	3504	378419	2001-12-28	2001-12-28 00:00:00	\N	\N	32020		\N	232301	0	26929004	378419		0
69813	4130	375671	1993-01-21	1993-01-21 00:00:00	1993-03-22	1993-03-22 00:00:00	32020		\N	274663	0	62564004	375671		0
80536	4773	81151	1989-01-21	1989-01-21 00:00:00	1989-02-11	1989-02-11 00:00:00	32020		\N	317891	0	44465007	81151		0
59525	3529	4237458	1951-03-05	1951-03-05 00:00:00	1951-05-04	1951-05-04 00:00:00	32020		\N	234287	0	58150001	4237458		0
71267	4226	80180	2002-11-28	2002-11-28 00:00:00	\N	\N	32020		\N	280643	0	396275006	80180		0
70255	4160	4112343	2012-10-13	2012-10-13 00:00:00	2012-10-21	2012-10-21 00:00:00	32020		\N	276458	0	195662009	4112343		0
70497	4176	4152936	1979-03-27	1979-03-27 00:00:00	1979-04-17	1979-04-17 00:00:00	32020		\N	277544	0	283385000	4152936		0
70680	4194	372328	1981-08-28	1981-08-28 00:00:00	1982-04-11	1982-04-11 00:00:00	32020		\N	278381	0	65363002	372328		0
70743	4199	40481087	1952-02-21	1952-02-21 00:00:00	1952-03-06	1952-03-06 00:00:00	32020		\N	278680	0	444814009	40481087		0
60415	3573	40481087	1963-09-24	1963-09-24 00:00:00	1963-10-15	1963-10-15 00:00:00	32020		\N	237521	0	444814009	40481087		0
60487	3577	4266809	1996-05-09	1996-05-09 00:00:00	\N	\N	32020		\N	237812	0	397881000	4266809		0
71227	4224	40481087	1981-03-24	1981-03-24 00:00:00	1981-03-31	1981-03-31 00:00:00	32020		\N	280457	0	444814009	40481087		0
60875	3603	260139	1969-12-18	1969-12-18 00:00:00	1969-12-25	1969-12-25 00:00:00	32020		\N	239375	0	10509002	260139		0
71586	4246	4310024	2004-01-18	2004-01-18 00:00:00	\N	\N	32020		\N	281958	0	424802006	4310024		0
61233	3622	4278672	1925-02-07	1925-02-07 00:00:00	1925-04-08	1925-04-08 00:00:00	32020		\N	240709	0	65966004	4278672		0
61385	3628	4112343	2003-08-06	2003-08-06 00:00:00	2003-08-14	2003-08-14 00:00:00	32020		\N	241364	0	195662009	4112343		0
61541	3637	40481087	2014-05-25	2014-05-25 00:00:00	2014-06-08	2014-06-08 00:00:00	32020		\N	241926	0	444814009	40481087		0
61645	3641	40481087	1976-05-29	1976-05-29 00:00:00	1976-06-05	1976-06-05 00:00:00	32020		\N	242331	0	444814009	40481087		0
72475	4304	257012	2015-03-18	2015-03-18 00:00:00	\N	\N	32020		\N	285511	0	40055000	257012		0
72610	4313	80180	1980-01-27	1980-01-27 00:00:00	\N	\N	32020		\N	286227	0	396275006	80180		0
72721	4321	260139	1993-08-18	1993-08-18 00:00:00	1993-09-01	1993-09-01 00:00:00	32020		\N	286705	0	10509002	260139		0
73031	4340	4218389	1984-02-13	1984-02-13 00:00:00	1984-03-05	1984-03-05 00:00:00	32020		\N	287780	0	39848009	4218389		0
73079	4342	4027663	1986-06-28	1986-06-28 00:00:00	\N	\N	32020		\N	287866	0	13200003	4027663		0
62692	3701	4283893	1997-08-29	1997-08-29 00:00:00	1997-12-26	1997-12-26 00:00:00	32020		\N	246034	0	36971009	4283893		0
73442	4366	40481087	1983-09-24	1983-09-24 00:00:00	1983-10-08	1983-10-08 00:00:00	32020		\N	289639	0	444814009	40481087		0
63006	3720	40481087	2011-06-25	2011-06-25 00:00:00	2011-07-16	2011-07-16 00:00:00	32020		\N	247237	0	444814009	40481087		0
73799	4383	40481087	1996-11-19	1996-11-19 00:00:00	1996-12-03	1996-12-03 00:00:00	32020		\N	291289	0	444814009	40481087		0
73948	4392	40481087	2013-01-04	2013-01-04 00:00:00	2013-01-25	2013-01-25 00:00:00	32020		\N	292051	0	444814009	40481087		0
74112	4403	4059173	1940-10-01	1940-10-01 00:00:00	1940-11-30	1940-11-30 00:00:00	32020		\N	292703	0	16114001	4059173		0
74321	4412	80180	2002-09-11	2002-09-11 00:00:00	\N	\N	32020		\N	293404	0	396275006	80180		0
63818	3769	4146173	1971-06-27	1971-06-27 00:00:00	1971-07-27	1971-07-27 00:00:00	32020		\N	250538	0	307731004	4146173		0
64035	3784	4116491	1954-08-14	1954-08-14 00:00:00	1954-09-30	1954-09-30 00:00:00	32020		\N	251492	0	301011002	4116491		0
64119	3787	80180	1998-07-20	1998-07-20 00:00:00	\N	\N	32020		\N	251750	0	396275006	80180		0
53778	3181	4112343	1989-11-21	1989-11-21 00:00:00	1989-12-04	1989-12-04 00:00:00	32020		\N	211664	0	195662009	4112343		0
53906	3191	4112343	2012-04-07	2012-04-07 00:00:00	2012-04-18	2012-04-18 00:00:00	32020		\N	212334	0	195662009	4112343		0
64647	3823	260139	1969-10-25	1969-10-25 00:00:00	1969-11-01	1969-11-01 00:00:00	32020		\N	253908	0	10509002	260139		0
54198	3212	4218389	1996-05-15	1996-05-15 00:00:00	1996-06-19	1996-06-19 00:00:00	32020		\N	213428	0	39848009	4218389		0
54431	3223	378419	1991-07-10	1991-07-10 00:00:00	\N	\N	32020		\N	214230	0	26929004	378419		0
54556	3231	40481087	1953-08-04	1953-08-04 00:00:00	1953-08-25	1953-08-25 00:00:00	32020		\N	214771	0	444814009	40481087		0
54760	3241	4112343	1986-05-15	1986-05-15 00:00:00	1986-05-25	1986-05-25 00:00:00	32020		\N	215541	0	195662009	4112343		0
54929	3249	4112343	1983-02-22	1983-02-22 00:00:00	1983-03-01	1983-03-01 00:00:00	32020		\N	215948	0	195662009	4112343		0
65677	3884	28060	1980-01-18	1980-01-18 00:00:00	1980-01-31	1980-01-31 00:00:00	32020		\N	258146	0	43878008	28060		0
65849	3893	40481087	2011-05-06	2011-05-06 00:00:00	2011-05-27	2011-05-27 00:00:00	32020		\N	258844	0	444814009	40481087		0
65908	3895	40481087	1959-08-31	1959-08-31 00:00:00	1959-09-14	1959-09-14 00:00:00	32020		\N	259120	0	444814009	40481087		0
55609	3293	80180	1950-04-26	1950-04-26 00:00:00	\N	\N	32020		\N	218672	0	396275006	80180		0
66249	3921	40481087	2011-07-25	2011-07-25 00:00:00	2011-08-08	2011-08-08 00:00:00	32020		\N	260718	0	444814009	40481087		0
55884	3308	4112343	1949-05-04	1949-05-04 00:00:00	1949-05-17	1949-05-17 00:00:00	32020		\N	219662	0	195662009	4112343		0
66691	3946	80180	2003-02-25	2003-02-25 00:00:00	\N	\N	32020		\N	262326	0	396275006	80180		0
66770	3951	40481087	1948-04-06	1948-04-06 00:00:00	1948-04-27	1948-04-27 00:00:00	32020		\N	262648	0	444814009	40481087		0
66938	3958	4285898	2001-06-25	2001-06-25 00:00:00	\N	\N	32020		\N	263194	0	68496003	4285898		0
67084	3967	260139	2018-06-17	2018-06-17 00:00:00	2018-07-01	2018-07-01 00:00:00	32020		\N	263776	0	10509002	260139		0
77860	4613	260139	2018-05-21	2018-05-21 00:00:00	2018-06-04	2018-06-04 00:00:00	32020		\N	307317	0	10509002	260139		0
67446	3986	4109685	1990-04-09	1990-04-09 00:00:00	1990-04-23	1990-04-23 00:00:00	32020		\N	265021	0	284551006	4109685		0
57103	3389	4113008	2016-12-25	2016-12-25 00:00:00	2017-01-08	2017-01-08 00:00:00	32020		\N	224745	0	284549007	4113008		0
57239	3397	81893	1980-09-01	1980-09-01 00:00:00	\N	\N	32020		\N	225374	0	64766004	81893		0
67933	4014	378001	1984-07-29	1984-07-29 00:00:00	1984-09-27	1984-09-27 00:00:00	32020		\N	266740	0	62106007	378001		0
68065	4020	257012	1973-08-26	1973-08-26 00:00:00	\N	\N	32020		\N	267195	0	40055000	257012		0
68275	4033	40481087	2012-11-10	2012-11-10 00:00:00	2012-11-24	2012-11-24 00:00:00	32020		\N	268365	0	444814009	40481087		0
68419	4044	4112343	2009-11-26	2009-11-26 00:00:00	2009-12-05	2009-12-05 00:00:00	32020		\N	268953	0	195662009	4112343		0
58080	3440	4218389	2009-11-10	2009-11-10 00:00:00	2009-12-15	2009-12-15 00:00:00	32020		\N	228230	0	39848009	4218389		0
68789	4071	260139	1965-10-03	1965-10-03 00:00:00	1965-10-17	1965-10-17 00:00:00	32020		\N	270611	0	10509002	260139		0
58349	3456	372328	1945-10-07	1945-10-07 00:00:00	1945-11-15	1945-11-15 00:00:00	32020		\N	229311	0	65363002	372328		0
58563	3470	28060	1962-06-19	1962-06-19 00:00:00	1962-06-28	1962-06-28 00:00:00	32020		\N	230301	0	43878008	28060		0
69362	4105	4113008	2000-11-14	2000-11-14 00:00:00	2000-12-05	2000-12-05 00:00:00	32020		\N	272707	0	284549007	4113008		0
58821	3489	40481087	1987-12-15	1987-12-15 00:00:00	1987-12-29	1987-12-29 00:00:00	32020		\N	231460	0	444814009	40481087		0
59041	3504	192671	1956-05-19	1956-05-19 00:00:00	\N	\N	32020		\N	232331	0	K92.2	35208414		0
69814	4130	260139	1997-03-02	1997-03-02 00:00:00	1997-03-16	1997-03-16 00:00:00	32020		\N	274535	0	10509002	260139		0
80537	4773	40481087	1976-04-22	1976-04-22 00:00:00	1976-05-13	1976-05-13 00:00:00	32020		\N	317848	0	444814009	40481087		0
59526	3529	4112343	1949-01-16	1949-01-16 00:00:00	1949-01-24	1949-01-24 00:00:00	32020		\N	234433	0	195662009	4112343		0
70256	4160	81151	2017-06-08	2017-06-08 00:00:00	2017-06-29	2017-06-29 00:00:00	32020		\N	276413	0	44465007	81151		0
70498	4176	40481087	1972-10-08	1972-10-08 00:00:00	1972-10-15	1972-10-15 00:00:00	32020		\N	277550	0	444814009	40481087		0
70681	4194	260139	2012-06-18	2012-06-18 00:00:00	2012-07-02	2012-07-02 00:00:00	32020		\N	278372	0	10509002	260139		0
70744	4199	4294548	1968-08-23	1968-08-23 00:00:00	1968-09-20	1968-09-20 00:00:00	32020		\N	278682	0	75498004	4294548		0
60416	3573	40481087	1934-03-08	1934-03-08 00:00:00	1934-03-15	1934-03-15 00:00:00	32020		\N	237579	0	444814009	40481087		0
60488	3577	372328	1961-05-28	1961-05-28 00:00:00	1961-08-07	1961-08-07 00:00:00	32020		\N	237844	0	65363002	372328		0
71228	4224	40481087	1959-04-08	1959-04-08 00:00:00	1959-04-29	1959-04-29 00:00:00	32020		\N	280486	0	444814009	40481087		0
60876	3603	260139	1974-06-14	1974-06-14 00:00:00	1974-06-21	1974-06-21 00:00:00	32020		\N	239361	0	10509002	260139		0
71587	4246	40481087	2003-07-13	2003-07-13 00:00:00	2003-08-03	2003-08-03 00:00:00	32020		\N	281958	0	444814009	40481087		0
61234	3622	28060	2002-01-05	2002-01-05 00:00:00	2002-01-12	2002-01-12 00:00:00	32020		\N	240779	0	43878008	28060		0
61386	3628	372328	1915-10-23	1915-10-23 00:00:00	1915-11-06	1915-11-06 00:00:00	32020		\N	241333	0	65363002	372328		0
61542	3637	4112343	1993-07-25	1993-07-25 00:00:00	1993-08-04	1993-08-04 00:00:00	32020		\N	241924	0	195662009	4112343		0
61646	3641	4112343	1967-10-24	1967-10-24 00:00:00	1967-10-31	1967-10-31 00:00:00	32020		\N	242330	0	195662009	4112343		0
72476	4304	4294548	2014-12-31	2014-12-31 00:00:00	2015-08-12	2015-08-12 00:00:00	32020		\N	285510	0	75498004	4294548		0
72611	4313	260139	1991-08-28	1991-08-28 00:00:00	1991-09-04	1991-09-04 00:00:00	32020		\N	286264	0	10509002	260139		0
72722	4321	81151	2011-03-30	2011-03-30 00:00:00	2011-04-13	2011-04-13 00:00:00	32020		\N	286753	0	44465007	81151		0
73032	4340	4112343	2003-02-07	2003-02-07 00:00:00	2003-02-14	2003-02-14 00:00:00	32020		\N	287749	0	195662009	4112343		0
73080	4342	260139	1987-05-06	1987-05-06 00:00:00	1987-05-14	1987-05-14 00:00:00	32020		\N	287866	0	10509002	260139		0
62693	3701	4112343	1968-06-12	1968-06-12 00:00:00	1968-06-21	1968-06-21 00:00:00	32020		\N	246125	0	195662009	4112343		0
73443	4366	40481087	2007-12-21	2007-12-21 00:00:00	2008-01-11	2008-01-11 00:00:00	32020		\N	289718	0	444814009	40481087		0
63007	3720	4112343	1983-06-01	1983-06-01 00:00:00	1983-06-12	1983-06-12 00:00:00	32020		\N	247245	0	195662009	4112343		0
73800	4383	260139	1990-12-20	1990-12-20 00:00:00	1991-01-03	1991-01-03 00:00:00	32020		\N	291307	0	10509002	260139		0
73949	4392	81151	1991-01-02	1991-01-02 00:00:00	1991-01-30	1991-01-30 00:00:00	32020		\N	292083	0	44465007	81151		0
74113	4403	4112343	1945-09-19	1945-09-19 00:00:00	1945-10-02	1945-10-02 00:00:00	32020		\N	292658	0	195662009	4112343		0
74322	4412	40481087	1979-12-21	1979-12-21 00:00:00	1980-01-04	1980-01-04 00:00:00	32020		\N	293306	0	444814009	40481087		0
63819	3769	40481087	1962-05-09	1962-05-09 00:00:00	1962-05-16	1962-05-16 00:00:00	32020		\N	250520	0	444814009	40481087		0
64036	3784	4112343	1987-07-07	1987-07-07 00:00:00	1987-07-19	1987-07-19 00:00:00	32020		\N	251495	0	195662009	4112343		0
64120	3787	260139	1979-09-28	1979-09-28 00:00:00	1979-10-12	1979-10-12 00:00:00	32020		\N	251773	0	10509002	260139		0
53779	3181	40481087	1981-12-02	1981-12-02 00:00:00	1981-12-16	1981-12-16 00:00:00	32020		\N	211661	0	444814009	40481087		0
53907	3191	40481087	1995-04-30	1995-04-30 00:00:00	1995-05-14	1995-05-14 00:00:00	32020		\N	212375	0	444814009	40481087		0
64648	3823	4112343	1966-12-26	1966-12-26 00:00:00	1967-01-03	1967-01-03 00:00:00	32020		\N	253977	0	195662009	4112343		0
54199	3212	260139	2009-04-30	2009-04-30 00:00:00	2009-05-14	2009-05-14 00:00:00	32020		\N	213404	0	10509002	260139		0
54432	3223	40481087	1978-09-28	1978-09-28 00:00:00	1978-10-12	1978-10-12 00:00:00	32020		\N	214249	0	444814009	40481087		0
54557	3231	260139	1996-07-01	1996-07-01 00:00:00	1996-07-08	1996-07-08 00:00:00	32020		\N	214777	0	10509002	260139		0
54761	3241	378001	2007-02-02	2007-02-02 00:00:00	2007-03-04	2007-03-04 00:00:00	32020		\N	215444	0	62106007	378001		0
54930	3250	40481087	1980-01-23	1980-01-23 00:00:00	1980-01-30	1980-01-30 00:00:00	32020		\N	216055	0	444814009	40481087		0
65678	3884	40481087	2001-05-14	2001-05-14 00:00:00	2001-06-04	2001-06-04 00:00:00	32020		\N	258153	0	444814009	40481087		0
65850	3893	78272	1996-10-17	1996-10-17 00:00:00	1996-10-31	1996-10-31 00:00:00	32020		\N	258878	0	70704007	78272		0
65909	3896	4218389	1985-01-28	1985-01-28 00:00:00	1985-02-18	1985-02-18 00:00:00	32020		\N	259185	0	39848009	4218389		0
55610	3293	30753	1949-05-31	1949-05-31 00:00:00	\N	\N	32020		\N	218672	0	16761005	30753		0
66250	3921	40481087	2017-10-10	2017-10-10 00:00:00	2017-10-17	2017-10-17 00:00:00	32020		\N	260697	0	444814009	40481087		0
55895	3311	28060	2011-09-12	2011-09-12 00:00:00	2011-09-20	2011-09-20 00:00:00	32020		\N	219769	0	43878008	28060		0
66692	3946	81151	1972-06-01	1972-06-01 00:00:00	1972-06-15	1972-06-15 00:00:00	32020		\N	262353	0	44465007	81151		0
66771	3951	372328	2006-04-18	2006-04-18 00:00:00	2006-05-02	2006-05-02 00:00:00	32020		\N	262646	0	65363002	372328		0
66939	3958	80180	2001-11-22	2001-11-22 00:00:00	\N	\N	32020		\N	263194	0	396275006	80180		0
67085	3967	260139	2009-07-23	2009-07-23 00:00:00	2009-08-06	2009-08-06 00:00:00	32020		\N	263772	0	10509002	260139		0
77861	4613	260139	1996-09-21	1996-09-21 00:00:00	1996-09-28	1996-09-28 00:00:00	32020		\N	307272	0	10509002	260139		0
67447	3986	40481087	1966-02-05	1966-02-05 00:00:00	1966-02-26	1966-02-26 00:00:00	32020		\N	264979	0	444814009	40481087		0
57104	3389	260139	1998-04-05	1998-04-05 00:00:00	1998-04-19	1998-04-19 00:00:00	32020		\N	224788	0	10509002	260139		0
57240	3397	30753	1981-07-28	1981-07-28 00:00:00	\N	\N	32020		\N	225374	0	16761005	30753		0
67934	4014	40481087	1993-11-27	1993-11-27 00:00:00	1993-12-18	1993-12-18 00:00:00	32020		\N	266783	0	444814009	40481087		0
68066	4020	260139	1965-02-23	1965-02-23 00:00:00	1965-03-02	1965-03-02 00:00:00	32020		\N	267266	0	10509002	260139		0
68276	4033	40481087	1995-02-07	1995-02-07 00:00:00	1995-02-21	1995-02-21 00:00:00	32020		\N	268382	0	444814009	40481087		0
68420	4044	40481087	1984-06-29	1984-06-29 00:00:00	1984-07-13	1984-07-13 00:00:00	32020		\N	268950	0	444814009	40481087		0
58081	3440	81151	1960-12-14	1960-12-14 00:00:00	1960-12-28	1960-12-28 00:00:00	32020		\N	228295	0	44465007	81151		0
68790	4071	40481087	1974-08-21	1974-08-21 00:00:00	1974-09-11	1974-09-11 00:00:00	32020		\N	270588	0	444814009	40481087		0
58350	3456	4112343	1982-03-03	1982-03-03 00:00:00	1982-03-16	1982-03-16 00:00:00	32020		\N	229288	0	195662009	4112343		0
58564	3470	28060	1967-05-06	1967-05-06 00:00:00	1967-05-19	1967-05-19 00:00:00	32020		\N	230298	0	43878008	28060		0
69363	4105	4112343	1969-01-28	1969-01-28 00:00:00	1969-02-07	1969-02-07 00:00:00	32020		\N	272697	0	195662009	4112343		0
58822	3489	372328	1975-05-16	1975-05-16 00:00:00	1975-10-04	1975-10-04 00:00:00	32020		\N	231463	0	65363002	372328		0
59042	3504	372328	1924-05-07	1924-05-07 00:00:00	1924-07-25	1924-07-25 00:00:00	32020		\N	232280	0	65363002	372328		0
69815	4130	372328	1966-05-25	1966-05-25 00:00:00	1966-10-27	1966-10-27 00:00:00	32020		\N	274538	0	65363002	372328		0
80538	4773	40481087	2015-11-25	2015-11-25 00:00:00	2015-12-09	2015-12-09 00:00:00	32020		\N	317854	0	444814009	40481087		0
59527	3529	40481087	1976-01-06	1976-01-06 00:00:00	1976-01-13	1976-01-13 00:00:00	32020		\N	234320	0	444814009	40481087		0
70257	4160	40481087	1968-09-01	1968-09-01 00:00:00	1968-09-22	1968-09-22 00:00:00	32020		\N	276470	0	444814009	40481087		0
70499	4176	40481087	1991-05-07	1991-05-07 00:00:00	1991-05-21	1991-05-21 00:00:00	32020		\N	277494	0	444814009	40481087		0
70682	4194	4112343	2003-08-08	2003-08-08 00:00:00	2003-08-17	2003-08-17 00:00:00	32020		\N	278407	0	195662009	4112343		0
70745	4199	4112343	2003-08-01	2003-08-01 00:00:00	2003-08-10	2003-08-10 00:00:00	32020		\N	278617	0	195662009	4112343		0
60417	3573	4112343	1931-05-17	1931-05-17 00:00:00	1931-05-29	1931-05-29 00:00:00	32020		\N	237573	0	195662009	4112343		0
60489	3577	40481087	1973-08-16	1973-08-16 00:00:00	1973-08-30	1973-08-30 00:00:00	32020		\N	237840	0	444814009	40481087		0
71229	4224	260139	2019-03-30	2019-03-30 00:00:00	2019-04-13	2019-04-13 00:00:00	32020		\N	280555	0	10509002	260139		0
60877	3603	40481087	1969-08-30	1969-08-30 00:00:00	1969-09-13	1969-09-13 00:00:00	32020		\N	239441	0	444814009	40481087		0
71588	4246	4112343	2002-08-17	2002-08-17 00:00:00	2002-08-29	2002-08-29 00:00:00	32020		\N	281952	0	195662009	4112343		0
61235	3622	28060	2012-09-04	2012-09-04 00:00:00	2012-09-15	2012-09-15 00:00:00	32020		\N	240781	0	43878008	28060		0
61387	3628	4146173	1971-05-07	1971-05-07 00:00:00	1971-07-06	1971-07-06 00:00:00	32020		\N	241390	0	307731004	4146173		0
61543	3637	40481087	1974-02-05	1974-02-05 00:00:00	1974-02-12	1974-02-12 00:00:00	32020		\N	241943	0	444814009	40481087		0
61647	3641	28060	1943-11-18	1943-11-18 00:00:00	1943-11-27	1943-11-27 00:00:00	32020		\N	242323	0	43878008	28060		0
72477	4304	260139	1967-05-11	1967-05-11 00:00:00	1967-05-25	1967-05-25 00:00:00	32020		\N	285484	0	10509002	260139		0
72612	4313	260139	2006-02-18	2006-02-18 00:00:00	2006-02-25	2006-02-25 00:00:00	32020		\N	286298	0	10509002	260139		0
72723	4321	4218389	1992-09-14	1992-09-14 00:00:00	1992-10-05	1992-10-05 00:00:00	32020		\N	286752	0	39848009	4218389		0
73033	4340	81151	2000-10-07	2000-10-07 00:00:00	2000-10-28	2000-10-28 00:00:00	32020		\N	287782	0	44465007	81151		0
73081	4342	4155034	2016-07-21	2016-07-21 00:00:00	2016-08-11	2016-08-11 00:00:00	32020		\N	287848	0	283371005	4155034		0
62694	3701	40481087	1981-03-29	1981-03-29 00:00:00	1981-04-19	1981-04-19 00:00:00	32020		\N	246120	0	444814009	40481087		0
73444	4366	28060	1983-09-25	1983-09-25 00:00:00	1983-10-02	1983-10-02 00:00:00	32020		\N	289667	0	43878008	28060		0
63008	3720	4285898	1989-11-13	1989-11-13 00:00:00	\N	\N	32020		\N	247318	0	68496003	4285898		0
73801	4383	80180	2008-06-24	2008-06-24 00:00:00	\N	\N	32020		\N	291292	0	396275006	80180		0
73950	4392	40481087	2016-12-14	2016-12-14 00:00:00	2017-01-04	2017-01-04 00:00:00	32020		\N	292062	0	444814009	40481087		0
74114	4403	260139	1969-02-21	1969-02-21 00:00:00	1969-03-07	1969-03-07 00:00:00	32020		\N	292660	0	10509002	260139		0
74323	4412	260139	1979-12-07	1979-12-07 00:00:00	1979-12-21	1979-12-21 00:00:00	32020		\N	293325	0	10509002	260139		0
63820	3769	40481087	1951-01-26	1951-01-26 00:00:00	1951-02-16	1951-02-16 00:00:00	32020		\N	250576	0	444814009	40481087		0
64037	3784	372328	1932-08-08	1932-08-08 00:00:00	1932-12-13	1932-12-13 00:00:00	32020		\N	251466	0	65363002	372328		0
64121	3787	4329847	2016-08-27	2016-08-27 00:00:00	\N	\N	32020		\N	251789	0	22298006	4329847		0
53780	3181	40481087	1976-12-01	1976-12-01 00:00:00	1976-12-22	1976-12-22 00:00:00	32020		\N	211829	0	444814009	40481087		0
53908	3191	381316	2015-09-24	2015-09-24 00:00:00	\N	\N	32020		\N	212402	0	230690007	381316		0
64649	3823	257012	2011-01-30	2011-01-30 00:00:00	\N	\N	32020		\N	253909	0	40055000	257012		0
54200	3212	81151	1986-08-31	1986-08-31 00:00:00	1986-10-05	1986-10-05 00:00:00	32020		\N	213427	0	44465007	81151		0
54433	3223	28060	1948-07-05	1948-07-05 00:00:00	1948-07-12	1948-07-12 00:00:00	32020		\N	214240	0	43878008	28060		0
54558	3231	4156265	1957-11-22	1957-11-22 00:00:00	1957-12-13	1957-12-13 00:00:00	32020		\N	214727	0	370247008	4156265		0
54762	3241	40481087	2002-08-02	2002-08-02 00:00:00	2002-08-09	2002-08-09 00:00:00	32020		\N	215524	0	444814009	40481087		0
54931	3250	4112343	1977-06-07	1977-06-07 00:00:00	1977-06-17	1977-06-17 00:00:00	32020		\N	216051	0	195662009	4112343		0
65679	3884	40481087	1974-03-25	1974-03-25 00:00:00	1974-04-01	1974-04-01 00:00:00	32020		\N	258072	0	444814009	40481087		0
65851	3893	28060	1979-10-07	1979-10-07 00:00:00	1979-10-14	1979-10-14 00:00:00	32020		\N	258879	0	43878008	28060		0
65910	3896	4112343	2006-10-09	2006-10-09 00:00:00	2006-10-21	2006-10-21 00:00:00	32020		\N	259150	0	195662009	4112343		0
66084	3909	260139	2012-12-23	2012-12-23 00:00:00	2013-01-06	2013-01-06 00:00:00	32020		\N	259855	0	10509002	260139		0
66251	3921	80180	2014-06-26	2014-06-26 00:00:00	\N	\N	32020		\N	260749	0	396275006	80180		0
55896	3311	40481087	1979-10-01	1979-10-01 00:00:00	1979-10-22	1979-10-22 00:00:00	32020		\N	219847	0	444814009	40481087		0
66693	3946	40481087	1988-09-28	1988-09-28 00:00:00	1988-10-12	1988-10-12 00:00:00	32020		\N	262356	0	444814009	40481087		0
66772	3951	4112343	1973-08-06	1973-08-06 00:00:00	1973-08-15	1973-08-15 00:00:00	32020		\N	262652	0	195662009	4112343		0
66940	3958	30753	2001-03-27	2001-03-27 00:00:00	\N	\N	32020		\N	263194	0	16761005	30753		0
67086	3967	440448	1993-04-25	1993-04-25 00:00:00	\N	\N	32020		\N	263745	0	74400008	440448		0
77862	4613	372328	1967-10-14	1967-10-14 00:00:00	1967-10-28	1967-10-28 00:00:00	32020		\N	307282	0	65363002	372328		0
67448	3986	260139	1992-06-18	1992-06-18 00:00:00	1992-06-25	1992-06-25 00:00:00	32020		\N	264983	0	10509002	260139		0
67563	3991	40481087	1968-06-14	1968-06-14 00:00:00	1968-06-28	1968-06-28 00:00:00	32020		\N	265325	0	444814009	40481087		0
57241	3397	4285898	1981-08-27	1981-08-27 00:00:00	\N	\N	32020		\N	225374	0	68496003	4285898		0
67935	4014	40481087	1985-08-25	1985-08-25 00:00:00	1985-09-01	1985-09-01 00:00:00	32020		\N	266769	0	444814009	40481087		0
68067	4020	40481087	1996-04-26	1996-04-26 00:00:00	1996-05-17	1996-05-17 00:00:00	32020		\N	267222	0	444814009	40481087		0
68277	4033	40481087	1997-08-18	1997-08-18 00:00:00	1997-09-01	1997-09-01 00:00:00	32020		\N	268383	0	444814009	40481087		0
68421	4044	40481087	1979-02-16	1979-02-16 00:00:00	1979-03-02	1979-03-02 00:00:00	32020		\N	268949	0	444814009	40481087		0
58082	3440	81151	1978-02-18	1978-02-18 00:00:00	1978-03-11	1978-03-11 00:00:00	32020		\N	228226	0	44465007	81151		0
68791	4071	4296204	1986-02-11	1986-02-11 00:00:00	1986-03-04	1986-03-04 00:00:00	32020		\N	270583	0	403190006	4296204		0
58351	3456	80180	1982-07-13	1982-07-13 00:00:00	\N	\N	32020		\N	229288	0	396275006	80180		0
58565	3470	4152936	1971-10-28	1971-10-28 00:00:00	1971-11-11	1971-11-11 00:00:00	32020		\N	230326	0	283385000	4152936		0
69364	4105	260139	1950-08-04	1950-08-04 00:00:00	1950-08-18	1950-08-18 00:00:00	32020		\N	272720	0	10509002	260139		0
58823	3489	40481087	1998-05-30	1998-05-30 00:00:00	1998-06-20	1998-06-20 00:00:00	32020		\N	231473	0	444814009	40481087		0
59043	3504	4112343	1946-01-27	1946-01-27 00:00:00	1946-02-04	1946-02-04 00:00:00	32020		\N	232336	0	195662009	4112343		0
69816	4130	40481087	2005-05-08	2005-05-08 00:00:00	2005-05-29	2005-05-29 00:00:00	32020		\N	274609	0	444814009	40481087		0
80539	4773	40481087	2015-04-07	2015-04-07 00:00:00	2015-04-21	2015-04-21 00:00:00	32020		\N	317853	0	444814009	40481087		0
59528	3529	80180	1976-07-07	1976-07-07 00:00:00	\N	\N	32020		\N	234320	0	396275006	80180		0
70258	4160	260139	2017-01-27	2017-01-27 00:00:00	2017-02-03	2017-02-03 00:00:00	32020		\N	276476	0	10509002	260139		0
70500	4176	40481087	1981-01-09	1981-01-09 00:00:00	1981-01-23	1981-01-23 00:00:00	32020		\N	277529	0	444814009	40481087		0
70683	4194	40481087	1984-02-21	1984-02-21 00:00:00	1984-02-28	1984-02-28 00:00:00	32020		\N	278378	0	444814009	40481087		0
70746	4199	80180	1979-08-06	1979-08-06 00:00:00	\N	\N	32020		\N	278660	0	396275006	80180		0
60418	3573	40481087	1937-07-04	1937-07-04 00:00:00	1937-07-18	1937-07-18 00:00:00	32020		\N	237515	0	444814009	40481087		0
60490	3577	260139	2011-03-08	2011-03-08 00:00:00	2011-03-15	2011-03-15 00:00:00	32020		\N	237801	0	10509002	260139		0
71230	4224	40481087	1968-12-13	1968-12-13 00:00:00	1968-12-27	1968-12-27 00:00:00	32020		\N	280444	0	444814009	40481087		0
60878	3603	440086	1980-02-03	1980-02-03 00:00:00	1984-02-12	1984-02-12 00:00:00	32020		\N	239364	0	192127007	440086		0
71589	4246	260139	2005-08-14	2005-08-14 00:00:00	2005-08-28	2005-08-28 00:00:00	32020		\N	281922	0	10509002	260139		0
61236	3622	40481087	1970-11-02	1970-11-02 00:00:00	1970-11-09	1970-11-09 00:00:00	32020		\N	240792	0	444814009	40481087		0
61388	3628	40481087	1992-02-06	1992-02-06 00:00:00	1992-02-20	1992-02-20 00:00:00	32020		\N	241362	0	444814009	40481087		0
61544	3637	28060	1970-11-09	1970-11-09 00:00:00	1970-11-19	1970-11-19 00:00:00	32020		\N	241921	0	43878008	28060		0
61648	3641	40481087	1920-10-29	1920-10-29 00:00:00	1920-11-05	1920-11-05 00:00:00	32020		\N	242357	0	444814009	40481087		0
72478	4304	4112343	1990-09-08	1990-09-08 00:00:00	1990-09-21	1990-09-21 00:00:00	32020		\N	285518	0	195662009	4112343		0
72613	4313	4294548	1990-05-26	1990-05-26 00:00:00	1990-06-02	1990-06-02 00:00:00	32020		\N	286314	0	75498004	4294548		0
72724	4321	40481087	1984-04-06	1984-04-06 00:00:00	1984-04-27	1984-04-27 00:00:00	32020		\N	286704	0	444814009	40481087		0
73034	4340	40481087	2006-07-13	2006-07-13 00:00:00	2006-07-20	2006-07-20 00:00:00	32020		\N	287777	0	444814009	40481087		0
73082	4343	80502	2014-12-15	2014-12-15 00:00:00	\N	\N	32020		\N	288073	0	64859006	80502		0
62712	3703	40481087	1998-11-21	1998-11-21 00:00:00	1998-12-05	1998-12-05 00:00:00	32020		\N	246192	0	444814009	40481087		0
73445	4366	372328	1983-01-25	1983-01-25 00:00:00	1983-02-08	1983-02-08 00:00:00	32020		\N	289621	0	65363002	372328		0
63009	3720	80180	1990-06-11	1990-06-11 00:00:00	\N	\N	32020		\N	247318	0	396275006	80180		0
73802	4383	40481087	2002-05-04	2002-05-04 00:00:00	2002-05-18	2002-05-18 00:00:00	32020		\N	291290	0	444814009	40481087		0
73951	4392	4094814	2016-10-20	2016-10-20 00:00:00	2016-11-19	2016-11-19 00:00:00	32020		\N	292048	0	262574004	4094814		0
74115	4403	40481087	1993-04-14	1993-04-14 00:00:00	1993-05-05	1993-05-05 00:00:00	32020		\N	292723	0	444814009	40481087		0
74324	4412	40479422	2000-09-14	2000-09-14 00:00:00	2000-11-20	2000-11-20 00:00:00	32020		\N	293285	0	444448004	40479422		0
63821	3769	40481087	2017-06-18	2017-06-18 00:00:00	2017-06-25	2017-06-25 00:00:00	32020		\N	250546	0	444814009	40481087		0
64038	3784	4218389	1949-08-27	1949-08-27 00:00:00	1949-09-17	1949-09-17 00:00:00	32020		\N	251488	0	39848009	4218389		0
64123	3787	260139	2010-10-04	2010-10-04 00:00:00	2010-10-11	2010-10-11 00:00:00	32020		\N	251736	0	10509002	260139		0
53781	3181	261325	2000-09-22	2000-09-22 00:00:00	\N	\N	32020		\N	211714	0	87433001	261325		0
53909	3191	372328	1960-04-13	1960-04-13 00:00:00	1960-09-01	1960-09-01 00:00:00	32020		\N	212377	0	65363002	372328		0
64650	3823	4155034	2009-01-27	2009-01-27 00:00:00	2009-02-17	2009-02-17 00:00:00	32020		\N	253974	0	283371005	4155034		0
54201	3212	260139	1995-09-18	1995-09-18 00:00:00	1995-10-02	1995-10-02 00:00:00	32020		\N	213418	0	10509002	260139		0
54434	3223	80180	1959-12-21	1959-12-21 00:00:00	\N	\N	32020		\N	214325	0	396275006	80180		0
54559	3231	40481087	1954-03-01	1954-03-01 00:00:00	1954-03-22	1954-03-22 00:00:00	32020		\N	214772	0	444814009	40481087		0
54763	3241	78272	1976-09-07	1976-09-07 00:00:00	1976-10-12	1976-10-12 00:00:00	32020		\N	215441	0	70704007	78272		0
54932	3250	40481087	2003-01-25	2003-01-25 00:00:00	2003-02-15	2003-02-15 00:00:00	32020		\N	216093	0	444814009	40481087		0
65680	3884	260139	1997-01-12	1997-01-12 00:00:00	1997-01-19	1997-01-19 00:00:00	32020		\N	258055	0	10509002	260139		0
65852	3893	80180	2011-04-28	2011-04-28 00:00:00	\N	\N	32020		\N	258860	0	396275006	80180		0
65911	3896	372328	1978-08-03	1978-08-03 00:00:00	1978-09-15	1978-09-15 00:00:00	32020		\N	259170	0	65363002	372328		0
66085	3909	40481087	1977-02-21	1977-02-21 00:00:00	1977-03-07	1977-03-07 00:00:00	32020		\N	259830	0	444814009	40481087		0
66252	3921	4266809	2014-06-26	2014-06-26 00:00:00	\N	\N	32020		\N	260749	0	397881000	4266809		0
55897	3311	4113008	1965-01-03	1965-01-03 00:00:00	1965-01-17	1965-01-17 00:00:00	32020		\N	219795	0	284549007	4113008		0
66694	3946	4112343	1980-06-19	1980-06-19 00:00:00	1980-06-26	1980-06-26 00:00:00	32020		\N	262306	0	195662009	4112343		0
66773	3951	4283893	1990-02-21	1990-02-21 00:00:00	1990-09-26	1990-09-26 00:00:00	32020		\N	262685	0	36971009	4283893		0
66941	3958	4266809	2001-11-22	2001-11-22 00:00:00	\N	\N	32020		\N	263194	0	397881000	4266809		0
67087	3967	372328	2008-04-26	2008-04-26 00:00:00	2008-05-25	2008-05-25 00:00:00	32020		\N	263714	0	65363002	372328		0
77863	4613	4218389	1967-04-17	1967-04-17 00:00:00	1967-05-22	1967-05-22 00:00:00	32020		\N	307230	0	39848009	4218389		0
67449	3986	260139	1973-09-24	1973-09-24 00:00:00	1973-10-01	1973-10-01 00:00:00	32020		\N	264966	0	10509002	260139		0
67564	3991	40481087	1962-07-20	1962-07-20 00:00:00	1962-08-10	1962-08-10 00:00:00	32020		\N	265324	0	444814009	40481087		0
57242	3397	28060	2008-10-18	2008-10-18 00:00:00	2008-10-27	2008-10-27 00:00:00	32020		\N	225327	0	43878008	28060		0
67936	4014	372328	1993-07-04	1993-07-04 00:00:00	1996-05-19	1996-05-19 00:00:00	32020		\N	266752	0	65363002	372328		0
68068	4020	4152936	1959-12-11	1959-12-11 00:00:00	1960-01-01	1960-01-01 00:00:00	32020		\N	267234	0	283385000	4152936		0
68278	4033	40481087	2000-03-24	2000-03-24 00:00:00	2000-03-31	2000-03-31 00:00:00	32020		\N	268359	0	444814009	40481087		0
68422	4044	4112343	2017-10-27	2017-10-27 00:00:00	2017-11-08	2017-11-08 00:00:00	32020		\N	268954	0	195662009	4112343		0
58083	3440	28060	1985-06-30	1985-06-30 00:00:00	1985-07-11	1985-07-11 00:00:00	32020		\N	228261	0	43878008	28060		0
68792	4071	4094814	1969-12-07	1969-12-07 00:00:00	1970-02-05	1970-02-05 00:00:00	32020		\N	270582	0	262574004	4094814		0
58352	3456	321042	1991-12-12	1991-12-12 00:00:00	\N	\N	32020		\N	229296	0	410429000	321042		0
58566	3470	4112343	2012-08-01	2012-08-01 00:00:00	2012-08-10	2012-08-10 00:00:00	32020		\N	230346	0	195662009	4112343		0
69365	4105	4112343	1973-11-15	1973-11-15 00:00:00	1973-11-24	1973-11-24 00:00:00	32020		\N	272759	0	195662009	4112343		0
58824	3489	40481087	1991-12-13	1991-12-13 00:00:00	1991-12-27	1991-12-27 00:00:00	32020		\N	231461	0	444814009	40481087		0
59044	3504	40481087	1999-05-20	1999-05-20 00:00:00	1999-05-27	1999-05-27 00:00:00	32020		\N	232322	0	444814009	40481087		0
69817	4130	4155034	1999-12-19	1999-12-19 00:00:00	2000-01-02	2000-01-02 00:00:00	32020		\N	274666	0	283371005	4155034		0
80540	4773	4294548	2016-06-12	2016-06-12 00:00:00	2016-07-17	2016-07-17 00:00:00	32020		\N	317873	0	75498004	4294548		0
59529	3529	372328	1944-09-23	1944-09-23 00:00:00	1945-01-03	1945-01-03 00:00:00	32020		\N	234310	0	65363002	372328		0
70259	4160	40481087	1985-09-13	1985-09-13 00:00:00	1985-09-27	1985-09-27 00:00:00	32020		\N	276473	0	444814009	40481087		0
70501	4176	40481087	1944-01-06	1944-01-06 00:00:00	1944-01-20	1944-01-20 00:00:00	32020		\N	277527	0	444814009	40481087		0
70684	4194	4112343	1976-08-28	1976-08-28 00:00:00	1976-09-10	1976-09-10 00:00:00	32020		\N	278369	0	195662009	4112343		0
70747	4199	4112343	1973-09-07	1973-09-07 00:00:00	1973-09-20	1973-09-20 00:00:00	32020		\N	278613	0	195662009	4112343		0
60419	3573	4142905	2000-01-24	2000-01-24 00:00:00	2000-03-24	2000-03-24 00:00:00	32020		\N	237630	0	33737001	4142905		0
60491	3577	378001	2007-12-23	2007-12-23 00:00:00	2008-01-22	2008-01-22 00:00:00	32020		\N	237829	0	62106007	378001		0
71231	4224	4112343	2005-05-14	2005-05-14 00:00:00	2005-05-26	2005-05-26 00:00:00	32020		\N	280493	0	195662009	4112343		0
60879	3603	372328	1971-09-08	1971-09-08 00:00:00	1972-01-02	1972-01-02 00:00:00	32020		\N	239323	0	65363002	372328		0
71590	4246	40481087	1987-05-09	1987-05-09 00:00:00	1987-05-30	1987-05-30 00:00:00	32020		\N	281956	0	444814009	40481087		0
61237	3622	4059173	2008-11-18	2008-11-18 00:00:00	2008-12-18	2008-12-18 00:00:00	32020		\N	240712	0	16114001	4059173		0
61389	3628	4278672	1985-09-25	1985-09-25 00:00:00	1985-10-25	1985-10-25 00:00:00	32020		\N	241355	0	65966004	4278672		0
61545	3637	4112343	1966-10-16	1966-10-16 00:00:00	1966-10-27	1966-10-27 00:00:00	32020		\N	241899	0	195662009	4112343		0
61649	3641	4218389	1946-06-27	1946-06-27 00:00:00	1946-08-01	1946-08-01 00:00:00	32020		\N	242311	0	39848009	4218389		0
72479	4304	80180	2002-02-19	2002-02-19 00:00:00	\N	\N	32020		\N	285508	0	396275006	80180		0
72614	4313	40481087	1975-12-12	1975-12-12 00:00:00	1976-01-02	1976-01-02 00:00:00	32020		\N	286311	0	444814009	40481087		0
72725	4321	80180	2006-05-13	2006-05-13 00:00:00	\N	\N	32020		\N	286740	0	396275006	80180		0
73035	4340	4285898	2009-10-03	2009-10-03 00:00:00	\N	\N	32020		\N	287786	0	68496003	4285898		0
73083	4343	4113008	1963-04-11	1963-04-11 00:00:00	1963-04-25	1963-04-25 00:00:00	32020		\N	288077	0	284549007	4113008		0
62713	3703	40481087	1993-06-01	1993-06-01 00:00:00	1993-06-15	1993-06-15 00:00:00	32020		\N	246227	0	444814009	40481087		0
73446	4366	4051466	1984-05-11	1984-05-11 00:00:00	2001-04-03	2001-04-03 00:00:00	32020		\N	289632	0	233678006	4051466		0
63010	3720	40481087	2016-07-25	2016-07-25 00:00:00	2016-08-08	2016-08-08 00:00:00	32020		\N	247238	0	444814009	40481087		0
73803	4383	40481087	2015-07-03	2015-07-03 00:00:00	2015-07-24	2015-07-24 00:00:00	32020		\N	291329	0	444814009	40481087		0
73952	4392	40481087	1993-07-27	1993-07-27 00:00:00	1993-08-10	1993-08-10 00:00:00	32020		\N	292060	0	444814009	40481087		0
74116	4403	40481087	1958-11-29	1958-11-29 00:00:00	1958-12-20	1958-12-20 00:00:00	32020		\N	292659	0	444814009	40481087		0
74325	4412	40481087	1978-03-05	1978-03-05 00:00:00	1978-03-26	1978-03-26 00:00:00	32020		\N	293324	0	444814009	40481087		0
63822	3769	260139	1981-07-29	1981-07-29 00:00:00	1981-08-05	1981-08-05 00:00:00	32020		\N	250522	0	10509002	260139		0
64039	3784	40481087	1974-10-10	1974-10-10 00:00:00	1974-10-17	1974-10-17 00:00:00	32020		\N	251493	0	444814009	40481087		0
64124	3788	40481087	1996-04-01	1996-04-01 00:00:00	1996-04-15	1996-04-15 00:00:00	32020		\N	251842	0	444814009	40481087		0
53782	3181	4084167	1959-05-05	1959-05-05 00:00:00	1959-05-06	1959-05-06 00:00:00	32020		\N	211653	0	241929008	4084167		0
53910	3191	40481087	2014-03-24	2014-03-24 00:00:00	2014-04-07	2014-04-07 00:00:00	32020		\N	212339	0	444814009	40481087		0
64651	3823	40481087	1967-12-05	1967-12-05 00:00:00	1967-12-19	1967-12-19 00:00:00	32020		\N	253947	0	444814009	40481087		0
54202	3212	260139	2000-12-10	2000-12-10 00:00:00	2000-12-24	2000-12-24 00:00:00	32020		\N	213432	0	10509002	260139		0
54435	3223	4112343	1959-10-17	1959-10-17 00:00:00	1959-10-29	1959-10-29 00:00:00	32020		\N	214325	0	195662009	4112343		0
54560	3231	40481087	2018-08-14	2018-08-14 00:00:00	2018-08-21	2018-08-21 00:00:00	32020		\N	214718	0	444814009	40481087		0
54764	3241	260139	1966-02-04	1966-02-04 00:00:00	1966-02-18	1966-02-18 00:00:00	32020		\N	215445	0	10509002	260139		0
54933	3250	80180	2002-08-16	2002-08-16 00:00:00	\N	\N	32020		\N	216053	0	396275006	80180		0
65681	3884	372328	1974-07-15	1974-07-15 00:00:00	1974-09-02	1974-09-02 00:00:00	32020		\N	258156	0	65363002	372328		0
65853	3893	4112343	2004-09-06	2004-09-06 00:00:00	2004-09-16	2004-09-16 00:00:00	32020		\N	258882	0	195662009	4112343		0
65912	3896	4112343	1990-01-26	1990-01-26 00:00:00	1990-02-03	1990-02-03 00:00:00	32020		\N	259165	0	195662009	4112343		0
66086	3909	260139	1997-12-03	1997-12-03 00:00:00	1997-12-10	1997-12-10 00:00:00	32020		\N	259868	0	10509002	260139		0
66253	3921	81151	2007-07-19	2007-07-19 00:00:00	2007-08-23	2007-08-23 00:00:00	32020		\N	260706	0	44465007	81151		0
55898	3311	40481087	1970-08-10	1970-08-10 00:00:00	1970-08-24	1970-08-24 00:00:00	32020		\N	219860	0	444814009	40481087		0
66695	3946	260139	1970-04-01	1970-04-01 00:00:00	1970-04-15	1970-04-15 00:00:00	32020		\N	262340	0	10509002	260139		0
66774	3951	4285898	1985-10-04	1985-10-04 00:00:00	\N	\N	32020		\N	262604	0	68496003	4285898		0
66942	3958	81893	2000-05-01	2000-05-01 00:00:00	\N	\N	32020		\N	263193	0	64766004	81893		0
67088	3967	4112343	1964-03-14	1964-03-14 00:00:00	1964-03-25	1964-03-25 00:00:00	32020		\N	263766	0	195662009	4112343		0
77864	4613	40481087	1984-07-23	1984-07-23 00:00:00	1984-08-06	1984-08-06 00:00:00	32020		\N	307264	0	444814009	40481087		0
67450	3986	260139	1971-03-07	1971-03-07 00:00:00	1971-03-14	1971-03-14 00:00:00	32020		\N	264965	0	10509002	260139		0
67565	3991	257012	1954-09-06	1954-09-06 00:00:00	1969-08-03	1969-08-03 00:00:00	32020		\N	265318	0	40055000	257012		0
57243	3397	260139	2010-01-08	2010-01-08 00:00:00	2010-01-22	2010-01-22 00:00:00	32020		\N	225313	0	10509002	260139		0
67937	4014	4059173	2018-10-29	2018-10-29 00:00:00	2018-12-28	2018-12-28 00:00:00	32020		\N	266741	0	16114001	4059173		0
68069	4020	4283893	1984-04-18	1984-04-18 00:00:00	1984-06-20	1984-06-20 00:00:00	32020		\N	267220	0	36971009	4283893		0
68279	4033	260139	2003-09-17	2003-09-17 00:00:00	2003-10-01	2003-10-01 00:00:00	32020		\N	268351	0	10509002	260139		0
68423	4044	260139	2004-03-12	2004-03-12 00:00:00	2004-03-19	2004-03-19 00:00:00	32020		\N	268952	0	10509002	260139		0
58084	3440	4112343	2017-07-28	2017-07-28 00:00:00	2017-08-09	2017-08-09 00:00:00	32020		\N	228278	0	195662009	4112343		0
68793	4071	4112343	1994-09-09	1994-09-09 00:00:00	1994-09-20	1994-09-20 00:00:00	32020		\N	270566	0	195662009	4112343		0
58354	3456	317576	1989-12-21	1989-12-21 00:00:00	\N	\N	32020		\N	229286	0	53741008	317576		0
58567	3470	80180	1999-02-08	1999-02-08 00:00:00	\N	\N	32020		\N	230342	0	396275006	80180		0
69366	4106	40481087	1969-05-09	1969-05-09 00:00:00	1969-05-23	1969-05-23 00:00:00	32020		\N	272835	0	444814009	40481087		0
58825	3489	257012	1973-02-21	1973-02-21 00:00:00	\N	\N	32020		\N	231468	0	40055000	257012		0
59045	3504	40481087	1943-08-03	1943-08-03 00:00:00	1943-08-17	1943-08-17 00:00:00	32020		\N	232307	0	444814009	40481087		0
69818	4130	80180	2004-04-28	2004-04-28 00:00:00	\N	\N	32020		\N	274549	0	396275006	80180		0
80541	4773	4112343	2003-05-11	2003-05-11 00:00:00	2003-05-24	2003-05-24 00:00:00	32020		\N	317894	0	195662009	4112343		0
59530	3529	4134304	2017-05-15	2017-05-15 00:00:00	2017-08-13	2017-08-13 00:00:00	32020		\N	234452	0	263102004	4134304		0
70260	4160	40481087	1963-10-07	1963-10-07 00:00:00	1963-10-21	1963-10-21 00:00:00	32020		\N	276453	0	444814009	40481087		0
70502	4176	4294548	1996-11-26	1996-11-26 00:00:00	1996-12-31	1996-12-31 00:00:00	32020		\N	277448	0	75498004	4294548		0
70685	4194	80180	2014-07-06	2014-07-06 00:00:00	\N	\N	32020		\N	278405	0	396275006	80180		0
70748	4199	134438	1962-04-29	1962-04-29 00:00:00	1963-01-28	1963-01-28 00:00:00	32020		\N	278644	0	40275004	134438		0
60420	3573	4112343	1946-05-24	1946-05-24 00:00:00	1946-06-03	1946-06-03 00:00:00	32020		\N	237577	0	195662009	4112343		0
60492	3577	260139	2013-08-28	2013-08-28 00:00:00	2013-09-04	2013-09-04 00:00:00	32020		\N	237843	0	10509002	260139		0
71232	4224	260139	1996-12-04	1996-12-04 00:00:00	1996-12-11	1996-12-11 00:00:00	32020		\N	280453	0	10509002	260139		0
60880	3603	260139	1973-12-13	1973-12-13 00:00:00	1973-12-27	1973-12-27 00:00:00	32020		\N	239360	0	10509002	260139		0
71591	4246	40481087	1967-07-02	1967-07-02 00:00:00	1967-07-09	1967-07-09 00:00:00	32020		\N	281949	0	444814009	40481087		0
61238	3622	40480160	2008-11-18	2008-11-18 00:00:00	2008-12-18	2008-12-18 00:00:00	32020		\N	240712	0	443165006	40480160		0
61390	3628	40480160	1985-09-25	1985-09-25 00:00:00	1985-10-25	1985-10-25 00:00:00	32020		\N	241355	0	443165006	40480160		0
61546	3637	40481087	2003-09-20	2003-09-20 00:00:00	2003-10-11	2003-10-11 00:00:00	32020		\N	241909	0	444814009	40481087		0
61650	3641	4156265	1924-08-30	1924-08-30 00:00:00	1924-09-20	1924-09-20 00:00:00	32020		\N	242310	0	370247008	4156265		0
72480	4304	40481087	1999-11-08	1999-11-08 00:00:00	1999-11-29	1999-11-29 00:00:00	32020		\N	285508	0	444814009	40481087		0
72615	4313	4310024	1978-01-07	1978-01-07 00:00:00	\N	\N	32020		\N	286311	0	424802006	4310024		0
72726	4321	40481087	1995-08-15	1995-08-15 00:00:00	1995-08-29	1995-08-29 00:00:00	32020		\N	286764	0	444814009	40481087		0
73036	4340	81893	2008-08-09	2008-08-09 00:00:00	\N	\N	32020		\N	287786	0	64766004	81893		0
73084	4343	4109685	1999-07-04	1999-07-04 00:00:00	1999-07-18	1999-07-18 00:00:00	32020		\N	288081	0	284551006	4109685		0
62714	3703	28060	2014-07-22	2014-07-22 00:00:00	2014-07-31	2014-07-31 00:00:00	32020		\N	246231	0	43878008	28060		0
73447	4366	375671	1995-08-20	1995-08-20 00:00:00	1995-10-19	1995-10-19 00:00:00	32020		\N	289594	0	62564004	375671		0
63011	3721	40481087	1969-03-10	1969-03-10 00:00:00	1969-03-31	1969-03-31 00:00:00	32020		\N	247386	0	444814009	40481087		0
73804	4383	40481087	1977-10-28	1977-10-28 00:00:00	1977-11-11	1977-11-11 00:00:00	32020		\N	291320	0	444814009	40481087		0
73953	4392	4155034	1997-07-27	1997-07-27 00:00:00	1997-08-10	1997-08-10 00:00:00	32020		\N	292084	0	283371005	4155034		0
74117	4403	260139	1982-07-12	1982-07-12 00:00:00	1982-07-26	1982-07-26 00:00:00	32020		\N	292669	0	10509002	260139		0
74326	4412	4112343	1994-06-27	1994-06-27 00:00:00	1994-07-07	1994-07-07 00:00:00	32020		\N	293385	0	195662009	4112343		0
63823	3769	40481087	1960-01-05	1960-01-05 00:00:00	1960-01-12	1960-01-12 00:00:00	32020		\N	250519	0	444814009	40481087		0
64040	3784	4112343	1972-08-12	1972-08-12 00:00:00	1972-08-21	1972-08-21 00:00:00	32020		\N	251509	0	195662009	4112343		0
64125	3788	4237458	1967-08-26	1967-08-26 00:00:00	1967-09-25	1967-09-25 00:00:00	32020		\N	251800	0	58150001	4237458		0
53783	3181	4112343	1985-06-30	1985-06-30 00:00:00	1985-07-12	1985-07-12 00:00:00	32020		\N	211830	0	195662009	4112343		0
53911	3191	260139	2016-07-03	2016-07-03 00:00:00	2016-07-17	2016-07-17 00:00:00	32020		\N	212341	0	10509002	260139		0
64652	3823	260139	1997-07-09	1997-07-09 00:00:00	1997-07-23	1997-07-23 00:00:00	32020		\N	253921	0	10509002	260139		0
54203	3212	260139	1987-05-30	1987-05-30 00:00:00	1987-06-13	1987-06-13 00:00:00	32020		\N	213449	0	10509002	260139		0
54436	3223	257012	1976-08-10	1976-08-10 00:00:00	\N	\N	32020		\N	214313	0	40055000	257012		0
54561	3231	40481087	1949-04-15	1949-04-15 00:00:00	1949-04-22	1949-04-22 00:00:00	32020		\N	214796	0	444814009	40481087		0
54765	3241	4134304	1970-02-11	1970-02-11 00:00:00	1970-04-12	1970-04-12 00:00:00	32020		\N	215440	0	263102004	4134304		0
54934	3250	40481087	2002-01-16	2002-01-16 00:00:00	2002-01-23	2002-01-23 00:00:00	32020		\N	216053	0	444814009	40481087		0
58397	3458	80180	2019-03-28	2019-03-28 00:00:00	\N	\N	32020		\N	229453	0	396275006	80180		0
65682	3884	378001	1979-01-18	1979-01-18 00:00:00	1979-03-19	1979-03-19 00:00:00	32020		\N	258014	0	62106007	378001		0
65854	3893	260139	1988-09-17	1988-09-17 00:00:00	1988-09-24	1988-09-24 00:00:00	32020		\N	258880	0	10509002	260139		0
65913	3896	40481087	2007-04-16	2007-04-16 00:00:00	2007-04-30	2007-04-30 00:00:00	32020		\N	259182	0	444814009	40481087		0
66087	3909	28060	2015-03-05	2015-03-05 00:00:00	2015-03-12	2015-03-12 00:00:00	32020		\N	259869	0	43878008	28060		0
66254	3921	372328	1982-02-09	1982-02-09 00:00:00	1982-04-21	1982-04-21 00:00:00	32020		\N	260722	0	65363002	372328		0
55899	3311	40481087	2013-08-29	2013-08-29 00:00:00	2013-09-05	2013-09-05 00:00:00	32020		\N	219770	0	444814009	40481087		0
66696	3946	4027663	1991-03-15	1991-03-15 00:00:00	\N	\N	32020		\N	262315	0	13200003	4027663		0
66775	3951	4112343	1988-05-23	1988-05-23 00:00:00	1988-06-05	1988-06-05 00:00:00	32020		\N	262619	0	195662009	4112343		0
66943	3958	260139	1974-02-03	1974-02-03 00:00:00	1974-02-10	1974-02-10 00:00:00	32020		\N	263179	0	10509002	260139		0
67089	3967	40481087	2006-08-15	2006-08-15 00:00:00	2006-08-29	2006-08-29 00:00:00	32020		\N	263771	0	444814009	40481087		0
77865	4613	260139	1996-02-15	1996-02-15 00:00:00	1996-02-22	1996-02-22 00:00:00	32020		\N	307260	0	10509002	260139		0
67451	3986	4112343	1974-04-03	1974-04-03 00:00:00	1974-04-16	1974-04-16 00:00:00	32020		\N	264982	0	195662009	4112343		0
67573	3993	4296205	1974-07-03	1974-07-03 00:00:00	1974-07-31	1974-07-31 00:00:00	32020		\N	265524	0	403191005	4296205		0
57244	3397	80180	1981-12-25	1981-12-25 00:00:00	\N	\N	32020		\N	225351	0	396275006	80180		0
67938	4014	40481087	1971-05-07	1971-05-07 00:00:00	1971-05-14	1971-05-14 00:00:00	32020		\N	266761	0	444814009	40481087		0
68070	4020	4156265	1968-02-18	1968-02-18 00:00:00	1968-03-03	1968-03-03 00:00:00	32020		\N	267235	0	370247008	4156265		0
68280	4033	28060	1979-11-21	1979-11-21 00:00:00	1979-12-03	1979-12-03 00:00:00	32020		\N	268316	0	43878008	28060		0
68424	4044	80180	1993-06-19	1993-06-19 00:00:00	\N	\N	32020		\N	268959	0	396275006	80180		0
58085	3440	40481087	1944-11-26	1944-11-26 00:00:00	1944-12-17	1944-12-17 00:00:00	32020		\N	228273	0	444814009	40481087		0
68794	4071	4112343	1976-07-30	1976-07-30 00:00:00	1976-08-07	1976-08-07 00:00:00	32020		\N	270619	0	195662009	4112343		0
58355	3457	78272	1930-12-01	1930-12-01 00:00:00	1930-12-15	1930-12-15 00:00:00	32020		\N	229382	0	70704007	78272		0
58568	3470	4113008	1988-09-12	1988-09-12 00:00:00	1988-10-03	1988-10-03 00:00:00	32020		\N	230327	0	284549007	4113008		0
69367	4106	4112343	1967-10-18	1967-10-18 00:00:00	1967-10-26	1967-10-26 00:00:00	32020		\N	272834	0	195662009	4112343		0
58826	3489	260139	2009-09-07	2009-09-07 00:00:00	2009-09-21	2009-09-21 00:00:00	32020		\N	231462	0	10509002	260139		0
59046	3504	4112343	1979-02-14	1979-02-14 00:00:00	1979-02-21	1979-02-21 00:00:00	32020		\N	232279	0	195662009	4112343		0
69819	4130	378001	1968-07-01	1968-07-01 00:00:00	1968-08-30	1968-08-30 00:00:00	32020		\N	274632	0	62106007	378001		0
80542	4773	4112343	1993-11-04	1993-11-04 00:00:00	1993-11-16	1993-11-16 00:00:00	32020		\N	317850	0	195662009	4112343		0
59531	3529	40480160	2017-05-15	2017-05-15 00:00:00	2017-08-13	2017-08-13 00:00:00	32020		\N	234452	0	443165006	40480160		0
70261	4160	4296205	1989-02-18	1989-02-18 00:00:00	1989-03-18	1989-03-18 00:00:00	32020		\N	276451	0	403191005	4296205		0
70503	4176	40481087	1940-05-04	1940-05-04 00:00:00	1940-05-18	1940-05-18 00:00:00	32020		\N	277490	0	444814009	40481087		0
70686	4194	40481087	2014-12-15	2014-12-15 00:00:00	2014-12-29	2014-12-29 00:00:00	32020		\N	278408	0	444814009	40481087		0
70749	4199	260139	1987-12-15	1987-12-15 00:00:00	1987-12-29	1987-12-29 00:00:00	32020		\N	278615	0	10509002	260139		0
60421	3573	260139	1940-04-10	1940-04-10 00:00:00	1940-04-24	1940-04-24 00:00:00	32020		\N	237575	0	10509002	260139		0
60493	3577	372328	1963-03-30	1963-03-30 00:00:00	1963-08-05	1963-08-05 00:00:00	32020		\N	237845	0	65363002	372328		0
71233	4224	260139	1978-07-24	1978-07-24 00:00:00	1978-08-07	1978-08-07 00:00:00	32020		\N	280515	0	10509002	260139		0
60881	3603	4051466	1969-02-12	1969-02-12 00:00:00	1986-07-13	1986-07-13 00:00:00	32020		\N	239374	0	233678006	4051466		0
71592	4247	372328	1985-10-12	1985-10-12 00:00:00	1986-02-22	1986-02-22 00:00:00	32020		\N	282089	0	65363002	372328		0
61239	3622	378001	1984-07-27	1984-07-27 00:00:00	1984-08-26	1984-08-26 00:00:00	32020		\N	240711	0	62106007	378001		0
61391	3628	4283893	1942-10-12	1942-10-12 00:00:00	1943-03-08	1943-03-08 00:00:00	32020		\N	241298	0	36971009	4283893		0
61547	3637	40481087	1978-12-27	1978-12-27 00:00:00	1979-01-17	1979-01-17 00:00:00	32020		\N	241923	0	444814009	40481087		0
61651	3641	40481087	1953-08-16	1953-08-16 00:00:00	1953-08-23	1953-08-23 00:00:00	32020		\N	242268	0	444814009	40481087		0
72481	4304	30753	2001-02-24	2001-02-24 00:00:00	\N	\N	32020		\N	285508	0	16761005	30753		0
72616	4313	28060	1958-12-29	1958-12-29 00:00:00	1959-01-05	1959-01-05 00:00:00	32020		\N	286275	0	43878008	28060		0
72727	4321	4113008	1965-11-14	1965-11-14 00:00:00	1965-12-05	1965-12-05 00:00:00	32020		\N	286751	0	284549007	4113008		0
73037	4340	28060	1994-10-07	1994-10-07 00:00:00	1994-10-20	1994-10-20 00:00:00	32020		\N	287762	0	43878008	28060		0
73085	4343	4112343	1979-02-16	1979-02-16 00:00:00	1979-02-28	1979-02-28 00:00:00	32020		\N	287991	0	195662009	4112343		0
62715	3703	4156265	1971-10-30	1971-10-30 00:00:00	1971-11-13	1971-11-13 00:00:00	32020		\N	246253	0	370247008	4156265		0
73448	4366	4218389	1999-01-01	1999-01-01 00:00:00	1999-02-05	1999-02-05 00:00:00	32020		\N	289596	0	39848009	4218389		0
63012	3721	4116491	1994-11-07	1994-11-07 00:00:00	1994-12-21	1994-12-21 00:00:00	32020		\N	247327	0	301011002	4116491		0
73805	4383	372328	1969-09-12	1969-09-12 00:00:00	1969-10-25	1969-10-25 00:00:00	32020		\N	291330	0	65363002	372328		0
73954	4392	4112343	1991-05-06	1991-05-06 00:00:00	1991-05-14	1991-05-14 00:00:00	32020		\N	292059	0	195662009	4112343		0
74118	4403	40481087	1949-01-18	1949-01-18 00:00:00	1949-02-01	1949-02-01 00:00:00	32020		\N	292653	0	444814009	40481087		0
74327	4412	4112343	1973-02-13	1973-02-13 00:00:00	1973-02-20	1973-02-20 00:00:00	32020		\N	293406	0	195662009	4112343		0
63824	3769	81151	1951-03-18	1951-03-18 00:00:00	1951-04-15	1951-04-15 00:00:00	32020		\N	250504	0	44465007	81151		0
64041	3784	261325	1982-07-20	1982-07-20 00:00:00	\N	\N	32020		\N	251531	0	87433001	261325		0
64126	3788	28060	1975-11-25	1975-11-25 00:00:00	1975-12-02	1975-12-02 00:00:00	32020		\N	251838	0	43878008	28060		0
53784	3181	40481087	1968-12-26	1968-12-26 00:00:00	1969-01-09	1969-01-09 00:00:00	32020		\N	211796	0	444814009	40481087		0
53912	3191	4112343	1981-10-21	1981-10-21 00:00:00	1981-10-28	1981-10-28 00:00:00	32020		\N	212360	0	195662009	4112343		0
64653	3823	40481087	2014-06-10	2014-06-10 00:00:00	2014-07-01	2014-07-01 00:00:00	32020		\N	253926	0	444814009	40481087		0
54204	3212	80180	2018-05-10	2018-05-10 00:00:00	\N	\N	32020		\N	213450	0	396275006	80180		0
54437	3223	40481087	1983-07-27	1983-07-27 00:00:00	1983-08-03	1983-08-03 00:00:00	32020		\N	214326	0	444814009	40481087		0
54562	3231	28060	1962-09-01	1962-09-01 00:00:00	1962-09-11	1962-09-11 00:00:00	32020		\N	214798	0	43878008	28060		0
54766	3241	40481087	1982-03-13	1982-03-13 00:00:00	1982-04-03	1982-04-03 00:00:00	32020		\N	215565	0	444814009	40481087		0
54935	3250	372328	2009-08-04	2009-08-04 00:00:00	2011-02-01	2011-02-01 00:00:00	32020		\N	216094	0	65363002	372328		0
65683	3884	4048171	1975-04-03	1975-04-03 00:00:00	1991-04-01	1991-04-01 00:00:00	32020		\N	258144	0	232353008	4048171		0
65855	3893	40481087	1998-09-18	1998-09-18 00:00:00	1998-10-02	1998-10-02 00:00:00	32020		\N	258868	0	444814009	40481087		0
65914	3896	381316	2010-06-18	2010-06-18 00:00:00	\N	\N	32020		\N	259191	0	230690007	381316		0
66088	3909	40481087	1995-07-30	1995-07-30 00:00:00	1995-08-13	1995-08-13 00:00:00	32020		\N	259833	0	444814009	40481087		0
66255	3921	372328	1983-08-14	1983-08-14 00:00:00	1983-10-19	1983-10-19 00:00:00	32020		\N	260729	0	65363002	372328		0
55900	3311	4156265	2011-09-18	2011-09-18 00:00:00	2011-10-09	2011-10-09 00:00:00	32020		\N	219835	0	370247008	4156265		0
66697	3946	28060	1989-07-22	1989-07-22 00:00:00	1989-08-04	1989-08-04 00:00:00	32020		\N	262315	0	43878008	28060		0
66776	3951	378001	1972-02-25	1972-02-25 00:00:00	1972-03-26	1972-03-26 00:00:00	32020		\N	262601	0	62106007	378001		0
66944	3958	4152936	2000-08-08	2000-08-08 00:00:00	2000-08-29	2000-08-29 00:00:00	32020		\N	263176	0	283385000	4152936		0
67090	3967	40481087	1965-01-14	1965-01-14 00:00:00	1965-01-21	1965-01-21 00:00:00	32020		\N	263763	0	444814009	40481087		0
77866	4613	40481087	2002-08-15	2002-08-15 00:00:00	2002-09-05	2002-09-05 00:00:00	32020		\N	307316	0	444814009	40481087		0
67452	3986	40481087	2001-05-31	2001-05-31 00:00:00	2001-06-21	2001-06-21 00:00:00	32020		\N	265014	0	444814009	40481087		0
67574	3993	40481087	1946-10-16	1946-10-16 00:00:00	1946-11-06	1946-11-06 00:00:00	32020		\N	265539	0	444814009	40481087		0
57245	3397	78272	1981-09-06	1981-09-06 00:00:00	1981-10-11	1981-10-11 00:00:00	32020		\N	225351	0	70704007	78272		0
67939	4014	372328	1968-02-24	1968-02-24 00:00:00	1968-05-05	1968-05-05 00:00:00	32020		\N	266751	0	65363002	372328		0
68071	4020	4112343	2016-02-16	2016-02-16 00:00:00	2016-02-27	2016-02-27 00:00:00	32020		\N	267224	0	195662009	4112343		0
68281	4033	40481087	2002-05-27	2002-05-27 00:00:00	2002-06-03	2002-06-03 00:00:00	32020		\N	268360	0	444814009	40481087		0
68425	4044	260139	1971-03-18	1971-03-18 00:00:00	1971-03-25	1971-03-25 00:00:00	32020		\N	268948	0	10509002	260139		0
58098	3442	81151	2015-06-20	2015-06-20 00:00:00	2015-07-04	2015-07-04 00:00:00	32020		\N	228420	0	44465007	81151		0
68795	4071	78272	1992-11-27	1992-11-27 00:00:00	1992-12-18	1992-12-18 00:00:00	32020		\N	270584	0	70704007	78272		0
58356	3457	81151	1921-02-07	1921-02-07 00:00:00	1921-02-21	1921-02-21 00:00:00	32020		\N	229381	0	44465007	81151		0
58569	3470	4283893	1975-11-05	1975-11-05 00:00:00	1976-02-11	1976-02-11 00:00:00	32020		\N	230321	0	36971009	4283893		0
69368	4106	260139	1991-06-05	1991-06-05 00:00:00	1991-06-12	1991-06-12 00:00:00	32020		\N	272837	0	10509002	260139		0
58827	3489	40481087	2005-02-07	2005-02-07 00:00:00	2005-02-14	2005-02-14 00:00:00	32020		\N	231475	0	444814009	40481087		0
59047	3504	260139	1967-06-22	1967-06-22 00:00:00	1967-07-06	1967-07-06 00:00:00	32020		\N	232305	0	10509002	260139		0
69820	4130	40481087	2006-04-29	2006-04-29 00:00:00	2006-05-20	2006-05-20 00:00:00	32020		\N	274536	0	444814009	40481087		0
80543	4773	28060	1960-04-21	1960-04-21 00:00:00	1960-05-03	1960-05-03 00:00:00	32020		\N	317845	0	43878008	28060		0
59532	3529	4278672	1949-02-13	1949-02-13 00:00:00	1949-05-14	1949-05-14 00:00:00	32020		\N	234286	0	65966004	4278672		0
70262	4160	81151	1969-02-28	1969-02-28 00:00:00	1969-04-04	1969-04-04 00:00:00	32020		\N	276448	0	44465007	81151		0
70504	4176	80180	1952-05-20	1952-05-20 00:00:00	\N	\N	32020		\N	277566	0	396275006	80180		0
70687	4194	4112343	1984-04-03	1984-04-03 00:00:00	1984-04-14	1984-04-14 00:00:00	32020		\N	278370	0	195662009	4112343		0
70750	4199	28060	1939-01-25	1939-01-25 00:00:00	1939-02-02	1939-02-02 00:00:00	32020		\N	278678	0	43878008	28060		0
60422	3573	40481087	1959-11-14	1959-11-14 00:00:00	1959-12-05	1959-12-05 00:00:00	32020		\N	237582	0	444814009	40481087		0
60494	3577	40481087	1977-09-15	1977-09-15 00:00:00	1977-10-06	1977-10-06 00:00:00	32020		\N	237841	0	444814009	40481087		0
71234	4224	40481087	1976-04-28	1976-04-28 00:00:00	1976-05-12	1976-05-12 00:00:00	32020		\N	280445	0	444814009	40481087		0
60882	3603	4156265	2017-06-08	2017-06-08 00:00:00	2017-06-22	2017-06-22 00:00:00	32020		\N	239394	0	370247008	4156265		0
71593	4247	4112343	2018-07-15	2018-07-15 00:00:00	2018-07-27	2018-07-27 00:00:00	32020		\N	282065	0	195662009	4112343		0
61240	3622	80180	1964-11-29	1964-11-29 00:00:00	\N	\N	32020		\N	240832	0	396275006	80180		0
61392	3628	4112343	1995-10-04	1995-10-04 00:00:00	1995-10-14	1995-10-14 00:00:00	32020		\N	241363	0	195662009	4112343		0
61548	3637	30753	2000-01-27	2000-01-27 00:00:00	\N	\N	32020		\N	241883	0	16761005	30753		0
61652	3641	4134304	1915-08-18	1915-08-18 00:00:00	1915-09-17	1915-09-17 00:00:00	32020		\N	242309	0	263102004	4134304		0
72482	4304	4266809	2002-02-19	2002-02-19 00:00:00	\N	\N	32020		\N	285508	0	397881000	4266809		0
72617	4313	40481087	2008-07-27	2008-07-27 00:00:00	2008-08-10	2008-08-10 00:00:00	32020		\N	286299	0	444814009	40481087		0
72728	4321	40481087	1985-12-26	1985-12-26 00:00:00	1986-01-02	1986-01-02 00:00:00	32020		\N	286761	0	444814009	40481087		0
73038	4340	40481087	2009-11-10	2009-11-10 00:00:00	2009-11-17	2009-11-17 00:00:00	32020		\N	287764	0	444814009	40481087		0
73086	4343	4112343	1974-06-03	1974-06-03 00:00:00	1974-06-10	1974-06-10 00:00:00	32020		\N	287990	0	195662009	4112343		0
62716	3703	40481087	1973-08-05	1973-08-05 00:00:00	1973-08-12	1973-08-12 00:00:00	32020		\N	246271	0	444814009	40481087		0
73449	4366	40481087	1983-02-02	1983-02-02 00:00:00	1983-02-23	1983-02-23 00:00:00	32020		\N	289665	0	444814009	40481087		0
63013	3721	40481087	2001-07-06	2001-07-06 00:00:00	2001-07-27	2001-07-27 00:00:00	32020		\N	247403	0	444814009	40481087		0
73806	4383	40481087	2004-01-08	2004-01-08 00:00:00	2004-01-29	2004-01-29 00:00:00	32020		\N	291291	0	444814009	40481087		0
73955	4392	260139	2017-02-22	2017-02-22 00:00:00	2017-03-01	2017-03-01 00:00:00	32020		\N	292052	0	10509002	260139		0
74119	4403	4059173	1946-11-29	1946-11-29 00:00:00	1947-01-28	1947-01-28 00:00:00	32020		\N	292705	0	16114001	4059173		0
74328	4412	40481087	2011-06-07	2011-06-07 00:00:00	2011-06-14	2011-06-14 00:00:00	32020		\N	293374	0	444814009	40481087		0
63825	3769	4112343	1978-04-29	1978-04-29 00:00:00	1978-05-10	1978-05-10 00:00:00	32020		\N	250544	0	195662009	4112343		0
64042	3784	40481087	1967-08-06	1967-08-06 00:00:00	1967-08-27	1967-08-27 00:00:00	32020		\N	251456	0	444814009	40481087		0
64127	3788	4112343	1991-03-16	1991-03-16 00:00:00	1991-03-27	1991-03-27 00:00:00	32020		\N	251819	0	195662009	4112343		0
64243	3793	260139	1994-04-14	1994-04-14 00:00:00	1994-04-21	1994-04-21 00:00:00	32020		\N	252233	0	10509002	260139		0
53913	3191	40481087	2001-02-28	2001-02-28 00:00:00	2001-03-07	2001-03-07 00:00:00	32020		\N	212335	0	444814009	40481087		0
64654	3823	4134304	1976-01-21	1976-01-21 00:00:00	1976-04-20	1976-04-20 00:00:00	32020		\N	253973	0	263102004	4134304		0
54205	3212	4116491	2016-07-19	2016-07-19 00:00:00	2016-09-09	2016-09-09 00:00:00	32020		\N	213450	0	301011002	4116491		0
54438	3223	28060	1985-09-24	1985-09-24 00:00:00	1985-10-06	1985-10-06 00:00:00	32020		\N	214315	0	43878008	28060		0
54563	3231	80180	1980-01-01	1980-01-01 00:00:00	\N	\N	32020		\N	214808	0	396275006	80180		0
54767	3241	40481087	2019-06-10	2019-06-10 00:00:00	\N	\N	32020		\N	215547	0	444814009	40481087		0
54936	3250	40481087	1981-07-30	1981-07-30 00:00:00	1981-08-20	1981-08-20 00:00:00	32020		\N	216040	0	444814009	40481087		0
65684	3884	81151	1973-03-22	1973-03-22 00:00:00	1973-04-19	1973-04-19 00:00:00	32020		\N	258013	0	44465007	81151		0
65856	3893	4112343	2018-07-07	2018-07-07 00:00:00	2018-07-15	2018-07-15 00:00:00	32020		\N	258845	0	195662009	4112343		0
65915	3896	260139	1990-12-29	1990-12-29 00:00:00	1991-01-12	1991-01-12 00:00:00	32020		\N	259140	0	10509002	260139		0
66089	3909	4035415	1962-08-13	1962-08-13 00:00:00	1962-09-12	1962-09-12 00:00:00	32020		\N	259841	0	239720000	4035415		0
66293	3926	4152936	1963-07-14	1963-07-14 00:00:00	1963-07-28	1963-07-28 00:00:00	32020		\N	261007	0	283385000	4152936		0
55901	3311	260139	1986-02-13	1986-02-13 00:00:00	1986-02-27	1986-02-27 00:00:00	32020		\N	219755	0	10509002	260139		0
66698	3946	40481087	1992-06-28	1992-06-28 00:00:00	1992-07-12	1992-07-12 00:00:00	32020		\N	262342	0	444814009	40481087		0
66777	3951	4112343	1948-12-31	1948-12-31 00:00:00	1949-01-08	1949-01-08 00:00:00	32020		\N	262650	0	195662009	4112343		0
66945	3958	4112343	1997-03-16	1997-03-16 00:00:00	1997-03-24	1997-03-24 00:00:00	32020		\N	263149	0	195662009	4112343		0
67091	3967	4155034	1978-08-16	1978-08-16 00:00:00	1978-08-30	1978-08-30 00:00:00	32020		\N	263744	0	283371005	4155034		0
77867	4613	40481087	1995-07-12	1995-07-12 00:00:00	1995-08-02	1995-08-02 00:00:00	32020		\N	307267	0	444814009	40481087		0
67453	3986	80180	1996-06-07	1996-06-07 00:00:00	\N	\N	32020		\N	264998	0	396275006	80180		0
67575	3993	4116491	1965-02-02	1965-02-02 00:00:00	1965-03-08	1965-03-08 00:00:00	32020		\N	265525	0	301011002	4116491		0
57246	3397	28060	1951-01-13	1951-01-13 00:00:00	1951-01-25	1951-01-25 00:00:00	32020		\N	225333	0	43878008	28060		0
67940	4014	260139	1977-02-27	1977-02-27 00:00:00	1977-03-13	1977-03-13 00:00:00	32020		\N	266787	0	10509002	260139		0
68072	4020	4112343	1972-08-08	1972-08-08 00:00:00	1972-08-20	1972-08-20 00:00:00	32020		\N	267193	0	195662009	4112343		0
68282	4033	440086	1978-10-12	1978-10-12 00:00:00	1981-12-09	1981-12-09 00:00:00	32020		\N	268297	0	192127007	440086		0
68426	4044	40481087	1983-12-12	1983-12-12 00:00:00	1983-12-26	1983-12-26 00:00:00	32020		\N	268971	0	444814009	40481087		0
58099	3442	4112343	1985-06-26	1985-06-26 00:00:00	1985-07-05	1985-07-05 00:00:00	32020		\N	228429	0	195662009	4112343		0
68796	4071	78272	1961-04-18	1961-04-18 00:00:00	1961-05-23	1961-05-23 00:00:00	32020		\N	270581	0	70704007	78272		0
58357	3457	28060	1926-10-11	1926-10-11 00:00:00	1926-10-20	1926-10-20 00:00:00	32020		\N	229404	0	43878008	28060		0
58570	3470	4112343	2001-01-20	2001-01-20 00:00:00	2001-01-28	2001-01-28 00:00:00	32020		\N	230303	0	195662009	4112343		0
69369	4106	78272	1960-01-09	1960-01-09 00:00:00	1960-02-06	1960-02-06 00:00:00	32020		\N	272859	0	70704007	78272		0
58828	3489	260139	1985-01-25	1985-01-25 00:00:00	1985-02-08	1985-02-08 00:00:00	32020		\N	231447	0	10509002	260139		0
59048	3504	80180	1956-04-29	1956-04-29 00:00:00	\N	\N	32020		\N	232328	0	396275006	80180		0
69821	4131	260139	1988-06-09	1988-06-09 00:00:00	1988-06-23	1988-06-23 00:00:00	32020		\N	274683	0	10509002	260139		0
80544	4773	4296205	1964-09-24	1964-09-24 00:00:00	1964-10-29	1964-10-29 00:00:00	32020		\N	317890	0	403191005	4296205		0
59533	3529	4218389	1981-02-25	1981-02-25 00:00:00	1981-03-25	1981-03-25 00:00:00	32020		\N	234289	0	39848009	4218389		0
70263	4160	80180	2004-08-08	2004-08-08 00:00:00	\N	\N	32020		\N	276408	0	396275006	80180		0
70505	4176	4278672	1920-04-23	1920-04-23 00:00:00	1920-06-22	1920-06-22 00:00:00	32020		\N	277541	0	65966004	4278672		0
70688	4194	40481087	2001-09-05	2001-09-05 00:00:00	2001-09-19	2001-09-19 00:00:00	32020		\N	278371	0	444814009	40481087		0
70751	4199	40481087	2003-08-16	2003-08-16 00:00:00	2003-09-06	2003-09-06 00:00:00	32020		\N	278625	0	444814009	40481087		0
60423	3573	4310024	1960-12-14	1960-12-14 00:00:00	\N	\N	32020		\N	237582	0	424802006	4310024		0
60495	3577	40481087	1971-07-29	1971-07-29 00:00:00	1971-08-19	1971-08-19 00:00:00	32020		\N	237790	0	444814009	40481087		0
71235	4224	260139	2008-12-14	2008-12-14 00:00:00	2008-12-21	2008-12-21 00:00:00	32020		\N	280541	0	10509002	260139		0
60883	3603	40481087	1981-02-20	1981-02-20 00:00:00	1981-02-27	1981-02-27 00:00:00	32020		\N	239356	0	444814009	40481087		0
71594	4247	440086	1995-03-16	1995-03-16 00:00:00	2001-03-22	2001-03-22 00:00:00	32020		\N	282099	0	192127007	440086		0
61241	3622	40481087	1967-01-03	1967-01-03 00:00:00	1967-01-17	1967-01-17 00:00:00	32020		\N	240777	0	444814009	40481087		0
61393	3628	40481087	1985-01-31	1985-01-31 00:00:00	1985-02-07	1985-02-07 00:00:00	32020		\N	241392	0	444814009	40481087		0
61549	3637	80180	2001-01-21	2001-01-21 00:00:00	\N	\N	32020		\N	241883	0	396275006	80180		0
61653	3641	375671	2016-07-27	2016-07-27 00:00:00	2016-09-25	2016-09-25 00:00:00	32020		\N	242316	0	62564004	375671		0
72483	4304	40481087	2013-11-08	2013-11-08 00:00:00	2013-11-29	2013-11-29 00:00:00	32020		\N	285481	0	444814009	40481087		0
72618	4313	78272	1949-05-09	1949-05-09 00:00:00	1949-05-30	1949-05-30 00:00:00	32020		\N	286306	0	70704007	78272		0
72729	4321	260139	2002-10-05	2002-10-05 00:00:00	2002-10-19	2002-10-19 00:00:00	32020		\N	286755	0	10509002	260139		0
73039	4340	80180	2010-01-31	2010-01-31 00:00:00	\N	\N	32020		\N	287764	0	396275006	80180		0
73087	4343	4112343	1960-04-23	1960-04-23 00:00:00	1960-05-02	1960-05-02 00:00:00	32020		\N	287988	0	195662009	4112343		0
62717	3703	4113008	1999-07-24	1999-07-24 00:00:00	1999-08-07	1999-08-07 00:00:00	32020		\N	246257	0	284549007	4113008		0
73450	4366	260139	1985-09-24	1985-09-24 00:00:00	1985-10-01	1985-10-01 00:00:00	32020		\N	289690	0	10509002	260139		0
63014	3721	260139	1972-06-12	1972-06-12 00:00:00	1972-06-26	1972-06-26 00:00:00	32020		\N	247352	0	10509002	260139		0
73807	4383	40481087	1977-01-02	1977-01-02 00:00:00	1977-01-23	1977-01-23 00:00:00	32020		\N	291319	0	444814009	40481087		0
73956	4392	4112343	1991-06-15	1991-06-15 00:00:00	1991-06-27	1991-06-27 00:00:00	32020		\N	292069	0	195662009	4112343		0
74120	4403	81151	1999-05-01	1999-05-01 00:00:00	1999-05-29	1999-05-29 00:00:00	32020		\N	292713	0	44465007	81151		0
74329	4412	372328	1965-11-19	1965-11-19 00:00:00	1966-01-07	1966-01-07 00:00:00	32020		\N	293315	0	65363002	372328		0
63826	3769	381316	2016-04-17	2016-04-17 00:00:00	\N	\N	32020		\N	250560	0	230690007	381316		0
64043	3784	80180	1965-02-14	1965-02-14 00:00:00	\N	\N	32020		\N	251485	0	396275006	80180		0
64128	3788	81151	1974-05-21	1974-05-21 00:00:00	1974-06-25	1974-06-25 00:00:00	32020		\N	251823	0	44465007	81151		0
64244	3793	4296205	1967-05-01	1967-05-01 00:00:00	1967-05-29	1967-05-29 00:00:00	32020		\N	252279	0	403191005	4296205		0
53914	3191	4112343	2015-09-18	2015-09-18 00:00:00	2015-09-25	2015-09-25 00:00:00	32020		\N	212340	0	195662009	4112343		0
64655	3823	260139	2013-08-07	2013-08-07 00:00:00	2013-08-21	2013-08-21 00:00:00	32020		\N	253923	0	10509002	260139		0
54206	3212	4112343	2015-11-10	2015-11-10 00:00:00	2015-11-19	2015-11-19 00:00:00	32020		\N	213422	0	195662009	4112343		0
54439	3223	80502	1987-06-17	1987-06-17 00:00:00	\N	\N	32020		\N	214244	0	64859006	80502		0
54564	3231	40481087	1994-01-23	1994-01-23 00:00:00	1994-01-30	1994-01-30 00:00:00	32020		\N	214776	0	444814009	40481087		0
54768	3241	80180	1998-08-08	1998-08-08 00:00:00	\N	\N	32020		\N	215512	0	396275006	80180		0
54937	3250	40481087	1982-08-23	1982-08-23 00:00:00	1982-09-13	1982-09-13 00:00:00	32020		\N	216041	0	444814009	40481087		0
65685	3884	28060	2005-05-22	2005-05-22 00:00:00	2005-06-02	2005-06-02 00:00:00	32020		\N	258155	0	43878008	28060		0
65857	3893	4113008	1999-11-15	1999-11-15 00:00:00	1999-11-29	1999-11-29 00:00:00	32020		\N	258836	0	284549007	4113008		0
65916	3896	80180	2018-11-11	2018-11-11 00:00:00	\N	\N	32020		\N	259193	0	396275006	80180		0
66090	3909	4278672	2011-02-27	2011-02-27 00:00:00	2011-03-29	2011-03-29 00:00:00	32020		\N	259843	0	65966004	4278672		0
66294	3926	40481087	1966-06-19	1966-06-19 00:00:00	1966-07-10	1966-07-10 00:00:00	32020		\N	260982	0	444814009	40481087		0
55902	3311	134438	1990-03-20	1990-03-20 00:00:00	1991-12-11	1991-12-11 00:00:00	32020		\N	219756	0	40275004	134438		0
66699	3946	40481087	1986-09-25	1986-09-25 00:00:00	1986-10-02	1986-10-02 00:00:00	32020		\N	262314	0	444814009	40481087		0
66778	3951	257012	1990-04-25	1990-04-25 00:00:00	2004-09-16	2004-09-16 00:00:00	32020		\N	262620	0	40055000	257012		0
66946	3958	40481087	1983-02-07	1983-02-07 00:00:00	1983-02-21	1983-02-21 00:00:00	32020		\N	263185	0	444814009	40481087		0
67092	3967	81151	1998-11-13	1998-11-13 00:00:00	1998-12-04	1998-12-04 00:00:00	32020		\N	263746	0	44465007	81151		0
77868	4613	40481087	1999-12-04	1999-12-04 00:00:00	1999-12-25	1999-12-25 00:00:00	32020		\N	307261	0	444814009	40481087		0
67454	3986	372328	1967-04-26	1967-04-26 00:00:00	1967-08-11	1967-08-11 00:00:00	32020		\N	264967	0	65363002	372328		0
67576	3993	40481087	2010-08-16	2010-08-16 00:00:00	2010-09-06	2010-09-06 00:00:00	32020		\N	265484	0	444814009	40481087		0
57247	3397	40481087	1956-05-24	1956-05-24 00:00:00	1956-05-31	1956-05-31 00:00:00	32020		\N	225287	0	444814009	40481087		0
67941	4014	260139	1976-09-11	1976-09-11 00:00:00	1976-09-18	1976-09-18 00:00:00	32020		\N	266768	0	10509002	260139		0
68073	4020	372328	1958-12-16	1958-12-16 00:00:00	1959-02-05	1959-02-05 00:00:00	32020		\N	267225	0	65363002	372328		0
68283	4033	375671	1987-06-12	1987-06-12 00:00:00	1987-07-12	1987-07-12 00:00:00	32020		\N	268370	0	62564004	375671		0
68427	4044	4112343	2003-10-17	2003-10-17 00:00:00	2003-10-27	2003-10-27 00:00:00	32020		\N	268973	0	195662009	4112343		0
58100	3442	372328	1963-02-14	1963-02-14 00:00:00	1963-05-19	1963-05-19 00:00:00	32020		\N	228414	0	65363002	372328		0
68797	4071	260139	1962-09-11	1962-09-11 00:00:00	1962-09-18	1962-09-18 00:00:00	32020		\N	270609	0	10509002	260139		0
58358	3457	40481087	1979-03-27	1979-03-27 00:00:00	1979-04-10	1979-04-10 00:00:00	32020		\N	229410	0	444814009	40481087		0
58571	3470	260139	1980-10-18	1980-10-18 00:00:00	1980-11-01	1980-11-01 00:00:00	32020		\N	230322	0	10509002	260139		0
69370	4106	4027663	1975-02-24	1975-02-24 00:00:00	\N	\N	32020		\N	272850	0	13200003	4027663		0
58829	3489	372328	1977-12-22	1977-12-22 00:00:00	1978-10-14	1978-10-14 00:00:00	32020		\N	231448	0	65363002	372328		0
59049	3504	30753	1955-10-02	1955-10-02 00:00:00	\N	\N	32020		\N	232328	0	16761005	30753		0
69822	4131	260139	1989-09-22	1989-09-22 00:00:00	1989-09-29	1989-09-29 00:00:00	32020		\N	274713	0	10509002	260139		0
80545	4773	28060	1961-04-02	1961-04-02 00:00:00	1961-04-10	1961-04-10 00:00:00	32020		\N	317902	0	43878008	28060		0
59534	3529	40481087	1971-02-18	1971-02-18 00:00:00	1971-02-25	1971-02-25 00:00:00	32020		\N	234435	0	444814009	40481087		0
70264	4160	260139	1964-03-28	1964-03-28 00:00:00	1964-04-11	1964-04-11 00:00:00	32020		\N	276414	0	10509002	260139		0
70506	4176	260139	2010-02-02	2010-02-02 00:00:00	2010-02-09	2010-02-09 00:00:00	32020		\N	277450	0	10509002	260139		0
70689	4194	4112343	2005-04-23	2005-04-23 00:00:00	2005-05-01	2005-05-01 00:00:00	32020		\N	278384	0	195662009	4112343		0
70752	4199	4112343	1972-01-04	1972-01-04 00:00:00	1972-01-12	1972-01-12 00:00:00	32020		\N	278687	0	195662009	4112343		0
60424	3573	40481087	1940-07-09	1940-07-09 00:00:00	1940-07-16	1940-07-16 00:00:00	32020		\N	237576	0	444814009	40481087		0
60496	3577	372328	1966-05-21	1966-05-21 00:00:00	1967-02-13	1967-02-13 00:00:00	32020		\N	237804	0	65363002	372328		0
71236	4224	40481087	1979-01-06	1979-01-06 00:00:00	1979-01-27	1979-01-27 00:00:00	32020		\N	280466	0	444814009	40481087		0
60884	3603	40481087	1998-12-20	1998-12-20 00:00:00	1999-01-10	1999-01-10 00:00:00	32020		\N	239388	0	444814009	40481087		0
71595	4247	4112343	2000-12-01	2000-12-01 00:00:00	2000-12-12	2000-12-12 00:00:00	32020		\N	282021	0	195662009	4112343		0
61242	3622	80502	1982-07-21	1982-07-21 00:00:00	\N	\N	32020		\N	240845	0	64859006	80502		0
61394	3628	4296204	1973-04-26	1973-04-26 00:00:00	1973-05-31	1973-05-31 00:00:00	32020		\N	241354	0	403190006	4296204		0
61550	3637	4310024	1998-06-06	1998-06-06 00:00:00	\N	\N	32020		\N	241882	0	424802006	4310024		0
61654	3641	40481087	1999-04-26	1999-04-26 00:00:00	1999-05-10	1999-05-10 00:00:00	32020		\N	242333	0	444814009	40481087		0
72484	4304	40481087	1979-09-17	1979-09-17 00:00:00	1979-10-01	1979-10-01 00:00:00	32020		\N	285485	0	444814009	40481087		0
72619	4313	4112343	1966-01-01	1966-01-01 00:00:00	1966-01-11	1966-01-11 00:00:00	32020		\N	286319	0	195662009	4112343		0
72730	4321	260139	1968-09-30	1968-09-30 00:00:00	1968-10-07	1968-10-07 00:00:00	32020		\N	286754	0	10509002	260139		0
73040	4340	40481087	2001-11-17	2001-11-17 00:00:00	2001-12-01	2001-12-01 00:00:00	32020		\N	287748	0	444814009	40481087		0
73088	4343	4112343	2004-08-14	2004-08-14 00:00:00	2004-08-25	2004-08-25 00:00:00	32020		\N	288034	0	195662009	4112343		0
62718	3703	80180	2010-07-01	2010-07-01 00:00:00	\N	\N	32020		\N	246297	0	396275006	80180		0
73451	4366	372328	1984-09-01	1984-09-01 00:00:00	1985-01-01	1985-01-01 00:00:00	32020		\N	289613	0	65363002	372328		0
63015	3721	378001	1993-05-25	1993-05-25 00:00:00	1993-07-24	1993-07-24 00:00:00	32020		\N	247323	0	62106007	378001		0
73808	4383	40481087	2016-08-25	2016-08-25 00:00:00	2016-09-15	2016-09-15 00:00:00	32020		\N	291322	0	444814009	40481087		0
73957	4392	260139	2003-11-27	2003-11-27 00:00:00	2003-12-11	2003-12-11 00:00:00	32020		\N	292050	0	10509002	260139		0
74121	4403	40481087	1955-07-29	1955-07-29 00:00:00	1955-08-12	1955-08-12 00:00:00	32020		\N	292665	0	444814009	40481087		0
74330	4412	4112343	2013-05-29	2013-05-29 00:00:00	2013-06-07	2013-06-07 00:00:00	32020		\N	293388	0	195662009	4112343		0
63827	3771	257012	2008-05-04	2008-05-04 00:00:00	\N	\N	32020		\N	250599	0	40055000	257012		0
64044	3784	28060	1932-01-01	1932-01-01 00:00:00	1932-01-14	1932-01-14 00:00:00	32020		\N	251490	0	43878008	28060		0
64129	3788	372328	1968-07-21	1968-07-21 00:00:00	1968-12-31	1968-12-31 00:00:00	32020		\N	251821	0	65363002	372328		0
64245	3793	4112343	1966-10-05	1966-10-05 00:00:00	1966-10-16	1966-10-16 00:00:00	32020		\N	252263	0	195662009	4112343		0
53915	3191	4112343	1958-12-23	1958-12-23 00:00:00	1959-01-02	1959-01-02 00:00:00	32020		\N	212331	0	195662009	4112343		0
64656	3823	4027663	1983-10-06	1983-10-06 00:00:00	\N	\N	32020		\N	253969	0	13200003	4027663		0
54207	3212	40481087	1988-12-25	1988-12-25 00:00:00	1989-01-01	1989-01-01 00:00:00	32020		\N	213403	0	444814009	40481087		0
54440	3223	4294548	1976-07-20	1976-07-20 00:00:00	1976-08-31	1976-08-31 00:00:00	32020		\N	214248	0	75498004	4294548		0
54565	3231	40481087	2012-04-01	2012-04-01 00:00:00	2012-04-08	2012-04-08 00:00:00	32020		\N	214760	0	444814009	40481087		0
54769	3241	30753	1997-11-11	1997-11-11 00:00:00	\N	\N	32020		\N	215512	0	16761005	30753		0
54938	3250	40481087	1989-12-20	1989-12-20 00:00:00	1989-12-27	1989-12-27 00:00:00	32020		\N	216064	0	444814009	40481087		0
65686	3884	260139	2001-08-27	2001-08-27 00:00:00	2001-09-03	2001-09-03 00:00:00	32020		\N	258115	0	10509002	260139		0
65858	3893	260139	1994-07-07	1994-07-07 00:00:00	1994-07-21	1994-07-21 00:00:00	32020		\N	258881	0	10509002	260139		0
65917	3896	257012	2014-07-16	2014-07-16 00:00:00	\N	\N	32020		\N	259145	0	40055000	257012		0
66091	3909	4112343	1972-07-08	1972-07-08 00:00:00	1972-07-17	1972-07-17 00:00:00	32020		\N	259838	0	195662009	4112343		0
66295	3926	378001	1968-07-31	1968-07-31 00:00:00	1968-08-30	1968-08-30 00:00:00	32020		\N	261008	0	62106007	378001		0
55903	3311	80180	1995-07-05	1995-07-05 00:00:00	\N	\N	32020		\N	219824	0	396275006	80180		0
66700	3946	4112343	1988-11-13	1988-11-13 00:00:00	1988-11-20	1988-11-20 00:00:00	32020		\N	262308	0	195662009	4112343		0
66779	3951	4112343	1963-08-17	1963-08-17 00:00:00	1963-08-27	1963-08-27 00:00:00	32020		\N	262632	0	195662009	4112343		0
66947	3958	40481087	1973-08-29	1973-08-29 00:00:00	1973-09-19	1973-09-19 00:00:00	32020		\N	263178	0	444814009	40481087		0
67093	3967	40481087	2012-02-05	2012-02-05 00:00:00	2012-02-19	2012-02-19 00:00:00	32020		\N	263712	0	444814009	40481087		0
77869	4613	4146173	1994-10-18	1994-10-18 00:00:00	1994-11-17	1994-11-17 00:00:00	32020		\N	307259	0	307731004	4146173		0
67455	3987	40481087	2014-06-22	2014-06-22 00:00:00	2014-06-29	2014-06-29 00:00:00	32020		\N	265070	0	444814009	40481087		0
67577	3993	40481087	1970-12-02	1970-12-02 00:00:00	1970-12-16	1970-12-16 00:00:00	32020		\N	265540	0	444814009	40481087		0
57248	3397	260139	1961-09-18	1961-09-18 00:00:00	1961-10-02	1961-10-02 00:00:00	32020		\N	225335	0	10509002	260139		0
67942	4014	40481087	2008-12-22	2008-12-22 00:00:00	2009-01-12	2009-01-12 00:00:00	32020		\N	266710	0	444814009	40481087		0
68074	4020	260139	1964-07-19	1964-07-19 00:00:00	1964-07-26	1964-07-26 00:00:00	32020		\N	267217	0	10509002	260139		0
68284	4033	257012	2018-02-19	2018-02-19 00:00:00	\N	\N	32020		\N	268353	0	40055000	257012		0
68428	4044	260139	1999-04-29	1999-04-29 00:00:00	1999-05-06	1999-05-06 00:00:00	32020		\N	268972	0	10509002	260139		0
68564	4055	260139	1970-05-01	1970-05-01 00:00:00	1970-05-15	1970-05-15 00:00:00	32020		\N	269525	0	10509002	260139		0
68798	4071	28060	2014-01-08	2014-01-08 00:00:00	2014-01-17	2014-01-17 00:00:00	32020		\N	270628	0	43878008	28060		0
58359	3457	40481087	1952-03-10	1952-03-10 00:00:00	1952-03-24	1952-03-24 00:00:00	32020		\N	229406	0	444814009	40481087		0
58572	3470	40481087	1957-04-23	1957-04-23 00:00:00	1957-05-07	1957-05-07 00:00:00	32020		\N	230320	0	444814009	40481087		0
69371	4106	260139	1985-10-25	1985-10-25 00:00:00	1985-11-01	1985-11-01 00:00:00	32020		\N	272865	0	10509002	260139		0
58830	3489	4155034	2012-10-28	2012-10-28 00:00:00	2012-11-11	2012-11-11 00:00:00	32020		\N	231481	0	283371005	4155034		0
59050	3504	4310024	1954-11-06	1954-11-06 00:00:00	\N	\N	32020		\N	232328	0	424802006	4310024		0
69823	4131	257012	1987-10-11	1987-10-11 00:00:00	\N	\N	32020		\N	274692	0	40055000	257012		0
80546	4773	4112343	1967-07-12	1967-07-12 00:00:00	1967-07-25	1967-07-25 00:00:00	32020		\N	317846	0	195662009	4112343		0
59535	3529	4112343	1957-12-22	1957-12-22 00:00:00	1958-01-03	1958-01-03 00:00:00	32020		\N	234439	0	195662009	4112343		0
70265	4160	4218389	2016-07-08	2016-07-08 00:00:00	2016-08-12	2016-08-12 00:00:00	32020		\N	276412	0	39848009	4218389		0
70690	4194	4112343	2003-12-16	2003-12-16 00:00:00	2003-12-26	2003-12-26 00:00:00	32020		\N	278379	0	195662009	4112343		0
70753	4199	4113008	1980-06-05	1980-06-05 00:00:00	1980-06-19	1980-06-19 00:00:00	32020		\N	278708	0	284549007	4113008		0
70883	4205	40481087	2011-09-28	2011-09-28 00:00:00	2011-10-05	2011-10-05 00:00:00	32020		\N	279252	0	444814009	40481087		0
60497	3577	4112343	2012-03-13	2012-03-13 00:00:00	2012-03-23	2012-03-23 00:00:00	32020		\N	237816	0	195662009	4112343		0
71237	4224	4112343	1955-09-23	1955-09-23 00:00:00	1955-10-01	1955-10-01 00:00:00	32020		\N	280530	0	195662009	4112343		0
60885	3603	260139	2006-06-21	2006-06-21 00:00:00	2006-06-28	2006-06-28 00:00:00	32020		\N	239368	0	10509002	260139		0
71596	4247	372328	1983-05-18	1983-05-18 00:00:00	1983-06-25	1983-06-25 00:00:00	32020		\N	282000	0	65363002	372328		0
61243	3622	381316	1991-07-03	1991-07-03 00:00:00	\N	\N	32020		\N	240809	0	230690007	381316		0
61395	3628	260139	2000-08-16	2000-08-16 00:00:00	2000-08-30	2000-08-30 00:00:00	32020		\N	241395	0	10509002	260139		0
61551	3637	81893	1999-04-02	1999-04-02 00:00:00	\N	\N	32020		\N	241882	0	64766004	81893		0
61655	3641	40481087	1923-08-27	1923-08-27 00:00:00	1923-09-03	1923-09-03 00:00:00	32020		\N	242329	0	444814009	40481087		0
72485	4305	4278672	2019-06-12	2019-06-12 00:00:00	\N	\N	32020		\N	285537	0	65966004	4278672		0
72620	4313	40481087	1958-01-01	1958-01-01 00:00:00	1958-01-08	1958-01-08 00:00:00	32020		\N	286255	0	444814009	40481087		0
72731	4321	4112343	2004-01-11	2004-01-11 00:00:00	2004-01-18	2004-01-18 00:00:00	32020		\N	286706	0	195662009	4112343		0
83499	4963	81151	1981-12-28	1981-12-28 00:00:00	1982-02-01	1982-02-01 00:00:00	32020		\N	329966	0	44465007	81151		0
73089	4343	40481087	1962-10-12	1962-10-12 00:00:00	1962-10-19	1962-10-19 00:00:00	32020		\N	288058	0	444814009	40481087		0
62719	3703	4112343	2010-01-01	2010-01-01 00:00:00	2010-01-10	2010-01-10 00:00:00	32020		\N	246297	0	195662009	4112343		0
73452	4366	40481087	2008-06-14	2008-06-14 00:00:00	2008-06-21	2008-06-21 00:00:00	32020		\N	289730	0	444814009	40481087		0
63016	3721	372328	1968-02-03	1968-02-03 00:00:00	1968-10-18	1968-10-18 00:00:00	32020		\N	247340	0	65363002	372328		0
73809	4384	4294548	2018-01-24	2018-01-24 00:00:00	2018-03-07	2018-03-07 00:00:00	32020		\N	291403	0	75498004	4294548		0
73958	4392	260139	2004-12-08	2004-12-08 00:00:00	2004-12-15	2004-12-15 00:00:00	32020		\N	292061	0	10509002	260139		0
74122	4403	4294548	1947-10-02	1947-10-02 00:00:00	1948-06-17	1948-06-17 00:00:00	32020		\N	292716	0	75498004	4294548		0
74331	4412	28060	1982-10-17	1982-10-17 00:00:00	1982-10-25	1982-10-25 00:00:00	32020		\N	293341	0	43878008	28060		0
63828	3771	40481087	1983-01-21	1983-01-21 00:00:00	1983-02-04	1983-02-04 00:00:00	32020		\N	250588	0	444814009	40481087		0
64045	3784	40481087	1975-08-21	1975-08-21 00:00:00	1975-08-28	1975-08-28 00:00:00	32020		\N	251494	0	444814009	40481087		0
64130	3788	4112343	1974-03-22	1974-03-22 00:00:00	1974-04-02	1974-04-02 00:00:00	32020		\N	251816	0	195662009	4112343		0
64246	3793	40481087	1964-04-11	1964-04-11 00:00:00	1964-05-02	1964-05-02 00:00:00	32020		\N	252232	0	444814009	40481087		0
53916	3191	80180	1998-08-02	1998-08-02 00:00:00	\N	\N	32020		\N	212369	0	396275006	80180		0
64657	3823	381316	2016-11-16	2016-11-16 00:00:00	\N	\N	32020		\N	253946	0	230690007	381316		0
54208	3212	260139	1992-11-08	1992-11-08 00:00:00	1992-11-22	1992-11-22 00:00:00	32020		\N	213417	0	10509002	260139		0
54441	3224	4112343	1971-09-05	1971-09-05 00:00:00	1971-09-16	1971-09-16 00:00:00	32020		\N	214358	0	195662009	4112343		0
54566	3231	40481087	1974-11-22	1974-11-22 00:00:00	1974-12-06	1974-12-06 00:00:00	32020		\N	214740	0	444814009	40481087		0
54770	3241	4285898	1998-07-09	1998-07-09 00:00:00	\N	\N	32020		\N	215512	0	68496003	4285898		0
54939	3250	40481087	1977-12-19	1977-12-19 00:00:00	1977-12-26	1977-12-26 00:00:00	32020		\N	216054	0	444814009	40481087		0
65687	3884	378001	1992-11-19	1992-11-19 00:00:00	1992-12-19	1992-12-19 00:00:00	32020		\N	258016	0	62106007	378001		0
65859	3893	40481087	1985-02-09	1985-02-09 00:00:00	1985-02-23	1985-02-23 00:00:00	32020		\N	258835	0	444814009	40481087		0
65918	3896	40481087	1979-04-06	1979-04-06 00:00:00	1979-04-27	1979-04-27 00:00:00	32020		\N	259180	0	444814009	40481087		0
66092	3909	40481087	1988-10-12	1988-10-12 00:00:00	1988-10-26	1988-10-26 00:00:00	32020		\N	259831	0	444814009	40481087		0
66296	3926	28060	1952-07-07	1952-07-07 00:00:00	1952-07-16	1952-07-16 00:00:00	32020		\N	260922	0	43878008	28060		0
55904	3311	260139	1979-01-15	1979-01-15 00:00:00	1979-01-29	1979-01-29 00:00:00	32020		\N	219798	0	10509002	260139		0
66701	3946	4156265	2007-07-12	2007-07-12 00:00:00	2007-08-02	2007-08-02 00:00:00	32020		\N	262355	0	370247008	4156265		0
66780	3951	4112343	2019-03-09	2019-03-09 00:00:00	2019-03-18	2019-03-18 00:00:00	32020		\N	262696	0	195662009	4112343		0
66948	3958	4296205	1993-10-25	1993-10-25 00:00:00	1993-11-22	1993-11-22 00:00:00	32020		\N	263174	0	403191005	4296205		0
67094	3967	40481087	1986-06-07	1986-06-07 00:00:00	1986-06-28	1986-06-28 00:00:00	32020		\N	263767	0	444814009	40481087		0
77870	4613	4001336	2014-08-04	2014-08-04 00:00:00	2014-10-03	2014-10-03 00:00:00	32020		\N	307235	0	110030002	4001336		0
67456	3987	313217	2016-03-05	2016-03-05 00:00:00	\N	\N	32020		\N	265060	0	49436004	313217		0
67578	3993	40481087	2018-01-26	2018-01-26 00:00:00	2018-02-02	2018-02-02 00:00:00	32020		\N	265495	0	444814009	40481087		0
57249	3397	40481087	1962-09-04	1962-09-04 00:00:00	1962-09-18	1962-09-18 00:00:00	32020		\N	225288	0	444814009	40481087		0
67943	4014	4112343	1976-05-29	1976-05-29 00:00:00	1976-06-05	1976-06-05 00:00:00	32020		\N	266694	0	195662009	4112343		0
68075	4020	40481087	1999-07-08	1999-07-08 00:00:00	1999-07-22	1999-07-22 00:00:00	32020		\N	267209	0	444814009	40481087		0
68285	4033	80180	2014-07-25	2014-07-25 00:00:00	\N	\N	32020		\N	268323	0	396275006	80180		0
68429	4044	260139	1961-12-25	1961-12-25 00:00:00	1962-01-08	1962-01-08 00:00:00	32020		\N	268937	0	10509002	260139		0
68565	4055	4027663	1996-10-30	1996-10-30 00:00:00	\N	\N	32020		\N	269528	0	13200003	4027663		0
68799	4071	4294548	1986-07-23	1986-07-23 00:00:00	1986-11-05	1986-11-05 00:00:00	32020		\N	270580	0	75498004	4294548		0
58360	3457	80180	1952-08-13	1952-08-13 00:00:00	\N	\N	32020		\N	229406	0	396275006	80180		0
58573	3470	40481087	1981-12-05	1981-12-05 00:00:00	1981-12-12	1981-12-12 00:00:00	32020		\N	230319	0	444814009	40481087		0
69372	4106	40481087	1954-03-12	1954-03-12 00:00:00	1954-03-26	1954-03-26 00:00:00	32020		\N	272862	0	444814009	40481087		0
58831	3490	260139	1978-05-02	1978-05-02 00:00:00	1978-05-09	1978-05-09 00:00:00	32020		\N	231610	0	10509002	260139		0
59051	3504	81893	1955-09-02	1955-09-02 00:00:00	\N	\N	32020		\N	232328	0	64766004	81893		0
69824	4131	260139	2014-09-23	2014-09-23 00:00:00	2014-09-30	2014-09-30 00:00:00	32020		\N	274715	0	10509002	260139		0
80547	4773	4294548	1966-06-26	1966-06-26 00:00:00	1966-07-17	1966-07-17 00:00:00	32020		\N	317892	0	75498004	4294548		0
59536	3529	4112343	1989-05-19	1989-05-19 00:00:00	1989-05-30	1989-05-30 00:00:00	32020		\N	234440	0	195662009	4112343		0
70266	4160	40481087	2002-09-11	2002-09-11 00:00:00	2002-10-02	2002-10-02 00:00:00	32020		\N	276417	0	444814009	40481087		0
81010	4805	40481087	2008-08-29	2008-08-29 00:00:00	2008-09-12	2008-09-12 00:00:00	32020		\N	319701	0	444814009	40481087		0
70691	4194	81151	2005-11-19	2005-11-19 00:00:00	2005-12-17	2005-12-17 00:00:00	32020		\N	278386	0	44465007	81151		0
70754	4199	40481087	1991-05-01	1991-05-01 00:00:00	1991-05-15	1991-05-15 00:00:00	32020		\N	278670	0	444814009	40481087		0
70884	4205	28060	1978-03-11	1978-03-11 00:00:00	1978-03-18	1978-03-18 00:00:00	32020		\N	279164	0	43878008	28060		0
60498	3577	40481087	1963-06-25	1963-06-25 00:00:00	1963-07-02	1963-07-02 00:00:00	32020		\N	237839	0	444814009	40481087		0
71238	4224	81151	2010-10-21	2010-10-21 00:00:00	2010-11-04	2010-11-04 00:00:00	32020		\N	280591	0	44465007	81151		0
60886	3603	260139	2001-06-02	2001-06-02 00:00:00	2001-06-16	2001-06-16 00:00:00	32020		\N	239321	0	10509002	260139		0
71597	4247	260139	2006-12-08	2006-12-08 00:00:00	2006-12-22	2006-12-22 00:00:00	32020		\N	282023	0	10509002	260139		0
68137	4024	4027663	2006-01-21	2006-01-21 00:00:00	\N	\N	32020		\N	267530	0	13200003	4027663		0
61244	3622	4112343	1961-05-15	1961-05-15 00:00:00	1961-05-28	1961-05-28 00:00:00	32020		\N	240776	0	195662009	4112343		0
61396	3628	4109685	1987-09-15	1987-09-15 00:00:00	1987-09-29	1987-09-29 00:00:00	32020		\N	241356	0	284551006	4109685		0
61552	3637	260139	2009-01-24	2009-01-24 00:00:00	2009-02-07	2009-02-07 00:00:00	32020		\N	241925	0	10509002	260139		0
61656	3641	80180	1957-12-10	1957-12-10 00:00:00	\N	\N	32020		\N	242246	0	396275006	80180		0
72486	4305	4134304	1969-09-20	1969-09-20 00:00:00	1969-12-19	1969-12-19 00:00:00	32020		\N	285583	0	263102004	4134304		0
72621	4313	4278672	1953-09-06	1953-09-06 00:00:00	1953-10-06	1953-10-06 00:00:00	32020		\N	286307	0	65966004	4278672		0
72732	4321	40481087	1990-04-16	1990-04-16 00:00:00	1990-05-07	1990-05-07 00:00:00	32020		\N	286762	0	444814009	40481087		0
83500	4963	80180	2009-03-21	2009-03-21 00:00:00	\N	\N	32020		\N	329877	0	396275006	80180		0
73090	4343	4278672	1967-03-05	1967-03-05 00:00:00	1967-04-04	1967-04-04 00:00:00	32020		\N	288078	0	65966004	4278672		0
62720	3703	4112343	2006-05-13	2006-05-13 00:00:00	2006-05-21	2006-05-21 00:00:00	32020		\N	246275	0	195662009	4112343		0
73453	4366	372328	1998-10-20	1998-10-20 00:00:00	1999-03-23	1999-03-23 00:00:00	32020		\N	289719	0	65363002	372328		0
63017	3721	40481087	2017-05-19	2017-05-19 00:00:00	2017-06-09	2017-06-09 00:00:00	32020		\N	247330	0	444814009	40481087		0
73810	4384	40481087	2014-12-22	2014-12-22 00:00:00	2015-01-05	2015-01-05 00:00:00	32020		\N	291378	0	444814009	40481087		0
73959	4392	4113008	2001-09-18	2001-09-18 00:00:00	2001-10-09	2001-10-09 00:00:00	32020		\N	292085	0	284549007	4113008		0
74123	4403	40481087	1980-03-26	1980-03-26 00:00:00	1980-04-02	1980-04-02 00:00:00	32020		\N	292655	0	444814009	40481087		0
74332	4412	40481087	2008-03-27	2008-03-27 00:00:00	2008-04-17	2008-04-17 00:00:00	32020		\N	293387	0	444814009	40481087		0
63829	3771	40481087	1978-05-04	1978-05-04 00:00:00	1978-05-25	1978-05-25 00:00:00	32020		\N	250586	0	444814009	40481087		0
64046	3784	4283893	1979-12-02	1979-12-02 00:00:00	1979-12-30	1979-12-30 00:00:00	32020		\N	251465	0	36971009	4283893		0
64131	3788	4112343	1979-01-19	1979-01-19 00:00:00	1979-02-01	1979-02-01 00:00:00	32020		\N	251818	0	195662009	4112343		0
64247	3793	4237458	1949-12-10	1949-12-10 00:00:00	1950-02-08	1950-02-08 00:00:00	32020		\N	252276	0	58150001	4237458		0
53917	3191	4112343	2013-11-12	2013-11-12 00:00:00	2013-11-23	2013-11-23 00:00:00	32020		\N	212338	0	195662009	4112343		0
64658	3823	313217	2008-11-05	2008-11-05 00:00:00	\N	\N	32020		\N	253982	0	49436004	313217		0
54209	3212	440086	1992-07-25	1992-07-25 00:00:00	1999-08-03	1999-08-03 00:00:00	32020		\N	213402	0	192127007	440086		0
54442	3224	140673	2016-12-31	2016-12-31 00:00:00	\N	\N	32020		\N	214381	0	40930008	140673		0
54567	3231	4112343	1979-02-16	1979-02-16 00:00:00	1979-03-01	1979-03-01 00:00:00	32020		\N	214799	0	195662009	4112343		0
54771	3241	28060	1980-09-29	1980-09-29 00:00:00	1980-10-11	1980-10-11 00:00:00	32020		\N	215576	0	43878008	28060		0
54940	3250	40481087	1977-10-30	1977-10-30 00:00:00	1977-11-13	1977-11-13 00:00:00	32020		\N	216039	0	444814009	40481087		0
65688	3884	4155034	1983-02-26	1983-02-26 00:00:00	1983-03-12	1983-03-12 00:00:00	32020		\N	258015	0	283371005	4155034		0
65870	3895	4112343	1946-06-02	1946-06-02 00:00:00	1946-06-12	1946-06-12 00:00:00	32020		\N	259047	0	195662009	4112343		0
65919	3896	40481087	1995-01-08	1995-01-08 00:00:00	1995-01-15	1995-01-15 00:00:00	32020		\N	259141	0	444814009	40481087		0
66093	3909	260139	1995-06-08	1995-06-08 00:00:00	1995-06-15	1995-06-15 00:00:00	32020		\N	259832	0	10509002	260139		0
66297	3926	4116491	1991-09-18	1991-09-18 00:00:00	1991-11-12	1991-11-12 00:00:00	32020		\N	260985	0	301011002	4116491		0
55905	3311	40481087	1997-12-21	1997-12-21 00:00:00	1998-01-11	1998-01-11 00:00:00	32020		\N	219816	0	444814009	40481087		0
66702	3946	4112343	1970-10-27	1970-10-27 00:00:00	1970-11-07	1970-11-07 00:00:00	32020		\N	262341	0	195662009	4112343		0
66781	3951	4237458	2011-05-31	2011-05-31 00:00:00	2011-07-30	2011-07-30 00:00:00	32020		\N	262602	0	58150001	4237458		0
66949	3958	81151	1980-06-21	1980-06-21 00:00:00	1980-07-05	1980-07-05 00:00:00	32020		\N	263173	0	44465007	81151		0
67095	3967	372328	1965-09-02	1965-09-02 00:00:00	1966-04-17	1966-04-17 00:00:00	32020		\N	263777	0	65363002	372328		0
77871	4613	40481087	1985-10-06	1985-10-06 00:00:00	1985-10-27	1985-10-27 00:00:00	32020		\N	307313	0	444814009	40481087		0
67457	3987	40481087	1985-09-19	1985-09-19 00:00:00	1985-10-03	1985-10-03 00:00:00	32020		\N	265064	0	444814009	40481087		0
67579	3993	40481087	1983-07-20	1983-07-20 00:00:00	1983-07-27	1983-07-27 00:00:00	32020		\N	265509	0	444814009	40481087		0
57250	3397	4310024	1980-05-04	1980-05-04 00:00:00	\N	\N	32020		\N	225360	0	424802006	4310024		0
67944	4014	40481087	1970-07-19	1970-07-19 00:00:00	1970-08-02	1970-08-02 00:00:00	32020		\N	266767	0	444814009	40481087		0
68076	4020	28060	1979-04-04	1979-04-04 00:00:00	1979-04-14	1979-04-14 00:00:00	32020		\N	267219	0	43878008	28060		0
68286	4033	4112343	2009-05-02	2009-05-02 00:00:00	2009-05-15	2009-05-15 00:00:00	32020		\N	268362	0	195662009	4112343		0
68430	4044	81151	1965-08-05	1965-08-05 00:00:00	1965-09-02	1965-09-02 00:00:00	32020		\N	268947	0	44465007	81151		0
68566	4055	4112343	1996-06-08	1996-06-08 00:00:00	1996-06-20	1996-06-20 00:00:00	32020		\N	269528	0	195662009	4112343		0
68800	4071	439777	2005-09-19	2005-09-19 00:00:00	\N	\N	32020		\N	270627	0	271737000	439777		0
58361	3457	40481087	1982-11-25	1982-11-25 00:00:00	1982-12-02	1982-12-02 00:00:00	32020		\N	229356	0	444814009	40481087		0
69057	4087	28060	1991-08-22	1991-08-22 00:00:00	1991-08-31	1991-08-31 00:00:00	32020		\N	271646	0	43878008	28060		0
69373	4106	4112343	2007-04-09	2007-04-09 00:00:00	2007-04-18	2007-04-18 00:00:00	32020		\N	272787	0	195662009	4112343		0
58832	3490	260139	1961-06-23	1961-06-23 00:00:00	1961-07-07	1961-07-07 00:00:00	32020		\N	231564	0	10509002	260139		0
59052	3504	4027663	1949-02-10	1949-02-10 00:00:00	\N	\N	32020		\N	232343	0	13200003	4027663		0
69825	4131	4283893	1987-08-02	1987-08-02 00:00:00	1987-11-29	1987-11-29 00:00:00	32020		\N	274682	0	36971009	4283893		0
80548	4773	260139	2009-06-04	2009-06-04 00:00:00	2009-06-18	2009-06-18 00:00:00	32020		\N	317852	0	10509002	260139		0
59537	3530	260139	1978-11-12	1978-11-12 00:00:00	1978-11-26	1978-11-26 00:00:00	32020		\N	234499	0	10509002	260139		0
70295	4165	40481087	1950-08-02	1950-08-02 00:00:00	1950-08-09	1950-08-09 00:00:00	32020		\N	276746	0	444814009	40481087		0
81011	4805	4109685	1972-05-04	1972-05-04 00:00:00	1972-05-18	1972-05-18 00:00:00	32020		\N	319731	0	284551006	4109685		0
70710	4197	80180	2017-04-30	2017-04-30 00:00:00	\N	\N	32020		\N	278533	0	396275006	80180		0
70755	4199	4112343	2012-04-25	2012-04-25 00:00:00	2012-05-05	2012-05-05 00:00:00	32020		\N	278618	0	195662009	4112343		0
70885	4205	40481087	2018-02-08	2018-02-08 00:00:00	2018-02-15	2018-02-15 00:00:00	32020		\N	279175	0	444814009	40481087		0
60499	3577	4059173	1978-05-29	1978-05-29 00:00:00	1978-08-27	1978-08-27 00:00:00	32020		\N	237826	0	16114001	4059173		0
71239	4224	4112343	2016-02-18	2016-02-18 00:00:00	2016-02-27	2016-02-27 00:00:00	32020		\N	280542	0	195662009	4112343		0
60887	3603	440448	1967-02-08	1967-02-08 00:00:00	\N	\N	32020		\N	239390	0	74400008	440448		0
71598	4247	4112343	2019-03-28	2019-03-28 00:00:00	2019-04-05	2019-04-05 00:00:00	32020		\N	282077	0	195662009	4112343		0
61245	3622	260139	1993-07-20	1993-07-20 00:00:00	1993-07-27	1993-07-27 00:00:00	32020		\N	240677	0	10509002	260139		0
61397	3628	40481087	1924-07-13	1924-07-13 00:00:00	1924-07-27	1924-07-27 00:00:00	32020		\N	241403	0	444814009	40481087		0
61553	3637	40481087	1973-04-20	1973-04-20 00:00:00	1973-05-04	1973-05-04 00:00:00	32020		\N	241900	0	444814009	40481087		0
61657	3641	4278672	1992-11-30	1992-11-30 00:00:00	1993-02-28	1993-02-28 00:00:00	32020		\N	242315	0	65966004	4278672		0
72487	4305	40481087	1974-08-30	1974-08-30 00:00:00	1974-09-13	1974-09-13 00:00:00	32020		\N	285574	0	444814009	40481087		0
72622	4313	4027663	1972-07-12	1972-07-12 00:00:00	\N	\N	32020		\N	286331	0	13200003	4027663		0
72733	4321	40481087	2015-08-23	2015-08-23 00:00:00	2015-09-13	2015-09-13 00:00:00	32020		\N	286707	0	444814009	40481087		0
83501	4963	40481087	2008-06-18	2008-06-18 00:00:00	2008-06-25	2008-06-25 00:00:00	32020		\N	329877	0	444814009	40481087		0
73091	4343	4155034	1978-10-03	1978-10-03 00:00:00	1978-10-24	1978-10-24 00:00:00	32020		\N	288079	0	283371005	4155034		0
62721	3703	4059173	1982-01-24	1982-01-24 00:00:00	1982-03-25	1982-03-25 00:00:00	32020		\N	246255	0	16114001	4059173		0
73454	4366	372328	1984-01-04	1984-01-04 00:00:00	1984-07-03	1984-07-03 00:00:00	32020		\N	289612	0	65363002	372328		0
63018	3721	40481087	1968-02-28	1968-02-28 00:00:00	1968-03-06	1968-03-06 00:00:00	32020		\N	247331	0	444814009	40481087		0
73811	4384	78272	1999-10-01	1999-10-01 00:00:00	1999-10-22	1999-10-22 00:00:00	32020		\N	291365	0	70704007	78272		0
73960	4392	4278672	2005-09-18	2005-09-18 00:00:00	2005-11-17	2005-11-17 00:00:00	32020		\N	292047	0	65966004	4278672		0
74124	4403	260139	1950-08-12	1950-08-12 00:00:00	1950-08-19	1950-08-19 00:00:00	32020		\N	292719	0	10509002	260139		0
74334	4412	260139	2016-03-11	2016-03-11 00:00:00	2016-03-20	2016-03-20 00:00:00	32020		\N	293312	0	10509002	260139		0
63830	3771	4283893	2008-03-30	2008-03-30 00:00:00	2008-05-18	2008-05-18 00:00:00	32020		\N	250598	0	36971009	4283893		0
64047	3784	40481087	1966-06-29	1966-06-29 00:00:00	1966-07-06	1966-07-06 00:00:00	32020		\N	251508	0	444814009	40481087		0
64132	3788	78272	2005-07-12	2005-07-12 00:00:00	2005-08-02	2005-08-02 00:00:00	32020		\N	251824	0	70704007	78272		0
64248	3793	40481087	2012-08-24	2012-08-24 00:00:00	2012-08-31	2012-08-31 00:00:00	32020		\N	252255	0	444814009	40481087		0
53918	3191	40481087	1999-12-16	1999-12-16 00:00:00	1999-12-30	1999-12-30 00:00:00	32020		\N	212347	0	444814009	40481087		0
64659	3823	4112343	1991-01-31	1991-01-31 00:00:00	1991-02-12	1991-02-12 00:00:00	32020		\N	253950	0	195662009	4112343		0
54210	3212	260139	1988-07-09	1988-07-09 00:00:00	1988-07-16	1988-07-16 00:00:00	32020		\N	213431	0	10509002	260139		0
54443	3224	80180	2001-12-20	2001-12-20 00:00:00	\N	\N	32020		\N	214334	0	396275006	80180		0
54568	3231	4112343	2000-10-22	2000-10-22 00:00:00	2000-11-01	2000-11-01 00:00:00	32020		\N	214742	0	195662009	4112343		0
54772	3241	4134304	1987-03-19	1987-03-19 00:00:00	1987-04-18	1987-04-18 00:00:00	32020		\N	215442	0	263102004	4134304		0
54941	3250	28060	1970-01-03	1970-01-03 00:00:00	1970-01-14	1970-01-14 00:00:00	32020		\N	216050	0	43878008	28060		0
65689	3884	372328	1976-08-22	1976-08-22 00:00:00	1977-03-07	1977-03-07 00:00:00	32020		\N	258192	0	65363002	372328		0
65871	3895	381316	1999-02-12	1999-02-12 00:00:00	\N	\N	32020		\N	259125	0	230690007	381316		0
65920	3896	4112343	1988-03-28	1988-03-28 00:00:00	1988-04-05	1988-04-05 00:00:00	32020		\N	259139	0	195662009	4112343		0
66094	3909	4112343	1962-04-19	1962-04-19 00:00:00	1962-04-28	1962-04-28 00:00:00	32020		\N	259853	0	195662009	4112343		0
66298	3926	4112343	1959-08-13	1959-08-13 00:00:00	1959-08-22	1959-08-22 00:00:00	32020		\N	260924	0	195662009	4112343		0
55906	3311	260139	1969-10-10	1969-10-10 00:00:00	1969-10-24	1969-10-24 00:00:00	32020		\N	219754	0	10509002	260139		0
66703	3946	378001	1986-11-29	1986-11-29 00:00:00	1986-12-29	1986-12-29 00:00:00	32020		\N	262354	0	62106007	378001		0
66782	3951	260139	1997-12-11	1997-12-11 00:00:00	1997-12-25	1997-12-25 00:00:00	32020		\N	262686	0	10509002	260139		0
66950	3958	4156265	1996-10-07	1996-10-07 00:00:00	1996-10-28	1996-10-28 00:00:00	32020		\N	263175	0	370247008	4156265		0
67096	3967	40481087	2005-12-20	2005-12-20 00:00:00	2006-01-10	2006-01-10 00:00:00	32020		\N	263770	0	444814009	40481087		0
77872	4613	4112343	1976-11-28	1976-11-28 00:00:00	1976-12-07	1976-12-07 00:00:00	32020		\N	307294	0	195662009	4112343		0
67458	3987	80180	1997-02-03	1997-02-03 00:00:00	\N	\N	32020		\N	265106	0	396275006	80180		0
67580	3993	40481087	1971-11-06	1971-11-06 00:00:00	1971-11-13	1971-11-13 00:00:00	32020		\N	265508	0	444814009	40481087		0
57251	3397	40481087	1978-11-21	1978-11-21 00:00:00	1978-11-28	1978-11-28 00:00:00	32020		\N	225360	0	444814009	40481087		0
67945	4014	134438	1997-11-25	1997-11-25 00:00:00	1999-02-20	1999-02-20 00:00:00	32020		\N	266695	0	40275004	134438		0
68077	4020	378001	1979-11-15	1979-11-15 00:00:00	1979-12-15	1979-12-15 00:00:00	32020		\N	267237	0	62106007	378001		0
68287	4033	40481087	2009-07-14	2009-07-14 00:00:00	2009-07-21	2009-07-21 00:00:00	32020		\N	268352	0	444814009	40481087		0
68431	4045	40481087	1985-04-22	1985-04-22 00:00:00	1985-04-29	1985-04-29 00:00:00	32020		\N	269035	0	444814009	40481087		0
68567	4055	378001	1975-08-02	1975-08-02 00:00:00	1975-09-01	1975-09-01 00:00:00	32020		\N	269534	0	62106007	378001		0
68801	4071	40481087	2008-10-06	2008-10-06 00:00:00	2008-10-20	2008-10-20 00:00:00	32020		\N	270567	0	444814009	40481087		0
58362	3457	260139	1919-06-19	1919-06-19 00:00:00	1919-06-26	1919-06-26 00:00:00	32020		\N	229396	0	10509002	260139		0
69058	4087	4294548	1993-04-20	1993-04-20 00:00:00	1993-06-22	1993-06-22 00:00:00	32020		\N	271647	0	75498004	4294548		0
69374	4106	4112343	1988-09-08	1988-09-08 00:00:00	1988-09-19	1988-09-19 00:00:00	32020		\N	272863	0	195662009	4112343		0
58833	3490	81151	1950-03-22	1950-03-22 00:00:00	1950-04-19	1950-04-19 00:00:00	32020		\N	231512	0	44465007	81151		0
59053	3504	40481087	1988-03-29	1988-03-29 00:00:00	1988-04-12	1988-04-12 00:00:00	32020		\N	232306	0	444814009	40481087		0
69826	4131	28060	1996-09-07	1996-09-07 00:00:00	1996-09-17	1996-09-17 00:00:00	32020		\N	274684	0	43878008	28060		0
80549	4773	80180	1997-03-30	1997-03-30 00:00:00	\N	\N	32020		\N	317917	0	396275006	80180		0
59538	3530	372328	1960-10-15	1960-10-15 00:00:00	1961-03-24	1961-03-24 00:00:00	32020		\N	234480	0	65363002	372328		0
70296	4165	4156265	1917-12-13	1917-12-13 00:00:00	1918-01-03	1918-01-03 00:00:00	32020		\N	276829	0	370247008	4156265		0
81012	4805	317576	2017-10-27	2017-10-27 00:00:00	\N	\N	32020		\N	319730	0	53741008	317576		0
70711	4197	372328	1990-10-10	1990-10-10 00:00:00	1991-09-01	1991-09-01 00:00:00	32020		\N	278488	0	65363002	372328		0
70756	4199	4283893	2016-03-31	2016-03-31 00:00:00	2016-06-09	2016-06-09 00:00:00	32020		\N	278619	0	36971009	4283893		0
70886	4205	439777	1995-01-02	1995-01-02 00:00:00	\N	\N	32020		\N	279207	0	271737000	439777		0
60500	3577	40481087	2017-08-23	2017-08-23 00:00:00	2017-08-30	2017-08-30 00:00:00	32020		\N	237817	0	444814009	40481087		0
71240	4224	4027663	1978-01-01	1978-01-01 00:00:00	\N	\N	32020		\N	280588	0	13200003	4027663		0
60888	3603	4166224	1967-02-08	1967-02-08 00:00:00	\N	\N	32020		\N	239390	0	47693006	4166224		0
71599	4247	260139	2002-04-30	2002-04-30 00:00:00	2002-05-07	2002-05-07 00:00:00	32020		\N	282076	0	10509002	260139		0
61246	3622	4112343	1969-12-14	1969-12-14 00:00:00	1969-12-26	1969-12-26 00:00:00	32020		\N	240770	0	195662009	4112343		0
61398	3628	4112343	1955-04-28	1955-04-28 00:00:00	1955-05-09	1955-05-09 00:00:00	32020		\N	241407	0	195662009	4112343		0
61554	3637	40481087	1964-01-04	1964-01-04 00:00:00	1964-01-11	1964-01-11 00:00:00	32020		\N	241940	0	444814009	40481087		0
61658	3641	80502	1992-11-30	1992-11-30 00:00:00	\N	\N	32020		\N	242315	0	64859006	80502		0
72488	4305	260139	1999-10-14	1999-10-14 00:00:00	1999-10-28	1999-10-28 00:00:00	32020		\N	285531	0	10509002	260139		0
72623	4313	28060	1954-10-12	1954-10-12 00:00:00	1954-10-19	1954-10-19 00:00:00	32020		\N	286308	0	43878008	28060		0
72734	4321	260139	1995-01-29	1995-01-29 00:00:00	1995-02-12	1995-02-12 00:00:00	32020		\N	286710	0	10509002	260139		0
83502	4963	4112343	1973-12-13	1973-12-13 00:00:00	1973-12-25	1973-12-25 00:00:00	32020		\N	329942	0	195662009	4112343		0
73092	4343	4112343	1997-01-11	1997-01-11 00:00:00	1997-01-21	1997-01-21 00:00:00	32020		\N	288053	0	195662009	4112343		0
62722	3703	40481087	2008-01-26	2008-01-26 00:00:00	2008-02-02	2008-02-02 00:00:00	32020		\N	246276	0	444814009	40481087		0
73455	4366	40481087	2018-10-06	2018-10-06 00:00:00	2018-10-13	2018-10-13 00:00:00	32020		\N	289731	0	444814009	40481087		0
63019	3721	40481087	1992-01-08	1992-01-08 00:00:00	1992-01-22	1992-01-22 00:00:00	32020		\N	247354	0	444814009	40481087		0
73812	4384	260139	1978-10-17	1978-10-17 00:00:00	1978-10-24	1978-10-24 00:00:00	32020		\N	291418	0	10509002	260139		0
73961	4392	40481087	1991-10-07	1991-10-07 00:00:00	1991-10-28	1991-10-28 00:00:00	32020		\N	292049	0	444814009	40481087		0
74125	4403	4059173	1943-11-15	1943-11-15 00:00:00	1944-02-13	1944-02-13 00:00:00	32020		\N	292704	0	16114001	4059173		0
74335	4412	4283893	1991-09-10	1991-09-10 00:00:00	1991-10-15	1991-10-15 00:00:00	32020		\N	293365	0	36971009	4283893		0
63831	3771	78272	1966-11-13	1966-11-13 00:00:00	1966-12-11	1966-12-11 00:00:00	32020		\N	250620	0	70704007	78272		0
64048	3784	4142905	1945-07-19	1945-07-19 00:00:00	1945-09-17	1945-09-17 00:00:00	32020		\N	251487	0	33737001	4142905		0
64133	3788	40481087	1990-03-22	1990-03-22 00:00:00	1990-03-29	1990-03-29 00:00:00	32020		\N	251839	0	444814009	40481087		0
64249	3793	40481087	2011-03-03	2011-03-03 00:00:00	2011-03-24	2011-03-24 00:00:00	32020		\N	252254	0	444814009	40481087		0
53919	3191	4155034	1976-08-31	1976-08-31 00:00:00	1976-09-21	1976-09-21 00:00:00	32020		\N	212388	0	283371005	4155034		0
64660	3823	260139	2014-05-20	2014-05-20 00:00:00	2014-06-03	2014-06-03 00:00:00	32020		\N	253924	0	10509002	260139		0
54211	3212	196456	2018-07-21	2018-07-21 00:00:00	2018-07-21	2018-07-21 00:00:00	32020		\N	213430	0	235919008	196456		0
54444	3224	192671	2002-01-26	2002-01-26 00:00:00	\N	\N	32020		\N	214340	0	K92.2	35208414		0
54569	3231	260139	2001-05-30	2001-05-30 00:00:00	2001-06-13	2001-06-13 00:00:00	32020		\N	214801	0	10509002	260139		0
54773	3241	40481087	1976-05-31	1976-05-31 00:00:00	1976-06-21	1976-06-21 00:00:00	32020		\N	215486	0	444814009	40481087		0
54942	3250	4134304	1973-06-14	1973-06-14 00:00:00	1973-09-12	1973-09-12 00:00:00	32020		\N	216088	0	263102004	4134304		0
65690	3884	440086	1984-03-24	1984-03-24 00:00:00	1990-04-14	1990-04-14 00:00:00	32020		\N	258104	0	192127007	440086		0
65872	3895	40481087	1944-06-21	1944-06-21 00:00:00	1944-07-12	1944-07-12 00:00:00	32020		\N	259123	0	444814009	40481087		0
65921	3896	4283893	2014-06-25	2014-06-25 00:00:00	2014-10-08	2014-10-08 00:00:00	32020		\N	259142	0	36971009	4283893		0
66095	3909	260139	1964-09-03	1964-09-03 00:00:00	1964-09-17	1964-09-17 00:00:00	32020		\N	259854	0	10509002	260139		0
66299	3926	40481087	1972-04-14	1972-04-14 00:00:00	1972-05-05	1972-05-05 00:00:00	32020		\N	260977	0	444814009	40481087		0
55907	3311	260139	1981-02-18	1981-02-18 00:00:00	1981-02-25	1981-02-25 00:00:00	32020		\N	219799	0	10509002	260139		0
66722	3949	4112343	2002-03-19	2002-03-19 00:00:00	2002-03-29	2002-03-29 00:00:00	32020		\N	262510	0	195662009	4112343		0
66783	3951	80180	1986-08-30	1986-08-30 00:00:00	\N	\N	32020		\N	262684	0	396275006	80180		0
66951	3958	4112343	1983-03-20	1983-03-20 00:00:00	1983-03-27	1983-03-27 00:00:00	32020		\N	263148	0	195662009	4112343		0
67097	3967	260139	1980-01-18	1980-01-18 00:00:00	1980-01-25	1980-01-25 00:00:00	32020		\N	263764	0	10509002	260139		0
77873	4613	40481087	2001-02-23	2001-02-23 00:00:00	2001-03-16	2001-03-16 00:00:00	32020		\N	307262	0	444814009	40481087		0
67459	3987	40481087	2003-09-25	2003-09-25 00:00:00	2003-10-02	2003-10-02 00:00:00	32020		\N	265043	0	444814009	40481087		0
67581	3993	40481087	1987-12-09	1987-12-09 00:00:00	1987-12-23	1987-12-23 00:00:00	32020		\N	265510	0	444814009	40481087		0
57252	3397	4134304	1956-01-16	1956-01-16 00:00:00	1956-02-15	1956-02-15 00:00:00	32020		\N	225347	0	263102004	4134304		0
67946	4014	4112343	2006-08-29	2006-08-29 00:00:00	2006-09-11	2006-09-11 00:00:00	32020		\N	266750	0	195662009	4112343		0
68078	4020	40481087	1979-10-28	1979-10-28 00:00:00	1979-11-04	1979-11-04 00:00:00	32020		\N	267269	0	444814009	40481087		0
68288	4033	4112343	2010-05-13	2010-05-13 00:00:00	2010-05-25	2010-05-25 00:00:00	32020		\N	268363	0	195662009	4112343		0
68432	4045	40481087	2000-06-18	2000-06-18 00:00:00	2000-07-02	2000-07-02 00:00:00	32020		\N	269036	0	444814009	40481087		0
68568	4055	30753	2006-05-26	2006-05-26 00:00:00	\N	\N	32020		\N	269518	0	16761005	30753		0
68802	4071	4113008	2003-06-24	2003-06-24 00:00:00	2003-07-08	2003-07-08 00:00:00	32020		\N	270615	0	284549007	4113008		0
58363	3457	372328	1921-04-08	1921-04-08 00:00:00	1921-08-12	1921-08-12 00:00:00	32020		\N	229423	0	65363002	372328		0
69059	4087	257012	1993-05-18	1993-05-18 00:00:00	\N	\N	32020		\N	271669	0	40055000	257012		0
69375	4106	4112343	1995-04-03	1995-04-03 00:00:00	1995-04-10	1995-04-10 00:00:00	32020		\N	272786	0	195662009	4112343		0
58834	3490	4156265	2017-03-17	2017-03-17 00:00:00	2017-03-31	2017-03-31 00:00:00	32020		\N	231524	0	370247008	4156265		0
59054	3504	40481087	1939-11-24	1939-11-24 00:00:00	1939-12-15	1939-12-15 00:00:00	32020		\N	232290	0	444814009	40481087		0
69827	4131	4112343	2009-10-21	2009-10-21 00:00:00	2009-10-29	2009-10-29 00:00:00	32020		\N	274694	0	195662009	4112343		0
80550	4773	40481087	1992-10-06	1992-10-06 00:00:00	1992-10-27	1992-10-27 00:00:00	32020		\N	317905	0	444814009	40481087		0
59539	3530	40481087	1970-01-20	1970-01-20 00:00:00	1970-01-27	1970-01-27 00:00:00	32020		\N	234459	0	444814009	40481087		0
70297	4165	28060	1938-05-15	1938-05-15 00:00:00	1938-05-28	1938-05-28 00:00:00	32020		\N	276740	0	43878008	28060		0
81013	4805	260139	2019-02-13	2019-02-13 00:00:00	2019-02-20	2019-02-20 00:00:00	32020		\N	319687	0	10509002	260139		0
70712	4197	4112343	2016-03-10	2016-03-10 00:00:00	2016-03-17	2016-03-17 00:00:00	32020		\N	278509	0	195662009	4112343		0
70757	4199	260139	2014-09-28	2014-09-28 00:00:00	2014-10-05	2014-10-05 00:00:00	32020		\N	278627	0	10509002	260139		0
70887	4205	4112343	1984-12-24	1984-12-24 00:00:00	1985-01-02	1985-01-02 00:00:00	32020		\N	279165	0	195662009	4112343		0
60501	3577	4283893	2007-06-26	2007-06-26 00:00:00	2007-11-20	2007-11-20 00:00:00	32020		\N	237795	0	36971009	4283893		0
71241	4224	4109685	1956-01-24	1956-01-24 00:00:00	1956-02-07	1956-02-07 00:00:00	32020		\N	280590	0	284551006	4109685		0
60889	3604	260139	1996-03-24	1996-03-24 00:00:00	1996-03-31	1996-03-31 00:00:00	32020		\N	239476	0	10509002	260139		0
71600	4247	372328	1987-05-18	1987-05-18 00:00:00	1988-02-27	1988-02-27 00:00:00	32020		\N	282078	0	65363002	372328		0
61247	3622	372328	1927-09-07	1927-09-07 00:00:00	1928-05-09	1928-05-09 00:00:00	32020		\N	240783	0	65363002	372328		0
61399	3628	260139	1920-04-30	1920-04-30 00:00:00	1920-05-14	1920-05-14 00:00:00	32020		\N	241296	0	10509002	260139		0
61555	3637	260139	1973-04-09	1973-04-09 00:00:00	1973-04-16	1973-04-16 00:00:00	32020		\N	241942	0	10509002	260139		0
61659	3641	40480160	1992-11-30	1992-11-30 00:00:00	1993-02-28	1993-02-28 00:00:00	32020		\N	242315	0	443165006	40480160		0
72489	4305	4112343	2007-08-28	2007-08-28 00:00:00	2007-09-07	2007-09-07 00:00:00	32020		\N	285643	0	195662009	4112343		0
72624	4313	40481087	2000-03-16	2000-03-16 00:00:00	2000-04-06	2000-04-06 00:00:00	32020		\N	286247	0	444814009	40481087		0
72735	4321	4112343	1969-01-29	1969-01-29 00:00:00	1969-02-11	1969-02-11 00:00:00	32020		\N	286702	0	195662009	4112343		0
83503	4963	4113008	2006-02-25	2006-02-25 00:00:00	2006-03-18	2006-03-18 00:00:00	32020		\N	329967	0	284549007	4113008		0
73093	4343	28060	1967-09-26	1967-09-26 00:00:00	1967-10-04	1967-10-04 00:00:00	32020		\N	287989	0	43878008	28060		0
62723	3703	372328	1969-01-22	1969-01-22 00:00:00	1969-03-01	1969-03-01 00:00:00	32020		\N	246232	0	65363002	372328		0
73456	4366	40486433	1983-05-12	1983-05-12 00:00:00	2000-05-09	2000-05-09 00:00:00	32020		\N	289638	0	446096008	40486433		0
63020	3721	260139	1965-10-06	1965-10-06 00:00:00	1965-10-13	1965-10-13 00:00:00	32020		\N	247324	0	10509002	260139		0
73813	4384	372328	1968-04-24	1968-04-24 00:00:00	1968-06-24	1968-06-24 00:00:00	32020		\N	291420	0	65363002	372328		0
73962	4392	80180	2018-03-06	2018-03-06 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
74126	4403	4230399	1992-10-04	1992-10-04 00:00:00	1992-11-03	1992-11-03 00:00:00	32020		\N	292712	0	359817006	4230399		0
74336	4412	40481087	1969-03-06	1969-03-06 00:00:00	1969-03-13	1969-03-13 00:00:00	32020		\N	293275	0	444814009	40481087		0
63832	3771	80180	1996-09-11	1996-09-11 00:00:00	\N	\N	32020		\N	250641	0	396275006	80180		0
64049	3784	4113008	1952-08-02	1952-08-02 00:00:00	1952-08-23	1952-08-23 00:00:00	32020		\N	251489	0	284549007	4113008		0
64134	3788	4112343	1985-08-29	1985-08-29 00:00:00	1985-09-11	1985-09-11 00:00:00	32020		\N	251857	0	195662009	4112343		0
64250	3793	4112343	2014-07-31	2014-07-31 00:00:00	2014-08-10	2014-08-10 00:00:00	32020		\N	252185	0	195662009	4112343		0
53920	3191	260139	1992-05-26	1992-05-26 00:00:00	1992-06-09	1992-06-09 00:00:00	32020		\N	212345	0	10509002	260139		0
64661	3823	40481087	1958-12-26	1958-12-26 00:00:00	1959-01-16	1959-01-16 00:00:00	32020		\N	253907	0	444814009	40481087		0
54212	3212	198809	2018-07-21	2018-07-21 00:00:00	2018-07-21	2018-07-21 00:00:00	32020		\N	213430	0	65275009	198809		0
54445	3224	4116491	2000-01-05	2000-01-05 00:00:00	2000-02-13	2000-02-13 00:00:00	32020		\N	214379	0	301011002	4116491		0
54570	3231	260139	2005-01-29	2005-01-29 00:00:00	2005-02-12	2005-02-12 00:00:00	32020		\N	214759	0	10509002	260139		0
54774	3241	4112343	1964-07-15	1964-07-15 00:00:00	1964-07-23	1964-07-23 00:00:00	32020		\N	215449	0	195662009	4112343		0
54943	3250	40481087	2005-04-13	2005-04-13 00:00:00	2005-04-27	2005-04-27 00:00:00	32020		\N	216056	0	444814009	40481087		0
65691	3884	80180	2011-04-07	2011-04-07 00:00:00	\N	\N	32020		\N	258070	0	396275006	80180		0
65873	3895	4296205	1982-03-30	1982-03-30 00:00:00	1982-04-27	1982-04-27 00:00:00	32020		\N	259023	0	403191005	4296205		0
65922	3896	28060	1987-02-21	1987-02-21 00:00:00	1987-03-02	1987-03-02 00:00:00	32020		\N	259187	0	43878008	28060		0
66096	3909	372328	1962-08-21	1962-08-21 00:00:00	1962-10-26	1962-10-26 00:00:00	32020		\N	259871	0	65363002	372328		0
66300	3926	40481087	1980-12-26	1980-12-26 00:00:00	1981-01-16	1981-01-16 00:00:00	32020		\N	260978	0	444814009	40481087		0
55908	3311	40481087	1977-12-24	1977-12-24 00:00:00	1977-12-31	1977-12-31 00:00:00	32020		\N	219846	0	444814009	40481087		0
66723	3949	40481087	2005-10-02	2005-10-02 00:00:00	2005-10-23	2005-10-23 00:00:00	32020		\N	262461	0	444814009	40481087		0
66784	3951	4266809	1986-08-30	1986-08-30 00:00:00	\N	\N	32020		\N	262684	0	397881000	4266809		0
66952	3958	372328	1968-10-31	1968-10-31 00:00:00	1969-08-17	1969-08-17 00:00:00	32020		\N	263186	0	65363002	372328		0
67098	3967	372328	1975-05-30	1975-05-30 00:00:00	1976-06-13	1976-06-13 00:00:00	32020		\N	263713	0	65363002	372328		0
77874	4613	378001	2003-12-30	2003-12-30 00:00:00	2004-01-29	2004-01-29 00:00:00	32020		\N	307234	0	62106007	378001		0
67460	3987	4112343	1980-08-31	1980-08-31 00:00:00	1980-09-13	1980-09-13 00:00:00	32020		\N	265041	0	195662009	4112343		0
67582	3993	4146173	1942-01-01	1942-01-01 00:00:00	1942-01-31	1942-01-31 00:00:00	32020		\N	265504	0	307731004	4146173		0
57253	3397	260139	1980-07-05	1980-07-05 00:00:00	1980-07-12	1980-07-12 00:00:00	32020		\N	225325	0	10509002	260139		0
67947	4014	80180	2006-10-02	2006-10-02 00:00:00	\N	\N	32020		\N	266750	0	396275006	80180		0
68079	4021	81151	1957-08-29	1957-08-29 00:00:00	1957-09-19	1957-09-19 00:00:00	32020		\N	267308	0	44465007	81151		0
68289	4033	260139	2010-09-06	2010-09-06 00:00:00	2010-09-20	2010-09-20 00:00:00	32020		\N	268364	0	10509002	260139		0
68433	4045	372328	1974-08-15	1974-08-15 00:00:00	1974-10-26	1974-10-26 00:00:00	32020		\N	268997	0	65363002	372328		0
68569	4055	4266809	2007-02-20	2007-02-20 00:00:00	\N	\N	32020		\N	269518	0	397881000	4266809		0
68803	4071	4112343	1993-01-05	1993-01-05 00:00:00	1993-01-16	1993-01-16 00:00:00	32020		\N	270626	0	195662009	4112343		0
58364	3457	40481087	1979-05-19	1979-05-19 00:00:00	1979-06-09	1979-06-09 00:00:00	32020		\N	229329	0	444814009	40481087		0
69060	4087	40481087	2016-03-30	2016-03-30 00:00:00	2016-04-13	2016-04-13 00:00:00	32020		\N	271649	0	444814009	40481087		0
69376	4106	4112343	2000-04-29	2000-04-29 00:00:00	2000-05-11	2000-05-11 00:00:00	32020		\N	272838	0	195662009	4112343		0
58835	3490	80502	2005-11-11	2005-11-11 00:00:00	\N	\N	32020		\N	231570	0	64859006	80502		0
59055	3504	40481087	1988-12-17	1988-12-17 00:00:00	1989-01-07	1989-01-07 00:00:00	32020		\N	232321	0	444814009	40481087		0
69828	4131	80180	2018-05-22	2018-05-22 00:00:00	\N	\N	32020		\N	274676	0	396275006	80180		0
80551	4773	40481087	1984-10-03	1984-10-03 00:00:00	1984-10-10	1984-10-10 00:00:00	32020		\N	317893	0	444814009	40481087		0
59540	3530	4112343	1963-10-04	1963-10-04 00:00:00	1963-10-11	1963-10-11 00:00:00	32020		\N	234466	0	195662009	4112343		0
70298	4165	28060	1922-02-24	1922-02-24 00:00:00	1922-03-09	1922-03-09 00:00:00	32020		\N	276719	0	43878008	28060		0
81014	4805	260139	2003-08-28	2003-08-28 00:00:00	2003-09-04	2003-09-04 00:00:00	32020		\N	319735	0	10509002	260139		0
70713	4197	372328	1985-10-15	1985-10-15 00:00:00	1985-12-22	1985-12-22 00:00:00	32020		\N	278510	0	65363002	372328		0
70758	4199	4112343	1960-01-24	1960-01-24 00:00:00	1960-02-05	1960-02-05 00:00:00	32020		\N	278686	0	195662009	4112343		0
70888	4205	4112343	1988-08-17	1988-08-17 00:00:00	1988-08-25	1988-08-25 00:00:00	32020		\N	279156	0	195662009	4112343		0
60502	3577	4134304	1993-04-10	1993-04-10 00:00:00	1993-06-09	1993-06-09 00:00:00	32020		\N	237828	0	263102004	4134304		0
71242	4224	260139	1973-12-15	1973-12-15 00:00:00	1973-12-29	1973-12-29 00:00:00	32020		\N	280532	0	10509002	260139		0
60890	3604	4112343	1985-06-18	1985-06-18 00:00:00	1985-06-29	1985-06-29 00:00:00	32020		\N	239525	0	195662009	4112343		0
71601	4247	28060	1995-07-16	1995-07-16 00:00:00	1995-07-27	1995-07-27 00:00:00	32020		\N	282100	0	43878008	28060		0
61248	3622	4112343	1939-12-24	1939-12-24 00:00:00	1940-01-05	1940-01-05 00:00:00	32020		\N	240793	0	195662009	4112343		0
61401	3628	4329847	2006-08-19	2006-08-19 00:00:00	\N	\N	32020		\N	241357	0	22298006	4329847		0
61556	3637	40481087	2019-01-21	2019-01-21 00:00:00	2019-02-11	2019-02-11 00:00:00	32020		\N	241945	0	444814009	40481087		0
61660	3641	260139	2002-01-03	2002-01-03 00:00:00	2002-01-10	2002-01-10 00:00:00	32020		\N	242334	0	10509002	260139		0
72490	4305	40481087	2004-11-11	2004-11-11 00:00:00	2004-12-02	2004-12-02 00:00:00	32020		\N	285520	0	444814009	40481087		0
72625	4313	372328	1950-01-04	1950-01-04 00:00:00	1950-06-24	1950-06-24 00:00:00	32020		\N	286365	0	65363002	372328		0
72740	4324	372328	1967-01-30	1967-01-30 00:00:00	1967-05-28	1967-05-28 00:00:00	32020		\N	286845	0	65363002	372328		0
83504	4963	4112343	1975-07-20	1975-07-20 00:00:00	1975-07-30	1975-07-30 00:00:00	32020		\N	329960	0	195662009	4112343		0
73094	4343	260139	2007-08-31	2007-08-31 00:00:00	2007-09-07	2007-09-07 00:00:00	32020		\N	288013	0	10509002	260139		0
62724	3703	4112343	2003-11-08	2003-11-08 00:00:00	2003-11-21	2003-11-21 00:00:00	32020		\N	246296	0	195662009	4112343		0
73457	4366	4155034	2000-09-27	2000-09-27 00:00:00	2000-10-11	2000-10-11 00:00:00	32020		\N	289597	0	283371005	4155034		0
63021	3721	40481087	2001-10-03	2001-10-03 00:00:00	2001-10-17	2001-10-17 00:00:00	32020		\N	247335	0	444814009	40481087		0
73814	4384	28060	1991-10-03	1991-10-03 00:00:00	1991-10-15	1991-10-15 00:00:00	32020		\N	291419	0	43878008	28060		0
73963	4393	28060	1987-10-02	1987-10-02 00:00:00	1987-10-14	1987-10-14 00:00:00	32020		\N	292103	0	43878008	28060		0
74127	4403	40481087	1937-07-10	1937-07-10 00:00:00	1937-07-17	1937-07-17 00:00:00	32020		\N	292637	0	444814009	40481087		0
74337	4412	372328	1969-07-20	1969-07-20 00:00:00	1970-07-24	1970-07-24 00:00:00	32020		\N	293390	0	65363002	372328		0
63833	3771	260139	2000-03-20	2000-03-20 00:00:00	2000-03-27	2000-03-27 00:00:00	32020		\N	250612	0	10509002	260139		0
64050	3784	260139	1951-06-10	1951-06-10 00:00:00	1951-06-17	1951-06-17 00:00:00	32020		\N	251507	0	10509002	260139		0
64135	3788	260139	1987-04-22	1987-04-22 00:00:00	1987-04-29	1987-04-29 00:00:00	32020		\N	251858	0	10509002	260139		0
64251	3793	80502	1999-05-25	1999-05-25 00:00:00	\N	\N	32020		\N	252236	0	64859006	80502		0
53921	3191	260139	1993-05-07	1993-05-07 00:00:00	1993-05-14	1993-05-14 00:00:00	32020		\N	212350	0	10509002	260139		0
64662	3823	80180	1993-10-23	1993-10-23 00:00:00	\N	\N	32020		\N	253943	0	396275006	80180		0
54213	3212	4294548	2012-05-23	2012-05-23 00:00:00	2012-06-20	2012-06-20 00:00:00	32020		\N	213421	0	75498004	4294548		0
54446	3224	260139	1983-01-18	1983-01-18 00:00:00	1983-02-01	1983-02-01 00:00:00	32020		\N	214378	0	10509002	260139		0
54571	3231	440448	1983-10-09	1983-10-09 00:00:00	\N	\N	32020		\N	214728	0	74400008	440448		0
54775	3241	260139	1992-09-10	1992-09-10 00:00:00	1992-09-24	1992-09-24 00:00:00	32020		\N	215507	0	10509002	260139		0
54944	3250	260139	1964-05-03	1964-05-03 00:00:00	1964-05-10	1964-05-10 00:00:00	32020		\N	216038	0	10509002	260139		0
65692	3884	260139	1975-10-10	1975-10-10 00:00:00	1975-10-24	1975-10-24 00:00:00	32020		\N	258103	0	10509002	260139		0
65874	3895	40481087	1951-07-10	1951-07-10 00:00:00	1951-07-17	1951-07-17 00:00:00	32020		\N	259049	0	444814009	40481087		0
65923	3896	40481087	1996-02-16	1996-02-16 00:00:00	1996-03-08	1996-03-08 00:00:00	32020		\N	259164	0	444814009	40481087		0
66097	3909	378001	1965-04-29	1965-04-29 00:00:00	1965-05-29	1965-05-29 00:00:00	32020		\N	259842	0	62106007	378001		0
66301	3926	260139	2005-01-23	2005-01-23 00:00:00	2005-02-06	2005-02-06 00:00:00	32020		\N	260927	0	10509002	260139		0
55909	3311	4152936	1974-07-20	1974-07-20 00:00:00	1974-08-03	1974-08-03 00:00:00	32020		\N	219797	0	283385000	4152936		0
66724	3949	4112343	2014-10-12	2014-10-12 00:00:00	2014-10-21	2014-10-21 00:00:00	32020		\N	262496	0	195662009	4112343		0
66785	3951	4112343	1985-12-21	1985-12-21 00:00:00	1986-01-02	1986-01-02 00:00:00	32020		\N	262684	0	195662009	4112343		0
66957	3960	4310024	1994-11-03	1994-11-03 00:00:00	\N	\N	32020		\N	263285	0	424802006	4310024		0
67099	3967	4266809	2003-12-07	2003-12-07 00:00:00	\N	\N	32020		\N	263747	0	397881000	4266809		0
77875	4613	40481087	1973-06-22	1973-06-22 00:00:00	1973-07-13	1973-07-13 00:00:00	32020		\N	307311	0	444814009	40481087		0
67461	3987	260139	1989-05-23	1989-05-23 00:00:00	1989-06-06	1989-06-06 00:00:00	32020		\N	265042	0	10509002	260139		0
67583	3993	260139	1991-06-24	1991-06-24 00:00:00	1991-07-01	1991-07-01 00:00:00	32020		\N	265470	0	10509002	260139		0
57254	3397	4283893	1992-09-20	1992-09-20 00:00:00	1993-01-31	1993-01-31 00:00:00	32020		\N	225291	0	36971009	4283893		0
67948	4014	40481087	1999-11-26	1999-11-26 00:00:00	1999-12-03	1999-12-03 00:00:00	32020		\N	266743	0	444814009	40481087		0
68080	4021	4112343	1960-12-12	1960-12-12 00:00:00	1960-12-19	1960-12-19 00:00:00	32020		\N	267290	0	195662009	4112343		0
68290	4033	4283893	2018-02-05	2018-02-05 00:00:00	2018-04-24	2018-04-24 00:00:00	32020		\N	268385	0	36971009	4283893		0
68434	4045	40481087	2007-08-01	2007-08-01 00:00:00	2007-08-22	2007-08-22 00:00:00	32020		\N	269037	0	444814009	40481087		0
68570	4055	4112343	2006-05-13	2006-05-13 00:00:00	2006-05-22	2006-05-22 00:00:00	32020		\N	269518	0	195662009	4112343		0
68804	4071	4112343	1987-03-15	1987-03-15 00:00:00	1987-03-24	1987-03-24 00:00:00	32020		\N	270625	0	195662009	4112343		0
58365	3457	40481087	1975-08-19	1975-08-19 00:00:00	1975-09-09	1975-09-09 00:00:00	32020		\N	229398	0	444814009	40481087		0
69061	4087	375671	2005-04-05	2005-04-05 00:00:00	2005-05-05	2005-05-05 00:00:00	32020		\N	271641	0	62564004	375671		0
69377	4106	40481087	1959-11-01	1959-11-01 00:00:00	1959-11-22	1959-11-22 00:00:00	32020		\N	272833	0	444814009	40481087		0
58836	3490	260139	1980-09-22	1980-09-22 00:00:00	1980-10-01	1980-10-01 00:00:00	32020		\N	231583	0	10509002	260139		0
59056	3504	4285898	1955-12-31	1955-12-31 00:00:00	\N	\N	32020		\N	232328	0	68496003	4285898		0
69829	4131	40481087	2018-06-25	2018-06-25 00:00:00	2018-07-09	2018-07-09 00:00:00	32020		\N	274721	0	444814009	40481087		0
80552	4773	260139	1977-12-26	1977-12-26 00:00:00	1978-01-02	1978-01-02 00:00:00	32020		\N	317904	0	10509002	260139		0
59541	3530	4112343	1977-02-10	1977-02-10 00:00:00	1977-02-20	1977-02-20 00:00:00	32020		\N	234468	0	195662009	4112343		0
70299	4165	40481087	1918-11-14	1918-11-14 00:00:00	1918-12-05	1918-12-05 00:00:00	32020		\N	276718	0	444814009	40481087		0
81015	4805	4112343	1985-08-26	1985-08-26 00:00:00	1985-09-02	1985-09-02 00:00:00	32020		\N	319671	0	195662009	4112343		0
70714	4197	372328	1986-06-20	1986-06-20 00:00:00	1986-08-24	1986-08-24 00:00:00	32020		\N	278516	0	65363002	372328		0
70759	4199	40481087	2009-08-25	2009-08-25 00:00:00	2009-09-08	2009-09-08 00:00:00	32020		\N	278626	0	444814009	40481087		0
70889	4205	40481087	1982-11-16	1982-11-16 00:00:00	1982-12-07	1982-12-07 00:00:00	32020		\N	279155	0	444814009	40481087		0
60503	3577	28060	2014-05-14	2014-05-14 00:00:00	2014-05-23	2014-05-23 00:00:00	32020		\N	237802	0	43878008	28060		0
71243	4225	40481087	1983-11-18	1983-11-18 00:00:00	1983-12-02	1983-12-02 00:00:00	32020		\N	280621	0	444814009	40481087		0
60891	3604	4112343	1998-02-16	1998-02-16 00:00:00	1998-02-24	1998-02-24 00:00:00	32020		\N	239481	0	195662009	4112343		0
71602	4247	40481087	2018-10-16	2018-10-16 00:00:00	2018-10-30	2018-10-30 00:00:00	32020		\N	282081	0	444814009	40481087		0
61249	3622	4112343	1932-10-16	1932-10-16 00:00:00	1932-10-29	1932-10-29 00:00:00	32020		\N	240768	0	195662009	4112343		0
61402	3628	372328	1917-01-29	1917-01-29 00:00:00	1917-08-04	1917-08-04 00:00:00	32020		\N	241372	0	65363002	372328		0
61557	3637	260139	2018-08-04	2018-08-04 00:00:00	2018-08-18	2018-08-18 00:00:00	32020		\N	241944	0	10509002	260139		0
61661	3641	4155034	1979-04-01	1979-04-01 00:00:00	1979-04-15	1979-04-15 00:00:00	32020		\N	242313	0	283371005	4155034		0
72491	4305	260139	2012-08-01	2012-08-01 00:00:00	2012-08-15	2012-08-15 00:00:00	32020		\N	285644	0	10509002	260139		0
72626	4313	40481087	1995-05-12	1995-05-12 00:00:00	1995-06-02	1995-06-02 00:00:00	32020		\N	286246	0	444814009	40481087		0
72741	4324	40481087	2014-01-04	2014-01-04 00:00:00	2014-01-11	2014-01-11 00:00:00	32020		\N	286829	0	444814009	40481087		0
83505	4963	40481087	2010-09-20	2010-09-20 00:00:00	2010-10-04	2010-10-04 00:00:00	32020		\N	329889	0	444814009	40481087		0
73095	4343	80180	1995-06-20	1995-06-20 00:00:00	\N	\N	32020		\N	288004	0	396275006	80180		0
62725	3703	40481087	1976-08-01	1976-08-01 00:00:00	1976-08-22	1976-08-22 00:00:00	32020		\N	246272	0	444814009	40481087		0
73458	4366	80180	2015-06-16	2015-06-16 00:00:00	\N	\N	32020		\N	289608	0	396275006	80180		0
63022	3721	80180	2002-08-27	2002-08-27 00:00:00	\N	\N	32020		\N	247335	0	396275006	80180		0
73815	4384	260139	2008-11-27	2008-11-27 00:00:00	2008-12-11	2008-12-11 00:00:00	32020		\N	291402	0	10509002	260139		0
73964	4393	260139	2011-12-20	2011-12-20 00:00:00	2011-12-27	2011-12-27 00:00:00	32020		\N	292091	0	10509002	260139		0
74128	4403	40481087	1936-10-01	1936-10-01 00:00:00	1936-10-08	1936-10-08 00:00:00	32020		\N	292651	0	444814009	40481087		0
74338	4412	81151	1989-01-31	1989-01-31 00:00:00	1989-02-14	1989-02-14 00:00:00	32020		\N	293284	0	44465007	81151		0
63834	3771	28060	1981-04-13	1981-04-13 00:00:00	1981-04-21	1981-04-21 00:00:00	32020		\N	250632	0	43878008	28060		0
64051	3784	372328	1931-01-04	1931-01-04 00:00:00	1931-03-17	1931-03-17 00:00:00	32020		\N	251512	0	65363002	372328		0
64136	3788	40481087	1968-05-30	1968-05-30 00:00:00	1968-06-06	1968-06-06 00:00:00	32020		\N	251841	0	444814009	40481087		0
64252	3793	28060	2002-02-06	2002-02-06 00:00:00	2002-02-17	2002-02-17 00:00:00	32020		\N	252183	0	43878008	28060		0
53922	3191	4218389	1999-03-30	1999-03-30 00:00:00	1999-05-04	1999-05-04 00:00:00	32020		\N	212390	0	39848009	4218389		0
64663	3823	30753	1992-12-27	1992-12-27 00:00:00	\N	\N	32020		\N	253943	0	16761005	30753		0
54214	3212	4112343	2006-08-18	2006-08-18 00:00:00	2006-08-27	2006-08-27 00:00:00	32020		\N	213420	0	195662009	4112343		0
54447	3224	260139	1981-02-18	1981-02-18 00:00:00	1981-02-25	1981-02-25 00:00:00	32020		\N	214397	0	10509002	260139		0
54573	3231	260139	1996-08-09	1996-08-09 00:00:00	1996-08-16	1996-08-16 00:00:00	32020		\N	214778	0	10509002	260139		0
54776	3241	40481087	1999-12-20	1999-12-20 00:00:00	2000-01-10	2000-01-10 00:00:00	32020		\N	215555	0	444814009	40481087		0
54945	3250	40481087	2001-12-01	2001-12-01 00:00:00	2001-12-08	2001-12-08 00:00:00	32020		\N	216065	0	444814009	40481087		0
65693	3885	260139	1981-10-29	1981-10-29 00:00:00	1981-11-12	1981-11-12 00:00:00	32020		\N	258226	0	10509002	260139		0
65875	3895	80502	1994-05-20	1994-05-20 00:00:00	\N	\N	32020		\N	259028	0	64859006	80502		0
65924	3896	40481087	2007-08-03	2007-08-03 00:00:00	2007-08-24	2007-08-24 00:00:00	32020		\N	259144	0	444814009	40481087		0
66098	3909	40481087	1966-07-30	1966-07-30 00:00:00	1966-08-13	1966-08-13 00:00:00	32020		\N	259829	0	444814009	40481087		0
66302	3926	260139	1992-12-07	1992-12-07 00:00:00	1992-12-14	1992-12-14 00:00:00	32020		\N	260973	0	10509002	260139		0
55910	3311	40481087	1986-09-21	1986-09-21 00:00:00	1986-10-12	1986-10-12 00:00:00	32020		\N	219861	0	444814009	40481087		0
66725	3949	4112343	1975-05-17	1975-05-17 00:00:00	1975-05-25	1975-05-25 00:00:00	32020		\N	262475	0	195662009	4112343		0
66786	3951	4112343	1977-04-28	1977-04-28 00:00:00	1977-05-05	1977-05-05 00:00:00	32020		\N	262633	0	195662009	4112343		0
66958	3960	4116491	1981-02-09	1981-02-09 00:00:00	1981-03-17	1981-03-17 00:00:00	32020		\N	263252	0	301011002	4116491		0
67100	3967	80180	2003-12-07	2003-12-07 00:00:00	\N	\N	32020		\N	263747	0	396275006	80180		0
77876	4613	372328	1971-08-08	1971-08-08 00:00:00	1972-05-07	1972-05-07 00:00:00	32020		\N	307246	0	65363002	372328		0
67462	3987	4116491	2003-12-14	2003-12-14 00:00:00	2004-02-02	2004-02-02 00:00:00	32020		\N	265066	0	301011002	4116491		0
67584	3993	4156265	1991-08-31	1991-08-31 00:00:00	1991-09-21	1991-09-21 00:00:00	32020		\N	265521	0	370247008	4156265		0
57255	3397	40481087	2003-06-04	2003-06-04 00:00:00	2003-06-18	2003-06-18 00:00:00	32020		\N	225362	0	444814009	40481087		0
67969	4017	40479422	1934-01-17	1934-01-17 00:00:00	1934-03-25	1934-03-25 00:00:00	32020		\N	267029	0	444448004	40479422		0
68081	4021	40481087	1992-03-21	1992-03-21 00:00:00	1992-04-11	1992-04-11 00:00:00	32020		\N	267280	0	444814009	40481087		0
68291	4033	260139	2016-04-11	2016-04-11 00:00:00	2016-04-18	2016-04-18 00:00:00	32020		\N	268372	0	10509002	260139		0
68435	4045	260139	1988-02-25	1988-02-25 00:00:00	1988-03-03	1988-03-03 00:00:00	32020		\N	269015	0	10509002	260139		0
68571	4055	80180	2007-02-20	2007-02-20 00:00:00	\N	\N	32020		\N	269518	0	396275006	80180		0
68805	4071	40481087	1990-05-23	1990-05-23 00:00:00	1990-06-06	1990-06-06 00:00:00	32020		\N	270642	0	444814009	40481087		0
58366	3457	4134304	1986-03-31	1986-03-31 00:00:00	1986-06-29	1986-06-29 00:00:00	32020		\N	229385	0	263102004	4134304		0
69062	4087	260139	2002-09-17	2002-09-17 00:00:00	2002-09-24	2002-09-24 00:00:00	32020		\N	271670	0	10509002	260139		0
69378	4106	372328	1949-01-01	1949-01-01 00:00:00	1950-01-20	1950-01-20 00:00:00	32020		\N	272788	0	65363002	372328		0
58837	3490	40481087	1983-03-27	1983-03-27 00:00:00	1983-04-03	1983-04-03 00:00:00	32020		\N	231584	0	444814009	40481087		0
59057	3504	255848	2008-11-21	2008-11-21 00:00:00	\N	\N	32020		\N	232332	0	233604007	255848		0
69830	4131	28060	1985-04-26	1985-04-26 00:00:00	1985-05-05	1985-05-05 00:00:00	32020		\N	274712	0	43878008	28060		0
80553	4773	260139	1963-10-02	1963-10-02 00:00:00	1963-10-09	1963-10-09 00:00:00	32020		\N	317903	0	10509002	260139		0
59543	3530	321042	2003-01-03	2003-01-03 00:00:00	\N	\N	32020		\N	234457	0	410429000	321042		0
70300	4165	260139	1932-01-15	1932-01-15 00:00:00	1932-01-29	1932-01-29 00:00:00	32020		\N	276720	0	10509002	260139		0
81016	4805	4294548	1972-05-09	1972-05-09 00:00:00	1972-06-27	1972-06-27 00:00:00	32020		\N	319678	0	75498004	4294548		0
70715	4197	40481087	1988-09-05	1988-09-05 00:00:00	1988-09-12	1988-09-12 00:00:00	32020		\N	278515	0	444814009	40481087		0
70760	4199	40481087	1985-12-24	1985-12-24 00:00:00	1985-12-31	1985-12-31 00:00:00	32020		\N	278689	0	444814009	40481087		0
70890	4205	260139	2003-04-26	2003-04-26 00:00:00	2003-05-10	2003-05-10 00:00:00	32020		\N	279209	0	10509002	260139		0
60504	3577	378001	1979-09-21	1979-09-21 00:00:00	1979-10-21	1979-10-21 00:00:00	32020		\N	237827	0	62106007	378001		0
71244	4225	40481087	2002-10-29	2002-10-29 00:00:00	2002-11-05	2002-11-05 00:00:00	32020		\N	280629	0	444814009	40481087		0
60892	3604	40481087	1990-03-12	1990-03-12 00:00:00	1990-03-19	1990-03-19 00:00:00	32020		\N	239473	0	444814009	40481087		0
71603	4247	378001	2008-06-17	2008-06-17 00:00:00	2008-08-16	2008-08-16 00:00:00	32020		\N	282012	0	62106007	378001		0
61250	3622	4112343	1975-03-31	1975-03-31 00:00:00	1975-04-08	1975-04-08 00:00:00	32020		\N	240747	0	195662009	4112343		0
61403	3628	81151	1967-07-22	1967-07-22 00:00:00	1967-08-26	1967-08-26 00:00:00	32020		\N	241353	0	44465007	81151		0
61558	3637	40481087	1994-03-27	1994-03-27 00:00:00	1994-04-03	1994-04-03 00:00:00	32020		\N	241908	0	444814009	40481087		0
61662	3641	28060	1978-02-07	1978-02-07 00:00:00	1978-02-14	1978-02-14 00:00:00	32020		\N	242338	0	43878008	28060		0
72492	4305	28060	1963-07-28	1963-07-28 00:00:00	1963-08-08	1963-08-08 00:00:00	32020		\N	285558	0	43878008	28060		0
72627	4313	81151	1958-09-10	1958-09-10 00:00:00	1958-10-01	1958-10-01 00:00:00	32020		\N	286271	0	44465007	81151		0
72742	4324	372328	1963-08-30	1963-08-30 00:00:00	1963-11-17	1963-11-17 00:00:00	32020		\N	286852	0	65363002	372328		0
83506	4963	4112343	2017-08-03	2017-08-03 00:00:00	2017-08-13	2017-08-13 00:00:00	32020		\N	329941	0	195662009	4112343		0
73096	4343	28060	2019-06-24	2019-06-24 00:00:00	\N	\N	32020		\N	288037	0	43878008	28060		0
62726	3703	4112343	1999-01-17	1999-01-17 00:00:00	1999-01-29	1999-01-29 00:00:00	32020		\N	246229	0	195662009	4112343		0
73459	4366	40481087	1991-02-06	1991-02-06 00:00:00	1991-02-13	1991-02-13 00:00:00	32020		\N	289669	0	444814009	40481087		0
63023	3721	4112343	1985-04-15	1985-04-15 00:00:00	1985-04-25	1985-04-25 00:00:00	32020		\N	247334	0	195662009	4112343		0
73816	4384	4155034	1982-12-08	1982-12-08 00:00:00	1982-12-29	1982-12-29 00:00:00	32020		\N	291364	0	283371005	4155034		0
73965	4393	28060	1990-12-30	1990-12-30 00:00:00	1991-01-07	1991-01-07 00:00:00	32020		\N	292116	0	43878008	28060		0
74129	4403	4112343	1942-01-26	1942-01-26 00:00:00	1942-02-06	1942-02-06 00:00:00	32020		\N	292664	0	195662009	4112343		0
74339	4413	28060	1966-06-04	1966-06-04 00:00:00	1966-06-17	1966-06-17 00:00:00	32020		\N	293454	0	43878008	28060		0
63835	3771	4112343	2009-08-03	2009-08-03 00:00:00	2009-08-11	2009-08-11 00:00:00	32020		\N	250600	0	195662009	4112343		0
64052	3784	140673	1984-06-24	1984-06-24 00:00:00	\N	\N	32020		\N	251500	0	40930008	140673		0
64137	3788	40481087	2009-12-11	2009-12-11 00:00:00	2010-01-01	2010-01-01 00:00:00	32020		\N	251847	0	444814009	40481087		0
64253	3793	4112343	1983-08-22	1983-08-22 00:00:00	1983-08-29	1983-08-29 00:00:00	32020		\N	252251	0	195662009	4112343		0
53923	3191	40481087	2017-10-26	2017-10-26 00:00:00	2017-11-16	2017-11-16 00:00:00	32020		\N	212362	0	444814009	40481087		0
64664	3823	81893	1992-08-29	1992-08-29 00:00:00	\N	\N	32020		\N	253943	0	64766004	81893		0
54215	3212	78272	2006-10-25	2006-10-25 00:00:00	2006-11-22	2006-11-22 00:00:00	32020		\N	213429	0	70704007	78272		0
54448	3224	4283893	2012-02-18	2012-02-18 00:00:00	2012-04-07	2012-04-07 00:00:00	32020		\N	214359	0	36971009	4283893		0
54574	3231	4146173	1989-03-30	1989-03-30 00:00:00	1989-05-06	1989-05-06 00:00:00	32020		\N	214800	0	307731004	4146173		0
54777	3241	260139	2013-08-02	2013-08-02 00:00:00	2013-08-09	2013-08-09 00:00:00	32020		\N	215558	0	10509002	260139		0
54946	3250	81151	2017-04-24	2017-04-24 00:00:00	2017-05-22	2017-05-22 00:00:00	32020		\N	216089	0	44465007	81151		0
65694	3885	4155034	2011-12-19	2011-12-19 00:00:00	2012-01-02	2012-01-02 00:00:00	32020		\N	258220	0	283371005	4155034		0
65876	3895	40481087	1952-07-18	1952-07-18 00:00:00	1952-08-01	1952-08-01 00:00:00	32020		\N	259118	0	444814009	40481087		0
65925	3896	81151	1987-09-06	1987-09-06 00:00:00	1987-10-11	1987-10-11 00:00:00	32020		\N	259186	0	44465007	81151		0
66099	3909	372328	1961-10-17	1961-10-17 00:00:00	1961-11-24	1961-11-24 00:00:00	32020		\N	259840	0	65363002	372328		0
66303	3926	4112343	1984-12-10	1984-12-10 00:00:00	1984-12-17	1984-12-17 00:00:00	32020		\N	260926	0	195662009	4112343		0
55911	3311	4112343	1968-11-15	1968-11-15 00:00:00	1968-11-25	1968-11-25 00:00:00	32020		\N	219859	0	195662009	4112343		0
66726	3949	4112343	2017-07-11	2017-07-11 00:00:00	2017-07-23	2017-07-23 00:00:00	32020		\N	262497	0	195662009	4112343		0
66787	3951	4294548	1959-03-10	1959-03-10 00:00:00	1959-11-10	1959-11-10 00:00:00	32020		\N	262617	0	75498004	4294548		0
66959	3960	40481087	2018-09-04	2018-09-04 00:00:00	2018-09-18	2018-09-18 00:00:00	32020		\N	263301	0	444814009	40481087		0
67101	3967	30753	2002-12-12	2002-12-12 00:00:00	\N	\N	32020		\N	263747	0	16761005	30753		0
77877	4613	4146173	1973-10-17	1973-10-17 00:00:00	1973-12-16	1973-12-16 00:00:00	32020		\N	307293	0	307731004	4146173		0
67463	3987	40481087	1996-02-15	1996-02-15 00:00:00	1996-02-29	1996-02-29 00:00:00	32020		\N	265065	0	444814009	40481087		0
67585	3993	40481087	1971-07-20	1971-07-20 00:00:00	1971-08-03	1971-08-03 00:00:00	32020		\N	265507	0	444814009	40481087		0
57256	3397	40481087	1994-03-04	1994-03-04 00:00:00	1994-03-18	1994-03-18 00:00:00	32020		\N	225294	0	444814009	40481087		0
67970	4017	40481087	1927-08-29	1927-08-29 00:00:00	1927-09-05	1927-09-05 00:00:00	32020		\N	266963	0	444814009	40481087		0
68292	4033	372328	2017-02-03	2017-02-03 00:00:00	2018-04-24	2018-04-24 00:00:00	32020		\N	268386	0	65363002	372328		0
68436	4045	40481087	1979-10-06	1979-10-06 00:00:00	1979-10-13	1979-10-13 00:00:00	32020		\N	269045	0	444814009	40481087		0
68572	4055	260139	2013-12-23	2013-12-23 00:00:00	2014-01-06	2014-01-06 00:00:00	32020		\N	269558	0	10509002	260139		0
68806	4071	4112343	1989-06-14	1989-06-14 00:00:00	1989-06-22	1989-06-22 00:00:00	32020		\N	270589	0	195662009	4112343		0
58367	3457	40480160	1986-03-31	1986-03-31 00:00:00	1986-06-29	1986-06-29 00:00:00	32020		\N	229385	0	443165006	40480160		0
69063	4087	81151	2008-03-20	2008-03-20 00:00:00	2008-04-03	2008-04-03 00:00:00	32020		\N	271642	0	44465007	81151		0
69379	4106	40481087	2016-03-23	2016-03-23 00:00:00	2016-04-13	2016-04-13 00:00:00	32020		\N	272839	0	444814009	40481087		0
58838	3490	4051466	1947-09-21	1947-09-21 00:00:00	1964-12-21	1964-12-21 00:00:00	32020		\N	231487	0	233678006	4051466		0
59058	3504	28060	1931-04-04	1931-04-04 00:00:00	1931-04-13	1931-04-13 00:00:00	32020		\N	232288	0	43878008	28060		0
69831	4131	40481087	2003-05-17	2003-05-17 00:00:00	2003-05-24	2003-05-24 00:00:00	32020		\N	274693	0	444814009	40481087		0
80554	4773	4112343	1974-12-18	1974-12-18 00:00:00	1974-12-28	1974-12-28 00:00:00	32020		\N	317871	0	195662009	4112343		0
59544	3530	28060	1972-09-24	1972-09-24 00:00:00	1972-10-02	1972-10-02 00:00:00	32020		\N	234467	0	43878008	28060		0
70301	4165	260139	1960-10-22	1960-10-22 00:00:00	1960-11-05	1960-11-05 00:00:00	32020		\N	276748	0	10509002	260139		0
81017	4805	260139	1983-07-07	1983-07-07 00:00:00	1983-07-21	1983-07-21 00:00:00	32020		\N	319686	0	10509002	260139		0
70716	4197	4134304	1997-03-16	1997-03-16 00:00:00	1997-04-15	1997-04-15 00:00:00	32020		\N	278525	0	263102004	4134304		0
70761	4199	4112343	2016-09-13	2016-09-13 00:00:00	2016-09-25	2016-09-25 00:00:00	32020		\N	278693	0	195662009	4112343		0
70891	4205	78272	2004-07-18	2004-07-18 00:00:00	2004-08-22	2004-08-22 00:00:00	32020		\N	279235	0	70704007	78272		0
60505	3577	4027663	1989-02-20	1989-02-20 00:00:00	\N	\N	32020		\N	237787	0	13200003	4027663		0
71245	4225	4310024	2013-05-26	2013-05-26 00:00:00	\N	\N	32020		\N	280597	0	424802006	4310024		0
60893	3604	372328	1987-03-02	1987-03-02 00:00:00	1987-04-10	1987-04-10 00:00:00	32020		\N	239554	0	65363002	372328		0
71604	4247	4051466	1986-03-25	1986-03-25 00:00:00	2002-12-28	2002-12-28 00:00:00	32020		\N	282057	0	233678006	4051466		0
61251	3622	260139	1948-12-04	1948-12-04 00:00:00	1948-12-11	1948-12-11 00:00:00	32020		\N	240769	0	10509002	260139		0
61404	3628	80502	1974-12-28	1974-12-28 00:00:00	\N	\N	32020		\N	241311	0	64859006	80502		0
61559	3637	40481087	1971-07-10	1971-07-10 00:00:00	1971-07-24	1971-07-24 00:00:00	32020		\N	241941	0	444814009	40481087		0
61663	3641	4294548	1991-03-20	1991-03-20 00:00:00	1991-05-01	1991-05-01 00:00:00	32020		\N	242339	0	75498004	4294548		0
72493	4305	4156265	1973-09-29	1973-09-29 00:00:00	1973-10-13	1973-10-13 00:00:00	32020		\N	285658	0	370247008	4156265		0
72628	4313	40481087	2003-12-24	2003-12-24 00:00:00	2004-01-14	2004-01-14 00:00:00	32020		\N	286297	0	444814009	40481087		0
72743	4324	4116491	2019-06-11	2019-06-11 00:00:00	\N	\N	32020		\N	286844	0	301011002	4116491		0
83507	4963	4112343	2001-10-03	2001-10-03 00:00:00	2001-10-15	2001-10-15 00:00:00	32020		\N	329888	0	195662009	4112343		0
73097	4343	4283893	1988-05-28	1988-05-28 00:00:00	1988-08-27	1988-08-27 00:00:00	32020		\N	288059	0	36971009	4283893		0
62727	3703	260139	1995-03-09	1995-03-09 00:00:00	1995-03-16	1995-03-16 00:00:00	32020		\N	246228	0	10509002	260139		0
73460	4366	4059173	1996-11-12	1996-11-12 00:00:00	1997-01-11	1997-01-11 00:00:00	32020		\N	289595	0	16114001	4059173		0
63024	3721	4112343	1990-08-31	1990-08-31 00:00:00	1990-09-08	1990-09-08 00:00:00	32020		\N	247353	0	195662009	4112343		0
73817	4384	40481087	1969-08-10	1969-08-10 00:00:00	1969-08-31	1969-08-31 00:00:00	32020		\N	291366	0	444814009	40481087		0
73966	4393	40481087	2007-09-17	2007-09-17 00:00:00	2007-10-08	2007-10-08 00:00:00	32020		\N	292118	0	444814009	40481087		0
74130	4403	4294548	1975-04-25	1975-04-25 00:00:00	1975-06-13	1975-06-13 00:00:00	32020		\N	292667	0	75498004	4294548		0
74340	4413	4112343	1992-03-02	1992-03-02 00:00:00	1992-03-15	1992-03-15 00:00:00	32020		\N	293491	0	195662009	4112343		0
63836	3771	81151	1970-12-20	1970-12-20 00:00:00	1971-01-24	1971-01-24 00:00:00	32020		\N	250621	0	44465007	81151		0
64053	3784	260139	1937-05-04	1937-05-04 00:00:00	1937-05-18	1937-05-18 00:00:00	32020		\N	251491	0	10509002	260139		0
64138	3788	80180	2006-12-14	2006-12-14 00:00:00	\N	\N	32020		\N	251845	0	396275006	80180		0
64254	3793	40481087	1943-01-20	1943-01-20 00:00:00	1943-01-27	1943-01-27 00:00:00	32020		\N	252259	0	444814009	40481087		0
53924	3191	260139	2000-10-05	2000-10-05 00:00:00	2000-10-12	2000-10-12 00:00:00	32020		\N	212361	0	10509002	260139		0
64665	3823	4112343	1962-11-02	1962-11-02 00:00:00	1962-11-15	1962-11-15 00:00:00	32020		\N	253920	0	195662009	4112343		0
54216	3212	40481087	2006-07-07	2006-07-07 00:00:00	2006-07-28	2006-07-28 00:00:00	32020		\N	213419	0	444814009	40481087		0
64919	3839	4112343	1981-11-01	1981-11-01 00:00:00	1981-11-08	1981-11-08 00:00:00	32020		\N	254921	0	195662009	4112343		0
54575	3231	40481087	1956-02-15	1956-02-15 00:00:00	1956-02-29	1956-02-29 00:00:00	32020		\N	214797	0	444814009	40481087		0
54778	3241	4283893	2012-12-18	2012-12-18 00:00:00	2013-02-05	2013-02-05 00:00:00	32020		\N	215545	0	36971009	4283893		0
65412	3869	4278672	1961-07-16	1961-07-16 00:00:00	1961-08-15	1961-08-15 00:00:00	32020		\N	256843	0	65966004	4278672		0
65695	3885	80180	2004-10-26	2004-10-26 00:00:00	\N	\N	32020		\N	258223	0	396275006	80180		0
65877	3895	40481087	1947-04-03	1947-04-03 00:00:00	1947-04-24	1947-04-24 00:00:00	32020		\N	259086	0	444814009	40481087		0
65926	3896	260139	2000-10-31	2000-10-31 00:00:00	2000-11-07	2000-11-07 00:00:00	32020		\N	259181	0	10509002	260139		0
66100	3909	372328	1967-02-02	1967-02-02 00:00:00	1967-08-11	1967-08-11 00:00:00	32020		\N	259856	0	65363002	372328		0
66304	3926	4296204	1982-11-13	1982-11-13 00:00:00	1982-12-11	1982-12-11 00:00:00	32020		\N	261010	0	403190006	4296204		0
55912	3311	260139	2012-01-07	2012-01-07 00:00:00	2012-01-21	2012-01-21 00:00:00	32020		\N	219832	0	10509002	260139		0
66727	3949	40481087	1994-12-14	1994-12-14 00:00:00	1994-12-21	1994-12-21 00:00:00	32020		\N	262494	0	444814009	40481087		0
66788	3951	4027663	1975-09-17	1975-09-17 00:00:00	\N	\N	32020		\N	262677	0	13200003	4027663		0
66960	3960	40481087	1978-12-13	1978-12-13 00:00:00	1978-12-20	1978-12-20 00:00:00	32020		\N	263291	0	444814009	40481087		0
67102	3967	4285898	2003-02-10	2003-02-10 00:00:00	\N	\N	32020		\N	263747	0	68496003	4285898		0
77890	4615	4112343	1991-04-03	1991-04-03 00:00:00	1991-04-15	1991-04-15 00:00:00	32020		\N	307453	0	195662009	4112343		0
67464	3987	40481087	1967-06-24	1967-06-24 00:00:00	1967-07-08	1967-07-08 00:00:00	32020		\N	265040	0	444814009	40481087		0
67586	3993	4294548	1989-01-23	1989-01-23 00:00:00	1989-05-01	1989-05-01 00:00:00	32020		\N	265494	0	75498004	4294548		0
57257	3397	81151	1976-11-10	1976-11-10 00:00:00	1976-12-01	1976-12-01 00:00:00	32020		\N	225350	0	44465007	81151		0
67971	4017	4112343	1922-08-20	1922-08-20 00:00:00	1922-09-01	1922-09-01 00:00:00	32020		\N	266962	0	195662009	4112343		0
68083	4021	40481087	2015-04-05	2015-04-05 00:00:00	2015-04-26	2015-04-26 00:00:00	32020		\N	267326	0	444814009	40481087		0
68307	4035	80180	2007-04-02	2007-04-02 00:00:00	\N	\N	32020		\N	268468	0	396275006	80180		0
68437	4045	40481087	1976-04-15	1976-04-15 00:00:00	1976-04-22	1976-04-22 00:00:00	32020		\N	269023	0	444814009	40481087		0
68573	4055	4296204	1997-06-28	1997-06-28 00:00:00	1997-07-12	1997-07-12 00:00:00	32020		\N	269536	0	403190006	4296204		0
68807	4071	257012	1986-08-20	1986-08-20 00:00:00	\N	\N	32020		\N	270565	0	40055000	257012		0
58368	3457	4218389	1960-04-25	1960-04-25 00:00:00	1960-05-16	1960-05-16 00:00:00	32020		\N	229384	0	39848009	4218389		0
69064	4087	260139	1983-12-18	1983-12-18 00:00:00	1984-01-01	1984-01-01 00:00:00	32020		\N	271666	0	10509002	260139		0
69380	4106	80180	1984-02-07	1984-02-07 00:00:00	\N	\N	32020		\N	272825	0	396275006	80180		0
77996	4622	80180	1997-08-03	1997-08-03 00:00:00	\N	\N	32020		\N	307781	0	396275006	80180		0
58839	3490	40481087	2014-07-08	2014-07-08 00:00:00	2014-07-15	2014-07-15 00:00:00	32020		\N	231502	0	444814009	40481087		0
59059	3505	4112343	1949-11-14	1949-11-14 00:00:00	1949-11-22	1949-11-22 00:00:00	32020		\N	232438	0	195662009	4112343		0
69832	4131	4112343	2011-12-21	2011-12-21 00:00:00	2012-01-02	2012-01-02 00:00:00	32020		\N	274720	0	195662009	4112343		0
80555	4773	257012	1959-07-25	1959-07-25 00:00:00	\N	\N	32020		\N	317901	0	40055000	257012		0
59545	3530	40481087	1982-05-01	1982-05-01 00:00:00	1982-05-08	1982-05-08 00:00:00	32020		\N	234488	0	444814009	40481087		0
70302	4165	4112343	1968-12-22	1968-12-22 00:00:00	1969-01-04	1969-01-04 00:00:00	32020		\N	276721	0	195662009	4112343		0
81030	4807	4116491	2002-03-15	2002-03-15 00:00:00	2002-04-28	2002-04-28 00:00:00	32020		\N	319858	0	301011002	4116491		0
81175	4814	40481087	1942-01-06	1942-01-06 00:00:00	1942-01-27	1942-01-27 00:00:00	32020		\N	320217	0	444814009	40481087		0
70762	4199	28060	1945-02-03	1945-02-03 00:00:00	1945-02-16	1945-02-16 00:00:00	32020		\N	278679	0	43878008	28060		0
70892	4205	4294548	2010-07-18	2010-07-18 00:00:00	2010-08-29	2010-08-29 00:00:00	32020		\N	279251	0	75498004	4294548		0
60506	3577	40481087	1977-11-14	1977-11-14 00:00:00	1977-11-21	1977-11-21 00:00:00	32020		\N	237791	0	444814009	40481087		0
71246	4225	372328	1980-04-29	1980-04-29 00:00:00	1980-06-12	1980-06-12 00:00:00	32020		\N	280623	0	65363002	372328		0
60894	3604	372328	1984-10-31	1984-10-31 00:00:00	1985-01-11	1985-01-11 00:00:00	32020		\N	239553	0	65363002	372328		0
71605	4247	260139	1994-01-21	1994-01-21 00:00:00	1994-01-28	1994-01-28 00:00:00	32020		\N	282045	0	10509002	260139		0
61252	3622	40481087	2004-10-31	2004-10-31 00:00:00	2004-11-21	2004-11-21 00:00:00	32020		\N	240735	0	444814009	40481087		0
61405	3628	4112343	1971-12-23	1971-12-23 00:00:00	1972-01-05	1972-01-05 00:00:00	32020		\N	241408	0	195662009	4112343		0
61560	3637	372328	1964-11-21	1964-11-21 00:00:00	1965-07-06	1965-07-06 00:00:00	32020		\N	241927	0	65363002	372328		0
61664	3641	40481087	1942-11-13	1942-11-13 00:00:00	1942-12-04	1942-12-04 00:00:00	32020		\N	242322	0	444814009	40481087		0
72494	4305	4084167	2004-04-19	2004-04-19 00:00:00	2004-04-20	2004-04-20 00:00:00	32020		\N	285535	0	241929008	4084167		0
72629	4313	40481087	1963-06-19	1963-06-19 00:00:00	1963-07-10	1963-07-10 00:00:00	32020		\N	286310	0	444814009	40481087		0
72744	4324	40481087	2007-04-20	2007-04-20 00:00:00	2007-05-04	2007-05-04 00:00:00	32020		\N	286851	0	444814009	40481087		0
83508	4963	4112343	1982-08-25	1982-08-25 00:00:00	1982-09-02	1982-09-02 00:00:00	32020		\N	329963	0	195662009	4112343		0
73098	4343	260139	1961-07-28	1961-07-28 00:00:00	1961-08-11	1961-08-11 00:00:00	32020		\N	288008	0	10509002	260139		0
62728	3703	260139	2013-08-09	2013-08-09 00:00:00	2013-08-16	2013-08-16 00:00:00	32020		\N	246230	0	10509002	260139		0
73461	4366	4112343	1991-11-23	1991-11-23 00:00:00	1991-12-04	1991-12-04 00:00:00	32020		\N	289680	0	195662009	4112343		0
63025	3721	260139	1981-05-19	1981-05-19 00:00:00	1981-06-02	1981-06-02 00:00:00	32020		\N	247333	0	10509002	260139		0
73818	4384	4112343	1973-07-29	1973-07-29 00:00:00	1973-08-05	1973-08-05 00:00:00	32020		\N	291368	0	195662009	4112343		0
73967	4393	40481087	2009-10-02	2009-10-02 00:00:00	2009-10-23	2009-10-23 00:00:00	32020		\N	292090	0	444814009	40481087		0
74131	4403	81151	1989-09-15	1989-09-15 00:00:00	1989-10-20	1989-10-20 00:00:00	32020		\N	292711	0	44465007	81151		0
74341	4413	80180	1997-11-14	1997-11-14 00:00:00	\N	\N	32020		\N	293419	0	396275006	80180		0
63837	3771	4112343	2007-11-03	2007-11-03 00:00:00	2007-11-10	2007-11-10 00:00:00	32020		\N	250597	0	195662009	4112343		0
64054	3784	260139	1979-01-01	1979-01-01 00:00:00	1979-01-08	1979-01-08 00:00:00	32020		\N	251511	0	10509002	260139		0
64139	3788	440086	1975-08-09	1975-08-09 00:00:00	1982-08-17	1982-08-17 00:00:00	32020		\N	251817	0	192127007	440086		0
64255	3793	4296204	1944-12-01	1944-12-01 00:00:00	1945-01-05	1945-01-05 00:00:00	32020		\N	252274	0	403190006	4296204		0
53925	3191	40481087	1976-10-21	1976-10-21 00:00:00	1976-10-28	1976-10-28 00:00:00	32020		\N	212349	0	444814009	40481087		0
64666	3823	372328	1956-06-04	1956-06-04 00:00:00	1956-09-19	1956-09-19 00:00:00	32020		\N	253952	0	65363002	372328		0
54217	3212	40481087	2009-05-19	2009-05-19 00:00:00	2009-06-02	2009-06-02 00:00:00	32020		\N	213405	0	444814009	40481087		0
64920	3839	4296204	2007-11-28	2007-11-28 00:00:00	2007-12-19	2007-12-19 00:00:00	32020		\N	254862	0	403190006	4296204		0
54576	3231	40481087	1956-12-01	1956-12-01 00:00:00	1956-12-22	1956-12-22 00:00:00	32020		\N	214773	0	444814009	40481087		0
54779	3241	4112343	1988-08-15	1988-08-15 00:00:00	1988-08-26	1988-08-26 00:00:00	32020		\N	215478	0	195662009	4112343		0
65413	3869	4112343	1974-12-14	1974-12-14 00:00:00	1974-12-27	1974-12-27 00:00:00	32020		\N	256940	0	195662009	4112343		0
65696	3885	4112343	2009-04-02	2009-04-02 00:00:00	2009-04-11	2009-04-11 00:00:00	32020		\N	258259	0	195662009	4112343		0
65878	3895	4112343	1943-02-24	1943-02-24 00:00:00	1943-03-05	1943-03-05 00:00:00	32020		\N	259056	0	195662009	4112343		0
65937	3899	4112343	2006-10-04	2006-10-04 00:00:00	2006-10-15	2006-10-15 00:00:00	32020		\N	259289	0	195662009	4112343		0
66101	3909	80180	1999-08-29	1999-08-29 00:00:00	\N	\N	32020		\N	259864	0	396275006	80180		0
66305	3926	4112343	1986-05-15	1986-05-15 00:00:00	1986-05-22	1986-05-22 00:00:00	32020		\N	260979	0	195662009	4112343		0
55913	3311	28060	2015-10-02	2015-10-02 00:00:00	2015-10-12	2015-10-12 00:00:00	32020		\N	219817	0	43878008	28060		0
66728	3949	40481087	1977-05-09	1977-05-09 00:00:00	1977-05-30	1977-05-30 00:00:00	32020		\N	262477	0	444814009	40481087		0
66789	3951	4134304	1950-01-21	1950-01-21 00:00:00	1950-04-21	1950-04-21 00:00:00	32020		\N	262600	0	263102004	4134304		0
66961	3960	4266809	1997-05-21	1997-05-21 00:00:00	\N	\N	32020		\N	263272	0	397881000	4266809		0
67103	3967	81151	1966-01-30	1966-01-30 00:00:00	1966-02-20	1966-02-20 00:00:00	32020		\N	263784	0	44465007	81151		0
77891	4615	372328	1957-10-25	1957-10-25 00:00:00	1958-03-26	1958-03-26 00:00:00	32020		\N	307408	0	65363002	372328		0
67465	3987	4134304	1964-11-19	1964-11-19 00:00:00	1965-02-17	1965-02-17 00:00:00	32020		\N	265027	0	263102004	4134304		0
67587	3993	195588	1960-12-22	1960-12-22 00:00:00	1961-02-03	1961-02-03 00:00:00	32020		\N	265506	0	38822007	195588		0
57258	3397	4112343	2001-10-11	2001-10-11 00:00:00	2001-10-24	2001-10-24 00:00:00	32020		\N	225326	0	195662009	4112343		0
67972	4017	260139	1936-05-08	1936-05-08 00:00:00	1936-05-22	1936-05-22 00:00:00	32020		\N	267034	0	10509002	260139		0
68084	4021	4296204	1966-04-10	1966-04-10 00:00:00	1966-05-01	1966-05-01 00:00:00	32020		\N	267347	0	403190006	4296204		0
68308	4035	260139	1975-07-06	1975-07-06 00:00:00	1975-07-20	1975-07-20 00:00:00	32020		\N	268491	0	10509002	260139		0
68438	4045	4112343	2004-06-23	2004-06-23 00:00:00	2004-07-04	2004-07-04 00:00:00	32020		\N	269025	0	195662009	4112343		0
68574	4055	40481087	1980-08-08	1980-08-08 00:00:00	1980-08-22	1980-08-22 00:00:00	32020		\N	269517	0	444814009	40481087		0
68808	4072	192671	2012-01-09	2012-01-09 00:00:00	\N	\N	32020		\N	270678	0	K92.2	35208414		0
58369	3457	40481087	2006-06-19	2006-06-19 00:00:00	2006-06-26	2006-06-26 00:00:00	32020		\N	229331	0	444814009	40481087		0
69065	4087	372328	1982-01-26	1982-01-26 00:00:00	1982-09-29	1982-09-29 00:00:00	32020		\N	271650	0	65363002	372328		0
69381	4106	4285898	1983-09-10	1983-09-10 00:00:00	\N	\N	32020		\N	272825	0	68496003	4285898		0
58840	3490	4109685	2012-06-27	2012-06-27 00:00:00	2012-07-11	2012-07-11 00:00:00	32020		\N	231523	0	284551006	4109685		0
59060	3505	4112343	1965-03-11	1965-03-11 00:00:00	1965-03-18	1965-03-18 00:00:00	32020		\N	232397	0	195662009	4112343		0
69833	4131	4218389	1989-04-04	1989-04-04 00:00:00	1989-05-02	1989-05-02 00:00:00	32020		\N	274668	0	39848009	4218389		0
80556	4773	28060	1987-01-28	1987-01-28 00:00:00	1987-02-06	1987-02-06 00:00:00	32020		\N	317849	0	43878008	28060		0
59546	3530	317576	1970-05-01	1970-05-01 00:00:00	\N	\N	32020		\N	234504	0	53741008	317576		0
70303	4165	40481087	1946-03-20	1946-03-20 00:00:00	1946-03-27	1946-03-27 00:00:00	32020		\N	276743	0	444814009	40481087		0
81031	4807	28060	1961-04-05	1961-04-05 00:00:00	1961-04-13	1961-04-13 00:00:00	32020		\N	319788	0	43878008	28060		0
81176	4814	4152936	1970-07-29	1970-07-29 00:00:00	1970-08-19	1970-08-19 00:00:00	32020		\N	320247	0	283385000	4152936		0
70763	4199	372328	1963-01-17	1963-01-17 00:00:00	1963-05-16	1963-05-16 00:00:00	32020		\N	278621	0	65363002	372328		0
70893	4205	80180	2011-01-13	2011-01-13 00:00:00	\N	\N	32020		\N	279251	0	396275006	80180		0
60507	3577	257012	2007-08-21	2007-08-21 00:00:00	\N	\N	32020		\N	237799	0	40055000	257012		0
71247	4225	78272	2002-09-01	2002-09-01 00:00:00	2002-10-06	2002-10-06 00:00:00	32020		\N	280593	0	70704007	78272		0
60895	3604	4112343	2014-12-09	2014-12-09 00:00:00	2014-12-22	2014-12-22 00:00:00	32020		\N	239552	0	195662009	4112343		0
71606	4247	4296205	2013-08-20	2013-08-20 00:00:00	2013-09-10	2013-09-10 00:00:00	32020		\N	282013	0	403191005	4296205		0
61253	3622	28060	1925-09-08	1925-09-08 00:00:00	1925-09-20	1925-09-20 00:00:00	32020		\N	240774	0	43878008	28060		0
61406	3628	4112343	1952-10-28	1952-10-28 00:00:00	1952-11-07	1952-11-07 00:00:00	32020		\N	241370	0	195662009	4112343		0
61561	3637	4027663	1989-07-13	1989-07-13 00:00:00	\N	\N	32020		\N	241886	0	13200003	4027663		0
61665	3641	4112343	1913-10-30	1913-10-30 00:00:00	1913-11-10	1913-11-10 00:00:00	32020		\N	242253	0	195662009	4112343		0
72495	4305	375671	1978-10-17	1978-10-17 00:00:00	1978-12-16	1978-12-16 00:00:00	32020		\N	285659	0	62564004	375671		0
72630	4313	4001336	1963-01-08	1963-01-08 00:00:00	1963-02-07	1963-02-07 00:00:00	32020		\N	286272	0	110030002	4001336		0
72745	4324	40481087	1992-08-19	1992-08-19 00:00:00	1992-08-26	1992-08-26 00:00:00	32020		\N	286811	0	444814009	40481087		0
83509	4963	4112343	1994-10-27	1994-10-27 00:00:00	1994-11-05	1994-11-05 00:00:00	32020		\N	329938	0	195662009	4112343		0
73099	4343	40479422	1958-07-29	1958-07-29 00:00:00	1958-10-04	1958-10-04 00:00:00	32020		\N	288076	0	444448004	40479422		0
62729	3703	81151	1969-12-18	1969-12-18 00:00:00	1970-01-08	1970-01-08 00:00:00	32020		\N	246252	0	44465007	81151		0
73462	4366	81151	2003-09-26	2003-09-26 00:00:00	2003-10-24	2003-10-24 00:00:00	32020		\N	289598	0	44465007	81151		0
63026	3721	4294548	2005-01-07	2005-01-07 00:00:00	2005-05-13	2005-05-13 00:00:00	32020		\N	247336	0	75498004	4294548		0
73819	4384	4109685	1968-03-12	1968-03-12 00:00:00	1968-03-26	1968-03-26 00:00:00	32020		\N	291361	0	284551006	4109685		0
73968	4393	260139	2000-08-02	2000-08-02 00:00:00	2000-08-09	2000-08-09 00:00:00	32020		\N	292088	0	10509002	260139		0
74132	4403	260139	1986-04-20	1986-04-20 00:00:00	1986-04-27	1986-04-27 00:00:00	32020		\N	292722	0	10509002	260139		0
74342	4413	4029498	1996-11-29	1996-11-29 00:00:00	\N	\N	32020		\N	293419	0	128613002	4029498		0
63838	3771	4218389	1989-06-18	1989-06-18 00:00:00	1989-07-23	1989-07-23 00:00:00	32020		\N	250622	0	39848009	4218389		0
64055	3784	40481087	1975-11-01	1975-11-01 00:00:00	1975-11-15	1975-11-15 00:00:00	32020		\N	251510	0	444814009	40481087		0
64140	3788	28060	1965-02-10	1965-02-10 00:00:00	1965-02-21	1965-02-21 00:00:00	32020		\N	251840	0	43878008	28060		0
64256	3793	4112343	2004-10-05	2004-10-05 00:00:00	2004-10-17	2004-10-17 00:00:00	32020		\N	252235	0	195662009	4112343		0
53926	3191	40481087	1996-06-12	1996-06-12 00:00:00	1996-06-26	1996-06-26 00:00:00	32020		\N	212346	0	444814009	40481087		0
64667	3823	40481087	1979-08-27	1979-08-27 00:00:00	1979-09-17	1979-09-17 00:00:00	32020		\N	253949	0	444814009	40481087		0
54224	3214	378001	1985-08-17	1985-08-17 00:00:00	1985-10-16	1985-10-16 00:00:00	32020		\N	213495	0	62106007	378001		0
64921	3839	40481087	1970-10-29	1970-10-29 00:00:00	1970-11-05	1970-11-05 00:00:00	32020		\N	254916	0	444814009	40481087		0
54577	3231	260139	1954-07-12	1954-07-12 00:00:00	1954-07-26	1954-07-26 00:00:00	32020		\N	214769	0	10509002	260139		0
54780	3241	40481087	1982-10-05	1982-10-05 00:00:00	1982-10-12	1982-10-12 00:00:00	32020		\N	215566	0	444814009	40481087		0
65414	3869	78272	1950-09-28	1950-09-28 00:00:00	1950-10-12	1950-10-12 00:00:00	32020		\N	256842	0	70704007	78272		0
65697	3885	260139	1987-09-19	1987-09-19 00:00:00	1987-09-26	1987-09-26 00:00:00	32020		\N	258213	0	10509002	260139		0
65879	3895	40481087	2016-09-26	2016-09-26 00:00:00	2016-10-17	2016-10-17 00:00:00	32020		\N	259129	0	444814009	40481087		0
65938	3899	4112343	1988-01-17	1988-01-17 00:00:00	1988-01-29	1988-01-29 00:00:00	32020		\N	259266	0	195662009	4112343		0
66102	3909	40481087	2016-12-26	2016-12-26 00:00:00	2017-01-16	2017-01-16 00:00:00	32020		\N	259870	0	444814009	40481087		0
66306	3926	28060	2012-06-19	2012-06-19 00:00:00	2012-07-02	2012-07-02 00:00:00	32020		\N	260986	0	43878008	28060		0
55914	3311	4155034	1965-11-13	1965-11-13 00:00:00	1965-12-04	1965-12-04 00:00:00	32020		\N	219796	0	283371005	4155034		0
66729	3949	4278672	1980-01-19	1980-01-19 00:00:00	1980-03-19	1980-03-19 00:00:00	32020		\N	262519	0	65966004	4278672		0
66790	3951	4283893	2004-07-22	2004-07-22 00:00:00	2004-09-16	2004-09-16 00:00:00	32020		\N	262622	0	36971009	4283893		0
66962	3960	80180	1997-05-21	1997-05-21 00:00:00	\N	\N	32020		\N	263272	0	396275006	80180		0
67104	3967	4112343	1994-12-14	1994-12-14 00:00:00	1994-12-25	1994-12-25 00:00:00	32020		\N	263765	0	195662009	4112343		0
77892	4615	4112343	2003-01-02	2003-01-02 00:00:00	2003-01-15	2003-01-15 00:00:00	32020		\N	307424	0	195662009	4112343		0
67466	3987	81151	1993-01-21	1993-01-21 00:00:00	1993-02-18	1993-02-18 00:00:00	32020		\N	265028	0	44465007	81151		0
67588	3993	40481087	1963-01-17	1963-01-17 00:00:00	1963-02-07	1963-02-07 00:00:00	32020		\N	265481	0	444814009	40481087		0
57259	3397	260139	1952-04-07	1952-04-07 00:00:00	1952-04-21	1952-04-21 00:00:00	32020		\N	225334	0	10509002	260139		0
67973	4017	40481087	1995-07-29	1995-07-29 00:00:00	1995-08-19	1995-08-19 00:00:00	32020		\N	266967	0	444814009	40481087		0
68085	4021	4112343	1987-10-03	1987-10-03 00:00:00	1987-10-11	1987-10-11 00:00:00	32020		\N	267293	0	195662009	4112343		0
68309	4035	4112343	1986-11-04	1986-11-04 00:00:00	1986-11-15	1986-11-15 00:00:00	32020		\N	268470	0	195662009	4112343		0
68439	4045	80180	2015-04-27	2015-04-27 00:00:00	\N	\N	32020		\N	269007	0	396275006	80180		0
68575	4055	4112343	2001-10-26	2001-10-26 00:00:00	2001-11-03	2001-11-03 00:00:00	32020		\N	269538	0	195662009	4112343		0
68809	4072	260139	2010-10-28	2010-10-28 00:00:00	2010-11-11	2010-11-11 00:00:00	32020		\N	270671	0	10509002	260139		0
58370	3457	40481087	1947-07-12	1947-07-12 00:00:00	1947-07-26	1947-07-26 00:00:00	32020		\N	229405	0	444814009	40481087		0
69066	4087	80180	2018-01-27	2018-01-27 00:00:00	\N	\N	32020		\N	271679	0	396275006	80180		0
69382	4106	4310024	1982-01-18	1982-01-18 00:00:00	\N	\N	32020		\N	272825	0	424802006	4310024		0
58841	3490	40481087	1952-01-11	1952-01-11 00:00:00	1952-01-25	1952-01-25 00:00:00	32020		\N	231621	0	444814009	40481087		0
59061	3505	4112343	2014-01-05	2014-01-05 00:00:00	2014-01-16	2014-01-16 00:00:00	32020		\N	232483	0	195662009	4112343		0
69834	4131	378001	1982-06-10	1982-06-10 00:00:00	1982-08-09	1982-08-09 00:00:00	32020		\N	274667	0	62106007	378001		0
80557	4773	40481087	1970-07-31	1970-07-31 00:00:00	1970-08-14	1970-08-14 00:00:00	32020		\N	317847	0	444814009	40481087		0
59547	3530	378001	1970-11-13	1970-11-13 00:00:00	1971-01-12	1971-01-12 00:00:00	32020		\N	234454	0	62106007	378001		0
70304	4165	40481087	1983-06-25	1983-06-25 00:00:00	1983-07-16	1983-07-16 00:00:00	32020		\N	276709	0	444814009	40481087		0
81032	4807	260139	1988-07-27	1988-07-27 00:00:00	1988-08-10	1988-08-10 00:00:00	32020		\N	319799	0	10509002	260139		0
81177	4814	28060	1944-07-28	1944-07-28 00:00:00	1944-08-09	1944-08-09 00:00:00	32020		\N	320302	0	43878008	28060		0
70764	4199	257012	2016-05-19	2016-05-19 00:00:00	\N	\N	32020		\N	278671	0	40055000	257012		0
70894	4205	81893	2008-12-24	2008-12-24 00:00:00	\N	\N	32020		\N	279223	0	64766004	81893		0
60508	3577	4112343	2015-02-18	2015-02-18 00:00:00	2015-03-01	2015-03-01 00:00:00	32020		\N	237803	0	195662009	4112343		0
71248	4225	28060	1991-08-01	1991-08-01 00:00:00	1991-08-10	1991-08-10 00:00:00	32020		\N	280615	0	43878008	28060		0
60896	3604	372328	1987-08-08	1987-08-08 00:00:00	1987-10-09	1987-10-09 00:00:00	32020		\N	239564	0	65363002	372328		0
71607	4247	80180	2018-03-30	2018-03-30 00:00:00	\N	\N	32020		\N	282009	0	396275006	80180		0
79192	4689	4027663	1996-05-02	1996-05-02 00:00:00	\N	\N	32020		\N	312393	0	13200003	4027663		0
61254	3622	40481087	1996-06-03	1996-06-03 00:00:00	1996-06-10	1996-06-10 00:00:00	32020		\N	240664	0	444814009	40481087		0
61407	3628	80180	1954-03-07	1954-03-07 00:00:00	\N	\N	32020		\N	241370	0	396275006	80180		0
61562	3637	4109685	1989-03-15	1989-03-15 00:00:00	1989-03-29	1989-03-29 00:00:00	32020		\N	241886	0	284551006	4109685		0
61666	3641	40481087	1929-07-11	1929-07-11 00:00:00	1929-07-18	1929-07-18 00:00:00	32020		\N	242336	0	444814009	40481087		0
72496	4305	4112343	2014-03-06	2014-03-06 00:00:00	2014-03-17	2014-03-17 00:00:00	32020		\N	285532	0	195662009	4112343		0
72650	4317	260139	2012-03-19	2012-03-19 00:00:00	2012-04-02	2012-04-02 00:00:00	32020		\N	286502	0	10509002	260139		0
72746	4324	40481087	2004-02-16	2004-02-16 00:00:00	2004-03-01	2004-03-01 00:00:00	32020		\N	286842	0	444814009	40481087		0
83510	4963	260139	1980-10-29	1980-10-29 00:00:00	1980-11-05	1980-11-05 00:00:00	32020		\N	329962	0	10509002	260139		0
73100	4343	260139	1955-07-17	1955-07-17 00:00:00	1955-07-31	1955-07-31 00:00:00	32020		\N	287987	0	10509002	260139		0
62730	3703	4218389	1973-08-04	1973-08-04 00:00:00	1973-09-08	1973-09-08 00:00:00	32020		\N	246254	0	39848009	4218389		0
73505	4370	40481087	2002-03-29	2002-03-29 00:00:00	2002-04-19	2002-04-19 00:00:00	32020		\N	290143	0	444814009	40481087		0
63027	3721	28060	2015-02-13	2015-02-13 00:00:00	2015-02-23	2015-02-23 00:00:00	32020		\N	247329	0	43878008	28060		0
73820	4384	372328	1968-02-11	1968-02-11 00:00:00	1968-03-25	1968-03-25 00:00:00	32020		\N	291407	0	65363002	372328		0
73969	4393	4112343	1998-08-02	1998-08-02 00:00:00	1998-08-11	1998-08-11 00:00:00	32020		\N	292104	0	195662009	4112343		0
74133	4403	40481087	1981-10-31	1981-10-31 00:00:00	1981-11-07	1981-11-07 00:00:00	32020		\N	292668	0	444814009	40481087		0
74344	4413	260139	2013-06-21	2013-06-21 00:00:00	2013-07-05	2013-07-05 00:00:00	32020		\N	293492	0	10509002	260139		0
63839	3771	28060	1972-05-19	1972-05-19 00:00:00	1972-05-26	1972-05-26 00:00:00	32020		\N	250611	0	43878008	28060		0
64056	3784	40481087	1972-09-06	1972-09-06 00:00:00	1972-09-13	1972-09-13 00:00:00	32020		\N	251499	0	444814009	40481087		0
64141	3788	28060	1997-11-24	1997-11-24 00:00:00	1997-12-07	1997-12-07 00:00:00	32020		\N	251820	0	43878008	28060		0
64257	3793	378001	1964-04-16	1964-04-16 00:00:00	1964-06-15	1964-06-15 00:00:00	32020		\N	252278	0	62106007	378001		0
53927	3191	260139	2013-10-08	2013-10-08 00:00:00	2013-10-15	2013-10-15 00:00:00	32020		\N	212337	0	10509002	260139		0
64668	3823	4059173	1959-05-20	1959-05-20 00:00:00	1959-06-19	1959-06-19 00:00:00	32020		\N	253972	0	16114001	4059173		0
54225	3214	4112343	2016-09-14	2016-09-14 00:00:00	2016-09-24	2016-09-24 00:00:00	32020		\N	213527	0	195662009	4112343		0
64922	3839	40481087	1952-02-08	1952-02-08 00:00:00	1952-02-29	1952-02-29 00:00:00	32020		\N	254905	0	444814009	40481087		0
54578	3231	260139	1966-04-16	1966-04-16 00:00:00	1966-04-30	1966-04-30 00:00:00	32020		\N	214770	0	10509002	260139		0
65241	3859	4059173	1995-10-23	1995-10-23 00:00:00	1996-01-21	1996-01-21 00:00:00	32020		\N	256267	0	16114001	4059173		0
65415	3869	40481087	1955-01-22	1955-01-22 00:00:00	1955-02-05	1955-02-05 00:00:00	32020		\N	256910	0	444814009	40481087		0
65698	3885	260139	2005-09-19	2005-09-19 00:00:00	2005-09-26	2005-09-26 00:00:00	32020		\N	258258	0	10509002	260139		0
65880	3895	40481087	2019-03-13	2019-03-13 00:00:00	2019-04-03	2019-04-03 00:00:00	32020		\N	259107	0	444814009	40481087		0
65939	3899	4112343	2012-12-14	2012-12-14 00:00:00	2012-12-21	2012-12-21 00:00:00	32020		\N	259268	0	195662009	4112343		0
66118	3913	257012	1966-11-23	1966-11-23 00:00:00	\N	\N	32020		\N	260110	0	40055000	257012		0
66307	3926	40481087	1954-07-15	1954-07-15 00:00:00	1954-07-22	1954-07-22 00:00:00	32020		\N	260981	0	444814009	40481087		0
55939	3313	40481087	1992-04-23	1992-04-23 00:00:00	1992-04-30	1992-04-30 00:00:00	32020		\N	219980	0	444814009	40481087		0
66730	3949	4112343	1992-12-22	1992-12-22 00:00:00	1993-01-03	1993-01-03 00:00:00	32020		\N	262509	0	195662009	4112343		0
66791	3951	260139	2014-03-09	2014-03-09 00:00:00	2014-03-16	2014-03-16 00:00:00	32020		\N	262644	0	10509002	260139		0
66963	3960	40481087	1969-12-20	1969-12-20 00:00:00	1970-01-03	1970-01-03 00:00:00	32020		\N	263270	0	444814009	40481087		0
67105	3967	195588	2000-04-21	2000-04-21 00:00:00	2000-06-10	2000-06-10 00:00:00	32020		\N	263768	0	38822007	195588		0
77893	4615	260139	1963-08-08	1963-08-08 00:00:00	1963-08-15	1963-08-15 00:00:00	32020		\N	307421	0	10509002	260139		0
67467	3987	40481087	2007-06-19	2007-06-19 00:00:00	2007-07-03	2007-07-03 00:00:00	32020		\N	265044	0	444814009	40481087		0
67589	3993	40481087	2012-12-31	2012-12-31 00:00:00	2013-01-14	2013-01-14 00:00:00	32020		\N	265486	0	444814009	40481087		0
57260	3397	4109685	1973-03-17	1973-03-17 00:00:00	1973-03-31	1973-03-31 00:00:00	32020		\N	225349	0	284551006	4109685		0
67974	4017	40481087	2012-11-01	2012-11-01 00:00:00	2012-11-22	2012-11-22 00:00:00	32020		\N	266977	0	444814009	40481087		0
68086	4021	40481087	1963-05-27	1963-05-27 00:00:00	1963-06-03	1963-06-03 00:00:00	32020		\N	267312	0	444814009	40481087		0
68310	4035	4112343	2018-04-02	2018-04-02 00:00:00	2018-04-11	2018-04-11 00:00:00	32020		\N	268493	0	195662009	4112343		0
68440	4045	260139	1982-03-07	1982-03-07 00:00:00	1982-03-21	1982-03-21 00:00:00	32020		\N	269040	0	10509002	260139		0
68576	4055	4112343	1995-02-06	1995-02-06 00:00:00	1995-02-13	1995-02-13 00:00:00	32020		\N	269527	0	195662009	4112343		0
68810	4072	4112343	2006-01-24	2006-01-24 00:00:00	2006-02-03	2006-02-03 00:00:00	32020		\N	270670	0	195662009	4112343		0
58371	3457	4294548	1981-03-30	1981-03-30 00:00:00	1981-05-25	1981-05-25 00:00:00	32020		\N	229330	0	75498004	4294548		0
69067	4087	28060	1985-11-08	1985-11-08 00:00:00	1985-11-19	1985-11-19 00:00:00	32020		\N	271645	0	43878008	28060		0
69383	4106	30753	1982-12-14	1982-12-14 00:00:00	\N	\N	32020		\N	272825	0	16761005	30753		0
58842	3490	40481087	1978-08-04	1978-08-04 00:00:00	1978-08-11	1978-08-11 00:00:00	32020		\N	231573	0	444814009	40481087		0
59062	3505	40481087	2001-11-13	2001-11-13 00:00:00	2001-11-20	2001-11-20 00:00:00	32020		\N	232432	0	444814009	40481087		0
69835	4131	40481087	1984-04-07	1984-04-07 00:00:00	1984-04-14	1984-04-14 00:00:00	32020		\N	274691	0	444814009	40481087		0
80558	4773	40481087	1963-06-29	1963-06-29 00:00:00	1963-07-06	1963-07-06 00:00:00	32020		\N	317869	0	444814009	40481087		0
59548	3530	40481087	1994-04-12	1994-04-12 00:00:00	1994-05-03	1994-05-03 00:00:00	32020		\N	234500	0	444814009	40481087		0
70305	4165	260139	1992-02-08	1992-02-08 00:00:00	1992-02-15	1992-02-15 00:00:00	32020		\N	276722	0	10509002	260139		0
81033	4807	80180	1981-03-10	1981-03-10 00:00:00	\N	\N	32020		\N	319833	0	396275006	80180		0
81178	4814	4296204	2010-12-13	2010-12-13 00:00:00	2010-12-27	2010-12-27 00:00:00	32020		\N	320250	0	403190006	4296204		0
70765	4199	4237458	1940-02-17	1940-02-17 00:00:00	1940-05-17	1940-05-17 00:00:00	32020		\N	278705	0	58150001	4237458		0
70895	4205	40481087	2008-06-15	2008-06-15 00:00:00	2008-06-22	2008-06-22 00:00:00	32020		\N	279223	0	444814009	40481087		0
60509	3577	4112343	1993-07-13	1993-07-13 00:00:00	1993-07-20	1993-07-20 00:00:00	32020		\N	237793	0	195662009	4112343		0
71249	4225	372328	1983-04-28	1983-04-28 00:00:00	1984-03-15	1984-03-15 00:00:00	32020		\N	280617	0	65363002	372328		0
60897	3604	260139	1993-02-17	1993-02-17 00:00:00	1993-03-03	1993-03-03 00:00:00	32020		\N	239475	0	10509002	260139		0
71608	4247	4218389	1991-08-04	1991-08-04 00:00:00	1991-08-25	1991-08-25 00:00:00	32020		\N	282010	0	39848009	4218389		0
71713	4255	28060	1984-08-14	1984-08-14 00:00:00	1984-08-21	1984-08-21 00:00:00	32020		\N	282507	0	43878008	28060		0
61408	3628	40481087	1955-06-08	1955-06-08 00:00:00	1955-06-29	1955-06-29 00:00:00	32020		\N	241359	0	444814009	40481087		0
61563	3637	260139	1991-05-20	1991-05-20 00:00:00	1991-05-28	1991-05-28 00:00:00	32020		\N	241901	0	10509002	260139		0
61667	3641	78272	1947-06-27	1947-06-27 00:00:00	1947-07-18	1947-07-18 00:00:00	32020		\N	242312	0	70704007	78272		0
72497	4305	4112343	1975-02-08	1975-02-08 00:00:00	1975-02-17	1975-02-17 00:00:00	32020		\N	285560	0	195662009	4112343		0
72651	4317	4112343	1987-07-02	1987-07-02 00:00:00	1987-07-13	1987-07-13 00:00:00	32020		\N	286501	0	195662009	4112343		0
79363	4700	80180	1990-10-24	1990-10-24 00:00:00	\N	\N	32020		\N	313089	0	396275006	80180		0
72747	4324	260139	2016-07-17	2016-07-17 00:00:00	2016-07-31	2016-07-31 00:00:00	32020		\N	286830	0	10509002	260139		0
83511	4963	40481087	2013-01-11	2013-01-11 00:00:00	2013-01-25	2013-01-25 00:00:00	32020		\N	329940	0	444814009	40481087		0
73101	4343	4112343	2017-01-18	2017-01-18 00:00:00	2017-01-31	2017-01-31 00:00:00	32020		\N	288036	0	195662009	4112343		0
62731	3703	4112343	2016-07-22	2016-07-22 00:00:00	2016-07-29	2016-07-29 00:00:00	32020		\N	246298	0	195662009	4112343		0
73506	4370	80180	1999-03-24	1999-03-24 00:00:00	\N	\N	32020		\N	290137	0	396275006	80180		0
63028	3721	257012	2005-02-18	2005-02-18 00:00:00	\N	\N	32020		\N	247328	0	40055000	257012		0
73821	4384	372328	1982-01-12	1982-01-12 00:00:00	1982-11-15	1982-11-15 00:00:00	32020		\N	291408	0	65363002	372328		0
73970	4393	40481087	1999-11-02	1999-11-02 00:00:00	1999-11-23	1999-11-23 00:00:00	32020		\N	292117	0	444814009	40481087		0
74134	4403	257012	1948-01-01	1948-01-01 00:00:00	\N	\N	32020		\N	292638	0	40055000	257012		0
74345	4413	372328	1964-02-03	1964-02-03 00:00:00	1964-04-09	1964-04-09 00:00:00	32020		\N	293467	0	65363002	372328		0
63840	3771	40481087	1967-06-18	1967-06-18 00:00:00	1967-06-25	1967-06-25 00:00:00	32020		\N	250631	0	444814009	40481087		0
64057	3784	260139	1956-07-02	1956-07-02 00:00:00	1956-07-16	1956-07-16 00:00:00	32020		\N	251455	0	10509002	260139		0
64142	3788	4112343	1965-10-23	1965-10-23 00:00:00	1965-11-02	1965-11-02 00:00:00	32020		\N	251836	0	195662009	4112343		0
64258	3793	4027663	1971-04-24	1971-04-24 00:00:00	\N	\N	32020		\N	252212	0	13200003	4027663		0
53937	3194	260139	1968-01-02	1968-01-02 00:00:00	1968-01-09	1968-01-09 00:00:00	32020		\N	212455	0	10509002	260139		0
64669	3823	78272	2014-10-19	2014-10-19 00:00:00	2014-11-23	2014-11-23 00:00:00	32020		\N	253975	0	70704007	78272		0
54226	3214	192671	2009-01-25	2009-01-25 00:00:00	\N	\N	32020		\N	213499	0	K92.2	35208414		0
64923	3839	4134304	1951-10-18	1951-10-18 00:00:00	1951-12-17	1951-12-17 00:00:00	32020		\N	254857	0	263102004	4134304		0
54579	3231	372328	2010-03-19	2010-03-19 00:00:00	2010-07-29	2010-07-29 00:00:00	32020		\N	214761	0	65363002	372328		0
65242	3859	260139	1949-08-25	1949-08-25 00:00:00	1949-09-08	1949-09-08 00:00:00	32020		\N	256205	0	10509002	260139		0
65416	3869	4278672	1980-12-03	1980-12-03 00:00:00	1981-03-03	1981-03-03 00:00:00	32020		\N	256844	0	65966004	4278672		0
65699	3885	4113008	1995-02-11	1995-02-11 00:00:00	1995-03-04	1995-03-04 00:00:00	32020		\N	258218	0	284549007	4113008		0
65881	3895	40481087	1978-02-23	1978-02-23 00:00:00	1978-03-09	1978-03-09 00:00:00	32020		\N	259088	0	444814009	40481087		0
65940	3899	81151	1985-05-31	1985-05-31 00:00:00	1985-06-28	1985-06-28 00:00:00	32020		\N	259247	0	44465007	81151		0
66119	3913	4112343	2006-08-22	2006-08-22 00:00:00	2006-08-29	2006-08-29 00:00:00	32020		\N	260187	0	195662009	4112343		0
66308	3926	40481087	1987-01-21	1987-01-21 00:00:00	1987-02-11	1987-02-11 00:00:00	32020		\N	260984	0	444814009	40481087		0
55940	3313	260139	1971-10-17	1971-10-17 00:00:00	1971-10-24	1971-10-24 00:00:00	32020		\N	219978	0	10509002	260139		0
66731	3949	4112343	2011-08-12	2011-08-12 00:00:00	2011-08-25	2011-08-25 00:00:00	32020		\N	262462	0	195662009	4112343		0
66792	3951	40481087	2004-04-24	2004-04-24 00:00:00	2004-05-15	2004-05-15 00:00:00	32020		\N	262628	0	444814009	40481087		0
66964	3960	4112343	2014-02-10	2014-02-10 00:00:00	2014-02-19	2014-02-19 00:00:00	32020		\N	263255	0	195662009	4112343		0
67107	3967	4027663	1994-04-23	1994-04-23 00:00:00	\N	\N	32020		\N	263743	0	13200003	4027663		0
77894	4615	4112343	1995-09-25	1995-09-25 00:00:00	1995-10-08	1995-10-08 00:00:00	32020		\N	307406	0	195662009	4112343		0
67468	3987	40481087	1974-08-05	1974-08-05 00:00:00	1974-08-12	1974-08-12 00:00:00	32020		\N	265031	0	444814009	40481087		0
67590	3993	4152936	1999-03-13	1999-03-13 00:00:00	1999-04-03	1999-04-03 00:00:00	32020		\N	265522	0	283385000	4152936		0
57261	3397	260139	1954-01-06	1954-01-06 00:00:00	1954-01-20	1954-01-20 00:00:00	32020		\N	225323	0	10509002	260139		0
67975	4017	40481087	2013-11-22	2013-11-22 00:00:00	2013-12-13	2013-12-13 00:00:00	32020		\N	266978	0	444814009	40481087		0
68087	4021	81151	2016-06-21	2016-06-21 00:00:00	2016-07-05	2016-07-05 00:00:00	32020		\N	267349	0	44465007	81151		0
68311	4035	40481087	1995-06-11	1995-06-11 00:00:00	1995-07-02	1995-07-02 00:00:00	32020		\N	268460	0	444814009	40481087		0
68441	4045	40481087	1977-09-19	1977-09-19 00:00:00	1977-10-10	1977-10-10 00:00:00	32020		\N	269013	0	444814009	40481087		0
68577	4055	4112343	2007-05-20	2007-05-20 00:00:00	2007-06-02	2007-06-02 00:00:00	32020		\N	269510	0	195662009	4112343		0
68811	4072	260139	2002-11-10	2002-11-10 00:00:00	2002-11-17	2002-11-17 00:00:00	32020		\N	270696	0	10509002	260139		0
58372	3457	4112343	2005-08-06	2005-08-06 00:00:00	2005-08-18	2005-08-18 00:00:00	32020		\N	229327	0	195662009	4112343		0
69068	4087	4134304	2013-12-03	2013-12-03 00:00:00	2014-02-01	2014-02-01 00:00:00	32020		\N	271643	0	263102004	4134304		0
69384	4106	81893	1982-08-16	1982-08-16 00:00:00	\N	\N	32020		\N	272825	0	64766004	81893		0
58843	3490	40481087	2002-07-28	2002-07-28 00:00:00	2002-08-18	2002-08-18 00:00:00	32020		\N	231598	0	444814009	40481087		0
59063	3505	257012	1948-12-22	1948-12-22 00:00:00	\N	\N	32020		\N	232424	0	40055000	257012		0
69836	4131	4112343	2000-05-02	2000-05-02 00:00:00	2000-05-09	2000-05-09 00:00:00	32020		\N	274714	0	195662009	4112343		0
80559	4773	372328	1964-05-27	1964-05-27 00:00:00	1964-10-15	1964-10-15 00:00:00	32020		\N	317872	0	65363002	372328		0
59549	3530	80180	1995-04-30	1995-04-30 00:00:00	\N	\N	32020		\N	234500	0	396275006	80180		0
70306	4165	40481087	2011-06-11	2011-06-11 00:00:00	2011-07-02	2011-07-02 00:00:00	32020		\N	276710	0	444814009	40481087		0
81034	4807	4283893	1958-12-15	1958-12-15 00:00:00	1959-09-14	1959-09-14 00:00:00	32020		\N	319784	0	36971009	4283893		0
81179	4814	4237458	1939-04-26	1939-04-26 00:00:00	1939-05-26	1939-05-26 00:00:00	32020		\N	320292	0	58150001	4237458		0
70766	4199	40481087	2012-06-30	2012-06-30 00:00:00	2012-07-14	2012-07-14 00:00:00	32020		\N	278692	0	444814009	40481087		0
70896	4206	4048695	1993-04-12	1993-04-12 00:00:00	1993-06-13	1993-06-13 00:00:00	32020		\N	279334	0	15724005	4048695		0
60510	3578	260139	1998-01-20	1998-01-20 00:00:00	1998-02-03	1998-02-03 00:00:00	32020		\N	237853	0	10509002	260139		0
71250	4225	4112343	1996-12-15	1996-12-15 00:00:00	1996-12-28	1996-12-28 00:00:00	32020		\N	280616	0	195662009	4112343		0
60898	3604	40481087	1987-11-23	1987-11-23 00:00:00	1987-11-30	1987-11-30 00:00:00	32020		\N	239540	0	444814009	40481087		0
71609	4247	78272	1993-07-15	1993-07-15 00:00:00	1993-08-05	1993-08-05 00:00:00	32020		\N	282011	0	70704007	78272		0
71714	4255	4112343	1984-02-03	1984-02-03 00:00:00	1984-02-14	1984-02-14 00:00:00	32020		\N	282539	0	195662009	4112343		0
61409	3628	260139	1965-10-25	1965-10-25 00:00:00	1965-11-01	1965-11-01 00:00:00	32020		\N	241361	0	10509002	260139		0
61564	3637	40481087	1990-01-25	1990-01-25 00:00:00	1990-02-08	1990-02-08 00:00:00	32020		\N	241901	0	444814009	40481087		0
61668	3641	40481087	1993-08-12	1993-08-12 00:00:00	1993-08-19	1993-08-19 00:00:00	32020		\N	242270	0	444814009	40481087		0
72498	4305	28060	1984-08-31	1984-08-31 00:00:00	1984-09-09	1984-09-09 00:00:00	32020		\N	285575	0	43878008	28060		0
72652	4317	4237458	1961-11-19	1961-11-19 00:00:00	1961-12-19	1961-12-19 00:00:00	32020		\N	286477	0	58150001	4237458		0
72748	4324	40481087	2015-10-10	2015-10-10 00:00:00	2015-10-24	2015-10-24 00:00:00	32020		\N	286843	0	444814009	40481087		0
83512	4963	260139	2011-12-24	2011-12-24 00:00:00	2011-12-31	2011-12-31 00:00:00	32020		\N	329908	0	10509002	260139		0
73102	4343	4283893	1997-04-17	1997-04-17 00:00:00	1997-10-02	1997-10-02 00:00:00	32020		\N	288011	0	36971009	4283893		0
62732	3703	372328	1970-11-21	1970-11-21 00:00:00	1971-05-01	1971-05-01 00:00:00	32020		\N	246233	0	65363002	372328		0
73507	4370	260139	1993-05-17	1993-05-17 00:00:00	1993-05-24	1993-05-24 00:00:00	32020		\N	290129	0	10509002	260139		0
63029	3721	40481087	1972-07-21	1972-07-21 00:00:00	1972-07-28	1972-07-28 00:00:00	32020		\N	247325	0	444814009	40481087		0
73822	4384	4084167	1976-03-31	1976-03-31 00:00:00	1976-03-31	1976-03-31 00:00:00	32020		\N	291363	0	241929008	4084167		0
73971	4393	4134304	2016-08-28	2016-08-28 00:00:00	2016-09-27	2016-09-27 00:00:00	32020		\N	292102	0	263102004	4134304		0
74135	4403	40481087	1955-05-09	1955-05-09 00:00:00	1955-05-23	1955-05-23 00:00:00	32020		\N	292720	0	444814009	40481087		0
74346	4413	4094814	1969-01-25	1969-01-25 00:00:00	1969-02-24	1969-02-24 00:00:00	32020		\N	293468	0	262574004	4094814		0
63841	3771	40481087	1982-03-12	1982-03-12 00:00:00	1982-03-19	1982-03-19 00:00:00	32020		\N	250587	0	444814009	40481087		0
64058	3784	40481087	1954-05-10	1954-05-10 00:00:00	1954-05-24	1954-05-24 00:00:00	32020		\N	251454	0	444814009	40481087		0
64143	3788	260139	1968-12-19	1968-12-19 00:00:00	1968-12-26	1968-12-26 00:00:00	32020		\N	251837	0	10509002	260139		0
64259	3793	4113008	1959-05-22	1959-05-22 00:00:00	1959-06-12	1959-06-12 00:00:00	32020		\N	252277	0	284549007	4113008		0
53938	3194	372328	1944-11-01	1944-11-01 00:00:00	1944-11-15	1944-11-15 00:00:00	32020		\N	212491	0	65363002	372328		0
64670	3823	4283893	2010-12-12	2010-12-12 00:00:00	2011-02-20	2011-02-20 00:00:00	32020		\N	253951	0	36971009	4283893		0
54227	3214	260139	2003-12-31	2003-12-31 00:00:00	2004-01-07	2004-01-07 00:00:00	32020		\N	213550	0	10509002	260139		0
64924	3839	81151	1970-08-09	1970-08-09 00:00:00	1970-09-13	1970-09-13 00:00:00	32020		\N	254860	0	44465007	81151		0
54580	3231	4294548	2012-02-04	2012-02-04 00:00:00	2012-02-25	2012-02-25 00:00:00	32020		\N	214779	0	75498004	4294548		0
65243	3859	40481087	1990-02-14	1990-02-14 00:00:00	1990-02-21	1990-02-21 00:00:00	32020		\N	256273	0	444814009	40481087		0
65417	3869	4112343	1919-05-27	1919-05-27 00:00:00	1919-06-07	1919-06-07 00:00:00	32020		\N	256891	0	195662009	4112343		0
65700	3885	40481087	1972-09-14	1972-09-14 00:00:00	1972-10-05	1972-10-05 00:00:00	32020		\N	258255	0	444814009	40481087		0
65882	3895	260139	1963-07-29	1963-07-29 00:00:00	1963-08-05	1963-08-05 00:00:00	32020		\N	259050	0	10509002	260139		0
65941	3899	4112343	1993-11-01	1993-11-01 00:00:00	1993-11-09	1993-11-09 00:00:00	32020		\N	259288	0	195662009	4112343		0
66120	3913	40481087	1998-07-13	1998-07-13 00:00:00	1998-07-20	1998-07-20 00:00:00	32020		\N	260186	0	444814009	40481087		0
66309	3926	80180	1988-01-07	1988-01-07 00:00:00	\N	\N	32020		\N	260984	0	396275006	80180		0
55941	3313	40481087	1995-01-21	1995-01-21 00:00:00	1995-01-28	1995-01-28 00:00:00	32020		\N	219982	0	444814009	40481087		0
66732	3949	40481087	2011-06-03	2011-06-03 00:00:00	2011-06-10	2011-06-10 00:00:00	32020		\N	262495	0	444814009	40481087		0
66793	3951	30753	1985-05-07	1985-05-07 00:00:00	\N	\N	32020		\N	262680	0	16761005	30753		0
66965	3960	4218389	1972-12-26	1972-12-26 00:00:00	1973-01-23	1973-01-23 00:00:00	32020		\N	263312	0	39848009	4218389		0
67108	3967	40481087	2016-08-05	2016-08-05 00:00:00	2016-08-12	2016-08-12 00:00:00	32020		\N	263775	0	444814009	40481087		0
77895	4615	372328	1984-01-09	1984-01-09 00:00:00	1986-10-29	1986-10-29 00:00:00	32020		\N	307409	0	65363002	372328		0
67469	3987	4278672	2010-04-20	2010-04-20 00:00:00	2010-05-20	2010-05-20 00:00:00	32020		\N	265030	0	65966004	4278672		0
67591	3993	4112343	2004-02-07	2004-02-07 00:00:00	2004-02-15	2004-02-15 00:00:00	32020		\N	265471	0	195662009	4112343		0
57262	3397	40481087	2009-04-12	2009-04-12 00:00:00	2009-05-03	2009-05-03 00:00:00	32020		\N	225354	0	444814009	40481087		0
67976	4017	257012	1970-08-27	1970-08-27 00:00:00	\N	\N	32020		\N	266974	0	40055000	257012		0
68088	4021	78272	1958-10-14	1958-10-14 00:00:00	1958-11-18	1958-11-18 00:00:00	32020		\N	267309	0	70704007	78272		0
68312	4035	40481087	1974-08-11	1974-08-11 00:00:00	1974-08-25	1974-08-25 00:00:00	32020		\N	268459	0	444814009	40481087		0
68442	4045	28060	2003-03-19	2003-03-19 00:00:00	2003-03-27	2003-03-27 00:00:00	32020		\N	269041	0	43878008	28060		0
68578	4055	40481087	1969-02-10	1969-02-10 00:00:00	1969-03-03	1969-03-03 00:00:00	32020		\N	269515	0	444814009	40481087		0
68812	4072	40481087	1977-06-02	1977-06-02 00:00:00	1977-06-23	1977-06-23 00:00:00	32020		\N	270683	0	444814009	40481087		0
58373	3457	134438	1936-09-03	1936-09-03 00:00:00	1937-11-27	1937-11-27 00:00:00	32020		\N	229322	0	40275004	134438		0
69069	4087	260139	2010-10-13	2010-10-13 00:00:00	2010-10-20	2010-10-20 00:00:00	32020		\N	271648	0	10509002	260139		0
69385	4106	4266809	1984-02-07	1984-02-07 00:00:00	\N	\N	32020		\N	272825	0	397881000	4266809		0
58844	3490	4112343	1969-08-24	1969-08-24 00:00:00	1969-09-06	1969-09-06 00:00:00	32020		\N	231489	0	195662009	4112343		0
59064	3505	28060	2000-02-08	2000-02-08 00:00:00	2000-02-18	2000-02-18 00:00:00	32020		\N	232482	0	43878008	28060		0
69837	4131	40481087	2009-05-30	2009-05-30 00:00:00	2009-06-06	2009-06-06 00:00:00	32020		\N	274719	0	444814009	40481087		0
80576	4776	4112343	1988-10-21	1988-10-21 00:00:00	1988-11-03	1988-11-03 00:00:00	32020		\N	318006	0	195662009	4112343		0
59550	3530	257012	1993-07-04	1993-07-04 00:00:00	\N	\N	32020		\N	234478	0	40055000	257012		0
70307	4165	40481087	1994-07-26	1994-07-26 00:00:00	1994-08-16	1994-08-16 00:00:00	32020		\N	276723	0	444814009	40481087		0
81035	4807	40481087	1967-11-09	1967-11-09 00:00:00	1967-11-30	1967-11-30 00:00:00	32020		\N	319884	0	444814009	40481087		0
81180	4814	4112343	1965-04-21	1965-04-21 00:00:00	1965-05-01	1965-05-01 00:00:00	32020		\N	320253	0	195662009	4112343		0
70767	4199	4112343	1986-05-19	1986-05-19 00:00:00	1986-05-30	1986-05-30 00:00:00	32020		\N	278614	0	195662009	4112343		0
70897	4206	4112343	1968-02-12	1968-02-12 00:00:00	1968-02-22	1968-02-22 00:00:00	32020		\N	279325	0	195662009	4112343		0
60511	3578	40481087	1983-12-09	1983-12-09 00:00:00	1983-12-16	1983-12-16 00:00:00	32020		\N	237876	0	444814009	40481087		0
71251	4225	260139	1983-11-11	1983-11-11 00:00:00	1983-11-18	1983-11-18 00:00:00	32020		\N	280620	0	10509002	260139		0
60899	3604	80180	2019-05-16	2019-05-16 00:00:00	\N	\N	32020		\N	239472	0	396275006	80180		0
71610	4247	40481087	1989-01-22	1989-01-22 00:00:00	1989-02-12	1989-02-12 00:00:00	32020		\N	282044	0	444814009	40481087		0
71715	4255	260139	1989-12-26	1989-12-26 00:00:00	1990-01-09	1990-01-09 00:00:00	32020		\N	282514	0	10509002	260139		0
61410	3628	40481087	1929-07-09	1929-07-09 00:00:00	1929-07-16	1929-07-16 00:00:00	32020		\N	241405	0	444814009	40481087		0
61565	3638	40481087	1997-11-12	1997-11-12 00:00:00	1997-11-19	1997-11-19 00:00:00	32020		\N	241957	0	444814009	40481087		0
61669	3641	40481087	1984-07-31	1984-07-31 00:00:00	1984-08-21	1984-08-21 00:00:00	32020		\N	242332	0	444814009	40481087		0
72499	4305	372328	1958-12-17	1958-12-17 00:00:00	1959-01-30	1959-01-30 00:00:00	32020		\N	285587	0	65363002	372328		0
72653	4317	40481087	1967-09-25	1967-09-25 00:00:00	1967-10-09	1967-10-09 00:00:00	32020		\N	286498	0	444814009	40481087		0
72749	4324	4112343	1974-09-11	1974-09-11 00:00:00	1974-09-18	1974-09-18 00:00:00	32020		\N	286847	0	195662009	4112343		0
83513	4963	260139	1982-07-06	1982-07-06 00:00:00	1982-07-13	1982-07-13 00:00:00	32020		\N	329929	0	10509002	260139		0
73103	4343	40481087	1990-04-25	1990-04-25 00:00:00	1990-05-16	1990-05-16 00:00:00	32020		\N	288060	0	444814009	40481087		0
62733	3703	4084167	1985-03-29	1985-03-29 00:00:00	1985-03-29	1985-03-29 00:00:00	32020		\N	246256	0	241929008	4084167		0
73508	4370	4152936	1966-10-06	1966-10-06 00:00:00	1966-10-27	1966-10-27 00:00:00	32020		\N	290119	0	283385000	4152936		0
63030	3721	40481087	2001-05-23	2001-05-23 00:00:00	2001-05-30	2001-05-30 00:00:00	32020		\N	247390	0	444814009	40481087		0
73823	4384	40481087	1975-09-04	1975-09-04 00:00:00	1975-09-18	1975-09-18 00:00:00	32020		\N	291405	0	444814009	40481087		0
73972	4393	260139	1995-10-20	1995-10-20 00:00:00	1995-10-27	1995-10-27 00:00:00	32020		\N	292087	0	10509002	260139		0
74136	4403	261325	1989-05-13	1989-05-13 00:00:00	\N	\N	32020		\N	292735	0	87433001	261325		0
74347	4413	81151	2006-10-29	2006-10-29 00:00:00	2006-12-03	2006-12-03 00:00:00	32020		\N	293420	0	44465007	81151		0
63842	3772	4278672	1980-07-17	1980-07-17 00:00:00	1980-09-15	1980-09-15 00:00:00	32020		\N	250671	0	65966004	4278672		0
64059	3784	372328	1972-03-18	1972-03-18 00:00:00	1972-08-01	1972-08-01 00:00:00	32020		\N	251496	0	65363002	372328		0
64144	3788	28060	2004-03-06	2004-03-06 00:00:00	2004-03-14	2004-03-14 00:00:00	32020		\N	251859	0	43878008	28060		0
64260	3793	4112343	1953-07-19	1953-07-19 00:00:00	1953-07-30	1953-07-30 00:00:00	32020		\N	252261	0	195662009	4112343		0
53939	3194	40481087	1951-12-31	1951-12-31 00:00:00	1952-01-21	1952-01-21 00:00:00	32020		\N	212461	0	444814009	40481087		0
64685	3825	28060	1988-11-25	1988-11-25 00:00:00	1988-12-04	1988-12-04 00:00:00	32020		\N	254081	0	43878008	28060		0
54228	3214	372328	1975-06-12	1975-06-12 00:00:00	1975-07-22	1975-07-22 00:00:00	32020		\N	213539	0	65363002	372328		0
64925	3839	40481087	1984-09-20	1984-09-20 00:00:00	1984-10-04	1984-10-04 00:00:00	32020		\N	254922	0	444814009	40481087		0
54581	3232	40481087	1981-01-01	1981-01-01 00:00:00	1981-01-08	1981-01-08 00:00:00	32020		\N	214818	0	444814009	40481087		0
65244	3859	261325	1987-09-10	1987-09-10 00:00:00	\N	\N	32020		\N	256254	0	87433001	261325		0
65418	3869	40481087	1945-02-23	1945-02-23 00:00:00	1945-03-09	1945-03-09 00:00:00	32020		\N	256895	0	444814009	40481087		0
65701	3885	4112343	1977-06-06	1977-06-06 00:00:00	1977-06-17	1977-06-17 00:00:00	32020		\N	258256	0	195662009	4112343		0
65883	3895	4112343	1964-08-05	1964-08-05 00:00:00	1964-08-14	1964-08-14 00:00:00	32020		\N	259057	0	195662009	4112343		0
65942	3899	4112343	2018-04-26	2018-04-26 00:00:00	2018-05-05	2018-05-05 00:00:00	32020		\N	259257	0	195662009	4112343		0
66121	3913	40481087	2014-03-03	2014-03-03 00:00:00	2014-03-17	2014-03-17 00:00:00	32020		\N	260138	0	444814009	40481087		0
66310	3926	40481087	1953-10-03	1953-10-03 00:00:00	1953-10-10	1953-10-10 00:00:00	32020		\N	260923	0	444814009	40481087		0
55942	3313	372328	1957-07-28	1957-07-28 00:00:00	1957-12-27	1957-12-27 00:00:00	32020		\N	220036	0	65363002	372328		0
77191	4572	260139	1987-04-17	1987-04-17 00:00:00	1987-05-01	1987-05-01 00:00:00	32020		\N	304622	0	10509002	260139		0
66794	3951	4310024	1984-01-13	1984-01-13 00:00:00	\N	\N	32020		\N	262680	0	424802006	4310024		0
66966	3960	260139	1961-07-31	1961-07-31 00:00:00	1961-08-14	1961-08-14 00:00:00	32020		\N	263249	0	10509002	260139		0
67109	3967	195588	2004-06-09	2004-06-09 00:00:00	2004-07-23	2004-07-23 00:00:00	32020		\N	263769	0	38822007	195588		0
77896	4615	4112343	2002-06-21	2002-06-21 00:00:00	2002-07-02	2002-07-02 00:00:00	32020		\N	307454	0	195662009	4112343		0
67470	3987	28060	2012-08-13	2012-08-13 00:00:00	2012-08-21	2012-08-21 00:00:00	32020		\N	265069	0	43878008	28060		0
67592	3993	4112343	2008-09-23	2008-09-23 00:00:00	2008-10-02	2008-10-02 00:00:00	32020		\N	265472	0	195662009	4112343		0
57263	3397	40481087	1968-11-22	1968-11-22 00:00:00	1968-11-29	1968-11-29 00:00:00	32020		\N	225289	0	444814009	40481087		0
67977	4017	4112343	2007-04-17	2007-04-17 00:00:00	2007-04-27	2007-04-27 00:00:00	32020		\N	266970	0	195662009	4112343		0
68089	4021	40481087	1994-06-08	1994-06-08 00:00:00	1994-06-15	1994-06-15 00:00:00	32020		\N	267324	0	444814009	40481087		0
68313	4035	4112343	2019-03-09	2019-03-09 00:00:00	2019-03-19	2019-03-19 00:00:00	32020		\N	268461	0	195662009	4112343		0
68443	4045	40481087	1984-11-23	1984-11-23 00:00:00	1984-12-14	1984-12-14 00:00:00	32020		\N	269014	0	444814009	40481087		0
68579	4055	4310024	2005-11-27	2005-11-27 00:00:00	\N	\N	32020		\N	269564	0	424802006	4310024		0
68813	4072	78272	1999-08-27	1999-08-27 00:00:00	1999-09-10	1999-09-10 00:00:00	32020		\N	270688	0	70704007	78272		0
58374	3457	40481087	1966-10-13	1966-10-13 00:00:00	1966-10-27	1966-10-27 00:00:00	32020		\N	229397	0	444814009	40481087		0
69070	4087	40481087	1979-09-16	1979-09-16 00:00:00	1979-09-23	1979-09-23 00:00:00	32020		\N	271644	0	444814009	40481087		0
69386	4106	4112343	1985-01-25	1985-01-25 00:00:00	1985-02-06	1985-02-06 00:00:00	32020		\N	272864	0	195662009	4112343		0
58845	3490	40481087	1955-07-16	1955-07-16 00:00:00	1955-08-06	1955-08-06 00:00:00	32020		\N	231562	0	444814009	40481087		0
59065	3505	4112343	2008-02-21	2008-02-21 00:00:00	2008-03-04	2008-03-04 00:00:00	32020		\N	232433	0	195662009	4112343		0
69843	4133	28060	1981-03-08	1981-03-08 00:00:00	1981-03-18	1981-03-18 00:00:00	32020		\N	274784	0	43878008	28060		0
80577	4776	372328	1964-12-22	1964-12-22 00:00:00	1965-03-07	1965-03-07 00:00:00	32020		\N	317999	0	65363002	372328		0
59551	3530	4218389	1981-06-18	1981-06-18 00:00:00	1981-07-23	1981-07-23 00:00:00	32020		\N	234455	0	39848009	4218389		0
70308	4165	381316	1980-04-06	1980-04-06 00:00:00	\N	\N	32020		\N	276754	0	230690007	381316		0
81036	4807	260139	1974-03-15	1974-03-15 00:00:00	1974-03-22	1974-03-22 00:00:00	32020		\N	319856	0	10509002	260139		0
81181	4814	4109685	1946-01-03	1946-01-03 00:00:00	1946-01-17	1946-01-17 00:00:00	32020		\N	320244	0	284551006	4109685		0
70768	4199	260139	1948-03-08	1948-03-08 00:00:00	1948-03-22	1948-03-22 00:00:00	32020		\N	278633	0	10509002	260139		0
70898	4206	78272	1968-08-23	1968-08-23 00:00:00	1968-09-20	1968-09-20 00:00:00	32020		\N	279331	0	70704007	78272		0
60512	3578	4278672	1992-03-18	1992-03-18 00:00:00	1992-05-17	1992-05-17 00:00:00	32020		\N	237860	0	65966004	4278672		0
71252	4225	4266809	2014-06-20	2014-06-20 00:00:00	\N	\N	32020		\N	280598	0	397881000	4266809		0
60900	3604	28060	1984-08-05	1984-08-05 00:00:00	1984-08-18	1984-08-18 00:00:00	32020		\N	239539	0	43878008	28060		0
71643	4250	4059173	2015-04-07	2015-04-07 00:00:00	2015-07-06	2015-07-06 00:00:00	32020		\N	282264	0	16114001	4059173		0
71716	4255	372328	1979-04-14	1979-04-14 00:00:00	1980-04-19	1980-04-19 00:00:00	32020		\N	282559	0	65363002	372328		0
61411	3628	317576	2002-04-13	2002-04-13 00:00:00	\N	\N	32020		\N	241325	0	53741008	317576		0
61566	3638	28060	1999-10-29	1999-10-29 00:00:00	1999-11-10	1999-11-10 00:00:00	32020		\N	241958	0	43878008	28060		0
61670	3641	4112343	1915-07-04	1915-07-04 00:00:00	1915-07-14	1915-07-14 00:00:00	32020		\N	242356	0	195662009	4112343		0
72500	4305	4296204	2013-07-15	2013-07-15 00:00:00	2013-08-12	2013-08-12 00:00:00	32020		\N	285536	0	403190006	4296204		0
72654	4317	80180	1988-08-14	1988-08-14 00:00:00	\N	\N	32020		\N	286524	0	396275006	80180		0
72750	4324	4156265	1980-07-31	1980-07-31 00:00:00	1980-08-21	1980-08-21 00:00:00	32020		\N	286823	0	370247008	4156265		0
83514	4963	28060	2010-08-31	2010-08-31 00:00:00	2010-09-07	2010-09-07 00:00:00	32020		\N	329939	0	43878008	28060		0
73104	4343	4112343	1989-03-11	1989-03-11 00:00:00	1989-03-22	1989-03-22 00:00:00	32020		\N	287993	0	195662009	4112343		0
73219	4352	81151	2015-08-07	2015-08-07 00:00:00	2015-08-28	2015-08-28 00:00:00	32020		\N	288671	0	44465007	81151		0
73509	4370	375671	2019-02-28	2019-02-28 00:00:00	2019-03-30	2019-03-30 00:00:00	32020		\N	290120	0	62564004	375671		0
63031	3721	78272	1978-08-28	1978-08-28 00:00:00	1978-09-11	1978-09-11 00:00:00	32020		\N	247322	0	70704007	78272		0
73824	4384	4084167	1968-09-08	1968-09-08 00:00:00	1968-09-08	1968-09-08 00:00:00	32020		\N	291362	0	241929008	4084167		0
73973	4393	40481087	2004-05-07	2004-05-07 00:00:00	2004-05-28	2004-05-28 00:00:00	32020		\N	292105	0	444814009	40481087		0
74137	4403	78272	1987-01-15	1987-01-15 00:00:00	1987-01-29	1987-01-29 00:00:00	32020		\N	292710	0	70704007	78272		0
74348	4413	40481087	1994-05-23	1994-05-23 00:00:00	1994-06-06	1994-06-06 00:00:00	32020		\N	293462	0	444814009	40481087		0
63843	3772	260139	2014-06-28	2014-06-28 00:00:00	2014-07-12	2014-07-12 00:00:00	32020		\N	250762	0	10509002	260139		0
64060	3784	195588	1948-07-03	1948-07-03 00:00:00	1948-08-15	1948-08-15 00:00:00	32020		\N	251453	0	38822007	195588		0
64145	3789	372328	1945-08-11	1945-08-11 00:00:00	1945-10-25	1945-10-25 00:00:00	32020		\N	251886	0	65363002	372328		0
64261	3795	4059173	1993-06-28	1993-06-28 00:00:00	1993-07-28	1993-07-28 00:00:00	32020		\N	252344	0	16114001	4059173		0
53940	3194	28060	1957-02-27	1957-02-27 00:00:00	1957-03-09	1957-03-09 00:00:00	32020		\N	212454	0	43878008	28060		0
64686	3825	40481087	1979-05-24	1979-05-24 00:00:00	1979-06-07	1979-06-07 00:00:00	32020		\N	254069	0	444814009	40481087		0
54229	3214	4152936	1982-12-17	1982-12-17 00:00:00	1982-12-31	1982-12-31 00:00:00	32020		\N	213494	0	283385000	4152936		0
64926	3839	4310024	1991-05-11	1991-05-11 00:00:00	\N	\N	32020		\N	254897	0	424802006	4310024		0
54582	3232	192671	2004-07-15	2004-07-15 00:00:00	\N	\N	32020		\N	214815	0	K92.2	35208414		0
65245	3859	4112343	1996-08-25	1996-08-25 00:00:00	1996-09-07	1996-09-07 00:00:00	32020		\N	256276	0	195662009	4112343		0
65419	3869	260139	1981-11-11	1981-11-11 00:00:00	1981-11-25	1981-11-25 00:00:00	32020		\N	256913	0	10509002	260139		0
65702	3885	4152936	1987-11-29	1987-11-29 00:00:00	1987-12-20	1987-12-20 00:00:00	32020		\N	258217	0	283385000	4152936		0
65884	3895	40481087	2003-11-03	2003-11-03 00:00:00	2003-11-24	2003-11-24 00:00:00	32020		\N	259075	0	444814009	40481087		0
65943	3899	40481087	2018-02-13	2018-02-13 00:00:00	2018-02-27	2018-02-27 00:00:00	32020		\N	259280	0	444814009	40481087		0
66122	3913	372328	1964-04-10	1964-04-10 00:00:00	1964-09-24	1964-09-24 00:00:00	32020		\N	260139	0	65363002	372328		0
66311	3926	4218389	1991-08-26	1991-08-26 00:00:00	1991-09-30	1991-09-30 00:00:00	32020		\N	261011	0	39848009	4218389		0
66401	3930	4146173	1925-11-25	1925-11-25 00:00:00	1925-12-25	1925-12-25 00:00:00	32020		\N	261263	0	307731004	4146173		0
77192	4572	4112343	2016-08-13	2016-08-13 00:00:00	2016-08-22	2016-08-22 00:00:00	32020		\N	304603	0	195662009	4112343		0
66795	3951	81893	1984-11-08	1984-11-08 00:00:00	\N	\N	32020		\N	262680	0	64766004	81893		0
66967	3960	260139	1970-11-28	1970-11-28 00:00:00	1970-12-12	1970-12-12 00:00:00	32020		\N	263290	0	10509002	260139		0
67110	3968	40481087	1966-12-06	1966-12-06 00:00:00	1966-12-27	1966-12-27 00:00:00	32020		\N	263835	0	444814009	40481087		0
77897	4615	40481087	2017-08-30	2017-08-30 00:00:00	2017-09-06	2017-09-06 00:00:00	32020		\N	307456	0	444814009	40481087		0
67471	3987	4218389	1956-08-12	1956-08-12 00:00:00	1956-09-02	1956-09-02 00:00:00	32020		\N	265026	0	39848009	4218389		0
67593	3993	260139	1976-08-11	1976-08-11 00:00:00	1976-08-25	1976-08-25 00:00:00	32020		\N	265542	0	10509002	260139		0
57264	3397	4112343	1952-06-19	1952-06-19 00:00:00	1952-06-29	1952-06-29 00:00:00	32020		\N	225363	0	195662009	4112343		0
67978	4017	80502	1980-09-25	1980-09-25 00:00:00	\N	\N	32020		\N	266987	0	64859006	80502		0
68090	4021	4134304	1961-09-03	1961-09-03 00:00:00	1961-11-02	1961-11-02 00:00:00	32020		\N	267310	0	263102004	4134304		0
68314	4035	4283893	2002-01-19	2002-01-19 00:00:00	2002-03-16	2002-03-16 00:00:00	32020		\N	268447	0	36971009	4283893		0
68444	4045	192671	2015-07-17	2015-07-17 00:00:00	\N	\N	32020		\N	269034	0	K92.2	35208414		0
68580	4055	260139	1979-09-29	1979-09-29 00:00:00	1979-10-06	1979-10-06 00:00:00	32020		\N	269509	0	10509002	260139		0
68814	4072	372328	1980-06-19	1980-06-19 00:00:00	1980-08-23	1980-08-23 00:00:00	32020		\N	270698	0	65363002	372328		0
58375	3457	40481087	1999-04-13	1999-04-13 00:00:00	1999-04-20	1999-04-20 00:00:00	32020		\N	229326	0	444814009	40481087		0
69071	4087	40481087	2018-07-09	2018-07-09 00:00:00	2018-07-30	2018-07-30 00:00:00	32020		\N	271663	0	444814009	40481087		0
69387	4106	40481087	1990-10-09	1990-10-09 00:00:00	1990-10-30	1990-10-30 00:00:00	32020		\N	272811	0	444814009	40481087		0
58846	3490	80180	1987-06-21	1987-06-21 00:00:00	\N	\N	32020		\N	231511	0	396275006	80180		0
59066	3505	4112343	1998-06-05	1998-06-05 00:00:00	1998-06-15	1998-06-15 00:00:00	32020		\N	232431	0	195662009	4112343		0
69844	4133	40481087	1999-01-04	1999-01-04 00:00:00	1999-01-18	1999-01-18 00:00:00	32020		\N	274785	0	444814009	40481087		0
80578	4776	4112343	1999-02-11	1999-02-11 00:00:00	1999-02-20	1999-02-20 00:00:00	32020		\N	317994	0	195662009	4112343		0
59552	3530	4146173	1972-10-03	1972-10-03 00:00:00	1972-11-02	1972-11-02 00:00:00	32020		\N	234461	0	307731004	4146173		0
70309	4165	4112343	1980-01-11	1980-01-11 00:00:00	1980-01-20	1980-01-20 00:00:00	32020		\N	276754	0	195662009	4112343		0
81037	4807	4218389	1971-05-17	1971-05-17 00:00:00	1971-06-14	1971-06-14 00:00:00	32020		\N	319808	0	39848009	4218389		0
81182	4814	40481087	2002-05-12	2002-05-12 00:00:00	2002-05-26	2002-05-26 00:00:00	32020		\N	320231	0	444814009	40481087		0
70769	4199	260139	2011-02-08	2011-02-08 00:00:00	2011-02-15	2011-02-15 00:00:00	32020		\N	278691	0	10509002	260139		0
70899	4206	440086	1954-09-03	1954-09-03 00:00:00	1961-09-11	1961-09-11 00:00:00	32020		\N	279275	0	192127007	440086		0
60513	3578	440448	1979-08-03	1979-08-03 00:00:00	\N	\N	32020		\N	237858	0	74400008	440448		0
71253	4225	30753	2013-11-22	2013-11-22 00:00:00	\N	\N	32020		\N	280598	0	16761005	30753		0
60901	3604	4112343	2005-06-21	2005-06-21 00:00:00	2005-06-28	2005-06-28 00:00:00	32020		\N	239497	0	195662009	4112343		0
71644	4250	40481087	1958-04-13	1958-04-13 00:00:00	1958-04-20	1958-04-20 00:00:00	32020		\N	282324	0	444814009	40481087		0
71717	4255	40481087	1997-05-17	1997-05-17 00:00:00	1997-05-31	1997-05-31 00:00:00	32020		\N	282515	0	444814009	40481087		0
61412	3628	28060	1927-05-27	1927-05-27 00:00:00	1927-06-08	1927-06-08 00:00:00	32020		\N	241297	0	43878008	28060		0
61567	3638	372328	1968-06-04	1968-06-04 00:00:00	1969-04-17	1969-04-17 00:00:00	32020		\N	241998	0	65363002	372328		0
61671	3641	40481087	2007-03-05	2007-03-05 00:00:00	2007-03-19	2007-03-19 00:00:00	32020		\N	242342	0	444814009	40481087		0
72501	4305	40481087	2013-04-26	2013-04-26 00:00:00	2013-05-10	2013-05-10 00:00:00	32020		\N	285521	0	444814009	40481087		0
72655	4317	317576	2018-11-01	2018-11-01 00:00:00	\N	\N	32020		\N	286529	0	53741008	317576		0
72751	4324	40481087	2002-01-15	2002-01-15 00:00:00	2002-01-22	2002-01-22 00:00:00	32020		\N	286841	0	444814009	40481087		0
83515	4963	378001	1975-07-03	1975-07-03 00:00:00	1975-08-02	1975-08-02 00:00:00	32020		\N	329965	0	62106007	378001		0
73105	4343	40481087	2013-11-12	2013-11-12 00:00:00	2013-11-26	2013-11-26 00:00:00	32020		\N	288035	0	444814009	40481087		0
73220	4352	40481087	1958-11-10	1958-11-10 00:00:00	1958-11-24	1958-11-24 00:00:00	32020		\N	288634	0	444814009	40481087		0
73510	4370	4112343	1968-04-04	1968-04-04 00:00:00	1968-04-16	1968-04-16 00:00:00	32020		\N	290111	0	195662009	4112343		0
63032	3721	260139	1968-11-28	1968-11-28 00:00:00	1968-12-12	1968-12-12 00:00:00	32020		\N	247350	0	10509002	260139		0
73825	4384	40481087	1998-01-28	1998-01-28 00:00:00	1998-02-11	1998-02-11 00:00:00	32020		\N	291406	0	444814009	40481087		0
73974	4393	260139	2006-04-12	2006-04-12 00:00:00	2006-04-19	2006-04-19 00:00:00	32020		\N	292089	0	10509002	260139		0
74138	4403	40481087	1961-01-16	1961-01-16 00:00:00	1961-01-30	1961-01-30 00:00:00	32020		\N	292721	0	444814009	40481087		0
74349	4413	4283893	1990-05-25	1990-05-25 00:00:00	1990-06-08	1990-06-08 00:00:00	32020		\N	293461	0	36971009	4283893		0
63844	3772	260139	1984-07-27	1984-07-27 00:00:00	1984-08-03	1984-08-03 00:00:00	32020		\N	250697	0	10509002	260139		0
64069	3786	4112343	1969-05-13	1969-05-13 00:00:00	1969-05-20	1969-05-20 00:00:00	32020		\N	251698	0	195662009	4112343		0
64146	3789	4116491	1994-05-06	1994-05-06 00:00:00	1994-06-15	1994-06-15 00:00:00	32020		\N	251926	0	301011002	4116491		0
64262	3795	192671	2010-08-11	2010-08-11 00:00:00	\N	\N	32020		\N	252325	0	K92.2	35208414		0
53941	3194	81893	1979-06-01	1979-06-01 00:00:00	\N	\N	32020		\N	212497	0	64766004	81893		0
64687	3825	372328	1955-07-06	1955-07-06 00:00:00	1955-08-19	1955-08-19 00:00:00	32020		\N	254040	0	65363002	372328		0
54230	3214	4109685	1988-07-02	1988-07-02 00:00:00	1988-07-16	1988-07-16 00:00:00	32020		\N	213496	0	284551006	4109685		0
64927	3839	4112343	1979-08-06	1979-08-06 00:00:00	1979-08-13	1979-08-13 00:00:00	32020		\N	254840	0	195662009	4112343		0
54583	3232	381316	2019-04-29	2019-04-29 00:00:00	\N	\N	32020		\N	214846	0	230690007	381316		0
65246	3859	4112343	1974-02-13	1974-02-13 00:00:00	1974-02-26	1974-02-26 00:00:00	32020		\N	256244	0	195662009	4112343		0
65420	3869	40481087	1920-10-08	1920-10-08 00:00:00	1920-10-15	1920-10-15 00:00:00	32020		\N	256894	0	444814009	40481087		0
65703	3885	81151	2001-10-28	2001-10-28 00:00:00	2001-11-11	2001-11-11 00:00:00	32020		\N	258219	0	44465007	81151		0
65885	3895	260139	1977-02-01	1977-02-01 00:00:00	1977-02-15	1977-02-15 00:00:00	32020		\N	259122	0	10509002	260139		0
65944	3899	80180	2015-07-08	2015-07-08 00:00:00	\N	\N	32020		\N	259276	0	396275006	80180		0
66123	3913	40481087	1969-04-10	1969-04-10 00:00:00	1969-05-01	1969-05-01 00:00:00	32020		\N	260170	0	444814009	40481087		0
66312	3926	260139	1962-09-11	1962-09-11 00:00:00	1962-09-25	1962-09-25 00:00:00	32020		\N	260925	0	10509002	260139		0
66402	3930	28060	1971-07-11	1971-07-11 00:00:00	1971-07-21	1971-07-21 00:00:00	32020		\N	261231	0	43878008	28060		0
77193	4572	4296204	2008-04-25	2008-04-25 00:00:00	2008-05-30	2008-05-30 00:00:00	32020		\N	304638	0	403190006	4296204		0
70094	4149	257012	1991-10-04	1991-10-04 00:00:00	\N	\N	32020		\N	275710	0	40055000	257012		0
66796	3951	372328	1946-03-13	1946-03-13 00:00:00	1946-08-31	1946-08-31 00:00:00	32020		\N	262645	0	65363002	372328		0
66968	3960	28060	1980-04-23	1980-04-23 00:00:00	1980-05-06	1980-05-06 00:00:00	32020		\N	263258	0	43878008	28060		0
67111	3968	313217	2006-03-31	2006-03-31 00:00:00	\N	\N	32020		\N	263800	0	49436004	313217		0
77898	4615	4112343	1994-03-01	1994-03-01 00:00:00	1994-03-14	1994-03-14 00:00:00	32020		\N	307423	0	195662009	4112343		0
67472	3987	40481087	2009-01-29	2009-01-29 00:00:00	2009-02-12	2009-02-12 00:00:00	32020		\N	265067	0	444814009	40481087		0
67594	3993	4112343	1966-03-23	1966-03-23 00:00:00	1966-04-01	1966-04-01 00:00:00	32020		\N	265526	0	195662009	4112343		0
57265	3397	4294548	1971-03-25	1971-03-25 00:00:00	1971-06-24	1971-06-24 00:00:00	32020		\N	225324	0	75498004	4294548		0
67979	4017	4112343	1939-03-18	1939-03-18 00:00:00	1939-03-27	1939-03-27 00:00:00	32020		\N	266964	0	195662009	4112343		0
68091	4021	40481087	2016-05-29	2016-05-29 00:00:00	2016-06-12	2016-06-12 00:00:00	32020		\N	267316	0	444814009	40481087		0
68315	4035	40481087	1998-02-24	1998-02-24 00:00:00	1998-03-03	1998-03-03 00:00:00	32020		\N	268492	0	444814009	40481087		0
68445	4045	4112343	2009-04-10	2009-04-10 00:00:00	2009-04-17	2009-04-17 00:00:00	32020		\N	268996	0	195662009	4112343		0
68581	4055	40481087	1997-07-01	1997-07-01 00:00:00	1997-07-08	1997-07-08 00:00:00	32020		\N	269537	0	444814009	40481087		0
68815	4072	4113008	2013-12-09	2013-12-09 00:00:00	2013-12-23	2013-12-23 00:00:00	32020		\N	270691	0	284549007	4113008		0
58376	3457	80502	1976-10-29	1976-10-29 00:00:00	\N	\N	32020		\N	229388	0	64859006	80502		0
69072	4087	4152936	1995-07-06	1995-07-06 00:00:00	1995-07-27	1995-07-27 00:00:00	32020		\N	271640	0	283385000	4152936		0
69388	4106	372328	1947-06-16	1947-06-16 00:00:00	1947-07-11	1947-07-11 00:00:00	32020		\N	272840	0	65363002	372328		0
58847	3490	4112343	1975-05-09	1975-05-09 00:00:00	1975-05-19	1975-05-19 00:00:00	32020		\N	231501	0	195662009	4112343		0
59067	3505	40486433	1939-02-12	1939-02-12 00:00:00	1956-02-10	1956-02-10 00:00:00	32020		\N	232421	0	446096008	40486433		0
69845	4133	4112343	1993-09-25	1993-09-25 00:00:00	1993-10-07	1993-10-07 00:00:00	32020		\N	274767	0	195662009	4112343		0
80579	4776	260139	2008-04-23	2008-04-23 00:00:00	2008-05-07	2008-05-07 00:00:00	32020		\N	318043	0	10509002	260139		0
59553	3530	4294548	1993-06-13	1993-06-13 00:00:00	1993-08-08	1993-08-08 00:00:00	32020		\N	234464	0	75498004	4294548		0
70310	4165	40481087	1982-01-01	1982-01-01 00:00:00	1982-01-22	1982-01-22 00:00:00	32020		\N	276708	0	444814009	40481087		0
81038	4807	78272	1972-05-09	1972-05-09 00:00:00	1972-06-13	1972-06-13 00:00:00	32020		\N	319809	0	70704007	78272		0
81183	4815	40481087	2004-01-28	2004-01-28 00:00:00	2004-02-11	2004-02-11 00:00:00	32020		\N	320350	0	444814009	40481087		0
70770	4199	40481087	1985-04-01	1985-04-01 00:00:00	1985-04-22	1985-04-22 00:00:00	32020		\N	278688	0	444814009	40481087		0
70900	4206	4112343	1970-12-12	1970-12-12 00:00:00	1970-12-25	1970-12-25 00:00:00	32020		\N	279278	0	195662009	4112343		0
60514	3578	78272	1980-04-22	1980-04-22 00:00:00	1980-05-20	1980-05-20 00:00:00	32020		\N	237859	0	70704007	78272		0
71254	4225	80180	2014-06-20	2014-06-20 00:00:00	\N	\N	32020		\N	280598	0	396275006	80180		0
60902	3604	4112343	1992-06-03	1992-06-03 00:00:00	1992-06-14	1992-06-14 00:00:00	32020		\N	239526	0	195662009	4112343		0
71645	4250	260139	1988-08-26	1988-08-26 00:00:00	1988-09-02	1988-09-02 00:00:00	32020		\N	282288	0	10509002	260139		0
71718	4255	28060	2008-12-16	2008-12-16 00:00:00	2008-12-26	2008-12-26 00:00:00	32020		\N	282529	0	43878008	28060		0
61413	3628	4112343	1956-10-31	1956-10-31 00:00:00	1956-11-10	1956-11-10 00:00:00	32020		\N	241360	0	195662009	4112343		0
61568	3638	260139	2014-07-27	2014-07-27 00:00:00	2014-08-10	2014-08-10 00:00:00	32020		\N	241992	0	10509002	260139		0
61672	3641	440086	1920-10-30	1920-10-30 00:00:00	1922-04-08	1922-04-08 00:00:00	32020		\N	242263	0	192127007	440086		0
72502	4305	4112343	1997-07-07	1997-07-07 00:00:00	1997-07-18	1997-07-18 00:00:00	32020		\N	285530	0	195662009	4112343		0
72656	4317	4278672	1964-10-04	1964-10-04 00:00:00	1964-11-03	1964-11-03 00:00:00	32020		\N	286478	0	65966004	4278672		0
72752	4324	28060	1961-08-12	1961-08-12 00:00:00	1961-08-19	1961-08-19 00:00:00	32020		\N	286846	0	43878008	28060		0
83516	4963	28060	1986-08-26	1986-08-26 00:00:00	1986-09-07	1986-09-07 00:00:00	32020		\N	329867	0	43878008	28060		0
73106	4343	40481087	1959-08-01	1959-08-01 00:00:00	1959-08-22	1959-08-22 00:00:00	32020		\N	288051	0	444814009	40481087		0
73221	4352	4112343	1985-01-15	1985-01-15 00:00:00	1985-01-25	1985-01-25 00:00:00	32020		\N	288707	0	195662009	4112343		0
73511	4370	260139	1969-06-27	1969-06-27 00:00:00	1969-07-11	1969-07-11 00:00:00	32020		\N	290121	0	10509002	260139		0
63033	3721	28060	1971-09-16	1971-09-16 00:00:00	1971-09-25	1971-09-25 00:00:00	32020		\N	247351	0	43878008	28060		0
73826	4384	4112343	1970-11-29	1970-11-29 00:00:00	1970-12-11	1970-12-11 00:00:00	32020		\N	291367	0	195662009	4112343		0
73975	4393	4230399	1987-10-30	1987-10-30 00:00:00	1988-01-28	1988-01-28 00:00:00	32020		\N	292101	0	359817006	4230399		0
74139	4403	4152936	1949-10-14	1949-10-14 00:00:00	1949-11-04	1949-11-04 00:00:00	32020		\N	292706	0	283385000	4152936		0
74350	4413	4112343	1981-01-31	1981-01-31 00:00:00	1981-02-12	1981-02-12 00:00:00	32020		\N	293428	0	195662009	4112343		0
63845	3772	40481087	1976-06-15	1976-06-15 00:00:00	1976-06-22	1976-06-22 00:00:00	32020		\N	250665	0	444814009	40481087		0
64070	3786	195588	1987-12-02	1987-12-02 00:00:00	1988-01-24	1988-01-24 00:00:00	32020		\N	251714	0	38822007	195588		0
64147	3789	40481087	1974-06-30	1974-06-30 00:00:00	1974-07-21	1974-07-21 00:00:00	32020		\N	251876	0	444814009	40481087		0
64263	3795	40481087	2014-10-09	2014-10-09 00:00:00	2014-10-23	2014-10-23 00:00:00	32020		\N	252334	0	444814009	40481087		0
53942	3194	80180	1980-08-24	1980-08-24 00:00:00	\N	\N	32020		\N	212497	0	396275006	80180		0
64688	3825	4112343	1977-01-14	1977-01-14 00:00:00	1977-01-23	1977-01-23 00:00:00	32020		\N	254059	0	195662009	4112343		0
54231	3214	260139	2017-05-17	2017-05-17 00:00:00	2017-05-24	2017-05-24 00:00:00	32020		\N	213553	0	10509002	260139		0
64928	3839	28060	1952-12-12	1952-12-12 00:00:00	1952-12-21	1952-12-21 00:00:00	32020		\N	254836	0	43878008	28060		0
54584	3232	4112343	1969-06-17	1969-06-17 00:00:00	1969-06-24	1969-06-24 00:00:00	32020		\N	214816	0	195662009	4112343		0
65247	3859	80180	1957-11-26	1957-11-26 00:00:00	\N	\N	32020		\N	256249	0	396275006	80180		0
65421	3869	4112343	1977-04-17	1977-04-17 00:00:00	1977-04-27	1977-04-27 00:00:00	32020		\N	256916	0	195662009	4112343		0
65704	3885	4059173	1968-09-06	1968-09-06 00:00:00	1968-10-06	1968-10-06 00:00:00	32020		\N	258295	0	16114001	4059173		0
65886	3895	40481087	1926-09-25	1926-09-25 00:00:00	1926-10-09	1926-10-09 00:00:00	32020		\N	259055	0	444814009	40481087		0
65945	3899	260139	2003-12-18	2003-12-18 00:00:00	2003-12-25	2003-12-25 00:00:00	32020		\N	259267	0	10509002	260139		0
66124	3913	378001	2007-07-08	2007-07-08 00:00:00	2007-08-07	2007-08-07 00:00:00	32020		\N	260088	0	62106007	378001		0
66313	3926	40481087	1956-04-21	1956-04-21 00:00:00	1956-05-05	1956-05-05 00:00:00	32020		\N	260970	0	444814009	40481087		0
66403	3930	372328	1917-02-01	1917-02-01 00:00:00	1917-08-04	1917-08-04 00:00:00	32020		\N	261244	0	65363002	372328		0
77194	4572	372328	1981-10-01	1981-10-01 00:00:00	1982-05-25	1982-05-25 00:00:00	32020		\N	304605	0	65363002	372328		0
66797	3951	4112343	1951-01-01	1951-01-01 00:00:00	1951-01-10	1951-01-10 00:00:00	32020		\N	262649	0	195662009	4112343		0
66969	3960	4001336	1997-02-16	1997-02-16 00:00:00	1997-04-17	1997-04-17 00:00:00	32020		\N	263313	0	110030002	4001336		0
67112	3968	375671	1944-06-10	1944-06-10 00:00:00	1944-08-09	1944-08-09 00:00:00	32020		\N	263903	0	62564004	375671		0
77899	4615	81151	2011-04-24	2011-04-24 00:00:00	2011-05-22	2011-05-22 00:00:00	32020		\N	307376	0	44465007	81151		0
67473	3987	4112343	1990-10-22	1990-10-22 00:00:00	1990-11-03	1990-11-03 00:00:00	32020		\N	265071	0	195662009	4112343		0
67595	3993	260139	2013-09-05	2013-09-05 00:00:00	2013-09-12	2013-09-12 00:00:00	32020		\N	265459	0	10509002	260139		0
57266	3397	40481087	2004-07-18	2004-07-18 00:00:00	2004-08-01	2004-08-01 00:00:00	32020		\N	225353	0	444814009	40481087		0
68092	4021	4112343	1970-10-02	1970-10-02 00:00:00	1970-10-15	1970-10-15 00:00:00	32020		\N	267277	0	195662009	4112343		0
68316	4035	378001	1978-10-16	1978-10-16 00:00:00	1978-11-15	1978-11-15 00:00:00	32020		\N	268480	0	62106007	378001		0
68446	4045	372328	1980-01-28	1980-01-28 00:00:00	1980-10-11	1980-10-11 00:00:00	32020		\N	269016	0	65363002	372328		0
68582	4055	81893	2006-02-25	2006-02-25 00:00:00	\N	\N	32020		\N	269543	0	64766004	81893		0
68816	4072	4152936	2004-04-16	2004-04-16 00:00:00	2004-04-30	2004-04-30 00:00:00	32020		\N	270689	0	283385000	4152936		0
58377	3457	40481087	1947-04-21	1947-04-21 00:00:00	1947-05-05	1947-05-05 00:00:00	32020		\N	229323	0	444814009	40481087		0
69073	4087	4218389	1984-05-15	1984-05-15 00:00:00	1984-06-19	1984-06-19 00:00:00	32020		\N	271677	0	39848009	4218389		0
79847	4731	4027663	2000-10-25	2000-10-25 00:00:00	\N	\N	32020		\N	315222	0	13200003	4027663		0
58848	3490	40481087	1946-04-19	1946-04-19 00:00:00	1946-05-03	1946-05-03 00:00:00	32020		\N	231486	0	444814009	40481087		0
59068	3505	4112343	1954-03-04	1954-03-04 00:00:00	1954-03-12	1954-03-12 00:00:00	32020		\N	232395	0	195662009	4112343		0
69846	4133	4112343	1994-05-06	1994-05-06 00:00:00	1994-05-18	1994-05-18 00:00:00	32020		\N	274803	0	195662009	4112343		0
80580	4776	81151	1974-06-03	1974-06-03 00:00:00	1974-07-08	1974-07-08 00:00:00	32020		\N	318024	0	44465007	81151		0
59554	3530	28060	1980-10-05	1980-10-05 00:00:00	1980-10-18	1980-10-18 00:00:00	32020		\N	234462	0	43878008	28060		0
70311	4165	4278672	1981-10-20	1981-10-20 00:00:00	1981-12-19	1981-12-19 00:00:00	32020		\N	276831	0	65966004	4278672		0
81039	4807	80502	2006-03-09	2006-03-09 00:00:00	\N	\N	32020		\N	319872	0	64859006	80502		0
81184	4815	40481087	2010-09-13	2010-09-13 00:00:00	2010-10-04	2010-10-04 00:00:00	32020		\N	320340	0	444814009	40481087		0
70771	4199	4283893	2017-08-11	2017-08-11 00:00:00	2017-09-01	2017-09-01 00:00:00	32020		\N	278620	0	36971009	4283893		0
70901	4206	40481087	1962-09-10	1962-09-10 00:00:00	1962-10-01	1962-10-01 00:00:00	32020		\N	279296	0	444814009	40481087		0
60515	3578	4112343	1978-05-31	1978-05-31 00:00:00	1978-06-09	1978-06-09 00:00:00	32020		\N	237875	0	195662009	4112343		0
71255	4225	40481087	2003-03-11	2003-03-11 00:00:00	2003-03-18	2003-03-18 00:00:00	32020		\N	280622	0	444814009	40481087		0
60903	3604	4112343	1992-04-24	1992-04-24 00:00:00	1992-05-02	1992-05-02 00:00:00	32020		\N	239474	0	195662009	4112343		0
71646	4250	40481087	1987-07-17	1987-07-17 00:00:00	1987-08-07	1987-08-07 00:00:00	32020		\N	282327	0	444814009	40481087		0
71719	4255	4113008	1975-01-18	1975-01-18 00:00:00	1975-02-08	1975-02-08 00:00:00	32020		\N	282502	0	284549007	4113008		0
61414	3628	40481087	1939-03-04	1939-03-04 00:00:00	1939-03-25	1939-03-25 00:00:00	32020		\N	241406	0	444814009	40481087		0
61569	3638	4051466	1967-05-08	1967-05-08 00:00:00	1985-06-27	1985-06-27 00:00:00	32020		\N	241971	0	233678006	4051466		0
61695	3644	80180	1981-10-25	1981-10-25 00:00:00	\N	\N	32020		\N	242481	0	396275006	80180		0
72503	4305	80180	1997-12-27	1997-12-27 00:00:00	\N	\N	32020		\N	285570	0	396275006	80180		0
72657	4317	40481087	2002-10-16	2002-10-16 00:00:00	2002-10-23	2002-10-23 00:00:00	32020		\N	286509	0	444814009	40481087		0
72753	4324	134438	1981-06-13	1981-06-13 00:00:00	1982-08-09	1982-08-09 00:00:00	32020		\N	286837	0	40275004	134438		0
83517	4963	192671	2009-05-25	2009-05-25 00:00:00	\N	\N	32020		\N	329959	0	K92.2	35208414		0
73107	4343	4112343	2012-03-03	2012-03-03 00:00:00	2012-03-13	2012-03-13 00:00:00	32020		\N	288054	0	195662009	4112343		0
73222	4352	4112343	2003-11-29	2003-11-29 00:00:00	2003-12-10	2003-12-10 00:00:00	32020		\N	288709	0	195662009	4112343		0
73512	4370	40481087	1988-11-11	1988-11-11 00:00:00	1988-12-02	1988-12-02 00:00:00	32020		\N	290150	0	444814009	40481087		0
63034	3721	40481087	1996-09-04	1996-09-04 00:00:00	1996-09-11	1996-09-11 00:00:00	32020		\N	247388	0	444814009	40481087		0
73827	4384	80180	2005-08-25	2005-08-25 00:00:00	\N	\N	32020		\N	291377	0	396275006	80180		0
73976	4393	80180	2019-03-01	2019-03-01 00:00:00	\N	\N	32020		\N	292114	0	396275006	80180		0
74140	4403	81151	1969-06-20	1969-06-20 00:00:00	1969-07-18	1969-07-18 00:00:00	32020		\N	292709	0	44465007	81151		0
74351	4413	4112343	2016-12-01	2016-12-01 00:00:00	2016-12-14	2016-12-14 00:00:00	32020		\N	293465	0	195662009	4112343		0
63846	3772	372328	1970-06-10	1970-06-10 00:00:00	1970-07-25	1970-07-25 00:00:00	32020		\N	250763	0	65363002	372328		0
64071	3786	40481087	2003-04-24	2003-04-24 00:00:00	2003-05-15	2003-05-15 00:00:00	32020		\N	251653	0	444814009	40481087		0
64148	3789	40481087	1951-04-30	1951-04-30 00:00:00	1951-05-21	1951-05-21 00:00:00	32020		\N	251870	0	444814009	40481087		0
64264	3795	4112343	1996-11-21	1996-11-21 00:00:00	1996-12-01	1996-12-01 00:00:00	32020		\N	252326	0	195662009	4112343		0
53943	3194	4285898	1980-07-25	1980-07-25 00:00:00	\N	\N	32020		\N	212497	0	68496003	4285898		0
64689	3825	40481087	1961-09-28	1961-09-28 00:00:00	1961-10-19	1961-10-19 00:00:00	32020		\N	254054	0	444814009	40481087		0
54232	3214	40481087	1979-01-17	1979-01-17 00:00:00	1979-02-07	1979-02-07 00:00:00	32020		\N	213523	0	444814009	40481087		0
64929	3839	4278672	2012-05-26	2012-05-26 00:00:00	2012-08-24	2012-08-24 00:00:00	32020		\N	254863	0	65966004	4278672		0
54585	3232	40481087	2001-04-13	2001-04-13 00:00:00	2001-05-04	2001-05-04 00:00:00	32020		\N	214836	0	444814009	40481087		0
65248	3859	4112343	1965-03-18	1965-03-18 00:00:00	1965-03-30	1965-03-30 00:00:00	32020		\N	256207	0	195662009	4112343		0
65422	3869	80180	1943-07-03	1943-07-03 00:00:00	\N	\N	32020		\N	256855	0	396275006	80180		0
65705	3885	81151	1980-05-27	1980-05-27 00:00:00	1980-06-10	1980-06-10 00:00:00	32020		\N	258297	0	44465007	81151		0
65887	3895	40481087	2006-05-02	2006-05-02 00:00:00	2006-05-16	2006-05-16 00:00:00	32020		\N	259106	0	444814009	40481087		0
65946	3899	260139	2016-06-06	2016-06-06 00:00:00	2016-06-13	2016-06-13 00:00:00	32020		\N	259279	0	10509002	260139		0
66125	3913	80180	2001-07-05	2001-07-05 00:00:00	\N	\N	32020		\N	260109	0	396275006	80180		0
66314	3926	372328	1950-05-29	1950-05-29 00:00:00	1950-09-04	1950-09-04 00:00:00	32020		\N	260975	0	65363002	372328		0
66404	3930	40481087	1972-04-07	1972-04-07 00:00:00	1972-04-21	1972-04-21 00:00:00	32020		\N	261242	0	444814009	40481087		0
77195	4572	257012	2008-06-06	2008-06-06 00:00:00	\N	\N	32020		\N	304625	0	40055000	257012		0
66798	3951	4112343	2013-08-26	2013-08-26 00:00:00	2013-09-04	2013-09-04 00:00:00	32020		\N	262695	0	195662009	4112343		0
66970	3960	372328	1958-04-16	1958-04-16 00:00:00	1958-05-24	1958-05-24 00:00:00	32020		\N	263303	0	65363002	372328		0
67113	3968	4112343	1927-08-19	1927-08-19 00:00:00	1927-08-28	1927-08-28 00:00:00	32020		\N	263867	0	195662009	4112343		0
77900	4615	4112343	1969-04-07	1969-04-07 00:00:00	1969-04-16	1969-04-16 00:00:00	32020		\N	307426	0	195662009	4112343		0
67474	3987	4112343	1956-05-15	1956-05-15 00:00:00	1956-05-25	1956-05-25 00:00:00	32020		\N	265062	0	195662009	4112343		0
67596	3993	4112343	1988-04-17	1988-04-17 00:00:00	1988-04-27	1988-04-27 00:00:00	32020		\N	265469	0	195662009	4112343		0
57267	3397	81151	1994-09-03	1994-09-03 00:00:00	1994-09-17	1994-09-17 00:00:00	32020		\N	225352	0	44465007	81151		0
67981	4017	40481087	2004-07-03	2004-07-03 00:00:00	2004-07-10	2004-07-10 00:00:00	32020		\N	266975	0	444814009	40481087		0
68093	4021	372328	1955-02-11	1955-02-11 00:00:00	1955-04-20	1955-04-20 00:00:00	32020		\N	267317	0	65363002	372328		0
68317	4035	40481087	1972-05-27	1972-05-27 00:00:00	1972-06-17	1972-06-17 00:00:00	32020		\N	268481	0	444814009	40481087		0
68464	4049	4112343	1991-06-14	1991-06-14 00:00:00	1991-06-24	1991-06-24 00:00:00	32020		\N	269172	0	195662009	4112343		0
68583	4055	4112343	1984-08-17	1984-08-17 00:00:00	1984-08-29	1984-08-29 00:00:00	32020		\N	269526	0	195662009	4112343		0
68817	4072	40481087	2012-08-03	2012-08-03 00:00:00	2012-08-17	2012-08-17 00:00:00	32020		\N	270697	0	444814009	40481087		0
58378	3457	4112343	1960-04-26	1960-04-26 00:00:00	1960-05-03	1960-05-03 00:00:00	32020		\N	229407	0	195662009	4112343		0
69074	4087	4152936	1990-10-16	1990-10-16 00:00:00	1990-10-30	1990-10-30 00:00:00	32020		\N	271678	0	283385000	4152936		0
79848	4731	4112343	1993-01-04	1993-01-04 00:00:00	1993-01-12	1993-01-12 00:00:00	32020		\N	315195	0	195662009	4112343		0
58849	3490	28060	1950-04-22	1950-04-22 00:00:00	1950-05-02	1950-05-02 00:00:00	32020		\N	231493	0	43878008	28060		0
59069	3505	372328	1942-12-06	1942-12-06 00:00:00	1943-12-24	1943-12-24 00:00:00	32020		\N	232416	0	65363002	372328		0
69847	4133	80180	2009-10-10	2009-10-10 00:00:00	\N	\N	32020		\N	274812	0	396275006	80180		0
80581	4776	40481087	1965-09-27	1965-09-27 00:00:00	1965-10-04	1965-10-04 00:00:00	32020		\N	318005	0	444814009	40481087		0
59555	3530	78272	2001-12-05	2001-12-05 00:00:00	2001-12-26	2001-12-26 00:00:00	32020		\N	234456	0	70704007	78272		0
70312	4165	40481087	1945-12-30	1945-12-30 00:00:00	1946-01-13	1946-01-13 00:00:00	32020		\N	276742	0	444814009	40481087		0
81040	4807	260139	1957-10-24	1957-10-24 00:00:00	1957-11-07	1957-11-07 00:00:00	32020		\N	319855	0	10509002	260139		0
81185	4815	40481087	1993-04-10	1993-04-10 00:00:00	1993-04-17	1993-04-17 00:00:00	32020		\N	320337	0	444814009	40481087		0
70772	4199	4294548	1954-04-01	1954-04-01 00:00:00	1954-06-03	1954-06-03 00:00:00	32020		\N	278684	0	75498004	4294548		0
70902	4206	40481087	1955-02-07	1955-02-07 00:00:00	1955-02-14	1955-02-14 00:00:00	32020		\N	279276	0	444814009	40481087		0
60516	3578	28060	1992-06-28	1992-06-28 00:00:00	1992-07-06	1992-07-06 00:00:00	32020		\N	237869	0	43878008	28060		0
71256	4225	4027663	2006-03-29	2006-03-29 00:00:00	\N	\N	32020		\N	280609	0	13200003	4027663		0
60904	3604	260139	2000-05-06	2000-05-06 00:00:00	2000-05-20	2000-05-20 00:00:00	32020		\N	239459	0	10509002	260139		0
71647	4250	40481087	1989-08-05	1989-08-05 00:00:00	1989-08-19	1989-08-19 00:00:00	32020		\N	282292	0	444814009	40481087		0
71720	4255	40481087	1996-03-30	1996-03-30 00:00:00	1996-04-13	1996-04-13 00:00:00	32020		\N	282492	0	444814009	40481087		0
61415	3628	40481087	1998-09-25	1998-09-25 00:00:00	1998-10-16	1998-10-16 00:00:00	32020		\N	241394	0	444814009	40481087		0
61570	3638	40481087	1999-01-18	1999-01-18 00:00:00	1999-02-01	1999-02-01 00:00:00	32020		\N	241977	0	444814009	40481087		0
61696	3644	260139	1965-09-05	1965-09-05 00:00:00	1965-09-12	1965-09-12 00:00:00	32020		\N	242464	0	10509002	260139		0
72511	4308	378419	1986-04-16	1986-04-16 00:00:00	\N	\N	32020		\N	285865	0	26929004	378419		0
72658	4317	4112343	1971-03-06	1971-03-06 00:00:00	1971-03-16	1971-03-16 00:00:00	32020		\N	286553	0	195662009	4112343		0
72754	4324	4112343	2000-09-19	2000-09-19 00:00:00	2000-10-01	2000-10-01 00:00:00	32020		\N	286827	0	195662009	4112343		0
83518	4963	372328	1980-01-08	1980-01-08 00:00:00	1980-05-05	1980-05-05 00:00:00	32020		\N	329909	0	65363002	372328		0
73108	4343	260139	1997-02-27	1997-02-27 00:00:00	1997-03-13	1997-03-13 00:00:00	32020		\N	288031	0	10509002	260139		0
73223	4352	4278672	1965-11-27	1965-11-27 00:00:00	1966-01-26	1966-01-26 00:00:00	32020		\N	288648	0	65966004	4278672		0
73513	4370	40481087	1988-05-23	1988-05-23 00:00:00	1988-06-06	1988-06-06 00:00:00	32020		\N	290126	0	444814009	40481087		0
63035	3721	4112343	2000-12-17	2000-12-17 00:00:00	2000-12-24	2000-12-24 00:00:00	32020		\N	247389	0	195662009	4112343		0
73838	4387	40481087	1975-01-22	1975-01-22 00:00:00	1975-02-05	1975-02-05 00:00:00	32020		\N	291600	0	444814009	40481087		0
73977	4393	40481087	2018-04-16	2018-04-16 00:00:00	2018-05-07	2018-05-07 00:00:00	32020		\N	292115	0	444814009	40481087		0
74141	4403	40481087	1996-11-20	1996-11-20 00:00:00	1996-12-04	1996-12-04 00:00:00	32020		\N	292698	0	444814009	40481087		0
74352	4413	40481087	1975-09-25	1975-09-25 00:00:00	1975-10-16	1975-10-16 00:00:00	32020		\N	293458	0	444814009	40481087		0
63847	3772	40481087	2003-06-10	2003-06-10 00:00:00	2003-07-01	2003-07-01 00:00:00	32020		\N	250760	0	444814009	40481087		0
64072	3786	372328	1962-11-18	1962-11-18 00:00:00	1963-11-19	1963-11-19 00:00:00	32020		\N	251655	0	65363002	372328		0
64149	3789	40481087	1997-08-18	1997-08-18 00:00:00	1997-09-01	1997-09-01 00:00:00	32020		\N	251938	0	444814009	40481087		0
64265	3795	80180	2010-05-25	2010-05-25 00:00:00	\N	\N	32020		\N	252351	0	396275006	80180		0
53944	3194	4266809	1980-08-24	1980-08-24 00:00:00	\N	\N	32020		\N	212497	0	397881000	4266809		0
64690	3825	4113008	1988-12-14	1988-12-14 00:00:00	1988-12-28	1988-12-28 00:00:00	32020		\N	254067	0	284549007	4113008		0
54233	3214	4112343	1984-02-27	1984-02-27 00:00:00	1984-03-10	1984-03-10 00:00:00	32020		\N	213524	0	195662009	4112343		0
64930	3839	40481087	2013-08-08	2013-08-08 00:00:00	2013-08-29	2013-08-29 00:00:00	32020		\N	254890	0	444814009	40481087		0
54586	3232	30753	2003-09-01	2003-09-01 00:00:00	\N	\N	32020		\N	214836	0	16761005	30753		0
65249	3859	4112343	1992-04-08	1992-04-08 00:00:00	1992-04-17	1992-04-17 00:00:00	32020		\N	256275	0	195662009	4112343		0
65423	3869	378419	1987-09-26	1987-09-26 00:00:00	\N	\N	32020		\N	256876	0	26929004	378419		0
65706	3885	40481087	1966-03-05	1966-03-05 00:00:00	1966-03-19	1966-03-19 00:00:00	32020		\N	258279	0	444814009	40481087		0
65888	3895	40481087	1976-07-14	1976-07-14 00:00:00	1976-07-28	1976-07-28 00:00:00	32020		\N	259121	0	444814009	40481087		0
65947	3899	260139	1991-10-29	1991-10-29 00:00:00	1991-11-12	1991-11-12 00:00:00	32020		\N	259278	0	10509002	260139		0
66126	3913	4113008	2017-11-12	2017-11-12 00:00:00	2017-11-26	2017-11-26 00:00:00	32020		\N	260089	0	284549007	4113008		0
66315	3926	40479768	1957-05-09	1957-05-09 00:00:00	1957-07-15	1957-07-15 00:00:00	32020		\N	261006	0	444470001	40479768		0
66405	3930	4329847	1979-12-29	1979-12-29 00:00:00	\N	\N	32020		\N	261309	0	22298006	4329847		0
77196	4572	78272	1976-11-08	1976-11-08 00:00:00	1976-12-13	1976-12-13 00:00:00	32020		\N	304635	0	70704007	78272		0
66799	3951	40481087	1961-06-07	1961-06-07 00:00:00	1961-06-14	1961-06-14 00:00:00	32020		\N	262618	0	444814009	40481087		0
66971	3960	40481087	1970-09-07	1970-09-07 00:00:00	1970-09-21	1970-09-21 00:00:00	32020		\N	263251	0	444814009	40481087		0
67114	3968	40480160	2018-05-25	2018-05-25 00:00:00	2018-08-23	2018-08-23 00:00:00	32020		\N	263865	0	443165006	40480160		0
77901	4615	372328	1957-04-09	1957-04-09 00:00:00	1957-09-25	1957-09-25 00:00:00	32020		\N	307407	0	65363002	372328		0
67475	3987	80502	2014-02-22	2014-02-22 00:00:00	\N	\N	32020		\N	265059	0	64859006	80502		0
67597	3993	260139	1947-07-06	1947-07-06 00:00:00	1947-07-13	1947-07-13 00:00:00	32020		\N	265479	0	10509002	260139		0
67753	4005	4109685	2006-11-23	2006-11-23 00:00:00	2006-12-07	2006-12-07 00:00:00	32020		\N	266086	0	284551006	4109685		0
67982	4017	80180	1963-08-13	1963-08-13 00:00:00	\N	\N	32020		\N	266985	0	396275006	80180		0
68094	4021	40481087	1974-04-13	1974-04-13 00:00:00	1974-05-04	1974-05-04 00:00:00	32020		\N	267278	0	444814009	40481087		0
68354	4040	40481087	2006-10-08	2006-10-08 00:00:00	2006-10-29	2006-10-29 00:00:00	32020		\N	268672	0	444814009	40481087		0
68465	4049	372328	1961-07-03	1961-07-03 00:00:00	1961-09-12	1961-09-12 00:00:00	32020		\N	269132	0	65363002	372328		0
68584	4055	372328	1970-07-29	1970-07-29 00:00:00	1970-10-14	1970-10-14 00:00:00	32020		\N	269530	0	65363002	372328		0
68818	4072	260139	1995-10-18	1995-10-18 00:00:00	1995-11-01	1995-11-01 00:00:00	32020		\N	270694	0	10509002	260139		0
58379	3457	372328	1987-09-25	1987-09-25 00:00:00	1988-05-06	1988-05-06 00:00:00	32020		\N	229334	0	65363002	372328		0
69075	4087	260139	1988-11-20	1988-11-20 00:00:00	1988-11-27	1988-11-27 00:00:00	32020		\N	271667	0	10509002	260139		0
79849	4731	440086	1981-10-30	1981-10-30 00:00:00	1983-11-11	1983-11-11 00:00:00	32020		\N	315193	0	192127007	440086		0
58850	3490	260139	1969-10-30	1969-10-30 00:00:00	1969-11-13	1969-11-13 00:00:00	32020		\N	231490	0	10509002	260139		0
59070	3505	81893	1973-12-23	1973-12-23 00:00:00	\N	\N	32020		\N	232513	0	64766004	81893		0
69848	4133	260139	1985-04-15	1985-04-15 00:00:00	1985-04-22	1985-04-22 00:00:00	32020		\N	274764	0	10509002	260139		0
80582	4776	40481087	1986-11-22	1986-11-22 00:00:00	1986-12-06	1986-12-06 00:00:00	32020		\N	317998	0	444814009	40481087		0
59556	3530	40481087	1989-08-07	1989-08-07 00:00:00	1989-08-28	1989-08-28 00:00:00	32020		\N	234463	0	444814009	40481087		0
70313	4165	4237458	1990-08-18	1990-08-18 00:00:00	1990-11-16	1990-11-16 00:00:00	32020		\N	276827	0	58150001	4237458		0
81041	4807	4056621	2002-05-26	2002-05-26 00:00:00	\N	\N	32020		\N	319886	0	197927001	4056621		0
81186	4815	260139	2003-01-13	2003-01-13 00:00:00	2003-01-20	2003-01-20 00:00:00	32020		\N	320320	0	10509002	260139		0
70773	4199	260139	1976-01-04	1976-01-04 00:00:00	1976-01-18	1976-01-18 00:00:00	32020		\N	278624	0	10509002	260139		0
70903	4206	40481087	1965-05-26	1965-05-26 00:00:00	1965-06-09	1965-06-09 00:00:00	32020		\N	279285	0	444814009	40481087		0
60517	3578	40481087	1983-05-16	1983-05-16 00:00:00	1983-06-06	1983-06-06 00:00:00	32020		\N	237863	0	444814009	40481087		0
71257	4226	81151	1996-10-20	1996-10-20 00:00:00	1996-11-10	1996-11-10 00:00:00	32020		\N	280776	0	44465007	81151		0
60905	3604	4294548	1988-03-06	1988-03-06 00:00:00	1988-05-15	1988-05-15 00:00:00	32020		\N	239512	0	75498004	4294548		0
71648	4250	4059173	2016-05-31	2016-05-31 00:00:00	2016-06-30	2016-06-30 00:00:00	32020		\N	282265	0	16114001	4059173		0
71721	4255	4094814	1999-12-11	1999-12-11 00:00:00	2000-01-10	2000-01-10 00:00:00	32020		\N	282505	0	262574004	4094814		0
61416	3628	260139	1931-02-06	1931-02-06 00:00:00	1931-02-20	1931-02-20 00:00:00	32020		\N	241358	0	10509002	260139		0
61571	3638	40481087	1966-10-21	1966-10-21 00:00:00	1966-11-04	1966-11-04 00:00:00	32020		\N	241970	0	444814009	40481087		0
61697	3644	4142905	1962-03-04	1962-03-04 00:00:00	1962-04-03	1962-04-03 00:00:00	32020		\N	242489	0	33737001	4142905		0
72512	4308	4296205	1981-10-09	1981-10-09 00:00:00	1981-11-06	1981-11-06 00:00:00	32020		\N	285721	0	403191005	4296205		0
72659	4317	372328	1947-09-04	1947-09-04 00:00:00	1947-10-16	1947-10-16 00:00:00	32020		\N	286503	0	65363002	372328		0
72755	4324	260139	1981-08-26	1981-08-26 00:00:00	1981-09-02	1981-09-02 00:00:00	32020		\N	286838	0	10509002	260139		0
83519	4963	40481087	2011-06-06	2011-06-06 00:00:00	2011-06-13	2011-06-13 00:00:00	32020		\N	329878	0	444814009	40481087		0
73109	4343	4218389	1992-02-13	1992-02-13 00:00:00	1992-03-12	1992-03-12 00:00:00	32020		\N	288080	0	39848009	4218389		0
73224	4352	372328	1952-04-26	1952-04-26 00:00:00	1952-07-03	1952-07-03 00:00:00	32020		\N	288646	0	65363002	372328		0
73514	4370	4112343	2010-07-25	2010-07-25 00:00:00	2010-08-04	2010-08-04 00:00:00	32020		\N	290144	0	195662009	4112343		0
63036	3721	4112343	1968-03-25	1968-03-25 00:00:00	1968-04-01	1968-04-01 00:00:00	32020		\N	247355	0	195662009	4112343		0
73839	4387	40481087	1970-01-28	1970-01-28 00:00:00	1970-02-11	1970-02-11 00:00:00	32020		\N	291605	0	444814009	40481087		0
73978	4394	4112343	2004-03-13	2004-03-13 00:00:00	2004-03-21	2004-03-21 00:00:00	32020		\N	292156	0	195662009	4112343		0
74142	4403	4027663	1963-02-23	1963-02-23 00:00:00	\N	\N	32020		\N	292707	0	13200003	4027663		0
74353	4413	4112343	1962-07-13	1962-07-13 00:00:00	1962-07-21	1962-07-21 00:00:00	32020		\N	293456	0	195662009	4112343		0
63848	3772	378001	2007-06-26	2007-06-26 00:00:00	2007-07-26	2007-07-26 00:00:00	32020		\N	250673	0	62106007	378001		0
64073	3786	40481087	1959-03-15	1959-03-15 00:00:00	1959-04-05	1959-04-05 00:00:00	32020		\N	251708	0	444814009	40481087		0
64150	3789	4134304	2010-07-29	2010-07-29 00:00:00	2010-08-28	2010-08-28 00:00:00	32020		\N	251914	0	263102004	4134304		0
64266	3795	260139	2004-04-03	2004-04-03 00:00:00	2004-04-17	2004-04-17 00:00:00	32020		\N	252301	0	10509002	260139		0
53945	3194	40481087	1978-09-23	1978-09-23 00:00:00	1978-10-07	1978-10-07 00:00:00	32020		\N	212497	0	444814009	40481087		0
64691	3825	40481087	1997-07-23	1997-07-23 00:00:00	1997-07-30	1997-07-30 00:00:00	32020		\N	254062	0	444814009	40481087		0
54234	3214	4112343	2011-04-06	2011-04-06 00:00:00	2011-04-13	2011-04-13 00:00:00	32020		\N	213552	0	195662009	4112343		0
64931	3839	375671	1961-04-28	1961-04-28 00:00:00	1961-05-28	1961-05-28 00:00:00	32020		\N	254859	0	62564004	375671		0
54587	3232	4310024	2002-11-05	2002-11-05 00:00:00	\N	\N	32020		\N	214836	0	424802006	4310024		0
65250	3859	40481087	2017-12-16	2017-12-16 00:00:00	2018-01-06	2018-01-06 00:00:00	32020		\N	256263	0	444814009	40481087		0
65424	3869	81151	1943-07-16	1943-07-16 00:00:00	1943-08-06	1943-08-06 00:00:00	32020		\N	256841	0	44465007	81151		0
65707	3885	4112343	1966-10-29	1966-10-29 00:00:00	1966-11-06	1966-11-06 00:00:00	32020		\N	258280	0	195662009	4112343		0
65889	3895	40481087	2003-07-08	2003-07-08 00:00:00	2003-07-29	2003-07-29 00:00:00	32020		\N	259090	0	444814009	40481087		0
65948	3899	260139	2010-10-21	2010-10-21 00:00:00	2010-10-28	2010-10-28 00:00:00	32020		\N	259290	0	10509002	260139		0
66127	3913	40481087	2015-08-17	2015-08-17 00:00:00	2015-08-24	2015-08-24 00:00:00	32020		\N	260190	0	444814009	40481087		0
66316	3926	4218389	1977-02-14	1977-02-14 00:00:00	1977-03-14	1977-03-14 00:00:00	32020		\N	261009	0	39848009	4218389		0
66407	3930	4112343	1941-01-09	1941-01-09 00:00:00	1941-01-16	1941-01-16 00:00:00	32020		\N	261230	0	195662009	4112343		0
77197	4572	81151	1977-11-08	1977-11-08 00:00:00	1977-12-13	1977-12-13 00:00:00	32020		\N	304636	0	44465007	81151		0
66800	3951	192671	1986-09-17	1986-09-17 00:00:00	\N	\N	32020		\N	262673	0	K92.2	35208414		0
66972	3960	260139	1983-04-08	1983-04-08 00:00:00	1983-04-15	1983-04-15 00:00:00	32020		\N	263259	0	10509002	260139		0
67115	3968	4134304	2018-05-25	2018-05-25 00:00:00	2018-08-23	2018-08-23 00:00:00	32020		\N	263865	0	263102004	4134304		0
77902	4615	40481087	1955-08-26	1955-08-26 00:00:00	1955-09-16	1955-09-16 00:00:00	32020		\N	307420	0	444814009	40481087		0
67476	3987	260139	2010-08-17	2010-08-17 00:00:00	2010-08-31	2010-08-31 00:00:00	32020		\N	265073	0	10509002	260139		0
67598	3993	28060	1949-05-26	1949-05-26 00:00:00	1949-06-04	1949-06-04 00:00:00	32020		\N	265505	0	43878008	28060		0
67754	4005	4152936	1992-09-02	1992-09-02 00:00:00	1992-09-16	1992-09-16 00:00:00	32020		\N	266084	0	283385000	4152936		0
67983	4017	378419	2010-05-20	2010-05-20 00:00:00	\N	\N	32020		\N	267004	0	26929004	378419		0
68095	4021	372328	1958-04-04	1958-04-04 00:00:00	1958-06-18	1958-06-18 00:00:00	32020		\N	267281	0	65363002	372328		0
68355	4040	260139	1979-11-22	1979-11-22 00:00:00	1979-12-06	1979-12-06 00:00:00	32020		\N	268663	0	10509002	260139		0
68466	4049	4113008	1999-06-10	1999-06-10 00:00:00	1999-07-01	1999-07-01 00:00:00	32020		\N	269140	0	284549007	4113008		0
68585	4055	78272	1980-01-08	1980-01-08 00:00:00	1980-01-29	1980-01-29 00:00:00	32020		\N	269535	0	70704007	78272		0
68819	4072	372328	1975-02-04	1975-02-04 00:00:00	1975-05-17	1975-05-17 00:00:00	32020		\N	270684	0	65363002	372328		0
58380	3457	40481087	1990-11-27	1990-11-27 00:00:00	1990-12-18	1990-12-18 00:00:00	32020		\N	229325	0	444814009	40481087		0
69096	4090	40481087	2000-01-03	2000-01-03 00:00:00	2000-01-24	2000-01-24 00:00:00	32020		\N	271917	0	444814009	40481087		0
79850	4731	40481087	2013-10-30	2013-10-30 00:00:00	2013-11-13	2013-11-13 00:00:00	32020		\N	315238	0	444814009	40481087		0
58851	3490	260139	1990-04-23	1990-04-23 00:00:00	1990-04-30	1990-04-30 00:00:00	32020		\N	231626	0	10509002	260139		0
59071	3505	4112343	1973-11-05	1973-11-05 00:00:00	1973-11-17	1973-11-17 00:00:00	32020		\N	232513	0	195662009	4112343		0
69849	4133	260139	2005-05-02	2005-05-02 00:00:00	2005-05-16	2005-05-16 00:00:00	32020		\N	274786	0	10509002	260139		0
80583	4776	260139	1981-12-10	1981-12-10 00:00:00	1981-12-24	1981-12-24 00:00:00	32020		\N	317993	0	10509002	260139		0
59557	3530	40481087	1960-06-25	1960-06-25 00:00:00	1960-07-02	1960-07-02 00:00:00	32020		\N	234458	0	444814009	40481087		0
70314	4165	40481087	1997-08-05	1997-08-05 00:00:00	1997-08-19	1997-08-19 00:00:00	32020		\N	276724	0	444814009	40481087		0
81042	4807	4116491	2002-05-26	2002-05-26 00:00:00	2002-07-13	2002-07-13 00:00:00	32020		\N	319886	0	301011002	4116491		0
81187	4815	4237458	1988-08-25	1988-08-25 00:00:00	1988-10-24	1988-10-24 00:00:00	32020		\N	320334	0	58150001	4237458		0
70774	4199	260139	1994-05-29	1994-05-29 00:00:00	1994-06-05	1994-06-05 00:00:00	32020		\N	278616	0	10509002	260139		0
70904	4206	40481087	1950-11-04	1950-11-04 00:00:00	1950-11-25	1950-11-25 00:00:00	32020		\N	279294	0	444814009	40481087		0
60519	3578	372328	1973-11-25	1973-11-25 00:00:00	1974-01-09	1974-01-09 00:00:00	32020		\N	237865	0	65363002	372328		0
71258	4226	4112343	1967-06-27	1967-06-27 00:00:00	1967-07-08	1967-07-08 00:00:00	32020		\N	280650	0	195662009	4112343		0
60906	3604	81151	1990-01-03	1990-01-03 00:00:00	1990-01-31	1990-01-31 00:00:00	32020		\N	239470	0	44465007	81151		0
71649	4250	40481087	1995-05-26	1995-05-26 00:00:00	1995-06-16	1995-06-16 00:00:00	32020		\N	282289	0	444814009	40481087		0
71722	4255	4109685	2019-06-29	2019-06-29 00:00:00	\N	\N	32020		\N	282506	0	284551006	4109685		0
61572	3638	40481087	2011-03-21	2011-03-21 00:00:00	2011-04-11	2011-04-11 00:00:00	32020		\N	241991	0	444814009	40481087		0
61698	3644	81151	1977-09-11	1977-09-11 00:00:00	1977-10-02	1977-10-02 00:00:00	32020		\N	242490	0	44465007	81151		0
72513	4308	4051466	1915-08-28	1915-08-28 00:00:00	1931-12-04	1931-12-04 00:00:00	32020		\N	285714	0	233678006	4051466		0
72660	4317	40481087	1949-12-01	1949-12-01 00:00:00	1949-12-08	1949-12-08 00:00:00	32020		\N	286496	0	444814009	40481087		0
72756	4324	40481087	1976-09-26	1976-09-26 00:00:00	1976-10-17	1976-10-17 00:00:00	32020		\N	286848	0	444814009	40481087		0
83520	4963	260139	1976-05-29	1976-05-29 00:00:00	1976-06-05	1976-06-05 00:00:00	32020		\N	329897	0	10509002	260139		0
73110	4343	260139	1994-01-28	1994-01-28 00:00:00	1994-02-11	1994-02-11 00:00:00	32020		\N	288052	0	10509002	260139		0
73225	4352	40481087	1990-05-27	1990-05-27 00:00:00	1990-06-17	1990-06-17 00:00:00	32020		\N	288670	0	444814009	40481087		0
73515	4370	4112343	1977-04-02	1977-04-02 00:00:00	1977-04-15	1977-04-15 00:00:00	32020		\N	290142	0	195662009	4112343		0
63037	3721	40481087	1975-09-19	1975-09-19 00:00:00	1975-09-26	1975-09-26 00:00:00	32020		\N	247332	0	444814009	40481087		0
73840	4387	40481087	1994-09-28	1994-09-28 00:00:00	1994-10-05	1994-10-05 00:00:00	32020		\N	291590	0	444814009	40481087		0
73979	4394	4112343	1985-05-28	1985-05-28 00:00:00	1985-06-07	1985-06-07 00:00:00	32020		\N	292138	0	195662009	4112343		0
74143	4403	4109685	1962-06-29	1962-06-29 00:00:00	1962-07-13	1962-07-13 00:00:00	32020		\N	292707	0	284551006	4109685		0
74354	4413	260139	1965-09-15	1965-09-15 00:00:00	1965-09-29	1965-09-29 00:00:00	32020		\N	293426	0	10509002	260139		0
63849	3772	4084167	1983-01-03	1983-01-03 00:00:00	1983-01-03	1983-01-03 00:00:00	32020		\N	250672	0	241929008	4084167		0
64074	3786	40481087	1972-05-06	1972-05-06 00:00:00	1972-05-20	1972-05-20 00:00:00	32020		\N	251699	0	444814009	40481087		0
64151	3789	260139	2006-06-10	2006-06-10 00:00:00	2006-06-24	2006-06-24 00:00:00	32020		\N	251881	0	10509002	260139		0
64267	3795	40481087	1979-03-21	1979-03-21 00:00:00	1979-04-11	1979-04-11 00:00:00	32020		\N	252310	0	444814009	40481087		0
53946	3194	40481087	1977-06-09	1977-06-09 00:00:00	1977-06-23	1977-06-23 00:00:00	32020		\N	212464	0	444814009	40481087		0
64692	3825	4112343	1998-12-30	1998-12-30 00:00:00	1999-01-10	1999-01-10 00:00:00	32020		\N	254109	0	195662009	4112343		0
54235	3214	4310024	2007-06-06	2007-06-06 00:00:00	\N	\N	32020		\N	213548	0	424802006	4310024		0
64932	3839	4294548	1962-06-20	1962-06-20 00:00:00	1962-07-18	1962-07-18 00:00:00	32020		\N	254838	0	75498004	4294548		0
54588	3232	4027663	1994-09-08	1994-09-08 00:00:00	\N	\N	32020		\N	214823	0	13200003	4027663		0
65251	3859	40481087	1954-02-05	1954-02-05 00:00:00	1954-02-19	1954-02-19 00:00:00	32020		\N	256158	0	444814009	40481087		0
65425	3869	372328	1914-10-26	1914-10-26 00:00:00	1915-04-03	1915-04-03 00:00:00	32020		\N	256914	0	65363002	372328		0
65708	3885	40481087	1969-09-02	1969-09-02 00:00:00	1969-09-23	1969-09-23 00:00:00	32020		\N	258254	0	444814009	40481087		0
65890	3895	372328	1925-08-26	1925-08-26 00:00:00	1925-11-13	1925-11-13 00:00:00	32020		\N	259092	0	65363002	372328		0
65949	3899	4134304	2018-08-09	2018-08-09 00:00:00	2018-11-07	2018-11-07 00:00:00	32020		\N	259249	0	263102004	4134304		0
66128	3913	40481087	1986-08-09	1986-08-09 00:00:00	1986-08-16	1986-08-16 00:00:00	32020		\N	260173	0	444814009	40481087		0
66317	3926	261325	1981-10-12	1981-10-12 00:00:00	\N	\N	32020		\N	260948	0	87433001	261325		0
66408	3930	80180	1957-11-06	1957-11-06 00:00:00	\N	\N	32020		\N	261287	0	396275006	80180		0
77198	4572	372328	1978-05-02	1978-05-02 00:00:00	1978-10-17	1978-10-17 00:00:00	32020		\N	304611	0	65363002	372328		0
66801	3951	4112343	1955-11-18	1955-11-18 00:00:00	1955-11-25	1955-11-25 00:00:00	32020		\N	262616	0	195662009	4112343		0
66973	3960	192671	1997-06-12	1997-06-12 00:00:00	\N	\N	32020		\N	263314	0	K92.2	35208414		0
67116	3968	260139	1968-08-28	1968-08-28 00:00:00	1968-09-04	1968-09-04 00:00:00	32020		\N	263833	0	10509002	260139		0
77903	4615	40481087	2006-07-29	2006-07-29 00:00:00	2006-08-19	2006-08-19 00:00:00	32020		\N	307396	0	444814009	40481087		0
67477	3987	28060	1965-12-06	1965-12-06 00:00:00	1965-12-17	1965-12-17 00:00:00	32020		\N	265039	0	43878008	28060		0
67599	3993	80180	1980-08-09	1980-08-09 00:00:00	\N	\N	32020		\N	265454	0	396275006	80180		0
67755	4005	28060	2013-09-08	2013-09-08 00:00:00	2013-09-19	2013-09-19 00:00:00	32020		\N	266119	0	43878008	28060		0
67984	4017	4112343	1927-07-10	1927-07-10 00:00:00	1927-07-17	1927-07-17 00:00:00	32020		\N	266943	0	195662009	4112343		0
68096	4021	134438	1984-01-12	1984-01-12 00:00:00	1985-11-02	1985-11-02 00:00:00	32020		\N	267314	0	40275004	134438		0
68356	4040	40481087	2005-11-20	2005-11-20 00:00:00	2005-12-04	2005-12-04 00:00:00	32020		\N	268684	0	444814009	40481087		0
68467	4049	4294548	2009-04-21	2009-04-21 00:00:00	2009-05-12	2009-05-12 00:00:00	32020		\N	269164	0	75498004	4294548		0
68673	4064	4237458	2004-02-23	2004-02-23 00:00:00	2004-05-23	2004-05-23 00:00:00	32020		\N	270124	0	58150001	4237458		0
68820	4072	40481087	2011-05-12	2011-05-12 00:00:00	2011-06-02	2011-06-02 00:00:00	32020		\N	270672	0	444814009	40481087		0
58381	3457	40481087	1942-06-24	1942-06-24 00:00:00	1942-07-08	1942-07-08 00:00:00	32020		\N	229409	0	444814009	40481087		0
69097	4090	40481087	1991-03-28	1991-03-28 00:00:00	1991-04-11	1991-04-11 00:00:00	32020		\N	271855	0	444814009	40481087		0
79851	4731	372328	1975-01-15	1975-01-15 00:00:00	1975-04-08	1975-04-08 00:00:00	32020		\N	315239	0	65363002	372328		0
58852	3490	4112343	1987-11-16	1987-11-16 00:00:00	1987-11-24	1987-11-24 00:00:00	32020		\N	231594	0	195662009	4112343		0
59072	3505	4285898	1975-09-14	1975-09-14 00:00:00	\N	\N	32020		\N	232513	0	68496003	4285898		0
69850	4133	4027663	2001-07-24	2001-07-24 00:00:00	\N	\N	32020		\N	274761	0	13200003	4027663		0
80584	4776	40481087	2001-01-30	2001-01-30 00:00:00	2001-02-06	2001-02-06 00:00:00	32020		\N	317995	0	444814009	40481087		0
59558	3530	4109685	1968-12-02	1968-12-02 00:00:00	1968-12-23	1968-12-23 00:00:00	32020		\N	234453	0	284551006	4109685		0
70315	4165	260139	1912-03-15	1912-03-15 00:00:00	1912-03-29	1912-03-29 00:00:00	32020		\N	276694	0	10509002	260139		0
81043	4807	260139	2005-02-22	2005-02-22 00:00:00	2005-03-08	2005-03-08 00:00:00	32020		\N	319887	0	10509002	260139		0
81188	4815	28060	1970-12-31	1970-12-31 00:00:00	1971-01-08	1971-01-08 00:00:00	32020		\N	320318	0	43878008	28060		0
70775	4199	4112343	1956-02-01	1956-02-01 00:00:00	1956-02-13	1956-02-13 00:00:00	32020		\N	278685	0	195662009	4112343		0
70905	4206	260139	1961-03-07	1961-03-07 00:00:00	1961-03-21	1961-03-21 00:00:00	32020		\N	279295	0	10509002	260139		0
60520	3578	4112343	1976-08-28	1976-08-28 00:00:00	1976-09-07	1976-09-07 00:00:00	32020		\N	237862	0	195662009	4112343		0
71259	4226	4112343	1987-09-04	1987-09-04 00:00:00	1987-09-17	1987-09-17 00:00:00	32020		\N	280693	0	195662009	4112343		0
71381	4235	40481087	1990-01-22	1990-01-22 00:00:00	1990-01-29	1990-01-29 00:00:00	32020		\N	281178	0	444814009	40481087		0
71650	4250	40481087	1998-02-22	1998-02-22 00:00:00	1998-03-08	1998-03-08 00:00:00	32020		\N	282243	0	444814009	40481087		0
71723	4255	40481087	1974-10-10	1974-10-10 00:00:00	1974-10-17	1974-10-17 00:00:00	32020		\N	282525	0	444814009	40481087		0
61418	3628	260139	1926-09-11	1926-09-11 00:00:00	1926-09-25	1926-09-25 00:00:00	32020		\N	241404	0	10509002	260139		0
61573	3638	40481087	1985-08-04	1985-08-04 00:00:00	1985-08-11	1985-08-11 00:00:00	32020		\N	241996	0	444814009	40481087		0
61699	3644	260139	1956-08-03	1956-08-03 00:00:00	1956-08-17	1956-08-17 00:00:00	32020		\N	242503	0	10509002	260139		0
72514	4308	40481087	1923-12-03	1923-12-03 00:00:00	1923-12-24	1923-12-24 00:00:00	32020		\N	285735	0	444814009	40481087		0
72661	4317	40481087	1973-10-15	1973-10-15 00:00:00	1973-10-22	1973-10-22 00:00:00	32020		\N	286554	0	444814009	40481087		0
72757	4324	40481087	2003-11-22	2003-11-22 00:00:00	2003-12-13	2003-12-13 00:00:00	32020		\N	286812	0	444814009	40481087		0
83521	4964	81151	1965-01-08	1965-01-08 00:00:00	1965-01-22	1965-01-22 00:00:00	32020		\N	329969	0	44465007	81151		0
73111	4343	40481087	1979-07-01	1979-07-01 00:00:00	1979-07-08	1979-07-08 00:00:00	32020		\N	287992	0	444814009	40481087		0
73226	4352	260139	2018-08-14	2018-08-14 00:00:00	2018-08-21	2018-08-21 00:00:00	32020		\N	288644	0	10509002	260139		0
73516	4370	260139	1968-08-30	1968-08-30 00:00:00	1968-09-13	1968-09-13 00:00:00	32020		\N	290125	0	10509002	260139		0
63038	3721	372328	1964-03-14	1964-03-14 00:00:00	1964-04-24	1964-04-24 00:00:00	32020		\N	247391	0	65363002	372328		0
73841	4387	4112343	1992-06-06	1992-06-06 00:00:00	1992-06-17	1992-06-17 00:00:00	32020		\N	291602	0	195662009	4112343		0
73980	4394	40481087	1983-11-26	1983-11-26 00:00:00	1983-12-17	1983-12-17 00:00:00	32020		\N	292137	0	444814009	40481087		0
74144	4403	4266809	1973-08-09	1973-08-09 00:00:00	\N	\N	32020		\N	292648	0	397881000	4266809		0
74355	4413	40481087	1968-05-06	1968-05-06 00:00:00	1968-05-27	1968-05-27 00:00:00	32020		\N	293427	0	444814009	40481087		0
63850	3772	40481087	2005-08-25	2005-08-25 00:00:00	2005-09-01	2005-09-01 00:00:00	32020		\N	250739	0	444814009	40481087		0
64075	3786	4113008	1978-02-27	1978-02-27 00:00:00	1978-03-13	1978-03-13 00:00:00	32020		\N	251689	0	284549007	4113008		0
64152	3789	4112343	1953-08-12	1953-08-12 00:00:00	1953-08-21	1953-08-21 00:00:00	32020		\N	251934	0	195662009	4112343		0
64268	3795	40481087	2011-05-05	2011-05-05 00:00:00	2011-05-26	2011-05-26 00:00:00	32020		\N	252305	0	444814009	40481087		0
53947	3194	4027663	1973-06-07	1973-06-07 00:00:00	\N	\N	32020		\N	212489	0	13200003	4027663		0
64693	3825	4116491	1988-06-02	1988-06-02 00:00:00	1988-08-01	1988-08-01 00:00:00	32020		\N	254108	0	301011002	4116491		0
54236	3214	30753	2007-12-03	2007-12-03 00:00:00	\N	\N	32020		\N	213548	0	16761005	30753		0
64933	3839	80180	1994-06-24	1994-06-24 00:00:00	\N	\N	32020		\N	254888	0	396275006	80180		0
54589	3232	80180	2004-06-27	2004-06-27 00:00:00	\N	\N	32020		\N	214844	0	396275006	80180		0
65252	3859	40481087	1952-09-27	1952-09-27 00:00:00	1952-10-04	1952-10-04 00:00:00	32020		\N	256175	0	444814009	40481087		0
65426	3869	4112343	1934-08-18	1934-08-18 00:00:00	1934-08-31	1934-08-31 00:00:00	32020		\N	256925	0	195662009	4112343		0
65709	3885	4116491	1995-11-08	1995-11-08 00:00:00	1996-01-05	1996-01-05 00:00:00	32020		\N	258214	0	301011002	4116491		0
65891	3895	40481087	2003-02-22	2003-02-22 00:00:00	2003-03-01	2003-03-01 00:00:00	32020		\N	259059	0	444814009	40481087		0
65950	3899	78272	1998-08-19	1998-08-19 00:00:00	1998-09-23	1998-09-23 00:00:00	32020		\N	259248	0	70704007	78272		0
66129	3913	40481087	1989-05-08	1989-05-08 00:00:00	1989-05-29	1989-05-29 00:00:00	32020		\N	260126	0	444814009	40481087		0
66318	3926	372328	1948-05-26	1948-05-26 00:00:00	1948-09-06	1948-09-06 00:00:00	32020		\N	260987	0	65363002	372328		0
66409	3930	372328	1916-01-29	1916-01-29 00:00:00	1916-08-05	1916-08-05 00:00:00	32020		\N	261243	0	65363002	372328		0
77204	4574	372328	1958-10-02	1958-10-02 00:00:00	1959-02-20	1959-02-20 00:00:00	32020		\N	304747	0	65363002	372328		0
66834	3955	260139	2007-03-02	2007-03-02 00:00:00	2007-03-09	2007-03-09 00:00:00	32020		\N	262859	0	10509002	260139		0
66974	3960	40481087	2018-11-26	2018-11-26 00:00:00	2018-12-03	2018-12-03 00:00:00	32020		\N	263302	0	444814009	40481087		0
67117	3968	4112343	1996-01-12	1996-01-12 00:00:00	1996-01-19	1996-01-19 00:00:00	32020		\N	263928	0	195662009	4112343		0
77904	4615	4112343	2019-02-08	2019-02-08 00:00:00	2019-02-20	2019-02-20 00:00:00	32020		\N	307457	0	195662009	4112343		0
67478	3987	4059173	2008-03-01	2008-03-01 00:00:00	2008-04-30	2008-04-30 00:00:00	32020		\N	265029	0	16114001	4059173		0
67600	3993	40481087	2011-07-10	2011-07-10 00:00:00	2011-07-31	2011-07-31 00:00:00	32020		\N	265485	0	444814009	40481087		0
67756	4005	80180	2012-03-27	2012-03-27 00:00:00	\N	\N	32020		\N	266068	0	396275006	80180		0
67985	4017	40481087	1966-09-17	1966-09-17 00:00:00	1966-09-24	1966-09-24 00:00:00	32020		\N	266945	0	444814009	40481087		0
68097	4021	4296204	2010-02-09	2010-02-09 00:00:00	2010-02-23	2010-02-23 00:00:00	32020		\N	267348	0	403190006	4296204		0
68357	4040	4027663	2006-02-01	2006-02-01 00:00:00	\N	\N	32020		\N	268684	0	13200003	4027663		0
68468	4049	260139	1990-10-27	1990-10-27 00:00:00	1990-11-03	1990-11-03 00:00:00	32020		\N	269163	0	10509002	260139		0
68674	4064	4134304	1969-11-18	1969-11-18 00:00:00	1970-02-16	1970-02-16 00:00:00	32020		\N	269997	0	263102004	4134304		0
68821	4072	80180	2011-11-17	2011-11-17 00:00:00	\N	\N	32020		\N	270672	0	396275006	80180		0
58382	3457	257012	1980-03-08	1980-03-08 00:00:00	\N	\N	32020		\N	229421	0	40055000	257012		0
69098	4090	378001	1953-10-21	1953-10-21 00:00:00	1953-12-20	1953-12-20 00:00:00	32020		\N	271932	0	62106007	378001		0
79852	4731	40481087	2006-01-20	2006-01-20 00:00:00	2006-02-03	2006-02-03 00:00:00	32020		\N	315236	0	444814009	40481087		0
58853	3490	81151	1954-11-24	1954-11-24 00:00:00	1954-12-29	1954-12-29 00:00:00	32020		\N	231515	0	44465007	81151		0
59073	3505	260139	1970-02-10	1970-02-10 00:00:00	1970-02-24	1970-02-24 00:00:00	32020		\N	232439	0	10509002	260139		0
69851	4133	40481087	1993-09-19	1993-09-19 00:00:00	1993-09-26	1993-09-26 00:00:00	32020		\N	274766	0	444814009	40481087		0
80585	4776	80180	2001-01-17	2001-01-17 00:00:00	\N	\N	32020		\N	318020	0	396275006	80180		0
59559	3530	40481087	1970-04-06	1970-04-06 00:00:00	1970-04-27	1970-04-27 00:00:00	32020		\N	234497	0	444814009	40481087		0
70316	4165	4112343	1958-02-25	1958-02-25 00:00:00	1958-03-05	1958-03-05 00:00:00	32020		\N	276745	0	195662009	4112343		0
81044	4807	440086	1953-03-27	1953-03-27 00:00:00	1963-04-04	1963-04-04 00:00:00	32020		\N	319803	0	192127007	440086		0
81189	4815	4112343	1997-02-26	1997-02-26 00:00:00	1997-03-05	1997-03-05 00:00:00	32020		\N	320329	0	195662009	4112343		0
70776	4199	40481087	1987-08-30	1987-08-30 00:00:00	1987-09-13	1987-09-13 00:00:00	32020		\N	278668	0	444814009	40481087		0
70906	4206	260139	1973-01-29	1973-01-29 00:00:00	1973-02-12	1973-02-12 00:00:00	32020		\N	279286	0	10509002	260139		0
60521	3578	40481087	1987-01-04	1987-01-04 00:00:00	1987-01-18	1987-01-18 00:00:00	32020		\N	237852	0	444814009	40481087		0
71260	4226	260139	1975-04-15	1975-04-15 00:00:00	1975-04-22	1975-04-22 00:00:00	32020		\N	280764	0	10509002	260139		0
71382	4235	4266809	2014-02-05	2014-02-05 00:00:00	\N	\N	32020		\N	281213	0	397881000	4266809		0
71651	4250	4116491	1964-02-27	1964-02-27 00:00:00	1964-04-12	1964-04-12 00:00:00	32020		\N	282325	0	301011002	4116491		0
71724	4255	40481087	2006-10-11	2006-10-11 00:00:00	2006-10-25	2006-10-25 00:00:00	32020		\N	282528	0	444814009	40481087		0
61419	3629	40479768	1973-05-20	1973-05-20 00:00:00	1973-07-26	1973-07-26 00:00:00	32020		\N	241471	0	444470001	40479768		0
61574	3638	4059173	2001-01-17	2001-01-17 00:00:00	2001-02-16	2001-02-16 00:00:00	32020		\N	241968	0	16114001	4059173		0
61700	3644	378001	1957-02-28	1957-02-28 00:00:00	1957-04-29	1957-04-29 00:00:00	32020		\N	242488	0	62106007	378001		0
72515	4308	260139	1956-11-14	1956-11-14 00:00:00	1956-11-21	1956-11-21 00:00:00	32020		\N	285751	0	10509002	260139		0
72662	4317	260139	1977-11-23	1977-11-23 00:00:00	1977-11-30	1977-11-30 00:00:00	32020		\N	286508	0	10509002	260139		0
72758	4324	260139	2010-11-01	2010-11-01 00:00:00	2010-11-08	2010-11-08 00:00:00	32020		\N	286828	0	10509002	260139		0
83522	4964	4112343	2013-02-07	2013-02-07 00:00:00	2013-02-20	2013-02-20 00:00:00	32020		\N	330032	0	195662009	4112343		0
73112	4343	4112343	2005-11-22	2005-11-22 00:00:00	2005-12-03	2005-12-03 00:00:00	32020		\N	287995	0	195662009	4112343		0
73227	4352	372328	1949-02-24	1949-02-24 00:00:00	1949-04-07	1949-04-07 00:00:00	32020		\N	288645	0	65363002	372328		0
73517	4370	4112343	2011-06-02	2011-06-02 00:00:00	2011-06-09	2011-06-09 00:00:00	32020		\N	290145	0	195662009	4112343		0
63039	3721	40481087	1978-12-17	1978-12-17 00:00:00	1979-01-07	1979-01-07 00:00:00	32020		\N	247326	0	444814009	40481087		0
73842	4387	28060	1974-11-13	1974-11-13 00:00:00	1974-11-25	1974-11-25 00:00:00	32020		\N	291589	0	43878008	28060		0
73981	4394	81151	1978-02-18	1978-02-18 00:00:00	1978-03-11	1978-03-11 00:00:00	32020		\N	292167	0	44465007	81151		0
74145	4403	80180	1973-08-09	1973-08-09 00:00:00	\N	\N	32020		\N	292648	0	396275006	80180		0
74356	4413	28060	1961-10-08	1961-10-08 00:00:00	1961-10-15	1961-10-15 00:00:00	32020		\N	293489	0	43878008	28060		0
63851	3772	4112343	2018-06-01	2018-06-01 00:00:00	2018-06-13	2018-06-13 00:00:00	32020		\N	250714	0	195662009	4112343		0
64076	3786	260139	2002-07-25	2002-07-25 00:00:00	2002-08-08	2002-08-08 00:00:00	32020		\N	251716	0	10509002	260139		0
64153	3789	372328	1976-04-15	1976-04-15 00:00:00	1977-12-08	1977-12-08 00:00:00	32020		\N	251887	0	65363002	372328		0
64269	3795	40481087	1985-05-18	1985-05-18 00:00:00	1985-05-25	1985-05-25 00:00:00	32020		\N	252300	0	444814009	40481087		0
53948	3194	317576	1971-01-11	1971-01-11 00:00:00	\N	\N	32020		\N	212489	0	53741008	317576		0
64694	3825	260139	1958-08-15	1958-08-15 00:00:00	1958-08-29	1958-08-29 00:00:00	32020		\N	254080	0	10509002	260139		0
54237	3214	80180	2008-11-27	2008-11-27 00:00:00	\N	\N	32020		\N	213548	0	396275006	80180		0
64934	3839	30753	1993-01-30	1993-01-30 00:00:00	\N	\N	32020		\N	254888	0	16761005	30753		0
54590	3232	4266809	2004-06-27	2004-06-27 00:00:00	\N	\N	32020		\N	214844	0	397881000	4266809		0
65253	3859	80502	1993-03-06	1993-03-06 00:00:00	\N	\N	32020		\N	256153	0	64859006	80502		0
65427	3869	40481087	1929-01-06	1929-01-06 00:00:00	1929-01-27	1929-01-27 00:00:00	32020		\N	256893	0	444814009	40481087		0
65710	3885	40481087	1969-07-20	1969-07-20 00:00:00	1969-07-27	1969-07-27 00:00:00	32020		\N	258212	0	444814009	40481087		0
65892	3895	4112343	1980-09-22	1980-09-22 00:00:00	1980-10-02	1980-10-02 00:00:00	32020		\N	259052	0	195662009	4112343		0
65951	3900	4310024	1997-07-26	1997-07-26 00:00:00	\N	\N	32020		\N	259316	0	424802006	4310024		0
66130	3913	260139	1972-01-01	1972-01-01 00:00:00	1972-01-15	1972-01-15 00:00:00	32020		\N	260171	0	10509002	260139		0
66319	3926	4112343	1986-09-23	1986-09-23 00:00:00	1986-10-01	1986-10-01 00:00:00	32020		\N	260980	0	195662009	4112343		0
66410	3930	4112343	1956-06-14	1956-06-14 00:00:00	1956-06-27	1956-06-27 00:00:00	32020		\N	261265	0	195662009	4112343		0
77205	4574	439777	1974-03-12	1974-03-12 00:00:00	\N	\N	32020		\N	304682	0	271737000	439777		0
66835	3955	78272	1976-03-20	1976-03-20 00:00:00	1976-04-03	1976-04-03 00:00:00	32020		\N	262844	0	70704007	78272		0
66975	3960	78272	1966-10-01	1966-10-01 00:00:00	1966-10-29	1966-10-29 00:00:00	32020		\N	263311	0	70704007	78272		0
67118	3968	40481087	1919-04-23	1919-04-23 00:00:00	1919-05-07	1919-05-07 00:00:00	32020		\N	263866	0	444814009	40481087		0
77905	4615	4116491	1988-04-11	1988-04-11 00:00:00	1988-05-22	1988-05-22 00:00:00	32020		\N	307422	0	301011002	4116491		0
67486	3989	40481087	1941-03-22	1941-03-22 00:00:00	1941-04-12	1941-04-12 00:00:00	32020		\N	265151	0	444814009	40481087		0
67601	3993	28060	1965-04-15	1965-04-15 00:00:00	1965-04-23	1965-04-23 00:00:00	32020		\N	265482	0	43878008	28060		0
67757	4005	378001	1982-06-27	1982-06-27 00:00:00	1982-07-27	1982-07-27 00:00:00	32020		\N	266083	0	62106007	378001		0
67986	4017	260139	1930-02-08	1930-02-08 00:00:00	1930-02-22	1930-02-22 00:00:00	32020		\N	267033	0	10509002	260139		0
68098	4021	40481087	1965-11-28	1965-11-28 00:00:00	1965-12-19	1965-12-19 00:00:00	32020		\N	267292	0	444814009	40481087		0
68358	4040	4113008	1982-11-04	1982-11-04 00:00:00	1982-11-18	1982-11-18 00:00:00	32020		\N	268659	0	284549007	4113008		0
68469	4049	4113008	1974-08-08	1974-08-08 00:00:00	1974-08-22	1974-08-22 00:00:00	32020		\N	269136	0	284549007	4113008		0
68675	4064	80180	1997-12-16	1997-12-16 00:00:00	\N	\N	32020		\N	270106	0	396275006	80180		0
68822	4072	40481087	1982-02-25	1982-02-25 00:00:00	1982-03-11	1982-03-11 00:00:00	32020		\N	270668	0	444814009	40481087		0
58383	3457	40481087	2012-03-31	2012-03-31 00:00:00	2012-04-21	2012-04-21 00:00:00	32020		\N	229328	0	444814009	40481087		0
69099	4090	321042	2015-03-23	2015-03-23 00:00:00	\N	\N	32020		\N	271940	0	410429000	321042		0
79853	4731	4112343	1979-10-03	1979-10-03 00:00:00	1979-10-11	1979-10-11 00:00:00	32020		\N	315228	0	195662009	4112343		0
58854	3490	4278672	1956-01-23	1956-01-23 00:00:00	1956-04-22	1956-04-22 00:00:00	32020		\N	231516	0	65966004	4278672		0
59074	3505	28060	1977-07-01	1977-07-01 00:00:00	1977-07-09	1977-07-09 00:00:00	32020		\N	232399	0	43878008	28060		0
69852	4133	378001	1982-07-13	1982-07-13 00:00:00	1982-09-11	1982-09-11 00:00:00	32020		\N	274780	0	62106007	378001		0
80586	4776	260139	1965-02-21	1965-02-21 00:00:00	1965-03-07	1965-03-07 00:00:00	32020		\N	318041	0	10509002	260139		0
59560	3531	4116491	1994-03-22	1994-03-22 00:00:00	1994-05-15	1994-05-15 00:00:00	32020		\N	234522	0	301011002	4116491		0
70317	4165	4112343	1960-02-27	1960-02-27 00:00:00	1960-03-05	1960-03-05 00:00:00	32020		\N	276747	0	195662009	4112343		0
81045	4807	260139	2012-04-08	2012-04-08 00:00:00	2012-04-22	2012-04-22 00:00:00	32020		\N	319888	0	10509002	260139		0
81190	4815	40481087	2007-08-01	2007-08-01 00:00:00	2007-08-22	2007-08-22 00:00:00	32020		\N	320321	0	444814009	40481087		0
70777	4199	4296205	1970-06-14	1970-06-14 00:00:00	1970-06-28	1970-06-28 00:00:00	32020		\N	278707	0	403191005	4296205		0
70907	4206	80180	1984-06-12	1984-06-12 00:00:00	\N	\N	32020		\N	279333	0	396275006	80180		0
60522	3578	40481087	1976-11-18	1976-11-18 00:00:00	1976-12-09	1976-12-09 00:00:00	32020		\N	237874	0	444814009	40481087		0
71261	4226	372328	1967-07-16	1967-07-16 00:00:00	1968-07-14	1968-07-14 00:00:00	32020		\N	280661	0	65363002	372328		0
71383	4235	4218389	2012-11-14	2012-11-14 00:00:00	2012-12-05	2012-12-05 00:00:00	32020		\N	281213	0	39848009	4218389		0
71652	4250	4109685	1949-01-11	1949-01-11 00:00:00	1949-01-25	1949-01-25 00:00:00	32020		\N	282261	0	284551006	4109685		0
71725	4255	81151	1986-08-30	1986-08-30 00:00:00	1986-09-20	1986-09-20 00:00:00	32020		\N	282504	0	44465007	81151		0
61420	3629	4113008	1992-03-02	1992-03-02 00:00:00	1992-03-23	1992-03-23 00:00:00	32020		\N	241473	0	284549007	4113008		0
61575	3638	4112343	1977-05-15	1977-05-15 00:00:00	1977-05-24	1977-05-24 00:00:00	32020		\N	241986	0	195662009	4112343		0
61701	3644	317576	1947-12-31	1947-12-31 00:00:00	\N	\N	32020		\N	242484	0	53741008	317576		0
72516	4308	78272	1921-10-03	1921-10-03 00:00:00	1921-10-24	1921-10-24 00:00:00	32020		\N	285771	0	70704007	78272		0
72663	4317	4112343	1955-02-06	1955-02-06 00:00:00	1955-02-18	1955-02-18 00:00:00	32020		\N	286497	0	195662009	4112343		0
72759	4324	4112343	1984-08-29	1984-08-29 00:00:00	1984-09-10	1984-09-10 00:00:00	32020		\N	286839	0	195662009	4112343		0
83523	4964	4112343	1968-01-16	1968-01-16 00:00:00	1968-01-28	1968-01-28 00:00:00	32020		\N	330031	0	195662009	4112343		0
73113	4343	4155034	2009-10-23	2009-10-23 00:00:00	2009-11-06	2009-11-06 00:00:00	32020		\N	288082	0	283371005	4155034		0
73228	4352	260139	1985-04-17	1985-04-17 00:00:00	1985-05-01	1985-05-01 00:00:00	32020		\N	288638	0	10509002	260139		0
73518	4370	81151	1964-09-18	1964-09-18 00:00:00	1964-10-16	1964-10-16 00:00:00	32020		\N	290118	0	44465007	81151		0
63067	3725	28060	2016-03-20	2016-03-20 00:00:00	2016-04-01	2016-04-01 00:00:00	32020		\N	247567	0	43878008	28060		0
73843	4387	28060	1990-01-05	1990-01-05 00:00:00	1990-01-17	1990-01-17 00:00:00	32020		\N	291601	0	43878008	28060		0
73982	4394	80180	2013-02-04	2013-02-04 00:00:00	\N	\N	32020		\N	292189	0	396275006	80180		0
74155	4405	260139	1975-12-26	1975-12-26 00:00:00	1976-01-09	1976-01-09 00:00:00	32020		\N	292783	0	10509002	260139		0
74357	4413	4113008	1975-08-22	1975-08-22 00:00:00	1975-09-12	1975-09-12 00:00:00	32020		\N	293416	0	284549007	4113008		0
63852	3772	80180	2007-10-29	2007-10-29 00:00:00	\N	\N	32020		\N	250761	0	396275006	80180		0
74552	4428	40481087	1997-09-03	1997-09-03 00:00:00	1997-09-24	1997-09-24 00:00:00	32020		\N	294414	0	444814009	40481087		0
64154	3789	80180	1977-03-01	1977-03-01 00:00:00	\N	\N	32020		\N	251887	0	396275006	80180		0
64270	3795	4112343	1994-04-26	1994-04-26 00:00:00	1994-05-03	1994-05-03 00:00:00	32020		\N	252311	0	195662009	4112343		0
53950	3194	321042	1983-03-28	1983-03-28 00:00:00	\N	\N	32020		\N	212460	0	410429000	321042		0
64695	3825	40481087	2017-09-19	2017-09-19 00:00:00	2017-09-26	2017-09-26 00:00:00	32020		\N	254072	0	444814009	40481087		0
54238	3214	40481087	1991-11-06	1991-11-06 00:00:00	1991-11-13	1991-11-13 00:00:00	32020		\N	213547	0	444814009	40481087		0
64935	3839	4134304	2017-04-30	2017-04-30 00:00:00	2017-05-30	2017-05-30 00:00:00	32020		\N	254864	0	263102004	4134304		0
54591	3232	40481087	1967-02-02	1967-02-02 00:00:00	1967-02-23	1967-02-23 00:00:00	32020		\N	214835	0	444814009	40481087		0
65254	3859	40481087	1950-08-18	1950-08-18 00:00:00	1950-09-01	1950-09-01 00:00:00	32020		\N	256174	0	444814009	40481087		0
65428	3869	372328	1909-05-17	1909-05-17 00:00:00	1909-07-24	1909-07-24 00:00:00	32020		\N	256944	0	65363002	372328		0
65711	3885	4296205	1973-09-10	1973-09-10 00:00:00	1973-10-01	1973-10-01 00:00:00	32020		\N	258296	0	403191005	4296205		0
65893	3895	40481087	1938-02-13	1938-02-13 00:00:00	1938-02-20	1938-02-20 00:00:00	32020		\N	259116	0	444814009	40481087		0
65952	3900	30753	1998-03-23	1998-03-23 00:00:00	\N	\N	32020		\N	259316	0	16761005	30753		0
66131	3913	28060	1979-06-24	1979-06-24 00:00:00	1979-07-01	1979-07-01 00:00:00	32020		\N	260172	0	43878008	28060		0
66320	3926	4112343	2017-07-10	2017-07-10 00:00:00	2017-07-22	2017-07-22 00:00:00	32020		\N	260974	0	195662009	4112343		0
66411	3930	81151	1945-07-13	1945-07-13 00:00:00	1945-07-27	1945-07-27 00:00:00	32020		\N	261308	0	44465007	81151		0
77206	4574	40481087	1960-11-26	1960-11-26 00:00:00	1960-12-17	1960-12-17 00:00:00	32020		\N	304723	0	444814009	40481087		0
66836	3955	40481087	1981-03-18	1981-03-18 00:00:00	1981-04-01	1981-04-01 00:00:00	32020		\N	262848	0	444814009	40481087		0
66976	3960	260139	1966-09-30	1966-09-30 00:00:00	1966-10-14	1966-10-14 00:00:00	32020		\N	263289	0	10509002	260139		0
67119	3968	4112343	1994-05-13	1994-05-13 00:00:00	1994-05-21	1994-05-21 00:00:00	32020		\N	263854	0	195662009	4112343		0
77906	4615	78272	1969-12-02	1969-12-02 00:00:00	1969-12-30	1969-12-30 00:00:00	32020		\N	307375	0	70704007	78272		0
67487	3989	4112343	1981-12-11	1981-12-11 00:00:00	1981-12-23	1981-12-23 00:00:00	32020		\N	265170	0	195662009	4112343		0
67602	3993	260139	1990-07-20	1990-07-20 00:00:00	1990-07-27	1990-07-27 00:00:00	32020		\N	265458	0	10509002	260139		0
67758	4005	40481087	1979-03-05	1979-03-05 00:00:00	1979-03-26	1979-03-26 00:00:00	32020		\N	266125	0	444814009	40481087		0
67987	4017	260139	1989-02-09	1989-02-09 00:00:00	1989-02-23	1989-02-23 00:00:00	32020		\N	266948	0	10509002	260139		0
68099	4021	4112343	1999-03-14	1999-03-14 00:00:00	1999-03-24	1999-03-24 00:00:00	32020		\N	267294	0	195662009	4112343		0
68359	4040	81151	1994-08-17	1994-08-17 00:00:00	1994-09-21	1994-09-21 00:00:00	32020		\N	268661	0	44465007	81151		0
68470	4049	260139	1983-02-10	1983-02-10 00:00:00	1983-02-24	1983-02-24 00:00:00	32020		\N	269125	0	10509002	260139		0
68676	4064	4112343	1961-03-07	1961-03-07 00:00:00	1961-03-15	1961-03-15 00:00:00	32020		\N	270071	0	195662009	4112343		0
68823	4072	40481087	1981-10-05	1981-10-05 00:00:00	1981-10-19	1981-10-19 00:00:00	32020		\N	270679	0	444814009	40481087		0
58384	3457	260139	1925-11-06	1925-11-06 00:00:00	1925-11-20	1925-11-20 00:00:00	32020		\N	229321	0	10509002	260139		0
69101	4090	40481087	2007-11-22	2007-11-22 00:00:00	2007-12-06	2007-12-06 00:00:00	32020		\N	271857	0	444814009	40481087		0
79854	4731	40481087	1982-02-13	1982-02-13 00:00:00	1982-03-06	1982-03-06 00:00:00	32020		\N	315205	0	444814009	40481087		0
58855	3490	40481087	2011-01-11	2011-01-11 00:00:00	2011-01-18	2011-01-18 00:00:00	32020		\N	231585	0	444814009	40481087		0
59075	3505	4027663	1967-01-29	1967-01-29 00:00:00	\N	\N	32020		\N	232463	0	13200003	4027663		0
69853	4133	4155034	2005-10-31	2005-10-31 00:00:00	2005-11-14	2005-11-14 00:00:00	32020		\N	274782	0	283371005	4155034		0
80587	4776	313217	2011-04-24	2011-04-24 00:00:00	\N	\N	32020		\N	318053	0	49436004	313217		0
59561	3531	40481087	1992-06-02	1992-06-02 00:00:00	1992-06-16	1992-06-16 00:00:00	32020		\N	234561	0	444814009	40481087		0
70318	4165	81151	1925-09-23	1925-09-23 00:00:00	1925-10-14	1925-10-14 00:00:00	32020		\N	276830	0	44465007	81151		0
81046	4807	4112343	1975-01-17	1975-01-17 00:00:00	1975-01-28	1975-01-28 00:00:00	32020		\N	319789	0	195662009	4112343		0
81191	4815	80180	2008-09-06	2008-09-06 00:00:00	\N	\N	32020		\N	320321	0	396275006	80180		0
70778	4199	4218389	1946-11-12	1946-11-12 00:00:00	1946-12-17	1946-12-17 00:00:00	32020		\N	278706	0	39848009	4218389		0
70908	4206	28060	1955-06-08	1955-06-08 00:00:00	1955-06-17	1955-06-17 00:00:00	32020		\N	279284	0	43878008	28060		0
60523	3578	4112343	1973-12-27	1973-12-27 00:00:00	1974-01-09	1974-01-09 00:00:00	32020		\N	237873	0	195662009	4112343		0
71262	4226	261325	2003-12-28	2003-12-28 00:00:00	\N	\N	32020		\N	280662	0	87433001	261325		0
71384	4235	80180	2014-02-05	2014-02-05 00:00:00	\N	\N	32020		\N	281213	0	396275006	80180		0
71653	4250	4112343	2001-08-28	2001-08-28 00:00:00	2001-09-06	2001-09-06 00:00:00	32020		\N	282293	0	195662009	4112343		0
71726	4255	40481087	1997-08-06	1997-08-06 00:00:00	1997-08-20	1997-08-20 00:00:00	32020		\N	282516	0	444814009	40481087		0
71900	4268	80180	1997-06-23	1997-06-23 00:00:00	\N	\N	32020		\N	283257	0	396275006	80180		0
61576	3638	4112343	2003-06-24	2003-06-24 00:00:00	2003-07-06	2003-07-06 00:00:00	32020		\N	241960	0	195662009	4112343		0
61702	3644	40481087	1971-03-13	1971-03-13 00:00:00	1971-04-03	1971-04-03 00:00:00	32020		\N	242465	0	444814009	40481087		0
72517	4308	28060	1938-04-16	1938-04-16 00:00:00	1938-04-26	1938-04-26 00:00:00	32020		\N	285766	0	43878008	28060		0
72664	4317	260139	1970-12-03	1970-12-03 00:00:00	1970-12-17	1970-12-17 00:00:00	32020		\N	286552	0	10509002	260139		0
72760	4324	40481087	1982-08-22	1982-08-22 00:00:00	1982-09-05	1982-09-05 00:00:00	32020		\N	286850	0	444814009	40481087		0
83524	4964	4112343	1980-05-11	1980-05-11 00:00:00	1980-05-21	1980-05-21 00:00:00	32020		\N	330005	0	195662009	4112343		0
73114	4343	257012	1988-06-25	1988-06-25 00:00:00	\N	\N	32020		\N	288010	0	40055000	257012		0
73229	4352	40481087	2016-01-21	2016-01-21 00:00:00	2016-01-28	2016-01-28 00:00:00	32020		\N	288640	0	444814009	40481087		0
73519	4370	40481087	2013-02-26	2013-02-26 00:00:00	2013-03-12	2013-03-12 00:00:00	32020		\N	290151	0	444814009	40481087		0
63068	3725	40481087	1999-10-20	1999-10-20 00:00:00	1999-11-10	1999-11-10 00:00:00	32020		\N	247537	0	444814009	40481087		0
73844	4387	28060	1985-05-20	1985-05-20 00:00:00	1985-05-30	1985-05-30 00:00:00	32020		\N	291608	0	43878008	28060		0
73983	4394	4237458	2000-08-12	2000-08-12 00:00:00	2000-11-10	2000-11-10 00:00:00	32020		\N	292168	0	58150001	4237458		0
74156	4405	372328	1969-09-01	1969-09-01 00:00:00	1969-11-10	1969-11-10 00:00:00	32020		\N	292787	0	65363002	372328		0
74358	4413	4146173	2001-08-26	2001-08-26 00:00:00	2001-10-25	2001-10-25 00:00:00	32020		\N	293429	0	307731004	4146173		0
63853	3772	372328	1974-07-04	1974-07-04 00:00:00	1975-02-01	1975-02-01 00:00:00	32020		\N	250688	0	65363002	372328		0
74553	4428	28060	1954-05-05	1954-05-05 00:00:00	1954-05-15	1954-05-15 00:00:00	32020		\N	294377	0	43878008	28060		0
64155	3789	378001	1966-02-22	1966-02-22 00:00:00	1966-04-23	1966-04-23 00:00:00	32020		\N	251912	0	62106007	378001		0
64271	3795	28060	2009-10-06	2009-10-06 00:00:00	2009-10-16	2009-10-16 00:00:00	32020		\N	252312	0	43878008	28060		0
64409	3804	4296204	1978-11-14	1978-11-14 00:00:00	1978-12-19	1978-12-19 00:00:00	32020		\N	252859	0	403190006	4296204		0
64696	3825	4156265	2009-03-13	2009-03-13 00:00:00	2009-03-27	2009-03-27 00:00:00	32020		\N	254068	0	370247008	4156265		0
54239	3214	372328	1972-11-11	1972-11-11 00:00:00	1973-01-23	1973-01-23 00:00:00	32020		\N	213529	0	65363002	372328		0
64936	3839	40481087	1961-10-31	1961-10-31 00:00:00	1961-11-14	1961-11-14 00:00:00	32020		\N	254837	0	444814009	40481087		0
54592	3232	40481087	1970-12-11	1970-12-11 00:00:00	1970-12-18	1970-12-18 00:00:00	32020		\N	214827	0	444814009	40481087		0
65255	3859	260139	1931-03-10	1931-03-10 00:00:00	1931-03-24	1931-03-24 00:00:00	32020		\N	256242	0	10509002	260139		0
65429	3869	40481087	1924-05-03	1924-05-03 00:00:00	1924-05-24	1924-05-24 00:00:00	32020		\N	256909	0	444814009	40481087		0
65712	3885	260139	2014-06-18	2014-06-18 00:00:00	2014-06-25	2014-06-25 00:00:00	32020		\N	258227	0	10509002	260139		0
65894	3895	40481087	1941-02-11	1941-02-11 00:00:00	1941-03-04	1941-03-04 00:00:00	32020		\N	259046	0	444814009	40481087		0
65953	3900	81893	1998-01-22	1998-01-22 00:00:00	\N	\N	32020		\N	259316	0	64766004	81893		0
66132	3913	260139	2004-06-28	2004-06-28 00:00:00	2004-07-12	2004-07-12 00:00:00	32020		\N	260189	0	10509002	260139		0
66321	3927	372328	1949-04-17	1949-04-17 00:00:00	1949-07-05	1949-07-05 00:00:00	32020		\N	261056	0	65363002	372328		0
66412	3930	4112343	1947-10-13	1947-10-13 00:00:00	1947-10-26	1947-10-26 00:00:00	32020		\N	261241	0	195662009	4112343		0
77207	4574	4112343	1964-12-15	1964-12-15 00:00:00	1964-12-22	1964-12-22 00:00:00	32020		\N	304681	0	195662009	4112343		0
66837	3955	4027663	1988-01-27	1988-01-27 00:00:00	\N	\N	32020		\N	262854	0	13200003	4027663		0
66977	3960	4283893	1963-03-27	1963-03-27 00:00:00	1963-04-17	1963-04-17 00:00:00	32020		\N	263257	0	36971009	4283893		0
67120	3968	4112343	1977-07-18	1977-07-18 00:00:00	1977-07-29	1977-07-29 00:00:00	32020		\N	263852	0	195662009	4112343		0
77907	4615	260139	2004-12-25	2004-12-25 00:00:00	2005-01-08	2005-01-08 00:00:00	32020		\N	307425	0	10509002	260139		0
67488	3989	40481087	1967-04-10	1967-04-10 00:00:00	1967-05-01	1967-05-01 00:00:00	32020		\N	265156	0	444814009	40481087		0
67603	3993	257012	1989-03-13	1989-03-13 00:00:00	\N	\N	32020		\N	265457	0	40055000	257012		0
67759	4005	28060	1989-01-08	1989-01-08 00:00:00	1989-01-19	1989-01-19 00:00:00	32020		\N	266130	0	43878008	28060		0
67988	4017	260139	1984-03-04	1984-03-04 00:00:00	1984-03-18	1984-03-18 00:00:00	32020		\N	266946	0	10509002	260139		0
68100	4021	4112343	1974-06-28	1974-06-28 00:00:00	1974-07-10	1974-07-10 00:00:00	32020		\N	267307	0	195662009	4112343		0
68360	4040	372328	1977-02-03	1977-02-03 00:00:00	1977-04-18	1977-04-18 00:00:00	32020		\N	268665	0	65363002	372328		0
68471	4049	28060	2018-03-01	2018-03-01 00:00:00	2018-03-12	2018-03-12 00:00:00	32020		\N	269131	0	43878008	28060		0
68677	4064	40481087	2017-09-30	2017-09-30 00:00:00	2017-10-14	2017-10-14 00:00:00	32020		\N	270094	0	444814009	40481087		0
68824	4072	40481087	1987-06-20	1987-06-20 00:00:00	1987-07-11	1987-07-11 00:00:00	32020		\N	270669	0	444814009	40481087		0
58385	3457	4294548	1980-02-09	1980-02-09 00:00:00	1980-03-29	1980-03-29 00:00:00	32020		\N	229324	0	75498004	4294548		0
69102	4090	81151	1968-01-04	1968-01-04 00:00:00	1968-02-01	1968-02-01 00:00:00	32020		\N	271936	0	44465007	81151		0
79855	4731	378001	2010-08-09	2010-08-09 00:00:00	2010-10-08	2010-10-08 00:00:00	32020		\N	315216	0	62106007	378001		0
58856	3490	4278672	1951-02-13	1951-02-13 00:00:00	1951-04-14	1951-04-14 00:00:00	32020		\N	231513	0	65966004	4278672		0
59076	3505	4155034	1993-02-16	1993-02-16 00:00:00	1993-03-09	1993-03-09 00:00:00	32020		\N	232380	0	283371005	4155034		0
69854	4133	81893	2008-05-18	2008-05-18 00:00:00	\N	\N	32020		\N	274782	0	64766004	81893		0
80588	4776	40481087	1960-06-25	1960-06-25 00:00:00	1960-07-16	1960-07-16 00:00:00	32020		\N	317997	0	444814009	40481087		0
59562	3531	260139	1982-09-07	1982-09-07 00:00:00	1982-09-21	1982-09-21 00:00:00	32020		\N	234521	0	10509002	260139		0
70319	4165	372328	1913-01-27	1913-01-27 00:00:00	1913-03-30	1913-03-30 00:00:00	32020		\N	276767	0	65363002	372328		0
81047	4807	4112343	1948-04-16	1948-04-16 00:00:00	1948-04-25	1948-04-25 00:00:00	32020		\N	319802	0	195662009	4112343		0
81192	4815	4112343	2001-10-12	2001-10-12 00:00:00	2001-10-22	2001-10-22 00:00:00	32020		\N	320339	0	195662009	4112343		0
70779	4200	378001	1982-06-06	1982-06-06 00:00:00	1982-08-05	1982-08-05 00:00:00	32020		\N	278719	0	62106007	378001		0
70909	4206	260139	1980-09-16	1980-09-16 00:00:00	1980-09-23	1980-09-23 00:00:00	32020		\N	279298	0	10509002	260139		0
60524	3578	260139	2008-05-03	2008-05-03 00:00:00	2008-05-17	2008-05-17 00:00:00	32020		\N	237864	0	10509002	260139		0
71263	4226	40481087	1994-05-17	1994-05-17 00:00:00	1994-05-31	1994-05-31 00:00:00	32020		\N	280758	0	444814009	40481087		0
71385	4235	40481087	1979-06-07	1979-06-07 00:00:00	1979-06-14	1979-06-14 00:00:00	32020		\N	281204	0	444814009	40481087		0
71654	4250	40481087	1997-08-26	1997-08-26 00:00:00	1997-09-16	1997-09-16 00:00:00	32020		\N	282329	0	444814009	40481087		0
71727	4255	40481087	1978-02-03	1978-02-03 00:00:00	1978-02-24	1978-02-24 00:00:00	32020		\N	282538	0	444814009	40481087		0
71901	4268	4112343	2015-12-22	2015-12-22 00:00:00	2016-01-03	2016-01-03 00:00:00	32020		\N	283247	0	195662009	4112343		0
61577	3638	40481087	2002-03-25	2002-03-25 00:00:00	2002-04-01	2002-04-01 00:00:00	32020		\N	241997	0	444814009	40481087		0
61703	3644	28060	1947-11-21	1947-11-21 00:00:00	1947-12-01	1947-12-01 00:00:00	32020		\N	242471	0	43878008	28060		0
72518	4308	40481087	1988-05-29	1988-05-29 00:00:00	1988-06-05	1988-06-05 00:00:00	32020		\N	285830	0	444814009	40481087		0
72665	4317	4112343	1966-05-23	1966-05-23 00:00:00	1966-05-30	1966-05-30 00:00:00	32020		\N	286551	0	195662009	4112343		0
72761	4324	30753	1998-09-30	1998-09-30 00:00:00	\N	\N	32020		\N	286808	0	16761005	30753		0
83525	4964	4152936	1961-02-07	1961-02-07 00:00:00	1961-02-28	1961-02-28 00:00:00	32020		\N	329968	0	283385000	4152936		0
73139	4347	440448	1993-04-05	1993-04-05 00:00:00	\N	\N	32020		\N	288292	0	74400008	440448		0
73230	4352	372328	1949-08-05	1949-08-05 00:00:00	1949-10-06	1949-10-06 00:00:00	32020		\N	288659	0	65363002	372328		0
73520	4370	4146173	1991-11-15	1991-11-15 00:00:00	1992-01-21	1992-01-21 00:00:00	32020		\N	290127	0	307731004	4146173		0
63069	3725	4112343	2006-10-24	2006-10-24 00:00:00	2006-11-06	2006-11-06 00:00:00	32020		\N	247566	0	195662009	4112343		0
73845	4387	4112343	1979-08-03	1979-08-03 00:00:00	1979-08-16	1979-08-16 00:00:00	32020		\N	291607	0	195662009	4112343		0
73984	4394	260139	2014-05-12	2014-05-12 00:00:00	2014-05-26	2014-05-26 00:00:00	32020		\N	292149	0	10509002	260139		0
74157	4405	372328	1964-11-13	1964-11-13 00:00:00	1965-01-25	1965-01-25 00:00:00	32020		\N	292791	0	65363002	372328		0
74359	4413	4112343	1998-01-15	1998-01-15 00:00:00	1998-01-25	1998-01-25 00:00:00	32020		\N	293463	0	195662009	4112343		0
63854	3773	372328	1961-05-16	1961-05-16 00:00:00	1961-10-06	1961-10-06 00:00:00	32020		\N	250826	0	65363002	372328		0
74554	4428	40481087	1989-10-26	1989-10-26 00:00:00	1989-11-15	1989-11-15 00:00:00	32020		\N	294413	0	444814009	40481087		0
64156	3789	40481087	1945-09-16	1945-09-16 00:00:00	1945-09-23	1945-09-23 00:00:00	32020		\N	251921	0	444814009	40481087		0
64272	3795	40481087	2012-07-28	2012-07-28 00:00:00	2012-08-11	2012-08-11 00:00:00	32020		\N	252306	0	444814009	40481087		0
64410	3804	4112343	2001-05-30	2001-05-30 00:00:00	2001-06-09	2001-06-09 00:00:00	32020		\N	252866	0	195662009	4112343		0
64697	3825	260139	1958-02-21	1958-02-21 00:00:00	1958-02-28	1958-02-28 00:00:00	32020		\N	254058	0	10509002	260139		0
54240	3214	440086	1983-02-12	1983-02-12 00:00:00	1990-02-20	1990-02-20 00:00:00	32020		\N	213545	0	192127007	440086		0
64937	3839	260139	1957-09-17	1957-09-17 00:00:00	1957-10-01	1957-10-01 00:00:00	32020		\N	254870	0	10509002	260139		0
54593	3232	4112343	2017-11-10	2017-11-10 00:00:00	2017-11-18	2017-11-18 00:00:00	32020		\N	214837	0	195662009	4112343		0
65256	3859	260139	1954-10-15	1954-10-15 00:00:00	1954-10-22	1954-10-22 00:00:00	32020		\N	256206	0	10509002	260139		0
65430	3869	40481087	1978-09-11	1978-09-11 00:00:00	1978-10-02	1978-10-02 00:00:00	32020		\N	256931	0	444814009	40481087		0
65713	3885	4109685	1963-11-11	1963-11-11 00:00:00	1963-12-02	1963-12-02 00:00:00	32020		\N	258294	0	284551006	4109685		0
65895	3895	4112343	1949-08-28	1949-08-28 00:00:00	1949-09-10	1949-09-10 00:00:00	32020		\N	259048	0	195662009	4112343		0
65954	3900	4266809	1999-02-16	1999-02-16 00:00:00	\N	\N	32020		\N	259317	0	397881000	4266809		0
66133	3913	4134304	1969-11-10	1969-11-10 00:00:00	1970-01-09	1970-01-09 00:00:00	32020		\N	260086	0	263102004	4134304		0
66322	3927	4218389	1948-10-19	1948-10-19 00:00:00	1948-11-09	1948-11-09 00:00:00	32020		\N	261012	0	39848009	4218389		0
66413	3930	40481087	1965-01-14	1965-01-14 00:00:00	1965-02-04	1965-02-04 00:00:00	32020		\N	261267	0	444814009	40481087		0
77208	4574	260139	1990-02-06	1990-02-06 00:00:00	1990-02-13	1990-02-13 00:00:00	32020		\N	304739	0	10509002	260139		0
66838	3955	4134304	1994-02-28	1994-02-28 00:00:00	1994-05-29	1994-05-29 00:00:00	32020		\N	262901	0	263102004	4134304		0
66978	3960	40481087	1987-08-10	1987-08-10 00:00:00	1987-08-31	1987-08-31 00:00:00	32020		\N	263271	0	444814009	40481087		0
67121	3968	260139	2019-01-27	2019-01-27 00:00:00	2019-02-10	2019-02-10 00:00:00	32020		\N	263857	0	10509002	260139		0
77908	4615	80180	1995-05-30	1995-05-30 00:00:00	\N	\N	32020		\N	307438	0	396275006	80180		0
67489	3989	372328	1928-10-27	1928-10-27 00:00:00	1928-12-10	1928-12-10 00:00:00	32020		\N	265237	0	65363002	372328		0
67604	3993	4112343	1980-10-15	1980-10-15 00:00:00	1980-10-24	1980-10-24 00:00:00	32020		\N	265483	0	195662009	4112343		0
67760	4005	372328	1975-02-20	1975-02-20 00:00:00	1976-03-06	1976-03-06 00:00:00	32020		\N	266132	0	65363002	372328		0
67989	4017	4112343	2014-02-01	2014-02-01 00:00:00	2014-02-10	2014-02-10 00:00:00	32020		\N	266950	0	195662009	4112343		0
68101	4021	260139	1970-06-24	1970-06-24 00:00:00	1970-07-08	1970-07-08 00:00:00	32020		\N	267306	0	10509002	260139		0
68361	4040	260139	2009-03-12	2009-03-12 00:00:00	2009-03-26	2009-03-26 00:00:00	32020		\N	268685	0	10509002	260139		0
68472	4049	4112343	1987-08-19	1987-08-19 00:00:00	1987-09-01	1987-09-01 00:00:00	32020		\N	269171	0	195662009	4112343		0
68678	4064	81151	1990-01-02	1990-01-02 00:00:00	1990-01-16	1990-01-16 00:00:00	32020		\N	269998	0	44465007	81151		0
68825	4072	40481087	1998-01-21	1998-01-21 00:00:00	1998-02-11	1998-02-11 00:00:00	32020		\N	270695	0	444814009	40481087		0
58386	3457	4156265	1938-07-06	1938-07-06 00:00:00	1938-07-20	1938-07-20 00:00:00	32020		\N	229383	0	370247008	4156265		0
69103	4090	372328	1944-07-10	1944-07-10 00:00:00	1944-08-28	1944-08-28 00:00:00	32020		\N	271859	0	65363002	372328		0
79856	4731	260139	2014-06-14	2014-06-14 00:00:00	2014-06-21	2014-06-21 00:00:00	32020		\N	315197	0	10509002	260139		0
58857	3490	40481087	1974-12-31	1974-12-31 00:00:00	1975-01-14	1975-01-14 00:00:00	32020		\N	231606	0	444814009	40481087		0
59077	3505	260139	1992-09-28	1992-09-28 00:00:00	1992-10-05	1992-10-05 00:00:00	32020		\N	232453	0	10509002	260139		0
69855	4133	4310024	2008-03-19	2008-03-19 00:00:00	\N	\N	32020		\N	274782	0	424802006	4310024		0
80589	4776	40481087	2018-09-12	2018-09-12 00:00:00	2018-09-26	2018-09-26 00:00:00	32020		\N	318044	0	444814009	40481087		0
59563	3531	81151	2009-02-16	2009-02-16 00:00:00	2009-03-16	2009-03-16 00:00:00	32020		\N	234528	0	44465007	81151		0
70320	4165	372328	1912-08-11	1912-08-11 00:00:00	1912-09-29	1912-09-29 00:00:00	32020		\N	276725	0	65363002	372328		0
81048	4807	260139	1981-01-03	1981-01-03 00:00:00	1981-01-17	1981-01-17 00:00:00	32020		\N	319885	0	10509002	260139		0
81193	4815	4109685	1985-09-26	1985-09-26 00:00:00	1985-10-10	1985-10-10 00:00:00	32020		\N	320356	0	284551006	4109685		0
70780	4200	260139	1974-09-18	1974-09-18 00:00:00	1974-10-02	1974-10-02 00:00:00	32020		\N	278800	0	10509002	260139		0
70910	4206	378001	1974-05-22	1974-05-22 00:00:00	1974-07-21	1974-07-21 00:00:00	32020		\N	279332	0	62106007	378001		0
60525	3578	40481087	1985-09-12	1985-09-12 00:00:00	1985-10-03	1985-10-03 00:00:00	32020		\N	237877	0	444814009	40481087		0
71264	4226	40481087	2016-11-08	2016-11-08 00:00:00	2016-11-29	2016-11-29 00:00:00	32020		\N	280644	0	444814009	40481087		0
71386	4235	4296205	1987-10-15	1987-10-15 00:00:00	1987-11-19	1987-11-19 00:00:00	32020		\N	281188	0	403191005	4296205		0
71655	4250	4146173	2017-04-26	2017-04-26 00:00:00	2017-06-25	2017-06-25 00:00:00	32020		\N	282298	0	307731004	4146173		0
71728	4255	260139	1990-09-07	1990-09-07 00:00:00	1990-09-14	1990-09-14 00:00:00	32020		\N	282490	0	10509002	260139		0
71902	4268	4059173	1961-06-12	1961-06-12 00:00:00	1961-07-12	1961-07-12 00:00:00	32020		\N	283208	0	16114001	4059173		0
61578	3638	80180	2002-12-13	2002-12-13 00:00:00	\N	\N	32020		\N	241997	0	396275006	80180		0
61704	3644	4113008	1979-09-22	1979-09-22 00:00:00	1979-10-06	1979-10-06 00:00:00	32020		\N	242491	0	284549007	4113008		0
72519	4308	40481087	1919-06-12	1919-06-12 00:00:00	1919-06-19	1919-06-19 00:00:00	32020		\N	285734	0	444814009	40481087		0
72666	4317	40481087	1996-03-23	1996-03-23 00:00:00	1996-04-13	1996-04-13 00:00:00	32020		\N	286556	0	444814009	40481087		0
72762	4324	4310024	1998-07-02	1998-07-02 00:00:00	\N	\N	32020		\N	286808	0	424802006	4310024		0
83526	4964	40481087	2003-08-27	2003-08-27 00:00:00	2003-09-17	2003-09-17 00:00:00	32020		\N	330008	0	444814009	40481087		0
73140	4347	4142905	1974-02-02	1974-02-02 00:00:00	1974-03-04	1974-03-04 00:00:00	32020		\N	288291	0	33737001	4142905		0
73231	4352	4059173	1956-03-19	1956-03-19 00:00:00	1956-06-17	1956-06-17 00:00:00	32020		\N	288672	0	16114001	4059173		0
73529	4372	40481087	1992-08-12	1992-08-12 00:00:00	1992-08-19	1992-08-19 00:00:00	32020		\N	290222	0	444814009	40481087		0
63070	3725	4112343	1970-06-27	1970-06-27 00:00:00	1970-07-04	1970-07-04 00:00:00	32020		\N	247587	0	195662009	4112343		0
73846	4387	4156265	1993-05-26	1993-05-26 00:00:00	1993-06-09	1993-06-09 00:00:00	32020		\N	291620	0	370247008	4156265		0
73985	4394	40481087	2006-08-27	2006-08-27 00:00:00	2006-09-10	2006-09-10 00:00:00	32020		\N	292157	0	444814009	40481087		0
74158	4405	440086	1977-02-13	1977-02-13 00:00:00	1982-02-22	1982-02-22 00:00:00	32020		\N	292784	0	192127007	440086		0
74360	4413	40481087	1987-01-21	1987-01-21 00:00:00	1987-02-04	1987-02-04 00:00:00	32020		\N	293479	0	444814009	40481087		0
63855	3773	4112343	1968-02-11	1968-02-11 00:00:00	1968-02-23	1968-02-23 00:00:00	32020		\N	250804	0	195662009	4112343		0
74555	4428	40481087	1966-11-01	1966-11-01 00:00:00	1966-11-08	1966-11-08 00:00:00	32020		\N	294416	0	444814009	40481087		0
64157	3789	4218389	1970-10-29	1970-10-29 00:00:00	1970-11-26	1970-11-26 00:00:00	32020		\N	251913	0	39848009	4218389		0
64273	3795	372328	1974-02-08	1974-02-08 00:00:00	1974-04-23	1974-04-23 00:00:00	32020		\N	252304	0	65363002	372328		0
64411	3804	40481087	1999-08-11	1999-08-11 00:00:00	1999-08-18	1999-08-18 00:00:00	32020		\N	252883	0	444814009	40481087		0
64698	3825	381316	1998-01-02	1998-01-02 00:00:00	\N	\N	32020		\N	254062	0	230690007	381316		0
54241	3214	40481087	2018-06-17	2018-06-17 00:00:00	2018-06-24	2018-06-24 00:00:00	32020		\N	213538	0	444814009	40481087		0
64938	3839	440086	1963-10-20	1963-10-20 00:00:00	1964-03-22	1964-03-22 00:00:00	32020		\N	254909	0	192127007	440086		0
54594	3232	81151	1964-07-12	1964-07-12 00:00:00	1964-08-02	1964-08-02 00:00:00	32020		\N	214857	0	44465007	81151		0
65257	3859	375671	1964-09-05	1964-09-05 00:00:00	1964-10-05	1964-10-05 00:00:00	32020		\N	256265	0	62564004	375671		0
65431	3869	40481087	1964-01-27	1964-01-27 00:00:00	1964-02-10	1964-02-10 00:00:00	32020		\N	256915	0	444814009	40481087		0
65714	3885	28060	1973-06-17	1973-06-17 00:00:00	1973-06-26	1973-06-26 00:00:00	32020		\N	258282	0	43878008	28060		0
65896	3895	40481087	1966-07-14	1966-07-14 00:00:00	1966-07-28	1966-07-28 00:00:00	32020		\N	259087	0	444814009	40481087		0
65955	3900	80180	1999-02-16	1999-02-16 00:00:00	\N	\N	32020		\N	259317	0	396275006	80180		0
66134	3913	40481087	1989-12-30	1989-12-30 00:00:00	1990-01-20	1990-01-20 00:00:00	32020		\N	260127	0	444814009	40481087		0
66323	3927	40481087	1951-08-13	1951-08-13 00:00:00	1951-08-27	1951-08-27 00:00:00	32020		\N	261041	0	444814009	40481087		0
66414	3930	28060	1927-10-05	1927-10-05 00:00:00	1927-10-18	1927-10-18 00:00:00	32020		\N	261229	0	43878008	28060		0
77209	4574	81151	1970-11-28	1970-11-28 00:00:00	1971-01-02	1971-01-02 00:00:00	32020		\N	304711	0	44465007	81151		0
66839	3955	40481087	1990-06-21	1990-06-21 00:00:00	1990-06-28	1990-06-28 00:00:00	32020		\N	262868	0	444814009	40481087		0
66979	3960	40481087	2009-10-29	2009-10-29 00:00:00	2009-11-12	2009-11-12 00:00:00	32020		\N	263254	0	444814009	40481087		0
67122	3968	4155034	1936-10-29	1936-10-29 00:00:00	1936-11-19	1936-11-19 00:00:00	32020		\N	263902	0	283371005	4155034		0
77909	4615	4112343	1995-02-10	1995-02-10 00:00:00	1995-02-23	1995-02-23 00:00:00	32020		\N	307438	0	195662009	4112343		0
67490	3989	40481087	1974-05-16	1974-05-16 00:00:00	1974-05-30	1974-05-30 00:00:00	32020		\N	265158	0	444814009	40481087		0
67605	3993	4218389	1957-10-09	1957-10-09 00:00:00	1957-10-30	1957-10-30 00:00:00	32020		\N	265523	0	39848009	4218389		0
67761	4005	40481087	1986-04-08	1986-04-08 00:00:00	1986-04-15	1986-04-15 00:00:00	32020		\N	266129	0	444814009	40481087		0
67990	4017	4112343	1942-11-10	1942-11-10 00:00:00	1942-11-21	1942-11-21 00:00:00	32020		\N	266965	0	195662009	4112343		0
68102	4021	195588	1989-01-03	1989-01-03 00:00:00	1989-02-07	1989-02-07 00:00:00	32020		\N	267279	0	38822007	195588		0
68362	4040	80180	2013-01-20	2013-01-20 00:00:00	\N	\N	32020		\N	268710	0	396275006	80180		0
68473	4049	78272	1989-11-01	1989-11-01 00:00:00	1989-11-29	1989-11-29 00:00:00	32020		\N	269138	0	70704007	78272		0
68679	4064	4084167	1966-02-08	1966-02-08 00:00:00	1966-02-08	1966-02-08 00:00:00	32020		\N	269996	0	241929008	4084167		0
58387	3457	4112343	2016-09-21	2016-09-21 00:00:00	2016-10-02	2016-10-02 00:00:00	32020		\N	229333	0	195662009	4112343		0
69104	4090	440086	1954-03-20	1954-03-20 00:00:00	1960-03-28	1960-03-28 00:00:00	32020		\N	271843	0	192127007	440086		0
79857	4731	260139	2005-08-07	2005-08-07 00:00:00	2005-08-14	2005-08-14 00:00:00	32020		\N	315196	0	10509002	260139		0
58858	3490	40481087	1972-08-15	1972-08-15 00:00:00	1972-09-05	1972-09-05 00:00:00	32020		\N	231566	0	444814009	40481087		0
59078	3505	40481087	1965-08-18	1965-08-18 00:00:00	1965-08-25	1965-08-25 00:00:00	32020		\N	232422	0	444814009	40481087		0
69856	4133	4112343	2015-01-01	2015-01-01 00:00:00	2015-01-12	2015-01-12 00:00:00	32020		\N	274787	0	195662009	4112343		0
80590	4776	40481087	2005-12-20	2005-12-20 00:00:00	2006-01-10	2006-01-10 00:00:00	32020		\N	318042	0	444814009	40481087		0
59564	3531	4112343	2014-07-18	2014-07-18 00:00:00	2014-07-31	2014-07-31 00:00:00	32020		\N	234563	0	195662009	4112343		0
70321	4165	372328	1916-07-12	1916-07-12 00:00:00	1917-04-08	1917-04-08 00:00:00	32020		\N	276756	0	65363002	372328		0
81049	4807	4155034	1954-03-03	1954-03-03 00:00:00	1954-03-17	1954-03-17 00:00:00	32020		\N	319806	0	283371005	4155034		0
81194	4815	4112343	1995-08-19	1995-08-19 00:00:00	1995-09-01	1995-09-01 00:00:00	32020		\N	320338	0	195662009	4112343		0
70781	4200	4112343	1995-08-13	1995-08-13 00:00:00	1995-08-21	1995-08-21 00:00:00	32020		\N	278770	0	195662009	4112343		0
70911	4206	4112343	1974-05-10	1974-05-10 00:00:00	1974-05-17	1974-05-17 00:00:00	32020		\N	279287	0	195662009	4112343		0
60526	3578	192671	2017-01-08	2017-01-08 00:00:00	\N	\N	32020		\N	237907	0	K92.2	35208414		0
71265	4226	40481087	1983-03-29	1983-03-29 00:00:00	1983-04-12	1983-04-12 00:00:00	32020		\N	280769	0	444814009	40481087		0
71387	4235	4112343	1979-11-30	1979-11-30 00:00:00	1979-12-11	1979-12-11 00:00:00	32020		\N	281187	0	195662009	4112343		0
71656	4250	81151	1996-11-14	1996-11-14 00:00:00	1996-12-12	1996-12-12 00:00:00	32020		\N	282262	0	44465007	81151		0
71729	4255	40481087	1979-07-27	1979-07-27 00:00:00	1979-08-03	1979-08-03 00:00:00	32020		\N	282512	0	444814009	40481087		0
71903	4268	4218389	2016-12-07	2016-12-07 00:00:00	2016-12-28	2016-12-28 00:00:00	32020		\N	283214	0	39848009	4218389		0
61579	3638	4112343	2009-08-06	2009-08-06 00:00:00	2009-08-17	2009-08-17 00:00:00	32020		\N	241978	0	195662009	4112343		0
61705	3644	40481087	1956-11-07	1956-11-07 00:00:00	1956-11-28	1956-11-28 00:00:00	32020		\N	242472	0	444814009	40481087		0
72520	4308	40481087	1938-10-11	1938-10-11 00:00:00	1938-10-25	1938-10-25 00:00:00	32020		\N	285749	0	444814009	40481087		0
72667	4317	4278672	1954-01-30	1954-01-30 00:00:00	1954-04-30	1954-04-30 00:00:00	32020		\N	286476	0	65966004	4278672		0
72763	4324	81893	1998-08-31	1998-08-31 00:00:00	\N	\N	32020		\N	286808	0	64766004	81893		0
83527	4964	260139	1973-11-23	1973-11-23 00:00:00	1973-12-07	1973-12-07 00:00:00	32020		\N	329985	0	10509002	260139		0
73141	4347	4112343	1987-02-21	1987-02-21 00:00:00	1987-03-03	1987-03-03 00:00:00	32020		\N	288302	0	195662009	4112343		0
73232	4352	4283893	2009-02-14	2009-02-14 00:00:00	2009-04-18	2009-04-18 00:00:00	32020		\N	288639	0	36971009	4283893		0
73530	4372	4035415	1993-10-27	1993-10-27 00:00:00	1993-11-26	1993-11-26 00:00:00	32020		\N	290286	0	239720000	4035415		0
63071	3725	4283893	2000-01-18	2000-01-18 00:00:00	2000-02-15	2000-02-15 00:00:00	32020		\N	247538	0	36971009	4283893		0
73847	4387	40481087	2010-08-21	2010-08-21 00:00:00	2010-08-28	2010-08-28 00:00:00	32020		\N	291591	0	444814009	40481087		0
73986	4394	4112343	1993-10-27	1993-10-27 00:00:00	1993-11-03	1993-11-03 00:00:00	32020		\N	292141	0	195662009	4112343		0
74159	4405	260139	1968-10-25	1968-10-25 00:00:00	1968-11-01	1968-11-01 00:00:00	32020		\N	292839	0	10509002	260139		0
74361	4413	4112343	2008-02-06	2008-02-06 00:00:00	2008-02-14	2008-02-14 00:00:00	32020		\N	293430	0	195662009	4112343		0
63856	3773	4155034	1963-02-05	1963-02-05 00:00:00	1963-02-26	1963-02-26 00:00:00	32020		\N	250812	0	283371005	4155034		0
74556	4428	4112343	1966-12-24	1966-12-24 00:00:00	1967-01-06	1967-01-06 00:00:00	32020		\N	294412	0	195662009	4112343		0
64158	3789	4112343	2017-01-09	2017-01-09 00:00:00	2017-01-20	2017-01-20 00:00:00	32020		\N	251941	0	195662009	4112343		0
64274	3795	40481087	2004-09-17	2004-09-17 00:00:00	2004-10-01	2004-10-01 00:00:00	32020		\N	252302	0	444814009	40481087		0
64412	3804	40481087	1983-10-01	1983-10-01 00:00:00	1983-10-15	1983-10-15 00:00:00	32020		\N	252880	0	444814009	40481087		0
64699	3825	40481087	1988-02-21	1988-02-21 00:00:00	1988-03-06	1988-03-06 00:00:00	32020		\N	254060	0	444814009	40481087		0
54242	3214	4112343	1990-06-11	1990-06-11 00:00:00	1990-06-23	1990-06-23 00:00:00	32020		\N	213537	0	195662009	4112343		0
64939	3839	40481087	1974-04-27	1974-04-27 00:00:00	1974-05-11	1974-05-11 00:00:00	32020		\N	254918	0	444814009	40481087		0
54595	3232	40481087	1982-02-10	1982-02-10 00:00:00	1982-02-17	1982-02-17 00:00:00	32020		\N	214819	0	444814009	40481087		0
65258	3859	40481087	1981-08-03	1981-08-03 00:00:00	1981-08-17	1981-08-17 00:00:00	32020		\N	256259	0	444814009	40481087		0
65432	3869	40481087	1974-12-19	1974-12-19 00:00:00	1974-12-26	1974-12-26 00:00:00	32020		\N	256912	0	444814009	40481087		0
65715	3885	260139	1978-07-27	1978-07-27 00:00:00	1978-08-10	1978-08-10 00:00:00	32020		\N	258222	0	10509002	260139		0
65897	3895	28060	1946-02-19	1946-02-19 00:00:00	1946-03-02	1946-03-02 00:00:00	32020		\N	259085	0	43878008	28060		0
65956	3900	40481087	1988-05-18	1988-05-18 00:00:00	1988-06-01	1988-06-01 00:00:00	32020		\N	259304	0	444814009	40481087		0
66135	3913	134438	1981-10-20	1981-10-20 00:00:00	1982-11-17	1982-11-17 00:00:00	32020		\N	260077	0	40275004	134438		0
66324	3927	4112343	1957-03-04	1957-03-04 00:00:00	1957-03-14	1957-03-14 00:00:00	32020		\N	261098	0	195662009	4112343		0
66415	3930	258780	1963-11-23	1963-11-23 00:00:00	\N	\N	32020		\N	261252	0	185086009	258780		0
77210	4574	4027663	1985-03-09	1985-03-09 00:00:00	\N	\N	32020		\N	304735	0	13200003	4027663		0
66840	3955	4294548	1998-07-25	1998-07-25 00:00:00	1998-08-01	1998-08-01 00:00:00	32020		\N	262870	0	75498004	4294548		0
66980	3960	260139	1963-01-08	1963-01-08 00:00:00	1963-01-15	1963-01-15 00:00:00	32020		\N	263250	0	10509002	260139		0
67123	3968	40481087	1931-09-23	1931-09-23 00:00:00	1931-10-14	1931-10-14 00:00:00	32020		\N	263826	0	444814009	40481087		0
77910	4615	4112343	1998-01-28	1998-01-28 00:00:00	1998-02-10	1998-02-10 00:00:00	32020		\N	307395	0	195662009	4112343		0
67491	3989	40481087	1994-04-20	1994-04-20 00:00:00	1994-05-04	1994-05-04 00:00:00	32020		\N	265252	0	444814009	40481087		0
67613	3995	4112343	1992-02-06	1992-02-06 00:00:00	1992-02-13	1992-02-13 00:00:00	32020		\N	265592	0	195662009	4112343		0
67762	4005	260139	1971-02-12	1971-02-12 00:00:00	1971-02-19	1971-02-19 00:00:00	32020		\N	266124	0	10509002	260139		0
67991	4017	4294548	1970-06-11	1970-06-11 00:00:00	1970-09-03	1970-09-03 00:00:00	32020		\N	266973	0	75498004	4294548		0
68103	4021	40481087	1962-03-13	1962-03-13 00:00:00	1962-03-27	1962-03-27 00:00:00	32020		\N	267311	0	444814009	40481087		0
68363	4040	28060	1986-11-27	1986-11-27 00:00:00	1986-12-04	1986-12-04 00:00:00	32020		\N	268671	0	43878008	28060		0
68474	4049	80180	1997-08-13	1997-08-13 00:00:00	\N	\N	32020		\N	269201	0	396275006	80180		0
68680	4064	4112343	1999-10-06	1999-10-06 00:00:00	1999-10-16	1999-10-16 00:00:00	32020		\N	270117	0	195662009	4112343		0
68828	4072	4134304	1977-10-21	1977-10-21 00:00:00	1977-12-20	1977-12-20 00:00:00	32020		\N	270687	0	263102004	4134304		0
58388	3457	260139	2011-04-18	2011-04-18 00:00:00	2011-04-25	2011-04-25 00:00:00	32020		\N	229332	0	10509002	260139		0
69105	4090	80180	1984-06-30	1984-06-30 00:00:00	\N	\N	32020		\N	271887	0	396275006	80180		0
79858	4732	40481087	1996-07-12	1996-07-12 00:00:00	1996-07-26	1996-07-26 00:00:00	32020		\N	315297	0	444814009	40481087		0
58859	3490	40481087	2000-03-10	2000-03-10 00:00:00	2000-03-31	2000-03-31 00:00:00	32020		\N	231554	0	444814009	40481087		0
59079	3505	4112343	1959-11-13	1959-11-13 00:00:00	1959-11-21	1959-11-21 00:00:00	32020		\N	232465	0	195662009	4112343		0
69857	4133	40481087	1977-03-04	1977-03-04 00:00:00	1977-03-11	1977-03-11 00:00:00	32020		\N	274783	0	444814009	40481087		0
80591	4777	28060	1964-03-14	1964-03-14 00:00:00	1964-03-27	1964-03-27 00:00:00	32020		\N	318080	0	43878008	28060		0
59565	3531	4112343	1976-12-18	1976-12-18 00:00:00	1976-12-30	1976-12-30 00:00:00	32020		\N	234520	0	195662009	4112343		0
70322	4165	40481087	1924-02-13	1924-02-13 00:00:00	1924-02-20	1924-02-20 00:00:00	32020		\N	276738	0	444814009	40481087		0
81050	4807	257012	1959-01-19	1959-01-19 00:00:00	1959-09-14	1959-09-14 00:00:00	32020		\N	319785	0	40055000	257012		0
81195	4815	81151	2010-11-28	2010-11-28 00:00:00	2011-01-02	2011-01-02 00:00:00	32020		\N	320336	0	44465007	81151		0
70782	4200	372328	1971-01-05	1971-01-05 00:00:00	1971-05-26	1971-05-26 00:00:00	32020		\N	278832	0	65363002	372328		0
70912	4206	378001	1961-10-29	1961-10-29 00:00:00	1961-12-28	1961-12-28 00:00:00	32020		\N	279302	0	62106007	378001		0
60527	3578	80180	2016-11-09	2016-11-09 00:00:00	\N	\N	32020		\N	237851	0	396275006	80180		0
71266	4226	4112343	1974-08-02	1974-08-02 00:00:00	1974-08-09	1974-08-09 00:00:00	32020		\N	280651	0	195662009	4112343		0
71388	4235	4112343	2012-06-23	2012-06-23 00:00:00	2012-07-04	2012-07-04 00:00:00	32020		\N	281171	0	195662009	4112343		0
71657	4250	372328	1950-07-05	1950-07-05 00:00:00	1950-12-09	1950-12-09 00:00:00	32020		\N	282247	0	65363002	372328		0
71730	4255	372328	1974-11-19	1974-11-19 00:00:00	1975-04-05	1975-04-05 00:00:00	32020		\N	282555	0	65363002	372328		0
71904	4268	260139	1968-07-16	1968-07-16 00:00:00	1968-07-30	1968-07-30 00:00:00	32020		\N	283244	0	10509002	260139		0
61580	3638	40481087	2013-03-07	2013-03-07 00:00:00	2013-03-28	2013-03-28 00:00:00	32020		\N	241947	0	444814009	40481087		0
61706	3644	372328	1948-11-12	1948-11-12 00:00:00	1948-12-29	1948-12-29 00:00:00	32020		\N	242495	0	65363002	372328		0
72521	4308	40481087	1983-07-26	1983-07-26 00:00:00	1983-08-02	1983-08-02 00:00:00	32020		\N	285841	0	444814009	40481087		0
72668	4317	4112343	1953-02-05	1953-02-05 00:00:00	1953-02-15	1953-02-15 00:00:00	32020		\N	286490	0	195662009	4112343		0
72764	4324	80180	1999-07-27	1999-07-27 00:00:00	\N	\N	32020		\N	286808	0	396275006	80180		0
83528	4964	28060	1970-04-20	1970-04-20 00:00:00	1970-04-30	1970-04-30 00:00:00	32020		\N	329988	0	43878008	28060		0
73142	4347	40481087	2014-06-16	2014-06-16 00:00:00	2014-07-07	2014-07-07 00:00:00	32020		\N	288297	0	444814009	40481087		0
73233	4352	4112343	2005-06-04	2005-06-04 00:00:00	2005-06-15	2005-06-15 00:00:00	32020		\N	288710	0	195662009	4112343		0
73531	4372	4112343	2001-02-04	2001-02-04 00:00:00	2001-02-12	2001-02-12 00:00:00	32020		\N	290290	0	195662009	4112343		0
63072	3725	4278672	1972-06-05	1972-06-05 00:00:00	1972-08-04	1972-08-04 00:00:00	32020		\N	247590	0	65966004	4278672		0
73848	4387	4296205	1967-07-07	1967-07-07 00:00:00	1967-08-04	1967-08-04 00:00:00	32020		\N	291619	0	403191005	4296205		0
73987	4394	28060	1978-03-22	1978-03-22 00:00:00	1978-04-04	1978-04-04 00:00:00	32020		\N	292140	0	43878008	28060		0
74160	4405	40481087	2018-08-08	2018-08-08 00:00:00	2018-08-22	2018-08-22 00:00:00	32020		\N	292790	0	444814009	40481087		0
74362	4413	260139	2012-04-18	2012-04-18 00:00:00	2012-04-25	2012-04-25 00:00:00	32020		\N	293480	0	10509002	260139		0
63857	3773	260139	1982-06-21	1982-06-21 00:00:00	1982-06-28	1982-06-28 00:00:00	32020		\N	250807	0	10509002	260139		0
74557	4428	80180	1991-05-04	1991-05-04 00:00:00	\N	\N	32020		\N	294359	0	396275006	80180		0
64159	3789	40481087	1962-12-31	1962-12-31 00:00:00	1963-01-21	1963-01-21 00:00:00	32020		\N	251874	0	444814009	40481087		0
64275	3795	4112343	2007-01-10	2007-01-10 00:00:00	2007-01-17	2007-01-17 00:00:00	32020		\N	252303	0	195662009	4112343		0
64413	3804	4027663	1993-11-24	1993-11-24 00:00:00	\N	\N	32020		\N	252891	0	13200003	4027663		0
64700	3825	4113008	1965-10-11	1965-10-11 00:00:00	1965-10-25	1965-10-25 00:00:00	32020		\N	254065	0	284549007	4113008		0
54243	3214	4296205	1991-05-02	1991-05-02 00:00:00	1991-05-16	1991-05-16 00:00:00	32020		\N	213497	0	403191005	4296205		0
64940	3839	40481087	1968-04-23	1968-04-23 00:00:00	1968-05-07	1968-05-07 00:00:00	32020		\N	254915	0	444814009	40481087		0
54596	3232	4152936	1983-11-21	1983-11-21 00:00:00	1983-12-05	1983-12-05 00:00:00	32020		\N	214858	0	283385000	4152936		0
65259	3859	378001	2017-03-31	2017-03-31 00:00:00	2017-05-30	2017-05-30 00:00:00	32020		\N	256268	0	62106007	378001		0
65433	3869	40481087	1935-10-29	1935-10-29 00:00:00	1935-11-12	1935-11-12 00:00:00	32020		\N	256926	0	444814009	40481087		0
65716	3885	40481087	1967-01-20	1967-01-20 00:00:00	1967-01-27	1967-01-27 00:00:00	32020		\N	258221	0	444814009	40481087		0
65898	3895	260139	1933-09-14	1933-09-14 00:00:00	1933-09-28	1933-09-28 00:00:00	32020		\N	259115	0	10509002	260139		0
65957	3900	4027663	1992-06-27	1992-06-27 00:00:00	\N	\N	32020		\N	259314	0	13200003	4027663		0
66136	3913	260139	1982-07-14	1982-07-14 00:00:00	1982-07-28	1982-07-28 00:00:00	32020		\N	260079	0	10509002	260139		0
66325	3927	372328	1962-02-27	1962-02-27 00:00:00	1962-04-10	1962-04-10 00:00:00	32020		\N	261015	0	65363002	372328		0
66416	3930	4152936	1917-05-20	1917-05-20 00:00:00	1917-06-10	1917-06-10 00:00:00	32020		\N	261307	0	283385000	4152936		0
77211	4574	4112343	2008-06-11	2008-06-11 00:00:00	2008-06-20	2008-06-20 00:00:00	32020		\N	304684	0	195662009	4112343		0
66841	3955	40481087	2005-07-05	2005-07-05 00:00:00	2005-07-26	2005-07-26 00:00:00	32020		\N	262850	0	444814009	40481087		0
66981	3960	4027663	1987-02-08	1987-02-08 00:00:00	\N	\N	32020		\N	263320	0	13200003	4027663		0
67124	3968	28060	1985-05-02	1985-05-02 00:00:00	1985-05-15	1985-05-15 00:00:00	32020		\N	263839	0	43878008	28060		0
77911	4615	4112343	2009-05-16	2009-05-16 00:00:00	2009-05-27	2009-05-27 00:00:00	32020		\N	307377	0	195662009	4112343		0
67492	3989	81151	1975-03-25	1975-03-25 00:00:00	1975-04-22	1975-04-22 00:00:00	32020		\N	265247	0	44465007	81151		0
67614	3995	4278672	1974-02-27	1974-02-27 00:00:00	1974-05-28	1974-05-28 00:00:00	32020		\N	265612	0	65966004	4278672		0
67763	4005	40481087	1971-08-16	1971-08-16 00:00:00	1971-08-23	1971-08-23 00:00:00	32020		\N	266126	0	444814009	40481087		0
67992	4017	4146173	1972-06-24	1972-06-24 00:00:00	1972-08-23	1972-08-23 00:00:00	32020		\N	267035	0	307731004	4146173		0
68104	4021	40481087	1986-08-07	1986-08-07 00:00:00	1986-08-14	1986-08-14 00:00:00	32020		\N	267315	0	444814009	40481087		0
68364	4040	28060	1981-02-13	1981-02-13 00:00:00	1981-02-25	1981-02-25 00:00:00	32020		\N	268702	0	43878008	28060		0
68475	4049	40481087	1974-05-02	1974-05-02 00:00:00	1974-05-16	1974-05-16 00:00:00	32020		\N	269126	0	444814009	40481087		0
68681	4064	40481087	1985-12-27	1985-12-27 00:00:00	1986-01-03	1986-01-03 00:00:00	32020		\N	270012	0	444814009	40481087		0
68829	4072	372328	2010-01-18	2010-01-18 00:00:00	2010-02-01	2010-02-01 00:00:00	32020		\N	270685	0	65363002	372328		0
58389	3458	81151	1983-06-30	1983-06-30 00:00:00	1983-07-21	1983-07-21 00:00:00	32020		\N	229483	0	44465007	81151		0
69106	4090	4285898	1984-04-01	1984-04-01 00:00:00	\N	\N	32020		\N	271887	0	68496003	4285898		0
79859	4732	4112343	1985-02-10	1985-02-10 00:00:00	1985-02-18	1985-02-18 00:00:00	32020		\N	315245	0	195662009	4112343		0
58860	3490	260139	1993-06-22	1993-06-22 00:00:00	1993-07-06	1993-07-06 00:00:00	32020		\N	231597	0	10509002	260139		0
59080	3505	4266809	1975-11-13	1975-11-13 00:00:00	\N	\N	32020		\N	232398	0	397881000	4266809		0
69858	4133	4152936	2004-11-14	2004-11-14 00:00:00	2004-12-05	2004-12-05 00:00:00	32020		\N	274781	0	283385000	4152936		0
80592	4777	4283893	2010-06-17	2010-06-17 00:00:00	2010-07-15	2010-07-15 00:00:00	32020		\N	318060	0	36971009	4283893		0
59566	3531	378001	2012-01-30	2012-01-30 00:00:00	2012-03-30	2012-03-30 00:00:00	32020		\N	234529	0	62106007	378001		0
70323	4165	4112343	1951-01-22	1951-01-22 00:00:00	1951-01-31	1951-01-31 00:00:00	32020		\N	276697	0	195662009	4112343		0
81051	4807	378001	1957-10-27	1957-10-27 00:00:00	1957-12-26	1957-12-26 00:00:00	32020		\N	319807	0	62106007	378001		0
81196	4815	378001	1995-05-21	1995-05-21 00:00:00	1995-07-20	1995-07-20 00:00:00	32020		\N	320335	0	62106007	378001		0
70783	4200	372328	1973-06-14	1973-06-14 00:00:00	1974-06-05	1974-06-05 00:00:00	32020		\N	278783	0	65363002	372328		0
70913	4206	261325	1983-09-06	1983-09-06 00:00:00	\N	\N	32020		\N	279322	0	87433001	261325		0
60528	3578	4109685	2009-02-17	2009-02-17 00:00:00	2009-03-03	2009-03-03 00:00:00	32020		\N	237861	0	284551006	4109685		0
71389	4235	40481087	2002-07-31	2002-07-31 00:00:00	2002-08-14	2002-08-14 00:00:00	32020		\N	281169	0	444814009	40481087		0
71658	4250	40481087	1999-07-08	1999-07-08 00:00:00	1999-07-29	1999-07-29 00:00:00	32020		\N	282330	0	444814009	40481087		0
71731	4255	440086	1981-04-26	1981-04-26 00:00:00	1991-05-04	1991-05-04 00:00:00	32020		\N	282513	0	192127007	440086		0
71905	4268	260139	1993-05-26	1993-05-26 00:00:00	1993-06-09	1993-06-09 00:00:00	32020		\N	283246	0	10509002	260139		0
61581	3638	4112343	1970-05-11	1970-05-11 00:00:00	1970-05-18	1970-05-18 00:00:00	32020		\N	241974	0	195662009	4112343		0
61707	3644	134438	1974-01-22	1974-01-22 00:00:00	1975-01-17	1975-01-17 00:00:00	32020		\N	242466	0	40275004	134438		0
72522	4308	40481087	1957-02-08	1957-02-08 00:00:00	1957-03-01	1957-03-01 00:00:00	32020		\N	285775	0	444814009	40481087		0
72669	4317	260139	2007-11-25	2007-11-25 00:00:00	2007-12-09	2007-12-09 00:00:00	32020		\N	286557	0	10509002	260139		0
72765	4324	4027663	1991-06-04	1991-06-04 00:00:00	\N	\N	32020		\N	286806	0	13200003	4027663		0
83529	4964	4059173	2015-09-27	2015-09-27 00:00:00	2015-12-26	2015-12-26 00:00:00	32020		\N	329972	0	16114001	4059173		0
73143	4347	260139	2001-05-07	2001-05-07 00:00:00	2001-05-21	2001-05-21 00:00:00	32020		\N	288268	0	10509002	260139		0
73234	4352	372328	1950-04-04	1950-04-04 00:00:00	1950-07-06	1950-07-06 00:00:00	32020		\N	288713	0	65363002	372328		0
73532	4372	4084167	1981-01-03	1981-01-03 00:00:00	1981-01-03	1981-01-03 00:00:00	32020		\N	290259	0	241929008	4084167		0
63073	3725	80180	2006-11-13	2006-11-13 00:00:00	\N	\N	32020		\N	247585	0	396275006	80180		0
73849	4387	4146173	1972-07-08	1972-07-08 00:00:00	1972-08-14	1972-08-14 00:00:00	32020		\N	291587	0	307731004	4146173		0
73988	4395	40481087	1998-03-28	1998-03-28 00:00:00	1998-04-18	1998-04-18 00:00:00	32020		\N	292267	0	444814009	40481087		0
74161	4405	40481087	2011-06-20	2011-06-20 00:00:00	2011-07-11	2011-07-11 00:00:00	32020		\N	292789	0	444814009	40481087		0
74363	4413	372328	1962-07-01	1962-07-01 00:00:00	1962-10-11	1962-10-11 00:00:00	32020		\N	293466	0	65363002	372328		0
63858	3773	260139	2003-06-09	2003-06-09 00:00:00	2003-06-16	2003-06-16 00:00:00	32020		\N	250824	0	10509002	260139		0
74558	4428	28060	1961-11-05	1961-11-05 00:00:00	1961-11-17	1961-11-17 00:00:00	32020		\N	294415	0	43878008	28060		0
64160	3789	4112343	2002-02-16	2002-02-16 00:00:00	2002-02-24	2002-02-24 00:00:00	32020		\N	251880	0	195662009	4112343		0
64276	3796	260139	1973-09-14	1973-09-14 00:00:00	1973-09-28	1973-09-28 00:00:00	32020		\N	252354	0	10509002	260139		0
64414	3804	4278672	1962-09-18	1962-09-18 00:00:00	1962-10-18	1962-10-18 00:00:00	32020		\N	252857	0	65966004	4278672		0
64701	3825	4113008	1988-01-28	1988-01-28 00:00:00	1988-02-18	1988-02-18 00:00:00	32020		\N	254066	0	284549007	4113008		0
54244	3214	4218389	1976-03-25	1976-03-25 00:00:00	1976-04-22	1976-04-22 00:00:00	32020		\N	213493	0	39848009	4218389		0
64941	3839	40481087	2014-04-04	2014-04-04 00:00:00	2014-04-25	2014-04-25 00:00:00	32020		\N	254843	0	444814009	40481087		0
54597	3232	4296204	1999-07-14	1999-07-14 00:00:00	1999-08-11	1999-08-11 00:00:00	32020		\N	214859	0	403190006	4296204		0
65260	3859	4283893	1982-02-20	1982-02-20 00:00:00	1982-03-20	1982-03-20 00:00:00	32020		\N	256176	0	36971009	4283893		0
65434	3869	4112343	1944-08-09	1944-08-09 00:00:00	1944-08-21	1944-08-21 00:00:00	32020		\N	256928	0	195662009	4112343		0
65717	3885	4112343	1967-06-05	1967-06-05 00:00:00	1967-06-17	1967-06-17 00:00:00	32020		\N	258281	0	195662009	4112343		0
65899	3895	260139	1958-06-26	1958-06-26 00:00:00	1958-07-10	1958-07-10 00:00:00	32020		\N	259119	0	10509002	260139		0
65958	3900	40481087	2002-04-26	2002-04-26 00:00:00	2002-05-17	2002-05-17 00:00:00	32020		\N	259305	0	444814009	40481087		0
66137	3913	4283893	1966-10-05	1966-10-05 00:00:00	1967-04-12	1967-04-12 00:00:00	32020		\N	260136	0	36971009	4283893		0
66326	3927	4112343	1948-10-22	1948-10-22 00:00:00	1948-11-03	1948-11-03 00:00:00	32020		\N	261040	0	195662009	4112343		0
66417	3930	260139	1917-09-14	1917-09-14 00:00:00	1917-09-28	1917-09-28 00:00:00	32020		\N	261262	0	10509002	260139		0
77212	4574	4112343	1990-06-24	1990-06-24 00:00:00	1990-07-02	1990-07-02 00:00:00	32020		\N	304740	0	195662009	4112343		0
66842	3955	4112343	1983-10-11	1983-10-11 00:00:00	1983-10-18	1983-10-18 00:00:00	32020		\N	262892	0	195662009	4112343		0
66982	3960	4285898	1996-09-23	1996-09-23 00:00:00	\N	\N	32020		\N	263286	0	68496003	4285898		0
67125	3968	4112343	1979-01-23	1979-01-23 00:00:00	1979-01-30	1979-01-30 00:00:00	32020		\N	263838	0	195662009	4112343		0
77912	4615	260139	1973-06-04	1973-06-04 00:00:00	1973-06-18	1973-06-18 00:00:00	32020		\N	307427	0	10509002	260139		0
67493	3989	260139	1974-12-02	1974-12-02 00:00:00	1974-12-16	1974-12-16 00:00:00	32020		\N	265250	0	10509002	260139		0
67615	3995	40481087	1992-07-12	1992-07-12 00:00:00	1992-07-19	1992-07-19 00:00:00	32020		\N	265594	0	444814009	40481087		0
67764	4005	40481087	1979-07-03	1979-07-03 00:00:00	1979-07-10	1979-07-10 00:00:00	32020		\N	266128	0	444814009	40481087		0
67993	4017	40481087	1959-10-25	1959-10-25 00:00:00	1959-11-15	1959-11-15 00:00:00	32020		\N	266944	0	444814009	40481087		0
68105	4022	40481087	2012-06-26	2012-06-26 00:00:00	2012-07-03	2012-07-03 00:00:00	32020		\N	267414	0	444814009	40481087		0
68365	4040	260139	2017-03-02	2017-03-02 00:00:00	2017-03-09	2017-03-09 00:00:00	32020		\N	268673	0	10509002	260139		0
68476	4049	40481087	2012-05-23	2012-05-23 00:00:00	2012-06-13	2012-06-13 00:00:00	32020		\N	269165	0	444814009	40481087		0
68682	4064	4112343	1991-02-08	1991-02-08 00:00:00	1991-02-16	1991-02-16 00:00:00	32020		\N	270001	0	195662009	4112343		0
68869	4077	40481087	2008-11-20	2008-11-20 00:00:00	2008-11-27	2008-11-27 00:00:00	32020		\N	270899	0	444814009	40481087		0
58390	3458	78272	2014-04-21	2014-04-21 00:00:00	2014-05-19	2014-05-19 00:00:00	32020		\N	229449	0	70704007	78272		0
69107	4090	4266809	1984-06-30	1984-06-30 00:00:00	\N	\N	32020		\N	271887	0	397881000	4266809		0
79860	4732	260139	1995-02-28	1995-02-28 00:00:00	1995-03-07	1995-03-07 00:00:00	32020		\N	315282	0	10509002	260139		0
58884	3494	440086	1970-08-03	1970-08-03 00:00:00	1977-08-11	1977-08-11 00:00:00	32020		\N	231741	0	192127007	440086		0
59081	3505	40481087	1975-10-01	1975-10-01 00:00:00	1975-10-15	1975-10-15 00:00:00	32020		\N	232398	0	444814009	40481087		0
69859	4133	4113008	2012-07-10	2012-07-10 00:00:00	2012-07-31	2012-07-31 00:00:00	32020		\N	274816	0	284549007	4113008		0
80593	4777	260139	2004-08-21	2004-08-21 00:00:00	2004-08-28	2004-08-28 00:00:00	32020		\N	318110	0	10509002	260139		0
59567	3531	40481087	1990-01-02	1990-01-02 00:00:00	1990-01-09	1990-01-09 00:00:00	32020		\N	234570	0	444814009	40481087		0
70324	4165	40481087	2001-05-06	2001-05-06 00:00:00	2001-05-27	2001-05-27 00:00:00	32020		\N	276766	0	444814009	40481087		0
81052	4807	40481087	1976-03-26	1976-03-26 00:00:00	1976-04-09	1976-04-09 00:00:00	32020		\N	319845	0	444814009	40481087		0
81197	4815	372328	1971-08-27	1971-08-27 00:00:00	1972-02-10	1972-02-10 00:00:00	32020		\N	320341	0	65363002	372328		0
70784	4200	40481087	2005-01-26	2005-01-26 00:00:00	2005-02-02	2005-02-02 00:00:00	32020		\N	278748	0	444814009	40481087		0
70914	4206	4218389	1959-01-15	1959-01-15 00:00:00	1959-02-12	1959-02-12 00:00:00	32020		\N	279301	0	39848009	4218389		0
60529	3578	372328	1991-01-10	1991-01-10 00:00:00	1991-10-02	1991-10-02 00:00:00	32020		\N	237870	0	65363002	372328		0
71268	4226	40481087	2002-03-27	2002-03-27 00:00:00	2002-04-17	2002-04-17 00:00:00	32020		\N	280643	0	444814009	40481087		0
71390	4235	4149245	2007-03-09	2007-03-09 00:00:00	2007-04-15	2007-04-15 00:00:00	32020		\N	281212	0	30832001	4149245		0
71659	4250	4112343	1947-07-22	1947-07-22 00:00:00	1947-07-31	1947-07-31 00:00:00	32020		\N	282332	0	195662009	4112343		0
71732	4255	80180	2010-02-03	2010-02-03 00:00:00	\N	\N	32020		\N	282494	0	396275006	80180		0
71906	4268	260139	1996-04-25	1996-04-25 00:00:00	1996-05-02	1996-05-02 00:00:00	32020		\N	283278	0	10509002	260139		0
61582	3638	4112343	1966-07-17	1966-07-17 00:00:00	1966-07-28	1966-07-28 00:00:00	32020		\N	241969	0	195662009	4112343		0
61708	3644	4112343	1978-02-13	1978-02-13 00:00:00	1978-02-25	1978-02-25 00:00:00	32020		\N	242482	0	195662009	4112343		0
72523	4308	372328	1913-10-23	1913-10-23 00:00:00	1914-01-28	1914-01-28 00:00:00	32020		\N	285816	0	65363002	372328		0
72670	4317	40481087	1989-11-03	1989-11-03 00:00:00	1989-11-17	1989-11-17 00:00:00	32020		\N	286555	0	444814009	40481087		0
72766	4325	40481087	1972-10-27	1972-10-27 00:00:00	1972-11-03	1972-11-03 00:00:00	32020		\N	286925	0	444814009	40481087		0
83530	4964	439777	2016-01-30	2016-01-30 00:00:00	\N	\N	32020		\N	329971	0	271737000	439777		0
73144	4347	4134304	1972-11-09	1972-11-09 00:00:00	1973-01-08	1973-01-08 00:00:00	32020		\N	288290	0	263102004	4134304		0
73235	4352	4112343	1973-01-21	1973-01-21 00:00:00	1973-02-02	1973-02-02 00:00:00	32020		\N	288635	0	195662009	4112343		0
73533	4372	260139	1987-07-11	1987-07-11 00:00:00	1987-07-25	1987-07-25 00:00:00	32020		\N	290206	0	10509002	260139		0
63074	3725	40481087	2007-01-14	2007-01-14 00:00:00	2007-01-21	2007-01-21 00:00:00	32020		\N	247561	0	444814009	40481087		0
73850	4387	28060	1974-07-04	1974-07-04 00:00:00	1974-07-15	1974-07-15 00:00:00	32020		\N	291588	0	43878008	28060		0
73989	4395	4230399	2013-11-08	2013-11-08 00:00:00	2013-12-08	2013-12-08 00:00:00	32020		\N	292288	0	359817006	4230399		0
74162	4405	40481087	1973-09-03	1973-09-03 00:00:00	1973-09-10	1973-09-10 00:00:00	32020		\N	292840	0	444814009	40481087		0
74364	4413	260139	1976-08-04	1976-08-04 00:00:00	1976-08-18	1976-08-18 00:00:00	32020		\N	293490	0	10509002	260139		0
63859	3773	260139	1961-11-14	1961-11-14 00:00:00	1961-11-28	1961-11-28 00:00:00	32020		\N	250777	0	10509002	260139		0
74559	4428	4112343	2011-04-05	2011-04-05 00:00:00	2011-04-13	2011-04-13 00:00:00	32020		\N	294367	0	195662009	4112343		0
64161	3789	4112343	1953-07-04	1953-07-04 00:00:00	1953-07-12	1953-07-12 00:00:00	32020		\N	251872	0	195662009	4112343		0
64277	3796	4156265	1986-05-22	1986-05-22 00:00:00	1986-06-05	1986-06-05 00:00:00	32020		\N	252356	0	370247008	4156265		0
64415	3804	40481087	1989-06-19	1989-06-19 00:00:00	1989-07-03	1989-07-03 00:00:00	32020		\N	252831	0	444814009	40481087		0
64702	3825	40481087	1984-01-20	1984-01-20 00:00:00	1984-02-03	1984-02-03 00:00:00	32020		\N	254055	0	444814009	40481087		0
54245	3214	81151	2005-10-29	2005-10-29 00:00:00	2005-11-26	2005-11-26 00:00:00	32020		\N	213498	0	44465007	81151		0
64942	3839	260139	1994-07-23	1994-07-23 00:00:00	1994-08-06	1994-08-06 00:00:00	32020		\N	254889	0	10509002	260139		0
65073	3849	28060	1969-04-20	1969-04-20 00:00:00	1969-05-03	1969-05-03 00:00:00	32020		\N	255452	0	43878008	28060		0
65261	3859	260139	1993-07-08	1993-07-08 00:00:00	1993-07-22	1993-07-22 00:00:00	32020		\N	256210	0	10509002	260139		0
65435	3869	40481087	1919-11-28	1919-11-28 00:00:00	1919-12-05	1919-12-05 00:00:00	32020		\N	256937	0	444814009	40481087		0
65718	3885	260139	2003-06-06	2003-06-06 00:00:00	2003-06-13	2003-06-13 00:00:00	32020		\N	258257	0	10509002	260139		0
65900	3895	4112343	1950-05-10	1950-05-10 00:00:00	1950-05-17	1950-05-17 00:00:00	32020		\N	259117	0	195662009	4112343		0
65959	3900	4218389	1977-07-11	1977-07-11 00:00:00	1977-08-01	1977-08-01 00:00:00	32020		\N	259340	0	39848009	4218389		0
66138	3913	4112343	2005-03-19	2005-03-19 00:00:00	2005-03-29	2005-03-29 00:00:00	32020		\N	260098	0	195662009	4112343		0
66327	3927	40481087	1957-04-04	1957-04-04 00:00:00	1957-04-18	1957-04-18 00:00:00	32020		\N	261042	0	444814009	40481087		0
66426	3932	4112343	2013-11-17	2013-11-17 00:00:00	2013-11-24	2013-11-24 00:00:00	32020		\N	261362	0	195662009	4112343		0
77213	4574	30753	1991-02-01	1991-02-01 00:00:00	\N	\N	32020		\N	304740	0	16761005	30753		0
66843	3955	28060	1996-01-15	1996-01-15 00:00:00	1996-01-22	1996-01-22 00:00:00	32020		\N	262869	0	43878008	28060		0
66983	3960	40481087	1999-01-09	1999-01-09 00:00:00	1999-01-16	1999-01-16 00:00:00	32020		\N	263253	0	444814009	40481087		0
67126	3968	40481087	1944-03-11	1944-03-11 00:00:00	1944-03-18	1944-03-18 00:00:00	32020		\N	263829	0	444814009	40481087		0
77913	4615	372328	2000-09-15	2000-09-15 00:00:00	2002-02-13	2002-02-13 00:00:00	32020		\N	307459	0	65363002	372328		0
67494	3989	4112343	1939-10-28	1939-10-28 00:00:00	1939-11-04	1939-11-04 00:00:00	32020		\N	265150	0	195662009	4112343		0
67616	3995	4112343	2018-08-06	2018-08-06 00:00:00	2018-08-18	2018-08-18 00:00:00	32020		\N	265596	0	195662009	4112343		0
67765	4005	4112343	1978-12-04	1978-12-04 00:00:00	1978-12-12	1978-12-12 00:00:00	32020		\N	266117	0	195662009	4112343		0
67994	4017	4152936	1948-11-06	1948-11-06 00:00:00	1948-11-27	1948-11-27 00:00:00	32020		\N	267031	0	283385000	4152936		0
68106	4022	40481087	1968-09-18	1968-09-18 00:00:00	1968-09-25	1968-09-25 00:00:00	32020		\N	267395	0	444814009	40481087		0
68366	4040	40481087	2003-05-09	2003-05-09 00:00:00	2003-05-30	2003-05-30 00:00:00	32020		\N	268703	0	444814009	40481087		0
68477	4049	40481087	2011-06-07	2011-06-07 00:00:00	2011-06-21	2011-06-21 00:00:00	32020		\N	269143	0	444814009	40481087		0
68683	4064	4218389	1999-06-28	1999-06-28 00:00:00	1999-07-19	1999-07-19 00:00:00	32020		\N	270123	0	39848009	4218389		0
68870	4077	4059173	1979-08-18	1979-08-18 00:00:00	1979-10-17	1979-10-17 00:00:00	32020		\N	270887	0	16114001	4059173		0
58391	3458	4112343	2008-09-06	2008-09-06 00:00:00	2008-09-13	2008-09-13 00:00:00	32020		\N	229491	0	195662009	4112343		0
69108	4090	260139	1952-02-01	1952-02-01 00:00:00	1952-02-08	1952-02-08 00:00:00	32020		\N	271847	0	10509002	260139		0
79861	4732	40481087	1984-06-16	1984-06-16 00:00:00	1984-07-07	1984-07-07 00:00:00	32020		\N	315287	0	444814009	40481087		0
58885	3494	258780	1999-04-29	1999-04-29 00:00:00	\N	\N	32020		\N	231752	0	185086009	258780		0
59082	3505	80180	1975-11-13	1975-11-13 00:00:00	\N	\N	32020		\N	232398	0	396275006	80180		0
69860	4133	40481087	2019-02-13	2019-02-13 00:00:00	2019-02-27	2019-02-27 00:00:00	32020		\N	274790	0	444814009	40481087		0
80594	4777	40481087	2001-01-19	2001-01-19 00:00:00	2001-01-26	2001-01-26 00:00:00	32020		\N	318077	0	444814009	40481087		0
59568	3531	4027663	1992-03-22	1992-03-22 00:00:00	\N	\N	32020		\N	234579	0	13200003	4027663		0
70325	4165	321042	1991-01-27	1991-01-27 00:00:00	\N	\N	32020		\N	276828	0	410429000	321042		0
81053	4807	40481087	1956-07-06	1956-07-06 00:00:00	1956-07-20	1956-07-20 00:00:00	32020		\N	319795	0	444814009	40481087		0
81198	4815	4156265	1982-10-28	1982-10-28 00:00:00	1982-11-11	1982-11-11 00:00:00	32020		\N	320355	0	370247008	4156265		0
70785	4200	28060	1979-06-26	1979-06-26 00:00:00	1979-07-04	1979-07-04 00:00:00	32020		\N	278737	0	43878008	28060		0
70916	4208	81151	1960-05-30	1960-05-30 00:00:00	1960-06-13	1960-06-13 00:00:00	32020		\N	279426	0	44465007	81151		0
60530	3579	4155034	1965-10-26	1965-10-26 00:00:00	1965-11-16	1965-11-16 00:00:00	32020		\N	237960	0	283371005	4155034		0
71269	4226	260139	1983-03-09	1983-03-09 00:00:00	1983-03-16	1983-03-16 00:00:00	32020		\N	280768	0	10509002	260139		0
71391	4235	40481087	2005-02-04	2005-02-04 00:00:00	2005-02-18	2005-02-18 00:00:00	32020		\N	281170	0	444814009	40481087		0
71660	4250	40481087	1966-05-14	1966-05-14 00:00:00	1966-05-21	1966-05-21 00:00:00	32020		\N	282326	0	444814009	40481087		0
71733	4255	40481087	2009-12-16	2009-12-16 00:00:00	2010-01-06	2010-01-06 00:00:00	32020		\N	282494	0	444814009	40481087		0
71907	4268	4112343	1956-01-13	1956-01-13 00:00:00	1956-01-23	1956-01-23 00:00:00	32020		\N	283265	0	195662009	4112343		0
61583	3638	81151	1976-04-23	1976-04-23 00:00:00	1976-05-07	1976-05-07 00:00:00	32020		\N	241966	0	44465007	81151		0
61709	3644	321042	1982-02-24	1982-02-24 00:00:00	\N	\N	32020		\N	242492	0	410429000	321042		0
72524	4308	40481087	1925-10-20	1925-10-20 00:00:00	1925-11-10	1925-11-10 00:00:00	32020		\N	285741	0	444814009	40481087		0
72671	4317	260139	1980-05-20	1980-05-20 00:00:00	1980-06-03	1980-06-03 00:00:00	32020		\N	286499	0	10509002	260139		0
72767	4325	78272	1982-11-03	1982-11-03 00:00:00	1982-11-17	1982-11-17 00:00:00	32020		\N	286933	0	70704007	78272		0
83531	4964	40481087	1989-03-21	1989-03-21 00:00:00	1989-04-04	1989-04-04 00:00:00	32020		\N	330006	0	444814009	40481087		0
73145	4347	40481087	1997-09-29	1997-09-29 00:00:00	1997-10-06	1997-10-06 00:00:00	32020		\N	288303	0	444814009	40481087		0
73236	4352	4266809	1987-04-11	1987-04-11 00:00:00	\N	\N	32020		\N	288649	0	397881000	4266809		0
73534	4372	4112343	2007-09-13	2007-09-13 00:00:00	2007-09-22	2007-09-22 00:00:00	32020		\N	290245	0	195662009	4112343		0
63075	3725	4059173	1981-09-16	1981-09-16 00:00:00	1981-12-15	1981-12-15 00:00:00	32020		\N	247576	0	16114001	4059173		0
73851	4387	260139	2002-08-04	2002-08-04 00:00:00	2002-08-11	2002-08-11 00:00:00	32020		\N	291603	0	10509002	260139		0
73990	4395	40481087	2009-10-23	2009-10-23 00:00:00	2009-11-06	2009-11-06 00:00:00	32020		\N	292212	0	444814009	40481087		0
74163	4405	4112343	1971-03-13	1971-03-13 00:00:00	1971-03-23	1971-03-23 00:00:00	32020		\N	292796	0	195662009	4112343		0
74365	4413	4278672	1976-08-07	1976-08-07 00:00:00	1976-09-06	1976-09-06 00:00:00	32020		\N	293417	0	65966004	4278672		0
63860	3773	81151	1990-12-31	1990-12-31 00:00:00	1991-01-14	1991-01-14 00:00:00	32020		\N	250814	0	44465007	81151		0
74560	4428	195588	2005-11-10	2005-11-10 00:00:00	2005-12-16	2005-12-16 00:00:00	32020		\N	294418	0	38822007	195588		0
64162	3789	260139	1974-11-30	1974-11-30 00:00:00	1974-12-14	1974-12-14 00:00:00	32020		\N	251871	0	10509002	260139		0
64278	3796	260139	1986-05-03	1986-05-03 00:00:00	1986-05-17	1986-05-17 00:00:00	32020		\N	252411	0	10509002	260139		0
64416	3804	4283893	2007-09-11	2007-09-11 00:00:00	2007-10-02	2007-10-02 00:00:00	32020		\N	252884	0	36971009	4283893		0
64703	3825	260139	1992-06-06	1992-06-06 00:00:00	1992-06-13	1992-06-13 00:00:00	32020		\N	254038	0	10509002	260139		0
54246	3214	4112343	1976-06-26	1976-06-26 00:00:00	1976-07-05	1976-07-05 00:00:00	32020		\N	213522	0	195662009	4112343		0
64943	3839	4027663	1981-10-15	1981-10-15 00:00:00	\N	\N	32020		\N	254873	0	13200003	4027663		0
65074	3849	4112343	1975-08-02	1975-08-02 00:00:00	1975-08-09	1975-08-09 00:00:00	32020		\N	255406	0	195662009	4112343		0
65262	3859	372328	1923-05-14	1923-05-14 00:00:00	1923-08-25	1923-08-25 00:00:00	32020		\N	256178	0	65363002	372328		0
65436	3869	260139	1947-03-16	1947-03-16 00:00:00	1947-03-23	1947-03-23 00:00:00	32020		\N	256939	0	10509002	260139		0
65719	3885	40481087	2018-10-10	2018-10-10 00:00:00	2018-10-17	2018-10-17 00:00:00	32020		\N	258228	0	444814009	40481087		0
65901	3895	260139	2004-08-30	2004-08-30 00:00:00	2004-09-13	2004-09-13 00:00:00	32020		\N	259105	0	10509002	260139		0
65960	3900	260139	1978-01-08	1978-01-08 00:00:00	1978-01-15	1978-01-15 00:00:00	32020		\N	259298	0	10509002	260139		0
66139	3913	4109685	1996-10-19	1996-10-19 00:00:00	1996-11-02	1996-11-02 00:00:00	32020		\N	260087	0	284551006	4109685		0
66328	3927	4218389	1998-09-12	1998-09-12 00:00:00	1998-10-03	1998-10-03 00:00:00	32020		\N	261037	0	39848009	4218389		0
66427	3932	80180	2010-11-10	2010-11-10 00:00:00	\N	\N	32020		\N	261387	0	396275006	80180		0
77214	4574	40481087	1986-12-18	1986-12-18 00:00:00	1987-01-01	1987-01-01 00:00:00	32020		\N	304683	0	444814009	40481087		0
66844	3955	40481087	2011-06-03	2011-06-03 00:00:00	2011-06-17	2011-06-17 00:00:00	32020		\N	262860	0	444814009	40481087		0
66984	3961	40481087	2007-03-29	2007-03-29 00:00:00	2007-04-05	2007-04-05 00:00:00	32020		\N	263369	0	444814009	40481087		0
67127	3968	4112343	1990-07-22	1990-07-22 00:00:00	1990-08-01	1990-08-01 00:00:00	32020		\N	263853	0	195662009	4112343		0
77914	4615	260139	2002-08-11	2002-08-11 00:00:00	2002-08-25	2002-08-25 00:00:00	32020		\N	307455	0	10509002	260139		0
67495	3989	4112343	2003-01-18	2003-01-18 00:00:00	2003-01-26	2003-01-26 00:00:00	32020		\N	265259	0	195662009	4112343		0
67617	3995	4112343	2001-07-26	2001-07-26 00:00:00	2001-08-04	2001-08-04 00:00:00	32020		\N	265616	0	195662009	4112343		0
67766	4005	4112343	2009-07-06	2009-07-06 00:00:00	2009-07-13	2009-07-13 00:00:00	32020		\N	266112	0	195662009	4112343		0
67995	4017	4112343	2009-04-20	2009-04-20 00:00:00	2009-04-27	2009-04-27 00:00:00	32020		\N	266949	0	195662009	4112343		0
68107	4022	4112343	2001-11-05	2001-11-05 00:00:00	2001-11-15	2001-11-15 00:00:00	32020		\N	267392	0	195662009	4112343		0
68367	4040	40481087	1977-04-02	1977-04-02 00:00:00	1977-04-16	1977-04-16 00:00:00	32020		\N	268662	0	444814009	40481087		0
68478	4049	81151	1973-08-29	1973-08-29 00:00:00	1973-09-12	1973-09-12 00:00:00	32020		\N	269135	0	44465007	81151		0
68684	4064	28060	1966-11-18	1966-11-18 00:00:00	1966-11-30	1966-11-30 00:00:00	32020		\N	270109	0	43878008	28060		0
68871	4077	4112343	1998-04-18	1998-04-18 00:00:00	1998-04-30	1998-04-30 00:00:00	32020		\N	270914	0	195662009	4112343		0
58392	3458	4109685	2013-05-05	2013-05-05 00:00:00	2013-05-26	2013-05-26 00:00:00	32020		\N	229448	0	284551006	4109685		0
69109	4090	313217	2017-08-14	2017-08-14 00:00:00	\N	\N	32020		\N	271870	0	49436004	313217		0
79862	4732	440448	1970-07-21	1970-07-21 00:00:00	\N	\N	32020		\N	315274	0	74400008	440448		0
58886	3494	4112343	2012-10-17	2012-10-17 00:00:00	2012-10-26	2012-10-26 00:00:00	32020		\N	231773	0	195662009	4112343		0
59083	3505	4294548	1948-10-06	1948-10-06 00:00:00	1949-01-05	1949-01-05 00:00:00	32020		\N	232423	0	75498004	4294548		0
69861	4133	40481087	2002-09-05	2002-09-05 00:00:00	2002-09-19	2002-09-19 00:00:00	32020		\N	274798	0	444814009	40481087		0
80595	4777	81151	2004-03-17	2004-03-17 00:00:00	2004-04-07	2004-04-07 00:00:00	32020		\N	318097	0	44465007	81151		0
59569	3531	4112343	1972-08-30	1972-08-30 00:00:00	1972-09-06	1972-09-06 00:00:00	32020		\N	234519	0	195662009	4112343		0
70327	4165	260139	1944-02-11	1944-02-11 00:00:00	1944-02-18	1944-02-18 00:00:00	32020		\N	276741	0	10509002	260139		0
81054	4807	28060	1967-07-12	1967-07-12 00:00:00	1967-07-25	1967-07-25 00:00:00	32020		\N	319797	0	43878008	28060		0
81199	4815	260139	2012-06-02	2012-06-02 00:00:00	2012-06-09	2012-06-09 00:00:00	32020		\N	320330	0	10509002	260139		0
70786	4200	40481087	1970-10-15	1970-10-15 00:00:00	1970-10-29	1970-10-29 00:00:00	32020		\N	278731	0	444814009	40481087		0
70917	4208	78272	2012-09-18	2012-09-18 00:00:00	2012-10-09	2012-10-09 00:00:00	32020		\N	279459	0	70704007	78272		0
60531	3579	4113008	2004-11-12	2004-11-12 00:00:00	2004-12-03	2004-12-03 00:00:00	32020		\N	237963	0	284549007	4113008		0
71270	4226	40481087	1977-08-21	1977-08-21 00:00:00	1977-09-04	1977-09-04 00:00:00	32020		\N	280692	0	444814009	40481087		0
71392	4235	4027663	2005-02-22	2005-02-22 00:00:00	\N	\N	32020		\N	281170	0	13200003	4027663		0
71661	4250	4294548	2008-07-19	2008-07-19 00:00:00	2008-08-09	2008-08-09 00:00:00	32020		\N	282307	0	75498004	4294548		0
71734	4255	40481087	1994-03-25	1994-03-25 00:00:00	1994-04-01	1994-04-01 00:00:00	32020		\N	282491	0	444814009	40481087		0
71908	4268	4155034	1980-01-25	1980-01-25 00:00:00	1980-02-08	1980-02-08 00:00:00	32020		\N	283211	0	283371005	4155034		0
61584	3638	260139	1988-09-19	1988-09-19 00:00:00	1988-09-26	1988-09-26 00:00:00	32020		\N	241990	0	10509002	260139		0
61711	3644	40481087	1962-04-08	1962-04-08 00:00:00	1962-04-22	1962-04-22 00:00:00	32020		\N	242463	0	444814009	40481087		0
72525	4308	260139	1973-01-20	1973-01-20 00:00:00	1973-01-29	1973-01-29 00:00:00	32020		\N	285839	0	10509002	260139		0
72672	4317	40481087	1965-01-26	1965-01-26 00:00:00	1965-02-02	1965-02-02 00:00:00	32020		\N	286550	0	444814009	40481087		0
72768	4325	260139	1972-09-14	1972-09-14 00:00:00	1972-09-21	1972-09-21 00:00:00	32020		\N	286936	0	10509002	260139		0
83532	4964	260139	1966-05-13	1966-05-13 00:00:00	1966-05-27	1966-05-27 00:00:00	32020		\N	329983	0	10509002	260139		0
73146	4347	80180	2002-10-18	2002-10-18 00:00:00	\N	\N	32020		\N	288252	0	396275006	80180		0
73237	4352	4285898	1987-03-12	1987-03-12 00:00:00	\N	\N	32020		\N	288649	0	68496003	4285898		0
73535	4372	378001	2006-09-10	2006-09-10 00:00:00	2006-10-10	2006-10-10 00:00:00	32020		\N	290288	0	62106007	378001		0
63076	3725	81151	1998-07-19	1998-07-19 00:00:00	1998-08-23	1998-08-23 00:00:00	32020		\N	247577	0	44465007	81151		0
73852	4387	372328	1968-04-02	1968-04-02 00:00:00	1968-07-26	1968-07-26 00:00:00	32020		\N	291610	0	65363002	372328		0
73991	4395	4134304	1960-11-27	1960-11-27 00:00:00	1961-02-25	1961-02-25 00:00:00	32020		\N	292237	0	263102004	4134304		0
74164	4405	40481087	1975-01-10	1975-01-10 00:00:00	1975-01-17	1975-01-17 00:00:00	32020		\N	292782	0	444814009	40481087		0
74366	4413	378001	1986-04-17	1986-04-17 00:00:00	1986-06-16	1986-06-16 00:00:00	32020		\N	293418	0	62106007	378001		0
63861	3773	40481087	1969-12-07	1969-12-07 00:00:00	1969-12-21	1969-12-21 00:00:00	32020		\N	250805	0	444814009	40481087		0
74561	4428	378001	2003-12-25	2003-12-25 00:00:00	2004-02-23	2004-02-23 00:00:00	32020		\N	294346	0	62106007	378001		0
64163	3789	4278672	1963-04-09	1963-04-09 00:00:00	1963-05-09	1963-05-09 00:00:00	32020		\N	251911	0	65966004	4278672		0
64279	3796	4218389	2018-12-26	2018-12-26 00:00:00	2019-01-16	2019-01-16 00:00:00	32020		\N	252361	0	39848009	4218389		0
64417	3804	378001	2007-11-17	2007-11-17 00:00:00	2007-12-17	2007-12-17 00:00:00	32020		\N	252861	0	62106007	378001		0
64704	3825	40481087	1996-01-10	1996-01-10 00:00:00	1996-01-24	1996-01-24 00:00:00	32020		\N	254071	0	444814009	40481087		0
54247	3214	40481087	2018-11-27	2018-11-27 00:00:00	2018-12-18	2018-12-18 00:00:00	32020		\N	213528	0	444814009	40481087		0
64944	3839	40481087	1980-08-14	1980-08-14 00:00:00	1980-09-04	1980-09-04 00:00:00	32020		\N	254873	0	444814009	40481087		0
65075	3849	28060	1968-04-13	1968-04-13 00:00:00	1968-04-21	1968-04-21 00:00:00	32020		\N	255428	0	43878008	28060		0
65263	3859	40481087	1926-12-03	1926-12-03 00:00:00	1926-12-17	1926-12-17 00:00:00	32020		\N	256241	0	444814009	40481087		0
65437	3869	40481087	1969-01-19	1969-01-19 00:00:00	1969-02-09	1969-02-09 00:00:00	32020		\N	256930	0	444814009	40481087		0
65720	3885	81151	1984-03-21	1984-03-21 00:00:00	1984-04-18	1984-04-18 00:00:00	32020		\N	258216	0	44465007	81151		0
65902	3895	40481087	1992-03-02	1992-03-02 00:00:00	1992-03-16	1992-03-16 00:00:00	32020		\N	259089	0	444814009	40481087		0
65961	3900	4155034	2002-05-22	2002-05-22 00:00:00	2002-06-12	2002-06-12 00:00:00	32020		\N	259330	0	283371005	4155034		0
66150	3916	4112343	1979-11-18	1979-11-18 00:00:00	1979-12-01	1979-12-01 00:00:00	32020		\N	260279	0	195662009	4112343		0
66329	3927	4112343	1954-05-09	1954-05-09 00:00:00	1954-05-16	1954-05-16 00:00:00	32020		\N	261051	0	195662009	4112343		0
66428	3932	372328	1976-09-09	1976-09-09 00:00:00	1977-03-21	1977-03-21 00:00:00	32020		\N	261366	0	65363002	372328		0
77215	4574	28060	1958-12-02	1958-12-02 00:00:00	1958-12-14	1958-12-14 00:00:00	32020		\N	304738	0	43878008	28060		0
66845	3955	40481087	1978-07-03	1978-07-03 00:00:00	1978-07-24	1978-07-24 00:00:00	32020		\N	262847	0	444814009	40481087		0
66985	3961	40481087	2005-11-06	2005-11-06 00:00:00	2005-11-27	2005-11-27 00:00:00	32020		\N	263331	0	444814009	40481087		0
67128	3968	40481087	1932-05-20	1932-05-20 00:00:00	1932-06-03	1932-06-03 00:00:00	32020		\N	263896	0	444814009	40481087		0
77915	4615	4112343	1977-03-07	1977-03-07 00:00:00	1977-03-16	1977-03-16 00:00:00	32020		\N	307405	0	195662009	4112343		0
67496	3989	4112343	1935-02-09	1935-02-09 00:00:00	1935-02-18	1935-02-18 00:00:00	32020		\N	265149	0	195662009	4112343		0
67618	3995	4112343	1977-02-15	1977-02-15 00:00:00	1977-02-22	1977-02-22 00:00:00	32020		\N	265593	0	195662009	4112343		0
67767	4005	40481087	1980-03-11	1980-03-11 00:00:00	1980-04-01	1980-04-01 00:00:00	32020		\N	266099	0	444814009	40481087		0
67996	4017	313217	1998-04-09	1998-04-09 00:00:00	\N	\N	32020		\N	267002	0	49436004	313217		0
68108	4022	40481087	1983-01-05	1983-01-05 00:00:00	1983-01-26	1983-01-26 00:00:00	32020		\N	267412	0	444814009	40481087		0
68368	4040	40481087	2010-07-17	2010-07-17 00:00:00	2010-07-31	2010-07-31 00:00:00	32020		\N	268686	0	444814009	40481087		0
68479	4049	80809	1991-03-28	1991-03-28 00:00:00	\N	\N	32020		\N	269127	0	69896004	80809		0
68685	4064	4146173	1980-06-23	1980-06-23 00:00:00	1980-07-23	1980-07-23 00:00:00	32020		\N	270074	0	307731004	4146173		0
68872	4077	260139	1971-11-30	1971-11-30 00:00:00	1971-12-14	1971-12-14 00:00:00	32020		\N	270889	0	10509002	260139		0
58393	3458	28060	2000-07-31	2000-07-31 00:00:00	2000-08-07	2000-08-07 00:00:00	32020		\N	229471	0	43878008	28060		0
69110	4090	40481087	1973-04-26	1973-04-26 00:00:00	1973-05-03	1973-05-03 00:00:00	32020		\N	271854	0	444814009	40481087		0
79863	4732	4166224	1970-07-21	1970-07-21 00:00:00	\N	\N	32020		\N	315274	0	47693006	4166224		0
58887	3494	4112343	1996-12-13	1996-12-13 00:00:00	1996-12-24	1996-12-24 00:00:00	32020		\N	231772	0	195662009	4112343		0
59084	3505	4237458	2009-08-12	2009-08-12 00:00:00	2009-11-10	2009-11-10 00:00:00	32020		\N	232382	0	58150001	4237458		0
69862	4133	40481087	2014-12-07	2014-12-07 00:00:00	2014-12-14	2014-12-14 00:00:00	32020		\N	274799	0	444814009	40481087		0
80596	4777	4142905	1974-11-29	1974-11-29 00:00:00	1975-02-27	1975-02-27 00:00:00	32020		\N	318095	0	33737001	4142905		0
59570	3531	30753	2000-07-13	2000-07-13 00:00:00	\N	\N	32020		\N	234537	0	16761005	30753		0
70328	4165	40481087	1937-01-26	1937-01-26 00:00:00	1937-02-09	1937-02-09 00:00:00	32020		\N	276695	0	444814009	40481087		0
81055	4807	28060	1987-03-29	1987-03-29 00:00:00	1987-04-11	1987-04-11 00:00:00	32020		\N	319857	0	43878008	28060		0
81200	4815	4112343	1992-03-21	1992-03-21 00:00:00	1992-04-03	1992-04-03 00:00:00	32020		\N	320328	0	195662009	4112343		0
70787	4200	40486433	1972-06-25	1972-06-25 00:00:00	1987-06-24	1987-06-24 00:00:00	32020		\N	278739	0	446096008	40486433		0
70918	4208	4112343	1944-05-13	1944-05-13 00:00:00	1944-05-20	1944-05-20 00:00:00	32020		\N	279394	0	195662009	4112343		0
60532	3579	4152936	1969-12-25	1969-12-25 00:00:00	1970-01-08	1970-01-08 00:00:00	32020		\N	237961	0	283385000	4152936		0
71271	4226	4218389	2017-10-21	2017-10-21 00:00:00	2017-11-11	2017-11-11 00:00:00	32020		\N	280762	0	39848009	4218389		0
71393	4235	378001	2016-12-14	2016-12-14 00:00:00	2017-02-12	2017-02-12 00:00:00	32020		\N	281214	0	62106007	378001		0
71662	4250	80180	1982-05-13	1982-05-13 00:00:00	\N	\N	32020		\N	282260	0	396275006	80180		0
71735	4255	4218389	1977-11-24	1977-11-24 00:00:00	1977-12-15	1977-12-15 00:00:00	32020		\N	282503	0	39848009	4218389		0
71909	4268	40481087	1993-12-17	1993-12-17 00:00:00	1993-12-31	1993-12-31 00:00:00	32020		\N	283267	0	444814009	40481087		0
61585	3638	4152936	1987-07-09	1987-07-09 00:00:00	1987-07-30	1987-07-30 00:00:00	32020		\N	241967	0	283385000	4152936		0
61712	3644	260139	1959-11-11	1959-11-11 00:00:00	1959-11-18	1959-11-18 00:00:00	32020		\N	242504	0	10509002	260139		0
72526	4308	40481087	1978-11-24	1978-11-24 00:00:00	1978-12-15	1978-12-15 00:00:00	32020		\N	285823	0	444814009	40481087		0
72673	4317	4230399	1998-11-05	1998-11-05 00:00:00	1999-02-03	1999-02-03 00:00:00	32020		\N	286479	0	359817006	4230399		0
72769	4325	28060	1969-01-03	1969-01-03 00:00:00	1969-01-11	1969-01-11 00:00:00	32020		\N	286884	0	43878008	28060		0
83533	4964	4237458	1978-06-13	1978-06-13 00:00:00	1978-08-12	1978-08-12 00:00:00	32020		\N	329970	0	58150001	4237458		0
73147	4347	40481087	2017-01-19	2017-01-19 00:00:00	2017-02-09	2017-02-09 00:00:00	32020		\N	288299	0	444814009	40481087		0
73238	4352	80180	1987-04-11	1987-04-11 00:00:00	\N	\N	32020		\N	288649	0	396275006	80180		0
73536	4372	40481087	1984-02-13	1984-02-13 00:00:00	1984-03-05	1984-03-05 00:00:00	32020		\N	290221	0	444814009	40481087		0
63077	3725	40481087	1978-03-21	1978-03-21 00:00:00	1978-04-04	1978-04-04 00:00:00	32020		\N	247588	0	444814009	40481087		0
73853	4387	80180	2007-11-24	2007-11-24 00:00:00	\N	\N	32020		\N	291617	0	396275006	80180		0
73992	4395	4146173	1974-07-17	1974-07-17 00:00:00	1974-09-15	1974-09-15 00:00:00	32020		\N	292242	0	307731004	4146173		0
74165	4405	260139	1983-05-10	1983-05-10 00:00:00	1983-05-17	1983-05-17 00:00:00	32020		\N	292810	0	10509002	260139		0
74367	4413	4112343	1986-01-20	1986-01-20 00:00:00	1986-01-29	1986-01-29 00:00:00	32020		\N	293457	0	195662009	4112343		0
63862	3773	40481087	1988-04-06	1988-04-06 00:00:00	1988-04-13	1988-04-13 00:00:00	32020		\N	250780	0	444814009	40481087		0
74562	4428	40481087	2011-10-17	2011-10-17 00:00:00	2011-10-31	2011-10-31 00:00:00	32020		\N	294419	0	444814009	40481087		0
64164	3789	260139	1949-05-24	1949-05-24 00:00:00	1949-05-31	1949-05-31 00:00:00	32020		\N	251922	0	10509002	260139		0
64280	3796	375671	2012-03-02	2012-03-02 00:00:00	2012-05-01	2012-05-01 00:00:00	32020		\N	252360	0	62564004	375671		0
64418	3804	30753	2002-09-18	2002-09-18 00:00:00	\N	\N	32020		\N	252894	0	16761005	30753		0
64705	3825	80180	1994-06-21	1994-06-21 00:00:00	\N	\N	32020		\N	254101	0	396275006	80180		0
54248	3214	4027663	1999-02-08	1999-02-08 00:00:00	\N	\N	32020		\N	213517	0	13200003	4027663		0
64945	3839	40481087	1958-06-26	1958-06-26 00:00:00	1958-07-10	1958-07-10 00:00:00	32020		\N	254911	0	444814009	40481087		0
65076	3849	80180	2003-06-29	2003-06-29 00:00:00	\N	\N	32020		\N	255415	0	396275006	80180		0
65264	3859	260139	1926-12-25	1926-12-25 00:00:00	1927-01-08	1927-01-08 00:00:00	32020		\N	256173	0	10509002	260139		0
70376	4168	80180	2010-06-12	2010-06-12 00:00:00	\N	\N	32020		\N	277055	0	396275006	80180		0
65438	3869	78272	1911-03-08	1911-03-08 00:00:00	1911-04-05	1911-04-05 00:00:00	32020		\N	256935	0	70704007	78272		0
65732	3887	4112343	2014-09-28	2014-09-28 00:00:00	2014-10-11	2014-10-11 00:00:00	32020		\N	258352	0	195662009	4112343		0
76361	4529	192671	1997-09-09	1997-09-09 00:00:00	\N	\N	32020		\N	301559	0	K92.2	35208414		0
65962	3900	28060	1967-08-06	1967-08-06 00:00:00	1967-08-16	1967-08-16 00:00:00	32020		\N	259323	0	43878008	28060		0
66151	3916	4285898	2015-08-11	2015-08-11 00:00:00	\N	\N	32020		\N	260300	0	68496003	4285898		0
66330	3927	40481087	1961-12-29	1961-12-29 00:00:00	1962-01-19	1962-01-19 00:00:00	32020		\N	261099	0	444814009	40481087		0
66429	3932	4112343	1978-11-09	1978-11-09 00:00:00	1978-11-21	1978-11-21 00:00:00	32020		\N	261352	0	195662009	4112343		0
77216	4574	40481087	1980-04-27	1980-04-27 00:00:00	1980-05-18	1980-05-18 00:00:00	32020		\N	304726	0	444814009	40481087		0
66846	3955	40481087	1966-02-28	1966-02-28 00:00:00	1966-03-21	1966-03-21 00:00:00	32020		\N	262826	0	444814009	40481087		0
66986	3961	4112343	2016-06-17	2016-06-17 00:00:00	2016-06-25	2016-06-25 00:00:00	32020		\N	263370	0	195662009	4112343		0
67129	3968	40481087	1929-02-19	1929-02-19 00:00:00	1929-02-26	1929-02-26 00:00:00	32020		\N	263791	0	444814009	40481087		0
77964	4621	80180	2012-07-07	2012-07-07 00:00:00	\N	\N	32020		\N	307767	0	396275006	80180		0
67497	3989	4112343	1928-08-29	1928-08-29 00:00:00	1928-09-09	1928-09-09 00:00:00	32020		\N	265148	0	195662009	4112343		0
67619	3995	372328	1973-05-03	1973-05-03 00:00:00	1973-07-21	1973-07-21 00:00:00	32020		\N	265617	0	65363002	372328		0
67768	4005	260139	1973-04-10	1973-04-10 00:00:00	1973-04-17	1973-04-17 00:00:00	32020		\N	266109	0	10509002	260139		0
67997	4017	4134304	1937-04-08	1937-04-08 00:00:00	1937-05-08	1937-05-08 00:00:00	32020		\N	267030	0	263102004	4134304		0
68109	4022	257012	1986-09-10	1986-09-10 00:00:00	\N	\N	32020		\N	267391	0	40055000	257012		0
68369	4040	40481087	1976-05-15	1976-05-15 00:00:00	1976-05-29	1976-05-29 00:00:00	32020		\N	268701	0	444814009	40481087		0
68480	4049	260139	2017-11-13	2017-11-13 00:00:00	2017-11-27	2017-11-27 00:00:00	32020		\N	269175	0	10509002	260139		0
68686	4064	28060	2000-07-15	2000-07-15 00:00:00	2000-07-28	2000-07-28 00:00:00	32020		\N	270031	0	43878008	28060		0
68873	4077	4283893	1994-01-09	1994-01-09 00:00:00	1994-02-06	1994-02-06 00:00:00	32020		\N	270891	0	36971009	4283893		0
58394	3458	260139	1991-06-12	1991-06-12 00:00:00	1991-06-26	1991-06-26 00:00:00	32020		\N	229450	0	10509002	260139		0
69111	4090	4027663	1975-03-15	1975-03-15 00:00:00	\N	\N	32020		\N	271854	0	13200003	4027663		0
79864	4732	40481087	1969-03-20	1969-03-20 00:00:00	1969-04-10	1969-04-10 00:00:00	32020		\N	315244	0	444814009	40481087		0
58888	3494	81151	1991-02-03	1991-02-03 00:00:00	1991-02-24	1991-02-24 00:00:00	32020		\N	231768	0	44465007	81151		0
59085	3505	4112343	1963-12-02	1963-12-02 00:00:00	1963-12-15	1963-12-15 00:00:00	32020		\N	232396	0	195662009	4112343		0
69863	4133	40481087	1987-08-24	1987-08-24 00:00:00	1987-08-31	1987-08-31 00:00:00	32020		\N	274765	0	444814009	40481087		0
80597	4777	4112343	1990-06-15	1990-06-15 00:00:00	1990-06-25	1990-06-25 00:00:00	32020		\N	318084	0	195662009	4112343		0
59571	3531	372328	1971-04-15	1971-04-15 00:00:00	1972-03-08	1972-03-08 00:00:00	32020		\N	234564	0	65363002	372328		0
70329	4165	257012	1949-07-02	1949-07-02 00:00:00	\N	\N	32020		\N	276696	0	40055000	257012		0
81056	4807	4112343	1961-02-19	1961-02-19 00:00:00	1961-03-02	1961-03-02 00:00:00	32020		\N	319787	0	195662009	4112343		0
81201	4816	260139	1994-03-08	1994-03-08 00:00:00	1994-03-22	1994-03-22 00:00:00	32020		\N	320438	0	10509002	260139		0
70788	4200	260139	1991-05-07	1991-05-07 00:00:00	1991-05-14	1991-05-14 00:00:00	32020		\N	278728	0	10509002	260139		0
70919	4208	4294548	1995-08-05	1995-08-05 00:00:00	1996-04-13	1996-04-13 00:00:00	32020		\N	279446	0	75498004	4294548		0
60533	3579	372328	1968-09-10	1968-09-10 00:00:00	1968-10-05	1968-10-05 00:00:00	32020		\N	237955	0	65363002	372328		0
71272	4226	40481087	1982-06-19	1982-06-19 00:00:00	1982-06-26	1982-06-26 00:00:00	32020		\N	280767	0	444814009	40481087		0
71394	4235	40481087	2016-10-23	2016-10-23 00:00:00	2016-10-30	2016-10-30 00:00:00	32020		\N	281206	0	444814009	40481087		0
71663	4250	4112343	2016-03-07	2016-03-07 00:00:00	2016-03-15	2016-03-15 00:00:00	32020		\N	282297	0	195662009	4112343		0
71736	4255	40481087	1974-05-28	1974-05-28 00:00:00	1974-06-04	1974-06-04 00:00:00	32020		\N	282523	0	444814009	40481087		0
71910	4268	4112343	1965-05-09	1965-05-09 00:00:00	1965-05-20	1965-05-20 00:00:00	32020		\N	283276	0	195662009	4112343		0
61586	3638	260139	2013-02-19	2013-02-19 00:00:00	2013-03-05	2013-03-05 00:00:00	32020		\N	241946	0	10509002	260139		0
61713	3644	260139	1975-05-29	1975-05-29 00:00:00	1975-06-12	1975-06-12 00:00:00	32020		\N	242494	0	10509002	260139		0
72527	4308	80180	1947-12-31	1947-12-31 00:00:00	\N	\N	32020		\N	285755	0	396275006	80180		0
72674	4317	4112343	1981-08-22	1981-08-22 00:00:00	1981-08-29	1981-08-29 00:00:00	32020		\N	286500	0	195662009	4112343		0
72770	4325	40481087	1984-05-28	1984-05-28 00:00:00	1984-06-18	1984-06-18 00:00:00	32020		\N	286894	0	444814009	40481087		0
83534	4964	4112343	1991-12-07	1991-12-07 00:00:00	1991-12-14	1991-12-14 00:00:00	32020		\N	329991	0	195662009	4112343		0
73148	4347	81151	2012-06-12	2012-06-12 00:00:00	2012-07-03	2012-07-03 00:00:00	32020		\N	288293	0	44465007	81151		0
73239	4352	260139	2006-03-27	2006-03-27 00:00:00	2006-04-03	2006-04-03 00:00:00	32020		\N	288711	0	10509002	260139		0
73537	4372	4116491	2009-05-01	2009-05-01 00:00:00	2009-06-04	2009-06-04 00:00:00	32020		\N	290291	0	301011002	4116491		0
63078	3725	4152936	1970-09-23	1970-09-23 00:00:00	1970-10-14	1970-10-14 00:00:00	32020		\N	247589	0	283385000	4152936		0
73854	4387	40481087	2018-03-27	2018-03-27 00:00:00	2018-04-03	2018-04-03 00:00:00	32020		\N	291609	0	444814009	40481087		0
73993	4395	4112343	2010-05-30	2010-05-30 00:00:00	2010-06-11	2010-06-11 00:00:00	32020		\N	292261	0	195662009	4112343		0
74166	4405	80180	2006-09-24	2006-09-24 00:00:00	\N	\N	32020		\N	292836	0	396275006	80180		0
84827	5045	40481087	1986-01-21	1986-01-21 00:00:00	1986-02-11	1986-02-11 00:00:00	32020		\N	335269	0	444814009	40481087		0
63863	3773	40481087	2019-01-27	2019-01-27 00:00:00	2019-02-10	2019-02-10 00:00:00	32020		\N	250768	0	444814009	40481087		0
74563	4428	40481087	1994-01-02	1994-01-02 00:00:00	1994-01-16	1994-01-16 00:00:00	32020		\N	294399	0	444814009	40481087		0
64165	3789	78272	2014-12-05	2014-12-05 00:00:00	2015-01-09	2015-01-09 00:00:00	32020		\N	251915	0	70704007	78272		0
64281	3796	4112343	2001-01-14	2001-01-14 00:00:00	2001-01-27	2001-01-27 00:00:00	32020		\N	252392	0	195662009	4112343		0
64419	3804	81893	2002-03-22	2002-03-22 00:00:00	\N	\N	32020		\N	252894	0	64766004	81893		0
64706	3825	4059173	1956-05-31	1956-05-31 00:00:00	1956-06-30	1956-06-30 00:00:00	32020		\N	254107	0	16114001	4059173		0
54249	3214	40481087	2004-02-17	2004-02-17 00:00:00	2004-02-24	2004-02-24 00:00:00	32020		\N	213551	0	444814009	40481087		0
64946	3839	4134304	1972-08-03	1972-08-03 00:00:00	1972-10-02	1972-10-02 00:00:00	32020		\N	254861	0	263102004	4134304		0
65077	3849	40481087	2000-09-14	2000-09-14 00:00:00	2000-09-28	2000-09-28 00:00:00	32020		\N	255392	0	444814009	40481087		0
65265	3859	4112343	1931-06-03	1931-06-03 00:00:00	1931-06-12	1931-06-12 00:00:00	32020		\N	256157	0	195662009	4112343		0
65439	3869	4112343	1994-01-02	1994-01-02 00:00:00	1994-01-11	1994-01-11 00:00:00	32020		\N	256932	0	195662009	4112343		0
65733	3887	40481087	1992-06-03	1992-06-03 00:00:00	1992-06-17	1992-06-17 00:00:00	32020		\N	258343	0	444814009	40481087		0
76362	4529	4112343	2017-10-28	2017-10-28 00:00:00	2017-11-05	2017-11-05 00:00:00	32020		\N	301604	0	195662009	4112343		0
65963	3900	258780	2004-09-21	2004-09-21 00:00:00	\N	\N	32020		\N	259319	0	185086009	258780		0
66152	3916	4134304	2003-07-23	2003-07-23 00:00:00	2003-10-21	2003-10-21 00:00:00	32020		\N	260438	0	263102004	4134304		0
66331	3927	4112343	2013-08-03	2013-08-03 00:00:00	2013-08-12	2013-08-12 00:00:00	32020		\N	261101	0	195662009	4112343		0
66430	3932	4112343	1981-11-08	1981-11-08 00:00:00	1981-11-17	1981-11-17 00:00:00	32020		\N	261361	0	195662009	4112343		0
77217	4574	4112343	2013-09-10	2013-09-10 00:00:00	2013-09-21	2013-09-21 00:00:00	32020		\N	304697	0	195662009	4112343		0
66847	3955	40481087	1957-04-08	1957-04-08 00:00:00	1957-04-15	1957-04-15 00:00:00	32020		\N	262825	0	444814009	40481087		0
66987	3961	4112343	1977-05-19	1977-05-19 00:00:00	1977-05-31	1977-05-31 00:00:00	32020		\N	263339	0	195662009	4112343		0
67130	3968	4112343	1972-04-02	1972-04-02 00:00:00	1972-04-12	1972-04-12 00:00:00	32020		\N	263836	0	195662009	4112343		0
77965	4621	81151	2005-05-30	2005-05-30 00:00:00	2005-06-27	2005-06-27 00:00:00	32020		\N	307744	0	44465007	81151		0
67498	3989	260139	1978-04-09	1978-04-09 00:00:00	1978-04-23	1978-04-23 00:00:00	32020		\N	265159	0	10509002	260139		0
67620	3995	4152936	2010-03-25	2010-03-25 00:00:00	2010-04-15	2010-04-15 00:00:00	32020		\N	265615	0	283385000	4152936		0
67769	4005	4112343	1979-05-15	1979-05-15 00:00:00	1979-05-28	1979-05-28 00:00:00	32020		\N	266110	0	195662009	4112343		0
67998	4017	40481087	1999-10-06	1999-10-06 00:00:00	1999-10-20	1999-10-20 00:00:00	32020		\N	266969	0	444814009	40481087		0
68110	4022	78272	1968-02-01	1968-02-01 00:00:00	1968-03-07	1968-03-07 00:00:00	32020		\N	267385	0	70704007	78272		0
68370	4040	4132546	1991-06-04	1991-06-04 00:00:00	\N	\N	32020		\N	268660	0	275272006	4166590		0
68481	4049	40481087	1993-08-09	1993-08-09 00:00:00	1993-08-23	1993-08-23 00:00:00	32020		\N	269173	0	444814009	40481087		0
68687	4064	40481087	1998-12-03	1998-12-03 00:00:00	1998-12-10	1998-12-10 00:00:00	32020		\N	270046	0	444814009	40481087		0
68874	4077	40481087	1995-04-07	1995-04-07 00:00:00	1995-04-28	1995-04-28 00:00:00	32020		\N	270892	0	444814009	40481087		0
58395	3458	4113008	1992-06-03	1992-06-03 00:00:00	1992-06-24	1992-06-24 00:00:00	32020		\N	229446	0	284549007	4113008		0
69112	4090	40481087	2013-01-06	2013-01-06 00:00:00	2013-01-13	2013-01-13 00:00:00	32020		\N	271918	0	444814009	40481087		0
79865	4732	4237458	1961-11-19	1961-11-19 00:00:00	1962-01-18	1962-01-18 00:00:00	32020		\N	315273	0	58150001	4237458		0
58889	3494	375671	1985-01-05	1985-01-05 00:00:00	1985-03-06	1985-03-06 00:00:00	32020		\N	231767	0	62564004	375671		0
59086	3505	40481087	2004-02-17	2004-02-17 00:00:00	2004-03-09	2004-03-09 00:00:00	32020		\N	232385	0	444814009	40481087		0
69864	4133	40481087	2018-10-30	2018-10-30 00:00:00	2018-11-06	2018-11-06 00:00:00	32020		\N	274788	0	444814009	40481087		0
80598	4777	4112343	1970-05-29	1970-05-29 00:00:00	1970-06-11	1970-06-11 00:00:00	32020		\N	318056	0	195662009	4112343		0
59572	3531	372328	1967-04-28	1967-04-28 00:00:00	1967-07-05	1967-07-05 00:00:00	32020		\N	234574	0	65363002	372328		0
70330	4165	28060	1983-03-06	1983-03-06 00:00:00	1983-03-13	1983-03-13 00:00:00	32020		\N	276755	0	43878008	28060		0
81057	4807	4155034	1946-03-24	1946-03-24 00:00:00	1946-04-14	1946-04-14 00:00:00	32020		\N	319805	0	283371005	4155034		0
81202	4816	81893	2016-01-25	2016-01-25 00:00:00	\N	\N	32020		\N	320377	0	64766004	81893		0
70789	4200	260139	2016-12-24	2016-12-24 00:00:00	2016-12-31	2016-12-31 00:00:00	32020		\N	278750	0	10509002	260139		0
70920	4208	4156265	1972-10-08	1972-10-08 00:00:00	1972-10-22	1972-10-22 00:00:00	32020		\N	279427	0	370247008	4156265		0
60534	3579	321042	2006-05-20	2006-05-20 00:00:00	\N	\N	32020		\N	237964	0	410429000	321042		0
71273	4226	260139	1995-12-09	1995-12-09 00:00:00	1995-12-16	1995-12-16 00:00:00	32020		\N	280642	0	10509002	260139		0
71395	4235	260139	1995-06-06	1995-06-06 00:00:00	1995-06-20	1995-06-20 00:00:00	32020		\N	281168	0	10509002	260139		0
71664	4250	4112343	2002-12-04	2002-12-04 00:00:00	2002-12-15	2002-12-15 00:00:00	32020		\N	282294	0	195662009	4112343		0
71737	4256	40481087	2011-12-26	2011-12-26 00:00:00	2012-01-02	2012-01-02 00:00:00	32020		\N	282612	0	444814009	40481087		0
71911	4268	40481087	1994-07-06	1994-07-06 00:00:00	1994-07-13	1994-07-13 00:00:00	32020		\N	283241	0	444814009	40481087		0
72045	4275	40481087	1999-04-12	1999-04-12 00:00:00	1999-04-26	1999-04-26 00:00:00	32020		\N	283706	0	444814009	40481087		0
61714	3644	192671	1981-12-09	1981-12-09 00:00:00	\N	\N	32020		\N	242487	0	K92.2	35208414		0
72528	4308	372328	1912-10-20	1912-10-20 00:00:00	1912-11-27	1912-11-27 00:00:00	32020		\N	285831	0	65363002	372328		0
72677	4319	258780	1999-12-22	1999-12-22 00:00:00	\N	\N	32020		\N	286588	0	185086009	258780		0
72771	4325	4112343	1988-04-01	1988-04-01 00:00:00	1988-04-10	1988-04-10 00:00:00	32020		\N	286896	0	195662009	4112343		0
83535	4964	80180	2000-05-23	2000-05-23 00:00:00	\N	\N	32020		\N	330024	0	396275006	80180		0
73149	4347	4283893	2003-01-03	2003-01-03 00:00:00	2003-01-31	2003-01-31 00:00:00	32020		\N	288269	0	36971009	4283893		0
73240	4352	4146173	1951-06-14	1951-06-14 00:00:00	1951-07-14	1951-07-14 00:00:00	32020		\N	288656	0	307731004	4146173		0
73538	4372	78272	1997-06-08	1997-06-08 00:00:00	1997-06-29	1997-06-29 00:00:00	32020		\N	290287	0	70704007	78272		0
73539	4372	260139	1982-01-30	1982-01-30 00:00:00	1982-02-06	1982-02-06 00:00:00	32020		\N	290261	0	10509002	260139		0
73855	4388	4112343	2004-12-24	2004-12-24 00:00:00	2005-01-04	2005-01-04 00:00:00	32020		\N	291714	0	195662009	4112343		0
73994	4395	28060	1981-12-17	1981-12-17 00:00:00	1981-12-27	1981-12-27 00:00:00	32020		\N	292266	0	43878008	28060		0
74167	4405	260139	1996-04-28	1996-04-28 00:00:00	1996-05-05	1996-05-05 00:00:00	32020		\N	292786	0	10509002	260139		0
84828	5045	28060	1974-09-16	1974-09-16 00:00:00	1974-09-24	1974-09-24 00:00:00	32020		\N	335266	0	43878008	28060		0
63864	3773	4112343	1979-12-23	1979-12-23 00:00:00	1980-01-03	1980-01-03 00:00:00	32020		\N	250778	0	195662009	4112343		0
74564	4428	260139	1983-08-31	1983-08-31 00:00:00	1983-09-07	1983-09-07 00:00:00	32020		\N	294349	0	10509002	260139		0
64166	3789	260139	1971-10-21	1971-10-21 00:00:00	1971-10-28	1971-10-28 00:00:00	32020		\N	251875	0	10509002	260139		0
64282	3796	40481087	1982-03-16	1982-03-16 00:00:00	1982-03-23	1982-03-23 00:00:00	32020		\N	252379	0	444814009	40481087		0
64420	3804	80180	2003-04-16	2003-04-16 00:00:00	\N	\N	32020		\N	252894	0	396275006	80180		0
64707	3825	4112343	1994-09-06	1994-09-06 00:00:00	1994-09-18	1994-09-18 00:00:00	32020		\N	254070	0	195662009	4112343		0
54250	3214	372328	1976-09-14	1976-09-14 00:00:00	1977-01-25	1977-01-25 00:00:00	32020		\N	213540	0	65363002	372328		0
64947	3839	4116491	1987-10-14	1987-10-14 00:00:00	1987-11-18	1987-11-18 00:00:00	32020		\N	254841	0	301011002	4116491		0
65083	3851	260139	1962-11-05	1962-11-05 00:00:00	1962-11-12	1962-11-12 00:00:00	32020		\N	255601	0	10509002	260139		0
65266	3859	4112343	1980-05-27	1980-05-27 00:00:00	1980-06-08	1980-06-08 00:00:00	32020		\N	256270	0	195662009	4112343		0
65441	3869	321042	1926-10-09	1926-10-09 00:00:00	\N	\N	32020		\N	256936	0	410429000	321042		0
65734	3887	4278672	1968-12-08	1968-12-08 00:00:00	1969-01-07	1969-01-07 00:00:00	32020		\N	258364	0	65966004	4278672		0
76363	4529	4149245	1998-09-28	1998-09-28 00:00:00	1998-11-04	1998-11-04 00:00:00	32020		\N	301615	0	30832001	4149245		0
65964	3900	40481087	1983-06-15	1983-06-15 00:00:00	1983-07-06	1983-07-06 00:00:00	32020		\N	259303	0	444814009	40481087		0
66153	3916	40481087	1987-05-15	1987-05-15 00:00:00	1987-06-05	1987-06-05 00:00:00	32020		\N	260264	0	444814009	40481087		0
66332	3927	260139	1973-06-11	1973-06-11 00:00:00	1973-06-18	1973-06-18 00:00:00	32020		\N	261044	0	10509002	260139		0
66431	3932	81151	1994-01-08	1994-01-08 00:00:00	1994-01-22	1994-01-22 00:00:00	32020		\N	261400	0	44465007	81151		0
77218	4574	28060	1982-09-21	1982-09-21 00:00:00	1982-10-02	1982-10-02 00:00:00	32020		\N	304727	0	43878008	28060		0
66848	3955	40481087	1987-04-09	1987-04-09 00:00:00	1987-04-30	1987-04-30 00:00:00	32020		\N	262893	0	444814009	40481087		0
66988	3961	4112343	1989-06-28	1989-06-28 00:00:00	1989-07-08	1989-07-08 00:00:00	32020		\N	263328	0	195662009	4112343		0
67131	3968	381316	1972-07-07	1972-07-07 00:00:00	\N	\N	32020		\N	263836	0	230690007	381316		0
77966	4621	40481087	2002-04-29	2002-04-29 00:00:00	2002-05-13	2002-05-13 00:00:00	32020		\N	307748	0	444814009	40481087		0
67499	3989	192671	1965-02-06	1965-02-06 00:00:00	\N	\N	32020		\N	265271	0	K92.2	35208414		0
67621	3995	440086	1982-02-10	1982-02-10 00:00:00	1989-02-18	1989-02-18 00:00:00	32020		\N	265590	0	192127007	440086		0
67770	4005	4134304	1981-05-03	1981-05-03 00:00:00	1981-06-02	1981-06-02 00:00:00	32020		\N	266082	0	263102004	4134304		0
67999	4017	260139	1986-10-14	1986-10-14 00:00:00	1986-10-21	1986-10-21 00:00:00	32020		\N	266947	0	10509002	260139		0
68111	4022	4112343	1968-11-28	1968-11-28 00:00:00	1968-12-06	1968-12-06 00:00:00	32020		\N	267396	0	195662009	4112343		0
68371	4040	4001336	1991-06-04	1991-06-04 00:00:00	1991-08-03	1991-08-03 00:00:00	32020		\N	268660	0	110030002	4001336		0
68482	4049	28060	1993-08-15	1993-08-15 00:00:00	1993-08-23	1993-08-23 00:00:00	32020		\N	269174	0	43878008	28060		0
68688	4064	40486433	1963-05-16	1963-05-16 00:00:00	1993-07-12	1993-07-12 00:00:00	32020		\N	270048	0	446096008	40486433		0
68875	4077	260139	1990-11-04	1990-11-04 00:00:00	1990-11-18	1990-11-18 00:00:00	32020		\N	270912	0	10509002	260139		0
58396	3458	372328	1988-04-04	1988-04-04 00:00:00	1988-06-17	1988-06-17 00:00:00	32020		\N	229462	0	65363002	372328		0
69113	4090	317576	2015-08-03	2015-08-03 00:00:00	\N	\N	32020		\N	271869	0	53741008	317576		0
79866	4732	80180	1992-09-27	1992-09-27 00:00:00	\N	\N	32020		\N	315267	0	396275006	80180		0
58890	3494	40481087	2017-06-11	2017-06-11 00:00:00	2017-06-25	2017-06-25 00:00:00	32020		\N	231724	0	444814009	40481087		0
59087	3505	40481087	1994-05-08	1994-05-08 00:00:00	1994-05-15	1994-05-15 00:00:00	32020		\N	232411	0	444814009	40481087		0
69865	4133	40481087	1993-03-08	1993-03-08 00:00:00	1993-03-15	1993-03-15 00:00:00	32020		\N	274802	0	444814009	40481087		0
80599	4777	40481087	1963-07-24	1963-07-24 00:00:00	1963-07-31	1963-07-31 00:00:00	32020		\N	318075	0	444814009	40481087		0
59573	3531	4237458	1979-05-25	1979-05-25 00:00:00	1979-06-24	1979-06-24 00:00:00	32020		\N	234588	0	58150001	4237458		0
70331	4165	80180	1950-06-28	1950-06-28 00:00:00	\N	\N	32020		\N	276796	0	396275006	80180		0
81058	4807	40481087	1988-07-14	1988-07-14 00:00:00	1988-07-21	1988-07-21 00:00:00	32020		\N	319798	0	444814009	40481087		0
81203	4816	80180	2017-12-15	2017-12-15 00:00:00	\N	\N	32020		\N	320377	0	396275006	80180		0
70790	4200	4294548	2018-03-19	2018-03-19 00:00:00	2018-04-09	2018-04-09 00:00:00	32020		\N	278752	0	75498004	4294548		0
70921	4208	4112343	1972-08-17	1972-08-17 00:00:00	1972-08-25	1972-08-25 00:00:00	32020		\N	279443	0	195662009	4112343		0
60536	3579	40479768	1996-04-21	1996-04-21 00:00:00	1996-06-27	1996-06-27 00:00:00	32020		\N	237962	0	444470001	40479768		0
71274	4226	4294548	1976-07-16	1976-07-16 00:00:00	1977-01-14	1977-01-14 00:00:00	32020		\N	280761	0	75498004	4294548		0
71396	4235	260139	2011-05-13	2011-05-13 00:00:00	2011-05-20	2011-05-20 00:00:00	32020		\N	281216	0	10509002	260139		0
71665	4250	40481087	1976-06-21	1976-06-21 00:00:00	1976-07-05	1976-07-05 00:00:00	32020		\N	282337	0	444814009	40481087		0
71738	4256	260139	1985-11-21	1985-11-21 00:00:00	1985-11-28	1985-11-28 00:00:00	32020		\N	282584	0	10509002	260139		0
71912	4268	40481087	1990-10-12	1990-10-12 00:00:00	1990-10-26	1990-10-26 00:00:00	32020		\N	283240	0	444814009	40481087		0
72046	4275	260139	1993-03-27	1993-03-27 00:00:00	1993-04-03	1993-04-03 00:00:00	32020		\N	283678	0	10509002	260139		0
61715	3644	260139	1961-02-05	1961-02-05 00:00:00	1961-02-19	1961-02-19 00:00:00	32020		\N	242474	0	10509002	260139		0
72529	4308	195588	1958-09-22	1958-09-22 00:00:00	1958-11-12	1958-11-12 00:00:00	32020		\N	285756	0	38822007	195588		0
72678	4319	40481087	2007-03-03	2007-03-03 00:00:00	2007-03-10	2007-03-10 00:00:00	32020		\N	286602	0	444814009	40481087		0
72772	4325	40481087	1970-11-18	1970-11-18 00:00:00	1970-12-09	1970-12-09 00:00:00	32020		\N	286885	0	444814009	40481087		0
83536	4964	4112343	1966-09-12	1966-09-12 00:00:00	1966-09-21	1966-09-21 00:00:00	32020		\N	330004	0	195662009	4112343		0
73150	4347	40481087	2014-08-13	2014-08-13 00:00:00	2014-08-27	2014-08-27 00:00:00	32020		\N	288298	0	444814009	40481087		0
73241	4352	28060	2003-04-22	2003-04-22 00:00:00	2003-05-01	2003-05-01 00:00:00	32020		\N	288708	0	43878008	28060		0
84007	4990	40481087	1996-08-31	1996-08-31 00:00:00	1996-09-14	1996-09-14 00:00:00	32020		\N	331977	0	444814009	40481087		0
73540	4372	260139	2012-10-13	2012-10-13 00:00:00	2012-10-20	2012-10-20 00:00:00	32020		\N	290246	0	10509002	260139		0
73856	4388	4112343	1978-11-21	1978-11-21 00:00:00	1978-11-28	1978-11-28 00:00:00	32020		\N	291693	0	195662009	4112343		0
73995	4395	40481087	1953-03-17	1953-03-17 00:00:00	1953-03-24	1953-03-24 00:00:00	32020		\N	292240	0	444814009	40481087		0
74168	4405	257012	1994-12-01	1994-12-01 00:00:00	\N	\N	32020		\N	292785	0	40055000	257012		0
84829	5045	4296204	1981-04-26	1981-04-26 00:00:00	1981-05-24	1981-05-24 00:00:00	32020		\N	335242	0	403190006	4296204		0
63865	3773	80180	1996-10-09	1996-10-09 00:00:00	\N	\N	32020		\N	250797	0	396275006	80180		0
74565	4428	40481087	1992-02-12	1992-02-12 00:00:00	1992-03-04	1992-03-04 00:00:00	32020		\N	294389	0	444814009	40481087		0
64167	3789	40481087	1953-10-12	1953-10-12 00:00:00	1953-10-19	1953-10-19 00:00:00	32020		\N	251935	0	444814009	40481087		0
64283	3796	40481087	1970-12-25	1970-12-25 00:00:00	1971-01-08	1971-01-08 00:00:00	32020		\N	252368	0	444814009	40481087		0
64421	3804	4266809	2003-04-16	2003-04-16 00:00:00	\N	\N	32020		\N	252894	0	397881000	4266809		0
64708	3825	40481087	1993-08-07	1993-08-07 00:00:00	1993-08-14	1993-08-14 00:00:00	32020		\N	254039	0	444814009	40481087		0
54251	3215	260139	1981-09-24	1981-09-24 00:00:00	1981-10-01	1981-10-01 00:00:00	32020		\N	213680	0	10509002	260139		0
64948	3839	4059173	1959-05-09	1959-05-09 00:00:00	1959-06-08	1959-06-08 00:00:00	32020		\N	254858	0	16114001	4059173		0
65084	3851	260139	1969-02-17	1969-02-17 00:00:00	1969-03-03	1969-03-03 00:00:00	32020		\N	255563	0	10509002	260139		0
65267	3859	260139	1973-06-01	1973-06-01 00:00:00	1973-06-15	1973-06-15 00:00:00	32020		\N	256243	0	10509002	260139		0
65442	3869	40481087	1939-10-30	1939-10-30 00:00:00	1939-11-13	1939-11-13 00:00:00	32020		\N	256927	0	444814009	40481087		0
65735	3887	40481087	2010-08-01	2010-08-01 00:00:00	2010-08-08	2010-08-08 00:00:00	32020		\N	258351	0	444814009	40481087		0
76364	4529	4112343	1984-11-03	1984-11-03 00:00:00	1984-11-14	1984-11-14 00:00:00	32020		\N	301545	0	195662009	4112343		0
65965	3901	28060	2017-01-23	2017-01-23 00:00:00	2017-02-02	2017-02-02 00:00:00	32020		\N	259428	0	43878008	28060		0
66154	3916	4112343	1979-09-03	1979-09-03 00:00:00	1979-09-16	1979-09-16 00:00:00	32020		\N	260251	0	195662009	4112343		0
66333	3927	4146173	1988-07-06	1988-07-06 00:00:00	1988-09-04	1988-09-04 00:00:00	32020		\N	261053	0	307731004	4146173		0
66432	3932	260139	2006-09-27	2006-09-27 00:00:00	2006-10-04	2006-10-04 00:00:00	32020		\N	261380	0	10509002	260139		0
77219	4574	40481087	2019-04-21	2019-04-21 00:00:00	2019-04-28	2019-04-28 00:00:00	32020		\N	304705	0	444814009	40481087		0
66849	3955	40481087	1999-10-03	1999-10-03 00:00:00	1999-10-17	1999-10-17 00:00:00	32020		\N	262829	0	444814009	40481087		0
66989	3961	40481087	1985-05-03	1985-05-03 00:00:00	1985-05-24	1985-05-24 00:00:00	32020		\N	263327	0	444814009	40481087		0
67132	3968	40481087	1961-07-12	1961-07-12 00:00:00	1961-07-26	1961-07-26 00:00:00	32020		\N	263898	0	444814009	40481087		0
77967	4621	372328	1978-11-30	1978-11-30 00:00:00	1979-01-01	1979-01-01 00:00:00	32020		\N	307724	0	65363002	372328		0
67500	3989	28060	1996-11-05	1996-11-05 00:00:00	1996-11-16	1996-11-16 00:00:00	32020		\N	265172	0	43878008	28060		0
67622	3995	40481087	1986-09-30	1986-09-30 00:00:00	1986-10-07	1986-10-07 00:00:00	32020		\N	265591	0	444814009	40481087		0
67771	4005	40481087	1978-12-22	1978-12-22 00:00:00	1978-12-29	1978-12-29 00:00:00	32020		\N	266127	0	444814009	40481087		0
68000	4017	40481087	1996-10-21	1996-10-21 00:00:00	1996-11-11	1996-11-11 00:00:00	32020		\N	266968	0	444814009	40481087		0
68112	4022	4112343	1977-06-24	1977-06-24 00:00:00	1977-07-07	1977-07-07 00:00:00	32020		\N	267411	0	195662009	4112343		0
68372	4040	40481087	2015-03-12	2015-03-12 00:00:00	2015-03-26	2015-03-26 00:00:00	32020		\N	268704	0	444814009	40481087		0
68483	4049	40481087	2003-06-06	2003-06-06 00:00:00	2003-06-27	2003-06-27 00:00:00	32020		\N	269129	0	444814009	40481087		0
68689	4064	4084167	1961-10-01	1961-10-01 00:00:00	1961-10-01	1961-10-01 00:00:00	32020		\N	269995	0	241929008	4084167		0
68876	4077	4112343	2010-06-28	2010-06-28 00:00:00	2010-07-05	2010-07-05 00:00:00	32020		\N	270900	0	195662009	4112343		0
69114	4090	4112343	1986-10-12	1986-10-12 00:00:00	1986-10-24	1986-10-24 00:00:00	32020		\N	271851	0	195662009	4112343		0
79867	4732	4152936	1997-11-24	1997-11-24 00:00:00	1997-12-08	1997-12-08 00:00:00	32020		\N	315277	0	283385000	4152936		0
58891	3494	40481087	1996-10-01	1996-10-01 00:00:00	1996-10-22	1996-10-22 00:00:00	32020		\N	231742	0	444814009	40481087		0
59088	3505	4112343	1982-09-14	1982-09-14 00:00:00	1982-09-23	1982-09-23 00:00:00	32020		\N	232468	0	195662009	4112343		0
69866	4133	40481087	2012-07-04	2012-07-04 00:00:00	2012-07-11	2012-07-11 00:00:00	32020		\N	274768	0	444814009	40481087		0
80600	4777	4116491	1982-05-07	1982-05-07 00:00:00	1982-06-30	1982-06-30 00:00:00	32020		\N	318059	0	301011002	4116491		0
59574	3531	40481087	2007-08-01	2007-08-01 00:00:00	2007-08-15	2007-08-15 00:00:00	32020		\N	234572	0	444814009	40481087		0
70332	4165	4283893	1949-06-18	1949-06-18 00:00:00	1949-07-30	1949-07-30 00:00:00	32020		\N	276744	0	36971009	4283893		0
81088	4811	40481087	1966-07-27	1966-07-27 00:00:00	1966-08-10	1966-08-10 00:00:00	32020		\N	320024	0	444814009	40481087		0
81204	4816	4285898	2017-05-19	2017-05-19 00:00:00	\N	\N	32020		\N	320377	0	68496003	4285898		0
70791	4200	40481087	2007-01-29	2007-01-29 00:00:00	2007-02-05	2007-02-05 00:00:00	32020		\N	278771	0	444814009	40481087		0
70923	4208	321042	1981-04-07	1981-04-07 00:00:00	\N	\N	32020		\N	279428	0	410429000	321042		0
60537	3579	80180	1997-09-08	1997-09-08 00:00:00	\N	\N	32020		\N	237934	0	396275006	80180		0
71275	4226	4112343	1989-12-07	1989-12-07 00:00:00	1989-12-16	1989-12-16 00:00:00	32020		\N	280722	0	195662009	4112343		0
71414	4238	260139	1973-12-05	1973-12-05 00:00:00	1973-12-19	1973-12-19 00:00:00	32020		\N	281403	0	10509002	260139		0
71666	4250	260139	1974-03-11	1974-03-11 00:00:00	1974-03-25	1974-03-25 00:00:00	32020		\N	282291	0	10509002	260139		0
71739	4256	372328	1954-10-25	1954-10-25 00:00:00	1955-03-13	1955-03-13 00:00:00	32020		\N	282586	0	65363002	372328		0
71913	4268	28060	1967-08-11	1967-08-11 00:00:00	1967-08-22	1967-08-22 00:00:00	32020		\N	283266	0	43878008	28060		0
72047	4275	4027663	2007-01-06	2007-01-06 00:00:00	\N	\N	32020		\N	283703	0	13200003	4027663		0
61716	3644	4112343	1970-02-13	1970-02-13 00:00:00	1970-02-22	1970-02-22 00:00:00	32020		\N	242493	0	195662009	4112343		0
72530	4308	4116491	1953-08-11	1953-08-11 00:00:00	1953-09-23	1953-09-23 00:00:00	32020		\N	285742	0	301011002	4116491		0
72679	4319	4155034	1997-12-18	1997-12-18 00:00:00	1998-01-08	1998-01-08 00:00:00	32020		\N	286584	0	283371005	4155034		0
72773	4325	28060	1969-12-10	1969-12-10 00:00:00	1969-12-17	1969-12-17 00:00:00	32020		\N	286935	0	43878008	28060		0
83537	4964	28060	1990-08-29	1990-08-29 00:00:00	1990-09-11	1990-09-11 00:00:00	32020		\N	330007	0	43878008	28060		0
73151	4347	40481087	2009-06-22	2009-06-22 00:00:00	2009-07-06	2009-07-06 00:00:00	32020		\N	288271	0	444814009	40481087		0
73242	4352	257012	2009-03-07	2009-03-07 00:00:00	\N	\N	32020		\N	288712	0	40055000	257012		0
84008	4990	4116491	1981-01-19	1981-01-19 00:00:00	1981-02-23	1981-02-23 00:00:00	32020		\N	331953	0	301011002	4116491		0
73541	4372	4112343	1987-07-04	1987-07-04 00:00:00	1987-07-16	1987-07-16 00:00:00	32020		\N	290329	0	195662009	4112343		0
73857	4388	260139	2017-09-13	2017-09-13 00:00:00	2017-09-27	2017-09-27 00:00:00	32020		\N	291632	0	10509002	260139		0
73996	4395	81151	1982-07-10	1982-07-10 00:00:00	1982-07-24	1982-07-24 00:00:00	32020		\N	292287	0	44465007	81151		0
74169	4405	4218389	2011-06-10	2011-06-10 00:00:00	2011-07-01	2011-07-01 00:00:00	32020		\N	292837	0	39848009	4218389		0
84830	5045	81151	1979-05-23	1979-05-23 00:00:00	1979-06-06	1979-06-06 00:00:00	32020		\N	335241	0	44465007	81151		0
63866	3773	4112343	1980-06-04	1980-06-04 00:00:00	1980-06-16	1980-06-16 00:00:00	32020		\N	250779	0	195662009	4112343		0
74566	4428	40481087	1969-07-31	1969-07-31 00:00:00	1969-08-07	1969-08-07 00:00:00	32020		\N	294417	0	444814009	40481087		0
64168	3789	40481087	1988-03-11	1988-03-11 00:00:00	1988-04-01	1988-04-01 00:00:00	32020		\N	251879	0	444814009	40481087		0
64284	3796	4112343	1995-03-01	1995-03-01 00:00:00	1995-03-13	1995-03-13 00:00:00	32020		\N	252391	0	195662009	4112343		0
64422	3804	81151	2018-04-23	2018-04-23 00:00:00	2018-05-28	2018-05-28 00:00:00	32020		\N	252862	0	44465007	81151		0
64709	3825	40481087	1992-10-20	1992-10-20 00:00:00	1992-11-03	1992-11-03 00:00:00	32020		\N	254061	0	444814009	40481087		0
54252	3215	317576	2009-04-06	2009-04-06 00:00:00	\N	\N	32020		\N	213639	0	53741008	317576		0
64949	3839	40481087	1951-03-29	1951-03-29 00:00:00	1951-04-05	1951-04-05 00:00:00	32020		\N	254906	0	444814009	40481087		0
65085	3851	40481087	1952-07-03	1952-07-03 00:00:00	1952-07-24	1952-07-24 00:00:00	32020		\N	255610	0	444814009	40481087		0
65268	3859	313217	2016-04-16	2016-04-16 00:00:00	\N	\N	32020		\N	256182	0	49436004	313217		0
65443	3869	260139	1941-06-30	1941-06-30 00:00:00	1941-07-14	1941-07-14 00:00:00	32020		\N	256938	0	10509002	260139		0
65736	3887	4112343	1970-03-24	1970-03-24 00:00:00	1970-04-05	1970-04-05 00:00:00	32020		\N	258388	0	195662009	4112343		0
76365	4529	4112343	1972-11-23	1972-11-23 00:00:00	1972-12-02	1972-12-02 00:00:00	32020		\N	301549	0	195662009	4112343		0
65966	3901	4112343	2011-06-09	2011-06-09 00:00:00	2011-06-20	2011-06-20 00:00:00	32020		\N	259449	0	195662009	4112343		0
66155	3916	372328	1980-12-22	1980-12-22 00:00:00	1981-03-11	1981-03-11 00:00:00	32020		\N	260388	0	65363002	372328		0
66334	3927	260139	2011-04-02	2011-04-02 00:00:00	2011-04-16	2011-04-16 00:00:00	32020		\N	261045	0	10509002	260139		0
66433	3932	40481087	2011-08-20	2011-08-20 00:00:00	2011-09-10	2011-09-10 00:00:00	32020		\N	261355	0	444814009	40481087		0
77220	4574	4112343	2009-10-17	2009-10-17 00:00:00	2009-10-29	2009-10-29 00:00:00	32020		\N	304704	0	195662009	4112343		0
66850	3955	81893	1994-02-19	1994-02-19 00:00:00	\N	\N	32020		\N	262842	0	64766004	81893		0
66990	3961	372328	1975-02-26	1975-02-26 00:00:00	1975-07-22	1975-07-22 00:00:00	32020		\N	263371	0	65363002	372328		0
67133	3968	4134304	1954-01-03	1954-01-03 00:00:00	1954-02-02	1954-02-02 00:00:00	32020		\N	263905	0	263102004	4134304		0
77968	4621	40481087	1988-01-15	1988-01-15 00:00:00	1988-01-22	1988-01-22 00:00:00	32020		\N	307747	0	444814009	40481087		0
67501	3989	40481087	1969-10-24	1969-10-24 00:00:00	1969-10-31	1969-10-31 00:00:00	32020		\N	265168	0	444814009	40481087		0
67623	3995	4113008	1978-01-07	1978-01-07 00:00:00	1978-01-21	1978-01-21 00:00:00	32020		\N	265613	0	284549007	4113008		0
67772	4005	4112343	2013-04-27	2013-04-27 00:00:00	2013-05-10	2013-05-10 00:00:00	32020		\N	266113	0	195662009	4112343		0
68001	4017	381316	2014-08-07	2014-08-07 00:00:00	\N	\N	32020		\N	267006	0	230690007	381316		0
68113	4022	40481087	1976-09-22	1976-09-22 00:00:00	1976-09-29	1976-09-29 00:00:00	32020		\N	267416	0	444814009	40481087		0
78851	4670	4156265	1994-04-26	1994-04-26 00:00:00	1994-05-17	1994-05-17 00:00:00	32020		\N	311158	0	370247008	4156265		0
68484	4049	40481087	2003-11-30	2003-11-30 00:00:00	2003-12-14	2003-12-14 00:00:00	32020		\N	269130	0	444814009	40481087		0
68690	4064	28060	1972-11-30	1972-11-30 00:00:00	1972-12-11	1972-12-11 00:00:00	32020		\N	270110	0	43878008	28060		0
68877	4077	80180	2010-10-14	2010-10-14 00:00:00	\N	\N	32020		\N	270900	0	396275006	80180		0
58398	3458	40481087	2017-04-07	2017-04-07 00:00:00	2017-04-21	2017-04-21 00:00:00	32020		\N	229453	0	444814009	40481087		0
69115	4090	40481087	2009-11-30	2009-11-30 00:00:00	2009-12-14	2009-12-14 00:00:00	32020		\N	271858	0	444814009	40481087		0
79868	4732	40481087	1997-02-27	1997-02-27 00:00:00	1997-03-20	1997-03-20 00:00:00	32020		\N	315246	0	444814009	40481087		0
58892	3494	28060	1964-10-23	1964-10-23 00:00:00	1964-11-01	1964-11-01 00:00:00	32020		\N	231771	0	43878008	28060		0
59089	3505	40481087	1972-10-24	1972-10-24 00:00:00	1972-11-07	1972-11-07 00:00:00	32020		\N	232467	0	444814009	40481087		0
69867	4133	4112343	2018-11-25	2018-11-25 00:00:00	2018-12-04	2018-12-04 00:00:00	32020		\N	274789	0	195662009	4112343		0
80601	4777	260139	1978-05-29	1978-05-29 00:00:00	1978-06-12	1978-06-12 00:00:00	32020		\N	318082	0	10509002	260139		0
59575	3531	40481087	1994-01-27	1994-01-27 00:00:00	1994-02-03	1994-02-03 00:00:00	32020		\N	234562	0	444814009	40481087		0
70333	4165	4152936	1983-09-10	1983-09-10 00:00:00	1983-09-24	1983-09-24 00:00:00	32020		\N	276826	0	283385000	4152936		0
81089	4811	4112343	1969-05-23	1969-05-23 00:00:00	1969-05-30	1969-05-30 00:00:00	32020		\N	320074	0	195662009	4112343		0
81205	4816	4283893	1983-06-08	1983-06-08 00:00:00	1983-07-27	1983-07-27 00:00:00	32020		\N	320436	0	36971009	4283893		0
70792	4200	81151	2009-04-15	2009-04-15 00:00:00	2009-05-13	2009-05-13 00:00:00	32020		\N	278720	0	44465007	81151		0
70924	4208	257012	1995-09-02	1995-09-02 00:00:00	\N	\N	32020		\N	279435	0	40055000	257012		0
60538	3579	260139	2017-07-22	2017-07-22 00:00:00	2017-07-29	2017-07-29 00:00:00	32020		\N	237924	0	10509002	260139		0
71276	4226	372328	1965-08-04	1965-08-04 00:00:00	1965-10-24	1965-10-24 00:00:00	32020		\N	280741	0	65363002	372328		0
71415	4238	40481087	1993-09-23	1993-09-23 00:00:00	1993-10-14	1993-10-14 00:00:00	32020		\N	281406	0	444814009	40481087		0
71667	4250	260139	1984-02-22	1984-02-22 00:00:00	1984-03-07	1984-03-07 00:00:00	32020		\N	282242	0	10509002	260139		0
71740	4256	260139	1991-06-01	1991-06-01 00:00:00	1991-06-15	1991-06-15 00:00:00	32020		\N	282611	0	10509002	260139		0
71914	4268	260139	2011-12-12	2011-12-12 00:00:00	2011-12-19	2011-12-19 00:00:00	32020		\N	283243	0	10509002	260139		0
72049	4276	4166224	2006-12-14	2006-12-14 00:00:00	\N	\N	32020		\N	283773	0	47693006	4166224		0
61717	3644	4112343	1959-06-02	1959-06-02 00:00:00	1959-06-10	1959-06-10 00:00:00	32020		\N	242473	0	195662009	4112343		0
72531	4308	260139	1988-07-10	1988-07-10 00:00:00	1988-07-24	1988-07-24 00:00:00	32020		\N	285837	0	10509002	260139		0
72680	4319	260139	2009-04-04	2009-04-04 00:00:00	2009-04-11	2009-04-11 00:00:00	32020		\N	286612	0	10509002	260139		0
72774	4325	40481087	1974-03-05	1974-03-05 00:00:00	1974-03-12	1974-03-12 00:00:00	32020		\N	286892	0	444814009	40481087		0
83538	4964	28060	2000-05-31	2000-05-31 00:00:00	2000-06-12	2000-06-12 00:00:00	32020		\N	329986	0	43878008	28060		0
73152	4347	372328	1969-05-24	1969-05-24 00:00:00	1969-09-14	1969-09-14 00:00:00	32020		\N	288304	0	65363002	372328		0
73243	4352	4027663	1980-07-21	1980-07-21 00:00:00	\N	\N	32020		\N	288636	0	13200003	4027663		0
84009	4990	40481087	2018-02-12	2018-02-12 00:00:00	2018-02-19	2018-02-19 00:00:00	32020		\N	332006	0	444814009	40481087		0
73542	4372	372328	1985-12-08	1985-12-08 00:00:00	1986-02-13	1986-02-13 00:00:00	32020		\N	290211	0	65363002	372328		0
73858	4388	28060	2000-04-04	2000-04-04 00:00:00	2000-04-15	2000-04-15 00:00:00	32020		\N	291710	0	43878008	28060		0
73997	4395	40481087	2018-09-27	2018-09-27 00:00:00	2018-10-18	2018-10-18 00:00:00	32020		\N	292215	0	444814009	40481087		0
74170	4405	40481087	1966-07-13	1966-07-13 00:00:00	1966-08-03	1966-08-03 00:00:00	32020		\N	292838	0	444814009	40481087		0
84831	5045	4112343	1997-01-12	1997-01-12 00:00:00	1997-01-19	1997-01-19 00:00:00	32020		\N	335232	0	195662009	4112343		0
63867	3773	40481087	2002-12-04	2002-12-04 00:00:00	2002-12-18	2002-12-18 00:00:00	32020		\N	250823	0	444814009	40481087		0
74567	4428	40481087	2014-03-26	2014-03-26 00:00:00	2014-04-16	2014-04-16 00:00:00	32020		\N	294368	0	444814009	40481087		0
64169	3789	40481087	1986-07-23	1986-07-23 00:00:00	1986-08-13	1986-08-13 00:00:00	32020		\N	251878	0	444814009	40481087		0
64285	3796	81151	1971-12-23	1971-12-23 00:00:00	1972-01-06	1972-01-06 00:00:00	32020		\N	252355	0	44465007	81151		0
64431	3807	260139	1958-06-09	1958-06-09 00:00:00	1958-06-23	1958-06-23 00:00:00	32020		\N	252997	0	10509002	260139		0
64710	3825	40481087	1957-09-29	1957-09-29 00:00:00	1957-10-13	1957-10-13 00:00:00	32020		\N	254057	0	444814009	40481087		0
54253	3215	40481087	1988-12-10	1988-12-10 00:00:00	1988-12-31	1988-12-31 00:00:00	32020		\N	213562	0	444814009	40481087		0
64950	3839	40481087	2017-11-12	2017-11-12 00:00:00	2017-11-26	2017-11-26 00:00:00	32020		\N	254844	0	444814009	40481087		0
65086	3851	372328	1916-12-21	1916-12-21 00:00:00	1917-04-16	1917-04-16 00:00:00	32020		\N	255566	0	65363002	372328		0
65269	3859	40480160	1995-10-23	1995-10-23 00:00:00	1996-01-21	1996-01-21 00:00:00	32020		\N	256267	0	443165006	40480160		0
65444	3869	260139	1953-08-31	1953-08-31 00:00:00	1953-09-07	1953-09-07 00:00:00	32020		\N	256929	0	10509002	260139		0
76195	4521	40481087	2004-08-06	2004-08-06 00:00:00	2004-08-13	2004-08-13 00:00:00	32020		\N	300985	0	444814009	40481087		0
76366	4530	4059173	1980-07-19	1980-07-19 00:00:00	1980-10-17	1980-10-17 00:00:00	32020		\N	301619	0	16114001	4059173		0
65967	3901	40481087	2009-10-28	2009-10-28 00:00:00	2009-11-11	2009-11-11 00:00:00	32020		\N	259427	0	444814009	40481087		0
66156	3916	80180	2016-05-07	2016-05-07 00:00:00	\N	\N	32020		\N	260308	0	396275006	80180		0
66335	3927	81151	1977-01-16	1977-01-16 00:00:00	1977-01-30	1977-01-30 00:00:00	32020		\N	261035	0	44465007	81151		0
66434	3932	28060	1975-09-17	1975-09-17 00:00:00	1975-09-24	1975-09-24 00:00:00	32020		\N	261401	0	43878008	28060		0
77221	4574	260139	1968-04-14	1968-04-14 00:00:00	1968-04-21	1968-04-21 00:00:00	32020		\N	304725	0	10509002	260139		0
66851	3955	40481087	1983-12-26	1983-12-26 00:00:00	1984-01-16	1984-01-16 00:00:00	32020		\N	262828	0	444814009	40481087		0
66991	3961	4112343	1998-02-23	1998-02-23 00:00:00	1998-03-07	1998-03-07 00:00:00	32020		\N	263365	0	195662009	4112343		0
67134	3968	260139	1913-10-01	1913-10-01 00:00:00	1913-10-15	1913-10-15 00:00:00	32020		\N	263789	0	10509002	260139		0
77969	4621	40481087	1978-07-21	1978-07-21 00:00:00	1978-07-28	1978-07-28 00:00:00	32020		\N	307775	0	444814009	40481087		0
67502	3989	4285898	1964-09-13	1964-09-13 00:00:00	\N	\N	32020		\N	265202	0	68496003	4285898		0
67624	3995	4156265	1986-01-09	1986-01-09 00:00:00	1986-01-30	1986-01-30 00:00:00	32020		\N	265614	0	370247008	4156265		0
67773	4005	4156265	1971-05-12	1971-05-12 00:00:00	1971-05-26	1971-05-26 00:00:00	32020		\N	266081	0	370247008	4156265		0
68002	4017	40481087	2005-09-12	2005-09-12 00:00:00	2005-10-03	2005-10-03 00:00:00	32020		\N	267036	0	444814009	40481087		0
68114	4022	4112343	1992-02-16	1992-02-16 00:00:00	1992-02-25	1992-02-25 00:00:00	32020		\N	267417	0	195662009	4112343		0
78852	4670	40481087	1997-04-02	1997-04-02 00:00:00	1997-04-16	1997-04-16 00:00:00	32020		\N	311163	0	444814009	40481087		0
68485	4049	40481087	1998-12-01	1998-12-01 00:00:00	1998-12-22	1998-12-22 00:00:00	32020		\N	269128	0	444814009	40481087		0
68691	4064	260139	1991-01-04	1991-01-04 00:00:00	1991-01-13	1991-01-13 00:00:00	32020		\N	270018	0	10509002	260139		0
68878	4077	28060	1988-10-26	1988-10-26 00:00:00	1988-11-03	1988-11-03 00:00:00	32020		\N	270890	0	43878008	28060		0
58399	3458	28060	2006-08-10	2006-08-10 00:00:00	2006-08-17	2006-08-17 00:00:00	32020		\N	229472	0	43878008	28060		0
69116	4090	260139	1988-06-21	1988-06-21 00:00:00	1988-06-28	1988-06-28 00:00:00	32020		\N	271845	0	10509002	260139		0
79869	4732	28060	1957-04-16	1957-04-16 00:00:00	1957-04-25	1957-04-25 00:00:00	32020		\N	315278	0	43878008	28060		0
58893	3494	260139	1981-04-01	1981-04-01 00:00:00	1981-04-15	1981-04-15 00:00:00	32020		\N	231721	0	10509002	260139		0
59090	3505	378001	1999-12-03	1999-12-03 00:00:00	2000-02-01	2000-02-01 00:00:00	32020		\N	232381	0	62106007	378001		0
69868	4133	4296205	1978-05-21	1978-05-21 00:00:00	1978-06-04	1978-06-04 00:00:00	32020		\N	274779	0	403191005	4296205		0
80602	4777	4112343	1981-11-12	1981-11-12 00:00:00	1981-11-25	1981-11-25 00:00:00	32020		\N	318083	0	195662009	4112343		0
59576	3531	4112343	1990-02-03	1990-02-03 00:00:00	1990-02-11	1990-02-11 00:00:00	32020		\N	234571	0	195662009	4112343		0
70334	4165	4294548	1928-12-03	1928-12-03 00:00:00	1928-12-31	1928-12-31 00:00:00	32020		\N	276739	0	75498004	4294548		0
81090	4811	40481087	2007-10-10	2007-10-10 00:00:00	2007-10-17	2007-10-17 00:00:00	32020		\N	320067	0	444814009	40481087		0
81206	4816	372328	1984-10-11	1984-10-11 00:00:00	1985-04-15	1985-04-15 00:00:00	32020		\N	320411	0	65363002	372328		0
70793	4200	40481087	2011-04-13	2011-04-13 00:00:00	2011-04-20	2011-04-20 00:00:00	32020		\N	278749	0	444814009	40481087		0
70925	4208	260139	1941-11-08	1941-11-08 00:00:00	1941-11-22	1941-11-22 00:00:00	32020		\N	279441	0	10509002	260139		0
60539	3579	260139	1990-02-19	1990-02-19 00:00:00	1990-03-05	1990-03-05 00:00:00	32020		\N	237923	0	10509002	260139		0
71277	4226	4280726	1964-11-24	1964-11-24 00:00:00	\N	\N	32020		\N	280649	0	367498001	4280726		0
71416	4238	372328	1963-04-23	1963-04-23 00:00:00	1963-08-08	1963-08-08 00:00:00	32020		\N	281374	0	65363002	372328		0
71668	4250	40481087	1995-11-22	1995-11-22 00:00:00	1995-11-29	1995-11-29 00:00:00	32020		\N	282290	0	444814009	40481087		0
71741	4256	372328	1957-08-29	1957-08-29 00:00:00	1957-09-12	1957-09-12 00:00:00	32020		\N	282613	0	65363002	372328		0
71915	4268	260139	1969-09-28	1969-09-28 00:00:00	1969-10-05	1969-10-05 00:00:00	32020		\N	283217	0	10509002	260139		0
72050	4276	440448	2006-12-14	2006-12-14 00:00:00	\N	\N	32020		\N	283773	0	74400008	440448		0
61718	3644	40481087	1978-09-01	1978-09-01 00:00:00	1978-09-08	1978-09-08 00:00:00	32020		\N	242475	0	444814009	40481087		0
72532	4308	40481087	1943-01-08	1943-01-08 00:00:00	1943-01-15	1943-01-15 00:00:00	32020		\N	285754	0	444814009	40481087		0
72681	4319	260139	1998-09-19	1998-09-19 00:00:00	1998-09-26	1998-09-26 00:00:00	32020		\N	286611	0	10509002	260139		0
72775	4325	81151	1971-10-18	1971-10-18 00:00:00	1971-11-01	1971-11-01 00:00:00	32020		\N	286932	0	44465007	81151		0
83539	4964	40481087	1971-06-24	1971-06-24 00:00:00	1971-07-15	1971-07-15 00:00:00	32020		\N	329989	0	444814009	40481087		0
73153	4347	40481087	2005-07-26	2005-07-26 00:00:00	2005-08-09	2005-08-09 00:00:00	32020		\N	288270	0	444814009	40481087		0
73244	4352	40481087	1979-03-17	1979-03-17 00:00:00	1979-03-24	1979-03-24 00:00:00	32020		\N	288636	0	444814009	40481087		0
84010	4990	40481087	1988-09-25	1988-09-25 00:00:00	1988-10-16	1988-10-16 00:00:00	32020		\N	332002	0	444814009	40481087		0
73543	4372	195588	2013-06-03	2013-06-03 00:00:00	2013-07-11	2013-07-11 00:00:00	32020		\N	290292	0	38822007	195588		0
73859	4388	28060	2006-05-02	2006-05-02 00:00:00	2006-05-15	2006-05-15 00:00:00	32020		\N	291631	0	43878008	28060		0
73998	4395	40481087	1953-05-29	1953-05-29 00:00:00	1953-06-12	1953-06-12 00:00:00	32020		\N	292255	0	444814009	40481087		0
74171	4405	4112343	1976-05-29	1976-05-29 00:00:00	1976-06-09	1976-06-09 00:00:00	32020		\N	292841	0	195662009	4112343		0
84832	5046	40481087	1984-02-14	1984-02-14 00:00:00	1984-02-28	1984-02-28 00:00:00	32020		\N	335305	0	444814009	40481087		0
63868	3773	4112343	2009-05-16	2009-05-16 00:00:00	2009-05-25	2009-05-25 00:00:00	32020		\N	250808	0	195662009	4112343		0
74568	4428	4112343	1994-12-12	1994-12-12 00:00:00	1994-12-25	1994-12-25 00:00:00	32020		\N	294400	0	195662009	4112343		0
64170	3789	4112343	1975-11-10	1975-11-10 00:00:00	1975-11-17	1975-11-17 00:00:00	32020		\N	251877	0	195662009	4112343		0
64286	3796	260139	2019-03-11	2019-03-11 00:00:00	2019-03-18	2019-03-18 00:00:00	32020		\N	252380	0	10509002	260139		0
64432	3807	440086	1956-09-18	1956-09-18 00:00:00	1964-09-26	1964-09-26 00:00:00	32020		\N	252969	0	192127007	440086		0
64719	3827	372328	1960-11-27	1960-11-27 00:00:00	1961-08-11	1961-08-11 00:00:00	32020		\N	254178	0	65363002	372328		0
54254	3215	372328	1980-06-02	1980-06-02 00:00:00	1980-09-01	1980-09-01 00:00:00	32020		\N	213621	0	65363002	372328		0
64951	3839	40481087	1957-04-12	1957-04-12 00:00:00	1957-04-26	1957-04-26 00:00:00	32020		\N	254910	0	444814009	40481087		0
65087	3851	40481087	1953-06-28	1953-06-28 00:00:00	1953-07-19	1953-07-19 00:00:00	32020		\N	255611	0	444814009	40481087		0
65270	3859	40481087	2004-06-12	2004-06-12 00:00:00	2004-06-19	2004-06-19 00:00:00	32020		\N	256261	0	444814009	40481087		0
65445	3869	40481087	1923-01-10	1923-01-10 00:00:00	1923-01-31	1923-01-31 00:00:00	32020		\N	256892	0	444814009	40481087		0
76196	4521	40481087	1976-11-22	1976-11-22 00:00:00	1976-11-29	1976-11-29 00:00:00	32020		\N	301020	0	444814009	40481087		0
76367	4530	4152936	2008-09-20	2008-09-20 00:00:00	2008-10-04	2008-10-04 00:00:00	32020		\N	301621	0	283385000	4152936		0
65968	3901	40481087	1992-08-17	1992-08-17 00:00:00	1992-08-24	1992-08-24 00:00:00	32020		\N	259446	0	444814009	40481087		0
66157	3916	4266809	2016-05-07	2016-05-07 00:00:00	\N	\N	32020		\N	260308	0	397881000	4266809		0
66336	3927	40481087	1962-07-26	1962-07-26 00:00:00	1962-08-16	1962-08-16 00:00:00	32020		\N	261013	0	444814009	40481087		0
66435	3932	40481087	2004-01-26	2004-01-26 00:00:00	2004-02-02	2004-02-02 00:00:00	32020		\N	261353	0	444814009	40481087		0
77222	4574	4113008	1985-10-15	1985-10-15 00:00:00	1985-10-29	1985-10-29 00:00:00	32020		\N	304712	0	284549007	4113008		0
66852	3955	40481087	1973-06-14	1973-06-14 00:00:00	1973-06-21	1973-06-21 00:00:00	32020		\N	262846	0	444814009	40481087		0
66992	3961	40481087	1999-11-13	1999-11-13 00:00:00	1999-12-04	1999-12-04 00:00:00	32020		\N	263330	0	444814009	40481087		0
67135	3968	40481087	1918-09-13	1918-09-13 00:00:00	1918-09-20	1918-09-20 00:00:00	32020		\N	263900	0	444814009	40481087		0
77970	4621	40481087	2018-01-08	2018-01-08 00:00:00	2018-01-15	2018-01-15 00:00:00	32020		\N	307723	0	444814009	40481087		0
67503	3989	80180	1965-01-11	1965-01-11 00:00:00	\N	\N	32020		\N	265202	0	396275006	80180		0
67625	3995	4116491	2014-02-02	2014-02-02 00:00:00	2014-03-06	2014-03-06 00:00:00	32020		\N	265600	0	301011002	4116491		0
67774	4005	78272	1999-03-14	1999-03-14 00:00:00	1999-04-04	1999-04-04 00:00:00	32020		\N	266085	0	70704007	78272		0
68003	4018	378001	1972-11-29	1972-11-29 00:00:00	1973-01-28	1973-01-28 00:00:00	32020		\N	267050	0	62106007	378001		0
68115	4022	4112343	1985-05-13	1985-05-13 00:00:00	1985-05-21	1985-05-21 00:00:00	32020		\N	267390	0	195662009	4112343		0
78853	4670	4112343	2019-03-28	2019-03-28 00:00:00	2019-04-08	2019-04-08 00:00:00	32020		\N	311232	0	195662009	4112343		0
68486	4049	4112343	2009-08-01	2009-08-01 00:00:00	2009-08-14	2009-08-14 00:00:00	32020		\N	269142	0	195662009	4112343		0
68692	4064	40481087	1985-02-03	1985-02-03 00:00:00	1985-02-24	1985-02-24 00:00:00	32020		\N	269986	0	444814009	40481087		0
68879	4077	260139	1975-03-23	1975-03-23 00:00:00	1975-04-06	1975-04-06 00:00:00	32020		\N	270898	0	10509002	260139		0
58400	3458	375671	2010-01-21	2010-01-21 00:00:00	2010-03-22	2010-03-22 00:00:00	32020		\N	229447	0	62564004	375671		0
69117	4090	372328	1944-10-27	1944-10-27 00:00:00	1945-02-26	1945-02-26 00:00:00	32020		\N	271860	0	65363002	372328		0
79870	4732	4112343	2018-01-10	2018-01-10 00:00:00	2018-01-17	2018-01-17 00:00:00	32020		\N	315288	0	195662009	4112343		0
58894	3494	80180	1999-01-18	1999-01-18 00:00:00	\N	\N	32020		\N	231722	0	396275006	80180		0
59091	3505	4299128	1970-07-12	1970-07-12 00:00:00	1970-08-16	1970-08-16 00:00:00	32020		\N	232379	0	403192003	4299128		0
69869	4133	4112343	1992-06-19	1992-06-19 00:00:00	1992-07-01	1992-07-01 00:00:00	32020		\N	274797	0	195662009	4112343		0
80603	4777	40481087	1977-04-27	1977-04-27 00:00:00	1977-05-18	1977-05-18 00:00:00	32020		\N	318076	0	444814009	40481087		0
59577	3531	4237458	1969-01-17	1969-01-17 00:00:00	1969-04-17	1969-04-17 00:00:00	32020		\N	234586	0	58150001	4237458		0
70349	4167	378001	1983-09-08	1983-09-08 00:00:00	1983-11-07	1983-11-07 00:00:00	32020		\N	276999	0	62106007	378001		0
81091	4811	40481087	2001-08-01	2001-08-01 00:00:00	2001-08-08	2001-08-08 00:00:00	32020		\N	320025	0	444814009	40481087		0
81207	4816	440448	1982-11-11	1982-11-11 00:00:00	\N	\N	32020		\N	320430	0	74400008	440448		0
70794	4200	40481087	1976-08-03	1976-08-03 00:00:00	1976-08-17	1976-08-17 00:00:00	32020		\N	278736	0	444814009	40481087		0
70926	4208	40481087	1998-02-09	1998-02-09 00:00:00	1998-03-02	1998-03-02 00:00:00	32020		\N	279449	0	444814009	40481087		0
60540	3579	4112343	1990-10-19	1990-10-19 00:00:00	1990-10-28	1990-10-28 00:00:00	32020		\N	237953	0	195662009	4112343		0
71278	4226	257012	1976-09-10	1976-09-10 00:00:00	1977-01-14	1977-01-14 00:00:00	32020		\N	280765	0	40055000	257012		0
71417	4238	80180	2005-11-03	2005-11-03 00:00:00	\N	\N	32020		\N	281426	0	396275006	80180		0
71669	4250	40481087	1971-03-01	1971-03-01 00:00:00	1971-03-15	1971-03-15 00:00:00	32020		\N	282286	0	444814009	40481087		0
71742	4256	40479768	2009-12-26	2009-12-26 00:00:00	2010-02-01	2010-02-01 00:00:00	32020		\N	282635	0	444470001	40479768		0
71916	4268	372328	1959-01-24	1959-01-24 00:00:00	1959-02-16	1959-02-16 00:00:00	32020		\N	283248	0	65363002	372328		0
72051	4276	4230399	1977-07-17	1977-07-17 00:00:00	1977-10-15	1977-10-15 00:00:00	32020		\N	283771	0	359817006	4230399		0
61736	3647	4218389	2007-01-01	2007-01-01 00:00:00	2007-01-29	2007-01-29 00:00:00	32020		\N	242666	0	39848009	4218389		0
72533	4308	260139	1992-08-29	1992-08-29 00:00:00	1992-09-05	1992-09-05 00:00:00	32020		\N	285814	0	10509002	260139		0
72682	4319	372328	1982-12-11	1982-12-11 00:00:00	1983-11-23	1983-11-23 00:00:00	32020		\N	286615	0	65363002	372328		0
72776	4325	260139	2014-08-19	2014-08-19 00:00:00	2014-09-02	2014-09-02 00:00:00	32020		\N	286888	0	10509002	260139		0
83565	4967	40481087	1983-07-09	1983-07-09 00:00:00	1983-07-30	1983-07-30 00:00:00	32020		\N	330184	0	444814009	40481087		0
73154	4347	81151	1971-12-10	1971-12-10 00:00:00	1972-01-14	1972-01-14 00:00:00	32020		\N	288244	0	44465007	81151		0
73245	4352	40481087	1982-05-13	1982-05-13 00:00:00	1982-06-03	1982-06-03 00:00:00	32020		\N	288637	0	444814009	40481087		0
84011	4990	4112343	1975-02-06	1975-02-06 00:00:00	1975-02-16	1975-02-16 00:00:00	32020		\N	331975	0	195662009	4112343		0
73544	4372	40481087	1987-11-22	1987-11-22 00:00:00	1987-11-29	1987-11-29 00:00:00	32020		\N	290330	0	444814009	40481087		0
73860	4388	40479422	1996-10-21	1996-10-21 00:00:00	1996-12-27	1996-12-27 00:00:00	32020		\N	291643	0	444448004	40479422		0
73999	4395	4112343	1966-09-28	1966-09-28 00:00:00	1966-10-05	1966-10-05 00:00:00	32020		\N	292265	0	195662009	4112343		0
74172	4405	4283893	1994-10-13	1994-10-13 00:00:00	1994-12-08	1994-12-08 00:00:00	32020		\N	292797	0	36971009	4283893		0
84833	5046	260139	2009-05-18	2009-05-18 00:00:00	2009-06-01	2009-06-01 00:00:00	32020		\N	335365	0	10509002	260139		0
63869	3773	4059173	1981-01-22	1981-01-22 00:00:00	1981-02-21	1981-02-21 00:00:00	32020		\N	250813	0	16114001	4059173		0
74569	4428	260139	1985-05-31	1985-05-31 00:00:00	1985-06-14	1985-06-14 00:00:00	32020		\N	294350	0	10509002	260139		0
64171	3789	4112343	1965-03-22	1965-03-22 00:00:00	1965-04-04	1965-04-04 00:00:00	32020		\N	251925	0	195662009	4112343		0
64287	3796	260139	2016-09-07	2016-09-07 00:00:00	2016-09-14	2016-09-14 00:00:00	32020		\N	252371	0	10509002	260139		0
64433	3807	372328	1948-01-14	1948-01-14 00:00:00	1948-02-28	1948-02-28 00:00:00	32020		\N	253001	0	65363002	372328		0
64720	3827	4112343	2009-04-03	2009-04-03 00:00:00	2009-04-11	2009-04-11 00:00:00	32020		\N	254161	0	195662009	4112343		0
54255	3215	40481087	1978-04-10	1978-04-10 00:00:00	1978-05-01	1978-05-01 00:00:00	32020		\N	213679	0	444814009	40481087		0
64962	3841	40481087	2018-09-03	2018-09-03 00:00:00	2018-09-24	2018-09-24 00:00:00	32020		\N	254987	0	444814009	40481087		0
65088	3851	40479768	1927-10-04	1927-10-04 00:00:00	1927-11-10	1927-11-10 00:00:00	32020		\N	255592	0	444470001	40479768		0
65271	3859	260139	1971-09-24	1971-09-24 00:00:00	1971-10-08	1971-10-08 00:00:00	32020		\N	256208	0	10509002	260139		0
65462	3871	4035415	1994-03-28	1994-03-28 00:00:00	1994-05-27	1994-05-27 00:00:00	32020		\N	257018	0	239720000	4035415		0
76197	4521	40481087	1942-03-21	1942-03-21 00:00:00	1942-04-04	1942-04-04 00:00:00	32020		\N	301039	0	444814009	40481087		0
76368	4530	80180	2008-11-29	2008-11-29 00:00:00	\N	\N	32020		\N	301621	0	396275006	80180		0
65969	3901	4296205	1959-08-04	1959-08-04 00:00:00	1959-08-25	1959-08-25 00:00:00	32020		\N	259386	0	403191005	4296205		0
66158	3916	30753	2014-09-15	2014-09-15 00:00:00	\N	\N	32020		\N	260363	0	16761005	30753		0
66337	3927	4112343	2015-01-18	2015-01-18 00:00:00	2015-01-26	2015-01-26 00:00:00	32020		\N	261088	0	195662009	4112343		0
66436	3932	40481087	2001-02-28	2001-02-28 00:00:00	2001-03-07	2001-03-07 00:00:00	32020		\N	261379	0	444814009	40481087		0
77223	4574	40481087	1991-07-18	1991-07-18 00:00:00	1991-08-08	1991-08-08 00:00:00	32020		\N	304746	0	444814009	40481087		0
66853	3955	4285898	1994-11-16	1994-11-16 00:00:00	\N	\N	32020		\N	262849	0	68496003	4285898		0
66993	3961	80180	2011-09-15	2011-09-15 00:00:00	\N	\N	32020		\N	263386	0	396275006	80180		0
67136	3968	40481087	1928-09-10	1928-09-10 00:00:00	1928-09-17	1928-09-17 00:00:00	32020		\N	263825	0	444814009	40481087		0
77971	4621	40481087	1995-12-17	1995-12-17 00:00:00	1995-12-31	1995-12-31 00:00:00	32020		\N	307776	0	444814009	40481087		0
67504	3989	81893	1963-02-21	1963-02-21 00:00:00	\N	\N	32020		\N	265202	0	64766004	81893		0
67626	3995	260139	1998-04-23	1998-04-23 00:00:00	1998-04-30	1998-04-30 00:00:00	32020		\N	265595	0	10509002	260139		0
67775	4005	260139	1990-05-01	1990-05-01 00:00:00	1990-05-08	1990-05-08 00:00:00	32020		\N	266131	0	10509002	260139		0
68004	4018	40481087	1966-01-19	1966-01-19 00:00:00	1966-02-02	1966-02-02 00:00:00	32020		\N	267064	0	444814009	40481087		0
68116	4022	40481087	2019-06-21	2019-06-21 00:00:00	\N	\N	32020		\N	267418	0	444814009	40481087		0
78854	4670	80180	1989-07-15	1989-07-15 00:00:00	\N	\N	32020		\N	311189	0	396275006	80180		0
68487	4049	4278672	1979-11-24	1979-11-24 00:00:00	1980-02-22	1980-02-22 00:00:00	32020		\N	269137	0	65966004	4278672		0
68693	4064	133834	1960-11-12	1960-11-12 00:00:00	\N	\N	32020		\N	270070	0	24079001	133834		0
68880	4077	40481087	2010-03-29	2010-03-29 00:00:00	2010-04-05	2010-04-05 00:00:00	32020		\N	270916	0	444814009	40481087		0
58401	3458	260139	1985-05-22	1985-05-22 00:00:00	1985-06-05	1985-06-05 00:00:00	32020		\N	229468	0	10509002	260139		0
69118	4090	378001	2003-04-28	2003-04-28 00:00:00	2003-05-28	2003-05-28 00:00:00	32020		\N	271938	0	62106007	378001		0
79871	4732	4112343	1966-08-07	1966-08-07 00:00:00	1966-08-17	1966-08-17 00:00:00	32020		\N	315296	0	195662009	4112343		0
58895	3494	4112343	1997-08-22	1997-08-22 00:00:00	1997-09-04	1997-09-04 00:00:00	32020		\N	231722	0	195662009	4112343		0
59092	3505	4112343	1937-09-04	1937-09-04 00:00:00	1937-09-16	1937-09-16 00:00:00	32020		\N	232393	0	195662009	4112343		0
69870	4133	192671	2009-11-25	2009-11-25 00:00:00	\N	\N	32020		\N	274773	0	K92.2	35208414		0
80604	4777	4112343	1967-12-26	1967-12-26 00:00:00	1968-01-06	1968-01-06 00:00:00	32020		\N	318081	0	195662009	4112343		0
59578	3531	4112343	1999-01-27	1999-01-27 00:00:00	1999-02-04	1999-02-04 00:00:00	32020		\N	234543	0	195662009	4112343		0
70350	4167	4027663	2006-09-13	2006-09-13 00:00:00	\N	\N	32020		\N	276914	0	13200003	4027663		0
81092	4811	40481087	2016-03-24	2016-03-24 00:00:00	2016-04-14	2016-04-14 00:00:00	32020		\N	320068	0	444814009	40481087		0
81208	4816	4113008	1990-05-26	1990-05-26 00:00:00	1990-06-09	1990-06-09 00:00:00	32020		\N	320431	0	284549007	4113008		0
70795	4200	80180	2006-09-23	2006-09-23 00:00:00	\N	\N	32020		\N	278817	0	396275006	80180		0
70927	4208	4112343	2000-04-30	2000-04-30 00:00:00	2000-05-08	2000-05-08 00:00:00	32020		\N	279353	0	195662009	4112343		0
60541	3579	4112343	2006-09-07	2006-09-07 00:00:00	2006-09-17	2006-09-17 00:00:00	32020		\N	237954	0	195662009	4112343		0
71279	4226	4112343	1992-08-04	1992-08-04 00:00:00	1992-08-14	1992-08-14 00:00:00	32020		\N	280771	0	195662009	4112343		0
71418	4238	40481087	1993-02-11	1993-02-11 00:00:00	1993-02-18	1993-02-18 00:00:00	32020		\N	281364	0	444814009	40481087		0
71670	4250	40481087	1952-05-27	1952-05-27 00:00:00	1952-06-17	1952-06-17 00:00:00	32020		\N	282334	0	444814009	40481087		0
71743	4256	198809	1963-11-14	1963-11-14 00:00:00	1963-11-14	1963-11-14 00:00:00	32020		\N	282589	0	65275009	198809		0
71917	4268	4113008	2012-05-18	2012-05-18 00:00:00	2012-06-01	2012-06-01 00:00:00	32020		\N	283213	0	284549007	4113008		0
72052	4276	260139	2016-11-14	2016-11-14 00:00:00	2016-11-21	2016-11-21 00:00:00	32020		\N	283779	0	10509002	260139		0
61737	3647	260139	2004-03-31	2004-03-31 00:00:00	2004-04-07	2004-04-07 00:00:00	32020		\N	242722	0	10509002	260139		0
72534	4308	255848	1992-11-10	1992-11-10 00:00:00	\N	\N	32020		\N	285715	0	233604007	255848		0
72683	4319	40481087	2006-08-05	2006-08-05 00:00:00	2006-08-26	2006-08-26 00:00:00	32020		\N	286616	0	444814009	40481087		0
72777	4325	4112343	1995-12-01	1995-12-01 00:00:00	1995-12-10	1995-12-10 00:00:00	32020		\N	286881	0	195662009	4112343		0
83566	4967	40481087	1996-05-01	1996-05-01 00:00:00	1996-05-08	1996-05-08 00:00:00	32020		\N	330164	0	444814009	40481087		0
73155	4347	40481087	1998-01-09	1998-01-09 00:00:00	1998-01-23	1998-01-23 00:00:00	32020		\N	288296	0	444814009	40481087		0
73246	4352	4112343	1973-07-06	1973-07-06 00:00:00	1973-07-14	1973-07-14 00:00:00	32020		\N	288658	0	195662009	4112343		0
84012	4990	80180	2002-08-02	2002-08-02 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
73545	4372	40481087	1996-11-04	1996-11-04 00:00:00	1996-11-11	1996-11-11 00:00:00	32020		\N	290243	0	444814009	40481087		0
73861	4388	4112343	1983-04-07	1983-04-07 00:00:00	1983-04-17	1983-04-17 00:00:00	32020		\N	291660	0	195662009	4112343		0
74000	4395	40481087	1954-06-16	1954-06-16 00:00:00	1954-07-07	1954-07-07 00:00:00	32020		\N	292221	0	444814009	40481087		0
74173	4406	4218389	1975-04-28	1975-04-28 00:00:00	1975-05-19	1975-05-19 00:00:00	32020		\N	292860	0	39848009	4218389		0
84834	5046	81151	1971-09-03	1971-09-03 00:00:00	1971-10-08	1971-10-08 00:00:00	32020		\N	335339	0	44465007	81151		0
63870	3773	40481087	1984-10-12	1984-10-12 00:00:00	1984-10-19	1984-10-19 00:00:00	32020		\N	250822	0	444814009	40481087		0
74570	4428	81151	1972-10-25	1972-10-25 00:00:00	1972-11-07	1972-11-07 00:00:00	32020		\N	294345	0	44465007	81151		0
64172	3789	40481087	1958-07-02	1958-07-02 00:00:00	1958-07-23	1958-07-23 00:00:00	32020		\N	251924	0	444814009	40481087		0
64288	3796	4237458	2003-08-26	2003-08-26 00:00:00	2003-11-24	2003-11-24 00:00:00	32020		\N	252358	0	58150001	4237458		0
64434	3807	4027663	1978-09-13	1978-09-13 00:00:00	\N	\N	32020		\N	253047	0	13200003	4027663		0
64721	3827	4112343	1969-01-21	1969-01-21 00:00:00	1969-02-03	1969-02-03 00:00:00	32020		\N	254159	0	195662009	4112343		0
54256	3215	4109685	2003-10-17	2003-10-17 00:00:00	2003-10-31	2003-10-31 00:00:00	32020		\N	213685	0	284551006	4109685		0
64963	3841	372328	1975-04-02	1975-04-02 00:00:00	1975-09-03	1975-09-03 00:00:00	32020		\N	255041	0	65363002	372328		0
65089	3851	257012	1971-05-12	1971-05-12 00:00:00	\N	\N	32020		\N	255576	0	40055000	257012		0
65272	3859	4112343	2016-04-08	2016-04-08 00:00:00	2016-04-20	2016-04-20 00:00:00	32020		\N	256262	0	195662009	4112343		0
65463	3871	40481087	1985-07-08	1985-07-08 00:00:00	1985-07-22	1985-07-22 00:00:00	32020		\N	257020	0	444814009	40481087		0
76198	4521	313217	2000-06-08	2000-06-08 00:00:00	\N	\N	32020		\N	301035	0	49436004	313217		0
76369	4530	260139	1990-01-25	1990-01-25 00:00:00	1990-02-08	1990-02-08 00:00:00	32020		\N	301636	0	10509002	260139		0
65970	3901	260139	2010-04-28	2010-04-28 00:00:00	2010-05-05	2010-05-05 00:00:00	32020		\N	259407	0	10509002	260139		0
66159	3916	4310024	2013-07-22	2013-07-22 00:00:00	\N	\N	32020		\N	260363	0	424802006	4310024		0
66338	3927	4112343	2013-09-15	2013-09-15 00:00:00	2013-09-24	2013-09-24 00:00:00	32020		\N	261055	0	195662009	4112343		0
66437	3932	40481087	2011-03-02	2011-03-02 00:00:00	2011-03-16	2011-03-16 00:00:00	32020		\N	261397	0	444814009	40481087		0
77224	4574	80180	1992-06-25	1992-06-25 00:00:00	\N	\N	32020		\N	304746	0	396275006	80180		0
66854	3955	80180	1995-03-16	1995-03-16 00:00:00	\N	\N	32020		\N	262849	0	396275006	80180		0
66994	3961	4155034	2018-12-10	2018-12-10 00:00:00	2018-12-31	2018-12-31 00:00:00	32020		\N	263353	0	283371005	4155034		0
67138	3968	321042	1928-02-03	1928-02-03 00:00:00	\N	\N	32020		\N	263901	0	410429000	321042		0
77972	4621	4156265	1989-09-30	1989-09-30 00:00:00	1989-10-21	1989-10-21 00:00:00	32020		\N	307743	0	370247008	4156265		0
67505	3989	30753	1963-11-18	1963-11-18 00:00:00	\N	\N	32020		\N	265202	0	16761005	30753		0
67627	3995	80180	2005-11-21	2005-11-21 00:00:00	\N	\N	32020		\N	265584	0	396275006	80180		0
67776	4005	40481087	1995-10-04	1995-10-04 00:00:00	1995-10-11	1995-10-11 00:00:00	32020		\N	266118	0	444814009	40481087		0
68005	4018	372328	1968-01-25	1968-01-25 00:00:00	1968-11-05	1968-11-05 00:00:00	32020		\N	267109	0	65363002	372328		0
68117	4022	40481087	1963-12-30	1963-12-30 00:00:00	1964-01-20	1964-01-20 00:00:00	32020		\N	267415	0	444814009	40481087		0
78855	4670	4112343	1977-03-21	1977-03-21 00:00:00	1977-04-03	1977-04-03 00:00:00	32020		\N	311193	0	195662009	4112343		0
68498	4051	40481087	2002-01-01	2002-01-01 00:00:00	2002-01-08	2002-01-08 00:00:00	32020		\N	269242	0	444814009	40481087		0
68694	4064	40481087	2012-06-06	2012-06-06 00:00:00	2012-06-20	2012-06-20 00:00:00	32020		\N	270118	0	444814009	40481087		0
68881	4077	4112343	1984-11-03	1984-11-03 00:00:00	1984-11-15	1984-11-15 00:00:00	32020		\N	270911	0	195662009	4112343		0
58402	3458	40481087	1986-01-21	1986-01-21 00:00:00	1986-02-04	1986-02-04 00:00:00	32020		\N	229469	0	444814009	40481087		0
69119	4090	40481087	1985-07-06	1985-07-06 00:00:00	1985-07-20	1985-07-20 00:00:00	32020		\N	271850	0	444814009	40481087		0
79873	4732	4112343	2007-08-23	2007-08-23 00:00:00	2007-09-02	2007-09-02 00:00:00	32020		\N	315254	0	195662009	4112343		0
58896	3494	40481087	1978-05-03	1978-05-03 00:00:00	1978-05-17	1978-05-17 00:00:00	32020		\N	231720	0	444814009	40481087		0
59093	3505	260139	2018-04-28	2018-04-28 00:00:00	2018-05-12	2018-05-12 00:00:00	32020		\N	232415	0	10509002	260139		0
69871	4134	260139	1976-12-19	1976-12-19 00:00:00	1977-01-02	1977-01-02 00:00:00	32020		\N	274846	0	10509002	260139		0
80605	4777	80180	1992-10-16	1992-10-16 00:00:00	\N	\N	32020		\N	318068	0	396275006	80180		0
59579	3531	40481087	1993-11-15	1993-11-15 00:00:00	1993-11-22	1993-11-22 00:00:00	32020		\N	234542	0	444814009	40481087		0
70351	4167	4296204	2016-08-15	2016-08-15 00:00:00	2016-09-19	2016-09-19 00:00:00	32020		\N	277001	0	403190006	4296204		0
81093	4811	4218389	1994-03-13	1994-03-13 00:00:00	1994-04-18	1994-04-18 00:00:00	32020		\N	320051	0	39848009	4218389		0
81209	4816	4310024	2015-09-27	2015-09-27 00:00:00	\N	\N	32020		\N	320424	0	424802006	4310024		0
70796	4200	40481087	2010-08-26	2010-08-26 00:00:00	2010-09-09	2010-09-09 00:00:00	32020		\N	278782	0	444814009	40481087		0
70928	4208	40481087	1999-11-28	1999-11-28 00:00:00	1999-12-12	1999-12-12 00:00:00	32020		\N	279352	0	444814009	40481087		0
60542	3580	4112343	1975-10-07	1975-10-07 00:00:00	1975-10-16	1975-10-16 00:00:00	32020		\N	237994	0	195662009	4112343		0
71280	4226	40481087	1987-10-24	1987-10-24 00:00:00	1987-11-14	1987-11-14 00:00:00	32020		\N	280669	0	444814009	40481087		0
71419	4238	40479422	2013-06-18	2013-06-18 00:00:00	2013-07-25	2013-07-25 00:00:00	32020		\N	281411	0	444448004	40479422		0
71671	4250	40481087	1957-03-29	1957-03-29 00:00:00	1957-04-12	1957-04-12 00:00:00	32020		\N	282335	0	444814009	40481087		0
71744	4256	196456	1963-11-14	1963-11-14 00:00:00	1963-11-14	1963-11-14 00:00:00	32020		\N	282589	0	235919008	196456		0
71918	4268	80502	2016-01-11	2016-01-11 00:00:00	\N	\N	32020		\N	283237	0	64859006	80502		0
72053	4276	80180	1996-10-30	1996-10-30 00:00:00	\N	\N	32020		\N	283796	0	396275006	80180		0
61738	3647	40481087	1958-11-20	1958-11-20 00:00:00	1958-11-27	1958-11-27 00:00:00	32020		\N	242620	0	444814009	40481087		0
72535	4308	4112343	1941-11-07	1941-11-07 00:00:00	1941-11-16	1941-11-16 00:00:00	32020		\N	285737	0	195662009	4112343		0
72684	4319	4134304	2014-05-28	2014-05-28 00:00:00	2014-07-27	2014-07-27 00:00:00	32020		\N	286586	0	263102004	4134304		0
72778	4325	40481087	1989-07-01	1989-07-01 00:00:00	1989-07-08	1989-07-08 00:00:00	32020		\N	286897	0	444814009	40481087		0
83567	4967	257012	1978-10-07	1978-10-07 00:00:00	\N	\N	32020		\N	330135	0	40055000	257012		0
73157	4347	40481087	2008-04-02	2008-04-02 00:00:00	2008-04-23	2008-04-23 00:00:00	32020		\N	288277	0	444814009	40481087		0
73247	4353	4112343	1968-05-31	1968-05-31 00:00:00	1968-06-11	1968-06-11 00:00:00	32020		\N	288728	0	195662009	4112343		0
84013	4990	40481087	1975-05-02	1975-05-02 00:00:00	1975-05-23	1975-05-23 00:00:00	32020		\N	331950	0	444814009	40481087		0
73546	4372	40481087	1983-12-25	1983-12-25 00:00:00	1984-01-08	1984-01-08 00:00:00	32020		\N	290205	0	444814009	40481087		0
73862	4388	40481087	1967-11-21	1967-11-21 00:00:00	1967-12-05	1967-12-05 00:00:00	32020		\N	291684	0	444814009	40481087		0
74001	4395	40481087	1994-09-25	1994-09-25 00:00:00	1994-10-09	1994-10-09 00:00:00	32020		\N	292260	0	444814009	40481087		0
74174	4406	4112343	2014-12-23	2014-12-23 00:00:00	2014-12-31	2014-12-31 00:00:00	32020		\N	292943	0	195662009	4112343		0
84835	5046	372328	1959-08-07	1959-08-07 00:00:00	1959-12-21	1959-12-21 00:00:00	32020		\N	335366	0	65363002	372328		0
63871	3773	372328	1981-08-22	1981-08-22 00:00:00	1982-07-02	1982-07-02 00:00:00	32020		\N	250809	0	65363002	372328		0
74571	4428	372328	1952-05-13	1952-05-13 00:00:00	1952-10-30	1952-10-30 00:00:00	32020		\N	294369	0	65363002	372328		0
64173	3789	260139	1950-09-02	1950-09-02 00:00:00	1950-09-09	1950-09-09 00:00:00	32020		\N	251923	0	10509002	260139		0
64289	3796	372328	2019-02-28	2019-02-28 00:00:00	\N	\N	32020		\N	252414	0	65363002	372328		0
64435	3807	372328	1948-03-29	1948-03-29 00:00:00	1948-08-28	1948-08-28 00:00:00	32020		\N	252963	0	65363002	372328		0
64722	3827	40481087	1961-09-06	1961-09-06 00:00:00	1961-09-13	1961-09-13 00:00:00	32020		\N	254192	0	444814009	40481087		0
54257	3215	4112343	1978-06-02	1978-06-02 00:00:00	1978-06-14	1978-06-14 00:00:00	32020		\N	213640	0	195662009	4112343		0
64964	3841	260139	2002-08-29	2002-08-29 00:00:00	2002-09-05	2002-09-05 00:00:00	32020		\N	255033	0	10509002	260139		0
65090	3851	4112343	1982-10-20	1982-10-20 00:00:00	1982-10-31	1982-10-31 00:00:00	32020		\N	255495	0	195662009	4112343		0
65273	3859	4059173	1936-12-01	1936-12-01 00:00:00	1936-12-31	1936-12-31 00:00:00	32020		\N	256264	0	16114001	4059173		0
65464	3871	80180	1999-10-18	1999-10-18 00:00:00	\N	\N	32020		\N	257052	0	396275006	80180		0
76199	4521	378419	2000-06-08	2000-06-08 00:00:00	\N	\N	32020		\N	301035	0	26929004	378419		0
76370	4530	40481087	1990-08-13	1990-08-13 00:00:00	1990-08-27	1990-08-27 00:00:00	32020		\N	301624	0	444814009	40481087		0
65971	3901	40481087	1978-07-10	1978-07-10 00:00:00	1978-07-24	1978-07-24 00:00:00	32020		\N	259346	0	444814009	40481087		0
66160	3916	81893	2013-11-19	2013-11-19 00:00:00	\N	\N	32020		\N	260363	0	64766004	81893		0
66339	3927	81151	1960-04-10	1960-04-10 00:00:00	1960-05-15	1960-05-15 00:00:00	32020		\N	261034	0	44465007	81151		0
66438	3932	4142905	1975-06-17	1975-06-17 00:00:00	1975-09-15	1975-09-15 00:00:00	32020		\N	261411	0	33737001	4142905		0
77225	4574	4283893	1962-10-15	1962-10-15 00:00:00	1962-11-19	1962-11-19 00:00:00	32020		\N	304724	0	36971009	4283893		0
66855	3955	4266809	1995-03-16	1995-03-16 00:00:00	\N	\N	32020		\N	262849	0	397881000	4266809		0
66995	3961	4112343	2000-12-23	2000-12-23 00:00:00	2001-01-03	2001-01-03 00:00:00	32020		\N	263340	0	195662009	4112343		0
67139	3968	4296205	1977-07-01	1977-07-01 00:00:00	1977-07-29	1977-07-29 00:00:00	32020		\N	263906	0	403191005	4296205		0
77973	4621	40481087	2017-10-14	2017-10-14 00:00:00	2017-11-04	2017-11-04 00:00:00	32020		\N	307778	0	444814009	40481087		0
67506	3989	4310024	1963-01-22	1963-01-22 00:00:00	\N	\N	32020		\N	265202	0	424802006	4310024		0
67628	3996	4112343	2001-06-01	2001-06-01 00:00:00	2001-06-08	2001-06-08 00:00:00	32020		\N	265688	0	195662009	4112343		0
67777	4006	40481087	2004-04-24	2004-04-24 00:00:00	2004-05-01	2004-05-01 00:00:00	32020		\N	266191	0	444814009	40481087		0
68006	4018	4112343	1980-12-27	1980-12-27 00:00:00	1981-01-07	1981-01-07 00:00:00	32020		\N	267104	0	195662009	4112343		0
68118	4022	80180	1999-07-28	1999-07-28 00:00:00	\N	\N	32020		\N	267423	0	396275006	80180		0
78856	4670	260139	1982-03-24	1982-03-24 00:00:00	1982-03-31	1982-03-31 00:00:00	32020		\N	311229	0	10509002	260139		0
68499	4051	260139	2005-01-08	2005-01-08 00:00:00	2005-01-15	2005-01-15 00:00:00	32020		\N	269267	0	10509002	260139		0
68695	4064	260139	1984-11-01	1984-11-01 00:00:00	1984-11-08	1984-11-08 00:00:00	32020		\N	270011	0	10509002	260139		0
68882	4077	40481087	2006-11-18	2006-11-18 00:00:00	2006-11-25	2006-11-25 00:00:00	32020		\N	270915	0	444814009	40481087		0
58403	3458	260139	1997-09-29	1997-09-29 00:00:00	1997-10-06	1997-10-06 00:00:00	32020		\N	229452	0	10509002	260139		0
69120	4090	4278672	1949-09-12	1949-09-12 00:00:00	1949-12-11	1949-12-11 00:00:00	32020		\N	271904	0	65966004	4278672		0
79874	4732	81151	1976-06-03	1976-06-03 00:00:00	1976-06-17	1976-06-17 00:00:00	32020		\N	315276	0	44465007	81151		0
58897	3494	4112343	2015-12-12	2015-12-12 00:00:00	2015-12-22	2015-12-22 00:00:00	32020		\N	231743	0	195662009	4112343		0
59094	3505	40481087	1982-06-18	1982-06-18 00:00:00	1982-07-02	1982-07-02 00:00:00	32020		\N	232440	0	444814009	40481087		0
69872	4134	40481087	2001-07-05	2001-07-05 00:00:00	2001-07-26	2001-07-26 00:00:00	32020		\N	274828	0	444814009	40481087		0
80606	4777	372328	1959-01-08	1959-01-08 00:00:00	1959-04-21	1959-04-21 00:00:00	32020		\N	318111	0	65363002	372328		0
59580	3531	4285898	2001-01-09	2001-01-09 00:00:00	\N	\N	32020		\N	234537	0	68496003	4285898		0
70352	4167	40481087	1999-08-17	1999-08-17 00:00:00	1999-08-31	1999-08-31 00:00:00	32020		\N	276951	0	444814009	40481087		0
81094	4811	4112343	1967-02-06	1967-02-06 00:00:00	1967-02-13	1967-02-13 00:00:00	32020		\N	320072	0	195662009	4112343		0
81210	4816	40481087	1994-07-07	1994-07-07 00:00:00	1994-07-14	1994-07-14 00:00:00	32020		\N	320381	0	444814009	40481087		0
70797	4200	40481087	2017-04-25	2017-04-25 00:00:00	2017-05-16	2017-05-16 00:00:00	32020		\N	278751	0	444814009	40481087		0
70929	4208	260139	1943-10-15	1943-10-15 00:00:00	1943-10-29	1943-10-29 00:00:00	32020		\N	279431	0	10509002	260139		0
60543	3580	260139	1986-03-13	1986-03-13 00:00:00	1986-03-27	1986-03-27 00:00:00	32020		\N	238001	0	10509002	260139		0
71281	4227	260139	1992-02-27	1992-02-27 00:00:00	1992-03-05	1992-03-05 00:00:00	32020		\N	280783	0	10509002	260139		0
71420	4238	4146173	2001-08-20	2001-08-20 00:00:00	2001-10-19	2001-10-19 00:00:00	32020		\N	281372	0	307731004	4146173		0
71672	4250	4134304	2000-06-24	2000-06-24 00:00:00	2000-07-24	2000-07-24 00:00:00	32020		\N	282263	0	263102004	4134304		0
71745	4256	4027663	1980-09-28	1980-09-28 00:00:00	\N	\N	32020		\N	282583	0	13200003	4027663		0
71919	4268	260139	1963-02-04	1963-02-04 00:00:00	1963-02-11	1963-02-11 00:00:00	32020		\N	283216	0	10509002	260139		0
72054	4276	4112343	2000-05-21	2000-05-21 00:00:00	2000-06-03	2000-06-03 00:00:00	32020		\N	283776	0	195662009	4112343		0
61739	3647	4112343	1979-05-27	1979-05-27 00:00:00	1979-06-04	1979-06-04 00:00:00	32020		\N	242622	0	195662009	4112343		0
72536	4308	260139	1913-11-15	1913-11-15 00:00:00	1913-11-22	1913-11-22 00:00:00	32020		\N	285738	0	10509002	260139		0
72685	4319	4132546	2018-05-07	2018-05-07 00:00:00	\N	\N	32020		\N	286587	0	275272006	4166590		0
72779	4325	260139	1996-08-30	1996-08-30 00:00:00	1996-09-06	1996-09-06 00:00:00	32020		\N	286882	0	10509002	260139		0
83568	4967	4112343	1993-04-10	1993-04-10 00:00:00	1993-04-22	1993-04-22 00:00:00	32020		\N	330185	0	195662009	4112343		0
73158	4348	260139	2007-05-17	2007-05-17 00:00:00	2007-05-31	2007-05-31 00:00:00	32020		\N	288346	0	10509002	260139		0
73248	4353	440086	1976-08-04	1976-08-04 00:00:00	1981-05-27	1981-05-27 00:00:00	32020		\N	288819	0	192127007	440086		0
84014	4990	372328	1966-07-02	1966-07-02 00:00:00	1967-01-25	1967-01-25 00:00:00	32020		\N	331924	0	65363002	372328		0
73547	4372	4155034	2019-06-04	2019-06-04 00:00:00	2019-06-25	2019-06-25 00:00:00	32020		\N	290289	0	283371005	4155034		0
73863	4388	4134304	1968-05-11	1968-05-11 00:00:00	1968-06-10	1968-06-10 00:00:00	32020		\N	291634	0	263102004	4134304		0
74002	4395	80180	1992-04-13	1992-04-13 00:00:00	\N	\N	32020		\N	292252	0	396275006	80180		0
74175	4406	4112343	2008-04-16	2008-04-16 00:00:00	2008-04-27	2008-04-27 00:00:00	32020		\N	292942	0	195662009	4112343		0
84836	5046	81151	2000-05-06	2000-05-06 00:00:00	2000-05-20	2000-05-20 00:00:00	32020		\N	335341	0	44465007	81151		0
63872	3773	439777	1960-05-01	1960-05-01 00:00:00	\N	\N	32020		\N	250803	0	271737000	439777		0
74603	4432	40481087	2019-05-13	2019-05-13 00:00:00	2019-06-03	2019-06-03 00:00:00	32020		\N	294630	0	444814009	40481087		0
64174	3789	4112343	1999-12-14	1999-12-14 00:00:00	1999-12-25	1999-12-25 00:00:00	32020		\N	251939	0	195662009	4112343		0
64290	3796	4155034	1992-10-31	1992-10-31 00:00:00	1992-11-21	1992-11-21 00:00:00	32020		\N	252357	0	283371005	4155034		0
64436	3807	28060	1952-02-26	1952-02-26 00:00:00	1952-03-10	1952-03-10 00:00:00	32020		\N	252976	0	43878008	28060		0
64723	3827	81151	1998-07-19	1998-07-19 00:00:00	1998-08-23	1998-08-23 00:00:00	32020		\N	254190	0	44465007	81151		0
54258	3215	40481087	1997-10-16	1997-10-16 00:00:00	1997-10-23	1997-10-23 00:00:00	32020		\N	213563	0	444814009	40481087		0
64965	3841	40481087	2002-08-15	2002-08-15 00:00:00	2002-08-22	2002-08-22 00:00:00	32020		\N	255028	0	444814009	40481087		0
65091	3851	4112343	1927-10-21	1927-10-21 00:00:00	1927-10-28	1927-10-28 00:00:00	32020		\N	255608	0	195662009	4112343		0
65274	3859	4112343	2009-02-05	2009-02-05 00:00:00	2009-02-12	2009-02-12 00:00:00	32020		\N	256277	0	195662009	4112343		0
65465	3871	40481087	1985-12-25	1985-12-25 00:00:00	1986-01-01	1986-01-01 00:00:00	32020		\N	257021	0	444814009	40481087		0
76200	4521	255848	2009-04-22	2009-04-22 00:00:00	\N	\N	32020		\N	300974	0	233604007	255848		0
76371	4530	40481087	1997-08-25	1997-08-25 00:00:00	1997-09-08	1997-09-08 00:00:00	32020		\N	301647	0	444814009	40481087		0
65972	3901	260139	2017-07-16	2017-07-16 00:00:00	2017-07-23	2017-07-23 00:00:00	32020		\N	259429	0	10509002	260139		0
66161	3916	28060	2001-11-20	2001-11-20 00:00:00	2001-11-30	2001-11-30 00:00:00	32020		\N	260374	0	43878008	28060		0
66340	3927	4218389	1979-01-20	1979-01-20 00:00:00	1979-02-24	1979-02-24 00:00:00	32020		\N	261036	0	39848009	4218389		0
66439	3932	4142905	1989-01-04	1989-01-04 00:00:00	1989-04-04	1989-04-04 00:00:00	32020		\N	261399	0	33737001	4142905		0
77226	4574	40481087	2000-03-31	2000-03-31 00:00:00	2000-04-21	2000-04-21 00:00:00	32020		\N	304690	0	444814009	40481087		0
66856	3955	260139	2004-03-09	2004-03-09 00:00:00	2004-03-16	2004-03-16 00:00:00	32020		\N	262830	0	10509002	260139		0
66996	3961	4296205	1990-06-05	1990-06-05 00:00:00	1990-07-10	1990-07-10 00:00:00	32020		\N	263352	0	403191005	4296205		0
67140	3968	40481087	1921-07-03	1921-07-03 00:00:00	1921-07-10	1921-07-10 00:00:00	32020		\N	263894	0	444814009	40481087		0
77974	4621	40481087	1996-02-04	1996-02-04 00:00:00	1996-02-25	1996-02-25 00:00:00	32020		\N	307771	0	444814009	40481087		0
67507	3989	4112343	2006-11-08	2006-11-08 00:00:00	2006-11-17	2006-11-17 00:00:00	32020		\N	265163	0	195662009	4112343		0
67629	3996	81151	1976-09-01	1976-09-01 00:00:00	1976-09-22	1976-09-22 00:00:00	32020		\N	265651	0	44465007	81151		0
67778	4006	260139	1981-08-17	1981-08-17 00:00:00	1981-08-31	1981-08-31 00:00:00	32020		\N	266139	0	10509002	260139		0
68007	4018	260139	1967-08-08	1967-08-08 00:00:00	1967-08-15	1967-08-15 00:00:00	32020		\N	267103	0	10509002	260139		0
68119	4022	78272	2010-06-09	2010-06-09 00:00:00	2010-07-14	2010-07-14 00:00:00	32020		\N	267387	0	70704007	78272		0
78857	4670	40481087	2007-10-30	2007-10-30 00:00:00	2007-11-06	2007-11-06 00:00:00	32020		\N	311231	0	444814009	40481087		0
68500	4051	372328	1977-08-15	1977-08-15 00:00:00	1977-12-21	1977-12-21 00:00:00	32020		\N	269243	0	65363002	372328		0
68712	4067	40481087	2010-02-10	2010-02-10 00:00:00	2010-02-17	2010-02-17 00:00:00	32020		\N	270222	0	444814009	40481087		0
68883	4077	260139	2006-01-12	2006-01-12 00:00:00	2006-01-26	2006-01-26 00:00:00	32020		\N	270893	0	10509002	260139		0
58404	3458	40481087	1996-09-02	1996-09-02 00:00:00	1996-09-16	1996-09-16 00:00:00	32020		\N	229451	0	444814009	40481087		0
69121	4090	4112343	1971-12-18	1971-12-18 00:00:00	1971-12-28	1971-12-28 00:00:00	32020		\N	271853	0	195662009	4112343		0
79875	4732	40481087	1984-03-29	1984-03-29 00:00:00	1984-04-12	1984-04-12 00:00:00	32020		\N	315281	0	444814009	40481087		0
58898	3494	40481087	1990-09-20	1990-09-20 00:00:00	1990-09-27	1990-09-27 00:00:00	32020		\N	231781	0	444814009	40481087		0
59095	3505	260139	1946-02-20	1946-02-20 00:00:00	1946-02-27	1946-02-27 00:00:00	32020		\N	232394	0	10509002	260139		0
69873	4134	40481087	1990-11-15	1990-11-15 00:00:00	1990-11-29	1990-11-29 00:00:00	32020		\N	274827	0	444814009	40481087		0
80607	4777	4296204	1971-04-05	1971-04-05 00:00:00	1971-04-19	1971-04-19 00:00:00	32020		\N	318094	0	403190006	4296204		0
59581	3531	80180	2001-07-08	2001-07-08 00:00:00	\N	\N	32020		\N	234537	0	396275006	80180		0
70353	4167	4112343	1980-12-11	1980-12-11 00:00:00	1980-12-19	1980-12-19 00:00:00	32020		\N	276920	0	195662009	4112343		0
81095	4811	40481087	2003-07-07	2003-07-07 00:00:00	2003-07-28	2003-07-28 00:00:00	32020		\N	320077	0	444814009	40481087		0
81211	4816	81151	1993-04-24	1993-04-24 00:00:00	1993-05-29	1993-05-29 00:00:00	32020		\N	320432	0	44465007	81151		0
70811	4202	28060	1990-09-29	1990-09-29 00:00:00	1990-10-07	1990-10-07 00:00:00	32020		\N	278967	0	43878008	28060		0
70930	4208	40481087	1986-09-29	1986-09-29 00:00:00	1986-10-13	1986-10-13 00:00:00	32020		\N	279434	0	444814009	40481087		0
60544	3580	4142905	1989-05-15	1989-05-15 00:00:00	1989-06-14	1989-06-14 00:00:00	32020		\N	237966	0	33737001	4142905		0
71282	4227	260139	1993-10-27	1993-10-27 00:00:00	1993-11-03	1993-11-03 00:00:00	32020		\N	280854	0	10509002	260139		0
71421	4238	4112343	2010-07-25	2010-07-25 00:00:00	2010-08-07	2010-08-07 00:00:00	32020		\N	281373	0	195662009	4112343		0
71673	4250	4112343	1996-10-12	1996-10-12 00:00:00	1996-10-21	1996-10-21 00:00:00	32020		\N	282328	0	195662009	4112343		0
71746	4256	40481087	1980-04-27	1980-04-27 00:00:00	1980-05-04	1980-05-04 00:00:00	32020		\N	282583	0	444814009	40481087		0
71920	4268	40481087	2006-04-16	2006-04-16 00:00:00	2006-04-30	2006-04-30 00:00:00	32020		\N	283242	0	444814009	40481087		0
72055	4276	260139	2001-02-03	2001-02-03 00:00:00	2001-02-17	2001-02-17 00:00:00	32020		\N	283763	0	10509002	260139		0
61740	3647	4112343	1943-06-30	1943-06-30 00:00:00	1943-07-07	1943-07-07 00:00:00	32020		\N	242678	0	195662009	4112343		0
72537	4308	4278672	1925-05-06	1925-05-06 00:00:00	1925-08-04	1925-08-04 00:00:00	32020		\N	285772	0	65966004	4278672		0
72686	4319	4001336	2018-05-07	2018-05-07 00:00:00	2018-07-06	2018-07-06 00:00:00	32020		\N	286587	0	110030002	4001336		0
72780	4325	4112343	2009-11-27	2009-11-27 00:00:00	2009-12-05	2009-12-05 00:00:00	32020		\N	286898	0	195662009	4112343		0
83569	4967	4112343	1995-06-12	1995-06-12 00:00:00	1995-06-23	1995-06-23 00:00:00	32020		\N	330158	0	195662009	4112343		0
73159	4348	40481087	1988-04-07	1988-04-07 00:00:00	1988-04-28	1988-04-28 00:00:00	32020		\N	288329	0	444814009	40481087		0
73249	4353	372328	1967-04-04	1967-04-04 00:00:00	1967-07-16	1967-07-16 00:00:00	32020		\N	288834	0	65363002	372328		0
84015	4990	40481087	1964-04-06	1964-04-06 00:00:00	1964-04-20	1964-04-20 00:00:00	32020		\N	331960	0	444814009	40481087		0
73548	4372	40481087	2015-12-11	2015-12-11 00:00:00	2015-12-18	2015-12-18 00:00:00	32020		\N	290210	0	444814009	40481087		0
73864	4388	4112343	1996-05-10	1996-05-10 00:00:00	1996-05-23	1996-05-23 00:00:00	32020		\N	291701	0	195662009	4112343		0
74003	4395	81151	1981-08-09	1981-08-09 00:00:00	1981-09-13	1981-09-13 00:00:00	32020		\N	292239	0	44465007	81151		0
74176	4406	4294548	1976-02-23	1976-02-23 00:00:00	1976-04-26	1976-04-26 00:00:00	32020		\N	292905	0	75498004	4294548		0
84837	5046	4112343	2015-07-26	2015-07-26 00:00:00	2015-08-05	2015-08-05 00:00:00	32020		\N	335346	0	195662009	4112343		0
63873	3773	40481087	2018-06-02	2018-06-02 00:00:00	2018-06-23	2018-06-23 00:00:00	32020		\N	250825	0	444814009	40481087		0
74604	4432	81151	2004-08-13	2004-08-13 00:00:00	2004-09-17	2004-09-17 00:00:00	32020		\N	294585	0	44465007	81151		0
64175	3789	40481087	2016-12-29	2016-12-29 00:00:00	2017-01-19	2017-01-19 00:00:00	32020		\N	251927	0	444814009	40481087		0
64291	3796	4112343	2010-11-10	2010-11-10 00:00:00	2010-11-23	2010-11-23 00:00:00	32020		\N	252413	0	195662009	4112343		0
64437	3807	195588	1973-09-14	1973-09-14 00:00:00	1973-10-23	1973-10-23 00:00:00	32020		\N	252970	0	38822007	195588		0
64724	3827	40481087	2004-03-24	2004-03-24 00:00:00	2004-04-14	2004-04-14 00:00:00	32020		\N	254195	0	444814009	40481087		0
54259	3215	372328	1978-06-30	1978-06-30 00:00:00	1978-09-11	1978-09-11 00:00:00	32020		\N	213569	0	65363002	372328		0
64966	3841	260139	1982-09-27	1982-09-27 00:00:00	1982-10-11	1982-10-11 00:00:00	32020		\N	255022	0	10509002	260139		0
65092	3851	321042	1985-10-14	1985-10-14 00:00:00	\N	\N	32020		\N	255594	0	410429000	321042		0
65275	3860	28060	1984-12-03	1984-12-03 00:00:00	1984-12-10	1984-12-10 00:00:00	32020		\N	256319	0	43878008	28060		0
65466	3871	4059173	1968-06-12	1968-06-12 00:00:00	1968-09-10	1968-09-10 00:00:00	32020		\N	257017	0	16114001	4059173		0
76201	4521	260139	1976-02-19	1976-02-19 00:00:00	1976-02-26	1976-02-26 00:00:00	32020		\N	301007	0	10509002	260139		0
76372	4530	40481087	2016-10-03	2016-10-03 00:00:00	2016-10-24	2016-10-24 00:00:00	32020		\N	301649	0	444814009	40481087		0
65973	3901	40481087	1939-02-06	1939-02-06 00:00:00	1939-02-13	1939-02-13 00:00:00	32020		\N	259415	0	444814009	40481087		0
66162	3916	40479422	1997-06-17	1997-06-17 00:00:00	1997-07-24	1997-07-24 00:00:00	32020		\N	260435	0	444448004	40479422		0
66341	3927	80180	1981-02-08	1981-02-08 00:00:00	\N	\N	32020		\N	261094	0	396275006	80180		0
66440	3932	260139	1982-05-12	1982-05-12 00:00:00	1982-05-26	1982-05-26 00:00:00	32020		\N	261403	0	10509002	260139		0
77227	4574	4112343	2007-01-05	2007-01-05 00:00:00	2007-01-14	2007-01-14 00:00:00	32020		\N	304703	0	195662009	4112343		0
66857	3955	40481087	1969-02-09	1969-02-09 00:00:00	1969-03-02	1969-03-02 00:00:00	32020		\N	262827	0	444814009	40481087		0
66997	3961	40481087	2004-09-16	2004-09-16 00:00:00	2004-10-07	2004-10-07 00:00:00	32020		\N	263366	0	444814009	40481087		0
67141	3968	4294548	1934-10-29	1934-10-29 00:00:00	1934-12-24	1934-12-24 00:00:00	32020		\N	263792	0	75498004	4294548		0
77975	4621	372328	1978-01-17	1978-01-17 00:00:00	1978-07-03	1978-07-03 00:00:00	32020		\N	307773	0	65363002	372328		0
67508	3989	4294548	1993-04-12	1993-04-12 00:00:00	1993-05-17	1993-05-17 00:00:00	32020		\N	265251	0	75498004	4294548		0
67630	3996	4283893	1973-06-25	1973-06-25 00:00:00	1973-07-09	1973-07-09 00:00:00	32020		\N	265649	0	36971009	4283893		0
67779	4006	372328	1950-09-12	1950-09-12 00:00:00	1950-11-28	1950-11-28 00:00:00	32020		\N	266184	0	65363002	372328		0
68008	4018	260139	2000-06-18	2000-06-18 00:00:00	2000-07-02	2000-07-02 00:00:00	32020		\N	267055	0	10509002	260139		0
68120	4022	4112343	1978-10-04	1978-10-04 00:00:00	1978-10-15	1978-10-15 00:00:00	32020		\N	267389	0	195662009	4112343		0
78858	4670	372328	1954-05-30	1954-05-30 00:00:00	1954-07-07	1954-07-07 00:00:00	32020		\N	311165	0	65363002	372328		0
68501	4051	260139	1995-11-23	1995-11-23 00:00:00	1995-12-07	1995-12-07 00:00:00	32020		\N	269252	0	10509002	260139		0
68713	4067	378001	1991-11-28	1991-11-28 00:00:00	1991-12-28	1991-12-28 00:00:00	32020		\N	270198	0	62106007	378001		0
68884	4077	260139	1983-11-22	1983-11-22 00:00:00	1983-11-29	1983-11-29 00:00:00	32020		\N	270910	0	10509002	260139		0
58405	3458	260139	2004-01-04	2004-01-04 00:00:00	2004-01-11	2004-01-11 00:00:00	32020		\N	229460	0	10509002	260139		0
69122	4090	40481087	1984-11-25	1984-11-25 00:00:00	1984-12-02	1984-12-02 00:00:00	32020		\N	271840	0	444814009	40481087		0
79876	4732	372328	1964-07-06	1964-07-06 00:00:00	1964-07-20	1964-07-20 00:00:00	32020		\N	315289	0	65363002	372328		0
58899	3494	4112343	1970-07-20	1970-07-20 00:00:00	1970-08-01	1970-08-01 00:00:00	32020		\N	231779	0	195662009	4112343		0
59096	3505	40481087	1938-05-10	1938-05-10 00:00:00	1938-05-24	1938-05-24 00:00:00	32020		\N	232436	0	444814009	40481087		0
69874	4134	4146173	1981-06-18	1981-06-18 00:00:00	1981-07-18	1981-07-18 00:00:00	32020		\N	274847	0	307731004	4146173		0
80608	4777	260139	1983-06-02	1983-06-02 00:00:00	1983-06-09	1983-06-09 00:00:00	32020		\N	318109	0	10509002	260139		0
59582	3531	4142905	1975-07-15	1975-07-15 00:00:00	1975-10-13	1975-10-13 00:00:00	32020		\N	234587	0	33737001	4142905		0
70354	4167	4266809	2015-11-30	2015-11-30 00:00:00	\N	\N	32020		\N	276917	0	397881000	4266809		0
81096	4811	4310024	1998-01-02	1998-01-02 00:00:00	\N	\N	32020		\N	320017	0	424802006	4310024		0
81213	4816	257012	1983-07-20	1983-07-20 00:00:00	\N	\N	32020		\N	320437	0	40055000	257012		0
70812	4202	40481087	1997-01-13	1997-01-13 00:00:00	1997-01-20	1997-01-20 00:00:00	32020		\N	278994	0	444814009	40481087		0
70931	4208	4112343	1999-01-23	1999-01-23 00:00:00	1999-02-04	1999-02-04 00:00:00	32020		\N	279351	0	195662009	4112343		0
60545	3580	40481087	2007-05-25	2007-05-25 00:00:00	2007-06-01	2007-06-01 00:00:00	32020		\N	237984	0	444814009	40481087		0
71283	4227	4112343	1987-05-18	1987-05-18 00:00:00	1987-05-28	1987-05-28 00:00:00	32020		\N	280782	0	195662009	4112343		0
71423	4238	321042	1978-12-28	1978-12-28 00:00:00	\N	\N	32020		\N	281383	0	410429000	321042		0
71674	4250	40481087	1950-12-07	1950-12-07 00:00:00	1950-12-28	1950-12-28 00:00:00	32020		\N	282333	0	444814009	40481087		0
71747	4256	4112343	2008-11-02	2008-11-02 00:00:00	2008-11-14	2008-11-14 00:00:00	32020		\N	282616	0	195662009	4112343		0
71921	4268	81151	1971-05-28	1971-05-28 00:00:00	1971-06-11	1971-06-11 00:00:00	32020		\N	283210	0	44465007	81151		0
72056	4276	40481087	1973-03-04	1973-03-04 00:00:00	1973-03-25	1973-03-25 00:00:00	32020		\N	283740	0	444814009	40481087		0
61741	3647	260139	1954-05-21	1954-05-21 00:00:00	1954-05-28	1954-05-28 00:00:00	32020		\N	242717	0	10509002	260139		0
72538	4308	4112343	1962-05-03	1962-05-03 00:00:00	1962-05-16	1962-05-16 00:00:00	32020		\N	285753	0	195662009	4112343		0
72687	4319	4112343	2019-06-02	2019-06-02 00:00:00	2019-06-12	2019-06-12 00:00:00	32020		\N	286614	0	195662009	4112343		0
72781	4325	40481087	2010-06-23	2010-06-23 00:00:00	2010-07-07	2010-07-07 00:00:00	32020		\N	286926	0	444814009	40481087		0
83570	4967	378001	1964-05-13	1964-05-13 00:00:00	1964-07-12	1964-07-12 00:00:00	32020		\N	330153	0	62106007	378001		0
73160	4348	40481087	2019-01-07	2019-01-07 00:00:00	2019-01-28	2019-01-28 00:00:00	32020		\N	288380	0	444814009	40481087		0
73250	4353	80180	2008-01-09	2008-01-09 00:00:00	\N	\N	32020		\N	288790	0	396275006	80180		0
84016	4990	4237458	1967-03-29	1967-03-29 00:00:00	1967-06-27	1967-06-27 00:00:00	32020		\N	331968	0	58150001	4237458		0
73549	4372	80180	2017-10-16	2017-10-16 00:00:00	\N	\N	32020		\N	290210	0	396275006	80180		0
73865	4388	40481087	2002-04-28	2002-04-28 00:00:00	2002-05-19	2002-05-19 00:00:00	32020		\N	291663	0	444814009	40481087		0
74004	4395	40481087	1961-08-06	1961-08-06 00:00:00	1961-08-20	1961-08-20 00:00:00	32020		\N	292256	0	444814009	40481087		0
74177	4406	80180	1981-08-29	1981-08-29 00:00:00	\N	\N	32020		\N	292939	0	396275006	80180		0
84838	5046	4112343	1968-12-20	1968-12-20 00:00:00	1968-12-29	1968-12-29 00:00:00	32020		\N	335324	0	195662009	4112343		0
63899	3776	81151	2017-03-25	2017-03-25 00:00:00	2017-04-15	2017-04-15 00:00:00	32020		\N	250982	0	44465007	81151		0
74605	4432	260139	1970-03-11	1970-03-11 00:00:00	1970-03-18	1970-03-18 00:00:00	32020		\N	294587	0	10509002	260139		0
64176	3789	40481087	1962-06-08	1962-06-08 00:00:00	1962-06-29	1962-06-29 00:00:00	32020		\N	251873	0	444814009	40481087		0
64292	3796	317576	2018-11-20	2018-11-20 00:00:00	\N	\N	32020		\N	252366	0	53741008	317576		0
64438	3807	260139	1977-03-06	1977-03-06 00:00:00	1977-03-13	1977-03-13 00:00:00	32020		\N	252971	0	10509002	260139		0
64725	3827	40481087	1978-12-30	1978-12-30 00:00:00	1979-01-13	1979-01-13 00:00:00	32020		\N	254194	0	444814009	40481087		0
54260	3215	260139	1979-02-27	1979-02-27 00:00:00	1979-03-06	1979-03-06 00:00:00	32020		\N	213669	0	10509002	260139		0
64967	3841	40481087	2000-07-03	2000-07-03 00:00:00	2000-07-17	2000-07-17 00:00:00	32020		\N	255032	0	444814009	40481087		0
65094	3851	317576	1992-07-06	1992-07-06 00:00:00	\N	\N	32020		\N	255607	0	53741008	317576		0
65276	3860	81151	1985-02-05	1985-02-05 00:00:00	1985-03-05	1985-03-05 00:00:00	32020		\N	256337	0	44465007	81151		0
65467	3871	40481087	1967-08-24	1967-08-24 00:00:00	1967-09-07	1967-09-07 00:00:00	32020		\N	257008	0	444814009	40481087		0
76202	4521	4112343	1965-09-05	1965-09-05 00:00:00	1965-09-12	1965-09-12 00:00:00	32020		\N	301040	0	195662009	4112343		0
76373	4530	4134304	1988-07-07	1988-07-07 00:00:00	1988-09-05	1988-09-05 00:00:00	32020		\N	301620	0	263102004	4134304		0
65974	3901	4218389	1976-01-28	1976-01-28 00:00:00	1976-03-03	1976-03-03 00:00:00	32020		\N	259387	0	39848009	4218389		0
66163	3916	40481087	1987-01-26	1987-01-26 00:00:00	1987-02-09	1987-02-09 00:00:00	32020		\N	260253	0	444814009	40481087		0
66342	3927	81893	1979-08-18	1979-08-18 00:00:00	\N	\N	32020		\N	261094	0	64766004	81893		0
66441	3932	260139	2018-05-06	2018-05-06 00:00:00	2018-05-13	2018-05-13 00:00:00	32020		\N	261398	0	10509002	260139		0
77228	4574	372328	1968-04-03	1968-04-03 00:00:00	1968-04-17	1968-04-17 00:00:00	32020		\N	304698	0	65363002	372328		0
66858	3955	260139	1989-08-10	1989-08-10 00:00:00	1989-08-24	1989-08-24 00:00:00	32020		\N	262894	0	10509002	260139		0
66998	3961	40481087	1984-09-15	1984-09-15 00:00:00	1984-09-29	1984-09-29 00:00:00	32020		\N	263364	0	444814009	40481087		0
67142	3968	40481087	1948-05-02	1948-05-02 00:00:00	1948-05-16	1948-05-16 00:00:00	32020		\N	263831	0	444814009	40481087		0
77976	4621	4112343	1991-08-25	1991-08-25 00:00:00	1991-09-05	1991-09-05 00:00:00	32020		\N	307721	0	195662009	4112343		0
67509	3989	260139	1971-01-14	1971-01-14 00:00:00	1971-01-21	1971-01-21 00:00:00	32020		\N	265169	0	10509002	260139		0
67631	3996	40481087	1984-02-06	1984-02-06 00:00:00	1984-02-27	1984-02-27 00:00:00	32020		\N	265655	0	444814009	40481087		0
67780	4006	4134304	1997-12-09	1997-12-09 00:00:00	1998-02-07	1998-02-07 00:00:00	32020		\N	266145	0	263102004	4134304		0
68009	4018	80180	2001-08-08	2001-08-08 00:00:00	\N	\N	32020		\N	267055	0	396275006	80180		0
71800	4260	4027663	1967-12-29	1967-12-29 00:00:00	\N	\N	32020		\N	282774	0	13200003	4027663		0
68121	4022	40481087	2015-12-24	2015-12-24 00:00:00	2015-12-31	2015-12-31 00:00:00	32020		\N	267365	0	444814009	40481087		0
78859	4670	40481087	1973-02-21	1973-02-21 00:00:00	1973-02-28	1973-02-28 00:00:00	32020		\N	311161	0	444814009	40481087		0
68502	4051	78272	1993-10-08	1993-10-08 00:00:00	1993-10-29	1993-10-29 00:00:00	32020		\N	269262	0	70704007	78272		0
68714	4067	40481087	2002-08-29	2002-08-29 00:00:00	2002-09-12	2002-09-12 00:00:00	32020		\N	270204	0	444814009	40481087		0
68885	4077	4112343	1976-12-03	1976-12-03 00:00:00	1976-12-11	1976-12-11 00:00:00	32020		\N	270908	0	195662009	4112343		0
58406	3458	40481087	1987-12-03	1987-12-03 00:00:00	1987-12-10	1987-12-10 00:00:00	32020		\N	229470	0	444814009	40481087		0
69123	4090	4113008	2011-08-14	2011-08-14 00:00:00	2011-08-28	2011-08-28 00:00:00	32020		\N	271939	0	284549007	4113008		0
79877	4732	260139	1982-08-03	1982-08-03 00:00:00	1982-08-17	1982-08-17 00:00:00	32020		\N	315280	0	10509002	260139		0
58900	3494	4109685	1984-01-27	1984-01-27 00:00:00	1984-02-10	1984-02-10 00:00:00	32020		\N	231766	0	284551006	4109685		0
69555	4116	81151	1980-06-21	1980-06-21 00:00:00	1980-07-12	1980-07-12 00:00:00	32020		\N	273675	0	44465007	81151		0
69875	4134	81151	1953-05-13	1953-05-13 00:00:00	1953-05-27	1953-05-27 00:00:00	32020		\N	274817	0	44465007	81151		0
80609	4777	4112343	1964-07-29	1964-07-29 00:00:00	1964-08-10	1964-08-10 00:00:00	32020		\N	318057	0	195662009	4112343		0
59583	3531	4112343	1981-09-07	1981-09-07 00:00:00	1981-09-16	1981-09-16 00:00:00	32020		\N	234541	0	195662009	4112343		0
70355	4167	80180	2015-11-30	2015-11-30 00:00:00	\N	\N	32020		\N	276917	0	396275006	80180		0
81097	4811	40481087	1995-11-11	1995-11-11 00:00:00	1995-11-25	1995-11-25 00:00:00	32020		\N	320017	0	444814009	40481087		0
81214	4816	4059173	1997-03-09	1997-03-09 00:00:00	1997-06-07	1997-06-07 00:00:00	32020		\N	320433	0	16114001	4059173		0
70813	4202	40481087	1981-01-12	1981-01-12 00:00:00	1981-02-02	1981-02-02 00:00:00	32020		\N	278966	0	444814009	40481087		0
70932	4208	440086	1952-11-18	1952-11-18 00:00:00	1956-11-27	1956-11-27 00:00:00	32020		\N	279444	0	192127007	440086		0
60546	3580	372328	1983-05-22	1983-05-22 00:00:00	1983-12-02	1983-12-02 00:00:00	32020		\N	238010	0	65363002	372328		0
71284	4227	80180	1988-06-29	1988-06-29 00:00:00	\N	\N	32020		\N	280782	0	396275006	80180		0
71424	4238	4112343	1993-06-23	1993-06-23 00:00:00	1993-07-05	1993-07-05 00:00:00	32020		\N	281418	0	195662009	4112343		0
71675	4250	260139	1980-07-03	1980-07-03 00:00:00	1980-07-10	1980-07-10 00:00:00	32020		\N	282287	0	10509002	260139		0
71748	4256	4134304	1961-04-21	1961-04-21 00:00:00	1961-06-20	1961-06-20 00:00:00	32020		\N	282588	0	263102004	4134304		0
71922	4268	40481087	1957-07-12	1957-07-12 00:00:00	1957-08-02	1957-08-02 00:00:00	32020		\N	283274	0	444814009	40481087		0
72057	4276	40481087	1979-12-28	1979-12-28 00:00:00	1980-01-18	1980-01-18 00:00:00	32020		\N	283741	0	444814009	40481087		0
61742	3647	260139	1963-06-11	1963-06-11 00:00:00	1963-06-25	1963-06-25 00:00:00	32020		\N	242621	0	10509002	260139		0
72539	4308	28060	1916-12-29	1916-12-29 00:00:00	1917-01-05	1917-01-05 00:00:00	32020		\N	285732	0	43878008	28060		0
72688	4319	78272	1986-04-15	1986-04-15 00:00:00	1986-05-20	1986-05-20 00:00:00	32020		\N	286582	0	70704007	78272		0
72782	4325	40481087	1972-08-09	1972-08-09 00:00:00	1972-08-23	1972-08-23 00:00:00	32020		\N	286886	0	444814009	40481087		0
83571	4967	4112343	1961-12-27	1961-12-27 00:00:00	1962-01-09	1962-01-09 00:00:00	32020		\N	330133	0	195662009	4112343		0
73161	4348	4112343	2007-07-11	2007-07-11 00:00:00	2007-07-21	2007-07-21 00:00:00	32020		\N	288311	0	195662009	4112343		0
73251	4353	260139	1991-11-26	1991-11-26 00:00:00	1991-12-03	1991-12-03 00:00:00	32020		\N	288784	0	10509002	260139		0
84017	4990	260139	1975-04-09	1975-04-09 00:00:00	1975-04-23	1975-04-23 00:00:00	32020		\N	331961	0	10509002	260139		0
73550	4373	4048171	1979-01-12	1979-01-12 00:00:00	\N	\N	32020		\N	290375	0	232353008	4048171		0
73866	4388	40481087	2019-04-22	2019-04-22 00:00:00	2019-04-29	2019-04-29 00:00:00	32020		\N	291664	0	444814009	40481087		0
74005	4395	40481087	1965-11-02	1965-11-02 00:00:00	1965-11-23	1965-11-23 00:00:00	32020		\N	292257	0	444814009	40481087		0
74178	4406	260139	1969-11-27	1969-11-27 00:00:00	1969-12-04	1969-12-04 00:00:00	32020		\N	292895	0	10509002	260139		0
84839	5046	40481087	1991-10-27	1991-10-27 00:00:00	1991-11-02	1991-11-02 00:00:00	32020		\N	335306	0	444814009	40481087		0
63900	3776	4278672	1987-03-21	1987-03-21 00:00:00	1987-06-19	1987-06-19 00:00:00	32020		\N	250978	0	65966004	4278672		0
74606	4432	81151	2014-06-27	2014-06-27 00:00:00	2014-07-25	2014-07-25 00:00:00	32020		\N	294586	0	44465007	81151		0
64177	3790	4112343	1983-09-29	1983-09-29 00:00:00	1983-10-06	1983-10-06 00:00:00	32020		\N	252002	0	195662009	4112343		0
64293	3796	80180	2007-05-23	2007-05-23 00:00:00	\N	\N	32020		\N	252359	0	396275006	80180		0
64439	3807	4112343	1966-12-20	1966-12-20 00:00:00	1967-01-02	1967-01-02 00:00:00	32020		\N	252978	0	195662009	4112343		0
64726	3827	260139	1963-10-06	1963-10-06 00:00:00	1963-10-20	1963-10-20 00:00:00	32020		\N	254158	0	10509002	260139		0
54261	3215	4112343	1992-12-16	1992-12-16 00:00:00	1992-12-23	1992-12-23 00:00:00	32020		\N	213681	0	195662009	4112343		0
64968	3841	40481087	2018-03-10	2018-03-10 00:00:00	2018-03-31	2018-03-31 00:00:00	32020		\N	255034	0	444814009	40481087		0
65095	3851	260139	1918-12-22	1918-12-22 00:00:00	1918-12-29	1918-12-29 00:00:00	32020		\N	255573	0	10509002	260139		0
65277	3860	81151	1985-12-30	1985-12-30 00:00:00	1986-02-03	1986-02-03 00:00:00	32020		\N	256338	0	44465007	81151		0
65468	3871	440086	1969-09-10	1969-09-10 00:00:00	1980-09-17	1980-09-17 00:00:00	32020		\N	257035	0	192127007	440086		0
76203	4521	4112343	1991-09-23	1991-09-23 00:00:00	1991-10-06	1991-10-06 00:00:00	32020		\N	300967	0	195662009	4112343		0
76374	4530	40481087	2010-01-12	2010-01-12 00:00:00	2010-02-02	2010-02-02 00:00:00	32020		\N	301633	0	444814009	40481087		0
65975	3901	40481087	2004-02-28	2004-02-28 00:00:00	2004-03-13	2004-03-13 00:00:00	32020		\N	259448	0	444814009	40481087		0
66164	3916	440086	1989-10-01	1989-10-01 00:00:00	1989-12-31	1989-12-31 00:00:00	32020		\N	260280	0	192127007	440086		0
66343	3927	4266809	1981-02-08	1981-02-08 00:00:00	\N	\N	32020		\N	261094	0	397881000	4266809		0
66442	3932	28060	1995-12-08	1995-12-08 00:00:00	1995-12-20	1995-12-20 00:00:00	32020		\N	261404	0	43878008	28060		0
77231	4576	260139	1955-10-23	1955-10-23 00:00:00	1955-10-30	1955-10-30 00:00:00	32020		\N	304852	0	10509002	260139		0
66859	3955	40481087	2004-05-28	2004-05-28 00:00:00	2004-06-04	2004-06-04 00:00:00	32020		\N	262871	0	444814009	40481087		0
66999	3961	192671	2011-11-24	2011-11-24 00:00:00	\N	\N	32020		\N	263349	0	K92.2	35208414		0
67143	3968	80180	1950-07-18	1950-07-18 00:00:00	\N	\N	32020		\N	263831	0	396275006	80180		0
77977	4621	4156265	1978-04-17	1978-04-17 00:00:00	1978-05-01	1978-05-01 00:00:00	32020		\N	307741	0	370247008	4156265		0
67510	3989	4112343	1951-04-21	1951-04-21 00:00:00	1951-04-29	1951-04-29 00:00:00	32020		\N	265254	0	195662009	4112343		0
67632	3996	4112343	2012-02-15	2012-02-15 00:00:00	2012-02-25	2012-02-25 00:00:00	32020		\N	265668	0	195662009	4112343		0
67781	4006	260139	1952-07-23	1952-07-23 00:00:00	1952-08-06	1952-08-06 00:00:00	32020		\N	266136	0	10509002	260139		0
68010	4018	260139	2005-07-12	2005-07-12 00:00:00	2005-07-26	2005-07-26 00:00:00	32020		\N	267060	0	10509002	260139		0
68122	4022	4116491	1977-07-13	1977-07-13 00:00:00	1977-08-20	1977-08-20 00:00:00	32020		\N	267397	0	301011002	4116491		0
78860	4670	40481087	1961-08-23	1961-08-23 00:00:00	1961-08-30	1961-08-30 00:00:00	32020		\N	311202	0	444814009	40481087		0
68503	4051	80180	2009-09-29	2009-09-29 00:00:00	\N	\N	32020		\N	269283	0	396275006	80180		0
68715	4067	4112343	1981-06-20	1981-06-20 00:00:00	1981-07-02	1981-07-02 00:00:00	32020		\N	270250	0	195662009	4112343		0
68886	4077	260139	2013-07-16	2013-07-16 00:00:00	2013-07-31	2013-07-31 00:00:00	32020		\N	270888	0	10509002	260139		0
68891	4078	4112343	1964-01-17	1964-01-17 00:00:00	1964-01-25	1964-01-25 00:00:00	32020		\N	270976	0	195662009	4112343		0
69124	4090	40481087	1975-07-01	1975-07-01 00:00:00	1975-07-08	1975-07-08 00:00:00	32020		\N	271839	0	444814009	40481087		0
79904	4735	40481087	1975-08-30	1975-08-30 00:00:00	1975-09-20	1975-09-20 00:00:00	32020		\N	315412	0	444814009	40481087		0
58901	3494	4112343	1962-02-22	1962-02-22 00:00:00	1962-03-04	1962-03-04 00:00:00	32020		\N	231770	0	195662009	4112343		0
69556	4116	4218389	2004-07-27	2004-07-27 00:00:00	2004-08-17	2004-08-17 00:00:00	32020		\N	273678	0	39848009	4218389		0
69876	4134	260139	2017-06-13	2017-06-13 00:00:00	2017-06-20	2017-06-20 00:00:00	32020		\N	274864	0	10509002	260139		0
80610	4777	4109685	1979-09-04	1979-09-04 00:00:00	1979-09-25	1979-09-25 00:00:00	32020		\N	318096	0	284551006	4109685		0
59584	3531	260139	1987-05-30	1987-05-30 00:00:00	1987-06-13	1987-06-13 00:00:00	32020		\N	234569	0	10509002	260139		0
70356	4167	4285898	2015-06-03	2015-06-03 00:00:00	\N	\N	32020		\N	276917	0	68496003	4285898		0
81098	4811	440448	1995-04-10	1995-04-10 00:00:00	\N	\N	32020		\N	320052	0	74400008	440448		0
81215	4816	372328	1983-06-02	1983-06-02 00:00:00	1983-10-17	1983-10-17 00:00:00	32020		\N	320385	0	65363002	372328		0
70814	4202	40481087	2003-05-12	2003-05-12 00:00:00	2003-05-26	2003-05-26 00:00:00	32020		\N	278968	0	444814009	40481087		0
70933	4208	4112343	1962-04-03	1962-04-03 00:00:00	1962-04-11	1962-04-11 00:00:00	32020		\N	279432	0	195662009	4112343		0
60547	3580	81151	1990-05-10	1990-05-10 00:00:00	1990-05-31	1990-05-31 00:00:00	32020		\N	237967	0	44465007	81151		0
71285	4227	40481087	2005-09-15	2005-09-15 00:00:00	2005-09-22	2005-09-22 00:00:00	32020		\N	280855	0	444814009	40481087		0
71425	4238	4116491	1992-08-23	1992-08-23 00:00:00	1992-10-12	1992-10-12 00:00:00	32020		\N	281389	0	301011002	4116491		0
71676	4250	260139	1947-11-20	1947-11-20 00:00:00	1947-11-27	1947-11-27 00:00:00	32020		\N	282285	0	10509002	260139		0
71749	4256	4112343	1961-11-01	1961-11-01 00:00:00	1961-11-14	1961-11-14 00:00:00	32020		\N	282608	0	195662009	4112343		0
71923	4268	40481087	1978-09-16	1978-09-16 00:00:00	1978-10-07	1978-10-07 00:00:00	32020		\N	283245	0	444814009	40481087		0
72058	4276	4112343	1977-07-30	1977-07-30 00:00:00	1977-08-06	1977-08-06 00:00:00	32020		\N	283760	0	195662009	4112343		0
61743	3647	4112343	1946-08-22	1946-08-22 00:00:00	1946-09-03	1946-09-03 00:00:00	32020		\N	242619	0	195662009	4112343		0
72540	4308	40481087	1916-05-09	1916-05-09 00:00:00	1916-05-23	1916-05-23 00:00:00	32020		\N	285739	0	444814009	40481087		0
72689	4319	4155034	1982-09-12	1982-09-12 00:00:00	1982-10-03	1982-10-03 00:00:00	32020		\N	286581	0	283371005	4155034		0
72783	4325	4283893	1980-06-17	1980-06-17 00:00:00	1980-08-12	1980-08-12 00:00:00	32020		\N	286880	0	36971009	4283893		0
83572	4967	4112343	1971-11-16	1971-11-16 00:00:00	1971-11-28	1971-11-28 00:00:00	32020		\N	330138	0	195662009	4112343		0
73162	4348	40481087	1990-04-26	1990-04-26 00:00:00	1990-05-17	1990-05-17 00:00:00	32020		\N	288343	0	444814009	40481087		0
73252	4353	40481087	2004-09-26	2004-09-26 00:00:00	2004-10-17	2004-10-17 00:00:00	32020		\N	288833	0	444814009	40481087		0
84018	4990	4237458	1979-12-21	1979-12-21 00:00:00	1980-03-20	1980-03-20 00:00:00	32020		\N	331970	0	58150001	4237458		0
73551	4373	4112343	1978-06-09	1978-06-09 00:00:00	1978-06-19	1978-06-19 00:00:00	32020		\N	290413	0	195662009	4112343		0
73867	4388	28060	1975-02-28	1975-02-28 00:00:00	1975-03-10	1975-03-10 00:00:00	32020		\N	291690	0	43878008	28060		0
74006	4395	4059173	1949-10-26	1949-10-26 00:00:00	1949-12-25	1949-12-25 00:00:00	32020		\N	292236	0	16114001	4059173		0
74179	4406	40481087	1945-07-22	1945-07-22 00:00:00	1945-08-05	1945-08-05 00:00:00	32020		\N	292871	0	444814009	40481087		0
84840	5046	4285898	1995-03-25	1995-03-25 00:00:00	\N	\N	32020		\N	335311	0	68496003	4285898		0
63901	3776	4112343	2014-08-28	2014-08-28 00:00:00	2014-09-04	2014-09-04 00:00:00	32020		\N	250989	0	195662009	4112343		0
74607	4432	4294548	1990-07-05	1990-07-05 00:00:00	1990-09-06	1990-09-06 00:00:00	32020		\N	294568	0	75498004	4294548		0
64178	3790	40481087	1969-09-06	1969-09-06 00:00:00	1969-09-20	1969-09-20 00:00:00	32020		\N	252019	0	444814009	40481087		0
64294	3796	4218389	2006-08-10	2006-08-10 00:00:00	2006-08-31	2006-08-31 00:00:00	32020		\N	252359	0	39848009	4218389		0
64440	3807	40481087	2006-04-18	2006-04-18 00:00:00	2006-05-09	2006-05-09 00:00:00	32020		\N	252999	0	444814009	40481087		0
64727	3827	372328	1960-10-03	1960-10-03 00:00:00	1960-10-28	1960-10-28 00:00:00	32020		\N	254177	0	65363002	372328		0
54262	3215	40481087	2015-11-28	2015-11-28 00:00:00	2015-12-19	2015-12-19 00:00:00	32020		\N	213643	0	444814009	40481087		0
64969	3841	4112343	2018-09-25	2018-09-25 00:00:00	2018-10-04	2018-10-04 00:00:00	32020		\N	255035	0	195662009	4112343		0
65096	3851	4112343	1950-10-29	1950-10-29 00:00:00	1950-11-10	1950-11-10 00:00:00	32020		\N	255597	0	195662009	4112343		0
65278	3860	40481087	1977-11-15	1977-11-15 00:00:00	1977-11-22	1977-11-22 00:00:00	32020		\N	256289	0	444814009	40481087		0
65469	3871	40481087	2004-01-02	2004-01-02 00:00:00	2004-01-23	2004-01-23 00:00:00	32020		\N	257037	0	444814009	40481087		0
76204	4521	40481087	2006-05-14	2006-05-14 00:00:00	2006-06-04	2006-06-04 00:00:00	32020		\N	300987	0	444814009	40481087		0
76375	4530	40481087	1981-11-09	1981-11-09 00:00:00	1981-11-23	1981-11-23 00:00:00	32020		\N	301635	0	444814009	40481087		0
65976	3901	260139	1962-04-12	1962-04-12 00:00:00	1962-04-19	1962-04-19 00:00:00	32020		\N	259416	0	10509002	260139		0
66165	3916	4112343	1983-05-18	1983-05-18 00:00:00	1983-05-28	1983-05-28 00:00:00	32020		\N	260256	0	195662009	4112343		0
66344	3927	4218389	2013-12-13	2013-12-13 00:00:00	2014-01-17	2014-01-17 00:00:00	32020		\N	261038	0	39848009	4218389		0
66443	3932	40481087	2006-08-27	2006-08-27 00:00:00	2006-09-17	2006-09-17 00:00:00	32020		\N	261354	0	444814009	40481087		0
77232	4576	4112343	1991-11-28	1991-11-28 00:00:00	1991-12-05	1991-12-05 00:00:00	32020		\N	304853	0	195662009	4112343		0
66860	3955	40481087	1957-07-22	1957-07-22 00:00:00	1957-08-05	1957-08-05 00:00:00	32020		\N	262845	0	444814009	40481087		0
67000	3961	260139	1973-03-09	1973-03-09 00:00:00	1973-03-16	1973-03-16 00:00:00	32020		\N	263368	0	10509002	260139		0
67144	3968	260139	2007-05-21	2007-05-21 00:00:00	2007-05-28	2007-05-28 00:00:00	32020		\N	263855	0	10509002	260139		0
77978	4621	4112343	1995-03-20	1995-03-20 00:00:00	1995-03-27	1995-03-27 00:00:00	32020		\N	307770	0	195662009	4112343		0
67511	3989	40481087	1961-03-21	1961-03-21 00:00:00	1961-04-04	1961-04-04 00:00:00	32020		\N	265167	0	444814009	40481087		0
67633	3996	317576	2003-02-25	2003-02-25 00:00:00	\N	\N	32020		\N	265643	0	53741008	317576		0
67782	4006	257012	1971-05-01	1971-05-01 00:00:00	\N	\N	32020		\N	266160	0	40055000	257012		0
68011	4018	372328	1964-06-23	1964-06-23 00:00:00	1964-08-04	1964-08-04 00:00:00	32020		\N	267108	0	65363002	372328		0
68123	4022	4155034	1993-03-26	1993-03-26 00:00:00	1993-04-09	1993-04-09 00:00:00	32020		\N	267386	0	283371005	4155034		0
78861	4670	4116491	1990-03-22	1990-03-22 00:00:00	1990-05-22	1990-05-22 00:00:00	32020		\N	311194	0	301011002	4116491		0
68504	4051	40481087	1980-10-30	1980-10-30 00:00:00	1980-11-20	1980-11-20 00:00:00	32020		\N	269234	0	444814009	40481087		0
68716	4067	4112343	2005-08-09	2005-08-09 00:00:00	2005-08-21	2005-08-21 00:00:00	32020		\N	270205	0	195662009	4112343		0
68887	4077	81151	2012-02-26	2012-02-26 00:00:00	2012-04-01	2012-04-01 00:00:00	32020		\N	270888	0	44465007	81151		0
68892	4078	260139	1967-09-12	1967-09-12 00:00:00	1967-09-19	1967-09-19 00:00:00	32020		\N	270950	0	10509002	260139		0
69125	4090	40479768	1955-01-14	1955-01-14 00:00:00	1955-03-22	1955-03-22 00:00:00	32020		\N	271933	0	444470001	40479768		0
79905	4735	372328	1973-11-30	1973-11-30 00:00:00	1974-03-14	1974-03-14 00:00:00	32020		\N	315445	0	65363002	372328		0
58902	3494	260139	2003-07-03	2003-07-03 00:00:00	2003-07-17	2003-07-17 00:00:00	32020		\N	231782	0	10509002	260139		0
69557	4116	28060	2002-11-12	2002-11-12 00:00:00	2002-11-25	2002-11-25 00:00:00	32020		\N	273631	0	43878008	28060		0
69877	4134	4112343	2000-11-12	2000-11-12 00:00:00	2000-11-19	2000-11-19 00:00:00	32020		\N	274832	0	195662009	4112343		0
80611	4777	260139	1990-10-18	1990-10-18 00:00:00	1990-11-01	1990-11-01 00:00:00	32020		\N	318085	0	10509002	260139		0
59585	3532	81151	1994-06-06	1994-06-06 00:00:00	1994-06-27	1994-06-27 00:00:00	32020		\N	234630	0	44465007	81151		0
70357	4167	378001	1999-07-16	1999-07-16 00:00:00	1999-08-15	1999-08-15 00:00:00	32020		\N	277000	0	62106007	378001		0
81099	4811	260139	2002-10-31	2002-10-31 00:00:00	2002-11-14	2002-11-14 00:00:00	32020		\N	320076	0	10509002	260139		0
81216	4816	40481087	2019-03-29	2019-03-29 00:00:00	2019-04-12	2019-04-12 00:00:00	32020		\N	320384	0	444814009	40481087		0
70815	4202	80180	2009-01-20	2009-01-20 00:00:00	\N	\N	32020		\N	278936	0	396275006	80180		0
70934	4208	4310024	1977-08-09	1977-08-09 00:00:00	\N	\N	32020		\N	279455	0	424802006	4310024		0
60548	3580	4112343	2015-10-17	2015-10-17 00:00:00	2015-10-25	2015-10-25 00:00:00	32020		\N	238008	0	195662009	4112343		0
71286	4227	372328	1960-10-20	1960-10-20 00:00:00	1961-01-29	1961-01-29 00:00:00	32020		\N	280850	0	65363002	372328		0
71426	4238	40481087	1966-11-08	1966-11-08 00:00:00	1966-11-22	1966-11-22 00:00:00	32020		\N	281401	0	444814009	40481087		0
71690	4253	28060	1996-06-30	1996-06-30 00:00:00	1996-07-08	1996-07-08 00:00:00	32020		\N	282447	0	43878008	28060		0
71750	4256	81893	1991-02-18	1991-02-18 00:00:00	\N	\N	32020		\N	282641	0	64766004	81893		0
71924	4268	78272	1994-12-21	1994-12-21 00:00:00	1995-01-18	1995-01-18 00:00:00	32020		\N	283212	0	70704007	78272		0
72059	4276	260139	1953-01-25	1953-01-25 00:00:00	1953-02-01	1953-02-01 00:00:00	32020		\N	283758	0	10509002	260139		0
61744	3647	4112343	1978-02-20	1978-02-20 00:00:00	1978-03-02	1978-03-02 00:00:00	32020		\N	242718	0	195662009	4112343		0
72541	4308	40481087	1987-08-20	1987-08-20 00:00:00	1987-08-27	1987-08-27 00:00:00	32020		\N	285828	0	444814009	40481087		0
72690	4319	80180	2012-07-21	2012-07-21 00:00:00	\N	\N	32020		\N	286627	0	396275006	80180		0
72784	4325	4112343	1979-08-01	1979-08-01 00:00:00	1979-08-14	1979-08-14 00:00:00	32020		\N	286887	0	195662009	4112343		0
83573	4967	4134304	1982-07-08	1982-07-08 00:00:00	1982-10-06	1982-10-06 00:00:00	32020		\N	330154	0	263102004	4134304		0
73163	4348	80180	2015-01-01	2015-01-01 00:00:00	\N	\N	32020		\N	288359	0	396275006	80180		0
73253	4353	40481087	2012-04-15	2012-04-15 00:00:00	2012-04-29	2012-04-29 00:00:00	32020		\N	288766	0	444814009	40481087		0
84019	4990	40481087	1980-08-31	1980-08-31 00:00:00	1980-09-14	1980-09-14 00:00:00	32020		\N	332000	0	444814009	40481087		0
73552	4373	372328	1978-10-06	1978-10-06 00:00:00	1978-12-12	1978-12-12 00:00:00	32020		\N	290398	0	65363002	372328		0
73868	4388	40481087	1998-02-20	1998-02-20 00:00:00	1998-03-13	1998-03-13 00:00:00	32020		\N	291740	0	444814009	40481087		0
74007	4395	40481087	1977-06-14	1977-06-14 00:00:00	1977-07-05	1977-07-05 00:00:00	32020		\N	292223	0	444814009	40481087		0
74180	4406	4112343	1998-08-29	1998-08-29 00:00:00	1998-09-05	1998-09-05 00:00:00	32020		\N	292866	0	195662009	4112343		0
84841	5046	4266809	1995-09-22	1995-09-22 00:00:00	\N	\N	32020		\N	335311	0	397881000	4266809		0
63902	3776	28060	1979-12-29	1979-12-29 00:00:00	1980-01-05	1980-01-05 00:00:00	32020		\N	250983	0	43878008	28060		0
74608	4432	40481087	1977-11-21	1977-11-21 00:00:00	1977-12-05	1977-12-05 00:00:00	32020		\N	294588	0	444814009	40481087		0
64179	3790	40481087	1989-04-05	1989-04-05 00:00:00	1989-04-19	1989-04-19 00:00:00	32020		\N	251998	0	444814009	40481087		0
64295	3796	40481087	2005-08-28	2005-08-28 00:00:00	2005-09-18	2005-09-18 00:00:00	32020		\N	252393	0	444814009	40481087		0
64441	3807	372328	1949-08-23	1949-08-23 00:00:00	1950-02-25	1950-02-25 00:00:00	32020		\N	252980	0	65363002	372328		0
64728	3827	40481087	1996-03-20	1996-03-20 00:00:00	1996-03-27	1996-03-27 00:00:00	32020		\N	254160	0	444814009	40481087		0
54263	3215	40481087	1996-06-01	1996-06-01 00:00:00	1996-06-15	1996-06-15 00:00:00	32020		\N	213629	0	444814009	40481087		0
64970	3841	260139	1975-04-13	1975-04-13 00:00:00	1975-04-20	1975-04-20 00:00:00	32020		\N	255021	0	10509002	260139		0
65097	3851	40481087	1989-11-08	1989-11-08 00:00:00	1989-11-15	1989-11-15 00:00:00	32020		\N	255511	0	444814009	40481087		0
65279	3860	28060	1986-09-04	1986-09-04 00:00:00	1986-09-17	1986-09-17 00:00:00	32020		\N	256281	0	43878008	28060		0
65470	3871	40481087	1976-08-25	1976-08-25 00:00:00	1976-09-01	1976-09-01 00:00:00	32020		\N	257019	0	444814009	40481087		0
76205	4521	4112343	1987-02-23	1987-02-23 00:00:00	1987-03-07	1987-03-07 00:00:00	32020		\N	300966	0	195662009	4112343		0
76376	4530	40481087	1968-12-23	1968-12-23 00:00:00	1968-12-30	1968-12-30 00:00:00	32020		\N	301664	0	444814009	40481087		0
65977	3901	78272	1939-01-02	1939-01-02 00:00:00	1939-01-16	1939-01-16 00:00:00	32020		\N	259383	0	70704007	78272		0
66166	3916	4112343	2019-04-04	2019-04-04 00:00:00	2019-04-13	2019-04-13 00:00:00	32020		\N	260302	0	195662009	4112343		0
66345	3927	40481087	1986-05-09	1986-05-09 00:00:00	1986-05-30	1986-05-30 00:00:00	32020		\N	261100	0	444814009	40481087		0
66444	3932	4294548	1980-12-24	1980-12-24 00:00:00	1981-01-07	1981-01-07 00:00:00	32020		\N	261402	0	75498004	4294548		0
77233	4576	40481087	2007-04-13	2007-04-13 00:00:00	2007-04-27	2007-04-27 00:00:00	32020		\N	304788	0	444814009	40481087		0
66861	3956	440448	1952-10-30	1952-10-30 00:00:00	\N	\N	32020		\N	262905	0	74400008	440448		0
67001	3961	4109685	1975-10-31	1975-10-31 00:00:00	1975-11-21	1975-11-21 00:00:00	32020		\N	263351	0	284551006	4109685		0
67145	3968	260139	1965-02-19	1965-02-19 00:00:00	1965-02-26	1965-02-26 00:00:00	32020		\N	263899	0	10509002	260139		0
77979	4621	4112343	1979-10-12	1979-10-12 00:00:00	1979-10-25	1979-10-25 00:00:00	32020		\N	307746	0	195662009	4112343		0
67512	3989	40481087	1997-03-13	1997-03-13 00:00:00	1997-03-20	1997-03-20 00:00:00	32020		\N	265161	0	444814009	40481087		0
67634	3996	4266809	2003-02-27	2003-02-27 00:00:00	\N	\N	32020		\N	265643	0	397881000	4266809		0
67783	4006	381316	2016-08-02	2016-08-02 00:00:00	\N	\N	32020		\N	266192	0	230690007	381316		0
68012	4018	40481087	2011-06-05	2011-06-05 00:00:00	2011-06-12	2011-06-12 00:00:00	32020		\N	267056	0	444814009	40481087		0
68124	4022	40481087	1964-12-22	1964-12-22 00:00:00	1964-12-29	1964-12-29 00:00:00	32020		\N	267388	0	444814009	40481087		0
78862	4670	40481087	1958-08-13	1958-08-13 00:00:00	1958-09-03	1958-09-03 00:00:00	32020		\N	311226	0	444814009	40481087		0
68505	4051	40481087	1978-03-02	1978-03-02 00:00:00	1978-03-09	1978-03-09 00:00:00	32020		\N	269264	0	444814009	40481087		0
68717	4067	80180	2007-07-01	2007-07-01 00:00:00	\N	\N	32020		\N	270205	0	396275006	80180		0
68888	4077	40481087	1995-07-04	1995-07-04 00:00:00	1995-07-11	1995-07-11 00:00:00	32020		\N	270913	0	444814009	40481087		0
68893	4078	4112343	1963-09-06	1963-09-06 00:00:00	1963-09-18	1963-09-18 00:00:00	32020		\N	271056	0	195662009	4112343		0
69126	4090	40481087	1993-03-10	1993-03-10 00:00:00	1993-03-31	1993-03-31 00:00:00	32020		\N	271916	0	444814009	40481087		0
79906	4735	4112343	1990-12-30	1990-12-30 00:00:00	1991-01-10	1991-01-10 00:00:00	32020		\N	315442	0	195662009	4112343		0
58903	3494	260139	1968-03-22	1968-03-22 00:00:00	1968-03-29	1968-03-29 00:00:00	32020		\N	231740	0	10509002	260139		0
69558	4116	4027663	2002-10-09	2002-10-09 00:00:00	\N	\N	32020		\N	273630	0	13200003	4027663		0
69878	4134	81151	1955-06-16	1955-06-16 00:00:00	1955-07-21	1955-07-21 00:00:00	32020		\N	274818	0	44465007	81151		0
80638	4781	40481087	2011-04-30	2011-04-30 00:00:00	2011-05-07	2011-05-07 00:00:00	32020		\N	318280	0	444814009	40481087		0
59586	3532	378001	2003-10-08	2003-10-08 00:00:00	2003-11-07	2003-11-07 00:00:00	32020		\N	234631	0	62106007	378001		0
70358	4167	372328	1981-05-21	1981-05-21 00:00:00	1981-08-26	1981-08-26 00:00:00	32020		\N	276988	0	65363002	372328		0
81100	4811	40481087	1973-05-26	1973-05-26 00:00:00	1973-06-02	1973-06-02 00:00:00	32020		\N	320066	0	444814009	40481087		0
81217	4816	4299128	1999-03-29	1999-03-29 00:00:00	1999-05-03	1999-05-03 00:00:00	32020		\N	320434	0	403192003	4299128		0
70816	4202	4112343	2008-11-02	2008-11-02 00:00:00	2008-11-15	2008-11-15 00:00:00	32020		\N	278936	0	195662009	4112343		0
70935	4208	40481087	1977-10-02	1977-10-02 00:00:00	1977-10-09	1977-10-09 00:00:00	32020		\N	279433	0	444814009	40481087		0
60549	3580	40481087	1996-12-29	1996-12-29 00:00:00	1997-01-12	1997-01-12 00:00:00	32020		\N	237998	0	444814009	40481087		0
71287	4227	4112343	1978-07-08	1978-07-08 00:00:00	1978-07-20	1978-07-20 00:00:00	32020		\N	280781	0	195662009	4112343		0
71427	4238	4112343	1997-04-19	1997-04-19 00:00:00	1997-05-01	1997-05-01 00:00:00	32020		\N	281390	0	195662009	4112343		0
64211	3791	80180	1947-10-10	1947-10-10 00:00:00	\N	\N	32020		\N	252142	0	396275006	80180		0
71691	4253	4283893	2010-08-06	2010-08-06 00:00:00	2010-11-11	2010-11-11 00:00:00	32020		\N	282459	0	36971009	4283893		0
71751	4256	4310024	1990-07-23	1990-07-23 00:00:00	\N	\N	32020		\N	282641	0	424802006	4310024		0
71925	4268	40479422	1970-04-26	1970-04-26 00:00:00	1970-07-02	1970-07-02 00:00:00	32020		\N	283209	0	444448004	40479422		0
72060	4276	4142905	2005-05-21	2005-05-21 00:00:00	2005-07-20	2005-07-20 00:00:00	32020		\N	283772	0	33737001	4142905		0
61745	3647	28060	1940-08-05	1940-08-05 00:00:00	1940-08-13	1940-08-13 00:00:00	32020		\N	242595	0	43878008	28060		0
72542	4308	40481087	1962-02-08	1962-02-08 00:00:00	1962-02-15	1962-02-15 00:00:00	32020		\N	285752	0	444814009	40481087		0
72691	4319	81151	2013-04-19	2013-04-19 00:00:00	2013-05-03	2013-05-03 00:00:00	32020		\N	286585	0	44465007	81151		0
72785	4325	40481087	1967-08-15	1967-08-15 00:00:00	1967-08-29	1967-08-29 00:00:00	32020		\N	286934	0	444814009	40481087		0
83574	4967	372328	1961-06-28	1961-06-28 00:00:00	1961-09-04	1961-09-04 00:00:00	32020		\N	330166	0	65363002	372328		0
73164	4348	4113008	1995-11-07	1995-11-07 00:00:00	1995-11-28	1995-11-28 00:00:00	32020		\N	288326	0	284549007	4113008		0
73254	4353	40479768	1972-11-03	1972-11-03 00:00:00	1972-12-10	1972-12-10 00:00:00	32020		\N	288786	0	444470001	40479768		0
84020	4990	40481087	1964-01-22	1964-01-22 00:00:00	1964-01-29	1964-01-29 00:00:00	32020		\N	332008	0	444814009	40481087		0
73553	4373	4296205	1976-11-01	1976-11-01 00:00:00	1976-12-06	1976-12-06 00:00:00	32020		\N	290373	0	403191005	4296205		0
73869	4388	40481087	1985-11-06	1985-11-06 00:00:00	1985-11-27	1985-11-27 00:00:00	32020		\N	291694	0	444814009	40481087		0
74008	4395	40481087	1970-08-06	1970-08-06 00:00:00	1970-08-13	1970-08-13 00:00:00	32020		\N	292258	0	444814009	40481087		0
74181	4406	372328	1942-04-21	1942-04-21 00:00:00	1942-08-01	1942-08-01 00:00:00	32020		\N	292908	0	65363002	372328		0
84842	5046	80180	1995-09-22	1995-09-22 00:00:00	\N	\N	32020		\N	335311	0	396275006	80180		0
63903	3776	4113008	1994-12-30	1994-12-30 00:00:00	1995-01-13	1995-01-13 00:00:00	32020		\N	250980	0	284549007	4113008		0
74609	4432	4112343	1959-10-01	1959-10-01 00:00:00	1959-10-11	1959-10-11 00:00:00	32020		\N	294611	0	195662009	4112343		0
64180	3790	260139	1981-03-29	1981-03-29 00:00:00	1981-04-05	1981-04-05 00:00:00	32020		\N	252021	0	10509002	260139		0
64296	3796	4112343	1969-09-05	1969-09-05 00:00:00	1969-09-12	1969-09-12 00:00:00	32020		\N	252367	0	195662009	4112343		0
64442	3807	28060	1953-07-04	1953-07-04 00:00:00	1953-07-14	1953-07-14 00:00:00	32020		\N	252959	0	43878008	28060		0
64729	3827	4142905	2015-08-24	2015-08-24 00:00:00	2015-10-23	2015-10-23 00:00:00	32020		\N	254191	0	33737001	4142905		0
54264	3215	4112343	1986-02-06	1986-02-06 00:00:00	1986-02-18	1986-02-18 00:00:00	32020		\N	213560	0	195662009	4112343		0
64971	3841	81151	1988-10-29	1988-10-29 00:00:00	1988-11-19	1988-11-19 00:00:00	32020		\N	255054	0	44465007	81151		0
65098	3851	372328	1913-11-05	1913-11-05 00:00:00	1914-04-06	1914-04-06 00:00:00	32020		\N	255498	0	65363002	372328		0
65280	3860	4112343	2004-03-13	2004-03-13 00:00:00	2004-03-23	2004-03-23 00:00:00	32020		\N	256320	0	195662009	4112343		0
65471	3871	4112343	1983-11-04	1983-11-04 00:00:00	1983-11-13	1983-11-13 00:00:00	32020		\N	257059	0	195662009	4112343		0
76206	4522	40481087	2008-07-21	2008-07-21 00:00:00	2008-08-11	2008-08-11 00:00:00	32020		\N	301129	0	444814009	40481087		0
76377	4530	260139	1991-11-14	1991-11-14 00:00:00	1991-11-21	1991-11-21 00:00:00	32020		\N	301646	0	10509002	260139		0
65978	3901	40481087	1977-05-18	1977-05-18 00:00:00	1977-06-08	1977-06-08 00:00:00	32020		\N	259345	0	444814009	40481087		0
66167	3916	4051466	1980-10-10	1980-10-10 00:00:00	1998-01-16	1998-01-16 00:00:00	32020		\N	260340	0	233678006	4051466		0
66346	3927	4112343	1967-10-21	1967-10-21 00:00:00	1967-10-31	1967-10-31 00:00:00	32020		\N	261052	0	195662009	4112343		0
66445	3934	4112343	1998-09-06	1998-09-06 00:00:00	1998-09-14	1998-09-14 00:00:00	32020		\N	261481	0	195662009	4112343		0
77234	4576	40481087	1991-06-04	1991-06-04 00:00:00	1991-06-18	1991-06-18 00:00:00	32020		\N	304772	0	444814009	40481087		0
66862	3956	260139	2012-10-02	2012-10-02 00:00:00	2012-10-09	2012-10-09 00:00:00	32020		\N	262968	0	10509002	260139		0
67002	3961	372328	1984-03-29	1984-03-29 00:00:00	1985-03-05	1985-03-05 00:00:00	32020		\N	263372	0	65363002	372328		0
67146	3968	260139	1944-02-04	1944-02-04 00:00:00	1944-02-11	1944-02-11 00:00:00	32020		\N	263897	0	10509002	260139		0
77980	4621	81151	2006-06-22	2006-06-22 00:00:00	2006-07-06	2006-07-06 00:00:00	32020		\N	307745	0	44465007	81151		0
67513	3989	378419	2017-01-23	2017-01-23 00:00:00	\N	\N	32020		\N	265186	0	26929004	378419		0
67635	3996	80180	2003-02-27	2003-02-27 00:00:00	\N	\N	32020		\N	265643	0	396275006	80180		0
67784	4006	40481087	2016-03-04	2016-03-04 00:00:00	2016-03-25	2016-03-25 00:00:00	32020		\N	266192	0	444814009	40481087		0
68013	4018	4112343	2017-12-09	2017-12-09 00:00:00	2017-12-21	2017-12-21 00:00:00	32020		\N	267066	0	195662009	4112343		0
68125	4022	4283893	1986-07-16	1986-07-16 00:00:00	1986-11-05	1986-11-05 00:00:00	32020		\N	267413	0	36971009	4283893		0
78863	4670	260139	1993-07-03	1993-07-03 00:00:00	1993-07-10	1993-07-10 00:00:00	32020		\N	311162	0	10509002	260139		0
68506	4051	372328	1975-08-09	1975-08-09 00:00:00	1975-12-24	1975-12-24 00:00:00	32020		\N	269269	0	65363002	372328		0
68718	4067	40481087	1984-10-22	1984-10-22 00:00:00	1984-11-05	1984-11-05 00:00:00	32020		\N	270202	0	444814009	40481087		0
68889	4078	4112343	2008-01-11	2008-01-11 00:00:00	2008-01-24	2008-01-24 00:00:00	32020		\N	271081	0	195662009	4112343		0
68894	4078	260139	1975-03-23	1975-03-23 00:00:00	1975-03-30	1975-03-30 00:00:00	32020		\N	271057	0	10509002	260139		0
69127	4090	81893	1983-05-07	1983-05-07 00:00:00	\N	\N	32020		\N	271864	0	64766004	81893		0
79907	4735	4112343	1989-10-20	1989-10-20 00:00:00	1989-11-02	1989-11-02 00:00:00	32020		\N	315456	0	195662009	4112343		0
58904	3494	4094814	2014-12-20	2014-12-20 00:00:00	2015-01-19	2015-01-19 00:00:00	32020		\N	231769	0	262574004	4094814		0
69559	4116	40481087	2000-11-06	2000-11-06 00:00:00	2000-11-27	2000-11-27 00:00:00	32020		\N	273630	0	444814009	40481087		0
69879	4134	4112343	1981-09-09	1981-09-09 00:00:00	1981-09-17	1981-09-17 00:00:00	32020		\N	274896	0	195662009	4112343		0
80639	4781	81151	1998-10-03	1998-10-03 00:00:00	1998-10-31	1998-10-31 00:00:00	32020		\N	318274	0	44465007	81151		0
59587	3532	4230399	1986-12-15	1986-12-15 00:00:00	1987-03-15	1987-03-15 00:00:00	32020		\N	234629	0	359817006	4230399		0
70359	4167	440086	1992-09-16	1992-09-16 00:00:00	1996-09-25	1996-09-25 00:00:00	32020		\N	276953	0	192127007	440086		0
81101	4811	4112343	1967-10-16	1967-10-16 00:00:00	1967-10-28	1967-10-28 00:00:00	32020		\N	320073	0	195662009	4112343		0
81218	4816	40481087	2000-09-18	2000-09-18 00:00:00	2000-09-25	2000-09-25 00:00:00	32020		\N	320383	0	444814009	40481087		0
70817	4202	40481087	1986-08-25	1986-08-25 00:00:00	1986-09-01	1986-09-01 00:00:00	32020		\N	278935	0	444814009	40481087		0
70936	4208	80180	1978-10-03	1978-10-03 00:00:00	\N	\N	32020		\N	279433	0	396275006	80180		0
60550	3580	372328	1979-03-18	1979-03-18 00:00:00	1979-11-09	1979-11-09 00:00:00	32020		\N	238009	0	65363002	372328		0
71288	4227	4112343	1960-05-18	1960-05-18 00:00:00	1960-05-31	1960-05-31 00:00:00	32020		\N	280852	0	195662009	4112343		0
71428	4238	40481087	2011-08-13	2011-08-13 00:00:00	2011-09-03	2011-09-03 00:00:00	32020		\N	281365	0	444814009	40481087		0
71692	4253	81893	2017-01-07	2017-01-07 00:00:00	\N	\N	32020		\N	282438	0	64766004	81893		0
71752	4256	40481087	1988-04-01	1988-04-01 00:00:00	1988-04-15	1988-04-15 00:00:00	32020		\N	282571	0	444814009	40481087		0
71926	4268	260139	1971-01-30	1971-01-30 00:00:00	1971-02-13	1971-02-13 00:00:00	32020		\N	283218	0	10509002	260139		0
72061	4276	40481087	1958-02-02	1958-02-02 00:00:00	1958-02-16	1958-02-16 00:00:00	32020		\N	283726	0	444814009	40481087		0
61746	3647	192671	1970-01-06	1970-01-06 00:00:00	\N	\N	32020		\N	242624	0	K92.2	35208414		0
83001	4929	4218389	1984-07-16	1984-07-16 00:00:00	1984-08-06	1984-08-06 00:00:00	32020		\N	327672	0	39848009	4218389		0
72692	4319	40481087	1996-11-02	1996-11-02 00:00:00	1996-11-16	1996-11-16 00:00:00	32020		\N	286620	0	444814009	40481087		0
72786	4325	260139	2012-02-04	2012-02-04 00:00:00	2012-02-18	2012-02-18 00:00:00	32020		\N	286927	0	10509002	260139		0
83575	4967	28060	1968-12-07	1968-12-07 00:00:00	1968-12-20	1968-12-20 00:00:00	32020		\N	330155	0	43878008	28060		0
73165	4348	4051466	1985-10-27	1985-10-27 00:00:00	2001-02-07	2001-02-07 00:00:00	32020		\N	288327	0	233678006	4051466		0
73255	4353	4134304	1980-08-30	1980-08-30 00:00:00	1980-09-29	1980-09-29 00:00:00	32020		\N	288787	0	263102004	4134304		0
84021	4990	40481087	1986-09-17	1986-09-17 00:00:00	1986-10-01	1986-10-01 00:00:00	32020		\N	332001	0	444814009	40481087		0
73554	4373	4027663	2005-12-29	2005-12-29 00:00:00	\N	\N	32020		\N	290434	0	13200003	4027663		0
73870	4388	40481087	2013-03-01	2013-03-01 00:00:00	2013-03-15	2013-03-15 00:00:00	32020		\N	291743	0	444814009	40481087		0
74009	4395	28060	2018-05-31	2018-05-31 00:00:00	2018-06-08	2018-06-08 00:00:00	32020		\N	292214	0	43878008	28060		0
74182	4406	4112343	1967-07-06	1967-07-06 00:00:00	1967-07-19	1967-07-19 00:00:00	32020		\N	292892	0	195662009	4112343		0
84843	5046	81893	1994-04-30	1994-04-30 00:00:00	\N	\N	32020		\N	335343	0	64766004	81893		0
63904	3776	4112343	2003-12-03	2003-12-03 00:00:00	2003-12-13	2003-12-13 00:00:00	32020		\N	250948	0	195662009	4112343		0
74610	4432	260139	1978-09-03	1978-09-03 00:00:00	1978-09-17	1978-09-17 00:00:00	32020		\N	294589	0	10509002	260139		0
64181	3790	372328	1969-05-23	1969-05-23 00:00:00	1969-06-16	1969-06-16 00:00:00	32020		\N	252023	0	65363002	372328		0
64297	3796	260139	2010-08-18	2010-08-18 00:00:00	2010-09-01	2010-09-01 00:00:00	32020		\N	252412	0	10509002	260139		0
64443	3807	81893	1986-08-07	1986-08-07 00:00:00	\N	\N	32020		\N	253017	0	64766004	81893		0
64730	3827	4112343	1973-01-17	1973-01-17 00:00:00	1973-01-26	1973-01-26 00:00:00	32020		\N	254210	0	195662009	4112343		0
54265	3215	260139	1997-10-24	1997-10-24 00:00:00	1997-10-31	1997-10-31 00:00:00	32020		\N	213666	0	10509002	260139		0
64972	3841	440086	1984-09-25	1984-09-25 00:00:00	1986-02-25	1986-02-25 00:00:00	32020		\N	255019	0	192127007	440086		0
65099	3851	40481087	1961-09-02	1961-09-02 00:00:00	1961-09-16	1961-09-16 00:00:00	32020		\N	255493	0	444814009	40481087		0
65281	3860	80180	2007-03-22	2007-03-22 00:00:00	\N	\N	32020		\N	256316	0	396275006	80180		0
65472	3871	40481087	1981-07-15	1981-07-15 00:00:00	1981-07-29	1981-07-29 00:00:00	32020		\N	257058	0	444814009	40481087		0
76207	4522	4112343	1984-12-25	1984-12-25 00:00:00	1985-01-07	1985-01-07 00:00:00	32020		\N	301105	0	195662009	4112343		0
76378	4530	4112343	1976-06-07	1976-06-07 00:00:00	1976-06-16	1976-06-16 00:00:00	32020		\N	301631	0	195662009	4112343		0
65979	3901	4113008	2002-02-15	2002-02-15 00:00:00	2002-03-01	2002-03-01 00:00:00	32020		\N	259388	0	284549007	4113008		0
66168	3916	4027663	2004-09-27	2004-09-27 00:00:00	\N	\N	32020		\N	260290	0	13200003	4027663		0
66347	3927	40481087	1969-08-17	1969-08-17 00:00:00	1969-08-31	1969-08-31 00:00:00	32020		\N	261043	0	444814009	40481087		0
66446	3934	260139	1952-03-26	1952-03-26 00:00:00	1952-04-09	1952-04-09 00:00:00	32020		\N	261520	0	10509002	260139		0
77235	4576	40481087	1959-05-11	1959-05-11 00:00:00	1959-05-18	1959-05-18 00:00:00	32020		\N	304769	0	444814009	40481087		0
66863	3956	4310024	1956-09-23	1956-09-23 00:00:00	\N	\N	32020		\N	263021	0	424802006	4310024		0
67003	3961	372328	1983-02-10	1983-02-10 00:00:00	1984-02-28	1984-02-28 00:00:00	32020		\N	263367	0	65363002	372328		0
67147	3968	4112343	1954-03-29	1954-03-29 00:00:00	1954-04-06	1954-04-06 00:00:00	32020		\N	263851	0	195662009	4112343		0
77981	4621	372328	1980-10-22	1980-10-22 00:00:00	1981-07-06	1981-07-06 00:00:00	32020		\N	307774	0	65363002	372328		0
67514	3989	4027663	1955-09-26	1955-09-26 00:00:00	\N	\N	32020		\N	265154	0	13200003	4027663		0
67636	3996	260139	2016-10-05	2016-10-05 00:00:00	2016-10-12	2016-10-12 00:00:00	32020		\N	265669	0	10509002	260139		0
67785	4006	372328	1966-03-09	1966-03-09 00:00:00	1966-10-18	1966-10-18 00:00:00	32020		\N	266193	0	65363002	372328		0
68014	4018	81151	1978-07-22	1978-07-22 00:00:00	1978-08-12	1978-08-12 00:00:00	32020		\N	267052	0	44465007	81151		0
68132	4024	260139	1981-09-16	1981-09-16 00:00:00	1981-09-23	1981-09-23 00:00:00	32020		\N	267515	0	10509002	260139		0
78864	4670	81151	1969-12-21	1969-12-21 00:00:00	1970-01-04	1970-01-04 00:00:00	32020		\N	311155	0	44465007	81151		0
68507	4051	4155034	2018-07-20	2018-07-20 00:00:00	2018-08-03	2018-08-03 00:00:00	32020		\N	269263	0	283371005	4155034		0
68719	4067	378001	1980-05-29	1980-05-29 00:00:00	1980-07-28	1980-07-28 00:00:00	32020		\N	270201	0	62106007	378001		0
68890	4078	78272	1968-03-09	1968-03-09 00:00:00	1968-03-23	1968-03-23 00:00:00	32020		\N	271096	0	70704007	78272		0
68895	4078	372328	1955-11-13	1955-11-13 00:00:00	1956-07-16	1956-07-16 00:00:00	32020		\N	271072	0	65363002	372328		0
69128	4090	40481087	1969-03-27	1969-03-27 00:00:00	1969-04-10	1969-04-10 00:00:00	32020		\N	271852	0	444814009	40481087		0
79908	4735	4112343	1994-02-26	1994-02-26 00:00:00	1994-03-10	1994-03-10 00:00:00	32020		\N	315425	0	195662009	4112343		0
58905	3494	4112343	1967-04-22	1967-04-22 00:00:00	1967-05-04	1967-05-04 00:00:00	32020		\N	231719	0	195662009	4112343		0
69560	4116	40479422	1996-10-30	1996-10-30 00:00:00	1997-01-05	1997-01-05 00:00:00	32020		\N	273677	0	444448004	40479422		0
69880	4134	260139	2019-05-13	2019-05-13 00:00:00	2019-05-20	2019-05-20 00:00:00	32020		\N	274833	0	10509002	260139		0
80640	4781	4112343	2016-12-14	2016-12-14 00:00:00	2016-12-22	2016-12-22 00:00:00	32020		\N	318303	0	195662009	4112343		0
59588	3532	4112343	1995-07-01	1995-07-01 00:00:00	1995-07-11	1995-07-11 00:00:00	32020		\N	234597	0	195662009	4112343		0
70360	4167	260139	1992-12-06	1992-12-06 00:00:00	1992-12-13	1992-12-13 00:00:00	32020		\N	276939	0	10509002	260139		0
81102	4811	4134304	1965-12-26	1965-12-26 00:00:00	1966-03-26	1966-03-26 00:00:00	32020		\N	320082	0	263102004	4134304		0
81219	4816	4027663	2007-11-03	2007-11-03 00:00:00	\N	\N	32020		\N	320422	0	13200003	4027663		0
70818	4202	260139	1995-02-10	1995-02-10 00:00:00	1995-02-24	1995-02-24 00:00:00	32020		\N	278993	0	10509002	260139		0
70937	4208	81893	1977-11-07	1977-11-07 00:00:00	\N	\N	32020		\N	279433	0	64766004	81893		0
60551	3580	260139	2003-02-25	2003-02-25 00:00:00	2003-03-04	2003-03-04 00:00:00	32020		\N	238000	0	10509002	260139		0
71289	4227	260139	2001-06-25	2001-06-25 00:00:00	2001-07-02	2001-07-02 00:00:00	32020		\N	280784	0	10509002	260139		0
71429	4238	260139	1962-04-29	1962-04-29 00:00:00	1962-05-06	1962-05-06 00:00:00	32020		\N	281402	0	10509002	260139		0
71693	4253	40481087	1984-10-11	1984-10-11 00:00:00	1984-10-25	1984-10-25 00:00:00	32020		\N	282421	0	444814009	40481087		0
71753	4256	4156265	1974-09-10	1974-09-10 00:00:00	1974-10-01	1974-10-01 00:00:00	32020		\N	282634	0	370247008	4156265		0
71927	4268	40481087	1960-01-28	1960-01-28 00:00:00	1960-02-18	1960-02-18 00:00:00	32020		\N	283275	0	444814009	40481087		0
72062	4276	4112343	1997-07-24	1997-07-24 00:00:00	1997-08-01	1997-08-01 00:00:00	32020		\N	283775	0	195662009	4112343		0
61747	3647	257012	1997-06-01	1997-06-01 00:00:00	\N	\N	32020		\N	242626	0	40055000	257012		0
83002	4929	4113008	2004-10-20	2004-10-20 00:00:00	2004-11-03	2004-11-03 00:00:00	32020		\N	327673	0	284549007	4113008		0
72693	4319	4059173	1995-10-30	1995-10-30 00:00:00	1996-01-28	1996-01-28 00:00:00	32020		\N	286583	0	16114001	4059173		0
72787	4325	260139	1986-05-21	1986-05-21 00:00:00	1986-06-04	1986-06-04 00:00:00	32020		\N	286895	0	10509002	260139		0
83576	4967	260139	2014-11-19	2014-11-19 00:00:00	2014-11-26	2014-11-26 00:00:00	32020		\N	330139	0	10509002	260139		0
73166	4348	40481087	1986-04-05	1986-04-05 00:00:00	1986-04-12	1986-04-12 00:00:00	32020		\N	288328	0	444814009	40481087		0
73256	4353	28060	1990-05-20	1990-05-20 00:00:00	1990-05-28	1990-05-28 00:00:00	32020		\N	288757	0	43878008	28060		0
84022	4990	378001	2004-08-11	2004-08-11 00:00:00	2004-09-10	2004-09-10 00:00:00	32020		\N	331971	0	62106007	378001		0
73555	4373	40481087	1981-05-27	1981-05-27 00:00:00	1981-06-17	1981-06-17 00:00:00	32020		\N	290379	0	444814009	40481087		0
84329	5013	4294548	1990-08-28	1990-08-28 00:00:00	1990-10-16	1990-10-16 00:00:00	32020		\N	333182	0	75498004	4294548		0
74010	4395	4283893	2010-12-31	2010-12-31 00:00:00	2011-02-11	2011-02-11 00:00:00	32020		\N	292263	0	36971009	4283893		0
74183	4406	4112343	1948-01-08	1948-01-08 00:00:00	1948-01-21	1948-01-21 00:00:00	32020		\N	292872	0	195662009	4112343		0
84844	5046	30753	1994-08-28	1994-08-28 00:00:00	\N	\N	32020		\N	335343	0	16761005	30753		0
63905	3776	192671	2007-11-18	2007-11-18 00:00:00	\N	\N	32020		\N	250956	0	K92.2	35208414		0
74611	4432	40481087	1959-11-21	1959-11-21 00:00:00	1959-11-28	1959-11-28 00:00:00	32020		\N	294614	0	444814009	40481087		0
64182	3790	40481087	1976-12-17	1976-12-17 00:00:00	1976-12-31	1976-12-31 00:00:00	32020		\N	251997	0	444814009	40481087		0
64298	3796	40481087	1969-09-10	1969-09-10 00:00:00	1969-09-24	1969-09-24 00:00:00	32020		\N	252353	0	444814009	40481087		0
64444	3807	30753	1986-12-05	1986-12-05 00:00:00	\N	\N	32020		\N	253017	0	16761005	30753		0
64731	3827	4116491	1998-11-13	1998-11-13 00:00:00	1998-12-26	1998-12-26 00:00:00	32020		\N	254176	0	301011002	4116491		0
54266	3215	260139	1982-01-31	1982-01-31 00:00:00	1982-02-07	1982-02-07 00:00:00	32020		\N	213664	0	10509002	260139		0
64973	3841	372328	1974-04-16	1974-04-16 00:00:00	1974-09-04	1974-09-04 00:00:00	32020		\N	255005	0	65363002	372328		0
65100	3851	81151	1963-09-02	1963-09-02 00:00:00	1963-10-07	1963-10-07 00:00:00	32020		\N	255593	0	44465007	81151		0
65282	3860	81151	1980-05-27	1980-05-27 00:00:00	1980-07-01	1980-07-01 00:00:00	32020		\N	256336	0	44465007	81151		0
65473	3871	372328	1968-01-14	1968-01-14 00:00:00	1968-08-28	1968-08-28 00:00:00	32020		\N	257039	0	65363002	372328		0
76208	4522	40481087	2002-02-23	2002-02-23 00:00:00	2002-03-16	2002-03-16 00:00:00	32020		\N	301117	0	444814009	40481087		0
76379	4530	81151	1976-08-04	1976-08-04 00:00:00	1976-09-08	1976-09-08 00:00:00	32020		\N	301618	0	44465007	81151		0
65980	3901	4029498	1936-03-18	1936-03-18 00:00:00	\N	\N	32020		\N	259382	0	128613002	4029498		0
66169	3916	4296205	2010-11-20	2010-11-20 00:00:00	2010-12-25	2010-12-25 00:00:00	32020		\N	260441	0	403191005	4296205		0
66348	3927	4027663	1972-01-22	1972-01-22 00:00:00	\N	\N	32020		\N	261043	0	13200003	4027663		0
66447	3934	260139	1939-02-16	1939-02-16 00:00:00	1939-03-02	1939-03-02 00:00:00	32020		\N	261448	0	10509002	260139		0
77236	4576	4112343	1986-01-12	1986-01-12 00:00:00	1986-01-24	1986-01-24 00:00:00	32020		\N	304786	0	195662009	4112343		0
66864	3956	40481087	1956-07-20	1956-07-20 00:00:00	1956-07-27	1956-07-27 00:00:00	32020		\N	263021	0	444814009	40481087		0
67004	3961	4149245	1974-10-29	1974-10-29 00:00:00	1974-12-05	1974-12-05 00:00:00	32020		\N	263350	0	30832001	4149245		0
67148	3968	28060	1923-11-24	1923-11-24 00:00:00	1923-12-05	1923-12-05 00:00:00	32020		\N	263895	0	43878008	28060		0
77983	4621	4029498	1976-07-26	1976-07-26 00:00:00	\N	\N	32020		\N	307740	0	128613002	4029498		0
67515	3989	195588	1954-09-26	1954-09-26 00:00:00	1954-11-08	1954-11-08 00:00:00	32020		\N	265154	0	38822007	195588		0
67637	3996	4294548	2005-01-15	2005-01-15 00:00:00	2005-03-26	2005-03-26 00:00:00	32020		\N	265689	0	75498004	4294548		0
67786	4006	4283893	1971-04-10	1971-04-10 00:00:00	1971-07-24	1971-07-24 00:00:00	32020		\N	266138	0	36971009	4283893		0
68015	4018	40481087	1984-05-03	1984-05-03 00:00:00	1984-05-24	1984-05-24 00:00:00	32020		\N	267058	0	444814009	40481087		0
68133	4024	40481087	1997-09-29	1997-09-29 00:00:00	1997-10-20	1997-10-20 00:00:00	32020		\N	267509	0	444814009	40481087		0
78891	4674	40481087	2014-01-10	2014-01-10 00:00:00	2014-01-17	2014-01-17 00:00:00	32020		\N	311367	0	444814009	40481087		0
68508	4051	192671	2009-10-14	2009-10-14 00:00:00	\N	\N	32020		\N	269273	0	K92.2	35208414		0
68720	4067	28060	1972-05-24	1972-05-24 00:00:00	1972-06-03	1972-06-03 00:00:00	32020		\N	270227	0	43878008	28060		0
79349	4700	260139	1963-03-21	1963-03-21 00:00:00	1963-04-04	1963-04-04 00:00:00	32020		\N	313023	0	10509002	260139		0
68896	4078	4112343	1989-03-15	1989-03-15 00:00:00	1989-03-23	1989-03-23 00:00:00	32020		\N	270978	0	195662009	4112343		0
69129	4090	28060	1991-04-02	1991-04-02 00:00:00	1991-04-12	1991-04-12 00:00:00	32020		\N	271846	0	43878008	28060		0
79909	4735	4113008	2014-05-29	2014-05-29 00:00:00	2014-06-12	2014-06-12 00:00:00	32020		\N	315430	0	284549007	4113008		0
58906	3494	192671	1999-02-24	1999-02-24 00:00:00	\N	\N	32020		\N	231786	0	K92.2	35208414		0
69561	4117	40481087	1967-09-25	1967-09-25 00:00:00	1967-10-09	1967-10-09 00:00:00	32020		\N	273691	0	444814009	40481087		0
69881	4134	40481087	1976-02-18	1976-02-18 00:00:00	1976-02-25	1976-02-25 00:00:00	32020		\N	274845	0	444814009	40481087		0
80641	4781	28060	1987-03-09	1987-03-09 00:00:00	1987-03-20	1987-03-20 00:00:00	32020		\N	318291	0	43878008	28060		0
59589	3532	28060	1981-10-13	1981-10-13 00:00:00	1981-10-25	1981-10-25 00:00:00	32020		\N	234644	0	43878008	28060		0
70361	4167	40481087	1981-04-14	1981-04-14 00:00:00	1981-04-28	1981-04-28 00:00:00	32020		\N	276882	0	444814009	40481087		0
81103	4811	260139	2006-08-21	2006-08-21 00:00:00	2006-08-29	2006-08-29 00:00:00	32020		\N	320048	0	10509002	260139		0
81237	4819	4112343	1980-05-09	1980-05-09 00:00:00	1980-05-21	1980-05-21 00:00:00	32020		\N	320576	0	195662009	4112343		0
70819	4202	4134304	1974-02-28	1974-02-28 00:00:00	1974-03-30	1974-03-30 00:00:00	32020		\N	278927	0	263102004	4134304		0
70938	4208	30753	1978-07-05	1978-07-05 00:00:00	\N	\N	32020		\N	279433	0	16761005	30753		0
60552	3580	40481087	2007-11-03	2007-11-03 00:00:00	2007-11-24	2007-11-24 00:00:00	32020		\N	237989	0	444814009	40481087		0
71290	4227	4112343	2012-03-02	2012-03-02 00:00:00	2012-03-13	2012-03-13 00:00:00	32020		\N	280821	0	195662009	4112343		0
71430	4238	78272	1969-12-17	1969-12-17 00:00:00	1970-01-21	1970-01-21 00:00:00	32020		\N	281382	0	70704007	78272		0
71694	4253	260139	1987-06-22	1987-06-22 00:00:00	1987-06-29	1987-06-29 00:00:00	32020		\N	282440	0	10509002	260139		0
71754	4256	4283893	1997-04-22	1997-04-22 00:00:00	1997-06-03	1997-06-03 00:00:00	32020		\N	282572	0	36971009	4283893		0
71928	4268	40481087	1985-07-10	1985-07-10 00:00:00	1985-07-31	1985-07-31 00:00:00	32020		\N	283277	0	444814009	40481087		0
72063	4276	28060	2016-09-24	2016-09-24 00:00:00	2016-10-07	2016-10-07 00:00:00	32020		\N	283778	0	43878008	28060		0
61748	3647	4218389	2010-11-09	2010-11-09 00:00:00	2010-12-14	2010-12-14 00:00:00	32020		\N	242667	0	39848009	4218389		0
83003	4929	4112343	1984-10-15	1984-10-15 00:00:00	1984-10-28	1984-10-28 00:00:00	32020		\N	327718	0	195662009	4112343		0
72694	4320	372328	1973-02-11	1973-02-11 00:00:00	1973-03-04	1973-03-04 00:00:00	32020		\N	286666	0	65363002	372328		0
72788	4325	40481087	1980-12-18	1980-12-18 00:00:00	1981-01-08	1981-01-08 00:00:00	32020		\N	286893	0	444814009	40481087		0
83577	4967	80180	2003-11-10	2003-11-10 00:00:00	\N	\N	32020		\N	330189	0	396275006	80180		0
73167	4348	40481087	1992-02-12	1992-02-12 00:00:00	1992-02-19	1992-02-19 00:00:00	32020		\N	288349	0	444814009	40481087		0
73257	4353	4142905	1992-01-30	1992-01-30 00:00:00	1992-03-30	1992-03-30 00:00:00	32020		\N	288788	0	33737001	4142905		0
84023	4990	4112343	1980-01-22	1980-01-22 00:00:00	1980-02-04	1980-02-04 00:00:00	32020		\N	331951	0	195662009	4112343		0
73556	4373	40481087	1990-03-08	1990-03-08 00:00:00	1990-03-15	1990-03-15 00:00:00	32020		\N	290352	0	444814009	40481087		0
84330	5013	40481087	1987-01-18	1987-01-18 00:00:00	1987-02-08	1987-02-08 00:00:00	32020		\N	333204	0	444814009	40481087		0
74011	4395	4237458	1963-03-17	1963-03-17 00:00:00	1963-04-16	1963-04-16 00:00:00	32020		\N	292238	0	58150001	4237458		0
74184	4406	40481087	2017-06-18	2017-06-18 00:00:00	2017-07-02	2017-07-02 00:00:00	32020		\N	292907	0	444814009	40481087		0
84845	5046	4112343	1994-04-20	1994-04-20 00:00:00	1994-05-03	1994-05-03 00:00:00	32020		\N	335343	0	195662009	4112343		0
63906	3776	80180	2007-09-12	2007-09-12 00:00:00	\N	\N	32020		\N	250967	0	396275006	80180		0
74612	4432	260139	1994-08-09	1994-08-09 00:00:00	1994-08-16	1994-08-16 00:00:00	32020		\N	294616	0	10509002	260139		0
64183	3790	4112343	1979-05-09	1979-05-09 00:00:00	1979-05-21	1979-05-21 00:00:00	32020		\N	252001	0	195662009	4112343		0
64299	3796	372328	1968-11-08	1968-11-08 00:00:00	1969-01-21	1969-01-21 00:00:00	32020		\N	252394	0	65363002	372328		0
83680	4972	257012	1952-08-31	1952-08-31 00:00:00	\N	\N	32020		\N	330709	0	40055000	257012		0
64445	3807	260139	1965-10-18	1965-10-18 00:00:00	1965-10-25	1965-10-25 00:00:00	32020		\N	252961	0	10509002	260139		0
64732	3827	40481087	1963-04-11	1963-04-11 00:00:00	1963-04-18	1963-04-18 00:00:00	32020		\N	254193	0	444814009	40481087		0
54267	3215	4283893	2009-08-27	2009-08-27 00:00:00	2009-10-08	2009-10-08 00:00:00	32020		\N	213604	0	36971009	4283893		0
64974	3841	78272	2009-10-30	2009-10-30 00:00:00	2009-12-04	2009-12-04 00:00:00	32020		\N	255055	0	70704007	78272		0
65101	3851	40481087	1960-11-15	1960-11-15 00:00:00	1960-11-29	1960-11-29 00:00:00	32020		\N	255600	0	444814009	40481087		0
65283	3860	40481087	2018-11-16	2018-11-16 00:00:00	2018-11-30	2018-11-30 00:00:00	32020		\N	256290	0	444814009	40481087		0
65474	3871	28060	1966-05-25	1966-05-25 00:00:00	1966-06-05	1966-06-05 00:00:00	32020		\N	257007	0	43878008	28060		0
76209	4522	4112343	1988-08-04	1988-08-04 00:00:00	1988-08-11	1988-08-11 00:00:00	32020		\N	301109	0	195662009	4112343		0
76380	4530	4237458	1969-05-13	1969-05-13 00:00:00	1969-06-12	1969-06-12 00:00:00	32020		\N	301617	0	58150001	4237458		0
65981	3901	380378	1936-03-18	1936-03-18 00:00:00	\N	\N	32020		\N	259382	0	84757009	380378		0
66170	3916	260139	2012-10-07	2012-10-07 00:00:00	2012-10-21	2012-10-21 00:00:00	32020		\N	260309	0	10509002	260139		0
66349	3927	40481087	1990-12-13	1990-12-13 00:00:00	1990-12-20	1990-12-20 00:00:00	32020		\N	261054	0	444814009	40481087		0
66448	3934	4155034	1991-02-07	1991-02-07 00:00:00	1991-02-21	1991-02-21 00:00:00	32020		\N	261505	0	283371005	4155034		0
77237	4576	260139	1956-03-30	1956-03-30 00:00:00	1956-04-13	1956-04-13 00:00:00	32020		\N	304784	0	10509002	260139		0
66865	3956	4112343	2014-11-05	2014-11-05 00:00:00	2014-11-15	2014-11-15 00:00:00	32020		\N	263001	0	195662009	4112343		0
67005	3961	381316	2014-10-28	2014-10-28 00:00:00	\N	\N	32020		\N	263347	0	230690007	381316		0
67149	3968	28060	1923-04-12	1923-04-12 00:00:00	1923-04-24	1923-04-24 00:00:00	32020		\N	263790	0	43878008	28060		0
77984	4621	40481087	2000-05-11	2000-05-11 00:00:00	2000-06-01	2000-06-01 00:00:00	32020		\N	307777	0	444814009	40481087		0
67516	3989	40481087	1995-06-06	1995-06-06 00:00:00	1995-06-13	1995-06-13 00:00:00	32020		\N	265160	0	444814009	40481087		0
67638	3996	257012	2005-02-05	2005-02-05 00:00:00	\N	\N	32020		\N	265677	0	40055000	257012		0
67787	4006	40481087	2000-12-23	2000-12-23 00:00:00	2000-12-30	2000-12-30 00:00:00	32020		\N	266182	0	444814009	40481087		0
68016	4018	4152936	1968-02-03	1968-02-03 00:00:00	1968-02-24	1968-02-24 00:00:00	32020		\N	267049	0	283385000	4152936		0
68134	4024	40481087	2003-08-13	2003-08-13 00:00:00	2003-08-27	2003-08-27 00:00:00	32020		\N	267557	0	444814009	40481087		0
78892	4674	4112343	2015-03-17	2015-03-17 00:00:00	2015-03-24	2015-03-24 00:00:00	32020		\N	311384	0	195662009	4112343		0
68509	4051	4280726	1979-01-22	1979-01-22 00:00:00	1993-01-20	1993-01-20 00:00:00	32020		\N	269251	0	367498001	4280726		0
68721	4067	40481087	2010-09-20	2010-09-20 00:00:00	2010-09-27	2010-09-27 00:00:00	32020		\N	270223	0	444814009	40481087		0
79350	4700	372328	1953-01-11	1953-01-11 00:00:00	1953-04-28	1953-04-28 00:00:00	32020		\N	313035	0	65363002	372328		0
68897	4078	40481087	1955-07-15	1955-07-15 00:00:00	1955-07-22	1955-07-22 00:00:00	32020		\N	271054	0	444814009	40481087		0
69130	4090	78272	1964-03-04	1964-03-04 00:00:00	1964-03-25	1964-03-25 00:00:00	32020		\N	271935	0	70704007	78272		0
79910	4735	378001	2018-06-21	2018-06-21 00:00:00	2018-07-21	2018-07-21 00:00:00	32020		\N	315431	0	62106007	378001		0
58907	3495	4296204	1985-03-08	1985-03-08 00:00:00	1985-04-05	1985-04-05 00:00:00	32020		\N	231814	0	403190006	4296204		0
69562	4117	40481087	1998-04-08	1998-04-08 00:00:00	1998-04-15	1998-04-15 00:00:00	32020		\N	273715	0	444814009	40481087		0
69882	4134	40481087	2003-09-22	2003-09-22 00:00:00	2003-10-13	2003-10-13 00:00:00	32020		\N	274829	0	444814009	40481087		0
80642	4781	440448	2002-09-29	2002-09-29 00:00:00	\N	\N	32020		\N	318275	0	74400008	440448		0
59590	3532	4112343	2014-03-15	2014-03-15 00:00:00	2014-03-27	2014-03-27 00:00:00	32020		\N	234648	0	195662009	4112343		0
70362	4167	40481087	1993-11-23	1993-11-23 00:00:00	1993-12-07	1993-12-07 00:00:00	32020		\N	276963	0	444814009	40481087		0
81104	4811	4027663	1990-04-10	1990-04-10 00:00:00	\N	\N	32020		\N	320061	0	13200003	4027663		0
81238	4819	439777	1960-09-21	1960-09-21 00:00:00	\N	\N	32020		\N	320582	0	271737000	439777		0
70820	4202	133834	1971-08-20	1971-08-20 00:00:00	1988-10-11	1988-10-11 00:00:00	32020		\N	278978	0	24079001	133834		0
70939	4208	4285898	1978-08-04	1978-08-04 00:00:00	\N	\N	32020		\N	279433	0	68496003	4285898		0
60553	3580	260139	2006-10-15	2006-10-15 00:00:00	2006-10-22	2006-10-22 00:00:00	32020		\N	238004	0	10509002	260139		0
71291	4227	4112343	1986-06-10	1986-06-10 00:00:00	1986-06-19	1986-06-19 00:00:00	32020		\N	280847	0	195662009	4112343		0
71431	4238	40481087	1981-07-30	1981-07-30 00:00:00	1981-08-06	1981-08-06 00:00:00	32020		\N	281362	0	444814009	40481087		0
71695	4253	78272	1995-03-09	1995-03-09 00:00:00	1995-04-07	1995-04-07 00:00:00	32020		\N	282427	0	70704007	78272		0
71755	4256	4112343	1983-07-24	1983-07-24 00:00:00	1983-08-03	1983-08-03 00:00:00	32020		\N	282610	0	195662009	4112343		0
71929	4268	4112343	1979-04-22	1979-04-22 00:00:00	1979-05-04	1979-05-04 00:00:00	32020		\N	283239	0	195662009	4112343		0
72064	4276	4112343	1960-02-19	1960-02-19 00:00:00	1960-02-28	1960-02-28 00:00:00	32020		\N	283739	0	195662009	4112343		0
61749	3647	260139	2018-06-25	2018-06-25 00:00:00	2018-07-09	2018-07-09 00:00:00	32020		\N	242604	0	10509002	260139		0
83004	4929	28060	1994-01-12	1994-01-12 00:00:00	1994-01-19	1994-01-19 00:00:00	32020		\N	327719	0	43878008	28060		0
72695	4320	4027663	2000-03-21	2000-03-21 00:00:00	\N	\N	32020		\N	286673	0	13200003	4027663		0
72789	4325	80180	2002-05-03	2002-05-03 00:00:00	\N	\N	32020		\N	286910	0	396275006	80180		0
83578	4967	372328	1963-11-23	1963-11-23 00:00:00	1964-05-04	1964-05-04 00:00:00	32020		\N	330136	0	65363002	372328		0
73168	4348	4112343	2017-07-29	2017-07-29 00:00:00	2017-08-06	2017-08-06 00:00:00	32020		\N	288379	0	195662009	4112343		0
73258	4353	40481087	1992-03-14	1992-03-14 00:00:00	1992-03-28	1992-03-28 00:00:00	32020		\N	288785	0	444814009	40481087		0
84024	4990	4237458	1974-01-21	1974-01-21 00:00:00	1974-04-21	1974-04-21 00:00:00	32020		\N	331969	0	58150001	4237458		0
73557	4373	372328	1977-05-30	1977-05-30 00:00:00	1977-06-13	1977-06-13 00:00:00	32020		\N	290365	0	65363002	372328		0
84331	5013	260139	1990-07-26	1990-07-26 00:00:00	1990-08-09	1990-08-09 00:00:00	32020		\N	333205	0	10509002	260139		0
74012	4395	40481087	1948-06-11	1948-06-11 00:00:00	1948-07-02	1948-07-02 00:00:00	32020		\N	292254	0	444814009	40481087		0
74185	4406	40481087	2016-08-06	2016-08-06 00:00:00	2016-08-13	2016-08-13 00:00:00	32020		\N	292868	0	444814009	40481087		0
84846	5046	4155034	2012-11-12	2012-11-12 00:00:00	2012-12-03	2012-12-03 00:00:00	32020		\N	335342	0	283371005	4155034		0
63907	3776	40481087	1993-07-04	1993-07-04 00:00:00	1993-07-18	1993-07-18 00:00:00	32020		\N	250959	0	444814009	40481087		0
74613	4432	4218389	1995-08-03	1995-08-03 00:00:00	1995-08-31	1995-08-31 00:00:00	32020		\N	294584	0	39848009	4218389		0
64184	3790	4112343	1984-01-08	1984-01-08 00:00:00	1984-01-17	1984-01-17 00:00:00	32020		\N	251996	0	195662009	4112343		0
64324	3799	40481087	1974-01-16	1974-01-16 00:00:00	1974-01-23	1974-01-23 00:00:00	32020		\N	252562	0	444814009	40481087		0
64446	3807	40481087	1958-10-27	1958-10-27 00:00:00	1958-11-10	1958-11-10 00:00:00	32020		\N	252960	0	444814009	40481087		0
64733	3827	4152936	1986-07-08	1986-07-08 00:00:00	1986-07-22	1986-07-22 00:00:00	32020		\N	254189	0	283385000	4152936		0
54268	3215	40481087	2010-11-08	2010-11-08 00:00:00	2010-11-15	2010-11-15 00:00:00	32020		\N	213580	0	444814009	40481087		0
64975	3841	80180	2017-03-01	2017-03-01 00:00:00	\N	\N	32020		\N	255017	0	396275006	80180		0
65102	3851	255848	2000-09-14	2000-09-14 00:00:00	\N	\N	32020		\N	255596	0	233604007	255848		0
65284	3860	4294548	2001-07-26	2001-07-26 00:00:00	2001-08-16	2001-08-16 00:00:00	32020		\N	256282	0	75498004	4294548		0
65475	3871	40481087	2013-10-11	2013-10-11 00:00:00	2013-11-01	2013-11-01 00:00:00	32020		\N	257038	0	444814009	40481087		0
76210	4522	192671	2017-11-08	2017-11-08 00:00:00	\N	\N	32020		\N	301116	0	K92.2	35208414		0
76381	4530	378001	2010-08-25	2010-08-25 00:00:00	2010-10-24	2010-10-24 00:00:00	32020		\N	301622	0	62106007	378001		0
65983	3901	80180	1976-06-26	1976-06-26 00:00:00	\N	\N	32020		\N	259349	0	396275006	80180		0
66171	3916	40479422	2007-08-01	2007-08-01 00:00:00	2007-10-07	2007-10-07 00:00:00	32020		\N	260440	0	444448004	40479422		0
66351	3928	192671	2012-09-11	2012-09-11 00:00:00	\N	\N	32020		\N	261146	0	K92.2	35208414		0
66449	3934	40481087	1979-05-20	1979-05-20 00:00:00	1979-06-10	1979-06-10 00:00:00	32020		\N	261491	0	444814009	40481087		0
77238	4576	260139	1968-05-13	1968-05-13 00:00:00	1968-05-20	1968-05-20 00:00:00	32020		\N	304770	0	10509002	260139		0
66866	3956	40481087	1977-09-25	1977-09-25 00:00:00	1977-10-02	1977-10-02 00:00:00	32020		\N	263028	0	444814009	40481087		0
67006	3962	4112343	1968-04-30	1968-04-30 00:00:00	1968-05-08	1968-05-08 00:00:00	32020		\N	263477	0	195662009	4112343		0
67150	3968	4278672	2003-06-13	2003-06-13 00:00:00	2003-09-11	2003-09-11 00:00:00	32020		\N	263907	0	65966004	4278672		0
77985	4621	4112343	2008-07-20	2008-07-20 00:00:00	2008-08-01	2008-08-01 00:00:00	32020		\N	307772	0	195662009	4112343		0
67517	3989	260139	1999-01-26	1999-01-26 00:00:00	1999-02-09	1999-02-09 00:00:00	32020		\N	265173	0	10509002	260139		0
67639	3996	4112343	1974-07-16	1974-07-16 00:00:00	1974-07-28	1974-07-28 00:00:00	32020		\N	265653	0	195662009	4112343		0
67788	4006	260139	1951-04-11	1951-04-11 00:00:00	1951-04-25	1951-04-25 00:00:00	32020		\N	266135	0	10509002	260139		0
68017	4018	378001	2003-01-03	2003-01-03 00:00:00	2003-02-02	2003-02-02 00:00:00	32020		\N	267053	0	62106007	378001		0
68135	4024	4112343	2006-09-14	2006-09-14 00:00:00	2006-09-21	2006-09-21 00:00:00	32020		\N	267559	0	195662009	4112343		0
78893	4674	4113008	1984-03-11	1984-03-11 00:00:00	1984-03-25	1984-03-25 00:00:00	32020		\N	311387	0	284549007	4113008		0
68510	4051	40481087	2017-12-16	2017-12-16 00:00:00	2017-12-23	2017-12-23 00:00:00	32020		\N	269253	0	444814009	40481087		0
68722	4067	40481087	2001-04-15	2001-04-15 00:00:00	2001-04-29	2001-04-29 00:00:00	32020		\N	270221	0	444814009	40481087		0
79351	4700	81151	1998-06-05	1998-06-05 00:00:00	1998-06-19	1998-06-19 00:00:00	32020		\N	313117	0	44465007	81151		0
68898	4078	80180	1995-10-09	1995-10-09 00:00:00	\N	\N	32020		\N	271048	0	396275006	80180		0
69131	4090	4278672	1957-03-11	1957-03-11 00:00:00	1957-06-09	1957-06-09 00:00:00	32020		\N	271934	0	65966004	4278672		0
79911	4735	40481087	2009-11-09	2009-11-09 00:00:00	2009-11-16	2009-11-16 00:00:00	32020		\N	315444	0	444814009	40481087		0
58908	3495	40481087	1977-06-13	1977-06-13 00:00:00	1977-06-27	1977-06-27 00:00:00	32020		\N	231803	0	444814009	40481087		0
69563	4117	372328	1964-05-07	1964-05-07 00:00:00	1964-05-21	1964-05-21 00:00:00	32020		\N	273696	0	65363002	372328		0
69883	4134	4112343	1964-01-20	1964-01-20 00:00:00	1964-01-27	1964-01-27 00:00:00	32020		\N	274843	0	195662009	4112343		0
80643	4781	378001	2016-12-25	2016-12-25 00:00:00	2017-02-23	2017-02-23 00:00:00	32020		\N	318277	0	62106007	378001		0
59591	3532	28060	1978-12-14	1978-12-14 00:00:00	1978-12-24	1978-12-24 00:00:00	32020		\N	234596	0	43878008	28060		0
70363	4167	4280726	1982-09-26	1982-09-26 00:00:00	\N	\N	32020		\N	276935	0	367498001	4280726		0
81105	4811	4285898	1999-07-27	1999-07-27 00:00:00	\N	\N	32020		\N	320046	0	68496003	4285898		0
81239	4819	4112343	1995-01-19	1995-01-19 00:00:00	1995-01-28	1995-01-28 00:00:00	32020		\N	320578	0	195662009	4112343		0
70821	4202	4112343	1972-01-13	1972-01-13 00:00:00	1972-01-21	1972-01-21 00:00:00	32020		\N	278934	0	195662009	4112343		0
70940	4208	260139	1950-07-26	1950-07-26 00:00:00	1950-08-09	1950-08-09 00:00:00	32020		\N	279396	0	10509002	260139		0
60554	3580	40481087	1977-04-03	1977-04-03 00:00:00	1977-04-10	1977-04-10 00:00:00	32020		\N	237981	0	444814009	40481087		0
71292	4227	372328	1959-04-14	1959-04-14 00:00:00	1960-01-24	1960-01-24 00:00:00	32020		\N	280857	0	65363002	372328		0
71432	4238	40481087	2018-10-04	2018-10-04 00:00:00	2018-10-18	2018-10-18 00:00:00	32020		\N	281367	0	444814009	40481087		0
71696	4253	257012	2010-09-17	2010-09-17 00:00:00	\N	\N	32020		\N	282448	0	40055000	257012		0
71756	4256	40481087	1971-12-04	1971-12-04 00:00:00	1971-12-18	1971-12-18 00:00:00	32020		\N	282570	0	444814009	40481087		0
71930	4269	4218389	2013-12-27	2013-12-27 00:00:00	2014-01-31	2014-01-31 00:00:00	32020		\N	283355	0	39848009	4218389		0
72065	4276	4112343	2016-01-15	2016-01-15 00:00:00	2016-01-24	2016-01-24 00:00:00	32020		\N	283742	0	195662009	4112343		0
61750	3647	381316	1992-08-19	1992-08-19 00:00:00	\N	\N	32020		\N	242650	0	230690007	381316		0
83005	4929	28060	1972-12-05	1972-12-05 00:00:00	1972-12-14	1972-12-14 00:00:00	32020		\N	327688	0	43878008	28060		0
72696	4320	4112343	1984-03-16	1984-03-16 00:00:00	1984-03-24	1984-03-24 00:00:00	32020		\N	286650	0	195662009	4112343		0
72803	4328	260139	1993-12-31	1993-12-31 00:00:00	1994-01-14	1994-01-14 00:00:00	32020		\N	287015	0	10509002	260139		0
83579	4967	4112343	2010-05-07	2010-05-07 00:00:00	2010-05-18	2010-05-18 00:00:00	32020		\N	330165	0	195662009	4112343		0
73169	4348	4294548	2015-03-22	2015-03-22 00:00:00	2015-04-19	2015-04-19 00:00:00	32020		\N	288360	0	75498004	4294548		0
73259	4353	40481087	1982-01-20	1982-01-20 00:00:00	1982-01-27	1982-01-27 00:00:00	32020		\N	288783	0	444814009	40481087		0
84025	4990	260139	2002-07-31	2002-07-31 00:00:00	2002-08-07	2002-08-07 00:00:00	32020		\N	332004	0	10509002	260139		0
73558	4373	80180	2018-01-10	2018-01-10 00:00:00	\N	\N	32020		\N	290340	0	396275006	80180		0
84332	5013	81151	1969-06-17	1969-06-17 00:00:00	1969-07-08	1969-07-08 00:00:00	32020		\N	333199	0	44465007	81151		0
74013	4395	40481087	2010-07-11	2010-07-11 00:00:00	2010-07-25	2010-07-25 00:00:00	32020		\N	292262	0	444814009	40481087		0
74186	4406	4112343	1960-07-19	1960-07-19 00:00:00	1960-07-30	1960-07-30 00:00:00	32020		\N	292904	0	195662009	4112343		0
84847	5046	28060	2006-01-16	2006-01-16 00:00:00	2006-01-29	2006-01-29 00:00:00	32020		\N	335344	0	43878008	28060		0
63908	3776	40481087	1974-08-31	1974-08-31 00:00:00	1974-09-07	1974-09-07 00:00:00	32020		\N	250957	0	444814009	40481087		0
74614	4432	80180	1997-02-05	1997-02-05 00:00:00	\N	\N	32020		\N	294584	0	396275006	80180		0
64185	3790	372328	1965-05-21	1965-05-21 00:00:00	1965-06-04	1965-06-04 00:00:00	32020		\N	251982	0	65363002	372328		0
64325	3799	40481087	1978-10-05	1978-10-05 00:00:00	1978-10-19	1978-10-19 00:00:00	32020		\N	252531	0	444814009	40481087		0
64447	3807	378001	2010-01-02	2010-01-02 00:00:00	2010-02-01	2010-02-01 00:00:00	32020		\N	253039	0	62106007	378001		0
64734	3827	4218389	1959-08-10	1959-08-10 00:00:00	1959-09-14	1959-09-14 00:00:00	32020		\N	254187	0	39848009	4218389		0
54269	3215	378001	2010-03-28	2010-03-28 00:00:00	2010-04-27	2010-04-27 00:00:00	32020		\N	213668	0	62106007	378001		0
64976	3843	260139	1978-02-21	1978-02-21 00:00:00	1978-03-07	1978-03-07 00:00:00	32020		\N	255062	0	10509002	260139		0
65103	3851	40481087	1928-11-16	1928-11-16 00:00:00	1928-11-30	1928-11-30 00:00:00	32020		\N	255609	0	444814009	40481087		0
65285	3860	440448	1978-07-08	1978-07-08 00:00:00	\N	\N	32020		\N	256335	0	74400008	440448		0
65476	3871	260139	1963-09-08	1963-09-08 00:00:00	1963-09-15	1963-09-15 00:00:00	32020		\N	257006	0	10509002	260139		0
76211	4522	260139	1985-04-23	1985-04-23 00:00:00	1985-04-30	1985-04-30 00:00:00	32020		\N	301106	0	10509002	260139		0
76382	4530	40481087	1972-04-18	1972-04-18 00:00:00	1972-04-25	1972-04-25 00:00:00	32020		\N	301666	0	444814009	40481087		0
65984	3901	4112343	2008-09-10	2008-09-10 00:00:00	2008-09-18	2008-09-18 00:00:00	32020		\N	259419	0	195662009	4112343		0
66172	3916	4156265	1987-10-17	1987-10-17 00:00:00	1987-11-07	1987-11-07 00:00:00	32020		\N	260434	0	370247008	4156265		0
66352	3928	4001336	2009-05-10	2009-05-10 00:00:00	2009-07-09	2009-07-09 00:00:00	32020		\N	261134	0	110030002	4001336		0
66451	3934	321042	1957-03-06	1957-03-06 00:00:00	\N	\N	32020		\N	261501	0	410429000	321042		0
77239	4576	4112343	2013-08-22	2013-08-22 00:00:00	2013-09-03	2013-09-03 00:00:00	32020		\N	304789	0	195662009	4112343		0
66867	3956	4218389	1939-05-01	1939-05-01 00:00:00	1939-06-05	1939-06-05 00:00:00	32020		\N	262904	0	39848009	4218389		0
73336	4359	80502	2013-09-04	2013-09-04 00:00:00	\N	\N	32020		\N	289209	0	64859006	80502		0
67007	3962	4294548	2018-11-23	2018-11-23 00:00:00	2019-01-18	2019-01-18 00:00:00	32020		\N	263479	0	75498004	4294548		0
67151	3968	40480160	2003-06-13	2003-06-13 00:00:00	2003-09-11	2003-09-11 00:00:00	32020		\N	263907	0	443165006	40480160		0
77986	4621	40481087	2003-06-15	2003-06-15 00:00:00	2003-06-22	2003-06-22 00:00:00	32020		\N	307722	0	444814009	40481087		0
67518	3989	4112343	1948-01-25	1948-01-25 00:00:00	1948-02-05	1948-02-05 00:00:00	32020		\N	265153	0	195662009	4112343		0
67640	3996	260139	1979-12-16	1979-12-16 00:00:00	1979-12-30	1979-12-30 00:00:00	32020		\N	265654	0	10509002	260139		0
67789	4006	40481087	1984-04-24	1984-04-24 00:00:00	1984-05-01	1984-05-01 00:00:00	32020		\N	266174	0	444814009	40481087		0
68018	4018	372328	1966-06-25	1966-06-25 00:00:00	1966-11-01	1966-11-01 00:00:00	32020		\N	267067	0	65363002	372328		0
68136	4024	78272	2005-07-10	2005-07-10 00:00:00	2005-08-07	2005-08-07 00:00:00	32020		\N	267530	0	70704007	78272		0
78894	4674	4112343	1982-05-12	1982-05-12 00:00:00	1982-05-22	1982-05-22 00:00:00	32020		\N	311389	0	195662009	4112343		0
68511	4051	40481087	2018-12-24	2018-12-24 00:00:00	2019-01-07	2019-01-07 00:00:00	32020		\N	269254	0	444814009	40481087		0
68723	4067	4142905	1983-01-14	1983-01-14 00:00:00	1983-04-14	1983-04-14 00:00:00	32020		\N	270197	0	33737001	4142905		0
79352	4700	375671	1974-06-11	1974-06-11 00:00:00	1974-07-11	1974-07-11 00:00:00	32020		\N	313116	0	62564004	375671		0
68899	4078	40481087	1960-06-02	1960-06-02 00:00:00	1960-06-09	1960-06-09 00:00:00	32020		\N	270975	0	444814009	40481087		0
69132	4090	40481087	1955-09-17	1955-09-17 00:00:00	1955-10-01	1955-10-01 00:00:00	32020		\N	271849	0	444814009	40481087		0
79912	4735	4112343	1974-08-30	1974-08-30 00:00:00	1974-09-09	1974-09-09 00:00:00	32020		\N	315455	0	195662009	4112343		0
58909	3495	40481087	1971-05-25	1971-05-25 00:00:00	1971-06-08	1971-06-08 00:00:00	32020		\N	231802	0	444814009	40481087		0
69564	4117	260139	2012-06-30	2012-06-30 00:00:00	2012-07-07	2012-07-07 00:00:00	32020		\N	273695	0	10509002	260139		0
69884	4134	260139	1972-01-06	1972-01-06 00:00:00	1972-01-13	1972-01-13 00:00:00	32020		\N	274844	0	10509002	260139		0
80644	4781	260139	2013-09-15	2013-09-15 00:00:00	2013-09-22	2013-09-22 00:00:00	32020		\N	318302	0	10509002	260139		0
59592	3532	40481087	2009-01-19	2009-01-19 00:00:00	2009-01-26	2009-01-26 00:00:00	32020		\N	234591	0	444814009	40481087		0
70364	4167	4296205	1979-10-15	1979-10-15 00:00:00	1979-10-29	1979-10-29 00:00:00	32020		\N	276998	0	403191005	4296205		0
81106	4811	80180	1999-10-25	1999-10-25 00:00:00	\N	\N	32020		\N	320046	0	396275006	80180		0
81240	4819	40481087	2013-02-25	2013-02-25 00:00:00	2013-03-04	2013-03-04 00:00:00	32020		\N	320517	0	444814009	40481087		0
70822	4202	40481087	1982-01-03	1982-01-03 00:00:00	1982-01-10	1982-01-10 00:00:00	32020		\N	278991	0	444814009	40481087		0
70941	4208	81151	1984-07-21	1984-07-21 00:00:00	1984-08-11	1984-08-11 00:00:00	32020		\N	279429	0	44465007	81151		0
60555	3580	4109685	1986-04-10	1986-04-10 00:00:00	1986-05-01	1986-05-01 00:00:00	32020		\N	237965	0	284551006	4109685		0
71293	4227	4112343	2004-06-30	2004-06-30 00:00:00	2004-07-11	2004-07-11 00:00:00	32020		\N	280820	0	195662009	4112343		0
71433	4238	378001	2012-04-24	2012-04-24 00:00:00	2012-06-23	2012-06-23 00:00:00	32020		\N	281385	0	62106007	378001		0
71697	4253	4112343	1992-02-05	1992-02-05 00:00:00	1992-02-17	1992-02-17 00:00:00	32020		\N	282441	0	195662009	4112343		0
71757	4256	257012	1997-05-20	1997-05-20 00:00:00	\N	\N	32020		\N	282615	0	40055000	257012		0
71931	4269	40481087	1983-01-18	1983-01-18 00:00:00	1983-02-08	1983-02-08 00:00:00	32020		\N	283323	0	444814009	40481087		0
72066	4276	40481087	1967-12-04	1967-12-04 00:00:00	1967-12-25	1967-12-25 00:00:00	32020		\N	283727	0	444814009	40481087		0
61751	3647	4027663	1961-10-15	1961-10-15 00:00:00	\N	\N	32020		\N	242703	0	13200003	4027663		0
83006	4929	260139	1991-09-11	1991-09-11 00:00:00	1991-09-18	1991-09-18 00:00:00	32020		\N	327689	0	10509002	260139		0
72697	4320	257012	1984-03-11	1984-03-11 00:00:00	1984-04-01	1984-04-01 00:00:00	32020		\N	286676	0	40055000	257012		0
72804	4328	40481087	2006-08-29	2006-08-29 00:00:00	2006-09-05	2006-09-05 00:00:00	32020		\N	287037	0	444814009	40481087		0
83580	4967	40481087	1961-12-30	1961-12-30 00:00:00	1962-01-20	1962-01-20 00:00:00	32020		\N	330134	0	444814009	40481087		0
73170	4348	260139	1982-11-16	1982-11-16 00:00:00	1982-11-23	1982-11-23 00:00:00	32020		\N	288342	0	10509002	260139		0
73260	4353	40481087	2002-08-12	2002-08-12 00:00:00	2002-09-02	2002-09-02 00:00:00	32020		\N	288758	0	444814009	40481087		0
84026	4990	4112343	2016-03-21	2016-03-21 00:00:00	2016-03-30	2016-03-30 00:00:00	32020		\N	331964	0	195662009	4112343		0
73559	4373	28060	1977-02-03	1977-02-03 00:00:00	1977-02-12	1977-02-12 00:00:00	32020		\N	290378	0	43878008	28060		0
84333	5013	4112343	2000-02-26	2000-02-26 00:00:00	2000-03-10	2000-03-10 00:00:00	32020		\N	333174	0	195662009	4112343		0
74014	4395	40481087	1988-08-13	1988-08-13 00:00:00	1988-08-20	1988-08-20 00:00:00	32020		\N	292211	0	444814009	40481087		0
74187	4406	40481087	1955-04-23	1955-04-23 00:00:00	1955-05-07	1955-05-07 00:00:00	32020		\N	292862	0	444814009	40481087		0
84848	5046	4112343	2012-10-26	2012-10-26 00:00:00	2012-11-04	2012-11-04 00:00:00	32020		\N	335345	0	195662009	4112343		0
63909	3776	4155034	1991-12-25	1991-12-25 00:00:00	1992-01-15	1992-01-15 00:00:00	32020		\N	250979	0	283371005	4155034		0
74615	4432	257012	1990-08-30	1990-08-30 00:00:00	\N	\N	32020		\N	294590	0	40055000	257012		0
64186	3790	40481087	1976-03-24	1976-03-24 00:00:00	1976-04-14	1976-04-14 00:00:00	32020		\N	252020	0	444814009	40481087		0
64326	3799	260139	2007-07-12	2007-07-12 00:00:00	2007-07-26	2007-07-26 00:00:00	32020		\N	252590	0	10509002	260139		0
64448	3807	260139	1951-10-27	1951-10-27 00:00:00	1951-11-10	1951-11-10 00:00:00	32020		\N	252968	0	10509002	260139		0
64735	3827	260139	1961-10-07	1961-10-07 00:00:00	1961-10-14	1961-10-14 00:00:00	32020		\N	254157	0	10509002	260139		0
54270	3215	4237458	1995-01-02	1995-01-02 00:00:00	1995-02-01	1995-02-01 00:00:00	32020		\N	213684	0	58150001	4237458		0
64977	3843	40481087	2008-11-11	2008-11-11 00:00:00	2008-11-18	2008-11-18 00:00:00	32020		\N	255075	0	444814009	40481087		0
65104	3851	4112343	1912-10-26	1912-10-26 00:00:00	1912-11-05	1912-11-05 00:00:00	32020		\N	255561	0	195662009	4112343		0
65286	3860	40481087	2007-04-22	2007-04-22 00:00:00	2007-05-13	2007-05-13 00:00:00	32020		\N	256321	0	444814009	40481087		0
65477	3871	40481087	1984-10-20	1984-10-20 00:00:00	1984-11-03	1984-11-03 00:00:00	32020		\N	257004	0	444814009	40481087		0
76212	4522	378001	1978-08-26	1978-08-26 00:00:00	1978-10-25	1978-10-25 00:00:00	32020		\N	301107	0	62106007	378001		0
76383	4530	40481087	1992-12-22	1992-12-22 00:00:00	1993-01-12	1993-01-12 00:00:00	32020		\N	301632	0	444814009	40481087		0
65985	3901	260139	1990-06-10	1990-06-10 00:00:00	1990-06-17	1990-06-17 00:00:00	32020		\N	259405	0	10509002	260139		0
66173	3916	40486433	1983-10-10	1983-10-10 00:00:00	\N	\N	32020		\N	260259	0	446096008	40486433		0
66353	3928	40481087	2016-03-18	2016-03-18 00:00:00	2016-03-25	2016-03-25 00:00:00	32020		\N	261138	0	444814009	40481087		0
66452	3934	4218389	2011-11-03	2011-11-03 00:00:00	2011-11-24	2011-11-24 00:00:00	32020		\N	261507	0	39848009	4218389		0
77240	4576	4112343	2014-08-30	2014-08-30 00:00:00	2014-09-07	2014-09-07 00:00:00	32020		\N	304790	0	195662009	4112343		0
66868	3956	4112343	1930-01-01	1930-01-01 00:00:00	1930-01-09	1930-01-09 00:00:00	32020		\N	263027	0	195662009	4112343		0
67008	3962	80180	1989-11-24	1989-11-24 00:00:00	\N	\N	32020		\N	263440	0	396275006	80180		0
67152	3968	40481087	1969-08-19	1969-08-19 00:00:00	1969-08-26	1969-08-26 00:00:00	32020		\N	263834	0	444814009	40481087		0
77987	4621	375671	1987-08-12	1987-08-12 00:00:00	1987-10-11	1987-10-11 00:00:00	32020		\N	307742	0	62564004	375671		0
67519	3989	40481087	1982-05-26	1982-05-26 00:00:00	1982-06-02	1982-06-02 00:00:00	32020		\N	265258	0	444814009	40481087		0
67641	3996	40481087	1976-11-28	1976-11-28 00:00:00	1976-12-05	1976-12-05 00:00:00	32020		\N	265686	0	444814009	40481087		0
67790	4006	81151	1966-09-18	1966-09-18 00:00:00	1966-10-23	1966-10-23 00:00:00	32020		\N	266144	0	44465007	81151		0
68019	4018	40481087	1995-04-21	1995-04-21 00:00:00	1995-05-12	1995-05-12 00:00:00	32020		\N	267106	0	444814009	40481087		0
78895	4674	4112343	1982-09-21	1982-09-21 00:00:00	1982-10-02	1982-10-02 00:00:00	32020		\N	311373	0	195662009	4112343		0
68512	4051	40481087	1998-01-29	1998-01-29 00:00:00	1998-02-12	1998-02-12 00:00:00	32020		\N	269241	0	444814009	40481087		0
68724	4067	4112343	2016-08-03	2016-08-03 00:00:00	2016-08-16	2016-08-16 00:00:00	32020		\N	270230	0	195662009	4112343		0
79353	4700	440086	1965-05-18	1965-05-18 00:00:00	1967-05-30	1967-05-30 00:00:00	32020		\N	313058	0	192127007	440086		0
68900	4078	378001	1987-08-09	1987-08-09 00:00:00	1987-09-08	1987-09-08 00:00:00	32020		\N	271098	0	62106007	378001		0
69133	4090	40481087	1968-09-01	1968-09-01 00:00:00	1968-09-22	1968-09-22 00:00:00	32020		\N	271844	0	444814009	40481087		0
79913	4735	80180	2012-04-14	2012-04-14 00:00:00	\N	\N	32020		\N	315411	0	396275006	80180		0
58910	3495	40481087	2012-10-02	2012-10-02 00:00:00	2012-10-16	2012-10-16 00:00:00	32020		\N	231796	0	444814009	40481087		0
69565	4117	260139	1980-03-16	1980-03-16 00:00:00	1980-03-23	1980-03-23 00:00:00	32020		\N	273693	0	10509002	260139		0
69885	4134	40481087	1993-10-22	1993-10-22 00:00:00	1993-11-05	1993-11-05 00:00:00	32020		\N	274898	0	444814009	40481087		0
80645	4781	372328	1997-11-07	1997-11-07 00:00:00	1998-11-20	1998-11-20 00:00:00	32020		\N	318257	0	65363002	372328		0
59593	3532	40481087	2002-10-09	2002-10-09 00:00:00	2002-10-16	2002-10-16 00:00:00	32020		\N	234599	0	444814009	40481087		0
70365	4167	260139	2002-01-13	2002-01-13 00:00:00	2002-01-20	2002-01-20 00:00:00	32020		\N	276925	0	10509002	260139		0
81107	4811	192671	1999-12-03	1999-12-03 00:00:00	\N	\N	32020		\N	320049	0	K92.2	35208414		0
81241	4819	40481087	1998-03-15	1998-03-15 00:00:00	1998-03-29	1998-03-29 00:00:00	32020		\N	320587	0	444814009	40481087		0
70823	4202	28060	1981-12-30	1981-12-30 00:00:00	1982-01-11	1982-01-11 00:00:00	32020		\N	278982	0	43878008	28060		0
70942	4208	80809	1972-11-13	1972-11-13 00:00:00	1972-11-27	1972-11-27 00:00:00	32020		\N	279445	0	69896004	80809		0
60556	3580	4296204	1993-03-16	1993-03-16 00:00:00	1993-04-20	1993-04-20 00:00:00	32020		\N	237968	0	403190006	4296204		0
71294	4227	260139	1977-10-17	1977-10-17 00:00:00	1977-10-31	1977-10-31 00:00:00	32020		\N	280853	0	10509002	260139		0
71434	4238	40481087	2007-07-09	2007-07-09 00:00:00	2007-07-30	2007-07-30 00:00:00	32020		\N	281420	0	444814009	40481087		0
71698	4253	4112343	1986-11-24	1986-11-24 00:00:00	1986-12-01	1986-12-01 00:00:00	32020		\N	282439	0	195662009	4112343		0
71758	4256	260139	1958-03-09	1958-03-09 00:00:00	1958-03-16	1958-03-16 00:00:00	32020		\N	282580	0	10509002	260139		0
71932	4269	40481087	1994-10-04	1994-10-04 00:00:00	1994-10-25	1994-10-25 00:00:00	32020		\N	283356	0	444814009	40481087		0
72067	4276	40481087	1997-11-22	1997-11-22 00:00:00	1997-12-06	1997-12-06 00:00:00	32020		\N	283762	0	444814009	40481087		0
61752	3647	40481087	1991-02-01	1991-02-01 00:00:00	1991-02-15	1991-02-15 00:00:00	32020		\N	242720	0	444814009	40481087		0
83021	4932	260139	2002-10-12	2002-10-12 00:00:00	2002-10-26	2002-10-26 00:00:00	32020		\N	327827	0	10509002	260139		0
72698	4320	260139	2004-02-01	2004-02-01 00:00:00	2004-02-08	2004-02-08 00:00:00	32020		\N	286682	0	10509002	260139		0
72805	4328	260139	2016-03-07	2016-03-07 00:00:00	2016-03-21	2016-03-21 00:00:00	32020		\N	287020	0	10509002	260139		0
83581	4967	4112343	1970-01-16	1970-01-16 00:00:00	1970-01-23	1970-01-23 00:00:00	32020		\N	330156	0	195662009	4112343		0
73171	4348	81151	2000-11-01	2000-11-01 00:00:00	2000-11-15	2000-11-15 00:00:00	32020		\N	288319	0	44465007	81151		0
73261	4353	40481087	1978-12-07	1978-12-07 00:00:00	1978-12-28	1978-12-28 00:00:00	32020		\N	288801	0	444814009	40481087		0
84027	4990	28060	2008-02-04	2008-02-04 00:00:00	2008-02-12	2008-02-12 00:00:00	32020		\N	331986	0	43878008	28060		0
73560	4373	4084167	1976-07-04	1976-07-04 00:00:00	1976-07-04	1976-07-04 00:00:00	32020		\N	290372	0	241929008	4084167		0
84334	5013	40481087	1983-06-18	1983-06-18 00:00:00	1983-07-02	1983-07-02 00:00:00	32020		\N	333173	0	444814009	40481087		0
74015	4395	4283893	2013-12-03	2013-12-03 00:00:00	2014-02-11	2014-02-11 00:00:00	32020		\N	292268	0	36971009	4283893		0
74188	4406	4112343	2018-07-14	2018-07-14 00:00:00	2018-07-21	2018-07-21 00:00:00	32020		\N	292869	0	195662009	4112343		0
84849	5046	40481087	1971-04-10	1971-04-10 00:00:00	1971-04-17	1971-04-17 00:00:00	32020		\N	335300	0	444814009	40481087		0
63910	3776	260139	2006-10-08	2006-10-08 00:00:00	2006-10-15	2006-10-15 00:00:00	32020		\N	250984	0	10509002	260139		0
74616	4432	4296205	1959-05-16	1959-05-16 00:00:00	1959-06-13	1959-06-13 00:00:00	32020		\N	294583	0	403191005	4296205		0
64187	3790	4283893	2019-01-31	2019-01-31 00:00:00	2019-03-07	2019-03-07 00:00:00	32020		\N	252000	0	36971009	4283893		0
64327	3799	372328	1972-09-18	1972-09-18 00:00:00	1972-10-31	1972-10-31 00:00:00	32020		\N	252534	0	65363002	372328		0
64449	3807	4035415	1974-08-25	1974-08-25 00:00:00	1974-10-24	1974-10-24 00:00:00	32020		\N	253024	0	239720000	4035415		0
64736	3827	4152936	1977-10-09	1977-10-09 00:00:00	1977-10-23	1977-10-23 00:00:00	32020		\N	254188	0	283385000	4152936		0
54271	3215	40481087	1987-09-20	1987-09-20 00:00:00	1987-10-11	1987-10-11 00:00:00	32020		\N	213561	0	444814009	40481087		0
64978	3843	40481087	1983-09-12	1983-09-12 00:00:00	1983-09-19	1983-09-19 00:00:00	32020		\N	255067	0	444814009	40481087		0
65105	3851	260139	1935-12-31	1935-12-31 00:00:00	1936-01-14	1936-01-14 00:00:00	32020		\N	255509	0	10509002	260139		0
65287	3860	4112343	2013-09-16	2013-09-16 00:00:00	2013-09-26	2013-09-26 00:00:00	32020		\N	256322	0	195662009	4112343		0
65478	3871	260139	2010-12-15	2010-12-15 00:00:00	2010-12-22	2010-12-22 00:00:00	32020		\N	257022	0	10509002	260139		0
76213	4522	40481087	1977-04-09	1977-04-09 00:00:00	1977-04-30	1977-04-30 00:00:00	32020		\N	301108	0	444814009	40481087		0
76384	4530	4112343	2004-08-19	2004-08-19 00:00:00	2004-08-28	2004-08-28 00:00:00	32020		\N	301648	0	195662009	4112343		0
65986	3901	4112343	1941-06-03	1941-06-03 00:00:00	1941-06-15	1941-06-15 00:00:00	32020		\N	259401	0	195662009	4112343		0
66174	3916	40481087	2016-05-12	2016-05-12 00:00:00	2016-05-19	2016-05-19 00:00:00	32020		\N	260301	0	444814009	40481087		0
66354	3928	28060	2006-06-02	2006-06-02 00:00:00	2006-06-14	2006-06-14 00:00:00	32020		\N	261137	0	43878008	28060		0
66453	3934	40481087	1957-05-09	1957-05-09 00:00:00	1957-05-30	1957-05-30 00:00:00	32020		\N	261489	0	444814009	40481087		0
77241	4576	372328	1955-04-25	1955-04-25 00:00:00	1955-07-06	1955-07-06 00:00:00	32020		\N	304856	0	65363002	372328		0
66869	3956	40481087	2002-01-14	2002-01-14 00:00:00	2002-02-04	2002-02-04 00:00:00	32020		\N	262999	0	444814009	40481087		0
67009	3962	40481087	1989-08-15	1989-08-15 00:00:00	1989-08-22	1989-08-22 00:00:00	32020		\N	263440	0	444814009	40481087		0
67153	3968	4109685	1952-02-29	1952-02-29 00:00:00	1952-03-14	1952-03-14 00:00:00	32020		\N	263904	0	284551006	4109685		0
77988	4622	372328	1957-09-17	1957-09-17 00:00:00	1958-01-02	1958-01-02 00:00:00	32020		\N	307797	0	65363002	372328		0
67520	3989	40481087	2014-12-24	2014-12-24 00:00:00	2015-01-14	2015-01-14 00:00:00	32020		\N	265253	0	444814009	40481087		0
67642	3996	4218389	2016-06-22	2016-06-22 00:00:00	2016-07-13	2016-07-13 00:00:00	32020		\N	265698	0	39848009	4218389		0
67791	4006	81151	2011-04-30	2011-04-30 00:00:00	2011-05-28	2011-05-28 00:00:00	32020		\N	266146	0	44465007	81151		0
68020	4018	40481087	1997-02-06	1997-02-06 00:00:00	1997-02-13	1997-02-13 00:00:00	32020		\N	267059	0	444814009	40481087		0
68138	4024	261325	2003-08-24	2003-08-24 00:00:00	\N	\N	32020		\N	267535	0	87433001	261325		0
78896	4674	40481087	2006-03-28	2006-03-28 00:00:00	2006-04-04	2006-04-04 00:00:00	32020		\N	311417	0	444814009	40481087		0
68513	4051	40481087	2011-05-30	2011-05-30 00:00:00	2011-06-13	2011-06-13 00:00:00	32020		\N	269268	0	444814009	40481087		0
79183	4689	260139	1981-07-27	1981-07-27 00:00:00	1981-08-03	1981-08-03 00:00:00	32020		\N	312441	0	10509002	260139		0
79354	4700	40481087	1977-01-12	1977-01-12 00:00:00	1977-01-19	1977-01-19 00:00:00	32020		\N	313033	0	444814009	40481087		0
68901	4078	40486433	1953-08-12	1953-08-12 00:00:00	1993-07-12	1993-07-12 00:00:00	32020		\N	270949	0	446096008	40486433		0
69134	4091	192671	2009-06-12	2009-06-12 00:00:00	\N	\N	32020		\N	271950	0	K92.2	35208414		0
64219	3791	192671	1947-12-25	1947-12-25 00:00:00	\N	\N	32020		\N	252116	0	K92.2	35208414		0
79914	4735	4112343	1980-05-14	1980-05-14 00:00:00	1980-05-25	1980-05-25 00:00:00	32020		\N	315413	0	195662009	4112343		0
58911	3495	40481087	1981-01-14	1981-01-14 00:00:00	1981-02-04	1981-02-04 00:00:00	32020		\N	231827	0	444814009	40481087		0
69566	4117	40481087	1972-11-20	1972-11-20 00:00:00	1972-11-27	1972-11-27 00:00:00	32020		\N	273692	0	444814009	40481087		0
69886	4134	40481087	1961-07-09	1961-07-09 00:00:00	1961-07-30	1961-07-30 00:00:00	32020		\N	274823	0	444814009	40481087		0
80646	4781	4142905	2007-05-17	2007-05-17 00:00:00	2007-08-15	2007-08-15 00:00:00	32020		\N	318276	0	33737001	4142905		0
59594	3532	4112343	2018-07-19	2018-07-19 00:00:00	2018-07-28	2018-07-28 00:00:00	32020		\N	234649	0	195662009	4112343		0
70366	4167	372328	1979-08-16	1979-08-16 00:00:00	1979-11-28	1979-11-28 00:00:00	32020		\N	276928	0	65363002	372328		0
81108	4811	78272	1992-04-09	1992-04-09 00:00:00	1992-04-23	1992-04-23 00:00:00	32020		\N	320050	0	70704007	78272		0
81242	4819	4156265	1988-01-23	1988-01-23 00:00:00	1988-02-06	1988-02-06 00:00:00	32020		\N	320546	0	370247008	4156265		0
70824	4202	40481087	1999-11-15	1999-11-15 00:00:00	1999-11-22	1999-11-22 00:00:00	32020		\N	278983	0	444814009	40481087		0
70943	4208	372328	1940-05-15	1940-05-15 00:00:00	1940-10-29	1940-10-29 00:00:00	32020		\N	279452	0	65363002	372328		0
60557	3580	40481087	1995-10-20	1995-10-20 00:00:00	1995-10-27	1995-10-27 00:00:00	32020		\N	237983	0	444814009	40481087		0
71295	4227	81151	2007-09-06	2007-09-06 00:00:00	2007-10-04	2007-10-04 00:00:00	32020		\N	280799	0	44465007	81151		0
71435	4238	40481087	1979-11-22	1979-11-22 00:00:00	1979-11-29	1979-11-29 00:00:00	32020		\N	281404	0	444814009	40481087		0
71699	4253	260139	2017-06-12	2017-06-12 00:00:00	2017-06-26	2017-06-26 00:00:00	32020		\N	282460	0	10509002	260139		0
71759	4256	40481087	1974-08-12	1974-08-12 00:00:00	1974-08-19	1974-08-19 00:00:00	32020		\N	282609	0	444814009	40481087		0
71934	4269	4112343	1981-10-04	1981-10-04 00:00:00	1981-10-12	1981-10-12 00:00:00	32020		\N	283366	0	195662009	4112343		0
72068	4276	40481087	2006-07-01	2006-07-01 00:00:00	2006-07-08	2006-07-08 00:00:00	32020		\N	283729	0	444814009	40481087		0
72211	4284	40481087	2012-06-02	2012-06-02 00:00:00	2012-06-23	2012-06-23 00:00:00	32020		\N	284332	0	444814009	40481087		0
83022	4932	40481087	1973-12-25	1973-12-25 00:00:00	1974-01-08	1974-01-08 00:00:00	32020		\N	327808	0	444814009	40481087		0
72699	4320	260139	2018-07-22	2018-07-22 00:00:00	2018-07-29	2018-07-29 00:00:00	32020		\N	286679	0	10509002	260139		0
72806	4328	4278672	1995-06-22	1995-06-22 00:00:00	1995-09-20	1995-09-20 00:00:00	32020		\N	287016	0	65966004	4278672		0
83582	4967	4283893	1978-09-02	1978-09-02 00:00:00	1978-10-28	1978-10-28 00:00:00	32020		\N	330183	0	36971009	4283893		0
73172	4348	40481087	1992-06-27	1992-06-27 00:00:00	1992-07-11	1992-07-11 00:00:00	32020		\N	288376	0	444814009	40481087		0
73273	4355	40481087	1996-08-23	1996-08-23 00:00:00	1996-09-06	1996-09-06 00:00:00	32020		\N	288990	0	444814009	40481087		0
84028	4990	4294548	1982-05-14	1982-05-14 00:00:00	1982-06-04	1982-06-04 00:00:00	32020		\N	331976	0	75498004	4294548		0
73561	4373	192671	2018-02-04	2018-02-04 00:00:00	\N	\N	32020		\N	290374	0	K92.2	35208414		0
84335	5013	260139	1966-10-12	1966-10-12 00:00:00	1966-10-19	1966-10-19 00:00:00	32020		\N	333203	0	10509002	260139		0
84568	5031	40481087	2009-09-11	2009-09-11 00:00:00	2009-09-25	2009-09-25 00:00:00	32020		\N	334319	0	444814009	40481087		0
74189	4406	372328	2004-07-06	2004-07-06 00:00:00	2005-02-05	2005-02-05 00:00:00	32020		\N	292945	0	65363002	372328		0
84850	5046	40481087	2008-04-14	2008-04-14 00:00:00	2008-04-28	2008-04-28 00:00:00	32020		\N	335301	0	444814009	40481087		0
74413	4418	40481087	1952-10-24	1952-10-24 00:00:00	1952-11-14	1952-11-14 00:00:00	32020		\N	293758	0	444814009	40481087		0
74617	4432	40481087	2012-10-17	2012-10-17 00:00:00	2012-11-07	2012-11-07 00:00:00	32020		\N	294591	0	444814009	40481087		0
64188	3790	80180	2001-11-03	2001-11-03 00:00:00	\N	\N	32020		\N	251979	0	396275006	80180		0
64328	3799	4112343	2013-12-26	2013-12-26 00:00:00	2014-01-04	2014-01-04 00:00:00	32020		\N	252591	0	195662009	4112343		0
64450	3807	4112343	1965-06-15	1965-06-15 00:00:00	1965-06-27	1965-06-27 00:00:00	32020		\N	252977	0	195662009	4112343		0
64737	3827	260139	1967-08-03	1967-08-03 00:00:00	1967-08-17	1967-08-17 00:00:00	32020		\N	254174	0	10509002	260139		0
54272	3215	28060	2007-10-08	2007-10-08 00:00:00	2007-10-15	2007-10-15 00:00:00	32020		\N	213598	0	43878008	28060		0
64979	3843	80180	2008-06-21	2008-06-21 00:00:00	\N	\N	32020		\N	255096	0	396275006	80180		0
65106	3851	40481087	1912-05-31	1912-05-31 00:00:00	1912-06-07	1912-06-07 00:00:00	32020		\N	255560	0	444814009	40481087		0
65288	3860	260139	1986-09-24	1986-09-24 00:00:00	1986-10-01	1986-10-01 00:00:00	32020		\N	256329	0	10509002	260139		0
65479	3871	372328	2003-09-24	2003-09-24 00:00:00	2004-09-22	2004-09-22 00:00:00	32020		\N	257040	0	65363002	372328		0
76214	4522	4112343	2003-09-08	2003-09-08 00:00:00	2003-09-21	2003-09-21 00:00:00	32020		\N	301136	0	195662009	4112343		0
76385	4531	260139	2009-12-24	2009-12-24 00:00:00	2009-12-31	2009-12-31 00:00:00	32020		\N	301754	0	10509002	260139		0
65987	3901	260139	1993-11-03	1993-11-03 00:00:00	1993-11-17	1993-11-17 00:00:00	32020		\N	259447	0	10509002	260139		0
66175	3917	4283893	1983-06-22	1983-06-22 00:00:00	1984-08-22	1984-08-22 00:00:00	32020		\N	260499	0	36971009	4283893		0
66355	3928	440448	1995-12-06	1995-12-06 00:00:00	\N	\N	32020		\N	261132	0	74400008	440448		0
66454	3934	4283893	1988-02-01	1988-02-01 00:00:00	1988-03-07	1988-03-07 00:00:00	32020		\N	261479	0	36971009	4283893		0
77242	4576	4237458	1962-02-15	1962-02-15 00:00:00	1962-04-16	1962-04-16 00:00:00	32020		\N	304850	0	58150001	4237458		0
66870	3956	372328	1974-12-10	1974-12-10 00:00:00	1975-01-05	1975-01-05 00:00:00	32020		\N	263002	0	65363002	372328		0
67010	3962	4296204	1999-09-08	1999-09-08 00:00:00	1999-10-13	1999-10-13 00:00:00	32020		\N	263464	0	403190006	4296204		0
67154	3968	257012	1934-11-19	1934-11-19 00:00:00	\N	\N	32020		\N	263827	0	40055000	257012		0
77989	4622	260139	1996-01-15	1996-01-15 00:00:00	1996-01-29	1996-01-29 00:00:00	32020		\N	307807	0	10509002	260139		0
67521	3989	80502	2018-01-29	2018-01-29 00:00:00	\N	\N	32020		\N	265193	0	64859006	80502		0
67643	3996	28060	1979-07-03	1979-07-03 00:00:00	1979-07-11	1979-07-11 00:00:00	32020		\N	265665	0	43878008	28060		0
67792	4006	4027663	1982-12-13	1982-12-13 00:00:00	\N	\N	32020		\N	266205	0	13200003	4027663		0
68021	4018	192671	2001-09-09	2001-09-09 00:00:00	\N	\N	32020		\N	267047	0	K92.2	35208414		0
68139	4024	40481087	2000-05-16	2000-05-16 00:00:00	2000-05-23	2000-05-23 00:00:00	32020		\N	267531	0	444814009	40481087		0
78897	4674	260139	2006-04-17	2006-04-17 00:00:00	2006-04-24	2006-04-24 00:00:00	32020		\N	311366	0	10509002	260139		0
68514	4051	81151	1982-05-04	1982-05-04 00:00:00	1982-06-08	1982-06-08 00:00:00	32020		\N	269261	0	44465007	81151		0
79184	4689	40481087	1968-04-09	1968-04-09 00:00:00	1968-04-16	1968-04-16 00:00:00	32020		\N	312428	0	444814009	40481087		0
79355	4700	40481087	1962-11-26	1962-11-26 00:00:00	1962-12-10	1962-12-10 00:00:00	32020		\N	313022	0	444814009	40481087		0
68902	4078	4112343	2006-07-26	2006-07-26 00:00:00	2006-08-06	2006-08-06 00:00:00	32020		\N	271080	0	195662009	4112343		0
69135	4091	4116491	1987-11-21	1987-11-21 00:00:00	1988-01-10	1988-01-10 00:00:00	32020		\N	271988	0	301011002	4116491		0
79915	4735	40481087	1995-05-13	1995-05-13 00:00:00	1995-05-20	1995-05-20 00:00:00	32020		\N	315410	0	444814009	40481087		0
58912	3495	4116491	2017-06-03	2017-06-03 00:00:00	2017-07-15	2017-07-15 00:00:00	32020		\N	231855	0	301011002	4116491		0
69567	4117	260139	1998-11-05	1998-11-05 00:00:00	1998-11-12	1998-11-12 00:00:00	32020		\N	273682	0	10509002	260139		0
80345	4759	4218389	1980-12-25	1980-12-25 00:00:00	1981-01-29	1981-01-29 00:00:00	32020		\N	317117	0	39848009	4218389		0
80647	4781	40481087	1991-05-18	1991-05-18 00:00:00	1991-06-08	1991-06-08 00:00:00	32020		\N	318292	0	444814009	40481087		0
70085	4149	4109685	2006-04-26	2006-04-26 00:00:00	2006-05-10	2006-05-10 00:00:00	32020		\N	275760	0	284551006	4109685		0
70367	4167	40481087	1983-03-27	1983-03-27 00:00:00	1983-04-17	1983-04-17 00:00:00	32020		\N	276921	0	444814009	40481087		0
81109	4811	4113008	2011-02-17	2011-02-17 00:00:00	2011-03-10	2011-03-10 00:00:00	32020		\N	320053	0	284549007	4113008		0
81243	4819	40481087	1966-01-22	1966-01-22 00:00:00	1966-01-29	1966-01-29 00:00:00	32020		\N	320511	0	444814009	40481087		0
70825	4202	40486433	1976-05-20	1976-05-20 00:00:00	\N	\N	32020		\N	278980	0	446096008	40486433		0
70944	4208	4237458	1944-11-20	1944-11-20 00:00:00	1944-12-20	1944-12-20 00:00:00	32020		\N	279425	0	58150001	4237458		0
60558	3580	40481087	1994-10-02	1994-10-02 00:00:00	1994-10-16	1994-10-16 00:00:00	32020		\N	237997	0	444814009	40481087		0
71296	4227	321042	2003-04-06	2003-04-06 00:00:00	\N	\N	32020		\N	280798	0	410429000	321042		0
71436	4238	40481087	1999-02-23	1999-02-23 00:00:00	1999-03-16	1999-03-16 00:00:00	32020		\N	281409	0	444814009	40481087		0
71700	4253	4027663	2010-12-15	2010-12-15 00:00:00	\N	\N	32020		\N	282443	0	13200003	4027663		0
71760	4256	4112343	1997-09-22	1997-09-22 00:00:00	1997-09-30	1997-09-30 00:00:00	32020		\N	282585	0	195662009	4112343		0
71935	4269	4112343	1988-08-10	1988-08-10 00:00:00	1988-08-23	1988-08-23 00:00:00	32020		\N	283305	0	195662009	4112343		0
72069	4276	260139	1995-08-07	1995-08-07 00:00:00	1995-08-21	1995-08-21 00:00:00	32020		\N	283728	0	10509002	260139		0
72212	4284	28060	1998-04-01	1998-04-01 00:00:00	1998-04-08	1998-04-08 00:00:00	32020		\N	284394	0	43878008	28060		0
83023	4932	4112343	2019-04-24	2019-04-24 00:00:00	2019-05-06	2019-05-06 00:00:00	32020		\N	327829	0	195662009	4112343		0
72700	4320	40481087	1994-12-27	1994-12-27 00:00:00	1995-01-03	1995-01-03 00:00:00	32020		\N	286677	0	444814009	40481087		0
72807	4328	260139	2003-08-06	2003-08-06 00:00:00	2003-08-20	2003-08-20 00:00:00	32020		\N	287035	0	10509002	260139		0
83608	4970	40481087	1926-05-27	1926-05-27 00:00:00	1926-06-03	1926-06-03 00:00:00	32020		\N	330490	0	444814009	40481087		0
73173	4349	40481087	2016-08-05	2016-08-05 00:00:00	2016-08-12	2016-08-12 00:00:00	32020		\N	288388	0	444814009	40481087		0
73274	4355	4109685	2017-05-07	2017-05-07 00:00:00	2017-05-28	2017-05-28 00:00:00	32020		\N	288964	0	284551006	4109685		0
84029	4990	40481087	1995-09-15	1995-09-15 00:00:00	1995-09-29	1995-09-29 00:00:00	32020		\N	331963	0	444814009	40481087		0
73562	4373	40481087	1979-08-23	1979-08-23 00:00:00	1979-08-30	1979-08-30 00:00:00	32020		\N	290414	0	444814009	40481087		0
84336	5013	4113008	2003-04-11	2003-04-11 00:00:00	2003-04-25	2003-04-25 00:00:00	32020		\N	333200	0	284549007	4113008		0
84569	5031	40481087	1930-08-30	1930-08-30 00:00:00	1930-09-20	1930-09-20 00:00:00	32020		\N	334325	0	444814009	40481087		0
74190	4406	378001	1947-09-22	1947-09-22 00:00:00	1947-10-22	1947-10-22 00:00:00	32020		\N	292859	0	62106007	378001		0
84851	5046	4112343	2002-07-24	2002-07-24 00:00:00	2002-08-03	2002-08-03 00:00:00	32020		\N	335364	0	195662009	4112343		0
74414	4418	260139	1992-10-21	1992-10-21 00:00:00	1992-10-28	1992-10-28 00:00:00	32020		\N	293719	0	10509002	260139		0
74618	4432	40481087	1986-04-28	1986-04-28 00:00:00	1986-05-19	1986-05-19 00:00:00	32020		\N	294615	0	444814009	40481087		0
64189	3790	260139	2005-05-01	2005-05-01 00:00:00	2005-05-08	2005-05-08 00:00:00	32020		\N	251981	0	10509002	260139		0
64329	3799	81151	1980-07-08	1980-07-08 00:00:00	1980-07-22	1980-07-22 00:00:00	32020		\N	252527	0	44465007	81151		0
64451	3807	4059173	1956-01-02	1956-01-02 00:00:00	1956-03-02	1956-03-02 00:00:00	32020		\N	253023	0	16114001	4059173		0
64738	3827	260139	1961-07-31	1961-07-31 00:00:00	1961-08-07	1961-08-07 00:00:00	32020		\N	254156	0	10509002	260139		0
54273	3215	260139	2016-07-21	2016-07-21 00:00:00	2016-08-04	2016-08-04 00:00:00	32020		\N	213581	0	10509002	260139		0
64980	3843	81151	2007-11-19	2007-11-19 00:00:00	2007-12-10	2007-12-10 00:00:00	32020		\N	255096	0	44465007	81151		0
65107	3851	40481087	1951-10-21	1951-10-21 00:00:00	1951-10-28	1951-10-28 00:00:00	32020		\N	255598	0	444814009	40481087		0
65289	3860	4109685	1994-02-21	1994-02-21 00:00:00	1994-03-07	1994-03-07 00:00:00	32020		\N	256339	0	284551006	4109685		0
65480	3871	40481087	2018-10-12	2018-10-12 00:00:00	2018-10-19	2018-10-19 00:00:00	32020		\N	257064	0	444814009	40481087		0
76215	4522	372328	1981-03-13	1981-03-13 00:00:00	1981-12-25	1981-12-25 00:00:00	32020		\N	301118	0	65363002	372328		0
76386	4531	260139	1949-05-21	1949-05-21 00:00:00	1949-06-04	1949-06-04 00:00:00	32020		\N	301814	0	10509002	260139		0
65988	3901	260139	1942-11-14	1942-11-14 00:00:00	1942-11-21	1942-11-21 00:00:00	32020		\N	259425	0	10509002	260139		0
66176	3917	80180	2000-05-21	2000-05-21 00:00:00	\N	\N	32020		\N	260469	0	396275006	80180		0
66356	3928	40481087	2006-06-17	2006-06-17 00:00:00	2006-07-01	2006-07-01 00:00:00	32020		\N	261112	0	444814009	40481087		0
66455	3934	40481087	1955-08-25	1955-08-25 00:00:00	1955-09-08	1955-09-08 00:00:00	32020		\N	261449	0	444814009	40481087		0
77243	4576	4112343	1970-03-21	1970-03-21 00:00:00	1970-04-03	1970-04-03 00:00:00	32020		\N	304800	0	195662009	4112343		0
66871	3956	4237458	1924-06-18	1924-06-18 00:00:00	1924-08-17	1924-08-17 00:00:00	32020		\N	262903	0	58150001	4237458		0
67011	3962	4156265	1981-09-21	1981-09-21 00:00:00	1981-10-12	1981-10-12 00:00:00	32020		\N	263463	0	370247008	4156265		0
67155	3968	4112343	1939-07-30	1939-07-30 00:00:00	1939-08-11	1939-08-11 00:00:00	32020		\N	263850	0	195662009	4112343		0
77990	4622	375671	1979-05-30	1979-05-30 00:00:00	1979-07-29	1979-07-29 00:00:00	32020		\N	307829	0	62564004	375671		0
67522	3989	40481087	1943-12-04	1943-12-04 00:00:00	1943-12-25	1943-12-25 00:00:00	32020		\N	265152	0	444814009	40481087		0
67644	3996	4112343	1995-09-19	1995-09-19 00:00:00	1995-09-27	1995-09-27 00:00:00	32020		\N	265687	0	195662009	4112343		0
67793	4006	40481087	1950-01-21	1950-01-21 00:00:00	1950-01-28	1950-01-28 00:00:00	32020		\N	266159	0	444814009	40481087		0
68022	4018	40481087	1986-02-22	1986-02-22 00:00:00	1986-03-01	1986-03-01 00:00:00	32020		\N	267105	0	444814009	40481087		0
68140	4024	260139	2006-04-29	2006-04-29 00:00:00	2006-05-13	2006-05-13 00:00:00	32020		\N	267558	0	10509002	260139		0
78898	4674	4218389	1971-09-04	1971-09-04 00:00:00	1971-10-02	1971-10-02 00:00:00	32020		\N	311378	0	39848009	4218389		0
68515	4051	372328	1979-04-15	1979-04-15 00:00:00	1980-01-02	1980-01-02 00:00:00	32020		\N	269255	0	65363002	372328		0
79185	4689	4285898	2007-01-14	2007-01-14 00:00:00	\N	\N	32020		\N	312450	0	68496003	4285898		0
79356	4700	40481087	1979-06-15	1979-06-15 00:00:00	1979-06-29	1979-06-29 00:00:00	32020		\N	313107	0	444814009	40481087		0
68903	4078	40481087	2014-06-16	2014-06-16 00:00:00	2014-06-30	2014-06-30 00:00:00	32020		\N	271071	0	444814009	40481087		0
69136	4091	372328	1970-09-11	1970-09-11 00:00:00	1970-11-22	1970-11-22 00:00:00	32020		\N	271990	0	65363002	372328		0
79916	4735	4237458	1982-04-17	1982-04-17 00:00:00	1982-07-16	1982-07-16 00:00:00	32020		\N	315451	0	58150001	4237458		0
58913	3495	260139	1979-05-06	1979-05-06 00:00:00	1979-05-20	1979-05-20 00:00:00	32020		\N	231807	0	10509002	260139		0
69568	4117	372328	1965-04-16	1965-04-16 00:00:00	1965-05-21	1965-05-21 00:00:00	32020		\N	273697	0	65363002	372328		0
80346	4759	4283893	2011-06-26	2011-06-26 00:00:00	2012-04-01	2012-04-01 00:00:00	32020		\N	317090	0	36971009	4283893		0
80649	4781	40481087	1983-06-29	1983-06-29 00:00:00	1983-07-20	1983-07-20 00:00:00	32020		\N	318290	0	444814009	40481087		0
70086	4149	4112343	2008-06-18	2008-06-18 00:00:00	2008-06-29	2008-06-29 00:00:00	32020		\N	275714	0	195662009	4112343		0
70368	4167	4112343	1981-11-18	1981-11-18 00:00:00	1981-11-29	1981-11-29 00:00:00	32020		\N	276980	0	195662009	4112343		0
81110	4811	40481087	2012-07-01	2012-07-01 00:00:00	2012-07-08	2012-07-08 00:00:00	32020		\N	320019	0	444814009	40481087		0
81244	4819	40481087	1984-04-23	1984-04-23 00:00:00	1984-04-30	1984-04-30 00:00:00	32020		\N	320586	0	444814009	40481087		0
70826	4202	4112343	2016-04-10	2016-04-10 00:00:00	2016-04-21	2016-04-21 00:00:00	32020		\N	278969	0	195662009	4112343		0
70945	4208	4112343	1976-09-06	1976-09-06 00:00:00	1976-09-16	1976-09-16 00:00:00	32020		\N	279349	0	195662009	4112343		0
60559	3580	40481087	2008-09-26	2008-09-26 00:00:00	2008-10-10	2008-10-10 00:00:00	32020		\N	238005	0	444814009	40481087		0
71298	4227	4112343	1961-05-27	1961-05-27 00:00:00	1961-06-03	1961-06-03 00:00:00	32020		\N	280819	0	195662009	4112343		0
71437	4238	4109685	1998-10-21	1998-10-21 00:00:00	1998-11-04	1998-11-04 00:00:00	32020		\N	281384	0	284551006	4109685		0
71701	4253	4112343	2010-11-24	2010-11-24 00:00:00	2010-12-06	2010-12-06 00:00:00	32020		\N	282443	0	195662009	4112343		0
71761	4256	80180	1992-06-12	1992-06-12 00:00:00	\N	\N	32020		\N	282614	0	396275006	80180		0
71936	4269	4112343	1973-09-03	1973-09-03 00:00:00	1973-09-13	1973-09-13 00:00:00	32020		\N	283365	0	195662009	4112343		0
72070	4276	260139	1964-01-07	1964-01-07 00:00:00	1964-01-21	1964-01-21 00:00:00	32020		\N	283774	0	10509002	260139		0
72213	4284	4112343	1947-03-14	1947-03-14 00:00:00	1947-03-22	1947-03-22 00:00:00	32020		\N	284325	0	195662009	4112343		0
83024	4932	4112343	2000-03-12	2000-03-12 00:00:00	2000-03-19	2000-03-19 00:00:00	32020		\N	327882	0	195662009	4112343		0
72701	4320	40481087	2013-06-04	2013-06-04 00:00:00	2013-06-11	2013-06-11 00:00:00	32020		\N	286664	0	444814009	40481087		0
72808	4328	40481087	2006-02-02	2006-02-02 00:00:00	2006-02-23	2006-02-23 00:00:00	32020		\N	287018	0	444814009	40481087		0
83609	4970	40481087	1980-04-18	1980-04-18 00:00:00	1980-04-25	1980-04-25 00:00:00	32020		\N	330360	0	444814009	40481087		0
73174	4349	4112343	1999-06-19	1999-06-19 00:00:00	1999-06-29	1999-06-29 00:00:00	32020		\N	288422	0	195662009	4112343		0
73275	4355	30753	2017-12-30	2017-12-30 00:00:00	\N	\N	32020		\N	288964	0	16761005	30753		0
84030	4990	40481087	2012-12-24	2012-12-24 00:00:00	2012-12-31	2012-12-31 00:00:00	32020		\N	331958	0	444814009	40481087		0
73563	4373	40481087	2011-07-28	2011-07-28 00:00:00	2011-08-11	2011-08-11 00:00:00	32020		\N	290439	0	444814009	40481087		0
84337	5013	4112343	1973-04-07	1973-04-07 00:00:00	1973-04-17	1973-04-17 00:00:00	32020		\N	333172	0	195662009	4112343		0
84570	5031	40481087	1938-05-12	1938-05-12 00:00:00	1938-05-19	1938-05-19 00:00:00	32020		\N	334273	0	444814009	40481087		0
74191	4406	40481087	1943-07-20	1943-07-20 00:00:00	1943-07-27	1943-07-27 00:00:00	32020		\N	292890	0	444814009	40481087		0
84852	5046	4296204	1992-08-18	1992-08-18 00:00:00	1992-09-15	1992-09-15 00:00:00	32020		\N	335340	0	403190006	4296204		0
74415	4418	28060	1959-04-20	1959-04-20 00:00:00	1959-05-03	1959-05-03 00:00:00	32020		\N	293715	0	43878008	28060		0
74619	4432	40481087	1965-03-10	1965-03-10 00:00:00	1965-03-24	1965-03-24 00:00:00	32020		\N	294629	0	444814009	40481087		0
64190	3790	378001	1983-10-14	1983-10-14 00:00:00	1983-12-13	1983-12-13 00:00:00	32020		\N	252010	0	62106007	378001		0
64330	3799	40481087	1987-08-30	1987-08-30 00:00:00	1987-09-20	1987-09-20 00:00:00	32020		\N	252564	0	444814009	40481087		0
64452	3807	40481087	1983-06-07	1983-06-07 00:00:00	1983-06-28	1983-06-28 00:00:00	32020		\N	252998	0	444814009	40481087		0
64739	3827	80180	2001-08-29	2001-08-29 00:00:00	\N	\N	32020		\N	254215	0	396275006	80180		0
54274	3215	80180	2018-01-11	2018-01-11 00:00:00	\N	\N	32020		\N	213628	0	396275006	80180		0
64981	3843	4112343	2013-06-20	2013-06-20 00:00:00	2013-07-03	2013-07-03 00:00:00	32020		\N	255070	0	195662009	4112343		0
65108	3851	80180	1948-10-08	1948-10-08 00:00:00	\N	\N	32020		\N	255531	0	396275006	80180		0
65291	3860	260139	2014-02-07	2014-02-07 00:00:00	2014-02-14	2014-02-14 00:00:00	32020		\N	256283	0	10509002	260139		0
65481	3871	260139	1969-11-20	1969-11-20 00:00:00	1969-12-04	1969-12-04 00:00:00	32020		\N	257036	0	10509002	260139		0
76216	4522	4112343	1988-09-12	1988-09-12 00:00:00	1988-09-23	1988-09-23 00:00:00	32020		\N	301128	0	195662009	4112343		0
76387	4531	260139	1941-09-17	1941-09-17 00:00:00	1941-10-01	1941-10-01 00:00:00	32020		\N	301739	0	10509002	260139		0
65989	3901	40481087	1954-06-29	1954-06-29 00:00:00	1954-07-20	1954-07-20 00:00:00	32020		\N	259403	0	444814009	40481087		0
66177	3917	260139	1994-01-20	1994-01-20 00:00:00	1994-02-03	1994-02-03 00:00:00	32020		\N	260449	0	10509002	260139		0
66357	3928	372328	1982-09-24	1982-09-24 00:00:00	1982-11-14	1982-11-14 00:00:00	32020		\N	261114	0	65363002	372328		0
66456	3934	4283893	2014-10-17	2014-10-17 00:00:00	2015-03-06	2015-03-06 00:00:00	32020		\N	261419	0	36971009	4283893		0
77244	4576	78272	1957-08-12	1957-08-12 00:00:00	1957-09-09	1957-09-09 00:00:00	32020		\N	304849	0	70704007	78272		0
66872	3956	260139	1924-03-22	1924-03-22 00:00:00	1924-04-05	1924-04-05 00:00:00	32020		\N	263025	0	10509002	260139		0
67012	3962	4027663	1979-05-11	1979-05-11 00:00:00	\N	\N	32020		\N	263425	0	13200003	4027663		0
67156	3968	80502	1994-01-21	1994-01-21 00:00:00	\N	\N	32020		\N	263869	0	64859006	80502		0
77991	4622	81893	1995-12-12	1995-12-12 00:00:00	\N	\N	32020		\N	307791	0	64766004	81893		0
67523	3989	4112343	1972-06-18	1972-06-18 00:00:00	1972-06-29	1972-06-29 00:00:00	32020		\N	265157	0	195662009	4112343		0
67645	3996	4027663	1996-11-05	1996-11-05 00:00:00	\N	\N	32020		\N	265687	0	13200003	4027663		0
67794	4006	28060	1993-07-12	1993-07-12 00:00:00	1993-07-19	1993-07-19 00:00:00	32020		\N	266162	0	43878008	28060		0
68023	4018	260139	1990-05-04	1990-05-04 00:00:00	1990-05-11	1990-05-11 00:00:00	32020		\N	267054	0	10509002	260139		0
68141	4024	4001336	1988-05-10	1988-05-10 00:00:00	1988-06-09	1988-06-09 00:00:00	32020		\N	267529	0	110030002	4001336		0
78899	4674	372328	1969-01-17	1969-01-17 00:00:00	1969-04-29	1969-04-29 00:00:00	32020		\N	311369	0	65363002	372328		0
68516	4051	28060	1986-12-11	1986-12-11 00:00:00	1986-12-24	1986-12-24 00:00:00	32020		\N	269235	0	43878008	28060		0
79186	4689	80180	2007-10-12	2007-10-12 00:00:00	\N	\N	32020		\N	312450	0	396275006	80180		0
79357	4700	4027663	1980-05-14	1980-05-14 00:00:00	\N	\N	32020		\N	313107	0	13200003	4027663		0
68904	4078	4112343	2007-05-07	2007-05-07 00:00:00	2007-05-15	2007-05-15 00:00:00	32020		\N	271092	0	195662009	4112343		0
69137	4091	257012	1983-12-31	1983-12-31 00:00:00	\N	\N	32020		\N	271993	0	40055000	257012		0
79917	4735	4237458	2011-01-15	2011-01-15 00:00:00	2011-04-15	2011-04-15 00:00:00	32020		\N	315454	0	58150001	4237458		0
58914	3495	4152936	1975-05-25	1975-05-25 00:00:00	1975-06-15	1975-06-15 00:00:00	32020		\N	231812	0	283385000	4152936		0
69569	4117	4112343	1970-03-02	1970-03-02 00:00:00	1970-03-10	1970-03-10 00:00:00	32020		\N	273711	0	195662009	4112343		0
80347	4759	40481087	2009-03-25	2009-03-25 00:00:00	2009-04-01	2009-04-01 00:00:00	32020		\N	317089	0	444814009	40481087		0
80650	4781	260139	1998-12-03	1998-12-03 00:00:00	1998-12-10	1998-12-10 00:00:00	32020		\N	318293	0	10509002	260139		0
70087	4149	372328	1968-06-22	1968-06-22 00:00:00	1968-11-22	1968-11-22 00:00:00	32020		\N	275715	0	65363002	372328		0
70369	4167	28060	1983-10-24	1983-10-24 00:00:00	1983-11-02	1983-11-02 00:00:00	32020		\N	276908	0	43878008	28060		0
81111	4811	40481087	1964-10-08	1964-10-08 00:00:00	1964-10-28	1964-10-28 00:00:00	32020		\N	320064	0	444814009	40481087		0
81245	4819	4230399	1976-09-22	1976-09-22 00:00:00	1976-11-21	1976-11-21 00:00:00	32020		\N	320545	0	359817006	4230399		0
70827	4202	4084167	1972-10-06	1972-10-06 00:00:00	1972-10-06	1972-10-06 00:00:00	32020		\N	278926	0	241929008	4084167		0
70946	4208	40481087	1952-11-14	1952-11-14 00:00:00	1952-12-05	1952-12-05 00:00:00	32020		\N	279397	0	444814009	40481087		0
60560	3580	40481087	2007-08-08	2007-08-08 00:00:00	2007-08-29	2007-08-29 00:00:00	32020		\N	237972	0	444814009	40481087		0
71299	4227	372328	1957-08-31	1957-08-31 00:00:00	1958-01-19	1958-01-19 00:00:00	32020		\N	280856	0	65363002	372328		0
71438	4238	195588	1992-11-16	1992-11-16 00:00:00	1993-01-06	1993-01-06 00:00:00	32020		\N	281363	0	38822007	195588		0
71702	4253	192671	2018-10-25	2018-10-25 00:00:00	\N	\N	32020		\N	282429	0	K92.2	35208414		0
71762	4256	40481087	1992-01-04	1992-01-04 00:00:00	1992-01-11	1992-01-11 00:00:00	32020		\N	282614	0	444814009	40481087		0
71937	4269	4283893	2000-07-27	2000-07-27 00:00:00	2000-09-07	2000-09-07 00:00:00	32020		\N	283357	0	36971009	4283893		0
72071	4276	4112343	2019-02-25	2019-02-25 00:00:00	2019-03-04	2019-03-04 00:00:00	32020		\N	283743	0	195662009	4112343		0
72214	4284	40481087	2001-07-09	2001-07-09 00:00:00	2001-07-23	2001-07-23 00:00:00	32020		\N	284331	0	444814009	40481087		0
83025	4932	260139	1964-12-08	1964-12-08 00:00:00	1964-12-22	1964-12-22 00:00:00	32020		\N	327865	0	10509002	260139		0
72702	4320	4112343	1989-08-28	1989-08-28 00:00:00	1989-09-07	1989-09-07 00:00:00	32020		\N	286662	0	195662009	4112343		0
72809	4328	4112343	1990-03-01	1990-03-01 00:00:00	1990-03-11	1990-03-11 00:00:00	32020		\N	287014	0	195662009	4112343		0
83610	4970	134438	1946-04-19	1946-04-19 00:00:00	1947-06-14	1947-06-14 00:00:00	32020		\N	330344	0	40275004	134438		0
73175	4349	40481087	1990-06-27	1990-06-27 00:00:00	1990-07-04	1990-07-04 00:00:00	32020		\N	288386	0	444814009	40481087		0
73276	4355	4112343	2007-04-20	2007-04-20 00:00:00	2007-04-30	2007-04-30 00:00:00	32020		\N	288966	0	195662009	4112343		0
84031	4990	4116491	1983-02-23	1983-02-23 00:00:00	1983-04-18	1983-04-18 00:00:00	32020		\N	331954	0	301011002	4116491		0
73564	4374	4048171	1979-05-27	1979-05-27 00:00:00	1995-05-25	1995-05-25 00:00:00	32020		\N	290447	0	232353008	4048171		0
84338	5013	317576	2010-09-10	2010-09-10 00:00:00	\N	\N	32020		\N	333181	0	53741008	317576		0
84571	5031	40481087	2004-05-27	2004-05-27 00:00:00	2004-06-03	2004-06-03 00:00:00	32020		\N	334399	0	444814009	40481087		0
74192	4406	40481087	1999-05-26	1999-05-26 00:00:00	1999-06-09	1999-06-09 00:00:00	32020		\N	292867	0	444814009	40481087		0
84853	5046	4027663	1984-01-07	1984-01-07 00:00:00	\N	\N	32020		\N	335358	0	13200003	4027663		0
74416	4418	40481087	2015-10-04	2015-10-04 00:00:00	2015-10-18	2015-10-18 00:00:00	32020		\N	293754	0	444814009	40481087		0
74620	4432	4112343	1959-03-21	1959-03-21 00:00:00	1959-04-03	1959-04-03 00:00:00	32020		\N	294567	0	195662009	4112343		0
64191	3790	40481087	1993-03-06	1993-03-06 00:00:00	1993-03-13	1993-03-13 00:00:00	32020		\N	252003	0	444814009	40481087		0
64331	3799	40481087	2016-02-06	2016-02-06 00:00:00	2016-02-20	2016-02-20 00:00:00	32020		\N	252545	0	444814009	40481087		0
64453	3807	4266809	1988-06-27	1988-06-27 00:00:00	\N	\N	32020		\N	252990	0	397881000	4266809		0
64740	3827	4112343	2011-04-05	2011-04-05 00:00:00	2011-04-17	2011-04-17 00:00:00	32020		\N	254211	0	195662009	4112343		0
54275	3215	260139	2000-03-21	2000-03-21 00:00:00	2000-03-28	2000-03-28 00:00:00	32020		\N	213670	0	10509002	260139		0
64982	3843	372328	1974-02-03	1974-02-03 00:00:00	1974-11-24	1974-11-24 00:00:00	32020		\N	255113	0	65363002	372328		0
65109	3851	40481087	1935-07-04	1935-07-04 00:00:00	1935-07-11	1935-07-11 00:00:00	32020		\N	255508	0	444814009	40481087		0
65292	3860	4112343	2004-02-02	2004-02-02 00:00:00	2004-02-09	2004-02-09 00:00:00	32020		\N	256331	0	195662009	4112343		0
65482	3871	40481087	1988-11-22	1988-11-22 00:00:00	1988-12-13	1988-12-13 00:00:00	32020		\N	257005	0	444814009	40481087		0
76217	4522	28060	2017-02-12	2017-02-12 00:00:00	2017-02-25	2017-02-25 00:00:00	32020		\N	301110	0	43878008	28060		0
76388	4531	260139	1944-05-20	1944-05-20 00:00:00	1944-06-03	1944-06-03 00:00:00	32020		\N	301745	0	10509002	260139		0
65990	3901	4109685	1958-08-25	1958-08-25 00:00:00	1958-09-08	1958-09-08 00:00:00	32020		\N	259385	0	284551006	4109685		0
66178	3917	40481087	1970-11-25	1970-11-25 00:00:00	1970-12-02	1970-12-02 00:00:00	32020		\N	260489	0	444814009	40481087		0
66358	3928	81151	2005-03-27	2005-03-27 00:00:00	2005-05-01	2005-05-01 00:00:00	32020		\N	261133	0	44465007	81151		0
66457	3934	40481087	1993-12-10	1993-12-10 00:00:00	1993-12-31	1993-12-31 00:00:00	32020		\N	261453	0	444814009	40481087		0
77245	4576	4152936	1981-11-02	1981-11-02 00:00:00	1981-11-16	1981-11-16 00:00:00	32020		\N	304851	0	283385000	4152936		0
66873	3956	372328	1920-08-29	1920-08-29 00:00:00	1920-10-24	1920-10-24 00:00:00	32020		\N	262971	0	65363002	372328		0
67013	3962	78272	2011-12-09	2011-12-09 00:00:00	2011-12-23	2011-12-23 00:00:00	32020		\N	263466	0	70704007	78272		0
67187	3972	40481087	2007-11-01	2007-11-01 00:00:00	2007-11-15	2007-11-15 00:00:00	32020		\N	264119	0	444814009	40481087		0
77992	4622	40481087	1963-01-28	1963-01-28 00:00:00	1963-02-04	1963-02-04 00:00:00	32020		\N	307780	0	444814009	40481087		0
67524	3989	4112343	1951-10-27	1951-10-27 00:00:00	1951-11-05	1951-11-05 00:00:00	32020		\N	265255	0	195662009	4112343		0
67646	3996	4278672	2010-08-23	2010-08-23 00:00:00	2010-09-22	2010-09-22 00:00:00	32020		\N	265697	0	65966004	4278672		0
67795	4006	80180	1994-12-25	1994-12-25 00:00:00	\N	\N	32020		\N	266162	0	396275006	80180		0
68024	4018	4109685	1975-12-14	1975-12-14 00:00:00	1976-01-04	1976-01-04 00:00:00	32020		\N	267051	0	284551006	4109685		0
68142	4024	28060	1989-08-04	1989-08-04 00:00:00	1989-08-11	1989-08-11 00:00:00	32020		\N	267517	0	43878008	28060		0
78901	4674	260139	2012-01-25	2012-01-25 00:00:00	2012-02-08	2012-02-08 00:00:00	32020		\N	311383	0	10509002	260139		0
68517	4052	40481087	2018-06-10	2018-06-10 00:00:00	2018-06-17	2018-06-17 00:00:00	32020		\N	269347	0	444814009	40481087		0
79187	4689	30753	2006-03-20	2006-03-20 00:00:00	\N	\N	32020		\N	312450	0	16761005	30753		0
79358	4700	4156265	1952-03-17	1952-03-17 00:00:00	1952-04-07	1952-04-07 00:00:00	32020		\N	313115	0	370247008	4156265		0
68905	4078	372328	1957-01-12	1957-01-12 00:00:00	1957-07-22	1957-07-22 00:00:00	32020		\N	271082	0	65363002	372328		0
69138	4091	4112343	2010-05-20	2010-05-20 00:00:00	2010-06-02	2010-06-02 00:00:00	32020		\N	271970	0	195662009	4112343		0
79918	4735	260139	1993-06-20	1993-06-20 00:00:00	1993-06-27	1993-06-27 00:00:00	32020		\N	315443	0	10509002	260139		0
58915	3495	40481087	1990-02-02	1990-02-02 00:00:00	1990-02-16	1990-02-16 00:00:00	32020		\N	231851	0	444814009	40481087		0
69570	4117	40481087	1989-01-07	1989-01-07 00:00:00	1989-01-21	1989-01-21 00:00:00	32020		\N	273712	0	444814009	40481087		0
80348	4759	4029498	2008-11-08	2008-11-08 00:00:00	\N	\N	32020		\N	317067	0	128613002	4029498		0
80651	4781	80180	2018-05-16	2018-05-16 00:00:00	\N	\N	32020		\N	318279	0	396275006	80180		0
70088	4149	260139	1999-06-03	1999-06-03 00:00:00	1999-06-10	1999-06-10 00:00:00	32020		\N	275712	0	10509002	260139		0
70370	4167	260139	2016-01-12	2016-01-12 00:00:00	2016-01-19	2016-01-19 00:00:00	32020		\N	276926	0	10509002	260139		0
81112	4811	260139	1962-09-16	1962-09-16 00:00:00	1962-09-23	1962-09-23 00:00:00	32020		\N	320016	0	10509002	260139		0
81246	4819	260139	2002-08-20	2002-08-20 00:00:00	2002-09-03	2002-09-03 00:00:00	32020		\N	320579	0	10509002	260139		0
70828	4202	40481087	1980-07-04	1980-07-04 00:00:00	1980-07-11	1980-07-11 00:00:00	32020		\N	278932	0	444814009	40481087		0
70947	4208	4112343	1959-05-06	1959-05-06 00:00:00	1959-05-15	1959-05-15 00:00:00	32020		\N	279442	0	195662009	4112343		0
60561	3580	257012	1990-03-15	1990-03-15 00:00:00	\N	\N	32020		\N	237970	0	40055000	257012		0
71300	4227	4156265	1969-06-29	1969-06-29 00:00:00	1969-07-13	1969-07-13 00:00:00	32020		\N	280796	0	370247008	4156265		0
71439	4238	4056621	1992-11-16	1992-11-16 00:00:00	\N	\N	32020		\N	281363	0	197927001	4056621		0
71703	4253	40481087	2008-09-25	2008-09-25 00:00:00	2008-10-09	2008-10-09 00:00:00	32020		\N	282442	0	444814009	40481087		0
71763	4256	4266809	1992-06-12	1992-06-12 00:00:00	\N	\N	32020		\N	282614	0	397881000	4266809		0
71938	4269	260139	2010-03-23	2010-03-23 00:00:00	2010-03-30	2010-03-30 00:00:00	32020		\N	283368	0	10509002	260139		0
72076	4278	4112343	1963-11-27	1963-11-27 00:00:00	1963-12-09	1963-12-09 00:00:00	32020		\N	283904	0	195662009	4112343		0
72215	4284	378001	1954-10-01	1954-10-01 00:00:00	1954-11-30	1954-11-30 00:00:00	32020		\N	284385	0	62106007	378001		0
83026	4932	4027663	1987-11-07	1987-11-07 00:00:00	\N	\N	32020		\N	327792	0	13200003	4027663		0
72703	4320	4112343	2018-07-10	2018-07-10 00:00:00	2018-07-19	2018-07-19 00:00:00	32020		\N	286684	0	195662009	4112343		0
72810	4328	195588	1998-05-27	1998-05-27 00:00:00	1998-07-19	1998-07-19 00:00:00	32020		\N	287067	0	38822007	195588		0
83611	4970	81151	1987-01-17	1987-01-17 00:00:00	1987-02-21	1987-02-21 00:00:00	32020		\N	330396	0	44465007	81151		0
73176	4349	372328	1983-05-01	1983-05-01 00:00:00	1983-08-11	1983-08-11 00:00:00	32020		\N	288389	0	65363002	372328		0
73277	4355	40481087	1997-06-09	1997-06-09 00:00:00	1997-06-30	1997-06-30 00:00:00	32020		\N	288965	0	444814009	40481087		0
84032	4990	260139	2008-06-06	2008-06-06 00:00:00	2008-06-13	2008-06-13 00:00:00	32020		\N	332005	0	10509002	260139		0
73565	4374	40481087	1989-05-21	1989-05-21 00:00:00	1989-05-28	1989-05-28 00:00:00	32020		\N	290575	0	444814009	40481087		0
84339	5014	4112343	1928-02-04	1928-02-04 00:00:00	1928-02-14	1928-02-14 00:00:00	32020		\N	333313	0	195662009	4112343		0
84572	5031	81151	2009-08-28	2009-08-28 00:00:00	2009-09-11	2009-09-11 00:00:00	32020		\N	334283	0	44465007	81151		0
72844	4330	257012	1979-07-03	1979-07-03 00:00:00	\N	\N	32020		\N	287239	0	40055000	257012		0
74193	4406	4112343	1965-06-06	1965-06-06 00:00:00	1965-06-14	1965-06-14 00:00:00	32020		\N	292894	0	195662009	4112343		0
84854	5046	4310024	1993-08-03	1993-08-03 00:00:00	\N	\N	32020		\N	335363	0	424802006	4310024		0
74417	4418	4112343	2010-02-22	2010-02-22 00:00:00	2010-03-04	2010-03-04 00:00:00	32020		\N	293722	0	195662009	4112343		0
74621	4432	4112343	2019-01-02	2019-01-02 00:00:00	2019-01-10	2019-01-10 00:00:00	32020		\N	294592	0	195662009	4112343		0
64192	3790	28060	2001-02-05	2001-02-05 00:00:00	2001-02-18	2001-02-18 00:00:00	32020		\N	251980	0	43878008	28060		0
64332	3799	372328	1989-09-17	1989-09-17 00:00:00	1990-09-25	1990-09-25 00:00:00	32020		\N	252536	0	65363002	372328		0
64454	3807	80180	1988-06-27	1988-06-27 00:00:00	\N	\N	32020		\N	252990	0	396275006	80180		0
75199	4467	40481087	1955-01-28	1955-01-28 00:00:00	1955-02-11	1955-02-11 00:00:00	32020		\N	297201	0	444814009	40481087		0
54276	3215	134438	2002-10-04	2002-10-04 00:00:00	2003-08-04	2003-08-04 00:00:00	32020		\N	213630	0	40275004	134438		0
64983	3843	4112343	2011-02-20	2011-02-20 00:00:00	2011-02-27	2011-02-27 00:00:00	32020		\N	255065	0	195662009	4112343		0
65110	3851	4116491	1931-04-26	1931-04-26 00:00:00	1931-06-24	1931-06-24 00:00:00	32020		\N	255574	0	301011002	4116491		0
65293	3860	4112343	1993-10-11	1993-10-11 00:00:00	1993-10-24	1993-10-24 00:00:00	32020		\N	256330	0	195662009	4112343		0
65483	3871	260139	1991-05-25	1991-05-25 00:00:00	1991-06-01	1991-06-01 00:00:00	32020		\N	257063	0	10509002	260139		0
76218	4522	80180	2017-08-16	2017-08-16 00:00:00	\N	\N	32020		\N	301110	0	396275006	80180		0
76389	4531	40481087	1952-09-03	1952-09-03 00:00:00	1952-09-10	1952-09-10 00:00:00	32020		\N	301815	0	444814009	40481087		0
65991	3901	40481087	2004-09-16	2004-09-16 00:00:00	2004-10-07	2004-10-07 00:00:00	32020		\N	259406	0	444814009	40481087		0
66179	3917	40481087	2008-07-09	2008-07-09 00:00:00	2008-07-30	2008-07-30 00:00:00	32020		\N	260451	0	444814009	40481087		0
66359	3928	4112343	1993-10-28	1993-10-28 00:00:00	1993-11-06	1993-11-06 00:00:00	32020		\N	261135	0	195662009	4112343		0
66458	3934	4218389	2015-12-03	2015-12-03 00:00:00	2015-12-31	2015-12-31 00:00:00	32020		\N	261508	0	39848009	4218389		0
77246	4576	381316	1984-08-08	1984-08-08 00:00:00	\N	\N	32020		\N	304803	0	230690007	381316		0
66874	3956	4294548	1974-08-15	1974-08-15 00:00:00	1974-09-19	1974-09-19 00:00:00	32020		\N	263023	0	75498004	4294548		0
67014	3962	257012	1958-10-02	1958-10-02 00:00:00	\N	\N	32020		\N	263389	0	40055000	257012		0
67188	3972	260139	1960-04-06	1960-04-06 00:00:00	1960-04-13	1960-04-13 00:00:00	32020		\N	264093	0	10509002	260139		0
77993	4622	4266809	1997-08-03	1997-08-03 00:00:00	\N	\N	32020		\N	307781	0	397881000	4266809		0
67525	3989	260139	1994-02-13	1994-02-13 00:00:00	1994-02-20	1994-02-20 00:00:00	32020		\N	265171	0	10509002	260139		0
67647	3996	4146173	1990-05-10	1990-05-10 00:00:00	1990-07-09	1990-07-09 00:00:00	32020		\N	265656	0	307731004	4146173		0
67796	4006	4285898	1994-06-28	1994-06-28 00:00:00	\N	\N	32020		\N	266162	0	68496003	4285898		0
68025	4018	4059173	1964-12-20	1964-12-20 00:00:00	1965-01-19	1965-01-19 00:00:00	32020		\N	267048	0	16114001	4059173		0
68143	4024	378001	1987-03-17	1987-03-17 00:00:00	1987-04-16	1987-04-16 00:00:00	32020		\N	267528	0	62106007	378001		0
78902	4674	4146173	2017-06-21	2017-06-21 00:00:00	2017-08-27	2017-08-27 00:00:00	32020		\N	311419	0	307731004	4146173		0
68518	4052	4112343	1984-11-15	1984-11-15 00:00:00	1984-11-26	1984-11-26 00:00:00	32020		\N	269374	0	195662009	4112343		0
79188	4689	192671	2007-12-12	2007-12-12 00:00:00	\N	\N	32020		\N	312397	0	K92.2	35208414		0
79359	4700	4310024	1987-12-09	1987-12-09 00:00:00	\N	\N	32020		\N	313034	0	424802006	4310024		0
68906	4078	40481087	1981-12-16	1981-12-16 00:00:00	1981-12-30	1981-12-30 00:00:00	32020		\N	271058	0	444814009	40481087		0
69139	4091	260139	1999-05-22	1999-05-22 00:00:00	1999-05-29	1999-05-29 00:00:00	32020		\N	271969	0	10509002	260139		0
79919	4735	28060	1985-08-01	1985-08-01 00:00:00	1985-08-09	1985-08-09 00:00:00	32020		\N	315414	0	43878008	28060		0
58916	3495	4112343	1978-01-24	1978-01-24 00:00:00	1978-02-04	1978-02-04 00:00:00	32020		\N	231826	0	195662009	4112343		0
69571	4117	4112343	1996-03-26	1996-03-26 00:00:00	1996-04-07	1996-04-07 00:00:00	32020		\N	273737	0	195662009	4112343		0
80350	4759	257012	1988-08-19	1988-08-19 00:00:00	\N	\N	32020		\N	317041	0	40055000	257012		0
80652	4782	260139	1998-07-16	1998-07-16 00:00:00	1998-07-23	1998-07-23 00:00:00	32020		\N	318365	0	10509002	260139		0
70089	4149	4156265	2007-06-04	2007-06-04 00:00:00	2007-06-25	2007-06-25 00:00:00	32020		\N	275761	0	370247008	4156265		0
70371	4167	40481087	2013-02-26	2013-02-26 00:00:00	2013-03-05	2013-03-05 00:00:00	32020		\N	276952	0	444814009	40481087		0
81113	4811	260139	1979-01-27	1979-01-27 00:00:00	1979-02-10	1979-02-10 00:00:00	32020		\N	320075	0	10509002	260139		0
81247	4819	28060	1960-09-18	1960-09-18 00:00:00	1960-09-25	1960-09-25 00:00:00	32020		\N	320509	0	43878008	28060		0
70847	4204	4155034	1972-04-20	1972-04-20 00:00:00	1972-05-11	1972-05-11 00:00:00	32020		\N	279065	0	283371005	4155034		0
70948	4208	4112343	1943-08-01	1943-08-01 00:00:00	1943-08-13	1943-08-13 00:00:00	32020		\N	279393	0	195662009	4112343		0
60562	3580	4116491	1998-03-18	1998-03-18 00:00:00	1998-05-02	1998-05-02 00:00:00	32020		\N	238003	0	301011002	4116491		0
71301	4227	4296205	1997-08-15	1997-08-15 00:00:00	1997-08-29	1997-08-29 00:00:00	32020		\N	280797	0	403191005	4296205		0
71440	4238	4112343	1987-06-11	1987-06-11 00:00:00	1987-06-23	1987-06-23 00:00:00	32020		\N	281361	0	195662009	4112343		0
71704	4253	4113008	2010-08-16	2010-08-16 00:00:00	2010-08-30	2010-08-30 00:00:00	32020		\N	282428	0	284549007	4113008		0
71764	4256	375671	1959-05-02	1959-05-02 00:00:00	1959-06-01	1959-06-01 00:00:00	32020		\N	282587	0	62564004	375671		0
71939	4269	40481087	1989-06-12	1989-06-12 00:00:00	1989-06-26	1989-06-26 00:00:00	32020		\N	283367	0	444814009	40481087		0
72077	4278	258780	1986-10-31	1986-10-31 00:00:00	\N	\N	32020		\N	283925	0	185086009	258780		0
72216	4284	372328	1947-07-01	1947-07-01 00:00:00	1947-11-13	1947-11-13 00:00:00	32020		\N	284382	0	65363002	372328		0
83027	4932	40481087	1996-07-16	1996-07-16 00:00:00	1996-08-06	1996-08-06 00:00:00	32020		\N	327856	0	444814009	40481087		0
72704	4320	260139	2013-05-25	2013-05-25 00:00:00	2013-06-08	2013-06-08 00:00:00	32020		\N	286663	0	10509002	260139		0
72811	4328	372328	1976-02-02	1976-02-02 00:00:00	1976-05-19	1976-05-19 00:00:00	32020		\N	287038	0	65363002	372328		0
83612	4970	260139	1962-08-31	1962-08-31 00:00:00	1962-09-14	1962-09-14 00:00:00	32020		\N	330426	0	10509002	260139		0
73177	4349	40481087	1995-10-13	1995-10-13 00:00:00	1995-10-20	1995-10-20 00:00:00	32020		\N	288432	0	444814009	40481087		0
73278	4355	260139	2019-04-12	2019-04-12 00:00:00	2019-04-19	2019-04-19 00:00:00	32020		\N	288947	0	10509002	260139		0
84033	4990	4112343	2006-09-03	2006-09-03 00:00:00	2006-09-10	2006-09-10 00:00:00	32020		\N	331956	0	195662009	4112343		0
73566	4374	4112343	1986-08-22	1986-08-22 00:00:00	1986-08-29	1986-08-29 00:00:00	32020		\N	290488	0	195662009	4112343		0
84340	5014	28060	1927-11-20	1927-11-20 00:00:00	1927-12-03	1927-12-03 00:00:00	32020		\N	333259	0	43878008	28060		0
84573	5031	4029498	1941-02-01	1941-02-01 00:00:00	\N	\N	32020		\N	334343	0	128613002	4029498		0
74194	4406	40481087	2015-07-23	2015-07-23 00:00:00	2015-08-06	2015-08-06 00:00:00	32020		\N	292944	0	444814009	40481087		0
84855	5046	372328	1961-12-10	1961-12-10 00:00:00	1962-12-24	1962-12-24 00:00:00	32020		\N	335347	0	65363002	372328		0
74418	4418	40481087	1987-09-17	1987-09-17 00:00:00	1987-09-24	1987-09-24 00:00:00	32020		\N	293761	0	444814009	40481087		0
74622	4432	260139	1966-01-11	1966-01-11 00:00:00	1966-01-25	1966-01-25 00:00:00	32020		\N	294612	0	10509002	260139		0
64193	3790	4027663	1991-06-24	1991-06-24 00:00:00	\N	\N	32020		\N	251999	0	13200003	4027663		0
64333	3799	80180	2006-04-08	2006-04-08 00:00:00	\N	\N	32020		\N	252543	0	396275006	80180		0
64455	3807	40481087	2002-10-16	2002-10-16 00:00:00	2002-10-30	2002-10-30 00:00:00	32020		\N	252962	0	444814009	40481087		0
75200	4467	40481087	2007-03-15	2007-03-15 00:00:00	2007-03-29	2007-03-29 00:00:00	32020		\N	297243	0	444814009	40481087		0
54277	3216	378001	1977-01-02	1977-01-02 00:00:00	1977-03-03	1977-03-03 00:00:00	32020		\N	213709	0	62106007	378001		0
64984	3843	40481087	1982-04-23	1982-04-23 00:00:00	1982-05-14	1982-05-14 00:00:00	32020		\N	255073	0	444814009	40481087		0
65111	3851	372328	1924-07-08	1924-07-08 00:00:00	1925-06-01	1925-06-01 00:00:00	32020		\N	255499	0	65363002	372328		0
65294	3860	4112343	2012-04-12	2012-04-12 00:00:00	2012-04-20	2012-04-20 00:00:00	32020		\N	256332	0	195662009	4112343		0
65502	3874	4112343	2009-03-09	2009-03-09 00:00:00	2009-03-17	2009-03-17 00:00:00	32020		\N	257228	0	195662009	4112343		0
76219	4522	4112343	1986-06-03	1986-06-03 00:00:00	1986-06-12	1986-06-12 00:00:00	32020		\N	301127	0	195662009	4112343		0
76390	4531	4294548	1987-07-15	1987-07-15 00:00:00	1987-10-14	1987-10-14 00:00:00	32020		\N	301753	0	75498004	4294548		0
65992	3901	4112343	1975-03-26	1975-03-26 00:00:00	1975-04-03	1975-04-03 00:00:00	32020		\N	259344	0	195662009	4112343		0
66180	3917	40481087	1986-11-16	1986-11-16 00:00:00	1986-11-23	1986-11-23 00:00:00	32020		\N	260490	0	444814009	40481087		0
66360	3928	40481087	1988-04-03	1988-04-03 00:00:00	1988-04-17	1988-04-17 00:00:00	32020		\N	261116	0	444814009	40481087		0
66459	3934	4296204	1967-06-08	1967-06-08 00:00:00	1967-06-22	1967-06-22 00:00:00	32020		\N	261502	0	403190006	4296204		0
77247	4576	28060	2011-09-23	2011-09-23 00:00:00	2011-10-01	2011-10-01 00:00:00	32020		\N	304855	0	43878008	28060		0
66875	3956	4112343	1995-08-24	1995-08-24 00:00:00	1995-09-01	1995-09-01 00:00:00	32020		\N	262964	0	195662009	4112343		0
67015	3962	195588	1997-05-06	1997-05-06 00:00:00	1997-06-28	1997-06-28 00:00:00	32020		\N	263449	0	38822007	195588		0
67189	3972	28060	1962-04-29	1962-04-29 00:00:00	1962-05-10	1962-05-10 00:00:00	32020		\N	264157	0	43878008	28060		0
77994	4622	30753	1996-07-09	1996-07-09 00:00:00	\N	\N	32020		\N	307781	0	16761005	30753		0
67526	3989	4059173	2003-11-21	2003-11-21 00:00:00	2004-02-19	2004-02-19 00:00:00	32020		\N	265248	0	16114001	4059173		0
67648	3996	260139	2003-04-05	2003-04-05 00:00:00	2003-04-12	2003-04-12 00:00:00	32020		\N	265676	0	10509002	260139		0
67797	4006	192671	1995-01-10	1995-01-10 00:00:00	\N	\N	32020		\N	266148	0	K92.2	35208414		0
68026	4018	28060	1987-06-09	1987-06-09 00:00:00	1987-06-17	1987-06-17 00:00:00	32020		\N	267065	0	43878008	28060		0
68144	4024	80180	2016-05-08	2016-05-08 00:00:00	\N	\N	32020		\N	267547	0	396275006	80180		0
78903	4674	440448	1978-08-20	1978-08-20 00:00:00	\N	\N	32020		\N	311386	0	74400008	440448		0
68519	4052	40481087	1986-02-15	1986-02-15 00:00:00	1986-02-22	1986-02-22 00:00:00	32020		\N	269293	0	444814009	40481087		0
79189	4689	4116491	2012-04-28	2012-04-28 00:00:00	2012-06-02	2012-06-02 00:00:00	32020		\N	312381	0	301011002	4116491		0
79360	4700	40481087	1987-10-23	1987-10-23 00:00:00	1987-11-13	1987-11-13 00:00:00	32020		\N	313034	0	444814009	40481087		0
68907	4078	40481087	1952-08-08	1952-08-08 00:00:00	1952-08-22	1952-08-22 00:00:00	32020		\N	271013	0	444814009	40481087		0
69140	4091	260139	1994-03-08	1994-03-08 00:00:00	1994-03-15	1994-03-15 00:00:00	32020		\N	271952	0	10509002	260139		0
79920	4735	321042	1983-06-16	1983-06-16 00:00:00	\N	\N	32020		\N	315452	0	410429000	321042		0
58917	3495	4112343	1984-01-05	1984-01-05 00:00:00	1984-01-17	1984-01-17 00:00:00	32020		\N	231804	0	195662009	4112343		0
69572	4117	80180	1996-05-29	1996-05-29 00:00:00	\N	\N	32020		\N	273737	0	396275006	80180		0
80351	4759	4156265	1992-06-30	1992-06-30 00:00:00	1992-07-14	1992-07-14 00:00:00	32020		\N	317120	0	370247008	4156265		0
80653	4782	4027663	2008-04-22	2008-04-22 00:00:00	\N	\N	32020		\N	318373	0	13200003	4027663		0
70090	4149	4112343	2012-09-21	2012-09-21 00:00:00	2012-09-29	2012-09-29 00:00:00	32020		\N	275707	0	195662009	4112343		0
70372	4167	40481087	1988-08-24	1988-08-24 00:00:00	1988-09-14	1988-09-14 00:00:00	32020		\N	276981	0	444814009	40481087		0
81114	4811	4294548	1968-02-07	1968-02-07 00:00:00	1968-02-14	1968-02-14 00:00:00	32020		\N	320065	0	75498004	4294548		0
81248	4819	260139	2015-11-03	2015-11-03 00:00:00	2015-11-10	2015-11-10 00:00:00	32020		\N	320580	0	10509002	260139		0
70848	4204	4112343	2016-02-28	2016-02-28 00:00:00	2016-03-06	2016-03-06 00:00:00	32020		\N	279115	0	195662009	4112343		0
70949	4208	378419	2008-04-08	2008-04-08 00:00:00	\N	\N	32020		\N	279392	0	26929004	378419		0
60563	3580	4283893	2014-11-17	2014-11-17 00:00:00	2015-02-09	2015-02-09 00:00:00	32020		\N	238006	0	36971009	4283893		0
71302	4227	40481087	1972-07-18	1972-07-18 00:00:00	1972-08-01	1972-08-01 00:00:00	32020		\N	280829	0	444814009	40481087		0
71441	4238	195588	1998-01-05	1998-01-05 00:00:00	1998-02-19	1998-02-19 00:00:00	32020		\N	281407	0	38822007	195588		0
71705	4253	4310024	2016-06-12	2016-06-12 00:00:00	\N	\N	32020		\N	282437	0	424802006	4310024		0
71765	4256	28060	1956-12-14	1956-12-14 00:00:00	1956-12-26	1956-12-26 00:00:00	32020		\N	282606	0	43878008	28060		0
71940	4269	81151	1988-02-28	1988-02-28 00:00:00	1988-03-13	1988-03-13 00:00:00	32020		\N	283353	0	44465007	81151		0
72078	4278	28060	2000-12-24	2000-12-24 00:00:00	2001-01-05	2001-01-05 00:00:00	32020		\N	283940	0	43878008	28060		0
72217	4284	260139	1965-11-04	1965-11-04 00:00:00	1965-11-11	1965-11-11 00:00:00	32020		\N	284381	0	10509002	260139		0
83028	4932	4112343	1995-09-21	1995-09-21 00:00:00	1995-10-03	1995-10-03 00:00:00	32020		\N	327920	0	195662009	4112343		0
72705	4320	4294548	1984-02-19	1984-02-19 00:00:00	1984-04-01	1984-04-01 00:00:00	32020		\N	286635	0	75498004	4294548		0
72812	4328	4294548	2017-05-29	2017-05-29 00:00:00	2017-06-12	2017-06-12 00:00:00	32020		\N	287056	0	75498004	4294548		0
83613	4970	4112343	1926-09-30	1926-09-30 00:00:00	1926-10-11	1926-10-11 00:00:00	32020		\N	330473	0	195662009	4112343		0
73178	4349	40481087	1998-11-10	1998-11-10 00:00:00	1998-12-01	1998-12-01 00:00:00	32020		\N	288387	0	444814009	40481087		0
73279	4355	4027663	2010-04-11	2010-04-11 00:00:00	\N	\N	32020		\N	288995	0	13200003	4027663		0
84034	4990	4112343	2001-10-15	2001-10-15 00:00:00	2001-10-27	2001-10-27 00:00:00	32020		\N	332003	0	195662009	4112343		0
73567	4374	372328	1978-08-27	1978-08-27 00:00:00	1978-11-02	1978-11-02 00:00:00	32020		\N	290485	0	65363002	372328		0
84341	5014	4112343	1965-06-26	1965-06-26 00:00:00	1965-07-09	1965-07-09 00:00:00	32020		\N	333264	0	195662009	4112343		0
84575	5031	40481087	1948-05-22	1948-05-22 00:00:00	1948-06-05	1948-06-05 00:00:00	32020		\N	334275	0	444814009	40481087		0
74195	4406	40481087	1985-01-13	1985-01-13 00:00:00	1985-02-03	1985-02-03 00:00:00	32020		\N	292893	0	444814009	40481087		0
84867	5048	372328	1961-07-10	1961-07-10 00:00:00	1961-07-24	1961-07-24 00:00:00	32020		\N	335445	0	65363002	372328		0
74419	4418	40481087	2003-10-05	2003-10-05 00:00:00	2003-10-12	2003-10-12 00:00:00	32020		\N	293705	0	444814009	40481087		0
74623	4433	4294548	1991-01-10	1991-01-10 00:00:00	1991-02-14	1991-02-14 00:00:00	32020		\N	294655	0	75498004	4294548		0
64194	3790	4112343	1991-01-14	1991-01-14 00:00:00	1991-01-27	1991-01-27 00:00:00	32020		\N	251999	0	195662009	4112343		0
64334	3799	372328	1976-02-13	1976-02-13 00:00:00	1976-07-27	1976-07-27 00:00:00	32020		\N	252535	0	65363002	372328		0
64456	3807	78272	1995-09-04	1995-09-04 00:00:00	1995-09-18	1995-09-18 00:00:00	32020		\N	253025	0	70704007	78272		0
75201	4467	40481087	2001-05-30	2001-05-30 00:00:00	2001-06-20	2001-06-20 00:00:00	32020		\N	297205	0	444814009	40481087		0
54278	3216	372328	1955-02-17	1955-02-17 00:00:00	1955-05-31	1955-05-31 00:00:00	32020		\N	213755	0	65363002	372328		0
64985	3843	260139	1998-05-24	1998-05-24 00:00:00	1998-06-07	1998-06-07 00:00:00	32020		\N	255064	0	10509002	260139		0
65112	3851	4112343	1959-01-13	1959-01-13 00:00:00	1959-01-23	1959-01-23 00:00:00	32020		\N	255599	0	195662009	4112343		0
65305	3862	40481087	1974-04-02	1974-04-02 00:00:00	1974-04-09	1974-04-09 00:00:00	32020		\N	256424	0	444814009	40481087		0
65503	3874	40481087	2019-04-28	2019-04-28 00:00:00	2019-05-19	2019-05-19 00:00:00	32020		\N	257229	0	444814009	40481087		0
76220	4523	4109685	2013-12-09	2013-12-09 00:00:00	2013-12-30	2013-12-30 00:00:00	32020		\N	301156	0	284551006	4109685		0
76391	4531	40481087	1935-06-28	1935-06-28 00:00:00	1935-07-05	1935-07-05 00:00:00	32020		\N	301744	0	444814009	40481087		0
65993	3901	4112343	1949-09-27	1949-09-27 00:00:00	1949-10-06	1949-10-06 00:00:00	32020		\N	259426	0	195662009	4112343		0
66181	3917	4218389	1968-08-02	1968-08-02 00:00:00	1968-08-30	1968-08-30 00:00:00	32020		\N	260481	0	39848009	4218389		0
66361	3928	80180	2012-08-17	2012-08-17 00:00:00	\N	\N	32020		\N	261144	0	396275006	80180		0
66460	3934	4283893	1951-12-13	1951-12-13 00:00:00	1952-07-03	1952-07-03 00:00:00	32020		\N	261417	0	36971009	4283893		0
77248	4576	260139	1983-06-02	1983-06-02 00:00:00	1983-06-16	1983-06-16 00:00:00	32020		\N	304771	0	10509002	260139		0
66876	3956	257012	1974-09-12	1974-09-12 00:00:00	\N	\N	32020		\N	262996	0	40055000	257012		0
67016	3962	40481087	1962-01-11	1962-01-11 00:00:00	1962-01-18	1962-01-18 00:00:00	32020		\N	263475	0	444814009	40481087		0
67190	3972	4112343	2013-06-14	2013-06-14 00:00:00	2013-06-25	2013-06-25 00:00:00	32020		\N	264163	0	195662009	4112343		0
77995	4622	4112343	1996-02-08	1996-02-08 00:00:00	1996-02-20	1996-02-20 00:00:00	32020		\N	307781	0	195662009	4112343		0
67527	3989	40481087	1932-06-15	1932-06-15 00:00:00	1932-06-29	1932-06-29 00:00:00	32020		\N	265249	0	444814009	40481087		0
67649	3996	81151	1983-05-19	1983-05-19 00:00:00	1983-06-09	1983-06-09 00:00:00	32020		\N	265652	0	44465007	81151		0
67798	4006	40481087	1961-05-05	1961-05-05 00:00:00	1961-05-12	1961-05-12 00:00:00	32020		\N	266202	0	444814009	40481087		0
68027	4019	4112343	1997-10-09	1997-10-09 00:00:00	1997-10-18	1997-10-18 00:00:00	32020		\N	267127	0	195662009	4112343		0
68145	4024	4285898	2016-01-09	2016-01-09 00:00:00	\N	\N	32020		\N	267547	0	68496003	4285898		0
78904	4674	4166224	1978-08-20	1978-08-20 00:00:00	\N	\N	32020		\N	311386	0	47693006	4166224		0
68520	4052	372328	1979-05-19	1979-05-19 00:00:00	1979-09-20	1979-09-20 00:00:00	32020		\N	269330	0	65363002	372328		0
79190	4689	4109685	2005-12-27	2005-12-27 00:00:00	2006-01-17	2006-01-17 00:00:00	32020		\N	312394	0	284551006	4109685		0
79361	4700	4285898	1989-12-28	1989-12-28 00:00:00	\N	\N	32020		\N	313034	0	68496003	4285898		0
68908	4078	133834	1953-03-05	1953-03-05 00:00:00	1969-01-03	1969-01-03 00:00:00	32020		\N	271014	0	24079001	133834		0
69141	4091	81893	2007-03-11	2007-03-11 00:00:00	\N	\N	32020		\N	271966	0	64766004	81893		0
79922	4735	4278672	1998-06-22	1998-06-22 00:00:00	1998-07-22	1998-07-22 00:00:00	32020		\N	315453	0	65966004	4278672		0
58918	3495	80180	2001-02-27	2001-02-27 00:00:00	\N	\N	32020		\N	231823	0	396275006	80180		0
69573	4117	4027663	1988-12-07	1988-12-07 00:00:00	\N	\N	32020		\N	273740	0	13200003	4027663		0
80352	4759	378001	1997-04-19	1997-04-19 00:00:00	1997-05-19	1997-05-19 00:00:00	32020		\N	317065	0	62106007	378001		0
80654	4782	4266809	2017-09-07	2017-09-07 00:00:00	\N	\N	32020		\N	318348	0	397881000	4266809		0
70091	4149	4112343	2011-06-15	2011-06-15 00:00:00	2011-06-28	2011-06-28 00:00:00	32020		\N	275746	0	195662009	4112343		0
70373	4167	40481087	2018-06-13	2018-06-13 00:00:00	2018-06-20	2018-06-20 00:00:00	32020		\N	276987	0	444814009	40481087		0
81115	4811	372328	1964-07-22	1964-07-22 00:00:00	1964-09-22	1964-09-22 00:00:00	32020		\N	320069	0	65363002	372328		0
81249	4819	4283893	2016-06-21	2016-06-21 00:00:00	2016-07-26	2016-07-26 00:00:00	32020		\N	320581	0	36971009	4283893		0
70849	4204	4112343	1983-05-21	1983-05-21 00:00:00	1983-06-02	1983-06-02 00:00:00	32020		\N	279114	0	195662009	4112343		0
70950	4208	4027663	1971-11-14	1971-11-14 00:00:00	\N	\N	32020		\N	279384	0	13200003	4027663		0
60564	3580	80180	2017-07-31	2017-07-31 00:00:00	\N	\N	32020		\N	237980	0	396275006	80180		0
71303	4227	40481087	2010-08-04	2010-08-04 00:00:00	2010-08-18	2010-08-18 00:00:00	32020		\N	280849	0	444814009	40481087		0
71442	4238	40481087	1977-04-07	1977-04-07 00:00:00	1977-04-28	1977-04-28 00:00:00	32020		\N	281360	0	444814009	40481087		0
71706	4253	4266809	2018-08-01	2018-08-01 00:00:00	\N	\N	32020		\N	282473	0	397881000	4266809		0
71766	4256	4112343	2013-06-22	2013-06-22 00:00:00	2013-07-01	2013-07-01 00:00:00	32020		\N	282617	0	195662009	4112343		0
71941	4269	40481087	1997-11-17	1997-11-17 00:00:00	1997-12-01	1997-12-01 00:00:00	32020		\N	283325	0	444814009	40481087		0
72079	4278	40481087	1952-03-18	1952-03-18 00:00:00	1952-04-08	1952-04-08 00:00:00	32020		\N	283879	0	444814009	40481087		0
72218	4284	28060	1981-11-13	1981-11-13 00:00:00	1981-11-25	1981-11-25 00:00:00	32020		\N	284328	0	43878008	28060		0
83029	4932	4266809	1996-02-23	1996-02-23 00:00:00	\N	\N	32020		\N	327920	0	397881000	4266809		0
72706	4320	40481087	1986-01-28	1986-01-28 00:00:00	1986-02-04	1986-02-04 00:00:00	32020		\N	286661	0	444814009	40481087		0
72813	4328	40481087	1983-04-04	1983-04-04 00:00:00	1983-04-25	1983-04-25 00:00:00	32020		\N	287028	0	444814009	40481087		0
83614	4970	40481087	1925-02-13	1925-02-13 00:00:00	1925-02-27	1925-02-27 00:00:00	32020		\N	330472	0	444814009	40481087		0
73179	4349	4113008	1987-01-10	1987-01-10 00:00:00	1987-01-31	1987-01-31 00:00:00	32020		\N	288400	0	284549007	4113008		0
73280	4355	260139	2018-07-08	2018-07-08 00:00:00	2018-07-15	2018-07-15 00:00:00	32020		\N	288967	0	10509002	260139		0
84035	4990	4112343	2012-03-26	2012-03-26 00:00:00	2012-04-07	2012-04-07 00:00:00	32020		\N	331957	0	195662009	4112343		0
73568	4374	372328	1976-12-16	1976-12-16 00:00:00	1977-02-03	1977-02-03 00:00:00	32020		\N	290540	0	65363002	372328		0
84342	5014	4027663	1937-11-06	1937-11-06 00:00:00	\N	\N	32020		\N	333281	0	13200003	4027663		0
84576	5031	4218389	1995-05-23	1995-05-23 00:00:00	1995-06-13	1995-06-13 00:00:00	32020		\N	334282	0	39848009	4218389		0
74196	4406	195588	1976-11-13	1976-11-13 00:00:00	1977-01-08	1977-01-08 00:00:00	32020		\N	292906	0	38822007	195588		0
84868	5048	40481087	1965-05-11	1965-05-11 00:00:00	1965-06-01	1965-06-01 00:00:00	32020		\N	335402	0	444814009	40481087		0
74420	4418	260139	1968-11-25	1968-11-25 00:00:00	1968-12-09	1968-12-09 00:00:00	32020		\N	293781	0	10509002	260139		0
74624	4433	4112343	1950-03-23	1950-03-23 00:00:00	1950-04-05	1950-04-05 00:00:00	32020		\N	294642	0	195662009	4112343		0
64195	3790	4310024	1999-05-18	1999-05-18 00:00:00	\N	\N	32020		\N	251978	0	424802006	4310024		0
64335	3799	40481087	2007-04-10	2007-04-10 00:00:00	2007-04-17	2007-04-17 00:00:00	32020		\N	252575	0	444814009	40481087		0
64457	3807	40481087	1991-08-23	1991-08-23 00:00:00	1991-09-06	1991-09-06 00:00:00	32020		\N	252979	0	444814009	40481087		0
75202	4467	40481087	1952-10-27	1952-10-27 00:00:00	1952-11-03	1952-11-03 00:00:00	32020		\N	297200	0	444814009	40481087		0
54279	3216	4027663	1985-06-14	1985-06-14 00:00:00	\N	\N	32020		\N	213693	0	13200003	4027663		0
64986	3843	4218389	1979-06-14	1979-06-14 00:00:00	1979-07-19	1979-07-19 00:00:00	32020		\N	255095	0	39848009	4218389		0
65113	3851	40481087	1989-05-13	1989-05-13 00:00:00	1989-06-03	1989-06-03 00:00:00	32020		\N	255496	0	444814009	40481087		0
65306	3862	4283893	1987-08-20	1987-08-20 00:00:00	1987-11-19	1987-11-19 00:00:00	32020		\N	256380	0	36971009	4283893		0
65504	3874	4280726	1983-12-30	1983-12-30 00:00:00	2000-12-27	2000-12-27 00:00:00	32020		\N	257306	0	367498001	4280726		0
76221	4523	260139	1998-11-27	1998-11-27 00:00:00	1998-12-04	1998-12-04 00:00:00	32020		\N	301183	0	10509002	260139		0
76392	4531	4112343	2011-07-11	2011-07-11 00:00:00	2011-07-19	2011-07-19 00:00:00	32020		\N	301731	0	195662009	4112343		0
65994	3901	4218389	2012-11-03	2012-11-03 00:00:00	2012-12-08	2012-12-08 00:00:00	32020		\N	259389	0	39848009	4218389		0
66182	3917	40481087	1980-12-26	1980-12-26 00:00:00	1981-01-16	1981-01-16 00:00:00	32020		\N	260445	0	444814009	40481087		0
66362	3929	257012	1958-01-21	1958-01-21 00:00:00	\N	\N	32020		\N	261153	0	40055000	257012		0
66461	3934	4218389	1981-08-07	1981-08-07 00:00:00	1981-08-28	1981-08-28 00:00:00	32020		\N	261503	0	39848009	4218389		0
77249	4576	372328	1955-12-03	1955-12-03 00:00:00	1956-02-01	1956-02-01 00:00:00	32020		\N	304818	0	65363002	372328		0
66877	3956	4112343	2004-12-13	2004-12-13 00:00:00	2004-12-23	2004-12-23 00:00:00	32020		\N	262966	0	195662009	4112343		0
67017	3962	4294548	1958-08-14	1958-08-14 00:00:00	1958-11-20	1958-11-20 00:00:00	32020		\N	263437	0	75498004	4294548		0
67191	3972	4112343	1997-01-16	1997-01-16 00:00:00	1997-01-27	1997-01-27 00:00:00	32020		\N	264142	0	195662009	4112343		0
67528	3989	260139	1959-01-20	1959-01-20 00:00:00	1959-02-03	1959-02-03 00:00:00	32020		\N	265155	0	10509002	260139		0
67650	3996	4149245	1989-05-08	1989-05-08 00:00:00	1989-06-14	1989-06-14 00:00:00	32020		\N	265696	0	30832001	4149245		0
67799	4006	4283893	2001-04-08	2001-04-08 00:00:00	2001-06-03	2001-06-03 00:00:00	32020		\N	266183	0	36971009	4283893		0
68028	4019	4112343	2001-03-05	2001-03-05 00:00:00	2001-03-18	2001-03-18 00:00:00	32020		\N	267128	0	195662009	4112343		0
68146	4024	40481087	2015-05-14	2015-05-14 00:00:00	2015-05-21	2015-05-21 00:00:00	32020		\N	267547	0	444814009	40481087		0
78905	4674	40481087	2003-02-20	2003-02-20 00:00:00	2003-03-06	2003-03-06 00:00:00	32020		\N	311359	0	444814009	40481087		0
68521	4052	40481087	1980-03-04	1980-03-04 00:00:00	1980-03-11	1980-03-11 00:00:00	32020		\N	269317	0	444814009	40481087		0
79191	4689	4156265	1994-08-07	1994-08-07 00:00:00	1994-08-28	1994-08-28 00:00:00	32020		\N	312393	0	370247008	4156265		0
79362	4700	4112343	1955-08-31	1955-08-31 00:00:00	1955-09-12	1955-09-12 00:00:00	32020		\N	313118	0	195662009	4112343		0
68909	4078	4218389	1986-09-15	1986-09-15 00:00:00	1986-10-13	1986-10-13 00:00:00	32020		\N	271097	0	39848009	4218389		0
69142	4091	4113008	2012-09-28	2012-09-28 00:00:00	2012-10-12	2012-10-12 00:00:00	32020		\N	271943	0	284549007	4113008		0
79923	4736	260139	1982-08-17	1982-08-17 00:00:00	1982-08-24	1982-08-24 00:00:00	32020		\N	315477	0	10509002	260139		0
58919	3495	40481087	2003-02-03	2003-02-03 00:00:00	2003-02-17	2003-02-17 00:00:00	32020		\N	231853	0	444814009	40481087		0
69574	4117	28060	1964-05-10	1964-05-10 00:00:00	1964-05-19	1964-05-19 00:00:00	32020		\N	273690	0	43878008	28060		0
80353	4759	372328	1980-05-29	1980-05-29 00:00:00	1980-08-12	1980-08-12 00:00:00	32020		\N	317064	0	65363002	372328		0
80655	4782	80180	2017-09-07	2017-09-07 00:00:00	\N	\N	32020		\N	318348	0	396275006	80180		0
70092	4149	28060	2005-06-25	2005-06-25 00:00:00	2005-07-03	2005-07-03 00:00:00	32020		\N	275713	0	43878008	28060		0
70374	4167	28060	1990-07-02	1990-07-02 00:00:00	1990-07-10	1990-07-10 00:00:00	32020		\N	276923	0	43878008	28060		0
81116	4811	372328	1963-12-07	1963-12-07 00:00:00	1964-03-23	1964-03-23 00:00:00	32020		\N	320026	0	65363002	372328		0
81250	4819	40481087	2011-04-15	2011-04-15 00:00:00	2011-04-29	2011-04-29 00:00:00	32020		\N	320559	0	444814009	40481087		0
70850	4204	40481087	1954-03-04	1954-03-04 00:00:00	1954-03-11	1954-03-11 00:00:00	32020		\N	279073	0	444814009	40481087		0
70951	4208	4112343	2012-09-06	2012-09-06 00:00:00	2012-09-18	2012-09-18 00:00:00	32020		\N	279451	0	195662009	4112343		0
60565	3580	4283893	1990-02-08	1990-02-08 00:00:00	1990-04-19	1990-04-19 00:00:00	32020		\N	237969	0	36971009	4283893		0
71309	4229	78272	1956-02-15	1956-02-15 00:00:00	1956-03-07	1956-03-07 00:00:00	32020		\N	280920	0	70704007	78272		0
71443	4238	4112343	1973-06-10	1973-06-10 00:00:00	1973-06-22	1973-06-22 00:00:00	32020		\N	281359	0	195662009	4112343		0
71707	4253	4285898	2017-12-03	2017-12-03 00:00:00	\N	\N	32020		\N	282473	0	68496003	4285898		0
71797	4260	378001	1974-08-10	1974-08-10 00:00:00	1974-09-09	1974-09-09 00:00:00	32020		\N	282845	0	62106007	378001		0
71942	4269	81151	1975-02-24	1975-02-24 00:00:00	1975-03-17	1975-03-17 00:00:00	32020		\N	283350	0	44465007	81151		0
72080	4278	4112343	1955-11-25	1955-11-25 00:00:00	1955-12-08	1955-12-08 00:00:00	32020		\N	283902	0	195662009	4112343		0
72219	4284	40481087	1948-08-08	1948-08-08 00:00:00	1948-08-29	1948-08-29 00:00:00	32020		\N	284363	0	444814009	40481087		0
83030	4932	80180	1996-02-23	1996-02-23 00:00:00	\N	\N	32020		\N	327920	0	396275006	80180		0
72707	4320	4156265	1979-07-10	1979-07-10 00:00:00	1979-07-24	1979-07-24 00:00:00	32020		\N	286670	0	370247008	4156265		0
72814	4328	260139	2015-02-02	2015-02-02 00:00:00	2015-02-09	2015-02-09 00:00:00	32020		\N	287019	0	10509002	260139		0
83615	4970	4296204	1934-10-17	1934-10-17 00:00:00	1934-11-21	1934-11-21 00:00:00	32020		\N	330394	0	403190006	4296204		0
73180	4349	28060	1992-07-14	1992-07-14 00:00:00	1992-07-23	1992-07-23 00:00:00	32020		\N	288431	0	43878008	28060		0
73281	4355	40481087	1999-05-29	1999-05-29 00:00:00	1999-06-12	1999-06-12 00:00:00	32020		\N	288991	0	444814009	40481087		0
84036	4990	4116491	1986-04-17	1986-04-17 00:00:00	1986-06-02	1986-06-02 00:00:00	32020		\N	331962	0	301011002	4116491		0
73569	4374	40481087	2015-03-24	2015-03-24 00:00:00	2015-04-07	2015-04-07 00:00:00	32020		\N	290511	0	444814009	40481087		0
84343	5014	40481087	1978-10-19	1978-10-19 00:00:00	1978-10-26	1978-10-26 00:00:00	32020		\N	333289	0	444814009	40481087		0
84577	5031	381316	1995-08-19	1995-08-19 00:00:00	\N	\N	32020		\N	334282	0	230690007	381316		0
74197	4406	4112343	1989-08-07	1989-08-07 00:00:00	1989-08-15	1989-08-15 00:00:00	32020		\N	292865	0	195662009	4112343		0
84869	5048	4218389	1993-08-03	1993-08-03 00:00:00	1993-08-24	1993-08-24 00:00:00	32020		\N	335503	0	39848009	4218389		0
74421	4418	78272	1956-05-22	1956-05-22 00:00:00	1956-06-12	1956-06-12 00:00:00	32020		\N	293695	0	70704007	78272		0
74625	4433	40481087	1970-09-21	1970-09-21 00:00:00	1970-10-12	1970-10-12 00:00:00	32020		\N	294643	0	444814009	40481087		0
64196	3790	81893	2000-04-12	2000-04-12 00:00:00	\N	\N	32020		\N	251978	0	64766004	81893		0
64336	3799	260139	1973-10-15	1973-10-15 00:00:00	1973-10-22	1973-10-22 00:00:00	32020		\N	252561	0	10509002	260139		0
64458	3807	372328	1960-04-03	1960-04-03 00:00:00	1960-06-25	1960-06-25 00:00:00	32020		\N	253002	0	65363002	372328		0
75203	4467	4112343	1952-05-25	1952-05-25 00:00:00	1952-06-06	1952-06-06 00:00:00	32020		\N	297223	0	195662009	4112343		0
54280	3216	260139	1959-10-26	1959-10-26 00:00:00	1959-11-09	1959-11-09 00:00:00	32020		\N	213750	0	10509002	260139		0
64987	3843	372328	1972-02-21	1972-02-21 00:00:00	1972-05-14	1972-05-14 00:00:00	32020		\N	255066	0	65363002	372328		0
65114	3851	81151	1987-08-02	1987-08-02 00:00:00	1987-08-16	1987-08-16 00:00:00	32020		\N	255595	0	44465007	81151		0
65307	3862	4112343	1976-05-31	1976-05-31 00:00:00	1976-06-11	1976-06-11 00:00:00	32020		\N	256425	0	195662009	4112343		0
65505	3874	40481087	1994-06-16	1994-06-16 00:00:00	1994-06-30	1994-06-30 00:00:00	32020		\N	257212	0	444814009	40481087		0
76222	4523	4156265	2015-11-20	2015-11-20 00:00:00	2015-12-04	2015-12-04 00:00:00	32020		\N	301157	0	370247008	4156265		0
76393	4531	40481087	1985-01-12	1985-01-12 00:00:00	1985-01-19	1985-01-19 00:00:00	32020		\N	301749	0	444814009	40481087		0
65995	3901	40481087	1965-10-26	1965-10-26 00:00:00	1965-11-09	1965-11-09 00:00:00	32020		\N	259343	0	444814009	40481087		0
66183	3917	80809	2008-08-27	2008-08-27 00:00:00	2012-03-09	2012-03-09 00:00:00	32020		\N	260491	0	69896004	80809		0
66363	3929	260139	1970-06-27	1970-06-27 00:00:00	1970-07-04	1970-07-04 00:00:00	32020		\N	261154	0	10509002	260139		0
66462	3934	40481087	1965-09-24	1965-09-24 00:00:00	1965-10-08	1965-10-08 00:00:00	32020		\N	261450	0	444814009	40481087		0
77250	4576	260139	1963-04-02	1963-04-02 00:00:00	1963-04-09	1963-04-09 00:00:00	32020		\N	304828	0	10509002	260139		0
66878	3956	4027663	1948-10-30	1948-10-30 00:00:00	\N	\N	32020		\N	262946	0	13200003	4027663		0
67018	3962	372328	1956-12-17	1956-12-17 00:00:00	1957-05-03	1957-05-03 00:00:00	32020		\N	263452	0	65363002	372328		0
67192	3972	78272	1971-10-05	1971-10-05 00:00:00	1971-11-09	1971-11-09 00:00:00	32020		\N	264135	0	70704007	78272		0
77997	4622	4285898	1996-12-06	1996-12-06 00:00:00	\N	\N	32020		\N	307781	0	68496003	4285898		0
67529	3989	40481087	1957-04-20	1957-04-20 00:00:00	1957-05-04	1957-05-04 00:00:00	32020		\N	265256	0	444814009	40481087		0
67651	3997	28060	1973-04-27	1973-04-27 00:00:00	1973-05-10	1973-05-10 00:00:00	32020		\N	265730	0	43878008	28060		0
67800	4006	4112343	1957-09-06	1957-09-06 00:00:00	1957-09-16	1957-09-16 00:00:00	32020		\N	266201	0	195662009	4112343		0
68029	4019	260139	1988-04-05	1988-04-05 00:00:00	1988-04-12	1988-04-12 00:00:00	32020		\N	267137	0	10509002	260139		0
68147	4024	40481087	2006-12-15	2006-12-15 00:00:00	2006-12-22	2006-12-22 00:00:00	32020		\N	267510	0	444814009	40481087		0
78906	4674	80180	2005-04-28	2005-04-28 00:00:00	\N	\N	32020		\N	311359	0	396275006	80180		0
68522	4052	4237458	1985-11-24	1985-11-24 00:00:00	1985-12-24	1985-12-24 00:00:00	32020		\N	269341	0	58150001	4237458		0
68910	4078	40481087	1965-09-20	1965-09-20 00:00:00	1965-10-04	1965-10-04 00:00:00	32020		\N	271016	0	444814009	40481087		0
69143	4091	4027663	1997-11-18	1997-11-18 00:00:00	\N	\N	32020		\N	271963	0	13200003	4027663		0
79924	4736	372328	1976-11-06	1976-11-06 00:00:00	1977-08-05	1977-08-05 00:00:00	32020		\N	315504	0	65363002	372328		0
58920	3495	372328	1967-02-19	1967-02-19 00:00:00	1967-05-24	1967-05-24 00:00:00	32020		\N	231846	0	65363002	372328		0
69575	4117	4112343	2017-10-18	2017-10-18 00:00:00	2017-10-30	2017-10-30 00:00:00	32020		\N	273716	0	195662009	4112343		0
80354	4759	4237458	1979-12-01	1979-12-01 00:00:00	1980-02-29	1980-02-29 00:00:00	32020		\N	317116	0	58150001	4237458		0
80656	4782	4112343	2005-03-01	2005-03-01 00:00:00	2005-03-12	2005-03-12 00:00:00	32020		\N	318359	0	195662009	4112343		0
70093	4149	372328	1970-11-12	1970-11-12 00:00:00	1970-11-26	1970-11-26 00:00:00	32020		\N	275742	0	65363002	372328		0
70375	4168	28060	1973-04-26	1973-04-26 00:00:00	1973-05-08	1973-05-08 00:00:00	32020		\N	277038	0	43878008	28060		0
81118	4811	4112343	1962-06-17	1962-06-17 00:00:00	1962-06-30	1962-06-30 00:00:00	32020		\N	320071	0	195662009	4112343		0
81251	4819	4112343	1976-06-17	1976-06-17 00:00:00	1976-06-27	1976-06-27 00:00:00	32020		\N	320522	0	195662009	4112343		0
70851	4204	4112343	1980-11-21	1980-11-21 00:00:00	1980-12-01	1980-12-01 00:00:00	32020		\N	279069	0	195662009	4112343		0
70952	4208	4218389	1995-04-16	1995-04-16 00:00:00	1995-05-21	1995-05-21 00:00:00	32020		\N	279430	0	39848009	4218389		0
60580	3582	28060	1997-01-08	1997-01-08 00:00:00	1997-01-19	1997-01-19 00:00:00	32020		\N	238137	0	43878008	28060		0
71310	4229	372328	1959-08-14	1959-08-14 00:00:00	1960-06-25	1960-06-25 00:00:00	32020		\N	280950	0	65363002	372328		0
71444	4238	4112343	1967-01-03	1967-01-03 00:00:00	1967-01-10	1967-01-10 00:00:00	32020		\N	281388	0	195662009	4112343		0
71708	4253	80180	2018-08-01	2018-08-01 00:00:00	\N	\N	32020		\N	282473	0	396275006	80180		0
71798	4260	378001	1948-08-26	1948-08-26 00:00:00	1948-09-25	1948-09-25 00:00:00	32020		\N	282844	0	62106007	378001		0
71943	4269	4166224	1976-05-01	1976-05-01 00:00:00	\N	\N	32020		\N	283351	0	47693006	4166224		0
72081	4278	40481087	2005-11-12	2005-11-12 00:00:00	2005-11-26	2005-11-26 00:00:00	32020		\N	283899	0	444814009	40481087		0
72220	4284	4112343	2014-09-19	2014-09-19 00:00:00	2014-10-01	2014-10-01 00:00:00	32020		\N	284396	0	195662009	4112343		0
83031	4932	260139	2010-10-22	2010-10-22 00:00:00	2010-10-29	2010-10-29 00:00:00	32020		\N	327924	0	10509002	260139		0
72708	4320	192671	2010-03-23	2010-03-23 00:00:00	\N	\N	32020		\N	286639	0	K92.2	35208414		0
72815	4328	40481087	2016-07-21	2016-07-21 00:00:00	2016-07-28	2016-07-28 00:00:00	32020		\N	287036	0	444814009	40481087		0
83616	4970	40481087	1926-02-28	1926-02-28 00:00:00	1926-03-21	1926-03-21 00:00:00	32020		\N	330342	0	444814009	40481087		0
73181	4349	81151	1991-02-09	1991-02-09 00:00:00	1991-03-09	1991-03-09 00:00:00	32020		\N	288402	0	44465007	81151		0
73282	4355	40481087	2009-05-03	2009-05-03 00:00:00	2009-05-10	2009-05-10 00:00:00	32020		\N	288989	0	444814009	40481087		0
84037	4990	4142905	1966-03-04	1966-03-04 00:00:00	1966-06-02	1966-06-02 00:00:00	32020		\N	331967	0	33737001	4142905		0
73570	4374	40481087	2016-10-03	2016-10-03 00:00:00	2016-10-24	2016-10-24 00:00:00	32020		\N	290532	0	444814009	40481087		0
84344	5014	40481087	1958-12-06	1958-12-06 00:00:00	1958-12-13	1958-12-13 00:00:00	32020		\N	333263	0	444814009	40481087		0
84578	5031	40481087	1947-11-03	1947-11-03 00:00:00	1947-11-17	1947-11-17 00:00:00	32020		\N	334313	0	444814009	40481087		0
74198	4406	4112343	1942-03-25	1942-03-25 00:00:00	1942-04-07	1942-04-07 00:00:00	32020		\N	292861	0	195662009	4112343		0
84870	5048	4112343	1981-06-11	1981-06-11 00:00:00	1981-06-19	1981-06-19 00:00:00	32020		\N	335461	0	195662009	4112343		0
74422	4418	260139	1996-12-07	1996-12-07 00:00:00	1996-12-21	1996-12-21 00:00:00	32020		\N	293704	0	10509002	260139		0
74626	4433	313217	1993-04-10	1993-04-10 00:00:00	\N	\N	32020		\N	294693	0	49436004	313217		0
64197	3790	372328	1966-06-29	1966-06-29 00:00:00	1966-12-05	1966-12-05 00:00:00	32020		\N	251970	0	65363002	372328		0
64337	3799	28060	1978-03-22	1978-03-22 00:00:00	1978-03-29	1978-03-29 00:00:00	32020		\N	252571	0	43878008	28060		0
64473	3811	40481087	1952-07-16	1952-07-16 00:00:00	1952-07-30	1952-07-30 00:00:00	32020		\N	253214	0	444814009	40481087		0
75204	4467	372328	1957-04-27	1957-04-27 00:00:00	1957-06-13	1957-06-13 00:00:00	32020		\N	297245	0	65363002	372328		0
54281	3216	40481087	1973-12-03	1973-12-03 00:00:00	1973-12-10	1973-12-10 00:00:00	32020		\N	213744	0	444814009	40481087		0
64988	3843	40481087	1976-08-30	1976-08-30 00:00:00	1976-09-13	1976-09-13 00:00:00	32020		\N	255092	0	444814009	40481087		0
65115	3851	4283893	1971-02-03	1971-02-03 00:00:00	1971-08-11	1971-08-11 00:00:00	32020		\N	255494	0	36971009	4283893		0
65308	3862	257012	1969-04-01	1969-04-01 00:00:00	\N	\N	32020		\N	256379	0	40055000	257012		0
65506	3874	4134304	1986-09-28	1986-09-28 00:00:00	1986-11-27	1986-11-27 00:00:00	32020		\N	257236	0	263102004	4134304		0
76223	4523	4134304	1989-01-21	1989-01-21 00:00:00	1989-02-20	1989-02-20 00:00:00	32020		\N	301154	0	263102004	4134304		0
76394	4531	40481087	1974-05-01	1974-05-01 00:00:00	1974-05-22	1974-05-22 00:00:00	32020		\N	301748	0	444814009	40481087		0
65996	3901	40481087	1955-01-22	1955-01-22 00:00:00	1955-02-12	1955-02-12 00:00:00	32020		\N	259342	0	444814009	40481087		0
66184	3917	40481087	1982-12-12	1982-12-12 00:00:00	1982-12-19	1982-12-19 00:00:00	32020		\N	260470	0	444814009	40481087		0
66364	3929	378001	1970-09-12	1970-09-12 00:00:00	1970-11-11	1970-11-11 00:00:00	32020		\N	261167	0	62106007	378001		0
66463	3934	40481087	1992-10-18	1992-10-18 00:00:00	1992-11-08	1992-11-08 00:00:00	32020		\N	261480	0	444814009	40481087		0
77251	4576	260139	1988-05-03	1988-05-03 00:00:00	1988-05-17	1988-05-17 00:00:00	32020		\N	304787	0	10509002	260139		0
66879	3956	4283893	2011-02-22	2011-02-22 00:00:00	2011-03-15	2011-03-15 00:00:00	32020		\N	262967	0	36971009	4283893		0
67019	3962	40481087	1990-11-21	1990-11-21 00:00:00	1990-12-12	1990-12-12 00:00:00	32020		\N	263391	0	444814009	40481087		0
67193	3972	4296204	2016-03-22	2016-03-22 00:00:00	2016-04-19	2016-04-19 00:00:00	32020		\N	264118	0	403190006	4296204		0
77998	4622	4112343	2017-07-31	2017-07-31 00:00:00	2017-08-08	2017-08-08 00:00:00	32020		\N	307841	0	195662009	4112343		0
67530	3989	260139	1981-01-13	1981-01-13 00:00:00	1981-01-20	1981-01-20 00:00:00	32020		\N	265257	0	10509002	260139		0
67652	3997	40481087	2004-12-09	2004-12-09 00:00:00	2004-12-16	2004-12-16 00:00:00	32020		\N	265742	0	444814009	40481087		0
67801	4006	40481087	1967-01-19	1967-01-19 00:00:00	1967-01-26	1967-01-26 00:00:00	32020		\N	266203	0	444814009	40481087		0
68030	4019	40481087	2014-02-11	2014-02-11 00:00:00	2014-02-18	2014-02-18 00:00:00	32020		\N	267142	0	444814009	40481087		0
68149	4026	4112343	2000-04-21	2000-04-21 00:00:00	2000-05-03	2000-05-03 00:00:00	32020		\N	267624	0	195662009	4112343		0
78907	4674	40481087	2015-10-05	2015-10-05 00:00:00	2015-10-19	2015-10-19 00:00:00	32020		\N	311368	0	444814009	40481087		0
68523	4052	260139	2004-02-26	2004-02-26 00:00:00	2004-03-04	2004-03-04 00:00:00	32020		\N	269345	0	10509002	260139		0
79193	4689	40481087	2004-04-28	2004-04-28 00:00:00	2004-05-19	2004-05-19 00:00:00	32020		\N	312407	0	444814009	40481087		0
79364	4700	4112343	1959-01-09	1959-01-09 00:00:00	1959-01-22	1959-01-22 00:00:00	32020		\N	313021	0	195662009	4112343		0
68934	4080	81893	2001-04-18	2001-04-18 00:00:00	\N	\N	32020		\N	271190	0	64766004	81893		0
69144	4091	4112343	2000-01-30	2000-01-30 00:00:00	2000-02-08	2000-02-08 00:00:00	32020		\N	271989	0	195662009	4112343		0
79925	4736	260139	1979-11-23	1979-11-23 00:00:00	1979-11-30	1979-11-30 00:00:00	32020		\N	315483	0	10509002	260139		0
58921	3495	260139	2008-10-06	2008-10-06 00:00:00	2008-10-20	2008-10-20 00:00:00	32020		\N	231854	0	10509002	260139		0
69576	4117	78272	2011-09-03	2011-09-03 00:00:00	2011-10-01	2011-10-01 00:00:00	32020		\N	273681	0	70704007	78272		0
80355	4759	40481087	2014-09-24	2014-09-24 00:00:00	2014-10-08	2014-10-08 00:00:00	32020		\N	317063	0	444814009	40481087		0
80657	4782	260139	2004-05-18	2004-05-18 00:00:00	2004-05-25	2004-05-25 00:00:00	32020		\N	318366	0	10509002	260139		0
81119	4812	28060	1986-07-26	1986-07-26 00:00:00	1986-08-06	1986-08-06 00:00:00	32020		\N	320110	0	43878008	28060		0
81252	4819	260139	1993-12-03	1993-12-03 00:00:00	1993-12-17	1993-12-17 00:00:00	32020		\N	320515	0	10509002	260139		0
70852	4204	4283893	1980-07-08	1980-07-08 00:00:00	1980-08-05	1980-08-05 00:00:00	32020		\N	279076	0	36971009	4283893		0
70953	4208	260139	1961-02-17	1961-02-17 00:00:00	1961-02-24	1961-02-24 00:00:00	32020		\N	279398	0	10509002	260139		0
60581	3582	81893	1999-09-09	1999-09-09 00:00:00	\N	\N	32020		\N	238131	0	64766004	81893		0
71311	4229	4237458	1957-03-02	1957-03-02 00:00:00	1957-05-01	1957-05-01 00:00:00	32020		\N	280921	0	58150001	4237458		0
71445	4239	372328	1954-06-17	1954-06-17 00:00:00	1954-11-20	1954-11-20 00:00:00	32020		\N	281581	0	65363002	372328		0
71709	4253	30753	2017-11-04	2017-11-04 00:00:00	\N	\N	32020		\N	282473	0	16761005	30753		0
71799	4260	40481087	1993-05-03	1993-05-03 00:00:00	1993-05-10	1993-05-10 00:00:00	32020		\N	282836	0	444814009	40481087		0
71944	4269	440448	1976-05-01	1976-05-01 00:00:00	\N	\N	32020		\N	283351	0	74400008	440448		0
72082	4278	4146173	1960-02-21	1960-02-21 00:00:00	1960-04-21	1960-04-21 00:00:00	32020		\N	283903	0	307731004	4146173		0
72221	4284	4112343	1951-04-02	1951-04-02 00:00:00	1951-04-13	1951-04-13 00:00:00	32020		\N	284364	0	195662009	4112343		0
83032	4932	40481087	2002-07-13	2002-07-13 00:00:00	2002-08-03	2002-08-03 00:00:00	32020		\N	327922	0	444814009	40481087		0
83167	4942	4059173	1955-02-23	1955-02-23 00:00:00	1955-04-24	1955-04-24 00:00:00	32020		\N	328460	0	16114001	4059173		0
72816	4328	4112343	1980-05-13	1980-05-13 00:00:00	1980-05-21	1980-05-21 00:00:00	32020		\N	287013	0	195662009	4112343		0
83617	4970	260139	1983-01-21	1983-01-21 00:00:00	1983-01-28	1983-01-28 00:00:00	32020		\N	330427	0	10509002	260139		0
73182	4349	40481087	1989-03-06	1989-03-06 00:00:00	1989-03-27	1989-03-27 00:00:00	32020		\N	288403	0	444814009	40481087		0
73283	4355	4112343	2009-11-19	2009-11-19 00:00:00	2009-12-01	2009-12-01 00:00:00	32020		\N	288995	0	195662009	4112343		0
84038	4990	4112343	1965-05-12	1965-05-12 00:00:00	1965-05-25	1965-05-25 00:00:00	32020		\N	331972	0	195662009	4112343		0
73571	4374	372328	1989-06-07	1989-06-07 00:00:00	1989-06-21	1989-06-21 00:00:00	32020		\N	290541	0	65363002	372328		0
84345	5014	81151	1953-09-06	1953-09-06 00:00:00	1953-10-11	1953-10-11 00:00:00	32020		\N	333254	0	44465007	81151		0
84579	5031	257012	1990-06-11	1990-06-11 00:00:00	\N	\N	32020		\N	334396	0	40055000	257012		0
74199	4406	4112343	1986-05-11	1986-05-11 00:00:00	1986-05-23	1986-05-23 00:00:00	32020		\N	292897	0	195662009	4112343		0
84871	5048	40481087	1966-08-30	1966-08-30 00:00:00	1966-09-06	1966-09-06 00:00:00	32020		\N	335519	0	444814009	40481087		0
74423	4418	40481087	1991-11-11	1991-11-11 00:00:00	1991-12-02	1991-12-02 00:00:00	32020		\N	293751	0	444814009	40481087		0
74627	4433	40481087	1989-05-04	1989-05-04 00:00:00	1989-05-11	1989-05-11 00:00:00	32020		\N	294721	0	444814009	40481087		0
64198	3790	4112343	2004-08-03	2004-08-03 00:00:00	2004-08-16	2004-08-16 00:00:00	32020		\N	252022	0	195662009	4112343		0
64338	3799	4237458	2000-04-22	2000-04-22 00:00:00	2000-07-21	2000-07-21 00:00:00	32020		\N	252529	0	58150001	4237458		0
64474	3811	80180	1955-12-13	1955-12-13 00:00:00	\N	\N	32020		\N	253151	0	396275006	80180		0
75205	4467	4109685	1956-05-02	1956-05-02 00:00:00	1956-05-23	1956-05-23 00:00:00	32020		\N	297160	0	284551006	4109685		0
54282	3216	260139	1963-10-22	1963-10-22 00:00:00	1963-11-05	1963-11-05 00:00:00	32020		\N	213743	0	10509002	260139		0
64989	3843	4283893	2001-05-25	2001-05-25 00:00:00	2001-06-15	2001-06-15 00:00:00	32020		\N	255069	0	36971009	4283893		0
65116	3851	4112343	1958-10-30	1958-10-30 00:00:00	1958-11-10	1958-11-10 00:00:00	32020		\N	255562	0	195662009	4112343		0
65309	3862	375671	2008-04-28	2008-04-28 00:00:00	2008-05-28	2008-05-28 00:00:00	32020		\N	256459	0	62564004	375671		0
65507	3874	260139	2012-06-15	2012-06-15 00:00:00	2012-06-29	2012-06-29 00:00:00	32020		\N	257271	0	10509002	260139		0
76224	4523	260139	2017-04-30	2017-04-30 00:00:00	2017-05-07	2017-05-07 00:00:00	32020		\N	301202	0	10509002	260139		0
76395	4531	81151	1982-06-13	1982-06-13 00:00:00	1982-06-27	1982-06-27 00:00:00	32020		\N	301706	0	44465007	81151		0
65997	3901	40481087	2009-08-10	2009-08-10 00:00:00	2009-08-24	2009-08-24 00:00:00	32020		\N	259420	0	444814009	40481087		0
66185	3917	40481087	1974-09-19	1974-09-19 00:00:00	1974-10-10	1974-10-10 00:00:00	32020		\N	260443	0	444814009	40481087		0
66365	3929	4112343	1957-02-10	1957-02-10 00:00:00	1957-02-22	1957-02-22 00:00:00	32020		\N	261184	0	195662009	4112343		0
66464	3934	4113008	1941-10-01	1941-10-01 00:00:00	1941-10-22	1941-10-22 00:00:00	32020		\N	261498	0	284549007	4113008		0
77252	4576	80180	1993-03-31	1993-03-31 00:00:00	\N	\N	32020		\N	304854	0	396275006	80180		0
66880	3956	80180	1959-02-10	1959-02-10 00:00:00	\N	\N	32020		\N	263022	0	396275006	80180		0
67020	3962	4112343	1992-08-30	1992-08-30 00:00:00	1992-09-10	1992-09-10 00:00:00	32020		\N	263448	0	195662009	4112343		0
67194	3972	80180	1999-07-25	1999-07-25 00:00:00	\N	\N	32020		\N	264153	0	396275006	80180		0
77999	4622	4218389	1962-12-20	1962-12-20 00:00:00	1963-01-24	1963-01-24 00:00:00	32020		\N	307828	0	39848009	4218389		0
67534	3991	257012	2014-09-12	2014-09-12 00:00:00	\N	\N	32020		\N	265397	0	40055000	257012		0
67653	3997	40481087	1991-02-14	1991-02-14 00:00:00	1991-02-28	1991-02-28 00:00:00	32020		\N	265769	0	444814009	40481087		0
67802	4006	260139	1970-10-05	1970-10-05 00:00:00	1970-10-12	1970-10-12 00:00:00	32020		\N	266137	0	10509002	260139		0
68031	4019	4266809	2005-04-30	2005-04-30 00:00:00	\N	\N	32020		\N	267186	0	397881000	4266809		0
68150	4026	260139	1970-11-21	1970-11-21 00:00:00	1970-12-05	1970-12-05 00:00:00	32020		\N	267721	0	10509002	260139		0
78908	4674	40481087	1988-03-14	1988-03-14 00:00:00	1988-04-04	1988-04-04 00:00:00	32020		\N	311380	0	444814009	40481087		0
68524	4052	40481087	1999-07-19	1999-07-19 00:00:00	1999-08-02	1999-08-02 00:00:00	32020		\N	269301	0	444814009	40481087		0
79194	4689	28060	1968-07-07	1968-07-07 00:00:00	1968-07-15	1968-07-15 00:00:00	32020		\N	312443	0	43878008	28060		0
79365	4701	372328	1971-02-25	1971-02-25 00:00:00	1971-05-07	1971-05-07 00:00:00	32020		\N	313139	0	65363002	372328		0
68935	4080	4310024	2001-01-18	2001-01-18 00:00:00	\N	\N	32020		\N	271190	0	424802006	4310024		0
69145	4091	4294548	1983-12-10	1983-12-10 00:00:00	1984-01-07	1984-01-07 00:00:00	32020		\N	271951	0	75498004	4294548		0
79926	4736	260139	1994-09-30	1994-09-30 00:00:00	1994-10-14	1994-10-14 00:00:00	32020		\N	315478	0	10509002	260139		0
58922	3495	372328	1968-01-19	1968-01-19 00:00:00	1968-05-22	1968-05-22 00:00:00	32020		\N	231847	0	65363002	372328		0
69577	4117	192671	1996-08-08	1996-08-08 00:00:00	\N	\N	32020		\N	273735	0	K92.2	35208414		0
80356	4760	4112343	2013-03-28	2013-03-28 00:00:00	2013-04-07	2013-04-07 00:00:00	32020		\N	317124	0	195662009	4112343		0
80658	4782	4310024	2015-06-20	2015-06-20 00:00:00	\N	\N	32020		\N	318347	0	424802006	4310024		0
70095	4149	4112343	1973-11-16	1973-11-16 00:00:00	1973-11-27	1973-11-27 00:00:00	32020		\N	275740	0	195662009	4112343		0
70377	4168	4283893	1996-07-12	1996-07-12 00:00:00	1996-08-02	1996-08-02 00:00:00	32020		\N	277026	0	36971009	4283893		0
81120	4812	4112343	1999-05-31	1999-05-31 00:00:00	1999-06-07	1999-06-07 00:00:00	32020		\N	320137	0	195662009	4112343		0
81253	4819	372328	1963-11-30	1963-11-30 00:00:00	1964-04-28	1964-04-28 00:00:00	32020		\N	320560	0	65363002	372328		0
70853	4204	4112343	1987-06-12	1987-06-12 00:00:00	1987-06-19	1987-06-19 00:00:00	32020		\N	279070	0	195662009	4112343		0
70954	4208	4059173	2013-10-04	2013-10-04 00:00:00	2013-11-03	2013-11-03 00:00:00	32020		\N	279460	0	16114001	4059173		0
60582	3582	30753	2000-02-06	2000-02-06 00:00:00	\N	\N	32020		\N	238138	0	16761005	30753		0
71312	4229	78272	1967-07-08	1967-07-08 00:00:00	1967-08-05	1967-08-05 00:00:00	32020		\N	280922	0	70704007	78272		0
71446	4239	4112343	1953-11-01	1953-11-01 00:00:00	1953-11-14	1953-11-14 00:00:00	32020		\N	281514	0	195662009	4112343		0
71712	4255	260139	1988-04-11	1988-04-11 00:00:00	1988-04-25	1988-04-25 00:00:00	32020		\N	282527	0	10509002	260139		0
71945	4269	372328	1968-05-31	1968-05-31 00:00:00	1968-08-07	1968-08-07 00:00:00	32020		\N	283326	0	65363002	372328		0
72083	4278	4152936	2010-09-01	2010-09-01 00:00:00	2010-09-15	2010-09-15 00:00:00	32020		\N	283935	0	283385000	4152936		0
72222	4284	40481087	1982-06-09	1982-06-09 00:00:00	1982-06-16	1982-06-16 00:00:00	32020		\N	284391	0	444814009	40481087		0
83033	4932	4112343	2008-01-11	2008-01-11 00:00:00	2008-01-21	2008-01-21 00:00:00	32020		\N	327923	0	195662009	4112343		0
83168	4942	372328	1954-11-25	1954-11-25 00:00:00	1955-01-06	1955-01-06 00:00:00	32020		\N	328506	0	65363002	372328		0
72817	4328	80180	2009-07-13	2009-07-13 00:00:00	\N	\N	32020		\N	287017	0	396275006	80180		0
83618	4970	40481087	1978-06-05	1978-06-05 00:00:00	1978-06-19	1978-06-19 00:00:00	32020		\N	330494	0	444814009	40481087		0
73183	4349	80180	2019-05-12	2019-05-12 00:00:00	\N	\N	32020		\N	288430	0	396275006	80180		0
73284	4355	80180	2019-04-24	2019-04-24 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
84039	4990	260139	1971-03-09	1971-03-09 00:00:00	1971-03-23	1971-03-23 00:00:00	32020		\N	331974	0	10509002	260139		0
73572	4374	4113008	1986-03-29	1986-03-29 00:00:00	1986-04-19	1986-04-19 00:00:00	32020		\N	290537	0	284549007	4113008		0
84346	5014	260139	1925-10-29	1925-10-29 00:00:00	1925-11-05	1925-11-05 00:00:00	32020		\N	333258	0	10509002	260139		0
84580	5031	40481087	1947-09-08	1947-09-08 00:00:00	1947-09-29	1947-09-29 00:00:00	32020		\N	334274	0	444814009	40481087		0
74200	4406	4116491	1978-01-08	1978-01-08 00:00:00	1978-02-15	1978-02-15 00:00:00	32020		\N	292864	0	301011002	4116491		0
84872	5048	81151	1999-06-24	1999-06-24 00:00:00	1999-07-08	1999-07-08 00:00:00	32020		\N	335504	0	44465007	81151		0
74424	4418	81151	1952-07-21	1952-07-21 00:00:00	1952-08-11	1952-08-11 00:00:00	32020		\N	293693	0	44465007	81151		0
74628	4433	4113008	2002-12-08	2002-12-08 00:00:00	2002-12-29	2002-12-29 00:00:00	32020		\N	294729	0	284549007	4113008		0
64199	3791	260139	2003-11-25	2003-11-25 00:00:00	2003-12-02	2003-12-02 00:00:00	32020		\N	252057	0	10509002	260139		0
64339	3799	260139	1985-03-19	1985-03-19 00:00:00	1985-04-02	1985-04-02 00:00:00	32020		\N	252573	0	10509002	260139		0
64475	3811	260139	1991-11-23	1991-11-23 00:00:00	1991-12-07	1991-12-07 00:00:00	32020		\N	253216	0	10509002	260139		0
75206	4467	260139	1980-07-26	1980-07-26 00:00:00	1980-08-09	1980-08-09 00:00:00	32020		\N	297242	0	10509002	260139		0
64741	3827	4112343	1987-04-17	1987-04-17 00:00:00	1987-04-26	1987-04-26 00:00:00	32020		\N	254175	0	195662009	4112343		0
64990	3843	28060	2000-03-08	2000-03-08 00:00:00	2000-03-18	2000-03-18 00:00:00	32020		\N	255068	0	43878008	28060		0
65117	3851	40481087	1995-07-24	1995-07-24 00:00:00	1995-07-31	1995-07-31 00:00:00	32020		\N	255497	0	444814009	40481087		0
65310	3862	40481087	2009-05-23	2009-05-23 00:00:00	2009-05-30	2009-05-30 00:00:00	32020		\N	256431	0	444814009	40481087		0
65508	3874	28060	2016-06-09	2016-06-09 00:00:00	2016-06-16	2016-06-16 00:00:00	32020		\N	257288	0	43878008	28060		0
76225	4523	40481087	1998-06-21	1998-06-21 00:00:00	1998-07-05	1998-07-05 00:00:00	32020		\N	301175	0	444814009	40481087		0
76396	4531	4112343	1936-02-20	1936-02-20 00:00:00	1936-03-01	1936-03-01 00:00:00	32020		\N	301726	0	195662009	4112343		0
65998	3901	40481087	2005-08-09	2005-08-09 00:00:00	2005-08-23	2005-08-23 00:00:00	32020		\N	259418	0	444814009	40481087		0
66186	3917	81151	1970-05-22	1970-05-22 00:00:00	1970-06-26	1970-06-26 00:00:00	32020		\N	260482	0	44465007	81151		0
66366	3929	81151	1991-05-23	1991-05-23 00:00:00	1991-06-06	1991-06-06 00:00:00	32020		\N	261149	0	44465007	81151		0
66465	3934	80180	1972-09-23	1972-09-23 00:00:00	\N	\N	32020		\N	261478	0	396275006	80180		0
77253	4576	40481087	1992-06-17	1992-06-17 00:00:00	1992-06-24	1992-06-24 00:00:00	32020		\N	304854	0	444814009	40481087		0
66881	3956	4296205	1958-11-22	1958-11-22 00:00:00	1958-12-27	1958-12-27 00:00:00	32020		\N	262906	0	403191005	4296205		0
67021	3962	4112343	1957-12-16	1957-12-16 00:00:00	1957-12-23	1957-12-23 00:00:00	32020		\N	263468	0	195662009	4112343		0
67195	3972	4278672	1967-10-26	1967-10-26 00:00:00	1967-12-25	1967-12-25 00:00:00	32020		\N	264134	0	65966004	4278672		0
78000	4622	4112343	1994-11-01	1994-11-01 00:00:00	1994-11-11	1994-11-11 00:00:00	32020		\N	307806	0	195662009	4112343		0
67535	3991	372328	1947-07-02	1947-07-02 00:00:00	1947-09-06	1947-09-06 00:00:00	32020		\N	265398	0	65363002	372328		0
67654	3997	40481087	1992-08-30	1992-08-30 00:00:00	1992-09-13	1992-09-13 00:00:00	32020		\N	265739	0	444814009	40481087		0
67803	4006	40481087	1990-08-05	1990-08-05 00:00:00	1990-08-12	1990-08-12 00:00:00	32020		\N	266140	0	444814009	40481087		0
68032	4019	80180	2005-04-30	2005-04-30 00:00:00	\N	\N	32020		\N	267186	0	396275006	80180		0
68151	4026	260139	1981-07-30	1981-07-30 00:00:00	1981-08-06	1981-08-06 00:00:00	32020		\N	267734	0	10509002	260139		0
78909	4674	4113008	1973-07-23	1973-07-23 00:00:00	1973-08-06	1973-08-06 00:00:00	32020		\N	311385	0	284549007	4113008		0
68525	4052	372328	1978-06-04	1978-06-04 00:00:00	1978-09-21	1978-09-21 00:00:00	32020		\N	269302	0	65363002	372328		0
79195	4689	40481087	2015-07-23	2015-07-23 00:00:00	2015-08-13	2015-08-13 00:00:00	32020		\N	312409	0	444814009	40481087		0
79366	4701	4116491	2001-11-19	2001-11-19 00:00:00	2001-12-27	2001-12-27 00:00:00	32020		\N	313127	0	301011002	4116491		0
68936	4080	4285898	2002-09-10	2002-09-10 00:00:00	\N	\N	32020		\N	271190	0	68496003	4285898		0
69146	4091	260139	1970-05-16	1970-05-16 00:00:00	1970-05-30	1970-05-30 00:00:00	32020		\N	271985	0	10509002	260139		0
79927	4736	40481087	2001-07-29	2001-07-29 00:00:00	2001-08-12	2001-08-12 00:00:00	32020		\N	315487	0	444814009	40481087		0
58923	3495	40481087	1983-03-03	1983-03-03 00:00:00	1983-03-17	1983-03-17 00:00:00	32020		\N	231828	0	444814009	40481087		0
69578	4117	81151	1997-05-14	1997-05-14 00:00:00	1997-06-18	1997-06-18 00:00:00	32020		\N	273680	0	44465007	81151		0
80357	4760	28060	1968-02-28	1968-02-28 00:00:00	1968-03-07	1968-03-07 00:00:00	32020		\N	317203	0	43878008	28060		0
80659	4782	30753	2016-01-16	2016-01-16 00:00:00	\N	\N	32020		\N	318347	0	16761005	30753		0
70096	4149	40481087	1968-05-19	1968-05-19 00:00:00	1968-06-09	1968-06-09 00:00:00	32020		\N	275750	0	444814009	40481087		0
70378	4168	40481087	1988-03-09	1988-03-09 00:00:00	1988-03-30	1988-03-30 00:00:00	32020		\N	277048	0	444814009	40481087		0
81121	4812	4112343	1965-01-24	1965-01-24 00:00:00	1965-02-02	1965-02-02 00:00:00	32020		\N	320107	0	195662009	4112343		0
81254	4819	28060	1962-10-18	1962-10-18 00:00:00	1962-10-25	1962-10-25 00:00:00	32020		\N	320510	0	43878008	28060		0
70854	4204	40481087	1978-07-07	1978-07-07 00:00:00	1978-07-14	1978-07-14 00:00:00	32020		\N	279075	0	444814009	40481087		0
70965	4210	260139	1991-04-13	1991-04-13 00:00:00	1991-04-27	1991-04-27 00:00:00	32020		\N	279520	0	10509002	260139		0
60583	3582	260139	1999-10-11	1999-10-11 00:00:00	1999-10-18	1999-10-18 00:00:00	32020		\N	238138	0	10509002	260139		0
71313	4229	260139	1996-03-10	1996-03-10 00:00:00	1996-03-17	1996-03-17 00:00:00	32020		\N	280947	0	10509002	260139		0
71447	4239	40479422	2019-04-12	2019-04-12 00:00:00	2019-05-19	2019-05-19 00:00:00	32020		\N	281553	0	444448004	40479422		0
82171	4872	4218389	2011-04-27	2011-04-27 00:00:00	2011-05-18	2011-05-18 00:00:00	32020		\N	324093	0	39848009	4218389		0
71801	4260	4112343	1981-07-01	1981-07-01 00:00:00	1981-07-13	1981-07-13 00:00:00	32020		\N	282805	0	195662009	4112343		0
71946	4269	4152936	1981-04-14	1981-04-14 00:00:00	1981-05-05	1981-05-05 00:00:00	32020		\N	283352	0	283385000	4152936		0
72084	4278	40481087	1988-03-09	1988-03-09 00:00:00	1988-03-30	1988-03-30 00:00:00	32020		\N	283896	0	444814009	40481087		0
72223	4284	4112343	2013-07-02	2013-07-02 00:00:00	2013-07-14	2013-07-14 00:00:00	32020		\N	284333	0	195662009	4112343		0
83034	4932	40481087	2012-09-21	2012-09-21 00:00:00	2012-10-12	2012-10-12 00:00:00	32020		\N	327884	0	444814009	40481087		0
83169	4942	260139	1989-12-16	1989-12-16 00:00:00	1989-12-23	1989-12-23 00:00:00	32020		\N	328504	0	10509002	260139		0
72818	4328	4218389	2007-08-18	2007-08-18 00:00:00	2007-09-22	2007-09-22 00:00:00	32020		\N	287017	0	39848009	4218389		0
83619	4970	4112343	1960-05-25	1960-05-25 00:00:00	1960-06-07	1960-06-07 00:00:00	32020		\N	330358	0	195662009	4112343		0
73184	4349	260139	2008-05-20	2008-05-20 00:00:00	2008-05-27	2008-05-27 00:00:00	32020		\N	288423	0	10509002	260139		0
73285	4355	4266809	2019-04-24	2019-04-24 00:00:00	\N	\N	32020		\N	\N	0	397881000	4266809		0
84040	4991	40481087	1995-04-20	1995-04-20 00:00:00	1995-04-27	1995-04-27 00:00:00	32020		\N	332073	0	444814009	40481087		0
73573	4374	260139	1976-08-20	1976-08-20 00:00:00	1976-09-03	1976-09-03 00:00:00	32020		\N	290573	0	10509002	260139		0
84347	5014	260139	1949-05-05	1949-05-05 00:00:00	1949-05-19	1949-05-19 00:00:00	32020		\N	333262	0	10509002	260139		0
84581	5031	260139	1943-08-05	1943-08-05 00:00:00	1943-08-19	1943-08-19 00:00:00	32020		\N	334326	0	10509002	260139		0
74201	4406	40481087	1978-04-23	1978-04-23 00:00:00	1978-05-14	1978-05-14 00:00:00	32020		\N	292896	0	444814009	40481087		0
84873	5048	4285898	1991-08-07	1991-08-07 00:00:00	\N	\N	32020		\N	335491	0	68496003	4285898		0
74425	4418	440086	1960-07-24	1960-07-24 00:00:00	1961-03-12	1961-03-12 00:00:00	32020		\N	293762	0	192127007	440086		0
74629	4433	40481087	1994-07-03	1994-07-03 00:00:00	1994-07-24	1994-07-24 00:00:00	32020		\N	294667	0	444814009	40481087		0
64200	3791	260139	1937-07-08	1937-07-08 00:00:00	1937-07-22	1937-07-22 00:00:00	32020		\N	252133	0	10509002	260139		0
64340	3799	257012	2003-12-06	2003-12-06 00:00:00	\N	\N	32020		\N	252574	0	40055000	257012		0
64476	3811	4112343	1969-12-31	1969-12-31 00:00:00	1970-01-07	1970-01-07 00:00:00	32020		\N	253120	0	195662009	4112343		0
75207	4467	4112343	2010-12-29	2010-12-29 00:00:00	2011-01-05	2011-01-05 00:00:00	32020		\N	297244	0	195662009	4112343		0
64756	3830	372328	1985-07-11	1985-07-11 00:00:00	1986-03-23	1986-03-23 00:00:00	32020		\N	254321	0	65363002	372328		0
64991	3843	260139	2004-05-08	2004-05-08 00:00:00	2004-05-15	2004-05-15 00:00:00	32020		\N	255074	0	10509002	260139		0
65118	3851	372328	1913-05-20	1913-05-20 00:00:00	1913-10-06	1913-10-06 00:00:00	32020		\N	255565	0	65363002	372328		0
65311	3862	4112343	1973-07-03	1973-07-03 00:00:00	1973-07-15	1973-07-15 00:00:00	32020		\N	256392	0	195662009	4112343		0
65509	3874	4112343	1985-03-08	1985-03-08 00:00:00	1985-03-18	1985-03-18 00:00:00	32020		\N	257237	0	195662009	4112343		0
76226	4523	4294548	1999-03-09	1999-03-09 00:00:00	1999-08-24	1999-08-24 00:00:00	32020		\N	301194	0	75498004	4294548		0
76397	4531	40481087	1983-02-03	1983-02-03 00:00:00	1983-02-17	1983-02-17 00:00:00	32020		\N	301752	0	444814009	40481087		0
65999	3901	81151	2013-10-04	2013-10-04 00:00:00	2013-10-25	2013-10-25 00:00:00	32020		\N	259390	0	44465007	81151		0
66187	3917	40481087	1978-09-26	1978-09-26 00:00:00	1978-10-03	1978-10-03 00:00:00	32020		\N	260444	0	444814009	40481087		0
66367	3929	260139	1968-02-13	1968-02-13 00:00:00	1968-02-27	1968-02-27 00:00:00	32020		\N	261186	0	10509002	260139		0
66466	3934	4112343	1972-09-22	1972-09-22 00:00:00	1972-10-05	1972-10-05 00:00:00	32020		\N	261478	0	195662009	4112343		0
77254	4576	4112343	1965-02-05	1965-02-05 00:00:00	1965-02-14	1965-02-14 00:00:00	32020		\N	304799	0	195662009	4112343		0
66882	3956	260139	1944-09-12	1944-09-12 00:00:00	1944-09-19	1944-09-19 00:00:00	32020		\N	262973	0	10509002	260139		0
67022	3962	260139	1963-10-13	1963-10-13 00:00:00	1963-10-20	1963-10-20 00:00:00	32020		\N	263476	0	10509002	260139		0
67196	3972	28060	1979-07-09	1979-07-09 00:00:00	1979-07-19	1979-07-19 00:00:00	32020		\N	264141	0	43878008	28060		0
78001	4622	40481087	1972-02-24	1972-02-24 00:00:00	1972-03-16	1972-03-16 00:00:00	32020		\N	307831	0	444814009	40481087		0
67536	3991	4112343	1955-06-12	1955-06-12 00:00:00	1955-06-19	1955-06-19 00:00:00	32020		\N	265338	0	195662009	4112343		0
67655	3997	4283893	2012-03-17	2012-03-17 00:00:00	2012-06-16	2012-06-16 00:00:00	32020		\N	265741	0	36971009	4283893		0
67826	4009	4112343	1999-01-26	1999-01-26 00:00:00	1999-02-07	1999-02-07 00:00:00	32020		\N	266382	0	195662009	4112343		0
68033	4019	40481087	1984-12-31	1984-12-31 00:00:00	1985-01-07	1985-01-07 00:00:00	32020		\N	267161	0	444814009	40481087		0
68152	4026	28060	1959-01-22	1959-01-22 00:00:00	1959-02-02	1959-02-02 00:00:00	32020		\N	267728	0	43878008	28060		0
78910	4674	260139	2001-05-31	2001-05-31 00:00:00	2001-06-14	2001-06-14 00:00:00	32020		\N	311381	0	10509002	260139		0
68526	4052	4310024	2012-10-03	2012-10-03 00:00:00	\N	\N	32020		\N	269404	0	424802006	4310024		0
79196	4689	40481087	1998-01-07	1998-01-07 00:00:00	1998-01-28	1998-01-28 00:00:00	32020		\N	312431	0	444814009	40481087		0
79367	4701	4283893	1989-06-15	1989-06-15 00:00:00	1989-12-21	1989-12-21 00:00:00	32020		\N	313160	0	36971009	4283893		0
68937	4080	4109685	2014-05-06	2014-05-06 00:00:00	2014-05-20	2014-05-20 00:00:00	32020		\N	271177	0	284551006	4109685		0
69147	4091	4266809	2009-05-29	2009-05-29 00:00:00	\N	\N	32020		\N	272002	0	397881000	4266809		0
79928	4736	4112343	1973-01-15	1973-01-15 00:00:00	1973-01-23	1973-01-23 00:00:00	32020		\N	315481	0	195662009	4112343		0
58924	3495	260139	1980-07-14	1980-07-14 00:00:00	1980-07-28	1980-07-28 00:00:00	32020		\N	231795	0	10509002	260139		0
69579	4117	4112343	1966-04-11	1966-04-11 00:00:00	1966-04-18	1966-04-18 00:00:00	32020		\N	273736	0	195662009	4112343		0
80358	4760	4237458	1969-05-18	1969-05-18 00:00:00	1969-07-17	1969-07-17 00:00:00	32020		\N	317197	0	58150001	4237458		0
80660	4782	4112343	2003-01-31	2003-01-31 00:00:00	2003-02-08	2003-02-08 00:00:00	32020		\N	318307	0	195662009	4112343		0
70097	4149	40481087	1967-09-25	1967-09-25 00:00:00	1967-10-16	1967-10-16 00:00:00	32020		\N	275762	0	444814009	40481087		0
70379	4168	40481087	2002-09-22	2002-09-22 00:00:00	2002-10-13	2002-10-13 00:00:00	32020		\N	277037	0	444814009	40481087		0
81122	4812	81151	1968-03-01	1968-03-01 00:00:00	1968-03-29	1968-03-29 00:00:00	32020		\N	320161	0	44465007	81151		0
81255	4819	40481087	1987-08-20	1987-08-20 00:00:00	1987-09-03	1987-09-03 00:00:00	32020		\N	320524	0	444814009	40481087		0
70855	4204	4112343	1995-10-06	1995-10-06 00:00:00	1995-10-19	1995-10-19 00:00:00	32020		\N	279072	0	195662009	4112343		0
70966	4210	40481087	2006-08-01	2006-08-01 00:00:00	2006-08-08	2006-08-08 00:00:00	32020		\N	279526	0	444814009	40481087		0
60584	3582	4059173	2011-12-03	2011-12-03 00:00:00	2012-02-01	2012-02-01 00:00:00	32020		\N	238125	0	16114001	4059173		0
71314	4229	40481087	1960-04-15	1960-04-15 00:00:00	1960-05-06	1960-05-06 00:00:00	32020		\N	280963	0	444814009	40481087		0
71448	4239	4112343	1958-02-24	1958-02-24 00:00:00	1958-03-03	1958-03-03 00:00:00	32020		\N	281465	0	195662009	4112343		0
82172	4872	40481087	1980-06-29	1980-06-29 00:00:00	1980-07-06	1980-07-06 00:00:00	32020		\N	324031	0	444814009	40481087		0
71802	4260	28060	1940-05-02	1940-05-02 00:00:00	1940-05-15	1940-05-15 00:00:00	32020		\N	282808	0	43878008	28060		0
71947	4269	372328	1970-06-28	1970-06-28 00:00:00	1970-10-07	1970-10-07 00:00:00	32020		\N	283327	0	65363002	372328		0
72085	4278	317576	1978-12-29	1978-12-29 00:00:00	\N	\N	32020		\N	283874	0	53741008	317576		0
72224	4284	4112343	1990-03-17	1990-03-17 00:00:00	1990-03-24	1990-03-24 00:00:00	32020		\N	284393	0	195662009	4112343		0
83035	4932	260139	1967-02-18	1967-02-18 00:00:00	1967-03-04	1967-03-04 00:00:00	32020		\N	327862	0	10509002	260139		0
83170	4942	4116491	2003-04-17	2003-04-17 00:00:00	2003-06-03	2003-06-03 00:00:00	32020		\N	328470	0	301011002	4116491		0
72819	4329	260139	1981-10-16	1981-10-16 00:00:00	1981-10-29	1981-10-29 00:00:00	32020		\N	287120	0	10509002	260139		0
83620	4970	4112343	1959-01-06	1959-01-06 00:00:00	1959-01-19	1959-01-19 00:00:00	32020		\N	330345	0	195662009	4112343		0
73185	4349	4134304	1984-11-21	1984-11-21 00:00:00	1985-02-19	1985-02-19 00:00:00	32020		\N	288399	0	263102004	4134304		0
73286	4355	260139	1994-03-13	1994-03-13 00:00:00	1994-03-20	1994-03-20 00:00:00	32020		\N	288988	0	10509002	260139		0
84041	4991	4112343	2001-12-13	2001-12-13 00:00:00	2001-12-23	2001-12-23 00:00:00	32020		\N	332074	0	195662009	4112343		0
73574	4374	192671	2013-04-13	2013-04-13 00:00:00	\N	\N	32020		\N	290531	0	K92.2	35208414		0
84348	5014	260139	1987-04-19	1987-04-19 00:00:00	1987-04-26	1987-04-26 00:00:00	32020		\N	333291	0	10509002	260139		0
84582	5031	4112343	1931-09-09	1931-09-09 00:00:00	1931-09-17	1931-09-17 00:00:00	32020		\N	334312	0	195662009	4112343		0
74202	4406	40481087	1950-09-17	1950-09-17 00:00:00	1950-10-08	1950-10-08 00:00:00	32020		\N	292873	0	444814009	40481087		0
84874	5048	40481087	2012-12-13	2012-12-13 00:00:00	2012-12-20	2012-12-20 00:00:00	32020		\N	335478	0	444814009	40481087		0
74426	4418	4218389	2003-02-20	2003-02-20 00:00:00	2003-03-20	2003-03-20 00:00:00	32020		\N	293747	0	39848009	4218389		0
74630	4433	4218389	1981-11-16	1981-11-16 00:00:00	1981-12-07	1981-12-07 00:00:00	32020		\N	294727	0	39848009	4218389		0
64201	3791	4112343	1944-09-24	1944-09-24 00:00:00	1944-10-03	1944-10-03 00:00:00	32020		\N	252134	0	195662009	4112343		0
64341	3799	28060	1984-03-09	1984-03-09 00:00:00	1984-03-18	1984-03-18 00:00:00	32020		\N	252563	0	43878008	28060		0
64477	3811	28060	2008-04-13	2008-04-13 00:00:00	2008-04-22	2008-04-22 00:00:00	32020		\N	253184	0	43878008	28060		0
75208	4467	40481087	2004-02-10	2004-02-10 00:00:00	2004-02-24	2004-02-24 00:00:00	32020		\N	297186	0	444814009	40481087		0
64757	3830	372328	2008-07-26	2008-07-26 00:00:00	2010-06-28	2010-06-28 00:00:00	32020		\N	254322	0	65363002	372328		0
64992	3843	192671	2008-06-27	2008-06-27 00:00:00	\N	\N	32020		\N	255094	0	K92.2	35208414		0
65119	3851	378419	1994-07-18	1994-07-18 00:00:00	\N	\N	32020		\N	255522	0	26929004	378419		0
65312	3862	260139	1977-05-12	1977-05-12 00:00:00	1977-05-19	1977-05-19 00:00:00	32020		\N	256438	0	10509002	260139		0
65510	3874	28060	1986-06-14	1986-06-14 00:00:00	1986-06-23	1986-06-23 00:00:00	32020		\N	257238	0	43878008	28060		0
76227	4523	4152936	2016-11-28	2016-11-28 00:00:00	2016-12-19	2016-12-19 00:00:00	32020		\N	301158	0	283385000	4152936		0
76398	4531	40481087	1963-11-11	1963-11-11 00:00:00	1963-11-18	1963-11-18 00:00:00	32020		\N	301746	0	444814009	40481087		0
66000	3901	40481087	2010-10-12	2010-10-12 00:00:00	2010-10-19	2010-10-19 00:00:00	32020		\N	259408	0	444814009	40481087		0
66188	3917	4112343	1971-04-20	1971-04-20 00:00:00	1971-05-01	1971-05-01 00:00:00	32020		\N	260498	0	195662009	4112343		0
66368	3929	372328	1952-12-01	1952-12-01 00:00:00	1953-01-12	1953-01-12 00:00:00	32020		\N	261158	0	65363002	372328		0
66467	3934	257012	1952-01-31	1952-01-31 00:00:00	1988-03-07	1988-03-07 00:00:00	32020		\N	261519	0	40055000	257012		0
77255	4577	372328	1988-04-04	1988-04-04 00:00:00	1988-06-18	1988-06-18 00:00:00	32020		\N	304909	0	65363002	372328		0
66883	3956	378001	1919-06-15	1919-06-15 00:00:00	1919-07-15	1919-07-15 00:00:00	32020		\N	262902	0	62106007	378001		0
67023	3962	28060	2003-11-13	2003-11-13 00:00:00	2003-11-22	2003-11-22 00:00:00	32020		\N	263441	0	43878008	28060		0
67197	3972	4112343	1964-07-30	1964-07-30 00:00:00	1964-08-12	1964-08-12 00:00:00	32020		\N	264158	0	195662009	4112343		0
78002	4622	192671	1997-08-31	1997-08-31 00:00:00	\N	\N	32020		\N	307859	0	K92.2	35208414		0
67537	3991	40481087	2005-06-28	2005-06-28 00:00:00	2005-07-05	2005-07-05 00:00:00	32020		\N	265304	0	444814009	40481087		0
67656	3997	4152936	1967-09-17	1967-09-17 00:00:00	1967-10-08	1967-10-08 00:00:00	32020		\N	265699	0	283385000	4152936		0
67827	4009	40481087	1975-09-23	1975-09-23 00:00:00	1975-10-14	1975-10-14 00:00:00	32020		\N	266426	0	444814009	40481087		0
68034	4019	40481087	1997-03-24	1997-03-24 00:00:00	1997-03-31	1997-03-31 00:00:00	32020		\N	267126	0	444814009	40481087		0
68153	4026	258780	2012-02-05	2012-02-05 00:00:00	\N	\N	32020		\N	267676	0	185086009	258780		0
78911	4674	40481087	2014-09-20	2014-09-20 00:00:00	2014-10-04	2014-10-04 00:00:00	32020		\N	311418	0	444814009	40481087		0
68527	4052	4109685	1986-12-19	1986-12-19 00:00:00	1987-01-02	1987-01-02 00:00:00	32020		\N	269342	0	284551006	4109685		0
79197	4689	260139	1993-12-29	1993-12-29 00:00:00	1994-01-12	1994-01-12 00:00:00	32020		\N	312404	0	10509002	260139		0
79368	4701	260139	1991-02-01	1991-02-01 00:00:00	1991-02-15	1991-02-15 00:00:00	32020		\N	313138	0	10509002	260139		0
68938	4080	4027663	1992-05-25	1992-05-25 00:00:00	\N	\N	32020		\N	271206	0	13200003	4027663		0
69148	4091	80180	2009-05-29	2009-05-29 00:00:00	\N	\N	32020		\N	272002	0	396275006	80180		0
79929	4736	4237458	2009-01-25	2009-01-25 00:00:00	2009-03-26	2009-03-26 00:00:00	32020		\N	315515	0	58150001	4237458		0
58925	3495	40481087	1996-02-21	1996-02-21 00:00:00	1996-03-06	1996-03-06 00:00:00	32020		\N	231829	0	444814009	40481087		0
69580	4117	40481087	1989-09-25	1989-09-25 00:00:00	1989-10-16	1989-10-16 00:00:00	32020		\N	273694	0	444814009	40481087		0
80359	4760	4112343	1993-08-19	1993-08-19 00:00:00	1993-08-26	1993-08-26 00:00:00	32020		\N	317172	0	195662009	4112343		0
80661	4782	260139	1995-06-12	1995-06-12 00:00:00	1995-06-26	1995-06-26 00:00:00	32020		\N	318316	0	10509002	260139		0
70098	4149	4283893	1991-08-16	1991-08-16 00:00:00	1991-12-27	1991-12-27 00:00:00	32020		\N	275763	0	36971009	4283893		0
70380	4168	40481087	1993-09-05	1993-09-05 00:00:00	1993-09-19	1993-09-19 00:00:00	32020		\N	277025	0	444814009	40481087		0
81123	4812	4112343	2007-09-25	2007-09-25 00:00:00	2007-10-05	2007-10-05 00:00:00	32020		\N	320139	0	195662009	4112343		0
81256	4819	40481087	1969-12-17	1969-12-17 00:00:00	1969-12-24	1969-12-24 00:00:00	32020		\N	320583	0	444814009	40481087		0
70856	4204	4112343	1999-05-02	1999-05-02 00:00:00	1999-05-13	1999-05-13 00:00:00	32020		\N	279121	0	195662009	4112343		0
70967	4210	4112343	2002-06-16	2002-06-16 00:00:00	2002-06-29	2002-06-29 00:00:00	32020		\N	279574	0	195662009	4112343		0
60585	3582	40481087	2007-08-20	2007-08-20 00:00:00	2007-09-10	2007-09-10 00:00:00	32020		\N	238142	0	444814009	40481087		0
71315	4229	260139	1963-08-10	1963-08-10 00:00:00	1963-08-24	1963-08-24 00:00:00	32020		\N	280961	0	10509002	260139		0
71449	4239	40481087	2014-10-11	2014-10-11 00:00:00	2014-11-01	2014-11-01 00:00:00	32020		\N	281557	0	444814009	40481087		0
82173	4872	260139	1944-05-29	1944-05-29 00:00:00	1944-06-12	1944-06-12 00:00:00	32020		\N	323976	0	10509002	260139		0
71803	4260	28060	1999-06-04	1999-06-04 00:00:00	1999-06-11	1999-06-11 00:00:00	32020		\N	282788	0	43878008	28060		0
71948	4269	4035415	2006-07-07	2006-07-07 00:00:00	2006-09-05	2006-09-05 00:00:00	32020		\N	283354	0	239720000	4035415		0
72086	4278	4109685	1995-06-08	1995-06-08 00:00:00	1995-06-22	1995-06-22 00:00:00	32020		\N	283934	0	284551006	4109685		0
72225	4284	40481087	1993-03-24	1993-03-24 00:00:00	1993-04-14	1993-04-14 00:00:00	32020		\N	284365	0	444814009	40481087		0
83036	4932	260139	2016-09-09	2016-09-09 00:00:00	2016-09-16	2016-09-16 00:00:00	32020		\N	327842	0	10509002	260139		0
83171	4942	40481087	1961-05-11	1961-05-11 00:00:00	1961-05-18	1961-05-18 00:00:00	32020		\N	328501	0	444814009	40481087		0
72820	4329	195588	2008-03-26	2008-03-26 00:00:00	2008-05-24	2008-05-24 00:00:00	32020		\N	287123	0	38822007	195588		0
83621	4970	4112343	1962-03-02	1962-03-02 00:00:00	1962-03-14	1962-03-14 00:00:00	32020		\N	330359	0	195662009	4112343		0
73186	4349	4001336	1990-01-15	1990-01-15 00:00:00	1990-02-14	1990-02-14 00:00:00	32020		\N	288401	0	110030002	4001336		0
73287	4355	40481087	2018-12-27	2018-12-27 00:00:00	2019-01-17	2019-01-17 00:00:00	32020		\N	288946	0	444814009	40481087		0
84042	4991	40481087	1972-11-09	1972-11-09 00:00:00	1972-11-16	1972-11-16 00:00:00	32020		\N	332056	0	444814009	40481087		0
73575	4374	40481087	2012-09-06	2012-09-06 00:00:00	2012-09-13	2012-09-13 00:00:00	32020		\N	290510	0	444814009	40481087		0
84349	5014	4112343	1981-08-17	1981-08-17 00:00:00	1981-08-25	1981-08-25 00:00:00	32020		\N	333267	0	195662009	4112343		0
84583	5031	4112343	1959-08-03	1959-08-03 00:00:00	1959-08-10	1959-08-10 00:00:00	32020		\N	334328	0	195662009	4112343		0
84661	5035	28060	1976-04-21	1976-04-21 00:00:00	1976-05-01	1976-05-01 00:00:00	32020		\N	334639	0	43878008	28060		0
84875	5048	40481087	2012-05-04	2012-05-04 00:00:00	2012-05-11	2012-05-11 00:00:00	32020		\N	335432	0	444814009	40481087		0
74427	4418	4112343	2012-03-25	2012-03-25 00:00:00	2012-04-05	2012-04-05 00:00:00	32020		\N	293753	0	195662009	4112343		0
74631	4433	40481087	2008-04-16	2008-04-16 00:00:00	2008-04-30	2008-04-30 00:00:00	32020		\N	294723	0	444814009	40481087		0
64202	3791	372328	1915-08-24	1915-08-24 00:00:00	1915-11-06	1915-11-06 00:00:00	32020		\N	252111	0	65363002	372328		0
64342	3799	375671	2011-06-24	2011-06-24 00:00:00	2011-07-24	2011-07-24 00:00:00	32020		\N	252530	0	62564004	375671		0
64478	3811	81151	1985-10-05	1985-10-05 00:00:00	1985-11-09	1985-11-09 00:00:00	32020		\N	253142	0	44465007	81151		0
75209	4467	81151	1973-02-19	1973-02-19 00:00:00	1973-03-26	1973-03-26 00:00:00	32020		\N	297163	0	44465007	81151		0
64758	3830	372328	1982-07-13	1982-07-13 00:00:00	1982-10-25	1982-10-25 00:00:00	32020		\N	254283	0	65363002	372328		0
64993	3843	4112343	1995-05-24	1995-05-24 00:00:00	1995-06-01	1995-06-01 00:00:00	32020		\N	255063	0	195662009	4112343		0
65120	3852	40481087	1985-04-25	1985-04-25 00:00:00	1985-05-02	1985-05-02 00:00:00	32020		\N	255616	0	444814009	40481087		0
65313	3862	4294548	1968-12-10	1968-12-10 00:00:00	1969-08-19	1969-08-19 00:00:00	32020		\N	256434	0	75498004	4294548		0
65511	3874	30753	2013-08-12	2013-08-12 00:00:00	\N	\N	32020		\N	257283	0	16761005	30753		0
76228	4523	40481087	2010-07-24	2010-07-24 00:00:00	2010-07-31	2010-07-31 00:00:00	32020		\N	301185	0	444814009	40481087		0
76399	4531	260139	1967-12-11	1967-12-11 00:00:00	1967-12-25	1967-12-25 00:00:00	32020		\N	301747	0	10509002	260139		0
66001	3901	4112343	1947-06-28	1947-06-28 00:00:00	1947-07-06	1947-07-06 00:00:00	32020		\N	259402	0	195662009	4112343		0
66189	3917	257012	1983-09-14	1983-09-14 00:00:00	\N	\N	32020		\N	260471	0	40055000	257012		0
66369	3929	40481087	1966-04-17	1966-04-17 00:00:00	1966-05-08	1966-05-08 00:00:00	32020		\N	261198	0	444814009	40481087		0
66468	3934	40481087	1972-04-12	1972-04-12 00:00:00	1972-04-19	1972-04-19 00:00:00	32020		\N	261418	0	444814009	40481087		0
77256	4577	4112343	1986-07-25	1986-07-25 00:00:00	1986-08-03	1986-08-03 00:00:00	32020		\N	304885	0	195662009	4112343		0
66884	3956	4113008	1983-05-20	1983-05-20 00:00:00	1983-06-03	1983-06-03 00:00:00	32020		\N	262907	0	284549007	4113008		0
67024	3962	260139	1969-02-22	1969-02-22 00:00:00	1969-03-08	1969-03-08 00:00:00	32020		\N	263447	0	10509002	260139		0
67198	3972	4112343	1974-05-25	1974-05-25 00:00:00	1974-06-02	1974-06-02 00:00:00	32020		\N	264162	0	195662009	4112343		0
78003	4622	260139	1986-09-14	1986-09-14 00:00:00	1986-09-28	1986-09-28 00:00:00	32020		\N	307816	0	10509002	260139		0
67538	3991	378001	2000-12-14	2000-12-14 00:00:00	2001-01-13	2001-01-13 00:00:00	32020		\N	265376	0	62106007	378001		0
67657	3997	4112343	2001-01-13	2001-01-13 00:00:00	2001-01-25	2001-01-25 00:00:00	32020		\N	265771	0	195662009	4112343		0
67828	4009	40481087	1955-04-23	1955-04-23 00:00:00	1955-05-15	1955-05-15 00:00:00	32020		\N	266424	0	444814009	40481087		0
68035	4019	4027663	1996-11-18	1996-11-18 00:00:00	\N	\N	32020		\N	267123	0	13200003	4027663		0
68154	4026	81151	1992-04-18	1992-04-18 00:00:00	1992-05-09	1992-05-09 00:00:00	32020		\N	267633	0	44465007	81151		0
78912	4674	40481087	2010-08-16	2010-08-16 00:00:00	2010-08-23	2010-08-23 00:00:00	32020		\N	311382	0	444814009	40481087		0
68528	4052	4285898	2014-10-23	2014-10-23 00:00:00	\N	\N	32020		\N	269405	0	68496003	4285898		0
79198	4689	40481087	1986-03-22	1986-03-22 00:00:00	1986-04-12	1986-04-12 00:00:00	32020		\N	312442	0	444814009	40481087		0
79369	4701	4112343	2010-03-24	2010-03-24 00:00:00	2010-03-31	2010-03-31 00:00:00	32020		\N	313164	0	195662009	4112343		0
68939	4080	40481087	1988-09-03	1988-09-03 00:00:00	1988-09-10	1988-09-10 00:00:00	32020		\N	271156	0	444814009	40481087		0
69149	4091	81151	1978-04-02	1978-04-02 00:00:00	1978-04-16	1978-04-16 00:00:00	32020		\N	271941	0	44465007	81151		0
79930	4736	40481087	2019-06-14	2019-06-14 00:00:00	\N	\N	32020		\N	315479	0	444814009	40481087		0
58926	3495	4152936	1981-05-14	1981-05-14 00:00:00	1981-05-28	1981-05-28 00:00:00	32020		\N	231813	0	283385000	4152936		0
69592	4119	40481087	1969-11-18	1969-11-18 00:00:00	1969-11-25	1969-11-25 00:00:00	32020		\N	273866	0	444814009	40481087		0
80360	4760	4112343	1998-04-06	1998-04-06 00:00:00	1998-04-13	1998-04-13 00:00:00	32020		\N	317177	0	195662009	4112343		0
80662	4782	28060	2006-03-11	2006-03-11 00:00:00	2006-03-19	2006-03-19 00:00:00	32020		\N	318367	0	43878008	28060		0
70099	4149	372328	1966-03-27	1966-03-27 00:00:00	1966-06-03	1966-06-03 00:00:00	32020		\N	275747	0	65363002	372328		0
70381	4168	378001	1992-08-10	1992-08-10 00:00:00	1992-10-09	1992-10-09 00:00:00	32020		\N	277012	0	62106007	378001		0
81124	4812	4134304	1972-03-08	1972-03-08 00:00:00	1972-06-06	1972-06-06 00:00:00	32020		\N	320162	0	263102004	4134304		0
81257	4819	40481087	1983-02-12	1983-02-12 00:00:00	1983-02-19	1983-02-19 00:00:00	32020		\N	320577	0	444814009	40481087		0
70857	4204	4218389	1994-05-16	1994-05-16 00:00:00	1994-06-20	1994-06-20 00:00:00	32020		\N	279066	0	39848009	4218389		0
70968	4210	4112343	1978-10-17	1978-10-17 00:00:00	1978-10-30	1978-10-30 00:00:00	32020		\N	279519	0	195662009	4112343		0
60586	3582	261325	1993-08-15	1993-08-15 00:00:00	\N	\N	32020		\N	238103	0	87433001	261325		0
71316	4229	40481087	1988-02-13	1988-02-13 00:00:00	1988-02-20	1988-02-20 00:00:00	32020		\N	280957	0	444814009	40481087		0
71450	4239	4283893	1952-02-13	1952-02-13 00:00:00	1952-03-19	1952-03-19 00:00:00	32020		\N	281535	0	36971009	4283893		0
82174	4872	28060	1946-11-05	1946-11-05 00:00:00	1946-11-13	1946-11-13 00:00:00	32020		\N	323977	0	43878008	28060		0
71804	4260	80180	1979-11-11	1979-11-11 00:00:00	\N	\N	32020		\N	282777	0	396275006	80180		0
71949	4269	80180	2007-06-11	2007-06-11 00:00:00	\N	\N	32020		\N	283354	0	396275006	80180		0
72087	4278	134438	1973-10-21	1973-10-21 00:00:00	1975-11-10	1975-11-10 00:00:00	32020		\N	283895	0	40275004	134438		0
72226	4284	4112343	1994-10-03	1994-10-03 00:00:00	1994-10-16	1994-10-16 00:00:00	32020		\N	284329	0	195662009	4112343		0
83037	4932	40481087	2005-04-24	2005-04-24 00:00:00	2005-05-08	2005-05-08 00:00:00	32020		\N	327857	0	444814009	40481087		0
83172	4942	4109685	1972-11-04	1972-11-04 00:00:00	1972-11-25	1972-11-25 00:00:00	32020		\N	328463	0	284551006	4109685		0
72821	4329	372328	1978-11-28	1978-11-28 00:00:00	1979-03-11	1979-03-11 00:00:00	32020		\N	287127	0	65363002	372328		0
83622	4970	40481087	1953-05-26	1953-05-26 00:00:00	1953-06-09	1953-06-09 00:00:00	32020		\N	330493	0	444814009	40481087		0
83665	4971	378001	1945-03-24	1945-03-24 00:00:00	1945-04-23	1945-04-23 00:00:00	32020		\N	330510	0	62106007	378001		0
73288	4355	372328	1983-12-16	1983-12-16 00:00:00	1984-03-24	1984-03-24 00:00:00	32020		\N	288969	0	65363002	372328		0
84043	4991	260139	1976-04-16	1976-04-16 00:00:00	1976-04-23	1976-04-23 00:00:00	32020		\N	332071	0	10509002	260139		0
73576	4374	80180	2013-01-31	2013-01-31 00:00:00	\N	\N	32020		\N	290510	0	396275006	80180		0
84350	5014	40481087	1960-11-10	1960-11-10 00:00:00	1960-11-24	1960-11-24 00:00:00	32020		\N	333287	0	444814009	40481087		0
84584	5031	4134304	1990-08-17	1990-08-17 00:00:00	1990-10-16	1990-10-16 00:00:00	32020		\N	334281	0	263102004	4134304		0
84662	5035	40481087	1976-06-28	1976-06-28 00:00:00	1976-07-05	1976-07-05 00:00:00	32020		\N	334640	0	444814009	40481087		0
84876	5048	260139	2002-05-15	2002-05-15 00:00:00	2002-05-22	2002-05-22 00:00:00	32020		\N	335442	0	10509002	260139		0
74428	4418	378001	1990-10-12	1990-10-12 00:00:00	1990-11-11	1990-11-11 00:00:00	32020		\N	293745	0	62106007	378001		0
74632	4433	4112343	1993-07-10	1993-07-10 00:00:00	1993-07-18	1993-07-18 00:00:00	32020		\N	294646	0	195662009	4112343		0
64203	3791	40481087	1931-11-04	1931-11-04 00:00:00	1931-11-11	1931-11-11 00:00:00	32020		\N	252052	0	444814009	40481087		0
64343	3799	28060	1983-09-01	1983-09-01 00:00:00	1983-09-08	1983-09-08 00:00:00	32020		\N	252572	0	43878008	28060		0
64479	3811	40481087	1966-11-15	1966-11-15 00:00:00	1966-11-22	1966-11-22 00:00:00	32020		\N	253167	0	444814009	40481087		0
75210	4467	40481087	1973-02-13	1973-02-13 00:00:00	1973-02-27	1973-02-27 00:00:00	32020		\N	297177	0	444814009	40481087		0
64759	3830	40481087	1986-12-25	1986-12-25 00:00:00	1987-01-01	1987-01-01 00:00:00	32020		\N	254298	0	444814009	40481087		0
64994	3843	40481087	1976-06-05	1976-06-05 00:00:00	1976-06-26	1976-06-26 00:00:00	32020		\N	255061	0	444814009	40481087		0
65121	3852	28060	1993-04-17	1993-04-17 00:00:00	1993-04-30	1993-04-30 00:00:00	32020		\N	255753	0	43878008	28060		0
65314	3862	4283893	1996-09-02	1996-09-02 00:00:00	1996-09-30	1996-09-30 00:00:00	32020		\N	256430	0	36971009	4283893		0
65512	3874	4266809	2014-10-06	2014-10-06 00:00:00	\N	\N	32020		\N	257283	0	397881000	4266809		0
76229	4523	260139	2004-08-06	2004-08-06 00:00:00	2004-08-20	2004-08-20 00:00:00	32020		\N	301184	0	10509002	260139		0
76400	4531	40481087	1915-02-02	1915-02-02 00:00:00	1915-02-16	1915-02-16 00:00:00	32020		\N	301743	0	444814009	40481087		0
66002	3901	4112343	1939-12-29	1939-12-29 00:00:00	1940-01-06	1940-01-06 00:00:00	32020		\N	259341	0	195662009	4112343		0
66190	3917	372328	1972-10-10	1972-10-10 00:00:00	1973-08-23	1973-08-23 00:00:00	32020		\N	260473	0	65363002	372328		0
66370	3929	40481087	1990-12-30	1990-12-30 00:00:00	1991-01-20	1991-01-20 00:00:00	32020		\N	261170	0	444814009	40481087		0
66469	3934	28060	1976-11-15	1976-11-15 00:00:00	1976-11-26	1976-11-26 00:00:00	32020		\N	261490	0	43878008	28060		0
77257	4577	4112343	2015-03-30	2015-03-30 00:00:00	2015-04-11	2015-04-11 00:00:00	32020		\N	304907	0	195662009	4112343		0
66885	3956	260139	1975-11-07	1975-11-07 00:00:00	1975-11-14	1975-11-14 00:00:00	32020		\N	262997	0	10509002	260139		0
67025	3962	4112343	1969-08-03	1969-08-03 00:00:00	1969-08-13	1969-08-13 00:00:00	32020		\N	263438	0	195662009	4112343		0
67199	3972	40481087	1973-05-12	1973-05-12 00:00:00	1973-05-26	1973-05-26 00:00:00	32020		\N	264095	0	444814009	40481087		0
78004	4622	40481087	1983-03-08	1983-03-08 00:00:00	1983-03-22	1983-03-22 00:00:00	32020		\N	307834	0	444814009	40481087		0
67539	3991	372328	1945-12-28	1945-12-28 00:00:00	1946-03-09	1946-03-09 00:00:00	32020		\N	265364	0	65363002	372328		0
67658	3997	260139	2017-07-22	2017-07-22 00:00:00	2017-07-29	2017-07-29 00:00:00	32020		\N	265772	0	10509002	260139		0
67829	4009	40481087	1961-10-10	1961-10-10 00:00:00	1961-10-30	1961-10-30 00:00:00	32020		\N	266425	0	444814009	40481087		0
68036	4019	4109685	1979-12-28	1979-12-28 00:00:00	1980-01-11	1980-01-11 00:00:00	32020		\N	267169	0	284551006	4109685		0
68155	4026	40481087	2008-01-19	2008-01-19 00:00:00	2008-02-02	2008-02-02 00:00:00	32020		\N	267715	0	444814009	40481087		0
78913	4674	40481087	1987-11-16	1987-11-16 00:00:00	1987-12-07	1987-12-07 00:00:00	32020		\N	311379	0	444814009	40481087		0
68529	4052	4266809	2015-09-18	2015-09-18 00:00:00	\N	\N	32020		\N	269405	0	397881000	4266809		0
79199	4689	381316	1993-03-02	1993-03-02 00:00:00	\N	\N	32020		\N	312415	0	230690007	381316		0
79370	4701	4001336	1987-05-16	1987-05-16 00:00:00	1987-07-15	1987-07-15 00:00:00	32020		\N	313170	0	110030002	4001336		0
68940	4080	4134304	1998-01-30	1998-01-30 00:00:00	1998-03-01	1998-03-01 00:00:00	32020		\N	271175	0	263102004	4134304		0
69150	4091	4152936	2015-03-31	2015-03-31 00:00:00	2015-04-21	2015-04-21 00:00:00	32020		\N	271944	0	283385000	4152936		0
79931	4736	4112343	2016-10-22	2016-10-22 00:00:00	2016-11-01	2016-11-01 00:00:00	32020		\N	315486	0	195662009	4112343		0
58927	3495	40481087	1988-04-24	1988-04-24 00:00:00	1988-05-08	1988-05-08 00:00:00	32020		\N	231806	0	444814009	40481087		0
69593	4119	40481087	1955-09-27	1955-09-27 00:00:00	1955-10-04	1955-10-04 00:00:00	32020		\N	273879	0	444814009	40481087		0
80361	4760	260139	1986-07-21	1986-07-21 00:00:00	1986-07-28	1986-07-28 00:00:00	32020		\N	317123	0	10509002	260139		0
80663	4782	28060	2018-03-17	2018-03-17 00:00:00	2018-03-24	2018-03-24 00:00:00	32020		\N	318324	0	43878008	28060		0
70100	4149	4112343	1988-02-13	1988-02-13 00:00:00	1988-02-24	1988-02-24 00:00:00	32020		\N	275706	0	195662009	4112343		0
70382	4168	372328	1973-12-18	1973-12-18 00:00:00	1974-03-09	1974-03-09 00:00:00	32020		\N	277040	0	65363002	372328		0
81125	4812	40481087	1997-08-04	1997-08-04 00:00:00	1997-08-18	1997-08-18 00:00:00	32020		\N	320126	0	444814009	40481087		0
81258	4819	40481087	1965-07-27	1965-07-27 00:00:00	1965-08-17	1965-08-17 00:00:00	32020		\N	320520	0	444814009	40481087		0
70858	4204	192671	1988-12-26	1988-12-26 00:00:00	\N	\N	32020		\N	279143	0	K92.2	35208414		0
70969	4210	4112343	2012-02-10	2012-02-10 00:00:00	2012-02-22	2012-02-22 00:00:00	32020		\N	279524	0	195662009	4112343		0
60587	3582	4283893	1958-02-21	1958-02-21 00:00:00	1958-03-28	1958-03-28 00:00:00	32020		\N	238166	0	36971009	4283893		0
71317	4229	40481087	2018-10-05	2018-10-05 00:00:00	2018-10-19	2018-10-19 00:00:00	32020		\N	280904	0	444814009	40481087		0
71451	4239	260139	1957-01-22	1957-01-22 00:00:00	1957-02-05	1957-02-05 00:00:00	32020		\N	281464	0	10509002	260139		0
82175	4872	81151	1999-07-10	1999-07-10 00:00:00	1999-07-24	1999-07-24 00:00:00	32020		\N	324091	0	44465007	81151		0
71805	4260	260139	1968-12-19	1968-12-19 00:00:00	1968-12-26	1968-12-26 00:00:00	32020		\N	282755	0	10509002	260139		0
71950	4269	378001	1971-02-15	1971-02-15 00:00:00	1971-03-17	1971-03-17 00:00:00	32020		\N	283373	0	62106007	378001		0
72088	4278	260139	1989-12-25	1989-12-25 00:00:00	1990-01-08	1990-01-08 00:00:00	32020		\N	283938	0	10509002	260139		0
72255	4288	80180	1994-09-17	1994-09-17 00:00:00	\N	\N	32020		\N	284732	0	396275006	80180		0
83038	4932	81151	1997-11-14	1997-11-14 00:00:00	1997-11-28	1997-11-28 00:00:00	32020		\N	327807	0	44465007	81151		0
83173	4942	81893	1985-05-16	1985-05-16 00:00:00	\N	\N	32020		\N	328496	0	64766004	81893		0
72822	4329	4112343	2001-12-06	2001-12-06 00:00:00	2001-12-18	2001-12-18 00:00:00	32020		\N	287122	0	195662009	4112343		0
83623	4970	40481087	1995-12-09	1995-12-09 00:00:00	1995-12-16	1995-12-16 00:00:00	32020		\N	330457	0	444814009	40481087		0
83666	4971	4112343	1982-07-22	1982-07-22 00:00:00	1982-08-03	1982-08-03 00:00:00	32020		\N	330588	0	195662009	4112343		0
73289	4355	4310024	2016-11-05	2016-11-05 00:00:00	\N	\N	32020		\N	288978	0	424802006	4310024		0
84044	4991	4152936	1994-08-04	1994-08-04 00:00:00	1994-08-25	1994-08-25 00:00:00	32020		\N	332055	0	283385000	4152936		0
73577	4374	134438	2002-05-21	2002-05-21 00:00:00	2003-02-15	2003-02-15 00:00:00	32020		\N	290567	0	40275004	134438		0
84351	5014	4294548	1935-02-18	1935-02-18 00:00:00	1935-06-03	1935-06-03 00:00:00	32020		\N	333260	0	75498004	4294548		0
84585	5031	4112343	1944-11-08	1944-11-08 00:00:00	1944-11-17	1944-11-17 00:00:00	32020		\N	334361	0	195662009	4112343		0
84663	5035	4283893	1934-06-20	1934-06-20 00:00:00	1934-07-04	1934-07-04 00:00:00	32020		\N	334605	0	36971009	4283893		0
84877	5048	81893	1990-12-10	1990-12-10 00:00:00	\N	\N	32020		\N	335468	0	64766004	81893		0
74429	4418	260139	2018-11-29	2018-11-29 00:00:00	2018-12-13	2018-12-13 00:00:00	32020		\N	293765	0	10509002	260139		0
74633	4433	4112343	1967-05-20	1967-05-20 00:00:00	1967-05-27	1967-05-27 00:00:00	32020		\N	294666	0	195662009	4112343		0
64204	3791	40481087	1936-12-20	1936-12-20 00:00:00	1937-01-03	1937-01-03 00:00:00	32020		\N	252054	0	444814009	40481087		0
64344	3799	4112343	1999-10-29	1999-10-29 00:00:00	1999-11-06	1999-11-06 00:00:00	32020		\N	252533	0	195662009	4112343		0
64480	3811	4112343	1965-08-30	1965-08-30 00:00:00	1965-09-07	1965-09-07 00:00:00	32020		\N	253219	0	195662009	4112343		0
75211	4467	260139	1991-05-03	1991-05-03 00:00:00	1991-05-17	1991-05-17 00:00:00	32020		\N	297185	0	10509002	260139		0
64760	3830	4296204	2005-08-11	2005-08-11 00:00:00	2005-09-15	2005-09-15 00:00:00	32020		\N	254326	0	403190006	4296204		0
64995	3844	4112343	1966-06-01	1966-06-01 00:00:00	1966-06-11	1966-06-11 00:00:00	32020		\N	255152	0	195662009	4112343		0
65122	3852	40481087	2005-07-15	2005-07-15 00:00:00	2005-08-05	2005-08-05 00:00:00	32020		\N	255682	0	444814009	40481087		0
65315	3862	40481087	1968-08-19	1968-08-19 00:00:00	1968-09-02	1968-09-02 00:00:00	32020		\N	256378	0	444814009	40481087		0
65513	3874	80180	2014-10-06	2014-10-06 00:00:00	\N	\N	32020		\N	257283	0	396275006	80180		0
76230	4523	4112343	2012-03-28	2012-03-28 00:00:00	2012-04-08	2012-04-08 00:00:00	32020		\N	301195	0	195662009	4112343		0
76401	4531	81151	1948-05-28	1948-05-28 00:00:00	1948-06-11	1948-06-11 00:00:00	32020		\N	301705	0	44465007	81151		0
66003	3901	78272	1943-01-25	1943-01-25 00:00:00	1943-02-15	1943-02-15 00:00:00	32020		\N	259384	0	70704007	78272		0
66191	3917	372328	1974-12-16	1974-12-16 00:00:00	1975-09-04	1975-09-04 00:00:00	32020		\N	260474	0	65363002	372328		0
66371	3929	4155034	2004-10-09	2004-10-09 00:00:00	2004-10-23	2004-10-23 00:00:00	32020		\N	261151	0	283371005	4155034		0
66470	3934	4237458	1945-08-02	1945-08-02 00:00:00	1945-10-31	1945-10-31 00:00:00	32020		\N	261499	0	58150001	4237458		0
77258	4577	260139	2017-05-03	2017-05-03 00:00:00	2017-05-10	2017-05-10 00:00:00	32020		\N	304908	0	10509002	260139		0
66886	3956	40481087	1917-09-02	1917-09-02 00:00:00	1917-09-23	1917-09-23 00:00:00	32020		\N	262938	0	444814009	40481087		0
67026	3962	4113008	2015-09-03	2015-09-03 00:00:00	2015-09-24	2015-09-24 00:00:00	32020		\N	263467	0	284549007	4113008		0
67200	3972	40481087	1962-04-02	1962-04-02 00:00:00	1962-04-16	1962-04-16 00:00:00	32020		\N	264094	0	444814009	40481087		0
78005	4622	4112343	2018-12-04	2018-12-04 00:00:00	2018-12-14	2018-12-14 00:00:00	32020		\N	307783	0	195662009	4112343		0
67540	3991	4278672	1958-01-29	1958-01-29 00:00:00	1958-03-30	1958-03-30 00:00:00	32020		\N	265375	0	65966004	4278672		0
67659	3997	81151	2005-05-03	2005-05-03 00:00:00	2005-06-07	2005-06-07 00:00:00	32020		\N	265704	0	44465007	81151		0
67830	4009	40481087	2006-11-28	2006-11-28 00:00:00	2006-12-05	2006-12-05 00:00:00	32020		\N	266383	0	444814009	40481087		0
68037	4019	260139	1974-01-29	1974-01-29 00:00:00	1974-02-12	1974-02-12 00:00:00	32020		\N	267136	0	10509002	260139		0
68156	4026	372328	1961-04-01	1961-04-01 00:00:00	1961-07-02	1961-07-02 00:00:00	32020		\N	267629	0	65363002	372328		0
78914	4674	4152936	1987-02-08	1987-02-08 00:00:00	1987-03-01	1987-03-01 00:00:00	32020		\N	311388	0	283385000	4152936		0
68530	4052	80180	2015-09-18	2015-09-18 00:00:00	\N	\N	32020		\N	269405	0	396275006	80180		0
79200	4689	40481087	1991-09-19	1991-09-19 00:00:00	1991-10-03	1991-10-03 00:00:00	32020		\N	312415	0	444814009	40481087		0
79371	4701	4132546	1987-05-16	1987-05-16 00:00:00	\N	\N	32020		\N	313170	0	275272006	4166590		0
68941	4080	260139	1985-01-19	1985-01-19 00:00:00	1985-02-02	1985-02-02 00:00:00	32020		\N	271178	0	10509002	260139		0
69151	4091	260139	1990-11-09	1990-11-09 00:00:00	1990-11-23	1990-11-23 00:00:00	32020		\N	271948	0	10509002	260139		0
79932	4736	260139	1974-11-05	1974-11-05 00:00:00	1974-11-19	1974-11-19 00:00:00	32020		\N	315474	0	10509002	260139		0
58928	3495	28060	1968-06-02	1968-06-02 00:00:00	1968-06-14	1968-06-14 00:00:00	32020		\N	231794	0	43878008	28060		0
69594	4119	40481087	1971-04-25	1971-04-25 00:00:00	1971-05-16	1971-05-16 00:00:00	32020		\N	273845	0	444814009	40481087		0
80362	4760	4149245	1956-10-16	1956-10-16 00:00:00	1956-11-22	1956-11-22 00:00:00	32020		\N	317194	0	30832001	4149245		0
80664	4782	40481087	1984-05-15	1984-05-15 00:00:00	1984-05-22	1984-05-22 00:00:00	32020		\N	318364	0	444814009	40481087		0
70101	4149	192671	2002-10-13	2002-10-13 00:00:00	\N	\N	32020		\N	275749	0	K92.2	35208414		0
70383	4168	40481087	1977-09-10	1977-09-10 00:00:00	1977-09-17	1977-09-17 00:00:00	32020		\N	277036	0	444814009	40481087		0
81126	4812	4112343	1963-05-10	1963-05-10 00:00:00	1963-05-22	1963-05-22 00:00:00	32020		\N	320184	0	195662009	4112343		0
81259	4819	4112343	1989-05-06	1989-05-06 00:00:00	1989-05-19	1989-05-19 00:00:00	32020		\N	320514	0	195662009	4112343		0
70859	4204	372328	1952-12-01	1952-12-01 00:00:00	1953-01-26	1953-01-26 00:00:00	32020		\N	279133	0	65363002	372328		0
70970	4210	372328	1986-01-07	1986-01-07 00:00:00	1986-02-15	1986-02-15 00:00:00	32020		\N	279542	0	65363002	372328		0
60588	3582	78272	2000-03-07	2000-03-07 00:00:00	2000-04-04	2000-04-04 00:00:00	32020		\N	238123	0	70704007	78272		0
71318	4229	40481087	1984-06-06	1984-06-06 00:00:00	1984-06-27	1984-06-27 00:00:00	32020		\N	280901	0	444814009	40481087		0
71452	4239	260139	1971-11-20	1971-11-20 00:00:00	1971-12-04	1971-12-04 00:00:00	32020		\N	281566	0	10509002	260139		0
82176	4872	4112343	1997-01-24	1997-01-24 00:00:00	1997-02-05	1997-02-05 00:00:00	32020		\N	323995	0	195662009	4112343		0
71806	4260	4296205	1945-11-19	1945-11-19 00:00:00	1945-12-10	1945-12-10 00:00:00	32020		\N	282843	0	403191005	4296205		0
71951	4269	4112343	2005-03-29	2005-03-29 00:00:00	2005-04-08	2005-04-08 00:00:00	32020		\N	283358	0	195662009	4112343		0
72089	4278	4283893	2000-03-05	2000-03-05 00:00:00	2000-11-12	2000-11-12 00:00:00	32020		\N	283909	0	36971009	4283893		0
72256	4288	4112343	2010-10-16	2010-10-16 00:00:00	2010-10-27	2010-10-27 00:00:00	32020		\N	284653	0	195662009	4112343		0
83039	4932	4112343	1983-09-01	1983-09-01 00:00:00	1983-09-10	1983-09-10 00:00:00	32020		\N	327867	0	195662009	4112343		0
83174	4942	4310024	1984-12-17	1984-12-17 00:00:00	\N	\N	32020		\N	328496	0	424802006	4310024		0
72823	4329	4112343	1981-12-16	1981-12-16 00:00:00	1981-12-26	1981-12-26 00:00:00	32020		\N	287145	0	195662009	4112343		0
83624	4970	4112343	1952-03-02	1952-03-02 00:00:00	1952-03-12	1952-03-12 00:00:00	32020		\N	330492	0	195662009	4112343		0
83667	4971	40481087	1947-04-02	1947-04-02 00:00:00	1947-04-23	1947-04-23 00:00:00	32020		\N	330622	0	444814009	40481087		0
73290	4355	4296204	2010-10-13	2010-10-13 00:00:00	2010-10-27	2010-10-27 00:00:00	32020		\N	288962	0	403190006	4296204		0
84045	4991	40481087	1981-08-06	1981-08-06 00:00:00	1981-08-20	1981-08-20 00:00:00	32020		\N	332020	0	444814009	40481087		0
73578	4374	260139	1980-09-15	1980-09-15 00:00:00	1980-09-22	1980-09-22 00:00:00	32020		\N	290458	0	10509002	260139		0
84352	5014	4296205	1936-01-11	1936-01-11 00:00:00	1936-02-01	1936-02-01 00:00:00	32020		\N	333251	0	403191005	4296205		0
84586	5031	4294548	1994-09-10	1994-09-10 00:00:00	1994-12-10	1994-12-10 00:00:00	32020		\N	334397	0	75498004	4294548		0
84664	5035	4112343	1938-07-23	1938-07-23 00:00:00	1938-08-02	1938-08-02 00:00:00	32020		\N	334588	0	195662009	4112343		0
84878	5048	4218389	1966-08-13	1966-08-13 00:00:00	1966-09-10	1966-09-10 00:00:00	32020		\N	335501	0	39848009	4218389		0
74430	4418	4112343	2000-06-05	2000-06-05 00:00:00	2000-06-13	2000-06-13 00:00:00	32020		\N	293782	0	195662009	4112343		0
74634	4433	40481087	1997-05-17	1997-05-17 00:00:00	1997-06-07	1997-06-07 00:00:00	32020		\N	294722	0	444814009	40481087		0
64205	3791	4059173	1982-10-13	1982-10-13 00:00:00	1983-01-11	1983-01-11 00:00:00	32020		\N	252161	0	16114001	4059173		0
64345	3799	4283893	2003-10-04	2003-10-04 00:00:00	2003-12-20	2003-12-20 00:00:00	32020		\N	252542	0	36971009	4283893		0
64481	3811	255848	2016-12-23	2016-12-23 00:00:00	\N	\N	32020		\N	253239	0	233604007	255848		0
75212	4467	4094814	1979-10-21	1979-10-21 00:00:00	1979-12-20	1979-12-20 00:00:00	32020		\N	297164	0	262574004	4094814		0
64761	3830	40481087	2000-07-28	2000-07-28 00:00:00	2000-08-18	2000-08-18 00:00:00	32020		\N	254291	0	444814009	40481087		0
64996	3844	440086	1964-08-26	1964-08-26 00:00:00	1970-09-04	1970-09-04 00:00:00	32020		\N	255156	0	192127007	440086		0
65123	3852	40481087	2005-04-19	2005-04-19 00:00:00	2005-05-10	2005-05-10 00:00:00	32020		\N	255710	0	444814009	40481087		0
65316	3862	4113008	2013-11-19	2013-11-19 00:00:00	2013-12-03	2013-12-03 00:00:00	32020		\N	256461	0	284549007	4113008		0
65514	3874	4285898	2014-05-09	2014-05-09 00:00:00	\N	\N	32020		\N	257283	0	68496003	4285898		0
76231	4523	378001	1981-11-24	1981-11-24 00:00:00	1981-12-24	1981-12-24 00:00:00	32020		\N	301152	0	62106007	378001		0
76402	4531	4283893	1927-02-20	1927-02-20 00:00:00	1927-03-06	1927-03-06 00:00:00	32020		\N	301737	0	36971009	4283893		0
66004	3901	4112343	1941-11-13	1941-11-13 00:00:00	1941-11-25	1941-11-25 00:00:00	32020		\N	259435	0	195662009	4112343		0
66192	3917	313217	2014-02-27	2014-02-27 00:00:00	\N	\N	32020		\N	260496	0	49436004	313217		0
66372	3929	4112343	1977-07-23	1977-07-23 00:00:00	1977-08-01	1977-08-01 00:00:00	32020		\N	261188	0	195662009	4112343		0
66471	3934	40481087	1946-10-11	1946-10-11 00:00:00	1946-11-01	1946-11-01 00:00:00	32020		\N	261416	0	444814009	40481087		0
77259	4577	260139	1992-03-24	1992-03-24 00:00:00	1992-04-07	1992-04-07 00:00:00	32020		\N	304905	0	10509002	260139		0
66887	3956	40481087	1973-12-28	1973-12-28 00:00:00	1974-01-11	1974-01-11 00:00:00	32020		\N	262941	0	444814009	40481087		0
67027	3962	81151	1953-07-06	1953-07-06 00:00:00	1953-07-20	1953-07-20 00:00:00	32020		\N	263462	0	44465007	81151		0
67201	3972	378001	1974-01-02	1974-01-02 00:00:00	1974-02-01	1974-02-01 00:00:00	32020		\N	264117	0	62106007	378001		0
78006	4622	40481087	1978-12-17	1978-12-17 00:00:00	1978-12-24	1978-12-24 00:00:00	32020		\N	307815	0	444814009	40481087		0
67541	3991	4283893	2004-12-30	2004-12-30 00:00:00	2005-01-20	2005-01-20 00:00:00	32020		\N	265303	0	36971009	4283893		0
67660	3997	4152936	1997-01-17	1997-01-17 00:00:00	1997-01-31	1997-01-31 00:00:00	32020		\N	265702	0	283385000	4152936		0
67831	4009	81151	1955-08-18	1955-08-18 00:00:00	1955-09-08	1955-09-08 00:00:00	32020		\N	266432	0	44465007	81151		0
68038	4019	40481087	1991-12-09	1991-12-09 00:00:00	1991-12-16	1991-12-16 00:00:00	32020		\N	267139	0	444814009	40481087		0
68157	4026	4051466	1960-02-02	1960-02-02 00:00:00	1977-05-14	1977-05-14 00:00:00	32020		\N	267729	0	233678006	4051466		0
78915	4675	4155034	1917-01-01	1917-01-01 00:00:00	1917-01-15	1917-01-15 00:00:00	32020		\N	311502	0	283371005	4155034		0
68531	4052	81893	2013-08-29	2013-08-29 00:00:00	\N	\N	32020		\N	269405	0	64766004	81893		0
79201	4689	4035415	2017-02-09	2017-02-09 00:00:00	2017-04-11	2017-04-11 00:00:00	32020		\N	312396	0	239720000	4035415		0
79372	4701	260139	2008-11-02	2008-11-02 00:00:00	2008-11-16	2008-11-16 00:00:00	32020		\N	313163	0	10509002	260139		0
68942	4080	40481087	1981-02-14	1981-02-14 00:00:00	1981-03-07	1981-03-07 00:00:00	32020		\N	271168	0	444814009	40481087		0
69152	4091	321042	2017-09-10	2017-09-10 00:00:00	\N	\N	32020		\N	271945	0	410429000	321042		0
79933	4736	40481087	1974-10-10	1974-10-10 00:00:00	1974-10-31	1974-10-31 00:00:00	32020		\N	315482	0	444814009	40481087		0
58929	3495	372328	1966-04-12	1966-04-12 00:00:00	1966-05-25	1966-05-25 00:00:00	32020		\N	231797	0	65363002	372328		0
69595	4119	4294548	1997-06-20	1997-06-20 00:00:00	1997-11-07	1997-11-07 00:00:00	32020		\N	273868	0	75498004	4294548		0
80363	4760	40481087	1955-08-29	1955-08-29 00:00:00	1955-09-12	1955-09-12 00:00:00	32020		\N	317201	0	444814009	40481087		0
80674	4784	40481087	2010-11-20	2010-11-20 00:00:00	2010-12-04	2010-12-04 00:00:00	32020		\N	318485	0	444814009	40481087		0
70102	4149	80180	2002-08-05	2002-08-05 00:00:00	\N	\N	32020		\N	275727	0	396275006	80180		0
70384	4168	260139	1973-12-20	1973-12-20 00:00:00	1974-01-03	1974-01-03 00:00:00	32020		\N	277042	0	10509002	260139		0
81127	4812	4283893	1966-03-22	1966-03-22 00:00:00	1966-04-12	1966-04-12 00:00:00	32020		\N	320124	0	36971009	4283893		0
81260	4819	80180	2003-03-30	2003-03-30 00:00:00	\N	\N	32020		\N	320573	0	396275006	80180		0
70860	4204	4112343	1967-12-19	1967-12-19 00:00:00	1967-12-26	1967-12-26 00:00:00	32020		\N	279074	0	195662009	4112343		0
70971	4210	4112343	1999-05-17	1999-05-17 00:00:00	1999-05-29	1999-05-29 00:00:00	32020		\N	279521	0	195662009	4112343		0
60589	3582	4278672	1989-09-01	1989-09-01 00:00:00	1989-10-01	1989-10-01 00:00:00	32020		\N	238122	0	65966004	4278672		0
71319	4229	40481087	1999-05-04	1999-05-04 00:00:00	1999-05-18	1999-05-18 00:00:00	32020		\N	280948	0	444814009	40481087		0
71453	4239	80180	1990-06-07	1990-06-07 00:00:00	\N	\N	32020		\N	281534	0	396275006	80180		0
82177	4872	28060	1990-08-17	1990-08-17 00:00:00	1990-08-27	1990-08-27 00:00:00	32020		\N	323993	0	43878008	28060		0
71807	4260	40481087	1984-09-26	1984-09-26 00:00:00	1984-10-10	1984-10-10 00:00:00	32020		\N	282807	0	444814009	40481087		0
71952	4270	260139	1980-12-06	1980-12-06 00:00:00	1980-12-13	1980-12-13 00:00:00	32020		\N	283448	0	10509002	260139		0
72090	4278	80180	1993-07-26	1993-07-26 00:00:00	\N	\N	32020		\N	283926	0	396275006	80180		0
72257	4288	260139	1974-06-28	1974-06-28 00:00:00	1974-07-05	1974-07-05 00:00:00	32020		\N	284675	0	10509002	260139		0
83040	4932	40481087	2008-09-19	2008-09-19 00:00:00	2008-10-03	2008-10-03 00:00:00	32020		\N	327828	0	444814009	40481087		0
83175	4942	317576	1982-10-14	1982-10-14 00:00:00	\N	\N	32020		\N	328496	0	53741008	317576		0
72824	4329	40481087	1990-10-17	1990-10-17 00:00:00	1990-10-24	1990-10-24 00:00:00	32020		\N	287119	0	444814009	40481087		0
83625	4970	40481087	1932-03-08	1932-03-08 00:00:00	1932-03-22	1932-03-22 00:00:00	32020		\N	330474	0	444814009	40481087		0
83668	4971	4237458	1940-04-19	1940-04-19 00:00:00	1940-05-19	1940-05-19 00:00:00	32020		\N	330662	0	58150001	4237458		0
73291	4355	4109685	2013-05-14	2013-05-14 00:00:00	2013-05-28	2013-05-28 00:00:00	32020		\N	288963	0	284551006	4109685		0
84046	4991	40481087	2002-05-17	2002-05-17 00:00:00	2002-05-31	2002-05-31 00:00:00	32020		\N	332058	0	444814009	40481087		0
73579	4374	4112343	2001-10-05	2001-10-05 00:00:00	2001-10-15	2001-10-15 00:00:00	32020		\N	290566	0	195662009	4112343		0
84353	5014	4112343	1956-12-15	1956-12-15 00:00:00	1956-12-22	1956-12-22 00:00:00	32020		\N	333286	0	195662009	4112343		0
84587	5031	372328	1922-01-08	1922-01-08 00:00:00	1922-07-15	1922-07-15 00:00:00	32020		\N	334356	0	65363002	372328		0
84665	5035	40481087	1952-07-29	1952-07-29 00:00:00	1952-08-05	1952-08-05 00:00:00	32020		\N	334545	0	444814009	40481087		0
84879	5048	195588	1982-11-20	1982-11-20 00:00:00	1983-01-13	1983-01-13 00:00:00	32020		\N	335462	0	38822007	195588		0
74431	4418	40481087	2008-11-20	2008-11-20 00:00:00	2008-12-04	2008-12-04 00:00:00	32020		\N	293721	0	444814009	40481087		0
74635	4433	40481087	2019-06-24	2019-06-24 00:00:00	\N	\N	32020		\N	294660	0	444814009	40481087		0
64206	3791	4134304	2012-04-08	2012-04-08 00:00:00	2012-06-07	2012-06-07 00:00:00	32020		\N	252162	0	263102004	4134304		0
64346	3799	4155034	1982-08-11	1982-08-11 00:00:00	1982-08-25	1982-08-25 00:00:00	32020		\N	252528	0	283371005	4155034		0
64482	3811	260139	1929-06-13	1929-06-13 00:00:00	1929-06-27	1929-06-27 00:00:00	32020		\N	253211	0	10509002	260139		0
75213	4467	4112343	1989-10-08	1989-10-08 00:00:00	1989-10-18	1989-10-18 00:00:00	32020		\N	297179	0	195662009	4112343		0
64762	3830	28060	1983-03-13	1983-03-13 00:00:00	1983-03-21	1983-03-21 00:00:00	32020		\N	254280	0	43878008	28060		0
64997	3844	40481087	1967-05-02	1967-05-02 00:00:00	1967-05-16	1967-05-16 00:00:00	32020		\N	255131	0	444814009	40481087		0
65124	3852	260139	1997-01-02	1997-01-02 00:00:00	1997-01-16	1997-01-16 00:00:00	32020		\N	255756	0	10509002	260139		0
65317	3862	40481087	1967-12-04	1967-12-04 00:00:00	1967-12-18	1967-12-18 00:00:00	32020		\N	256423	0	444814009	40481087		0
65515	3874	40481087	1988-09-26	1988-09-26 00:00:00	1988-10-10	1988-10-10 00:00:00	32020		\N	257308	0	444814009	40481087		0
76232	4523	4112343	1977-10-19	1977-10-19 00:00:00	1977-10-30	1977-10-30 00:00:00	32020		\N	301174	0	195662009	4112343		0
76403	4531	40481087	1956-06-29	1956-06-29 00:00:00	1956-07-13	1956-07-13 00:00:00	32020		\N	301816	0	444814009	40481087		0
66005	3901	4146173	1982-01-01	1982-01-01 00:00:00	1982-01-31	1982-01-31 00:00:00	32020		\N	259417	0	307731004	4146173		0
66193	3917	4218389	1980-12-30	1980-12-30 00:00:00	1981-01-27	1981-01-27 00:00:00	32020		\N	260483	0	39848009	4218389		0
66373	3929	4283893	2001-09-03	2001-09-03 00:00:00	2002-02-11	2002-02-11 00:00:00	32020		\N	261191	0	36971009	4283893		0
66472	3935	40481087	1986-06-06	1986-06-06 00:00:00	1986-06-20	1986-06-20 00:00:00	32020		\N	261562	0	444814009	40481087		0
77260	4577	28060	1996-05-15	1996-05-15 00:00:00	1996-05-27	1996-05-27 00:00:00	32020		\N	304859	0	43878008	28060		0
66889	3956	4237458	2013-02-25	2013-02-25 00:00:00	2013-04-26	2013-04-26 00:00:00	32020		\N	262908	0	58150001	4237458		0
67028	3962	40481087	2018-09-25	2018-09-25 00:00:00	2018-10-16	2018-10-16 00:00:00	32020		\N	263392	0	444814009	40481087		0
67202	3972	260139	2014-01-09	2014-01-09 00:00:00	2014-01-16	2014-01-16 00:00:00	32020		\N	264164	0	10509002	260139		0
78007	4622	260139	2010-11-23	2010-11-23 00:00:00	2010-12-07	2010-12-07 00:00:00	32020		\N	307817	0	10509002	260139		0
67542	3991	78272	1948-07-15	1948-07-15 00:00:00	1948-08-19	1948-08-19 00:00:00	32020		\N	265374	0	70704007	78272		0
67661	3997	260139	1983-08-26	1983-08-26 00:00:00	1983-09-02	1983-09-02 00:00:00	32020		\N	265738	0	10509002	260139		0
67832	4009	195588	1996-07-28	1996-07-28 00:00:00	1996-08-30	1996-08-30 00:00:00	32020		\N	266381	0	38822007	195588		0
68039	4019	4112343	1993-12-16	1993-12-16 00:00:00	1993-12-28	1993-12-28 00:00:00	32020		\N	267151	0	195662009	4112343		0
68158	4026	4237458	1973-04-07	1973-04-07 00:00:00	1973-06-06	1973-06-06 00:00:00	32020		\N	267697	0	58150001	4237458		0
78916	4675	40481087	2007-08-29	2007-08-29 00:00:00	2007-09-12	2007-09-12 00:00:00	32020		\N	311442	0	444814009	40481087		0
68532	4052	4294548	2013-06-24	2013-06-24 00:00:00	2013-07-29	2013-07-29 00:00:00	32020		\N	269346	0	75498004	4294548		0
79202	4689	40481087	1989-07-05	1989-07-05 00:00:00	1989-07-26	1989-07-26 00:00:00	32020		\N	312430	0	444814009	40481087		0
79373	4701	260139	1978-12-26	1978-12-26 00:00:00	1979-01-09	1979-01-09 00:00:00	32020		\N	313176	0	10509002	260139		0
68943	4080	260139	1993-09-05	1993-09-05 00:00:00	1993-09-19	1993-09-19 00:00:00	32020		\N	271157	0	10509002	260139		0
69154	4091	28060	1980-03-04	1980-03-04 00:00:00	1980-03-11	1980-03-11 00:00:00	32020		\N	271987	0	43878008	28060		0
79934	4736	4152936	1981-04-01	1981-04-01 00:00:00	1981-04-15	1981-04-15 00:00:00	32020		\N	315513	0	283385000	4152936		0
58930	3495	4296204	2014-08-22	2014-08-22 00:00:00	2014-09-26	2014-09-26 00:00:00	32020		\N	231816	0	403190006	4296204		0
69596	4119	4112343	2000-01-18	2000-01-18 00:00:00	2000-01-25	2000-01-25 00:00:00	32020		\N	273846	0	195662009	4112343		0
80364	4760	4112343	2014-09-03	2014-09-03 00:00:00	2014-09-16	2014-09-16 00:00:00	32020		\N	317125	0	195662009	4112343		0
80675	4784	4156265	2009-11-22	2009-11-22 00:00:00	2009-12-13	2009-12-13 00:00:00	32020		\N	318452	0	370247008	4156265		0
70134	4153	192671	2001-10-30	2001-10-30 00:00:00	\N	\N	32020		\N	276037	0	K92.2	35208414		0
80843	4795	372328	1969-12-12	1969-12-12 00:00:00	1970-10-14	1970-10-14 00:00:00	32020		\N	319024	0	65363002	372328		0
81128	4812	4112343	2006-06-17	2006-06-17 00:00:00	2006-06-29	2006-06-29 00:00:00	32020		\N	320129	0	195662009	4112343		0
81261	4819	40481087	1999-01-29	1999-01-29 00:00:00	1999-02-12	1999-02-12 00:00:00	32020		\N	320516	0	444814009	40481087		0
70861	4204	28060	2010-12-15	2010-12-15 00:00:00	2010-12-24	2010-12-24 00:00:00	32020		\N	279083	0	43878008	28060		0
70972	4210	4027663	2005-03-28	2005-03-28 00:00:00	\N	\N	32020		\N	279541	0	13200003	4027663		0
60590	3582	40481087	1960-11-20	1960-11-20 00:00:00	1960-12-04	1960-12-04 00:00:00	32020		\N	238136	0	444814009	40481087		0
71320	4229	40481087	1996-05-05	1996-05-05 00:00:00	1996-05-12	1996-05-12 00:00:00	32020		\N	280958	0	444814009	40481087		0
71454	4239	378419	2019-01-19	2019-01-19 00:00:00	\N	\N	32020		\N	281490	0	26929004	378419		0
82178	4872	4152936	2018-11-07	2018-11-07 00:00:00	2018-11-21	2018-11-21 00:00:00	32020		\N	324094	0	283385000	4152936		0
71808	4260	4310024	1977-07-24	1977-07-24 00:00:00	\N	\N	32020		\N	282809	0	424802006	4310024		0
71953	4270	372328	1970-07-30	1970-07-30 00:00:00	1970-12-22	1970-12-22 00:00:00	32020		\N	283440	0	65363002	372328		0
72091	4278	4294548	2006-04-30	2006-04-30 00:00:00	2006-06-04	2006-06-04 00:00:00	32020		\N	283891	0	75498004	4294548		0
72258	4288	40481087	2014-12-16	2014-12-16 00:00:00	2014-12-30	2014-12-30 00:00:00	32020		\N	284688	0	444814009	40481087		0
83041	4932	134438	1976-11-16	1976-11-16 00:00:00	1977-11-17	1977-11-17 00:00:00	32020		\N	327809	0	40275004	134438		0
83176	4942	313217	2004-04-29	2004-04-29 00:00:00	\N	\N	32020		\N	328521	0	49436004	313217		0
72825	4329	4112343	1997-07-20	1997-07-20 00:00:00	1997-07-28	1997-07-28 00:00:00	32020		\N	287147	0	195662009	4112343		0
83626	4970	260139	1964-06-21	1964-06-21 00:00:00	1964-06-28	1964-06-28 00:00:00	32020		\N	330382	0	10509002	260139		0
83669	4971	40481087	1938-03-25	1938-03-25 00:00:00	1938-04-01	1938-04-01 00:00:00	32020		\N	330507	0	444814009	40481087		0
73292	4355	40481087	1991-03-04	1991-03-04 00:00:00	1991-03-18	1991-03-18 00:00:00	32020		\N	288987	0	444814009	40481087		0
84047	4991	134438	1997-07-10	1997-07-10 00:00:00	1998-04-09	1998-04-09 00:00:00	32020		\N	332031	0	40275004	134438		0
73580	4374	4112343	1995-05-01	1995-05-01 00:00:00	1995-05-09	1995-05-09 00:00:00	32020		\N	290565	0	195662009	4112343		0
84354	5014	257012	1935-04-08	1935-04-08 00:00:00	1935-06-03	1935-06-03 00:00:00	32020		\N	333249	0	40055000	257012		0
84588	5031	4296204	2017-01-02	2017-01-02 00:00:00	2017-01-30	2017-01-30 00:00:00	32020		\N	334284	0	403190006	4296204		0
84666	5035	378419	2009-08-03	2009-08-03 00:00:00	\N	\N	32020		\N	334645	0	26929004	378419		0
84880	5048	4027663	1983-10-18	1983-10-18 00:00:00	\N	\N	32020		\N	335462	0	13200003	4027663		0
74432	4418	372328	1955-01-07	1955-01-07 00:00:00	1955-07-01	1955-07-01 00:00:00	32020		\N	293706	0	65363002	372328		0
74636	4433	372328	1943-07-25	1943-07-25 00:00:00	1944-02-26	1944-02-26 00:00:00	32020		\N	294648	0	65363002	372328		0
64207	3791	40481087	1997-07-20	1997-07-20 00:00:00	1997-08-03	1997-08-03 00:00:00	32020		\N	252049	0	444814009	40481087		0
64347	3799	40481087	1984-07-27	1984-07-27 00:00:00	1984-08-10	1984-08-10 00:00:00	32020		\N	252540	0	444814009	40481087		0
64483	3811	40481087	1953-12-29	1953-12-29 00:00:00	1954-01-19	1954-01-19 00:00:00	32020		\N	253166	0	444814009	40481087		0
75214	4467	40481087	1955-12-15	1955-12-15 00:00:00	1956-01-05	1956-01-05 00:00:00	32020		\N	297202	0	444814009	40481087		0
64763	3830	80180	2016-10-22	2016-10-22 00:00:00	\N	\N	32020		\N	254320	0	396275006	80180		0
64998	3844	40481087	1981-06-09	1981-06-09 00:00:00	1981-06-16	1981-06-16 00:00:00	32020		\N	255157	0	444814009	40481087		0
65125	3852	4152936	1995-01-20	1995-01-20 00:00:00	1995-02-03	1995-02-03 00:00:00	32020		\N	255632	0	283385000	4152936		0
65318	3862	4112343	1998-04-20	1998-04-20 00:00:00	1998-04-29	1998-04-29 00:00:00	32020		\N	256394	0	195662009	4112343		0
65516	3874	4112343	1998-05-25	1998-05-25 00:00:00	1998-06-04	1998-06-04 00:00:00	32020		\N	257270	0	195662009	4112343		0
76233	4523	4112343	1978-07-01	1978-07-01 00:00:00	1978-07-08	1978-07-08 00:00:00	32020		\N	301181	0	195662009	4112343		0
76404	4531	4112343	1973-06-14	1973-06-14 00:00:00	1973-06-27	1973-06-27 00:00:00	32020		\N	301741	0	195662009	4112343		0
66022	3904	40481087	2012-06-21	2012-06-21 00:00:00	2012-06-28	2012-06-28 00:00:00	32020		\N	259639	0	444814009	40481087		0
66218	3920	80180	2011-01-09	2011-01-09 00:00:00	\N	\N	32020		\N	260666	0	396275006	80180		0
66374	3929	195588	1977-04-29	1977-04-29 00:00:00	1977-05-30	1977-05-30 00:00:00	32020		\N	261169	0	38822007	195588		0
66473	3935	4294548	1958-03-16	1958-03-16 00:00:00	1958-03-30	1958-03-30 00:00:00	32020		\N	261575	0	75498004	4294548		0
77261	4577	40481087	2007-07-17	2007-07-17 00:00:00	2007-08-07	2007-08-07 00:00:00	32020		\N	304879	0	444814009	40481087		0
66890	3956	4112343	1987-08-25	1987-08-25 00:00:00	1987-09-02	1987-09-02 00:00:00	32020		\N	262998	0	195662009	4112343		0
67029	3962	378001	2006-12-05	2006-12-05 00:00:00	2007-01-04	2007-01-04 00:00:00	32020		\N	263465	0	62106007	378001		0
67203	3972	78272	1972-12-03	1972-12-03 00:00:00	1973-01-07	1973-01-07 00:00:00	32020		\N	264136	0	70704007	78272		0
78008	4622	28060	1961-09-28	1961-09-28 00:00:00	1961-10-09	1961-10-09 00:00:00	32020		\N	307830	0	43878008	28060		0
67543	3991	4283893	1954-07-19	1954-07-19 00:00:00	1954-10-25	1954-10-25 00:00:00	32020		\N	265336	0	36971009	4283893		0
67662	3997	4112343	2018-03-28	2018-03-28 00:00:00	2018-04-05	2018-04-05 00:00:00	32020		\N	265734	0	195662009	4112343		0
67833	4009	40481087	1961-03-22	1961-03-22 00:00:00	1961-04-05	1961-04-05 00:00:00	32020		\N	266442	0	444814009	40481087		0
68040	4019	28060	1968-01-04	1968-01-04 00:00:00	1968-01-11	1968-01-11 00:00:00	32020		\N	267168	0	43878008	28060		0
68159	4026	4294548	2019-03-14	2019-03-14 00:00:00	2019-06-20	2019-06-20 00:00:00	32020		\N	267602	0	75498004	4294548		0
78917	4675	4134304	1949-04-16	1949-04-16 00:00:00	1949-05-16	1949-05-16 00:00:00	32020		\N	311505	0	263102004	4134304		0
68533	4052	81151	1999-06-28	1999-06-28 00:00:00	1999-07-12	1999-07-12 00:00:00	32020		\N	269416	0	44465007	81151		0
79203	4689	4112343	1981-08-23	1981-08-23 00:00:00	1981-09-02	1981-09-02 00:00:00	32020		\N	312414	0	195662009	4112343		0
79374	4701	4112343	1976-08-28	1976-08-28 00:00:00	1976-09-04	1976-09-04 00:00:00	32020		\N	313125	0	195662009	4112343		0
68944	4080	80180	2002-10-10	2002-10-10 00:00:00	\N	\N	32020		\N	271191	0	396275006	80180		0
69155	4091	78272	1982-02-24	1982-02-24 00:00:00	1982-03-10	1982-03-10 00:00:00	32020		\N	271942	0	70704007	78272		0
79935	4736	80180	2013-08-21	2013-08-21 00:00:00	\N	\N	32020		\N	315496	0	396275006	80180		0
69389	4106	4112343	1986-10-03	1986-10-03 00:00:00	1986-10-15	1986-10-15 00:00:00	32020		\N	272836	0	195662009	4112343		0
69597	4119	40481087	2003-01-15	2003-01-15 00:00:00	2003-02-05	2003-02-05 00:00:00	32020		\N	273848	0	444814009	40481087		0
80365	4760	4059173	1964-07-13	1964-07-13 00:00:00	1964-08-12	1964-08-12 00:00:00	32020		\N	317195	0	16114001	4059173		0
80676	4784	4112343	2007-07-04	2007-07-04 00:00:00	2007-07-13	2007-07-13 00:00:00	32020		\N	318457	0	195662009	4112343		0
70135	4153	30753	2000-08-26	2000-08-26 00:00:00	\N	\N	32020		\N	276038	0	16761005	30753		0
80844	4795	260139	1974-02-20	1974-02-20 00:00:00	1974-03-06	1974-03-06 00:00:00	32020		\N	318993	0	10509002	260139		0
81129	4812	372328	1955-03-12	1955-03-12 00:00:00	1955-06-22	1955-06-22 00:00:00	32020		\N	320113	0	65363002	372328		0
81262	4819	28060	1970-02-10	1970-02-10 00:00:00	1970-02-17	1970-02-17 00:00:00	32020		\N	320584	0	43878008	28060		0
70862	4204	4112343	1962-10-29	1962-10-29 00:00:00	1962-11-11	1962-11-11 00:00:00	32020		\N	279113	0	195662009	4112343		0
70973	4210	40481087	2004-08-25	2004-08-25 00:00:00	2004-09-01	2004-09-01 00:00:00	32020		\N	279541	0	444814009	40481087		0
71049	4214	28060	2008-01-17	2008-01-17 00:00:00	2008-01-27	2008-01-27 00:00:00	32020		\N	279796	0	43878008	28060		0
71321	4229	4112343	1984-11-22	1984-11-22 00:00:00	1984-12-03	1984-12-03 00:00:00	32020		\N	280945	0	195662009	4112343		0
71455	4239	4112343	2016-10-09	2016-10-09 00:00:00	2016-10-19	2016-10-19 00:00:00	32020		\N	281558	0	195662009	4112343		0
82179	4872	40481087	1962-06-05	1962-06-05 00:00:00	1962-06-12	1962-06-12 00:00:00	32020		\N	324056	0	444814009	40481087		0
71809	4260	4112343	2016-10-11	2016-10-11 00:00:00	2016-10-20	2016-10-20 00:00:00	32020		\N	282790	0	195662009	4112343		0
71954	4270	260139	1994-01-06	1994-01-06 00:00:00	1994-01-13	1994-01-13 00:00:00	32020		\N	283437	0	10509002	260139		0
72092	4278	4112343	2014-10-11	2014-10-11 00:00:00	2014-10-18	2014-10-18 00:00:00	32020		\N	283842	0	195662009	4112343		0
72259	4288	28060	1960-08-22	1960-08-22 00:00:00	1960-08-31	1960-08-31 00:00:00	32020		\N	284698	0	43878008	28060		0
83042	4932	4112343	1985-03-04	1985-03-04 00:00:00	1985-03-16	1985-03-16 00:00:00	32020		\N	327810	0	195662009	4112343		0
83177	4942	260139	1986-12-08	1986-12-08 00:00:00	1986-12-15	1986-12-15 00:00:00	32020		\N	328482	0	10509002	260139		0
72826	4329	40481087	2011-08-27	2011-08-27 00:00:00	2011-09-17	2011-09-17 00:00:00	32020		\N	287148	0	444814009	40481087		0
83627	4970	260139	1934-04-13	1934-04-13 00:00:00	1934-04-20	1934-04-20 00:00:00	32020		\N	330343	0	10509002	260139		0
83670	4971	4112343	1985-05-30	1985-05-30 00:00:00	1985-06-07	1985-06-07 00:00:00	32020		\N	330652	0	195662009	4112343		0
73293	4355	40481087	2001-05-08	2001-05-08 00:00:00	2001-05-22	2001-05-22 00:00:00	32020		\N	288992	0	444814009	40481087		0
84048	4991	4116491	2007-07-01	2007-07-01 00:00:00	2007-08-21	2007-08-21 00:00:00	32020		\N	332024	0	301011002	4116491		0
73581	4374	4112343	1993-12-23	1993-12-23 00:00:00	1994-01-02	1994-01-02 00:00:00	32020		\N	290529	0	195662009	4112343		0
84355	5014	40481087	1932-10-05	1932-10-05 00:00:00	1932-10-26	1932-10-26 00:00:00	32020		\N	333248	0	444814009	40481087		0
84589	5031	40481087	1977-05-03	1977-05-03 00:00:00	1977-05-24	1977-05-24 00:00:00	32020		\N	334416	0	444814009	40481087		0
84667	5035	28060	1979-03-20	1979-03-20 00:00:00	1979-03-30	1979-03-30 00:00:00	32020		\N	334626	0	43878008	28060		0
84881	5048	40481087	1964-08-31	1964-08-31 00:00:00	1964-09-07	1964-09-07 00:00:00	32020		\N	335518	0	444814009	40481087		0
74433	4418	4113008	1994-07-23	1994-07-23 00:00:00	1994-08-06	1994-08-06 00:00:00	32020		\N	293746	0	284549007	4113008		0
74637	4433	4266809	1982-06-25	1982-06-25 00:00:00	\N	\N	32020		\N	294644	0	397881000	4266809		0
64208	3791	260139	1966-03-15	1966-03-15 00:00:00	1966-03-29	1966-03-29 00:00:00	32020		\N	252055	0	10509002	260139		0
64348	3799	260139	1981-11-19	1981-11-19 00:00:00	1981-11-26	1981-11-26 00:00:00	32020		\N	252532	0	10509002	260139		0
64484	3811	378419	2005-09-22	2005-09-22 00:00:00	\N	\N	32020		\N	253126	0	26929004	378419		0
75215	4467	40481087	1989-10-04	1989-10-04 00:00:00	1989-10-25	1989-10-25 00:00:00	32020		\N	297213	0	444814009	40481087		0
64764	3830	40481087	2015-11-02	2015-11-02 00:00:00	2015-11-16	2015-11-16 00:00:00	32020		\N	254302	0	444814009	40481087		0
64999	3844	28060	1990-03-09	1990-03-09 00:00:00	1990-03-20	1990-03-20 00:00:00	32020		\N	255153	0	43878008	28060		0
65126	3852	40481087	1995-09-10	1995-09-10 00:00:00	1995-10-01	1995-10-01 00:00:00	32020		\N	255736	0	444814009	40481087		0
65319	3862	40481087	2018-01-22	2018-01-22 00:00:00	2018-02-05	2018-02-05 00:00:00	32020		\N	256396	0	444814009	40481087		0
65517	3874	4027663	2006-12-17	2006-12-17 00:00:00	\N	\N	32020		\N	257303	0	13200003	4027663		0
76234	4523	4112343	1979-04-06	1979-04-06 00:00:00	1979-04-18	1979-04-18 00:00:00	32020		\N	301198	0	195662009	4112343		0
76405	4531	40481087	1978-11-04	1978-11-04 00:00:00	1978-11-18	1978-11-18 00:00:00	32020		\N	301742	0	444814009	40481087		0
66023	3904	28060	1986-04-17	1986-04-17 00:00:00	1986-04-27	1986-04-27 00:00:00	32020		\N	259592	0	43878008	28060		0
66219	3920	40481087	1987-08-11	1987-08-11 00:00:00	1987-09-01	1987-09-01 00:00:00	32020		\N	260635	0	444814009	40481087		0
66375	3929	4112343	1996-11-01	1996-11-01 00:00:00	1996-11-11	1996-11-11 00:00:00	32020		\N	261189	0	195662009	4112343		0
66474	3935	30753	1982-02-18	1982-02-18 00:00:00	\N	\N	32020		\N	261576	0	16761005	30753		0
77262	4577	40481087	2012-07-20	2012-07-20 00:00:00	2012-08-10	2012-08-10 00:00:00	32020		\N	304906	0	444814009	40481087		0
66891	3956	372328	1917-07-25	1917-07-25 00:00:00	1917-10-14	1917-10-14 00:00:00	32020		\N	262970	0	65363002	372328		0
67030	3962	4112343	1985-02-21	1985-02-21 00:00:00	1985-03-06	1985-03-06 00:00:00	32020		\N	263439	0	195662009	4112343		0
67204	3972	260139	2018-05-27	2018-05-27 00:00:00	2018-06-10	2018-06-10 00:00:00	32020		\N	264098	0	10509002	260139		0
78009	4622	4294548	1998-09-05	1998-09-05 00:00:00	1999-01-09	1999-01-09 00:00:00	32020		\N	307808	0	75498004	4294548		0
67544	3991	4112343	1981-08-23	1981-08-23 00:00:00	1981-09-05	1981-09-05 00:00:00	32020		\N	265343	0	195662009	4112343		0
67663	3997	4112343	1978-06-17	1978-06-17 00:00:00	1978-06-28	1978-06-28 00:00:00	32020		\N	265731	0	195662009	4112343		0
67834	4009	4296204	1983-07-13	1983-07-13 00:00:00	1983-07-27	1983-07-27 00:00:00	32020		\N	266433	0	403190006	4296204		0
68041	4019	78272	1987-10-31	1987-10-31 00:00:00	1987-11-21	1987-11-21 00:00:00	32020		\N	267170	0	70704007	78272		0
68160	4026	257012	2019-04-25	2019-04-25 00:00:00	2019-06-20	2019-06-20 00:00:00	32020		\N	267603	0	40055000	257012		0
78918	4675	81151	1961-04-13	1961-04-13 00:00:00	1961-05-11	1961-05-11 00:00:00	32020		\N	311507	0	44465007	81151		0
68534	4052	4113008	2007-01-01	2007-01-01 00:00:00	2007-01-22	2007-01-22 00:00:00	32020		\N	269417	0	284549007	4113008		0
79204	4689	440086	1981-05-06	1981-05-06 00:00:00	1981-07-01	1981-07-01 00:00:00	32020		\N	312432	0	192127007	440086		0
79375	4701	257012	1989-08-24	1989-08-24 00:00:00	\N	\N	32020		\N	313161	0	40055000	257012		0
68945	4080	260139	2007-01-25	2007-01-25 00:00:00	2007-02-01	2007-02-01 00:00:00	32020		\N	271180	0	10509002	260139		0
69156	4091	4112343	1973-05-29	1973-05-29 00:00:00	1973-06-07	1973-06-07 00:00:00	32020		\N	271986	0	195662009	4112343		0
79936	4736	40479422	2002-08-23	2002-08-23 00:00:00	2002-10-29	2002-10-29 00:00:00	32020		\N	315514	0	444448004	40479422		0
69390	4106	81151	1966-02-18	1966-02-18 00:00:00	1966-03-18	1966-03-18 00:00:00	32020		\N	272861	0	44465007	81151		0
69598	4119	440448	1976-07-15	1976-07-15 00:00:00	\N	\N	32020		\N	273810	0	74400008	440448		0
80366	4760	372328	1960-05-28	1960-05-28 00:00:00	1960-10-12	1960-10-12 00:00:00	32020		\N	317126	0	65363002	372328		0
70136	4153	80180	2001-09-20	2001-09-20 00:00:00	\N	\N	32020		\N	276038	0	396275006	80180		0
80845	4795	372328	2011-10-09	2011-10-09 00:00:00	2011-11-23	2011-11-23 00:00:00	32020		\N	319030	0	65363002	372328		0
81130	4812	4112343	1974-02-16	1974-02-16 00:00:00	1974-02-27	1974-02-27 00:00:00	32020		\N	320093	0	195662009	4112343		0
81263	4819	260139	1982-01-26	1982-01-26 00:00:00	1982-02-02	1982-02-02 00:00:00	32020		\N	320513	0	10509002	260139		0
70863	4204	4027663	1979-08-07	1979-08-07 00:00:00	\N	\N	32020		\N	279108	0	13200003	4027663		0
70974	4210	80180	2016-12-10	2016-12-10 00:00:00	\N	\N	32020		\N	279540	0	396275006	80180		0
71050	4214	4112343	1975-09-15	1975-09-15 00:00:00	1975-09-25	1975-09-25 00:00:00	32020		\N	279772	0	195662009	4112343		0
71322	4229	4155034	1953-05-17	1953-05-17 00:00:00	1953-05-31	1953-05-31 00:00:00	32020		\N	280919	0	283371005	4155034		0
71456	4239	260139	1952-09-06	1952-09-06 00:00:00	1952-09-13	1952-09-13 00:00:00	32020		\N	281513	0	10509002	260139		0
82180	4872	260139	1952-08-14	1952-08-14 00:00:00	1952-08-21	1952-08-21 00:00:00	32020		\N	324008	0	10509002	260139		0
71810	4260	378419	2018-10-30	2018-10-30 00:00:00	\N	\N	32020		\N	282851	0	26929004	378419		0
71955	4270	440086	1977-01-14	1977-01-14 00:00:00	1978-06-23	1978-06-23 00:00:00	32020		\N	283433	0	192127007	440086		0
72093	4278	4112343	1994-06-01	1994-06-01 00:00:00	1994-06-11	1994-06-11 00:00:00	32020		\N	283883	0	195662009	4112343		0
72260	4288	4283893	1996-08-09	1996-08-09 00:00:00	1996-08-30	1996-08-30 00:00:00	32020		\N	284716	0	36971009	4283893		0
83043	4932	81893	1994-07-03	1994-07-03 00:00:00	\N	\N	32020		\N	327818	0	64766004	81893		0
83178	4942	4146173	1964-09-17	1964-09-17 00:00:00	1964-11-16	1964-11-16 00:00:00	32020		\N	328468	0	307731004	4146173		0
72827	4329	257012	2018-12-09	2018-12-09 00:00:00	2018-12-30	2018-12-30 00:00:00	32020		\N	287076	0	40055000	257012		0
83628	4970	372328	1928-10-18	1928-10-18 00:00:00	1929-03-20	1929-03-20 00:00:00	32020		\N	330436	0	65363002	372328		0
83671	4971	4134304	2000-11-12	2000-11-12 00:00:00	2000-12-12	2000-12-12 00:00:00	32020		\N	330514	0	263102004	4134304		0
73294	4355	372328	1981-11-14	1981-11-14 00:00:00	1981-12-26	1981-12-26 00:00:00	32020		\N	288968	0	65363002	372328		0
84049	4991	257012	1983-12-16	1983-12-16 00:00:00	\N	\N	32020		\N	332057	0	40055000	257012		0
73582	4374	4294548	2011-05-08	2011-05-08 00:00:00	2011-06-05	2011-06-05 00:00:00	32020		\N	290484	0	75498004	4294548		0
84356	5014	40481087	1968-04-22	1968-04-22 00:00:00	1968-05-06	1968-05-06 00:00:00	32020		\N	333265	0	444814009	40481087		0
84590	5031	260139	1922-07-28	1922-07-28 00:00:00	1922-08-11	1922-08-11 00:00:00	32020		\N	334271	0	10509002	260139		0
84668	5035	4310024	1967-04-19	1967-04-19 00:00:00	\N	\N	32020		\N	334547	0	424802006	4310024		0
84882	5048	28060	1970-06-27	1970-06-27 00:00:00	1970-07-08	1970-07-08 00:00:00	32020		\N	335403	0	43878008	28060		0
74434	4418	40481087	2013-11-17	2013-11-17 00:00:00	2013-12-08	2013-12-08 00:00:00	32020		\N	293783	0	444814009	40481087		0
74638	4433	80180	1982-06-25	1982-06-25 00:00:00	\N	\N	32020		\N	294644	0	396275006	80180		0
64209	3791	40481087	2010-06-15	2010-06-15 00:00:00	2010-06-22	2010-06-22 00:00:00	32020		\N	252041	0	444814009	40481087		0
64372	3803	40481087	1998-09-22	1998-09-22 00:00:00	1998-09-29	1998-09-29 00:00:00	32020		\N	252756	0	444814009	40481087		0
64485	3811	4112343	1989-01-13	1989-01-13 00:00:00	1989-01-23	1989-01-23 00:00:00	32020		\N	253121	0	195662009	4112343		0
75216	4467	4027663	1976-06-21	1976-06-21 00:00:00	\N	\N	32020		\N	297210	0	13200003	4027663		0
64765	3830	40481087	2007-07-21	2007-07-21 00:00:00	2007-08-11	2007-08-11 00:00:00	32020		\N	254300	0	444814009	40481087		0
65000	3844	40481087	1962-03-30	1962-03-30 00:00:00	1962-04-20	1962-04-20 00:00:00	32020		\N	255125	0	444814009	40481087		0
65127	3852	372328	1953-08-28	1953-08-28 00:00:00	1953-09-11	1953-09-11 00:00:00	32020		\N	255618	0	65363002	372328		0
65320	3862	40481087	1996-06-12	1996-06-12 00:00:00	1996-06-26	1996-06-26 00:00:00	32020		\N	256428	0	444814009	40481087		0
65518	3874	372328	1983-08-15	1983-08-15 00:00:00	1983-11-30	1983-11-30 00:00:00	32020		\N	257289	0	65363002	372328		0
76235	4523	4112343	2014-03-02	2014-03-02 00:00:00	2014-03-15	2014-03-15 00:00:00	32020		\N	301196	0	195662009	4112343		0
76406	4531	4109685	1943-09-08	1943-09-08 00:00:00	1943-09-22	1943-09-22 00:00:00	32020		\N	301704	0	284551006	4109685		0
66024	3904	40481087	1999-07-16	1999-07-16 00:00:00	1999-07-23	1999-07-23 00:00:00	32020		\N	259595	0	444814009	40481087		0
66220	3920	260139	1975-04-14	1975-04-14 00:00:00	1975-04-21	1975-04-21 00:00:00	32020		\N	260633	0	10509002	260139		0
66376	3929	28060	1961-04-05	1961-04-05 00:00:00	1961-04-17	1961-04-17 00:00:00	32020		\N	261196	0	43878008	28060		0
66475	3935	4146173	1982-01-13	1982-01-13 00:00:00	1982-03-14	1982-03-14 00:00:00	32020		\N	261576	0	307731004	4146173		0
77263	4577	4112343	1996-10-26	1996-10-26 00:00:00	1996-11-03	1996-11-03 00:00:00	32020		\N	304860	0	195662009	4112343		0
66892	3956	40481087	1976-08-31	1976-08-31 00:00:00	1976-09-21	1976-09-21 00:00:00	32020		\N	262963	0	444814009	40481087		0
67031	3962	40481087	1951-08-24	1951-08-24 00:00:00	1951-09-14	1951-09-14 00:00:00	32020		\N	263442	0	444814009	40481087		0
67205	3972	4027663	1990-01-03	1990-01-03 00:00:00	\N	\N	32020		\N	264129	0	13200003	4027663		0
78010	4622	257012	1998-10-10	1998-10-10 00:00:00	\N	\N	32020		\N	307835	0	40055000	257012		0
67545	3991	80502	2016-01-23	2016-01-23 00:00:00	\N	\N	32020		\N	265352	0	64859006	80502		0
67664	3997	4156265	1998-02-25	1998-02-25 00:00:00	1998-03-11	1998-03-11 00:00:00	32020		\N	265703	0	370247008	4156265		0
67835	4009	4152936	2004-06-06	2004-06-06 00:00:00	2004-06-20	2004-06-20 00:00:00	32020		\N	266434	0	283385000	4152936		0
68042	4019	40481087	1970-12-23	1970-12-23 00:00:00	1971-01-06	1971-01-06 00:00:00	32020		\N	267119	0	444814009	40481087		0
68161	4026	40481087	1960-07-19	1960-07-19 00:00:00	1960-08-09	1960-08-09 00:00:00	32020		\N	267657	0	444814009	40481087		0
78919	4675	40480160	2012-07-12	2012-07-12 00:00:00	2012-09-10	2012-09-10 00:00:00	32020		\N	311450	0	443165006	40480160		0
68535	4052	4027663	2007-04-08	2007-04-08 00:00:00	\N	\N	32020		\N	269417	0	13200003	4027663		0
79205	4689	260139	1998-10-01	1998-10-01 00:00:00	1998-10-15	1998-10-15 00:00:00	32020		\N	312379	0	10509002	260139		0
79376	4701	4296204	1978-08-17	1978-08-17 00:00:00	1978-08-31	1978-08-31 00:00:00	32020		\N	313169	0	403190006	4296204		0
68946	4080	378001	2007-02-12	2007-02-12 00:00:00	2007-04-13	2007-04-13 00:00:00	32020		\N	271176	0	62106007	378001		0
69157	4091	28060	1974-04-07	1974-04-07 00:00:00	1974-04-18	1974-04-18 00:00:00	32020		\N	271946	0	43878008	28060		0
79937	4736	4112343	1998-08-12	1998-08-12 00:00:00	1998-08-24	1998-08-24 00:00:00	32020		\N	315502	0	195662009	4112343		0
69391	4106	4152936	1963-01-21	1963-01-21 00:00:00	1963-02-04	1963-02-04 00:00:00	32020		\N	272860	0	283385000	4152936		0
69599	4119	40481087	2003-12-09	2003-12-09 00:00:00	2003-12-16	2003-12-16 00:00:00	32020		\N	273891	0	444814009	40481087		0
80367	4760	260139	1974-12-08	1974-12-08 00:00:00	1974-12-22	1974-12-22 00:00:00	32020		\N	317143	0	10509002	260139		0
70137	4153	40481087	1965-11-15	1965-11-15 00:00:00	1965-12-06	1965-12-06 00:00:00	32020		\N	276062	0	444814009	40481087		0
80846	4795	260139	1991-06-28	1991-06-28 00:00:00	1991-07-12	1991-07-12 00:00:00	32020		\N	318999	0	10509002	260139		0
81131	4812	40481087	2011-10-12	2011-10-12 00:00:00	2011-11-02	2011-11-02 00:00:00	32020		\N	320112	0	444814009	40481087		0
81264	4819	28060	1967-08-14	1967-08-14 00:00:00	1967-08-23	1967-08-23 00:00:00	32020		\N	320512	0	43878008	28060		0
70864	4204	260139	2015-05-19	2015-05-19 00:00:00	2015-06-02	2015-06-02 00:00:00	32020		\N	279084	0	10509002	260139		0
70975	4210	40481087	1977-07-31	1977-07-31 00:00:00	1977-08-14	1977-08-14 00:00:00	32020		\N	279518	0	444814009	40481087		0
71051	4214	260139	1998-10-24	1998-10-24 00:00:00	1998-10-31	1998-10-31 00:00:00	32020		\N	279762	0	10509002	260139		0
71323	4229	78272	2001-07-03	2001-07-03 00:00:00	2001-07-24	2001-07-24 00:00:00	32020		\N	280925	0	70704007	78272		0
71457	4239	81151	1951-09-10	1951-09-10 00:00:00	1951-10-08	1951-10-08 00:00:00	32020		\N	281501	0	44465007	81151		0
82181	4872	372328	1918-07-14	1918-07-14 00:00:00	1919-07-15	1919-07-15 00:00:00	32020		\N	324085	0	65363002	372328		0
71811	4260	4112343	1987-06-27	1987-06-27 00:00:00	1987-07-06	1987-07-06 00:00:00	32020		\N	282787	0	195662009	4112343		0
71956	4270	4112343	2013-06-10	2013-06-10 00:00:00	2013-06-18	2013-06-18 00:00:00	32020		\N	283439	0	195662009	4112343		0
72094	4278	40481087	2004-01-03	2004-01-03 00:00:00	2004-01-17	2004-01-17 00:00:00	32020		\N	283941	0	444814009	40481087		0
72261	4288	40481087	1974-03-25	1974-03-25 00:00:00	1974-04-01	1974-04-01 00:00:00	32020		\N	284664	0	444814009	40481087		0
83044	4932	260139	1990-09-06	1990-09-06 00:00:00	1990-09-20	1990-09-20 00:00:00	32020		\N	327887	0	10509002	260139		0
83179	4942	28060	1960-03-29	1960-03-29 00:00:00	1960-04-10	1960-04-10 00:00:00	32020		\N	328520	0	43878008	28060		0
72828	4329	40481087	2013-08-14	2013-08-14 00:00:00	2013-08-28	2013-08-28 00:00:00	32020		\N	287073	0	444814009	40481087		0
83629	4970	40481087	1948-10-23	1948-10-23 00:00:00	1948-11-13	1948-11-13 00:00:00	32020		\N	330424	0	444814009	40481087		0
83672	4971	81151	1971-07-06	1971-07-06 00:00:00	1971-08-03	1971-08-03 00:00:00	32020		\N	330511	0	44465007	81151		0
73295	4355	40481087	2009-01-18	2009-01-18 00:00:00	2009-01-25	2009-01-25 00:00:00	32020		\N	288994	0	444814009	40481087		0
84050	4991	40481087	1988-10-01	1988-10-01 00:00:00	1988-10-15	1988-10-15 00:00:00	32020		\N	332022	0	444814009	40481087		0
73583	4374	30753	2012-08-04	2012-08-04 00:00:00	\N	\N	32020		\N	290484	0	16761005	30753		0
84357	5014	40481087	1930-06-20	1930-06-20 00:00:00	1930-07-11	1930-07-11 00:00:00	32020		\N	333235	0	444814009	40481087		0
84591	5031	372328	2019-01-04	2019-01-04 00:00:00	2019-05-25	2019-05-25 00:00:00	32020		\N	334422	0	65363002	372328		0
84669	5035	40481087	1965-09-03	1965-09-03 00:00:00	1965-09-17	1965-09-17 00:00:00	32020		\N	334547	0	444814009	40481087		0
84883	5048	40481087	2008-05-09	2008-05-09 00:00:00	2008-05-16	2008-05-16 00:00:00	32020		\N	335431	0	444814009	40481087		0
74435	4418	40479422	2006-09-30	2006-09-30 00:00:00	2006-11-06	2006-11-06 00:00:00	32020		\N	293748	0	444448004	40479422		0
74639	4433	40481087	1982-03-21	1982-03-21 00:00:00	1982-04-04	1982-04-04 00:00:00	32020		\N	294644	0	444814009	40481087		0
64210	3791	4112343	1948-02-16	1948-02-16 00:00:00	1948-02-27	1948-02-27 00:00:00	32020		\N	252135	0	195662009	4112343		0
64373	3803	4027663	1994-04-05	1994-04-05 00:00:00	\N	\N	32020		\N	252784	0	13200003	4027663		0
64486	3811	40481087	1983-07-05	1983-07-05 00:00:00	1983-07-26	1983-07-26 00:00:00	32020		\N	253169	0	444814009	40481087		0
75217	4467	81151	1959-02-07	1959-02-07 00:00:00	1959-03-07	1959-03-07 00:00:00	32020		\N	297161	0	44465007	81151		0
64766	3830	40481087	1984-06-10	1984-06-10 00:00:00	1984-07-01	1984-07-01 00:00:00	32020		\N	254281	0	444814009	40481087		0
65001	3844	257012	1993-05-01	1993-05-01 00:00:00	1993-07-31	1993-07-31 00:00:00	32020		\N	255159	0	40055000	257012		0
65128	3852	40481087	1983-04-08	1983-04-08 00:00:00	1983-04-29	1983-04-29 00:00:00	32020		\N	255630	0	444814009	40481087		0
65321	3862	40481087	1979-03-06	1979-03-06 00:00:00	1979-03-27	1979-03-27 00:00:00	32020		\N	256427	0	444814009	40481087		0
65519	3875	28060	2006-11-17	2006-11-17 00:00:00	2006-11-26	2006-11-26 00:00:00	32020		\N	257326	0	43878008	28060		0
76236	4523	40481087	1985-04-16	1985-04-16 00:00:00	1985-04-23	1985-04-23 00:00:00	32020		\N	301182	0	444814009	40481087		0
76407	4531	4296205	1930-04-21	1930-04-21 00:00:00	1930-05-19	1930-05-19 00:00:00	32020		\N	301823	0	403191005	4296205		0
66025	3904	40481087	2010-05-20	2010-05-20 00:00:00	2010-05-27	2010-05-27 00:00:00	32020		\N	259610	0	444814009	40481087		0
66221	3920	40481087	1977-12-27	1977-12-27 00:00:00	1978-01-03	1978-01-03 00:00:00	32020		\N	260668	0	444814009	40481087		0
66377	3929	81893	1988-08-24	1988-08-24 00:00:00	\N	\N	32020		\N	261161	0	64766004	81893		0
66476	3935	4296204	1961-05-30	1961-05-30 00:00:00	1961-07-04	1961-07-04 00:00:00	32020		\N	261541	0	403190006	4296204		0
77264	4577	372328	1985-06-06	1985-06-06 00:00:00	1985-12-14	1985-12-14 00:00:00	32020		\N	304891	0	65363002	372328		0
66893	3956	439777	1996-10-18	1996-10-18 00:00:00	\N	\N	32020		\N	262965	0	271737000	439777		0
67032	3962	4310024	1988-01-04	1988-01-04 00:00:00	\N	\N	32020		\N	263390	0	424802006	4310024		0
67206	3972	40481087	1971-07-03	1971-07-03 00:00:00	1971-07-17	1971-07-17 00:00:00	32020		\N	264160	0	444814009	40481087		0
78011	4622	40481087	2007-08-30	2007-08-30 00:00:00	2007-09-06	2007-09-06 00:00:00	32020		\N	307809	0	444814009	40481087		0
67546	3991	40481087	1956-01-24	1956-01-24 00:00:00	1956-02-14	1956-02-14 00:00:00	32020		\N	265319	0	444814009	40481087		0
67665	3997	4134304	1978-04-13	1978-04-13 00:00:00	1978-06-12	1978-06-12 00:00:00	32020		\N	265700	0	263102004	4134304		0
67836	4009	372328	1952-03-30	1952-03-30 00:00:00	1952-07-16	1952-07-16 00:00:00	32020		\N	266428	0	65363002	372328		0
68043	4019	4112343	1973-07-15	1973-07-15 00:00:00	1973-07-23	1973-07-23 00:00:00	32020		\N	267120	0	195662009	4112343		0
68162	4026	4112343	2019-02-08	2019-02-08 00:00:00	2019-02-18	2019-02-18 00:00:00	32020		\N	267643	0	195662009	4112343		0
78920	4675	4059173	2012-07-12	2012-07-12 00:00:00	2012-09-10	2012-09-10 00:00:00	32020		\N	311450	0	16114001	4059173		0
68536	4052	260139	1990-07-02	1990-07-02 00:00:00	1990-07-09	1990-07-09 00:00:00	32020		\N	269378	0	10509002	260139		0
79206	4689	40481087	1998-03-07	1998-03-07 00:00:00	1998-03-21	1998-03-21 00:00:00	32020		\N	312405	0	444814009	40481087		0
79377	4701	260139	1977-12-27	1977-12-27 00:00:00	1978-01-10	1978-01-10 00:00:00	32020		\N	313135	0	10509002	260139		0
68947	4080	4113008	1970-10-03	1970-10-03 00:00:00	1970-10-24	1970-10-24 00:00:00	32020		\N	271172	0	284549007	4113008		0
69158	4091	4112343	2016-04-05	2016-04-05 00:00:00	2016-04-18	2016-04-18 00:00:00	32020		\N	271994	0	195662009	4112343		0
79938	4736	40481087	1976-07-27	1976-07-27 00:00:00	1976-08-10	1976-08-10 00:00:00	32020		\N	315475	0	444814009	40481087		0
69392	4106	40481087	1946-05-30	1946-05-30 00:00:00	1946-06-13	1946-06-13 00:00:00	32020		\N	272832	0	444814009	40481087		0
69600	4119	40481087	2007-08-06	2007-08-06 00:00:00	2007-08-13	2007-08-13 00:00:00	32020		\N	273849	0	444814009	40481087		0
80368	4760	40481087	2013-03-17	2013-03-17 00:00:00	2013-03-24	2013-03-24 00:00:00	32020		\N	317178	0	444814009	40481087		0
70138	4153	260139	1975-12-26	1975-12-26 00:00:00	1976-01-09	1976-01-09 00:00:00	32020		\N	276063	0	10509002	260139		0
80883	4799	4116491	1986-11-09	1986-11-09 00:00:00	1986-12-21	1986-12-21 00:00:00	32020		\N	319285	0	301011002	4116491		0
81132	4812	28060	1964-02-17	1964-02-17 00:00:00	1964-02-26	1964-02-26 00:00:00	32020		\N	320135	0	43878008	28060		0
81265	4819	40481087	1970-10-28	1970-10-28 00:00:00	1970-11-11	1970-11-11 00:00:00	32020		\N	320585	0	444814009	40481087		0
70865	4204	40481087	2005-01-03	2005-01-03 00:00:00	2005-01-10	2005-01-10 00:00:00	32020		\N	279082	0	444814009	40481087		0
70976	4210	81151	1976-04-29	1976-04-29 00:00:00	1976-05-13	1976-05-13 00:00:00	32020		\N	279575	0	44465007	81151		0
71052	4214	260139	1981-12-13	1981-12-13 00:00:00	1981-12-20	1981-12-20 00:00:00	32020		\N	279773	0	10509002	260139		0
71324	4229	260139	1985-05-05	1985-05-05 00:00:00	1985-05-19	1985-05-19 00:00:00	32020		\N	280946	0	10509002	260139		0
71458	4239	40481087	1976-12-21	1976-12-21 00:00:00	1977-01-04	1977-01-04 00:00:00	32020		\N	281526	0	444814009	40481087		0
82182	4873	4112343	2014-06-24	2014-06-24 00:00:00	2014-07-04	2014-07-04 00:00:00	32020		\N	324129	0	195662009	4112343		0
71812	4260	4112343	1960-11-08	1960-11-08 00:00:00	1960-11-16	1960-11-16 00:00:00	32020		\N	282833	0	195662009	4112343		0
71957	4270	372328	1978-03-15	1978-03-15 00:00:00	1979-02-06	1979-02-06 00:00:00	32020		\N	283441	0	65363002	372328		0
72095	4278	4112343	1997-11-25	1997-11-25 00:00:00	1997-12-08	1997-12-08 00:00:00	32020		\N	283939	0	195662009	4112343		0
72262	4288	260139	1998-12-01	1998-12-01 00:00:00	1998-12-15	1998-12-15 00:00:00	32020		\N	284700	0	10509002	260139		0
83045	4932	40481087	2007-03-08	2007-03-08 00:00:00	2007-03-22	2007-03-22 00:00:00	32020		\N	327883	0	444814009	40481087		0
83180	4942	378001	1961-01-06	1961-01-06 00:00:00	1961-03-07	1961-03-07 00:00:00	32020		\N	328462	0	62106007	378001		0
72829	4329	260139	2018-03-15	2018-03-15 00:00:00	2018-03-22	2018-03-22 00:00:00	32020		\N	287074	0	10509002	260139		0
83630	4970	378419	1995-11-29	1995-11-29 00:00:00	\N	\N	32020		\N	330355	0	26929004	378419		0
83673	4971	4112343	1954-07-07	1954-07-07 00:00:00	1954-07-18	1954-07-18 00:00:00	32020		\N	330649	0	195662009	4112343		0
73296	4355	4112343	2002-02-28	2002-02-28 00:00:00	2002-03-13	2002-03-13 00:00:00	32020		\N	288993	0	195662009	4112343		0
84051	4991	28060	1973-06-01	1973-06-01 00:00:00	1973-06-11	1973-06-11 00:00:00	32020		\N	332027	0	43878008	28060		0
73584	4374	260139	2000-07-27	2000-07-27 00:00:00	2000-08-10	2000-08-10 00:00:00	32020		\N	290509	0	10509002	260139		0
84358	5014	381316	1996-05-28	1996-05-28 00:00:00	\N	\N	32020		\N	333290	0	230690007	381316		0
84592	5031	260139	1928-02-17	1928-02-17 00:00:00	1928-02-24	1928-02-24 00:00:00	32020		\N	334323	0	10509002	260139		0
84670	5035	40481087	1995-01-21	1995-01-21 00:00:00	1995-02-11	1995-02-11 00:00:00	32020		\N	334565	0	444814009	40481087		0
84884	5048	40481087	1987-01-20	1987-01-20 00:00:00	1987-02-03	1987-02-03 00:00:00	32020		\N	335463	0	444814009	40481087		0
74436	4418	260139	1979-10-22	1979-10-22 00:00:00	1979-10-29	1979-10-29 00:00:00	32020		\N	293750	0	10509002	260139		0
74640	4433	4112343	1997-07-31	1997-07-31 00:00:00	1997-08-10	1997-08-10 00:00:00	32020		\N	294656	0	195662009	4112343		0
64374	3803	40481087	1969-10-29	1969-10-29 00:00:00	1969-11-12	1969-11-12 00:00:00	32020		\N	252804	0	444814009	40481087		0
64487	3811	260139	1932-08-24	1932-08-24 00:00:00	1932-09-07	1932-09-07 00:00:00	32020		\N	253144	0	10509002	260139		0
75218	4467	30753	1986-03-16	1986-03-16 00:00:00	\N	\N	32020		\N	297184	0	16761005	30753		0
64767	3830	4112343	2012-04-01	2012-04-01 00:00:00	2012-04-14	2012-04-14 00:00:00	32020		\N	254301	0	195662009	4112343		0
65002	3844	40481087	1960-01-27	1960-01-27 00:00:00	1960-02-03	1960-02-03 00:00:00	32020		\N	255151	0	444814009	40481087		0
65129	3852	260139	2013-05-05	2013-05-05 00:00:00	2013-05-19	2013-05-19 00:00:00	32020		\N	255617	0	10509002	260139		0
65322	3862	80180	1995-06-11	1995-06-11 00:00:00	\N	\N	32020		\N	256381	0	396275006	80180		0
65520	3875	81151	1977-01-17	1977-01-17 00:00:00	1977-01-31	1977-01-31 00:00:00	32020		\N	257380	0	44465007	81151		0
76237	4523	80180	2018-01-04	2018-01-04 00:00:00	\N	\N	32020		\N	301197	0	396275006	80180		0
76408	4531	372328	1915-01-26	1915-01-26 00:00:00	1915-05-08	1915-05-08 00:00:00	32020		\N	301755	0	65363002	372328		0
66026	3904	260139	1995-05-05	1995-05-05 00:00:00	1995-05-12	1995-05-12 00:00:00	32020		\N	259594	0	10509002	260139		0
66222	3920	260139	2004-05-17	2004-05-17 00:00:00	2004-05-31	2004-05-31 00:00:00	32020		\N	260636	0	10509002	260139		0
66378	3929	258780	1987-04-06	1987-04-06 00:00:00	\N	\N	32020		\N	261161	0	185086009	258780		0
66477	3935	81151	1958-05-25	1958-05-25 00:00:00	1958-06-15	1958-06-15 00:00:00	32020		\N	261540	0	44465007	81151		0
77265	4577	4283893	2016-07-06	2016-07-06 00:00:00	2016-08-31	2016-08-31 00:00:00	32020		\N	304888	0	36971009	4283893		0
66894	3956	40481087	1962-02-17	1962-02-17 00:00:00	1962-02-24	1962-02-24 00:00:00	32020		\N	262976	0	444814009	40481087		0
67033	3962	40481087	1986-08-19	1986-08-19 00:00:00	1986-08-26	1986-08-26 00:00:00	32020		\N	263390	0	444814009	40481087		0
67207	3972	192671	1999-08-15	1999-08-15 00:00:00	\N	\N	32020		\N	264166	0	K92.2	35208414		0
78012	4622	4027663	1988-01-18	1988-01-18 00:00:00	\N	\N	32020		\N	\N	0	13200003	4027663		0
67547	3991	40481087	1996-06-18	1996-06-18 00:00:00	1996-07-09	1996-07-09 00:00:00	32020		\N	265394	0	444814009	40481087		0
67666	3997	257012	2012-05-12	2012-05-12 00:00:00	\N	\N	32020		\N	265743	0	40055000	257012		0
67837	4009	192671	1992-06-12	1992-06-12 00:00:00	\N	\N	32020		\N	266431	0	K92.2	35208414		0
68044	4019	4294548	2001-04-15	2001-04-15 00:00:00	2001-06-10	2001-06-10 00:00:00	32020		\N	267140	0	75498004	4294548		0
68163	4026	81151	1977-04-16	1977-04-16 00:00:00	1977-05-07	1977-05-07 00:00:00	32020		\N	267630	0	44465007	81151		0
78921	4675	40481087	1988-07-05	1988-07-05 00:00:00	1988-07-12	1988-07-12 00:00:00	32020		\N	311439	0	444814009	40481087		0
68537	4052	4112343	1977-02-11	1977-02-11 00:00:00	1977-02-22	1977-02-22 00:00:00	32020		\N	269371	0	195662009	4112343		0
79207	4689	28060	1981-01-08	1981-01-08 00:00:00	1981-01-21	1981-01-21 00:00:00	32020		\N	312439	0	43878008	28060		0
79378	4701	4112343	1990-02-25	1990-02-25 00:00:00	1990-03-06	1990-03-06 00:00:00	32020		\N	313162	0	195662009	4112343		0
68948	4080	4134304	1971-11-18	1971-11-18 00:00:00	1972-01-17	1972-01-17 00:00:00	32020		\N	271173	0	263102004	4134304		0
69159	4091	40481087	2010-12-22	2010-12-22 00:00:00	2011-01-12	2011-01-12 00:00:00	32020		\N	271949	0	444814009	40481087		0
79939	4736	40481087	1985-01-02	1985-01-02 00:00:00	1985-01-16	1985-01-16 00:00:00	32020		\N	315476	0	444814009	40481087		0
69393	4106	4112343	1999-04-21	1999-04-21 00:00:00	1999-05-03	1999-05-03 00:00:00	32020		\N	272866	0	195662009	4112343		0
69601	4119	372328	1947-02-24	1947-02-24 00:00:00	1947-08-23	1947-08-23 00:00:00	32020		\N	273795	0	65363002	372328		0
80369	4760	28060	1955-03-27	1955-03-27 00:00:00	1955-04-05	1955-04-05 00:00:00	32020		\N	317171	0	43878008	28060		0
70139	4153	4112343	1991-12-04	1991-12-04 00:00:00	1991-12-13	1991-12-13 00:00:00	32020		\N	276064	0	195662009	4112343		0
80884	4799	40481087	1961-12-19	1961-12-19 00:00:00	1961-12-26	1961-12-26 00:00:00	32020		\N	319290	0	444814009	40481087		0
81133	4812	28060	1997-05-27	1997-05-27 00:00:00	1997-06-06	1997-06-06 00:00:00	32020		\N	320111	0	43878008	28060		0
81266	4819	4112343	1965-09-10	1965-09-10 00:00:00	1965-09-21	1965-09-21 00:00:00	32020		\N	320521	0	195662009	4112343		0
70866	4204	40481087	1972-04-12	1972-04-12 00:00:00	1972-05-03	1972-05-03 00:00:00	32020		\N	279120	0	444814009	40481087		0
70977	4210	4156265	2017-07-17	2017-07-17 00:00:00	2017-07-31	2017-07-31 00:00:00	32020		\N	279552	0	370247008	4156265		0
71053	4214	4283893	1973-02-02	1973-02-02 00:00:00	1973-03-09	1973-03-09 00:00:00	32020		\N	279793	0	36971009	4283893		0
71325	4229	260139	1963-06-26	1963-06-26 00:00:00	1963-07-10	1963-07-10 00:00:00	32020		\N	280960	0	10509002	260139		0
71459	4239	4112343	2018-08-12	2018-08-12 00:00:00	2018-08-20	2018-08-20 00:00:00	32020		\N	281570	0	195662009	4112343		0
82183	4873	80180	2018-10-24	2018-10-24 00:00:00	\N	\N	32020		\N	324114	0	396275006	80180		0
71813	4260	28060	1959-12-04	1959-12-04 00:00:00	1959-12-11	1959-12-11 00:00:00	32020		\N	282754	0	43878008	28060		0
71958	4270	260139	1995-09-22	1995-09-22 00:00:00	1995-10-06	1995-10-06 00:00:00	32020		\N	283438	0	10509002	260139		0
72096	4278	4112343	2002-12-28	2002-12-28 00:00:00	2003-01-10	2003-01-10 00:00:00	32020		\N	283841	0	195662009	4112343		0
72263	4288	4112343	1966-10-11	1966-10-11 00:00:00	1966-10-22	1966-10-22 00:00:00	32020		\N	284663	0	195662009	4112343		0
83046	4932	260139	1997-04-18	1997-04-18 00:00:00	1997-04-25	1997-04-25 00:00:00	32020		\N	327921	0	10509002	260139		0
83181	4942	4156265	1957-03-14	1957-03-14 00:00:00	1957-03-28	1957-03-28 00:00:00	32020		\N	328461	0	370247008	4156265		0
72830	4329	4112343	2008-09-17	2008-09-17 00:00:00	2008-09-26	2008-09-26 00:00:00	32020		\N	287079	0	195662009	4112343		0
83631	4970	40481087	1947-04-09	1947-04-09 00:00:00	1947-04-23	1947-04-23 00:00:00	32020		\N	330491	0	444814009	40481087		0
83674	4971	260139	1974-10-04	1974-10-04 00:00:00	1974-10-18	1974-10-18 00:00:00	32020		\N	330650	0	10509002	260139		0
73330	4359	260139	1970-10-17	1970-10-17 00:00:00	1970-10-24	1970-10-24 00:00:00	32020		\N	289222	0	10509002	260139		0
84052	4991	260139	1985-04-23	1985-04-23 00:00:00	1985-05-07	1985-05-07 00:00:00	32020		\N	332021	0	10509002	260139		0
73585	4374	40481087	1993-09-12	1993-09-12 00:00:00	1993-10-03	1993-10-03 00:00:00	32020		\N	290508	0	444814009	40481087		0
84359	5014	28060	1921-09-11	1921-09-11 00:00:00	1921-09-19	1921-09-19 00:00:00	32020		\N	333234	0	43878008	28060		0
84593	5031	4112343	1968-10-05	1968-10-05 00:00:00	1968-10-17	1968-10-17 00:00:00	32020		\N	334330	0	195662009	4112343		0
84671	5035	260139	1990-04-07	1990-04-07 00:00:00	1990-04-14	1990-04-14 00:00:00	32020		\N	334591	0	10509002	260139		0
84885	5048	4116491	1976-10-19	1976-10-19 00:00:00	1976-11-21	1976-11-21 00:00:00	32020		\N	335470	0	301011002	4116491		0
74437	4418	28060	1996-10-09	1996-10-09 00:00:00	1996-10-22	1996-10-22 00:00:00	32020		\N	293720	0	43878008	28060		0
74641	4433	81151	1940-02-11	1940-02-11 00:00:00	1940-02-25	1940-02-25 00:00:00	32020		\N	294725	0	44465007	81151		0
64212	3791	260139	2000-07-04	2000-07-04 00:00:00	2000-07-11	2000-07-11 00:00:00	32020		\N	252086	0	10509002	260139		0
64375	3803	40481087	2006-10-25	2006-10-25 00:00:00	2006-11-15	2006-11-15 00:00:00	32020		\N	252806	0	444814009	40481087		0
64488	3811	40481087	1960-01-25	1960-01-25 00:00:00	1960-02-01	1960-02-01 00:00:00	32020		\N	253118	0	444814009	40481087		0
75219	4467	81893	1986-01-15	1986-01-15 00:00:00	\N	\N	32020		\N	297184	0	64766004	81893		0
64768	3830	4112343	1987-03-01	1987-03-01 00:00:00	1987-03-10	1987-03-10 00:00:00	32020		\N	254290	0	195662009	4112343		0
65003	3844	4112343	1965-10-22	1965-10-22 00:00:00	1965-11-02	1965-11-02 00:00:00	32020		\N	255126	0	195662009	4112343		0
65130	3852	4112343	1968-11-10	1968-11-10 00:00:00	1968-11-21	1968-11-21 00:00:00	32020		\N	255707	0	195662009	4112343		0
65323	3862	260139	1995-04-20	1995-04-20 00:00:00	1995-05-04	1995-05-04 00:00:00	32020		\N	256381	0	10509002	260139		0
65521	3875	378001	2013-04-27	2013-04-27 00:00:00	2013-06-26	2013-06-26 00:00:00	32020		\N	257382	0	62106007	378001		0
76238	4523	372328	2017-12-15	2017-12-15 00:00:00	2018-02-04	2018-02-04 00:00:00	32020		\N	301197	0	65363002	372328		0
76409	4531	4329847	2017-04-29	2017-04-29 00:00:00	\N	\N	32020		\N	301711	0	22298006	4329847		0
66027	3904	4152936	2006-01-01	2006-01-01 00:00:00	2006-01-22	2006-01-22 00:00:00	32020		\N	259644	0	283385000	4152936		0
66223	3920	40481087	1981-09-22	1981-09-22 00:00:00	1981-10-06	1981-10-06 00:00:00	32020		\N	260669	0	444814009	40481087		0
66379	3929	4310024	1988-05-26	1988-05-26 00:00:00	\N	\N	32020		\N	261161	0	424802006	4310024		0
66478	3935	4112343	1957-01-04	1957-01-04 00:00:00	1957-01-17	1957-01-17 00:00:00	32020		\N	261558	0	195662009	4112343		0
77266	4577	40479422	2002-03-31	2002-03-31 00:00:00	2002-06-06	2002-06-06 00:00:00	32020		\N	304857	0	444448004	40479422		0
66895	3956	260139	1932-12-26	1932-12-26 00:00:00	1933-01-09	1933-01-09 00:00:00	32020		\N	262975	0	10509002	260139		0
67056	3966	81151	1974-05-02	1974-05-02 00:00:00	1974-05-16	1974-05-16 00:00:00	32020		\N	263662	0	44465007	81151		0
67208	3972	4112343	2012-12-05	2012-12-05 00:00:00	2012-12-14	2012-12-14 00:00:00	32020		\N	264096	0	195662009	4112343		0
78013	4622	260139	1983-01-06	1983-01-06 00:00:00	1983-01-20	1983-01-20 00:00:00	32020		\N	307833	0	10509002	260139		0
67548	3991	4266809	1981-08-11	1981-08-11 00:00:00	\N	\N	32020		\N	265359	0	397881000	4266809		0
67667	3997	260139	2001-04-01	2001-04-01 00:00:00	2001-04-15	2001-04-15 00:00:00	32020		\N	265740	0	10509002	260139		0
67838	4009	372328	1954-09-04	1954-09-04 00:00:00	1955-06-08	1955-06-08 00:00:00	32020		\N	266385	0	65363002	372328		0
68045	4019	260139	2012-03-06	2012-03-06 00:00:00	2012-03-20	2012-03-20 00:00:00	32020		\N	267141	0	10509002	260139		0
68164	4026	260139	2003-01-20	2003-01-20 00:00:00	2003-01-27	2003-01-27 00:00:00	32020		\N	267713	0	10509002	260139		0
78922	4675	260139	1930-05-20	1930-05-20 00:00:00	1930-06-03	1930-06-03 00:00:00	32020		\N	311493	0	10509002	260139		0
68538	4052	40481087	1988-02-18	1988-02-18 00:00:00	1988-03-10	1988-03-10 00:00:00	32020		\N	269294	0	444814009	40481087		0
79208	4689	40481087	1971-05-11	1971-05-11 00:00:00	1971-06-01	1971-06-01 00:00:00	32020		\N	312377	0	444814009	40481087		0
79379	4701	372328	1973-12-22	1973-12-22 00:00:00	1974-05-03	1974-05-03 00:00:00	32020		\N	313129	0	65363002	372328		0
68949	4080	378001	1989-01-17	1989-01-17 00:00:00	1989-02-16	1989-02-16 00:00:00	32020		\N	271174	0	62106007	378001		0
69160	4091	4112343	1979-12-19	1979-12-19 00:00:00	1979-12-31	1979-12-31 00:00:00	32020		\N	271947	0	195662009	4112343		0
79940	4736	260139	1987-10-29	1987-10-29 00:00:00	1987-11-05	1987-11-05 00:00:00	32020		\N	315484	0	10509002	260139		0
69394	4106	4112343	1989-04-21	1989-04-21 00:00:00	1989-05-03	1989-05-03 00:00:00	32020		\N	272785	0	195662009	4112343		0
69602	4119	257012	1997-07-25	1997-07-25 00:00:00	\N	\N	32020		\N	273869	0	40055000	257012		0
80370	4760	28060	1979-07-08	1979-07-08 00:00:00	1979-07-19	1979-07-19 00:00:00	32020		\N	317144	0	43878008	28060		0
70140	4153	4027663	1993-02-04	1993-02-04 00:00:00	\N	\N	32020		\N	276064	0	13200003	4027663		0
80885	4799	28060	1998-08-25	1998-08-25 00:00:00	1998-09-02	1998-09-02 00:00:00	32020		\N	319262	0	43878008	28060		0
81134	4812	40481087	1978-12-04	1978-12-04 00:00:00	1978-12-11	1978-12-11 00:00:00	32020		\N	320125	0	444814009	40481087		0
81267	4819	40481087	2016-12-30	2016-12-30 00:00:00	2017-01-20	2017-01-20 00:00:00	32020		\N	320518	0	444814009	40481087		0
70867	4204	378001	1971-05-26	1971-05-26 00:00:00	1971-06-25	1971-06-25 00:00:00	32020		\N	279064	0	62106007	378001		0
70978	4210	4283893	2001-12-04	2001-12-04 00:00:00	2002-01-29	2002-01-29 00:00:00	32020		\N	279522	0	36971009	4283893		0
71054	4214	372328	1978-06-23	1978-06-23 00:00:00	1978-11-14	1978-11-14 00:00:00	32020		\N	279776	0	65363002	372328		0
71326	4229	260139	2011-10-20	2011-10-20 00:00:00	2011-10-27	2011-10-27 00:00:00	32020		\N	280903	0	10509002	260139		0
71460	4239	40481087	2013-06-02	2013-06-02 00:00:00	2013-06-09	2013-06-09 00:00:00	32020		\N	281577	0	444814009	40481087		0
82184	4873	4285898	2018-04-27	2018-04-27 00:00:00	\N	\N	32020		\N	324114	0	68496003	4285898		0
71814	4260	260139	1976-12-15	1976-12-15 00:00:00	1976-12-22	1976-12-22 00:00:00	32020		\N	282785	0	10509002	260139		0
71959	4270	4048695	1992-01-06	1992-01-06 00:00:00	1992-02-06	1992-02-06 00:00:00	32020		\N	283416	0	15724005	4048695		0
72097	4278	40481087	1957-11-16	1957-11-16 00:00:00	1957-12-07	1957-12-07 00:00:00	32020		\N	283880	0	444814009	40481087		0
72264	4288	28060	2010-03-07	2010-03-07 00:00:00	2010-03-18	2010-03-18 00:00:00	32020		\N	284717	0	43878008	28060		0
83047	4933	4294548	1997-11-04	1997-11-04 00:00:00	1997-11-11	1997-11-11 00:00:00	32020		\N	327929	0	75498004	4294548		0
83182	4942	81151	1994-10-13	1994-10-13 00:00:00	1994-11-03	1994-11-03 00:00:00	32020		\N	328466	0	44465007	81151		0
72831	4329	4059173	1991-09-20	1991-09-20 00:00:00	1991-12-18	1991-12-18 00:00:00	32020		\N	287105	0	16114001	4059173		0
83632	4970	80180	1958-11-25	1958-11-25 00:00:00	\N	\N	32020		\N	330350	0	396275006	80180		0
83675	4972	4112343	1963-12-22	1963-12-22 00:00:00	1964-01-02	1964-01-02 00:00:00	32020		\N	330702	0	195662009	4112343		0
73331	4359	4112343	2006-06-14	2006-06-14 00:00:00	2006-06-26	2006-06-26 00:00:00	32020		\N	289179	0	195662009	4112343		0
84053	4991	4112343	2009-03-04	2009-03-04 00:00:00	2009-03-13	2009-03-13 00:00:00	32020		\N	332075	0	195662009	4112343		0
73586	4374	4156265	2003-12-16	2003-12-16 00:00:00	2004-01-06	2004-01-06 00:00:00	32020		\N	290538	0	370247008	4156265		0
84360	5014	40481087	1995-11-05	1995-11-05 00:00:00	1995-11-19	1995-11-19 00:00:00	32020		\N	333315	0	444814009	40481087		0
84594	5031	40481087	2011-03-27	2011-03-27 00:00:00	2011-04-10	2011-04-10 00:00:00	32020		\N	334321	0	444814009	40481087		0
84672	5035	80180	1969-06-07	1969-06-07 00:00:00	\N	\N	32020		\N	334625	0	396275006	80180		0
84886	5048	4156265	2007-12-23	2007-12-23 00:00:00	2008-01-06	2008-01-06 00:00:00	32020		\N	335505	0	370247008	4156265		0
74438	4418	378001	1957-06-07	1957-06-07 00:00:00	1957-07-07	1957-07-07 00:00:00	32020		\N	293744	0	62106007	378001		0
74642	4433	4134304	2015-12-12	2015-12-12 00:00:00	2016-03-11	2016-03-11 00:00:00	32020		\N	294731	0	263102004	4134304		0
64213	3791	40481087	1967-01-29	1967-01-29 00:00:00	1967-02-05	1967-02-05 00:00:00	32020		\N	252047	0	444814009	40481087		0
64376	3803	40481087	2016-09-04	2016-09-04 00:00:00	2016-09-18	2016-09-18 00:00:00	32020		\N	252808	0	444814009	40481087		0
64489	3811	40481087	1946-04-05	1946-04-05 00:00:00	1946-04-12	1946-04-12 00:00:00	32020		\N	253213	0	444814009	40481087		0
75220	4467	80180	1987-07-09	1987-07-09 00:00:00	\N	\N	32020		\N	297204	0	396275006	80180		0
64769	3831	80180	1991-04-11	1991-04-11 00:00:00	\N	\N	32020		\N	254349	0	396275006	80180		0
65004	3844	40481087	1984-09-03	1984-09-03 00:00:00	1984-09-10	1984-09-10 00:00:00	32020		\N	255158	0	444814009	40481087		0
65131	3852	40481087	1956-12-19	1956-12-19 00:00:00	1957-01-09	1957-01-09 00:00:00	32020		\N	255706	0	444814009	40481087		0
65324	3862	4294548	1995-10-14	1995-10-14 00:00:00	1996-03-09	1996-03-09 00:00:00	32020		\N	256393	0	75498004	4294548		0
65522	3875	260139	1982-02-09	1982-02-09 00:00:00	1982-02-23	1982-02-23 00:00:00	32020		\N	257395	0	10509002	260139		0
76239	4523	40481087	2008-07-13	2008-07-13 00:00:00	2008-07-27	2008-07-27 00:00:00	32020		\N	301201	0	444814009	40481087		0
76411	4531	4112343	1923-10-12	1923-10-12 00:00:00	1923-10-23	1923-10-23 00:00:00	32020		\N	301736	0	195662009	4112343		0
66028	3904	4116491	2005-02-15	2005-02-15 00:00:00	2005-04-05	2005-04-05 00:00:00	32020		\N	259638	0	301011002	4116491		0
66224	3920	40481087	1977-07-07	1977-07-07 00:00:00	1977-07-21	1977-07-21 00:00:00	32020		\N	260687	0	444814009	40481087		0
66380	3929	80180	1989-10-18	1989-10-18 00:00:00	\N	\N	32020		\N	261161	0	396275006	80180		0
66479	3935	40481087	1956-12-28	1956-12-28 00:00:00	1957-01-11	1957-01-11 00:00:00	32020		\N	261564	0	444814009	40481087		0
77267	4577	40481087	2018-03-31	2018-03-31 00:00:00	2018-04-21	2018-04-21 00:00:00	32020		\N	304889	0	444814009	40481087		0
66896	3956	40481087	1986-12-21	1986-12-21 00:00:00	1986-12-28	1986-12-28 00:00:00	32020		\N	263029	0	444814009	40481087		0
64399	3803	257012	2014-10-11	2014-10-11 00:00:00	\N	\N	32020		\N	252807	0	40055000	257012		0
67057	3966	378001	1987-05-22	1987-05-22 00:00:00	1987-06-21	1987-06-21 00:00:00	32020		\N	263664	0	62106007	378001		0
67209	3972	30753	1998-09-28	1998-09-28 00:00:00	\N	\N	32020		\N	264116	0	16761005	30753		0
78014	4622	372328	1966-06-19	1966-06-19 00:00:00	1967-02-09	1967-02-09 00:00:00	32020		\N	307798	0	65363002	372328		0
67549	3991	80180	1981-08-11	1981-08-11 00:00:00	\N	\N	32020		\N	265359	0	396275006	80180		0
67668	3997	4112343	1969-12-04	1969-12-04 00:00:00	1969-12-12	1969-12-12 00:00:00	32020		\N	265729	0	195662009	4112343		0
67839	4009	4218389	1951-09-03	1951-09-03 00:00:00	1951-10-07	1951-10-07 00:00:00	32020		\N	266439	0	39848009	4218389		0
68046	4019	372328	1966-11-06	1966-11-06 00:00:00	1967-11-07	1967-11-07 00:00:00	32020		\N	267154	0	65363002	372328		0
68165	4026	4134304	1962-11-01	1962-11-01 00:00:00	1962-12-01	1962-12-01 00:00:00	32020		\N	267690	0	263102004	4134304		0
78923	4675	4112343	1921-10-19	1921-10-19 00:00:00	1921-11-01	1921-11-01 00:00:00	32020		\N	311427	0	195662009	4112343		0
68539	4052	372328	1985-07-20	1985-07-20 00:00:00	1986-02-20	1986-02-20 00:00:00	32020		\N	269348	0	65363002	372328		0
79209	4689	4112343	2001-10-31	2001-10-31 00:00:00	2001-11-13	2001-11-13 00:00:00	32020		\N	312406	0	195662009	4112343		0
79380	4701	378001	2003-02-17	2003-02-17 00:00:00	2003-03-19	2003-03-19 00:00:00	32020		\N	313173	0	62106007	378001		0
68950	4081	257012	1998-02-28	1998-02-28 00:00:00	1998-05-02	1998-05-02 00:00:00	32020		\N	271248	0	40055000	257012		0
69161	4092	372328	1976-11-18	1976-11-18 00:00:00	1977-05-12	1977-05-12 00:00:00	32020		\N	272023	0	65363002	372328		0
79941	4736	372328	1974-11-04	1974-11-04 00:00:00	1975-05-16	1975-05-16 00:00:00	32020		\N	315503	0	65363002	372328		0
69395	4106	28060	1944-07-05	1944-07-05 00:00:00	1944-07-17	1944-07-17 00:00:00	32020		\N	272831	0	43878008	28060		0
69603	4119	80180	1984-08-26	1984-08-26 00:00:00	\N	\N	32020		\N	273890	0	396275006	80180		0
80371	4760	40481087	1984-05-02	1984-05-02 00:00:00	1984-05-16	1984-05-16 00:00:00	32020		\N	317122	0	444814009	40481087		0
70141	4153	40481087	1979-06-02	1979-06-02 00:00:00	1979-06-09	1979-06-09 00:00:00	32020		\N	276029	0	444814009	40481087		0
80886	4799	4134304	1977-01-10	1977-01-10 00:00:00	1977-03-11	1977-03-11 00:00:00	32020		\N	319245	0	263102004	4134304		0
81135	4812	40481087	1973-02-11	1973-02-11 00:00:00	1973-02-25	1973-02-25 00:00:00	32020		\N	320108	0	444814009	40481087		0
81268	4820	257012	2009-03-13	2009-03-13 00:00:00	\N	\N	32020		\N	320670	0	40055000	257012		0
70868	4204	40481087	2017-02-07	2017-02-07 00:00:00	2017-02-21	2017-02-21 00:00:00	32020		\N	279085	0	444814009	40481087		0
70979	4210	257012	2002-01-08	2002-01-08 00:00:00	\N	\N	32020		\N	279564	0	40055000	257012		0
71055	4214	30753	2004-11-15	2004-11-15 00:00:00	\N	\N	32020		\N	279794	0	16761005	30753		0
71327	4229	4112343	1983-03-21	1983-03-21 00:00:00	1983-03-31	1983-03-31 00:00:00	32020		\N	280956	0	195662009	4112343		0
71461	4239	372328	1951-03-14	1951-03-14 00:00:00	1951-09-01	1951-09-01 00:00:00	32020		\N	281491	0	65363002	372328		0
82185	4873	40481087	2017-11-30	2017-11-30 00:00:00	2017-12-21	2017-12-21 00:00:00	32020		\N	324114	0	444814009	40481087		0
71815	4260	40481087	2003-05-05	2003-05-05 00:00:00	2003-05-26	2003-05-26 00:00:00	32020		\N	282838	0	444814009	40481087		0
71960	4270	4112343	1991-03-15	1991-03-15 00:00:00	1991-03-22	1991-03-22 00:00:00	32020		\N	283435	0	195662009	4112343		0
72098	4278	4043241	2017-12-01	2017-12-01 00:00:00	\N	\N	32020		\N	283943	0	230265002	4043241		0
72265	4288	4146173	1963-10-05	1963-10-05 00:00:00	1963-12-04	1963-12-04 00:00:00	32020		\N	284662	0	307731004	4146173		0
83048	4933	4059173	1980-03-03	1980-03-03 00:00:00	1980-06-01	1980-06-01 00:00:00	32020		\N	327967	0	16114001	4059173		0
83183	4942	4112343	1979-04-15	1979-04-15 00:00:00	1979-04-28	1979-04-28 00:00:00	32020		\N	328523	0	195662009	4112343		0
72832	4329	81151	1981-03-17	1981-03-17 00:00:00	1981-04-14	1981-04-14 00:00:00	32020		\N	287104	0	44465007	81151		0
83633	4970	4112343	1959-07-21	1959-07-21 00:00:00	1959-07-28	1959-07-28 00:00:00	32020		\N	330357	0	195662009	4112343		0
83676	4972	372328	1956-01-17	1956-01-17 00:00:00	1956-12-29	1956-12-29 00:00:00	32020		\N	330692	0	65363002	372328		0
73332	4359	257012	1968-08-13	1968-08-13 00:00:00	\N	\N	32020		\N	289189	0	40055000	257012		0
84054	4991	4283893	1983-10-14	1983-10-14 00:00:00	1984-02-17	1984-02-17 00:00:00	32020		\N	332072	0	36971009	4283893		0
73587	4374	4027663	2006-05-13	2006-05-13 00:00:00	\N	\N	32020		\N	290538	0	13200003	4027663		0
84361	5014	30753	1947-07-27	1947-07-27 00:00:00	\N	\N	32020		\N	333314	0	16761005	30753		0
84595	5031	372328	1924-08-03	1924-08-03 00:00:00	1925-01-17	1925-01-17 00:00:00	32020		\N	334357	0	65363002	372328		0
84673	5035	40481087	1968-02-11	1968-02-11 00:00:00	1968-03-03	1968-03-03 00:00:00	32020		\N	334625	0	444814009	40481087		0
84887	5048	372328	1964-09-06	1964-09-06 00:00:00	1965-08-13	1965-08-13 00:00:00	32020		\N	335446	0	65363002	372328		0
74439	4418	317576	2008-02-01	2008-02-01 00:00:00	\N	\N	32020		\N	293696	0	53741008	317576		0
74643	4433	40481087	1941-06-14	1941-06-14 00:00:00	1941-06-21	1941-06-21 00:00:00	32020		\N	294700	0	444814009	40481087		0
64214	3791	4237458	1980-11-22	1980-11-22 00:00:00	1981-01-21	1981-01-21 00:00:00	32020		\N	252160	0	58150001	4237458		0
64377	3803	80180	2003-12-24	2003-12-24 00:00:00	\N	\N	32020		\N	252766	0	396275006	80180		0
64490	3811	4112343	1948-03-20	1948-03-20 00:00:00	1948-03-31	1948-03-31 00:00:00	32020		\N	253117	0	195662009	4112343		0
75221	4467	4116491	1987-06-19	1987-06-19 00:00:00	1987-08-02	1987-08-02 00:00:00	32020		\N	297204	0	301011002	4116491		0
64770	3831	81893	1990-09-13	1990-09-13 00:00:00	\N	\N	32020		\N	254330	0	64766004	81893		0
65005	3844	4155034	1985-09-03	1985-09-03 00:00:00	1985-09-24	1985-09-24 00:00:00	32020		\N	255130	0	283371005	4155034		0
65132	3852	80180	1990-03-17	1990-03-17 00:00:00	\N	\N	32020		\N	255651	0	396275006	80180		0
65325	3862	40481087	2005-07-20	2005-07-20 00:00:00	2005-08-03	2005-08-03 00:00:00	32020		\N	256395	0	444814009	40481087		0
65523	3875	4116491	2009-12-19	2009-12-19 00:00:00	2010-01-30	2010-01-30 00:00:00	32020		\N	257328	0	301011002	4116491		0
76240	4523	81151	1994-07-24	1994-07-24 00:00:00	1994-08-21	1994-08-21 00:00:00	32020		\N	301155	0	44465007	81151		0
76412	4531	4059173	1995-04-20	1995-04-20 00:00:00	1995-05-20	1995-05-20 00:00:00	32020		\N	301708	0	16114001	4059173		0
66029	3904	40481087	2013-08-01	2013-08-01 00:00:00	2013-08-22	2013-08-22 00:00:00	32020		\N	259611	0	444814009	40481087		0
66225	3920	40481087	1986-01-20	1986-01-20 00:00:00	1986-01-27	1986-01-27 00:00:00	32020		\N	260670	0	444814009	40481087		0
66381	3929	4285898	1989-08-19	1989-08-19 00:00:00	\N	\N	32020		\N	261161	0	68496003	4285898		0
66480	3935	78272	1968-05-28	1968-05-28 00:00:00	1968-06-25	1968-06-25 00:00:00	32020		\N	261542	0	70704007	78272		0
77268	4577	80180	2019-03-17	2019-03-17 00:00:00	\N	\N	32020		\N	304889	0	396275006	80180		0
66897	3956	40481087	2008-03-12	2008-03-12 00:00:00	2008-04-02	2008-04-02 00:00:00	32020		\N	263000	0	444814009	40481087		0
67058	3966	378001	2008-03-02	2008-03-02 00:00:00	2008-04-01	2008-04-01 00:00:00	32020		\N	263665	0	62106007	378001		0
67210	3972	81893	1998-03-02	1998-03-02 00:00:00	\N	\N	32020		\N	264116	0	64766004	81893		0
78015	4622	40481087	1999-10-13	1999-10-13 00:00:00	1999-11-03	1999-11-03 00:00:00	32020		\N	307782	0	444814009	40481087		0
67550	3991	4285898	1981-05-13	1981-05-13 00:00:00	\N	\N	32020		\N	265359	0	68496003	4285898		0
67669	3997	28060	1969-08-23	1969-08-23 00:00:00	1969-09-01	1969-09-01 00:00:00	32020		\N	265728	0	43878008	28060		0
67840	4009	40481087	1987-06-13	1987-06-13 00:00:00	1987-07-04	1987-07-04 00:00:00	32020		\N	266380	0	444814009	40481087		0
68047	4019	4112343	1985-10-20	1985-10-20 00:00:00	1985-10-27	1985-10-27 00:00:00	32020		\N	267162	0	195662009	4112343		0
68166	4026	81151	2009-10-07	2009-10-07 00:00:00	2009-11-11	2009-11-11 00:00:00	32020		\N	267635	0	44465007	81151		0
78924	4675	4112343	2009-02-02	2009-02-02 00:00:00	2009-02-14	2009-02-14 00:00:00	32020		\N	311555	0	195662009	4112343		0
77692	4603	80180	1970-01-24	1970-01-24 00:00:00	\N	\N	32020		\N	306620	0	396275006	80180		0
68540	4052	260139	1995-01-15	1995-01-15 00:00:00	1995-01-22	1995-01-22 00:00:00	32020		\N	269344	0	10509002	260139		0
79210	4689	40481087	2009-11-24	2009-11-24 00:00:00	2009-12-15	2009-12-15 00:00:00	32020		\N	312408	0	444814009	40481087		0
79381	4701	78272	1990-07-04	1990-07-04 00:00:00	1990-07-25	1990-07-25 00:00:00	32020		\N	313172	0	70704007	78272		0
68951	4081	40481087	2000-06-27	2000-06-27 00:00:00	2000-07-04	2000-07-04 00:00:00	32020		\N	271264	0	444814009	40481087		0
69162	4092	4112343	1973-10-09	1973-10-09 00:00:00	1973-10-21	1973-10-21 00:00:00	32020		\N	272019	0	195662009	4112343		0
79951	4738	4218389	1924-03-02	1924-03-02 00:00:00	1924-03-30	1924-03-30 00:00:00	32020		\N	315652	0	39848009	4218389		0
69396	4107	80180	2014-08-16	2014-08-16 00:00:00	\N	\N	32020		\N	272888	0	396275006	80180		0
69604	4119	40481087	1984-08-12	1984-08-12 00:00:00	1984-08-19	1984-08-19 00:00:00	32020		\N	273890	0	444814009	40481087		0
80372	4760	260139	1985-06-27	1985-06-27 00:00:00	1985-07-12	1985-07-12 00:00:00	32020		\N	317122	0	10509002	260139		0
70142	4153	260139	2018-01-21	2018-01-21 00:00:00	2018-01-28	2018-01-28 00:00:00	32020		\N	276040	0	10509002	260139		0
80887	4799	260139	1963-12-16	1963-12-16 00:00:00	1963-12-23	1963-12-23 00:00:00	32020		\N	319284	0	10509002	260139		0
81136	4812	4146173	2000-01-02	2000-01-02 00:00:00	2000-03-02	2000-03-02 00:00:00	32020		\N	320127	0	307731004	4146173		0
81269	4820	40481087	1990-08-29	1990-08-29 00:00:00	1990-09-12	1990-09-12 00:00:00	32020		\N	320653	0	444814009	40481087		0
70869	4204	4285898	1988-02-26	1988-02-26 00:00:00	\N	\N	32020		\N	279111	0	68496003	4285898		0
70980	4210	40481087	1992-06-28	1992-06-28 00:00:00	1992-07-19	1992-07-19 00:00:00	32020		\N	279515	0	444814009	40481087		0
71086	4217	4027663	1989-08-05	1989-08-05 00:00:00	\N	\N	32020		\N	279932	0	13200003	4027663		0
71328	4229	4218389	1995-07-30	1995-07-30 00:00:00	1995-09-03	1995-09-03 00:00:00	32020		\N	280924	0	39848009	4218389		0
71462	4239	4112343	1972-01-21	1972-01-21 00:00:00	1972-01-31	1972-01-31 00:00:00	32020		\N	281520	0	195662009	4112343		0
82186	4873	195588	1996-07-11	1996-07-11 00:00:00	1996-08-11	1996-08-11 00:00:00	32020		\N	324112	0	38822007	195588		0
71816	4260	40481087	1973-10-28	1973-10-28 00:00:00	1973-11-18	1973-11-18 00:00:00	32020		\N	282784	0	444814009	40481087		0
71961	4270	40481087	1989-04-28	1989-04-28 00:00:00	1989-05-05	1989-05-05 00:00:00	32020		\N	283449	0	444814009	40481087		0
72099	4278	4113008	1959-02-05	1959-02-05 00:00:00	1959-02-26	1959-02-26 00:00:00	32020		\N	283930	0	284549007	4113008		0
72266	4288	40481087	1952-12-10	1952-12-10 00:00:00	1952-12-24	1952-12-24 00:00:00	32020		\N	284713	0	444814009	40481087		0
83049	4933	4112343	1984-08-01	1984-08-01 00:00:00	1984-08-13	1984-08-13 00:00:00	32020		\N	327972	0	195662009	4112343		0
83184	4942	4027663	1979-04-23	1979-04-23 00:00:00	\N	\N	32020		\N	328523	0	13200003	4027663		0
72833	4329	372328	1982-05-25	1982-05-25 00:00:00	1982-10-31	1982-10-31 00:00:00	32020		\N	287107	0	65363002	372328		0
83634	4970	4278672	1962-06-27	1962-06-27 00:00:00	1962-07-27	1962-07-27 00:00:00	32020		\N	330395	0	65966004	4278672		0
83677	4972	40481087	2016-12-14	2016-12-14 00:00:00	2016-12-28	2016-12-28 00:00:00	32020		\N	330671	0	444814009	40481087		0
73333	4359	260139	1991-02-08	1991-02-08 00:00:00	1991-02-15	1991-02-15 00:00:00	32020		\N	289251	0	10509002	260139		0
84055	4991	4112343	2005-07-08	2005-07-08 00:00:00	2005-07-21	2005-07-21 00:00:00	32020		\N	332023	0	195662009	4112343		0
73588	4374	40481087	2013-11-16	2013-11-16 00:00:00	2013-11-23	2013-11-23 00:00:00	32020		\N	290568	0	444814009	40481087		0
84362	5014	40481087	1947-06-07	1947-06-07 00:00:00	1947-06-28	1947-06-28 00:00:00	32020		\N	333314	0	444814009	40481087		0
84596	5031	4112343	2018-10-18	2018-10-18 00:00:00	2018-10-31	2018-10-31 00:00:00	32020		\N	334291	0	195662009	4112343		0
84674	5035	4266809	1969-06-07	1969-06-07 00:00:00	\N	\N	32020		\N	334625	0	397881000	4266809		0
84888	5048	4155034	1975-11-22	1975-11-22 00:00:00	1975-12-06	1975-12-06 00:00:00	32020		\N	335502	0	283371005	4155034		0
74440	4418	80180	1993-05-07	1993-05-07 00:00:00	\N	\N	32020		\N	293731	0	396275006	80180		0
74644	4433	4112343	1951-01-01	1951-01-01 00:00:00	1951-01-13	1951-01-13 00:00:00	32020		\N	294665	0	195662009	4112343		0
64215	3791	40481087	1989-04-05	1989-04-05 00:00:00	1989-04-26	1989-04-26 00:00:00	32020		\N	252056	0	444814009	40481087		0
64378	3803	30753	2003-06-27	2003-06-27 00:00:00	\N	\N	32020		\N	252766	0	16761005	30753		0
64491	3811	4294548	1942-07-09	1942-07-09 00:00:00	1942-07-16	1942-07-16 00:00:00	32020		\N	253212	0	75498004	4294548		0
75239	4470	372328	1972-02-08	1972-02-08 00:00:00	1972-04-16	1972-04-16 00:00:00	32020		\N	297364	0	65363002	372328		0
64771	3831	40481087	1990-02-03	1990-02-03 00:00:00	1990-02-24	1990-02-24 00:00:00	32020		\N	254330	0	444814009	40481087		0
65006	3844	260139	1975-07-01	1975-07-01 00:00:00	1975-07-15	1975-07-15 00:00:00	32020		\N	255132	0	10509002	260139		0
65133	3852	4278672	1964-12-28	1964-12-28 00:00:00	1965-01-27	1965-01-27 00:00:00	32020		\N	255631	0	65966004	4278672		0
65326	3862	40481087	1958-04-28	1958-04-28 00:00:00	1958-05-19	1958-05-19 00:00:00	32020		\N	256377	0	444814009	40481087		0
65524	3875	195588	2005-11-11	2005-11-11 00:00:00	2005-12-20	2005-12-20 00:00:00	32020		\N	257346	0	38822007	195588		0
76241	4523	4218389	1984-01-13	1984-01-13 00:00:00	1984-02-17	1984-02-17 00:00:00	32020		\N	301153	0	39848009	4218389		0
76413	4531	381316	1965-01-09	1965-01-09 00:00:00	\N	\N	32020		\N	301695	0	230690007	381316		0
66030	3904	260139	2009-06-09	2009-06-09 00:00:00	2009-06-16	2009-06-16 00:00:00	32020		\N	259626	0	10509002	260139		0
66226	3920	4218389	2012-11-24	2012-11-24 00:00:00	2012-12-29	2012-12-29 00:00:00	32020		\N	260686	0	39848009	4218389		0
66382	3929	40481087	1964-06-11	1964-06-11 00:00:00	1964-06-18	1964-06-18 00:00:00	32020		\N	261197	0	444814009	40481087		0
66481	3935	80180	1982-10-16	1982-10-16 00:00:00	\N	\N	32020		\N	261561	0	396275006	80180		0
77269	4577	40481087	1987-12-21	1987-12-21 00:00:00	1988-01-04	1988-01-04 00:00:00	32020		\N	304886	0	444814009	40481087		0
66898	3956	40481087	1959-11-15	1959-11-15 00:00:00	1959-11-22	1959-11-22 00:00:00	32020		\N	262940	0	444814009	40481087		0
67059	3966	4112343	2004-09-25	2004-09-25 00:00:00	2004-10-05	2004-10-05 00:00:00	32020		\N	263695	0	195662009	4112343		0
67211	3973	313217	2018-08-30	2018-08-30 00:00:00	\N	\N	32020		\N	264215	0	49436004	313217		0
78016	4622	28060	1968-11-04	1968-11-04 00:00:00	1968-11-15	1968-11-15 00:00:00	32020		\N	307814	0	43878008	28060		0
67551	3991	28060	1972-02-22	1972-02-22 00:00:00	1972-02-29	1972-02-29 00:00:00	32020		\N	265342	0	43878008	28060		0
67670	3997	4112343	1981-03-16	1981-03-16 00:00:00	1981-03-28	1981-03-28 00:00:00	32020		\N	265737	0	195662009	4112343		0
67841	4009	260139	1956-07-18	1956-07-18 00:00:00	1956-07-25	1956-07-25 00:00:00	32020		\N	266378	0	10509002	260139		0
68048	4019	40481087	2018-11-02	2018-11-02 00:00:00	2018-11-16	2018-11-16 00:00:00	32020		\N	267153	0	444814009	40481087		0
68167	4026	4027663	1988-01-19	1988-01-19 00:00:00	\N	\N	32020		\N	267664	0	13200003	4027663		0
78925	4675	375671	1959-06-23	1959-06-23 00:00:00	1959-08-22	1959-08-22 00:00:00	32020		\N	311506	0	62564004	375671		0
68541	4052	133834	1977-11-13	1977-11-13 00:00:00	\N	\N	32020		\N	269316	0	24079001	133834		0
79211	4689	372328	1969-04-29	1969-04-29 00:00:00	1969-10-15	1969-10-15 00:00:00	32020		\N	312416	0	65363002	372328		0
79382	4701	260139	1975-06-06	1975-06-06 00:00:00	1975-06-20	1975-06-20 00:00:00	32020		\N	313134	0	10509002	260139		0
68952	4081	40481087	2013-11-18	2013-11-18 00:00:00	2013-12-09	2013-12-09 00:00:00	32020		\N	271249	0	444814009	40481087		0
69163	4092	260139	1987-09-24	1987-09-24 00:00:00	1987-10-08	1987-10-08 00:00:00	32020		\N	272055	0	10509002	260139		0
79952	4738	40481087	1910-10-21	1910-10-21 00:00:00	1910-11-04	1910-11-04 00:00:00	32020		\N	315661	0	444814009	40481087		0
69397	4107	40481087	2018-12-21	2018-12-21 00:00:00	2018-12-28	2018-12-28 00:00:00	32020		\N	272894	0	444814009	40481087		0
69605	4119	28060	2012-05-08	2012-05-08 00:00:00	2012-05-19	2012-05-19 00:00:00	32020		\N	273793	0	43878008	28060		0
80373	4760	40481087	1969-10-05	1969-10-05 00:00:00	1969-10-12	1969-10-12 00:00:00	32020		\N	317204	0	444814009	40481087		0
70143	4153	40481087	2004-01-05	2004-01-05 00:00:00	2004-01-12	2004-01-12 00:00:00	32020		\N	276065	0	444814009	40481087		0
80888	4799	321042	2010-05-01	2010-05-01 00:00:00	\N	\N	32020		\N	319291	0	410429000	321042		0
81137	4812	80180	1989-12-18	1989-12-18 00:00:00	\N	\N	32020		\N	320159	0	396275006	80180		0
81270	4820	4112343	1974-03-30	1974-03-30 00:00:00	1974-04-12	1974-04-12 00:00:00	32020		\N	320620	0	195662009	4112343		0
70870	4204	4266809	1988-10-23	1988-10-23 00:00:00	\N	\N	32020		\N	279111	0	397881000	4266809		0
70981	4210	4059173	1984-12-18	1984-12-18 00:00:00	1985-03-18	1985-03-18 00:00:00	32020		\N	279577	0	16114001	4059173		0
71087	4217	40481087	1968-07-27	1968-07-27 00:00:00	1968-08-10	1968-08-10 00:00:00	32020		\N	279972	0	444814009	40481087		0
71329	4229	28060	1953-10-16	1953-10-16 00:00:00	1953-10-27	1953-10-27 00:00:00	32020		\N	280900	0	43878008	28060		0
71463	4239	4283893	1968-10-27	1968-10-27 00:00:00	1968-11-24	1968-11-24 00:00:00	32020		\N	281469	0	36971009	4283893		0
82187	4873	372328	1979-06-20	1979-06-20 00:00:00	1979-12-21	1979-12-21 00:00:00	32020		\N	324116	0	65363002	372328		0
71817	4260	40481087	2010-02-23	2010-02-23 00:00:00	2010-03-02	2010-03-02 00:00:00	32020		\N	282789	0	444814009	40481087		0
71962	4270	40481087	2015-11-22	2015-11-22 00:00:00	2015-12-06	2015-12-06 00:00:00	32020		\N	283425	0	444814009	40481087		0
72100	4278	375671	1987-09-18	1987-09-18 00:00:00	1987-11-17	1987-11-17 00:00:00	32020		\N	283933	0	62564004	375671		0
72267	4288	4112343	2006-12-09	2006-12-09 00:00:00	2006-12-19	2006-12-19 00:00:00	32020		\N	284676	0	195662009	4112343		0
83050	4933	257012	1973-01-30	1973-01-30 00:00:00	\N	\N	32020		\N	327940	0	40055000	257012		0
83185	4942	40481087	1992-11-24	1992-11-24 00:00:00	1992-12-15	1992-12-15 00:00:00	32020		\N	328524	0	444814009	40481087		0
72834	4329	260139	2013-12-19	2013-12-19 00:00:00	2013-12-26	2013-12-26 00:00:00	32020		\N	287125	0	10509002	260139		0
83635	4970	260139	1927-02-27	1927-02-27 00:00:00	1927-03-13	1927-03-13 00:00:00	32020		\N	330379	0	10509002	260139		0
83678	4972	80180	1988-09-20	1988-09-20 00:00:00	\N	\N	32020		\N	330736	0	396275006	80180		0
73334	4359	40481087	1999-11-23	1999-11-23 00:00:00	1999-11-30	1999-11-30 00:00:00	32020		\N	289252	0	444814009	40481087		0
84056	4991	40481087	2004-12-23	2004-12-23 00:00:00	2004-12-30	2004-12-30 00:00:00	32020		\N	332059	0	444814009	40481087		0
73589	4374	4112343	1982-08-21	1982-08-21 00:00:00	1982-08-30	1982-08-30 00:00:00	32020		\N	290574	0	195662009	4112343		0
84363	5014	80180	1948-10-19	1948-10-19 00:00:00	\N	\N	32020		\N	333314	0	396275006	80180		0
84597	5031	40481087	1960-08-02	1960-08-02 00:00:00	1960-08-23	1960-08-23 00:00:00	32020		\N	334314	0	444814009	40481087		0
84675	5035	30753	1968-05-13	1968-05-13 00:00:00	\N	\N	32020		\N	334625	0	16761005	30753		0
84889	5048	40481087	1989-04-30	1989-04-30 00:00:00	1989-05-14	1989-05-14 00:00:00	32020		\N	335419	0	444814009	40481087		0
74441	4418	440448	1954-07-27	1954-07-27 00:00:00	\N	\N	32020		\N	293694	0	74400008	440448		0
74645	4433	4310024	1980-12-02	1980-12-02 00:00:00	\N	\N	32020		\N	294677	0	424802006	4310024		0
64216	3791	4155034	1939-05-20	1939-05-20 00:00:00	1939-06-03	1939-06-03 00:00:00	32020		\N	252050	0	283371005	4155034		0
64379	3803	4112343	1973-05-09	1973-05-09 00:00:00	1973-05-20	1973-05-20 00:00:00	32020		\N	252768	0	195662009	4112343		0
64492	3811	28060	1944-12-24	1944-12-24 00:00:00	1945-01-04	1945-01-04 00:00:00	32020		\N	253145	0	43878008	28060		0
75240	4470	4112343	1982-09-15	1982-09-15 00:00:00	1982-09-23	1982-09-23 00:00:00	32020		\N	297332	0	195662009	4112343		0
64772	3831	192671	1991-05-04	1991-05-04 00:00:00	\N	\N	32020		\N	254405	0	K92.2	35208414		0
65007	3844	378001	1955-08-14	1955-08-14 00:00:00	1955-09-13	1955-09-13 00:00:00	32020		\N	255127	0	62106007	378001		0
65134	3852	40481087	1999-02-19	1999-02-19 00:00:00	1999-02-26	1999-02-26 00:00:00	32020		\N	255757	0	444814009	40481087		0
65327	3862	4156265	2011-04-13	2011-04-13 00:00:00	2011-05-04	2011-05-04 00:00:00	32020		\N	256460	0	370247008	4156265		0
65525	3875	4283893	2011-04-06	2011-04-06 00:00:00	2011-11-30	2011-11-30 00:00:00	32020		\N	257388	0	36971009	4283893		0
76253	4525	28060	2013-11-06	2013-11-06 00:00:00	2013-11-19	2013-11-19 00:00:00	32020		\N	301263	0	43878008	28060		0
76414	4531	80502	2004-12-25	2004-12-25 00:00:00	\N	\N	32020		\N	301781	0	64859006	80502		0
66031	3904	372328	1984-12-03	1984-12-03 00:00:00	1985-02-07	1985-02-07 00:00:00	32020		\N	259641	0	65363002	372328		0
66227	3920	372328	1974-05-18	1974-05-18 00:00:00	1974-08-03	1974-08-03 00:00:00	32020		\N	260673	0	65363002	372328		0
66383	3929	372328	1954-01-07	1954-01-07 00:00:00	1954-04-12	1954-04-12 00:00:00	32020		\N	261200	0	65363002	372328		0
66482	3935	260139	1964-06-20	1964-06-20 00:00:00	1964-06-27	1964-06-27 00:00:00	32020		\N	261565	0	10509002	260139		0
77270	4577	372328	1986-01-13	1986-01-13 00:00:00	1986-06-14	1986-06-14 00:00:00	32020		\N	304861	0	65363002	372328		0
77390	4586	260139	1968-05-29	1968-05-29 00:00:00	1968-06-05	1968-06-05 00:00:00	32020		\N	305464	0	10509002	260139		0
67060	3966	4112343	2015-07-13	2015-07-13 00:00:00	2015-07-22	2015-07-22 00:00:00	32020		\N	263652	0	195662009	4112343		0
67212	3973	4112343	1977-05-26	1977-05-26 00:00:00	1977-06-07	1977-06-07 00:00:00	32020		\N	264177	0	195662009	4112343		0
78017	4623	4112343	1996-05-08	1996-05-08 00:00:00	1996-05-19	1996-05-19 00:00:00	32020		\N	307991	0	195662009	4112343		0
67552	3991	257012	1971-02-23	1971-02-23 00:00:00	2005-01-20	2005-01-20 00:00:00	32020		\N	265300	0	40055000	257012		0
67671	3997	40481087	1969-04-18	1969-04-18 00:00:00	1969-05-02	1969-05-02 00:00:00	32020		\N	265764	0	444814009	40481087		0
67842	4009	260139	1984-01-08	1984-01-08 00:00:00	1984-01-15	1984-01-15 00:00:00	32020		\N	266427	0	10509002	260139		0
68049	4019	260139	1992-07-22	1992-07-22 00:00:00	1992-08-05	1992-08-05 00:00:00	32020		\N	267163	0	10509002	260139		0
68168	4026	80180	1998-02-05	1998-02-05 00:00:00	\N	\N	32020		\N	267706	0	396275006	80180		0
78926	4675	40481087	2008-02-17	2008-02-17 00:00:00	2008-03-02	2008-03-02 00:00:00	32020		\N	311554	0	444814009	40481087		0
68542	4053	80180	1999-03-07	1999-03-07 00:00:00	\N	\N	32020		\N	269444	0	396275006	80180		0
79212	4690	81151	1971-11-18	1971-11-18 00:00:00	1971-12-02	1971-12-02 00:00:00	32020		\N	312490	0	44465007	81151		0
79383	4701	4113008	2015-11-11	2015-11-11 00:00:00	2015-12-02	2015-12-02 00:00:00	32020		\N	313174	0	284549007	4113008		0
68953	4081	40481087	1968-06-15	1968-06-15 00:00:00	1968-07-06	1968-07-06 00:00:00	32020		\N	271254	0	444814009	40481087		0
69164	4092	260139	2018-04-09	2018-04-09 00:00:00	2018-04-16	2018-04-16 00:00:00	32020		\N	272049	0	10509002	260139		0
79953	4738	4116491	1935-09-11	1935-09-11 00:00:00	1935-10-16	1935-10-16 00:00:00	32020		\N	315644	0	301011002	4116491		0
69398	4107	4112343	2004-10-25	2004-10-25 00:00:00	2004-11-07	2004-11-07 00:00:00	32020		\N	272929	0	195662009	4112343		0
69606	4119	40481087	1951-04-25	1951-04-25 00:00:00	1951-05-16	1951-05-16 00:00:00	32020		\N	273878	0	444814009	40481087		0
80374	4760	4112343	1982-08-03	1982-08-03 00:00:00	1982-08-16	1982-08-16 00:00:00	32020		\N	317145	0	195662009	4112343		0
70144	4153	4112343	1980-01-27	1980-01-27 00:00:00	1980-02-03	1980-02-03 00:00:00	32020		\N	276049	0	195662009	4112343		0
80890	4799	40481087	1960-12-05	1960-12-05 00:00:00	1960-12-19	1960-12-19 00:00:00	32020		\N	319289	0	444814009	40481087		0
81138	4812	372328	1956-12-13	1956-12-13 00:00:00	1957-03-20	1957-03-20 00:00:00	32020		\N	320140	0	65363002	372328		0
81271	4820	40481087	1960-05-09	1960-05-09 00:00:00	1960-05-16	1960-05-16 00:00:00	32020		\N	320639	0	444814009	40481087		0
70871	4204	80180	1988-10-23	1988-10-23 00:00:00	\N	\N	32020		\N	279111	0	396275006	80180		0
70982	4210	4218389	1995-10-06	1995-10-06 00:00:00	1995-11-10	1995-11-10 00:00:00	32020		\N	279551	0	39848009	4218389		0
71088	4217	260139	1976-06-11	1976-06-11 00:00:00	1976-06-25	1976-06-25 00:00:00	32020		\N	279975	0	10509002	260139		0
71330	4229	372328	1998-01-07	1998-01-07 00:00:00	1998-05-23	1998-05-23 00:00:00	32020		\N	280951	0	65363002	372328		0
71464	4239	40479422	1993-07-29	1993-07-29 00:00:00	1993-10-04	1993-10-04 00:00:00	32020		\N	281507	0	444448004	40479422		0
82188	4873	372328	1978-10-16	1978-10-16 00:00:00	1978-12-22	1978-12-22 00:00:00	32020		\N	324115	0	65363002	372328		0
71818	4260	4112343	1982-09-08	1982-09-08 00:00:00	1982-09-17	1982-09-17 00:00:00	32020		\N	282806	0	195662009	4112343		0
71963	4270	4146173	1987-10-29	1987-10-29 00:00:00	1987-12-28	1987-12-28 00:00:00	32020		\N	283400	0	307731004	4146173		0
72101	4278	4283893	1982-02-19	1982-02-19 00:00:00	1982-05-07	1982-05-07 00:00:00	32020		\N	283937	0	36971009	4283893		0
72268	4288	40481087	1966-11-16	1966-11-16 00:00:00	1966-11-23	1966-11-23 00:00:00	32020		\N	284715	0	444814009	40481087		0
83051	4933	4296204	1974-11-09	1974-11-09 00:00:00	1974-11-30	1974-11-30 00:00:00	32020		\N	327965	0	403190006	4296204		0
83186	4942	4112343	1973-03-04	1973-03-04 00:00:00	1973-03-16	1973-03-16 00:00:00	32020		\N	328503	0	195662009	4112343		0
72835	4329	4112343	2014-06-18	2014-06-18 00:00:00	2014-06-27	2014-06-27 00:00:00	32020		\N	287126	0	195662009	4112343		0
83636	4971	260139	1968-03-06	1968-03-06 00:00:00	1968-03-20	1968-03-20 00:00:00	32020		\N	330548	0	10509002	260139		0
83679	4972	40481087	1968-06-06	1968-06-06 00:00:00	1968-06-13	1968-06-13 00:00:00	32020		\N	330712	0	444814009	40481087		0
73335	4359	80180	1985-02-14	1985-02-14 00:00:00	\N	\N	32020		\N	289196	0	396275006	80180		0
84057	4991	80180	2006-04-12	2006-04-12 00:00:00	\N	\N	32020		\N	332043	0	396275006	80180		0
73590	4374	4112343	1985-02-18	1985-02-18 00:00:00	1985-02-27	1985-02-27 00:00:00	32020		\N	290487	0	195662009	4112343		0
84364	5014	4285898	1948-05-22	1948-05-22 00:00:00	\N	\N	32020		\N	333314	0	68496003	4285898		0
84598	5031	372328	1920-06-06	1920-06-06 00:00:00	1920-07-17	1920-07-17 00:00:00	32020		\N	334292	0	65363002	372328		0
84676	5035	4112343	1940-07-23	1940-07-23 00:00:00	1940-08-01	1940-08-01 00:00:00	32020		\N	334621	0	195662009	4112343		0
84890	5048	40481087	1977-05-20	1977-05-20 00:00:00	1977-06-03	1977-06-03 00:00:00	32020		\N	335418	0	444814009	40481087		0
74442	4418	4166224	1954-07-27	1954-07-27 00:00:00	\N	\N	32020		\N	293694	0	47693006	4166224		0
74646	4433	4285898	1981-09-28	1981-09-28 00:00:00	\N	\N	32020		\N	294691	0	68496003	4285898		0
64217	3791	40481087	2009-06-08	2009-06-08 00:00:00	2009-06-15	2009-06-15 00:00:00	32020		\N	252088	0	444814009	40481087		0
64380	3803	260139	1966-07-12	1966-07-12 00:00:00	1966-07-19	1966-07-19 00:00:00	32020		\N	252803	0	10509002	260139		0
64493	3811	260139	1932-05-17	1932-05-17 00:00:00	1932-05-24	1932-05-24 00:00:00	32020		\N	253143	0	10509002	260139		0
75242	4470	81151	1992-05-23	1992-05-23 00:00:00	1992-06-13	1992-06-13 00:00:00	32020		\N	297387	0	44465007	81151		0
64773	3831	4112343	1955-09-24	1955-09-24 00:00:00	1955-10-06	1955-10-06 00:00:00	32020		\N	254371	0	195662009	4112343		0
65008	3844	260139	1981-04-01	1981-04-01 00:00:00	1981-04-08	1981-04-08 00:00:00	32020		\N	255133	0	10509002	260139		0
65135	3852	4296204	2003-09-19	2003-09-19 00:00:00	2003-10-10	2003-10-10 00:00:00	32020		\N	255633	0	403190006	4296204		0
65328	3862	372328	1957-12-22	1957-12-22 00:00:00	1958-01-05	1958-01-05 00:00:00	32020		\N	256397	0	65363002	372328		0
65526	3875	40481087	1985-06-20	1985-06-20 00:00:00	1985-06-27	1985-06-27 00:00:00	32020		\N	257396	0	444814009	40481087		0
76254	4525	260139	1969-01-26	1969-01-26 00:00:00	1969-02-09	1969-02-09 00:00:00	32020		\N	301268	0	10509002	260139		0
76415	4531	260139	1924-02-26	1924-02-26 00:00:00	1924-03-11	1924-03-11 00:00:00	32020		\N	301682	0	10509002	260139		0
66032	3904	40481087	2008-12-11	2008-12-11 00:00:00	2008-12-18	2008-12-18 00:00:00	32020		\N	259625	0	444814009	40481087		0
66228	3920	372328	1975-08-30	1975-08-30 00:00:00	1975-10-25	1975-10-25 00:00:00	32020		\N	260674	0	65363002	372328		0
66384	3929	260139	1999-12-14	1999-12-14 00:00:00	1999-12-21	1999-12-21 00:00:00	32020		\N	261190	0	10509002	260139		0
66483	3935	40481087	1965-01-28	1965-01-28 00:00:00	1965-02-18	1965-02-18 00:00:00	32020		\N	261566	0	444814009	40481087		0
77271	4577	257012	1988-07-21	1988-07-21 00:00:00	\N	\N	32020		\N	304858	0	40055000	257012		0
77391	4586	80180	1992-06-01	1992-06-01 00:00:00	\N	\N	32020		\N	305521	0	396275006	80180		0
67061	3966	4294548	1971-04-23	1971-04-23 00:00:00	1971-09-10	1971-09-10 00:00:00	32020		\N	263692	0	75498004	4294548		0
67213	3973	440086	1978-07-23	1978-07-23 00:00:00	1986-07-31	1986-07-31 00:00:00	32020		\N	264187	0	192127007	440086		0
78018	4623	40481087	2009-05-06	2009-05-06 00:00:00	2009-05-13	2009-05-13 00:00:00	32020		\N	307873	0	444814009	40481087		0
67553	3991	4112343	1973-10-23	1973-10-23 00:00:00	1973-11-01	1973-11-01 00:00:00	32020		\N	265301	0	195662009	4112343		0
67672	3997	40481087	1983-08-08	1983-08-08 00:00:00	1983-08-22	1983-08-22 00:00:00	32020		\N	265767	0	444814009	40481087		0
67843	4009	80180	1992-05-15	1992-05-15 00:00:00	\N	\N	32020		\N	266436	0	396275006	80180		0
68050	4019	4112343	2012-02-22	2012-02-22 00:00:00	2012-03-02	2012-03-02 00:00:00	32020		\N	267152	0	195662009	4112343		0
68169	4026	134438	1977-01-28	1977-01-28 00:00:00	1977-11-26	1977-11-26 00:00:00	32020		\N	267661	0	40275004	134438		0
78927	4675	260139	1972-06-16	1972-06-16 00:00:00	1972-06-30	1972-06-30 00:00:00	32020		\N	311497	0	10509002	260139		0
68543	4053	4113008	1988-06-28	1988-06-28 00:00:00	1988-07-12	1988-07-12 00:00:00	32020		\N	269419	0	284549007	4113008		0
79213	4690	4112343	1997-10-03	1997-10-03 00:00:00	1997-10-12	1997-10-12 00:00:00	32020		\N	312523	0	195662009	4112343		0
79384	4701	381316	2015-04-03	2015-04-03 00:00:00	\N	\N	32020		\N	313191	0	230690007	381316		0
68954	4081	40481087	1988-03-13	1988-03-13 00:00:00	1988-04-03	1988-04-03 00:00:00	32020		\N	271247	0	444814009	40481087		0
69165	4092	40481087	1981-03-02	1981-03-02 00:00:00	1981-03-09	1981-03-09 00:00:00	32020		\N	272054	0	444814009	40481087		0
79954	4738	195588	1937-10-15	1937-10-15 00:00:00	1937-11-25	1937-11-25 00:00:00	32020		\N	315645	0	38822007	195588		0
69399	4107	28060	1995-01-21	1995-01-21 00:00:00	1995-01-29	1995-01-29 00:00:00	32020		\N	272890	0	43878008	28060		0
69607	4119	4112343	1948-11-02	1948-11-02 00:00:00	1948-11-13	1948-11-13 00:00:00	32020		\N	273791	0	195662009	4112343		0
80375	4760	4296205	2015-11-04	2015-11-04 00:00:00	2015-12-02	2015-12-02 00:00:00	32020		\N	317200	0	403191005	4296205		0
70145	4153	40481087	1967-05-08	1967-05-08 00:00:00	1967-05-29	1967-05-29 00:00:00	32020		\N	276059	0	444814009	40481087		0
80891	4799	378001	1971-01-21	1971-01-21 00:00:00	1971-03-22	1971-03-22 00:00:00	32020		\N	319243	0	62106007	378001		0
81139	4812	40481087	1981-05-07	1981-05-07 00:00:00	1981-05-21	1981-05-21 00:00:00	32020		\N	320109	0	444814009	40481087		0
81272	4820	78272	2016-10-07	2016-10-07 00:00:00	2016-11-11	2016-11-11 00:00:00	32020		\N	320617	0	70704007	78272		0
70872	4204	260139	1993-03-18	1993-03-18 00:00:00	1993-04-01	1993-04-01 00:00:00	32020		\N	279071	0	10509002	260139		0
70983	4210	260139	2007-02-02	2007-02-02 00:00:00	2007-02-16	2007-02-16 00:00:00	32020		\N	279523	0	10509002	260139		0
71089	4217	28060	1983-04-14	1983-04-14 00:00:00	1983-04-23	1983-04-23 00:00:00	32020		\N	279968	0	43878008	28060		0
71331	4229	260139	2008-08-14	2008-08-14 00:00:00	2008-08-28	2008-08-28 00:00:00	32020		\N	280949	0	10509002	260139		0
71465	4239	4218389	2001-09-22	2001-09-22 00:00:00	2001-10-13	2001-10-13 00:00:00	32020		\N	281508	0	39848009	4218389		0
82189	4873	40481087	2002-10-31	2002-10-31 00:00:00	2002-11-07	2002-11-07 00:00:00	32020		\N	324127	0	444814009	40481087		0
71819	4260	4112343	1939-01-27	1939-01-27 00:00:00	1939-02-06	1939-02-06 00:00:00	32020		\N	282762	0	195662009	4112343		0
71964	4270	192671	2005-09-15	2005-09-15 00:00:00	\N	\N	32020		\N	283417	0	K92.2	35208414		0
72102	4278	257012	1982-03-05	1982-03-05 00:00:00	\N	\N	32020		\N	283882	0	40055000	257012		0
72269	4288	372328	1954-03-10	1954-03-10 00:00:00	1954-07-17	1954-07-17 00:00:00	32020		\N	284655	0	65363002	372328		0
83052	4933	81151	2007-08-19	2007-08-19 00:00:00	2007-09-23	2007-09-23 00:00:00	32020		\N	327971	0	44465007	81151		0
83187	4942	257012	1958-05-05	1958-05-05 00:00:00	\N	\N	32020		\N	328519	0	40055000	257012		0
72836	4329	40481087	1997-05-29	1997-05-29 00:00:00	1997-06-05	1997-06-05 00:00:00	32020		\N	287078	0	444814009	40481087		0
83637	4971	40481087	1997-02-26	1997-02-26 00:00:00	1997-03-19	1997-03-19 00:00:00	32020		\N	330551	0	444814009	40481087		0
84058	4991	40481087	2000-04-07	2000-04-07 00:00:00	2000-04-21	2000-04-21 00:00:00	32020		\N	332034	0	444814009	40481087		0
73591	4375	40481087	1973-05-31	1973-05-31 00:00:00	1973-06-14	1973-06-14 00:00:00	32020		\N	290606	0	444814009	40481087		0
84365	5014	4266809	1948-10-19	1948-10-19 00:00:00	\N	\N	32020		\N	333314	0	397881000	4266809		0
84599	5031	40481087	1930-01-20	1930-01-20 00:00:00	1930-01-27	1930-01-27 00:00:00	32020		\N	334324	0	444814009	40481087		0
84677	5035	192671	1969-07-27	1969-07-27 00:00:00	\N	\N	32020		\N	334575	0	K92.2	35208414		0
84891	5048	4278672	2016-05-23	2016-05-23 00:00:00	2016-08-21	2016-08-21 00:00:00	32020		\N	335506	0	65966004	4278672		0
74443	4418	4112343	1961-06-23	1961-06-23 00:00:00	1961-07-02	1961-07-02 00:00:00	32020		\N	293780	0	195662009	4112343		0
74647	4433	40481087	2008-11-03	2008-11-03 00:00:00	2008-11-10	2008-11-10 00:00:00	32020		\N	294658	0	444814009	40481087		0
64218	3791	260139	1932-06-26	1932-06-26 00:00:00	1932-07-03	1932-07-03 00:00:00	32020		\N	252053	0	10509002	260139		0
64381	3803	4266809	2003-12-24	2003-12-24 00:00:00	\N	\N	32020		\N	252766	0	397881000	4266809		0
64494	3811	4134304	1927-05-22	1927-05-22 00:00:00	1927-08-20	1927-08-20 00:00:00	32020		\N	253140	0	263102004	4134304		0
75243	4470	4146173	1994-06-03	1994-06-03 00:00:00	1994-07-03	1994-07-03 00:00:00	32020		\N	297360	0	307731004	4146173		0
64774	3831	260139	2001-12-07	2001-12-07 00:00:00	2001-12-14	2001-12-14 00:00:00	32020		\N	254331	0	10509002	260139		0
65009	3844	4218389	1965-02-22	1965-02-22 00:00:00	1965-03-22	1965-03-22 00:00:00	32020		\N	255128	0	39848009	4218389		0
65136	3852	40481087	2006-01-11	2006-01-11 00:00:00	2006-01-18	2006-01-18 00:00:00	32020		\N	255683	0	444814009	40481087		0
65329	3862	40481087	1977-02-28	1977-02-28 00:00:00	1977-03-07	1977-03-07 00:00:00	32020		\N	256426	0	444814009	40481087		0
65527	3875	40481087	1965-02-20	1965-02-20 00:00:00	1965-03-06	1965-03-06 00:00:00	32020		\N	257342	0	444814009	40481087		0
76255	4525	4218389	2012-04-30	2012-04-30 00:00:00	2012-05-21	2012-05-21 00:00:00	32020		\N	301267	0	39848009	4218389		0
76416	4531	4113008	2004-10-29	2004-10-29 00:00:00	2004-11-19	2004-11-19 00:00:00	32020		\N	301709	0	284549007	4113008		0
66033	3904	372328	1979-05-23	1979-05-23 00:00:00	1979-08-02	1979-08-02 00:00:00	32020		\N	259640	0	65363002	372328		0
66229	3920	40481087	1992-05-12	1992-05-12 00:00:00	1992-05-19	1992-05-19 00:00:00	32020		\N	260643	0	444814009	40481087		0
66385	3929	81151	1956-04-14	1956-04-14 00:00:00	1956-04-28	1956-04-28 00:00:00	32020		\N	261166	0	44465007	81151		0
66484	3935	260139	1952-02-28	1952-02-28 00:00:00	1952-03-13	1952-03-13 00:00:00	32020		\N	261574	0	10509002	260139		0
77272	4577	4112343	2015-06-13	2015-06-13 00:00:00	2015-06-25	2015-06-25 00:00:00	32020		\N	304871	0	195662009	4112343		0
77392	4586	4112343	1992-04-26	1992-04-26 00:00:00	1992-05-04	1992-05-04 00:00:00	32020		\N	305521	0	195662009	4112343		0
67062	3966	260139	2005-10-18	2005-10-18 00:00:00	2005-10-25	2005-10-25 00:00:00	32020		\N	263635	0	10509002	260139		0
67214	3973	4112343	1987-12-13	1987-12-13 00:00:00	1987-12-26	1987-12-26 00:00:00	32020		\N	264178	0	195662009	4112343		0
78019	4623	28060	1931-06-06	1931-06-06 00:00:00	1931-06-14	1931-06-14 00:00:00	32020		\N	307860	0	43878008	28060		0
67554	3991	40481087	1971-09-05	1971-09-05 00:00:00	1971-09-26	1971-09-26 00:00:00	32020		\N	265393	0	444814009	40481087		0
67673	3997	439777	2018-11-08	2018-11-08 00:00:00	\N	\N	32020		\N	265735	0	271737000	439777		0
67844	4009	260139	1952-11-26	1952-11-26 00:00:00	1952-12-10	1952-12-10 00:00:00	32020		\N	266388	0	10509002	260139		0
68051	4019	4094814	1991-05-04	1991-05-04 00:00:00	1991-08-02	1991-08-02 00:00:00	32020		\N	267171	0	262574004	4094814		0
68170	4026	30753	1997-07-10	1997-07-10 00:00:00	\N	\N	32020		\N	267673	0	16761005	30753		0
78928	4675	378001	2001-06-10	2001-06-10 00:00:00	2001-08-09	2001-08-09 00:00:00	32020		\N	311447	0	62106007	378001		0
68544	4053	4294548	1968-01-02	1968-01-02 00:00:00	1968-05-07	1968-05-07 00:00:00	32020		\N	269449	0	75498004	4294548		0
79214	4690	40481087	2006-05-19	2006-05-19 00:00:00	2006-06-02	2006-06-02 00:00:00	32020		\N	312457	0	444814009	40481087		0
79385	4701	40481087	1974-07-14	1974-07-14 00:00:00	1974-07-28	1974-07-28 00:00:00	32020		\N	313175	0	444814009	40481087		0
68955	4081	80180	1999-04-21	1999-04-21 00:00:00	\N	\N	32020		\N	271263	0	396275006	80180		0
69166	4092	40481087	2006-05-08	2006-05-08 00:00:00	2006-05-29	2006-05-29 00:00:00	32020		\N	272047	0	444814009	40481087		0
79955	4738	372328	1911-03-11	1911-03-11 00:00:00	1911-08-25	1911-08-25 00:00:00	32020		\N	315665	0	65363002	372328		0
69400	4107	372328	1984-09-11	1984-09-11 00:00:00	1985-03-11	1985-03-11 00:00:00	32020		\N	272911	0	65363002	372328		0
69608	4119	4112343	2015-08-04	2015-08-04 00:00:00	2015-08-16	2015-08-16 00:00:00	32020		\N	273872	0	195662009	4112343		0
80376	4760	260139	1971-07-11	1971-07-11 00:00:00	1971-07-25	1971-07-25 00:00:00	32020		\N	317175	0	10509002	260139		0
70146	4153	4134304	2005-05-10	2005-05-10 00:00:00	2005-07-09	2005-07-09 00:00:00	32020		\N	276008	0	263102004	4134304		0
80892	4799	40481087	1975-05-14	1975-05-14 00:00:00	1975-05-28	1975-05-28 00:00:00	32020		\N	319206	0	444814009	40481087		0
81140	4812	317576	2011-07-27	2011-07-27 00:00:00	\N	\N	32020		\N	320171	0	53741008	317576		0
81273	4820	4112343	1996-01-03	1996-01-03 00:00:00	1996-01-12	1996-01-12 00:00:00	32020		\N	320654	0	195662009	4112343		0
70873	4204	28060	1955-12-20	1955-12-20 00:00:00	1956-01-02	1956-01-02 00:00:00	32020		\N	279068	0	43878008	28060		0
70984	4210	260139	2014-02-24	2014-02-24 00:00:00	2014-03-03	2014-03-03 00:00:00	32020		\N	279565	0	10509002	260139		0
71090	4217	80180	2001-04-19	2001-04-19 00:00:00	\N	\N	32020		\N	279955	0	396275006	80180		0
71332	4229	4112343	1970-11-11	1970-11-11 00:00:00	1970-11-20	1970-11-20 00:00:00	32020		\N	280964	0	195662009	4112343		0
71466	4239	375671	1971-10-23	1971-10-23 00:00:00	1971-11-22	1971-11-22 00:00:00	32020		\N	281505	0	62564004	375671		0
82190	4873	40481087	1977-09-15	1977-09-15 00:00:00	1977-10-06	1977-10-06 00:00:00	32020		\N	324137	0	444814009	40481087		0
71820	4260	40481087	2001-12-29	2001-12-29 00:00:00	2002-01-05	2002-01-05 00:00:00	32020		\N	282837	0	444814009	40481087		0
71965	4270	40481087	2017-12-01	2017-12-01 00:00:00	2017-12-08	2017-12-08 00:00:00	32020		\N	283394	0	444814009	40481087		0
72103	4278	40481087	1969-09-11	1969-09-11 00:00:00	1969-09-18	1969-09-18 00:00:00	32020		\N	283894	0	444814009	40481087		0
72270	4288	28060	1973-02-21	1973-02-21 00:00:00	1973-03-06	1973-03-06 00:00:00	32020		\N	284699	0	43878008	28060		0
83053	4933	40481087	1978-03-28	1978-03-28 00:00:00	1978-04-11	1978-04-11 00:00:00	32020		\N	327943	0	444814009	40481087		0
83188	4942	4112343	2001-09-03	2001-09-03 00:00:00	2001-09-12	2001-09-12 00:00:00	32020		\N	328469	0	195662009	4112343		0
72837	4329	40479422	2014-10-19	2014-10-19 00:00:00	2014-12-24	2014-12-24 00:00:00	32020		\N	287106	0	444448004	40479422		0
83638	4971	4134304	2004-01-26	2004-01-26 00:00:00	2004-02-25	2004-02-25 00:00:00	32020		\N	330515	0	263102004	4134304		0
83681	4972	4146173	1990-01-09	1990-01-09 00:00:00	1990-03-10	1990-03-10 00:00:00	32020		\N	330749	0	307731004	4146173		0
73337	4359	4112343	1959-01-15	1959-01-15 00:00:00	1959-01-26	1959-01-26 00:00:00	32020		\N	289217	0	195662009	4112343		0
84059	4991	4109685	1973-03-31	1973-03-31 00:00:00	1973-04-21	1973-04-21 00:00:00	32020		\N	332052	0	284551006	4109685		0
73592	4375	40481087	1959-08-03	1959-08-03 00:00:00	1959-08-24	1959-08-24 00:00:00	32020		\N	290637	0	444814009	40481087		0
84366	5014	4146173	1973-12-25	1973-12-25 00:00:00	1974-01-24	1974-01-24 00:00:00	32020		\N	333266	0	307731004	4146173		0
84600	5031	4112343	1984-09-22	1984-09-22 00:00:00	1984-10-01	1984-10-01 00:00:00	32020		\N	334419	0	195662009	4112343		0
84678	5035	81151	1976-07-21	1976-07-21 00:00:00	1976-08-04	1976-08-04 00:00:00	32020		\N	334619	0	44465007	81151		0
84892	5048	260139	1992-08-24	1992-08-24 00:00:00	1992-08-31	1992-08-31 00:00:00	32020		\N	335496	0	10509002	260139		0
74444	4418	4112343	1976-01-18	1976-01-18 00:00:00	1976-01-25	1976-01-25 00:00:00	32020		\N	293717	0	195662009	4112343		0
74648	4433	378001	1953-03-18	1953-03-18 00:00:00	1953-05-17	1953-05-17 00:00:00	32020		\N	294726	0	62106007	378001		0
64382	3803	4112343	2003-04-14	2003-04-14 00:00:00	2003-04-21	2003-04-21 00:00:00	32020		\N	252766	0	195662009	4112343		0
64495	3811	260139	1998-08-03	1998-08-03 00:00:00	1998-08-17	1998-08-17 00:00:00	32020		\N	253217	0	10509002	260139		0
75244	4470	440448	2010-12-31	2010-12-31 00:00:00	\N	\N	32020		\N	297388	0	74400008	440448		0
64775	3831	260139	1958-03-11	1958-03-11 00:00:00	1958-03-25	1958-03-25 00:00:00	32020		\N	254390	0	10509002	260139		0
65010	3844	4278672	1970-03-26	1970-03-26 00:00:00	1970-06-24	1970-06-24 00:00:00	32020		\N	255129	0	65966004	4278672		0
65137	3852	40481087	1982-12-18	1982-12-18 00:00:00	1983-01-01	1983-01-01 00:00:00	32020		\N	255636	0	444814009	40481087		0
65331	3864	40481087	1996-02-24	1996-02-24 00:00:00	1996-03-09	1996-03-09 00:00:00	32020		\N	256477	0	444814009	40481087		0
65528	3875	4152936	1971-06-04	1971-06-04 00:00:00	1971-06-18	1971-06-18 00:00:00	32020		\N	257379	0	283385000	4152936		0
76256	4525	40481087	1986-08-24	1986-08-24 00:00:00	1986-08-31	1986-08-31 00:00:00	32020		\N	301301	0	444814009	40481087		0
76417	4531	40481087	1943-06-02	1943-06-02 00:00:00	1943-06-16	1943-06-16 00:00:00	32020		\N	301740	0	444814009	40481087		0
66034	3904	80180	2015-01-04	2015-01-04 00:00:00	\N	\N	32020		\N	259612	0	396275006	80180		0
66230	3920	4237458	2009-11-10	2009-11-10 00:00:00	2010-01-09	2010-01-09 00:00:00	32020		\N	260685	0	58150001	4237458		0
66386	3929	4218389	1983-09-04	1983-09-04 00:00:00	1983-10-02	1983-10-02 00:00:00	32020		\N	261148	0	39848009	4218389		0
66485	3935	81893	1981-10-21	1981-10-21 00:00:00	\N	\N	32020		\N	261537	0	64766004	81893		0
77273	4577	372328	1983-08-08	1983-08-08 00:00:00	1983-10-15	1983-10-15 00:00:00	32020		\N	304890	0	65363002	372328		0
77393	4586	257012	1964-05-22	1964-05-22 00:00:00	1964-08-28	1964-08-28 00:00:00	32020		\N	305463	0	40055000	257012		0
67063	3966	4112343	2016-12-15	2016-12-15 00:00:00	2016-12-23	2016-12-23 00:00:00	32020		\N	263632	0	195662009	4112343		0
67215	3973	378001	1993-09-10	1993-09-10 00:00:00	1993-11-09	1993-11-09 00:00:00	32020		\N	264218	0	62106007	378001		0
78020	4623	4112343	1958-02-20	1958-02-20 00:00:00	1958-03-04	1958-03-04 00:00:00	32020		\N	307927	0	195662009	4112343		0
67555	3991	4283893	2014-07-25	2014-07-25 00:00:00	2014-09-19	2014-09-19 00:00:00	32020		\N	265385	0	36971009	4283893		0
67674	3997	28060	1967-05-21	1967-05-21 00:00:00	1967-06-02	1967-06-02 00:00:00	32020		\N	265774	0	43878008	28060		0
67845	4009	260139	1979-03-06	1979-03-06 00:00:00	1979-03-20	1979-03-20 00:00:00	32020		\N	266443	0	10509002	260139		0
68052	4019	192671	2005-05-08	2005-05-08 00:00:00	\N	\N	32020		\N	267176	0	K92.2	35208414		0
68171	4026	4310024	1996-07-15	1996-07-15 00:00:00	\N	\N	32020		\N	267673	0	424802006	4310024		0
78929	4675	313217	1998-11-29	1998-11-29 00:00:00	\N	\N	32020		\N	311529	0	49436004	313217		0
68545	4053	40481087	1975-08-05	1975-08-05 00:00:00	1975-08-12	1975-08-12 00:00:00	32020		\N	269465	0	444814009	40481087		0
79215	4690	257012	2005-05-06	2005-05-06 00:00:00	\N	\N	32020		\N	312537	0	40055000	257012		0
79386	4701	81151	1989-05-05	1989-05-05 00:00:00	1989-06-09	1989-06-09 00:00:00	32020		\N	313171	0	44465007	81151		0
68956	4081	4112343	1959-07-04	1959-07-04 00:00:00	1959-07-13	1959-07-13 00:00:00	32020		\N	271233	0	195662009	4112343		0
69167	4092	260139	1989-07-15	1989-07-15 00:00:00	1989-07-29	1989-07-29 00:00:00	32020		\N	272021	0	10509002	260139		0
79956	4738	30753	1943-07-06	1943-07-06 00:00:00	\N	\N	32020		\N	315655	0	16761005	30753		0
69401	4107	4113008	1992-01-19	1992-01-19 00:00:00	1992-02-02	1992-02-02 00:00:00	32020		\N	272889	0	284549007	4113008		0
69609	4119	372328	1946-02-12	1946-02-12 00:00:00	1946-06-29	1946-06-29 00:00:00	32020		\N	273834	0	65363002	372328		0
80377	4760	4152936	2012-11-28	2012-11-28 00:00:00	2012-12-19	2012-12-19 00:00:00	32020		\N	317199	0	283385000	4152936		0
70147	4153	81151	1981-01-18	1981-01-18 00:00:00	1981-02-08	1981-02-08 00:00:00	32020		\N	276006	0	44465007	81151		0
80893	4799	4112343	1970-02-14	1970-02-14 00:00:00	1970-02-21	1970-02-21 00:00:00	32020		\N	319203	0	195662009	4112343		0
81141	4812	4218389	1967-03-09	1967-03-09 00:00:00	1967-04-06	1967-04-06 00:00:00	32020		\N	320160	0	39848009	4218389		0
81274	4820	4059173	1967-02-13	1967-02-13 00:00:00	1967-05-14	1967-05-14 00:00:00	32020		\N	320645	0	16114001	4059173		0
70874	4204	40481087	2012-03-13	2012-03-13 00:00:00	2012-03-27	2012-03-27 00:00:00	32020		\N	279077	0	444814009	40481087		0
70985	4210	4310024	2014-12-21	2014-12-21 00:00:00	\N	\N	32020		\N	279565	0	424802006	4310024		0
71091	4217	40481087	2000-10-26	2000-10-26 00:00:00	2000-11-09	2000-11-09 00:00:00	32020		\N	279955	0	444814009	40481087		0
71333	4229	4112343	1996-05-08	1996-05-08 00:00:00	1996-05-18	1996-05-18 00:00:00	32020		\N	280935	0	195662009	4112343		0
71467	4239	4051466	1952-10-01	1952-10-01 00:00:00	1968-01-13	1968-01-13 00:00:00	32020		\N	281536	0	233678006	4051466		0
82191	4873	40481087	2005-03-17	2005-03-17 00:00:00	2005-03-31	2005-03-31 00:00:00	32020		\N	324096	0	444814009	40481087		0
71821	4260	40481087	1975-08-17	1975-08-17 00:00:00	1975-09-07	1975-09-07 00:00:00	32020		\N	282834	0	444814009	40481087		0
71966	4270	80180	2005-06-26	2005-06-26 00:00:00	\N	\N	32020		\N	283401	0	396275006	80180		0
72104	4278	40481087	1985-05-28	1985-05-28 00:00:00	1985-06-18	1985-06-18 00:00:00	32020		\N	283907	0	444814009	40481087		0
72271	4288	260139	1955-09-18	1955-09-18 00:00:00	1955-09-25	1955-09-25 00:00:00	32020		\N	284714	0	10509002	260139		0
83054	4933	4310024	2005-09-22	2005-09-22 00:00:00	\N	\N	32020		\N	327951	0	424802006	4310024		0
83189	4942	4294548	1971-07-01	1971-07-01 00:00:00	1971-08-12	1971-08-12 00:00:00	32020		\N	328481	0	75498004	4294548		0
72838	4329	80180	2010-11-10	2010-11-10 00:00:00	\N	\N	32020		\N	287102	0	396275006	80180		0
83639	4971	260139	2000-05-27	2000-05-27 00:00:00	2000-06-03	2000-06-03 00:00:00	32020		\N	330552	0	10509002	260139		0
83682	4972	40481087	2011-07-28	2011-07-28 00:00:00	2011-08-04	2011-08-04 00:00:00	32020		\N	330670	0	444814009	40481087		0
73338	4359	4112343	1963-01-06	1963-01-06 00:00:00	1963-01-15	1963-01-15 00:00:00	32020		\N	289261	0	195662009	4112343		0
84060	4991	378001	1978-11-21	1978-11-21 00:00:00	1979-01-20	1979-01-20 00:00:00	32020		\N	332053	0	62106007	378001		0
73593	4375	40481087	1985-02-16	1985-02-16 00:00:00	1985-02-23	1985-02-23 00:00:00	32020		\N	290624	0	444814009	40481087		0
84367	5014	260139	1915-11-29	1915-11-29 00:00:00	1915-12-06	1915-12-06 00:00:00	32020		\N	333311	0	10509002	260139		0
84601	5031	260139	2015-01-07	2015-01-07 00:00:00	2015-01-14	2015-01-14 00:00:00	32020		\N	334322	0	10509002	260139		0
84679	5035	4059173	1996-06-20	1996-06-20 00:00:00	1996-09-18	1996-09-18 00:00:00	32020		\N	334620	0	16114001	4059173		0
84893	5048	30753	1991-01-09	1991-01-09 00:00:00	\N	\N	32020		\N	335425	0	16761005	30753		0
74445	4418	260139	2010-01-20	2010-01-20 00:00:00	2010-01-27	2010-01-27 00:00:00	32020		\N	293752	0	10509002	260139		0
74649	4433	260139	2008-08-02	2008-08-02 00:00:00	2008-08-16	2008-08-16 00:00:00	32020		\N	294657	0	10509002	260139		0
64220	3791	260139	1976-09-19	1976-09-19 00:00:00	1976-09-26	1976-09-26 00:00:00	32020		\N	252136	0	10509002	260139		0
64383	3803	4285898	2003-08-26	2003-08-26 00:00:00	\N	\N	32020		\N	252766	0	68496003	4285898		0
64496	3811	81151	1925-05-04	1925-05-04 00:00:00	1925-06-01	1925-06-01 00:00:00	32020		\N	253139	0	44465007	81151		0
75245	4470	40481087	1990-04-15	1990-04-15 00:00:00	1990-04-29	1990-04-29 00:00:00	32020		\N	297359	0	444814009	40481087		0
64776	3831	260139	2013-03-18	2013-03-18 00:00:00	2013-03-25	2013-03-25 00:00:00	32020		\N	254358	0	10509002	260139		0
65011	3844	40481087	2017-08-19	2017-08-19 00:00:00	2017-08-26	2017-08-26 00:00:00	32020		\N	255144	0	444814009	40481087		0
65138	3852	40481087	1996-08-03	1996-08-03 00:00:00	1996-08-24	1996-08-24 00:00:00	32020		\N	255737	0	444814009	40481087		0
65332	3864	40481087	2015-12-23	2015-12-23 00:00:00	2016-01-13	2016-01-13 00:00:00	32020		\N	256480	0	444814009	40481087		0
65529	3875	260139	1963-06-26	1963-06-26 00:00:00	1963-07-10	1963-07-10 00:00:00	32020		\N	257393	0	10509002	260139		0
76257	4525	372328	1969-10-22	1969-10-22 00:00:00	1969-11-12	1969-11-12 00:00:00	32020		\N	301273	0	65363002	372328		0
76418	4531	4278672	1983-07-22	1983-07-22 00:00:00	1983-10-20	1983-10-20 00:00:00	32020		\N	301707	0	65966004	4278672		0
66035	3904	40481087	2014-04-24	2014-04-24 00:00:00	2014-05-08	2014-05-08 00:00:00	32020		\N	259612	0	444814009	40481087		0
66231	3920	4035415	1989-01-29	1989-01-29 00:00:00	1989-02-28	1989-02-28 00:00:00	32020		\N	260684	0	239720000	4035415		0
66387	3929	4283893	1957-12-10	1957-12-10 00:00:00	1958-07-08	1958-07-08 00:00:00	32020		\N	261152	0	36971009	4283893		0
66486	3935	4310024	1981-02-23	1981-02-23 00:00:00	\N	\N	32020		\N	261537	0	424802006	4310024		0
77274	4577	40481087	1986-06-02	1986-06-02 00:00:00	1986-06-23	1986-06-23 00:00:00	32020		\N	304878	0	444814009	40481087		0
77394	4586	40481087	1997-01-20	1997-01-20 00:00:00	1997-01-27	1997-01-27 00:00:00	32020		\N	305465	0	444814009	40481087		0
67064	3966	4112343	1978-08-20	1978-08-20 00:00:00	1978-08-31	1978-08-31 00:00:00	32020		\N	263704	0	195662009	4112343		0
67216	3973	40481087	1992-11-17	1992-11-17 00:00:00	1992-12-08	1992-12-08 00:00:00	32020		\N	264168	0	444814009	40481087		0
88479	5259	260139	1987-09-05	1987-09-05 00:00:00	1987-09-12	1987-09-12 00:00:00	32020		\N	349946	0	10509002	260139		0
67556	3991	260139	1994-01-17	1994-01-17 00:00:00	1994-01-31	1994-01-31 00:00:00	32020		\N	265344	0	10509002	260139		0
67675	3997	40481087	1989-08-25	1989-08-25 00:00:00	1989-09-15	1989-09-15 00:00:00	32020		\N	265732	0	444814009	40481087		0
67846	4009	380378	2005-07-26	2005-07-26 00:00:00	\N	\N	32020		\N	266396	0	84757009	380378		0
68053	4020	28060	1991-03-08	1991-03-08 00:00:00	1991-03-16	1991-03-16 00:00:00	32020		\N	267256	0	43878008	28060		0
68172	4026	260139	2013-06-05	2013-06-05 00:00:00	2013-06-19	2013-06-19 00:00:00	32020		\N	267599	0	10509002	260139		0
78930	4675	260139	1971-11-28	1971-11-28 00:00:00	1971-12-05	1971-12-05 00:00:00	32020		\N	311549	0	10509002	260139		0
68546	4053	40481087	1990-04-02	1990-04-02 00:00:00	1990-04-16	1990-04-16 00:00:00	32020		\N	269466	0	444814009	40481087		0
79216	4690	4134304	1965-02-22	1965-02-22 00:00:00	1965-04-23	1965-04-23 00:00:00	32020		\N	312520	0	263102004	4134304		0
79387	4701	40481087	1972-10-23	1972-10-23 00:00:00	1972-11-13	1972-11-13 00:00:00	32020		\N	313131	0	444814009	40481087		0
68957	4081	40481087	1997-07-23	1997-07-23 00:00:00	1997-07-30	1997-07-30 00:00:00	32020		\N	271236	0	444814009	40481087		0
69168	4092	4112343	2001-07-11	2001-07-11 00:00:00	2001-07-22	2001-07-22 00:00:00	32020		\N	272056	0	195662009	4112343		0
79957	4738	4027663	1934-09-11	1934-09-11 00:00:00	\N	\N	32020		\N	315639	0	13200003	4027663		0
69402	4107	40481087	1991-05-18	1991-05-18 00:00:00	1991-06-01	1991-06-01 00:00:00	32020		\N	272902	0	444814009	40481087		0
69610	4119	4112343	1968-05-18	1968-05-18 00:00:00	1968-05-31	1968-05-31 00:00:00	32020		\N	273865	0	195662009	4112343		0
80378	4760	260139	1971-03-04	1971-03-04 00:00:00	1971-03-11	1971-03-11 00:00:00	32020		\N	317142	0	10509002	260139		0
70148	4153	372328	1967-01-02	1967-01-02 00:00:00	1967-01-16	1967-01-16 00:00:00	32020		\N	276041	0	65363002	372328		0
80894	4799	260139	2010-01-16	2010-01-16 00:00:00	2010-01-30	2010-01-30 00:00:00	32020		\N	319218	0	10509002	260139		0
81142	4812	4109685	1981-12-16	1981-12-16 00:00:00	1982-01-06	1982-01-06 00:00:00	32020		\N	320163	0	284551006	4109685		0
81275	4820	372328	2003-07-17	2003-07-17 00:00:00	2005-01-20	2005-01-20 00:00:00	32020		\N	320633	0	65363002	372328		0
70875	4204	4156265	2006-07-17	2006-07-17 00:00:00	2006-07-31	2006-07-31 00:00:00	32020		\N	279067	0	370247008	4156265		0
70986	4210	192671	2017-02-17	2017-02-17 00:00:00	\N	\N	32020		\N	279517	0	K92.2	35208414		0
71092	4217	4278672	1991-07-05	1991-07-05 00:00:00	1991-09-03	1991-09-03 00:00:00	32020		\N	279909	0	65966004	4278672		0
71334	4229	40481087	1993-05-30	1993-05-30 00:00:00	1993-06-13	1993-06-13 00:00:00	32020		\N	280978	0	444814009	40481087		0
71468	4239	4116491	1980-09-17	1980-09-17 00:00:00	1980-10-29	1980-10-29 00:00:00	32020		\N	281476	0	301011002	4116491		0
82192	4873	372328	1977-02-11	1977-02-11 00:00:00	1977-03-25	1977-03-25 00:00:00	32020		\N	324105	0	65363002	372328		0
71822	4260	372328	1941-05-14	1941-05-14 00:00:00	1941-08-12	1941-08-12 00:00:00	32020		\N	282839	0	65363002	372328		0
71967	4270	4112343	2005-03-11	2005-03-11 00:00:00	2005-03-23	2005-03-23 00:00:00	32020		\N	283401	0	195662009	4112343		0
72105	4278	378001	1964-04-30	1964-04-30 00:00:00	1964-06-29	1964-06-29 00:00:00	32020		\N	283931	0	62106007	378001		0
72272	4288	4112343	1961-06-28	1961-06-28 00:00:00	1961-07-05	1961-07-05 00:00:00	32020		\N	284661	0	195662009	4112343		0
83055	4933	4266809	2007-06-14	2007-06-14 00:00:00	\N	\N	32020		\N	327951	0	397881000	4266809		0
83190	4942	4283893	1958-04-14	1958-04-14 00:00:00	1958-07-21	1958-07-21 00:00:00	32020		\N	328478	0	36971009	4283893		0
72839	4329	40481087	1985-09-29	1985-09-29 00:00:00	1985-10-06	1985-10-06 00:00:00	32020		\N	287118	0	444814009	40481087		0
83640	4971	40481087	2005-12-11	2005-12-11 00:00:00	2005-12-18	2005-12-18 00:00:00	32020		\N	330536	0	444814009	40481087		0
83683	4972	4059173	2016-09-19	2016-09-19 00:00:00	2016-12-18	2016-12-18 00:00:00	32020		\N	330665	0	16114001	4059173		0
73339	4359	40481087	1987-06-13	1987-06-13 00:00:00	1987-06-20	1987-06-20 00:00:00	32020		\N	289223	0	444814009	40481087		0
84061	4991	81151	1992-09-08	1992-09-08 00:00:00	1992-10-13	1992-10-13 00:00:00	32020		\N	332054	0	44465007	81151		0
73594	4375	313217	2006-06-25	2006-06-25 00:00:00	\N	\N	32020		\N	290646	0	49436004	313217		0
84368	5014	372328	1917-01-20	1917-01-20 00:00:00	1917-10-23	1917-10-23 00:00:00	32020		\N	333268	0	65363002	372328		0
84602	5031	378001	1950-12-24	1950-12-24 00:00:00	1951-02-22	1951-02-22 00:00:00	32020		\N	334278	0	62106007	378001		0
84680	5035	4112343	1962-05-24	1962-05-24 00:00:00	1962-06-02	1962-06-02 00:00:00	32020		\N	334546	0	195662009	4112343		0
84894	5048	260139	1959-10-20	1959-10-20 00:00:00	1959-10-27	1959-10-27 00:00:00	32020		\N	335517	0	10509002	260139		0
74446	4419	81151	1972-01-28	1972-01-28 00:00:00	1972-03-03	1972-03-03 00:00:00	32020		\N	293819	0	44465007	81151		0
74650	4433	4112343	2019-03-19	2019-03-19 00:00:00	2019-03-31	2019-03-31 00:00:00	32020		\N	294647	0	195662009	4112343		0
64221	3791	4152936	1953-09-17	1953-09-17 00:00:00	1953-10-01	1953-10-01 00:00:00	32020		\N	252051	0	283385000	4152936		0
64384	3803	4112343	1974-05-03	1974-05-03 00:00:00	1974-05-14	1974-05-14 00:00:00	32020		\N	252754	0	195662009	4112343		0
64497	3811	80502	2000-08-24	2000-08-24 00:00:00	\N	\N	32020		\N	253235	0	64859006	80502		0
75246	4470	40481087	2007-11-14	2007-11-14 00:00:00	2007-12-05	2007-12-05 00:00:00	32020		\N	297362	0	444814009	40481087		0
64777	3831	4027663	1982-05-23	1982-05-23 00:00:00	\N	\N	32020		\N	254370	0	13200003	4027663		0
65012	3844	40481087	2004-05-09	2004-05-09 00:00:00	2004-05-30	2004-05-30 00:00:00	32020		\N	255135	0	444814009	40481087		0
65139	3852	40481087	2004-02-26	2004-02-26 00:00:00	2004-03-18	2004-03-18 00:00:00	32020		\N	255738	0	444814009	40481087		0
65333	3864	40481087	1994-04-20	1994-04-20 00:00:00	1994-05-11	1994-05-11 00:00:00	32020		\N	256476	0	444814009	40481087		0
65530	3875	80502	2018-07-14	2018-07-14 00:00:00	\N	\N	32020		\N	257341	0	64859006	80502		0
76258	4525	378001	1971-07-14	1971-07-14 00:00:00	1971-08-13	1971-08-13 00:00:00	32020		\N	301265	0	62106007	378001		0
76419	4531	28060	1941-02-18	1941-02-18 00:00:00	1941-02-28	1941-02-28 00:00:00	32020		\N	301813	0	43878008	28060		0
66036	3904	260139	1991-06-21	1991-06-21 00:00:00	1991-06-28	1991-06-28 00:00:00	32020		\N	259593	0	10509002	260139		0
66232	3920	40481087	1997-06-28	1997-06-28 00:00:00	1997-07-05	1997-07-05 00:00:00	32020		\N	260644	0	444814009	40481087		0
66388	3929	4112343	1993-11-07	1993-11-07 00:00:00	1993-11-14	1993-11-14 00:00:00	32020		\N	261156	0	195662009	4112343		0
66487	3935	4027663	1975-12-27	1975-12-27 00:00:00	\N	\N	32020		\N	261522	0	13200003	4027663		0
77275	4577	4283893	1988-07-07	1988-07-07 00:00:00	1988-09-15	1988-09-15 00:00:00	32020		\N	304869	0	36971009	4283893		0
77395	4586	4112343	1995-03-21	1995-03-21 00:00:00	1995-04-03	1995-04-03 00:00:00	32020		\N	305488	0	195662009	4112343		0
77523	4593	378001	2000-09-16	2000-09-16 00:00:00	2000-10-16	2000-10-16 00:00:00	32020		\N	306051	0	62106007	378001		0
67217	3973	78272	1973-04-14	1973-04-14 00:00:00	1973-04-28	1973-04-28 00:00:00	32020		\N	264217	0	70704007	78272		0
88480	5259	4146173	1961-07-13	1961-07-13 00:00:00	1961-09-11	1961-09-11 00:00:00	32020		\N	349993	0	307731004	4146173		0
67557	3991	4112343	2002-02-19	2002-02-19 00:00:00	2002-03-01	2002-03-01 00:00:00	32020		\N	265396	0	195662009	4112343		0
67676	3997	80180	2011-09-26	2011-09-26 00:00:00	\N	\N	32020		\N	265726	0	396275006	80180		0
67847	4009	4029498	2005-07-26	2005-07-26 00:00:00	\N	\N	32020		\N	266396	0	128613002	4029498		0
68054	4020	80180	1999-03-11	1999-03-11 00:00:00	\N	\N	32020		\N	267261	0	396275006	80180		0
68173	4026	40481087	2004-06-11	2004-06-11 00:00:00	2004-07-02	2004-07-02 00:00:00	32020		\N	267714	0	444814009	40481087		0
78931	4675	4296205	1946-09-08	1946-09-08 00:00:00	1946-09-29	1946-09-29 00:00:00	32020		\N	311504	0	403191005	4296205		0
68547	4053	40481087	2010-02-05	2010-02-05 00:00:00	2010-02-12	2010-02-12 00:00:00	32020		\N	269467	0	444814009	40481087		0
79217	4690	80180	2001-03-20	2001-03-20 00:00:00	\N	\N	32020		\N	312493	0	396275006	80180		0
79388	4701	80180	2011-07-10	2011-07-10 00:00:00	\N	\N	32020		\N	313197	0	396275006	80180		0
68958	4081	81151	2007-08-07	2007-08-07 00:00:00	2007-09-11	2007-09-11 00:00:00	32020		\N	271238	0	44465007	81151		0
69169	4092	40481087	1988-09-04	1988-09-04 00:00:00	1988-09-11	1988-09-11 00:00:00	32020		\N	272044	0	444814009	40481087		0
79958	4738	260139	1922-12-17	1922-12-17 00:00:00	1922-12-24	1922-12-24 00:00:00	32020		\N	315621	0	10509002	260139		0
69403	4107	40481087	2001-02-13	2001-02-13 00:00:00	2001-03-06	2001-03-06 00:00:00	32020		\N	272905	0	444814009	40481087		0
69611	4119	4112343	2011-01-01	2011-01-01 00:00:00	2011-01-12	2011-01-12 00:00:00	32020		\N	273892	0	195662009	4112343		0
80379	4760	40481087	1994-08-31	1994-08-31 00:00:00	1994-09-14	1994-09-14 00:00:00	32020		\N	317147	0	444814009	40481087		0
70149	4153	260139	1975-09-19	1975-09-19 00:00:00	1975-09-26	1975-09-26 00:00:00	32020		\N	276060	0	10509002	260139		0
80895	4799	260139	1971-04-07	1971-04-07 00:00:00	1971-04-14	1971-04-14 00:00:00	32020		\N	319205	0	10509002	260139		0
81143	4812	4112343	1955-04-13	1955-04-13 00:00:00	1955-04-21	1955-04-21 00:00:00	32020		\N	320134	0	195662009	4112343		0
81276	4820	28060	1961-05-30	1961-05-30 00:00:00	1961-06-06	1961-06-06 00:00:00	32020		\N	320640	0	43878008	28060		0
70876	4204	372328	1954-07-20	1954-07-20 00:00:00	1955-08-01	1955-08-01 00:00:00	32020		\N	279078	0	65363002	372328		0
70987	4210	40481087	1984-01-30	1984-01-30 00:00:00	1984-02-06	1984-02-06 00:00:00	32020		\N	279572	0	444814009	40481087		0
71093	4217	4048171	1962-08-19	1962-08-19 00:00:00	1993-07-14	1993-07-14 00:00:00	32020		\N	279920	0	232353008	4048171		0
71335	4229	80180	1993-09-24	1993-09-24 00:00:00	\N	\N	32020		\N	280978	0	396275006	80180		0
71469	4239	4142905	1958-02-03	1958-02-03 00:00:00	1958-05-04	1958-05-04 00:00:00	32020		\N	281502	0	33737001	4142905		0
82193	4873	260139	2004-09-18	2004-09-18 00:00:00	2004-10-02	2004-10-02 00:00:00	32020		\N	324095	0	10509002	260139		0
71823	4261	4113008	1995-10-27	1995-10-27 00:00:00	1995-11-10	1995-11-10 00:00:00	32020		\N	282894	0	284549007	4113008		0
72000	4274	4237458	2018-04-10	2018-04-10 00:00:00	2018-06-09	2018-06-09 00:00:00	32020		\N	283563	0	58150001	4237458		0
72106	4278	4152936	1978-03-18	1978-03-18 00:00:00	1978-04-08	1978-04-08 00:00:00	32020		\N	283932	0	283385000	4152936		0
72273	4288	260139	2000-08-08	2000-08-08 00:00:00	2000-08-15	2000-08-15 00:00:00	32020		\N	284651	0	10509002	260139		0
83056	4933	80180	2007-06-14	2007-06-14 00:00:00	\N	\N	32020		\N	327951	0	396275006	80180		0
83191	4942	4294548	1966-07-12	1966-07-12 00:00:00	1966-09-20	1966-09-20 00:00:00	32020		\N	328479	0	75498004	4294548		0
72840	4329	4112343	1982-11-22	1982-11-22 00:00:00	1982-12-04	1982-12-04 00:00:00	32020		\N	287117	0	195662009	4112343		0
83641	4971	4112343	2001-08-01	2001-08-01 00:00:00	2001-08-09	2001-08-09 00:00:00	32020		\N	330655	0	195662009	4112343		0
83684	4972	28060	1974-05-25	1974-05-25 00:00:00	1974-06-02	1974-06-02 00:00:00	32020		\N	330713	0	43878008	28060		0
73340	4359	40481087	1966-02-07	1966-02-07 00:00:00	1966-02-14	1966-02-14 00:00:00	32020		\N	289226	0	444814009	40481087		0
84062	4991	372328	1971-09-08	1971-09-08 00:00:00	1971-10-16	1971-10-16 00:00:00	32020		\N	332076	0	65363002	372328		0
73595	4375	40481087	1987-02-20	1987-02-20 00:00:00	1987-02-27	1987-02-27 00:00:00	32020		\N	290615	0	444814009	40481087		0
84369	5014	4112343	1960-01-09	1960-01-09 00:00:00	1960-01-21	1960-01-21 00:00:00	32020		\N	333282	0	195662009	4112343		0
84603	5031	40481087	1951-08-27	1951-08-27 00:00:00	1951-09-10	1951-09-10 00:00:00	32020		\N	334286	0	444814009	40481087		0
84681	5035	4142905	1948-04-19	1948-04-19 00:00:00	1948-07-18	1948-07-18 00:00:00	32020		\N	334618	0	33737001	4142905		0
84895	5048	4048171	1962-10-30	1962-10-30 00:00:00	1977-10-28	1977-10-28 00:00:00	32020		\N	335460	0	232353008	4048171		0
74447	4419	80180	1990-12-31	1990-12-31 00:00:00	\N	\N	32020		\N	293852	0	396275006	80180		0
74651	4433	260139	1993-07-04	1993-07-04 00:00:00	1993-07-11	1993-07-11 00:00:00	32020		\N	294645	0	10509002	260139		0
64222	3791	4112343	2007-10-19	2007-10-19 00:00:00	2007-10-28	2007-10-28 00:00:00	32020		\N	252040	0	195662009	4112343		0
64385	3803	372328	1961-12-04	1961-12-04 00:00:00	1962-03-21	1962-03-21 00:00:00	32020		\N	252809	0	65363002	372328		0
64498	3811	4112343	1967-08-31	1967-08-31 00:00:00	1967-09-10	1967-09-10 00:00:00	32020		\N	253168	0	195662009	4112343		0
75247	4470	260139	2017-08-09	2017-08-09 00:00:00	2017-08-16	2017-08-16 00:00:00	32020		\N	297393	0	10509002	260139		0
64778	3831	4237458	1971-08-20	1971-08-20 00:00:00	1971-11-18	1971-11-18 00:00:00	32020		\N	254328	0	58150001	4237458		0
65013	3844	4294548	1993-04-03	1993-04-03 00:00:00	1993-07-31	1993-07-31 00:00:00	32020		\N	255155	0	75498004	4294548		0
65140	3852	40481087	1985-06-09	1985-06-09 00:00:00	1985-06-30	1985-06-30 00:00:00	32020		\N	255650	0	444814009	40481087		0
65334	3864	40481087	1967-09-02	1967-09-02 00:00:00	1967-09-23	1967-09-23 00:00:00	32020		\N	256526	0	444814009	40481087		0
65531	3875	4283893	1983-09-24	1983-09-24 00:00:00	1983-10-22	1983-10-22 00:00:00	32020		\N	257345	0	36971009	4283893		0
76259	4525	28060	1984-05-19	1984-05-19 00:00:00	1984-05-28	1984-05-28 00:00:00	32020		\N	301298	0	43878008	28060		0
76420	4531	4109685	1916-07-19	1916-07-19 00:00:00	1916-08-02	1916-08-02 00:00:00	32020		\N	301822	0	284551006	4109685		0
66038	3906	4112343	1980-01-29	1980-01-29 00:00:00	1980-02-10	1980-02-10 00:00:00	32020		\N	259744	0	195662009	4112343		0
66233	3920	4112343	1997-07-27	1997-07-27 00:00:00	1997-08-08	1997-08-08 00:00:00	32020		\N	260645	0	195662009	4112343		0
66389	3929	4027663	1980-04-28	1980-04-28 00:00:00	\N	\N	32020		\N	261155	0	13200003	4027663		0
66488	3935	260139	1958-01-15	1958-01-15 00:00:00	1958-01-22	1958-01-22 00:00:00	32020		\N	261559	0	10509002	260139		0
77276	4577	4283893	2015-08-01	2015-08-01 00:00:00	2015-10-03	2015-10-03 00:00:00	32020		\N	304887	0	36971009	4283893		0
77396	4586	40481087	2013-01-08	2013-01-08 00:00:00	2013-01-29	2013-01-29 00:00:00	32020		\N	305466	0	444814009	40481087		0
77524	4593	4112343	2002-08-03	2002-08-03 00:00:00	2002-08-15	2002-08-15 00:00:00	32020		\N	306036	0	195662009	4112343		0
67218	3973	40481087	1978-06-10	1978-06-10 00:00:00	1978-06-17	1978-06-17 00:00:00	32020		\N	264203	0	444814009	40481087		0
88481	5259	40481087	2010-04-30	2010-04-30 00:00:00	2010-05-07	2010-05-07 00:00:00	32020		\N	349968	0	444814009	40481087		0
67558	3991	40481087	1988-08-06	1988-08-06 00:00:00	1988-08-20	1988-08-20 00:00:00	32020		\N	265383	0	444814009	40481087		0
67677	3997	40481087	1999-07-17	1999-07-17 00:00:00	1999-07-31	1999-07-31 00:00:00	32020		\N	265770	0	444814009	40481087		0
67849	4009	260139	1959-01-12	1959-01-12 00:00:00	1959-01-19	1959-01-19 00:00:00	32020		\N	266441	0	10509002	260139		0
68055	4020	381316	2014-10-02	2014-10-02 00:00:00	\N	\N	32020		\N	267274	0	230690007	381316		0
68174	4026	40481087	1980-12-31	1980-12-31 00:00:00	1981-01-07	1981-01-07 00:00:00	32020		\N	267733	0	444814009	40481087		0
78932	4675	260139	1923-01-01	1923-01-01 00:00:00	1923-01-15	1923-01-15 00:00:00	32020		\N	311492	0	10509002	260139		0
68548	4053	260139	2015-12-29	2015-12-29 00:00:00	2016-01-05	2016-01-05 00:00:00	32020		\N	269468	0	10509002	260139		0
79218	4690	4283893	1960-02-24	1960-02-24 00:00:00	1960-04-27	1960-04-27 00:00:00	32020		\N	312521	0	36971009	4283893		0
79414	4704	260139	2009-11-01	2009-11-01 00:00:00	2009-11-08	2009-11-08 00:00:00	32020		\N	313363	0	10509002	260139		0
68959	4081	40481087	1962-09-07	1962-09-07 00:00:00	1962-09-14	1962-09-14 00:00:00	32020		\N	271283	0	444814009	40481087		0
69170	4092	80180	2015-02-12	2015-02-12 00:00:00	\N	\N	32020		\N	272033	0	396275006	80180		0
79959	4738	257012	1942-06-22	1942-06-22 00:00:00	\N	\N	32020		\N	315624	0	40055000	257012		0
69404	4107	4112343	1996-09-22	1996-09-22 00:00:00	1996-10-05	1996-10-05 00:00:00	32020		\N	272903	0	195662009	4112343		0
69612	4119	40481087	2018-06-22	2018-06-22 00:00:00	2018-07-06	2018-07-06 00:00:00	32020		\N	273794	0	444814009	40481087		0
80380	4760	4112343	1975-12-11	1975-12-11 00:00:00	1975-12-24	1975-12-24 00:00:00	32020		\N	317121	0	195662009	4112343		0
70150	4153	40481087	2005-01-14	2005-01-14 00:00:00	2005-01-28	2005-01-28 00:00:00	32020		\N	276018	0	444814009	40481087		0
80896	4799	4112343	2017-11-30	2017-11-30 00:00:00	2017-12-11	2017-12-11 00:00:00	32020		\N	319264	0	195662009	4112343		0
81144	4812	28060	2002-05-25	2002-05-25 00:00:00	2002-06-06	2002-06-06 00:00:00	32020		\N	320128	0	43878008	28060		0
81277	4820	4283893	2009-02-13	2009-02-13 00:00:00	2009-06-05	2009-06-05 00:00:00	32020		\N	320607	0	36971009	4283893		0
70877	4204	260139	1950-09-15	1950-09-15 00:00:00	1950-09-29	1950-09-29 00:00:00	32020		\N	279112	0	10509002	260139		0
70988	4210	40481087	1978-06-16	1978-06-16 00:00:00	1978-06-23	1978-06-23 00:00:00	32020		\N	279571	0	444814009	40481087		0
71094	4217	372328	1987-09-10	1987-09-10 00:00:00	1989-03-01	1989-03-01 00:00:00	32020		\N	280008	0	65363002	372328		0
71336	4229	40481087	2004-04-30	2004-04-30 00:00:00	2004-05-14	2004-05-14 00:00:00	32020		\N	280979	0	444814009	40481087		0
71470	4240	40481087	1971-08-26	1971-08-26 00:00:00	1971-09-02	1971-09-02 00:00:00	32020		\N	281634	0	444814009	40481087		0
82194	4873	4027663	2010-07-08	2010-07-08 00:00:00	\N	\N	32020		\N	324128	0	13200003	4027663		0
71824	4261	40481087	1958-07-16	1958-07-16 00:00:00	1958-08-06	1958-08-06 00:00:00	32020		\N	282859	0	444814009	40481087		0
72001	4274	260139	1973-10-29	1973-10-29 00:00:00	1973-11-05	1973-11-05 00:00:00	32020		\N	283619	0	10509002	260139		0
72107	4278	40481087	2004-07-24	2004-07-24 00:00:00	2004-08-14	2004-08-14 00:00:00	32020		\N	283942	0	444814009	40481087		0
72274	4288	40481087	2004-04-28	2004-04-28 00:00:00	2004-05-05	2004-05-05 00:00:00	32020		\N	284652	0	444814009	40481087		0
83057	4933	372328	1971-02-28	1971-02-28 00:00:00	1971-05-13	1971-05-13 00:00:00	32020		\N	327978	0	65363002	372328		0
83192	4942	4109685	1981-12-08	1981-12-08 00:00:00	1981-12-29	1981-12-29 00:00:00	32020		\N	328464	0	284551006	4109685		0
72841	4329	440086	1991-03-30	1991-03-30 00:00:00	1996-04-08	1996-04-08 00:00:00	32020		\N	287121	0	192127007	440086		0
83642	4971	260139	1964-08-29	1964-08-29 00:00:00	1964-09-12	1964-09-12 00:00:00	32020		\N	330547	0	10509002	260139		0
83685	4972	4112343	1965-05-28	1965-05-28 00:00:00	1965-06-09	1965-06-09 00:00:00	32020		\N	330711	0	195662009	4112343		0
73341	4359	4112343	2017-09-28	2017-09-28 00:00:00	2017-10-05	2017-10-05 00:00:00	32020		\N	289253	0	195662009	4112343		0
84063	4991	260139	1983-01-18	1983-01-18 00:00:00	1983-02-01	1983-02-01 00:00:00	32020		\N	332029	0	10509002	260139		0
73596	4375	4112343	1996-01-03	1996-01-03 00:00:00	1996-01-14	1996-01-14 00:00:00	32020		\N	290616	0	195662009	4112343		0
84370	5014	192671	1949-01-08	1949-01-08 00:00:00	\N	\N	32020		\N	333250	0	K92.2	35208414		0
84604	5031	378001	1966-01-04	1966-01-04 00:00:00	1966-03-05	1966-03-05 00:00:00	32020		\N	334279	0	62106007	378001		0
84682	5035	81151	1935-05-07	1935-05-07 00:00:00	1935-05-28	1935-05-28 00:00:00	32020		\N	334617	0	44465007	81151		0
84896	5048	260139	1978-01-22	1978-01-22 00:00:00	1978-01-29	1978-01-29 00:00:00	32020		\N	335471	0	10509002	260139		0
74448	4419	78272	1983-07-04	1983-07-04 00:00:00	1983-08-08	1983-08-08 00:00:00	32020		\N	293820	0	70704007	78272		0
74652	4433	4027663	1973-03-09	1973-03-09 00:00:00	\N	\N	32020		\N	294720	0	13200003	4027663		0
64223	3791	40481087	1983-11-14	1983-11-14 00:00:00	1983-11-28	1983-11-28 00:00:00	32020		\N	252137	0	444814009	40481087		0
64386	3803	40481087	1961-08-12	1961-08-12 00:00:00	1961-09-02	1961-09-02 00:00:00	32020		\N	252763	0	444814009	40481087		0
64499	3811	40481087	1962-08-25	1962-08-25 00:00:00	1962-09-01	1962-09-01 00:00:00	32020		\N	253215	0	444814009	40481087		0
75248	4470	372328	1973-06-10	1973-06-10 00:00:00	1973-12-16	1973-12-16 00:00:00	32020		\N	297365	0	65363002	372328		0
64779	3831	4294548	2011-10-10	2011-10-10 00:00:00	2011-12-19	2011-12-19 00:00:00	32020		\N	254376	0	75498004	4294548		0
65014	3844	80180	1991-02-06	1991-02-06 00:00:00	\N	\N	32020		\N	255154	0	396275006	80180		0
65141	3852	40481087	1988-01-24	1988-01-24 00:00:00	1988-02-14	1988-02-14 00:00:00	32020		\N	255709	0	444814009	40481087		0
65335	3864	260139	1974-08-08	1974-08-08 00:00:00	1974-08-15	1974-08-15 00:00:00	32020		\N	256527	0	10509002	260139		0
65532	3875	4142905	1967-09-23	1967-09-23 00:00:00	1967-11-22	1967-11-22 00:00:00	32020		\N	257378	0	33737001	4142905		0
76260	4525	257012	1987-09-14	1987-09-14 00:00:00	1988-01-04	1988-01-04 00:00:00	32020		\N	301271	0	40055000	257012		0
76421	4531	260139	1916-05-21	1916-05-21 00:00:00	1916-05-28	1916-05-28 00:00:00	32020		\N	301681	0	10509002	260139		0
66039	3906	4059173	2011-04-02	2011-04-02 00:00:00	2011-06-01	2011-06-01 00:00:00	32020		\N	259730	0	16114001	4059173		0
66234	3920	372328	1974-12-01	1974-12-01 00:00:00	1975-02-01	1975-02-01 00:00:00	32020		\N	260689	0	65363002	372328		0
66390	3929	40481087	1978-04-10	1978-04-10 00:00:00	1978-05-01	1978-05-01 00:00:00	32020		\N	261155	0	444814009	40481087		0
66489	3935	4112343	1973-02-26	1973-02-26 00:00:00	1973-03-06	1973-03-06 00:00:00	32020		\N	261544	0	195662009	4112343		0
77277	4578	40481087	1990-12-14	1990-12-14 00:00:00	1991-01-04	1991-01-04 00:00:00	32020		\N	304979	0	444814009	40481087		0
77397	4586	40481087	1982-12-31	1982-12-31 00:00:00	1983-01-14	1983-01-14 00:00:00	32020		\N	305487	0	444814009	40481087		0
77525	4593	40481087	1996-10-08	1996-10-08 00:00:00	1996-10-22	1996-10-22 00:00:00	32020		\N	306081	0	444814009	40481087		0
67219	3973	80180	2004-03-03	2004-03-03 00:00:00	\N	\N	32020		\N	264200	0	396275006	80180		0
88482	5259	40481087	1972-02-10	1972-02-10 00:00:00	1972-02-24	1972-02-24 00:00:00	32020		\N	349934	0	444814009	40481087		0
67559	3991	4027663	1973-09-22	1973-09-22 00:00:00	\N	\N	32020		\N	265328	0	13200003	4027663		0
67678	3997	260139	1987-02-16	1987-02-16 00:00:00	1987-03-02	1987-03-02 00:00:00	32020		\N	265768	0	10509002	260139		0
67850	4009	40481087	1984-12-03	1984-12-03 00:00:00	1984-12-17	1984-12-17 00:00:00	32020		\N	266389	0	444814009	40481087		0
68056	4020	80502	2016-04-28	2016-04-28 00:00:00	\N	\N	32020		\N	267275	0	64859006	80502		0
68175	4026	4112343	1994-10-11	1994-10-11 00:00:00	1994-10-18	1994-10-18 00:00:00	32020		\N	267747	0	195662009	4112343		0
78933	4675	372328	1915-05-12	1915-05-12 00:00:00	1915-06-06	1915-06-06 00:00:00	32020		\N	311443	0	65363002	372328		0
68549	4053	4296204	2014-09-24	2014-09-24 00:00:00	2014-10-08	2014-10-08 00:00:00	32020		\N	269420	0	403190006	4296204		0
79219	4690	4278672	1959-02-24	1959-02-24 00:00:00	1959-04-25	1959-04-25 00:00:00	32020		\N	312519	0	65966004	4278672		0
79415	4704	4266809	2010-07-25	2010-07-25 00:00:00	\N	\N	32020		\N	313363	0	397881000	4266809		0
68960	4081	40481087	1974-04-13	1974-04-13 00:00:00	1974-04-20	1974-04-20 00:00:00	32020		\N	271285	0	444814009	40481087		0
69171	4092	28060	1996-08-08	1996-08-08 00:00:00	1996-08-18	1996-08-18 00:00:00	32020		\N	272045	0	43878008	28060		0
79960	4738	4266809	1944-12-27	1944-12-27 00:00:00	\N	\N	32020		\N	315659	0	397881000	4266809		0
69405	4107	28060	1987-04-18	1987-04-18 00:00:00	1987-05-01	1987-05-01 00:00:00	32020		\N	272928	0	43878008	28060		0
69613	4119	260139	2018-04-10	2018-04-10 00:00:00	2018-04-17	2018-04-17 00:00:00	32020		\N	273873	0	10509002	260139		0
80929	4800	4285898	2008-08-11	2008-08-11 00:00:00	\N	\N	32020		\N	319353	0	68496003	4285898		0
80381	4760	4142905	1972-07-31	1972-07-31 00:00:00	1972-10-29	1972-10-29 00:00:00	32020		\N	317198	0	33737001	4142905		0
70151	4153	81893	1999-10-31	1999-10-31 00:00:00	\N	\N	32020		\N	276007	0	64766004	81893		0
80897	4799	4283893	1963-02-25	1963-02-25 00:00:00	1963-05-27	1963-05-27 00:00:00	32020		\N	319214	0	36971009	4283893		0
81145	4812	4112343	1991-02-15	1991-02-15 00:00:00	1991-02-26	1991-02-26 00:00:00	32020		\N	320136	0	195662009	4112343		0
81278	4820	81151	1956-11-20	1956-11-20 00:00:00	1956-12-04	1956-12-04 00:00:00	32020		\N	320641	0	44465007	81151		0
70878	4205	4285898	2010-07-17	2010-07-17 00:00:00	\N	\N	32020		\N	279224	0	68496003	4285898		0
70989	4210	78272	1990-02-20	1990-02-20 00:00:00	1990-03-06	1990-03-06 00:00:00	32020		\N	279578	0	70704007	78272		0
71095	4217	4112343	1965-06-09	1965-06-09 00:00:00	1965-06-17	1965-06-17 00:00:00	32020		\N	279971	0	195662009	4112343		0
71337	4229	4112343	1954-11-24	1954-11-24 00:00:00	1954-12-01	1954-12-01 00:00:00	32020		\N	280959	0	195662009	4112343		0
71471	4240	4112343	2003-11-17	2003-11-17 00:00:00	2003-11-29	2003-11-29 00:00:00	32020		\N	281674	0	195662009	4112343		0
82195	4873	28060	2009-09-07	2009-09-07 00:00:00	2009-09-17	2009-09-17 00:00:00	32020		\N	324128	0	43878008	28060		0
71825	4261	40481087	1987-03-05	1987-03-05 00:00:00	1987-03-19	1987-03-19 00:00:00	32020		\N	282966	0	444814009	40481087		0
72002	4274	28060	1930-03-10	1930-03-10 00:00:00	1930-03-23	1930-03-23 00:00:00	32020		\N	283661	0	43878008	28060		0
72108	4279	28060	1954-01-20	1954-01-20 00:00:00	1954-01-30	1954-01-30 00:00:00	32020		\N	283960	0	43878008	28060		0
72275	4288	372328	1953-06-29	1953-06-29 00:00:00	1953-07-13	1953-07-13 00:00:00	32020		\N	284654	0	65363002	372328		0
83058	4933	81151	1986-08-27	1986-08-27 00:00:00	1986-10-01	1986-10-01 00:00:00	32020		\N	327969	0	44465007	81151		0
83193	4942	40481087	1961-07-23	1961-07-23 00:00:00	1961-07-30	1961-07-30 00:00:00	32020		\N	328518	0	444814009	40481087		0
72842	4329	4294548	2018-11-04	2018-11-04 00:00:00	2018-12-30	2018-12-30 00:00:00	32020		\N	287075	0	75498004	4294548		0
83643	4971	381316	2007-09-04	2007-09-04 00:00:00	\N	\N	32020		\N	330506	0	230690007	381316		0
83686	4972	4230399	1999-08-20	1999-08-20 00:00:00	1999-09-19	1999-09-19 00:00:00	32020		\N	330664	0	359817006	4230399		0
73342	4359	40481087	2010-07-11	2010-07-11 00:00:00	2010-07-25	2010-07-25 00:00:00	32020		\N	289258	0	444814009	40481087		0
84064	4992	440086	1995-05-14	1995-05-14 00:00:00	1998-05-31	1998-05-31 00:00:00	32020		\N	332124	0	192127007	440086		0
73597	4375	4112343	1946-04-14	1946-04-14 00:00:00	1946-04-21	1946-04-21 00:00:00	32020		\N	290612	0	195662009	4112343		0
84371	5014	28060	1916-09-24	1916-09-24 00:00:00	1916-10-05	1916-10-05 00:00:00	32020		\N	333247	0	43878008	28060		0
84605	5031	80502	2000-10-14	2000-10-14 00:00:00	\N	\N	32020		\N	334341	0	64859006	80502		0
84683	5035	4283893	2003-07-19	2003-07-19 00:00:00	2003-08-02	2003-08-02 00:00:00	32020		\N	334567	0	36971009	4283893		0
84897	5048	80180	1991-10-06	1991-10-06 00:00:00	\N	\N	32020		\N	335507	0	396275006	80180		0
74449	4419	378001	2010-02-17	2010-02-17 00:00:00	2010-04-18	2010-04-18 00:00:00	32020		\N	293821	0	62106007	378001		0
74653	4433	40481087	1971-10-15	1971-10-15 00:00:00	1971-11-05	1971-11-05 00:00:00	32020		\N	294720	0	444814009	40481087		0
64224	3791	4146173	2002-01-31	2002-01-31 00:00:00	2002-04-01	2002-04-01 00:00:00	32020		\N	252149	0	307731004	4146173		0
64387	3803	40481087	1978-04-06	1978-04-06 00:00:00	1978-04-20	1978-04-20 00:00:00	32020		\N	252769	0	444814009	40481087		0
64500	3811	4112343	2007-03-06	2007-03-06 00:00:00	2007-03-19	2007-03-19 00:00:00	32020		\N	253222	0	195662009	4112343		0
75249	4470	4112343	1999-07-08	1999-07-08 00:00:00	1999-07-16	1999-07-16 00:00:00	32020		\N	297378	0	195662009	4112343		0
64780	3831	40481087	1987-10-25	1987-10-25 00:00:00	1987-11-08	1987-11-08 00:00:00	32020		\N	254374	0	444814009	40481087		0
65015	3844	4112343	1990-10-20	1990-10-20 00:00:00	1990-10-27	1990-10-27 00:00:00	32020		\N	255154	0	195662009	4112343		0
65142	3852	40481087	1978-11-23	1978-11-23 00:00:00	1978-11-30	1978-11-30 00:00:00	32020		\N	255629	0	444814009	40481087		0
65336	3864	260139	1966-11-03	1966-11-03 00:00:00	1966-11-17	1966-11-17 00:00:00	32020		\N	256514	0	10509002	260139		0
65533	3875	40481087	2013-08-30	2013-08-30 00:00:00	2013-09-13	2013-09-13 00:00:00	32020		\N	257350	0	444814009	40481087		0
76261	4525	4283893	1987-07-06	1987-07-06 00:00:00	1988-01-04	1988-01-04 00:00:00	32020		\N	301260	0	36971009	4283893		0
76422	4531	317576	1994-10-29	1994-10-29 00:00:00	\N	\N	32020		\N	301684	0	53741008	317576		0
66040	3906	40481087	1993-02-23	1993-02-23 00:00:00	1993-03-16	1993-03-16 00:00:00	32020		\N	259664	0	444814009	40481087		0
76693	4546	40481087	1990-07-29	1990-07-29 00:00:00	1990-08-05	1990-08-05 00:00:00	32020		\N	302816	0	444814009	40481087		0
66391	3929	4155034	1992-04-01	1992-04-01 00:00:00	1992-04-15	1992-04-15 00:00:00	32020		\N	261150	0	283371005	4155034		0
66490	3935	260139	1987-05-16	1987-05-16 00:00:00	1987-05-30	1987-05-30 00:00:00	32020		\N	261553	0	10509002	260139		0
77278	4578	260139	1970-11-21	1970-11-21 00:00:00	1970-11-28	1970-11-28 00:00:00	32020		\N	304919	0	10509002	260139		0
77398	4586	4112343	2003-08-22	2003-08-22 00:00:00	2003-08-30	2003-08-30 00:00:00	32020		\N	305508	0	195662009	4112343		0
77526	4593	4294548	1992-05-06	1992-05-06 00:00:00	1992-05-27	1992-05-27 00:00:00	32020		\N	306080	0	75498004	4294548		0
67220	3973	40481087	1995-03-03	1995-03-03 00:00:00	1995-03-10	1995-03-10 00:00:00	32020		\N	264170	0	444814009	40481087		0
88483	5259	4109685	2004-05-19	2004-05-19 00:00:00	2004-06-09	2004-06-09 00:00:00	32020		\N	350004	0	284551006	4109685		0
67560	3991	4294548	1969-03-30	1969-03-30 00:00:00	1969-08-03	1969-08-03 00:00:00	32020		\N	265326	0	75498004	4294548		0
67679	3997	40481087	2013-03-22	2013-03-22 00:00:00	2013-04-12	2013-04-12 00:00:00	32020		\N	265733	0	444814009	40481087		0
67851	4010	4029498	1977-05-05	1977-05-05 00:00:00	\N	\N	32020		\N	266485	0	128613002	4029498		0
68057	4020	372328	1960-10-27	1960-10-27 00:00:00	1961-02-09	1961-02-09 00:00:00	32020		\N	267257	0	65363002	372328		0
68176	4026	28060	2018-04-01	2018-04-01 00:00:00	2018-04-13	2018-04-13 00:00:00	32020		\N	267601	0	43878008	28060		0
78934	4675	40481087	1947-09-25	1947-09-25 00:00:00	1947-10-16	1947-10-16 00:00:00	32020		\N	311546	0	444814009	40481087		0
68550	4053	4112343	1994-03-07	1994-03-07 00:00:00	1994-03-19	1994-03-19 00:00:00	32020		\N	269476	0	195662009	4112343		0
79220	4690	4155034	1992-05-04	1992-05-04 00:00:00	1992-05-25	1992-05-25 00:00:00	32020		\N	312468	0	283371005	4155034		0
79416	4704	80180	2010-07-25	2010-07-25 00:00:00	\N	\N	32020		\N	313363	0	396275006	80180		0
68961	4081	4112343	1962-07-01	1962-07-01 00:00:00	1962-07-14	1962-07-14 00:00:00	32020		\N	271282	0	195662009	4112343		0
69172	4092	4112343	1996-11-19	1996-11-19 00:00:00	1996-12-02	1996-12-02 00:00:00	32020		\N	272046	0	195662009	4112343		0
79961	4738	80180	1944-12-27	1944-12-27 00:00:00	\N	\N	32020		\N	315659	0	396275006	80180		0
69406	4107	40481087	1987-12-19	1987-12-19 00:00:00	1987-12-26	1987-12-26 00:00:00	32020		\N	272904	0	444814009	40481087		0
69614	4119	195588	1967-07-17	1967-07-17 00:00:00	1967-08-18	1967-08-18 00:00:00	32020		\N	273844	0	38822007	195588		0
80382	4760	381316	2018-03-28	2018-03-28 00:00:00	\N	\N	32020		\N	317165	0	230690007	381316		0
70152	4153	4149245	1999-11-01	1999-11-01 00:00:00	1999-12-08	1999-12-08 00:00:00	32020		\N	276007	0	30832001	4149245		0
80898	4799	40481087	1971-03-09	1971-03-09 00:00:00	1971-03-30	1971-03-30 00:00:00	32020		\N	319216	0	444814009	40481087		0
81157	4814	260139	2000-05-07	2000-05-07 00:00:00	2000-05-14	2000-05-14 00:00:00	32020		\N	320304	0	10509002	260139		0
81279	4820	4109685	1966-01-28	1966-01-28 00:00:00	1966-02-18	1966-02-18 00:00:00	32020		\N	320644	0	284551006	4109685		0
70879	4205	40481087	1999-02-19	1999-02-19 00:00:00	1999-02-26	1999-02-26 00:00:00	32020		\N	279250	0	444814009	40481087		0
70990	4210	40481087	1995-09-11	1995-09-11 00:00:00	1995-10-02	1995-10-02 00:00:00	32020		\N	279516	0	444814009	40481087		0
71096	4217	40481087	2012-07-09	2012-07-09 00:00:00	2012-07-23	2012-07-23 00:00:00	32020		\N	280036	0	444814009	40481087		0
71338	4229	40481087	1999-12-23	1999-12-23 00:00:00	2000-01-13	2000-01-13 00:00:00	32020		\N	280936	0	444814009	40481087		0
71472	4240	40481087	1998-07-04	1998-07-04 00:00:00	1998-07-11	1998-07-11 00:00:00	32020		\N	281628	0	444814009	40481087		0
82196	4873	4310024	2017-01-02	2017-01-02 00:00:00	\N	\N	32020		\N	324141	0	424802006	4310024		0
71826	4261	378001	1993-08-08	1993-08-08 00:00:00	1993-10-07	1993-10-07 00:00:00	32020		\N	282893	0	62106007	378001		0
72003	4274	260139	1947-05-09	1947-05-09 00:00:00	1947-05-23	1947-05-23 00:00:00	32020		\N	283664	0	10509002	260139		0
72109	4279	40481087	1969-05-11	1969-05-11 00:00:00	1969-05-25	1969-05-25 00:00:00	32020		\N	283946	0	444814009	40481087		0
72276	4289	40481087	1957-12-03	1957-12-03 00:00:00	1957-12-17	1957-12-17 00:00:00	32020		\N	284735	0	444814009	40481087		0
83059	4933	4027663	2000-02-26	2000-02-26 00:00:00	\N	\N	32020		\N	327926	0	13200003	4027663		0
83194	4942	30753	1985-11-12	1985-11-12 00:00:00	\N	\N	32020		\N	328497	0	16761005	30753		0
72843	4329	4112343	2013-10-04	2013-10-04 00:00:00	2013-10-17	2013-10-17 00:00:00	32020		\N	287124	0	195662009	4112343		0
83644	4971	372328	1991-08-06	1991-08-06 00:00:00	1991-10-15	1991-10-15 00:00:00	32020		\N	330656	0	65363002	372328		0
83687	4972	4112343	1954-09-27	1954-09-27 00:00:00	1954-10-06	1954-10-06 00:00:00	32020		\N	330666	0	195662009	4112343		0
73343	4359	40481087	1959-09-21	1959-09-21 00:00:00	1959-10-05	1959-10-05 00:00:00	32020		\N	289177	0	444814009	40481087		0
84066	4992	28060	2014-03-01	2014-03-01 00:00:00	2014-03-14	2014-03-14 00:00:00	32020		\N	332097	0	43878008	28060		0
73598	4375	260139	1966-07-08	1966-07-08 00:00:00	1966-07-22	1966-07-22 00:00:00	32020		\N	290605	0	10509002	260139		0
84372	5014	258780	1985-10-22	1985-10-22 00:00:00	\N	\N	32020		\N	333307	0	185086009	258780		0
84606	5031	4112343	1985-10-28	1985-10-28 00:00:00	1985-11-07	1985-11-07 00:00:00	32020		\N	334364	0	195662009	4112343		0
84684	5035	4027663	1961-05-25	1961-05-25 00:00:00	\N	\N	32020		\N	334607	0	13200003	4027663		0
84898	5048	260139	1995-02-26	1995-02-26 00:00:00	1995-03-12	1995-03-12 00:00:00	32020		\N	335500	0	10509002	260139		0
74450	4419	40481087	1980-04-13	1980-04-13 00:00:00	1980-05-04	1980-05-04 00:00:00	32020		\N	293865	0	444814009	40481087		0
74654	4433	192671	1982-08-13	1982-08-13 00:00:00	\N	\N	32020		\N	294732	0	K92.2	35208414		0
64225	3791	260139	1944-06-01	1944-06-01 00:00:00	1944-06-15	1944-06-15 00:00:00	32020		\N	252046	0	10509002	260139		0
64388	3803	4109685	2011-04-21	2011-04-21 00:00:00	2011-05-05	2011-05-05 00:00:00	32020		\N	252802	0	284551006	4109685		0
64501	3811	260139	1963-10-02	1963-10-02 00:00:00	1963-10-16	1963-10-16 00:00:00	32020		\N	253119	0	10509002	260139		0
75250	4470	40481087	1996-04-05	1996-04-05 00:00:00	1996-04-19	1996-04-19 00:00:00	32020		\N	297377	0	444814009	40481087		0
64781	3831	40481087	1965-12-30	1965-12-30 00:00:00	1966-01-13	1966-01-13 00:00:00	32020		\N	254373	0	444814009	40481087		0
65016	3844	4112343	2000-12-04	2000-12-04 00:00:00	2000-12-13	2000-12-13 00:00:00	32020		\N	255143	0	195662009	4112343		0
65144	3852	321042	2008-03-31	2008-03-31 00:00:00	\N	\N	32020		\N	255634	0	410429000	321042		0
65337	3864	40481087	1995-06-10	1995-06-10 00:00:00	1995-06-24	1995-06-24 00:00:00	32020		\N	256529	0	444814009	40481087		0
65534	3875	28060	1965-04-16	1965-04-16 00:00:00	1965-04-23	1965-04-23 00:00:00	32020		\N	257343	0	43878008	28060		0
76262	4525	81151	1973-06-03	1973-06-03 00:00:00	1973-06-24	1973-06-24 00:00:00	32020		\N	301266	0	44465007	81151		0
76423	4531	257012	1987-08-05	1987-08-05 00:00:00	\N	\N	32020		\N	301750	0	40055000	257012		0
66041	3906	80180	1984-04-28	1984-04-28 00:00:00	\N	\N	32020		\N	259662	0	396275006	80180		0
76694	4546	4112343	1982-10-17	1982-10-17 00:00:00	1982-10-24	1982-10-24 00:00:00	32020		\N	302814	0	195662009	4112343		0
66392	3930	40481087	1927-02-28	1927-02-28 00:00:00	1927-03-14	1927-03-14 00:00:00	32020		\N	261264	0	444814009	40481087		0
66491	3935	28060	1987-10-23	1987-10-23 00:00:00	1987-11-01	1987-11-01 00:00:00	32020		\N	261567	0	43878008	28060		0
77279	4578	4218389	1967-01-09	1967-01-09 00:00:00	1967-02-06	1967-02-06 00:00:00	32020		\N	304986	0	39848009	4218389		0
77399	4586	30753	1991-02-07	1991-02-07 00:00:00	\N	\N	32020		\N	305507	0	16761005	30753		0
77527	4593	40481087	2011-08-02	2011-08-02 00:00:00	2011-08-23	2011-08-23 00:00:00	32020		\N	306064	0	444814009	40481087		0
67221	3973	4027663	1995-07-19	1995-07-19 00:00:00	\N	\N	32020		\N	264170	0	13200003	4027663		0
88484	5259	81151	1972-10-13	1972-10-13 00:00:00	1972-11-03	1972-11-03 00:00:00	32020		\N	350002	0	44465007	81151		0
67561	3991	4283893	1971-02-02	1971-02-02 00:00:00	1971-03-02	1971-03-02 00:00:00	32020		\N	265392	0	36971009	4283893		0
67680	3997	40481087	1979-11-11	1979-11-11 00:00:00	1979-11-18	1979-11-18 00:00:00	32020		\N	265766	0	444814009	40481087		0
67852	4010	380378	1977-05-05	1977-05-05 00:00:00	\N	\N	32020		\N	266485	0	84757009	380378		0
68058	4020	4283893	1973-08-05	1973-08-05 00:00:00	1974-01-20	1974-01-20 00:00:00	32020		\N	267267	0	36971009	4283893		0
68177	4026	372328	1960-10-12	1960-10-12 00:00:00	1961-01-01	1961-01-01 00:00:00	32020		\N	267628	0	65363002	372328		0
78935	4675	80180	1948-01-09	1948-01-09 00:00:00	\N	\N	32020		\N	311546	0	396275006	80180		0
68551	4053	260139	1965-06-18	1965-06-18 00:00:00	1965-06-25	1965-06-25 00:00:00	32020		\N	269448	0	10509002	260139		0
79221	4690	40481087	1975-04-12	1975-04-12 00:00:00	1975-04-19	1975-04-19 00:00:00	32020		\N	312454	0	444814009	40481087		0
79417	4704	40481087	1970-09-28	1970-09-28 00:00:00	1970-10-05	1970-10-05 00:00:00	32020		\N	313393	0	444814009	40481087		0
68962	4081	40481087	1978-12-03	1978-12-03 00:00:00	1978-12-24	1978-12-24 00:00:00	32020		\N	271255	0	444814009	40481087		0
69173	4092	4112343	2007-04-04	2007-04-04 00:00:00	2007-04-14	2007-04-14 00:00:00	32020		\N	272048	0	195662009	4112343		0
79962	4738	40481087	1922-11-08	1922-11-08 00:00:00	1922-11-22	1922-11-22 00:00:00	32020		\N	315654	0	444814009	40481087		0
69407	4107	40481087	2012-01-06	2012-01-06 00:00:00	2012-01-20	2012-01-20 00:00:00	32020		\N	272891	0	444814009	40481087		0
69615	4119	81151	1949-04-27	1949-04-27 00:00:00	1949-06-01	1949-06-01 00:00:00	32020		\N	273808	0	44465007	81151		0
80383	4760	40481087	2018-05-06	2018-05-06 00:00:00	2018-05-20	2018-05-20 00:00:00	32020		\N	317179	0	444814009	40481087		0
70153	4153	260139	2015-03-20	2015-03-20 00:00:00	2015-04-03	2015-04-03 00:00:00	32020		\N	276039	0	10509002	260139		0
80899	4799	372328	1958-04-15	1958-04-15 00:00:00	1958-07-26	1958-07-26 00:00:00	32020		\N	319265	0	65363002	372328		0
81158	4814	80180	1981-10-17	1981-10-17 00:00:00	\N	\N	32020		\N	320282	0	396275006	80180		0
81280	4820	40481087	1977-08-23	1977-08-23 00:00:00	1977-09-06	1977-09-06 00:00:00	32020		\N	320650	0	444814009	40481087		0
70880	4205	4027663	2000-12-31	2000-12-31 00:00:00	\N	\N	32020		\N	279208	0	13200003	4027663		0
70991	4210	81151	1979-01-28	1979-01-28 00:00:00	1979-02-18	1979-02-18 00:00:00	32020		\N	279576	0	44465007	81151		0
71097	4217	4152936	1965-10-05	1965-10-05 00:00:00	1965-10-19	1965-10-19 00:00:00	32020		\N	279908	0	283385000	4152936		0
71339	4229	81151	1974-07-29	1974-07-29 00:00:00	1974-08-19	1974-08-19 00:00:00	32020		\N	280923	0	44465007	81151		0
71473	4240	4296204	1943-06-11	1943-06-11 00:00:00	1943-07-16	1943-07-16 00:00:00	32020		\N	281590	0	403190006	4296204		0
82197	4873	4112343	2017-11-16	2017-11-16 00:00:00	2017-11-25	2017-11-25 00:00:00	32020		\N	324097	0	195662009	4112343		0
71827	4261	40481087	1925-09-29	1925-09-29 00:00:00	1925-10-20	1925-10-20 00:00:00	32020		\N	282935	0	444814009	40481087		0
72004	4274	40481087	1928-02-26	1928-02-26 00:00:00	1928-03-11	1928-03-11 00:00:00	32020		\N	283616	0	444814009	40481087		0
72110	4279	40481087	1964-08-30	1964-08-30 00:00:00	1964-09-06	1964-09-06 00:00:00	32020		\N	283961	0	444814009	40481087		0
72277	4289	40481087	1959-05-17	1959-05-17 00:00:00	1959-05-31	1959-05-31 00:00:00	32020		\N	284736	0	444814009	40481087		0
83060	4933	4283893	1972-12-26	1972-12-26 00:00:00	1973-04-17	1973-04-17 00:00:00	32020		\N	327939	0	36971009	4283893		0
83195	4942	4266809	1986-12-07	1986-12-07 00:00:00	\N	\N	32020		\N	328497	0	397881000	4266809		0
83645	4971	4112343	1993-11-11	1993-11-11 00:00:00	1993-11-24	1993-11-24 00:00:00	32020		\N	330644	0	195662009	4112343		0
83688	4972	4283893	1977-05-02	1977-05-02 00:00:00	1977-05-23	1977-05-23 00:00:00	32020		\N	330714	0	36971009	4283893		0
73344	4359	78272	1959-12-13	1959-12-13 00:00:00	1960-01-10	1960-01-10 00:00:00	32020		\N	289211	0	70704007	78272		0
84067	4992	40481087	1989-04-30	1989-04-30 00:00:00	1989-05-07	1989-05-07 00:00:00	32020		\N	332139	0	444814009	40481087		0
73599	4375	40481087	2017-02-26	2017-02-26 00:00:00	2017-03-12	2017-03-12 00:00:00	32020		\N	290625	0	444814009	40481087		0
84373	5014	4134304	1938-02-20	1938-02-20 00:00:00	1938-03-22	1938-03-22 00:00:00	32020		\N	333252	0	263102004	4134304		0
84607	5031	40481087	1983-11-28	1983-11-28 00:00:00	1983-12-05	1983-12-05 00:00:00	32020		\N	334418	0	444814009	40481087		0
84685	5035	40481087	1997-02-06	1997-02-06 00:00:00	1997-02-13	1997-02-13 00:00:00	32020		\N	334649	0	444814009	40481087		0
84899	5048	4112343	2003-12-24	2003-12-24 00:00:00	2003-12-31	2003-12-31 00:00:00	32020		\N	335443	0	195662009	4112343		0
74451	4419	81151	2013-03-03	2013-03-03 00:00:00	2013-03-24	2013-03-24 00:00:00	32020		\N	293822	0	44465007	81151		0
74655	4433	4296204	2014-12-26	2014-12-26 00:00:00	2015-01-16	2015-01-16 00:00:00	32020		\N	294730	0	403190006	4296204		0
64226	3791	4152936	1966-03-27	1966-03-27 00:00:00	1966-04-10	1966-04-10 00:00:00	32020		\N	252159	0	283385000	4152936		0
64389	3803	78272	2000-12-09	2000-12-09 00:00:00	2001-01-13	2001-01-13 00:00:00	32020		\N	252801	0	70704007	78272		0
64502	3811	4218389	1945-04-17	1945-04-17 00:00:00	1945-05-08	1945-05-08 00:00:00	32020		\N	253141	0	39848009	4218389		0
75251	4470	4112343	1997-11-04	1997-11-04 00:00:00	1997-11-11	1997-11-11 00:00:00	32020		\N	297361	0	195662009	4112343		0
64782	3831	40481087	1960-01-04	1960-01-04 00:00:00	1960-01-25	1960-01-25 00:00:00	32020		\N	254356	0	444814009	40481087		0
65017	3844	40481087	1958-11-04	1958-11-04 00:00:00	1958-11-25	1958-11-25 00:00:00	32020		\N	255123	0	444814009	40481087		0
65145	3852	260139	1982-09-20	1982-09-20 00:00:00	1982-10-04	1982-10-04 00:00:00	32020		\N	255615	0	10509002	260139		0
65338	3864	80180	2007-12-16	2007-12-16 00:00:00	\N	\N	32020		\N	256497	0	396275006	80180		0
65535	3875	40481087	1969-11-18	1969-11-18 00:00:00	1969-11-25	1969-11-25 00:00:00	32020		\N	257344	0	444814009	40481087		0
76263	4525	40481087	1994-05-11	1994-05-11 00:00:00	1994-05-18	1994-05-18 00:00:00	32020		\N	301303	0	444814009	40481087		0
76424	4531	4156265	2017-04-15	2017-04-15 00:00:00	2017-04-29	2017-04-29 00:00:00	32020		\N	301710	0	370247008	4156265		0
66042	3906	40481087	2011-03-02	2011-03-02 00:00:00	2011-03-09	2011-03-09 00:00:00	32020		\N	259733	0	444814009	40481087		0
76695	4546	28060	2015-12-02	2015-12-02 00:00:00	2015-12-09	2015-12-09 00:00:00	32020		\N	302818	0	43878008	28060		0
66393	3930	28060	1923-04-18	1923-04-18 00:00:00	1923-04-27	1923-04-27 00:00:00	32020		\N	261238	0	43878008	28060		0
66492	3935	4155034	1983-02-07	1983-02-07 00:00:00	1983-02-21	1983-02-21 00:00:00	32020		\N	261543	0	283371005	4155034		0
77280	4578	4109685	1981-10-20	1981-10-20 00:00:00	1981-11-10	1981-11-10 00:00:00	32020		\N	305003	0	284551006	4109685		0
77400	4586	81893	1990-04-13	1990-04-13 00:00:00	\N	\N	32020		\N	305507	0	64766004	81893		0
77528	4593	40481087	2001-02-04	2001-02-04 00:00:00	2001-02-18	2001-02-18 00:00:00	32020		\N	306063	0	444814009	40481087		0
67222	3973	4112343	2007-07-25	2007-07-25 00:00:00	2007-08-03	2007-08-03 00:00:00	32020		\N	264180	0	195662009	4112343		0
88485	5259	28060	1966-05-20	1966-05-20 00:00:00	1966-05-31	1966-05-31 00:00:00	32020		\N	349933	0	43878008	28060		0
67562	3991	4112343	2004-01-24	2004-01-24 00:00:00	2004-02-06	2004-02-06 00:00:00	32020		\N	265345	0	195662009	4112343		0
67681	3997	81151	1979-06-07	1979-06-07 00:00:00	1979-06-21	1979-06-21 00:00:00	32020		\N	265701	0	44465007	81151		0
67854	4010	40481087	2015-06-03	2015-06-03 00:00:00	2015-06-17	2015-06-17 00:00:00	32020		\N	266495	0	444814009	40481087		0
68059	4020	28060	1979-07-15	1979-07-15 00:00:00	1979-07-27	1979-07-27 00:00:00	32020		\N	267197	0	43878008	28060		0
68178	4026	4112343	1980-07-14	1980-07-14 00:00:00	1980-07-22	1980-07-22 00:00:00	32020		\N	267663	0	195662009	4112343		0
78936	4675	4278672	2007-12-06	2007-12-06 00:00:00	2008-01-05	2008-01-05 00:00:00	32020		\N	311449	0	65966004	4278672		0
68552	4053	4112343	1991-07-07	1991-07-07 00:00:00	1991-07-20	1991-07-20 00:00:00	32020		\N	269475	0	195662009	4112343		0
79222	4690	4156265	1991-05-26	1991-05-26 00:00:00	1991-06-09	1991-06-09 00:00:00	32020		\N	312467	0	370247008	4156265		0
79418	4704	4113008	1998-04-13	1998-04-13 00:00:00	1998-04-27	1998-04-27 00:00:00	32020		\N	313432	0	284549007	4113008		0
68963	4081	4112343	1956-12-03	1956-12-03 00:00:00	1956-12-14	1956-12-14 00:00:00	32020		\N	271221	0	195662009	4112343		0
69174	4092	4112343	2007-02-22	2007-02-22 00:00:00	2007-03-03	2007-03-03 00:00:00	32020		\N	272022	0	195662009	4112343		0
79963	4738	260139	1917-11-05	1917-11-05 00:00:00	1917-11-12	1917-11-12 00:00:00	32020		\N	315640	0	10509002	260139		0
69408	4107	4112343	2018-01-15	2018-01-15 00:00:00	2018-01-27	2018-01-27 00:00:00	32020		\N	272893	0	195662009	4112343		0
69617	4119	28060	1949-10-12	1949-10-12 00:00:00	1949-10-23	1949-10-23 00:00:00	32020		\N	273792	0	43878008	28060		0
80384	4760	28060	1968-09-06	1968-09-06 00:00:00	1968-09-17	1968-09-17 00:00:00	32020		\N	317174	0	43878008	28060		0
70154	4153	4146173	1990-06-21	1990-06-21 00:00:00	1990-07-21	1990-07-21 00:00:00	32020		\N	276017	0	307731004	4146173		0
80900	4799	378001	1997-06-29	1997-06-29 00:00:00	1997-07-29	1997-07-29 00:00:00	32020		\N	319247	0	62106007	378001		0
81159	4814	28060	1936-12-11	1936-12-11 00:00:00	1936-12-18	1936-12-18 00:00:00	32020		\N	320299	0	43878008	28060		0
81281	4820	4112343	1968-02-04	1968-02-04 00:00:00	1968-02-15	1968-02-15 00:00:00	32020		\N	320618	0	195662009	4112343		0
70881	4205	40481087	2000-12-26	2000-12-26 00:00:00	2001-01-16	2001-01-16 00:00:00	32020		\N	279208	0	444814009	40481087		0
71005	4212	4112343	2015-06-26	2015-06-26 00:00:00	2015-07-09	2015-07-09 00:00:00	32020		\N	279684	0	195662009	4112343		0
71098	4217	4112343	1976-01-11	1976-01-11 00:00:00	1976-01-19	1976-01-19 00:00:00	32020		\N	279947	0	195662009	4112343		0
71340	4229	134438	1979-06-22	1979-06-22 00:00:00	1980-06-16	1980-06-16 00:00:00	32020		\N	280955	0	40275004	134438		0
71474	4240	317576	2010-11-08	2010-11-08 00:00:00	\N	\N	32020		\N	281660	0	53741008	317576		0
82198	4873	4112343	1980-11-25	1980-11-25 00:00:00	1980-12-04	1980-12-04 00:00:00	32020		\N	324104	0	195662009	4112343		0
71828	4261	80180	1954-09-25	1954-09-25 00:00:00	\N	\N	32020		\N	282905	0	396275006	80180		0
72005	4274	4278672	2002-07-03	2002-07-03 00:00:00	2002-10-01	2002-10-01 00:00:00	32020		\N	283562	0	65966004	4278672		0
72111	4279	440086	1964-04-03	1964-04-03 00:00:00	1968-04-12	1968-04-12 00:00:00	32020		\N	283945	0	192127007	440086		0
72278	4289	4134304	1952-07-01	1952-07-01 00:00:00	1952-08-30	1952-08-30 00:00:00	32020		\N	284740	0	263102004	4134304		0
83061	4933	4112343	1981-11-05	1981-11-05 00:00:00	1981-11-13	1981-11-13 00:00:00	32020		\N	327928	0	195662009	4112343		0
83196	4942	80180	1986-12-07	1986-12-07 00:00:00	\N	\N	32020		\N	328497	0	396275006	80180		0
72845	4330	4155034	1953-07-13	1953-07-13 00:00:00	1953-07-27	1953-07-27 00:00:00	32020		\N	287257	0	283371005	4155034		0
83646	4971	4112343	1995-08-18	1995-08-18 00:00:00	1995-08-29	1995-08-29 00:00:00	32020		\N	330654	0	195662009	4112343		0
83690	4972	260139	1984-07-11	1984-07-11 00:00:00	1984-07-25	1984-07-25 00:00:00	32020		\N	330668	0	10509002	260139		0
73345	4359	260139	2016-01-31	2016-01-31 00:00:00	2016-02-14	2016-02-14 00:00:00	32020		\N	289259	0	10509002	260139		0
84068	4992	372328	1987-09-03	1987-09-03 00:00:00	1987-10-22	1987-10-22 00:00:00	32020		\N	332156	0	65363002	372328		0
73600	4375	260139	1946-05-27	1946-05-27 00:00:00	1946-06-03	1946-06-03 00:00:00	32020		\N	290635	0	10509002	260139		0
84374	5014	81893	1947-01-28	1947-01-28 00:00:00	\N	\N	32020		\N	333240	0	64766004	81893		0
84608	5031	4112343	1980-04-01	1980-04-01 00:00:00	1980-04-13	1980-04-13 00:00:00	32020		\N	334417	0	195662009	4112343		0
84686	5035	4283893	1990-08-26	1990-08-26 00:00:00	1990-11-04	1990-11-04 00:00:00	32020		\N	334592	0	36971009	4283893		0
84900	5049	378001	1965-10-12	1965-10-12 00:00:00	1965-11-11	1965-11-11 00:00:00	32020		\N	335583	0	62106007	378001		0
74452	4419	260139	2005-05-12	2005-05-12 00:00:00	2005-05-26	2005-05-26 00:00:00	32020		\N	293794	0	10509002	260139		0
74656	4433	81151	1983-12-27	1983-12-27 00:00:00	1984-01-17	1984-01-17 00:00:00	32020		\N	294728	0	44465007	81151		0
64227	3791	40481087	1955-09-02	1955-09-02 00:00:00	1955-09-23	1955-09-23 00:00:00	32020		\N	252038	0	444814009	40481087		0
64390	3803	4283893	2014-09-13	2014-09-13 00:00:00	2014-12-06	2014-12-06 00:00:00	32020		\N	252758	0	36971009	4283893		0
64503	3811	40481087	2014-06-21	2014-06-21 00:00:00	2014-06-28	2014-06-28 00:00:00	32020		\N	253224	0	444814009	40481087		0
75252	4470	260139	2011-03-29	2011-03-29 00:00:00	2011-04-12	2011-04-12 00:00:00	32020		\N	297363	0	10509002	260139		0
64783	3831	40481087	2017-12-25	2017-12-25 00:00:00	2018-01-08	2018-01-08 00:00:00	32020		\N	254382	0	444814009	40481087		0
65018	3844	40481087	2007-03-25	2007-03-25 00:00:00	2007-04-08	2007-04-08 00:00:00	32020		\N	255160	0	444814009	40481087		0
65146	3852	260139	1965-11-25	1965-11-25 00:00:00	1965-12-09	1965-12-09 00:00:00	32020		\N	255628	0	10509002	260139		0
65339	3864	40481087	1999-05-28	1999-05-28 00:00:00	1999-06-11	1999-06-11 00:00:00	32020		\N	256508	0	444814009	40481087		0
65536	3875	80180	2000-02-01	2000-02-01 00:00:00	\N	\N	32020		\N	257373	0	396275006	80180		0
76264	4525	40481087	1968-06-05	1968-06-05 00:00:00	1968-06-26	1968-06-26 00:00:00	32020		\N	301300	0	444814009	40481087		0
76425	4531	40481087	1989-08-09	1989-08-09 00:00:00	1989-08-16	1989-08-16 00:00:00	32020		\N	301729	0	444814009	40481087		0
66043	3906	4294548	1968-05-24	1968-05-24 00:00:00	1968-06-14	1968-06-14 00:00:00	32020		\N	259742	0	75498004	4294548		0
76696	4546	260139	2004-06-15	2004-06-15 00:00:00	2004-06-22	2004-06-22 00:00:00	32020		\N	302817	0	10509002	260139		0
66394	3930	192671	1958-01-03	1958-01-03 00:00:00	\N	\N	32020		\N	261311	0	K92.2	35208414		0
66493	3935	40481087	1946-08-31	1946-08-31 00:00:00	1946-09-14	1946-09-14 00:00:00	32020		\N	261563	0	444814009	40481087		0
77281	4578	4112343	1978-02-04	1978-02-04 00:00:00	1978-02-17	1978-02-17 00:00:00	32020		\N	304977	0	195662009	4112343		0
77401	4586	4116491	1989-10-20	1989-10-20 00:00:00	1989-12-01	1989-12-01 00:00:00	32020		\N	305507	0	301011002	4116491		0
77529	4593	80180	2007-05-19	2007-05-19 00:00:00	\N	\N	32020		\N	306025	0	396275006	80180		0
67223	3973	40481087	2008-09-08	2008-09-08 00:00:00	2008-09-29	2008-09-29 00:00:00	32020		\N	264181	0	444814009	40481087		0
88486	5259	40481087	1970-07-01	1970-07-01 00:00:00	1970-07-15	1970-07-15 00:00:00	32020		\N	349942	0	444814009	40481087		0
78021	4623	40481087	1932-11-29	1932-11-29 00:00:00	1932-12-06	1932-12-06 00:00:00	32020		\N	307943	0	444814009	40481087		0
67682	3998	321042	1982-08-26	1982-08-26 00:00:00	\N	\N	32020		\N	265792	0	410429000	321042		0
67855	4010	260139	1994-01-27	1994-01-27 00:00:00	1994-02-10	1994-02-10 00:00:00	32020		\N	266515	0	10509002	260139		0
68060	4020	40481087	1957-04-01	1957-04-01 00:00:00	1957-04-22	1957-04-22 00:00:00	32020		\N	267265	0	444814009	40481087		0
68179	4026	372328	1962-09-25	1962-09-25 00:00:00	1963-01-06	1963-01-06 00:00:00	32020		\N	267645	0	65363002	372328		0
78937	4675	40480160	2007-12-06	2007-12-06 00:00:00	2008-01-05	2008-01-05 00:00:00	32020		\N	311449	0	443165006	40480160		0
68553	4053	81151	2017-11-21	2017-11-21 00:00:00	2017-12-26	2017-12-26 00:00:00	32020		\N	269452	0	44465007	81151		0
79223	4690	260139	2013-09-08	2013-09-08 00:00:00	2013-09-15	2013-09-15 00:00:00	32020		\N	312524	0	10509002	260139		0
79419	4704	40481087	1991-11-09	1991-11-09 00:00:00	1991-11-16	1991-11-16 00:00:00	32020		\N	313419	0	444814009	40481087		0
68964	4081	40481087	2014-06-16	2014-06-16 00:00:00	2014-07-07	2014-07-07 00:00:00	32020		\N	271257	0	444814009	40481087		0
69175	4092	378001	1983-03-17	1983-03-17 00:00:00	1983-04-16	1983-04-16 00:00:00	32020		\N	272071	0	62106007	378001		0
79964	4738	4001336	1945-07-08	1945-07-08 00:00:00	\N	\N	32020		\N	315653	0	110030002	4001336		0
69409	4107	40481087	2003-03-02	2003-03-02 00:00:00	2003-03-16	2003-03-16 00:00:00	32020		\N	272892	0	444814009	40481087		0
69618	4119	40481087	1967-04-12	1967-04-12 00:00:00	1967-04-26	1967-04-26 00:00:00	32020		\N	273864	0	444814009	40481087		0
80385	4760	80180	1995-03-06	1995-03-06 00:00:00	\N	\N	32020		\N	317152	0	396275006	80180		0
70155	4153	40481087	1968-07-01	1968-07-01 00:00:00	1968-07-22	1968-07-22 00:00:00	32020		\N	276028	0	444814009	40481087		0
80901	4799	257012	1963-03-11	1963-03-11 00:00:00	\N	\N	32020		\N	319200	0	40055000	257012		0
81160	4814	4218389	1998-12-18	1998-12-18 00:00:00	1999-01-15	1999-01-15 00:00:00	32020		\N	320249	0	39848009	4218389		0
81282	4820	4299128	1963-06-15	1963-06-15 00:00:00	1963-07-13	1963-07-13 00:00:00	32020		\N	320643	0	403192003	4299128		0
70882	4205	4112343	1982-09-25	1982-09-25 00:00:00	1982-10-03	1982-10-03 00:00:00	32020		\N	279154	0	195662009	4112343		0
71006	4212	40481087	1981-11-23	1981-11-23 00:00:00	1981-11-30	1981-11-30 00:00:00	32020		\N	279645	0	444814009	40481087		0
71099	4217	30753	2000-03-25	2000-03-25 00:00:00	\N	\N	32020		\N	279919	0	16761005	30753		0
71341	4229	4112343	2005-12-30	2005-12-30 00:00:00	2006-01-06	2006-01-06 00:00:00	32020		\N	280902	0	195662009	4112343		0
71475	4240	4112343	1982-03-10	1982-03-10 00:00:00	1982-03-21	1982-03-21 00:00:00	32020		\N	281677	0	195662009	4112343		0
82199	4873	40481087	2004-07-07	2004-07-07 00:00:00	2004-07-14	2004-07-14 00:00:00	32020		\N	324113	0	444814009	40481087		0
71829	4261	260139	1998-11-12	1998-11-12 00:00:00	1998-11-19	1998-11-19 00:00:00	32020		\N	282942	0	10509002	260139		0
72006	4274	195588	1958-02-05	1958-02-05 00:00:00	1958-03-23	1958-03-23 00:00:00	32020		\N	283617	0	38822007	195588		0
72112	4279	4237458	1966-11-14	1966-11-14 00:00:00	1967-02-12	1967-02-12 00:00:00	32020		\N	284091	0	58150001	4237458		0
72279	4289	4278672	2017-05-10	2017-05-10 00:00:00	2017-08-08	2017-08-08 00:00:00	32020		\N	284744	0	65966004	4278672		0
83062	4933	40481087	2004-06-16	2004-06-16 00:00:00	2004-06-30	2004-06-30 00:00:00	32020		\N	327930	0	444814009	40481087		0
83197	4943	4112343	1965-05-14	1965-05-14 00:00:00	1965-05-21	1965-05-21 00:00:00	32020		\N	328553	0	195662009	4112343		0
72846	4330	4112343	2007-05-24	2007-05-24 00:00:00	2007-06-01	2007-06-01 00:00:00	32020		\N	287240	0	195662009	4112343		0
83647	4971	40481087	1979-08-11	1979-08-11 00:00:00	1979-09-01	1979-09-01 00:00:00	32020		\N	330587	0	444814009	40481087		0
83691	4972	40481087	1970-07-10	1970-07-10 00:00:00	1970-07-31	1970-07-31 00:00:00	32020		\N	330688	0	444814009	40481087		0
73346	4359	4294548	1968-07-09	1968-07-09 00:00:00	1968-08-20	1968-08-20 00:00:00	32020		\N	289188	0	75498004	4294548		0
84069	4992	4112343	1996-08-19	1996-08-19 00:00:00	1996-08-29	1996-08-29 00:00:00	32020		\N	332148	0	195662009	4112343		0
73601	4375	317576	2015-08-16	2015-08-16 00:00:00	\N	\N	32020		\N	290647	0	53741008	317576		0
84375	5014	40479422	1943-02-24	1943-02-24 00:00:00	1943-05-02	1943-05-02 00:00:00	32020		\N	333253	0	444448004	40479422		0
84609	5031	4296205	1982-10-07	1982-10-07 00:00:00	1982-10-28	1982-10-28 00:00:00	32020		\N	334280	0	403191005	4296205		0
84687	5035	257012	1945-10-08	1945-10-08 00:00:00	\N	\N	32020		\N	334606	0	40055000	257012		0
84901	5049	4294548	1968-02-08	1968-02-08 00:00:00	1968-02-15	1968-02-15 00:00:00	32020		\N	335632	0	75498004	4294548		0
74453	4419	192671	1991-01-20	1991-01-20 00:00:00	\N	\N	32020		\N	293806	0	K92.2	35208414		0
74657	4433	40481087	1955-01-16	1955-01-16 00:00:00	1955-02-06	1955-02-06 00:00:00	32020		\N	294701	0	444814009	40481087		0
64228	3791	381316	2014-11-01	2014-11-01 00:00:00	\N	\N	32020		\N	252148	0	230690007	381316		0
64391	3803	28060	1973-07-22	1973-07-22 00:00:00	1973-08-03	1973-08-03 00:00:00	32020		\N	252805	0	43878008	28060		0
64504	3811	28060	1994-03-31	1994-03-31 00:00:00	1994-04-09	1994-04-09 00:00:00	32020		\N	253221	0	43878008	28060		0
75253	4470	4294548	2000-11-14	2000-11-14 00:00:00	2001-03-20	2001-03-20 00:00:00	32020		\N	297379	0	75498004	4294548		0
64784	3831	260139	1962-07-13	1962-07-13 00:00:00	1962-07-27	1962-07-27 00:00:00	32020		\N	254372	0	10509002	260139		0
65057	3849	440086	1973-11-18	1973-11-18 00:00:00	1981-11-26	1981-11-26 00:00:00	32020		\N	255397	0	192127007	440086		0
65147	3852	134438	1970-10-10	1970-10-10 00:00:00	1971-10-07	1971-10-07 00:00:00	32020		\N	255614	0	40275004	134438		0
65340	3864	372328	1969-03-20	1969-03-20 00:00:00	1969-11-22	1969-11-22 00:00:00	32020		\N	256510	0	65363002	372328		0
65537	3875	260139	2017-07-03	2017-07-03 00:00:00	2017-07-10	2017-07-10 00:00:00	32020		\N	257329	0	10509002	260139		0
76265	4525	28060	1990-02-27	1990-02-27 00:00:00	1990-03-10	1990-03-10 00:00:00	32020		\N	301261	0	43878008	28060		0
76426	4531	4112343	1940-05-11	1940-05-11 00:00:00	1940-05-20	1940-05-20 00:00:00	32020		\N	301812	0	195662009	4112343		0
66044	3906	40481087	1978-05-31	1978-05-31 00:00:00	1978-06-07	1978-06-07 00:00:00	32020		\N	259674	0	444814009	40481087		0
76697	4546	375671	1982-07-15	1982-07-15 00:00:00	1982-08-14	1982-08-14 00:00:00	32020		\N	302791	0	62564004	375671		0
66395	3930	317576	1972-07-22	1972-07-22 00:00:00	\N	\N	32020		\N	261271	0	53741008	317576		0
66494	3935	381316	1990-10-24	1990-10-24 00:00:00	\N	\N	32020		\N	261552	0	230690007	381316		0
77282	4578	192671	2000-04-25	2000-04-25 00:00:00	\N	\N	32020		\N	305004	0	K92.2	35208414		0
77402	4586	40481087	1961-02-11	1961-02-11 00:00:00	1961-03-04	1961-03-04 00:00:00	32020		\N	305473	0	444814009	40481087		0
77530	4593	372328	1967-05-15	1967-05-15 00:00:00	1967-08-17	1967-08-17 00:00:00	32020		\N	306038	0	65363002	372328		0
67224	3973	4218389	2009-05-19	2009-05-19 00:00:00	2009-06-16	2009-06-16 00:00:00	32020		\N	264220	0	39848009	4218389		0
88487	5259	28060	1973-08-24	1973-08-24 00:00:00	1973-09-04	1973-09-04 00:00:00	32020		\N	349943	0	43878008	28060		0
78022	4623	4112343	1964-02-11	1964-02-11 00:00:00	1964-02-23	1964-02-23 00:00:00	32020		\N	307929	0	195662009	4112343		0
67683	3998	81893	1985-01-28	1985-01-28 00:00:00	\N	\N	32020		\N	265792	0	64766004	81893		0
67856	4010	4237458	2018-04-30	2018-04-30 00:00:00	2018-05-30	2018-05-30 00:00:00	32020		\N	266491	0	58150001	4237458		0
78523	4649	195588	2015-01-30	2015-01-30 00:00:00	2015-03-16	2015-03-16 00:00:00	32020		\N	310033	0	38822007	195588		0
68180	4026	4134304	1970-07-22	1970-07-22 00:00:00	1970-08-21	1970-08-21 00:00:00	32020		\N	267695	0	263102004	4134304		0
78938	4675	260139	1945-10-14	1945-10-14 00:00:00	1945-10-21	1945-10-21 00:00:00	32020		\N	311494	0	10509002	260139		0
68554	4053	257012	1968-03-26	1968-03-26 00:00:00	1968-05-07	1968-05-07 00:00:00	32020		\N	269450	0	40055000	257012		0
79224	4690	4155034	1980-02-09	1980-02-09 00:00:00	1980-02-23	1980-02-23 00:00:00	32020		\N	312492	0	283371005	4155034		0
79420	4704	4218389	2010-09-21	2010-09-21 00:00:00	2010-10-26	2010-10-26 00:00:00	32020		\N	313433	0	39848009	4218389		0
68965	4081	4112343	2012-10-05	2012-10-05 00:00:00	2012-10-14	2012-10-14 00:00:00	32020		\N	271265	0	195662009	4112343		0
69176	4092	40481087	1991-10-02	1991-10-02 00:00:00	1991-10-16	1991-10-16 00:00:00	32020		\N	272035	0	444814009	40481087		0
79965	4738	40481087	1926-07-11	1926-07-11 00:00:00	1926-08-01	1926-08-01 00:00:00	32020		\N	315663	0	444814009	40481087		0
69410	4107	372328	1972-01-12	1972-01-12 00:00:00	1972-04-17	1972-04-17 00:00:00	32020		\N	272914	0	65363002	372328		0
69619	4119	260139	2001-10-22	2001-10-22 00:00:00	2001-10-29	2001-10-29 00:00:00	32020		\N	273847	0	10509002	260139		0
80386	4761	375671	2005-02-07	2005-02-07 00:00:00	2005-03-09	2005-03-09 00:00:00	32020		\N	317239	0	62564004	375671		0
70156	4153	378001	2007-06-29	2007-06-29 00:00:00	2007-07-29	2007-07-29 00:00:00	32020		\N	276009	0	62106007	378001		0
80902	4799	40481087	1966-07-17	1966-07-17 00:00:00	1966-07-24	1966-07-24 00:00:00	32020		\N	319202	0	444814009	40481087		0
81161	4814	4218389	1995-12-06	1995-12-06 00:00:00	1996-01-03	1996-01-03 00:00:00	32020		\N	320248	0	39848009	4218389		0
81283	4820	28060	1989-01-25	1989-01-25 00:00:00	1989-02-07	1989-02-07 00:00:00	32020		\N	320669	0	43878008	28060		0
81346	4826	260139	1996-05-10	1996-05-10 00:00:00	1996-05-17	1996-05-17 00:00:00	32020		\N	321031	0	10509002	260139		0
71007	4212	4294548	2008-03-15	2008-03-15 00:00:00	2008-05-03	2008-05-03 00:00:00	32020		\N	279649	0	75498004	4294548		0
71100	4217	4285898	2000-06-23	2000-06-23 00:00:00	\N	\N	32020		\N	279919	0	68496003	4285898		0
71379	4235	260139	2001-12-23	2001-12-23 00:00:00	2001-12-30	2001-12-30 00:00:00	32020		\N	281205	0	10509002	260139		0
71476	4240	40481087	1958-05-05	1958-05-05 00:00:00	1958-05-26	1958-05-26 00:00:00	32020		\N	281665	0	444814009	40481087		0
82200	4874	40481087	2016-07-19	2016-07-19 00:00:00	2016-08-02	2016-08-02 00:00:00	32020		\N	324196	0	444814009	40481087		0
71830	4261	80502	1982-05-09	1982-05-09 00:00:00	\N	\N	32020		\N	282950	0	64859006	80502		0
72007	4274	40481087	1983-04-29	1983-04-29 00:00:00	1983-05-13	1983-05-13 00:00:00	32020		\N	283638	0	444814009	40481087		0
72113	4279	28060	2007-03-03	2007-03-03 00:00:00	2007-03-16	2007-03-16 00:00:00	32020		\N	284006	0	43878008	28060		0
72280	4289	81151	1951-05-03	1951-05-03 00:00:00	1951-06-07	1951-06-07 00:00:00	32020		\N	284739	0	44465007	81151		0
83064	4933	4029498	1978-03-03	1978-03-03 00:00:00	\N	\N	32020		\N	327966	0	128613002	4029498		0
83198	4943	4237458	1974-02-14	1974-02-14 00:00:00	1974-04-15	1974-04-15 00:00:00	32020		\N	328621	0	58150001	4237458		0
72847	4330	40481087	2006-06-03	2006-06-03 00:00:00	2006-06-24	2006-06-24 00:00:00	32020		\N	287197	0	444814009	40481087		0
83648	4971	80180	1978-02-10	1978-02-10 00:00:00	\N	\N	32020		\N	330630	0	396275006	80180		0
83692	4972	440448	1991-01-04	1991-01-04 00:00:00	\N	\N	32020		\N	330723	0	74400008	440448		0
73347	4359	4112343	1950-01-20	1950-01-20 00:00:00	1950-01-30	1950-01-30 00:00:00	32020		\N	289187	0	195662009	4112343		0
84070	4992	440448	2007-05-12	2007-05-12 00:00:00	\N	\N	32020		\N	332117	0	74400008	440448		0
73602	4375	80502	2018-03-04	2018-03-04 00:00:00	\N	\N	32020		\N	290599	0	64859006	80502		0
84376	5015	372328	1968-04-05	1968-04-05 00:00:00	1968-05-13	1968-05-13 00:00:00	32020		\N	333349	0	65363002	372328		0
84610	5031	260139	1973-04-30	1973-04-30 00:00:00	1973-05-07	1973-05-07 00:00:00	32020		\N	334331	0	10509002	260139		0
84688	5035	260139	1996-12-10	1996-12-10 00:00:00	1996-12-24	1996-12-24 00:00:00	32020		\N	334648	0	10509002	260139		0
84902	5049	4294548	1988-12-22	1988-12-22 00:00:00	1989-03-23	1989-03-23 00:00:00	32020		\N	335593	0	75498004	4294548		0
74454	4419	40481087	1970-01-13	1970-01-13 00:00:00	1970-01-27	1970-01-27 00:00:00	32020		\N	293863	0	444814009	40481087		0
74662	4435	260139	1989-12-01	1989-12-01 00:00:00	1989-12-08	1989-12-08 00:00:00	32020		\N	294805	0	10509002	260139		0
64229	3791	313217	2011-06-25	2011-06-25 00:00:00	\N	\N	32020		\N	252036	0	49436004	313217		0
64392	3803	260139	1983-08-29	1983-08-29 00:00:00	1983-09-12	1983-09-12 00:00:00	32020		\N	252764	0	10509002	260139		0
64505	3811	4112343	1982-09-05	1982-09-05 00:00:00	1982-09-13	1982-09-13 00:00:00	32020		\N	253220	0	195662009	4112343		0
75254	4470	440086	1985-01-05	1985-01-05 00:00:00	1990-01-14	1990-01-14 00:00:00	32020		\N	297358	0	192127007	440086		0
64785	3831	378001	1989-04-17	1989-04-17 00:00:00	1989-06-16	1989-06-16 00:00:00	32020		\N	254329	0	62106007	378001		0
65058	3849	81151	2009-10-09	2009-10-09 00:00:00	2009-11-13	2009-11-13 00:00:00	32020		\N	255449	0	44465007	81151		0
65148	3852	40481087	2002-02-15	2002-02-15 00:00:00	2002-03-01	2002-03-01 00:00:00	32020		\N	255758	0	444814009	40481087		0
65341	3864	4112343	1998-11-16	1998-11-16 00:00:00	1998-11-27	1998-11-27 00:00:00	32020		\N	256478	0	195662009	4112343		0
65538	3875	4218389	2004-02-09	2004-02-09 00:00:00	2004-03-15	2004-03-15 00:00:00	32020		\N	257381	0	39848009	4218389		0
76266	4525	40481087	1985-10-30	1985-10-30 00:00:00	1985-11-20	1985-11-20 00:00:00	32020		\N	301259	0	444814009	40481087		0
76427	4531	260139	2008-07-24	2008-07-24 00:00:00	2008-07-31	2008-07-31 00:00:00	32020		\N	301819	0	10509002	260139		0
66045	3906	4112343	1978-06-27	1978-06-27 00:00:00	1978-07-06	1978-07-06 00:00:00	32020		\N	259656	0	195662009	4112343		0
76698	4546	260139	1973-02-03	1973-02-03 00:00:00	1973-02-17	1973-02-17 00:00:00	32020		\N	302810	0	10509002	260139		0
66396	3930	78272	1916-06-19	1916-06-19 00:00:00	1916-07-24	1916-07-24 00:00:00	32020		\N	261306	0	70704007	78272		0
66495	3936	78272	1960-02-28	1960-02-28 00:00:00	1960-03-13	1960-03-13 00:00:00	32020		\N	261630	0	70704007	78272		0
77283	4578	4134304	1973-06-04	1973-06-04 00:00:00	1973-07-04	1973-07-04 00:00:00	32020		\N	304987	0	263102004	4134304		0
77403	4586	4027663	1983-10-22	1983-10-22 00:00:00	\N	\N	32020		\N	305456	0	13200003	4027663		0
77531	4593	81151	1971-05-03	1971-05-03 00:00:00	1971-05-31	1971-05-31 00:00:00	32020		\N	306049	0	44465007	81151		0
67225	3973	260139	1996-11-15	1996-11-15 00:00:00	1996-11-29	1996-11-29 00:00:00	32020		\N	264171	0	10509002	260139		0
88488	5259	4156265	2012-03-06	2012-03-06 00:00:00	2012-03-27	2012-03-27 00:00:00	32020		\N	350006	0	370247008	4156265		0
78023	4623	378001	1944-11-26	1944-11-26 00:00:00	1945-01-25	1945-01-25 00:00:00	32020		\N	308004	0	62106007	378001		0
67685	3998	40481087	2010-09-21	2010-09-21 00:00:00	2010-09-28	2010-09-28 00:00:00	32020		\N	265861	0	444814009	40481087		0
67857	4010	40481087	1981-09-16	1981-09-16 00:00:00	1981-09-30	1981-09-30 00:00:00	32020		\N	266453	0	444814009	40481087		0
78524	4649	372328	1970-02-05	1970-02-05 00:00:00	1970-04-20	1970-04-20 00:00:00	32020		\N	310013	0	65363002	372328		0
68181	4027	40481087	1983-04-06	1983-04-06 00:00:00	1983-04-27	1983-04-27 00:00:00	32020		\N	267832	0	444814009	40481087		0
78939	4675	4112343	1921-02-11	1921-02-11 00:00:00	1921-02-20	1921-02-20 00:00:00	32020		\N	311543	0	195662009	4112343		0
68555	4053	372328	2016-01-12	2016-01-12 00:00:00	2016-12-25	2016-12-25 00:00:00	32020		\N	269428	0	65363002	372328		0
79225	4690	40481087	2003-10-01	2003-10-01 00:00:00	2003-10-15	2003-10-15 00:00:00	32020		\N	312455	0	444814009	40481087		0
79421	4704	40481087	1983-08-07	1983-08-07 00:00:00	1983-08-14	1983-08-14 00:00:00	32020		\N	313413	0	444814009	40481087		0
68966	4081	4294548	1998-01-31	1998-01-31 00:00:00	1998-05-02	1998-05-02 00:00:00	32020		\N	271256	0	75498004	4294548		0
69177	4092	4112343	1982-07-08	1982-07-08 00:00:00	1982-07-21	1982-07-21 00:00:00	32020		\N	272020	0	195662009	4112343		0
79966	4738	28060	1915-12-17	1915-12-17 00:00:00	1915-12-27	1915-12-27 00:00:00	32020		\N	315662	0	43878008	28060		0
69411	4107	4112343	2005-08-07	2005-08-07 00:00:00	2005-08-18	2005-08-18 00:00:00	32020		\N	272909	0	195662009	4112343		0
69620	4119	381316	2001-09-29	2001-09-29 00:00:00	\N	\N	32020		\N	273830	0	230690007	381316		0
80387	4761	4283893	2002-09-16	2002-09-16 00:00:00	2002-10-14	2002-10-14 00:00:00	32020		\N	317289	0	36971009	4283893		0
70157	4153	40481087	2008-01-18	2008-01-18 00:00:00	2008-01-25	2008-01-25 00:00:00	32020		\N	276019	0	444814009	40481087		0
80903	4799	4112343	2011-07-27	2011-07-27 00:00:00	2011-08-03	2011-08-03 00:00:00	32020		\N	319274	0	195662009	4112343		0
81162	4814	78272	1940-03-21	1940-03-21 00:00:00	1940-04-04	1940-04-04 00:00:00	32020		\N	320243	0	70704007	78272		0
81284	4820	40481087	1981-05-23	1981-05-23 00:00:00	1981-06-13	1981-06-13 00:00:00	32020		\N	320651	0	444814009	40481087		0
81347	4826	372328	1951-09-07	1951-09-07 00:00:00	1951-11-17	1951-11-17 00:00:00	32020		\N	321046	0	65363002	372328		0
71008	4212	372328	1970-07-28	1970-07-28 00:00:00	1970-10-09	1970-10-09 00:00:00	32020		\N	279626	0	65363002	372328		0
71101	4217	40481087	1975-06-10	1975-06-10 00:00:00	1975-06-17	1975-06-17 00:00:00	32020		\N	279946	0	444814009	40481087		0
71380	4235	40481087	2008-02-09	2008-02-09 00:00:00	2008-03-01	2008-03-01 00:00:00	32020		\N	281215	0	444814009	40481087		0
71477	4240	260139	1964-07-23	1964-07-23 00:00:00	1964-08-06	1964-08-06 00:00:00	32020		\N	281689	0	10509002	260139		0
82201	4874	260139	1972-09-20	1972-09-20 00:00:00	1972-10-04	1972-10-04 00:00:00	32020		\N	324167	0	10509002	260139		0
71831	4261	28060	1995-11-03	1995-11-03 00:00:00	1995-11-15	1995-11-15 00:00:00	32020		\N	282941	0	43878008	28060		0
72008	4274	4112343	1960-05-16	1960-05-16 00:00:00	1960-05-25	1960-05-25 00:00:00	32020		\N	283636	0	195662009	4112343		0
72114	4279	80180	1987-08-16	1987-08-16 00:00:00	\N	\N	32020		\N	284080	0	396275006	80180		0
72281	4289	28060	2001-06-24	2001-06-24 00:00:00	2001-07-05	2001-07-05 00:00:00	32020		\N	284747	0	43878008	28060		0
83065	4933	40479422	1998-10-28	1998-10-28 00:00:00	1998-12-04	1998-12-04 00:00:00	32020		\N	327970	0	444448004	40479422		0
83199	4943	40481087	1981-03-16	1981-03-16 00:00:00	1981-04-06	1981-04-06 00:00:00	32020		\N	328568	0	444814009	40481087		0
72848	4330	4218389	1988-12-02	1988-12-02 00:00:00	1989-01-06	1989-01-06 00:00:00	32020		\N	287262	0	39848009	4218389		0
83649	4971	317576	1995-11-07	1995-11-07 00:00:00	\N	\N	32020		\N	330503	0	53741008	317576		0
83693	4972	4113008	1956-09-13	1956-09-13 00:00:00	1956-10-04	1956-10-04 00:00:00	32020		\N	330722	0	284549007	4113008		0
73348	4359	81151	2013-07-12	2013-07-12 00:00:00	2013-08-09	2013-08-09 00:00:00	32020		\N	289215	0	44465007	81151		0
84071	4992	40481087	2002-03-19	2002-03-19 00:00:00	2002-03-26	2002-03-26 00:00:00	32020		\N	332155	0	444814009	40481087		0
73603	4375	4112343	1957-05-26	1957-05-26 00:00:00	1957-06-03	1957-06-03 00:00:00	32020		\N	290654	0	195662009	4112343		0
84377	5015	372328	1971-02-27	1971-02-27 00:00:00	1971-07-12	1971-07-12 00:00:00	32020		\N	333363	0	65363002	372328		0
84611	5031	4112343	1969-12-15	1969-12-15 00:00:00	1969-12-24	1969-12-24 00:00:00	32020		\N	334415	0	195662009	4112343		0
84689	5035	40481087	1985-05-27	1985-05-27 00:00:00	1985-06-17	1985-06-17 00:00:00	32020		\N	334642	0	444814009	40481087		0
84903	5049	260139	1981-05-21	1981-05-21 00:00:00	1981-06-04	1981-06-04 00:00:00	32020		\N	335576	0	10509002	260139		0
74455	4419	260139	1956-01-21	1956-01-21 00:00:00	1956-01-28	1956-01-28 00:00:00	32020		\N	293859	0	10509002	260139		0
74663	4435	28060	2005-11-09	2005-11-09 00:00:00	2005-11-17	2005-11-17 00:00:00	32020		\N	294806	0	43878008	28060		0
64234	3793	4112343	1989-06-02	1989-06-02 00:00:00	1989-06-10	1989-06-10 00:00:00	32020		\N	252252	0	195662009	4112343		0
64393	3803	4116491	2002-04-03	2002-04-03 00:00:00	2002-05-17	2002-05-17 00:00:00	32020		\N	252757	0	301011002	4116491		0
64510	3813	4237458	1982-09-11	1982-09-11 00:00:00	1982-12-10	1982-12-10 00:00:00	32020		\N	253260	0	58150001	4237458		0
75255	4470	40481087	1996-05-25	1996-05-25 00:00:00	1996-06-01	1996-06-01 00:00:00	32020		\N	297349	0	444814009	40481087		0
64786	3831	81151	1956-04-19	1956-04-19 00:00:00	1956-05-10	1956-05-10 00:00:00	32020		\N	254327	0	44465007	81151		0
65059	3849	78272	2016-11-06	2016-11-06 00:00:00	2016-12-11	2016-12-11 00:00:00	32020		\N	255450	0	70704007	78272		0
65177	3856	4112343	2015-02-26	2015-02-26 00:00:00	2015-03-10	2015-03-10 00:00:00	32020		\N	255935	0	195662009	4112343		0
65342	3864	260139	2003-05-25	2003-05-25 00:00:00	2003-06-01	2003-06-01 00:00:00	32020		\N	256479	0	10509002	260139		0
65539	3875	260139	1997-08-20	1997-08-20 00:00:00	1997-09-03	1997-09-03 00:00:00	32020		\N	257333	0	10509002	260139		0
76267	4525	4294548	2009-04-07	2009-04-07 00:00:00	2009-04-28	2009-04-28 00:00:00	32020		\N	301262	0	75498004	4294548		0
76428	4531	372328	1918-02-21	1918-02-21 00:00:00	1918-08-03	1918-08-03 00:00:00	32020		\N	301756	0	65363002	372328		0
66046	3906	260139	1989-10-18	1989-10-18 00:00:00	1989-10-25	1989-10-25 00:00:00	32020		\N	259676	0	10509002	260139		0
76699	4546	260139	2012-12-19	2012-12-19 00:00:00	2012-12-26	2012-12-26 00:00:00	32020		\N	302801	0	10509002	260139		0
66397	3930	260139	1935-02-28	1935-02-28 00:00:00	1935-03-14	1935-03-14 00:00:00	32020		\N	261239	0	10509002	260139		0
66496	3936	40481087	1967-12-07	1967-12-07 00:00:00	1967-12-28	1967-12-28 00:00:00	32020		\N	261641	0	444814009	40481087		0
77284	4578	4027663	1993-05-17	1993-05-17 00:00:00	\N	\N	32020		\N	304965	0	13200003	4027663		0
77404	4586	40481087	1983-02-19	1983-02-19 00:00:00	1983-02-26	1983-02-26 00:00:00	32020		\N	305456	0	444814009	40481087		0
77532	4593	372328	1965-11-29	1965-11-29 00:00:00	1966-02-16	1966-02-16 00:00:00	32020		\N	306014	0	65363002	372328		0
67226	3973	4059173	2005-07-09	2005-07-09 00:00:00	2005-10-07	2005-10-07 00:00:00	32020		\N	264219	0	16114001	4059173		0
88489	5259	28060	1994-09-03	1994-09-03 00:00:00	1994-09-15	1994-09-15 00:00:00	32020		\N	349996	0	43878008	28060		0
78024	4623	372328	1946-04-15	1946-04-15 00:00:00	1946-10-22	1946-10-22 00:00:00	32020		\N	307979	0	65363002	372328		0
67686	3998	4112343	2011-10-25	2011-10-25 00:00:00	2011-11-05	2011-11-05 00:00:00	32020		\N	265862	0	195662009	4112343		0
67858	4010	4112343	1994-01-17	1994-01-17 00:00:00	1994-01-26	1994-01-26 00:00:00	32020		\N	266514	0	195662009	4112343		0
78525	4649	260139	1999-01-06	1999-01-06 00:00:00	1999-01-20	1999-01-20 00:00:00	32020		\N	310009	0	10509002	260139		0
68182	4027	260139	2002-06-26	2002-06-26 00:00:00	2002-07-03	2002-07-03 00:00:00	32020		\N	267826	0	10509002	260139		0
78940	4675	4218389	2014-07-02	2014-07-02 00:00:00	2014-07-23	2014-07-23 00:00:00	32020		\N	311451	0	39848009	4218389		0
68556	4053	81151	1964-09-11	1964-09-11 00:00:00	1964-10-02	1964-10-02 00:00:00	32020		\N	269418	0	44465007	81151		0
79226	4690	4283893	1985-02-01	1985-02-01 00:00:00	1985-03-01	1985-03-01 00:00:00	32020		\N	312522	0	36971009	4283893		0
79422	4704	4155034	1969-01-01	1969-01-01 00:00:00	1969-01-15	1969-01-15 00:00:00	32020		\N	313430	0	283371005	4155034		0
68967	4081	317576	2016-10-31	2016-10-31 00:00:00	\N	\N	32020		\N	271302	0	53741008	317576		0
69178	4092	192671	2015-04-29	2015-04-29 00:00:00	\N	\N	32020		\N	272062	0	K92.2	35208414		0
79967	4738	4294548	1942-05-18	1942-05-18 00:00:00	1942-10-12	1942-10-12 00:00:00	32020		\N	315623	0	75498004	4294548		0
69412	4107	372328	1971-04-09	1971-04-09 00:00:00	1971-05-17	1971-05-17 00:00:00	32020		\N	272910	0	65363002	372328		0
69621	4119	4113008	1964-09-10	1964-09-10 00:00:00	1964-09-24	1964-09-24 00:00:00	32020		\N	273809	0	284549007	4113008		0
80388	4761	28060	1989-03-23	1989-03-23 00:00:00	1989-04-03	1989-04-03 00:00:00	32020		\N	317213	0	43878008	28060		0
70158	4153	372328	1973-05-14	1973-05-14 00:00:00	1974-02-14	1974-02-14 00:00:00	32020		\N	276067	0	65363002	372328		0
80904	4799	80180	1997-02-19	1997-02-19 00:00:00	\N	\N	32020		\N	319273	0	396275006	80180		0
81163	4814	4112343	1981-11-05	1981-11-05 00:00:00	1981-11-17	1981-11-17 00:00:00	32020		\N	320230	0	195662009	4112343		0
81285	4820	4112343	2010-07-30	2010-07-30 00:00:00	2010-08-07	2010-08-07 00:00:00	32020		\N	320671	0	195662009	4112343		0
81348	4826	40481087	1970-07-15	1970-07-15 00:00:00	1970-08-05	1970-08-05 00:00:00	32020		\N	321062	0	444814009	40481087		0
71009	4212	81151	1982-02-25	1982-02-25 00:00:00	1982-03-25	1982-03-25 00:00:00	32020		\N	279651	0	44465007	81151		0
71102	4217	40481087	2007-03-16	2007-03-16 00:00:00	2007-03-30	2007-03-30 00:00:00	32020		\N	279981	0	444814009	40481087		0
81839	4853	80180	1999-04-20	1999-04-20 00:00:00	\N	\N	32020		\N	322926	0	396275006	80180		0
71478	4240	4156265	1981-11-21	1981-11-21 00:00:00	1981-12-05	1981-12-05 00:00:00	32020		\N	281593	0	370247008	4156265		0
82202	4874	4112343	1981-12-27	1981-12-27 00:00:00	1982-01-09	1982-01-09 00:00:00	32020		\N	324161	0	195662009	4112343		0
71832	4261	40481087	1979-12-04	1979-12-04 00:00:00	1979-12-11	1979-12-11 00:00:00	32020		\N	282964	0	444814009	40481087		0
72009	4274	4112343	1989-09-30	1989-09-30 00:00:00	1989-10-08	1989-10-08 00:00:00	32020		\N	283640	0	195662009	4112343		0
72115	4279	40481087	1980-10-25	1980-10-25 00:00:00	1980-11-08	1980-11-08 00:00:00	32020		\N	284076	0	444814009	40481087		0
72282	4289	4112343	2008-11-13	2008-11-13 00:00:00	2008-11-23	2008-11-23 00:00:00	32020		\N	284749	0	195662009	4112343		0
83066	4933	4218389	1984-09-08	1984-09-08 00:00:00	1984-10-06	1984-10-06 00:00:00	32020		\N	327968	0	39848009	4218389		0
83200	4943	40481087	2004-07-20	2004-07-20 00:00:00	2004-07-27	2004-07-27 00:00:00	32020		\N	328570	0	444814009	40481087		0
72849	4330	40481087	1985-04-25	1985-04-25 00:00:00	1985-05-09	1985-05-09 00:00:00	32020		\N	287188	0	444814009	40481087		0
83650	4971	78272	1983-11-28	1983-11-28 00:00:00	1983-12-12	1983-12-12 00:00:00	32020		\N	330512	0	70704007	78272		0
83694	4972	4230399	1997-08-30	1997-08-30 00:00:00	1997-09-29	1997-09-29 00:00:00	32020		\N	330724	0	359817006	4230399		0
73349	4359	40481087	1986-03-28	1986-03-28 00:00:00	1986-04-11	1986-04-11 00:00:00	32020		\N	289250	0	444814009	40481087		0
84072	4992	40481087	1989-11-10	1989-11-10 00:00:00	1989-12-01	1989-12-01 00:00:00	32020		\N	332123	0	444814009	40481087		0
73605	4375	440448	1946-07-06	1946-07-06 00:00:00	\N	\N	32020		\N	290621	0	74400008	440448		0
84378	5015	4152936	2002-05-19	2002-05-19 00:00:00	2002-06-09	2002-06-09 00:00:00	32020		\N	333377	0	283385000	4152936		0
84612	5031	80180	1956-06-17	1956-06-17 00:00:00	\N	\N	32020		\N	334386	0	396275006	80180		0
84690	5035	255848	2014-10-06	2014-10-06 00:00:00	\N	\N	32020		\N	334574	0	233604007	255848		0
84904	5049	258780	2019-02-06	2019-02-06 00:00:00	\N	\N	32020		\N	335639	0	185086009	258780		0
74456	4419	40481087	1981-05-06	1981-05-06 00:00:00	1981-05-27	1981-05-27 00:00:00	32020		\N	293807	0	444814009	40481087		0
74664	4435	40481087	1988-09-12	1988-09-12 00:00:00	1988-09-19	1988-09-19 00:00:00	32020		\N	294801	0	444814009	40481087		0
64235	3793	260139	2008-08-07	2008-08-07 00:00:00	2008-08-21	2008-08-21 00:00:00	32020		\N	252253	0	10509002	260139		0
64394	3803	81893	2002-08-01	2002-08-01 00:00:00	\N	\N	32020		\N	252757	0	64766004	81893		0
64511	3813	40481087	1994-04-02	1994-04-02 00:00:00	1994-04-23	1994-04-23 00:00:00	32020		\N	253259	0	444814009	40481087		0
75256	4470	4112343	2015-10-21	2015-10-21 00:00:00	2015-11-02	2015-11-02 00:00:00	32020		\N	297351	0	195662009	4112343		0
64787	3831	257012	1997-04-21	1997-04-21 00:00:00	\N	\N	32020		\N	254381	0	40055000	257012		0
65060	3849	4112343	1980-01-17	1980-01-17 00:00:00	1980-01-26	1980-01-26 00:00:00	32020		\N	255407	0	195662009	4112343		0
65178	3856	195588	1998-09-27	1998-09-27 00:00:00	1998-10-29	1998-10-29 00:00:00	32020		\N	255892	0	38822007	195588		0
65343	3864	4294548	1993-06-17	1993-06-17 00:00:00	1993-07-15	1993-07-15 00:00:00	32020		\N	256528	0	75498004	4294548		0
65540	3875	257012	2011-06-22	2011-06-22 00:00:00	\N	\N	32020		\N	257389	0	40055000	257012		0
76268	4525	28060	1974-02-01	1974-02-01 00:00:00	1974-02-09	1974-02-09 00:00:00	32020		\N	301270	0	43878008	28060		0
76429	4531	80180	1950-03-13	1950-03-13 00:00:00	\N	\N	32020		\N	301765	0	396275006	80180		0
66047	3906	4296204	2004-05-03	2004-05-03 00:00:00	2004-06-07	2004-06-07 00:00:00	32020		\N	259753	0	403190006	4296204		0
76700	4546	40481087	2018-09-16	2018-09-16 00:00:00	2018-09-23	2018-09-23 00:00:00	32020		\N	302783	0	444814009	40481087		0
66398	3930	40481087	1956-10-30	1956-10-30 00:00:00	1956-11-20	1956-11-20 00:00:00	32020		\N	261266	0	444814009	40481087		0
66497	3936	257012	1963-02-08	1963-02-08 00:00:00	\N	\N	32020		\N	261615	0	40055000	257012		0
77285	4578	4112343	1993-04-26	1993-04-26 00:00:00	1993-05-06	1993-05-06 00:00:00	32020		\N	304965	0	195662009	4112343		0
77405	4586	81151	1989-04-08	1989-04-08 00:00:00	1989-04-29	1989-04-29 00:00:00	32020		\N	305484	0	44465007	81151		0
77533	4593	260139	1984-06-09	1984-06-09 00:00:00	1984-06-23	1984-06-23 00:00:00	32020		\N	306079	0	10509002	260139		0
67227	3973	40481087	1980-07-12	1980-07-12 00:00:00	1980-07-19	1980-07-19 00:00:00	32020		\N	264204	0	444814009	40481087		0
88490	5259	80180	1999-11-06	1999-11-06 00:00:00	\N	\N	32020		\N	349951	0	396275006	80180		0
78025	4623	4027663	1963-05-06	1963-05-06 00:00:00	\N	\N	32020		\N	308014	0	13200003	4027663		0
67687	3998	4134304	1972-10-28	1972-10-28 00:00:00	1973-01-26	1973-01-26 00:00:00	32020		\N	265789	0	263102004	4134304		0
67859	4010	439777	1999-04-30	1999-04-30 00:00:00	\N	\N	32020		\N	266454	0	271737000	439777		0
78526	4649	40481087	2008-08-04	2008-08-04 00:00:00	2008-08-25	2008-08-25 00:00:00	32020		\N	309996	0	444814009	40481087		0
68183	4027	40481087	1974-05-11	1974-05-11 00:00:00	1974-05-18	1974-05-18 00:00:00	32020		\N	267829	0	444814009	40481087		0
78941	4675	80502	1991-10-20	1991-10-20 00:00:00	\N	\N	32020		\N	311565	0	64859006	80502		0
68557	4053	28060	1971-07-10	1971-07-10 00:00:00	1971-07-21	1971-07-21 00:00:00	32020		\N	269426	0	43878008	28060		0
79227	4690	40481087	2016-03-20	2016-03-20 00:00:00	2016-04-03	2016-04-03 00:00:00	32020		\N	312497	0	444814009	40481087		0
79423	4704	260139	1972-01-17	1972-01-17 00:00:00	1972-01-24	1972-01-24 00:00:00	32020		\N	313395	0	10509002	260139		0
68968	4081	4112343	2015-06-03	2015-06-03 00:00:00	2015-06-12	2015-06-12 00:00:00	32020		\N	271250	0	195662009	4112343		0
69179	4092	4278672	1986-12-26	1986-12-26 00:00:00	1987-01-25	1987-01-25 00:00:00	32020		\N	272072	0	65966004	4278672		0
79968	4739	4112343	1984-07-14	1984-07-14 00:00:00	1984-07-22	1984-07-22 00:00:00	32020		\N	315688	0	195662009	4112343		0
69423	4109	4112343	1999-06-11	1999-06-11 00:00:00	1999-06-20	1999-06-20 00:00:00	32020		\N	273143	0	195662009	4112343		0
69622	4119	375671	1978-05-14	1978-05-14 00:00:00	1978-07-13	1978-07-13 00:00:00	32020		\N	273811	0	62564004	375671		0
80389	4761	4027663	2011-04-28	2011-04-28 00:00:00	\N	\N	32020		\N	317245	0	13200003	4027663		0
70159	4153	4310024	1999-08-02	1999-08-02 00:00:00	\N	\N	32020		\N	276013	0	424802006	4310024		0
80905	4799	40481087	1996-02-29	1996-02-29 00:00:00	1996-03-14	1996-03-14 00:00:00	32020		\N	319273	0	444814009	40481087		0
81164	4814	4112343	1942-03-26	1942-03-26 00:00:00	1942-04-07	1942-04-07 00:00:00	32020		\N	320301	0	195662009	4112343		0
81286	4820	80180	1995-10-07	1995-10-07 00:00:00	\N	\N	32020		\N	320626	0	396275006	80180		0
81349	4826	260139	1991-11-07	1991-11-07 00:00:00	1991-11-21	1991-11-21 00:00:00	32020		\N	320946	0	10509002	260139		0
71010	4212	40481087	1977-08-27	1977-08-27 00:00:00	1977-09-10	1977-09-10 00:00:00	32020		\N	279662	0	444814009	40481087		0
71103	4217	40481087	1963-09-22	1963-09-22 00:00:00	1963-10-13	1963-10-13 00:00:00	32020		\N	279970	0	444814009	40481087		0
81840	4853	40481087	1999-04-02	1999-04-02 00:00:00	1999-04-23	1999-04-23 00:00:00	32020		\N	322926	0	444814009	40481087		0
71479	4240	40481087	1971-01-12	1971-01-12 00:00:00	1971-01-19	1971-01-19 00:00:00	32020		\N	281690	0	444814009	40481087		0
82203	4874	80180	2004-02-11	2004-02-11 00:00:00	\N	\N	32020		\N	324195	0	396275006	80180		0
71833	4261	81151	1957-08-05	1957-08-05 00:00:00	1957-08-26	1957-08-26 00:00:00	32020		\N	282891	0	44465007	81151		0
72010	4274	40481087	1929-06-11	1929-06-11 00:00:00	1929-07-02	1929-07-02 00:00:00	32020		\N	283631	0	444814009	40481087		0
72116	4279	40481087	1984-07-25	1984-07-25 00:00:00	1984-08-01	1984-08-01 00:00:00	32020		\N	284077	0	444814009	40481087		0
72283	4289	4027663	1967-07-13	1967-07-13 00:00:00	\N	\N	32020		\N	284807	0	13200003	4027663		0
83067	4933	4059173	1970-12-30	1970-12-30 00:00:00	1971-01-29	1971-01-29 00:00:00	32020		\N	327964	0	16114001	4059173		0
83201	4943	28060	2016-02-23	2016-02-23 00:00:00	2016-03-05	2016-03-05 00:00:00	32020		\N	328583	0	43878008	28060		0
72850	4330	40481087	1988-07-24	1988-07-24 00:00:00	1988-07-31	1988-07-31 00:00:00	32020		\N	287189	0	444814009	40481087		0
83651	4971	80502	2015-02-24	2015-02-24 00:00:00	\N	\N	32020		\N	330583	0	64859006	80502		0
83695	4972	4283893	1980-04-13	1980-04-13 00:00:00	1980-11-30	1980-11-30 00:00:00	32020		\N	330703	0	36971009	4283893		0
73350	4359	372328	1952-07-04	1952-07-04 00:00:00	1953-02-18	1953-02-18 00:00:00	32020		\N	289228	0	65363002	372328		0
84073	4992	40481087	2006-05-13	2006-05-13 00:00:00	2006-05-27	2006-05-27 00:00:00	32020		\N	332091	0	444814009	40481087		0
73606	4375	4166224	1946-07-06	1946-07-06 00:00:00	\N	\N	32020		\N	290621	0	47693006	4166224		0
84379	5015	372328	1983-05-10	1983-05-10 00:00:00	1984-03-19	1984-03-19 00:00:00	32020		\N	333346	0	65363002	372328		0
84613	5031	40481087	1935-11-02	1935-11-02 00:00:00	1935-11-16	1935-11-16 00:00:00	32020		\N	334272	0	444814009	40481087		0
84691	5035	40481087	1983-07-08	1983-07-08 00:00:00	1983-07-29	1983-07-29 00:00:00	32020		\N	334548	0	444814009	40481087		0
84905	5049	4283893	1970-09-09	1970-09-09 00:00:00	1970-09-23	1970-09-23 00:00:00	32020		\N	335619	0	36971009	4283893		0
74457	4419	4112343	1965-10-30	1965-10-30 00:00:00	1965-11-06	1965-11-06 00:00:00	32020		\N	293862	0	195662009	4112343		0
74665	4435	4112343	1973-07-31	1973-07-31 00:00:00	1973-08-08	1973-08-08 00:00:00	32020		\N	294780	0	195662009	4112343		0
64236	3793	4285898	1982-05-11	1982-05-11 00:00:00	\N	\N	32020		\N	252289	0	68496003	4285898		0
64395	3803	4310024	2002-07-02	2002-07-02 00:00:00	\N	\N	32020		\N	252757	0	424802006	4310024		0
64512	3813	40481087	2002-11-16	2002-11-16 00:00:00	2002-11-23	2002-11-23 00:00:00	32020		\N	253276	0	444814009	40481087		0
75257	4470	80180	2012-09-20	2012-09-20 00:00:00	\N	\N	32020		\N	297339	0	396275006	80180		0
64788	3831	4294548	1997-02-24	1997-02-24 00:00:00	1997-06-16	1997-06-16 00:00:00	32020		\N	254375	0	75498004	4294548		0
65061	3849	40481087	1996-01-10	1996-01-10 00:00:00	1996-01-31	1996-01-31 00:00:00	32020		\N	255453	0	444814009	40481087		0
65179	3856	40481087	1992-03-08	1992-03-08 00:00:00	1992-03-22	1992-03-22 00:00:00	32020		\N	255923	0	444814009	40481087		0
65344	3864	81151	1978-08-30	1978-08-30 00:00:00	1978-10-04	1978-10-04 00:00:00	32020		\N	256525	0	44465007	81151		0
65541	3875	40481087	1988-12-17	1988-12-17 00:00:00	1988-12-24	1988-12-24 00:00:00	32020		\N	257397	0	444814009	40481087		0
76269	4525	80180	2007-08-04	2007-08-04 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
76430	4532	4152936	1946-03-04	1946-03-04 00:00:00	1946-03-18	1946-03-18 00:00:00	32020		\N	301938	0	283385000	4152936		0
66048	3906	40481087	1962-01-06	1962-01-06 00:00:00	1962-01-20	1962-01-20 00:00:00	32020		\N	259741	0	444814009	40481087		0
76701	4547	4112343	1990-11-11	1990-11-11 00:00:00	1990-11-19	1990-11-19 00:00:00	32020		\N	302910	0	195662009	4112343		0
66399	3930	40481087	1947-01-07	1947-01-07 00:00:00	1947-01-14	1947-01-14 00:00:00	32020		\N	261240	0	444814009	40481087		0
66498	3936	378001	2014-10-17	2014-10-17 00:00:00	2014-12-16	2014-12-16 00:00:00	32020		\N	261657	0	62106007	378001		0
77286	4578	40481087	1964-09-30	1964-09-30 00:00:00	1964-10-14	1964-10-14 00:00:00	32020		\N	304916	0	444814009	40481087		0
77406	4586	81151	2003-08-14	2003-08-14 00:00:00	2003-09-04	2003-09-04 00:00:00	32020		\N	305485	0	44465007	81151		0
77534	4593	372328	1966-05-18	1966-05-18 00:00:00	1966-08-18	1966-08-18 00:00:00	32020		\N	306065	0	65363002	372328		0
67228	3973	4112343	2019-02-15	2019-02-15 00:00:00	2019-02-28	2019-02-28 00:00:00	32020		\N	264205	0	195662009	4112343		0
88491	5259	260139	1973-02-11	1973-02-11 00:00:00	1973-02-18	1973-02-18 00:00:00	32020		\N	349972	0	10509002	260139		0
78026	4623	4112343	1942-01-20	1942-01-20 00:00:00	1942-01-29	1942-01-29 00:00:00	32020		\N	307964	0	195662009	4112343		0
67688	3998	4112343	1962-02-08	1962-02-08 00:00:00	1962-02-16	1962-02-16 00:00:00	32020		\N	265834	0	195662009	4112343		0
67860	4010	260139	1999-11-24	1999-11-24 00:00:00	1999-12-01	1999-12-01 00:00:00	32020		\N	266516	0	10509002	260139		0
78527	4649	40481087	2003-10-07	2003-10-07 00:00:00	2003-10-21	2003-10-21 00:00:00	32020		\N	310010	0	444814009	40481087		0
68184	4027	4112343	2017-06-19	2017-06-19 00:00:00	2017-06-28	2017-06-28 00:00:00	32020		\N	267827	0	195662009	4112343		0
78942	4675	260139	1959-07-08	1959-07-08 00:00:00	1959-07-15	1959-07-15 00:00:00	32020		\N	311570	0	10509002	260139		0
68558	4053	260139	1963-08-20	1963-08-20 00:00:00	1963-08-27	1963-08-27 00:00:00	32020		\N	269421	0	10509002	260139		0
79228	4690	28060	2008-05-03	2008-05-03 00:00:00	2008-05-12	2008-05-12 00:00:00	32020		\N	312538	0	43878008	28060		0
79424	4704	28060	1968-10-05	1968-10-05 00:00:00	1968-10-17	1968-10-17 00:00:00	32020		\N	313392	0	43878008	28060		0
68969	4081	4112343	1969-07-09	1969-07-09 00:00:00	1969-07-19	1969-07-19 00:00:00	32020		\N	271284	0	195662009	4112343		0
69191	4094	4294548	1961-11-18	1961-11-18 00:00:00	1961-12-02	1961-12-02 00:00:00	32020		\N	272140	0	75498004	4294548		0
79969	4739	4112343	1947-11-05	1947-11-05 00:00:00	1947-11-16	1947-11-16 00:00:00	32020		\N	315754	0	195662009	4112343		0
69424	4109	260139	1988-09-17	1988-09-17 00:00:00	1988-09-24	1988-09-24 00:00:00	32020		\N	273104	0	10509002	260139		0
69623	4119	4152936	1981-04-28	1981-04-28 00:00:00	1981-05-12	1981-05-12 00:00:00	32020		\N	273812	0	283385000	4152936		0
80390	4761	260139	2014-06-19	2014-06-19 00:00:00	2014-06-26	2014-06-26 00:00:00	32020		\N	317325	0	10509002	260139		0
70175	4156	4294548	1966-04-09	1966-04-09 00:00:00	1966-04-30	1966-04-30 00:00:00	32020		\N	276161	0	75498004	4294548		0
80906	4799	40481087	1998-08-06	1998-08-06 00:00:00	1998-08-20	1998-08-20 00:00:00	32020		\N	319209	0	444814009	40481087		0
81165	4814	372328	1940-04-20	1940-04-20 00:00:00	1940-09-16	1940-09-16 00:00:00	32020		\N	320305	0	65363002	372328		0
81287	4820	4112343	1968-04-18	1968-04-18 00:00:00	1968-04-26	1968-04-26 00:00:00	32020		\N	320619	0	195662009	4112343		0
81350	4826	40481087	1969-05-25	1969-05-25 00:00:00	1969-06-15	1969-06-15 00:00:00	32020		\N	321068	0	444814009	40481087		0
83101	4935	4027663	1993-09-17	1993-09-17 00:00:00	\N	\N	32020		\N	328123	0	13200003	4027663		0
71011	4212	4112343	1982-09-05	1982-09-05 00:00:00	1982-09-15	1982-09-15 00:00:00	32020		\N	279646	0	195662009	4112343		0
71104	4217	4112343	1989-02-22	1989-02-22 00:00:00	1989-03-01	1989-03-01 00:00:00	32020		\N	279949	0	195662009	4112343		0
81841	4853	260139	1995-03-18	1995-03-18 00:00:00	1995-04-01	1995-04-01 00:00:00	32020		\N	322885	0	10509002	260139		0
71480	4240	80180	1985-12-02	1985-12-02 00:00:00	\N	\N	32020		\N	281601	0	396275006	80180		0
82204	4874	40481087	2003-05-09	2003-05-09 00:00:00	2003-05-23	2003-05-23 00:00:00	32020		\N	324195	0	444814009	40481087		0
71834	4261	4112343	2016-11-08	2016-11-08 00:00:00	2016-11-21	2016-11-21 00:00:00	32020		\N	282944	0	195662009	4112343		0
72011	4274	28060	1986-01-06	1986-01-06 00:00:00	1986-01-16	1986-01-16 00:00:00	32020		\N	283554	0	43878008	28060		0
72117	4279	4059173	2018-03-16	2018-03-16 00:00:00	2018-05-15	2018-05-15 00:00:00	32020		\N	284093	0	16114001	4059173		0
72284	4289	40481087	1988-11-01	1988-11-01 00:00:00	1988-11-22	1988-11-22 00:00:00	32020		\N	284765	0	444814009	40481087		0
83076	4935	4146173	1988-06-04	1988-06-04 00:00:00	1988-08-03	1988-08-03 00:00:00	32020		\N	328075	0	307731004	4146173		0
83202	4943	28060	1971-12-05	1971-12-05 00:00:00	1971-12-14	1971-12-14 00:00:00	32020		\N	328538	0	43878008	28060		0
72851	4330	372328	1951-06-15	1951-06-15 00:00:00	1951-12-08	1951-12-08 00:00:00	32020		\N	287192	0	65363002	372328		0
83652	4971	261325	1999-11-30	1999-11-30 00:00:00	\N	\N	32020		\N	330579	0	87433001	261325		0
83696	4972	4112343	1996-12-04	1996-12-04 00:00:00	1996-12-12	1996-12-12 00:00:00	32020		\N	330669	0	195662009	4112343		0
73351	4359	372328	1985-04-01	1985-04-01 00:00:00	1986-11-19	1986-11-19 00:00:00	32020		\N	289254	0	65363002	372328		0
84074	4992	40481087	2016-08-07	2016-08-07 00:00:00	2016-08-14	2016-08-14 00:00:00	32020		\N	332098	0	444814009	40481087		0
73607	4375	260139	1936-03-12	1936-03-12 00:00:00	1936-03-19	1936-03-19 00:00:00	32020		\N	290633	0	10509002	260139		0
84380	5015	40481087	1977-08-11	1977-08-11 00:00:00	1977-08-18	1977-08-18 00:00:00	32020		\N	333381	0	444814009	40481087		0
84614	5031	4283893	1986-05-31	1986-05-31 00:00:00	1986-06-21	1986-06-21 00:00:00	32020		\N	334395	0	36971009	4283893		0
84692	5035	313217	2011-08-15	2011-08-15 00:00:00	\N	\N	32020		\N	334646	0	49436004	313217		0
84907	5049	321042	1998-02-18	1998-02-18 00:00:00	\N	\N	32020		\N	335586	0	410429000	321042		0
74458	4419	4218389	1971-03-06	1971-03-06 00:00:00	1971-04-03	1971-04-03 00:00:00	32020		\N	293818	0	39848009	4218389		0
74666	4435	28060	1976-08-26	1976-08-26 00:00:00	1976-09-08	1976-09-08 00:00:00	32020		\N	294758	0	43878008	28060		0
64237	3793	80180	1982-11-07	1982-11-07 00:00:00	\N	\N	32020		\N	252289	0	396275006	80180		0
64396	3803	40481087	1984-06-23	1984-06-23 00:00:00	1984-06-30	1984-06-30 00:00:00	32020		\N	252765	0	444814009	40481087		0
64513	3813	40481087	1979-02-08	1979-02-08 00:00:00	1979-02-22	1979-02-22 00:00:00	32020		\N	253293	0	444814009	40481087		0
75258	4470	4294548	2005-09-04	2005-09-04 00:00:00	2005-10-16	2005-10-16 00:00:00	32020		\N	297350	0	75498004	4294548		0
64789	3832	40481087	2017-03-28	2017-03-28 00:00:00	2017-04-11	2017-04-11 00:00:00	32020		\N	254441	0	444814009	40481087		0
65062	3849	28060	1965-02-14	1965-02-14 00:00:00	1965-02-25	1965-02-25 00:00:00	32020		\N	255451	0	43878008	28060		0
65180	3856	260139	1984-06-18	1984-06-18 00:00:00	1984-06-25	1984-06-25 00:00:00	32020		\N	255921	0	10509002	260139		0
65345	3864	4112343	2010-01-31	2010-01-31 00:00:00	2010-02-08	2010-02-08 00:00:00	32020		\N	256509	0	195662009	4112343		0
65542	3875	4112343	2008-06-21	2008-06-21 00:00:00	2008-06-28	2008-06-28 00:00:00	32020		\N	257327	0	195662009	4112343		0
76270	4525	260139	2007-05-23	2007-05-23 00:00:00	2007-05-30	2007-05-30 00:00:00	32020		\N	301289	0	10509002	260139		0
76431	4532	140673	1964-04-03	1964-04-03 00:00:00	\N	\N	32020		\N	301895	0	40930008	140673		0
66049	3906	78272	1989-09-14	1989-09-14 00:00:00	1989-10-19	1989-10-19 00:00:00	32020		\N	259752	0	70704007	78272		0
76702	4547	4112343	1936-07-10	1936-07-10 00:00:00	1936-07-22	1936-07-22 00:00:00	32020		\N	302857	0	195662009	4112343		0
66400	3930	372328	1914-09-28	1914-09-28 00:00:00	1914-12-05	1914-12-05 00:00:00	32020		\N	261258	0	65363002	372328		0
66499	3936	28060	1991-05-27	1991-05-27 00:00:00	1991-06-08	1991-06-08 00:00:00	32020		\N	261618	0	43878008	28060		0
77287	4578	4112343	1975-01-10	1975-01-10 00:00:00	1975-01-20	1975-01-20 00:00:00	32020		\N	304976	0	195662009	4112343		0
77407	4586	40481087	2014-03-30	2014-03-30 00:00:00	2014-04-06	2014-04-06 00:00:00	32020		\N	305522	0	444814009	40481087		0
77535	4593	28060	1975-09-11	1975-09-11 00:00:00	1975-09-21	1975-09-21 00:00:00	32020		\N	306078	0	43878008	28060		0
67229	3973	40481087	1989-11-07	1989-11-07 00:00:00	1989-11-28	1989-11-28 00:00:00	32020		\N	264222	0	444814009	40481087		0
88492	5259	28060	2011-03-21	2011-03-21 00:00:00	2011-04-02	2011-04-02 00:00:00	32020		\N	349969	0	43878008	28060		0
78027	4623	4112343	1973-10-21	1973-10-21 00:00:00	1973-11-03	1973-11-03 00:00:00	32020		\N	307898	0	195662009	4112343		0
67689	3998	40481087	1976-07-12	1976-07-12 00:00:00	1976-08-02	1976-08-02 00:00:00	32020		\N	265848	0	444814009	40481087		0
67861	4010	4294548	2016-05-21	2016-05-21 00:00:00	2016-06-11	2016-06-11 00:00:00	32020		\N	266464	0	75498004	4294548		0
78528	4649	4278672	1984-05-06	1984-05-06 00:00:00	1984-06-05	1984-06-05 00:00:00	32020		\N	309990	0	65966004	4278672		0
68185	4027	80180	2008-04-16	2008-04-16 00:00:00	\N	\N	32020		\N	267883	0	396275006	80180		0
78943	4675	40481087	1977-07-06	1977-07-06 00:00:00	1977-07-27	1977-07-27 00:00:00	32020		\N	311550	0	444814009	40481087		0
79017	4678	40481087	1962-10-23	1962-10-23 00:00:00	1962-11-13	1962-11-13 00:00:00	32020		\N	311737	0	444814009	40481087		0
79229	4690	260139	1978-10-14	1978-10-14 00:00:00	1978-10-28	1978-10-28 00:00:00	32020		\N	312515	0	10509002	260139		0
79425	4704	4112343	1990-06-07	1990-06-07 00:00:00	1990-06-15	1990-06-15 00:00:00	32020		\N	313396	0	195662009	4112343		0
68970	4081	4134304	1965-03-20	1965-03-20 00:00:00	1965-04-19	1965-04-19 00:00:00	32020		\N	271237	0	263102004	4134304		0
69192	4094	28060	2004-09-16	2004-09-16 00:00:00	2004-09-23	2004-09-23 00:00:00	32020		\N	272116	0	43878008	28060		0
79970	4739	260139	1943-12-27	1943-12-27 00:00:00	1944-01-10	1944-01-10 00:00:00	32020		\N	315701	0	10509002	260139		0
69425	4109	133834	1965-05-07	1965-05-07 00:00:00	\N	\N	32020		\N	273153	0	24079001	133834		0
69624	4119	40481087	1946-08-19	1946-08-19 00:00:00	1946-09-09	1946-09-09 00:00:00	32020		\N	273790	0	444814009	40481087		0
80391	4761	260139	2000-08-20	2000-08-20 00:00:00	2000-08-27	2000-08-27 00:00:00	32020		\N	317323	0	10509002	260139		0
70176	4156	40481087	1993-02-09	1993-02-09 00:00:00	1993-03-02	1993-03-02 00:00:00	32020		\N	276172	0	444814009	40481087		0
80907	4799	4156265	1969-04-17	1969-04-17 00:00:00	1969-05-01	1969-05-01 00:00:00	32020		\N	319242	0	370247008	4156265		0
81166	4814	4112343	1947-06-29	1947-06-29 00:00:00	1947-07-06	1947-07-06 00:00:00	32020		\N	320252	0	195662009	4112343		0
81288	4820	260139	1982-12-05	1982-12-05 00:00:00	1982-12-19	1982-12-19 00:00:00	32020		\N	320668	0	10509002	260139		0
81351	4826	40481087	1996-02-23	1996-02-23 00:00:00	1996-03-15	1996-03-15 00:00:00	32020		\N	321030	0	444814009	40481087		0
71012	4212	4112343	1993-10-04	1993-10-04 00:00:00	1993-10-15	1993-10-15 00:00:00	32020		\N	279648	0	195662009	4112343		0
71105	4217	40481087	1980-08-27	1980-08-27 00:00:00	1980-09-03	1980-09-03 00:00:00	32020		\N	279948	0	444814009	40481087		0
81842	4853	4112343	1965-04-09	1965-04-09 00:00:00	1965-04-22	1965-04-22 00:00:00	32020		\N	322867	0	195662009	4112343		0
71481	4240	260139	1973-03-10	1973-03-10 00:00:00	1973-03-24	1973-03-24 00:00:00	32020		\N	281635	0	10509002	260139		0
82205	4874	257012	1980-10-11	1980-10-11 00:00:00	1980-11-01	1980-11-01 00:00:00	32020		\N	324168	0	40055000	257012		0
71835	4261	260139	1929-09-02	1929-09-02 00:00:00	1929-09-09	1929-09-09 00:00:00	32020		\N	282862	0	10509002	260139		0
72012	4274	260139	1943-04-22	1943-04-22 00:00:00	1943-04-29	1943-04-29 00:00:00	32020		\N	283663	0	10509002	260139		0
72118	4279	81151	1964-01-24	1964-01-24 00:00:00	1964-02-28	1964-02-28 00:00:00	32020		\N	284011	0	44465007	81151		0
72285	4289	4112343	2010-03-21	2010-03-21 00:00:00	2010-03-29	2010-03-29 00:00:00	32020		\N	284753	0	195662009	4112343		0
83077	4935	40481087	1989-09-26	1989-09-26 00:00:00	1989-10-10	1989-10-10 00:00:00	32020		\N	328077	0	444814009	40481087		0
83203	4943	4112343	1984-04-11	1984-04-11 00:00:00	1984-04-18	1984-04-18 00:00:00	32020		\N	328539	0	195662009	4112343		0
72852	4330	372328	1948-06-28	1948-06-28 00:00:00	1948-11-27	1948-11-27 00:00:00	32020		\N	287243	0	65363002	372328		0
83653	4971	4112343	2008-10-04	2008-10-04 00:00:00	2008-10-16	2008-10-16 00:00:00	32020		\N	330537	0	195662009	4112343		0
83697	4972	40481087	1961-12-20	1961-12-20 00:00:00	1962-01-03	1962-01-03 00:00:00	32020		\N	330667	0	444814009	40481087		0
73352	4359	4112343	1988-03-06	1988-03-06 00:00:00	1988-03-18	1988-03-18 00:00:00	32020		\N	289178	0	195662009	4112343		0
84075	4992	80180	2019-03-24	2019-03-24 00:00:00	\N	\N	32020		\N	332098	0	396275006	80180		0
73608	4375	260139	1952-06-13	1952-06-13 00:00:00	1952-06-20	1952-06-20 00:00:00	32020		\N	290603	0	10509002	260139		0
84381	5015	260139	1991-02-06	1991-02-06 00:00:00	1991-02-13	1991-02-13 00:00:00	32020		\N	333382	0	10509002	260139		0
84615	5031	4283893	1990-05-07	1990-05-07 00:00:00	1990-09-24	1990-09-24 00:00:00	32020		\N	334288	0	36971009	4283893		0
84694	5035	321042	2003-03-03	2003-03-03 00:00:00	\N	\N	32020		\N	334577	0	410429000	321042		0
84908	5049	4112343	1977-06-15	1977-06-15 00:00:00	1977-06-28	1977-06-28 00:00:00	32020		\N	335575	0	195662009	4112343		0
74459	4419	4112343	1972-12-02	1972-12-02 00:00:00	1972-12-14	1972-12-14 00:00:00	32020		\N	293864	0	195662009	4112343		0
74667	4435	4285898	2000-09-14	2000-09-14 00:00:00	\N	\N	32020		\N	294819	0	68496003	4285898		0
64238	3793	40481087	2017-09-10	2017-09-10 00:00:00	2017-09-17	2017-09-17 00:00:00	32020		\N	252268	0	444814009	40481087		0
64397	3803	260139	1975-05-04	1975-05-04 00:00:00	1975-05-11	1975-05-11 00:00:00	32020		\N	252755	0	10509002	260139		0
64514	3813	260139	2012-10-01	2012-10-01 00:00:00	2012-10-15	2012-10-15 00:00:00	32020		\N	253302	0	10509002	260139		0
75259	4470	40481087	1976-10-22	1976-10-22 00:00:00	1976-11-05	1976-11-05 00:00:00	32020		\N	297348	0	444814009	40481087		0
64790	3832	4146173	2017-06-25	2017-06-25 00:00:00	2017-07-25	2017-07-25 00:00:00	32020		\N	254454	0	307731004	4146173		0
65063	3849	378001	2006-11-24	2006-11-24 00:00:00	2006-12-24	2006-12-24 00:00:00	32020		\N	255448	0	62106007	378001		0
65181	3856	4112343	1977-04-27	1977-04-27 00:00:00	1977-05-05	1977-05-05 00:00:00	32020		\N	255919	0	195662009	4112343		0
65346	3865	4112343	1986-04-25	1986-04-25 00:00:00	1986-05-05	1986-05-05 00:00:00	32020		\N	256661	0	195662009	4112343		0
65543	3875	4112343	2019-01-05	2019-01-05 00:00:00	2019-01-17	2019-01-17 00:00:00	32020		\N	257361	0	195662009	4112343		0
76271	4525	40481087	2015-11-29	2015-11-29 00:00:00	2015-12-20	2015-12-20 00:00:00	32020		\N	301272	0	444814009	40481087		0
76432	4532	40481087	1985-02-02	1985-02-02 00:00:00	1985-02-09	1985-02-09 00:00:00	32020		\N	301909	0	444814009	40481087		0
66050	3906	80502	2012-10-31	2012-10-31 00:00:00	\N	\N	32020		\N	259712	0	64859006	80502		0
76703	4547	4112343	2008-03-04	2008-03-04 00:00:00	2008-03-13	2008-03-13 00:00:00	32020		\N	302970	0	195662009	4112343		0
76870	4557	81151	1932-10-03	1932-10-03 00:00:00	1932-10-31	1932-10-31 00:00:00	32020		\N	303638	0	44465007	81151		0
66500	3936	4218389	1962-02-01	1962-02-01 00:00:00	1962-02-22	1962-02-22 00:00:00	32020		\N	261631	0	39848009	4218389		0
77288	4578	260139	1998-06-05	1998-06-05 00:00:00	1998-06-19	1998-06-19 00:00:00	32020		\N	304948	0	10509002	260139		0
77408	4586	378001	1969-02-22	1969-02-22 00:00:00	1969-04-23	1969-04-23 00:00:00	32020		\N	305483	0	62106007	378001		0
77536	4593	40481087	1985-01-16	1985-01-16 00:00:00	1985-02-06	1985-02-06 00:00:00	32020		\N	306073	0	444814009	40481087		0
67230	3973	372328	1979-06-28	1979-06-28 00:00:00	1979-08-09	1979-08-09 00:00:00	32020		\N	264206	0	65363002	372328		0
88493	5259	372328	1959-02-24	1959-02-24 00:00:00	1959-04-06	1959-04-06 00:00:00	32020		\N	349970	0	65363002	372328		0
78028	4623	4112343	1943-09-22	1943-09-22 00:00:00	1943-10-05	1943-10-05 00:00:00	32020		\N	307965	0	195662009	4112343		0
67690	3998	4027663	1977-06-04	1977-06-04 00:00:00	\N	\N	32020		\N	265848	0	13200003	4027663		0
67862	4010	28060	1981-03-18	1981-03-18 00:00:00	1981-03-30	1981-03-30 00:00:00	32020		\N	266493	0	43878008	28060		0
78529	4649	81151	2010-01-25	2010-01-25 00:00:00	2010-02-15	2010-02-15 00:00:00	32020		\N	309992	0	44465007	81151		0
68186	4027	81151	2006-02-16	2006-02-16 00:00:00	2006-03-23	2006-03-23 00:00:00	32020		\N	267883	0	44465007	81151		0
78944	4675	372328	1916-05-01	1916-05-01 00:00:00	1916-06-11	1916-06-11 00:00:00	32020		\N	311483	0	65363002	372328		0
79018	4678	4112343	1973-07-29	1973-07-29 00:00:00	1973-08-11	1973-08-11 00:00:00	32020		\N	311736	0	195662009	4112343		0
79230	4690	4283893	2005-04-15	2005-04-15 00:00:00	2005-06-17	2005-06-17 00:00:00	32020		\N	312456	0	36971009	4283893		0
79426	4704	4134304	1982-09-04	1982-09-04 00:00:00	1982-11-03	1982-11-03 00:00:00	32020		\N	313431	0	263102004	4134304		0
68971	4081	260139	1968-02-04	1968-02-04 00:00:00	1968-02-11	1968-02-11 00:00:00	32020		\N	271253	0	10509002	260139		0
69193	4094	28060	1968-03-31	1968-03-31 00:00:00	1968-04-11	1968-04-11 00:00:00	32020		\N	272121	0	43878008	28060		0
79971	4739	372328	1927-09-11	1927-09-11 00:00:00	1928-08-11	1928-08-11 00:00:00	32020		\N	315691	0	65363002	372328		0
69426	4109	40481087	1969-10-06	1969-10-06 00:00:00	1969-10-20	1969-10-20 00:00:00	32020		\N	273156	0	444814009	40481087		0
69631	4121	81151	1925-11-18	1925-11-18 00:00:00	1925-12-09	1925-12-09 00:00:00	32020		\N	273928	0	44465007	81151		0
80392	4761	372328	1981-09-27	1981-09-27 00:00:00	1981-10-11	1981-10-11 00:00:00	32020		\N	317290	0	65363002	372328		0
70177	4156	40481087	1971-12-13	1971-12-13 00:00:00	1971-12-27	1971-12-27 00:00:00	32020		\N	276179	0	444814009	40481087		0
80908	4799	81151	1972-02-15	1972-02-15 00:00:00	1972-03-07	1972-03-07 00:00:00	32020		\N	319244	0	44465007	81151		0
81167	4814	81151	1953-09-28	1953-09-28 00:00:00	1953-10-26	1953-10-26 00:00:00	32020		\N	320246	0	44465007	81151		0
81289	4820	4109685	2002-08-08	2002-08-08 00:00:00	2002-08-22	2002-08-22 00:00:00	32020		\N	320646	0	284551006	4109685		0
81352	4826	28060	1992-04-17	1992-04-17 00:00:00	1992-04-28	1992-04-28 00:00:00	32020		\N	320943	0	43878008	28060		0
71013	4212	260139	1983-10-20	1983-10-20 00:00:00	1983-10-27	1983-10-27 00:00:00	32020		\N	279682	0	10509002	260139		0
71106	4217	4310024	1998-12-31	1998-12-31 00:00:00	\N	\N	32020		\N	280018	0	424802006	4310024		0
81843	4853	4112343	2015-04-04	2015-04-04 00:00:00	2015-04-16	2015-04-16 00:00:00	32020		\N	322902	0	195662009	4112343		0
71482	4240	4112343	2003-09-01	2003-09-01 00:00:00	2003-09-14	2003-09-14 00:00:00	32020		\N	281673	0	195662009	4112343		0
82206	4874	40481087	1975-03-09	1975-03-09 00:00:00	1975-03-23	1975-03-23 00:00:00	32020		\N	324204	0	444814009	40481087		0
71836	4261	260139	1962-07-19	1962-07-19 00:00:00	1962-08-02	1962-08-02 00:00:00	32020		\N	282860	0	10509002	260139		0
72013	4274	372328	1926-01-29	1926-01-29 00:00:00	1926-11-12	1926-11-12 00:00:00	32020		\N	283574	0	65363002	372328		0
72119	4279	260139	1970-10-20	1970-10-20 00:00:00	1970-11-03	1970-11-03 00:00:00	32020		\N	283947	0	10509002	260139		0
72286	4289	260139	2003-12-24	2003-12-24 00:00:00	2003-12-31	2003-12-31 00:00:00	32020		\N	284787	0	10509002	260139		0
83078	4935	40481087	1981-04-30	1981-04-30 00:00:00	1981-05-07	1981-05-07 00:00:00	32020		\N	328023	0	444814009	40481087		0
83204	4943	4112343	1986-05-11	1986-05-11 00:00:00	1986-05-20	1986-05-20 00:00:00	32020		\N	328554	0	195662009	4112343		0
72853	4330	40481087	1950-07-04	1950-07-04 00:00:00	1950-07-11	1950-07-11 00:00:00	32020		\N	287222	0	444814009	40481087		0
83654	4971	4112343	1983-10-29	1983-10-29 00:00:00	1983-11-05	1983-11-05 00:00:00	32020		\N	330643	0	195662009	4112343		0
83698	4972	378001	1991-01-04	1991-01-04 00:00:00	1991-03-05	1991-03-05 00:00:00	32020		\N	330723	0	62106007	378001		0
73353	4359	4112343	1947-02-22	1947-02-22 00:00:00	1947-03-05	1947-03-05 00:00:00	32020		\N	289216	0	195662009	4112343		0
84076	4992	40481087	1996-04-21	1996-04-21 00:00:00	1996-05-12	1996-05-12 00:00:00	32020		\N	332111	0	444814009	40481087		0
73609	4375	4112343	1959-01-08	1959-01-08 00:00:00	1959-01-15	1959-01-15 00:00:00	32020		\N	290604	0	195662009	4112343		0
84382	5015	4112343	1993-05-06	1993-05-06 00:00:00	1993-05-14	1993-05-14 00:00:00	32020		\N	333383	0	195662009	4112343		0
84616	5031	40481087	1975-06-14	1975-06-14 00:00:00	1975-07-05	1975-07-05 00:00:00	32020		\N	334287	0	444814009	40481087		0
84695	5035	4112343	2011-10-21	2011-10-21 00:00:00	2011-10-30	2011-10-30 00:00:00	32020		\N	334549	0	195662009	4112343		0
84909	5049	4112343	2001-10-24	2001-10-24 00:00:00	2001-11-01	2001-11-01 00:00:00	32020		\N	335579	0	195662009	4112343		0
74460	4419	81151	1959-07-02	1959-07-02 00:00:00	1959-08-06	1959-08-06 00:00:00	32020		\N	293817	0	44465007	81151		0
74668	4435	30753	2000-06-16	2000-06-16 00:00:00	\N	\N	32020		\N	294819	0	16761005	30753		0
64239	3793	4296204	2003-11-16	2003-11-16 00:00:00	2003-12-21	2003-12-21 00:00:00	32020		\N	252280	0	403190006	4296204		0
64398	3803	372328	1962-04-20	1962-04-20 00:00:00	1962-09-19	1962-09-19 00:00:00	32020		\N	252759	0	65363002	372328		0
64515	3813	4156265	1994-11-07	1994-11-07 00:00:00	1994-11-28	1994-11-28 00:00:00	32020		\N	253261	0	370247008	4156265		0
75260	4470	40481087	1984-05-04	1984-05-04 00:00:00	1984-05-25	1984-05-25 00:00:00	32020		\N	297371	0	444814009	40481087		0
64791	3832	40481087	1991-06-12	1991-06-12 00:00:00	1991-07-03	1991-07-03 00:00:00	32020		\N	254451	0	444814009	40481087		0
65064	3849	4218389	1976-06-06	1976-06-06 00:00:00	1976-07-04	1976-07-04 00:00:00	32020		\N	255447	0	39848009	4218389		0
65182	3856	40481087	2008-09-03	2008-09-03 00:00:00	2008-09-24	2008-09-24 00:00:00	32020		\N	255933	0	444814009	40481087		0
65347	3865	40481087	2001-04-28	2001-04-28 00:00:00	2001-05-19	2001-05-19 00:00:00	32020		\N	256545	0	444814009	40481087		0
65544	3875	4294548	1974-02-09	1974-02-09 00:00:00	1974-04-06	1974-04-06 00:00:00	32020		\N	257325	0	75498004	4294548		0
76272	4526	257012	1983-11-27	1983-11-27 00:00:00	\N	\N	32020		\N	301377	0	40055000	257012		0
76433	4532	40481087	1916-08-15	1916-08-15 00:00:00	1916-09-05	1916-09-05 00:00:00	32020		\N	301914	0	444814009	40481087		0
66051	3906	260139	1978-03-13	1978-03-13 00:00:00	1978-03-20	1978-03-20 00:00:00	32020		\N	259655	0	10509002	260139		0
76704	4547	4112343	1968-02-16	1968-02-16 00:00:00	1968-02-27	1968-02-27 00:00:00	32020		\N	302935	0	195662009	4112343		0
76871	4557	4278672	2017-06-24	2017-06-24 00:00:00	2017-09-22	2017-09-22 00:00:00	32020		\N	303645	0	65966004	4278672		0
66501	3936	372328	1959-01-16	1959-01-16 00:00:00	1959-02-16	1959-02-16 00:00:00	32020		\N	261610	0	65363002	372328		0
77289	4578	260139	1998-09-19	1998-09-19 00:00:00	1998-10-03	1998-10-03 00:00:00	32020		\N	304949	0	10509002	260139		0
77409	4586	4283893	1964-03-27	1964-03-27 00:00:00	1964-08-28	1964-08-28 00:00:00	32020		\N	305486	0	36971009	4283893		0
77537	4593	260139	1977-02-01	1977-02-01 00:00:00	1977-02-15	1977-02-15 00:00:00	32020		\N	306034	0	10509002	260139		0
77689	4603	81151	2000-11-22	2000-11-22 00:00:00	2000-12-27	2000-12-27 00:00:00	32020		\N	306622	0	44465007	81151		0
88494	5259	40481087	1992-09-18	1992-09-18 00:00:00	1992-09-25	1992-09-25 00:00:00	32020		\N	349999	0	444814009	40481087		0
78029	4623	134438	1955-05-15	1955-05-15 00:00:00	1956-07-11	1956-07-11 00:00:00	32020		\N	308007	0	40275004	134438		0
67691	3998	4237458	2016-10-24	2016-10-24 00:00:00	2016-12-23	2016-12-23 00:00:00	32020		\N	265850	0	58150001	4237458		0
67863	4010	260139	2006-01-13	2006-01-13 00:00:00	2006-01-20	2006-01-20 00:00:00	32020		\N	266494	0	10509002	260139		0
78530	4649	81151	1978-08-22	1978-08-22 00:00:00	1978-09-05	1978-09-05 00:00:00	32020		\N	309989	0	44465007	81151		0
68188	4027	321042	2014-06-21	2014-06-21 00:00:00	\N	\N	32020		\N	267885	0	410429000	321042		0
78945	4675	40480160	1994-07-17	1994-07-17 00:00:00	1994-08-16	1994-08-16 00:00:00	32020		\N	311446	0	443165006	40480160		0
79019	4678	4112343	1963-03-02	1963-03-02 00:00:00	1963-03-09	1963-03-09 00:00:00	32020		\N	311762	0	195662009	4112343		0
79231	4690	4113008	2004-05-06	2004-05-06 00:00:00	2004-05-20	2004-05-20 00:00:00	32020		\N	312470	0	284549007	4113008		0
79427	4704	4310024	2008-06-05	2008-06-05 00:00:00	\N	\N	32020		\N	313397	0	424802006	4310024		0
68972	4081	260139	1988-10-25	1988-10-25 00:00:00	1988-11-01	1988-11-01 00:00:00	32020		\N	271235	0	10509002	260139		0
69194	4094	40481087	2006-09-28	2006-09-28 00:00:00	2006-10-12	2006-10-12 00:00:00	32020		\N	272117	0	444814009	40481087		0
79972	4739	4112343	1924-04-12	1924-04-12 00:00:00	1924-04-25	1924-04-25 00:00:00	32020		\N	315733	0	195662009	4112343		0
69427	4109	4027663	1991-11-25	1991-11-25 00:00:00	\N	\N	32020		\N	273218	0	13200003	4027663		0
69632	4121	4112343	1923-07-15	1923-07-15 00:00:00	1923-07-24	1923-07-24 00:00:00	32020		\N	273987	0	195662009	4112343		0
80393	4761	40481087	2003-11-17	2003-11-17 00:00:00	2003-12-08	2003-12-08 00:00:00	32020		\N	317305	0	444814009	40481087		0
70178	4156	78272	1960-03-06	1960-03-06 00:00:00	1960-03-27	1960-03-27 00:00:00	32020		\N	276156	0	70704007	78272		0
80909	4799	81151	1983-03-10	1983-03-10 00:00:00	1983-04-14	1983-04-14 00:00:00	32020		\N	319246	0	44465007	81151		0
81168	4814	4112343	1955-12-25	1955-12-25 00:00:00	1956-01-06	1956-01-06 00:00:00	32020		\N	320229	0	195662009	4112343		0
81290	4820	40481087	1987-03-20	1987-03-20 00:00:00	1987-04-10	1987-04-10 00:00:00	32020		\N	320652	0	444814009	40481087		0
81353	4826	40481087	1990-10-10	1990-10-10 00:00:00	1990-10-31	1990-10-31 00:00:00	32020		\N	321050	0	444814009	40481087		0
71014	4212	4142905	1981-01-31	1981-01-31 00:00:00	1981-04-01	1981-04-01 00:00:00	32020		\N	279650	0	33737001	4142905		0
71107	4217	40481087	1960-05-13	1960-05-13 00:00:00	1960-06-03	1960-06-03 00:00:00	32020		\N	279963	0	444814009	40481087		0
81844	4853	372328	1963-12-14	1963-12-14 00:00:00	1964-04-15	1964-04-15 00:00:00	32020		\N	322930	0	65363002	372328		0
71483	4240	257012	1950-03-08	1950-03-08 00:00:00	1967-06-26	1967-06-26 00:00:00	32020		\N	281670	0	40055000	257012		0
82207	4874	4048695	2006-11-26	2006-11-26 00:00:00	2006-12-28	2006-12-28 00:00:00	32020		\N	324213	0	15724005	4048695		0
71837	4261	4112343	1979-04-21	1979-04-21 00:00:00	1979-04-28	1979-04-28 00:00:00	32020		\N	282889	0	195662009	4112343		0
72014	4274	40481087	1929-09-06	1929-09-06 00:00:00	1929-09-20	1929-09-20 00:00:00	32020		\N	283632	0	444814009	40481087		0
72120	4279	40481087	1993-03-22	1993-03-22 00:00:00	1993-03-29	1993-03-29 00:00:00	32020		\N	283992	0	444814009	40481087		0
72287	4289	40481087	1968-12-18	1968-12-18 00:00:00	1968-12-25	1968-12-25 00:00:00	32020		\N	284745	0	444814009	40481087		0
83079	4935	40481087	1987-12-21	1987-12-21 00:00:00	1988-01-11	1988-01-11 00:00:00	32020		\N	328025	0	444814009	40481087		0
83205	4943	4112343	2017-05-02	2017-05-02 00:00:00	2017-05-09	2017-05-09 00:00:00	32020		\N	328577	0	195662009	4112343		0
72854	4330	4283893	1986-04-09	1986-04-09 00:00:00	1986-05-28	1986-05-28 00:00:00	32020		\N	287185	0	36971009	4283893		0
83655	4971	440086	1946-09-01	1946-09-01 00:00:00	1950-12-10	1950-12-10 00:00:00	32020		\N	330541	0	192127007	440086		0
83699	4972	260139	1957-10-10	1957-10-10 00:00:00	1957-10-24	1957-10-24 00:00:00	32020		\N	330687	0	10509002	260139		0
73354	4359	4113008	1979-06-29	1979-06-29 00:00:00	1979-07-13	1979-07-13 00:00:00	32020		\N	289212	0	284549007	4113008		0
84077	4992	260139	2004-05-07	2004-05-07 00:00:00	2004-05-21	2004-05-21 00:00:00	32020		\N	332090	0	10509002	260139		0
73610	4375	260139	1976-10-27	1976-10-27 00:00:00	1976-11-10	1976-11-10 00:00:00	32020		\N	290639	0	10509002	260139		0
84383	5015	28060	1969-04-02	1969-04-02 00:00:00	1969-04-10	1969-04-10 00:00:00	32020		\N	333360	0	43878008	28060		0
84617	5031	4112343	1962-04-30	1962-04-30 00:00:00	1962-05-09	1962-05-09 00:00:00	32020		\N	334362	0	195662009	4112343		0
84696	5035	4283893	1945-08-27	1945-08-27 00:00:00	1945-12-24	1945-12-24 00:00:00	32020		\N	334560	0	36971009	4283893		0
84910	5049	40481087	2012-05-26	2012-05-26 00:00:00	2012-06-02	2012-06-02 00:00:00	32020		\N	335547	0	444814009	40481087		0
74494	4423	260139	2001-10-15	2001-10-15 00:00:00	2001-10-29	2001-10-29 00:00:00	32020		\N	294088	0	10509002	260139		0
74669	4435	80180	2000-10-14	2000-10-14 00:00:00	\N	\N	32020		\N	294819	0	396275006	80180		0
64240	3793	375671	1944-01-06	1944-01-06 00:00:00	1944-02-05	1944-02-05 00:00:00	32020		\N	252273	0	62564004	375671		0
64516	3813	40481087	1986-12-17	1986-12-17 00:00:00	1986-12-31	1986-12-31 00:00:00	32020		\N	253295	0	444814009	40481087		0
75261	4470	40481087	1979-12-28	1979-12-28 00:00:00	1980-01-18	1980-01-18 00:00:00	32020		\N	297357	0	444814009	40481087		0
64792	3832	78272	2006-10-11	2006-10-11 00:00:00	2006-11-15	2006-11-15 00:00:00	32020		\N	254428	0	70704007	78272		0
65065	3849	4112343	2016-12-27	2016-12-27 00:00:00	2017-01-08	2017-01-08 00:00:00	32020		\N	255396	0	195662009	4112343		0
65183	3856	40481087	1991-06-23	1991-06-23 00:00:00	1991-07-07	1991-07-07 00:00:00	32020		\N	255908	0	444814009	40481087		0
65348	3865	40481087	1982-02-01	1982-02-01 00:00:00	1982-02-08	1982-02-08 00:00:00	32020		\N	256581	0	444814009	40481087		0
65545	3875	4296205	1962-10-28	1962-10-28 00:00:00	1962-11-18	1962-11-18 00:00:00	32020		\N	257377	0	403191005	4296205		0
76273	4526	40481087	1986-05-02	1986-05-02 00:00:00	1986-05-09	1986-05-09 00:00:00	32020		\N	301379	0	444814009	40481087		0
76434	4532	40481087	1958-02-17	1958-02-17 00:00:00	1958-03-10	1958-03-10 00:00:00	32020		\N	301953	0	444814009	40481087		0
66052	3906	40481087	2016-05-16	2016-05-16 00:00:00	2016-05-23	2016-05-23 00:00:00	32020		\N	259667	0	444814009	40481087		0
76705	4547	40481087	1946-02-25	1946-02-25 00:00:00	1946-03-11	1946-03-11 00:00:00	32020		\N	302900	0	444814009	40481087		0
76872	4557	40480160	2017-06-24	2017-06-24 00:00:00	2017-09-22	2017-09-22 00:00:00	32020		\N	303645	0	443165006	40480160		0
66502	3936	40481087	2010-09-27	2010-09-27 00:00:00	2010-10-11	2010-10-11 00:00:00	32020		\N	261622	0	444814009	40481087		0
77290	4578	4134304	1979-02-03	1979-02-03 00:00:00	1979-05-04	1979-05-04 00:00:00	32020		\N	304988	0	263102004	4134304		0
77410	4587	40481087	1940-02-05	1940-02-05 00:00:00	1940-02-26	1940-02-26 00:00:00	32020		\N	305538	0	444814009	40481087		0
77538	4593	40481087	1979-10-23	1979-10-23 00:00:00	1979-11-05	1979-11-05 00:00:00	32020		\N	306035	0	444814009	40481087		0
77690	4603	4237458	2004-09-07	2004-09-07 00:00:00	2004-10-07	2004-10-07 00:00:00	32020		\N	306623	0	58150001	4237458		0
88495	5259	4294548	1977-04-19	1977-04-19 00:00:00	1977-12-27	1977-12-27 00:00:00	32020		\N	349944	0	75498004	4294548		0
78030	4623	4112343	1959-02-28	1959-02-28 00:00:00	1959-03-07	1959-03-07 00:00:00	32020		\N	307928	0	195662009	4112343		0
67692	3998	260139	1964-02-15	1964-02-15 00:00:00	1964-02-22	1964-02-22 00:00:00	32020		\N	265845	0	10509002	260139		0
67864	4010	4109685	2019-05-25	2019-05-25 00:00:00	2019-06-15	2019-06-15 00:00:00	32020		\N	266492	0	284551006	4109685		0
78531	4649	4112343	2004-11-18	2004-11-18 00:00:00	2004-11-27	2004-11-27 00:00:00	32020		\N	310011	0	195662009	4112343		0
68189	4027	4112343	1989-02-26	1989-02-26 00:00:00	1989-03-09	1989-03-09 00:00:00	32020		\N	267834	0	195662009	4112343		0
78946	4675	4134304	1994-07-17	1994-07-17 00:00:00	1994-08-16	1994-08-16 00:00:00	32020		\N	311446	0	263102004	4134304		0
79020	4678	40481087	2014-01-05	2014-01-05 00:00:00	2014-01-12	2014-01-12 00:00:00	32020		\N	311740	0	444814009	40481087		0
79232	4690	372328	1958-03-31	1958-03-31 00:00:00	1958-05-17	1958-05-17 00:00:00	32020		\N	312458	0	65363002	372328		0
79428	4704	4027663	1999-12-10	1999-12-10 00:00:00	\N	\N	32020		\N	313420	0	13200003	4027663		0
68973	4081	40481087	2000-12-10	2000-12-10 00:00:00	2000-12-17	2000-12-17 00:00:00	32020		\N	271286	0	444814009	40481087		0
69195	4094	40481087	2016-03-31	2016-03-31 00:00:00	2016-04-14	2016-04-14 00:00:00	32020		\N	272127	0	444814009	40481087		0
79973	4739	40481087	1976-04-19	1976-04-19 00:00:00	1976-05-03	1976-05-03 00:00:00	32020		\N	315673	0	444814009	40481087		0
69428	4109	372328	1967-02-01	1967-02-01 00:00:00	1967-05-09	1967-05-09 00:00:00	32020		\N	273181	0	65363002	372328		0
69633	4121	4116491	1971-05-20	1971-05-20 00:00:00	1971-06-22	1971-06-22 00:00:00	32020		\N	273989	0	301011002	4116491		0
80394	4761	30753	2018-01-16	2018-01-16 00:00:00	\N	\N	32020		\N	317247	0	16761005	30753		0
70179	4156	192671	1997-04-02	1997-04-02 00:00:00	\N	\N	32020		\N	276155	0	K92.2	35208414		0
80910	4799	40481087	1984-07-16	1984-07-16 00:00:00	1984-07-23	1984-07-23 00:00:00	32020		\N	319207	0	444814009	40481087		0
81169	4814	80502	2016-08-15	2016-08-15 00:00:00	\N	\N	32020		\N	320266	0	64859006	80502		0
81291	4820	81151	1961-06-11	1961-06-11 00:00:00	1961-06-25	1961-06-25 00:00:00	32020		\N	320642	0	44465007	81151		0
81354	4826	4112343	1976-01-19	1976-01-19 00:00:00	1976-02-01	1976-02-01 00:00:00	32020		\N	321015	0	195662009	4112343		0
71015	4212	257012	2008-04-19	2008-04-19 00:00:00	\N	\N	32020		\N	279654	0	40055000	257012		0
71108	4217	4112343	1973-09-06	1973-09-06 00:00:00	1973-09-19	1973-09-19 00:00:00	32020		\N	279973	0	195662009	4112343		0
81845	4853	4112343	1994-01-22	1994-01-22 00:00:00	1994-02-04	1994-02-04 00:00:00	32020		\N	322925	0	195662009	4112343		0
71484	4240	4112343	1945-12-30	1945-12-30 00:00:00	1946-01-06	1946-01-06 00:00:00	32020		\N	281686	0	195662009	4112343		0
82208	4874	260139	1976-12-12	1976-12-12 00:00:00	1976-12-26	1976-12-26 00:00:00	32020		\N	324159	0	10509002	260139		0
71838	4261	40481087	1986-09-24	1986-09-24 00:00:00	1986-10-01	1986-10-01 00:00:00	32020		\N	282866	0	444814009	40481087		0
72015	4274	4237458	1995-08-25	1995-08-25 00:00:00	1995-11-23	1995-11-23 00:00:00	32020		\N	283560	0	58150001	4237458		0
72121	4279	260139	1976-03-08	1976-03-08 00:00:00	1976-03-22	1976-03-22 00:00:00	32020		\N	283949	0	10509002	260139		0
72288	4289	260139	2017-11-11	2017-11-11 00:00:00	2017-11-18	2017-11-18 00:00:00	32020		\N	284754	0	10509002	260139		0
83080	4935	40481087	1988-08-17	1988-08-17 00:00:00	1988-08-24	1988-08-24 00:00:00	32020		\N	328076	0	444814009	40481087		0
83206	4943	4134304	1970-07-05	1970-07-05 00:00:00	1970-10-03	1970-10-03 00:00:00	32020		\N	328620	0	263102004	4134304		0
72855	4330	80180	1987-02-25	1987-02-25 00:00:00	\N	\N	32020		\N	287185	0	396275006	80180		0
83656	4971	40481087	1943-04-10	1943-04-10 00:00:00	1943-04-17	1943-04-17 00:00:00	32020		\N	330540	0	444814009	40481087		0
83700	4972	4283893	1952-08-10	1952-08-10 00:00:00	1952-11-30	1952-11-30 00:00:00	32020		\N	330701	0	36971009	4283893		0
73355	4359	4237458	2012-06-17	2012-06-17 00:00:00	2012-08-16	2012-08-16 00:00:00	32020		\N	289214	0	58150001	4237458		0
84078	4992	40481087	1992-05-28	1992-05-28 00:00:00	1992-06-04	1992-06-04 00:00:00	32020		\N	332140	0	444814009	40481087		0
73611	4375	378001	1949-11-11	1949-11-11 00:00:00	1949-12-11	1949-12-11 00:00:00	32020		\N	290622	0	62106007	378001		0
84384	5015	80180	2006-08-14	2006-08-14 00:00:00	\N	\N	32020		\N	333370	0	396275006	80180		0
84618	5031	40481087	2010-03-03	2010-03-03 00:00:00	2010-03-24	2010-03-24 00:00:00	32020		\N	334320	0	444814009	40481087		0
84697	5035	381316	1995-06-19	1995-06-19 00:00:00	\N	\N	32020		\N	334597	0	230690007	381316		0
84911	5049	260139	1969-11-07	1969-11-07 00:00:00	1969-11-21	1969-11-21 00:00:00	32020		\N	335589	0	10509002	260139		0
74495	4423	40481087	1993-08-31	1993-08-31 00:00:00	1993-09-14	1993-09-14 00:00:00	32020		\N	294099	0	444814009	40481087		0
74670	4435	81893	2000-01-18	2000-01-18 00:00:00	\N	\N	32020		\N	294794	0	64766004	81893		0
64241	3793	4112343	1959-10-28	1959-10-28 00:00:00	1959-11-09	1959-11-09 00:00:00	32020		\N	252182	0	195662009	4112343		0
64400	3804	40481087	1986-04-10	1986-04-10 00:00:00	1986-05-01	1986-05-01 00:00:00	32020		\N	252881	0	444814009	40481087		0
64517	3813	378001	1997-11-12	1997-11-12 00:00:00	1998-01-11	1998-01-11 00:00:00	32020		\N	253301	0	62106007	378001		0
75262	4470	257012	2001-03-13	2001-03-13 00:00:00	\N	\N	32020		\N	297380	0	40055000	257012		0
64793	3832	81151	2001-01-26	2001-01-26 00:00:00	2001-02-09	2001-02-09 00:00:00	32020		\N	254461	0	44465007	81151		0
65066	3849	4116491	2006-12-21	2006-12-21 00:00:00	2007-01-26	2007-01-26 00:00:00	32020		\N	255398	0	301011002	4116491		0
65184	3856	372328	1975-05-26	1975-05-26 00:00:00	1975-07-09	1975-07-09 00:00:00	32020		\N	255936	0	65363002	372328		0
65349	3865	4048171	1960-07-04	1960-07-04 00:00:00	\N	\N	32020		\N	256576	0	232353008	4048171		0
65546	3876	4112343	2012-09-10	2012-09-10 00:00:00	2012-09-22	2012-09-22 00:00:00	32020		\N	257468	0	195662009	4112343		0
76274	4526	260139	1968-04-03	1968-04-03 00:00:00	1968-04-17	1968-04-17 00:00:00	32020		\N	301352	0	10509002	260139		0
81886	4855	4266809	2014-07-23	2014-07-23 00:00:00	\N	\N	32020		\N	323050	0	397881000	4266809		0
76435	4532	260139	1983-02-02	1983-02-02 00:00:00	1983-02-16	1983-02-16 00:00:00	32020		\N	301847	0	10509002	260139		0
66053	3906	4112343	1993-12-13	1993-12-13 00:00:00	1993-12-22	1993-12-22 00:00:00	32020		\N	259732	0	195662009	4112343		0
76706	4547	40481087	2001-07-14	2001-07-14 00:00:00	2001-07-28	2001-07-28 00:00:00	32020		\N	302904	0	444814009	40481087		0
76873	4557	4237458	2001-11-15	2001-11-15 00:00:00	2002-02-13	2002-02-13 00:00:00	32020		\N	303644	0	58150001	4237458		0
66503	3936	4294548	1963-01-18	1963-01-18 00:00:00	1963-02-22	1963-02-22 00:00:00	32020		\N	261639	0	75498004	4294548		0
77291	4578	40481087	1993-02-27	1993-02-27 00:00:00	1993-03-13	1993-03-13 00:00:00	32020		\N	304947	0	444814009	40481087		0
77411	4587	372328	1936-02-07	1936-02-07 00:00:00	1936-03-21	1936-03-21 00:00:00	32020		\N	305611	0	65363002	372328		0
77539	4593	4294548	2018-04-23	2018-04-23 00:00:00	2018-05-28	2018-05-28 00:00:00	32020		\N	306037	0	75498004	4294548		0
77691	4603	4218389	1969-10-24	1969-10-24 00:00:00	1969-11-21	1969-11-21 00:00:00	32020		\N	306620	0	39848009	4218389		0
88496	5259	40481087	1972-08-01	1972-08-01 00:00:00	1972-08-22	1972-08-22 00:00:00	32020		\N	349935	0	444814009	40481087		0
78031	4623	81151	1938-03-28	1938-03-28 00:00:00	1938-05-02	1938-05-02 00:00:00	32020		\N	308003	0	44465007	81151		0
67693	3998	260139	1990-02-05	1990-02-05 00:00:00	1990-02-12	1990-02-12 00:00:00	32020		\N	265805	0	10509002	260139		0
67865	4010	4112343	1981-05-01	1981-05-01 00:00:00	1981-05-08	1981-05-08 00:00:00	32020		\N	266513	0	195662009	4112343		0
78532	4649	40481087	1995-06-17	1995-06-17 00:00:00	1995-06-24	1995-06-24 00:00:00	32020		\N	309994	0	444814009	40481087		0
68190	4027	372328	1975-05-30	1975-05-30 00:00:00	1975-10-11	1975-10-11 00:00:00	32020		\N	267828	0	65363002	372328		0
78947	4675	40481087	1928-01-03	1928-01-03 00:00:00	1928-01-24	1928-01-24 00:00:00	32020		\N	311567	0	444814009	40481087		0
79021	4678	4112343	2015-06-06	2015-06-06 00:00:00	2015-06-19	2015-06-19 00:00:00	32020		\N	311741	0	195662009	4112343		0
79233	4690	4116491	2012-07-16	2012-07-16 00:00:00	2012-09-09	2012-09-09 00:00:00	32020		\N	312495	0	301011002	4116491		0
79429	4704	195588	1999-12-10	1999-12-10 00:00:00	2000-01-18	2000-01-18 00:00:00	32020		\N	313420	0	38822007	195588		0
68974	4081	40481087	1965-09-06	1965-09-06 00:00:00	1965-09-20	1965-09-20 00:00:00	32020		\N	271234	0	444814009	40481087		0
69196	4094	4112343	1981-01-05	1981-01-05 00:00:00	1981-01-16	1981-01-16 00:00:00	32020		\N	272124	0	195662009	4112343		0
79974	4739	4294548	1980-08-14	1980-08-14 00:00:00	1980-12-11	1980-12-11 00:00:00	32020		\N	315687	0	75498004	4294548		0
69429	4109	4112343	1981-06-07	1981-06-07 00:00:00	1981-06-16	1981-06-16 00:00:00	32020		\N	273127	0	195662009	4112343		0
69634	4121	261325	1966-05-08	1966-05-08 00:00:00	\N	\N	32020		\N	273937	0	87433001	261325		0
80395	4761	4280726	1984-05-11	1984-05-11 00:00:00	\N	\N	32020		\N	317222	0	367498001	4280726		0
70180	4156	317576	2004-11-15	2004-11-15 00:00:00	\N	\N	32020		\N	276209	0	53741008	317576		0
80911	4799	40481087	2011-03-22	2011-03-22 00:00:00	2011-04-12	2011-04-12 00:00:00	32020		\N	319263	0	444814009	40481087		0
81170	4814	40481087	1939-08-01	1939-08-01 00:00:00	1939-08-15	1939-08-15 00:00:00	32020		\N	320251	0	444814009	40481087		0
81292	4820	192671	1995-10-24	1995-10-24 00:00:00	\N	\N	32020		\N	320665	0	K92.2	35208414		0
81355	4826	81151	1960-04-22	1960-04-22 00:00:00	1960-05-06	1960-05-06 00:00:00	32020		\N	320984	0	44465007	81151		0
71016	4212	4112343	2019-05-23	2019-05-23 00:00:00	2019-05-30	2019-05-30 00:00:00	32020		\N	279685	0	195662009	4112343		0
71132	4220	260139	1962-01-16	1962-01-16 00:00:00	1962-01-23	1962-01-23 00:00:00	32020		\N	280185	0	10509002	260139		0
81846	4853	260139	2000-07-20	2000-07-20 00:00:00	2000-08-03	2000-08-03 00:00:00	32020		\N	322927	0	10509002	260139		0
71485	4240	40481087	1963-10-23	1963-10-23 00:00:00	1963-11-13	1963-11-13 00:00:00	32020		\N	281672	0	444814009	40481087		0
82209	4874	4155034	1992-12-25	1992-12-25 00:00:00	1993-01-08	1993-01-08 00:00:00	32020		\N	324212	0	283371005	4155034		0
71839	4261	4112343	1937-11-13	1937-11-13 00:00:00	1937-11-23	1937-11-23 00:00:00	32020		\N	282937	0	195662009	4112343		0
72016	4274	40481087	1952-05-31	1952-05-31 00:00:00	1952-06-14	1952-06-14 00:00:00	32020		\N	283634	0	444814009	40481087		0
72122	4279	4280726	1954-04-13	1954-04-13 00:00:00	1993-07-16	1993-07-16 00:00:00	32020		\N	283944	0	367498001	4280726		0
72289	4289	4237458	1944-06-08	1944-06-08 00:00:00	1944-08-07	1944-08-07 00:00:00	32020		\N	284738	0	58150001	4237458		0
83081	4935	4112343	1968-08-18	1968-08-18 00:00:00	1968-08-25	1968-08-25 00:00:00	32020		\N	328033	0	195662009	4112343		0
83207	4943	40479768	1979-11-15	1979-11-15 00:00:00	1979-12-22	1979-12-22 00:00:00	32020		\N	328622	0	444470001	40479768		0
72856	4330	40481087	2015-09-30	2015-09-30 00:00:00	2015-10-21	2015-10-21 00:00:00	32020		\N	287198	0	444814009	40481087		0
83657	4971	260139	1979-01-09	1979-01-09 00:00:00	1979-01-16	1979-01-16 00:00:00	32020		\N	330651	0	10509002	260139		0
83719	4975	4112343	1976-10-17	1976-10-17 00:00:00	1976-10-25	1976-10-25 00:00:00	32020		\N	330846	0	195662009	4112343		0
73356	4359	372328	1943-09-08	1943-09-08 00:00:00	1943-10-20	1943-10-20 00:00:00	32020		\N	289227	0	65363002	372328		0
84109	4998	40481087	1975-04-12	1975-04-12 00:00:00	1975-04-19	1975-04-19 00:00:00	32020		\N	332370	0	444814009	40481087		0
73612	4375	257012	1943-06-29	1943-06-29 00:00:00	\N	\N	32020		\N	290653	0	40055000	257012		0
84385	5015	40481087	2014-03-14	2014-03-14 00:00:00	2014-04-04	2014-04-04 00:00:00	32020		\N	333348	0	444814009	40481087		0
84619	5031	4296204	1946-02-20	1946-02-20 00:00:00	1946-03-20	1946-03-20 00:00:00	32020		\N	334345	0	403190006	4296204		0
84698	5035	40481087	1937-09-23	1937-09-23 00:00:00	1937-09-30	1937-09-30 00:00:00	32020		\N	334542	0	444814009	40481087		0
84912	5049	440086	1971-01-29	1971-01-29 00:00:00	1972-12-22	1972-12-22 00:00:00	32020		\N	335627	0	192127007	440086		0
74496	4423	321042	1989-04-21	1989-04-21 00:00:00	\N	\N	32020		\N	294121	0	410429000	321042		0
74671	4435	260139	1982-03-15	1982-03-15 00:00:00	1982-03-29	1982-03-29 00:00:00	32020		\N	294781	0	10509002	260139		0
64242	3793	378001	1947-12-21	1947-12-21 00:00:00	1948-01-20	1948-01-20 00:00:00	32020		\N	252275	0	62106007	378001		0
64401	3804	260139	1991-06-19	1991-06-19 00:00:00	1991-07-03	1991-07-03 00:00:00	32020		\N	252882	0	10509002	260139		0
64518	3813	260139	1995-08-06	1995-08-06 00:00:00	1995-08-13	1995-08-13 00:00:00	32020		\N	253281	0	10509002	260139		0
75263	4470	260139	2003-02-15	2003-02-15 00:00:00	2003-03-01	2003-03-01 00:00:00	32020		\N	297381	0	10509002	260139		0
64794	3832	4218389	2012-06-16	2012-06-16 00:00:00	2012-07-21	2012-07-21 00:00:00	32020		\N	254430	0	39848009	4218389		0
65067	3849	260139	1983-12-07	1983-12-07 00:00:00	1983-12-21	1983-12-21 00:00:00	32020		\N	255429	0	10509002	260139		0
65185	3856	4112343	1983-06-12	1983-06-12 00:00:00	1983-06-24	1983-06-24 00:00:00	32020		\N	255890	0	195662009	4112343		0
65350	3865	4283893	1970-12-29	1970-12-29 00:00:00	1971-03-09	1971-03-09 00:00:00	32020		\N	256561	0	36971009	4283893		0
65547	3876	4048171	1971-05-28	1971-05-28 00:00:00	\N	\N	32020		\N	257491	0	232353008	4048171		0
76275	4526	28060	2006-06-26	2006-06-26 00:00:00	2006-07-09	2006-07-09 00:00:00	32020		\N	301333	0	43878008	28060		0
76436	4532	4155034	1956-10-21	1956-10-21 00:00:00	1956-11-11	1956-11-11 00:00:00	32020		\N	301891	0	283371005	4155034		0
66054	3906	4112343	1944-01-16	1944-01-16 00:00:00	1944-01-23	1944-01-23 00:00:00	32020		\N	259669	0	195662009	4112343		0
76707	4547	40481087	1978-07-16	1978-07-16 00:00:00	1978-07-23	1978-07-23 00:00:00	32020		\N	302969	0	444814009	40481087		0
76874	4557	40480160	2001-11-15	2001-11-15 00:00:00	2002-02-13	2002-02-13 00:00:00	32020		\N	303644	0	443165006	40480160		0
66504	3936	4112343	1977-08-18	1977-08-18 00:00:00	1977-08-30	1977-08-30 00:00:00	32020		\N	261617	0	195662009	4112343		0
77292	4578	4112343	1979-08-15	1979-08-15 00:00:00	1979-08-23	1979-08-23 00:00:00	32020		\N	304945	0	195662009	4112343		0
77412	4587	317576	2003-07-12	2003-07-12 00:00:00	\N	\N	32020		\N	305555	0	53741008	317576		0
77540	4593	4218389	1978-09-21	1978-09-21 00:00:00	1978-10-12	1978-10-12 00:00:00	32020		\N	306050	0	39848009	4218389		0
88512	5262	260139	2012-08-23	2012-08-23 00:00:00	2012-09-06	2012-09-06 00:00:00	32020		\N	350123	0	10509002	260139		0
78032	4623	40481087	1975-12-07	1975-12-07 00:00:00	1975-12-28	1975-12-28 00:00:00	32020		\N	307967	0	444814009	40481087		0
67694	3998	28060	2005-05-13	2005-05-13 00:00:00	2005-05-26	2005-05-26 00:00:00	32020		\N	265776	0	43878008	28060		0
67866	4010	40481087	2009-10-10	2009-10-10 00:00:00	2009-10-24	2009-10-24 00:00:00	32020		\N	266517	0	444814009	40481087		0
78533	4649	372328	1971-06-14	1971-06-14 00:00:00	1971-07-19	1971-07-19 00:00:00	32020		\N	310014	0	65363002	372328		0
68191	4027	40481087	2017-05-15	2017-05-15 00:00:00	2017-05-29	2017-05-29 00:00:00	32020		\N	267803	0	444814009	40481087		0
78948	4675	40480160	2006-11-11	2006-11-11 00:00:00	2006-12-11	2006-12-11 00:00:00	32020		\N	311448	0	443165006	40480160		0
79022	4678	40481087	1975-06-15	1975-06-15 00:00:00	1975-07-06	1975-07-06 00:00:00	32020		\N	311731	0	444814009	40481087		0
79234	4690	195588	2010-05-27	2010-05-27 00:00:00	2010-07-17	2010-07-17 00:00:00	32020		\N	312518	0	38822007	195588		0
79430	4704	260139	1982-01-03	1982-01-03 00:00:00	1982-01-10	1982-01-10 00:00:00	32020		\N	313412	0	10509002	260139		0
68985	4084	4112343	1966-11-25	1966-11-25 00:00:00	1966-12-05	1966-12-05 00:00:00	32020		\N	271374	0	195662009	4112343		0
69197	4094	372328	1963-03-15	1963-03-15 00:00:00	1963-07-04	1963-07-04 00:00:00	32020		\N	272133	0	65363002	372328		0
79975	4739	4152936	1950-10-03	1950-10-03 00:00:00	1950-10-24	1950-10-24 00:00:00	32020		\N	315728	0	283385000	4152936		0
69430	4109	40481087	2009-03-14	2009-03-14 00:00:00	2009-03-28	2009-03-28 00:00:00	32020		\N	273152	0	444814009	40481087		0
69635	4121	4112343	1978-03-31	1978-03-31 00:00:00	1978-04-07	1978-04-07 00:00:00	32020		\N	273981	0	195662009	4112343		0
80396	4761	40481087	1988-04-02	1988-04-02 00:00:00	1988-04-23	1988-04-23 00:00:00	32020		\N	317260	0	444814009	40481087		0
70181	4156	4329847	2006-02-27	2006-02-27 00:00:00	\N	\N	32020		\N	276159	0	22298006	4329847		0
80912	4800	439777	1970-10-29	1970-10-29 00:00:00	\N	\N	32020		\N	319321	0	271737000	439777		0
81171	4814	40481087	1995-07-20	1995-07-20 00:00:00	1995-08-10	1995-08-10 00:00:00	32020		\N	320218	0	444814009	40481087		0
81296	4822	4116491	1989-09-13	1989-09-13 00:00:00	1989-11-04	1989-11-04 00:00:00	32020		\N	320746	0	301011002	4116491		0
81356	4826	28060	1990-04-20	1990-04-20 00:00:00	1990-04-27	1990-04-27 00:00:00	32020		\N	321016	0	43878008	28060		0
71017	4212	260139	1995-01-28	1995-01-28 00:00:00	1995-02-11	1995-02-11 00:00:00	32020		\N	279653	0	10509002	260139		0
71133	4220	4112343	2008-11-28	2008-11-28 00:00:00	2008-12-07	2008-12-07 00:00:00	32020		\N	280202	0	195662009	4112343		0
81847	4853	40481087	1974-04-11	1974-04-11 00:00:00	1974-04-25	1974-04-25 00:00:00	32020		\N	322884	0	444814009	40481087		0
71486	4240	4294548	1967-04-03	1967-04-03 00:00:00	1967-06-26	1967-06-26 00:00:00	32020		\N	281666	0	75498004	4294548		0
82210	4874	260139	1972-06-14	1972-06-14 00:00:00	1972-06-21	1972-06-21 00:00:00	32020		\N	324158	0	10509002	260139		0
71840	4261	4112343	2008-05-13	2008-05-13 00:00:00	2008-05-21	2008-05-21 00:00:00	32020		\N	282943	0	195662009	4112343		0
72017	4274	4112343	1993-03-24	1993-03-24 00:00:00	1993-04-06	1993-04-06 00:00:00	32020		\N	283621	0	195662009	4112343		0
72123	4279	40481087	1979-05-22	1979-05-22 00:00:00	1979-05-29	1979-05-29 00:00:00	32020		\N	283950	0	444814009	40481087		0
72290	4289	4109685	1967-01-28	1967-01-28 00:00:00	1967-02-18	1967-02-18 00:00:00	32020		\N	284742	0	284551006	4109685		0
83082	4935	4285898	2002-12-04	2002-12-04 00:00:00	\N	\N	32020		\N	328150	0	68496003	4285898		0
83208	4943	260139	2014-09-30	2014-09-30 00:00:00	2014-10-14	2014-10-14 00:00:00	32020		\N	328582	0	10509002	260139		0
72857	4330	40481087	1967-03-26	1967-03-26 00:00:00	1967-04-09	1967-04-09 00:00:00	32020		\N	287264	0	444814009	40481087		0
83658	4971	4109685	1936-06-25	1936-06-25 00:00:00	1936-07-09	1936-07-09 00:00:00	32020		\N	330543	0	284551006	4109685		0
83720	4975	4218389	1999-11-25	1999-11-25 00:00:00	1999-12-23	1999-12-23 00:00:00	32020		\N	330919	0	39848009	4218389		0
73357	4359	260139	1999-06-11	1999-06-11 00:00:00	1999-06-18	1999-06-18 00:00:00	32020		\N	289224	0	10509002	260139		0
84110	4998	4112343	1983-01-20	1983-01-20 00:00:00	1983-01-30	1983-01-30 00:00:00	32020		\N	332329	0	195662009	4112343		0
73613	4375	4116491	1980-06-26	1980-06-26 00:00:00	1980-07-28	1980-07-28 00:00:00	32020		\N	290679	0	301011002	4116491		0
84386	5015	4113008	1991-04-26	1991-04-26 00:00:00	1991-05-17	1991-05-17 00:00:00	32020		\N	333376	0	284549007	4113008		0
84620	5031	260139	2002-02-06	2002-02-06 00:00:00	2002-02-13	2002-02-13 00:00:00	32020		\N	334289	0	10509002	260139		0
84699	5035	4278672	1997-08-14	1997-08-14 00:00:00	1997-10-13	1997-10-13 00:00:00	32020		\N	334576	0	65966004	4278672		0
84913	5049	4218389	1993-08-16	1993-08-16 00:00:00	1993-09-06	1993-09-06 00:00:00	32020		\N	335585	0	39848009	4218389		0
74498	4423	372328	1984-03-21	1984-03-21 00:00:00	1984-08-24	1984-08-24 00:00:00	32020		\N	294089	0	65363002	372328		0
74672	4435	40481087	2018-11-15	2018-11-15 00:00:00	2018-12-06	2018-12-06 00:00:00	32020		\N	294760	0	444814009	40481087		0
74701	4436	4113008	1968-05-12	1968-05-12 00:00:00	1968-05-26	1968-05-26 00:00:00	32020		\N	294878	0	284549007	4113008		0
64402	3804	192671	2003-07-05	2003-07-05 00:00:00	\N	\N	32020		\N	252863	0	K92.2	35208414		0
64519	3813	4112343	1973-08-30	1973-08-30 00:00:00	1973-09-12	1973-09-12 00:00:00	32020		\N	253258	0	195662009	4112343		0
75264	4470	260139	1996-11-30	1996-11-30 00:00:00	1996-12-07	1996-12-07 00:00:00	32020		\N	297391	0	10509002	260139		0
64795	3832	40481087	2016-03-19	2016-03-19 00:00:00	2016-03-26	2016-03-26 00:00:00	32020		\N	254440	0	444814009	40481087		0
65068	3849	372328	1969-01-23	1969-01-23 00:00:00	1969-04-24	1969-04-24 00:00:00	32020		\N	255430	0	65363002	372328		0
65186	3856	372328	1976-01-04	1976-01-04 00:00:00	1976-07-07	1976-07-07 00:00:00	32020		\N	255897	0	65363002	372328		0
65351	3865	40481087	1968-11-12	1968-11-12 00:00:00	1968-12-03	1968-12-03 00:00:00	32020		\N	256578	0	444814009	40481087		0
65548	3876	81151	1977-07-28	1977-07-28 00:00:00	1977-08-25	1977-08-25 00:00:00	32020		\N	257430	0	44465007	81151		0
76276	4526	4294548	1999-05-02	1999-05-02 00:00:00	1999-08-22	1999-08-22 00:00:00	32020		\N	301331	0	75498004	4294548		0
76437	4532	440448	1946-04-10	1946-04-10 00:00:00	\N	\N	32020		\N	301939	0	74400008	440448		0
66055	3906	260139	1990-06-23	1990-06-23 00:00:00	1990-07-07	1990-07-07 00:00:00	32020		\N	259731	0	10509002	260139		0
76708	4547	4278672	1997-09-07	1997-09-07 00:00:00	1997-12-06	1997-12-06 00:00:00	32020		\N	302962	0	65966004	4278672		0
76875	4557	81151	1951-12-21	1951-12-21 00:00:00	1952-01-25	1952-01-25 00:00:00	32020		\N	303639	0	44465007	81151		0
66505	3936	80180	1997-12-15	1997-12-15 00:00:00	\N	\N	32020		\N	261604	0	396275006	80180		0
77293	4578	4266809	2000-04-05	2000-04-05 00:00:00	\N	\N	32020		\N	304963	0	397881000	4266809		0
77413	4587	378419	2015-01-31	2015-01-31 00:00:00	\N	\N	32020		\N	305564	0	26929004	378419		0
77561	4595	40481087	2003-10-26	2003-10-26 00:00:00	2003-11-08	2003-11-08 00:00:00	32020		\N	306171	0	444814009	40481087		0
77693	4603	40481087	2018-08-30	2018-08-30 00:00:00	2018-09-13	2018-09-13 00:00:00	32020		\N	306660	0	444814009	40481087		0
88513	5262	28060	2008-07-05	2008-07-05 00:00:00	2008-07-17	2008-07-17 00:00:00	32020		\N	350079	0	43878008	28060		0
78033	4623	28060	1968-02-05	1968-02-05 00:00:00	1968-02-16	1968-02-16 00:00:00	32020		\N	307897	0	43878008	28060		0
67695	3998	40481087	1999-12-19	1999-12-19 00:00:00	2000-01-09	2000-01-09 00:00:00	32020		\N	265860	0	444814009	40481087		0
67867	4010	260139	1985-01-24	1985-01-24 00:00:00	1985-02-07	1985-02-07 00:00:00	32020		\N	266462	0	10509002	260139		0
78534	4649	40481087	1997-11-09	1997-11-09 00:00:00	1997-11-30	1997-11-30 00:00:00	32020		\N	309976	0	444814009	40481087		0
68192	4027	4112343	2014-05-25	2014-05-25 00:00:00	2014-06-04	2014-06-04 00:00:00	32020		\N	267802	0	195662009	4112343		0
78949	4675	4278672	2006-11-11	2006-11-11 00:00:00	2006-12-11	2006-12-11 00:00:00	32020		\N	311448	0	65966004	4278672		0
79023	4678	40481087	1971-12-14	1971-12-14 00:00:00	1971-12-28	1971-12-28 00:00:00	32020		\N	311730	0	444814009	40481087		0
79235	4690	4155034	2007-05-05	2007-05-05 00:00:00	2007-05-26	2007-05-26 00:00:00	32020		\N	312471	0	283371005	4155034		0
79431	4704	4112343	1970-11-09	1970-11-09 00:00:00	1970-11-17	1970-11-17 00:00:00	32020		\N	313394	0	195662009	4112343		0
68986	4084	4134304	1976-08-01	1976-08-01 00:00:00	1976-08-31	1976-08-31 00:00:00	32020		\N	271435	0	263102004	4134304		0
69198	4094	4156265	2017-10-25	2017-10-25 00:00:00	2017-11-08	2017-11-08 00:00:00	32020		\N	272152	0	370247008	4156265		0
79976	4739	372328	1911-09-02	1911-09-02 00:00:00	1911-11-04	1911-11-04 00:00:00	32020		\N	315766	0	65363002	372328		0
69431	4109	81893	2000-10-18	2000-10-18 00:00:00	\N	\N	32020		\N	273191	0	64766004	81893		0
69636	4121	80180	1964-10-19	1964-10-19 00:00:00	\N	\N	32020		\N	274004	0	396275006	80180		0
80397	4761	4218389	2008-03-23	2008-03-23 00:00:00	2008-04-13	2008-04-13 00:00:00	32020		\N	317240	0	39848009	4218389		0
70183	4156	4112343	1998-11-09	1998-11-09 00:00:00	1998-11-18	1998-11-18 00:00:00	32020		\N	276180	0	195662009	4112343		0
80913	4800	28060	1975-03-22	1975-03-22 00:00:00	1975-03-29	1975-03-29 00:00:00	32020		\N	319328	0	43878008	28060		0
81172	4814	40481087	1952-03-10	1952-03-10 00:00:00	1952-03-31	1952-03-31 00:00:00	32020		\N	320303	0	444814009	40481087		0
81297	4822	40481087	2014-05-12	2014-05-12 00:00:00	2014-05-26	2014-05-26 00:00:00	32020		\N	320715	0	444814009	40481087		0
81357	4826	4278672	1969-01-19	1969-01-19 00:00:00	1969-03-20	1969-03-20 00:00:00	32020		\N	320986	0	65966004	4278672		0
71018	4212	28060	1977-01-23	1977-01-23 00:00:00	1977-02-01	1977-02-01 00:00:00	32020		\N	279680	0	43878008	28060		0
71134	4220	4283893	1949-04-16	1949-04-16 00:00:00	1949-05-14	1949-05-14 00:00:00	32020		\N	280194	0	36971009	4283893		0
81848	4853	40481087	1999-09-11	1999-09-11 00:00:00	1999-10-02	1999-10-02 00:00:00	32020		\N	322873	0	444814009	40481087		0
71487	4240	378419	2018-12-24	2018-12-24 00:00:00	\N	\N	32020		\N	281589	0	26929004	378419		0
82211	4874	40481087	2010-09-20	2010-09-20 00:00:00	2010-10-11	2010-10-11 00:00:00	32020		\N	324164	0	444814009	40481087		0
71841	4261	4294548	1944-07-16	1944-07-16 00:00:00	1944-08-20	1944-08-20 00:00:00	32020		\N	282972	0	75498004	4294548		0
72018	4274	4156265	1997-11-12	1997-11-12 00:00:00	1997-11-26	1997-11-26 00:00:00	32020		\N	283561	0	370247008	4156265		0
72124	4279	40481087	1965-12-09	1965-12-09 00:00:00	1965-12-23	1965-12-23 00:00:00	32020		\N	284074	0	444814009	40481087		0
72291	4289	260139	1964-05-25	1964-05-25 00:00:00	1964-06-01	1964-06-01 00:00:00	32020		\N	284764	0	10509002	260139		0
83083	4935	80180	2003-08-01	2003-08-01 00:00:00	\N	\N	32020		\N	328150	0	396275006	80180		0
83209	4943	4112343	2005-06-09	2005-06-09 00:00:00	2005-06-19	2005-06-19 00:00:00	32020		\N	328571	0	195662009	4112343		0
72858	4330	4296205	1987-11-24	1987-11-24 00:00:00	1987-12-08	1987-12-08 00:00:00	32020		\N	287261	0	403191005	4296205		0
83659	4971	4112343	1941-02-01	1941-02-01 00:00:00	1941-02-14	1941-02-14 00:00:00	32020		\N	330526	0	195662009	4112343		0
83721	4975	260139	1977-08-04	1977-08-04 00:00:00	1977-08-18	1977-08-18 00:00:00	32020		\N	330880	0	10509002	260139		0
73358	4359	4218389	1987-04-02	1987-04-02 00:00:00	1987-04-30	1987-04-30 00:00:00	32020		\N	289213	0	39848009	4218389		0
84111	4998	40481087	1970-11-11	1970-11-11 00:00:00	1970-12-02	1970-12-02 00:00:00	32020		\N	332327	0	444814009	40481087		0
73614	4375	4294548	1968-05-14	1968-05-14 00:00:00	1968-07-23	1968-07-23 00:00:00	32020		\N	290638	0	75498004	4294548		0
84387	5015	40481087	1968-05-12	1968-05-12 00:00:00	1968-05-26	1968-05-26 00:00:00	32020		\N	333359	0	444814009	40481087		0
84622	5034	260139	1927-11-28	1927-11-28 00:00:00	1927-12-05	1927-12-05 00:00:00	32020		\N	334440	0	10509002	260139		0
84717	5037	28060	1985-06-22	1985-06-22 00:00:00	1985-07-03	1985-07-03 00:00:00	32020		\N	334737	0	43878008	28060		0
84914	5049	40481087	2005-06-18	2005-06-18 00:00:00	2005-06-25	2005-06-25 00:00:00	32020		\N	335580	0	444814009	40481087		0
74499	4423	40481087	1976-04-26	1976-04-26 00:00:00	1976-05-03	1976-05-03 00:00:00	32020		\N	294108	0	444814009	40481087		0
74673	4435	192671	2000-11-16	2000-11-16 00:00:00	\N	\N	32020		\N	294782	0	K92.2	35208414		0
74702	4437	257012	1985-05-07	1985-05-07 00:00:00	\N	\N	32020		\N	294932	0	40055000	257012		0
64403	3804	4237458	2000-01-28	2000-01-28 00:00:00	2000-02-27	2000-02-27 00:00:00	32020		\N	252860	0	58150001	4237458		0
64520	3813	40481087	2016-01-23	2016-01-23 00:00:00	2016-02-06	2016-02-06 00:00:00	32020		\N	253297	0	444814009	40481087		0
75265	4470	260139	2007-04-24	2007-04-24 00:00:00	2007-05-01	2007-05-01 00:00:00	32020		\N	297392	0	10509002	260139		0
64796	3832	80180	2016-06-27	2016-06-27 00:00:00	\N	\N	32020		\N	254440	0	396275006	80180		0
65069	3849	81151	1964-11-15	1964-11-15 00:00:00	1964-12-06	1964-12-06 00:00:00	32020		\N	255446	0	44465007	81151		0
65187	3856	260139	1991-06-21	1991-06-21 00:00:00	1991-07-05	1991-07-05 00:00:00	32020		\N	255896	0	10509002	260139		0
65352	3865	4278672	1978-10-01	1978-10-01 00:00:00	1978-11-30	1978-11-30 00:00:00	32020		\N	256556	0	65966004	4278672		0
65549	3876	40481087	1978-04-29	1978-04-29 00:00:00	1978-05-20	1978-05-20 00:00:00	32020		\N	257450	0	444814009	40481087		0
76277	4526	4112343	1991-10-16	1991-10-16 00:00:00	1991-10-28	1991-10-28 00:00:00	32020		\N	301323	0	195662009	4112343		0
76438	4532	4112343	1970-02-02	1970-02-02 00:00:00	1970-02-09	1970-02-09 00:00:00	32020		\N	301908	0	195662009	4112343		0
66056	3906	260139	1957-03-12	1957-03-12 00:00:00	1957-03-19	1957-03-19 00:00:00	32020		\N	259672	0	10509002	260139		0
76709	4547	40480160	1997-09-07	1997-09-07 00:00:00	1997-12-06	1997-12-06 00:00:00	32020		\N	302962	0	443165006	40480160		0
76876	4557	81893	1964-07-31	1964-07-31 00:00:00	\N	\N	32020		\N	303674	0	64766004	81893		0
66506	3936	4112343	2004-03-17	2004-03-17 00:00:00	2004-03-25	2004-03-25 00:00:00	32020		\N	261608	0	195662009	4112343		0
77294	4578	80180	2000-04-05	2000-04-05 00:00:00	\N	\N	32020		\N	304963	0	396275006	80180		0
77414	4587	4134304	1940-01-17	1940-01-17 00:00:00	1940-04-16	1940-04-16 00:00:00	32020		\N	305566	0	263102004	4134304		0
77562	4595	378001	1968-08-10	1968-08-10 00:00:00	1968-09-09	1968-09-09 00:00:00	32020		\N	306181	0	62106007	378001		0
77694	4603	4296204	1959-07-21	1959-07-21 00:00:00	1959-08-18	1959-08-18 00:00:00	32020		\N	306648	0	403190006	4296204		0
88514	5262	28060	2005-06-11	2005-06-11 00:00:00	2005-06-19	2005-06-19 00:00:00	32020		\N	350089	0	43878008	28060		0
78034	4623	40481087	1936-08-23	1936-08-23 00:00:00	1936-09-06	1936-09-06 00:00:00	32020		\N	307963	0	444814009	40481087		0
67696	3998	81151	1974-12-17	1974-12-17 00:00:00	1975-01-14	1975-01-14 00:00:00	32020		\N	265790	0	44465007	81151		0
67868	4010	28060	2015-10-21	2015-10-21 00:00:00	2015-10-31	2015-10-31 00:00:00	32020		\N	266455	0	43878008	28060		0
78535	4649	40481087	1992-04-17	1992-04-17 00:00:00	1992-04-24	1992-04-24 00:00:00	32020		\N	309999	0	444814009	40481087		0
68193	4027	260139	1994-04-30	1994-04-30 00:00:00	1994-05-07	1994-05-07 00:00:00	32020		\N	267853	0	10509002	260139		0
78950	4675	381316	1975-09-07	1975-09-07 00:00:00	\N	\N	32020		\N	311561	0	230690007	381316		0
79024	4678	40481087	1985-05-09	1985-05-09 00:00:00	1985-05-16	1985-05-16 00:00:00	32020		\N	311751	0	444814009	40481087		0
79236	4690	4112343	2015-04-09	2015-04-09 00:00:00	2015-04-16	2015-04-16 00:00:00	32020		\N	312539	0	195662009	4112343		0
79432	4704	372328	1968-02-06	1968-02-06 00:00:00	1968-05-25	1968-05-25 00:00:00	32020		\N	313414	0	65363002	372328		0
68987	4084	4109685	1978-06-22	1978-06-22 00:00:00	1978-07-13	1978-07-13 00:00:00	32020		\N	271436	0	284551006	4109685		0
69199	4094	40481087	1970-11-23	1970-11-23 00:00:00	1970-12-14	1970-12-14 00:00:00	32020		\N	272122	0	444814009	40481087		0
79977	4739	4152936	1934-10-01	1934-10-01 00:00:00	1934-10-22	1934-10-22 00:00:00	32020		\N	315726	0	283385000	4152936		0
69432	4109	80180	2002-02-10	2002-02-10 00:00:00	\N	\N	32020		\N	273191	0	396275006	80180		0
69637	4121	28060	1930-12-30	1930-12-30 00:00:00	1931-01-12	1931-01-12 00:00:00	32020		\N	273988	0	43878008	28060		0
80398	4761	4237458	1998-01-01	1998-01-01 00:00:00	1998-01-31	1998-01-31 00:00:00	32020		\N	317237	0	58150001	4237458		0
73638	4376	192671	1961-02-23	1961-02-23 00:00:00	\N	\N	32020		\N	290729	0	K92.2	35208414		0
70184	4156	28060	1958-10-29	1958-10-29 00:00:00	1958-11-07	1958-11-07 00:00:00	32020		\N	276136	0	43878008	28060		0
80914	4800	260139	1977-04-12	1977-04-12 00:00:00	1977-04-27	1977-04-27 00:00:00	32020		\N	319341	0	10509002	260139		0
81173	4814	372328	1960-05-04	1960-05-04 00:00:00	1961-06-19	1961-06-19 00:00:00	32020		\N	320254	0	65363002	372328		0
81298	4822	40481087	1958-07-26	1958-07-26 00:00:00	1958-08-16	1958-08-16 00:00:00	32020		\N	320742	0	444814009	40481087		0
81358	4826	40481087	1994-12-16	1994-12-16 00:00:00	1994-12-23	1994-12-23 00:00:00	32020		\N	321005	0	444814009	40481087		0
71019	4212	4134304	1984-01-14	1984-01-14 00:00:00	1984-03-14	1984-03-14 00:00:00	32020		\N	279652	0	263102004	4134304		0
71135	4220	260139	1986-03-09	1986-03-09 00:00:00	1986-03-23	1986-03-23 00:00:00	32020		\N	280198	0	10509002	260139		0
81849	4853	40481087	1995-08-22	1995-08-22 00:00:00	1995-09-12	1995-09-12 00:00:00	32020		\N	322872	0	444814009	40481087		0
71488	4240	4112343	1947-12-30	1947-12-30 00:00:00	1948-01-09	1948-01-09 00:00:00	32020		\N	281687	0	195662009	4112343		0
82212	4874	4112343	1995-11-30	1995-11-30 00:00:00	1995-12-10	1995-12-10 00:00:00	32020		\N	324162	0	195662009	4112343		0
71842	4261	4218389	1974-01-29	1974-01-29 00:00:00	1974-02-19	1974-02-19 00:00:00	32020		\N	282892	0	39848009	4218389		0
72019	4274	260139	1978-11-10	1978-11-10 00:00:00	1978-11-17	1978-11-17 00:00:00	32020		\N	283620	0	10509002	260139		0
72125	4279	260139	1980-12-23	1980-12-23 00:00:00	1980-12-30	1980-12-30 00:00:00	32020		\N	283951	0	10509002	260139		0
72292	4289	40481087	2001-11-23	2001-11-23 00:00:00	2001-12-14	2001-12-14 00:00:00	32020		\N	284766	0	444814009	40481087		0
83084	4935	4266809	2003-08-01	2003-08-01 00:00:00	\N	\N	32020		\N	328150	0	397881000	4266809		0
83210	4943	4112343	1991-09-22	1991-09-22 00:00:00	1991-10-04	1991-10-04 00:00:00	32020		\N	328540	0	195662009	4112343		0
72859	4330	4134304	2012-03-20	2012-03-20 00:00:00	2012-06-18	2012-06-18 00:00:00	32020		\N	287221	0	263102004	4134304		0
83660	4971	4112343	1986-04-07	1986-04-07 00:00:00	1986-04-18	1986-04-18 00:00:00	32020		\N	330653	0	195662009	4112343		0
83722	4975	40481087	1983-10-15	1983-10-15 00:00:00	1983-10-22	1983-10-22 00:00:00	32020		\N	330870	0	444814009	40481087		0
83831	4979	40481087	1990-08-17	1990-08-17 00:00:00	1990-09-07	1990-09-07 00:00:00	32020		\N	331271	0	444814009	40481087		0
84112	4998	260139	1992-05-02	1992-05-02 00:00:00	1992-05-16	1992-05-16 00:00:00	32020		\N	332382	0	10509002	260139		0
73615	4375	40481087	1969-09-22	1969-09-22 00:00:00	1969-10-13	1969-10-13 00:00:00	32020		\N	290623	0	444814009	40481087		0
84388	5015	4237458	1970-11-21	1970-11-21 00:00:00	1971-02-19	1971-02-19 00:00:00	32020		\N	333373	0	58150001	4237458		0
84623	5034	40481087	1936-06-28	1936-06-28 00:00:00	1936-07-05	1936-07-05 00:00:00	32020		\N	334437	0	444814009	40481087		0
84718	5037	40481087	2014-04-05	2014-04-05 00:00:00	2014-04-12	2014-04-12 00:00:00	32020		\N	334738	0	444814009	40481087		0
84915	5049	80180	1998-12-08	1998-12-08 00:00:00	\N	\N	32020		\N	335562	0	396275006	80180		0
74500	4423	80180	2011-03-01	2011-03-01 00:00:00	\N	\N	32020		\N	294118	0	396275006	80180		0
74674	4435	317576	2002-04-15	2002-04-15 00:00:00	\N	\N	32020		\N	294776	0	53741008	317576		0
74703	4437	40481087	1971-09-01	1971-09-01 00:00:00	1971-09-15	1971-09-15 00:00:00	32020		\N	294940	0	444814009	40481087		0
64404	3804	40481087	1968-05-24	1968-05-24 00:00:00	1968-06-14	1968-06-14 00:00:00	32020		\N	252830	0	444814009	40481087		0
64521	3813	80180	2006-07-12	2006-07-12 00:00:00	\N	\N	32020		\N	253277	0	396275006	80180		0
75266	4470	40481087	1988-07-11	1988-07-11 00:00:00	1988-07-18	1988-07-18 00:00:00	32020		\N	297390	0	444814009	40481087		0
64797	3832	4084167	2010-12-21	2010-12-21 00:00:00	2010-12-21	2010-12-21 00:00:00	32020		\N	254429	0	241929008	4084167		0
65070	3849	439777	2015-11-08	2015-11-08 00:00:00	\N	\N	32020		\N	255395	0	271737000	439777		0
65188	3856	28060	1983-01-04	1983-01-04 00:00:00	1983-01-11	1983-01-11 00:00:00	32020		\N	255920	0	43878008	28060		0
65353	3865	40481087	2009-12-21	2009-12-21 00:00:00	2009-12-28	2009-12-28 00:00:00	32020		\N	256618	0	444814009	40481087		0
65550	3876	4112343	1982-04-28	1982-04-28 00:00:00	1982-05-11	1982-05-11 00:00:00	32020		\N	257502	0	195662009	4112343		0
76278	4526	4299128	2012-05-02	2012-05-02 00:00:00	2012-06-06	2012-06-06 00:00:00	32020		\N	301375	0	403192003	4299128		0
76440	4532	4112343	1912-07-15	1912-07-15 00:00:00	1912-07-25	1912-07-25 00:00:00	32020		\N	301829	0	195662009	4112343		0
66057	3906	260139	1978-06-20	1978-06-20 00:00:00	1978-07-04	1978-07-04 00:00:00	32020		\N	259743	0	10509002	260139		0
76710	4547	40481087	1966-06-30	1966-06-30 00:00:00	1966-07-14	1966-07-14 00:00:00	32020		\N	302967	0	444814009	40481087		0
76877	4557	260139	1998-06-22	1998-06-22 00:00:00	1998-06-29	1998-06-29 00:00:00	32020		\N	303624	0	10509002	260139		0
66507	3936	4112343	1990-12-12	1990-12-12 00:00:00	1990-12-24	1990-12-24 00:00:00	32020		\N	261643	0	195662009	4112343		0
77295	4578	40481087	1999-12-16	1999-12-16 00:00:00	1999-12-30	1999-12-30 00:00:00	32020		\N	304963	0	444814009	40481087		0
77415	4587	40481087	2018-05-31	2018-05-31 00:00:00	2018-06-14	2018-06-14 00:00:00	32020		\N	305630	0	444814009	40481087		0
77563	4595	80180	2001-11-14	2001-11-14 00:00:00	\N	\N	32020		\N	306215	0	396275006	80180		0
77695	4603	40481087	1990-08-18	1990-08-18 00:00:00	1990-08-25	1990-08-25 00:00:00	32020		\N	306663	0	444814009	40481087		0
88515	5262	260139	1983-12-27	1983-12-27 00:00:00	1984-01-10	1984-01-10 00:00:00	32020		\N	350101	0	10509002	260139		0
78035	4623	40481087	2005-11-09	2005-11-09 00:00:00	2005-11-16	2005-11-16 00:00:00	32020		\N	307978	0	444814009	40481087		0
67697	3998	40481087	1971-01-11	1971-01-11 00:00:00	1971-02-01	1971-02-01 00:00:00	32020		\N	265794	0	444814009	40481087		0
67869	4010	80180	2012-12-17	2012-12-17 00:00:00	\N	\N	32020		\N	266522	0	396275006	80180		0
78536	4649	4112343	1990-08-23	1990-08-23 00:00:00	1990-09-01	1990-09-01 00:00:00	32020		\N	310032	0	195662009	4112343		0
68194	4027	40481087	2005-04-08	2005-04-08 00:00:00	2005-04-15	2005-04-15 00:00:00	32020		\N	267874	0	444814009	40481087		0
78951	4675	40481087	1926-11-10	1926-11-10 00:00:00	1926-12-01	1926-12-01 00:00:00	32020		\N	311544	0	444814009	40481087		0
79025	4678	40481087	1972-03-06	1972-03-06 00:00:00	1972-03-27	1972-03-27 00:00:00	32020		\N	311738	0	444814009	40481087		0
79237	4690	40481087	1964-11-07	1964-11-07 00:00:00	1964-11-28	1964-11-28 00:00:00	32020		\N	312452	0	444814009	40481087		0
79433	4704	372328	1970-04-15	1970-04-15 00:00:00	1970-11-28	1970-11-28 00:00:00	32020		\N	313364	0	65363002	372328		0
68988	4084	40481087	2018-11-30	2018-11-30 00:00:00	2018-12-07	2018-12-07 00:00:00	32020		\N	271387	0	444814009	40481087		0
69200	4094	4237458	1959-09-02	1959-09-02 00:00:00	1959-11-01	1959-11-01 00:00:00	32020		\N	272189	0	58150001	4237458		0
79978	4739	4112343	1960-12-06	1960-12-06 00:00:00	1960-12-15	1960-12-15 00:00:00	32020		\N	315685	0	195662009	4112343		0
69433	4109	4285898	2001-11-12	2001-11-12 00:00:00	\N	\N	32020		\N	273191	0	68496003	4285898		0
69638	4121	81151	1979-10-30	1979-10-30 00:00:00	1979-12-04	1979-12-04 00:00:00	32020		\N	273964	0	44465007	81151		0
80399	4761	260139	1986-08-03	1986-08-03 00:00:00	1986-08-17	1986-08-17 00:00:00	32020		\N	317258	0	10509002	260139		0
70185	4156	40481087	1997-09-12	1997-09-12 00:00:00	1997-09-19	1997-09-19 00:00:00	32020		\N	276162	0	444814009	40481087		0
80915	4800	40481087	1995-09-13	1995-09-13 00:00:00	1995-10-04	1995-10-04 00:00:00	32020		\N	319343	0	444814009	40481087		0
81174	4814	81151	1946-11-13	1946-11-13 00:00:00	1946-12-04	1946-12-04 00:00:00	32020		\N	320245	0	44465007	81151		0
81299	4822	260139	1947-10-26	1947-10-26 00:00:00	1947-11-02	1947-11-02 00:00:00	32020		\N	320739	0	10509002	260139		0
81359	4826	40481087	2009-05-21	2009-05-21 00:00:00	2009-06-11	2009-06-11 00:00:00	32020		\N	321033	0	444814009	40481087		0
71020	4212	260139	2014-12-18	2014-12-18 00:00:00	2015-01-01	2015-01-01 00:00:00	32020		\N	279666	0	10509002	260139		0
71136	4220	40481087	1972-08-27	1972-08-27 00:00:00	1972-09-17	1972-09-17 00:00:00	32020		\N	280196	0	444814009	40481087		0
81850	4853	372328	1968-03-25	1968-03-25 00:00:00	1968-04-24	1968-04-24 00:00:00	32020		\N	322903	0	65363002	372328		0
71489	4240	4134304	2010-10-04	2010-10-04 00:00:00	2010-12-03	2010-12-03 00:00:00	32020		\N	281594	0	263102004	4134304		0
82213	4874	40481087	1995-09-22	1995-09-22 00:00:00	1995-10-13	1995-10-13 00:00:00	32020		\N	324194	0	444814009	40481087		0
71843	4261	260139	1983-03-14	1983-03-14 00:00:00	1983-03-21	1983-03-21 00:00:00	32020		\N	282890	0	10509002	260139		0
72020	4274	4059173	1943-01-30	1943-01-30 00:00:00	1943-03-01	1943-03-01 00:00:00	32020		\N	283559	0	16114001	4059173		0
72126	4279	28060	1975-10-09	1975-10-09 00:00:00	1975-10-16	1975-10-16 00:00:00	32020		\N	283948	0	43878008	28060		0
72293	4289	4152936	1994-06-26	1994-06-26 00:00:00	1994-07-10	1994-07-10 00:00:00	32020		\N	284743	0	283385000	4152936		0
83085	4935	81893	2002-05-08	2002-05-08 00:00:00	\N	\N	32020		\N	328150	0	64766004	81893		0
83212	4943	4029498	1962-02-01	1962-02-01 00:00:00	\N	\N	32020		\N	328618	0	128613002	4029498		0
72860	4330	40480160	2012-03-20	2012-03-20 00:00:00	2012-06-18	2012-06-18 00:00:00	32020		\N	287221	0	443165006	40480160		0
83661	4971	4116491	1992-08-20	1992-08-20 00:00:00	1992-10-13	1992-10-13 00:00:00	32020		\N	330549	0	301011002	4116491		0
83723	4975	40481087	1986-03-08	1986-03-08 00:00:00	1986-03-15	1986-03-15 00:00:00	32020		\N	330906	0	444814009	40481087		0
83832	4979	4142905	1978-03-15	1978-03-15 00:00:00	1978-06-13	1978-06-13 00:00:00	32020		\N	331243	0	33737001	4142905		0
84113	4998	4112343	1975-01-19	1975-01-19 00:00:00	1975-01-31	1975-01-31 00:00:00	32020		\N	332404	0	195662009	4112343		0
73616	4375	4294548	1943-05-25	1943-05-25 00:00:00	1943-11-16	1943-11-16 00:00:00	32020		\N	290602	0	75498004	4294548		0
84389	5015	4155034	1982-05-22	1982-05-22 00:00:00	1982-06-12	1982-06-12 00:00:00	32020		\N	333374	0	283371005	4155034		0
84624	5034	40481087	1986-12-17	1986-12-17 00:00:00	1986-12-24	1986-12-24 00:00:00	32020		\N	334519	0	444814009	40481087		0
84719	5037	372328	1982-05-04	1982-05-04 00:00:00	1983-02-02	1983-02-02 00:00:00	32020		\N	334739	0	65363002	372328		0
84916	5049	40481087	1998-10-10	1998-10-10 00:00:00	1998-10-17	1998-10-17 00:00:00	32020		\N	335562	0	444814009	40481087		0
74501	4423	260139	1998-09-22	1998-09-22 00:00:00	1998-09-29	1998-09-29 00:00:00	32020		\N	294109	0	10509002	260139		0
74675	4435	4294548	1996-04-18	1996-04-18 00:00:00	1996-05-23	1996-05-23 00:00:00	32020		\N	294816	0	75498004	4294548		0
74704	4437	40481087	1996-05-04	1996-05-04 00:00:00	1996-05-11	1996-05-11 00:00:00	32020		\N	294933	0	444814009	40481087		0
64405	3804	40481087	1962-01-27	1962-01-27 00:00:00	1962-02-17	1962-02-17 00:00:00	32020		\N	252879	0	444814009	40481087		0
64522	3814	4278672	1975-09-27	1975-09-27 00:00:00	1975-12-26	1975-12-26 00:00:00	32020		\N	253312	0	65966004	4278672		0
75267	4471	80180	1998-05-18	1998-05-18 00:00:00	\N	\N	32020		\N	297426	0	396275006	80180		0
64798	3832	40481087	1991-08-10	1991-08-10 00:00:00	1991-08-17	1991-08-17 00:00:00	32020		\N	254410	0	444814009	40481087		0
65071	3849	195588	2005-11-10	2005-11-10 00:00:00	2005-12-21	2005-12-21 00:00:00	32020		\N	255393	0	38822007	195588		0
65189	3856	28060	1976-10-18	1976-10-18 00:00:00	1976-10-25	1976-10-25 00:00:00	32020		\N	255907	0	43878008	28060		0
65354	3865	40479422	2009-05-28	2009-05-28 00:00:00	2009-07-04	2009-07-04 00:00:00	32020		\N	256558	0	444448004	40479422		0
65551	3876	4278672	2017-12-23	2017-12-23 00:00:00	2018-01-22	2018-01-22 00:00:00	32020		\N	257538	0	65966004	4278672		0
76279	4526	40481087	1980-10-10	1980-10-10 00:00:00	1980-10-24	1980-10-24 00:00:00	32020		\N	301322	0	444814009	40481087		0
76441	4532	40481087	1968-04-22	1968-04-22 00:00:00	1968-04-29	1968-04-29 00:00:00	32020		\N	301919	0	444814009	40481087		0
66058	3906	375671	1967-01-13	1967-01-13 00:00:00	1967-02-12	1967-02-12 00:00:00	32020		\N	259751	0	62564004	375671		0
76711	4547	40481087	1977-06-08	1977-06-08 00:00:00	1977-06-15	1977-06-15 00:00:00	32020		\N	302902	0	444814009	40481087		0
76878	4557	260139	1942-12-20	1942-12-20 00:00:00	1943-01-03	1943-01-03 00:00:00	32020		\N	303573	0	10509002	260139		0
66508	3936	40481087	1976-10-17	1976-10-17 00:00:00	1976-10-24	1976-10-24 00:00:00	32020		\N	261616	0	444814009	40481087		0
77296	4578	4112343	1998-12-07	1998-12-07 00:00:00	1998-12-19	1998-12-19 00:00:00	32020		\N	304921	0	195662009	4112343		0
77416	4587	4113008	2004-04-17	2004-04-17 00:00:00	2004-05-08	2004-05-08 00:00:00	32020		\N	305568	0	284549007	4113008		0
77564	4595	260139	1986-04-01	1986-04-01 00:00:00	1986-04-08	1986-04-08 00:00:00	32020		\N	306187	0	10509002	260139		0
77696	4603	257012	1960-06-27	1960-06-27 00:00:00	\N	\N	32020		\N	306629	0	40055000	257012		0
88516	5262	40481087	1977-10-04	1977-10-04 00:00:00	1977-10-11	1977-10-11 00:00:00	32020		\N	350099	0	444814009	40481087		0
78036	4623	80502	1989-09-26	1989-09-26 00:00:00	\N	\N	32020		\N	307998	0	64859006	80502		0
67698	3998	4112343	1953-03-15	1953-03-15 00:00:00	1953-03-25	1953-03-25 00:00:00	32020		\N	265833	0	195662009	4112343		0
67870	4010	4112343	1983-08-29	1983-08-29 00:00:00	1983-09-11	1983-09-11 00:00:00	32020		\N	266461	0	195662009	4112343		0
78537	4649	260139	2010-05-03	2010-05-03 00:00:00	2010-05-17	2010-05-17 00:00:00	32020		\N	310012	0	10509002	260139		0
68195	4027	257012	1996-03-23	1996-03-23 00:00:00	\N	\N	32020		\N	267791	0	40055000	257012		0
78952	4675	260139	1953-09-11	1953-09-11 00:00:00	1953-09-25	1953-09-25 00:00:00	32020		\N	311429	0	10509002	260139		0
79026	4678	40481087	1980-10-16	1980-10-16 00:00:00	1980-10-23	1980-10-23 00:00:00	32020		\N	311732	0	444814009	40481087		0
79238	4690	4152936	1993-05-20	1993-05-20 00:00:00	1993-06-03	1993-06-03 00:00:00	32020		\N	312469	0	283385000	4152936		0
79434	4704	4112343	1983-10-27	1983-10-27 00:00:00	1983-11-08	1983-11-08 00:00:00	32020		\N	313370	0	195662009	4112343		0
68989	4084	4134304	1994-08-18	1994-08-18 00:00:00	1994-09-17	1994-09-17 00:00:00	32020		\N	271437	0	263102004	4134304		0
69201	4094	80180	1991-02-26	1991-02-26 00:00:00	\N	\N	32020		\N	272169	0	396275006	80180		0
79979	4739	4218389	1944-05-02	1944-05-02 00:00:00	1944-06-06	1944-06-06 00:00:00	32020		\N	315727	0	39848009	4218389		0
69434	4109	4310024	2000-06-20	2000-06-20 00:00:00	\N	\N	32020		\N	273191	0	424802006	4310024		0
69639	4121	40481087	1925-09-28	1925-09-28 00:00:00	1925-10-19	1925-10-19 00:00:00	32020		\N	273956	0	444814009	40481087		0
80400	4761	4285898	2018-10-13	2018-10-13 00:00:00	\N	\N	32020		\N	317322	0	68496003	4285898		0
70186	4156	40481087	1991-10-22	1991-10-22 00:00:00	1991-11-12	1991-11-12 00:00:00	32020		\N	276216	0	444814009	40481087		0
80916	4800	260139	2001-01-28	2001-01-28 00:00:00	2001-02-04	2001-02-04 00:00:00	32020		\N	319299	0	10509002	260139		0
81300	4822	40481087	1966-08-23	1966-08-23 00:00:00	1966-08-30	1966-08-30 00:00:00	32020		\N	320743	0	444814009	40481087		0
81360	4826	4296205	2019-05-18	2019-05-18 00:00:00	2019-06-22	2019-06-22 00:00:00	32020		\N	320988	0	403191005	4296205		0
71021	4212	40481087	1972-05-27	1972-05-27 00:00:00	1972-06-17	1972-06-17 00:00:00	32020		\N	279663	0	444814009	40481087		0
71137	4220	40481087	2010-12-01	2010-12-01 00:00:00	2010-12-15	2010-12-15 00:00:00	32020		\N	280225	0	444814009	40481087		0
81851	4853	4113008	1978-04-15	1978-04-15 00:00:00	1978-05-06	1978-05-06 00:00:00	32020		\N	322912	0	284549007	4113008		0
71490	4240	4283893	1949-10-12	1949-10-12 00:00:00	1950-04-12	1950-04-12 00:00:00	32020		\N	281688	0	36971009	4283893		0
82214	4874	4294548	1980-08-02	1980-08-02 00:00:00	1980-11-01	1980-11-01 00:00:00	32020		\N	324205	0	75498004	4294548		0
71844	4261	28060	1928-08-10	1928-08-10 00:00:00	1928-08-17	1928-08-17 00:00:00	32020		\N	282971	0	43878008	28060		0
72021	4274	4112343	1964-06-06	1964-06-06 00:00:00	1964-06-17	1964-06-17 00:00:00	32020		\N	283618	0	195662009	4112343		0
72127	4279	260139	1986-12-05	1986-12-05 00:00:00	1986-12-12	1986-12-12 00:00:00	32020		\N	283964	0	10509002	260139		0
72294	4289	28060	2016-09-24	2016-09-24 00:00:00	2016-10-07	2016-10-07 00:00:00	32020		\N	284798	0	43878008	28060		0
83086	4935	30753	2002-06-07	2002-06-07 00:00:00	\N	\N	32020		\N	328150	0	16761005	30753		0
83213	4943	40481087	1997-03-18	1997-03-18 00:00:00	1997-03-25	1997-03-25 00:00:00	32020		\N	328541	0	444814009	40481087		0
72861	4330	40481087	1957-02-09	1957-02-09 00:00:00	1957-02-23	1957-02-23 00:00:00	32020		\N	287266	0	444814009	40481087		0
83662	4971	40481087	1993-02-28	1993-02-28 00:00:00	1993-03-21	1993-03-21 00:00:00	32020		\N	330550	0	444814009	40481087		0
83724	4975	28060	2011-07-03	2011-07-03 00:00:00	2011-07-15	2011-07-15 00:00:00	32020		\N	330908	0	43878008	28060		0
83833	4979	40481087	2001-09-27	2001-09-27 00:00:00	2001-10-04	2001-10-04 00:00:00	32020		\N	331293	0	444814009	40481087		0
84114	4998	40481087	2015-03-25	2015-03-25 00:00:00	2015-04-01	2015-04-01 00:00:00	32020		\N	332334	0	444814009	40481087		0
73617	4375	80180	1969-07-19	1969-07-19 00:00:00	\N	\N	32020		\N	290611	0	396275006	80180		0
84390	5015	4155034	2010-09-25	2010-09-25 00:00:00	2010-10-16	2010-10-16 00:00:00	32020		\N	333378	0	283371005	4155034		0
84625	5034	40479768	1971-03-08	1971-03-08 00:00:00	1971-04-14	1971-04-14 00:00:00	32020		\N	334461	0	444470001	40479768		0
84720	5037	80180	2009-07-28	2009-07-28 00:00:00	\N	\N	32020		\N	334768	0	396275006	80180		0
84917	5049	260139	1966-05-11	1966-05-11 00:00:00	1966-05-25	1966-05-25 00:00:00	32020		\N	335588	0	10509002	260139		0
74502	4423	4237458	1979-03-04	1979-03-04 00:00:00	1979-04-03	1979-04-03 00:00:00	32020		\N	294120	0	58150001	4237458		0
74676	4435	4156265	1978-04-03	1978-04-03 00:00:00	1978-04-24	1978-04-24 00:00:00	32020		\N	294822	0	370247008	4156265		0
74705	4437	372328	1970-06-15	1970-06-15 00:00:00	1970-12-16	1970-12-16 00:00:00	32020		\N	294917	0	65363002	372328		0
64406	3804	372328	1964-05-10	1964-05-10 00:00:00	1964-11-12	1964-11-12 00:00:00	32020		\N	252897	0	65363002	372328		0
64523	3814	4142905	1987-06-26	1987-06-26 00:00:00	1987-08-25	1987-08-25 00:00:00	32020		\N	253313	0	33737001	4142905		0
75268	4471	40481087	1964-11-20	1964-11-20 00:00:00	1964-11-27	1964-11-27 00:00:00	32020		\N	297451	0	444814009	40481087		0
64799	3832	257012	1993-05-15	1993-05-15 00:00:00	\N	\N	32020		\N	254452	0	40055000	257012		0
65072	3849	4112343	2013-08-01	2013-08-01 00:00:00	2013-08-12	2013-08-12 00:00:00	32020		\N	255394	0	195662009	4112343		0
65190	3856	40481087	1975-04-04	1975-04-04 00:00:00	1975-04-11	1975-04-11 00:00:00	32020		\N	255905	0	444814009	40481087		0
65355	3865	40481087	2010-11-28	2010-11-28 00:00:00	2010-12-19	2010-12-19 00:00:00	32020		\N	256671	0	444814009	40481087		0
65552	3876	40481087	2011-01-23	2011-01-23 00:00:00	2011-02-13	2011-02-13 00:00:00	32020		\N	257444	0	444814009	40481087		0
76280	4526	4112343	1979-09-05	1979-09-05 00:00:00	1979-09-15	1979-09-15 00:00:00	32020		\N	301363	0	195662009	4112343		0
76442	4532	40481087	1949-01-26	1949-01-26 00:00:00	1949-02-09	1949-02-09 00:00:00	32020		\N	301832	0	444814009	40481087		0
66059	3906	28060	1982-04-01	1982-04-01 00:00:00	1982-04-12	1982-04-12 00:00:00	32020		\N	259675	0	43878008	28060		0
76712	4547	40481087	1970-11-27	1970-11-27 00:00:00	1970-12-04	1970-12-04 00:00:00	32020		\N	302936	0	444814009	40481087		0
76879	4557	28060	1934-10-05	1934-10-05 00:00:00	1934-10-16	1934-10-16 00:00:00	32020		\N	303602	0	43878008	28060		0
66509	3936	4035415	2006-11-28	2006-11-28 00:00:00	2007-01-27	2007-01-27 00:00:00	32020		\N	261632	0	239720000	4035415		0
77297	4578	30753	1999-04-11	1999-04-11 00:00:00	\N	\N	32020		\N	304921	0	16761005	30753		0
77417	4587	40481087	1937-11-03	1937-11-03 00:00:00	1937-11-10	1937-11-10 00:00:00	32020		\N	305605	0	444814009	40481087		0
77565	4595	40481087	1967-06-23	1967-06-23 00:00:00	1967-07-14	1967-07-14 00:00:00	32020		\N	306163	0	444814009	40481087		0
77697	4603	81151	1940-09-23	1940-09-23 00:00:00	1940-10-28	1940-10-28 00:00:00	32020		\N	306647	0	44465007	81151		0
88517	5262	4112343	2003-04-14	2003-04-14 00:00:00	2003-04-22	2003-04-22 00:00:00	32020		\N	350113	0	195662009	4112343		0
78037	4623	30753	1970-12-25	1970-12-25 00:00:00	\N	\N	32020		\N	308005	0	16761005	30753		0
67699	3998	81151	2008-08-02	2008-08-02 00:00:00	2008-09-06	2008-09-06 00:00:00	32020		\N	265793	0	44465007	81151		0
67871	4010	372328	1982-12-05	1982-12-05 00:00:00	1983-04-21	1983-04-21 00:00:00	32020		\N	266456	0	65363002	372328		0
78538	4649	4112343	2018-03-04	2018-03-04 00:00:00	2018-03-12	2018-03-12 00:00:00	32020		\N	309997	0	195662009	4112343		0
68196	4027	4112343	1976-10-05	1976-10-05 00:00:00	1976-10-16	1976-10-16 00:00:00	32020		\N	267896	0	195662009	4112343		0
78953	4675	40481087	1980-06-19	1980-06-19 00:00:00	1980-07-10	1980-07-10 00:00:00	32020		\N	311432	0	444814009	40481087		0
79027	4678	40481087	1986-08-17	1986-08-17 00:00:00	1986-08-31	1986-08-31 00:00:00	32020		\N	311765	0	444814009	40481087		0
79239	4690	80502	2016-10-01	2016-10-01 00:00:00	\N	\N	32020		\N	312474	0	64859006	80502		0
79435	4704	4112343	1982-04-21	1982-04-21 00:00:00	1982-05-02	1982-05-02 00:00:00	32020		\N	313361	0	195662009	4112343		0
68990	4084	372328	1962-12-13	1962-12-13 00:00:00	1963-01-27	1963-01-27 00:00:00	32020		\N	271413	0	65363002	372328		0
69202	4094	40481087	1958-02-17	1958-02-17 00:00:00	1958-03-03	1958-03-03 00:00:00	32020		\N	272114	0	444814009	40481087		0
79980	4739	260139	1919-06-09	1919-06-09 00:00:00	1919-06-16	1919-06-16 00:00:00	32020		\N	315680	0	10509002	260139		0
69435	4109	40481087	2000-05-03	2000-05-03 00:00:00	2000-05-24	2000-05-24 00:00:00	32020		\N	273191	0	444814009	40481087		0
69640	4121	81151	1986-08-29	1986-08-29 00:00:00	1986-09-26	1986-09-26 00:00:00	32020		\N	273965	0	44465007	81151		0
80401	4761	80180	2018-12-12	2018-12-12 00:00:00	\N	\N	32020		\N	317322	0	396275006	80180		0
70187	4156	260139	2017-12-24	2017-12-24 00:00:00	2017-12-31	2017-12-31 00:00:00	32020		\N	276181	0	10509002	260139		0
80917	4800	40481087	2007-10-09	2007-10-09 00:00:00	2007-10-30	2007-10-30 00:00:00	32020		\N	319308	0	444814009	40481087		0
81301	4822	439777	1993-09-12	1993-09-12 00:00:00	\N	\N	32020		\N	320747	0	271737000	439777		0
81361	4826	4294548	1956-12-10	1956-12-10 00:00:00	1957-01-21	1957-01-21 00:00:00	32020		\N	321067	0	75498004	4294548		0
71022	4212	40481087	1991-06-20	1991-06-20 00:00:00	1991-07-04	1991-07-04 00:00:00	32020		\N	279683	0	444814009	40481087		0
71138	4220	40481087	1964-06-18	1964-06-18 00:00:00	1964-07-02	1964-07-02 00:00:00	32020		\N	280228	0	444814009	40481087		0
81852	4853	4296204	2002-06-29	2002-06-29 00:00:00	2002-07-13	2002-07-13 00:00:00	32020		\N	322913	0	403190006	4296204		0
71491	4240	440448	1965-07-16	1965-07-16 00:00:00	\N	\N	32020		\N	281592	0	74400008	440448		0
82220	4876	40481087	1991-11-21	1991-11-21 00:00:00	1991-12-12	1991-12-12 00:00:00	32020		\N	324271	0	444814009	40481087		0
71845	4261	4155034	1999-11-19	1999-11-19 00:00:00	1999-12-10	1999-12-10 00:00:00	32020		\N	282895	0	283371005	4155034		0
72022	4274	40481087	1996-10-24	1996-10-24 00:00:00	1996-11-14	1996-11-14 00:00:00	32020		\N	283555	0	444814009	40481087		0
72128	4279	40481087	2008-05-22	2008-05-22 00:00:00	2008-05-29	2008-05-29 00:00:00	32020		\N	283994	0	444814009	40481087		0
72295	4289	4112343	2002-08-03	2002-08-03 00:00:00	2002-08-13	2002-08-13 00:00:00	32020		\N	284748	0	195662009	4112343		0
83087	4935	40481087	2005-08-15	2005-08-15 00:00:00	2005-08-29	2005-08-29 00:00:00	32020		\N	328126	0	444814009	40481087		0
83214	4943	257012	1997-09-04	1997-09-04 00:00:00	\N	\N	32020		\N	328542	0	40055000	257012		0
72862	4330	40481087	2008-04-20	2008-04-20 00:00:00	2008-05-04	2008-05-04 00:00:00	32020		\N	287190	0	444814009	40481087		0
83663	4971	4283893	2018-03-22	2018-03-22 00:00:00	2018-06-07	2018-06-07 00:00:00	32020		\N	330645	0	36971009	4283893		0
83725	4975	4027663	1993-06-30	1993-06-30 00:00:00	\N	\N	32020		\N	330907	0	13200003	4027663		0
83834	4979	260139	1978-07-14	1978-07-14 00:00:00	1978-07-28	1978-07-28 00:00:00	32020		\N	331291	0	10509002	260139		0
84115	4998	40481087	1967-06-03	1967-06-03 00:00:00	1967-06-24	1967-06-24 00:00:00	32020		\N	332372	0	444814009	40481087		0
73618	4375	28060	1957-12-04	1957-12-04 00:00:00	1957-12-12	1957-12-12 00:00:00	32020		\N	290636	0	43878008	28060		0
84391	5015	378001	1985-02-26	1985-02-26 00:00:00	1985-04-27	1985-04-27 00:00:00	32020		\N	333375	0	62106007	378001		0
84626	5034	28060	1973-06-24	1973-06-24 00:00:00	1973-07-05	1973-07-05 00:00:00	32020		\N	334486	0	43878008	28060		0
84721	5037	40481087	2003-12-05	2003-12-05 00:00:00	2003-12-26	2003-12-26 00:00:00	32020		\N	334773	0	444814009	40481087		0
84918	5049	4112343	2002-05-03	2002-05-03 00:00:00	2002-05-11	2002-05-11 00:00:00	32020		\N	335546	0	195662009	4112343		0
84414	5018	80180	1980-01-25	1980-01-25 00:00:00	\N	\N	32020		\N	333505	0	396275006	80180		0
74503	4423	4112343	1995-08-09	1995-08-09 00:00:00	1995-08-22	1995-08-22 00:00:00	32020		\N	294087	0	195662009	4112343		0
74677	4435	4027663	1990-12-26	1990-12-26 00:00:00	\N	\N	32020		\N	\N	0	13200003	4027663		0
74706	4437	4112343	1981-01-17	1981-01-17 00:00:00	1981-01-29	1981-01-29 00:00:00	32020		\N	294931	0	195662009	4112343		0
64407	3804	40481087	1994-04-16	1994-04-16 00:00:00	1994-04-30	1994-04-30 00:00:00	32020		\N	252832	0	444814009	40481087		0
64524	3814	260139	1977-08-19	1977-08-19 00:00:00	1977-09-02	1977-09-02 00:00:00	32020		\N	253333	0	10509002	260139		0
75269	4471	40481087	1962-02-06	1962-02-06 00:00:00	1962-02-27	1962-02-27 00:00:00	32020		\N	297443	0	444814009	40481087		0
64800	3832	40481087	2012-04-11	2012-04-11 00:00:00	2012-05-02	2012-05-02 00:00:00	32020		\N	254473	0	444814009	40481087		0
75531	4482	40481087	1980-10-29	1980-10-29 00:00:00	1980-11-12	1980-11-12 00:00:00	32020		\N	298369	0	444814009	40481087		0
65191	3856	4112343	1986-08-08	1986-08-08 00:00:00	1986-08-16	1986-08-16 00:00:00	32020		\N	255922	0	195662009	4112343		0
65356	3865	40481087	1978-11-04	1978-11-04 00:00:00	1978-11-11	1978-11-11 00:00:00	32020		\N	256580	0	444814009	40481087		0
65553	3876	372328	1975-05-10	1975-05-10 00:00:00	1976-05-10	1976-05-10 00:00:00	32020		\N	257418	0	65363002	372328		0
76281	4526	40481087	2011-11-21	2011-11-21 00:00:00	2011-12-05	2011-12-05 00:00:00	32020		\N	301325	0	444814009	40481087		0
76443	4532	40481087	1979-01-03	1979-01-03 00:00:00	1979-01-17	1979-01-17 00:00:00	32020		\N	301846	0	444814009	40481087		0
66060	3906	40481087	1945-08-13	1945-08-13 00:00:00	1945-08-27	1945-08-27 00:00:00	32020		\N	259670	0	444814009	40481087		0
76713	4547	40480160	1982-01-17	1982-01-17 00:00:00	1982-04-17	1982-04-17 00:00:00	32020		\N	302959	0	443165006	40480160		0
76880	4557	260139	1988-07-21	1988-07-21 00:00:00	1988-07-28	1988-07-28 00:00:00	32020		\N	303577	0	10509002	260139		0
66510	3936	4112343	2012-08-13	2012-08-13 00:00:00	2012-08-24	2012-08-24 00:00:00	32020		\N	261640	0	195662009	4112343		0
77298	4578	40481087	2019-02-21	2019-02-21 00:00:00	2019-02-28	2019-02-28 00:00:00	32020		\N	304964	0	444814009	40481087		0
77418	4587	260139	2003-07-02	2003-07-02 00:00:00	2003-07-16	2003-07-16 00:00:00	32020		\N	305598	0	10509002	260139		0
77566	4595	4278672	1974-08-09	1974-08-09 00:00:00	1974-11-06	1974-11-06 00:00:00	32020		\N	306182	0	65966004	4278672		0
77698	4603	40481087	1998-05-09	1998-05-09 00:00:00	1998-05-23	1998-05-23 00:00:00	32020		\N	306665	0	444814009	40481087		0
88518	5262	40481087	1993-10-31	1993-10-31 00:00:00	1993-11-21	1993-11-21 00:00:00	32020		\N	350085	0	444814009	40481087		0
78038	4623	4285898	1971-02-23	1971-02-23 00:00:00	\N	\N	32020		\N	308005	0	68496003	4285898		0
67700	3998	260139	2006-07-10	2006-07-10 00:00:00	2006-07-17	2006-07-17 00:00:00	32020		\N	265806	0	10509002	260139		0
67872	4010	4112343	2007-12-17	2007-12-17 00:00:00	2007-12-28	2007-12-28 00:00:00	32020		\N	266463	0	195662009	4112343		0
78539	4649	260139	2015-03-01	2015-03-01 00:00:00	2015-03-15	2015-03-15 00:00:00	32020		\N	309978	0	10509002	260139		0
68197	4027	40481087	1994-02-06	1994-02-06 00:00:00	1994-02-13	1994-02-13 00:00:00	32020		\N	267825	0	444814009	40481087		0
78954	4675	40481087	1960-08-06	1960-08-06 00:00:00	1960-08-13	1960-08-13 00:00:00	32020		\N	311437	0	444814009	40481087		0
79028	4678	260139	1974-01-06	1974-01-06 00:00:00	1974-01-13	1974-01-13 00:00:00	32020		\N	311739	0	10509002	260139		0
79240	4690	4112343	1998-01-12	1998-01-12 00:00:00	1998-01-22	1998-01-22 00:00:00	32020		\N	312517	0	195662009	4112343		0
79436	4704	378001	1967-10-09	1967-10-09 00:00:00	1967-12-08	1967-12-08 00:00:00	32020		\N	313429	0	62106007	378001		0
68991	4084	40481087	2011-03-15	2011-03-15 00:00:00	2011-04-05	2011-04-05 00:00:00	32020		\N	271402	0	444814009	40481087		0
69203	4094	260139	1959-12-17	1959-12-17 00:00:00	1959-12-24	1959-12-24 00:00:00	32020		\N	272115	0	10509002	260139		0
79981	4739	4112343	1957-03-16	1957-03-16 00:00:00	1957-03-23	1957-03-23 00:00:00	32020		\N	315741	0	195662009	4112343		0
69436	4109	4266809	2002-02-10	2002-02-10 00:00:00	\N	\N	32020		\N	273191	0	397881000	4266809		0
69641	4121	4218389	1933-06-30	1933-06-30 00:00:00	1933-08-04	1933-08-04 00:00:00	32020		\N	273929	0	39848009	4218389		0
80402	4761	260139	1989-12-31	1989-12-31 00:00:00	1990-01-14	1990-01-14 00:00:00	32020		\N	317214	0	10509002	260139		0
70188	4156	40481087	1959-12-16	1959-12-16 00:00:00	1960-01-06	1960-01-06 00:00:00	32020		\N	276177	0	444814009	40481087		0
80918	4800	4027663	1997-10-23	1997-10-23 00:00:00	\N	\N	32020		\N	319337	0	13200003	4027663		0
81302	4822	81151	1952-07-20	1952-07-20 00:00:00	1952-08-03	1952-08-03 00:00:00	32020		\N	320723	0	44465007	81151		0
81362	4826	4134304	1967-11-26	1967-11-26 00:00:00	1967-12-26	1967-12-26 00:00:00	32020		\N	320985	0	263102004	4134304		0
71023	4212	4112343	1992-10-26	1992-10-26 00:00:00	1992-11-07	1992-11-07 00:00:00	32020		\N	279664	0	195662009	4112343		0
71139	4220	40481087	1943-04-02	1943-04-02 00:00:00	1943-04-09	1943-04-09 00:00:00	32020		\N	280200	0	444814009	40481087		0
81853	4853	40481087	2009-11-17	2009-11-17 00:00:00	2009-12-08	2009-12-08 00:00:00	32020		\N	322874	0	444814009	40481087		0
71492	4240	4218389	1946-05-01	1946-05-01 00:00:00	1946-05-29	1946-05-29 00:00:00	32020		\N	281591	0	39848009	4218389		0
82221	4876	40481087	2006-03-31	2006-03-31 00:00:00	2006-04-07	2006-04-07 00:00:00	32020		\N	324254	0	444814009	40481087		0
71846	4261	40481087	1977-10-30	1977-10-30 00:00:00	1977-11-06	1977-11-06 00:00:00	32020		\N	282861	0	444814009	40481087		0
72023	4274	80180	1958-05-31	1958-05-31 00:00:00	\N	\N	32020		\N	283602	0	396275006	80180		0
72129	4279	40481087	2001-11-02	2001-11-02 00:00:00	2001-11-16	2001-11-16 00:00:00	32020		\N	284068	0	444814009	40481087		0
72296	4289	40481087	1950-12-11	1950-12-11 00:00:00	1951-01-01	1951-01-01 00:00:00	32020		\N	284797	0	444814009	40481087		0
83088	4935	4112343	2017-03-24	2017-03-24 00:00:00	2017-03-31	2017-03-31 00:00:00	32020		\N	328097	0	195662009	4112343		0
83215	4943	40481087	2007-11-17	2007-11-17 00:00:00	2007-12-08	2007-12-08 00:00:00	32020		\N	328576	0	444814009	40481087		0
72863	4330	260139	1977-08-29	1977-08-29 00:00:00	1977-09-12	1977-09-12 00:00:00	32020		\N	287183	0	10509002	260139		0
83664	4971	40481087	1994-11-16	1994-11-16 00:00:00	1994-11-30	1994-11-30 00:00:00	32020		\N	330589	0	444814009	40481087		0
83726	4975	4112343	1992-11-13	1992-11-13 00:00:00	1992-11-23	1992-11-23 00:00:00	32020		\N	330907	0	195662009	4112343		0
83835	4979	4112343	2008-04-30	2008-04-30 00:00:00	2008-05-11	2008-05-11 00:00:00	32020		\N	331280	0	195662009	4112343		0
84116	4998	28060	1993-02-08	1993-02-08 00:00:00	1993-02-17	1993-02-17 00:00:00	32020		\N	332406	0	43878008	28060		0
73619	4375	4112343	1939-06-11	1939-06-11 00:00:00	1939-06-18	1939-06-18 00:00:00	32020		\N	290634	0	195662009	4112343		0
84392	5015	40481087	2017-12-23	2017-12-23 00:00:00	2017-12-30	2017-12-30 00:00:00	32020		\N	333362	0	444814009	40481087		0
84627	5034	260139	1980-09-25	1980-09-25 00:00:00	1980-10-09	1980-10-09 00:00:00	32020		\N	334442	0	10509002	260139		0
84722	5037	81151	2012-09-01	2012-09-01 00:00:00	2012-09-15	2012-09-15 00:00:00	32020		\N	334735	0	44465007	81151		0
84919	5049	381316	2002-07-31	2002-07-31 00:00:00	\N	\N	32020		\N	335546	0	230690007	381316		0
74504	4423	40481087	1992-01-20	1992-01-20 00:00:00	1992-02-03	1992-02-03 00:00:00	32020		\N	294091	0	444814009	40481087		0
74678	4435	4237458	2015-09-28	2015-09-28 00:00:00	2015-10-28	2015-10-28 00:00:00	32020		\N	294783	0	58150001	4237458		0
74707	4437	40481087	1986-03-29	1986-03-29 00:00:00	1986-04-19	1986-04-19 00:00:00	32020		\N	294916	0	444814009	40481087		0
64408	3804	78272	1971-08-02	1971-08-02 00:00:00	1971-08-23	1971-08-23 00:00:00	32020		\N	252858	0	70704007	78272		0
64525	3814	40481087	1976-02-20	1976-02-20 00:00:00	1976-03-05	1976-03-05 00:00:00	32020		\N	253332	0	444814009	40481087		0
75270	4471	40481087	1975-05-16	1975-05-16 00:00:00	1975-05-23	1975-05-23 00:00:00	32020		\N	297430	0	444814009	40481087		0
64801	3832	4283893	1993-04-17	1993-04-17 00:00:00	1993-12-11	1993-12-11 00:00:00	32020		\N	254408	0	36971009	4283893		0
75532	4482	4134304	1966-12-23	1966-12-23 00:00:00	1967-01-22	1967-01-22 00:00:00	32020		\N	298356	0	263102004	4134304		0
65192	3856	80180	2012-02-05	2012-02-05 00:00:00	\N	\N	32020		\N	255947	0	396275006	80180		0
65357	3865	4112343	1991-11-09	1991-11-09 00:00:00	1991-11-22	1991-11-22 00:00:00	32020		\N	256626	0	195662009	4112343		0
65554	3876	80180	2004-07-26	2004-07-26 00:00:00	\N	\N	32020		\N	257536	0	396275006	80180		0
76282	4526	260139	1989-02-04	1989-02-04 00:00:00	1989-02-18	1989-02-18 00:00:00	32020		\N	301380	0	10509002	260139		0
76444	4532	28060	1912-02-07	1912-02-07 00:00:00	1912-02-14	1912-02-14 00:00:00	32020		\N	301913	0	43878008	28060		0
66061	3906	40481087	2017-06-25	2017-06-25 00:00:00	2017-07-02	2017-07-02 00:00:00	32020		\N	259734	0	444814009	40481087		0
76714	4547	4230399	1982-01-17	1982-01-17 00:00:00	1982-04-17	1982-04-17 00:00:00	32020		\N	302959	0	359817006	4230399		0
76881	4557	260139	1988-12-26	1988-12-26 00:00:00	1989-01-02	1989-01-02 00:00:00	32020		\N	303578	0	10509002	260139		0
66511	3936	372328	1958-08-07	1958-08-07 00:00:00	1958-11-17	1958-11-17 00:00:00	32020		\N	261644	0	65363002	372328		0
77299	4578	4112343	1967-09-08	1967-09-08 00:00:00	1967-09-17	1967-09-17 00:00:00	32020		\N	304918	0	195662009	4112343		0
77419	4587	40481087	1952-10-25	1952-10-25 00:00:00	1952-11-15	1952-11-15 00:00:00	32020		\N	305596	0	444814009	40481087		0
77567	4595	260139	1991-04-09	1991-04-09 00:00:00	1991-04-23	1991-04-23 00:00:00	32020		\N	306188	0	10509002	260139		0
77699	4603	28060	1970-05-17	1970-05-17 00:00:00	1970-05-30	1970-05-30 00:00:00	32020		\N	306638	0	43878008	28060		0
88519	5262	40481087	2000-07-22	2000-07-22 00:00:00	2000-08-12	2000-08-12 00:00:00	32020		\N	350112	0	444814009	40481087		0
78039	4623	80180	1971-08-22	1971-08-22 00:00:00	\N	\N	32020		\N	308005	0	396275006	80180		0
67701	3998	4112343	1993-02-04	1993-02-04 00:00:00	1993-02-11	1993-02-11 00:00:00	32020		\N	265788	0	195662009	4112343		0
78353	4639	30753	2002-12-09	2002-12-09 00:00:00	\N	\N	32020		\N	309221	0	16761005	30753		0
78540	4649	80180	2003-05-28	2003-05-28 00:00:00	\N	\N	32020		\N	309991	0	396275006	80180		0
68198	4027	260139	1974-10-04	1974-10-04 00:00:00	1974-10-11	1974-10-11 00:00:00	32020		\N	267866	0	10509002	260139		0
78955	4675	40481087	1964-03-03	1964-03-03 00:00:00	1964-03-10	1964-03-10 00:00:00	32020		\N	311496	0	444814009	40481087		0
79029	4678	260139	1973-01-23	1973-01-23 00:00:00	1973-02-06	1973-02-06 00:00:00	32020		\N	311764	0	10509002	260139		0
79241	4690	378001	1987-06-16	1987-06-16 00:00:00	1987-07-16	1987-07-16 00:00:00	32020		\N	312466	0	62106007	378001		0
79437	4705	4218389	2007-04-13	2007-04-13 00:00:00	2007-05-18	2007-05-18 00:00:00	32020		\N	313435	0	39848009	4218389		0
68992	4084	40481087	1987-02-08	1987-02-08 00:00:00	1987-03-01	1987-03-01 00:00:00	32020		\N	271401	0	444814009	40481087		0
69204	4094	260139	2010-09-02	2010-09-02 00:00:00	2010-09-09	2010-09-09 00:00:00	32020		\N	272126	0	10509002	260139		0
79982	4739	260139	1938-11-26	1938-11-26 00:00:00	1938-12-10	1938-12-10 00:00:00	32020		\N	315683	0	10509002	260139		0
69437	4109	30753	2001-01-16	2001-01-16 00:00:00	\N	\N	32020		\N	273191	0	16761005	30753		0
69642	4121	40481087	1931-09-24	1931-09-24 00:00:00	1931-10-01	1931-10-01 00:00:00	32020		\N	273993	0	444814009	40481087		0
80403	4761	4237458	1989-11-14	1989-11-14 00:00:00	1989-12-14	1989-12-14 00:00:00	32020		\N	317236	0	58150001	4237458		0
70189	4156	4283893	1968-01-26	1968-01-26 00:00:00	1968-02-23	1968-02-23 00:00:00	32020		\N	276178	0	36971009	4283893		0
80919	4800	4112343	1980-08-03	1980-08-03 00:00:00	1980-08-15	1980-08-15 00:00:00	32020		\N	319342	0	195662009	4112343		0
81303	4822	260139	1966-08-25	1966-08-25 00:00:00	1966-09-01	1966-09-01 00:00:00	32020		\N	320781	0	10509002	260139		0
81363	4826	4152936	2002-11-22	2002-11-22 00:00:00	2002-12-13	2002-12-13 00:00:00	32020		\N	320987	0	283385000	4152936		0
71024	4212	80180	2010-02-03	2010-02-03 00:00:00	\N	\N	32020		\N	279637	0	396275006	80180		0
71140	4220	40481087	1949-12-18	1949-12-18 00:00:00	1950-01-08	1950-01-08 00:00:00	32020		\N	280201	0	444814009	40481087		0
81854	4853	40481087	2012-06-03	2012-06-03 00:00:00	2012-06-24	2012-06-24 00:00:00	32020		\N	322888	0	444814009	40481087		0
71494	4240	372328	1984-09-03	1984-09-03 00:00:00	1985-08-05	1985-08-05 00:00:00	32020		\N	281675	0	65363002	372328		0
82222	4876	4112343	2009-09-22	2009-09-22 00:00:00	2009-10-03	2009-10-03 00:00:00	32020		\N	324299	0	195662009	4112343		0
71847	4261	372328	1927-03-16	1927-03-16 00:00:00	1928-02-26	1928-02-26 00:00:00	32020		\N	282876	0	65363002	372328		0
72024	4274	4116491	1954-01-06	1954-01-06 00:00:00	1954-02-06	1954-02-06 00:00:00	32020		\N	283635	0	301011002	4116491		0
72130	4279	40481087	1995-03-26	1995-03-26 00:00:00	1995-04-02	1995-04-02 00:00:00	32020		\N	284067	0	444814009	40481087		0
72297	4289	4116491	1984-07-08	1984-07-08 00:00:00	1984-08-31	1984-08-31 00:00:00	32020		\N	284746	0	301011002	4116491		0
83089	4935	4112343	1965-08-21	1965-08-21 00:00:00	1965-09-02	1965-09-02 00:00:00	32020		\N	328032	0	195662009	4112343		0
83216	4943	378001	1993-07-11	1993-07-11 00:00:00	1993-09-09	1993-09-09 00:00:00	32020		\N	328623	0	62106007	378001		0
72864	4330	40481087	2004-04-14	2004-04-14 00:00:00	2004-05-05	2004-05-05 00:00:00	32020		\N	287215	0	444814009	40481087		0
83727	4975	40481087	1960-01-11	1960-01-11 00:00:00	1960-01-25	1960-01-25 00:00:00	32020		\N	330896	0	444814009	40481087		0
83836	4979	40481087	1997-08-06	1997-08-06 00:00:00	1997-08-20	1997-08-20 00:00:00	32020		\N	331301	0	444814009	40481087		0
84117	4998	4051466	1968-10-15	1968-10-15 00:00:00	1984-06-01	1984-06-01 00:00:00	32020		\N	332403	0	233678006	4051466		0
73620	4375	140673	1982-06-26	1982-06-26 00:00:00	\N	\N	32020		\N	290614	0	40930008	140673		0
84393	5015	40481087	1970-03-25	1970-03-25 00:00:00	1970-04-15	1970-04-15 00:00:00	32020		\N	333379	0	444814009	40481087		0
84628	5034	40481087	1922-06-20	1922-06-20 00:00:00	1922-07-04	1922-07-04 00:00:00	32020		\N	334433	0	444814009	40481087		0
84723	5037	28060	1992-05-01	1992-05-01 00:00:00	1992-05-12	1992-05-12 00:00:00	32020		\N	334772	0	43878008	28060		0
84920	5049	260139	1996-04-28	1996-04-28 00:00:00	1996-05-12	1996-05-12 00:00:00	32020		\N	335578	0	10509002	260139		0
74505	4423	40481087	2006-01-31	2006-01-31 00:00:00	2006-02-07	2006-02-07 00:00:00	32020		\N	294093	0	444814009	40481087		0
74679	4435	78272	2000-03-29	2000-03-29 00:00:00	2000-04-19	2000-04-19 00:00:00	32020		\N	294823	0	70704007	78272		0
74708	4437	4112343	2000-10-07	2000-10-07 00:00:00	2000-10-15	2000-10-15 00:00:00	32020		\N	294887	0	195662009	4112343		0
74867	4448	4112343	2008-02-22	2008-02-22 00:00:00	2008-03-04	2008-03-04 00:00:00	32020		\N	295899	0	195662009	4112343		0
64526	3814	40481087	1998-01-14	1998-01-14 00:00:00	1998-01-28	1998-01-28 00:00:00	32020		\N	253315	0	444814009	40481087		0
75271	4471	40481087	1969-11-09	1969-11-09 00:00:00	1969-11-23	1969-11-23 00:00:00	32020		\N	297452	0	444814009	40481087		0
64802	3832	134438	2005-01-13	2005-01-13 00:00:00	2006-04-08	2006-04-08 00:00:00	32020		\N	254470	0	40275004	134438		0
75533	4482	372328	1952-11-15	1952-11-15 00:00:00	1953-04-18	1953-04-18 00:00:00	32020		\N	298360	0	65363002	372328		0
65193	3856	260139	1975-06-27	1975-06-27 00:00:00	1975-07-04	1975-07-04 00:00:00	32020		\N	255906	0	10509002	260139		0
65358	3865	4283893	2009-08-13	2009-08-13 00:00:00	2009-09-17	2009-09-17 00:00:00	32020		\N	256670	0	36971009	4283893		0
65555	3876	40481087	2004-12-13	2004-12-13 00:00:00	2004-12-20	2004-12-20 00:00:00	32020		\N	257460	0	444814009	40481087		0
76283	4526	28060	1959-02-07	1959-02-07 00:00:00	1959-02-19	1959-02-19 00:00:00	32020		\N	301329	0	43878008	28060		0
76445	4532	4237458	1984-03-03	1984-03-03 00:00:00	1984-05-02	1984-05-02 00:00:00	32020		\N	301893	0	58150001	4237458		0
66062	3906	4294548	2010-05-23	2010-05-23 00:00:00	2010-05-30	2010-05-30 00:00:00	32020		\N	259666	0	75498004	4294548		0
76715	4547	4113008	1933-09-12	1933-09-12 00:00:00	1933-09-26	1933-09-26 00:00:00	32020		\N	302957	0	284549007	4113008		0
76882	4557	40481087	1979-09-22	1979-09-22 00:00:00	1979-10-06	1979-10-06 00:00:00	32020		\N	303575	0	444814009	40481087		0
66512	3936	4112343	1987-08-09	1987-08-09 00:00:00	1987-08-17	1987-08-17 00:00:00	32020		\N	261642	0	195662009	4112343		0
77300	4578	40481087	2015-11-11	2015-11-11 00:00:00	2015-12-02	2015-12-02 00:00:00	32020		\N	304950	0	444814009	40481087		0
77420	4587	40481087	2010-03-03	2010-03-03 00:00:00	2010-03-24	2010-03-24 00:00:00	32020		\N	305608	0	444814009	40481087		0
77568	4595	4149245	1996-02-14	1996-02-14 00:00:00	1996-03-22	1996-03-22 00:00:00	32020		\N	306179	0	30832001	4149245		0
77700	4603	372328	1959-12-13	1959-12-13 00:00:00	1960-08-18	1960-08-18 00:00:00	32020		\N	306656	0	65363002	372328		0
88520	5262	4027663	2001-12-26	2001-12-26 00:00:00	\N	\N	32020		\N	350112	0	13200003	4027663		0
78040	4623	4152936	1970-12-10	1970-12-10 00:00:00	1970-12-31	1970-12-31 00:00:00	32020		\N	308005	0	283385000	4152936		0
67702	3998	260139	1975-03-07	1975-03-07 00:00:00	1975-03-14	1975-03-14 00:00:00	32020		\N	265858	0	10509002	260139		0
78354	4639	4310024	2002-03-14	2002-03-14 00:00:00	\N	\N	32020		\N	309221	0	424802006	4310024		0
78541	4649	81151	2002-07-31	2002-07-31 00:00:00	2002-09-04	2002-09-04 00:00:00	32020		\N	309991	0	44465007	81151		0
68199	4027	4112343	1986-03-30	1986-03-30 00:00:00	1986-04-11	1986-04-11 00:00:00	32020		\N	267833	0	195662009	4112343		0
78956	4675	40481087	1974-04-23	1974-04-23 00:00:00	1974-04-30	1974-04-30 00:00:00	32020		\N	311431	0	444814009	40481087		0
79030	4678	81151	2017-12-01	2017-12-01 00:00:00	2017-12-22	2017-12-22 00:00:00	32020		\N	311728	0	44465007	81151		0
79242	4690	4218389	1974-01-20	1974-01-20 00:00:00	1974-02-10	1974-02-10 00:00:00	32020		\N	312491	0	39848009	4218389		0
79438	4705	4112343	1989-02-11	1989-02-11 00:00:00	1989-02-20	1989-02-20 00:00:00	32020		\N	313478	0	195662009	4112343		0
68993	4084	4278672	1973-03-20	1973-03-20 00:00:00	1973-06-18	1973-06-18 00:00:00	32020		\N	271434	0	65966004	4278672		0
69205	4094	40481087	1997-10-26	1997-10-26 00:00:00	1997-11-09	1997-11-09 00:00:00	32020		\N	272175	0	444814009	40481087		0
79983	4739	4113008	1913-09-07	1913-09-07 00:00:00	1913-09-21	1913-09-21 00:00:00	32020		\N	315723	0	284549007	4113008		0
69438	4109	260139	2015-03-21	2015-03-21 00:00:00	2015-04-04	2015-04-04 00:00:00	32020		\N	273117	0	10509002	260139		0
69643	4121	4116491	1966-04-07	1966-04-07 00:00:00	1966-05-21	1966-05-21 00:00:00	32020		\N	273979	0	301011002	4116491		0
80404	4761	4278672	1983-11-16	1983-11-16 00:00:00	1984-02-14	1984-02-14 00:00:00	32020		\N	317235	0	65966004	4278672		0
70190	4156	4155034	1966-09-22	1966-09-22 00:00:00	1966-10-06	1966-10-06 00:00:00	32020		\N	276158	0	283371005	4155034		0
80920	4800	4112343	1997-08-20	1997-08-20 00:00:00	1997-08-29	1997-08-29 00:00:00	32020		\N	319344	0	195662009	4112343		0
81304	4822	40481087	2013-04-04	2013-04-04 00:00:00	2013-04-11	2013-04-11 00:00:00	32020		\N	320784	0	444814009	40481087		0
81364	4826	4112343	2011-07-31	2011-07-31 00:00:00	2011-08-12	2011-08-12 00:00:00	32020		\N	321045	0	195662009	4112343		0
71025	4212	40481087	2013-02-11	2013-02-11 00:00:00	2013-03-04	2013-03-04 00:00:00	32020		\N	279665	0	444814009	40481087		0
71141	4220	260139	1995-01-21	1995-01-21 00:00:00	1995-01-28	1995-01-28 00:00:00	32020		\N	280223	0	10509002	260139		0
81855	4853	40481087	1991-08-14	1991-08-14 00:00:00	1991-09-04	1991-09-04 00:00:00	32020		\N	322870	0	444814009	40481087		0
71495	4240	40481087	1960-04-13	1960-04-13 00:00:00	1960-05-04	1960-05-04 00:00:00	32020		\N	281671	0	444814009	40481087		0
82223	4876	4112343	1985-10-21	1985-10-21 00:00:00	1985-10-30	1985-10-30 00:00:00	32020		\N	324270	0	195662009	4112343		0
71848	4261	40481087	1932-06-22	1932-06-22 00:00:00	1932-07-13	1932-07-13 00:00:00	32020		\N	282936	0	444814009	40481087		0
72025	4274	4112343	2009-11-10	2009-11-10 00:00:00	2009-11-23	2009-11-23 00:00:00	32020		\N	283556	0	195662009	4112343		0
72131	4279	40481087	1978-10-04	1978-10-04 00:00:00	1978-10-18	1978-10-18 00:00:00	32020		\N	284075	0	444814009	40481087		0
72298	4289	4310024	1976-08-09	1976-08-09 00:00:00	\N	\N	32020		\N	284810	0	424802006	4310024		0
83090	4935	4152936	1981-08-26	1981-08-26 00:00:00	1981-09-09	1981-09-09 00:00:00	32020		\N	328154	0	283385000	4152936		0
83217	4943	4112343	1967-04-14	1967-04-14 00:00:00	1967-04-27	1967-04-27 00:00:00	32020		\N	328564	0	195662009	4112343		0
72865	4330	40481087	1950-08-15	1950-08-15 00:00:00	1950-09-05	1950-09-05 00:00:00	32020		\N	287223	0	444814009	40481087		0
83728	4975	4152936	2014-01-08	2014-01-08 00:00:00	2014-01-22	2014-01-22 00:00:00	32020		\N	330920	0	283385000	4152936		0
83837	4979	372328	1986-02-01	1986-02-01 00:00:00	1986-02-28	1986-02-28 00:00:00	32020		\N	331294	0	65363002	372328		0
84118	4998	133834	1965-05-14	1965-05-14 00:00:00	\N	\N	32020		\N	332402	0	24079001	133834		0
73621	4375	260139	1933-06-09	1933-06-09 00:00:00	1933-06-16	1933-06-16 00:00:00	32020		\N	290601	0	10509002	260139		0
84394	5015	4112343	2008-08-10	2008-08-10 00:00:00	2008-08-18	2008-08-18 00:00:00	32020		\N	333384	0	195662009	4112343		0
84629	5034	440086	1932-02-09	1932-02-09 00:00:00	1932-09-20	1932-09-20 00:00:00	32020		\N	334527	0	192127007	440086		0
84724	5037	4112343	2015-12-24	2015-12-24 00:00:00	2016-01-06	2016-01-06 00:00:00	32020		\N	334713	0	195662009	4112343		0
84921	5049	257012	1989-01-05	1989-01-05 00:00:00	\N	\N	32020		\N	335577	0	40055000	257012		0
74506	4423	40481087	1991-07-09	1991-07-09 00:00:00	1991-07-16	1991-07-16 00:00:00	32020		\N	294098	0	444814009	40481087		0
74680	4435	40481087	1987-07-24	1987-07-24 00:00:00	1987-08-14	1987-08-14 00:00:00	32020		\N	294804	0	444814009	40481087		0
74709	4437	4283893	1985-03-12	1985-03-12 00:00:00	1985-05-28	1985-05-28 00:00:00	32020		\N	294924	0	36971009	4283893		0
74868	4448	4112343	1994-07-10	1994-07-10 00:00:00	1994-07-17	1994-07-17 00:00:00	32020		\N	295846	0	195662009	4112343		0
64527	3814	260139	1988-10-29	1988-10-29 00:00:00	1988-11-05	1988-11-05 00:00:00	32020		\N	253363	0	10509002	260139		0
75272	4471	134438	1984-07-12	1984-07-12 00:00:00	1985-10-06	1985-10-06 00:00:00	32020		\N	297432	0	40275004	134438		0
64803	3832	372328	1991-12-31	1991-12-31 00:00:00	1992-08-20	1992-08-20 00:00:00	32020		\N	254443	0	65363002	372328		0
75534	4482	372328	1952-02-12	1952-02-12 00:00:00	1952-04-19	1952-04-19 00:00:00	32020		\N	298380	0	65363002	372328		0
65194	3856	372328	1979-07-22	1979-07-22 00:00:00	1980-07-23	1980-07-23 00:00:00	32020		\N	255893	0	65363002	372328		0
65359	3865	40481087	1994-08-03	1994-08-03 00:00:00	1994-08-24	1994-08-24 00:00:00	32020		\N	256676	0	444814009	40481087		0
65556	3876	133834	1972-02-02	1972-02-02 00:00:00	\N	\N	32020		\N	257492	0	24079001	133834		0
76284	4526	40481087	1995-03-01	1995-03-01 00:00:00	1995-03-15	1995-03-15 00:00:00	32020		\N	301330	0	444814009	40481087		0
76446	4532	80180	1945-08-26	1945-08-26 00:00:00	\N	\N	32020		\N	301904	0	396275006	80180		0
66063	3906	260139	2001-10-20	2001-10-20 00:00:00	2001-10-27	2001-10-27 00:00:00	32020		\N	259745	0	10509002	260139		0
76716	4547	4112343	1951-09-03	1951-09-03 00:00:00	1951-09-12	1951-09-12 00:00:00	32020		\N	302965	0	195662009	4112343		0
76883	4557	4059173	1969-11-12	1969-11-12 00:00:00	1970-01-11	1970-01-11 00:00:00	32020		\N	303641	0	16114001	4059173		0
66513	3936	40481087	2003-07-08	2003-07-08 00:00:00	2003-07-29	2003-07-29 00:00:00	32020		\N	261621	0	444814009	40481087		0
77301	4578	372328	1967-04-09	1967-04-09 00:00:00	1967-04-30	1967-04-30 00:00:00	32020		\N	304922	0	65363002	372328		0
77421	4587	40481087	1945-05-20	1945-05-20 00:00:00	1945-05-27	1945-05-27 00:00:00	32020		\N	305595	0	444814009	40481087		0
77569	4595	40481087	2015-06-14	2015-06-14 00:00:00	2015-06-28	2015-06-28 00:00:00	32020		\N	306157	0	444814009	40481087		0
77701	4603	28060	1931-05-18	1931-05-18 00:00:00	1931-05-26	1931-05-26 00:00:00	32020		\N	306627	0	43878008	28060		0
88521	5262	78272	2015-05-08	2015-05-08 00:00:00	2015-06-12	2015-06-12 00:00:00	32020		\N	350077	0	70704007	78272		0
78041	4623	4266809	1971-08-22	1971-08-22 00:00:00	\N	\N	32020		\N	308005	0	397881000	4266809		0
67703	3998	4266809	1986-06-22	1986-06-22 00:00:00	\N	\N	32020		\N	265808	0	397881000	4266809		0
78355	4639	260139	2004-10-09	2004-10-09 00:00:00	2004-10-23	2004-10-23 00:00:00	32020		\N	309201	0	10509002	260139		0
78542	4649	4112343	2017-12-23	2017-12-23 00:00:00	2018-01-02	2018-01-02 00:00:00	32020		\N	309979	0	195662009	4112343		0
68200	4027	4113008	2012-03-21	2012-03-21 00:00:00	2012-04-11	2012-04-11 00:00:00	32020		\N	267884	0	284549007	4113008		0
78957	4675	4112343	2001-08-31	2001-08-31 00:00:00	2001-09-10	2001-09-10 00:00:00	32020		\N	311553	0	195662009	4112343		0
79031	4678	4112343	1970-08-03	1970-08-03 00:00:00	1970-08-12	1970-08-12 00:00:00	32020		\N	311729	0	195662009	4112343		0
79243	4691	28060	1969-10-09	1969-10-09 00:00:00	1969-10-20	1969-10-20 00:00:00	32020		\N	312600	0	43878008	28060		0
79439	4705	4112343	1985-05-21	1985-05-21 00:00:00	1985-05-31	1985-05-31 00:00:00	32020		\N	313477	0	195662009	4112343		0
68994	4084	260139	1987-01-26	1987-01-26 00:00:00	1987-02-09	1987-02-09 00:00:00	32020		\N	271405	0	10509002	260139		0
69206	4094	40481087	1993-04-23	1993-04-23 00:00:00	1993-05-14	1993-05-14 00:00:00	32020		\N	272132	0	444814009	40481087		0
79984	4739	317576	1982-11-13	1982-11-13 00:00:00	\N	\N	32020		\N	315721	0	53741008	317576		0
69439	4109	260139	1973-05-19	1973-05-19 00:00:00	1973-05-26	1973-05-26 00:00:00	32020		\N	273101	0	10509002	260139		0
69644	4121	4294548	1971-07-29	1971-07-29 00:00:00	1971-08-26	1971-08-26 00:00:00	32020		\N	273943	0	75498004	4294548		0
80405	4761	4296204	2002-02-09	2002-02-09 00:00:00	2002-02-23	2002-02-23 00:00:00	32020		\N	317238	0	403190006	4296204		0
70191	4156	80180	1997-03-02	1997-03-02 00:00:00	\N	\N	32020		\N	276208	0	396275006	80180		0
80921	4800	81151	2005-11-29	2005-11-29 00:00:00	2005-12-27	2005-12-27 00:00:00	32020		\N	319297	0	44465007	81151		0
81305	4822	372328	1949-06-07	1949-06-07 00:00:00	1949-09-07	1949-09-07 00:00:00	32020		\N	320748	0	65363002	372328		0
81365	4826	40481087	2011-05-09	2011-05-09 00:00:00	2011-05-30	2011-05-30 00:00:00	32020		\N	320963	0	444814009	40481087		0
71026	4212	40481087	2014-05-05	2014-05-05 00:00:00	2014-05-26	2014-05-26 00:00:00	32020		\N	279655	0	444814009	40481087		0
71142	4220	4112343	1968-02-23	1968-02-23 00:00:00	1968-03-03	1968-03-03 00:00:00	32020		\N	280221	0	195662009	4112343		0
81856	4853	40481087	1985-07-03	1985-07-03 00:00:00	1985-07-10	1985-07-10 00:00:00	32020		\N	322869	0	444814009	40481087		0
71496	4240	4112343	1950-07-10	1950-07-10 00:00:00	1950-07-22	1950-07-22 00:00:00	32020		\N	281664	0	195662009	4112343		0
82224	4876	4112343	1997-08-13	1997-08-13 00:00:00	1997-08-24	1997-08-24 00:00:00	32020		\N	324288	0	195662009	4112343		0
71849	4261	313217	2010-01-24	2010-01-24 00:00:00	\N	\N	32020		\N	282955	0	49436004	313217		0
72026	4274	40481087	1967-08-02	1967-08-02 00:00:00	1967-08-16	1967-08-16 00:00:00	32020		\N	283553	0	444814009	40481087		0
72132	4279	4142905	2011-07-21	2011-07-21 00:00:00	2011-09-19	2011-09-19 00:00:00	32020		\N	284092	0	33737001	4142905		0
72299	4289	260139	2018-01-18	2018-01-18 00:00:00	2018-01-25	2018-01-25 00:00:00	32020		\N	284755	0	10509002	260139		0
83091	4935	260139	1970-10-24	1970-10-24 00:00:00	1970-11-07	1970-11-07 00:00:00	32020		\N	328034	0	10509002	260139		0
83218	4943	81151	1995-09-29	1995-09-29 00:00:00	1995-10-13	1995-10-13 00:00:00	32020		\N	328617	0	44465007	81151		0
72866	4330	4283893	1979-06-05	1979-06-05 00:00:00	1979-09-04	1979-09-04 00:00:00	32020		\N	287212	0	36971009	4283893		0
83729	4975	40481087	1985-04-22	1985-04-22 00:00:00	1985-05-06	1985-05-06 00:00:00	32020		\N	330881	0	444814009	40481087		0
83838	4979	40481087	1982-08-16	1982-08-16 00:00:00	1982-08-23	1982-08-23 00:00:00	32020		\N	331299	0	444814009	40481087		0
84119	4998	40481087	2008-12-14	2008-12-14 00:00:00	2008-12-28	2008-12-28 00:00:00	32020		\N	332384	0	444814009	40481087		0
73622	4375	372328	1929-01-30	1929-01-30 00:00:00	1929-06-16	1929-06-16 00:00:00	32020		\N	290680	0	65363002	372328		0
84395	5015	260139	1977-11-16	1977-11-16 00:00:00	1977-11-30	1977-11-30 00:00:00	32020		\N	333344	0	10509002	260139		0
84630	5034	260139	1923-01-08	1923-01-08 00:00:00	1923-01-22	1923-01-22 00:00:00	32020		\N	334432	0	10509002	260139		0
84725	5037	372328	1977-11-13	1977-11-13 00:00:00	1978-01-25	1978-01-25 00:00:00	32020		\N	334775	0	65363002	372328		0
84922	5049	81151	1999-07-07	1999-07-07 00:00:00	1999-07-28	1999-07-28 00:00:00	32020		\N	335587	0	44465007	81151		0
74507	4423	372328	1991-05-20	1991-05-20 00:00:00	1991-10-04	1991-10-04 00:00:00	32020		\N	294090	0	65363002	372328		0
74681	4435	81151	2018-11-11	2018-11-11 00:00:00	2018-12-09	2018-12-09 00:00:00	32020		\N	294784	0	44465007	81151		0
74710	4437	4112343	1999-06-07	1999-06-07 00:00:00	1999-06-14	1999-06-14 00:00:00	32020		\N	294886	0	195662009	4112343		0
74869	4448	40481087	2000-08-22	2000-08-22 00:00:00	2000-09-05	2000-09-05 00:00:00	32020		\N	295879	0	444814009	40481087		0
64528	3814	260139	1983-02-01	1983-02-01 00:00:00	1983-02-15	1983-02-15 00:00:00	32020		\N	253334	0	10509002	260139		0
75273	4471	40481087	1975-08-27	1975-08-27 00:00:00	1975-09-17	1975-09-17 00:00:00	32020		\N	297431	0	444814009	40481087		0
64804	3832	81151	1985-11-02	1985-11-02 00:00:00	1985-11-16	1985-11-16 00:00:00	32020		\N	254459	0	44465007	81151		0
75535	4482	40481087	1954-01-23	1954-01-23 00:00:00	1954-02-06	1954-02-06 00:00:00	32020		\N	298372	0	444814009	40481087		0
65195	3856	4112343	1989-06-02	1989-06-02 00:00:00	1989-06-09	1989-06-09 00:00:00	32020		\N	255891	0	195662009	4112343		0
65360	3865	4278672	1957-04-24	1957-04-24 00:00:00	1957-05-24	1957-05-24 00:00:00	32020		\N	256554	0	65966004	4278672		0
65557	3876	4112343	2001-07-18	2001-07-18 00:00:00	2001-07-27	2001-07-27 00:00:00	32020		\N	257442	0	195662009	4112343		0
76285	4526	28060	1954-12-17	1954-12-17 00:00:00	1954-12-28	1954-12-28 00:00:00	32020		\N	301328	0	43878008	28060		0
76447	4532	28060	1911-04-27	1911-04-27 00:00:00	1911-05-10	1911-05-10 00:00:00	32020		\N	301912	0	43878008	28060		0
66064	3906	260139	1955-07-17	1955-07-17 00:00:00	1955-07-24	1955-07-24 00:00:00	32020		\N	259671	0	10509002	260139		0
76717	4547	40481087	1948-02-04	1948-02-04 00:00:00	1948-02-11	1948-02-11 00:00:00	32020		\N	302844	0	444814009	40481087		0
76884	4557	4112343	1965-03-12	1965-03-12 00:00:00	1965-03-24	1965-03-24 00:00:00	32020		\N	303647	0	195662009	4112343		0
66514	3936	40481087	1989-02-26	1989-02-26 00:00:00	1989-03-19	1989-03-19 00:00:00	32020		\N	261607	0	444814009	40481087		0
77302	4578	40481087	1986-07-09	1986-07-09 00:00:00	1986-07-30	1986-07-30 00:00:00	32020		\N	304962	0	444814009	40481087		0
77422	4587	40481087	1942-05-23	1942-05-23 00:00:00	1942-05-30	1942-05-30 00:00:00	32020		\N	305569	0	444814009	40481087		0
77570	4595	4112343	1981-05-11	1981-05-11 00:00:00	1981-05-21	1981-05-21 00:00:00	32020		\N	306169	0	195662009	4112343		0
77702	4603	4112343	1990-05-17	1990-05-17 00:00:00	1990-05-26	1990-05-26 00:00:00	32020		\N	306653	0	195662009	4112343		0
88522	5262	81893	2008-06-22	2008-06-22 00:00:00	\N	\N	32020		\N	350140	0	64766004	81893		0
78042	4623	40481087	1979-06-19	1979-06-19 00:00:00	1979-07-10	1979-07-10 00:00:00	32020		\N	307930	0	444814009	40481087		0
67704	3998	4285898	1985-07-27	1985-07-27 00:00:00	\N	\N	32020		\N	265808	0	68496003	4285898		0
78356	4639	81151	1973-03-06	1973-03-06 00:00:00	1973-04-03	1973-04-03 00:00:00	32020		\N	309190	0	44465007	81151		0
78543	4649	260139	2004-05-11	2004-05-11 00:00:00	2004-05-18	2004-05-18 00:00:00	32020		\N	309977	0	10509002	260139		0
68201	4027	40481087	2011-06-18	2011-06-18 00:00:00	2011-07-09	2011-07-09 00:00:00	32020		\N	267855	0	444814009	40481087		0
78958	4675	260139	1960-06-02	1960-06-02 00:00:00	1960-06-16	1960-06-16 00:00:00	32020		\N	311547	0	10509002	260139		0
79032	4678	4112343	1956-01-25	1956-01-25 00:00:00	1956-02-06	1956-02-06 00:00:00	32020		\N	311761	0	195662009	4112343		0
79244	4691	40481087	1973-11-15	1973-11-15 00:00:00	1973-11-29	1973-11-29 00:00:00	32020		\N	312573	0	444814009	40481087		0
79440	4705	40481087	2013-10-27	2013-10-27 00:00:00	2013-11-10	2013-11-10 00:00:00	32020		\N	313470	0	444814009	40481087		0
68995	4084	4294548	1980-09-29	1980-09-29 00:00:00	1980-10-06	1980-10-06 00:00:00	32020		\N	271400	0	75498004	4294548		0
69207	4094	260139	1992-09-27	1992-09-27 00:00:00	1992-10-04	1992-10-04 00:00:00	32020		\N	272125	0	10509002	260139		0
79985	4739	4329847	1993-06-26	1993-06-26 00:00:00	\N	\N	32020		\N	315731	0	22298006	4329847		0
69440	4109	40481087	1977-05-20	1977-05-20 00:00:00	1977-05-27	1977-05-27 00:00:00	32020		\N	273103	0	444814009	40481087		0
69645	4121	4116491	1971-07-20	1971-07-20 00:00:00	1971-09-13	1971-09-13 00:00:00	32020		\N	273943	0	301011002	4116491		0
80413	4763	260139	2009-04-23	2009-04-23 00:00:00	2009-05-07	2009-05-07 00:00:00	32020		\N	317380	0	10509002	260139		0
70192	4156	4237458	1962-12-12	1962-12-12 00:00:00	1963-02-10	1963-02-10 00:00:00	32020		\N	276157	0	58150001	4237458		0
80922	4800	40481087	1990-08-25	1990-08-25 00:00:00	1990-09-01	1990-09-01 00:00:00	32020		\N	319323	0	444814009	40481087		0
81306	4822	372328	1952-04-02	1952-04-02 00:00:00	1952-09-10	1952-09-10 00:00:00	32020		\N	320718	0	65363002	372328		0
81366	4826	40481087	1997-08-16	1997-08-16 00:00:00	1997-08-23	1997-08-23 00:00:00	32020		\N	321032	0	444814009	40481087		0
71037	4214	28060	1990-03-08	1990-03-08 00:00:00	1990-03-20	1990-03-20 00:00:00	32020		\N	279759	0	43878008	28060		0
71143	4220	4237458	2012-08-10	2012-08-10 00:00:00	2012-11-08	2012-11-08 00:00:00	32020		\N	280153	0	58150001	4237458		0
81872	4855	4116491	2004-09-03	2004-09-03 00:00:00	2004-10-08	2004-10-08 00:00:00	32020		\N	323019	0	301011002	4116491		0
71497	4240	40481087	1975-07-22	1975-07-22 00:00:00	1975-08-12	1975-08-12 00:00:00	32020		\N	281676	0	444814009	40481087		0
82225	4876	40481087	2004-06-12	2004-06-12 00:00:00	2004-07-03	2004-07-03 00:00:00	32020		\N	324298	0	444814009	40481087		0
71850	4261	260139	1998-03-14	1998-03-14 00:00:00	1998-03-21	1998-03-21 00:00:00	32020		\N	282968	0	10509002	260139		0
72027	4274	372328	1986-03-02	1986-03-02 00:00:00	1987-01-02	1987-01-02 00:00:00	32020		\N	283624	0	65363002	372328		0
72133	4279	40481087	1977-02-19	1977-02-19 00:00:00	1977-03-05	1977-03-05 00:00:00	32020		\N	283963	0	444814009	40481087		0
72300	4289	40481087	1977-03-22	1977-03-22 00:00:00	1977-03-29	1977-03-29 00:00:00	32020		\N	284737	0	444814009	40481087		0
83092	4935	4112343	1973-03-03	1973-03-03 00:00:00	1973-03-13	1973-03-13 00:00:00	32020		\N	328035	0	195662009	4112343		0
83219	4943	40481087	1983-12-31	1983-12-31 00:00:00	1984-01-21	1984-01-21 00:00:00	32020		\N	328593	0	444814009	40481087		0
72867	4330	40481087	1975-12-27	1975-12-27 00:00:00	1976-01-17	1976-01-17 00:00:00	32020		\N	287182	0	444814009	40481087		0
83730	4975	4112343	1993-08-21	1993-08-21 00:00:00	1993-09-02	1993-09-02 00:00:00	32020		\N	330871	0	195662009	4112343		0
83839	4979	192671	2014-10-22	2014-10-22 00:00:00	\N	\N	32020		\N	331270	0	K92.2	35208414		0
84120	4998	260139	1967-02-27	1967-02-27 00:00:00	1967-03-13	1967-03-13 00:00:00	32020		\N	332326	0	10509002	260139		0
73623	4375	372328	1933-03-27	1933-03-27 00:00:00	1933-06-25	1933-06-25 00:00:00	32020		\N	290681	0	65363002	372328		0
84396	5015	4112343	1994-09-07	1994-09-07 00:00:00	1994-09-19	1994-09-19 00:00:00	32020		\N	333361	0	195662009	4112343		0
84631	5034	260139	1965-01-30	1965-01-30 00:00:00	1965-02-06	1965-02-06 00:00:00	32020		\N	334517	0	10509002	260139		0
84726	5037	260139	2002-04-08	2002-04-08 00:00:00	2002-04-15	2002-04-15 00:00:00	32020		\N	334711	0	10509002	260139		0
84923	5049	4059173	1970-07-18	1970-07-18 00:00:00	1970-10-16	1970-10-16 00:00:00	32020		\N	335584	0	16114001	4059173		0
74508	4423	372328	1977-07-12	1977-07-12 00:00:00	1977-07-26	1977-07-26 00:00:00	32020		\N	294110	0	65363002	372328		0
74682	4435	40481087	2018-09-03	2018-09-03 00:00:00	2018-09-10	2018-09-10 00:00:00	32020		\N	294807	0	444814009	40481087		0
74711	4437	4218389	2018-02-20	2018-02-20 00:00:00	2018-03-13	2018-03-13 00:00:00	32020		\N	294911	0	39848009	4218389		0
74870	4448	28060	1955-05-14	1955-05-14 00:00:00	1955-05-24	1955-05-24 00:00:00	32020		\N	295843	0	43878008	28060		0
64529	3814	4296204	1995-09-12	1995-09-12 00:00:00	1995-10-10	1995-10-10 00:00:00	32020		\N	253314	0	403190006	4296204		0
75274	4471	260139	1962-07-03	1962-07-03 00:00:00	1962-07-10	1962-07-10 00:00:00	32020		\N	297450	0	10509002	260139		0
64805	3832	40481087	1999-03-18	1999-03-18 00:00:00	1999-04-08	1999-04-08 00:00:00	32020		\N	254437	0	444814009	40481087		0
75536	4482	260139	1952-04-13	1952-04-13 00:00:00	1952-04-27	1952-04-27 00:00:00	32020		\N	298406	0	10509002	260139		0
65196	3857	4112343	1982-03-05	1982-03-05 00:00:00	1982-03-17	1982-03-17 00:00:00	32020		\N	255958	0	195662009	4112343		0
65361	3865	260139	1977-07-10	1977-07-10 00:00:00	1977-07-24	1977-07-24 00:00:00	32020		\N	256579	0	10509002	260139		0
65558	3876	4112343	1981-06-22	1981-06-22 00:00:00	1981-06-29	1981-06-29 00:00:00	32020		\N	257451	0	195662009	4112343		0
76286	4526	4294548	2006-05-22	2006-05-22 00:00:00	2006-07-31	2006-07-31 00:00:00	32020		\N	301332	0	75498004	4294548		0
76448	4532	81151	1974-06-10	1974-06-10 00:00:00	1974-06-24	1974-06-24 00:00:00	32020		\N	301892	0	44465007	81151		0
66065	3906	372328	1947-01-28	1947-01-28 00:00:00	1947-10-01	1947-10-01 00:00:00	32020		\N	259668	0	65363002	372328		0
76718	4547	4112343	1928-03-09	1928-03-09 00:00:00	1928-03-21	1928-03-21 00:00:00	32020		\N	302856	0	195662009	4112343		0
76885	4557	40481087	2013-01-26	2013-01-26 00:00:00	2013-02-16	2013-02-16 00:00:00	32020		\N	303581	0	444814009	40481087		0
66515	3936	40481087	1995-06-23	1995-06-23 00:00:00	1995-07-14	1995-07-14 00:00:00	32020		\N	261619	0	444814009	40481087		0
77303	4578	4310024	1998-08-14	1998-08-14 00:00:00	\N	\N	32020		\N	304984	0	424802006	4310024		0
77423	4587	4112343	1976-11-17	1976-11-17 00:00:00	1976-11-24	1976-11-24 00:00:00	32020		\N	305586	0	195662009	4112343		0
77571	4595	4146173	2010-05-09	2010-05-09 00:00:00	2010-06-08	2010-06-08 00:00:00	32020		\N	306172	0	307731004	4146173		0
77703	4603	40481087	1955-03-12	1955-03-12 00:00:00	1955-03-26	1955-03-26 00:00:00	32020		\N	306649	0	444814009	40481087		0
88523	5262	4152936	1973-08-20	1973-08-20 00:00:00	1973-09-03	1973-09-03 00:00:00	32020		\N	350073	0	283385000	4152936		0
78043	4623	260139	1986-08-26	1986-08-26 00:00:00	1986-09-09	1986-09-09 00:00:00	32020		\N	307931	0	10509002	260139		0
67705	3998	80180	1986-06-22	1986-06-22 00:00:00	\N	\N	32020		\N	265808	0	396275006	80180		0
78365	4641	4112343	2012-03-22	2012-03-22 00:00:00	2012-04-04	2012-04-04 00:00:00	32020		\N	309307	0	195662009	4112343		0
78544	4649	40481087	1982-05-10	1982-05-10 00:00:00	1982-05-31	1982-05-31 00:00:00	32020		\N	309993	0	444814009	40481087		0
68202	4027	4112343	2004-05-02	2004-05-02 00:00:00	2004-05-15	2004-05-15 00:00:00	32020		\N	267801	0	195662009	4112343		0
78959	4675	260139	1988-09-22	1988-09-22 00:00:00	1988-10-06	1988-10-06 00:00:00	32020		\N	311433	0	10509002	260139		0
79033	4678	81151	1957-08-13	1957-08-13 00:00:00	1957-09-03	1957-09-03 00:00:00	32020		\N	311726	0	44465007	81151		0
79245	4691	40481087	2015-08-14	2015-08-14 00:00:00	2015-09-04	2015-09-04 00:00:00	32020		\N	312589	0	444814009	40481087		0
79441	4705	260139	1973-03-14	1973-03-14 00:00:00	1973-03-28	1973-03-28 00:00:00	32020		\N	313484	0	10509002	260139		0
68996	4084	40481087	2011-08-11	2011-08-11 00:00:00	2011-09-01	2011-09-01 00:00:00	32020		\N	271406	0	444814009	40481087		0
69208	4094	28060	1957-10-15	1957-10-15 00:00:00	1957-10-24	1957-10-24 00:00:00	32020		\N	272113	0	43878008	28060		0
79987	4739	4112343	1920-08-16	1920-08-16 00:00:00	1920-08-29	1920-08-29 00:00:00	32020		\N	315681	0	195662009	4112343		0
69441	4109	81151	1978-09-19	1978-09-19 00:00:00	1978-10-10	1978-10-10 00:00:00	32020		\N	273073	0	44465007	81151		0
69646	4121	4056621	1971-07-20	1971-07-20 00:00:00	\N	\N	32020		\N	273943	0	197927001	4056621		0
80414	4763	40479768	1989-11-21	1989-11-21 00:00:00	1990-01-20	1990-01-20 00:00:00	32020		\N	317457	0	444470001	40479768		0
70193	4156	260139	1992-04-19	1992-04-19 00:00:00	1992-04-26	1992-04-26 00:00:00	32020		\N	276171	0	10509002	260139		0
80923	4800	4155034	1983-02-07	1983-02-07 00:00:00	1983-02-28	1983-02-28 00:00:00	32020		\N	319294	0	283371005	4155034		0
81307	4822	4113008	1967-08-29	1967-08-29 00:00:00	1967-09-12	1967-09-12 00:00:00	32020		\N	320726	0	284549007	4113008		0
81367	4826	4112343	1968-05-14	1968-05-14 00:00:00	1968-05-27	1968-05-27 00:00:00	32020		\N	320921	0	195662009	4112343		0
71038	4214	372328	1975-11-13	1975-11-13 00:00:00	1976-05-04	1976-05-04 00:00:00	32020		\N	279803	0	65363002	372328		0
71144	4220	40481087	2012-07-15	2012-07-15 00:00:00	2012-07-22	2012-07-22 00:00:00	32020		\N	280211	0	444814009	40481087		0
81873	4855	40481087	2014-03-07	2014-03-07 00:00:00	2014-03-21	2014-03-21 00:00:00	32020		\N	322997	0	444814009	40481087		0
71498	4240	40481087	2011-05-13	2011-05-13 00:00:00	2011-05-27	2011-05-27 00:00:00	32020		\N	281679	0	444814009	40481087		0
82226	4876	40481087	2012-01-12	2012-01-12 00:00:00	2012-01-19	2012-01-19 00:00:00	32020		\N	324300	0	444814009	40481087		0
71851	4261	40481087	1938-08-17	1938-08-17 00:00:00	1938-09-07	1938-09-07 00:00:00	32020		\N	282863	0	444814009	40481087		0
72028	4274	4116491	1949-11-19	1949-11-19 00:00:00	1950-01-07	1950-01-07 00:00:00	32020		\N	283665	0	301011002	4116491		0
76037	4509	81893	2005-09-13	2005-09-13 00:00:00	\N	\N	32020		\N	300398	0	64766004	81893		0
72150	4282	4112343	1997-11-06	1997-11-06 00:00:00	1997-11-15	1997-11-15 00:00:00	32020		\N	284198	0	195662009	4112343		0
72301	4289	4266809	1978-09-28	1978-09-28 00:00:00	\N	\N	32020		\N	284737	0	397881000	4266809		0
83093	4935	40481087	2003-11-05	2003-11-05 00:00:00	2003-11-19	2003-11-19 00:00:00	32020		\N	328125	0	444814009	40481087		0
83220	4943	4283893	1997-05-29	1997-05-29 00:00:00	1997-11-20	1997-11-20 00:00:00	32020		\N	328573	0	36971009	4283893		0
72868	4330	40481087	2013-08-15	2013-08-15 00:00:00	2013-09-05	2013-09-05 00:00:00	32020		\N	287241	0	444814009	40481087		0
83731	4975	260139	2001-11-25	2001-11-25 00:00:00	2001-12-02	2001-12-02 00:00:00	32020		\N	330883	0	10509002	260139		0
83840	4979	4294548	1976-09-27	1976-09-27 00:00:00	1976-10-11	1976-10-11 00:00:00	32020		\N	331290	0	75498004	4294548		0
84121	4998	4310024	2000-10-30	2000-10-30 00:00:00	\N	\N	32020		\N	332332	0	424802006	4310024		0
73624	4376	313217	1978-07-18	1978-07-18 00:00:00	\N	\N	32020		\N	290796	0	49436004	313217		0
84400	5017	81151	1983-10-23	1983-10-23 00:00:00	1983-11-13	1983-11-13 00:00:00	32020		\N	333453	0	44465007	81151		0
84632	5034	4156265	1967-04-07	1967-04-07 00:00:00	1967-04-28	1967-04-28 00:00:00	32020		\N	334460	0	370247008	4156265		0
84727	5037	4156265	1994-12-14	1994-12-14 00:00:00	1995-01-04	1995-01-04 00:00:00	32020		\N	334734	0	370247008	4156265		0
84940	5051	260139	1986-10-09	1986-10-09 00:00:00	1986-10-16	1986-10-16 00:00:00	32020		\N	335895	0	10509002	260139		0
74509	4423	40481087	1984-10-23	1984-10-23 00:00:00	1984-11-06	1984-11-06 00:00:00	32020		\N	294086	0	444814009	40481087		0
74683	4436	134438	1984-05-30	1984-05-30 00:00:00	1987-05-18	1987-05-18 00:00:00	32020		\N	294835	0	40275004	134438		0
74712	4437	40481087	1971-05-06	1971-05-06 00:00:00	1971-05-27	1971-05-27 00:00:00	32020		\N	294929	0	444814009	40481087		0
74871	4448	260139	1962-04-05	1962-04-05 00:00:00	1962-04-12	1962-04-12 00:00:00	32020		\N	295850	0	10509002	260139		0
64530	3814	40481087	1975-12-03	1975-12-03 00:00:00	1975-12-17	1975-12-17 00:00:00	32020		\N	253360	0	444814009	40481087		0
75275	4471	372328	1963-03-28	1963-03-28 00:00:00	1963-06-17	1963-06-17 00:00:00	32020		\N	297435	0	65363002	372328		0
64806	3832	40481087	2007-07-01	2007-07-01 00:00:00	2007-07-08	2007-07-08 00:00:00	32020		\N	254438	0	444814009	40481087		0
75537	4482	40481087	1991-02-22	1991-02-22 00:00:00	1991-03-15	1991-03-15 00:00:00	32020		\N	298386	0	444814009	40481087		0
65197	3857	4112343	1974-12-08	1974-12-08 00:00:00	1974-12-20	1974-12-20 00:00:00	32020		\N	255950	0	195662009	4112343		0
65362	3865	40479422	2004-11-13	2004-11-13 00:00:00	2004-12-20	2004-12-20 00:00:00	32020		\N	256557	0	444448004	40479422		0
65559	3876	40481087	2000-09-06	2000-09-06 00:00:00	2000-09-27	2000-09-27 00:00:00	32020		\N	257441	0	444814009	40481087		0
76287	4526	40481087	2011-09-02	2011-09-02 00:00:00	2011-09-16	2011-09-16 00:00:00	32020		\N	301324	0	444814009	40481087		0
76449	4532	40481087	1954-08-17	1954-08-17 00:00:00	1954-08-31	1954-08-31 00:00:00	32020		\N	301918	0	444814009	40481087		0
76555	4538	4283893	2014-01-31	2014-01-31 00:00:00	2014-05-02	2014-05-02 00:00:00	32020		\N	302312	0	36971009	4283893		0
76719	4547	4155034	1916-10-06	1916-10-06 00:00:00	1916-10-20	1916-10-20 00:00:00	32020		\N	302955	0	283371005	4155034		0
76886	4557	40481087	1983-09-20	1983-09-20 00:00:00	1983-09-27	1983-09-27 00:00:00	32020		\N	303576	0	444814009	40481087		0
66516	3936	28060	1968-11-23	1968-11-23 00:00:00	1968-12-02	1968-12-02 00:00:00	32020		\N	261605	0	43878008	28060		0
77304	4578	4112343	1985-10-22	1985-10-22 00:00:00	1985-11-01	1985-11-01 00:00:00	32020		\N	304920	0	195662009	4112343		0
77424	4587	4112343	1953-08-07	1953-08-07 00:00:00	1953-08-19	1953-08-19 00:00:00	32020		\N	305597	0	195662009	4112343		0
77572	4595	260139	1976-03-02	1976-03-02 00:00:00	1976-03-16	1976-03-16 00:00:00	32020		\N	306186	0	10509002	260139		0
77704	4603	4112343	1939-12-13	1939-12-13 00:00:00	1939-12-22	1939-12-22 00:00:00	32020		\N	306592	0	195662009	4112343		0
88524	5262	4112343	1981-08-27	1981-08-27 00:00:00	1981-09-05	1981-09-05 00:00:00	32020		\N	350084	0	195662009	4112343		0
78044	4623	40481087	1946-05-23	1946-05-23 00:00:00	1946-06-06	1946-06-06 00:00:00	32020		\N	307966	0	444814009	40481087		0
67706	3998	40481087	1998-04-16	1998-04-16 00:00:00	1998-04-23	1998-04-23 00:00:00	32020		\N	265775	0	444814009	40481087		0
78366	4641	40481087	2006-08-07	2006-08-07 00:00:00	2006-08-28	2006-08-28 00:00:00	32020		\N	309314	0	444814009	40481087		0
78545	4649	40481087	1996-05-26	1996-05-26 00:00:00	1996-06-09	1996-06-09 00:00:00	32020		\N	309995	0	444814009	40481087		0
68203	4027	28060	1976-08-25	1976-08-25 00:00:00	1976-09-03	1976-09-03 00:00:00	32020		\N	267868	0	43878008	28060		0
78960	4675	4112343	1968-01-01	1968-01-01 00:00:00	1968-01-11	1968-01-11 00:00:00	32020		\N	311430	0	195662009	4112343		0
79034	4678	40481087	1990-08-16	1990-08-16 00:00:00	1990-08-30	1990-08-30 00:00:00	32020		\N	311752	0	444814009	40481087		0
79246	4691	4134304	1978-12-29	1978-12-29 00:00:00	1979-01-28	1979-01-28 00:00:00	32020		\N	312598	0	263102004	4134304		0
79442	4705	260139	1983-01-09	1983-01-09 00:00:00	1983-01-23	1983-01-23 00:00:00	32020		\N	313490	0	10509002	260139		0
68997	4084	40481087	1962-06-25	1962-06-25 00:00:00	1962-07-16	1962-07-16 00:00:00	32020		\N	271368	0	444814009	40481087		0
69209	4094	440086	1965-09-10	1965-09-10 00:00:00	1975-09-18	1975-09-18 00:00:00	32020		\N	272130	0	192127007	440086		0
79988	4739	40481087	1912-08-20	1912-08-20 00:00:00	1912-09-03	1912-09-03 00:00:00	32020		\N	315698	0	444814009	40481087		0
69442	4109	4218389	1991-12-31	1991-12-31 00:00:00	1992-02-04	1992-02-04 00:00:00	32020		\N	273224	0	39848009	4218389		0
69647	4121	4112343	1921-01-16	1921-01-16 00:00:00	1921-01-23	1921-01-23 00:00:00	32020		\N	273953	0	195662009	4112343		0
80415	4763	80180	1990-04-24	1990-04-24 00:00:00	\N	\N	32020		\N	317457	0	396275006	80180		0
70194	4156	4112343	1957-06-23	1957-06-23 00:00:00	1957-07-05	1957-07-05 00:00:00	32020		\N	276176	0	195662009	4112343		0
80924	4800	81893	2007-08-17	2007-08-17 00:00:00	\N	\N	32020		\N	319352	0	64766004	81893		0
81308	4822	4156265	1951-08-04	1951-08-04 00:00:00	1951-08-25	1951-08-25 00:00:00	32020		\N	320722	0	370247008	4156265		0
81368	4826	4112343	2009-11-27	2009-11-27 00:00:00	2009-12-05	2009-12-05 00:00:00	32020		\N	321034	0	195662009	4112343		0
71039	4214	4112343	1986-07-11	1986-07-11 00:00:00	1986-07-23	1986-07-23 00:00:00	32020		\N	279774	0	195662009	4112343		0
71145	4220	372328	1947-05-22	1947-05-22 00:00:00	1947-12-16	1947-12-16 00:00:00	32020		\N	280230	0	65363002	372328		0
81874	4855	40481087	1986-02-13	1986-02-13 00:00:00	1986-02-27	1986-02-27 00:00:00	32020		\N	323052	0	444814009	40481087		0
71499	4240	260139	1981-05-26	1981-05-26 00:00:00	1981-06-09	1981-06-09 00:00:00	32020		\N	281627	0	10509002	260139		0
82227	4876	4035415	2018-01-19	2018-01-19 00:00:00	2018-03-20	2018-03-20 00:00:00	32020		\N	324304	0	239720000	4035415		0
71852	4261	4112343	1932-10-28	1932-10-28 00:00:00	1932-11-06	1932-11-06 00:00:00	32020		\N	282856	0	195662009	4112343		0
72029	4274	4112343	1983-04-13	1983-04-13 00:00:00	1983-04-20	1983-04-20 00:00:00	32020		\N	283637	0	195662009	4112343		0
72151	4282	40481087	2015-04-14	2015-04-14 00:00:00	2015-04-28	2015-04-28 00:00:00	32020		\N	284170	0	444814009	40481087		0
72302	4289	80180	1978-09-28	1978-09-28 00:00:00	\N	\N	32020		\N	284737	0	396275006	80180		0
83094	4935	40481087	1983-02-01	1983-02-01 00:00:00	1983-02-08	1983-02-08 00:00:00	32020		\N	328073	0	444814009	40481087		0
83221	4943	260139	1969-10-18	1969-10-18 00:00:00	1969-10-25	1969-10-25 00:00:00	32020		\N	328536	0	10509002	260139		0
72869	4330	260139	1959-06-13	1959-06-13 00:00:00	1959-06-27	1959-06-27 00:00:00	32020		\N	287267	0	10509002	260139		0
83732	4975	372328	1960-02-04	1960-02-04 00:00:00	1960-03-17	1960-03-17 00:00:00	32020		\N	330872	0	65363002	372328		0
83841	4979	80180	2014-08-28	2014-08-28 00:00:00	\N	\N	32020		\N	331279	0	396275006	80180		0
84122	4998	40481087	2000-10-13	2000-10-13 00:00:00	2000-10-27	2000-10-27 00:00:00	32020		\N	332332	0	444814009	40481087		0
73625	4376	40481087	2010-07-02	2010-07-02 00:00:00	2010-07-23	2010-07-23 00:00:00	32020		\N	290741	0	444814009	40481087		0
84401	5017	260139	1996-09-16	1996-09-16 00:00:00	1996-09-23	1996-09-23 00:00:00	32020		\N	333438	0	10509002	260139		0
84633	5034	4112343	1970-08-28	1970-08-28 00:00:00	1970-09-06	1970-09-06 00:00:00	32020		\N	334530	0	195662009	4112343		0
84728	5037	40481087	2007-03-15	2007-03-15 00:00:00	2007-04-05	2007-04-05 00:00:00	32020		\N	334712	0	444814009	40481087		0
84941	5051	81151	1987-12-02	1987-12-02 00:00:00	1987-12-23	1987-12-23 00:00:00	32020		\N	335905	0	44465007	81151		0
74510	4423	40481087	1996-10-04	1996-10-04 00:00:00	1996-10-11	1996-10-11 00:00:00	32020		\N	294092	0	444814009	40481087		0
74684	4436	4156265	2007-08-30	2007-08-30 00:00:00	2007-09-13	2007-09-13 00:00:00	32020		\N	294882	0	370247008	4156265		0
74713	4437	28060	1976-10-01	1976-10-01 00:00:00	1976-10-08	1976-10-08 00:00:00	32020		\N	294941	0	43878008	28060		0
74872	4448	4218389	1978-05-09	1978-05-09 00:00:00	1978-06-06	1978-06-06 00:00:00	32020		\N	295897	0	39848009	4218389		0
64531	3814	28060	1987-12-08	1987-12-08 00:00:00	1987-12-17	1987-12-17 00:00:00	32020		\N	253335	0	43878008	28060		0
75276	4471	28060	1975-04-27	1975-04-27 00:00:00	1975-05-09	1975-05-09 00:00:00	32020		\N	297429	0	43878008	28060		0
64807	3832	40481087	2011-10-22	2011-10-22 00:00:00	2011-11-05	2011-11-05 00:00:00	32020		\N	254417	0	444814009	40481087		0
75541	4484	4112343	1963-09-21	1963-09-21 00:00:00	1963-09-28	1963-09-28 00:00:00	32020		\N	298444	0	195662009	4112343		0
65198	3857	257012	1948-07-30	1948-07-30 00:00:00	\N	\N	32020		\N	255955	0	40055000	257012		0
65363	3865	40481087	1964-06-21	1964-06-21 00:00:00	1964-06-28	1964-06-28 00:00:00	32020		\N	256660	0	444814009	40481087		0
65560	3876	4112343	2006-04-05	2006-04-05 00:00:00	2006-04-13	2006-04-13 00:00:00	32020		\N	257443	0	195662009	4112343		0
76288	4526	80180	1993-01-17	1993-01-17 00:00:00	\N	\N	32020		\N	301392	0	396275006	80180		0
76450	4532	40481087	1969-11-28	1969-11-28 00:00:00	1969-12-12	1969-12-12 00:00:00	32020		\N	301845	0	444814009	40481087		0
76556	4538	40481087	1961-08-04	1961-08-04 00:00:00	1961-08-11	1961-08-11 00:00:00	32020		\N	302332	0	444814009	40481087		0
76720	4547	40481087	1955-12-06	1955-12-06 00:00:00	1955-12-20	1955-12-20 00:00:00	32020		\N	302966	0	444814009	40481087		0
76887	4557	4112343	1934-11-16	1934-11-16 00:00:00	1934-11-23	1934-11-23 00:00:00	32020		\N	303572	0	195662009	4112343		0
66517	3936	4112343	1959-06-04	1959-06-04 00:00:00	1959-06-13	1959-06-13 00:00:00	32020		\N	261638	0	195662009	4112343		0
77305	4578	40481087	1980-03-03	1980-03-03 00:00:00	1980-03-10	1980-03-10 00:00:00	32020		\N	304978	0	444814009	40481087		0
77425	4587	4134304	2018-04-25	2018-04-25 00:00:00	2018-06-24	2018-06-24 00:00:00	32020		\N	305571	0	263102004	4134304		0
77573	4595	4152936	2017-01-31	2017-01-31 00:00:00	2017-02-14	2017-02-14 00:00:00	32020		\N	306180	0	283385000	4152936		0
77705	4603	40481087	1993-05-16	1993-05-16 00:00:00	1993-05-30	1993-05-30 00:00:00	32020		\N	306664	0	444814009	40481087		0
88525	5262	40481087	1982-11-19	1982-11-19 00:00:00	1982-12-03	1982-12-03 00:00:00	32020		\N	350110	0	444814009	40481087		0
78045	4623	40481087	1985-05-16	1985-05-16 00:00:00	1985-05-23	1985-05-23 00:00:00	32020		\N	307899	0	444814009	40481087		0
67707	3998	40481087	1959-04-15	1959-04-15 00:00:00	1959-05-06	1959-05-06 00:00:00	32020		\N	265844	0	444814009	40481087		0
78367	4641	261325	1998-09-03	1998-09-03 00:00:00	\N	\N	32020		\N	309349	0	87433001	261325		0
78557	4653	80180	2002-10-29	2002-10-29 00:00:00	\N	\N	32020		\N	310142	0	396275006	80180		0
68204	4027	4283893	1996-02-10	1996-02-10 00:00:00	1996-05-18	1996-05-18 00:00:00	32020		\N	267790	0	36971009	4283893		0
78961	4675	260139	1969-03-23	1969-03-23 00:00:00	1969-04-06	1969-04-06 00:00:00	32020		\N	311548	0	10509002	260139		0
79035	4678	80180	1991-01-02	1991-01-02 00:00:00	\N	\N	32020		\N	311752	0	396275006	80180		0
79247	4691	28060	1967-04-03	1967-04-03 00:00:00	1967-04-12	1967-04-12 00:00:00	32020		\N	312574	0	43878008	28060		0
79443	4705	40481087	1994-03-22	1994-03-22 00:00:00	1994-03-29	1994-03-29 00:00:00	32020		\N	313491	0	444814009	40481087		0
68998	4084	80180	1996-11-29	1996-11-29 00:00:00	\N	\N	32020		\N	271430	0	396275006	80180		0
69210	4094	40481087	2010-06-01	2010-06-01 00:00:00	2010-06-22	2010-06-22 00:00:00	32020		\N	272176	0	444814009	40481087		0
79989	4739	260139	1930-10-13	1930-10-13 00:00:00	1930-10-27	1930-10-27 00:00:00	32020		\N	315739	0	10509002	260139		0
69443	4109	4112343	1982-04-16	1982-04-16 00:00:00	1982-04-28	1982-04-28 00:00:00	32020		\N	273056	0	195662009	4112343		0
69648	4121	4059173	1952-05-24	1952-05-24 00:00:00	1952-07-23	1952-07-23 00:00:00	32020		\N	273931	0	16114001	4059173		0
80416	4763	4112343	2005-04-29	2005-04-29 00:00:00	2005-05-06	2005-05-06 00:00:00	32020		\N	317407	0	195662009	4112343		0
70195	4156	40481087	1965-07-15	1965-07-15 00:00:00	1965-08-05	1965-08-05 00:00:00	32020		\N	276215	0	444814009	40481087		0
80925	4800	40481087	1987-11-08	1987-11-08 00:00:00	1987-11-29	1987-11-29 00:00:00	32020		\N	319330	0	444814009	40481087		0
81309	4822	4156265	1966-08-20	1966-08-20 00:00:00	1966-09-03	1966-09-03 00:00:00	32020		\N	320724	0	370247008	4156265		0
81369	4826	4294548	1985-02-24	1985-02-24 00:00:00	1985-03-31	1985-03-31 00:00:00	32020		\N	320922	0	75498004	4294548		0
71040	4214	375671	1991-02-22	1991-02-22 00:00:00	1991-03-24	1991-03-24 00:00:00	32020		\N	279786	0	62564004	375671		0
71146	4220	40481087	1961-06-04	1961-06-04 00:00:00	1961-06-25	1961-06-25 00:00:00	32020		\N	280219	0	444814009	40481087		0
81875	4855	40481087	2017-03-10	2017-03-10 00:00:00	2017-03-31	2017-03-31 00:00:00	32020		\N	322998	0	444814009	40481087		0
71500	4240	40481087	1958-12-27	1958-12-27 00:00:00	1959-01-10	1959-01-10 00:00:00	32020		\N	281625	0	444814009	40481087		0
82228	4876	40481087	1988-01-20	1988-01-20 00:00:00	1988-02-03	1988-02-03 00:00:00	32020		\N	324264	0	444814009	40481087		0
71853	4261	40481087	1980-03-16	1980-03-16 00:00:00	1980-03-23	1980-03-23 00:00:00	32020		\N	282965	0	444814009	40481087		0
72030	4274	40481087	1984-03-16	1984-03-16 00:00:00	1984-03-23	1984-03-23 00:00:00	32020		\N	283639	0	444814009	40481087		0
72152	4282	40481087	1998-07-26	1998-07-26 00:00:00	1998-08-02	1998-08-02 00:00:00	32020		\N	284161	0	444814009	40481087		0
72303	4289	4285898	1977-11-02	1977-11-02 00:00:00	\N	\N	32020		\N	284737	0	68496003	4285898		0
83095	4935	195588	1996-09-16	1996-09-16 00:00:00	1996-11-04	1996-11-04 00:00:00	32020		\N	328124	0	38822007	195588		0
83222	4943	40481087	2000-07-15	2000-07-15 00:00:00	2000-08-05	2000-08-05 00:00:00	32020		\N	328543	0	444814009	40481087		0
72870	4330	4310024	1984-11-07	1984-11-07 00:00:00	\N	\N	32020		\N	287177	0	424802006	4310024		0
83733	4975	81151	1999-01-01	1999-01-01 00:00:00	1999-01-29	1999-01-29 00:00:00	32020		\N	330918	0	44465007	81151		0
83842	4979	28060	1986-04-05	1986-04-05 00:00:00	1986-04-14	1986-04-14 00:00:00	32020		\N	331249	0	43878008	28060		0
84123	4998	372328	1966-03-03	1966-03-03 00:00:00	1966-03-17	1966-03-17 00:00:00	32020		\N	332356	0	65363002	372328		0
73626	4376	40481087	1963-11-07	1963-11-07 00:00:00	1963-11-21	1963-11-21 00:00:00	32020		\N	290763	0	444814009	40481087		0
84402	5017	28060	1981-11-05	1981-11-05 00:00:00	1981-11-15	1981-11-15 00:00:00	32020		\N	333446	0	43878008	28060		0
84634	5034	4112343	1969-04-24	1969-04-24 00:00:00	1969-05-02	1969-05-02 00:00:00	32020		\N	334529	0	195662009	4112343		0
84729	5037	4112343	1982-10-22	1982-10-22 00:00:00	1982-11-02	1982-11-02 00:00:00	32020		\N	334736	0	195662009	4112343		0
84942	5051	40481087	1997-08-06	1997-08-06 00:00:00	1997-08-20	1997-08-20 00:00:00	32020		\N	335837	0	444814009	40481087		0
74511	4423	4112343	2013-06-20	2013-06-20 00:00:00	2013-07-02	2013-07-02 00:00:00	32020		\N	294100	0	195662009	4112343		0
74685	4436	80180	2008-06-01	2008-06-01 00:00:00	\N	\N	32020		\N	294882	0	396275006	80180		0
74714	4437	28060	1984-03-15	1984-03-15 00:00:00	1984-03-25	1984-03-25 00:00:00	32020		\N	294942	0	43878008	28060		0
74873	4448	4112343	1965-03-17	1965-03-17 00:00:00	1965-03-29	1965-03-29 00:00:00	32020		\N	295852	0	195662009	4112343		0
64532	3814	372328	1976-07-23	1976-07-23 00:00:00	1976-11-07	1976-11-07 00:00:00	32020		\N	253356	0	65363002	372328		0
75277	4471	40481087	1973-06-10	1973-06-10 00:00:00	1973-06-17	1973-06-17 00:00:00	32020		\N	297445	0	444814009	40481087		0
64808	3832	40481087	1996-09-01	1996-09-01 00:00:00	1996-09-22	1996-09-22 00:00:00	32020		\N	254469	0	444814009	40481087		0
75542	4484	4112343	1989-04-13	1989-04-13 00:00:00	1989-04-21	1989-04-21 00:00:00	32020		\N	298475	0	195662009	4112343		0
65199	3857	40481087	1996-10-07	1996-10-07 00:00:00	1996-10-14	1996-10-14 00:00:00	32020		\N	255961	0	444814009	40481087		0
65364	3865	40481087	1982-12-14	1982-12-14 00:00:00	1982-12-28	1982-12-28 00:00:00	32020		\N	256643	0	444814009	40481087		0
65561	3876	4294548	1979-08-21	1979-08-21 00:00:00	1979-09-18	1979-09-18 00:00:00	32020		\N	257493	0	75498004	4294548		0
76289	4526	40481087	1954-09-11	1954-09-11 00:00:00	1954-09-18	1954-09-18 00:00:00	32020		\N	301327	0	444814009	40481087		0
76451	4532	40481087	1928-10-14	1928-10-14 00:00:00	1928-11-04	1928-11-04 00:00:00	32020		\N	301905	0	444814009	40481087		0
76557	4538	4112343	2013-04-22	2013-04-22 00:00:00	2013-05-03	2013-05-03 00:00:00	32020		\N	302393	0	195662009	4112343		0
76721	4547	78272	1983-03-13	1983-03-13 00:00:00	1983-04-03	1983-04-03 00:00:00	32020		\N	302960	0	70704007	78272		0
76888	4557	4112343	1960-02-24	1960-02-24 00:00:00	1960-03-04	1960-03-04 00:00:00	32020		\N	303654	0	195662009	4112343		0
66518	3936	4112343	2000-12-18	2000-12-18 00:00:00	2000-12-29	2000-12-29 00:00:00	32020		\N	261620	0	195662009	4112343		0
77306	4578	40481087	1982-01-05	1982-01-05 00:00:00	1982-01-26	1982-01-26 00:00:00	32020		\N	304946	0	444814009	40481087		0
77426	4587	40481087	1991-01-16	1991-01-16 00:00:00	1991-02-06	1991-02-06 00:00:00	32020		\N	305588	0	444814009	40481087		0
77574	4595	372328	1965-03-28	1965-03-28 00:00:00	1965-06-18	1965-06-18 00:00:00	32020		\N	306173	0	65363002	372328		0
77706	4603	4112343	1996-09-24	1996-09-24 00:00:00	1996-10-03	1996-10-03 00:00:00	32020		\N	306658	0	195662009	4112343		0
88526	5262	4112343	1977-12-01	1977-12-01 00:00:00	1977-12-12	1977-12-12 00:00:00	32020		\N	350100	0	195662009	4112343		0
78046	4623	260139	1937-11-30	1937-11-30 00:00:00	1937-12-14	1937-12-14 00:00:00	32020		\N	308006	0	10509002	260139		0
67708	3998	40481087	1991-05-25	1991-05-25 00:00:00	1991-06-15	1991-06-15 00:00:00	32020		\N	265859	0	444814009	40481087		0
78368	4641	80180	2004-10-21	2004-10-21 00:00:00	\N	\N	32020		\N	309351	0	396275006	80180		0
78558	4653	372328	2002-06-17	2002-06-17 00:00:00	2003-03-09	2003-03-09 00:00:00	32020		\N	310142	0	65363002	372328		0
68205	4027	4112343	1991-05-31	1991-05-31 00:00:00	1991-06-08	1991-06-08 00:00:00	32020		\N	267839	0	195662009	4112343		0
78962	4675	81151	1941-01-09	1941-01-09 00:00:00	1941-02-06	1941-02-06 00:00:00	32020		\N	311503	0	44465007	81151		0
79036	4678	4152936	1982-09-22	1982-09-22 00:00:00	1982-10-06	1982-10-06 00:00:00	32020		\N	311727	0	283385000	4152936		0
79248	4691	4059173	1962-03-28	1962-03-28 00:00:00	1962-06-26	1962-06-26 00:00:00	32020		\N	312596	0	16114001	4059173		0
79444	4705	40481087	1980-01-12	1980-01-12 00:00:00	1980-02-02	1980-02-02 00:00:00	32020		\N	313467	0	444814009	40481087		0
68999	4084	4112343	1972-02-10	1972-02-10 00:00:00	1972-02-22	1972-02-22 00:00:00	32020		\N	271398	0	195662009	4112343		0
69211	4094	260139	1974-09-08	1974-09-08 00:00:00	1974-09-22	1974-09-22 00:00:00	32020		\N	272123	0	10509002	260139		0
79990	4739	40481087	1924-08-03	1924-08-03 00:00:00	1924-08-17	1924-08-17 00:00:00	32020		\N	315738	0	444814009	40481087		0
69444	4109	4051466	1967-12-08	1967-12-08 00:00:00	1984-03-15	1984-03-15 00:00:00	32020		\N	273154	0	233678006	4051466		0
69649	4121	4112343	1952-02-23	1952-02-23 00:00:00	1952-03-06	1952-03-06 00:00:00	32020		\N	273976	0	195662009	4112343		0
80417	4763	4112343	2005-02-12	2005-02-12 00:00:00	2005-02-24	2005-02-24 00:00:00	32020		\N	317431	0	195662009	4112343		0
80677	4784	28060	2004-02-08	2004-02-08 00:00:00	2004-02-19	2004-02-19 00:00:00	32020		\N	318482	0	43878008	28060		0
80926	4800	4134304	1985-10-16	1985-10-16 00:00:00	1985-11-14	1985-11-14 00:00:00	32020		\N	319295	0	263102004	4134304		0
81310	4822	372328	1951-04-06	1951-04-06 00:00:00	1951-09-05	1951-09-05 00:00:00	32020		\N	320749	0	65363002	372328		0
81370	4826	80180	1986-04-16	1986-04-16 00:00:00	\N	\N	32020		\N	320922	0	396275006	80180		0
71041	4214	260139	2005-03-09	2005-03-09 00:00:00	2005-03-16	2005-03-16 00:00:00	32020		\N	279795	0	10509002	260139		0
71147	4220	4112343	1972-11-10	1972-11-10 00:00:00	1972-11-23	1972-11-23 00:00:00	32020		\N	280222	0	195662009	4112343		0
81876	4855	81151	2018-08-06	2018-08-06 00:00:00	2018-08-20	2018-08-20 00:00:00	32020		\N	323055	0	44465007	81151		0
71501	4240	4112343	1948-06-10	1948-06-10 00:00:00	1948-06-19	1948-06-19 00:00:00	32020		\N	281669	0	195662009	4112343		0
82229	4876	40481087	1986-10-12	1986-10-12 00:00:00	1986-10-19	1986-10-19 00:00:00	32020		\N	324286	0	444814009	40481087		0
82337	4884	40481087	2008-04-02	2008-04-02 00:00:00	2008-04-09	2008-04-09 00:00:00	32020		\N	324757	0	444814009	40481087		0
72031	4274	260139	1938-04-27	1938-04-27 00:00:00	1938-05-11	1938-05-11 00:00:00	32020		\N	283633	0	10509002	260139		0
72153	4282	372328	1983-12-24	1983-12-24 00:00:00	1984-10-24	1984-10-24 00:00:00	32020		\N	284171	0	65363002	372328		0
72304	4289	4109685	1965-03-25	1965-03-25 00:00:00	1965-04-08	1965-04-08 00:00:00	32020		\N	284741	0	284551006	4109685		0
83096	4935	134438	1985-09-26	1985-09-26 00:00:00	1986-11-21	1986-11-21 00:00:00	32020		\N	328024	0	40275004	134438		0
83223	4943	4218389	1964-10-13	1964-10-13 00:00:00	1964-11-03	1964-11-03 00:00:00	32020		\N	328619	0	39848009	4218389		0
72871	4330	4027663	1978-12-14	1978-12-14 00:00:00	\N	\N	32020		\N	287238	0	13200003	4027663		0
83734	4975	372328	1961-05-12	1961-05-12 00:00:00	1961-06-15	1961-06-15 00:00:00	32020		\N	330873	0	65363002	372328		0
83843	4979	4112343	1995-07-27	1995-07-27 00:00:00	1995-08-05	1995-08-05 00:00:00	32020		\N	331300	0	195662009	4112343		0
84124	4998	4048171	1968-10-15	1968-10-15 00:00:00	\N	\N	32020		\N	332403	0	232353008	4048171		0
73627	4376	40481087	1988-01-29	1988-01-29 00:00:00	1988-02-12	1988-02-12 00:00:00	32020		\N	290721	0	444814009	40481087		0
84403	5017	260139	2011-10-15	2011-10-15 00:00:00	2011-10-29	2011-10-29 00:00:00	32020		\N	333440	0	10509002	260139		0
84635	5034	4329847	1993-11-13	1993-11-13 00:00:00	\N	\N	32020		\N	334462	0	22298006	4329847		0
84730	5037	260139	2014-08-03	2014-08-03 00:00:00	2014-08-17	2014-08-17 00:00:00	32020		\N	334774	0	10509002	260139		0
84943	5051	4310024	2011-08-13	2011-08-13 00:00:00	\N	\N	32020		\N	335948	0	424802006	4310024		0
85002	5056	260139	1989-10-05	1989-10-05 00:00:00	1989-10-19	1989-10-19 00:00:00	32020		\N	336131	0	10509002	260139		0
74686	4436	4266809	2008-06-01	2008-06-01 00:00:00	\N	\N	32020		\N	294882	0	397881000	4266809		0
74715	4437	30753	2009-06-22	2009-06-22 00:00:00	\N	\N	32020		\N	294909	0	16761005	30753		0
74874	4448	40481087	2018-03-23	2018-03-23 00:00:00	2018-04-13	2018-04-13 00:00:00	32020		\N	295858	0	444814009	40481087		0
64533	3814	40481087	1999-09-26	1999-09-26 00:00:00	1999-10-17	1999-10-17 00:00:00	32020		\N	253316	0	444814009	40481087		0
75278	4471	40481087	1986-04-24	1986-04-24 00:00:00	1986-05-15	1986-05-15 00:00:00	32020		\N	297447	0	444814009	40481087		0
64809	3832	40481087	2009-05-06	2009-05-06 00:00:00	2009-05-13	2009-05-13 00:00:00	32020		\N	254439	0	444814009	40481087		0
75543	4484	4112343	1992-09-05	1992-09-05 00:00:00	1992-09-18	1992-09-18 00:00:00	32020		\N	298462	0	195662009	4112343		0
65200	3857	4112343	2002-01-18	2002-01-18 00:00:00	2002-01-26	2002-01-26 00:00:00	32020		\N	255983	0	195662009	4112343		0
65365	3865	260139	2009-08-06	2009-08-06 00:00:00	2009-08-13	2009-08-13 00:00:00	32020		\N	256677	0	10509002	260139		0
65562	3876	28060	1977-05-03	1977-05-03 00:00:00	1977-05-12	1977-05-12 00:00:00	32020		\N	257432	0	43878008	28060		0
76290	4526	28060	1954-08-07	1954-08-07 00:00:00	1954-08-17	1954-08-17 00:00:00	32020		\N	301326	0	43878008	28060		0
76452	4532	4112343	1955-02-25	1955-02-25 00:00:00	1955-03-09	1955-03-09 00:00:00	32020		\N	301907	0	195662009	4112343		0
76558	4538	40479422	1972-10-02	1972-10-02 00:00:00	1972-11-08	1972-11-08 00:00:00	32020		\N	302314	0	444448004	40479422		0
76722	4547	40481087	1936-01-02	1936-01-02 00:00:00	1936-01-23	1936-01-23 00:00:00	32020		\N	302932	0	444814009	40481087		0
76889	4557	4156265	1968-01-31	1968-01-31 00:00:00	1968-02-21	1968-02-21 00:00:00	32020		\N	303640	0	370247008	4156265		0
66519	3936	4112343	1987-10-17	1987-10-17 00:00:00	1987-10-25	1987-10-25 00:00:00	32020		\N	261606	0	195662009	4112343		0
77307	4578	260139	2008-08-25	2008-08-25 00:00:00	2008-09-08	2008-09-08 00:00:00	32020		\N	304967	0	10509002	260139		0
77427	4587	40481087	2012-07-18	2012-07-18 00:00:00	2012-08-08	2012-08-08 00:00:00	32020		\N	305629	0	444814009	40481087		0
77575	4595	4112343	2016-01-28	2016-01-28 00:00:00	2016-02-10	2016-02-10 00:00:00	32020		\N	306189	0	195662009	4112343		0
77707	4603	80502	2010-10-28	2010-10-28 00:00:00	\N	\N	32020		\N	306633	0	64859006	80502		0
88527	5262	4294548	2003-06-06	2003-06-06 00:00:00	2003-06-27	2003-06-27 00:00:00	32020		\N	350103	0	75498004	4294548		0
78056	4625	40481087	2006-11-23	2006-11-23 00:00:00	2006-11-30	2006-11-30 00:00:00	32020		\N	308107	0	444814009	40481087		0
67709	3998	78272	1978-10-25	1978-10-25 00:00:00	1978-11-08	1978-11-08 00:00:00	32020		\N	265791	0	70704007	78272		0
78369	4641	40481087	1999-06-02	1999-06-02 00:00:00	1999-06-09	1999-06-09 00:00:00	32020		\N	309287	0	444814009	40481087		0
78559	4653	40481087	1972-09-17	1972-09-17 00:00:00	1972-10-08	1972-10-08 00:00:00	32020		\N	310180	0	444814009	40481087		0
68206	4027	372328	1976-06-07	1976-06-07 00:00:00	1976-10-09	1976-10-09 00:00:00	32020		\N	267875	0	65363002	372328		0
78963	4675	40481087	1919-04-28	1919-04-28 00:00:00	1919-05-12	1919-05-12 00:00:00	32020		\N	311566	0	444814009	40481087		0
79037	4678	40481087	1964-03-12	1964-03-12 00:00:00	1964-03-19	1964-03-19 00:00:00	32020		\N	311763	0	444814009	40481087		0
79249	4691	80180	2002-01-12	2002-01-12 00:00:00	\N	\N	32020		\N	312593	0	396275006	80180		0
79445	4705	40481087	1982-07-30	1982-07-30 00:00:00	1982-08-20	1982-08-20 00:00:00	32020		\N	313486	0	444814009	40481087		0
69000	4084	260139	1971-08-29	1971-08-29 00:00:00	1971-09-12	1971-09-12 00:00:00	32020		\N	271419	0	10509002	260139		0
69212	4094	260139	1958-09-09	1958-09-09 00:00:00	1958-09-23	1958-09-23 00:00:00	32020		\N	272138	0	10509002	260139		0
79991	4739	4084167	1922-02-25	1922-02-25 00:00:00	1922-02-25	1922-02-25 00:00:00	32020		\N	315725	0	241929008	4084167		0
69445	4109	192671	2002-03-25	2002-03-25 00:00:00	\N	\N	32020		\N	273074	0	K92.2	35208414		0
69650	4121	4299128	1948-05-17	1948-05-17 00:00:00	1948-06-14	1948-06-14 00:00:00	32020		\N	273930	0	403192003	4299128		0
80418	4763	372328	1953-01-08	1953-01-08 00:00:00	1953-01-22	1953-01-22 00:00:00	32020		\N	317408	0	65363002	372328		0
80678	4784	28060	1963-03-23	1963-03-23 00:00:00	1963-03-31	1963-03-31 00:00:00	32020		\N	318418	0	43878008	28060		0
80927	4800	260139	2007-11-14	2007-11-14 00:00:00	2007-11-21	2007-11-21 00:00:00	32020		\N	319324	0	10509002	260139		0
81311	4822	4294548	1956-02-18	1956-02-18 00:00:00	1956-03-31	1956-03-31 00:00:00	32020		\N	320709	0	75498004	4294548		0
81371	4826	40481087	1954-03-03	1954-03-03 00:00:00	1954-03-17	1954-03-17 00:00:00	32020		\N	320920	0	444814009	40481087		0
71042	4214	80180	2005-07-13	2005-07-13 00:00:00	\N	\N	32020		\N	279795	0	396275006	80180		0
71148	4220	40481087	2009-03-15	2009-03-15 00:00:00	2009-04-05	2009-04-05 00:00:00	32020		\N	280210	0	444814009	40481087		0
81877	4855	4142905	1987-02-20	1987-02-20 00:00:00	1987-03-22	1987-03-22 00:00:00	32020		\N	323022	0	33737001	4142905		0
71502	4240	4112343	2011-12-20	2011-12-20 00:00:00	2012-01-02	2012-01-02 00:00:00	32020		\N	281637	0	195662009	4112343		0
82230	4876	372328	1987-12-28	1987-12-28 00:00:00	1988-01-30	1988-01-30 00:00:00	32020		\N	324265	0	65363002	372328		0
82338	4884	4112343	2013-03-21	2013-03-21 00:00:00	2013-04-01	2013-04-01 00:00:00	32020		\N	324751	0	195662009	4112343		0
72032	4274	260139	1999-07-31	1999-07-31 00:00:00	1999-08-14	1999-08-14 00:00:00	32020		\N	283623	0	10509002	260139		0
72154	4282	40481087	1985-09-30	1985-09-30 00:00:00	1985-10-07	1985-10-07 00:00:00	32020		\N	284197	0	444814009	40481087		0
72305	4289	28060	1944-11-07	1944-11-07 00:00:00	1944-11-19	1944-11-19 00:00:00	32020		\N	284762	0	43878008	28060		0
83097	4935	372328	1969-01-01	1969-01-01 00:00:00	1969-09-04	1969-09-04 00:00:00	32020		\N	328040	0	65363002	372328		0
83224	4943	40481087	1976-02-22	1976-02-22 00:00:00	1976-03-07	1976-03-07 00:00:00	32020		\N	328592	0	444814009	40481087		0
72872	4330	40481087	1978-04-12	1978-04-12 00:00:00	1978-05-03	1978-05-03 00:00:00	32020		\N	287238	0	444814009	40481087		0
83735	4975	4112343	1965-08-10	1965-08-10 00:00:00	1965-08-18	1965-08-18 00:00:00	32020		\N	330844	0	195662009	4112343		0
83901	4986	40481087	1959-03-27	1959-03-27 00:00:00	1959-04-10	1959-04-10 00:00:00	32020		\N	331677	0	444814009	40481087		0
84125	4998	4027663	1995-10-02	1995-10-02 00:00:00	\N	\N	32020		\N	332331	0	13200003	4027663		0
73628	4376	372328	2008-03-05	2008-03-05 00:00:00	2008-12-16	2008-12-16 00:00:00	32020		\N	290769	0	65363002	372328		0
84404	5017	40481087	2010-04-28	2010-04-28 00:00:00	2010-05-12	2010-05-12 00:00:00	32020		\N	333449	0	444814009	40481087		0
84637	5034	317576	1993-01-23	1993-01-23 00:00:00	\N	\N	32020		\N	334481	0	53741008	317576		0
84731	5037	4112343	2014-01-20	2014-01-20 00:00:00	2014-01-31	2014-01-31 00:00:00	32020		\N	334718	0	195662009	4112343		0
84944	5051	4266809	2013-12-30	2013-12-30 00:00:00	\N	\N	32020		\N	335949	0	397881000	4266809		0
85003	5056	4237458	1982-04-16	1982-04-16 00:00:00	1982-07-15	1982-07-15 00:00:00	32020		\N	336165	0	58150001	4237458		0
74687	4436	4134304	1980-05-23	1980-05-23 00:00:00	1980-06-22	1980-06-22 00:00:00	32020		\N	294879	0	263102004	4134304		0
74716	4437	81893	2008-08-26	2008-08-26 00:00:00	\N	\N	32020		\N	294909	0	64766004	81893		0
74875	4448	260139	1987-11-28	1987-11-28 00:00:00	1987-12-12	1987-12-12 00:00:00	32020		\N	295845	0	10509002	260139		0
64534	3814	40481087	2008-09-06	2008-09-06 00:00:00	2008-09-13	2008-09-13 00:00:00	32020		\N	253317	0	444814009	40481087		0
75279	4471	260139	1963-11-14	1963-11-14 00:00:00	1963-11-21	1963-11-21 00:00:00	32020		\N	297444	0	10509002	260139		0
64810	3832	260139	1993-08-23	1993-08-23 00:00:00	1993-08-30	1993-08-30 00:00:00	32020		\N	254453	0	10509002	260139		0
75544	4484	260139	1951-11-14	1951-11-14 00:00:00	1951-11-21	1951-11-21 00:00:00	32020		\N	298458	0	10509002	260139		0
65201	3857	372328	1945-12-24	1945-12-24 00:00:00	1946-06-11	1946-06-11 00:00:00	32020		\N	255984	0	65363002	372328		0
65366	3865	80180	1990-04-06	1990-04-06 00:00:00	\N	\N	32020		\N	256563	0	396275006	80180		0
65563	3876	260139	1974-04-17	1974-04-17 00:00:00	1974-04-24	1974-04-24 00:00:00	32020		\N	257431	0	10509002	260139		0
76291	4526	40481087	1985-02-16	1985-02-16 00:00:00	1985-03-02	1985-03-02 00:00:00	32020		\N	301378	0	444814009	40481087		0
76453	4532	40481087	1983-06-30	1983-06-30 00:00:00	1983-07-07	1983-07-07 00:00:00	32020		\N	301896	0	444814009	40481087		0
76559	4538	40481087	2012-11-25	2012-11-25 00:00:00	2012-12-02	2012-12-02 00:00:00	32020		\N	302354	0	444814009	40481087		0
76723	4547	260139	1994-02-02	1994-02-02 00:00:00	1994-02-09	1994-02-09 00:00:00	32020		\N	302911	0	10509002	260139		0
76890	4557	80502	1990-08-12	1990-08-12 00:00:00	\N	\N	32020		\N	303660	0	64859006	80502		0
66531	3938	4112343	1952-05-24	1952-05-24 00:00:00	1952-06-01	1952-06-01 00:00:00	32020		\N	261791	0	195662009	4112343		0
77308	4578	4112343	2005-11-14	2005-11-14 00:00:00	2005-11-24	2005-11-24 00:00:00	32020		\N	304966	0	195662009	4112343		0
77428	4587	4059173	2011-09-29	2011-09-29 00:00:00	2011-11-28	2011-11-28 00:00:00	32020		\N	305570	0	16114001	4059173		0
77576	4595	40481087	1971-05-01	1971-05-01 00:00:00	1971-05-08	1971-05-08 00:00:00	32020		\N	306153	0	444814009	40481087		0
77708	4603	4283893	1960-04-04	1960-04-04 00:00:00	1961-03-06	1961-03-06 00:00:00	32020		\N	306628	0	36971009	4283893		0
88528	5262	30753	2009-02-17	2009-02-17 00:00:00	\N	\N	32020		\N	350147	0	16761005	30753		0
78057	4625	4109685	1964-01-28	1964-01-28 00:00:00	1964-02-11	1964-02-11 00:00:00	32020		\N	308126	0	284551006	4109685		0
67710	3998	4134304	1970-09-09	1970-09-09 00:00:00	1970-11-08	1970-11-08 00:00:00	32020		\N	265849	0	263102004	4134304		0
78370	4641	40481087	1969-11-05	1969-11-05 00:00:00	1969-11-19	1969-11-19 00:00:00	32020		\N	309294	0	444814009	40481087		0
78560	4653	40481087	2004-07-22	2004-07-22 00:00:00	2004-07-29	2004-07-29 00:00:00	32020		\N	310147	0	444814009	40481087		0
78685	4660	4283893	1976-07-23	1976-07-23 00:00:00	1976-08-27	1976-08-27 00:00:00	32020		\N	310606	0	36971009	4283893		0
74891	4448	4027663	1987-04-07	1987-04-07 00:00:00	\N	\N	32020		\N	295888	0	13200003	4027663		0
78964	4675	40481087	1948-07-18	1948-07-18 00:00:00	1948-08-01	1948-08-01 00:00:00	32020		\N	311568	0	444814009	40481087		0
79049	4680	4112343	1991-11-19	1991-11-19 00:00:00	1991-11-29	1991-11-29 00:00:00	32020		\N	311891	0	195662009	4112343		0
79250	4691	4112343	1968-05-08	1968-05-08 00:00:00	1968-05-15	1968-05-15 00:00:00	32020		\N	312572	0	195662009	4112343		0
79446	4705	372328	1982-05-27	1982-05-27 00:00:00	1982-06-17	1982-06-17 00:00:00	32020		\N	313472	0	65363002	372328		0
69001	4084	40481087	1971-12-03	1971-12-03 00:00:00	1971-12-10	1971-12-10 00:00:00	32020		\N	271369	0	444814009	40481087		0
69213	4094	4296204	1967-03-24	1967-03-24 00:00:00	1967-04-21	1967-04-21 00:00:00	32020		\N	272151	0	403190006	4296204		0
79992	4739	260139	1962-08-08	1962-08-08 00:00:00	1962-08-15	1962-08-15 00:00:00	32020		\N	315702	0	10509002	260139		0
69446	4109	4112343	2013-06-19	2013-06-19 00:00:00	2013-06-28	2013-06-28 00:00:00	32020		\N	273116	0	195662009	4112343		0
69651	4121	4112343	1976-09-21	1976-09-21 00:00:00	1976-10-04	1976-10-04 00:00:00	32020		\N	273980	0	195662009	4112343		0
80419	4763	4112343	1962-03-13	1962-03-13 00:00:00	1962-03-22	1962-03-22 00:00:00	32020		\N	317458	0	195662009	4112343		0
80679	4784	260139	1987-01-06	1987-01-06 00:00:00	1987-01-13	1987-01-13 00:00:00	32020		\N	318495	0	10509002	260139		0
80928	4800	4113008	1974-11-07	1974-11-07 00:00:00	1974-11-21	1974-11-21 00:00:00	32020		\N	319292	0	284549007	4113008		0
81312	4822	261325	2003-10-29	2003-10-29 00:00:00	\N	\N	32020		\N	320770	0	87433001	261325		0
81372	4826	40481087	2005-10-16	2005-10-16 00:00:00	2005-10-30	2005-10-30 00:00:00	32020		\N	321044	0	444814009	40481087		0
71043	4214	40481087	1999-03-31	1999-03-31 00:00:00	1999-04-21	1999-04-21 00:00:00	32020		\N	279775	0	444814009	40481087		0
71149	4220	4310024	1974-09-18	1974-09-18 00:00:00	\N	\N	32020		\N	280165	0	424802006	4310024		0
81878	4855	4112343	1990-08-18	1990-08-18 00:00:00	1990-08-31	1990-08-31 00:00:00	32020		\N	323005	0	195662009	4112343		0
71503	4240	260139	1963-04-29	1963-04-29 00:00:00	1963-05-13	1963-05-13 00:00:00	32020		\N	281626	0	10509002	260139		0
82231	4876	4112343	1987-04-24	1987-04-24 00:00:00	1987-05-06	1987-05-06 00:00:00	32020		\N	324297	0	195662009	4112343		0
82339	4884	4296204	2006-12-06	2006-12-06 00:00:00	2006-12-27	2006-12-27 00:00:00	32020		\N	324742	0	403190006	4296204		0
72033	4275	81151	1995-04-01	1995-04-01 00:00:00	1995-04-23	1995-04-23 00:00:00	32020		\N	283716	0	44465007	81151		0
72155	4282	4112343	1975-06-20	1975-06-20 00:00:00	1975-07-02	1975-07-02 00:00:00	32020		\N	284166	0	195662009	4112343		0
72306	4289	439777	2005-07-03	2005-07-03 00:00:00	\N	\N	32020		\N	284752	0	271737000	439777		0
83099	4935	4310024	2001-06-12	2001-06-12 00:00:00	\N	\N	32020		\N	328052	0	424802006	4310024		0
83225	4943	40481087	1990-08-24	1990-08-24 00:00:00	1990-09-14	1990-09-14 00:00:00	32020		\N	328555	0	444814009	40481087		0
72873	4330	4134304	1963-09-01	1963-09-01 00:00:00	1963-11-30	1963-11-30 00:00:00	32020		\N	287259	0	263102004	4134304		0
83736	4975	372328	1960-04-16	1960-04-16 00:00:00	1960-06-16	1960-06-16 00:00:00	32020		\N	330848	0	65363002	372328		0
83902	4986	313217	2001-04-29	2001-04-29 00:00:00	\N	\N	32020		\N	331638	0	49436004	313217		0
84126	4998	4112343	1995-07-10	1995-07-10 00:00:00	1995-07-18	1995-07-18 00:00:00	32020		\N	332331	0	195662009	4112343		0
73629	4376	40481087	1931-08-13	1931-08-13 00:00:00	1931-09-03	1931-09-03 00:00:00	32020		\N	290826	0	444814009	40481087		0
84405	5017	192671	2015-08-17	2015-08-17 00:00:00	\N	\N	32020		\N	333436	0	K92.2	35208414		0
84638	5034	260139	1989-05-02	1989-05-02 00:00:00	1989-05-16	1989-05-16 00:00:00	32020		\N	334520	0	10509002	260139		0
84733	5039	260139	2014-04-13	2014-04-13 00:00:00	2014-04-27	2014-04-27 00:00:00	32020		\N	334858	0	10509002	260139		0
84945	5051	80180	2013-12-30	2013-12-30 00:00:00	\N	\N	32020		\N	335949	0	396275006	80180		0
85004	5056	30753	1979-04-05	1979-04-05 00:00:00	\N	\N	32020		\N	336176	0	16761005	30753		0
74689	4436	321042	2003-06-13	2003-06-13 00:00:00	\N	\N	32020		\N	294881	0	410429000	321042		0
74717	4437	4285898	2010-05-18	2010-05-18 00:00:00	\N	\N	32020		\N	294909	0	68496003	4285898		0
74876	4448	4112343	1966-01-26	1966-01-26 00:00:00	1966-02-03	1966-02-03 00:00:00	32020		\N	295853	0	195662009	4112343		0
64535	3814	4112343	1975-06-02	1975-06-02 00:00:00	1975-06-10	1975-06-10 00:00:00	32020		\N	253354	0	195662009	4112343		0
75280	4471	40481087	1986-02-27	1986-02-27 00:00:00	1986-03-20	1986-03-20 00:00:00	32020		\N	297433	0	444814009	40481087		0
64811	3832	4294548	2019-06-07	2019-06-07 00:00:00	\N	\N	32020		\N	254474	0	75498004	4294548		0
75545	4484	40481087	1952-07-04	1952-07-04 00:00:00	1952-07-25	1952-07-25 00:00:00	32020		\N	298481	0	444814009	40481087		0
65202	3857	40481087	1944-02-12	1944-02-12 00:00:00	1944-02-19	1944-02-19 00:00:00	32020		\N	255976	0	444814009	40481087		0
65367	3865	257012	1971-02-23	1971-02-23 00:00:00	\N	\N	32020		\N	256641	0	40055000	257012		0
65564	3876	260139	2016-12-10	2016-12-10 00:00:00	2016-12-17	2016-12-17 00:00:00	32020		\N	257417	0	10509002	260139		0
76292	4526	372328	1962-08-19	1962-08-19 00:00:00	1962-10-19	1962-10-19 00:00:00	32020		\N	301341	0	65363002	372328		0
76454	4532	439777	1960-04-04	1960-04-04 00:00:00	\N	\N	32020		\N	301954	0	271737000	439777		0
76560	4538	4112343	1954-11-08	1954-11-08 00:00:00	1954-11-17	1954-11-17 00:00:00	32020		\N	302348	0	195662009	4112343		0
76724	4547	4218389	2004-06-02	2004-06-02 00:00:00	2004-07-07	2004-07-07 00:00:00	32020		\N	302963	0	39848009	4218389		0
76891	4557	40481087	1936-12-25	1936-12-25 00:00:00	1937-01-08	1937-01-08 00:00:00	32020		\N	303620	0	444814009	40481087		0
66532	3938	381316	1976-10-20	1976-10-20 00:00:00	\N	\N	32020		\N	261757	0	230690007	381316		0
77309	4579	40481087	2014-12-20	2014-12-20 00:00:00	2015-01-03	2015-01-03 00:00:00	32020		\N	305063	0	444814009	40481087		0
77429	4587	40479768	1960-04-01	1960-04-01 00:00:00	1960-06-07	1960-06-07 00:00:00	32020		\N	305567	0	444470001	40479768		0
77577	4595	4112343	1966-03-25	1966-03-25 00:00:00	1966-04-03	1966-04-03 00:00:00	32020		\N	306183	0	195662009	4112343		0
77709	4603	40481087	1973-07-29	1973-07-29 00:00:00	1973-08-19	1973-08-19 00:00:00	32020		\N	306636	0	444814009	40481087		0
88529	5262	4266809	2010-04-13	2010-04-13 00:00:00	\N	\N	32020		\N	350147	0	397881000	4266809		0
78058	4625	260139	1976-10-23	1976-10-23 00:00:00	1976-10-30	1976-10-30 00:00:00	32020		\N	308092	0	10509002	260139		0
67711	3998	372328	1953-06-10	1953-06-10 00:00:00	1954-06-03	1954-06-03 00:00:00	32020		\N	265777	0	65363002	372328		0
78371	4641	28060	1967-10-14	1967-10-14 00:00:00	1967-10-27	1967-10-27 00:00:00	32020		\N	309285	0	43878008	28060		0
78561	4653	4112343	2010-09-23	2010-09-23 00:00:00	2010-10-03	2010-10-03 00:00:00	32020		\N	310130	0	195662009	4112343		0
78686	4660	40481087	1964-03-24	1964-03-24 00:00:00	1964-04-07	1964-04-07 00:00:00	32020		\N	310662	0	444814009	40481087		0
78965	4675	40481087	1930-03-22	1930-03-22 00:00:00	1930-03-29	1930-03-29 00:00:00	32020		\N	311545	0	444814009	40481087		0
79050	4680	4112343	1975-11-02	1975-11-02 00:00:00	1975-11-15	1975-11-15 00:00:00	32020		\N	311933	0	195662009	4112343		0
79251	4691	4112343	1980-05-14	1980-05-14 00:00:00	1980-05-26	1980-05-26 00:00:00	32020		\N	312575	0	195662009	4112343		0
79447	4705	4112343	2013-05-12	2013-05-12 00:00:00	2013-05-19	2013-05-19 00:00:00	32020		\N	313493	0	195662009	4112343		0
69002	4084	321042	2010-10-03	2010-10-03 00:00:00	\N	\N	32020		\N	271438	0	410429000	321042		0
79681	4720	4283893	1995-11-05	1995-11-05 00:00:00	1996-06-02	1996-06-02 00:00:00	32020		\N	314360	0	36971009	4283893		0
79993	4739	257012	1980-10-23	1980-10-23 00:00:00	\N	\N	32020		\N	315674	0	40055000	257012		0
69447	4109	372328	1965-05-30	1965-05-30 00:00:00	1965-08-10	1965-08-10 00:00:00	32020		\N	273118	0	65363002	372328		0
69652	4121	260139	1928-06-23	1928-06-23 00:00:00	1928-06-30	1928-06-30 00:00:00	32020		\N	273957	0	10509002	260139		0
80420	4763	4112343	1962-12-18	1962-12-18 00:00:00	1962-12-31	1962-12-31 00:00:00	32020		\N	317414	0	195662009	4112343		0
80680	4784	260139	2010-07-18	2010-07-18 00:00:00	2010-08-01	2010-08-01 00:00:00	32020		\N	318484	0	10509002	260139		0
81313	4822	260139	2018-06-01	2018-06-01 00:00:00	2018-06-15	2018-06-15 00:00:00	32020		\N	320716	0	10509002	260139		0
81373	4827	40481087	1968-04-22	1968-04-22 00:00:00	1968-04-29	1968-04-29 00:00:00	32020		\N	321106	0	444814009	40481087		0
71044	4214	4027663	1997-11-22	1997-11-22 00:00:00	\N	\N	32020		\N	279814	0	13200003	4027663		0
71150	4220	40481087	2015-02-14	2015-02-14 00:00:00	2015-03-07	2015-03-07 00:00:00	32020		\N	280226	0	444814009	40481087		0
81879	4855	40481087	1984-08-09	1984-08-09 00:00:00	1984-08-16	1984-08-16 00:00:00	32020		\N	323035	0	444814009	40481087		0
71504	4240	40481087	2014-08-16	2014-08-16 00:00:00	2014-09-06	2014-09-06 00:00:00	32020		\N	281638	0	444814009	40481087		0
82232	4876	80180	2013-08-28	2013-08-28 00:00:00	\N	\N	32020		\N	324281	0	396275006	80180		0
82340	4884	4156265	1978-02-22	1978-02-22 00:00:00	1978-03-08	1978-03-08 00:00:00	32020		\N	324733	0	370247008	4156265		0
72034	4275	4112343	2003-04-15	2003-04-15 00:00:00	2003-04-26	2003-04-26 00:00:00	32020		\N	283686	0	195662009	4112343		0
72156	4282	4278672	1970-02-14	1970-02-14 00:00:00	1970-03-16	1970-03-16 00:00:00	32020		\N	284192	0	65966004	4278672		0
72318	4291	40481087	1994-10-15	1994-10-15 00:00:00	1994-10-29	1994-10-29 00:00:00	32020		\N	284880	0	444814009	40481087		0
83100	4935	40481087	1978-07-19	1978-07-19 00:00:00	1978-08-09	1978-08-09 00:00:00	32020		\N	328107	0	444814009	40481087		0
83226	4943	80180	1996-03-09	1996-03-09 00:00:00	\N	\N	32020		\N	328607	0	396275006	80180		0
72874	4330	78272	1955-08-16	1955-08-16 00:00:00	1955-09-13	1955-09-13 00:00:00	32020		\N	287258	0	70704007	78272		0
83737	4975	28060	1973-10-19	1973-10-19 00:00:00	1973-10-30	1973-10-30 00:00:00	32020		\N	330904	0	43878008	28060		0
83903	4986	40481087	1970-06-13	1970-06-13 00:00:00	1970-07-04	1970-07-04 00:00:00	32020		\N	331691	0	444814009	40481087		0
84127	4998	28060	2008-04-13	2008-04-13 00:00:00	2008-04-25	2008-04-25 00:00:00	32020		\N	332407	0	43878008	28060		0
73630	4376	40481087	2000-02-13	2000-02-13 00:00:00	2000-02-20	2000-02-20 00:00:00	32020		\N	290747	0	444814009	40481087		0
84406	5017	260139	1997-07-21	1997-07-21 00:00:00	1997-07-28	1997-07-28 00:00:00	32020		\N	333439	0	10509002	260139		0
84639	5034	378001	1954-05-15	1954-05-15 00:00:00	1954-07-14	1954-07-14 00:00:00	32020		\N	334459	0	62106007	378001		0
84734	5039	4283893	1984-08-19	1984-08-19 00:00:00	1984-09-09	1984-09-09 00:00:00	32020		\N	334862	0	36971009	4283893		0
84946	5051	4285898	2013-10-31	2013-10-31 00:00:00	\N	\N	32020		\N	335949	0	68496003	4285898		0
85005	5056	80180	1979-07-04	1979-07-04 00:00:00	\N	\N	32020		\N	336176	0	396275006	80180		0
74690	4436	40481087	1972-07-24	1972-07-24 00:00:00	1972-08-07	1972-08-07 00:00:00	32020		\N	294834	0	444814009	40481087		0
74718	4437	4266809	2010-11-14	2010-11-14 00:00:00	\N	\N	32020		\N	294915	0	397881000	4266809		0
74877	4448	4112343	1961-12-20	1961-12-20 00:00:00	1961-12-30	1961-12-30 00:00:00	32020		\N	295849	0	195662009	4112343		0
64536	3814	4112343	2012-11-09	2012-11-09 00:00:00	2012-11-21	2012-11-21 00:00:00	32020		\N	253355	0	195662009	4112343		0
75281	4471	381316	2001-01-08	2001-01-08 00:00:00	\N	\N	32020		\N	297427	0	230690007	381316		0
64812	3832	40481087	2011-07-11	2011-07-11 00:00:00	2011-07-18	2011-07-18 00:00:00	32020		\N	254416	0	444814009	40481087		0
75546	4484	4112343	1986-03-14	1986-03-14 00:00:00	1986-03-26	1986-03-26 00:00:00	32020		\N	298446	0	195662009	4112343		0
65203	3857	40481087	1956-09-01	1956-09-01 00:00:00	1956-09-15	1956-09-15 00:00:00	32020		\N	255980	0	444814009	40481087		0
65368	3865	192671	1990-06-09	1990-06-09 00:00:00	\N	\N	32020		\N	256560	0	K92.2	35208414		0
65565	3876	4112343	1988-02-11	1988-02-11 00:00:00	1988-02-23	1988-02-23 00:00:00	32020		\N	257433	0	195662009	4112343		0
76293	4526	372328	1955-10-13	1955-10-13 00:00:00	1956-03-23	1956-03-23 00:00:00	32020		\N	301402	0	65363002	372328		0
76455	4532	260139	1949-03-04	1949-03-04 00:00:00	1949-03-11	1949-03-11 00:00:00	32020		\N	301917	0	10509002	260139		0
76561	4538	40481087	1988-01-22	1988-01-22 00:00:00	1988-01-29	1988-01-29 00:00:00	32020		\N	302308	0	444814009	40481087		0
76725	4547	440086	1915-10-17	1915-10-17 00:00:00	1916-06-25	1916-06-25 00:00:00	32020		\N	302840	0	192127007	440086		0
76892	4557	80180	1966-04-22	1966-04-22 00:00:00	\N	\N	32020		\N	303596	0	396275006	80180		0
66533	3938	372328	1969-07-11	1969-07-11 00:00:00	1970-04-21	1970-04-21 00:00:00	32020		\N	261742	0	65363002	372328		0
77310	4579	4112343	1976-05-11	1976-05-11 00:00:00	1976-05-23	1976-05-23 00:00:00	32020		\N	305024	0	195662009	4112343		0
77430	4587	4283893	1989-01-05	1989-01-05 00:00:00	1989-02-16	1989-02-16 00:00:00	32020		\N	305607	0	36971009	4283893		0
77578	4595	28060	1970-07-13	1970-07-13 00:00:00	1970-07-22	1970-07-22 00:00:00	32020		\N	306150	0	43878008	28060		0
77710	4603	40481087	2015-12-25	2015-12-25 00:00:00	2016-01-08	2016-01-08 00:00:00	32020		\N	306667	0	444814009	40481087		0
88530	5262	4285898	2009-12-14	2009-12-14 00:00:00	\N	\N	32020		\N	350147	0	68496003	4285898		0
78059	4625	40481087	2003-03-05	2003-03-05 00:00:00	2003-03-19	2003-03-19 00:00:00	32020		\N	308134	0	444814009	40481087		0
78187	4631	4112343	1995-04-01	1995-04-01 00:00:00	1995-04-13	1995-04-13 00:00:00	32020		\N	308651	0	195662009	4112343		0
78372	4641	4112343	1973-08-27	1973-08-27 00:00:00	1973-09-06	1973-09-06 00:00:00	32020		\N	309329	0	195662009	4112343		0
78562	4653	40481087	2003-12-12	2003-12-12 00:00:00	2003-12-19	2003-12-19 00:00:00	32020		\N	310139	0	444814009	40481087		0
78687	4660	40481087	2000-04-06	2000-04-06 00:00:00	2000-04-27	2000-04-27 00:00:00	32020		\N	310665	0	444814009	40481087		0
78966	4675	40481087	2000-06-16	2000-06-16 00:00:00	2000-06-30	2000-06-30 00:00:00	32020		\N	311435	0	444814009	40481087		0
79051	4680	80180	1952-07-25	1952-07-25 00:00:00	\N	\N	32020		\N	311899	0	396275006	80180		0
79252	4691	28060	1974-02-28	1974-02-28 00:00:00	1974-03-13	1974-03-13 00:00:00	32020		\N	312587	0	43878008	28060		0
79448	4705	40481087	2019-06-21	2019-06-21 00:00:00	\N	\N	32020		\N	313471	0	444814009	40481087		0
69004	4084	40481087	2010-09-02	2010-09-02 00:00:00	2010-09-09	2010-09-09 00:00:00	32020		\N	271375	0	444814009	40481087		0
79682	4720	260139	1993-03-12	1993-03-12 00:00:00	1993-03-26	1993-03-26 00:00:00	32020		\N	314403	0	10509002	260139		0
79994	4739	40481087	1980-04-19	1980-04-19 00:00:00	1980-05-10	1980-05-10 00:00:00	32020		\N	315742	0	444814009	40481087		0
69448	4109	4112343	1990-10-15	1990-10-15 00:00:00	1990-10-24	1990-10-24 00:00:00	32020		\N	273091	0	195662009	4112343		0
69653	4121	260139	1926-02-18	1926-02-18 00:00:00	1926-03-04	1926-03-04 00:00:00	32020		\N	273941	0	10509002	260139		0
80421	4763	4283893	1997-09-24	1997-09-24 00:00:00	1998-01-21	1998-01-21 00:00:00	32020		\N	317377	0	36971009	4283893		0
80681	4784	4112343	1968-11-03	1968-11-03 00:00:00	1968-11-11	1968-11-11 00:00:00	32020		\N	318493	0	195662009	4112343		0
80930	4800	30753	2007-12-14	2007-12-14 00:00:00	\N	\N	32020		\N	319353	0	16761005	30753		0
81314	4822	28060	1953-12-23	1953-12-23 00:00:00	1954-01-03	1954-01-03 00:00:00	32020		\N	320728	0	43878008	28060		0
81374	4827	134438	1967-12-11	1967-12-11 00:00:00	1968-09-11	1968-09-11 00:00:00	32020		\N	321179	0	40275004	134438		0
71045	4214	4283893	2004-03-03	2004-03-03 00:00:00	2004-07-21	2004-07-21 00:00:00	32020		\N	279763	0	36971009	4283893		0
71151	4220	4266809	1977-04-05	1977-04-05 00:00:00	\N	\N	32020		\N	280166	0	397881000	4266809		0
81880	4855	28060	1984-11-03	1984-11-03 00:00:00	1984-11-14	1984-11-14 00:00:00	32020		\N	323004	0	43878008	28060		0
71505	4240	40481087	1996-07-28	1996-07-28 00:00:00	1996-08-04	1996-08-04 00:00:00	32020		\N	281636	0	444814009	40481087		0
82233	4876	260139	1994-12-23	1994-12-23 00:00:00	1995-01-06	1995-01-06 00:00:00	32020		\N	324287	0	10509002	260139		0
82341	4884	4051466	1975-10-28	1975-10-28 00:00:00	1992-02-04	1992-02-04 00:00:00	32020		\N	324726	0	233678006	4051466		0
72035	4275	4285898	2017-08-22	2017-08-22 00:00:00	\N	\N	32020		\N	283714	0	68496003	4285898		0
72157	4282	260139	2014-10-30	2014-10-30 00:00:00	2014-11-06	2014-11-06 00:00:00	32020		\N	284219	0	10509002	260139		0
72319	4291	80180	2016-08-29	2016-08-29 00:00:00	\N	\N	32020		\N	284903	0	396275006	80180		0
83227	4943	28060	1999-05-29	1999-05-29 00:00:00	1999-06-09	1999-06-09 00:00:00	32020		\N	328575	0	43878008	28060		0
83333	4952	372328	1973-02-17	1973-02-17 00:00:00	1973-03-17	1973-03-17 00:00:00	32020		\N	329156	0	65363002	372328		0
83738	4975	4112343	1990-07-15	1990-07-15 00:00:00	1990-07-23	1990-07-23 00:00:00	32020		\N	330882	0	195662009	4112343		0
83904	4986	4112343	2017-12-24	2017-12-24 00:00:00	2018-01-06	2018-01-06 00:00:00	32020		\N	331624	0	195662009	4112343		0
84128	4998	81151	2007-03-28	2007-03-28 00:00:00	2007-04-18	2007-04-18 00:00:00	32020		\N	332338	0	44465007	81151		0
73631	4376	40481087	2016-04-29	2016-04-29 00:00:00	2016-05-13	2016-05-13 00:00:00	32020		\N	290714	0	444814009	40481087		0
84407	5017	40481087	2004-12-29	2004-12-29 00:00:00	2005-01-19	2005-01-19 00:00:00	32020		\N	333415	0	444814009	40481087		0
84640	5034	4294548	1975-02-20	1975-02-20 00:00:00	1975-03-13	1975-03-13 00:00:00	32020		\N	334518	0	75498004	4294548		0
84735	5039	40481087	2008-12-23	2008-12-23 00:00:00	2008-12-30	2008-12-30 00:00:00	32020		\N	334863	0	444814009	40481087		0
84947	5051	40481087	1979-04-23	1979-04-23 00:00:00	1979-05-07	1979-05-07 00:00:00	32020		\N	335871	0	444814009	40481087		0
85006	5056	81893	1978-09-07	1978-09-07 00:00:00	\N	\N	32020		\N	336176	0	64766004	81893		0
74691	4436	40481087	2006-12-12	2006-12-12 00:00:00	2007-01-02	2007-01-02 00:00:00	32020		\N	294826	0	444814009	40481087		0
74719	4437	80180	2010-11-14	2010-11-14 00:00:00	\N	\N	32020		\N	294915	0	396275006	80180		0
74878	4448	40481087	1999-06-10	1999-06-10 00:00:00	1999-06-24	1999-06-24 00:00:00	32020		\N	295847	0	444814009	40481087		0
64537	3814	80180	2013-04-10	2013-04-10 00:00:00	\N	\N	32020		\N	253355	0	396275006	80180		0
75282	4471	4237458	1996-04-03	1996-04-03 00:00:00	1996-06-02	1996-06-02 00:00:00	32020		\N	297400	0	58150001	4237458		0
64813	3833	4278672	1976-04-02	1976-04-02 00:00:00	1976-05-02	1976-05-02 00:00:00	32020		\N	254526	0	65966004	4278672		0
75547	4484	372328	1954-06-29	1954-06-29 00:00:00	1954-07-22	1954-07-22 00:00:00	32020		\N	298485	0	65363002	372328		0
65204	3857	40481087	1971-05-19	1971-05-19 00:00:00	1971-05-26	1971-05-26 00:00:00	32020		\N	255956	0	444814009	40481087		0
65369	3865	4237458	1969-06-20	1969-06-20 00:00:00	1969-07-20	1969-07-20 00:00:00	32020		\N	256555	0	58150001	4237458		0
76029	4509	4112343	1986-05-23	1986-05-23 00:00:00	1986-06-04	1986-06-04 00:00:00	32020		\N	300375	0	195662009	4112343		0
76294	4526	40481087	2007-08-01	2007-08-01 00:00:00	2007-08-15	2007-08-15 00:00:00	32020		\N	301381	0	444814009	40481087		0
76456	4532	4112343	1966-03-13	1966-03-13 00:00:00	1966-03-21	1966-03-21 00:00:00	32020		\N	301844	0	195662009	4112343		0
76562	4538	40481087	2015-02-20	2015-02-20 00:00:00	2015-03-13	2015-03-13 00:00:00	32020		\N	302339	0	444814009	40481087		0
76726	4547	40481087	2001-03-02	2001-03-02 00:00:00	2001-03-09	2001-03-09 00:00:00	32020		\N	302939	0	444814009	40481087		0
76893	4557	4113008	1924-05-27	1924-05-27 00:00:00	1924-06-17	1924-06-17 00:00:00	32020		\N	303637	0	284549007	4113008		0
66534	3938	378001	1937-06-29	1937-06-29 00:00:00	1937-07-29	1937-07-29 00:00:00	32020		\N	261807	0	62106007	378001		0
77311	4579	28060	1973-04-15	1973-04-15 00:00:00	1973-04-24	1973-04-24 00:00:00	32020		\N	305023	0	43878008	28060		0
77431	4587	40481087	2013-01-13	2013-01-13 00:00:00	2013-01-20	2013-01-20 00:00:00	32020		\N	305599	0	444814009	40481087		0
77579	4595	4112343	1975-11-23	1975-11-23 00:00:00	1975-12-04	1975-12-04 00:00:00	32020		\N	306185	0	195662009	4112343		0
77711	4603	40481087	1989-06-01	1989-06-01 00:00:00	1989-06-15	1989-06-15 00:00:00	32020		\N	306703	0	444814009	40481087		0
88531	5262	80180	2010-04-13	2010-04-13 00:00:00	\N	\N	32020		\N	350147	0	396275006	80180		0
78060	4625	260139	2003-09-27	2003-09-27 00:00:00	2003-10-04	2003-10-04 00:00:00	32020		\N	308116	0	10509002	260139		0
78188	4631	4112343	1960-06-14	1960-06-14 00:00:00	1960-06-25	1960-06-25 00:00:00	32020		\N	308575	0	195662009	4112343		0
78373	4641	4109685	2017-07-20	2017-07-20 00:00:00	2017-08-03	2017-08-03 00:00:00	32020		\N	309338	0	284551006	4109685		0
78563	4653	260139	1965-07-22	1965-07-22 00:00:00	1965-07-29	1965-07-29 00:00:00	32020		\N	310116	0	10509002	260139		0
78688	4660	80180	1998-08-12	1998-08-12 00:00:00	\N	\N	32020		\N	310653	0	396275006	80180		0
78967	4675	40481087	1975-01-04	1975-01-04 00:00:00	1975-01-11	1975-01-11 00:00:00	32020		\N	311551	0	444814009	40481087		0
79052	4680	372328	1910-11-22	1910-11-22 00:00:00	1911-03-25	1911-03-25 00:00:00	32020		\N	311884	0	65363002	372328		0
79253	4691	260139	2006-03-09	2006-03-09 00:00:00	2006-03-16	2006-03-16 00:00:00	32020		\N	312540	0	10509002	260139		0
79449	4705	40481087	2007-11-07	2007-11-07 00:00:00	2007-11-14	2007-11-14 00:00:00	32020		\N	313469	0	444814009	40481087		0
69005	4084	40481087	2000-06-26	2000-06-26 00:00:00	2000-07-17	2000-07-17 00:00:00	32020		\N	271386	0	444814009	40481087		0
79683	4720	4142905	1982-02-14	1982-02-14 00:00:00	1982-04-15	1982-04-15 00:00:00	32020		\N	314369	0	33737001	4142905		0
79995	4739	28060	1916-10-22	1916-10-22 00:00:00	1916-11-01	1916-11-01 00:00:00	32020		\N	315749	0	43878008	28060		0
69449	4109	40481087	1987-05-14	1987-05-14 00:00:00	1987-06-04	1987-06-04 00:00:00	32020		\N	273057	0	444814009	40481087		0
69654	4121	4112343	1965-05-11	1965-05-11 00:00:00	1965-05-21	1965-05-21 00:00:00	32020		\N	273978	0	195662009	4112343		0
80422	4763	40481087	1960-07-03	1960-07-03 00:00:00	1960-07-17	1960-07-17 00:00:00	32020		\N	317375	0	444814009	40481087		0
80682	4784	372328	1976-09-06	1976-09-06 00:00:00	1977-01-15	1977-01-15 00:00:00	32020		\N	318440	0	65363002	372328		0
80931	4800	80180	2009-03-09	2009-03-09 00:00:00	\N	\N	32020		\N	319353	0	396275006	80180		0
81315	4822	40481087	1961-06-07	1961-06-07 00:00:00	1961-06-14	1961-06-14 00:00:00	32020		\N	320780	0	444814009	40481087		0
81375	4827	40481087	2015-09-06	2015-09-06 00:00:00	2015-09-27	2015-09-27 00:00:00	32020		\N	321128	0	444814009	40481087		0
71046	4214	4112343	1981-04-27	1981-04-27 00:00:00	1981-05-07	1981-05-07 00:00:00	32020		\N	279758	0	195662009	4112343		0
71152	4220	80180	1977-04-05	1977-04-05 00:00:00	\N	\N	32020		\N	280166	0	396275006	80180		0
81881	4855	40481087	2005-11-03	2005-11-03 00:00:00	2005-11-24	2005-11-24 00:00:00	32020		\N	322996	0	444814009	40481087		0
71506	4241	40481087	1970-07-18	1970-07-18 00:00:00	1970-08-08	1970-08-08 00:00:00	32020		\N	281728	0	444814009	40481087		0
82234	4876	28060	1977-11-24	1977-11-24 00:00:00	1977-12-01	1977-12-01 00:00:00	32020		\N	324296	0	43878008	28060		0
82342	4884	372328	1974-05-26	1974-05-26 00:00:00	1974-09-28	1974-09-28 00:00:00	32020		\N	324783	0	65363002	372328		0
72036	4275	80180	2018-02-17	2018-02-17 00:00:00	\N	\N	32020		\N	283714	0	396275006	80180		0
72158	4282	260139	1977-09-06	1977-09-06 00:00:00	1977-09-13	1977-09-13 00:00:00	32020		\N	284196	0	10509002	260139		0
72320	4291	40481087	1979-11-29	1979-11-29 00:00:00	1979-12-13	1979-12-13 00:00:00	32020		\N	284877	0	444814009	40481087		0
83102	4935	372328	2008-06-11	2008-06-11 00:00:00	2009-11-19	2009-11-19 00:00:00	32020		\N	328098	0	65363002	372328		0
83236	4945	40481087	1997-02-14	1997-02-14 00:00:00	1997-02-21	1997-02-21 00:00:00	32020		\N	328681	0	444814009	40481087		0
83334	4952	260139	1978-05-12	1978-05-12 00:00:00	1978-05-19	1978-05-19 00:00:00	32020		\N	329153	0	10509002	260139		0
83739	4975	257012	1968-09-27	1968-09-27 00:00:00	\N	\N	32020		\N	330869	0	40055000	257012		0
83905	4986	260139	1983-06-09	1983-06-09 00:00:00	1983-06-16	1983-06-16 00:00:00	32020		\N	331680	0	10509002	260139		0
84129	4998	40481087	2013-09-11	2013-09-11 00:00:00	2013-09-25	2013-09-25 00:00:00	32020		\N	332385	0	444814009	40481087		0
73632	4376	40481087	1921-07-03	1921-07-03 00:00:00	1921-07-17	1921-07-17 00:00:00	32020		\N	290765	0	444814009	40481087		0
84408	5017	4112343	1988-07-14	1988-07-14 00:00:00	1988-07-26	1988-07-26 00:00:00	32020		\N	333424	0	195662009	4112343		0
84641	5034	260139	1956-12-14	1956-12-14 00:00:00	1956-12-28	1956-12-28 00:00:00	32020		\N	334516	0	10509002	260139		0
84736	5039	260139	1979-12-25	1979-12-25 00:00:00	1980-01-01	1980-01-01 00:00:00	32020		\N	334855	0	10509002	260139		0
84948	5051	81151	2016-02-22	2016-02-22 00:00:00	2016-03-28	2016-03-28 00:00:00	32020		\N	335907	0	44465007	81151		0
85007	5056	4094814	1973-08-31	1973-08-31 00:00:00	1973-09-30	1973-09-30 00:00:00	32020		\N	336164	0	262574004	4094814		0
74692	4436	40481087	1990-04-14	1990-04-14 00:00:00	1990-05-05	1990-05-05 00:00:00	32020		\N	294877	0	444814009	40481087		0
74720	4437	260139	1976-08-31	1976-08-31 00:00:00	1976-09-07	1976-09-07 00:00:00	32020		\N	294930	0	10509002	260139		0
74879	4448	40481087	1965-01-02	1965-01-02 00:00:00	1965-01-16	1965-01-16 00:00:00	32020		\N	295851	0	444814009	40481087		0
64552	3817	4112343	2014-02-24	2014-02-24 00:00:00	2014-03-04	2014-03-04 00:00:00	32020		\N	253466	0	195662009	4112343		0
75284	4472	4329847	2015-10-03	2015-10-03 00:00:00	\N	\N	32020		\N	297547	0	22298006	4329847		0
64814	3833	4146173	2007-10-01	2007-10-01 00:00:00	2007-10-31	2007-10-31 00:00:00	32020		\N	254488	0	307731004	4146173		0
75548	4484	4112343	2003-05-18	2003-05-18 00:00:00	2003-05-31	2003-05-31 00:00:00	32020		\N	298505	0	195662009	4112343		0
65205	3857	78272	1956-07-20	1956-07-20 00:00:00	1956-08-17	1956-08-17 00:00:00	32020		\N	256034	0	70704007	78272		0
65370	3865	260139	1985-12-10	1985-12-10 00:00:00	1985-12-24	1985-12-24 00:00:00	32020		\N	256582	0	10509002	260139		0
76030	4509	4112343	1994-05-27	1994-05-27 00:00:00	1994-06-08	1994-06-08 00:00:00	32020		\N	300385	0	195662009	4112343		0
76295	4526	4294548	1983-10-16	1983-10-16 00:00:00	1983-12-18	1983-12-18 00:00:00	32020		\N	301376	0	75498004	4294548		0
76457	4532	260139	1980-06-28	1980-06-28 00:00:00	1980-07-12	1980-07-12 00:00:00	32020		\N	301920	0	10509002	260139		0
76563	4538	80180	1987-05-22	1987-05-22 00:00:00	\N	\N	32020		\N	302389	0	396275006	80180		0
76727	4547	260139	1965-05-27	1965-05-27 00:00:00	1965-06-03	1965-06-03 00:00:00	32020		\N	302934	0	10509002	260139		0
76894	4557	4112343	1974-04-07	1974-04-07 00:00:00	1974-04-16	1974-04-16 00:00:00	32020		\N	303623	0	195662009	4112343		0
66535	3938	260139	1926-07-06	1926-07-06 00:00:00	1926-07-13	1926-07-13 00:00:00	32020		\N	261770	0	10509002	260139		0
77312	4579	257012	2011-03-07	2011-03-07 00:00:00	2011-04-04	2011-04-04 00:00:00	32020		\N	305033	0	40055000	257012		0
77432	4587	4112343	1978-07-20	1978-07-20 00:00:00	1978-07-29	1978-07-29 00:00:00	32020		\N	305587	0	195662009	4112343		0
77580	4595	4112343	1992-11-20	1992-11-20 00:00:00	1992-11-28	1992-11-28 00:00:00	32020		\N	306170	0	195662009	4112343		0
77712	4603	4156265	1982-04-17	1982-04-17 00:00:00	1982-05-01	1982-05-01 00:00:00	32020		\N	306621	0	370247008	4156265		0
88532	5262	4112343	2017-02-01	2017-02-01 00:00:00	2017-02-10	2017-02-10 00:00:00	32020		\N	350081	0	195662009	4112343		0
78061	4625	4109685	1991-07-15	1991-07-15 00:00:00	1991-08-05	1991-08-05 00:00:00	32020		\N	308132	0	284551006	4109685		0
78189	4631	40481087	1960-09-11	1960-09-11 00:00:00	1960-10-02	1960-10-02 00:00:00	32020		\N	308606	0	444814009	40481087		0
78374	4641	378001	1992-05-02	1992-05-02 00:00:00	1992-07-01	1992-07-01 00:00:00	32020		\N	309325	0	62106007	378001		0
78564	4653	40481087	1982-12-19	1982-12-19 00:00:00	1983-01-09	1983-01-09 00:00:00	32020		\N	310167	0	444814009	40481087		0
78689	4660	40481087	1990-04-27	1990-04-27 00:00:00	1990-05-04	1990-05-04 00:00:00	32020		\N	310658	0	444814009	40481087		0
78968	4675	40481087	1947-05-06	1947-05-06 00:00:00	1947-05-20	1947-05-20 00:00:00	32020		\N	311428	0	444814009	40481087		0
79053	4680	372328	1913-04-13	1913-04-13 00:00:00	1914-03-28	1914-03-28 00:00:00	32020		\N	311894	0	65363002	372328		0
79254	4691	40481087	1991-05-24	1991-05-24 00:00:00	1991-06-14	1991-06-14 00:00:00	32020		\N	312603	0	444814009	40481087		0
79450	4705	80180	2009-03-23	2009-03-23 00:00:00	\N	\N	32020		\N	313469	0	396275006	80180		0
69006	4085	28060	1969-09-08	1969-09-08 00:00:00	1969-09-19	1969-09-19 00:00:00	32020		\N	271493	0	43878008	28060		0
79684	4720	4310024	2012-12-03	2012-12-03 00:00:00	\N	\N	32020		\N	314350	0	424802006	4310024		0
79996	4739	40481087	1940-09-29	1940-09-29 00:00:00	1940-10-06	1940-10-06 00:00:00	32020		\N	315752	0	444814009	40481087		0
69450	4109	40481087	1966-10-01	1966-10-01 00:00:00	1966-10-15	1966-10-15 00:00:00	32020		\N	273126	0	444814009	40481087		0
69655	4121	260139	1934-05-31	1934-05-31 00:00:00	1934-06-14	1934-06-14 00:00:00	32020		\N	273994	0	10509002	260139		0
80423	4763	81151	1987-03-02	1987-03-02 00:00:00	1987-04-06	1987-04-06 00:00:00	32020		\N	317456	0	44465007	81151		0
80683	4784	40481087	1970-02-17	1970-02-17 00:00:00	1970-03-03	1970-03-03 00:00:00	32020		\N	318456	0	444814009	40481087		0
80932	4800	4059173	1978-11-30	1978-11-30 00:00:00	1979-02-28	1979-02-28 00:00:00	32020		\N	319293	0	16114001	4059173		0
81316	4822	372328	1949-02-15	1949-02-15 00:00:00	1949-03-09	1949-03-09 00:00:00	32020		\N	320759	0	65363002	372328		0
81376	4827	40481087	1987-10-03	1987-10-03 00:00:00	1987-10-24	1987-10-24 00:00:00	32020		\N	321181	0	444814009	40481087		0
71047	4214	317576	2018-12-18	2018-12-18 00:00:00	\N	\N	32020		\N	279771	0	53741008	317576		0
71153	4220	4112343	1953-11-28	1953-11-28 00:00:00	1953-12-07	1953-12-07 00:00:00	32020		\N	280195	0	195662009	4112343		0
81882	4855	40481087	2007-11-23	2007-11-23 00:00:00	2007-11-30	2007-11-30 00:00:00	32020		\N	323020	0	444814009	40481087		0
71507	4241	260139	1972-12-15	1972-12-15 00:00:00	1972-12-22	1972-12-22 00:00:00	32020		\N	281751	0	10509002	260139		0
82237	4878	4051466	1965-01-11	1965-01-11 00:00:00	1985-02-16	1985-02-16 00:00:00	32020		\N	324409	0	233678006	4051466		0
82343	4884	28060	1975-11-09	1975-11-09 00:00:00	1975-11-16	1975-11-16 00:00:00	32020		\N	324743	0	43878008	28060		0
72037	4275	260139	2005-02-16	2005-02-16 00:00:00	2005-03-02	2005-03-02 00:00:00	32020		\N	283679	0	10509002	260139		0
72159	4282	80180	2004-10-13	2004-10-13 00:00:00	\N	\N	32020		\N	284216	0	396275006	80180		0
72321	4291	372328	1987-06-02	1987-06-02 00:00:00	1988-01-15	1988-01-15 00:00:00	32020		\N	284906	0	65363002	372328		0
83103	4935	40479422	1999-02-07	1999-02-07 00:00:00	1999-03-16	1999-03-16 00:00:00	32020		\N	328156	0	444448004	40479422		0
83237	4945	260139	2008-03-10	2008-03-10 00:00:00	2008-03-24	2008-03-24 00:00:00	32020		\N	328682	0	10509002	260139		0
83335	4952	40481087	2005-02-09	2005-02-09 00:00:00	2005-02-23	2005-02-23 00:00:00	32020		\N	329144	0	444814009	40481087		0
83740	4975	260139	1983-05-25	1983-05-25 00:00:00	1983-06-01	1983-06-01 00:00:00	32020		\N	330905	0	10509002	260139		0
83906	4986	260139	1989-03-20	1989-03-20 00:00:00	1989-04-03	1989-04-03 00:00:00	32020		\N	331681	0	10509002	260139		0
84130	4998	40481087	1973-12-25	1973-12-25 00:00:00	1974-01-08	1974-01-08 00:00:00	32020		\N	332328	0	444814009	40481087		0
73633	4376	40481087	1963-05-28	1963-05-28 00:00:00	1963-06-04	1963-06-04 00:00:00	32020		\N	290710	0	444814009	40481087		0
84409	5017	40481087	1991-05-14	1991-05-14 00:00:00	1991-06-04	1991-06-04 00:00:00	32020		\N	333447	0	444814009	40481087		0
84642	5034	4027663	1953-02-03	1953-02-03 00:00:00	\N	\N	32020		\N	334438	0	13200003	4027663		0
84737	5039	4112343	1991-05-29	1991-05-29 00:00:00	1991-06-10	1991-06-10 00:00:00	32020		\N	334882	0	195662009	4112343		0
84949	5051	4027663	2003-11-18	2003-11-18 00:00:00	\N	\N	32020		\N	335918	0	13200003	4027663		0
85008	5056	372328	1939-02-19	1939-02-19 00:00:00	1939-06-01	1939-06-01 00:00:00	32020		\N	336219	0	65363002	372328		0
74693	4436	4027663	1999-05-20	1999-05-20 00:00:00	\N	\N	32020		\N	294845	0	13200003	4027663		0
74721	4437	40481087	1999-01-04	1999-01-04 00:00:00	1999-01-18	1999-01-18 00:00:00	32020		\N	294925	0	444814009	40481087		0
74880	4448	40481087	1964-08-16	1964-08-16 00:00:00	1964-08-30	1964-08-30 00:00:00	32020		\N	295898	0	444814009	40481087		0
64553	3817	4112343	1970-01-26	1970-01-26 00:00:00	1970-02-04	1970-02-04 00:00:00	32020		\N	253519	0	195662009	4112343		0
75285	4472	40481087	1971-11-09	1971-11-09 00:00:00	1971-11-16	1971-11-16 00:00:00	32020		\N	297484	0	444814009	40481087		0
64815	3833	30753	2000-12-12	2000-12-12 00:00:00	\N	\N	32020		\N	254516	0	16761005	30753		0
75549	4484	40481087	2005-02-18	2005-02-18 00:00:00	2005-03-11	2005-03-11 00:00:00	32020		\N	298464	0	444814009	40481087		0
65206	3857	260139	1972-05-25	1972-05-25 00:00:00	1972-06-08	1972-06-08 00:00:00	32020		\N	255982	0	10509002	260139		0
65371	3866	4109685	1968-04-30	1968-04-30 00:00:00	1968-05-21	1968-05-21 00:00:00	32020		\N	256700	0	284551006	4109685		0
76031	4509	4156265	1991-11-21	1991-11-21 00:00:00	1991-12-05	1991-12-05 00:00:00	32020		\N	300401	0	370247008	4156265		0
76296	4526	4278672	1987-08-12	1987-08-12 00:00:00	1987-11-10	1987-11-10 00:00:00	32020		\N	301374	0	65966004	4278672		0
76458	4532	372328	1912-10-17	1912-10-17 00:00:00	1913-03-22	1913-03-22 00:00:00	32020		\N	301883	0	65363002	372328		0
76564	4538	260139	1986-09-21	1986-09-21 00:00:00	1986-09-28	1986-09-28 00:00:00	32020		\N	302389	0	10509002	260139		0
76728	4547	4059173	2016-10-02	2016-10-02 00:00:00	2016-12-01	2016-12-01 00:00:00	32020		\N	302964	0	16114001	4059173		0
76895	4557	40481087	1996-06-25	1996-06-25 00:00:00	1996-07-09	1996-07-09 00:00:00	32020		\N	303656	0	444814009	40481087		0
66536	3938	80180	1949-06-06	1949-06-06 00:00:00	\N	\N	32020		\N	261750	0	396275006	80180		0
77313	4579	80180	2008-03-20	2008-03-20 00:00:00	\N	\N	32020		\N	305050	0	396275006	80180		0
77433	4587	40481087	1976-10-17	1976-10-17 00:00:00	1976-10-31	1976-10-31 00:00:00	32020		\N	305606	0	444814009	40481087		0
77581	4596	260139	1957-06-18	1957-06-18 00:00:00	1957-06-25	1957-06-25 00:00:00	32020		\N	306287	0	10509002	260139		0
77713	4603	4112343	2007-05-12	2007-05-12 00:00:00	2007-05-22	2007-05-22 00:00:00	32020		\N	306666	0	195662009	4112343		0
88533	5262	4310024	2008-01-24	2008-01-24 00:00:00	\N	\N	32020		\N	350076	0	424802006	4310024		0
78062	4625	4142905	1975-03-29	1975-03-29 00:00:00	1975-06-27	1975-06-27 00:00:00	32020		\N	308129	0	33737001	4142905		0
78190	4631	260139	1978-03-27	1978-03-27 00:00:00	1978-04-03	1978-04-03 00:00:00	32020		\N	308533	0	10509002	260139		0
78375	4641	40481087	1999-12-12	1999-12-12 00:00:00	2000-01-02	2000-01-02 00:00:00	32020		\N	309288	0	444814009	40481087		0
78565	4653	28060	1964-09-24	1964-09-24 00:00:00	1964-10-04	1964-10-04 00:00:00	32020		\N	310166	0	43878008	28060		0
78690	4660	40481087	2017-03-23	2017-03-23 00:00:00	2017-04-13	2017-04-13 00:00:00	32020		\N	310636	0	444814009	40481087		0
78969	4675	40481087	2009-10-31	2009-10-31 00:00:00	2009-11-21	2009-11-21 00:00:00	32020		\N	311577	0	444814009	40481087		0
79054	4680	4112343	1982-01-14	1982-01-14 00:00:00	1982-01-24	1982-01-24 00:00:00	32020		\N	311936	0	195662009	4112343		0
79255	4691	257012	1963-05-25	1963-05-25 00:00:00	\N	\N	32020		\N	312585	0	40055000	257012		0
79451	4705	4134304	1975-11-27	1975-11-27 00:00:00	1975-12-27	1975-12-27 00:00:00	32020		\N	313434	0	263102004	4134304		0
69007	4085	40481087	1959-05-09	1959-05-09 00:00:00	1959-05-23	1959-05-23 00:00:00	32020		\N	271478	0	444814009	40481087		0
79685	4720	4027663	2004-06-08	2004-06-08 00:00:00	\N	\N	32020		\N	314346	0	13200003	4027663		0
79997	4739	80180	1952-01-31	1952-01-31 00:00:00	\N	\N	32020		\N	315740	0	396275006	80180		0
69451	4109	4112343	2011-01-21	2011-01-21 00:00:00	2011-01-28	2011-01-28 00:00:00	32020		\N	273115	0	195662009	4112343		0
69656	4121	4112343	1923-12-22	1923-12-22 00:00:00	1924-01-02	1924-01-02 00:00:00	32020		\N	273955	0	195662009	4112343		0
80424	4763	257012	1997-10-15	1997-10-15 00:00:00	\N	\N	32020		\N	317416	0	40055000	257012		0
80684	4784	81151	2018-08-28	2018-08-28 00:00:00	2018-10-02	2018-10-02 00:00:00	32020		\N	318453	0	44465007	81151		0
80933	4800	28060	1970-12-29	1970-12-29 00:00:00	1971-01-09	1971-01-09 00:00:00	32020		\N	319322	0	43878008	28060		0
81317	4822	4112343	2018-07-27	2018-07-27 00:00:00	2018-08-03	2018-08-03 00:00:00	32020		\N	320758	0	195662009	4112343		0
81377	4827	4310024	1989-04-27	1989-04-27 00:00:00	\N	\N	32020		\N	321181	0	424802006	4310024		0
71048	4214	257012	2004-03-31	2004-03-31 00:00:00	\N	\N	32020		\N	279802	0	40055000	257012		0
71154	4220	4152936	1995-04-21	1995-04-21 00:00:00	1995-05-12	1995-05-12 00:00:00	32020		\N	280152	0	283385000	4152936		0
81883	4855	81893	2012-12-30	2012-12-30 00:00:00	\N	\N	32020		\N	323028	0	64766004	81893		0
71508	4241	4156265	1965-10-22	1965-10-22 00:00:00	1965-11-12	1965-11-12 00:00:00	32020		\N	281747	0	370247008	4156265		0
82238	4878	78272	1969-10-21	1969-10-21 00:00:00	1969-11-11	1969-11-11 00:00:00	32020		\N	324429	0	70704007	78272		0
82344	4884	4112343	2004-08-22	2004-08-22 00:00:00	2004-08-31	2004-08-31 00:00:00	32020		\N	324747	0	195662009	4112343		0
72038	4275	30753	2016-11-24	2016-11-24 00:00:00	\N	\N	32020		\N	283711	0	16761005	30753		0
72160	4282	40481087	1991-04-08	1991-04-08 00:00:00	1991-04-29	1991-04-29 00:00:00	32020		\N	284168	0	444814009	40481087		0
72322	4291	40481087	2015-01-18	2015-01-18 00:00:00	2015-01-25	2015-01-25 00:00:00	32020		\N	284881	0	444814009	40481087		0
83104	4935	440448	1995-09-18	1995-09-18 00:00:00	\N	\N	32020		\N	328155	0	74400008	440448		0
83238	4945	260139	1992-11-22	1992-11-22 00:00:00	1992-12-06	1992-12-06 00:00:00	32020		\N	328711	0	10509002	260139		0
83336	4952	40481087	1976-12-10	1976-12-10 00:00:00	1976-12-17	1976-12-17 00:00:00	32020		\N	329142	0	444814009	40481087		0
83741	4975	4296205	1965-03-09	1965-03-09 00:00:00	1965-03-30	1965-03-30 00:00:00	32020		\N	330917	0	403191005	4296205		0
83907	4986	4112343	2009-03-03	2009-03-03 00:00:00	2009-03-10	2009-03-10 00:00:00	32020		\N	331652	0	195662009	4112343		0
84131	4998	80180	2003-08-16	2003-08-16 00:00:00	\N	\N	32020		\N	332333	0	396275006	80180		0
73634	4376	28060	1951-05-01	1951-05-01 00:00:00	1951-05-12	1951-05-12 00:00:00	32020		\N	290743	0	43878008	28060		0
84410	5017	4283893	1993-09-27	1993-09-27 00:00:00	1993-11-22	1993-11-22 00:00:00	32020		\N	333448	0	36971009	4283893		0
84643	5034	4112343	1951-01-19	1951-01-19 00:00:00	1951-01-26	1951-01-26 00:00:00	32020		\N	334438	0	195662009	4112343		0
84738	5039	40481087	1981-08-22	1981-08-22 00:00:00	1981-08-29	1981-08-29 00:00:00	32020		\N	334861	0	444814009	40481087		0
84950	5051	260139	1998-07-08	1998-07-08 00:00:00	1998-07-22	1998-07-22 00:00:00	32020		\N	335890	0	10509002	260139		0
85009	5056	81151	2013-09-30	2013-09-30 00:00:00	2013-10-14	2013-10-14 00:00:00	32020		\N	336182	0	44465007	81151		0
74694	4436	40479422	2017-06-22	2017-06-22 00:00:00	2017-08-28	2017-08-28 00:00:00	32020		\N	294883	0	444448004	40479422		0
74722	4437	4027663	2000-01-01	2000-01-01 00:00:00	\N	\N	32020		\N	294899	0	13200003	4027663		0
74881	4448	378001	1966-09-09	1966-09-09 00:00:00	1966-11-08	1966-11-08 00:00:00	32020		\N	295896	0	62106007	378001		0
64554	3817	4112343	2008-06-12	2008-06-12 00:00:00	2008-06-23	2008-06-23 00:00:00	32020		\N	253522	0	195662009	4112343		0
75286	4472	40481087	1986-02-24	1986-02-24 00:00:00	1986-03-10	1986-03-10 00:00:00	32020		\N	297527	0	444814009	40481087		0
64816	3833	81893	2000-09-13	2000-09-13 00:00:00	\N	\N	32020		\N	254516	0	64766004	81893		0
75550	4484	28060	2001-01-15	2001-01-15 00:00:00	2001-01-24	2001-01-24 00:00:00	32020		\N	298494	0	43878008	28060		0
65207	3857	4283893	1948-07-02	1948-07-02 00:00:00	1949-02-04	1949-02-04 00:00:00	32020		\N	256015	0	36971009	4283893		0
65372	3866	4112343	2018-08-30	2018-08-30 00:00:00	2018-09-11	2018-09-11 00:00:00	32020		\N	256763	0	195662009	4112343		0
76032	4509	4310024	2005-01-16	2005-01-16 00:00:00	\N	\N	32020		\N	300387	0	424802006	4310024		0
76297	4526	260139	1962-10-23	1962-10-23 00:00:00	1962-11-06	1962-11-06 00:00:00	32020		\N	301351	0	10509002	260139		0
76459	4532	378419	1989-03-04	1989-03-04 00:00:00	\N	\N	32020		\N	301947	0	26929004	378419		0
76565	4538	4112343	1958-06-01	1958-06-01 00:00:00	1958-06-11	1958-06-11 00:00:00	32020		\N	302331	0	195662009	4112343		0
76729	4547	40480160	2016-10-02	2016-10-02 00:00:00	2016-12-01	2016-12-01 00:00:00	32020		\N	302964	0	443165006	40480160		0
76896	4557	372328	1925-08-20	1925-08-20 00:00:00	1926-04-04	1926-04-04 00:00:00	32020		\N	303565	0	65363002	372328		0
66537	3938	40481087	1943-11-01	1943-11-01 00:00:00	1943-11-08	1943-11-08 00:00:00	32020		\N	261719	0	444814009	40481087		0
77314	4579	260139	2001-02-28	2001-02-28 00:00:00	2001-03-14	2001-03-14 00:00:00	32020		\N	305030	0	10509002	260139		0
77434	4587	80180	1968-04-24	1968-04-24 00:00:00	\N	\N	32020		\N	305609	0	396275006	80180		0
77582	4596	40481087	1974-04-06	1974-04-06 00:00:00	1974-04-20	1974-04-20 00:00:00	32020		\N	306262	0	444814009	40481087		0
77714	4603	40481087	2008-02-07	2008-02-07 00:00:00	2008-02-28	2008-02-28 00:00:00	32020		\N	306655	0	444814009	40481087		0
69680	4123	4285898	1998-08-10	1998-08-10 00:00:00	\N	\N	32020		\N	274117	0	68496003	4285898		0
88534	5262	4113008	2007-01-29	2007-01-29 00:00:00	2007-02-19	2007-02-19 00:00:00	32020		\N	350076	0	284549007	4113008		0
78063	4625	260139	1985-08-24	1985-08-24 00:00:00	1985-08-31	1985-08-31 00:00:00	32020		\N	308133	0	10509002	260139		0
78191	4631	260139	1939-10-21	1939-10-21 00:00:00	1939-11-04	1939-11-04 00:00:00	32020		\N	308573	0	10509002	260139		0
78376	4641	260139	1981-07-12	1981-07-12 00:00:00	1981-07-26	1981-07-26 00:00:00	32020		\N	309304	0	10509002	260139		0
78566	4653	40481087	1980-01-04	1980-01-04 00:00:00	1980-01-25	1980-01-25 00:00:00	32020		\N	310127	0	444814009	40481087		0
78691	4660	260139	1995-11-24	1995-11-24 00:00:00	1995-12-08	1995-12-08 00:00:00	32020		\N	310599	0	10509002	260139		0
78970	4675	4112343	1986-06-09	1986-06-09 00:00:00	1986-06-19	1986-06-19 00:00:00	32020		\N	311552	0	195662009	4112343		0
79055	4680	380378	1946-11-11	1946-11-11 00:00:00	\N	\N	32020		\N	311944	0	84757009	380378		0
79256	4691	4283893	1977-05-18	1977-05-18 00:00:00	1977-07-27	1977-07-27 00:00:00	32020		\N	312601	0	36971009	4283893		0
79452	4705	260139	1984-11-28	1984-11-28 00:00:00	1984-12-05	1984-12-05 00:00:00	32020		\N	313476	0	10509002	260139		0
69008	4085	257012	1962-02-23	1962-02-23 00:00:00	\N	\N	32020		\N	271480	0	40055000	257012		0
79686	4720	195588	2016-06-05	2016-06-05 00:00:00	2016-07-23	2016-07-23 00:00:00	32020		\N	314375	0	38822007	195588		0
79998	4739	4109685	1954-09-03	1954-09-03 00:00:00	1954-09-17	1954-09-17 00:00:00	32020		\N	315730	0	284551006	4109685		0
69452	4109	40481087	2010-07-27	2010-07-27 00:00:00	2010-08-17	2010-08-17 00:00:00	32020		\N	273175	0	444814009	40481087		0
69657	4121	4112343	1958-09-04	1958-09-04 00:00:00	1958-09-13	1958-09-13 00:00:00	32020		\N	273995	0	195662009	4112343		0
80425	4763	4112343	1950-10-22	1950-10-22 00:00:00	1950-11-01	1950-11-01 00:00:00	32020		\N	317403	0	195662009	4112343		0
80685	4784	4113008	1998-07-09	1998-07-09 00:00:00	1998-07-23	1998-07-23 00:00:00	32020		\N	318451	0	284549007	4113008		0
80934	4800	4134304	1989-07-27	1989-07-27 00:00:00	1989-10-25	1989-10-25 00:00:00	32020		\N	319296	0	263102004	4134304		0
81318	4822	80180	1987-07-31	1987-07-31 00:00:00	\N	\N	32020		\N	320787	0	396275006	80180		0
81378	4827	81893	1989-06-26	1989-06-26 00:00:00	\N	\N	32020		\N	321181	0	64766004	81893		0
81507	4834	81151	2001-06-05	2001-06-05 00:00:00	2001-07-10	2001-07-10 00:00:00	32020		\N	321549	0	44465007	81151		0
71155	4220	4027663	1966-12-24	1966-12-24 00:00:00	\N	\N	32020		\N	280220	0	13200003	4027663		0
81884	4855	4310024	2012-11-30	2012-11-30 00:00:00	\N	\N	32020		\N	323028	0	424802006	4310024		0
71509	4241	372328	1987-12-26	1987-12-26 00:00:00	1990-03-06	1990-03-06 00:00:00	32020		\N	281694	0	65363002	372328		0
82239	4878	260139	1988-01-25	1988-01-25 00:00:00	1988-02-08	1988-02-08 00:00:00	32020		\N	324346	0	10509002	260139		0
82345	4884	4112343	2001-08-24	2001-08-24 00:00:00	2001-09-04	2001-09-04 00:00:00	32020		\N	324756	0	195662009	4112343		0
72039	4275	40481087	2015-02-06	2015-02-06 00:00:00	2015-02-13	2015-02-13 00:00:00	32020		\N	283711	0	444814009	40481087		0
72161	4282	40481087	2012-05-25	2012-05-25 00:00:00	2012-06-01	2012-06-01 00:00:00	32020		\N	284169	0	444814009	40481087		0
72323	4291	4112343	1997-03-25	1997-03-25 00:00:00	1997-04-04	1997-04-04 00:00:00	32020		\N	284914	0	195662009	4112343		0
83105	4935	4166224	1995-09-18	1995-09-18 00:00:00	\N	\N	32020		\N	328155	0	47693006	4166224		0
83239	4945	4116491	1985-04-21	1985-04-21 00:00:00	1985-05-28	1985-05-28 00:00:00	32020		\N	328723	0	301011002	4116491		0
83337	4952	4296205	1994-07-13	1994-07-13 00:00:00	1994-08-03	1994-08-03 00:00:00	32020		\N	329122	0	403191005	4296205		0
83742	4975	4285898	2003-09-16	2003-09-16 00:00:00	\N	\N	32020		\N	330857	0	68496003	4285898		0
83908	4986	40481087	1956-12-25	1956-12-25 00:00:00	1957-01-01	1957-01-01 00:00:00	32020		\N	331678	0	444814009	40481087		0
84132	4998	4285898	2002-10-20	2002-10-20 00:00:00	\N	\N	32020		\N	332333	0	68496003	4285898		0
73635	4376	40481087	1926-08-26	1926-08-26 00:00:00	1926-09-02	1926-09-02 00:00:00	32020		\N	290768	0	444814009	40481087		0
84411	5017	80180	2015-06-27	2015-06-27 00:00:00	\N	\N	32020		\N	333460	0	396275006	80180		0
84644	5034	260139	1930-12-22	1930-12-22 00:00:00	1930-12-29	1930-12-29 00:00:00	32020		\N	334526	0	10509002	260139		0
84739	5039	260139	2019-02-11	2019-02-11 00:00:00	2019-02-25	2019-02-25 00:00:00	32020		\N	334895	0	10509002	260139		0
84951	5051	81151	1996-12-05	1996-12-05 00:00:00	1997-01-02	1997-01-02 00:00:00	32020		\N	335906	0	44465007	81151		0
85010	5056	4112343	1996-10-30	1996-10-30 00:00:00	1996-11-06	1996-11-06 00:00:00	32020		\N	336143	0	195662009	4112343		0
74695	4436	40481087	1990-10-10	1990-10-10 00:00:00	1990-10-31	1990-10-31 00:00:00	32020		\N	294824	0	444814009	40481087		0
74723	4437	372328	1969-10-05	1969-10-05 00:00:00	1969-12-17	1969-12-17 00:00:00	32020		\N	294926	0	65363002	372328		0
74882	4448	4294548	2009-11-23	2009-11-23 00:00:00	2010-03-29	2010-03-29 00:00:00	32020		\N	295900	0	75498004	4294548		0
64555	3817	40481087	2007-01-27	2007-01-27 00:00:00	2007-02-03	2007-02-03 00:00:00	32020		\N	253512	0	444814009	40481087		0
75287	4472	28060	1938-10-26	1938-10-26 00:00:00	1938-11-07	1938-11-07 00:00:00	32020		\N	297513	0	43878008	28060		0
64817	3833	4112343	1971-01-02	1971-01-02 00:00:00	1971-01-14	1971-01-14 00:00:00	32020		\N	254482	0	195662009	4112343		0
75551	4484	372328	2019-05-11	2019-05-11 00:00:00	2019-06-20	2019-06-20 00:00:00	32020		\N	298497	0	65363002	372328		0
65208	3857	4112343	1996-06-25	1996-06-25 00:00:00	1996-07-05	1996-07-05 00:00:00	32020		\N	256031	0	195662009	4112343		0
65373	3866	40481087	1960-02-23	1960-02-23 00:00:00	1960-03-08	1960-03-08 00:00:00	32020		\N	256761	0	444814009	40481087		0
76033	4509	40481087	2003-11-04	2003-11-04 00:00:00	2003-11-18	2003-11-18 00:00:00	32020		\N	300387	0	444814009	40481087		0
76298	4526	372328	1954-09-04	1954-09-04 00:00:00	1954-09-18	1954-09-18 00:00:00	32020		\N	301336	0	65363002	372328		0
76460	4532	260139	1943-04-20	1943-04-20 00:00:00	1943-05-04	1943-05-04 00:00:00	32020		\N	301831	0	10509002	260139		0
76566	4538	40481087	1960-05-28	1960-05-28 00:00:00	1960-06-04	1960-06-04 00:00:00	32020		\N	302349	0	444814009	40481087		0
76730	4547	260139	1943-10-17	1943-10-17 00:00:00	1943-10-24	1943-10-24 00:00:00	32020		\N	302843	0	10509002	260139		0
76897	4557	40481087	1998-11-03	1998-11-03 00:00:00	1998-11-10	1998-11-10 00:00:00	32020		\N	303657	0	444814009	40481087		0
66538	3938	4112343	1916-06-20	1916-06-20 00:00:00	1916-07-03	1916-07-03 00:00:00	32020		\N	261773	0	195662009	4112343		0
77315	4579	372328	1969-10-01	1969-10-01 00:00:00	1970-01-16	1970-01-16 00:00:00	32020		\N	305011	0	65363002	372328		0
77435	4587	260139	1967-02-25	1967-02-25 00:00:00	1967-03-04	1967-03-04 00:00:00	32020		\N	305609	0	10509002	260139		0
77583	4596	4112343	1993-08-25	1993-08-25 00:00:00	1993-09-03	1993-09-03 00:00:00	32020		\N	306292	0	195662009	4112343		0
77715	4603	4156265	2014-03-19	2014-03-19 00:00:00	2014-04-09	2014-04-09 00:00:00	32020		\N	306624	0	370247008	4156265		0
88535	5262	40481087	2014-09-03	2014-09-03 00:00:00	2014-09-17	2014-09-17 00:00:00	32020		\N	350086	0	444814009	40481087		0
78064	4625	81151	1977-04-17	1977-04-17 00:00:00	1977-05-08	1977-05-08 00:00:00	32020		\N	308130	0	44465007	81151		0
78192	4631	40481087	1948-09-11	1948-09-11 00:00:00	1948-09-18	1948-09-18 00:00:00	32020		\N	308605	0	444814009	40481087		0
78377	4641	378001	1990-04-13	1990-04-13 00:00:00	1990-05-13	1990-05-13 00:00:00	32020		\N	309324	0	62106007	378001		0
78567	4653	372328	1959-06-22	1959-06-22 00:00:00	1959-08-02	1959-08-02 00:00:00	32020		\N	310141	0	65363002	372328		0
78692	4660	81151	1967-06-01	1967-06-01 00:00:00	1967-06-15	1967-06-15 00:00:00	32020		\N	310651	0	44465007	81151		0
78971	4675	260139	1984-08-28	1984-08-28 00:00:00	1984-09-11	1984-09-11 00:00:00	32020		\N	311438	0	10509002	260139		0
79056	4680	260139	1950-06-21	1950-06-21 00:00:00	1950-06-28	1950-06-28 00:00:00	32020		\N	311886	0	10509002	260139		0
79257	4691	4294548	1977-02-18	1977-02-18 00:00:00	1977-03-11	1977-03-11 00:00:00	32020		\N	312588	0	75498004	4294548		0
79453	4705	40481087	2010-07-22	2010-07-22 00:00:00	2010-08-05	2010-08-05 00:00:00	32020		\N	313492	0	444814009	40481087		0
69009	4085	28060	1997-09-04	1997-09-04 00:00:00	1997-09-13	1997-09-13 00:00:00	32020		\N	271541	0	43878008	28060		0
79687	4720	40481087	2006-08-17	2006-08-17 00:00:00	2006-09-07	2006-09-07 00:00:00	32020		\N	314374	0	444814009	40481087		0
79999	4739	4112343	1937-09-18	1937-09-18 00:00:00	1937-09-25	1937-09-25 00:00:00	32020		\N	315700	0	195662009	4112343		0
69453	4109	4116491	2007-12-31	2007-12-31 00:00:00	2008-02-17	2008-02-17 00:00:00	32020		\N	273172	0	301011002	4116491		0
69658	4121	40481087	1959-01-14	1959-01-14 00:00:00	1959-01-28	1959-01-28 00:00:00	32020		\N	273996	0	444814009	40481087		0
80426	4763	4035415	1983-06-21	1983-06-21 00:00:00	1983-07-21	1983-07-21 00:00:00	32020		\N	317455	0	239720000	4035415		0
80686	4784	260139	1971-01-15	1971-01-15 00:00:00	1971-01-29	1971-01-29 00:00:00	32020		\N	318494	0	10509002	260139		0
80935	4800	260139	1973-06-17	1973-06-17 00:00:00	1973-07-01	1973-07-01 00:00:00	32020		\N	319327	0	10509002	260139		0
81319	4822	372328	1950-11-01	1950-11-01 00:00:00	1951-03-07	1951-03-07 00:00:00	32020		\N	320717	0	65363002	372328		0
81379	4827	40481087	1973-07-03	1973-07-03 00:00:00	1973-07-10	1973-07-10 00:00:00	32020		\N	321137	0	444814009	40481087		0
81508	4835	4294548	1998-01-22	1998-01-22 00:00:00	1998-04-24	1998-04-24 00:00:00	32020		\N	321632	0	75498004	4294548		0
71156	4220	40481087	1966-08-29	1966-08-29 00:00:00	1966-09-19	1966-09-19 00:00:00	32020		\N	280220	0	444814009	40481087		0
81885	4855	4285898	2013-11-25	2013-11-25 00:00:00	\N	\N	32020		\N	323028	0	68496003	4285898		0
71510	4241	40481087	1990-07-10	1990-07-10 00:00:00	1990-07-31	1990-07-31 00:00:00	32020		\N	281701	0	444814009	40481087		0
82240	4878	40481087	1985-06-30	1985-06-30 00:00:00	1985-07-14	1985-07-14 00:00:00	32020		\N	324402	0	444814009	40481087		0
82346	4884	4112343	1979-09-08	1979-09-08 00:00:00	1979-09-16	1979-09-16 00:00:00	32020		\N	324776	0	195662009	4112343		0
72040	4275	81893	2016-06-28	2016-06-28 00:00:00	\N	\N	32020		\N	283711	0	64766004	81893		0
72162	4282	381316	2007-10-10	2007-10-10 00:00:00	\N	\N	32020		\N	284176	0	230690007	381316		0
72324	4291	40481087	1989-05-30	1989-05-30 00:00:00	1989-06-06	1989-06-06 00:00:00	32020		\N	284879	0	444814009	40481087		0
83164	4942	4218389	1985-09-09	1985-09-09 00:00:00	1985-09-30	1985-09-30 00:00:00	32020		\N	328465	0	39848009	4218389		0
83240	4945	4112343	1992-04-11	1992-04-11 00:00:00	1992-04-19	1992-04-19 00:00:00	32020		\N	328726	0	195662009	4112343		0
83338	4952	257012	1972-05-04	1972-05-04 00:00:00	\N	\N	32020		\N	329123	0	40055000	257012		0
83743	4975	80180	2004-01-14	2004-01-14 00:00:00	\N	\N	32020		\N	330857	0	396275006	80180		0
83909	4986	40481087	1971-06-06	1971-06-06 00:00:00	1971-06-13	1971-06-13 00:00:00	32020		\N	331679	0	444814009	40481087		0
84133	4998	40481087	2001-08-30	2001-08-30 00:00:00	2001-09-13	2001-09-13 00:00:00	32020		\N	332333	0	444814009	40481087		0
73636	4376	261325	1975-07-01	1975-07-01 00:00:00	\N	\N	32020		\N	290816	0	87433001	261325		0
84412	5017	40481087	1986-10-14	1986-10-14 00:00:00	1986-10-28	1986-10-28 00:00:00	32020		\N	333437	0	444814009	40481087		0
84645	5034	372328	1922-11-08	1922-11-08 00:00:00	1923-01-20	1923-01-20 00:00:00	32020		\N	334521	0	65363002	372328		0
84740	5039	80180	2010-10-02	2010-10-02 00:00:00	\N	\N	32020		\N	334908	0	396275006	80180		0
84952	5051	40481087	2014-09-17	2014-09-17 00:00:00	2014-09-24	2014-09-24 00:00:00	32020		\N	335843	0	444814009	40481087		0
85011	5056	4027663	1969-02-16	1969-02-16 00:00:00	\N	\N	32020		\N	336228	0	13200003	4027663		0
74696	4436	375671	1988-06-10	1988-06-10 00:00:00	1988-07-10	1988-07-10 00:00:00	32020		\N	294880	0	62564004	375671		0
74737	4439	372328	1955-07-17	1955-07-17 00:00:00	1955-08-17	1955-08-17 00:00:00	32020		\N	295128	0	65363002	372328		0
74883	4448	40481087	1969-06-01	1969-06-01 00:00:00	1969-06-08	1969-06-08 00:00:00	32020		\N	295878	0	444814009	40481087		0
64556	3817	80180	2000-05-29	2000-05-29 00:00:00	\N	\N	32020		\N	253499	0	396275006	80180		0
75288	4472	4112343	1964-05-08	1964-05-08 00:00:00	1964-05-19	1964-05-19 00:00:00	32020		\N	297481	0	195662009	4112343		0
64818	3833	4142905	1971-04-29	1971-04-29 00:00:00	1971-06-28	1971-06-28 00:00:00	32020		\N	254525	0	33737001	4142905		0
75552	4484	260139	2011-09-09	2011-09-09 00:00:00	2011-09-16	2011-09-16 00:00:00	32020		\N	298465	0	10509002	260139		0
65209	3857	40481087	2001-08-24	2001-08-24 00:00:00	2001-08-31	2001-08-31 00:00:00	32020		\N	256006	0	444814009	40481087		0
65374	3866	40481087	1951-06-11	1951-06-11 00:00:00	1951-06-25	1951-06-25 00:00:00	32020		\N	256719	0	444814009	40481087		0
76034	4509	4266809	2006-11-07	2006-11-07 00:00:00	\N	\N	32020		\N	300398	0	397881000	4266809		0
76299	4526	28060	1997-07-29	1997-07-29 00:00:00	1997-08-10	1997-08-10 00:00:00	32020		\N	301365	0	43878008	28060		0
76461	4532	40481087	1954-01-19	1954-01-19 00:00:00	1954-02-09	1954-02-09 00:00:00	32020		\N	301833	0	444814009	40481087		0
76567	4538	40481087	1977-02-25	1977-02-25 00:00:00	1977-03-18	1977-03-18 00:00:00	32020		\N	302350	0	444814009	40481087		0
76731	4547	40481087	1938-07-16	1938-07-16 00:00:00	1938-07-30	1938-07-30 00:00:00	32020		\N	302858	0	444814009	40481087		0
76898	4557	4283893	2011-03-02	2011-03-02 00:00:00	2011-03-30	2011-03-30 00:00:00	32020		\N	303659	0	36971009	4283893		0
66539	3938	195588	1938-03-15	1938-03-15 00:00:00	1938-05-10	1938-05-10 00:00:00	32020		\N	261702	0	38822007	195588		0
77316	4579	40481087	1973-09-16	1973-09-16 00:00:00	1973-09-30	1973-09-30 00:00:00	32020		\N	305071	0	444814009	40481087		0
77436	4587	381316	2017-11-18	2017-11-18 00:00:00	\N	\N	32020		\N	305610	0	230690007	381316		0
77584	4596	260139	1957-10-25	1957-10-25 00:00:00	1957-11-08	1957-11-08 00:00:00	32020		\N	306254	0	10509002	260139		0
77716	4604	40481087	2014-12-11	2014-12-11 00:00:00	2014-12-18	2014-12-18 00:00:00	32020		\N	306750	0	444814009	40481087		0
88536	5262	260139	2008-06-22	2008-06-22 00:00:00	2008-06-29	2008-06-29 00:00:00	32020		\N	350122	0	10509002	260139		0
78065	4625	80180	2001-10-25	2001-10-25 00:00:00	\N	\N	32020		\N	308140	0	396275006	80180		0
78193	4631	40481087	1947-07-28	1947-07-28 00:00:00	1947-08-11	1947-08-11 00:00:00	32020		\N	308604	0	444814009	40481087		0
78378	4641	40481087	1979-10-03	1979-10-03 00:00:00	1979-10-10	1979-10-10 00:00:00	32020		\N	309328	0	444814009	40481087		0
78568	4653	4283893	1992-08-24	1992-08-24 00:00:00	1992-11-02	1992-11-02 00:00:00	32020		\N	310169	0	36971009	4283893		0
78693	4660	260139	1989-01-02	1989-01-02 00:00:00	1989-01-16	1989-01-16 00:00:00	32020		\N	310608	0	10509002	260139		0
78972	4676	81151	2002-11-04	2002-11-04 00:00:00	2002-11-25	2002-11-25 00:00:00	32020		\N	311621	0	44465007	81151		0
79057	4680	40481087	1911-02-14	1911-02-14 00:00:00	1911-02-28	1911-02-28 00:00:00	32020		\N	311953	0	444814009	40481087		0
79258	4691	4278672	1969-05-20	1969-05-20 00:00:00	1969-08-18	1969-08-18 00:00:00	32020		\N	312597	0	65966004	4278672		0
79454	4705	40481087	1999-04-08	1999-04-08 00:00:00	1999-04-15	1999-04-15 00:00:00	32020		\N	313480	0	444814009	40481087		0
69010	4085	80180	1998-03-13	1998-03-13 00:00:00	\N	\N	32020		\N	271541	0	396275006	80180		0
79688	4720	439777	2007-06-08	2007-06-08 00:00:00	\N	\N	32020		\N	314409	0	271737000	439777		0
80000	4739	260139	1930-08-05	1930-08-05 00:00:00	1930-08-12	1930-08-12 00:00:00	32020		\N	315682	0	10509002	260139		0
69454	4109	4116491	2004-11-21	2004-11-21 00:00:00	2004-12-31	2004-12-31 00:00:00	32020		\N	273079	0	301011002	4116491		0
69659	4122	40481087	1994-04-19	1994-04-19 00:00:00	1994-04-26	1994-04-26 00:00:00	32020		\N	274031	0	444814009	40481087		0
80427	4763	372328	1955-09-09	1955-09-09 00:00:00	1956-08-07	1956-08-07 00:00:00	32020		\N	317382	0	65363002	372328		0
80687	4784	4218389	1967-04-02	1967-04-02 00:00:00	1967-04-23	1967-04-23 00:00:00	32020		\N	318450	0	39848009	4218389		0
80936	4801	378001	1978-07-17	1978-07-17 00:00:00	1978-08-16	1978-08-16 00:00:00	32020		\N	319420	0	62106007	378001		0
81380	4827	4112343	1983-03-18	1983-03-18 00:00:00	1983-03-29	1983-03-29 00:00:00	32020		\N	321159	0	195662009	4112343		0
81509	4835	257012	1998-04-02	1998-04-02 00:00:00	\N	\N	32020		\N	321655	0	40055000	257012		0
71157	4220	4112343	1995-06-27	1995-06-27 00:00:00	1995-07-07	1995-07-07 00:00:00	32020		\N	280224	0	195662009	4112343		0
71511	4241	4112343	1985-10-08	1985-10-08 00:00:00	1985-10-15	1985-10-15 00:00:00	32020		\N	281693	0	195662009	4112343		0
82241	4878	4027663	1987-12-30	1987-12-30 00:00:00	\N	\N	32020		\N	324402	0	13200003	4027663		0
82347	4884	40481087	1982-01-31	1982-01-31 00:00:00	1982-02-14	1982-02-14 00:00:00	32020		\N	324798	0	444814009	40481087		0
72041	4275	28060	2008-07-29	2008-07-29 00:00:00	2008-08-08	2008-08-08 00:00:00	32020		\N	283710	0	43878008	28060		0
72164	4282	40481087	1967-03-10	1967-03-10 00:00:00	1967-03-31	1967-03-31 00:00:00	32020		\N	284165	0	444814009	40481087		0
72325	4291	372328	1974-02-21	1974-02-21 00:00:00	1974-05-03	1974-05-03 00:00:00	32020		\N	284904	0	65363002	372328		0
83165	4942	381316	2006-08-03	2006-08-03 00:00:00	\N	\N	32020		\N	328522	0	230690007	381316		0
83241	4945	28060	1994-11-08	1994-11-08 00:00:00	1994-11-18	1994-11-18 00:00:00	32020		\N	328727	0	43878008	28060		0
83339	4952	80180	2008-11-01	2008-11-01 00:00:00	\N	\N	32020		\N	329180	0	396275006	80180		0
83744	4975	81893	2002-10-21	2002-10-21 00:00:00	\N	\N	32020		\N	330857	0	64766004	81893		0
83910	4986	40481087	1983-08-17	1983-08-17 00:00:00	1983-08-24	1983-08-24 00:00:00	32020		\N	331692	0	444814009	40481087		0
84134	4999	313217	2018-01-21	2018-01-21 00:00:00	\N	\N	32020		\N	332478	0	49436004	313217		0
73637	4376	40481087	1979-06-29	1979-06-29 00:00:00	1979-07-13	1979-07-13 00:00:00	32020		\N	290719	0	444814009	40481087		0
84413	5018	260139	2009-08-27	2009-08-27 00:00:00	2009-09-03	2009-09-03 00:00:00	32020		\N	333511	0	10509002	260139		0
84646	5034	4112343	1929-06-05	1929-06-05 00:00:00	1929-06-12	1929-06-12 00:00:00	32020		\N	334434	0	195662009	4112343		0
84741	5039	317576	2008-12-30	2008-12-30 00:00:00	\N	\N	32020		\N	334908	0	53741008	317576		0
84953	5051	372328	1983-09-15	1983-09-15 00:00:00	1983-11-10	1983-11-10 00:00:00	32020		\N	335892	0	65363002	372328		0
85012	5056	4112343	1967-05-25	1967-05-25 00:00:00	1967-06-06	1967-06-06 00:00:00	32020		\N	336228	0	195662009	4112343		0
74697	4436	81893	2006-01-13	2006-01-13 00:00:00	\N	\N	32020		\N	294848	0	64766004	81893		0
74738	4439	260139	1989-07-08	1989-07-08 00:00:00	1989-07-22	1989-07-22 00:00:00	32020		\N	295127	0	10509002	260139		0
74884	4448	257012	2010-01-25	2010-01-25 00:00:00	\N	\N	32020		\N	295856	0	40055000	257012		0
64557	3817	4112343	1984-12-19	1984-12-19 00:00:00	1984-12-31	1984-12-31 00:00:00	32020		\N	253488	0	195662009	4112343		0
75289	4472	4112343	1978-06-18	1978-06-18 00:00:00	1978-06-27	1978-06-27 00:00:00	32020		\N	297485	0	195662009	4112343		0
64819	3833	372328	2011-04-06	2011-04-06 00:00:00	2013-03-27	2013-03-27 00:00:00	32020		\N	254530	0	65363002	372328		0
75553	4484	40481087	1997-02-11	1997-02-11 00:00:00	1997-02-25	1997-02-25 00:00:00	32020		\N	298504	0	444814009	40481087		0
65210	3857	4112343	1998-06-26	1998-06-26 00:00:00	1998-07-04	1998-07-04 00:00:00	32020		\N	255962	0	195662009	4112343		0
65375	3866	81151	2003-07-06	2003-07-06 00:00:00	2003-07-27	2003-07-27 00:00:00	32020		\N	256703	0	44465007	81151		0
76035	4509	80180	2006-11-07	2006-11-07 00:00:00	\N	\N	32020		\N	300398	0	396275006	80180		0
76300	4526	40481087	2017-03-13	2017-03-13 00:00:00	2017-03-27	2017-03-27 00:00:00	32020		\N	301335	0	444814009	40481087		0
76462	4532	40481087	1917-07-10	1917-07-10 00:00:00	1917-07-24	1917-07-24 00:00:00	32020		\N	301951	0	444814009	40481087		0
76568	4538	4027663	1978-05-09	1978-05-09 00:00:00	\N	\N	32020		\N	302350	0	13200003	4027663		0
76732	4547	4218389	1990-11-22	1990-11-22 00:00:00	1990-12-13	1990-12-13 00:00:00	32020		\N	302961	0	39848009	4218389		0
76899	4557	40481087	2002-05-31	2002-05-31 00:00:00	2002-06-21	2002-06-21 00:00:00	32020		\N	303658	0	444814009	40481087		0
66540	3938	378001	1952-03-11	1952-03-11 00:00:00	1952-05-11	1952-05-11 00:00:00	32020		\N	261808	0	62106007	378001		0
77317	4579	260139	1982-07-18	1982-07-18 00:00:00	1982-08-01	1982-08-01 00:00:00	32020		\N	305008	0	10509002	260139		0
77437	4587	4112343	2004-10-12	2004-10-12 00:00:00	2004-10-23	2004-10-23 00:00:00	32020		\N	305589	0	195662009	4112343		0
77585	4596	257012	1958-04-23	1958-04-23 00:00:00	\N	\N	32020		\N	306255	0	40055000	257012		0
77717	4604	260139	1987-10-23	1987-10-23 00:00:00	1987-10-30	1987-10-30 00:00:00	32020		\N	306714	0	10509002	260139		0
88537	5262	4278672	1990-12-24	1990-12-24 00:00:00	1991-03-24	1991-03-24 00:00:00	32020		\N	350075	0	65966004	4278672		0
78066	4625	40481087	1985-11-07	1985-11-07 00:00:00	1985-11-28	1985-11-28 00:00:00	32020		\N	308106	0	444814009	40481087		0
78194	4631	4112343	2005-12-19	2005-12-19 00:00:00	2005-12-28	2005-12-28 00:00:00	32020		\N	308642	0	195662009	4112343		0
78379	4641	372328	1975-05-02	1975-05-02 00:00:00	1975-07-10	1975-07-10 00:00:00	32020		\N	309299	0	65363002	372328		0
78569	4653	4112343	1989-03-01	1989-03-01 00:00:00	1989-03-08	1989-03-08 00:00:00	32020		\N	310194	0	195662009	4112343		0
78694	4660	40481087	1990-12-06	1990-12-06 00:00:00	1990-12-27	1990-12-27 00:00:00	32020		\N	310664	0	444814009	40481087		0
78973	4676	40481087	2013-03-03	2013-03-03 00:00:00	2013-03-17	2013-03-17 00:00:00	32020		\N	311613	0	444814009	40481087		0
79058	4680	40481087	1917-10-02	1917-10-02 00:00:00	1917-10-16	1917-10-16 00:00:00	32020		\N	311957	0	444814009	40481087		0
79259	4691	4283893	1963-04-27	1963-04-27 00:00:00	1963-08-03	1963-08-03 00:00:00	32020		\N	312571	0	36971009	4283893		0
79455	4705	4112343	1995-10-03	1995-10-03 00:00:00	1995-10-13	1995-10-13 00:00:00	32020		\N	313468	0	195662009	4112343		0
69011	4085	260139	2006-08-25	2006-08-25 00:00:00	2006-09-01	2006-09-01 00:00:00	32020		\N	271454	0	10509002	260139		0
79689	4720	260139	2009-11-07	2009-11-07 00:00:00	2009-11-14	2009-11-14 00:00:00	32020		\N	314378	0	10509002	260139		0
80001	4739	40481087	1981-07-15	1981-07-15 00:00:00	1981-07-29	1981-07-29 00:00:00	32020		\N	315765	0	444814009	40481087		0
69455	4109	372328	2013-08-05	2013-08-05 00:00:00	2014-12-02	2014-12-02 00:00:00	32020		\N	273062	0	65363002	372328		0
69660	4122	4027663	2002-01-07	2002-01-07 00:00:00	\N	\N	32020		\N	274027	0	13200003	4027663		0
80428	4763	40481087	1995-06-08	1995-06-08 00:00:00	1995-06-29	1995-06-29 00:00:00	32020		\N	317429	0	444814009	40481087		0
80688	4784	81151	1958-11-10	1958-11-10 00:00:00	1958-12-15	1958-12-15 00:00:00	32020		\N	318490	0	44465007	81151		0
80937	4801	40481087	2011-06-14	2011-06-14 00:00:00	2011-07-05	2011-07-05 00:00:00	32020		\N	319404	0	444814009	40481087		0
81381	4827	4112343	1992-11-07	1992-11-07 00:00:00	1992-11-14	1992-11-14 00:00:00	32020		\N	321173	0	195662009	4112343		0
81510	4835	40481087	1981-03-09	1981-03-09 00:00:00	1981-03-23	1981-03-23 00:00:00	32020		\N	321654	0	444814009	40481087		0
71158	4220	260139	1973-03-18	1973-03-18 00:00:00	1973-04-01	1973-04-01 00:00:00	32020		\N	280197	0	10509002	260139		0
81887	4855	80180	2014-07-23	2014-07-23 00:00:00	\N	\N	32020		\N	323050	0	396275006	80180		0
71512	4241	40481087	1998-05-25	1998-05-25 00:00:00	1998-06-08	1998-06-08 00:00:00	32020		\N	281703	0	444814009	40481087		0
82242	4878	40481087	2004-03-10	2004-03-10 00:00:00	2004-03-31	2004-03-31 00:00:00	32020		\N	324394	0	444814009	40481087		0
82348	4884	4035415	1980-12-22	1980-12-22 00:00:00	1981-01-21	1981-01-21 00:00:00	32020		\N	324734	0	239720000	4035415		0
72042	4275	4149245	1992-05-10	1992-05-10 00:00:00	1992-06-16	1992-06-16 00:00:00	32020		\N	283715	0	30832001	4149245		0
72165	4282	440448	1978-04-05	1978-04-05 00:00:00	\N	\N	32020		\N	284193	0	74400008	440448		0
72326	4291	40481087	2019-06-09	2019-06-09 00:00:00	\N	\N	32020		\N	284882	0	444814009	40481087		0
83166	4942	81151	1998-04-16	1998-04-16 00:00:00	1998-05-21	1998-05-21 00:00:00	32020		\N	328467	0	44465007	81151		0
83242	4945	4283893	1975-03-08	1975-03-08 00:00:00	1975-04-19	1975-04-19 00:00:00	32020		\N	328730	0	36971009	4283893		0
83340	4952	372328	1971-05-15	1971-05-15 00:00:00	1971-05-29	1971-05-29 00:00:00	32020		\N	329125	0	65363002	372328		0
83745	4975	4283893	1968-08-16	1968-08-16 00:00:00	1968-12-13	1968-12-13 00:00:00	32020		\N	330845	0	36971009	4283893		0
83911	4986	381316	1983-09-11	1983-09-11 00:00:00	\N	\N	32020		\N	331692	0	230690007	381316		0
84135	4999	40481087	2008-09-17	2008-09-17 00:00:00	2008-10-01	2008-10-01 00:00:00	32020		\N	332484	0	444814009	40481087		0
84647	5034	4152936	1945-02-10	1945-02-10 00:00:00	1945-03-03	1945-03-03 00:00:00	32020		\N	334458	0	283385000	4152936		0
84742	5039	4112343	1991-03-13	1991-03-13 00:00:00	1991-03-26	1991-03-26 00:00:00	32020		\N	334856	0	195662009	4112343		0
84954	5051	4059173	1983-08-25	1983-08-25 00:00:00	1983-11-23	1983-11-23 00:00:00	32020		\N	335904	0	16114001	4059173		0
85013	5056	260139	1991-02-26	1991-02-26 00:00:00	1991-03-05	1991-03-05 00:00:00	32020		\N	336142	0	10509002	260139		0
74698	4436	4310024	2005-12-14	2005-12-14 00:00:00	\N	\N	32020		\N	294848	0	424802006	4310024		0
74739	4439	4112343	1958-10-22	1958-10-22 00:00:00	1958-11-02	1958-11-02 00:00:00	32020		\N	295120	0	195662009	4112343		0
74885	4448	40481087	1958-07-02	1958-07-02 00:00:00	1958-07-16	1958-07-16 00:00:00	32020		\N	295903	0	444814009	40481087		0
64558	3817	40481087	2007-09-09	2007-09-09 00:00:00	2007-09-23	2007-09-23 00:00:00	32020		\N	253513	0	444814009	40481087		0
75290	4472	372328	1938-02-11	1938-02-11 00:00:00	1938-03-19	1938-03-19 00:00:00	32020		\N	297528	0	65363002	372328		0
64820	3833	40481087	1973-03-10	1973-03-10 00:00:00	1973-03-31	1973-03-31 00:00:00	32020		\N	254499	0	444814009	40481087		0
75554	4484	375671	1952-07-09	1952-07-09 00:00:00	1952-09-07	1952-09-07 00:00:00	32020		\N	298466	0	62564004	375671		0
65211	3857	4112343	1986-09-24	1986-09-24 00:00:00	1986-10-01	1986-10-01 00:00:00	32020		\N	255959	0	195662009	4112343		0
65376	3866	28060	1973-07-12	1973-07-12 00:00:00	1973-07-25	1973-07-25 00:00:00	32020		\N	256685	0	43878008	28060		0
76036	4509	4285898	2006-09-08	2006-09-08 00:00:00	\N	\N	32020		\N	300398	0	68496003	4285898		0
76301	4527	40481087	1981-11-14	1981-11-14 00:00:00	1981-11-21	1981-11-21 00:00:00	32020		\N	301450	0	444814009	40481087		0
76463	4532	4112343	1910-08-13	1910-08-13 00:00:00	1910-08-26	1910-08-26 00:00:00	32020		\N	301911	0	195662009	4112343		0
76569	4538	40481087	2014-10-04	2014-10-04 00:00:00	2014-10-18	2014-10-18 00:00:00	32020		\N	302395	0	444814009	40481087		0
76733	4547	4296204	1943-06-06	1943-06-06 00:00:00	1943-07-11	1943-07-11 00:00:00	32020		\N	302958	0	403190006	4296204		0
76900	4557	40481087	2010-01-16	2010-01-16 00:00:00	2010-01-30	2010-01-30 00:00:00	32020		\N	303648	0	444814009	40481087		0
66541	3938	40481087	1990-07-15	1990-07-15 00:00:00	1990-07-22	1990-07-22 00:00:00	32020		\N	261722	0	444814009	40481087		0
77318	4579	260139	1985-09-18	1985-09-18 00:00:00	1985-09-25	1985-09-25 00:00:00	32020		\N	305028	0	10509002	260139		0
77465	4590	4112343	1990-05-02	1990-05-02 00:00:00	1990-05-13	1990-05-13 00:00:00	32020		\N	305849	0	195662009	4112343		0
77586	4596	4112343	1941-01-25	1941-01-25 00:00:00	1941-02-03	1941-02-03 00:00:00	32020		\N	306259	0	195662009	4112343		0
77718	4604	40481087	1985-10-15	1985-10-15 00:00:00	1985-10-22	1985-10-22 00:00:00	32020		\N	306747	0	444814009	40481087		0
88538	5262	81151	1978-04-10	1978-04-10 00:00:00	1978-05-01	1978-05-01 00:00:00	32020		\N	350074	0	44465007	81151		0
78067	4625	28060	2015-12-28	2015-12-28 00:00:00	2016-01-04	2016-01-04 00:00:00	32020		\N	308108	0	43878008	28060		0
78195	4631	4112343	1924-05-09	1924-05-09 00:00:00	1924-05-17	1924-05-17 00:00:00	32020		\N	308602	0	195662009	4112343		0
78380	4641	4294548	2013-04-28	2013-04-28 00:00:00	2013-05-12	2013-05-12 00:00:00	32020		\N	309308	0	75498004	4294548		0
78570	4653	257012	1964-08-24	1964-08-24 00:00:00	\N	\N	32020		\N	310190	0	40055000	257012		0
78695	4661	4112343	1994-05-25	1994-05-25 00:00:00	1994-06-03	1994-06-03 00:00:00	32020		\N	310674	0	195662009	4112343		0
78974	4676	4278672	1981-08-21	1981-08-21 00:00:00	1981-09-20	1981-09-20 00:00:00	32020		\N	311618	0	65966004	4278672		0
79059	4680	4278672	1987-05-15	1987-05-15 00:00:00	1987-07-14	1987-07-14 00:00:00	32020		\N	311950	0	65966004	4278672		0
79268	4694	4296204	2012-12-24	2012-12-24 00:00:00	2013-01-07	2013-01-07 00:00:00	32020		\N	312721	0	403190006	4296204		0
79456	4705	40481087	2009-07-14	2009-07-14 00:00:00	2009-07-21	2009-07-21 00:00:00	32020		\N	313489	0	444814009	40481087		0
69012	4085	260139	2014-05-20	2014-05-20 00:00:00	2014-05-27	2014-05-27 00:00:00	32020		\N	271542	0	10509002	260139		0
79690	4720	4285898	2013-12-28	2013-12-28 00:00:00	\N	\N	32020		\N	314372	0	68496003	4285898		0
80002	4739	260139	1919-09-15	1919-09-15 00:00:00	1919-09-29	1919-09-29 00:00:00	32020		\N	315732	0	10509002	260139		0
69484	4113	372328	1963-04-11	1963-04-11 00:00:00	1964-03-30	1964-03-30 00:00:00	32020		\N	273399	0	65363002	372328		0
69661	4122	80180	2013-08-22	2013-08-22 00:00:00	\N	\N	32020		\N	274042	0	396275006	80180		0
80429	4763	4112343	1979-10-04	1979-10-04 00:00:00	1979-10-13	1979-10-13 00:00:00	32020		\N	317405	0	195662009	4112343		0
80689	4784	40481087	2013-11-27	2013-11-27 00:00:00	2013-12-04	2013-12-04 00:00:00	32020		\N	318421	0	444814009	40481087		0
80938	4801	260139	1988-08-24	1988-08-24 00:00:00	1988-08-31	1988-08-31 00:00:00	32020		\N	319357	0	10509002	260139		0
81382	4827	40481087	1964-02-01	1964-02-01 00:00:00	1964-02-08	1964-02-08 00:00:00	32020		\N	321105	0	444814009	40481087		0
81511	4835	440448	1985-04-26	1985-04-26 00:00:00	\N	\N	32020		\N	321634	0	74400008	440448		0
71159	4220	260139	1992-03-29	1992-03-29 00:00:00	1992-04-05	1992-04-05 00:00:00	32020		\N	280209	0	10509002	260139		0
81888	4855	192671	2014-08-22	2014-08-22 00:00:00	\N	\N	32020		\N	323003	0	K92.2	35208414		0
71513	4241	257012	1998-08-13	1998-08-13 00:00:00	\N	\N	32020		\N	281704	0	40055000	257012		0
82243	4878	40481087	1993-01-18	1993-01-18 00:00:00	1993-02-01	1993-02-01 00:00:00	32020		\N	324440	0	444814009	40481087		0
82349	4884	40481087	1995-11-02	1995-11-02 00:00:00	1995-11-16	1995-11-16 00:00:00	32020		\N	324744	0	444814009	40481087		0
72043	4275	317576	1994-02-13	1994-02-13 00:00:00	\N	\N	32020		\N	283699	0	53741008	317576		0
72166	4282	4166224	1978-04-05	1978-04-05 00:00:00	\N	\N	32020		\N	284193	0	47693006	4166224		0
72327	4291	4109685	1994-11-03	1994-11-03 00:00:00	1994-11-24	1994-11-24 00:00:00	32020		\N	284893	0	284551006	4109685		0
83243	4945	40481087	2005-03-18	2005-03-18 00:00:00	2005-04-08	2005-04-08 00:00:00	32020		\N	328670	0	444814009	40481087		0
83341	4952	260139	1975-02-07	1975-02-07 00:00:00	1975-02-21	1975-02-21 00:00:00	32020		\N	329181	0	10509002	260139		0
83746	4975	4310024	2002-03-25	2002-03-25 00:00:00	\N	\N	32020		\N	\N	0	424802006	4310024		0
83912	4986	4109685	1965-03-05	1965-03-05 00:00:00	1965-03-26	1965-03-26 00:00:00	32020		\N	331615	0	284551006	4109685		0
84136	4999	40481087	2009-04-06	2009-04-06 00:00:00	2009-04-27	2009-04-27 00:00:00	32020		\N	332492	0	444814009	40481087		0
73639	4376	4152936	2011-10-14	2011-10-14 00:00:00	2011-11-04	2011-11-04 00:00:00	32020		\N	290736	0	283385000	4152936		0
84415	5018	4116491	1980-11-05	1980-11-05 00:00:00	1980-12-07	1980-12-07 00:00:00	32020		\N	333530	0	301011002	4116491		0
84648	5034	4112343	1982-05-20	1982-05-20 00:00:00	1982-05-27	1982-05-27 00:00:00	32020		\N	334487	0	195662009	4112343		0
84743	5039	4156265	1984-02-22	1984-02-22 00:00:00	1984-03-14	1984-03-14 00:00:00	32020		\N	334866	0	370247008	4156265		0
84955	5051	40481087	1982-06-25	1982-06-25 00:00:00	1982-07-09	1982-07-09 00:00:00	32020		\N	335897	0	444814009	40481087		0
85014	5056	40481087	1995-01-14	1995-01-14 00:00:00	1995-01-21	1995-01-21 00:00:00	32020		\N	336201	0	444814009	40481087		0
74699	4436	30753	2006-10-10	2006-10-10 00:00:00	\N	\N	32020		\N	294848	0	16761005	30753		0
74740	4439	40481087	1992-02-07	1992-02-07 00:00:00	1992-02-21	1992-02-21 00:00:00	32020		\N	295148	0	444814009	40481087		0
74886	4448	30753	1993-11-26	1993-11-26 00:00:00	\N	\N	32020		\N	295870	0	16761005	30753		0
64559	3817	40481087	1989-10-15	1989-10-15 00:00:00	1989-10-22	1989-10-22 00:00:00	32020		\N	253520	0	444814009	40481087		0
75291	4472	260139	1967-03-12	1967-03-12 00:00:00	1967-03-19	1967-03-19 00:00:00	32020		\N	297483	0	10509002	260139		0
64821	3833	40481087	2006-05-23	2006-05-23 00:00:00	2006-06-06	2006-06-06 00:00:00	32020		\N	254539	0	444814009	40481087		0
75555	4484	372328	1960-12-24	1960-12-24 00:00:00	1961-10-12	1961-10-12 00:00:00	32020		\N	298448	0	65363002	372328		0
65212	3857	40481087	1967-11-15	1967-11-15 00:00:00	1967-11-29	1967-11-29 00:00:00	32020		\N	255949	0	444814009	40481087		0
65377	3866	4146173	1975-11-11	1975-11-11 00:00:00	1975-12-11	1975-12-11 00:00:00	32020		\N	256731	0	307731004	4146173		0
76302	4527	378001	2016-08-06	2016-08-06 00:00:00	2016-09-05	2016-09-05 00:00:00	32020		\N	301447	0	62106007	378001		0
76464	4532	40481087	1926-05-14	1926-05-14 00:00:00	1926-05-21	1926-05-21 00:00:00	32020		\N	301830	0	444814009	40481087		0
76570	4538	40481087	1991-04-21	1991-04-21 00:00:00	1991-05-12	1991-05-12 00:00:00	32020		\N	302351	0	444814009	40481087		0
76734	4547	4112343	1976-11-13	1976-11-13 00:00:00	1976-11-22	1976-11-22 00:00:00	32020		\N	302968	0	195662009	4112343		0
76901	4557	81151	1973-08-23	1973-08-23 00:00:00	1973-09-13	1973-09-13 00:00:00	32020		\N	303642	0	44465007	81151		0
66542	3938	40481087	1994-02-06	1994-02-06 00:00:00	1994-02-27	1994-02-27 00:00:00	32020		\N	261777	0	444814009	40481087		0
77319	4579	4294548	2010-12-20	2010-12-20 00:00:00	2011-04-04	2011-04-04 00:00:00	32020		\N	305032	0	75498004	4294548		0
77466	4590	40481087	1990-12-24	1990-12-24 00:00:00	1990-12-31	1990-12-31 00:00:00	32020		\N	305823	0	444814009	40481087		0
77587	4596	4112343	1958-04-15	1958-04-15 00:00:00	1958-04-28	1958-04-28 00:00:00	32020		\N	306319	0	195662009	4112343		0
77719	4604	260139	2007-05-22	2007-05-22 00:00:00	2007-05-29	2007-05-29 00:00:00	32020		\N	306763	0	10509002	260139		0
88539	5262	40481087	1993-03-15	1993-03-15 00:00:00	1993-03-29	1993-03-29 00:00:00	32020		\N	350078	0	444814009	40481087		0
78068	4625	4218389	1981-11-13	1981-11-13 00:00:00	1981-12-04	1981-12-04 00:00:00	32020		\N	308131	0	39848009	4218389		0
78196	4631	28060	1920-12-01	1920-12-01 00:00:00	1920-12-10	1920-12-10 00:00:00	32020		\N	308570	0	43878008	28060		0
78381	4641	4112343	1997-04-15	1997-04-15 00:00:00	1997-04-28	1997-04-28 00:00:00	32020		\N	309306	0	195662009	4112343		0
78571	4653	4283893	1959-11-27	1959-11-27 00:00:00	1960-01-08	1960-01-08 00:00:00	32020		\N	310186	0	36971009	4283893		0
78696	4661	81151	1983-06-10	1983-06-10 00:00:00	1983-06-24	1983-06-24 00:00:00	32020		\N	310684	0	44465007	81151		0
78975	4676	378001	2000-01-19	2000-01-19 00:00:00	2000-02-18	2000-02-18 00:00:00	32020		\N	311620	0	62106007	378001		0
79060	4680	4112343	1957-12-13	1957-12-13 00:00:00	1957-12-25	1957-12-25 00:00:00	32020		\N	311879	0	195662009	4112343		0
79269	4694	40481087	2018-01-23	2018-01-23 00:00:00	2018-01-30	2018-01-30 00:00:00	32020		\N	312678	0	444814009	40481087		0
79457	4705	260139	1979-05-22	1979-05-22 00:00:00	1979-05-29	1979-05-29 00:00:00	32020		\N	313466	0	10509002	260139		0
69013	4085	4237458	1966-03-26	1966-03-26 00:00:00	1966-04-25	1966-04-25 00:00:00	32020		\N	271439	0	58150001	4237458		0
79691	4720	81151	2012-12-29	2012-12-29 00:00:00	2013-01-19	2013-01-19 00:00:00	32020		\N	314372	0	44465007	81151		0
80003	4739	4084167	1915-03-31	1915-03-31 00:00:00	1915-03-31	1915-03-31 00:00:00	32020		\N	315724	0	241929008	4084167		0
69485	4113	372328	1961-07-20	1961-07-20 00:00:00	1961-09-18	1961-09-18 00:00:00	32020		\N	273429	0	65363002	372328		0
69662	4122	28060	2013-06-23	2013-06-23 00:00:00	2013-07-05	2013-07-05 00:00:00	32020		\N	274042	0	43878008	28060		0
80430	4763	4237458	1966-08-19	1966-08-19 00:00:00	1966-09-18	1966-09-18 00:00:00	32020		\N	317454	0	58150001	4237458		0
80690	4784	40481087	1981-05-13	1981-05-13 00:00:00	1981-05-20	1981-05-20 00:00:00	32020		\N	318480	0	444814009	40481087		0
80939	4801	40481087	2006-04-26	2006-04-26 00:00:00	2006-05-03	2006-05-03 00:00:00	32020		\N	319379	0	444814009	40481087		0
81383	4827	260139	1995-02-02	1995-02-02 00:00:00	1995-02-09	1995-02-09 00:00:00	32020		\N	321094	0	10509002	260139		0
81512	4835	80180	2010-04-10	2010-04-10 00:00:00	\N	\N	32020		\N	321644	0	396275006	80180		0
71160	4220	40481087	1950-09-11	1950-09-11 00:00:00	1950-09-25	1950-09-25 00:00:00	32020		\N	280184	0	444814009	40481087		0
81889	4855	372328	1978-06-07	1978-06-07 00:00:00	1978-08-19	1978-08-19 00:00:00	32020		\N	323030	0	65363002	372328		0
71514	4241	28060	2008-10-02	2008-10-02 00:00:00	2008-10-10	2008-10-10 00:00:00	32020		\N	281758	0	43878008	28060		0
82244	4878	40481087	2008-06-03	2008-06-03 00:00:00	2008-06-24	2008-06-24 00:00:00	32020		\N	324366	0	444814009	40481087		0
82364	4886	4237458	1982-06-07	1982-06-07 00:00:00	1982-09-05	1982-09-05 00:00:00	32020		\N	324933	0	58150001	4237458		0
72044	4275	260139	1988-03-02	1988-03-02 00:00:00	1988-03-09	1988-03-09 00:00:00	32020		\N	283717	0	10509002	260139		0
72167	4282	40481087	1989-11-22	1989-11-22 00:00:00	1989-12-06	1989-12-06 00:00:00	32020		\N	284167	0	444814009	40481087		0
72328	4291	372328	1975-10-25	1975-10-25 00:00:00	1976-04-30	1976-04-30 00:00:00	32020		\N	284905	0	65363002	372328		0
83244	4945	40481087	1964-03-14	1964-03-14 00:00:00	1964-04-04	1964-04-04 00:00:00	32020		\N	328722	0	444814009	40481087		0
83342	4952	260139	1973-04-06	1973-04-06 00:00:00	1973-04-20	1973-04-20 00:00:00	32020		\N	329124	0	10509002	260139		0
83747	4975	40481087	1978-02-01	1978-02-01 00:00:00	1978-02-08	1978-02-08 00:00:00	32020		\N	330847	0	444814009	40481087		0
83913	4986	4112343	1990-03-05	1990-03-05 00:00:00	1990-03-12	1990-03-12 00:00:00	32020		\N	331693	0	195662009	4112343		0
84137	4999	4112343	2003-01-19	2003-01-19 00:00:00	2003-01-27	2003-01-27 00:00:00	32020		\N	332447	0	195662009	4112343		0
73640	4376	40481087	1973-03-09	1973-03-09 00:00:00	1973-03-23	1973-03-23 00:00:00	32020		\N	290712	0	444814009	40481087		0
84416	5018	4155034	1963-07-16	1963-07-16 00:00:00	1963-08-06	1963-08-06 00:00:00	32020		\N	333481	0	283371005	4155034		0
84649	5034	378001	1933-08-12	1933-08-12 00:00:00	1933-10-11	1933-10-11 00:00:00	32020		\N	334507	0	62106007	378001		0
84744	5039	4237458	1994-12-17	1994-12-17 00:00:00	1995-03-17	1995-03-17 00:00:00	32020		\N	334867	0	58150001	4237458		0
84956	5051	260139	1992-05-18	1992-05-18 00:00:00	1992-06-01	1992-06-01 00:00:00	32020		\N	335931	0	10509002	260139		0
85015	5056	40481087	1945-03-12	1945-03-12 00:00:00	1945-03-26	1945-03-26 00:00:00	32020		\N	336183	0	444814009	40481087		0
74700	4436	40481087	1970-12-03	1970-12-03 00:00:00	1970-12-24	1970-12-24 00:00:00	32020		\N	294874	0	444814009	40481087		0
74741	4439	40481087	1968-03-04	1968-03-04 00:00:00	1968-03-18	1968-03-18 00:00:00	32020		\N	295101	0	444814009	40481087		0
74887	4448	40481087	1961-03-07	1961-03-07 00:00:00	1961-03-28	1961-03-28 00:00:00	32020		\N	295844	0	444814009	40481087		0
64560	3817	260139	1991-03-30	1991-03-30 00:00:00	1991-04-06	1991-04-06 00:00:00	32020		\N	253491	0	10509002	260139		0
75292	4472	4112343	2005-04-09	2005-04-09 00:00:00	2005-04-21	2005-04-21 00:00:00	32020		\N	297487	0	195662009	4112343		0
64822	3833	40481087	2008-10-29	2008-10-29 00:00:00	2008-11-05	2008-11-05 00:00:00	32020		\N	254540	0	444814009	40481087		0
75556	4484	4112343	2000-05-10	2000-05-10 00:00:00	2000-05-17	2000-05-17 00:00:00	32020		\N	298463	0	195662009	4112343		0
65213	3857	40481087	1990-04-14	1990-04-14 00:00:00	1990-05-05	1990-05-05 00:00:00	32020		\N	255960	0	444814009	40481087		0
65378	3866	372328	1953-03-24	1953-03-24 00:00:00	1953-09-15	1953-09-15 00:00:00	32020		\N	256764	0	65363002	372328		0
76038	4509	4027663	1997-08-21	1997-08-21 00:00:00	\N	\N	32020		\N	300395	0	13200003	4027663		0
76303	4527	80180	2002-01-21	2002-01-21 00:00:00	\N	\N	32020		\N	301441	0	396275006	80180		0
76465	4532	4112343	1953-02-21	1953-02-21 00:00:00	1953-03-06	1953-03-06 00:00:00	32020		\N	301952	0	195662009	4112343		0
76571	4538	4112343	1986-09-07	1986-09-07 00:00:00	1986-09-20	1986-09-20 00:00:00	32020		\N	302335	0	195662009	4112343		0
76735	4547	80180	1948-08-24	1948-08-24 00:00:00	\N	\N	32020		\N	302901	0	396275006	80180		0
76902	4557	40481087	2016-05-02	2016-05-02 00:00:00	2016-05-23	2016-05-23 00:00:00	32020		\N	303563	0	444814009	40481087		0
66543	3938	378419	1993-09-01	1993-09-01 00:00:00	\N	\N	32020		\N	261804	0	26929004	378419		0
77320	4579	40481087	1991-02-21	1991-02-21 00:00:00	1991-02-28	1991-02-28 00:00:00	32020		\N	305029	0	444814009	40481087		0
77467	4590	4112343	2012-04-19	2012-04-19 00:00:00	2012-04-26	2012-04-26 00:00:00	32020		\N	305888	0	195662009	4112343		0
77588	4596	4112343	2012-06-26	2012-06-26 00:00:00	2012-07-03	2012-07-03 00:00:00	32020		\N	306293	0	195662009	4112343		0
77720	4604	40481087	2006-02-05	2006-02-05 00:00:00	2006-02-19	2006-02-19 00:00:00	32020		\N	306715	0	444814009	40481087		0
88540	5262	4283893	2015-07-20	2015-07-20 00:00:00	2015-08-24	2015-08-24 00:00:00	32020		\N	350080	0	36971009	4283893		0
78069	4625	40481087	2005-11-08	2005-11-08 00:00:00	2005-11-22	2005-11-22 00:00:00	32020		\N	308073	0	444814009	40481087		0
78197	4631	4156265	1982-06-03	1982-06-03 00:00:00	1982-06-24	1982-06-24 00:00:00	32020		\N	308555	0	370247008	4156265		0
78382	4641	4112343	1979-10-06	1979-10-06 00:00:00	1979-10-13	1979-10-13 00:00:00	32020		\N	309296	0	195662009	4112343		0
78572	4653	40481087	1978-07-16	1978-07-16 00:00:00	1978-08-06	1978-08-06 00:00:00	32020		\N	310193	0	444814009	40481087		0
78697	4661	40481087	2001-08-10	2001-08-10 00:00:00	2001-08-24	2001-08-24 00:00:00	32020		\N	310686	0	444814009	40481087		0
78976	4676	4112343	1993-03-24	1993-03-24 00:00:00	1993-04-05	1993-04-05 00:00:00	32020		\N	311588	0	195662009	4112343		0
79061	4680	4112343	1963-09-27	1963-09-27 00:00:00	1963-10-05	1963-10-05 00:00:00	32020		\N	311880	0	195662009	4112343		0
79270	4694	40481087	1993-12-03	1993-12-03 00:00:00	1993-12-24	1993-12-24 00:00:00	32020		\N	312750	0	444814009	40481087		0
79458	4705	260139	1997-07-14	1997-07-14 00:00:00	1997-07-28	1997-07-28 00:00:00	32020		\N	313479	0	10509002	260139		0
69014	4085	260139	1971-05-25	1971-05-25 00:00:00	1971-06-01	1971-06-01 00:00:00	32020		\N	271498	0	10509002	260139		0
79692	4720	80180	2014-01-27	2014-01-27 00:00:00	\N	\N	32020		\N	314372	0	396275006	80180		0
80004	4739	372328	1910-11-22	1910-11-22 00:00:00	1911-02-04	1911-02-04 00:00:00	32020		\N	315690	0	65363002	372328		0
69486	4113	4218389	1964-06-04	1964-06-04 00:00:00	1964-06-25	1964-06-25 00:00:00	32020		\N	273385	0	39848009	4218389		0
69663	4122	4266809	2013-08-22	2013-08-22 00:00:00	\N	\N	32020		\N	274042	0	397881000	4266809		0
80431	4763	4112343	1953-04-20	1953-04-20 00:00:00	1953-04-27	1953-04-27 00:00:00	32020		\N	317426	0	195662009	4112343		0
80691	4784	260139	1996-03-02	1996-03-02 00:00:00	1996-03-16	1996-03-16 00:00:00	32020		\N	318481	0	10509002	260139		0
80940	4801	4237458	2016-12-08	2016-12-08 00:00:00	2017-02-06	2017-02-06 00:00:00	32020		\N	319401	0	58150001	4237458		0
81384	4827	4285898	1990-12-18	1990-12-18 00:00:00	\N	\N	32020		\N	321118	0	68496003	4285898		0
81513	4835	4285898	2009-11-10	2009-11-10 00:00:00	\N	\N	32020		\N	321644	0	68496003	4285898		0
71161	4220	260139	2012-07-26	2012-07-26 00:00:00	2012-08-09	2012-08-09 00:00:00	32020		\N	280203	0	10509002	260139		0
81890	4855	375671	1992-05-24	1992-05-24 00:00:00	1992-07-23	1992-07-23 00:00:00	32020		\N	323054	0	62564004	375671		0
71515	4241	81893	2005-08-13	2005-08-13 00:00:00	\N	\N	32020		\N	281736	0	64766004	81893		0
82245	4878	257012	1990-07-17	1990-07-17 00:00:00	\N	\N	32020		\N	324349	0	40055000	257012		0
82365	4886	4134304	1968-07-22	1968-07-22 00:00:00	1968-10-20	1968-10-20 00:00:00	32020		\N	324929	0	263102004	4134304		0
82532	4898	260139	1983-03-29	1983-03-29 00:00:00	1983-04-12	1983-04-12 00:00:00	32020		\N	325691	0	10509002	260139		0
72168	4282	4116491	2008-03-26	2008-03-26 00:00:00	2008-05-03	2008-05-03 00:00:00	32020		\N	284162	0	301011002	4116491		0
72329	4291	4237458	2017-01-27	2017-01-27 00:00:00	2017-02-26	2017-02-26 00:00:00	32020		\N	284894	0	58150001	4237458		0
83245	4945	40481087	1973-12-10	1973-12-10 00:00:00	1973-12-31	1973-12-31 00:00:00	32020		\N	328729	0	444814009	40481087		0
83343	4952	40481087	1975-09-19	1975-09-19 00:00:00	1975-10-10	1975-10-10 00:00:00	32020		\N	329127	0	444814009	40481087		0
83748	4975	4112343	1973-05-11	1973-05-11 00:00:00	1973-05-18	1973-05-18 00:00:00	32020		\N	330903	0	195662009	4112343		0
83914	4986	40481087	2005-02-07	2005-02-07 00:00:00	2005-02-21	2005-02-21 00:00:00	32020		\N	331695	0	444814009	40481087		0
84138	4999	40481087	1963-05-21	1963-05-21 00:00:00	1963-06-11	1963-06-11 00:00:00	32020		\N	332412	0	444814009	40481087		0
73641	4376	4112343	2009-01-08	2009-01-08 00:00:00	2009-01-15	2009-01-15 00:00:00	32020		\N	290784	0	195662009	4112343		0
84417	5018	4112343	2009-05-08	2009-05-08 00:00:00	2009-05-19	2009-05-19 00:00:00	32020		\N	333526	0	195662009	4112343		0
84650	5034	260139	1973-12-22	1973-12-22 00:00:00	1973-12-29	1973-12-29 00:00:00	32020		\N	334531	0	10509002	260139		0
84745	5039	4112343	1979-12-27	1979-12-27 00:00:00	1980-01-06	1980-01-06 00:00:00	32020		\N	334860	0	195662009	4112343		0
84957	5051	372328	1980-05-12	1980-05-12 00:00:00	1980-10-30	1980-10-30 00:00:00	32020		\N	335891	0	65363002	372328		0
85016	5056	260139	2004-02-12	2004-02-12 00:00:00	2004-02-19	2004-02-19 00:00:00	32020		\N	336218	0	10509002	260139		0
85160	5065	4112343	1970-12-04	1970-12-04 00:00:00	1970-12-15	1970-12-15 00:00:00	32020		\N	336739	0	195662009	4112343		0
74742	4439	192671	1995-07-01	1995-07-01 00:00:00	\N	\N	32020		\N	295119	0	K92.2	35208414		0
74888	4448	40481087	2012-07-23	2012-07-23 00:00:00	2012-08-13	2012-08-13 00:00:00	32020		\N	295857	0	444814009	40481087		0
64561	3817	4059173	1995-10-08	1995-10-08 00:00:00	1995-12-07	1995-12-07 00:00:00	32020		\N	253529	0	16114001	4059173		0
75293	4472	260139	1987-02-03	1987-02-03 00:00:00	1987-02-17	1987-02-17 00:00:00	32020		\N	297486	0	10509002	260139		0
64823	3833	40481087	1983-11-13	1983-11-13 00:00:00	1983-11-20	1983-11-20 00:00:00	32020		\N	254523	0	444814009	40481087		0
75557	4484	378001	1972-05-30	1972-05-30 00:00:00	1972-06-29	1972-06-29 00:00:00	32020		\N	298468	0	62106007	378001		0
65214	3857	4112343	1978-07-04	1978-07-04 00:00:00	1978-07-13	1978-07-13 00:00:00	32020		\N	255957	0	195662009	4112343		0
65379	3866	140673	2017-09-24	2017-09-24 00:00:00	\N	\N	32020		\N	256725	0	40930008	140673		0
76039	4509	192671	2007-01-25	2007-01-25 00:00:00	\N	\N	32020		\N	300402	0	K92.2	35208414		0
76304	4527	4310024	2000-09-28	2000-09-28 00:00:00	\N	\N	32020		\N	301441	0	424802006	4310024		0
76466	4532	40481087	1926-08-26	1926-08-26 00:00:00	1926-09-16	1926-09-16 00:00:00	32020		\N	301915	0	444814009	40481087		0
76572	4538	260139	2009-06-08	2009-06-08 00:00:00	2009-06-22	2009-06-22 00:00:00	32020		\N	302352	0	10509002	260139		0
76736	4547	40481087	1948-08-16	1948-08-16 00:00:00	1948-09-06	1948-09-06 00:00:00	32020		\N	302901	0	444814009	40481087		0
76903	4557	4112343	1997-04-19	1997-04-19 00:00:00	1997-05-02	1997-05-02 00:00:00	32020		\N	303579	0	195662009	4112343		0
66544	3938	260139	1915-01-26	1915-01-26 00:00:00	1915-02-02	1915-02-02 00:00:00	32020		\N	261772	0	10509002	260139		0
77321	4579	4112343	1997-03-08	1997-03-08 00:00:00	1997-03-17	1997-03-17 00:00:00	32020		\N	305061	0	195662009	4112343		0
77468	4590	4278672	2002-09-29	2002-09-29 00:00:00	2002-12-28	2002-12-28 00:00:00	32020		\N	305863	0	65966004	4278672		0
77589	4596	40481087	1957-11-11	1957-11-11 00:00:00	1957-12-02	1957-12-02 00:00:00	32020		\N	306261	0	444814009	40481087		0
77721	4604	4112343	2008-02-21	2008-02-21 00:00:00	2008-02-28	2008-02-28 00:00:00	32020		\N	306728	0	195662009	4112343		0
88541	5262	40481087	1994-04-27	1994-04-27 00:00:00	1994-05-18	1994-05-18 00:00:00	32020		\N	350111	0	444814009	40481087		0
78070	4625	4152936	1974-05-19	1974-05-19 00:00:00	1974-06-02	1974-06-02 00:00:00	32020		\N	308128	0	283385000	4152936		0
78198	4631	4166224	1934-08-04	1934-08-04 00:00:00	\N	\N	32020		\N	308554	0	47693006	4166224		0
78383	4641	195588	1987-07-08	1987-07-08 00:00:00	1987-08-25	1987-08-25 00:00:00	32020		\N	309286	0	38822007	195588		0
78573	4653	4283893	1964-07-20	1964-07-20 00:00:00	1965-02-22	1965-02-22 00:00:00	32020		\N	310189	0	36971009	4283893		0
78698	4661	40481087	1979-03-09	1979-03-09 00:00:00	1979-03-23	1979-03-23 00:00:00	32020		\N	310668	0	444814009	40481087		0
78977	4676	40481087	1996-03-10	1996-03-10 00:00:00	1996-03-24	1996-03-24 00:00:00	32020		\N	311603	0	444814009	40481087		0
79062	4680	4155034	1944-12-30	1944-12-30 00:00:00	1945-01-13	1945-01-13 00:00:00	32020		\N	311941	0	283371005	4155034		0
79271	4694	195588	2015-08-01	2015-08-01 00:00:00	2015-09-05	2015-09-05 00:00:00	32020		\N	312677	0	38822007	195588		0
79459	4705	40481087	1990-03-17	1990-03-17 00:00:00	1990-04-07	1990-04-07 00:00:00	32020		\N	313487	0	444814009	40481087		0
69015	4085	4112343	1986-07-24	1986-07-24 00:00:00	1986-07-31	1986-07-31 00:00:00	32020		\N	271496	0	195662009	4112343		0
79693	4720	260139	1977-11-22	1977-11-22 00:00:00	1977-11-29	1977-11-29 00:00:00	32020		\N	314406	0	10509002	260139		0
80005	4739	378001	1951-11-18	1951-11-18 00:00:00	1951-12-18	1951-12-18 00:00:00	32020		\N	315729	0	62106007	378001		0
69487	4113	40481087	1986-08-27	1986-08-27 00:00:00	1986-09-10	1986-09-10 00:00:00	32020		\N	273396	0	444814009	40481087		0
82031	4865	4027663	2004-01-23	2004-01-23 00:00:00	\N	\N	32020		\N	323519	0	13200003	4027663		0
69664	4122	4283893	2001-04-22	2001-04-22 00:00:00	2001-05-20	2001-05-20 00:00:00	32020		\N	274033	0	36971009	4283893		0
80432	4763	40481087	1951-11-22	1951-11-22 00:00:00	1951-12-13	1951-12-13 00:00:00	32020		\N	317413	0	444814009	40481087		0
80692	4784	80180	1987-11-08	1987-11-08 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
80941	4801	372328	1997-01-14	1997-01-14 00:00:00	1999-10-02	1999-10-02 00:00:00	32020		\N	319407	0	65363002	372328		0
81385	4827	4112343	1980-08-16	1980-08-16 00:00:00	1980-08-26	1980-08-26 00:00:00	32020		\N	321113	0	195662009	4112343		0
81514	4835	4266809	2010-04-10	2010-04-10 00:00:00	\N	\N	32020		\N	321644	0	397881000	4266809		0
71162	4220	372328	1944-02-18	1944-02-18 00:00:00	1944-06-06	1944-06-06 00:00:00	32020		\N	280229	0	65363002	372328		0
81891	4855	4027663	2003-09-04	2003-09-04 00:00:00	\N	\N	32020		\N	323048	0	13200003	4027663		0
71516	4241	30753	2006-01-10	2006-01-10 00:00:00	\N	\N	32020		\N	281736	0	16761005	30753		0
82246	4878	4152936	1970-12-06	1970-12-06 00:00:00	1970-12-20	1970-12-20 00:00:00	32020		\N	324430	0	283385000	4152936		0
82366	4886	4112343	1975-01-14	1975-01-14 00:00:00	1975-01-27	1975-01-27 00:00:00	32020		\N	324888	0	195662009	4112343		0
82533	4898	260139	1999-06-23	1999-06-23 00:00:00	1999-07-07	1999-07-07 00:00:00	32020		\N	325667	0	10509002	260139		0
72169	4282	372328	1969-02-01	1969-02-01 00:00:00	1969-03-12	1969-03-12 00:00:00	32020		\N	284163	0	65363002	372328		0
72330	4291	372328	1997-10-24	1997-10-24 00:00:00	1999-02-19	1999-02-19 00:00:00	32020		\N	284883	0	65363002	372328		0
83246	4945	40481087	1995-07-10	1995-07-10 00:00:00	1995-07-17	1995-07-17 00:00:00	32020		\N	328680	0	444814009	40481087		0
83344	4952	4112343	2009-02-25	2009-02-25 00:00:00	2009-03-05	2009-03-05 00:00:00	32020		\N	329155	0	195662009	4112343		0
83749	4976	4113008	1995-01-25	1995-01-25 00:00:00	1995-02-15	1995-02-15 00:00:00	32020		\N	331108	0	284549007	4113008		0
83915	4986	40481087	2015-08-04	2015-08-04 00:00:00	2015-08-18	2015-08-18 00:00:00	32020		\N	331696	0	444814009	40481087		0
84139	4999	40481087	1962-04-28	1962-04-28 00:00:00	1962-05-19	1962-05-19 00:00:00	32020		\N	332443	0	444814009	40481087		0
73642	4376	40481087	1953-02-28	1953-02-28 00:00:00	1953-03-14	1953-03-14 00:00:00	32020		\N	290762	0	444814009	40481087		0
84418	5018	40481087	2012-11-14	2012-11-14 00:00:00	2012-12-05	2012-12-05 00:00:00	32020		\N	333490	0	444814009	40481087		0
84651	5034	80180	1959-07-27	1959-07-27 00:00:00	\N	\N	32020		\N	334498	0	396275006	80180		0
84746	5039	4112343	1999-08-28	1999-08-28 00:00:00	1999-09-06	1999-09-06 00:00:00	32020		\N	334894	0	195662009	4112343		0
84958	5051	40481087	2011-12-11	2011-12-11 00:00:00	2011-12-25	2011-12-25 00:00:00	32020		\N	335922	0	444814009	40481087		0
85017	5056	78272	1945-12-14	1945-12-14 00:00:00	1945-12-28	1945-12-28 00:00:00	32020		\N	336161	0	70704007	78272		0
85161	5065	4112343	1984-05-16	1984-05-16 00:00:00	1984-05-27	1984-05-27 00:00:00	32020		\N	336732	0	195662009	4112343		0
74743	4439	4310024	1992-07-26	1992-07-26 00:00:00	\N	\N	32020		\N	295089	0	424802006	4310024		0
74889	4448	4112343	1994-09-16	1994-09-16 00:00:00	1994-09-29	1994-09-29 00:00:00	32020		\N	295855	0	195662009	4112343		0
64562	3817	260139	2010-07-13	2010-07-13 00:00:00	2010-07-27	2010-07-27 00:00:00	32020		\N	253523	0	10509002	260139		0
75294	4472	317576	2010-04-24	2010-04-24 00:00:00	\N	\N	32020		\N	297556	0	53741008	317576		0
64824	3833	4266809	2001-12-07	2001-12-07 00:00:00	\N	\N	32020		\N	254486	0	397881000	4266809		0
75558	4484	40481087	1992-04-09	1992-04-09 00:00:00	1992-04-30	1992-04-30 00:00:00	32020		\N	298447	0	444814009	40481087		0
65215	3857	80180	1978-01-15	1978-01-15 00:00:00	\N	\N	32020		\N	256044	0	396275006	80180		0
65380	3866	40481087	1952-10-08	1952-10-08 00:00:00	1952-10-29	1952-10-29 00:00:00	32020		\N	256720	0	444814009	40481087		0
76040	4509	4278672	1968-09-22	1968-09-22 00:00:00	1968-11-21	1968-11-21 00:00:00	32020		\N	300362	0	65966004	4278672		0
76305	4527	4266809	2002-01-21	2002-01-21 00:00:00	\N	\N	32020		\N	301441	0	397881000	4266809		0
76467	4532	255848	1998-10-13	1998-10-13 00:00:00	\N	\N	32020		\N	301937	0	233604007	255848		0
76573	4538	4112343	1981-07-12	1981-07-12 00:00:00	1981-07-22	1981-07-22 00:00:00	32020		\N	302334	0	195662009	4112343		0
76737	4547	4112343	1999-10-05	1999-10-05 00:00:00	1999-10-17	1999-10-17 00:00:00	32020		\N	302938	0	195662009	4112343		0
76905	4557	321042	1978-12-31	1978-12-31 00:00:00	\N	\N	32020		\N	303643	0	410429000	321042		0
66545	3938	4112343	1922-02-05	1922-02-05 00:00:00	1922-02-15	1922-02-15 00:00:00	32020		\N	261774	0	195662009	4112343		0
77322	4579	40481087	1985-09-04	1985-09-04 00:00:00	1985-09-11	1985-09-11 00:00:00	32020		\N	305009	0	444814009	40481087		0
77469	4590	81893	1994-11-29	1994-11-29 00:00:00	\N	\N	32020		\N	305824	0	64766004	81893		0
77590	4596	4156265	1954-07-30	1954-07-30 00:00:00	1954-08-20	1954-08-20 00:00:00	32020		\N	306267	0	370247008	4156265		0
77722	4604	260139	2014-04-06	2014-04-06 00:00:00	2014-04-20	2014-04-20 00:00:00	32020		\N	306729	0	10509002	260139		0
88550	5264	40481087	2010-07-12	2010-07-12 00:00:00	2010-08-02	2010-08-02 00:00:00	32020		\N	350207	0	444814009	40481087		0
78071	4625	378001	1973-05-24	1973-05-24 00:00:00	1973-07-23	1973-07-23 00:00:00	32020		\N	308127	0	62106007	378001		0
78199	4631	440448	1934-08-04	1934-08-04 00:00:00	\N	\N	32020		\N	308554	0	74400008	440448		0
78384	4641	192671	2004-12-29	2004-12-29 00:00:00	\N	\N	32020		\N	309347	0	K92.2	35208414		0
78574	4653	260139	2016-12-17	2016-12-17 00:00:00	2016-12-24	2016-12-24 00:00:00	32020		\N	310171	0	10509002	260139		0
78699	4661	192671	2018-04-27	2018-04-27 00:00:00	\N	\N	32020		\N	310666	0	K92.2	35208414		0
78978	4676	80180	2018-09-11	2018-09-11 00:00:00	\N	\N	32020		\N	311636	0	396275006	80180		0
79063	4680	4296204	1925-04-23	1925-04-23 00:00:00	1925-05-14	1925-05-14 00:00:00	32020		\N	311939	0	403190006	4296204		0
79272	4694	4112343	1986-05-17	1986-05-17 00:00:00	1986-05-27	1986-05-27 00:00:00	32020		\N	312722	0	195662009	4112343		0
79460	4705	4112343	1992-10-04	1992-10-04 00:00:00	1992-10-15	1992-10-15 00:00:00	32020		\N	313488	0	195662009	4112343		0
69016	4085	372328	1966-05-18	1966-05-18 00:00:00	1967-05-06	1967-05-06 00:00:00	32020		\N	271458	0	65363002	372328		0
79703	4722	40481087	1928-05-28	1928-05-28 00:00:00	1928-06-18	1928-06-18 00:00:00	32020		\N	314580	0	444814009	40481087		0
80006	4739	40481087	1944-02-27	1944-02-27 00:00:00	1944-03-05	1944-03-05 00:00:00	32020		\N	315753	0	444814009	40481087		0
69488	4113	40479422	1997-01-17	1997-01-17 00:00:00	1997-02-23	1997-02-23 00:00:00	32020		\N	273388	0	444448004	40479422		0
69665	4122	4310024	2011-11-01	2011-11-01 00:00:00	\N	\N	32020		\N	274029	0	424802006	4310024		0
80433	4763	40481087	2009-01-29	2009-01-29 00:00:00	2009-02-12	2009-02-12 00:00:00	32020		\N	317379	0	444814009	40481087		0
80693	4784	260139	2009-05-16	2009-05-16 00:00:00	2009-05-23	2009-05-23 00:00:00	32020		\N	318432	0	10509002	260139		0
80942	4801	80180	2002-08-10	2002-08-10 00:00:00	\N	\N	32020		\N	319414	0	396275006	80180		0
81386	4827	30753	1990-05-22	1990-05-22 00:00:00	\N	\N	32020		\N	321209	0	16761005	30753		0
81515	4835	4112343	2008-11-14	2008-11-14 00:00:00	2008-11-27	2008-11-27 00:00:00	32020		\N	321644	0	195662009	4112343		0
71165	4222	40481087	1962-06-17	1962-06-17 00:00:00	1962-06-24	1962-06-24 00:00:00	32020		\N	280304	0	444814009	40481087		0
81892	4855	40481087	1991-09-06	1991-09-06 00:00:00	1991-09-13	1991-09-13 00:00:00	32020		\N	323017	0	444814009	40481087		0
71517	4241	80180	2006-08-08	2006-08-08 00:00:00	\N	\N	32020		\N	281736	0	396275006	80180		0
82247	4878	4109685	1964-01-30	1964-01-30 00:00:00	1964-02-20	1964-02-20 00:00:00	32020		\N	324460	0	284551006	4109685		0
82367	4886	4237458	1970-11-09	1970-11-09 00:00:00	1971-02-07	1971-02-07 00:00:00	32020		\N	324930	0	58150001	4237458		0
82534	4898	4152936	1991-08-24	1991-08-24 00:00:00	1991-09-07	1991-09-07 00:00:00	32020		\N	325706	0	283385000	4152936		0
72170	4282	372328	1966-10-03	1966-10-03 00:00:00	1966-12-14	1966-12-14 00:00:00	32020		\N	284200	0	65363002	372328		0
72331	4291	4230399	1978-09-28	1978-09-28 00:00:00	1978-12-27	1978-12-27 00:00:00	32020		\N	284892	0	359817006	4230399		0
83247	4945	260139	1982-05-03	1982-05-03 00:00:00	1982-05-17	1982-05-17 00:00:00	32020		\N	328667	0	10509002	260139		0
83345	4952	4035415	1979-06-02	1979-06-02 00:00:00	1979-07-02	1979-07-02 00:00:00	32020		\N	329121	0	239720000	4035415		0
83750	4976	81151	1936-09-05	1936-09-05 00:00:00	1936-09-19	1936-09-19 00:00:00	32020		\N	331102	0	44465007	81151		0
83916	4986	40481087	1969-11-06	1969-11-06 00:00:00	1969-11-13	1969-11-13 00:00:00	32020		\N	331690	0	444814009	40481087		0
84140	4999	40481087	1992-08-13	1992-08-13 00:00:00	1992-09-03	1992-09-03 00:00:00	32020		\N	332460	0	444814009	40481087		0
73643	4376	381316	1985-03-19	1985-03-19 00:00:00	\N	\N	32020		\N	290703	0	230690007	381316		0
84419	5018	372328	1942-07-03	1942-07-03 00:00:00	1942-10-22	1942-10-22 00:00:00	32020		\N	333545	0	65363002	372328		0
84652	5034	4266809	1959-07-27	1959-07-27 00:00:00	\N	\N	32020		\N	334498	0	397881000	4266809		0
84747	5039	372328	1974-10-21	1974-10-21 00:00:00	1974-12-31	1974-12-31 00:00:00	32020		\N	334864	0	65363002	372328		0
84959	5051	40481087	1983-04-10	1983-04-10 00:00:00	1983-04-17	1983-04-17 00:00:00	32020		\N	335898	0	444814009	40481087		0
85018	5056	4230399	1950-09-03	1950-09-03 00:00:00	1950-10-03	1950-10-03 00:00:00	32020		\N	336162	0	359817006	4230399		0
85162	5065	40481087	1969-04-21	1969-04-21 00:00:00	1969-05-05	1969-05-05 00:00:00	32020		\N	336729	0	444814009	40481087		0
74744	4439	372328	1955-03-08	1955-03-08 00:00:00	1955-05-18	1955-05-18 00:00:00	32020		\N	295125	0	65363002	372328		0
74890	4448	80180	1995-01-20	1995-01-20 00:00:00	\N	\N	32020		\N	295855	0	396275006	80180		0
64563	3817	260139	1964-12-21	1964-12-21 00:00:00	1965-01-04	1965-01-04 00:00:00	32020		\N	253486	0	10509002	260139		0
75295	4472	4112343	1971-05-14	1971-05-14 00:00:00	1971-05-24	1971-05-24 00:00:00	32020		\N	297495	0	195662009	4112343		0
64825	3833	80180	2001-12-07	2001-12-07 00:00:00	\N	\N	32020		\N	254486	0	396275006	80180		0
75559	4484	40481087	1972-02-12	1972-02-12 00:00:00	1972-02-19	1972-02-19 00:00:00	32020		\N	298482	0	444814009	40481087		0
65216	3857	28060	1954-10-11	1954-10-11 00:00:00	1954-10-21	1954-10-21 00:00:00	32020		\N	255979	0	43878008	28060		0
65381	3866	28060	1966-02-10	1966-02-10 00:00:00	1966-02-17	1966-02-17 00:00:00	32020		\N	256684	0	43878008	28060		0
76070	4513	260139	1966-03-01	1966-03-01 00:00:00	1966-03-15	1966-03-15 00:00:00	32020		\N	300579	0	10509002	260139		0
76306	4527	4285898	2001-12-22	2001-12-22 00:00:00	\N	\N	32020		\N	301441	0	68496003	4285898		0
76468	4532	4112343	1939-02-22	1939-02-22 00:00:00	1939-03-03	1939-03-03 00:00:00	32020		\N	301916	0	195662009	4112343		0
76574	4538	257012	2014-02-28	2014-02-28 00:00:00	\N	\N	32020		\N	302394	0	40055000	257012		0
76738	4547	80502	1969-06-29	1969-06-29 00:00:00	\N	\N	32020		\N	302950	0	64859006	80502		0
76906	4557	4112343	1942-09-13	1942-09-13 00:00:00	1942-09-25	1942-09-25 00:00:00	32020		\N	303621	0	195662009	4112343		0
66546	3938	40481087	1971-02-12	1971-02-12 00:00:00	1971-03-05	1971-03-05 00:00:00	32020		\N	261740	0	444814009	40481087		0
77323	4579	4218389	2009-01-04	2009-01-04 00:00:00	2009-02-08	2009-02-08 00:00:00	32020		\N	305006	0	39848009	4218389		0
77470	4590	4310024	1994-05-03	1994-05-03 00:00:00	\N	\N	32020		\N	305824	0	424802006	4310024		0
77591	4596	81151	1971-03-24	1971-03-24 00:00:00	1971-04-14	1971-04-14 00:00:00	32020		\N	306269	0	44465007	81151		0
77723	4604	4152936	2000-04-21	2000-04-21 00:00:00	2000-05-05	2000-05-05 00:00:00	32020		\N	306760	0	283385000	4152936		0
88551	5264	4283893	2019-01-25	2019-01-25 00:00:00	2019-02-22	2019-02-22 00:00:00	32020		\N	350217	0	36971009	4283893		0
78072	4625	4112343	2017-05-31	2017-05-31 00:00:00	2017-06-13	2017-06-13 00:00:00	32020		\N	308074	0	195662009	4112343		0
78200	4631	260139	1913-10-09	1913-10-09 00:00:00	1913-10-16	1913-10-16 00:00:00	32020		\N	308600	0	10509002	260139		0
78385	4641	260139	1978-03-19	1978-03-19 00:00:00	1978-03-26	1978-03-26 00:00:00	32020		\N	309295	0	10509002	260139		0
78575	4653	4112343	2004-07-18	2004-07-18 00:00:00	2004-07-25	2004-07-25 00:00:00	32020		\N	310140	0	195662009	4112343		0
78700	4661	40481087	1982-11-11	1982-11-11 00:00:00	1982-11-25	1982-11-25 00:00:00	32020		\N	310693	0	444814009	40481087		0
78979	4676	439777	1983-08-01	1983-08-01 00:00:00	\N	\N	32020		\N	311586	0	271737000	439777		0
79064	4680	40481087	1925-02-12	1925-02-12 00:00:00	1925-02-19	1925-02-19 00:00:00	32020		\N	311955	0	444814009	40481087		0
79273	4694	40481087	2016-07-18	2016-07-18 00:00:00	2016-07-25	2016-07-25 00:00:00	32020		\N	312764	0	444814009	40481087		0
79461	4705	372328	1976-08-23	1976-08-23 00:00:00	1977-03-24	1977-03-24 00:00:00	32020		\N	313454	0	65363002	372328		0
69017	4085	40481087	1982-11-28	1982-11-28 00:00:00	1982-12-05	1982-12-05 00:00:00	32020		\N	271494	0	444814009	40481087		0
79704	4722	40481087	1933-03-29	1933-03-29 00:00:00	1933-04-05	1933-04-05 00:00:00	32020		\N	314498	0	444814009	40481087		0
80007	4739	40481087	1920-01-31	1920-01-31 00:00:00	1920-02-21	1920-02-21 00:00:00	32020		\N	315751	0	444814009	40481087		0
69489	4113	4112343	1991-09-03	1991-09-03 00:00:00	1991-09-16	1991-09-16 00:00:00	32020		\N	273460	0	195662009	4112343		0
69666	4122	81893	2012-08-27	2012-08-27 00:00:00	\N	\N	32020		\N	274029	0	64766004	81893		0
80434	4763	4218389	1951-06-18	1951-06-18 00:00:00	1951-07-09	1951-07-09 00:00:00	32020		\N	317453	0	39848009	4218389		0
80694	4784	4112343	2013-12-12	2013-12-12 00:00:00	2013-12-23	2013-12-23 00:00:00	32020		\N	318486	0	195662009	4112343		0
80943	4801	40481087	1971-08-28	1971-08-28 00:00:00	1971-09-18	1971-09-18 00:00:00	32020		\N	319388	0	444814009	40481087		0
81387	4827	4059173	1983-04-28	1983-04-28 00:00:00	1983-05-28	1983-05-28 00:00:00	32020		\N	321146	0	16114001	4059173		0
81516	4835	40481087	1983-06-19	1983-06-19 00:00:00	1983-07-03	1983-07-03 00:00:00	32020		\N	321630	0	444814009	40481087		0
71166	4222	4112343	1969-06-02	1969-06-02 00:00:00	1969-06-11	1969-06-11 00:00:00	32020		\N	280305	0	195662009	4112343		0
81893	4855	4112343	1996-10-31	1996-10-31 00:00:00	1996-11-07	1996-11-07 00:00:00	32020		\N	322995	0	195662009	4112343		0
71518	4241	4285898	2006-05-10	2006-05-10 00:00:00	\N	\N	32020		\N	281736	0	68496003	4285898		0
82248	4878	4112343	1968-11-14	1968-11-14 00:00:00	1968-11-22	1968-11-22 00:00:00	32020		\N	324329	0	195662009	4112343		0
82368	4886	378001	2018-11-25	2018-11-25 00:00:00	2018-12-25	2018-12-25 00:00:00	32020		\N	324886	0	62106007	378001		0
82535	4898	260139	1954-03-14	1954-03-14 00:00:00	1954-03-28	1954-03-28 00:00:00	32020		\N	325663	0	10509002	260139		0
72171	4282	40481087	2013-10-31	2013-10-31 00:00:00	2013-11-14	2013-11-14 00:00:00	32020		\N	284199	0	444814009	40481087		0
72332	4291	260139	1982-12-08	1982-12-08 00:00:00	1982-12-15	1982-12-15 00:00:00	32020		\N	284878	0	10509002	260139		0
83248	4945	40481087	1986-05-29	1986-05-29 00:00:00	1986-06-05	1986-06-05 00:00:00	32020		\N	328731	0	444814009	40481087		0
83346	4952	4294548	1972-03-16	1972-03-16 00:00:00	1972-06-29	1972-06-29 00:00:00	32020		\N	329126	0	75498004	4294548		0
83751	4976	80180	1953-12-22	1953-12-22 00:00:00	\N	\N	32020		\N	331033	0	396275006	80180		0
83917	4986	372328	1952-10-24	1952-10-24 00:00:00	1953-03-29	1953-03-29 00:00:00	32020		\N	331654	0	65363002	372328		0
84141	4999	4283893	2003-06-17	2003-06-17 00:00:00	2003-09-23	2003-09-23 00:00:00	32020		\N	332418	0	36971009	4283893		0
73644	4376	4296205	1956-10-20	1956-10-20 00:00:00	1956-11-24	1956-11-24 00:00:00	32020		\N	290730	0	403191005	4296205		0
84420	5018	4112343	1995-03-13	1995-03-13 00:00:00	1995-03-21	1995-03-21 00:00:00	32020		\N	333524	0	195662009	4112343		0
84653	5034	30753	1958-11-29	1958-11-29 00:00:00	\N	\N	32020		\N	334498	0	16761005	30753		0
84748	5039	372328	1977-01-19	1977-01-19 00:00:00	1977-06-28	1977-06-28 00:00:00	32020		\N	334884	0	65363002	372328		0
84963	5053	260139	1986-02-18	1986-02-18 00:00:00	1986-03-04	1986-03-04 00:00:00	32020		\N	336040	0	10509002	260139		0
85019	5056	4116491	1993-02-10	1993-02-10 00:00:00	1993-03-15	1993-03-15 00:00:00	32020		\N	336132	0	301011002	4116491		0
85163	5065	40481087	1970-10-17	1970-10-17 00:00:00	1970-10-31	1970-10-31 00:00:00	32020		\N	336738	0	444814009	40481087		0
74745	4439	4112343	1985-12-22	1985-12-22 00:00:00	1986-01-04	1986-01-04 00:00:00	32020		\N	295122	0	195662009	4112343		0
64564	3817	260139	2012-09-16	2012-09-16 00:00:00	2012-09-23	2012-09-23 00:00:00	32020		\N	253514	0	10509002	260139		0
75296	4472	378001	1941-04-11	1941-04-11 00:00:00	1941-06-10	1941-06-10 00:00:00	32020		\N	297543	0	62106007	378001		0
64826	3833	40481087	2001-10-18	2001-10-18 00:00:00	2001-11-08	2001-11-08 00:00:00	32020		\N	254486	0	444814009	40481087		0
75560	4484	40481087	1970-08-22	1970-08-22 00:00:00	1970-09-12	1970-09-12 00:00:00	32020		\N	298473	0	444814009	40481087		0
65217	3857	4112343	1992-05-04	1992-05-04 00:00:00	1992-05-13	1992-05-13 00:00:00	32020		\N	255952	0	195662009	4112343		0
65382	3866	4237458	1964-08-19	1964-08-19 00:00:00	1964-09-18	1964-09-18 00:00:00	32020		\N	256760	0	58150001	4237458		0
76071	4513	260139	1978-12-05	1978-12-05 00:00:00	1978-12-19	1978-12-19 00:00:00	32020		\N	300519	0	10509002	260139		0
76307	4527	381316	2001-03-02	2001-03-02 00:00:00	\N	\N	32020		\N	301441	0	230690007	381316		0
76469	4532	81151	1998-08-17	1998-08-17 00:00:00	1998-09-07	1998-09-07 00:00:00	32020		\N	301894	0	44465007	81151		0
76575	4538	40481087	1999-12-31	1999-12-31 00:00:00	2000-01-07	2000-01-07 00:00:00	32020		\N	302390	0	444814009	40481087		0
76739	4547	4152936	1918-10-10	1918-10-10 00:00:00	1918-10-31	1918-10-31 00:00:00	32020		\N	302956	0	283385000	4152936		0
76907	4557	40481087	1947-01-24	1947-01-24 00:00:00	1947-02-07	1947-02-07 00:00:00	32020		\N	303622	0	444814009	40481087		0
66547	3938	260139	1929-11-14	1929-11-14 00:00:00	1929-11-21	1929-11-21 00:00:00	32020		\N	261701	0	10509002	260139		0
77324	4579	260139	1969-07-05	1969-07-05 00:00:00	1969-07-19	1969-07-19 00:00:00	32020		\N	305027	0	10509002	260139		0
77471	4590	80180	1995-11-24	1995-11-24 00:00:00	\N	\N	32020		\N	305824	0	396275006	80180		0
77592	4596	260139	1958-11-12	1958-11-12 00:00:00	1958-11-21	1958-11-21 00:00:00	32020		\N	306268	0	10509002	260139		0
77724	4604	260139	1971-03-26	1971-03-26 00:00:00	1971-04-09	1971-04-09 00:00:00	32020		\N	306711	0	10509002	260139		0
88552	5264	4294548	1992-02-11	1992-02-11 00:00:00	1992-02-25	1992-02-25 00:00:00	32020		\N	350213	0	75498004	4294548		0
78073	4625	78272	2000-01-20	2000-01-20 00:00:00	2000-02-17	2000-02-17 00:00:00	32020		\N	308089	0	70704007	78272		0
78201	4631	28060	1921-03-14	1921-03-14 00:00:00	1921-03-23	1921-03-23 00:00:00	32020		\N	308562	0	43878008	28060		0
78386	4641	4112343	1999-02-18	1999-02-18 00:00:00	1999-02-25	1999-02-25 00:00:00	32020		\N	309298	0	195662009	4112343		0
78576	4653	4112343	1997-04-13	1997-04-13 00:00:00	1997-04-25	1997-04-25 00:00:00	32020		\N	310170	0	195662009	4112343		0
78701	4661	81151	2016-08-29	2016-08-29 00:00:00	2016-09-12	2016-09-12 00:00:00	32020		\N	310685	0	44465007	81151		0
78980	4676	195588	1996-07-28	1996-07-28 00:00:00	1996-09-01	1996-09-01 00:00:00	32020		\N	311597	0	38822007	195588		0
79065	4680	40481087	1995-04-14	1995-04-14 00:00:00	1995-05-05	1995-05-05 00:00:00	32020		\N	311882	0	444814009	40481087		0
79274	4694	40481087	1993-01-16	1993-01-16 00:00:00	1993-01-30	1993-01-30 00:00:00	32020		\N	312749	0	444814009	40481087		0
79462	4705	195588	2010-06-06	2010-06-06 00:00:00	2010-07-20	2010-07-20 00:00:00	32020		\N	313481	0	38822007	195588		0
69018	4085	372328	1959-09-29	1959-09-29 00:00:00	1959-12-12	1959-12-12 00:00:00	32020		\N	271543	0	65363002	372328		0
79705	4722	40481087	1918-04-05	1918-04-05 00:00:00	1918-04-12	1918-04-12 00:00:00	32020		\N	314497	0	444814009	40481087		0
80008	4739	40481087	1975-09-24	1975-09-24 00:00:00	1975-10-15	1975-10-15 00:00:00	32020		\N	315686	0	444814009	40481087		0
69490	4113	80180	1992-05-13	1992-05-13 00:00:00	\N	\N	32020		\N	273460	0	396275006	80180		0
69667	4122	4134304	1995-11-25	1995-11-25 00:00:00	1996-02-23	1996-02-23 00:00:00	32020		\N	274067	0	263102004	4134304		0
80435	4763	4112343	1989-06-25	1989-06-25 00:00:00	1989-07-02	1989-07-02 00:00:00	32020		\N	317428	0	195662009	4112343		0
80695	4784	260139	1953-10-08	1953-10-08 00:00:00	1953-10-15	1953-10-15 00:00:00	32020		\N	318455	0	10509002	260139		0
80944	4801	372328	1972-12-15	1972-12-15 00:00:00	1972-12-29	1972-12-29 00:00:00	32020		\N	319406	0	65363002	372328		0
81388	4827	40481087	2006-07-22	2006-07-22 00:00:00	2006-08-05	2006-08-05 00:00:00	32020		\N	321096	0	444814009	40481087		0
81517	4835	4027663	2000-04-22	2000-04-22 00:00:00	\N	\N	32020		\N	321618	0	13200003	4027663		0
71167	4222	4146173	1959-06-24	1959-06-24 00:00:00	1959-08-23	1959-08-23 00:00:00	32020		\N	280303	0	307731004	4146173		0
81894	4855	195588	2005-10-08	2005-10-08 00:00:00	2005-11-10	2005-11-10 00:00:00	32020		\N	323049	0	38822007	195588		0
71519	4241	78272	1967-10-03	1967-10-03 00:00:00	1967-10-17	1967-10-17 00:00:00	32020		\N	281748	0	70704007	78272		0
82249	4878	378001	1973-08-06	1973-08-06 00:00:00	1973-09-05	1973-09-05 00:00:00	32020		\N	324432	0	62106007	378001		0
82369	4886	260139	2005-04-06	2005-04-06 00:00:00	2005-04-20	2005-04-20 00:00:00	32020		\N	324880	0	10509002	260139		0
82536	4898	4112343	1954-07-21	1954-07-21 00:00:00	1954-07-30	1954-07-30 00:00:00	32020		\N	325689	0	195662009	4112343		0
72172	4283	4112343	1959-02-04	1959-02-04 00:00:00	1959-02-11	1959-02-11 00:00:00	32020		\N	284230	0	195662009	4112343		0
72361	4295	40481087	1995-07-09	1995-07-09 00:00:00	1995-07-23	1995-07-23 00:00:00	32020		\N	285062	0	444814009	40481087		0
83249	4945	40481087	1987-02-09	1987-02-09 00:00:00	1987-03-02	1987-03-02 00:00:00	32020		\N	328724	0	444814009	40481087		0
83347	4952	439777	1991-03-16	1991-03-16 00:00:00	\N	\N	32020		\N	329128	0	271737000	439777		0
83752	4976	4112343	1928-06-06	1928-06-06 00:00:00	1928-06-15	1928-06-15 00:00:00	32020		\N	330966	0	195662009	4112343		0
83918	4986	260139	1955-12-25	1955-12-25 00:00:00	1956-01-01	1956-01-01 00:00:00	32020		\N	331688	0	10509002	260139		0
84142	4999	40481087	2007-01-14	2007-01-14 00:00:00	2007-01-21	2007-01-21 00:00:00	32020		\N	332491	0	444814009	40481087		0
73645	4376	372328	1921-10-24	1921-10-24 00:00:00	1921-11-07	1921-11-07 00:00:00	32020		\N	290788	0	65363002	372328		0
84421	5018	4237458	1976-03-30	1976-03-30 00:00:00	1976-06-28	1976-06-28 00:00:00	32020		\N	333482	0	58150001	4237458		0
84654	5034	81893	1958-07-02	1958-07-02 00:00:00	\N	\N	32020		\N	334498	0	64766004	81893		0
84749	5039	40481087	1992-12-02	1992-12-02 00:00:00	1992-12-09	1992-12-09 00:00:00	32020		\N	334857	0	444814009	40481087		0
84964	5053	80180	1987-06-05	1987-06-05 00:00:00	\N	\N	32020		\N	336040	0	396275006	80180		0
85020	5056	40481087	1938-09-01	1938-09-01 00:00:00	1938-09-08	1938-09-08 00:00:00	32020		\N	336171	0	444814009	40481087		0
85164	5065	28060	1993-01-26	1993-01-26 00:00:00	1993-02-04	1993-02-04 00:00:00	32020		\N	336721	0	43878008	28060		0
74746	4439	4266809	1995-04-12	1995-04-12 00:00:00	\N	\N	32020		\N	295097	0	397881000	4266809		0
74906	4450	260139	2000-08-28	2000-08-28 00:00:00	2000-09-04	2000-09-04 00:00:00	32020		\N	296070	0	10509002	260139		0
64565	3817	4113008	2011-05-17	2011-05-17 00:00:00	2011-05-31	2011-05-31 00:00:00	32020		\N	253530	0	284549007	4113008		0
75297	4472	4278672	2005-11-13	2005-11-13 00:00:00	2006-01-12	2006-01-12 00:00:00	32020		\N	297546	0	65966004	4278672		0
64827	3833	40481087	1984-03-24	1984-03-24 00:00:00	1984-04-14	1984-04-14 00:00:00	32020		\N	254524	0	444814009	40481087		0
75561	4484	4296205	2003-02-17	2003-02-17 00:00:00	2003-03-03	2003-03-03 00:00:00	32020		\N	298469	0	403191005	4296205		0
65218	3857	40481087	1987-03-09	1987-03-09 00:00:00	1987-03-23	1987-03-23 00:00:00	32020		\N	256030	0	444814009	40481087		0
65383	3866	81151	1977-10-31	1977-10-31 00:00:00	1977-11-14	1977-11-14 00:00:00	32020		\N	256701	0	44465007	81151		0
76072	4513	40481087	2018-05-22	2018-05-22 00:00:00	2018-06-05	2018-06-05 00:00:00	32020		\N	300548	0	444814009	40481087		0
76308	4527	40481087	1980-06-10	1980-06-10 00:00:00	1980-06-17	1980-06-17 00:00:00	32020		\N	301414	0	444814009	40481087		0
76470	4532	372328	1911-07-20	1911-07-20 00:00:00	1911-09-23	1911-09-23 00:00:00	32020		\N	301898	0	65363002	372328		0
76576	4538	40481087	1957-03-30	1957-03-30 00:00:00	1957-04-06	1957-04-06 00:00:00	32020		\N	302306	0	444814009	40481087		0
76740	4547	4112343	2010-10-01	2010-10-01 00:00:00	2010-10-14	2010-10-14 00:00:00	32020		\N	302971	0	195662009	4112343		0
76908	4557	4116491	1952-04-10	1952-04-10 00:00:00	1952-05-27	1952-05-27 00:00:00	32020		\N	303653	0	301011002	4116491		0
66548	3938	4112343	1997-08-08	1997-08-08 00:00:00	1997-08-18	1997-08-18 00:00:00	32020		\N	261741	0	195662009	4112343		0
77325	4579	260139	2010-06-10	2010-06-10 00:00:00	2010-06-24	2010-06-24 00:00:00	32020		\N	305031	0	10509002	260139		0
77472	4590	260139	1980-11-13	1980-11-13 00:00:00	1980-11-20	1980-11-20 00:00:00	32020		\N	305885	0	10509002	260139		0
77593	4596	40481087	1963-08-06	1963-08-06 00:00:00	1963-08-27	1963-08-27 00:00:00	32020		\N	306290	0	444814009	40481087		0
77725	4604	260139	1991-09-10	1991-09-10 00:00:00	1991-09-24	1991-09-24 00:00:00	32020		\N	306748	0	10509002	260139		0
88553	5264	260139	1980-04-26	1980-04-26 00:00:00	1980-05-03	1980-05-03 00:00:00	32020		\N	350206	0	10509002	260139		0
78074	4625	40481087	1982-03-31	1982-03-31 00:00:00	1982-04-21	1982-04-21 00:00:00	32020		\N	308072	0	444814009	40481087		0
78202	4631	40481087	2014-02-09	2014-02-09 00:00:00	2014-02-16	2014-02-16 00:00:00	32020		\N	308655	0	444814009	40481087		0
78387	4642	40481087	1976-07-25	1976-07-25 00:00:00	1976-08-01	1976-08-01 00:00:00	32020		\N	309415	0	444814009	40481087		0
78577	4653	4112343	1989-05-11	1989-05-11 00:00:00	1989-05-23	1989-05-23 00:00:00	32020		\N	310128	0	195662009	4112343		0
78702	4661	80180	2018-02-21	2018-02-21 00:00:00	\N	\N	32020		\N	310685	0	396275006	80180		0
78981	4676	372328	1982-11-03	1982-11-03 00:00:00	1983-01-06	1983-01-06 00:00:00	32020		\N	311600	0	65363002	372328		0
79066	4680	378001	1912-03-02	1912-03-02 00:00:00	1912-05-01	1912-05-01 00:00:00	32020		\N	311938	0	62106007	378001		0
79275	4694	4237458	1982-08-04	1982-08-04 00:00:00	1982-11-02	1982-11-02 00:00:00	32020		\N	312718	0	58150001	4237458		0
79463	4705	4112343	2016-04-07	2016-04-07 00:00:00	2016-04-17	2016-04-17 00:00:00	32020		\N	313494	0	195662009	4112343		0
69019	4085	260139	1976-10-03	1976-10-03 00:00:00	1976-10-10	1976-10-10 00:00:00	32020		\N	271540	0	10509002	260139		0
79706	4722	4278672	2012-10-14	2012-10-14 00:00:00	2013-01-12	2013-01-12 00:00:00	32020		\N	314616	0	65966004	4278672		0
80009	4739	28060	1948-02-18	1948-02-18 00:00:00	1948-02-28	1948-02-28 00:00:00	32020		\N	315684	0	43878008	28060		0
69491	4113	28060	1984-05-05	1984-05-05 00:00:00	1984-05-13	1984-05-13 00:00:00	32020		\N	273458	0	43878008	28060		0
69668	4122	260139	2004-06-12	2004-06-12 00:00:00	2004-06-19	2004-06-19 00:00:00	32020		\N	274034	0	10509002	260139		0
80436	4763	40481087	1983-10-20	1983-10-20 00:00:00	1983-11-03	1983-11-03 00:00:00	32020		\N	317415	0	444814009	40481087		0
80733	4788	40481087	2013-01-23	2013-01-23 00:00:00	2013-01-30	2013-01-30 00:00:00	32020		\N	318676	0	444814009	40481087		0
80945	4801	4152936	1991-01-10	1991-01-10 00:00:00	1991-01-24	1991-01-24 00:00:00	32020		\N	319422	0	283385000	4152936		0
81389	4827	80180	1991-01-17	1991-01-17 00:00:00	\N	\N	32020		\N	321119	0	396275006	80180		0
81518	4835	4230399	1974-03-10	1974-03-10 00:00:00	1974-04-09	1974-04-09 00:00:00	32020		\N	321633	0	359817006	4230399		0
71168	4222	40481087	1997-08-10	1997-08-10 00:00:00	1997-08-17	1997-08-17 00:00:00	32020		\N	280287	0	444814009	40481087		0
81895	4855	4112343	2008-03-11	2008-03-11 00:00:00	2008-03-22	2008-03-22 00:00:00	32020		\N	323021	0	195662009	4112343		0
71520	4241	40481087	1986-08-30	1986-08-30 00:00:00	1986-09-20	1986-09-20 00:00:00	32020		\N	281738	0	444814009	40481087		0
82250	4878	4084167	1963-08-03	1963-08-03 00:00:00	1963-08-03	1963-08-03 00:00:00	32020		\N	324459	0	241929008	4084167		0
82370	4886	4112343	1980-07-02	1980-07-02 00:00:00	1980-07-09	1980-07-09 00:00:00	32020		\N	324903	0	195662009	4112343		0
82537	4898	40481087	1963-06-27	1963-06-27 00:00:00	1963-07-11	1963-07-11 00:00:00	32020		\N	325664	0	444814009	40481087		0
72173	4283	4146173	1955-11-19	1955-11-19 00:00:00	1956-01-25	1956-01-25 00:00:00	32020		\N	284228	0	307731004	4146173		0
72362	4295	260139	1999-10-20	1999-10-20 00:00:00	1999-10-27	1999-10-27 00:00:00	32020		\N	285073	0	10509002	260139		0
83250	4945	4112343	2010-08-28	2010-08-28 00:00:00	2010-09-08	2010-09-08 00:00:00	32020		\N	328671	0	195662009	4112343		0
83348	4952	40481087	1984-02-14	1984-02-14 00:00:00	1984-02-21	1984-02-21 00:00:00	32020		\N	329154	0	444814009	40481087		0
83753	4976	255848	1996-03-24	1996-03-24 00:00:00	\N	\N	32020		\N	330922	0	233604007	255848		0
83919	4986	4218389	1979-03-13	1979-03-13 00:00:00	1979-04-10	1979-04-10 00:00:00	32020		\N	331616	0	39848009	4218389		0
84143	4999	260139	1988-08-31	1988-08-31 00:00:00	1988-09-07	1988-09-07 00:00:00	32020		\N	332414	0	10509002	260139		0
73646	4376	4059173	1989-05-05	1989-05-05 00:00:00	1989-08-03	1989-08-03 00:00:00	32020		\N	290733	0	16114001	4059173		0
84422	5018	260139	1979-03-13	1979-03-13 00:00:00	1979-03-27	1979-03-27 00:00:00	32020		\N	333543	0	10509002	260139		0
84655	5035	260139	1982-03-02	1982-03-02 00:00:00	1982-03-16	1982-03-16 00:00:00	32020		\N	334590	0	10509002	260139		0
84750	5039	4113008	1976-05-13	1976-05-13 00:00:00	1976-06-03	1976-06-03 00:00:00	32020		\N	334865	0	284549007	4113008		0
84965	5053	40481087	1992-11-06	1992-11-06 00:00:00	1992-11-13	1992-11-13 00:00:00	32020		\N	336010	0	444814009	40481087		0
85021	5056	4278672	2005-10-12	2005-10-12 00:00:00	2006-01-10	2006-01-10 00:00:00	32020		\N	336181	0	65966004	4278672		0
85165	5065	372328	1971-06-01	1971-06-01 00:00:00	1971-07-20	1971-07-20 00:00:00	32020		\N	336741	0	65363002	372328		0
74747	4439	80180	1995-04-12	1995-04-12 00:00:00	\N	\N	32020		\N	295097	0	396275006	80180		0
74907	4450	372328	1970-03-16	1970-03-16 00:00:00	1970-06-13	1970-06-13 00:00:00	32020		\N	296052	0	65363002	372328		0
64566	3817	372328	1967-02-07	1967-02-07 00:00:00	1967-07-07	1967-07-07 00:00:00	32020		\N	253524	0	65363002	372328		0
75298	4472	260139	1960-09-16	1960-09-16 00:00:00	1960-09-30	1960-09-30 00:00:00	32020		\N	297480	0	10509002	260139		0
64828	3833	192671	2002-01-27	2002-01-27 00:00:00	\N	\N	32020		\N	254498	0	K92.2	35208414		0
75562	4484	81151	1966-09-24	1966-09-24 00:00:00	1966-10-29	1966-10-29 00:00:00	32020		\N	298467	0	44465007	81151		0
65219	3857	260139	1960-06-10	1960-06-10 00:00:00	1960-06-17	1960-06-17 00:00:00	32020		\N	256029	0	10509002	260139		0
65384	3866	81151	1960-10-11	1960-10-11 00:00:00	1960-11-08	1960-11-08 00:00:00	32020		\N	256759	0	44465007	81151		0
76073	4513	4278672	1978-01-16	1978-01-16 00:00:00	1978-04-16	1978-04-16 00:00:00	32020		\N	300570	0	65966004	4278672		0
76309	4527	78272	1986-05-25	1986-05-25 00:00:00	1986-06-15	1986-06-15 00:00:00	32020		\N	301445	0	70704007	78272		0
76471	4532	372328	1911-03-08	1911-03-08 00:00:00	1911-03-22	1911-03-22 00:00:00	32020		\N	301860	0	65363002	372328		0
76577	4538	4112343	1999-06-15	1999-06-15 00:00:00	1999-06-23	1999-06-23 00:00:00	32020		\N	302310	0	195662009	4112343		0
76741	4547	372328	1910-04-11	1910-04-11 00:00:00	1910-09-25	1910-09-25 00:00:00	32020		\N	302905	0	65363002	372328		0
76909	4557	4027663	1954-04-10	1954-04-10 00:00:00	\N	\N	32020		\N	303653	0	13200003	4027663		0
66549	3938	40481087	1961-11-11	1961-11-11 00:00:00	1961-11-25	1961-11-25 00:00:00	32020		\N	261771	0	444814009	40481087		0
77326	4579	372328	1999-05-14	1999-05-14 00:00:00	2000-03-03	2000-03-03 00:00:00	32020		\N	305012	0	65363002	372328		0
77473	4590	40481087	1958-11-07	1958-11-07 00:00:00	1958-11-28	1958-11-28 00:00:00	32020		\N	305883	0	444814009	40481087		0
77594	4596	4266809	1979-01-27	1979-01-27 00:00:00	\N	\N	32020		\N	\N	0	397881000	4266809		0
77726	4604	80180	2002-05-06	2002-05-06 00:00:00	\N	\N	32020		\N	306749	0	396275006	80180		0
88554	5264	4112343	2008-07-18	2008-07-18 00:00:00	2008-07-30	2008-07-30 00:00:00	32020		\N	350216	0	195662009	4112343		0
78075	4626	4294548	1984-04-24	1984-04-24 00:00:00	1984-05-15	1984-05-15 00:00:00	32020		\N	308212	0	75498004	4294548		0
78203	4631	40481087	2011-11-10	2011-11-10 00:00:00	2011-11-17	2011-11-17 00:00:00	32020		\N	308653	0	444814009	40481087		0
78388	4642	40481087	1965-11-22	1965-11-22 00:00:00	1965-12-13	1965-12-13 00:00:00	32020		\N	309357	0	444814009	40481087		0
78578	4653	40481087	1969-05-09	1969-05-09 00:00:00	1969-05-30	1969-05-30 00:00:00	32020		\N	310192	0	444814009	40481087		0
78703	4661	40481087	2012-12-02	2012-12-02 00:00:00	2012-12-09	2012-12-09 00:00:00	32020		\N	310687	0	444814009	40481087		0
78982	4676	4218389	1997-12-25	1997-12-25 00:00:00	1998-01-29	1998-01-29 00:00:00	32020		\N	311619	0	39848009	4218389		0
79067	4680	81151	1976-01-29	1976-01-29 00:00:00	1976-02-12	1976-02-12 00:00:00	32020		\N	311947	0	44465007	81151		0
79276	4694	40481087	2009-04-12	2009-04-12 00:00:00	2009-05-03	2009-05-03 00:00:00	32020		\N	312763	0	444814009	40481087		0
79464	4705	4112343	1978-04-19	1978-04-19 00:00:00	1978-04-26	1978-04-26 00:00:00	32020		\N	313443	0	195662009	4112343		0
69020	4085	260139	1994-04-21	1994-04-21 00:00:00	1994-04-28	1994-04-28 00:00:00	32020		\N	271499	0	10509002	260139		0
79707	4722	4218389	1914-02-18	1914-02-18 00:00:00	1914-03-11	1914-03-11 00:00:00	32020		\N	314551	0	39848009	4218389		0
69492	4113	4112343	1986-05-21	1986-05-21 00:00:00	1986-05-29	1986-05-29 00:00:00	32020		\N	273459	0	195662009	4112343		0
69669	4122	257012	2001-05-13	2001-05-13 00:00:00	\N	\N	32020		\N	274073	0	40055000	257012		0
80437	4763	260139	2003-08-15	2003-08-15 00:00:00	2003-08-22	2003-08-22 00:00:00	32020		\N	317418	0	10509002	260139		0
80734	4788	40481087	2008-11-03	2008-11-03 00:00:00	2008-11-10	2008-11-10 00:00:00	32020		\N	318670	0	444814009	40481087		0
80946	4801	40481087	2006-03-15	2006-03-15 00:00:00	2006-03-22	2006-03-22 00:00:00	32020		\N	319378	0	444814009	40481087		0
81390	4827	4116491	1994-11-27	1994-11-27 00:00:00	1995-01-06	1995-01-06 00:00:00	32020		\N	321225	0	301011002	4116491		0
81519	4835	260139	2004-06-02	2004-06-02 00:00:00	2004-06-09	2004-06-09 00:00:00	32020		\N	321639	0	10509002	260139		0
71169	4222	40481087	1987-10-02	1987-10-02 00:00:00	1987-10-23	1987-10-23 00:00:00	32020		\N	280286	0	444814009	40481087		0
81896	4855	372328	1982-11-19	1982-11-19 00:00:00	1983-08-27	1983-08-27 00:00:00	32020		\N	322999	0	65363002	372328		0
71521	4241	40481087	1978-12-03	1978-12-03 00:00:00	1978-12-10	1978-12-10 00:00:00	32020		\N	281753	0	444814009	40481087		0
82251	4878	440448	2011-12-25	2011-12-25 00:00:00	\N	\N	32020		\N	324433	0	74400008	440448		0
82371	4886	4237458	1973-08-25	1973-08-25 00:00:00	1973-10-24	1973-10-24 00:00:00	32020		\N	324931	0	58150001	4237458		0
82538	4898	260139	2003-09-16	2003-09-16 00:00:00	2003-09-23	2003-09-23 00:00:00	32020		\N	325668	0	10509002	260139		0
72174	4283	4059173	1953-10-30	1953-10-30 00:00:00	1954-01-28	1954-01-28 00:00:00	32020		\N	284278	0	16114001	4059173		0
72363	4295	372328	1976-12-25	1976-12-25 00:00:00	1977-08-03	1977-08-03 00:00:00	32020		\N	285080	0	65363002	372328		0
83251	4945	40481087	1988-01-01	1988-01-01 00:00:00	1988-01-15	1988-01-15 00:00:00	32020		\N	328668	0	444814009	40481087		0
83396	4957	4112343	2001-08-26	2001-08-26 00:00:00	2001-09-06	2001-09-06 00:00:00	32020		\N	329524	0	195662009	4112343		0
83754	4976	260139	1987-01-10	1987-01-10 00:00:00	1987-01-24	1987-01-24 00:00:00	32020		\N	330971	0	10509002	260139		0
83920	4986	40481087	1968-04-29	1968-04-29 00:00:00	1968-05-06	1968-05-06 00:00:00	32020		\N	331689	0	444814009	40481087		0
84144	4999	378001	1969-11-10	1969-11-10 00:00:00	1969-12-10	1969-12-10 00:00:00	32020		\N	332468	0	62106007	378001		0
73647	4376	28060	1971-09-27	1971-09-27 00:00:00	1971-10-06	1971-10-06 00:00:00	32020		\N	290737	0	43878008	28060		0
84423	5018	4218389	1959-08-01	1959-08-01 00:00:00	1959-09-05	1959-09-05 00:00:00	32020		\N	333480	0	39848009	4218389		0
84656	5035	4112343	1943-09-19	1943-09-19 00:00:00	1943-09-28	1943-09-28 00:00:00	32020		\N	334543	0	195662009	4112343		0
84751	5041	4283893	1981-09-15	1981-09-15 00:00:00	1981-12-01	1981-12-01 00:00:00	32020		\N	334939	0	36971009	4283893		0
84966	5053	4283893	1998-07-22	1998-07-22 00:00:00	1998-10-07	1998-10-07 00:00:00	32020		\N	336042	0	36971009	4283893		0
85022	5056	257012	1985-01-31	1985-01-31 00:00:00	1985-05-30	1985-05-30 00:00:00	32020		\N	336231	0	40055000	257012		0
85166	5065	40481087	1971-07-03	1971-07-03 00:00:00	1971-07-24	1971-07-24 00:00:00	32020		\N	336730	0	444814009	40481087		0
74748	4439	4152936	2002-03-01	2002-03-01 00:00:00	2002-03-22	2002-03-22 00:00:00	32020		\N	295082	0	283385000	4152936		0
74908	4450	4112343	2004-02-02	2004-02-02 00:00:00	2004-02-15	2004-02-15 00:00:00	32020		\N	296071	0	195662009	4112343		0
64567	3817	260139	1997-06-12	1997-06-12 00:00:00	1997-06-19	1997-06-19 00:00:00	32020		\N	253490	0	10509002	260139		0
75299	4472	260139	2009-01-28	2009-01-28 00:00:00	2009-02-04	2009-02-04 00:00:00	32020		\N	297498	0	10509002	260139		0
64829	3833	260139	2018-08-18	2018-08-18 00:00:00	2018-09-01	2018-09-01 00:00:00	32020		\N	254500	0	10509002	260139		0
75563	4484	40481087	1962-02-12	1962-02-12 00:00:00	1962-02-26	1962-02-26 00:00:00	32020		\N	298472	0	444814009	40481087		0
65220	3857	260139	1997-03-22	1997-03-22 00:00:00	1997-04-05	1997-04-05 00:00:00	32020		\N	256005	0	10509002	260139		0
65385	3866	260139	2009-12-03	2009-12-03 00:00:00	2009-12-10	2009-12-10 00:00:00	32020		\N	256736	0	10509002	260139		0
76074	4513	40481087	2008-04-15	2008-04-15 00:00:00	2008-04-22	2008-04-22 00:00:00	32020		\N	300547	0	444814009	40481087		0
76310	4527	260139	2012-03-21	2012-03-21 00:00:00	2012-04-04	2012-04-04 00:00:00	32020		\N	301416	0	10509002	260139		0
76472	4532	28060	1937-01-17	1937-01-17 00:00:00	1937-01-30	1937-01-30 00:00:00	32020		\N	301906	0	43878008	28060		0
76578	4538	4113008	2003-12-26	2003-12-26 00:00:00	2004-01-09	2004-01-09 00:00:00	32020		\N	302316	0	284549007	4113008		0
76742	4548	260139	2016-04-17	2016-04-17 00:00:00	2016-04-24	2016-04-24 00:00:00	32020		\N	303054	0	10509002	260139		0
76910	4557	372328	1971-03-09	1971-03-09 00:00:00	1971-04-25	1971-04-25 00:00:00	32020		\N	303627	0	65363002	372328		0
66550	3938	80502	1990-08-15	1990-08-15 00:00:00	\N	\N	32020		\N	261731	0	64859006	80502		0
77327	4579	4278672	1977-11-18	1977-11-18 00:00:00	1978-02-16	1978-02-16 00:00:00	32020		\N	305005	0	65966004	4278672		0
77474	4590	40481087	1966-02-06	1966-02-06 00:00:00	1966-02-20	1966-02-20 00:00:00	32020		\N	305848	0	444814009	40481087		0
77595	4596	80180	1979-01-27	1979-01-27 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
77727	4604	40481087	2000-10-08	2000-10-08 00:00:00	2000-10-29	2000-10-29 00:00:00	32020		\N	306749	0	444814009	40481087		0
88555	5264	372328	1968-08-26	1968-08-26 00:00:00	1968-10-08	1968-10-08 00:00:00	32020		\N	350218	0	65363002	372328		0
78076	4626	372328	1981-08-28	1981-08-28 00:00:00	1981-10-19	1981-10-19 00:00:00	32020		\N	308228	0	65363002	372328		0
78204	4631	40481087	1933-08-29	1933-08-29 00:00:00	1933-09-05	1933-09-05 00:00:00	32020		\N	308580	0	444814009	40481087		0
78389	4642	4112343	1971-07-04	1971-07-04 00:00:00	1971-07-12	1971-07-12 00:00:00	32020		\N	309358	0	195662009	4112343		0
78579	4653	260139	1993-07-04	1993-07-04 00:00:00	1993-07-18	1993-07-18 00:00:00	32020		\N	310146	0	10509002	260139		0
78704	4661	4112343	2013-04-10	2013-04-10 00:00:00	2013-04-19	2013-04-19 00:00:00	32020		\N	310676	0	195662009	4112343		0
78983	4676	4112343	2015-03-26	2015-03-26 00:00:00	2015-04-07	2015-04-07 00:00:00	32020		\N	311599	0	195662009	4112343		0
79068	4680	4112343	1924-01-01	1924-01-01 00:00:00	1924-01-09	1924-01-09 00:00:00	32020		\N	311954	0	195662009	4112343		0
79277	4694	80180	2018-01-17	2018-01-17 00:00:00	\N	\N	32020		\N	312774	0	396275006	80180		0
79477	4707	4112343	1991-11-14	1991-11-14 00:00:00	1991-11-26	1991-11-26 00:00:00	32020		\N	313557	0	195662009	4112343		0
69021	4085	372328	1961-11-02	1961-11-02 00:00:00	1962-03-10	1962-03-10 00:00:00	32020		\N	271457	0	65363002	372328		0
79708	4722	40481087	1950-05-01	1950-05-01 00:00:00	1950-05-08	1950-05-08 00:00:00	32020		\N	314564	0	444814009	40481087		0
69493	4113	4156265	2008-10-14	2008-10-14 00:00:00	2008-10-28	2008-10-28 00:00:00	32020		\N	273390	0	370247008	4156265		0
69670	4122	4285898	2013-04-24	2013-04-24 00:00:00	\N	\N	32020		\N	274056	0	68496003	4285898		0
80438	4763	4146173	1961-10-14	1961-10-14 00:00:00	1961-12-13	1961-12-13 00:00:00	32020		\N	317404	0	307731004	4146173		0
80735	4788	81151	1989-08-11	1989-08-11 00:00:00	1989-09-01	1989-09-01 00:00:00	32020		\N	318668	0	44465007	81151		0
80947	4801	4112343	1997-04-21	1997-04-21 00:00:00	1997-05-02	1997-05-02 00:00:00	32020		\N	319358	0	195662009	4112343		0
81391	4827	4027663	1979-12-01	1979-12-01 00:00:00	\N	\N	32020		\N	321076	0	13200003	4027663		0
81520	4835	4112343	1980-07-16	1980-07-16 00:00:00	1980-07-28	1980-07-28 00:00:00	32020		\N	321638	0	195662009	4112343		0
71170	4222	40481087	1975-01-06	1975-01-06 00:00:00	1975-01-20	1975-01-20 00:00:00	32020		\N	280285	0	444814009	40481087		0
81897	4855	372328	1982-04-30	1982-04-30 00:00:00	1982-08-21	1982-08-21 00:00:00	32020		\N	323031	0	65363002	372328		0
71522	4241	378001	1972-08-21	1972-08-21 00:00:00	1972-10-20	1972-10-20 00:00:00	32020		\N	281749	0	62106007	378001		0
82252	4878	28060	1963-11-02	1963-11-02 00:00:00	1963-11-09	1963-11-09 00:00:00	32020		\N	324400	0	43878008	28060		0
82372	4886	372328	1968-05-23	1968-05-23 00:00:00	1968-08-12	1968-08-12 00:00:00	32020		\N	324892	0	65363002	372328		0
82539	4898	4112343	2005-04-01	2005-04-01 00:00:00	2005-04-09	2005-04-09 00:00:00	32020		\N	325696	0	195662009	4112343		0
72175	4283	260139	1967-03-09	1967-03-09 00:00:00	1967-03-16	1967-03-16 00:00:00	32020		\N	284262	0	10509002	260139		0
72364	4295	40481087	1985-12-07	1985-12-07 00:00:00	1985-12-21	1985-12-21 00:00:00	32020		\N	285053	0	444814009	40481087		0
83252	4945	80180	1989-03-06	1989-03-06 00:00:00	\N	\N	32020		\N	328668	0	396275006	80180		0
83397	4957	40481087	2016-08-27	2016-08-27 00:00:00	2016-09-17	2016-09-17 00:00:00	32020		\N	329556	0	444814009	40481087		0
83755	4976	4084167	1931-07-06	1931-07-06 00:00:00	1931-07-06	1931-07-06 00:00:00	32020		\N	331101	0	241929008	4084167		0
83921	4986	440086	1960-04-20	1960-04-20 00:00:00	1968-04-28	1968-04-28 00:00:00	32020		\N	331651	0	192127007	440086		0
84145	4999	40481087	1981-06-10	1981-06-10 00:00:00	1981-07-01	1981-07-01 00:00:00	32020		\N	332459	0	444814009	40481087		0
73648	4376	40481087	1983-12-24	1983-12-24 00:00:00	1984-01-14	1984-01-14 00:00:00	32020		\N	290720	0	444814009	40481087		0
84424	5018	40481087	1964-01-16	1964-01-16 00:00:00	1964-01-23	1964-01-23 00:00:00	32020		\N	333463	0	444814009	40481087		0
84657	5035	4112343	1982-10-12	1982-10-12 00:00:00	1982-10-22	1982-10-22 00:00:00	32020		\N	334641	0	195662009	4112343		0
84752	5041	257012	1981-10-13	1981-10-13 00:00:00	1981-12-01	1981-12-01 00:00:00	32020		\N	334950	0	40055000	257012		0
84967	5053	40481087	1989-06-13	1989-06-13 00:00:00	1989-06-20	1989-06-20 00:00:00	32020		\N	336041	0	444814009	40481087		0
85023	5056	4294548	1984-12-27	1984-12-27 00:00:00	1985-05-30	1985-05-30 00:00:00	32020		\N	336230	0	75498004	4294548		0
85167	5065	260139	1984-06-23	1984-06-23 00:00:00	1984-07-07	1984-07-07 00:00:00	32020		\N	336702	0	10509002	260139		0
74749	4439	40481087	2005-08-17	2005-08-17 00:00:00	2005-09-07	2005-09-07 00:00:00	32020		\N	295124	0	444814009	40481087		0
74909	4450	28060	1982-06-28	1982-06-28 00:00:00	1982-07-09	1982-07-09 00:00:00	32020		\N	296092	0	43878008	28060		0
64568	3817	260139	2017-06-25	2017-06-25 00:00:00	2017-07-09	2017-07-09 00:00:00	32020		\N	253492	0	10509002	260139		0
75300	4472	40481087	1966-07-14	1966-07-14 00:00:00	1966-07-21	1966-07-21 00:00:00	32020		\N	297482	0	444814009	40481087		0
64830	3833	260139	1966-09-24	1966-09-24 00:00:00	1966-10-01	1966-10-01 00:00:00	32020		\N	254520	0	10509002	260139		0
75564	4484	40481087	2013-03-25	2013-03-25 00:00:00	2013-04-15	2013-04-15 00:00:00	32020		\N	298506	0	444814009	40481087		0
65221	3857	4112343	1980-06-04	1980-06-04 00:00:00	1980-06-12	1980-06-12 00:00:00	32020		\N	255951	0	195662009	4112343		0
65386	3866	78272	2000-08-15	2000-08-15 00:00:00	2000-09-19	2000-09-19 00:00:00	32020		\N	256702	0	70704007	78272		0
76075	4513	4278672	2004-08-02	2004-08-02 00:00:00	2004-10-01	2004-10-01 00:00:00	32020		\N	300588	0	65966004	4278672		0
76311	4527	4112343	1963-02-26	1963-02-26 00:00:00	1963-03-11	1963-03-11 00:00:00	32020		\N	301412	0	195662009	4112343		0
76483	4534	372328	1946-10-28	1946-10-28 00:00:00	1947-04-02	1947-04-02 00:00:00	32020		\N	302026	0	65363002	372328		0
76579	4538	195588	2012-04-30	2012-04-30 00:00:00	2012-06-18	2012-06-18 00:00:00	32020		\N	302353	0	38822007	195588		0
76743	4548	372328	1995-05-18	1995-05-18 00:00:00	1996-05-07	1996-05-07 00:00:00	32020		\N	303042	0	65363002	372328		0
76911	4557	40481087	2013-05-25	2013-05-25 00:00:00	2013-06-08	2013-06-08 00:00:00	32020		\N	303562	0	444814009	40481087		0
66551	3938	260139	1956-02-04	1956-02-04 00:00:00	1956-02-11	1956-02-11 00:00:00	32020		\N	261720	0	10509002	260139		0
77328	4579	260139	1976-11-12	1976-11-12 00:00:00	1976-11-19	1976-11-19 00:00:00	32020		\N	305072	0	10509002	260139		0
77475	4590	40481087	1964-01-27	1964-01-27 00:00:00	1964-02-10	1964-02-10 00:00:00	32020		\N	305865	0	444814009	40481087		0
77596	4596	260139	2017-01-01	2017-01-01 00:00:00	2017-01-08	2017-01-08 00:00:00	32020		\N	306305	0	10509002	260139		0
77728	4604	260139	1986-08-14	1986-08-14 00:00:00	1986-08-28	1986-08-28 00:00:00	32020		\N	306727	0	10509002	260139		0
88556	5264	4112343	2002-07-09	2002-07-09 00:00:00	2002-07-17	2002-07-17 00:00:00	32020		\N	350215	0	195662009	4112343		0
78077	4626	40481087	1995-01-24	1995-01-24 00:00:00	1995-01-31	1995-01-31 00:00:00	32020		\N	308258	0	444814009	40481087		0
78205	4631	4283893	1978-10-22	1978-10-22 00:00:00	1978-12-17	1978-12-17 00:00:00	32020		\N	308534	0	36971009	4283893		0
78390	4642	4084167	1953-08-22	1953-08-22 00:00:00	1953-08-23	1953-08-23 00:00:00	32020		\N	309390	0	241929008	4084167		0
78580	4653	40481087	2019-04-17	2019-04-17 00:00:00	2019-05-01	2019-05-01 00:00:00	32020		\N	310149	0	444814009	40481087		0
78705	4661	40481087	2015-03-05	2015-03-05 00:00:00	2015-03-26	2015-03-26 00:00:00	32020		\N	310677	0	444814009	40481087		0
78984	4676	40481087	1983-11-18	1983-11-18 00:00:00	1983-12-09	1983-12-09 00:00:00	32020		\N	311587	0	444814009	40481087		0
79069	4680	4142905	1928-09-25	1928-09-25 00:00:00	1928-12-24	1928-12-24 00:00:00	32020		\N	311940	0	33737001	4142905		0
79278	4694	4112343	2016-10-18	2016-10-18 00:00:00	2016-10-26	2016-10-26 00:00:00	32020		\N	312774	0	195662009	4112343		0
79478	4707	4142905	1977-03-19	1977-03-19 00:00:00	1977-06-17	1977-06-17 00:00:00	32020		\N	313554	0	33737001	4142905		0
69022	4085	260139	1983-06-09	1983-06-09 00:00:00	1983-06-16	1983-06-16 00:00:00	32020		\N	271495	0	10509002	260139		0
79709	4722	40481087	2008-05-15	2008-05-15 00:00:00	2008-05-22	2008-05-22 00:00:00	32020		\N	314522	0	444814009	40481087		0
69494	4113	40481087	1995-07-25	1995-07-25 00:00:00	1995-08-08	1995-08-08 00:00:00	32020		\N	273422	0	444814009	40481087		0
69671	4122	4112343	1975-01-18	1975-01-18 00:00:00	1975-01-31	1975-01-31 00:00:00	32020		\N	274068	0	195662009	4112343		0
80439	4764	4112343	1991-10-01	1991-10-01 00:00:00	1991-10-13	1991-10-13 00:00:00	32020		\N	317509	0	195662009	4112343		0
80736	4788	40481087	1979-01-14	1979-01-14 00:00:00	1979-02-04	1979-02-04 00:00:00	32020		\N	318648	0	444814009	40481087		0
80948	4801	260139	2013-03-04	2013-03-04 00:00:00	2013-03-18	2013-03-18 00:00:00	32020		\N	319359	0	10509002	260139		0
81392	4827	260139	1982-05-20	1982-05-20 00:00:00	1982-05-27	1982-05-27 00:00:00	32020		\N	321158	0	10509002	260139		0
81521	4835	4296205	2011-03-26	2011-03-26 00:00:00	2011-04-16	2011-04-16 00:00:00	32020		\N	321636	0	403191005	4296205		0
71171	4222	81151	1998-07-29	1998-07-29 00:00:00	1998-08-26	1998-08-26 00:00:00	32020		\N	280338	0	44465007	81151		0
81945	4859	4112343	1999-10-29	1999-10-29 00:00:00	1999-11-05	1999-11-05 00:00:00	32020		\N	323254	0	195662009	4112343		0
71523	4241	4152936	1976-05-02	1976-05-02 00:00:00	1976-05-16	1976-05-16 00:00:00	32020		\N	281750	0	283385000	4152936		0
82253	4878	40481087	2007-06-23	2007-06-23 00:00:00	2007-06-30	2007-06-30 00:00:00	32020		\N	324321	0	444814009	40481087		0
82373	4886	260139	2017-12-16	2017-12-16 00:00:00	2017-12-23	2017-12-23 00:00:00	32020		\N	324881	0	10509002	260139		0
82540	4898	260139	1991-08-26	1991-08-26 00:00:00	1991-09-02	1991-09-02 00:00:00	32020		\N	325723	0	10509002	260139		0
72176	4283	40481087	1978-05-22	1978-05-22 00:00:00	1978-06-12	1978-06-12 00:00:00	32020		\N	284309	0	444814009	40481087		0
72365	4295	192671	2007-12-11	2007-12-11 00:00:00	\N	\N	32020		\N	285101	0	K92.2	35208414		0
83253	4945	40481087	1995-01-28	1995-01-28 00:00:00	1995-02-04	1995-02-04 00:00:00	32020		\N	328669	0	444814009	40481087		0
83398	4957	372328	1971-12-01	1971-12-01 00:00:00	1972-01-08	1972-01-08 00:00:00	32020		\N	329557	0	65363002	372328		0
83756	4976	40481087	1920-04-01	1920-04-01 00:00:00	1920-04-15	1920-04-15 00:00:00	32020		\N	330934	0	444814009	40481087		0
83922	4986	4112343	2018-03-10	2018-03-10 00:00:00	2018-03-21	2018-03-21 00:00:00	32020		\N	331653	0	195662009	4112343		0
84146	4999	40481087	1970-08-09	1970-08-09 00:00:00	1970-08-16	1970-08-16 00:00:00	32020		\N	332458	0	444814009	40481087		0
73649	4376	4149245	1999-06-12	1999-06-12 00:00:00	1999-08-18	1999-08-18 00:00:00	32020		\N	290734	0	30832001	4149245		0
84425	5018	4294548	2018-09-11	2018-09-11 00:00:00	2019-01-01	2019-01-01 00:00:00	32020		\N	333512	0	75498004	4294548		0
84658	5035	4112343	1963-11-28	1963-11-28 00:00:00	1963-12-10	1963-12-10 00:00:00	32020		\N	334624	0	195662009	4112343		0
84753	5041	4027663	2002-11-16	2002-11-16 00:00:00	\N	\N	32020		\N	334923	0	13200003	4027663		0
84968	5053	40481087	1973-08-14	1973-08-14 00:00:00	1973-08-28	1973-08-28 00:00:00	32020		\N	335989	0	444814009	40481087		0
85024	5056	4310024	1977-12-11	1977-12-11 00:00:00	\N	\N	32020		\N	336156	0	424802006	4310024		0
85168	5065	80180	2002-02-23	2002-02-23 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
74750	4439	4112343	2005-12-22	2005-12-22 00:00:00	2005-12-31	2005-12-31 00:00:00	32020		\N	295103	0	195662009	4112343		0
74910	4450	4112343	2012-02-07	2012-02-07 00:00:00	2012-02-19	2012-02-19 00:00:00	32020		\N	296073	0	195662009	4112343		0
64569	3817	4112343	2001-02-06	2001-02-06 00:00:00	2001-02-17	2001-02-17 00:00:00	32020		\N	253521	0	195662009	4112343		0
75301	4472	4112343	1958-09-25	1958-09-25 00:00:00	1958-10-05	1958-10-05 00:00:00	32020		\N	297493	0	195662009	4112343		0
64831	3833	4155034	2005-10-27	2005-10-27 00:00:00	2005-11-10	2005-11-10 00:00:00	32020		\N	254527	0	283371005	4155034		0
75565	4484	4112343	2009-12-27	2009-12-27 00:00:00	2010-01-03	2010-01-03 00:00:00	32020		\N	298495	0	195662009	4112343		0
65222	3857	260139	2015-07-09	2015-07-09 00:00:00	2015-07-16	2015-07-16 00:00:00	32020		\N	256007	0	10509002	260139		0
65387	3866	372328	1958-01-22	1958-01-22 00:00:00	1958-05-27	1958-05-27 00:00:00	32020		\N	256686	0	65363002	372328		0
76076	4513	28060	2014-07-07	2014-07-07 00:00:00	2014-07-20	2014-07-20 00:00:00	32020		\N	300566	0	43878008	28060		0
76312	4527	40481087	1967-05-27	1967-05-27 00:00:00	1967-06-17	1967-06-17 00:00:00	32020		\N	301425	0	444814009	40481087		0
76484	4534	40481087	1987-03-29	1987-03-29 00:00:00	1987-04-19	1987-04-19 00:00:00	32020		\N	302022	0	444814009	40481087		0
76580	4538	4112343	1982-05-21	1982-05-21 00:00:00	1982-05-30	1982-05-30 00:00:00	32020		\N	302333	0	195662009	4112343		0
76744	4548	40481087	2005-09-04	2005-09-04 00:00:00	2005-09-18	2005-09-18 00:00:00	32020		\N	302991	0	444814009	40481087		0
76913	4559	4296205	1966-11-06	1966-11-06 00:00:00	1966-12-11	1966-12-11 00:00:00	32020		\N	303805	0	403191005	4296205		0
66552	3938	78272	1984-09-20	1984-09-20 00:00:00	1984-10-18	1984-10-18 00:00:00	32020		\N	261809	0	70704007	78272		0
77329	4579	4112343	2016-10-04	2016-10-04 00:00:00	2016-10-13	2016-10-13 00:00:00	32020		\N	305010	0	195662009	4112343		0
77476	4590	4156265	1962-06-10	1962-06-10 00:00:00	1962-07-01	1962-07-01 00:00:00	32020		\N	305862	0	370247008	4156265		0
77597	4596	4112343	2016-06-16	2016-06-16 00:00:00	2016-06-29	2016-06-29 00:00:00	32020		\N	306258	0	195662009	4112343		0
77729	4604	4112343	1976-09-12	1976-09-12 00:00:00	1976-09-22	1976-09-22 00:00:00	32020		\N	306762	0	195662009	4112343		0
88557	5264	80180	2004-07-13	2004-07-13 00:00:00	\N	\N	32020		\N	350215	0	396275006	80180		0
78078	4626	372328	1977-02-25	1977-02-25 00:00:00	1977-04-11	1977-04-11 00:00:00	32020		\N	308226	0	65363002	372328		0
78206	4631	4112343	1948-06-06	1948-06-06 00:00:00	1948-06-13	1948-06-13 00:00:00	32020		\N	308582	0	195662009	4112343		0
78391	4642	40481087	2000-07-07	2000-07-07 00:00:00	2000-07-14	2000-07-14 00:00:00	32020		\N	309402	0	444814009	40481087		0
78581	4653	4296204	1960-02-17	1960-02-17 00:00:00	1960-03-09	1960-03-09 00:00:00	32020		\N	310137	0	403190006	4296204		0
78706	4661	372328	1979-11-28	1979-11-28 00:00:00	1980-03-20	1980-03-20 00:00:00	32020		\N	310688	0	65363002	372328		0
78985	4676	372328	1981-11-19	1981-11-19 00:00:00	1982-01-07	1982-01-07 00:00:00	32020		\N	311604	0	65363002	372328		0
79070	4680	260139	1933-01-13	1933-01-13 00:00:00	1933-01-20	1933-01-20 00:00:00	32020		\N	311878	0	10509002	260139		0
79279	4694	260139	1982-02-07	1982-02-07 00:00:00	1982-02-21	1982-02-21 00:00:00	32020		\N	312747	0	10509002	260139		0
79479	4707	40481087	1976-04-28	1976-04-28 00:00:00	1976-05-05	1976-05-05 00:00:00	32020		\N	313590	0	444814009	40481087		0
69023	4085	260139	1964-04-07	1964-04-07 00:00:00	1964-04-21	1964-04-21 00:00:00	32020		\N	271441	0	10509002	260139		0
79710	4722	80180	1945-07-25	1945-07-25 00:00:00	\N	\N	32020		\N	314589	0	396275006	80180		0
69495	4113	81151	1990-04-10	1990-04-10 00:00:00	1990-04-24	1990-04-24 00:00:00	32020		\N	273387	0	44465007	81151		0
69672	4122	40481087	1997-01-15	1997-01-15 00:00:00	1997-02-05	1997-02-05 00:00:00	32020		\N	274070	0	444814009	40481087		0
80440	4764	40481087	1984-09-22	1984-09-22 00:00:00	1984-09-29	1984-09-29 00:00:00	32020		\N	317493	0	444814009	40481087		0
80737	4788	372328	1978-07-27	1978-07-27 00:00:00	1978-10-29	1978-10-29 00:00:00	32020		\N	318660	0	65363002	372328		0
80949	4801	4112343	1997-08-04	1997-08-04 00:00:00	1997-08-15	1997-08-15 00:00:00	32020		\N	319356	0	195662009	4112343		0
81393	4827	40481087	2014-12-17	2014-12-17 00:00:00	2014-12-31	2014-12-31 00:00:00	32020		\N	321193	0	444814009	40481087		0
81522	4835	4112343	1971-01-26	1971-01-26 00:00:00	1971-02-02	1971-02-02 00:00:00	32020		\N	321637	0	195662009	4112343		0
71172	4222	260139	1956-03-12	1956-03-12 00:00:00	1956-03-19	1956-03-19 00:00:00	32020		\N	280302	0	10509002	260139		0
81946	4859	257012	2010-07-25	2010-07-25 00:00:00	\N	\N	32020		\N	323270	0	40055000	257012		0
71524	4241	4283893	1998-07-16	1998-07-16 00:00:00	1998-10-01	1998-10-01 00:00:00	32020		\N	281757	0	36971009	4283893		0
82254	4878	40481087	1971-08-26	1971-08-26 00:00:00	1971-09-09	1971-09-09 00:00:00	32020		\N	324370	0	444814009	40481087		0
82374	4886	4112343	2014-02-15	2014-02-15 00:00:00	2014-02-25	2014-02-25 00:00:00	32020		\N	324906	0	195662009	4112343		0
82541	4898	4112343	1983-02-11	1983-02-11 00:00:00	1983-02-23	1983-02-23 00:00:00	32020		\N	325666	0	195662009	4112343		0
72177	4283	260139	1964-11-03	1964-11-03 00:00:00	1964-11-17	1964-11-17 00:00:00	32020		\N	284307	0	10509002	260139		0
72366	4295	372328	1975-10-01	1975-10-01 00:00:00	1976-07-28	1976-07-28 00:00:00	32020		\N	285046	0	65363002	372328		0
83254	4945	378001	1969-08-08	1969-08-08 00:00:00	1969-09-07	1969-09-07 00:00:00	32020		\N	328735	0	62106007	378001		0
83399	4957	4112343	1979-09-22	1979-09-22 00:00:00	1979-10-02	1979-10-02 00:00:00	32020		\N	329523	0	195662009	4112343		0
83757	4976	4112343	1956-09-17	1956-09-17 00:00:00	1956-09-27	1956-09-27 00:00:00	32020		\N	330968	0	195662009	4112343		0
83923	4986	80180	1981-12-06	1981-12-06 00:00:00	\N	\N	32020		\N	331633	0	396275006	80180		0
84147	4999	372328	1971-10-01	1971-10-01 00:00:00	1971-12-26	1971-12-26 00:00:00	32020		\N	332420	0	65363002	372328		0
73650	4376	4112343	1925-06-08	1925-06-08 00:00:00	1925-06-15	1925-06-15 00:00:00	32020		\N	290760	0	195662009	4112343		0
84426	5018	81151	1955-09-23	1955-09-23 00:00:00	1955-10-21	1955-10-21 00:00:00	32020		\N	333479	0	44465007	81151		0
84659	5035	372328	1932-09-19	1932-09-19 00:00:00	1932-11-07	1932-11-07 00:00:00	32020		\N	334570	0	65363002	372328		0
84754	5041	4112343	1983-07-24	1983-07-24 00:00:00	1983-08-01	1983-08-01 00:00:00	32020		\N	334951	0	195662009	4112343		0
84969	5053	4059173	1991-06-24	1991-06-24 00:00:00	1991-08-23	1991-08-23 00:00:00	32020		\N	336019	0	16114001	4059173		0
85025	5056	40481087	1996-11-16	1996-11-16 00:00:00	1996-11-23	1996-11-23 00:00:00	32020		\N	336202	0	444814009	40481087		0
85169	5065	260139	1989-02-04	1989-02-04 00:00:00	1989-02-11	1989-02-11 00:00:00	32020		\N	336734	0	10509002	260139		0
74751	4439	260139	1999-02-18	1999-02-18 00:00:00	1999-03-04	1999-03-04 00:00:00	32020		\N	295123	0	10509002	260139		0
74911	4450	4112343	1997-07-24	1997-07-24 00:00:00	1997-08-03	1997-08-03 00:00:00	32020		\N	296069	0	195662009	4112343		0
64570	3817	372328	1968-07-31	1968-07-31 00:00:00	1968-08-30	1968-08-30 00:00:00	32020		\N	253515	0	65363002	372328		0
75302	4472	40481087	1978-11-11	1978-11-11 00:00:00	1978-11-25	1978-11-25 00:00:00	32020		\N	297496	0	444814009	40481087		0
64832	3833	40481087	1968-07-21	1968-07-21 00:00:00	1968-08-11	1968-08-11 00:00:00	32020		\N	254481	0	444814009	40481087		0
75566	4484	372328	1958-01-02	1958-01-02 00:00:00	1958-08-07	1958-08-07 00:00:00	32020		\N	298507	0	65363002	372328		0
65223	3857	4109685	1944-11-29	1944-11-29 00:00:00	1944-12-20	1944-12-20 00:00:00	32020		\N	256033	0	284551006	4109685		0
65388	3866	4116491	2004-09-27	2004-09-27 00:00:00	2004-11-18	2004-11-18 00:00:00	32020		\N	256734	0	301011002	4116491		0
76077	4513	4112343	1993-11-01	1993-11-01 00:00:00	1993-11-12	1993-11-12 00:00:00	32020		\N	300584	0	195662009	4112343		0
76313	4527	260139	1980-05-06	1980-05-06 00:00:00	1980-05-20	1980-05-20 00:00:00	32020		\N	301413	0	10509002	260139		0
76485	4534	40479768	1998-06-10	1998-06-10 00:00:00	1998-08-16	1998-08-16 00:00:00	32020		\N	302078	0	444470001	40479768		0
76581	4538	30753	1986-01-27	1986-01-27 00:00:00	\N	\N	32020		\N	302307	0	16761005	30753		0
76745	4548	40481087	2011-05-21	2011-05-21 00:00:00	2011-05-28	2011-05-28 00:00:00	32020		\N	303053	0	444814009	40481087		0
76914	4559	372328	1950-11-18	1950-11-18 00:00:00	1951-10-02	1951-10-02 00:00:00	32020		\N	303779	0	65363002	372328		0
66553	3938	40481087	1920-09-05	1920-09-05 00:00:00	1920-09-26	1920-09-26 00:00:00	32020		\N	261700	0	444814009	40481087		0
77330	4580	4218389	1975-07-12	1975-07-12 00:00:00	1975-08-16	1975-08-16 00:00:00	32020		\N	305137	0	39848009	4218389		0
77477	4590	4112343	1988-06-27	1988-06-27 00:00:00	1988-07-07	1988-07-07 00:00:00	32020		\N	305886	0	195662009	4112343		0
77598	4596	260139	1962-11-09	1962-11-09 00:00:00	1962-11-16	1962-11-16 00:00:00	32020		\N	306289	0	10509002	260139		0
77730	4604	4112343	1979-03-12	1979-03-12 00:00:00	1979-03-24	1979-03-24 00:00:00	32020		\N	306713	0	195662009	4112343		0
88558	5264	40481087	1983-10-26	1983-10-26 00:00:00	1983-11-16	1983-11-16 00:00:00	32020		\N	350244	0	444814009	40481087		0
78079	4626	260139	1990-12-14	1990-12-14 00:00:00	1990-12-28	1990-12-28 00:00:00	32020		\N	308234	0	10509002	260139		0
78207	4631	40481087	2013-01-17	2013-01-17 00:00:00	2013-02-07	2013-02-07 00:00:00	32020		\N	308654	0	444814009	40481087		0
78392	4642	4112343	1985-12-27	1985-12-27 00:00:00	1986-01-09	1986-01-09 00:00:00	32020		\N	309370	0	195662009	4112343		0
78582	4653	40481087	1986-05-29	1986-05-29 00:00:00	1986-06-19	1986-06-19 00:00:00	32020		\N	310181	0	444814009	40481087		0
78707	4661	40481087	1987-04-12	1987-04-12 00:00:00	1987-04-19	1987-04-19 00:00:00	32020		\N	310694	0	444814009	40481087		0
78986	4676	260139	2014-10-29	2014-10-29 00:00:00	2014-11-12	2014-11-12 00:00:00	32020		\N	311598	0	10509002	260139		0
79071	4680	4237458	1985-06-24	1985-06-24 00:00:00	1985-08-23	1985-08-23 00:00:00	32020		\N	311949	0	58150001	4237458		0
79280	4694	4278672	2001-02-25	2001-02-25 00:00:00	2001-03-27	2001-03-27 00:00:00	32020		\N	312720	0	65966004	4278672		0
79480	4707	372328	1975-03-30	1975-03-30 00:00:00	1975-08-14	1975-08-14 00:00:00	32020		\N	313594	0	65363002	372328		0
69024	4085	372328	1960-02-10	1960-02-10 00:00:00	1960-03-12	1960-03-12 00:00:00	32020		\N	271523	0	65363002	372328		0
79711	4722	40481087	1943-12-13	1943-12-13 00:00:00	1943-12-27	1943-12-27 00:00:00	32020		\N	314589	0	444814009	40481087		0
69496	4113	260139	1972-02-04	1972-02-04 00:00:00	1972-02-18	1972-02-18 00:00:00	32020		\N	273427	0	10509002	260139		0
69673	4122	40481087	2006-04-03	2006-04-03 00:00:00	2006-04-10	2006-04-10 00:00:00	32020		\N	274040	0	444814009	40481087		0
80441	4764	260139	1998-07-17	1998-07-17 00:00:00	1998-07-31	1998-07-31 00:00:00	32020		\N	317484	0	10509002	260139		0
80738	4788	40481087	2016-06-19	2016-06-19 00:00:00	2016-07-10	2016-07-10 00:00:00	32020		\N	318677	0	444814009	40481087		0
80950	4801	40481087	1988-05-11	1988-05-11 00:00:00	1988-05-25	1988-05-25 00:00:00	32020		\N	319355	0	444814009	40481087		0
81394	4827	4113008	1970-12-18	1970-12-18 00:00:00	1971-01-01	1971-01-01 00:00:00	32020		\N	321145	0	284549007	4113008		0
81523	4835	40481087	2016-11-19	2016-11-19 00:00:00	2016-12-03	2016-12-03 00:00:00	32020		\N	321656	0	444814009	40481087		0
71173	4222	40481087	1983-01-06	1983-01-06 00:00:00	1983-01-20	1983-01-20 00:00:00	32020		\N	280273	0	444814009	40481087		0
81947	4859	260139	1980-03-14	1980-03-14 00:00:00	1980-03-21	1980-03-21 00:00:00	32020		\N	323248	0	10509002	260139		0
71525	4241	4294548	1986-01-10	1986-01-10 00:00:00	1986-01-24	1986-01-24 00:00:00	32020		\N	281729	0	75498004	4294548		0
82255	4878	4294548	1991-06-06	1991-06-06 00:00:00	1991-06-20	1991-06-20 00:00:00	32020		\N	324445	0	75498004	4294548		0
82375	4886	260139	1979-09-25	1979-09-25 00:00:00	1979-10-02	1979-10-02 00:00:00	32020		\N	324940	0	10509002	260139		0
82542	4898	28060	1954-02-12	1954-02-12 00:00:00	1954-02-20	1954-02-20 00:00:00	32020		\N	325693	0	43878008	28060		0
72178	4283	30753	1989-05-24	1989-05-24 00:00:00	\N	\N	32020		\N	284269	0	16761005	30753		0
72367	4295	260139	1992-06-18	1992-06-18 00:00:00	1992-07-02	1992-07-02 00:00:00	32020		\N	285071	0	10509002	260139		0
83255	4945	40481087	1991-04-07	1991-04-07 00:00:00	1991-04-14	1991-04-14 00:00:00	32020		\N	328725	0	444814009	40481087		0
83400	4957	78272	2019-06-20	2019-06-20 00:00:00	\N	\N	32020		\N	329512	0	70704007	78272		0
83758	4976	381316	1984-06-12	1984-06-12 00:00:00	\N	\N	32020		\N	330937	0	230690007	381316		0
83924	4986	260139	1959-07-23	1959-07-23 00:00:00	1959-08-06	1959-08-06 00:00:00	32020		\N	331656	0	10509002	260139		0
84148	4999	260139	1978-12-25	1978-12-25 00:00:00	1979-01-08	1979-01-08 00:00:00	32020		\N	332413	0	10509002	260139		0
73651	4376	80180	1961-01-07	1961-01-07 00:00:00	\N	\N	32020		\N	290777	0	396275006	80180		0
84427	5018	40481087	1992-09-25	1992-09-25 00:00:00	1992-10-16	1992-10-16 00:00:00	32020		\N	333488	0	444814009	40481087		0
84660	5035	4112343	1975-01-12	1975-01-12 00:00:00	1975-01-24	1975-01-24 00:00:00	32020		\N	334589	0	195662009	4112343		0
84755	5041	40481087	1971-04-02	1971-04-02 00:00:00	1971-04-09	1971-04-09 00:00:00	32020		\N	334928	0	444814009	40481087		0
84970	5053	81151	2004-03-15	2004-03-15 00:00:00	2004-04-12	2004-04-12 00:00:00	32020		\N	336022	0	44465007	81151		0
85026	5056	40481087	1952-06-12	1952-06-12 00:00:00	1952-06-26	1952-06-26 00:00:00	32020		\N	336197	0	444814009	40481087		0
85170	5065	40481087	1983-07-30	1983-07-30 00:00:00	1983-08-06	1983-08-06 00:00:00	32020		\N	336719	0	444814009	40481087		0
74752	4439	28060	1961-12-19	1961-12-19 00:00:00	1961-12-26	1961-12-26 00:00:00	32020		\N	295121	0	43878008	28060		0
74912	4450	372328	1967-12-10	1967-12-10 00:00:00	1968-01-20	1968-01-20 00:00:00	32020		\N	296075	0	65363002	372328		0
64571	3817	78272	2019-02-18	2019-02-18 00:00:00	2019-03-25	2019-03-25 00:00:00	32020		\N	253531	0	70704007	78272		0
75303	4472	40481087	1970-12-22	1970-12-22 00:00:00	1971-01-05	1971-01-05 00:00:00	32020		\N	297525	0	444814009	40481087		0
64833	3833	40481087	1968-09-19	1968-09-19 00:00:00	1968-09-26	1968-09-26 00:00:00	32020		\N	254521	0	444814009	40481087		0
75567	4484	4112343	1960-09-26	1960-09-26 00:00:00	1960-10-03	1960-10-03 00:00:00	32020		\N	298459	0	195662009	4112343		0
65224	3857	261325	1969-03-11	1969-03-11 00:00:00	\N	\N	32020		\N	256053	0	87433001	261325		0
65389	3866	260139	1984-04-12	1984-04-12 00:00:00	1984-04-19	1984-04-19 00:00:00	32020		\N	256732	0	10509002	260139		0
76078	4513	4112343	1986-01-30	1986-01-30 00:00:00	1986-02-09	1986-02-09 00:00:00	32020		\N	300582	0	195662009	4112343		0
76314	4527	40481087	1978-05-28	1978-05-28 00:00:00	1978-06-18	1978-06-18 00:00:00	32020		\N	301449	0	444814009	40481087		0
76486	4534	40481087	1960-02-16	1960-02-16 00:00:00	1960-03-01	1960-03-01 00:00:00	32020		\N	302056	0	444814009	40481087		0
76582	4538	40481087	1985-04-11	1985-04-11 00:00:00	1985-05-02	1985-05-02 00:00:00	32020		\N	302307	0	444814009	40481087		0
76746	4548	260139	1987-01-02	1987-01-02 00:00:00	1987-01-16	1987-01-16 00:00:00	32020		\N	303094	0	10509002	260139		0
76915	4559	40481087	1983-08-12	1983-08-12 00:00:00	1983-08-26	1983-08-26 00:00:00	32020		\N	303737	0	444814009	40481087		0
66554	3938	4112343	1946-12-09	1946-12-09 00:00:00	1946-12-19	1946-12-19 00:00:00	32020		\N	261776	0	195662009	4112343		0
77331	4580	195588	2008-02-19	2008-02-19 00:00:00	2008-04-10	2008-04-10 00:00:00	32020		\N	305082	0	38822007	195588		0
77478	4590	40481087	1986-08-12	1986-08-12 00:00:00	1986-08-19	1986-08-19 00:00:00	32020		\N	305857	0	444814009	40481087		0
77599	4596	40481087	2005-02-12	2005-02-12 00:00:00	2005-02-19	2005-02-19 00:00:00	32020		\N	306303	0	444814009	40481087		0
77731	4604	260139	1977-09-12	1977-09-12 00:00:00	1977-09-19	1977-09-19 00:00:00	32020		\N	306712	0	10509002	260139		0
88559	5264	40481087	1971-08-16	1971-08-16 00:00:00	1971-08-23	1971-08-23 00:00:00	32020		\N	350227	0	444814009	40481087		0
78080	4626	40481087	1978-06-29	1978-06-29 00:00:00	1978-07-20	1978-07-20 00:00:00	32020		\N	308245	0	444814009	40481087		0
78208	4631	40481087	1948-12-25	1948-12-25 00:00:00	1949-01-15	1949-01-15 00:00:00	32020		\N	308531	0	444814009	40481087		0
78393	4642	80180	1991-11-06	1991-11-06 00:00:00	\N	\N	32020		\N	309363	0	396275006	80180		0
78583	4653	260139	2011-06-28	2011-06-28 00:00:00	2011-07-12	2011-07-12 00:00:00	32020		\N	310148	0	10509002	260139		0
78708	4661	4112343	2008-02-23	2008-02-23 00:00:00	2008-03-05	2008-03-05 00:00:00	32020		\N	310675	0	195662009	4112343		0
78987	4676	4112343	1995-11-22	1995-11-22 00:00:00	1995-12-04	1995-12-04 00:00:00	32020		\N	311589	0	195662009	4112343		0
79073	4680	4029498	1946-04-08	1946-04-08 00:00:00	\N	\N	32020		\N	311942	0	128613002	4029498		0
79281	4694	40481087	2015-02-08	2015-02-08 00:00:00	2015-02-15	2015-02-15 00:00:00	32020		\N	312713	0	444814009	40481087		0
79481	4707	372328	1990-03-28	1990-03-28 00:00:00	1990-10-25	1990-10-25 00:00:00	32020		\N	313595	0	65363002	372328		0
69025	4085	4112343	2002-11-30	2002-11-30 00:00:00	2002-12-08	2002-12-08 00:00:00	32020		\N	271522	0	195662009	4112343		0
79712	4722	4112343	1979-02-23	1979-02-23 00:00:00	1979-03-07	1979-03-07 00:00:00	32020		\N	314591	0	195662009	4112343		0
69497	4113	192671	1992-06-03	1992-06-03 00:00:00	\N	\N	32020		\N	273392	0	K92.2	35208414		0
69674	4122	40481087	2009-03-02	2009-03-02 00:00:00	2009-03-09	2009-03-09 00:00:00	32020		\N	274041	0	444814009	40481087		0
80442	4764	40481087	2018-05-12	2018-05-12 00:00:00	2018-05-19	2018-05-19 00:00:00	32020		\N	317499	0	444814009	40481087		0
80739	4788	378001	1999-10-09	1999-10-09 00:00:00	1999-11-08	1999-11-08 00:00:00	32020		\N	318669	0	62106007	378001		0
80951	4801	40481087	1992-02-13	1992-02-13 00:00:00	1992-02-20	1992-02-20 00:00:00	32020		\N	319391	0	444814009	40481087		0
81395	4827	4278672	1963-08-27	1963-08-27 00:00:00	1963-10-26	1963-10-26 00:00:00	32020		\N	321144	0	65966004	4278672		0
81524	4835	375671	2007-07-15	2007-07-15 00:00:00	2007-09-13	2007-09-13 00:00:00	32020		\N	321635	0	62564004	375671		0
71174	4222	372328	1951-03-08	1951-03-08 00:00:00	1951-05-24	1951-05-24 00:00:00	32020		\N	280341	0	65363002	372328		0
81948	4859	4155034	2013-07-28	2013-07-28 00:00:00	2013-08-18	2013-08-18 00:00:00	32020		\N	323228	0	283371005	4155034		0
71526	4241	4112343	1979-08-27	1979-08-27 00:00:00	1979-09-06	1979-09-06 00:00:00	32020		\N	281700	0	195662009	4112343		0
82256	4878	40481087	1980-02-02	1980-02-02 00:00:00	1980-02-23	1980-02-23 00:00:00	32020		\N	324337	0	444814009	40481087		0
82376	4886	260139	1996-10-13	1996-10-13 00:00:00	1996-10-20	1996-10-20 00:00:00	32020		\N	324879	0	10509002	260139		0
82543	4898	260139	1966-09-20	1966-09-20 00:00:00	1966-10-04	1966-10-04 00:00:00	32020		\N	325678	0	10509002	260139		0
72179	4283	4310024	1988-01-30	1988-01-30 00:00:00	\N	\N	32020		\N	284269	0	424802006	4310024		0
72368	4295	28060	2018-01-04	2018-01-04 00:00:00	2018-01-15	2018-01-15 00:00:00	32020		\N	285075	0	43878008	28060		0
83256	4945	40481087	1965-04-06	1965-04-06 00:00:00	1965-04-20	1965-04-20 00:00:00	32020		\N	328709	0	444814009	40481087		0
83401	4957	40481087	1990-02-24	1990-02-24 00:00:00	1990-03-17	1990-03-17 00:00:00	32020		\N	329516	0	444814009	40481087		0
83759	4976	140673	1983-10-26	1983-10-26 00:00:00	\N	\N	32020		\N	330937	0	40930008	140673		0
83925	4986	40481087	2017-08-14	2017-08-14 00:00:00	2017-08-28	2017-08-28 00:00:00	32020		\N	331682	0	444814009	40481087		0
84149	4999	4294548	1990-06-20	1990-06-20 00:00:00	1990-08-15	1990-08-15 00:00:00	32020		\N	332480	0	75498004	4294548		0
73652	4376	4112343	1977-07-17	1977-07-17 00:00:00	1977-07-24	1977-07-24 00:00:00	32020		\N	290738	0	195662009	4112343		0
84428	5018	257012	2002-08-23	2002-08-23 00:00:00	\N	\N	32020		\N	333509	0	40055000	257012		0
84756	5041	4310024	2012-03-13	2012-03-13 00:00:00	\N	\N	32020		\N	334942	0	424802006	4310024		0
84971	5053	140673	2017-02-07	2017-02-07 00:00:00	\N	\N	32020		\N	336012	0	40930008	140673		0
85027	5056	260139	1967-04-25	1967-04-25 00:00:00	1967-05-02	1967-05-02 00:00:00	32020		\N	336129	0	10509002	260139		0
85171	5065	4112343	1984-11-26	1984-11-26 00:00:00	1984-12-08	1984-12-08 00:00:00	32020		\N	336720	0	195662009	4112343		0
74753	4439	40481087	1976-09-01	1976-09-01 00:00:00	1976-09-22	1976-09-22 00:00:00	32020		\N	295147	0	444814009	40481087		0
74913	4450	4059173	2015-04-16	2015-04-16 00:00:00	2015-05-16	2015-05-16 00:00:00	32020		\N	296086	0	16114001	4059173		0
64572	3817	260139	1968-08-18	1968-08-18 00:00:00	1968-08-25	1968-08-25 00:00:00	32020		\N	253487	0	10509002	260139		0
75304	4472	4283893	1956-08-28	1956-08-28 00:00:00	1956-11-13	1956-11-13 00:00:00	32020		\N	297533	0	36971009	4283893		0
64834	3833	4027663	1991-10-21	1991-10-21 00:00:00	\N	\N	32020		\N	254484	0	13200003	4027663		0
75568	4484	260139	1976-09-11	1976-09-11 00:00:00	1976-09-25	1976-09-25 00:00:00	32020		\N	298460	0	10509002	260139		0
65225	3857	81151	1960-03-29	1960-03-29 00:00:00	1960-04-26	1960-04-26 00:00:00	32020		\N	256035	0	44465007	81151		0
65390	3866	260139	2003-04-28	2003-04-28 00:00:00	2003-05-05	2003-05-05 00:00:00	32020		\N	256762	0	10509002	260139		0
76079	4513	40481087	2009-04-24	2009-04-24 00:00:00	2009-05-01	2009-05-01 00:00:00	32020		\N	300541	0	444814009	40481087		0
76315	4527	4027663	1993-06-02	1993-06-02 00:00:00	\N	\N	32020		\N	301473	0	13200003	4027663		0
76487	4534	80180	1985-04-09	1985-04-09 00:00:00	\N	\N	32020		\N	302016	0	396275006	80180		0
76583	4538	40481087	1997-03-18	1997-03-18 00:00:00	1997-04-08	1997-04-08 00:00:00	32020		\N	302309	0	444814009	40481087		0
76747	4548	40481087	2019-06-05	2019-06-05 00:00:00	\N	\N	32020		\N	303056	0	444814009	40481087		0
76916	4559	372328	1956-12-04	1956-12-04 00:00:00	1957-11-05	1957-11-05 00:00:00	32020		\N	303780	0	65363002	372328		0
66555	3938	40481087	1977-10-09	1977-10-09 00:00:00	1977-10-16	1977-10-16 00:00:00	32020		\N	261721	0	444814009	40481087		0
77332	4580	372328	1971-07-25	1971-07-25 00:00:00	1972-02-01	1972-02-01 00:00:00	32020		\N	305115	0	65363002	372328		0
77479	4590	4027663	1986-11-06	1986-11-06 00:00:00	\N	\N	32020		\N	305857	0	13200003	4027663		0
77600	4596	28060	1951-11-09	1951-11-09 00:00:00	1951-11-17	1951-11-17 00:00:00	32020		\N	306260	0	43878008	28060		0
77732	4604	28060	1971-02-27	1971-02-27 00:00:00	1971-03-11	1971-03-11 00:00:00	32020		\N	306761	0	43878008	28060		0
88560	5264	40481087	2005-06-22	2005-06-22 00:00:00	2005-06-29	2005-06-29 00:00:00	32020		\N	350228	0	444814009	40481087		0
78081	4626	372328	1979-06-30	1979-06-30 00:00:00	1979-10-08	1979-10-08 00:00:00	32020		\N	308227	0	65363002	372328		0
78209	4631	40481087	1981-03-12	1981-03-12 00:00:00	1981-04-02	1981-04-02 00:00:00	32020		\N	308608	0	444814009	40481087		0
78394	4642	4084167	1957-06-05	1957-06-05 00:00:00	1957-06-06	1957-06-06 00:00:00	32020		\N	309391	0	241929008	4084167		0
78593	4655	40481087	1984-04-21	1984-04-21 00:00:00	1984-04-28	1984-04-28 00:00:00	32020		\N	310392	0	444814009	40481087		0
78709	4661	4112343	1986-06-26	1986-06-26 00:00:00	1986-07-05	1986-07-05 00:00:00	32020		\N	310708	0	195662009	4112343		0
78988	4677	4112343	2017-05-16	2017-05-16 00:00:00	2017-05-24	2017-05-24 00:00:00	32020		\N	311670	0	195662009	4112343		0
79074	4680	372328	1910-06-11	1910-06-11 00:00:00	1910-06-25	1910-06-25 00:00:00	32020		\N	311883	0	65363002	372328		0
79282	4694	4059173	1998-02-11	1998-02-11 00:00:00	1998-03-13	1998-03-13 00:00:00	32020		\N	312719	0	16114001	4059173		0
79482	4707	4283893	1987-05-16	1987-05-16 00:00:00	1987-06-13	1987-06-13 00:00:00	32020		\N	313573	0	36971009	4283893		0
69026	4085	40481087	2018-12-09	2018-12-09 00:00:00	2018-12-23	2018-12-23 00:00:00	32020		\N	271456	0	444814009	40481087		0
79713	4722	4112343	1974-11-02	1974-11-02 00:00:00	1974-11-14	1974-11-14 00:00:00	32020		\N	314576	0	195662009	4112343		0
69498	4113	4113008	2005-11-08	2005-11-08 00:00:00	2005-11-29	2005-11-29 00:00:00	32020		\N	273389	0	284549007	4113008		0
69675	4122	40481087	1982-07-05	1982-07-05 00:00:00	1982-07-12	1982-07-12 00:00:00	32020		\N	274069	0	444814009	40481087		0
80443	4764	78272	1981-11-11	1981-11-11 00:00:00	1981-11-25	1981-11-25 00:00:00	32020		\N	317482	0	70704007	78272		0
80740	4788	4112343	1999-03-31	1999-03-31 00:00:00	1999-04-12	1999-04-12 00:00:00	32020		\N	318688	0	195662009	4112343		0
80952	4801	40481087	1982-04-15	1982-04-15 00:00:00	1982-05-06	1982-05-06 00:00:00	32020		\N	319365	0	444814009	40481087		0
81396	4827	4112343	2008-05-10	2008-05-10 00:00:00	2008-05-19	2008-05-19 00:00:00	32020		\N	321198	0	195662009	4112343		0
81526	4835	4112343	1996-12-04	1996-12-04 00:00:00	1996-12-16	1996-12-16 00:00:00	32020		\N	321631	0	195662009	4112343		0
71175	4222	40481087	1968-07-29	1968-07-29 00:00:00	1968-08-05	1968-08-05 00:00:00	32020		\N	280284	0	444814009	40481087		0
81949	4859	40481087	1967-10-19	1967-10-19 00:00:00	1967-11-09	1967-11-09 00:00:00	32020		\N	323267	0	444814009	40481087		0
71527	4241	260139	1977-01-01	1977-01-01 00:00:00	1977-01-15	1977-01-15 00:00:00	32020		\N	281752	0	10509002	260139		0
82257	4878	4283893	1990-06-26	1990-06-26 00:00:00	1990-10-02	1990-10-02 00:00:00	32020		\N	324341	0	36971009	4283893		0
82377	4886	40481087	1997-01-13	1997-01-13 00:00:00	1997-02-03	1997-02-03 00:00:00	32020		\N	324890	0	444814009	40481087		0
82544	4898	4112343	2017-05-09	2017-05-09 00:00:00	2017-05-16	2017-05-16 00:00:00	32020		\N	325698	0	195662009	4112343		0
72180	4283	81893	1988-09-26	1988-09-26 00:00:00	\N	\N	32020		\N	284269	0	64766004	81893		0
72369	4295	40481087	1997-08-17	1997-08-17 00:00:00	1997-08-31	1997-08-31 00:00:00	32020		\N	285072	0	444814009	40481087		0
83257	4945	4283893	1974-04-09	1974-04-09 00:00:00	1974-05-07	1974-05-07 00:00:00	32020		\N	328710	0	36971009	4283893		0
83402	4957	81151	2004-11-07	2004-11-07 00:00:00	2004-12-05	2004-12-05 00:00:00	32020		\N	329511	0	44465007	81151		0
83760	4976	372328	1937-10-02	1937-10-02 00:00:00	1938-01-25	1938-01-25 00:00:00	32020		\N	331060	0	65363002	372328		0
83926	4986	372328	1951-08-16	1951-08-16 00:00:00	1951-09-30	1951-09-30 00:00:00	32020		\N	331625	0	65363002	372328		0
84150	4999	257012	1990-08-01	1990-08-01 00:00:00	\N	\N	32020		\N	332481	0	40055000	257012		0
73653	4376	40481087	1934-08-25	1934-08-25 00:00:00	1934-09-15	1934-09-15 00:00:00	32020		\N	290827	0	444814009	40481087		0
84429	5018	260139	1963-05-07	1963-05-07 00:00:00	1963-05-21	1963-05-21 00:00:00	32020		\N	333462	0	10509002	260139		0
84757	5041	40481087	2012-03-02	2012-03-02 00:00:00	2012-03-23	2012-03-23 00:00:00	32020		\N	334942	0	444814009	40481087		0
84972	5053	260139	1979-08-27	1979-08-27 00:00:00	1979-09-10	1979-09-10 00:00:00	32020		\N	335990	0	10509002	260139		0
85028	5056	4218389	1955-08-08	1955-08-08 00:00:00	1955-09-05	1955-09-05 00:00:00	32020		\N	336163	0	39848009	4218389		0
85172	5066	195588	2000-03-30	2000-03-30 00:00:00	2000-05-15	2000-05-15 00:00:00	32020		\N	336799	0	38822007	195588		0
74754	4439	40481087	1969-01-19	1969-01-19 00:00:00	1969-02-02	1969-02-02 00:00:00	32020		\N	295102	0	444814009	40481087		0
74914	4450	4027663	2001-08-03	2001-08-03 00:00:00	\N	\N	32020		\N	\N	0	13200003	4027663		0
75035	4456	4116491	2008-05-13	2008-05-13 00:00:00	2008-07-02	2008-07-02 00:00:00	32020		\N	296577	0	301011002	4116491		0
75305	4472	40481087	2009-06-16	2009-06-16 00:00:00	2009-06-23	2009-06-23 00:00:00	32020		\N	297488	0	444814009	40481087		0
64835	3833	40481087	1991-04-15	1991-04-15 00:00:00	1991-05-06	1991-05-06 00:00:00	32020		\N	254484	0	444814009	40481087		0
75569	4484	4112343	2012-02-25	2012-02-25 00:00:00	2012-03-03	2012-03-03 00:00:00	32020		\N	298496	0	195662009	4112343		0
65226	3857	40481087	1964-10-08	1964-10-08 00:00:00	1964-10-22	1964-10-22 00:00:00	32020		\N	255981	0	444814009	40481087		0
65391	3866	4112343	1952-06-01	1952-06-01 00:00:00	1952-06-08	1952-06-08 00:00:00	32020		\N	256729	0	195662009	4112343		0
76080	4513	81151	1966-09-25	1966-09-25 00:00:00	1966-10-16	1966-10-16 00:00:00	32020		\N	300568	0	44465007	81151		0
76316	4527	40481087	1962-04-09	1962-04-09 00:00:00	1962-04-16	1962-04-16 00:00:00	32020		\N	301448	0	444814009	40481087		0
76488	4534	4112343	1980-10-14	1980-10-14 00:00:00	1980-10-27	1980-10-27 00:00:00	32020		\N	302043	0	195662009	4112343		0
76584	4538	4278672	2011-10-29	2011-10-29 00:00:00	2011-12-28	2011-12-28 00:00:00	32020		\N	302317	0	65966004	4278672		0
76748	4548	40481087	1987-01-08	1987-01-08 00:00:00	1987-01-15	1987-01-15 00:00:00	32020		\N	303095	0	444814009	40481087		0
76917	4559	28060	1956-11-18	1956-11-18 00:00:00	1956-11-28	1956-11-28 00:00:00	32020		\N	303709	0	43878008	28060		0
66556	3939	372328	1976-05-09	1976-05-09 00:00:00	1976-06-27	1976-06-27 00:00:00	32020		\N	261868	0	65363002	372328		0
77333	4580	260139	1971-01-21	1971-01-21 00:00:00	1971-02-04	1971-02-04 00:00:00	32020		\N	305111	0	10509002	260139		0
77480	4590	40481087	1989-04-12	1989-04-12 00:00:00	1989-04-26	1989-04-26 00:00:00	32020		\N	305887	0	444814009	40481087		0
77601	4596	4027663	1970-06-18	1970-06-18 00:00:00	\N	\N	32020		\N	306230	0	13200003	4027663		0
77751	4606	4112343	1996-08-22	1996-08-22 00:00:00	1996-09-03	1996-09-03 00:00:00	32020		\N	306840	0	195662009	4112343		0
88561	5264	40481087	1996-10-07	1996-10-07 00:00:00	1996-10-28	1996-10-28 00:00:00	32020		\N	350214	0	444814009	40481087		0
78082	4626	260139	1982-01-31	1982-01-31 00:00:00	1982-02-07	1982-02-07 00:00:00	32020		\N	308232	0	10509002	260139		0
78210	4631	81151	1921-12-24	1921-12-24 00:00:00	1922-01-21	1922-01-21 00:00:00	32020		\N	308551	0	44465007	81151		0
78395	4642	372328	1956-12-04	1956-12-04 00:00:00	1957-11-05	1957-11-05 00:00:00	32020		\N	309453	0	65363002	372328		0
78594	4655	4112343	1962-10-27	1962-10-27 00:00:00	1962-11-06	1962-11-06 00:00:00	32020		\N	310391	0	195662009	4112343		0
78710	4662	4109685	1953-04-21	1953-04-21 00:00:00	1953-05-05	1953-05-05 00:00:00	32020		\N	310770	0	284551006	4109685		0
78989	4677	40481087	2016-05-13	2016-05-13 00:00:00	2016-05-27	2016-05-27 00:00:00	32020		\N	311657	0	444814009	40481087		0
79075	4680	4237458	1979-10-24	1979-10-24 00:00:00	1980-01-22	1980-01-22 00:00:00	32020		\N	311948	0	58150001	4237458		0
79292	4696	40481087	2000-07-04	2000-07-04 00:00:00	2000-07-25	2000-07-25 00:00:00	32020		\N	312825	0	444814009	40481087		0
79483	4707	260139	1980-11-30	1980-11-30 00:00:00	1980-12-14	1980-12-14 00:00:00	32020		\N	313580	0	10509002	260139		0
69027	4085	4112343	2011-10-24	2011-10-24 00:00:00	2011-11-02	2011-11-02 00:00:00	32020		\N	271455	0	195662009	4112343		0
79714	4722	40481087	2001-10-04	2001-10-04 00:00:00	2001-10-11	2001-10-11 00:00:00	32020		\N	314490	0	444814009	40481087		0
69499	4113	260139	2007-01-01	2007-01-01 00:00:00	2007-01-15	2007-01-15 00:00:00	32020		\N	273397	0	10509002	260139		0
69676	4122	4112343	1988-04-26	1988-04-26 00:00:00	1988-05-04	1988-05-04 00:00:00	32020		\N	274032	0	195662009	4112343		0
80444	4764	4112343	1989-01-04	1989-01-04 00:00:00	1989-01-11	1989-01-11 00:00:00	32020		\N	317495	0	195662009	4112343		0
80741	4788	4112343	1989-04-11	1989-04-11 00:00:00	1989-04-21	1989-04-21 00:00:00	32020		\N	318650	0	195662009	4112343		0
80953	4801	4112343	1985-06-11	1985-06-11 00:00:00	1985-06-19	1985-06-19 00:00:00	32020		\N	319403	0	195662009	4112343		0
81397	4827	260139	2006-07-12	2006-07-12 00:00:00	2006-07-19	2006-07-19 00:00:00	32020		\N	321095	0	10509002	260139		0
81527	4835	372328	1987-06-30	1987-06-30 00:00:00	1987-07-14	1987-07-14 00:00:00	32020		\N	321657	0	65363002	372328		0
71176	4222	40481087	2019-06-13	2019-06-13 00:00:00	2019-06-27	2019-06-27 00:00:00	32020		\N	280327	0	444814009	40481087		0
81950	4859	198809	1971-06-05	1971-06-05 00:00:00	1971-06-05	1971-06-05 00:00:00	32020		\N	323226	0	65275009	198809		0
71528	4241	40481087	1966-08-23	1966-08-23 00:00:00	1966-08-30	1966-08-30 00:00:00	32020		\N	281699	0	444814009	40481087		0
82258	4878	4112343	2000-04-19	2000-04-19 00:00:00	2000-05-01	2000-05-01 00:00:00	32020		\N	324442	0	195662009	4112343		0
82378	4886	4112343	2004-11-02	2004-11-02 00:00:00	2004-11-15	2004-11-15 00:00:00	32020		\N	324891	0	195662009	4112343		0
82545	4898	4278672	1990-07-30	1990-07-30 00:00:00	1990-08-29	1990-08-29 00:00:00	32020		\N	325705	0	65966004	4278672		0
72181	4283	81151	1973-10-22	1973-10-22 00:00:00	1973-11-19	1973-11-19 00:00:00	32020		\N	284275	0	44465007	81151		0
72370	4295	4296204	1982-08-25	1982-08-25 00:00:00	1982-09-08	1982-09-08 00:00:00	32020		\N	285076	0	403190006	4296204		0
83297	4949	40481087	1997-06-15	1997-06-15 00:00:00	1997-06-29	1997-06-29 00:00:00	32020		\N	329000	0	444814009	40481087		0
83463	4960	378419	1984-12-08	1984-12-08 00:00:00	\N	\N	32020		\N	329663	0	26929004	378419		0
83403	4957	40481087	1993-02-06	1993-02-06 00:00:00	1993-02-20	1993-02-20 00:00:00	32020		\N	329533	0	444814009	40481087		0
83761	4976	4112343	1979-12-10	1979-12-10 00:00:00	1979-12-22	1979-12-22 00:00:00	32020		\N	330977	0	195662009	4112343		0
83927	4986	40481087	1969-12-19	1969-12-19 00:00:00	1970-01-09	1970-01-09 00:00:00	32020		\N	331622	0	444814009	40481087		0
84151	4999	80180	1991-06-28	1991-06-28 00:00:00	\N	\N	32020		\N	332454	0	396275006	80180		0
73654	4376	4112343	1973-01-29	1973-01-29 00:00:00	1973-02-06	1973-02-06 00:00:00	32020		\N	290764	0	195662009	4112343		0
84430	5018	40481087	1967-05-14	1967-05-14 00:00:00	1967-06-04	1967-06-04 00:00:00	32020		\N	333508	0	444814009	40481087		0
84758	5041	81151	1994-08-20	1994-08-20 00:00:00	1994-09-24	1994-09-24 00:00:00	32020		\N	334920	0	44465007	81151		0
84973	5053	4112343	1948-02-11	1948-02-11 00:00:00	1948-02-21	1948-02-21 00:00:00	32020		\N	336049	0	195662009	4112343		0
85029	5056	40481087	1949-12-06	1949-12-06 00:00:00	1949-12-20	1949-12-20 00:00:00	32020		\N	336196	0	444814009	40481087		0
85173	5066	4112343	2014-09-10	2014-09-10 00:00:00	2014-09-23	2014-09-23 00:00:00	32020		\N	336774	0	195662009	4112343		0
74755	4439	4027663	1984-11-30	1984-11-30 00:00:00	\N	\N	32020		\N	295143	0	13200003	4027663		0
74915	4450	260139	1968-07-09	1968-07-09 00:00:00	1968-07-16	1968-07-16 00:00:00	32020		\N	296089	0	10509002	260139		0
75036	4456	260139	1969-05-13	1969-05-13 00:00:00	1969-05-20	1969-05-20 00:00:00	32020		\N	296578	0	10509002	260139		0
75306	4472	372328	1936-07-06	1936-07-06 00:00:00	1936-09-19	1936-09-19 00:00:00	32020		\N	297534	0	65363002	372328		0
64836	3833	260139	1999-02-14	1999-02-14 00:00:00	1999-02-28	1999-02-28 00:00:00	32020		\N	254485	0	10509002	260139		0
75570	4484	260139	1986-03-23	1986-03-23 00:00:00	1986-04-06	1986-04-06 00:00:00	32020		\N	298461	0	10509002	260139		0
75697	4490	260139	1956-04-15	1956-04-15 00:00:00	1956-04-29	1956-04-29 00:00:00	32020		\N	298916	0	10509002	260139		0
65392	3866	40481087	1990-04-28	1990-04-28 00:00:00	1990-05-05	1990-05-05 00:00:00	32020		\N	256724	0	444814009	40481087		0
76081	4513	260139	1986-12-14	1986-12-14 00:00:00	1986-12-28	1986-12-28 00:00:00	32020		\N	300583	0	10509002	260139		0
76317	4527	4283893	1979-09-18	1979-09-18 00:00:00	1979-11-06	1979-11-06 00:00:00	32020		\N	301457	0	36971009	4283893		0
76489	4534	40481087	1994-04-02	1994-04-02 00:00:00	1994-04-16	1994-04-16 00:00:00	32020		\N	302044	0	444814009	40481087		0
76585	4538	40481087	2001-02-06	2001-02-06 00:00:00	2001-02-20	2001-02-20 00:00:00	32020		\N	302336	0	444814009	40481087		0
76749	4548	80180	2017-09-29	2017-09-29 00:00:00	\N	\N	32020		\N	303055	0	396275006	80180		0
76918	4559	81151	1985-03-06	1985-03-06 00:00:00	1985-03-27	1985-03-27 00:00:00	32020		\N	303806	0	44465007	81151		0
66557	3939	40481087	1982-07-21	1982-07-21 00:00:00	1982-08-11	1982-08-11 00:00:00	32020		\N	261812	0	444814009	40481087		0
77334	4580	260139	2002-01-23	2002-01-23 00:00:00	2002-02-06	2002-02-06 00:00:00	32020		\N	305124	0	10509002	260139		0
77481	4590	4283893	2007-07-14	2007-07-14 00:00:00	2007-08-04	2007-08-04 00:00:00	32020		\N	305859	0	36971009	4283893		0
77602	4596	260139	1947-08-09	1947-08-09 00:00:00	1947-08-16	1947-08-16 00:00:00	32020		\N	306252	0	10509002	260139		0
77752	4606	40481087	1985-11-21	1985-11-21 00:00:00	1985-12-05	1985-12-05 00:00:00	32020		\N	306830	0	444814009	40481087		0
88562	5264	78272	1978-11-02	1978-11-02 00:00:00	1978-11-30	1978-11-30 00:00:00	32020		\N	350205	0	70704007	78272		0
78083	4626	260139	1994-12-08	1994-12-08 00:00:00	1994-12-22	1994-12-22 00:00:00	32020		\N	308213	0	10509002	260139		0
78211	4631	4112343	1933-10-10	1933-10-10 00:00:00	1933-10-22	1933-10-22 00:00:00	32020		\N	308581	0	195662009	4112343		0
78396	4642	372328	1958-10-01	1958-10-01 00:00:00	1958-11-11	1958-11-11 00:00:00	32020		\N	309408	0	65363002	372328		0
78595	4655	4112343	2015-02-17	2015-02-17 00:00:00	2015-02-28	2015-02-28 00:00:00	32020		\N	310337	0	195662009	4112343		0
78711	4662	81151	1966-12-23	1966-12-23 00:00:00	1967-01-13	1967-01-13 00:00:00	32020		\N	310772	0	44465007	81151		0
78990	4677	4112343	1964-01-14	1964-01-14 00:00:00	1964-01-26	1964-01-26 00:00:00	32020		\N	311642	0	195662009	4112343		0
79076	4680	4112343	1989-02-18	1989-02-18 00:00:00	1989-03-03	1989-03-03 00:00:00	32020		\N	311889	0	195662009	4112343		0
79293	4696	40481087	1960-11-14	1960-11-14 00:00:00	1960-11-28	1960-11-28 00:00:00	32020		\N	312895	0	444814009	40481087		0
79484	4707	80180	2012-08-12	2012-08-12 00:00:00	\N	\N	32020		\N	313569	0	396275006	80180		0
69028	4085	40481087	1994-01-07	1994-01-07 00:00:00	1994-01-14	1994-01-14 00:00:00	32020		\N	271521	0	444814009	40481087		0
79715	4722	40481087	2011-07-11	2011-07-11 00:00:00	2011-08-01	2011-08-01 00:00:00	32020		\N	314491	0	444814009	40481087		0
69500	4113	4283893	1969-12-12	1969-12-12 00:00:00	1970-01-16	1970-01-16 00:00:00	32020		\N	273426	0	36971009	4283893		0
69677	4122	260139	2010-09-17	2010-09-17 00:00:00	2010-10-01	2010-10-01 00:00:00	32020		\N	274071	0	10509002	260139		0
80445	4764	4112343	1997-01-15	1997-01-15 00:00:00	1997-01-23	1997-01-23 00:00:00	32020		\N	317496	0	195662009	4112343		0
80742	4788	80180	2014-01-02	2014-01-02 00:00:00	\N	\N	32020		\N	318685	0	396275006	80180		0
80954	4801	372328	1975-09-15	1975-09-15 00:00:00	1976-07-03	1976-07-03 00:00:00	32020		\N	319381	0	65363002	372328		0
81398	4827	4059173	1990-01-21	1990-01-21 00:00:00	1990-02-20	1990-02-20 00:00:00	32020		\N	321147	0	16114001	4059173		0
81528	4835	40481087	2001-02-14	2001-02-14 00:00:00	2001-03-07	2001-03-07 00:00:00	32020		\N	321663	0	444814009	40481087		0
71177	4222	40481087	1998-05-19	1998-05-19 00:00:00	1998-05-26	1998-05-26 00:00:00	32020		\N	280307	0	444814009	40481087		0
81951	4859	196456	1971-06-05	1971-06-05 00:00:00	1971-06-05	1971-06-05 00:00:00	32020		\N	323226	0	235919008	196456		0
71529	4241	4112343	1991-12-16	1991-12-16 00:00:00	1991-12-28	1991-12-28 00:00:00	32020		\N	281702	0	195662009	4112343		0
82260	4878	80180	1999-06-15	1999-06-15 00:00:00	\N	\N	32020		\N	324374	0	396275006	80180		0
82379	4886	4112343	2009-08-25	2009-08-25 00:00:00	2009-09-07	2009-09-07 00:00:00	32020		\N	324904	0	195662009	4112343		0
82546	4898	40481087	1995-12-17	1995-12-17 00:00:00	1995-12-24	1995-12-24 00:00:00	32020		\N	325695	0	444814009	40481087		0
72182	4283	40481087	1970-10-05	1970-10-05 00:00:00	1970-10-26	1970-10-26 00:00:00	32020		\N	284308	0	444814009	40481087		0
72371	4295	40481087	1982-06-30	1982-06-30 00:00:00	1982-07-21	1982-07-21 00:00:00	32020		\N	285051	0	444814009	40481087		0
83298	4949	81151	1994-10-26	1994-10-26 00:00:00	1994-11-16	1994-11-16 00:00:00	32020		\N	329048	0	44465007	81151		0
83404	4957	4112343	1983-07-16	1983-07-16 00:00:00	1983-07-28	1983-07-28 00:00:00	32020		\N	329553	0	195662009	4112343		0
83762	4976	260139	1920-11-10	1920-11-10 00:00:00	1920-11-17	1920-11-17 00:00:00	32020		\N	330986	0	10509002	260139		0
83928	4986	195588	2000-04-10	2000-04-10 00:00:00	2000-05-29	2000-05-29 00:00:00	32020		\N	331694	0	38822007	195588		0
84152	4999	40481087	2004-10-26	2004-10-26 00:00:00	2004-11-16	2004-11-16 00:00:00	32020		\N	332490	0	444814009	40481087		0
73655	4376	40481087	1998-08-23	1998-08-23 00:00:00	1998-09-13	1998-09-13 00:00:00	32020		\N	290739	0	444814009	40481087		0
84431	5018	260139	1942-05-06	1942-05-06 00:00:00	1942-05-13	1942-05-13 00:00:00	32020		\N	333531	0	10509002	260139		0
84759	5041	40481087	1978-02-06	1978-02-06 00:00:00	1978-02-27	1978-02-27 00:00:00	32020		\N	334938	0	444814009	40481087		0
84974	5053	40481087	1956-01-05	1956-01-05 00:00:00	1956-01-19	1956-01-19 00:00:00	32020		\N	336050	0	444814009	40481087		0
85030	5056	372328	1942-11-12	1942-11-12 00:00:00	1942-12-03	1942-12-03 00:00:00	32020		\N	336220	0	65363002	372328		0
85174	5066	40481087	1994-06-12	1994-06-12 00:00:00	1994-06-19	1994-06-19 00:00:00	32020		\N	336787	0	444814009	40481087		0
74756	4439	40481087	2012-06-07	2012-06-07 00:00:00	2012-06-14	2012-06-14 00:00:00	32020		\N	295149	0	444814009	40481087		0
74916	4450	192671	2009-03-03	2009-03-03 00:00:00	\N	\N	32020		\N	296056	0	K92.2	35208414		0
75037	4456	260139	1971-06-11	1971-06-11 00:00:00	1971-06-18	1971-06-18 00:00:00	32020		\N	296565	0	10509002	260139		0
75307	4472	372328	1940-02-07	1940-02-07 00:00:00	1940-03-23	1940-03-23 00:00:00	32020		\N	297535	0	65363002	372328		0
64837	3833	260139	1985-09-23	1985-09-23 00:00:00	1985-09-30	1985-09-30 00:00:00	32020		\N	254538	0	10509002	260139		0
75571	4484	4112343	1977-04-20	1977-04-20 00:00:00	1977-04-27	1977-04-27 00:00:00	32020		\N	298474	0	195662009	4112343		0
75698	4490	81151	1929-12-15	1929-12-15 00:00:00	1929-12-29	1929-12-29 00:00:00	32020		\N	298881	0	44465007	81151		0
65393	3866	40481087	1953-07-02	1953-07-02 00:00:00	1953-07-23	1953-07-23 00:00:00	32020		\N	256721	0	444814009	40481087		0
76082	4513	80180	1995-12-27	1995-12-27 00:00:00	\N	\N	32020		\N	300546	0	396275006	80180		0
76318	4527	40481087	2017-02-01	2017-02-01 00:00:00	2017-02-22	2017-02-22 00:00:00	32020		\N	301452	0	444814009	40481087		0
76490	4534	40481087	1960-09-02	1960-09-02 00:00:00	1960-09-16	1960-09-16 00:00:00	32020		\N	302057	0	444814009	40481087		0
76586	4538	4112343	2002-09-06	2002-09-06 00:00:00	2002-09-15	2002-09-15 00:00:00	32020		\N	302391	0	195662009	4112343		0
76750	4548	378001	1989-06-07	1989-06-07 00:00:00	1989-07-07	1989-07-07 00:00:00	32020		\N	303032	0	62106007	378001		0
76919	4559	4112343	1995-09-20	1995-09-20 00:00:00	1995-09-27	1995-09-27 00:00:00	32020		\N	303755	0	195662009	4112343		0
66558	3939	40481087	2017-03-28	2017-03-28 00:00:00	2017-04-04	2017-04-04 00:00:00	32020		\N	261867	0	444814009	40481087		0
77335	4580	80180	2004-06-09	2004-06-09 00:00:00	\N	\N	32020		\N	305124	0	396275006	80180		0
77482	4590	40481087	1962-01-07	1962-01-07 00:00:00	1962-01-28	1962-01-28 00:00:00	32020		\N	305847	0	444814009	40481087		0
77603	4596	4155034	1983-12-07	1983-12-07 00:00:00	1983-12-28	1983-12-28 00:00:00	32020		\N	306270	0	283371005	4155034		0
77753	4606	40481087	1994-12-16	1994-12-16 00:00:00	1994-12-30	1994-12-30 00:00:00	32020		\N	306858	0	444814009	40481087		0
88563	5264	4283893	2012-11-27	2012-11-27 00:00:00	2012-12-18	2012-12-18 00:00:00	32020		\N	350229	0	36971009	4283893		0
78084	4626	260139	2007-01-05	2007-01-05 00:00:00	2007-01-12	2007-01-12 00:00:00	32020		\N	308188	0	10509002	260139		0
78212	4631	4283893	1968-06-01	1968-06-01 00:00:00	1968-09-07	1968-09-07 00:00:00	32020		\N	308532	0	36971009	4283893		0
78397	4642	260139	1984-09-09	1984-09-09 00:00:00	1984-09-23	1984-09-23 00:00:00	32020		\N	309471	0	10509002	260139		0
78596	4655	80180	1990-08-28	1990-08-28 00:00:00	\N	\N	32020		\N	310398	0	396275006	80180		0
78712	4662	80180	1994-06-10	1994-06-10 00:00:00	\N	\N	32020		\N	310793	0	396275006	80180		0
78991	4677	378001	2008-02-16	2008-02-16 00:00:00	2008-03-17	2008-03-17 00:00:00	32020		\N	311725	0	62106007	378001		0
79077	4680	40481087	1978-12-17	1978-12-17 00:00:00	1979-01-07	1979-01-07 00:00:00	32020		\N	311934	0	444814009	40481087		0
79294	4696	40481087	1995-06-12	1995-06-12 00:00:00	1995-06-26	1995-06-26 00:00:00	32020		\N	312854	0	444814009	40481087		0
79485	4707	260139	1999-07-28	1999-07-28 00:00:00	1999-08-04	1999-08-04 00:00:00	32020		\N	313592	0	10509002	260139		0
69029	4085	40481087	1986-10-23	1986-10-23 00:00:00	1986-11-06	1986-11-06 00:00:00	32020		\N	271520	0	444814009	40481087		0
79716	4722	4278672	1918-04-19	1918-04-19 00:00:00	1918-05-19	1918-05-19 00:00:00	32020		\N	314609	0	65966004	4278672		0
69501	4113	40481087	1959-09-08	1959-09-08 00:00:00	1959-09-15	1959-09-15 00:00:00	32020		\N	273419	0	444814009	40481087		0
69678	4122	40481087	1976-12-11	1976-12-11 00:00:00	1976-12-25	1976-12-25 00:00:00	32020		\N	274072	0	444814009	40481087		0
80446	4764	40481087	1974-10-08	1974-10-08 00:00:00	1974-10-15	1974-10-15 00:00:00	32020		\N	317491	0	444814009	40481087		0
80743	4788	372328	1976-07-20	1976-07-20 00:00:00	1976-10-31	1976-10-31 00:00:00	32020		\N	318678	0	65363002	372328		0
80955	4801	4112343	2011-10-04	2011-10-04 00:00:00	2011-10-16	2011-10-16 00:00:00	32020		\N	319405	0	195662009	4112343		0
81399	4827	4112343	1993-08-15	1993-08-15 00:00:00	1993-08-24	1993-08-24 00:00:00	32020		\N	321093	0	195662009	4112343		0
81540	4837	372328	1949-09-17	1949-09-17 00:00:00	1949-11-29	1949-11-29 00:00:00	32020		\N	321867	0	65363002	372328		0
71178	4222	40481087	1981-05-25	1981-05-25 00:00:00	1981-06-08	1981-06-08 00:00:00	32020		\N	280306	0	444814009	40481087		0
81952	4859	40481087	1999-09-23	1999-09-23 00:00:00	1999-10-07	1999-10-07 00:00:00	32020		\N	323253	0	444814009	40481087		0
71530	4241	4156265	1985-02-28	1985-02-28 00:00:00	1985-03-21	1985-03-21 00:00:00	32020		\N	281698	0	370247008	4156265		0
82261	4878	81893	1997-11-22	1997-11-22 00:00:00	\N	\N	32020		\N	324374	0	64766004	81893		0
82380	4886	28060	1972-01-16	1972-01-16 00:00:00	1972-01-28	1972-01-28 00:00:00	32020		\N	324936	0	43878008	28060		0
82547	4898	40481087	2005-12-09	2005-12-09 00:00:00	2005-12-23	2005-12-23 00:00:00	32020		\N	325742	0	444814009	40481087		0
72183	4283	192671	1991-03-03	1991-03-03 00:00:00	\N	\N	32020		\N	284276	0	K92.2	35208414		0
72372	4295	4027663	1998-09-15	1998-09-15 00:00:00	\N	\N	32020		\N	285077	0	13200003	4027663		0
83299	4949	40481087	1977-07-04	1977-07-04 00:00:00	1977-07-18	1977-07-18 00:00:00	32020		\N	329002	0	444814009	40481087		0
83405	4957	4134304	1986-08-14	1986-08-14 00:00:00	1986-11-12	1986-11-12 00:00:00	32020		\N	329510	0	263102004	4134304		0
83763	4976	195588	1941-11-05	1941-11-05 00:00:00	1941-12-26	1941-12-26 00:00:00	32020		\N	330967	0	38822007	195588		0
83929	4986	4112343	1958-01-14	1958-01-14 00:00:00	1958-01-23	1958-01-23 00:00:00	32020		\N	331676	0	195662009	4112343		0
84153	4999	4283893	1993-08-31	1993-08-31 00:00:00	1993-09-21	1993-09-21 00:00:00	32020		\N	332446	0	36971009	4283893		0
73656	4376	375671	1971-02-09	1971-02-09 00:00:00	1971-03-11	1971-03-11 00:00:00	32020		\N	290731	0	62564004	375671		0
84432	5018	4112343	1957-12-13	1957-12-13 00:00:00	1957-12-25	1957-12-25 00:00:00	32020		\N	333532	0	195662009	4112343		0
84760	5041	4112343	1972-01-20	1972-01-20 00:00:00	1972-01-28	1972-01-28 00:00:00	32020		\N	334948	0	195662009	4112343		0
84975	5053	4155034	1992-07-18	1992-07-18 00:00:00	1992-08-01	1992-08-01 00:00:00	32020		\N	336020	0	283371005	4155034		0
85031	5056	40481087	1952-09-02	1952-09-02 00:00:00	1952-09-23	1952-09-23 00:00:00	32020		\N	336185	0	444814009	40481087		0
85175	5066	4156265	1997-08-17	1997-08-17 00:00:00	1997-08-31	1997-08-31 00:00:00	32020		\N	336813	0	370247008	4156265		0
74776	4442	257012	1985-07-22	1985-07-22 00:00:00	\N	\N	32020		\N	295310	0	40055000	257012		0
74917	4450	4112343	1975-06-03	1975-06-03 00:00:00	1975-06-11	1975-06-11 00:00:00	32020		\N	296037	0	195662009	4112343		0
75038	4456	4112343	1982-09-19	1982-09-19 00:00:00	1982-09-30	1982-09-30 00:00:00	32020		\N	296574	0	195662009	4112343		0
75308	4472	40481087	2013-08-10	2013-08-10 00:00:00	2013-08-31	2013-08-31 00:00:00	32020		\N	297499	0	444814009	40481087		0
64838	3833	372328	1967-03-21	1967-03-21 00:00:00	1967-04-04	1967-04-04 00:00:00	32020		\N	254529	0	65363002	372328		0
75572	4484	313217	2017-06-08	2017-06-08 00:00:00	\N	\N	32020		\N	298520	0	49436004	313217		0
75699	4490	260139	1980-10-03	1980-10-03 00:00:00	1980-10-10	1980-10-10 00:00:00	32020		\N	298890	0	10509002	260139		0
65394	3866	40481087	1989-08-11	1989-08-11 00:00:00	1989-08-25	1989-08-25 00:00:00	32020		\N	256733	0	444814009	40481087		0
76083	4513	4112343	1994-05-14	1994-05-14 00:00:00	1994-05-22	1994-05-22 00:00:00	32020		\N	300546	0	195662009	4112343		0
76319	4527	372328	1964-02-20	1964-02-20 00:00:00	1964-03-05	1964-03-05 00:00:00	32020		\N	301418	0	65363002	372328		0
76491	4534	40481087	1960-11-24	1960-11-24 00:00:00	1960-12-08	1960-12-08 00:00:00	32020		\N	302084	0	444814009	40481087		0
76587	4538	192671	1987-06-01	1987-06-01 00:00:00	\N	\N	32020		\N	302313	0	K92.2	35208414		0
76751	4548	40481087	2009-02-04	2009-02-04 00:00:00	2009-02-25	2009-02-25 00:00:00	32020		\N	303052	0	444814009	40481087		0
76920	4559	40481087	1962-01-14	1962-01-14 00:00:00	1962-01-28	1962-01-28 00:00:00	32020		\N	303790	0	444814009	40481087		0
66559	3939	4310024	2010-02-10	2010-02-10 00:00:00	\N	\N	32020		\N	261814	0	424802006	4310024		0
77336	4580	260139	1967-05-26	1967-05-26 00:00:00	1967-06-09	1967-06-09 00:00:00	32020		\N	305119	0	10509002	260139		0
77483	4590	260139	1968-08-09	1968-08-09 00:00:00	1968-08-16	1968-08-16 00:00:00	32020		\N	305884	0	10509002	260139		0
77604	4596	40481087	2016-01-26	2016-01-26 00:00:00	2016-02-09	2016-02-09 00:00:00	32020		\N	306304	0	444814009	40481087		0
76799	4551	257012	2003-09-16	2003-09-16 00:00:00	\N	\N	32020		\N	303305	0	40055000	257012		0
77754	4606	40481087	1990-01-20	1990-01-20 00:00:00	1990-02-03	1990-02-03 00:00:00	32020		\N	306832	0	444814009	40481087		0
88564	5264	4237458	1977-09-08	1977-09-08 00:00:00	1977-12-07	1977-12-07 00:00:00	32020		\N	350204	0	58150001	4237458		0
78085	4626	4112343	2006-07-09	2006-07-09 00:00:00	2006-07-20	2006-07-20 00:00:00	32020		\N	308187	0	195662009	4112343		0
78213	4631	40481087	1948-05-16	1948-05-16 00:00:00	1948-06-06	1948-06-06 00:00:00	32020		\N	308574	0	444814009	40481087		0
78398	4642	40481087	2016-07-18	2016-07-18 00:00:00	2016-08-01	2016-08-01 00:00:00	32020		\N	309491	0	444814009	40481087		0
78597	4655	4112343	1998-04-23	1998-04-23 00:00:00	1998-04-30	1998-04-30 00:00:00	32020		\N	310336	0	195662009	4112343		0
78713	4662	28060	1953-08-23	1953-08-23 00:00:00	1953-09-05	1953-09-05 00:00:00	32020		\N	310728	0	43878008	28060		0
78992	4677	372328	2017-03-03	2017-03-03 00:00:00	2017-03-24	2017-03-24 00:00:00	32020		\N	311698	0	65363002	372328		0
79078	4680	4155034	1967-07-31	1967-07-31 00:00:00	1967-08-14	1967-08-14 00:00:00	32020		\N	311946	0	283371005	4155034		0
79295	4696	81151	1955-01-22	1955-01-22 00:00:00	1955-02-05	1955-02-05 00:00:00	32020		\N	312834	0	44465007	81151		0
79486	4707	260139	1986-04-12	1986-04-12 00:00:00	1986-04-26	1986-04-26 00:00:00	32020		\N	313572	0	10509002	260139		0
69030	4085	440086	1966-10-02	1966-10-02 00:00:00	1969-04-13	1969-04-13 00:00:00	32020		\N	271464	0	192127007	440086		0
79717	4722	260139	1967-02-05	1967-02-05 00:00:00	1967-02-12	1967-02-12 00:00:00	32020		\N	314575	0	10509002	260139		0
69502	4113	40481087	1976-09-11	1976-09-11 00:00:00	1976-10-02	1976-10-02 00:00:00	32020		\N	273420	0	444814009	40481087		0
69679	4123	80180	1999-01-07	1999-01-07 00:00:00	\N	\N	32020		\N	274117	0	396275006	80180		0
80447	4764	4294548	2005-06-11	2005-06-11 00:00:00	2005-07-23	2005-07-23 00:00:00	32020		\N	317510	0	75498004	4294548		0
80744	4788	372328	1977-08-27	1977-08-27 00:00:00	1977-10-30	1977-10-30 00:00:00	32020		\N	318659	0	65363002	372328		0
80956	4801	4237458	1983-03-23	1983-03-23 00:00:00	1983-06-21	1983-06-21 00:00:00	32020		\N	319421	0	58150001	4237458		0
81400	4827	372328	1954-04-16	1954-04-16 00:00:00	1954-11-18	1954-11-18 00:00:00	32020		\N	321098	0	65363002	372328		0
81541	4837	80180	1981-11-03	1981-11-03 00:00:00	\N	\N	32020		\N	321863	0	396275006	80180		0
71179	4222	372328	1951-09-21	1951-09-21 00:00:00	1951-11-22	1951-11-22 00:00:00	32020		\N	280288	0	65363002	372328		0
81953	4859	372328	1955-10-17	1955-10-17 00:00:00	1956-04-01	1956-04-01 00:00:00	32020		\N	323238	0	65363002	372328		0
71531	4241	28060	1973-11-13	1973-11-13 00:00:00	1973-11-24	1973-11-24 00:00:00	32020		\N	281692	0	43878008	28060		0
82262	4878	4310024	1997-05-26	1997-05-26 00:00:00	\N	\N	32020		\N	324374	0	424802006	4310024		0
82381	4886	78272	1978-09-28	1978-09-28 00:00:00	1978-10-26	1978-10-26 00:00:00	32020		\N	324932	0	70704007	78272		0
82548	4898	40481087	1976-10-05	1976-10-05 00:00:00	1976-10-19	1976-10-19 00:00:00	32020		\N	325665	0	444814009	40481087		0
72184	4283	4027663	1982-04-06	1982-04-06 00:00:00	\N	\N	32020		\N	284267	0	13200003	4027663		0
72373	4295	4113008	1997-12-18	1997-12-18 00:00:00	1998-01-08	1998-01-08 00:00:00	32020		\N	285077	0	284549007	4113008		0
83300	4949	4112343	1980-02-12	1980-02-12 00:00:00	1980-02-25	1980-02-25 00:00:00	32020		\N	328998	0	195662009	4112343		0
83406	4957	80180	2004-05-16	2004-05-16 00:00:00	\N	\N	32020		\N	329555	0	396275006	80180		0
83764	4976	28060	1970-08-16	1970-08-16 00:00:00	1970-08-28	1970-08-28 00:00:00	32020		\N	330976	0	43878008	28060		0
83930	4986	4112343	1976-09-30	1976-09-30 00:00:00	1976-10-12	1976-10-12 00:00:00	32020		\N	331623	0	195662009	4112343		0
84154	4999	40481087	2000-09-03	2000-09-03 00:00:00	2000-09-24	2000-09-24 00:00:00	32020		\N	332462	0	444814009	40481087		0
73657	4376	4230399	2010-09-19	2010-09-19 00:00:00	2010-10-19	2010-10-19 00:00:00	32020		\N	290735	0	359817006	4230399		0
84433	5018	4294548	2002-07-05	2002-07-05 00:00:00	2002-11-01	2002-11-01 00:00:00	32020		\N	333489	0	75498004	4294548		0
84761	5041	260139	2007-02-14	2007-02-14 00:00:00	2007-02-28	2007-02-28 00:00:00	32020		\N	334963	0	10509002	260139		0
84976	5053	40481087	1963-06-17	1963-06-17 00:00:00	1963-07-01	1963-07-01 00:00:00	32020		\N	335987	0	444814009	40481087		0
85032	5056	4112343	1981-04-27	1981-04-27 00:00:00	1981-05-10	1981-05-10 00:00:00	32020		\N	336229	0	195662009	4112343		0
85176	5066	260139	2011-06-18	2011-06-18 00:00:00	2011-07-02	2011-07-02 00:00:00	32020		\N	336763	0	10509002	260139		0
74777	4442	40481087	2016-07-18	2016-07-18 00:00:00	2016-08-01	2016-08-01 00:00:00	32020		\N	295311	0	444814009	40481087		0
74918	4450	40481087	1982-05-02	1982-05-02 00:00:00	1982-05-23	1982-05-23 00:00:00	32020		\N	296068	0	444814009	40481087		0
75039	4456	40481087	1986-07-04	1986-07-04 00:00:00	1986-07-25	1986-07-25 00:00:00	32020		\N	296552	0	444814009	40481087		0
75309	4472	40481087	1969-03-16	1969-03-16 00:00:00	1969-03-23	1969-03-23 00:00:00	32020		\N	297524	0	444814009	40481087		0
64839	3833	372328	1970-10-15	1970-10-15 00:00:00	1971-08-04	1971-08-04 00:00:00	32020		\N	254541	0	65363002	372328		0
75573	4484	40481087	1952-04-19	1952-04-19 00:00:00	1952-04-26	1952-04-26 00:00:00	32020		\N	298470	0	444814009	40481087		0
75700	4490	40481087	1981-12-29	1981-12-29 00:00:00	1982-01-19	1982-01-19 00:00:00	32020		\N	298932	0	444814009	40481087		0
65395	3866	40481087	1952-05-28	1952-05-28 00:00:00	1952-06-04	1952-06-04 00:00:00	32020		\N	256683	0	444814009	40481087		0
76084	4513	4230399	1976-03-27	1976-03-27 00:00:00	1976-04-26	1976-04-26 00:00:00	32020		\N	300569	0	359817006	4230399		0
76320	4527	260139	1963-08-26	1963-08-26 00:00:00	1963-09-02	1963-09-02 00:00:00	32020		\N	301420	0	10509002	260139		0
76492	4534	4112343	1951-04-28	1951-04-28 00:00:00	1951-05-08	1951-05-08 00:00:00	32020		\N	302054	0	195662009	4112343		0
76630	4543	260139	1984-04-16	1984-04-16 00:00:00	1984-04-30	1984-04-30 00:00:00	32020		\N	302603	0	10509002	260139		0
76752	4548	81151	1984-10-12	1984-10-12 00:00:00	1984-11-16	1984-11-16 00:00:00	32020		\N	303029	0	44465007	81151		0
76921	4559	40481087	1985-12-20	1985-12-20 00:00:00	1986-01-10	1986-01-10 00:00:00	32020		\N	303753	0	444814009	40481087		0
66560	3939	260139	2013-03-29	2013-03-29 00:00:00	2013-04-12	2013-04-12 00:00:00	32020		\N	261843	0	10509002	260139		0
77337	4580	260139	1972-11-29	1972-11-29 00:00:00	1972-12-13	1972-12-13 00:00:00	32020		\N	305112	0	10509002	260139		0
77484	4590	378001	2008-10-27	2008-10-27 00:00:00	2008-12-26	2008-12-26 00:00:00	32020		\N	305864	0	62106007	378001		0
77605	4596	40481087	1951-07-27	1951-07-27 00:00:00	1951-08-10	1951-08-10 00:00:00	32020		\N	306286	0	444814009	40481087		0
77755	4606	4134304	2013-06-03	2013-06-03 00:00:00	2013-07-03	2013-07-03 00:00:00	32020		\N	306867	0	263102004	4134304		0
88565	5264	4112343	2018-01-12	2018-01-12 00:00:00	2018-01-21	2018-01-21 00:00:00	32020		\N	350208	0	195662009	4112343		0
78086	4626	40481087	1987-01-06	1987-01-06 00:00:00	1987-01-27	1987-01-27 00:00:00	32020		\N	308246	0	444814009	40481087		0
78214	4631	4112343	2008-08-03	2008-08-03 00:00:00	2008-08-11	2008-08-11 00:00:00	32020		\N	308590	0	195662009	4112343		0
78399	4642	4112343	1960-10-16	1960-10-16 00:00:00	1960-10-25	1960-10-25 00:00:00	32020		\N	309413	0	195662009	4112343		0
78598	4655	40481087	1968-07-30	1968-07-30 00:00:00	1968-08-06	1968-08-06 00:00:00	32020		\N	310308	0	444814009	40481087		0
78714	4662	4112343	1976-02-11	1976-02-11 00:00:00	1976-02-24	1976-02-24 00:00:00	32020		\N	310788	0	195662009	4112343		0
78993	4677	4156265	1973-07-20	1973-07-20 00:00:00	1973-08-03	1973-08-03 00:00:00	32020		\N	311666	0	370247008	4156265		0
79079	4680	381316	2000-01-01	2000-01-01 00:00:00	\N	\N	32020		\N	311966	0	230690007	381316		0
79296	4696	40481087	1999-12-11	1999-12-11 00:00:00	2000-01-01	2000-01-01 00:00:00	32020		\N	312824	0	444814009	40481087		0
79487	4707	4112343	1975-01-01	1975-01-01 00:00:00	1975-01-11	1975-01-11 00:00:00	32020		\N	313571	0	195662009	4112343		0
69031	4085	4112343	1999-08-07	1999-08-07 00:00:00	1999-08-17	1999-08-17 00:00:00	32020		\N	271500	0	195662009	4112343		0
79718	4722	260139	1938-12-11	1938-12-11 00:00:00	1938-12-18	1938-12-18 00:00:00	32020		\N	314588	0	10509002	260139		0
69503	4113	81151	2011-08-14	2011-08-14 00:00:00	2011-09-04	2011-09-04 00:00:00	32020		\N	273391	0	44465007	81151		0
80448	4764	40481087	1987-05-24	1987-05-24 00:00:00	1987-06-14	1987-06-14 00:00:00	32020		\N	317494	0	444814009	40481087		0
80745	4788	4112343	1985-02-18	1985-02-18 00:00:00	1985-02-28	1985-02-28 00:00:00	32020		\N	318649	0	195662009	4112343		0
80957	4801	40481087	1980-10-09	1980-10-09 00:00:00	1980-10-16	1980-10-16 00:00:00	32020		\N	319402	0	444814009	40481087		0
81401	4827	40481087	1971-03-21	1971-03-21 00:00:00	1971-03-28	1971-03-28 00:00:00	32020		\N	321136	0	444814009	40481087		0
81542	4837	372328	1954-07-16	1954-07-16 00:00:00	1954-12-07	1954-12-07 00:00:00	32020		\N	321850	0	65363002	372328		0
71180	4222	4112343	2007-05-27	2007-05-27 00:00:00	2007-06-06	2007-06-06 00:00:00	32020		\N	280340	0	195662009	4112343		0
81954	4859	4112343	1972-03-01	1972-03-01 00:00:00	1972-03-09	1972-03-09 00:00:00	32020		\N	323233	0	195662009	4112343		0
71532	4241	4027663	1996-10-19	1996-10-19 00:00:00	\N	\N	32020		\N	281754	0	13200003	4027663		0
82263	4878	40481087	1984-04-10	1984-04-10 00:00:00	1984-05-01	1984-05-01 00:00:00	32020		\N	324345	0	444814009	40481087		0
82382	4886	260139	1989-08-12	1989-08-12 00:00:00	1989-08-26	1989-08-26 00:00:00	32020		\N	324889	0	10509002	260139		0
82549	4898	4294548	1985-12-09	1985-12-09 00:00:00	1985-12-30	1985-12-30 00:00:00	32020		\N	325692	0	75498004	4294548		0
72185	4283	28060	1990-09-11	1990-09-11 00:00:00	1990-09-24	1990-09-24 00:00:00	32020		\N	284263	0	43878008	28060		0
72374	4295	4112343	2011-12-23	2011-12-23 00:00:00	2012-01-03	2012-01-03 00:00:00	32020		\N	285074	0	195662009	4112343		0
83301	4949	4285898	2012-12-30	2012-12-30 00:00:00	\N	\N	32020		\N	329008	0	68496003	4285898		0
83407	4957	260139	2003-09-05	2003-09-05 00:00:00	2003-09-12	2003-09-12 00:00:00	32020		\N	329555	0	10509002	260139		0
83765	4976	40481087	1971-10-02	1971-10-02 00:00:00	1971-10-23	1971-10-23 00:00:00	32020		\N	331035	0	444814009	40481087		0
83931	4986	28060	1959-04-20	1959-04-20 00:00:00	1959-04-30	1959-04-30 00:00:00	32020		\N	331650	0	43878008	28060		0
84155	4999	260139	2001-09-19	2001-09-19 00:00:00	2001-09-26	2001-09-26 00:00:00	32020		\N	332417	0	10509002	260139		0
73658	4376	40480160	2010-09-19	2010-09-19 00:00:00	2010-10-19	2010-10-19 00:00:00	32020		\N	290735	0	443165006	40480160		0
84447	5022	4109685	1986-01-24	1986-01-24 00:00:00	1986-02-07	1986-02-07 00:00:00	32020		\N	333660	0	284551006	4109685		0
84762	5041	378001	2018-04-21	2018-04-21 00:00:00	2018-06-20	2018-06-20 00:00:00	32020		\N	334922	0	62106007	378001		0
84977	5053	4112343	1964-03-16	1964-03-16 00:00:00	1964-03-26	1964-03-26 00:00:00	32020		\N	335988	0	195662009	4112343		0
85033	5056	40481087	1971-07-21	1971-07-21 00:00:00	1971-07-28	1971-07-28 00:00:00	32020		\N	336130	0	444814009	40481087		0
85177	5066	40481087	1975-06-02	1975-06-02 00:00:00	1975-06-16	1975-06-16 00:00:00	32020		\N	336755	0	444814009	40481087		0
74778	4442	80180	2015-04-28	2015-04-28 00:00:00	\N	\N	32020		\N	295308	0	396275006	80180		0
74919	4450	372328	1969-02-13	1969-02-13 00:00:00	1969-07-19	1969-07-19 00:00:00	32020		\N	296039	0	65363002	372328		0
75040	4456	40481087	1990-05-14	1990-05-14 00:00:00	1990-06-04	1990-06-04 00:00:00	32020		\N	296575	0	444814009	40481087		0
75310	4472	80180	1975-03-19	1975-03-19 00:00:00	\N	\N	32020		\N	297526	0	396275006	80180		0
64840	3834	40481087	2009-10-04	2009-10-04 00:00:00	2009-10-11	2009-10-11 00:00:00	32020		\N	254607	0	444814009	40481087		0
75574	4484	40481087	2007-04-05	2007-04-05 00:00:00	2007-04-19	2007-04-19 00:00:00	32020		\N	298484	0	444814009	40481087		0
75701	4490	40481087	1980-02-12	1980-02-12 00:00:00	1980-03-04	1980-03-04 00:00:00	32020		\N	298918	0	444814009	40481087		0
65396	3866	28060	1957-05-16	1957-05-16 00:00:00	1957-05-24	1957-05-24 00:00:00	32020		\N	256722	0	43878008	28060		0
76085	4513	372328	1967-05-23	1967-05-23 00:00:00	1968-03-20	1968-03-20 00:00:00	32020		\N	300549	0	65363002	372328		0
76321	4527	28060	1986-03-28	1986-03-28 00:00:00	1986-04-04	1986-04-04 00:00:00	32020		\N	301426	0	43878008	28060		0
76493	4534	4112343	2008-10-13	2008-10-13 00:00:00	2008-10-21	2008-10-21 00:00:00	32020		\N	302046	0	195662009	4112343		0
76631	4543	372328	1981-07-29	1981-07-29 00:00:00	1981-08-12	1981-08-12 00:00:00	32020		\N	302645	0	65363002	372328		0
76753	4548	4278672	2016-08-03	2016-08-03 00:00:00	2016-09-02	2016-09-02 00:00:00	32020		\N	303028	0	65966004	4278672		0
76922	4559	4294548	2011-05-05	2011-05-05 00:00:00	2011-07-07	2011-07-07 00:00:00	32020		\N	303740	0	75498004	4294548		0
66561	3939	40481087	1979-07-21	1979-07-21 00:00:00	1979-08-04	1979-08-04 00:00:00	32020		\N	261811	0	444814009	40481087		0
77338	4580	40481087	1986-07-20	1986-07-20 00:00:00	1986-08-10	1986-08-10 00:00:00	32020		\N	305120	0	444814009	40481087		0
77485	4590	40481087	1959-09-30	1959-09-30 00:00:00	1959-10-14	1959-10-14 00:00:00	32020		\N	305856	0	444814009	40481087		0
77606	4596	40481087	1996-12-11	1996-12-11 00:00:00	1996-12-18	1996-12-18 00:00:00	32020		\N	306265	0	444814009	40481087		0
77756	4606	260139	1987-09-07	1987-09-07 00:00:00	1987-09-14	1987-09-14 00:00:00	32020		\N	306831	0	10509002	260139		0
88566	5264	4112343	1969-06-23	1969-06-23 00:00:00	1969-07-01	1969-07-01 00:00:00	32020		\N	350226	0	195662009	4112343		0
78087	4626	378001	1993-07-31	1993-07-31 00:00:00	1993-09-29	1993-09-29 00:00:00	32020		\N	308210	0	62106007	378001		0
78215	4631	4283893	2019-06-27	2019-06-27 00:00:00	\N	\N	32020		\N	308656	0	36971009	4283893		0
78400	4642	40481087	1994-07-27	1994-07-27 00:00:00	1994-08-10	1994-08-10 00:00:00	32020		\N	309401	0	444814009	40481087		0
78599	4655	81151	1992-09-03	1992-09-03 00:00:00	1992-09-24	1992-09-24 00:00:00	32020		\N	310303	0	44465007	81151		0
78715	4662	4134304	1965-01-02	1965-01-02 00:00:00	1965-02-01	1965-02-01 00:00:00	32020		\N	310771	0	263102004	4134304		0
78994	4677	4112343	1965-10-18	1965-10-18 00:00:00	1965-10-26	1965-10-26 00:00:00	32020		\N	311643	0	195662009	4112343		0
79080	4680	4218389	1988-08-07	1988-08-07 00:00:00	1988-08-28	1988-08-28 00:00:00	32020		\N	311951	0	39848009	4218389		0
79297	4696	4112343	2014-07-15	2014-07-15 00:00:00	2014-07-26	2014-07-26 00:00:00	32020		\N	312898	0	195662009	4112343		0
79488	4707	4112343	1996-03-06	1996-03-06 00:00:00	1996-03-15	1996-03-15 00:00:00	32020		\N	313591	0	195662009	4112343		0
69032	4085	4283893	1962-01-12	1962-01-12 00:00:00	1962-09-07	1962-09-07 00:00:00	32020		\N	271479	0	36971009	4283893		0
79719	4722	4156265	1996-06-19	1996-06-19 00:00:00	1996-07-10	1996-07-10 00:00:00	32020		\N	314615	0	370247008	4156265		0
69504	4113	40481087	1983-04-17	1983-04-17 00:00:00	1983-05-08	1983-05-08 00:00:00	32020		\N	273395	0	444814009	40481087		0
69681	4123	4218389	1997-12-25	1997-12-25 00:00:00	1998-01-29	1998-01-29 00:00:00	32020		\N	274117	0	39848009	4218389		0
80449	4764	40481087	2018-06-25	2018-06-25 00:00:00	2018-07-02	2018-07-02 00:00:00	32020		\N	317512	0	444814009	40481087		0
80746	4788	28060	1978-09-10	1978-09-10 00:00:00	1978-09-20	1978-09-20 00:00:00	32020		\N	318675	0	43878008	28060		0
80958	4802	80180	2005-06-20	2005-06-20 00:00:00	\N	\N	32020		\N	319480	0	396275006	80180		0
81402	4827	40481087	1971-12-28	1971-12-28 00:00:00	1972-01-04	1972-01-04 00:00:00	32020		\N	321180	0	444814009	40481087		0
81543	4837	4112343	1992-03-06	1992-03-06 00:00:00	1992-03-13	1992-03-13 00:00:00	32020		\N	321838	0	195662009	4112343		0
71181	4222	4027663	1979-06-09	1979-06-09 00:00:00	\N	\N	32020		\N	280275	0	13200003	4027663		0
81955	4859	4112343	2018-08-30	2018-08-30 00:00:00	2018-09-06	2018-09-06 00:00:00	32020		\N	323237	0	195662009	4112343		0
71533	4241	260139	1996-02-07	1996-02-07 00:00:00	1996-02-21	1996-02-21 00:00:00	32020		\N	281754	0	10509002	260139		0
82264	4878	4112343	1971-01-14	1971-01-14 00:00:00	1971-01-21	1971-01-21 00:00:00	32020		\N	324315	0	195662009	4112343		0
82383	4886	195588	1987-09-01	1987-09-01 00:00:00	1987-10-04	1987-10-04 00:00:00	32020		\N	324876	0	38822007	195588		0
82550	4898	4218389	1971-04-13	1971-04-13 00:00:00	1971-05-11	1971-05-11 00:00:00	32020		\N	325704	0	39848009	4218389		0
72186	4283	260139	1981-12-29	1981-12-29 00:00:00	1982-01-12	1982-01-12 00:00:00	32020		\N	284231	0	10509002	260139		0
72375	4295	260139	1973-07-14	1973-07-14 00:00:00	1973-07-28	1973-07-28 00:00:00	32020		\N	285044	0	10509002	260139		0
83302	4949	80180	2013-02-28	2013-02-28 00:00:00	\N	\N	32020		\N	329008	0	396275006	80180		0
83408	4957	40481087	1978-05-06	1978-05-06 00:00:00	1978-05-20	1978-05-20 00:00:00	32020		\N	329514	0	444814009	40481087		0
83766	4976	4296205	1952-10-09	1952-10-09 00:00:00	1952-11-06	1952-11-06 00:00:00	32020		\N	331104	0	403191005	4296205		0
83932	4987	4027663	1990-09-14	1990-09-14 00:00:00	\N	\N	32020		\N	331750	0	13200003	4027663		0
84156	4999	4116491	2007-11-06	2007-11-06 00:00:00	2007-12-19	2007-12-19 00:00:00	32020		\N	332419	0	301011002	4116491		0
73659	4376	80502	2010-09-19	2010-09-19 00:00:00	\N	\N	32020		\N	290735	0	64859006	80502		0
84448	5022	4112343	1991-06-22	1991-06-22 00:00:00	1991-07-05	1991-07-05 00:00:00	32020		\N	333667	0	195662009	4112343		0
84763	5041	372328	1971-04-23	1971-04-23 00:00:00	1971-08-03	1971-08-03 00:00:00	32020		\N	334929	0	65363002	372328		0
84978	5053	260139	2018-07-21	2018-07-21 00:00:00	2018-07-28	2018-07-28 00:00:00	32020		\N	336031	0	10509002	260139		0
85034	5056	40481087	2000-08-09	2000-08-09 00:00:00	2000-08-30	2000-08-30 00:00:00	32020		\N	336203	0	444814009	40481087		0
85178	5066	257012	2018-10-07	2018-10-07 00:00:00	\N	\N	32020		\N	336757	0	40055000	257012		0
74779	4442	40481087	2005-12-01	2005-12-01 00:00:00	2005-12-08	2005-12-08 00:00:00	32020		\N	295283	0	444814009	40481087		0
74920	4450	40481087	1973-11-23	1973-11-23 00:00:00	1973-12-07	1973-12-07 00:00:00	32020		\N	296067	0	444814009	40481087		0
75041	4456	40481087	1976-04-30	1976-04-30 00:00:00	1976-05-21	1976-05-21 00:00:00	32020		\N	296573	0	444814009	40481087		0
75311	4472	40481087	1974-04-10	1974-04-10 00:00:00	1974-05-01	1974-05-01 00:00:00	32020		\N	297526	0	444814009	40481087		0
64841	3834	4283893	1992-07-25	1992-07-25 00:00:00	1992-09-12	1992-09-12 00:00:00	32020		\N	254580	0	36971009	4283893		0
75575	4484	80180	1986-07-26	1986-07-26 00:00:00	\N	\N	32020		\N	298514	0	396275006	80180		0
75702	4490	372328	1926-04-21	1926-04-21 00:00:00	1926-06-05	1926-06-05 00:00:00	32020		\N	298919	0	65363002	372328		0
65397	3866	4218389	1955-05-13	1955-05-13 00:00:00	1955-06-10	1955-06-10 00:00:00	32020		\N	256758	0	39848009	4218389		0
76086	4513	28060	1982-02-07	1982-02-07 00:00:00	1982-02-16	1982-02-16 00:00:00	32020		\N	300545	0	43878008	28060		0
76322	4527	4112343	1988-04-27	1988-04-27 00:00:00	1988-05-05	1988-05-05 00:00:00	32020		\N	301428	0	195662009	4112343		0
76494	4534	40481087	1943-12-02	1943-12-02 00:00:00	1943-12-09	1943-12-09 00:00:00	32020		\N	302052	0	444814009	40481087		0
76632	4543	4109685	2001-06-05	2001-06-05 00:00:00	2001-06-26	2001-06-26 00:00:00	32020		\N	302642	0	284551006	4109685		0
76754	4548	260139	1988-10-15	1988-10-15 00:00:00	1988-10-29	1988-10-29 00:00:00	32020		\N	303016	0	10509002	260139		0
76923	4559	40481087	2011-10-14	2011-10-14 00:00:00	2011-10-28	2011-10-28 00:00:00	32020		\N	303778	0	444814009	40481087		0
66562	3939	40481087	1992-12-09	1992-12-09 00:00:00	1992-12-23	1992-12-23 00:00:00	32020		\N	261816	0	444814009	40481087		0
77339	4580	40481087	1967-10-31	1967-10-31 00:00:00	1967-11-21	1967-11-21 00:00:00	32020		\N	305122	0	444814009	40481087		0
77486	4591	4027663	1983-09-11	1983-09-11 00:00:00	\N	\N	32020		\N	305917	0	13200003	4027663		0
77607	4596	372328	2013-06-22	2013-06-22 00:00:00	2014-04-20	2014-04-20 00:00:00	32020		\N	306308	0	65363002	372328		0
77757	4606	80180	2016-12-17	2016-12-17 00:00:00	\N	\N	32020		\N	306871	0	396275006	80180		0
88567	5264	260139	2016-02-22	2016-02-22 00:00:00	2016-02-29	2016-02-29 00:00:00	32020		\N	350245	0	10509002	260139		0
78088	4626	4230399	2016-05-01	2016-05-01 00:00:00	2016-05-31	2016-05-31 00:00:00	32020		\N	308211	0	359817006	4230399		0
78216	4631	260139	1918-12-21	1918-12-21 00:00:00	1918-12-28	1918-12-28 00:00:00	32020		\N	308601	0	10509002	260139		0
78401	4642	81151	1979-02-07	1979-02-07 00:00:00	1979-03-14	1979-03-14 00:00:00	32020		\N	309392	0	44465007	81151		0
78600	4655	260139	2011-11-27	2011-11-27 00:00:00	2011-12-04	2011-12-04 00:00:00	32020		\N	310345	0	10509002	260139		0
78716	4662	40481087	1982-02-24	1982-02-24 00:00:00	1982-03-10	1982-03-10 00:00:00	32020		\N	310739	0	444814009	40481087		0
78995	4677	4218389	1977-04-14	1977-04-14 00:00:00	1977-05-19	1977-05-19 00:00:00	32020		\N	311667	0	39848009	4218389		0
79081	4680	40481087	1990-03-15	1990-03-15 00:00:00	1990-04-05	1990-04-05 00:00:00	32020		\N	311890	0	444814009	40481087		0
79298	4696	260139	1954-12-24	1954-12-24 00:00:00	1954-12-31	1954-12-31 00:00:00	32020		\N	312853	0	10509002	260139		0
79489	4707	4294548	2016-02-16	2016-02-16 00:00:00	2016-04-05	2016-04-05 00:00:00	32020		\N	313574	0	75498004	4294548		0
69033	4086	40481087	1993-05-31	1993-05-31 00:00:00	1993-06-14	1993-06-14 00:00:00	32020		\N	271559	0	444814009	40481087		0
79720	4722	40481087	1996-10-31	1996-10-31 00:00:00	1996-11-21	1996-11-21 00:00:00	32020		\N	314489	0	444814009	40481087		0
69505	4113	40481087	1979-12-21	1979-12-21 00:00:00	1979-12-28	1979-12-28 00:00:00	32020		\N	273457	0	444814009	40481087		0
69682	4123	4266809	1999-01-07	1999-01-07 00:00:00	\N	\N	32020		\N	274117	0	397881000	4266809		0
80450	4764	40481087	2010-12-31	2010-12-31 00:00:00	2011-01-14	2011-01-14 00:00:00	32020		\N	317518	0	444814009	40481087		0
80747	4788	40481087	1982-04-24	1982-04-24 00:00:00	1982-05-15	1982-05-15 00:00:00	32020		\N	318687	0	444814009	40481087		0
80959	4802	40481087	1972-12-15	1972-12-15 00:00:00	1973-01-05	1973-01-05 00:00:00	32020		\N	319453	0	444814009	40481087		0
81403	4827	260139	2016-02-29	2016-02-29 00:00:00	2016-03-14	2016-03-14 00:00:00	32020		\N	321097	0	10509002	260139		0
81544	4837	4112343	2002-09-19	2002-09-19 00:00:00	2002-10-01	2002-10-01 00:00:00	32020		\N	321823	0	195662009	4112343		0
71182	4222	378001	1964-04-28	1964-04-28 00:00:00	1964-05-28	1964-05-28 00:00:00	32020		\N	280337	0	62106007	378001		0
81956	4859	372328	1969-03-24	1969-03-24 00:00:00	1969-11-02	1969-11-02 00:00:00	32020		\N	323255	0	65363002	372328		0
71542	4243	372328	1969-02-12	1969-02-12 00:00:00	1969-03-28	1969-03-28 00:00:00	32020		\N	281831	0	65363002	372328		0
82275	4881	381316	2017-03-05	2017-03-05 00:00:00	\N	\N	32020		\N	324558	0	230690007	381316		0
82384	4886	192671	2002-05-01	2002-05-01 00:00:00	\N	\N	32020		\N	324938	0	K92.2	35208414		0
82551	4898	4059173	1962-10-27	1962-10-27 00:00:00	1962-11-26	1962-11-26 00:00:00	32020		\N	325703	0	16114001	4059173		0
72187	4283	257012	2001-04-19	2001-04-19 00:00:00	\N	\N	32020		\N	284291	0	40055000	257012		0
72376	4295	40481087	1975-10-09	1975-10-09 00:00:00	1975-10-30	1975-10-30 00:00:00	32020		\N	285061	0	444814009	40481087		0
83303	4949	4266809	2013-02-28	2013-02-28 00:00:00	\N	\N	32020		\N	329008	0	397881000	4266809		0
83409	4957	260139	1978-11-12	1978-11-12 00:00:00	1978-11-19	1978-11-19 00:00:00	32020		\N	329515	0	10509002	260139		0
83767	4976	439777	1976-10-27	1976-10-27 00:00:00	\N	\N	32020		\N	330970	0	271737000	439777		0
83933	4987	4113008	1970-01-27	1970-01-27 00:00:00	1970-02-17	1970-02-17 00:00:00	32020		\N	331786	0	284549007	4113008		0
84157	4999	40481087	1995-05-20	1995-05-20 00:00:00	1995-05-27	1995-05-27 00:00:00	32020		\N	332415	0	444814009	40481087		0
73660	4376	40481087	1948-02-12	1948-02-12 00:00:00	1948-02-19	1948-02-19 00:00:00	32020		\N	290828	0	444814009	40481087		0
84449	5022	192671	2005-06-19	2005-06-19 00:00:00	\N	\N	32020		\N	333656	0	K92.2	35208414		0
84764	5041	4112343	1994-03-19	1994-03-19 00:00:00	1994-03-27	1994-03-27 00:00:00	32020		\N	334941	0	195662009	4112343		0
84979	5053	4155034	2001-07-15	2001-07-15 00:00:00	2001-07-29	2001-07-29 00:00:00	32020		\N	336021	0	283371005	4155034		0
85035	5056	260139	2000-09-14	2000-09-14 00:00:00	2000-09-28	2000-09-28 00:00:00	32020		\N	336124	0	10509002	260139		0
85179	5066	4112343	1982-12-16	1982-12-16 00:00:00	1982-12-25	1982-12-25 00:00:00	32020		\N	336773	0	195662009	4112343		0
74780	4442	4237458	1991-09-12	1991-09-12 00:00:00	1991-12-11	1991-12-11 00:00:00	32020		\N	295333	0	58150001	4237458		0
74921	4450	40481087	1985-08-14	1985-08-14 00:00:00	1985-08-21	1985-08-21 00:00:00	32020		\N	296049	0	444814009	40481087		0
75042	4456	375671	1968-04-03	1968-04-03 00:00:00	1968-05-03	1968-05-03 00:00:00	32020		\N	296617	0	62564004	375671		0
75312	4472	40481087	1965-01-05	1965-01-05 00:00:00	1965-01-12	1965-01-12 00:00:00	32020		\N	297494	0	444814009	40481087		0
64842	3834	40481087	1957-07-11	1957-07-11 00:00:00	1957-07-18	1957-07-18 00:00:00	32020		\N	254590	0	444814009	40481087		0
75576	4485	81151	2008-10-21	2008-10-21 00:00:00	2008-11-04	2008-11-04 00:00:00	32020		\N	298620	0	44465007	81151		0
75703	4490	4112343	1971-05-09	1971-05-09 00:00:00	1971-05-18	1971-05-18 00:00:00	32020		\N	298889	0	195662009	4112343		0
65398	3866	80180	1990-02-18	1990-02-18 00:00:00	\N	\N	32020		\N	256706	0	396275006	80180		0
76087	4513	4218389	2003-09-02	2003-09-02 00:00:00	2003-10-07	2003-10-07 00:00:00	32020		\N	300587	0	39848009	4218389		0
76323	4527	4112343	2015-12-11	2015-12-11 00:00:00	2015-12-24	2015-12-24 00:00:00	32020		\N	301429	0	195662009	4112343		0
76495	4534	4146173	1980-02-15	1980-02-15 00:00:00	1980-03-16	1980-03-16 00:00:00	32020		\N	302021	0	307731004	4146173		0
76633	4543	40481087	1992-10-05	1992-10-05 00:00:00	1992-10-12	1992-10-12 00:00:00	32020		\N	302604	0	444814009	40481087		0
76755	4548	4280726	1986-10-24	1986-10-24 00:00:00	2002-10-22	2002-10-22 00:00:00	32020		\N	303097	0	367498001	4280726		0
76924	4559	80502	2015-07-28	2015-07-28 00:00:00	\N	\N	32020		\N	303732	0	64859006	80502		0
66563	3939	28060	1978-08-01	1978-08-01 00:00:00	1978-08-13	1978-08-13 00:00:00	32020		\N	261862	0	43878008	28060		0
77340	4580	4112343	1987-01-23	1987-01-23 00:00:00	1987-02-04	1987-02-04 00:00:00	32020		\N	305123	0	195662009	4112343		0
77487	4591	375671	1959-04-15	1959-04-15 00:00:00	1959-05-15	1959-05-15 00:00:00	32020		\N	305893	0	62564004	375671		0
77608	4596	4294548	1979-08-27	1979-08-27 00:00:00	1980-01-07	1980-01-07 00:00:00	32020		\N	306264	0	75498004	4294548		0
77758	4606	260139	2018-04-10	2018-04-10 00:00:00	2018-04-17	2018-04-17 00:00:00	32020		\N	306842	0	10509002	260139		0
88568	5265	40481087	1991-11-27	1991-11-27 00:00:00	1991-12-18	1991-12-18 00:00:00	32020		\N	350280	0	444814009	40481087		0
78089	4626	4112343	1990-09-18	1990-09-18 00:00:00	1990-09-27	1990-09-27 00:00:00	32020		\N	308233	0	195662009	4112343		0
78217	4631	81151	1984-08-12	1984-08-12 00:00:00	1984-09-02	1984-09-02 00:00:00	32020		\N	308556	0	44465007	81151		0
78402	4642	133834	1955-10-18	1955-10-18 00:00:00	1970-01-02	1970-01-02 00:00:00	32020		\N	309452	0	24079001	133834		0
78601	4655	372328	2006-10-03	2006-10-03 00:00:00	2008-07-13	2008-07-13 00:00:00	32020		\N	310349	0	65363002	372328		0
78717	4662	40481087	1978-08-14	1978-08-14 00:00:00	1978-09-04	1978-09-04 00:00:00	32020		\N	310731	0	444814009	40481087		0
78996	4677	81151	1983-10-15	1983-10-15 00:00:00	1983-11-05	1983-11-05 00:00:00	32020		\N	311668	0	44465007	81151		0
79082	4680	4059173	1995-01-24	1995-01-24 00:00:00	1995-02-23	1995-02-23 00:00:00	32020		\N	311952	0	16114001	4059173		0
79299	4696	372328	1989-08-12	1989-08-12 00:00:00	1991-03-20	1991-03-20 00:00:00	32020		\N	312861	0	65363002	372328		0
79490	4707	260139	2014-03-20	2014-03-20 00:00:00	2014-03-27	2014-03-27 00:00:00	32020		\N	313581	0	10509002	260139		0
69034	4086	4112343	2017-06-10	2017-06-10 00:00:00	2017-06-17	2017-06-17 00:00:00	32020		\N	271622	0	195662009	4112343		0
79721	4722	260139	1946-04-17	1946-04-17 00:00:00	1946-04-24	1946-04-24 00:00:00	32020		\N	314563	0	10509002	260139		0
69506	4113	40481087	1976-07-20	1976-07-20 00:00:00	1976-08-03	1976-08-03 00:00:00	32020		\N	273428	0	444814009	40481087		0
69683	4123	40481087	1976-05-28	1976-05-28 00:00:00	1976-06-04	1976-06-04 00:00:00	32020		\N	274119	0	444814009	40481087		0
80451	4764	257012	2005-07-16	2005-07-16 00:00:00	\N	\N	32020		\N	317497	0	40055000	257012		0
80763	4791	40481087	1994-11-12	1994-11-12 00:00:00	1994-11-19	1994-11-19 00:00:00	32020		\N	318813	0	444814009	40481087		0
80960	4802	40481087	2016-09-04	2016-09-04 00:00:00	2016-09-25	2016-09-25 00:00:00	32020		\N	319456	0	444814009	40481087		0
81404	4827	4112343	1963-05-03	1963-05-03 00:00:00	1963-05-15	1963-05-15 00:00:00	32020		\N	321134	0	195662009	4112343		0
81545	4837	4112343	2005-12-16	2005-12-16 00:00:00	2005-12-27	2005-12-27 00:00:00	32020		\N	321865	0	195662009	4112343		0
71183	4222	192671	1987-02-17	1987-02-17 00:00:00	\N	\N	32020		\N	280343	0	K92.2	35208414		0
81957	4859	260139	1985-09-22	1985-09-22 00:00:00	1985-10-06	1985-10-06 00:00:00	32020		\N	323252	0	10509002	260139		0
71543	4243	40481087	1977-10-06	1977-10-06 00:00:00	1977-10-20	1977-10-20 00:00:00	32020		\N	281824	0	444814009	40481087		0
82276	4881	4218389	1994-04-19	1994-04-19 00:00:00	1994-05-17	1994-05-17 00:00:00	32020		\N	324547	0	39848009	4218389		0
82385	4886	4027663	1992-08-30	1992-08-30 00:00:00	\N	\N	32020		\N	324915	0	13200003	4027663		0
82552	4898	260139	2008-01-05	2008-01-05 00:00:00	2008-01-19	2008-01-19 00:00:00	32020		\N	325697	0	10509002	260139		0
72188	4283	40481087	1985-12-07	1985-12-07 00:00:00	1985-12-28	1985-12-28 00:00:00	32020		\N	284237	0	444814009	40481087		0
82865	4922	195588	2000-07-28	2000-07-28 00:00:00	2000-09-14	2000-09-14 00:00:00	32020		\N	327037	0	38822007	195588		0
83304	4949	40481087	2009-04-22	2009-04-22 00:00:00	2009-04-29	2009-04-29 00:00:00	32020		\N	329009	0	444814009	40481087		0
83410	4957	260139	2009-09-30	2009-09-30 00:00:00	2009-10-07	2009-10-07 00:00:00	32020		\N	329534	0	10509002	260139		0
83768	4976	260139	1981-06-05	1981-06-05 00:00:00	1981-06-19	1981-06-19 00:00:00	32020		\N	330978	0	10509002	260139		0
83934	4987	40481087	1972-11-22	1972-11-22 00:00:00	1972-11-29	1972-11-29 00:00:00	32020		\N	331757	0	444814009	40481087		0
84158	4999	40481087	1971-08-17	1971-08-17 00:00:00	1971-08-24	1971-08-24 00:00:00	32020		\N	332479	0	444814009	40481087		0
73661	4376	260139	1929-02-15	1929-02-15 00:00:00	1929-03-01	1929-03-01 00:00:00	32020		\N	290825	0	10509002	260139		0
84450	5022	40481087	2007-01-31	2007-01-31 00:00:00	2007-02-14	2007-02-14 00:00:00	32020		\N	333696	0	444814009	40481087		0
84765	5041	4112343	1981-08-22	1981-08-22 00:00:00	1981-08-29	1981-08-29 00:00:00	32020		\N	334949	0	195662009	4112343		0
84980	5053	4112343	1967-03-14	1967-03-14 00:00:00	1967-03-21	1967-03-21 00:00:00	32020		\N	335971	0	195662009	4112343		0
85036	5056	40481087	2010-11-14	2010-11-14 00:00:00	2010-11-28	2010-11-28 00:00:00	32020		\N	336144	0	444814009	40481087		0
85180	5066	81151	1973-01-06	1973-01-06 00:00:00	1973-02-03	1973-02-03 00:00:00	32020		\N	336803	0	44465007	81151		0
74781	4442	81151	1987-02-14	1987-02-14 00:00:00	1987-03-07	1987-03-07 00:00:00	32020		\N	295332	0	44465007	81151		0
74922	4450	4112343	2018-10-18	2018-10-18 00:00:00	2018-10-31	2018-10-31 00:00:00	32020		\N	296074	0	195662009	4112343		0
75043	4456	4059173	1965-06-18	1965-06-18 00:00:00	1965-08-17	1965-08-17 00:00:00	32020		\N	296616	0	16114001	4059173		0
75313	4472	260139	1940-05-18	1940-05-18 00:00:00	1940-05-25	1940-05-25 00:00:00	32020		\N	297479	0	10509002	260139		0
64843	3834	372328	1966-08-24	1966-08-24 00:00:00	1967-06-25	1967-06-25 00:00:00	32020		\N	254556	0	65363002	372328		0
75577	4485	81893	1992-12-25	1992-12-25 00:00:00	\N	\N	32020		\N	298596	0	64766004	81893		0
75704	4490	40481087	1937-11-26	1937-11-26 00:00:00	1937-12-17	1937-12-17 00:00:00	32020		\N	298909	0	444814009	40481087		0
75863	4500	4112343	2006-08-28	2006-08-28 00:00:00	2006-09-08	2006-09-08 00:00:00	32020		\N	299584	0	195662009	4112343		0
76088	4513	260139	1969-02-03	1969-02-03 00:00:00	1969-02-10	1969-02-10 00:00:00	32020		\N	300580	0	10509002	260139		0
76324	4527	4283893	1983-01-21	1983-01-21 00:00:00	1983-02-11	1983-02-11 00:00:00	32020		\N	301458	0	36971009	4283893		0
76496	4534	372328	1945-04-19	1945-04-19 00:00:00	1945-10-03	1945-10-03 00:00:00	32020		\N	302048	0	65363002	372328		0
76634	4543	4218389	1984-07-13	1984-07-13 00:00:00	1984-08-03	1984-08-03 00:00:00	32020		\N	302640	0	39848009	4218389		0
76756	4548	40481087	2015-12-08	2015-12-08 00:00:00	2015-12-15	2015-12-15 00:00:00	32020		\N	302992	0	444814009	40481087		0
76925	4559	372328	1965-01-27	1965-01-27 00:00:00	1967-12-19	1967-12-19 00:00:00	32020		\N	303756	0	65363002	372328		0
66564	3939	40481087	1974-04-29	1974-04-29 00:00:00	1974-05-13	1974-05-13 00:00:00	32020		\N	261861	0	444814009	40481087		0
77341	4580	372328	1970-12-05	1970-12-05 00:00:00	1971-01-26	1971-01-26 00:00:00	32020		\N	305106	0	65363002	372328		0
77488	4591	260139	2012-01-09	2012-01-09 00:00:00	2012-01-23	2012-01-23 00:00:00	32020		\N	305946	0	10509002	260139		0
77609	4596	40481087	1980-10-10	1980-10-10 00:00:00	1980-10-31	1980-10-31 00:00:00	32020		\N	306291	0	444814009	40481087		0
77759	4606	4112343	2017-11-07	2017-11-07 00:00:00	2017-11-16	2017-11-16 00:00:00	32020		\N	306841	0	195662009	4112343		0
88569	5265	4152936	1970-12-08	1970-12-08 00:00:00	1970-12-22	1970-12-22 00:00:00	32020		\N	350326	0	283385000	4152936		0
78090	4626	260139	2017-11-16	2017-11-16 00:00:00	2017-11-30	2017-11-30 00:00:00	32020		\N	308170	0	10509002	260139		0
78218	4631	4112343	2006-10-27	2006-10-27 00:00:00	2006-11-08	2006-11-08 00:00:00	32020		\N	308609	0	195662009	4112343		0
78403	4642	40481087	1988-02-05	1988-02-05 00:00:00	1988-02-26	1988-02-26 00:00:00	32020		\N	309380	0	444814009	40481087		0
78602	4655	4294548	2017-09-21	2017-09-21 00:00:00	2017-11-23	2017-11-23 00:00:00	32020		\N	310403	0	75498004	4294548		0
78718	4662	40481087	1995-10-04	1995-10-04 00:00:00	1995-10-25	1995-10-25 00:00:00	32020		\N	310797	0	444814009	40481087		0
78997	4677	40481087	2001-02-26	2001-02-26 00:00:00	2001-03-12	2001-03-12 00:00:00	32020		\N	311655	0	444814009	40481087		0
79083	4680	4113008	1957-04-10	1957-04-10 00:00:00	1957-04-24	1957-04-24 00:00:00	32020		\N	311945	0	284549007	4113008		0
79300	4696	260139	1958-12-31	1958-12-31 00:00:00	1959-01-14	1959-01-14 00:00:00	32020		\N	312833	0	10509002	260139		0
79491	4707	257012	2016-03-08	2016-03-08 00:00:00	\N	\N	32020		\N	313582	0	40055000	257012		0
69035	4086	378001	1976-04-12	1976-04-12 00:00:00	1976-05-13	1976-05-13 00:00:00	32020		\N	271569	0	62106007	378001		0
79722	4722	4278672	2015-09-29	2015-09-29 00:00:00	2015-10-29	2015-10-29 00:00:00	32020		\N	314617	0	65966004	4278672		0
69507	4113	40481087	1960-05-17	1960-05-17 00:00:00	1960-05-24	1960-05-24 00:00:00	32020		\N	273425	0	444814009	40481087		0
69684	4123	4112343	2003-05-01	2003-05-01 00:00:00	2003-05-09	2003-05-09 00:00:00	32020		\N	274148	0	195662009	4112343		0
80452	4764	80180	2007-01-29	2007-01-29 00:00:00	\N	\N	32020		\N	317497	0	396275006	80180		0
80764	4791	4112343	1994-07-18	1994-07-18 00:00:00	1994-07-28	1994-07-28 00:00:00	32020		\N	318766	0	195662009	4112343		0
80961	4802	4059173	1971-12-05	1971-12-05 00:00:00	1972-03-04	1972-03-04 00:00:00	32020		\N	319437	0	16114001	4059173		0
81405	4827	4112343	2017-12-29	2017-12-29 00:00:00	2018-01-07	2018-01-07 00:00:00	32020		\N	321129	0	195662009	4112343		0
81546	4837	40481087	2007-10-31	2007-10-31 00:00:00	2007-11-14	2007-11-14 00:00:00	32020		\N	321866	0	444814009	40481087		0
71184	4222	30753	1986-08-01	1986-08-01 00:00:00	\N	\N	32020		\N	280298	0	16761005	30753		0
81958	4859	260139	1955-08-19	1955-08-19 00:00:00	1955-08-26	1955-08-26 00:00:00	32020		\N	323247	0	10509002	260139		0
71544	4243	40481087	1999-05-31	1999-05-31 00:00:00	1999-06-14	1999-06-14 00:00:00	32020		\N	281827	0	444814009	40481087		0
82277	4881	372328	1952-09-18	1952-09-18 00:00:00	1953-06-21	1953-06-21 00:00:00	32020		\N	324510	0	65363002	372328		0
82386	4886	80180	2002-04-15	2002-04-15 00:00:00	\N	\N	32020		\N	324945	0	396275006	80180		0
82553	4898	260139	2012-03-28	2012-03-28 00:00:00	2012-04-11	2012-04-11 00:00:00	32020		\N	325743	0	10509002	260139		0
72189	4283	4059173	1959-02-08	1959-02-08 00:00:00	1959-05-09	1959-05-09 00:00:00	32020		\N	284280	0	16114001	4059173		0
82866	4922	192671	2013-08-01	2013-08-01 00:00:00	\N	\N	32020		\N	327006	0	K92.2	35208414		0
83305	4949	192671	2013-03-31	2013-03-31 00:00:00	\N	\N	32020		\N	329003	0	K92.2	35208414		0
83411	4957	260139	1983-09-05	1983-09-05 00:00:00	1983-09-19	1983-09-19 00:00:00	32020		\N	329554	0	10509002	260139		0
83769	4976	40481087	1914-03-15	1914-03-15 00:00:00	1914-03-29	1914-03-29 00:00:00	32020		\N	331031	0	444814009	40481087		0
83935	4987	372328	1962-10-06	1962-10-06 00:00:00	1963-02-26	1963-02-26 00:00:00	32020		\N	331762	0	65363002	372328		0
84159	4999	40481087	1993-04-10	1993-04-10 00:00:00	1993-04-24	1993-04-24 00:00:00	32020		\N	332482	0	444814009	40481087		0
73688	4379	4142905	1987-04-14	1987-04-14 00:00:00	1987-07-13	1987-07-13 00:00:00	32020		\N	290992	0	33737001	4142905		0
84451	5022	372328	1972-09-06	1972-09-06 00:00:00	1972-12-11	1972-12-11 00:00:00	32020		\N	333697	0	65363002	372328		0
84766	5041	4112343	1993-05-11	1993-05-11 00:00:00	1993-05-21	1993-05-21 00:00:00	32020		\N	334940	0	195662009	4112343		0
84981	5053	257012	1998-09-09	1998-09-09 00:00:00	\N	\N	32020		\N	336029	0	40055000	257012		0
85037	5056	4112343	2004-11-25	2004-11-25 00:00:00	2004-12-03	2004-12-03 00:00:00	32020		\N	336125	0	195662009	4112343		0
85181	5066	80180	2011-07-16	2011-07-16 00:00:00	\N	\N	32020		\N	336811	0	396275006	80180		0
74782	4442	4294548	1985-06-24	1985-06-24 00:00:00	1985-07-29	1985-07-29 00:00:00	32020		\N	295285	0	75498004	4294548		0
74923	4450	4283893	1969-10-07	1969-10-07 00:00:00	1969-12-09	1969-12-09 00:00:00	32020		\N	296087	0	36971009	4283893		0
75044	4456	260139	1999-12-09	1999-12-09 00:00:00	1999-12-16	1999-12-16 00:00:00	32020		\N	296553	0	10509002	260139		0
75314	4472	81151	1955-09-25	1955-09-25 00:00:00	1955-10-16	1955-10-16 00:00:00	32020		\N	297544	0	44465007	81151		0
64844	3834	40481087	1960-04-23	1960-04-23 00:00:00	1960-05-07	1960-05-07 00:00:00	32020		\N	254619	0	444814009	40481087		0
75578	4485	30753	1993-08-22	1993-08-22 00:00:00	\N	\N	32020		\N	298596	0	16761005	30753		0
75705	4490	4112343	1981-02-26	1981-02-26 00:00:00	1981-03-07	1981-03-07 00:00:00	32020		\N	298910	0	195662009	4112343		0
75864	4500	4084167	1962-08-09	1962-08-09 00:00:00	1962-08-09	1962-08-09 00:00:00	32020		\N	299602	0	241929008	4084167		0
76089	4513	40481087	1972-08-02	1972-08-02 00:00:00	1972-08-16	1972-08-16 00:00:00	32020		\N	300581	0	444814009	40481087		0
76325	4527	4112343	1974-10-12	1974-10-12 00:00:00	1974-10-23	1974-10-23 00:00:00	32020		\N	301456	0	195662009	4112343		0
76497	4534	40481087	1993-08-21	1993-08-21 00:00:00	1993-08-28	1993-08-28 00:00:00	32020		\N	302100	0	444814009	40481087		0
76635	4543	40481087	2002-04-20	2002-04-20 00:00:00	2002-05-04	2002-05-04 00:00:00	32020		\N	302623	0	444814009	40481087		0
76757	4548	40481087	2013-01-26	2013-01-26 00:00:00	2013-02-16	2013-02-16 00:00:00	32020		\N	303011	0	444814009	40481087		0
76926	4559	81151	1962-04-03	1962-04-03 00:00:00	1962-05-01	1962-05-01 00:00:00	32020		\N	303804	0	44465007	81151		0
66565	3939	260139	1993-05-12	1993-05-12 00:00:00	1993-05-26	1993-05-26 00:00:00	32020		\N	261817	0	10509002	260139		0
77342	4580	28060	1976-11-04	1976-11-04 00:00:00	1976-11-15	1976-11-15 00:00:00	32020		\N	305113	0	43878008	28060		0
77489	4591	260139	2003-03-19	2003-03-19 00:00:00	2003-03-26	2003-03-26 00:00:00	32020		\N	305919	0	10509002	260139		0
77610	4596	260139	1978-11-24	1978-11-24 00:00:00	1978-12-08	1978-12-08 00:00:00	32020		\N	306263	0	10509002	260139		0
77760	4606	40481087	2012-07-03	2012-07-03 00:00:00	2012-07-24	2012-07-24 00:00:00	32020		\N	306833	0	444814009	40481087		0
88570	5265	4113008	2008-03-12	2008-03-12 00:00:00	2008-04-02	2008-04-02 00:00:00	32020		\N	350270	0	284549007	4113008		0
78091	4626	134438	1997-11-04	1997-11-04 00:00:00	1998-11-02	1998-11-02 00:00:00	32020		\N	308177	0	40275004	134438		0
78219	4631	4112343	1977-10-28	1977-10-28 00:00:00	1977-11-06	1977-11-06 00:00:00	32020		\N	308607	0	195662009	4112343		0
78404	4642	260139	1965-10-05	1965-10-05 00:00:00	1965-10-12	1965-10-12 00:00:00	32020		\N	309356	0	10509002	260139		0
78603	4655	28060	1962-12-09	1962-12-09 00:00:00	1962-12-19	1962-12-19 00:00:00	32020		\N	310263	0	43878008	28060		0
78719	4662	4283893	1984-10-30	1984-10-30 00:00:00	1985-01-22	1985-01-22 00:00:00	32020		\N	310732	0	36971009	4283893		0
78998	4677	260139	1984-12-13	1984-12-13 00:00:00	1984-12-27	1984-12-27 00:00:00	32020		\N	311654	0	10509002	260139		0
79084	4680	40481087	1980-05-09	1980-05-09 00:00:00	1980-05-30	1980-05-30 00:00:00	32020		\N	311887	0	444814009	40481087		0
79301	4696	40481087	1968-12-13	1968-12-13 00:00:00	1968-12-27	1968-12-27 00:00:00	32020		\N	312821	0	444814009	40481087		0
79492	4707	4112343	2000-02-25	2000-02-25 00:00:00	2000-03-05	2000-03-05 00:00:00	32020		\N	313593	0	195662009	4112343		0
69036	4086	40481087	1994-07-15	1994-07-15 00:00:00	1994-07-29	1994-07-29 00:00:00	32020		\N	271595	0	444814009	40481087		0
79723	4722	4112343	1990-09-07	1990-09-07 00:00:00	1990-09-20	1990-09-20 00:00:00	32020		\N	314541	0	195662009	4112343		0
69508	4113	4237458	1969-03-31	1969-03-31 00:00:00	1969-04-30	1969-04-30 00:00:00	32020		\N	273386	0	58150001	4237458		0
69685	4123	4059173	1977-11-10	1977-11-10 00:00:00	1978-01-09	1978-01-09 00:00:00	32020		\N	274116	0	16114001	4059173		0
80453	4764	372328	1971-01-08	1971-01-08 00:00:00	1971-01-22	1971-01-22 00:00:00	32020		\N	317504	0	65363002	372328		0
80765	4791	260139	2016-06-04	2016-06-04 00:00:00	2016-06-18	2016-06-18 00:00:00	32020		\N	318793	0	10509002	260139		0
80962	4802	4112343	2009-08-11	2009-08-11 00:00:00	2009-08-23	2009-08-23 00:00:00	32020		\N	319439	0	195662009	4112343		0
81406	4827	40481087	2014-03-31	2014-03-31 00:00:00	2014-04-14	2014-04-14 00:00:00	32020		\N	321127	0	444814009	40481087		0
81547	4837	260139	2008-05-29	2008-05-29 00:00:00	2008-06-12	2008-06-12 00:00:00	32020		\N	321839	0	10509002	260139		0
71185	4222	4266809	1987-01-28	1987-01-28 00:00:00	\N	\N	32020		\N	280298	0	397881000	4266809		0
81959	4859	4112343	1983-06-10	1983-06-10 00:00:00	1983-06-23	1983-06-23 00:00:00	32020		\N	323269	0	195662009	4112343		0
71545	4243	260139	1993-11-06	1993-11-06 00:00:00	1993-11-20	1993-11-20 00:00:00	32020		\N	281851	0	10509002	260139		0
82278	4881	81151	1952-05-21	1952-05-21 00:00:00	1952-06-18	1952-06-18 00:00:00	32020		\N	324520	0	44465007	81151		0
82387	4886	4310024	2000-02-25	2000-02-25 00:00:00	\N	\N	32020		\N	324945	0	424802006	4310024		0
82554	4898	4283893	1956-03-07	1956-03-07 00:00:00	1956-03-28	1956-03-28 00:00:00	32020		\N	325690	0	36971009	4283893		0
72190	4283	4112343	1996-01-27	1996-01-27 00:00:00	1996-02-08	1996-02-08 00:00:00	32020		\N	284290	0	195662009	4112343		0
82867	4922	40481087	2000-07-10	2000-07-10 00:00:00	2000-07-17	2000-07-17 00:00:00	32020		\N	327050	0	444814009	40481087		0
83306	4949	372328	1977-11-08	1977-11-08 00:00:00	1978-09-07	1978-09-07 00:00:00	32020		\N	329030	0	65363002	372328		0
83412	4957	40481087	2017-01-24	2017-01-24 00:00:00	2017-01-31	2017-01-31 00:00:00	32020		\N	329535	0	444814009	40481087		0
83770	4976	260139	1982-09-21	1982-09-21 00:00:00	1982-10-05	1982-10-05 00:00:00	32020		\N	331037	0	10509002	260139		0
83936	4987	30753	1996-06-09	1996-06-09 00:00:00	\N	\N	32020		\N	331768	0	16761005	30753		0
84160	4999	28060	1968-05-20	1968-05-20 00:00:00	1968-06-02	1968-06-02 00:00:00	32020		\N	332444	0	43878008	28060		0
73689	4379	260139	1975-06-17	1975-06-17 00:00:00	1975-06-24	1975-06-24 00:00:00	32020		\N	290970	0	10509002	260139		0
84452	5022	4112343	1975-04-25	1975-04-25 00:00:00	1975-05-02	1975-05-02 00:00:00	32020		\N	333664	0	195662009	4112343		0
84767	5041	4142905	2013-01-17	2013-01-17 00:00:00	2013-03-18	2013-03-18 00:00:00	32020		\N	334921	0	33737001	4142905		0
84982	5053	378001	2016-05-30	2016-05-30 00:00:00	2016-06-29	2016-06-29 00:00:00	32020		\N	336024	0	62106007	378001		0
85038	5056	381316	2003-05-22	2003-05-22 00:00:00	\N	\N	32020		\N	336194	0	230690007	381316		0
85182	5066	4294548	2018-07-22	2018-07-22 00:00:00	2018-10-28	2018-10-28 00:00:00	32020		\N	336756	0	75498004	4294548		0
74783	4442	4112343	1999-11-23	1999-11-23 00:00:00	1999-11-30	1999-11-30 00:00:00	32020		\N	295287	0	195662009	4112343		0
74924	4450	28060	1975-12-11	1975-12-11 00:00:00	1975-12-21	1975-12-21 00:00:00	32020		\N	296091	0	43878008	28060		0
75045	4456	80180	1998-03-07	1998-03-07 00:00:00	\N	\N	32020		\N	296603	0	396275006	80180		0
75315	4472	4109685	2000-12-18	2000-12-18 00:00:00	2001-01-08	2001-01-08 00:00:00	32020		\N	297545	0	284551006	4109685		0
64845	3834	4112343	1973-04-27	1973-04-27 00:00:00	1973-05-08	1973-05-08 00:00:00	32020		\N	254604	0	195662009	4112343		0
75579	4485	40481087	1970-10-26	1970-10-26 00:00:00	1970-11-16	1970-11-16 00:00:00	32020		\N	298584	0	444814009	40481087		0
75706	4490	28060	1971-03-29	1971-03-29 00:00:00	1971-04-07	1971-04-07 00:00:00	32020		\N	298917	0	43878008	28060		0
75865	4500	4112343	1968-09-08	1968-09-08 00:00:00	1968-09-21	1968-09-21 00:00:00	32020		\N	299547	0	195662009	4112343		0
76090	4514	40481087	1990-11-21	1990-11-21 00:00:00	1990-12-05	1990-12-05 00:00:00	32020		\N	300655	0	444814009	40481087		0
76326	4527	4059173	2011-09-02	2011-09-02 00:00:00	2011-12-01	2011-12-01 00:00:00	32020		\N	301446	0	16114001	4059173		0
76499	4534	4329847	2011-11-30	2011-11-30 00:00:00	\N	\N	32020		\N	302079	0	22298006	4329847		0
76636	4543	375671	1997-03-28	1997-03-28 00:00:00	1997-05-27	1997-05-27 00:00:00	32020		\N	302641	0	62564004	375671		0
76758	4548	81151	2000-01-11	2000-01-11 00:00:00	2000-02-08	2000-02-08 00:00:00	32020		\N	303026	0	44465007	81151		0
76927	4559	260139	1950-09-21	1950-09-21 00:00:00	1950-10-05	1950-10-05 00:00:00	32020		\N	303734	0	10509002	260139		0
66566	3939	40481087	1987-07-22	1987-07-22 00:00:00	1987-08-12	1987-08-12 00:00:00	32020		\N	261863	0	444814009	40481087		0
77343	4580	40481087	1996-09-25	1996-09-25 00:00:00	1996-10-02	1996-10-02 00:00:00	32020		\N	305121	0	444814009	40481087		0
77490	4591	81151	1977-08-13	1977-08-13 00:00:00	1977-08-27	1977-08-27 00:00:00	32020		\N	305895	0	44465007	81151		0
77611	4596	260139	1988-01-15	1988-01-15 00:00:00	1988-01-29	1988-01-29 00:00:00	32020		\N	306322	0	10509002	260139		0
77761	4606	78272	1992-05-12	1992-05-12 00:00:00	1992-06-09	1992-06-09 00:00:00	32020		\N	306865	0	70704007	78272		0
88571	5265	81151	1982-08-21	1982-08-21 00:00:00	1982-09-25	1982-09-25 00:00:00	32020		\N	350328	0	44465007	81151		0
78092	4626	80180	2009-11-09	2009-11-09 00:00:00	\N	\N	32020		\N	308206	0	396275006	80180		0
78221	4631	28060	2009-09-08	2009-09-08 00:00:00	2009-09-17	2009-09-17 00:00:00	32020		\N	308643	0	43878008	28060		0
78405	4642	4112343	2008-01-18	2008-01-18 00:00:00	2008-01-28	2008-01-28 00:00:00	32020		\N	309489	0	195662009	4112343		0
78604	4655	4296204	1980-01-14	1980-01-14 00:00:00	1980-02-04	1980-02-04 00:00:00	32020		\N	310300	0	403190006	4296204		0
78720	4662	4112343	1971-11-21	1971-11-21 00:00:00	1971-11-30	1971-11-30 00:00:00	32020		\N	310730	0	195662009	4112343		0
78999	4677	40481087	1998-02-22	1998-02-22 00:00:00	1998-03-08	1998-03-08 00:00:00	32020		\N	311649	0	444814009	40481087		0
79086	4682	4156265	2000-09-09	2000-09-09 00:00:00	2000-09-23	2000-09-23 00:00:00	32020		\N	312043	0	370247008	4156265		0
79302	4696	28060	1953-02-02	1953-02-02 00:00:00	1953-02-11	1953-02-11 00:00:00	32020		\N	312820	0	43878008	28060		0
79493	4707	4278672	2018-07-12	2018-07-12 00:00:00	2018-09-10	2018-09-10 00:00:00	32020		\N	313555	0	65966004	4278672		0
69037	4086	258780	2007-06-07	2007-06-07 00:00:00	\N	\N	32020		\N	271609	0	185086009	258780		0
79724	4722	257012	1945-10-15	1945-10-15 00:00:00	\N	\N	32020		\N	314573	0	40055000	257012		0
69509	4113	260139	1958-07-08	1958-07-08 00:00:00	1958-07-15	1958-07-15 00:00:00	32020		\N	273454	0	10509002	260139		0
69686	4123	260139	1984-10-24	1984-10-24 00:00:00	1984-11-07	1984-11-07 00:00:00	32020		\N	274084	0	10509002	260139		0
80454	4764	4112343	2015-03-02	2015-03-02 00:00:00	2015-03-14	2015-03-14 00:00:00	32020		\N	317511	0	195662009	4112343		0
80766	4791	372328	1969-11-10	1969-11-10 00:00:00	1970-03-19	1970-03-19 00:00:00	32020		\N	318816	0	65363002	372328		0
80963	4802	260139	2003-05-17	2003-05-17 00:00:00	2003-05-31	2003-05-31 00:00:00	32020		\N	319455	0	10509002	260139		0
81407	4828	372328	1972-02-20	1972-02-20 00:00:00	1972-04-18	1972-04-18 00:00:00	32020		\N	321241	0	65363002	372328		0
81548	4837	4112343	1966-05-09	1966-05-09 00:00:00	1966-05-19	1966-05-19 00:00:00	32020		\N	321837	0	195662009	4112343		0
71186	4222	80180	1987-01-28	1987-01-28 00:00:00	\N	\N	32020		\N	280298	0	396275006	80180		0
81960	4859	40481087	1997-12-18	1997-12-18 00:00:00	1997-12-25	1997-12-25 00:00:00	32020		\N	323234	0	444814009	40481087		0
71546	4243	260139	2015-05-11	2015-05-11 00:00:00	2015-05-18	2015-05-18 00:00:00	32020		\N	281861	0	10509002	260139		0
82279	4881	80180	1988-11-18	1988-11-18 00:00:00	\N	\N	32020		\N	324529	0	396275006	80180		0
82388	4886	260139	1984-03-10	1984-03-10 00:00:00	1984-03-17	1984-03-17 00:00:00	32020		\N	324937	0	10509002	260139		0
82555	4898	80180	1997-11-22	1997-11-22 00:00:00	\N	\N	32020		\N	325734	0	396275006	80180		0
72191	4283	80180	1990-12-15	1990-12-15 00:00:00	\N	\N	32020		\N	284270	0	396275006	80180		0
82868	4922	4048695	2013-11-15	2013-11-15 00:00:00	2014-01-15	2014-01-15 00:00:00	32020		\N	327004	0	15724005	4048695		0
83307	4949	4112343	2017-06-11	2017-06-11 00:00:00	2017-06-23	2017-06-23 00:00:00	32020		\N	329010	0	195662009	4112343		0
83413	4957	260139	1977-02-04	1977-02-04 00:00:00	1977-02-11	1977-02-11 00:00:00	32020		\N	329513	0	10509002	260139		0
83771	4976	40481087	1952-10-10	1952-10-10 00:00:00	1952-10-31	1952-10-31 00:00:00	32020		\N	330989	0	444814009	40481087		0
83937	4987	40481087	1996-02-18	1996-02-18 00:00:00	1996-03-10	1996-03-10 00:00:00	32020		\N	331768	0	444814009	40481087		0
84161	4999	4112343	1996-08-07	1996-08-07 00:00:00	1996-08-19	1996-08-19 00:00:00	32020		\N	332461	0	195662009	4112343		0
73690	4379	4283893	1969-11-19	1969-11-19 00:00:00	1969-12-10	1969-12-10 00:00:00	32020		\N	290936	0	36971009	4283893		0
84453	5022	40481087	2013-01-20	2013-01-20 00:00:00	2013-01-27	2013-01-27 00:00:00	32020		\N	333646	0	444814009	40481087		0
84768	5041	4112343	1976-12-05	1976-12-05 00:00:00	1976-12-15	1976-12-15 00:00:00	32020		\N	334915	0	195662009	4112343		0
84983	5053	4112343	1956-12-08	1956-12-08 00:00:00	1956-12-20	1956-12-20 00:00:00	32020		\N	336039	0	195662009	4112343		0
85039	5056	40481087	2011-07-31	2011-07-31 00:00:00	2011-08-14	2011-08-14 00:00:00	32020		\N	336127	0	444814009	40481087		0
85183	5066	81151	1982-08-15	1982-08-15 00:00:00	1982-09-05	1982-09-05 00:00:00	32020		\N	336804	0	44465007	81151		0
74784	4442	4283893	1999-05-25	1999-05-25 00:00:00	1999-09-28	1999-09-28 00:00:00	32020		\N	295296	0	36971009	4283893		0
74925	4450	40481087	2008-03-16	2008-03-16 00:00:00	2008-03-23	2008-03-23 00:00:00	32020		\N	296072	0	444814009	40481087		0
75046	4456	4283893	2009-07-30	2009-07-30 00:00:00	2009-09-17	2009-09-17 00:00:00	32020		\N	296587	0	36971009	4283893		0
75316	4473	372328	1991-02-27	1991-02-27 00:00:00	1993-09-26	1993-09-26 00:00:00	32020		\N	297597	0	65363002	372328		0
64846	3834	317576	2003-08-10	2003-08-10 00:00:00	\N	\N	32020		\N	254576	0	53741008	317576		0
75580	4485	260139	2002-08-22	2002-08-22 00:00:00	2002-08-29	2002-08-29 00:00:00	32020		\N	298599	0	10509002	260139		0
75707	4491	4278672	1952-02-02	1952-02-02 00:00:00	1952-05-02	1952-05-02 00:00:00	32020		\N	299023	0	65966004	4278672		0
75866	4500	40481087	2005-12-09	2005-12-09 00:00:00	2005-12-16	2005-12-16 00:00:00	32020		\N	299580	0	444814009	40481087		0
76091	4514	40481087	2008-06-08	2008-06-08 00:00:00	2008-06-29	2008-06-29 00:00:00	32020		\N	300610	0	444814009	40481087		0
76327	4527	4112343	2016-09-22	2016-09-22 00:00:00	2016-09-30	2016-09-30 00:00:00	32020		\N	301430	0	195662009	4112343		0
76500	4534	4112343	1959-12-26	1959-12-26 00:00:00	1960-01-02	1960-01-02 00:00:00	32020		\N	302083	0	195662009	4112343		0
76637	4543	40481087	1998-11-16	1998-11-16 00:00:00	1998-11-30	1998-11-30 00:00:00	32020		\N	302644	0	444814009	40481087		0
76759	4548	317576	2018-07-03	2018-07-03 00:00:00	\N	\N	32020		\N	303071	0	53741008	317576		0
76928	4559	80180	1983-05-29	1983-05-29 00:00:00	\N	\N	32020		\N	303736	0	396275006	80180		0
77025	4562	260139	1985-04-30	1985-04-30 00:00:00	1985-05-07	1985-05-07 00:00:00	32020		\N	304041	0	10509002	260139		0
77344	4580	78272	1993-10-10	1993-10-10 00:00:00	1993-10-24	1993-10-24 00:00:00	32020		\N	305078	0	70704007	78272		0
77491	4591	4112343	1991-12-26	1991-12-26 00:00:00	1992-01-07	1992-01-07 00:00:00	32020		\N	305930	0	195662009	4112343		0
77612	4596	78272	2016-01-09	2016-01-09 00:00:00	2016-02-06	2016-02-06 00:00:00	32020		\N	306271	0	70704007	78272		0
77762	4606	4113008	2006-10-24	2006-10-24 00:00:00	2006-11-07	2006-11-07 00:00:00	32020		\N	306866	0	284549007	4113008		0
88572	5265	40481087	2008-04-14	2008-04-14 00:00:00	2008-05-05	2008-05-05 00:00:00	32020		\N	350304	0	444814009	40481087		0
78100	4628	40481087	1984-07-13	1984-07-13 00:00:00	1984-07-20	1984-07-20 00:00:00	32020		\N	308355	0	444814009	40481087		0
78222	4631	317576	2015-09-18	2015-09-18 00:00:00	\N	\N	32020		\N	308680	0	53741008	317576		0
78406	4642	40481087	1991-10-14	1991-10-14 00:00:00	1991-11-04	1991-11-04 00:00:00	32020		\N	309362	0	444814009	40481087		0
78605	4655	4027663	1983-12-08	1983-12-08 00:00:00	\N	\N	32020		\N	310381	0	13200003	4027663		0
78721	4662	40481087	1974-09-25	1974-09-25 00:00:00	1974-10-09	1974-10-09 00:00:00	32020		\N	310787	0	444814009	40481087		0
79000	4677	4112343	1983-11-06	1983-11-06 00:00:00	1983-11-13	1983-11-13 00:00:00	32020		\N	311646	0	195662009	4112343		0
79087	4682	372328	1981-02-07	1981-02-07 00:00:00	1981-02-21	1981-02-21 00:00:00	32020		\N	312001	0	65363002	372328		0
79303	4696	81151	1966-01-08	1966-01-08 00:00:00	1966-01-29	1966-01-29 00:00:00	32020		\N	312835	0	44465007	81151		0
79496	4709	4112343	1969-12-10	1969-12-10 00:00:00	1969-12-20	1969-12-20 00:00:00	32020		\N	313689	0	195662009	4112343		0
69038	4086	4152936	1990-03-19	1990-03-19 00:00:00	1990-04-10	1990-04-10 00:00:00	32020		\N	271573	0	283385000	4152936		0
79725	4722	378001	1915-03-06	1915-03-06 00:00:00	1915-05-05	1915-05-05 00:00:00	32020		\N	314552	0	62106007	378001		0
69510	4113	40481087	1992-11-16	1992-11-16 00:00:00	1992-11-30	1992-11-30 00:00:00	32020		\N	273461	0	444814009	40481087		0
69687	4123	40481087	1991-12-21	1991-12-21 00:00:00	1992-01-11	1992-01-11 00:00:00	32020		\N	274085	0	444814009	40481087		0
80455	4764	4112343	2013-12-27	2013-12-27 00:00:00	2014-01-05	2014-01-05 00:00:00	32020		\N	317485	0	195662009	4112343		0
80767	4791	40481087	2011-12-19	2011-12-19 00:00:00	2012-01-02	2012-01-02 00:00:00	32020		\N	318792	0	444814009	40481087		0
80964	4802	4294548	1968-08-02	1968-08-02 00:00:00	1968-10-31	1968-10-31 00:00:00	32020		\N	319484	0	75498004	4294548		0
81408	4828	4112343	1989-06-06	1989-06-06 00:00:00	1989-06-19	1989-06-19 00:00:00	32020		\N	321238	0	195662009	4112343		0
81549	4837	260139	1979-01-15	1979-01-15 00:00:00	1979-01-29	1979-01-29 00:00:00	32020		\N	321820	0	10509002	260139		0
71187	4222	4116491	1970-06-11	1970-06-11 00:00:00	1970-07-12	1970-07-12 00:00:00	32020		\N	280339	0	301011002	4116491		0
81961	4859	81151	1958-11-30	1958-11-30 00:00:00	1958-12-14	1958-12-14 00:00:00	32020		\N	323287	0	44465007	81151		0
82005	4861	40481087	1962-08-05	1962-08-05 00:00:00	1962-08-12	1962-08-12 00:00:00	32020		\N	323422	0	444814009	40481087		0
82280	4881	28060	1957-05-10	1957-05-10 00:00:00	1957-05-17	1957-05-17 00:00:00	32020		\N	324536	0	43878008	28060		0
82389	4886	40481087	2017-11-22	2017-11-22 00:00:00	2017-12-06	2017-12-06 00:00:00	32020		\N	324905	0	444814009	40481087		0
82556	4898	192671	1998-01-09	1998-01-09 00:00:00	\N	\N	32020		\N	325676	0	K92.2	35208414		0
72192	4283	4278672	1961-06-27	1961-06-27 00:00:00	1961-07-27	1961-07-27 00:00:00	32020		\N	284274	0	65966004	4278672		0
82869	4922	195588	2002-09-14	2002-09-14 00:00:00	2002-10-21	2002-10-21 00:00:00	32020		\N	327038	0	38822007	195588		0
83308	4949	4112343	1975-09-09	1975-09-09 00:00:00	1975-09-20	1975-09-20 00:00:00	32020		\N	329001	0	195662009	4112343		0
83436	4960	4294548	1965-02-03	1965-02-03 00:00:00	1965-02-24	1965-02-24 00:00:00	32020		\N	329751	0	75498004	4294548		0
83772	4976	40481087	1962-04-19	1962-04-19 00:00:00	1962-05-03	1962-05-03 00:00:00	32020		\N	331034	0	444814009	40481087		0
83938	4987	4112343	1967-05-09	1967-05-09 00:00:00	1967-05-16	1967-05-16 00:00:00	32020		\N	331764	0	195662009	4112343		0
84162	4999	375671	2002-04-21	2002-04-21 00:00:00	2002-06-20	2002-06-20 00:00:00	32020		\N	332470	0	62564004	375671		0
73691	4379	28060	2003-12-29	2003-12-29 00:00:00	2004-01-09	2004-01-09 00:00:00	32020		\N	290974	0	43878008	28060		0
84454	5022	4155034	1992-01-07	1992-01-07 00:00:00	1992-01-28	1992-01-28 00:00:00	32020		\N	333661	0	283371005	4155034		0
84769	5041	4266809	2013-10-04	2013-10-04 00:00:00	\N	\N	32020		\N	334964	0	397881000	4266809		0
84984	5053	40481087	1972-03-22	1972-03-22 00:00:00	1972-04-12	1972-04-12 00:00:00	32020		\N	336009	0	444814009	40481087		0
85040	5056	40481087	1974-09-01	1974-09-01 00:00:00	1974-09-15	1974-09-15 00:00:00	32020		\N	336198	0	444814009	40481087		0
85184	5066	4035415	1983-08-31	1983-08-31 00:00:00	1983-10-30	1983-10-30 00:00:00	32020		\N	336805	0	239720000	4035415		0
74785	4442	4112343	2007-02-22	2007-02-22 00:00:00	2007-03-04	2007-03-04 00:00:00	32020		\N	295322	0	195662009	4112343		0
74926	4450	80180	2008-12-19	2008-12-19 00:00:00	\N	\N	32020		\N	296072	0	396275006	80180		0
75047	4456	260139	1967-02-09	1967-02-09 00:00:00	1967-02-23	1967-02-23 00:00:00	32020		\N	296550	0	10509002	260139		0
75317	4473	4116491	1999-07-18	1999-07-18 00:00:00	1999-09-04	1999-09-04 00:00:00	32020		\N	297565	0	301011002	4116491		0
64847	3834	4112343	2004-12-27	2004-12-27 00:00:00	2005-01-05	2005-01-05 00:00:00	32020		\N	254625	0	195662009	4112343		0
75581	4485	4283893	2019-03-24	2019-03-24 00:00:00	2019-06-02	2019-06-02 00:00:00	32020		\N	298571	0	36971009	4283893		0
75708	4491	4112343	1983-04-09	1983-04-09 00:00:00	1983-04-17	1983-04-17 00:00:00	32020		\N	299017	0	195662009	4112343		0
75867	4500	4112343	2008-06-02	2008-06-02 00:00:00	2008-06-15	2008-06-15 00:00:00	32020		\N	299657	0	195662009	4112343		0
76092	4514	378001	1990-12-14	1990-12-14 00:00:00	1991-01-13	1991-01-13 00:00:00	32020		\N	300591	0	62106007	378001		0
76328	4527	40481087	2004-09-21	2004-09-21 00:00:00	2004-09-28	2004-09-28 00:00:00	32020		\N	301415	0	444814009	40481087		0
76501	4534	28060	1955-02-03	1955-02-03 00:00:00	1955-02-16	1955-02-16 00:00:00	32020		\N	302082	0	43878008	28060		0
76638	4543	40481087	2014-01-06	2014-01-06 00:00:00	2014-01-20	2014-01-20 00:00:00	32020		\N	302605	0	444814009	40481087		0
76760	4548	260139	1989-06-27	1989-06-27 00:00:00	1989-07-04	1989-07-04 00:00:00	32020		\N	303106	0	10509002	260139		0
76929	4559	40481087	1983-01-28	1983-01-28 00:00:00	1983-02-04	1983-02-04 00:00:00	32020		\N	303736	0	444814009	40481087		0
77026	4562	372328	1963-02-17	1963-02-17 00:00:00	1963-07-06	1963-07-06 00:00:00	32020		\N	304021	0	65363002	372328		0
77345	4580	260139	1984-06-18	1984-06-18 00:00:00	1984-06-25	1984-06-25 00:00:00	32020		\N	305114	0	10509002	260139		0
77492	4591	4310024	1993-08-04	1993-08-04 00:00:00	\N	\N	32020		\N	305930	0	424802006	4310024		0
77613	4596	40481087	1954-07-02	1954-07-02 00:00:00	1954-07-23	1954-07-23 00:00:00	32020		\N	306253	0	444814009	40481087		0
77763	4606	4112343	2003-09-01	2003-09-01 00:00:00	2003-09-08	2003-09-08 00:00:00	32020		\N	306859	0	195662009	4112343		0
88573	5265	4112343	2007-08-23	2007-08-23 00:00:00	2007-09-05	2007-09-05 00:00:00	32020		\N	350283	0	195662009	4112343		0
78101	4628	4112343	1992-10-31	1992-10-31 00:00:00	1992-11-09	1992-11-09 00:00:00	32020		\N	308357	0	195662009	4112343		0
78223	4631	4237458	1929-10-09	1929-10-09 00:00:00	1929-12-08	1929-12-08 00:00:00	32020		\N	308553	0	58150001	4237458		0
78407	4642	40481087	1994-09-18	1994-09-18 00:00:00	1994-10-02	1994-10-02 00:00:00	32020		\N	309488	0	444814009	40481087		0
78606	4655	260139	1998-06-14	1998-06-14 00:00:00	1998-06-28	1998-06-28 00:00:00	32020		\N	310369	0	10509002	260139		0
78722	4662	260139	2003-12-27	2003-12-27 00:00:00	2004-01-03	2004-01-03 00:00:00	32020		\N	310734	0	10509002	260139		0
79001	4677	40481087	2008-08-11	2008-08-11 00:00:00	2008-08-18	2008-08-18 00:00:00	32020		\N	311697	0	444814009	40481087		0
79088	4682	260139	2005-04-02	2005-04-02 00:00:00	2005-04-09	2005-04-09 00:00:00	32020		\N	312035	0	10509002	260139		0
79304	4696	40481087	1994-06-21	1994-06-21 00:00:00	1994-07-12	1994-07-12 00:00:00	32020		\N	312897	0	444814009	40481087		0
79497	4709	40481087	2008-10-26	2008-10-26 00:00:00	2008-11-02	2008-11-02 00:00:00	32020		\N	313703	0	444814009	40481087		0
69039	4086	40481087	1998-01-16	1998-01-16 00:00:00	1998-02-06	1998-02-06 00:00:00	32020		\N	271596	0	444814009	40481087		0
79726	4722	4134304	1984-04-09	1984-04-09 00:00:00	1984-05-09	1984-05-09 00:00:00	32020		\N	314613	0	263102004	4134304		0
69511	4113	260139	1978-05-25	1978-05-25 00:00:00	1978-06-01	1978-06-01 00:00:00	32020		\N	273456	0	10509002	260139		0
69688	4123	4027663	1992-06-17	1992-06-17 00:00:00	\N	\N	32020		\N	274085	0	13200003	4027663		0
80456	4764	40481087	1973-10-31	1973-10-31 00:00:00	1973-11-07	1973-11-07 00:00:00	32020		\N	317483	0	444814009	40481087		0
80768	4791	40481087	1970-12-02	1970-12-02 00:00:00	1970-12-16	1970-12-16 00:00:00	32020		\N	318774	0	444814009	40481087		0
80965	4802	40481087	2016-11-02	2016-11-02 00:00:00	2016-11-15	2016-11-15 00:00:00	32020		\N	319462	0	444814009	40481087		0
81409	4828	4283893	1980-05-16	1980-05-16 00:00:00	1980-06-20	1980-06-20 00:00:00	32020		\N	321247	0	36971009	4283893		0
81550	4837	28060	1956-08-15	1956-08-15 00:00:00	1956-08-25	1956-08-25 00:00:00	32020		\N	321836	0	43878008	28060		0
71188	4223	372328	1962-11-01	1962-11-01 00:00:00	1963-01-11	1963-01-11 00:00:00	32020		\N	280385	0	65363002	372328		0
81962	4859	4112343	1980-11-07	1980-11-07 00:00:00	1980-11-19	1980-11-19 00:00:00	32020		\N	323249	0	195662009	4112343		0
82006	4861	372328	1948-04-23	1948-04-23 00:00:00	1948-05-08	1948-05-08 00:00:00	32020		\N	323411	0	65363002	372328		0
82281	4881	40479768	1981-12-18	1981-12-18 00:00:00	1982-02-23	1982-02-23 00:00:00	32020		\N	324545	0	444470001	40479768		0
82390	4886	257012	1989-10-16	1989-10-16 00:00:00	\N	\N	32020		\N	324878	0	40055000	257012		0
82557	4898	4112343	1978-03-28	1978-03-28 00:00:00	1978-04-06	1978-04-06 00:00:00	32020		\N	325694	0	195662009	4112343		0
72193	4283	40481087	2001-11-15	2001-11-15 00:00:00	2001-11-29	2001-11-29 00:00:00	32020		\N	284238	0	444814009	40481087		0
82870	4922	40481087	2018-11-30	2018-11-30 00:00:00	2018-12-07	2018-12-07 00:00:00	32020		\N	327046	0	444814009	40481087		0
83309	4949	4112343	1977-04-16	1977-04-16 00:00:00	1977-04-26	1977-04-26 00:00:00	32020		\N	329004	0	195662009	4112343		0
83437	4960	40481087	1984-11-19	1984-11-19 00:00:00	1984-12-10	1984-12-10 00:00:00	32020		\N	329753	0	444814009	40481087		0
83773	4976	40481087	1938-12-09	1938-12-09 00:00:00	1938-12-16	1938-12-16 00:00:00	32020		\N	330988	0	444814009	40481087		0
83939	4987	40481087	2018-10-17	2018-10-17 00:00:00	2018-11-07	2018-11-07 00:00:00	32020		\N	331761	0	444814009	40481087		0
73692	4379	4112343	2009-02-25	2009-02-25 00:00:00	2009-03-07	2009-03-07 00:00:00	32020		\N	290984	0	195662009	4112343		0
84455	5022	81151	1974-04-29	1974-04-29 00:00:00	1974-05-27	1974-05-27 00:00:00	32020		\N	333657	0	44465007	81151		0
84770	5041	80180	2013-10-04	2013-10-04 00:00:00	\N	\N	32020		\N	334964	0	396275006	80180		0
84985	5053	4155034	2013-09-22	2013-09-22 00:00:00	2013-10-13	2013-10-13 00:00:00	32020		\N	336023	0	283371005	4155034		0
85041	5056	378419	2012-08-23	2012-08-23 00:00:00	\N	\N	32020		\N	336138	0	26929004	378419		0
85185	5066	372328	1971-08-15	1971-08-15 00:00:00	1972-03-18	1972-03-18 00:00:00	32020		\N	336788	0	65363002	372328		0
74786	4442	4112343	1993-05-14	1993-05-14 00:00:00	1993-05-25	1993-05-25 00:00:00	32020		\N	295286	0	195662009	4112343		0
74927	4450	4285898	2008-05-23	2008-05-23 00:00:00	\N	\N	32020		\N	296072	0	68496003	4285898		0
75048	4456	260139	1976-01-24	1976-01-24 00:00:00	1976-02-07	1976-02-07 00:00:00	32020		\N	296551	0	10509002	260139		0
75318	4473	40481087	1990-11-04	1990-11-04 00:00:00	1990-11-18	1990-11-18 00:00:00	32020		\N	297594	0	444814009	40481087		0
64848	3834	378001	2000-03-22	2000-03-22 00:00:00	2000-05-21	2000-05-21 00:00:00	32020		\N	254588	0	62106007	378001		0
75582	4485	40481087	1994-12-18	1994-12-18 00:00:00	1995-01-01	1995-01-01 00:00:00	32020		\N	298570	0	444814009	40481087		0
75709	4491	80502	2006-07-09	2006-07-09 00:00:00	\N	\N	32020		\N	299006	0	64859006	80502		0
75868	4500	40481087	1979-11-08	1979-11-08 00:00:00	1979-11-22	1979-11-22 00:00:00	32020		\N	299646	0	444814009	40481087		0
76093	4514	4134304	1979-04-16	1979-04-16 00:00:00	1979-07-15	1979-07-15 00:00:00	32020		\N	300590	0	263102004	4134304		0
76329	4527	40481087	1987-01-27	1987-01-27 00:00:00	1987-02-17	1987-02-17 00:00:00	32020		\N	301427	0	444814009	40481087		0
76502	4534	4112343	1990-08-08	1990-08-08 00:00:00	1990-08-18	1990-08-18 00:00:00	32020		\N	302099	0	195662009	4112343		0
76639	4543	40481087	1984-08-20	1984-08-20 00:00:00	1984-09-10	1984-09-10 00:00:00	32020		\N	302643	0	444814009	40481087		0
76761	4548	4218389	2010-06-15	2010-06-15 00:00:00	2010-07-06	2010-07-06 00:00:00	32020		\N	303027	0	39848009	4218389		0
76930	4559	81151	1947-03-09	1947-03-09 00:00:00	1947-03-23	1947-03-23 00:00:00	32020		\N	303803	0	44465007	81151		0
77027	4563	81151	1980-04-17	1980-04-17 00:00:00	1980-05-15	1980-05-15 00:00:00	32020		\N	304073	0	44465007	81151		0
87838	5228	78272	1939-01-21	1939-01-21 00:00:00	1939-02-11	1939-02-11 00:00:00	32020		\N	347852	0	70704007	78272		0
77493	4591	192671	1995-04-10	1995-04-10 00:00:00	\N	\N	32020		\N	305892	0	K92.2	35208414		0
77614	4596	313217	2013-04-14	2013-04-14 00:00:00	\N	\N	32020		\N	306282	0	49436004	313217		0
77764	4606	4112343	2010-06-07	2010-06-07 00:00:00	2010-06-14	2010-06-14 00:00:00	32020		\N	306849	0	195662009	4112343		0
88574	5265	378001	1978-08-12	1978-08-12 00:00:00	1978-09-11	1978-09-11 00:00:00	32020		\N	350327	0	62106007	378001		0
78102	4628	378001	1993-12-22	1993-12-22 00:00:00	1994-01-21	1994-01-21 00:00:00	32020		\N	308349	0	62106007	378001		0
78224	4631	378001	1986-08-23	1986-08-23 00:00:00	1986-09-22	1986-09-22 00:00:00	32020		\N	308557	0	62106007	378001		0
78408	4642	260139	1962-05-08	1962-05-08 00:00:00	1962-05-22	1962-05-22 00:00:00	32020		\N	309414	0	10509002	260139		0
78607	4655	28060	1970-03-27	1970-03-27 00:00:00	1970-04-06	1970-04-06 00:00:00	32020		\N	310380	0	43878008	28060		0
78723	4662	28060	1958-01-16	1958-01-16 00:00:00	1958-01-29	1958-01-29 00:00:00	32020		\N	310785	0	43878008	28060		0
79002	4677	260139	1967-12-23	1967-12-23 00:00:00	1967-12-30	1967-12-30 00:00:00	32020		\N	311696	0	10509002	260139		0
79089	4682	80180	2011-11-02	2011-11-02 00:00:00	\N	\N	32020		\N	311991	0	396275006	80180		0
79305	4696	4112343	2006-01-16	2006-01-16 00:00:00	2006-01-25	2006-01-25 00:00:00	32020		\N	312859	0	195662009	4112343		0
79498	4709	81151	2008-06-08	2008-06-08 00:00:00	2008-06-29	2008-06-29 00:00:00	32020		\N	313647	0	44465007	81151		0
69040	4086	4109685	1986-06-04	1986-06-04 00:00:00	1986-06-18	1986-06-18 00:00:00	32020		\N	271571	0	284551006	4109685		0
79727	4722	372328	2009-07-29	2009-07-29 00:00:00	2009-10-11	2009-10-11 00:00:00	32020		\N	314524	0	65363002	372328		0
69512	4113	4112343	1985-02-11	1985-02-11 00:00:00	1985-02-21	1985-02-21 00:00:00	32020		\N	273421	0	195662009	4112343		0
69689	4123	40481087	1994-12-31	1994-12-31 00:00:00	1995-01-07	1995-01-07 00:00:00	32020		\N	274147	0	444814009	40481087		0
80457	4764	40481087	1999-06-17	1999-06-17 00:00:00	1999-07-08	1999-07-08 00:00:00	32020		\N	317517	0	444814009	40481087		0
80769	4791	40481087	2009-07-13	2009-07-13 00:00:00	2009-07-27	2009-07-27 00:00:00	32020		\N	318814	0	444814009	40481087		0
80966	4802	4112343	2008-04-08	2008-04-08 00:00:00	2008-04-16	2008-04-16 00:00:00	32020		\N	319466	0	195662009	4112343		0
81410	4828	4152936	2000-11-02	2000-11-02 00:00:00	2000-11-23	2000-11-23 00:00:00	32020		\N	321254	0	283385000	4152936		0
81551	4837	40486433	1951-12-28	1951-12-28 00:00:00	1967-12-26	1967-12-26 00:00:00	32020		\N	321819	0	446096008	40486433		0
71189	4223	4112343	1984-07-25	1984-07-25 00:00:00	1984-08-05	1984-08-05 00:00:00	32020		\N	280360	0	195662009	4112343		0
81963	4859	4116491	2002-04-13	2002-04-13 00:00:00	2002-06-01	2002-06-01 00:00:00	32020		\N	323280	0	301011002	4116491		0
82007	4861	260139	2017-09-10	2017-09-10 00:00:00	2017-09-17	2017-09-17 00:00:00	32020		\N	323446	0	10509002	260139		0
82282	4881	78272	1984-11-09	1984-11-09 00:00:00	1984-12-07	1984-12-07 00:00:00	32020		\N	324546	0	70704007	78272		0
82391	4886	4294548	1989-07-10	1989-07-10 00:00:00	1990-01-15	1990-01-15 00:00:00	32020		\N	324877	0	75498004	4294548		0
82558	4899	372328	1924-07-24	1924-07-24 00:00:00	1925-05-12	1925-05-12 00:00:00	32020		\N	325842	0	65363002	372328		0
72194	4283	28060	1970-09-15	1970-09-15 00:00:00	1970-09-25	1970-09-25 00:00:00	32020		\N	284236	0	43878008	28060		0
82871	4922	4113008	2011-12-05	2011-12-05 00:00:00	2011-12-26	2011-12-26 00:00:00	32020		\N	327003	0	284549007	4113008		0
83310	4949	372328	1972-12-20	1972-12-20 00:00:00	1973-03-01	1973-03-01 00:00:00	32020		\N	329011	0	65363002	372328		0
83438	4960	80180	1949-11-28	1949-11-28 00:00:00	\N	\N	32020		\N	329743	0	396275006	80180		0
83774	4976	4152936	1950-12-05	1950-12-05 00:00:00	1950-12-19	1950-12-19 00:00:00	32020		\N	331103	0	283385000	4152936		0
83940	4987	4112343	2005-07-21	2005-07-21 00:00:00	2005-08-02	2005-08-02 00:00:00	32020		\N	331769	0	195662009	4112343		0
73693	4379	4294548	1973-04-29	1973-04-29 00:00:00	1973-05-27	1973-05-27 00:00:00	32020		\N	290937	0	75498004	4294548		0
84456	5022	260139	1987-08-29	1987-08-29 00:00:00	1987-09-12	1987-09-12 00:00:00	32020		\N	333694	0	10509002	260139		0
84786	5043	40481087	1975-03-16	1975-03-16 00:00:00	1975-03-23	1975-03-23 00:00:00	32020		\N	335154	0	444814009	40481087		0
85042	5056	40481087	1972-03-01	1972-03-01 00:00:00	1972-03-08	1972-03-08 00:00:00	32020		\N	336186	0	444814009	40481087		0
85186	5066	4134304	2015-02-28	2015-02-28 00:00:00	2015-03-30	2015-03-30 00:00:00	32020		\N	336814	0	263102004	4134304		0
74787	4442	260139	1994-03-10	1994-03-10 00:00:00	1994-03-17	1994-03-17 00:00:00	32020		\N	295295	0	10509002	260139		0
74928	4450	4266809	2008-12-19	2008-12-19 00:00:00	\N	\N	32020		\N	296072	0	397881000	4266809		0
75049	4456	260139	2010-03-31	2010-03-31 00:00:00	2010-04-14	2010-04-14 00:00:00	32020		\N	296579	0	10509002	260139		0
75319	4473	372328	1973-04-15	1973-04-15 00:00:00	1973-07-01	1973-07-01 00:00:00	32020		\N	297589	0	65363002	372328		0
64849	3834	4283893	1971-10-13	1971-10-13 00:00:00	1972-02-02	1972-02-02 00:00:00	32020		\N	254621	0	36971009	4283893		0
75583	4485	378001	1952-09-01	1952-09-01 00:00:00	1952-10-01	1952-10-01 00:00:00	32020		\N	298618	0	62106007	378001		0
75710	4491	4112343	1995-04-18	1995-04-18 00:00:00	1995-04-26	1995-04-26 00:00:00	32020		\N	299019	0	195662009	4112343		0
75869	4500	372328	1961-11-12	1961-11-12 00:00:00	1961-12-20	1961-12-20 00:00:00	32020		\N	299586	0	65363002	372328		0
76094	4514	4156265	1977-02-11	1977-02-11 00:00:00	1977-02-25	1977-02-25 00:00:00	32020		\N	300589	0	370247008	4156265		0
76349	4529	4152936	1985-04-25	1985-04-25 00:00:00	1985-05-09	1985-05-09 00:00:00	32020		\N	301560	0	283385000	4152936		0
76503	4534	28060	1953-01-01	1953-01-01 00:00:00	1953-01-13	1953-01-13 00:00:00	32020		\N	302086	0	43878008	28060		0
76640	4543	40481087	2018-05-06	2018-05-06 00:00:00	2018-05-20	2018-05-20 00:00:00	32020		\N	302606	0	444814009	40481087		0
76762	4548	40481087	1988-03-17	1988-03-17 00:00:00	1988-03-31	1988-03-31 00:00:00	32020		\N	303096	0	444814009	40481087		0
76931	4559	257012	2011-06-09	2011-06-09 00:00:00	\N	\N	32020		\N	303795	0	40055000	257012		0
77028	4563	40481087	2019-04-28	2019-04-28 00:00:00	2019-05-19	2019-05-19 00:00:00	32020		\N	304076	0	444814009	40481087		0
87839	5228	260139	1949-03-10	1949-03-10 00:00:00	1949-03-24	1949-03-24 00:00:00	32020		\N	347778	0	10509002	260139		0
77494	4591	260139	1964-06-18	1964-06-18 00:00:00	1964-06-25	1964-06-25 00:00:00	32020		\N	305924	0	10509002	260139		0
77615	4596	4296205	1951-10-16	1951-10-16 00:00:00	1951-11-13	1951-11-13 00:00:00	32020		\N	306266	0	403191005	4296205		0
77765	4606	260139	1990-10-09	1990-10-09 00:00:00	1990-10-16	1990-10-16 00:00:00	32020		\N	306857	0	10509002	260139		0
88575	5265	4112343	1973-09-26	1973-09-26 00:00:00	1973-10-07	1973-10-07 00:00:00	32020		\N	350274	0	195662009	4112343		0
78103	4628	40481087	2002-05-13	2002-05-13 00:00:00	2002-05-27	2002-05-27 00:00:00	32020		\N	308329	0	444814009	40481087		0
78225	4631	4109685	1995-03-09	1995-03-09 00:00:00	1995-03-23	1995-03-23 00:00:00	32020		\N	308558	0	284551006	4109685		0
78409	4642	40481087	2009-10-03	2009-10-03 00:00:00	2009-10-17	2009-10-17 00:00:00	32020		\N	309490	0	444814009	40481087		0
78608	4655	4156265	2009-04-28	2009-04-28 00:00:00	2009-05-12	2009-05-12 00:00:00	32020		\N	310304	0	370247008	4156265		0
78724	4662	4112343	2004-11-24	2004-11-24 00:00:00	2004-12-06	2004-12-06 00:00:00	32020		\N	310775	0	195662009	4112343		0
79003	4677	80180	1996-09-19	1996-09-19 00:00:00	\N	\N	32020		\N	311707	0	396275006	80180		0
79090	4682	260139	2008-05-24	2008-05-24 00:00:00	2008-06-07	2008-06-07 00:00:00	32020		\N	312025	0	10509002	260139		0
79306	4696	4112343	2005-01-11	2005-01-11 00:00:00	2005-01-19	2005-01-19 00:00:00	32020		\N	312858	0	195662009	4112343		0
79499	4709	372328	1961-11-15	1961-11-15 00:00:00	1962-04-23	1962-04-23 00:00:00	32020		\N	313696	0	65363002	372328		0
69041	4086	40481087	2010-12-07	2010-12-07 00:00:00	2010-12-21	2010-12-21 00:00:00	32020		\N	271597	0	444814009	40481087		0
79728	4722	4283893	1991-03-11	1991-03-11 00:00:00	1991-07-22	1991-07-22 00:00:00	32020		\N	314565	0	36971009	4283893		0
69513	4113	4112343	1972-02-27	1972-02-27 00:00:00	1972-03-08	1972-03-08 00:00:00	32020		\N	273394	0	195662009	4112343		0
69690	4123	4112343	1967-02-26	1967-02-26 00:00:00	1967-03-11	1967-03-11 00:00:00	32020		\N	274129	0	195662009	4112343		0
80458	4764	40481087	1983-07-07	1983-07-07 00:00:00	1983-07-21	1983-07-21 00:00:00	32020		\N	317492	0	444814009	40481087		0
80770	4791	40481087	2003-05-01	2003-05-01 00:00:00	2003-05-08	2003-05-08 00:00:00	32020		\N	318756	0	444814009	40481087		0
80967	4802	40481087	1988-06-17	1988-06-17 00:00:00	1988-06-24	1988-06-24 00:00:00	32020		\N	319454	0	444814009	40481087		0
81411	4828	40481087	1999-08-29	1999-08-29 00:00:00	1999-09-19	1999-09-19 00:00:00	32020		\N	321239	0	444814009	40481087		0
81552	4837	372328	1952-02-17	1952-02-17 00:00:00	1952-05-27	1952-05-27 00:00:00	32020		\N	321862	0	65363002	372328		0
71190	4223	28060	1969-11-15	1969-11-15 00:00:00	1969-11-26	1969-11-26 00:00:00	32020		\N	280358	0	43878008	28060		0
81964	4859	4294548	2010-04-18	2010-04-18 00:00:00	2011-01-16	2011-01-16 00:00:00	32020		\N	323281	0	75498004	4294548		0
82008	4861	317009	1982-06-02	1982-06-02 00:00:00	\N	\N	32020		\N	323415	0	195967001	317009		0
82283	4881	4112343	1957-02-27	1957-02-27 00:00:00	1957-03-09	1957-03-09 00:00:00	32020		\N	324524	0	195662009	4112343		0
82392	4886	4112343	1971-09-06	1971-09-06 00:00:00	1971-09-17	1971-09-17 00:00:00	32020		\N	324935	0	195662009	4112343		0
82559	4899	78272	1972-10-10	1972-10-10 00:00:00	1972-11-14	1972-11-14 00:00:00	32020		\N	325815	0	70704007	78272		0
72195	4283	40481087	2009-04-28	2009-04-28 00:00:00	2009-05-05	2009-05-05 00:00:00	32020		\N	284233	0	444814009	40481087		0
82872	4922	440086	1984-08-01	1984-08-01 00:00:00	1988-10-19	1988-10-19 00:00:00	32020		\N	327024	0	192127007	440086		0
83311	4949	372328	1973-08-28	1973-08-28 00:00:00	1973-11-29	1973-11-29 00:00:00	32020		\N	329029	0	65363002	372328		0
83439	4960	260139	1918-09-28	1918-09-28 00:00:00	1918-10-05	1918-10-05 00:00:00	32020		\N	329735	0	10509002	260139		0
83775	4976	4218389	1913-12-07	1913-12-07 00:00:00	1914-01-04	1914-01-04 00:00:00	32020		\N	330921	0	39848009	4218389		0
83941	4987	40481087	1970-06-22	1970-06-22 00:00:00	1970-06-29	1970-06-29 00:00:00	32020		\N	331755	0	444814009	40481087		0
73694	4379	260139	1986-11-25	1986-11-25 00:00:00	1986-12-02	1986-12-02 00:00:00	32020		\N	290940	0	10509002	260139		0
84457	5022	4230399	1984-05-04	1984-05-04 00:00:00	1984-06-03	1984-06-03 00:00:00	32020		\N	333659	0	359817006	4230399		0
84787	5043	260139	2013-09-16	2013-09-16 00:00:00	2013-09-30	2013-09-30 00:00:00	32020		\N	335158	0	10509002	260139		0
85043	5056	4112343	1983-08-29	1983-08-29 00:00:00	1983-09-07	1983-09-07 00:00:00	32020		\N	336199	0	195662009	4112343		0
85187	5067	40481087	1990-05-18	1990-05-18 00:00:00	1990-05-25	1990-05-25 00:00:00	32020		\N	336852	0	444814009	40481087		0
74788	4442	4146173	1989-11-21	1989-11-21 00:00:00	1990-01-20	1990-01-20 00:00:00	32020		\N	295282	0	307731004	4146173		0
74929	4450	30753	2008-01-24	2008-01-24 00:00:00	\N	\N	32020		\N	296085	0	16761005	30753		0
75050	4456	40481087	2018-04-11	2018-04-11 00:00:00	2018-04-25	2018-04-25 00:00:00	32020		\N	296588	0	444814009	40481087		0
75320	4473	40481087	1979-06-28	1979-06-28 00:00:00	1979-07-05	1979-07-05 00:00:00	32020		\N	297610	0	444814009	40481087		0
64850	3834	28060	1989-12-21	1989-12-21 00:00:00	1989-12-31	1989-12-31 00:00:00	32020		\N	254551	0	43878008	28060		0
75584	4485	372328	1951-07-09	1951-07-09 00:00:00	1951-09-20	1951-09-20 00:00:00	32020		\N	298543	0	65363002	372328		0
75711	4491	4027663	1973-01-06	1973-01-06 00:00:00	\N	\N	32020		\N	299002	0	13200003	4027663		0
75870	4500	4109685	2003-12-16	2003-12-16 00:00:00	2004-01-06	2004-01-06 00:00:00	32020		\N	299605	0	284551006	4109685		0
76095	4514	260139	1999-05-19	1999-05-19 00:00:00	1999-06-02	1999-06-02 00:00:00	32020		\N	300641	0	10509002	260139		0
76350	4529	80180	1997-08-30	1997-08-30 00:00:00	\N	\N	32020		\N	301561	0	396275006	80180		0
76504	4534	317576	2005-03-02	2005-03-02 00:00:00	\N	\N	32020		\N	302032	0	53741008	317576		0
76641	4543	80180	2017-10-13	2017-10-13 00:00:00	\N	\N	32020		\N	302616	0	396275006	80180		0
76763	4548	4112343	1998-01-03	1998-01-03 00:00:00	1998-01-11	1998-01-11 00:00:00	32020		\N	302999	0	195662009	4112343		0
76932	4559	40481087	1971-01-19	1971-01-19 00:00:00	1971-02-09	1971-02-09 00:00:00	32020		\N	303735	0	444814009	40481087		0
77029	4563	4142905	1981-04-10	1981-04-10 00:00:00	1981-07-09	1981-07-09 00:00:00	32020		\N	304074	0	33737001	4142905		0
87840	5228	40481087	1948-01-18	1948-01-18 00:00:00	1948-02-01	1948-02-01 00:00:00	32020		\N	347783	0	444814009	40481087		0
77495	4591	4112343	2016-06-16	2016-06-16 00:00:00	2016-06-28	2016-06-28 00:00:00	32020		\N	305932	0	195662009	4112343		0
77616	4596	40481087	2014-07-20	2014-07-20 00:00:00	2014-07-27	2014-07-27 00:00:00	32020		\N	306257	0	444814009	40481087		0
77766	4607	80180	2014-12-30	2014-12-30 00:00:00	\N	\N	32020		\N	306907	0	396275006	80180		0
88576	5265	260139	2018-12-15	2018-12-15 00:00:00	2018-12-29	2018-12-29 00:00:00	32020		\N	350285	0	10509002	260139		0
78104	4628	4112343	1979-12-16	1979-12-16 00:00:00	1979-12-25	1979-12-25 00:00:00	32020		\N	308354	0	195662009	4112343		0
78226	4631	4112343	1929-07-22	1929-07-22 00:00:00	1929-08-01	1929-08-01 00:00:00	32020		\N	308571	0	195662009	4112343		0
78410	4643	78272	1958-02-27	1958-02-27 00:00:00	1958-03-27	1958-03-27 00:00:00	32020		\N	309624	0	70704007	78272		0
78609	4655	40481087	1987-06-21	1987-06-21 00:00:00	1987-06-28	1987-06-28 00:00:00	32020		\N	310382	0	444814009	40481087		0
78725	4662	40481087	2006-06-06	2006-06-06 00:00:00	2006-06-27	2006-06-27 00:00:00	32020		\N	310740	0	444814009	40481087		0
79004	4677	4112343	2016-11-30	2016-11-30 00:00:00	2016-12-13	2016-12-13 00:00:00	32020		\N	311669	0	195662009	4112343		0
79091	4682	260139	1992-05-11	1992-05-11 00:00:00	1992-05-25	1992-05-25 00:00:00	32020		\N	312004	0	10509002	260139		0
79307	4696	4152936	2017-06-30	2017-06-30 00:00:00	2017-07-14	2017-07-14 00:00:00	32020		\N	312836	0	283385000	4152936		0
79500	4709	40481087	2018-12-15	2018-12-15 00:00:00	2018-12-22	2018-12-22 00:00:00	32020		\N	313680	0	444814009	40481087		0
69042	4086	4112343	2018-10-14	2018-10-14 00:00:00	2018-10-24	2018-10-24 00:00:00	32020		\N	271562	0	195662009	4112343		0
79729	4722	260139	1941-02-23	1941-02-23 00:00:00	1941-03-02	1941-03-02 00:00:00	32020		\N	314499	0	10509002	260139		0
69536	4116	40481087	2011-07-02	2011-07-02 00:00:00	2011-07-23	2011-07-23 00:00:00	32020		\N	273636	0	444814009	40481087		0
69691	4123	4112343	1977-07-03	1977-07-03 00:00:00	1977-07-12	1977-07-12 00:00:00	32020		\N	274082	0	195662009	4112343		0
80510	4771	81151	1971-06-17	1971-06-17 00:00:00	1971-07-15	1971-07-15 00:00:00	32020		\N	317772	0	44465007	81151		0
80771	4791	378001	1970-04-09	1970-04-09 00:00:00	1970-05-09	1970-05-09 00:00:00	32020		\N	318772	0	62106007	378001		0
80968	4802	260139	1968-11-21	1968-11-21 00:00:00	1968-12-05	1968-12-05 00:00:00	32020		\N	319423	0	10509002	260139		0
81412	4828	260139	2000-07-17	2000-07-17 00:00:00	2000-07-31	2000-07-31 00:00:00	32020		\N	321286	0	10509002	260139		0
81553	4837	40481087	1990-11-18	1990-11-18 00:00:00	1990-12-02	1990-12-02 00:00:00	32020		\N	321864	0	444814009	40481087		0
71191	4223	4156265	1997-05-16	1997-05-16 00:00:00	1997-05-30	1997-05-30 00:00:00	32020		\N	280365	0	370247008	4156265		0
81965	4859	40481087	1985-06-27	1985-06-27 00:00:00	1985-07-18	1985-07-18 00:00:00	32020		\N	323251	0	444814009	40481087		0
82009	4861	4112343	2017-11-30	2017-11-30 00:00:00	2017-12-13	2017-12-13 00:00:00	32020		\N	323410	0	195662009	4112343		0
82284	4881	81151	1967-09-28	1967-09-28 00:00:00	1967-11-02	1967-11-02 00:00:00	32020		\N	324521	0	44465007	81151		0
82417	4890	4116491	1978-12-20	1978-12-20 00:00:00	1979-01-31	1979-01-31 00:00:00	32020		\N	325065	0	301011002	4116491		0
82560	4899	4112343	1961-01-30	1961-01-30 00:00:00	1961-02-08	1961-02-08 00:00:00	32020		\N	325838	0	195662009	4112343		0
72196	4283	4230399	1956-12-20	1956-12-20 00:00:00	1957-03-20	1957-03-20 00:00:00	32020		\N	284279	0	359817006	4230399		0
82873	4922	40481087	1999-01-01	1999-01-01 00:00:00	1999-01-08	1999-01-08 00:00:00	32020		\N	327049	0	444814009	40481087		0
83312	4949	375671	2006-07-16	2006-07-16 00:00:00	2006-09-14	2006-09-14 00:00:00	32020		\N	329049	0	62564004	375671		0
83440	4960	40481087	1958-09-27	1958-09-27 00:00:00	1958-10-18	1958-10-18 00:00:00	32020		\N	329673	0	444814009	40481087		0
83776	4976	4278672	1917-08-16	1917-08-16 00:00:00	1917-11-14	1917-11-14 00:00:00	32020		\N	331100	0	65966004	4278672		0
83942	4987	198199	2014-09-08	2014-09-08 00:00:00	2014-11-01	2014-11-01 00:00:00	32020		\N	331760	0	45816000	198199		0
73695	4379	260139	1985-12-29	1985-12-29 00:00:00	1986-01-05	1986-01-05 00:00:00	32020		\N	290939	0	10509002	260139		0
84458	5022	40481087	1999-12-04	1999-12-04 00:00:00	1999-12-25	1999-12-25 00:00:00	32020		\N	333668	0	444814009	40481087		0
84788	5043	40481087	2013-05-13	2013-05-13 00:00:00	2013-05-20	2013-05-20 00:00:00	32020		\N	335157	0	444814009	40481087		0
85045	5058	40481087	1972-12-04	1972-12-04 00:00:00	1972-12-11	1972-12-11 00:00:00	32020		\N	336305	0	444814009	40481087		0
85188	5067	260139	1976-12-20	1976-12-20 00:00:00	1977-01-03	1977-01-03 00:00:00	32020		\N	336850	0	10509002	260139		0
74789	4442	40481087	1984-11-05	1984-11-05 00:00:00	1984-11-19	1984-11-19 00:00:00	32020		\N	295284	0	444814009	40481087		0
74930	4450	4156265	2008-01-09	2008-01-09 00:00:00	2008-01-23	2008-01-23 00:00:00	32020		\N	296085	0	370247008	4156265		0
75051	4456	28060	1999-11-03	1999-11-03 00:00:00	1999-11-11	1999-11-11 00:00:00	32020		\N	296576	0	43878008	28060		0
75321	4473	375671	1981-09-30	1981-09-30 00:00:00	1981-11-29	1981-11-29 00:00:00	32020		\N	297592	0	62564004	375671		0
64851	3834	4278672	1963-10-03	1963-10-03 00:00:00	1964-01-01	1964-01-01 00:00:00	32020		\N	254587	0	65966004	4278672		0
75585	4485	260139	1963-02-08	1963-02-08 00:00:00	1963-02-22	1963-02-22 00:00:00	32020		\N	298541	0	10509002	260139		0
75712	4491	30753	1983-08-27	1983-08-27 00:00:00	\N	\N	32020		\N	299018	0	16761005	30753		0
75871	4500	40481087	1997-06-27	1997-06-27 00:00:00	1997-07-04	1997-07-04 00:00:00	32020		\N	299552	0	444814009	40481087		0
76096	4514	80180	2015-03-29	2015-03-29 00:00:00	\N	\N	32020		\N	300663	0	396275006	80180		0
76351	4529	4112343	1989-01-25	1989-01-25 00:00:00	1989-02-04	1989-02-04 00:00:00	32020		\N	301568	0	195662009	4112343		0
76505	4534	4134304	1996-05-21	1996-05-21 00:00:00	1996-07-20	1996-07-20 00:00:00	32020		\N	302077	0	263102004	4134304		0
76642	4543	28060	1988-08-23	1988-08-23 00:00:00	1988-09-02	1988-09-02 00:00:00	32020		\N	302622	0	43878008	28060		0
76764	4548	4156265	1986-10-07	1986-10-07 00:00:00	1986-10-21	1986-10-21 00:00:00	32020		\N	303030	0	370247008	4156265		0
76933	4559	4059173	1945-12-14	1945-12-14 00:00:00	1946-02-12	1946-02-12 00:00:00	32020		\N	303766	0	16114001	4059173		0
77030	4563	260139	1984-04-10	1984-04-10 00:00:00	1984-04-17	1984-04-17 00:00:00	32020		\N	304096	0	10509002	260139		0
87841	5228	40481087	1961-04-18	1961-04-18 00:00:00	1961-05-09	1961-05-09 00:00:00	32020		\N	347785	0	444814009	40481087		0
77496	4591	40481087	1974-10-30	1974-10-30 00:00:00	1974-11-06	1974-11-06 00:00:00	32020		\N	305918	0	444814009	40481087		0
77617	4596	40481087	2013-01-13	2013-01-13 00:00:00	2013-01-20	2013-01-20 00:00:00	32020		\N	306256	0	444814009	40481087		0
77767	4607	4218389	2007-08-05	2007-08-05 00:00:00	2007-09-09	2007-09-09 00:00:00	32020		\N	306877	0	39848009	4218389		0
88577	5265	80180	2003-03-05	2003-03-05 00:00:00	\N	\N	32020		\N	350309	0	396275006	80180		0
78105	4628	4113008	2016-08-23	2016-08-23 00:00:00	2016-09-13	2016-09-13 00:00:00	32020		\N	308352	0	284549007	4113008		0
78227	4631	257012	1968-08-03	1968-08-03 00:00:00	1978-12-17	1978-12-17 00:00:00	32020		\N	308576	0	40055000	257012		0
78411	4643	260139	1956-02-06	1956-02-06 00:00:00	1956-02-13	1956-02-13 00:00:00	32020		\N	309590	0	10509002	260139		0
78610	4655	40481087	1996-05-04	1996-05-04 00:00:00	1996-05-25	1996-05-25 00:00:00	32020		\N	310368	0	444814009	40481087		0
78726	4662	198809	1989-07-27	1989-07-27 00:00:00	1989-07-27	1989-07-27 00:00:00	32020		\N	310773	0	65275009	198809		0
79005	4677	40481087	1958-01-18	1958-01-18 00:00:00	1958-02-08	1958-02-08 00:00:00	32020		\N	311672	0	444814009	40481087		0
79092	4682	4283893	1986-10-11	1986-10-11 00:00:00	1987-02-21	1987-02-21 00:00:00	32020		\N	312032	0	36971009	4283893		0
79308	4696	4027663	1979-03-07	1979-03-07 00:00:00	\N	\N	32020		\N	312846	0	13200003	4027663		0
79501	4709	40481087	2007-03-20	2007-03-20 00:00:00	2007-03-27	2007-03-27 00:00:00	32020		\N	313694	0	444814009	40481087		0
69043	4086	260139	2019-02-09	2019-02-09 00:00:00	2019-02-16	2019-02-16 00:00:00	32020		\N	271614	0	10509002	260139		0
79730	4722	4156265	1994-07-16	1994-07-16 00:00:00	1994-07-30	1994-07-30 00:00:00	32020		\N	314614	0	370247008	4156265		0
69537	4116	4266809	2012-06-23	2012-06-23 00:00:00	\N	\N	32020		\N	273636	0	397881000	4266809		0
69692	4123	378001	1967-04-16	1967-04-16 00:00:00	1967-06-15	1967-06-15 00:00:00	32020		\N	274114	0	62106007	378001		0
80772	4791	260139	1981-01-24	1981-01-24 00:00:00	1981-01-31	1981-01-31 00:00:00	32020		\N	318778	0	10509002	260139		0
80969	4802	40481087	1973-08-09	1973-08-09 00:00:00	1973-08-30	1973-08-30 00:00:00	32020		\N	319460	0	444814009	40481087		0
81413	4828	40481087	1993-10-17	1993-10-17 00:00:00	1993-10-24	1993-10-24 00:00:00	32020		\N	321268	0	444814009	40481087		0
81554	4837	4001336	1987-06-28	1987-06-28 00:00:00	1987-08-27	1987-08-27 00:00:00	32020		\N	321869	0	110030002	4001336		0
71192	4223	260139	1979-05-16	1979-05-16 00:00:00	1979-05-23	1979-05-23 00:00:00	32020		\N	280426	0	10509002	260139		0
81966	4859	80180	1993-11-01	1993-11-01 00:00:00	\N	\N	32020		\N	323200	0	396275006	80180		0
82010	4861	260139	2003-04-12	2003-04-12 00:00:00	2003-04-26	2003-04-26 00:00:00	32020		\N	323384	0	10509002	260139		0
82285	4881	28060	1992-03-16	1992-03-16 00:00:00	1992-03-29	1992-03-29 00:00:00	32020		\N	324537	0	43878008	28060		0
82418	4890	4112343	2000-06-15	2000-06-15 00:00:00	2000-06-26	2000-06-26 00:00:00	32020		\N	325157	0	195662009	4112343		0
82561	4899	261325	1967-02-21	1967-02-21 00:00:00	\N	\N	32020		\N	325852	0	87433001	261325		0
72197	4283	40481087	1954-01-05	1954-01-05 00:00:00	1954-01-26	1954-01-26 00:00:00	32020		\N	284287	0	444814009	40481087		0
82874	4922	260139	1983-11-27	1983-11-27 00:00:00	1983-12-04	1983-12-04 00:00:00	32020		\N	327023	0	10509002	260139		0
83313	4949	4294548	1979-12-13	1979-12-13 00:00:00	1980-02-14	1980-02-14 00:00:00	32020		\N	328997	0	75498004	4294548		0
83441	4960	40481087	1934-08-07	1934-08-07 00:00:00	1934-08-14	1934-08-14 00:00:00	32020		\N	329672	0	444814009	40481087		0
83777	4976	260139	1913-03-14	1913-03-14 00:00:00	1913-03-21	1913-03-21 00:00:00	32020		\N	331068	0	10509002	260139		0
83943	4987	260139	2004-06-29	2004-06-29 00:00:00	2004-07-13	2004-07-13 00:00:00	32020		\N	331775	0	10509002	260139		0
73696	4379	257012	1973-05-20	1973-05-20 00:00:00	\N	\N	32020		\N	290969	0	40055000	257012		0
84459	5022	40481087	2000-07-27	2000-07-27 00:00:00	2000-08-10	2000-08-10 00:00:00	32020		\N	333644	0	444814009	40481087		0
84789	5043	257012	2004-11-19	2004-11-19 00:00:00	\N	\N	32020		\N	335156	0	40055000	257012		0
85046	5058	4059173	2011-10-31	2011-10-31 00:00:00	2011-11-30	2011-11-30 00:00:00	32020		\N	336347	0	16114001	4059173		0
85189	5067	80180	2012-02-08	2012-02-08 00:00:00	\N	\N	32020		\N	336869	0	396275006	80180		0
74828	4446	4156265	2014-06-20	2014-06-20 00:00:00	2014-07-04	2014-07-04 00:00:00	32020		\N	295667	0	370247008	4156265		0
74931	4450	4310024	2006-12-30	2006-12-30 00:00:00	\N	\N	32020		\N	296045	0	424802006	4310024		0
75052	4456	4112343	2004-07-19	2004-07-19 00:00:00	2004-07-26	2004-07-26 00:00:00	32020		\N	296554	0	195662009	4112343		0
75322	4473	80180	2012-06-29	2012-06-29 00:00:00	\N	\N	32020		\N	297625	0	396275006	80180		0
64852	3834	4112343	1974-03-07	1974-03-07 00:00:00	1974-03-14	1974-03-14 00:00:00	32020		\N	254579	0	195662009	4112343		0
75586	4485	80180	1994-10-16	1994-10-16 00:00:00	\N	\N	32020		\N	298605	0	396275006	80180		0
75713	4491	4296204	1983-04-11	1983-04-11 00:00:00	1983-04-25	1983-04-25 00:00:00	32020		\N	299026	0	403190006	4296204		0
75872	4500	4112343	2014-03-03	2014-03-03 00:00:00	2014-03-12	2014-03-12 00:00:00	32020		\N	299595	0	195662009	4112343		0
76097	4514	260139	2014-06-29	2014-06-29 00:00:00	2014-07-06	2014-07-06 00:00:00	32020		\N	300663	0	10509002	260139		0
76352	4529	28060	1993-07-14	1993-07-14 00:00:00	1993-07-21	1993-07-21 00:00:00	32020		\N	301551	0	43878008	28060		0
76506	4534	372328	1949-06-20	1949-06-20 00:00:00	1949-10-12	1949-10-12 00:00:00	32020		\N	302049	0	65363002	372328		0
76643	4544	378001	1981-10-27	1981-10-27 00:00:00	1981-12-26	1981-12-26 00:00:00	32020		\N	302670	0	62106007	378001		0
76776	4550	40481087	1985-04-02	1985-04-02 00:00:00	1985-04-23	1985-04-23 00:00:00	32020		\N	303179	0	444814009	40481087		0
76934	4559	40481087	1952-10-14	1952-10-14 00:00:00	1952-10-28	1952-10-28 00:00:00	32020		\N	303752	0	444814009	40481087		0
77031	4563	4112343	1969-05-16	1969-05-16 00:00:00	1969-05-26	1969-05-26 00:00:00	32020		\N	304090	0	195662009	4112343		0
87842	5228	40481087	1956-07-23	1956-07-23 00:00:00	1956-08-06	1956-08-06 00:00:00	32020		\N	347774	0	444814009	40481087		0
77497	4591	30753	1994-03-02	1994-03-02 00:00:00	\N	\N	32020		\N	305960	0	16761005	30753		0
77618	4596	4294548	1958-04-09	1958-04-09 00:00:00	1958-06-25	1958-06-25 00:00:00	32020		\N	306318	0	75498004	4294548		0
77768	4607	40481087	2019-05-16	2019-05-16 00:00:00	2019-06-06	2019-06-06 00:00:00	32020		\N	306911	0	444814009	40481087		0
88578	5265	4112343	2018-12-21	2018-12-21 00:00:00	2018-12-29	2018-12-29 00:00:00	32020		\N	350278	0	195662009	4112343		0
78106	4628	375671	2002-09-06	2002-09-06 00:00:00	2002-10-06	2002-10-06 00:00:00	32020		\N	308350	0	62564004	375671		0
78228	4631	260139	1921-10-25	1921-10-25 00:00:00	1921-11-08	1921-11-08 00:00:00	32020		\N	308563	0	10509002	260139		0
78412	4643	260139	1963-01-12	1963-01-12 00:00:00	1963-01-19	1963-01-19 00:00:00	32020		\N	309591	0	10509002	260139		0
78611	4655	260139	1993-06-14	1993-06-14 00:00:00	1993-06-21	1993-06-21 00:00:00	32020		\N	310335	0	10509002	260139		0
78727	4662	196456	1989-07-27	1989-07-27 00:00:00	1989-07-27	1989-07-27 00:00:00	32020		\N	310773	0	235919008	196456		0
79006	4677	40481087	1978-05-08	1978-05-08 00:00:00	1978-05-29	1978-05-29 00:00:00	32020		\N	311645	0	444814009	40481087		0
79093	4682	260139	1993-04-10	1993-04-10 00:00:00	1993-04-24	1993-04-24 00:00:00	32020		\N	312005	0	10509002	260139		0
79309	4696	260139	2017-12-20	2017-12-20 00:00:00	2018-01-03	2018-01-03 00:00:00	32020		\N	312826	0	10509002	260139		0
79502	4709	260139	1984-09-09	1984-09-09 00:00:00	1984-09-23	1984-09-23 00:00:00	32020		\N	313661	0	10509002	260139		0
69044	4086	78272	1987-05-14	1987-05-14 00:00:00	1987-06-04	1987-06-04 00:00:00	32020		\N	271572	0	70704007	78272		0
79731	4722	4001336	1934-01-02	1934-01-02 00:00:00	1934-03-03	1934-03-03 00:00:00	32020		\N	314611	0	110030002	4001336		0
69538	4116	80180	2012-06-23	2012-06-23 00:00:00	\N	\N	32020		\N	273636	0	396275006	80180		0
69693	4123	4112343	1971-02-22	1971-02-22 00:00:00	1971-03-03	1971-03-03 00:00:00	32020		\N	274146	0	195662009	4112343		0
80773	4791	40481087	2005-03-06	2005-03-06 00:00:00	2005-03-27	2005-03-27 00:00:00	32020		\N	318757	0	444814009	40481087		0
80970	4802	257012	1968-08-23	1968-08-23 00:00:00	\N	\N	32020		\N	319458	0	40055000	257012		0
81414	4828	372328	1967-07-09	1967-07-09 00:00:00	1967-08-16	1967-08-16 00:00:00	32020		\N	321255	0	65363002	372328		0
81555	4837	372328	1968-07-26	1968-07-26 00:00:00	1968-10-29	1968-10-29 00:00:00	32020		\N	321803	0	65363002	372328		0
71193	4223	40481087	2011-08-31	2011-08-31 00:00:00	2011-09-21	2011-09-21 00:00:00	32020		\N	280429	0	444814009	40481087		0
81967	4859	260139	1963-10-17	1963-10-17 00:00:00	1963-10-31	1963-10-31 00:00:00	32020		\N	323277	0	10509002	260139		0
82011	4861	40481087	2012-07-05	2012-07-05 00:00:00	2012-07-26	2012-07-26 00:00:00	32020		\N	323436	0	444814009	40481087		0
82286	4881	40481087	2003-01-03	2003-01-03 00:00:00	2003-01-17	2003-01-17 00:00:00	32020		\N	324538	0	444814009	40481087		0
82419	4890	81151	1927-01-11	1927-01-11 00:00:00	1927-02-01	1927-02-01 00:00:00	32020		\N	325142	0	44465007	81151		0
82562	4899	260139	1947-09-10	1947-09-10 00:00:00	1947-09-17	1947-09-17 00:00:00	32020		\N	325767	0	10509002	260139		0
72198	4283	4294548	2001-03-15	2001-03-15 00:00:00	2001-08-09	2001-08-09 00:00:00	32020		\N	284232	0	75498004	4294548		0
82875	4922	40479422	1983-05-29	1983-05-29 00:00:00	1983-08-04	1983-08-04 00:00:00	32020		\N	327002	0	444448004	40479422		0
83314	4949	40481087	1991-10-19	1991-10-19 00:00:00	1991-11-09	1991-11-09 00:00:00	32020		\N	328999	0	444814009	40481087		0
83442	4960	4112343	1973-12-18	1973-12-18 00:00:00	1973-12-29	1973-12-29 00:00:00	32020		\N	329695	0	195662009	4112343		0
83778	4976	260139	1956-11-20	1956-11-20 00:00:00	1956-12-04	1956-12-04 00:00:00	32020		\N	330969	0	10509002	260139		0
83944	4987	4112343	1970-07-31	1970-07-31 00:00:00	1970-08-11	1970-08-11 00:00:00	32020		\N	331756	0	195662009	4112343		0
73697	4379	4112343	2007-12-22	2007-12-22 00:00:00	2007-12-31	2007-12-31 00:00:00	32020		\N	290971	0	195662009	4112343		0
84460	5022	40481087	1991-02-22	1991-02-22 00:00:00	1991-03-15	1991-03-15 00:00:00	32020		\N	333642	0	444814009	40481087		0
84790	5043	260139	2004-08-04	2004-08-04 00:00:00	2004-08-18	2004-08-18 00:00:00	32020		\N	335134	0	10509002	260139		0
85047	5058	40481087	1979-04-15	1979-04-15 00:00:00	1979-05-06	1979-05-06 00:00:00	32020		\N	336283	0	444814009	40481087		0
85190	5067	4218389	1977-04-17	1977-04-17 00:00:00	1977-05-08	1977-05-08 00:00:00	32020		\N	336815	0	39848009	4218389		0
74829	4446	4112343	2003-10-21	2003-10-21 00:00:00	2003-11-02	2003-11-02 00:00:00	32020		\N	295660	0	195662009	4112343		0
74932	4450	40481087	1999-10-16	1999-10-16 00:00:00	1999-10-23	1999-10-23 00:00:00	32020		\N	296050	0	444814009	40481087		0
75053	4456	260139	2003-04-30	2003-04-30 00:00:00	2003-05-14	2003-05-14 00:00:00	32020		\N	296566	0	10509002	260139		0
75323	4473	4112343	1987-01-27	1987-01-27 00:00:00	1987-02-04	1987-02-04 00:00:00	32020		\N	297612	0	195662009	4112343		0
64853	3834	40481087	2007-02-27	2007-02-27 00:00:00	2007-03-13	2007-03-13 00:00:00	32020		\N	254554	0	444814009	40481087		0
75587	4485	4266809	1994-10-16	1994-10-16 00:00:00	\N	\N	32020		\N	298605	0	397881000	4266809		0
75714	4491	260139	1984-04-25	1984-04-25 00:00:00	1984-05-02	1984-05-02 00:00:00	32020		\N	299029	0	10509002	260139		0
75873	4500	40481087	2001-06-18	2001-06-18 00:00:00	2001-07-09	2001-07-09 00:00:00	32020		\N	299553	0	444814009	40481087		0
76098	4514	372328	1978-09-04	1978-09-04 00:00:00	1978-10-27	1978-10-27 00:00:00	32020		\N	300694	0	65363002	372328		0
76353	4529	4116491	1993-11-09	1993-11-09 00:00:00	1993-12-29	1993-12-29 00:00:00	32020		\N	301593	0	301011002	4116491		0
76507	4534	4112343	1949-07-29	1949-07-29 00:00:00	1949-08-05	1949-08-05 00:00:00	32020		\N	302053	0	195662009	4112343		0
76644	4544	372328	1943-09-03	1943-09-03 00:00:00	1944-06-20	1944-06-20 00:00:00	32020		\N	302692	0	65363002	372328		0
76777	4550	40481087	1964-07-05	1964-07-05 00:00:00	1964-07-26	1964-07-26 00:00:00	32020		\N	303177	0	444814009	40481087		0
76935	4559	4112343	1985-12-28	1985-12-28 00:00:00	1986-01-06	1986-01-06 00:00:00	32020		\N	303793	0	195662009	4112343		0
77032	4563	40481087	2016-05-16	2016-05-16 00:00:00	2016-05-23	2016-05-23 00:00:00	32020		\N	304129	0	444814009	40481087		0
87843	5228	4134304	1941-01-01	1941-01-01 00:00:00	1941-04-01	1941-04-01 00:00:00	32020		\N	347860	0	263102004	4134304		0
77498	4591	81893	1994-01-31	1994-01-31 00:00:00	\N	\N	32020		\N	305960	0	64766004	81893		0
77619	4596	30753	1977-08-05	1977-08-05 00:00:00	\N	\N	32020		\N	306272	0	16761005	30753		0
77769	4607	40481087	1992-02-22	1992-02-22 00:00:00	1992-03-14	1992-03-14 00:00:00	32020		\N	306895	0	444814009	40481087		0
88579	5265	40481087	2016-04-28	2016-04-28 00:00:00	2016-05-05	2016-05-05 00:00:00	32020		\N	350284	0	444814009	40481087		0
78107	4628	372328	1970-05-05	1970-05-05 00:00:00	1970-09-06	1970-09-06 00:00:00	32020		\N	308314	0	65363002	372328		0
78229	4631	40481087	1992-05-10	1992-05-10 00:00:00	1992-05-17	1992-05-17 00:00:00	32020		\N	308641	0	444814009	40481087		0
78413	4643	260139	1916-04-19	1916-04-19 00:00:00	1916-04-26	1916-04-26 00:00:00	32020		\N	309600	0	10509002	260139		0
78612	4655	4296204	1982-11-20	1982-11-20 00:00:00	1982-12-25	1982-12-25 00:00:00	32020		\N	310301	0	403190006	4296204		0
78728	4662	40481087	1987-07-19	1987-07-19 00:00:00	1987-08-09	1987-08-09 00:00:00	32020		\N	310796	0	444814009	40481087		0
79007	4677	4112343	1971-08-29	1971-08-29 00:00:00	1971-09-07	1971-09-07 00:00:00	32020		\N	311652	0	195662009	4112343		0
79094	4682	40481087	1994-03-21	1994-03-21 00:00:00	1994-04-11	1994-04-11 00:00:00	32020		\N	312034	0	444814009	40481087		0
79310	4696	40481087	1951-05-22	1951-05-22 00:00:00	1951-05-29	1951-05-29 00:00:00	32020		\N	312832	0	444814009	40481087		0
79503	4709	4112343	1965-04-23	1965-04-23 00:00:00	1965-05-01	1965-05-01 00:00:00	32020		\N	313660	0	195662009	4112343		0
69045	4086	195588	2016-11-18	2016-11-18 00:00:00	2016-12-23	2016-12-23 00:00:00	32020		\N	271561	0	38822007	195588		0
79732	4722	4132546	1934-01-02	1934-01-02 00:00:00	\N	\N	32020		\N	314611	0	275272006	4166590		0
69539	4116	372328	1979-07-05	1979-07-05 00:00:00	1979-11-01	1979-11-01 00:00:00	32020		\N	273637	0	65363002	372328		0
69694	4123	4156265	1976-12-24	1976-12-24 00:00:00	1977-01-14	1977-01-14 00:00:00	32020		\N	274115	0	370247008	4156265		0
80774	4791	4134304	1968-06-18	1968-06-18 00:00:00	1968-07-18	1968-07-18 00:00:00	32020		\N	318771	0	263102004	4134304		0
80971	4802	260139	1970-03-23	1970-03-23 00:00:00	1970-03-30	1970-03-30 00:00:00	32020		\N	319459	0	10509002	260139		0
81415	4828	40481087	2007-08-17	2007-08-17 00:00:00	2007-09-07	2007-09-07 00:00:00	32020		\N	321287	0	444814009	40481087		0
81556	4837	4152936	1964-02-15	1964-02-15 00:00:00	1964-02-29	1964-02-29 00:00:00	32020		\N	321817	0	283385000	4152936		0
71194	4223	372328	1958-08-18	1958-08-18 00:00:00	1959-01-02	1959-01-02 00:00:00	32020		\N	280382	0	65363002	372328		0
81968	4859	260139	1956-08-29	1956-08-29 00:00:00	1956-09-12	1956-09-12 00:00:00	32020		\N	323199	0	10509002	260139		0
82012	4861	40481087	1977-10-30	1977-10-30 00:00:00	1977-11-06	1977-11-06 00:00:00	32020		\N	323356	0	444814009	40481087		0
82287	4881	28060	2018-03-14	2018-03-14 00:00:00	2018-03-24	2018-03-24 00:00:00	32020		\N	324539	0	43878008	28060		0
82420	4890	4237458	1998-09-28	1998-09-28 00:00:00	1998-10-28	1998-10-28 00:00:00	32020		\N	325147	0	58150001	4237458		0
82563	4899	192671	1964-06-13	1964-06-13 00:00:00	\N	\N	32020		\N	325807	0	K92.2	35208414		0
72199	4284	40481087	1987-10-24	1987-10-24 00:00:00	1987-11-14	1987-11-14 00:00:00	32020		\N	284392	0	444814009	40481087		0
82876	4922	40481087	2019-04-12	2019-04-12 00:00:00	2019-04-26	2019-04-26 00:00:00	32020		\N	327053	0	444814009	40481087		0
83315	4949	4027663	2003-09-14	2003-09-14 00:00:00	\N	\N	32020		\N	329028	0	13200003	4027663		0
83443	4960	378001	1923-08-02	1923-08-02 00:00:00	1923-10-01	1923-10-01 00:00:00	32020		\N	329768	0	62106007	378001		0
83779	4976	40481087	1916-10-22	1916-10-22 00:00:00	1916-11-12	1916-11-12 00:00:00	32020		\N	330923	0	444814009	40481087		0
83945	4987	4112343	1985-08-07	1985-08-07 00:00:00	1985-08-19	1985-08-19 00:00:00	32020		\N	331710	0	195662009	4112343		0
73698	4379	28060	1983-04-08	1983-04-08 00:00:00	1983-04-17	1983-04-17 00:00:00	32020		\N	290938	0	43878008	28060		0
84461	5022	40481087	1984-10-26	1984-10-26 00:00:00	1984-11-16	1984-11-16 00:00:00	32020		\N	333679	0	444814009	40481087		0
84791	5043	375671	2009-08-14	2009-08-14 00:00:00	2009-09-13	2009-09-13 00:00:00	32020		\N	335132	0	62564004	375671		0
85048	5058	81893	1976-12-24	1976-12-24 00:00:00	\N	\N	32020		\N	336320	0	64766004	81893		0
85191	5067	4156265	2002-04-27	2002-04-27 00:00:00	2002-05-11	2002-05-11 00:00:00	32020		\N	336821	0	370247008	4156265		0
74830	4446	40481087	2009-09-26	2009-09-26 00:00:00	2009-10-17	2009-10-17 00:00:00	32020		\N	295669	0	444814009	40481087		0
74933	4450	4035415	1976-11-22	1976-11-22 00:00:00	1977-01-21	1977-01-21 00:00:00	32020		\N	296084	0	239720000	4035415		0
75054	4457	4237458	2006-07-22	2006-07-22 00:00:00	2006-08-21	2006-08-21 00:00:00	32020		\N	296640	0	58150001	4237458		0
75324	4473	4112343	1979-02-14	1979-02-14 00:00:00	1979-02-24	1979-02-24 00:00:00	32020		\N	297586	0	195662009	4112343		0
64854	3834	28060	1965-07-27	1965-07-27 00:00:00	1965-08-04	1965-08-04 00:00:00	32020		\N	254601	0	43878008	28060		0
75588	4485	192671	1994-12-14	1994-12-14 00:00:00	\N	\N	32020		\N	298617	0	K92.2	35208414		0
75715	4491	4112343	2005-07-17	2005-07-17 00:00:00	2005-07-27	2005-07-27 00:00:00	32020		\N	298943	0	195662009	4112343		0
75874	4500	80180	1997-05-22	1997-05-22 00:00:00	\N	\N	32020		\N	299591	0	396275006	80180		0
76099	4514	40481087	1981-10-23	1981-10-23 00:00:00	1981-11-06	1981-11-06 00:00:00	32020		\N	300650	0	444814009	40481087		0
76354	4529	81151	2016-10-30	2016-10-30 00:00:00	2016-12-04	2016-12-04 00:00:00	32020		\N	301616	0	44465007	81151		0
76509	4534	4029498	1956-10-23	1956-10-23 00:00:00	\N	\N	32020		\N	302074	0	128613002	4029498		0
76645	4544	375671	1986-09-01	1986-09-01 00:00:00	1986-10-31	1986-10-31 00:00:00	32020		\N	302671	0	62564004	375671		0
76778	4550	372328	1968-02-23	1968-02-23 00:00:00	1968-08-25	1968-08-25 00:00:00	32020		\N	303271	0	65363002	372328		0
76936	4559	4116491	2005-01-06	2005-01-06 00:00:00	2005-02-12	2005-02-12 00:00:00	32020		\N	303739	0	301011002	4116491		0
77033	4563	40481087	1972-08-21	1972-08-21 00:00:00	1972-09-04	1972-09-04 00:00:00	32020		\N	304065	0	444814009	40481087		0
87844	5228	40481087	1983-04-14	1983-04-14 00:00:00	1983-04-21	1983-04-21 00:00:00	32020		\N	347781	0	444814009	40481087		0
77499	4591	80180	1995-01-26	1995-01-26 00:00:00	\N	\N	32020		\N	305960	0	396275006	80180		0
77620	4596	81893	1976-10-09	1976-10-09 00:00:00	\N	\N	32020		\N	306272	0	64766004	81893		0
77770	4607	260139	1998-01-04	1998-01-04 00:00:00	1998-01-11	1998-01-11 00:00:00	32020		\N	306896	0	10509002	260139		0
88580	5265	372328	1971-02-06	1971-02-06 00:00:00	1971-07-29	1971-07-29 00:00:00	32020		\N	350305	0	65363002	372328		0
78108	4628	40481087	2000-01-10	2000-01-10 00:00:00	2000-01-17	2000-01-17 00:00:00	32020		\N	308312	0	444814009	40481087		0
78237	4633	260139	1965-06-05	1965-06-05 00:00:00	1965-06-19	1965-06-19 00:00:00	32020		\N	308792	0	10509002	260139		0
78414	4643	4112343	1945-12-01	1945-12-01 00:00:00	1945-12-14	1945-12-14 00:00:00	32020		\N	309537	0	195662009	4112343		0
78613	4655	40481087	1990-07-19	1990-07-19 00:00:00	1990-07-26	1990-07-26 00:00:00	32020		\N	310269	0	444814009	40481087		0
78729	4662	4113008	1998-07-29	1998-07-29 00:00:00	1998-08-19	1998-08-19 00:00:00	32020		\N	310774	0	284549007	4113008		0
79008	4677	260139	1981-03-02	1981-03-02 00:00:00	1981-03-16	1981-03-16 00:00:00	32020		\N	311653	0	10509002	260139		0
79095	4682	28060	1996-02-21	1996-02-21 00:00:00	1996-03-01	1996-03-01 00:00:00	32020		\N	312023	0	43878008	28060		0
79311	4696	439777	1997-03-02	1997-03-02 00:00:00	\N	\N	32020		\N	312822	0	271737000	439777		0
79504	4709	4112343	2001-10-21	2001-10-21 00:00:00	2001-10-30	2001-10-30 00:00:00	32020		\N	313693	0	195662009	4112343		0
69046	4086	260139	2016-11-12	2016-11-12 00:00:00	2016-11-19	2016-11-19 00:00:00	32020		\N	271621	0	10509002	260139		0
79733	4722	4294548	1956-04-15	1956-04-15 00:00:00	1956-05-06	1956-05-06 00:00:00	32020		\N	314487	0	75498004	4294548		0
69540	4116	40481087	1986-08-12	1986-08-12 00:00:00	1986-08-26	1986-08-26 00:00:00	32020		\N	273651	0	444814009	40481087		0
69695	4123	4112343	2015-03-23	2015-03-23 00:00:00	2015-04-05	2015-04-05 00:00:00	32020		\N	274150	0	195662009	4112343		0
80775	4791	4112343	2015-02-12	2015-02-12 00:00:00	2015-02-21	2015-02-21 00:00:00	32020		\N	318815	0	195662009	4112343		0
80972	4802	4113008	2003-12-17	2003-12-17 00:00:00	2004-01-07	2004-01-07 00:00:00	32020		\N	319438	0	284549007	4113008		0
81416	4828	4112343	2017-11-21	2017-11-21 00:00:00	2017-12-02	2017-12-02 00:00:00	32020		\N	321290	0	195662009	4112343		0
81557	4837	40481087	1996-06-10	1996-06-10 00:00:00	1996-06-24	1996-06-24 00:00:00	32020		\N	321861	0	444814009	40481087		0
71195	4223	372328	1960-07-27	1960-07-27 00:00:00	1960-12-30	1960-12-30 00:00:00	32020		\N	280361	0	65363002	372328		0
81969	4859	4112343	1958-09-02	1958-09-02 00:00:00	1958-09-09	1958-09-09 00:00:00	32020		\N	323229	0	195662009	4112343		0
82013	4861	4027663	1979-05-27	1979-05-27 00:00:00	\N	\N	32020		\N	323356	0	13200003	4027663		0
82288	4881	375671	1980-12-23	1980-12-23 00:00:00	1981-02-21	1981-02-21 00:00:00	32020		\N	324522	0	62564004	375671		0
82421	4890	372328	1924-08-24	1924-08-24 00:00:00	1924-10-29	1924-10-29 00:00:00	32020		\N	325191	0	65363002	372328		0
82564	4899	4112343	1925-02-02	1925-02-02 00:00:00	1925-02-12	1925-02-12 00:00:00	32020		\N	325765	0	195662009	4112343		0
72200	4284	4218389	2003-02-16	2003-02-16 00:00:00	2003-03-09	2003-03-09 00:00:00	32020		\N	284386	0	39848009	4218389		0
82877	4922	372328	1977-12-26	1977-12-26 00:00:00	1978-01-09	1978-01-09 00:00:00	32020		\N	327020	0	65363002	372328		0
83316	4949	40481087	2002-12-30	2002-12-30 00:00:00	2003-01-20	2003-01-20 00:00:00	32020		\N	329028	0	444814009	40481087		0
83444	4960	81151	1952-08-11	1952-08-11 00:00:00	1952-09-01	1952-09-01 00:00:00	32020		\N	329708	0	44465007	81151		0
83780	4976	375671	1981-03-09	1981-03-09 00:00:00	1981-05-08	1981-05-08 00:00:00	32020		\N	331105	0	62564004	375671		0
83946	4987	4285898	1997-01-05	1997-01-05 00:00:00	\N	\N	32020		\N	331730	0	68496003	4285898		0
74967	4452	80180	1996-11-14	1996-11-14 00:00:00	\N	\N	32020		\N	296268	0	396275006	80180		0
73699	4379	81151	1990-05-28	1990-05-28 00:00:00	1990-06-25	1990-06-25 00:00:00	32020		\N	290991	0	44465007	81151		0
84462	5022	260139	1978-01-10	1978-01-10 00:00:00	1978-01-17	1978-01-17 00:00:00	32020		\N	333677	0	10509002	260139		0
84792	5043	4112343	2012-08-14	2012-08-14 00:00:00	2012-08-22	2012-08-22 00:00:00	32020		\N	335113	0	195662009	4112343		0
85049	5058	30753	1977-11-19	1977-11-19 00:00:00	\N	\N	32020		\N	336320	0	16761005	30753		0
85192	5067	4283893	2013-05-01	2013-05-01 00:00:00	2013-05-29	2013-05-29 00:00:00	32020		\N	336828	0	36971009	4283893		0
74831	4446	4112343	1985-07-27	1985-07-27 00:00:00	1985-08-08	1985-08-08 00:00:00	32020		\N	295635	0	195662009	4112343		0
74934	4450	4112343	1980-05-29	1980-05-29 00:00:00	1980-06-07	1980-06-07 00:00:00	32020		\N	296038	0	195662009	4112343		0
75055	4457	40481087	1999-11-16	1999-11-16 00:00:00	1999-11-23	1999-11-23 00:00:00	32020		\N	296641	0	444814009	40481087		0
75325	4473	40481087	2018-10-12	2018-10-12 00:00:00	2018-10-26	2018-10-26 00:00:00	32020		\N	297614	0	444814009	40481087		0
64855	3834	260139	2009-04-27	2009-04-27 00:00:00	2009-05-04	2009-05-04 00:00:00	32020		\N	254606	0	10509002	260139		0
75589	4485	4027663	1982-10-04	1982-10-04 00:00:00	\N	\N	32020		\N	298593	0	13200003	4027663		0
75716	4491	195588	1976-01-06	1976-01-06 00:00:00	1976-02-29	1976-02-29 00:00:00	32020		\N	298967	0	38822007	195588		0
75875	4500	260139	1989-10-17	1989-10-17 00:00:00	1989-10-24	1989-10-24 00:00:00	32020		\N	299534	0	10509002	260139		0
76100	4514	40481087	1985-10-22	1985-10-22 00:00:00	1985-11-12	1985-11-12 00:00:00	32020		\N	300672	0	444814009	40481087		0
76355	4529	258780	1985-12-01	1985-12-01 00:00:00	\N	\N	32020		\N	301589	0	185086009	258780		0
76510	4534	380378	1956-10-23	1956-10-23 00:00:00	\N	\N	32020		\N	302074	0	84757009	380378		0
76646	4544	317576	1989-10-24	1989-10-24 00:00:00	\N	\N	32020		\N	302666	0	53741008	317576		0
76779	4550	40481087	1974-03-14	1974-03-14 00:00:00	1974-04-04	1974-04-04 00:00:00	32020		\N	303203	0	444814009	40481087		0
76937	4559	40481087	1991-10-19	1991-10-19 00:00:00	1991-10-26	1991-10-26 00:00:00	32020		\N	303789	0	444814009	40481087		0
77034	4563	260139	1970-04-12	1970-04-12 00:00:00	1970-04-26	1970-04-26 00:00:00	32020		\N	304091	0	10509002	260139		0
87845	5228	260139	1969-06-21	1969-06-21 00:00:00	1969-06-28	1969-06-28 00:00:00	32020		\N	347760	0	10509002	260139		0
77500	4591	4266809	1995-01-26	1995-01-26 00:00:00	\N	\N	32020		\N	305960	0	397881000	4266809		0
77621	4596	4112343	1939-03-24	1939-03-24 00:00:00	1939-04-03	1939-04-03 00:00:00	32020		\N	306285	0	195662009	4112343		0
77771	4607	4112343	1976-10-12	1976-10-12 00:00:00	1976-10-24	1976-10-24 00:00:00	32020		\N	306893	0	195662009	4112343		0
88581	5265	4112343	2011-04-20	2011-04-20 00:00:00	2011-05-01	2011-05-01 00:00:00	32020		\N	350277	0	195662009	4112343		0
78109	4628	81151	1979-03-06	1979-03-06 00:00:00	1979-04-10	1979-04-10 00:00:00	32020		\N	308348	0	44465007	81151		0
78238	4633	4285898	1992-06-09	1992-06-09 00:00:00	\N	\N	32020		\N	308768	0	68496003	4285898		0
78415	4643	4112343	1909-09-15	1909-09-15 00:00:00	1909-09-27	1909-09-27 00:00:00	32020		\N	309605	0	195662009	4112343		0
78614	4655	195588	2015-12-14	2015-12-14 00:00:00	2016-01-19	2016-01-19 00:00:00	32020		\N	310346	0	38822007	195588		0
78730	4662	257012	1984-11-27	1984-11-27 00:00:00	\N	\N	32020		\N	310795	0	40055000	257012		0
79009	4677	4296205	2000-06-29	2000-06-29 00:00:00	2000-07-27	2000-07-27 00:00:00	32020		\N	311724	0	403191005	4296205		0
79096	4682	4155034	2009-12-19	2009-12-19 00:00:00	2010-01-02	2010-01-02 00:00:00	32020		\N	312045	0	283371005	4155034		0
79312	4696	260139	1962-02-03	1962-02-03 00:00:00	1962-02-10	1962-02-10 00:00:00	32020		\N	312823	0	10509002	260139		0
79505	4709	260139	2000-11-20	2000-11-20 00:00:00	2000-12-04	2000-12-04 00:00:00	32020		\N	313636	0	10509002	260139		0
69047	4086	4134304	2006-06-20	2006-06-20 00:00:00	2006-09-18	2006-09-18 00:00:00	32020		\N	271576	0	263102004	4134304		0
79734	4722	4149245	1924-02-17	1924-02-17 00:00:00	1924-03-25	1924-03-25 00:00:00	32020		\N	314610	0	30832001	4149245		0
69541	4116	81151	1970-09-07	1970-09-07 00:00:00	1970-10-12	1970-10-12 00:00:00	32020		\N	273674	0	44465007	81151		0
69696	4123	4310024	1997-08-15	1997-08-15 00:00:00	\N	\N	32020		\N	274136	0	424802006	4310024		0
80776	4791	40481087	1969-09-19	1969-09-19 00:00:00	1969-10-03	1969-10-03 00:00:00	32020		\N	318777	0	444814009	40481087		0
80973	4802	40481087	1974-10-01	1974-10-01 00:00:00	1974-10-22	1974-10-22 00:00:00	32020		\N	319461	0	444814009	40481087		0
81417	4828	40481087	1969-09-02	1969-09-02 00:00:00	1969-09-16	1969-09-16 00:00:00	32020		\N	321236	0	444814009	40481087		0
81558	4837	375671	1980-11-01	1980-11-01 00:00:00	1980-12-01	1980-12-01 00:00:00	32020		\N	321818	0	62564004	375671		0
71196	4223	372328	1959-02-01	1959-02-01 00:00:00	1959-07-03	1959-07-03 00:00:00	32020		\N	280383	0	65363002	372328		0
81970	4859	260139	1962-02-03	1962-02-03 00:00:00	1962-02-17	1962-02-17 00:00:00	32020		\N	323232	0	10509002	260139		0
82014	4861	40481087	1995-02-11	1995-02-11 00:00:00	1995-02-25	1995-02-25 00:00:00	32020		\N	323417	0	444814009	40481087		0
82302	4883	260139	2004-08-23	2004-08-23 00:00:00	2004-08-30	2004-08-30 00:00:00	32020		\N	324642	0	10509002	260139		0
82422	4890	81151	1969-04-12	1969-04-12 00:00:00	1969-04-26	1969-04-26 00:00:00	32020		\N	325144	0	44465007	81151		0
82565	4899	195588	1951-05-25	1951-05-25 00:00:00	1951-06-25	1951-06-25 00:00:00	32020		\N	325837	0	38822007	195588		0
72201	4284	260139	1996-01-31	1996-01-31 00:00:00	1996-02-07	1996-02-07 00:00:00	32020		\N	284330	0	10509002	260139		0
82878	4922	4283893	1981-01-14	1981-01-14 00:00:00	1981-01-28	1981-01-28 00:00:00	32020		\N	327022	0	36971009	4283893		0
83317	4949	40481087	2001-05-17	2001-05-17 00:00:00	2001-05-31	2001-05-31 00:00:00	32020		\N	329050	0	444814009	40481087		0
83445	4960	4296205	1943-09-30	1943-09-30 00:00:00	1943-10-28	1943-10-28 00:00:00	32020		\N	329706	0	403191005	4296205		0
83781	4976	375671	1987-10-04	1987-10-04 00:00:00	1987-12-03	1987-12-03 00:00:00	32020		\N	331107	0	62564004	375671		0
83947	4987	80180	1997-06-04	1997-06-04 00:00:00	\N	\N	32020		\N	331730	0	396275006	80180		0
73700	4379	80180	2007-11-30	2007-11-30 00:00:00	\N	\N	32020		\N	290965	0	396275006	80180		0
84463	5022	40481087	1997-11-16	1997-11-16 00:00:00	1997-11-23	1997-11-23 00:00:00	32020		\N	333681	0	444814009	40481087		0
84793	5043	80180	2008-03-25	2008-03-25 00:00:00	\N	\N	32020		\N	335173	0	396275006	80180		0
85050	5058	260139	1995-04-25	1995-04-25 00:00:00	1995-05-04	1995-05-04 00:00:00	32020		\N	336282	0	10509002	260139		0
85193	5067	372328	1983-10-13	1983-10-13 00:00:00	1983-12-25	1983-12-25 00:00:00	32020		\N	336840	0	65363002	372328		0
74832	4446	4112343	1982-01-27	1982-01-27 00:00:00	1982-02-09	1982-02-09 00:00:00	32020		\N	295650	0	195662009	4112343		0
74935	4450	257012	1969-11-11	1969-11-11 00:00:00	\N	\N	32020		\N	296088	0	40055000	257012		0
75056	4457	40481087	2009-07-09	2009-07-09 00:00:00	2009-07-23	2009-07-23 00:00:00	32020		\N	296622	0	444814009	40481087		0
75326	4473	81151	1997-08-07	1997-08-07 00:00:00	1997-09-04	1997-09-04 00:00:00	32020		\N	297583	0	44465007	81151		0
64856	3834	372328	1957-10-04	1957-10-04 00:00:00	1957-12-22	1957-12-22 00:00:00	32020		\N	254567	0	65363002	372328		0
75590	4485	40481087	1959-09-04	1959-09-04 00:00:00	1959-09-18	1959-09-18 00:00:00	32020		\N	298583	0	444814009	40481087		0
75717	4491	40481087	1984-05-23	1984-05-23 00:00:00	1984-06-06	1984-06-06 00:00:00	32020		\N	298977	0	444814009	40481087		0
75876	4500	4278672	2010-04-25	2010-04-25 00:00:00	2010-07-24	2010-07-24 00:00:00	32020		\N	299607	0	65966004	4278672		0
76137	4520	372328	1930-11-08	1930-11-08 00:00:00	1931-03-14	1931-03-14 00:00:00	32020		\N	300877	0	65363002	372328		0
76356	4529	28060	1970-03-26	1970-03-26 00:00:00	1970-04-05	1970-04-05 00:00:00	32020		\N	301547	0	43878008	28060		0
76511	4534	40481087	1955-01-15	1955-01-15 00:00:00	1955-02-05	1955-02-05 00:00:00	32020		\N	302081	0	444814009	40481087		0
76647	4544	40481087	1953-09-09	1953-09-09 00:00:00	1953-09-16	1953-09-16 00:00:00	32020		\N	302654	0	444814009	40481087		0
76780	4550	80180	2000-11-13	2000-11-13 00:00:00	\N	\N	32020		\N	303185	0	396275006	80180		0
76938	4559	40481087	1992-05-28	1992-05-28 00:00:00	1992-06-11	1992-06-11 00:00:00	32020		\N	303777	0	444814009	40481087		0
77035	4563	4112343	1985-12-02	1985-12-02 00:00:00	1985-12-13	1985-12-13 00:00:00	32020		\N	304092	0	195662009	4112343		0
87846	5228	40481087	2012-02-07	2012-02-07 00:00:00	2012-02-28	2012-02-28 00:00:00	32020		\N	347788	0	444814009	40481087		0
77501	4591	4112343	1997-02-10	1997-02-10 00:00:00	1997-02-22	1997-02-22 00:00:00	32020		\N	305945	0	195662009	4112343		0
77670	4602	40481087	1996-12-11	1996-12-11 00:00:00	1996-12-25	1996-12-25 00:00:00	32020		\N	306543	0	444814009	40481087		0
77772	4607	40481087	1975-01-09	1975-01-09 00:00:00	1975-01-16	1975-01-16 00:00:00	32020		\N	306920	0	444814009	40481087		0
88582	5265	260139	1990-08-26	1990-08-26 00:00:00	1990-09-09	1990-09-09 00:00:00	32020		\N	350313	0	10509002	260139		0
78110	4628	4112343	1981-06-20	1981-06-20 00:00:00	1981-06-29	1981-06-29 00:00:00	32020		\N	308367	0	195662009	4112343		0
78239	4633	80180	1992-09-07	1992-09-07 00:00:00	\N	\N	32020		\N	308768	0	396275006	80180		0
78416	4643	260139	1913-05-27	1913-05-27 00:00:00	1913-06-03	1913-06-03 00:00:00	32020		\N	309606	0	10509002	260139		0
78615	4655	4112343	1968-02-24	1968-02-24 00:00:00	1968-03-06	1968-03-06 00:00:00	32020		\N	310307	0	195662009	4112343		0
78731	4662	40481087	1977-03-06	1977-03-06 00:00:00	1977-03-13	1977-03-13 00:00:00	32020		\N	310789	0	444814009	40481087		0
79010	4677	81151	1966-03-01	1966-03-01 00:00:00	1966-03-29	1966-03-29 00:00:00	32020		\N	311665	0	44465007	81151		0
79097	4682	260139	2001-05-10	2001-05-10 00:00:00	2001-05-24	2001-05-24 00:00:00	32020		\N	312024	0	10509002	260139		0
79313	4696	372328	1953-03-03	1953-03-03 00:00:00	1953-07-22	1953-07-22 00:00:00	32020		\N	312827	0	65363002	372328		0
79506	4709	40481087	1984-05-15	1984-05-15 00:00:00	1984-05-22	1984-05-22 00:00:00	32020		\N	313635	0	444814009	40481087		0
69048	4086	40481087	1979-07-02	1979-07-02 00:00:00	1979-07-09	1979-07-09 00:00:00	32020		\N	271554	0	444814009	40481087		0
79735	4722	4294548	1945-08-27	1945-08-27 00:00:00	1946-01-14	1946-01-14 00:00:00	32020		\N	314590	0	75498004	4294548		0
69542	4116	4112343	1980-08-16	1980-08-16 00:00:00	1980-08-28	1980-08-28 00:00:00	32020		\N	273626	0	195662009	4112343		0
69697	4123	40481087	1970-06-17	1970-06-17 00:00:00	1970-06-24	1970-06-24 00:00:00	32020		\N	274081	0	444814009	40481087		0
80777	4791	260139	1989-10-27	1989-10-27 00:00:00	1989-11-10	1989-11-10 00:00:00	32020		\N	318801	0	10509002	260139		0
80974	4802	4112343	1999-12-11	1999-12-11 00:00:00	1999-12-18	1999-12-18 00:00:00	32020		\N	319424	0	195662009	4112343		0
81418	4828	4294548	2012-08-03	2012-08-03 00:00:00	2012-08-24	2012-08-24 00:00:00	32020		\N	321240	0	75498004	4294548		0
81559	4837	81151	1963-02-06	1963-02-06 00:00:00	1963-02-20	1963-02-20 00:00:00	32020		\N	321816	0	44465007	81151		0
71197	4223	260139	1971-09-18	1971-09-18 00:00:00	1971-10-02	1971-10-02 00:00:00	32020		\N	280413	0	10509002	260139		0
81971	4859	4134304	1982-07-11	1982-07-11 00:00:00	1982-09-09	1982-09-09 00:00:00	32020		\N	323227	0	263102004	4134304		0
82015	4861	257012	1955-08-21	1955-08-21 00:00:00	\N	\N	32020		\N	323394	0	40055000	257012		0
82303	4883	40481087	1974-08-18	1974-08-18 00:00:00	1974-09-01	1974-09-01 00:00:00	32020		\N	324632	0	444814009	40481087		0
82423	4890	4109685	1942-05-13	1942-05-13 00:00:00	1942-06-03	1942-06-03 00:00:00	32020		\N	325143	0	284551006	4109685		0
82566	4899	28060	1994-07-22	1994-07-22 00:00:00	1994-08-04	1994-08-04 00:00:00	32020		\N	325778	0	43878008	28060		0
72202	4284	40481087	2015-06-14	2015-06-14 00:00:00	2015-06-21	2015-06-21 00:00:00	32020		\N	284367	0	444814009	40481087		0
82879	4922	28060	1981-08-11	1981-08-11 00:00:00	1981-08-20	1981-08-20 00:00:00	32020		\N	326967	0	43878008	28060		0
83318	4949	40481087	2005-08-15	2005-08-15 00:00:00	2005-09-05	2005-09-05 00:00:00	32020		\N	329039	0	444814009	40481087		0
83446	4960	4112343	1939-07-01	1939-07-01 00:00:00	1939-07-12	1939-07-12 00:00:00	32020		\N	329656	0	195662009	4112343		0
83782	4976	28060	1913-01-15	1913-01-15 00:00:00	1913-01-25	1913-01-25 00:00:00	32020		\N	331067	0	43878008	28060		0
83948	4987	4266809	1997-06-04	1997-06-04 00:00:00	\N	\N	32020		\N	331730	0	397881000	4266809		0
73701	4379	260139	1997-07-08	1997-07-08 00:00:00	1997-07-15	1997-07-15 00:00:00	32020		\N	290941	0	10509002	260139		0
84464	5022	4112343	2006-12-29	2006-12-29 00:00:00	2007-01-08	2007-01-08 00:00:00	32020		\N	333645	0	195662009	4112343		0
84794	5043	4149245	1994-08-26	1994-08-26 00:00:00	1994-11-01	1994-11-01 00:00:00	32020		\N	335130	0	30832001	4149245		0
85051	5058	4112343	2002-09-04	2002-09-04 00:00:00	2002-09-16	2002-09-16 00:00:00	32020		\N	336333	0	195662009	4112343		0
85194	5067	28060	1974-08-04	1974-08-04 00:00:00	1974-08-14	1974-08-14 00:00:00	32020		\N	336887	0	43878008	28060		0
74833	4446	4156265	1977-04-21	1977-04-21 00:00:00	1977-05-05	1977-05-05 00:00:00	32020		\N	295666	0	370247008	4156265		0
74936	4451	4112343	1999-11-08	1999-11-08 00:00:00	1999-11-15	1999-11-15 00:00:00	32020		\N	296134	0	195662009	4112343		0
75057	4457	372328	1987-07-18	1987-07-18 00:00:00	1988-04-19	1988-04-19 00:00:00	32020		\N	296623	0	65363002	372328		0
75327	4473	40481087	2005-06-09	2005-06-09 00:00:00	2005-06-16	2005-06-16 00:00:00	32020		\N	297566	0	444814009	40481087		0
64857	3834	4112343	1993-11-12	1993-11-12 00:00:00	1993-11-24	1993-11-24 00:00:00	32020		\N	254581	0	195662009	4112343		0
75591	4485	260139	1994-07-20	1994-07-20 00:00:00	1994-08-03	1994-08-03 00:00:00	32020		\N	298581	0	10509002	260139		0
75718	4491	80180	1984-07-22	1984-07-22 00:00:00	\N	\N	32020		\N	298977	0	396275006	80180		0
75877	4500	40481087	2012-03-20	2012-03-20 00:00:00	2012-04-03	2012-04-03 00:00:00	32020		\N	299594	0	444814009	40481087		0
76139	4520	4329847	1996-09-28	1996-09-28 00:00:00	\N	\N	32020		\N	300940	0	22298006	4329847		0
76357	4529	4112343	1997-12-29	1997-12-29 00:00:00	1998-01-07	1998-01-07 00:00:00	32020		\N	301552	0	195662009	4112343		0
76512	4534	440086	1955-10-24	1955-10-24 00:00:00	1956-01-30	1956-01-30 00:00:00	32020		\N	302097	0	192127007	440086		0
76648	4544	195588	1961-10-18	1961-10-18 00:00:00	1961-11-28	1961-11-28 00:00:00	32020		\N	302710	0	38822007	195588		0
76781	4550	4112343	1966-10-21	1966-10-21 00:00:00	1966-11-01	1966-11-01 00:00:00	32020		\N	303157	0	195662009	4112343		0
76939	4559	260139	1981-11-25	1981-11-25 00:00:00	1981-12-09	1981-12-09 00:00:00	32020		\N	303788	0	10509002	260139		0
77036	4563	260139	2001-11-03	2001-11-03 00:00:00	2001-11-10	2001-11-10 00:00:00	32020		\N	304127	0	10509002	260139		0
87847	5228	372328	1939-10-27	1939-10-27 00:00:00	1940-01-25	1940-01-25 00:00:00	32020		\N	347763	0	65363002	372328		0
77502	4591	40481087	2011-01-18	2011-01-18 00:00:00	2011-02-08	2011-02-08 00:00:00	32020		\N	305931	0	444814009	40481087		0
77671	4602	260139	2015-07-16	2015-07-16 00:00:00	2015-07-30	2015-07-30 00:00:00	32020		\N	306584	0	10509002	260139		0
77773	4607	4112343	1984-03-18	1984-03-18 00:00:00	1984-03-28	1984-03-28 00:00:00	32020		\N	306894	0	195662009	4112343		0
88583	5265	4112343	1996-12-07	1996-12-07 00:00:00	1996-12-17	1996-12-17 00:00:00	32020		\N	350275	0	195662009	4112343		0
78111	4628	4112343	1969-07-27	1969-07-27 00:00:00	1969-08-07	1969-08-07 00:00:00	32020		\N	308308	0	195662009	4112343		0
78240	4633	28060	1991-03-26	1991-03-26 00:00:00	1991-04-05	1991-04-05 00:00:00	32020		\N	308741	0	43878008	28060		0
78417	4643	40481087	1951-03-31	1951-03-31 00:00:00	1951-04-07	1951-04-07 00:00:00	32020		\N	309514	0	444814009	40481087		0
78616	4655	4112343	1974-01-19	1974-01-19 00:00:00	1974-01-26	1974-01-26 00:00:00	32020		\N	310309	0	195662009	4112343		0
78732	4662	4294548	1958-12-26	1958-12-26 00:00:00	1959-01-09	1959-01-09 00:00:00	32020		\N	310786	0	75498004	4294548		0
79011	4677	28060	2016-04-22	2016-04-22 00:00:00	2016-05-03	2016-05-03 00:00:00	32020		\N	311648	0	43878008	28060		0
79098	4682	40481087	1998-01-26	1998-01-26 00:00:00	1998-02-09	1998-02-09 00:00:00	32020		\N	312000	0	444814009	40481087		0
79314	4696	81893	1985-06-28	1985-06-28 00:00:00	\N	\N	32020		\N	312887	0	64766004	81893		0
79507	4709	260139	1993-08-23	1993-08-23 00:00:00	1993-09-06	1993-09-06 00:00:00	32020		\N	313701	0	10509002	260139		0
69049	4086	40481087	2015-11-23	2015-11-23 00:00:00	2015-12-14	2015-12-14 00:00:00	32020		\N	271598	0	444814009	40481087		0
79736	4722	40481087	1941-03-02	1941-03-02 00:00:00	1941-03-23	1941-03-23 00:00:00	32020		\N	314500	0	444814009	40481087		0
69543	4116	4156265	1994-03-01	1994-03-01 00:00:00	1994-03-15	1994-03-15 00:00:00	32020		\N	273676	0	370247008	4156265		0
69698	4123	4142905	2013-02-09	2013-02-09 00:00:00	2013-03-11	2013-03-11 00:00:00	32020		\N	274118	0	33737001	4142905		0
80778	4791	4218389	2007-11-21	2007-11-21 00:00:00	2007-12-19	2007-12-19 00:00:00	32020		\N	318825	0	39848009	4218389		0
80987	4804	4027663	2004-03-14	2004-03-14 00:00:00	\N	\N	32020		\N	319602	0	13200003	4027663		0
81419	4828	4112343	1977-10-01	1977-10-01 00:00:00	1977-10-12	1977-10-12 00:00:00	32020		\N	321246	0	195662009	4112343		0
81560	4837	260139	2006-10-28	2006-10-28 00:00:00	2006-11-04	2006-11-04 00:00:00	32020		\N	321824	0	10509002	260139		0
71198	4223	192671	1989-11-01	1989-11-01 00:00:00	\N	\N	32020		\N	280380	0	K92.2	35208414		0
81972	4859	40481087	1983-06-25	1983-06-25 00:00:00	1983-07-02	1983-07-02 00:00:00	32020		\N	323279	0	444814009	40481087		0
82016	4861	28060	2012-10-18	2012-10-18 00:00:00	2012-10-26	2012-10-26 00:00:00	32020		\N	323407	0	43878008	28060		0
82304	4883	260139	1987-05-17	1987-05-17 00:00:00	1987-05-24	1987-05-24 00:00:00	32020		\N	324702	0	10509002	260139		0
82424	4890	80502	2000-09-06	2000-09-06 00:00:00	\N	\N	32020		\N	325251	0	64859006	80502		0
82567	4899	4112343	1994-05-12	1994-05-12 00:00:00	1994-05-19	1994-05-19 00:00:00	32020		\N	325805	0	195662009	4112343		0
72203	4284	260139	1979-12-29	1979-12-29 00:00:00	1980-01-12	1980-01-12 00:00:00	32020		\N	284327	0	10509002	260139		0
82880	4922	260139	2007-08-01	2007-08-01 00:00:00	2007-08-08	2007-08-08 00:00:00	32020		\N	327078	0	10509002	260139		0
83319	4949	40481087	1995-10-25	1995-10-25 00:00:00	1995-11-15	1995-11-15 00:00:00	32020		\N	329038	0	444814009	40481087		0
83447	4960	40481087	1931-03-28	1931-03-28 00:00:00	1931-04-18	1931-04-18 00:00:00	32020		\N	329671	0	444814009	40481087		0
83783	4976	40481087	1991-09-14	1991-09-14 00:00:00	1991-09-28	1991-09-28 00:00:00	32020		\N	330985	0	444814009	40481087		0
83949	4987	4112343	1960-05-20	1960-05-20 00:00:00	1960-06-02	1960-06-02 00:00:00	32020		\N	331754	0	195662009	4112343		0
73702	4379	372328	1974-11-18	1974-11-18 00:00:00	1975-06-03	1975-06-03 00:00:00	32020		\N	290975	0	65363002	372328		0
84465	5022	4116491	1992-12-25	1992-12-25 00:00:00	1993-01-28	1993-01-28 00:00:00	32020		\N	333695	0	301011002	4116491		0
84795	5043	4283893	2004-10-22	2004-10-22 00:00:00	2004-12-17	2004-12-17 00:00:00	32020		\N	335111	0	36971009	4283893		0
85052	5058	40481087	2009-07-18	2009-07-18 00:00:00	2009-08-01	2009-08-01 00:00:00	32020		\N	336286	0	444814009	40481087		0
85195	5067	4142905	1988-12-06	1988-12-06 00:00:00	1989-02-04	1989-02-04 00:00:00	32020		\N	336817	0	33737001	4142905		0
74834	4446	28060	1972-02-23	1972-02-23 00:00:00	1972-03-07	1972-03-07 00:00:00	32020		\N	295668	0	43878008	28060		0
74937	4451	260139	1974-12-27	1974-12-27 00:00:00	1975-01-03	1975-01-03 00:00:00	32020		\N	296098	0	10509002	260139		0
75058	4457	4112343	1985-06-01	1985-06-01 00:00:00	1985-06-11	1985-06-11 00:00:00	32020		\N	296661	0	195662009	4112343		0
75328	4473	4112343	2002-07-03	2002-07-03 00:00:00	2002-07-13	2002-07-13 00:00:00	32020		\N	297588	0	195662009	4112343		0
64858	3834	80180	1994-06-27	1994-06-27 00:00:00	\N	\N	32020		\N	254581	0	396275006	80180		0
75592	4485	40481087	1972-04-14	1972-04-14 00:00:00	1972-04-28	1972-04-28 00:00:00	32020		\N	298598	0	444814009	40481087		0
75719	4491	4218389	1975-05-02	1975-05-02 00:00:00	1975-05-23	1975-05-23 00:00:00	32020		\N	299024	0	39848009	4218389		0
75878	4500	4155034	1984-03-16	1984-03-16 00:00:00	1984-03-30	1984-03-30 00:00:00	32020		\N	299603	0	283371005	4155034		0
76140	4520	317576	1991-01-05	1991-01-05 00:00:00	\N	\N	32020		\N	300927	0	53741008	317576		0
76358	4529	260139	1965-04-12	1965-04-12 00:00:00	1965-04-19	1965-04-19 00:00:00	32020		\N	301546	0	10509002	260139		0
76513	4534	260139	1995-01-05	1995-01-05 00:00:00	1995-01-12	1995-01-12 00:00:00	32020		\N	302023	0	10509002	260139		0
76649	4544	40481087	1942-12-16	1942-12-16 00:00:00	1942-12-30	1942-12-30 00:00:00	32020		\N	302673	0	444814009	40481087		0
76782	4550	40481087	1989-12-06	1989-12-06 00:00:00	1989-12-13	1989-12-13 00:00:00	32020		\N	303216	0	444814009	40481087		0
76940	4559	40481087	2009-05-18	2009-05-18 00:00:00	2009-06-08	2009-06-08 00:00:00	32020		\N	303794	0	444814009	40481087		0
77037	4563	80180	2003-07-21	2003-07-21 00:00:00	\N	\N	32020		\N	304127	0	396275006	80180		0
87848	5228	4116491	1972-09-30	1972-09-30 00:00:00	1972-10-31	1972-10-31 00:00:00	32020		\N	347780	0	301011002	4116491		0
77503	4591	4156265	2018-04-08	2018-04-08 00:00:00	2018-04-29	2018-04-29 00:00:00	32020		\N	305898	0	370247008	4156265		0
77672	4602	4112343	1996-06-16	1996-06-16 00:00:00	1996-06-27	1996-06-27 00:00:00	32020		\N	306538	0	195662009	4112343		0
77774	4607	40481087	2013-12-01	2013-12-01 00:00:00	2013-12-15	2013-12-15 00:00:00	32020		\N	306909	0	444814009	40481087		0
88584	5265	81151	2012-02-11	2012-02-11 00:00:00	2012-03-03	2012-03-03 00:00:00	32020		\N	350272	0	44465007	81151		0
78112	4628	40481087	2004-08-19	2004-08-19 00:00:00	2004-09-09	2004-09-09 00:00:00	32020		\N	308330	0	444814009	40481087		0
78241	4633	372328	1960-09-28	1960-09-28 00:00:00	1960-11-01	1960-11-01 00:00:00	32020		\N	308742	0	65363002	372328		0
78418	4643	40481087	1996-06-02	1996-06-02 00:00:00	1996-06-23	1996-06-23 00:00:00	32020		\N	309531	0	444814009	40481087		0
78617	4655	4112343	2006-06-20	2006-06-20 00:00:00	2006-07-02	2006-07-02 00:00:00	32020		\N	310334	0	195662009	4112343		0
78733	4662	40481087	1958-08-30	1958-08-30 00:00:00	1958-09-20	1958-09-20 00:00:00	32020		\N	310738	0	444814009	40481087		0
79012	4677	4113008	1993-10-13	1993-10-13 00:00:00	1993-11-03	1993-11-03 00:00:00	32020		\N	311723	0	284549007	4113008		0
79099	4682	4112343	1997-02-25	1997-02-25 00:00:00	1997-03-04	1997-03-04 00:00:00	32020		\N	312006	0	195662009	4112343		0
79315	4696	80180	1985-12-25	1985-12-25 00:00:00	\N	\N	32020		\N	312887	0	396275006	80180		0
79508	4709	4294548	1988-12-06	1988-12-06 00:00:00	1989-06-06	1989-06-06 00:00:00	32020		\N	313648	0	75498004	4294548		0
69050	4086	80180	2016-08-31	2016-08-31 00:00:00	\N	\N	32020		\N	271598	0	396275006	80180		0
79745	4724	260139	1993-05-14	1993-05-14 00:00:00	1993-05-21	1993-05-21 00:00:00	32020		\N	314756	0	10509002	260139		0
69544	4116	81893	2010-09-02	2010-09-02 00:00:00	\N	\N	32020		\N	273633	0	64766004	81893		0
69699	4123	40481087	2018-08-10	2018-08-10 00:00:00	2018-08-31	2018-08-31 00:00:00	32020		\N	274121	0	444814009	40481087		0
80779	4791	260139	1970-03-12	1970-03-12 00:00:00	1970-03-26	1970-03-26 00:00:00	32020		\N	318811	0	10509002	260139		0
80988	4804	4084167	1978-01-15	1978-01-15 00:00:00	1978-01-15	1978-01-15 00:00:00	32020		\N	319590	0	241929008	4084167		0
81420	4828	40481087	1978-01-10	1978-01-10 00:00:00	1978-01-17	1978-01-17 00:00:00	32020		\N	321303	0	444814009	40481087		0
81561	4837	313217	2008-11-18	2008-11-18 00:00:00	\N	\N	32020		\N	321813	0	49436004	313217		0
71199	4223	4134304	1972-04-06	1972-04-06 00:00:00	1972-07-05	1972-07-05 00:00:00	32020		\N	280378	0	263102004	4134304		0
81973	4859	4112343	1974-07-01	1974-07-01 00:00:00	1974-07-10	1974-07-10 00:00:00	32020		\N	323278	0	195662009	4112343		0
82017	4861	80502	2007-05-22	2007-05-22 00:00:00	\N	\N	32020		\N	323399	0	64859006	80502		0
82305	4883	4112343	1993-08-19	1993-08-19 00:00:00	1993-08-29	1993-08-29 00:00:00	32020		\N	324636	0	195662009	4112343		0
82425	4890	260139	1971-01-29	1971-01-29 00:00:00	1971-02-05	1971-02-05 00:00:00	32020		\N	325183	0	10509002	260139		0
82568	4899	4283893	1961-07-04	1961-07-04 00:00:00	1961-08-01	1961-08-01 00:00:00	32020		\N	325752	0	36971009	4283893		0
72204	4284	372328	1958-03-20	1958-03-20 00:00:00	1959-01-15	1959-01-15 00:00:00	32020		\N	284368	0	65363002	372328		0
82881	4922	28060	2013-01-04	2013-01-04 00:00:00	2013-01-14	2013-01-14 00:00:00	32020		\N	327044	0	43878008	28060		0
83448	4960	260139	1948-01-02	1948-01-02 00:00:00	1948-01-16	1948-01-16 00:00:00	32020		\N	329659	0	10509002	260139		0
83784	4976	40481087	1994-04-24	1994-04-24 00:00:00	1994-05-15	1994-05-15 00:00:00	32020		\N	331017	0	444814009	40481087		0
78808	4668	80180	1997-05-20	1997-05-20 00:00:00	\N	\N	32020		\N	311048	0	396275006	80180		0
83950	4987	40481087	1995-10-22	1995-10-22 00:00:00	1995-11-12	1995-11-12 00:00:00	32020		\N	331767	0	444814009	40481087		0
73703	4380	4112343	1986-06-07	1986-06-07 00:00:00	1986-06-18	1986-06-18 00:00:00	32020		\N	291033	0	195662009	4112343		0
84466	5022	4112343	2000-11-16	2000-11-16 00:00:00	2000-11-28	2000-11-28 00:00:00	32020		\N	333682	0	195662009	4112343		0
84796	5043	4112343	1975-11-06	1975-11-06 00:00:00	1975-11-19	1975-11-19 00:00:00	32020		\N	335133	0	195662009	4112343		0
85053	5058	80502	2017-03-05	2017-03-05 00:00:00	\N	\N	32020		\N	336327	0	64859006	80502		0
85196	5067	4051466	1978-06-08	1978-06-08 00:00:00	1993-09-18	1993-09-18 00:00:00	32020		\N	336888	0	233678006	4051466		0
74835	4446	40481087	1998-08-03	1998-08-03 00:00:00	1998-08-17	1998-08-17 00:00:00	32020		\N	295639	0	444814009	40481087		0
74938	4451	4149245	1997-02-24	1997-02-24 00:00:00	1997-04-02	1997-04-02 00:00:00	32020		\N	296140	0	30832001	4149245		0
75059	4457	40481087	1985-01-06	1985-01-06 00:00:00	1985-01-27	1985-01-27 00:00:00	32020		\N	296630	0	444814009	40481087		0
75329	4473	378001	2001-06-15	2001-06-15 00:00:00	2001-07-15	2001-07-15 00:00:00	32020		\N	297584	0	62106007	378001		0
64859	3834	372328	1959-11-12	1959-11-12 00:00:00	1960-06-26	1960-06-26 00:00:00	32020		\N	254555	0	65363002	372328		0
75593	4485	40481087	1990-08-21	1990-08-21 00:00:00	1990-09-04	1990-09-04 00:00:00	32020		\N	298585	0	444814009	40481087		0
75720	4491	40481087	1992-06-29	1992-06-29 00:00:00	1992-07-13	1992-07-13 00:00:00	32020		\N	298968	0	444814009	40481087		0
75879	4500	40481087	2003-11-05	2003-11-05 00:00:00	2003-11-12	2003-11-12 00:00:00	32020		\N	299578	0	444814009	40481087		0
76141	4520	260139	1981-02-24	1981-02-24 00:00:00	1981-03-10	1981-03-10 00:00:00	32020		\N	300874	0	10509002	260139		0
76359	4529	40481087	1980-08-28	1980-08-28 00:00:00	1980-09-18	1980-09-18 00:00:00	32020		\N	301548	0	444814009	40481087		0
76514	4534	260139	1973-02-22	1973-02-22 00:00:00	1973-03-08	1973-03-08 00:00:00	32020		\N	302085	0	10509002	260139		0
76650	4544	4310024	1981-06-10	1981-06-10 00:00:00	\N	\N	32020		\N	302717	0	424802006	4310024		0
76783	4550	40481087	1976-06-19	1976-06-19 00:00:00	1976-07-10	1976-07-10 00:00:00	32020		\N	303276	0	444814009	40481087		0
76941	4559	195588	2001-12-05	2001-12-05 00:00:00	2002-01-07	2002-01-07 00:00:00	32020		\N	303738	0	38822007	195588		0
77038	4563	4112343	2010-05-12	2010-05-12 00:00:00	2010-05-24	2010-05-24 00:00:00	32020		\N	304109	0	195662009	4112343		0
87849	5228	4112343	1970-04-03	1970-04-03 00:00:00	1970-04-12	1970-04-12 00:00:00	32020		\N	347761	0	195662009	4112343		0
77504	4591	260139	1982-10-05	1982-10-05 00:00:00	1982-10-19	1982-10-19 00:00:00	32020		\N	305925	0	10509002	260139		0
77673	4602	4112343	2004-02-20	2004-02-20 00:00:00	2004-03-02	2004-03-02 00:00:00	32020		\N	306567	0	195662009	4112343		0
77775	4607	40481087	2007-07-30	2007-07-30 00:00:00	2007-08-13	2007-08-13 00:00:00	32020		\N	306919	0	444814009	40481087		0
88586	5265	321042	2008-06-05	2008-06-05 00:00:00	\N	\N	32020		\N	350271	0	410429000	321042		0
78113	4628	80180	2004-09-05	2004-09-05 00:00:00	\N	\N	32020		\N	308330	0	396275006	80180		0
78242	4633	40479768	1974-01-05	1974-01-05 00:00:00	1974-03-13	1974-03-13 00:00:00	32020		\N	308763	0	444470001	40479768		0
78419	4643	4156265	1912-12-27	1912-12-27 00:00:00	1913-01-10	1913-01-10 00:00:00	32020		\N	309566	0	370247008	4156265		0
78618	4655	40481087	2018-07-27	2018-07-27 00:00:00	2018-08-03	2018-08-03 00:00:00	32020		\N	310338	0	444814009	40481087		0
78753	4665	40481087	2016-08-05	2016-08-05 00:00:00	2016-08-19	2016-08-19 00:00:00	32020		\N	310875	0	444814009	40481087		0
79013	4677	4112343	2011-06-04	2011-06-04 00:00:00	2011-06-14	2011-06-14 00:00:00	32020		\N	311679	0	195662009	4112343		0
79100	4682	40481087	1984-01-28	1984-01-28 00:00:00	1984-02-18	1984-02-18 00:00:00	32020		\N	312022	0	444814009	40481087		0
79316	4696	40481087	1968-07-26	1968-07-26 00:00:00	1968-08-09	1968-08-09 00:00:00	32020		\N	312896	0	444814009	40481087		0
79509	4709	372328	1956-06-06	1956-06-06 00:00:00	1956-08-13	1956-08-13 00:00:00	32020		\N	313637	0	65363002	372328		0
69051	4086	260139	1979-02-28	1979-02-28 00:00:00	1979-03-07	1979-03-07 00:00:00	32020		\N	271594	0	10509002	260139		0
79746	4724	372328	1942-03-03	1942-03-03 00:00:00	1942-04-15	1942-04-15 00:00:00	32020		\N	314817	0	65363002	372328		0
69545	4116	40481087	2009-11-18	2009-11-18 00:00:00	2009-12-02	2009-12-02 00:00:00	32020		\N	273633	0	444814009	40481087		0
69700	4123	372328	1963-08-14	1963-08-14 00:00:00	1963-12-01	1963-12-01 00:00:00	32020		\N	274142	0	65363002	372328		0
80780	4791	40481087	1984-10-30	1984-10-30 00:00:00	1984-11-06	1984-11-06 00:00:00	32020		\N	318779	0	444814009	40481087		0
80989	4804	40481087	2004-09-25	2004-09-25 00:00:00	2004-10-09	2004-10-09 00:00:00	32020		\N	319573	0	444814009	40481087		0
81421	4828	40481087	2012-05-20	2012-05-20 00:00:00	2012-05-27	2012-05-27 00:00:00	32020		\N	321289	0	444814009	40481087		0
81562	4837	321042	2004-03-23	2004-03-23 00:00:00	\N	\N	32020		\N	321870	0	410429000	321042		0
71200	4223	260139	1976-11-19	1976-11-19 00:00:00	1976-11-26	1976-11-26 00:00:00	32020		\N	280359	0	10509002	260139		0
81974	4860	192671	2011-11-04	2011-11-04 00:00:00	\N	\N	32020		\N	323338	0	K92.2	35208414		0
82018	4861	4230399	2008-05-09	2008-05-09 00:00:00	2008-06-08	2008-06-08 00:00:00	32020		\N	323459	0	359817006	4230399		0
82306	4883	28060	1981-12-09	1981-12-09 00:00:00	1981-12-22	1981-12-22 00:00:00	32020		\N	324634	0	43878008	28060		0
82426	4890	40481087	1926-11-09	1926-11-09 00:00:00	1926-11-30	1926-11-30 00:00:00	32020		\N	325079	0	444814009	40481087		0
82569	4899	81151	1998-03-01	1998-03-01 00:00:00	1998-03-15	1998-03-15 00:00:00	32020		\N	325813	0	44465007	81151		0
72205	4284	372328	1945-10-02	1945-10-02 00:00:00	1945-11-08	1945-11-08 00:00:00	32020		\N	284406	0	65363002	372328		0
82882	4922	80180	2013-06-15	2013-06-15 00:00:00	\N	\N	32020		\N	327044	0	396275006	80180		0
83449	4960	28060	1919-05-13	1919-05-13 00:00:00	1919-05-26	1919-05-26 00:00:00	32020		\N	329715	0	43878008	28060		0
83785	4976	378419	1986-07-15	1986-07-15 00:00:00	\N	\N	32020		\N	330997	0	26929004	378419		0
83951	4987	4283893	1969-02-07	1969-02-07 00:00:00	1969-05-23	1969-05-23 00:00:00	32020		\N	331765	0	36971009	4283893		0
73704	4380	40481087	2009-05-04	2009-05-04 00:00:00	2009-05-11	2009-05-11 00:00:00	32020		\N	291025	0	444814009	40481087		0
84467	5022	378001	1995-01-12	1995-01-12 00:00:00	1995-03-13	1995-03-13 00:00:00	32020		\N	333662	0	62106007	378001		0
84797	5043	4112343	1976-09-17	1976-09-17 00:00:00	1976-09-28	1976-09-28 00:00:00	32020		\N	335162	0	195662009	4112343		0
85054	5058	260139	1991-04-19	1991-04-19 00:00:00	1991-05-03	1991-05-03 00:00:00	32020		\N	336306	0	10509002	260139		0
85197	5067	40481087	1980-12-02	1980-12-02 00:00:00	1980-12-16	1980-12-16 00:00:00	32020		\N	336851	0	444814009	40481087		0
74836	4446	40481087	1984-02-28	1984-02-28 00:00:00	1984-03-06	1984-03-06 00:00:00	32020		\N	295651	0	444814009	40481087		0
74939	4451	4142905	1976-04-01	1976-04-01 00:00:00	1976-05-01	1976-05-01 00:00:00	32020		\N	296138	0	33737001	4142905		0
75060	4457	4112343	2015-09-11	2015-09-11 00:00:00	2015-09-19	2015-09-19 00:00:00	32020		\N	296632	0	195662009	4112343		0
75330	4473	40481087	1977-04-29	1977-04-29 00:00:00	1977-05-20	1977-05-20 00:00:00	32020		\N	297609	0	444814009	40481087		0
64860	3834	40481087	1957-12-22	1957-12-22 00:00:00	1957-12-29	1957-12-29 00:00:00	32020		\N	254559	0	444814009	40481087		0
75594	4485	4113008	2003-05-07	2003-05-07 00:00:00	2003-05-21	2003-05-21 00:00:00	32020		\N	298619	0	284549007	4113008		0
75721	4491	4112343	2003-05-15	2003-05-15 00:00:00	2003-05-27	2003-05-27 00:00:00	32020		\N	298942	0	195662009	4112343		0
75880	4500	40481087	1977-10-26	1977-10-26 00:00:00	1977-11-09	1977-11-09 00:00:00	32020		\N	299548	0	444814009	40481087		0
76142	4520	81151	1945-10-27	1945-10-27 00:00:00	1945-11-10	1945-11-10 00:00:00	32020		\N	300892	0	44465007	81151		0
76360	4529	28060	1965-11-08	1965-11-08 00:00:00	1965-11-15	1965-11-15 00:00:00	32020		\N	301566	0	43878008	28060		0
76515	4534	40481087	2008-06-10	2008-06-10 00:00:00	2008-06-24	2008-06-24 00:00:00	32020		\N	302045	0	444814009	40481087		0
76651	4544	260139	1949-06-20	1949-06-20 00:00:00	1949-07-04	1949-07-04 00:00:00	32020		\N	302680	0	10509002	260139		0
76784	4550	372328	1963-06-06	1963-06-06 00:00:00	1963-08-18	1963-08-18 00:00:00	32020		\N	303207	0	65363002	372328		0
76942	4559	40481087	1976-08-18	1976-08-18 00:00:00	1976-08-25	1976-08-25 00:00:00	32020		\N	303792	0	444814009	40481087		0
77039	4563	4112343	1997-09-15	1997-09-15 00:00:00	1997-09-25	1997-09-25 00:00:00	32020		\N	304066	0	195662009	4112343		0
87850	5228	192671	1969-01-21	1969-01-21 00:00:00	\N	\N	32020		\N	347756	0	K92.2	35208414		0
77505	4591	375671	2005-11-12	2005-11-12 00:00:00	2006-01-11	2006-01-11 00:00:00	32020		\N	305897	0	62564004	375671		0
77674	4602	440086	1987-05-07	1987-05-07 00:00:00	1989-03-02	1989-03-02 00:00:00	32020		\N	306549	0	192127007	440086		0
77776	4607	40481087	2018-07-31	2018-07-31 00:00:00	2018-08-14	2018-08-14 00:00:00	32020		\N	306910	0	444814009	40481087		0
88587	5265	40481087	1995-08-08	1995-08-08 00:00:00	1995-08-15	1995-08-15 00:00:00	32020		\N	350281	0	444814009	40481087		0
78114	4628	378001	2007-07-12	2007-07-12 00:00:00	2007-08-11	2007-08-11 00:00:00	32020		\N	308351	0	62106007	378001		0
78243	4633	260139	1991-08-03	1991-08-03 00:00:00	1991-08-10	1991-08-10 00:00:00	32020		\N	308805	0	10509002	260139		0
78420	4643	4142905	1985-02-03	1985-02-03 00:00:00	1985-03-05	1985-03-05 00:00:00	32020		\N	309627	0	33737001	4142905		0
78619	4655	81151	1965-04-11	1965-04-11 00:00:00	1965-05-02	1965-05-02 00:00:00	32020		\N	310299	0	44465007	81151		0
78754	4665	81893	2015-05-04	2015-05-04 00:00:00	\N	\N	32020		\N	310902	0	64766004	81893		0
79014	4677	4294548	1966-07-05	1966-07-05 00:00:00	1966-08-02	1966-08-02 00:00:00	32020		\N	311644	0	75498004	4294548		0
79101	4682	257012	1986-11-01	1986-11-01 00:00:00	\N	\N	32020		\N	312003	0	40055000	257012		0
79343	4700	40481087	2016-08-30	2016-08-30 00:00:00	2016-09-06	2016-09-06 00:00:00	32020		\N	313068	0	444814009	40481087		0
79510	4709	257012	1989-02-28	1989-02-28 00:00:00	\N	\N	32020		\N	313649	0	40055000	257012		0
69052	4086	260139	1991-10-02	1991-10-02 00:00:00	1991-10-16	1991-10-16 00:00:00	32020		\N	271619	0	10509002	260139		0
79747	4724	372328	1946-11-26	1946-11-26 00:00:00	1947-04-23	1947-04-23 00:00:00	32020		\N	314800	0	65363002	372328		0
69546	4116	372328	1969-08-13	1969-08-13 00:00:00	1969-09-25	1969-09-25 00:00:00	32020		\N	273634	0	65363002	372328		0
69701	4123	4152936	1965-07-04	1965-07-04 00:00:00	1965-07-25	1965-07-25 00:00:00	32020		\N	274113	0	283385000	4152936		0
80781	4791	80180	2004-08-03	2004-08-03 00:00:00	\N	\N	32020		\N	318808	0	396275006	80180		0
80990	4804	4084167	1990-09-10	1990-09-10 00:00:00	1990-09-10	1990-09-10 00:00:00	32020		\N	319591	0	241929008	4084167		0
81422	4828	378001	1986-05-21	1986-05-21 00:00:00	1986-06-20	1986-06-20 00:00:00	32020		\N	321253	0	62106007	378001		0
81615	4843	375671	1997-07-14	1997-07-14 00:00:00	1997-08-13	1997-08-13 00:00:00	32020		\N	322110	0	62564004	375671		0
71201	4223	4112343	1984-12-06	1984-12-06 00:00:00	1984-12-17	1984-12-17 00:00:00	32020		\N	280427	0	195662009	4112343		0
81975	4860	378001	1983-09-03	1983-09-03 00:00:00	1983-11-02	1983-11-02 00:00:00	32020		\N	323339	0	62106007	378001		0
82019	4861	40480160	2008-05-09	2008-05-09 00:00:00	2008-06-08	2008-06-08 00:00:00	32020		\N	323459	0	443165006	40480160		0
82307	4883	4112343	1982-12-20	1982-12-20 00:00:00	1983-01-02	1983-01-02 00:00:00	32020		\N	324635	0	195662009	4112343		0
82427	4890	40481087	1998-02-17	1998-02-17 00:00:00	1998-03-03	1998-03-03 00:00:00	32020		\N	325249	0	444814009	40481087		0
82570	4899	4112343	1921-10-27	1921-10-27 00:00:00	1921-11-04	1921-11-04 00:00:00	32020		\N	325786	0	195662009	4112343		0
72206	4284	80180	1976-07-17	1976-07-17 00:00:00	\N	\N	32020		\N	284344	0	396275006	80180		0
82883	4922	40481087	2003-01-12	2003-01-12 00:00:00	2003-02-02	2003-02-02 00:00:00	32020		\N	327019	0	444814009	40481087		0
83450	4960	378001	1982-02-01	1982-02-01 00:00:00	1982-04-02	1982-04-02 00:00:00	32020		\N	329711	0	62106007	378001		0
83786	4976	40481087	1967-08-10	1967-08-10 00:00:00	1967-08-17	1967-08-17 00:00:00	32020		\N	330936	0	444814009	40481087		0
83952	4987	4112343	2008-09-16	2008-09-16 00:00:00	2008-09-25	2008-09-25 00:00:00	32020		\N	331712	0	195662009	4112343		0
84163	4999	378001	1999-07-06	1999-07-06 00:00:00	1999-09-04	1999-09-04 00:00:00	32020		\N	332469	0	62106007	378001		0
84468	5022	40481087	1998-01-01	1998-01-01 00:00:00	1998-01-08	1998-01-08 00:00:00	32020		\N	333643	0	444814009	40481087		0
84798	5043	4112343	2007-07-31	2007-07-31 00:00:00	2007-08-10	2007-08-10 00:00:00	32020		\N	335112	0	195662009	4112343		0
85055	5058	4027663	1969-01-30	1969-01-30 00:00:00	\N	\N	32020		\N	336350	0	13200003	4027663		0
85198	5067	260139	1990-07-30	1990-07-30 00:00:00	1990-08-13	1990-08-13 00:00:00	32020		\N	336865	0	10509002	260139		0
74837	4446	4112343	1970-11-17	1970-11-17 00:00:00	1970-11-26	1970-11-26 00:00:00	32020		\N	295649	0	195662009	4112343		0
74940	4451	28060	1976-07-03	1976-07-03 00:00:00	1976-07-15	1976-07-15 00:00:00	32020		\N	296165	0	43878008	28060		0
75061	4457	28060	2003-11-02	2003-11-02 00:00:00	2003-11-09	2003-11-09 00:00:00	32020		\N	296621	0	43878008	28060		0
75331	4473	81151	2004-06-29	2004-06-29 00:00:00	2004-08-03	2004-08-03 00:00:00	32020		\N	297585	0	44465007	81151		0
64861	3834	260139	1967-06-15	1967-06-15 00:00:00	1967-06-29	1967-06-29 00:00:00	32020		\N	254620	0	10509002	260139		0
75595	4485	40481087	2012-12-06	2012-12-06 00:00:00	2012-12-20	2012-12-20 00:00:00	32020		\N	298586	0	444814009	40481087		0
75722	4491	4059173	1992-04-07	1992-04-07 00:00:00	1992-06-06	1992-06-06 00:00:00	32020		\N	299027	0	16114001	4059173		0
75881	4500	78272	2011-06-19	2011-06-19 00:00:00	2011-07-24	2011-07-24 00:00:00	32020		\N	299608	0	70704007	78272		0
76143	4520	80180	1962-05-15	1962-05-15 00:00:00	\N	\N	32020		\N	300923	0	396275006	80180		0
86819	5169	80180	1996-07-05	1996-07-05 00:00:00	\N	\N	32020		\N	343703	0	396275006	80180		0
76516	4534	260139	2003-02-11	2003-02-11 00:00:00	2003-02-18	2003-02-18 00:00:00	32020		\N	302025	0	10509002	260139		0
76652	4544	4112343	1984-04-02	1984-04-02 00:00:00	1984-04-14	1984-04-14 00:00:00	32020		\N	302656	0	195662009	4112343		0
76785	4550	40481087	1989-03-11	1989-03-11 00:00:00	1989-04-01	1989-04-01 00:00:00	32020		\N	303180	0	444814009	40481087		0
76943	4559	260139	2015-05-25	2015-05-25 00:00:00	2015-06-01	2015-06-01 00:00:00	32020		\N	303741	0	10509002	260139		0
77040	4563	40481087	2019-03-14	2019-03-14 00:00:00	2019-03-21	2019-03-21 00:00:00	32020		\N	304095	0	444814009	40481087		0
87851	5228	4112343	1956-09-30	1956-09-30 00:00:00	1956-10-11	1956-10-11 00:00:00	32020		\N	347784	0	195662009	4112343		0
77506	4591	4113008	1989-11-22	1989-11-22 00:00:00	1989-12-06	1989-12-06 00:00:00	32020		\N	305896	0	284549007	4113008		0
77675	4602	28060	1985-12-26	1985-12-26 00:00:00	1986-01-07	1986-01-07 00:00:00	32020		\N	306532	0	43878008	28060		0
77777	4607	28060	1973-09-15	1973-09-15 00:00:00	1973-09-26	1973-09-26 00:00:00	32020		\N	306918	0	43878008	28060		0
88592	5267	81893	2004-06-17	2004-06-17 00:00:00	\N	\N	32020		\N	350426	0	64766004	81893		0
78115	4628	372328	1971-10-31	1971-10-31 00:00:00	1972-03-05	1972-03-05 00:00:00	32020		\N	308332	0	65363002	372328		0
78244	4633	313217	2009-12-01	2009-12-01 00:00:00	\N	\N	32020		\N	308816	0	49436004	313217		0
78421	4643	378001	1970-10-20	1970-10-20 00:00:00	1970-12-19	1970-12-19 00:00:00	32020		\N	309625	0	62106007	378001		0
78620	4655	4029498	1982-12-08	1982-12-08 00:00:00	\N	\N	32020		\N	310302	0	128613002	4029498		0
78755	4665	80180	2015-11-30	2015-11-30 00:00:00	\N	\N	32020		\N	310902	0	396275006	80180		0
79015	4677	4112343	2002-01-10	2002-01-10 00:00:00	2002-01-21	2002-01-21 00:00:00	32020		\N	311656	0	195662009	4112343		0
79102	4682	81151	1984-03-23	1984-03-23 00:00:00	1984-04-06	1984-04-06 00:00:00	32020		\N	312042	0	44465007	81151		0
79344	4700	260139	2015-03-13	2015-03-13 00:00:00	2015-03-20	2015-03-20 00:00:00	32020		\N	313057	0	10509002	260139		0
79511	4709	4113008	1962-03-07	1962-03-07 00:00:00	1962-03-21	1962-03-21 00:00:00	32020		\N	313645	0	284549007	4113008		0
69053	4086	4155034	1994-08-31	1994-08-31 00:00:00	1994-09-21	1994-09-21 00:00:00	32020		\N	271575	0	283371005	4155034		0
79748	4724	40481087	1956-02-16	1956-02-16 00:00:00	1956-03-01	1956-03-01 00:00:00	32020		\N	314734	0	444814009	40481087		0
69547	4116	260139	2006-01-28	2006-01-28 00:00:00	2006-02-11	2006-02-11 00:00:00	32020		\N	273632	0	10509002	260139		0
69702	4123	4112343	2015-02-08	2015-02-08 00:00:00	2015-02-17	2015-02-17 00:00:00	32020		\N	274120	0	195662009	4112343		0
80782	4791	40481087	1997-08-10	1997-08-10 00:00:00	1997-08-24	1997-08-24 00:00:00	32020		\N	318791	0	444814009	40481087		0
80991	4804	260139	1978-10-14	1978-10-14 00:00:00	1978-10-21	1978-10-21 00:00:00	32020		\N	319615	0	10509002	260139		0
81423	4828	28060	1982-04-19	1982-04-19 00:00:00	1982-04-28	1982-04-28 00:00:00	32020		\N	321266	0	43878008	28060		0
81616	4843	4285898	1997-07-31	1997-07-31 00:00:00	\N	\N	32020		\N	322110	0	68496003	4285898		0
71202	4223	28060	1968-07-14	1968-07-14 00:00:00	1968-07-21	1968-07-21 00:00:00	32020		\N	280357	0	43878008	28060		0
81976	4860	40481087	2006-09-07	2006-09-07 00:00:00	2006-09-21	2006-09-21 00:00:00	32020		\N	323322	0	444814009	40481087		0
82020	4861	28060	1985-04-21	1985-04-21 00:00:00	1985-04-29	1985-04-29 00:00:00	32020		\N	323423	0	43878008	28060		0
82308	4883	4112343	2017-01-09	2017-01-09 00:00:00	2017-01-16	2017-01-16 00:00:00	32020		\N	324637	0	195662009	4112343		0
82428	4890	40481087	1970-06-07	1970-06-07 00:00:00	1970-06-28	1970-06-28 00:00:00	32020		\N	325199	0	444814009	40481087		0
82571	4899	40479422	1976-10-15	1976-10-15 00:00:00	1976-12-21	1976-12-21 00:00:00	32020		\N	325810	0	444448004	40479422		0
72207	4284	28060	2011-09-29	2011-09-29 00:00:00	2011-10-07	2011-10-07 00:00:00	32020		\N	284395	0	43878008	28060		0
82884	4922	4283893	2010-11-01	2010-11-01 00:00:00	2011-01-03	2011-01-03 00:00:00	32020		\N	327051	0	36971009	4283893		0
83451	4960	140673	1977-03-31	1977-03-31 00:00:00	\N	\N	32020		\N	329696	0	40930008	140673		0
83787	4976	40481087	1935-09-29	1935-09-29 00:00:00	1935-10-20	1935-10-20 00:00:00	32020		\N	330935	0	444814009	40481087		0
83953	4987	4218389	2016-05-28	2016-05-28 00:00:00	2016-06-25	2016-06-25 00:00:00	32020		\N	331790	0	39848009	4218389		0
84164	5000	260139	1979-01-28	1979-01-28 00:00:00	1979-02-04	1979-02-04 00:00:00	32020		\N	332540	0	10509002	260139		0
84469	5022	81151	2010-01-23	2010-01-23 00:00:00	2010-02-27	2010-02-27 00:00:00	32020		\N	333663	0	44465007	81151		0
84799	5043	4112343	1998-06-07	1998-06-07 00:00:00	1998-06-16	1998-06-16 00:00:00	32020		\N	335163	0	195662009	4112343		0
85056	5058	40481087	1967-03-22	1967-03-22 00:00:00	1967-03-29	1967-03-29 00:00:00	32020		\N	336350	0	444814009	40481087		0
85199	5067	4230399	1978-04-03	1978-04-03 00:00:00	1978-05-03	1978-05-03 00:00:00	32020		\N	336816	0	359817006	4230399		0
74838	4446	260139	1964-12-06	1964-12-06 00:00:00	1964-12-20	1964-12-20 00:00:00	32020		\N	295648	0	10509002	260139		0
74941	4451	4112343	1987-01-31	1987-01-31 00:00:00	1987-02-11	1987-02-11 00:00:00	32020		\N	296099	0	195662009	4112343		0
75062	4457	4155034	1994-02-11	1994-02-11 00:00:00	1994-02-25	1994-02-25 00:00:00	32020		\N	296638	0	283371005	4155034		0
75332	4473	28060	1981-09-15	1981-09-15 00:00:00	1981-09-23	1981-09-23 00:00:00	32020		\N	297611	0	43878008	28060		0
64862	3834	40481087	2001-02-06	2001-02-06 00:00:00	2001-02-20	2001-02-20 00:00:00	32020		\N	254624	0	444814009	40481087		0
75596	4485	257012	2019-04-28	2019-04-28 00:00:00	\N	\N	32020		\N	298572	0	40055000	257012		0
75723	4491	40481087	1947-04-16	1947-04-16 00:00:00	1947-04-30	1947-04-30 00:00:00	32020		\N	299014	0	444814009	40481087		0
75882	4500	40481087	2017-10-23	2017-10-23 00:00:00	2017-11-06	2017-11-06 00:00:00	32020		\N	299596	0	444814009	40481087		0
76144	4520	372328	1929-04-28	1929-04-28 00:00:00	1929-09-14	1929-09-14 00:00:00	32020		\N	300876	0	65363002	372328		0
86820	5169	40481087	1983-10-26	1983-10-26 00:00:00	1983-11-09	1983-11-09 00:00:00	32020		\N	343717	0	444814009	40481087		0
87031	5184	80809	2017-06-06	2017-06-06 00:00:00	\N	\N	32020		\N	344568	0	69896004	80809		0
76653	4544	80180	1984-04-25	1984-04-25 00:00:00	\N	\N	32020		\N	302656	0	396275006	80180		0
76786	4550	40481087	2018-06-29	2018-06-29 00:00:00	2018-07-06	2018-07-06 00:00:00	32020		\N	303230	0	444814009	40481087		0
76944	4559	260139	1990-03-09	1990-03-09 00:00:00	1990-03-23	1990-03-23 00:00:00	32020		\N	303754	0	10509002	260139		0
77041	4563	40481087	2008-06-06	2008-06-06 00:00:00	2008-06-20	2008-06-20 00:00:00	32020		\N	304094	0	444814009	40481087		0
87852	5228	4112343	1972-01-05	1972-01-05 00:00:00	1972-01-17	1972-01-17 00:00:00	32020		\N	347787	0	195662009	4112343		0
77507	4591	40481087	1989-01-28	1989-01-28 00:00:00	1989-02-04	1989-02-04 00:00:00	32020		\N	305926	0	444814009	40481087		0
77676	4602	40481087	1992-10-14	1992-10-14 00:00:00	1992-10-28	1992-10-28 00:00:00	32020		\N	306524	0	444814009	40481087		0
77778	4607	378001	2005-07-16	2005-07-16 00:00:00	2005-08-15	2005-08-15 00:00:00	32020		\N	306876	0	62106007	378001		0
88593	5267	80180	2006-01-08	2006-01-08 00:00:00	\N	\N	32020		\N	350426	0	396275006	80180		0
78116	4628	40481087	1988-04-09	1988-04-09 00:00:00	1988-04-16	1988-04-16 00:00:00	32020		\N	308356	0	444814009	40481087		0
78245	4633	4048695	1987-01-04	1987-01-04 00:00:00	1987-03-07	1987-03-07 00:00:00	32020		\N	308764	0	15724005	4048695		0
78422	4643	40481087	1958-08-11	1958-08-11 00:00:00	1958-08-25	1958-08-25 00:00:00	32020		\N	309526	0	444814009	40481087		0
78622	4655	4084167	1963-05-22	1963-05-22 00:00:00	1963-05-22	1963-05-22 00:00:00	32020		\N	310298	0	241929008	4084167		0
78756	4665	4285898	2015-10-01	2015-10-01 00:00:00	\N	\N	32020		\N	310902	0	68496003	4285898		0
79016	4678	260139	2016-07-02	2016-07-02 00:00:00	2016-07-16	2016-07-16 00:00:00	32020		\N	311742	0	10509002	260139		0
79103	4682	81151	2008-11-10	2008-11-10 00:00:00	2008-11-24	2008-11-24 00:00:00	32020		\N	312044	0	44465007	81151		0
79345	4700	381316	1973-03-13	1973-03-13 00:00:00	\N	\N	32020		\N	313031	0	230690007	381316		0
79512	4709	40481087	2007-01-29	2007-01-29 00:00:00	2007-02-12	2007-02-12 00:00:00	32020		\N	313679	0	444814009	40481087		0
69054	4086	40481087	2014-04-13	2014-04-13 00:00:00	2014-04-27	2014-04-27 00:00:00	32020		\N	271620	0	444814009	40481087		0
79749	4724	4278672	2011-03-06	2011-03-06 00:00:00	2011-05-05	2011-05-05 00:00:00	32020		\N	314862	0	65966004	4278672		0
69548	4116	4112343	1981-11-22	1981-11-22 00:00:00	1981-11-30	1981-11-30 00:00:00	32020		\N	273627	0	195662009	4112343		0
69703	4124	40481087	1996-05-28	1996-05-28 00:00:00	1996-06-04	1996-06-04 00:00:00	32020		\N	274154	0	444814009	40481087		0
80783	4791	4112343	1982-11-06	1982-11-06 00:00:00	1982-11-15	1982-11-15 00:00:00	32020		\N	318775	0	195662009	4112343		0
80992	4804	40481087	1979-03-19	1979-03-19 00:00:00	1979-04-02	1979-04-02 00:00:00	32020		\N	319532	0	444814009	40481087		0
81424	4828	4112343	1984-05-21	1984-05-21 00:00:00	1984-05-31	1984-05-31 00:00:00	32020		\N	321267	0	195662009	4112343		0
81617	4843	4134304	1984-06-22	1984-06-22 00:00:00	1984-09-20	1984-09-20 00:00:00	32020		\N	322109	0	263102004	4134304		0
71203	4223	4142905	1973-05-01	1973-05-01 00:00:00	1973-05-31	1973-05-31 00:00:00	32020		\N	280379	0	33737001	4142905		0
81977	4860	40481087	1986-08-26	1986-08-26 00:00:00	1986-09-16	1986-09-16 00:00:00	32020		\N	323295	0	444814009	40481087		0
82024	4865	260139	1980-06-29	1980-06-29 00:00:00	1980-07-06	1980-07-06 00:00:00	32020		\N	323490	0	10509002	260139		0
82309	4883	81151	1983-03-24	1983-03-24 00:00:00	1983-04-14	1983-04-14 00:00:00	32020		\N	324682	0	44465007	81151		0
82429	4890	4112343	1934-08-15	1934-08-15 00:00:00	1934-08-28	1934-08-28 00:00:00	32020		\N	325062	0	195662009	4112343		0
82572	4899	4113008	1973-09-10	1973-09-10 00:00:00	1973-10-01	1973-10-01 00:00:00	32020		\N	325809	0	284549007	4113008		0
72208	4284	4112343	1964-01-07	1964-01-07 00:00:00	1964-01-16	1964-01-16 00:00:00	32020		\N	284401	0	195662009	4112343		0
82885	4922	4112343	1984-01-09	1984-01-09 00:00:00	1984-01-20	1984-01-20 00:00:00	32020		\N	326968	0	195662009	4112343		0
83452	4960	372328	1909-06-16	1909-06-16 00:00:00	1909-07-24	1909-07-24 00:00:00	32020		\N	329755	0	65363002	372328		0
83788	4977	40481087	2001-12-16	2001-12-16 00:00:00	2001-12-30	2001-12-30 00:00:00	32020		\N	331112	0	444814009	40481087		0
83954	4987	40481087	1998-12-01	1998-12-01 00:00:00	1998-12-22	1998-12-22 00:00:00	32020		\N	331774	0	444814009	40481087		0
84165	5000	378419	2016-08-16	2016-08-16 00:00:00	\N	\N	32020		\N	332575	0	26929004	378419		0
84470	5022	40481087	2003-01-06	2003-01-06 00:00:00	2003-01-20	2003-01-20 00:00:00	32020		\N	333683	0	444814009	40481087		0
84800	5043	378001	1997-07-18	1997-07-18 00:00:00	1997-08-17	1997-08-17 00:00:00	32020		\N	335131	0	62106007	378001		0
85057	5058	80180	1978-05-18	1978-05-18 00:00:00	\N	\N	32020		\N	336357	0	396275006	80180		0
85200	5067	260139	2006-11-18	2006-11-18 00:00:00	2006-12-02	2006-12-02 00:00:00	32020		\N	336856	0	10509002	260139		0
74839	4446	4294548	2002-01-04	2002-01-04 00:00:00	2002-03-01	2002-03-01 00:00:00	32020		\N	295640	0	75498004	4294548		0
74942	4451	260139	1957-03-14	1957-03-14 00:00:00	1957-03-21	1957-03-21 00:00:00	32020		\N	296177	0	10509002	260139		0
75063	4457	4112343	1991-09-10	1991-09-10 00:00:00	1991-09-23	1991-09-23 00:00:00	32020		\N	296662	0	195662009	4112343		0
75333	4473	4112343	2018-10-20	2018-10-20 00:00:00	2018-10-28	2018-10-28 00:00:00	32020		\N	297567	0	195662009	4112343		0
64863	3834	257012	1971-11-10	1971-11-10 00:00:00	\N	\N	32020		\N	254602	0	40055000	257012		0
75597	4485	4112343	1990-07-26	1990-07-26 00:00:00	1990-08-02	1990-08-02 00:00:00	32020		\N	298542	0	195662009	4112343		0
75724	4491	4112343	1957-02-18	1957-02-18 00:00:00	1957-02-27	1957-02-27 00:00:00	32020		\N	299015	0	195662009	4112343		0
75883	4500	375671	1995-10-29	1995-10-29 00:00:00	1995-11-28	1995-11-28 00:00:00	32020		\N	299604	0	62564004	375671		0
76145	4520	4294548	1955-03-13	1955-03-13 00:00:00	1955-03-20	1955-03-20 00:00:00	32020		\N	300946	0	75498004	4294548		0
86821	5169	40481087	2016-12-22	2016-12-22 00:00:00	2017-01-12	2017-01-12 00:00:00	32020		\N	343676	0	444814009	40481087		0
87032	5184	4112343	1998-10-14	1998-10-14 00:00:00	1998-10-23	1998-10-23 00:00:00	32020		\N	344581	0	195662009	4112343		0
76654	4544	260139	1953-04-21	1953-04-21 00:00:00	1953-04-28	1953-04-28 00:00:00	32020		\N	302653	0	10509002	260139		0
76787	4550	40481087	1994-05-26	1994-05-26 00:00:00	1994-06-09	1994-06-09 00:00:00	32020		\N	303259	0	444814009	40481087		0
76945	4560	40481087	1979-10-04	1979-10-04 00:00:00	1979-10-18	1979-10-18 00:00:00	32020		\N	303847	0	444814009	40481087		0
77042	4563	40481087	1970-11-15	1970-11-15 00:00:00	1970-11-22	1970-11-22 00:00:00	32020		\N	304106	0	444814009	40481087		0
87853	5228	4237458	2013-08-30	2013-08-30 00:00:00	2013-09-29	2013-09-29 00:00:00	32020		\N	347863	0	58150001	4237458		0
77508	4591	4218389	1974-07-25	1974-07-25 00:00:00	1974-08-29	1974-08-29 00:00:00	32020		\N	305894	0	39848009	4218389		0
77677	4602	260139	1996-04-30	1996-04-30 00:00:00	1996-05-07	1996-05-07 00:00:00	32020		\N	306542	0	10509002	260139		0
77779	4607	372328	1974-07-08	1974-07-08 00:00:00	1974-12-26	1974-12-26 00:00:00	32020		\N	306897	0	65363002	372328		0
88594	5267	30753	2004-12-14	2004-12-14 00:00:00	\N	\N	32020		\N	350426	0	16761005	30753		0
78117	4628	40481087	2013-12-29	2013-12-29 00:00:00	2014-01-05	2014-01-05 00:00:00	32020		\N	308331	0	444814009	40481087		0
78246	4633	81151	2017-08-10	2017-08-10 00:00:00	2017-08-31	2017-08-31 00:00:00	32020		\N	308766	0	44465007	81151		0
78423	4643	40481087	1993-11-29	1993-11-29 00:00:00	1993-12-06	1993-12-06 00:00:00	32020		\N	309530	0	444814009	40481087		0
78623	4655	40481087	2016-06-14	2016-06-14 00:00:00	2016-06-21	2016-06-21 00:00:00	32020		\N	310347	0	444814009	40481087		0
78757	4665	40481087	2015-03-14	2015-03-14 00:00:00	2015-04-04	2015-04-04 00:00:00	32020		\N	310902	0	444814009	40481087		0
89475	5322	28060	1994-02-18	1994-02-18 00:00:00	1994-03-02	1994-03-02 00:00:00	32020		\N	354140	0	43878008	28060		0
79111	4685	28060	1952-01-28	1952-01-28 00:00:00	1952-02-06	1952-02-06 00:00:00	32020		\N	312138	0	43878008	28060		0
79346	4700	40481087	1972-01-27	1972-01-27 00:00:00	1972-02-03	1972-02-03 00:00:00	32020		\N	313031	0	444814009	40481087		0
79513	4709	4112343	1981-09-21	1981-09-21 00:00:00	1981-10-04	1981-10-04 00:00:00	32020		\N	313634	0	195662009	4112343		0
69055	4086	4296205	1991-02-03	1991-02-03 00:00:00	1991-02-17	1991-02-17 00:00:00	32020		\N	271574	0	403191005	4296205		0
79750	4724	378001	1980-09-14	1980-09-14 00:00:00	1980-11-13	1980-11-13 00:00:00	32020		\N	314688	0	62106007	378001		0
69549	4116	192671	2012-07-20	2012-07-20 00:00:00	\N	\N	32020		\N	273635	0	K92.2	35208414		0
69704	4124	40481087	1973-08-26	1973-08-26 00:00:00	1973-09-16	1973-09-16 00:00:00	32020		\N	274183	0	444814009	40481087		0
80784	4791	40481087	1984-03-12	1984-03-12 00:00:00	1984-03-26	1984-03-26 00:00:00	32020		\N	318776	0	444814009	40481087		0
80993	4804	4266809	2013-06-25	2013-06-25 00:00:00	\N	\N	32020		\N	319575	0	397881000	4266809		0
81425	4828	134438	1996-05-09	1996-05-09 00:00:00	1999-09-21	1999-09-21 00:00:00	32020		\N	321269	0	40275004	134438		0
81618	4843	372328	1964-02-10	1964-02-10 00:00:00	1964-06-23	1964-06-23 00:00:00	32020		\N	322120	0	65363002	372328		0
71204	4223	372328	1961-11-25	1961-11-25 00:00:00	1962-01-05	1962-01-05 00:00:00	32020		\N	280384	0	65363002	372328		0
81978	4860	81151	2016-06-02	2016-06-02 00:00:00	2016-07-07	2016-07-07 00:00:00	32020		\N	323342	0	44465007	81151		0
82025	4865	40479768	1981-11-24	1981-11-24 00:00:00	1982-01-30	1982-01-30 00:00:00	32020		\N	323501	0	444470001	40479768		0
82310	4883	40481087	2011-07-16	2011-07-16 00:00:00	2011-07-30	2011-07-30 00:00:00	32020		\N	324703	0	444814009	40481087		0
82430	4890	40481087	1996-11-09	1996-11-09 00:00:00	1996-11-16	1996-11-16 00:00:00	32020		\N	325189	0	444814009	40481087		0
82573	4899	40481087	1931-05-28	1931-05-28 00:00:00	1931-06-04	1931-06-04 00:00:00	32020		\N	325774	0	444814009	40481087		0
72209	4284	4112343	2014-08-09	2014-08-09 00:00:00	2014-08-18	2014-08-18 00:00:00	32020		\N	284366	0	195662009	4112343		0
82886	4922	4112343	1985-07-16	1985-07-16 00:00:00	1985-07-29	1985-07-29 00:00:00	32020		\N	326987	0	195662009	4112343		0
83453	4960	4155034	1964-10-19	1964-10-19 00:00:00	1964-11-02	1964-11-02 00:00:00	32020		\N	329710	0	283371005	4155034		0
83789	4977	260139	1990-08-13	1990-08-13 00:00:00	1990-08-27	1990-08-27 00:00:00	32020		\N	331163	0	10509002	260139		0
83955	4987	28060	1960-12-31	1960-12-31 00:00:00	1961-01-07	1961-01-07 00:00:00	32020		\N	331708	0	43878008	28060		0
84166	5000	40481087	1983-02-05	1983-02-05 00:00:00	1983-02-26	1983-02-26 00:00:00	32020		\N	332541	0	444814009	40481087		0
84471	5022	80180	2005-06-05	2005-06-05 00:00:00	\N	\N	32020		\N	333684	0	396275006	80180		0
84801	5044	40481087	1995-11-06	1995-11-06 00:00:00	1995-11-20	1995-11-20 00:00:00	32020		\N	335217	0	444814009	40481087		0
85058	5058	4285898	1978-02-17	1978-02-17 00:00:00	\N	\N	32020		\N	336357	0	68496003	4285898		0
85201	5067	40481087	1987-12-15	1987-12-15 00:00:00	1987-12-22	1987-12-22 00:00:00	32020		\N	336839	0	444814009	40481087		0
74840	4446	80180	2002-03-05	2002-03-05 00:00:00	\N	\N	32020		\N	295640	0	396275006	80180		0
74943	4451	40481087	1969-09-04	1969-09-04 00:00:00	1969-09-18	1969-09-18 00:00:00	32020		\N	296148	0	444814009	40481087		0
75064	4457	4237458	1999-09-27	1999-09-27 00:00:00	1999-11-26	1999-11-26 00:00:00	32020		\N	296639	0	58150001	4237458		0
75334	4473	40481087	1978-12-17	1978-12-17 00:00:00	1978-12-24	1978-12-24 00:00:00	32020		\N	297603	0	444814009	40481087		0
64864	3834	4109685	2012-04-18	2012-04-18 00:00:00	2012-05-02	2012-05-02 00:00:00	32020		\N	254589	0	284551006	4109685		0
75598	4485	40481087	1979-01-31	1979-01-31 00:00:00	1979-02-14	1979-02-14 00:00:00	32020		\N	298580	0	444814009	40481087		0
75725	4491	4310024	1982-10-31	1982-10-31 00:00:00	\N	\N	32020		\N	298964	0	424802006	4310024		0
75884	4500	372328	1974-12-12	1974-12-12 00:00:00	1975-10-15	1975-10-15 00:00:00	32020		\N	299587	0	65363002	372328		0
76146	4520	40481087	1991-10-25	1991-10-25 00:00:00	1991-11-08	1991-11-08 00:00:00	32020		\N	300875	0	444814009	40481087		0
86822	5169	260139	1977-12-24	1977-12-24 00:00:00	1977-12-31	1977-12-31 00:00:00	32020		\N	343730	0	10509002	260139		0
87033	5184	80180	2001-05-01	2001-05-01 00:00:00	\N	\N	32020		\N	344581	0	396275006	80180		0
76655	4544	4329847	1994-02-01	1994-02-01 00:00:00	\N	\N	32020		\N	302672	0	22298006	4329847		0
76788	4550	40481087	1980-01-29	1980-01-29 00:00:00	1980-02-19	1980-02-19 00:00:00	32020		\N	303205	0	444814009	40481087		0
76946	4560	378001	1994-08-07	1994-08-07 00:00:00	1994-09-06	1994-09-06 00:00:00	32020		\N	303811	0	62106007	378001		0
89179	5306	80180	2013-01-23	2013-01-23 00:00:00	\N	\N	32020		\N	352985	0	396275006	80180		0
77043	4563	40481087	1986-05-02	1986-05-02 00:00:00	1986-05-09	1986-05-09 00:00:00	32020		\N	304093	0	444814009	40481087		0
87854	5228	260139	1939-01-09	1939-01-09 00:00:00	1939-01-23	1939-01-23 00:00:00	32020		\N	347757	0	10509002	260139		0
77522	4593	378001	2017-09-17	2017-09-17 00:00:00	2017-10-17	2017-10-17 00:00:00	32020		\N	306052	0	62106007	378001		0
77678	4602	80180	2011-05-21	2011-05-21 00:00:00	\N	\N	32020		\N	306580	0	396275006	80180		0
77780	4607	4156265	1984-10-13	1984-10-13 00:00:00	1984-11-03	1984-11-03 00:00:00	32020		\N	306874	0	370247008	4156265		0
88595	5267	4112343	1985-10-12	1985-10-12 00:00:00	1985-10-24	1985-10-24 00:00:00	32020		\N	350429	0	195662009	4112343		0
78118	4628	40481087	1974-08-23	1974-08-23 00:00:00	1974-08-30	1974-08-30 00:00:00	32020		\N	308366	0	444814009	40481087		0
78247	4633	4109685	2014-10-11	2014-10-11 00:00:00	2014-10-25	2014-10-25 00:00:00	32020		\N	308765	0	284551006	4109685		0
78424	4643	4112343	1979-06-27	1979-06-27 00:00:00	1979-07-08	1979-07-08 00:00:00	32020		\N	309529	0	195662009	4112343		0
78624	4656	80502	2009-11-08	2009-11-08 00:00:00	\N	\N	32020		\N	310440	0	64859006	80502		0
78758	4665	4296204	2003-08-20	2003-08-20 00:00:00	2003-09-03	2003-09-03 00:00:00	32020		\N	310864	0	403190006	4296204		0
89476	5322	4112343	1949-07-12	1949-07-12 00:00:00	1949-07-24	1949-07-24 00:00:00	32020		\N	354217	0	195662009	4112343		0
79112	4685	28060	1944-08-21	1944-08-21 00:00:00	1944-09-03	1944-09-03 00:00:00	32020		\N	312154	0	43878008	28060		0
79347	4700	40481087	2010-01-21	2010-01-21 00:00:00	2010-01-28	2010-01-28 00:00:00	32020		\N	313067	0	444814009	40481087		0
79514	4709	80180	1998-08-15	1998-08-15 00:00:00	\N	\N	32020		\N	313657	0	396275006	80180		0
69056	4086	4152936	1979-11-23	1979-11-23 00:00:00	1979-12-07	1979-12-07 00:00:00	32020		\N	271570	0	283385000	4152936		0
79751	4724	378001	1989-01-30	1989-01-30 00:00:00	1989-03-01	1989-03-01 00:00:00	32020		\N	314689	0	62106007	378001		0
69550	4116	40481087	1973-09-20	1973-09-20 00:00:00	1973-10-11	1973-10-11 00:00:00	32020		\N	273625	0	444814009	40481087		0
69705	4124	40481087	1988-07-29	1988-07-29 00:00:00	1988-08-12	1988-08-12 00:00:00	32020		\N	274175	0	444814009	40481087		0
80785	4791	4237458	2002-04-21	2002-04-21 00:00:00	2002-07-20	2002-07-20 00:00:00	32020		\N	318824	0	58150001	4237458		0
80994	4804	80180	2013-06-25	2013-06-25 00:00:00	\N	\N	32020		\N	319575	0	396275006	80180		0
81426	4828	80180	2014-01-07	2014-01-07 00:00:00	\N	\N	32020		\N	321274	0	396275006	80180		0
81619	4843	28060	1965-09-04	1965-09-04 00:00:00	1965-09-13	1965-09-13 00:00:00	32020		\N	322157	0	43878008	28060		0
71205	4223	4218389	1975-04-21	1975-04-21 00:00:00	1975-05-12	1975-05-12 00:00:00	32020		\N	280364	0	39848009	4218389		0
81979	4860	4112343	1995-12-03	1995-12-03 00:00:00	1995-12-14	1995-12-14 00:00:00	32020		\N	323344	0	195662009	4112343		0
82026	4865	78272	1974-12-26	1974-12-26 00:00:00	1975-01-23	1975-01-23 00:00:00	32020		\N	323499	0	70704007	78272		0
82311	4883	40481087	1950-09-04	1950-09-04 00:00:00	1950-09-18	1950-09-18 00:00:00	32020		\N	324641	0	444814009	40481087		0
82431	4890	260139	1938-10-12	1938-10-12 00:00:00	1938-10-26	1938-10-26 00:00:00	32020		\N	325195	0	10509002	260139		0
82574	4899	4283893	1988-10-16	1988-10-16 00:00:00	1988-12-11	1988-12-11 00:00:00	32020		\N	325839	0	36971009	4283893		0
72210	4284	372328	1945-04-21	1945-04-21 00:00:00	1945-05-05	1945-05-05 00:00:00	32020		\N	284405	0	65363002	372328		0
82887	4923	28060	1969-01-10	1969-01-10 00:00:00	1969-01-20	1969-01-20 00:00:00	32020		\N	327096	0	43878008	28060		0
83454	4960	378001	1947-08-08	1947-08-08 00:00:00	1947-10-07	1947-10-07 00:00:00	32020		\N	329707	0	62106007	378001		0
83790	4977	40481087	2016-04-16	2016-04-16 00:00:00	2016-04-30	2016-04-30 00:00:00	32020		\N	331159	0	444814009	40481087		0
83956	4987	4112343	1990-11-25	1990-11-25 00:00:00	1990-12-04	1990-12-04 00:00:00	32020		\N	331759	0	195662009	4112343		0
84167	5000	40481087	2007-07-18	2007-07-18 00:00:00	2007-08-01	2007-08-01 00:00:00	32020		\N	332588	0	444814009	40481087		0
84472	5022	40481087	2003-07-24	2003-07-24 00:00:00	2003-08-14	2003-08-14 00:00:00	32020		\N	333684	0	444814009	40481087		0
84802	5044	80180	2015-07-23	2015-07-23 00:00:00	\N	\N	32020		\N	335183	0	396275006	80180		0
85059	5058	40481087	2001-10-16	2001-10-16 00:00:00	2001-10-23	2001-10-23 00:00:00	32020		\N	336307	0	444814009	40481087		0
85202	5067	378001	1992-12-15	1992-12-15 00:00:00	1993-02-13	1993-02-13 00:00:00	32020		\N	336819	0	62106007	378001		0
74841	4446	4294548	1997-09-01	1997-09-01 00:00:00	1997-09-29	1997-09-29 00:00:00	32020		\N	295637	0	75498004	4294548		0
74944	4451	40481087	1961-07-28	1961-07-28 00:00:00	1961-08-11	1961-08-11 00:00:00	32020		\N	296178	0	444814009	40481087		0
75065	4457	28060	1994-06-10	1994-06-10 00:00:00	1994-06-20	1994-06-20 00:00:00	32020		\N	296631	0	43878008	28060		0
75335	4473	260139	1996-04-15	1996-04-15 00:00:00	1996-04-29	1996-04-29 00:00:00	32020		\N	297596	0	10509002	260139		0
64865	3834	28060	2005-03-09	2005-03-09 00:00:00	2005-03-18	2005-03-18 00:00:00	32020		\N	254553	0	43878008	28060		0
75599	4485	4112343	1958-10-04	1958-10-04 00:00:00	1958-10-11	1958-10-11 00:00:00	32020		\N	298597	0	195662009	4112343		0
75726	4491	81893	1983-02-28	1983-02-28 00:00:00	\N	\N	32020		\N	298964	0	64766004	81893		0
75885	4500	40481087	2014-12-24	2014-12-24 00:00:00	2014-12-31	2014-12-31 00:00:00	32020		\N	299658	0	444814009	40481087		0
76147	4520	4113008	1937-08-28	1937-08-28 00:00:00	1937-09-18	1937-09-18 00:00:00	32020		\N	300890	0	284549007	4113008		0
86823	5169	40481087	2016-08-08	2016-08-08 00:00:00	2016-08-15	2016-08-15 00:00:00	32020		\N	343685	0	444814009	40481087		0
87034	5184	372328	1969-03-16	1969-03-16 00:00:00	1969-05-30	1969-05-30 00:00:00	32020		\N	344583	0	65363002	372328		0
76657	4544	260139	1942-03-14	1942-03-14 00:00:00	1942-03-28	1942-03-28 00:00:00	32020		\N	302708	0	10509002	260139		0
76789	4550	40481087	2010-04-23	2010-04-23 00:00:00	2010-05-07	2010-05-07 00:00:00	32020		\N	303269	0	444814009	40481087		0
76947	4560	40481087	1985-04-10	1985-04-10 00:00:00	1985-04-17	1985-04-17 00:00:00	32020		\N	303832	0	444814009	40481087		0
77044	4563	4112343	2007-10-14	2007-10-14 00:00:00	2007-10-24	2007-10-24 00:00:00	32020		\N	304108	0	195662009	4112343		0
87855	5228	40481087	2005-11-26	2005-11-26 00:00:00	2005-12-03	2005-12-03 00:00:00	32020		\N	347855	0	444814009	40481087		0
87981	5234	4094814	1995-07-03	1995-07-03 00:00:00	1995-08-02	1995-08-02 00:00:00	32020		\N	348216	0	262574004	4094814		0
77679	4602	40481087	1977-11-13	1977-11-13 00:00:00	1977-12-04	1977-12-04 00:00:00	32020		\N	306551	0	444814009	40481087		0
77781	4607	372328	1975-04-25	1975-04-25 00:00:00	1975-06-26	1975-06-26 00:00:00	32020		\N	306879	0	65363002	372328		0
88596	5267	28060	1972-02-23	1972-02-23 00:00:00	1972-03-07	1972-03-07 00:00:00	32020		\N	350428	0	43878008	28060		0
78119	4628	40481087	1971-06-24	1971-06-24 00:00:00	1971-07-01	1971-07-01 00:00:00	32020		\N	308353	0	444814009	40481087		0
78248	4633	81893	1992-01-11	1992-01-11 00:00:00	\N	\N	32020		\N	308768	0	64766004	81893		0
78425	4643	4112343	1961-05-22	1961-05-22 00:00:00	1961-05-29	1961-05-29 00:00:00	32020		\N	309527	0	195662009	4112343		0
78625	4656	4112343	1997-09-27	1997-09-27 00:00:00	1997-10-05	1997-10-05 00:00:00	32020		\N	310482	0	195662009	4112343		0
78759	4665	78272	2005-09-22	2005-09-22 00:00:00	2005-10-27	2005-10-27 00:00:00	32020		\N	310865	0	70704007	78272		0
89477	5322	40481087	2014-06-28	2014-06-28 00:00:00	2014-07-12	2014-07-12 00:00:00	32020		\N	354157	0	444814009	40481087		0
79113	4685	372328	1957-12-10	1957-12-10 00:00:00	1958-11-17	1958-11-17 00:00:00	32020		\N	312133	0	65363002	372328		0
79348	4700	28060	1958-01-03	1958-01-03 00:00:00	1958-01-13	1958-01-13 00:00:00	32020		\N	313052	0	43878008	28060		0
79515	4709	4152936	1983-03-31	1983-03-31 00:00:00	1983-04-21	1983-04-21 00:00:00	32020		\N	313646	0	283385000	4152936		0
79752	4724	260139	2005-06-13	2005-06-13 00:00:00	2005-06-20	2005-06-20 00:00:00	32020		\N	314718	0	10509002	260139		0
69551	4116	260139	2008-12-23	2008-12-23 00:00:00	2008-12-30	2008-12-30 00:00:00	32020		\N	273615	0	10509002	260139		0
69706	4124	40481087	2015-12-17	2015-12-17 00:00:00	2015-12-31	2015-12-31 00:00:00	32020		\N	274162	0	444814009	40481087		0
80786	4791	40481087	1986-10-04	1986-10-04 00:00:00	1986-10-18	1986-10-18 00:00:00	32020		\N	318780	0	444814009	40481087		0
80995	4804	317009	1997-03-23	1997-03-23 00:00:00	\N	\N	32020		\N	319587	0	195967001	317009		0
81427	4828	4112343	1974-07-04	1974-07-04 00:00:00	1974-07-17	1974-07-17 00:00:00	32020		\N	321265	0	195662009	4112343		0
81620	4843	257012	1986-12-08	1986-12-08 00:00:00	1987-01-05	1987-01-05 00:00:00	32020		\N	322151	0	40055000	257012		0
71206	4223	81151	2019-04-26	2019-04-26 00:00:00	2019-05-17	2019-05-17 00:00:00	32020		\N	280367	0	44465007	81151		0
81980	4860	78272	1999-07-11	1999-07-11 00:00:00	1999-08-01	1999-08-01 00:00:00	32020		\N	323341	0	70704007	78272		0
82027	4865	40481087	2007-07-29	2007-07-29 00:00:00	2007-08-12	2007-08-12 00:00:00	32020		\N	323546	0	444814009	40481087		0
82312	4883	40481087	2019-03-29	2019-03-29 00:00:00	2019-04-05	2019-04-05 00:00:00	32020		\N	324644	0	444814009	40481087		0
82432	4890	260139	1976-04-09	1976-04-09 00:00:00	1976-04-16	1976-04-16 00:00:00	32020		\N	325082	0	10509002	260139		0
82575	4899	4112343	1984-12-19	1984-12-19 00:00:00	1984-12-28	1984-12-28 00:00:00	32020		\N	325776	0	195662009	4112343		0
82669	4907	40481087	2005-07-29	2005-07-29 00:00:00	2005-08-05	2005-08-05 00:00:00	32020		\N	326101	0	444814009	40481087		0
82888	4923	40481087	1997-09-19	1997-09-19 00:00:00	1997-10-03	1997-10-03 00:00:00	32020		\N	327129	0	444814009	40481087		0
83455	4960	4156265	1955-08-17	1955-08-17 00:00:00	1955-09-07	1955-09-07 00:00:00	32020		\N	329709	0	370247008	4156265		0
83791	4977	28060	1981-06-24	1981-06-24 00:00:00	1981-07-06	1981-07-06 00:00:00	32020		\N	331124	0	43878008	28060		0
83957	4987	4109685	1980-05-25	1980-05-25 00:00:00	1980-06-08	1980-06-08 00:00:00	32020		\N	331787	0	284551006	4109685		0
84168	5000	260139	2007-06-12	2007-06-12 00:00:00	2007-06-26	2007-06-26 00:00:00	32020		\N	332528	0	10509002	260139		0
84473	5022	4027663	1994-12-25	1994-12-25 00:00:00	\N	\N	32020		\N	333692	0	13200003	4027663		0
84803	5044	40481087	1985-08-10	1985-08-10 00:00:00	1985-08-24	1985-08-24 00:00:00	32020		\N	335209	0	444814009	40481087		0
85060	5058	4112343	1991-10-07	1991-10-07 00:00:00	1991-10-18	1991-10-18 00:00:00	32020		\N	336284	0	195662009	4112343		0
85203	5068	80180	1973-03-26	1973-03-26 00:00:00	\N	\N	32020		\N	336942	0	396275006	80180		0
74842	4446	372328	1963-04-14	1963-04-14 00:00:00	1963-06-04	1963-06-04 00:00:00	32020		\N	295685	0	65363002	372328		0
74945	4451	192671	1992-11-10	1992-11-10 00:00:00	\N	\N	32020		\N	296175	0	K92.2	35208414		0
75066	4457	80180	2016-08-19	2016-08-19 00:00:00	\N	\N	32020		\N	296643	0	396275006	80180		0
75336	4473	40481087	1984-11-14	1984-11-14 00:00:00	1984-11-28	1984-11-28 00:00:00	32020		\N	297593	0	444814009	40481087		0
64866	3835	4296205	1984-10-06	1984-10-06 00:00:00	1984-10-27	1984-10-27 00:00:00	32020		\N	254661	0	403191005	4296205		0
75617	4487	28060	1985-03-11	1985-03-11 00:00:00	1985-03-18	1985-03-18 00:00:00	32020		\N	298749	0	43878008	28060		0
75727	4491	378001	1979-04-02	1979-04-02 00:00:00	1979-05-02	1979-05-02 00:00:00	32020		\N	299025	0	62106007	378001		0
75886	4500	28060	2006-07-18	2006-07-18 00:00:00	2006-07-27	2006-07-27 00:00:00	32020		\N	299592	0	43878008	28060		0
76148	4520	4112343	1942-08-01	1942-08-01 00:00:00	1942-08-14	1942-08-14 00:00:00	32020		\N	300872	0	195662009	4112343		0
86824	5169	4283893	1980-08-17	1980-08-17 00:00:00	1980-10-05	1980-10-05 00:00:00	32020		\N	343689	0	36971009	4283893		0
87035	5184	260139	1984-01-07	1984-01-07 00:00:00	1984-01-21	1984-01-21 00:00:00	32020		\N	344566	0	10509002	260139		0
76658	4544	30753	1982-10-03	1982-10-03 00:00:00	\N	\N	32020		\N	302678	0	16761005	30753		0
76790	4550	78272	1980-01-08	1980-01-08 00:00:00	1980-02-05	1980-02-05 00:00:00	32020		\N	303201	0	70704007	78272		0
76948	4560	372328	1969-06-23	1969-06-23 00:00:00	1969-10-08	1969-10-08 00:00:00	32020		\N	303816	0	65363002	372328		0
77045	4563	4112343	2005-02-17	2005-02-17 00:00:00	2005-02-25	2005-02-25 00:00:00	32020		\N	304128	0	195662009	4112343		0
87856	5228	195588	1966-08-05	1966-08-05 00:00:00	1966-10-02	1966-10-02 00:00:00	32020		\N	347759	0	38822007	195588		0
87982	5234	40481087	1989-12-05	1989-12-05 00:00:00	1989-12-12	1989-12-12 00:00:00	32020		\N	348284	0	444814009	40481087		0
77680	4602	40481087	2006-03-13	2006-03-13 00:00:00	2006-03-27	2006-03-27 00:00:00	32020		\N	306568	0	444814009	40481087		0
77782	4607	4112343	2011-12-04	2011-12-04 00:00:00	2011-12-15	2011-12-15 00:00:00	32020		\N	306922	0	195662009	4112343		0
88597	5267	4112343	2013-12-30	2013-12-30 00:00:00	2014-01-07	2014-01-07 00:00:00	32020		\N	350400	0	195662009	4112343		0
78120	4628	372328	1969-06-26	1969-06-26 00:00:00	1969-09-07	1969-09-07 00:00:00	32020		\N	308370	0	65363002	372328		0
78249	4633	257012	1975-08-01	1975-08-01 00:00:00	\N	\N	32020		\N	308803	0	40055000	257012		0
78426	4643	378001	1916-04-08	1916-04-08 00:00:00	1916-06-07	1916-06-07 00:00:00	32020		\N	309568	0	62106007	378001		0
78626	4656	4146173	1987-07-22	1987-07-22 00:00:00	1987-09-20	1987-09-20 00:00:00	32020		\N	310481	0	307731004	4146173		0
78760	4665	4310024	2014-10-06	2014-10-06 00:00:00	\N	\N	32020		\N	310896	0	424802006	4310024		0
89478	5322	78272	1962-02-02	1962-02-02 00:00:00	1962-03-02	1962-03-02 00:00:00	32020		\N	354086	0	70704007	78272		0
79114	4685	4027663	1964-08-28	1964-08-28 00:00:00	\N	\N	32020		\N	312145	0	13200003	4027663		0
89837	5343	28060	1991-03-04	1991-03-04 00:00:00	1991-03-16	1991-03-16 00:00:00	32020		\N	355861	0	43878008	28060		0
79516	4709	40481087	1992-05-30	1992-05-30 00:00:00	1992-06-20	1992-06-20 00:00:00	32020		\N	313700	0	444814009	40481087		0
79753	4724	4237458	2008-12-16	2008-12-16 00:00:00	2009-02-14	2009-02-14 00:00:00	32020		\N	314861	0	58150001	4237458		0
69552	4116	4294548	1969-11-17	1969-11-17 00:00:00	1969-12-01	1969-12-01 00:00:00	32020		\N	273650	0	75498004	4294548		0
69707	4124	40481087	2000-04-13	2000-04-13 00:00:00	2000-05-04	2000-05-04 00:00:00	32020		\N	274208	0	444814009	40481087		0
80787	4792	260139	1996-10-09	1996-10-09 00:00:00	1996-10-16	1996-10-16 00:00:00	32020		\N	318842	0	10509002	260139		0
80996	4804	28060	1990-04-13	1990-04-13 00:00:00	1990-04-24	1990-04-24 00:00:00	32020		\N	319565	0	43878008	28060		0
81428	4828	40481087	1989-05-11	1989-05-11 00:00:00	1989-06-01	1989-06-01 00:00:00	32020		\N	321237	0	444814009	40481087		0
81621	4843	28060	2001-02-18	2001-02-18 00:00:00	2001-02-27	2001-02-27 00:00:00	32020		\N	322154	0	43878008	28060		0
71207	4223	40481087	1968-12-31	1968-12-31 00:00:00	1969-01-07	1969-01-07 00:00:00	32020		\N	280435	0	444814009	40481087		0
81981	4860	260139	2006-09-28	2006-09-28 00:00:00	2006-10-05	2006-10-05 00:00:00	32020		\N	323297	0	10509002	260139		0
82028	4865	40481087	1981-08-09	1981-08-09 00:00:00	1981-08-30	1981-08-30 00:00:00	32020		\N	323542	0	444814009	40481087		0
82313	4883	4059173	1973-04-24	1973-04-24 00:00:00	1973-06-23	1973-06-23 00:00:00	32020		\N	324680	0	16114001	4059173		0
82433	4890	40481087	1932-12-31	1932-12-31 00:00:00	1933-01-21	1933-01-21 00:00:00	32020		\N	325194	0	444814009	40481087		0
82576	4899	4112343	1996-02-28	1996-02-28 00:00:00	1996-03-08	1996-03-08 00:00:00	32020		\N	325840	0	195662009	4112343		0
82670	4907	4116491	1985-01-23	1985-01-23 00:00:00	1985-03-17	1985-03-17 00:00:00	32020		\N	326173	0	301011002	4116491		0
82889	4923	4237458	1977-01-24	1977-01-24 00:00:00	1977-03-25	1977-03-25 00:00:00	32020		\N	327124	0	58150001	4237458		0
83456	4960	4112343	1948-03-30	1948-03-30 00:00:00	1948-04-06	1948-04-06 00:00:00	32020		\N	329717	0	195662009	4112343		0
83792	4977	260139	1963-02-01	1963-02-01 00:00:00	1963-02-15	1963-02-15 00:00:00	32020		\N	331184	0	10509002	260139		0
83958	4987	4310024	1995-10-13	1995-10-13 00:00:00	\N	\N	32020		\N	331785	0	424802006	4310024		0
84169	5000	4112343	1977-07-04	1977-07-04 00:00:00	1977-07-13	1977-07-13 00:00:00	32020		\N	332544	0	195662009	4112343		0
84474	5022	4112343	1984-04-16	1984-04-16 00:00:00	1984-04-26	1984-04-26 00:00:00	32020		\N	333678	0	195662009	4112343		0
84804	5044	40481087	1994-11-13	1994-11-13 00:00:00	1994-12-04	1994-12-04 00:00:00	32020		\N	335191	0	444814009	40481087		0
85061	5058	260139	1980-11-19	1980-11-19 00:00:00	1980-11-26	1980-11-26 00:00:00	32020		\N	336329	0	10509002	260139		0
85204	5068	4112343	1971-12-06	1971-12-06 00:00:00	1971-12-13	1971-12-13 00:00:00	32020		\N	336942	0	195662009	4112343		0
74843	4446	4294548	2002-10-06	2002-10-06 00:00:00	2002-10-27	2002-10-27 00:00:00	32020		\N	295638	0	75498004	4294548		0
74946	4451	40481087	2018-08-24	2018-08-24 00:00:00	2018-09-07	2018-09-07 00:00:00	32020		\N	296169	0	444814009	40481087		0
75067	4457	40481087	2016-03-24	2016-03-24 00:00:00	2016-04-07	2016-04-07 00:00:00	32020		\N	296643	0	444814009	40481087		0
75337	4473	4112343	1993-06-05	1993-06-05 00:00:00	1993-06-16	1993-06-16 00:00:00	32020		\N	297595	0	195662009	4112343		0
64867	3835	80180	2004-08-29	2004-08-29 00:00:00	\N	\N	32020		\N	254649	0	396275006	80180		0
75618	4487	260139	1987-09-11	1987-09-11 00:00:00	1987-09-18	1987-09-18 00:00:00	32020		\N	298715	0	10509002	260139		0
75728	4491	81151	1949-11-23	1949-11-23 00:00:00	1949-12-14	1949-12-14 00:00:00	32020		\N	299022	0	44465007	81151		0
75888	4500	4029498	1961-09-13	1961-09-13 00:00:00	\N	\N	32020		\N	299601	0	128613002	4029498		0
76149	4520	260139	1948-10-16	1948-10-16 00:00:00	1948-10-30	1948-10-30 00:00:00	32020		\N	300945	0	10509002	260139		0
86825	5169	40481087	1998-02-25	1998-02-25 00:00:00	1998-03-11	1998-03-11 00:00:00	32020		\N	343718	0	444814009	40481087		0
87036	5184	4134304	1965-05-15	1965-05-15 00:00:00	1965-06-14	1965-06-14 00:00:00	32020		\N	344591	0	263102004	4134304		0
76659	4544	81893	1982-03-07	1982-03-07 00:00:00	\N	\N	32020		\N	302678	0	64766004	81893		0
76791	4550	40481087	2018-09-10	2018-09-10 00:00:00	2018-09-17	2018-09-17 00:00:00	32020		\N	303270	0	444814009	40481087		0
76949	4560	40481087	1996-10-31	1996-10-31 00:00:00	1996-11-07	1996-11-07 00:00:00	32020		\N	303852	0	444814009	40481087		0
77046	4563	78272	2005-01-04	2005-01-04 00:00:00	2005-02-01	2005-02-01 00:00:00	32020		\N	304075	0	70704007	78272		0
87857	5228	260139	1937-01-11	1937-01-11 00:00:00	1937-01-18	1937-01-18 00:00:00	32020		\N	347777	0	10509002	260139		0
87983	5234	4294548	1976-11-02	1976-11-02 00:00:00	1977-01-04	1977-01-04 00:00:00	32020		\N	348221	0	75498004	4294548		0
77681	4602	40481087	1983-09-10	1983-09-10 00:00:00	1983-09-24	1983-09-24 00:00:00	32020		\N	306552	0	444814009	40481087		0
77783	4607	40481087	2011-09-27	2011-09-27 00:00:00	2011-10-04	2011-10-04 00:00:00	32020		\N	306878	0	444814009	40481087		0
88598	5267	4116491	1994-11-27	1994-11-27 00:00:00	1995-01-01	1995-01-01 00:00:00	32020		\N	350356	0	301011002	4116491		0
78121	4628	40481087	1999-03-26	1999-03-26 00:00:00	1999-04-09	1999-04-09 00:00:00	32020		\N	308328	0	444814009	40481087		0
78250	4633	192671	1992-09-27	1992-09-27 00:00:00	\N	\N	32020		\N	308807	0	K92.2	35208414		0
78427	4643	4155034	1914-02-04	1914-02-04 00:00:00	1914-02-18	1914-02-18 00:00:00	32020		\N	309567	0	283371005	4155034		0
78627	4656	40481087	1963-03-14	1963-03-14 00:00:00	1963-03-21	1963-03-21 00:00:00	32020		\N	310480	0	444814009	40481087		0
78761	4665	4112343	2018-03-30	2018-03-30 00:00:00	2018-04-06	2018-04-06 00:00:00	32020		\N	310903	0	195662009	4112343		0
89479	5322	257012	1985-11-07	1985-11-07 00:00:00	\N	\N	32020		\N	354183	0	40055000	257012		0
79115	4685	40481087	1967-12-07	1967-12-07 00:00:00	1967-12-14	1967-12-14 00:00:00	32020		\N	312118	0	444814009	40481087		0
89838	5343	28060	1994-08-30	1994-08-30 00:00:00	1994-09-11	1994-09-11 00:00:00	32020		\N	355876	0	43878008	28060		0
79517	4709	40481087	1997-01-30	1997-01-30 00:00:00	1997-02-13	1997-02-13 00:00:00	32020		\N	313702	0	444814009	40481087		0
79754	4724	4294548	1974-05-31	1974-05-31 00:00:00	1975-01-03	1975-01-03 00:00:00	32020		\N	314749	0	75498004	4294548		0
69553	4116	40481087	1999-09-22	1999-09-22 00:00:00	1999-10-06	1999-10-06 00:00:00	32020		\N	273629	0	444814009	40481087		0
69708	4124	40481087	1981-10-12	1981-10-12 00:00:00	1981-10-26	1981-10-26 00:00:00	32020		\N	274184	0	444814009	40481087		0
80788	4792	40481087	2013-09-08	2013-09-08 00:00:00	2013-09-22	2013-09-22 00:00:00	32020		\N	318867	0	444814009	40481087		0
80997	4804	260139	2006-09-16	2006-09-16 00:00:00	2006-09-23	2006-09-23 00:00:00	32020		\N	319603	0	10509002	260139		0
81429	4828	260139	2009-07-14	2009-07-14 00:00:00	2009-07-21	2009-07-21 00:00:00	32020		\N	321288	0	10509002	260139		0
81622	4843	378001	2001-08-22	2001-08-22 00:00:00	2001-09-21	2001-09-21 00:00:00	32020		\N	322111	0	62106007	378001		0
71208	4223	40481087	1980-09-11	1980-09-11 00:00:00	1980-09-25	1980-09-25 00:00:00	32020		\N	280414	0	444814009	40481087		0
81982	4860	260139	1988-05-27	1988-05-27 00:00:00	1988-06-03	1988-06-03 00:00:00	32020		\N	323289	0	10509002	260139		0
82029	4865	4112343	2015-05-22	2015-05-22 00:00:00	2015-05-30	2015-05-30 00:00:00	32020		\N	323522	0	195662009	4112343		0
82314	4883	80180	1986-03-31	1986-03-31 00:00:00	\N	\N	32020		\N	324692	0	396275006	80180		0
82434	4890	260139	1951-06-16	1951-06-16 00:00:00	1951-06-30	1951-06-30 00:00:00	32020		\N	325196	0	10509002	260139		0
82577	4899	378419	1993-10-12	1993-10-12 00:00:00	\N	\N	32020		\N	325831	0	26929004	378419		0
82671	4907	372328	1948-12-18	1948-12-18 00:00:00	1949-01-08	1949-01-08 00:00:00	32020		\N	326102	0	65363002	372328		0
82890	4923	80180	2000-05-23	2000-05-23 00:00:00	\N	\N	32020		\N	327084	0	396275006	80180		0
83457	4960	4112343	1921-10-16	1921-10-16 00:00:00	1921-10-29	1921-10-29 00:00:00	32020		\N	329716	0	195662009	4112343		0
83793	4977	4112343	1987-11-04	1987-11-04 00:00:00	1987-11-15	1987-11-15 00:00:00	32020		\N	331162	0	195662009	4112343		0
83959	4987	40481087	1981-12-19	1981-12-19 00:00:00	1981-12-26	1981-12-26 00:00:00	32020		\N	331709	0	444814009	40481087		0
84170	5000	40481087	1992-05-15	1992-05-15 00:00:00	1992-05-29	1992-05-29 00:00:00	32020		\N	332546	0	444814009	40481087		0
84475	5022	4059173	1977-07-10	1977-07-10 00:00:00	1977-09-08	1977-09-08 00:00:00	32020		\N	333658	0	16114001	4059173		0
84805	5044	257012	1975-06-28	1975-06-28 00:00:00	\N	\N	32020		\N	335226	0	40055000	257012		0
85062	5058	378001	1981-04-13	1981-04-13 00:00:00	1981-06-12	1981-06-12 00:00:00	32020		\N	336345	0	62106007	378001		0
85205	5068	4112343	1973-07-07	1973-07-07 00:00:00	1973-07-19	1973-07-19 00:00:00	32020		\N	336971	0	195662009	4112343		0
74844	4446	81151	1964-05-08	1964-05-08 00:00:00	1964-05-29	1964-05-29 00:00:00	32020		\N	295665	0	44465007	81151		0
74947	4451	4112343	1979-03-03	1979-03-03 00:00:00	1979-03-12	1979-03-12 00:00:00	32020		\N	296149	0	195662009	4112343		0
75068	4459	4112343	1972-08-20	1972-08-20 00:00:00	1972-09-01	1972-09-01 00:00:00	32020		\N	296720	0	195662009	4112343		0
75338	4473	40481087	1996-07-27	1996-07-27 00:00:00	1996-08-17	1996-08-17 00:00:00	32020		\N	297564	0	444814009	40481087		0
64868	3835	40481087	2018-01-07	2018-01-07 00:00:00	2018-01-14	2018-01-14 00:00:00	32020		\N	254638	0	444814009	40481087		0
75619	4487	40481087	1983-04-11	1983-04-11 00:00:00	1983-05-02	1983-05-02 00:00:00	32020		\N	298748	0	444814009	40481087		0
75729	4491	4112343	1965-05-17	1965-05-17 00:00:00	1965-05-25	1965-05-25 00:00:00	32020		\N	299028	0	195662009	4112343		0
75889	4500	4109685	2007-07-19	2007-07-19 00:00:00	2007-08-09	2007-08-09 00:00:00	32020		\N	299606	0	284551006	4109685		0
76150	4520	40481087	1983-06-30	1983-06-30 00:00:00	1983-07-07	1983-07-07 00:00:00	32020		\N	300900	0	444814009	40481087		0
86826	5169	40481087	1986-01-03	1986-01-03 00:00:00	1986-01-24	1986-01-24 00:00:00	32020		\N	343683	0	444814009	40481087		0
87037	5184	81151	1973-12-29	1973-12-29 00:00:00	1974-02-02	1974-02-02 00:00:00	32020		\N	344592	0	44465007	81151		0
76660	4544	4142905	1949-10-31	1949-10-31 00:00:00	1949-12-30	1949-12-30 00:00:00	32020		\N	302668	0	33737001	4142905		0
76792	4550	4134304	1971-03-26	1971-03-26 00:00:00	1971-04-25	1971-04-25 00:00:00	32020		\N	303200	0	263102004	4134304		0
76950	4560	4237458	1983-07-06	1983-07-06 00:00:00	1983-08-05	1983-08-05 00:00:00	32020		\N	303810	0	58150001	4237458		0
77047	4563	40481087	1989-12-27	1989-12-27 00:00:00	1990-01-03	1990-01-03 00:00:00	32020		\N	304107	0	444814009	40481087		0
87858	5228	372328	1952-05-21	1952-05-21 00:00:00	1953-04-09	1953-04-09 00:00:00	32020		\N	347797	0	65363002	372328		0
87984	5234	4296204	1972-04-15	1972-04-15 00:00:00	1972-05-06	1972-05-06 00:00:00	32020		\N	348211	0	403190006	4296204		0
77682	4603	40481087	1964-02-25	1964-02-25 00:00:00	1964-03-10	1964-03-10 00:00:00	32020		\N	306702	0	444814009	40481087		0
77784	4607	4134304	1988-10-13	1988-10-13 00:00:00	1988-12-12	1988-12-12 00:00:00	32020		\N	306875	0	263102004	4134304		0
88599	5267	192671	2006-04-03	2006-04-03 00:00:00	\N	\N	32020		\N	350477	0	K92.2	35208414		0
78122	4628	134438	1986-10-02	1986-10-02 00:00:00	1987-09-03	1987-09-03 00:00:00	32020		\N	308309	0	40275004	134438		0
78251	4633	4112343	1973-07-12	1973-07-12 00:00:00	1973-07-24	1973-07-24 00:00:00	32020		\N	308740	0	195662009	4112343		0
78428	4643	80180	1944-06-22	1944-06-22 00:00:00	\N	\N	32020		\N	309503	0	396275006	80180		0
78628	4656	317576	1959-09-20	1959-09-20 00:00:00	\N	\N	32020		\N	310430	0	53741008	317576		0
78762	4665	40481087	1983-01-15	1983-01-15 00:00:00	1983-01-22	1983-01-22 00:00:00	32020		\N	310882	0	444814009	40481087		0
89480	5322	81151	2000-09-29	2000-09-29 00:00:00	2000-10-27	2000-10-27 00:00:00	32020		\N	354261	0	44465007	81151		0
79116	4685	4112343	1949-04-28	1949-04-28 00:00:00	1949-05-10	1949-05-10 00:00:00	32020		\N	312130	0	195662009	4112343		0
89839	5343	40481087	1995-10-02	1995-10-02 00:00:00	1995-10-09	1995-10-09 00:00:00	32020		\N	355832	0	444814009	40481087		0
79518	4709	40481087	2018-09-18	2018-09-18 00:00:00	2018-10-09	2018-10-09 00:00:00	32020		\N	313695	0	444814009	40481087		0
79755	4724	4112343	1984-05-22	1984-05-22 00:00:00	1984-06-03	1984-06-03 00:00:00	32020		\N	314772	0	195662009	4112343		0
69554	4116	260139	1996-12-20	1996-12-20 00:00:00	1996-12-27	1996-12-27 00:00:00	32020		\N	273628	0	10509002	260139		0
69709	4124	80180	2014-03-01	2014-03-01 00:00:00	\N	\N	32020		\N	274203	0	396275006	80180		0
80789	4792	4059173	1969-03-11	1969-03-11 00:00:00	1969-04-10	1969-04-10 00:00:00	32020		\N	318826	0	16114001	4059173		0
80998	4804	260139	1994-08-07	1994-08-07 00:00:00	1994-08-14	1994-08-14 00:00:00	32020		\N	319563	0	10509002	260139		0
81430	4828	81151	1974-11-28	1974-11-28 00:00:00	1974-12-19	1974-12-19 00:00:00	32020		\N	321251	0	44465007	81151		0
81623	4843	260139	1988-08-13	1988-08-13 00:00:00	1988-08-20	1988-08-20 00:00:00	32020		\N	322152	0	10509002	260139		0
71209	4223	260139	1973-02-27	1973-02-27 00:00:00	1973-03-06	1973-03-06 00:00:00	32020		\N	280392	0	10509002	260139		0
81983	4860	260139	1980-06-21	1980-06-21 00:00:00	1980-07-05	1980-07-05 00:00:00	32020		\N	323343	0	10509002	260139		0
82030	4865	260139	2005-04-28	2005-04-28 00:00:00	2005-05-05	2005-05-05 00:00:00	32020		\N	323492	0	10509002	260139		0
82315	4883	4218389	1951-07-14	1951-07-14 00:00:00	1951-08-18	1951-08-18 00:00:00	32020		\N	324679	0	39848009	4218389		0
82435	4890	40481087	1923-07-07	1923-07-07 00:00:00	1923-07-21	1923-07-21 00:00:00	32020		\N	325078	0	444814009	40481087		0
82578	4899	80180	1964-05-01	1964-05-01 00:00:00	\N	\N	32020		\N	325791	0	396275006	80180		0
82672	4907	4296205	1983-07-02	1983-07-02 00:00:00	1983-08-06	1983-08-06 00:00:00	32020		\N	326204	0	403191005	4296205		0
82891	4923	4266809	2000-05-23	2000-05-23 00:00:00	\N	\N	32020		\N	327084	0	397881000	4266809		0
83458	4960	40481087	1930-10-01	1930-10-01 00:00:00	1930-10-22	1930-10-22 00:00:00	32020		\N	329748	0	444814009	40481087		0
83794	4977	260139	1988-07-15	1988-07-15 00:00:00	1988-07-22	1988-07-22 00:00:00	32020		\N	331188	0	10509002	260139		0
83960	4987	257012	1969-03-14	1969-03-14 00:00:00	\N	\N	32020		\N	331766	0	40055000	257012		0
84171	5000	260139	1953-04-08	1953-04-08 00:00:00	1953-04-15	1953-04-15 00:00:00	32020		\N	332512	0	10509002	260139		0
84476	5022	40481087	1979-01-10	1979-01-10 00:00:00	1979-01-17	1979-01-17 00:00:00	32020		\N	333666	0	444814009	40481087		0
84806	5044	260139	1993-05-15	1993-05-15 00:00:00	1993-05-29	1993-05-29 00:00:00	32020		\N	335210	0	10509002	260139		0
85063	5058	40481087	1957-09-28	1957-09-28 00:00:00	1957-10-05	1957-10-05 00:00:00	32020		\N	336303	0	444814009	40481087		0
85206	5068	260139	1983-08-29	1983-08-29 00:00:00	1983-09-05	1983-09-05 00:00:00	32020		\N	336949	0	10509002	260139		0
74845	4446	4112343	1964-04-12	1964-04-12 00:00:00	1964-04-21	1964-04-21 00:00:00	32020		\N	295634	0	195662009	4112343		0
74948	4451	4283893	1993-07-05	1993-07-05 00:00:00	1993-09-27	1993-09-27 00:00:00	32020		\N	296100	0	36971009	4283893		0
75069	4459	81151	1972-11-16	1972-11-16 00:00:00	1972-12-07	1972-12-07 00:00:00	32020		\N	296732	0	44465007	81151		0
75339	4474	28060	1969-10-22	1969-10-22 00:00:00	1969-10-30	1969-10-30 00:00:00	32020		\N	297696	0	43878008	28060		0
64869	3835	4112343	1997-05-27	1997-05-27 00:00:00	1997-06-04	1997-06-04 00:00:00	32020		\N	254644	0	195662009	4112343		0
75620	4487	78272	1962-07-27	1962-07-27 00:00:00	1962-08-17	1962-08-17 00:00:00	32020		\N	298682	0	70704007	78272		0
75730	4491	372328	1948-04-02	1948-04-02 00:00:00	1948-06-20	1948-06-20 00:00:00	32020		\N	298978	0	65363002	372328		0
75890	4501	40481087	1993-09-04	1993-09-04 00:00:00	1993-09-11	1993-09-11 00:00:00	32020		\N	299712	0	444814009	40481087		0
76151	4520	4109685	1935-10-24	1935-10-24 00:00:00	1935-11-07	1935-11-07 00:00:00	32020		\N	300889	0	284551006	4109685		0
86827	5169	40481087	1969-04-04	1969-04-04 00:00:00	1969-04-11	1969-04-11 00:00:00	32020		\N	343729	0	444814009	40481087		0
87038	5184	81151	1990-08-07	1990-08-07 00:00:00	1990-09-11	1990-09-11 00:00:00	32020		\N	344594	0	44465007	81151		0
76661	4544	4027663	1972-10-15	1972-10-15 00:00:00	\N	\N	32020		\N	302714	0	13200003	4027663		0
76793	4550	4112343	2002-12-26	2002-12-26 00:00:00	2003-01-02	2003-01-02 00:00:00	32020		\N	303172	0	195662009	4112343		0
76951	4560	40481087	2001-05-07	2001-05-07 00:00:00	2001-05-28	2001-05-28 00:00:00	32020		\N	303848	0	444814009	40481087		0
77048	4563	260139	1976-06-27	1976-06-27 00:00:00	1976-07-11	1976-07-11 00:00:00	32020		\N	304113	0	10509002	260139		0
87859	5228	4109685	1938-02-04	1938-02-04 00:00:00	1938-02-25	1938-02-25 00:00:00	32020		\N	347851	0	284551006	4109685		0
87985	5234	372328	1937-09-27	1937-09-27 00:00:00	1937-11-10	1937-11-10 00:00:00	32020		\N	348296	0	65363002	372328		0
77683	4603	260139	1962-05-10	1962-05-10 00:00:00	1962-05-24	1962-05-24 00:00:00	32020		\N	306651	0	10509002	260139		0
77785	4608	260139	1956-04-11	1956-04-11 00:00:00	1956-04-25	1956-04-25 00:00:00	32020		\N	307072	0	10509002	260139		0
88600	5267	260139	2008-09-26	2008-09-26 00:00:00	2008-10-03	2008-10-03 00:00:00	32020		\N	350399	0	10509002	260139		0
78143	4630	260139	1959-03-09	1959-03-09 00:00:00	1959-03-23	1959-03-23 00:00:00	32020		\N	308473	0	10509002	260139		0
78252	4633	4112343	2002-07-09	2002-07-09 00:00:00	2002-07-16	2002-07-16 00:00:00	32020		\N	308750	0	195662009	4112343		0
78429	4643	4283893	1945-10-27	1945-10-27 00:00:00	1945-12-22	1945-12-22 00:00:00	32020		\N	309609	0	36971009	4283893		0
78629	4656	372328	1951-08-02	1951-08-02 00:00:00	1951-08-16	1951-08-16 00:00:00	32020		\N	310453	0	65363002	372328		0
78763	4665	4112343	1986-12-03	1986-12-03 00:00:00	1986-12-13	1986-12-13 00:00:00	32020		\N	310899	0	195662009	4112343		0
89481	5322	40480160	2014-03-18	2014-03-18 00:00:00	2014-05-17	2014-05-17 00:00:00	32020		\N	354264	0	443165006	40480160		0
79117	4685	4112343	1957-11-19	1957-11-19 00:00:00	1957-12-01	1957-12-01 00:00:00	32020		\N	312104	0	195662009	4112343		0
89840	5343	28060	2008-08-11	2008-08-11 00:00:00	2008-08-24	2008-08-24 00:00:00	32020		\N	355935	0	43878008	28060		0
79525	4712	80180	2005-10-01	2005-10-01 00:00:00	\N	\N	32020		\N	313776	0	396275006	80180		0
79756	4724	439777	1941-05-07	1941-05-07 00:00:00	\N	\N	32020		\N	314678	0	271737000	439777		0
80027	4745	260139	1988-02-23	1988-02-23 00:00:00	1988-03-01	1988-03-01 00:00:00	32020		\N	315964	0	10509002	260139		0
69710	4124	260139	2013-03-22	2013-03-22 00:00:00	2013-03-29	2013-03-29 00:00:00	32020		\N	274194	0	10509002	260139		0
80790	4792	4112343	1993-08-23	1993-08-23 00:00:00	1993-08-31	1993-08-31 00:00:00	32020		\N	318872	0	195662009	4112343		0
80999	4804	30753	2012-02-01	2012-02-01 00:00:00	\N	\N	32020		\N	319574	0	16761005	30753		0
81431	4828	4278672	1984-05-01	1984-05-01 00:00:00	1984-06-30	1984-06-30 00:00:00	32020		\N	321252	0	65966004	4278672		0
81624	4843	4001336	1979-03-23	1979-03-23 00:00:00	1979-05-22	1979-05-22 00:00:00	32020		\N	322107	0	110030002	4001336		0
71210	4223	260139	1966-07-08	1966-07-08 00:00:00	1966-07-15	1966-07-15 00:00:00	32020		\N	280391	0	10509002	260139		0
81984	4860	80180	2011-10-11	2011-10-11 00:00:00	\N	\N	32020		\N	323311	0	396275006	80180		0
82316	4883	4112343	1986-12-16	1986-12-16 00:00:00	1986-12-23	1986-12-23 00:00:00	32020		\N	324689	0	195662009	4112343		0
82436	4890	4116491	1976-11-04	1976-11-04 00:00:00	1976-12-20	1976-12-20 00:00:00	32020		\N	325083	0	301011002	4116491		0
82579	4899	40481087	1929-08-22	1929-08-22 00:00:00	1929-08-29	1929-08-29 00:00:00	32020		\N	325836	0	444814009	40481087		0
82673	4907	4283893	1974-07-14	1974-07-14 00:00:00	1974-10-13	1974-10-13 00:00:00	32020		\N	326171	0	36971009	4283893		0
82892	4923	372328	1978-03-12	1978-03-12 00:00:00	1978-04-11	1978-04-11 00:00:00	32020		\N	327132	0	65363002	372328		0
83459	4960	4113008	1991-02-14	1991-02-14 00:00:00	1991-03-07	1991-03-07 00:00:00	32020		\N	329714	0	284549007	4113008		0
83795	4977	40481087	1983-12-25	1983-12-25 00:00:00	1984-01-01	1984-01-01 00:00:00	32020		\N	331111	0	444814009	40481087		0
83961	4987	78272	2019-06-10	2019-06-10 00:00:00	\N	\N	32020		\N	331791	0	70704007	78272		0
84172	5000	40481087	1947-04-05	1947-04-05 00:00:00	1947-04-19	1947-04-19 00:00:00	32020		\N	332511	0	444814009	40481087		0
84477	5023	260139	1994-09-12	1994-09-12 00:00:00	1994-09-26	1994-09-26 00:00:00	32020		\N	333746	0	10509002	260139		0
84807	5044	4294548	1975-05-10	1975-05-10 00:00:00	1975-09-27	1975-09-27 00:00:00	32020		\N	335214	0	75498004	4294548		0
85064	5058	4112343	1937-07-08	1937-07-08 00:00:00	1937-07-21	1937-07-21 00:00:00	32020		\N	336290	0	195662009	4112343		0
85207	5068	4109685	1966-06-16	1966-06-16 00:00:00	1966-06-30	1966-06-30 00:00:00	32020		\N	336990	0	284551006	4109685		0
74846	4446	4112343	1993-08-28	1993-08-28 00:00:00	1993-09-09	1993-09-09 00:00:00	32020		\N	295636	0	195662009	4112343		0
74949	4451	28060	2005-03-22	2005-03-22 00:00:00	2005-04-04	2005-04-04 00:00:00	32020		\N	296168	0	43878008	28060		0
75070	4459	260139	1968-12-03	1968-12-03 00:00:00	1968-12-10	1968-12-10 00:00:00	32020		\N	296728	0	10509002	260139		0
75340	4474	260139	1966-02-23	1966-02-23 00:00:00	1966-03-09	1966-03-09 00:00:00	32020		\N	297694	0	10509002	260139		0
64870	3835	4116491	2006-09-08	2006-09-08 00:00:00	2006-10-17	2006-10-17 00:00:00	32020		\N	254637	0	301011002	4116491		0
75621	4487	40481087	1996-01-27	1996-01-27 00:00:00	1996-02-10	1996-02-10 00:00:00	32020		\N	298756	0	444814009	40481087		0
75731	4491	260139	2001-05-28	2001-05-28 00:00:00	2001-06-05	2001-06-05 00:00:00	32020		\N	299032	0	10509002	260139		0
75891	4501	372328	1976-03-14	1976-03-14 00:00:00	1976-05-06	1976-05-06 00:00:00	32020		\N	299715	0	65363002	372328		0
76152	4520	260139	1972-01-13	1972-01-13 00:00:00	1972-01-20	1972-01-20 00:00:00	32020		\N	300947	0	10509002	260139		0
86828	5169	40481087	1956-09-18	1956-09-18 00:00:00	1956-10-02	1956-10-02 00:00:00	32020		\N	343716	0	444814009	40481087		0
87039	5184	4112343	1990-01-19	1990-01-19 00:00:00	1990-01-28	1990-01-28 00:00:00	32020		\N	344567	0	195662009	4112343		0
76662	4544	40481087	1993-11-29	1993-11-29 00:00:00	1993-12-13	1993-12-13 00:00:00	32020		\N	302711	0	444814009	40481087		0
76794	4550	40481087	1974-10-07	1974-10-07 00:00:00	1974-10-21	1974-10-21 00:00:00	32020		\N	303178	0	444814009	40481087		0
76952	4560	81151	1975-06-22	1975-06-22 00:00:00	1975-07-27	1975-07-27 00:00:00	32020		\N	303807	0	44465007	81151		0
77053	4565	40481087	2019-05-26	2019-05-26 00:00:00	2019-06-02	2019-06-02 00:00:00	32020		\N	304238	0	444814009	40481087		0
87860	5228	4146173	1985-11-11	1985-11-11 00:00:00	1986-01-10	1986-01-10 00:00:00	32020		\N	347782	0	307731004	4146173		0
87986	5234	4155034	1993-08-28	1993-08-28 00:00:00	1993-09-11	1993-09-11 00:00:00	32020		\N	348215	0	283371005	4155034		0
77684	4603	4278672	2018-01-18	2018-01-18 00:00:00	2018-03-19	2018-03-19 00:00:00	32020		\N	306625	0	65966004	4278672		0
77786	4608	260139	1992-05-15	1992-05-15 00:00:00	1992-05-22	1992-05-22 00:00:00	32020		\N	306977	0	10509002	260139		0
88601	5267	372328	1968-06-26	1968-06-26 00:00:00	1968-11-10	1968-11-10 00:00:00	32020		\N	350413	0	65363002	372328		0
78144	4630	4059173	1965-09-15	1965-09-15 00:00:00	1965-11-14	1965-11-14 00:00:00	32020		\N	308519	0	16114001	4059173		0
78253	4633	4283893	1975-06-20	1975-06-20 00:00:00	1975-08-29	1975-08-29 00:00:00	32020		\N	308802	0	36971009	4283893		0
78430	4643	40481087	1922-07-17	1922-07-17 00:00:00	1922-07-24	1922-07-24 00:00:00	32020		\N	309512	0	444814009	40481087		0
78630	4656	40481087	2011-05-30	2011-05-30 00:00:00	2011-06-06	2011-06-06 00:00:00	32020		\N	310458	0	444814009	40481087		0
78764	4665	4112343	1988-09-07	1988-09-07 00:00:00	1988-09-16	1988-09-16 00:00:00	32020		\N	310874	0	195662009	4112343		0
89482	5322	4237458	2014-03-18	2014-03-18 00:00:00	2014-05-17	2014-05-17 00:00:00	32020		\N	354264	0	58150001	4237458		0
79118	4685	81151	1950-07-13	1950-07-13 00:00:00	1950-08-03	1950-08-03 00:00:00	32020		\N	312151	0	44465007	81151		0
89841	5343	4278672	1998-09-10	1998-09-10 00:00:00	1998-11-09	1998-11-09 00:00:00	32020		\N	355928	0	65966004	4278672		0
79526	4712	40481087	1973-02-21	1973-02-21 00:00:00	1973-03-14	1973-03-14 00:00:00	32020		\N	313781	0	444814009	40481087		0
79757	4724	4112343	2015-05-23	2015-05-23 00:00:00	2015-06-04	2015-06-04 00:00:00	32020		\N	314719	0	195662009	4112343		0
80028	4745	260139	2011-09-28	2011-09-28 00:00:00	2011-10-12	2011-10-12 00:00:00	32020		\N	315986	0	10509002	260139		0
69711	4124	4112343	1976-03-08	1976-03-08 00:00:00	1976-03-19	1976-03-19 00:00:00	32020		\N	274204	0	195662009	4112343		0
80791	4792	40481087	1997-04-20	1997-04-20 00:00:00	1997-05-04	1997-05-04 00:00:00	32020		\N	318843	0	444814009	40481087		0
81000	4805	40481087	2006-09-26	2006-09-26 00:00:00	2006-10-03	2006-10-03 00:00:00	32020		\N	319700	0	444814009	40481087		0
81432	4829	4112343	2001-10-14	2001-10-14 00:00:00	2001-10-24	2001-10-24 00:00:00	32020		\N	321345	0	195662009	4112343		0
81625	4843	4266809	1997-11-28	1997-11-28 00:00:00	\N	\N	32020		\N	322153	0	397881000	4266809		0
71211	4223	80180	1989-08-05	1989-08-05 00:00:00	\N	\N	32020		\N	280436	0	396275006	80180		0
81985	4860	4237458	1995-08-01	1995-08-01 00:00:00	1995-08-31	1995-08-31 00:00:00	32020		\N	323340	0	58150001	4237458		0
82032	4865	4112343	1981-12-22	1981-12-22 00:00:00	1981-12-31	1981-12-31 00:00:00	32020		\N	323543	0	195662009	4112343		0
82317	4883	372328	1947-06-14	1947-06-14 00:00:00	1947-11-28	1947-11-28 00:00:00	32020		\N	324638	0	65363002	372328		0
82437	4890	134438	1946-11-19	1946-11-19 00:00:00	1947-11-18	1947-11-18 00:00:00	32020		\N	325063	0	40275004	134438		0
82580	4899	372328	1922-10-19	1922-10-19 00:00:00	1922-11-02	1922-11-02 00:00:00	32020		\N	325806	0	65363002	372328		0
82674	4907	4134304	1953-03-27	1953-03-27 00:00:00	1953-05-26	1953-05-26 00:00:00	32020		\N	326194	0	263102004	4134304		0
82893	4923	40481087	1997-08-04	1997-08-04 00:00:00	1997-08-11	1997-08-11 00:00:00	32020		\N	327138	0	444814009	40481087		0
83460	4960	4152936	1935-01-01	1935-01-01 00:00:00	1935-01-15	1935-01-15 00:00:00	32020		\N	329705	0	283385000	4152936		0
83796	4977	40481087	1973-10-11	1973-10-11 00:00:00	1973-10-18	1973-10-18 00:00:00	32020		\N	331185	0	444814009	40481087		0
83962	4987	4296204	2002-03-15	2002-03-15 00:00:00	2002-04-12	2002-04-12 00:00:00	32020		\N	331789	0	403190006	4296204		0
84173	5000	40481087	2008-02-04	2008-02-04 00:00:00	2008-02-25	2008-02-25 00:00:00	32020		\N	332514	0	444814009	40481087		0
84478	5023	260139	2003-02-01	2003-02-01 00:00:00	2003-02-15	2003-02-15 00:00:00	32020		\N	333777	0	10509002	260139		0
84808	5044	40481087	1982-08-26	1982-08-26 00:00:00	1982-09-16	1982-09-16 00:00:00	32020		\N	335208	0	444814009	40481087		0
85065	5058	4218389	1975-06-23	1975-06-23 00:00:00	1975-07-14	1975-07-14 00:00:00	32020		\N	336344	0	39848009	4218389		0
85208	5068	28060	1984-12-02	1984-12-02 00:00:00	1984-12-10	1984-12-10 00:00:00	32020		\N	336923	0	43878008	28060		0
74847	4446	4112343	1975-05-25	1975-05-25 00:00:00	1975-06-01	1975-06-01 00:00:00	32020		\N	295641	0	195662009	4112343		0
74950	4451	372328	1954-06-26	1954-06-26 00:00:00	1954-10-17	1954-10-17 00:00:00	32020		\N	296137	0	65363002	372328		0
75071	4459	81151	1970-11-13	1970-11-13 00:00:00	1970-11-27	1970-11-27 00:00:00	32020		\N	296709	0	44465007	81151		0
75341	4474	260139	1966-10-04	1966-10-04 00:00:00	1966-10-18	1966-10-18 00:00:00	32020		\N	297670	0	10509002	260139		0
64871	3835	28060	1967-12-10	1967-12-10 00:00:00	1967-12-17	1967-12-17 00:00:00	32020		\N	254635	0	43878008	28060		0
75622	4487	40481087	2003-09-18	2003-09-18 00:00:00	2003-10-09	2003-10-09 00:00:00	32020		\N	298734	0	444814009	40481087		0
75732	4491	260139	2018-06-08	2018-06-08 00:00:00	2018-06-22	2018-06-22 00:00:00	32020		\N	298987	0	10509002	260139		0
75892	4501	40481087	1991-03-05	1991-03-05 00:00:00	1991-03-12	1991-03-12 00:00:00	32020		\N	299706	0	444814009	40481087		0
76153	4520	4218389	1985-02-13	1985-02-13 00:00:00	1985-03-06	1985-03-06 00:00:00	32020		\N	300894	0	39848009	4218389		0
86829	5169	4152936	1954-06-26	1954-06-26 00:00:00	1954-07-17	1954-07-17 00:00:00	32020		\N	343731	0	283385000	4152936		0
87040	5184	40481087	2002-03-26	2002-03-26 00:00:00	2002-04-09	2002-04-09 00:00:00	32020		\N	344548	0	444814009	40481087		0
76663	4544	40481087	1968-12-27	1968-12-27 00:00:00	1969-01-03	1969-01-03 00:00:00	32020		\N	302655	0	444814009	40481087		0
76795	4550	4112343	1999-04-01	1999-04-01 00:00:00	1999-04-14	1999-04-14 00:00:00	32020		\N	303260	0	195662009	4112343		0
76953	4560	80180	2007-02-04	2007-02-04 00:00:00	\N	\N	32020		\N	303866	0	396275006	80180		0
77054	4565	4278672	2016-11-04	2016-11-04 00:00:00	2017-02-02	2017-02-02 00:00:00	32020		\N	304213	0	65966004	4278672		0
87861	5228	4266809	1968-12-03	1968-12-03 00:00:00	\N	\N	32020		\N	347793	0	397881000	4266809		0
87987	5234	258780	1997-04-23	1997-04-23 00:00:00	\N	\N	32020		\N	348274	0	185086009	258780		0
77685	4603	40480160	2018-01-18	2018-01-18 00:00:00	2018-03-19	2018-03-19 00:00:00	32020		\N	306625	0	443165006	40480160		0
77787	4608	378001	1958-09-26	1958-09-26 00:00:00	1958-10-26	1958-10-26 00:00:00	32020		\N	307062	0	62106007	378001		0
88602	5267	4112343	1979-03-04	1979-03-04 00:00:00	1979-03-16	1979-03-16 00:00:00	32020		\N	350355	0	195662009	4112343		0
78145	4630	40481087	1986-07-20	1986-07-20 00:00:00	1986-07-27	1986-07-27 00:00:00	32020		\N	308510	0	444814009	40481087		0
78254	4633	40481087	1960-04-26	1960-04-26 00:00:00	1960-05-03	1960-05-03 00:00:00	32020		\N	308801	0	444814009	40481087		0
78431	4643	378419	1992-04-25	1992-04-25 00:00:00	\N	\N	32020		\N	309523	0	26929004	378419		0
78631	4656	260139	2009-08-29	2009-08-29 00:00:00	2009-09-12	2009-09-12 00:00:00	32020		\N	310483	0	10509002	260139		0
78765	4665	40481087	2001-03-26	2001-03-26 00:00:00	2001-04-02	2001-04-02 00:00:00	32020		\N	310883	0	444814009	40481087		0
89483	5322	40486433	1950-01-28	1950-01-28 00:00:00	\N	\N	32020		\N	354071	0	446096008	40486433		0
79119	4685	372328	1940-04-01	1940-04-01 00:00:00	1940-05-13	1940-05-13 00:00:00	32020		\N	312132	0	65363002	372328		0
89842	5343	4112343	1987-12-09	1987-12-09 00:00:00	1987-12-17	1987-12-17 00:00:00	32020		\N	355815	0	195662009	4112343		0
79527	4712	40481087	1972-10-03	1972-10-03 00:00:00	1972-10-17	1972-10-17 00:00:00	32020		\N	313767	0	444814009	40481087		0
79758	4724	4278672	2003-09-14	2003-09-14 00:00:00	2003-12-13	2003-12-13 00:00:00	32020		\N	314690	0	65966004	4278672		0
80029	4745	260139	1981-11-27	1981-11-27 00:00:00	1981-12-04	1981-12-04 00:00:00	32020		\N	315940	0	10509002	260139		0
69712	4124	4283893	1996-01-11	1996-01-11 00:00:00	1996-02-22	1996-02-22 00:00:00	32020		\N	274153	0	36971009	4283893		0
80792	4792	4116491	1981-04-21	1981-04-21 00:00:00	1981-05-29	1981-05-29 00:00:00	32020		\N	318878	0	301011002	4116491		0
81001	4805	260139	1999-08-12	1999-08-12 00:00:00	1999-08-26	1999-08-26 00:00:00	32020		\N	319681	0	10509002	260139		0
81433	4829	192671	2012-07-04	2012-07-04 00:00:00	\N	\N	32020		\N	321316	0	K92.2	35208414		0
81626	4843	80180	1997-11-28	1997-11-28 00:00:00	\N	\N	32020		\N	322153	0	396275006	80180		0
71212	4223	4112343	1967-07-04	1967-07-04 00:00:00	1967-07-16	1967-07-16 00:00:00	32020		\N	280356	0	195662009	4112343		0
81986	4860	40481087	2006-12-25	2006-12-25 00:00:00	2007-01-15	2007-01-15 00:00:00	32020		\N	323323	0	444814009	40481087		0
82033	4865	4112343	2010-01-08	2010-01-08 00:00:00	2010-01-16	2010-01-16 00:00:00	32020		\N	323521	0	195662009	4112343		0
82318	4883	4112343	2015-12-05	2015-12-05 00:00:00	2015-12-13	2015-12-13 00:00:00	32020		\N	324704	0	195662009	4112343		0
82438	4890	313217	2009-12-09	2009-12-09 00:00:00	\N	\N	32020		\N	325166	0	49436004	313217		0
82581	4899	40481087	1991-02-05	1991-02-05 00:00:00	1991-02-12	1991-02-12 00:00:00	32020		\N	325777	0	444814009	40481087		0
82675	4907	440448	1948-02-03	1948-02-03 00:00:00	\N	\N	32020		\N	326193	0	74400008	440448		0
82894	4923	260139	1977-04-15	1977-04-15 00:00:00	1977-04-29	1977-04-29 00:00:00	32020		\N	327097	0	10509002	260139		0
83461	4960	4112343	1990-10-03	1990-10-03 00:00:00	1990-10-15	1990-10-15 00:00:00	32020		\N	329687	0	195662009	4112343		0
83797	4977	4294548	1998-06-23	1998-06-23 00:00:00	1998-07-28	1998-07-28 00:00:00	32020		\N	331125	0	75498004	4294548		0
83963	4987	378001	1986-02-07	1986-02-07 00:00:00	1986-03-09	1986-03-09 00:00:00	32020		\N	331788	0	62106007	378001		0
84174	5000	40481087	1950-12-06	1950-12-06 00:00:00	1950-12-27	1950-12-27 00:00:00	32020		\N	332543	0	444814009	40481087		0
84479	5023	80180	2015-06-12	2015-06-12 00:00:00	\N	\N	32020		\N	333763	0	396275006	80180		0
84809	5044	4112343	1976-04-02	1976-04-02 00:00:00	1976-04-09	1976-04-09 00:00:00	32020		\N	335189	0	195662009	4112343		0
85066	5058	260139	1966-11-03	1966-11-03 00:00:00	1966-11-17	1966-11-17 00:00:00	32020		\N	336304	0	10509002	260139		0
85209	5068	28060	1956-09-14	1956-09-14 00:00:00	1956-09-23	1956-09-23 00:00:00	32020		\N	336996	0	43878008	28060		0
74848	4447	4059173	1955-08-30	1955-08-30 00:00:00	1955-09-29	1955-09-29 00:00:00	32020		\N	295712	0	16114001	4059173		0
74951	4451	372328	1955-05-15	1955-05-15 00:00:00	1956-04-22	1956-04-22 00:00:00	32020		\N	296151	0	65363002	372328		0
75072	4459	4112343	2005-01-14	2005-01-14 00:00:00	2005-01-21	2005-01-21 00:00:00	32020		\N	296711	0	195662009	4112343		0
75342	4474	40481087	1988-09-02	1988-09-02 00:00:00	1988-09-16	1988-09-16 00:00:00	32020		\N	297671	0	444814009	40481087		0
64872	3835	81151	1966-08-14	1966-08-14 00:00:00	1966-09-11	1966-09-11 00:00:00	32020		\N	254690	0	44465007	81151		0
75623	4487	192671	1988-03-26	1988-03-26 00:00:00	\N	\N	32020		\N	298776	0	K92.2	35208414		0
75733	4491	28060	2015-02-09	2015-02-09 00:00:00	2015-02-19	2015-02-19 00:00:00	32020		\N	298999	0	43878008	28060		0
75893	4501	260139	1983-01-31	1983-01-31 00:00:00	1983-02-07	1983-02-07 00:00:00	32020		\N	299705	0	10509002	260139		0
76154	4520	258780	1957-04-20	1957-04-20 00:00:00	\N	\N	32020		\N	300885	0	185086009	258780		0
86830	5169	260139	1984-11-25	1984-11-25 00:00:00	1984-12-09	1984-12-09 00:00:00	32020		\N	343690	0	10509002	260139		0
87041	5184	40481087	1973-08-04	1973-08-04 00:00:00	1973-08-25	1973-08-25 00:00:00	32020		\N	344529	0	444814009	40481087		0
76664	4544	192671	1984-06-02	1984-06-02 00:00:00	\N	\N	32020		\N	302707	0	K92.2	35208414		0
76796	4550	28060	1977-09-07	1977-09-07 00:00:00	1977-09-20	1977-09-20 00:00:00	32020		\N	303204	0	43878008	28060		0
76954	4560	30753	2005-10-12	2005-10-12 00:00:00	\N	\N	32020		\N	303866	0	16761005	30753		0
77055	4565	40481087	1976-05-04	1976-05-04 00:00:00	1976-05-18	1976-05-18 00:00:00	32020		\N	304222	0	444814009	40481087		0
87862	5228	30753	1968-02-07	1968-02-07 00:00:00	\N	\N	32020		\N	347793	0	16761005	30753		0
87988	5234	40481087	2000-07-25	2000-07-25 00:00:00	2000-08-15	2000-08-15 00:00:00	32020		\N	348288	0	444814009	40481087		0
77686	4603	40481087	1937-10-14	1937-10-14 00:00:00	1937-11-04	1937-11-04 00:00:00	32020		\N	306591	0	444814009	40481087		0
77788	4608	260139	2017-10-10	2017-10-10 00:00:00	2017-10-24	2017-10-24 00:00:00	32020		\N	307036	0	10509002	260139		0
88603	5267	28060	1971-05-15	1971-05-15 00:00:00	1971-05-27	1971-05-27 00:00:00	32020		\N	350352	0	43878008	28060		0
78146	4630	260139	1985-08-20	1985-08-20 00:00:00	1985-09-03	1985-09-03 00:00:00	32020		\N	308509	0	10509002	260139		0
78255	4633	260139	1961-08-12	1961-08-12 00:00:00	1961-08-26	1961-08-26 00:00:00	32020		\N	308746	0	10509002	260139		0
78432	4643	40481087	1968-06-10	1968-06-10 00:00:00	1968-06-17	1968-06-17 00:00:00	32020		\N	309592	0	444814009	40481087		0
78632	4656	4296204	1950-10-06	1950-10-06 00:00:00	1950-11-03	1950-11-03 00:00:00	32020		\N	310468	0	403190006	4296204		0
78766	4665	40481087	2006-01-15	2006-01-15 00:00:00	2006-01-22	2006-01-22 00:00:00	32020		\N	310908	0	444814009	40481087		0
89484	5322	40481087	1976-09-26	1976-09-26 00:00:00	1976-10-10	1976-10-10 00:00:00	32020		\N	354181	0	444814009	40481087		0
79120	4685	40481087	1957-08-31	1957-08-31 00:00:00	1957-09-21	1957-09-21 00:00:00	32020		\N	312102	0	444814009	40481087		0
89843	5343	4112343	1999-02-21	1999-02-21 00:00:00	1999-02-28	1999-02-28 00:00:00	32020		\N	355892	0	195662009	4112343		0
79529	4712	4112343	1978-12-06	1978-12-06 00:00:00	1978-12-17	1978-12-17 00:00:00	32020		\N	313783	0	195662009	4112343		0
79759	4724	40481087	1952-11-14	1952-11-14 00:00:00	1952-11-28	1952-11-28 00:00:00	32020		\N	314733	0	444814009	40481087		0
80030	4745	40481087	1984-06-07	1984-06-07 00:00:00	1984-06-21	1984-06-21 00:00:00	32020		\N	315962	0	444814009	40481087		0
69713	4124	40481087	1998-07-01	1998-07-01 00:00:00	1998-07-15	1998-07-15 00:00:00	32020		\N	274207	0	444814009	40481087		0
80793	4792	40481087	2005-11-28	2005-11-28 00:00:00	2005-12-12	2005-12-12 00:00:00	32020		\N	318879	0	444814009	40481087		0
81002	4805	4296204	2016-10-24	2016-10-24 00:00:00	2016-11-14	2016-11-14 00:00:00	32020		\N	319732	0	403190006	4296204		0
81434	4829	4112343	2009-01-16	2009-01-16 00:00:00	2009-01-27	2009-01-27 00:00:00	32020		\N	321357	0	195662009	4112343		0
81627	4843	28060	1981-12-22	1981-12-22 00:00:00	1981-12-29	1981-12-29 00:00:00	32020		\N	322150	0	43878008	28060		0
71213	4223	40481087	2003-11-20	2003-11-20 00:00:00	2003-12-04	2003-12-04 00:00:00	32020		\N	280428	0	444814009	40481087		0
81987	4860	134438	1999-10-01	1999-10-01 00:00:00	2000-10-25	2000-10-25 00:00:00	32020		\N	323346	0	40275004	134438		0
82034	4865	81151	1985-01-14	1985-01-14 00:00:00	1985-02-11	1985-02-11 00:00:00	32020		\N	323502	0	44465007	81151		0
82319	4883	4109685	1975-06-13	1975-06-13 00:00:00	1975-07-04	1975-07-04 00:00:00	32020		\N	324681	0	284551006	4109685		0
82439	4890	80180	1957-07-02	1957-07-02 00:00:00	\N	\N	32020		\N	325176	0	396275006	80180		0
82582	4899	28060	1924-11-19	1924-11-19 00:00:00	1924-12-01	1924-12-01 00:00:00	32020		\N	325751	0	43878008	28060		0
82680	4909	40481087	1997-08-14	1997-08-14 00:00:00	1997-09-04	1997-09-04 00:00:00	32020		\N	326256	0	444814009	40481087		0
82895	4923	4155034	2014-09-05	2014-09-05 00:00:00	2014-09-19	2014-09-19 00:00:00	32020		\N	327127	0	283371005	4155034		0
83462	4960	4237458	1989-12-21	1989-12-21 00:00:00	1990-03-21	1990-03-21 00:00:00	32020		\N	329712	0	58150001	4237458		0
83798	4977	372328	1962-03-07	1962-03-07 00:00:00	1962-05-26	1962-05-26 00:00:00	32020		\N	331116	0	65363002	372328		0
83964	4987	260139	2007-01-30	2007-01-30 00:00:00	2007-02-06	2007-02-06 00:00:00	32020		\N	331735	0	10509002	260139		0
84175	5000	372328	1938-09-22	1938-09-22 00:00:00	1938-11-29	1938-11-29 00:00:00	32020		\N	332518	0	65363002	372328		0
84480	5023	372328	1972-10-05	1972-10-05 00:00:00	1972-11-12	1972-11-12 00:00:00	32020		\N	333739	0	65363002	372328		0
84810	5044	372328	2013-02-13	2013-02-13 00:00:00	2014-11-26	2014-11-26 00:00:00	32020		\N	335218	0	65363002	372328		0
85067	5058	40479422	2014-07-17	2014-07-17 00:00:00	2014-09-22	2014-09-22 00:00:00	32020		\N	336348	0	444448004	40479422		0
85210	5068	28060	1945-08-06	1945-08-06 00:00:00	1945-08-18	1945-08-18 00:00:00	32020		\N	336915	0	43878008	28060		0
74849	4447	28060	1959-02-24	1959-02-24 00:00:00	1959-03-08	1959-03-08 00:00:00	32020		\N	295705	0	43878008	28060		0
74952	4451	4112343	2019-05-22	2019-05-22 00:00:00	2019-05-31	2019-05-31 00:00:00	32020		\N	296150	0	195662009	4112343		0
75073	4459	80180	2005-05-29	2005-05-29 00:00:00	\N	\N	32020		\N	296711	0	396275006	80180		0
75343	4474	40481087	2004-08-16	2004-08-16 00:00:00	2004-08-23	2004-08-23 00:00:00	32020		\N	297673	0	444814009	40481087		0
64873	3835	4113008	1986-09-17	1986-09-17 00:00:00	1986-10-01	1986-10-01 00:00:00	32020		\N	254662	0	284549007	4113008		0
75624	4487	260139	1960-05-10	1960-05-10 00:00:00	1960-05-17	1960-05-17 00:00:00	32020		\N	298698	0	10509002	260139		0
75734	4491	4112343	1968-02-11	1968-02-11 00:00:00	1968-02-23	1968-02-23 00:00:00	32020		\N	299016	0	195662009	4112343		0
75894	4501	40481087	1987-09-22	1987-09-22 00:00:00	1987-10-13	1987-10-13 00:00:00	32020		\N	299711	0	444814009	40481087		0
76155	4520	40481087	1946-11-02	1946-11-02 00:00:00	1946-11-16	1946-11-16 00:00:00	32020		\N	300897	0	444814009	40481087		0
86831	5169	4112343	1998-12-06	1998-12-06 00:00:00	1998-12-16	1998-12-16 00:00:00	32020		\N	343675	0	195662009	4112343		0
87042	5184	4112343	1973-02-03	1973-02-03 00:00:00	1973-02-13	1973-02-13 00:00:00	32020		\N	344579	0	195662009	4112343		0
76665	4544	40481087	1964-09-23	1964-09-23 00:00:00	1964-10-14	1964-10-14 00:00:00	32020		\N	302674	0	444814009	40481087		0
76797	4551	40481087	2016-03-11	2016-03-11 00:00:00	2016-04-01	2016-04-01 00:00:00	32020		\N	303331	0	444814009	40481087		0
76955	4560	81893	2005-04-15	2005-04-15 00:00:00	\N	\N	32020		\N	303866	0	64766004	81893		0
77056	4565	40479422	1962-07-14	1962-07-14 00:00:00	1962-09-19	1962-09-19 00:00:00	32020		\N	304208	0	444448004	40479422		0
87863	5228	81893	1967-09-10	1967-09-10 00:00:00	\N	\N	32020		\N	347793	0	64766004	81893		0
87989	5234	40481087	1954-08-05	1954-08-05 00:00:00	1954-08-12	1954-08-12 00:00:00	32020		\N	348243	0	444814009	40481087		0
77687	4603	260139	1972-04-14	1972-04-14 00:00:00	1972-04-28	1972-04-28 00:00:00	32020		\N	306652	0	10509002	260139		0
77789	4608	40481087	1977-07-13	1977-07-13 00:00:00	1977-07-27	1977-07-27 00:00:00	32020		\N	307073	0	444814009	40481087		0
88604	5267	134438	1995-12-04	1995-12-04 00:00:00	1996-10-04	1996-10-04 00:00:00	32020		\N	350430	0	40275004	134438		0
78147	4630	40481087	1982-01-20	1982-01-20 00:00:00	1982-02-03	1982-02-03 00:00:00	32020		\N	308508	0	444814009	40481087		0
78256	4633	372328	1959-07-23	1959-07-23 00:00:00	1959-11-03	1959-11-03 00:00:00	32020		\N	308796	0	65363002	372328		0
78433	4643	28060	1994-06-20	1994-06-20 00:00:00	1994-07-02	1994-07-02 00:00:00	32020		\N	309596	0	43878008	28060		0
78633	4656	372328	1963-05-15	1963-05-15 00:00:00	1963-10-13	1963-10-13 00:00:00	32020		\N	310484	0	65363002	372328		0
78767	4665	4112343	2010-10-23	2010-10-23 00:00:00	2010-11-05	2010-11-05 00:00:00	32020		\N	310901	0	195662009	4112343		0
89485	5322	80180	1982-06-02	1982-06-02 00:00:00	\N	\N	32020		\N	354112	0	396275006	80180		0
79121	4685	372328	1974-09-24	1974-09-24 00:00:00	1976-12-06	1976-12-06 00:00:00	32020		\N	312121	0	65363002	372328		0
89844	5343	4113008	2016-11-04	2016-11-04 00:00:00	2016-11-18	2016-11-18 00:00:00	32020		\N	355930	0	284549007	4113008		0
79530	4712	28060	1979-03-18	1979-03-18 00:00:00	1979-03-25	1979-03-25 00:00:00	32020		\N	313746	0	43878008	28060		0
79760	4724	372328	1943-06-09	1943-06-09 00:00:00	1943-10-13	1943-10-13 00:00:00	32020		\N	314720	0	65363002	372328		0
80031	4745	440086	1985-03-30	1985-03-30 00:00:00	1993-04-07	1993-04-07 00:00:00	32020		\N	315963	0	192127007	440086		0
69714	4124	28060	2002-06-11	2002-06-11 00:00:00	2002-06-19	2002-06-19 00:00:00	32020		\N	274177	0	43878008	28060		0
80794	4792	381316	1974-11-05	1974-11-05 00:00:00	\N	\N	32020		\N	318868	0	230690007	381316		0
81003	4805	80180	2003-07-01	2003-07-01 00:00:00	\N	\N	32020		\N	319709	0	396275006	80180		0
81435	4829	40481087	1973-06-11	1973-06-11 00:00:00	1973-07-02	1973-07-02 00:00:00	32020		\N	321304	0	444814009	40481087		0
81628	4843	40481087	1980-02-21	1980-02-21 00:00:00	1980-03-13	1980-03-13 00:00:00	32020		\N	322114	0	444814009	40481087		0
71214	4223	4283893	1983-07-19	1983-07-19 00:00:00	1983-08-30	1983-08-30 00:00:00	32020		\N	280381	0	36971009	4283893		0
81988	4860	260139	2015-11-12	2015-11-12 00:00:00	2015-11-21	2015-11-21 00:00:00	32020		\N	323290	0	10509002	260139		0
82035	4865	4294548	1998-04-05	1998-04-05 00:00:00	1998-04-26	1998-04-26 00:00:00	32020		\N	323491	0	75498004	4294548		0
82320	4883	260139	2008-08-15	2008-08-15 00:00:00	2008-08-29	2008-08-29 00:00:00	32020		\N	324643	0	10509002	260139		0
82440	4890	4142905	1981-12-26	1981-12-26 00:00:00	1982-02-24	1982-02-24 00:00:00	32020		\N	325146	0	33737001	4142905		0
82583	4899	4109685	1945-06-20	1945-06-20 00:00:00	1945-07-04	1945-07-04 00:00:00	32020		\N	325814	0	284551006	4109685		0
82681	4909	4156265	1985-12-25	1985-12-25 00:00:00	1986-01-15	1986-01-15 00:00:00	32020		\N	326277	0	370247008	4156265		0
82896	4923	4112343	2005-07-11	2005-07-11 00:00:00	2005-07-22	2005-07-22 00:00:00	32020		\N	327139	0	195662009	4112343		0
83799	4977	40481087	1971-08-26	1971-08-26 00:00:00	1971-09-16	1971-09-16 00:00:00	32020		\N	331198	0	444814009	40481087		0
83965	4987	4112343	1979-05-29	1979-05-29 00:00:00	1979-06-08	1979-06-08 00:00:00	32020		\N	331729	0	195662009	4112343		0
84176	5000	4027663	1964-08-16	1964-08-16 00:00:00	\N	\N	32020		\N	332608	0	13200003	4027663		0
84481	5023	40481087	2007-07-02	2007-07-02 00:00:00	2007-07-23	2007-07-23 00:00:00	32020		\N	333725	0	444814009	40481087		0
84811	5044	28060	1979-08-26	1979-08-26 00:00:00	1979-09-07	1979-09-07 00:00:00	32020		\N	335190	0	43878008	28060		0
85068	5058	40481087	2013-06-18	2013-06-18 00:00:00	2013-06-25	2013-06-25 00:00:00	32020		\N	336335	0	444814009	40481087		0
85211	5068	260139	1975-07-19	1975-07-19 00:00:00	1975-08-02	1975-08-02 00:00:00	32020		\N	336948	0	10509002	260139		0
74850	4447	260139	1998-06-03	1998-06-03 00:00:00	1998-06-17	1998-06-17 00:00:00	32020		\N	295779	0	10509002	260139		0
74953	4451	4152936	1980-01-11	1980-01-11 00:00:00	1980-01-25	1980-01-25 00:00:00	32020		\N	296139	0	283385000	4152936		0
75074	4459	4296204	2012-12-03	2012-12-03 00:00:00	2012-12-17	2012-12-17 00:00:00	32020		\N	296735	0	403190006	4296204		0
75344	4474	40481087	1997-04-29	1997-04-29 00:00:00	1997-05-20	1997-05-20 00:00:00	32020		\N	297632	0	444814009	40481087		0
64874	3835	81151	2001-02-14	2001-02-14 00:00:00	2001-03-21	2001-03-21 00:00:00	32020		\N	254663	0	44465007	81151		0
75625	4487	81151	1965-05-03	1965-05-03 00:00:00	1965-05-24	1965-05-24 00:00:00	32020		\N	298683	0	44465007	81151		0
75735	4491	40481087	2007-06-03	2007-06-03 00:00:00	2007-06-10	2007-06-10 00:00:00	32020		\N	298998	0	444814009	40481087		0
75895	4501	80180	2014-11-10	2014-11-10 00:00:00	\N	\N	32020		\N	299752	0	396275006	80180		0
76156	4520	40481087	1990-01-07	1990-01-07 00:00:00	1990-01-28	1990-01-28 00:00:00	32020		\N	300901	0	444814009	40481087		0
86832	5169	378001	1967-10-07	1967-10-07 00:00:00	1967-12-06	1967-12-06 00:00:00	32020		\N	343732	0	62106007	378001		0
87043	5184	372328	1967-01-05	1967-01-05 00:00:00	1967-05-26	1967-05-26 00:00:00	32020		\N	344569	0	65363002	372328		0
76666	4544	260139	1955-09-17	1955-09-17 00:00:00	1955-09-24	1955-09-24 00:00:00	32020		\N	302709	0	10509002	260139		0
76798	4551	40481087	1979-07-23	1979-07-23 00:00:00	1979-08-06	1979-08-06 00:00:00	32020		\N	303288	0	444814009	40481087		0
76956	4560	4310024	2004-08-18	2004-08-18 00:00:00	\N	\N	32020		\N	303866	0	424802006	4310024		0
77057	4565	40481087	2004-11-09	2004-11-09 00:00:00	2004-11-16	2004-11-16 00:00:00	32020		\N	304167	0	444814009	40481087		0
87864	5228	4285898	1968-03-08	1968-03-08 00:00:00	\N	\N	32020		\N	347793	0	68496003	4285898		0
87990	5234	260139	1956-06-25	1956-06-25 00:00:00	1956-07-09	1956-07-09 00:00:00	32020		\N	348222	0	10509002	260139		0
77688	4603	260139	1931-02-14	1931-02-14 00:00:00	1931-02-21	1931-02-21 00:00:00	32020		\N	306626	0	10509002	260139		0
77790	4608	40481087	2018-08-26	2018-08-26 00:00:00	2018-09-09	2018-09-09 00:00:00	32020		\N	307046	0	444814009	40481087		0
88605	5267	4027663	1996-11-26	1996-11-26 00:00:00	\N	\N	32020		\N	350367	0	13200003	4027663		0
78148	4630	81893	1991-08-16	1991-08-16 00:00:00	\N	\N	32020		\N	308482	0	64766004	81893		0
78257	4633	4027663	1983-11-19	1983-11-19 00:00:00	\N	\N	32020		\N	308811	0	13200003	4027663		0
78434	4643	4278672	1978-12-07	1978-12-07 00:00:00	1979-02-05	1979-02-05 00:00:00	32020		\N	309626	0	65966004	4278672		0
78634	4656	4155034	1989-05-12	1989-05-12 00:00:00	1989-06-02	1989-06-02 00:00:00	32020		\N	310470	0	283371005	4155034		0
78768	4665	4027663	2009-08-08	2009-08-08 00:00:00	\N	\N	32020		\N	310894	0	13200003	4027663		0
89486	5322	81151	1985-11-26	1985-11-26 00:00:00	1985-12-17	1985-12-17 00:00:00	32020		\N	354090	0	44465007	81151		0
79122	4685	4134304	1975-01-22	1975-01-22 00:00:00	1975-04-22	1975-04-22 00:00:00	32020		\N	312153	0	263102004	4134304		0
89845	5343	4112343	2010-04-01	2010-04-01 00:00:00	2010-04-14	2010-04-14 00:00:00	32020		\N	355826	0	195662009	4112343		0
79531	4712	440448	1972-01-20	1972-01-20 00:00:00	\N	\N	32020		\N	313755	0	74400008	440448		0
79761	4724	40481087	1998-03-30	1998-03-30 00:00:00	1998-04-20	1998-04-20 00:00:00	32020		\N	314780	0	444814009	40481087		0
80032	4745	40481087	1983-03-30	1983-03-30 00:00:00	1983-04-06	1983-04-06 00:00:00	32020		\N	315892	0	444814009	40481087		0
69715	4124	4112343	1980-05-30	1980-05-30 00:00:00	1980-06-09	1980-06-09 00:00:00	32020		\N	274173	0	195662009	4112343		0
80795	4792	4283893	1956-03-24	1956-03-24 00:00:00	1956-05-12	1956-05-12 00:00:00	32020		\N	318861	0	36971009	4283893		0
81004	4805	260139	1996-03-30	1996-03-30 00:00:00	1996-04-13	1996-04-13 00:00:00	32020		\N	319672	0	10509002	260139		0
81436	4829	372328	1973-11-13	1973-11-13 00:00:00	1974-05-17	1974-05-17 00:00:00	32020		\N	321315	0	65363002	372328		0
81629	4843	4283893	1986-09-15	1986-09-15 00:00:00	1987-01-05	1987-01-05 00:00:00	32020		\N	322116	0	36971009	4283893		0
81673	4844	4084167	1975-03-12	1975-03-12 00:00:00	1975-03-12	1975-03-12 00:00:00	32020		\N	322281	0	241929008	4084167		0
81989	4860	40481087	2013-03-19	2013-03-19 00:00:00	2013-04-02	2013-04-02 00:00:00	32020		\N	323290	0	444814009	40481087		0
82036	4865	40481087	1975-03-01	1975-03-01 00:00:00	1975-03-08	1975-03-08 00:00:00	32020		\N	323489	0	444814009	40481087		0
82321	4883	40481087	1979-08-14	1979-08-14 00:00:00	1979-08-28	1979-08-28 00:00:00	32020		\N	324633	0	444814009	40481087		0
82441	4890	40481087	1928-10-29	1928-10-29 00:00:00	1928-11-19	1928-11-19 00:00:00	32020		\N	325080	0	444814009	40481087		0
82584	4899	4112343	1980-03-02	1980-03-02 00:00:00	1980-03-12	1980-03-12 00:00:00	32020		\N	325768	0	195662009	4112343		0
82682	4909	4218389	1977-06-05	1977-06-05 00:00:00	1977-07-10	1977-07-10 00:00:00	32020		\N	326276	0	39848009	4218389		0
82897	4923	4278672	1997-03-08	1997-03-08 00:00:00	1997-04-07	1997-04-07 00:00:00	32020		\N	327126	0	65966004	4278672		0
83464	4960	40481087	1943-05-05	1943-05-05 00:00:00	1943-05-12	1943-05-12 00:00:00	32020		\N	329657	0	444814009	40481087		0
83800	4977	4112343	1990-09-02	1990-09-02 00:00:00	1990-09-15	1990-09-15 00:00:00	32020		\N	331189	0	195662009	4112343		0
83966	4987	260139	2013-07-05	2013-07-05 00:00:00	2013-07-12	2013-07-12 00:00:00	32020		\N	331736	0	10509002	260139		0
84177	5000	4278672	2011-03-06	2011-03-06 00:00:00	2011-06-04	2011-06-04 00:00:00	32020		\N	332555	0	65966004	4278672		0
84482	5023	4112343	2010-01-20	2010-01-20 00:00:00	2010-01-27	2010-01-27 00:00:00	32020		\N	333778	0	195662009	4112343		0
84812	5044	4112343	1985-04-11	1985-04-11 00:00:00	1985-04-22	1985-04-22 00:00:00	32020		\N	335215	0	195662009	4112343		0
85069	5058	81151	2000-12-29	2000-12-29 00:00:00	2001-01-26	2001-01-26 00:00:00	32020		\N	336346	0	44465007	81151		0
85212	5068	40481087	1982-06-09	1982-06-09 00:00:00	1982-06-23	1982-06-23 00:00:00	32020		\N	336998	0	444814009	40481087		0
74851	4447	4218389	2012-10-04	2012-10-04 00:00:00	2012-10-25	2012-10-25 00:00:00	32020		\N	295723	0	39848009	4218389		0
74954	4451	4059173	2003-09-28	2003-09-28 00:00:00	2003-12-27	2003-12-27 00:00:00	32020		\N	296141	0	16114001	4059173		0
75075	4459	4112343	1964-01-21	1964-01-21 00:00:00	1964-01-30	1964-01-30 00:00:00	32020		\N	296710	0	195662009	4112343		0
75345	4474	4112343	2002-01-23	2002-01-23 00:00:00	2002-02-03	2002-02-03 00:00:00	32020		\N	297643	0	195662009	4112343		0
64875	3835	40481087	1978-01-20	1978-01-20 00:00:00	1978-02-03	1978-02-03 00:00:00	32020		\N	254678	0	444814009	40481087		0
75626	4487	260139	1990-10-03	1990-10-03 00:00:00	1990-10-10	1990-10-10 00:00:00	32020		\N	298716	0	10509002	260139		0
75736	4492	4134304	1975-01-25	1975-01-25 00:00:00	1975-04-25	1975-04-25 00:00:00	32020		\N	299091	0	263102004	4134304		0
75896	4501	260139	1979-11-25	1979-11-25 00:00:00	1979-12-09	1979-12-09 00:00:00	32020		\N	299704	0	10509002	260139		0
76157	4520	372328	1950-03-04	1950-03-04 00:00:00	1952-06-14	1952-06-14 00:00:00	32020		\N	300878	0	65363002	372328		0
86833	5169	4112343	1997-01-28	1997-01-28 00:00:00	1997-02-10	1997-02-10 00:00:00	32020		\N	343691	0	195662009	4112343		0
87044	5184	260139	2010-02-18	2010-02-18 00:00:00	2010-03-04	2010-03-04 00:00:00	32020		\N	344582	0	10509002	260139		0
76667	4544	4155034	1970-07-13	1970-07-13 00:00:00	1970-07-27	1970-07-27 00:00:00	32020		\N	302669	0	283371005	4155034		0
76957	4560	40481087	2018-01-22	2018-01-22 00:00:00	2018-01-29	2018-01-29 00:00:00	32020		\N	303815	0	444814009	40481087		0
77058	4565	40481087	1951-09-02	1951-09-02 00:00:00	1951-09-23	1951-09-23 00:00:00	32020		\N	304216	0	444814009	40481087		0
87865	5228	80180	1968-12-03	1968-12-03 00:00:00	\N	\N	32020		\N	347793	0	396275006	80180		0
87991	5234	40481087	1990-06-16	1990-06-16 00:00:00	1990-06-23	1990-06-23 00:00:00	32020		\N	348285	0	444814009	40481087		0
88147	5241	378001	1974-01-23	1974-01-23 00:00:00	1974-02-22	1974-02-22 00:00:00	32020		\N	348797	0	62106007	378001		0
77791	4608	257012	1977-04-29	1977-04-29 00:00:00	\N	\N	32020		\N	307081	0	40055000	257012		0
88606	5267	40481087	1976-04-21	1976-04-21 00:00:00	1976-05-05	1976-05-05 00:00:00	32020		\N	350354	0	444814009	40481087		0
78149	4630	4112343	1991-07-03	1991-07-03 00:00:00	1991-07-13	1991-07-13 00:00:00	32020		\N	308482	0	195662009	4112343		0
78258	4633	4310024	1991-02-15	1991-02-15 00:00:00	\N	\N	32020		\N	308814	0	424802006	4310024		0
78435	4643	260139	1937-10-04	1937-10-04 00:00:00	1937-10-11	1937-10-11 00:00:00	32020		\N	309536	0	10509002	260139		0
78635	4656	4059173	1966-11-09	1966-11-09 00:00:00	1967-01-08	1967-01-08 00:00:00	32020		\N	310469	0	16114001	4059173		0
78769	4665	381316	2009-01-31	2009-01-31 00:00:00	\N	\N	32020		\N	310894	0	230690007	381316		0
89487	5322	40481087	1967-03-14	1967-03-14 00:00:00	1967-03-21	1967-03-21 00:00:00	32020		\N	354211	0	444814009	40481087		0
79123	4685	4112343	1948-07-18	1948-07-18 00:00:00	1948-07-30	1948-07-30 00:00:00	32020		\N	312137	0	195662009	4112343		0
89846	5343	4084167	1999-05-11	1999-05-11 00:00:00	1999-05-11	1999-05-11 00:00:00	32020		\N	355929	0	241929008	4084167		0
79532	4712	4310024	2004-07-08	2004-07-08 00:00:00	\N	\N	32020		\N	313775	0	424802006	4310024		0
79762	4724	378419	2018-02-28	2018-02-28 00:00:00	\N	\N	32020		\N	314815	0	26929004	378419		0
80033	4745	80180	2016-10-08	2016-10-08 00:00:00	\N	\N	32020		\N	315898	0	396275006	80180		0
69716	4124	4109685	1977-02-28	1977-02-28 00:00:00	1977-03-14	1977-03-14 00:00:00	32020		\N	274209	0	284551006	4109685		0
80796	4792	195588	1979-03-14	1979-03-14 00:00:00	1979-04-22	1979-04-22 00:00:00	32020		\N	318863	0	38822007	195588		0
81005	4805	40481087	1963-12-25	1963-12-25 00:00:00	1964-01-15	1964-01-15 00:00:00	32020		\N	319734	0	444814009	40481087		0
81437	4829	260139	2007-10-07	2007-10-07 00:00:00	2007-10-14	2007-10-14 00:00:00	32020		\N	321312	0	10509002	260139		0
81630	4843	4027663	1987-02-14	1987-02-14 00:00:00	\N	\N	32020		\N	322117	0	13200003	4027663		0
81674	4844	40481087	2003-06-09	2003-06-09 00:00:00	2003-06-30	2003-06-30 00:00:00	32020		\N	322323	0	444814009	40481087		0
81990	4860	4112343	1997-10-05	1997-10-05 00:00:00	1997-10-16	1997-10-16 00:00:00	32020		\N	323345	0	195662009	4112343		0
82037	4865	80180	2013-06-09	2013-06-09 00:00:00	\N	\N	32020		\N	323540	0	396275006	80180		0
82322	4883	192671	1986-04-18	1986-04-18 00:00:00	\N	\N	32020		\N	324677	0	K92.2	35208414		0
82442	4890	40481087	1928-12-24	1928-12-24 00:00:00	1929-01-14	1929-01-14 00:00:00	32020		\N	325061	0	444814009	40481087		0
82585	4899	257012	1988-11-13	1988-11-13 00:00:00	\N	\N	32020		\N	325769	0	40055000	257012		0
82683	4909	4112343	2004-02-17	2004-02-17 00:00:00	2004-03-01	2004-03-01 00:00:00	32020		\N	326258	0	195662009	4112343		0
82898	4923	4112343	2007-02-14	2007-02-14 00:00:00	2007-02-23	2007-02-23 00:00:00	32020		\N	327130	0	195662009	4112343		0
83465	4960	40481087	1960-04-16	1960-04-16 00:00:00	1960-04-23	1960-04-23 00:00:00	32020		\N	329750	0	444814009	40481087		0
83801	4977	4112343	2004-11-06	2004-11-06 00:00:00	2004-11-19	2004-11-19 00:00:00	32020		\N	331126	0	195662009	4112343		0
83967	4988	260139	1988-03-28	1988-03-28 00:00:00	1988-04-11	1988-04-11 00:00:00	32020		\N	331824	0	10509002	260139		0
84178	5000	4112343	1941-04-13	1941-04-13 00:00:00	1941-04-26	1941-04-26 00:00:00	32020		\N	332586	0	195662009	4112343		0
84483	5023	4149245	1994-04-13	1994-04-13 00:00:00	1994-05-20	1994-05-20 00:00:00	32020		\N	333770	0	30832001	4149245		0
84813	5044	317576	2010-02-03	2010-02-03 00:00:00	\N	\N	32020		\N	335206	0	53741008	317576		0
85070	5058	4112343	2001-05-30	2001-05-30 00:00:00	2001-06-09	2001-06-09 00:00:00	32020		\N	336332	0	195662009	4112343		0
85213	5068	375671	1977-02-02	1977-02-02 00:00:00	1977-04-03	1977-04-03 00:00:00	32020		\N	336991	0	62564004	375671		0
74852	4447	4283893	1972-03-27	1972-03-27 00:00:00	1972-05-08	1972-05-08 00:00:00	32020		\N	295777	0	36971009	4283893		0
74955	4451	260139	1999-03-29	1999-03-29 00:00:00	1999-04-05	1999-04-05 00:00:00	32020		\N	296166	0	10509002	260139		0
75076	4459	40481087	1985-04-07	1985-04-07 00:00:00	1985-04-21	1985-04-21 00:00:00	32020		\N	296721	0	444814009	40481087		0
75346	4474	372328	1966-11-18	1966-11-18 00:00:00	1967-04-14	1967-04-14 00:00:00	32020		\N	297634	0	65363002	372328		0
64876	3835	40481087	1991-07-11	1991-07-11 00:00:00	1991-08-01	1991-08-01 00:00:00	32020		\N	254696	0	444814009	40481087		0
75627	4487	40481087	2002-06-09	2002-06-09 00:00:00	2002-06-16	2002-06-16 00:00:00	32020		\N	298718	0	444814009	40481087		0
75737	4492	260139	1959-06-09	1959-06-09 00:00:00	1959-06-23	1959-06-23 00:00:00	32020		\N	299083	0	10509002	260139		0
75897	4501	4112343	2011-01-13	2011-01-13 00:00:00	2011-01-21	2011-01-21 00:00:00	32020		\N	299679	0	195662009	4112343		0
76158	4520	78272	1938-10-13	1938-10-13 00:00:00	1938-11-03	1938-11-03 00:00:00	32020		\N	300891	0	70704007	78272		0
86834	5169	260139	1997-01-20	1997-01-20 00:00:00	1997-02-03	1997-02-03 00:00:00	32020		\N	343684	0	10509002	260139		0
87045	5184	40481087	1965-09-17	1965-09-17 00:00:00	1965-10-08	1965-10-08 00:00:00	32020		\N	344565	0	444814009	40481087		0
76668	4544	372328	1944-09-18	1944-09-18 00:00:00	1945-06-26	1945-06-26 00:00:00	32020		\N	302675	0	65363002	372328		0
76800	4551	4112343	1983-04-26	1983-04-26 00:00:00	1983-05-05	1983-05-05 00:00:00	32020		\N	303326	0	195662009	4112343		0
76958	4560	260139	2012-10-07	2012-10-07 00:00:00	2012-10-21	2012-10-21 00:00:00	32020		\N	303849	0	10509002	260139		0
77059	4565	260139	1991-08-27	1991-08-27 00:00:00	1991-09-03	1991-09-03 00:00:00	32020		\N	304164	0	10509002	260139		0
87866	5228	81151	1972-03-19	1972-03-19 00:00:00	1972-04-23	1972-04-23 00:00:00	32020		\N	347861	0	44465007	81151		0
87992	5234	4155034	1960-09-26	1960-09-26 00:00:00	1960-10-10	1960-10-10 00:00:00	32020		\N	348228	0	283371005	4155034		0
88148	5241	81151	1987-03-14	1987-03-14 00:00:00	1987-04-11	1987-04-11 00:00:00	32020		\N	348799	0	44465007	81151		0
77792	4608	4299128	2006-12-04	2006-12-04 00:00:00	2007-01-01	2007-01-01 00:00:00	32020		\N	307069	0	403192003	4299128		0
88607	5267	78272	1976-01-16	1976-01-16 00:00:00	1976-02-20	1976-02-20 00:00:00	32020		\N	350357	0	70704007	78272		0
78150	4630	40481087	1962-11-23	1962-11-23 00:00:00	1962-11-30	1962-11-30 00:00:00	32020		\N	308505	0	444814009	40481087		0
78259	4633	40481087	1994-02-27	1994-02-27 00:00:00	1994-03-20	1994-03-20 00:00:00	32020		\N	308794	0	444814009	40481087		0
78436	4643	40481087	1981-02-15	1981-02-15 00:00:00	1981-03-01	1981-03-01 00:00:00	32020		\N	309572	0	444814009	40481087		0
78636	4656	40481087	1961-01-04	1961-01-04 00:00:00	1961-01-18	1961-01-18 00:00:00	32020		\N	310479	0	444814009	40481087		0
78770	4665	260139	1988-09-09	1988-09-09 00:00:00	1988-09-16	1988-09-16 00:00:00	32020		\N	310900	0	10509002	260139		0
89488	5322	133834	1947-02-28	1947-02-28 00:00:00	1964-10-12	1964-10-12 00:00:00	32020		\N	354265	0	24079001	133834		0
79124	4685	28060	1953-10-01	1953-10-01 00:00:00	1953-10-09	1953-10-09 00:00:00	32020		\N	312101	0	43878008	28060		0
89847	5343	4084167	1984-04-26	1984-04-26 00:00:00	1984-04-26	1984-04-26 00:00:00	32020		\N	355926	0	241929008	4084167		0
79533	4712	81893	2004-09-06	2004-09-06 00:00:00	\N	\N	32020		\N	313775	0	64766004	81893		0
79763	4724	260139	1977-12-26	1977-12-26 00:00:00	1978-01-02	1978-01-02 00:00:00	32020		\N	314771	0	10509002	260139		0
80034	4745	81151	1995-10-03	1995-10-03 00:00:00	1995-10-31	1995-10-31 00:00:00	32020		\N	315992	0	44465007	81151		0
69717	4124	4112343	1988-12-10	1988-12-10 00:00:00	1988-12-18	1988-12-18 00:00:00	32020		\N	274193	0	195662009	4112343		0
80797	4792	28060	1951-06-17	1951-06-17 00:00:00	1951-06-25	1951-06-25 00:00:00	32020		\N	318831	0	43878008	28060		0
81006	4805	40481087	1981-03-20	1981-03-20 00:00:00	1981-04-10	1981-04-10 00:00:00	32020		\N	319685	0	444814009	40481087		0
81438	4829	4112343	2019-04-07	2019-04-07 00:00:00	2019-04-19	2019-04-19 00:00:00	32020		\N	321346	0	195662009	4112343		0
81631	4843	30753	1996-11-03	1996-11-03 00:00:00	\N	\N	32020		\N	322168	0	16761005	30753		0
81696	4847	4218389	1969-11-06	1969-11-06 00:00:00	1969-11-27	1969-11-27 00:00:00	32020		\N	322427	0	39848009	4218389		0
81991	4860	372328	1979-10-24	1979-10-24 00:00:00	1979-12-07	1979-12-07 00:00:00	32020		\N	323298	0	65363002	372328		0
82038	4865	4266809	2013-06-09	2013-06-09 00:00:00	\N	\N	32020		\N	323540	0	397881000	4266809		0
82323	4883	4112343	1955-03-19	1955-03-19 00:00:00	1955-03-30	1955-03-30 00:00:00	32020		\N	324701	0	195662009	4112343		0
82443	4890	40481087	1956-11-25	1956-11-25 00:00:00	1956-12-16	1956-12-16 00:00:00	32020		\N	325197	0	444814009	40481087		0
82586	4899	4112343	1933-01-03	1933-01-03 00:00:00	1933-01-13	1933-01-13 00:00:00	32020		\N	325766	0	195662009	4112343		0
82684	4909	40481087	2008-02-14	2008-02-14 00:00:00	2008-02-28	2008-02-28 00:00:00	32020		\N	326264	0	444814009	40481087		0
82899	4923	381316	2018-06-19	2018-06-19 00:00:00	\N	\N	32020		\N	327147	0	230690007	381316		0
83466	4960	4112343	1968-08-08	1968-08-08 00:00:00	1968-08-15	1968-08-15 00:00:00	32020		\N	329752	0	195662009	4112343		0
83802	4977	4112343	1999-08-30	1999-08-30 00:00:00	1999-09-07	1999-09-07 00:00:00	32020		\N	331191	0	195662009	4112343		0
83968	4988	40481087	2000-02-26	2000-02-26 00:00:00	2000-03-04	2000-03-04 00:00:00	32020		\N	331826	0	444814009	40481087		0
84179	5000	30753	1973-08-04	1973-08-04 00:00:00	\N	\N	32020		\N	332564	0	16761005	30753		0
84484	5023	4051466	1974-08-13	1974-08-13 00:00:00	1991-11-13	1991-11-13 00:00:00	32020		\N	333749	0	233678006	4051466		0
84814	5044	260139	1986-08-06	1986-08-06 00:00:00	1986-08-20	1986-08-20 00:00:00	32020		\N	335216	0	10509002	260139		0
85071	5058	378001	1945-08-29	1945-08-29 00:00:00	1945-10-28	1945-10-28 00:00:00	32020		\N	336343	0	62106007	378001		0
85214	5068	372328	1936-09-10	1936-09-10 00:00:00	1937-06-05	1937-06-05 00:00:00	32020		\N	336925	0	65363002	372328		0
74853	4447	257012	1972-04-24	1972-04-24 00:00:00	\N	\N	32020		\N	295753	0	40055000	257012		0
74956	4451	260139	2001-07-08	2001-07-08 00:00:00	2001-07-15	2001-07-15 00:00:00	32020		\N	296167	0	10509002	260139		0
75077	4459	40481087	2002-10-11	2002-10-11 00:00:00	2002-10-31	2002-10-31 00:00:00	32020		\N	296724	0	444814009	40481087		0
75347	4474	440086	1971-06-05	1971-06-05 00:00:00	1981-06-12	1981-06-12 00:00:00	32020		\N	297697	0	192127007	440086		0
64877	3835	40481087	1988-04-06	1988-04-06 00:00:00	1988-04-20	1988-04-20 00:00:00	32020		\N	254643	0	444814009	40481087		0
75628	4487	4112343	2005-01-20	2005-01-20 00:00:00	2005-01-28	2005-01-28 00:00:00	32020		\N	298758	0	195662009	4112343		0
75738	4492	4152936	1996-12-21	1996-12-21 00:00:00	1997-01-04	1997-01-04 00:00:00	32020		\N	299095	0	283385000	4152936		0
75898	4501	28060	1986-05-09	1986-05-09 00:00:00	1986-05-22	1986-05-22 00:00:00	32020		\N	299710	0	43878008	28060		0
76159	4520	40481087	1957-09-10	1957-09-10 00:00:00	1957-09-17	1957-09-17 00:00:00	32020		\N	300899	0	444814009	40481087		0
86835	5169	4112343	2005-07-14	2005-07-14 00:00:00	2005-07-24	2005-07-24 00:00:00	32020		\N	343719	0	195662009	4112343		0
87046	5184	40481087	2001-11-05	2001-11-05 00:00:00	2001-11-19	2001-11-19 00:00:00	32020		\N	344547	0	444814009	40481087		0
76681	4546	260139	1999-01-16	1999-01-16 00:00:00	1999-01-30	1999-01-30 00:00:00	32020		\N	302794	0	10509002	260139		0
76801	4551	372328	1977-02-25	1977-02-25 00:00:00	1977-05-04	1977-05-04 00:00:00	32020		\N	303290	0	65363002	372328		0
76959	4560	4027663	1994-10-25	1994-10-25 00:00:00	\N	\N	32020		\N	303862	0	13200003	4027663		0
77060	4565	4294548	1966-06-03	1966-06-03 00:00:00	1966-08-19	1966-08-19 00:00:00	32020		\N	304235	0	75498004	4294548		0
87867	5228	260139	1971-03-04	1971-03-04 00:00:00	1971-03-11	1971-03-11 00:00:00	32020		\N	347853	0	10509002	260139		0
87993	5234	40481087	1990-07-29	1990-07-29 00:00:00	1990-08-19	1990-08-19 00:00:00	32020		\N	348269	0	444814009	40481087		0
88149	5241	372328	1962-04-26	1962-04-26 00:00:00	1962-07-03	1962-07-03 00:00:00	32020		\N	348772	0	65363002	372328		0
77793	4608	4134304	2010-07-14	2010-07-14 00:00:00	2010-10-12	2010-10-12 00:00:00	32020		\N	307071	0	263102004	4134304		0
88608	5267	40481087	2001-11-25	2001-11-25 00:00:00	2001-12-16	2001-12-16 00:00:00	32020		\N	350398	0	444814009	40481087		0
78151	4630	260139	1995-03-01	1995-03-01 00:00:00	1995-03-15	1995-03-15 00:00:00	32020		\N	308483	0	10509002	260139		0
78260	4633	40481087	2015-08-06	2015-08-06 00:00:00	2015-08-13	2015-08-13 00:00:00	32020		\N	308795	0	444814009	40481087		0
78437	4643	4283893	1955-12-19	1955-12-19 00:00:00	1956-01-16	1956-01-16 00:00:00	32020		\N	309611	0	36971009	4283893		0
78637	4656	80180	1993-06-12	1993-06-12 00:00:00	\N	\N	32020		\N	310456	0	396275006	80180		0
78771	4665	4112343	1982-08-11	1982-08-11 00:00:00	1982-08-23	1982-08-23 00:00:00	32020		\N	310898	0	195662009	4112343		0
89489	5322	80502	2007-05-09	2007-05-09 00:00:00	\N	\N	32020		\N	354256	0	64859006	80502		0
79125	4685	40481087	1973-11-15	1973-11-15 00:00:00	1973-12-06	1973-12-06 00:00:00	32020		\N	312166	0	444814009	40481087		0
89848	5343	260139	1985-01-23	1985-01-23 00:00:00	1985-01-30	1985-01-30 00:00:00	32020		\N	355858	0	10509002	260139		0
79534	4712	260139	2007-05-25	2007-05-25 00:00:00	2007-06-01	2007-06-01 00:00:00	32020		\N	313787	0	10509002	260139		0
79764	4724	40481087	1971-05-17	1971-05-17 00:00:00	1971-06-07	1971-06-07 00:00:00	32020		\N	314681	0	444814009	40481087		0
80035	4745	40481087	1996-09-03	1996-09-03 00:00:00	1996-09-10	1996-09-10 00:00:00	32020		\N	316001	0	444814009	40481087		0
69718	4124	40481087	1983-11-23	1983-11-23 00:00:00	1983-12-14	1983-12-14 00:00:00	32020		\N	274174	0	444814009	40481087		0
80798	4792	4112343	1978-05-07	1978-05-07 00:00:00	1978-05-17	1978-05-17 00:00:00	32020		\N	318877	0	195662009	4112343		0
81007	4805	40481087	1986-01-22	1986-01-22 00:00:00	1986-02-05	1986-02-05 00:00:00	32020		\N	319680	0	444814009	40481087		0
81439	4829	372328	1972-11-04	1972-11-04 00:00:00	1973-02-16	1973-02-16 00:00:00	32020		\N	321358	0	65363002	372328		0
81632	4843	4218389	1980-05-16	1980-05-16 00:00:00	1980-06-13	1980-06-13 00:00:00	32020		\N	322108	0	39848009	4218389		0
81697	4847	4294548	1991-08-31	1991-08-31 00:00:00	1991-09-28	1991-09-28 00:00:00	32020		\N	322482	0	75498004	4294548		0
81992	4860	40481087	2017-10-16	2017-10-16 00:00:00	2017-10-30	2017-10-30 00:00:00	32020		\N	323330	0	444814009	40481087		0
82039	4865	4310024	2011-08-19	2011-08-19 00:00:00	\N	\N	32020		\N	323540	0	424802006	4310024		0
82324	4883	381316	1967-04-07	1967-04-07 00:00:00	\N	\N	32020		\N	324714	0	230690007	381316		0
82444	4890	40481087	1980-07-13	1980-07-13 00:00:00	1980-07-27	1980-07-27 00:00:00	32020		\N	325202	0	444814009	40481087		0
82587	4899	28060	1934-10-07	1934-10-07 00:00:00	1934-10-16	1934-10-16 00:00:00	32020		\N	325775	0	43878008	28060		0
82685	4909	81151	1993-01-08	1993-01-08 00:00:00	1993-02-05	1993-02-05 00:00:00	32020		\N	326278	0	44465007	81151		0
82900	4923	372328	1970-01-01	1970-01-01 00:00:00	1970-03-24	1970-03-24 00:00:00	32020		\N	327131	0	65363002	372328		0
83467	4960	4112343	1916-10-08	1916-10-08 00:00:00	1916-10-21	1916-10-21 00:00:00	32020		\N	329734	0	195662009	4112343		0
83803	4977	4112343	1999-12-06	1999-12-06 00:00:00	1999-12-17	1999-12-17 00:00:00	32020		\N	331192	0	195662009	4112343		0
83969	4988	40481087	1964-12-09	1964-12-09 00:00:00	1964-12-23	1964-12-23 00:00:00	32020		\N	331830	0	444814009	40481087		0
84180	5000	4266809	1973-12-02	1973-12-02 00:00:00	\N	\N	32020		\N	332564	0	397881000	4266809		0
84485	5023	40481087	2011-11-05	2011-11-05 00:00:00	2011-11-26	2011-11-26 00:00:00	32020		\N	333736	0	444814009	40481087		0
84815	5044	40481087	2013-06-25	2013-06-25 00:00:00	2013-07-09	2013-07-09 00:00:00	32020		\N	335211	0	444814009	40481087		0
85072	5058	4296204	1943-08-05	1943-08-05 00:00:00	1943-09-09	1943-09-09 00:00:00	32020		\N	336342	0	403190006	4296204		0
85215	5068	4112343	1946-12-15	1946-12-15 00:00:00	1946-12-24	1946-12-24 00:00:00	32020		\N	337007	0	195662009	4112343		0
85384	5078	4027663	1937-04-24	1937-04-24 00:00:00	\N	\N	32020		\N	337536	0	13200003	4027663		0
74854	4447	40481087	1979-04-07	1979-04-07 00:00:00	1979-04-14	1979-04-14 00:00:00	32020		\N	295757	0	444814009	40481087		0
74957	4451	40481087	1992-01-26	1992-01-26 00:00:00	1992-02-02	1992-02-02 00:00:00	32020		\N	296123	0	444814009	40481087		0
75078	4459	40481087	1999-08-15	1999-08-15 00:00:00	1999-08-29	1999-08-29 00:00:00	32020		\N	296723	0	444814009	40481087		0
75348	4474	4146173	1996-10-16	1996-10-16 00:00:00	1996-11-15	1996-11-15 00:00:00	32020		\N	297642	0	307731004	4146173		0
64878	3835	40481087	1984-09-05	1984-09-05 00:00:00	1984-09-19	1984-09-19 00:00:00	32020		\N	254679	0	444814009	40481087		0
75629	4487	260139	1980-09-01	1980-09-01 00:00:00	1980-09-08	1980-09-08 00:00:00	32020		\N	298700	0	10509002	260139		0
75739	4492	378001	1984-12-24	1984-12-24 00:00:00	1985-01-23	1985-01-23 00:00:00	32020		\N	299093	0	62106007	378001		0
75899	4501	40481087	2018-10-07	2018-10-07 00:00:00	2018-10-28	2018-10-28 00:00:00	32020		\N	299714	0	444814009	40481087		0
76160	4520	378001	1949-06-22	1949-06-22 00:00:00	1949-07-22	1949-07-22 00:00:00	32020		\N	300893	0	62106007	378001		0
86836	5169	4112343	1969-09-09	1969-09-09 00:00:00	1969-09-19	1969-09-19 00:00:00	32020		\N	343682	0	195662009	4112343		0
87047	5184	378001	1985-08-03	1985-08-03 00:00:00	1985-10-02	1985-10-02 00:00:00	32020		\N	344593	0	62106007	378001		0
76682	4546	260139	1994-04-03	1994-04-03 00:00:00	1994-04-10	1994-04-10 00:00:00	32020		\N	302781	0	10509002	260139		0
76802	4551	192671	2015-12-30	2015-12-30 00:00:00	\N	\N	32020		\N	303328	0	K92.2	35208414		0
76960	4560	40481087	1982-11-09	1982-11-09 00:00:00	1982-11-16	1982-11-16 00:00:00	32020		\N	303813	0	444814009	40481087		0
77061	4565	260139	1977-05-23	1977-05-23 00:00:00	1977-05-30	1977-05-30 00:00:00	32020		\N	304236	0	10509002	260139		0
87868	5228	40481087	1942-02-20	1942-02-20 00:00:00	1942-03-13	1942-03-13 00:00:00	32020		\N	347773	0	444814009	40481087		0
87994	5234	40481087	1958-12-28	1958-12-28 00:00:00	1959-01-18	1959-01-18 00:00:00	32020		\N	348223	0	444814009	40481087		0
88150	5241	40481087	1994-06-28	1994-06-28 00:00:00	1994-07-12	1994-07-12 00:00:00	32020		\N	348757	0	444814009	40481087		0
77794	4608	4112343	1967-10-13	1967-10-13 00:00:00	1967-10-25	1967-10-25 00:00:00	32020		\N	306991	0	195662009	4112343		0
88609	5267	40481087	1997-07-20	1997-07-20 00:00:00	1997-08-10	1997-08-10 00:00:00	32020		\N	350473	0	444814009	40481087		0
78152	4630	40481087	1976-09-25	1976-09-25 00:00:00	1976-10-16	1976-10-16 00:00:00	32020		\N	308475	0	444814009	40481087		0
78261	4634	40481087	2009-06-06	2009-06-06 00:00:00	2009-06-27	2009-06-27 00:00:00	32020		\N	308824	0	444814009	40481087		0
78438	4643	40481087	1927-07-07	1927-07-07 00:00:00	1927-07-28	1927-07-28 00:00:00	32020		\N	309607	0	444814009	40481087		0
78638	4656	40481087	1993-02-19	1993-02-19 00:00:00	1993-03-05	1993-03-05 00:00:00	32020		\N	310456	0	444814009	40481087		0
78772	4666	4156265	2015-08-22	2015-08-22 00:00:00	2015-09-05	2015-09-05 00:00:00	32020		\N	310945	0	370247008	4156265		0
89490	5322	4051466	1951-01-28	1951-01-28 00:00:00	1966-05-12	1966-05-12 00:00:00	32020		\N	354266	0	233678006	4051466		0
79126	4685	4112343	1961-02-17	1961-02-17 00:00:00	1961-02-25	1961-02-25 00:00:00	32020		\N	312105	0	195662009	4112343		0
89849	5343	40486433	1986-01-08	1986-01-08 00:00:00	\N	\N	32020		\N	355860	0	446096008	40486433		0
79535	4712	313217	2017-03-17	2017-03-17 00:00:00	\N	\N	32020		\N	313784	0	49436004	313217		0
79765	4724	133834	1942-03-10	1942-03-10 00:00:00	\N	\N	32020		\N	314744	0	24079001	133834		0
80036	4745	40481087	2009-08-12	2009-08-12 00:00:00	2009-09-02	2009-09-02 00:00:00	32020		\N	315972	0	444814009	40481087		0
69719	4124	4146173	1991-03-15	1991-03-15 00:00:00	1991-04-14	1991-04-14 00:00:00	32020		\N	274176	0	307731004	4146173		0
80799	4792	4152936	2017-04-03	2017-04-03 00:00:00	2017-04-24	2017-04-24 00:00:00	32020		\N	318829	0	283385000	4152936		0
81008	4805	257012	1972-06-06	1972-06-06 00:00:00	\N	\N	32020		\N	319670	0	40055000	257012		0
81440	4829	40481087	2016-07-21	2016-07-21 00:00:00	2016-08-11	2016-08-11 00:00:00	32020		\N	321314	0	444814009	40481087		0
81633	4843	260139	1963-03-18	1963-03-18 00:00:00	1963-03-25	1963-03-25 00:00:00	32020		\N	322148	0	10509002	260139		0
81698	4847	4294548	2011-09-01	2011-09-01 00:00:00	2011-09-15	2011-09-15 00:00:00	32020		\N	322444	0	75498004	4294548		0
81993	4861	81893	1988-02-18	1988-02-18 00:00:00	\N	\N	32020		\N	323427	0	64766004	81893		0
82040	4865	40481087	1985-09-15	1985-09-15 00:00:00	1985-09-22	1985-09-22 00:00:00	32020		\N	323496	0	444814009	40481087		0
82325	4883	260139	2006-03-11	2006-03-11 00:00:00	2006-03-18	2006-03-18 00:00:00	32020		\N	324690	0	10509002	260139		0
82445	4890	4112343	1923-03-05	1923-03-05 00:00:00	1923-03-14	1923-03-14 00:00:00	32020		\N	325219	0	195662009	4112343		0
82623	4905	4155034	2018-09-20	2018-09-20 00:00:00	2018-10-04	2018-10-04 00:00:00	32020		\N	326059	0	283371005	4155034		0
82686	4909	4112343	2014-12-05	2014-12-05 00:00:00	2014-12-14	2014-12-14 00:00:00	32020		\N	326274	0	195662009	4112343		0
82901	4923	81151	1984-07-16	1984-07-16 00:00:00	1984-08-13	1984-08-13 00:00:00	32020		\N	327125	0	44465007	81151		0
83468	4960	260139	1930-09-03	1930-09-03 00:00:00	1930-09-17	1930-09-17 00:00:00	32020		\N	329655	0	10509002	260139		0
83804	4977	260139	1982-06-02	1982-06-02 00:00:00	1982-06-09	1982-06-09 00:00:00	32020		\N	331110	0	10509002	260139		0
83970	4988	40481087	1957-11-02	1957-11-02 00:00:00	1957-11-09	1957-11-09 00:00:00	32020		\N	331797	0	444814009	40481087		0
84181	5000	80180	1973-12-02	1973-12-02 00:00:00	\N	\N	32020		\N	332564	0	396275006	80180		0
84486	5023	40481087	1984-05-14	1984-05-14 00:00:00	1984-05-28	1984-05-28 00:00:00	32020		\N	333741	0	444814009	40481087		0
84816	5045	260139	1989-12-29	1989-12-29 00:00:00	1990-01-12	1990-01-12 00:00:00	32020		\N	335286	0	10509002	260139		0
85079	5060	80180	2009-10-09	2009-10-09 00:00:00	\N	\N	32020		\N	336435	0	396275006	80180		0
85216	5068	4112343	1934-09-12	1934-09-12 00:00:00	1934-09-21	1934-09-21 00:00:00	32020		\N	336913	0	195662009	4112343		0
74855	4447	260139	1988-05-10	1988-05-10 00:00:00	1988-05-24	1988-05-24 00:00:00	32020		\N	295783	0	10509002	260139		0
74958	4451	80180	1992-08-20	1992-08-20 00:00:00	\N	\N	32020		\N	296123	0	396275006	80180		0
75079	4459	81151	1982-05-20	1982-05-20 00:00:00	1982-06-10	1982-06-10 00:00:00	32020		\N	296733	0	44465007	81151		0
75349	4474	40481087	2013-03-18	2013-03-18 00:00:00	2013-03-25	2013-03-25 00:00:00	32020		\N	297679	0	444814009	40481087		0
64879	3835	40481087	2015-10-30	2015-10-30 00:00:00	2015-11-13	2015-11-13 00:00:00	32020		\N	254680	0	444814009	40481087		0
75630	4487	40481087	1958-02-25	1958-02-25 00:00:00	1958-03-18	1958-03-18 00:00:00	32020		\N	298711	0	444814009	40481087		0
75740	4492	4237458	1964-03-23	1964-03-23 00:00:00	1964-05-22	1964-05-22 00:00:00	32020		\N	299048	0	58150001	4237458		0
75900	4501	4112343	1973-11-29	1973-11-29 00:00:00	1973-12-09	1973-12-09 00:00:00	32020		\N	299677	0	195662009	4112343		0
76161	4520	4218389	1987-03-26	1987-03-26 00:00:00	1987-04-23	1987-04-23 00:00:00	32020		\N	300895	0	39848009	4218389		0
86837	5170	40481087	1985-04-04	1985-04-04 00:00:00	1985-04-25	1985-04-25 00:00:00	32020		\N	343752	0	444814009	40481087		0
87048	5184	4112343	2003-12-29	2003-12-29 00:00:00	2004-01-06	2004-01-06 00:00:00	32020		\N	344549	0	195662009	4112343		0
76683	4546	4283893	1983-05-17	1983-05-17 00:00:00	1983-05-31	1983-05-31 00:00:00	32020		\N	302815	0	36971009	4283893		0
76803	4551	260139	1981-09-03	1981-09-03 00:00:00	1981-09-17	1981-09-17 00:00:00	32020		\N	303340	0	10509002	260139		0
76961	4560	40481087	2011-08-11	2011-08-11 00:00:00	2011-08-18	2011-08-18 00:00:00	32020		\N	303814	0	444814009	40481087		0
77062	4565	260139	1972-02-18	1972-02-18 00:00:00	1972-03-03	1972-03-03 00:00:00	32020		\N	304217	0	10509002	260139		0
87869	5228	4113008	2007-11-16	2007-11-16 00:00:00	2007-11-30	2007-11-30 00:00:00	32020		\N	347862	0	284549007	4113008		0
87995	5234	440448	1977-08-24	1977-08-24 00:00:00	\N	\N	32020		\N	348212	0	74400008	440448		0
88151	5241	260139	2001-04-02	2001-04-02 00:00:00	2001-04-09	2001-04-09 00:00:00	32020		\N	348720	0	10509002	260139		0
77795	4608	40481087	1981-10-12	1981-10-12 00:00:00	1981-10-26	1981-10-26 00:00:00	32020		\N	307075	0	444814009	40481087		0
88610	5267	40481087	1972-11-08	1972-11-08 00:00:00	1972-11-29	1972-11-29 00:00:00	32020		\N	350353	0	444814009	40481087		0
78153	4630	40481087	2012-12-16	2012-12-16 00:00:00	2012-12-23	2012-12-23 00:00:00	32020		\N	308486	0	444814009	40481087		0
78262	4634	40481087	2015-08-01	2015-08-01 00:00:00	2015-08-22	2015-08-22 00:00:00	32020		\N	308882	0	444814009	40481087		0
78439	4643	40481087	1941-11-20	1941-11-20 00:00:00	1941-12-11	1941-12-11 00:00:00	32020		\N	309608	0	444814009	40481087		0
78639	4656	4112343	1993-06-24	1993-06-24 00:00:00	1993-07-05	1993-07-05 00:00:00	32020		\N	310457	0	195662009	4112343		0
78773	4666	372328	1978-04-03	1978-04-03 00:00:00	1978-06-19	1978-06-19 00:00:00	32020		\N	310920	0	65363002	372328		0
89491	5322	4294548	1974-01-05	1974-01-05 00:00:00	1974-02-02	1974-02-02 00:00:00	32020		\N	354120	0	75498004	4294548		0
79127	4685	4218389	1941-09-23	1941-09-23 00:00:00	1941-10-28	1941-10-28 00:00:00	32020		\N	312150	0	39848009	4218389		0
89850	5343	260139	1998-01-04	1998-01-04 00:00:00	1998-01-11	1998-01-11 00:00:00	32020		\N	355911	0	10509002	260139		0
79536	4712	260139	2013-02-28	2013-02-28 00:00:00	2013-03-07	2013-03-07 00:00:00	32020		\N	313762	0	10509002	260139		0
79766	4724	40481087	1963-04-01	1963-04-01 00:00:00	1963-04-22	1963-04-22 00:00:00	32020		\N	314742	0	444814009	40481087		0
80037	4745	4048171	1978-04-08	1978-04-08 00:00:00	\N	\N	32020		\N	315961	0	232353008	4048171		0
69720	4124	81151	1985-08-29	1985-08-29 00:00:00	1985-09-12	1985-09-12 00:00:00	32020		\N	274210	0	44465007	81151		0
80800	4792	4294548	1953-08-10	1953-08-10 00:00:00	1953-08-31	1953-08-31 00:00:00	32020		\N	318850	0	75498004	4294548		0
81441	4829	80180	2012-06-17	2012-06-17 00:00:00	\N	\N	32020		\N	321321	0	396275006	80180		0
81634	4843	40481087	1967-03-01	1967-03-01 00:00:00	1967-03-08	1967-03-08 00:00:00	32020		\N	322158	0	444814009	40481087		0
81699	4847	40481087	1971-10-17	1971-10-17 00:00:00	1971-11-07	1971-11-07 00:00:00	32020		\N	322481	0	444814009	40481087		0
81994	4861	4278672	1994-01-22	1994-01-22 00:00:00	1994-02-21	1994-02-21 00:00:00	32020		\N	323378	0	65966004	4278672		0
82041	4865	28060	1991-10-26	1991-10-26 00:00:00	1991-11-02	1991-11-02 00:00:00	32020		\N	323545	0	43878008	28060		0
82326	4883	28060	1954-01-12	1954-01-12 00:00:00	1954-01-21	1954-01-21 00:00:00	32020		\N	324683	0	43878008	28060		0
82446	4890	260139	1980-05-26	1980-05-26 00:00:00	1980-06-09	1980-06-09 00:00:00	32020		\N	325201	0	10509002	260139		0
82624	4905	4112343	1980-06-19	1980-06-19 00:00:00	1980-07-01	1980-07-01 00:00:00	32020		\N	326032	0	195662009	4112343		0
82687	4909	40481087	1991-09-25	1991-09-25 00:00:00	1991-10-09	1991-10-09 00:00:00	32020		\N	326255	0	444814009	40481087		0
82902	4923	192671	2000-06-14	2000-06-14 00:00:00	\N	\N	32020		\N	327123	0	K92.2	35208414		0
83469	4960	4112343	1965-07-09	1965-07-09 00:00:00	1965-07-21	1965-07-21 00:00:00	32020		\N	329674	0	195662009	4112343		0
83805	4977	4112343	2000-03-18	2000-03-18 00:00:00	2000-03-30	2000-03-30 00:00:00	32020		\N	331193	0	195662009	4112343		0
83971	4988	40481087	1998-10-05	1998-10-05 00:00:00	1998-10-26	1998-10-26 00:00:00	32020		\N	331832	0	444814009	40481087		0
84182	5000	260139	1992-11-06	1992-11-06 00:00:00	1992-11-13	1992-11-13 00:00:00	32020		\N	332527	0	10509002	260139		0
84487	5023	78272	2017-11-15	2017-11-15 00:00:00	2017-12-13	2017-12-13 00:00:00	32020		\N	333776	0	70704007	78272		0
84817	5045	40481087	1988-10-05	1988-10-05 00:00:00	1988-10-26	1988-10-26 00:00:00	32020		\N	335285	0	444814009	40481087		0
85080	5060	260139	2004-09-07	2004-09-07 00:00:00	2004-09-21	2004-09-21 00:00:00	32020		\N	336421	0	10509002	260139		0
85217	5068	4112343	1937-11-05	1937-11-05 00:00:00	1937-11-12	1937-11-12 00:00:00	32020		\N	336914	0	195662009	4112343		0
74856	4447	80180	1990-07-27	1990-07-27 00:00:00	\N	\N	32020		\N	295788	0	396275006	80180		0
74959	4451	440086	1962-05-10	1962-05-10 00:00:00	1964-03-05	1964-03-05 00:00:00	32020		\N	296179	0	192127007	440086		0
75080	4459	40481087	2002-02-20	2002-02-20 00:00:00	2002-03-06	2002-03-06 00:00:00	32020		\N	296730	0	444814009	40481087		0
75350	4474	4283893	2007-05-16	2007-05-16 00:00:00	2007-07-11	2007-07-11 00:00:00	32020		\N	297655	0	36971009	4283893		0
64880	3835	4112343	1976-11-30	1976-11-30 00:00:00	1976-12-12	1976-12-12 00:00:00	32020		\N	254642	0	195662009	4112343		0
75631	4487	40481087	2005-09-03	2005-09-03 00:00:00	2005-09-17	2005-09-17 00:00:00	32020		\N	298735	0	444814009	40481087		0
75741	4492	4112343	1993-05-11	1993-05-11 00:00:00	1993-05-24	1993-05-24 00:00:00	32020		\N	299050	0	195662009	4112343		0
75901	4501	134438	2002-11-30	2002-11-30 00:00:00	2003-07-28	2003-07-28 00:00:00	32020		\N	299713	0	40275004	134438		0
76162	4520	28060	1940-04-04	1940-04-04 00:00:00	1940-04-12	1940-04-12 00:00:00	32020		\N	300944	0	43878008	28060		0
86838	5170	4155034	1990-03-26	1990-03-26 00:00:00	1990-04-16	1990-04-16 00:00:00	32020		\N	343737	0	283371005	4155034		0
87049	5185	372328	1938-06-30	1938-06-30 00:00:00	1938-09-19	1938-09-19 00:00:00	32020		\N	344689	0	65363002	372328		0
76684	4546	80180	2010-10-31	2010-10-31 00:00:00	\N	\N	32020		\N	302827	0	396275006	80180		0
76804	4551	40481087	1988-12-23	1988-12-23 00:00:00	1988-12-30	1988-12-30 00:00:00	32020		\N	303329	0	444814009	40481087		0
76962	4560	4112343	1999-08-30	1999-08-30 00:00:00	1999-09-11	1999-09-11 00:00:00	32020		\N	303820	0	195662009	4112343		0
77063	4565	40481087	1945-09-11	1945-09-11 00:00:00	1945-09-25	1945-09-25 00:00:00	32020		\N	304240	0	444814009	40481087		0
87870	5228	260139	1958-08-10	1958-08-10 00:00:00	1958-08-17	1958-08-17 00:00:00	32020		\N	347775	0	10509002	260139		0
87997	5234	378419	2006-07-19	2006-07-19 00:00:00	\N	\N	32020		\N	348277	0	26929004	378419		0
88152	5241	28060	1996-01-20	1996-01-20 00:00:00	1996-02-01	1996-02-01 00:00:00	32020		\N	348719	0	43878008	28060		0
77796	4608	4084167	1967-02-11	1967-02-11 00:00:00	1967-02-11	1967-02-11 00:00:00	32020		\N	307065	0	241929008	4084167		0
88611	5268	40481087	2007-11-22	2007-11-22 00:00:00	2007-12-13	2007-12-13 00:00:00	32020		\N	350479	0	444814009	40481087		0
78154	4630	40481087	2015-06-17	2015-06-17 00:00:00	2015-07-08	2015-07-08 00:00:00	32020		\N	308477	0	444814009	40481087		0
78263	4634	81151	1996-04-27	1996-04-27 00:00:00	1996-05-25	1996-05-25 00:00:00	32020		\N	308859	0	44465007	81151		0
78440	4643	4112343	1958-01-24	1958-01-24 00:00:00	1958-02-03	1958-02-03 00:00:00	32020		\N	309538	0	195662009	4112343		0
78640	4656	40481087	2008-04-20	2008-04-20 00:00:00	2008-04-27	2008-04-27 00:00:00	32020		\N	310452	0	444814009	40481087		0
78774	4666	260139	2003-06-16	2003-06-16 00:00:00	2003-06-23	2003-06-23 00:00:00	32020		\N	310918	0	10509002	260139		0
89492	5322	372328	1949-01-23	1949-01-23 00:00:00	1949-06-29	1949-06-29 00:00:00	32020		\N	354158	0	65363002	372328		0
79128	4685	40481087	1947-05-30	1947-05-30 00:00:00	1947-06-20	1947-06-20 00:00:00	32020		\N	312155	0	444814009	40481087		0
89851	5343	40481087	1992-08-04	1992-08-04 00:00:00	1992-08-11	1992-08-11 00:00:00	32020		\N	355831	0	444814009	40481087		0
79537	4712	40481087	2013-05-15	2013-05-15 00:00:00	2013-05-22	2013-05-22 00:00:00	32020		\N	313789	0	444814009	40481087		0
79767	4724	81151	1952-12-05	1952-12-05 00:00:00	1953-01-09	1953-01-09 00:00:00	32020		\N	314685	0	44465007	81151		0
80038	4745	40481087	1985-11-22	1985-11-22 00:00:00	1985-12-06	1985-12-06 00:00:00	32020		\N	315941	0	444814009	40481087		0
80179	4753	4059173	2006-02-25	2006-02-25 00:00:00	2006-05-26	2006-05-26 00:00:00	32020		\N	316518	0	16114001	4059173		0
80801	4792	4112343	1978-11-17	1978-11-17 00:00:00	1978-11-24	1978-11-24 00:00:00	32020		\N	318840	0	195662009	4112343		0
81442	4829	260139	1983-09-10	1983-09-10 00:00:00	1983-09-24	1983-09-24 00:00:00	32020		\N	321355	0	10509002	260139		0
81635	4843	4112343	2019-02-27	2019-02-27 00:00:00	2019-03-12	2019-03-12 00:00:00	32020		\N	322161	0	195662009	4112343		0
81700	4847	81151	1960-09-03	1960-09-03 00:00:00	1960-09-24	1960-09-24 00:00:00	32020		\N	322426	0	44465007	81151		0
81995	4861	260139	1958-08-31	1958-08-31 00:00:00	1958-09-14	1958-09-14 00:00:00	32020		\N	323382	0	10509002	260139		0
82042	4865	4112343	1991-08-12	1991-08-12 00:00:00	1991-08-25	1991-08-25 00:00:00	32020		\N	323506	0	195662009	4112343		0
82327	4883	4109685	1947-12-11	1947-12-11 00:00:00	1948-01-01	1948-01-01 00:00:00	32020		\N	324678	0	284551006	4109685		0
82447	4890	372328	1925-07-26	1925-07-26 00:00:00	1925-11-04	1925-11-04 00:00:00	32020		\N	325216	0	65363002	372328		0
82625	4905	40481087	2001-04-28	2001-04-28 00:00:00	2001-05-19	2001-05-19 00:00:00	32020		\N	326034	0	444814009	40481087		0
82688	4909	372328	1976-03-20	1976-03-20 00:00:00	1976-05-24	1976-05-24 00:00:00	32020		\N	326246	0	65363002	372328		0
82903	4923	40481087	2009-02-10	2009-02-10 00:00:00	2009-02-24	2009-02-24 00:00:00	32020		\N	327098	0	444814009	40481087		0
83497	4963	4112343	1985-02-19	1985-02-19 00:00:00	1985-03-03	1985-03-03 00:00:00	32020		\N	329964	0	195662009	4112343		0
83806	4977	40481087	2009-12-27	2009-12-27 00:00:00	2010-01-10	2010-01-10 00:00:00	32020		\N	331127	0	444814009	40481087		0
83972	4988	40481087	1978-11-11	1978-11-11 00:00:00	1978-11-18	1978-11-18 00:00:00	32020		\N	331798	0	444814009	40481087		0
84183	5000	372328	1941-10-25	1941-10-25 00:00:00	1942-01-27	1942-01-27 00:00:00	32020		\N	332529	0	65363002	372328		0
84488	5023	378001	1974-07-27	1974-07-27 00:00:00	1974-09-25	1974-09-25 00:00:00	32020		\N	333768	0	62106007	378001		0
84818	5045	40481087	2004-01-13	2004-01-13 00:00:00	2004-01-20	2004-01-20 00:00:00	32020		\N	335288	0	444814009	40481087		0
85081	5060	4278672	1988-06-01	1988-06-01 00:00:00	1988-07-01	1988-07-01 00:00:00	32020		\N	336406	0	65966004	4278672		0
85218	5068	4112343	1974-04-16	1974-04-16 00:00:00	1974-04-28	1974-04-28 00:00:00	32020		\N	336947	0	195662009	4112343		0
74857	4447	4218389	2008-09-04	2008-09-04 00:00:00	2008-09-25	2008-09-25 00:00:00	32020		\N	295721	0	39848009	4218389		0
74960	4451	40481087	1963-02-11	1963-02-11 00:00:00	1963-03-04	1963-03-04 00:00:00	32020		\N	296200	0	444814009	40481087		0
75081	4459	81151	2015-10-04	2015-10-04 00:00:00	2015-11-01	2015-11-01 00:00:00	32020		\N	296736	0	44465007	81151		0
75351	4474	40481087	1969-01-15	1969-01-15 00:00:00	1969-02-05	1969-02-05 00:00:00	32020		\N	297695	0	444814009	40481087		0
64881	3836	260139	1997-11-09	1997-11-09 00:00:00	1997-11-23	1997-11-23 00:00:00	32020		\N	254708	0	10509002	260139		0
75632	4487	4230399	1953-09-12	1953-09-12 00:00:00	1953-12-11	1953-12-11 00:00:00	32020		\N	298681	0	359817006	4230399		0
75742	4492	80180	1987-09-10	1987-09-10 00:00:00	\N	\N	32020		\N	299062	0	396275006	80180		0
75912	4503	260139	1998-12-24	1998-12-24 00:00:00	1998-12-31	1998-12-31 00:00:00	32020		\N	299882	0	10509002	260139		0
76163	4520	40481087	1964-11-16	1964-11-16 00:00:00	1964-11-30	1964-11-30 00:00:00	32020		\N	300873	0	444814009	40481087		0
86839	5170	40481087	2018-04-27	2018-04-27 00:00:00	2018-05-11	2018-05-11 00:00:00	32020		\N	343774	0	444814009	40481087		0
87050	5185	4112343	2010-05-25	2010-05-25 00:00:00	2010-06-07	2010-06-07 00:00:00	32020		\N	344696	0	195662009	4112343		0
76685	4546	4112343	2009-12-27	2009-12-27 00:00:00	2010-01-07	2010-01-07 00:00:00	32020		\N	302827	0	195662009	4112343		0
76805	4551	40481087	1989-02-04	1989-02-04 00:00:00	1989-02-11	1989-02-11 00:00:00	32020		\N	303303	0	444814009	40481087		0
76963	4560	440448	1977-10-30	1977-10-30 00:00:00	\N	\N	32020		\N	303809	0	74400008	440448		0
77064	4565	40481087	2001-04-29	2001-04-29 00:00:00	2001-05-20	2001-05-20 00:00:00	32020		\N	304220	0	444814009	40481087		0
87871	5228	40481087	2005-02-03	2005-02-03 00:00:00	2005-02-24	2005-02-24 00:00:00	32020		\N	347796	0	444814009	40481087		0
87998	5234	4109685	1965-09-05	1965-09-05 00:00:00	1965-09-19	1965-09-19 00:00:00	32020		\N	348230	0	284551006	4109685		0
88153	5241	4112343	2012-04-02	2012-04-02 00:00:00	2012-04-10	2012-04-10 00:00:00	32020		\N	348760	0	195662009	4112343		0
77797	4608	40481087	2003-05-04	2003-05-04 00:00:00	2003-05-18	2003-05-18 00:00:00	32020		\N	307033	0	444814009	40481087		0
88612	5268	4155034	2004-08-31	2004-08-31 00:00:00	2004-09-14	2004-09-14 00:00:00	32020		\N	350534	0	283371005	4155034		0
78155	4630	260139	1973-07-15	1973-07-15 00:00:00	1973-07-22	1973-07-22 00:00:00	32020		\N	308436	0	10509002	260139		0
78264	4634	80180	1997-10-20	1997-10-20 00:00:00	\N	\N	32020		\N	308859	0	396275006	80180		0
78441	4643	4059173	1946-05-01	1946-05-01 00:00:00	1946-05-31	1946-05-31 00:00:00	32020		\N	309571	0	16114001	4059173		0
78642	4656	4329847	2008-06-29	2008-06-29 00:00:00	\N	\N	32020		\N	310471	0	22298006	4329847		0
78775	4666	372328	1981-02-03	1981-02-03 00:00:00	1981-07-06	1981-07-06 00:00:00	32020		\N	310957	0	65363002	372328		0
89493	5322	40481087	1970-04-12	1970-04-12 00:00:00	1970-04-19	1970-04-19 00:00:00	32020		\N	354271	0	444814009	40481087		0
79129	4685	40481087	1970-03-09	1970-03-09 00:00:00	1970-03-30	1970-03-30 00:00:00	32020		\N	312119	0	444814009	40481087		0
89852	5343	80180	2019-02-12	2019-02-12 00:00:00	\N	\N	32020		\N	355856	0	396275006	80180		0
79538	4712	4112343	1990-02-28	1990-02-28 00:00:00	1990-03-11	1990-03-11 00:00:00	32020		\N	313786	0	195662009	4112343		0
79768	4724	80180	1977-12-14	1977-12-14 00:00:00	\N	\N	32020		\N	314770	0	396275006	80180		0
80039	4745	4112343	2018-03-18	2018-03-18 00:00:00	2018-03-27	2018-03-27 00:00:00	32020		\N	316003	0	195662009	4112343		0
80180	4753	40481087	1963-10-02	1963-10-02 00:00:00	1963-10-23	1963-10-23 00:00:00	32020		\N	316560	0	444814009	40481087		0
80802	4792	40481087	2007-11-09	2007-11-09 00:00:00	2007-11-30	2007-11-30 00:00:00	32020		\N	318866	0	444814009	40481087		0
81443	4829	260139	1999-12-03	1999-12-03 00:00:00	1999-12-17	1999-12-17 00:00:00	32020		\N	321356	0	10509002	260139		0
81636	4843	260139	1984-05-05	1984-05-05 00:00:00	1984-05-19	1984-05-19 00:00:00	32020		\N	322159	0	10509002	260139		0
81701	4847	317576	2013-03-27	2013-03-27 00:00:00	\N	\N	32020		\N	322420	0	53741008	317576		0
81996	4861	4112343	1947-06-02	1947-06-02 00:00:00	1947-06-13	1947-06-13 00:00:00	32020		\N	323420	0	195662009	4112343		0
82043	4865	81151	1995-02-10	1995-02-10 00:00:00	1995-02-24	1995-02-24 00:00:00	32020		\N	323505	0	44465007	81151		0
82328	4884	372328	1973-03-20	1973-03-20 00:00:00	1973-06-30	1973-06-30 00:00:00	32020		\N	324752	0	65363002	372328		0
82448	4890	4112343	2010-06-16	2010-06-16 00:00:00	2010-06-29	2010-06-29 00:00:00	32020		\N	325190	0	195662009	4112343		0
82626	4905	81151	1988-06-08	1988-06-08 00:00:00	1988-06-29	1988-06-29 00:00:00	32020		\N	326058	0	44465007	81151		0
82689	4909	4116491	2003-07-14	2003-07-14 00:00:00	2003-09-06	2003-09-06 00:00:00	32020		\N	326226	0	301011002	4116491		0
82904	4923	260139	1979-05-08	1979-05-08 00:00:00	1979-05-22	1979-05-22 00:00:00	32020		\N	327128	0	10509002	260139		0
83498	4963	440086	1987-05-11	1987-05-11 00:00:00	1990-09-03	1990-09-03 00:00:00	32020		\N	329943	0	192127007	440086		0
83807	4977	40481087	1996-06-03	1996-06-03 00:00:00	1996-06-24	1996-06-24 00:00:00	32020		\N	331190	0	444814009	40481087		0
83973	4988	4218389	1977-12-23	1977-12-23 00:00:00	1978-01-27	1978-01-27 00:00:00	32020		\N	331795	0	39848009	4218389		0
84184	5000	260139	1956-01-12	1956-01-12 00:00:00	1956-01-26	1956-01-26 00:00:00	32020		\N	332513	0	10509002	260139		0
84819	5045	28060	1963-08-19	1963-08-19 00:00:00	1963-09-01	1963-09-01 00:00:00	32020		\N	335261	0	43878008	28060		0
85082	5060	4112343	1977-07-01	1977-07-01 00:00:00	1977-07-08	1977-07-08 00:00:00	32020		\N	336419	0	195662009	4112343		0
85219	5068	40481087	1931-11-23	1931-11-23 00:00:00	1931-11-30	1931-11-30 00:00:00	32020		\N	337006	0	444814009	40481087		0
74858	4447	40481087	2010-03-10	2010-03-10 00:00:00	2010-03-31	2010-03-31 00:00:00	32020		\N	295792	0	444814009	40481087		0
74961	4451	4294548	1984-09-05	1984-09-05 00:00:00	1984-09-26	1984-09-26 00:00:00	32020		\N	296132	0	75498004	4294548		0
75082	4459	260139	1966-09-07	1966-09-07 00:00:00	1966-09-14	1966-09-14 00:00:00	32020		\N	296727	0	10509002	260139		0
75352	4474	4112343	2011-11-14	2011-11-14 00:00:00	2011-11-24	2011-11-24 00:00:00	32020		\N	297633	0	195662009	4112343		0
64882	3836	372328	1978-05-10	1978-05-10 00:00:00	1978-08-11	1978-08-11 00:00:00	32020		\N	254739	0	65363002	372328		0
75633	4487	40481087	1986-12-17	1986-12-17 00:00:00	1987-01-07	1987-01-07 00:00:00	32020		\N	298750	0	444814009	40481087		0
75743	4492	40481087	2005-09-29	2005-09-29 00:00:00	2005-10-20	2005-10-20 00:00:00	32020		\N	299052	0	444814009	40481087		0
75913	4503	80180	1971-01-04	1971-01-04 00:00:00	\N	\N	32020		\N	299878	0	396275006	80180		0
76164	4521	375671	1978-08-08	1978-08-08 00:00:00	1978-09-07	1978-09-07 00:00:00	32020		\N	301013	0	62564004	375671		0
86840	5170	40481087	1980-04-04	1980-04-04 00:00:00	1980-04-25	1980-04-25 00:00:00	32020		\N	343791	0	444814009	40481087		0
87051	5185	4112343	2015-04-07	2015-04-07 00:00:00	2015-04-19	2015-04-19 00:00:00	32020		\N	344688	0	195662009	4112343		0
76686	4546	378001	1992-12-19	1992-12-19 00:00:00	1993-02-17	1993-02-17 00:00:00	32020		\N	302792	0	62106007	378001		0
76806	4551	30753	2015-01-12	2015-01-12 00:00:00	\N	\N	32020		\N	303324	0	16761005	30753		0
76964	4560	4166224	1977-10-30	1977-10-30 00:00:00	\N	\N	32020		\N	303809	0	47693006	4166224		0
77065	4565	4112343	1977-12-21	1977-12-21 00:00:00	1977-12-28	1977-12-28 00:00:00	32020		\N	304237	0	195662009	4112343		0
87872	5228	40481087	1963-10-03	1963-10-03 00:00:00	1963-10-17	1963-10-17 00:00:00	32020		\N	347776	0	444814009	40481087		0
87999	5234	4152936	1962-09-30	1962-09-30 00:00:00	1962-10-21	1962-10-21 00:00:00	32020		\N	348229	0	283385000	4152936		0
88154	5241	40481087	1989-11-23	1989-11-23 00:00:00	1989-11-30	1989-11-30 00:00:00	32020		\N	348769	0	444814009	40481087		0
77798	4608	40481087	2008-09-25	2008-09-25 00:00:00	2008-10-02	2008-10-02 00:00:00	32020		\N	307008	0	444814009	40481087		0
88613	5268	260139	2005-08-07	2005-08-07 00:00:00	2005-08-14	2005-08-14 00:00:00	32020		\N	350502	0	10509002	260139		0
78156	4630	257012	1980-05-16	1980-05-16 00:00:00	\N	\N	32020		\N	308437	0	40055000	257012		0
78265	4634	372328	1964-09-11	1964-09-11 00:00:00	1964-10-15	1964-10-15 00:00:00	32020		\N	308839	0	65363002	372328		0
78442	4643	4112343	1920-01-05	1920-01-05 00:00:00	1920-01-15	1920-01-15 00:00:00	32020		\N	309601	0	195662009	4112343		0
78643	4656	40481087	2008-10-29	2008-10-29 00:00:00	2008-11-05	2008-11-05 00:00:00	32020		\N	310427	0	444814009	40481087		0
78776	4666	4112343	2005-07-13	2005-07-13 00:00:00	2005-07-23	2005-07-23 00:00:00	32020		\N	310950	0	195662009	4112343		0
89494	5322	40481087	1970-06-25	1970-06-25 00:00:00	1970-07-16	1970-07-16 00:00:00	32020		\N	354179	0	444814009	40481087		0
79130	4685	81893	1971-03-25	1971-03-25 00:00:00	\N	\N	32020		\N	312148	0	64766004	81893		0
89853	5343	372328	1988-05-28	1988-05-28 00:00:00	1988-12-18	1988-12-18 00:00:00	32020		\N	355827	0	65363002	372328		0
79539	4712	372328	2017-05-01	2017-05-01 00:00:00	2018-03-23	2018-03-23 00:00:00	32020		\N	313796	0	65363002	372328		0
79769	4724	40481087	1977-03-31	1977-03-31 00:00:00	1977-04-14	1977-04-14 00:00:00	32020		\N	314770	0	444814009	40481087		0
80040	4745	40481087	1989-01-28	1989-01-28 00:00:00	1989-02-04	1989-02-04 00:00:00	32020		\N	315951	0	444814009	40481087		0
80181	4753	40481087	1989-10-24	1989-10-24 00:00:00	1989-10-31	1989-10-31 00:00:00	32020		\N	316571	0	444814009	40481087		0
80803	4792	260139	2000-12-10	2000-12-10 00:00:00	2000-12-17	2000-12-17 00:00:00	32020		\N	318844	0	10509002	260139		0
81444	4829	40481087	2009-02-02	2009-02-02 00:00:00	2009-02-09	2009-02-09 00:00:00	32020		\N	321323	0	444814009	40481087		0
81637	4843	40481087	1974-09-02	1974-09-02 00:00:00	1974-09-23	1974-09-23 00:00:00	32020		\N	322115	0	444814009	40481087		0
81702	4847	260139	2002-01-20	2002-01-20 00:00:00	2002-02-03	2002-02-03 00:00:00	32020		\N	322483	0	10509002	260139		0
81997	4861	4266809	1989-05-14	1989-05-14 00:00:00	\N	\N	32020		\N	323431	0	397881000	4266809		0
82044	4865	4112343	1995-11-14	1995-11-14 00:00:00	1995-11-22	1995-11-22 00:00:00	32020		\N	323507	0	195662009	4112343		0
82329	4884	80180	2016-02-28	2016-02-28 00:00:00	\N	\N	32020		\N	324725	0	396275006	80180		0
82449	4890	81151	2000-10-17	2000-10-17 00:00:00	2000-11-21	2000-11-21 00:00:00	32020		\N	325140	0	44465007	81151		0
82627	4905	4237458	1978-07-31	1978-07-31 00:00:00	1978-08-30	1978-08-30 00:00:00	32020		\N	326057	0	58150001	4237458		0
82690	4909	4116491	1999-06-10	1999-06-10 00:00:00	1999-07-15	1999-07-15 00:00:00	32020		\N	326257	0	301011002	4116491		0
82905	4923	260139	1974-03-13	1974-03-13 00:00:00	1974-03-27	1974-03-27 00:00:00	32020		\N	327133	0	10509002	260139		0
83808	4977	372328	1964-06-14	1964-06-14 00:00:00	1964-08-15	1964-08-15 00:00:00	32020		\N	331117	0	65363002	372328		0
83974	4988	4283893	1975-09-06	1975-09-06 00:00:00	1975-09-20	1975-09-20 00:00:00	32020		\N	331831	0	36971009	4283893		0
84185	5000	81151	1980-08-17	1980-08-17 00:00:00	1980-09-14	1980-09-14 00:00:00	32020		\N	332551	0	44465007	81151		0
84820	5045	260139	1985-02-08	1985-02-08 00:00:00	1985-02-22	1985-02-22 00:00:00	32020		\N	335268	0	10509002	260139		0
85083	5060	372328	1976-12-31	1976-12-31 00:00:00	1977-03-07	1977-03-07 00:00:00	32020		\N	336440	0	65363002	372328		0
85220	5068	317576	2008-11-22	2008-11-22 00:00:00	\N	\N	32020		\N	336974	0	53741008	317576		0
74859	4447	260139	2015-01-05	2015-01-05 00:00:00	2015-01-12	2015-01-12 00:00:00	32020		\N	295735	0	10509002	260139		0
74962	4451	4146173	2018-12-08	2018-12-08 00:00:00	2019-02-06	2019-02-06 00:00:00	32020		\N	296170	0	307731004	4146173		0
75083	4459	260139	1977-12-04	1977-12-04 00:00:00	1977-12-11	1977-12-11 00:00:00	32020		\N	296688	0	10509002	260139		0
75353	4474	40481087	1990-09-13	1990-09-13 00:00:00	1990-09-27	1990-09-27 00:00:00	32020		\N	297653	0	444814009	40481087		0
64883	3836	4237458	1986-10-04	1986-10-04 00:00:00	1986-11-03	1986-11-03 00:00:00	32020		\N	254749	0	58150001	4237458		0
75634	4487	80180	1988-01-22	1988-01-22 00:00:00	\N	\N	32020		\N	298752	0	396275006	80180		0
75744	4492	257012	1970-02-06	1970-02-06 00:00:00	\N	\N	32020		\N	299072	0	40055000	257012		0
75914	4503	260139	1977-08-20	1977-08-20 00:00:00	1977-08-27	1977-08-27 00:00:00	32020		\N	299810	0	10509002	260139		0
76165	4521	192671	1958-11-18	1958-11-18 00:00:00	\N	\N	32020		\N	300975	0	K92.2	35208414		0
86841	5170	4112343	2014-07-31	2014-07-31 00:00:00	2014-08-09	2014-08-09 00:00:00	32020		\N	343773	0	195662009	4112343		0
87052	5185	4283893	1969-04-23	1969-04-23 00:00:00	1969-07-30	1969-07-30 00:00:00	32020		\N	344652	0	36971009	4283893		0
76687	4546	28060	1984-06-18	1984-06-18 00:00:00	1984-06-27	1984-06-27 00:00:00	32020		\N	302822	0	43878008	28060		0
76807	4551	4266809	2015-10-09	2015-10-09 00:00:00	\N	\N	32020		\N	303324	0	397881000	4266809		0
76965	4560	40481087	1993-09-02	1993-09-02 00:00:00	1993-09-09	1993-09-09 00:00:00	32020		\N	303861	0	444814009	40481087		0
77066	4565	378001	1976-02-08	1976-02-08 00:00:00	1976-03-09	1976-03-09 00:00:00	32020		\N	304209	0	62106007	378001		0
87873	5228	4027663	1960-06-13	1960-06-13 00:00:00	\N	\N	32020		\N	347779	0	13200003	4027663		0
88000	5234	4035415	1953-02-05	1953-02-05 00:00:00	1953-03-07	1953-03-07 00:00:00	32020		\N	348227	0	239720000	4035415		0
88155	5241	40481087	2000-02-17	2000-02-17 00:00:00	2000-03-02	2000-03-02 00:00:00	32020		\N	348758	0	444814009	40481087		0
77799	4608	4112343	2017-10-10	2017-10-10 00:00:00	2017-10-23	2017-10-23 00:00:00	32020		\N	307036	0	195662009	4112343		0
88614	5268	260139	1972-03-24	1972-03-24 00:00:00	1972-04-07	1972-04-07 00:00:00	32020		\N	350478	0	10509002	260139		0
78157	4630	4296204	1966-10-10	1966-10-10 00:00:00	1966-10-31	1966-10-31 00:00:00	32020		\N	308520	0	403190006	4296204		0
78266	4634	260139	2002-03-15	2002-03-15 00:00:00	2002-03-29	2002-03-29 00:00:00	32020		\N	308879	0	10509002	260139		0
78443	4643	40481087	1962-03-15	1962-03-15 00:00:00	1962-04-05	1962-04-05 00:00:00	32020		\N	309612	0	444814009	40481087		0
78644	4656	40481087	1958-01-27	1958-01-27 00:00:00	1958-02-10	1958-02-10 00:00:00	32020		\N	310425	0	444814009	40481087		0
78777	4666	4294548	1993-05-19	1993-05-19 00:00:00	1993-05-26	1993-05-26 00:00:00	32020		\N	310949	0	75498004	4294548		0
89495	5322	4112343	1978-03-05	1978-03-05 00:00:00	1978-03-12	1978-03-12 00:00:00	32020		\N	354122	0	195662009	4112343		0
79131	4685	4310024	1971-01-24	1971-01-24 00:00:00	\N	\N	32020		\N	312148	0	424802006	4310024		0
89854	5343	4112343	2009-04-22	2009-04-22 00:00:00	2009-05-04	2009-05-04 00:00:00	32020		\N	355825	0	195662009	4112343		0
79540	4712	4027663	1998-01-11	1998-01-11 00:00:00	\N	\N	32020		\N	313805	0	13200003	4027663		0
79770	4724	257012	1974-08-02	1974-08-02 00:00:00	\N	\N	32020		\N	314682	0	40055000	257012		0
80041	4745	81151	1981-12-26	1981-12-26 00:00:00	1982-01-16	1982-01-16 00:00:00	32020		\N	315887	0	44465007	81151		0
80182	4753	81151	2013-09-16	2013-09-16 00:00:00	2013-09-30	2013-09-30 00:00:00	32020		\N	316519	0	44465007	81151		0
80804	4792	4112343	2012-04-26	2012-04-26 00:00:00	2012-05-06	2012-05-06 00:00:00	32020		\N	318873	0	195662009	4112343		0
81445	4829	40481087	2015-12-12	2015-12-12 00:00:00	2015-12-19	2015-12-19 00:00:00	32020		\N	321313	0	444814009	40481087		0
81638	4843	4278672	1974-06-17	1974-06-17 00:00:00	1974-08-16	1974-08-16 00:00:00	32020		\N	322106	0	65966004	4278672		0
81703	4847	4112343	2000-09-02	2000-09-02 00:00:00	2000-09-12	2000-09-12 00:00:00	32020		\N	322443	0	195662009	4112343		0
81998	4861	80180	1989-05-14	1989-05-14 00:00:00	\N	\N	32020		\N	323431	0	396275006	80180		0
82045	4865	375671	1994-02-15	1994-02-15 00:00:00	1994-03-17	1994-03-17 00:00:00	32020		\N	323504	0	62564004	375671		0
82330	4884	40481087	1983-10-14	1983-10-14 00:00:00	1983-10-28	1983-10-28 00:00:00	32020		\N	324729	0	444814009	40481087		0
82450	4890	40481087	1967-02-01	1967-02-01 00:00:00	1967-02-15	1967-02-15 00:00:00	32020		\N	325081	0	444814009	40481087		0
82628	4905	40481087	2018-05-13	2018-05-13 00:00:00	2018-05-27	2018-05-27 00:00:00	32020		\N	326035	0	444814009	40481087		0
82691	4909	40481087	2008-07-04	2008-07-04 00:00:00	2008-07-18	2008-07-18 00:00:00	32020		\N	326265	0	444814009	40481087		0
82906	4923	260139	1980-11-18	1980-11-18 00:00:00	1980-11-25	1980-11-25 00:00:00	32020		\N	327135	0	10509002	260139		0
83809	4977	40481087	1974-10-19	1974-10-19 00:00:00	1974-10-26	1974-10-26 00:00:00	32020		\N	331186	0	444814009	40481087		0
83975	4988	4152936	2007-09-13	2007-09-13 00:00:00	2007-09-27	2007-09-27 00:00:00	32020		\N	331829	0	283385000	4152936		0
84186	5000	4146173	1991-11-16	1991-11-16 00:00:00	1991-12-16	1991-12-16 00:00:00	32020		\N	332542	0	307731004	4146173		0
84821	5045	260139	1967-04-28	1967-04-28 00:00:00	1967-05-12	1967-05-12 00:00:00	32020		\N	335231	0	10509002	260139		0
85084	5060	4134304	2012-10-23	2012-10-23 00:00:00	2012-12-22	2012-12-22 00:00:00	32020		\N	336407	0	263102004	4134304		0
85221	5068	381316	2009-07-11	2009-07-11 00:00:00	\N	\N	32020		\N	336974	0	230690007	381316		0
74860	4447	4146173	1967-11-25	1967-11-25 00:00:00	1968-01-24	1968-01-24 00:00:00	32020		\N	295775	0	307731004	4146173		0
74963	4452	78272	1970-05-29	1970-05-29 00:00:00	1970-06-19	1970-06-19 00:00:00	32020		\N	296343	0	70704007	78272		0
75084	4459	440086	1973-10-19	1973-10-19 00:00:00	1981-10-26	1981-10-26 00:00:00	32020		\N	296729	0	192127007	440086		0
75354	4474	28060	1972-07-19	1972-07-19 00:00:00	1972-07-28	1972-07-28 00:00:00	32020		\N	297641	0	43878008	28060		0
64884	3836	260139	2002-05-19	2002-05-19 00:00:00	2002-06-02	2002-06-02 00:00:00	32020		\N	254723	0	10509002	260139		0
75635	4487	40481087	1995-03-07	1995-03-07 00:00:00	1995-03-28	1995-03-28 00:00:00	32020		\N	298717	0	444814009	40481087		0
75745	4492	4283893	1958-07-12	1958-07-12 00:00:00	1958-09-06	1958-09-06 00:00:00	32020		\N	299069	0	36971009	4283893		0
75915	4503	40481087	1937-08-20	1937-08-20 00:00:00	1937-09-03	1937-09-03 00:00:00	32020		\N	299799	0	444814009	40481087		0
76166	4521	4059173	1933-04-15	1933-04-15 00:00:00	1933-06-14	1933-06-14 00:00:00	32020		\N	301010	0	16114001	4059173		0
86842	5170	81151	1971-10-13	1971-10-13 00:00:00	1971-11-03	1971-11-03 00:00:00	32020		\N	343733	0	44465007	81151		0
87053	5185	28060	1936-05-13	1936-05-13 00:00:00	1936-05-21	1936-05-21 00:00:00	32020		\N	344647	0	43878008	28060		0
76688	4546	4112343	2000-06-06	2000-06-06 00:00:00	2000-06-13	2000-06-13 00:00:00	32020		\N	302800	0	195662009	4112343		0
76808	4551	80180	2015-10-09	2015-10-09 00:00:00	\N	\N	32020		\N	303324	0	396275006	80180		0
76966	4560	81151	1976-08-20	1976-08-20 00:00:00	1976-09-10	1976-09-10 00:00:00	32020		\N	303808	0	44465007	81151		0
77067	4565	40481087	2006-03-20	2006-03-20 00:00:00	2006-03-27	2006-03-27 00:00:00	32020		\N	304180	0	444814009	40481087		0
87874	5228	195588	1960-06-13	1960-06-13 00:00:00	1960-08-06	1960-08-06 00:00:00	32020		\N	347779	0	38822007	195588		0
88001	5234	4285898	1978-11-16	1978-11-16 00:00:00	\N	\N	32020		\N	348205	0	68496003	4285898		0
88156	5241	260139	2017-03-18	2017-03-18 00:00:00	2017-03-25	2017-03-25 00:00:00	32020		\N	348771	0	10509002	260139		0
77800	4608	40481087	1971-05-29	1971-05-29 00:00:00	1971-06-05	1971-06-05 00:00:00	32020		\N	306992	0	444814009	40481087		0
88615	5268	4112343	1984-03-22	1984-03-22 00:00:00	1984-04-03	1984-04-03 00:00:00	32020		\N	350501	0	195662009	4112343		0
78158	4630	4112343	1973-09-23	1973-09-23 00:00:00	1973-10-04	1973-10-04 00:00:00	32020		\N	308525	0	195662009	4112343		0
78267	4634	4112343	2008-04-14	2008-04-14 00:00:00	2008-04-23	2008-04-23 00:00:00	32020		\N	308823	0	195662009	4112343		0
78444	4643	257012	1945-12-01	1945-12-01 00:00:00	\N	\N	32020		\N	309537	0	40055000	257012		0
78645	4656	4112343	1996-12-17	1996-12-17 00:00:00	1996-12-28	1996-12-28 00:00:00	32020		\N	310451	0	195662009	4112343		0
78778	4666	4146173	2001-11-03	2001-11-03 00:00:00	2002-01-02	2002-01-02 00:00:00	32020		\N	310956	0	307731004	4146173		0
89496	5322	4283893	1985-08-29	1985-08-29 00:00:00	1985-12-26	1985-12-26 00:00:00	32020		\N	354110	0	36971009	4283893		0
79132	4685	4285898	1971-08-22	1971-08-22 00:00:00	\N	\N	32020		\N	312148	0	68496003	4285898		0
89855	5343	40481087	1985-09-24	1985-09-24 00:00:00	1985-10-01	1985-10-01 00:00:00	32020		\N	355859	0	444814009	40481087		0
79541	4712	40481087	2019-03-31	2019-03-31 00:00:00	2019-04-21	2019-04-21 00:00:00	32020		\N	313790	0	444814009	40481087		0
79771	4724	260139	1996-10-20	1996-10-20 00:00:00	1996-10-27	1996-10-27 00:00:00	32020		\N	314798	0	10509002	260139		0
80042	4745	257012	2017-05-10	2017-05-10 00:00:00	\N	\N	32020		\N	316002	0	40055000	257012		0
80183	4753	40481087	2018-08-27	2018-08-27 00:00:00	2018-09-10	2018-09-10 00:00:00	32020		\N	316558	0	444814009	40481087		0
80805	4792	4112343	1988-06-06	1988-06-06 00:00:00	1988-06-18	1988-06-18 00:00:00	32020		\N	318871	0	195662009	4112343		0
81446	4829	4112343	1998-03-24	1998-03-24 00:00:00	1998-04-01	1998-04-01 00:00:00	32020		\N	321310	0	195662009	4112343		0
81639	4843	260139	2009-06-13	2009-06-13 00:00:00	2009-06-20	2009-06-20 00:00:00	32020		\N	322118	0	10509002	260139		0
81704	4847	80180	1977-07-08	1977-07-08 00:00:00	\N	\N	32020		\N	322413	0	396275006	80180		0
81999	4861	4285898	1989-04-14	1989-04-14 00:00:00	\N	\N	32020		\N	323431	0	68496003	4285898		0
82046	4865	40481087	2008-07-15	2008-07-15 00:00:00	2008-07-29	2008-07-29 00:00:00	32020		\N	323509	0	444814009	40481087		0
82331	4884	4134304	1989-07-08	1989-07-08 00:00:00	1989-10-06	1989-10-06 00:00:00	32020		\N	324736	0	263102004	4134304		0
82451	4890	260139	1965-10-31	1965-10-31 00:00:00	1965-11-14	1965-11-14 00:00:00	32020		\N	325198	0	10509002	260139		0
82629	4905	260139	2018-09-01	2018-09-01 00:00:00	2018-09-08	2018-09-08 00:00:00	32020		\N	326039	0	10509002	260139		0
82692	4909	80180	2008-08-26	2008-08-26 00:00:00	\N	\N	32020		\N	326265	0	396275006	80180		0
82907	4923	4027663	1993-10-02	1993-10-02 00:00:00	\N	\N	32020		\N	327081	0	13200003	4027663		0
83810	4977	4283893	1975-12-25	1975-12-25 00:00:00	1976-11-25	1976-11-25 00:00:00	32020		\N	331160	0	36971009	4283893		0
83976	4988	4027663	1979-04-15	1979-04-15 00:00:00	\N	\N	32020		\N	331855	0	13200003	4027663		0
84187	5000	260139	1983-01-28	1983-01-28 00:00:00	1983-02-11	1983-02-11 00:00:00	32020		\N	332545	0	10509002	260139		0
84822	5045	4112343	1993-12-16	1993-12-16 00:00:00	1993-12-28	1993-12-28 00:00:00	32020		\N	335263	0	195662009	4112343		0
85085	5060	40481087	2004-12-09	2004-12-09 00:00:00	2004-12-23	2004-12-23 00:00:00	32020		\N	336422	0	444814009	40481087		0
85222	5068	4112343	1931-08-20	1931-08-20 00:00:00	1931-08-27	1931-08-27 00:00:00	32020		\N	336967	0	195662009	4112343		0
74861	4447	4051466	1953-08-27	1953-08-27 00:00:00	1970-11-28	1970-11-28 00:00:00	32020		\N	295786	0	233678006	4051466		0
74964	4452	40481087	1965-04-16	1965-04-16 00:00:00	1965-05-07	1965-05-07 00:00:00	32020		\N	296272	0	444814009	40481087		0
75085	4459	4218389	1999-07-11	1999-07-11 00:00:00	1999-08-15	1999-08-15 00:00:00	32020		\N	296734	0	39848009	4218389		0
75355	4474	81151	2017-10-17	2017-10-17 00:00:00	2017-11-21	2017-11-21 00:00:00	32020		\N	297693	0	44465007	81151		0
64885	3836	40481087	2000-03-31	2000-03-31 00:00:00	2000-04-14	2000-04-14 00:00:00	32020		\N	254752	0	444814009	40481087		0
75636	4487	4329847	2010-02-12	2010-02-12 00:00:00	\N	\N	32020		\N	298687	0	22298006	4329847		0
75746	4492	4218389	1957-07-07	1957-07-07 00:00:00	1957-07-28	1957-07-28 00:00:00	32020		\N	299046	0	39848009	4218389		0
75916	4503	40481087	2018-05-29	2018-05-29 00:00:00	2018-06-12	2018-06-12 00:00:00	32020		\N	299830	0	444814009	40481087		0
76167	4521	80502	2008-11-13	2008-11-13 00:00:00	\N	\N	32020		\N	301028	0	64859006	80502		0
86843	5170	40481087	2010-01-13	2010-01-13 00:00:00	2010-02-03	2010-02-03 00:00:00	32020		\N	343766	0	444814009	40481087		0
87054	5185	4149245	2002-11-26	2002-11-26 00:00:00	2003-01-02	2003-01-02 00:00:00	32020		\N	344725	0	30832001	4149245		0
76689	4546	4112343	2014-05-31	2014-05-31 00:00:00	2014-06-09	2014-06-09 00:00:00	32020		\N	302829	0	195662009	4112343		0
76809	4551	4112343	2005-07-18	2005-07-18 00:00:00	2005-07-28	2005-07-28 00:00:00	32020		\N	303342	0	195662009	4112343		0
76967	4560	4112343	1984-06-06	1984-06-06 00:00:00	1984-06-15	1984-06-15 00:00:00	32020		\N	303831	0	195662009	4112343		0
77068	4565	260139	2011-11-04	2011-11-04 00:00:00	2011-11-11	2011-11-11 00:00:00	32020		\N	304168	0	10509002	260139		0
87875	5228	28060	2015-05-03	2015-05-03 00:00:00	2015-05-15	2015-05-15 00:00:00	32020		\N	347856	0	43878008	28060		0
88002	5234	80180	1979-07-14	1979-07-14 00:00:00	\N	\N	32020		\N	348205	0	396275006	80180		0
88157	5241	40481087	2001-01-04	2001-01-04 00:00:00	2001-01-18	2001-01-18 00:00:00	32020		\N	348724	0	444814009	40481087		0
77801	4608	4283893	1977-03-11	1977-03-11 00:00:00	1977-05-06	1977-05-06 00:00:00	32020		\N	306935	0	36971009	4283893		0
88616	5268	4237458	2008-08-24	2008-08-24 00:00:00	2008-09-23	2008-09-23 00:00:00	32020		\N	350491	0	58150001	4237458		0
78159	4630	30753	1992-01-13	1992-01-13 00:00:00	\N	\N	32020		\N	308500	0	16761005	30753		0
78268	4634	4112343	1980-11-17	1980-11-17 00:00:00	1980-11-27	1980-11-27 00:00:00	32020		\N	308831	0	195662009	4112343		0
78445	4643	4278672	1940-08-30	1940-08-30 00:00:00	1940-11-28	1940-11-28 00:00:00	32020		\N	309569	0	65966004	4278672		0
78646	4656	40481087	1955-11-18	1955-11-18 00:00:00	1955-12-02	1955-12-02 00:00:00	32020		\N	310478	0	444814009	40481087		0
78779	4666	4142905	1978-11-04	1978-11-04 00:00:00	1979-01-03	1979-01-03 00:00:00	32020		\N	310944	0	33737001	4142905		0
89497	5322	260139	1989-04-21	1989-04-21 00:00:00	1989-04-28	1989-04-28 00:00:00	32020		\N	354124	0	10509002	260139		0
79133	4685	80180	1971-11-20	1971-11-20 00:00:00	\N	\N	32020		\N	312148	0	396275006	80180		0
89856	5343	372328	1986-02-15	1986-02-15 00:00:00	1986-06-08	1986-06-08 00:00:00	32020		\N	355837	0	65363002	372328		0
79542	4712	81151	1988-03-04	1988-03-04 00:00:00	1988-03-18	1988-03-18 00:00:00	32020		\N	313756	0	44465007	81151		0
79772	4724	260139	1994-01-17	1994-01-17 00:00:00	1994-01-24	1994-01-24 00:00:00	32020		\N	314835	0	10509002	260139		0
80043	4745	4294548	2017-03-29	2017-03-29 00:00:00	2017-05-17	2017-05-17 00:00:00	32020		\N	315973	0	75498004	4294548		0
80184	4753	4134304	1968-04-01	1968-04-01 00:00:00	1968-05-01	1968-05-01 00:00:00	32020		\N	316573	0	263102004	4134304		0
80806	4792	80180	1988-10-27	1988-10-27 00:00:00	\N	\N	32020		\N	318871	0	396275006	80180		0
81447	4829	4296204	1994-10-10	1994-10-10 00:00:00	1994-11-07	1994-11-07 00:00:00	32020		\N	321333	0	403190006	4296204		0
81640	4843	40481087	2009-08-13	2009-08-13 00:00:00	2009-09-03	2009-09-03 00:00:00	32020		\N	322119	0	444814009	40481087		0
81705	4847	258780	1975-01-22	1975-01-22 00:00:00	\N	\N	32020		\N	322413	0	185086009	258780		0
82000	4861	4112343	1952-04-19	1952-04-19 00:00:00	1952-05-03	1952-05-03 00:00:00	32020		\N	323393	0	195662009	4112343		0
82047	4865	4155034	1991-01-11	1991-01-11 00:00:00	1991-02-01	1991-02-01 00:00:00	32020		\N	323503	0	283371005	4155034		0
82332	4884	40481087	1976-10-08	1976-10-08 00:00:00	1976-10-22	1976-10-22 00:00:00	32020		\N	324797	0	444814009	40481087		0
82452	4890	40481087	1947-03-18	1947-03-18 00:00:00	1947-04-08	1947-04-08 00:00:00	32020		\N	325064	0	444814009	40481087		0
82630	4905	4112343	2008-01-21	2008-01-21 00:00:00	2008-01-31	2008-01-31 00:00:00	32020		\N	326074	0	195662009	4112343		0
82693	4909	372328	1978-04-14	1978-04-14 00:00:00	1978-05-22	1978-05-22 00:00:00	32020		\N	326247	0	65363002	372328		0
82908	4923	40481087	1984-12-18	1984-12-18 00:00:00	1985-01-01	1985-01-01 00:00:00	32020		\N	327144	0	444814009	40481087		0
83811	4977	80180	1997-11-23	1997-11-23 00:00:00	\N	\N	32020		\N	331149	0	396275006	80180		0
83977	4988	372328	1979-01-05	1979-01-05 00:00:00	1980-04-29	1980-04-29 00:00:00	32020		\N	331855	0	65363002	372328		0
84188	5000	4296204	1943-06-28	1943-06-28 00:00:00	1943-07-12	1943-07-12 00:00:00	32020		\N	332549	0	403190006	4296204		0
84823	5045	80180	1995-05-14	1995-05-14 00:00:00	\N	\N	32020		\N	335263	0	396275006	80180		0
85086	5060	40481087	2000-09-01	2000-09-01 00:00:00	2000-09-22	2000-09-22 00:00:00	32020		\N	336438	0	444814009	40481087		0
85223	5068	4113008	1987-10-08	1987-10-08 00:00:00	1987-10-22	1987-10-22 00:00:00	32020		\N	336992	0	284549007	4113008		0
74862	4447	4155034	1975-01-17	1975-01-17 00:00:00	1975-01-31	1975-01-31 00:00:00	32020		\N	295715	0	283371005	4155034		0
74965	4452	40481087	1974-02-16	1974-02-16 00:00:00	1974-03-09	1974-03-09 00:00:00	32020		\N	296247	0	444814009	40481087		0
75086	4460	40481087	1979-08-10	1979-08-10 00:00:00	1979-08-24	1979-08-24 00:00:00	32020		\N	296814	0	444814009	40481087		0
75356	4474	4156265	2002-05-18	2002-05-18 00:00:00	2002-06-08	2002-06-08 00:00:00	32020		\N	297691	0	370247008	4156265		0
64886	3836	4112343	2015-03-18	2015-03-18 00:00:00	2015-03-25	2015-03-25 00:00:00	32020		\N	254738	0	195662009	4112343		0
75638	4487	317576	2004-10-22	2004-10-22 00:00:00	\N	\N	32020		\N	298775	0	53741008	317576		0
75747	4492	40481087	1963-08-20	1963-08-20 00:00:00	1963-09-03	1963-09-03 00:00:00	32020		\N	299084	0	444814009	40481087		0
75917	4503	40481087	1981-01-25	1981-01-25 00:00:00	1981-02-01	1981-02-01 00:00:00	32020		\N	299800	0	444814009	40481087		0
76168	4521	40481087	2003-10-18	2003-10-18 00:00:00	2003-11-01	2003-11-01 00:00:00	32020		\N	300970	0	444814009	40481087		0
86844	5170	260139	2015-12-23	2015-12-23 00:00:00	2016-01-06	2016-01-06 00:00:00	32020		\N	343796	0	10509002	260139		0
87055	5185	372328	2009-09-06	2009-09-06 00:00:00	2009-12-07	2009-12-07 00:00:00	32020		\N	344703	0	65363002	372328		0
76690	4546	4112343	2011-12-29	2011-12-29 00:00:00	2012-01-10	2012-01-10 00:00:00	32020		\N	302828	0	195662009	4112343		0
76810	4551	28060	1990-04-30	1990-04-30 00:00:00	1990-05-07	1990-05-07 00:00:00	32020		\N	303304	0	43878008	28060		0
76969	4560	40481087	2000-02-26	2000-02-26 00:00:00	2000-03-04	2000-03-04 00:00:00	32020		\N	303821	0	444814009	40481087		0
77069	4565	40481087	1985-09-06	1985-09-06 00:00:00	1985-09-27	1985-09-27 00:00:00	32020		\N	304223	0	444814009	40481087		0
87876	5229	4294548	2000-06-20	2000-06-20 00:00:00	2000-07-04	2000-07-04 00:00:00	32020		\N	347872	0	75498004	4294548		0
88003	5234	260139	1949-02-28	1949-02-28 00:00:00	1949-03-14	1949-03-14 00:00:00	32020		\N	348219	0	10509002	260139		0
88158	5241	80180	2001-04-01	2001-04-01 00:00:00	\N	\N	32020		\N	348724	0	396275006	80180		0
77802	4608	40481087	2015-11-19	2015-11-19 00:00:00	2015-12-03	2015-12-03 00:00:00	32020		\N	307035	0	444814009	40481087		0
88617	5268	40481087	2015-08-06	2015-08-06 00:00:00	2015-08-27	2015-08-27 00:00:00	32020		\N	350480	0	444814009	40481087		0
78160	4630	4266809	1993-04-07	1993-04-07 00:00:00	\N	\N	32020		\N	308500	0	397881000	4266809		0
78269	4634	372328	1963-07-06	1963-07-06 00:00:00	1963-10-17	1963-10-17 00:00:00	32020		\N	308833	0	65363002	372328		0
78446	4643	4112343	1953-02-06	1953-02-06 00:00:00	1953-02-16	1953-02-16 00:00:00	32020		\N	309525	0	195662009	4112343		0
78647	4657	260139	1993-05-05	1993-05-05 00:00:00	1993-05-19	1993-05-19 00:00:00	32020		\N	310505	0	10509002	260139		0
78780	4666	78272	1976-11-09	1976-11-09 00:00:00	1976-12-14	1976-12-14 00:00:00	32020		\N	310943	0	70704007	78272		0
89498	5322	4084167	1963-06-27	1963-06-27 00:00:00	1963-06-27	1963-06-27 00:00:00	32020		\N	354088	0	241929008	4084167		0
79134	4685	195588	1974-08-26	1974-08-26 00:00:00	1974-10-19	1974-10-19 00:00:00	32020		\N	312131	0	38822007	195588		0
89857	5343	4112343	2015-02-19	2015-02-19 00:00:00	2015-03-04	2015-03-04 00:00:00	32020		\N	355944	0	195662009	4112343		0
85499	5083	80180	1984-01-27	1984-01-27 00:00:00	\N	\N	32020		\N	338005	0	396275006	80180		0
79543	4712	4112343	1973-06-23	1973-06-23 00:00:00	1973-07-04	1973-07-04 00:00:00	32020		\N	313782	0	195662009	4112343		0
79773	4724	40481087	2014-10-30	2014-10-30 00:00:00	2014-11-06	2014-11-06 00:00:00	32020		\N	314799	0	444814009	40481087		0
80044	4745	40481087	2017-06-23	2017-06-23 00:00:00	2017-06-30	2017-06-30 00:00:00	32020		\N	315987	0	444814009	40481087		0
80185	4753	28060	1985-05-14	1985-05-14 00:00:00	1985-05-23	1985-05-23 00:00:00	32020		\N	316570	0	43878008	28060		0
80807	4792	81151	1990-09-17	1990-09-17 00:00:00	1990-10-22	1990-10-22 00:00:00	32020		\N	318828	0	44465007	81151		0
81460	4831	81151	1971-04-05	1971-04-05 00:00:00	1971-05-10	1971-05-10 00:00:00	32020		\N	321464	0	44465007	81151		0
81641	4843	40481087	1974-11-30	1974-11-30 00:00:00	1974-12-14	1974-12-14 00:00:00	32020		\N	322113	0	444814009	40481087		0
81706	4847	440086	1950-05-31	1950-05-31 00:00:00	1961-06-07	1961-06-07 00:00:00	32020		\N	322428	0	192127007	440086		0
82001	4861	4283893	1955-07-24	1955-07-24 00:00:00	1955-09-11	1955-09-11 00:00:00	32020		\N	323381	0	36971009	4283893		0
82048	4865	40481087	1991-04-29	1991-04-29 00:00:00	1991-05-06	1991-05-06 00:00:00	32020		\N	323544	0	444814009	40481087		0
82333	4884	372328	1977-05-15	1977-05-15 00:00:00	1977-10-22	1977-10-22 00:00:00	32020		\N	324753	0	65363002	372328		0
82453	4890	40479422	1972-02-10	1972-02-10 00:00:00	1972-03-18	1972-03-18 00:00:00	32020		\N	325145	0	444448004	40479422		0
82631	4905	4112343	1977-08-18	1977-08-18 00:00:00	1977-08-31	1977-08-31 00:00:00	32020		\N	326027	0	195662009	4112343		0
82694	4909	260139	2017-02-07	2017-02-07 00:00:00	2017-02-14	2017-02-14 00:00:00	32020		\N	326259	0	10509002	260139		0
82909	4924	28060	1980-03-07	1980-03-07 00:00:00	1980-03-17	1980-03-17 00:00:00	32020		\N	327149	0	43878008	28060		0
83812	4977	260139	2015-03-31	2015-03-31 00:00:00	2015-04-14	2015-04-14 00:00:00	32020		\N	331114	0	10509002	260139		0
83978	4988	260139	1977-04-17	1977-04-17 00:00:00	1977-04-24	1977-04-24 00:00:00	32020		\N	331844	0	10509002	260139		0
84189	5000	372328	1940-10-19	1940-10-19 00:00:00	1941-01-28	1941-01-28 00:00:00	32020		\N	332519	0	65363002	372328		0
84824	5045	28060	1999-12-08	1999-12-08 00:00:00	1999-12-20	1999-12-20 00:00:00	32020		\N	335287	0	43878008	28060		0
85087	5060	4146173	1994-01-31	1994-01-31 00:00:00	1994-04-01	1994-04-01 00:00:00	32020		\N	336420	0	307731004	4146173		0
85224	5068	4112343	1998-04-05	1998-04-05 00:00:00	1998-04-13	1998-04-13 00:00:00	32020		\N	336924	0	195662009	4112343		0
74863	4447	4112343	1955-09-03	1955-09-03 00:00:00	1955-09-10	1955-09-10 00:00:00	32020		\N	295773	0	195662009	4112343		0
74966	4452	40481087	2016-03-17	2016-03-17 00:00:00	2016-04-07	2016-04-07 00:00:00	32020		\N	296336	0	444814009	40481087		0
75087	4460	80180	1979-10-21	1979-10-21 00:00:00	\N	\N	32020		\N	296814	0	396275006	80180		0
75357	4474	4112343	1998-04-01	1998-04-01 00:00:00	1998-04-12	1998-04-12 00:00:00	32020		\N	297654	0	195662009	4112343		0
64887	3836	80180	2018-12-14	2018-12-14 00:00:00	\N	\N	32020		\N	254735	0	396275006	80180		0
75639	4487	40481087	1996-03-16	1996-03-16 00:00:00	1996-03-23	1996-03-23 00:00:00	32020		\N	298692	0	444814009	40481087		0
75748	4492	4112343	1974-01-09	1974-01-09 00:00:00	1974-01-18	1974-01-18 00:00:00	32020		\N	299073	0	195662009	4112343		0
75918	4503	4294548	2010-07-07	2010-07-07 00:00:00	2010-12-01	2010-12-01 00:00:00	32020		\N	299868	0	75498004	4294548		0
76169	4521	4134304	1996-12-15	1996-12-15 00:00:00	1997-02-13	1997-02-13 00:00:00	32020		\N	301015	0	263102004	4134304		0
86845	5170	81151	1997-08-28	1997-08-28 00:00:00	1997-10-02	1997-10-02 00:00:00	32020		\N	343740	0	44465007	81151		0
87056	5185	28060	1949-10-25	1949-10-25 00:00:00	1949-11-07	1949-11-07 00:00:00	32020		\N	344648	0	43878008	28060		0
76691	4546	378001	2018-07-06	2018-07-06 00:00:00	2018-08-05	2018-08-05 00:00:00	32020		\N	302793	0	62106007	378001		0
76811	4551	4027663	2009-01-18	2009-01-18 00:00:00	\N	\N	32020		\N	303322	0	13200003	4027663		0
76970	4560	40481087	1989-01-05	1989-01-05 00:00:00	1989-01-19	1989-01-19 00:00:00	32020		\N	303851	0	444814009	40481087		0
77070	4565	4112343	1948-03-25	1948-03-25 00:00:00	1948-04-03	1948-04-03 00:00:00	32020		\N	304215	0	195662009	4112343		0
87877	5229	4296204	2007-08-03	2007-08-03 00:00:00	2007-09-07	2007-09-07 00:00:00	32020		\N	347911	0	403190006	4296204		0
88004	5234	81151	1977-09-07	1977-09-07 00:00:00	1977-09-21	1977-09-21 00:00:00	32020		\N	348213	0	44465007	81151		0
88159	5241	40481087	1965-04-16	1965-04-16 00:00:00	1965-04-23	1965-04-23 00:00:00	32020		\N	348754	0	444814009	40481087		0
77803	4608	4112343	1976-06-11	1976-06-11 00:00:00	1976-06-23	1976-06-23 00:00:00	32020		\N	306934	0	195662009	4112343		0
88618	5268	80180	2004-01-04	2004-01-04 00:00:00	\N	\N	32020		\N	350497	0	396275006	80180		0
78161	4630	80180	1993-04-07	1993-04-07 00:00:00	\N	\N	32020		\N	308500	0	396275006	80180		0
78270	4634	4112343	1988-04-20	1988-04-20 00:00:00	1988-05-03	1988-05-03 00:00:00	32020		\N	308822	0	195662009	4112343		0
78447	4644	4155034	1995-08-16	1995-08-16 00:00:00	1995-08-30	1995-08-30 00:00:00	32020		\N	309630	0	283371005	4155034		0
78648	4657	4218389	2002-01-07	2002-01-07 00:00:00	2002-01-28	2002-01-28 00:00:00	32020		\N	310511	0	39848009	4218389		0
78781	4666	40481087	1993-08-29	1993-08-29 00:00:00	1993-09-19	1993-09-19 00:00:00	32020		\N	310932	0	444814009	40481087		0
89537	5325	40481087	1964-02-27	1964-02-27 00:00:00	1964-03-12	1964-03-12 00:00:00	32020		\N	354498	0	444814009	40481087		0
79135	4685	4112343	1944-06-13	1944-06-13 00:00:00	1944-06-20	1944-06-20 00:00:00	32020		\N	312128	0	195662009	4112343		0
89858	5343	40481087	2001-03-16	2001-03-16 00:00:00	2001-03-30	2001-03-30 00:00:00	32020		\N	355824	0	444814009	40481087		0
79544	4712	40481087	2010-05-31	2010-05-31 00:00:00	2010-06-21	2010-06-21 00:00:00	32020		\N	313788	0	444814009	40481087		0
79774	4724	4051466	1945-05-13	1945-05-13 00:00:00	1961-03-29	1961-03-29 00:00:00	32020		\N	314745	0	233678006	4051466		0
80045	4745	4296205	1982-11-12	1982-11-12 00:00:00	1982-12-10	1982-12-10 00:00:00	32020		\N	315991	0	403191005	4296205		0
80186	4753	4112343	1996-11-23	1996-11-23 00:00:00	1996-12-06	1996-12-06 00:00:00	32020		\N	316492	0	195662009	4112343		0
80808	4792	260139	1950-05-21	1950-05-21 00:00:00	1950-06-04	1950-06-04 00:00:00	32020		\N	318830	0	10509002	260139		0
81461	4831	80180	2002-08-05	2002-08-05 00:00:00	\N	\N	32020		\N	321469	0	396275006	80180		0
81642	4844	260139	1990-01-12	1990-01-12 00:00:00	1990-01-19	1990-01-19 00:00:00	32020		\N	322178	0	10509002	260139		0
81707	4847	81151	1959-09-18	1959-09-18 00:00:00	1959-10-09	1959-10-09 00:00:00	32020		\N	322425	0	44465007	81151		0
82002	4861	4112343	1995-12-03	1995-12-03 00:00:00	1995-12-12	1995-12-12 00:00:00	32020		\N	323418	0	195662009	4112343		0
82049	4865	40481087	2004-09-29	2004-09-29 00:00:00	2004-10-06	2004-10-06 00:00:00	32020		\N	323508	0	444814009	40481087		0
82334	4884	4112343	1976-01-16	1976-01-16 00:00:00	1976-01-23	1976-01-23 00:00:00	32020		\N	324727	0	195662009	4112343		0
82454	4890	4112343	2004-11-05	2004-11-05 00:00:00	2004-11-12	2004-11-12 00:00:00	32020		\N	325215	0	195662009	4112343		0
82632	4905	260139	1982-07-11	1982-07-11 00:00:00	1982-07-18	1982-07-18 00:00:00	32020		\N	326033	0	10509002	260139		0
82695	4909	372328	1975-07-16	1975-07-16 00:00:00	1975-09-22	1975-09-22 00:00:00	32020		\N	326245	0	65363002	372328		0
82910	4924	28060	2002-02-09	2002-02-09 00:00:00	2002-02-18	2002-02-18 00:00:00	32020		\N	327176	0	43878008	28060		0
83813	4977	4112343	1970-04-29	1970-04-29 00:00:00	1970-05-06	1970-05-06 00:00:00	32020		\N	331122	0	195662009	4112343		0
83979	4988	4142905	1956-02-05	1956-02-05 00:00:00	1956-04-05	1956-04-05 00:00:00	32020		\N	331792	0	33737001	4142905		0
84190	5000	4112343	1944-08-11	1944-08-11 00:00:00	1944-08-24	1944-08-24 00:00:00	32020		\N	332510	0	195662009	4112343		0
84825	5045	40481087	1982-01-13	1982-01-13 00:00:00	1982-02-03	1982-02-03 00:00:00	32020		\N	335262	0	444814009	40481087		0
85088	5060	40481087	2018-06-22	2018-06-22 00:00:00	2018-06-29	2018-06-29 00:00:00	32020		\N	336446	0	444814009	40481087		0
85225	5068	260139	1962-04-09	1962-04-09 00:00:00	1962-04-16	1962-04-16 00:00:00	32020		\N	336969	0	10509002	260139		0
74864	4447	4278672	1989-06-16	1989-06-16 00:00:00	1989-09-14	1989-09-14 00:00:00	32020		\N	295719	0	65966004	4278672		0
75088	4460	4112343	1954-10-03	1954-10-03 00:00:00	1954-10-12	1954-10-12 00:00:00	32020		\N	296772	0	195662009	4112343		0
75358	4474	4266809	1998-12-15	1998-12-15 00:00:00	\N	\N	32020		\N	297654	0	397881000	4266809		0
64888	3836	260139	1987-11-17	1987-11-17 00:00:00	1987-12-01	1987-12-01 00:00:00	32020		\N	254737	0	10509002	260139		0
75640	4487	40481087	1967-05-25	1967-05-25 00:00:00	1967-06-01	1967-06-01 00:00:00	32020		\N	298747	0	444814009	40481087		0
75749	4492	4237458	1959-05-19	1959-05-19 00:00:00	1959-06-18	1959-06-18 00:00:00	32020		\N	299047	0	58150001	4237458		0
75919	4503	4112343	1987-09-20	1987-09-20 00:00:00	1987-09-27	1987-09-27 00:00:00	32020		\N	299801	0	195662009	4112343		0
76170	4521	40481087	1948-11-05	1948-11-05 00:00:00	1948-11-26	1948-11-26 00:00:00	32020		\N	301003	0	444814009	40481087		0
86846	5170	4059173	1983-04-02	1983-04-02 00:00:00	1983-07-01	1983-07-01 00:00:00	32020		\N	343736	0	16114001	4059173		0
87057	5185	260139	2012-03-23	2012-03-23 00:00:00	2012-03-30	2012-03-30 00:00:00	32020		\N	344708	0	10509002	260139		0
76692	4546	4116491	2005-06-19	2005-06-19 00:00:00	2005-07-22	2005-07-22 00:00:00	32020		\N	302812	0	301011002	4116491		0
76812	4551	372328	1980-09-15	1980-09-15 00:00:00	1980-12-31	1980-12-31 00:00:00	32020		\N	303291	0	65363002	372328		0
76971	4561	4294548	2002-08-23	2002-08-23 00:00:00	2002-09-13	2002-09-13 00:00:00	32020		\N	303940	0	75498004	4294548		0
77071	4565	257012	1966-08-12	1966-08-12 00:00:00	\N	\N	32020		\N	304163	0	40055000	257012		0
87878	5229	4237458	1977-06-20	1977-06-20 00:00:00	1977-08-19	1977-08-19 00:00:00	32020		\N	347867	0	58150001	4237458		0
88005	5234	28060	1936-12-02	1936-12-02 00:00:00	1936-12-15	1936-12-15 00:00:00	32020		\N	348242	0	43878008	28060		0
88160	5241	372328	1981-10-21	1981-10-21 00:00:00	1984-05-29	1984-05-29 00:00:00	32020		\N	348722	0	65363002	372328		0
77804	4608	260139	1962-11-18	1962-11-18 00:00:00	1962-11-25	1962-11-25 00:00:00	32020		\N	306990	0	10509002	260139		0
88619	5268	372328	1965-09-25	1965-09-25 00:00:00	1965-12-05	1965-12-05 00:00:00	32020		\N	350529	0	65363002	372328		0
78162	4630	4285898	1992-07-11	1992-07-11 00:00:00	\N	\N	32020		\N	308500	0	68496003	4285898		0
78271	4634	4155034	1989-09-17	1989-09-17 00:00:00	1989-10-01	1989-10-01 00:00:00	32020		\N	308858	0	283371005	4155034		0
78448	4644	260139	1964-03-27	1964-03-27 00:00:00	1964-04-10	1964-04-10 00:00:00	32020		\N	309661	0	10509002	260139		0
78649	4657	4112343	1973-01-02	1973-01-02 00:00:00	1973-01-10	1973-01-10 00:00:00	32020		\N	310549	0	195662009	4112343		0
78782	4666	40481087	2009-10-01	2009-10-01 00:00:00	2009-10-22	2009-10-22 00:00:00	32020		\N	310933	0	444814009	40481087		0
89538	5325	40481087	2018-09-04	2018-09-04 00:00:00	2018-09-11	2018-09-11 00:00:00	32020		\N	354461	0	444814009	40481087		0
79136	4685	381316	1992-05-25	1992-05-25 00:00:00	\N	\N	32020		\N	312117	0	230690007	381316		0
89859	5343	378001	1997-07-17	1997-07-17 00:00:00	1997-09-15	1997-09-15 00:00:00	32020		\N	355927	0	62106007	378001		0
79545	4712	40481087	1992-10-05	1992-10-05 00:00:00	1992-10-26	1992-10-26 00:00:00	32020		\N	313761	0	444814009	40481087		0
79775	4725	81151	1996-02-19	1996-02-19 00:00:00	1996-03-18	1996-03-18 00:00:00	32020		\N	314866	0	44465007	81151		0
80079	4748	372328	1946-06-28	1946-06-28 00:00:00	1946-09-13	1946-09-13 00:00:00	32020		\N	316208	0	65363002	372328		0
80187	4753	40481087	1985-02-21	1985-02-21 00:00:00	1985-03-14	1985-03-14 00:00:00	32020		\N	316555	0	444814009	40481087		0
80809	4792	257012	1956-04-28	1956-04-28 00:00:00	\N	\N	32020		\N	318832	0	40055000	257012		0
81462	4831	260139	2015-01-15	2015-01-15 00:00:00	2015-01-22	2015-01-22 00:00:00	32020		\N	321431	0	10509002	260139		0
81643	4844	4294548	1993-02-05	1993-02-05 00:00:00	1993-03-05	1993-03-05 00:00:00	32020		\N	322258	0	75498004	4294548		0
81708	4847	81151	1953-09-28	1953-09-28 00:00:00	1953-10-19	1953-10-19 00:00:00	32020		\N	322424	0	44465007	81151		0
82003	4861	4112343	1961-05-19	1961-05-19 00:00:00	1961-05-27	1961-05-27 00:00:00	32020		\N	323355	0	195662009	4112343		0
82050	4865	4149245	1977-11-08	1977-11-08 00:00:00	1978-01-14	1978-01-14 00:00:00	32020		\N	323500	0	30832001	4149245		0
82335	4884	40481087	1998-04-09	1998-04-09 00:00:00	1998-04-16	1998-04-16 00:00:00	32020		\N	324781	0	444814009	40481087		0
82455	4890	78272	2015-05-07	2015-05-07 00:00:00	2015-05-21	2015-05-21 00:00:00	32020		\N	325141	0	70704007	78272		0
82633	4905	4112343	1989-02-15	1989-02-15 00:00:00	1989-02-27	1989-02-27 00:00:00	32020		\N	326037	0	195662009	4112343		0
82747	4913	4112343	2007-04-18	2007-04-18 00:00:00	2007-04-26	2007-04-26 00:00:00	32020		\N	326523	0	195662009	4112343		0
82911	4924	40481087	1992-10-02	1992-10-02 00:00:00	1992-10-09	1992-10-09 00:00:00	32020		\N	327217	0	444814009	40481087		0
83814	4977	4218389	1980-06-01	1980-06-01 00:00:00	1980-07-06	1980-07-06 00:00:00	32020		\N	331109	0	39848009	4218389		0
83980	4988	4112343	2012-04-22	2012-04-22 00:00:00	2012-04-29	2012-04-29 00:00:00	32020		\N	331834	0	195662009	4112343		0
84191	5000	4155034	1947-05-22	1947-05-22 00:00:00	1947-06-12	1947-06-12 00:00:00	32020		\N	332550	0	283371005	4155034		0
84826	5045	28060	1965-07-25	1965-07-25 00:00:00	1965-08-03	1965-08-03 00:00:00	32020		\N	335260	0	43878008	28060		0
85102	5063	260139	2010-05-20	2010-05-20 00:00:00	2010-06-04	2010-06-04 00:00:00	32020		\N	336564	0	10509002	260139		0
85226	5068	40481087	1970-07-15	1970-07-15 00:00:00	1970-08-05	1970-08-05 00:00:00	32020		\N	336922	0	444814009	40481087		0
74865	4447	40481087	1969-09-24	1969-09-24 00:00:00	1969-10-01	1969-10-01 00:00:00	32020		\N	295781	0	444814009	40481087		0
74968	4452	28060	1955-11-03	1955-11-03 00:00:00	1955-11-16	1955-11-16 00:00:00	32020		\N	296242	0	43878008	28060		0
75089	4460	372328	1944-01-18	1944-01-18 00:00:00	1944-03-13	1944-03-13 00:00:00	32020		\N	296799	0	65363002	372328		0
75359	4474	80180	1998-12-15	1998-12-15 00:00:00	\N	\N	32020		\N	297654	0	396275006	80180		0
64889	3836	40481087	1994-02-12	1994-02-12 00:00:00	1994-02-26	1994-02-26 00:00:00	32020		\N	254707	0	444814009	40481087		0
75641	4487	40481087	1953-08-22	1953-08-22 00:00:00	1953-09-12	1953-09-12 00:00:00	32020		\N	298688	0	444814009	40481087		0
75750	4492	260139	1952-06-06	1952-06-06 00:00:00	1952-06-13	1952-06-13 00:00:00	32020		\N	299049	0	10509002	260139		0
75920	4503	257012	2010-09-08	2010-09-08 00:00:00	\N	\N	32020		\N	299829	0	40055000	257012		0
76171	4521	4113008	1951-12-07	1951-12-07 00:00:00	1951-12-28	1951-12-28 00:00:00	32020		\N	301011	0	284549007	4113008		0
86847	5170	81151	1980-03-20	1980-03-20 00:00:00	1980-04-10	1980-04-10 00:00:00	32020		\N	343734	0	44465007	81151		0
87058	5185	4112343	1955-03-26	1955-03-26 00:00:00	1955-04-04	1955-04-04 00:00:00	32020		\N	344635	0	195662009	4112343		0
87151	5190	40481087	1965-01-27	1965-01-27 00:00:00	1965-02-10	1965-02-10 00:00:00	32020		\N	344971	0	444814009	40481087		0
76813	4551	40481087	2017-08-30	2017-08-30 00:00:00	2017-09-13	2017-09-13 00:00:00	32020		\N	303332	0	444814009	40481087		0
76972	4561	4059173	1988-08-20	1988-08-20 00:00:00	1988-11-18	1988-11-18 00:00:00	32020		\N	303948	0	16114001	4059173		0
77072	4565	260139	2012-10-23	2012-10-23 00:00:00	2012-10-30	2012-10-30 00:00:00	32020		\N	304258	0	10509002	260139		0
87879	5229	192671	2004-05-03	2004-05-03 00:00:00	\N	\N	32020		\N	347870	0	K92.2	35208414		0
88006	5234	4027663	1970-08-25	1970-08-25 00:00:00	\N	\N	32020		\N	348252	0	13200003	4027663		0
88161	5241	4112343	1975-08-27	1975-08-27 00:00:00	1975-09-04	1975-09-04 00:00:00	32020		\N	348756	0	195662009	4112343		0
77805	4608	4035415	2008-08-23	2008-08-23 00:00:00	2008-09-22	2008-09-22 00:00:00	32020		\N	307070	0	239720000	4035415		0
88620	5268	195588	2019-06-14	2019-06-14 00:00:00	\N	\N	32020		\N	350513	0	38822007	195588		0
78163	4630	4146173	1995-10-04	1995-10-04 00:00:00	1995-11-03	1995-11-03 00:00:00	32020		\N	308438	0	307731004	4146173		0
78272	4634	28060	2012-03-06	2012-03-06 00:00:00	2012-03-15	2012-03-15 00:00:00	32020		\N	308832	0	43878008	28060		0
78449	4644	317576	1990-11-22	1990-11-22 00:00:00	\N	\N	32020		\N	309632	0	53741008	317576		0
78650	4657	40481087	1991-03-23	1991-03-23 00:00:00	1991-04-13	1991-04-13 00:00:00	32020		\N	310562	0	444814009	40481087		0
78783	4666	80180	2015-04-09	2015-04-09 00:00:00	\N	\N	32020		\N	310967	0	396275006	80180		0
89539	5325	40481087	1960-08-28	1960-08-28 00:00:00	1960-09-11	1960-09-11 00:00:00	32020		\N	354522	0	444814009	40481087		0
79137	4685	260139	1967-05-12	1967-05-12 00:00:00	1967-05-19	1967-05-19 00:00:00	32020		\N	312106	0	10509002	260139		0
89860	5343	4112343	2017-06-23	2017-06-23 00:00:00	2017-07-01	2017-07-01 00:00:00	32020		\N	355945	0	195662009	4112343		0
79546	4712	40481087	1979-11-13	1979-11-13 00:00:00	1979-12-04	1979-12-04 00:00:00	32020		\N	313760	0	444814009	40481087		0
79776	4725	40481087	1997-02-24	1997-02-24 00:00:00	1997-03-17	1997-03-17 00:00:00	32020		\N	314895	0	444814009	40481087		0
80080	4748	40481087	2015-07-04	2015-07-04 00:00:00	2015-07-18	2015-07-18 00:00:00	32020		\N	316133	0	444814009	40481087		0
80188	4753	260139	1965-06-17	1965-06-17 00:00:00	1965-07-01	1965-07-01 00:00:00	32020		\N	316576	0	10509002	260139		0
80810	4792	40481087	1992-11-06	1992-11-06 00:00:00	1992-11-13	1992-11-13 00:00:00	32020		\N	318841	0	444814009	40481087		0
81463	4831	4112343	1973-02-25	1973-02-25 00:00:00	1973-03-06	1973-03-06 00:00:00	32020		\N	321429	0	195662009	4112343		0
81644	4844	40481087	2001-12-01	2001-12-01 00:00:00	2001-12-08	2001-12-08 00:00:00	32020		\N	322219	0	444814009	40481087		0
81709	4847	40481087	1963-05-17	1963-05-17 00:00:00	1963-05-24	1963-05-24 00:00:00	32020		\N	322462	0	444814009	40481087		0
82004	4861	40481087	1956-07-16	1956-07-16 00:00:00	1956-07-30	1956-07-30 00:00:00	32020		\N	323421	0	444814009	40481087		0
82061	4867	4112343	1960-02-19	1960-02-19 00:00:00	1960-02-29	1960-02-29 00:00:00	32020		\N	323607	0	195662009	4112343		0
82336	4884	40481087	2010-01-04	2010-01-04 00:00:00	2010-01-25	2010-01-25 00:00:00	32020		\N	324784	0	444814009	40481087		0
82634	4905	4112343	1977-07-09	1977-07-09 00:00:00	1977-07-17	1977-07-17 00:00:00	32020		\N	326063	0	195662009	4112343		0
82748	4913	40481087	2010-01-21	2010-01-21 00:00:00	2010-01-28	2010-01-28 00:00:00	32020		\N	326524	0	444814009	40481087		0
82912	4924	257012	2016-08-09	2016-08-09 00:00:00	\N	\N	32020		\N	327232	0	40055000	257012		0
83815	4977	4112343	1971-07-31	1971-07-31 00:00:00	1971-08-13	1971-08-13 00:00:00	32020		\N	331197	0	195662009	4112343		0
83981	4988	78272	1983-07-30	1983-07-30 00:00:00	1983-08-20	1983-08-20 00:00:00	32020		\N	331828	0	70704007	78272		0
84192	5000	4294548	2013-06-03	2013-06-03 00:00:00	2013-06-10	2013-06-10 00:00:00	32020		\N	332548	0	75498004	4294548		0
85103	5063	81151	1968-02-12	1968-02-12 00:00:00	1968-03-04	1968-03-04 00:00:00	32020		\N	336599	0	44465007	81151		0
85227	5068	4112343	1953-04-22	1953-04-22 00:00:00	1953-04-29	1953-04-29 00:00:00	32020		\N	336968	0	195662009	4112343		0
74866	4447	372328	1953-07-11	1953-07-11 00:00:00	1953-07-25	1953-07-25 00:00:00	32020		\N	295728	0	65363002	372328		0
74969	4452	260139	1964-04-18	1964-04-18 00:00:00	1964-04-25	1964-04-25 00:00:00	32020		\N	296225	0	10509002	260139		0
75090	4460	4112343	1985-02-08	1985-02-08 00:00:00	1985-02-17	1985-02-17 00:00:00	32020		\N	296776	0	195662009	4112343		0
75360	4474	378001	2013-12-07	2013-12-07 00:00:00	2014-02-05	2014-02-05 00:00:00	32020		\N	297692	0	62106007	378001		0
64890	3836	372328	1981-01-27	1981-01-27 00:00:00	1981-02-20	1981-02-20 00:00:00	32020		\N	254740	0	65363002	372328		0
75642	4487	260139	1997-09-04	1997-09-04 00:00:00	1997-09-11	1997-09-11 00:00:00	32020		\N	298693	0	10509002	260139		0
75751	4492	4283893	1969-11-07	1969-11-07 00:00:00	1970-05-01	1970-05-01 00:00:00	32020		\N	299099	0	36971009	4283893		0
75921	4503	40481087	1957-07-09	1957-07-09 00:00:00	1957-07-23	1957-07-23 00:00:00	32020		\N	299865	0	444814009	40481087		0
76172	4521	40481087	1963-06-11	1963-06-11 00:00:00	1963-07-02	1963-07-02 00:00:00	32020		\N	301004	0	444814009	40481087		0
86848	5170	4112343	2012-05-01	2012-05-01 00:00:00	2012-05-10	2012-05-10 00:00:00	32020		\N	343758	0	195662009	4112343		0
87059	5185	4112343	2011-07-04	2011-07-04 00:00:00	2011-07-13	2011-07-13 00:00:00	32020		\N	344699	0	195662009	4112343		0
87152	5190	40481087	1962-02-23	1962-02-23 00:00:00	1962-03-09	1962-03-09 00:00:00	32020		\N	344972	0	444814009	40481087		0
76814	4551	4283893	2003-09-02	2003-09-02 00:00:00	2003-11-11	2003-11-11 00:00:00	32020		\N	303341	0	36971009	4283893		0
76973	4561	40481087	1958-07-19	1958-07-19 00:00:00	1958-07-26	1958-07-26 00:00:00	32020		\N	303909	0	444814009	40481087		0
77073	4565	4155034	1955-12-13	1955-12-13 00:00:00	1955-12-27	1955-12-27 00:00:00	32020		\N	304210	0	283371005	4155034		0
87880	5229	4283893	2013-02-27	2013-02-27 00:00:00	2013-03-27	2013-03-27 00:00:00	32020		\N	347893	0	36971009	4283893		0
88007	5234	4283893	1960-12-14	1960-12-14 00:00:00	1961-02-15	1961-02-15 00:00:00	32020		\N	348224	0	36971009	4283893		0
88162	5241	28060	1972-01-06	1972-01-06 00:00:00	1972-01-14	1972-01-14 00:00:00	32020		\N	348752	0	43878008	28060		0
77806	4608	4001336	2004-01-19	2004-01-19 00:00:00	2004-03-19	2004-03-19 00:00:00	32020		\N	307068	0	110030002	4001336		0
88621	5268	378001	2012-08-03	2012-08-03 00:00:00	2012-09-02	2012-09-02 00:00:00	32020		\N	350492	0	62106007	378001		0
78164	4630	4283893	1980-03-07	1980-03-07 00:00:00	1980-06-20	1980-06-20 00:00:00	32020		\N	308507	0	36971009	4283893		0
78273	4634	4112343	2015-05-03	2015-05-03 00:00:00	2015-05-14	2015-05-14 00:00:00	32020		\N	308881	0	195662009	4112343		0
78450	4644	4027663	1992-06-27	1992-06-27 00:00:00	\N	\N	32020		\N	309632	0	13200003	4027663		0
78651	4657	40481087	1966-10-12	1966-10-12 00:00:00	1966-11-02	1966-11-02 00:00:00	32020		\N	310559	0	444814009	40481087		0
78784	4666	4296204	2016-09-29	2016-09-29 00:00:00	2016-10-20	2016-10-20 00:00:00	32020		\N	310946	0	403190006	4296204		0
89540	5325	260139	1973-03-16	1973-03-16 00:00:00	1973-03-30	1973-03-30 00:00:00	32020		\N	354492	0	10509002	260139		0
79138	4685	78272	1955-06-08	1955-06-08 00:00:00	1955-07-06	1955-07-06 00:00:00	32020		\N	312152	0	70704007	78272		0
79547	4713	4278672	1970-12-12	1970-12-12 00:00:00	1971-01-11	1971-01-11 00:00:00	32020		\N	313861	0	65966004	4278672		0
79777	4725	40481087	1985-12-14	1985-12-14 00:00:00	1985-12-28	1985-12-28 00:00:00	32020		\N	314869	0	444814009	40481087		0
80081	4748	378001	1954-10-14	1954-10-14 00:00:00	1954-12-13	1954-12-13 00:00:00	32020		\N	316217	0	62106007	378001		0
80189	4753	80180	2003-12-09	2003-12-09 00:00:00	\N	\N	32020		\N	316517	0	396275006	80180		0
80811	4792	4035415	1988-01-01	1988-01-01 00:00:00	1988-01-31	1988-01-31 00:00:00	32020		\N	318827	0	239720000	4035415		0
81464	4831	40481087	1981-01-08	1981-01-08 00:00:00	1981-01-15	1981-01-15 00:00:00	32020		\N	321477	0	444814009	40481087		0
81645	4844	4084167	1973-10-17	1973-10-17 00:00:00	1973-10-17	1973-10-17 00:00:00	32020		\N	322280	0	241929008	4084167		0
81710	4847	81151	1947-05-12	1947-05-12 00:00:00	1947-05-26	1947-05-26 00:00:00	32020		\N	322475	0	44465007	81151		0
82062	4867	381316	2009-08-26	2009-08-26 00:00:00	\N	\N	32020		\N	323695	0	230690007	381316		0
82635	4905	40481087	2007-03-26	2007-03-26 00:00:00	2007-04-02	2007-04-02 00:00:00	32020		\N	326038	0	444814009	40481087		0
82749	4913	260139	2017-09-23	2017-09-23 00:00:00	2017-10-07	2017-10-07 00:00:00	32020		\N	326500	0	10509002	260139		0
82913	4924	260139	2011-05-29	2011-05-29 00:00:00	2011-06-05	2011-06-05 00:00:00	32020		\N	327177	0	10509002	260139		0
83816	4977	198809	2010-12-07	2010-12-07 00:00:00	2010-12-08	2010-12-08 00:00:00	32020		\N	331120	0	65275009	198809		0
83982	4988	4116491	1983-04-14	1983-04-14 00:00:00	1983-06-03	1983-06-03 00:00:00	32020		\N	331845	0	301011002	4116491		0
84193	5000	40481087	1969-05-29	1969-05-29 00:00:00	1969-06-12	1969-06-12 00:00:00	32020		\N	332539	0	444814009	40481087		0
85104	5063	260139	1970-03-03	1970-03-03 00:00:00	1970-03-17	1970-03-17 00:00:00	32020		\N	336568	0	10509002	260139		0
85228	5068	4059173	2007-11-06	2007-11-06 00:00:00	2008-02-04	2008-02-04 00:00:00	32020		\N	336993	0	16114001	4059173		0
85325	5076	260139	1942-02-16	1942-02-16 00:00:00	1942-02-23	1942-02-23 00:00:00	32020		\N	337425	0	10509002	260139		0
74970	4452	4142905	1995-02-06	1995-02-06 00:00:00	1995-04-07	1995-04-07 00:00:00	32020		\N	296346	0	33737001	4142905		0
75091	4460	260139	2009-07-26	2009-07-26 00:00:00	2009-08-02	2009-08-02 00:00:00	32020		\N	296828	0	10509002	260139		0
75361	4474	28060	1973-02-24	1973-02-24 00:00:00	1973-03-09	1973-03-09 00:00:00	32020		\N	297651	0	43878008	28060		0
87513	5207	4285898	1994-07-25	1994-07-25 00:00:00	\N	\N	32020		\N	346393	0	68496003	4285898		0
64891	3836	260139	2008-09-24	2008-09-24 00:00:00	2008-10-01	2008-10-01 00:00:00	32020		\N	254725	0	10509002	260139		0
75643	4487	4113008	1968-06-07	1968-06-07 00:00:00	1968-06-28	1968-06-28 00:00:00	32020		\N	298684	0	284549007	4113008		0
75752	4492	378001	1993-11-07	1993-11-07 00:00:00	1994-01-06	1994-01-06 00:00:00	32020		\N	299094	0	62106007	378001		0
75922	4503	4112343	1977-04-06	1977-04-06 00:00:00	1977-04-13	1977-04-13 00:00:00	32020		\N	299880	0	195662009	4112343		0
76173	4521	4112343	1967-12-03	1967-12-03 00:00:00	1967-12-12	1967-12-12 00:00:00	32020		\N	301018	0	195662009	4112343		0
86849	5170	40481087	1993-10-22	1993-10-22 00:00:00	1993-11-05	1993-11-05 00:00:00	32020		\N	343755	0	444814009	40481087		0
87060	5185	255848	2019-02-18	2019-02-18 00:00:00	\N	\N	32020		\N	344656	0	233604007	255848		0
87153	5190	40481087	1965-12-12	1965-12-12 00:00:00	1965-12-19	1965-12-19 00:00:00	32020		\N	344973	0	444814009	40481087		0
76815	4551	4134304	2001-04-20	2001-04-20 00:00:00	2001-07-19	2001-07-19 00:00:00	32020		\N	303327	0	263102004	4134304		0
76974	4561	28060	1998-03-21	1998-03-21 00:00:00	1998-03-28	1998-03-28 00:00:00	32020		\N	303939	0	43878008	28060		0
77074	4565	40481087	1990-10-08	1990-10-08 00:00:00	1990-10-15	1990-10-15 00:00:00	32020		\N	304219	0	444814009	40481087		0
87881	5229	4112343	1965-10-20	1965-10-20 00:00:00	1965-10-31	1965-10-31 00:00:00	32020		\N	347922	0	195662009	4112343		0
88008	5234	195588	1971-08-25	1971-08-25 00:00:00	1971-10-08	1971-10-08 00:00:00	32020		\N	348220	0	38822007	195588		0
88163	5241	192671	2001-04-15	2001-04-15 00:00:00	\N	\N	32020		\N	348733	0	K92.2	35208414		0
77807	4608	80180	1997-03-25	1997-03-25 00:00:00	\N	\N	32020		\N	307017	0	396275006	80180		0
88622	5268	40481087	2011-07-30	2011-07-30 00:00:00	2011-08-20	2011-08-20 00:00:00	32020		\N	350512	0	444814009	40481087		0
78165	4630	260139	2002-11-14	2002-11-14 00:00:00	2002-11-21	2002-11-21 00:00:00	32020		\N	308476	0	10509002	260139		0
78274	4634	4112343	1970-03-03	1970-03-03 00:00:00	1970-03-12	1970-03-12 00:00:00	32020		\N	308821	0	195662009	4112343		0
78451	4644	40481087	1968-12-09	1968-12-09 00:00:00	1968-12-30	1968-12-30 00:00:00	32020		\N	309659	0	444814009	40481087		0
78652	4657	260139	1987-08-07	1987-08-07 00:00:00	1987-08-21	1987-08-21 00:00:00	32020		\N	310551	0	10509002	260139		0
78785	4666	260139	1984-03-03	1984-03-03 00:00:00	1984-03-10	1984-03-10 00:00:00	32020		\N	310948	0	10509002	260139		0
89541	5325	4112343	1991-04-22	1991-04-22 00:00:00	1991-05-01	1991-05-01 00:00:00	32020		\N	354514	0	195662009	4112343		0
79139	4685	40481087	1945-04-11	1945-04-11 00:00:00	1945-05-02	1945-05-02 00:00:00	32020		\N	312129	0	444814009	40481087		0
79548	4713	81151	1982-08-11	1982-08-11 00:00:00	1982-08-25	1982-08-25 00:00:00	32020		\N	313863	0	44465007	81151		0
79778	4725	81151	1979-07-29	1979-07-29 00:00:00	1979-08-26	1979-08-26 00:00:00	32020		\N	314864	0	44465007	81151		0
80082	4748	4134304	1946-08-27	1946-08-27 00:00:00	1946-11-25	1946-11-25 00:00:00	32020		\N	316139	0	263102004	4134304		0
80190	4753	81151	1970-02-20	1970-02-20 00:00:00	1970-03-06	1970-03-06 00:00:00	32020		\N	316574	0	44465007	81151		0
80812	4792	4283893	2004-01-05	2004-01-05 00:00:00	2004-02-02	2004-02-02 00:00:00	32020		\N	318845	0	36971009	4283893		0
81465	4831	4112343	1962-03-25	1962-03-25 00:00:00	1962-04-04	1962-04-04 00:00:00	32020		\N	321433	0	195662009	4112343		0
81646	4844	40481087	1978-01-06	1978-01-06 00:00:00	1978-01-27	1978-01-27 00:00:00	32020		\N	322197	0	444814009	40481087		0
81711	4847	260139	1959-12-06	1959-12-06 00:00:00	1959-12-20	1959-12-20 00:00:00	32020		\N	322442	0	10509002	260139		0
82063	4867	4112343	1947-08-27	1947-08-27 00:00:00	1947-09-08	1947-09-08 00:00:00	32020		\N	323678	0	195662009	4112343		0
82636	4905	80180	2016-09-04	2016-09-04 00:00:00	\N	\N	32020		\N	326081	0	396275006	80180		0
82750	4913	4112343	1995-04-10	1995-04-10 00:00:00	1995-04-18	1995-04-18 00:00:00	32020		\N	326557	0	195662009	4112343		0
82914	4924	4112343	2014-03-18	2014-03-18 00:00:00	2014-03-26	2014-03-26 00:00:00	32020		\N	327192	0	195662009	4112343		0
83817	4977	196456	2010-12-07	2010-12-07 00:00:00	2010-12-08	2010-12-08 00:00:00	32020		\N	331120	0	235919008	196456		0
83983	4988	40481087	1996-07-25	1996-07-25 00:00:00	1996-08-08	1996-08-08 00:00:00	32020		\N	331825	0	444814009	40481087		0
84194	5000	40481087	1938-10-30	1938-10-30 00:00:00	1938-11-13	1938-11-13 00:00:00	32020		\N	332537	0	444814009	40481087		0
85105	5063	4059173	1957-10-07	1957-10-07 00:00:00	1958-01-05	1958-01-05 00:00:00	32020		\N	336598	0	16114001	4059173		0
85229	5068	313217	2009-11-28	2009-11-28 00:00:00	\N	\N	32020		\N	336939	0	49436004	313217		0
85326	5076	4283893	1957-08-02	1957-08-02 00:00:00	1957-09-13	1957-09-13 00:00:00	32020		\N	337431	0	36971009	4283893		0
74971	4452	260139	1977-01-28	1977-01-28 00:00:00	1977-02-04	1977-02-04 00:00:00	32020		\N	296273	0	10509002	260139		0
75092	4460	40481087	1985-12-31	1985-12-31 00:00:00	1986-01-14	1986-01-14 00:00:00	32020		\N	296817	0	444814009	40481087		0
75362	4474	81151	1980-07-07	1980-07-07 00:00:00	1980-07-28	1980-07-28 00:00:00	32020		\N	297689	0	44465007	81151		0
64892	3836	260139	2007-10-22	2007-10-22 00:00:00	2007-10-29	2007-10-29 00:00:00	32020		\N	254709	0	10509002	260139		0
75644	4487	40481087	1965-06-07	1965-06-07 00:00:00	1965-06-28	1965-06-28 00:00:00	32020		\N	298699	0	444814009	40481087		0
75753	4492	260139	1992-02-06	1992-02-06 00:00:00	1992-02-20	1992-02-20 00:00:00	32020		\N	299101	0	10509002	260139		0
75923	4503	40481087	1999-08-05	1999-08-05 00:00:00	1999-08-12	1999-08-12 00:00:00	32020		\N	299811	0	444814009	40481087		0
76174	4521	40481087	1939-11-12	1939-11-12 00:00:00	1939-11-26	1939-11-26 00:00:00	32020		\N	301045	0	444814009	40481087		0
86850	5170	4112343	1990-03-02	1990-03-02 00:00:00	1990-03-12	1990-03-12 00:00:00	32020		\N	343754	0	195662009	4112343		0
87061	5185	40481087	2012-12-13	2012-12-13 00:00:00	2012-12-27	2012-12-27 00:00:00	32020		\N	344686	0	444814009	40481087		0
87154	5190	40481087	1991-10-22	1991-10-22 00:00:00	1991-11-05	1991-11-05 00:00:00	32020		\N	344995	0	444814009	40481087		0
76816	4551	40481087	2005-10-07	2005-10-07 00:00:00	2005-10-28	2005-10-28 00:00:00	32020		\N	303306	0	444814009	40481087		0
76975	4561	4112343	1969-10-27	1969-10-27 00:00:00	1969-11-03	1969-11-03 00:00:00	32020		\N	303910	0	195662009	4112343		0
77075	4565	260139	2004-11-03	2004-11-03 00:00:00	2004-11-17	2004-11-17 00:00:00	32020		\N	304179	0	10509002	260139		0
87882	5229	4109685	1986-11-30	1986-11-30 00:00:00	1986-12-21	1986-12-21 00:00:00	32020		\N	347868	0	284551006	4109685		0
88009	5234	260139	1995-04-02	1995-04-02 00:00:00	1995-04-16	1995-04-16 00:00:00	32020		\N	348286	0	10509002	260139		0
88164	5241	40481087	1978-11-29	1978-11-29 00:00:00	1978-12-13	1978-12-13 00:00:00	32020		\N	348768	0	444814009	40481087		0
77808	4608	258780	1989-01-26	1989-01-26 00:00:00	\N	\N	32020		\N	307057	0	185086009	258780		0
88623	5268	260139	1979-05-09	1979-05-09 00:00:00	1979-05-16	1979-05-16 00:00:00	32020		\N	350510	0	10509002	260139		0
78166	4630	260139	2009-09-17	2009-09-17 00:00:00	2009-10-01	2009-10-01 00:00:00	32020		\N	308485	0	10509002	260139		0
78275	4634	4112343	2006-02-12	2006-02-12 00:00:00	2006-02-23	2006-02-23 00:00:00	32020		\N	308880	0	195662009	4112343		0
78452	4644	378001	1971-02-18	1971-02-18 00:00:00	1971-04-19	1971-04-19 00:00:00	32020		\N	309628	0	62106007	378001		0
78653	4657	195588	1987-10-01	1987-10-01 00:00:00	1987-11-11	1987-11-11 00:00:00	32020		\N	310552	0	38822007	195588		0
78802	4668	321042	2011-04-26	2011-04-26 00:00:00	\N	\N	32020		\N	311088	0	410429000	321042		0
89542	5325	378419	2018-03-11	2018-03-11 00:00:00	\N	\N	32020		\N	354446	0	26929004	378419		0
79179	4689	4218389	2014-03-06	2014-03-06 00:00:00	2014-03-28	2014-03-28 00:00:00	32020		\N	312395	0	39848009	4218389		0
79549	4713	260139	2000-02-12	2000-02-12 00:00:00	2000-02-26	2000-02-26 00:00:00	32020		\N	313850	0	10509002	260139		0
79779	4725	4112343	1977-05-11	1977-05-11 00:00:00	1977-05-21	1977-05-21 00:00:00	32020		\N	314868	0	195662009	4112343		0
80083	4748	40479768	1997-07-19	1997-07-19 00:00:00	1997-08-25	1997-08-25 00:00:00	32020		\N	316222	0	444470001	40479768		0
80191	4754	78272	1981-02-23	1981-02-23 00:00:00	1981-03-16	1981-03-16 00:00:00	32020		\N	316636	0	70704007	78272		0
80813	4792	40481087	1989-06-25	1989-06-25 00:00:00	1989-07-16	1989-07-16 00:00:00	32020		\N	318864	0	444814009	40481087		0
81466	4831	4296204	2009-10-17	2009-10-17 00:00:00	2009-11-21	2009-11-21 00:00:00	32020		\N	321466	0	403190006	4296204		0
81647	4844	40481087	1994-01-07	1994-01-07 00:00:00	1994-01-14	1994-01-14 00:00:00	32020		\N	322297	0	444814009	40481087		0
81712	4847	372328	1943-11-29	1943-11-29 00:00:00	1944-02-09	1944-02-09 00:00:00	32020		\N	322465	0	65363002	372328		0
82064	4867	40481087	1949-03-15	1949-03-15 00:00:00	1949-03-29	1949-03-29 00:00:00	32020		\N	323679	0	444814009	40481087		0
82637	4905	40481087	1978-08-06	1978-08-06 00:00:00	1978-08-20	1978-08-20 00:00:00	32020		\N	326036	0	444814009	40481087		0
82751	4913	40481087	1975-09-11	1975-09-11 00:00:00	1975-09-18	1975-09-18 00:00:00	32020		\N	326498	0	444814009	40481087		0
82915	4924	4112343	1996-07-04	1996-07-04 00:00:00	1996-07-14	1996-07-14 00:00:00	32020		\N	327250	0	195662009	4112343		0
83818	4977	257012	1976-02-19	1976-02-19 00:00:00	\N	\N	32020		\N	331199	0	40055000	257012		0
83984	4988	40481087	1983-03-02	1983-03-02 00:00:00	1983-03-09	1983-03-09 00:00:00	32020		\N	331799	0	444814009	40481087		0
84195	5000	4059173	2000-06-01	2000-06-01 00:00:00	2000-07-01	2000-07-01 00:00:00	32020		\N	332554	0	16114001	4059173		0
85106	5063	4112343	1973-01-27	1973-01-27 00:00:00	1973-02-05	1973-02-05 00:00:00	32020		\N	336569	0	195662009	4112343		0
85230	5068	372328	1933-10-07	1933-10-07 00:00:00	1933-11-25	1933-11-25 00:00:00	32020		\N	336950	0	65363002	372328		0
85327	5076	4112343	1966-10-09	1966-10-09 00:00:00	1966-10-18	1966-10-18 00:00:00	32020		\N	337410	0	195662009	4112343		0
74972	4452	195588	1978-05-28	1978-05-28 00:00:00	1978-07-17	1978-07-17 00:00:00	32020		\N	296248	0	38822007	195588		0
75093	4460	4155034	1961-03-19	1961-03-19 00:00:00	1961-04-09	1961-04-09 00:00:00	32020		\N	296738	0	283371005	4155034		0
75363	4474	4112343	1965-11-26	1965-11-26 00:00:00	1965-12-08	1965-12-08 00:00:00	32020		\N	297669	0	195662009	4112343		0
64893	3836	40481087	2007-11-11	2007-11-11 00:00:00	2007-11-18	2007-11-18 00:00:00	32020		\N	254724	0	444814009	40481087		0
75645	4487	4112343	2002-09-16	2002-09-16 00:00:00	2002-09-29	2002-09-29 00:00:00	32020		\N	298694	0	195662009	4112343		0
75754	4492	381316	1992-10-27	1992-10-27 00:00:00	\N	\N	32020		\N	299101	0	230690007	381316		0
75924	4503	4112343	1948-03-23	1948-03-23 00:00:00	1948-04-05	1948-04-05 00:00:00	32020		\N	299808	0	195662009	4112343		0
76175	4521	4112343	1968-06-19	1968-06-19 00:00:00	1968-06-29	1968-06-29 00:00:00	32020		\N	301019	0	195662009	4112343		0
86851	5170	40481087	1988-09-26	1988-09-26 00:00:00	1988-10-10	1988-10-10 00:00:00	32020		\N	343772	0	444814009	40481087		0
87062	5185	4142905	2010-09-22	2010-09-22 00:00:00	2010-11-21	2010-11-21 00:00:00	32020		\N	344726	0	33737001	4142905		0
87155	5190	80180	1991-11-12	1991-11-12 00:00:00	\N	\N	32020		\N	344995	0	396275006	80180		0
76817	4551	260139	2016-07-20	2016-07-20 00:00:00	2016-07-27	2016-07-27 00:00:00	32020		\N	303289	0	10509002	260139		0
76976	4561	372328	1961-12-29	1961-12-29 00:00:00	1962-03-21	1962-03-21 00:00:00	32020		\N	303884	0	65363002	372328		0
77076	4565	4156265	2018-11-24	2018-11-24 00:00:00	2018-12-15	2018-12-15 00:00:00	32020		\N	304214	0	370247008	4156265		0
87883	5229	4027663	1993-11-28	1993-11-28 00:00:00	\N	\N	32020		\N	347933	0	13200003	4027663		0
88010	5234	4112343	1948-01-20	1948-01-20 00:00:00	1948-02-02	1948-02-02 00:00:00	32020		\N	348218	0	195662009	4112343		0
88165	5241	4116491	2019-03-13	2019-03-13 00:00:00	2019-04-18	2019-04-18 00:00:00	32020		\N	348727	0	301011002	4116491		0
77809	4608	40481087	2009-02-08	2009-02-08 00:00:00	2009-02-15	2009-02-15 00:00:00	32020		\N	307045	0	444814009	40481087		0
88637	5272	378001	1919-06-04	1919-06-04 00:00:00	1919-07-04	1919-07-04 00:00:00	32020		\N	350708	0	62106007	378001		0
78167	4630	378001	2009-02-22	2009-02-22 00:00:00	2009-03-24	2009-03-24 00:00:00	32020		\N	308523	0	62106007	378001		0
78276	4634	372328	1967-07-02	1967-07-02 00:00:00	1967-10-19	1967-10-19 00:00:00	32020		\N	308883	0	65363002	372328		0
78453	4644	30753	1999-11-18	1999-11-18 00:00:00	\N	\N	32020		\N	309634	0	16761005	30753		0
78654	4657	4112343	1968-05-01	1968-05-01 00:00:00	1968-05-14	1968-05-14 00:00:00	32020		\N	310502	0	195662009	4112343		0
78804	4668	4113008	1998-06-01	1998-06-01 00:00:00	1998-06-15	1998-06-15 00:00:00	32020		\N	311087	0	284549007	4113008		0
89543	5325	40481087	1962-02-09	1962-02-09 00:00:00	1962-03-02	1962-03-02 00:00:00	32020		\N	354457	0	444814009	40481087		0
79180	4689	4152936	1972-01-13	1972-01-13 00:00:00	1972-02-03	1972-02-03 00:00:00	32020		\N	312392	0	283385000	4152936		0
79550	4713	40481087	1979-11-13	1979-11-13 00:00:00	1979-11-20	1979-11-20 00:00:00	32020		\N	313829	0	444814009	40481087		0
79780	4725	40481087	2000-07-08	2000-07-08 00:00:00	2000-07-29	2000-07-29 00:00:00	32020		\N	314977	0	444814009	40481087		0
80084	4748	4059173	1976-03-27	1976-03-27 00:00:00	1976-06-25	1976-06-25 00:00:00	32020		\N	316219	0	16114001	4059173		0
80192	4754	260139	1991-09-13	1991-09-13 00:00:00	1991-09-20	1991-09-20 00:00:00	32020		\N	316613	0	10509002	260139		0
80814	4792	260139	1962-10-30	1962-10-30 00:00:00	1962-11-06	1962-11-06 00:00:00	32020		\N	318876	0	10509002	260139		0
81467	4831	40481087	1988-11-24	1988-11-24 00:00:00	1988-12-08	1988-12-08 00:00:00	32020		\N	321430	0	444814009	40481087		0
81648	4844	40481087	2014-08-18	2014-08-18 00:00:00	2014-08-25	2014-08-25 00:00:00	32020		\N	322220	0	444814009	40481087		0
81713	4847	4294548	2005-03-26	2005-03-26 00:00:00	2005-04-02	2005-04-02 00:00:00	32020		\N	322464	0	75498004	4294548		0
82065	4867	80180	1950-01-14	1950-01-14 00:00:00	\N	\N	32020		\N	323679	0	396275006	80180		0
82641	4907	257012	1974-09-15	1974-09-15 00:00:00	\N	\N	32020		\N	326129	0	40055000	257012		0
82752	4913	81151	2002-06-04	2002-06-04 00:00:00	2002-07-09	2002-07-09 00:00:00	32020		\N	326572	0	44465007	81151		0
82916	4924	78272	1989-04-15	1989-04-15 00:00:00	1989-05-13	1989-05-13 00:00:00	32020		\N	327219	0	70704007	78272		0
83819	4977	4218389	2013-11-09	2013-11-09 00:00:00	2013-12-14	2013-12-14 00:00:00	32020		\N	331121	0	39848009	4218389		0
83985	4988	81893	1989-08-05	1989-08-05 00:00:00	\N	\N	32020		\N	331876	0	64766004	81893		0
84196	5001	40481087	1976-03-11	1976-03-11 00:00:00	1976-04-01	1976-04-01 00:00:00	32020		\N	332637	0	444814009	40481087		0
85107	5063	4116491	1964-03-29	1964-03-29 00:00:00	1964-05-14	1964-05-14 00:00:00	32020		\N	336553	0	301011002	4116491		0
85231	5068	260139	1969-10-26	1969-10-26 00:00:00	1969-11-09	1969-11-09 00:00:00	32020		\N	336970	0	10509002	260139		0
85328	5076	4059173	2005-09-02	2005-09-02 00:00:00	2005-11-01	2005-11-01 00:00:00	32020		\N	337331	0	16114001	4059173		0
74973	4452	4112343	1962-07-29	1962-07-29 00:00:00	1962-08-10	1962-08-10 00:00:00	32020		\N	296210	0	195662009	4112343		0
75094	4460	260139	1987-11-04	1987-11-04 00:00:00	1987-11-11	1987-11-11 00:00:00	32020		\N	296777	0	10509002	260139		0
75364	4474	260139	1994-08-01	1994-08-01 00:00:00	1994-08-08	1994-08-08 00:00:00	32020		\N	297631	0	10509002	260139		0
64894	3836	78272	2015-02-04	2015-02-04 00:00:00	2015-02-18	2015-02-18 00:00:00	32020		\N	254750	0	70704007	78272		0
75646	4487	4112343	1975-10-20	1975-10-20 00:00:00	1975-10-29	1975-10-29 00:00:00	32020		\N	298689	0	195662009	4112343		0
75755	4492	4112343	1996-05-11	1996-05-11 00:00:00	1996-05-21	1996-05-21 00:00:00	32020		\N	299051	0	195662009	4112343		0
75925	4503	260139	1944-07-11	1944-07-11 00:00:00	1944-07-18	1944-07-18 00:00:00	32020		\N	299864	0	10509002	260139		0
76176	4521	4278672	1924-04-02	1924-04-02 00:00:00	1924-07-01	1924-07-01 00:00:00	32020		\N	301008	0	65966004	4278672		0
86852	5170	440086	1979-12-25	1979-12-25 00:00:00	1987-01-02	1987-01-02 00:00:00	32020		\N	343765	0	192127007	440086		0
87063	5185	4156265	1949-08-01	1949-08-01 00:00:00	1949-08-15	1949-08-15 00:00:00	32020		\N	344600	0	370247008	4156265		0
87156	5190	4152936	1962-06-02	1962-06-02 00:00:00	1962-06-23	1962-06-23 00:00:00	32020		\N	345057	0	283385000	4152936		0
87317	5197	81893	1994-08-04	1994-08-04 00:00:00	\N	\N	32020		\N	345584	0	64766004	81893		0
76977	4561	372328	1952-06-30	1952-06-30 00:00:00	1952-09-17	1952-09-17 00:00:00	32020		\N	303923	0	65363002	372328		0
77077	4565	28060	1963-03-30	1963-03-30 00:00:00	1963-04-07	1963-04-07 00:00:00	32020		\N	304162	0	43878008	28060		0
87884	5229	260139	2000-07-16	2000-07-16 00:00:00	2000-07-23	2000-07-23 00:00:00	32020		\N	347892	0	10509002	260139		0
88011	5234	4142905	1989-07-20	1989-07-20 00:00:00	1989-09-18	1989-09-18 00:00:00	32020		\N	348214	0	33737001	4142905		0
88166	5241	40481087	1990-01-04	1990-01-04 00:00:00	1990-01-11	1990-01-11 00:00:00	32020		\N	348770	0	444814009	40481087		0
77810	4608	4112343	1999-02-08	1999-02-08 00:00:00	1999-02-16	1999-02-16 00:00:00	32020		\N	307042	0	195662009	4112343		0
88638	5272	4112343	1918-05-14	1918-05-14 00:00:00	1918-05-26	1918-05-26 00:00:00	32020		\N	350651	0	195662009	4112343		0
78168	4630	4109685	1982-08-08	1982-08-08 00:00:00	1982-08-29	1982-08-29 00:00:00	32020		\N	308521	0	284551006	4109685		0
78277	4634	4112343	1976-11-27	1976-11-27 00:00:00	1976-12-06	1976-12-06 00:00:00	32020		\N	308877	0	195662009	4112343		0
78454	4644	4112343	1980-11-01	1980-11-01 00:00:00	1980-11-10	1980-11-10 00:00:00	32020		\N	309688	0	195662009	4112343		0
78655	4657	372328	1961-08-03	1961-08-03 00:00:00	1961-09-15	1961-09-15 00:00:00	32020		\N	310492	0	65363002	372328		0
78805	4668	40481087	2009-12-25	2009-12-25 00:00:00	2010-01-15	2010-01-15 00:00:00	32020		\N	311091	0	444814009	40481087		0
89544	5325	40481087	1963-02-04	1963-02-04 00:00:00	1963-02-25	1963-02-25 00:00:00	32020		\N	354458	0	444814009	40481087		0
79181	4689	372328	1969-11-13	1969-11-13 00:00:00	1970-04-14	1970-04-14 00:00:00	32020		\N	312417	0	65363002	372328		0
79551	4713	4283893	2015-04-17	2015-04-17 00:00:00	2015-10-09	2015-10-09 00:00:00	32020		\N	313856	0	36971009	4283893		0
79781	4725	40481087	1989-09-15	1989-09-15 00:00:00	1989-09-29	1989-09-29 00:00:00	32020		\N	314961	0	444814009	40481087		0
80085	4748	40481087	1957-04-25	1957-04-25 00:00:00	1957-05-09	1957-05-09 00:00:00	32020		\N	316156	0	444814009	40481087		0
80193	4754	260139	2016-06-28	2016-06-28 00:00:00	2016-07-05	2016-07-05 00:00:00	32020		\N	316616	0	10509002	260139		0
80815	4792	260139	2013-11-10	2013-11-10 00:00:00	2013-11-17	2013-11-17 00:00:00	32020		\N	318874	0	10509002	260139		0
81468	4831	40481087	1962-09-25	1962-09-25 00:00:00	1962-10-09	1962-10-09 00:00:00	32020		\N	321418	0	444814009	40481087		0
81649	4844	4156265	1960-02-21	1960-02-21 00:00:00	1960-03-06	1960-03-06 00:00:00	32020		\N	322278	0	370247008	4156265		0
81714	4847	40479768	1950-12-06	1950-12-06 00:00:00	1951-01-12	1951-01-12 00:00:00	32020		\N	322423	0	444470001	40479768		0
82066	4867	28060	1948-02-09	1948-02-09 00:00:00	1948-02-20	1948-02-20 00:00:00	32020		\N	323665	0	43878008	28060		0
82642	4907	378001	1976-11-05	1976-11-05 00:00:00	1977-01-04	1977-01-04 00:00:00	32020		\N	326203	0	62106007	378001		0
82753	4913	80180	2004-05-25	2004-05-25 00:00:00	\N	\N	32020		\N	326572	0	396275006	80180		0
82917	4924	4294548	2016-07-05	2016-07-05 00:00:00	2016-08-30	2016-08-30 00:00:00	32020		\N	327231	0	75498004	4294548		0
83827	4979	40481087	1999-05-20	1999-05-20 00:00:00	1999-06-03	1999-06-03 00:00:00	32020		\N	331292	0	444814009	40481087		0
83986	4988	30753	1990-04-02	1990-04-02 00:00:00	\N	\N	32020		\N	331876	0	16761005	30753		0
84197	5001	40481087	1966-01-14	1966-01-14 00:00:00	1966-01-21	1966-01-21 00:00:00	32020		\N	332652	0	444814009	40481087		0
85108	5063	260139	1967-05-09	1967-05-09 00:00:00	1967-05-16	1967-05-16 00:00:00	32020		\N	336590	0	10509002	260139		0
85273	5073	255848	2012-06-22	2012-06-22 00:00:00	\N	\N	32020		\N	337257	0	233604007	255848		0
85329	5076	260139	2009-04-02	2009-04-02 00:00:00	2009-04-09	2009-04-09 00:00:00	32020		\N	337401	0	10509002	260139		0
74974	4452	78272	1978-03-23	1978-03-23 00:00:00	1978-04-06	1978-04-06 00:00:00	32020		\N	296345	0	70704007	78272		0
75095	4460	378001	1984-01-09	1984-01-09 00:00:00	1984-02-08	1984-02-08 00:00:00	32020		\N	296739	0	62106007	378001		0
85833	5107	372328	1980-07-10	1980-07-10 00:00:00	1981-05-23	1981-05-23 00:00:00	32020		\N	339349	0	65363002	372328		0
64895	3836	260139	1981-02-12	1981-02-12 00:00:00	1981-02-19	1981-02-19 00:00:00	32020		\N	254751	0	10509002	260139		0
75647	4487	40481087	1981-07-21	1981-07-21 00:00:00	1981-08-11	1981-08-11 00:00:00	32020		\N	298714	0	444814009	40481087		0
75756	4492	372328	1949-06-21	1949-06-21 00:00:00	1949-07-12	1949-07-12 00:00:00	32020		\N	299076	0	65363002	372328		0
75926	4503	372328	1939-01-07	1939-01-07 00:00:00	1939-05-30	1939-05-30 00:00:00	32020		\N	299857	0	65363002	372328		0
76177	4521	80180	1958-10-11	1958-10-11 00:00:00	\N	\N	32020		\N	300979	0	396275006	80180		0
86853	5170	40481087	1988-04-10	1988-04-10 00:00:00	1988-04-24	1988-04-24 00:00:00	32020		\N	343753	0	444814009	40481087		0
87064	5185	260139	1955-03-05	1955-03-05 00:00:00	1955-03-12	1955-03-12 00:00:00	32020		\N	344599	0	10509002	260139		0
87157	5190	40481087	2000-12-23	2000-12-23 00:00:00	2001-01-13	2001-01-13 00:00:00	32020		\N	345043	0	444814009	40481087		0
87318	5197	196456	1962-06-05	1962-06-05 00:00:00	1962-06-06	1962-06-06 00:00:00	32020		\N	345571	0	235919008	196456		0
76978	4561	40481087	1968-01-12	1968-01-12 00:00:00	1968-02-02	1968-02-02 00:00:00	32020		\N	303872	0	444814009	40481087		0
77078	4565	195588	1999-07-25	1999-07-25 00:00:00	1999-09-05	1999-09-05 00:00:00	32020		\N	304166	0	38822007	195588		0
87885	5229	4112343	1975-01-31	1975-01-31 00:00:00	1975-02-07	1975-02-07 00:00:00	32020		\N	347880	0	195662009	4112343		0
88012	5234	40481087	2000-06-02	2000-06-02 00:00:00	2000-06-16	2000-06-16 00:00:00	32020		\N	348270	0	444814009	40481087		0
88167	5241	4112343	2009-03-08	2009-03-08 00:00:00	2009-03-17	2009-03-17 00:00:00	32020		\N	348725	0	195662009	4112343		0
77811	4608	372328	1967-12-08	1967-12-08 00:00:00	1968-12-12	1968-12-12 00:00:00	32020		\N	306960	0	65363002	372328		0
88639	5272	260139	1949-04-29	1949-04-29 00:00:00	1949-05-13	1949-05-13 00:00:00	32020		\N	350670	0	10509002	260139		0
78169	4630	4155034	1993-11-29	1993-11-29 00:00:00	1993-12-13	1993-12-13 00:00:00	32020		\N	308522	0	283371005	4155034		0
78278	4634	4283893	1972-05-23	1972-05-23 00:00:00	1972-06-13	1972-06-13 00:00:00	32020		\N	308829	0	36971009	4283893		0
78455	4644	260139	2007-07-31	2007-07-31 00:00:00	2007-08-14	2007-08-14 00:00:00	32020		\N	309668	0	10509002	260139		0
78656	4657	40479422	1995-06-06	1995-06-06 00:00:00	1995-07-13	1995-07-13 00:00:00	32020		\N	310510	0	444448004	40479422		0
78806	4668	4149245	1987-06-22	1987-06-22 00:00:00	1987-08-28	1987-08-28 00:00:00	32020		\N	311086	0	30832001	4149245		0
89545	5325	4296205	1989-10-22	1989-10-22 00:00:00	1989-11-05	1989-11-05 00:00:00	32020		\N	354439	0	403191005	4296205		0
79182	4689	4112343	2000-08-25	2000-08-25 00:00:00	2000-09-06	2000-09-06 00:00:00	32020		\N	312380	0	195662009	4112343		0
79552	4713	372328	1970-11-12	1970-11-12 00:00:00	1970-12-18	1970-12-18 00:00:00	32020		\N	313853	0	65363002	372328		0
79782	4725	4278672	1975-08-19	1975-08-19 00:00:00	1975-11-17	1975-11-17 00:00:00	32020		\N	314863	0	65966004	4278672		0
80086	4748	40481087	1966-01-21	1966-01-21 00:00:00	1966-02-04	1966-02-04 00:00:00	32020		\N	316130	0	444814009	40481087		0
80194	4754	4283893	2000-05-23	2000-05-23 00:00:00	2000-07-04	2000-07-04 00:00:00	32020		\N	316614	0	36971009	4283893		0
80816	4792	40481087	1993-11-16	1993-11-16 00:00:00	1993-11-30	1993-11-30 00:00:00	32020		\N	318865	0	444814009	40481087		0
81469	4831	40481087	1983-01-13	1983-01-13 00:00:00	1983-01-20	1983-01-20 00:00:00	32020		\N	321420	0	444814009	40481087		0
81650	4844	40481087	1997-06-05	1997-06-05 00:00:00	1997-06-19	1997-06-19 00:00:00	32020		\N	322262	0	444814009	40481087		0
81715	4847	40481087	1950-09-02	1950-09-02 00:00:00	1950-09-16	1950-09-16 00:00:00	32020		\N	322461	0	444814009	40481087		0
82067	4867	378001	2010-01-12	2010-01-12 00:00:00	2010-02-11	2010-02-11 00:00:00	32020		\N	323689	0	62106007	378001		0
82643	4907	260139	1951-02-21	1951-02-21 00:00:00	1951-03-07	1951-03-07 00:00:00	32020		\N	326169	0	10509002	260139		0
82754	4913	40481087	2005-11-29	2005-11-29 00:00:00	2005-12-06	2005-12-06 00:00:00	32020		\N	326533	0	444814009	40481087		0
82918	4924	4296204	2006-11-01	2006-11-01 00:00:00	2006-11-15	2006-11-15 00:00:00	32020		\N	327221	0	403190006	4296204		0
83828	4979	4112343	2017-04-25	2017-04-25 00:00:00	2017-05-08	2017-05-08 00:00:00	32020		\N	331273	0	195662009	4112343		0
83987	4988	80180	1991-04-27	1991-04-27 00:00:00	\N	\N	32020		\N	331868	0	396275006	80180		0
84198	5001	4109685	1970-01-30	1970-01-30 00:00:00	1970-02-20	1970-02-20 00:00:00	32020		\N	332684	0	284551006	4109685		0
85109	5063	378001	1942-02-28	1942-02-28 00:00:00	1942-04-29	1942-04-29 00:00:00	32020		\N	336597	0	62106007	378001		0
85274	5073	40481087	1978-07-13	1978-07-13 00:00:00	1978-08-03	1978-08-03 00:00:00	32020		\N	337185	0	444814009	40481087		0
85330	5076	4112343	1980-12-19	1980-12-19 00:00:00	1981-01-01	1981-01-01 00:00:00	32020		\N	337433	0	195662009	4112343		0
74975	4452	40481087	2003-02-13	2003-02-13 00:00:00	2003-02-20	2003-02-20 00:00:00	32020		\N	296335	0	444814009	40481087		0
75096	4460	260139	1952-07-05	1952-07-05 00:00:00	1952-07-19	1952-07-19 00:00:00	32020		\N	296813	0	10509002	260139		0
85834	5107	81151	1981-12-02	1981-12-02 00:00:00	1981-12-30	1981-12-30 00:00:00	32020		\N	339350	0	44465007	81151		0
64896	3836	440086	1989-03-01	1989-03-01 00:00:00	1995-03-10	1995-03-10 00:00:00	32020		\N	254721	0	192127007	440086		0
75648	4487	260139	1984-11-17	1984-11-17 00:00:00	1984-12-01	1984-12-01 00:00:00	32020		\N	298691	0	10509002	260139		0
75757	4492	40481087	2002-04-18	2002-04-18 00:00:00	2002-05-09	2002-05-09 00:00:00	32020		\N	299103	0	444814009	40481087		0
75927	4503	260139	1973-08-16	1973-08-16 00:00:00	1973-08-23	1973-08-23 00:00:00	32020		\N	299809	0	10509002	260139		0
76178	4521	4112343	2006-10-19	2006-10-19 00:00:00	2006-10-31	2006-10-31 00:00:00	32020		\N	300988	0	195662009	4112343		0
86854	5170	40479768	1981-02-04	1981-02-04 00:00:00	1981-03-13	1981-03-13 00:00:00	32020		\N	343735	0	444470001	40479768		0
87065	5185	40481087	2019-02-17	2019-02-17 00:00:00	\N	\N	32020		\N	344702	0	444814009	40481087		0
87158	5190	4112343	2006-07-19	2006-07-19 00:00:00	2006-07-27	2006-07-27 00:00:00	32020		\N	345044	0	195662009	4112343		0
87319	5197	198809	1962-06-05	1962-06-05 00:00:00	1962-06-06	1962-06-06 00:00:00	32020		\N	345571	0	65275009	198809		0
76979	4561	28060	1959-04-12	1959-04-12 00:00:00	1959-04-20	1959-04-20 00:00:00	32020		\N	303883	0	43878008	28060		0
77079	4565	4112343	1955-03-29	1955-03-29 00:00:00	1955-04-08	1955-04-08 00:00:00	32020		\N	304256	0	195662009	4112343		0
87886	5229	40481087	2017-08-09	2017-08-09 00:00:00	2017-08-23	2017-08-23 00:00:00	32020		\N	347875	0	444814009	40481087		0
88013	5234	4112343	1988-08-28	1988-08-28 00:00:00	1988-09-04	1988-09-04 00:00:00	32020		\N	348268	0	195662009	4112343		0
88168	5241	81151	1976-01-13	1976-01-13 00:00:00	1976-02-10	1976-02-10 00:00:00	32020		\N	348798	0	44465007	81151		0
77812	4608	4116491	1989-12-07	1989-12-07 00:00:00	1990-01-19	1990-01-19 00:00:00	32020		\N	307083	0	301011002	4116491		0
88640	5272	4294548	1971-06-18	1971-06-18 00:00:00	1971-10-01	1971-10-01 00:00:00	32020		\N	350713	0	75498004	4294548		0
78170	4630	260139	2012-01-15	2012-01-15 00:00:00	2012-01-22	2012-01-22 00:00:00	32020		\N	308511	0	10509002	260139		0
78279	4634	28060	1975-10-15	1975-10-15 00:00:00	1975-10-22	1975-10-22 00:00:00	32020		\N	308830	0	43878008	28060		0
78456	4644	257012	1996-01-28	1996-01-28 00:00:00	1996-02-04	1996-02-04 00:00:00	32020		\N	309648	0	40055000	257012		0
78657	4657	40481087	1969-02-26	1969-02-26 00:00:00	1969-03-19	1969-03-19 00:00:00	32020		\N	310560	0	444814009	40481087		0
78807	4668	40481087	2014-09-30	2014-09-30 00:00:00	2014-10-21	2014-10-21 00:00:00	32020		\N	311082	0	444814009	40481087		0
89546	5325	4294548	1980-02-21	1980-02-21 00:00:00	1980-04-24	1980-04-24 00:00:00	32020		\N	354501	0	75498004	4294548		0
89641	5329	378001	1979-04-25	1979-04-25 00:00:00	1979-06-24	1979-06-24 00:00:00	32020		\N	354831	0	62106007	378001		0
79553	4713	40481087	2017-11-03	2017-11-03 00:00:00	2017-11-24	2017-11-24 00:00:00	32020		\N	313852	0	444814009	40481087		0
79783	4725	4048171	1976-09-29	1976-09-29 00:00:00	1993-09-27	1993-09-27 00:00:00	32020		\N	314889	0	232353008	4048171		0
80087	4748	40481087	1988-03-16	1988-03-16 00:00:00	1988-04-06	1988-04-06 00:00:00	32020		\N	316204	0	444814009	40481087		0
80195	4754	4112343	2008-07-14	2008-07-14 00:00:00	2008-07-24	2008-07-24 00:00:00	32020		\N	316656	0	195662009	4112343		0
80832	4795	40481087	2003-08-02	2003-08-02 00:00:00	2003-08-09	2003-08-09 00:00:00	32020		\N	319000	0	444814009	40481087		0
81470	4831	81151	2019-02-16	2019-02-16 00:00:00	2019-03-02	2019-03-02 00:00:00	32020		\N	321482	0	44465007	81151		0
81651	4844	372328	1960-04-21	1960-04-21 00:00:00	1960-05-05	1960-05-05 00:00:00	32020		\N	322268	0	65363002	372328		0
81716	4847	40481087	2008-02-23	2008-02-23 00:00:00	2008-03-15	2008-03-15 00:00:00	32020		\N	322429	0	444814009	40481087		0
82068	4867	40481087	1935-01-20	1935-01-20 00:00:00	1935-02-10	1935-02-10 00:00:00	32020		\N	323606	0	444814009	40481087		0
82644	4907	260139	1982-04-28	1982-04-28 00:00:00	1982-05-05	1982-05-05 00:00:00	32020		\N	326135	0	10509002	260139		0
82755	4913	40481087	1987-08-19	1987-08-19 00:00:00	1987-08-26	1987-08-26 00:00:00	32020		\N	326539	0	444814009	40481087		0
82919	4924	40481087	2018-06-26	2018-06-26 00:00:00	2018-07-10	2018-07-10 00:00:00	32020		\N	327202	0	444814009	40481087		0
83829	4979	40481087	2014-03-08	2014-03-08 00:00:00	2014-03-15	2014-03-15 00:00:00	32020		\N	331272	0	444814009	40481087		0
83988	4988	4266809	1991-04-27	1991-04-27 00:00:00	\N	\N	32020		\N	331868	0	397881000	4266809		0
84199	5001	4237458	1973-05-05	1973-05-05 00:00:00	1973-06-04	1973-06-04 00:00:00	32020		\N	332685	0	58150001	4237458		0
85110	5063	80180	1981-09-11	1981-09-11 00:00:00	\N	\N	32020		\N	336661	0	396275006	80180		0
85275	5073	4112343	1943-02-16	1943-02-16 00:00:00	1943-02-24	1943-02-24 00:00:00	32020		\N	337229	0	195662009	4112343		0
85331	5076	260139	1988-03-13	1988-03-13 00:00:00	1988-03-27	1988-03-27 00:00:00	32020		\N	337422	0	10509002	260139		0
74976	4452	81151	1958-08-16	1958-08-16 00:00:00	1958-08-30	1958-08-30 00:00:00	32020		\N	296342	0	44465007	81151		0
75097	4460	4134304	2012-04-02	2012-04-02 00:00:00	2012-06-01	2012-06-01 00:00:00	32020		\N	296797	0	263102004	4134304		0
85835	5107	40481087	2015-05-04	2015-05-04 00:00:00	2015-05-25	2015-05-25 00:00:00	32020		\N	339321	0	444814009	40481087		0
64897	3836	4112343	1981-06-15	1981-06-15 00:00:00	1981-06-27	1981-06-27 00:00:00	32020		\N	254736	0	195662009	4112343		0
75649	4487	40481087	2006-09-20	2006-09-20 00:00:00	2006-09-27	2006-09-27 00:00:00	32020		\N	298695	0	444814009	40481087		0
75758	4492	4112343	1955-03-08	1955-03-08 00:00:00	1955-03-19	1955-03-19 00:00:00	32020		\N	299071	0	195662009	4112343		0
75928	4503	313217	2014-04-01	2014-04-01 00:00:00	\N	\N	32020		\N	299856	0	49436004	313217		0
76179	4521	4134304	1928-03-12	1928-03-12 00:00:00	1928-05-11	1928-05-11 00:00:00	32020		\N	301009	0	263102004	4134304		0
86855	5170	372328	1973-09-02	1973-09-02 00:00:00	1973-12-07	1973-12-07 00:00:00	32020		\N	343767	0	65363002	372328		0
87066	5185	80180	1968-09-20	1968-09-20 00:00:00	\N	\N	32020		\N	344610	0	396275006	80180		0
87159	5190	378001	2016-01-05	2016-01-05 00:00:00	2016-03-05	2016-03-05 00:00:00	32020		\N	345056	0	62106007	378001		0
87320	5197	40481087	1996-12-14	1996-12-14 00:00:00	1996-12-21	1996-12-21 00:00:00	32020		\N	345635	0	444814009	40481087		0
76980	4561	260139	2015-06-23	2015-06-23 00:00:00	2015-06-30	2015-06-30 00:00:00	32020		\N	303913	0	10509002	260139		0
77080	4565	40481087	1954-05-17	1954-05-17 00:00:00	1954-05-31	1954-05-31 00:00:00	32020		\N	304161	0	444814009	40481087		0
87887	5229	4156265	1968-07-02	1968-07-02 00:00:00	1968-07-23	1968-07-23 00:00:00	32020		\N	347865	0	370247008	4156265		0
88014	5235	40481087	1933-06-19	1933-06-19 00:00:00	1933-07-10	1933-07-10 00:00:00	32020		\N	348301	0	444814009	40481087		0
88169	5241	4152936	2012-10-26	2012-10-26 00:00:00	2012-11-09	2012-11-09 00:00:00	32020		\N	348800	0	283385000	4152936		0
77813	4608	4112343	1981-03-01	1981-03-01 00:00:00	1981-03-11	1981-03-11 00:00:00	32020		\N	307074	0	195662009	4112343		0
88641	5272	28060	1966-12-25	1966-12-25 00:00:00	1967-01-01	1967-01-01 00:00:00	32020		\N	350673	0	43878008	28060		0
78171	4630	81151	1964-11-05	1964-11-05 00:00:00	1964-11-19	1964-11-19 00:00:00	32020		\N	308518	0	44465007	81151		0
78280	4634	28060	1976-09-17	1976-09-17 00:00:00	1976-09-27	1976-09-27 00:00:00	32020		\N	308876	0	43878008	28060		0
78457	4644	192671	2001-02-16	2001-02-16 00:00:00	\N	\N	32020		\N	309697	0	K92.2	35208414		0
78658	4657	375671	2013-06-29	2013-06-29 00:00:00	2013-07-29	2013-07-29 00:00:00	32020		\N	310512	0	62564004	375671		0
89547	5325	4059173	1955-01-10	1955-01-10 00:00:00	1955-02-09	1955-02-09 00:00:00	32020		\N	354437	0	16114001	4059173		0
89642	5329	40481087	1967-05-13	1967-05-13 00:00:00	1967-05-20	1967-05-20 00:00:00	32020		\N	354745	0	444814009	40481087		0
79554	4713	375671	1976-10-11	1976-10-11 00:00:00	1976-12-10	1976-12-10 00:00:00	32020		\N	313862	0	62564004	375671		0
79784	4725	80180	2009-07-31	2009-07-31 00:00:00	\N	\N	32020		\N	314929	0	396275006	80180		0
80088	4748	4112343	1963-07-14	1963-07-14 00:00:00	1963-07-27	1963-07-27 00:00:00	32020		\N	316162	0	195662009	4112343		0
80196	4754	40481087	1975-07-24	1975-07-24 00:00:00	1975-07-31	1975-07-31 00:00:00	32020		\N	316655	0	444814009	40481087		0
80833	4795	80180	2005-10-09	2005-10-09 00:00:00	\N	\N	32020		\N	319000	0	396275006	80180		0
81471	4831	372328	1965-11-25	1965-11-25 00:00:00	1966-04-07	1966-04-07 00:00:00	32020		\N	321451	0	65363002	372328		0
81652	4844	81151	2011-11-09	2011-11-09 00:00:00	2011-11-30	2011-11-30 00:00:00	32020		\N	322284	0	44465007	81151		0
81717	4847	260139	1996-04-11	1996-04-11 00:00:00	1996-04-18	1996-04-18 00:00:00	32020		\N	322463	0	10509002	260139		0
82069	4867	4059173	1926-11-01	1926-11-01 00:00:00	1927-01-30	1927-01-30 00:00:00	32020		\N	323682	0	16114001	4059173		0
82645	4907	4112343	1949-05-20	1949-05-20 00:00:00	1949-05-28	1949-05-28 00:00:00	32020		\N	326168	0	195662009	4112343		0
82756	4913	40481087	1988-11-26	1988-11-26 00:00:00	1988-12-03	1988-12-03 00:00:00	32020		\N	326556	0	444814009	40481087		0
82920	4924	80180	2014-01-19	2014-01-19 00:00:00	\N	\N	32020		\N	327222	0	396275006	80180		0
83830	4979	4113008	1996-01-10	1996-01-10 00:00:00	1996-01-24	1996-01-24 00:00:00	32020		\N	331244	0	284549007	4113008		0
83989	4988	4113008	1960-09-11	1960-09-11 00:00:00	1960-09-25	1960-09-25 00:00:00	32020		\N	331793	0	284549007	4113008		0
84200	5001	28060	1969-12-19	1969-12-19 00:00:00	1969-12-27	1969-12-27 00:00:00	32020		\N	332647	0	43878008	28060		0
85111	5063	4266809	1981-09-11	1981-09-11 00:00:00	\N	\N	32020		\N	336661	0	397881000	4266809		0
85276	5073	260139	1970-03-08	1970-03-08 00:00:00	1970-03-15	1970-03-15 00:00:00	32020		\N	337246	0	10509002	260139		0
85332	5076	440086	1946-03-06	1946-03-06 00:00:00	1947-06-25	1947-06-25 00:00:00	32020		\N	337407	0	192127007	440086		0
74977	4452	28060	1958-05-07	1958-05-07 00:00:00	1958-05-17	1958-05-17 00:00:00	32020		\N	296244	0	43878008	28060		0
75098	4460	260139	2008-08-21	2008-08-21 00:00:00	2008-08-28	2008-08-28 00:00:00	32020		\N	296798	0	10509002	260139		0
85836	5107	4218389	1987-01-03	1987-01-03 00:00:00	1987-01-31	1987-01-31 00:00:00	32020		\N	339351	0	39848009	4218389		0
64898	3836	4112343	1998-06-29	1998-06-29 00:00:00	1998-07-11	1998-07-11 00:00:00	32020		\N	254722	0	195662009	4112343		0
75650	4487	372328	1950-08-29	1950-08-29 00:00:00	1951-02-16	1951-02-16 00:00:00	32020		\N	298759	0	65363002	372328		0
75759	4492	78272	1949-06-21	1949-06-21 00:00:00	1949-07-19	1949-07-19 00:00:00	32020		\N	299045	0	70704007	78272		0
75929	4503	4149245	2001-02-10	2001-02-10 00:00:00	2001-03-19	2001-03-19 00:00:00	32020		\N	299862	0	30832001	4149245		0
76180	4521	4112343	1942-02-28	1942-02-28 00:00:00	1942-03-09	1942-03-09 00:00:00	32020		\N	301046	0	195662009	4112343		0
86856	5170	4112343	2007-07-23	2007-07-23 00:00:00	2007-08-05	2007-08-05 00:00:00	32020		\N	343756	0	195662009	4112343		0
87067	5185	40481087	1943-11-27	1943-11-27 00:00:00	1943-12-04	1943-12-04 00:00:00	32020		\N	344597	0	444814009	40481087		0
87160	5190	4142905	1969-04-01	1969-04-01 00:00:00	1969-05-31	1969-05-31 00:00:00	32020		\N	345059	0	33737001	4142905		0
87321	5197	192671	1995-11-12	1995-11-12 00:00:00	\N	\N	32020		\N	345574	0	K92.2	35208414		0
76981	4561	4285898	1983-12-25	1983-12-25 00:00:00	\N	\N	32020		\N	303890	0	68496003	4285898		0
77081	4565	4112343	1993-11-08	1993-11-08 00:00:00	1993-11-21	1993-11-21 00:00:00	32020		\N	304224	0	195662009	4112343		0
87888	5229	372328	1963-11-26	1963-11-26 00:00:00	1964-05-13	1964-05-13 00:00:00	32020		\N	347894	0	65363002	372328		0
88015	5235	4112343	1956-04-20	1956-04-20 00:00:00	1956-05-03	1956-05-03 00:00:00	32020		\N	348319	0	195662009	4112343		0
88170	5242	40481087	1975-05-26	1975-05-26 00:00:00	1975-06-16	1975-06-16 00:00:00	32020		\N	348849	0	444814009	40481087		0
77814	4608	40481087	2000-04-27	2000-04-27 00:00:00	2000-05-11	2000-05-11 00:00:00	32020		\N	307043	0	444814009	40481087		0
88642	5272	260139	2015-07-29	2015-07-29 00:00:00	2015-08-05	2015-08-05 00:00:00	32020		\N	350658	0	10509002	260139		0
78172	4630	40481087	1970-06-30	1970-06-30 00:00:00	1970-07-21	1970-07-21 00:00:00	32020		\N	308506	0	444814009	40481087		0
78281	4634	28060	1989-06-30	1989-06-30 00:00:00	1989-07-09	1989-07-09 00:00:00	32020		\N	308878	0	43878008	28060		0
78458	4644	372328	1965-03-08	1965-03-08 00:00:00	1965-06-10	1965-06-10 00:00:00	32020		\N	309680	0	65363002	372328		0
78659	4657	40481087	1985-03-04	1985-03-04 00:00:00	1985-03-18	1985-03-18 00:00:00	32020		\N	310515	0	444814009	40481087		0
78809	4668	40481087	1979-03-08	1979-03-08 00:00:00	1979-03-15	1979-03-15 00:00:00	32020		\N	311070	0	444814009	40481087		0
89548	5325	4156265	1952-01-05	1952-01-05 00:00:00	1952-01-26	1952-01-26 00:00:00	32020		\N	354436	0	370247008	4156265		0
89643	5329	4109685	2000-09-22	2000-09-22 00:00:00	2000-10-06	2000-10-06 00:00:00	32020		\N	354833	0	284551006	4109685		0
79555	4713	4283893	1976-08-20	1976-08-20 00:00:00	1977-02-04	1977-02-04 00:00:00	32020		\N	313836	0	36971009	4283893		0
79785	4725	195588	2000-09-16	2000-09-16 00:00:00	2000-10-27	2000-10-27 00:00:00	32020		\N	314881	0	38822007	195588		0
80089	4748	260139	1995-12-28	1995-12-28 00:00:00	1996-01-11	1996-01-11 00:00:00	32020		\N	316142	0	10509002	260139		0
80197	4754	40481087	1985-12-26	1985-12-26 00:00:00	1986-01-02	1986-01-02 00:00:00	32020		\N	316642	0	444814009	40481087		0
80834	4795	4116491	1995-10-27	1995-10-27 00:00:00	1995-12-23	1995-12-23 00:00:00	32020		\N	318994	0	301011002	4116491		0
81472	4831	40481087	2016-04-21	2016-04-21 00:00:00	2016-04-28	2016-04-28 00:00:00	32020		\N	321432	0	444814009	40481087		0
81653	4844	40481087	1978-08-24	1978-08-24 00:00:00	1978-09-14	1978-09-14 00:00:00	32020		\N	322228	0	444814009	40481087		0
81718	4848	28060	1963-11-30	1963-11-30 00:00:00	1963-12-10	1963-12-10 00:00:00	32020		\N	322545	0	43878008	28060		0
82070	4867	40481087	1945-10-19	1945-10-19 00:00:00	1945-10-26	1945-10-26 00:00:00	32020		\N	323595	0	444814009	40481087		0
82646	4907	4155034	1964-06-27	1964-06-27 00:00:00	1964-07-11	1964-07-11 00:00:00	32020		\N	326202	0	283371005	4155034		0
82757	4913	260139	1995-12-17	1995-12-17 00:00:00	1995-12-31	1995-12-31 00:00:00	32020		\N	326558	0	10509002	260139		0
82921	4924	78272	2013-03-13	2013-03-13 00:00:00	2013-04-17	2013-04-17 00:00:00	32020		\N	327222	0	70704007	78272		0
83990	4988	28060	2006-12-10	2006-12-10 00:00:00	2006-12-17	2006-12-17 00:00:00	32020		\N	331833	0	43878008	28060		0
84201	5001	40481087	1968-07-17	1968-07-17 00:00:00	1968-07-31	1968-07-31 00:00:00	32020		\N	332646	0	444814009	40481087		0
85112	5063	40481087	1970-02-25	1970-02-25 00:00:00	1970-03-04	1970-03-04 00:00:00	32020		\N	336567	0	444814009	40481087		0
85277	5073	378419	2007-08-18	2007-08-18 00:00:00	\N	\N	32020		\N	337181	0	26929004	378419		0
85333	5076	40481087	2012-03-18	2012-03-18 00:00:00	2012-04-08	2012-04-08 00:00:00	32020		\N	337434	0	444814009	40481087		0
74978	4452	40481087	1973-08-01	1973-08-01 00:00:00	1973-08-15	1973-08-15 00:00:00	32020		\N	296246	0	444814009	40481087		0
75099	4460	260139	2006-08-24	2006-08-24 00:00:00	2006-09-07	2006-09-07 00:00:00	32020		\N	296827	0	10509002	260139		0
85837	5107	4283893	2002-09-19	2002-09-19 00:00:00	2002-10-31	2002-10-31 00:00:00	32020		\N	339340	0	36971009	4283893		0
64899	3836	4155034	1984-10-23	1984-10-23 00:00:00	1984-11-13	1984-11-13 00:00:00	32020		\N	254748	0	283371005	4155034		0
75651	4487	40481087	1994-06-27	1994-06-27 00:00:00	1994-07-04	1994-07-04 00:00:00	32020		\N	298720	0	444814009	40481087		0
75760	4492	4294548	2012-09-19	2012-09-19 00:00:00	2012-12-19	2012-12-19 00:00:00	32020		\N	299104	0	75498004	4294548		0
75930	4503	4112343	1992-04-07	1992-04-07 00:00:00	1992-04-19	1992-04-19 00:00:00	32020		\N	299881	0	195662009	4112343		0
76181	4521	4142905	1972-05-11	1972-05-11 00:00:00	1972-08-09	1972-08-09 00:00:00	32020		\N	301012	0	33737001	4142905		0
86857	5170	4112343	1991-07-07	1991-07-07 00:00:00	1991-07-16	1991-07-16 00:00:00	32020		\N	343794	0	195662009	4112343		0
87068	5185	40481087	2014-07-27	2014-07-27 00:00:00	2014-08-03	2014-08-03 00:00:00	32020		\N	344687	0	444814009	40481087		0
87161	5191	195588	2018-08-08	2018-08-08 00:00:00	2018-09-13	2018-09-13 00:00:00	32020		\N	345109	0	38822007	195588		0
87322	5197	40481087	1976-05-10	1976-05-10 00:00:00	1976-05-31	1976-05-31 00:00:00	32020		\N	345582	0	444814009	40481087		0
76982	4561	4310024	1982-10-31	1982-10-31 00:00:00	\N	\N	32020		\N	303890	0	424802006	4310024		0
77082	4565	80180	1981-10-17	1981-10-17 00:00:00	\N	\N	32020		\N	304248	0	396275006	80180		0
87889	5229	260139	2001-12-17	2001-12-17 00:00:00	2001-12-31	2001-12-31 00:00:00	32020		\N	347925	0	10509002	260139		0
88016	5235	4112343	1939-03-22	1939-03-22 00:00:00	1939-04-02	1939-04-02 00:00:00	32020		\N	348302	0	195662009	4112343		0
88171	5242	28060	2017-05-12	2017-05-12 00:00:00	2017-05-21	2017-05-21 00:00:00	32020		\N	348845	0	43878008	28060		0
77815	4608	4134304	1992-06-20	1992-06-20 00:00:00	1992-08-19	1992-08-19 00:00:00	32020		\N	307067	0	263102004	4134304		0
88643	5272	257012	1971-08-20	1971-08-20 00:00:00	\N	\N	32020		\N	350611	0	40055000	257012		0
78173	4630	195588	1983-01-20	1983-01-20 00:00:00	1983-03-10	1983-03-10 00:00:00	32020		\N	308480	0	38822007	195588		0
78282	4634	40481087	1964-09-03	1964-09-03 00:00:00	1964-09-24	1964-09-24 00:00:00	32020		\N	308838	0	444814009	40481087		0
78459	4644	40481087	1993-03-29	1993-03-29 00:00:00	1993-04-05	1993-04-05 00:00:00	32020		\N	309647	0	444814009	40481087		0
78660	4657	28060	1982-05-25	1982-05-25 00:00:00	1982-06-03	1982-06-03 00:00:00	32020		\N	310561	0	43878008	28060		0
78810	4668	40481087	2004-09-06	2004-09-06 00:00:00	2004-09-20	2004-09-20 00:00:00	32020		\N	311080	0	444814009	40481087		0
89549	5325	4059173	1948-11-21	1948-11-21 00:00:00	1948-12-21	1948-12-21 00:00:00	32020		\N	354435	0	16114001	4059173		0
89644	5329	4116491	1996-01-16	1996-01-16 00:00:00	1996-02-16	1996-02-16 00:00:00	32020		\N	354759	0	301011002	4116491		0
79556	4713	4112343	1973-08-14	1973-08-14 00:00:00	1973-08-27	1973-08-27 00:00:00	32020		\N	313835	0	195662009	4112343		0
79786	4725	40481087	1976-07-21	1976-07-21 00:00:00	1976-07-28	1976-07-28 00:00:00	32020		\N	314910	0	444814009	40481087		0
80090	4748	4112343	1946-11-27	1946-11-27 00:00:00	1946-12-08	1946-12-08 00:00:00	32020		\N	316160	0	195662009	4112343		0
80198	4754	28060	1972-03-13	1972-03-13 00:00:00	1972-03-25	1972-03-25 00:00:00	32020		\N	316639	0	43878008	28060		0
80835	4795	260139	1977-11-22	1977-11-22 00:00:00	1977-12-06	1977-12-06 00:00:00	32020		\N	319021	0	10509002	260139		0
81473	4831	81151	2015-05-24	2015-05-24 00:00:00	2015-06-07	2015-06-07 00:00:00	32020		\N	321481	0	44465007	81151		0
81654	4844	260139	2001-09-12	2001-09-12 00:00:00	2001-09-19	2001-09-19 00:00:00	32020		\N	322218	0	10509002	260139		0
81719	4848	4112343	2018-04-10	2018-04-10 00:00:00	2018-04-18	2018-04-18 00:00:00	32020		\N	322550	0	195662009	4112343		0
82071	4867	40481087	1941-10-12	1941-10-12 00:00:00	1941-11-02	1941-11-02 00:00:00	32020		\N	323594	0	444814009	40481087		0
82647	4907	40481087	1996-06-09	1996-06-09 00:00:00	1996-06-30	1996-06-30 00:00:00	32020		\N	326159	0	444814009	40481087		0
82758	4913	4112343	1989-11-26	1989-11-26 00:00:00	1989-12-05	1989-12-05 00:00:00	32020		\N	326522	0	195662009	4112343		0
82922	4924	4048171	1982-12-20	1982-12-20 00:00:00	\N	\N	32020		\N	327209	0	232353008	4048171		0
83991	4988	40481087	2002-08-27	2002-08-27 00:00:00	2002-09-03	2002-09-03 00:00:00	32020		\N	331846	0	444814009	40481087		0
84202	5001	80180	1997-01-03	1997-01-03 00:00:00	\N	\N	32020		\N	332664	0	396275006	80180		0
85113	5063	260139	1944-05-20	1944-05-20 00:00:00	1944-05-27	1944-05-27 00:00:00	32020		\N	336532	0	10509002	260139		0
85278	5073	40481087	1956-02-15	1956-02-15 00:00:00	1956-02-22	1956-02-22 00:00:00	32020		\N	337184	0	444814009	40481087		0
85334	5076	80180	1976-04-17	1976-04-17 00:00:00	\N	\N	32020		\N	337387	0	396275006	80180		0
74979	4452	260139	1987-07-15	1987-07-15 00:00:00	1987-07-22	1987-07-22 00:00:00	32020		\N	296249	0	10509002	260139		0
75100	4460	40481087	1981-12-18	1981-12-18 00:00:00	1981-12-25	1981-12-25 00:00:00	32020		\N	296826	0	444814009	40481087		0
85838	5107	4112343	1994-06-29	1994-06-29 00:00:00	1994-07-10	1994-07-10 00:00:00	32020		\N	339333	0	195662009	4112343		0
64900	3836	372328	1977-08-01	1977-08-01 00:00:00	1977-11-11	1977-11-11 00:00:00	32020		\N	254726	0	65363002	372328		0
75652	4487	40481087	1990-01-26	1990-01-26 00:00:00	1990-02-09	1990-02-09 00:00:00	32020		\N	298719	0	444814009	40481087		0
75761	4492	81151	1981-03-24	1981-03-24 00:00:00	1981-04-14	1981-04-14 00:00:00	32020		\N	299092	0	44465007	81151		0
75931	4503	40481087	1939-10-28	1939-10-28 00:00:00	1939-11-04	1939-11-04 00:00:00	32020		\N	299879	0	444814009	40481087		0
76182	4521	260139	1996-05-06	1996-05-06 00:00:00	1996-05-20	1996-05-20 00:00:00	32020		\N	300983	0	10509002	260139		0
86858	5170	4112343	1979-06-05	1979-06-05 00:00:00	1979-06-13	1979-06-13 00:00:00	32020		\N	343764	0	195662009	4112343		0
87069	5185	28060	1948-06-19	1948-06-19 00:00:00	1948-07-01	1948-07-01 00:00:00	32020		\N	344634	0	43878008	28060		0
87162	5191	260139	1998-03-06	1998-03-06 00:00:00	1998-03-20	1998-03-20 00:00:00	32020		\N	345089	0	10509002	260139		0
87323	5197	4109685	1995-08-28	1995-08-28 00:00:00	1995-09-18	1995-09-18 00:00:00	32020		\N	345576	0	284551006	4109685		0
76983	4561	30753	1983-10-26	1983-10-26 00:00:00	\N	\N	32020		\N	303890	0	16761005	30753		0
77083	4565	4296205	1961-06-28	1961-06-28 00:00:00	1961-07-19	1961-07-19 00:00:00	32020		\N	304207	0	403191005	4296205		0
87890	5229	40481087	1967-09-14	1967-09-14 00:00:00	1967-10-05	1967-10-05 00:00:00	32020		\N	347923	0	444814009	40481087		0
88017	5235	4285898	1960-02-29	1960-02-29 00:00:00	\N	\N	32020		\N	348310	0	68496003	4285898		0
88172	5242	260139	1993-10-30	1993-10-30 00:00:00	1993-11-13	1993-11-13 00:00:00	32020		\N	348804	0	10509002	260139		0
77816	4608	40479768	1987-10-08	1987-10-08 00:00:00	1987-11-14	1987-11-14 00:00:00	32020		\N	307066	0	444470001	40479768		0
88644	5272	40481087	2012-02-08	2012-02-08 00:00:00	2012-02-15	2012-02-15 00:00:00	32020		\N	350614	0	444814009	40481087		0
78174	4630	4027663	1983-01-20	1983-01-20 00:00:00	\N	\N	32020		\N	308480	0	13200003	4027663		0
78289	4636	260139	1963-10-18	1963-10-18 00:00:00	1963-10-25	1963-10-25 00:00:00	32020		\N	308933	0	10509002	260139		0
78460	4644	260139	1981-07-01	1981-07-01 00:00:00	1981-07-15	1981-07-15 00:00:00	32020		\N	309646	0	10509002	260139		0
78661	4657	80180	1999-02-15	1999-02-15 00:00:00	\N	\N	32020		\N	310568	0	396275006	80180		0
78811	4668	40481087	1995-01-20	1995-01-20 00:00:00	1995-01-27	1995-01-27 00:00:00	32020		\N	311105	0	444814009	40481087		0
89550	5325	40481087	1967-06-03	1967-06-03 00:00:00	1967-06-24	1967-06-24 00:00:00	32020		\N	354499	0	444814009	40481087		0
89645	5329	40481087	2003-06-05	2003-06-05 00:00:00	2003-06-12	2003-06-12 00:00:00	32020		\N	354762	0	444814009	40481087		0
79557	4713	257012	1976-11-19	1976-11-19 00:00:00	\N	\N	32020		\N	313848	0	40055000	257012		0
79787	4725	4218389	1988-09-07	1988-09-07 00:00:00	1988-09-28	1988-09-28 00:00:00	32020		\N	314865	0	39848009	4218389		0
80091	4748	4112343	1969-12-23	1969-12-23 00:00:00	1970-01-05	1970-01-05 00:00:00	32020		\N	316211	0	195662009	4112343		0
80199	4754	4112343	1994-04-12	1994-04-12 00:00:00	1994-04-25	1994-04-25 00:00:00	32020		\N	316592	0	195662009	4112343		0
80836	4795	81151	2001-02-27	2001-02-27 00:00:00	2001-04-03	2001-04-03 00:00:00	32020		\N	319045	0	44465007	81151		0
81474	4831	260139	1991-12-18	1991-12-18 00:00:00	1992-01-01	1992-01-01 00:00:00	32020		\N	321435	0	10509002	260139		0
81655	4844	40481087	1976-12-29	1976-12-29 00:00:00	1977-01-05	1977-01-05 00:00:00	32020		\N	322193	0	444814009	40481087		0
81720	4848	4112343	1986-07-15	1986-07-15 00:00:00	1986-07-22	1986-07-22 00:00:00	32020		\N	322496	0	195662009	4112343		0
82072	4867	40481087	1991-04-19	1991-04-19 00:00:00	1991-04-26	1991-04-26 00:00:00	32020		\N	323669	0	444814009	40481087		0
82648	4907	260139	1949-09-16	1949-09-16 00:00:00	1949-09-30	1949-09-30 00:00:00	32020		\N	326099	0	10509002	260139		0
89748	5335	80180	1992-10-01	1992-10-01 00:00:00	\N	\N	32020		\N	355279	0	396275006	80180		0
82759	4913	40481087	1986-02-28	1986-02-28 00:00:00	1986-03-21	1986-03-21 00:00:00	32020		\N	326538	0	444814009	40481087		0
82923	4924	28060	1985-05-24	1985-05-24 00:00:00	1985-06-01	1985-06-01 00:00:00	32020		\N	327279	0	43878008	28060		0
83992	4988	78272	1967-05-22	1967-05-22 00:00:00	1967-06-19	1967-06-19 00:00:00	32020		\N	331794	0	70704007	78272		0
84203	5001	40481087	1974-02-05	1974-02-05 00:00:00	1974-02-12	1974-02-12 00:00:00	32020		\N	332617	0	444814009	40481087		0
85114	5063	4112343	1954-11-23	1954-11-23 00:00:00	1954-12-02	1954-12-02 00:00:00	32020		\N	336628	0	195662009	4112343		0
85280	5073	313217	2001-07-14	2001-07-14 00:00:00	\N	\N	32020		\N	337206	0	49436004	313217		0
85335	5076	4266809	1976-04-17	1976-04-17 00:00:00	\N	\N	32020		\N	337387	0	397881000	4266809		0
74980	4452	40481087	2012-05-08	2012-05-08 00:00:00	2012-05-29	2012-05-29 00:00:00	32020		\N	296291	0	444814009	40481087		0
75101	4460	4278672	2003-07-19	2003-07-19 00:00:00	2003-08-18	2003-08-18 00:00:00	32020		\N	296741	0	65966004	4278672		0
85839	5107	192671	2011-07-09	2011-07-09 00:00:00	\N	\N	32020		\N	339318	0	K92.2	35208414		0
64901	3836	40481087	2019-02-25	2019-02-25 00:00:00	2019-03-04	2019-03-04 00:00:00	32020		\N	254753	0	444814009	40481087		0
75653	4487	4218389	2005-10-26	2005-10-26 00:00:00	2005-11-16	2005-11-16 00:00:00	32020		\N	298686	0	39848009	4218389		0
75762	4492	4116491	1976-07-29	1976-07-29 00:00:00	1976-09-21	1976-09-21 00:00:00	32020		\N	299074	0	301011002	4116491		0
75932	4503	260139	1999-07-31	1999-07-31 00:00:00	1999-08-14	1999-08-14 00:00:00	32020		\N	299867	0	10509002	260139		0
76183	4521	40481087	1991-10-18	1991-10-18 00:00:00	1991-11-01	1991-11-01 00:00:00	32020		\N	300968	0	444814009	40481087		0
86859	5170	40481087	1985-08-31	1985-08-31 00:00:00	1985-09-14	1985-09-14 00:00:00	32020		\N	343771	0	444814009	40481087		0
87071	5185	321042	1961-11-13	1961-11-13 00:00:00	\N	\N	32020		\N	344602	0	410429000	321042		0
87163	5191	4152936	1977-08-18	1977-08-18 00:00:00	1977-09-08	1977-09-08 00:00:00	32020		\N	345061	0	283385000	4152936		0
87324	5197	80180	1995-09-28	1995-09-28 00:00:00	\N	\N	32020		\N	345576	0	396275006	80180		0
76984	4561	81893	1983-09-26	1983-09-26 00:00:00	\N	\N	32020		\N	303890	0	64766004	81893		0
77084	4565	260139	1993-08-25	1993-08-25 00:00:00	1993-09-01	1993-09-01 00:00:00	32020		\N	304165	0	10509002	260139		0
87891	5229	4278672	1963-11-26	1963-11-26 00:00:00	1964-02-24	1964-02-24 00:00:00	32020		\N	347864	0	65966004	4278672		0
88018	5235	80180	1960-05-29	1960-05-29 00:00:00	\N	\N	32020		\N	348310	0	396275006	80180		0
88173	5242	440086	1969-07-25	1969-07-25 00:00:00	1980-08-01	1980-08-01 00:00:00	32020		\N	348828	0	192127007	440086		0
77817	4608	4109685	1964-02-27	1964-02-27 00:00:00	1964-03-12	1964-03-12 00:00:00	32020		\N	307063	0	284551006	4109685		0
78175	4631	40481087	1992-10-23	1992-10-23 00:00:00	1992-11-13	1992-11-13 00:00:00	32020		\N	308568	0	444814009	40481087		0
78290	4636	40481087	1994-06-12	1994-06-12 00:00:00	1994-06-19	1994-06-19 00:00:00	32020		\N	308979	0	444814009	40481087		0
78461	4644	260139	1970-03-14	1970-03-14 00:00:00	1970-03-21	1970-03-21 00:00:00	32020		\N	309687	0	10509002	260139		0
78662	4657	4112343	2012-09-06	2012-09-06 00:00:00	2012-09-15	2012-09-15 00:00:00	32020		\N	310519	0	195662009	4112343		0
78812	4668	40481087	2012-12-09	2012-12-09 00:00:00	2012-12-30	2012-12-30 00:00:00	32020		\N	311037	0	444814009	40481087		0
89551	5325	81151	1970-12-17	1970-12-17 00:00:00	1970-12-31	1970-12-31 00:00:00	32020		\N	354438	0	44465007	81151		0
89646	5329	40481087	1979-04-20	1979-04-20 00:00:00	1979-05-04	1979-05-04 00:00:00	32020		\N	354790	0	444814009	40481087		0
79558	4713	4285898	2010-05-16	2010-05-16 00:00:00	\N	\N	32020		\N	313843	0	68496003	4285898		0
79788	4725	372328	1977-03-11	1977-03-11 00:00:00	1977-05-23	1977-05-23 00:00:00	32020		\N	314896	0	65363002	372328		0
80092	4748	40481087	1958-09-10	1958-09-10 00:00:00	1958-09-24	1958-09-24 00:00:00	32020		\N	316210	0	444814009	40481087		0
80200	4754	260139	1971-08-12	1971-08-12 00:00:00	1971-08-26	1971-08-26 00:00:00	32020		\N	316640	0	10509002	260139		0
80837	4795	40481087	1990-09-17	1990-09-17 00:00:00	1990-10-01	1990-10-01 00:00:00	32020		\N	319037	0	444814009	40481087		0
81475	4831	4112343	1999-09-03	1999-09-03 00:00:00	1999-09-10	1999-09-10 00:00:00	32020		\N	321478	0	195662009	4112343		0
81656	4844	4084167	1959-09-24	1959-09-24 00:00:00	1959-09-24	1959-09-24 00:00:00	32020		\N	322277	0	241929008	4084167		0
81721	4848	4027663	1986-09-06	1986-09-06 00:00:00	\N	\N	32020		\N	322496	0	13200003	4027663		0
82073	4867	40481087	1935-09-16	1935-09-16 00:00:00	1935-10-07	1935-10-07 00:00:00	32020		\N	323677	0	444814009	40481087		0
82649	4907	40481087	1989-08-02	1989-08-02 00:00:00	1989-08-16	1989-08-16 00:00:00	32020		\N	326174	0	444814009	40481087		0
82760	4913	4059173	1981-04-25	1981-04-25 00:00:00	1981-07-24	1981-07-24 00:00:00	32020		\N	326571	0	16114001	4059173		0
82924	4924	4155034	1991-06-02	1991-06-02 00:00:00	1991-06-23	1991-06-23 00:00:00	32020		\N	327220	0	283371005	4155034		0
83993	4988	192671	1991-06-05	1991-06-05 00:00:00	\N	\N	32020		\N	331835	0	K92.2	35208414		0
84204	5001	378001	2000-03-12	2000-03-12 00:00:00	2000-04-11	2000-04-11 00:00:00	32020		\N	332672	0	62106007	378001		0
85115	5063	260139	1957-08-20	1957-08-20 00:00:00	1957-08-27	1957-08-27 00:00:00	32020		\N	336552	0	10509002	260139		0
85281	5073	40481087	1949-08-02	1949-08-02 00:00:00	1949-08-16	1949-08-16 00:00:00	32020		\N	337230	0	444814009	40481087		0
85336	5076	40481087	1997-11-18	1997-11-18 00:00:00	1997-11-25	1997-11-25 00:00:00	32020		\N	337424	0	444814009	40481087		0
74981	4452	81151	1971-05-15	1971-05-15 00:00:00	1971-05-29	1971-05-29 00:00:00	32020		\N	296344	0	44465007	81151		0
75102	4460	260139	1989-04-05	1989-04-05 00:00:00	1989-04-12	1989-04-12 00:00:00	32020		\N	296812	0	10509002	260139		0
85840	5107	4112343	1990-12-02	1990-12-02 00:00:00	1990-12-15	1990-12-15 00:00:00	32020		\N	339339	0	195662009	4112343		0
75365	4474	372328	2017-11-17	2017-11-17 00:00:00	2018-07-06	2018-07-06 00:00:00	32020		\N	297682	0	65363002	372328		0
75654	4487	40481087	1980-11-09	1980-11-09 00:00:00	1980-11-16	1980-11-16 00:00:00	32020		\N	298713	0	444814009	40481087		0
75763	4492	28060	1948-02-28	1948-02-28 00:00:00	1948-03-12	1948-03-12 00:00:00	32020		\N	299081	0	43878008	28060		0
75933	4503	260139	1992-06-11	1992-06-11 00:00:00	1992-06-25	1992-06-25 00:00:00	32020		\N	299866	0	10509002	260139		0
76184	4521	40481087	1950-06-28	1950-06-28 00:00:00	1950-07-12	1950-07-12 00:00:00	32020		\N	300962	0	444814009	40481087		0
86860	5170	4112343	2010-02-24	2010-02-24 00:00:00	2010-03-09	2010-03-09 00:00:00	32020		\N	343757	0	195662009	4112343		0
87072	5185	40481087	1943-05-15	1943-05-15 00:00:00	1943-05-22	1943-05-22 00:00:00	32020		\N	344596	0	444814009	40481087		0
87164	5191	80180	2012-11-27	2012-11-27 00:00:00	\N	\N	32020		\N	345070	0	396275006	80180		0
87325	5197	40481087	2005-08-12	2005-08-12 00:00:00	2005-08-19	2005-08-19 00:00:00	32020		\N	345585	0	444814009	40481087		0
76985	4561	4027663	1975-04-06	1975-04-06 00:00:00	\N	\N	32020		\N	303901	0	13200003	4027663		0
77106	4569	378001	1996-09-21	1996-09-21 00:00:00	1996-11-20	1996-11-20 00:00:00	32020		\N	304396	0	62106007	378001		0
87892	5229	40481087	2002-10-27	2002-10-27 00:00:00	2002-11-17	2002-11-17 00:00:00	32020		\N	347882	0	444814009	40481087		0
88019	5235	317576	1925-08-22	1925-08-22 00:00:00	\N	\N	32020		\N	348338	0	53741008	317576		0
88174	5242	313217	2018-08-31	2018-08-31 00:00:00	\N	\N	32020		\N	348827	0	49436004	313217		0
77818	4608	260139	1977-07-04	1977-07-04 00:00:00	1977-07-18	1977-07-18 00:00:00	32020		\N	306970	0	10509002	260139		0
78176	4631	80180	1953-09-17	1953-09-17 00:00:00	\N	\N	32020		\N	308631	0	396275006	80180		0
78291	4636	40481087	1980-10-23	1980-10-23 00:00:00	1980-11-13	1980-11-13 00:00:00	32020		\N	309006	0	444814009	40481087		0
78462	4644	4294548	1995-11-26	1995-11-26 00:00:00	1996-02-04	1996-02-04 00:00:00	32020		\N	309677	0	75498004	4294548		0
78663	4657	4278672	1969-03-24	1969-03-24 00:00:00	1969-04-23	1969-04-23 00:00:00	32020		\N	310509	0	65966004	4278672		0
78813	4668	260139	2003-10-07	2003-10-07 00:00:00	2003-10-21	2003-10-21 00:00:00	32020		\N	311036	0	10509002	260139		0
89552	5325	372328	2008-11-18	2008-11-18 00:00:00	2009-01-18	2009-01-18 00:00:00	32020		\N	354462	0	65363002	372328		0
89647	5329	40481087	2009-08-31	2009-08-31 00:00:00	2009-09-21	2009-09-21 00:00:00	32020		\N	354783	0	444814009	40481087		0
79559	4713	80180	2010-08-14	2010-08-14 00:00:00	\N	\N	32020		\N	313843	0	396275006	80180		0
79789	4725	40481087	2012-03-06	2012-03-06 00:00:00	2012-03-27	2012-03-27 00:00:00	32020		\N	314942	0	444814009	40481087		0
80093	4748	40481087	1954-12-21	1954-12-21 00:00:00	1954-12-28	1954-12-28 00:00:00	32020		\N	316161	0	444814009	40481087		0
80201	4754	372328	1968-10-29	1968-10-29 00:00:00	1969-09-30	1969-09-30 00:00:00	32020		\N	316617	0	65363002	372328		0
80838	4795	40481087	1974-07-24	1974-07-24 00:00:00	1974-08-07	1974-08-07 00:00:00	32020		\N	319036	0	444814009	40481087		0
81476	4831	28060	1966-08-14	1966-08-14 00:00:00	1966-08-27	1966-08-27 00:00:00	32020		\N	321428	0	43878008	28060		0
81657	4844	260139	1970-05-30	1970-05-30 00:00:00	1970-06-13	1970-06-13 00:00:00	32020		\N	322200	0	10509002	260139		0
81722	4848	192671	1996-11-19	1996-11-19 00:00:00	\N	\N	32020		\N	322575	0	K92.2	35208414		0
82074	4867	4142905	1987-05-29	1987-05-29 00:00:00	1987-07-28	1987-07-28 00:00:00	32020		\N	323685	0	33737001	4142905		0
82650	4907	372328	1950-05-03	1950-05-03 00:00:00	1950-12-02	1950-12-02 00:00:00	32020		\N	326179	0	65363002	372328		0
82761	4913	257012	1973-02-08	1973-02-08 00:00:00	\N	\N	32020		\N	326496	0	40055000	257012		0
82925	4924	4112343	2001-07-02	2001-07-02 00:00:00	2001-07-13	2001-07-13 00:00:00	32020		\N	327175	0	195662009	4112343		0
83994	4988	40481087	1987-07-21	1987-07-21 00:00:00	1987-08-04	1987-08-04 00:00:00	32020		\N	331823	0	444814009	40481087		0
84205	5001	4112343	2010-07-16	2010-07-16 00:00:00	2010-07-27	2010-07-27 00:00:00	32020		\N	332620	0	195662009	4112343		0
85116	5063	28060	2000-12-02	2000-12-02 00:00:00	2000-12-14	2000-12-14 00:00:00	32020		\N	336571	0	43878008	28060		0
85282	5073	78272	1976-11-29	1976-11-29 00:00:00	1976-12-27	1976-12-27 00:00:00	32020		\N	337164	0	70704007	78272		0
85337	5076	30753	1974-09-25	1974-09-25 00:00:00	\N	\N	32020		\N	337432	0	16761005	30753		0
74982	4452	4237458	1956-06-27	1956-06-27 00:00:00	1956-09-25	1956-09-25 00:00:00	32020		\N	296341	0	58150001	4237458		0
75103	4460	375671	1949-03-22	1949-03-22 00:00:00	1949-04-21	1949-04-21 00:00:00	32020		\N	296737	0	62564004	375671		0
85841	5107	378001	2017-07-22	2017-07-22 00:00:00	2017-09-20	2017-09-20 00:00:00	32020		\N	339352	0	62106007	378001		0
75366	4474	81893	1997-08-22	1997-08-22 00:00:00	\N	\N	32020		\N	297664	0	64766004	81893		0
75655	4487	40481087	1964-01-24	1964-01-24 00:00:00	1964-02-07	1964-02-07 00:00:00	32020		\N	298726	0	444814009	40481087		0
75764	4493	375671	1997-04-25	1997-04-25 00:00:00	1997-05-25	1997-05-25 00:00:00	32020		\N	299161	0	62564004	375671		0
75934	4503	40481087	2004-07-24	2004-07-24 00:00:00	2004-07-31	2004-07-31 00:00:00	32020		\N	299812	0	444814009	40481087		0
76185	4521	4112343	1968-05-12	1968-05-12 00:00:00	1968-05-19	1968-05-19 00:00:00	32020		\N	301041	0	195662009	4112343		0
86861	5170	4112343	1989-06-23	1989-06-23 00:00:00	1989-07-02	1989-07-02 00:00:00	32020		\N	343792	0	195662009	4112343		0
87073	5185	4112343	1999-10-06	1999-10-06 00:00:00	1999-10-18	1999-10-18 00:00:00	32020		\N	344685	0	195662009	4112343		0
87165	5191	4112343	2015-07-13	2015-07-13 00:00:00	2015-07-26	2015-07-26 00:00:00	32020		\N	345103	0	195662009	4112343		0
87326	5197	260139	1966-09-28	1966-09-28 00:00:00	1966-10-05	1966-10-05 00:00:00	32020		\N	345580	0	10509002	260139		0
76986	4561	260139	1984-08-06	1984-08-06 00:00:00	1984-08-13	1984-08-13 00:00:00	32020		\N	303938	0	10509002	260139		0
77107	4569	260139	1963-04-19	1963-04-19 00:00:00	1963-04-26	1963-04-26 00:00:00	32020		\N	304369	0	10509002	260139		0
87893	5229	4310024	2002-09-22	2002-09-22 00:00:00	\N	\N	32020		\N	347904	0	424802006	4310024		0
88020	5235	4113008	1967-07-20	1967-07-20 00:00:00	1967-08-10	1967-08-10 00:00:00	32020		\N	348366	0	284549007	4113008		0
88175	5242	40481087	1987-10-18	1987-10-18 00:00:00	1987-10-25	1987-10-25 00:00:00	32020		\N	348803	0	444814009	40481087		0
77852	4613	80180	2003-06-27	2003-06-27 00:00:00	\N	\N	32020		\N	307321	0	396275006	80180		0
78177	4631	40481087	1942-02-28	1942-02-28 00:00:00	1942-03-21	1942-03-21 00:00:00	32020		\N	308603	0	444814009	40481087		0
78292	4636	260139	1972-07-01	1972-07-01 00:00:00	1972-07-08	1972-07-08 00:00:00	32020		\N	308967	0	10509002	260139		0
78463	4644	372328	1968-11-17	1968-11-17 00:00:00	1969-06-26	1969-06-26 00:00:00	32020		\N	309690	0	65363002	372328		0
78664	4657	40481087	1994-08-04	1994-08-04 00:00:00	1994-08-11	1994-08-11 00:00:00	32020		\N	310506	0	444814009	40481087		0
78814	4668	260139	1976-05-22	1976-05-22 00:00:00	1976-05-29	1976-05-29 00:00:00	32020		\N	311033	0	10509002	260139		0
89553	5325	257012	1980-04-03	1980-04-03 00:00:00	\N	\N	32020		\N	354502	0	40055000	257012		0
89648	5329	4155034	1953-09-17	1953-09-17 00:00:00	1953-10-08	1953-10-08 00:00:00	32020		\N	354829	0	283371005	4155034		0
79560	4713	260139	1978-09-02	1978-09-02 00:00:00	1978-09-16	1978-09-16 00:00:00	32020		\N	313828	0	10509002	260139		0
79810	4729	4112343	2000-05-03	2000-05-03 00:00:00	2000-05-15	2000-05-15 00:00:00	32020		\N	315087	0	195662009	4112343		0
80094	4748	260139	2004-04-04	2004-04-04 00:00:00	2004-04-11	2004-04-11 00:00:00	32020		\N	316144	0	10509002	260139		0
80202	4754	375671	2005-02-13	2005-02-13 00:00:00	2005-03-15	2005-03-15 00:00:00	32020		\N	316638	0	62564004	375671		0
80839	4795	4116491	1998-12-22	1998-12-22 00:00:00	1999-02-14	1999-02-14 00:00:00	32020		\N	319023	0	301011002	4116491		0
81477	4831	28060	2007-10-01	2007-10-01 00:00:00	2007-10-12	2007-10-12 00:00:00	32020		\N	321479	0	43878008	28060		0
81658	4844	260139	1976-05-14	1976-05-14 00:00:00	1976-05-21	1976-05-21 00:00:00	32020		\N	322286	0	10509002	260139		0
81723	4848	40481087	2007-06-19	2007-06-19 00:00:00	2007-07-03	2007-07-03 00:00:00	32020		\N	322510	0	444814009	40481087		0
82075	4867	378001	2003-02-18	2003-02-18 00:00:00	2003-04-19	2003-04-19 00:00:00	32020		\N	323688	0	62106007	378001		0
82651	4907	4112343	1986-04-11	1986-04-11 00:00:00	1986-04-18	1986-04-18 00:00:00	32020		\N	326132	0	195662009	4112343		0
82762	4913	28060	2018-03-02	2018-03-02 00:00:00	2018-03-12	2018-03-12 00:00:00	32020		\N	326534	0	43878008	28060		0
82926	4924	40481087	2001-04-02	2001-04-02 00:00:00	2001-04-16	2001-04-16 00:00:00	32020		\N	327190	0	444814009	40481087		0
84206	5001	40481087	2006-08-17	2006-08-17 00:00:00	2006-09-07	2006-09-07 00:00:00	32020		\N	332656	0	444814009	40481087		0
85117	5063	40481087	1964-01-06	1964-01-06 00:00:00	1964-01-27	1964-01-27 00:00:00	32020		\N	336629	0	444814009	40481087		0
85283	5073	81151	1946-03-07	1946-03-07 00:00:00	1946-04-11	1946-04-11 00:00:00	32020		\N	337161	0	44465007	81151		0
85338	5076	40481087	1974-09-21	1974-09-21 00:00:00	1974-10-12	1974-10-12 00:00:00	32020		\N	337432	0	444814009	40481087		0
74983	4452	192671	1996-12-04	1996-12-04 00:00:00	\N	\N	32020		\N	296241	0	K92.2	35208414		0
75104	4460	40481087	1985-02-15	1985-02-15 00:00:00	1985-03-01	1985-03-01 00:00:00	32020		\N	296811	0	444814009	40481087		0
85842	5107	4112343	1987-08-04	1987-08-04 00:00:00	1987-08-17	1987-08-17 00:00:00	32020		\N	339346	0	195662009	4112343		0
75367	4474	260139	2018-10-02	2018-10-02 00:00:00	2018-10-09	2018-10-09 00:00:00	32020		\N	297681	0	10509002	260139		0
75656	4487	40481087	1978-09-08	1978-09-08 00:00:00	1978-09-15	1978-09-15 00:00:00	32020		\N	298690	0	444814009	40481087		0
75765	4493	40481087	2008-06-30	2008-06-30 00:00:00	2008-07-14	2008-07-14 00:00:00	32020		\N	299148	0	444814009	40481087		0
75935	4504	4237458	2003-11-05	2003-11-05 00:00:00	2003-12-05	2003-12-05 00:00:00	32020		\N	299902	0	58150001	4237458		0
76186	4521	28060	1991-01-17	1991-01-17 00:00:00	1991-01-24	1991-01-24 00:00:00	32020		\N	301021	0	43878008	28060		0
86862	5170	80180	2004-12-08	2004-12-08 00:00:00	\N	\N	32020		\N	343795	0	396275006	80180		0
87074	5185	4152936	1956-07-09	1956-07-09 00:00:00	1956-07-23	1956-07-23 00:00:00	32020		\N	344601	0	283385000	4152936		0
87166	5191	260139	2002-11-07	2002-11-07 00:00:00	2002-11-21	2002-11-21 00:00:00	32020		\N	345120	0	10509002	260139		0
87327	5197	372328	1954-02-15	1954-02-15 00:00:00	1954-03-30	1954-03-30 00:00:00	32020		\N	345631	0	65363002	372328		0
76987	4561	260139	1954-01-22	1954-01-22 00:00:00	1954-02-05	1954-02-05 00:00:00	32020		\N	303908	0	10509002	260139		0
77108	4569	260139	1968-11-03	1968-11-03 00:00:00	1968-11-10	1968-11-10 00:00:00	32020		\N	304351	0	10509002	260139		0
87894	5229	4112343	2004-08-06	2004-08-06 00:00:00	2004-08-17	2004-08-17 00:00:00	32020		\N	347912	0	195662009	4112343		0
88021	5235	313217	1981-12-12	1981-12-12 00:00:00	\N	\N	32020		\N	348373	0	49436004	313217		0
88176	5242	80180	2000-02-03	2000-02-03 00:00:00	\N	\N	32020		\N	348817	0	396275006	80180		0
77853	4613	4113008	1980-09-10	1980-09-10 00:00:00	1980-10-01	1980-10-01 00:00:00	32020		\N	307231	0	284549007	4113008		0
78178	4631	4059173	2002-06-28	2002-06-28 00:00:00	2002-09-26	2002-09-26 00:00:00	32020		\N	308560	0	16114001	4059173		0
78293	4636	40481087	1976-07-08	1976-07-08 00:00:00	1976-07-22	1976-07-22 00:00:00	32020		\N	308945	0	444814009	40481087		0
78464	4644	40481087	2008-04-07	2008-04-07 00:00:00	2008-04-21	2008-04-21 00:00:00	32020		\N	309669	0	444814009	40481087		0
78665	4657	28060	1972-05-27	1972-05-27 00:00:00	1972-06-05	1972-06-05 00:00:00	32020		\N	310503	0	43878008	28060		0
78815	4668	375671	1984-05-08	1984-05-08 00:00:00	1984-07-07	1984-07-07 00:00:00	32020		\N	311084	0	62564004	375671		0
89554	5325	372328	1946-06-05	1946-06-05 00:00:00	1946-09-15	1946-09-15 00:00:00	32020		\N	354450	0	65363002	372328		0
89649	5329	78272	2001-09-01	2001-09-01 00:00:00	2001-09-15	2001-09-15 00:00:00	32020		\N	354834	0	70704007	78272		0
79561	4713	4283893	1979-04-03	1979-04-03 00:00:00	1979-08-07	1979-08-07 00:00:00	32020		\N	313869	0	36971009	4283893		0
79811	4729	4059173	1965-09-18	1965-09-18 00:00:00	1965-10-18	1965-10-18 00:00:00	32020		\N	315097	0	16114001	4059173		0
80095	4748	4116491	1996-09-23	1996-09-23 00:00:00	1996-11-11	1996-11-11 00:00:00	32020		\N	316185	0	301011002	4116491		0
80203	4754	260139	1994-08-07	1994-08-07 00:00:00	1994-08-21	1994-08-21 00:00:00	32020		\N	316643	0	10509002	260139		0
80840	4795	4112343	2011-02-07	2011-02-07 00:00:00	2011-02-17	2011-02-17 00:00:00	32020		\N	319039	0	195662009	4112343		0
81478	4831	28060	1980-07-31	1980-07-31 00:00:00	1980-08-09	1980-08-09 00:00:00	32020		\N	321419	0	43878008	28060		0
81659	4844	40481087	2006-01-05	2006-01-05 00:00:00	2006-01-26	2006-01-26 00:00:00	32020		\N	322306	0	444814009	40481087		0
81724	4848	4218389	1970-12-09	1970-12-09 00:00:00	1971-01-06	1971-01-06 00:00:00	32020		\N	322561	0	39848009	4218389		0
82076	4867	40481087	1927-05-04	1927-05-04 00:00:00	1927-05-11	1927-05-11 00:00:00	32020		\N	323639	0	444814009	40481087		0
82652	4907	40481087	2004-05-16	2004-05-16 00:00:00	2004-05-30	2004-05-30 00:00:00	32020		\N	326178	0	444814009	40481087		0
82763	4913	4109685	1976-12-03	1976-12-03 00:00:00	1976-12-17	1976-12-17 00:00:00	32020		\N	326570	0	284551006	4109685		0
82927	4924	40481087	2017-11-30	2017-11-30 00:00:00	2017-12-21	2017-12-21 00:00:00	32020		\N	327193	0	444814009	40481087		0
84207	5001	260139	1965-02-11	1965-02-11 00:00:00	1965-02-18	1965-02-18 00:00:00	32020		\N	332616	0	10509002	260139		0
85118	5063	4134304	2019-02-08	2019-02-08 00:00:00	2019-03-10	2019-03-10 00:00:00	32020		\N	336541	0	263102004	4134304		0
85284	5073	4112343	1996-04-30	1996-04-30 00:00:00	1996-05-09	1996-05-09 00:00:00	32020		\N	337186	0	195662009	4112343		0
85339	5076	4296205	2004-10-02	2004-10-02 00:00:00	2004-11-06	2004-11-06 00:00:00	32020		\N	337330	0	403191005	4296205		0
74984	4452	40481087	1987-09-05	1987-09-05 00:00:00	1987-09-26	1987-09-26 00:00:00	32020		\N	296274	0	444814009	40481087		0
75105	4460	28060	1951-12-08	1951-12-08 00:00:00	1951-12-16	1951-12-16 00:00:00	32020		\N	296816	0	43878008	28060		0
85843	5107	4112343	2015-10-30	2015-10-30 00:00:00	2015-11-09	2015-11-09 00:00:00	32020		\N	339347	0	195662009	4112343		0
75368	4474	81151	1983-06-13	1983-06-13 00:00:00	1983-06-27	1983-06-27 00:00:00	32020		\N	297690	0	44465007	81151		0
75657	4487	40481087	1997-12-18	1997-12-18 00:00:00	1997-12-25	1997-12-25 00:00:00	32020		\N	298757	0	444814009	40481087		0
75766	4493	4112343	2004-07-11	2004-07-11 00:00:00	2004-07-24	2004-07-24 00:00:00	32020		\N	299142	0	195662009	4112343		0
75936	4504	40481087	1974-05-05	1974-05-05 00:00:00	1974-05-19	1974-05-19 00:00:00	32020		\N	299897	0	444814009	40481087		0
76187	4521	317576	1970-04-16	1970-04-16 00:00:00	\N	\N	32020		\N	301078	0	53741008	317576		0
86863	5170	40481087	2003-09-19	2003-09-19 00:00:00	2003-10-10	2003-10-10 00:00:00	32020		\N	343795	0	444814009	40481087		0
87075	5185	40481087	2002-12-24	2002-12-24 00:00:00	2002-12-31	2002-12-31 00:00:00	32020		\N	344695	0	444814009	40481087		0
87167	5191	40481087	2001-01-08	2001-01-08 00:00:00	2001-01-22	2001-01-22 00:00:00	32020		\N	345119	0	444814009	40481087		0
87342	5199	260139	1974-08-21	1974-08-21 00:00:00	1974-09-04	1974-09-04 00:00:00	32020		\N	345779	0	10509002	260139		0
76988	4561	80180	1984-06-22	1984-06-22 00:00:00	\N	\N	32020		\N	303891	0	396275006	80180		0
77109	4569	378001	1973-04-25	1973-04-25 00:00:00	1973-06-24	1973-06-24 00:00:00	32020		\N	304395	0	62106007	378001		0
87895	5229	4112343	2013-04-05	2013-04-05 00:00:00	2013-04-18	2013-04-18 00:00:00	32020		\N	347874	0	195662009	4112343		0
88022	5235	30753	1959-06-04	1959-06-04 00:00:00	\N	\N	32020		\N	348317	0	16761005	30753		0
88177	5242	81151	1997-12-20	1997-12-20 00:00:00	1998-01-10	1998-01-10 00:00:00	32020		\N	348802	0	44465007	81151		0
77854	4613	40481087	1999-10-16	1999-10-16 00:00:00	1999-10-30	1999-10-30 00:00:00	32020		\N	307270	0	444814009	40481087		0
78179	4631	4112343	1992-04-04	1992-04-04 00:00:00	1992-04-12	1992-04-12 00:00:00	32020		\N	308567	0	195662009	4112343		0
78294	4636	372328	1950-11-24	1950-11-24 00:00:00	1951-05-29	1951-05-29 00:00:00	32020		\N	309007	0	65363002	372328		0
78465	4644	80180	2001-02-10	2001-02-10 00:00:00	\N	\N	32020		\N	309678	0	396275006	80180		0
78666	4657	4112343	1990-12-21	1990-12-21 00:00:00	1990-12-29	1990-12-29 00:00:00	32020		\N	310516	0	195662009	4112343		0
78816	4668	78272	2011-10-05	2011-10-05 00:00:00	2011-10-26	2011-10-26 00:00:00	32020		\N	311089	0	70704007	78272		0
89555	5325	260139	1991-11-22	1991-11-22 00:00:00	1991-11-29	1991-11-29 00:00:00	32020		\N	354447	0	10509002	260139		0
89650	5329	4112343	1994-11-21	1994-11-21 00:00:00	1994-11-30	1994-11-30 00:00:00	32020		\N	354758	0	195662009	4112343		0
79562	4713	78272	1986-07-05	1986-07-05 00:00:00	1986-07-26	1986-07-26 00:00:00	32020		\N	313864	0	70704007	78272		0
79812	4729	4112343	1973-10-08	1973-10-08 00:00:00	1973-10-19	1973-10-19 00:00:00	32020		\N	315083	0	195662009	4112343		0
80096	4748	40481087	2003-02-24	2003-02-24 00:00:00	2003-03-03	2003-03-03 00:00:00	32020		\N	316143	0	444814009	40481087		0
80204	4754	4112343	1972-08-24	1972-08-24 00:00:00	1972-08-31	1972-08-31 00:00:00	32020		\N	316654	0	195662009	4112343		0
80841	4795	4294548	2008-05-20	2008-05-20 00:00:00	2008-07-22	2008-07-22 00:00:00	32020		\N	319038	0	75498004	4294548		0
81479	4831	372328	1964-09-08	1964-09-08 00:00:00	1964-10-01	1964-10-01 00:00:00	32020		\N	321450	0	65363002	372328		0
81660	4844	40481087	1980-03-16	1980-03-16 00:00:00	1980-03-23	1980-03-23 00:00:00	32020		\N	322177	0	444814009	40481087		0
81725	4848	40481087	1989-09-17	1989-09-17 00:00:00	1989-10-01	1989-10-01 00:00:00	32020		\N	322498	0	444814009	40481087		0
82077	4867	28060	1962-12-18	1962-12-18 00:00:00	1962-12-27	1962-12-27 00:00:00	32020		\N	323708	0	43878008	28060		0
82653	4907	378001	2002-04-28	2002-04-28 00:00:00	2002-05-28	2002-05-28 00:00:00	32020		\N	326205	0	62106007	378001		0
82764	4913	4294548	1972-11-02	1972-11-02 00:00:00	1973-05-17	1973-05-17 00:00:00	32020		\N	326520	0	75498004	4294548		0
82928	4924	28060	2000-09-24	2000-09-24 00:00:00	2000-10-04	2000-10-04 00:00:00	32020		\N	327200	0	43878008	28060		0
84208	5001	4112343	2001-02-25	2001-02-25 00:00:00	2001-03-05	2001-03-05 00:00:00	32020		\N	332618	0	195662009	4112343		0
85119	5063	4112343	2004-10-27	2004-10-27 00:00:00	2004-11-04	2004-11-04 00:00:00	32020		\N	336536	0	195662009	4112343		0
85285	5073	40481087	1999-08-18	1999-08-18 00:00:00	1999-09-08	1999-09-08 00:00:00	32020		\N	337187	0	444814009	40481087		0
85340	5076	4156265	1947-11-21	1947-11-21 00:00:00	1947-12-12	1947-12-12 00:00:00	32020		\N	337327	0	370247008	4156265		0
74987	4454	260139	1931-12-30	1931-12-30 00:00:00	1932-01-06	1932-01-06 00:00:00	32020		\N	296464	0	10509002	260139		0
75106	4460	4112343	1973-12-26	1973-12-26 00:00:00	1974-01-03	1974-01-03 00:00:00	32020		\N	296775	0	195662009	4112343		0
85844	5107	260139	1984-05-21	1984-05-21 00:00:00	1984-06-04	1984-06-04 00:00:00	32020		\N	339345	0	10509002	260139		0
75369	4474	260139	1981-09-29	1981-09-29 00:00:00	1981-10-06	1981-10-06 00:00:00	32020		\N	297652	0	10509002	260139		0
75658	4487	78272	1977-08-10	1977-08-10 00:00:00	1977-08-24	1977-08-24 00:00:00	32020		\N	298685	0	70704007	78272		0
75767	4493	257012	1991-02-26	1991-02-26 00:00:00	\N	\N	32020		\N	299141	0	40055000	257012		0
75937	4504	372328	1972-11-17	1972-11-17 00:00:00	1973-08-25	1973-08-25 00:00:00	32020		\N	299949	0	65363002	372328		0
76188	4521	40481087	1922-01-19	1922-01-19 00:00:00	1922-02-09	1922-02-09 00:00:00	32020		\N	301042	0	444814009	40481087		0
86864	5170	4296204	1991-03-12	1991-03-12 00:00:00	1991-04-02	1991-04-02 00:00:00	32020		\N	343738	0	403190006	4296204		0
87076	5185	40481087	1936-01-20	1936-01-20 00:00:00	1936-02-03	1936-02-03 00:00:00	32020		\N	344632	0	444814009	40481087		0
87168	5191	4283893	2006-04-26	2006-04-26 00:00:00	2006-08-02	2006-08-02 00:00:00	32020		\N	345121	0	36971009	4283893		0
87343	5199	260139	1963-10-09	1963-10-09 00:00:00	1963-10-23	1963-10-23 00:00:00	32020		\N	345771	0	10509002	260139		0
76989	4561	40481087	1993-10-25	1993-10-25 00:00:00	1993-11-08	1993-11-08 00:00:00	32020		\N	303911	0	444814009	40481087		0
77110	4569	372328	1964-12-08	1964-12-08 00:00:00	1964-12-29	1964-12-29 00:00:00	32020		\N	304401	0	65363002	372328		0
87896	5229	4112343	1973-05-26	1973-05-26 00:00:00	1973-06-06	1973-06-06 00:00:00	32020		\N	347871	0	195662009	4112343		0
88023	5235	40481087	1958-09-10	1958-09-10 00:00:00	1958-09-17	1958-09-17 00:00:00	32020		\N	348317	0	444814009	40481087		0
88178	5242	260139	1975-11-18	1975-11-18 00:00:00	1975-12-02	1975-12-02 00:00:00	32020		\N	348829	0	10509002	260139		0
88313	5252	260139	1987-01-08	1987-01-08 00:00:00	1987-01-15	1987-01-15 00:00:00	32020		\N	349415	0	10509002	260139		0
78180	4631	81151	2013-05-01	2013-05-01 00:00:00	2013-05-22	2013-05-22 00:00:00	32020		\N	308561	0	44465007	81151		0
78295	4636	40481087	2015-08-01	2015-08-01 00:00:00	2015-08-08	2015-08-08 00:00:00	32020		\N	308935	0	444814009	40481087		0
78466	4644	40481087	2000-08-17	2000-08-17 00:00:00	2000-09-07	2000-09-07 00:00:00	32020		\N	309678	0	444814009	40481087		0
78667	4657	260139	2010-07-15	2010-07-15 00:00:00	2010-07-29	2010-07-29 00:00:00	32020		\N	310518	0	10509002	260139		0
78817	4668	4156265	2014-12-09	2014-12-09 00:00:00	2014-12-23	2014-12-23 00:00:00	32020		\N	311090	0	370247008	4156265		0
89556	5325	80180	1985-08-14	1985-08-14 00:00:00	\N	\N	32020		\N	354507	0	396275006	80180		0
89651	5329	260139	2009-12-01	2009-12-01 00:00:00	2009-12-15	2009-12-15 00:00:00	32020		\N	354765	0	10509002	260139		0
79563	4713	4027663	1998-12-30	1998-12-30 00:00:00	\N	\N	32020		\N	313810	0	13200003	4027663		0
79813	4729	81151	2006-12-31	2006-12-31 00:00:00	2007-01-28	2007-01-28 00:00:00	32020		\N	315108	0	44465007	81151		0
80097	4748	40481087	2017-12-24	2017-12-24 00:00:00	2018-01-14	2018-01-14 00:00:00	32020		\N	316207	0	444814009	40481087		0
80205	4754	40481087	1974-03-09	1974-03-09 00:00:00	1974-03-23	1974-03-23 00:00:00	32020		\N	316612	0	444814009	40481087		0
80842	4795	4218389	2003-03-24	2003-03-24 00:00:00	2003-04-14	2003-04-14 00:00:00	32020		\N	319046	0	39848009	4218389		0
81480	4831	378001	1975-01-19	1975-01-19 00:00:00	1975-02-18	1975-02-18 00:00:00	32020		\N	321465	0	62106007	378001		0
81661	4844	40481087	2015-01-01	2015-01-01 00:00:00	2015-01-22	2015-01-22 00:00:00	32020		\N	322267	0	444814009	40481087		0
81726	4848	260139	1960-01-08	1960-01-08 00:00:00	1960-01-15	1960-01-15 00:00:00	32020		\N	322564	0	10509002	260139		0
82078	4867	40481087	1961-09-30	1961-09-30 00:00:00	1961-10-21	1961-10-21 00:00:00	32020		\N	323680	0	444814009	40481087		0
82654	4907	40481087	2016-10-11	2016-10-11 00:00:00	2016-11-01	2016-11-01 00:00:00	32020		\N	326162	0	444814009	40481087		0
82765	4913	260139	1979-05-24	1979-05-24 00:00:00	1979-05-31	1979-05-31 00:00:00	32020		\N	326521	0	10509002	260139		0
82929	4924	260139	2002-06-07	2002-06-07 00:00:00	2002-06-14	2002-06-14 00:00:00	32020		\N	327191	0	10509002	260139		0
84209	5001	4113008	1993-09-24	1993-09-24 00:00:00	1993-10-15	1993-10-15 00:00:00	32020		\N	332671	0	284549007	4113008		0
85120	5063	78272	1979-05-06	1979-05-06 00:00:00	1979-06-03	1979-06-03 00:00:00	32020		\N	336600	0	70704007	78272		0
85286	5073	440448	1947-04-11	1947-04-11 00:00:00	\N	\N	32020		\N	337162	0	74400008	440448		0
85341	5076	40481087	1950-12-09	1950-12-09 00:00:00	1950-12-30	1950-12-30 00:00:00	32020		\N	337386	0	444814009	40481087		0
74988	4454	4155034	1969-09-03	1969-09-03 00:00:00	1969-09-17	1969-09-17 00:00:00	32020		\N	296500	0	283371005	4155034		0
75107	4460	40481087	1965-09-22	1965-09-22 00:00:00	1965-10-13	1965-10-13 00:00:00	32020		\N	296774	0	444814009	40481087		0
85845	5107	4112343	1997-05-26	1997-05-26 00:00:00	1997-06-03	1997-06-03 00:00:00	32020		\N	339319	0	195662009	4112343		0
75370	4474	4027663	1988-05-31	1988-05-31 00:00:00	\N	\N	32020		\N	297675	0	13200003	4027663		0
75659	4487	4112343	2007-06-20	2007-06-20 00:00:00	2007-06-28	2007-06-28 00:00:00	32020		\N	298696	0	195662009	4112343		0
75768	4493	4294548	1991-01-15	1991-01-15 00:00:00	1991-03-05	1991-03-05 00:00:00	32020		\N	299140	0	75498004	4294548		0
75938	4504	40481087	2001-06-23	2001-06-23 00:00:00	2001-07-07	2001-07-07 00:00:00	32020		\N	299931	0	444814009	40481087		0
76189	4521	260139	1967-08-16	1967-08-16 00:00:00	1967-08-23	1967-08-23 00:00:00	32020		\N	301017	0	10509002	260139		0
86867	5172	4113008	1959-07-08	1959-07-08 00:00:00	1959-07-22	1959-07-22 00:00:00	32020		\N	343919	0	284549007	4113008		0
87077	5185	40481087	1939-03-25	1939-03-25 00:00:00	1939-04-01	1939-04-01 00:00:00	32020		\N	344633	0	444814009	40481087		0
87169	5191	260139	1993-01-22	1993-01-22 00:00:00	1993-01-29	1993-01-29 00:00:00	32020		\N	345118	0	10509002	260139		0
87344	5199	81151	1975-01-20	1975-01-20 00:00:00	1975-02-17	1975-02-17 00:00:00	32020		\N	345721	0	44465007	81151		0
76990	4561	40481087	1958-04-05	1958-04-05 00:00:00	1958-04-12	1958-04-12 00:00:00	32020		\N	303871	0	444814009	40481087		0
77111	4569	4112343	1996-07-07	1996-07-07 00:00:00	1996-07-19	1996-07-19 00:00:00	32020		\N	304375	0	195662009	4112343		0
87897	5229	372328	1964-11-09	1964-11-09 00:00:00	1965-05-12	1965-05-12 00:00:00	32020		\N	347876	0	65363002	372328		0
88024	5235	81893	1959-04-05	1959-04-05 00:00:00	\N	\N	32020		\N	348317	0	64766004	81893		0
88179	5242	40481087	1988-07-26	1988-07-26 00:00:00	1988-08-02	1988-08-02 00:00:00	32020		\N	348850	0	444814009	40481087		0
88314	5252	40481087	2004-04-09	2004-04-09 00:00:00	2004-04-30	2004-04-30 00:00:00	32020		\N	349445	0	444814009	40481087		0
78181	4631	78272	1925-01-05	1925-01-05 00:00:00	1925-02-02	1925-02-02 00:00:00	32020		\N	308552	0	70704007	78272		0
78296	4636	4112343	1956-05-28	1956-05-28 00:00:00	1956-06-04	1956-06-04 00:00:00	32020		\N	308932	0	195662009	4112343		0
78467	4644	372328	1963-12-27	1963-12-27 00:00:00	1964-06-11	1964-06-11 00:00:00	32020		\N	309679	0	65363002	372328		0
78668	4657	40481087	2005-10-09	2005-10-09 00:00:00	2005-10-23	2005-10-23 00:00:00	32020		\N	310507	0	444814009	40481087		0
78818	4668	40481087	2007-12-09	2007-12-09 00:00:00	2007-12-30	2007-12-30 00:00:00	32020		\N	311081	0	444814009	40481087		0
89557	5325	4112343	1979-09-10	1979-09-10 00:00:00	1979-09-21	1979-09-21 00:00:00	32020		\N	354500	0	195662009	4112343		0
89652	5329	260139	2012-05-04	2012-05-04 00:00:00	2012-05-18	2012-05-18 00:00:00	32020		\N	354792	0	10509002	260139		0
79564	4713	30753	2009-12-17	2009-12-17 00:00:00	\N	\N	32020		\N	313868	0	16761005	30753		0
79814	4729	378001	1978-12-09	1978-12-09 00:00:00	1979-01-08	1979-01-08 00:00:00	32020		\N	315105	0	62106007	378001		0
80098	4748	4112343	1999-02-13	1999-02-13 00:00:00	1999-02-23	1999-02-23 00:00:00	32020		\N	316205	0	195662009	4112343		0
80206	4754	40481087	2012-09-04	2012-09-04 00:00:00	2012-09-11	2012-09-11 00:00:00	32020		\N	316645	0	444814009	40481087		0
81489	4834	40481087	1968-11-06	1968-11-06 00:00:00	1968-11-13	1968-11-13 00:00:00	32020		\N	321560	0	444814009	40481087		0
81662	4844	260139	1994-06-25	1994-06-25 00:00:00	1994-07-09	1994-07-09 00:00:00	32020		\N	322217	0	10509002	260139		0
81727	4848	40481087	2014-11-23	2014-11-23 00:00:00	2014-11-30	2014-11-30 00:00:00	32020		\N	322549	0	444814009	40481087		0
82079	4867	4142905	1995-04-01	1995-04-01 00:00:00	1995-06-30	1995-06-30 00:00:00	32020		\N	323687	0	33737001	4142905		0
82655	4907	260139	2008-03-16	2008-03-16 00:00:00	2008-04-01	2008-04-01 00:00:00	32020		\N	326152	0	10509002	260139		0
82766	4913	40481087	1992-06-20	1992-06-20 00:00:00	1992-07-04	1992-07-04 00:00:00	32020		\N	326532	0	444814009	40481087		0
82930	4924	133834	1979-06-14	1979-06-14 00:00:00	1995-10-05	1995-10-05 00:00:00	32020		\N	327224	0	24079001	133834		0
84210	5001	40481087	1965-01-03	1965-01-03 00:00:00	1965-01-10	1965-01-10 00:00:00	32020		\N	332651	0	444814009	40481087		0
85121	5063	30753	1980-04-19	1980-04-19 00:00:00	\N	\N	32020		\N	336600	0	16761005	30753		0
85287	5073	80180	1977-05-17	1977-05-17 00:00:00	\N	\N	32020		\N	337222	0	396275006	80180		0
85342	5076	260139	2003-01-09	2003-01-09 00:00:00	2003-01-23	2003-01-23 00:00:00	32020		\N	337399	0	10509002	260139		0
74989	4454	4134304	1996-02-28	1996-02-28 00:00:00	1996-03-29	1996-03-29 00:00:00	32020		\N	296501	0	263102004	4134304		0
75108	4460	4113008	1993-12-17	1993-12-17 00:00:00	1994-01-07	1994-01-07 00:00:00	32020		\N	296740	0	284549007	4113008		0
85846	5107	80180	2011-05-19	2011-05-19 00:00:00	\N	\N	32020		\N	339336	0	396275006	80180		0
75371	4474	4112343	2018-02-23	2018-02-23 00:00:00	2018-03-04	2018-03-04 00:00:00	32020		\N	297656	0	195662009	4112343		0
75660	4488	28060	1996-05-03	1996-05-03 00:00:00	1996-05-15	1996-05-15 00:00:00	32020		\N	298811	0	43878008	28060		0
75769	4493	4296204	1988-01-22	1988-01-22 00:00:00	1988-02-12	1988-02-12 00:00:00	32020		\N	299160	0	403190006	4296204		0
75939	4504	260139	2012-03-05	2012-03-05 00:00:00	2012-03-19	2012-03-19 00:00:00	32020		\N	299941	0	10509002	260139		0
76190	4521	40481087	2001-01-19	2001-01-19 00:00:00	2001-01-26	2001-01-26 00:00:00	32020		\N	300969	0	444814009	40481087		0
86868	5172	40481087	1956-06-23	1956-06-23 00:00:00	1956-07-14	1956-07-14 00:00:00	32020		\N	343895	0	444814009	40481087		0
87078	5185	40481087	1950-09-05	1950-09-05 00:00:00	1950-09-19	1950-09-19 00:00:00	32020		\N	344598	0	444814009	40481087		0
87170	5191	81151	1973-10-03	1973-10-03 00:00:00	1973-11-07	1973-11-07 00:00:00	32020		\N	345060	0	44465007	81151		0
87345	5199	4294548	2005-03-28	2005-03-28 00:00:00	2005-05-16	2005-05-16 00:00:00	32020		\N	345770	0	75498004	4294548		0
76991	4561	40481087	1996-11-30	1996-11-30 00:00:00	1996-12-14	1996-12-14 00:00:00	32020		\N	303922	0	444814009	40481087		0
77112	4569	260139	1999-02-02	1999-02-02 00:00:00	1999-02-16	1999-02-16 00:00:00	32020		\N	304400	0	10509002	260139		0
87898	5229	4266809	2004-04-14	2004-04-14 00:00:00	\N	\N	32020		\N	347936	0	397881000	4266809		0
88025	5235	372328	1927-11-25	1927-11-25 00:00:00	1928-09-01	1928-09-01 00:00:00	32020		\N	348326	0	65363002	372328		0
88180	5242	260139	1996-12-07	1996-12-07 00:00:00	1996-12-14	1996-12-14 00:00:00	32020		\N	348844	0	10509002	260139		0
88315	5252	4278672	1969-10-01	1969-10-01 00:00:00	1969-12-30	1969-12-30 00:00:00	32020		\N	349398	0	65966004	4278672		0
78182	4631	4109685	1997-03-12	1997-03-12 00:00:00	1997-03-26	1997-03-26 00:00:00	32020		\N	308559	0	284551006	4109685		0
78297	4636	80180	1986-10-26	1986-10-26 00:00:00	\N	\N	32020		\N	308958	0	396275006	80180		0
78468	4644	372328	1968-01-26	1968-01-26 00:00:00	1968-06-20	1968-06-20 00:00:00	32020		\N	309681	0	65363002	372328		0
78669	4657	260139	2009-06-11	2009-06-11 00:00:00	2009-06-18	2009-06-18 00:00:00	32020		\N	310517	0	10509002	260139		0
78819	4668	4112343	1961-04-11	1961-04-11 00:00:00	1961-04-18	1961-04-18 00:00:00	32020		\N	311104	0	195662009	4112343		0
89558	5325	4112343	1955-08-03	1955-08-03 00:00:00	1955-08-14	1955-08-14 00:00:00	32020		\N	354497	0	195662009	4112343		0
89668	5331	40481087	1983-08-20	1983-08-20 00:00:00	1983-09-10	1983-09-10 00:00:00	32020		\N	354917	0	444814009	40481087		0
79565	4713	81893	2009-04-21	2009-04-21 00:00:00	\N	\N	32020		\N	313868	0	64766004	81893		0
79815	4729	40481087	1984-10-11	1984-10-11 00:00:00	1984-11-01	1984-11-01 00:00:00	32020		\N	315086	0	444814009	40481087		0
80099	4748	80180	1983-10-17	1983-10-17 00:00:00	\N	\N	32020		\N	316220	0	396275006	80180		0
80207	4754	40481087	1976-06-04	1976-06-04 00:00:00	1976-06-11	1976-06-11 00:00:00	32020		\N	316641	0	444814009	40481087		0
81490	4834	80180	2003-04-25	2003-04-25 00:00:00	\N	\N	32020		\N	321566	0	396275006	80180		0
81663	4844	40481087	1984-06-08	1984-06-08 00:00:00	1984-06-15	1984-06-15 00:00:00	32020		\N	322195	0	444814009	40481087		0
81728	4848	260139	2007-08-14	2007-08-14 00:00:00	2007-08-28	2007-08-28 00:00:00	32020		\N	322502	0	10509002	260139		0
82080	4867	40481087	1927-02-07	1927-02-07 00:00:00	1927-02-28	1927-02-28 00:00:00	32020		\N	323675	0	444814009	40481087		0
82656	4907	4283893	1982-01-10	1982-01-10 00:00:00	1982-03-07	1982-03-07 00:00:00	32020		\N	326131	0	36971009	4283893		0
82785	4916	40481087	2003-10-12	2003-10-12 00:00:00	2003-10-26	2003-10-26 00:00:00	32020		\N	326674	0	444814009	40481087		0
82952	4927	4283893	2004-12-22	2004-12-22 00:00:00	2005-05-04	2005-05-04 00:00:00	32020		\N	327494	0	36971009	4283893		0
84211	5001	372328	1961-10-14	1961-10-14 00:00:00	1962-01-28	1962-01-28 00:00:00	32020		\N	332658	0	65363002	372328		0
85122	5063	4285898	1981-01-14	1981-01-14 00:00:00	\N	\N	32020		\N	336600	0	68496003	4285898		0
85288	5073	28060	1959-09-29	1959-09-29 00:00:00	1959-10-09	1959-10-09 00:00:00	32020		\N	337194	0	43878008	28060		0
85343	5076	4112343	1970-12-29	1970-12-29 00:00:00	1971-01-10	1971-01-10 00:00:00	32020		\N	337397	0	195662009	4112343		0
74990	4454	4218389	1948-12-24	1948-12-24 00:00:00	1949-01-21	1949-01-21 00:00:00	32020		\N	296497	0	39848009	4218389		0
75109	4460	4112343	1968-02-17	1968-02-17 00:00:00	1968-02-24	1968-02-24 00:00:00	32020		\N	296809	0	195662009	4112343		0
85847	5107	28060	2018-03-02	2018-03-02 00:00:00	2018-03-14	2018-03-14 00:00:00	32020		\N	339334	0	43878008	28060		0
75372	4475	40481087	2012-12-14	2012-12-14 00:00:00	2012-12-28	2012-12-28 00:00:00	32020		\N	297710	0	444814009	40481087		0
75661	4488	4278672	2012-02-27	2012-02-27 00:00:00	2012-05-27	2012-05-27 00:00:00	32020		\N	298832	0	65966004	4278672		0
75770	4493	40481087	2012-08-01	2012-08-01 00:00:00	2012-08-15	2012-08-15 00:00:00	32020		\N	299143	0	444814009	40481087		0
75940	4504	40481087	1972-12-22	1972-12-22 00:00:00	1973-01-05	1973-01-05 00:00:00	32020		\N	299928	0	444814009	40481087		0
76191	4521	40481087	1961-06-23	1961-06-23 00:00:00	1961-07-14	1961-07-14 00:00:00	32020		\N	300963	0	444814009	40481087		0
86869	5172	40481087	1965-11-12	1965-11-12 00:00:00	1965-11-19	1965-11-19 00:00:00	32020		\N	343863	0	444814009	40481087		0
87079	5185	40481087	1957-06-21	1957-06-21 00:00:00	1957-06-28	1957-06-28 00:00:00	32020		\N	344684	0	444814009	40481087		0
87171	5191	40481087	2013-05-23	2013-05-23 00:00:00	2013-06-13	2013-06-13 00:00:00	32020		\N	345102	0	444814009	40481087		0
87346	5199	192671	2001-04-19	2001-04-19 00:00:00	\N	\N	32020		\N	345720	0	K92.2	35208414		0
76992	4561	4112343	2003-12-01	2003-12-01 00:00:00	2003-12-13	2003-12-13 00:00:00	32020		\N	303912	0	195662009	4112343		0
77113	4569	4296205	1997-10-16	1997-10-16 00:00:00	1997-11-20	1997-11-20 00:00:00	32020		\N	304397	0	403191005	4296205		0
87899	5229	4285898	2004-03-15	2004-03-15 00:00:00	\N	\N	32020		\N	347936	0	68496003	4285898		0
88026	5235	260139	1973-10-19	1973-10-19 00:00:00	1973-10-26	1973-10-26 00:00:00	32020		\N	348355	0	10509002	260139		0
88181	5242	372328	1964-09-14	1964-09-14 00:00:00	1965-01-01	1965-01-01 00:00:00	32020		\N	348830	0	65363002	372328		0
88316	5252	80180	1995-11-09	1995-11-09 00:00:00	\N	\N	32020		\N	349478	0	396275006	80180		0
78183	4631	40481087	1950-02-15	1950-02-15 00:00:00	1950-03-01	1950-03-01 00:00:00	32020		\N	308565	0	444814009	40481087		0
78298	4636	40481087	2004-02-02	2004-02-02 00:00:00	2004-02-23	2004-02-23 00:00:00	32020		\N	308980	0	444814009	40481087		0
78469	4644	4296204	1985-12-01	1985-12-01 00:00:00	1986-01-05	1986-01-05 00:00:00	32020		\N	309629	0	403190006	4296204		0
78670	4657	375671	1966-04-09	1966-04-09 00:00:00	1966-05-09	1966-05-09 00:00:00	32020		\N	310508	0	62564004	375671		0
78820	4668	40481087	2001-11-28	2001-11-28 00:00:00	2001-12-12	2001-12-12 00:00:00	32020		\N	311035	0	444814009	40481087		0
89559	5325	4218389	2009-04-24	2009-04-24 00:00:00	2009-05-22	2009-05-22 00:00:00	32020		\N	354440	0	39848009	4218389		0
89669	5331	4112343	2015-04-06	2015-04-06 00:00:00	2015-04-19	2015-04-19 00:00:00	32020		\N	354961	0	195662009	4112343		0
79566	4713	4112343	1999-02-01	1999-02-01 00:00:00	1999-02-14	1999-02-14 00:00:00	32020		\N	313849	0	195662009	4112343		0
79816	4729	260139	1984-12-27	1984-12-27 00:00:00	1985-01-03	1985-01-03 00:00:00	32020		\N	315098	0	10509002	260139		0
80100	4748	4156265	1982-10-22	1982-10-22 00:00:00	1982-11-05	1982-11-05 00:00:00	32020		\N	316220	0	370247008	4156265		0
80208	4754	257012	2000-06-13	2000-06-13 00:00:00	\N	\N	32020		\N	316644	0	40055000	257012		0
81491	4834	40481087	2013-11-14	2013-11-14 00:00:00	2013-11-21	2013-11-21 00:00:00	32020		\N	321595	0	444814009	40481087		0
81664	4844	260139	2000-09-16	2000-09-16 00:00:00	2000-09-30	2000-09-30 00:00:00	32020		\N	322322	0	10509002	260139		0
81729	4848	4285898	1996-03-27	1996-03-27 00:00:00	\N	\N	32020		\N	322519	0	68496003	4285898		0
82081	4867	260139	1918-03-20	1918-03-20 00:00:00	1918-03-27	1918-03-27 00:00:00	32020		\N	323640	0	10509002	260139		0
82658	4907	40481087	1991-10-13	1991-10-13 00:00:00	1991-10-27	1991-10-27 00:00:00	32020		\N	326133	0	444814009	40481087		0
82786	4916	28060	2010-07-10	2010-07-10 00:00:00	2010-07-18	2010-07-18 00:00:00	32020		\N	326664	0	43878008	28060		0
82953	4927	260139	1990-07-15	1990-07-15 00:00:00	1990-07-22	1990-07-22 00:00:00	32020		\N	327482	0	10509002	260139		0
84212	5001	40481087	2019-01-11	2019-01-11 00:00:00	2019-01-25	2019-01-25 00:00:00	32020		\N	332621	0	444814009	40481087		0
85123	5063	40481087	2012-06-13	2012-06-13 00:00:00	2012-07-04	2012-07-04 00:00:00	32020		\N	336537	0	444814009	40481087		0
85289	5073	372328	1936-01-08	1936-01-08 00:00:00	1936-03-21	1936-03-21 00:00:00	32020		\N	337188	0	65363002	372328		0
85344	5076	4285898	1975-08-21	1975-08-21 00:00:00	\N	\N	32020		\N	337380	0	68496003	4285898		0
74991	4454	4278672	2007-03-23	2007-03-23 00:00:00	2007-05-22	2007-05-22 00:00:00	32020		\N	296504	0	65966004	4278672		0
75110	4460	40481087	1950-03-22	1950-03-22 00:00:00	1950-04-05	1950-04-05 00:00:00	32020		\N	296815	0	444814009	40481087		0
85848	5107	260139	1997-10-05	1997-10-05 00:00:00	1997-10-12	1997-10-12 00:00:00	32020		\N	339320	0	10509002	260139		0
75373	4475	80180	2013-09-30	2013-09-30 00:00:00	\N	\N	32020		\N	297710	0	396275006	80180		0
75662	4488	28060	2002-01-17	2002-01-17 00:00:00	2002-01-30	2002-01-30 00:00:00	32020		\N	298792	0	43878008	28060		0
75771	4493	4112343	1987-04-30	1987-04-30 00:00:00	1987-05-10	1987-05-10 00:00:00	32020		\N	299153	0	195662009	4112343		0
75941	4504	4112343	2017-12-05	2017-12-05 00:00:00	2017-12-18	2017-12-18 00:00:00	32020		\N	299942	0	195662009	4112343		0
76192	4521	260139	1972-12-10	1972-12-10 00:00:00	1972-12-17	1972-12-17 00:00:00	32020		\N	301006	0	10509002	260139		0
86870	5172	192671	1980-05-04	1980-05-04 00:00:00	\N	\N	32020		\N	343915	0	K92.2	35208414		0
87080	5185	4237458	1989-01-01	1989-01-01 00:00:00	1989-04-01	1989-04-01 00:00:00	32020		\N	344603	0	58150001	4237458		0
87172	5191	4112343	1977-01-19	1977-01-19 00:00:00	1977-01-26	1977-01-26 00:00:00	32020		\N	345115	0	195662009	4112343		0
87347	5199	78272	1971-01-29	1971-01-29 00:00:00	1971-02-12	1971-02-12 00:00:00	32020		\N	345724	0	70704007	78272		0
76993	4561	4112343	1954-05-25	1954-05-25 00:00:00	1954-06-03	1954-06-03 00:00:00	32020		\N	303907	0	195662009	4112343		0
77114	4569	40481087	2008-12-11	2008-12-11 00:00:00	2009-01-01	2009-01-01 00:00:00	32020		\N	304377	0	444814009	40481087		0
87900	5229	80180	2004-04-14	2004-04-14 00:00:00	\N	\N	32020		\N	347936	0	396275006	80180		0
88027	5235	40481087	1957-02-21	1957-02-21 00:00:00	1957-03-14	1957-03-14 00:00:00	32020		\N	348323	0	444814009	40481087		0
88198	5245	40481087	2018-01-18	2018-01-18 00:00:00	2018-01-25	2018-01-25 00:00:00	32020		\N	349048	0	444814009	40481087		0
88317	5252	440086	1964-12-01	1964-12-01 00:00:00	1965-10-26	1965-10-26 00:00:00	32020		\N	349454	0	192127007	440086		0
78184	4631	260139	1936-04-01	1936-04-01 00:00:00	1936-04-08	1936-04-08 00:00:00	32020		\N	308572	0	10509002	260139		0
78299	4636	40481087	1954-08-10	1954-08-10 00:00:00	1954-08-24	1954-08-24 00:00:00	32020		\N	308966	0	444814009	40481087		0
78472	4646	260139	2010-04-22	2010-04-22 00:00:00	2010-05-06	2010-05-06 00:00:00	32020		\N	309827	0	10509002	260139		0
78671	4657	4116491	1990-11-10	1990-11-10 00:00:00	1991-01-05	1991-01-05 00:00:00	32020		\N	310553	0	301011002	4116491		0
78821	4668	372328	1963-01-24	1963-01-24 00:00:00	1964-01-14	1964-01-14 00:00:00	32020		\N	311073	0	65363002	372328		0
89560	5325	28060	2009-02-28	2009-02-28 00:00:00	2009-03-08	2009-03-08 00:00:00	32020		\N	354494	0	43878008	28060		0
89670	5331	4112343	1977-03-30	1977-03-30 00:00:00	1977-04-06	1977-04-06 00:00:00	32020		\N	354900	0	195662009	4112343		0
79567	4713	40481087	2013-07-29	2013-07-29 00:00:00	2013-08-19	2013-08-19 00:00:00	32020		\N	313851	0	444814009	40481087		0
79817	4729	40481087	1977-12-05	1977-12-05 00:00:00	1977-12-26	1977-12-26 00:00:00	32020		\N	315050	0	444814009	40481087		0
80101	4748	4112343	1969-08-11	1969-08-11 00:00:00	1969-08-23	1969-08-23 00:00:00	32020		\N	316131	0	195662009	4112343		0
80209	4754	80180	2006-02-02	2006-02-02 00:00:00	\N	\N	32020		\N	316609	0	396275006	80180		0
81492	4834	378001	1991-12-04	1991-12-04 00:00:00	1992-01-03	1992-01-03 00:00:00	32020		\N	321547	0	62106007	378001		0
81665	4844	80180	2001-01-06	2001-01-06 00:00:00	\N	\N	32020		\N	322322	0	396275006	80180		0
81730	4848	80180	1996-08-24	1996-08-24 00:00:00	\N	\N	32020		\N	322519	0	396275006	80180		0
82082	4867	4112343	1975-04-22	1975-04-22 00:00:00	1975-05-04	1975-05-04 00:00:00	32020		\N	323709	0	195662009	4112343		0
82659	4907	4112343	1967-03-26	1967-03-26 00:00:00	1967-04-06	1967-04-06 00:00:00	32020		\N	326170	0	195662009	4112343		0
82787	4916	40481087	2013-01-11	2013-01-11 00:00:00	2013-01-25	2013-01-25 00:00:00	32020		\N	326665	0	444814009	40481087		0
82954	4927	378001	1991-09-28	1991-09-28 00:00:00	1991-11-27	1991-11-27 00:00:00	32020		\N	327478	0	62106007	378001		0
84213	5001	4112343	2010-01-31	2010-01-31 00:00:00	2010-02-12	2010-02-12 00:00:00	32020		\N	332657	0	195662009	4112343		0
85124	5063	40481087	1972-06-28	1972-06-28 00:00:00	1972-07-12	1972-07-12 00:00:00	32020		\N	336593	0	444814009	40481087		0
85290	5073	4142905	1936-04-07	1936-04-07 00:00:00	1936-07-06	1936-07-06 00:00:00	32020		\N	337159	0	33737001	4142905		0
85345	5077	40481087	1977-08-20	1977-08-20 00:00:00	1977-09-03	1977-09-03 00:00:00	32020		\N	337465	0	444814009	40481087		0
74992	4454	260139	1985-12-08	1985-12-08 00:00:00	1985-12-15	1985-12-15 00:00:00	32020		\N	296417	0	10509002	260139		0
75111	4460	4112343	1956-06-05	1956-06-05 00:00:00	1956-06-15	1956-06-15 00:00:00	32020		\N	296773	0	195662009	4112343		0
85849	5108	260139	1998-11-20	1998-11-20 00:00:00	1998-11-27	1998-11-27 00:00:00	32020		\N	339384	0	10509002	260139		0
75374	4475	4059173	1994-03-28	1994-03-28 00:00:00	1994-04-28	1994-04-28 00:00:00	32020		\N	297715	0	16114001	4059173		0
75663	4488	40481087	1979-12-28	1979-12-28 00:00:00	1980-01-18	1980-01-18 00:00:00	32020		\N	298779	0	444814009	40481087		0
75772	4493	40481087	2002-02-11	2002-02-11 00:00:00	2002-02-25	2002-02-25 00:00:00	32020		\N	299164	0	444814009	40481087		0
75942	4504	4059173	1978-01-20	1978-01-20 00:00:00	1978-03-21	1978-03-21 00:00:00	32020		\N	299900	0	16114001	4059173		0
76193	4521	40481087	1970-10-02	1970-10-02 00:00:00	1970-10-16	1970-10-16 00:00:00	32020		\N	301005	0	444814009	40481087		0
86871	5172	372328	1948-06-16	1948-06-16 00:00:00	1948-09-07	1948-09-07 00:00:00	32020		\N	343830	0	65363002	372328		0
87081	5185	378419	2009-12-07	2009-12-07 00:00:00	\N	\N	32020		\N	344664	0	26929004	378419		0
87173	5191	4112343	1990-07-18	1990-07-18 00:00:00	1990-07-28	1990-07-28 00:00:00	32020		\N	345116	0	195662009	4112343		0
87348	5199	40481087	2007-12-08	2007-12-08 00:00:00	2007-12-22	2007-12-22 00:00:00	32020		\N	345774	0	444814009	40481087		0
76994	4561	4296204	2004-12-24	2004-12-24 00:00:00	2005-01-07	2005-01-07 00:00:00	32020		\N	303949	0	403190006	4296204		0
77115	4569	4294548	1989-08-23	1989-08-23 00:00:00	1989-09-13	1989-09-13 00:00:00	32020		\N	304370	0	75498004	4294548		0
87901	5229	4059173	1989-10-06	1989-10-06 00:00:00	1989-11-05	1989-11-05 00:00:00	32020		\N	347869	0	16114001	4059173		0
88028	5235	40481087	1970-04-29	1970-04-29 00:00:00	1970-05-06	1970-05-06 00:00:00	32020		\N	348354	0	444814009	40481087		0
88199	5245	4112343	2006-04-29	2006-04-29 00:00:00	2006-05-12	2006-05-12 00:00:00	32020		\N	349047	0	195662009	4112343		0
88318	5252	4156265	2015-11-04	2015-11-04 00:00:00	2015-11-25	2015-11-25 00:00:00	32020		\N	349400	0	370247008	4156265		0
78185	4631	4112343	1979-08-31	1979-08-31 00:00:00	1979-09-08	1979-09-08 00:00:00	32020		\N	308578	0	195662009	4112343		0
78300	4636	40481087	1978-10-19	1978-10-19 00:00:00	1978-10-26	1978-10-26 00:00:00	32020		\N	308968	0	444814009	40481087		0
78473	4646	4283893	1960-03-14	1960-03-14 00:00:00	1960-04-11	1960-04-11 00:00:00	32020		\N	309785	0	36971009	4283893		0
78672	4657	260139	1977-06-12	1977-06-12 00:00:00	1977-06-26	1977-06-26 00:00:00	32020		\N	310550	0	10509002	260139		0
78822	4668	40481087	1962-06-08	1962-06-08 00:00:00	1962-06-29	1962-06-29 00:00:00	32020		\N	311075	0	444814009	40481087		0
89561	5325	28060	1952-10-03	1952-10-03 00:00:00	1952-10-14	1952-10-14 00:00:00	32020		\N	354455	0	43878008	28060		0
89671	5331	40481087	1984-08-11	1984-08-11 00:00:00	1984-08-25	1984-08-25 00:00:00	32020		\N	354918	0	444814009	40481087		0
79568	4713	440086	1975-01-05	1975-01-05 00:00:00	1984-01-13	1984-01-13 00:00:00	32020		\N	313827	0	192127007	440086		0
79818	4729	40481087	2009-11-11	2009-11-11 00:00:00	2009-12-02	2009-12-02 00:00:00	32020		\N	315052	0	444814009	40481087		0
80102	4748	260139	1970-08-16	1970-08-16 00:00:00	1970-08-30	1970-08-30 00:00:00	32020		\N	316132	0	10509002	260139		0
80210	4754	4218389	1991-06-22	1991-06-22 00:00:00	1991-07-27	1991-07-27 00:00:00	32020		\N	316637	0	39848009	4218389		0
81493	4834	40481087	1995-04-03	1995-04-03 00:00:00	1995-04-17	1995-04-17 00:00:00	32020		\N	321552	0	444814009	40481087		0
81666	4844	372328	2013-07-26	2013-07-26 00:00:00	2014-03-27	2014-03-27 00:00:00	32020		\N	322307	0	65363002	372328		0
81731	4848	30753	1995-05-02	1995-05-02 00:00:00	\N	\N	32020		\N	322519	0	16761005	30753		0
82083	4867	260139	1948-01-20	1948-01-20 00:00:00	1948-02-03	1948-02-03 00:00:00	32020		\N	323707	0	10509002	260139		0
82660	4907	28060	1992-09-14	1992-09-14 00:00:00	1992-09-24	1992-09-24 00:00:00	32020		\N	326100	0	43878008	28060		0
82788	4916	80180	2013-01-06	2013-01-06 00:00:00	\N	\N	32020		\N	326665	0	396275006	80180		0
82955	4927	372328	1983-06-02	1983-06-02 00:00:00	1983-07-08	1983-07-08 00:00:00	32020		\N	327439	0	65363002	372328		0
84214	5001	40481087	1991-04-18	1991-04-18 00:00:00	1991-05-02	1991-05-02 00:00:00	32020		\N	332654	0	444814009	40481087		0
85125	5063	4218389	2010-10-18	2010-10-18 00:00:00	2010-11-22	2010-11-22 00:00:00	32020		\N	336601	0	39848009	4218389		0
85291	5073	40481087	1951-06-12	1951-06-12 00:00:00	1951-07-03	1951-07-03 00:00:00	32020		\N	337235	0	444814009	40481087		0
85346	5077	260139	1998-12-12	1998-12-12 00:00:00	1998-12-19	1998-12-19 00:00:00	32020		\N	337444	0	10509002	260139		0
74993	4454	260139	2015-12-21	2015-12-21 00:00:00	2015-12-28	2015-12-28 00:00:00	32020		\N	296419	0	10509002	260139		0
75118	4462	4310024	1988-06-24	1988-06-24 00:00:00	\N	\N	32020		\N	296876	0	424802006	4310024		0
85850	5108	372328	1962-07-29	1962-07-29 00:00:00	1962-12-30	1962-12-30 00:00:00	32020		\N	339386	0	65363002	372328		0
75375	4475	4112343	1981-08-06	1981-08-06 00:00:00	1981-08-13	1981-08-13 00:00:00	32020		\N	297736	0	195662009	4112343		0
75664	4488	40481087	1987-10-29	1987-10-29 00:00:00	1987-11-12	1987-11-12 00:00:00	32020		\N	298790	0	444814009	40481087		0
75773	4493	260139	1989-11-13	1989-11-13 00:00:00	1989-11-27	1989-11-27 00:00:00	32020		\N	299162	0	10509002	260139		0
75943	4504	4294548	1995-07-06	1995-07-06 00:00:00	1995-07-20	1995-07-20 00:00:00	32020		\N	299930	0	75498004	4294548		0
76194	4521	81151	1992-09-23	1992-09-23 00:00:00	1992-10-07	1992-10-07 00:00:00	32020		\N	301014	0	44465007	81151		0
86872	5172	4112343	1975-11-30	1975-11-30 00:00:00	1975-12-10	1975-12-10 00:00:00	32020		\N	343854	0	195662009	4112343		0
87082	5185	40481087	1973-10-14	1973-10-14 00:00:00	1973-11-04	1973-11-04 00:00:00	32020		\N	344705	0	444814009	40481087		0
87174	5191	40481087	2003-01-21	2003-01-21 00:00:00	2003-02-04	2003-02-04 00:00:00	32020		\N	345099	0	444814009	40481087		0
87349	5199	4112343	1974-09-25	1974-09-25 00:00:00	1974-10-06	1974-10-06 00:00:00	32020		\N	345780	0	195662009	4112343		0
76995	4561	28060	1980-04-12	1980-04-12 00:00:00	1980-04-20	1980-04-20 00:00:00	32020		\N	303920	0	43878008	28060		0
77116	4569	80180	2002-08-01	2002-08-01 00:00:00	\N	\N	32020		\N	304391	0	396275006	80180		0
87902	5229	81151	1973-06-27	1973-06-27 00:00:00	1973-07-11	1973-07-11 00:00:00	32020		\N	347866	0	44465007	81151		0
88029	5235	4329847	1982-01-23	1982-01-23 00:00:00	\N	\N	32020		\N	348320	0	22298006	4329847		0
88200	5245	40481087	1984-09-10	1984-09-10 00:00:00	1984-09-24	1984-09-24 00:00:00	32020		\N	348986	0	444814009	40481087		0
88319	5252	261325	1997-04-08	1997-04-08 00:00:00	\N	\N	32020		\N	349479	0	87433001	261325		0
78186	4631	40481087	1923-05-27	1923-05-27 00:00:00	1923-06-17	1923-06-17 00:00:00	32020		\N	308579	0	444814009	40481087		0
78301	4636	4112343	2003-07-14	2003-07-14 00:00:00	2003-07-21	2003-07-21 00:00:00	32020		\N	308934	0	195662009	4112343		0
78474	4646	4283893	1970-09-23	1970-09-23 00:00:00	1971-01-13	1971-01-13 00:00:00	32020		\N	309760	0	36971009	4283893		0
78673	4657	40481087	2001-09-08	2001-09-08 00:00:00	2001-09-22	2001-09-22 00:00:00	32020		\N	310554	0	444814009	40481087		0
78823	4668	40481087	1976-01-26	1976-01-26 00:00:00	1976-02-16	1976-02-16 00:00:00	32020		\N	311076	0	444814009	40481087		0
89562	5325	4283893	1996-08-03	1996-08-03 00:00:00	1996-12-21	1996-12-21 00:00:00	32020		\N	354448	0	36971009	4283893		0
89672	5331	80180	2004-09-03	2004-09-03 00:00:00	\N	\N	32020		\N	354941	0	396275006	80180		0
79569	4713	4112343	1990-12-28	1990-12-28 00:00:00	1991-01-10	1991-01-10 00:00:00	32020		\N	313830	0	195662009	4112343		0
79819	4729	4059173	1967-11-07	1967-11-07 00:00:00	1968-01-06	1968-01-06 00:00:00	32020		\N	315104	0	16114001	4059173		0
80103	4748	4112343	1978-04-25	1978-04-25 00:00:00	1978-05-02	1978-05-02 00:00:00	32020		\N	316159	0	195662009	4112343		0
80211	4754	260139	1968-07-03	1968-07-03 00:00:00	1968-07-17	1968-07-17 00:00:00	32020		\N	316653	0	10509002	260139		0
81494	4834	81151	1994-02-21	1994-02-21 00:00:00	1994-03-14	1994-03-14 00:00:00	32020		\N	321548	0	44465007	81151		0
81667	4844	40481087	1978-06-05	1978-06-05 00:00:00	1978-06-19	1978-06-19 00:00:00	32020		\N	322287	0	444814009	40481087		0
81732	4848	4310024	1995-02-01	1995-02-01 00:00:00	\N	\N	32020		\N	322519	0	424802006	4310024		0
82084	4867	4134304	1979-09-08	1979-09-08 00:00:00	1979-11-07	1979-11-07 00:00:00	32020		\N	323684	0	263102004	4134304		0
82661	4907	80180	1984-09-10	1984-09-10 00:00:00	\N	\N	32020		\N	326158	0	396275006	80180		0
82789	4916	4156265	1978-06-24	1978-06-24 00:00:00	1978-07-08	1978-07-08 00:00:00	32020		\N	326697	0	370247008	4156265		0
82956	4927	4109685	2000-10-10	2000-10-10 00:00:00	2000-10-24	2000-10-24 00:00:00	32020		\N	327479	0	284551006	4109685		0
84215	5001	4112343	1963-04-10	1963-04-10 00:00:00	1963-04-22	1963-04-22 00:00:00	32020		\N	332644	0	195662009	4112343		0
85126	5063	260139	1985-08-11	1985-08-11 00:00:00	1985-08-18	1985-08-18 00:00:00	32020		\N	336634	0	10509002	260139		0
85292	5073	317576	2009-08-29	2009-08-29 00:00:00	\N	\N	32020		\N	337182	0	53741008	317576		0
85347	5077	260139	2006-02-10	2006-02-10 00:00:00	2006-02-17	2006-02-17 00:00:00	32020		\N	337467	0	10509002	260139		0
74994	4454	313217	2006-10-07	2006-10-07 00:00:00	\N	\N	32020		\N	296468	0	49436004	313217		0
75119	4462	40481087	1965-08-14	1965-08-14 00:00:00	1965-09-04	1965-09-04 00:00:00	32020		\N	296932	0	444814009	40481087		0
85851	5108	81151	1967-08-20	1967-08-20 00:00:00	1967-09-17	1967-09-17 00:00:00	32020		\N	339381	0	44465007	81151		0
75376	4475	260139	2012-09-10	2012-09-10 00:00:00	2012-09-17	2012-09-17 00:00:00	32020		\N	297706	0	10509002	260139		0
87252	5195	81893	1994-03-05	1994-03-05 00:00:00	\N	\N	32020		\N	345465	0	64766004	81893		0
75665	4488	4218389	1990-08-16	1990-08-16 00:00:00	1990-09-06	1990-09-06 00:00:00	32020		\N	298830	0	39848009	4218389		0
75774	4493	260139	1995-06-05	1995-06-05 00:00:00	1995-06-12	1995-06-12 00:00:00	32020		\N	299154	0	10509002	260139		0
75944	4504	4112343	2007-04-18	2007-04-18 00:00:00	2007-04-29	2007-04-29 00:00:00	32020		\N	299948	0	195662009	4112343		0
86676	5157	4112343	2007-01-14	2007-01-14 00:00:00	2007-01-26	2007-01-26 00:00:00	32020		\N	342931	0	195662009	4112343		0
86873	5172	375671	1951-11-28	1951-11-28 00:00:00	1951-12-28	1951-12-28 00:00:00	32020		\N	343916	0	62564004	375671		0
87083	5185	40481087	2013-02-04	2013-02-04 00:00:00	2013-02-25	2013-02-25 00:00:00	32020		\N	344681	0	444814009	40481087		0
87175	5191	81151	1981-05-20	1981-05-20 00:00:00	1981-06-03	1981-06-03 00:00:00	32020		\N	345062	0	44465007	81151		0
87350	5199	372328	1966-08-23	1966-08-23 00:00:00	1966-10-18	1966-10-18 00:00:00	32020		\N	345736	0	65363002	372328		0
76996	4562	4112343	1993-10-23	1993-10-23 00:00:00	1993-11-04	1993-11-04 00:00:00	32020		\N	303983	0	195662009	4112343		0
77117	4569	40481087	1971-01-14	1971-01-14 00:00:00	1971-01-21	1971-01-21 00:00:00	32020		\N	304398	0	444814009	40481087		0
87903	5230	4112343	1953-03-25	1953-03-25 00:00:00	1953-04-05	1953-04-05 00:00:00	32020		\N	347947	0	195662009	4112343		0
88031	5235	372328	1927-01-31	1927-01-31 00:00:00	1927-08-27	1927-08-27 00:00:00	32020		\N	348328	0	65363002	372328		0
88201	5245	4294548	1985-05-31	1985-05-31 00:00:00	1985-08-09	1985-08-09 00:00:00	32020		\N	348987	0	75498004	4294548		0
88320	5252	40481087	1978-09-04	1978-09-04 00:00:00	1978-09-11	1978-09-11 00:00:00	32020		\N	349443	0	444814009	40481087		0
88645	5272	260139	2013-02-17	2013-02-17 00:00:00	2013-03-03	2013-03-03 00:00:00	32020		\N	350632	0	10509002	260139		0
78302	4636	4112343	2007-12-30	2007-12-30 00:00:00	2008-01-09	2008-01-09 00:00:00	32020		\N	308970	0	195662009	4112343		0
78475	4646	4294548	1979-08-08	1979-08-08 00:00:00	1980-01-02	1980-01-02 00:00:00	32020		\N	309723	0	75498004	4294548		0
78676	4660	40481087	1983-05-14	1983-05-14 00:00:00	1983-05-28	1983-05-28 00:00:00	32020		\N	310598	0	444814009	40481087		0
78824	4668	4112343	2018-09-02	2018-09-02 00:00:00	2018-09-13	2018-09-13 00:00:00	32020		\N	311083	0	195662009	4112343		0
89579	5328	4113008	1995-09-13	1995-09-13 00:00:00	1995-09-27	1995-09-27 00:00:00	32020		\N	354591	0	284549007	4113008		0
89673	5331	4112343	1983-06-06	1983-06-06 00:00:00	1983-06-19	1983-06-19 00:00:00	32020		\N	354901	0	195662009	4112343		0
79570	4713	4112343	1969-11-19	1969-11-19 00:00:00	1969-11-29	1969-11-29 00:00:00	32020		\N	313826	0	195662009	4112343		0
79820	4729	40481087	1968-03-14	1968-03-14 00:00:00	1968-03-21	1968-03-21 00:00:00	32020		\N	315082	0	444814009	40481087		0
80104	4748	40481087	2016-08-19	2016-08-19 00:00:00	2016-08-26	2016-08-26 00:00:00	32020		\N	316206	0	444814009	40481087		0
80212	4755	4116491	1981-10-24	1981-10-24 00:00:00	1981-11-25	1981-11-25 00:00:00	32020		\N	316727	0	301011002	4116491		0
81495	4834	4112343	2009-03-15	2009-03-15 00:00:00	2009-03-25	2009-03-25 00:00:00	32020		\N	321606	0	195662009	4112343		0
81668	4844	4218389	1981-05-15	1981-05-15 00:00:00	1981-06-19	1981-06-19 00:00:00	32020		\N	322283	0	39848009	4218389		0
81733	4848	4266809	1996-08-24	1996-08-24 00:00:00	\N	\N	32020		\N	322519	0	397881000	4266809		0
82085	4867	4112343	2003-03-23	2003-03-23 00:00:00	2003-04-05	2003-04-05 00:00:00	32020		\N	323610	0	195662009	4112343		0
82662	4907	260139	1959-10-28	1959-10-28 00:00:00	1959-11-04	1959-11-04 00:00:00	32020		\N	326128	0	10509002	260139		0
82790	4916	4059173	1990-03-07	1990-03-07 00:00:00	1990-04-06	1990-04-06 00:00:00	32020		\N	326698	0	16114001	4059173		0
82957	4927	80180	2017-06-27	2017-06-27 00:00:00	\N	\N	32020		\N	327496	0	396275006	80180		0
84216	5001	260139	2000-06-07	2000-06-07 00:00:00	2000-06-21	2000-06-21 00:00:00	32020		\N	332655	0	10509002	260139		0
85127	5063	40481087	2000-03-21	2000-03-21 00:00:00	2000-04-11	2000-04-11 00:00:00	32020		\N	336595	0	444814009	40481087		0
85293	5073	81151	1937-06-01	1937-06-01 00:00:00	1937-06-22	1937-06-22 00:00:00	32020		\N	337160	0	44465007	81151		0
85348	5077	4112343	1973-10-05	1973-10-05 00:00:00	1973-10-17	1973-10-17 00:00:00	32020		\N	337435	0	195662009	4112343		0
74995	4454	378001	2012-05-25	2012-05-25 00:00:00	2012-07-24	2012-07-24 00:00:00	32020		\N	296505	0	62106007	378001		0
75120	4462	192671	1990-10-23	1990-10-23 00:00:00	\N	\N	32020		\N	296951	0	K92.2	35208414		0
85852	5108	4278672	1974-03-14	1974-03-14 00:00:00	1974-04-13	1974-04-13 00:00:00	32020		\N	339382	0	65966004	4278672		0
75377	4475	260139	2014-10-18	2014-10-18 00:00:00	2014-10-25	2014-10-25 00:00:00	32020		\N	297742	0	10509002	260139		0
75666	4488	40481087	1984-06-03	1984-06-03 00:00:00	1984-06-17	1984-06-17 00:00:00	32020		\N	298780	0	444814009	40481087		0
75775	4493	80180	2017-01-29	2017-01-29 00:00:00	\N	\N	32020		\N	299185	0	396275006	80180		0
75945	4504	40481087	2018-06-14	2018-06-14 00:00:00	2018-07-05	2018-07-05 00:00:00	32020		\N	299907	0	444814009	40481087		0
86677	5157	260139	1980-08-10	1980-08-10 00:00:00	1980-08-24	1980-08-24 00:00:00	32020		\N	342881	0	10509002	260139		0
86874	5172	4266809	1980-03-15	1980-03-15 00:00:00	\N	\N	32020		\N	343876	0	397881000	4266809		0
87084	5185	40481087	1992-10-31	1992-10-31 00:00:00	1992-11-21	1992-11-21 00:00:00	32020		\N	344655	0	444814009	40481087		0
87176	5191	260139	2014-09-03	2014-09-03 00:00:00	2014-09-10	2014-09-10 00:00:00	32020		\N	345090	0	10509002	260139		0
87351	5199	40481087	1980-09-12	1980-09-12 00:00:00	1980-09-26	1980-09-26 00:00:00	32020		\N	345773	0	444814009	40481087		0
76997	4562	40481087	1972-12-02	1972-12-02 00:00:00	1972-12-16	1972-12-16 00:00:00	32020		\N	303979	0	444814009	40481087		0
77118	4569	4112343	1976-06-09	1976-06-09 00:00:00	1976-06-18	1976-06-18 00:00:00	32020		\N	304399	0	195662009	4112343		0
87904	5230	378001	2008-08-30	2008-08-30 00:00:00	2008-09-29	2008-09-29 00:00:00	32020		\N	347942	0	62106007	378001		0
88032	5235	40481087	1961-10-08	1961-10-08 00:00:00	1961-10-15	1961-10-15 00:00:00	32020		\N	348324	0	444814009	40481087		0
88202	5245	260139	1990-12-02	1990-12-02 00:00:00	1990-12-16	1990-12-16 00:00:00	32020		\N	348971	0	10509002	260139		0
88321	5252	378001	2010-02-03	2010-02-03 00:00:00	2010-03-05	2010-03-05 00:00:00	32020		\N	349452	0	62106007	378001		0
88646	5272	4112343	1959-06-24	1959-06-24 00:00:00	1959-07-02	1959-07-02 00:00:00	32020		\N	350672	0	195662009	4112343		0
78303	4636	81151	1962-02-08	1962-02-08 00:00:00	1962-02-22	1962-02-22 00:00:00	32020		\N	308978	0	44465007	81151		0
78476	4646	4156265	1946-09-16	1946-09-16 00:00:00	1946-09-30	1946-09-30 00:00:00	32020		\N	309737	0	370247008	4156265		0
78677	4660	81151	1989-07-19	1989-07-19 00:00:00	1989-08-23	1989-08-23 00:00:00	32020		\N	310652	0	44465007	81151		0
78825	4668	4112343	1989-03-25	1989-03-25 00:00:00	1989-04-06	1989-04-06 00:00:00	32020		\N	311079	0	195662009	4112343		0
89580	5328	80502	2000-01-26	2000-01-26 00:00:00	\N	\N	32020		\N	354600	0	64859006	80502		0
89674	5331	40481087	1973-02-13	1973-02-13 00:00:00	1973-02-20	1973-02-20 00:00:00	32020		\N	354904	0	444814009	40481087		0
79573	4715	260139	1996-07-14	1996-07-14 00:00:00	1996-07-28	1996-07-28 00:00:00	32020		\N	313933	0	10509002	260139		0
79821	4729	260139	2018-07-02	2018-07-02 00:00:00	2018-07-09	2018-07-09 00:00:00	32020		\N	315088	0	10509002	260139		0
80105	4748	4218389	1965-05-19	1965-05-19 00:00:00	1965-06-23	1965-06-23 00:00:00	32020		\N	316218	0	39848009	4218389		0
80213	4755	40481087	2001-09-18	2001-09-18 00:00:00	2001-10-02	2001-10-02 00:00:00	32020		\N	316775	0	444814009	40481087		0
81496	4834	372328	1962-06-21	1962-06-21 00:00:00	1962-10-21	1962-10-21 00:00:00	32020		\N	321554	0	65363002	372328		0
81669	4844	4278672	1965-12-05	1965-12-05 00:00:00	1966-02-03	1966-02-03 00:00:00	32020		\N	322279	0	65966004	4278672		0
81734	4848	195588	2003-09-02	2003-09-02 00:00:00	2003-10-06	2003-10-06 00:00:00	32020		\N	322546	0	38822007	195588		0
82086	4867	4112343	1983-05-26	1983-05-26 00:00:00	1983-06-04	1983-06-04 00:00:00	32020		\N	323710	0	195662009	4112343		0
82663	4907	40481087	1948-05-31	1948-05-31 00:00:00	1948-06-07	1948-06-07 00:00:00	32020		\N	326126	0	444814009	40481087		0
82791	4916	260139	1989-05-06	1989-05-06 00:00:00	1989-05-20	1989-05-20 00:00:00	32020		\N	326715	0	10509002	260139		0
82958	4927	260139	2016-12-09	2016-12-09 00:00:00	2016-12-16	2016-12-16 00:00:00	32020		\N	327496	0	10509002	260139		0
84217	5001	4146173	1964-03-02	1964-03-02 00:00:00	1964-04-01	1964-04-01 00:00:00	32020		\N	332636	0	307731004	4146173		0
85128	5063	260139	1999-06-08	1999-06-08 00:00:00	1999-06-22	1999-06-22 00:00:00	32020		\N	336570	0	10509002	260139		0
85294	5073	40481087	2010-02-18	2010-02-18 00:00:00	2010-02-25	2010-02-25 00:00:00	32020		\N	337234	0	444814009	40481087		0
85349	5077	378001	1976-10-29	1976-10-29 00:00:00	1976-11-28	1976-11-28 00:00:00	32020		\N	337489	0	62106007	378001		0
74996	4454	4134304	1998-02-17	1998-02-17 00:00:00	1998-04-18	1998-04-18 00:00:00	32020		\N	296502	0	263102004	4134304		0
75121	4462	260139	1997-05-20	1997-05-20 00:00:00	1997-06-03	1997-06-03 00:00:00	32020		\N	296893	0	10509002	260139		0
85853	5108	260139	1962-04-19	1962-04-19 00:00:00	1962-05-04	1962-05-04 00:00:00	32020		\N	339365	0	10509002	260139		0
75378	4475	375671	1995-04-23	1995-04-23 00:00:00	1995-05-23	1995-05-23 00:00:00	32020		\N	297716	0	62564004	375671		0
75667	4488	4283893	1978-03-30	1978-03-30 00:00:00	1978-06-29	1978-06-29 00:00:00	32020		\N	298796	0	36971009	4283893		0
75786	4496	4112343	1970-01-26	1970-01-26 00:00:00	1970-02-04	1970-02-04 00:00:00	32020		\N	299311	0	195662009	4112343		0
75946	4504	4059173	1992-03-07	1992-03-07 00:00:00	1992-05-06	1992-05-06 00:00:00	32020		\N	299901	0	16114001	4059173		0
86678	5157	40481087	2004-11-04	2004-11-04 00:00:00	2004-11-18	2004-11-18 00:00:00	32020		\N	342906	0	444814009	40481087		0
86875	5172	40481087	1980-02-14	1980-02-14 00:00:00	1980-03-06	1980-03-06 00:00:00	32020		\N	343876	0	444814009	40481087		0
87085	5185	260139	1993-01-01	1993-01-01 00:00:00	1993-01-15	1993-01-15 00:00:00	32020		\N	344706	0	10509002	260139		0
87177	5191	4112343	2013-02-13	2013-02-13 00:00:00	2013-02-21	2013-02-21 00:00:00	32020		\N	345101	0	195662009	4112343		0
87352	5199	4116491	2011-01-04	2011-01-04 00:00:00	2011-02-17	2011-02-17 00:00:00	32020		\N	345790	0	301011002	4116491		0
76998	4562	4112343	1963-08-20	1963-08-20 00:00:00	1963-08-31	1963-08-31 00:00:00	32020		\N	304031	0	195662009	4112343		0
77119	4570	372328	1937-09-20	1937-09-20 00:00:00	1938-01-01	1938-01-01 00:00:00	32020		\N	304467	0	65363002	372328		0
87905	5230	4112343	1990-01-22	1990-01-22 00:00:00	1990-02-02	1990-02-02 00:00:00	32020		\N	347959	0	195662009	4112343		0
88033	5235	40481087	1966-10-27	1966-10-27 00:00:00	1966-11-10	1966-11-10 00:00:00	32020		\N	348318	0	444814009	40481087		0
88203	5245	4112343	2011-02-16	2011-02-16 00:00:00	2011-02-28	2011-02-28 00:00:00	32020		\N	348955	0	195662009	4112343		0
88322	5252	192671	1995-12-19	1995-12-19 00:00:00	\N	\N	32020		\N	349449	0	K92.2	35208414		0
88647	5272	4112343	1923-09-09	1923-09-09 00:00:00	1923-09-18	1923-09-18 00:00:00	32020		\N	350652	0	195662009	4112343		0
78304	4636	4156265	1948-05-08	1948-05-08 00:00:00	1948-05-22	1948-05-22 00:00:00	32020		\N	308977	0	370247008	4156265		0
78477	4646	40481087	2012-05-26	2012-05-26 00:00:00	2012-06-02	2012-06-02 00:00:00	32020		\N	309879	0	444814009	40481087		0
78678	4660	40481087	2001-05-31	2001-05-31 00:00:00	2001-06-07	2001-06-07 00:00:00	32020		\N	310660	0	444814009	40481087		0
78826	4668	372328	1957-03-31	1957-03-31 00:00:00	1957-06-18	1957-06-18 00:00:00	32020		\N	311092	0	65363002	372328		0
89581	5328	28060	1954-08-04	1954-08-04 00:00:00	1954-08-14	1954-08-14 00:00:00	32020		\N	354707	0	43878008	28060		0
89675	5331	40481087	1982-02-11	1982-02-11 00:00:00	1982-02-18	1982-02-18 00:00:00	32020		\N	354911	0	444814009	40481087		0
79574	4715	40481087	2016-03-30	2016-03-30 00:00:00	2016-04-06	2016-04-06 00:00:00	32020		\N	313929	0	444814009	40481087		0
79822	4729	40481087	1993-07-23	1993-07-23 00:00:00	1993-07-30	1993-07-30 00:00:00	32020		\N	315091	0	444814009	40481087		0
80106	4748	4059173	1984-10-25	1984-10-25 00:00:00	1984-12-24	1984-12-24 00:00:00	32020		\N	316221	0	16114001	4059173		0
80215	4755	40481087	1932-03-06	1932-03-06 00:00:00	1932-03-13	1932-03-13 00:00:00	32020		\N	316712	0	444814009	40481087		0
81497	4834	195588	2016-05-01	2016-05-01 00:00:00	2016-06-21	2016-06-21 00:00:00	32020		\N	321553	0	38822007	195588		0
81670	4844	40481087	2005-03-28	2005-03-28 00:00:00	2005-04-04	2005-04-04 00:00:00	32020		\N	322305	0	444814009	40481087		0
81735	4848	260139	2003-10-25	2003-10-25 00:00:00	2003-11-01	2003-11-01 00:00:00	32020		\N	322509	0	10509002	260139		0
82087	4867	28060	2006-09-19	2006-09-19 00:00:00	2006-09-29	2006-09-29 00:00:00	32020		\N	323727	0	43878008	28060		0
82664	4907	40481087	2001-04-11	2001-04-11 00:00:00	2001-04-25	2001-04-25 00:00:00	32020		\N	326136	0	444814009	40481087		0
82792	4916	4112343	1981-01-13	1981-01-13 00:00:00	1981-01-25	1981-01-25 00:00:00	32020		\N	326709	0	195662009	4112343		0
82959	4927	4112343	1983-01-23	1983-01-23 00:00:00	1983-01-30	1983-01-30 00:00:00	32020		\N	327481	0	195662009	4112343		0
84218	5001	40479422	1975-04-25	1975-04-25 00:00:00	1975-07-01	1975-07-01 00:00:00	32020		\N	332670	0	444448004	40479422		0
85129	5063	4027663	1973-03-27	1973-03-27 00:00:00	\N	\N	32020		\N	336658	0	13200003	4027663		0
85295	5073	372328	1937-05-15	1937-05-15 00:00:00	1937-09-18	1937-09-18 00:00:00	32020		\N	337199	0	65363002	372328		0
85350	5077	4112343	2007-09-04	2007-09-04 00:00:00	2007-09-11	2007-09-11 00:00:00	32020		\N	337449	0	195662009	4112343		0
74997	4454	4278672	1932-04-26	1932-04-26 00:00:00	1932-06-25	1932-06-25 00:00:00	32020		\N	296492	0	65966004	4278672		0
75122	4462	40481087	1966-06-07	1966-06-07 00:00:00	1966-06-21	1966-06-21 00:00:00	32020		\N	296912	0	444814009	40481087		0
85854	5108	40481087	2009-03-26	2009-03-26 00:00:00	2009-04-16	2009-04-16 00:00:00	32020		\N	339402	0	444814009	40481087		0
75379	4475	260139	1992-10-06	1992-10-06 00:00:00	1992-10-13	1992-10-13 00:00:00	32020		\N	297738	0	10509002	260139		0
75668	4488	28060	2011-11-23	2011-11-23 00:00:00	2011-11-30	2011-11-30 00:00:00	32020		\N	298823	0	43878008	28060		0
75787	4496	40481087	2015-05-31	2015-05-31 00:00:00	2015-06-14	2015-06-14 00:00:00	32020		\N	299274	0	444814009	40481087		0
75947	4504	40481087	1987-04-20	1987-04-20 00:00:00	1987-05-11	1987-05-11 00:00:00	32020		\N	299947	0	444814009	40481087		0
86679	5157	40481087	1967-02-27	1967-02-27 00:00:00	1967-03-06	1967-03-06 00:00:00	32020		\N	342880	0	444814009	40481087		0
86876	5172	80180	1980-03-15	1980-03-15 00:00:00	\N	\N	32020		\N	343876	0	396275006	80180		0
87086	5185	40481087	1965-05-23	1965-05-23 00:00:00	1965-06-06	1965-06-06 00:00:00	32020		\N	344636	0	444814009	40481087		0
87178	5191	4112343	1990-10-29	1990-10-29 00:00:00	1990-11-09	1990-11-09 00:00:00	32020		\N	345117	0	195662009	4112343		0
87353	5199	4112343	1971-03-31	1971-03-31 00:00:00	1971-04-11	1971-04-11 00:00:00	32020		\N	345767	0	195662009	4112343		0
76999	4562	4035415	1984-12-28	1984-12-28 00:00:00	1985-01-27	1985-01-27 00:00:00	32020		\N	303955	0	239720000	4035415		0
77120	4570	40481087	1973-03-24	1973-03-24 00:00:00	1973-04-14	1973-04-14 00:00:00	32020		\N	304451	0	444814009	40481087		0
87906	5230	4112343	1974-02-17	1974-02-17 00:00:00	1974-02-24	1974-02-24 00:00:00	32020		\N	347981	0	195662009	4112343		0
88034	5235	40481087	1958-06-15	1958-06-15 00:00:00	1958-07-06	1958-07-06 00:00:00	32020		\N	348316	0	444814009	40481087		0
88204	5245	375671	2003-07-08	2003-07-08 00:00:00	2003-08-07	2003-08-07 00:00:00	32020		\N	348936	0	62564004	375671		0
88323	5252	78272	1973-09-10	1973-09-10 00:00:00	1973-09-24	1973-09-24 00:00:00	32020		\N	349399	0	70704007	78272		0
88648	5272	40481087	1932-11-29	1932-11-29 00:00:00	1932-12-06	1932-12-06 00:00:00	32020		\N	350669	0	444814009	40481087		0
78305	4636	4112343	2000-11-14	2000-11-14 00:00:00	2000-11-23	2000-11-23 00:00:00	32020		\N	308969	0	195662009	4112343		0
78478	4646	257012	1979-11-14	1979-11-14 00:00:00	\N	\N	32020		\N	309787	0	40055000	257012		0
78679	4660	40481087	1999-02-22	1999-02-22 00:00:00	1999-03-08	1999-03-08 00:00:00	32020		\N	310659	0	444814009	40481087		0
78827	4668	372328	1958-07-13	1958-07-13 00:00:00	1958-12-16	1958-12-16 00:00:00	32020		\N	311038	0	65363002	372328		0
89582	5328	260139	1993-12-17	1993-12-17 00:00:00	1993-12-24	1993-12-24 00:00:00	32020		\N	354712	0	10509002	260139		0
89676	5331	40481087	2001-07-21	2001-07-21 00:00:00	2001-08-11	2001-08-11 00:00:00	32020		\N	354926	0	444814009	40481087		0
80279	4757	81893	1993-08-11	1993-08-11 00:00:00	\N	\N	32020		\N	316947	0	64766004	81893		0
79575	4715	40481087	1978-02-01	1978-02-01 00:00:00	1978-02-15	1978-02-15 00:00:00	32020		\N	313927	0	444814009	40481087		0
79823	4729	40481087	1984-08-26	1984-08-26 00:00:00	1984-09-02	1984-09-02 00:00:00	32020		\N	315090	0	444814009	40481087		0
80107	4748	4112343	1963-12-28	1963-12-28 00:00:00	1964-01-06	1964-01-06 00:00:00	32020		\N	316129	0	195662009	4112343		0
80216	4755	4237458	1925-12-02	1925-12-02 00:00:00	1926-03-02	1926-03-02 00:00:00	32020		\N	316706	0	58150001	4237458		0
81498	4834	372328	1962-02-04	1962-02-04 00:00:00	1962-04-22	1962-04-22 00:00:00	32020		\N	321570	0	65363002	372328		0
81671	4844	260139	1993-10-19	1993-10-19 00:00:00	1993-10-26	1993-10-26 00:00:00	32020		\N	322266	0	10509002	260139		0
81736	4848	40481087	2016-11-25	2016-11-25 00:00:00	2016-12-09	2016-12-09 00:00:00	32020		\N	322566	0	444814009	40481087		0
82088	4867	40481087	2011-10-17	2011-10-17 00:00:00	2011-10-31	2011-10-31 00:00:00	32020		\N	323672	0	444814009	40481087		0
82665	4907	40481087	1950-04-07	1950-04-07 00:00:00	1950-04-14	1950-04-14 00:00:00	32020		\N	326134	0	444814009	40481087		0
82793	4916	40481087	2000-07-13	2000-07-13 00:00:00	2000-07-20	2000-07-20 00:00:00	32020		\N	326699	0	444814009	40481087		0
82960	4927	372328	1977-10-20	1977-10-20 00:00:00	1977-12-30	1977-12-30 00:00:00	32020		\N	327488	0	65363002	372328		0
84219	5001	260139	2006-12-19	2006-12-19 00:00:00	2006-12-26	2006-12-26 00:00:00	32020		\N	332638	0	10509002	260139		0
85130	5063	4283893	1969-01-05	1969-01-05 00:00:00	1969-09-21	1969-09-21 00:00:00	32020		\N	336533	0	36971009	4283893		0
85296	5073	40481087	1966-04-16	1966-04-16 00:00:00	1966-04-30	1966-04-30 00:00:00	32020		\N	337196	0	444814009	40481087		0
85351	5077	372328	1973-11-30	1973-11-30 00:00:00	1974-03-13	1974-03-13 00:00:00	32020		\N	337450	0	65363002	372328		0
74998	4454	4237458	1950-02-15	1950-02-15 00:00:00	1950-04-16	1950-04-16 00:00:00	32020		\N	296498	0	58150001	4237458		0
75123	4462	4116491	1984-01-27	1984-01-27 00:00:00	1984-03-15	1984-03-15 00:00:00	32020		\N	296941	0	301011002	4116491		0
85855	5108	317576	2012-12-30	2012-12-30 00:00:00	\N	\N	32020		\N	339398	0	53741008	317576		0
75380	4475	4134304	1988-08-27	1988-08-27 00:00:00	1988-10-26	1988-10-26 00:00:00	32020		\N	297714	0	263102004	4134304		0
75669	4488	40481087	1994-01-16	1994-01-16 00:00:00	1994-02-06	1994-02-06 00:00:00	32020		\N	298810	0	444814009	40481087		0
75788	4496	4296205	2006-10-11	2006-10-11 00:00:00	2006-11-01	2006-11-01 00:00:00	32020		\N	299308	0	403191005	4296205		0
75948	4504	260139	1970-08-01	1970-08-01 00:00:00	1970-08-15	1970-08-15 00:00:00	32020		\N	299927	0	10509002	260139		0
86680	5157	4112343	1991-12-24	1991-12-24 00:00:00	1992-01-01	1992-01-01 00:00:00	32020		\N	342882	0	195662009	4112343		0
86877	5172	260139	1967-06-08	1967-06-08 00:00:00	1967-06-22	1967-06-22 00:00:00	32020		\N	343852	0	10509002	260139		0
87087	5185	4112343	1964-11-16	1964-11-16 00:00:00	1964-11-24	1964-11-24 00:00:00	32020		\N	344650	0	195662009	4112343		0
87179	5191	378001	2015-05-06	2015-05-06 00:00:00	2015-07-05	2015-07-05 00:00:00	32020		\N	345063	0	62106007	378001		0
87354	5199	40481087	2010-10-13	2010-10-13 00:00:00	2010-11-03	2010-11-03 00:00:00	32020		\N	345789	0	444814009	40481087		0
77000	4562	4156265	1966-07-01	1966-07-01 00:00:00	1966-07-15	1966-07-15 00:00:00	32020		\N	303951	0	370247008	4156265		0
77121	4570	4112343	2009-08-28	2009-08-28 00:00:00	2009-09-09	2009-09-09 00:00:00	32020		\N	304432	0	195662009	4112343		0
87907	5230	40481087	1985-09-26	1985-09-26 00:00:00	1985-10-03	1985-10-03 00:00:00	32020		\N	347958	0	444814009	40481087		0
88035	5235	4109685	1954-01-15	1954-01-15 00:00:00	1954-01-29	1954-01-29 00:00:00	32020		\N	348365	0	284551006	4109685		0
88205	5245	4112343	2016-01-07	2016-01-07 00:00:00	2016-01-15	2016-01-15 00:00:00	32020		\N	349035	0	195662009	4112343		0
88324	5252	4112343	1992-01-23	1992-01-23 00:00:00	1992-01-31	1992-01-31 00:00:00	32020		\N	349388	0	195662009	4112343		0
88649	5272	80502	1977-02-09	1977-02-09 00:00:00	\N	\N	32020		\N	350685	0	64859006	80502		0
78306	4636	80502	2006-08-15	2006-08-15 00:00:00	\N	\N	32020		\N	308943	0	64859006	80502		0
78480	4646	28060	1977-01-23	1977-01-23 00:00:00	1977-02-02	1977-02-02 00:00:00	32020		\N	309786	0	43878008	28060		0
78680	4660	40481087	2005-06-24	2005-06-24 00:00:00	2005-07-15	2005-07-15 00:00:00	32020		\N	310661	0	444814009	40481087		0
78828	4668	4134304	1985-06-02	1985-06-02 00:00:00	1985-08-31	1985-08-31 00:00:00	32020		\N	311085	0	263102004	4134304		0
89583	5328	260139	1934-03-01	1934-03-01 00:00:00	1934-03-08	1934-03-08 00:00:00	32020		\N	354704	0	10509002	260139		0
89677	5331	40481087	1993-07-14	1993-07-14 00:00:00	1993-07-28	1993-07-28 00:00:00	32020		\N	354959	0	444814009	40481087		0
79576	4715	4112343	2016-12-27	2016-12-27 00:00:00	2017-01-06	2017-01-06 00:00:00	32020		\N	313930	0	195662009	4112343		0
79824	4729	4112343	2009-01-29	2009-01-29 00:00:00	2009-02-05	2009-02-05 00:00:00	32020		\N	315051	0	195662009	4112343		0
80108	4748	260139	1959-03-23	1959-03-23 00:00:00	1959-04-06	1959-04-06 00:00:00	32020		\N	316157	0	10509002	260139		0
80217	4755	440448	1933-11-06	1933-11-06 00:00:00	\N	\N	32020		\N	316708	0	74400008	440448		0
81499	4834	260139	1983-09-13	1983-09-13 00:00:00	1983-09-27	1983-09-27 00:00:00	32020		\N	321551	0	10509002	260139		0
81672	4844	4084167	1978-03-27	1978-03-27 00:00:00	1978-03-27	1978-03-27 00:00:00	32020		\N	322282	0	241929008	4084167		0
81737	4848	4112343	1959-03-13	1959-03-13 00:00:00	1959-03-22	1959-03-22 00:00:00	32020		\N	322491	0	195662009	4112343		0
82089	4867	260139	2001-07-17	2001-07-17 00:00:00	2001-07-24	2001-07-24 00:00:00	32020		\N	323609	0	10509002	260139		0
82666	4907	80502	2016-05-14	2016-05-14 00:00:00	\N	\N	32020		\N	326156	0	64859006	80502		0
82794	4916	40481087	1991-02-24	1991-02-24 00:00:00	1991-03-10	1991-03-10 00:00:00	32020		\N	326689	0	444814009	40481087		0
82961	4927	260139	2014-11-20	2014-11-20 00:00:00	2014-12-04	2014-12-04 00:00:00	32020		\N	327438	0	10509002	260139		0
84220	5001	4112343	2007-10-02	2007-10-02 00:00:00	2007-10-11	2007-10-11 00:00:00	32020		\N	332619	0	195662009	4112343		0
85131	5063	28060	2000-05-25	2000-05-25 00:00:00	2000-06-02	2000-06-02 00:00:00	32020		\N	336535	0	43878008	28060		0
85297	5073	4142905	1967-08-19	1967-08-19 00:00:00	1967-09-18	1967-09-18 00:00:00	32020		\N	337163	0	33737001	4142905		0
85352	5077	4027663	1993-03-10	1993-03-10 00:00:00	\N	\N	32020		\N	337466	0	13200003	4027663		0
74999	4454	81151	1933-06-20	1933-06-20 00:00:00	1933-07-11	1933-07-11 00:00:00	32020		\N	296493	0	44465007	81151		0
75124	4462	4027663	1981-01-27	1981-01-27 00:00:00	\N	\N	32020		\N	296892	0	13200003	4027663		0
85856	5108	80180	2002-05-28	2002-05-28 00:00:00	\N	\N	32020		\N	339377	0	396275006	80180		0
75381	4475	40481087	2017-08-04	2017-08-04 00:00:00	2017-08-11	2017-08-11 00:00:00	32020		\N	297712	0	444814009	40481087		0
75670	4488	40481087	2016-07-06	2016-07-06 00:00:00	2016-07-27	2016-07-27 00:00:00	32020		\N	298824	0	444814009	40481087		0
75789	4496	4152936	1960-12-29	1960-12-29 00:00:00	1961-01-19	1961-01-19 00:00:00	32020		\N	299305	0	283385000	4152936		0
75949	4504	313217	2019-06-22	2019-06-22 00:00:00	\N	\N	32020		\N	299921	0	49436004	313217		0
86681	5157	4112343	1982-08-31	1982-08-31 00:00:00	1982-09-10	1982-09-10 00:00:00	32020		\N	342903	0	195662009	4112343		0
86878	5172	28060	1990-04-26	1990-04-26 00:00:00	1990-05-08	1990-05-08 00:00:00	32020		\N	343880	0	43878008	28060		0
87088	5185	260139	1965-09-17	1965-09-17 00:00:00	1965-09-24	1965-09-24 00:00:00	32020		\N	344651	0	10509002	260139		0
87180	5191	40481087	2007-04-06	2007-04-06 00:00:00	2007-04-20	2007-04-20 00:00:00	32020		\N	345100	0	444814009	40481087		0
87355	5199	80180	2001-03-27	2001-03-27 00:00:00	\N	\N	32020		\N	345749	0	396275006	80180		0
77001	4562	80180	1999-10-06	1999-10-06 00:00:00	\N	\N	32020		\N	303991	0	396275006	80180		0
77122	4570	4294548	1985-11-12	1985-11-12 00:00:00	1986-01-07	1986-01-07 00:00:00	32020		\N	304512	0	75498004	4294548		0
87908	5230	40481087	1973-04-28	1973-04-28 00:00:00	1973-05-12	1973-05-12 00:00:00	32020		\N	347948	0	444814009	40481087		0
88036	5235	40481087	1931-06-08	1931-06-08 00:00:00	1931-06-22	1931-06-22 00:00:00	32020		\N	348300	0	444814009	40481087		0
89070	5299	4029498	1998-06-06	1998-06-06 00:00:00	\N	\N	32020		\N	352525	0	128613002	4029498		0
88206	5245	40481087	1978-12-11	1978-12-11 00:00:00	1979-01-01	1979-01-01 00:00:00	32020		\N	348939	0	444814009	40481087		0
88325	5252	40481087	1979-03-19	1979-03-19 00:00:00	1979-04-09	1979-04-09 00:00:00	32020		\N	349444	0	444814009	40481087		0
88650	5272	40481087	1929-09-17	1929-09-17 00:00:00	1929-10-08	1929-10-08 00:00:00	32020		\N	350710	0	444814009	40481087		0
78307	4637	40481087	1993-01-16	1993-01-16 00:00:00	1993-01-30	1993-01-30 00:00:00	32020		\N	309035	0	444814009	40481087		0
78481	4646	378001	1985-11-04	1985-11-04 00:00:00	1985-12-04	1985-12-04 00:00:00	32020		\N	309739	0	62106007	378001		0
78681	4660	40481087	1966-03-04	1966-03-04 00:00:00	1966-03-11	1966-03-11 00:00:00	32020		\N	310663	0	444814009	40481087		0
78829	4668	40481087	1987-09-17	1987-09-17 00:00:00	1987-09-24	1987-09-24 00:00:00	32020		\N	311034	0	444814009	40481087		0
89584	5328	372328	1910-02-26	1910-02-26 00:00:00	1910-06-08	1910-06-08 00:00:00	32020		\N	354716	0	65363002	372328		0
89678	5331	4134304	1970-03-26	1970-03-26 00:00:00	1970-05-25	1970-05-25 00:00:00	32020		\N	354939	0	263102004	4134304		0
79577	4715	260139	2004-09-27	2004-09-27 00:00:00	2004-10-04	2004-10-04 00:00:00	32020		\N	313898	0	10509002	260139		0
79825	4729	80180	2000-03-08	2000-03-08 00:00:00	\N	\N	32020		\N	315079	0	396275006	80180		0
80109	4749	4112343	2003-08-10	2003-08-10 00:00:00	2003-08-21	2003-08-21 00:00:00	32020		\N	316261	0	195662009	4112343		0
80218	4755	40481087	2017-07-05	2017-07-05 00:00:00	2017-07-19	2017-07-19 00:00:00	32020		\N	316670	0	444814009	40481087		0
81500	4834	40481087	2019-01-31	2019-01-31 00:00:00	2019-02-07	2019-02-07 00:00:00	32020		\N	321594	0	444814009	40481087		0
81738	4848	4113008	1988-10-24	1988-10-24 00:00:00	1988-11-07	1988-11-07 00:00:00	32020		\N	322563	0	284549007	4113008		0
82090	4867	28060	1931-09-07	1931-09-07 00:00:00	1931-09-17	1931-09-17 00:00:00	32020		\N	323642	0	43878008	28060		0
82667	4907	4112343	1974-01-03	1974-01-03 00:00:00	1974-01-12	1974-01-12 00:00:00	32020		\N	326157	0	195662009	4112343		0
82795	4916	260139	2005-05-27	2005-05-27 00:00:00	2005-06-10	2005-06-10 00:00:00	32020		\N	326663	0	10509002	260139		0
82962	4927	40481087	2005-06-10	2005-06-10 00:00:00	2005-07-01	2005-07-01 00:00:00	32020		\N	327487	0	444814009	40481087		0
84221	5001	260139	1961-01-19	1961-01-19 00:00:00	1961-02-02	1961-02-02 00:00:00	32020		\N	332615	0	10509002	260139		0
85132	5063	257012	1969-01-19	1969-01-19 00:00:00	1969-09-21	1969-09-21 00:00:00	32020		\N	336554	0	40055000	257012		0
85298	5073	260139	1963-09-15	1963-09-15 00:00:00	1963-09-22	1963-09-22 00:00:00	32020		\N	337232	0	10509002	260139		0
85353	5077	40481087	1991-07-28	1991-07-28 00:00:00	1991-08-11	1991-08-11 00:00:00	32020		\N	337466	0	444814009	40481087		0
75000	4454	4112343	1980-03-08	1980-03-08 00:00:00	1980-03-21	1980-03-21 00:00:00	32020		\N	296416	0	195662009	4112343		0
75125	4462	40481087	1979-11-28	1979-11-28 00:00:00	1979-12-19	1979-12-19 00:00:00	32020		\N	296892	0	444814009	40481087		0
85857	5108	40481087	2003-03-06	2003-03-06 00:00:00	2003-03-20	2003-03-20 00:00:00	32020		\N	339401	0	444814009	40481087		0
75382	4475	372328	1987-06-04	1987-06-04 00:00:00	1988-05-30	1988-05-30 00:00:00	32020		\N	297726	0	65363002	372328		0
75671	4488	40481087	1987-06-09	1987-06-09 00:00:00	1987-06-23	1987-06-23 00:00:00	32020		\N	298799	0	444814009	40481087		0
75790	4496	40481087	1995-10-16	1995-10-16 00:00:00	1995-11-06	1995-11-06 00:00:00	32020		\N	299279	0	444814009	40481087		0
75950	4504	4112343	2005-12-08	2005-12-08 00:00:00	2005-12-20	2005-12-20 00:00:00	32020		\N	299932	0	195662009	4112343		0
86682	5157	372328	1963-11-07	1963-11-07 00:00:00	1963-12-19	1963-12-19 00:00:00	32020		\N	342908	0	65363002	372328		0
86879	5172	40481087	1970-06-17	1970-06-17 00:00:00	1970-07-01	1970-07-01 00:00:00	32020		\N	343853	0	444814009	40481087		0
87089	5185	4149245	2000-01-04	2000-01-04 00:00:00	2000-03-11	2000-03-11 00:00:00	32020		\N	344724	0	30832001	4149245		0
87181	5191	40481087	1973-03-13	1973-03-13 00:00:00	1973-03-27	1973-03-27 00:00:00	32020		\N	345098	0	444814009	40481087		0
87356	5199	4029498	1976-01-13	1976-01-13 00:00:00	\N	\N	32020		\N	345722	0	128613002	4029498		0
77002	4562	4051466	1964-02-04	1964-02-04 00:00:00	1980-05-11	1980-05-11 00:00:00	32020		\N	304011	0	233678006	4051466		0
77123	4570	4112343	2008-04-25	2008-04-25 00:00:00	2008-05-03	2008-05-03 00:00:00	32020		\N	304430	0	195662009	4112343		0
87909	5230	378001	1950-07-06	1950-07-06 00:00:00	1950-08-05	1950-08-05 00:00:00	32020		\N	347939	0	62106007	378001		0
88037	5235	4112343	1940-10-27	1940-10-27 00:00:00	1940-11-08	1940-11-08 00:00:00	32020		\N	348367	0	195662009	4112343		0
88207	5245	40481087	2007-06-24	2007-06-24 00:00:00	2007-07-08	2007-07-08 00:00:00	32020		\N	348954	0	444814009	40481087		0
88326	5252	40481087	2011-01-14	2011-01-14 00:00:00	2011-01-28	2011-01-28 00:00:00	32020		\N	349460	0	444814009	40481087		0
88651	5272	40481087	2004-03-06	2004-03-06 00:00:00	2004-03-13	2004-03-13 00:00:00	32020		\N	350613	0	444814009	40481087		0
78308	4637	4152936	1989-08-10	1989-08-10 00:00:00	1989-08-24	1989-08-24 00:00:00	32020		\N	309045	0	283385000	4152936		0
78482	4646	260139	1947-07-03	1947-07-03 00:00:00	1947-07-17	1947-07-17 00:00:00	32020		\N	309720	0	10509002	260139		0
78682	4660	40481087	1976-10-02	1976-10-02 00:00:00	1976-10-09	1976-10-09 00:00:00	32020		\N	310607	0	444814009	40481087		0
78830	4668	40481087	1981-09-09	1981-09-09 00:00:00	1981-09-30	1981-09-30 00:00:00	32020		\N	311071	0	444814009	40481087		0
89585	5328	4283893	2019-02-07	2019-02-07 00:00:00	\N	\N	32020		\N	354714	0	36971009	4283893		0
89679	5331	4296205	2017-02-17	2017-02-17 00:00:00	2017-03-24	2017-03-24 00:00:00	32020		\N	354940	0	403191005	4296205		0
79578	4715	80180	1995-01-14	1995-01-14 00:00:00	\N	\N	32020		\N	313915	0	396275006	80180		0
79826	4729	260139	1980-05-03	1980-05-03 00:00:00	1980-05-10	1980-05-10 00:00:00	32020		\N	315085	0	10509002	260139		0
80110	4749	40481087	2003-05-15	2003-05-15 00:00:00	2003-06-05	2003-06-05 00:00:00	32020		\N	316239	0	444814009	40481087		0
80219	4755	260139	2011-12-15	2011-12-15 00:00:00	2011-12-22	2011-12-22 00:00:00	32020		\N	316776	0	10509002	260139		0
81501	4834	4112343	1984-08-10	1984-08-10 00:00:00	1984-08-19	1984-08-19 00:00:00	32020		\N	321616	0	195662009	4112343		0
81739	4848	4112343	2012-01-27	2012-01-27 00:00:00	2012-02-08	2012-02-08 00:00:00	32020		\N	322565	0	195662009	4112343		0
82091	4867	28060	1988-04-12	1988-04-12 00:00:00	1988-04-25	1988-04-25 00:00:00	32020		\N	323597	0	43878008	28060		0
82668	4907	260139	2004-09-07	2004-09-07 00:00:00	2004-09-14	2004-09-14 00:00:00	32020		\N	326175	0	10509002	260139		0
82796	4916	4112343	1988-04-22	1988-04-22 00:00:00	1988-05-02	1988-05-02 00:00:00	32020		\N	326688	0	195662009	4112343		0
82963	4927	4112343	1994-11-29	1994-11-29 00:00:00	1994-12-07	1994-12-07 00:00:00	32020		\N	327485	0	195662009	4112343		0
84222	5001	4112343	1984-01-14	1984-01-14 00:00:00	1984-01-24	1984-01-24 00:00:00	32020		\N	332653	0	195662009	4112343		0
85133	5063	4112343	1997-06-30	1997-06-30 00:00:00	1997-07-08	1997-07-08 00:00:00	32020		\N	336635	0	195662009	4112343		0
85299	5073	40481087	1999-05-24	1999-05-24 00:00:00	1999-06-14	1999-06-14 00:00:00	32020		\N	337233	0	444814009	40481087		0
85354	5077	40481087	2004-02-10	2004-02-10 00:00:00	2004-03-02	2004-03-02 00:00:00	32020		\N	337445	0	444814009	40481087		0
75001	4454	260139	1932-10-04	1932-10-04 00:00:00	1932-10-18	1932-10-18 00:00:00	32020		\N	296413	0	10509002	260139		0
75126	4462	40481087	2002-03-09	2002-03-09 00:00:00	2002-03-30	2002-03-30 00:00:00	32020		\N	296894	0	444814009	40481087		0
85858	5108	4112343	1963-10-23	1963-10-23 00:00:00	1963-10-29	1963-10-29 00:00:00	32020		\N	339432	0	195662009	4112343		0
75383	4475	260139	2016-01-19	2016-01-19 00:00:00	2016-02-02	2016-02-02 00:00:00	32020		\N	297711	0	10509002	260139		0
75672	4488	260139	1986-12-07	1986-12-07 00:00:00	1986-12-14	1986-12-14 00:00:00	32020		\N	298821	0	10509002	260139		0
75791	4496	260139	2010-04-21	2010-04-21 00:00:00	2010-05-05	2010-05-05 00:00:00	32020		\N	299313	0	10509002	260139		0
75951	4504	80180	2010-12-23	2010-12-23 00:00:00	\N	\N	32020		\N	299939	0	396275006	80180		0
86683	5157	80180	2000-08-19	2000-08-19 00:00:00	\N	\N	32020		\N	342939	0	396275006	80180		0
86880	5172	40481087	1946-10-02	1946-10-02 00:00:00	1946-10-09	1946-10-09 00:00:00	32020		\N	343873	0	444814009	40481087		0
87090	5185	4112343	1983-01-22	1983-01-22 00:00:00	1983-01-30	1983-01-30 00:00:00	32020		\N	344654	0	195662009	4112343		0
87198	5193	40481087	1986-05-31	1986-05-31 00:00:00	1986-06-14	1986-06-14 00:00:00	32020		\N	345201	0	444814009	40481087		0
87358	5199	40481087	2013-03-30	2013-03-30 00:00:00	2013-04-06	2013-04-06 00:00:00	32020		\N	345791	0	444814009	40481087		0
77003	4562	78272	2011-10-06	2011-10-06 00:00:00	2011-10-27	2011-10-27 00:00:00	32020		\N	304030	0	70704007	78272		0
77124	4570	260139	1985-05-15	1985-05-15 00:00:00	1985-05-29	1985-05-29 00:00:00	32020		\N	304483	0	10509002	260139		0
87910	5230	260139	1983-12-12	1983-12-12 00:00:00	1983-12-19	1983-12-19 00:00:00	32020		\N	347955	0	10509002	260139		0
88038	5235	40481087	1947-02-02	1947-02-02 00:00:00	1947-02-23	1947-02-23 00:00:00	32020		\N	348315	0	444814009	40481087		0
88208	5245	257012	1985-07-19	1985-07-19 00:00:00	\N	\N	32020		\N	348966	0	40055000	257012		0
88327	5252	28060	1990-02-15	1990-02-15 00:00:00	1990-02-28	1990-02-28 00:00:00	32020		\N	349459	0	43878008	28060		0
88652	5272	260139	2016-11-13	2016-11-13 00:00:00	2016-11-20	2016-11-20 00:00:00	32020		\N	350622	0	10509002	260139		0
78309	4637	40481087	1975-04-23	1975-04-23 00:00:00	1975-05-14	1975-05-14 00:00:00	32020		\N	309033	0	444814009	40481087		0
78483	4646	260139	2001-09-20	2001-09-20 00:00:00	2001-10-04	2001-10-04 00:00:00	32020		\N	309826	0	10509002	260139		0
78683	4660	260139	1967-08-02	1967-08-02 00:00:00	1967-08-16	1967-08-16 00:00:00	32020		\N	310597	0	10509002	260139		0
78831	4668	40481087	1982-11-30	1982-11-30 00:00:00	1982-12-07	1982-12-07 00:00:00	32020		\N	311077	0	444814009	40481087		0
89586	5328	40481087	1938-09-11	1938-09-11 00:00:00	1938-10-02	1938-10-02 00:00:00	32020		\N	354705	0	444814009	40481087		0
89680	5331	40481087	2007-07-19	2007-07-19 00:00:00	2007-08-02	2007-08-02 00:00:00	32020		\N	354960	0	444814009	40481087		0
79579	4715	4285898	1994-11-15	1994-11-15 00:00:00	\N	\N	32020		\N	313915	0	68496003	4285898		0
79827	4729	4155034	1993-11-20	1993-11-20 00:00:00	1993-12-11	1993-12-11 00:00:00	32020		\N	315106	0	283371005	4155034		0
80111	4749	372328	1994-04-08	1994-04-08 00:00:00	1994-12-24	1994-12-24 00:00:00	32020		\N	316251	0	65363002	372328		0
80220	4755	40481087	1928-12-22	1928-12-22 00:00:00	1929-01-12	1929-01-12 00:00:00	32020		\N	316680	0	444814009	40481087		0
81502	4834	4109685	2008-12-30	2008-12-30 00:00:00	2009-01-20	2009-01-20 00:00:00	32020		\N	321550	0	284551006	4109685		0
81740	4848	4142905	1966-10-01	1966-10-01 00:00:00	1966-12-30	1966-12-30 00:00:00	32020		\N	322560	0	33737001	4142905		0
82092	4867	4109685	1988-08-21	1988-08-21 00:00:00	1988-09-04	1988-09-04 00:00:00	32020		\N	323686	0	284551006	4109685		0
82797	4916	4112343	2013-06-04	2013-06-04 00:00:00	2013-06-17	2013-06-17 00:00:00	32020		\N	326690	0	195662009	4112343		0
82964	4927	260139	2007-05-22	2007-05-22 00:00:00	2007-05-29	2007-05-29 00:00:00	32020		\N	327495	0	10509002	260139		0
84223	5001	4112343	2013-09-10	2013-09-10 00:00:00	2013-09-20	2013-09-20 00:00:00	32020		\N	332687	0	195662009	4112343		0
85134	5063	40481087	2019-01-04	2019-01-04 00:00:00	2019-01-18	2019-01-18 00:00:00	32020		\N	336596	0	444814009	40481087		0
85300	5073	4283893	1977-10-04	1977-10-04 00:00:00	1977-12-06	1977-12-06 00:00:00	32020		\N	337247	0	36971009	4283893		0
85355	5077	260139	2014-05-18	2014-05-18 00:00:00	2014-05-25	2014-05-25 00:00:00	32020		\N	337447	0	10509002	260139		0
75002	4454	4237458	1955-12-16	1955-12-16 00:00:00	1956-01-15	1956-01-15 00:00:00	32020		\N	296499	0	58150001	4237458		0
75127	4462	4112343	2003-11-26	2003-11-26 00:00:00	2003-12-05	2003-12-05 00:00:00	32020		\N	296895	0	195662009	4112343		0
85859	5108	4112343	1962-10-18	1962-10-18 00:00:00	1962-10-26	1962-10-26 00:00:00	32020		\N	339431	0	195662009	4112343		0
75384	4475	40481087	2013-12-01	2013-12-01 00:00:00	2013-12-15	2013-12-15 00:00:00	32020		\N	297739	0	444814009	40481087		0
75673	4488	4112343	1989-11-25	1989-11-25 00:00:00	1989-12-04	1989-12-04 00:00:00	32020		\N	298822	0	195662009	4112343		0
75792	4496	4294548	1955-11-02	1955-11-02 00:00:00	1955-11-23	1955-11-23 00:00:00	32020		\N	299310	0	75498004	4294548		0
75952	4504	260139	1983-11-11	1983-11-11 00:00:00	1983-11-18	1983-11-18 00:00:00	32020		\N	299946	0	10509002	260139		0
86684	5157	381316	2015-05-14	2015-05-14 00:00:00	\N	\N	32020		\N	342944	0	230690007	381316		0
86881	5172	4027663	1971-03-28	1971-03-28 00:00:00	\N	\N	32020		\N	343912	0	13200003	4027663		0
87091	5185	4112343	1950-07-09	1950-07-09 00:00:00	1950-07-17	1950-07-17 00:00:00	32020		\N	344649	0	195662009	4112343		0
87199	5193	4112343	1974-03-29	1974-03-29 00:00:00	1974-04-08	1974-04-08 00:00:00	32020		\N	345209	0	195662009	4112343		0
87359	5199	260139	1999-01-08	1999-01-08 00:00:00	1999-01-22	1999-01-22 00:00:00	32020		\N	345769	0	10509002	260139		0
77004	4562	4283893	1989-11-22	1989-11-22 00:00:00	1990-01-17	1990-01-17 00:00:00	32020		\N	304003	0	36971009	4283893		0
77125	4570	28060	1947-07-29	1947-07-29 00:00:00	1947-08-11	1947-08-11 00:00:00	32020		\N	304509	0	43878008	28060		0
87911	5230	40481087	1963-12-25	1963-12-25 00:00:00	1964-01-08	1964-01-08 00:00:00	32020		\N	347957	0	444814009	40481087		0
88039	5235	372328	1940-03-02	1940-03-02 00:00:00	1940-08-03	1940-08-03 00:00:00	32020		\N	348356	0	65363002	372328		0
88209	5245	28060	1984-03-11	1984-03-11 00:00:00	1984-03-23	1984-03-23 00:00:00	32020		\N	348985	0	43878008	28060		0
88328	5252	4155034	1987-10-11	1987-10-11 00:00:00	1987-11-01	1987-11-01 00:00:00	32020		\N	349450	0	283371005	4155034		0
88653	5272	260139	1972-01-04	1972-01-04 00:00:00	1972-01-18	1972-01-18 00:00:00	32020		\N	350656	0	10509002	260139		0
78310	4637	4112343	1991-05-30	1991-05-30 00:00:00	1991-06-08	1991-06-08 00:00:00	32020		\N	309022	0	195662009	4112343		0
78484	4646	313217	2001-10-02	2001-10-02 00:00:00	\N	\N	32020		\N	\N	0	49436004	313217		0
78684	4660	4112343	1968-07-26	1968-07-26 00:00:00	1968-08-06	1968-08-06 00:00:00	32020		\N	310657	0	195662009	4112343		0
78837	4670	260139	1962-03-21	1962-03-21 00:00:00	1962-03-28	1962-03-28 00:00:00	32020		\N	311192	0	10509002	260139		0
89587	5328	260139	1981-09-19	1981-09-19 00:00:00	1981-10-03	1981-10-03 00:00:00	32020		\N	354607	0	10509002	260139		0
89681	5331	260139	1998-03-02	1998-03-02 00:00:00	1998-03-16	1998-03-16 00:00:00	32020		\N	354903	0	10509002	260139		0
79580	4715	40481087	2010-05-03	2010-05-03 00:00:00	2010-05-24	2010-05-24 00:00:00	32020		\N	313935	0	444814009	40481087		0
79828	4729	81151	2000-09-05	2000-09-05 00:00:00	2000-10-03	2000-10-03 00:00:00	32020		\N	315107	0	44465007	81151		0
80112	4749	81151	2007-03-29	2007-03-29 00:00:00	2007-04-26	2007-04-26 00:00:00	32020		\N	316224	0	44465007	81151		0
80221	4755	80180	1963-09-19	1963-09-19 00:00:00	\N	\N	32020		\N	316660	0	396275006	80180		0
81503	4834	372328	1964-10-10	1964-10-10 00:00:00	1965-04-25	1965-04-25 00:00:00	32020		\N	321555	0	65363002	372328		0
81741	4848	378001	1956-08-24	1956-08-24 00:00:00	1956-10-23	1956-10-23 00:00:00	32020		\N	322559	0	62106007	378001		0
82093	4867	260139	2011-07-03	2011-07-03 00:00:00	2011-07-10	2011-07-10 00:00:00	32020		\N	323671	0	10509002	260139		0
82798	4916	4112343	2017-12-11	2017-12-11 00:00:00	2017-12-18	2017-12-18 00:00:00	32020		\N	326692	0	195662009	4112343		0
82965	4927	4296205	1978-05-18	1978-05-18 00:00:00	1978-06-08	1978-06-08 00:00:00	32020		\N	327477	0	403191005	4296205		0
84224	5002	40481087	1977-10-09	1977-10-09 00:00:00	1977-10-30	1977-10-30 00:00:00	32020		\N	332703	0	444814009	40481087		0
85135	5063	260139	2000-05-19	2000-05-19 00:00:00	2000-06-02	2000-06-02 00:00:00	32020		\N	336636	0	10509002	260139		0
85301	5073	4112343	1941-01-12	1941-01-12 00:00:00	1941-01-24	1941-01-24 00:00:00	32020		\N	337193	0	195662009	4112343		0
85356	5077	260139	1971-02-16	1971-02-16 00:00:00	1971-03-02	1971-03-02 00:00:00	32020		\N	337448	0	10509002	260139		0
75003	4454	260139	2005-09-20	2005-09-20 00:00:00	2005-10-04	2005-10-04 00:00:00	32020		\N	296418	0	10509002	260139		0
75128	4462	260139	1978-09-02	1978-09-02 00:00:00	1978-09-16	1978-09-16 00:00:00	32020		\N	296914	0	10509002	260139		0
85860	5108	260139	1999-01-28	1999-01-28 00:00:00	1999-02-11	1999-02-11 00:00:00	32020		\N	339411	0	10509002	260139		0
75385	4475	4112343	2018-09-29	2018-09-29 00:00:00	2018-10-06	2018-10-06 00:00:00	32020		\N	297755	0	195662009	4112343		0
75674	4488	4112343	2009-08-24	2009-08-24 00:00:00	2009-08-31	2009-08-31 00:00:00	32020		\N	298793	0	195662009	4112343		0
75793	4496	40481087	2017-11-09	2017-11-09 00:00:00	2017-11-30	2017-11-30 00:00:00	32020		\N	299275	0	444814009	40481087		0
75953	4504	4112343	1981-07-07	1981-07-07 00:00:00	1981-07-16	1981-07-16 00:00:00	32020		\N	299904	0	195662009	4112343		0
86685	5157	372328	1976-03-28	1976-03-28 00:00:00	1976-05-06	1976-05-06 00:00:00	32020		\N	342915	0	65363002	372328		0
86882	5172	4112343	2001-11-09	2001-11-09 00:00:00	2001-11-19	2001-11-19 00:00:00	32020		\N	343827	0	195662009	4112343		0
87092	5185	257012	1969-06-04	1969-06-04 00:00:00	\N	\N	32020		\N	344653	0	40055000	257012		0
87200	5193	40481087	1983-09-21	1983-09-21 00:00:00	1983-10-05	1983-10-05 00:00:00	32020		\N	345239	0	444814009	40481087		0
87360	5199	4134304	2011-06-08	2011-06-08 00:00:00	2011-09-06	2011-09-06 00:00:00	32020		\N	345723	0	263102004	4134304		0
77005	4562	4084167	1970-11-08	1970-11-08 00:00:00	1970-11-08	1970-11-08 00:00:00	32020		\N	303952	0	241929008	4084167		0
77126	4570	372328	1941-03-21	1941-03-21 00:00:00	1941-11-29	1941-11-29 00:00:00	32020		\N	304431	0	65363002	372328		0
87912	5230	40480160	2014-02-14	2014-02-14 00:00:00	2014-05-15	2014-05-15 00:00:00	32020		\N	347944	0	443165006	40480160		0
88040	5235	4109685	1930-04-07	1930-04-07 00:00:00	1930-04-21	1930-04-21 00:00:00	32020		\N	348364	0	284551006	4109685		0
88210	5245	80180	2015-12-10	2015-12-10 00:00:00	\N	\N	32020		\N	349037	0	396275006	80180		0
88329	5252	4112343	1978-02-03	1978-02-03 00:00:00	1978-02-16	1978-02-16 00:00:00	32020		\N	349414	0	195662009	4112343		0
88654	5272	40481087	1962-07-06	1962-07-06 00:00:00	1962-07-20	1962-07-20 00:00:00	32020		\N	350588	0	444814009	40481087		0
78311	4637	28060	1980-04-20	1980-04-20 00:00:00	1980-04-30	1980-04-30 00:00:00	32020		\N	309021	0	43878008	28060		0
78485	4646	4112343	1948-11-07	1948-11-07 00:00:00	1948-11-17	1948-11-17 00:00:00	32020		\N	309784	0	195662009	4112343		0
89143	5302	260139	1992-07-23	1992-07-23 00:00:00	1992-08-06	1992-08-06 00:00:00	32020		\N	352780	0	10509002	260139		0
78838	4670	4155034	1958-02-08	1958-02-08 00:00:00	1958-02-22	1958-02-22 00:00:00	32020		\N	311154	0	283371005	4155034		0
89588	5328	260139	1974-08-13	1974-08-13 00:00:00	1974-08-27	1974-08-27 00:00:00	32020		\N	354624	0	10509002	260139		0
89682	5331	4112343	1965-11-18	1965-11-18 00:00:00	1965-11-25	1965-11-25 00:00:00	32020		\N	354916	0	195662009	4112343		0
79581	4715	28060	1983-12-26	1983-12-26 00:00:00	1984-01-08	1984-01-08 00:00:00	32020		\N	313958	0	43878008	28060		0
79837	4731	4112343	1972-07-03	1972-07-03 00:00:00	1972-07-14	1972-07-14 00:00:00	32020		\N	315191	0	195662009	4112343		0
80113	4749	260139	1978-07-23	1978-07-23 00:00:00	1978-08-06	1978-08-06 00:00:00	32020		\N	316237	0	10509002	260139		0
80222	4755	372328	1928-06-19	1928-06-19 00:00:00	1928-09-07	1928-09-07 00:00:00	32020		\N	316744	0	65363002	372328		0
81504	4834	4134304	1971-03-24	1971-03-24 00:00:00	1971-04-23	1971-04-23 00:00:00	32020		\N	321546	0	263102004	4134304		0
81742	4848	40481087	1978-05-10	1978-05-10 00:00:00	1978-05-31	1978-05-31 00:00:00	32020		\N	322494	0	444814009	40481087		0
82094	4867	4112343	1965-10-14	1965-10-14 00:00:00	1965-10-22	1965-10-22 00:00:00	32020		\N	323681	0	195662009	4112343		0
82799	4916	4112343	2014-04-15	2014-04-15 00:00:00	2014-04-27	2014-04-27 00:00:00	32020		\N	326691	0	195662009	4112343		0
82966	4927	257012	2005-01-26	2005-01-26 00:00:00	\N	\N	32020		\N	327486	0	40055000	257012		0
84225	5002	192671	2019-05-25	2019-05-25 00:00:00	\N	\N	32020		\N	332698	0	K92.2	35208414		0
85136	5063	40481087	1951-01-20	1951-01-20 00:00:00	1951-02-10	1951-02-10 00:00:00	32020		\N	336587	0	444814009	40481087		0
85302	5073	40481087	1959-01-13	1959-01-13 00:00:00	1959-01-27	1959-01-27 00:00:00	32020		\N	337231	0	444814009	40481087		0
85357	5077	40481087	2006-08-25	2006-08-25 00:00:00	2006-09-08	2006-09-08 00:00:00	32020		\N	337468	0	444814009	40481087		0
75004	4454	40481087	1997-06-09	1997-06-09 00:00:00	1997-06-23	1997-06-23 00:00:00	32020		\N	296389	0	444814009	40481087		0
75129	4462	4296204	1972-06-03	1972-06-03 00:00:00	1972-06-24	1972-06-24 00:00:00	32020		\N	296900	0	403190006	4296204		0
85861	5108	372328	1961-06-22	1961-06-22 00:00:00	1961-10-02	1961-10-02 00:00:00	32020		\N	339385	0	65363002	372328		0
75386	4475	40481087	2004-06-12	2004-06-12 00:00:00	2004-06-26	2004-06-26 00:00:00	32020		\N	297725	0	444814009	40481087		0
75675	4488	80180	2018-02-10	2018-02-10 00:00:00	\N	\N	32020		\N	298781	0	396275006	80180		0
75794	4496	4116491	1985-03-03	1985-03-03 00:00:00	1985-04-26	1985-04-26 00:00:00	32020		\N	299255	0	301011002	4116491		0
75954	4504	4113008	2008-08-10	2008-08-10 00:00:00	2008-08-24	2008-08-24 00:00:00	32020		\N	299903	0	284549007	4113008		0
86686	5157	40481087	2002-05-07	2002-05-07 00:00:00	2002-05-21	2002-05-21 00:00:00	32020		\N	342930	0	444814009	40481087		0
86883	5172	4112343	1957-01-13	1957-01-13 00:00:00	1957-01-22	1957-01-22 00:00:00	32020		\N	343850	0	195662009	4112343		0
87093	5185	28060	2014-10-27	2014-10-27 00:00:00	2014-11-04	2014-11-04 00:00:00	32020		\N	344700	0	43878008	28060		0
87201	5193	4294548	2002-08-26	2002-08-26 00:00:00	2002-09-09	2002-09-09 00:00:00	32020		\N	345202	0	75498004	4294548		0
87361	5199	78272	1973-01-02	1973-01-02 00:00:00	1973-01-30	1973-01-30 00:00:00	32020		\N	345725	0	70704007	78272		0
77006	4562	133834	1961-08-03	1961-08-03 00:00:00	1978-04-15	1978-04-15 00:00:00	32020		\N	304064	0	24079001	133834		0
77127	4570	80502	1997-01-25	1997-01-25 00:00:00	\N	\N	32020		\N	304494	0	64859006	80502		0
87913	5230	4134304	2014-02-14	2014-02-14 00:00:00	2014-05-15	2014-05-15 00:00:00	32020		\N	347944	0	263102004	4134304		0
88041	5235	372328	1922-10-16	1922-10-16 00:00:00	1922-12-23	1922-12-23 00:00:00	32020		\N	348327	0	65363002	372328		0
88211	5245	192671	2016-01-31	2016-01-31 00:00:00	\N	\N	32020		\N	348938	0	K92.2	35208414		0
88330	5252	28060	1967-03-19	1967-03-19 00:00:00	1967-03-31	1967-03-31 00:00:00	32020		\N	349442	0	43878008	28060		0
88655	5272	40481087	1968-08-16	1968-08-16 00:00:00	1968-08-23	1968-08-23 00:00:00	32020		\N	350589	0	444814009	40481087		0
78312	4637	4155034	2011-12-25	2011-12-25 00:00:00	2012-01-15	2012-01-15 00:00:00	32020		\N	309050	0	283371005	4155034		0
78486	4646	40481087	1990-07-16	1990-07-16 00:00:00	1990-07-30	1990-07-30 00:00:00	32020		\N	309861	0	444814009	40481087		0
89144	5302	40481087	2017-04-21	2017-04-21 00:00:00	2017-04-28	2017-04-28 00:00:00	32020		\N	352792	0	444814009	40481087		0
78839	4670	40481087	1965-08-17	1965-08-17 00:00:00	1965-08-24	1965-08-24 00:00:00	32020		\N	311204	0	444814009	40481087		0
89589	5328	40481087	1994-02-22	1994-02-22 00:00:00	1994-03-15	1994-03-15 00:00:00	32020		\N	354625	0	444814009	40481087		0
89683	5331	260139	2017-08-19	2017-08-19 00:00:00	2017-08-26	2017-08-26 00:00:00	32020		\N	354949	0	10509002	260139		0
79582	4715	4027663	1984-07-31	1984-07-31 00:00:00	\N	\N	32020		\N	313958	0	13200003	4027663		0
79838	4731	80180	2008-09-08	2008-09-08 00:00:00	\N	\N	32020		\N	315224	0	396275006	80180		0
80114	4749	372328	1979-11-14	1979-11-14 00:00:00	1980-10-18	1980-10-18 00:00:00	32020		\N	316228	0	65363002	372328		0
80223	4755	40481087	1994-09-03	1994-09-03 00:00:00	1994-09-17	1994-09-17 00:00:00	32020		\N	316714	0	444814009	40481087		0
81505	4834	78272	1969-02-27	1969-02-27 00:00:00	1969-04-03	1969-04-03 00:00:00	32020		\N	321545	0	70704007	78272		0
81743	4848	40481087	1981-02-22	1981-02-22 00:00:00	1981-03-08	1981-03-08 00:00:00	32020		\N	322495	0	444814009	40481087		0
82095	4867	40479768	2011-03-08	2011-03-08 00:00:00	2011-04-14	2011-04-14 00:00:00	32020		\N	323691	0	444470001	40479768		0
82800	4916	40481087	2000-05-28	2000-05-28 00:00:00	2000-06-04	2000-06-04 00:00:00	32020		\N	326662	0	444814009	40481087		0
82967	4927	40481087	1982-08-01	1982-08-01 00:00:00	1982-08-15	1982-08-15 00:00:00	32020		\N	327484	0	444814009	40481087		0
84226	5002	4112343	1977-04-06	1977-04-06 00:00:00	1977-04-18	1977-04-18 00:00:00	32020		\N	332715	0	195662009	4112343		0
85137	5063	40481087	1959-11-30	1959-11-30 00:00:00	1959-12-21	1959-12-21 00:00:00	32020		\N	336589	0	444814009	40481087		0
85303	5073	40481087	1960-06-25	1960-06-25 00:00:00	1960-07-09	1960-07-09 00:00:00	32020		\N	337195	0	444814009	40481087		0
85358	5077	40481087	2011-01-23	2011-01-23 00:00:00	2011-02-13	2011-02-13 00:00:00	32020		\N	337446	0	444814009	40481087		0
75005	4454	317576	2004-05-15	2004-05-15 00:00:00	\N	\N	32020		\N	296432	0	53741008	317576		0
75130	4462	40481087	1981-07-16	1981-07-16 00:00:00	1981-07-30	1981-07-30 00:00:00	32020		\N	296911	0	444814009	40481087		0
85862	5108	40481087	1995-07-26	1995-07-26 00:00:00	1995-08-09	1995-08-09 00:00:00	32020		\N	339367	0	444814009	40481087		0
75387	4475	40481087	1988-03-25	1988-03-25 00:00:00	1988-04-01	1988-04-01 00:00:00	32020		\N	297707	0	444814009	40481087		0
75676	4488	40481087	2017-12-25	2017-12-25 00:00:00	2018-01-01	2018-01-01 00:00:00	32020		\N	298781	0	444814009	40481087		0
75795	4496	4283893	1992-04-20	1992-04-20 00:00:00	1992-05-25	1992-05-25 00:00:00	32020		\N	299271	0	36971009	4283893		0
75955	4505	40481087	2000-08-05	2000-08-05 00:00:00	2000-08-26	2000-08-26 00:00:00	32020		\N	299991	0	444814009	40481087		0
86687	5157	4059173	2018-01-22	2018-01-22 00:00:00	2018-03-23	2018-03-23 00:00:00	32020		\N	342948	0	16114001	4059173		0
86884	5172	4112343	1946-03-31	1946-03-31 00:00:00	1946-04-10	1946-04-10 00:00:00	32020		\N	343825	0	195662009	4112343		0
87094	5185	40481087	1996-01-11	1996-01-11 00:00:00	1996-01-25	1996-01-25 00:00:00	32020		\N	344707	0	444814009	40481087		0
87202	5193	4146173	1974-02-13	1974-02-13 00:00:00	1974-04-14	1974-04-14 00:00:00	32020		\N	345242	0	307731004	4146173		0
87362	5199	260139	1978-05-13	1978-05-13 00:00:00	1978-05-22	1978-05-22 00:00:00	32020		\N	345781	0	10509002	260139		0
77007	4562	40481087	2007-01-30	2007-01-30 00:00:00	2007-02-13	2007-02-13 00:00:00	32020		\N	304008	0	444814009	40481087		0
77128	4570	4152936	1954-11-20	1954-11-20 00:00:00	1954-12-04	1954-12-04 00:00:00	32020		\N	304490	0	283385000	4152936		0
87914	5230	40481087	1949-08-15	1949-08-15 00:00:00	1949-09-05	1949-09-05 00:00:00	32020		\N	347945	0	444814009	40481087		0
88042	5235	4027663	1949-09-09	1949-09-09 00:00:00	\N	\N	32020		\N	348348	0	13200003	4027663		0
88212	5245	81151	2001-09-18	2001-09-18 00:00:00	2001-10-16	2001-10-16 00:00:00	32020		\N	348935	0	44465007	81151		0
88331	5252	40481087	1986-01-09	1986-01-09 00:00:00	1986-01-23	1986-01-23 00:00:00	32020		\N	349433	0	444814009	40481087		0
88656	5272	40481087	1978-07-04	1978-07-04 00:00:00	1978-07-18	1978-07-18 00:00:00	32020		\N	350631	0	444814009	40481087		0
78313	4637	4112343	1993-06-28	1993-06-28 00:00:00	1993-07-10	1993-07-10 00:00:00	32020		\N	309016	0	195662009	4112343		0
78487	4646	257012	1970-11-25	1970-11-25 00:00:00	1971-01-13	1971-01-13 00:00:00	32020		\N	309721	0	40055000	257012		0
89145	5302	40481087	2004-10-01	2004-10-01 00:00:00	2004-10-08	2004-10-08 00:00:00	32020		\N	352790	0	444814009	40481087		0
78840	4670	378001	1977-02-26	1977-02-26 00:00:00	1977-04-27	1977-04-27 00:00:00	32020		\N	311156	0	62106007	378001		0
89590	5328	40481087	1917-09-22	1917-09-22 00:00:00	1917-10-13	1917-10-13 00:00:00	32020		\N	354593	0	444814009	40481087		0
89684	5331	260139	1989-10-13	1989-10-13 00:00:00	1989-10-27	1989-10-27 00:00:00	32020		\N	354902	0	10509002	260139		0
79583	4715	4001336	1951-08-04	1951-08-04 00:00:00	1951-09-03	1951-09-03 00:00:00	32020		\N	313922	0	110030002	4001336		0
79839	4731	4285898	2008-04-11	2008-04-11 00:00:00	\N	\N	32020		\N	315224	0	68496003	4285898		0
80115	4749	4112343	2001-04-06	2001-04-06 00:00:00	2001-04-18	2001-04-18 00:00:00	32020		\N	316270	0	195662009	4112343		0
80224	4755	378001	1976-08-11	1976-08-11 00:00:00	1976-10-10	1976-10-10 00:00:00	32020		\N	316710	0	62106007	378001		0
81506	4834	260139	1999-07-10	1999-07-10 00:00:00	1999-07-17	1999-07-17 00:00:00	32020		\N	321561	0	10509002	260139		0
81744	4848	40481087	1964-04-09	1964-04-09 00:00:00	1964-04-16	1964-04-16 00:00:00	32020		\N	322493	0	444814009	40481087		0
82096	4867	40481087	1932-08-17	1932-08-17 00:00:00	1932-08-24	1932-08-24 00:00:00	32020		\N	323676	0	444814009	40481087		0
82801	4916	260139	1977-08-30	1977-08-30 00:00:00	1977-09-06	1977-09-06 00:00:00	32020		\N	326687	0	10509002	260139		0
82968	4927	4112343	2002-05-02	2002-05-02 00:00:00	2002-05-15	2002-05-15 00:00:00	32020		\N	327437	0	195662009	4112343		0
84227	5002	80180	2019-03-15	2019-03-15 00:00:00	\N	\N	32020		\N	332700	0	396275006	80180		0
85138	5063	372328	1947-03-04	1947-03-04 00:00:00	1947-12-12	1947-12-12 00:00:00	32020		\N	336618	0	65363002	372328		0
85313	5076	4296205	1975-11-15	1975-11-15 00:00:00	1975-12-13	1975-12-13 00:00:00	32020		\N	337328	0	403191005	4296205		0
85359	5077	81893	2001-11-03	2001-11-03 00:00:00	\N	\N	32020		\N	337438	0	64766004	81893		0
75006	4454	260139	1934-02-20	1934-02-20 00:00:00	1934-03-06	1934-03-06 00:00:00	32020		\N	296370	0	10509002	260139		0
75131	4462	40481087	1978-08-23	1978-08-23 00:00:00	1978-08-30	1978-08-30 00:00:00	32020		\N	296913	0	444814009	40481087		0
85863	5108	260139	2002-03-10	2002-03-10 00:00:00	2002-03-17	2002-03-17 00:00:00	32020		\N	339419	0	10509002	260139		0
75388	4475	4278672	1983-08-24	1983-08-24 00:00:00	1983-09-23	1983-09-23 00:00:00	32020		\N	297713	0	65966004	4278672		0
75677	4488	4112343	1976-03-06	1976-03-06 00:00:00	1976-03-18	1976-03-18 00:00:00	32020		\N	298787	0	195662009	4112343		0
75796	4496	40481087	2007-12-23	2007-12-23 00:00:00	2007-12-30	2007-12-30 00:00:00	32020		\N	299257	0	444814009	40481087		0
75956	4505	4112343	2007-07-20	2007-07-20 00:00:00	2007-07-31	2007-07-31 00:00:00	32020		\N	300064	0	195662009	4112343		0
86688	5157	4059173	1974-02-12	1974-02-12 00:00:00	1974-03-14	1974-03-14 00:00:00	32020		\N	342945	0	16114001	4059173		0
86885	5172	40481087	2008-01-05	2008-01-05 00:00:00	2008-01-26	2008-01-26 00:00:00	32020		\N	343828	0	444814009	40481087		0
87113	5189	4218389	1978-08-19	1978-08-19 00:00:00	1978-09-23	1978-09-23 00:00:00	32020		\N	344899	0	39848009	4218389		0
87203	5193	4112343	1975-06-06	1975-06-06 00:00:00	1975-06-14	1975-06-14 00:00:00	32020		\N	345179	0	195662009	4112343		0
87363	5199	40481087	1978-04-28	1978-04-28 00:00:00	1978-05-19	1978-05-19 00:00:00	32020		\N	345781	0	444814009	40481087		0
77008	4562	4294548	1979-03-21	1979-03-21 00:00:00	1979-04-11	1979-04-11 00:00:00	32020		\N	303981	0	75498004	4294548		0
77129	4570	40481087	1993-12-31	1993-12-31 00:00:00	1994-01-21	1994-01-21 00:00:00	32020		\N	304463	0	444814009	40481087		0
87915	5230	4278672	1961-09-06	1961-09-06 00:00:00	1961-11-05	1961-11-05 00:00:00	32020		\N	347940	0	65966004	4278672		0
88043	5235	40481087	1956-05-11	1956-05-11 00:00:00	1956-05-18	1956-05-18 00:00:00	32020		\N	348322	0	444814009	40481087		0
88213	5245	4113008	2004-06-02	2004-06-02 00:00:00	2004-06-23	2004-06-23 00:00:00	32020		\N	348937	0	284549007	4113008		0
88332	5252	40481087	2012-04-29	2012-04-29 00:00:00	2012-05-06	2012-05-06 00:00:00	32020		\N	349436	0	444814009	40481087		0
88657	5272	28060	1957-05-24	1957-05-24 00:00:00	1957-05-31	1957-05-31 00:00:00	32020		\N	350712	0	43878008	28060		0
78314	4637	378001	2007-02-05	2007-02-05 00:00:00	2007-04-06	2007-04-06 00:00:00	32020		\N	309048	0	62106007	378001		0
78488	4646	260139	1983-09-17	1983-09-17 00:00:00	1983-09-24	1983-09-24 00:00:00	32020		\N	309724	0	10509002	260139		0
89146	5302	40481087	1979-02-02	1979-02-02 00:00:00	1979-02-23	1979-02-23 00:00:00	32020		\N	352788	0	444814009	40481087		0
78841	4670	4296204	1993-04-03	1993-04-03 00:00:00	1993-05-01	1993-05-01 00:00:00	32020		\N	311157	0	403190006	4296204		0
89591	5328	40481087	1921-10-31	1921-10-31 00:00:00	1921-11-14	1921-11-14 00:00:00	32020		\N	354594	0	444814009	40481087		0
89702	5333	4043241	1996-01-14	1996-01-14 00:00:00	\N	\N	32020		\N	355117	0	230265002	4043241		0
79584	4715	4152936	2008-09-03	2008-09-03 00:00:00	2008-09-17	2008-09-17 00:00:00	32020		\N	313923	0	283385000	4152936		0
79840	4731	81893	2007-02-16	2007-02-16 00:00:00	\N	\N	32020		\N	315224	0	64766004	81893		0
80116	4749	4112343	1986-07-11	1986-07-11 00:00:00	1986-07-20	1986-07-20 00:00:00	32020		\N	316250	0	195662009	4112343		0
80225	4755	40481087	2013-11-04	2013-11-04 00:00:00	2013-11-25	2013-11-25 00:00:00	32020		\N	316765	0	444814009	40481087		0
81745	4848	40481087	1959-04-20	1959-04-20 00:00:00	1959-04-27	1959-04-27 00:00:00	32020		\N	322492	0	444814009	40481087		0
82097	4867	40481087	1967-10-29	1967-10-29 00:00:00	1967-11-12	1967-11-12 00:00:00	32020		\N	323596	0	444814009	40481087		0
82802	4917	81151	1997-12-14	1997-12-14 00:00:00	1998-01-18	1998-01-18 00:00:00	32020		\N	326749	0	44465007	81151		0
82969	4927	40481087	2006-04-03	2006-04-03 00:00:00	2006-04-10	2006-04-10 00:00:00	32020		\N	327491	0	444814009	40481087		0
84228	5002	378001	1989-07-05	1989-07-05 00:00:00	1989-09-03	1989-09-03 00:00:00	32020		\N	332713	0	62106007	378001		0
85139	5063	4283893	1974-01-11	1974-01-11 00:00:00	1974-02-01	1974-02-01 00:00:00	32020		\N	336594	0	36971009	4283893		0
85314	5076	372328	1938-06-06	1938-06-06 00:00:00	1938-08-16	1938-08-16 00:00:00	32020		\N	337335	0	65363002	372328		0
85360	5077	4285898	2002-09-29	2002-09-29 00:00:00	\N	\N	32020		\N	337438	0	68496003	4285898		0
75007	4454	40481087	1978-08-20	1978-08-20 00:00:00	1978-09-10	1978-09-10 00:00:00	32020		\N	296415	0	444814009	40481087		0
75132	4462	4112343	1993-03-11	1993-03-11 00:00:00	1993-03-21	1993-03-21 00:00:00	32020		\N	296942	0	195662009	4112343		0
85864	5108	4112343	1982-01-23	1982-01-23 00:00:00	1982-02-05	1982-02-05 00:00:00	32020		\N	339410	0	195662009	4112343		0
75389	4475	40481087	1984-05-26	1984-05-26 00:00:00	1984-06-09	1984-06-09 00:00:00	32020		\N	297732	0	444814009	40481087		0
75678	4488	28060	1978-10-08	1978-10-08 00:00:00	1978-10-21	1978-10-21 00:00:00	32020		\N	298820	0	43878008	28060		0
75797	4496	372328	1950-04-13	1950-04-13 00:00:00	1950-08-17	1950-08-17 00:00:00	32020		\N	299280	0	65363002	372328		0
75957	4505	4109685	1985-04-26	1985-04-26 00:00:00	1985-05-10	1985-05-10 00:00:00	32020		\N	300079	0	284551006	4109685		0
86689	5157	372328	1965-02-11	1965-02-11 00:00:00	1965-03-18	1965-03-18 00:00:00	32020		\N	342925	0	65363002	372328		0
86886	5172	81151	1956-08-24	1956-08-24 00:00:00	1956-09-21	1956-09-21 00:00:00	32020		\N	343918	0	44465007	81151		0
87114	5189	80180	1998-10-28	1998-10-28 00:00:00	\N	\N	32020		\N	344911	0	396275006	80180		0
87204	5193	81151	2008-10-12	2008-10-12 00:00:00	2008-11-02	2008-11-02 00:00:00	32020		\N	345177	0	44465007	81151		0
87364	5199	260139	2010-01-27	2010-01-27 00:00:00	2010-02-10	2010-02-10 00:00:00	32020		\N	345775	0	10509002	260139		0
77009	4562	40486433	1966-02-03	1966-02-03 00:00:00	\N	\N	32020		\N	304014	0	446096008	40486433		0
77130	4570	40481087	1958-10-04	1958-10-04 00:00:00	1958-10-18	1958-10-18 00:00:00	32020		\N	304455	0	444814009	40481087		0
87916	5230	4112343	2005-02-19	2005-02-19 00:00:00	2005-03-03	2005-03-03 00:00:00	32020		\N	347991	0	195662009	4112343		0
88044	5236	4230399	1986-07-10	1986-07-10 00:00:00	1986-10-08	1986-10-08 00:00:00	32020		\N	348426	0	359817006	4230399		0
88214	5245	4155034	1989-09-07	1989-09-07 00:00:00	1989-09-21	1989-09-21 00:00:00	32020		\N	348934	0	283371005	4155034		0
88333	5252	40481087	2008-02-14	2008-02-14 00:00:00	2008-02-21	2008-02-21 00:00:00	32020		\N	349435	0	444814009	40481087		0
88658	5272	260139	2009-01-04	2009-01-04 00:00:00	2009-01-11	2009-01-11 00:00:00	32020		\N	350657	0	10509002	260139		0
78315	4637	378001	1990-09-18	1990-09-18 00:00:00	1990-11-17	1990-11-17 00:00:00	32020		\N	309046	0	62106007	378001		0
78489	4646	81151	2017-10-17	2017-10-17 00:00:00	2017-11-07	2017-11-07 00:00:00	32020		\N	309819	0	44465007	81151		0
89147	5302	40481087	2005-08-09	2005-08-09 00:00:00	2005-08-23	2005-08-23 00:00:00	32020		\N	352791	0	444814009	40481087		0
78842	4670	40481087	2008-07-12	2008-07-12 00:00:00	2008-07-26	2008-07-26 00:00:00	32020		\N	311206	0	444814009	40481087		0
89592	5328	4278672	1955-02-03	1955-02-03 00:00:00	1955-05-04	1955-05-04 00:00:00	32020		\N	354588	0	65966004	4278672		0
89703	5333	40481087	1990-03-19	1990-03-19 00:00:00	1990-04-09	1990-04-09 00:00:00	32020		\N	355093	0	444814009	40481087		0
79585	4715	260139	1970-01-26	1970-01-26 00:00:00	1970-02-02	1970-02-02 00:00:00	32020		\N	313896	0	10509002	260139		0
79841	4731	4266809	2008-09-08	2008-09-08 00:00:00	\N	\N	32020		\N	315224	0	397881000	4266809		0
80117	4749	40481087	1979-11-23	1979-11-23 00:00:00	1979-12-14	1979-12-14 00:00:00	32020		\N	316238	0	444814009	40481087		0
80226	4755	260139	2001-03-22	2001-03-22 00:00:00	2001-04-05	2001-04-05 00:00:00	32020		\N	316774	0	10509002	260139		0
81746	4848	4113008	1980-08-16	1980-08-16 00:00:00	1980-09-06	1980-09-06 00:00:00	32020		\N	322562	0	284549007	4113008		0
82098	4867	4296205	1968-09-21	1968-09-21 00:00:00	1968-10-05	1968-10-05 00:00:00	32020		\N	323683	0	403191005	4296205		0
82803	4917	40481087	1984-07-18	1984-07-18 00:00:00	1984-08-01	1984-08-01 00:00:00	32020		\N	326736	0	444814009	40481087		0
82991	4929	4113008	1965-11-25	1965-11-25 00:00:00	1965-12-09	1965-12-09 00:00:00	32020		\N	327669	0	284549007	4113008		0
84229	5002	78272	1988-07-05	1988-07-05 00:00:00	1988-08-09	1988-08-09 00:00:00	32020		\N	332712	0	70704007	78272		0
85152	5065	4112343	1973-07-05	1973-07-05 00:00:00	1973-07-12	1973-07-12 00:00:00	32020		\N	336731	0	195662009	4112343		0
85315	5076	4048171	1940-03-14	1940-03-14 00:00:00	\N	\N	32020		\N	337352	0	232353008	4048171		0
85361	5077	80180	2002-10-29	2002-10-29 00:00:00	\N	\N	32020		\N	337438	0	396275006	80180		0
75008	4454	40481087	1938-03-03	1938-03-03 00:00:00	1938-03-17	1938-03-17 00:00:00	32020		\N	296414	0	444814009	40481087		0
75133	4462	261325	1990-09-20	1990-09-20 00:00:00	\N	\N	32020		\N	296905	0	87433001	261325		0
85865	5108	40481087	1980-03-18	1980-03-18 00:00:00	1980-04-08	1980-04-08 00:00:00	32020		\N	339383	0	444814009	40481087		0
75390	4475	4218389	2008-05-14	2008-05-14 00:00:00	2008-06-04	2008-06-04 00:00:00	32020		\N	297717	0	39848009	4218389		0
75679	4488	40481087	2001-10-03	2001-10-03 00:00:00	2001-10-17	2001-10-17 00:00:00	32020		\N	298791	0	444814009	40481087		0
75798	4496	80180	1980-08-21	1980-08-21 00:00:00	\N	\N	32020		\N	299333	0	396275006	80180		0
75958	4505	4296205	1993-03-29	1993-03-29 00:00:00	1993-05-03	1993-05-03 00:00:00	32020		\N	300080	0	403191005	4296205		0
86690	5157	375671	1982-09-28	1982-09-28 00:00:00	1982-10-28	1982-10-28 00:00:00	32020		\N	342946	0	62564004	375671		0
86887	5172	4112343	1963-07-22	1963-07-22 00:00:00	1963-08-04	1963-08-04 00:00:00	32020		\N	343851	0	195662009	4112343		0
87115	5189	40481087	1999-01-31	1999-01-31 00:00:00	1999-02-14	1999-02-14 00:00:00	32020		\N	344917	0	444814009	40481087		0
87205	5193	40481087	1971-06-05	1971-06-05 00:00:00	1971-06-19	1971-06-19 00:00:00	32020		\N	345238	0	444814009	40481087		0
87365	5199	260139	2005-06-06	2005-06-06 00:00:00	2005-06-20	2005-06-20 00:00:00	32020		\N	345782	0	10509002	260139		0
77010	4562	372328	1965-05-26	1965-05-26 00:00:00	1965-08-28	1965-08-28 00:00:00	32020		\N	304022	0	65363002	372328		0
77131	4570	28060	1944-05-03	1944-05-03 00:00:00	1944-05-14	1944-05-14 00:00:00	32020		\N	304459	0	43878008	28060		0
87917	5230	40481087	1975-04-07	1975-04-07 00:00:00	1975-04-14	1975-04-14 00:00:00	32020		\N	347954	0	444814009	40481087		0
88045	5236	260139	2004-11-28	2004-11-28 00:00:00	2004-12-05	2004-12-05 00:00:00	32020		\N	348421	0	10509002	260139		0
88237	5249	40481087	2007-01-07	2007-01-07 00:00:00	2007-01-14	2007-01-14 00:00:00	32020		\N	349173	0	444814009	40481087		0
88334	5252	40481087	1978-02-24	1978-02-24 00:00:00	1978-03-03	1978-03-03 00:00:00	32020		\N	349458	0	444814009	40481087		0
88659	5272	4294548	1965-11-10	1965-11-10 00:00:00	1965-12-01	1965-12-01 00:00:00	32020		\N	350653	0	75498004	4294548		0
78316	4637	4112343	1990-07-21	1990-07-21 00:00:00	1990-07-31	1990-07-31 00:00:00	32020		\N	309014	0	195662009	4112343		0
78490	4646	40481087	2003-08-19	2003-08-19 00:00:00	2003-09-02	2003-09-02 00:00:00	32020		\N	309878	0	444814009	40481087		0
89148	5302	372328	1973-05-25	1973-05-25 00:00:00	1973-08-10	1973-08-10 00:00:00	32020		\N	352793	0	65363002	372328		0
78843	4670	260139	1978-09-12	1978-09-12 00:00:00	1978-09-26	1978-09-26 00:00:00	32020		\N	311228	0	10509002	260139		0
89593	5328	40481087	1920-01-10	1920-01-10 00:00:00	1920-01-31	1920-01-31 00:00:00	32020		\N	354605	0	444814009	40481087		0
89704	5333	28060	1987-09-01	1987-09-01 00:00:00	1987-09-10	1987-09-10 00:00:00	32020		\N	355130	0	43878008	28060		0
79586	4715	40481087	1986-02-12	1986-02-12 00:00:00	1986-02-26	1986-02-26 00:00:00	32020		\N	313897	0	444814009	40481087		0
79842	4731	4059173	1972-10-27	1972-10-27 00:00:00	1973-01-25	1973-01-25 00:00:00	32020		\N	315215	0	16114001	4059173		0
80118	4749	4112343	1981-10-07	1981-10-07 00:00:00	1981-10-17	1981-10-17 00:00:00	32020		\N	316249	0	195662009	4112343		0
80227	4755	372328	1930-03-01	1930-03-01 00:00:00	1930-09-19	1930-09-19 00:00:00	32020		\N	316745	0	65363002	372328		0
81747	4848	260139	1975-04-27	1975-04-27 00:00:00	1975-05-11	1975-05-11 00:00:00	32020		\N	322508	0	10509002	260139		0
82099	4867	4112343	1967-09-16	1967-09-16 00:00:00	1967-09-28	1967-09-28 00:00:00	32020		\N	323666	0	195662009	4112343		0
82804	4917	80180	2016-06-28	2016-06-28 00:00:00	\N	\N	32020		\N	326730	0	396275006	80180		0
82992	4929	4112343	2012-09-15	2012-09-15 00:00:00	2012-09-27	2012-09-27 00:00:00	32020		\N	327662	0	195662009	4112343		0
84230	5002	372328	1976-10-06	1976-10-06 00:00:00	1976-12-17	1976-12-17 00:00:00	32020		\N	332705	0	65363002	372328		0
85153	5065	28060	2000-07-31	2000-07-31 00:00:00	2000-08-10	2000-08-10 00:00:00	32020		\N	336703	0	43878008	28060		0
85316	5076	40481087	1989-12-18	1989-12-18 00:00:00	1989-12-25	1989-12-25 00:00:00	32020		\N	337423	0	444814009	40481087		0
85362	5077	4266809	2002-10-29	2002-10-29 00:00:00	\N	\N	32020		\N	337438	0	397881000	4266809		0
75009	4454	375671	1946-03-10	1946-03-10 00:00:00	1946-05-09	1946-05-09 00:00:00	32020		\N	296496	0	62564004	375671		0
75134	4462	372328	1956-09-09	1956-09-09 00:00:00	1957-01-10	1957-01-10 00:00:00	32020		\N	296917	0	65363002	372328		0
85866	5108	260139	2002-11-14	2002-11-14 00:00:00	2002-11-28	2002-11-28 00:00:00	32020		\N	339400	0	10509002	260139		0
75391	4475	40481087	2005-08-27	2005-08-27 00:00:00	2005-09-17	2005-09-17 00:00:00	32020		\N	297709	0	444814009	40481087		0
75680	4488	4142905	1982-09-27	1982-09-27 00:00:00	1982-12-26	1982-12-26 00:00:00	32020		\N	298843	0	33737001	4142905		0
75799	4496	4134304	1970-06-22	1970-06-22 00:00:00	1970-09-20	1970-09-20 00:00:00	32020		\N	299307	0	263102004	4134304		0
75959	4505	4155034	2016-04-02	2016-04-02 00:00:00	2016-04-23	2016-04-23 00:00:00	32020		\N	300011	0	283371005	4155034		0
86692	5157	440448	1985-04-06	1985-04-06 00:00:00	\N	\N	32020		\N	342947	0	74400008	440448		0
86888	5172	260139	2017-05-11	2017-05-11 00:00:00	2017-05-25	2017-05-25 00:00:00	32020		\N	343856	0	10509002	260139		0
87116	5189	260139	1972-01-15	1972-01-15 00:00:00	1972-01-22	1972-01-22 00:00:00	32020		\N	344941	0	10509002	260139		0
87206	5193	313217	2015-09-24	2015-09-24 00:00:00	\N	\N	32020		\N	345235	0	49436004	313217		0
87366	5200	81151	1960-08-20	1960-08-20 00:00:00	1960-09-03	1960-09-03 00:00:00	32020		\N	345937	0	44465007	81151		0
77011	4562	260139	1975-09-14	1975-09-14 00:00:00	1975-09-21	1975-09-21 00:00:00	32020		\N	304057	0	10509002	260139		0
77132	4570	40481087	1996-06-17	1996-06-17 00:00:00	1996-07-01	1996-07-01 00:00:00	32020		\N	304457	0	444814009	40481087		0
87918	5230	4112343	1990-10-02	1990-10-02 00:00:00	1990-10-11	1990-10-11 00:00:00	32020		\N	347990	0	195662009	4112343		0
88046	5236	78272	2005-09-28	2005-09-28 00:00:00	2005-10-19	2005-10-19 00:00:00	32020		\N	348427	0	70704007	78272		0
88238	5249	4112343	1967-06-14	1967-06-14 00:00:00	1967-06-21	1967-06-21 00:00:00	32020		\N	349183	0	195662009	4112343		0
88335	5252	260139	1961-12-06	1961-12-06 00:00:00	1961-12-13	1961-12-13 00:00:00	32020		\N	349409	0	10509002	260139		0
88660	5272	4112343	1950-12-18	1950-12-18 00:00:00	1950-12-26	1950-12-26 00:00:00	32020		\N	350671	0	195662009	4112343		0
78317	4637	81151	2003-05-13	2003-05-13 00:00:00	2003-05-27	2003-05-27 00:00:00	32020		\N	309047	0	44465007	81151		0
78491	4646	40481087	1983-10-21	1983-10-21 00:00:00	1983-10-28	1983-10-28 00:00:00	32020		\N	309855	0	444814009	40481087		0
89149	5302	80180	2010-07-15	2010-07-15 00:00:00	\N	\N	32020		\N	352766	0	396275006	80180		0
78844	4670	260139	1964-03-18	1964-03-18 00:00:00	1964-03-25	1964-03-25 00:00:00	32020		\N	311203	0	10509002	260139		0
89594	5328	4116491	1966-09-15	1966-09-15 00:00:00	1966-10-16	1966-10-16 00:00:00	32020		\N	354708	0	301011002	4116491		0
89705	5333	4112343	1981-02-13	1981-02-13 00:00:00	1981-02-22	1981-02-22 00:00:00	32020		\N	355129	0	195662009	4112343		0
79587	4715	28060	2017-09-05	2017-09-05 00:00:00	2017-09-13	2017-09-13 00:00:00	32020		\N	313900	0	43878008	28060		0
79843	4731	4112343	1979-04-25	1979-04-25 00:00:00	1979-05-05	1979-05-05 00:00:00	32020		\N	315192	0	195662009	4112343		0
80119	4749	40481087	2011-07-22	2011-07-22 00:00:00	2011-07-29	2011-07-29 00:00:00	32020		\N	316227	0	444814009	40481087		0
80228	4755	260139	1925-06-06	1925-06-06 00:00:00	1925-06-20	1925-06-20 00:00:00	32020		\N	316679	0	10509002	260139		0
81748	4848	81151	2017-03-10	2017-03-10 00:00:00	2017-04-14	2017-04-14 00:00:00	32020		\N	322540	0	44465007	81151		0
82100	4867	4112343	1996-11-13	1996-11-13 00:00:00	1996-11-21	1996-11-21 00:00:00	32020		\N	323598	0	195662009	4112343		0
82805	4917	40481087	1985-01-07	1985-01-07 00:00:00	1985-01-14	1985-01-14 00:00:00	32020		\N	326750	0	444814009	40481087		0
82993	4929	28060	1968-02-15	1968-02-15 00:00:00	1968-02-26	1968-02-26 00:00:00	32020		\N	327695	0	43878008	28060		0
84231	5002	372328	1977-09-13	1977-09-13 00:00:00	1978-03-17	1978-03-17 00:00:00	32020		\N	332718	0	65363002	372328		0
85154	5065	317576	2004-03-02	2004-03-02 00:00:00	\N	\N	32020		\N	336744	0	53741008	317576		0
85317	5076	40481087	1984-12-23	1984-12-23 00:00:00	1985-01-06	1985-01-06 00:00:00	32020		\N	337421	0	444814009	40481087		0
85363	5077	4310024	2001-10-04	2001-10-04 00:00:00	\N	\N	32020		\N	337438	0	424802006	4310024		0
75010	4454	40481087	1926-07-30	1926-07-30 00:00:00	1926-08-06	1926-08-06 00:00:00	32020		\N	296462	0	444814009	40481087		0
75135	4462	4112343	1967-09-01	1967-09-01 00:00:00	1967-09-09	1967-09-09 00:00:00	32020		\N	296910	0	195662009	4112343		0
85890	5111	80180	1979-12-06	1979-12-06 00:00:00	\N	\N	32020		\N	339629	0	396275006	80180		0
75392	4476	40481087	1996-07-19	1996-07-19 00:00:00	1996-08-09	1996-08-09 00:00:00	32020		\N	297847	0	444814009	40481087		0
75681	4488	4155034	1992-08-26	1992-08-26 00:00:00	1992-09-09	1992-09-09 00:00:00	32020		\N	298831	0	283371005	4155034		0
75800	4496	78272	1964-08-01	1964-08-01 00:00:00	1964-08-22	1964-08-22 00:00:00	32020		\N	299306	0	70704007	78272		0
75960	4505	40481087	1944-08-13	1944-08-13 00:00:00	1944-08-27	1944-08-27 00:00:00	32020		\N	300081	0	444814009	40481087		0
86693	5157	40481087	2004-08-17	2004-08-17 00:00:00	2004-08-31	2004-08-31 00:00:00	32020		\N	342883	0	444814009	40481087		0
86889	5172	372328	1957-01-23	1957-01-23 00:00:00	1957-04-23	1957-04-23 00:00:00	32020		\N	343831	0	65363002	372328		0
87117	5189	40481087	1980-09-28	1980-09-28 00:00:00	1980-10-05	1980-10-05 00:00:00	32020		\N	344916	0	444814009	40481087		0
87207	5193	4112343	1983-07-05	1983-07-05 00:00:00	1983-07-13	1983-07-13 00:00:00	32020		\N	345200	0	195662009	4112343		0
87367	5200	40481087	2019-04-20	2019-04-20 00:00:00	2019-05-04	2019-05-04 00:00:00	32020		\N	345813	0	444814009	40481087		0
77012	4562	40481087	1997-03-17	1997-03-17 00:00:00	1997-03-31	1997-03-31 00:00:00	32020		\N	304042	0	444814009	40481087		0
77133	4570	4134304	1942-10-24	1942-10-24 00:00:00	1942-12-23	1942-12-23 00:00:00	32020		\N	304452	0	263102004	4134304		0
87919	5230	4134304	2002-03-05	2002-03-05 00:00:00	2002-04-04	2002-04-04 00:00:00	32020		\N	347941	0	263102004	4134304		0
88047	5236	40481087	1986-06-25	1986-06-25 00:00:00	1986-07-16	1986-07-16 00:00:00	32020		\N	348377	0	444814009	40481087		0
88239	5249	4112343	2004-07-06	2004-07-06 00:00:00	2004-07-13	2004-07-13 00:00:00	32020		\N	349236	0	195662009	4112343		0
88336	5252	40481087	1973-06-08	1973-06-08 00:00:00	1973-06-15	1973-06-15 00:00:00	32020		\N	349432	0	444814009	40481087		0
88661	5272	4112343	1929-06-03	1929-06-03 00:00:00	1929-06-10	1929-06-10 00:00:00	32020		\N	350709	0	195662009	4112343		0
78318	4637	78272	1975-12-12	1975-12-12 00:00:00	1976-01-16	1976-01-16 00:00:00	32020		\N	309043	0	70704007	78272		0
78492	4646	40481087	2000-09-10	2000-09-10 00:00:00	2000-09-24	2000-09-24 00:00:00	32020		\N	309757	0	444814009	40481087		0
89150	5302	40481087	1982-10-13	1982-10-13 00:00:00	1982-10-27	1982-10-27 00:00:00	32020		\N	352779	0	444814009	40481087		0
78845	4670	40481087	2009-10-27	2009-10-27 00:00:00	2009-11-10	2009-11-10 00:00:00	32020		\N	311164	0	444814009	40481087		0
89595	5328	40481087	1992-02-13	1992-02-13 00:00:00	1992-02-27	1992-02-27 00:00:00	32020		\N	354642	0	444814009	40481087		0
89706	5333	4112343	1981-07-23	1981-07-23 00:00:00	1981-07-31	1981-07-31 00:00:00	32020		\N	355108	0	195662009	4112343		0
79588	4715	4283893	1957-05-12	1957-05-12 00:00:00	1957-06-30	1957-06-30 00:00:00	32020		\N	313895	0	36971009	4283893		0
79844	4731	4112343	1973-05-12	1973-05-12 00:00:00	1973-05-23	1973-05-23 00:00:00	32020		\N	315178	0	195662009	4112343		0
80120	4749	40479422	1999-08-01	1999-08-01 00:00:00	1999-10-07	1999-10-07 00:00:00	32020		\N	316223	0	444448004	40479422		0
80229	4755	4134304	2014-05-24	2014-05-24 00:00:00	2014-06-23	2014-06-23 00:00:00	32020		\N	316711	0	263102004	4134304		0
81749	4848	4112343	2000-09-17	2000-09-17 00:00:00	2000-09-25	2000-09-25 00:00:00	32020		\N	322501	0	195662009	4112343		0
82134	4872	40481087	2009-03-07	2009-03-07 00:00:00	2009-03-21	2009-03-21 00:00:00	32020		\N	323997	0	444814009	40481087		0
82806	4917	28060	1989-02-16	1989-02-16 00:00:00	1989-02-28	1989-02-28 00:00:00	32020		\N	326737	0	43878008	28060		0
82994	4929	40481087	1989-02-23	1989-02-23 00:00:00	1989-03-16	1989-03-16 00:00:00	32020		\N	327697	0	444814009	40481087		0
84232	5002	260139	2009-09-15	2009-09-15 00:00:00	2009-09-29	2009-09-29 00:00:00	32020		\N	332704	0	10509002	260139		0
85155	5065	260139	2002-01-06	2002-01-06 00:00:00	2002-01-13	2002-01-13 00:00:00	32020		\N	336704	0	10509002	260139		0
85318	5076	4152936	1983-04-05	1983-04-05 00:00:00	1983-04-26	1983-04-26 00:00:00	32020		\N	337329	0	283385000	4152936		0
85364	5077	4112343	1996-07-20	1996-07-20 00:00:00	1996-07-30	1996-07-30 00:00:00	32020		\N	337491	0	195662009	4112343		0
75011	4454	78272	2000-05-07	2000-05-07 00:00:00	2000-05-28	2000-05-28 00:00:00	32020		\N	296503	0	70704007	78272		0
75136	4462	40481087	1994-09-25	1994-09-25 00:00:00	1994-10-09	1994-10-09 00:00:00	32020		\N	296915	0	444814009	40481087		0
85891	5111	192671	1980-02-02	1980-02-02 00:00:00	\N	\N	32020		\N	339633	0	K92.2	35208414		0
75393	4476	133834	1962-05-26	1962-05-26 00:00:00	1979-10-28	1979-10-28 00:00:00	32020		\N	297892	0	24079001	133834		0
75682	4488	257012	1978-05-18	1978-05-18 00:00:00	\N	\N	32020		\N	298788	0	40055000	257012		0
75801	4496	40481087	1985-08-25	1985-08-25 00:00:00	1985-09-15	1985-09-15 00:00:00	32020		\N	299312	0	444814009	40481087		0
75961	4505	80180	1981-10-23	1981-10-23 00:00:00	\N	\N	32020		\N	300120	0	396275006	80180		0
86694	5157	313217	2019-05-16	2019-05-16 00:00:00	\N	\N	32020		\N	342902	0	49436004	313217		0
86890	5172	40481087	2004-05-04	2004-05-04 00:00:00	2004-05-25	2004-05-25 00:00:00	32020		\N	343855	0	444814009	40481087		0
87118	5189	4112343	1981-05-03	1981-05-03 00:00:00	1981-05-15	1981-05-15 00:00:00	32020		\N	344942	0	195662009	4112343		0
87208	5193	40481087	1963-06-18	1963-06-18 00:00:00	1963-07-09	1963-07-09 00:00:00	32020		\N	345199	0	444814009	40481087		0
87368	5200	4112343	1982-06-25	1982-06-25 00:00:00	1982-07-05	1982-07-05 00:00:00	32020		\N	345934	0	195662009	4112343		0
77013	4562	260139	2015-10-09	2015-10-09 00:00:00	2015-10-23	2015-10-23 00:00:00	32020		\N	304044	0	10509002	260139		0
77134	4570	4112343	2018-11-11	2018-11-11 00:00:00	2018-11-19	2018-11-19 00:00:00	32020		\N	304466	0	195662009	4112343		0
87920	5230	40481087	1952-11-26	1952-11-26 00:00:00	1952-12-17	1952-12-17 00:00:00	32020		\N	347946	0	444814009	40481087		0
88048	5236	260139	1986-03-22	1986-03-22 00:00:00	1986-04-05	1986-04-05 00:00:00	32020		\N	348403	0	10509002	260139		0
88240	5249	4152936	1966-05-25	1966-05-25 00:00:00	1966-06-08	1966-06-08 00:00:00	32020		\N	349246	0	283385000	4152936		0
88337	5252	4116491	2015-12-03	2015-12-03 00:00:00	2016-01-06	2016-01-06 00:00:00	32020		\N	349416	0	301011002	4116491		0
88662	5272	28060	1921-01-12	1921-01-12 00:00:00	1921-01-20	1921-01-20 00:00:00	32020		\N	350586	0	43878008	28060		0
78319	4637	40481087	2017-04-04	2017-04-04 00:00:00	2017-04-18	2017-04-18 00:00:00	32020		\N	309068	0	444814009	40481087		0
78493	4646	260139	1945-09-22	1945-09-22 00:00:00	1945-09-29	1945-09-29 00:00:00	32020		\N	309719	0	10509002	260139		0
89151	5302	40481087	2006-07-27	2006-07-27 00:00:00	2006-08-10	2006-08-10 00:00:00	32020		\N	352814	0	444814009	40481087		0
78846	4670	4112343	1961-06-24	1961-06-24 00:00:00	1961-07-03	1961-07-03 00:00:00	32020		\N	311191	0	195662009	4112343		0
89596	5328	4218389	1921-07-26	1921-07-26 00:00:00	1921-08-30	1921-08-30 00:00:00	32020		\N	354587	0	39848009	4218389		0
89707	5333	4112343	1962-10-27	1962-10-27 00:00:00	1962-11-05	1962-11-05 00:00:00	32020		\N	355106	0	195662009	4112343		0
79589	4715	40481087	1976-09-24	1976-09-24 00:00:00	1976-10-01	1976-10-01 00:00:00	32020		\N	313932	0	444814009	40481087		0
79845	4731	372328	1975-05-08	1975-05-08 00:00:00	1975-10-07	1975-10-07 00:00:00	32020		\N	315240	0	65363002	372328		0
80121	4749	40481087	1981-07-12	1981-07-12 00:00:00	1981-08-02	1981-08-02 00:00:00	32020		\N	316248	0	444814009	40481087		0
80230	4755	28060	1944-09-06	1944-09-06 00:00:00	1944-09-16	1944-09-16 00:00:00	32020		\N	316755	0	43878008	28060		0
81750	4848	40481087	1990-09-02	1990-09-02 00:00:00	1990-09-09	1990-09-09 00:00:00	32020		\N	322499	0	444814009	40481087		0
82135	4872	372328	1930-11-14	1930-11-14 00:00:00	1931-09-22	1931-09-22 00:00:00	32020		\N	324058	0	65363002	372328		0
82807	4917	28060	1996-04-04	1996-04-04 00:00:00	1996-04-16	1996-04-16 00:00:00	32020		\N	326758	0	43878008	28060		0
82995	4929	40481087	2010-05-25	2010-05-25 00:00:00	2010-06-15	2010-06-15 00:00:00	32020		\N	327720	0	444814009	40481087		0
84233	5002	372328	1985-11-05	1985-11-05 00:00:00	1986-04-18	1986-04-18 00:00:00	32020		\N	332719	0	65363002	372328		0
85156	5065	40481087	1969-10-09	1969-10-09 00:00:00	1969-10-16	1969-10-16 00:00:00	32020		\N	336709	0	444814009	40481087		0
85319	5076	260139	1951-09-04	1951-09-04 00:00:00	1951-09-18	1951-09-18 00:00:00	32020		\N	337409	0	10509002	260139		0
85366	5077	4029498	2017-03-04	2017-03-04 00:00:00	\N	\N	32020		\N	337490	0	128613002	4029498		0
75012	4454	4142905	2018-02-23	2018-02-23 00:00:00	2018-05-24	2018-05-24 00:00:00	32020		\N	296460	0	33737001	4142905		0
75137	4462	372328	1955-12-30	1955-12-30 00:00:00	1956-04-12	1956-04-12 00:00:00	32020		\N	296896	0	65363002	372328		0
85892	5111	40481087	1961-05-31	1961-05-31 00:00:00	1961-06-21	1961-06-21 00:00:00	32020		\N	339587	0	444814009	40481087		0
75394	4476	40481087	2012-11-27	2012-11-27 00:00:00	2012-12-18	2012-12-18 00:00:00	32020		\N	297802	0	444814009	40481087		0
75686	4490	81151	1931-12-19	1931-12-19 00:00:00	1932-01-16	1932-01-16 00:00:00	32020		\N	298882	0	44465007	81151		0
75802	4496	40481087	1996-01-12	1996-01-12 00:00:00	1996-01-19	1996-01-19 00:00:00	32020		\N	299272	0	444814009	40481087		0
75962	4505	40481087	1937-06-22	1937-06-22 00:00:00	1937-07-13	1937-07-13 00:00:00	32020		\N	300044	0	444814009	40481087		0
86695	5157	372328	1966-12-08	1966-12-08 00:00:00	1967-03-16	1967-03-16 00:00:00	32020		\N	342926	0	65363002	372328		0
86891	5172	40481087	2015-08-25	2015-08-25 00:00:00	2015-09-01	2015-09-01 00:00:00	32020		\N	343829	0	444814009	40481087		0
87119	5189	40481087	1957-09-10	1957-09-10 00:00:00	1957-09-24	1957-09-24 00:00:00	32020		\N	344932	0	444814009	40481087		0
87209	5193	40481087	2018-03-10	2018-03-10 00:00:00	2018-03-24	2018-03-24 00:00:00	32020		\N	345244	0	444814009	40481087		0
87369	5200	260139	1995-01-27	1995-01-27 00:00:00	1995-02-03	1995-02-03 00:00:00	32020		\N	345812	0	10509002	260139		0
77014	4562	4112343	2006-02-01	2006-02-01 00:00:00	2006-02-09	2006-02-09 00:00:00	32020		\N	304007	0	195662009	4112343		0
77135	4570	4112343	1993-08-03	1993-08-03 00:00:00	1993-08-11	1993-08-11 00:00:00	32020		\N	304428	0	195662009	4112343		0
87921	5230	260139	1996-06-12	1996-06-12 00:00:00	1996-06-26	1996-06-26 00:00:00	32020		\N	347961	0	10509002	260139		0
88049	5236	4112343	1982-07-11	1982-07-11 00:00:00	1982-07-20	1982-07-20 00:00:00	32020		\N	348416	0	195662009	4112343		0
88241	5249	260139	2007-12-03	2007-12-03 00:00:00	2007-12-17	2007-12-17 00:00:00	32020		\N	349186	0	10509002	260139		0
88338	5252	40481087	2000-10-04	2000-10-04 00:00:00	2000-10-18	2000-10-18 00:00:00	32020		\N	349434	0	444814009	40481087		0
88663	5272	40481087	1989-03-10	1989-03-10 00:00:00	1989-03-17	1989-03-17 00:00:00	32020		\N	350621	0	444814009	40481087		0
78320	4637	4112343	1993-12-11	1993-12-11 00:00:00	1993-12-19	1993-12-19 00:00:00	32020		\N	309012	0	195662009	4112343		0
78494	4646	260139	1986-06-11	1986-06-11 00:00:00	1986-06-25	1986-06-25 00:00:00	32020		\N	309856	0	10509002	260139		0
89177	5306	40481087	1985-01-15	1985-01-15 00:00:00	1985-01-22	1985-01-22 00:00:00	32020		\N	352959	0	444814009	40481087		0
78847	4670	4112343	1963-11-21	1963-11-21 00:00:00	1963-11-29	1963-11-29 00:00:00	32020		\N	311160	0	195662009	4112343		0
89597	5328	4112343	1922-03-29	1922-03-29 00:00:00	1922-04-11	1922-04-11 00:00:00	32020		\N	354617	0	195662009	4112343		0
89708	5333	260139	1955-12-06	1955-12-06 00:00:00	1955-12-20	1955-12-20 00:00:00	32020		\N	355145	0	10509002	260139		0
79590	4715	81893	1993-09-22	1993-09-22 00:00:00	\N	\N	32020		\N	313974	0	64766004	81893		0
79846	4731	40481087	1992-03-19	1992-03-19 00:00:00	1992-03-26	1992-03-26 00:00:00	32020		\N	315212	0	444814009	40481087		0
80122	4749	28060	1983-12-09	1983-12-09 00:00:00	1983-12-22	1983-12-22 00:00:00	32020		\N	316247	0	43878008	28060		0
80231	4755	40481087	1979-05-21	1979-05-21 00:00:00	1979-05-28	1979-05-28 00:00:00	32020		\N	316726	0	444814009	40481087		0
81751	4848	40481087	2008-10-02	2008-10-02 00:00:00	2008-10-16	2008-10-16 00:00:00	32020		\N	322547	0	444814009	40481087		0
82136	4872	40481087	1925-06-25	1925-06-25 00:00:00	1925-07-16	1925-07-16 00:00:00	32020		\N	323960	0	444814009	40481087		0
82808	4917	4112343	2015-09-16	2015-09-16 00:00:00	2015-09-26	2015-09-26 00:00:00	32020		\N	326752	0	195662009	4112343		0
82996	4929	81151	1979-10-27	1979-10-27 00:00:00	1979-11-10	1979-11-10 00:00:00	32020		\N	327671	0	44465007	81151		0
84234	5002	4112343	1989-05-19	1989-05-19 00:00:00	1989-05-28	1989-05-28 00:00:00	32020		\N	332725	0	195662009	4112343		0
85157	5065	378001	1988-09-29	1988-09-29 00:00:00	1988-11-28	1988-11-28 00:00:00	32020		\N	336707	0	62106007	378001		0
85320	5076	4112343	1999-11-27	1999-11-27 00:00:00	1999-12-07	1999-12-07 00:00:00	32020		\N	337332	0	195662009	4112343		0
85367	5077	4156265	1973-10-31	1973-10-31 00:00:00	1973-11-14	1973-11-14 00:00:00	32020		\N	337488	0	370247008	4156265		0
75013	4454	40481087	2009-08-25	2009-08-25 00:00:00	2009-09-15	2009-09-15 00:00:00	32020		\N	296391	0	444814009	40481087		0
75138	4462	4112343	1988-08-22	1988-08-22 00:00:00	1988-09-02	1988-09-02 00:00:00	32020		\N	296934	0	195662009	4112343		0
85893	5111	260139	1948-09-10	1948-09-10 00:00:00	1948-09-17	1948-09-17 00:00:00	32020		\N	339600	0	10509002	260139		0
75395	4476	260139	1962-04-21	1962-04-21 00:00:00	1962-05-05	1962-05-05 00:00:00	32020		\N	297891	0	10509002	260139		0
75687	4490	4329847	1988-04-23	1988-04-23 00:00:00	\N	\N	32020		\N	298886	0	22298006	4329847		0
75803	4496	28060	1953-10-08	1953-10-08 00:00:00	1953-10-20	1953-10-20 00:00:00	32020		\N	299309	0	43878008	28060		0
75963	4505	40481087	1946-08-25	1946-08-25 00:00:00	1946-09-08	1946-09-08 00:00:00	32020		\N	300082	0	444814009	40481087		0
86743	5165	257012	1991-01-19	1991-01-19 00:00:00	\N	\N	32020		\N	343320	0	40055000	257012		0
86892	5172	4152936	1988-11-16	1988-11-16 00:00:00	1988-11-30	1988-11-30 00:00:00	32020		\N	343920	0	283385000	4152936		0
87120	5189	4112343	2012-11-13	2012-11-13 00:00:00	2012-11-25	2012-11-25 00:00:00	32020		\N	344918	0	195662009	4112343		0
87210	5193	40481087	2004-12-06	2004-12-06 00:00:00	2004-12-13	2004-12-13 00:00:00	32020		\N	345243	0	444814009	40481087		0
87370	5200	134438	1982-08-17	1982-08-17 00:00:00	1983-09-15	1983-09-15 00:00:00	32020		\N	345849	0	40275004	134438		0
77015	4562	260139	1978-04-09	1978-04-09 00:00:00	1978-04-16	1978-04-16 00:00:00	32020		\N	304002	0	10509002	260139		0
77136	4570	260139	1964-08-30	1964-08-30 00:00:00	1964-09-13	1964-09-13 00:00:00	32020		\N	304482	0	10509002	260139		0
87922	5230	4112343	1989-02-09	1989-02-09 00:00:00	1989-02-22	1989-02-22 00:00:00	32020		\N	347989	0	195662009	4112343		0
88050	5236	40481087	2015-09-12	2015-09-12 00:00:00	2015-10-03	2015-10-03 00:00:00	32020		\N	348437	0	444814009	40481087		0
88242	5249	4059173	1951-08-21	1951-08-21 00:00:00	1951-11-19	1951-11-19 00:00:00	32020		\N	349244	0	16114001	4059173		0
88339	5253	40481087	1956-10-13	1956-10-13 00:00:00	1956-10-20	1956-10-20 00:00:00	32020		\N	349521	0	444814009	40481087		0
88664	5272	260139	1969-04-10	1969-04-10 00:00:00	1969-04-17	1969-04-17 00:00:00	32020		\N	350655	0	10509002	260139		0
78321	4637	4299128	2008-04-30	2008-04-30 00:00:00	2008-05-14	2008-05-14 00:00:00	32020		\N	309049	0	403192003	4299128		0
78495	4646	40481087	1987-10-03	1987-10-03 00:00:00	1987-10-24	1987-10-24 00:00:00	32020		\N	309857	0	444814009	40481087		0
89178	5306	28060	1983-12-03	1983-12-03 00:00:00	1983-12-14	1983-12-14 00:00:00	32020		\N	352923	0	43878008	28060		0
78848	4670	260139	1967-02-23	1967-02-23 00:00:00	1967-03-02	1967-03-02 00:00:00	32020		\N	311227	0	10509002	260139		0
89598	5328	4116491	1969-10-15	1969-10-15 00:00:00	1969-12-01	1969-12-01 00:00:00	32020		\N	354620	0	301011002	4116491		0
89709	5333	372328	1950-12-25	1950-12-25 00:00:00	1951-06-10	1951-06-10 00:00:00	32020		\N	355151	0	65363002	372328		0
79591	4715	4310024	1993-02-23	1993-02-23 00:00:00	\N	\N	32020		\N	313974	0	424802006	4310024		0
80123	4749	40481087	2005-11-28	2005-11-28 00:00:00	2005-12-12	2005-12-12 00:00:00	32020		\N	316271	0	444814009	40481087		0
80232	4755	40481087	2004-05-27	2004-05-27 00:00:00	2004-06-17	2004-06-17 00:00:00	32020		\N	316715	0	444814009	40481087		0
81752	4848	40481087	1989-06-03	1989-06-03 00:00:00	1989-06-10	1989-06-10 00:00:00	32020		\N	322497	0	444814009	40481087		0
82137	4872	4112343	2015-11-12	2015-11-12 00:00:00	2015-11-25	2015-11-25 00:00:00	32020		\N	324034	0	195662009	4112343		0
82809	4917	4134304	1993-08-23	1993-08-23 00:00:00	1993-11-21	1993-11-21 00:00:00	32020		\N	326747	0	263102004	4134304		0
82997	4929	4283893	1979-03-24	1979-03-24 00:00:00	1979-05-12	1979-05-12 00:00:00	32020		\N	327696	0	36971009	4283893		0
84235	5002	4134304	1996-03-30	1996-03-30 00:00:00	1996-06-28	1996-06-28 00:00:00	32020		\N	332714	0	263102004	4134304		0
85158	5065	4329847	2005-03-15	2005-03-15 00:00:00	\N	\N	32020		\N	336708	0	22298006	4329847		0
85321	5076	4112343	2003-10-19	2003-10-19 00:00:00	2003-10-31	2003-10-31 00:00:00	32020		\N	337400	0	195662009	4112343		0
85368	5078	40481087	1938-06-10	1938-06-10 00:00:00	1938-07-01	1938-07-01 00:00:00	32020		\N	337567	0	444814009	40481087		0
75014	4454	40481087	1922-01-24	1922-01-24 00:00:00	1922-02-14	1922-02-14 00:00:00	32020		\N	296461	0	444814009	40481087		0
75139	4462	4285898	1989-11-16	1989-11-16 00:00:00	\N	\N	32020		\N	296934	0	68496003	4285898		0
85894	5111	40481087	1956-07-07	1956-07-07 00:00:00	1956-07-28	1956-07-28 00:00:00	32020		\N	339601	0	444814009	40481087		0
75396	4476	40481087	2018-06-29	2018-06-29 00:00:00	2018-07-13	2018-07-13 00:00:00	32020		\N	297827	0	444814009	40481087		0
75689	4490	4155034	1956-02-09	1956-02-09 00:00:00	1956-03-01	1956-03-01 00:00:00	32020		\N	298885	0	283371005	4155034		0
75804	4496	257012	1992-05-11	1992-05-11 00:00:00	\N	\N	32020		\N	299256	0	40055000	257012		0
75964	4505	40481087	1947-07-14	1947-07-14 00:00:00	1947-07-21	1947-07-21 00:00:00	32020		\N	299963	0	444814009	40481087		0
86744	5165	28060	1969-05-31	1969-05-31 00:00:00	1969-06-09	1969-06-09 00:00:00	32020		\N	343277	0	43878008	28060		0
86893	5172	78272	2006-04-30	2006-04-30 00:00:00	2006-05-21	2006-05-21 00:00:00	32020		\N	343921	0	70704007	78272		0
87121	5189	40481087	1987-04-07	1987-04-07 00:00:00	1987-04-28	1987-04-28 00:00:00	32020		\N	344904	0	444814009	40481087		0
87211	5193	4112343	2009-03-01	2009-03-01 00:00:00	2009-03-09	2009-03-09 00:00:00	32020		\N	345180	0	195662009	4112343		0
87371	5200	4112343	1978-12-28	1978-12-28 00:00:00	1979-01-09	1979-01-09 00:00:00	32020		\N	345933	0	195662009	4112343		0
77016	4562	4112343	2018-05-11	2018-05-11 00:00:00	2018-05-22	2018-05-22 00:00:00	32020		\N	304045	0	195662009	4112343		0
77137	4570	381316	1991-09-21	1991-09-21 00:00:00	\N	\N	32020		\N	304477	0	230690007	381316		0
87923	5230	80180	1981-02-13	1981-02-13 00:00:00	\N	\N	32020		\N	347962	0	396275006	80180		0
88051	5236	4155034	1982-10-08	1982-10-08 00:00:00	1982-10-29	1982-10-29 00:00:00	32020		\N	348425	0	283371005	4155034		0
88243	5249	4112343	1988-03-02	1988-03-02 00:00:00	1988-03-15	1988-03-15 00:00:00	32020		\N	349234	0	195662009	4112343		0
88340	5253	40481087	1972-12-06	1972-12-06 00:00:00	1972-12-20	1972-12-20 00:00:00	32020		\N	349488	0	444814009	40481087		0
88665	5272	40481087	1982-04-04	1982-04-04 00:00:00	1982-04-11	1982-04-11 00:00:00	32020		\N	350714	0	444814009	40481087		0
78322	4637	4112343	1988-04-22	1988-04-22 00:00:00	1988-04-29	1988-04-29 00:00:00	32020		\N	309034	0	195662009	4112343		0
78496	4646	80180	1986-12-15	1986-12-15 00:00:00	\N	\N	32020		\N	309726	0	396275006	80180		0
78849	4670	4113008	2018-07-10	2018-07-10 00:00:00	2018-07-31	2018-07-31 00:00:00	32020		\N	311159	0	284549007	4113008		0
89599	5328	260139	1939-02-03	1939-02-03 00:00:00	1939-02-17	1939-02-17 00:00:00	32020		\N	354706	0	10509002	260139		0
89710	5333	40481087	2001-10-02	2001-10-02 00:00:00	2001-10-16	2001-10-16 00:00:00	32020		\N	355135	0	444814009	40481087		0
79592	4715	40481087	1999-03-27	1999-03-27 00:00:00	1999-04-03	1999-04-03 00:00:00	32020		\N	313959	0	444814009	40481087		0
80124	4749	40479768	2014-02-18	2014-02-18 00:00:00	2014-03-27	2014-03-27 00:00:00	32020		\N	316225	0	444470001	40479768		0
80233	4755	4112343	2017-03-14	2017-03-14 00:00:00	2017-03-21	2017-03-21 00:00:00	32020		\N	316743	0	195662009	4112343		0
81753	4848	4112343	1997-11-22	1997-11-22 00:00:00	1997-12-01	1997-12-01 00:00:00	32020		\N	322500	0	195662009	4112343		0
82138	4872	4218389	2008-07-06	2008-07-06 00:00:00	2008-08-10	2008-08-10 00:00:00	32020		\N	324092	0	39848009	4218389		0
82810	4917	4146173	2018-03-04	2018-03-04 00:00:00	2018-05-03	2018-05-03 00:00:00	32020		\N	326760	0	307731004	4146173		0
82998	4929	80180	2002-07-24	2002-07-24 00:00:00	\N	\N	32020		\N	327698	0	396275006	80180		0
84248	5004	317576	1995-05-02	1995-05-02 00:00:00	\N	\N	32020		\N	332881	0	53741008	317576		0
85322	5076	4027663	1967-03-01	1967-03-01 00:00:00	\N	\N	32020		\N	\N	0	13200003	4027663		0
85369	5078	28060	1962-04-14	1962-04-14 00:00:00	1962-04-21	1962-04-21 00:00:00	32020		\N	337498	0	43878008	28060		0
75015	4454	4112343	1964-05-21	1964-05-21 00:00:00	1964-05-29	1964-05-29 00:00:00	32020		\N	296387	0	195662009	4112343		0
75140	4462	4112343	2005-11-26	2005-11-26 00:00:00	2005-12-07	2005-12-07 00:00:00	32020		\N	296943	0	195662009	4112343		0
85895	5111	317576	1967-07-24	1967-07-24 00:00:00	\N	\N	32020		\N	339598	0	53741008	317576		0
75397	4476	4112343	1984-02-26	1984-02-26 00:00:00	1984-03-05	1984-03-05 00:00:00	32020		\N	297805	0	195662009	4112343		0
75690	4490	4112343	1987-04-06	1987-04-06 00:00:00	1987-04-14	1987-04-14 00:00:00	32020		\N	298911	0	195662009	4112343		0
75805	4496	260139	1972-03-02	1972-03-02 00:00:00	1972-03-09	1972-03-09 00:00:00	32020		\N	299270	0	10509002	260139		0
75965	4505	4112343	1951-11-04	1951-11-04 00:00:00	1951-11-15	1951-11-15 00:00:00	32020		\N	299964	0	195662009	4112343		0
86745	5165	4116491	1989-12-06	1989-12-06 00:00:00	1990-01-07	1990-01-07 00:00:00	32020		\N	343269	0	301011002	4116491		0
86894	5172	260139	2013-09-20	2013-09-20 00:00:00	2013-09-27	2013-09-27 00:00:00	32020		\N	343865	0	10509002	260139		0
87122	5189	28060	1966-07-06	1966-07-06 00:00:00	1966-07-19	1966-07-19 00:00:00	32020		\N	344902	0	43878008	28060		0
87212	5193	381316	2010-06-10	2010-06-10 00:00:00	\N	\N	32020		\N	345180	0	230690007	381316		0
87372	5200	257012	1991-06-17	1991-06-17 00:00:00	\N	\N	32020		\N	345908	0	40055000	257012		0
77017	4562	81151	1985-12-23	1985-12-23 00:00:00	1986-01-20	1986-01-20 00:00:00	32020		\N	303956	0	44465007	81151		0
77138	4570	260139	1991-12-21	1991-12-21 00:00:00	1991-12-28	1991-12-28 00:00:00	32020		\N	304427	0	10509002	260139		0
87924	5230	4112343	1991-07-10	1991-07-10 00:00:00	1991-07-17	1991-07-17 00:00:00	32020		\N	347960	0	195662009	4112343		0
88052	5236	80180	2009-05-19	2009-05-19 00:00:00	\N	\N	32020		\N	348401	0	396275006	80180		0
88244	5249	80180	1988-05-13	1988-05-13 00:00:00	\N	\N	32020		\N	349234	0	396275006	80180		0
88341	5253	40481087	2001-03-20	2001-03-20 00:00:00	2001-04-10	2001-04-10 00:00:00	32020		\N	349526	0	444814009	40481087		0
88666	5272	80180	1952-05-31	1952-05-31 00:00:00	\N	\N	32020		\N	350696	0	396275006	80180		0
78323	4637	40481087	1998-01-31	1998-01-31 00:00:00	1998-02-21	1998-02-21 00:00:00	32020		\N	309036	0	444814009	40481087		0
78497	4646	4283893	1986-11-20	1986-11-20 00:00:00	1987-01-29	1987-01-29 00:00:00	32020		\N	309726	0	36971009	4283893		0
89180	5306	4296205	2013-01-22	2013-01-22 00:00:00	2013-02-19	2013-02-19 00:00:00	32020		\N	352985	0	403191005	4296205		0
78850	4670	40481087	1959-11-06	1959-11-06 00:00:00	1959-11-27	1959-11-27 00:00:00	32020		\N	311201	0	444814009	40481087		0
89600	5328	40481087	1941-12-23	1941-12-23 00:00:00	1941-12-30	1941-12-30 00:00:00	32020		\N	354623	0	444814009	40481087		0
89711	5333	81151	1990-03-30	1990-03-30 00:00:00	1990-05-04	1990-05-04 00:00:00	32020		\N	355122	0	44465007	81151		0
79593	4715	40481087	1970-05-01	1970-05-01 00:00:00	1970-05-22	1970-05-22 00:00:00	32020		\N	313926	0	444814009	40481087		0
80125	4749	4112343	2015-08-05	2015-08-05 00:00:00	2015-08-17	2015-08-17 00:00:00	32020		\N	316272	0	195662009	4112343		0
80234	4755	4112343	2018-08-14	2018-08-14 00:00:00	2018-08-26	2018-08-26 00:00:00	32020		\N	316671	0	195662009	4112343		0
81754	4848	40481087	2017-06-13	2017-06-13 00:00:00	2017-06-20	2017-06-20 00:00:00	32020		\N	322511	0	444814009	40481087		0
82139	4872	81151	1960-09-20	1960-09-20 00:00:00	1960-10-11	1960-10-11 00:00:00	32020		\N	323952	0	44465007	81151		0
82811	4917	4112343	1991-01-22	1991-01-22 00:00:00	1991-01-30	1991-01-30 00:00:00	32020		\N	326757	0	195662009	4112343		0
82999	4929	40481087	2002-01-16	2002-01-16 00:00:00	2002-01-30	2002-01-30 00:00:00	32020		\N	327698	0	444814009	40481087		0
84249	5004	192671	2012-09-13	2012-09-13 00:00:00	\N	\N	32020		\N	332854	0	K92.2	35208414		0
85323	5076	78272	1946-09-22	1946-09-22 00:00:00	1946-10-27	1946-10-27 00:00:00	32020		\N	337326	0	70704007	78272		0
85370	5078	4113008	1942-02-17	1942-02-17 00:00:00	1942-03-10	1942-03-10 00:00:00	32020		\N	337522	0	284549007	4113008		0
75016	4454	40481087	1991-01-14	1991-01-14 00:00:00	1991-02-04	1991-02-04 00:00:00	32020		\N	296403	0	444814009	40481087		0
75141	4462	4112343	2014-03-29	2014-03-29 00:00:00	2014-04-06	2014-04-06 00:00:00	32020		\N	296935	0	195662009	4112343		0
85896	5111	40481087	1980-05-21	1980-05-21 00:00:00	1980-06-04	1980-06-04 00:00:00	32020		\N	339620	0	444814009	40481087		0
75398	4476	40481087	1981-12-29	1981-12-29 00:00:00	1982-01-05	1982-01-05 00:00:00	32020		\N	297900	0	444814009	40481087		0
75691	4490	317576	1984-02-18	1984-02-18 00:00:00	\N	\N	32020		\N	298872	0	53741008	317576		0
75806	4496	372328	1949-01-01	1949-01-01 00:00:00	1949-02-17	1949-02-17 00:00:00	32020		\N	299258	0	65363002	372328		0
75966	4505	4112343	2009-10-22	2009-10-22 00:00:00	2009-10-31	2009-10-31 00:00:00	32020		\N	299999	0	195662009	4112343		0
86746	5165	4218389	2011-09-16	2011-09-16 00:00:00	2011-10-21	2011-10-21 00:00:00	32020		\N	343398	0	39848009	4218389		0
86895	5172	40481087	1963-10-11	1963-10-11 00:00:00	1963-10-18	1963-10-18 00:00:00	32020		\N	343874	0	444814009	40481087		0
87123	5189	4112343	1982-01-13	1982-01-13 00:00:00	1982-01-21	1982-01-21 00:00:00	32020		\N	344933	0	195662009	4112343		0
87213	5193	372328	1964-06-05	1964-06-05 00:00:00	1964-07-30	1964-07-30 00:00:00	32020		\N	345240	0	65363002	372328		0
87373	5200	372328	1960-06-21	1960-06-21 00:00:00	1960-07-27	1960-07-27 00:00:00	32020		\N	345814	0	65363002	372328		0
77018	4562	4283893	2000-06-22	2000-06-22 00:00:00	2000-08-03	2000-08-03 00:00:00	32020		\N	304006	0	36971009	4283893		0
77139	4570	372328	1957-12-05	1957-12-05 00:00:00	1959-02-21	1959-02-21 00:00:00	32020		\N	304434	0	65363002	372328		0
87925	5230	28060	1994-01-05	1994-01-05 00:00:00	1994-01-16	1994-01-16 00:00:00	32020		\N	347982	0	43878008	28060		0
88053	5236	260139	2017-10-12	2017-10-12 00:00:00	2017-10-19	2017-10-19 00:00:00	32020		\N	348423	0	10509002	260139		0
88245	5249	257012	2015-05-15	2015-05-15 00:00:00	\N	\N	32020		\N	349238	0	40055000	257012		0
88342	5253	260139	1991-03-13	1991-03-13 00:00:00	1991-03-20	1991-03-20 00:00:00	32020		\N	349523	0	10509002	260139		0
88667	5272	40481087	1967-01-31	1967-01-31 00:00:00	1967-02-14	1967-02-14 00:00:00	32020		\N	350654	0	444814009	40481087		0
78324	4637	4218389	1980-12-20	1980-12-20 00:00:00	1981-01-24	1981-01-24 00:00:00	32020		\N	309044	0	39848009	4218389		0
78498	4646	440448	1964-07-29	1964-07-29 00:00:00	\N	\N	32020		\N	309738	0	74400008	440448		0
89181	5306	40481087	2006-05-04	2006-05-04 00:00:00	2006-05-11	2006-05-11 00:00:00	32020		\N	352926	0	444814009	40481087		0
89313	5314	260139	1959-05-12	1959-05-12 00:00:00	1959-05-19	1959-05-19 00:00:00	32020		\N	353393	0	10509002	260139		0
89601	5328	257012	2019-05-09	2019-05-09 00:00:00	\N	\N	32020		\N	354608	0	40055000	257012		0
89712	5333	4059173	1962-12-22	1962-12-22 00:00:00	1963-02-20	1963-02-20 00:00:00	32020		\N	355121	0	16114001	4059173		0
79594	4715	4112343	2014-08-30	2014-08-30 00:00:00	2014-09-07	2014-09-07 00:00:00	32020		\N	313899	0	195662009	4112343		0
80126	4749	80180	2011-05-25	2011-05-25 00:00:00	\N	\N	32020		\N	316279	0	396275006	80180		0
80235	4755	4112343	1947-04-06	1947-04-06 00:00:00	1947-04-19	1947-04-19 00:00:00	32020		\N	316682	0	195662009	4112343		0
81786	4852	4299128	1969-05-15	1969-05-15 00:00:00	1969-06-12	1969-06-12 00:00:00	32020		\N	322780	0	403192003	4299128		0
82140	4872	40481087	2009-04-26	2009-04-26 00:00:00	2009-05-10	2009-05-10 00:00:00	32020		\N	324033	0	444814009	40481087		0
82812	4917	4112343	2002-02-15	2002-02-15 00:00:00	2002-02-25	2002-02-25 00:00:00	32020		\N	326759	0	195662009	4112343		0
83000	4929	4059173	1969-12-18	1969-12-18 00:00:00	1970-03-18	1970-03-18 00:00:00	32020		\N	327670	0	16114001	4059173		0
84250	5004	40481087	2014-04-16	2014-04-16 00:00:00	2014-05-07	2014-05-07 00:00:00	32020		\N	332889	0	444814009	40481087		0
85324	5076	372328	1952-08-02	1952-08-02 00:00:00	1952-09-16	1952-09-16 00:00:00	32020		\N	337342	0	65363002	372328		0
85371	5078	317576	1980-07-07	1980-07-07 00:00:00	\N	\N	32020		\N	337584	0	53741008	317576		0
75017	4454	4059173	1927-01-23	1927-01-23 00:00:00	1927-04-23	1927-04-23 00:00:00	32020		\N	296491	0	16114001	4059173		0
75142	4462	4266809	1990-09-12	1990-09-12 00:00:00	\N	\N	32020		\N	\N	0	397881000	4266809		0
85897	5111	260139	1960-06-17	1960-06-17 00:00:00	1960-07-01	1960-07-01 00:00:00	32020		\N	339619	0	10509002	260139		0
75399	4476	4116491	1992-03-16	1992-03-16 00:00:00	1992-04-18	1992-04-18 00:00:00	32020		\N	297769	0	301011002	4116491		0
75692	4490	4278672	1936-01-25	1936-01-25 00:00:00	1936-02-24	1936-02-24 00:00:00	32020		\N	298884	0	65966004	4278672		0
75807	4497	4296204	1973-05-29	1973-05-29 00:00:00	1973-06-26	1973-06-26 00:00:00	32020		\N	299366	0	403190006	4296204		0
75967	4505	40481087	1957-03-30	1957-03-30 00:00:00	1957-04-13	1957-04-13 00:00:00	32020		\N	299965	0	444814009	40481087		0
86747	5165	80180	2008-02-20	2008-02-20 00:00:00	\N	\N	32020		\N	343395	0	396275006	80180		0
86896	5172	40481087	1969-04-07	1969-04-07 00:00:00	1969-04-14	1969-04-14 00:00:00	32020		\N	343875	0	444814009	40481087		0
87124	5189	381316	2007-09-09	2007-09-09 00:00:00	\N	\N	32020		\N	344938	0	230690007	381316		0
87214	5193	80180	2001-08-05	2001-08-05 00:00:00	\N	\N	32020		\N	345227	0	396275006	80180		0
87374	5200	260139	1966-02-08	1966-02-08 00:00:00	1966-02-15	1966-02-15 00:00:00	32020		\N	345848	0	10509002	260139		0
77019	4562	81151	1971-10-17	1971-10-17 00:00:00	1971-11-07	1971-11-07 00:00:00	32020		\N	303953	0	44465007	81151		0
77140	4570	257012	1985-12-10	1985-12-10 00:00:00	\N	\N	32020		\N	304484	0	40055000	257012		0
87926	5230	4109685	2013-04-06	2013-04-06 00:00:00	2013-04-20	2013-04-20 00:00:00	32020		\N	347943	0	284551006	4109685		0
88054	5236	40481087	1987-04-21	1987-04-21 00:00:00	1987-05-05	1987-05-05 00:00:00	32020		\N	348404	0	444814009	40481087		0
88246	5249	4112343	1985-05-20	1985-05-20 00:00:00	1985-06-02	1985-06-02 00:00:00	32020		\N	349172	0	195662009	4112343		0
88343	5253	78272	1997-07-02	1997-07-02 00:00:00	1997-07-30	1997-07-30 00:00:00	32020		\N	349573	0	70704007	78272		0
88668	5272	260139	2001-03-22	2001-03-22 00:00:00	2001-04-05	2001-04-05 00:00:00	32020		\N	350612	0	10509002	260139		0
78325	4637	260139	1988-05-09	1988-05-09 00:00:00	1988-05-16	1988-05-16 00:00:00	32020		\N	309013	0	10509002	260139		0
88990	5295	4134304	1977-12-13	1977-12-13 00:00:00	1978-02-11	1978-02-11 00:00:00	32020		\N	352212	0	263102004	4134304		0
89182	5306	4112343	1992-10-29	1992-10-29 00:00:00	1992-11-06	1992-11-06 00:00:00	32020		\N	352924	0	195662009	4112343		0
89314	5314	260139	1976-10-04	1976-10-04 00:00:00	1976-10-18	1976-10-18 00:00:00	32020		\N	353408	0	10509002	260139		0
89602	5328	260139	1969-05-03	1969-05-03 00:00:00	1969-05-10	1969-05-10 00:00:00	32020		\N	354709	0	10509002	260139		0
89713	5333	260139	1993-12-20	1993-12-20 00:00:00	1994-01-03	1994-01-03 00:00:00	32020		\N	355094	0	10509002	260139		0
79595	4715	372328	1955-11-10	1955-11-10 00:00:00	1956-07-25	1956-07-25 00:00:00	32020		\N	313960	0	65363002	372328		0
80127	4749	28060	2008-11-25	2008-11-25 00:00:00	2008-12-05	2008-12-05 00:00:00	32020		\N	316240	0	43878008	28060		0
80236	4755	40481087	1989-05-12	1989-05-12 00:00:00	1989-05-26	1989-05-26 00:00:00	32020		\N	316742	0	444814009	40481087		0
81787	4852	372328	1952-01-07	1952-01-07 00:00:00	1952-10-30	1952-10-30 00:00:00	32020		\N	322793	0	65363002	372328		0
82141	4872	40481087	1927-12-10	1927-12-10 00:00:00	1927-12-24	1927-12-24 00:00:00	32020		\N	323971	0	444814009	40481087		0
82813	4917	4113008	1994-12-16	1994-12-16 00:00:00	1994-12-30	1994-12-30 00:00:00	32020		\N	326748	0	284549007	4113008		0
84251	5004	378001	2008-10-21	2008-10-21 00:00:00	2008-12-20	2008-12-20 00:00:00	32020		\N	332906	0	62106007	378001		0
85372	5078	4112343	1971-07-07	1971-07-07 00:00:00	1971-07-19	1971-07-19 00:00:00	32020		\N	337596	0	195662009	4112343		0
75018	4454	80180	1963-06-08	1963-06-08 00:00:00	\N	\N	32020		\N	296474	0	396275006	80180		0
75143	4462	80180	1990-09-12	1990-09-12 00:00:00	\N	\N	32020		\N	\N	0	396275006	80180		0
85898	5111	28060	1949-04-09	1949-04-09 00:00:00	1949-04-17	1949-04-17 00:00:00	32020		\N	339618	0	43878008	28060		0
75400	4476	4084167	1972-12-22	1972-12-22 00:00:00	1972-12-22	1972-12-22 00:00:00	32020		\N	297896	0	241929008	4084167		0
75693	4490	81151	1925-12-22	1925-12-22 00:00:00	1926-01-05	1926-01-05 00:00:00	32020		\N	298880	0	44465007	81151		0
75808	4497	4112343	2011-09-13	2011-09-13 00:00:00	2011-09-25	2011-09-25 00:00:00	32020		\N	299420	0	195662009	4112343		0
75968	4505	40481087	1959-12-05	1959-12-05 00:00:00	1959-12-12	1959-12-12 00:00:00	32020		\N	299976	0	444814009	40481087		0
86748	5165	40481087	2012-08-13	2012-08-13 00:00:00	2012-08-20	2012-08-20 00:00:00	32020		\N	343349	0	444814009	40481087		0
86897	5172	40481087	2005-10-24	2005-10-24 00:00:00	2005-11-07	2005-11-07 00:00:00	32020		\N	343864	0	444814009	40481087		0
87125	5189	4152936	2018-07-25	2018-07-25 00:00:00	2018-08-15	2018-08-15 00:00:00	32020		\N	344900	0	283385000	4152936		0
87215	5193	28060	1965-09-29	1965-09-29 00:00:00	1965-10-09	1965-10-09 00:00:00	32020		\N	345208	0	43878008	28060		0
87375	5200	40481087	1996-08-29	1996-08-29 00:00:00	1996-09-19	1996-09-19 00:00:00	32020		\N	345831	0	444814009	40481087		0
77020	4562	260139	2016-04-28	2016-04-28 00:00:00	2016-05-12	2016-05-12 00:00:00	32020		\N	303986	0	10509002	260139		0
77141	4570	260139	1997-05-31	1997-05-31 00:00:00	1997-06-07	1997-06-07 00:00:00	32020		\N	304464	0	10509002	260139		0
87927	5230	80502	2005-11-09	2005-11-09 00:00:00	\N	\N	32020		\N	348020	0	64859006	80502		0
88055	5236	4218389	2015-01-30	2015-01-30 00:00:00	2015-03-06	2015-03-06 00:00:00	32020		\N	348428	0	39848009	4218389		0
88247	5249	260139	1963-07-10	1963-07-10 00:00:00	1963-07-17	1963-07-17 00:00:00	32020		\N	349194	0	10509002	260139		0
88344	5253	40481087	1993-09-09	1993-09-09 00:00:00	1993-09-23	1993-09-23 00:00:00	32020		\N	349543	0	444814009	40481087		0
88669	5272	40481087	1950-10-09	1950-10-09 00:00:00	1950-10-30	1950-10-30 00:00:00	32020		\N	350711	0	444814009	40481087		0
78326	4637	80180	2013-04-01	2013-04-01 00:00:00	\N	\N	32020		\N	309061	0	396275006	80180		0
88991	5295	378419	1995-09-06	1995-09-06 00:00:00	\N	\N	32020		\N	352255	0	26929004	378419		0
89183	5306	4283893	1970-10-19	1970-10-19 00:00:00	1970-11-23	1970-11-23 00:00:00	32020		\N	352920	0	36971009	4283893		0
89315	5314	40481087	2016-01-22	2016-01-22 00:00:00	2016-02-05	2016-02-05 00:00:00	32020		\N	353412	0	444814009	40481087		0
89603	5328	40481087	1929-08-10	1929-08-10 00:00:00	1929-08-24	1929-08-24 00:00:00	32020		\N	354703	0	444814009	40481087		0
89714	5333	40481087	1984-10-23	1984-10-23 00:00:00	1984-11-06	1984-11-06 00:00:00	32020		\N	355092	0	444814009	40481087		0
79596	4715	40481087	2009-01-15	2009-01-15 00:00:00	2009-01-29	2009-01-29 00:00:00	32020		\N	313934	0	444814009	40481087		0
80128	4750	4294548	1988-03-18	1988-03-18 00:00:00	1988-04-22	1988-04-22 00:00:00	32020		\N	316356	0	75498004	4294548		0
80237	4755	40481087	2016-05-21	2016-05-21 00:00:00	2016-06-04	2016-06-04 00:00:00	32020		\N	316766	0	444814009	40481087		0
81788	4852	195588	1993-10-26	1993-10-26 00:00:00	1993-12-07	1993-12-07 00:00:00	32020		\N	322835	0	38822007	195588		0
82142	4872	4112343	1972-04-19	1972-04-19 00:00:00	1972-04-27	1972-04-27 00:00:00	32020		\N	324011	0	195662009	4112343		0
84252	5004	40481087	1999-09-16	1999-09-16 00:00:00	1999-09-23	1999-09-23 00:00:00	32020		\N	332817	0	444814009	40481087		0
85373	5078	378419	1993-06-07	1993-06-07 00:00:00	\N	\N	32020		\N	337588	0	26929004	378419		0
75019	4454	260139	1955-11-08	1955-11-08 00:00:00	1955-11-22	1955-11-22 00:00:00	32020		\N	296466	0	10509002	260139		0
75144	4462	81151	2006-12-23	2006-12-23 00:00:00	2007-01-20	2007-01-20 00:00:00	32020		\N	296901	0	44465007	81151		0
85900	5111	4329847	1984-12-03	1984-12-03 00:00:00	\N	\N	32020		\N	339626	0	22298006	4329847		0
75401	4476	4296204	1990-04-06	1990-04-06 00:00:00	1990-04-27	1990-04-27 00:00:00	32020		\N	297898	0	403190006	4296204		0
75694	4490	4237458	1932-12-11	1932-12-11 00:00:00	1933-03-11	1933-03-11 00:00:00	32020		\N	298883	0	58150001	4237458		0
75809	4497	4112343	2003-10-12	2003-10-12 00:00:00	2003-10-23	2003-10-23 00:00:00	32020		\N	299382	0	195662009	4112343		0
75969	4505	4112343	2015-11-02	2015-11-02 00:00:00	2015-11-09	2015-11-09 00:00:00	32020		\N	300071	0	195662009	4112343		0
86749	5165	81151	2008-03-21	2008-03-21 00:00:00	2008-04-04	2008-04-04 00:00:00	32020		\N	343397	0	44465007	81151		0
86898	5172	4155034	1952-10-23	1952-10-23 00:00:00	1952-11-13	1952-11-13 00:00:00	32020		\N	343917	0	283371005	4155034		0
87126	5189	40481087	1957-01-16	1957-01-16 00:00:00	1957-02-06	1957-02-06 00:00:00	32020		\N	344915	0	444814009	40481087		0
87216	5193	4134304	1965-07-30	1965-07-30 00:00:00	1965-09-28	1965-09-28 00:00:00	32020		\N	345176	0	263102004	4134304		0
87376	5200	80180	1989-01-25	1989-01-25 00:00:00	\N	\N	32020		\N	345924	0	396275006	80180		0
77021	4562	260139	1982-08-26	1982-08-26 00:00:00	1982-09-09	1982-09-09 00:00:00	32020		\N	304058	0	10509002	260139		0
77142	4570	40481087	1939-10-17	1939-10-17 00:00:00	1939-11-07	1939-11-07 00:00:00	32020		\N	304453	0	444814009	40481087		0
87928	5230	40481087	2004-10-29	2004-10-29 00:00:00	2004-11-05	2004-11-05 00:00:00	32020		\N	347956	0	444814009	40481087		0
88056	5236	260139	2008-08-18	2008-08-18 00:00:00	2008-09-01	2008-09-01 00:00:00	32020		\N	348422	0	10509002	260139		0
88248	5249	40481087	1959-06-02	1959-06-02 00:00:00	1959-06-09	1959-06-09 00:00:00	32020		\N	349156	0	444814009	40481087		0
88345	5253	4285898	1995-02-18	1995-02-18 00:00:00	\N	\N	32020		\N	349485	0	68496003	4285898		0
88670	5272	4112343	2014-01-27	2014-01-27 00:00:00	2014-02-03	2014-02-03 00:00:00	32020		\N	350633	0	195662009	4112343		0
78327	4637	40481087	1995-04-27	1995-04-27 00:00:00	1995-05-11	1995-05-11 00:00:00	32020		\N	309067	0	444814009	40481087		0
88992	5295	260139	1961-09-22	1961-09-22 00:00:00	1961-09-29	1961-09-29 00:00:00	32020		\N	352282	0	10509002	260139		0
89184	5306	439777	1989-01-14	1989-01-14 00:00:00	\N	\N	32020		\N	352949	0	271737000	439777		0
89316	5314	30753	1991-11-09	1991-11-09 00:00:00	\N	\N	32020		\N	353442	0	16761005	30753		0
89604	5328	4112343	1981-05-26	1981-05-26 00:00:00	1981-06-02	1981-06-02 00:00:00	32020		\N	354621	0	195662009	4112343		0
89715	5333	80180	1986-08-13	1986-08-13 00:00:00	\N	\N	32020		\N	355092	0	396275006	80180		0
79597	4715	260139	1985-01-07	1985-01-07 00:00:00	1985-01-14	1985-01-14 00:00:00	32020		\N	313928	0	10509002	260139		0
80129	4750	40481087	1991-10-11	1991-10-11 00:00:00	1991-11-01	1991-11-01 00:00:00	32020		\N	316295	0	444814009	40481087		0
80238	4755	4156265	1933-01-24	1933-01-24 00:00:00	1933-02-14	1933-02-14 00:00:00	32020		\N	316707	0	370247008	4156265		0
81789	4852	260139	1967-10-29	1967-10-29 00:00:00	1967-11-11	1967-11-11 00:00:00	32020		\N	322849	0	10509002	260139		0
82143	4872	4112343	1933-11-07	1933-11-07 00:00:00	1933-11-15	1933-11-15 00:00:00	32020		\N	323973	0	195662009	4112343		0
84253	5004	80180	2012-08-21	2012-08-21 00:00:00	\N	\N	32020		\N	332812	0	396275006	80180		0
85374	5078	40481087	1982-06-14	1982-06-14 00:00:00	1982-06-28	1982-06-28 00:00:00	32020		\N	337544	0	444814009	40481087		0
75020	4454	4109685	1945-04-30	1945-04-30 00:00:00	1945-05-14	1945-05-14 00:00:00	32020		\N	296495	0	284551006	4109685		0
75161	4465	40481087	1978-06-08	1978-06-08 00:00:00	1978-06-15	1978-06-15 00:00:00	32020		\N	297067	0	444814009	40481087		0
85901	5111	40481087	1958-09-25	1958-09-25 00:00:00	1958-10-09	1958-10-09 00:00:00	32020		\N	339603	0	444814009	40481087		0
75402	4476	80180	2000-02-29	2000-02-29 00:00:00	\N	\N	32020		\N	297875	0	396275006	80180		0
75695	4490	40481087	1982-08-25	1982-08-25 00:00:00	1982-09-15	1982-09-15 00:00:00	32020		\N	298899	0	444814009	40481087		0
75810	4497	372328	1958-02-17	1958-02-17 00:00:00	1958-03-03	1958-03-03 00:00:00	32020		\N	299359	0	65363002	372328		0
75970	4505	40481087	1995-09-12	1995-09-12 00:00:00	1995-09-26	1995-09-26 00:00:00	32020		\N	299998	0	444814009	40481087		0
86750	5165	4112343	1964-03-14	1964-03-14 00:00:00	1964-03-26	1964-03-26 00:00:00	32020		\N	343267	0	195662009	4112343		0
86912	5174	4283893	1986-06-20	1986-06-20 00:00:00	1986-07-04	1986-07-04 00:00:00	32020		\N	344016	0	36971009	4283893		0
87127	5189	4112343	1962-08-16	1962-08-16 00:00:00	1962-08-23	1962-08-23 00:00:00	32020		\N	344901	0	195662009	4112343		0
87217	5194	4112343	1981-12-08	1981-12-08 00:00:00	1981-12-21	1981-12-21 00:00:00	32020		\N	345366	0	195662009	4112343		0
87377	5200	4112343	1978-02-19	1978-02-19 00:00:00	1978-02-27	1978-02-27 00:00:00	32020		\N	345932	0	195662009	4112343		0
77022	4562	40481087	1966-08-09	1966-08-09 00:00:00	1966-08-30	1966-08-30 00:00:00	32020		\N	303977	0	444814009	40481087		0
77143	4570	4112343	1958-12-12	1958-12-12 00:00:00	1958-12-19	1958-12-19 00:00:00	32020		\N	304510	0	195662009	4112343		0
87929	5230	40481087	1949-02-18	1949-02-18 00:00:00	1949-03-11	1949-03-11 00:00:00	32020		\N	347986	0	444814009	40481087		0
88057	5236	4112343	1985-06-06	1985-06-06 00:00:00	1985-06-15	1985-06-15 00:00:00	32020		\N	348394	0	195662009	4112343		0
88249	5249	28060	1994-03-17	1994-03-17 00:00:00	1994-03-28	1994-03-28 00:00:00	32020		\N	349159	0	43878008	28060		0
88346	5253	81151	2011-01-18	2011-01-18 00:00:00	2011-02-01	2011-02-01 00:00:00	32020		\N	349574	0	44465007	81151		0
88671	5272	4112343	1926-12-05	1926-12-05 00:00:00	1926-12-15	1926-12-15 00:00:00	32020		\N	350587	0	195662009	4112343		0
78328	4637	40481087	2000-09-15	2000-09-15 00:00:00	2000-09-22	2000-09-22 00:00:00	32020		\N	309037	0	444814009	40481087		0
88993	5295	4113008	1958-10-03	1958-10-03 00:00:00	1958-10-24	1958-10-24 00:00:00	32020		\N	352209	0	284549007	4113008		0
89185	5306	40481087	1981-01-09	1981-01-09 00:00:00	1981-01-30	1981-01-30 00:00:00	32020		\N	352919	0	444814009	40481087		0
89317	5314	4310024	1990-12-14	1990-12-14 00:00:00	\N	\N	32020		\N	353442	0	424802006	4310024		0
89605	5328	78272	1962-01-27	1962-01-27 00:00:00	1962-02-17	1962-02-17 00:00:00	32020		\N	354589	0	70704007	78272		0
89716	5333	260139	1993-08-27	1993-08-27 00:00:00	1993-09-03	1993-09-03 00:00:00	32020		\N	355148	0	10509002	260139		0
79598	4715	4112343	1962-07-09	1962-07-09 00:00:00	1962-07-16	1962-07-16 00:00:00	32020		\N	313925	0	195662009	4112343		0
80130	4750	378001	2007-10-16	2007-10-16 00:00:00	2007-12-15	2007-12-15 00:00:00	32020		\N	316316	0	62106007	378001		0
80239	4755	192671	1963-11-29	1963-11-29 00:00:00	\N	\N	32020		\N	316705	0	K92.2	35208414		0
81790	4852	372328	1951-03-11	1951-03-11 00:00:00	1951-04-12	1951-04-12 00:00:00	32020		\N	322792	0	65363002	372328		0
82144	4872	4112343	1936-07-06	1936-07-06 00:00:00	1936-07-18	1936-07-18 00:00:00	32020		\N	324038	0	195662009	4112343		0
84254	5004	260139	1984-07-30	1984-07-30 00:00:00	1984-08-13	1984-08-13 00:00:00	32020		\N	332882	0	10509002	260139		0
85375	5078	372328	1983-06-12	1983-06-12 00:00:00	1983-07-25	1983-07-25 00:00:00	32020		\N	337581	0	65363002	372328		0
75021	4454	4112343	1932-12-25	1932-12-25 00:00:00	1933-01-02	1933-01-02 00:00:00	32020		\N	296385	0	195662009	4112343		0
75162	4465	372328	1976-01-11	1976-01-11 00:00:00	1976-07-02	1976-07-02 00:00:00	32020		\N	297077	0	65363002	372328		0
85910	5113	4112343	1993-12-07	1993-12-07 00:00:00	1993-12-18	1993-12-18 00:00:00	32020		\N	339719	0	195662009	4112343		0
75403	4476	4283893	1965-09-04	1965-09-04 00:00:00	1965-09-18	1965-09-18 00:00:00	32020		\N	297815	0	36971009	4283893		0
75696	4490	80180	1963-09-04	1963-09-04 00:00:00	\N	\N	32020		\N	298867	0	396275006	80180		0
75811	4497	40481087	1989-09-06	1989-09-06 00:00:00	1989-09-27	1989-09-27 00:00:00	32020		\N	299343	0	444814009	40481087		0
75971	4505	4152936	1942-02-20	1942-02-20 00:00:00	1942-03-13	1942-03-13 00:00:00	32020		\N	300078	0	283385000	4152936		0
86751	5165	260139	1993-04-29	1993-04-29 00:00:00	1993-05-06	1993-05-06 00:00:00	32020		\N	343347	0	10509002	260139		0
86913	5174	260139	2010-08-20	2010-08-20 00:00:00	2010-09-03	2010-09-03 00:00:00	32020		\N	344018	0	10509002	260139		0
87128	5189	260139	1970-04-05	1970-04-05 00:00:00	1970-04-19	1970-04-19 00:00:00	32020		\N	344903	0	10509002	260139		0
87218	5194	192671	1982-09-26	1982-09-26 00:00:00	\N	\N	32020		\N	345407	0	K92.2	35208414		0
87378	5200	4283893	1991-04-15	1991-04-15 00:00:00	1991-07-22	1991-07-22 00:00:00	32020		\N	345876	0	36971009	4283893		0
77023	4562	40481087	2005-03-18	2005-03-18 00:00:00	2005-04-01	2005-04-01 00:00:00	32020		\N	303992	0	444814009	40481087		0
77144	4570	4112343	1994-05-11	1994-05-11 00:00:00	1994-05-24	1994-05-24 00:00:00	32020		\N	304456	0	195662009	4112343		0
87930	5230	40481087	1947-10-29	1947-10-29 00:00:00	1947-11-19	1947-11-19 00:00:00	32020		\N	347980	0	444814009	40481087		0
88058	5236	40481087	2018-08-27	2018-08-27 00:00:00	2018-09-10	2018-09-10 00:00:00	32020		\N	348438	0	444814009	40481087		0
88250	5249	4283893	1984-12-21	1984-12-21 00:00:00	1985-01-04	1985-01-04 00:00:00	32020		\N	349185	0	36971009	4283893		0
88347	5253	80180	1996-01-14	1996-01-14 00:00:00	\N	\N	32020		\N	349508	0	396275006	80180		0
88685	5274	260139	1999-12-18	1999-12-18 00:00:00	2000-01-01	2000-01-01 00:00:00	32020		\N	350837	0	10509002	260139		0
78329	4637	260139	2009-05-28	2009-05-28 00:00:00	2009-06-04	2009-06-04 00:00:00	32020		\N	309018	0	10509002	260139		0
88994	5295	40481087	1952-09-01	1952-09-01 00:00:00	1952-09-15	1952-09-15 00:00:00	32020		\N	352301	0	444814009	40481087		0
89186	5306	372328	1969-03-20	1969-03-20 00:00:00	1969-04-27	1969-04-27 00:00:00	32020		\N	352951	0	65363002	372328		0
89318	5314	4112343	1986-02-15	1986-02-15 00:00:00	1986-02-22	1986-02-22 00:00:00	32020		\N	353389	0	195662009	4112343		0
89606	5328	28060	2019-06-17	2019-06-17 00:00:00	\N	\N	32020		\N	354612	0	43878008	28060		0
89717	5333	4112343	1965-11-23	1965-11-23 00:00:00	1965-12-02	1965-12-02 00:00:00	32020		\N	355147	0	195662009	4112343		0
79644	4719	40481087	1950-01-31	1950-01-31 00:00:00	1950-02-07	1950-02-07 00:00:00	32020		\N	314187	0	444814009	40481087		0
80131	4750	4112343	1980-04-10	1980-04-10 00:00:00	1980-04-17	1980-04-17 00:00:00	32020		\N	316335	0	195662009	4112343		0
80240	4755	40481087	1967-04-14	1967-04-14 00:00:00	1967-04-28	1967-04-28 00:00:00	32020		\N	316756	0	444814009	40481087		0
81791	4852	28060	1970-05-08	1970-05-08 00:00:00	1970-05-17	1970-05-17 00:00:00	32020		\N	322850	0	43878008	28060		0
82145	4872	257012	2007-04-06	2007-04-06 00:00:00	\N	\N	32020		\N	323996	0	40055000	257012		0
84255	5004	378001	1991-04-24	1991-04-24 00:00:00	1991-06-23	1991-06-23 00:00:00	32020		\N	332855	0	62106007	378001		0
85376	5078	40481087	1925-05-17	1925-05-17 00:00:00	1925-05-24	1925-05-24 00:00:00	32020		\N	337633	0	444814009	40481087		0
75022	4454	4112343	2005-12-09	2005-12-09 00:00:00	2005-12-18	2005-12-18 00:00:00	32020		\N	296405	0	195662009	4112343		0
75163	4465	40481087	2016-09-29	2016-09-29 00:00:00	2016-10-06	2016-10-06 00:00:00	32020		\N	297058	0	444814009	40481087		0
85911	5113	40481087	1987-11-15	1987-11-15 00:00:00	1987-11-29	1987-11-29 00:00:00	32020		\N	339666	0	444814009	40481087		0
75404	4476	260139	2008-08-03	2008-08-03 00:00:00	2008-08-10	2008-08-10 00:00:00	32020		\N	297801	0	10509002	260139		0
86155	5127	4112343	2002-10-27	2002-10-27 00:00:00	2002-11-06	2002-11-06 00:00:00	32020		\N	340891	0	195662009	4112343		0
75812	4497	28060	1971-04-07	1971-04-07 00:00:00	1971-04-15	1971-04-15 00:00:00	32020		\N	299416	0	43878008	28060		0
75972	4505	192671	1981-11-16	1981-11-16 00:00:00	\N	\N	32020		\N	300038	0	K92.2	35208414		0
86752	5165	40481087	1982-02-11	1982-02-11 00:00:00	1982-02-25	1982-02-25 00:00:00	32020		\N	343248	0	444814009	40481087		0
86914	5174	4294548	1960-08-17	1960-08-17 00:00:00	1960-09-28	1960-09-28 00:00:00	32020		\N	344037	0	75498004	4294548		0
87129	5189	40481087	1986-03-15	1986-03-15 00:00:00	1986-04-05	1986-04-05 00:00:00	32020		\N	344943	0	444814009	40481087		0
87219	5194	78272	2003-11-03	2003-11-03 00:00:00	2003-12-01	2003-12-01 00:00:00	32020		\N	345406	0	70704007	78272		0
87379	5200	260139	1961-04-18	1961-04-18 00:00:00	1961-05-02	1961-05-02 00:00:00	32020		\N	345865	0	10509002	260139		0
77024	4562	4084167	1962-06-22	1962-06-22 00:00:00	1962-06-22	1962-06-22 00:00:00	32020		\N	303950	0	241929008	4084167		0
77145	4570	28060	2002-11-09	2002-11-09 00:00:00	2002-11-22	2002-11-22 00:00:00	32020		\N	304458	0	43878008	28060		0
87937	5232	40481087	2017-09-25	2017-09-25 00:00:00	2017-10-09	2017-10-09 00:00:00	32020		\N	348101	0	444814009	40481087		0
88059	5236	440086	1984-03-06	1984-03-06 00:00:00	1985-01-15	1985-01-15 00:00:00	32020		\N	348417	0	192127007	440086		0
88251	5249	40481087	1980-02-24	1980-02-24 00:00:00	1980-03-16	1980-03-16 00:00:00	32020		\N	349171	0	444814009	40481087		0
88348	5253	4266809	1996-01-14	1996-01-14 00:00:00	\N	\N	32020		\N	349508	0	397881000	4266809		0
88686	5274	4112343	1965-07-13	1965-07-13 00:00:00	1965-07-24	1965-07-24 00:00:00	32020		\N	350799	0	195662009	4112343		0
78340	4639	4059173	1986-03-26	1986-03-26 00:00:00	1986-04-25	1986-04-25 00:00:00	32020		\N	309191	0	16114001	4059173		0
88995	5295	4156265	1933-07-25	1933-07-25 00:00:00	1933-08-15	1933-08-15 00:00:00	32020		\N	352208	0	370247008	4156265		0
89187	5306	40481087	1978-07-08	1978-07-08 00:00:00	1978-07-15	1978-07-15 00:00:00	32020		\N	352918	0	444814009	40481087		0
89319	5314	40481087	2000-11-12	2000-11-12 00:00:00	2000-11-19	2000-11-19 00:00:00	32020		\N	353411	0	444814009	40481087		0
89607	5328	372328	1913-08-21	1913-08-21 00:00:00	1914-09-09	1914-09-09 00:00:00	32020		\N	354717	0	65363002	372328		0
89718	5333	255848	2002-11-08	2002-11-08 00:00:00	\N	\N	32020		\N	355124	0	233604007	255848		0
79645	4719	260139	2009-10-22	2009-10-22 00:00:00	2009-10-29	2009-10-29 00:00:00	32020		\N	314332	0	10509002	260139		0
80132	4750	381316	2019-02-13	2019-02-13 00:00:00	\N	\N	32020		\N	316380	0	230690007	381316		0
80241	4755	4112343	1941-09-11	1941-09-11 00:00:00	1941-09-21	1941-09-21 00:00:00	32020		\N	316713	0	195662009	4112343		0
81792	4852	40481087	2018-02-28	2018-02-28 00:00:00	2018-03-15	2018-03-15 00:00:00	32020		\N	322778	0	444814009	40481087		0
82146	4872	4109685	1968-06-01	1968-06-01 00:00:00	1968-06-22	1968-06-22 00:00:00	32020		\N	324090	0	284551006	4109685		0
84256	5004	4112343	1998-02-17	1998-02-17 00:00:00	1998-02-26	1998-02-26 00:00:00	32020		\N	332888	0	195662009	4112343		0
85377	5078	4113008	1988-05-31	1988-05-31 00:00:00	1988-06-21	1988-06-21 00:00:00	32020		\N	337627	0	284549007	4113008		0
75023	4454	4218389	1938-05-16	1938-05-16 00:00:00	1938-06-06	1938-06-06 00:00:00	32020		\N	296494	0	39848009	4218389		0
75164	4465	4059173	1987-05-04	1987-05-04 00:00:00	1987-06-03	1987-06-03 00:00:00	32020		\N	297076	0	16114001	4059173		0
85912	5113	81151	1999-11-20	1999-11-20 00:00:00	1999-12-18	1999-12-18 00:00:00	32020		\N	339728	0	44465007	81151		0
75406	4476	321042	1975-05-04	1975-05-04 00:00:00	\N	\N	32020		\N	297897	0	410429000	321042		0
86156	5127	80180	2009-11-13	2009-11-13 00:00:00	\N	\N	32020		\N	340864	0	396275006	80180		0
75813	4497	372328	1958-06-01	1958-06-01 00:00:00	1958-09-02	1958-09-02 00:00:00	32020		\N	299386	0	65363002	372328		0
75973	4505	260139	1999-07-25	1999-07-25 00:00:00	1999-08-08	1999-08-08 00:00:00	32020		\N	300069	0	10509002	260139		0
86753	5165	260139	1970-09-09	1970-09-09 00:00:00	1970-09-16	1970-09-16 00:00:00	32020		\N	343255	0	10509002	260139		0
86915	5174	40481087	1989-12-21	1989-12-21 00:00:00	1990-01-11	1990-01-11 00:00:00	32020		\N	344040	0	444814009	40481087		0
87130	5190	40481087	1967-02-18	1967-02-18 00:00:00	1967-03-04	1967-03-04 00:00:00	32020		\N	345041	0	444814009	40481087		0
87220	5194	4112343	1969-12-19	1969-12-19 00:00:00	1969-12-29	1969-12-29 00:00:00	32020		\N	345309	0	195662009	4112343		0
87380	5200	78272	1972-07-02	1972-07-02 00:00:00	1972-07-30	1972-07-30 00:00:00	32020		\N	345938	0	70704007	78272		0
87486	5206	372328	1980-07-27	1980-07-27 00:00:00	1980-09-20	1980-09-20 00:00:00	32020		\N	346272	0	65363002	372328		0
77146	4570	40480160	2003-08-10	2003-08-10 00:00:00	2003-09-09	2003-09-09 00:00:00	32020		\N	304492	0	443165006	40480160		0
87938	5232	40481087	1981-12-21	1981-12-21 00:00:00	1982-01-04	1982-01-04 00:00:00	32020		\N	348063	0	444814009	40481087		0
88060	5236	372328	1976-10-09	1976-10-09 00:00:00	1977-02-23	1977-02-23 00:00:00	32020		\N	348395	0	65363002	372328		0
88252	5249	260139	1979-02-02	1979-02-02 00:00:00	1979-02-09	1979-02-09 00:00:00	32020		\N	349195	0	10509002	260139		0
88349	5253	4059173	1979-05-08	1979-05-08 00:00:00	1979-08-06	1979-08-06 00:00:00	32020		\N	349572	0	16114001	4059173		0
88687	5274	4112343	2002-03-26	2002-03-26 00:00:00	2002-04-03	2002-04-03 00:00:00	32020		\N	350762	0	195662009	4112343		0
78341	4639	28060	1971-07-18	1971-07-18 00:00:00	1971-07-25	1971-07-25 00:00:00	32020		\N	309185	0	43878008	28060		0
88996	5295	28060	1917-01-01	1917-01-01 00:00:00	1917-01-09	1917-01-09 00:00:00	32020		\N	352269	0	43878008	28060		0
89188	5306	28060	1995-04-29	1995-04-29 00:00:00	1995-05-11	1995-05-11 00:00:00	32020		\N	352925	0	43878008	28060		0
89320	5314	4112343	1958-05-19	1958-05-19 00:00:00	1958-05-26	1958-05-26 00:00:00	32020		\N	353407	0	195662009	4112343		0
89608	5328	81151	1975-03-11	1975-03-11 00:00:00	1975-04-01	1975-04-01 00:00:00	32020		\N	354590	0	44465007	81151		0
89719	5333	260139	1954-05-10	1954-05-10 00:00:00	1954-05-24	1954-05-24 00:00:00	32020		\N	355091	0	10509002	260139		0
79646	4719	4283893	1945-03-04	1945-03-04 00:00:00	1945-04-22	1945-04-22 00:00:00	32020		\N	314233	0	36971009	4283893		0
80133	4750	81893	1998-07-25	1998-07-25 00:00:00	\N	\N	32020		\N	316323	0	64766004	81893		0
80242	4755	260139	1932-12-04	1932-12-04 00:00:00	1932-12-18	1932-12-18 00:00:00	32020		\N	316681	0	10509002	260139		0
81793	4852	260139	1977-07-25	1977-07-25 00:00:00	1977-08-08	1977-08-08 00:00:00	32020		\N	322851	0	10509002	260139		0
82147	4872	4294548	2007-02-16	2007-02-16 00:00:00	2007-05-11	2007-05-11 00:00:00	32020		\N	324032	0	75498004	4294548		0
84257	5004	4278672	2015-07-17	2015-07-17 00:00:00	2015-09-15	2015-09-15 00:00:00	32020		\N	332907	0	65966004	4278672		0
85378	5078	4156265	1998-09-27	1998-09-27 00:00:00	1998-10-18	1998-10-18 00:00:00	32020		\N	337631	0	370247008	4156265		0
75024	4454	40481087	1930-06-23	1930-06-23 00:00:00	1930-07-07	1930-07-07 00:00:00	32020		\N	296383	0	444814009	40481087		0
75165	4465	4112343	2009-01-31	2009-01-31 00:00:00	2009-02-10	2009-02-10 00:00:00	32020		\N	297087	0	195662009	4112343		0
85913	5113	78272	2016-03-14	2016-03-14 00:00:00	2016-04-18	2016-04-18 00:00:00	32020		\N	339732	0	70704007	78272		0
75407	4476	40481087	2005-04-30	2005-04-30 00:00:00	2005-05-07	2005-05-07 00:00:00	32020		\N	297782	0	444814009	40481087		0
86157	5127	4283893	1971-06-18	1971-06-18 00:00:00	1971-07-16	1971-07-16 00:00:00	32020		\N	340896	0	36971009	4283893		0
75814	4497	260139	1978-03-06	1978-03-06 00:00:00	1978-03-20	1978-03-20 00:00:00	32020		\N	299397	0	10509002	260139		0
75974	4505	4059173	1938-04-12	1938-04-12 00:00:00	1938-06-11	1938-06-11 00:00:00	32020		\N	300077	0	16114001	4059173		0
86754	5165	40481087	1998-09-10	1998-09-10 00:00:00	1998-09-17	1998-09-17 00:00:00	32020		\N	343382	0	444814009	40481087		0
86916	5174	378001	1971-05-01	1971-05-01 00:00:00	1971-05-31	1971-05-31 00:00:00	32020		\N	344066	0	62106007	378001		0
87131	5190	40481087	1975-08-27	1975-08-27 00:00:00	1975-09-17	1975-09-17 00:00:00	32020		\N	345028	0	444814009	40481087		0
87221	5194	372328	1950-10-29	1950-10-29 00:00:00	1951-06-07	1951-06-07 00:00:00	32020		\N	345386	0	65363002	372328		0
87381	5200	372328	2005-07-31	2005-07-31 00:00:00	2005-08-14	2005-08-14 00:00:00	32020		\N	345912	0	65363002	372328		0
87487	5206	81151	1982-08-16	1982-08-16 00:00:00	1982-08-30	1982-08-30 00:00:00	32020		\N	346252	0	44465007	81151		0
77147	4570	4230399	2003-08-10	2003-08-10 00:00:00	2003-09-09	2003-09-09 00:00:00	32020		\N	304492	0	359817006	4230399		0
87939	5232	4237458	1976-07-21	1976-07-21 00:00:00	1976-08-20	1976-08-20 00:00:00	32020		\N	348066	0	58150001	4237458		0
88061	5236	40481087	1992-06-15	1992-06-15 00:00:00	1992-06-22	1992-06-22 00:00:00	32020		\N	348420	0	444814009	40481087		0
88253	5249	81151	1963-02-19	1963-02-19 00:00:00	1963-03-12	1963-03-12 00:00:00	32020		\N	349245	0	44465007	81151		0
88350	5253	40481087	1988-07-24	1988-07-24 00:00:00	1988-07-31	1988-07-31 00:00:00	32020		\N	349541	0	444814009	40481087		0
88688	5274	375671	1960-08-22	1960-08-22 00:00:00	1960-10-21	1960-10-21 00:00:00	32020		\N	350839	0	62564004	375671		0
78342	4639	40481087	2015-10-18	2015-10-18 00:00:00	2015-11-01	2015-11-01 00:00:00	32020		\N	309202	0	444814009	40481087		0
88997	5295	4112343	1917-02-12	1917-02-12 00:00:00	1917-02-23	1917-02-23 00:00:00	32020		\N	352270	0	195662009	4112343		0
89189	5306	372328	1971-01-22	1971-01-22 00:00:00	1971-06-27	1971-06-27 00:00:00	32020		\N	352939	0	65363002	372328		0
89321	5314	372328	1951-09-20	1951-09-20 00:00:00	1951-11-02	1951-11-02 00:00:00	32020		\N	353413	0	65363002	372328		0
89609	5328	260139	1929-01-18	1929-01-18 00:00:00	1929-01-25	1929-01-25 00:00:00	32020		\N	354618	0	10509002	260139		0
89720	5333	260139	1960-03-09	1960-03-09 00:00:00	1960-03-23	1960-03-23 00:00:00	32020		\N	355146	0	10509002	260139		0
79647	4719	40481087	1985-06-04	1985-06-04 00:00:00	1985-06-25	1985-06-25 00:00:00	32020		\N	314251	0	444814009	40481087		0
80134	4750	4027663	1989-04-03	1989-04-03 00:00:00	\N	\N	32020		\N	316329	0	13200003	4027663		0
80243	4755	4156265	1945-03-13	1945-03-13 00:00:00	1945-03-27	1945-03-27 00:00:00	32020		\N	316709	0	370247008	4156265		0
81794	4852	4294548	1977-01-01	1977-01-01 00:00:00	1977-02-05	1977-02-05 00:00:00	32020		\N	322774	0	75498004	4294548		0
82148	4872	40481087	1953-11-05	1953-11-05 00:00:00	1953-11-12	1953-11-12 00:00:00	32020		\N	323990	0	444814009	40481087		0
84258	5004	133834	1977-11-10	1977-11-10 00:00:00	1995-05-23	1995-05-23 00:00:00	32020		\N	332830	0	24079001	133834		0
85379	5078	4112343	1961-10-04	1961-10-04 00:00:00	1961-10-13	1961-10-13 00:00:00	32020		\N	337595	0	195662009	4112343		0
85494	5083	257012	1975-07-20	1975-07-20 00:00:00	1975-09-07	1975-09-07 00:00:00	32020		\N	338052	0	40055000	257012		0
75166	4465	80180	2010-09-04	2010-09-04 00:00:00	\N	\N	32020		\N	297041	0	396275006	80180		0
85914	5113	440448	2017-03-05	2017-03-05 00:00:00	\N	\N	32020		\N	339733	0	74400008	440448		0
75408	4476	40481087	1964-05-15	1964-05-15 00:00:00	1964-06-05	1964-06-05 00:00:00	32020		\N	297893	0	444814009	40481087		0
86158	5127	40481087	1975-04-23	1975-04-23 00:00:00	1975-04-30	1975-04-30 00:00:00	32020		\N	340887	0	444814009	40481087		0
75815	4497	80180	1992-11-05	1992-11-05 00:00:00	\N	\N	32020		\N	299344	0	396275006	80180		0
75975	4505	40481087	2007-09-26	2007-09-26 00:00:00	2007-10-10	2007-10-10 00:00:00	32020		\N	300070	0	444814009	40481087		0
86755	5165	28060	1977-02-07	1977-02-07 00:00:00	1977-02-15	1977-02-15 00:00:00	32020		\N	343256	0	43878008	28060		0
86917	5174	81151	1940-12-13	1940-12-13 00:00:00	1941-01-10	1941-01-10 00:00:00	32020		\N	344061	0	44465007	81151		0
87132	5190	40481087	1959-05-28	1959-05-28 00:00:00	1959-06-04	1959-06-04 00:00:00	32020		\N	344991	0	444814009	40481087		0
87222	5194	40481087	1966-05-29	1966-05-29 00:00:00	1966-06-12	1966-06-12 00:00:00	32020		\N	345290	0	444814009	40481087		0
87382	5200	4156265	1974-05-21	1974-05-21 00:00:00	1974-06-11	1974-06-11 00:00:00	32020		\N	345939	0	370247008	4156265		0
87488	5206	4296205	1986-05-11	1986-05-11 00:00:00	1986-06-01	1986-06-01 00:00:00	32020		\N	346253	0	403191005	4296205		0
77148	4570	372328	1939-11-22	1939-11-22 00:00:00	1940-05-25	1940-05-25 00:00:00	32020		\N	304468	0	65363002	372328		0
87940	5232	4237458	1972-06-12	1972-06-12 00:00:00	1972-09-10	1972-09-10 00:00:00	32020		\N	348065	0	58150001	4237458		0
88062	5236	40481087	1993-02-26	1993-02-26 00:00:00	1993-03-05	1993-03-05 00:00:00	32020		\N	348405	0	444814009	40481087		0
88254	5249	40481087	1953-11-16	1953-11-16 00:00:00	1953-12-07	1953-12-07 00:00:00	32020		\N	349180	0	444814009	40481087		0
88351	5253	4294548	1968-02-16	1968-02-16 00:00:00	1968-04-26	1968-04-26 00:00:00	32020		\N	349560	0	75498004	4294548		0
88689	5274	4112343	2002-11-09	2002-11-09 00:00:00	2002-11-19	2002-11-19 00:00:00	32020		\N	350812	0	195662009	4112343		0
78343	4639	80180	2004-07-01	2004-07-01 00:00:00	\N	\N	32020		\N	309210	0	396275006	80180		0
88998	5295	260139	1944-05-08	1944-05-08 00:00:00	1944-05-15	1944-05-15 00:00:00	32020		\N	352281	0	10509002	260139		0
89190	5306	372328	1973-05-17	1973-05-17 00:00:00	1973-12-30	1973-12-30 00:00:00	32020		\N	352961	0	65363002	372328		0
89322	5314	4294548	1963-05-29	1963-05-29 00:00:00	1963-11-06	1963-11-06 00:00:00	32020		\N	353396	0	75498004	4294548		0
89610	5328	260139	2002-11-18	2002-11-18 00:00:00	2002-11-25	2002-11-25 00:00:00	32020		\N	354713	0	10509002	260139		0
89721	5333	40481087	1996-07-13	1996-07-13 00:00:00	1996-08-03	1996-08-03 00:00:00	32020		\N	355131	0	444814009	40481087		0
79648	4719	40481087	2019-04-22	2019-04-22 00:00:00	2019-05-13	2019-05-13 00:00:00	32020		\N	314200	0	444814009	40481087		0
80135	4750	4112343	2001-07-15	2001-07-15 00:00:00	2001-07-23	2001-07-23 00:00:00	32020		\N	316402	0	195662009	4112343		0
80244	4755	40481087	1973-08-30	1973-08-30 00:00:00	1973-09-13	1973-09-13 00:00:00	32020		\N	316764	0	444814009	40481087		0
81795	4852	372328	1950-08-12	1950-08-12 00:00:00	1950-10-12	1950-10-12 00:00:00	32020		\N	322791	0	65363002	372328		0
82149	4872	80180	1955-11-07	1955-11-07 00:00:00	\N	\N	32020		\N	324066	0	396275006	80180		0
84259	5004	372328	1979-06-26	1979-06-26 00:00:00	1979-08-14	1979-08-14 00:00:00	32020		\N	332835	0	65363002	372328		0
85380	5078	30753	1944-04-12	1944-04-12 00:00:00	\N	\N	32020		\N	337592	0	16761005	30753		0
85495	5083	40481087	1996-01-22	1996-01-22 00:00:00	1996-02-12	1996-02-12 00:00:00	32020		\N	338028	0	444814009	40481087		0
75167	4465	4112343	2006-03-08	2006-03-08 00:00:00	2006-03-15	2006-03-15 00:00:00	32020		\N	297057	0	195662009	4112343		0
85915	5113	372328	1978-11-23	1978-11-23 00:00:00	1979-03-24	1979-03-24 00:00:00	32020		\N	339680	0	65363002	372328		0
75409	4476	81151	1971-06-01	1971-06-01 00:00:00	1971-06-15	1971-06-15 00:00:00	32020		\N	297895	0	44465007	81151		0
86159	5127	40481087	1999-06-13	1999-06-13 00:00:00	1999-07-04	1999-07-04 00:00:00	32020		\N	340867	0	444814009	40481087		0
75816	4497	4283893	1992-06-22	1992-06-22 00:00:00	1992-10-12	1992-10-12 00:00:00	32020		\N	299344	0	36971009	4283893		0
75976	4505	40481087	1949-08-18	1949-08-18 00:00:00	1949-09-01	1949-09-01 00:00:00	32020		\N	300083	0	444814009	40481087		0
86756	5165	260139	1974-12-26	1974-12-26 00:00:00	1975-01-02	1975-01-02 00:00:00	32020		\N	343268	0	10509002	260139		0
86918	5174	78272	1962-08-02	1962-08-02 00:00:00	1962-08-16	1962-08-16 00:00:00	32020		\N	344065	0	70704007	78272		0
87133	5190	81151	2015-02-11	2015-02-11 00:00:00	2015-03-11	2015-03-11 00:00:00	32020		\N	345055	0	44465007	81151		0
87223	5194	372328	1946-05-17	1946-05-17 00:00:00	1946-08-29	1946-08-29 00:00:00	32020		\N	345383	0	65363002	372328		0
87383	5200	40481087	1997-12-18	1997-12-18 00:00:00	1998-01-01	1998-01-01 00:00:00	32020		\N	345827	0	444814009	40481087		0
87489	5206	260139	1993-06-14	1993-06-14 00:00:00	1993-06-28	1993-06-28 00:00:00	32020		\N	346292	0	10509002	260139		0
77149	4570	40481087	2003-07-31	2003-07-31 00:00:00	2003-08-21	2003-08-21 00:00:00	32020		\N	304465	0	444814009	40481087		0
87941	5232	80180	2011-04-09	2011-04-09 00:00:00	\N	\N	32020		\N	348095	0	396275006	80180		0
88087	5239	260139	2004-09-23	2004-09-23 00:00:00	2004-10-07	2004-10-07 00:00:00	32020		\N	348541	0	10509002	260139		0
88255	5249	4283893	1954-10-08	1954-10-08 00:00:00	1954-12-17	1954-12-17 00:00:00	32020		\N	349191	0	36971009	4283893		0
88352	5253	40481087	2009-03-08	2009-03-08 00:00:00	2009-03-15	2009-03-15 00:00:00	32020		\N	349490	0	444814009	40481087		0
88690	5274	4142905	1956-12-11	1956-12-11 00:00:00	1957-02-09	1957-02-09 00:00:00	32020		\N	350838	0	33737001	4142905		0
78344	4639	28060	1984-05-30	1984-05-30 00:00:00	1984-06-10	1984-06-10 00:00:00	32020		\N	309233	0	43878008	28060		0
88999	5295	4112343	1914-09-05	1914-09-05 00:00:00	1914-09-12	1914-09-12 00:00:00	32020		\N	352278	0	195662009	4112343		0
89191	5306	378001	1983-03-07	1983-03-07 00:00:00	1983-05-06	1983-05-06 00:00:00	32020		\N	352980	0	62106007	378001		0
89323	5314	372328	1954-11-16	1954-11-16 00:00:00	1955-11-04	1955-11-04 00:00:00	32020		\N	353414	0	65363002	372328		0
89611	5328	260139	1975-12-26	1975-12-26 00:00:00	1976-01-09	1976-01-09 00:00:00	32020		\N	354710	0	10509002	260139		0
89722	5333	40481087	1949-12-05	1949-12-05 00:00:00	1949-12-19	1949-12-19 00:00:00	32020		\N	355126	0	444814009	40481087		0
79649	4719	81151	1969-06-06	1969-06-06 00:00:00	1969-06-20	1969-06-20 00:00:00	32020		\N	314229	0	44465007	81151		0
80136	4750	40481087	2008-10-28	2008-10-28 00:00:00	2008-11-04	2008-11-04 00:00:00	32020		\N	316298	0	444814009	40481087		0
80245	4755	260139	1941-07-27	1941-07-27 00:00:00	1941-08-03	1941-08-03 00:00:00	32020		\N	316754	0	10509002	260139		0
81796	4852	40481087	1956-04-28	1956-04-28 00:00:00	1956-05-13	1956-05-13 00:00:00	32020		\N	322847	0	444814009	40481087		0
82150	4872	78272	1941-04-28	1941-04-28 00:00:00	1941-06-02	1941-06-02 00:00:00	32020		\N	323951	0	70704007	78272		0
84260	5005	4113008	2004-08-31	2004-08-31 00:00:00	2004-09-14	2004-09-14 00:00:00	32020		\N	332909	0	284549007	4113008		0
85381	5078	81151	1987-06-01	1987-06-01 00:00:00	1987-07-06	1987-07-06 00:00:00	32020		\N	337527	0	44465007	81151		0
85496	5083	81893	1982-12-03	1982-12-03 00:00:00	\N	\N	32020		\N	338005	0	64766004	81893		0
75168	4465	260139	1986-09-17	1986-09-17 00:00:00	1986-09-24	1986-09-24 00:00:00	32020		\N	297039	0	10509002	260139		0
85916	5113	4112343	1972-08-09	1972-08-09 00:00:00	1972-08-20	1972-08-20 00:00:00	32020		\N	339692	0	195662009	4112343		0
75410	4476	40481087	2009-01-25	2009-01-25 00:00:00	2009-02-08	2009-02-08 00:00:00	32020		\N	297783	0	444814009	40481087		0
86160	5127	40481087	1995-11-03	1995-11-03 00:00:00	1995-11-24	1995-11-24 00:00:00	32020		\N	340856	0	444814009	40481087		0
75817	4497	28060	1963-08-04	1963-08-04 00:00:00	1963-08-14	1963-08-14 00:00:00	32020		\N	299396	0	43878008	28060		0
75977	4505	4048171	1941-07-27	1941-07-27 00:00:00	1993-07-13	1993-07-13 00:00:00	32020		\N	300039	0	232353008	4048171		0
86757	5165	4283893	1990-12-15	1990-12-15 00:00:00	1991-03-16	1991-03-16 00:00:00	32020		\N	343318	0	36971009	4283893		0
86919	5174	81893	1979-10-15	1979-10-15 00:00:00	\N	\N	32020		\N	344039	0	64766004	81893		0
87134	5190	372328	1993-04-20	1993-04-20 00:00:00	1994-10-28	1994-10-28 00:00:00	32020		\N	344977	0	65363002	372328		0
87224	5194	4112343	2013-05-21	2013-05-21 00:00:00	2013-06-02	2013-06-02 00:00:00	32020		\N	345353	0	195662009	4112343		0
87384	5200	40481087	1980-05-16	1980-05-16 00:00:00	1980-06-06	1980-06-06 00:00:00	32020		\N	345872	0	444814009	40481087		0
87490	5206	40481087	1984-01-13	1984-01-13 00:00:00	1984-02-03	1984-02-03 00:00:00	32020		\N	346255	0	444814009	40481087		0
77150	4570	40481087	1969-06-27	1969-06-27 00:00:00	1969-07-04	1969-07-04 00:00:00	32020		\N	304511	0	444814009	40481087		0
87942	5232	260139	1983-02-17	1983-02-17 00:00:00	1983-02-24	1983-02-24 00:00:00	32020		\N	348089	0	10509002	260139		0
88088	5239	4278672	1997-03-11	1997-03-11 00:00:00	1997-06-09	1997-06-09 00:00:00	32020		\N	348604	0	65966004	4278672		0
88256	5249	40481087	2002-04-12	2002-04-12 00:00:00	2002-04-26	2002-04-26 00:00:00	32020		\N	349235	0	444814009	40481087		0
88353	5253	40481087	2009-12-17	2009-12-17 00:00:00	2009-12-31	2009-12-31 00:00:00	32020		\N	349527	0	444814009	40481087		0
88691	5274	4112343	1999-01-26	1999-01-26 00:00:00	1999-02-07	1999-02-07 00:00:00	32020		\N	350802	0	195662009	4112343		0
78345	4639	192671	2004-09-05	2004-09-05 00:00:00	\N	\N	32020		\N	309245	0	K92.2	35208414		0
89000	5295	260139	1981-11-16	1981-11-16 00:00:00	1981-11-23	1981-11-23 00:00:00	32020		\N	352243	0	10509002	260139		0
89192	5306	40481087	2009-01-02	2009-01-02 00:00:00	2009-01-16	2009-01-16 00:00:00	32020		\N	352927	0	444814009	40481087		0
89324	5314	4116491	1979-11-17	1979-11-17 00:00:00	1979-12-28	1979-12-28 00:00:00	32020		\N	353421	0	301011002	4116491		0
89612	5328	80180	1945-04-08	1945-04-08 00:00:00	\N	\N	32020		\N	354727	0	396275006	80180		0
89723	5333	40481087	1999-01-27	1999-01-27 00:00:00	1999-02-10	1999-02-10 00:00:00	32020		\N	355150	0	444814009	40481087		0
79650	4719	81151	1992-06-19	1992-06-19 00:00:00	1992-07-03	1992-07-03 00:00:00	32020		\N	314231	0	44465007	81151		0
80137	4750	40481087	1975-02-26	1975-02-26 00:00:00	1975-03-19	1975-03-19 00:00:00	32020		\N	316334	0	444814009	40481087		0
80246	4756	260139	1977-06-03	1977-06-03 00:00:00	1977-06-10	1977-06-10 00:00:00	32020		\N	316843	0	10509002	260139		0
81797	4852	260139	1962-12-15	1962-12-15 00:00:00	1962-12-22	1962-12-22 00:00:00	32020		\N	322785	0	10509002	260139		0
82151	4872	4155034	1926-12-29	1926-12-29 00:00:00	1927-01-12	1927-01-12 00:00:00	32020		\N	323950	0	283371005	4155034		0
84261	5005	40481087	1995-08-11	1995-08-11 00:00:00	1995-09-01	1995-09-01 00:00:00	32020		\N	332921	0	444814009	40481087		0
85382	5078	40481087	1919-10-03	1919-10-03 00:00:00	1919-10-10	1919-10-10 00:00:00	32020		\N	337632	0	444814009	40481087		0
85497	5083	4310024	1982-10-04	1982-10-04 00:00:00	\N	\N	32020		\N	338005	0	424802006	4310024		0
75169	4465	4294548	1994-01-28	1994-01-28 00:00:00	1994-05-27	1994-05-27 00:00:00	32020		\N	297085	0	75498004	4294548		0
85917	5113	4112343	1979-01-17	1979-01-17 00:00:00	1979-01-29	1979-01-29 00:00:00	32020		\N	339707	0	195662009	4112343		0
75411	4476	4278672	1968-08-15	1968-08-15 00:00:00	1968-11-13	1968-11-13 00:00:00	32020		\N	297894	0	65966004	4278672		0
86161	5127	260139	1994-10-26	1994-10-26 00:00:00	1994-11-09	1994-11-09 00:00:00	32020		\N	340855	0	10509002	260139		0
75818	4497	260139	2005-01-22	2005-01-22 00:00:00	2005-01-29	2005-01-29 00:00:00	32020		\N	299398	0	10509002	260139		0
75978	4505	260139	1992-12-12	1992-12-12 00:00:00	1992-12-26	1992-12-26 00:00:00	32020		\N	300116	0	10509002	260139		0
86758	5165	4112343	2005-04-22	2005-04-22 00:00:00	2005-05-01	2005-05-01 00:00:00	32020		\N	343383	0	195662009	4112343		0
86920	5174	260139	1978-11-19	1978-11-19 00:00:00	1978-11-26	1978-11-26 00:00:00	32020		\N	344039	0	10509002	260139		0
87135	5190	260139	1998-07-20	1998-07-20 00:00:00	1998-08-04	1998-08-04 00:00:00	32020		\N	345037	0	10509002	260139		0
87225	5194	40481087	2010-06-26	2010-06-26 00:00:00	2010-07-10	2010-07-10 00:00:00	32020		\N	345402	0	444814009	40481087		0
87385	5200	4112343	2010-06-09	2010-06-09 00:00:00	2010-06-21	2010-06-21 00:00:00	32020		\N	345832	0	195662009	4112343		0
87491	5206	40481087	1983-07-03	1983-07-03 00:00:00	1983-07-10	1983-07-10 00:00:00	32020		\N	346291	0	444814009	40481087		0
77151	4570	4310024	1970-07-14	1970-07-14 00:00:00	\N	\N	32020		\N	304511	0	424802006	4310024		0
87943	5232	40481087	1996-07-20	1996-07-20 00:00:00	1996-08-03	1996-08-03 00:00:00	32020		\N	348097	0	444814009	40481087		0
88089	5239	372328	1966-07-22	1966-07-22 00:00:00	1966-11-02	1966-11-02 00:00:00	32020		\N	348543	0	65363002	372328		0
88257	5249	4112343	1986-03-31	1986-03-31 00:00:00	1986-04-08	1986-04-08 00:00:00	32020		\N	349158	0	195662009	4112343		0
88354	5253	40481087	1984-08-17	1984-08-17 00:00:00	1984-09-07	1984-09-07 00:00:00	32020		\N	349565	0	444814009	40481087		0
88692	5274	260139	1953-09-29	1953-09-29 00:00:00	1953-10-06	1953-10-06 00:00:00	32020		\N	350767	0	10509002	260139		0
78346	4639	4112343	1982-04-02	1982-04-02 00:00:00	1982-04-10	1982-04-10 00:00:00	32020		\N	309192	0	195662009	4112343		0
89001	5295	4294548	1914-11-10	1914-11-10 00:00:00	1915-05-25	1915-05-25 00:00:00	32020		\N	352298	0	75498004	4294548		0
89193	5306	40481087	1987-11-16	1987-11-16 00:00:00	1987-12-07	1987-12-07 00:00:00	32020		\N	352960	0	444814009	40481087		0
89325	5314	40481087	2003-02-15	2003-02-15 00:00:00	2003-02-22	2003-02-22 00:00:00	32020		\N	353430	0	444814009	40481087		0
89613	5328	260139	1988-09-05	1988-09-05 00:00:00	1988-09-12	1988-09-12 00:00:00	32020		\N	354711	0	10509002	260139		0
89724	5333	192671	1986-09-06	1986-09-06 00:00:00	\N	\N	32020		\N	355125	0	K92.2	35208414		0
79651	4719	4299128	2003-06-06	2003-06-06 00:00:00	2003-06-20	2003-06-20 00:00:00	32020		\N	314298	0	403192003	4299128		0
80138	4750	372328	1964-04-04	1964-04-04 00:00:00	1964-06-17	1964-06-17 00:00:00	32020		\N	316403	0	65363002	372328		0
80247	4756	260139	2003-05-26	2003-05-26 00:00:00	2003-06-09	2003-06-09 00:00:00	32020		\N	316868	0	10509002	260139		0
81798	4852	40481087	1956-08-18	1956-08-18 00:00:00	1956-08-25	1956-08-25 00:00:00	32020		\N	322771	0	444814009	40481087		0
82152	4872	4112343	1979-08-03	1979-08-03 00:00:00	1979-08-11	1979-08-11 00:00:00	32020		\N	323992	0	195662009	4112343		0
84262	5005	260139	2008-08-28	2008-08-28 00:00:00	2008-09-11	2008-09-11 00:00:00	32020		\N	332929	0	10509002	260139		0
85383	5078	4051466	1914-05-07	1914-05-07 00:00:00	1930-08-14	1930-08-14 00:00:00	32020		\N	337642	0	233678006	4051466		0
85498	5083	4266809	1984-01-27	1984-01-27 00:00:00	\N	\N	32020		\N	338005	0	397881000	4266809		0
75170	4465	4218389	1977-07-04	1977-07-04 00:00:00	1977-07-25	1977-07-25 00:00:00	32020		\N	297075	0	39848009	4218389		0
85918	5113	4112343	2019-05-13	2019-05-13 00:00:00	2019-05-21	2019-05-21 00:00:00	32020		\N	339679	0	195662009	4112343		0
75412	4476	40481087	1990-01-01	1990-01-01 00:00:00	1990-01-15	1990-01-15 00:00:00	32020		\N	297829	0	444814009	40481087		0
86162	5127	260139	1975-12-17	1975-12-17 00:00:00	1975-12-31	1975-12-31 00:00:00	32020		\N	340888	0	10509002	260139		0
75819	4497	40481087	1986-12-02	1986-12-02 00:00:00	1986-12-16	1986-12-16 00:00:00	32020		\N	299371	0	444814009	40481087		0
75979	4505	381316	1980-12-16	1980-12-16 00:00:00	\N	\N	32020		\N	300090	0	230690007	381316		0
86759	5165	4294548	2009-05-31	2009-05-31 00:00:00	2010-04-04	2010-04-04 00:00:00	32020		\N	343335	0	75498004	4294548		0
86921	5174	4310024	1979-09-15	1979-09-15 00:00:00	\N	\N	32020		\N	344039	0	424802006	4310024		0
87136	5190	4109685	1988-01-20	1988-01-20 00:00:00	1988-02-03	1988-02-03 00:00:00	32020		\N	345053	0	284551006	4109685		0
87226	5194	40481087	1990-01-30	1990-01-30 00:00:00	1990-02-06	1990-02-06 00:00:00	32020		\N	345321	0	444814009	40481087		0
87386	5200	260139	1968-05-24	1968-05-24 00:00:00	1968-06-07	1968-06-07 00:00:00	32020		\N	345866	0	10509002	260139		0
87492	5206	4112343	1985-10-27	1985-10-27 00:00:00	1985-11-04	1985-11-04 00:00:00	32020		\N	346264	0	195662009	4112343		0
77152	4570	28060	1976-12-16	1976-12-16 00:00:00	1976-12-27	1976-12-27 00:00:00	32020		\N	304461	0	43878008	28060		0
87944	5232	4112343	1982-12-08	1982-12-08 00:00:00	1982-12-16	1982-12-16 00:00:00	32020		\N	348088	0	195662009	4112343		0
88090	5239	4112343	2002-11-24	2002-11-24 00:00:00	2002-12-05	2002-12-05 00:00:00	32020		\N	348570	0	195662009	4112343		0
88258	5249	381316	2004-04-25	2004-04-25 00:00:00	\N	\N	32020		\N	349230	0	230690007	381316		0
88355	5253	260139	1991-10-18	1991-10-18 00:00:00	1991-10-25	1991-10-25 00:00:00	32020		\N	349524	0	10509002	260139		0
88693	5274	4112343	1966-11-01	1966-11-01 00:00:00	1966-11-12	1966-11-12 00:00:00	32020		\N	350834	0	195662009	4112343		0
78347	4639	40481087	1992-05-28	1992-05-28 00:00:00	1992-06-11	1992-06-11 00:00:00	32020		\N	309196	0	444814009	40481087		0
89002	5295	260139	1939-11-22	1939-11-22 00:00:00	1939-11-29	1939-11-29 00:00:00	32020		\N	352279	0	10509002	260139		0
89194	5306	40481087	1990-07-30	1990-07-30 00:00:00	1990-08-20	1990-08-20 00:00:00	32020		\N	352950	0	444814009	40481087		0
89326	5314	40481087	1977-11-15	1977-11-15 00:00:00	1977-12-06	1977-12-06 00:00:00	32020		\N	353388	0	444814009	40481087		0
89614	5328	81151	1914-05-06	1914-05-06 00:00:00	1914-06-03	1914-06-03 00:00:00	32020		\N	354586	0	44465007	81151		0
89725	5333	372328	1952-07-04	1952-07-04 00:00:00	1952-12-07	1952-12-07 00:00:00	32020		\N	355156	0	65363002	372328		0
79652	4719	28060	1957-09-04	1957-09-04 00:00:00	1957-09-15	1957-09-15 00:00:00	32020		\N	314188	0	43878008	28060		0
80139	4750	260139	1977-09-25	1977-09-25 00:00:00	1977-10-02	1977-10-02 00:00:00	32020		\N	316355	0	10509002	260139		0
80248	4756	80180	1985-04-16	1985-04-16 00:00:00	\N	\N	32020		\N	316847	0	396275006	80180		0
81799	4852	4218389	2003-01-26	2003-01-26 00:00:00	2003-03-02	2003-03-02 00:00:00	32020		\N	322783	0	39848009	4218389		0
82153	4872	260139	1960-07-25	1960-07-25 00:00:00	1960-08-08	1960-08-08 00:00:00	32020		\N	324009	0	10509002	260139		0
84263	5005	40481087	2007-08-24	2007-08-24 00:00:00	2007-09-07	2007-09-07 00:00:00	32020		\N	332912	0	444814009	40481087		0
75171	4465	40481087	1986-04-13	1986-04-13 00:00:00	1986-05-04	1986-05-04 00:00:00	32020		\N	297068	0	444814009	40481087		0
85919	5113	78272	1970-02-08	1970-02-08 00:00:00	1970-03-08	1970-03-08 00:00:00	32020		\N	339721	0	70704007	78272		0
75413	4476	195588	1989-02-11	1989-02-11 00:00:00	1989-03-17	1989-03-17 00:00:00	32020		\N	297828	0	38822007	195588		0
86163	5127	40481087	2017-08-22	2017-08-22 00:00:00	2017-08-29	2017-08-29 00:00:00	32020		\N	340846	0	444814009	40481087		0
75820	4497	378001	1976-01-12	1976-01-12 00:00:00	1976-02-11	1976-02-11 00:00:00	32020		\N	299367	0	62106007	378001		0
75980	4505	4112343	1958-08-11	1958-08-11 00:00:00	1958-08-18	1958-08-18 00:00:00	32020		\N	300041	0	195662009	4112343		0
86760	5165	40481087	2010-11-09	2010-11-09 00:00:00	2010-11-16	2010-11-16 00:00:00	32020		\N	343295	0	444814009	40481087		0
86922	5174	4027663	1971-01-20	1971-01-20 00:00:00	\N	\N	32020		\N	343979	0	13200003	4027663		0
87137	5190	4112343	1967-09-17	1967-09-17 00:00:00	1967-09-25	1967-09-25 00:00:00	32020		\N	345027	0	195662009	4112343		0
87227	5194	40481087	1950-01-03	1950-01-03 00:00:00	1950-01-17	1950-01-17 00:00:00	32020		\N	345285	0	444814009	40481087		0
87387	5200	4156265	1982-03-31	1982-03-31 00:00:00	1982-04-21	1982-04-21 00:00:00	32020		\N	345940	0	370247008	4156265		0
87493	5206	40481087	1977-01-20	1977-01-20 00:00:00	1977-01-27	1977-01-27 00:00:00	32020		\N	346289	0	444814009	40481087		0
77153	4570	4155034	1961-11-27	1961-11-27 00:00:00	1961-12-18	1961-12-18 00:00:00	32020		\N	304491	0	283371005	4155034		0
87945	5232	40481087	2016-06-20	2016-06-20 00:00:00	2016-06-27	2016-06-27 00:00:00	32020		\N	348099	0	444814009	40481087		0
88091	5239	192671	2011-10-26	2011-10-26 00:00:00	\N	\N	32020		\N	348605	0	K92.2	35208414		0
88259	5249	260139	1955-10-31	1955-10-31 00:00:00	1955-11-14	1955-11-14 00:00:00	32020		\N	349182	0	10509002	260139		0
88356	5253	40481087	1964-02-17	1964-02-17 00:00:00	1964-03-02	1964-03-02 00:00:00	32020		\N	349522	0	444814009	40481087		0
88694	5274	40481087	1979-09-18	1979-09-18 00:00:00	1979-09-25	1979-09-25 00:00:00	32020		\N	350835	0	444814009	40481087		0
78348	4639	4294548	1991-06-05	1991-06-05 00:00:00	1991-07-24	1991-07-24 00:00:00	32020		\N	309234	0	75498004	4294548		0
89003	5295	260139	1946-01-06	1946-01-06 00:00:00	1946-01-13	1946-01-13 00:00:00	32020		\N	352272	0	10509002	260139		0
89195	5306	81151	1990-08-27	1990-08-27 00:00:00	1990-09-24	1990-09-24 00:00:00	32020		\N	352981	0	44465007	81151		0
89327	5314	257012	1963-10-02	1963-10-02 00:00:00	\N	\N	32020		\N	353420	0	40055000	257012		0
89615	5328	28060	1923-05-07	1923-05-07 00:00:00	1923-05-18	1923-05-18 00:00:00	32020		\N	354622	0	43878008	28060		0
89726	5334	372328	1983-09-21	1983-09-21 00:00:00	1986-03-12	1986-03-12 00:00:00	32020		\N	355202	0	65363002	372328		0
79653	4719	4084167	1940-09-01	1940-09-01 00:00:00	1940-09-01	1940-09-01 00:00:00	32020		\N	314226	0	241929008	4084167		0
80140	4750	4283893	1994-07-26	1994-07-26 00:00:00	1994-09-06	1994-09-06 00:00:00	32020		\N	316366	0	36971009	4283893		0
80249	4756	28060	2006-04-02	2006-04-02 00:00:00	2006-04-11	2006-04-11 00:00:00	32020		\N	316788	0	43878008	28060		0
81800	4852	28060	1960-11-30	1960-11-30 00:00:00	1960-12-08	1960-12-08 00:00:00	32020		\N	322784	0	43878008	28060		0
82154	4872	4283893	1942-10-03	1942-10-03 00:00:00	1942-11-28	1942-11-28 00:00:00	32020		\N	323975	0	36971009	4283893		0
84264	5005	80180	2008-01-09	2008-01-09 00:00:00	\N	\N	32020		\N	332912	0	396275006	80180		0
85385	5078	4112343	1979-06-20	1979-06-20 00:00:00	1979-07-01	1979-07-01 00:00:00	32020		\N	337598	0	195662009	4112343		0
85500	5083	4285898	1983-11-28	1983-11-28 00:00:00	\N	\N	32020		\N	338005	0	68496003	4285898		0
75172	4465	40481087	2001-05-26	2001-05-26 00:00:00	2001-06-16	2001-06-16 00:00:00	32020		\N	297069	0	444814009	40481087		0
85920	5113	4112343	1971-01-08	1971-01-08 00:00:00	1971-01-15	1971-01-15 00:00:00	32020		\N	339691	0	195662009	4112343		0
75414	4476	4048171	1964-02-25	1964-02-25 00:00:00	\N	\N	32020		\N	297890	0	232353008	4048171		0
86164	5127	260139	1989-06-28	1989-06-28 00:00:00	1989-07-05	1989-07-05 00:00:00	32020		\N	340890	0	10509002	260139		0
75821	4497	40481087	2000-10-09	2000-10-09 00:00:00	2000-10-23	2000-10-23 00:00:00	32020		\N	299358	0	444814009	40481087		0
75981	4505	28060	1981-05-21	1981-05-21 00:00:00	1981-06-03	1981-06-03 00:00:00	32020		\N	300042	0	43878008	28060		0
86761	5165	4112343	1973-01-03	1973-01-03 00:00:00	1973-01-15	1973-01-15 00:00:00	32020		\N	343247	0	195662009	4112343		0
86923	5174	28060	1947-01-07	1947-01-07 00:00:00	1947-01-17	1947-01-17 00:00:00	32020		\N	344022	0	43878008	28060		0
87138	5190	40481087	1983-08-07	1983-08-07 00:00:00	1983-08-14	1983-08-14 00:00:00	32020		\N	345030	0	444814009	40481087		0
87228	5194	80180	1982-08-26	1982-08-26 00:00:00	\N	\N	32020		\N	345342	0	396275006	80180		0
87388	5201	40481087	1989-03-17	1989-03-17 00:00:00	1989-03-24	1989-03-24 00:00:00	32020		\N	345974	0	444814009	40481087		0
87494	5206	4112343	1995-11-15	1995-11-15 00:00:00	1995-11-25	1995-11-25 00:00:00	32020		\N	346271	0	195662009	4112343		0
77154	4570	4027663	1962-01-17	1962-01-17 00:00:00	\N	\N	32020		\N	304491	0	13200003	4027663		0
87946	5232	4112343	1978-08-15	1978-08-15 00:00:00	1978-08-28	1978-08-28 00:00:00	32020		\N	348082	0	195662009	4112343		0
88092	5239	4294548	2006-08-21	2006-08-21 00:00:00	2006-08-28	2006-08-28 00:00:00	32020		\N	348542	0	75498004	4294548		0
88260	5249	372328	1963-05-20	1963-05-20 00:00:00	1963-12-22	1963-12-22 00:00:00	32020		\N	349160	0	65363002	372328		0
88357	5253	40481087	1986-10-05	1986-10-05 00:00:00	1986-10-26	1986-10-26 00:00:00	32020		\N	349484	0	444814009	40481087		0
88695	5274	40481087	2016-12-06	2016-12-06 00:00:00	2016-12-13	2016-12-13 00:00:00	32020		\N	350814	0	444814009	40481087		0
78349	4639	372328	1975-07-24	1975-07-24 00:00:00	1976-02-06	1976-02-06 00:00:00	32020		\N	309187	0	65363002	372328		0
89004	5295	4112343	1993-09-08	1993-09-08 00:00:00	1993-09-16	1993-09-16 00:00:00	32020		\N	352285	0	195662009	4112343		0
89196	5306	81151	2003-08-08	2003-08-08 00:00:00	2003-09-12	2003-09-12 00:00:00	32020		\N	352983	0	44465007	81151		0
89328	5314	40481087	1971-11-24	1971-11-24 00:00:00	1971-12-08	1971-12-08 00:00:00	32020		\N	353397	0	444814009	40481087		0
89616	5328	40481087	1953-10-05	1953-10-05 00:00:00	1953-10-26	1953-10-26 00:00:00	32020		\N	354619	0	444814009	40481087		0
89727	5334	260139	1988-11-06	1988-11-06 00:00:00	1988-11-13	1988-11-13 00:00:00	32020		\N	355193	0	10509002	260139		0
79654	4719	4146173	2017-01-21	2017-01-21 00:00:00	2017-02-20	2017-02-20 00:00:00	32020		\N	314321	0	307731004	4146173		0
80141	4750	4048171	1968-04-15	1968-04-15 00:00:00	1982-04-14	1982-04-14 00:00:00	32020		\N	316357	0	232353008	4048171		0
80250	4756	192671	1985-04-21	1985-04-21 00:00:00	\N	\N	32020		\N	316780	0	K92.2	35208414		0
81801	4852	40481087	1975-06-22	1975-06-22 00:00:00	1975-07-06	1975-07-06 00:00:00	32020		\N	322833	0	444814009	40481087		0
82155	4872	40481087	1994-03-04	1994-03-04 00:00:00	1994-03-18	1994-03-18 00:00:00	32020		\N	323994	0	444814009	40481087		0
84265	5005	40481087	2003-05-28	2003-05-28 00:00:00	2003-06-11	2003-06-11 00:00:00	32020		\N	332911	0	444814009	40481087		0
85386	5078	4156265	1956-05-25	1956-05-25 00:00:00	1956-06-15	1956-06-15 00:00:00	32020		\N	337523	0	370247008	4156265		0
85501	5083	4112343	1951-03-05	1951-03-05 00:00:00	1951-03-14	1951-03-14 00:00:00	32020		\N	338051	0	195662009	4112343		0
75173	4465	257012	1994-03-11	1994-03-11 00:00:00	\N	\N	32020		\N	297086	0	40055000	257012		0
85922	5113	40479422	1974-02-15	1974-02-15 00:00:00	1974-03-24	1974-03-24 00:00:00	32020		\N	339722	0	444448004	40479422		0
75415	4476	260139	2003-03-08	2003-03-08 00:00:00	2003-03-22	2003-03-22 00:00:00	32020		\N	297857	0	10509002	260139		0
86165	5127	260139	1972-07-07	1972-07-07 00:00:00	1972-07-14	1972-07-14 00:00:00	32020		\N	340865	0	10509002	260139		0
75822	4497	4142905	1987-07-18	1987-07-18 00:00:00	1987-09-16	1987-09-16 00:00:00	32020		\N	299369	0	33737001	4142905		0
75982	4505	260139	1945-05-07	1945-05-07 00:00:00	1945-05-21	1945-05-21 00:00:00	32020		\N	300046	0	10509002	260139		0
86762	5165	28060	1973-02-15	1973-02-15 00:00:00	1973-02-27	1973-02-27 00:00:00	32020		\N	343289	0	43878008	28060		0
86924	5174	40481087	1998-07-07	1998-07-07 00:00:00	1998-07-28	1998-07-28 00:00:00	32020		\N	344041	0	444814009	40481087		0
87139	5190	40481087	1977-05-18	1977-05-18 00:00:00	1977-06-01	1977-06-01 00:00:00	32020		\N	345029	0	444814009	40481087		0
87229	5194	372328	1948-10-17	1948-10-17 00:00:00	1948-11-25	1948-11-25 00:00:00	32020		\N	345384	0	65363002	372328		0
87389	5201	40481087	1995-12-24	1995-12-24 00:00:00	1996-01-14	1996-01-14 00:00:00	32020		\N	345980	0	444814009	40481087		0
87495	5206	28060	1999-06-23	1999-06-23 00:00:00	1999-07-04	1999-07-04 00:00:00	32020		\N	346258	0	43878008	28060		0
77155	4570	4285898	1971-10-07	1971-10-07 00:00:00	\N	\N	32020		\N	304424	0	68496003	4285898		0
87947	5232	28060	1989-04-14	1989-04-14 00:00:00	1989-04-27	1989-04-27 00:00:00	32020		\N	348083	0	43878008	28060		0
88093	5239	80180	2011-08-30	2011-08-30 00:00:00	\N	\N	32020		\N	348559	0	396275006	80180		0
88261	5249	4294548	2015-04-10	2015-04-10 00:00:00	2015-06-19	2015-06-19 00:00:00	32020		\N	349237	0	75498004	4294548		0
88358	5253	4027663	1987-12-02	1987-12-02 00:00:00	\N	\N	32020		\N	349484	0	13200003	4027663		0
88696	5274	4218389	1976-03-29	1976-03-29 00:00:00	1976-04-19	1976-04-19 00:00:00	32020		\N	350842	0	39848009	4218389		0
78350	4639	4027663	1995-02-14	1995-02-14 00:00:00	\N	\N	32020		\N	\N	0	13200003	4027663		0
89005	5295	40481087	1995-09-27	1995-09-27 00:00:00	1995-10-18	1995-10-18 00:00:00	32020		\N	352286	0	444814009	40481087		0
89197	5306	372328	1969-09-24	1969-09-24 00:00:00	1969-12-28	1969-12-28 00:00:00	32020		\N	352938	0	65363002	372328		0
89329	5314	4027663	1981-11-16	1981-11-16 00:00:00	\N	\N	32020		\N	353429	0	13200003	4027663		0
89617	5329	28060	1985-01-28	1985-01-28 00:00:00	1985-02-09	1985-02-09 00:00:00	32020		\N	354757	0	43878008	28060		0
89728	5334	40481087	2017-05-31	2017-05-31 00:00:00	2017-06-07	2017-06-07 00:00:00	32020		\N	355196	0	444814009	40481087		0
79655	4719	4218389	1944-10-10	1944-10-10 00:00:00	1944-11-14	1944-11-14 00:00:00	32020		\N	314227	0	39848009	4218389		0
80142	4750	378001	1972-07-21	1972-07-21 00:00:00	1972-08-20	1972-08-20 00:00:00	32020		\N	316375	0	62106007	378001		0
80251	4756	40481087	1973-06-23	1973-06-23 00:00:00	1973-07-14	1973-07-14 00:00:00	32020		\N	316866	0	444814009	40481087		0
81802	4852	4116491	1994-01-04	1994-01-04 00:00:00	1994-02-20	1994-02-20 00:00:00	32020		\N	322852	0	301011002	4116491		0
82156	4872	40481087	1930-06-19	1930-06-19 00:00:00	1930-07-10	1930-07-10 00:00:00	32020		\N	323972	0	444814009	40481087		0
84266	5005	40479422	2010-03-17	2010-03-17 00:00:00	2010-04-23	2010-04-23 00:00:00	32020		\N	332910	0	444448004	40479422		0
85387	5078	40481087	1934-10-07	1934-10-07 00:00:00	1934-10-21	1934-10-21 00:00:00	32020		\N	337614	0	444814009	40481087		0
85502	5083	4283893	2000-08-26	2000-08-26 00:00:00	2000-12-09	2000-12-09 00:00:00	32020		\N	338017	0	36971009	4283893		0
75174	4465	40481087	2011-10-27	2011-10-27 00:00:00	2011-11-17	2011-11-17 00:00:00	32020		\N	297088	0	444814009	40481087		0
85923	5113	28060	2013-05-02	2013-05-02 00:00:00	2013-05-11	2013-05-11 00:00:00	32020		\N	339669	0	43878008	28060		0
75416	4476	4156265	2001-12-25	2001-12-25 00:00:00	2002-01-15	2002-01-15 00:00:00	32020		\N	297899	0	370247008	4156265		0
86166	5127	260139	1984-02-16	1984-02-16 00:00:00	1984-02-23	1984-02-23 00:00:00	32020		\N	340866	0	10509002	260139		0
75823	4497	260139	1996-04-13	1996-04-13 00:00:00	1996-04-27	1996-04-27 00:00:00	32020		\N	299381	0	10509002	260139		0
75983	4506	257012	1982-02-28	1982-02-28 00:00:00	\N	\N	32020		\N	300223	0	40055000	257012		0
86763	5165	378001	2000-10-29	2000-10-29 00:00:00	2000-11-28	2000-11-28 00:00:00	32020		\N	343396	0	62106007	378001		0
86925	5174	4237458	1944-12-20	1944-12-20 00:00:00	1945-02-18	1945-02-18 00:00:00	32020		\N	344062	0	58150001	4237458		0
87140	5190	260139	1990-10-05	1990-10-05 00:00:00	1990-10-19	1990-10-19 00:00:00	32020		\N	344994	0	10509002	260139		0
87230	5194	260139	1946-06-17	1946-06-17 00:00:00	1946-06-24	1946-06-24 00:00:00	32020		\N	345295	0	10509002	260139		0
87390	5201	80180	2015-02-10	2015-02-10 00:00:00	\N	\N	32020		\N	345948	0	396275006	80180		0
87496	5206	40481087	2000-09-29	2000-09-29 00:00:00	2000-10-20	2000-10-20 00:00:00	32020		\N	346293	0	444814009	40481087		0
77156	4570	80180	1972-08-02	1972-08-02 00:00:00	\N	\N	32020		\N	304424	0	396275006	80180		0
87948	5232	40481087	1973-10-14	1973-10-14 00:00:00	1973-10-28	1973-10-28 00:00:00	32020		\N	348079	0	444814009	40481087		0
88094	5239	4285898	2010-12-03	2010-12-03 00:00:00	\N	\N	32020		\N	348559	0	68496003	4285898		0
88262	5249	28060	1957-09-21	1957-09-21 00:00:00	1957-09-30	1957-09-30 00:00:00	32020		\N	349193	0	43878008	28060		0
88359	5253	4112343	1974-07-24	1974-07-24 00:00:00	1974-08-06	1974-08-06 00:00:00	32020		\N	349482	0	195662009	4112343		0
88697	5274	80180	1989-11-13	1989-11-13 00:00:00	\N	\N	32020		\N	350801	0	396275006	80180		0
78351	4639	260139	1994-07-15	1994-07-15 00:00:00	1994-07-29	1994-07-29 00:00:00	32020		\N	309193	0	10509002	260139		0
89006	5295	372328	1910-05-27	1910-05-27 00:00:00	1910-09-07	1910-09-07 00:00:00	32020		\N	352234	0	65363002	372328		0
89198	5306	4218389	1997-06-19	1997-06-19 00:00:00	1997-07-10	1997-07-10 00:00:00	32020		\N	352982	0	39848009	4218389		0
89330	5314	4112343	1980-02-04	1980-02-04 00:00:00	1980-02-15	1980-02-15 00:00:00	32020		\N	353429	0	195662009	4112343		0
89618	5329	40481087	2006-09-01	2006-09-01 00:00:00	2006-09-08	2006-09-08 00:00:00	32020		\N	354791	0	444814009	40481087		0
89729	5334	260139	2018-12-07	2018-12-07 00:00:00	2018-12-21	2018-12-21 00:00:00	32020		\N	355180	0	10509002	260139		0
79656	4719	372328	1935-04-01	1935-04-01 00:00:00	1935-05-12	1935-05-12 00:00:00	32020		\N	314201	0	65363002	372328		0
80143	4750	40481087	1970-11-23	1970-11-23 00:00:00	1970-12-14	1970-12-14 00:00:00	32020		\N	316282	0	444814009	40481087		0
80252	4756	40481087	1976-12-31	1976-12-31 00:00:00	1977-01-21	1977-01-21 00:00:00	32020		\N	316842	0	444814009	40481087		0
81803	4852	4056621	1994-01-04	1994-01-04 00:00:00	\N	\N	32020		\N	322852	0	197927001	4056621		0
82157	4872	260139	2007-09-22	2007-09-22 00:00:00	2007-09-29	2007-09-29 00:00:00	32020		\N	324057	0	10509002	260139		0
84267	5005	257012	2013-02-01	2013-02-01 00:00:00	\N	\N	32020		\N	332958	0	40055000	257012		0
85388	5078	4112343	1952-12-07	1952-12-07 00:00:00	1952-12-19	1952-12-19 00:00:00	32020		\N	337537	0	195662009	4112343		0
85503	5083	28060	1988-03-25	1988-03-25 00:00:00	1988-04-06	1988-04-06 00:00:00	32020		\N	338024	0	43878008	28060		0
75175	4466	40481087	2005-01-10	2005-01-10 00:00:00	2005-01-31	2005-01-31 00:00:00	32020		\N	297098	0	444814009	40481087		0
85924	5113	80180	2004-03-26	2004-03-26 00:00:00	\N	\N	32020		\N	339695	0	396275006	80180		0
75417	4476	260139	1992-05-25	1992-05-25 00:00:00	1992-06-01	1992-06-01 00:00:00	32020		\N	297852	0	10509002	260139		0
86167	5127	40481087	2002-03-28	2002-03-28 00:00:00	2002-04-04	2002-04-04 00:00:00	32020		\N	340844	0	444814009	40481087		0
75824	4497	40481087	1977-11-27	1977-11-27 00:00:00	1977-12-11	1977-12-11 00:00:00	32020		\N	299418	0	444814009	40481087		0
75984	4506	40481087	2009-07-26	2009-07-26 00:00:00	2009-08-09	2009-08-09 00:00:00	32020		\N	300239	0	444814009	40481087		0
86764	5165	4112343	1969-08-09	1969-08-09 00:00:00	1969-08-18	1969-08-18 00:00:00	32020		\N	343288	0	195662009	4112343		0
86926	5174	4109685	1954-09-29	1954-09-29 00:00:00	1954-10-13	1954-10-13 00:00:00	32020		\N	344064	0	284551006	4109685		0
87141	5190	40481087	2008-06-12	2008-06-12 00:00:00	2008-06-26	2008-06-26 00:00:00	32020		\N	345045	0	444814009	40481087		0
87231	5194	81151	1969-03-22	1969-03-22 00:00:00	1969-04-05	1969-04-05 00:00:00	32020		\N	345405	0	44465007	81151		0
87391	5201	4112343	1987-11-05	1987-11-05 00:00:00	1987-11-16	1987-11-16 00:00:00	32020		\N	345952	0	195662009	4112343		0
87497	5206	4112343	2017-09-01	2017-09-01 00:00:00	2017-09-12	2017-09-12 00:00:00	32020		\N	346260	0	195662009	4112343		0
77157	4570	4112343	2014-02-18	2014-02-18 00:00:00	2014-03-03	2014-03-03 00:00:00	32020		\N	304433	0	195662009	4112343		0
87949	5232	40481087	2008-05-10	2008-05-10 00:00:00	2008-05-24	2008-05-24 00:00:00	32020		\N	348091	0	444814009	40481087		0
88095	5239	4294548	1991-11-14	1991-11-14 00:00:00	1992-01-02	1992-01-02 00:00:00	32020		\N	348561	0	75498004	4294548		0
88263	5249	4283893	1981-11-15	1981-11-15 00:00:00	1981-11-29	1981-11-29 00:00:00	32020		\N	349157	0	36971009	4283893		0
88360	5253	260139	1974-09-03	1974-09-03 00:00:00	1974-09-10	1974-09-10 00:00:00	32020		\N	349489	0	10509002	260139		0
88698	5274	40481087	1988-02-19	1988-02-19 00:00:00	1988-03-11	1988-03-11 00:00:00	32020		\N	350801	0	444814009	40481087		0
78352	4639	81893	2002-05-13	2002-05-13 00:00:00	\N	\N	32020		\N	309221	0	64766004	81893		0
89007	5295	80502	1990-08-08	1990-08-08 00:00:00	\N	\N	32020		\N	352293	0	64859006	80502		0
89199	5306	40481087	1973-11-12	1973-11-12 00:00:00	1973-11-26	1973-11-26 00:00:00	32020		\N	352922	0	444814009	40481087		0
89331	5314	40481087	1989-05-10	1989-05-10 00:00:00	1989-05-17	1989-05-17 00:00:00	32020		\N	353410	0	444814009	40481087		0
89619	5329	260139	1947-01-03	1947-01-03 00:00:00	1947-01-17	1947-01-17 00:00:00	32020		\N	354740	0	10509002	260139		0
89730	5334	40481087	1984-06-26	1984-06-26 00:00:00	1984-07-03	1984-07-03 00:00:00	32020		\N	355205	0	444814009	40481087		0
79657	4719	80180	1972-05-11	1972-05-11 00:00:00	\N	\N	32020		\N	314220	0	396275006	80180		0
80144	4750	40481087	1964-06-08	1964-06-08 00:00:00	1964-06-22	1964-06-22 00:00:00	32020		\N	316281	0	444814009	40481087		0
80253	4756	4152936	1991-07-18	1991-07-18 00:00:00	1991-08-01	1991-08-01 00:00:00	32020		\N	316782	0	283385000	4152936		0
81804	4852	40481087	1958-01-22	1958-01-22 00:00:00	1958-02-12	1958-02-12 00:00:00	32020		\N	322830	0	444814009	40481087		0
82158	4872	4112343	1946-07-27	1946-07-27 00:00:00	1946-08-05	1946-08-05 00:00:00	32020		\N	324039	0	195662009	4112343		0
84268	5005	260139	2013-12-08	2013-12-08 00:00:00	2013-12-15	2013-12-15 00:00:00	32020		\N	332931	0	10509002	260139		0
85389	5078	4294548	1915-07-27	1915-07-27 00:00:00	1915-08-17	1915-08-17 00:00:00	32020		\N	337563	0	75498004	4294548		0
85504	5083	4112343	1980-03-25	1980-03-25 00:00:00	1980-04-03	1980-04-03 00:00:00	32020		\N	338016	0	195662009	4112343		0
75176	4466	40481087	2010-08-10	2010-08-10 00:00:00	2010-08-31	2010-08-31 00:00:00	32020		\N	297158	0	444814009	40481087		0
85925	5113	4059173	1986-01-02	1986-01-02 00:00:00	1986-02-01	1986-02-01 00:00:00	32020		\N	339727	0	16114001	4059173		0
75418	4477	4112343	1966-11-09	1966-11-09 00:00:00	1966-11-16	1966-11-16 00:00:00	32020		\N	297962	0	195662009	4112343		0
86168	5127	372328	1971-02-11	1971-02-11 00:00:00	1971-08-27	1971-08-27 00:00:00	32020		\N	340868	0	65363002	372328		0
75825	4497	260139	2013-11-06	2013-11-06 00:00:00	2013-11-13	2013-11-13 00:00:00	32020		\N	299402	0	10509002	260139		0
75985	4506	4112343	1980-05-08	1980-05-08 00:00:00	1980-05-19	1980-05-19 00:00:00	32020		\N	300236	0	195662009	4112343		0
86765	5166	40481087	1995-06-03	1995-06-03 00:00:00	1995-06-17	1995-06-17 00:00:00	32020		\N	343461	0	444814009	40481087		0
86927	5174	81151	1939-01-18	1939-01-18 00:00:00	1939-02-22	1939-02-22 00:00:00	32020		\N	344060	0	44465007	81151		0
87142	5190	40481087	1970-05-26	1970-05-26 00:00:00	1970-06-16	1970-06-16 00:00:00	32020		\N	344993	0	444814009	40481087		0
87232	5194	4084167	1953-04-10	1953-04-10 00:00:00	1953-04-10	1953-04-10 00:00:00	32020		\N	345404	0	241929008	4084167		0
87392	5201	4112343	2005-05-16	2005-05-16 00:00:00	2005-05-23	2005-05-23 00:00:00	32020		\N	345965	0	195662009	4112343		0
87498	5206	4112343	1996-04-26	1996-04-26 00:00:00	1996-05-06	1996-05-06 00:00:00	32020		\N	346257	0	195662009	4112343		0
77158	4570	4112343	1938-02-18	1938-02-18 00:00:00	1938-03-03	1938-03-03 00:00:00	32020		\N	304508	0	195662009	4112343		0
87950	5232	260139	2003-07-09	2003-07-09 00:00:00	2003-07-16	2003-07-16 00:00:00	32020		\N	348098	0	10509002	260139		0
88096	5239	28060	2007-05-17	2007-05-17 00:00:00	2007-05-26	2007-05-26 00:00:00	32020		\N	348571	0	43878008	28060		0
88264	5249	257012	1954-12-10	1954-12-10 00:00:00	1954-12-17	1954-12-17 00:00:00	32020		\N	349181	0	40055000	257012		0
88361	5253	4112343	1993-01-03	1993-01-03 00:00:00	1993-01-14	1993-01-14 00:00:00	32020		\N	349525	0	195662009	4112343		0
88699	5274	4112343	1966-02-20	1966-02-20 00:00:00	1966-03-05	1966-03-05 00:00:00	32020		\N	350833	0	195662009	4112343		0
88811	5279	4112343	1965-02-16	1965-02-16 00:00:00	1965-02-28	1965-02-28 00:00:00	32020		\N	351145	0	195662009	4112343		0
89008	5295	40481087	1993-05-20	1993-05-20 00:00:00	1993-06-03	1993-06-03 00:00:00	32020		\N	352216	0	444814009	40481087		0
89216	5309	4112343	2003-10-19	2003-10-19 00:00:00	2003-10-26	2003-10-26 00:00:00	32020		\N	353077	0	195662009	4112343		0
89332	5314	260139	1986-11-12	1986-11-12 00:00:00	1986-11-19	1986-11-19 00:00:00	32020		\N	353390	0	10509002	260139		0
89620	5329	40481087	1957-07-28	1957-07-28 00:00:00	1957-08-04	1957-08-04 00:00:00	32020		\N	354743	0	444814009	40481087		0
89731	5334	260139	1970-10-25	1970-10-25 00:00:00	1970-11-08	1970-11-08 00:00:00	32020		\N	355204	0	10509002	260139		0
79658	4719	40481087	1935-11-03	1935-11-03 00:00:00	1935-11-17	1935-11-17 00:00:00	32020		\N	314232	0	444814009	40481087		0
80145	4750	4116491	1997-04-01	1997-04-01 00:00:00	1997-05-07	1997-05-07 00:00:00	32020		\N	316367	0	301011002	4116491		0
80254	4756	40481087	2009-12-30	2009-12-30 00:00:00	2010-01-06	2010-01-06 00:00:00	32020		\N	316816	0	444814009	40481087		0
81805	4852	372328	1950-01-24	1950-01-24 00:00:00	1950-04-13	1950-04-13 00:00:00	32020		\N	322790	0	65363002	372328		0
82159	4872	40481087	1921-12-30	1921-12-30 00:00:00	1922-01-06	1922-01-06 00:00:00	32020		\N	323959	0	444814009	40481087		0
84269	5005	40481087	2004-07-10	2004-07-10 00:00:00	2004-07-31	2004-07-31 00:00:00	32020		\N	332928	0	444814009	40481087		0
85390	5078	255848	2001-09-23	2001-09-23 00:00:00	\N	\N	32020		\N	337528	0	233604007	255848		0
85505	5083	40481087	1979-03-25	1979-03-25 00:00:00	1979-04-01	1979-04-01 00:00:00	32020		\N	338015	0	444814009	40481087		0
75177	4466	257012	1986-01-03	1986-01-03 00:00:00	\N	\N	32020		\N	297115	0	40055000	257012		0
85926	5113	4218389	2014-04-03	2014-04-03 00:00:00	2014-04-24	2014-04-24 00:00:00	32020		\N	339729	0	39848009	4218389		0
75419	4477	4112343	1974-03-27	1974-03-27 00:00:00	1974-04-04	1974-04-04 00:00:00	32020		\N	297950	0	195662009	4112343		0
86169	5128	4112343	1971-03-28	1971-03-28 00:00:00	1971-04-06	1971-04-06 00:00:00	32020		\N	341005	0	195662009	4112343		0
75826	4497	40481087	1972-08-11	1972-08-11 00:00:00	1972-08-18	1972-08-18 00:00:00	32020		\N	299417	0	444814009	40481087		0
75986	4506	80180	1992-02-28	1992-02-28 00:00:00	\N	\N	32020		\N	300229	0	396275006	80180		0
86766	5166	260139	2003-01-18	2003-01-18 00:00:00	2003-01-25	2003-01-25 00:00:00	32020		\N	343463	0	10509002	260139		0
86928	5174	260139	1960-10-26	1960-10-26 00:00:00	1960-11-09	1960-11-09 00:00:00	32020		\N	344024	0	10509002	260139		0
87143	5190	260139	2009-03-20	2009-03-20 00:00:00	2009-04-03	2009-04-03 00:00:00	32020		\N	344996	0	10509002	260139		0
87233	5194	4112343	2012-10-11	2012-10-11 00:00:00	2012-10-19	2012-10-19 00:00:00	32020		\N	345352	0	195662009	4112343		0
87393	5201	260139	2001-10-21	2001-10-21 00:00:00	2001-10-28	2001-10-28 00:00:00	32020		\N	345975	0	10509002	260139		0
87499	5206	40481087	2006-12-27	2006-12-27 00:00:00	2007-01-17	2007-01-17 00:00:00	32020		\N	346259	0	444814009	40481087		0
77159	4571	40481087	1992-01-30	1992-01-30 00:00:00	1992-02-06	1992-02-06 00:00:00	32020		\N	304526	0	444814009	40481087		0
87951	5232	4059173	2016-09-19	2016-09-19 00:00:00	2016-11-18	2016-11-18 00:00:00	32020		\N	348067	0	16114001	4059173		0
88097	5239	4059173	1972-08-19	1972-08-19 00:00:00	1972-10-18	1972-10-18 00:00:00	32020		\N	348556	0	16114001	4059173		0
88278	5251	260139	1954-04-12	1954-04-12 00:00:00	1954-04-27	1954-04-27 00:00:00	32020		\N	349310	0	10509002	260139		0
88362	5253	4310024	1993-03-30	1993-03-30 00:00:00	\N	\N	32020		\N	349525	0	424802006	4310024		0
88700	5274	4278672	2006-06-16	2006-06-16 00:00:00	2006-09-14	2006-09-14 00:00:00	32020		\N	350844	0	65966004	4278672		0
88812	5279	260139	1975-08-07	1975-08-07 00:00:00	1975-08-21	1975-08-21 00:00:00	32020		\N	351146	0	10509002	260139		0
89009	5295	4134304	1971-02-18	1971-02-18 00:00:00	1971-04-19	1971-04-19 00:00:00	32020		\N	352210	0	263102004	4134304		0
89217	5309	40481087	1980-09-15	1980-09-15 00:00:00	1980-09-29	1980-09-29 00:00:00	32020		\N	353073	0	444814009	40481087		0
89333	5314	40481087	1971-07-04	1971-07-04 00:00:00	1971-07-18	1971-07-18 00:00:00	32020		\N	353417	0	444814009	40481087		0
89621	5329	40481087	1986-09-03	1986-09-03 00:00:00	1986-09-24	1986-09-24 00:00:00	32020		\N	354755	0	444814009	40481087		0
89732	5334	81151	1986-06-23	1986-06-23 00:00:00	1986-07-21	1986-07-21 00:00:00	32020		\N	355192	0	44465007	81151		0
79659	4719	40481087	2000-08-01	2000-08-01 00:00:00	2000-08-22	2000-08-22 00:00:00	32020		\N	314285	0	444814009	40481087		0
80146	4750	4112343	1973-02-19	1973-02-19 00:00:00	1973-03-03	1973-03-03 00:00:00	32020		\N	316284	0	195662009	4112343		0
80255	4756	40481087	1996-01-02	1996-01-02 00:00:00	1996-01-09	1996-01-09 00:00:00	32020		\N	316787	0	444814009	40481087		0
81806	4852	4027663	1981-10-28	1981-10-28 00:00:00	\N	\N	32020		\N	322824	0	13200003	4027663		0
82160	4872	195588	1953-07-25	1953-07-25 00:00:00	1953-09-01	1953-09-01 00:00:00	32020		\N	323989	0	38822007	195588		0
84270	5005	81151	1986-02-23	1986-02-23 00:00:00	1986-03-09	1986-03-09 00:00:00	32020		\N	332908	0	44465007	81151		0
85391	5078	40481087	1925-11-27	1925-11-27 00:00:00	1925-12-18	1925-12-18 00:00:00	32020		\N	337612	0	444814009	40481087		0
85506	5083	257012	2000-11-11	2000-11-11 00:00:00	\N	\N	32020		\N	338029	0	40055000	257012		0
75178	4466	80180	2008-02-09	2008-02-09 00:00:00	\N	\N	32020		\N	297147	0	396275006	80180		0
85928	5113	4029498	1974-03-14	1974-03-14 00:00:00	\N	\N	32020		\N	339723	0	128613002	4029498		0
75420	4477	260139	2009-12-21	2009-12-21 00:00:00	2010-01-04	2010-01-04 00:00:00	32020		\N	297951	0	10509002	260139		0
86170	5128	4113008	1983-05-28	1983-05-28 00:00:00	1983-06-18	1983-06-18 00:00:00	32020		\N	340919	0	284549007	4113008		0
75827	4497	81151	1978-01-31	1978-01-31 00:00:00	1978-03-07	1978-03-07 00:00:00	32020		\N	299368	0	44465007	81151		0
75987	4506	260139	1960-02-22	1960-02-22 00:00:00	1960-03-07	1960-03-07 00:00:00	32020		\N	300169	0	10509002	260139		0
86767	5166	81151	1989-05-24	1989-05-24 00:00:00	1989-06-28	1989-06-28 00:00:00	32020		\N	343402	0	44465007	81151		0
86929	5174	4059173	1947-02-08	1947-02-08 00:00:00	1947-03-10	1947-03-10 00:00:00	32020		\N	344063	0	16114001	4059173		0
87144	5190	28060	1974-10-21	1974-10-21 00:00:00	1974-10-31	1974-10-31 00:00:00	32020		\N	344974	0	43878008	28060		0
87234	5194	40481087	1972-03-21	1972-03-21 00:00:00	1972-03-28	1972-03-28 00:00:00	32020		\N	345310	0	444814009	40481087		0
87394	5201	40481087	1980-12-28	1980-12-28 00:00:00	1981-01-11	1981-01-11 00:00:00	32020		\N	345961	0	444814009	40481087		0
87500	5206	80180	2017-10-26	2017-10-26 00:00:00	\N	\N	32020		\N	346261	0	396275006	80180		0
77160	4571	260139	2000-08-03	2000-08-03 00:00:00	2000-08-10	2000-08-10 00:00:00	32020		\N	304592	0	10509002	260139		0
87952	5232	260139	2007-11-15	2007-11-15 00:00:00	2007-11-22	2007-11-22 00:00:00	32020		\N	348090	0	10509002	260139		0
88098	5239	257012	1991-11-28	1991-11-28 00:00:00	\N	\N	32020		\N	348569	0	40055000	257012		0
88279	5251	28060	1933-01-04	1933-01-04 00:00:00	1933-01-11	1933-01-11 00:00:00	32020		\N	349338	0	43878008	28060		0
88363	5253	4112343	1990-11-03	1990-11-03 00:00:00	1990-11-14	1990-11-14 00:00:00	32020		\N	349542	0	195662009	4112343		0
88701	5274	4296204	1966-02-22	1966-02-22 00:00:00	1966-03-22	1966-03-22 00:00:00	32020		\N	350840	0	403190006	4296204		0
88813	5279	4112343	1973-10-28	1973-10-28 00:00:00	1973-11-05	1973-11-05 00:00:00	32020		\N	351171	0	195662009	4112343		0
89010	5295	40481087	1942-02-07	1942-02-07 00:00:00	1942-02-21	1942-02-21 00:00:00	32020		\N	352300	0	444814009	40481087		0
89218	5309	40481087	1993-03-20	1993-03-20 00:00:00	1993-04-10	1993-04-10 00:00:00	32020		\N	353075	0	444814009	40481087		0
89334	5314	80180	1992-10-04	1992-10-04 00:00:00	\N	\N	32020		\N	353375	0	396275006	80180		0
89622	5329	40481087	1973-08-21	1973-08-21 00:00:00	1973-09-11	1973-09-11 00:00:00	32020		\N	354761	0	444814009	40481087		0
89733	5334	260139	1988-02-01	1988-02-01 00:00:00	1988-02-08	1988-02-08 00:00:00	32020		\N	355177	0	10509002	260139		0
79660	4719	260139	1953-01-28	1953-01-28 00:00:00	1953-02-11	1953-02-11 00:00:00	32020		\N	314288	0	10509002	260139		0
80147	4750	4112343	1973-11-29	1973-11-29 00:00:00	1973-12-12	1973-12-12 00:00:00	32020		\N	316285	0	195662009	4112343		0
80256	4756	4112343	1946-10-11	1946-10-11 00:00:00	1946-10-22	1946-10-22 00:00:00	32020		\N	316826	0	195662009	4112343		0
81807	4852	260139	1951-10-17	1951-10-17 00:00:00	1951-10-24	1951-10-24 00:00:00	32020		\N	322846	0	10509002	260139		0
82161	4872	40481087	1939-10-29	1939-10-29 00:00:00	1939-11-12	1939-11-12 00:00:00	32020		\N	323974	0	444814009	40481087		0
84271	5005	4283893	2012-10-19	2012-10-19 00:00:00	2013-04-19	2013-04-19 00:00:00	32020		\N	332913	0	36971009	4283893		0
85392	5078	4035415	1997-09-02	1997-09-02 00:00:00	1997-10-02	1997-10-02 00:00:00	32020		\N	337629	0	239720000	4035415		0
85507	5083	4156265	2011-06-08	2011-06-08 00:00:00	2011-06-22	2011-06-22 00:00:00	32020		\N	338031	0	370247008	4156265		0
75179	4466	4112343	2006-05-18	2006-05-18 00:00:00	2006-05-26	2006-05-26 00:00:00	32020		\N	297147	0	195662009	4112343		0
85929	5113	40481087	1990-10-13	1990-10-13 00:00:00	1990-11-03	1990-11-03 00:00:00	32020		\N	339678	0	444814009	40481087		0
75421	4477	40481087	1988-05-04	1988-05-04 00:00:00	1988-05-25	1988-05-25 00:00:00	32020		\N	297966	0	444814009	40481087		0
86171	5128	4112343	1994-10-17	1994-10-17 00:00:00	1994-10-30	1994-10-30 00:00:00	32020		\N	340996	0	195662009	4112343		0
75828	4497	4027663	1982-09-19	1982-09-19 00:00:00	\N	\N	32020		\N	299348	0	13200003	4027663		0
75988	4506	4112343	2017-08-04	2017-08-04 00:00:00	2017-08-11	2017-08-11 00:00:00	32020		\N	300180	0	195662009	4112343		0
86768	5166	4112343	2004-02-17	2004-02-17 00:00:00	2004-02-26	2004-02-26 00:00:00	32020		\N	343464	0	195662009	4112343		0
86930	5174	4116491	1966-01-21	1966-01-21 00:00:00	1966-02-27	1966-02-27 00:00:00	32020		\N	344038	0	301011002	4116491		0
87145	5190	78272	1965-03-09	1965-03-09 00:00:00	1965-03-23	1965-03-23 00:00:00	32020		\N	345058	0	70704007	78272		0
87235	5194	372328	1949-10-21	1949-10-21 00:00:00	1950-06-01	1950-06-01 00:00:00	32020		\N	345385	0	65363002	372328		0
87395	5201	4112343	1980-10-25	1980-10-25 00:00:00	1980-11-07	1980-11-07 00:00:00	32020		\N	345951	0	195662009	4112343		0
87501	5206	40481087	2017-10-26	2017-10-26 00:00:00	2017-11-09	2017-11-09 00:00:00	32020		\N	346261	0	444814009	40481087		0
77161	4571	4116491	2004-06-13	2004-06-13 00:00:00	2004-08-03	2004-08-03 00:00:00	32020		\N	304593	0	301011002	4116491		0
87953	5232	4112343	2004-01-12	2004-01-12 00:00:00	2004-01-25	2004-01-25 00:00:00	32020		\N	348084	0	195662009	4112343		0
88099	5239	4094814	1979-02-14	1979-02-14 00:00:00	1979-05-15	1979-05-15 00:00:00	32020		\N	348557	0	262574004	4094814		0
88280	5251	81151	1928-11-13	1928-11-13 00:00:00	1928-12-11	1928-12-11 00:00:00	32020		\N	349381	0	44465007	81151		0
88364	5253	195588	1994-11-30	1994-11-30 00:00:00	1995-01-26	1995-01-26 00:00:00	32020		\N	349544	0	38822007	195588		0
88702	5274	40481087	1999-03-21	1999-03-21 00:00:00	1999-04-04	1999-04-04 00:00:00	32020		\N	350780	0	444814009	40481087		0
88814	5279	260139	1954-05-16	1954-05-16 00:00:00	1954-05-30	1954-05-30 00:00:00	32020		\N	351181	0	10509002	260139		0
89011	5295	4112343	1934-01-26	1934-01-26 00:00:00	1934-02-06	1934-02-06 00:00:00	32020		\N	352271	0	195662009	4112343		0
89219	5309	40479768	1955-08-06	1955-08-06 00:00:00	1955-09-12	1955-09-12 00:00:00	32020		\N	353143	0	444470001	40479768		0
89335	5314	4285898	1992-01-08	1992-01-08 00:00:00	\N	\N	32020		\N	353375	0	68496003	4285898		0
89623	5329	81151	2011-02-25	2011-02-25 00:00:00	2011-03-25	2011-03-25 00:00:00	32020		\N	354835	0	44465007	81151		0
89734	5334	28060	2008-11-25	2008-11-25 00:00:00	2008-12-07	2008-12-07 00:00:00	32020		\N	355198	0	43878008	28060		0
79661	4719	257012	1945-04-15	1945-04-15 00:00:00	\N	\N	32020		\N	314234	0	40055000	257012		0
80148	4750	4112343	1998-11-13	1998-11-13 00:00:00	1998-11-26	1998-11-26 00:00:00	32020		\N	316296	0	195662009	4112343		0
80257	4756	378419	2018-12-01	2018-12-01 00:00:00	\N	\N	32020		\N	316860	0	26929004	378419		0
81808	4852	4112343	1990-01-02	1990-01-02 00:00:00	1990-01-15	1990-01-15 00:00:00	32020		\N	322775	0	195662009	4112343		0
82162	4872	260139	2005-12-21	2005-12-21 00:00:00	2006-01-04	2006-01-04 00:00:00	32020		\N	324012	0	10509002	260139		0
84272	5005	372328	1980-07-24	1980-07-24 00:00:00	1981-06-28	1981-06-28 00:00:00	32020		\N	332937	0	65363002	372328		0
85393	5078	4112343	1979-01-09	1979-01-09 00:00:00	1979-01-20	1979-01-20 00:00:00	32020		\N	337575	0	195662009	4112343		0
85508	5083	4283893	2008-05-10	2008-05-10 00:00:00	2008-06-28	2008-06-28 00:00:00	32020		\N	338030	0	36971009	4283893		0
75180	4466	40481087	1981-01-02	1981-01-02 00:00:00	1981-01-23	1981-01-23 00:00:00	32020		\N	297152	0	444814009	40481087		0
85930	5113	4112343	1989-10-17	1989-10-17 00:00:00	1989-10-26	1989-10-26 00:00:00	32020		\N	339667	0	195662009	4112343		0
75422	4477	40481087	2006-08-06	2006-08-06 00:00:00	2006-08-20	2006-08-20 00:00:00	32020		\N	297984	0	444814009	40481087		0
86172	5128	4112343	2017-08-20	2017-08-20 00:00:00	2017-08-30	2017-08-30 00:00:00	32020		\N	341008	0	195662009	4112343		0
75829	4497	372328	1974-01-11	1974-01-11 00:00:00	1974-11-19	1974-11-19 00:00:00	32020		\N	299387	0	65363002	372328		0
75989	4506	4230399	2001-10-13	2001-10-13 00:00:00	2001-12-12	2001-12-12 00:00:00	32020		\N	300228	0	359817006	4230399		0
86769	5166	4278672	1966-05-25	1966-05-25 00:00:00	1966-08-23	1966-08-23 00:00:00	32020		\N	343400	0	65966004	4278672		0
86931	5174	40481087	1948-07-25	1948-07-25 00:00:00	1948-08-15	1948-08-15 00:00:00	32020		\N	344023	0	444814009	40481087		0
87146	5190	40481087	1987-05-30	1987-05-30 00:00:00	1987-06-06	1987-06-06 00:00:00	32020		\N	345042	0	444814009	40481087		0
87236	5194	28060	1948-12-15	1948-12-15 00:00:00	1948-12-24	1948-12-24 00:00:00	32020		\N	345297	0	43878008	28060		0
87396	5201	372328	1979-06-29	1979-06-29 00:00:00	1979-08-08	1979-08-08 00:00:00	32020		\N	345963	0	65363002	372328		0
87502	5206	4112343	1983-10-28	1983-10-28 00:00:00	1983-11-05	1983-11-05 00:00:00	32020		\N	346263	0	195662009	4112343		0
77162	4571	260139	2018-03-11	2018-03-11 00:00:00	2018-03-25	2018-03-25 00:00:00	32020		\N	304562	0	10509002	260139		0
87954	5232	40481087	1991-12-22	1991-12-22 00:00:00	1992-01-05	1992-01-05 00:00:00	32020		\N	348064	0	444814009	40481087		0
88100	5239	372328	1971-07-02	1971-07-02 00:00:00	1971-11-10	1971-11-10 00:00:00	32020		\N	348584	0	65363002	372328		0
88281	5251	40481087	1938-09-21	1938-09-21 00:00:00	1938-10-12	1938-10-12 00:00:00	32020		\N	349339	0	444814009	40481087		0
88365	5253	258780	1983-04-23	1983-04-23 00:00:00	\N	\N	32020		\N	349532	0	185086009	258780		0
88703	5274	375671	2013-07-09	2013-07-09 00:00:00	2013-09-07	2013-09-07 00:00:00	32020		\N	350845	0	62564004	375671		0
88815	5279	40481087	1958-05-30	1958-05-30 00:00:00	1958-06-13	1958-06-13 00:00:00	32020		\N	351144	0	444814009	40481087		0
89012	5295	375671	1973-04-08	1973-04-08 00:00:00	1973-05-08	1973-05-08 00:00:00	32020		\N	352211	0	62564004	375671		0
89220	5309	40481087	1996-01-31	1996-01-31 00:00:00	1996-02-14	1996-02-14 00:00:00	32020		\N	353076	0	444814009	40481087		0
89336	5314	4156265	1997-05-05	1997-05-05 00:00:00	1997-05-26	1997-05-26 00:00:00	32020		\N	353457	0	370247008	4156265		0
89624	5329	40481087	1959-01-05	1959-01-05 00:00:00	1959-01-19	1959-01-19 00:00:00	32020		\N	354756	0	444814009	40481087		0
89735	5334	372328	1964-10-16	1964-10-16 00:00:00	1965-01-27	1965-01-27 00:00:00	32020		\N	355231	0	65363002	372328		0
79662	4719	260139	1966-07-05	1966-07-05 00:00:00	1966-07-12	1966-07-12 00:00:00	32020		\N	314189	0	10509002	260139		0
80149	4750	4285898	2000-03-16	2000-03-16 00:00:00	\N	\N	32020		\N	316296	0	68496003	4285898		0
80258	4756	4112343	1990-02-03	1990-02-03 00:00:00	1990-02-11	1990-02-11 00:00:00	32020		\N	316844	0	195662009	4112343		0
81809	4852	4112343	1995-04-23	1995-04-23 00:00:00	1995-05-05	1995-05-05 00:00:00	32020		\N	322855	0	195662009	4112343		0
82163	4872	260139	1968-03-01	1968-03-01 00:00:00	1968-03-08	1968-03-08 00:00:00	32020		\N	324010	0	10509002	260139		0
84281	5007	4294548	1999-11-18	1999-11-18 00:00:00	1999-11-25	1999-11-25 00:00:00	32020		\N	333025	0	75498004	4294548		0
85394	5078	260139	1973-04-22	1973-04-22 00:00:00	1973-05-06	1973-05-06 00:00:00	32020		\N	337503	0	10509002	260139		0
85509	5083	81151	1949-08-22	1949-08-22 00:00:00	1949-09-05	1949-09-05 00:00:00	32020		\N	337989	0	44465007	81151		0
75181	4466	372328	1977-07-31	1977-07-31 00:00:00	1977-09-16	1977-09-16 00:00:00	32020		\N	297118	0	65363002	372328		0
85931	5113	4112343	2007-01-10	2007-01-10 00:00:00	2007-01-19	2007-01-19 00:00:00	32020		\N	339668	0	195662009	4112343		0
75423	4477	40481087	1969-06-29	1969-06-29 00:00:00	1969-07-20	1969-07-20 00:00:00	32020		\N	297949	0	444814009	40481087		0
86173	5128	321042	1955-07-27	1955-07-27 00:00:00	\N	\N	32020		\N	340918	0	410429000	321042		0
75830	4497	4112343	1962-04-29	1962-04-29 00:00:00	1962-05-10	1962-05-10 00:00:00	32020		\N	299415	0	195662009	4112343		0
75990	4506	4134304	1955-11-14	1955-11-14 00:00:00	1956-01-13	1956-01-13 00:00:00	32020		\N	300227	0	263102004	4134304		0
86770	5166	40481087	1967-11-21	1967-11-21 00:00:00	1967-11-28	1967-11-28 00:00:00	32020		\N	343437	0	444814009	40481087		0
86932	5174	80502	1997-03-27	1997-03-27 00:00:00	\N	\N	32020		\N	344008	0	64859006	80502		0
87147	5190	4112343	1964-07-24	1964-07-24 00:00:00	1964-07-31	1964-07-31 00:00:00	32020		\N	345026	0	195662009	4112343		0
87237	5194	260139	2000-05-08	2000-05-08 00:00:00	2000-05-15	2000-05-15 00:00:00	32020		\N	345400	0	10509002	260139		0
87397	5201	40481087	2015-05-13	2015-05-13 00:00:00	2015-06-03	2015-06-03 00:00:00	32020		\N	345962	0	444814009	40481087		0
87503	5206	260139	1980-11-25	1980-11-25 00:00:00	1980-12-09	1980-12-09 00:00:00	32020		\N	346254	0	10509002	260139		0
77163	4571	40481087	1959-07-05	1959-07-05 00:00:00	1959-07-26	1959-07-26 00:00:00	32020		\N	304557	0	444814009	40481087		0
87955	5232	4112343	1968-09-15	1968-09-15 00:00:00	1968-09-23	1968-09-23 00:00:00	32020		\N	348081	0	195662009	4112343		0
88101	5239	81893	2010-03-08	2010-03-08 00:00:00	\N	\N	32020		\N	348572	0	64766004	81893		0
88282	5251	4112343	1947-12-11	1947-12-11 00:00:00	1947-12-20	1947-12-20 00:00:00	32020		\N	349334	0	195662009	4112343		0
88366	5253	40481087	1976-02-10	1976-02-10 00:00:00	1976-02-24	1976-02-24 00:00:00	32020		\N	349483	0	444814009	40481087		0
88704	5274	260139	1998-03-16	1998-03-16 00:00:00	1998-03-30	1998-03-30 00:00:00	32020		\N	350836	0	10509002	260139		0
88816	5279	40481087	1967-11-01	1967-11-01 00:00:00	1967-11-22	1967-11-22 00:00:00	32020		\N	351232	0	444814009	40481087		0
89013	5295	80180	1943-02-08	1943-02-08 00:00:00	\N	\N	32020		\N	352323	0	396275006	80180		0
89221	5309	4112343	1998-01-06	1998-01-06 00:00:00	1998-01-15	1998-01-15 00:00:00	32020		\N	353088	0	195662009	4112343		0
89337	5314	40481087	1960-07-10	1960-07-10 00:00:00	1960-07-17	1960-07-17 00:00:00	32020		\N	353419	0	444814009	40481087		0
89625	5329	260139	1960-05-12	1960-05-12 00:00:00	1960-05-19	1960-05-19 00:00:00	32020		\N	354744	0	10509002	260139		0
89736	5334	40481087	1993-02-21	1993-02-21 00:00:00	1993-03-14	1993-03-14 00:00:00	32020		\N	355194	0	444814009	40481087		0
79663	4719	40481087	1999-09-16	1999-09-16 00:00:00	1999-09-30	1999-09-30 00:00:00	32020		\N	314331	0	444814009	40481087		0
80150	4750	80180	2000-05-15	2000-05-15 00:00:00	\N	\N	32020		\N	316296	0	396275006	80180		0
80259	4756	81151	1994-08-15	1994-08-15 00:00:00	1994-09-12	1994-09-12 00:00:00	32020		\N	316783	0	44465007	81151		0
81810	4852	40481087	1986-10-24	1986-10-24 00:00:00	1986-10-30	1986-10-30 00:00:00	32020		\N	322834	0	444814009	40481087		0
82164	4872	28060	1971-08-08	1971-08-08 00:00:00	1971-08-19	1971-08-19 00:00:00	32020		\N	324028	0	43878008	28060		0
84282	5007	4112343	2013-07-06	2013-07-06 00:00:00	2013-07-17	2013-07-17 00:00:00	32020		\N	333011	0	195662009	4112343		0
85395	5078	4294548	1939-09-02	1939-09-02 00:00:00	1939-09-23	1939-09-23 00:00:00	32020		\N	337637	0	75498004	4294548		0
85510	5083	4283893	1975-06-15	1975-06-15 00:00:00	1975-09-07	1975-09-07 00:00:00	32020		\N	338013	0	36971009	4283893		0
75182	4466	260139	1996-07-16	1996-07-16 00:00:00	1996-07-30	1996-07-30 00:00:00	32020		\N	297156	0	10509002	260139		0
85932	5113	4112343	1985-04-30	1985-04-30 00:00:00	1985-05-10	1985-05-10 00:00:00	32020		\N	339677	0	195662009	4112343		0
75424	4477	40481087	1974-08-02	1974-08-02 00:00:00	1974-08-23	1974-08-23 00:00:00	32020		\N	297981	0	444814009	40481087		0
86175	5128	4283893	1983-12-07	1983-12-07 00:00:00	1984-01-04	1984-01-04 00:00:00	32020		\N	340974	0	36971009	4283893		0
75831	4497	4112343	1983-02-12	1983-02-12 00:00:00	1983-02-25	1983-02-25 00:00:00	32020		\N	299356	0	195662009	4112343		0
75991	4506	40481087	1983-12-21	1983-12-21 00:00:00	1984-01-04	1984-01-04 00:00:00	32020		\N	300161	0	444814009	40481087		0
86771	5166	4134304	1992-03-14	1992-03-14 00:00:00	1992-06-12	1992-06-12 00:00:00	32020		\N	343403	0	263102004	4134304		0
86933	5174	372328	1938-08-21	1938-08-21 00:00:00	1939-01-05	1939-01-05 00:00:00	32020		\N	344027	0	65363002	372328		0
87148	5190	378001	2005-01-04	2005-01-04 00:00:00	2005-03-05	2005-03-05 00:00:00	32020		\N	345054	0	62106007	378001		0
87238	5194	4112343	1953-08-03	1953-08-03 00:00:00	1953-08-11	1953-08-11 00:00:00	32020		\N	345287	0	195662009	4112343		0
87398	5201	260139	1982-01-26	1982-01-26 00:00:00	1982-02-02	1982-02-02 00:00:00	32020		\N	345964	0	10509002	260139		0
87504	5206	40481087	1985-09-03	1985-09-03 00:00:00	1985-09-10	1985-09-10 00:00:00	32020		\N	346269	0	444814009	40481087		0
77164	4571	28060	1958-02-09	1958-02-09 00:00:00	1958-02-19	1958-02-19 00:00:00	32020		\N	304556	0	43878008	28060		0
87956	5232	28060	1978-02-04	1978-02-04 00:00:00	1978-02-13	1978-02-13 00:00:00	32020		\N	348096	0	43878008	28060		0
88102	5239	40481087	2008-11-20	2008-11-20 00:00:00	2008-12-11	2008-12-11 00:00:00	32020		\N	348572	0	444814009	40481087		0
88283	5251	40481087	1959-11-19	1959-11-19 00:00:00	1959-12-10	1959-12-10 00:00:00	32020		\N	349319	0	444814009	40481087		0
88367	5253	4237458	1971-04-20	1971-04-20 00:00:00	1971-05-20	1971-05-20 00:00:00	32020		\N	349571	0	58150001	4237458		0
88705	5274	4112343	2002-10-01	2002-10-01 00:00:00	2002-10-08	2002-10-08 00:00:00	32020		\N	350768	0	195662009	4112343		0
88817	5279	375671	1976-02-24	1976-02-24 00:00:00	1976-03-25	1976-03-25 00:00:00	32020		\N	351136	0	62564004	375671		0
89014	5295	4112343	1937-11-18	1937-11-18 00:00:00	1937-12-01	1937-12-01 00:00:00	32020		\N	352299	0	195662009	4112343		0
89222	5309	4112343	1996-01-06	1996-01-06 00:00:00	1996-01-13	1996-01-13 00:00:00	32020		\N	353118	0	195662009	4112343		0
89338	5314	260139	1962-08-03	1962-08-03 00:00:00	1962-08-10	1962-08-10 00:00:00	32020		\N	353395	0	10509002	260139		0
89626	5329	4112343	1950-06-18	1950-06-18 00:00:00	1950-06-29	1950-06-29 00:00:00	32020		\N	354800	0	195662009	4112343		0
89737	5334	260139	1967-12-01	1967-12-01 00:00:00	1967-12-08	1967-12-08 00:00:00	32020		\N	355203	0	10509002	260139		0
79664	4719	4152936	2013-12-24	2013-12-24 00:00:00	2014-01-07	2014-01-07 00:00:00	32020		\N	314299	0	283385000	4152936		0
80151	4750	81151	2014-04-12	2014-04-12 00:00:00	2014-05-17	2014-05-17 00:00:00	32020		\N	316317	0	44465007	81151		0
80260	4756	4296204	1969-05-25	1969-05-25 00:00:00	1969-06-22	1969-06-22 00:00:00	32020		\N	316861	0	403190006	4296204		0
81811	4852	30753	1989-07-24	1989-07-24 00:00:00	\N	\N	32020		\N	322812	0	16761005	30753		0
82165	4872	4112343	1976-05-08	1976-05-08 00:00:00	1976-05-16	1976-05-16 00:00:00	32020		\N	324029	0	195662009	4112343		0
84283	5007	40481087	1994-08-03	1994-08-03 00:00:00	1994-08-17	1994-08-17 00:00:00	32020		\N	333022	0	444814009	40481087		0
85396	5078	81151	1981-03-06	1981-03-06 00:00:00	1981-04-03	1981-04-03 00:00:00	32020		\N	337525	0	44465007	81151		0
85511	5083	4027663	1975-11-10	1975-11-10 00:00:00	\N	\N	32020		\N	338014	0	13200003	4027663		0
75183	4466	192671	2008-04-25	2008-04-25 00:00:00	\N	\N	32020		\N	297104	0	K92.2	35208414		0
85933	5113	40481087	1990-05-23	1990-05-23 00:00:00	1990-06-06	1990-06-06 00:00:00	32020		\N	339718	0	444814009	40481087		0
75425	4477	4059173	1967-08-30	1967-08-30 00:00:00	1967-09-29	1967-09-29 00:00:00	32020		\N	297911	0	16114001	4059173		0
86176	5128	4230399	2019-05-08	2019-05-08 00:00:00	2019-06-07	2019-06-07 00:00:00	32020		\N	340922	0	359817006	4230399		0
75832	4498	4112343	1982-11-04	1982-11-04 00:00:00	1982-11-12	1982-11-12 00:00:00	32020		\N	299466	0	195662009	4112343		0
75992	4506	372328	1959-01-27	1959-01-27 00:00:00	1959-12-10	1959-12-10 00:00:00	32020		\N	300211	0	65363002	372328		0
86772	5166	260139	1998-06-03	1998-06-03 00:00:00	1998-06-17	1998-06-17 00:00:00	32020		\N	343462	0	10509002	260139		0
86934	5174	30753	1980-02-12	1980-02-12 00:00:00	\N	\N	32020		\N	343996	0	16761005	30753		0
87149	5190	4109685	1971-05-21	1971-05-21 00:00:00	1971-06-04	1971-06-04 00:00:00	32020		\N	345051	0	284551006	4109685		0
87239	5194	4112343	1975-06-03	1975-06-03 00:00:00	1975-06-12	1975-06-12 00:00:00	32020		\N	345318	0	195662009	4112343		0
87399	5201	40481087	1984-07-29	1984-07-29 00:00:00	1984-08-05	1984-08-05 00:00:00	32020		\N	345979	0	444814009	40481087		0
87505	5206	28060	1981-12-21	1981-12-21 00:00:00	1982-01-02	1982-01-02 00:00:00	32020		\N	346290	0	43878008	28060		0
77165	4571	4109685	1979-02-06	1979-02-06 00:00:00	1979-02-27	1979-02-27 00:00:00	32020		\N	304553	0	284551006	4109685		0
87957	5232	372328	1969-01-29	1969-01-29 00:00:00	1969-03-15	1969-03-15 00:00:00	32020		\N	348068	0	65363002	372328		0
88103	5239	4310024	2009-05-12	2009-05-12 00:00:00	\N	\N	32020		\N	348572	0	424802006	4310024		0
88284	5251	40481087	1927-07-31	1927-07-31 00:00:00	1927-08-14	1927-08-14 00:00:00	32020		\N	349361	0	444814009	40481087		0
88368	5253	4112343	1956-03-13	1956-03-13 00:00:00	1956-03-26	1956-03-26 00:00:00	32020		\N	349559	0	195662009	4112343		0
88706	5274	4112343	1954-11-26	1954-11-26 00:00:00	1954-12-06	1954-12-06 00:00:00	32020		\N	350822	0	195662009	4112343		0
88818	5279	378001	1999-03-25	1999-03-25 00:00:00	1999-04-24	1999-04-24 00:00:00	32020		\N	351137	0	62106007	378001		0
89015	5295	381316	1982-07-07	1982-07-07 00:00:00	\N	\N	32020		\N	352312	0	230690007	381316		0
89223	5309	195588	1977-01-22	1977-01-22 00:00:00	1977-03-04	1977-03-04 00:00:00	32020		\N	353062	0	38822007	195588		0
89339	5314	40481087	1953-01-20	1953-01-20 00:00:00	1953-02-10	1953-02-10 00:00:00	32020		\N	353418	0	444814009	40481087		0
89627	5329	40481087	2004-10-12	2004-10-12 00:00:00	2004-11-02	2004-11-02 00:00:00	32020		\N	354763	0	444814009	40481087		0
89738	5334	40481087	2007-04-05	2007-04-05 00:00:00	2007-04-19	2007-04-19 00:00:00	32020		\N	355178	0	444814009	40481087		0
79665	4719	40481087	1979-04-11	1979-04-11 00:00:00	1979-05-02	1979-05-02 00:00:00	32020		\N	314250	0	444814009	40481087		0
80165	4753	372328	1966-03-26	1966-03-26 00:00:00	1966-06-29	1966-06-29 00:00:00	32020		\N	316572	0	65363002	372328		0
80261	4756	4112343	1946-12-24	1946-12-24 00:00:00	1947-01-02	1947-01-02 00:00:00	32020		\N	316862	0	195662009	4112343		0
81812	4852	4310024	1989-02-23	1989-02-23 00:00:00	\N	\N	32020		\N	322812	0	424802006	4310024		0
82166	4872	40481087	1955-12-10	1955-12-10 00:00:00	1955-12-31	1955-12-31 00:00:00	32020		\N	323978	0	444814009	40481087		0
84284	5007	40481087	2005-02-05	2005-02-05 00:00:00	2005-02-12	2005-02-12 00:00:00	32020		\N	333000	0	444814009	40481087		0
85397	5078	4112343	1936-04-20	1936-04-20 00:00:00	1936-05-01	1936-05-01 00:00:00	32020		\N	337635	0	195662009	4112343		0
85512	5083	4059173	1995-06-02	1995-06-02 00:00:00	1995-07-02	1995-07-02 00:00:00	32020		\N	337992	0	16114001	4059173		0
75184	4466	40481087	2012-02-28	2012-02-28 00:00:00	2012-03-20	2012-03-20 00:00:00	32020		\N	297117	0	444814009	40481087		0
85934	5113	4109685	1978-12-28	1978-12-28 00:00:00	1979-01-18	1979-01-18 00:00:00	32020		\N	339725	0	284551006	4109685		0
75426	4477	81151	1964-09-16	1964-09-16 00:00:00	1964-10-14	1964-10-14 00:00:00	32020		\N	297910	0	44465007	81151		0
86177	5128	40480160	2019-05-08	2019-05-08 00:00:00	2019-06-07	2019-06-07 00:00:00	32020		\N	340922	0	443165006	40480160		0
75833	4498	40481087	2016-12-06	2016-12-06 00:00:00	2016-12-27	2016-12-27 00:00:00	32020		\N	299471	0	444814009	40481087		0
75993	4506	4283893	1981-10-18	1981-10-18 00:00:00	1982-06-20	1982-06-20 00:00:00	32020		\N	300205	0	36971009	4283893		0
86773	5166	260139	1969-10-31	1969-10-31 00:00:00	1969-11-07	1969-11-07 00:00:00	32020		\N	343438	0	10509002	260139		0
86935	5174	80180	1981-01-07	1981-01-07 00:00:00	\N	\N	32020		\N	343996	0	396275006	80180		0
87150	5190	81151	1986-03-17	1986-03-17 00:00:00	1986-03-31	1986-03-31 00:00:00	32020		\N	345052	0	44465007	81151		0
87240	5194	81151	1952-01-16	1952-01-16 00:00:00	1952-02-20	1952-02-20 00:00:00	32020		\N	345403	0	44465007	81151		0
87400	5201	198199	2015-03-27	2015-03-27 00:00:00	2015-05-19	2015-05-19 00:00:00	32020		\N	345966	0	45816000	198199		0
87506	5207	260139	2017-02-06	2017-02-06 00:00:00	2017-02-20	2017-02-20 00:00:00	32020		\N	346366	0	10509002	260139		0
77166	4571	80180	1995-04-02	1995-04-02 00:00:00	\N	\N	32020		\N	304546	0	396275006	80180		0
87958	5232	4112343	1968-04-06	1968-04-06 00:00:00	1968-04-15	1968-04-15 00:00:00	32020		\N	348087	0	195662009	4112343		0
88104	5239	260139	1968-10-11	1968-10-11 00:00:00	1968-10-18	1968-10-18 00:00:00	32020		\N	348547	0	10509002	260139		0
88285	5251	40481087	1964-05-07	1964-05-07 00:00:00	1964-05-21	1964-05-21 00:00:00	32020		\N	349342	0	444814009	40481087		0
88369	5253	4112343	1976-02-28	1976-02-28 00:00:00	1976-03-07	1976-03-07 00:00:00	32020		\N	349539	0	195662009	4112343		0
88707	5274	81151	1981-03-24	1981-03-24 00:00:00	1981-04-28	1981-04-28 00:00:00	32020		\N	350843	0	44465007	81151		0
88819	5279	4027663	1977-01-19	1977-01-19 00:00:00	\N	\N	32020		\N	351185	0	13200003	4027663		0
89016	5295	4112343	1941-10-13	1941-10-13 00:00:00	1941-10-22	1941-10-22 00:00:00	32020		\N	352280	0	195662009	4112343		0
89224	5309	4134304	1967-10-28	1967-10-28 00:00:00	1968-01-26	1968-01-26 00:00:00	32020		\N	353147	0	263102004	4134304		0
89340	5314	4155034	1951-11-19	1951-11-19 00:00:00	1951-12-03	1951-12-03 00:00:00	32020		\N	353367	0	283371005	4155034		0
89628	5329	381316	1989-03-01	1989-03-01 00:00:00	\N	\N	32020		\N	354810	0	230690007	381316		0
89739	5334	4112343	1965-10-12	1965-10-12 00:00:00	1965-10-25	1965-10-25 00:00:00	32020		\N	355229	0	195662009	4112343		0
79666	4719	378001	1952-10-03	1952-10-03 00:00:00	1952-11-02	1952-11-02 00:00:00	32020		\N	314228	0	62106007	378001		0
80166	4753	28060	1982-12-31	1982-12-31 00:00:00	1983-01-12	1983-01-12 00:00:00	32020		\N	316491	0	43878008	28060		0
80262	4756	260139	1952-03-19	1952-03-19 00:00:00	1952-03-26	1952-03-26 00:00:00	32020		\N	316863	0	10509002	260139		0
81813	4852	260139	1956-12-28	1956-12-28 00:00:00	1957-01-11	1957-01-11 00:00:00	32020		\N	322848	0	10509002	260139		0
82167	4872	4112343	2013-11-10	2013-11-10 00:00:00	2013-11-18	2013-11-18 00:00:00	32020		\N	324084	0	195662009	4112343		0
84285	5007	4156265	2008-08-26	2008-08-26 00:00:00	2008-09-09	2008-09-09 00:00:00	32020		\N	332998	0	370247008	4156265		0
85398	5078	80180	1945-06-06	1945-06-06 00:00:00	\N	\N	32020		\N	337594	0	396275006	80180		0
85513	5083	40481087	1988-05-19	1988-05-19 00:00:00	1988-05-26	1988-05-26 00:00:00	32020		\N	338071	0	444814009	40481087		0
75185	4466	4283893	1985-12-06	1985-12-06 00:00:00	1986-09-12	1986-09-12 00:00:00	32020		\N	297143	0	36971009	4283893		0
85935	5113	4156265	1981-02-06	1981-02-06 00:00:00	1981-02-27	1981-02-27 00:00:00	32020		\N	339726	0	370247008	4156265		0
75427	4477	40479422	2012-06-25	2012-06-25 00:00:00	2012-08-31	2012-08-31 00:00:00	32020		\N	297915	0	444448004	40479422		0
86178	5128	313217	2017-09-20	2017-09-20 00:00:00	\N	\N	32020		\N	340994	0	49436004	313217		0
75834	4498	28060	1978-07-19	1978-07-19 00:00:00	1978-07-26	1978-07-26 00:00:00	32020		\N	299468	0	43878008	28060		0
75994	4506	260139	1978-11-21	1978-11-21 00:00:00	1978-11-28	1978-11-28 00:00:00	32020		\N	300221	0	10509002	260139		0
86774	5166	4112343	1963-12-23	1963-12-23 00:00:00	1964-01-02	1964-01-02 00:00:00	32020		\N	343423	0	195662009	4112343		0
86936	5174	4285898	1980-06-11	1980-06-11 00:00:00	\N	\N	32020		\N	343996	0	68496003	4285898		0
87241	5194	260139	1958-05-30	1958-05-30 00:00:00	1958-06-06	1958-06-06 00:00:00	32020		\N	345288	0	10509002	260139		0
87401	5201	260139	1979-05-02	1979-05-02 00:00:00	1979-05-16	1979-05-16 00:00:00	32020		\N	345989	0	10509002	260139		0
87507	5207	81151	1980-12-05	1980-12-05 00:00:00	1980-12-26	1980-12-26 00:00:00	32020		\N	346376	0	44465007	81151		0
77167	4571	4112343	2009-01-24	2009-01-24 00:00:00	2009-02-04	2009-02-04 00:00:00	32020		\N	304524	0	195662009	4112343		0
87959	5233	81151	1958-10-08	1958-10-08 00:00:00	1958-11-12	1958-11-12 00:00:00	32020		\N	348170	0	44465007	81151		0
88105	5239	4027663	1999-11-16	1999-11-16 00:00:00	\N	\N	32020		\N	348564	0	13200003	4027663		0
88286	5251	4094814	1931-10-27	1931-10-27 00:00:00	1931-12-26	1931-12-26 00:00:00	32020		\N	349382	0	262574004	4094814		0
88370	5253	372328	1961-01-12	1961-01-12 00:00:00	1961-11-25	1961-11-25 00:00:00	32020		\N	349491	0	65363002	372328		0
88711	5276	4112343	1972-03-21	1972-03-21 00:00:00	1972-04-01	1972-04-01 00:00:00	32020		\N	350866	0	195662009	4112343		0
88820	5279	4112343	1968-04-16	1968-04-16 00:00:00	1968-04-24	1968-04-24 00:00:00	32020		\N	351233	0	195662009	4112343		0
89017	5295	28060	1985-08-06	1985-08-06 00:00:00	1985-08-19	1985-08-19 00:00:00	32020		\N	352244	0	43878008	28060		0
89225	5309	372328	1953-04-18	1953-04-18 00:00:00	1953-07-06	1953-07-06 00:00:00	32020		\N	353089	0	65363002	372328		0
89341	5314	40481087	2016-09-08	2016-09-08 00:00:00	2016-09-22	2016-09-22 00:00:00	32020		\N	353431	0	444814009	40481087		0
89629	5329	260139	1996-03-22	1996-03-22 00:00:00	1996-04-05	1996-04-05 00:00:00	32020		\N	354782	0	10509002	260139		0
89740	5334	28060	1976-10-01	1976-10-01 00:00:00	1976-10-11	1976-10-11 00:00:00	32020		\N	355230	0	43878008	28060		0
79667	4719	378001	1970-06-15	1970-06-15 00:00:00	1970-08-14	1970-08-14 00:00:00	32020		\N	314230	0	62106007	378001		0
80167	4753	28060	1975-02-28	1975-02-28 00:00:00	1975-03-10	1975-03-10 00:00:00	32020		\N	316539	0	43878008	28060		0
80263	4756	40481087	1962-07-25	1962-07-25 00:00:00	1962-08-15	1962-08-15 00:00:00	32020		\N	316802	0	444814009	40481087		0
81814	4852	40481087	2007-06-06	2007-06-06 00:00:00	2007-06-20	2007-06-20 00:00:00	32020		\N	322764	0	444814009	40481087		0
82168	4872	4112343	1915-09-30	1915-09-30 00:00:00	1915-10-12	1915-10-12 00:00:00	32020		\N	323988	0	195662009	4112343		0
84286	5007	4109685	2000-06-25	2000-06-25 00:00:00	2000-07-09	2000-07-09 00:00:00	32020		\N	332997	0	284551006	4109685		0
85399	5078	4266809	1945-06-06	1945-06-06 00:00:00	\N	\N	32020		\N	337594	0	397881000	4266809		0
85514	5083	4112343	1992-05-19	1992-05-19 00:00:00	1992-05-30	1992-05-30 00:00:00	32020		\N	338025	0	195662009	4112343		0
75186	4466	40481087	1979-09-25	1979-09-25 00:00:00	1979-10-02	1979-10-02 00:00:00	32020		\N	297093	0	444814009	40481087		0
85936	5113	40481087	2017-04-22	2017-04-22 00:00:00	2017-05-13	2017-05-13 00:00:00	32020		\N	339709	0	444814009	40481087		0
75428	4477	378001	1986-06-12	1986-06-12 00:00:00	1986-07-12	1986-07-12 00:00:00	32020		\N	297914	0	62106007	378001		0
86179	5128	80180	1965-04-23	1965-04-23 00:00:00	\N	\N	32020		\N	340965	0	396275006	80180		0
75835	4498	30753	2012-06-04	2012-06-04 00:00:00	\N	\N	32020		\N	299498	0	16761005	30753		0
75995	4506	40481087	1964-06-04	1964-06-04 00:00:00	1964-06-11	1964-06-11 00:00:00	32020		\N	300220	0	444814009	40481087		0
86775	5166	40481087	2016-09-08	2016-09-08 00:00:00	2016-09-29	2016-09-29 00:00:00	32020		\N	343473	0	444814009	40481087		0
86937	5174	4266809	1981-01-07	1981-01-07 00:00:00	\N	\N	32020		\N	343996	0	397881000	4266809		0
87242	5194	260139	2009-01-27	2009-01-27 00:00:00	2009-02-03	2009-02-03 00:00:00	32020		\N	345351	0	10509002	260139		0
87402	5201	372328	1980-04-04	1980-04-04 00:00:00	1980-08-06	1980-08-06 00:00:00	32020		\N	345955	0	65363002	372328		0
87508	5207	195588	1980-01-05	1980-01-05 00:00:00	1980-03-05	1980-03-05 00:00:00	32020		\N	346347	0	38822007	195588		0
77168	4571	40481087	1979-12-15	1979-12-15 00:00:00	1979-12-29	1979-12-29 00:00:00	32020		\N	304591	0	444814009	40481087		0
87960	5233	80180	1998-06-25	1998-06-25 00:00:00	\N	\N	32020		\N	348153	0	396275006	80180		0
88106	5239	28060	2001-01-20	2001-01-20 00:00:00	2001-01-29	2001-01-29 00:00:00	32020		\N	348548	0	43878008	28060		0
88287	5251	40481087	1957-09-08	1957-09-08 00:00:00	1957-09-22	1957-09-22 00:00:00	32020		\N	349341	0	444814009	40481087		0
88371	5253	260139	1980-04-13	1980-04-13 00:00:00	1980-04-20	1980-04-20 00:00:00	32020		\N	349540	0	10509002	260139		0
88712	5276	40481087	1962-05-06	1962-05-06 00:00:00	1962-05-27	1962-05-27 00:00:00	32020		\N	350901	0	444814009	40481087		0
88821	5279	40481087	2010-10-04	2010-10-04 00:00:00	2010-10-25	2010-10-25 00:00:00	32020		\N	351175	0	444814009	40481087		0
89018	5295	4152936	1995-04-13	1995-04-13 00:00:00	1995-04-27	1995-04-27 00:00:00	32020		\N	352213	0	283385000	4152936		0
89226	5309	40481087	2009-05-14	2009-05-14 00:00:00	2009-05-28	2009-05-28 00:00:00	32020		\N	353078	0	444814009	40481087		0
89342	5314	40481087	1993-01-31	1993-01-31 00:00:00	1993-02-14	1993-02-14 00:00:00	32020		\N	353422	0	444814009	40481087		0
89630	5329	4109685	1998-07-14	1998-07-14 00:00:00	1998-08-04	1998-08-04 00:00:00	32020		\N	354832	0	284551006	4109685		0
89741	5334	40481087	1970-04-26	1970-04-26 00:00:00	1970-05-03	1970-05-03 00:00:00	32020		\N	355176	0	444814009	40481087		0
79668	4719	28060	2006-10-15	2006-10-15 00:00:00	2006-10-27	2006-10-27 00:00:00	32020		\N	314195	0	43878008	28060		0
80168	4753	28060	1984-11-03	1984-11-03 00:00:00	1984-11-11	1984-11-11 00:00:00	32020		\N	316546	0	43878008	28060		0
80264	4756	378001	1999-07-02	1999-07-02 00:00:00	1999-08-01	1999-08-01 00:00:00	32020		\N	316785	0	62106007	378001		0
81815	4852	195588	1995-02-20	1995-02-20 00:00:00	1995-04-20	1995-04-20 00:00:00	32020		\N	322853	0	38822007	195588		0
82169	4872	375671	1961-09-06	1961-09-06 00:00:00	1961-10-06	1961-10-06 00:00:00	32020		\N	323953	0	62564004	375671		0
84287	5007	40481087	1998-09-01	1998-09-01 00:00:00	1998-09-15	1998-09-15 00:00:00	32020		\N	332999	0	444814009	40481087		0
85400	5078	40481087	1995-08-27	1995-08-27 00:00:00	1995-09-03	1995-09-03 00:00:00	32020		\N	337577	0	444814009	40481087		0
85515	5083	40481087	1966-10-17	1966-10-17 00:00:00	1966-10-24	1966-10-24 00:00:00	32020		\N	338021	0	444814009	40481087		0
75187	4466	4112343	2005-03-27	2005-03-27 00:00:00	2005-04-08	2005-04-08 00:00:00	32020		\N	297116	0	195662009	4112343		0
85937	5113	28060	2011-07-31	2011-07-31 00:00:00	2011-08-10	2011-08-10 00:00:00	32020		\N	339708	0	43878008	28060		0
75429	4477	4237458	1970-10-13	1970-10-13 00:00:00	1970-11-12	1970-11-12 00:00:00	32020		\N	297912	0	58150001	4237458		0
86180	5128	40481087	1964-09-16	1964-09-16 00:00:00	1964-10-07	1964-10-07 00:00:00	32020		\N	340965	0	444814009	40481087		0
75836	4498	80180	2013-12-26	2013-12-26 00:00:00	\N	\N	32020		\N	299498	0	396275006	80180		0
75996	4506	260139	1964-09-20	1964-09-20 00:00:00	1964-10-04	1964-10-04 00:00:00	32020		\N	300204	0	10509002	260139		0
86776	5166	81151	2008-12-15	2008-12-15 00:00:00	2009-01-12	2009-01-12 00:00:00	32020		\N	343404	0	44465007	81151		0
86938	5174	4112343	2000-06-18	2000-06-18 00:00:00	2000-06-25	2000-06-25 00:00:00	32020		\N	344017	0	195662009	4112343		0
87243	5194	4112343	1946-06-18	1946-06-18 00:00:00	1946-06-28	1946-06-28 00:00:00	32020		\N	345308	0	195662009	4112343		0
87420	5203	4112343	1940-11-16	1940-11-16 00:00:00	1940-11-25	1940-11-25 00:00:00	32020		\N	346100	0	195662009	4112343		0
87509	5207	40481087	2016-12-31	2016-12-31 00:00:00	2017-01-07	2017-01-07 00:00:00	32020		\N	346352	0	444814009	40481087		0
77169	4571	4149245	2001-03-17	2001-03-17 00:00:00	2001-05-23	2001-05-23 00:00:00	32020		\N	304555	0	30832001	4149245		0
87961	5233	40481087	1990-08-22	1990-08-22 00:00:00	1990-09-12	1990-09-12 00:00:00	32020		\N	348183	0	444814009	40481087		0
88107	5239	372328	1970-10-12	1970-10-12 00:00:00	1970-11-04	1970-11-04 00:00:00	32020		\N	348573	0	65363002	372328		0
88288	5251	81151	1935-11-05	1935-11-05 00:00:00	1935-11-19	1935-11-19 00:00:00	32020		\N	349384	0	44465007	81151		0
88372	5253	40481087	2016-05-07	2016-05-07 00:00:00	2016-05-14	2016-05-14 00:00:00	32020		\N	349528	0	444814009	40481087		0
88713	5276	40481087	1975-06-24	1975-06-24 00:00:00	1975-07-15	1975-07-15 00:00:00	32020		\N	350906	0	444814009	40481087		0
88847	5283	4112343	1999-03-20	1999-03-20 00:00:00	1999-03-29	1999-03-29 00:00:00	32020		\N	351421	0	195662009	4112343		0
89019	5295	257012	1915-01-12	1915-01-12 00:00:00	\N	\N	32020		\N	352222	0	40055000	257012		0
89227	5309	260139	1966-04-20	1966-04-20 00:00:00	1966-05-04	1966-05-04 00:00:00	32020		\N	353056	0	10509002	260139		0
89343	5314	40481087	1989-02-12	1989-02-12 00:00:00	1989-03-05	1989-03-05 00:00:00	32020		\N	353409	0	444814009	40481087		0
89631	5329	4094814	1951-07-30	1951-07-30 00:00:00	1951-09-28	1951-09-28 00:00:00	32020		\N	354828	0	262574004	4094814		0
89742	5334	4113008	2008-08-24	2008-08-24 00:00:00	2008-09-14	2008-09-14 00:00:00	32020		\N	355236	0	284549007	4113008		0
79669	4719	28060	1997-08-19	1997-08-19 00:00:00	1997-08-31	1997-08-31 00:00:00	32020		\N	314330	0	43878008	28060		0
80169	4753	260139	1973-04-24	1973-04-24 00:00:00	1973-05-08	1973-05-08 00:00:00	32020		\N	316550	0	10509002	260139		0
80265	4756	4112343	1964-08-01	1964-08-01 00:00:00	1964-08-14	1964-08-14 00:00:00	32020		\N	316864	0	195662009	4112343		0
81816	4852	260139	1975-11-23	1975-11-23 00:00:00	1975-11-30	1975-11-30 00:00:00	32020		\N	322773	0	10509002	260139		0
82170	4872	40481087	1977-08-01	1977-08-01 00:00:00	1977-08-08	1977-08-08 00:00:00	32020		\N	324030	0	444814009	40481087		0
84288	5007	4029498	1995-03-24	1995-03-24 00:00:00	\N	\N	32020		\N	332996	0	128613002	4029498		0
85401	5078	40481087	1912-09-27	1912-09-27 00:00:00	1912-10-04	1912-10-04 00:00:00	32020		\N	337529	0	444814009	40481087		0
85516	5083	4218389	1992-08-20	1992-08-20 00:00:00	1992-09-24	1992-09-24 00:00:00	32020		\N	337990	0	39848009	4218389		0
75188	4466	4112343	2006-04-05	2006-04-05 00:00:00	2006-04-16	2006-04-16 00:00:00	32020		\N	297157	0	195662009	4112343		0
85960	5116	80180	2010-05-03	2010-05-03 00:00:00	\N	\N	32020		\N	339937	0	396275006	80180		0
75430	4477	28060	1975-08-28	1975-08-28 00:00:00	1975-09-04	1975-09-04 00:00:00	32020		\N	297941	0	43878008	28060		0
86181	5128	40481087	2005-12-06	2005-12-06 00:00:00	2005-12-13	2005-12-13 00:00:00	32020		\N	340998	0	444814009	40481087		0
75837	4498	440086	1986-05-22	1986-05-22 00:00:00	1995-05-30	1995-05-30 00:00:00	32020		\N	299436	0	192127007	440086		0
75997	4506	40481087	1976-11-14	1976-11-14 00:00:00	1976-12-05	1976-12-05 00:00:00	32020		\N	300158	0	444814009	40481087		0
86777	5166	40481087	1980-03-29	1980-03-29 00:00:00	1980-04-19	1980-04-19 00:00:00	32020		\N	343418	0	444814009	40481087		0
86939	5174	4112343	1955-09-04	1955-09-04 00:00:00	1955-09-12	1955-09-12 00:00:00	32020		\N	343968	0	195662009	4112343		0
87244	5195	4294548	1974-11-19	1974-11-19 00:00:00	1975-03-18	1975-03-18 00:00:00	32020		\N	345474	0	75498004	4294548		0
87421	5203	260139	1961-09-15	1961-09-15 00:00:00	1961-09-22	1961-09-22 00:00:00	32020		\N	346121	0	10509002	260139		0
87510	5207	81893	1994-01-26	1994-01-26 00:00:00	\N	\N	32020		\N	346393	0	64766004	81893		0
77170	4571	372328	1956-11-29	1956-11-29 00:00:00	1957-06-01	1957-06-01 00:00:00	32020		\N	304595	0	65363002	372328		0
87962	5233	4112343	2018-06-08	2018-06-08 00:00:00	2018-06-21	2018-06-21 00:00:00	32020		\N	348157	0	195662009	4112343		0
88108	5240	195588	1985-06-15	1985-06-15 00:00:00	1985-07-31	1985-07-31 00:00:00	32020		\N	348693	0	38822007	195588		0
88289	5251	4156265	1923-03-24	1923-03-24 00:00:00	1923-04-14	1923-04-14 00:00:00	32020		\N	349387	0	370247008	4156265		0
88373	5253	4112343	1981-04-11	1981-04-11 00:00:00	1981-04-21	1981-04-21 00:00:00	32020		\N	349564	0	195662009	4112343		0
88714	5276	260139	1969-12-24	1969-12-24 00:00:00	1969-12-31	1969-12-31 00:00:00	32020		\N	350904	0	10509002	260139		0
88848	5283	260139	1989-06-28	1989-06-28 00:00:00	1989-07-12	1989-07-12 00:00:00	32020		\N	351425	0	10509002	260139		0
89020	5295	4112343	1998-07-24	1998-07-24 00:00:00	1998-07-31	1998-07-31 00:00:00	32020		\N	352258	0	195662009	4112343		0
89228	5309	4152936	1957-05-04	1957-05-04 00:00:00	1957-05-18	1957-05-18 00:00:00	32020		\N	353144	0	283385000	4152936		0
89344	5314	40481087	1960-11-21	1960-11-21 00:00:00	1960-12-05	1960-12-05 00:00:00	32020		\N	353394	0	444814009	40481087		0
89632	5329	4113008	1946-10-03	1946-10-03 00:00:00	1946-10-24	1946-10-24 00:00:00	32020		\N	354812	0	284549007	4113008		0
89743	5334	40481087	2012-09-24	2012-09-24 00:00:00	2012-10-15	2012-10-15 00:00:00	32020		\N	355179	0	444814009	40481087		0
79670	4719	4112343	2012-05-01	2012-05-01 00:00:00	2012-05-12	2012-05-12 00:00:00	32020		\N	314333	0	195662009	4112343		0
80170	4753	321042	1987-11-18	1987-11-18 00:00:00	\N	\N	32020		\N	316575	0	410429000	321042		0
80266	4756	4112343	2003-12-02	2003-12-02 00:00:00	2003-12-13	2003-12-13 00:00:00	32020		\N	316869	0	195662009	4112343		0
81817	4852	4266809	1990-09-17	1990-09-17 00:00:00	\N	\N	32020		\N	322808	0	397881000	4266809		0
84290	5007	372328	1983-06-25	1983-06-25 00:00:00	1983-09-04	1983-09-04 00:00:00	32020		\N	333014	0	65363002	372328		0
85402	5078	260139	1956-10-03	1956-10-03 00:00:00	1956-10-17	1956-10-17 00:00:00	32020		\N	337540	0	10509002	260139		0
85517	5083	78272	1948-09-12	1948-09-12 00:00:00	1948-09-26	1948-09-26 00:00:00	32020		\N	337988	0	70704007	78272		0
75189	4466	4112343	1991-05-31	1991-05-31 00:00:00	1991-06-08	1991-06-08 00:00:00	32020		\N	297146	0	195662009	4112343		0
85961	5116	78272	1969-12-28	1969-12-28 00:00:00	1970-01-11	1970-01-11 00:00:00	32020		\N	339886	0	70704007	78272		0
75431	4477	28060	1971-11-24	1971-11-24 00:00:00	1971-12-05	1971-12-05 00:00:00	32020		\N	297963	0	43878008	28060		0
86182	5128	4112343	1998-09-13	1998-09-13 00:00:00	1998-09-26	1998-09-26 00:00:00	32020		\N	340997	0	195662009	4112343		0
75838	4498	260139	1979-12-12	1979-12-12 00:00:00	1979-12-26	1979-12-26 00:00:00	32020		\N	299469	0	10509002	260139		0
75998	4506	260139	1980-03-20	1980-03-20 00:00:00	1980-04-03	1980-04-03 00:00:00	32020		\N	300222	0	10509002	260139		0
86778	5166	260139	1958-09-06	1958-09-06 00:00:00	1958-09-20	1958-09-20 00:00:00	32020		\N	343415	0	10509002	260139		0
86940	5174	4112343	2015-07-11	2015-07-11 00:00:00	2015-07-24	2015-07-24 00:00:00	32020		\N	344019	0	195662009	4112343		0
87245	5195	78272	1963-12-28	1963-12-28 00:00:00	1964-01-18	1964-01-18 00:00:00	32020		\N	345408	0	70704007	78272		0
87422	5203	260139	1973-08-03	1973-08-03 00:00:00	1973-08-10	1973-08-10 00:00:00	32020		\N	346123	0	10509002	260139		0
87511	5207	4310024	1993-08-29	1993-08-29 00:00:00	\N	\N	32020		\N	346393	0	424802006	4310024		0
77171	4571	40481087	2010-07-07	2010-07-07 00:00:00	2010-07-28	2010-07-28 00:00:00	32020		\N	304561	0	444814009	40481087		0
87963	5233	4112343	2012-07-23	2012-07-23 00:00:00	2012-08-05	2012-08-05 00:00:00	32020		\N	348192	0	195662009	4112343		0
88109	5240	4294548	1990-08-19	1990-08-19 00:00:00	1990-10-28	1990-10-28 00:00:00	32020		\N	348716	0	75498004	4294548		0
88290	5251	4112343	1965-10-03	1965-10-03 00:00:00	1965-10-10	1965-10-10 00:00:00	32020		\N	349343	0	195662009	4112343		0
88374	5253	257012	1968-03-22	1968-03-22 00:00:00	\N	\N	32020		\N	349561	0	40055000	257012		0
88715	5276	4112343	1999-11-21	1999-11-21 00:00:00	1999-12-04	1999-12-04 00:00:00	32020		\N	350887	0	195662009	4112343		0
88849	5283	4278672	1984-09-07	1984-09-07 00:00:00	1984-11-06	1984-11-06 00:00:00	32020		\N	351478	0	65966004	4278672		0
89021	5295	372328	1949-05-15	1949-05-15 00:00:00	1951-01-24	1951-01-24 00:00:00	32020		\N	352219	0	65363002	372328		0
89229	5309	4146173	1969-11-16	1969-11-16 00:00:00	1970-01-15	1970-01-15 00:00:00	32020		\N	353071	0	307731004	4146173		0
89345	5315	40481087	1942-03-13	1942-03-13 00:00:00	1942-03-27	1942-03-27 00:00:00	32020		\N	353499	0	444814009	40481087		0
89633	5329	40481087	1949-12-24	1949-12-24 00:00:00	1950-01-14	1950-01-14 00:00:00	32020		\N	354741	0	444814009	40481087		0
89744	5334	372328	1978-04-27	1978-04-27 00:00:00	1979-02-14	1979-02-14 00:00:00	32020		\N	355199	0	65363002	372328		0
79671	4720	260139	1976-08-15	1976-08-15 00:00:00	1976-08-29	1976-08-29 00:00:00	32020		\N	314400	0	10509002	260139		0
80172	4753	260139	1986-11-28	1986-11-28 00:00:00	1986-12-12	1986-12-12 00:00:00	32020		\N	316547	0	10509002	260139		0
80267	4756	4112343	1944-07-09	1944-07-09 00:00:00	1944-07-19	1944-07-19 00:00:00	32020		\N	316840	0	195662009	4112343		0
81818	4852	80180	1990-09-17	1990-09-17 00:00:00	\N	\N	32020		\N	322808	0	396275006	80180		0
84291	5007	4112343	2012-12-23	2012-12-23 00:00:00	2013-01-05	2013-01-05 00:00:00	32020		\N	333026	0	195662009	4112343		0
85403	5078	4134304	1983-05-23	1983-05-23 00:00:00	1983-06-22	1983-06-22 00:00:00	32020		\N	337526	0	263102004	4134304		0
85518	5083	260139	1970-04-21	1970-04-21 00:00:00	1970-05-05	1970-05-05 00:00:00	32020		\N	338022	0	10509002	260139		0
75190	4466	4113008	2016-09-04	2016-09-04 00:00:00	2016-09-18	2016-09-18 00:00:00	32020		\N	297159	0	284549007	4113008		0
85962	5116	40481087	2018-02-11	2018-02-11 00:00:00	2018-02-18	2018-02-18 00:00:00	32020		\N	339974	0	444814009	40481087		0
75432	4477	4027663	1995-11-13	1995-11-13 00:00:00	\N	\N	32020		\N	297972	0	13200003	4027663		0
86183	5128	4112343	1947-01-09	1947-01-09 00:00:00	1947-01-22	1947-01-22 00:00:00	32020		\N	340956	0	195662009	4112343		0
75839	4498	4296204	1989-01-21	1989-01-21 00:00:00	1989-02-25	1989-02-25 00:00:00	32020		\N	299494	0	403190006	4296204		0
75999	4506	40481087	2018-05-29	2018-05-29 00:00:00	2018-06-05	2018-06-05 00:00:00	32020		\N	300142	0	444814009	40481087		0
86779	5166	375671	1976-09-29	1976-09-29 00:00:00	1976-11-28	1976-11-28 00:00:00	32020		\N	343401	0	62564004	375671		0
86941	5174	40480160	2003-05-13	2003-05-13 00:00:00	2003-06-12	2003-06-12 00:00:00	32020		\N	344067	0	443165006	40480160		0
87246	5195	192671	1995-07-26	1995-07-26 00:00:00	\N	\N	32020		\N	345484	0	K92.2	35208414		0
87423	5203	372328	1938-03-31	1938-03-31 00:00:00	1938-07-20	1938-07-20 00:00:00	32020		\N	346116	0	65363002	372328		0
87512	5207	80180	1995-03-22	1995-03-22 00:00:00	\N	\N	32020		\N	346393	0	396275006	80180		0
77172	4571	4155034	1981-03-18	1981-03-18 00:00:00	1981-04-01	1981-04-01 00:00:00	32020		\N	304554	0	283371005	4155034		0
87964	5233	260139	1956-11-18	1956-11-18 00:00:00	1956-12-02	1956-12-02 00:00:00	32020		\N	348136	0	10509002	260139		0
88110	5240	40481087	2015-05-10	2015-05-10 00:00:00	2015-05-17	2015-05-17 00:00:00	32020		\N	348616	0	444814009	40481087		0
88291	5251	4112343	1952-01-30	1952-01-30 00:00:00	1952-02-10	1952-02-10 00:00:00	32020		\N	349318	0	195662009	4112343		0
88384	5255	257012	1979-01-16	1979-01-16 00:00:00	\N	\N	32020		\N	349666	0	40055000	257012		0
88716	5276	40481087	1995-07-26	1995-07-26 00:00:00	1995-08-09	1995-08-09 00:00:00	32020		\N	350915	0	444814009	40481087		0
88850	5283	372328	1978-04-07	1978-04-07 00:00:00	1978-08-22	1978-08-22 00:00:00	32020		\N	351416	0	65363002	372328		0
89032	5298	40481087	1963-07-05	1963-07-05 00:00:00	1963-07-19	1963-07-19 00:00:00	32020		\N	352385	0	444814009	40481087		0
89230	5309	4283893	1961-08-25	1961-08-25 00:00:00	1962-03-09	1962-03-09 00:00:00	32020		\N	353114	0	36971009	4283893		0
89346	5315	4112343	1962-08-05	1962-08-05 00:00:00	1962-08-15	1962-08-15 00:00:00	32020		\N	353466	0	195662009	4112343		0
89634	5329	4116491	1990-12-11	1990-12-11 00:00:00	1991-01-17	1991-01-17 00:00:00	32020		\N	354781	0	301011002	4116491		0
89745	5334	40481087	2001-01-06	2001-01-06 00:00:00	2001-01-27	2001-01-27 00:00:00	32020		\N	355195	0	444814009	40481087		0
79672	4720	40481087	1980-03-05	1980-03-05 00:00:00	1980-03-26	1980-03-26 00:00:00	32020		\N	314404	0	444814009	40481087		0
80173	4753	372328	1962-03-04	1962-03-04 00:00:00	1962-05-16	1962-05-16 00:00:00	32020		\N	316559	0	65363002	372328		0
80268	4756	4155034	1985-11-25	1985-11-25 00:00:00	1985-12-16	1985-12-16 00:00:00	32020		\N	316781	0	283371005	4155034		0
81819	4852	4112343	2003-07-24	2003-07-24 00:00:00	2003-08-05	2003-08-05 00:00:00	32020		\N	322763	0	195662009	4112343		0
84292	5007	40481087	2016-03-22	2016-03-22 00:00:00	2016-04-05	2016-04-05 00:00:00	32020		\N	333012	0	444814009	40481087		0
85404	5079	4112343	1991-12-28	1991-12-28 00:00:00	1992-01-10	1992-01-10 00:00:00	32020		\N	337689	0	195662009	4112343		0
85519	5083	28060	1973-12-14	1973-12-14 00:00:00	1973-12-24	1973-12-24 00:00:00	32020		\N	338023	0	43878008	28060		0
75191	4466	28060	1976-02-09	1976-02-09 00:00:00	1976-02-18	1976-02-18 00:00:00	32020		\N	297092	0	43878008	28060		0
85963	5116	260139	1969-01-03	1969-01-03 00:00:00	1969-01-10	1969-01-10 00:00:00	32020		\N	339910	0	10509002	260139		0
75433	4477	40481087	1982-11-18	1982-11-18 00:00:00	1982-12-02	1982-12-02 00:00:00	32020		\N	297982	0	444814009	40481087		0
86184	5128	40481087	1930-11-24	1930-11-24 00:00:00	1930-12-15	1930-12-15 00:00:00	32020		\N	340955	0	444814009	40481087		0
75840	4498	40481087	1981-08-09	1981-08-09 00:00:00	1981-08-16	1981-08-16 00:00:00	32020		\N	299474	0	444814009	40481087		0
76019	4509	260139	2005-02-19	2005-02-19 00:00:00	2005-03-05	2005-03-05 00:00:00	32020		\N	300404	0	10509002	260139		0
86780	5166	4134304	1955-02-22	1955-02-22 00:00:00	1955-05-23	1955-05-23 00:00:00	32020		\N	343399	0	263102004	4134304		0
86942	5174	4278672	2003-05-13	2003-05-13 00:00:00	2003-06-12	2003-06-12 00:00:00	32020		\N	344067	0	65966004	4278672		0
87247	5195	260139	1993-09-01	1993-09-01 00:00:00	1993-09-15	1993-09-15 00:00:00	32020		\N	345446	0	10509002	260139		0
87424	5203	4112343	1985-11-18	1985-11-18 00:00:00	1985-12-01	1985-12-01 00:00:00	32020		\N	346080	0	195662009	4112343		0
77173	4571	81151	1958-12-02	1958-12-02 00:00:00	1958-12-23	1958-12-23 00:00:00	32020		\N	304552	0	44465007	81151		0
87965	5233	40481087	1962-11-25	1962-11-25 00:00:00	1962-12-02	1962-12-02 00:00:00	32020		\N	348137	0	444814009	40481087		0
88111	5240	4113008	1975-06-14	1975-06-14 00:00:00	1975-06-28	1975-06-28 00:00:00	32020		\N	348609	0	284549007	4113008		0
88292	5251	260139	1947-05-18	1947-05-18 00:00:00	1947-06-01	1947-06-01 00:00:00	32020		\N	349340	0	10509002	260139		0
88385	5255	4112343	2014-05-04	2014-05-04 00:00:00	2014-05-13	2014-05-13 00:00:00	32020		\N	349625	0	195662009	4112343		0
88717	5276	40481087	2001-02-05	2001-02-05 00:00:00	2001-02-19	2001-02-19 00:00:00	32020		\N	350876	0	444814009	40481087		0
88851	5283	40481087	1996-05-06	1996-05-06 00:00:00	1996-05-20	1996-05-20 00:00:00	32020		\N	351456	0	444814009	40481087		0
89033	5298	260139	1942-03-20	1942-03-20 00:00:00	1942-04-03	1942-04-03 00:00:00	32020		\N	352441	0	10509002	260139		0
89231	5309	78272	1964-11-07	1964-11-07 00:00:00	1964-12-12	1964-12-12 00:00:00	32020		\N	353146	0	70704007	78272		0
89347	5315	192671	1957-05-08	1957-05-08 00:00:00	\N	\N	32020		\N	353460	0	K92.2	35208414		0
89635	5329	4035415	1968-12-18	1968-12-18 00:00:00	1969-02-16	1969-02-16 00:00:00	32020		\N	354830	0	239720000	4035415		0
89746	5334	80180	2001-01-30	2001-01-30 00:00:00	\N	\N	32020		\N	355195	0	396275006	80180		0
79673	4720	28060	1979-12-28	1979-12-28 00:00:00	1980-01-04	1980-01-04 00:00:00	32020		\N	314401	0	43878008	28060		0
80174	4753	40481087	1975-09-29	1975-09-29 00:00:00	1975-10-06	1975-10-06 00:00:00	32020		\N	316545	0	444814009	40481087		0
80269	4756	4156265	2010-12-01	2010-12-01 00:00:00	2010-12-15	2010-12-15 00:00:00	32020		\N	316786	0	370247008	4156265		0
81820	4852	260139	1986-06-09	1986-06-09 00:00:00	1986-06-23	1986-06-23 00:00:00	32020		\N	322786	0	10509002	260139		0
84293	5007	260139	1999-08-02	1999-08-02 00:00:00	1999-08-16	1999-08-16 00:00:00	32020		\N	333023	0	10509002	260139		0
85405	5079	4237458	1969-07-28	1969-07-28 00:00:00	1969-10-26	1969-10-26 00:00:00	32020		\N	337687	0	58150001	4237458		0
85520	5083	4112343	1993-09-23	1993-09-23 00:00:00	1993-10-03	1993-10-03 00:00:00	32020		\N	338027	0	195662009	4112343		0
75192	4466	260139	1983-03-04	1983-03-04 00:00:00	1983-03-18	1983-03-18 00:00:00	32020		\N	297153	0	10509002	260139		0
85964	5116	40481087	1978-03-29	1978-03-29 00:00:00	1978-04-05	1978-04-05 00:00:00	32020		\N	339923	0	444814009	40481087		0
75434	4477	40481087	2010-10-06	2010-10-06 00:00:00	2010-10-13	2010-10-13 00:00:00	32020		\N	297933	0	444814009	40481087		0
86185	5128	81151	1943-05-14	1943-05-14 00:00:00	1943-05-28	1943-05-28 00:00:00	32020		\N	340917	0	44465007	81151		0
75841	4498	260139	1983-12-01	1983-12-01 00:00:00	1983-12-15	1983-12-15 00:00:00	32020		\N	299435	0	10509002	260139		0
76020	4509	260139	1970-04-16	1970-04-16 00:00:00	1970-04-23	1970-04-23 00:00:00	32020		\N	300383	0	10509002	260139		0
86781	5166	40481087	1969-06-27	1969-06-27 00:00:00	1969-07-04	1969-07-04 00:00:00	32020		\N	343406	0	444814009	40481087		0
86943	5174	40481087	2007-06-18	2007-06-18 00:00:00	2007-07-09	2007-07-09 00:00:00	32020		\N	344042	0	444814009	40481087		0
87248	5195	40481087	1978-08-23	1978-08-23 00:00:00	1978-08-30	1978-08-30 00:00:00	32020		\N	345433	0	444814009	40481087		0
87425	5203	40481087	1988-03-19	1988-03-19 00:00:00	1988-03-26	1988-03-26 00:00:00	32020		\N	346081	0	444814009	40481087		0
87514	5207	40481087	1963-06-22	1963-06-22 00:00:00	1963-07-06	1963-07-06 00:00:00	32020		\N	346344	0	444814009	40481087		0
77174	4571	40481087	1983-06-19	1983-06-19 00:00:00	1983-07-10	1983-07-10 00:00:00	32020		\N	304559	0	444814009	40481087		0
87966	5233	4112343	2001-02-07	2001-02-07 00:00:00	2001-02-17	2001-02-17 00:00:00	32020		\N	348156	0	195662009	4112343		0
88112	5240	260139	1956-12-06	1956-12-06 00:00:00	1956-12-13	1956-12-13 00:00:00	32020		\N	348713	0	10509002	260139		0
88293	5251	4043241	1970-05-25	1970-05-25 00:00:00	\N	\N	32020		\N	349312	0	230265002	4043241		0
88386	5255	4112343	2010-09-12	2010-09-12 00:00:00	2010-09-19	2010-09-19 00:00:00	32020		\N	349624	0	195662009	4112343		0
88718	5276	260139	2012-08-19	2012-08-19 00:00:00	2012-09-02	2012-09-02 00:00:00	32020		\N	350879	0	10509002	260139		0
88852	5283	40481087	2002-06-25	2002-06-25 00:00:00	2002-07-02	2002-07-02 00:00:00	32020		\N	351415	0	444814009	40481087		0
89034	5298	40481087	1980-04-06	1980-04-06 00:00:00	1980-04-20	1980-04-20 00:00:00	32020		\N	352423	0	444814009	40481087		0
89232	5309	260139	1989-04-07	1989-04-07 00:00:00	1989-04-21	1989-04-21 00:00:00	32020		\N	353074	0	10509002	260139		0
89348	5315	317576	1967-12-10	1967-12-10 00:00:00	\N	\N	32020		\N	353479	0	53741008	317576		0
89636	5329	40481087	1950-10-20	1950-10-20 00:00:00	1950-11-03	1950-11-03 00:00:00	32020		\N	354748	0	444814009	40481087		0
89747	5334	372328	1966-10-19	1966-10-19 00:00:00	1967-01-25	1967-01-25 00:00:00	32020		\N	355232	0	65363002	372328		0
79674	4720	260139	1989-08-30	1989-08-30 00:00:00	1989-09-13	1989-09-13 00:00:00	32020		\N	314402	0	10509002	260139		0
80175	4753	440086	1971-06-05	1971-06-05 00:00:00	1974-07-27	1974-07-27 00:00:00	32020		\N	316563	0	192127007	440086		0
80270	4756	260139	1949-05-12	1949-05-12 00:00:00	1949-05-26	1949-05-26 00:00:00	32020		\N	316827	0	10509002	260139		0
81821	4852	28060	1966-10-12	1966-10-12 00:00:00	1966-10-22	1966-10-22 00:00:00	32020		\N	322831	0	43878008	28060		0
84294	5007	80180	2019-04-07	2019-04-07 00:00:00	\N	\N	32020		\N	333021	0	396275006	80180		0
85406	5079	4112343	1983-08-17	1983-08-17 00:00:00	1983-08-28	1983-08-28 00:00:00	32020		\N	337674	0	195662009	4112343		0
85521	5083	4152936	2013-06-11	2013-06-11 00:00:00	2013-07-02	2013-07-02 00:00:00	32020		\N	338032	0	283385000	4152936		0
75193	4466	4294548	2013-05-13	2013-05-13 00:00:00	2013-05-27	2013-05-27 00:00:00	32020		\N	297100	0	75498004	4294548		0
85965	5116	40481087	1988-04-20	1988-04-20 00:00:00	1988-05-04	1988-05-04 00:00:00	32020		\N	339994	0	444814009	40481087		0
75435	4477	80180	2005-08-27	2005-08-27 00:00:00	\N	\N	32020		\N	297975	0	396275006	80180		0
86186	5128	40481087	2005-08-12	2005-08-12 00:00:00	2005-09-02	2005-09-02 00:00:00	32020		\N	340962	0	444814009	40481087		0
75842	4498	40481087	2016-01-13	2016-01-13 00:00:00	2016-02-03	2016-02-03 00:00:00	32020		\N	299470	0	444814009	40481087		0
76021	4509	40481087	1978-09-25	1978-09-25 00:00:00	1978-10-16	1978-10-16 00:00:00	32020		\N	300403	0	444814009	40481087		0
86782	5166	40481087	1978-07-24	1978-07-24 00:00:00	1978-07-31	1978-07-31 00:00:00	32020		\N	343441	0	444814009	40481087		0
86944	5174	40481087	1937-08-02	1937-08-02 00:00:00	1937-08-16	1937-08-16 00:00:00	32020		\N	344050	0	444814009	40481087		0
87249	5195	257012	1975-01-14	1975-01-14 00:00:00	\N	\N	32020		\N	345430	0	40055000	257012		0
87426	5203	40481087	1998-06-23	1998-06-23 00:00:00	1998-07-07	1998-07-07 00:00:00	32020		\N	346083	0	444814009	40481087		0
87515	5207	4134304	1960-05-19	1960-05-19 00:00:00	1960-08-17	1960-08-17 00:00:00	32020		\N	346374	0	263102004	4134304		0
77175	4571	40481087	1978-05-25	1978-05-25 00:00:00	1978-06-15	1978-06-15 00:00:00	32020		\N	304558	0	444814009	40481087		0
87967	5233	260139	2012-02-12	2012-02-12 00:00:00	2012-02-26	2012-02-26 00:00:00	32020		\N	348140	0	10509002	260139		0
88113	5240	372328	1939-08-26	1939-08-26 00:00:00	1939-10-03	1939-10-03 00:00:00	32020		\N	348617	0	65363002	372328		0
88294	5251	40481087	1968-08-03	1968-08-03 00:00:00	1968-08-10	1968-08-10 00:00:00	32020		\N	349335	0	444814009	40481087		0
88387	5255	4112343	1971-07-27	1971-07-27 00:00:00	1971-08-04	1971-08-04 00:00:00	32020		\N	349634	0	195662009	4112343		0
88719	5276	372328	1958-02-18	1958-02-18 00:00:00	1958-04-27	1958-04-27 00:00:00	32020		\N	350880	0	65363002	372328		0
88853	5283	40481087	2005-05-26	2005-05-26 00:00:00	2005-06-09	2005-06-09 00:00:00	32020		\N	351422	0	444814009	40481087		0
89035	5298	40481087	1993-04-10	1993-04-10 00:00:00	1993-05-01	1993-05-01 00:00:00	32020		\N	352387	0	444814009	40481087		0
89233	5309	40481087	1988-12-21	1988-12-21 00:00:00	1989-01-04	1989-01-04 00:00:00	32020		\N	353064	0	444814009	40481087		0
89349	5315	4112343	1957-07-05	1957-07-05 00:00:00	1957-07-17	1957-07-17 00:00:00	32020		\N	353464	0	195662009	4112343		0
89637	5329	80180	1980-09-04	1980-09-04 00:00:00	\N	\N	32020		\N	354821	0	396275006	80180		0
79675	4720	4218389	1999-04-07	1999-04-07 00:00:00	1999-05-12	1999-05-12 00:00:00	32020		\N	314371	0	39848009	4218389		0
80176	4753	40481087	2012-12-04	2012-12-04 00:00:00	2012-12-18	2012-12-18 00:00:00	32020		\N	316493	0	444814009	40481087		0
80271	4756	260139	1953-06-21	1953-06-21 00:00:00	1953-06-28	1953-06-28 00:00:00	32020		\N	316828	0	10509002	260139		0
81822	4852	4059173	1967-03-26	1967-03-26 00:00:00	1967-05-26	1967-05-26 00:00:00	32020		\N	322779	0	16114001	4059173		0
84325	5013	4329847	2013-05-31	2013-05-31 00:00:00	\N	\N	32020		\N	333201	0	22298006	4329847		0
85407	5079	260139	1970-12-22	1970-12-22 00:00:00	1970-12-29	1970-12-29 00:00:00	32020		\N	337673	0	10509002	260139		0
85522	5083	4299128	1993-08-20	1993-08-20 00:00:00	1993-09-10	1993-09-10 00:00:00	32020		\N	337991	0	403192003	4299128		0
75194	4466	40481087	2012-08-26	2012-08-26 00:00:00	2012-09-09	2012-09-09 00:00:00	32020		\N	297099	0	444814009	40481087		0
85966	5116	4112343	2014-08-18	2014-08-18 00:00:00	2014-08-31	2014-08-31 00:00:00	32020		\N	339949	0	195662009	4112343		0
75436	4477	257012	1987-11-17	1987-11-17 00:00:00	\N	\N	32020		\N	297983	0	40055000	257012		0
86187	5128	4230399	2009-12-26	2009-12-26 00:00:00	2010-01-25	2010-01-25 00:00:00	32020		\N	340921	0	359817006	4230399		0
75843	4498	4084167	1978-02-18	1978-02-18 00:00:00	1978-02-18	1978-02-18 00:00:00	32020		\N	299492	0	241929008	4084167		0
76022	4509	40481087	2010-05-23	2010-05-23 00:00:00	2010-06-13	2010-06-13 00:00:00	32020		\N	300353	0	444814009	40481087		0
86783	5166	40481087	2004-10-05	2004-10-05 00:00:00	2004-10-19	2004-10-19 00:00:00	32020		\N	343407	0	444814009	40481087		0
87250	5195	28060	1986-09-12	1986-09-12 00:00:00	1986-09-24	1986-09-24 00:00:00	32020		\N	345475	0	43878008	28060		0
87427	5203	80180	1973-02-25	1973-02-25 00:00:00	\N	\N	32020		\N	346066	0	396275006	80180		0
87516	5207	260139	1967-01-15	1967-01-15 00:00:00	1967-01-22	1967-01-22 00:00:00	32020		\N	346335	0	10509002	260139		0
77176	4571	260139	1993-12-29	1993-12-29 00:00:00	1994-01-05	1994-01-05 00:00:00	32020		\N	304560	0	10509002	260139		0
87968	5233	4278672	1980-04-20	1980-04-20 00:00:00	1980-07-19	1980-07-19 00:00:00	32020		\N	348173	0	65966004	4278672		0
88114	5240	40479422	1979-04-06	1979-04-06 00:00:00	1979-06-12	1979-06-12 00:00:00	32020		\N	348611	0	444448004	40479422		0
88295	5251	40481087	1974-04-10	1974-04-10 00:00:00	1974-04-24	1974-04-24 00:00:00	32020		\N	349320	0	444814009	40481087		0
88388	5255	4027663	1986-12-17	1986-12-17 00:00:00	\N	\N	32020		\N	349656	0	13200003	4027663		0
88720	5276	4112343	2010-02-27	2010-02-27 00:00:00	2010-03-08	2010-03-08 00:00:00	32020		\N	350935	0	195662009	4112343		0
88854	5283	40481087	2011-07-17	2011-07-17 00:00:00	2011-08-07	2011-08-07 00:00:00	32020		\N	351460	0	444814009	40481087		0
89036	5298	260139	1993-03-07	1993-03-07 00:00:00	1993-03-14	1993-03-14 00:00:00	32020		\N	352424	0	10509002	260139		0
89234	5309	4112343	1976-09-29	1976-09-29 00:00:00	1976-10-06	1976-10-06 00:00:00	32020		\N	353116	0	195662009	4112343		0
89350	5315	4112343	1934-06-03	1934-06-03 00:00:00	1934-06-10	1934-06-10 00:00:00	32020		\N	353498	0	195662009	4112343		0
89638	5329	4112343	2009-08-17	2009-08-17 00:00:00	2009-08-26	2009-08-26 00:00:00	32020		\N	354764	0	195662009	4112343		0
89749	5335	4112343	1984-03-23	1984-03-23 00:00:00	1984-03-30	1984-03-30 00:00:00	32020		\N	355261	0	195662009	4112343		0
79676	4720	257012	1995-12-31	1995-12-31 00:00:00	\N	\N	32020		\N	314407	0	40055000	257012		0
80177	4753	40481087	1963-07-06	1963-07-06 00:00:00	1963-07-27	1963-07-27 00:00:00	32020		\N	316480	0	444814009	40481087		0
80272	4756	40481087	1955-08-16	1955-08-16 00:00:00	1955-08-23	1955-08-23 00:00:00	32020		\N	316841	0	444814009	40481087		0
81823	4852	4156265	1995-01-24	1995-01-24 00:00:00	1995-02-07	1995-02-07 00:00:00	32020		\N	322782	0	370247008	4156265		0
84327	5013	80180	2005-08-01	2005-08-01 00:00:00	\N	\N	32020		\N	333217	0	396275006	80180		0
85408	5079	80180	2008-05-19	2008-05-19 00:00:00	\N	\N	32020		\N	337711	0	396275006	80180		0
85523	5083	440086	1954-11-15	1954-11-15 00:00:00	1965-11-22	1965-11-22 00:00:00	32020		\N	338077	0	192127007	440086		0
75195	4467	4112343	1965-10-27	1965-10-27 00:00:00	1965-11-09	1965-11-09 00:00:00	32020		\N	297240	0	195662009	4112343		0
85967	5116	28060	2016-08-23	2016-08-23 00:00:00	2016-09-04	2016-09-04 00:00:00	32020		\N	339950	0	43878008	28060		0
75437	4477	4113008	1978-10-01	1978-10-01 00:00:00	1978-10-22	1978-10-22 00:00:00	32020		\N	297913	0	284549007	4113008		0
86188	5128	40480160	2009-12-26	2009-12-26 00:00:00	2010-01-25	2010-01-25 00:00:00	32020		\N	340921	0	443165006	40480160		0
75844	4498	4027663	2003-05-18	2003-05-18 00:00:00	\N	\N	32020		\N	299497	0	13200003	4027663		0
76023	4509	261325	1990-04-10	1990-04-10 00:00:00	\N	\N	32020		\N	300359	0	87433001	261325		0
86784	5166	28060	2011-04-23	2011-04-23 00:00:00	2011-05-04	2011-05-04 00:00:00	32020		\N	343465	0	43878008	28060		0
87251	5195	4027663	1987-02-10	1987-02-10 00:00:00	\N	\N	32020		\N	345475	0	13200003	4027663		0
87428	5203	4294548	1973-08-30	1973-08-30 00:00:00	1973-09-27	1973-09-27 00:00:00	32020		\N	346079	0	75498004	4294548		0
87517	5207	40481087	2011-03-19	2011-03-19 00:00:00	2011-03-26	2011-03-26 00:00:00	32020		\N	346351	0	444814009	40481087		0
77177	4571	372328	1956-01-17	1956-01-17 00:00:00	1956-06-02	1956-06-02 00:00:00	32020		\N	304525	0	65363002	372328		0
87969	5233	40481087	1964-03-03	1964-03-03 00:00:00	1964-03-17	1964-03-17 00:00:00	32020		\N	348129	0	444814009	40481087		0
88115	5240	257012	1970-09-04	1970-09-04 00:00:00	1970-10-09	1970-10-09 00:00:00	32020		\N	348677	0	40055000	257012		0
88296	5251	40481087	1970-08-09	1970-08-09 00:00:00	1970-08-23	1970-08-23 00:00:00	32020		\N	349336	0	444814009	40481087		0
88389	5255	40481087	1980-08-21	1980-08-21 00:00:00	1980-09-04	1980-09-04 00:00:00	32020		\N	349676	0	444814009	40481087		0
88721	5276	4294548	1973-12-01	1973-12-01 00:00:00	1973-12-22	1973-12-22 00:00:00	32020		\N	350912	0	75498004	4294548		0
88855	5283	80180	2011-02-08	2011-02-08 00:00:00	\N	\N	32020		\N	351459	0	396275006	80180		0
89037	5298	40481087	1967-01-25	1967-01-25 00:00:00	1967-02-15	1967-02-15 00:00:00	32020		\N	352421	0	444814009	40481087		0
89235	5309	4112343	1980-01-21	1980-01-21 00:00:00	1980-01-29	1980-01-29 00:00:00	32020		\N	353072	0	195662009	4112343		0
89351	5315	4329847	1979-04-15	1979-04-15 00:00:00	\N	\N	32020		\N	353459	0	22298006	4329847		0
89639	5329	260139	1977-05-01	1977-05-01 00:00:00	1977-05-15	1977-05-15 00:00:00	32020		\N	354749	0	10509002	260139		0
89750	5335	40481087	1972-07-23	1972-07-23 00:00:00	1972-08-13	1972-08-13 00:00:00	32020		\N	355259	0	444814009	40481087		0
79677	4720	40481087	2018-05-15	2018-05-15 00:00:00	2018-05-22	2018-05-22 00:00:00	32020		\N	314390	0	444814009	40481087		0
80178	4753	40481087	2014-06-20	2014-06-20 00:00:00	2014-07-11	2014-07-11 00:00:00	32020		\N	316557	0	444814009	40481087		0
80273	4756	80502	2004-09-11	2004-09-11 00:00:00	\N	\N	32020		\N	316875	0	64859006	80502		0
81824	4852	40481087	2003-09-11	2003-09-11 00:00:00	2003-09-18	2003-09-18 00:00:00	32020		\N	322777	0	444814009	40481087		0
84328	5013	4218389	1966-07-12	1966-07-12 00:00:00	1966-08-02	1966-08-02 00:00:00	32020		\N	333198	0	39848009	4218389		0
85409	5079	4285898	2008-03-20	2008-03-20 00:00:00	\N	\N	32020		\N	337711	0	68496003	4285898		0
85526	5085	4155034	2003-05-21	2003-05-21 00:00:00	2003-06-11	2003-06-11 00:00:00	32020		\N	338098	0	283371005	4155034		0
75196	4467	40481087	1979-03-04	1979-03-04 00:00:00	1979-03-25	1979-03-25 00:00:00	32020		\N	297178	0	444814009	40481087		0
85968	5116	40481087	2018-10-24	2018-10-24 00:00:00	2018-10-31	2018-10-31 00:00:00	32020		\N	339975	0	444814009	40481087		0
75438	4477	4310024	2002-12-11	2002-12-11 00:00:00	\N	\N	32020		\N	297974	0	424802006	4310024		0
86189	5128	40481087	2018-09-27	2018-09-27 00:00:00	2018-10-18	2018-10-18 00:00:00	32020		\N	341000	0	444814009	40481087		0
75845	4498	260139	2005-04-29	2005-04-29 00:00:00	2005-05-13	2005-05-13 00:00:00	32020		\N	299439	0	10509002	260139		0
76024	4509	40481087	1979-09-20	1979-09-20 00:00:00	1979-10-04	1979-10-04 00:00:00	32020		\N	300384	0	444814009	40481087		0
86785	5166	80180	1985-08-23	1985-08-23 00:00:00	\N	\N	32020		\N	343483	0	396275006	80180		0
87429	5203	378001	1978-06-04	1978-06-04 00:00:00	1978-08-03	1978-08-03 00:00:00	32020		\N	346134	0	62106007	378001		0
87518	5207	192671	1995-05-04	1995-05-04 00:00:00	\N	\N	32020		\N	346377	0	K92.2	35208414		0
77178	4572	40481087	1981-10-22	1981-10-22 00:00:00	1981-11-05	1981-11-05 00:00:00	32020		\N	304646	0	444814009	40481087		0
87970	5233	4152936	2003-02-17	2003-02-17 00:00:00	2003-03-03	2003-03-03 00:00:00	32020		\N	348175	0	283385000	4152936		0
88116	5240	40481087	1992-06-27	1992-06-27 00:00:00	1992-07-04	1992-07-04 00:00:00	32020		\N	348629	0	444814009	40481087		0
88297	5251	40481087	1922-12-02	1922-12-02 00:00:00	1922-12-16	1922-12-16 00:00:00	32020		\N	349362	0	444814009	40481087		0
88390	5255	4294548	1978-11-21	1978-11-21 00:00:00	1979-02-20	1979-02-20 00:00:00	32020		\N	349675	0	75498004	4294548		0
88722	5276	378001	1985-10-27	1985-10-27 00:00:00	1985-11-26	1985-11-26 00:00:00	32020		\N	350947	0	62106007	378001		0
88856	5283	4112343	2009-04-09	2009-04-09 00:00:00	2009-04-19	2009-04-19 00:00:00	32020		\N	351459	0	195662009	4112343		0
89038	5298	40481087	1988-03-15	1988-03-15 00:00:00	1988-03-29	1988-03-29 00:00:00	32020		\N	352413	0	444814009	40481087		0
89236	5309	4278672	1962-01-22	1962-01-22 00:00:00	1962-03-23	1962-03-23 00:00:00	32020		\N	353145	0	65966004	4278672		0
89353	5315	4112343	1973-05-23	1973-05-23 00:00:00	1973-06-04	1973-06-04 00:00:00	32020		\N	353503	0	195662009	4112343		0
89640	5329	40481087	1955-04-20	1955-04-20 00:00:00	1955-05-04	1955-05-04 00:00:00	32020		\N	354801	0	444814009	40481087		0
89751	5335	40481087	1973-05-18	1973-05-18 00:00:00	1973-06-08	1973-06-08 00:00:00	32020		\N	355260	0	444814009	40481087		0
79678	4720	40481087	1985-08-02	1985-08-02 00:00:00	1985-08-23	1985-08-23 00:00:00	32020		\N	314359	0	444814009	40481087		0
80274	4756	40481087	1987-10-02	1987-10-02 00:00:00	1987-10-09	1987-10-09 00:00:00	32020		\N	316829	0	444814009	40481087		0
81825	4852	78272	1985-03-19	1985-03-19 00:00:00	1985-04-16	1985-04-16 00:00:00	32020		\N	322781	0	70704007	78272		0
85410	5079	4266809	2008-05-19	2008-05-19 00:00:00	\N	\N	32020		\N	337711	0	397881000	4266809		0
85527	5085	4027663	2004-09-02	2004-09-02 00:00:00	\N	\N	32020		\N	338098	0	13200003	4027663		0
75197	4467	4156265	2016-01-10	2016-01-10 00:00:00	2016-01-31	2016-01-31 00:00:00	32020		\N	297166	0	370247008	4156265		0
85969	5116	372328	1966-10-16	1966-10-16 00:00:00	1966-10-30	1966-10-30 00:00:00	32020		\N	339951	0	65363002	372328		0
75439	4477	40481087	2002-12-13	2002-12-13 00:00:00	2002-12-20	2002-12-20 00:00:00	32020		\N	297942	0	444814009	40481087		0
86190	5128	260139	1994-11-17	1994-11-17 00:00:00	1994-11-24	1994-11-24 00:00:00	32020		\N	341007	0	10509002	260139		0
75846	4498	40481087	2009-02-26	2009-02-26 00:00:00	2009-03-12	2009-03-12 00:00:00	32020		\N	299477	0	444814009	40481087		0
76025	4509	40481087	1978-02-07	1978-02-07 00:00:00	1978-02-21	1978-02-21 00:00:00	32020		\N	300374	0	444814009	40481087		0
86786	5166	28060	1953-04-06	1953-04-06 00:00:00	1953-04-15	1953-04-15 00:00:00	32020		\N	343414	0	43878008	28060		0
87253	5195	30753	1994-04-04	1994-04-04 00:00:00	\N	\N	32020		\N	345465	0	16761005	30753		0
87430	5203	28060	1967-01-14	1967-01-14 00:00:00	1967-01-24	1967-01-24 00:00:00	32020		\N	346122	0	43878008	28060		0
87519	5207	4027663	1988-01-03	1988-01-03 00:00:00	\N	\N	32020		\N	346330	0	13200003	4027663		0
77179	4572	4283893	2008-04-25	2008-04-25 00:00:00	2008-06-13	2008-06-13 00:00:00	32020		\N	304623	0	36971009	4283893		0
87971	5233	4294548	1974-12-25	1974-12-25 00:00:00	1975-02-05	1975-02-05 00:00:00	32020		\N	348130	0	75498004	4294548		0
88117	5240	4116491	1988-07-30	1988-07-30 00:00:00	1988-09-02	1988-09-02 00:00:00	32020		\N	348653	0	301011002	4116491		0
88298	5251	4278672	1933-11-15	1933-11-15 00:00:00	1933-12-15	1933-12-15 00:00:00	32020		\N	349383	0	65966004	4278672		0
88391	5255	260139	1991-07-28	1991-07-28 00:00:00	1991-08-04	1991-08-04 00:00:00	32020		\N	349622	0	10509002	260139		0
88723	5276	4116491	1975-01-15	1975-01-15 00:00:00	1975-03-02	1975-03-02 00:00:00	32020		\N	350924	0	301011002	4116491		0
88857	5283	260139	1982-06-16	1982-06-16 00:00:00	1982-06-23	1982-06-23 00:00:00	32020		\N	351412	0	10509002	260139		0
89039	5298	260139	1963-10-10	1963-10-10 00:00:00	1963-10-24	1963-10-24 00:00:00	32020		\N	352409	0	10509002	260139		0
89237	5309	40481087	1953-09-16	1953-09-16 00:00:00	1953-09-30	1953-09-30 00:00:00	32020		\N	353058	0	444814009	40481087		0
89354	5315	372328	1916-09-16	1916-09-16 00:00:00	1916-11-26	1916-11-26 00:00:00	32020		\N	353529	0	65363002	372328		0
89752	5335	4218389	1981-09-29	1981-09-29 00:00:00	1981-10-27	1981-10-27 00:00:00	32020		\N	355240	0	39848009	4218389		0
79679	4720	192671	2014-04-25	2014-04-25 00:00:00	\N	\N	32020		\N	314352	0	K92.2	35208414		0
80275	4756	4156265	1997-10-26	1997-10-26 00:00:00	1997-11-09	1997-11-09 00:00:00	32020		\N	316784	0	370247008	4156265		0
81826	4853	40481087	1999-06-30	1999-06-30 00:00:00	1999-07-07	1999-07-07 00:00:00	32020		\N	322886	0	444814009	40481087		0
85411	5079	40481087	1974-07-07	1974-07-07 00:00:00	1974-07-14	1974-07-14 00:00:00	32020		\N	337714	0	444814009	40481087		0
85528	5085	40481087	2012-10-14	2012-10-14 00:00:00	2012-10-28	2012-10-28 00:00:00	32020		\N	338115	0	444814009	40481087		0
75198	4467	4296204	1966-08-27	1966-08-27 00:00:00	1966-09-24	1966-09-24 00:00:00	32020		\N	297162	0	403190006	4296204		0
85970	5116	40481087	1995-10-31	1995-10-31 00:00:00	1995-11-21	1995-11-21 00:00:00	32020		\N	339972	0	444814009	40481087		0
75440	4477	4294548	1987-09-15	1987-09-15 00:00:00	1987-12-01	1987-12-01 00:00:00	32020		\N	297965	0	75498004	4294548		0
86191	5128	40481087	2015-04-02	2015-04-02 00:00:00	2015-04-09	2015-04-09 00:00:00	32020		\N	340923	0	444814009	40481087		0
75847	4498	4310024	2011-03-12	2011-03-12 00:00:00	\N	\N	32020		\N	299477	0	424802006	4310024		0
76026	4509	4146173	2003-09-03	2003-09-03 00:00:00	2003-10-03	2003-10-03 00:00:00	32020		\N	300376	0	307731004	4146173		0
86787	5166	260139	2015-05-14	2015-05-14 00:00:00	2015-05-28	2015-05-28 00:00:00	32020		\N	343443	0	10509002	260139		0
87254	5195	40481087	1970-02-01	1970-02-01 00:00:00	1970-02-08	1970-02-08 00:00:00	32020		\N	345444	0	444814009	40481087		0
87431	5203	260139	1941-05-16	1941-05-16 00:00:00	1941-05-30	1941-05-30 00:00:00	32020		\N	346112	0	10509002	260139		0
87520	5207	4112343	1977-04-30	1977-04-30 00:00:00	1977-05-11	1977-05-11 00:00:00	32020		\N	346346	0	195662009	4112343		0
77180	4572	40481087	2017-08-02	2017-08-02 00:00:00	2017-08-09	2017-08-09 00:00:00	32020		\N	304604	0	444814009	40481087		0
87972	5233	378001	1966-08-02	1966-08-02 00:00:00	1966-09-01	1966-09-01 00:00:00	32020		\N	348172	0	62106007	378001		0
88118	5240	80180	1984-05-31	1984-05-31 00:00:00	\N	\N	32020		\N	348643	0	396275006	80180		0
88299	5251	255848	1980-03-03	1980-03-03 00:00:00	\N	\N	32020		\N	349327	0	233604007	255848		0
88392	5255	4112343	1976-09-08	1976-09-08 00:00:00	1976-09-15	1976-09-15 00:00:00	32020		\N	349635	0	195662009	4112343		0
88724	5276	81151	1994-05-13	1994-05-13 00:00:00	1994-06-03	1994-06-03 00:00:00	32020		\N	350948	0	44465007	81151		0
88858	5283	28060	1996-08-17	1996-08-17 00:00:00	1996-08-29	1996-08-29 00:00:00	32020		\N	351420	0	43878008	28060		0
89040	5298	4283893	1962-02-09	1962-02-09 00:00:00	1962-04-06	1962-04-06 00:00:00	32020		\N	352384	0	36971009	4283893		0
89238	5309	4112343	1954-02-15	1954-02-15 00:00:00	1954-02-26	1954-02-26 00:00:00	32020		\N	353070	0	195662009	4112343		0
89355	5315	372328	1920-09-18	1920-09-18 00:00:00	1921-05-29	1921-05-29 00:00:00	32020		\N	353534	0	65363002	372328		0
89753	5335	260139	1980-03-30	1980-03-30 00:00:00	1980-04-06	1980-04-06 00:00:00	32020		\N	355304	0	10509002	260139		0
79680	4720	4156265	1987-04-19	1987-04-19 00:00:00	1987-05-10	1987-05-10 00:00:00	32020		\N	314370	0	370247008	4156265		0
80276	4756	40481087	2000-10-22	2000-10-22 00:00:00	2000-11-12	2000-11-12 00:00:00	32020		\N	316845	0	444814009	40481087		0
81827	4853	4285898	1999-02-19	1999-02-19 00:00:00	\N	\N	32020		\N	322921	0	68496003	4285898		0
85412	5079	81893	2007-03-26	2007-03-26 00:00:00	\N	\N	32020		\N	337685	0	64766004	81893		0
85529	5085	40481087	2017-04-10	2017-04-10 00:00:00	2017-05-01	2017-05-01 00:00:00	32020		\N	338101	0	444814009	40481087		0
85657	5095	81151	1977-01-22	1977-01-22 00:00:00	1977-02-12	1977-02-12 00:00:00	32020		\N	338496	0	44465007	81151		0
85971	5116	260139	1977-05-29	1977-05-29 00:00:00	1977-06-05	1977-06-05 00:00:00	32020		\N	339982	0	10509002	260139		0
75460	4480	378001	1987-03-21	1987-03-21 00:00:00	1987-04-20	1987-04-20 00:00:00	32020		\N	298187	0	62106007	378001		0
86192	5128	4294548	2012-02-18	2012-02-18 00:00:00	2012-03-10	2012-03-10 00:00:00	32020		\N	340963	0	75498004	4294548		0
75848	4498	40481087	1997-07-31	1997-07-31 00:00:00	1997-08-21	1997-08-21 00:00:00	32020		\N	299485	0	444814009	40481087		0
76027	4509	4278672	1978-02-02	1978-02-02 00:00:00	1978-04-03	1978-04-03 00:00:00	32020		\N	300363	0	65966004	4278672		0
86788	5166	4112343	1997-09-07	1997-09-07 00:00:00	1997-09-18	1997-09-18 00:00:00	32020		\N	343442	0	195662009	4112343		0
87255	5195	4283893	1993-09-01	1993-09-01 00:00:00	1993-12-22	1993-12-22 00:00:00	32020		\N	345446	0	36971009	4283893		0
87432	5203	4329847	1999-02-17	1999-02-17 00:00:00	\N	\N	32020		\N	346136	0	22298006	4329847		0
87521	5207	40481087	1959-01-01	1959-01-01 00:00:00	1959-01-08	1959-01-08 00:00:00	32020		\N	346313	0	444814009	40481087		0
77181	4572	28060	2018-07-16	2018-07-16 00:00:00	2018-07-23	2018-07-23 00:00:00	32020		\N	304626	0	43878008	28060		0
87973	5233	4112343	1968-03-22	1968-03-22 00:00:00	1968-03-29	1968-03-29 00:00:00	32020		\N	348138	0	195662009	4112343		0
88119	5240	40481087	1983-01-11	1983-01-11 00:00:00	1983-02-01	1983-02-01 00:00:00	32020		\N	348643	0	444814009	40481087		0
88300	5251	80180	1962-03-09	1962-03-09 00:00:00	\N	\N	32020		\N	349365	0	396275006	80180		0
88393	5255	372328	1971-10-06	1971-10-06 00:00:00	1972-08-10	1972-08-10 00:00:00	32020		\N	349626	0	65363002	372328		0
88725	5276	260139	1960-06-08	1960-06-08 00:00:00	1960-06-22	1960-06-22 00:00:00	32020		\N	350922	0	10509002	260139		0
88859	5283	4218389	2013-12-04	2013-12-04 00:00:00	2014-01-08	2014-01-08 00:00:00	32020		\N	351455	0	39848009	4218389		0
89041	5298	78272	2003-11-27	2003-11-27 00:00:00	2003-12-11	2003-12-11 00:00:00	32020		\N	352439	0	70704007	78272		0
89239	5309	260139	1974-08-23	1974-08-23 00:00:00	1974-09-06	1974-09-06 00:00:00	32020		\N	353115	0	10509002	260139		0
89356	5315	4112343	1952-06-20	1952-06-20 00:00:00	1952-06-30	1952-06-30 00:00:00	32020		\N	353463	0	195662009	4112343		0
89754	5335	40481087	1970-08-13	1970-08-13 00:00:00	1970-08-27	1970-08-27 00:00:00	32020		\N	355258	0	444814009	40481087		0
80277	4757	4155034	2004-05-27	2004-05-27 00:00:00	2004-06-17	2004-06-17 00:00:00	32020		\N	316964	0	283371005	4155034		0
81828	4853	40481087	2013-10-26	2013-10-26 00:00:00	2013-11-16	2013-11-16 00:00:00	32020		\N	322879	0	444814009	40481087		0
85413	5079	28060	1985-01-20	1985-01-20 00:00:00	1985-01-29	1985-01-29 00:00:00	32020		\N	337704	0	43878008	28060		0
85530	5085	372328	1976-12-08	1976-12-08 00:00:00	1977-02-17	1977-02-17 00:00:00	32020		\N	338116	0	65363002	372328		0
85658	5095	260139	2016-05-02	2016-05-02 00:00:00	2016-05-09	2016-05-09 00:00:00	32020		\N	338549	0	10509002	260139		0
85972	5116	260139	2011-04-24	2011-04-24 00:00:00	2011-05-01	2011-05-01 00:00:00	32020		\N	339943	0	10509002	260139		0
75461	4480	260139	2013-10-15	2013-10-15 00:00:00	2013-10-29	2013-10-29 00:00:00	32020		\N	298125	0	10509002	260139		0
86193	5128	260139	1947-10-22	1947-10-22 00:00:00	1947-10-29	1947-10-29 00:00:00	32020		\N	340957	0	10509002	260139		0
75849	4498	260139	1996-03-01	1996-03-01 00:00:00	1996-03-15	1996-03-15 00:00:00	32020		\N	299484	0	10509002	260139		0
76028	4509	372328	1977-01-08	1977-01-08 00:00:00	1977-05-31	1977-05-31 00:00:00	32020		\N	300364	0	65363002	372328		0
86789	5166	40481087	1965-12-01	1965-12-01 00:00:00	1965-12-22	1965-12-22 00:00:00	32020		\N	343436	0	444814009	40481087		0
87256	5195	260139	1985-04-07	1985-04-07 00:00:00	1985-04-14	1985-04-14 00:00:00	32020		\N	345464	0	10509002	260139		0
87434	5203	317576	1988-08-31	1988-08-31 00:00:00	\N	\N	32020		\N	346106	0	53741008	317576		0
87522	5207	4218389	1969-03-03	1969-03-03 00:00:00	1969-04-07	1969-04-07 00:00:00	32020		\N	346375	0	39848009	4218389		0
77182	4572	80180	2018-10-24	2018-10-24 00:00:00	\N	\N	32020		\N	304626	0	396275006	80180		0
87974	5233	378001	1963-08-18	1963-08-18 00:00:00	1963-09-17	1963-09-17 00:00:00	32020		\N	348171	0	62106007	378001		0
88120	5240	4112343	2004-08-20	2004-08-20 00:00:00	2004-09-02	2004-09-02 00:00:00	32020		\N	348678	0	195662009	4112343		0
88301	5251	40481087	1961-06-07	1961-06-07 00:00:00	1961-06-14	1961-06-14 00:00:00	32020		\N	349365	0	444814009	40481087		0
88394	5255	81151	1996-05-28	1996-05-28 00:00:00	1996-07-02	1996-07-02 00:00:00	32020		\N	349702	0	44465007	81151		0
88726	5276	257012	1998-07-17	1998-07-17 00:00:00	\N	\N	32020		\N	350884	0	40055000	257012		0
88860	5283	4283893	1988-08-07	1988-08-07 00:00:00	1988-09-11	1988-09-11 00:00:00	32020		\N	351424	0	36971009	4283893		0
89042	5298	4112343	1999-07-04	1999-07-04 00:00:00	1999-07-14	1999-07-14 00:00:00	32020		\N	352425	0	195662009	4112343		0
89240	5309	40481087	1952-02-29	1952-02-29 00:00:00	1952-03-07	1952-03-07 00:00:00	32020		\N	353057	0	444814009	40481087		0
89357	5315	260139	1945-02-14	1945-02-14 00:00:00	1945-02-28	1945-02-28 00:00:00	32020		\N	353462	0	10509002	260139		0
89755	5335	440086	1966-08-19	1966-08-19 00:00:00	1968-04-05	1968-04-05 00:00:00	32020		\N	355277	0	192127007	440086		0
80278	4757	40481087	1967-02-06	1967-02-06 00:00:00	1967-02-27	1967-02-27 00:00:00	32020		\N	316879	0	444814009	40481087		0
81829	4853	28060	1965-08-22	1965-08-22 00:00:00	1965-09-04	1965-09-04 00:00:00	32020		\N	322868	0	43878008	28060		0
85414	5079	372328	1969-08-27	1969-08-27 00:00:00	1969-11-16	1969-11-16 00:00:00	32020		\N	337675	0	65363002	372328		0
85531	5085	4112343	1986-12-01	1986-12-01 00:00:00	1986-12-09	1986-12-09 00:00:00	32020		\N	338093	0	195662009	4112343		0
85659	5095	4296205	1978-03-09	1978-03-09 00:00:00	1978-04-06	1978-04-06 00:00:00	32020		\N	338497	0	403191005	4296205		0
85973	5116	4112343	2000-01-08	2000-01-08 00:00:00	2000-01-18	2000-01-18 00:00:00	32020		\N	339973	0	195662009	4112343		0
75462	4480	260139	1965-09-08	1965-09-08 00:00:00	1965-09-22	1965-09-22 00:00:00	32020		\N	298122	0	10509002	260139		0
86194	5128	4116491	1962-08-02	1962-08-02 00:00:00	1962-09-17	1962-09-17 00:00:00	32020		\N	340958	0	301011002	4116491		0
75850	4498	4237458	1983-11-19	1983-11-19 00:00:00	1984-02-17	1984-02-17 00:00:00	32020		\N	299493	0	58150001	4237458		0
86487	5146	4112343	2018-11-14	2018-11-14 00:00:00	2018-11-22	2018-11-22 00:00:00	32020		\N	342137	0	195662009	4112343		0
86790	5166	40481087	2010-05-29	2010-05-29 00:00:00	2010-06-05	2010-06-05 00:00:00	32020		\N	343472	0	444814009	40481087		0
87257	5195	4156265	1968-12-22	1968-12-22 00:00:00	1969-01-12	1969-01-12 00:00:00	32020		\N	345409	0	370247008	4156265		0
87435	5203	28060	1947-01-24	1947-01-24 00:00:00	1947-02-05	1947-02-05 00:00:00	32020		\N	346113	0	43878008	28060		0
87523	5207	40481087	1979-01-20	1979-01-20 00:00:00	1979-01-27	1979-01-27 00:00:00	32020		\N	346309	0	444814009	40481087		0
77183	4572	4112343	1999-08-28	1999-08-28 00:00:00	1999-09-10	1999-09-10 00:00:00	32020		\N	304602	0	195662009	4112343		0
87975	5233	40481087	2018-08-21	2018-08-21 00:00:00	2018-08-28	2018-08-28 00:00:00	32020		\N	348158	0	444814009	40481087		0
88121	5240	40481087	1965-11-29	1965-11-29 00:00:00	1965-12-06	1965-12-06 00:00:00	32020		\N	348640	0	444814009	40481087		0
88302	5251	375671	1936-10-14	1936-10-14 00:00:00	1936-12-13	1936-12-13 00:00:00	32020		\N	349385	0	62564004	375671		0
88395	5255	4266809	1996-08-26	1996-08-26 00:00:00	\N	\N	32020		\N	349702	0	397881000	4266809		0
88727	5276	81151	1975-07-31	1975-07-31 00:00:00	1975-08-21	1975-08-21 00:00:00	32020		\N	350946	0	44465007	81151		0
88861	5283	260139	2008-05-08	2008-05-08 00:00:00	2008-05-15	2008-05-15 00:00:00	32020		\N	351426	0	10509002	260139		0
89043	5298	257012	1962-03-02	1962-03-02 00:00:00	\N	\N	32020		\N	352419	0	40055000	257012		0
89241	5309	317576	1988-12-26	1988-12-26 00:00:00	\N	\N	32020		\N	353129	0	53741008	317576		0
89358	5315	28060	1944-04-19	1944-04-19 00:00:00	1944-05-02	1944-05-02 00:00:00	32020		\N	353500	0	43878008	28060		0
89756	5335	81151	1972-06-29	1972-06-29 00:00:00	1972-08-03	1972-08-03 00:00:00	32020		\N	355238	0	44465007	81151		0
81830	4853	40481087	1992-09-06	1992-09-06 00:00:00	1992-09-27	1992-09-27 00:00:00	32020		\N	322871	0	444814009	40481087		0
85415	5079	260139	1999-11-08	1999-11-08 00:00:00	1999-11-22	1999-11-22 00:00:00	32020		\N	337678	0	10509002	260139		0
85532	5085	40481087	1994-10-11	1994-10-11 00:00:00	1994-10-25	1994-10-25 00:00:00	32020		\N	338114	0	444814009	40481087		0
85660	5095	40481087	1991-08-19	1991-08-19 00:00:00	1991-09-09	1991-09-09 00:00:00	32020		\N	338523	0	444814009	40481087		0
85974	5116	40481087	2010-11-08	2010-11-08 00:00:00	2010-11-15	2010-11-15 00:00:00	32020		\N	340008	0	444814009	40481087		0
75463	4480	4112343	2002-12-11	2002-12-11 00:00:00	2002-12-20	2002-12-20 00:00:00	32020		\N	298139	0	195662009	4112343		0
86195	5128	40481087	1975-12-16	1975-12-16 00:00:00	1975-12-23	1975-12-23 00:00:00	32020		\N	340960	0	444814009	40481087		0
75851	4498	4112343	2015-03-25	2015-03-25 00:00:00	2015-04-06	2015-04-06 00:00:00	32020		\N	299486	0	195662009	4112343		0
86488	5146	40481087	1988-09-23	1988-09-23 00:00:00	1988-10-14	1988-10-14 00:00:00	32020		\N	342087	0	444814009	40481087		0
86791	5166	4294548	1976-06-06	1976-06-06 00:00:00	1976-06-27	1976-06-27 00:00:00	32020		\N	343439	0	75498004	4294548		0
87258	5195	40481087	1978-05-09	1978-05-09 00:00:00	1978-05-16	1978-05-16 00:00:00	32020		\N	345431	0	444814009	40481087		0
87436	5203	78272	1980-03-25	1980-03-25 00:00:00	1980-04-22	1980-04-22 00:00:00	32020		\N	346135	0	70704007	78272		0
87524	5207	4112343	1971-01-24	1971-01-24 00:00:00	1971-01-31	1971-01-31 00:00:00	32020		\N	346345	0	195662009	4112343		0
77184	4572	4112343	1980-05-08	1980-05-08 00:00:00	1980-05-21	1980-05-21 00:00:00	32020		\N	304621	0	195662009	4112343		0
87976	5233	81151	1993-09-09	1993-09-09 00:00:00	1993-10-07	1993-10-07 00:00:00	32020		\N	348174	0	44465007	81151		0
88122	5240	260139	1942-01-14	1942-01-14 00:00:00	1942-01-21	1942-01-21 00:00:00	32020		\N	348711	0	10509002	260139		0
88303	5251	4112343	1943-01-20	1943-01-20 00:00:00	1943-02-02	1943-02-02 00:00:00	32020		\N	349317	0	195662009	4112343		0
88396	5255	80180	1996-08-26	1996-08-26 00:00:00	\N	\N	32020		\N	349702	0	396275006	80180		0
88728	5276	4112343	1981-04-18	1981-04-18 00:00:00	1981-04-25	1981-04-25 00:00:00	32020		\N	350925	0	195662009	4112343		0
88862	5283	260139	1998-08-29	1998-08-29 00:00:00	1998-09-12	1998-09-12 00:00:00	32020		\N	351430	0	10509002	260139		0
89044	5298	378419	2011-07-24	2011-07-24 00:00:00	\N	\N	32020		\N	352403	0	26929004	378419		0
89242	5309	4278672	2018-06-16	2018-06-16 00:00:00	2018-09-14	2018-09-14 00:00:00	32020		\N	353149	0	65966004	4278672		0
89359	5315	260139	1957-09-09	1957-09-09 00:00:00	1957-09-23	1957-09-23 00:00:00	32020		\N	353501	0	10509002	260139		0
89757	5335	40481087	2019-03-17	2019-03-17 00:00:00	2019-04-07	2019-04-07 00:00:00	32020		\N	355263	0	444814009	40481087		0
80280	4757	40481087	1980-01-08	1980-01-08 00:00:00	1980-01-15	1980-01-15 00:00:00	32020		\N	316901	0	444814009	40481087		0
81831	4853	28060	1964-09-27	1964-09-27 00:00:00	1964-10-08	1964-10-08 00:00:00	32020		\N	322883	0	43878008	28060		0
85416	5079	4027663	1996-12-03	1996-12-03 00:00:00	\N	\N	32020		\N	337725	0	13200003	4027663		0
85533	5085	81893	2011-04-29	2011-04-29 00:00:00	\N	\N	32020		\N	338136	0	64766004	81893		0
85661	5096	260139	1985-01-30	1985-01-30 00:00:00	1985-02-13	1985-02-13 00:00:00	32020		\N	338595	0	10509002	260139		0
85975	5116	260139	1998-03-25	1998-03-25 00:00:00	1998-04-01	1998-04-01 00:00:00	32020		\N	340007	0	10509002	260139		0
75464	4480	4134304	1966-09-02	1966-09-02 00:00:00	1966-12-01	1966-12-01 00:00:00	32020		\N	298204	0	263102004	4134304		0
86196	5128	80502	1997-02-19	1997-02-19 00:00:00	\N	\N	32020		\N	340966	0	64859006	80502		0
75852	4498	40481087	1992-03-30	1992-03-30 00:00:00	1992-04-20	1992-04-20 00:00:00	32020		\N	299438	0	444814009	40481087		0
86489	5146	381316	2013-07-15	2013-07-15 00:00:00	\N	\N	32020		\N	342126	0	230690007	381316		0
86792	5166	40481087	1990-08-01	1990-08-01 00:00:00	1990-08-22	1990-08-22 00:00:00	32020		\N	343419	0	444814009	40481087		0
87259	5195	40481087	2016-03-23	2016-03-23 00:00:00	2016-04-06	2016-04-06 00:00:00	32020		\N	345447	0	444814009	40481087		0
87437	5203	40481087	1950-06-20	1950-06-20 00:00:00	1950-06-27	1950-06-27 00:00:00	32020		\N	346078	0	444814009	40481087		0
87525	5207	372328	1960-09-05	1960-09-05 00:00:00	1960-12-21	1960-12-21 00:00:00	32020		\N	346339	0	65363002	372328		0
77185	4572	4155034	2002-05-06	2002-05-06 00:00:00	2002-05-27	2002-05-27 00:00:00	32020		\N	304637	0	283371005	4155034		0
87977	5234	4112343	1965-09-15	1965-09-15 00:00:00	1965-09-25	1965-09-25 00:00:00	32020		\N	348245	0	195662009	4112343		0
88123	5240	81151	1976-05-23	1976-05-23 00:00:00	1976-06-20	1976-06-20 00:00:00	32020		\N	348610	0	44465007	81151		0
88304	5251	192671	1962-05-29	1962-05-29 00:00:00	\N	\N	32020		\N	349328	0	K92.2	35208414		0
88397	5255	372328	1961-05-17	1961-05-17 00:00:00	1961-05-31	1961-05-31 00:00:00	32020		\N	349669	0	65363002	372328		0
88729	5276	28060	1962-10-26	1962-10-26 00:00:00	1962-11-08	1962-11-08 00:00:00	32020		\N	350903	0	43878008	28060		0
88863	5283	40481087	1989-08-13	1989-08-13 00:00:00	1989-09-03	1989-09-03 00:00:00	32020		\N	351414	0	444814009	40481087		0
89045	5298	4112343	1954-03-19	1954-03-19 00:00:00	1954-03-30	1954-03-30 00:00:00	32020		\N	352418	0	195662009	4112343		0
89243	5309	80180	1993-05-08	1993-05-08 00:00:00	\N	\N	32020		\N	353093	0	396275006	80180		0
89360	5315	260139	1942-01-04	1942-01-04 00:00:00	1942-01-18	1942-01-18 00:00:00	32020		\N	353528	0	10509002	260139		0
89758	5335	81151	1964-03-22	1964-03-22 00:00:00	1964-04-12	1964-04-12 00:00:00	32020		\N	355237	0	44465007	81151		0
80281	4757	81151	1975-02-17	1975-02-17 00:00:00	1975-03-17	1975-03-17 00:00:00	32020		\N	316961	0	44465007	81151		0
81832	4853	4112343	1970-07-12	1970-07-12 00:00:00	1970-07-25	1970-07-25 00:00:00	32020		\N	322924	0	195662009	4112343		0
85417	5079	4152936	1981-08-24	1981-08-24 00:00:00	1981-09-14	1981-09-14 00:00:00	32020		\N	337688	0	283385000	4152936		0
85534	5085	4310024	2011-02-28	2011-02-28 00:00:00	\N	\N	32020		\N	338136	0	424802006	4310024		0
85662	5096	81151	2019-03-11	2019-03-11 00:00:00	2019-04-15	2019-04-15 00:00:00	32020		\N	338614	0	44465007	81151		0
85976	5116	40481087	1976-02-04	1976-02-04 00:00:00	1976-02-11	1976-02-11 00:00:00	32020		\N	339922	0	444814009	40481087		0
75465	4480	81151	2013-12-29	2013-12-29 00:00:00	2014-01-26	2014-01-26 00:00:00	32020		\N	298189	0	44465007	81151		0
86197	5128	40481087	2000-06-27	2000-06-27 00:00:00	2000-07-04	2000-07-04 00:00:00	32020		\N	340975	0	444814009	40481087		0
75860	4500	4112343	2004-06-17	2004-06-17 00:00:00	2004-06-26	2004-06-26 00:00:00	32020		\N	299579	0	195662009	4112343		0
86490	5146	257012	1969-12-04	1969-12-04 00:00:00	\N	\N	32020		\N	342097	0	40055000	257012		0
86801	5168	40481087	1996-05-22	1996-05-22 00:00:00	1996-05-29	1996-05-29 00:00:00	32020		\N	343651	0	444814009	40481087		0
87260	5195	4112343	1992-04-27	1992-04-27 00:00:00	1992-05-06	1992-05-06 00:00:00	32020		\N	345476	0	195662009	4112343		0
87438	5203	78272	1942-01-09	1942-01-09 00:00:00	1942-02-13	1942-02-13 00:00:00	32020		\N	346053	0	70704007	78272		0
87526	5207	40481087	1991-01-03	1991-01-03 00:00:00	1991-01-24	1991-01-24 00:00:00	32020		\N	346378	0	444814009	40481087		0
77186	4572	4112343	1993-12-01	1993-12-01 00:00:00	1993-12-13	1993-12-13 00:00:00	32020		\N	304639	0	195662009	4112343		0
87978	5234	195588	1977-10-06	1977-10-06 00:00:00	1977-11-24	1977-11-24 00:00:00	32020		\N	348226	0	38822007	195588		0
88124	5240	4218389	2001-12-13	2001-12-13 00:00:00	2002-01-03	2002-01-03 00:00:00	32020		\N	348613	0	39848009	4218389		0
88305	5251	4029498	1922-02-27	1922-02-27 00:00:00	\N	\N	32020		\N	349386	0	128613002	4029498		0
88398	5255	28060	1993-07-02	1993-07-02 00:00:00	1993-07-12	1993-07-12 00:00:00	32020		\N	349677	0	43878008	28060		0
88730	5276	40481087	1967-04-07	1967-04-07 00:00:00	1967-04-28	1967-04-28 00:00:00	32020		\N	350923	0	444814009	40481087		0
88864	5283	4237458	1975-08-21	1975-08-21 00:00:00	1975-11-19	1975-11-19 00:00:00	32020		\N	351476	0	58150001	4237458		0
89046	5298	81151	1975-12-21	1975-12-21 00:00:00	1976-01-18	1976-01-18 00:00:00	32020		\N	352436	0	44465007	81151		0
89244	5309	4156265	1986-04-21	1986-04-21 00:00:00	1986-05-05	1986-05-05 00:00:00	32020		\N	353148	0	370247008	4156265		0
89361	5315	4112343	1959-04-09	1959-04-09 00:00:00	1959-04-20	1959-04-20 00:00:00	32020		\N	353465	0	195662009	4112343		0
89759	5335	4112343	1973-05-07	1973-05-07 00:00:00	1973-05-17	1973-05-17 00:00:00	32020		\N	355303	0	195662009	4112343		0
80282	4757	4027663	1984-03-21	1984-03-21 00:00:00	\N	\N	32020		\N	316890	0	13200003	4027663		0
81833	4853	372328	1963-07-03	1963-07-03 00:00:00	1963-07-17	1963-07-17 00:00:00	32020		\N	322880	0	65363002	372328		0
85418	5079	372328	1970-12-11	1970-12-11 00:00:00	1970-12-25	1970-12-25 00:00:00	32020		\N	337679	0	65363002	372328		0
85535	5085	28060	1977-04-11	1977-04-11 00:00:00	1977-04-18	1977-04-18 00:00:00	32020		\N	338118	0	43878008	28060		0
85663	5096	40481087	2012-05-10	2012-05-10 00:00:00	2012-05-17	2012-05-17 00:00:00	32020		\N	338563	0	444814009	40481087		0
85977	5116	260139	1970-05-07	1970-05-07 00:00:00	1970-05-21	1970-05-21 00:00:00	32020		\N	339993	0	10509002	260139		0
75466	4480	28060	1995-10-07	1995-10-07 00:00:00	1995-10-18	1995-10-18 00:00:00	32020		\N	298137	0	43878008	28060		0
86198	5128	40481087	1982-05-27	1982-05-27 00:00:00	1982-06-10	1982-06-10 00:00:00	32020		\N	340973	0	444814009	40481087		0
75861	4500	4112343	2008-07-16	2008-07-16 00:00:00	2008-07-29	2008-07-29 00:00:00	32020		\N	299593	0	195662009	4112343		0
86491	5146	4112343	1994-01-10	1994-01-10 00:00:00	1994-01-22	1994-01-22 00:00:00	32020		\N	342136	0	195662009	4112343		0
86802	5168	439777	2015-02-15	2015-02-15 00:00:00	\N	\N	32020		\N	343612	0	271737000	439777		0
87261	5195	260139	1980-03-05	1980-03-05 00:00:00	1980-03-19	1980-03-19 00:00:00	32020		\N	345445	0	10509002	260139		0
87439	5203	40481087	1952-09-22	1952-09-22 00:00:00	1952-10-13	1952-10-13 00:00:00	32020		\N	346055	0	444814009	40481087		0
87527	5207	372328	1957-12-31	1957-12-31 00:00:00	1958-06-18	1958-06-18 00:00:00	32020		\N	346310	0	65363002	372328		0
77187	4572	28060	1981-05-17	1981-05-17 00:00:00	1981-05-27	1981-05-27 00:00:00	32020		\N	304600	0	43878008	28060		0
87979	5234	4310024	1978-03-21	1978-03-21 00:00:00	\N	\N	32020		\N	348226	0	424802006	4310024		0
88125	5240	4142905	1997-04-08	1997-04-08 00:00:00	1997-06-07	1997-06-07 00:00:00	32020		\N	348612	0	33737001	4142905		0
88306	5251	380378	1922-02-27	1922-02-27 00:00:00	\N	\N	32020		\N	349386	0	84757009	380378		0
88399	5255	81893	1994-06-08	1994-06-08 00:00:00	\N	\N	32020		\N	349677	0	64766004	81893		0
88731	5276	40479768	2015-05-14	2015-05-14 00:00:00	2015-06-20	2015-06-20 00:00:00	32020		\N	350921	0	444470001	40479768		0
88865	5283	28060	1981-02-22	1981-02-22 00:00:00	1981-03-05	1981-03-05 00:00:00	32020		\N	351411	0	43878008	28060		0
89047	5298	40481087	1963-11-21	1963-11-21 00:00:00	1963-12-05	1963-12-05 00:00:00	32020		\N	352410	0	444814009	40481087		0
89245	5309	40481087	1978-05-19	1978-05-19 00:00:00	1978-06-02	1978-06-02 00:00:00	32020		\N	353063	0	444814009	40481087		0
89362	5315	257012	1932-08-14	1932-08-14 00:00:00	\N	\N	32020		\N	353532	0	40055000	257012		0
89760	5335	40481087	1971-07-01	1971-07-01 00:00:00	1971-07-22	1971-07-22 00:00:00	32020		\N	355245	0	444814009	40481087		0
80283	4757	4112343	1983-12-28	1983-12-28 00:00:00	1984-01-09	1984-01-09 00:00:00	32020		\N	316890	0	195662009	4112343		0
81834	4853	260139	2018-09-06	2018-09-06 00:00:00	2018-09-20	2018-09-20 00:00:00	32020		\N	322929	0	10509002	260139		0
85419	5079	4112343	2002-12-15	2002-12-15 00:00:00	2002-12-25	2002-12-25 00:00:00	32020		\N	337715	0	195662009	4112343		0
85536	5085	4112343	2009-05-14	2009-05-14 00:00:00	2009-05-27	2009-05-27 00:00:00	32020		\N	338100	0	195662009	4112343		0
85664	5096	4112343	1980-08-17	1980-08-17 00:00:00	1980-08-30	1980-08-30 00:00:00	32020		\N	338562	0	195662009	4112343		0
85978	5116	40481087	1976-11-13	1976-11-13 00:00:00	1976-11-27	1976-11-27 00:00:00	32020		\N	339889	0	444814009	40481087		0
75467	4480	4112343	2014-06-24	2014-06-24 00:00:00	2014-07-07	2014-07-07 00:00:00	32020		\N	298143	0	195662009	4112343		0
86199	5128	4112343	1963-06-29	1963-06-29 00:00:00	1963-07-06	1963-07-06 00:00:00	32020		\N	340959	0	195662009	4112343		0
75862	4500	4048171	1963-09-20	1963-09-20 00:00:00	\N	\N	32020		\N	299645	0	232353008	4048171		0
86492	5146	260139	1947-03-04	1947-03-04 00:00:00	1947-03-11	1947-03-11 00:00:00	32020		\N	342084	0	10509002	260139		0
86803	5168	260139	1979-08-03	1979-08-03 00:00:00	1979-08-10	1979-08-10 00:00:00	32020		\N	343650	0	10509002	260139		0
87262	5195	80180	1995-05-29	1995-05-29 00:00:00	\N	\N	32020		\N	345424	0	396275006	80180		0
87440	5203	4112343	1949-11-23	1949-11-23 00:00:00	1949-12-03	1949-12-03 00:00:00	32020		\N	346077	0	195662009	4112343		0
87528	5207	260139	2001-07-21	2001-07-21 00:00:00	2001-07-28	2001-07-28 00:00:00	32020		\N	346349	0	10509002	260139		0
77188	4572	4112343	1994-03-15	1994-03-15 00:00:00	1994-03-23	1994-03-23 00:00:00	32020		\N	304601	0	195662009	4112343		0
87980	5234	4112343	1956-11-18	1956-11-18 00:00:00	1956-11-30	1956-11-30 00:00:00	32020		\N	348244	0	195662009	4112343		0
88126	5240	4283893	1970-08-21	1970-08-21 00:00:00	1970-10-09	1970-10-09 00:00:00	32020		\N	348641	0	36971009	4283893		0
88308	5252	40481087	2000-01-19	2000-01-19 00:00:00	2000-02-02	2000-02-02 00:00:00	32020		\N	349389	0	444814009	40481087		0
88400	5255	260139	1984-11-22	1984-11-22 00:00:00	1984-11-29	1984-11-29 00:00:00	32020		\N	349667	0	10509002	260139		0
88732	5276	313217	2009-12-27	2009-12-27 00:00:00	\N	\N	32020		\N	350871	0	49436004	313217		0
88866	5283	40481087	1981-02-26	1981-02-26 00:00:00	1981-03-12	1981-03-12 00:00:00	32020		\N	351417	0	444814009	40481087		0
89048	5298	4112343	2001-12-02	2001-12-02 00:00:00	2001-12-14	2001-12-14 00:00:00	32020		\N	352414	0	195662009	4112343		0
89246	5309	257012	1961-11-03	1961-11-03 00:00:00	\N	\N	32020		\N	353054	0	40055000	257012		0
89363	5315	260139	1949-10-23	1949-10-23 00:00:00	1949-11-06	1949-11-06 00:00:00	32020		\N	353533	0	10509002	260139		0
89761	5335	40481087	2007-04-06	2007-04-06 00:00:00	2007-04-13	2007-04-13 00:00:00	32020		\N	355316	0	444814009	40481087		0
80284	4757	260139	2018-10-17	2018-10-17 00:00:00	2018-10-24	2018-10-24 00:00:00	32020		\N	316926	0	10509002	260139		0
81835	4853	40481087	2017-02-06	2017-02-06 00:00:00	2017-02-20	2017-02-20 00:00:00	32020		\N	322875	0	444814009	40481087		0
85434	5081	260139	1997-06-20	1997-06-20 00:00:00	1997-06-27	1997-06-27 00:00:00	32020		\N	337860	0	10509002	260139		0
85537	5085	40481087	2001-04-30	2001-04-30 00:00:00	2001-05-14	2001-05-14 00:00:00	32020		\N	338119	0	444814009	40481087		0
85665	5096	40481087	1991-09-05	1991-09-05 00:00:00	1991-09-19	1991-09-19 00:00:00	32020		\N	338585	0	444814009	40481087		0
85979	5116	260139	1989-04-14	1989-04-14 00:00:00	1989-04-28	1989-04-28 00:00:00	32020		\N	339983	0	10509002	260139		0
75468	4480	81151	1979-06-10	1979-06-10 00:00:00	1979-07-01	1979-07-01 00:00:00	32020		\N	298185	0	44465007	81151		0
86200	5128	4112343	1937-03-18	1937-03-18 00:00:00	1937-03-29	1937-03-29 00:00:00	32020		\N	340964	0	195662009	4112343		0
86321	5138	372328	1989-03-17	1989-03-17 00:00:00	1989-09-01	1989-09-01 00:00:00	32020		\N	341492	0	65363002	372328		0
86493	5146	40481087	1948-08-02	1948-08-02 00:00:00	1948-08-23	1948-08-23 00:00:00	32020		\N	342132	0	444814009	40481087		0
86804	5168	40481087	2019-03-24	2019-03-24 00:00:00	2019-03-31	2019-03-31 00:00:00	32020		\N	343654	0	444814009	40481087		0
87263	5195	4112343	1961-09-11	1961-09-11 00:00:00	1961-09-20	1961-09-20 00:00:00	32020		\N	345411	0	195662009	4112343		0
87441	5203	260139	1996-10-10	1996-10-10 00:00:00	1996-10-17	1996-10-17 00:00:00	32020		\N	346114	0	10509002	260139		0
87529	5207	4112343	1990-03-07	1990-03-07 00:00:00	1990-03-16	1990-03-16 00:00:00	32020		\N	346315	0	195662009	4112343		0
77189	4572	28060	1977-01-08	1977-01-08 00:00:00	1977-01-21	1977-01-21 00:00:00	32020		\N	304610	0	43878008	28060		0
88127	5240	260139	1982-11-08	1982-11-08 00:00:00	1982-11-15	1982-11-15 00:00:00	32020		\N	348642	0	10509002	260139		0
88309	5252	4237458	2005-03-31	2005-03-31 00:00:00	2005-06-29	2005-06-29 00:00:00	32020		\N	349451	0	58150001	4237458		0
88401	5255	260139	1962-01-14	1962-01-14 00:00:00	1962-01-21	1962-01-21 00:00:00	32020		\N	349628	0	10509002	260139		0
88733	5276	260139	1962-06-13	1962-06-13 00:00:00	1962-06-27	1962-06-27 00:00:00	32020		\N	350902	0	10509002	260139		0
88867	5283	257012	1988-08-21	1988-08-21 00:00:00	\N	\N	32020		\N	351413	0	40055000	257012		0
89049	5298	4294548	1970-10-03	1970-10-03 00:00:00	1971-01-23	1971-01-23 00:00:00	32020		\N	352422	0	75498004	4294548		0
89247	5309	40481087	1952-08-09	1952-08-09 00:00:00	1952-08-16	1952-08-16 00:00:00	32020		\N	353053	0	444814009	40481087		0
89364	5315	4027663	1947-06-11	1947-06-11 00:00:00	\N	\N	32020		\N	353473	0	13200003	4027663		0
89762	5335	4113008	1975-08-18	1975-08-18 00:00:00	1975-09-01	1975-09-01 00:00:00	32020		\N	355239	0	284549007	4113008		0
80285	4757	257012	1985-03-22	1985-03-22 00:00:00	\N	\N	32020		\N	316891	0	40055000	257012		0
81836	4853	4112343	2008-10-22	2008-10-22 00:00:00	2008-11-04	2008-11-04 00:00:00	32020		\N	322887	0	195662009	4112343		0
85435	5081	4112343	1928-10-04	1928-10-04 00:00:00	1928-10-14	1928-10-14 00:00:00	32020		\N	337906	0	195662009	4112343		0
85538	5085	4285898	2012-12-19	2012-12-19 00:00:00	\N	\N	32020		\N	338115	0	68496003	4285898		0
85666	5096	260139	1971-03-25	1971-03-25 00:00:00	1971-04-08	1971-04-08 00:00:00	32020		\N	338581	0	10509002	260139		0
85980	5116	40486433	1967-06-05	1967-06-05 00:00:00	1983-06-03	1983-06-03 00:00:00	32020		\N	339992	0	446096008	40486433		0
75469	4480	40481087	2002-04-15	2002-04-15 00:00:00	2002-04-22	2002-04-22 00:00:00	32020		\N	298142	0	444814009	40481087		0
86201	5128	40481087	1993-07-21	1993-07-21 00:00:00	1993-07-28	1993-07-28 00:00:00	32020		\N	340995	0	444814009	40481087		0
86322	5138	40481087	1998-06-21	1998-06-21 00:00:00	1998-07-05	1998-07-05 00:00:00	32020		\N	341477	0	444814009	40481087		0
86494	5146	80180	1979-02-13	1979-02-13 00:00:00	\N	\N	32020		\N	342155	0	396275006	80180		0
86805	5168	260139	1973-05-17	1973-05-17 00:00:00	1973-05-24	1973-05-24 00:00:00	32020		\N	343649	0	10509002	260139		0
87264	5195	372328	1964-07-25	1964-07-25 00:00:00	1965-01-27	1965-01-27 00:00:00	32020		\N	345436	0	65363002	372328		0
87442	5203	40481087	1996-12-14	1996-12-14 00:00:00	1996-12-21	1996-12-21 00:00:00	32020		\N	346082	0	444814009	40481087		0
87530	5207	260139	1997-09-13	1997-09-13 00:00:00	1997-09-27	1997-09-27 00:00:00	32020		\N	346379	0	10509002	260139		0
77190	4572	4112343	1985-03-09	1985-03-09 00:00:00	1985-03-16	1985-03-16 00:00:00	32020		\N	304647	0	195662009	4112343		0
88128	5240	257012	1990-09-23	1990-09-23 00:00:00	\N	\N	32020		\N	348717	0	40055000	257012		0
88310	5252	381316	2018-11-27	2018-11-27 00:00:00	\N	\N	32020		\N	349481	0	230690007	381316		0
88402	5255	4112343	1977-01-17	1977-01-17 00:00:00	1977-01-25	1977-01-25 00:00:00	32020		\N	349665	0	195662009	4112343		0
88734	5276	4112343	2005-06-08	2005-06-08 00:00:00	2005-06-21	2005-06-21 00:00:00	32020		\N	350878	0	195662009	4112343		0
88868	5283	78272	1982-11-12	1982-11-12 00:00:00	1982-12-17	1982-12-17 00:00:00	32020		\N	351477	0	70704007	78272		0
89050	5298	40481087	1971-07-27	1971-07-27 00:00:00	1971-08-17	1971-08-17 00:00:00	32020		\N	352412	0	444814009	40481087		0
89248	5309	40481087	1978-10-05	1978-10-05 00:00:00	1978-10-19	1978-10-19 00:00:00	32020		\N	353117	0	444814009	40481087		0
89365	5315	4112343	1977-02-15	1977-02-15 00:00:00	1977-02-26	1977-02-26 00:00:00	32020		\N	353467	0	195662009	4112343		0
89763	5335	40481087	1966-10-14	1966-10-14 00:00:00	1966-10-28	1966-10-28 00:00:00	32020		\N	355257	0	444814009	40481087		0
80286	4757	260139	1985-09-02	1985-09-02 00:00:00	1985-09-09	1985-09-09 00:00:00	32020		\N	316893	0	10509002	260139		0
81837	4853	4027663	1988-05-02	1988-05-02 00:00:00	\N	\N	32020		\N	322942	0	13200003	4027663		0
85436	5081	260139	1970-07-07	1970-07-07 00:00:00	1970-07-21	1970-07-21 00:00:00	32020		\N	337850	0	10509002	260139		0
85539	5085	80180	2013-11-14	2013-11-14 00:00:00	\N	\N	32020		\N	338115	0	396275006	80180		0
85667	5096	257012	1981-10-24	1981-10-24 00:00:00	\N	\N	32020		\N	338582	0	40055000	257012		0
85981	5116	81151	1979-07-24	1979-07-24 00:00:00	1979-08-14	1979-08-14 00:00:00	32020		\N	339887	0	44465007	81151		0
75470	4480	4112343	1964-10-01	1964-10-01 00:00:00	1964-10-09	1964-10-09 00:00:00	32020		\N	298140	0	195662009	4112343		0
86202	5128	40481087	1935-11-26	1935-11-26 00:00:00	1935-12-10	1935-12-10 00:00:00	32020		\N	340938	0	444814009	40481087		0
86323	5138	4112343	1992-10-15	1992-10-15 00:00:00	1992-10-28	1992-10-28 00:00:00	32020		\N	341474	0	195662009	4112343		0
86495	5146	4113008	1953-08-19	1953-08-19 00:00:00	1953-09-02	1953-09-02 00:00:00	32020		\N	342082	0	284549007	4113008		0
86806	5168	4112343	1999-02-16	1999-02-16 00:00:00	1999-02-24	1999-02-24 00:00:00	32020		\N	343637	0	195662009	4112343		0
87265	5195	260139	2001-02-08	2001-02-08 00:00:00	2001-02-22	2001-02-22 00:00:00	32020		\N	345466	0	10509002	260139		0
87443	5203	4112343	1950-02-04	1950-02-04 00:00:00	1950-02-11	1950-02-11 00:00:00	32020		\N	346054	0	195662009	4112343		0
87542	5210	4027663	2004-11-28	2004-11-28 00:00:00	\N	\N	32020		\N	346467	0	13200003	4027663		0
87649	5215	4142905	1941-04-08	1941-04-08 00:00:00	1941-07-07	1941-07-07 00:00:00	32020		\N	346836	0	33737001	4142905		0
88129	5240	78272	1974-05-22	1974-05-22 00:00:00	1974-06-19	1974-06-19 00:00:00	32020		\N	348608	0	70704007	78272		0
88311	5252	40481087	1966-02-24	1966-02-24 00:00:00	1966-03-10	1966-03-10 00:00:00	32020		\N	349457	0	444814009	40481087		0
88403	5255	4112343	2018-06-24	2018-06-24 00:00:00	2018-07-06	2018-07-06 00:00:00	32020		\N	349668	0	195662009	4112343		0
88736	5276	81151	1965-08-10	1965-08-10 00:00:00	1965-08-31	1965-08-31 00:00:00	32020		\N	350944	0	44465007	81151		0
88869	5284	4299128	2002-05-17	2002-05-17 00:00:00	2002-05-31	2002-05-31 00:00:00	32020		\N	351518	0	403192003	4299128		0
89051	5298	80180	1973-12-06	1973-12-06 00:00:00	\N	\N	32020		\N	352412	0	396275006	80180		0
89249	5309	260139	1954-04-14	1954-04-14 00:00:00	1954-04-21	1954-04-21 00:00:00	32020		\N	353086	0	10509002	260139		0
89366	5315	40481087	1922-06-26	1922-06-26 00:00:00	1922-07-10	1922-07-10 00:00:00	32020		\N	353527	0	444814009	40481087		0
89764	5335	40481087	2004-11-27	2004-11-27 00:00:00	2004-12-11	2004-12-11 00:00:00	32020		\N	355305	0	444814009	40481087		0
80287	4757	4294548	1985-02-22	1985-02-22 00:00:00	1985-05-17	1985-05-17 00:00:00	32020		\N	316912	0	75498004	4294548		0
81838	4853	4266809	1999-04-20	1999-04-20 00:00:00	\N	\N	32020		\N	322926	0	397881000	4266809		0
85437	5081	40481087	1988-06-02	1988-06-02 00:00:00	1988-06-23	1988-06-23 00:00:00	32020		\N	337913	0	444814009	40481087		0
85540	5085	40481087	2009-05-11	2009-05-11 00:00:00	2009-05-25	2009-05-25 00:00:00	32020		\N	338120	0	444814009	40481087		0
85668	5096	260139	1989-04-29	1989-04-29 00:00:00	1989-05-13	1989-05-13 00:00:00	32020		\N	338584	0	10509002	260139		0
85982	5116	28060	1992-06-04	1992-06-04 00:00:00	1992-06-16	1992-06-16 00:00:00	32020		\N	340001	0	43878008	28060		0
75471	4480	80180	1998-08-10	1998-08-10 00:00:00	\N	\N	32020		\N	298138	0	396275006	80180		0
86203	5128	4296204	2008-01-08	2008-01-08 00:00:00	2008-02-05	2008-02-05 00:00:00	32020		\N	340920	0	403190006	4296204		0
86324	5138	260139	1993-02-12	1993-02-12 00:00:00	1993-02-26	1993-02-26 00:00:00	32020		\N	341504	0	10509002	260139		0
86496	5146	40481087	1987-04-02	1987-04-02 00:00:00	1987-04-23	1987-04-23 00:00:00	32020		\N	342135	0	444814009	40481087		0
86807	5168	372328	1973-04-27	1973-04-27 00:00:00	1973-08-03	1973-08-03 00:00:00	32020		\N	343605	0	65363002	372328		0
87266	5195	40481087	1981-07-24	1981-07-24 00:00:00	1981-08-14	1981-08-14 00:00:00	32020		\N	345432	0	444814009	40481087		0
87444	5203	40481087	1949-11-03	1949-11-03 00:00:00	1949-11-17	1949-11-17 00:00:00	32020		\N	346101	0	444814009	40481087		0
87543	5210	40481087	2003-11-21	2003-11-21 00:00:00	2003-11-28	2003-11-28 00:00:00	32020		\N	346467	0	444814009	40481087		0
87650	5215	4237458	2004-03-30	2004-03-30 00:00:00	2004-05-29	2004-05-29 00:00:00	32020		\N	346922	0	58150001	4237458		0
88130	5240	40481087	1999-06-07	1999-06-07 00:00:00	1999-06-28	1999-06-28 00:00:00	32020		\N	348614	0	444814009	40481087		0
88312	5252	260139	1961-04-17	1961-04-17 00:00:00	1961-04-24	1961-04-24 00:00:00	32020		\N	349453	0	10509002	260139		0
88404	5255	4283893	1997-08-11	1997-08-11 00:00:00	1997-09-08	1997-09-08 00:00:00	32020		\N	349637	0	36971009	4283893		0
88737	5276	40481087	1988-10-10	1988-10-10 00:00:00	1988-10-24	1988-10-24 00:00:00	32020		\N	350914	0	444814009	40481087		0
88870	5284	260139	2010-08-07	2010-08-07 00:00:00	2010-08-21	2010-08-21 00:00:00	32020		\N	351598	0	10509002	260139		0
89052	5298	40481087	1974-04-11	1974-04-11 00:00:00	1974-05-02	1974-05-02 00:00:00	32020		\N	352386	0	444814009	40481087		0
89260	5312	28060	1995-01-14	1995-01-14 00:00:00	1995-01-22	1995-01-22 00:00:00	32020		\N	353270	0	43878008	28060		0
89367	5315	372328	1919-06-18	1919-06-18 00:00:00	1919-11-23	1919-11-23 00:00:00	32020		\N	353531	0	65363002	372328		0
89765	5335	4112343	2001-07-01	2001-07-01 00:00:00	2001-07-11	2001-07-11 00:00:00	32020		\N	355262	0	195662009	4112343		0
80288	4757	4112343	1971-07-09	1971-07-09 00:00:00	1971-07-18	1971-07-18 00:00:00	32020		\N	316910	0	195662009	4112343		0
85438	5081	4296204	1919-11-05	1919-11-05 00:00:00	1919-12-10	1919-12-10 00:00:00	32020		\N	337897	0	403190006	4296204		0
85541	5086	192671	2010-03-26	2010-03-26 00:00:00	\N	\N	32020		\N	338170	0	K92.2	35208414		0
85669	5096	260139	1993-11-07	1993-11-07 00:00:00	1993-11-21	1993-11-21 00:00:00	32020		\N	338586	0	10509002	260139		0
85983	5116	4112343	2006-05-21	2006-05-21 00:00:00	2006-05-29	2006-05-29 00:00:00	32020		\N	339942	0	195662009	4112343		0
75472	4480	40481087	1997-06-18	1997-06-18 00:00:00	1997-07-02	1997-07-02 00:00:00	32020		\N	298138	0	444814009	40481087		0
86204	5128	372328	1930-04-15	1930-04-15 00:00:00	1930-07-16	1930-07-16 00:00:00	32020		\N	340924	0	65363002	372328		0
86325	5138	78272	2009-05-18	2009-05-18 00:00:00	2009-06-08	2009-06-08 00:00:00	32020		\N	341454	0	70704007	78272		0
86497	5146	4283893	1969-10-23	1969-10-23 00:00:00	1969-12-11	1969-12-11 00:00:00	32020		\N	342088	0	36971009	4283893		0
86808	5168	80180	2010-01-07	2010-01-07 00:00:00	\N	\N	32020		\N	343623	0	396275006	80180		0
87267	5195	4230399	2015-09-08	2015-09-08 00:00:00	2015-12-07	2015-12-07 00:00:00	32020		\N	345410	0	359817006	4230399		0
87445	5203	40481087	1997-01-29	1997-01-29 00:00:00	1997-02-19	1997-02-19 00:00:00	32020		\N	346057	0	444814009	40481087		0
87544	5210	40481087	1991-12-08	1991-12-08 00:00:00	1991-12-29	1991-12-29 00:00:00	32020		\N	346465	0	444814009	40481087		0
87651	5215	4296204	2002-05-12	2002-05-12 00:00:00	2002-06-09	2002-06-09 00:00:00	32020		\N	346843	0	403190006	4296204		0
88131	5240	78272	1969-06-19	1969-06-19 00:00:00	1969-07-17	1969-07-17 00:00:00	32020		\N	348607	0	70704007	78272		0
88405	5255	133834	1964-02-08	1964-02-08 00:00:00	1977-03-01	1977-03-01 00:00:00	32020		\N	349629	0	24079001	133834		0
88738	5276	80180	1998-03-25	1998-03-25 00:00:00	\N	\N	32020		\N	350952	0	396275006	80180		0
88871	5284	378001	1979-04-18	1979-04-18 00:00:00	1979-06-17	1979-06-17 00:00:00	32020		\N	351516	0	62106007	378001		0
89053	5298	4113008	1986-07-24	1986-07-24 00:00:00	1986-08-07	1986-08-07 00:00:00	32020		\N	352437	0	284549007	4113008		0
89261	5312	260139	1961-12-09	1961-12-09 00:00:00	1961-12-16	1961-12-16 00:00:00	32020		\N	353249	0	10509002	260139		0
89368	5315	4283893	1932-06-26	1932-06-26 00:00:00	1932-09-25	1932-09-25 00:00:00	32020		\N	353497	0	36971009	4283893		0
89779	5337	378001	1987-01-24	1987-01-24 00:00:00	1987-03-25	1987-03-25 00:00:00	32020		\N	355388	0	62106007	378001		0
80289	4757	40481087	2007-01-06	2007-01-06 00:00:00	2007-01-27	2007-01-27 00:00:00	32020		\N	316895	0	444814009	40481087		0
85439	5081	40481087	2004-01-08	2004-01-08 00:00:00	2004-01-29	2004-01-29 00:00:00	32020		\N	337867	0	444814009	40481087		0
85542	5086	4112343	2018-07-25	2018-07-25 00:00:00	2018-08-07	2018-08-07 00:00:00	32020		\N	338140	0	195662009	4112343		0
85670	5096	372328	2001-02-14	2001-02-14 00:00:00	2002-11-28	2002-11-28 00:00:00	32020		\N	338606	0	65363002	372328		0
85984	5117	4237458	1988-03-16	1988-03-16 00:00:00	1988-06-14	1988-06-14 00:00:00	32020		\N	340144	0	58150001	4237458		0
75473	4480	378001	1980-07-25	1980-07-25 00:00:00	1980-08-24	1980-08-24 00:00:00	32020		\N	298186	0	62106007	378001		0
86205	5128	372328	1929-08-25	1929-08-25 00:00:00	1930-01-15	1930-01-15 00:00:00	32020		\N	340979	0	65363002	372328		0
86326	5138	40481087	1985-07-30	1985-07-30 00:00:00	1985-08-20	1985-08-20 00:00:00	32020		\N	341462	0	444814009	40481087		0
86498	5146	4112343	1972-02-23	1972-02-23 00:00:00	1972-03-04	1972-03-04 00:00:00	32020		\N	342134	0	195662009	4112343		0
86809	5168	40481087	2015-11-21	2015-11-21 00:00:00	2015-12-05	2015-12-05 00:00:00	32020		\N	343625	0	444814009	40481087		0
87268	5195	40481087	1982-08-15	1982-08-15 00:00:00	1982-08-22	1982-08-22 00:00:00	32020		\N	345434	0	444814009	40481087		0
87545	5210	40481087	1994-06-17	1994-06-17 00:00:00	1994-07-08	1994-07-08 00:00:00	32020		\N	346451	0	444814009	40481087		0
87652	5215	4112343	1945-08-28	1945-08-28 00:00:00	1945-09-05	1945-09-05 00:00:00	32020		\N	346865	0	195662009	4112343		0
88132	5240	4112343	2001-04-28	2001-04-28 00:00:00	2001-05-07	2001-05-07 00:00:00	32020		\N	348615	0	195662009	4112343		0
88406	5255	81151	1965-08-08	1965-08-08 00:00:00	1965-09-12	1965-09-12 00:00:00	32020		\N	349698	0	44465007	81151		0
88739	5276	40481087	2011-06-05	2011-06-05 00:00:00	2011-06-26	2011-06-26 00:00:00	32020		\N	350936	0	444814009	40481087		0
88872	5284	40481087	2005-10-01	2005-10-01 00:00:00	2005-10-22	2005-10-22 00:00:00	32020		\N	351525	0	444814009	40481087		0
89054	5298	40481087	1941-12-28	1941-12-28 00:00:00	1942-01-18	1942-01-18 00:00:00	32020		\N	352408	0	444814009	40481087		0
89262	5312	28060	1961-07-13	1961-07-13 00:00:00	1961-07-26	1961-07-26 00:00:00	32020		\N	353283	0	43878008	28060		0
89369	5315	80180	1957-03-25	1957-03-25 00:00:00	\N	\N	32020		\N	353514	0	396275006	80180		0
89780	5337	372328	1971-12-14	1971-12-14 00:00:00	1972-01-30	1972-01-30 00:00:00	32020		\N	355466	0	65363002	372328		0
80290	4757	4112343	1991-05-03	1991-05-03 00:00:00	1991-05-15	1991-05-15 00:00:00	32020		\N	316902	0	195662009	4112343		0
85440	5081	4152936	1986-09-04	1986-09-04 00:00:00	1986-09-25	1986-09-25 00:00:00	32020		\N	337905	0	283385000	4152936		0
85543	5086	372328	1970-08-21	1970-08-21 00:00:00	1970-12-03	1970-12-03 00:00:00	32020		\N	338141	0	65363002	372328		0
85671	5096	80180	2008-08-20	2008-08-20 00:00:00	\N	\N	32020		\N	338623	0	396275006	80180		0
85985	5117	4112343	1967-09-23	1967-09-23 00:00:00	1967-10-06	1967-10-06 00:00:00	32020		\N	340127	0	195662009	4112343		0
75474	4480	40481087	1987-08-17	1987-08-17 00:00:00	1987-08-31	1987-08-31 00:00:00	32020		\N	298124	0	444814009	40481087		0
86206	5128	260139	2009-07-26	2009-07-26 00:00:00	2009-08-02	2009-08-02 00:00:00	32020		\N	340976	0	10509002	260139		0
86327	5138	40481087	1990-04-04	1990-04-04 00:00:00	1990-04-25	1990-04-25 00:00:00	32020		\N	341463	0	444814009	40481087		0
86499	5146	40481087	1962-02-19	1962-02-19 00:00:00	1962-02-26	1962-02-26 00:00:00	32020		\N	342086	0	444814009	40481087		0
86810	5168	372328	1971-05-27	1971-05-27 00:00:00	1971-08-06	1971-08-06 00:00:00	32020		\N	343638	0	65363002	372328		0
87269	5195	40481087	2009-04-08	2009-04-08 00:00:00	2009-04-29	2009-04-29 00:00:00	32020		\N	345435	0	444814009	40481087		0
87546	5210	28060	1974-01-26	1974-01-26 00:00:00	1974-02-02	1974-02-02 00:00:00	32020		\N	346474	0	43878008	28060		0
87653	5215	4112343	1949-06-18	1949-06-18 00:00:00	1949-07-01	1949-07-01 00:00:00	32020		\N	346822	0	195662009	4112343		0
88133	5240	4112343	1965-08-24	1965-08-24 00:00:00	1965-09-03	1965-09-03 00:00:00	32020		\N	348692	0	195662009	4112343		0
88407	5255	4156265	2015-12-18	2015-12-18 00:00:00	2016-01-01	2016-01-01 00:00:00	32020		\N	349706	0	370247008	4156265		0
88740	5276	40481087	1979-01-01	1979-01-01 00:00:00	1979-01-22	1979-01-22 00:00:00	32020		\N	350913	0	444814009	40481087		0
88873	5284	4112343	2007-05-11	2007-05-11 00:00:00	2007-05-19	2007-05-19 00:00:00	32020		\N	351617	0	195662009	4112343		0
89055	5298	260139	1943-01-26	1943-01-26 00:00:00	1943-02-09	1943-02-09 00:00:00	32020		\N	352442	0	10509002	260139		0
89263	5312	4296204	2004-12-16	2004-12-16 00:00:00	2005-01-06	2005-01-06 00:00:00	32020		\N	353231	0	403190006	4296204		0
89370	5315	372328	1917-10-22	1917-10-22 00:00:00	1917-11-25	1917-11-25 00:00:00	32020		\N	353530	0	65363002	372328		0
89781	5337	80180	2010-09-30	2010-09-30 00:00:00	\N	\N	32020		\N	355492	0	396275006	80180		0
80291	4757	4112343	1971-10-20	1971-10-20 00:00:00	1971-10-30	1971-10-30 00:00:00	32020		\N	316911	0	195662009	4112343		0
85441	5081	78272	1969-05-10	1969-05-10 00:00:00	1969-05-31	1969-05-31 00:00:00	32020		\N	337902	0	70704007	78272		0
85544	5086	372328	1974-02-24	1974-02-24 00:00:00	1974-09-05	1974-09-05 00:00:00	32020		\N	338162	0	65363002	372328		0
85672	5096	4283893	1981-10-03	1981-10-03 00:00:00	1981-12-19	1981-12-19 00:00:00	32020		\N	338578	0	36971009	4283893		0
85986	5117	4294548	2002-05-30	2002-05-30 00:00:00	2002-09-19	2002-09-19 00:00:00	32020		\N	340133	0	75498004	4294548		0
75475	4480	4059173	1993-12-14	1993-12-14 00:00:00	1994-03-14	1994-03-14 00:00:00	32020		\N	298188	0	16114001	4059173		0
86207	5128	260139	1993-01-11	1993-01-11 00:00:00	1993-01-25	1993-01-25 00:00:00	32020		\N	341006	0	10509002	260139		0
86328	5138	4112343	2017-11-30	2017-11-30 00:00:00	2017-12-10	2017-12-10 00:00:00	32020		\N	341459	0	195662009	4112343		0
86500	5146	260139	1950-11-26	1950-11-26 00:00:00	1950-12-03	1950-12-03 00:00:00	32020		\N	342085	0	10509002	260139		0
86811	5168	81151	2011-05-27	2011-05-27 00:00:00	2011-06-17	2011-06-17 00:00:00	32020		\N	343597	0	44465007	81151		0
87270	5195	40481087	2007-07-19	2007-07-19 00:00:00	2007-08-09	2007-08-09 00:00:00	32020		\N	345467	0	444814009	40481087		0
87547	5210	80180	2015-06-14	2015-06-14 00:00:00	\N	\N	32020		\N	346453	0	396275006	80180		0
87654	5215	81151	2008-08-06	2008-08-06 00:00:00	2008-09-10	2008-09-10 00:00:00	32020		\N	346923	0	44465007	81151		0
88134	5240	40481087	1989-12-02	1989-12-02 00:00:00	1989-12-16	1989-12-16 00:00:00	32020		\N	348715	0	444814009	40481087		0
88408	5255	40481087	1964-01-09	1964-01-09 00:00:00	1964-01-30	1964-01-30 00:00:00	32020		\N	349620	0	444814009	40481087		0
88741	5276	4283893	1998-07-03	1998-07-03 00:00:00	1998-11-13	1998-11-13 00:00:00	32020		\N	350874	0	36971009	4283893		0
88874	5284	40486433	1971-08-30	1971-08-30 00:00:00	1985-08-28	1985-08-28 00:00:00	32020		\N	351489	0	446096008	40486433		0
89056	5298	4109685	1991-08-11	1991-08-11 00:00:00	1991-09-01	1991-09-01 00:00:00	32020		\N	352438	0	284551006	4109685		0
89264	5312	260139	1961-05-04	1961-05-04 00:00:00	1961-05-11	1961-05-11 00:00:00	32020		\N	353248	0	10509002	260139		0
89371	5315	260139	1977-03-02	1977-03-02 00:00:00	1977-03-16	1977-03-16 00:00:00	32020		\N	353504	0	10509002	260139		0
89782	5337	40481087	1982-11-25	1982-11-25 00:00:00	1982-12-16	1982-12-16 00:00:00	32020		\N	355440	0	444814009	40481087		0
80292	4757	40481087	1973-09-28	1973-09-28 00:00:00	1973-10-05	1973-10-05 00:00:00	32020		\N	316880	0	444814009	40481087		0
85442	5081	4112343	1954-03-09	1954-03-09 00:00:00	1954-03-20	1954-03-20 00:00:00	32020		\N	337846	0	195662009	4112343		0
85545	5086	81151	2003-02-20	2003-02-20 00:00:00	2003-03-27	2003-03-27 00:00:00	32020		\N	338200	0	44465007	81151		0
85673	5096	4146173	1975-11-27	1975-11-27 00:00:00	1976-01-26	1976-01-26 00:00:00	32020		\N	338577	0	307731004	4146173		0
85987	5117	40481087	1997-01-28	1997-01-28 00:00:00	1997-02-18	1997-02-18 00:00:00	32020		\N	340084	0	444814009	40481087		0
75476	4480	4112343	1966-09-01	1966-09-01 00:00:00	1966-09-11	1966-09-11 00:00:00	32020		\N	298190	0	195662009	4112343		0
86208	5128	4112343	1976-12-07	1976-12-07 00:00:00	1976-12-16	1976-12-16 00:00:00	32020		\N	340961	0	195662009	4112343		0
86329	5138	80180	2018-05-11	2018-05-11 00:00:00	\N	\N	32020		\N	341473	0	396275006	80180		0
86511	5148	40481087	1965-01-25	1965-01-25 00:00:00	1965-02-15	1965-02-15 00:00:00	32020		\N	342255	0	444814009	40481087		0
86812	5168	4112343	2017-08-15	2017-08-15 00:00:00	2017-08-27	2017-08-27 00:00:00	32020		\N	343626	0	195662009	4112343		0
87271	5195	40481087	2011-03-27	2011-03-27 00:00:00	2011-04-10	2011-04-10 00:00:00	32020		\N	345478	0	444814009	40481087		0
87548	5210	4113008	2009-03-04	2009-03-04 00:00:00	2009-03-18	2009-03-18 00:00:00	32020		\N	346449	0	284549007	4113008		0
87655	5215	40481087	1960-11-22	1960-11-22 00:00:00	1960-12-13	1960-12-13 00:00:00	32020		\N	346867	0	444814009	40481087		0
88135	5240	40481087	1998-04-27	1998-04-27 00:00:00	1998-05-04	1998-05-04 00:00:00	32020		\N	348632	0	444814009	40481087		0
88409	5255	4296204	1961-11-13	1961-11-13 00:00:00	1961-11-27	1961-11-27 00:00:00	32020		\N	349697	0	403190006	4296204		0
88742	5276	4296205	1970-10-04	1970-10-04 00:00:00	1970-10-25	1970-10-25 00:00:00	32020		\N	350945	0	403191005	4296205		0
88875	5284	260139	1969-11-08	1969-11-08 00:00:00	1969-11-15	1969-11-15 00:00:00	32020		\N	351519	0	10509002	260139		0
89057	5298	4283893	2007-12-20	2007-12-20 00:00:00	2008-02-28	2008-02-28 00:00:00	32020		\N	352426	0	36971009	4283893		0
89265	5312	4112343	1997-07-28	1997-07-28 00:00:00	1997-08-06	1997-08-06 00:00:00	32020		\N	353271	0	195662009	4112343		0
89372	5315	40481087	1970-08-02	1970-08-02 00:00:00	1970-08-16	1970-08-16 00:00:00	32020		\N	353502	0	444814009	40481087		0
89783	5337	4048171	1974-02-28	1974-02-28 00:00:00	1993-07-11	1993-07-11 00:00:00	32020		\N	355393	0	232353008	4048171		0
80293	4757	80180	1994-10-05	1994-10-05 00:00:00	\N	\N	32020		\N	316948	0	396275006	80180		0
85443	5081	80180	1955-02-14	1955-02-14 00:00:00	\N	\N	32020		\N	337846	0	396275006	80180		0
85546	5086	4112343	1976-11-18	1976-11-18 00:00:00	1976-12-01	1976-12-01 00:00:00	32020		\N	338158	0	195662009	4112343		0
85674	5096	372328	1972-11-12	1972-11-12 00:00:00	1973-04-12	1973-04-12 00:00:00	32020		\N	338615	0	65363002	372328		0
85988	5117	80180	1998-02-13	1998-02-13 00:00:00	\N	\N	32020		\N	340084	0	396275006	80180		0
75477	4480	4113008	1974-08-21	1974-08-21 00:00:00	1974-09-04	1974-09-04 00:00:00	32020		\N	298184	0	284549007	4113008		0
86209	5128	260139	1966-08-22	1966-08-22 00:00:00	1966-08-29	1966-08-29 00:00:00	32020		\N	340939	0	10509002	260139		0
86330	5138	4278672	2001-08-28	2001-08-28 00:00:00	2001-11-26	2001-11-26 00:00:00	32020		\N	341453	0	65966004	4278672		0
86512	5148	40481087	2000-04-23	2000-04-23 00:00:00	2000-05-14	2000-05-14 00:00:00	32020		\N	342277	0	444814009	40481087		0
86813	5168	28060	2000-04-20	2000-04-20 00:00:00	2000-05-01	2000-05-01 00:00:00	32020		\N	343648	0	43878008	28060		0
87272	5196	4294548	2014-01-03	2014-01-03 00:00:00	2014-01-24	2014-01-24 00:00:00	32020		\N	345490	0	75498004	4294548		0
87549	5210	40481087	1984-04-27	1984-04-27 00:00:00	1984-05-11	1984-05-11 00:00:00	32020		\N	346459	0	444814009	40481087		0
87656	5215	80180	1982-03-19	1982-03-19 00:00:00	\N	\N	32020		\N	346898	0	396275006	80180		0
88136	5240	378001	1955-09-01	1955-09-01 00:00:00	1955-10-01	1955-10-01 00:00:00	32020		\N	348606	0	62106007	378001		0
88410	5255	4218389	1983-03-03	1983-03-03 00:00:00	1983-04-07	1983-04-07 00:00:00	32020		\N	349701	0	39848009	4218389		0
88743	5276	440448	2011-01-07	2011-01-07 00:00:00	\N	\N	32020		\N	350949	0	74400008	440448		0
88876	5284	4112343	1991-10-02	1991-10-02 00:00:00	1991-10-15	1991-10-15 00:00:00	32020		\N	351560	0	195662009	4112343		0
89058	5298	260139	2013-07-29	2013-07-29 00:00:00	2013-08-05	2013-08-05 00:00:00	32020		\N	352464	0	10509002	260139		0
89266	5312	40481087	1970-06-18	1970-06-18 00:00:00	1970-07-09	1970-07-09 00:00:00	32020		\N	353250	0	444814009	40481087		0
89373	5315	4112343	1928-07-19	1928-07-19 00:00:00	1928-08-01	1928-08-01 00:00:00	32020		\N	353483	0	195662009	4112343		0
89784	5337	4278672	1981-07-24	1981-07-24 00:00:00	1981-08-23	1981-08-23 00:00:00	32020		\N	355387	0	65966004	4278672		0
80294	4757	4266809	1994-10-05	1994-10-05 00:00:00	\N	\N	32020		\N	316948	0	397881000	4266809		0
85444	5081	4134304	1989-08-10	1989-08-10 00:00:00	1989-09-09	1989-09-09 00:00:00	32020		\N	337809	0	263102004	4134304		0
85547	5086	40481087	1981-03-17	1981-03-17 00:00:00	1981-04-07	1981-04-07 00:00:00	32020		\N	338182	0	444814009	40481087		0
85675	5096	4112343	1968-10-06	1968-10-06 00:00:00	1968-10-18	1968-10-18 00:00:00	32020		\N	338594	0	195662009	4112343		0
75478	4480	40481087	1963-09-23	1963-09-23 00:00:00	1963-10-14	1963-10-14 00:00:00	32020		\N	298121	0	444814009	40481087		0
86228	5132	81151	1991-09-26	1991-09-26 00:00:00	1991-10-31	1991-10-31 00:00:00	32020		\N	341169	0	44465007	81151		0
86331	5138	4109685	2013-03-19	2013-03-19 00:00:00	2013-04-02	2013-04-02 00:00:00	32020		\N	341456	0	284551006	4109685		0
86513	5148	80180	1998-01-21	1998-01-21 00:00:00	\N	\N	32020		\N	342289	0	396275006	80180		0
86814	5168	4112343	1975-10-06	1975-10-06 00:00:00	1975-10-19	1975-10-19 00:00:00	32020		\N	343647	0	195662009	4112343		0
87273	5196	260139	1958-12-26	1958-12-26 00:00:00	1959-01-02	1959-01-02 00:00:00	32020		\N	345551	0	10509002	260139		0
87550	5210	4112343	2013-07-03	2013-07-03 00:00:00	2013-07-16	2013-07-16 00:00:00	32020		\N	346468	0	195662009	4112343		0
87657	5215	40481087	1994-02-06	1994-02-06 00:00:00	1994-02-13	1994-02-13 00:00:00	32020		\N	346833	0	444814009	40481087		0
88137	5240	40481087	1957-08-22	1957-08-22 00:00:00	1957-09-05	1957-09-05 00:00:00	32020		\N	348691	0	444814009	40481087		0
88411	5255	81151	1999-02-17	1999-02-17 00:00:00	1999-03-03	1999-03-03 00:00:00	32020		\N	349703	0	44465007	81151		0
88744	5277	28060	1968-09-26	1968-09-26 00:00:00	1968-10-09	1968-10-09 00:00:00	32020		\N	351041	0	43878008	28060		0
88877	5284	440086	1980-08-20	1980-08-20 00:00:00	1981-02-25	1981-02-25 00:00:00	32020		\N	351599	0	192127007	440086		0
89059	5299	40481087	1986-04-30	1986-04-30 00:00:00	1986-05-14	1986-05-14 00:00:00	32020		\N	352543	0	444814009	40481087		0
89267	5312	40481087	1987-06-28	1987-06-28 00:00:00	1987-07-19	1987-07-19 00:00:00	32020		\N	353293	0	444814009	40481087		0
89374	5315	375671	1926-02-26	1926-02-26 00:00:00	1926-04-27	1926-04-27 00:00:00	32020		\N	353458	0	62564004	375671		0
89785	5337	372328	1974-12-15	1974-12-15 00:00:00	1975-02-02	1975-02-02 00:00:00	32020		\N	355486	0	65363002	372328		0
80295	4757	260139	1961-10-29	1961-10-29 00:00:00	1961-11-05	1961-11-05 00:00:00	32020		\N	316900	0	10509002	260139		0
85445	5081	255848	2006-11-07	2006-11-07 00:00:00	\N	\N	32020		\N	337811	0	233604007	255848		0
85548	5086	4134304	1978-04-02	1978-04-02 00:00:00	1978-05-02	1978-05-02 00:00:00	32020		\N	338199	0	263102004	4134304		0
85676	5096	4112343	2014-10-03	2014-10-03 00:00:00	2014-10-13	2014-10-13 00:00:00	32020		\N	338580	0	195662009	4112343		0
75479	4480	4112343	1969-02-28	1969-02-28 00:00:00	1969-03-07	1969-03-07 00:00:00	32020		\N	298135	0	195662009	4112343		0
86229	5132	40481087	1994-11-09	1994-11-09 00:00:00	1994-11-30	1994-11-30 00:00:00	32020		\N	341130	0	444814009	40481087		0
86332	5138	4134304	2011-02-28	2011-02-28 00:00:00	2011-04-29	2011-04-29 00:00:00	32020		\N	341455	0	263102004	4134304		0
86514	5148	4237458	1996-05-07	1996-05-07 00:00:00	1996-07-06	1996-07-06 00:00:00	32020		\N	342223	0	58150001	4237458		0
86815	5168	40481087	2010-02-20	2010-02-20 00:00:00	2010-03-13	2010-03-13 00:00:00	32020		\N	343652	0	444814009	40481087		0
87274	5196	378001	1961-11-08	1961-11-08 00:00:00	1962-01-07	1962-01-07 00:00:00	32020		\N	345567	0	62106007	378001		0
87551	5210	4310024	2013-02-24	2013-02-24 00:00:00	\N	\N	32020		\N	346486	0	424802006	4310024		0
87658	5215	40481087	1958-12-13	1958-12-13 00:00:00	1958-12-27	1958-12-27 00:00:00	32020		\N	346866	0	444814009	40481087		0
88138	5240	40481087	1956-07-05	1956-07-05 00:00:00	1956-07-19	1956-07-19 00:00:00	32020		\N	348712	0	444814009	40481087		0
88412	5255	4152936	2004-06-04	2004-06-04 00:00:00	2004-06-18	2004-06-18 00:00:00	32020		\N	349704	0	283385000	4152936		0
88745	5277	260139	1990-09-21	1990-09-21 00:00:00	1990-10-05	1990-10-05 00:00:00	32020		\N	351042	0	10509002	260139		0
88878	5284	80180	2008-07-29	2008-07-29 00:00:00	\N	\N	32020		\N	351591	0	396275006	80180		0
89060	5299	375671	2016-10-28	2016-10-28 00:00:00	2016-11-27	2016-11-27 00:00:00	32020		\N	352488	0	62564004	375671		0
89268	5312	372328	1939-09-26	1939-09-26 00:00:00	1940-01-08	1940-01-08 00:00:00	32020		\N	353296	0	65363002	372328		0
89375	5315	4310024	1954-09-07	1954-09-07 00:00:00	\N	\N	32020		\N	353513	0	424802006	4310024		0
89786	5337	4296204	2009-06-27	2009-06-27 00:00:00	2009-07-25	2009-07-25 00:00:00	32020		\N	355389	0	403190006	4296204		0
80296	4757	4109685	1982-09-06	1982-09-06 00:00:00	1982-09-20	1982-09-20 00:00:00	32020		\N	316962	0	284551006	4109685		0
85446	5081	4112343	1957-11-30	1957-11-30 00:00:00	1957-12-10	1957-12-10 00:00:00	32020		\N	337907	0	195662009	4112343		0
85549	5086	4218389	1970-10-20	1970-10-20 00:00:00	1970-11-10	1970-11-10 00:00:00	32020		\N	338198	0	39848009	4218389		0
85677	5096	260139	2000-09-02	2000-09-02 00:00:00	2000-09-16	2000-09-16 00:00:00	32020		\N	338579	0	10509002	260139		0
75480	4480	260139	2016-09-19	2016-09-19 00:00:00	2016-09-26	2016-09-26 00:00:00	32020		\N	298126	0	10509002	260139		0
86230	5132	4134304	2019-06-06	2019-06-06 00:00:00	\N	\N	32020		\N	341172	0	263102004	4134304		0
86333	5138	40481087	2009-11-10	2009-11-10 00:00:00	2009-12-01	2009-12-01 00:00:00	32020		\N	341458	0	444814009	40481087		0
86515	5148	372328	1975-09-16	1975-09-16 00:00:00	1976-05-04	1976-05-04 00:00:00	32020		\N	342267	0	65363002	372328		0
86816	5168	40481087	2016-12-06	2016-12-06 00:00:00	2016-12-27	2016-12-27 00:00:00	32020		\N	343653	0	444814009	40481087		0
87275	5196	260139	2017-01-08	2017-01-08 00:00:00	2017-01-24	2017-01-24 00:00:00	32020		\N	345544	0	10509002	260139		0
87552	5210	40481087	2002-12-29	2002-12-29 00:00:00	2003-01-19	2003-01-19 00:00:00	32020		\N	346452	0	444814009	40481087		0
87659	5215	4112343	1998-09-23	1998-09-23 00:00:00	1998-10-01	1998-10-01 00:00:00	32020		\N	346834	0	195662009	4112343		0
88139	5240	40481087	1992-11-09	1992-11-09 00:00:00	1992-11-16	1992-11-16 00:00:00	32020		\N	348630	0	444814009	40481087		0
88413	5255	78272	1973-08-31	1973-08-31 00:00:00	1973-09-21	1973-09-21 00:00:00	32020		\N	349699	0	70704007	78272		0
88746	5277	260139	1970-02-17	1970-02-17 00:00:00	1970-03-03	1970-03-03 00:00:00	32020		\N	350959	0	10509002	260139		0
88879	5284	372328	1969-03-11	1969-03-11 00:00:00	1969-07-30	1969-07-30 00:00:00	32020		\N	351543	0	65363002	372328		0
89061	5299	380378	2011-09-18	2011-09-18 00:00:00	\N	\N	32020		\N	352526	0	84757009	380378		0
89269	5312	4112343	2006-10-21	2006-10-21 00:00:00	2006-10-28	2006-10-28 00:00:00	32020		\N	353253	0	195662009	4112343		0
89376	5315	81893	1955-02-04	1955-02-04 00:00:00	\N	\N	32020		\N	353513	0	64766004	81893		0
89787	5337	260139	2014-08-31	2014-08-31 00:00:00	2014-09-07	2014-09-07 00:00:00	32020		\N	355420	0	10509002	260139		0
80297	4757	4112343	1996-07-21	1996-07-21 00:00:00	1996-08-01	1996-08-01 00:00:00	32020		\N	316913	0	195662009	4112343		0
85447	5081	4112343	1918-10-12	1918-10-12 00:00:00	1918-10-25	1918-10-25 00:00:00	32020		\N	337886	0	195662009	4112343		0
85550	5086	40481087	1996-09-23	1996-09-23 00:00:00	1996-09-30	1996-09-30 00:00:00	32020		\N	338139	0	444814009	40481087		0
85678	5097	81151	1979-02-23	1979-02-23 00:00:00	1979-03-16	1979-03-16 00:00:00	32020		\N	338713	0	44465007	81151		0
75481	4480	4112343	1977-12-24	1977-12-24 00:00:00	1978-01-05	1978-01-05 00:00:00	32020		\N	298191	0	195662009	4112343		0
86231	5132	4237458	1979-09-29	1979-09-29 00:00:00	1979-10-29	1979-10-29 00:00:00	32020		\N	341106	0	58150001	4237458		0
86334	5138	4112343	2001-08-13	2001-08-13 00:00:00	2001-08-23	2001-08-23 00:00:00	32020		\N	341457	0	195662009	4112343		0
86516	5148	40481087	2013-02-11	2013-02-11 00:00:00	2013-02-18	2013-02-18 00:00:00	32020		\N	342278	0	444814009	40481087		0
86817	5168	260139	2009-08-04	2009-08-04 00:00:00	2009-08-11	2009-08-11 00:00:00	32020		\N	343610	0	10509002	260139		0
87276	5196	260139	2005-09-04	2005-09-04 00:00:00	2005-09-11	2005-09-11 00:00:00	32020		\N	345513	0	10509002	260139		0
87553	5210	372328	1975-05-20	1975-05-20 00:00:00	1975-11-11	1975-11-11 00:00:00	32020		\N	346454	0	65363002	372328		0
87660	5215	375671	1998-08-01	1998-08-01 00:00:00	1998-09-30	1998-09-30 00:00:00	32020		\N	346842	0	62564004	375671		0
88140	5240	4112343	1947-08-16	1947-08-16 00:00:00	1947-08-28	1947-08-28 00:00:00	32020		\N	348639	0	195662009	4112343		0
88414	5255	4285898	1995-10-01	1995-10-01 00:00:00	\N	\N	32020		\N	349659	0	68496003	4285898		0
88747	5277	40481087	1989-11-22	1989-11-22 00:00:00	1989-12-13	1989-12-13 00:00:00	32020		\N	351031	0	444814009	40481087		0
88880	5284	40481087	1990-08-25	1990-08-25 00:00:00	1990-09-15	1990-09-15 00:00:00	32020		\N	351603	0	444814009	40481087		0
89062	5299	78272	2018-12-17	2018-12-17 00:00:00	2019-01-07	2019-01-07 00:00:00	32020		\N	352489	0	70704007	78272		0
89270	5312	260139	2005-04-24	2005-04-24 00:00:00	2005-05-01	2005-05-01 00:00:00	32020		\N	353272	0	10509002	260139		0
89377	5315	30753	1955-09-02	1955-09-02 00:00:00	\N	\N	32020		\N	353513	0	16761005	30753		0
89788	5337	4112343	1977-08-17	1977-08-17 00:00:00	1977-08-26	1977-08-26 00:00:00	32020		\N	355394	0	195662009	4112343		0
80298	4757	4283893	2004-01-16	2004-01-16 00:00:00	2004-05-14	2004-05-14 00:00:00	32020		\N	316894	0	36971009	4283893		0
85448	5081	4112343	1994-04-08	1994-04-08 00:00:00	1994-04-16	1994-04-16 00:00:00	32020		\N	337833	0	195662009	4112343		0
85551	5086	28060	1980-02-16	1980-02-16 00:00:00	1980-02-27	1980-02-27 00:00:00	32020		\N	338196	0	43878008	28060		0
85679	5097	40481087	2019-05-23	2019-05-23 00:00:00	2019-06-13	2019-06-13 00:00:00	32020		\N	338688	0	444814009	40481087		0
75482	4480	4112343	1964-03-20	1964-03-20 00:00:00	1964-04-02	1964-04-02 00:00:00	32020		\N	298151	0	195662009	4112343		0
86232	5132	40481087	1986-11-28	1986-11-28 00:00:00	1986-12-12	1986-12-12 00:00:00	32020		\N	341110	0	444814009	40481087		0
86335	5138	372328	1978-09-28	1978-09-28 00:00:00	1978-11-10	1978-11-10 00:00:00	32020		\N	341475	0	65363002	372328		0
86517	5148	4278672	1974-09-30	1974-09-30 00:00:00	1974-12-28	1974-12-28 00:00:00	32020		\N	342222	0	65966004	4278672		0
86818	5168	4112343	2014-02-20	2014-02-20 00:00:00	2014-02-28	2014-02-28 00:00:00	32020		\N	343611	0	195662009	4112343		0
87277	5196	40481087	1988-07-29	1988-07-29 00:00:00	1988-08-19	1988-08-19 00:00:00	32020		\N	345565	0	444814009	40481087		0
87554	5210	40481087	1978-05-12	1978-05-12 00:00:00	1978-06-02	1978-06-02 00:00:00	32020		\N	346464	0	444814009	40481087		0
87661	5215	40481087	1997-03-05	1997-03-05 00:00:00	1997-03-19	1997-03-19 00:00:00	32020		\N	346916	0	444814009	40481087		0
88141	5240	372328	1952-05-27	1952-05-27 00:00:00	1952-09-23	1952-09-23 00:00:00	32020		\N	348655	0	65363002	372328		0
88415	5255	378001	2008-04-28	2008-04-28 00:00:00	2008-06-27	2008-06-27 00:00:00	32020		\N	349705	0	62106007	378001		0
88748	5277	40481087	2002-03-18	2002-03-18 00:00:00	2002-04-08	2002-04-08 00:00:00	32020		\N	350962	0	444814009	40481087		0
88881	5284	40481087	1978-11-28	1978-11-28 00:00:00	1978-12-19	1978-12-19 00:00:00	32020		\N	351490	0	444814009	40481087		0
89063	5299	4152936	1994-09-10	1994-09-10 00:00:00	1994-09-24	1994-09-24 00:00:00	32020		\N	352524	0	283385000	4152936		0
89271	5312	40481087	1944-07-07	1944-07-07 00:00:00	1944-07-14	1944-07-14 00:00:00	32020		\N	353281	0	444814009	40481087		0
89378	5316	260139	2011-08-04	2011-08-04 00:00:00	2011-08-18	2011-08-18 00:00:00	32020		\N	353586	0	10509002	260139		0
89789	5337	40481087	1998-07-03	1998-07-03 00:00:00	1998-07-24	1998-07-24 00:00:00	32020		\N	355419	0	444814009	40481087		0
80299	4757	40481087	2004-11-19	2004-11-19 00:00:00	2004-12-10	2004-12-10 00:00:00	32020		\N	316925	0	444814009	40481087		0
85449	5081	260139	1989-08-12	1989-08-12 00:00:00	1989-08-19	1989-08-19 00:00:00	32020		\N	337858	0	10509002	260139		0
85552	5086	4112343	1970-09-24	1970-09-24 00:00:00	1970-10-03	1970-10-03 00:00:00	32020		\N	338181	0	195662009	4112343		0
85680	5097	40481087	1993-10-01	1993-10-01 00:00:00	1993-10-15	1993-10-15 00:00:00	32020		\N	338677	0	444814009	40481087		0
75506	4482	4283893	2005-05-31	2005-05-31 00:00:00	2005-09-06	2005-09-06 00:00:00	32020		\N	298378	0	36971009	4283893		0
86233	5132	40481087	2010-10-15	2010-10-15 00:00:00	2010-10-22	2010-10-22 00:00:00	32020		\N	341133	0	444814009	40481087		0
86368	5142	260139	1963-11-12	1963-11-12 00:00:00	1963-11-26	1963-11-26 00:00:00	32020		\N	341706	0	10509002	260139		0
86518	5148	40481087	1984-11-26	1984-11-26 00:00:00	1984-12-17	1984-12-17 00:00:00	32020		\N	342276	0	444814009	40481087		0
87278	5196	260139	1995-05-16	1995-05-16 00:00:00	1995-05-23	1995-05-23 00:00:00	32020		\N	345545	0	10509002	260139		0
87555	5210	260139	1981-05-20	1981-05-20 00:00:00	1981-05-27	1981-05-27 00:00:00	32020		\N	346458	0	10509002	260139		0
87662	5215	4296205	2017-12-22	2017-12-22 00:00:00	2018-01-05	2018-01-05 00:00:00	32020		\N	346924	0	403191005	4296205		0
88142	5240	4112343	2011-03-03	2011-03-03 00:00:00	2011-03-10	2011-03-10 00:00:00	32020		\N	348654	0	195662009	4112343		0
88416	5256	4294548	2013-09-25	2013-09-25 00:00:00	2013-10-09	2013-10-09 00:00:00	32020		\N	349714	0	75498004	4294548		0
88749	5277	40481087	1960-10-10	1960-10-10 00:00:00	1960-10-17	1960-10-17 00:00:00	32020		\N	351021	0	444814009	40481087		0
88882	5284	40481087	2003-07-14	2003-07-14 00:00:00	2003-08-04	2003-08-04 00:00:00	32020		\N	351524	0	444814009	40481087		0
89064	5299	4283893	1978-06-11	1978-06-11 00:00:00	1978-07-02	1978-07-02 00:00:00	32020		\N	352493	0	36971009	4283893		0
89272	5312	4112343	1951-11-22	1951-11-22 00:00:00	1951-12-02	1951-12-02 00:00:00	32020		\N	353247	0	195662009	4112343		0
89379	5316	4266809	1995-05-23	1995-05-23 00:00:00	\N	\N	32020		\N	353554	0	397881000	4266809		0
89790	5337	4134304	1973-10-04	1973-10-04 00:00:00	1973-11-03	1973-11-03 00:00:00	32020		\N	355386	0	263102004	4134304		0
80300	4757	195588	2008-03-15	2008-03-15 00:00:00	2008-04-21	2008-04-21 00:00:00	32020		\N	316896	0	38822007	195588		0
85450	5081	40481087	1942-04-14	1942-04-14 00:00:00	1942-04-21	1942-04-21 00:00:00	32020		\N	337844	0	444814009	40481087		0
85553	5086	260139	2009-04-30	2009-04-30 00:00:00	2009-05-14	2009-05-14 00:00:00	32020		\N	338159	0	10509002	260139		0
85681	5097	260139	2009-01-11	2009-01-11 00:00:00	2009-01-18	2009-01-18 00:00:00	32020		\N	338745	0	10509002	260139		0
75507	4482	28060	1955-06-07	1955-06-07 00:00:00	1955-06-16	1955-06-16 00:00:00	32020		\N	298407	0	43878008	28060		0
86234	5132	80180	2003-06-15	2003-06-15 00:00:00	\N	\N	32020		\N	341131	0	396275006	80180		0
86369	5142	40481087	1964-08-25	1964-08-25 00:00:00	1964-09-08	1964-09-08 00:00:00	32020		\N	341767	0	444814009	40481087		0
86519	5148	378001	1961-02-09	1961-02-09 00:00:00	1961-03-11	1961-03-11 00:00:00	32020		\N	342219	0	62106007	378001		0
87279	5196	4112343	1959-09-13	1959-09-13 00:00:00	1959-09-22	1959-09-22 00:00:00	32020		\N	345550	0	195662009	4112343		0
87556	5210	40481087	1980-03-28	1980-03-28 00:00:00	1980-04-11	1980-04-11 00:00:00	32020		\N	346457	0	444814009	40481087		0
87663	5215	372328	1941-11-04	1941-11-04 00:00:00	1942-04-20	1942-04-20 00:00:00	32020		\N	346827	0	65363002	372328		0
88143	5241	4142905	1969-04-19	1969-04-19 00:00:00	1969-05-19	1969-05-19 00:00:00	32020		\N	348786	0	33737001	4142905		0
88417	5256	260139	1965-07-16	1965-07-16 00:00:00	1965-07-23	1965-07-23 00:00:00	32020		\N	349710	0	10509002	260139		0
88750	5277	40481087	1995-12-21	1995-12-21 00:00:00	1996-01-11	1996-01-11 00:00:00	32020		\N	350973	0	444814009	40481087		0
88883	5284	260139	1971-07-24	1971-07-24 00:00:00	1971-07-31	1971-07-31 00:00:00	32020		\N	351549	0	10509002	260139		0
89065	5299	192671	2007-03-28	2007-03-28 00:00:00	\N	\N	32020		\N	352548	0	K92.2	35208414		0
89273	5312	40481087	1951-11-14	1951-11-14 00:00:00	1951-12-05	1951-12-05 00:00:00	32020		\N	353251	0	444814009	40481087		0
89380	5316	80180	1995-05-23	1995-05-23 00:00:00	\N	\N	32020		\N	353554	0	396275006	80180		0
80301	4757	4029498	2001-03-17	2001-03-17 00:00:00	\N	\N	32020		\N	316963	0	128613002	4029498		0
85451	5081	40481087	1940-06-24	1940-06-24 00:00:00	1940-07-15	1940-07-15 00:00:00	32020		\N	337843	0	444814009	40481087		0
85554	5086	4112343	1980-12-27	1980-12-27 00:00:00	1981-01-09	1981-01-09 00:00:00	32020		\N	338197	0	195662009	4112343		0
85682	5097	40481087	1987-12-06	1987-12-06 00:00:00	1987-12-27	1987-12-27 00:00:00	32020		\N	338715	0	444814009	40481087		0
75508	4482	4310024	1985-06-08	1985-06-08 00:00:00	\N	\N	32020		\N	298376	0	424802006	4310024		0
86235	5132	4112343	2002-01-13	2002-01-13 00:00:00	2002-01-22	2002-01-22 00:00:00	32020		\N	341131	0	195662009	4112343		0
86370	5142	80180	1985-03-19	1985-03-19 00:00:00	\N	\N	32020		\N	341761	0	396275006	80180		0
86520	5148	372328	1962-10-03	1962-10-03 00:00:00	1963-01-21	1963-01-21 00:00:00	32020		\N	342248	0	65363002	372328		0
87280	5196	40481087	2007-09-22	2007-09-22 00:00:00	2007-09-29	2007-09-29 00:00:00	32020		\N	345522	0	444814009	40481087		0
87557	5210	4113008	1996-09-26	1996-09-26 00:00:00	1996-10-17	1996-10-17 00:00:00	32020		\N	346447	0	284549007	4113008		0
87664	5215	4296205	1978-07-14	1978-07-14 00:00:00	1978-08-11	1978-08-11 00:00:00	32020		\N	346840	0	403191005	4296205		0
88144	5241	4059173	2017-05-17	2017-05-17 00:00:00	2017-08-15	2017-08-15 00:00:00	32020		\N	348801	0	16114001	4059173		0
88418	5256	4142905	2008-03-05	2008-03-05 00:00:00	2008-06-03	2008-06-03 00:00:00	32020		\N	349708	0	33737001	4142905		0
88751	5277	81151	1961-10-30	1961-10-30 00:00:00	1961-12-04	1961-12-04 00:00:00	32020		\N	350975	0	44465007	81151		0
88884	5284	4112343	1993-07-10	1993-07-10 00:00:00	1993-07-22	1993-07-22 00:00:00	32020		\N	351597	0	195662009	4112343		0
89066	5299	80180	2007-01-20	2007-01-20 00:00:00	\N	\N	32020		\N	352490	0	396275006	80180		0
89274	5312	4218389	1987-06-21	1987-06-21 00:00:00	1987-07-19	1987-07-19 00:00:00	32020		\N	353230	0	39848009	4218389		0
89381	5316	40481087	1987-04-10	1987-04-10 00:00:00	1987-05-01	1987-05-01 00:00:00	32020		\N	353542	0	444814009	40481087		0
80303	4757	40481087	2015-06-20	2015-06-20 00:00:00	2015-07-11	2015-07-11 00:00:00	32020		\N	316905	0	444814009	40481087		0
85452	5081	81151	1951-05-01	1951-05-01 00:00:00	1951-05-15	1951-05-15 00:00:00	32020		\N	337901	0	44465007	81151		0
85555	5086	80180	2010-02-27	2010-02-27 00:00:00	\N	\N	32020		\N	338180	0	396275006	80180		0
85683	5097	40481087	2007-04-30	2007-04-30 00:00:00	2007-05-21	2007-05-21 00:00:00	32020		\N	338738	0	444814009	40481087		0
75509	4482	30753	1986-08-02	1986-08-02 00:00:00	\N	\N	32020		\N	298376	0	16761005	30753		0
86236	5132	260139	2009-10-01	2009-10-01 00:00:00	2009-10-08	2009-10-08 00:00:00	32020		\N	341132	0	10509002	260139		0
86371	5142	4112343	2014-11-14	2014-11-14 00:00:00	2014-11-22	2014-11-22 00:00:00	32020		\N	341710	0	195662009	4112343		0
86521	5148	40481087	1986-02-16	1986-02-16 00:00:00	1986-03-02	1986-03-02 00:00:00	32020		\N	342247	0	444814009	40481087		0
87281	5196	260139	2002-09-12	2002-09-12 00:00:00	2002-09-19	2002-09-19 00:00:00	32020		\N	345546	0	10509002	260139		0
87558	5210	192671	2015-08-12	2015-08-12 00:00:00	\N	\N	32020		\N	346506	0	K92.2	35208414		0
87665	5215	260139	1944-02-23	1944-02-23 00:00:00	1944-03-01	1944-03-01 00:00:00	32020		\N	346832	0	10509002	260139		0
88145	5241	40481087	1973-04-16	1973-04-16 00:00:00	1973-04-23	1973-04-23 00:00:00	32020		\N	348753	0	444814009	40481087		0
88419	5256	4112343	1994-02-28	1994-02-28 00:00:00	1994-03-09	1994-03-09 00:00:00	32020		\N	349713	0	195662009	4112343		0
88752	5277	78272	2018-07-06	2018-07-06 00:00:00	2018-07-20	2018-07-20 00:00:00	32020		\N	350979	0	70704007	78272		0
88885	5284	40481087	2006-08-24	2006-08-24 00:00:00	2006-09-14	2006-09-14 00:00:00	32020		\N	351526	0	444814009	40481087		0
89067	5299	260139	2000-04-20	2000-04-20 00:00:00	2000-05-04	2000-05-04 00:00:00	32020		\N	352529	0	10509002	260139		0
89275	5312	260139	1998-12-04	1998-12-04 00:00:00	1998-12-18	1998-12-18 00:00:00	32020		\N	353294	0	10509002	260139		0
89382	5316	40481087	1957-05-23	1957-05-23 00:00:00	1957-06-13	1957-06-13 00:00:00	32020		\N	353585	0	444814009	40481087		0
80304	4758	4155034	1987-06-05	1987-06-05 00:00:00	1987-06-26	1987-06-26 00:00:00	32020		\N	316966	0	283371005	4155034		0
85453	5081	40481087	2006-07-24	2006-07-24 00:00:00	2006-08-07	2006-08-07 00:00:00	32020		\N	337929	0	444814009	40481087		0
85556	5086	40481087	1978-09-17	1978-09-17 00:00:00	1978-09-24	1978-09-24 00:00:00	32020		\N	338195	0	444814009	40481087		0
85684	5097	40481087	1973-02-02	1973-02-02 00:00:00	1973-02-16	1973-02-16 00:00:00	32020		\N	338714	0	444814009	40481087		0
75510	4482	4112343	2011-06-18	2011-06-18 00:00:00	2011-06-29	2011-06-29 00:00:00	32020		\N	298397	0	195662009	4112343		0
86237	5132	28060	1972-12-24	1972-12-24 00:00:00	1973-01-02	1973-01-02 00:00:00	32020		\N	341108	0	43878008	28060		0
86372	5142	28060	1973-08-06	1973-08-06 00:00:00	1973-08-17	1973-08-17 00:00:00	32020		\N	341768	0	43878008	28060		0
86522	5148	4112343	1981-02-26	1981-02-26 00:00:00	1981-03-05	1981-03-05 00:00:00	32020		\N	342226	0	195662009	4112343		0
87282	5196	4112343	2006-01-21	2006-01-21 00:00:00	2006-02-01	2006-02-01 00:00:00	32020		\N	345547	0	195662009	4112343		0
87559	5210	28060	1982-10-31	1982-10-31 00:00:00	1982-11-12	1982-11-12 00:00:00	32020		\N	346476	0	43878008	28060		0
87747	5222	40481087	1995-04-28	1995-04-28 00:00:00	1995-05-05	1995-05-05 00:00:00	32020		\N	347450	0	444814009	40481087		0
88146	5241	28060	2005-10-14	2005-10-14 00:00:00	2005-10-24	2005-10-24 00:00:00	32020		\N	348759	0	43878008	28060		0
88420	5256	40481087	1982-01-12	1982-01-12 00:00:00	1982-01-19	1982-01-19 00:00:00	32020		\N	349744	0	444814009	40481087		0
88753	5277	260139	1998-08-05	1998-08-05 00:00:00	1998-08-12	1998-08-12 00:00:00	32020		\N	351032	0	10509002	260139		0
88886	5284	28060	1973-12-19	1973-12-19 00:00:00	1974-01-01	1974-01-01 00:00:00	32020		\N	351479	0	43878008	28060		0
89068	5299	4059173	1988-11-10	1988-11-10 00:00:00	1989-01-09	1989-01-09 00:00:00	32020		\N	352523	0	16114001	4059173		0
89276	5312	4027663	1964-10-24	1964-10-24 00:00:00	\N	\N	32020		\N	353318	0	13200003	4027663		0
89383	5316	28060	1963-06-28	1963-06-28 00:00:00	1963-07-08	1963-07-08 00:00:00	32020		\N	353575	0	43878008	28060		0
80305	4758	372328	1958-05-08	1958-05-08 00:00:00	1958-06-15	1958-06-15 00:00:00	32020		\N	317030	0	65363002	372328		0
85454	5081	78272	1975-01-30	1975-01-30 00:00:00	1975-02-20	1975-02-20 00:00:00	32020		\N	337903	0	70704007	78272		0
85557	5086	28060	1974-07-18	1974-07-18 00:00:00	1974-07-29	1974-07-29 00:00:00	32020		\N	338157	0	43878008	28060		0
85685	5097	372328	1968-01-22	1968-01-22 00:00:00	1968-03-04	1968-03-04 00:00:00	32020		\N	338746	0	65363002	372328		0
75511	4482	78272	1962-01-20	1962-01-20 00:00:00	1962-02-17	1962-02-17 00:00:00	32020		\N	298391	0	70704007	78272		0
86238	5132	260139	2011-06-01	2011-06-01 00:00:00	2011-06-15	2011-06-15 00:00:00	32020		\N	341137	0	10509002	260139		0
86373	5142	78272	1976-04-19	1976-04-19 00:00:00	1976-05-03	1976-05-03 00:00:00	32020		\N	341695	0	70704007	78272		0
86523	5148	4142905	1970-08-22	1970-08-22 00:00:00	1970-11-19	1970-11-19 00:00:00	32020		\N	342221	0	33737001	4142905		0
87283	5196	4218389	1993-08-20	1993-08-20 00:00:00	1993-09-17	1993-09-17 00:00:00	32020		\N	345569	0	39848009	4218389		0
87560	5210	81151	2016-12-06	2016-12-06 00:00:00	2017-01-03	2017-01-03 00:00:00	32020		\N	346450	0	44465007	81151		0
87748	5222	260139	2009-10-15	2009-10-15 00:00:00	2009-10-29	2009-10-29 00:00:00	32020		\N	347502	0	10509002	260139		0
88421	5256	40481087	2011-05-10	2011-05-10 00:00:00	2011-05-31	2011-05-31 00:00:00	32020		\N	349776	0	444814009	40481087		0
88754	5277	40481087	1998-08-06	1998-08-06 00:00:00	1998-08-27	1998-08-27 00:00:00	32020		\N	350961	0	444814009	40481087		0
88887	5284	4237458	1997-04-13	1997-04-13 00:00:00	1997-07-12	1997-07-12 00:00:00	32020		\N	351517	0	58150001	4237458		0
89069	5299	372328	1974-09-09	1974-09-09 00:00:00	1974-11-17	1974-11-17 00:00:00	32020		\N	352546	0	65363002	372328		0
89277	5312	4112343	1995-12-22	1995-12-22 00:00:00	1996-01-03	1996-01-03 00:00:00	32020		\N	353288	0	195662009	4112343		0
89384	5316	4155034	1966-09-27	1966-09-27 00:00:00	1966-10-18	1966-10-18 00:00:00	32020		\N	353607	0	283371005	4155034		0
80306	4758	40481087	1979-10-24	1979-10-24 00:00:00	1979-10-31	1979-10-31 00:00:00	32020		\N	316971	0	444814009	40481087		0
85455	5081	260139	1915-12-28	1915-12-28 00:00:00	1916-01-04	1916-01-04 00:00:00	32020		\N	337885	0	10509002	260139		0
85558	5086	372328	1972-10-26	1972-10-26 00:00:00	1973-03-01	1973-03-01 00:00:00	32020		\N	338185	0	65363002	372328		0
85686	5097	260139	1983-05-05	1983-05-05 00:00:00	1983-05-19	1983-05-19 00:00:00	32020		\N	338629	0	10509002	260139		0
75512	4482	4112343	1975-01-15	1975-01-15 00:00:00	1975-01-27	1975-01-27 00:00:00	32020		\N	298392	0	195662009	4112343		0
86239	5132	378001	2017-05-17	2017-05-17 00:00:00	2017-07-16	2017-07-16 00:00:00	32020		\N	341171	0	62106007	378001		0
86374	5142	4230399	2014-06-18	2014-06-18 00:00:00	2014-08-17	2014-08-17 00:00:00	32020		\N	341699	0	359817006	4230399		0
86524	5148	378001	1962-12-01	1962-12-01 00:00:00	1963-01-30	1963-01-30 00:00:00	32020		\N	342220	0	62106007	378001		0
87284	5196	40481087	1996-08-06	1996-08-06 00:00:00	1996-08-13	1996-08-13 00:00:00	32020		\N	345520	0	444814009	40481087		0
87561	5210	40481087	1993-05-01	1993-05-01 00:00:00	1993-05-15	1993-05-15 00:00:00	32020		\N	346466	0	444814009	40481087		0
87749	5222	4112343	1962-05-09	1962-05-09 00:00:00	1962-05-22	1962-05-22 00:00:00	32020		\N	347354	0	195662009	4112343		0
88422	5256	28060	2018-08-02	2018-08-02 00:00:00	2018-08-15	2018-08-15 00:00:00	32020		\N	349777	0	43878008	28060		0
88755	5277	40481087	1963-12-06	1963-12-06 00:00:00	1963-12-13	1963-12-13 00:00:00	32020		\N	350972	0	444814009	40481087		0
88888	5285	40481087	2002-08-16	2002-08-16 00:00:00	2002-08-23	2002-08-23 00:00:00	32020		\N	351702	0	444814009	40481087		0
89278	5312	40481087	1980-11-19	1980-11-19 00:00:00	1980-12-10	1980-12-10 00:00:00	32020		\N	353285	0	444814009	40481087		0
89385	5316	4113008	1993-03-30	1993-03-30 00:00:00	1993-04-13	1993-04-13 00:00:00	32020		\N	353609	0	284549007	4113008		0
80307	4758	40481087	1961-04-23	1961-04-23 00:00:00	1961-05-07	1961-05-07 00:00:00	32020		\N	317024	0	444814009	40481087		0
85456	5081	4283893	1981-09-18	1981-09-18 00:00:00	1981-10-30	1981-10-30 00:00:00	32020		\N	337864	0	36971009	4283893		0
85559	5086	372328	1971-05-02	1971-05-02 00:00:00	1971-09-02	1971-09-02 00:00:00	32020		\N	338184	0	65363002	372328		0
85687	5097	80180	2005-08-05	2005-08-05 00:00:00	\N	\N	32020		\N	338726	0	396275006	80180		0
75513	4482	40481087	1977-08-04	1977-08-04 00:00:00	1977-08-25	1977-08-25 00:00:00	32020		\N	298393	0	444814009	40481087		0
86240	5132	260139	1970-05-21	1970-05-21 00:00:00	1970-05-28	1970-05-28 00:00:00	32020		\N	341107	0	10509002	260139		0
86375	5142	317576	1995-09-12	1995-09-12 00:00:00	\N	\N	32020		\N	341783	0	53741008	317576		0
86525	5148	4112343	1983-12-23	1983-12-23 00:00:00	1984-01-05	1984-01-05 00:00:00	32020		\N	342229	0	195662009	4112343		0
87285	5196	80180	1993-04-09	1993-04-09 00:00:00	\N	\N	32020		\N	345503	0	396275006	80180		0
87562	5210	4112343	1978-02-12	1978-02-12 00:00:00	1978-02-20	1978-02-20 00:00:00	32020		\N	346475	0	195662009	4112343		0
87750	5222	81151	1937-06-18	1937-06-18 00:00:00	1937-07-09	1937-07-09 00:00:00	32020		\N	347505	0	44465007	81151		0
88423	5256	4112343	1986-05-20	1986-05-20 00:00:00	1986-05-30	1986-05-30 00:00:00	32020		\N	349719	0	195662009	4112343		0
88756	5277	78272	1996-12-14	1996-12-14 00:00:00	1996-12-28	1996-12-28 00:00:00	32020		\N	350977	0	70704007	78272		0
88889	5285	40481087	2013-09-08	2013-09-08 00:00:00	2013-09-29	2013-09-29 00:00:00	32020		\N	351635	0	444814009	40481087		0
89072	5299	440086	1980-06-10	1980-06-10 00:00:00	1981-03-17	1981-03-17 00:00:00	32020		\N	352507	0	192127007	440086		0
89279	5312	261325	1973-12-31	1973-12-31 00:00:00	\N	\N	32020		\N	353262	0	87433001	261325		0
89386	5316	81893	1993-06-02	1993-06-02 00:00:00	\N	\N	32020		\N	353609	0	64766004	81893		0
80308	4758	4112343	1994-09-11	1994-09-11 00:00:00	1994-09-18	1994-09-18 00:00:00	32020		\N	317028	0	195662009	4112343		0
85457	5081	4112343	1939-11-19	1939-11-19 00:00:00	1939-11-29	1939-11-29 00:00:00	32020		\N	337875	0	195662009	4112343		0
85560	5086	260139	2017-05-23	2017-05-23 00:00:00	2017-05-30	2017-05-30 00:00:00	32020		\N	338183	0	10509002	260139		0
85688	5097	4112343	2004-11-12	2004-11-12 00:00:00	2004-11-22	2004-11-22 00:00:00	32020		\N	338687	0	195662009	4112343		0
75514	4482	4112343	2017-01-02	2017-01-02 00:00:00	2017-01-09	2017-01-09 00:00:00	32020		\N	298371	0	195662009	4112343		0
86241	5132	4059173	2014-05-03	2014-05-03 00:00:00	2014-06-02	2014-06-02 00:00:00	32020		\N	341170	0	16114001	4059173		0
86376	5142	4329847	2012-04-03	2012-04-03 00:00:00	\N	\N	32020		\N	341697	0	22298006	4329847		0
86526	5148	257012	1966-02-23	1966-02-23 00:00:00	\N	\N	32020		\N	342225	0	40055000	257012		0
87286	5196	28060	1952-10-27	1952-10-27 00:00:00	1952-11-06	1952-11-06 00:00:00	32020		\N	345510	0	43878008	28060		0
87563	5210	40481087	2015-03-06	2015-03-06 00:00:00	2015-03-20	2015-03-20 00:00:00	32020		\N	346453	0	444814009	40481087		0
87751	5222	28060	1922-12-21	1922-12-21 00:00:00	1922-12-30	1922-12-30 00:00:00	32020		\N	347509	0	43878008	28060		0
88424	5256	372328	1964-05-15	1964-05-15 00:00:00	1964-10-23	1964-10-23 00:00:00	32020		\N	349720	0	65363002	372328		0
88757	5277	80180	1997-09-06	1997-09-06 00:00:00	\N	\N	32020		\N	350977	0	396275006	80180		0
88890	5285	40481087	1944-05-06	1944-05-06 00:00:00	1944-05-20	1944-05-20 00:00:00	32020		\N	351707	0	444814009	40481087		0
89073	5299	260139	1979-09-30	1979-09-30 00:00:00	1979-10-07	1979-10-07 00:00:00	32020		\N	352494	0	10509002	260139		0
89280	5312	40481087	1982-08-11	1982-08-11 00:00:00	1982-09-01	1982-09-01 00:00:00	32020		\N	353286	0	444814009	40481087		0
89387	5316	372328	1958-10-23	1958-10-23 00:00:00	1959-01-26	1959-01-26 00:00:00	32020		\N	353568	0	65363002	372328		0
80309	4758	40481087	1981-11-25	1981-11-25 00:00:00	1981-12-16	1981-12-16 00:00:00	32020		\N	316977	0	444814009	40481087		0
85458	5081	4112343	1972-05-26	1972-05-26 00:00:00	1972-06-04	1972-06-04 00:00:00	32020		\N	337910	0	195662009	4112343		0
85624	5094	40481087	1984-10-17	1984-10-17 00:00:00	1984-10-31	1984-10-31 00:00:00	32020		\N	338470	0	444814009	40481087		0
85689	5097	372328	1969-11-24	1969-11-24 00:00:00	1970-06-01	1970-06-01 00:00:00	32020		\N	338697	0	65363002	372328		0
75515	4482	4112343	1950-12-20	1950-12-20 00:00:00	1950-12-27	1950-12-27 00:00:00	32020		\N	298384	0	195662009	4112343		0
86242	5132	28060	1974-02-28	1974-02-28 00:00:00	1974-03-08	1974-03-08 00:00:00	32020		\N	341109	0	43878008	28060		0
86378	5142	40481087	1981-11-28	1981-11-28 00:00:00	1981-12-19	1981-12-19 00:00:00	32020		\N	341769	0	444814009	40481087		0
86527	5148	4283893	1966-01-19	1966-01-19 00:00:00	1966-04-28	1966-04-28 00:00:00	32020		\N	342224	0	36971009	4283893		0
87287	5196	40481087	2016-08-05	2016-08-05 00:00:00	2016-08-26	2016-08-26 00:00:00	32020		\N	345491	0	444814009	40481087		0
87564	5210	4109685	2000-05-29	2000-05-29 00:00:00	2000-06-19	2000-06-19 00:00:00	32020		\N	346448	0	284551006	4109685		0
87752	5222	4112343	1937-07-18	1937-07-18 00:00:00	1937-07-31	1937-07-31 00:00:00	32020		\N	347403	0	195662009	4112343		0
88425	5256	372328	1963-09-23	1963-09-23 00:00:00	1963-10-18	1963-10-18 00:00:00	32020		\N	349715	0	65363002	372328		0
88758	5277	4112343	2004-03-07	2004-03-07 00:00:00	2004-03-15	2004-03-15 00:00:00	32020		\N	350963	0	195662009	4112343		0
88891	5285	4113008	1985-05-08	1985-05-08 00:00:00	1985-05-22	1985-05-22 00:00:00	32020		\N	351689	0	284549007	4113008		0
89074	5299	378001	2013-10-14	2013-10-14 00:00:00	2013-12-13	2013-12-13 00:00:00	32020		\N	352487	0	62106007	378001		0
89281	5312	372328	1943-05-22	1943-05-22 00:00:00	1943-10-11	1943-10-11 00:00:00	32020		\N	353297	0	65363002	372328		0
89388	5316	4112343	1966-01-25	1966-01-25 00:00:00	1966-02-04	1966-02-04 00:00:00	32020		\N	353576	0	195662009	4112343		0
80310	4758	40481087	1959-03-05	1959-03-05 00:00:00	1959-03-26	1959-03-26 00:00:00	32020		\N	316970	0	444814009	40481087		0
85459	5081	378419	1999-10-15	1999-10-15 00:00:00	\N	\N	32020		\N	337896	0	26929004	378419		0
85625	5094	28060	2006-10-18	2006-10-18 00:00:00	2006-10-30	2006-10-30 00:00:00	32020		\N	338459	0	43878008	28060		0
85690	5097	40481087	1996-02-11	1996-02-11 00:00:00	1996-02-18	1996-02-18 00:00:00	32020		\N	338686	0	444814009	40481087		0
75516	4482	4266809	1987-08-27	1987-08-27 00:00:00	\N	\N	32020		\N	298329	0	397881000	4266809		0
86243	5132	4278672	1973-03-04	1973-03-04 00:00:00	1973-06-02	1973-06-02 00:00:00	32020		\N	341105	0	65966004	4278672		0
86379	5142	4310024	1982-06-03	1982-06-03 00:00:00	\N	\N	32020		\N	341769	0	424802006	4310024		0
86539	5150	40481087	1943-08-01	1943-08-01 00:00:00	1943-08-08	1943-08-08 00:00:00	32020		\N	342375	0	444814009	40481087		0
87288	5196	260139	2006-10-07	2006-10-07 00:00:00	2006-10-14	2006-10-14 00:00:00	32020		\N	345521	0	10509002	260139		0
87599	5213	81151	2007-03-14	2007-03-14 00:00:00	2007-04-11	2007-04-11 00:00:00	32020		\N	346775	0	44465007	81151		0
87753	5222	40481087	1937-01-24	1937-01-24 00:00:00	1937-02-07	1937-02-07 00:00:00	32020		\N	347406	0	444814009	40481087		0
88426	5256	260139	1987-08-23	1987-08-23 00:00:00	1987-08-30	1987-08-30 00:00:00	32020		\N	349774	0	10509002	260139		0
88759	5277	4112343	2004-10-13	2004-10-13 00:00:00	2004-10-22	2004-10-22 00:00:00	32020		\N	351005	0	195662009	4112343		0
88892	5285	40481087	2014-10-31	2014-10-31 00:00:00	2014-11-21	2014-11-21 00:00:00	32020		\N	351636	0	444814009	40481087		0
89075	5299	372328	1973-10-30	1973-10-30 00:00:00	1973-11-13	1973-11-13 00:00:00	32020		\N	352530	0	65363002	372328		0
89282	5312	4112343	1950-07-16	1950-07-16 00:00:00	1950-07-29	1950-07-29 00:00:00	32020		\N	353292	0	195662009	4112343		0
89389	5316	134438	1980-08-21	1980-08-21 00:00:00	1981-11-14	1981-11-14 00:00:00	32020		\N	353605	0	40275004	134438		0
80311	4758	372328	1962-09-22	1962-09-22 00:00:00	1963-02-17	1963-02-17 00:00:00	32020		\N	317010	0	65363002	372328		0
85460	5081	257012	1960-07-23	1960-07-23 00:00:00	\N	\N	32020		\N	337881	0	40055000	257012		0
85626	5094	4112343	1989-10-04	1989-10-04 00:00:00	1989-10-14	1989-10-14 00:00:00	32020		\N	338443	0	195662009	4112343		0
85691	5097	4112343	2017-10-16	2017-10-16 00:00:00	2017-10-26	2017-10-26 00:00:00	32020		\N	338696	0	195662009	4112343		0
75517	4482	80180	1987-08-27	1987-08-27 00:00:00	\N	\N	32020		\N	298329	0	396275006	80180		0
86244	5132	28060	1968-11-28	1968-11-28 00:00:00	1968-12-11	1968-12-11 00:00:00	32020		\N	341128	0	43878008	28060		0
86380	5142	81893	1983-03-30	1983-03-30 00:00:00	\N	\N	32020		\N	341769	0	64766004	81893		0
86540	5150	4112343	1987-10-17	1987-10-17 00:00:00	1987-10-28	1987-10-28 00:00:00	32020		\N	342354	0	195662009	4112343		0
87289	5196	40481087	1993-06-01	1993-06-01 00:00:00	1993-06-15	1993-06-15 00:00:00	32020		\N	345512	0	444814009	40481087		0
87600	5213	28060	1985-02-23	1985-02-23 00:00:00	1985-03-04	1985-03-04 00:00:00	32020		\N	346765	0	43878008	28060		0
87754	5222	260139	1983-10-13	1983-10-13 00:00:00	1983-10-27	1983-10-27 00:00:00	32020		\N	347356	0	10509002	260139		0
88427	5256	4112343	1988-01-21	1988-01-21 00:00:00	1988-01-28	1988-01-28 00:00:00	32020		\N	349775	0	195662009	4112343		0
88760	5277	4237458	1955-12-31	1955-12-31 00:00:00	1956-02-29	1956-02-29 00:00:00	32020		\N	350974	0	58150001	4237458		0
88893	5285	40481087	1982-11-21	1982-11-21 00:00:00	1982-11-28	1982-11-28 00:00:00	32020		\N	351643	0	444814009	40481087		0
89076	5300	40481087	1984-06-29	1984-06-29 00:00:00	1984-07-06	1984-07-06 00:00:00	32020		\N	352641	0	444814009	40481087		0
89283	5312	4155034	1942-09-10	1942-09-10 00:00:00	1942-10-01	1942-10-01 00:00:00	32020		\N	353228	0	283371005	4155034		0
89390	5316	260139	2014-12-10	2014-12-10 00:00:00	2014-12-24	2014-12-24 00:00:00	32020		\N	353543	0	10509002	260139		0
80312	4758	260139	1967-01-22	1967-01-22 00:00:00	1967-01-29	1967-01-29 00:00:00	32020		\N	316996	0	10509002	260139		0
85461	5081	40481087	1977-09-25	1977-09-25 00:00:00	1977-10-02	1977-10-02 00:00:00	32020		\N	337851	0	444814009	40481087		0
85627	5094	4112343	1990-04-15	1990-04-15 00:00:00	1990-04-28	1990-04-28 00:00:00	32020		\N	338444	0	195662009	4112343		0
85692	5097	372328	1972-09-18	1972-09-18 00:00:00	1973-06-11	1973-06-11 00:00:00	32020		\N	338689	0	65363002	372328		0
75518	4482	260139	2003-10-08	2003-10-08 00:00:00	2003-10-22	2003-10-22 00:00:00	32020		\N	298359	0	10509002	260139		0
86300	5137	372328	1972-06-30	1972-06-30 00:00:00	1973-06-06	1973-06-06 00:00:00	32020		\N	341432	0	65363002	372328		0
86381	5142	4059173	2013-07-23	2013-07-23 00:00:00	2013-08-22	2013-08-22 00:00:00	32020		\N	341698	0	16114001	4059173		0
86541	5150	40481087	2002-04-21	2002-04-21 00:00:00	2002-04-28	2002-04-28 00:00:00	32020		\N	342464	0	444814009	40481087		0
87290	5196	40481087	1952-07-07	1952-07-07 00:00:00	1952-07-14	1952-07-14 00:00:00	32020		\N	345563	0	444814009	40481087		0
87601	5213	40481087	1982-06-07	1982-06-07 00:00:00	1982-06-14	1982-06-14 00:00:00	32020		\N	346707	0	444814009	40481087		0
87755	5222	313217	2004-02-12	2004-02-12 00:00:00	\N	\N	32020		\N	347466	0	49436004	313217		0
88428	5256	260139	1972-11-23	1972-11-23 00:00:00	1972-12-07	1972-12-07 00:00:00	32020		\N	349749	0	10509002	260139		0
88761	5277	40481087	1982-12-06	1982-12-06 00:00:00	1982-12-27	1982-12-27 00:00:00	32020		\N	351030	0	444814009	40481087		0
88894	5285	4112343	1959-07-20	1959-07-20 00:00:00	1959-07-30	1959-07-30 00:00:00	32020		\N	351697	0	195662009	4112343		0
89077	5300	40481087	1962-03-05	1962-03-05 00:00:00	1962-03-19	1962-03-19 00:00:00	32020		\N	352634	0	444814009	40481087		0
89284	5312	375671	1940-11-19	1940-11-19 00:00:00	1941-01-18	1941-01-18 00:00:00	32020		\N	353227	0	62564004	375671		0
89391	5316	4112343	1987-09-13	1987-09-13 00:00:00	1987-09-22	1987-09-22 00:00:00	32020		\N	353577	0	195662009	4112343		0
80313	4758	4278672	1999-11-11	1999-11-11 00:00:00	2000-02-09	2000-02-09 00:00:00	32020		\N	316969	0	65966004	4278672		0
85462	5081	260139	1947-09-19	1947-09-19 00:00:00	1947-10-03	1947-10-03 00:00:00	32020		\N	337879	0	10509002	260139		0
85628	5094	4237458	1991-09-25	1991-09-25 00:00:00	1991-11-24	1991-11-24 00:00:00	32020		\N	338493	0	58150001	4237458		0
85693	5097	134438	1992-06-26	1992-06-26 00:00:00	1993-04-28	1993-04-28 00:00:00	32020		\N	338716	0	40275004	134438		0
75519	4482	4027663	1979-07-15	1979-07-15 00:00:00	\N	\N	32020		\N	298374	0	13200003	4027663		0
86301	5137	4112343	1968-09-15	1968-09-15 00:00:00	1968-09-22	1968-09-22 00:00:00	32020		\N	341359	0	195662009	4112343		0
86382	5142	4296205	1978-01-23	1978-01-23 00:00:00	1978-02-27	1978-02-27 00:00:00	32020		\N	341696	0	403191005	4296205		0
86542	5150	28060	2010-09-24	2010-09-24 00:00:00	2010-10-02	2010-10-02 00:00:00	32020		\N	342465	0	43878008	28060		0
87291	5196	28060	1958-01-11	1958-01-11 00:00:00	1958-01-19	1958-01-19 00:00:00	32020		\N	345511	0	43878008	28060		0
87602	5213	372328	1942-09-14	1942-09-14 00:00:00	1943-05-27	1943-05-27 00:00:00	32020		\N	346711	0	65363002	372328		0
87756	5222	40481087	1938-06-08	1938-06-08 00:00:00	1938-06-22	1938-06-22 00:00:00	32020		\N	347352	0	444814009	40481087		0
88429	5256	78272	1988-04-14	1988-04-14 00:00:00	1988-05-19	1988-05-19 00:00:00	32020		\N	349707	0	70704007	78272		0
88762	5277	4283893	2009-08-07	2009-08-07 00:00:00	2009-08-21	2009-08-21 00:00:00	32020		\N	351033	0	36971009	4283893		0
88895	5285	317576	2007-02-25	2007-02-25 00:00:00	\N	\N	32020		\N	351713	0	53741008	317576		0
89078	5300	4112343	1957-02-28	1957-02-28 00:00:00	1957-03-10	1957-03-10 00:00:00	32020		\N	352632	0	195662009	4112343		0
89285	5312	80502	1998-12-14	1998-12-14 00:00:00	\N	\N	32020		\N	353233	0	64859006	80502		0
89392	5316	4218389	1998-10-14	1998-10-14 00:00:00	1998-11-04	1998-11-04 00:00:00	32020		\N	353610	0	39848009	4218389		0
80314	4758	260139	1995-10-21	1995-10-21 00:00:00	1995-11-04	1995-11-04 00:00:00	32020		\N	317029	0	10509002	260139		0
85463	5081	4294548	1960-05-07	1960-05-07 00:00:00	1961-01-14	1961-01-14 00:00:00	32020		\N	337880	0	75498004	4294548		0
85629	5094	4112343	2004-12-26	2004-12-26 00:00:00	2005-01-07	2005-01-07 00:00:00	32020		\N	338447	0	195662009	4112343		0
85704	5099	260139	2017-02-16	2017-02-16 00:00:00	2017-03-02	2017-03-02 00:00:00	32020		\N	338864	0	10509002	260139		0
75520	4482	40481087	1978-05-31	1978-05-31 00:00:00	1978-06-07	1978-06-07 00:00:00	32020		\N	298374	0	444814009	40481087		0
86302	5137	260139	2008-07-13	2008-07-13 00:00:00	2008-07-27	2008-07-27 00:00:00	32020		\N	341412	0	10509002	260139		0
86383	5142	40481087	1953-11-07	1953-11-07 00:00:00	1953-11-14	1953-11-14 00:00:00	32020		\N	341765	0	444814009	40481087		0
86543	5150	81151	1947-08-31	1947-08-31 00:00:00	1947-10-05	1947-10-05 00:00:00	32020		\N	342333	0	44465007	81151		0
87292	5196	40481087	2015-05-27	2015-05-27 00:00:00	2015-06-03	2015-06-03 00:00:00	32020		\N	345548	0	444814009	40481087		0
87603	5213	260139	1991-09-23	1991-09-23 00:00:00	1991-10-07	1991-10-07 00:00:00	32020		\N	346766	0	10509002	260139		0
87757	5222	134438	1946-07-19	1946-07-19 00:00:00	1947-08-18	1947-08-18 00:00:00	32020		\N	347407	0	40275004	134438		0
88430	5256	195588	1983-11-07	1983-11-07 00:00:00	1983-12-17	1983-12-17 00:00:00	32020		\N	349773	0	38822007	195588		0
88763	5277	40481087	2012-06-12	2012-06-12 00:00:00	2012-06-19	2012-06-19 00:00:00	32020		\N	351006	0	444814009	40481087		0
88896	5285	378419	2016-05-29	2016-05-29 00:00:00	\N	\N	32020		\N	351677	0	26929004	378419		0
89079	5300	40481087	1975-12-16	1975-12-16 00:00:00	1975-12-23	1975-12-23 00:00:00	32020		\N	352603	0	444814009	40481087		0
89286	5312	40481087	1957-11-11	1957-11-11 00:00:00	1957-11-18	1957-11-18 00:00:00	32020		\N	353282	0	444814009	40481087		0
89393	5316	372328	1957-08-15	1957-08-15 00:00:00	1957-10-28	1957-10-28 00:00:00	32020		\N	353567	0	65363002	372328		0
80315	4758	80180	1996-11-14	1996-11-14 00:00:00	\N	\N	32020		\N	317029	0	396275006	80180		0
85464	5081	78272	1927-12-28	1927-12-28 00:00:00	1928-01-18	1928-01-18 00:00:00	32020		\N	337898	0	70704007	78272		0
85630	5094	378001	1980-01-21	1980-01-21 00:00:00	1980-03-21	1980-03-21 00:00:00	32020		\N	338478	0	62106007	378001		0
85705	5099	4112343	1988-03-13	1988-03-13 00:00:00	1988-03-24	1988-03-24 00:00:00	32020		\N	338890	0	195662009	4112343		0
75521	4482	40481087	1951-01-25	1951-01-25 00:00:00	1951-02-01	1951-02-01 00:00:00	32020		\N	298405	0	444814009	40481087		0
86303	5137	260139	1992-07-20	1992-07-20 00:00:00	1992-08-03	1992-08-03 00:00:00	32020		\N	341398	0	10509002	260139		0
86384	5142	260139	1999-03-30	1999-03-30 00:00:00	1999-04-13	1999-04-13 00:00:00	32020		\N	341726	0	10509002	260139		0
86544	5150	40481087	1953-04-25	1953-04-25 00:00:00	1953-05-16	1953-05-16 00:00:00	32020		\N	342373	0	444814009	40481087		0
87293	5196	372328	1956-02-08	1956-02-08 00:00:00	1956-07-13	1956-07-13 00:00:00	32020		\N	345553	0	65363002	372328		0
87604	5213	40481087	2003-05-09	2003-05-09 00:00:00	2003-05-30	2003-05-30 00:00:00	32020		\N	346710	0	444814009	40481087		0
87758	5222	80180	1961-03-25	1961-03-25 00:00:00	\N	\N	32020		\N	347443	0	396275006	80180		0
88431	5256	4112343	1980-11-04	1980-11-04 00:00:00	1980-11-13	1980-11-13 00:00:00	32020		\N	349743	0	195662009	4112343		0
88764	5277	372328	1956-07-28	1956-07-28 00:00:00	1956-12-12	1956-12-12 00:00:00	32020		\N	351034	0	65363002	372328		0
88897	5285	80180	1980-12-16	1980-12-16 00:00:00	\N	\N	32020		\N	351655	0	396275006	80180		0
89080	5300	78272	1994-01-18	1994-01-18 00:00:00	1994-02-08	1994-02-08 00:00:00	32020		\N	352655	0	70704007	78272		0
89287	5312	81893	1972-07-19	1972-07-19 00:00:00	\N	\N	32020		\N	353229	0	64766004	81893		0
89394	5316	372328	1960-11-16	1960-11-16 00:00:00	1961-07-31	1961-07-31 00:00:00	32020		\N	353569	0	65363002	372328		0
80316	4758	4112343	1987-10-07	1987-10-07 00:00:00	1987-10-17	1987-10-17 00:00:00	32020		\N	316997	0	195662009	4112343		0
85465	5081	28060	1974-04-27	1974-04-27 00:00:00	1974-05-08	1974-05-08 00:00:00	32020		\N	337911	0	43878008	28060		0
85631	5094	4112343	2006-01-06	2006-01-06 00:00:00	2006-01-19	2006-01-19 00:00:00	32020		\N	338448	0	195662009	4112343		0
85706	5099	28060	1972-11-04	1972-11-04 00:00:00	1972-11-16	1972-11-16 00:00:00	32020		\N	338838	0	43878008	28060		0
75522	4482	40481087	2004-08-12	2004-08-12 00:00:00	2004-08-26	2004-08-26 00:00:00	32020		\N	298377	0	444814009	40481087		0
86304	5137	260139	1972-02-20	1972-02-20 00:00:00	1972-03-05	1972-03-05 00:00:00	32020		\N	341360	0	10509002	260139		0
86385	5142	40481087	1994-07-22	1994-07-22 00:00:00	1994-08-05	1994-08-05 00:00:00	32020		\N	341770	0	444814009	40481087		0
86545	5150	4112343	2004-10-01	2004-10-01 00:00:00	2004-10-13	2004-10-13 00:00:00	32020		\N	342439	0	195662009	4112343		0
87294	5196	78272	1989-01-15	1989-01-15 00:00:00	1989-02-12	1989-02-12 00:00:00	32020		\N	345568	0	70704007	78272		0
87605	5213	260139	2003-11-11	2003-11-11 00:00:00	2003-11-18	2003-11-18 00:00:00	32020		\N	346741	0	10509002	260139		0
87759	5222	4112343	1979-06-07	1979-06-07 00:00:00	1979-06-20	1979-06-20 00:00:00	32020		\N	347410	0	195662009	4112343		0
88432	5256	28060	1970-07-21	1970-07-21 00:00:00	1970-07-28	1970-07-28 00:00:00	32020		\N	349742	0	43878008	28060		0
88765	5277	40481087	1983-07-01	1983-07-01 00:00:00	1983-07-22	1983-07-22 00:00:00	32020		\N	351023	0	444814009	40481087		0
88898	5285	30753	1979-11-22	1979-11-22 00:00:00	\N	\N	32020		\N	351655	0	16761005	30753		0
89081	5300	40481087	1974-01-13	1974-01-13 00:00:00	1974-01-27	1974-01-27 00:00:00	32020		\N	352640	0	444814009	40481087		0
89288	5312	4266809	1973-06-14	1973-06-14 00:00:00	\N	\N	32020		\N	353229	0	397881000	4266809		0
89395	5316	40481087	2014-12-20	2014-12-20 00:00:00	2015-01-10	2015-01-10 00:00:00	32020		\N	353544	0	444814009	40481087		0
80317	4758	4116491	2018-03-08	2018-03-08 00:00:00	2018-04-11	2018-04-11 00:00:00	32020		\N	317009	0	301011002	4116491		0
85466	5081	260139	1964-11-04	1964-11-04 00:00:00	1964-11-18	1964-11-18 00:00:00	32020		\N	337863	0	10509002	260139		0
85632	5094	81151	1981-11-11	1981-11-11 00:00:00	1981-12-16	1981-12-16 00:00:00	32020		\N	338492	0	44465007	81151		0
85707	5099	40481087	1956-12-13	1956-12-13 00:00:00	1957-01-03	1957-01-03 00:00:00	32020		\N	338862	0	444814009	40481087		0
75523	4482	40481087	1982-12-07	1982-12-07 00:00:00	1982-12-28	1982-12-28 00:00:00	32020		\N	298375	0	444814009	40481087		0
86305	5137	372328	1991-04-03	1991-04-03 00:00:00	1992-08-26	1992-08-26 00:00:00	32020		\N	341434	0	65363002	372328		0
86386	5142	440086	1953-07-15	1953-07-15 00:00:00	1953-11-25	1953-11-25 00:00:00	32020		\N	341705	0	192127007	440086		0
86546	5150	4155034	1970-11-01	1970-11-01 00:00:00	1970-11-15	1970-11-15 00:00:00	32020		\N	342335	0	283371005	4155034		0
87295	5196	40481087	1976-07-13	1976-07-13 00:00:00	1976-07-27	1976-07-27 00:00:00	32020		\N	345564	0	444814009	40481087		0
87606	5213	40481087	2010-07-31	2010-07-31 00:00:00	2010-08-14	2010-08-14 00:00:00	32020		\N	346767	0	444814009	40481087		0
87760	5222	260139	1928-10-28	1928-10-28 00:00:00	1928-11-11	1928-11-11 00:00:00	32020		\N	347384	0	10509002	260139		0
88433	5256	40481087	1990-10-13	1990-10-13 00:00:00	1990-10-20	1990-10-20 00:00:00	32020		\N	349712	0	444814009	40481087		0
88766	5277	4294548	1969-02-19	1969-02-19 00:00:00	1969-03-12	1969-03-12 00:00:00	32020		\N	350958	0	75498004	4294548		0
88899	5285	4112343	1984-02-02	1984-02-02 00:00:00	1984-02-10	1984-02-10 00:00:00	32020		\N	351659	0	195662009	4112343		0
89082	5300	4112343	1953-08-07	1953-08-07 00:00:00	1953-08-15	1953-08-15 00:00:00	32020		\N	352631	0	195662009	4112343		0
89289	5312	4285898	1973-02-14	1973-02-14 00:00:00	\N	\N	32020		\N	353229	0	68496003	4285898		0
89396	5316	40481087	1975-04-16	1975-04-16 00:00:00	1975-05-07	1975-05-07 00:00:00	32020		\N	353604	0	444814009	40481087		0
80318	4758	378001	1965-11-27	1965-11-27 00:00:00	1965-12-27	1965-12-27 00:00:00	32020		\N	316965	0	62106007	378001		0
85467	5081	4112343	1944-04-10	1944-04-10 00:00:00	1944-04-20	1944-04-20 00:00:00	32020		\N	337876	0	195662009	4112343		0
85633	5094	4218389	2000-12-06	2000-12-06 00:00:00	2001-01-03	2001-01-03 00:00:00	32020		\N	338494	0	39848009	4218389		0
85708	5099	40481087	1977-01-30	1977-01-30 00:00:00	1977-02-06	1977-02-06 00:00:00	32020		\N	338869	0	444814009	40481087		0
75524	4482	260139	2019-01-19	2019-01-19 00:00:00	2019-01-26	2019-01-26 00:00:00	32020		\N	298379	0	10509002	260139		0
86306	5137	4113008	1998-04-21	1998-04-21 00:00:00	1998-05-05	1998-05-05 00:00:00	32020		\N	341357	0	284549007	4113008		0
86387	5142	4112343	1947-06-10	1947-06-10 00:00:00	1947-06-22	1947-06-22 00:00:00	32020		\N	341704	0	195662009	4112343		0
86547	5150	4112343	1939-04-17	1939-04-17 00:00:00	1939-04-26	1939-04-26 00:00:00	32020		\N	342370	0	195662009	4112343		0
87296	5197	40481087	1978-12-22	1978-12-22 00:00:00	1979-01-12	1979-01-12 00:00:00	32020		\N	345593	0	444814009	40481087		0
87607	5213	260139	1984-03-24	1984-03-24 00:00:00	1984-03-31	1984-03-31 00:00:00	32020		\N	346708	0	10509002	260139		0
87761	5222	372328	1920-02-23	1920-02-23 00:00:00	1920-06-24	1920-06-24 00:00:00	32020		\N	347432	0	65363002	372328		0
88434	5256	40481087	1966-09-13	1966-09-13 00:00:00	1966-09-27	1966-09-27 00:00:00	32020		\N	349711	0	444814009	40481087		0
88767	5277	40481087	1972-03-05	1972-03-05 00:00:00	1972-03-26	1972-03-26 00:00:00	32020		\N	351022	0	444814009	40481087		0
88900	5285	40481087	1943-07-13	1943-07-13 00:00:00	1943-08-03	1943-08-03 00:00:00	32020		\N	351641	0	444814009	40481087		0
89083	5300	260139	2007-06-15	2007-06-15 00:00:00	2007-06-29	2007-06-29 00:00:00	32020		\N	352616	0	10509002	260139		0
89290	5312	30753	1972-09-17	1972-09-17 00:00:00	\N	\N	32020		\N	353229	0	16761005	30753		0
89397	5316	321042	1984-01-02	1984-01-02 00:00:00	\N	\N	32020		\N	353608	0	410429000	321042		0
80320	4758	321042	1989-08-13	1989-08-13 00:00:00	\N	\N	32020		\N	316967	0	410429000	321042		0
85468	5081	4112343	1982-04-29	1982-04-29 00:00:00	1982-05-10	1982-05-10 00:00:00	32020		\N	337912	0	195662009	4112343		0
85634	5094	40481087	1982-01-19	1982-01-19 00:00:00	1982-01-26	1982-01-26 00:00:00	32020		\N	338463	0	444814009	40481087		0
85709	5099	40481087	1953-01-17	1953-01-17 00:00:00	1953-01-24	1953-01-24 00:00:00	32020		\N	338889	0	444814009	40481087		0
75525	4482	40481087	1970-12-17	1970-12-17 00:00:00	1970-12-31	1970-12-31 00:00:00	32020		\N	298373	0	444814009	40481087		0
86307	5137	4112343	1995-02-06	1995-02-06 00:00:00	1995-02-15	1995-02-15 00:00:00	32020		\N	341430	0	195662009	4112343		0
86388	5142	40481087	2015-09-22	2015-09-22 00:00:00	2015-10-06	2015-10-06 00:00:00	32020		\N	341711	0	444814009	40481087		0
86548	5150	372328	1944-09-15	1944-09-15 00:00:00	1945-03-01	1945-03-01 00:00:00	32020		\N	342440	0	65363002	372328		0
87297	5197	260139	1954-06-17	1954-06-17 00:00:00	1954-06-24	1954-06-24 00:00:00	32020		\N	345578	0	10509002	260139		0
87608	5213	4112343	1943-04-25	1943-04-25 00:00:00	1943-05-04	1943-05-04 00:00:00	32020		\N	346706	0	195662009	4112343		0
87762	5222	4112343	1997-05-18	1997-05-18 00:00:00	1997-05-30	1997-05-30 00:00:00	32020		\N	347429	0	195662009	4112343		0
88435	5256	80180	2004-02-15	2004-02-15 00:00:00	\N	\N	32020		\N	349756	0	396275006	80180		0
88768	5277	4283893	1982-08-09	1982-08-09 00:00:00	1982-08-30	1982-08-30 00:00:00	32020		\N	350960	0	36971009	4283893		0
88901	5285	78272	1970-04-13	1970-04-13 00:00:00	1970-04-27	1970-04-27 00:00:00	32020		\N	351688	0	70704007	78272		0
89084	5300	4112343	1979-05-28	1979-05-28 00:00:00	1979-06-04	1979-06-04 00:00:00	32020		\N	352629	0	195662009	4112343		0
89291	5312	4310024	1972-01-21	1972-01-21 00:00:00	\N	\N	32020		\N	353229	0	424802006	4310024		0
89399	5316	4027663	1984-08-13	1984-08-13 00:00:00	\N	\N	32020		\N	353608	0	13200003	4027663		0
80321	4758	260139	2013-06-09	2013-06-09 00:00:00	2013-06-16	2013-06-16 00:00:00	32020		\N	316998	0	10509002	260139		0
85469	5081	372328	1946-10-14	1946-10-14 00:00:00	1947-04-18	1947-04-18 00:00:00	32020		\N	337836	0	65363002	372328		0
85635	5094	80180	2017-12-07	2017-12-07 00:00:00	\N	\N	32020		\N	338465	0	396275006	80180		0
85710	5099	4109685	1978-11-27	1978-11-27 00:00:00	1978-12-18	1978-12-18 00:00:00	32020		\N	338866	0	284551006	4109685		0
75526	4482	81151	1976-10-01	1976-10-01 00:00:00	1976-10-22	1976-10-22 00:00:00	32020		\N	298357	0	44465007	81151		0
86308	5137	260139	1970-11-04	1970-11-04 00:00:00	1970-11-18	1970-11-18 00:00:00	32020		\N	341428	0	10509002	260139		0
86389	5142	4237458	1965-07-02	1965-07-02 00:00:00	1965-09-30	1965-09-30 00:00:00	32020		\N	341693	0	58150001	4237458		0
86549	5150	260139	1973-12-13	1973-12-13 00:00:00	1973-12-20	1973-12-20 00:00:00	32020		\N	342379	0	10509002	260139		0
87298	5197	40481087	2006-05-22	2006-05-22 00:00:00	2006-06-12	2006-06-12 00:00:00	32020		\N	345586	0	444814009	40481087		0
87609	5213	439777	2018-05-27	2018-05-27 00:00:00	\N	\N	32020		\N	346744	0	271737000	439777		0
87763	5222	372328	1919-03-11	1919-03-11 00:00:00	1919-06-26	1919-06-26 00:00:00	32020		\N	347504	0	65363002	372328		0
88436	5257	4230399	1989-02-13	1989-02-13 00:00:00	1989-05-14	1989-05-14 00:00:00	32020		\N	349843	0	359817006	4230399		0
88769	5277	4296204	1963-11-24	1963-11-24 00:00:00	1963-12-08	1963-12-08 00:00:00	32020		\N	350976	0	403190006	4296204		0
88902	5285	40481087	1993-05-09	1993-05-09 00:00:00	1993-05-30	1993-05-30 00:00:00	32020		\N	351628	0	444814009	40481087		0
89085	5300	30753	1980-04-11	1980-04-11 00:00:00	\N	\N	32020		\N	352629	0	16761005	30753		0
89292	5312	80180	1973-06-14	1973-06-14 00:00:00	\N	\N	32020		\N	353229	0	396275006	80180		0
89400	5316	40481087	2011-08-22	2011-08-22 00:00:00	2011-08-29	2011-08-29 00:00:00	32020		\N	353565	0	444814009	40481087		0
80322	4758	260139	1985-05-08	1985-05-08 00:00:00	1985-05-15	1985-05-15 00:00:00	32020		\N	317027	0	10509002	260139		0
85470	5081	40481087	1953-08-29	1953-08-29 00:00:00	1953-09-05	1953-09-05 00:00:00	32020		\N	337877	0	444814009	40481087		0
85636	5094	134438	1999-05-03	1999-05-03 00:00:00	2000-05-28	2000-05-28 00:00:00	32020		\N	338441	0	40275004	134438		0
85711	5099	28060	2017-04-07	2017-04-07 00:00:00	2017-04-16	2017-04-16 00:00:00	32020		\N	338843	0	43878008	28060		0
75527	4482	260139	1994-04-12	1994-04-12 00:00:00	1994-04-26	1994-04-26 00:00:00	32020		\N	298394	0	10509002	260139		0
86309	5137	80180	2004-03-28	2004-03-28 00:00:00	\N	\N	32020		\N	341446	0	396275006	80180		0
86390	5142	40481087	2017-12-31	2017-12-31 00:00:00	2018-01-07	2018-01-07 00:00:00	32020		\N	341771	0	444814009	40481087		0
86550	5150	4296204	2004-05-20	2004-05-20 00:00:00	2004-06-03	2004-06-03 00:00:00	32020		\N	342337	0	403190006	4296204		0
87299	5197	372328	1956-06-17	1956-06-17 00:00:00	1956-09-18	1956-09-18 00:00:00	32020		\N	345637	0	65363002	372328		0
87610	5213	40481087	1974-06-03	1974-06-03 00:00:00	1974-06-10	1974-06-10 00:00:00	32020		\N	346739	0	444814009	40481087		0
87764	5222	4142905	1928-02-06	1928-02-06 00:00:00	1928-03-07	1928-03-07 00:00:00	32020		\N	347508	0	33737001	4142905		0
88437	5257	4112343	1988-01-10	1988-01-10 00:00:00	1988-01-21	1988-01-21 00:00:00	32020		\N	349834	0	195662009	4112343		0
88770	5278	4230399	1971-06-28	1971-06-28 00:00:00	1971-09-26	1971-09-26 00:00:00	32020		\N	351125	0	359817006	4230399		0
88903	5285	4112343	2015-05-13	2015-05-13 00:00:00	2015-05-24	2015-05-24 00:00:00	32020		\N	351703	0	195662009	4112343		0
89086	5300	260139	1965-04-09	1965-04-09 00:00:00	1965-04-23	1965-04-23 00:00:00	32020		\N	352635	0	10509002	260139		0
89293	5312	4152936	1971-08-30	1971-08-30 00:00:00	1971-09-13	1971-09-13 00:00:00	32020		\N	353229	0	283385000	4152936		0
89401	5316	40481087	1999-04-06	1999-04-06 00:00:00	1999-04-20	1999-04-20 00:00:00	32020		\N	353606	0	444814009	40481087		0
80323	4758	40481087	2002-03-10	2002-03-10 00:00:00	2002-03-31	2002-03-31 00:00:00	32020		\N	317008	0	444814009	40481087		0
85471	5081	321042	1935-05-17	1935-05-17 00:00:00	\N	\N	32020		\N	337899	0	410429000	321042		0
85637	5094	4112343	1994-09-08	1994-09-08 00:00:00	1994-09-19	1994-09-19 00:00:00	32020		\N	338471	0	195662009	4112343		0
85712	5099	40481087	1992-09-23	1992-09-23 00:00:00	1992-10-07	1992-10-07 00:00:00	32020		\N	338840	0	444814009	40481087		0
75528	4482	378001	1985-04-08	1985-04-08 00:00:00	1985-06-07	1985-06-07 00:00:00	32020		\N	298358	0	62106007	378001		0
86310	5137	372328	2010-04-24	2010-04-24 00:00:00	2010-07-28	2010-07-28 00:00:00	32020		\N	341374	0	65363002	372328		0
86391	5142	4296204	1970-09-04	1970-09-04 00:00:00	1970-09-18	1970-09-18 00:00:00	32020		\N	341694	0	403190006	4296204		0
86551	5150	40481087	1968-07-05	1968-07-05 00:00:00	1968-07-26	1968-07-26 00:00:00	32020		\N	342389	0	444814009	40481087		0
87301	5197	260139	1960-11-20	1960-11-20 00:00:00	1960-12-04	1960-12-04 00:00:00	32020		\N	345592	0	10509002	260139		0
87611	5213	40481087	1984-05-12	1984-05-12 00:00:00	1984-05-19	1984-05-19 00:00:00	32020		\N	346740	0	444814009	40481087		0
87765	5222	81151	2016-05-15	2016-05-15 00:00:00	2016-06-12	2016-06-12 00:00:00	32020		\N	347506	0	44465007	81151		0
88438	5257	4112343	1979-09-09	1979-09-09 00:00:00	1979-09-22	1979-09-22 00:00:00	32020		\N	349823	0	195662009	4112343		0
88771	5278	4278672	1984-12-16	1984-12-16 00:00:00	1985-02-14	1985-02-14 00:00:00	32020		\N	351129	0	65966004	4278672		0
88904	5285	260139	1968-12-20	1968-12-20 00:00:00	1968-12-27	1968-12-27 00:00:00	32020		\N	351698	0	10509002	260139		0
89087	5300	80180	1981-09-03	1981-09-03 00:00:00	\N	\N	32020		\N	352592	0	396275006	80180		0
89294	5312	4112343	1948-02-14	1948-02-14 00:00:00	1948-02-25	1948-02-25 00:00:00	32020		\N	353291	0	195662009	4112343		0
89402	5316	28060	2016-06-22	2016-06-22 00:00:00	2016-06-30	2016-06-30 00:00:00	32020		\N	353566	0	43878008	28060		0
80324	4758	4113008	1991-05-06	1991-05-06 00:00:00	1991-05-27	1991-05-27 00:00:00	32020		\N	316968	0	284549007	4113008		0
85473	5081	4156265	1939-03-21	1939-03-21 00:00:00	1939-04-04	1939-04-04 00:00:00	32020		\N	337900	0	370247008	4156265		0
85638	5094	260139	2006-06-05	2006-06-05 00:00:00	2006-06-12	2006-06-12 00:00:00	32020		\N	338458	0	10509002	260139		0
85713	5099	40481087	1954-04-28	1954-04-28 00:00:00	1954-05-19	1954-05-19 00:00:00	32020		\N	338830	0	444814009	40481087		0
75529	4482	4112343	1958-11-30	1958-11-30 00:00:00	1958-12-07	1958-12-07 00:00:00	32020		\N	298385	0	195662009	4112343		0
86311	5137	4051466	1970-06-27	1970-06-27 00:00:00	1986-10-05	1986-10-05 00:00:00	32020		\N	341436	0	233678006	4051466		0
86392	5142	260139	1972-07-25	1972-07-25 00:00:00	1972-08-01	1972-08-01 00:00:00	32020		\N	341708	0	10509002	260139		0
86552	5150	40481087	1962-09-22	1962-09-22 00:00:00	1962-09-29	1962-09-29 00:00:00	32020		\N	342377	0	444814009	40481087		0
87302	5197	40481087	1969-08-02	1969-08-02 00:00:00	1969-08-09	1969-08-09 00:00:00	32020		\N	345625	0	444814009	40481087		0
87612	5213	4155034	1975-03-04	1975-03-04 00:00:00	1975-03-18	1975-03-18 00:00:00	32020		\N	346773	0	283371005	4155034		0
87766	5222	260139	1947-12-21	1947-12-21 00:00:00	1948-01-04	1948-01-04 00:00:00	32020		\N	347408	0	10509002	260139		0
88439	5257	4149245	2014-04-03	2014-04-03 00:00:00	2014-06-09	2014-06-09 00:00:00	32020		\N	349786	0	30832001	4149245		0
88772	5278	192671	2013-10-23	2013-10-23 00:00:00	\N	\N	32020		\N	351130	0	K92.2	35208414		0
88905	5285	260139	2009-09-03	2009-09-03 00:00:00	2009-09-10	2009-09-10 00:00:00	32020		\N	351663	0	10509002	260139		0
89088	5300	40481087	2012-05-16	2012-05-16 00:00:00	2012-05-23	2012-05-23 00:00:00	32020		\N	352643	0	444814009	40481087		0
89295	5312	40481087	1999-09-21	1999-09-21 00:00:00	1999-10-12	1999-10-12 00:00:00	32020		\N	353252	0	444814009	40481087		0
89403	5316	192671	1995-08-02	1995-08-02 00:00:00	\N	\N	32020		\N	353616	0	K92.2	35208414		0
80325	4758	40481087	1969-09-29	1969-09-29 00:00:00	1969-10-13	1969-10-13 00:00:00	32020		\N	317026	0	444814009	40481087		0
85474	5081	40481087	1958-02-19	1958-02-19 00:00:00	1958-03-12	1958-03-12 00:00:00	32020		\N	337847	0	444814009	40481087		0
85639	5095	4294548	2003-11-05	2003-11-05 00:00:00	2003-12-17	2003-12-17 00:00:00	32020		\N	338500	0	75498004	4294548		0
85714	5099	4116491	1989-02-22	1989-02-22 00:00:00	1989-04-01	1989-04-01 00:00:00	32020		\N	338839	0	301011002	4116491		0
75530	4482	257012	2005-06-14	2005-06-14 00:00:00	\N	\N	32020		\N	298395	0	40055000	257012		0
86312	5137	40481087	1993-05-10	1993-05-10 00:00:00	1993-05-17	1993-05-17 00:00:00	32020		\N	341368	0	444814009	40481087		0
86393	5142	4112343	2018-06-05	2018-06-05 00:00:00	2018-06-15	2018-06-15 00:00:00	32020		\N	341716	0	195662009	4112343		0
86553	5150	4112343	2007-01-03	2007-01-03 00:00:00	2007-01-12	2007-01-12 00:00:00	32020		\N	342431	0	195662009	4112343		0
87303	5197	260139	1986-10-21	1986-10-21 00:00:00	1986-11-04	1986-11-04 00:00:00	32020		\N	345594	0	10509002	260139		0
87613	5213	4112343	2009-03-30	2009-03-30 00:00:00	2009-04-07	2009-04-07 00:00:00	32020		\N	346742	0	195662009	4112343		0
87767	5222	372328	1919-10-24	1919-10-24 00:00:00	1919-12-25	1919-12-25 00:00:00	32020		\N	347431	0	65363002	372328		0
88440	5257	260139	1986-07-03	1986-07-03 00:00:00	1986-07-17	1986-07-17 00:00:00	32020		\N	349833	0	10509002	260139		0
88773	5278	40481087	1972-08-18	1972-08-18 00:00:00	1972-08-25	1972-08-25 00:00:00	32020		\N	351043	0	444814009	40481087		0
88906	5285	4112343	1995-01-15	1995-01-15 00:00:00	1995-01-25	1995-01-25 00:00:00	32020		\N	351701	0	195662009	4112343		0
89089	5300	40481087	1971-11-05	1971-11-05 00:00:00	1971-11-19	1971-11-19 00:00:00	32020		\N	352639	0	444814009	40481087		0
89296	5312	40481087	1982-10-08	1982-10-08 00:00:00	1982-10-15	1982-10-15 00:00:00	32020		\N	353287	0	444814009	40481087		0
89404	5316	4310024	1992-07-07	1992-07-07 00:00:00	\N	\N	32020		\N	353553	0	424802006	4310024		0
80326	4758	40481087	1977-11-05	1977-11-05 00:00:00	1977-11-26	1977-11-26 00:00:00	32020		\N	316976	0	444814009	40481087		0
85475	5081	81151	1985-07-27	1985-07-27 00:00:00	1985-08-10	1985-08-10 00:00:00	32020		\N	337904	0	44465007	81151		0
85640	5095	260139	1985-06-20	1985-06-20 00:00:00	1985-07-04	1985-07-04 00:00:00	32020		\N	338548	0	10509002	260139		0
85715	5099	4112343	1986-03-09	1986-03-09 00:00:00	1986-03-20	1986-03-20 00:00:00	32020		\N	338863	0	195662009	4112343		0
85989	5117	30753	1997-06-18	1997-06-18 00:00:00	\N	\N	32020		\N	340084	0	16761005	30753		0
86313	5137	4156265	1987-06-06	1987-06-06 00:00:00	1987-06-27	1987-06-27 00:00:00	32020		\N	341355	0	370247008	4156265		0
86394	5142	192671	1985-05-16	1985-05-16 00:00:00	\N	\N	32020		\N	341703	0	K92.2	35208414		0
86554	5150	378001	1975-10-20	1975-10-20 00:00:00	1975-11-19	1975-11-19 00:00:00	32020		\N	342336	0	62106007	378001		0
87304	5197	40481087	1989-12-02	1989-12-02 00:00:00	1989-12-16	1989-12-16 00:00:00	32020		\N	345629	0	444814009	40481087		0
87614	5213	4112343	1949-10-01	1949-10-01 00:00:00	1949-10-13	1949-10-13 00:00:00	32020		\N	346694	0	195662009	4112343		0
87768	5222	81151	1926-04-03	1926-04-03 00:00:00	1926-04-17	1926-04-17 00:00:00	32020		\N	347507	0	44465007	81151		0
88441	5257	80180	2014-03-21	2014-03-21 00:00:00	\N	\N	32020		\N	349784	0	396275006	80180		0
88774	5278	372328	1987-05-05	1987-05-05 00:00:00	1987-06-26	1987-06-26 00:00:00	32020		\N	351117	0	65363002	372328		0
88907	5285	28060	1950-09-27	1950-09-27 00:00:00	1950-10-04	1950-10-04 00:00:00	32020		\N	351710	0	43878008	28060		0
89090	5300	4027663	1971-12-20	1971-12-20 00:00:00	\N	\N	32020		\N	352639	0	13200003	4027663		0
89297	5312	4112343	1980-10-18	1980-10-18 00:00:00	1980-10-27	1980-10-27 00:00:00	32020		\N	353284	0	195662009	4112343		0
89405	5316	28060	1957-07-17	1957-07-17 00:00:00	1957-07-28	1957-07-28 00:00:00	32020		\N	353603	0	43878008	28060		0
80327	4758	40481087	1958-08-15	1958-08-15 00:00:00	1958-08-29	1958-08-29 00:00:00	32020		\N	317007	0	444814009	40481087		0
85476	5081	4230399	2004-11-19	2004-11-19 00:00:00	2004-12-19	2004-12-19 00:00:00	32020		\N	337810	0	359817006	4230399		0
85641	5095	81151	1979-01-31	1979-01-31 00:00:00	1979-02-21	1979-02-21 00:00:00	32020		\N	338498	0	44465007	81151		0
85716	5099	40481087	1949-03-09	1949-03-09 00:00:00	1949-03-16	1949-03-16 00:00:00	32020		\N	338860	0	444814009	40481087		0
85990	5117	40481087	1990-11-02	1990-11-02 00:00:00	1990-11-23	1990-11-23 00:00:00	32020		\N	340122	0	444814009	40481087		0
86314	5137	28060	1999-11-22	1999-11-22 00:00:00	1999-11-30	1999-11-30 00:00:00	32020		\N	341440	0	43878008	28060		0
86395	5142	260139	1988-07-10	1988-07-10 00:00:00	1988-07-17	1988-07-17 00:00:00	32020		\N	341709	0	10509002	260139		0
86555	5150	28060	1952-01-02	1952-01-02 00:00:00	1952-01-13	1952-01-13 00:00:00	32020		\N	342372	0	43878008	28060		0
87305	5197	81151	1987-07-27	1987-07-27 00:00:00	1987-08-10	1987-08-10 00:00:00	32020		\N	345573	0	44465007	81151		0
87615	5213	40481087	1994-06-04	1994-06-04 00:00:00	1994-06-18	1994-06-18 00:00:00	32020		\N	346709	0	444814009	40481087		0
87769	5222	260139	1924-01-15	1924-01-15 00:00:00	1924-01-22	1924-01-22 00:00:00	32020		\N	347362	0	10509002	260139		0
88442	5257	40481087	1995-04-02	1995-04-02 00:00:00	1995-04-16	1995-04-16 00:00:00	32020		\N	349835	0	444814009	40481087		0
88775	5278	4112343	1984-05-24	1984-05-24 00:00:00	1984-06-06	1984-06-06 00:00:00	32020		\N	351071	0	195662009	4112343		0
88908	5285	4329847	2008-07-06	2008-07-06 00:00:00	\N	\N	32020		\N	351690	0	22298006	4329847		0
89091	5300	4112343	1948-10-17	1948-10-17 00:00:00	1948-10-30	1948-10-30 00:00:00	32020		\N	352630	0	195662009	4112343		0
89406	5317	4112343	2009-10-23	2009-10-23 00:00:00	2009-11-05	2009-11-05 00:00:00	32020		\N	353677	0	195662009	4112343		0
80328	4759	260139	1979-02-06	1979-02-06 00:00:00	1979-02-13	1979-02-13 00:00:00	32020		\N	317055	0	10509002	260139		0
85477	5081	4146173	1995-08-09	1995-08-09 00:00:00	1995-09-08	1995-09-08 00:00:00	32020		\N	337859	0	307731004	4146173		0
85642	5095	260139	2012-11-27	2012-11-27 00:00:00	2012-12-11	2012-12-11 00:00:00	32020		\N	338520	0	10509002	260139		0
85717	5099	40481087	1971-07-11	1971-07-11 00:00:00	1971-07-25	1971-07-25 00:00:00	32020		\N	338837	0	444814009	40481087		0
85991	5117	81893	1996-08-22	1996-08-22 00:00:00	\N	\N	32020		\N	340045	0	64766004	81893		0
86315	5137	4155034	1989-05-17	1989-05-17 00:00:00	1989-06-07	1989-06-07 00:00:00	32020		\N	341356	0	283371005	4155034		0
86396	5142	40481087	1966-10-06	1966-10-06 00:00:00	1966-10-13	1966-10-13 00:00:00	32020		\N	341725	0	444814009	40481087		0
86556	5150	40481087	1953-06-22	1953-06-22 00:00:00	1953-07-13	1953-07-13 00:00:00	32020		\N	342469	0	444814009	40481087		0
87306	5197	4094814	1972-09-13	1972-09-13 00:00:00	1972-11-12	1972-11-12 00:00:00	32020		\N	345572	0	262574004	4094814		0
87616	5213	260139	1942-11-23	1942-11-23 00:00:00	1942-11-30	1942-11-30 00:00:00	32020		\N	346763	0	10509002	260139		0
87770	5222	260139	1935-02-21	1935-02-21 00:00:00	1935-02-28	1935-02-28 00:00:00	32020		\N	347385	0	10509002	260139		0
88443	5257	40481087	1994-10-12	1994-10-12 00:00:00	1994-10-26	1994-10-26 00:00:00	32020		\N	349825	0	444814009	40481087		0
88776	5278	40481087	1990-04-29	1990-04-29 00:00:00	1990-05-13	1990-05-13 00:00:00	32020		\N	351074	0	444814009	40481087		0
88910	5285	4027663	1973-11-28	1973-11-28 00:00:00	\N	\N	32020		\N	351653	0	13200003	4027663		0
89092	5300	4112343	1986-07-29	1986-07-29 00:00:00	1986-08-10	1986-08-10 00:00:00	32020		\N	352605	0	195662009	4112343		0
89407	5317	40481087	2003-12-27	2003-12-27 00:00:00	2004-01-17	2004-01-17 00:00:00	32020		\N	353658	0	444814009	40481087		0
80329	4759	81151	2005-01-07	2005-01-07 00:00:00	2005-02-04	2005-02-04 00:00:00	32020		\N	317066	0	44465007	81151		0
85478	5081	40481087	1984-02-25	1984-02-25 00:00:00	1984-03-17	1984-03-17 00:00:00	32020		\N	337865	0	444814009	40481087		0
85643	5095	40481087	1998-09-10	1998-09-10 00:00:00	1998-09-24	1998-09-24 00:00:00	32020		\N	338516	0	444814009	40481087		0
85718	5099	4296205	1989-02-23	1989-02-23 00:00:00	1989-03-09	1989-03-09 00:00:00	32020		\N	338867	0	403191005	4296205		0
85992	5117	40481087	2010-11-14	2010-11-14 00:00:00	2010-11-28	2010-11-28 00:00:00	32020		\N	340085	0	444814009	40481087		0
86316	5137	260139	2011-02-24	2011-02-24 00:00:00	2011-03-10	2011-03-10 00:00:00	32020		\N	341372	0	10509002	260139		0
86397	5142	4027663	1973-07-10	1973-07-10 00:00:00	\N	\N	32020		\N	341776	0	13200003	4027663		0
86557	5150	40481087	1976-10-20	1976-10-20 00:00:00	1976-11-10	1976-11-10 00:00:00	32020		\N	342470	0	444814009	40481087		0
87307	5197	381316	2012-05-08	2012-05-08 00:00:00	\N	\N	32020		\N	345612	0	230690007	381316		0
87617	5213	40481087	2016-10-16	2016-10-16 00:00:00	2016-10-30	2016-10-30 00:00:00	32020		\N	346743	0	444814009	40481087		0
87771	5222	40481087	2009-10-26	2009-10-26 00:00:00	2009-11-09	2009-11-09 00:00:00	32020		\N	347430	0	444814009	40481087		0
88444	5257	4112343	1998-09-08	1998-09-08 00:00:00	1998-09-18	1998-09-18 00:00:00	32020		\N	349826	0	195662009	4112343		0
88777	5278	4283893	2008-01-03	2008-01-03 00:00:00	2008-01-24	2008-01-24 00:00:00	32020		\N	351078	0	36971009	4283893		0
88911	5285	260139	2007-09-05	2007-09-05 00:00:00	2007-09-12	2007-09-12 00:00:00	32020		\N	351662	0	10509002	260139		0
89093	5300	260139	1959-05-24	1959-05-24 00:00:00	1959-06-07	1959-06-07 00:00:00	32020		\N	352633	0	10509002	260139		0
89408	5317	260139	1978-01-10	1978-01-10 00:00:00	1978-01-17	1978-01-17 00:00:00	32020		\N	353648	0	10509002	260139		0
80330	4759	4237458	1985-05-08	1985-05-08 00:00:00	1985-06-07	1985-06-07 00:00:00	32020		\N	317118	0	58150001	4237458		0
85479	5081	4112343	1944-05-21	1944-05-21 00:00:00	1944-05-28	1944-05-28 00:00:00	32020		\N	337845	0	195662009	4112343		0
85644	5095	81151	1970-12-04	1970-12-04 00:00:00	1970-12-25	1970-12-25 00:00:00	32020		\N	338495	0	44465007	81151		0
85719	5099	4112343	1944-03-31	1944-03-31 00:00:00	1944-04-07	1944-04-07 00:00:00	32020		\N	338833	0	195662009	4112343		0
85993	5117	4112343	1983-08-17	1983-08-17 00:00:00	1983-08-29	1983-08-29 00:00:00	32020		\N	340095	0	195662009	4112343		0
86317	5137	260139	1975-01-17	1975-01-17 00:00:00	1975-01-24	1975-01-24 00:00:00	32020		\N	341395	0	10509002	260139		0
86398	5143	40481087	2001-07-05	2001-07-05 00:00:00	2001-07-19	2001-07-19 00:00:00	32020		\N	341857	0	444814009	40481087		0
86558	5150	40481087	2000-08-13	2000-08-13 00:00:00	2000-08-20	2000-08-20 00:00:00	32020		\N	342411	0	444814009	40481087		0
87308	5197	260139	1964-08-24	1964-08-24 00:00:00	1964-09-07	1964-09-07 00:00:00	32020		\N	345579	0	10509002	260139		0
87618	5213	80180	1977-11-23	1977-11-23 00:00:00	\N	\N	32020		\N	346759	0	396275006	80180		0
87772	5222	4294548	1933-10-29	1933-10-29 00:00:00	1933-11-05	1933-11-05 00:00:00	32020		\N	347405	0	75498004	4294548		0
88445	5257	40481087	2000-08-25	2000-08-25 00:00:00	2000-09-08	2000-09-08 00:00:00	32020		\N	349787	0	444814009	40481087		0
88778	5278	80180	2013-10-15	2013-10-15 00:00:00	\N	\N	32020		\N	351079	0	396275006	80180		0
88912	5285	192671	1981-02-06	1981-02-06 00:00:00	\N	\N	32020		\N	351724	0	K92.2	35208414		0
89094	5300	40481087	1954-09-23	1954-09-23 00:00:00	1954-10-07	1954-10-07 00:00:00	32020		\N	352638	0	444814009	40481087		0
89409	5317	40481087	1996-12-06	1996-12-06 00:00:00	1996-12-27	1996-12-27 00:00:00	32020		\N	353657	0	444814009	40481087		0
80331	4759	4112343	1990-09-21	1990-09-21 00:00:00	1990-09-28	1990-09-28 00:00:00	32020		\N	317059	0	195662009	4112343		0
85645	5095	372328	1965-12-30	1965-12-30 00:00:00	1966-03-14	1966-03-14 00:00:00	32020		\N	338550	0	65363002	372328		0
85720	5099	28060	1999-02-27	1999-02-27 00:00:00	1999-03-11	1999-03-11 00:00:00	32020		\N	338891	0	43878008	28060		0
85994	5117	40481087	1987-06-22	1987-06-22 00:00:00	1987-07-13	1987-07-13 00:00:00	32020		\N	340117	0	444814009	40481087		0
86318	5137	260139	2002-09-05	2002-09-05 00:00:00	2002-09-12	2002-09-12 00:00:00	32020		\N	341369	0	10509002	260139		0
86399	5143	260139	2006-01-01	2006-01-01 00:00:00	2006-01-15	2006-01-15 00:00:00	32020		\N	341818	0	10509002	260139		0
86559	5150	260139	1979-10-03	1979-10-03 00:00:00	1979-10-17	1979-10-17 00:00:00	32020		\N	342344	0	10509002	260139		0
87309	5197	4112343	1971-04-20	1971-04-20 00:00:00	1971-05-01	1971-05-01 00:00:00	32020		\N	345626	0	195662009	4112343		0
87619	5213	40481087	1952-07-08	1952-07-08 00:00:00	1952-07-22	1952-07-22 00:00:00	32020		\N	346738	0	444814009	40481087		0
87773	5222	260139	1973-07-09	1973-07-09 00:00:00	1973-07-16	1973-07-16 00:00:00	32020		\N	347386	0	10509002	260139		0
88446	5257	4112343	1996-10-06	1996-10-06 00:00:00	1996-10-16	1996-10-16 00:00:00	32020		\N	349836	0	195662009	4112343		0
88779	5278	4112343	1997-09-27	1997-09-27 00:00:00	1997-10-06	1997-10-06 00:00:00	32020		\N	351116	0	195662009	4112343		0
88913	5285	40481087	2004-07-22	2004-07-22 00:00:00	2004-07-29	2004-07-29 00:00:00	32020		\N	351634	0	444814009	40481087		0
89095	5300	40481087	1975-01-28	1975-01-28 00:00:00	1975-02-11	1975-02-11 00:00:00	32020		\N	352628	0	444814009	40481087		0
89410	5317	372328	1974-01-30	1974-01-30 00:00:00	1974-02-20	1974-02-20 00:00:00	32020		\N	353681	0	65363002	372328		0
80332	4759	260139	2007-06-08	2007-06-08 00:00:00	2007-06-15	2007-06-15 00:00:00	32020		\N	317103	0	10509002	260139		0
85646	5095	257012	2003-12-10	2003-12-10 00:00:00	\N	\N	32020		\N	338501	0	40055000	257012		0
85721	5099	80180	1978-09-18	1978-09-18 00:00:00	\N	\N	32020		\N	338902	0	396275006	80180		0
85995	5117	4027663	1988-03-02	1988-03-02 00:00:00	\N	\N	32020		\N	340117	0	13200003	4027663		0
86319	5137	372328	1971-08-29	1971-08-29 00:00:00	1972-05-31	1972-05-31 00:00:00	32020		\N	341373	0	65363002	372328		0
86400	5143	40481087	1996-07-01	1996-07-01 00:00:00	1996-07-08	1996-07-08 00:00:00	32020		\N	341846	0	444814009	40481087		0
86560	5150	4112343	1939-12-26	1939-12-26 00:00:00	1940-01-04	1940-01-04 00:00:00	32020		\N	342364	0	195662009	4112343		0
87310	5197	4112343	2002-09-27	2002-09-27 00:00:00	2002-10-07	2002-10-07 00:00:00	32020		\N	345636	0	195662009	4112343		0
87620	5213	4296204	1981-11-11	1981-11-11 00:00:00	1981-11-25	1981-11-25 00:00:00	32020		\N	346774	0	403190006	4296204		0
87774	5222	28060	1965-06-06	1965-06-06 00:00:00	1965-06-16	1965-06-16 00:00:00	32020		\N	347486	0	43878008	28060		0
88447	5257	40481087	1987-02-02	1987-02-02 00:00:00	1987-02-16	1987-02-16 00:00:00	32020		\N	349828	0	444814009	40481087		0
88780	5278	4051466	1973-05-15	1973-05-15 00:00:00	1988-08-30	1988-08-30 00:00:00	32020		\N	351068	0	233678006	4051466		0
88914	5285	372328	1943-06-04	1943-06-04 00:00:00	1943-08-15	1943-08-15 00:00:00	32020		\N	351704	0	65363002	372328		0
89096	5300	260139	1998-11-10	1998-11-10 00:00:00	1998-11-17	1998-11-17 00:00:00	32020		\N	352642	0	10509002	260139		0
89411	5317	260139	1973-11-03	1973-11-03 00:00:00	1973-11-17	1973-11-17 00:00:00	32020		\N	353647	0	10509002	260139		0
80333	4759	28060	1992-05-21	1992-05-21 00:00:00	1992-05-29	1992-05-29 00:00:00	32020		\N	317060	0	43878008	28060		0
85647	5095	40481087	2005-03-18	2005-03-18 00:00:00	2005-04-08	2005-04-08 00:00:00	32020		\N	338518	0	444814009	40481087		0
85722	5099	40481087	2008-02-22	2008-02-22 00:00:00	2008-03-14	2008-03-14 00:00:00	32020		\N	338842	0	444814009	40481087		0
85996	5117	81151	1984-03-23	1984-03-23 00:00:00	1984-04-06	1984-04-06 00:00:00	32020		\N	340143	0	44465007	81151		0
86320	5137	4116491	1997-06-13	1997-06-13 00:00:00	1997-07-25	1997-07-25 00:00:00	32020		\N	341431	0	301011002	4116491		0
86401	5143	40481087	1964-12-13	1964-12-13 00:00:00	1964-12-27	1964-12-27 00:00:00	32020		\N	341859	0	444814009	40481087		0
86561	5150	80180	1976-07-19	1976-07-19 00:00:00	\N	\N	32020		\N	342367	0	396275006	80180		0
87311	5197	81151	1959-03-21	1959-03-21 00:00:00	1959-04-25	1959-04-25 00:00:00	32020		\N	345570	0	44465007	81151		0
87621	5213	4112343	1950-04-12	1950-04-12 00:00:00	1950-04-24	1950-04-24 00:00:00	32020		\N	346695	0	195662009	4112343		0
87775	5222	40481087	1923-05-25	1923-05-25 00:00:00	1923-06-15	1923-06-15 00:00:00	32020		\N	347361	0	444814009	40481087		0
88448	5257	4218389	1980-01-04	1980-01-04 00:00:00	1980-02-01	1980-02-01 00:00:00	32020		\N	349842	0	39848009	4218389		0
88781	5278	40481087	2010-05-20	2010-05-20 00:00:00	2010-06-10	2010-06-10 00:00:00	32020		\N	351098	0	444814009	40481087		0
88915	5285	40481087	1947-10-07	1947-10-07 00:00:00	1947-10-21	1947-10-21 00:00:00	32020		\N	351709	0	444814009	40481087		0
89097	5300	4237458	2018-03-18	2018-03-18 00:00:00	2018-04-17	2018-04-17 00:00:00	32020		\N	352657	0	58150001	4237458		0
89412	5317	4112343	2003-03-08	2003-03-08 00:00:00	2003-03-17	2003-03-17 00:00:00	32020		\N	353652	0	195662009	4112343		0
80334	4759	4142905	1989-06-16	1989-06-16 00:00:00	1989-09-14	1989-09-14 00:00:00	32020		\N	317119	0	33737001	4142905		0
85648	5095	40481087	2015-03-26	2015-03-26 00:00:00	2015-04-02	2015-04-02 00:00:00	32020		\N	338521	0	444814009	40481087		0
85723	5099	40481087	1950-10-14	1950-10-14 00:00:00	1950-10-21	1950-10-21 00:00:00	32020		\N	338888	0	444814009	40481087		0
85997	5117	260139	1979-09-17	1979-09-17 00:00:00	1979-10-01	1979-10-01 00:00:00	32020		\N	340094	0	10509002	260139		0
86402	5143	40481087	1982-12-23	1982-12-23 00:00:00	1982-12-30	1982-12-30 00:00:00	32020		\N	341831	0	444814009	40481087		0
86562	5150	40481087	1962-04-05	1962-04-05 00:00:00	1962-04-19	1962-04-19 00:00:00	32020		\N	342376	0	444814009	40481087		0
87312	5197	40481087	1986-09-07	1986-09-07 00:00:00	1986-09-14	1986-09-14 00:00:00	32020		\N	345583	0	444814009	40481087		0
87622	5213	372328	1941-03-02	1941-03-02 00:00:00	1941-05-22	1941-05-22 00:00:00	32020		\N	346745	0	65363002	372328		0
87776	5222	261325	1998-01-08	1998-01-08 00:00:00	\N	\N	32020		\N	347464	0	87433001	261325		0
88449	5257	372328	1979-06-08	1979-06-08 00:00:00	1979-08-22	1979-08-22 00:00:00	32020		\N	349827	0	65363002	372328		0
88782	5278	40481087	1970-11-08	1970-11-08 00:00:00	1970-11-22	1970-11-22 00:00:00	32020		\N	351066	0	444814009	40481087		0
88916	5285	140673	2011-11-19	2011-11-19 00:00:00	\N	\N	32020		\N	351664	0	40930008	140673		0
89098	5300	4112343	1962-02-16	1962-02-16 00:00:00	1962-02-25	1962-02-25 00:00:00	32020		\N	352602	0	195662009	4112343		0
89413	5317	40481087	2018-06-18	2018-06-18 00:00:00	2018-07-09	2018-07-09 00:00:00	32020		\N	353639	0	444814009	40481087		0
80335	4759	4113008	2017-01-02	2017-01-02 00:00:00	2017-01-16	2017-01-16 00:00:00	32020		\N	317072	0	284549007	4113008		0
85649	5095	4112343	2003-02-15	2003-02-15 00:00:00	2003-02-23	2003-02-23 00:00:00	32020		\N	338517	0	195662009	4112343		0
85724	5099	40481087	2000-01-06	2000-01-06 00:00:00	2000-01-27	2000-01-27 00:00:00	32020		\N	338841	0	444814009	40481087		0
85998	5117	260139	1993-07-02	1993-07-02 00:00:00	1993-07-09	1993-07-09 00:00:00	32020		\N	340070	0	10509002	260139		0
86403	5143	40481087	1969-02-10	1969-02-10 00:00:00	1969-02-17	1969-02-17 00:00:00	32020		\N	341861	0	444814009	40481087		0
86563	5150	78272	1958-12-06	1958-12-06 00:00:00	1959-01-03	1959-01-03 00:00:00	32020		\N	342334	0	70704007	78272		0
87313	5197	4027663	1984-04-13	1984-04-13 00:00:00	\N	\N	32020		\N	345604	0	13200003	4027663		0
87635	5215	4112343	1992-09-14	1992-09-14 00:00:00	1992-09-21	1992-09-21 00:00:00	32020		\N	346869	0	195662009	4112343		0
87777	5222	260139	1977-04-29	1977-04-29 00:00:00	1977-05-13	1977-05-13 00:00:00	32020		\N	347355	0	10509002	260139		0
88450	5258	260139	1984-09-22	1984-09-22 00:00:00	1984-10-06	1984-10-06 00:00:00	32020		\N	349850	0	10509002	260139		0
88783	5278	40481087	1999-07-03	1999-07-03 00:00:00	1999-07-10	1999-07-10 00:00:00	32020		\N	351094	0	444814009	40481087		0
88917	5285	28060	1971-10-26	1971-10-26 00:00:00	1971-11-06	1971-11-06 00:00:00	32020		\N	351624	0	43878008	28060		0
89099	5300	198809	1945-02-13	1945-02-13 00:00:00	1945-02-13	1945-02-13 00:00:00	32020		\N	352654	0	65275009	198809		0
89414	5317	81151	1981-04-23	1981-04-23 00:00:00	1981-05-07	1981-05-07 00:00:00	32020		\N	353645	0	44465007	81151		0
80336	4759	80180	2018-05-25	2018-05-25 00:00:00	\N	\N	32020		\N	317078	0	396275006	80180		0
85650	5095	4027663	1994-12-28	1994-12-28 00:00:00	\N	\N	32020		\N	338542	0	13200003	4027663		0
85725	5099	260139	1949-10-01	1949-10-01 00:00:00	1949-10-08	1949-10-08 00:00:00	32020		\N	338829	0	10509002	260139		0
85999	5117	40481087	1983-10-14	1983-10-14 00:00:00	1983-11-04	1983-11-04 00:00:00	32020		\N	340096	0	444814009	40481087		0
86404	5143	40481087	1986-05-11	1986-05-11 00:00:00	1986-05-18	1986-05-18 00:00:00	32020		\N	341813	0	444814009	40481087		0
86564	5150	260139	2011-06-01	2011-06-01 00:00:00	2011-06-08	2011-06-08 00:00:00	32020		\N	342466	0	10509002	260139		0
87314	5197	4296205	2009-04-07	2009-04-07 00:00:00	2009-05-05	2009-05-05 00:00:00	32020		\N	345577	0	403191005	4296205		0
87636	5215	260139	2014-09-04	2014-09-04 00:00:00	2014-09-11	2014-09-11 00:00:00	32020		\N	346826	0	10509002	260139		0
87778	5222	40481087	1959-12-05	1959-12-05 00:00:00	1959-12-26	1959-12-26 00:00:00	32020		\N	347409	0	444814009	40481087		0
88451	5258	260139	1982-11-23	1982-11-23 00:00:00	1982-11-30	1982-11-30 00:00:00	32020		\N	349890	0	10509002	260139		0
88784	5278	260139	1981-06-07	1981-06-07 00:00:00	1981-06-14	1981-06-14 00:00:00	32020		\N	351055	0	10509002	260139		0
88918	5285	40481087	2012-08-24	2012-08-24 00:00:00	2012-09-07	2012-09-07 00:00:00	32020		\N	351629	0	444814009	40481087		0
89100	5300	196456	1945-02-13	1945-02-13 00:00:00	1945-02-13	1945-02-13 00:00:00	32020		\N	352654	0	235919008	196456		0
89415	5317	80180	2014-05-20	2014-05-20 00:00:00	\N	\N	32020		\N	353675	0	396275006	80180		0
80337	4759	260139	1987-03-05	1987-03-05 00:00:00	1987-03-12	1987-03-12 00:00:00	32020		\N	317058	0	10509002	260139		0
85651	5095	40481087	1970-12-09	1970-12-09 00:00:00	1970-12-30	1970-12-30 00:00:00	32020		\N	338515	0	444814009	40481087		0
85726	5099	260139	1953-10-18	1953-10-18 00:00:00	1953-11-01	1953-11-01 00:00:00	32020		\N	338835	0	10509002	260139		0
86000	5117	4280726	1960-03-16	1960-03-16 00:00:00	1977-03-14	1977-03-14 00:00:00	32020		\N	340031	0	367498001	4280726		0
86405	5143	378001	2010-12-17	2010-12-17 00:00:00	2011-01-16	2011-01-16 00:00:00	32020		\N	341886	0	62106007	378001		0
86565	5150	260139	1978-06-24	1978-06-24 00:00:00	1978-07-08	1978-07-08 00:00:00	32020		\N	342343	0	10509002	260139		0
87315	5197	40481087	1974-01-23	1974-01-23 00:00:00	1974-02-13	1974-02-13 00:00:00	32020		\N	345628	0	444814009	40481087		0
87637	5215	40481087	1984-09-14	1984-09-14 00:00:00	1984-10-05	1984-10-05 00:00:00	32020		\N	346823	0	444814009	40481087		0
87779	5222	260139	2015-07-21	2015-07-21 00:00:00	2015-08-04	2015-08-04 00:00:00	32020		\N	347503	0	10509002	260139		0
88452	5258	372328	1958-11-27	1958-11-27 00:00:00	1959-01-07	1959-01-07 00:00:00	32020		\N	349861	0	65363002	372328		0
88785	5278	28060	2006-01-24	2006-01-24 00:00:00	2006-02-06	2006-02-06 00:00:00	32020		\N	351097	0	43878008	28060		0
88936	5290	4218389	2000-05-08	2000-05-08 00:00:00	2000-05-29	2000-05-29 00:00:00	32020		\N	352034	0	39848009	4218389		0
89101	5300	4155034	2015-04-19	2015-04-19 00:00:00	2015-05-03	2015-05-03 00:00:00	32020		\N	352656	0	283371005	4155034		0
89416	5317	4283893	2011-06-26	2011-06-26 00:00:00	2011-10-16	2011-10-16 00:00:00	32020		\N	353679	0	36971009	4283893		0
80338	4759	260139	2000-08-10	2000-08-10 00:00:00	2000-08-24	2000-08-24 00:00:00	32020		\N	317076	0	10509002	260139		0
85652	5095	381316	2007-01-15	2007-01-15 00:00:00	\N	\N	32020		\N	338519	0	230690007	381316		0
85727	5099	40481087	1963-07-09	1963-07-09 00:00:00	1963-07-16	1963-07-16 00:00:00	32020		\N	338836	0	444814009	40481087		0
86001	5117	4310024	1995-11-26	1995-11-26 00:00:00	\N	\N	32020		\N	340044	0	424802006	4310024		0
86406	5143	80180	2000-10-20	2000-10-20 00:00:00	\N	\N	32020		\N	341877	0	396275006	80180		0
86566	5150	4112343	1977-09-01	1977-09-01 00:00:00	1977-09-08	1977-09-08 00:00:00	32020		\N	342391	0	195662009	4112343		0
87316	5197	4112343	1975-09-09	1975-09-09 00:00:00	1975-09-16	1975-09-16 00:00:00	32020		\N	345581	0	195662009	4112343		0
87638	5215	372328	1954-09-14	1954-09-14 00:00:00	1955-05-09	1955-05-09 00:00:00	32020		\N	346882	0	65363002	372328		0
87780	5222	4112343	2003-02-01	2003-02-01 00:00:00	2003-02-14	2003-02-14 00:00:00	32020		\N	347501	0	195662009	4112343		0
88453	5258	4112343	1994-10-27	1994-10-27 00:00:00	1994-11-03	1994-11-03 00:00:00	32020		\N	349922	0	195662009	4112343		0
88786	5279	40481087	1983-08-16	1983-08-16 00:00:00	1983-09-06	1983-09-06 00:00:00	32020		\N	351173	0	444814009	40481087		0
88937	5290	40486433	1955-11-13	1955-11-13 00:00:00	\N	\N	32020		\N	351894	0	446096008	40486433		0
89102	5300	260139	2002-12-25	2002-12-25 00:00:00	2003-01-08	2003-01-08 00:00:00	32020		\N	352606	0	10509002	260139		0
89417	5317	4112343	1973-11-03	1973-11-03 00:00:00	1973-11-13	1973-11-13 00:00:00	32020		\N	353647	0	195662009	4112343		0
80339	4759	40481087	1992-10-30	1992-10-30 00:00:00	1992-11-13	1992-11-13 00:00:00	32020		\N	317101	0	444814009	40481087		0
85653	5095	4112343	2006-06-11	2006-06-11 00:00:00	2006-06-18	2006-06-18 00:00:00	32020		\N	338519	0	195662009	4112343		0
85728	5099	4112343	1950-05-20	1950-05-20 00:00:00	1950-05-31	1950-05-31 00:00:00	32020		\N	338861	0	195662009	4112343		0
86002	5117	4294548	1972-04-18	1972-04-18 00:00:00	1972-07-04	1972-07-04 00:00:00	32020		\N	340093	0	75498004	4294548		0
86407	5143	4059173	1965-04-07	1965-04-07 00:00:00	1965-05-07	1965-05-07 00:00:00	32020		\N	341882	0	16114001	4059173		0
86567	5150	260139	1998-09-13	1998-09-13 00:00:00	1998-09-27	1998-09-27 00:00:00	32020		\N	342410	0	10509002	260139		0
87639	5215	4112343	1943-08-28	1943-08-28 00:00:00	1943-09-04	1943-09-04 00:00:00	32020		\N	346821	0	195662009	4112343		0
87781	5222	4112343	1956-05-24	1956-05-24 00:00:00	1956-06-06	1956-06-06 00:00:00	32020		\N	347485	0	195662009	4112343		0
88454	5258	4059173	1968-01-14	1968-01-14 00:00:00	1968-02-13	1968-02-13 00:00:00	32020		\N	349869	0	16114001	4059173		0
88787	5279	28060	1949-12-09	1949-12-09 00:00:00	1949-12-22	1949-12-22 00:00:00	32020		\N	351212	0	43878008	28060		0
88938	5290	40481087	1956-09-26	1956-09-26 00:00:00	1956-10-03	1956-10-03 00:00:00	32020		\N	351910	0	444814009	40481087		0
89103	5300	4134304	1942-11-17	1942-11-17 00:00:00	1943-02-15	1943-02-15 00:00:00	32020		\N	352653	0	263102004	4134304		0
89418	5317	4112343	2011-01-03	2011-01-03 00:00:00	2011-01-16	2011-01-16 00:00:00	32020		\N	353678	0	195662009	4112343		0
80340	4759	4112343	1997-07-05	1997-07-05 00:00:00	1997-07-13	1997-07-13 00:00:00	32020		\N	317102	0	195662009	4112343		0
85654	5095	378001	1986-08-13	1986-08-13 00:00:00	1986-10-12	1986-10-12 00:00:00	32020		\N	338499	0	62106007	378001		0
85729	5099	260139	1969-02-11	1969-02-11 00:00:00	1969-02-27	1969-02-27 00:00:00	32020		\N	338819	0	10509002	260139		0
86003	5117	257012	1972-06-13	1972-06-13 00:00:00	\N	\N	32020		\N	340019	0	40055000	257012		0
86408	5143	81151	1979-09-12	1979-09-12 00:00:00	1979-10-10	1979-10-10 00:00:00	32020		\N	341884	0	44465007	81151		0
86568	5151	4112343	1992-01-15	1992-01-15 00:00:00	1992-01-22	1992-01-22 00:00:00	32020		\N	342503	0	195662009	4112343		0
87640	5215	81151	1982-08-20	1982-08-20 00:00:00	1982-09-24	1982-09-24 00:00:00	32020		\N	346841	0	44465007	81151		0
87782	5223	81151	1996-06-21	1996-06-21 00:00:00	1996-07-26	1996-07-26 00:00:00	32020		\N	347545	0	44465007	81151		0
88455	5258	372328	1962-11-23	1962-11-23 00:00:00	1963-07-10	1963-07-10 00:00:00	32020		\N	349854	0	65363002	372328		0
88788	5279	40481087	1975-01-19	1975-01-19 00:00:00	1975-01-26	1975-01-26 00:00:00	32020		\N	351184	0	444814009	40481087		0
88939	5290	40481087	1992-11-14	1992-11-14 00:00:00	1992-11-21	1992-11-21 00:00:00	32020		\N	351937	0	444814009	40481087		0
89104	5300	40481087	1978-01-19	1978-01-19 00:00:00	1978-01-26	1978-01-26 00:00:00	32020		\N	352604	0	444814009	40481087		0
89419	5317	4294548	2010-12-17	2010-12-17 00:00:00	2011-02-18	2011-02-18 00:00:00	32020		\N	353618	0	75498004	4294548		0
80341	4759	28060	1986-06-30	1986-06-30 00:00:00	1986-07-10	1986-07-10 00:00:00	32020		\N	317040	0	43878008	28060		0
85655	5095	4266809	2002-09-17	2002-09-17 00:00:00	\N	\N	32020		\N	338544	0	397881000	4266809		0
85730	5099	4112343	1946-04-28	1946-04-28 00:00:00	1946-05-07	1946-05-07 00:00:00	32020		\N	338834	0	195662009	4112343		0
86004	5117	40481087	1964-07-14	1964-07-14 00:00:00	1964-07-21	1964-07-21 00:00:00	32020		\N	340032	0	444814009	40481087		0
86409	5143	40481087	1984-01-01	1984-01-01 00:00:00	1984-01-15	1984-01-15 00:00:00	32020		\N	341844	0	444814009	40481087		0
86569	5151	4112343	2014-02-25	2014-02-25 00:00:00	2014-03-07	2014-03-07 00:00:00	32020		\N	342505	0	195662009	4112343		0
87641	5215	260139	2000-01-08	2000-01-08 00:00:00	2000-01-22	2000-01-22 00:00:00	32020		\N	346824	0	10509002	260139		0
87783	5223	260139	1978-02-08	1978-02-08 00:00:00	1978-02-22	1978-02-22 00:00:00	32020		\N	347590	0	10509002	260139		0
88456	5258	4112343	2000-04-09	2000-04-09 00:00:00	2000-04-19	2000-04-19 00:00:00	32020		\N	349859	0	195662009	4112343		0
88789	5279	260139	1955-11-27	1955-11-27 00:00:00	1955-12-11	1955-12-11 00:00:00	32020		\N	351229	0	10509002	260139		0
88940	5290	4084167	1955-01-30	1955-01-30 00:00:00	1955-01-30	1955-01-30 00:00:00	32020		\N	352029	0	241929008	4084167		0
89105	5301	40481087	1998-08-23	1998-08-23 00:00:00	1998-08-30	1998-08-30 00:00:00	32020		\N	352707	0	444814009	40481087		0
89420	5317	4112343	2001-09-05	2001-09-05 00:00:00	2001-09-13	2001-09-13 00:00:00	32020		\N	353651	0	195662009	4112343		0
80342	4759	380378	2012-11-06	2012-11-06 00:00:00	\N	\N	32020		\N	317068	0	84757009	380378		0
85656	5095	80180	2002-09-17	2002-09-17 00:00:00	\N	\N	32020		\N	338544	0	396275006	80180		0
85738	5101	40481087	2008-11-11	2008-11-11 00:00:00	2008-11-18	2008-11-18 00:00:00	32020		\N	338971	0	444814009	40481087		0
86005	5117	81151	2017-12-09	2017-12-09 00:00:00	2017-12-30	2017-12-30 00:00:00	32020		\N	340155	0	44465007	81151		0
86410	5143	40481087	1996-11-13	1996-11-13 00:00:00	1996-11-27	1996-11-27 00:00:00	32020		\N	341816	0	444814009	40481087		0
86570	5151	40481087	2011-02-19	2011-02-19 00:00:00	2011-03-05	2011-03-05 00:00:00	32020		\N	342504	0	444814009	40481087		0
87642	5215	4059173	1970-02-05	1970-02-05 00:00:00	1970-04-06	1970-04-06 00:00:00	32020		\N	346838	0	16114001	4059173		0
87784	5223	372328	1970-12-30	1970-12-30 00:00:00	1971-05-01	1971-05-01 00:00:00	32020		\N	347595	0	65363002	372328		0
88457	5258	4112343	1984-03-04	1984-03-04 00:00:00	1984-03-11	1984-03-11 00:00:00	32020		\N	349849	0	195662009	4112343		0
88790	5279	4116491	1990-01-16	1990-01-16 00:00:00	1990-03-05	1990-03-05 00:00:00	32020		\N	351147	0	301011002	4116491		0
88941	5290	372328	1956-09-21	1956-09-21 00:00:00	1957-03-29	1957-03-29 00:00:00	32020		\N	352010	0	65363002	372328		0
89106	5301	192671	1953-03-01	1953-03-01 00:00:00	\N	\N	32020		\N	352697	0	K92.2	35208414		0
89421	5317	257012	2011-01-14	2011-01-14 00:00:00	\N	\N	32020		\N	353637	0	40055000	257012		0
80343	4759	28060	1998-06-12	1998-06-12 00:00:00	1998-06-23	1998-06-23 00:00:00	32020		\N	317075	0	43878008	28060		0
85739	5101	80180	1998-10-10	1998-10-10 00:00:00	\N	\N	32020		\N	339008	0	396275006	80180		0
86006	5118	260139	2013-08-18	2013-08-18 00:00:00	2013-09-01	2013-09-01 00:00:00	32020		\N	340237	0	10509002	260139		0
86411	5143	4218389	1992-04-04	1992-04-04 00:00:00	1992-04-25	1992-04-25 00:00:00	32020		\N	341885	0	39848009	4218389		0
86571	5151	260139	2015-11-26	2015-11-26 00:00:00	2015-12-03	2015-12-03 00:00:00	32020		\N	342513	0	10509002	260139		0
87644	5215	321042	1960-07-11	1960-07-11 00:00:00	\N	\N	32020		\N	346837	0	410429000	321042		0
87785	5223	4112343	2015-05-18	2015-05-18 00:00:00	2015-05-26	2015-05-26 00:00:00	32020		\N	347532	0	195662009	4112343		0
88458	5258	80180	1999-07-10	1999-07-10 00:00:00	\N	\N	32020		\N	349920	0	396275006	80180		0
88791	5279	40481087	1994-12-14	1994-12-14 00:00:00	1995-01-04	1995-01-04 00:00:00	32020		\N	351148	0	444814009	40481087		0
88942	5290	378001	1961-02-27	1961-02-27 00:00:00	1961-04-28	1961-04-28 00:00:00	32020		\N	352030	0	62106007	378001		0
89107	5301	4112343	1980-04-03	1980-04-03 00:00:00	1980-04-12	1980-04-12 00:00:00	32020		\N	352751	0	195662009	4112343		0
89422	5317	260139	1976-03-08	1976-03-08 00:00:00	1976-03-22	1976-03-22 00:00:00	32020		\N	353656	0	10509002	260139		0
80344	4759	4283893	1988-07-22	1988-07-22 00:00:00	1988-11-11	1988-11-11 00:00:00	32020		\N	317073	0	36971009	4283893		0
85740	5101	260139	1973-08-23	1973-08-23 00:00:00	1973-09-06	1973-09-06 00:00:00	32020		\N	338962	0	10509002	260139		0
86007	5118	4112343	1989-03-07	1989-03-07 00:00:00	1989-03-18	1989-03-18 00:00:00	32020		\N	340221	0	195662009	4112343		0
86412	5143	260139	1966-10-31	1966-10-31 00:00:00	1966-11-07	1966-11-07 00:00:00	32020		\N	341850	0	10509002	260139		0
86572	5151	4112343	1961-11-18	1961-11-18 00:00:00	1961-11-28	1961-11-28 00:00:00	32020		\N	342576	0	195662009	4112343		0
87645	5215	40481087	1992-06-03	1992-06-03 00:00:00	1992-06-10	1992-06-10 00:00:00	32020		\N	346868	0	444814009	40481087		0
87786	5223	260139	1974-05-11	1974-05-11 00:00:00	1974-05-25	1974-05-25 00:00:00	32020		\N	347589	0	10509002	260139		0
88459	5258	4112343	1966-09-18	1966-09-18 00:00:00	1966-10-01	1966-10-01 00:00:00	32020		\N	349870	0	195662009	4112343		0
88792	5279	375671	1958-06-23	1958-06-23 00:00:00	1958-07-23	1958-07-23 00:00:00	32020		\N	351132	0	62564004	375671		0
88943	5290	4112343	1994-11-03	1994-11-03 00:00:00	1994-11-15	1994-11-15 00:00:00	32020		\N	352008	0	195662009	4112343		0
89108	5301	40481087	1960-07-20	1960-07-20 00:00:00	1960-08-03	1960-08-03 00:00:00	32020		\N	352730	0	444814009	40481087		0
89423	5317	260139	1983-09-20	1983-09-20 00:00:00	1983-09-27	1983-09-27 00:00:00	32020		\N	353649	0	10509002	260139		0
85741	5101	4230399	2002-12-17	2002-12-17 00:00:00	2003-01-16	2003-01-16 00:00:00	32020		\N	338977	0	359817006	4230399		0
86008	5118	4294548	1979-10-23	1979-10-23 00:00:00	1979-12-04	1979-12-04 00:00:00	32020		\N	340163	0	75498004	4294548		0
86413	5143	260139	1982-03-01	1982-03-01 00:00:00	1982-03-15	1982-03-15 00:00:00	32020		\N	341795	0	10509002	260139		0
86573	5151	4112343	1980-04-05	1980-04-05 00:00:00	1980-04-14	1980-04-14 00:00:00	32020		\N	342578	0	195662009	4112343		0
87646	5215	260139	2008-07-29	2008-07-29 00:00:00	2008-08-05	2008-08-05 00:00:00	32020		\N	346890	0	10509002	260139		0
87787	5223	80180	2004-10-27	2004-10-27 00:00:00	\N	\N	32020		\N	347553	0	396275006	80180		0
88460	5258	260139	1997-11-02	1997-11-02 00:00:00	1997-11-16	1997-11-16 00:00:00	32020		\N	349891	0	10509002	260139		0
88793	5279	40481087	1980-05-05	1980-05-05 00:00:00	1980-05-26	1980-05-26 00:00:00	32020		\N	351172	0	444814009	40481087		0
88944	5290	80180	1995-05-15	1995-05-15 00:00:00	\N	\N	32020		\N	352008	0	396275006	80180		0
89109	5301	40481087	2000-11-24	2000-11-24 00:00:00	2000-12-08	2000-12-08 00:00:00	32020		\N	352733	0	444814009	40481087		0
89424	5317	28060	1984-01-29	1984-01-29 00:00:00	1984-02-06	1984-02-06 00:00:00	32020		\N	353617	0	43878008	28060		0
85742	5101	40481087	1976-12-23	1976-12-23 00:00:00	1977-01-06	1977-01-06 00:00:00	32020		\N	338963	0	444814009	40481087		0
86009	5118	4084167	1968-10-11	1968-10-11 00:00:00	1968-10-11	1968-10-11 00:00:00	32020		\N	340156	0	241929008	4084167		0
86414	5143	260139	1967-03-09	1967-03-09 00:00:00	1967-03-23	1967-03-23 00:00:00	32020		\N	341851	0	10509002	260139		0
86574	5151	260139	2007-03-21	2007-03-21 00:00:00	2007-04-04	2007-04-04 00:00:00	32020		\N	342580	0	10509002	260139		0
87647	5215	40481087	2006-08-08	2006-08-08 00:00:00	2006-08-22	2006-08-22 00:00:00	32020		\N	346880	0	444814009	40481087		0
87788	5223	260139	1970-10-20	1970-10-20 00:00:00	1970-10-27	1970-10-27 00:00:00	32020		\N	347548	0	10509002	260139		0
88461	5258	40481087	1988-09-23	1988-09-23 00:00:00	1988-09-30	1988-09-30 00:00:00	32020		\N	349851	0	444814009	40481087		0
88794	5279	260139	1974-04-14	1974-04-14 00:00:00	1974-04-28	1974-04-28 00:00:00	32020		\N	351203	0	10509002	260139		0
88945	5290	4134304	1954-11-01	1954-11-01 00:00:00	1954-12-01	1954-12-01 00:00:00	32020		\N	352028	0	263102004	4134304		0
89110	5301	313217	1999-01-07	1999-01-07 00:00:00	\N	\N	32020		\N	352693	0	49436004	313217		0
89425	5317	4112343	2008-09-20	2008-09-20 00:00:00	2008-09-27	2008-09-27 00:00:00	32020		\N	353676	0	195662009	4112343		0
85743	5101	4218389	1991-02-20	1991-02-20 00:00:00	1991-03-20	1991-03-20 00:00:00	32020		\N	338975	0	39848009	4218389		0
86010	5118	4237458	1977-12-23	1977-12-23 00:00:00	1978-02-21	1978-02-21 00:00:00	32020		\N	340157	0	58150001	4237458		0
86415	5143	440086	1972-12-06	1972-12-06 00:00:00	1974-01-30	1974-01-30 00:00:00	32020		\N	341862	0	192127007	440086		0
86575	5151	40481087	1970-12-12	1970-12-12 00:00:00	1971-01-02	1971-01-02 00:00:00	32020		\N	342537	0	444814009	40481087		0
87648	5215	4152936	1973-10-17	1973-10-17 00:00:00	1973-11-07	1973-11-07 00:00:00	32020		\N	346839	0	283385000	4152936		0
87789	5223	260139	2010-10-17	2010-10-17 00:00:00	2010-10-31	2010-10-31 00:00:00	32020		\N	347531	0	10509002	260139		0
88462	5258	4112343	2014-02-20	2014-02-20 00:00:00	2014-03-03	2014-03-03 00:00:00	32020		\N	349894	0	195662009	4112343		0
88795	5279	378001	1955-05-10	1955-05-10 00:00:00	1955-07-09	1955-07-09 00:00:00	32020		\N	351131	0	62106007	378001		0
88946	5290	4112343	2005-05-23	2005-05-23 00:00:00	2005-05-31	2005-05-31 00:00:00	32020		\N	351953	0	195662009	4112343		0
89111	5301	381316	2003-05-01	2003-05-01 00:00:00	\N	\N	32020		\N	352672	0	230690007	381316		0
89426	5317	28060	1983-12-22	1983-12-22 00:00:00	1983-12-29	1983-12-29 00:00:00	32020		\N	353650	0	43878008	28060		0
85744	5101	260139	1997-12-23	1997-12-23 00:00:00	1998-01-06	1998-01-06 00:00:00	32020		\N	338952	0	10509002	260139		0
86011	5118	4112343	1967-12-19	1967-12-19 00:00:00	1968-01-01	1968-01-01 00:00:00	32020		\N	340197	0	195662009	4112343		0
86416	5143	40481087	1971-12-09	1971-12-09 00:00:00	1971-12-16	1971-12-16 00:00:00	32020		\N	341840	0	444814009	40481087		0
86576	5151	260139	1983-10-14	1983-10-14 00:00:00	1983-10-21	1983-10-21 00:00:00	32020		\N	342509	0	10509002	260139		0
87790	5223	260139	1968-06-20	1968-06-20 00:00:00	1968-07-04	1968-07-04 00:00:00	32020		\N	347585	0	10509002	260139		0
88463	5258	40481087	1972-02-17	1972-02-17 00:00:00	1972-02-24	1972-02-24 00:00:00	32020		\N	349847	0	444814009	40481087		0
88796	5279	192671	1985-03-02	1985-03-02 00:00:00	\N	\N	32020		\N	351149	0	K92.2	35208414		0
88947	5290	4237458	1979-05-29	1979-05-29 00:00:00	1979-08-27	1979-08-27 00:00:00	32020		\N	352032	0	58150001	4237458		0
89112	5301	80180	1953-01-12	1953-01-12 00:00:00	\N	\N	32020		\N	352741	0	396275006	80180		0
89427	5317	260139	2006-03-01	2006-03-01 00:00:00	2006-03-08	2006-03-08 00:00:00	32020		\N	353653	0	10509002	260139		0
85745	5101	4218389	2016-03-29	2016-03-29 00:00:00	2016-05-03	2016-05-03 00:00:00	32020		\N	338979	0	39848009	4218389		0
86012	5118	40481087	1986-01-06	1986-01-06 00:00:00	1986-01-20	1986-01-20 00:00:00	32020		\N	340200	0	444814009	40481087		0
86417	5143	40481087	2008-08-20	2008-08-20 00:00:00	2008-09-03	2008-09-03 00:00:00	32020		\N	341858	0	444814009	40481087		0
86577	5151	40481087	1973-12-24	1973-12-24 00:00:00	1973-12-31	1973-12-31 00:00:00	32020		\N	342538	0	444814009	40481087		0
87791	5223	4294548	1991-08-29	1991-08-29 00:00:00	1992-05-07	1992-05-07 00:00:00	32020		\N	347591	0	75498004	4294548		0
88464	5258	81151	1965-03-25	1965-03-25 00:00:00	1965-04-29	1965-04-29 00:00:00	32020		\N	349868	0	44465007	81151		0
88797	5279	4113008	1965-05-17	1965-05-17 00:00:00	1965-05-31	1965-05-31 00:00:00	32020		\N	351134	0	284549007	4113008		0
88948	5290	40481087	1972-03-21	1972-03-21 00:00:00	1972-03-28	1972-03-28 00:00:00	32020		\N	351895	0	444814009	40481087		0
89113	5301	4134304	1925-11-30	1925-11-30 00:00:00	1925-12-30	1925-12-30 00:00:00	32020		\N	352658	0	263102004	4134304		0
89428	5317	260139	2012-08-31	2012-08-31 00:00:00	2012-09-14	2012-09-14 00:00:00	32020		\N	353654	0	10509002	260139		0
85746	5101	40481087	1979-11-29	1979-11-29 00:00:00	1979-12-06	1979-12-06 00:00:00	32020		\N	338970	0	444814009	40481087		0
86013	5118	4218389	1990-05-19	1990-05-19 00:00:00	1990-06-09	1990-06-09 00:00:00	32020		\N	340159	0	39848009	4218389		0
86418	5143	260139	1968-04-20	1968-04-20 00:00:00	1968-05-04	1968-05-04 00:00:00	32020		\N	341852	0	10509002	260139		0
86578	5151	4113008	2000-11-05	2000-11-05 00:00:00	2000-11-26	2000-11-26 00:00:00	32020		\N	342591	0	284549007	4113008		0
87792	5223	4112343	1968-04-22	1968-04-22 00:00:00	1968-04-29	1968-04-29 00:00:00	32020		\N	347573	0	195662009	4112343		0
88465	5258	40481087	1973-06-23	1973-06-23 00:00:00	1973-07-07	1973-07-07 00:00:00	32020		\N	349848	0	444814009	40481087		0
88798	5279	40481087	2002-03-05	2002-03-05 00:00:00	2002-03-26	2002-03-26 00:00:00	32020		\N	351219	0	444814009	40481087		0
88949	5290	4296205	1971-09-03	1971-09-03 00:00:00	1971-10-08	1971-10-08 00:00:00	32020		\N	352031	0	403191005	4296205		0
89114	5301	260139	1929-09-11	1929-09-11 00:00:00	1929-09-18	1929-09-18 00:00:00	32020		\N	352659	0	10509002	260139		0
89469	5322	40481087	1993-01-27	1993-01-27 00:00:00	1993-02-10	1993-02-10 00:00:00	32020		\N	354080	0	444814009	40481087		0
85747	5101	4116491	1995-12-20	1995-12-20 00:00:00	1996-01-25	1996-01-25 00:00:00	32020		\N	338993	0	301011002	4116491		0
86014	5118	372328	1982-08-18	1982-08-18 00:00:00	1982-12-22	1982-12-22 00:00:00	32020		\N	340283	0	65363002	372328		0
86419	5143	260139	1986-06-25	1986-06-25 00:00:00	1986-07-09	1986-07-09 00:00:00	32020		\N	341814	0	10509002	260139		0
86579	5151	317576	2017-01-27	2017-01-27 00:00:00	\N	\N	32020		\N	342520	0	53741008	317576		0
87793	5223	40481087	1991-02-08	1991-02-08 00:00:00	1991-02-22	1991-02-22 00:00:00	32020		\N	347551	0	444814009	40481087		0
88466	5258	40481087	2007-04-14	2007-04-14 00:00:00	2007-04-21	2007-04-21 00:00:00	32020		\N	349860	0	444814009	40481087		0
88799	5279	378001	2012-05-15	2012-05-15 00:00:00	2012-06-14	2012-06-14 00:00:00	32020		\N	351138	0	62106007	378001		0
88950	5290	378001	1989-02-05	1989-02-05 00:00:00	1989-04-06	1989-04-06 00:00:00	32020		\N	352033	0	62106007	378001		0
89115	5301	40481087	1921-02-01	1921-02-01 00:00:00	1921-02-08	1921-02-08 00:00:00	32020		\N	352723	0	444814009	40481087		0
89470	5322	4112343	1973-04-22	1973-04-22 00:00:00	1973-04-29	1973-04-29 00:00:00	32020		\N	354180	0	195662009	4112343		0
85748	5101	40481087	2016-05-16	2016-05-16 00:00:00	2016-06-06	2016-06-06 00:00:00	32020		\N	338972	0	444814009	40481087		0
86015	5118	40481087	2018-12-02	2018-12-02 00:00:00	2018-12-23	2018-12-23 00:00:00	32020		\N	340177	0	444814009	40481087		0
86420	5143	4112343	1995-09-28	1995-09-28 00:00:00	1995-10-07	1995-10-07 00:00:00	32020		\N	341845	0	195662009	4112343		0
86580	5151	372328	1959-01-05	1959-01-05 00:00:00	1959-04-10	1959-04-10 00:00:00	32020		\N	342581	0	65363002	372328		0
87794	5223	40481087	1993-05-09	1993-05-09 00:00:00	1993-05-16	1993-05-16 00:00:00	32020		\N	347598	0	444814009	40481087		0
88467	5258	4294548	1967-01-23	1967-01-23 00:00:00	1967-09-04	1967-09-04 00:00:00	32020		\N	349845	0	75498004	4294548		0
88800	5279	260139	1965-11-19	1965-11-19 00:00:00	1965-11-26	1965-11-26 00:00:00	32020		\N	351183	0	10509002	260139		0
88951	5290	40481087	2000-05-19	2000-05-19 00:00:00	2000-06-09	2000-06-09 00:00:00	32020		\N	352009	0	444814009	40481087		0
89116	5301	40481087	1946-04-19	1946-04-19 00:00:00	1946-05-03	1946-05-03 00:00:00	32020		\N	352705	0	444814009	40481087		0
89471	5322	372328	1947-06-21	1947-06-21 00:00:00	1947-10-01	1947-10-01 00:00:00	32020		\N	354134	0	65363002	372328		0
85749	5101	4112343	1989-02-21	1989-02-21 00:00:00	1989-03-02	1989-03-02 00:00:00	32020		\N	338950	0	195662009	4112343		0
86016	5118	40481087	1989-11-06	1989-11-06 00:00:00	1989-11-13	1989-11-13 00:00:00	32020		\N	340190	0	444814009	40481087		0
86421	5143	40481087	1990-03-05	1990-03-05 00:00:00	1990-03-26	1990-03-26 00:00:00	32020		\N	341815	0	444814009	40481087		0
86581	5151	40481087	1967-03-18	1967-03-18 00:00:00	1967-03-25	1967-03-25 00:00:00	32020		\N	342501	0	444814009	40481087		0
87795	5223	28060	1972-06-08	1972-06-08 00:00:00	1972-06-17	1972-06-17 00:00:00	32020		\N	347586	0	43878008	28060		0
88468	5258	372328	1960-03-02	1960-03-02 00:00:00	1960-07-06	1960-07-06 00:00:00	32020		\N	349923	0	65363002	372328		0
88801	5279	4278672	1963-04-28	1963-04-28 00:00:00	1963-06-27	1963-06-27 00:00:00	32020		\N	351133	0	65966004	4278672		0
88952	5290	317576	2017-08-11	2017-08-11 00:00:00	\N	\N	32020		\N	351955	0	53741008	317576		0
89117	5301	372328	1923-05-30	1923-05-30 00:00:00	1923-07-05	1923-07-05 00:00:00	32020		\N	352745	0	65363002	372328		0
89472	5322	260139	1964-02-24	1964-02-24 00:00:00	1964-03-09	1964-03-09 00:00:00	32020		\N	354270	0	10509002	260139		0
85750	5101	378001	1994-04-03	1994-04-03 00:00:00	1994-05-03	1994-05-03 00:00:00	32020		\N	338976	0	62106007	378001		0
86017	5118	375671	1991-05-05	1991-05-05 00:00:00	1991-07-04	1991-07-04 00:00:00	32020		\N	340160	0	62564004	375671		0
86422	5143	78272	1976-10-06	1976-10-06 00:00:00	1976-10-27	1976-10-27 00:00:00	32020		\N	341883	0	70704007	78272		0
86582	5151	28060	1958-11-23	1958-11-23 00:00:00	1958-12-02	1958-12-02 00:00:00	32020		\N	342499	0	43878008	28060		0
87796	5223	4112343	1973-08-15	1973-08-15 00:00:00	1973-08-26	1973-08-26 00:00:00	32020		\N	347597	0	195662009	4112343		0
88469	5258	4112343	2009-09-01	2009-09-01 00:00:00	2009-09-13	2009-09-13 00:00:00	32020		\N	349893	0	195662009	4112343		0
88802	5279	4266809	1985-01-02	1985-01-02 00:00:00	\N	\N	32020		\N	351166	0	397881000	4266809		0
88953	5290	260139	1957-06-19	1957-06-19 00:00:00	1957-06-26	1957-06-26 00:00:00	32020		\N	351911	0	10509002	260139		0
89118	5301	260139	1974-06-14	1974-06-14 00:00:00	1974-06-21	1974-06-21 00:00:00	32020		\N	352731	0	10509002	260139		0
89473	5322	28060	2009-07-14	2009-07-14 00:00:00	2009-07-24	2009-07-24 00:00:00	32020		\N	354130	0	43878008	28060		0
85751	5101	372328	1962-02-01	1962-02-01 00:00:00	1962-12-15	1962-12-15 00:00:00	32020		\N	338953	0	65363002	372328		0
86018	5118	372328	1969-09-06	1969-09-06 00:00:00	1969-12-24	1969-12-24 00:00:00	32020		\N	340282	0	65363002	372328		0
86423	5143	40481087	1997-06-04	1997-06-04 00:00:00	1997-06-18	1997-06-18 00:00:00	32020		\N	341817	0	444814009	40481087		0
86583	5151	40481087	1986-02-01	1986-02-01 00:00:00	1986-02-08	1986-02-08 00:00:00	32020		\N	342502	0	444814009	40481087		0
87797	5223	372328	1971-10-28	1971-10-28 00:00:00	1972-11-04	1972-11-04 00:00:00	32020		\N	347596	0	65363002	372328		0
88470	5258	4112343	1993-03-26	1993-03-26 00:00:00	1993-04-02	1993-04-02 00:00:00	32020		\N	349858	0	195662009	4112343		0
88803	5279	80180	1985-01-02	1985-01-02 00:00:00	\N	\N	32020		\N	351166	0	396275006	80180		0
88954	5291	260139	1996-08-01	1996-08-01 00:00:00	1996-08-15	1996-08-15 00:00:00	32020		\N	352066	0	10509002	260139		0
89119	5301	4112343	1981-07-07	1981-07-07 00:00:00	1981-07-19	1981-07-19 00:00:00	32020		\N	352732	0	195662009	4112343		0
89474	5322	372328	1949-08-28	1949-08-28 00:00:00	1950-01-18	1950-01-18 00:00:00	32020		\N	354204	0	65363002	372328		0
85752	5101	4113008	2004-09-07	2004-09-07 00:00:00	2004-09-28	2004-09-28 00:00:00	32020		\N	338978	0	284549007	4113008		0
86019	5118	28060	1968-11-27	1968-11-27 00:00:00	1968-12-08	1968-12-08 00:00:00	32020		\N	340210	0	43878008	28060		0
86424	5144	40481087	1970-02-13	1970-02-13 00:00:00	1970-03-06	1970-03-06 00:00:00	32020		\N	341896	0	444814009	40481087		0
86584	5151	40481087	1963-12-02	1963-12-02 00:00:00	1963-12-09	1963-12-09 00:00:00	32020		\N	342500	0	444814009	40481087		0
87798	5223	81151	2019-01-11	2019-01-11 00:00:00	2019-02-01	2019-02-01 00:00:00	32020		\N	347547	0	44465007	81151		0
88471	5258	257012	1967-02-20	1967-02-20 00:00:00	\N	\N	32020		\N	349856	0	40055000	257012		0
88804	5279	4285898	1984-10-04	1984-10-04 00:00:00	\N	\N	32020		\N	351166	0	68496003	4285898		0
88955	5291	260139	2007-09-05	2007-09-05 00:00:00	2007-09-12	2007-09-12 00:00:00	32020		\N	352067	0	10509002	260139		0
89120	5301	28060	1986-03-28	1986-03-28 00:00:00	1986-04-04	1986-04-04 00:00:00	32020		\N	352752	0	43878008	28060		0
85753	5101	81151	1962-07-01	1962-07-01 00:00:00	1962-07-22	1962-07-22 00:00:00	32020		\N	338974	0	44465007	81151		0
86020	5118	40481087	1987-05-06	1987-05-06 00:00:00	1987-05-20	1987-05-20 00:00:00	32020		\N	340219	0	444814009	40481087		0
86425	5144	40481087	1983-03-07	1983-03-07 00:00:00	1983-03-14	1983-03-14 00:00:00	32020		\N	341967	0	444814009	40481087		0
86585	5151	28060	1995-03-11	1995-03-11 00:00:00	1995-03-21	1995-03-21 00:00:00	32020		\N	342549	0	43878008	28060		0
87799	5223	260139	1997-08-01	1997-08-01 00:00:00	1997-08-08	1997-08-08 00:00:00	32020		\N	347588	0	10509002	260139		0
88472	5258	40481087	2003-04-20	2003-04-20 00:00:00	2003-04-27	2003-04-27 00:00:00	32020		\N	349892	0	444814009	40481087		0
88805	5279	40481087	2005-07-13	2005-07-13 00:00:00	2005-07-27	2005-07-27 00:00:00	32020		\N	351205	0	444814009	40481087		0
88956	5291	40481087	1990-07-27	1990-07-27 00:00:00	1990-08-17	1990-08-17 00:00:00	32020		\N	352045	0	444814009	40481087		0
89121	5301	4056621	1940-10-13	1940-10-13 00:00:00	\N	\N	32020		\N	352727	0	197927001	4056621		0
85754	5101	4112343	1986-07-26	1986-07-26 00:00:00	1986-08-03	1986-08-03 00:00:00	32020		\N	338964	0	195662009	4112343		0
86021	5118	4112343	1987-09-01	1987-09-01 00:00:00	1987-09-12	1987-09-12 00:00:00	32020		\N	340164	0	195662009	4112343		0
86426	5144	80180	1971-09-03	1971-09-03 00:00:00	\N	\N	32020		\N	341919	0	396275006	80180		0
86586	5151	4132546	1991-01-27	1991-01-27 00:00:00	\N	\N	32020		\N	342590	0	275272006	4166590		0
87800	5223	257012	1991-11-14	1991-11-14 00:00:00	\N	\N	32020		\N	347592	0	40055000	257012		0
88473	5259	40479422	2008-04-19	2008-04-19 00:00:00	2008-05-26	2008-05-26 00:00:00	32020		\N	350005	0	444448004	40479422		0
88806	5279	81151	1969-02-09	1969-02-09 00:00:00	1969-03-02	1969-03-02 00:00:00	32020		\N	351135	0	44465007	81151		0
88957	5291	372328	1976-07-15	1976-07-15 00:00:00	1976-09-26	1976-09-26 00:00:00	32020		\N	352077	0	65363002	372328		0
89122	5301	4116491	1940-10-13	1940-10-13 00:00:00	1940-12-01	1940-12-01 00:00:00	32020		\N	352727	0	301011002	4116491		0
85755	5101	260139	1971-04-16	1971-04-16 00:00:00	1971-04-30	1971-04-30 00:00:00	32020		\N	338992	0	10509002	260139		0
86022	5118	40481087	1998-09-02	1998-09-02 00:00:00	1998-09-09	1998-09-09 00:00:00	32020		\N	340233	0	444814009	40481087		0
86427	5144	4112343	1955-11-17	1955-11-17 00:00:00	1955-11-29	1955-11-29 00:00:00	32020		\N	341927	0	195662009	4112343		0
86587	5151	4001336	1991-01-27	1991-01-27 00:00:00	1991-02-26	1991-02-26 00:00:00	32020		\N	342590	0	110030002	4001336		0
87801	5223	4109685	2005-10-07	2005-10-07 00:00:00	2005-10-21	2005-10-21 00:00:00	32020		\N	347546	0	284551006	4109685		0
88474	5259	4112343	1989-09-14	1989-09-14 00:00:00	1989-09-26	1989-09-26 00:00:00	32020		\N	349967	0	195662009	4112343		0
88807	5279	4112343	2016-10-22	2016-10-22 00:00:00	2016-11-04	2016-11-04 00:00:00	32020		\N	351206	0	195662009	4112343		0
88958	5291	260139	2002-01-02	2002-01-02 00:00:00	2002-01-16	2002-01-16 00:00:00	32020		\N	352055	0	10509002	260139		0
89123	5301	260139	1949-04-30	1949-04-30 00:00:00	1949-05-07	1949-05-07 00:00:00	32020		\N	352729	0	10509002	260139		0
85756	5101	260139	1994-04-26	1994-04-26 00:00:00	1994-05-03	1994-05-03 00:00:00	32020		\N	338965	0	10509002	260139		0
86023	5118	40481087	1978-04-01	1978-04-01 00:00:00	1978-04-22	1978-04-22 00:00:00	32020		\N	340199	0	444814009	40481087		0
86428	5144	4218389	1951-08-09	1951-08-09 00:00:00	1951-08-30	1951-08-30 00:00:00	32020		\N	341887	0	39848009	4218389		0
86588	5151	81151	1989-03-17	1989-03-17 00:00:00	1989-04-07	1989-04-07 00:00:00	32020		\N	342589	0	44465007	81151		0
87802	5223	40481087	2005-08-19	2005-08-19 00:00:00	2005-09-09	2005-09-09 00:00:00	32020		\N	347576	0	444814009	40481087		0
88475	5259	40481087	2012-02-01	2012-02-01 00:00:00	2012-02-22	2012-02-22 00:00:00	32020		\N	350000	0	444814009	40481087		0
88808	5279	4112343	1957-05-17	1957-05-17 00:00:00	1957-05-28	1957-05-28 00:00:00	32020		\N	351230	0	195662009	4112343		0
88959	5291	372328	1981-03-06	1981-03-06 00:00:00	1981-11-15	1981-11-15 00:00:00	32020		\N	352056	0	65363002	372328		0
89124	5301	4116491	1940-07-24	1940-07-24 00:00:00	1940-09-15	1940-09-15 00:00:00	32020		\N	352704	0	301011002	4116491		0
85757	5101	4112343	1999-12-09	1999-12-09 00:00:00	1999-12-22	1999-12-22 00:00:00	32020		\N	338966	0	195662009	4112343		0
86024	5118	4218389	1993-05-24	1993-05-24 00:00:00	1993-06-28	1993-06-28 00:00:00	32020		\N	340161	0	39848009	4218389		0
86429	5144	260139	1951-04-19	1951-04-19 00:00:00	1951-05-03	1951-05-03 00:00:00	32020		\N	341963	0	10509002	260139		0
86589	5151	4296204	2005-10-31	2005-10-31 00:00:00	2005-11-14	2005-11-14 00:00:00	32020		\N	342592	0	403190006	4296204		0
87803	5223	40481087	2008-10-29	2008-10-29 00:00:00	2008-11-12	2008-11-12 00:00:00	32020		\N	347599	0	444814009	40481087		0
88476	5259	4278672	1973-09-29	1973-09-29 00:00:00	1973-11-28	1973-11-28 00:00:00	32020		\N	350003	0	65966004	4278672		0
88809	5279	260139	1988-05-15	1988-05-15 00:00:00	1988-05-22	1988-05-22 00:00:00	32020		\N	351186	0	10509002	260139		0
88960	5291	80180	2014-08-25	2014-08-25 00:00:00	\N	\N	32020		\N	352095	0	396275006	80180		0
89125	5301	40481087	1937-02-21	1937-02-21 00:00:00	1937-02-28	1937-02-28 00:00:00	32020		\N	352725	0	444814009	40481087		0
85761	5103	260139	1967-12-29	1967-12-29 00:00:00	1968-01-05	1968-01-05 00:00:00	32020		\N	339065	0	10509002	260139		0
86025	5118	4134304	1980-10-08	1980-10-08 00:00:00	1980-12-07	1980-12-07 00:00:00	32020		\N	340158	0	263102004	4134304		0
86430	5144	40481087	1941-10-27	1941-10-27 00:00:00	1941-11-03	1941-11-03 00:00:00	32020		\N	341892	0	444814009	40481087		0
86590	5151	80180	1997-12-12	1997-12-12 00:00:00	\N	\N	32020		\N	342517	0	396275006	80180		0
87804	5223	40481087	1977-08-05	1977-08-05 00:00:00	1977-08-12	1977-08-12 00:00:00	32020		\N	347549	0	444814009	40481087		0
88477	5259	257012	1977-05-10	1977-05-10 00:00:00	\N	\N	32020		\N	349997	0	40055000	257012		0
88810	5279	4283893	2005-01-15	2005-01-15 00:00:00	2005-02-05	2005-02-05 00:00:00	32020		\N	351174	0	36971009	4283893		0
88961	5291	372328	1976-12-25	1976-12-25 00:00:00	1977-03-27	1977-03-27 00:00:00	32020		\N	352069	0	65363002	372328		0
89126	5301	372328	1923-09-03	1923-09-03 00:00:00	1924-01-03	1924-01-03 00:00:00	32020		\N	352746	0	65363002	372328		0
85762	5103	40481087	1948-04-10	1948-04-10 00:00:00	1948-04-24	1948-04-24 00:00:00	32020		\N	339092	0	444814009	40481087		0
86026	5118	257012	1979-11-27	1979-11-27 00:00:00	\N	\N	32020		\N	340187	0	40055000	257012		0
86431	5144	4112343	2019-03-14	2019-03-14 00:00:00	2019-03-27	2019-03-27 00:00:00	32020		\N	341930	0	195662009	4112343		0
86591	5151	78272	1957-11-27	1957-11-27 00:00:00	1957-12-11	1957-12-11 00:00:00	32020		\N	342585	0	70704007	78272		0
87805	5223	4112343	1990-05-01	1990-05-01 00:00:00	1990-05-14	1990-05-14 00:00:00	32020		\N	347550	0	195662009	4112343		0
88478	5259	40481087	1977-03-04	1977-03-04 00:00:00	1977-03-11	1977-03-11 00:00:00	32020		\N	349995	0	444814009	40481087		0
88962	5291	260139	1979-10-29	1979-10-29 00:00:00	1979-11-12	1979-11-12 00:00:00	32020		\N	352065	0	10509002	260139		0
89127	5301	4296204	1959-01-04	1959-01-04 00:00:00	1959-02-08	1959-02-08 00:00:00	32020		\N	352696	0	403190006	4296204		0
85763	5103	81151	2014-12-05	2014-12-05 00:00:00	2015-01-02	2015-01-02 00:00:00	32020		\N	339091	0	44465007	81151		0
86027	5118	40481087	1987-02-22	1987-02-22 00:00:00	1987-03-01	1987-03-01 00:00:00	32020		\N	340189	0	444814009	40481087		0
86432	5144	260139	2017-06-03	2017-06-03 00:00:00	2017-06-17	2017-06-17 00:00:00	32020		\N	341895	0	10509002	260139		0
86592	5151	134438	1988-11-01	1988-11-01 00:00:00	1991-08-18	1991-08-18 00:00:00	32020		\N	342510	0	40275004	134438		0
87806	5223	372328	1970-09-06	1970-09-06 00:00:00	1970-10-31	1970-10-31 00:00:00	32020		\N	347594	0	65363002	372328		0
88963	5291	4001336	2010-11-28	2010-11-28 00:00:00	2011-01-27	2011-01-27 00:00:00	32020		\N	352037	0	110030002	4001336		0
89128	5301	81151	1936-03-07	1936-03-07 00:00:00	1936-04-04	1936-04-04 00:00:00	32020		\N	352695	0	44465007	81151		0
85764	5103	81151	1957-12-15	1957-12-15 00:00:00	1958-01-12	1958-01-12 00:00:00	32020		\N	339104	0	44465007	81151		0
86028	5118	378001	2000-11-18	2000-11-18 00:00:00	2001-01-17	2001-01-17 00:00:00	32020		\N	340162	0	62106007	378001		0
86433	5144	4112343	1970-04-30	1970-04-30 00:00:00	1970-05-07	1970-05-07 00:00:00	32020		\N	341945	0	195662009	4112343		0
86593	5151	372328	1957-12-27	1957-12-27 00:00:00	1958-01-10	1958-01-10 00:00:00	32020		\N	342562	0	65363002	372328		0
87807	5223	4112343	2014-11-06	2014-11-06 00:00:00	2014-11-16	2014-11-16 00:00:00	32020		\N	347593	0	195662009	4112343		0
88964	5291	40481087	1987-05-28	1987-05-28 00:00:00	1987-06-04	1987-06-04 00:00:00	32020		\N	352048	0	444814009	40481087		0
89129	5301	4112343	1998-11-01	1998-11-01 00:00:00	1998-11-09	1998-11-09 00:00:00	32020		\N	352753	0	195662009	4112343		0
85765	5103	260139	1992-07-21	1992-07-21 00:00:00	1992-08-04	1992-08-04 00:00:00	32020		\N	339099	0	10509002	260139		0
86029	5118	40481087	1987-11-24	1987-11-24 00:00:00	1987-12-08	1987-12-08 00:00:00	32020		\N	340220	0	444814009	40481087		0
86434	5144	4152936	1968-07-01	1968-07-01 00:00:00	1968-07-22	1968-07-22 00:00:00	32020		\N	341888	0	283385000	4152936		0
86594	5151	440086	1965-10-31	1965-10-31 00:00:00	1974-11-08	1974-11-08 00:00:00	32020		\N	342577	0	192127007	440086		0
87808	5223	40481087	2014-12-16	2014-12-16 00:00:00	2014-12-30	2014-12-30 00:00:00	32020		\N	347577	0	444814009	40481087		0
88965	5291	40481087	1997-09-17	1997-09-17 00:00:00	1997-09-24	1997-09-24 00:00:00	32020		\N	352046	0	444814009	40481087		0
89130	5301	40481087	1954-01-27	1954-01-27 00:00:00	1954-02-17	1954-02-17 00:00:00	32020		\N	352660	0	444814009	40481087		0
85766	5103	317576	2014-02-03	2014-02-03 00:00:00	\N	\N	32020		\N	339080	0	53741008	317576		0
86030	5118	80180	2008-02-24	2008-02-24 00:00:00	\N	\N	32020		\N	340270	0	396275006	80180		0
86435	5144	372328	1938-04-19	1938-04-19 00:00:00	1938-07-02	1938-07-02 00:00:00	32020		\N	341946	0	65363002	372328		0
86595	5151	4156265	1987-04-13	1987-04-13 00:00:00	1987-04-27	1987-04-27 00:00:00	32020		\N	342588	0	370247008	4156265		0
88966	5291	28060	2000-09-09	2000-09-09 00:00:00	2000-09-22	2000-09-22 00:00:00	32020		\N	352075	0	43878008	28060		0
89131	5301	4112343	1955-11-27	1955-11-27 00:00:00	1955-12-09	1955-12-09 00:00:00	32020		\N	352750	0	195662009	4112343		0
85767	5103	260139	1944-02-09	1944-02-09 00:00:00	1944-02-23	1944-02-23 00:00:00	32020		\N	339059	0	10509002	260139		0
86031	5119	80180	2001-08-16	2001-08-16 00:00:00	\N	\N	32020		\N	340396	0	396275006	80180		0
86436	5144	40481087	1939-12-18	1939-12-18 00:00:00	1940-01-01	1940-01-01 00:00:00	32020		\N	341925	0	444814009	40481087		0
86596	5151	40481087	2002-09-08	2002-09-08 00:00:00	2002-09-29	2002-09-29 00:00:00	32020		\N	342550	0	444814009	40481087		0
88967	5291	40481087	2007-04-12	2007-04-12 00:00:00	2007-04-19	2007-04-19 00:00:00	32020		\N	352076	0	444814009	40481087		0
89132	5301	372328	1921-10-22	1921-10-22 00:00:00	1922-01-05	1922-01-05 00:00:00	32020		\N	352734	0	65363002	372328		0
85768	5103	4113008	1946-07-25	1946-07-25 00:00:00	1946-08-15	1946-08-15 00:00:00	32020		\N	339102	0	284549007	4113008		0
86032	5119	4059173	1998-08-11	1998-08-11 00:00:00	1998-10-10	1998-10-10 00:00:00	32020		\N	340421	0	16114001	4059173		0
86437	5144	40481087	1973-10-25	1973-10-25 00:00:00	1973-11-01	1973-11-01 00:00:00	32020		\N	341893	0	444814009	40481087		0
86597	5151	378001	1964-09-05	1964-09-05 00:00:00	1964-11-04	1964-11-04 00:00:00	32020		\N	342586	0	62106007	378001		0
88968	5291	260139	1992-09-09	1992-09-09 00:00:00	1992-09-16	1992-09-16 00:00:00	32020		\N	352049	0	10509002	260139		0
89133	5301	378001	1929-08-11	1929-08-11 00:00:00	1929-09-10	1929-09-10 00:00:00	32020		\N	352694	0	62106007	378001		0
85769	5103	4027663	1974-10-03	1974-10-03 00:00:00	\N	\N	32020		\N	339086	0	13200003	4027663		0
86033	5119	40481087	1998-10-08	1998-10-08 00:00:00	1998-10-15	1998-10-15 00:00:00	32020		\N	340365	0	444814009	40481087		0
86438	5144	40481087	2018-03-16	2018-03-16 00:00:00	2018-04-06	2018-04-06 00:00:00	32020		\N	341929	0	444814009	40481087		0
86598	5151	4112343	2001-05-22	2001-05-22 00:00:00	2001-06-01	2001-06-01 00:00:00	32020		\N	342512	0	195662009	4112343		0
88969	5291	378001	2001-08-03	2001-08-03 00:00:00	2001-09-02	2001-09-02 00:00:00	32020		\N	352035	0	62106007	378001		0
89134	5302	4112343	1997-02-17	1997-02-17 00:00:00	1997-02-28	1997-02-28 00:00:00	32020		\N	352812	0	195662009	4112343		0
85770	5103	40481087	1997-02-07	1997-02-07 00:00:00	1997-02-14	1997-02-14 00:00:00	32020		\N	339119	0	444814009	40481087		0
86034	5119	81151	1978-05-14	1978-05-14 00:00:00	1978-05-28	1978-05-28 00:00:00	32020		\N	340420	0	44465007	81151		0
86439	5144	4112343	2013-04-03	2013-04-03 00:00:00	2013-04-13	2013-04-13 00:00:00	32020		\N	341900	0	195662009	4112343		0
86599	5151	28060	1964-12-13	1964-12-13 00:00:00	1964-12-21	1964-12-21 00:00:00	32020		\N	342508	0	43878008	28060		0
88970	5291	4113008	2008-03-29	2008-03-29 00:00:00	2008-04-12	2008-04-12 00:00:00	32020		\N	352036	0	284549007	4113008		0
89135	5302	40481087	2017-03-06	2017-03-06 00:00:00	2017-03-13	2017-03-13 00:00:00	32020		\N	352771	0	444814009	40481087		0
85771	5103	40481087	1980-11-05	1980-11-05 00:00:00	1980-11-26	1980-11-26 00:00:00	32020		\N	339066	0	444814009	40481087		0
86035	5119	260139	1985-04-02	1985-04-02 00:00:00	1985-04-16	1985-04-16 00:00:00	32020		\N	340351	0	10509002	260139		0
86440	5144	4156265	2009-11-14	2009-11-14 00:00:00	2009-12-05	2009-12-05 00:00:00	32020		\N	341889	0	370247008	4156265		0
86600	5151	40481087	1966-02-02	1966-02-02 00:00:00	1966-02-16	1966-02-16 00:00:00	32020		\N	342536	0	444814009	40481087		0
89136	5302	260139	1980-04-19	1980-04-19 00:00:00	1980-04-26	1980-04-26 00:00:00	32020		\N	352770	0	10509002	260139		0
85772	5103	40481087	2006-10-31	2006-10-31 00:00:00	2006-11-14	2006-11-14 00:00:00	32020		\N	339120	0	444814009	40481087		0
86036	5119	372328	1968-02-06	1968-02-06 00:00:00	1968-04-23	1968-04-23 00:00:00	32020		\N	340367	0	65363002	372328		0
86441	5144	260139	1962-06-21	1962-06-21 00:00:00	1962-06-28	1962-06-28 00:00:00	32020		\N	341965	0	10509002	260139		0
86601	5151	40481087	2000-05-01	2000-05-01 00:00:00	2000-05-15	2000-05-15 00:00:00	32020		\N	342511	0	444814009	40481087		0
89137	5302	40481087	2003-06-16	2003-06-16 00:00:00	2003-06-30	2003-06-30 00:00:00	32020		\N	352813	0	444814009	40481087		0
85773	5103	4109685	1962-02-20	1962-02-20 00:00:00	1962-03-13	1962-03-13 00:00:00	32020		\N	339105	0	284551006	4109685		0
86037	5119	40481087	2000-03-17	2000-03-17 00:00:00	2000-03-31	2000-03-31 00:00:00	32020		\N	340314	0	444814009	40481087		0
86442	5144	260139	1961-06-17	1961-06-17 00:00:00	1961-06-24	1961-06-24 00:00:00	32020		\N	341944	0	10509002	260139		0
86602	5151	40481087	1961-03-20	1961-03-20 00:00:00	1961-04-10	1961-04-10 00:00:00	32020		\N	342535	0	444814009	40481087		0
89138	5302	4112343	1976-02-10	1976-02-10 00:00:00	1976-02-22	1976-02-22 00:00:00	32020		\N	352769	0	195662009	4112343		0
85774	5103	40481087	2019-03-31	2019-03-31 00:00:00	2019-04-14	2019-04-14 00:00:00	32020		\N	339122	0	444814009	40481087		0
86038	5119	4280726	1966-05-14	1966-05-14 00:00:00	1981-05-12	1981-05-12 00:00:00	32020		\N	340372	0	367498001	4280726		0
86443	5144	378419	2014-09-27	2014-09-27 00:00:00	\N	\N	32020		\N	341914	0	26929004	378419		0
86603	5151	81151	1969-09-09	1969-09-09 00:00:00	1969-10-14	1969-10-14 00:00:00	32020		\N	342587	0	44465007	81151		0
89139	5302	40481087	2007-01-12	2007-01-12 00:00:00	2007-01-19	2007-01-19 00:00:00	32020		\N	352782	0	444814009	40481087		0
85775	5103	40481087	1963-02-10	1963-02-10 00:00:00	1963-03-03	1963-03-03 00:00:00	32020		\N	339064	0	444814009	40481087		0
86039	5119	40481087	1965-09-12	1965-09-12 00:00:00	1965-09-26	1965-09-26 00:00:00	32020		\N	340371	0	444814009	40481087		0
86444	5144	40481087	1979-05-06	1979-05-06 00:00:00	1979-05-20	1979-05-20 00:00:00	32020		\N	341966	0	444814009	40481087		0
86604	5151	40481087	2015-01-20	2015-01-20 00:00:00	2015-01-27	2015-01-27 00:00:00	32020		\N	342552	0	444814009	40481087		0
89140	5302	4112343	2004-11-19	2004-11-19 00:00:00	2004-11-26	2004-11-26 00:00:00	32020		\N	352781	0	195662009	4112343		0
85776	5103	40481087	2012-06-21	2012-06-21 00:00:00	2012-06-28	2012-06-28 00:00:00	32020		\N	339121	0	444814009	40481087		0
86040	5119	4112343	1964-11-26	1964-11-26 00:00:00	1964-12-05	1964-12-05 00:00:00	32020		\N	340292	0	195662009	4112343		0
86445	5144	260139	1982-04-15	1982-04-15 00:00:00	1982-04-22	1982-04-22 00:00:00	32020		\N	341898	0	10509002	260139		0
86605	5152	28060	1973-01-22	1973-01-22 00:00:00	1973-01-31	1973-01-31 00:00:00	32020		\N	342601	0	43878008	28060		0
89141	5302	260139	1996-01-03	1996-01-03 00:00:00	1996-01-17	1996-01-17 00:00:00	32020		\N	352789	0	10509002	260139		0
85777	5103	440086	1957-10-07	1957-10-07 00:00:00	1958-02-03	1958-02-03 00:00:00	32020		\N	339093	0	192127007	440086		0
86041	5119	4112343	2010-12-08	2010-12-08 00:00:00	2010-12-19	2010-12-19 00:00:00	32020		\N	340366	0	195662009	4112343		0
86446	5144	260139	1942-02-28	1942-02-28 00:00:00	1942-03-07	1942-03-07 00:00:00	32020		\N	341926	0	10509002	260139		0
86606	5152	4112343	1988-02-23	1988-02-23 00:00:00	1988-03-04	1988-03-04 00:00:00	32020		\N	342602	0	195662009	4112343		0
89142	5302	28060	1989-01-15	1989-01-15 00:00:00	1989-01-26	1989-01-26 00:00:00	32020		\N	352811	0	43878008	28060		0
85778	5103	260139	1950-01-23	1950-01-23 00:00:00	1950-01-30	1950-01-30 00:00:00	32020		\N	339046	0	10509002	260139		0
86042	5119	260139	1980-12-09	1980-12-09 00:00:00	1980-12-23	1980-12-23 00:00:00	32020		\N	340315	0	10509002	260139		0
86447	5144	4112343	2007-11-21	2007-11-21 00:00:00	2007-11-29	2007-11-29 00:00:00	32020		\N	341899	0	195662009	4112343		0
86607	5152	40481087	1973-06-17	1973-06-17 00:00:00	1973-07-08	1973-07-08 00:00:00	32020		\N	342623	0	444814009	40481087		0
85779	5103	4112343	1968-02-01	1968-02-01 00:00:00	1968-02-14	1968-02-14 00:00:00	32020		\N	339096	0	195662009	4112343		0
86043	5119	40481087	1963-06-09	1963-06-09 00:00:00	1963-06-16	1963-06-16 00:00:00	32020		\N	340370	0	444814009	40481087		0
86448	5144	40481087	1977-03-24	1977-03-24 00:00:00	1977-04-07	1977-04-07 00:00:00	32020		\N	341897	0	444814009	40481087		0
86608	5152	4218389	1987-12-31	1987-12-31 00:00:00	1988-02-04	1988-02-04 00:00:00	32020		\N	342593	0	39848009	4218389		0
85780	5103	4134304	1956-01-25	1956-01-25 00:00:00	1956-03-25	1956-03-25 00:00:00	32020		\N	339103	0	263102004	4134304		0
86044	5119	260139	1997-10-24	1997-10-24 00:00:00	1997-11-07	1997-11-07 00:00:00	32020		\N	340418	0	10509002	260139		0
86449	5144	4112343	1959-08-12	1959-08-12 00:00:00	1959-08-22	1959-08-22 00:00:00	32020		\N	341964	0	195662009	4112343		0
86609	5152	40481087	2006-08-12	2006-08-12 00:00:00	2006-08-19	2006-08-19 00:00:00	32020		\N	342604	0	444814009	40481087		0
85781	5103	40481087	1947-04-30	1947-04-30 00:00:00	1947-05-07	1947-05-07 00:00:00	32020		\N	339061	0	444814009	40481087		0
86045	5119	260139	2000-09-24	2000-09-24 00:00:00	2000-10-08	2000-10-08 00:00:00	32020		\N	340383	0	10509002	260139		0
86450	5144	260139	1957-05-25	1957-05-25 00:00:00	1957-06-08	1957-06-08 00:00:00	32020		\N	341943	0	10509002	260139		0
86610	5152	28060	1976-08-14	1976-08-14 00:00:00	1976-08-23	1976-08-23 00:00:00	32020		\N	342637	0	43878008	28060		0
85782	5103	4112343	1946-08-29	1946-08-29 00:00:00	1946-09-06	1946-09-06 00:00:00	32020		\N	339060	0	195662009	4112343		0
86046	5119	260139	1976-11-21	1976-11-21 00:00:00	1976-11-28	1976-11-28 00:00:00	32020		\N	340293	0	10509002	260139		0
86451	5144	260139	2013-05-08	2013-05-08 00:00:00	2013-05-15	2013-05-15 00:00:00	32020		\N	341901	0	10509002	260139		0
86611	5152	81151	2015-07-03	2015-07-03 00:00:00	2015-07-24	2015-07-24 00:00:00	32020		\N	342649	0	44465007	81151		0
85783	5103	81893	1983-03-25	1983-03-25 00:00:00	\N	\N	32020		\N	339133	0	64766004	81893		0
86047	5119	40481087	2018-11-28	2018-11-28 00:00:00	2018-12-12	2018-12-12 00:00:00	32020		\N	340384	0	444814009	40481087		0
86452	5145	40481087	1970-12-19	1970-12-19 00:00:00	1971-01-02	1971-01-02 00:00:00	32020		\N	342038	0	444814009	40481087		0
86612	5152	4112343	2001-10-25	2001-10-25 00:00:00	2001-11-01	2001-11-01 00:00:00	32020		\N	342618	0	195662009	4112343		0
85784	5103	81151	1944-08-06	1944-08-06 00:00:00	1944-09-03	1944-09-03 00:00:00	32020		\N	339101	0	44465007	81151		0
86058	5121	4027663	1993-06-12	1993-06-12 00:00:00	\N	\N	32020		\N	340467	0	13200003	4027663		0
86453	5145	260139	2000-02-18	2000-02-18 00:00:00	2000-02-25	2000-02-25 00:00:00	32020		\N	342006	0	10509002	260139		0
86613	5152	192671	2012-06-20	2012-06-20 00:00:00	\N	\N	32020		\N	342648	0	K92.2	35208414		0
85785	5103	4112343	1967-05-23	1967-05-23 00:00:00	1967-06-05	1967-06-05 00:00:00	32020		\N	339095	0	195662009	4112343		0
86059	5121	4112343	1965-09-13	1965-09-13 00:00:00	1965-09-20	1965-09-20 00:00:00	32020		\N	340472	0	195662009	4112343		0
86454	5145	4283893	2000-12-28	2000-12-28 00:00:00	2001-06-14	2001-06-14 00:00:00	32020		\N	342043	0	36971009	4283893		0
86614	5152	260139	2013-06-19	2013-06-19 00:00:00	2013-06-26	2013-06-26 00:00:00	32020		\N	342605	0	10509002	260139		0
85786	5103	4278672	1993-06-28	1993-06-28 00:00:00	1993-08-27	1993-08-27 00:00:00	32020		\N	339106	0	65966004	4278672		0
86060	5121	4283893	2016-08-24	2016-08-24 00:00:00	2016-09-07	2016-09-07 00:00:00	32020		\N	340501	0	36971009	4283893		0
86455	5145	4112343	1981-02-21	1981-02-21 00:00:00	1981-03-01	1981-03-01 00:00:00	32020		\N	342004	0	195662009	4112343		0
86615	5152	4109685	2002-09-18	2002-09-18 00:00:00	2002-10-09	2002-10-09 00:00:00	32020		\N	342594	0	284551006	4109685		0
85787	5103	80180	1985-02-12	1985-02-12 00:00:00	\N	\N	32020		\N	339098	0	396275006	80180		0
86061	5121	4112343	2012-03-10	2012-03-10 00:00:00	2012-03-17	2012-03-17 00:00:00	32020		\N	340511	0	195662009	4112343		0
86456	5145	4112343	1996-06-20	1996-06-20 00:00:00	1996-06-29	1996-06-29 00:00:00	32020		\N	342041	0	195662009	4112343		0
86616	5152	40481087	1973-03-28	1973-03-28 00:00:00	1973-04-11	1973-04-11 00:00:00	32020		\N	342617	0	444814009	40481087		0
85788	5103	4112343	1984-10-19	1984-10-19 00:00:00	1984-11-01	1984-11-01 00:00:00	32020		\N	339098	0	195662009	4112343		0
86062	5121	440086	1973-06-17	1973-06-17 00:00:00	1982-06-25	1982-06-25 00:00:00	32020		\N	340473	0	192127007	440086		0
86457	5145	372328	1960-11-07	1960-11-07 00:00:00	1961-08-26	1961-08-26 00:00:00	32020		\N	342067	0	65363002	372328		0
86617	5152	260139	2002-01-17	2002-01-17 00:00:00	2002-01-31	2002-01-31 00:00:00	32020		\N	342603	0	10509002	260139		0
85789	5103	439777	1984-09-30	1984-09-30 00:00:00	\N	\N	32020		\N	339107	0	271737000	439777		0
86063	5121	4112343	2006-10-29	2006-10-29 00:00:00	2006-11-05	2006-11-05 00:00:00	32020		\N	340475	0	195662009	4112343		0
86458	5145	4237458	2001-11-26	2001-11-26 00:00:00	2002-01-25	2002-01-25 00:00:00	32020		\N	342079	0	58150001	4237458		0
86618	5152	40481087	1994-01-26	1994-01-26 00:00:00	1994-02-09	1994-02-09 00:00:00	32020		\N	342620	0	444814009	40481087		0
85790	5104	440086	1991-11-28	1991-11-28 00:00:00	1994-05-06	1994-05-06 00:00:00	32020		\N	339209	0	192127007	440086		0
86064	5121	260139	1988-10-12	1988-10-12 00:00:00	1988-10-26	1988-10-26 00:00:00	32020		\N	340455	0	10509002	260139		0
86459	5145	40481087	1998-12-26	1998-12-26 00:00:00	1999-01-02	1999-01-02 00:00:00	32020		\N	342042	0	444814009	40481087		0
86619	5152	80180	2012-05-13	2012-05-13 00:00:00	\N	\N	32020		\N	342599	0	396275006	80180		0
85791	5104	40481087	1994-09-10	1994-09-10 00:00:00	1994-10-01	1994-10-01 00:00:00	32020		\N	339171	0	444814009	40481087		0
86065	5121	40481087	1966-09-13	1966-09-13 00:00:00	1966-10-04	1966-10-04 00:00:00	32020		\N	340454	0	444814009	40481087		0
86460	5145	257012	2001-02-01	2001-02-01 00:00:00	\N	\N	32020		\N	342044	0	40055000	257012		0
86620	5152	378001	2013-04-14	2013-04-14 00:00:00	2013-06-13	2013-06-13 00:00:00	32020		\N	342595	0	62106007	378001		0
85792	5104	192671	2017-06-24	2017-06-24 00:00:00	\N	\N	32020		\N	339225	0	K92.2	35208414		0
86066	5121	4266809	2000-02-01	2000-02-01 00:00:00	\N	\N	32020		\N	340507	0	397881000	4266809		0
86461	5145	40481087	2018-02-20	2018-02-20 00:00:00	2018-03-13	2018-03-13 00:00:00	32020		\N	342007	0	444814009	40481087		0
86621	5153	40481087	1959-01-24	1959-01-24 00:00:00	1959-02-14	1959-02-14 00:00:00	32020		\N	342727	0	444814009	40481087		0
85793	5104	4296205	1988-07-31	1988-07-31 00:00:00	1988-08-21	1988-08-21 00:00:00	32020		\N	339184	0	403191005	4296205		0
86067	5121	81151	1998-10-19	1998-10-19 00:00:00	1998-11-16	1998-11-16 00:00:00	32020		\N	340507	0	44465007	81151		0
86462	5145	4116491	1978-09-04	1978-09-04 00:00:00	1978-10-28	1978-10-28 00:00:00	32020		\N	342033	0	301011002	4116491		0
86622	5153	40481087	2011-01-10	2011-01-10 00:00:00	2011-01-24	2011-01-24 00:00:00	32020		\N	342671	0	444814009	40481087		0
85794	5104	4112343	2005-06-19	2005-06-19 00:00:00	2005-06-26	2005-06-26 00:00:00	32020		\N	339186	0	195662009	4112343		0
86068	5121	30753	1999-05-07	1999-05-07 00:00:00	\N	\N	32020		\N	340507	0	16761005	30753		0
86463	5145	372328	1999-02-08	1999-02-08 00:00:00	1999-03-27	1999-03-27 00:00:00	32020		\N	342011	0	65363002	372328		0
86623	5153	40481087	1947-05-22	1947-05-22 00:00:00	1947-06-05	1947-06-05 00:00:00	32020		\N	342666	0	444814009	40481087		0
85795	5104	4278672	1987-04-08	1987-04-08 00:00:00	1987-07-07	1987-07-07 00:00:00	32020		\N	339183	0	65966004	4278672		0
86069	5121	80180	2000-02-01	2000-02-01 00:00:00	\N	\N	32020		\N	340507	0	396275006	80180		0
86464	5145	372328	1959-03-14	1959-03-14 00:00:00	1959-08-15	1959-08-15 00:00:00	32020		\N	342031	0	65363002	372328		0
86624	5153	40481087	2016-11-02	2016-11-02 00:00:00	2016-11-23	2016-11-23 00:00:00	32020		\N	342681	0	444814009	40481087		0
85796	5104	372328	1980-09-09	1980-09-09 00:00:00	1980-11-08	1980-11-08 00:00:00	32020		\N	339179	0	65363002	372328		0
86070	5121	4112343	1981-10-29	1981-10-29 00:00:00	1981-11-05	1981-11-05 00:00:00	32020		\N	340474	0	195662009	4112343		0
86465	5145	4112343	1992-03-05	1992-03-05 00:00:00	1992-03-12	1992-03-12 00:00:00	32020		\N	342040	0	195662009	4112343		0
86625	5153	40481087	1977-06-11	1977-06-11 00:00:00	1977-06-18	1977-06-18 00:00:00	32020		\N	342680	0	444814009	40481087		0
85797	5104	4112343	2013-08-30	2013-08-30 00:00:00	2013-09-07	2013-09-07 00:00:00	32020		\N	339178	0	195662009	4112343		0
86071	5121	378001	1976-02-17	1976-02-17 00:00:00	1976-03-18	1976-03-18 00:00:00	32020		\N	340506	0	62106007	378001		0
86466	5145	4112343	1977-05-02	1977-05-02 00:00:00	1977-05-09	1977-05-09 00:00:00	32020		\N	342002	0	195662009	4112343		0
86626	5153	4283893	1992-10-15	1992-10-15 00:00:00	1992-11-19	1992-11-19 00:00:00	32020		\N	342669	0	36971009	4283893		0
85798	5104	4113008	1986-05-29	1986-05-29 00:00:00	1986-06-12	1986-06-12 00:00:00	32020		\N	339182	0	284549007	4113008		0
86072	5121	40481087	1997-03-25	1997-03-25 00:00:00	1997-04-01	1997-04-01 00:00:00	32020		\N	340497	0	444814009	40481087		0
86467	5145	4296205	1979-08-26	1979-08-26 00:00:00	1979-09-23	1979-09-23 00:00:00	32020		\N	342078	0	403191005	4296205		0
86627	5153	4027663	1976-12-19	1976-12-19 00:00:00	\N	\N	32020		\N	342704	0	13200003	4027663		0
85799	5104	4112343	2009-06-08	2009-06-08 00:00:00	2009-06-19	2009-06-19 00:00:00	32020		\N	339172	0	195662009	4112343		0
86073	5121	260139	2019-01-19	2019-01-19 00:00:00	2019-01-26	2019-01-26 00:00:00	32020		\N	340513	0	10509002	260139		0
86468	5145	80180	1991-04-24	1991-04-24 00:00:00	\N	\N	32020		\N	342034	0	396275006	80180		0
86628	5153	40479422	2014-06-14	2014-06-14 00:00:00	2014-08-20	2014-08-20 00:00:00	32020		\N	342653	0	444448004	40479422		0
85800	5104	4027663	2009-11-23	2009-11-23 00:00:00	\N	\N	32020		\N	339172	0	13200003	4027663		0
86074	5121	4112343	2017-03-22	2017-03-22 00:00:00	2017-03-29	2017-03-29 00:00:00	32020		\N	340512	0	195662009	4112343		0
86469	5145	40481087	1990-01-23	1990-01-23 00:00:00	1990-02-06	1990-02-06 00:00:00	32020		\N	342034	0	444814009	40481087		0
86629	5153	4059173	1977-03-30	1977-03-30 00:00:00	1977-04-29	1977-04-29 00:00:00	32020		\N	342652	0	16114001	4059173		0
85801	5104	40481087	1994-01-15	1994-01-15 00:00:00	1994-02-05	1994-02-05 00:00:00	32020		\N	339197	0	444814009	40481087		0
86075	5121	40481087	1974-11-30	1974-11-30 00:00:00	1974-12-14	1974-12-14 00:00:00	32020		\N	340510	0	444814009	40481087		0
86470	5145	4112343	1967-10-08	1967-10-08 00:00:00	1967-10-18	1967-10-18 00:00:00	32020		\N	342026	0	195662009	4112343		0
86630	5153	40481087	1964-03-25	1964-03-25 00:00:00	1964-04-01	1964-04-01 00:00:00	32020		\N	342678	0	444814009	40481087		0
85802	5104	40481087	2011-06-12	2011-06-12 00:00:00	2011-06-26	2011-06-26 00:00:00	32020		\N	339198	0	444814009	40481087		0
86076	5121	4156265	2013-06-30	2013-06-30 00:00:00	2013-07-14	2013-07-14 00:00:00	32020		\N	340508	0	370247008	4156265		0
86471	5145	40481087	1983-11-30	1983-11-30 00:00:00	1983-12-07	1983-12-07 00:00:00	32020		\N	342005	0	444814009	40481087		0
86631	5153	260139	1955-10-03	1955-10-03 00:00:00	1955-10-10	1955-10-10 00:00:00	32020		\N	342732	0	10509002	260139		0
85803	5104	40481087	2011-11-29	2011-11-29 00:00:00	2011-12-20	2011-12-20 00:00:00	32020		\N	339177	0	444814009	40481087		0
86077	5121	81893	1998-09-09	1998-09-09 00:00:00	\N	\N	32020		\N	340469	0	64766004	81893		0
86473	5145	321042	2018-01-13	2018-01-13 00:00:00	\N	\N	32020		\N	342080	0	410429000	321042		0
86632	5153	440448	1963-12-25	1963-12-25 00:00:00	\N	\N	32020		\N	342651	0	74400008	440448		0
85804	5104	372328	1980-06-29	1980-06-29 00:00:00	1980-08-10	1980-08-10 00:00:00	32020		\N	339216	0	65363002	372328		0
86078	5121	4310024	1998-08-10	1998-08-10 00:00:00	\N	\N	32020		\N	340469	0	424802006	4310024		0
86474	5145	40481087	1986-10-28	1986-10-28 00:00:00	1986-11-04	1986-11-04 00:00:00	32020		\N	342027	0	444814009	40481087		0
86633	5153	28060	1972-01-07	1972-01-07 00:00:00	1972-01-17	1972-01-17 00:00:00	32020		\N	342679	0	43878008	28060		0
85805	5104	40481087	1991-09-09	1991-09-09 00:00:00	1991-09-23	1991-09-23 00:00:00	32020		\N	339155	0	444814009	40481087		0
86079	5121	372328	1964-11-16	1964-11-16 00:00:00	1965-02-26	1965-02-26 00:00:00	32020		\N	340498	0	65363002	372328		0
86475	5145	40481087	1969-04-07	1969-04-07 00:00:00	1969-04-21	1969-04-21 00:00:00	32020		\N	342001	0	444814009	40481087		0
86634	5153	40481087	1965-04-01	1965-04-01 00:00:00	1965-04-08	1965-04-08 00:00:00	32020		\N	342728	0	444814009	40481087		0
85806	5104	80180	2017-06-15	2017-06-15 00:00:00	\N	\N	32020		\N	339192	0	396275006	80180		0
86080	5121	192671	2000-04-10	2000-04-10 00:00:00	\N	\N	32020		\N	340509	0	K92.2	35208414		0
86476	5145	4112343	2015-06-23	2015-06-23 00:00:00	2015-07-05	2015-07-05 00:00:00	32020		\N	342030	0	195662009	4112343		0
86635	5153	80180	1987-02-05	1987-02-05 00:00:00	\N	\N	32020		\N	342690	0	396275006	80180		0
86096	5123	372328	1983-11-03	1983-11-03 00:00:00	1984-05-07	1984-05-07 00:00:00	32020		\N	340639	0	65363002	372328		0
86477	5145	4113008	1968-04-04	1968-04-04 00:00:00	1968-04-25	1968-04-25 00:00:00	32020		\N	342077	0	284549007	4113008		0
86636	5153	40481087	2001-12-09	2001-12-09 00:00:00	2001-12-23	2001-12-23 00:00:00	32020		\N	342731	0	444814009	40481087		0
86097	5123	4112343	1989-12-05	1989-12-05 00:00:00	1989-12-13	1989-12-13 00:00:00	32020		\N	340640	0	195662009	4112343		0
86478	5145	372328	1958-06-26	1958-06-26 00:00:00	1958-08-16	1958-08-16 00:00:00	32020		\N	342037	0	65363002	372328		0
86637	5153	260139	1970-03-27	1970-03-27 00:00:00	1970-04-10	1970-04-10 00:00:00	32020		\N	342733	0	10509002	260139		0
86098	5123	81151	1984-01-02	1984-01-02 00:00:00	1984-02-06	1984-02-06 00:00:00	32020		\N	340685	0	44465007	81151		0
86479	5145	4056621	1978-12-02	1978-12-02 00:00:00	\N	\N	32020		\N	342039	0	197927001	4056621		0
86638	5153	260139	1982-11-21	1982-11-21 00:00:00	1982-11-28	1982-11-28 00:00:00	32020		\N	342668	0	10509002	260139		0
86099	5123	260139	1985-03-28	1985-03-28 00:00:00	1985-04-04	1985-04-04 00:00:00	32020		\N	340636	0	10509002	260139		0
86480	5145	4116491	1978-12-02	1978-12-02 00:00:00	1979-01-20	1979-01-20 00:00:00	32020		\N	342039	0	301011002	4116491		0
86639	5153	30753	1985-12-12	1985-12-12 00:00:00	\N	\N	32020		\N	342707	0	16761005	30753		0
86100	5123	28060	1990-03-14	1990-03-14 00:00:00	1990-03-26	1990-03-26 00:00:00	32020		\N	340637	0	43878008	28060		0
86481	5146	260139	2000-01-18	2000-01-18 00:00:00	2000-01-25	2000-01-25 00:00:00	32020		\N	342098	0	10509002	260139		0
86640	5153	81893	1985-08-14	1985-08-14 00:00:00	\N	\N	32020		\N	342707	0	64766004	81893		0
86101	5123	4112343	1990-10-23	1990-10-23 00:00:00	1990-10-31	1990-10-31 00:00:00	32020		\N	340641	0	195662009	4112343		0
86482	5146	4296205	2017-01-29	2017-01-29 00:00:00	2017-03-05	2017-03-05 00:00:00	32020		\N	342083	0	403191005	4296205		0
86641	5153	4285898	1986-07-10	1986-07-10 00:00:00	\N	\N	32020		\N	342707	0	68496003	4285898		0
86102	5123	40481087	1993-05-21	1993-05-21 00:00:00	1993-05-28	1993-05-28 00:00:00	32020		\N	340642	0	444814009	40481087		0
86483	5146	78272	1952-08-03	1952-08-03 00:00:00	1952-08-24	1952-08-24 00:00:00	32020		\N	342081	0	70704007	78272		0
86642	5153	40481087	1987-12-27	1987-12-27 00:00:00	1988-01-03	1988-01-03 00:00:00	32020		\N	342730	0	444814009	40481087		0
86103	5123	80180	2016-08-06	2016-08-06 00:00:00	\N	\N	32020		\N	340683	0	396275006	80180		0
86484	5146	260139	1966-07-14	1966-07-14 00:00:00	1966-07-28	1966-07-28 00:00:00	32020		\N	342133	0	10509002	260139		0
86643	5153	192671	1987-03-14	1987-03-14 00:00:00	\N	\N	32020		\N	342655	0	K92.2	35208414		0
86104	5123	40481087	2002-04-19	2002-04-19 00:00:00	2002-04-26	2002-04-26 00:00:00	32020		\N	340643	0	444814009	40481087		0
86485	5146	40481087	1974-12-22	1974-12-22 00:00:00	1974-12-29	1974-12-29 00:00:00	32020		\N	342112	0	444814009	40481087		0
86644	5153	40481087	1983-10-21	1983-10-21 00:00:00	1983-11-11	1983-11-11 00:00:00	32020		\N	342729	0	444814009	40481087		0
86105	5123	4142905	1994-09-11	1994-09-11 00:00:00	1994-12-10	1994-12-10 00:00:00	32020		\N	340686	0	33737001	4142905		0
86486	5146	260139	2012-05-29	2012-05-29 00:00:00	2012-06-05	2012-06-05 00:00:00	32020		\N	342113	0	10509002	260139		0
86645	5153	40481087	1949-06-02	1949-06-02 00:00:00	1949-06-09	1949-06-09 00:00:00	32020		\N	342667	0	444814009	40481087		0
86106	5123	4237458	2004-04-21	2004-04-21 00:00:00	2004-05-21	2004-05-21 00:00:00	32020		\N	340687	0	58150001	4237458		0
86646	5153	78272	1960-01-08	1960-01-08 00:00:00	1960-01-29	1960-01-29 00:00:00	32020		\N	342650	0	70704007	78272		0
86107	5123	4112343	2013-06-05	2013-06-05 00:00:00	2013-06-17	2013-06-17 00:00:00	32020		\N	340644	0	195662009	4112343		0
86647	5153	28060	1998-04-02	1998-04-02 00:00:00	1998-04-09	1998-04-09 00:00:00	32020		\N	342670	0	43878008	28060		0
86151	5127	378001	2010-07-16	2010-07-16 00:00:00	2010-08-15	2010-08-15 00:00:00	32020		\N	340895	0	62106007	378001		0
86152	5127	40481087	1990-01-20	1990-01-20 00:00:00	1990-01-27	1990-01-27 00:00:00	32020		\N	340843	0	444814009	40481087		0
86153	5127	4059173	1980-03-25	1980-03-25 00:00:00	1980-04-24	1980-04-24 00:00:00	32020		\N	340894	0	16114001	4059173		0
86154	5127	40481087	1973-12-08	1973-12-08 00:00:00	1973-12-22	1973-12-22 00:00:00	32020		\N	340886	0	444814009	40481087		0
\.


--
-- TOC entry 3892 (class 0 OID 3185502)
-- Dependencies: 214
-- Data for Name: cost; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".cost (cost_id, cost_event_id, cost_domain_id, cost_type_concept_id, currency_concept_id, total_charge, total_cost, total_paid, paid_by_payer, paid_by_patient, paid_patient_copay, paid_patient_coinsurance, paid_patient_deductible, paid_by_primary, paid_ingredient_cost, paid_dispensing_fee, payer_plan_period_id, amount_allowed, revenue_code_concept_id, reveue_code_source_value, drg_concept_id, drg_source_value) FROM stdin;
\.


--
-- TOC entry 3893 (class 0 OID 3185508)
-- Dependencies: 215
-- Data for Name: death; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".death (person_id, death_date, death_datetime, death_type_concept_id, cause_concept_id, cause_source_value, cause_source_concept_id) FROM stdin;
\.


--
-- TOC entry 3894 (class 0 OID 3185511)
-- Dependencies: 216
-- Data for Name: device_exposure; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".device_exposure (device_exposure_id, person_id, device_concept_id, device_exposure_start_date, device_exposure_start_datetime, device_exposure_end_date, device_exposure_end_datetime, device_type_concept_id, unique_device_id, quantity, provider_id, visit_occurrence_id, visit_detail_id, device_source_value, device_source_concept_id) FROM stdin;
\.


--
-- TOC entry 3895 (class 0 OID 3185514)
-- Dependencies: 217
-- Data for Name: domain; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".domain (domain_id, domain_name, domain_concept_id) FROM stdin;
Condition	Condition	19
Condition/Device	Condition/Device	235
Condition/Drug	Condition/Drug	53
Condition/Meas	Condition/Measurement	47
Condition/Obs	Condition/Observation	48
Condition/Procedure	Condition/Procedure	49
Cost	Cost	581456
Currency	Currency	34
Device	Device	17
Device/Drug	Device/Drug	50
Device/Obs	Device/Observation	45
Device/Procedure	Device/Procedure	41
Drug	Drug	13
Drug/Measurement	Drug/Measurement	51
Drug/Obs	Drug/Observation	52
Drug/Procedure	Drug/Procedure	54
Episode	Episode	32527
Ethnicity	Ethnicity	4
Gender	Gender	2
Meas Value	Measurement Value	24
Meas Value Operator	Measurement Value Operator	23
Meas/Procedure	Measurement/Procedure	43
Measurement	Measurement	21
Measurement/Obs	Measurement/Observation	44
Metadata	Metadata	7
Modifier	Modifier	12
Obs/Procedure	Observation/Procedure	42
Observation	Observation	27
Payer	Payer - institution administering healthcare transactions	32477
Place of Service	Place of Service	32
Plan	Health Plan - contract to administer healthcare transactions by the payer, facilitated by the sponsor	32475
Plan Stop Reason	Plan Stop Reason - Reason for termination of the Health Plan	32478
Procedure	Procedure	10
Provider Specialty	Provider Specialty	33
Race	Race	3
Relationship	Relationship	31
Revenue Code	Revenue Code	35
Route	Route Of Administration	15
Spec Anatomic Site	Specimen Anatomic Site	38
Spec Disease Status	Specimen Disease Status	39
Specimen	Specimen	36
Sponsor	Sponsor - institution or individual financing healthcare transactions	32476
Type Concept	Type Concept	58
Unit	Unit	16
Visit	Visit	8
\.


--
-- TOC entry 3896 (class 0 OID 3185517)
-- Dependencies: 218
-- Data for Name: dose_era; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".dose_era (dose_era_id, person_id, drug_concept_id, unit_concept_id, dose_value, dose_era_start_date, dose_era_end_date) FROM stdin;
\.


--
-- TOC entry 3897 (class 0 OID 3185523)
-- Dependencies: 219
-- Data for Name: drug_era; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".drug_era (drug_era_id, person_id, drug_concept_id, drug_era_start_date, drug_era_end_date, drug_exposure_count, gap_days) FROM stdin;
2707	181	738818	1984-09-19	1984-10-03	1	5389
45782	3109	1125315	1931-02-05	1931-02-19	1	-14196
1918	126	1118084	1989-09-03	1989-09-03	1	7185
44684	3028	1307863	2007-05-17	2007-05-17	1	13650
764	49	1102527	1992-12-15	1992-12-15	1	8384
70141	4792	920293	1979-04-15	1979-04-22	1	3398
47860	3248	19016749	2016-06-26	2016-06-26	1	16978
525	35	1118084	1997-05-02	1997-05-02	1	9983
40496	2752	920293	1972-04-15	1972-04-22	1	842
75597	5174	1557272	1997-03-27	1997-03-27	1	9947
48568	3301	1112807	1973-01-31	1973-02-28	1	1154
2401	160	738818	2003-06-06	2003-06-13	1	12216
40914	2777	933724	2013-04-25	2013-05-02	1	15827
84	5	738818	2015-08-10	2015-08-17	1	16664
672	42	1112807	1935-09-08	1935-10-06	1	-12506
46460	3158	1119510	1950-11-20	1950-11-27	1	-6975
2226	149	738818	1975-05-25	1975-06-01	1	1977
47580	3231	1125315	2010-03-19	2010-04-02	1	14701
286	18	933724	1997-12-26	1998-01-09	1	10235
45601	3096	1728416	1964-10-17	1964-10-31	1	-1888
2879	191	715997	1999-03-08	1999-03-08	1	10658
40249	2736	1713332	2000-04-27	2000-05-18	1	11095
52684	3589	1551099	1998-03-31	1998-03-31	1	10316
1857	123	1125315	1954-01-10	1954-01-24	1	-5821
417	30	933724	1999-09-05	1999-09-12	1	10846
31071	2100	1102527	1976-06-10	1976-06-10	1	2352
1196	81	1112807	1963-09-11	1963-12-10	1	-2214
43065	2913	1759842	1957-11-05	1957-12-03	1	-4412
795	53	1125315	1988-02-26	1988-04-26	2	6690
44005	2975	1125315	2017-09-23	2017-10-07	1	17446
3680	248	1118084	2012-12-09	2012-12-09	1	15683
46779	3176	975125	2001-12-09	2001-12-09	1	11665
653	41	1125315	1979-12-21	1980-01-11	1	3662
46438	3157	920293	2008-07-25	2008-08-01	1	14092
48347	3285	1125315	1981-04-15	1981-04-29	1	4136
2814	187	1112807	1977-03-20	1977-04-25	1	2671
43153	2919	1347450	1996-06-15	1996-06-15	1	9662
1306	90	1115008	2009-06-10	2009-06-24	1	14419
923	63	1112807	1973-12-05	1974-01-04	1	1464
43882	2965	1125315	2008-11-28	2008-12-05	1	14218
43221	2925	1177480	2001-05-04	2001-05-18	1	11460
981	66	1759842	2017-05-31	2017-06-07	1	17324
47676	3236	1347450	2016-07-15	2016-07-15	1	16997
180	11	1125315	1966-10-25	1966-11-08	1	-1150
47040	3191	1112807	1968-09-28	1968-10-12	1	-446
1483	99	1115008	2011-09-11	2011-10-11	1	15258
44558	3017	1728416	1958-04-13	1958-04-27	1	-4267
49887	3399	1115008	2000-04-09	2000-06-08	1	11116
39215	2666	1118084	1992-06-24	1992-06-24	1	8210
1813	120	1115008	2007-07-25	2007-08-15	1	13740
1089	74	933724	2004-01-30	2004-02-06	1	12454
47798	3244	1124300	2013-07-27	2013-07-27	1	15913
1956	129	1125315	1983-04-23	1983-05-14	1	4881
42171	2859	1728416	1955-12-25	1956-01-08	1	-5107
153	9	1115008	2008-06-10	2008-06-24	1	14054
1224	84	1125315	1996-11-08	1996-11-22	1	9822
1	1	1112807	1970-12-03	1970-12-31	1	364
2708	181	1125315	1984-09-19	1984-10-03	1	5389
45783	3109	1713332	1979-02-13	1979-02-20	1	3337
1919	126	1125315	1951-04-24	1951-05-08	1	-6813
44685	3028	1713332	1981-01-02	1981-01-23	1	4040
765	49	1112807	1982-04-16	1982-05-14	1	4516
70142	4792	920293	1981-05-22	1981-05-29	1	4166
47861	3248	920293	1989-08-08	1989-08-22	2	7173
526	35	1119510	2007-02-25	2007-03-04	1	13576
40497	2752	933724	1972-04-15	1972-04-22	1	842
75598	5174	1729720	1947-01-07	1947-01-17	1	-8385
48569	3301	1124300	1974-05-11	1974-05-11	1	1591
2402	160	920293	1992-09-02	1992-09-16	2	8294
40915	2777	1115008	2007-02-03	2007-03-05	1	13577
85	5	1118084	2009-05-30	2009-05-30	1	14394
673	42	1125315	1974-06-13	1974-06-27	1	1638
46461	3158	1347450	2002-01-10	2002-01-10	1	11697
2227	149	1125315	1975-05-25	1975-06-01	1	1977
47581	3231	1102527	1989-04-06	1989-04-06	1	7035
287	18	1125315	1983-05-31	1983-06-28	1	4926
45602	3096	19127890	1986-11-01	1987-10-27	1	6508
2880	191	738818	1968-09-30	1968-10-07	1	-451
40250	2736	1759842	2000-04-27	2000-05-18	1	11095
52685	3589	1713332	1985-09-24	1985-10-08	1	5759
1858	123	1125315	2006-08-17	2006-08-24	1	13384
418	30	975125	1976-10-29	1976-11-19	1	2514
31072	2100	1112807	1944-08-01	1944-08-15	1	-9270
1197	81	1713332	1983-02-16	1983-03-02	1	4808
43066	2913	1177480	1988-03-14	1988-03-28	1	6661
796	53	1125315	1992-11-06	1992-11-20	1	8359
44006	2975	1551099	1975-05-30	1975-05-30	1	1975
3681	248	1119510	1981-02-16	1981-03-02	1	4078
46780	3176	1124957	1992-04-29	1992-04-29	1	8154
654	41	1713332	1977-10-21	1977-11-11	1	2871
46439	3157	1112807	1960-03-22	1960-06-20	1	-3482
48348	3285	1728416	1962-06-27	1962-07-11	1	-2731
2815	187	1125315	1965-10-07	1965-10-21	1	-1533
43154	2919	1361711	2017-12-16	2017-12-16	1	17516
1307	90	1124300	1997-06-02	1997-06-02	1	10014
924	63	1125315	1973-12-05	1973-12-05	1	1434
43883	2965	19127890	1990-01-19	1991-01-14	1	7683
43222	2925	1713332	1980-09-06	1980-09-20	1	3915
982	66	738818	1972-04-16	1972-04-30	1	850
47677	3236	1713332	1944-07-12	1944-08-02	1	-9283
181	11	1125315	1987-10-03	1987-11-02	1	6514
47041	3191	1125315	1992-05-26	1992-06-09	1	8195
1484	99	1125315	1980-11-30	1980-12-14	1	4000
44559	3017	1125315	2000-11-08	2000-11-15	1	11276
49888	3399	1119510	1987-01-18	1987-01-25	1	6233
39216	2666	1125315	1955-07-25	1955-08-01	1	-5267
1814	120	1125315	1979-12-28	1980-01-18	1	3669
1090	74	1124300	2015-08-12	2015-08-12	1	16659
47799	3244	1125315	2007-09-26	2007-10-03	1	13789
1957	129	1738521	1975-08-03	1975-08-17	1	2054
42172	2859	1759842	1964-09-22	1964-09-29	1	-1920
154	9	19127890	1994-07-06	1995-07-01	1	9312
1225	84	1150770	1979-04-03	1979-04-03	1	3379
2	1	1118084	1982-08-12	1982-08-12	1	4606
2709	181	19127890	1988-09-07	1990-08-28	2	7544
45784	3109	1729720	1930-08-22	1930-08-31	1	-14368
1920	126	1728416	1951-04-24	1951-05-08	1	-6813
44686	3028	1118084	2000-07-01	2000-07-01	1	11139
766	49	1119510	1978-03-10	1978-03-24	1	3004
70143	4792	933724	1979-04-15	1979-04-22	1	3398
47862	3248	933724	1989-08-08	1989-08-22	1	7173
527	35	1521369	1978-03-03	1979-02-26	1	3343
40498	2752	1112807	1952-06-10	1952-06-24	1	-6400
75599	5174	920293	1966-02-20	1966-02-27	1	-1404
48570	3301	1729720	1939-11-27	1939-12-09	1	-10981
2403	160	920293	1992-12-01	1992-12-08	1	8377
40916	2777	1125315	1985-11-06	1985-12-13	1	5825
86	5	1125315	1971-03-12	1971-03-26	1	449
674	42	1125315	1985-02-03	1985-02-17	1	5526
46462	3158	1713332	2000-03-15	2000-04-05	1	11052
2228	149	740275	1948-08-17	1949-03-15	1	-7597
47582	3231	1112807	1957-11-22	1957-12-13	1	-4402
288	18	1503184	1979-11-14	1980-11-08	1	3964
45603	3096	1112807	1964-10-17	1964-10-31	1	-1888
2881	191	920293	1958-06-19	1958-06-26	1	-4207
40251	2736	1118084	2015-07-11	2015-07-11	1	16627
52686	3589	1124300	2016-11-06	2016-11-06	1	17111
1859	123	1309944	2013-07-10	2013-07-10	1	15896
419	30	1112807	1972-04-06	1972-04-20	1	840
31073	2100	1115008	2014-12-16	2014-12-30	1	16434
1198	81	1729720	2005-08-09	2005-08-17	1	13012
43067	2913	1713332	2007-09-20	2007-09-27	1	13783
797	53	1713332	2001-05-31	2001-06-14	1	11487
44903	3049	1125315	1986-12-05	1986-12-05	1	6182
3682	248	1125315	1996-04-16	1996-04-23	1	9609
46781	3176	1125315	1973-09-24	1973-10-08	1	1376
655	41	1119510	1989-09-24	1989-10-08	1	7220
46440	3157	1125315	1955-07-01	1955-07-15	1	-5284
48349	3285	914335	2011-03-12	2011-03-12	1	15045
2816	187	1125315	1999-07-27	1999-08-03	1	10806
43155	2919	738818	1981-01-14	1981-01-21	1	4038
1308	90	1125315	1963-05-12	1963-05-26	1	-2412
925	63	1125315	1995-11-01	1995-11-15	1	9449
43884	2965	1112807	1971-02-18	1971-04-19	1	473
43223	2925	1118084	1998-12-21	1998-12-21	1	10581
983	66	1125315	1972-04-16	1972-04-30	1	850
47678	3236	1728416	1958-10-29	1958-11-26	1	-4054
182	11	1125315	1994-05-20	1994-06-24	1	8940
47042	3191	1347450	2015-09-24	2015-09-24	1	16702
1485	99	1125315	1994-04-02	1994-04-16	1	8871
44560	3017	1125315	2003-03-28	2003-04-11	1	12153
49889	3399	1759842	2005-02-08	2005-02-15	1	12829
39217	2666	1112807	1955-12-19	1956-01-09	1	-5106
1815	120	1125315	1992-11-10	1992-11-10	1	8349
1091	74	1549786	1992-11-25	1993-11-20	1	8724
47800	3244	1177480	1997-05-24	1997-06-28	1	10040
1958	129	1118084	2014-03-21	2014-03-21	1	16150
42173	2859	1118084	1976-10-24	1976-10-24	1	2488
155	9	1115008	2012-12-21	2013-01-11	1	15716
1226	84	1177480	1977-02-10	1977-02-24	1	2611
3	1	1125315	1980-03-15	1980-03-29	1	3740
2710	181	1118084	2010-08-28	2010-08-28	1	14849
45785	3109	1112807	1921-06-13	1921-06-27	1	-17720
1921	126	1112807	1950-04-06	1950-04-20	1	-7196
44687	3028	1326303	2007-05-17	2007-05-17	1	13650
767	49	1738521	1976-11-13	1976-11-27	1	2522
70144	4792	933724	1981-05-22	1981-05-29	1	4166
47863	3248	1112807	1948-02-12	1948-02-26	1	-7980
528	35	1713332	1984-02-18	1984-02-25	1	5168
40499	2752	1124300	1992-03-27	1992-03-27	1	8121
75600	5174	1112807	1944-12-20	1945-02-18	1	-9083
49632	3382	1125315	1978-11-01	1978-11-08	1	3233
2404	160	933724	1992-09-02	1992-09-16	1	8294
40917	2777	920293	2013-04-25	2013-05-02	1	15827
87	5	1125315	2015-08-10	2015-08-17	1	16664
675	42	1125315	2006-03-04	2006-03-11	1	13218
46463	3158	1713332	2001-07-08	2001-07-15	1	11518
2229	149	1112807	1942-06-15	1942-06-29	1	-10048
47583	3231	1125315	1960-04-27	1960-05-11	1	-3522
289	18	920293	1997-12-26	1998-01-09	2	10235
45604	3096	1112807	1965-04-28	1965-05-12	1	-1695
2882	191	1112807	1939-03-31	1939-04-30	1	-11204
40252	2736	1125315	1974-06-24	1974-07-08	1	1649
52687	3589	1125315	1983-02-17	1983-03-03	1	4809
1860	123	1343916	2013-07-10	2013-07-10	1	15896
420	30	1125315	1998-04-21	1998-05-05	1	10351
31074	2100	1713332	1982-09-11	1982-09-18	1	4643
1199	81	1759842	1986-05-21	1986-06-11	1	6005
43068	2913	1759842	2007-09-20	2007-09-27	1	13783
798	53	1738521	1967-09-16	1967-09-30	1	-824
44904	3049	1125315	2005-10-18	2005-11-22	1	13109
3683	248	1728416	1975-06-17	1975-07-01	1	2007
46782	3176	1125315	1976-05-28	1976-06-11	1	2353
656	41	1125315	1974-10-19	1974-10-26	1	1759
46441	3157	1125315	1957-10-29	1957-11-12	1	-4433
48350	3285	1125315	1970-11-10	1970-11-24	1	327
2817	187	1713332	1962-04-07	1962-04-14	1	-2819
43156	2919	1102527	2018-03-21	2018-03-21	1	17611
1309	90	1125315	1987-06-06	1987-06-20	1	6379
926	63	1125315	2000-10-15	2000-11-29	2	11266
43885	2965	1125315	1985-02-06	1985-02-13	1	5522
43224	2925	1124957	2007-06-17	2007-06-17	1	13681
984	66	1125315	1998-04-18	1998-05-02	1	10348
47679	3236	1729720	1942-03-14	1942-03-23	1	-10146
183	11	1322184	2002-05-28	2002-05-28	1	11835
47043	3191	1713332	2017-10-26	2017-11-16	1	17486
1486	99	1125315	2015-09-20	2015-12-19	1	16788
44561	3017	1759842	1973-12-08	1974-02-16	1	1507
49890	3399	1150770	1983-12-17	1983-12-17	1	5098
39218	2666	1112807	1959-12-19	1960-01-23	1	-3631
1816	120	1174888	1992-11-10	1992-11-10	1	8349
1092	74	1713332	1998-04-14	1998-05-05	1	10351
47801	3244	1521369	1995-03-04	1996-02-27	1	9553
1959	129	1125315	1994-08-25	1994-09-08	1	9016
42174	2859	1125315	1944-01-08	1944-01-15	1	-9483
156	9	1118084	2014-08-05	2014-08-05	1	16287
1227	84	1713332	1979-09-25	1979-10-09	1	3568
4	1	1713332	1967-05-30	1967-06-20	1	-926
2711	181	1713332	1997-03-22	1997-03-29	1	9949
45786	3109	1125315	1971-02-09	1971-03-02	1	425
1922	126	1115008	2010-05-26	2010-06-16	1	14776
44688	3028	1717327	1964-08-24	1964-09-07	1	-1942
768	49	738818	1978-03-10	1978-03-24	1	3004
70145	4792	1125315	1950-05-21	1950-06-04	1	-7151
47864	3248	1118084	1983-04-20	1983-04-20	1	4857
529	35	1729720	1996-07-02	1996-07-10	1	9687
40500	2752	1125315	1954-04-03	1954-04-10	1	-5745
75601	5174	1112807	1962-08-02	1962-08-16	1	-2695
49633	3382	1713332	1998-10-14	1998-10-28	1	10527
2405	160	933724	1992-12-01	1992-12-08	1	8377
40918	2777	1102527	1985-11-13	1985-11-13	1	5795
88	5	1192710	1973-08-13	1973-08-13	1	1320
676	42	1729720	1985-05-25	1985-06-01	1	5630
46464	3158	705944	1963-08-22	1967-03-30	1	-1008
2230	149	1125315	1947-01-21	1947-01-28	1	-8374
47584	3231	1125315	1989-04-06	1989-05-06	1	7065
290	18	1124300	2009-03-21	2009-03-21	1	14324
45605	3096	1115008	2016-04-08	2016-07-07	1	16989
2883	191	1119510	1946-04-17	1946-05-01	1	-8646
40253	2736	1728416	1970-05-03	1970-05-17	1	136
52688	3589	1112807	1983-11-14	1984-01-13	1	5125
1861	123	914335	2013-07-10	2013-07-10	1	15896
421	30	1125315	2004-11-28	2004-12-05	1	12757
31075	2100	1728416	1947-07-02	1947-07-16	1	-8205
1200	81	1118084	1997-04-30	1997-04-30	1	9981
43069	2913	1124300	1979-06-05	1979-06-05	1	3442
799	53	1112807	1967-01-02	1967-01-16	1	-1081
44905	3049	1125315	2011-07-24	2011-08-21	1	15207
3684	248	1112807	1975-06-17	1975-07-01	1	2007
46783	3176	1125315	1992-04-29	1992-06-28	2	8214
657	41	1125315	1984-11-04	1984-11-18	1	5435
46442	3157	1177480	2011-12-09	2011-12-23	1	15331
48351	3285	1309944	2011-03-12	2011-03-12	1	15045
2818	187	1102527	2012-04-15	2012-04-15	1	15445
43157	2919	1125315	1951-11-10	1951-11-17	1	-6620
1310	90	1729720	1963-02-13	1963-02-20	1	-2507
927	63	1174888	1973-12-05	1973-12-05	1	1434
43886	2965	1125315	1987-09-06	1987-09-06	1	6457
43225	2925	1177480	2015-03-12	2015-05-18	1	16573
985	66	1125315	2000-09-27	2000-10-04	1	11234
51133	3483	1102527	1978-02-26	1978-02-26	1	2978
184	11	1713332	1970-07-28	1970-08-04	1	215
47044	3191	1728416	1960-04-13	1960-04-27	1	-3536
1487	99	19127890	1976-09-30	1977-09-25	1	2824
45693	3103	1119510	1984-10-08	1984-10-22	1	5408
49891	3399	19127890	2000-01-19	2001-01-13	1	11335
39219	2666	1112807	1971-11-21	1971-12-12	1	710
1817	120	1177480	2016-03-30	2016-04-13	1	16904
1093	74	1729720	1979-04-16	1979-04-27	1	3403
47802	3244	1549786	1991-03-25	1993-03-14	2	8473
1960	129	1759842	2010-08-30	2010-10-04	1	14886
42175	2859	1125315	1948-06-02	1948-06-09	1	-7876
157	9	1125315	1982-04-30	1982-05-14	1	4516
1228	84	1729720	1982-07-13	1982-07-26	1	4589
5	1	1768849	1980-03-15	1980-03-29	1	3740
2712	181	1728416	1975-02-08	1975-02-22	1	1878
45787	3109	1112807	1925-02-05	1925-02-19	1	-16387
1923	126	1713332	1989-05-26	1989-06-09	1	7099
44689	3028	1112807	1964-08-24	1964-09-07	1	-1942
769	49	1125315	1978-03-10	1978-03-24	1	3004
70146	4792	1125315	1988-01-01	1988-01-31	1	6604
47865	3248	1119510	2004-02-29	2004-03-07	1	12484
530	35	1759842	1973-02-07	1973-02-21	1	1147
40501	2752	1729720	2008-06-09	2008-06-20	1	14050
75602	5174	1119510	1978-11-19	1978-11-26	1	3251
49634	3382	1729720	2013-05-02	2013-05-13	1	15838
2406	160	1119510	1990-01-13	1990-01-27	1	7331
40919	2777	1125315	1988-12-27	1989-01-24	1	6963
89	5	1729720	1980-08-05	1980-08-18	1	3882
677	42	738818	1985-02-03	1985-02-17	1	5526
46465	3158	1112807	1963-04-14	1963-04-28	1	-2440
2231	149	1125315	1999-03-29	1999-04-05	1	10686
47585	3231	1125315	1996-07-01	1996-07-08	1	9685
291	18	1125315	1995-06-25	1995-09-23	2	9396
45606	3096	1125315	1997-08-27	1997-09-03	1	10107
2884	191	1125315	1939-03-31	1939-03-31	1	-11234
40254	2736	1728416	1974-06-24	1974-07-08	1	1649
52689	3589	1713332	1983-02-17	1983-03-03	1	4809
1862	123	1112807	1962-07-08	1962-09-13	1	-2667
422	30	1125315	2018-04-23	2018-04-30	1	17651
31076	2100	1112807	1976-06-03	1976-07-10	1	2382
1201	81	1713332	1986-05-21	1986-06-11	1	6005
43070	2913	1713332	1957-11-05	1957-12-03	1	-4412
800	53	1112807	1967-09-16	1967-09-30	1	-824
44906	3049	1539403	1991-05-31	1991-05-31	1	7820
3685	248	1125315	1990-12-21	1990-12-28	1	7666
46784	3176	1153428	2001-12-23	2001-12-23	1	11679
658	41	1129625	1977-06-15	1977-06-15	1	2722
46443	3157	1728416	1955-07-01	1955-07-15	1	-5284
48352	3285	1343916	2011-03-12	2011-03-12	1	15045
2819	187	1112807	1947-09-28	1947-10-11	1	-8118
43158	2919	1125315	1981-01-14	1981-01-21	1	4038
1311	90	19127890	1981-01-17	1982-01-12	1	4394
928	63	1112807	1956-10-10	1956-10-24	1	-4817
43887	2965	1515774	1990-01-19	1991-01-14	1	7683
43226	2925	1521369	1975-12-27	1977-12-16	2	2906
986	66	1177480	1981-03-10	1981-03-31	1	4107
51134	3483	1112807	1953-11-20	1953-12-04	1	-5872
185	11	1112807	1966-08-24	1966-09-23	1	-1196
47045	3191	1759842	2017-10-26	2017-11-16	1	17486
1488	99	1112807	1959-08-21	1959-09-18	1	-3758
45694	3103	1125315	2011-01-23	2011-02-06	1	15011
49892	3399	738818	1987-01-18	1987-01-25	1	6233
39220	2666	1728416	1954-10-27	1954-11-10	1	-5531
1818	120	1729720	1981-08-22	1981-09-01	1	4261
1094	74	1759842	1998-04-14	1998-05-05	1	10351
47803	3244	1549786	1994-03-09	1995-03-04	1	9193
1961	129	1729720	1986-10-07	1986-10-18	1	6134
42176	2859	1125315	1969-08-22	1969-11-20	1	-42
158	9	1125315	2003-02-23	2003-03-09	1	12120
1229	84	1119510	1976-07-02	1976-07-16	1	2388
6	1	1125315	1971-01-04	1971-01-18	1	382
2713	181	1119510	1984-09-19	1984-10-03	1	5389
45788	3109	1112807	1956-12-03	1956-12-24	1	-4756
1924	126	1759842	1989-05-26	1989-06-09	1	7099
44690	3028	1310149	2007-05-17	2007-05-17	1	13650
770	49	1125315	1983-04-09	1983-05-07	1	4874
70147	4792	1125315	1990-09-17	1990-10-22	1	7599
47866	3248	1125315	1986-11-06	1986-11-20	1	6167
531	35	920293	1997-04-22	1997-04-29	1	9980
40502	2752	738818	1956-07-14	1956-07-21	1	-4912
75603	5174	1125315	1954-09-29	1954-10-13	1	-5559
49635	3382	1112807	1965-12-17	1966-01-07	1	-1455
2407	160	1125315	2003-06-06	2003-06-13	1	12216
40920	2777	1125315	2015-10-20	2015-11-09	1	16748
90	5	1125315	2012-10-16	2012-10-23	1	15636
678	42	1112807	1930-10-04	1931-01-02	1	-14244
46466	3158	1112807	1967-04-07	1967-05-12	1	-965
2232	149	1118084	1982-10-23	1982-10-23	1	4678
47586	3231	1125315	1996-08-09	1996-08-16	1	9724
292	18	1125315	2016-01-06	2016-02-03	1	16834
45607	3096	1307863	2011-10-02	2011-10-02	1	15249
2885	191	1125315	1968-09-30	1968-10-07	1	-451
40582	2758	738818	2012-02-07	2012-02-21	1	15391
54373	3699	1713332	2007-11-01	2007-11-15	1	13832
1863	123	1118084	1986-03-24	1986-03-24	1	5926
423	30	1503184	1984-08-11	1985-08-06	1	5696
31077	2100	1713332	1955-02-27	1955-03-06	1	-5415
1202	81	1759842	1983-02-16	1983-03-02	1	4808
43071	2913	1759842	1949-05-16	1949-05-23	1	-7528
801	53	1124300	1999-12-24	1999-12-24	1	10949
44907	3049	1125315	1997-10-14	1997-10-28	1	10162
3686	248	1125315	2009-05-19	2009-06-18	1	14413
46785	3176	1515774	1989-11-09	1990-11-04	1	7612
659	41	1149380	1975-06-02	1975-06-02	1	1978
46444	3157	738818	1984-06-17	1984-07-01	1	5295
48980	3334	1112807	1946-10-20	1947-01-18	1	-8384
2820	187	1125315	1980-01-09	1980-01-30	1	3681
43159	2919	1177480	2018-03-21	2018-05-20	1	17671
1312	90	1125315	1965-10-28	1965-12-02	1	-1491
929	63	1112807	1966-03-12	1966-04-16	1	-1356
43888	2965	1521369	1985-02-14	1986-02-09	1	5883
43227	2925	1521369	1979-12-06	1981-11-25	2	4346
987	66	1115008	2016-02-26	2016-03-27	1	16887
51135	3483	1112807	1970-05-09	1970-07-08	1	188
186	11	1177480	1998-04-02	1998-07-01	1	10408
47046	3191	1124300	1998-08-02	1998-08-02	1	10440
1489	99	1112807	1960-10-12	1960-11-02	1	-3347
45695	3103	1503184	1995-05-22	1996-05-16	1	9632
49893	3399	1125315	1987-01-18	1987-01-25	1	6233
39221	2666	1119510	1955-07-25	1955-08-01	1	-5267
1819	120	1125315	1978-06-06	1978-06-20	1	3092
1095	74	19127890	1986-01-01	1989-12-11	4	7284
47804	3244	1112807	1980-04-02	1980-04-23	1	3765
1962	129	1112807	1975-08-03	1975-08-17	1	2054
42177	2859	1125315	1992-05-23	1992-06-13	1	8199
159	9	1129625	1979-01-30	1979-01-30	1	3316
1230	84	1125315	1995-08-01	1995-08-15	1	9357
7	1	1125315	1978-06-22	1978-06-22	1	3094
2714	181	1125315	1975-02-08	1975-02-22	1	1878
45789	3109	1347450	1990-02-21	1990-02-21	1	7356
1925	126	1112807	1950-11-23	1950-12-07	1	-6965
44691	3028	1713332	1974-12-07	1974-12-28	1	1822
771	49	1125315	1997-05-30	1997-06-13	1	10025
70148	4792	1125315	2013-11-10	2013-11-17	1	16026
47867	3248	1125315	2014-10-14	2014-10-14	1	16357
532	35	1125315	1960-06-20	1960-07-04	1	-3468
40503	2752	1125315	1956-07-14	1956-07-21	1	-4912
75604	5174	1125315	2010-08-20	2010-09-03	1	14855
49636	3382	1112807	1992-04-20	1992-05-20	1	8175
2408	160	1125315	2016-08-05	2016-09-04	2	17048
40921	2777	1177480	1993-10-01	1993-10-31	1	8704
91	5	1102527	1990-04-07	1990-04-07	1	7401
679	42	1125315	1937-09-07	1937-09-14	1	-11797
46467	3158	1124300	1990-02-06	1990-02-06	1	7341
2233	149	1125315	1960-02-21	1960-03-06	1	-3588
47587	3231	1759842	2012-02-04	2012-02-25	1	15395
293	18	1521369	1979-11-14	1980-11-08	1	3964
45608	3096	1326303	2011-10-02	2011-10-02	1	15249
2886	191	1125315	1983-10-06	1983-10-27	1	5047
40583	2758	1125315	1950-09-24	1950-10-08	1	-7025
54374	3699	1118084	2014-01-15	2014-01-15	1	16085
1864	123	1125315	1972-02-13	1972-02-20	1	780
424	30	1503184	1986-08-01	1987-07-27	1	6416
31078	2100	1728416	1945-01-12	1945-01-26	1	-9106
2848	189	1118084	1992-03-18	1992-03-18	1	8112
43769	2957	1118084	1985-05-14	1985-05-14	1	5612
802	53	1125315	1962-12-13	1962-12-27	1	-2562
44908	3049	1309944	1991-07-12	1991-07-12	1	7862
3687	248	1177480	1990-04-29	1990-07-28	1	7513
46786	3176	1515774	1991-10-30	1992-10-24	1	8332
660	41	1551099	1976-02-10	1976-02-10	1	2231
46445	3157	1115008	2000-08-17	2000-09-07	1	11207
48981	3334	1112807	1951-01-27	1951-02-10	1	-6900
2821	187	1713332	1987-09-06	1987-09-27	1	6478
43160	2919	1539403	2017-12-16	2017-12-16	1	17516
1313	90	1125315	1978-08-26	1978-09-30	1	3194
930	63	1713332	1995-11-20	1995-11-27	1	9461
43889	2965	1115008	2012-05-27	2012-06-24	1	15515
43228	2925	1521369	1982-11-20	1983-11-15	1	5066
988	66	1119510	1972-04-16	1972-04-30	1	850
51136	3483	1125315	1978-02-26	1978-03-19	1	2999
187	11	1713332	1974-01-21	1974-01-28	1	1488
47047	3191	1177480	1976-08-31	1976-09-21	1	2455
1490	99	1119510	2015-03-28	2015-04-04	1	16529
45696	3103	1515774	1992-06-06	1993-06-01	1	8552
49894	3399	1521369	2000-01-19	2001-01-13	1	11335
39222	2666	1759842	1958-02-01	1958-02-15	1	-4338
1820	120	1177480	1978-12-15	1978-12-29	1	3284
1096	74	1125315	2017-08-20	2017-09-03	1	17412
47805	3244	1150836	1991-05-02	1991-05-02	1	7791
1963	129	1112807	1989-02-11	1989-03-04	1	7002
42178	2859	1713332	1964-09-22	1964-09-29	1	-1920
160	9	1515774	1994-07-06	1995-07-01	1	9312
1231	84	1177480	1975-04-08	1975-04-22	1	1937
8	1	1361711	2006-03-09	2006-03-09	1	13216
2715	181	1521369	1988-09-07	1990-08-28	2	7544
45790	3109	1759842	1979-02-13	1979-02-20	1	3337
1926	126	1125315	1978-11-07	1978-11-14	1	3239
44692	3028	1759842	1981-01-02	1981-01-23	1	4040
772	49	1177480	1992-12-15	1992-12-29	1	8398
70149	4792	1503184	1974-01-28	1975-01-23	1	1848
47868	3248	19003953	2016-06-26	2016-06-26	1	16978
533	35	1174888	1984-05-15	1984-05-15	1	5248
40504	2752	1501700	2004-03-04	2004-03-04	1	12481
75692	5184	1125315	1990-08-07	1990-09-11	1	7558
49637	3382	1118084	2003-08-29	2003-08-29	1	12293
2409	160	1521369	1975-07-24	1977-07-13	2	2750
40922	2777	1177480	1999-05-03	1999-05-17	1	10728
92	5	1112807	1990-03-31	1990-06-06	1	7461
680	42	1125315	1953-06-19	1953-07-03	1	-6026
46468	3158	1125315	1974-05-03	1974-05-17	1	1597
2234	149	1729720	1943-11-08	1943-11-21	1	-9538
47588	3231	1118084	1980-01-01	1980-01-01	1	3652
294	18	1174888	1995-06-25	1995-06-25	1	9306
45609	3096	1521369	1977-12-18	1979-12-08	2	3628
2887	191	1125315	2000-06-04	2000-06-25	1	11133
40584	2758	1713332	2006-01-14	2006-01-28	1	13176
54375	3699	1713332	1988-03-26	1988-04-16	1	6680
1865	123	1361711	2006-08-23	2006-08-23	1	13383
425	30	1551099	1971-02-11	1971-02-11	1	406
31079	2100	1729720	1945-10-27	1945-11-05	1	-8823
2849	189	1717327	1961-11-05	1961-11-19	1	-2965
43770	2957	1125315	2017-08-15	2017-09-14	1	17423
803	53	1177480	1974-05-05	1974-06-04	1	1615
44909	3049	1343916	1991-07-12	1991-07-12	1	7862
3688	248	1759842	1998-12-28	1999-01-18	1	10609
46787	3176	1728416	1976-05-28	1976-06-11	1	2353
661	41	1729720	1983-01-01	1983-01-11	1	4758
46446	3157	1124300	1986-05-12	1986-05-12	1	5975
48982	3334	1118084	1981-08-07	1981-08-07	1	4236
2822	187	1759842	1987-09-06	1987-09-27	1	6478
43161	2919	1759842	1958-12-29	1959-01-19	1	-4000
1314	90	1521369	1981-01-17	1982-01-12	1	4394
931	63	1759842	1962-07-17	1962-08-07	1	-2704
43890	2965	1118084	2003-09-03	2003-09-03	1	12298
43229	2925	1713332	1981-09-11	1981-09-25	1	4285
989	66	1713332	1988-12-17	1988-12-24	1	6932
51137	3483	1125315	2015-06-04	2015-06-18	1	16604
188	11	1759842	1970-07-28	1970-08-04	1	215
47048	3191	1759842	1995-04-30	1995-05-14	1	9264
1491	99	1503184	1976-09-30	1977-09-25	1	2824
45697	3103	1112807	1978-11-06	1978-11-20	1	3245
49895	3399	1713332	2005-02-08	2005-02-15	1	12829
39223	2666	1125315	2007-06-11	2007-06-18	1	13682
1821	120	1728416	1978-06-06	1978-06-20	1	3092
1097	74	1503184	1986-01-01	1989-12-11	4	7284
47806	3244	19127890	1991-03-25	1993-03-14	2	8473
1964	129	1713332	2010-08-30	2010-10-04	1	14886
42179	2859	1728416	1945-01-15	1945-01-29	1	-9103
161	9	1729720	1987-08-13	1987-08-24	1	6444
1232	84	1717327	1975-04-08	1975-04-22	1	1937
9	1	1713332	2012-02-14	2012-02-28	1	15398
2716	181	920293	1996-10-09	1996-10-16	1	9785
45791	3109	1759842	1985-03-24	1985-07-14	1	5673
1927	126	1759842	1976-04-29	1976-05-06	1	2317
44693	3028	1125315	2010-05-27	2010-06-03	1	14763
773	49	1713332	1994-08-29	1994-09-19	1	9027
70150	4792	1729720	1951-06-17	1951-06-25	1	-6765
47869	3248	738818	2004-02-29	2004-03-07	1	12484
534	35	933724	1997-04-22	1997-04-29	1	9980
40505	2752	1728416	1952-06-10	1952-06-24	1	-6400
75693	5184	1305058	2017-06-06	2017-06-06	1	17323
49638	3382	1119510	1978-11-01	1978-11-08	1	3233
2410	160	1729720	1961-10-28	1961-11-08	1	-2976
40923	2777	1713332	1975-04-27	1975-05-11	1	1956
93	5	1119510	2015-08-10	2015-08-17	1	16664
681	42	1125315	1938-11-10	1938-11-24	1	-11361
46469	3158	1125315	1977-04-01	1977-06-30	1	2737
2235	149	1112807	1958-07-21	1958-08-11	1	-4161
47589	3231	1125315	2001-05-30	2001-06-13	1	11486
295	18	1713332	1974-06-13	1974-06-20	1	1631
45610	3096	1112807	1968-09-26	1968-12-25	1	-372
2888	191	1759842	1997-10-13	1997-10-20	1	10154
40585	2758	1112807	1940-08-28	1940-09-11	1	-10704
54376	3699	1759842	1988-03-26	1988-04-16	1	6680
1866	123	1539403	2006-08-23	2006-08-23	1	13383
426	30	1112807	1972-07-05	1972-07-26	1	937
31080	2100	1759842	1982-09-11	1982-09-18	1	4643
2850	189	1759842	1997-09-20	1997-10-11	1	10145
43771	2957	1713332	1989-08-13	1989-08-20	1	7171
804	53	1728416	1962-12-13	1962-12-27	1	-2562
44910	3049	1361711	1980-03-28	1986-12-05	1	6182
3689	248	738818	1984-01-18	1984-01-25	1	5137
46788	3176	1729720	1984-02-01	1984-02-10	1	5153
662	41	1125315	1978-05-30	1978-06-13	1	3085
46447	3157	1124957	1964-07-29	1964-07-29	1	-1982
48983	3334	1729720	1959-12-13	1959-12-22	1	-3663
2823	187	1112807	1947-04-13	1947-04-28	1	-8284
43162	2919	1119510	1981-01-14	1981-01-21	1	4038
1315	90	1713332	1965-01-21	1965-02-18	1	-1778
932	63	1759842	1995-11-20	1995-11-27	1	9461
43891	2965	1125315	1971-04-30	1971-05-14	1	498
43230	2925	1729720	1973-12-09	1973-12-18	1	1447
990	66	1738521	1975-09-26	1975-10-10	1	2108
51138	3483	1177480	2018-07-22	2018-08-26	1	17769
189	11	1112807	1960-06-26	1960-07-10	1	-3462
47049	3191	1759842	2001-02-28	2001-03-07	1	11388
1492	99	1729720	1967-10-11	1967-10-19	1	-805
45698	3103	1124300	2019-01-20	2019-01-20	1	17916
49896	3399	1115008	2019-01-29	2019-02-19	1	17946
39224	2666	1713332	1958-02-01	1958-02-15	1	-4338
1822	120	1738521	1978-12-15	1978-12-29	1	3284
1098	74	1549786	1990-12-06	1991-12-01	1	8004
47807	3244	933724	2013-05-13	2013-05-27	1	15852
4274	292	1118084	2017-01-16	2017-01-16	1	17182
42180	2859	1729720	1951-09-27	1951-10-04	1	-6664
162	9	19127890	1996-06-25	1997-06-20	1	10032
1233	84	1729720	1974-05-16	1974-05-26	1	1606
10	1	1729720	1953-02-06	1953-02-16	1	-6163
2717	181	933724	1996-10-09	1996-10-16	1	9785
48079	3263	1118084	1985-01-27	1985-01-27	1	5505
1928	126	1112807	1985-08-30	1985-10-04	1	5755
44694	3028	1759842	1974-12-07	1974-12-28	1	1822
774	49	1759842	1994-08-29	1994-09-19	1	9027
70151	4792	1119510	2000-12-10	2000-12-17	1	11308
47870	3248	753626	2016-06-26	2016-06-26	1	16978
535	35	1112807	1993-04-28	1993-05-28	1	8548
40506	2752	1112807	1960-01-14	1960-01-28	1	-3626
75694	5184	1759842	1973-08-04	1973-08-25	1	1332
49639	3382	1124957	1992-04-20	1992-04-20	1	8145
2411	160	1729720	2016-09-06	2016-09-19	1	17063
40924	2777	1713332	2014-12-10	2014-12-31	1	16435
94	5	1125315	1974-05-11	1974-05-18	1	1598
682	42	1125315	1980-06-21	1980-06-28	1	3831
46470	3158	1729720	1949-12-24	1949-12-31	1	-7306
2236	149	1119510	1975-05-25	1975-06-01	1	1977
47590	3231	1125315	2005-01-29	2005-02-12	1	12826
296	18	1729720	1979-05-24	1979-06-01	1	3438
45611	3096	1124957	2011-01-14	2011-01-14	1	14988
2889	191	1778162	2000-06-04	2000-06-25	1	11133
40586	2758	1118084	1980-06-09	1980-06-09	1	3812
54377	3699	1125315	1976-10-16	1976-10-30	1	2494
1867	123	1728416	1956-01-11	1956-01-25	1	-5090
427	30	1125315	1980-06-14	1980-07-05	1	3838
31081	2100	1112807	1945-01-12	1945-01-26	1	-9106
2851	189	1125315	1959-04-06	1959-04-20	1	-3909
43772	2957	1713332	1996-11-09	1996-11-23	1	9823
805	53	1125315	1976-01-25	1976-02-29	1	2250
44911	3049	1361711	1987-05-08	1987-05-08	1	6336
3690	248	1125315	1984-01-18	1984-01-25	1	5137
46789	3176	19127890	1994-10-14	1995-10-09	1	9412
663	41	1125315	1999-07-05	1999-07-19	1	10791
46448	3157	1728416	1952-12-31	1953-01-14	1	-6196
48984	3334	1729720	2019-04-27	2019-05-07	1	18023
2824	187	1112807	1948-04-07	1948-05-08	1	-7908
43163	2919	1125315	2007-11-03	2007-11-10	1	13827
1316	90	1713332	2017-04-18	2017-05-09	1	17295
933	63	1112807	1956-12-08	1956-12-29	1	-4751
43892	2965	1177480	1978-03-13	1978-03-27	1	3007
43231	2925	1729720	1999-11-05	1999-11-13	1	10908
991	66	1759842	1988-12-17	1988-12-24	1	6932
51139	3483	1759842	1970-05-05	1970-05-26	1	145
190	11	1112807	1989-09-22	1989-10-13	1	7225
47050	3191	1119510	1992-05-26	1992-06-09	1	8195
1493	99	1759842	1976-09-30	1976-10-14	1	2478
45699	3103	1125315	2015-06-19	2015-06-26	1	16612
49897	3399	1118084	2016-08-13	2016-08-13	1	17026
44338	3001	1112807	1970-07-13	1970-08-10	1	221
1823	120	1112807	1992-11-10	1993-02-08	1	8439
1099	74	1729720	1978-03-07	1978-03-18	1	2998
47808	3244	1125315	1974-04-13	1974-05-04	1	1584
4275	292	1738521	1978-07-30	1978-08-13	1	3146
42181	2859	1713332	1955-02-16	1955-03-09	1	-5412
163	9	1154343	1982-07-26	1982-07-26	1	4589
1234	84	738818	1976-07-02	1976-07-16	1	2388
11	1	1759842	2012-02-14	2012-02-28	1	15398
2718	181	1503184	1988-09-07	1990-08-28	2	7544
48080	3263	1125315	1962-04-23	1962-05-07	1	-2796
1929	126	1713332	1976-04-29	1976-05-06	1	2317
45290	3074	738818	1972-09-28	1972-10-12	1	1015
775	49	1112807	1976-11-13	1976-11-27	1	2522
70152	4792	1125315	2000-12-10	2000-12-17	1	11308
47871	3248	967823	2016-06-26	2016-06-26	1	16978
536	35	1125315	1964-07-10	1964-07-24	1	-1987
40507	2752	1119510	1956-07-14	1956-07-21	1	-4912
75695	5184	19127890	1980-06-05	1981-05-31	1	4168
49640	3382	1125315	1962-05-18	1962-05-25	1	-2778
2412	160	738818	1980-01-14	1980-01-28	1	3679
40925	2777	1713332	2016-07-31	2016-08-07	1	17020
95	5	1177480	2012-10-08	2012-12-07	1	15681
683	42	1125315	1999-11-17	1999-11-24	1	10919
46471	3158	738818	1950-11-20	1950-11-27	1	-6975
2237	149	1125315	2011-09-15	2011-09-29	1	15246
47591	3231	1713332	2012-04-01	2012-04-08	1	15438
297	18	19127890	1979-11-14	1980-11-08	1	3964
45612	3096	1125315	1979-08-30	1979-11-28	1	3618
2890	191	933724	1958-06-19	1958-06-26	1	-4207
40587	2758	1125315	1996-01-08	1996-01-22	1	9517
54378	3699	1177480	1994-10-12	1994-11-02	1	9071
1868	123	1729720	1960-10-20	1960-11-01	1	-3348
428	30	1521369	1984-08-11	1985-08-06	1	5696
31082	2100	1112807	1960-06-22	1960-07-27	1	-3445
2852	189	1125315	1984-11-20	1984-12-11	1	5458
43773	2957	1759842	1999-01-20	1999-02-03	1	10625
806	53	1729720	1967-11-29	1967-12-09	1	-754
44912	3049	914335	1991-07-12	1991-07-12	1	7862
3691	248	1713332	1998-12-28	1999-01-18	1	10609
48739	3314	738818	2008-12-21	2009-01-04	1	14248
664	41	738818	1989-09-24	1989-10-08	1	7220
46449	3157	1729720	1965-12-20	1965-12-28	1	-1465
48985	3334	1728416	1951-01-27	1951-02-10	1	-6900
2825	187	1112807	1957-04-20	1957-05-05	1	-4624
43164	2919	1322184	2017-12-16	2017-12-16	1	17516
1317	90	1717327	1963-05-12	1963-05-26	1	-2412
934	63	1112807	1978-03-31	1978-04-14	1	3025
43893	2965	1549786	1990-01-19	1991-01-14	1	7683
43232	2925	1125315	1980-09-06	1980-09-20	1	3915
992	66	1112807	1959-04-23	1959-05-14	1	-3885
51140	3483	1115008	1996-11-09	1996-12-14	1	9844
191	11	1115008	1996-04-14	1996-05-12	1	9628
47051	3191	1125315	1993-05-07	1993-05-14	1	8534
1494	99	738818	2015-03-28	2015-04-04	1	16529
45700	3103	1177480	1983-03-15	1983-04-05	1	4842
49898	3399	1503184	2000-01-19	2001-01-13	1	11335
44339	3001	1125315	1986-09-06	1986-09-27	1	6113
1824	120	1124300	2017-03-18	2017-03-18	1	17243
1100	74	1778162	2017-08-20	2017-09-03	1	17412
47809	3244	1503184	1995-03-04	1996-02-27	1	9553
4276	292	1177480	1978-07-30	1978-08-13	1	3146
42997	2909	1119510	1972-03-13	1972-03-20	1	809
164	9	1177480	2011-01-10	2011-01-31	1	15005
1235	84	1125315	1976-07-02	1976-07-16	1	2388
12	1	1112807	1981-08-10	1981-09-16	1	4276
2719	181	1759842	1997-03-22	1997-03-29	1	9949
48081	3263	1177480	2011-06-03	2011-06-24	1	15149
1930	126	1728416	1950-04-06	1950-04-20	1	-7196
45291	3074	1125315	1968-04-07	1968-04-21	1	-620
776	49	1112807	1980-02-26	1980-05-26	1	3798
70153	4792	1521369	1974-01-28	1975-01-23	1	1848
47872	3248	1112807	1961-05-04	1961-06-08	1	-3129
537	35	1125315	1984-05-15	1984-06-14	2	5278
40508	2752	1119510	1964-12-08	1964-12-15	1	-1843
75696	5184	1115008	2017-06-06	2017-06-06	1	17323
49641	3382	1125315	1963-12-07	1963-12-28	1	-2196
2413	160	920293	1998-01-10	1998-01-17	1	10243
40926	2777	1759842	1988-06-28	1988-07-12	1	6767
96	5	738818	2003-09-10	2003-09-17	1	12312
684	42	1347450	1993-10-19	1993-10-19	1	8692
46472	3158	1112807	1964-05-22	1964-06-21	1	-2020
2238	149	1729720	1971-07-10	1971-07-17	1	562
47592	3231	1729720	1962-09-01	1962-09-11	1	-2669
298	18	1115008	1998-10-07	1999-01-05	1	10596
45613	3096	1521369	1986-11-01	1987-10-27	1	6508
2891	191	1112807	1929-09-12	1929-11-18	1	-14654
40588	2758	1310149	2005-11-18	2005-11-18	1	13105
54379	3699	1729720	1974-11-29	1974-12-10	1	1804
1869	123	1125315	1956-01-11	1956-01-25	1	-5090
429	30	1521369	1986-08-01	1987-07-27	1	6416
31083	2100	1115008	2009-09-15	2009-10-13	1	14530
2853	189	1177480	1992-06-02	1992-06-23	1	8209
43774	2957	1125315	1991-12-03	1991-12-10	1	8013
807	53	1112807	1965-05-01	1965-05-22	1	-1685
44913	3049	1115008	2017-06-20	2017-07-11	1	17358
3692	248	1778162	1995-09-21	1995-10-05	1	9408
48740	3314	920293	2009-10-11	2009-10-18	1	14535
665	41	1118084	2008-07-31	2008-07-31	1	14091
46450	3157	1112807	1952-12-31	1953-01-14	1	-6196
48986	3334	1115008	2017-09-12	2017-10-03	1	17442
2826	187	1115008	2012-04-15	2012-07-14	1	15535
43165	2919	1332418	2017-12-16	2017-12-16	1	17516
1318	90	1759842	1968-06-08	1968-06-29	1	-551
935	63	1115008	2008-02-19	2008-05-20	1	14019
43894	2965	1738521	1970-06-23	1970-07-07	1	187
43233	2925	1125315	1983-02-10	1983-02-17	1	4795
993	66	1112807	1979-03-30	1979-04-20	1	3396
51141	3483	1713332	2001-03-04	2001-03-11	1	11392
192	11	1124300	1987-06-15	1987-06-15	1	6374
47052	3191	1125315	1999-03-30	1999-05-04	1	10715
1495	99	1125315	1959-06-22	1959-07-06	1	-3832
45701	3103	1521369	1995-05-22	1996-05-16	1	9632
49899	3399	1519936	2003-01-03	2003-12-29	1	12415
44340	3001	1713332	1980-01-08	1980-01-15	1	3666
1825	120	1125315	2000-11-08	2000-11-22	1	11283
1101	74	19127890	1990-12-06	1991-12-01	1	8004
47810	3244	1515774	1994-03-09	1995-03-04	1	9193
4277	292	1125315	1985-01-26	1985-02-09	1	5518
42998	2909	1124300	1986-09-03	1986-09-03	1	6089
165	9	1515774	1996-06-25	1997-06-20	1	10032
1236	84	1118084	2014-03-29	2014-03-29	1	16158
13	1	1124957	1978-06-22	1978-06-22	1	3094
2957	195	1118084	1993-09-24	1993-09-24	1	8667
48082	3263	1309944	2007-09-11	2007-09-11	1	13767
1931	126	1728416	1950-11-23	1950-12-07	1	-6965
45292	3074	1125315	1971-07-19	1971-08-09	1	585
777	49	1125315	1978-09-12	1978-09-26	1	3190
70154	4792	738818	2000-12-10	2000-12-17	1	11308
47873	3248	1124957	2014-10-14	2014-10-14	1	16357
538	35	1728416	1960-06-20	1960-07-04	1	-3468
40509	2752	1125315	1969-03-02	1969-05-01	1	-245
75697	5184	1119510	1984-01-07	1984-01-21	1	5133
49642	3382	1729720	1968-07-28	1968-08-07	1	-512
2414	160	933724	1998-01-10	1998-01-17	1	10243
40927	2777	1112807	1969-07-13	1969-08-03	1	-151
97	5	738818	2012-02-10	2012-02-17	1	15387
685	42	1347450	1994-10-04	1994-10-04	1	9042
46473	3158	1125315	1950-11-20	1950-11-27	1	-6975
3400	227	1115008	2014-07-03	2014-07-31	1	16282
47593	3231	1759842	2012-04-01	2012-04-08	1	15438
299	18	1125315	1970-09-22	1970-10-06	1	278
45614	3096	1738521	1968-08-12	1968-08-26	1	-493
2892	191	1119510	1981-11-29	1981-12-06	1	4357
40589	2758	1729720	2012-05-21	2012-06-03	1	15494
54380	3699	1759842	2007-11-01	2007-11-15	1	13832
1870	123	1322184	2006-08-23	2006-08-23	1	13383
430	30	1115008	2002-05-11	2002-06-08	1	11846
31084	2100	1115008	2012-08-28	2012-11-26	1	15670
2854	189	705944	1972-05-07	1976-05-16	1	2327
43775	2957	1557272	2008-02-02	2008-02-02	1	13911
808	53	1174888	1988-02-26	1988-02-26	1	6630
44914	3049	1118084	2014-08-02	2014-08-02	1	16284
3693	248	738818	1981-02-16	1981-03-02	1	4078
48741	3314	920293	2015-11-29	2015-12-06	1	16775
666	41	1125315	1989-09-24	1989-10-08	1	7220
46451	3157	1112807	1966-09-17	1966-10-15	1	-1174
48987	3334	1713332	1955-04-12	1955-05-03	1	-5357
2827	187	1125315	2001-04-15	2001-05-13	1	11455
43166	2919	1729720	2007-12-09	2007-12-20	1	13867
1319	90	1759842	1970-06-28	1970-08-09	1	220
936	63	1118084	1992-07-28	1992-07-28	1	8244
43895	2965	19127890	1985-02-14	1986-02-09	1	5883
43234	2925	1503184	1979-12-06	1981-11-25	2	4346
994	66	1118084	1996-03-09	1996-03-09	1	9564
51142	3483	1759842	1956-03-07	1956-03-28	1	-5027
193	11	1125315	2008-02-20	2008-03-05	1	13943
47053	3191	1125315	2000-10-05	2000-10-12	1	11242
1496	99	1125315	1968-10-21	1968-11-20	1	-407
45702	3103	1549786	1992-06-06	1993-06-01	1	8552
49900	3399	1549786	2003-01-03	2003-12-29	1	12415
44341	3001	1713332	2016-11-25	2016-12-09	1	17144
2212	148	705944	1987-10-13	1996-10-20	1	9789
1102	74	19127890	1992-11-25	1993-11-20	1	8724
47811	3244	920293	2013-05-13	2013-05-27	2	15852
4278	292	1125315	1996-07-17	1996-07-31	1	9708
42999	2909	1125315	1990-07-15	1990-07-29	1	7514
166	9	1713332	1982-04-30	1982-05-14	1	4516
1237	84	1125315	1979-09-25	1979-10-09	1	3568
14	1	1177480	1978-06-22	1978-07-27	1	3129
2958	195	738818	1970-01-14	1970-01-21	1	20
48083	3263	1713332	1997-04-02	1997-04-16	1	9967
1932	126	1729720	1952-08-16	1952-08-25	1	-6338
45293	3074	1125315	1972-09-28	1972-10-12	1	1015
778	49	1713332	1992-12-15	1992-12-29	1	8398
70155	4792	1112807	1969-03-11	1969-04-10	1	-266
47874	3248	1125315	1968-09-29	1968-10-13	1	-445
539	35	1759842	1984-02-18	1984-02-25	1	5168
40510	2752	1177480	1982-10-20	1982-11-17	1	4703
75698	5184	1124300	2001-05-01	2001-05-01	1	11443
49643	3382	1729720	2014-07-10	2014-07-23	1	16274
2415	160	1112807	1964-03-13	1964-03-27	1	-2106
40928	2777	1119510	2000-08-30	2000-09-13	1	11213
98	5	1119510	2003-09-10	2003-09-17	1	12312
686	42	1713332	1980-08-10	1980-08-17	1	3881
46474	3158	1759842	1957-03-24	1957-04-07	1	-4652
3401	227	1118084	2009-11-01	2009-11-01	1	14549
47594	3231	1125315	1954-07-12	1954-07-26	1	-5638
300	18	1759842	1974-06-13	1974-06-20	1	1631
45615	3096	1759842	1987-10-12	1987-10-19	1	6500
2893	191	1124300	1960-04-07	1960-04-07	1	-3556
40590	2758	1112807	1943-12-02	1943-12-23	1	-9506
54381	3699	1308738	1999-07-08	1999-07-08	1	10780
1871	123	1332418	2006-08-23	2006-08-23	1	13383
431	30	1118084	2009-03-23	2009-03-23	1	14326
31085	2100	1125315	1954-07-12	1954-07-19	1	-5645
2855	189	738818	2003-07-16	2003-07-30	1	12263
43776	2957	1729720	1958-02-20	1958-03-01	1	-4324
809	53	1728416	1967-01-02	1967-01-16	1	-1081
44915	3049	1125315	1988-05-22	1988-06-05	1	6730
3694	248	1102527	1990-04-29	1990-04-29	1	7423
48742	3314	933724	2009-10-11	2009-10-18	1	14535
667	41	1125315	1999-03-22	1999-04-05	1	10686
46452	3157	1125315	1984-06-17	1984-07-01	1	5295
48988	3334	1115008	2001-10-31	2001-12-05	1	11661
2828	187	1759842	1962-04-07	1962-04-14	1	-2819
43746	2955	1125315	1980-04-21	1980-04-28	1	3770
1320	90	1759842	2017-04-18	2017-05-09	1	17295
937	63	1125315	1990-09-14	1990-09-21	1	7568
43896	2965	1124957	1987-09-06	1987-09-06	1	6457
43235	2925	1503184	1982-11-20	1983-11-15	1	5066
995	66	1177480	1975-09-26	1975-10-10	1	2108
51143	3483	1759842	2001-03-04	2001-03-11	1	11392
194	11	1347450	2002-05-28	2002-05-28	1	11835
47054	3191	1322184	2015-09-24	2015-09-24	1	16702
1497	99	1125315	2004-07-28	2004-08-18	1	12648
45703	3103	1713332	1982-05-04	1982-05-18	1	4520
52109	3549	1125315	1986-08-03	1986-08-17	1	6072
44342	3001	1728416	1951-06-27	1951-07-11	1	-6749
2213	148	1125315	1993-06-12	1993-08-11	2	8623
1103	74	920293	2004-01-30	2004-02-06	1	12454
47812	3244	975125	1991-04-24	1991-04-24	1	7783
4279	292	1125315	1988-07-07	1988-08-04	1	6790
43000	2909	1137529	1972-03-26	1972-03-26	1	815
167	9	1125315	1985-06-15	1985-06-29	1	5658
1238	84	1729720	1974-11-10	1974-11-21	1	1785
15	1	1322184	2006-03-09	2006-03-09	1	13216
2959	195	1125315	1961-09-27	1961-10-11	1	-3004
48084	3263	1729720	1985-04-23	1985-05-03	1	5601
4522	311	1115008	2004-08-24	2004-09-07	1	12668
45294	3074	1729720	1952-08-01	1952-08-11	1	-6352
779	49	1717327	1978-09-12	1978-09-26	1	3190
70156	4792	1118084	1988-10-27	1988-10-27	1	6874
47875	3248	1125315	2004-02-29	2004-03-07	1	12484
540	35	19127890	1978-03-03	1979-02-26	1	3343
40511	2752	1729720	1962-01-05	1962-01-12	1	-2911
75699	5184	1125315	2010-02-18	2010-03-04	1	14672
49644	3382	1112807	1963-02-10	1963-02-24	1	-2503
2416	160	1125315	1973-02-10	1973-02-17	1	1143
40929	2777	1125315	2004-05-02	2004-05-09	1	12547
99	5	1119510	2012-02-10	2012-02-17	1	15387
687	42	1713332	2008-02-22	2008-02-29	1	13938
46475	3158	1759842	2000-03-15	2000-04-05	1	11052
3402	227	1503184	1987-09-03	1988-08-28	1	6814
47595	3231	1125315	1966-04-16	1966-04-30	1	-1342
3750	254	1119510	1953-07-09	1953-07-16	1	-6013
45616	3096	1112807	1970-12-15	1971-02-13	1	408
2894	191	1124957	1939-03-31	1939-03-31	1	-11234
40591	2758	1326303	2005-11-18	2005-11-18	1	13105
54382	3699	1738521	1976-10-16	1976-10-30	1	2494
1872	123	1713332	1986-01-05	1986-01-26	1	5869
432	30	1125315	1974-11-09	1974-11-23	1	1787
31086	2100	1759842	1955-02-27	1955-03-06	1	-5415
2856	189	1112807	1970-01-08	1970-02-07	1	37
43777	2957	1759842	1950-09-04	1950-09-24	1	-7039
810	53	1759842	2001-05-31	2001-06-14	1	11487
44916	3049	1125315	1997-09-05	1997-09-12	1	10116
3695	248	1119510	1984-01-18	1984-01-25	1	5137
48743	3314	1112807	1976-08-25	1976-11-22	1	2517
668	41	1154343	1975-06-02	1975-06-02	1	1978
46453	3157	1713332	2011-12-09	2011-12-23	1	15331
48989	3334	1125315	1954-04-13	1954-04-27	1	-5728
2829	187	1118084	1984-11-29	1984-11-29	1	5446
43747	2955	1125315	1985-12-26	1986-01-09	1	5852
1321	90	1112807	1975-11-10	1975-12-10	1	2169
938	63	1125315	1994-05-03	1994-05-10	1	8895
43897	2965	1125315	1970-06-23	1970-07-07	1	187
43236	2925	1713332	2007-06-17	2007-07-22	1	13716
996	66	1713332	2017-05-31	2017-06-07	1	17324
51144	3483	1112807	1955-10-11	1955-10-25	1	-5182
195	11	1713332	1994-07-31	1994-08-14	1	8991
47055	3191	1713332	1999-12-16	1999-12-30	1	10955
1498	99	1125315	2015-03-28	2015-04-04	1	16529
45704	3103	1713332	2011-01-23	2011-02-06	1	15011
52110	3549	1713332	1963-09-27	1963-10-18	1	-2267
44343	3001	1728416	1952-06-27	1952-07-11	1	-6383
2214	148	1759842	1989-07-26	1989-08-09	1	7160
1104	74	1125315	2013-08-27	2013-09-10	1	15958
47813	3244	1125315	1985-09-14	1985-09-28	1	5749
4961	338	738818	2003-10-21	2003-11-04	1	12360
43001	2909	1713332	1992-02-08	1992-02-29	1	8094
168	9	1125315	1990-09-15	1990-09-29	1	7576
1239	84	1738521	1977-02-10	1977-02-24	1	2611
16	1	1332418	2006-03-09	2006-03-09	1	13216
2960	195	1125315	1970-01-14	1970-01-21	1	20
48085	3263	914335	2007-09-11	2007-09-11	1	13767
4523	311	1125315	1978-05-22	1978-06-12	1	3084
45295	3074	1112807	1953-12-20	1954-01-03	1	-5842
780	49	914335	2003-07-12	2003-07-12	1	12245
70157	4792	1125315	1962-10-30	1962-11-06	1	-2613
47876	3248	1310149	2007-03-30	2007-03-30	1	13602
541	35	738818	2007-02-25	2007-03-04	1	13576
40512	2752	738818	1964-12-08	1964-12-15	1	-1843
75700	5184	1713332	1973-08-04	1973-08-25	1	1332
49645	3382	1759842	1998-10-14	1998-10-28	1	10527
2417	160	1125315	1976-02-09	1976-03-08	1	2258
40930	2777	1759842	1975-04-27	1975-05-11	1	1956
100	5	1125315	2003-09-10	2003-09-17	1	12312
688	42	1759842	1980-08-10	1980-08-17	1	3881
46476	3158	1759842	2001-07-08	2001-07-15	1	11518
3403	227	1713332	1989-09-27	1989-10-11	1	7223
47596	3231	1713332	2010-03-19	2010-04-02	1	14701
3751	254	1119510	1962-10-29	1962-11-12	1	-2607
45617	3096	1124300	1997-07-31	1997-07-31	1	10073
2895	191	1149380	1990-09-25	1990-09-25	1	7572
40592	2758	1729720	1947-03-12	1947-03-25	1	-8318
55008	3743	1125315	1978-07-10	1978-07-24	1	3126
1873	123	1759842	1986-01-05	1986-01-26	1	5869
433	30	1129625	1973-09-04	1973-09-04	1	1342
31234	2114	1118084	2002-07-02	2002-07-02	1	11870
2857	189	1119510	2003-07-16	2003-07-30	1	12263
43778	2957	1759842	1953-08-15	1953-08-29	1	-5969
997	67	1125315	1976-01-04	1976-01-18	1	2208
44917	3049	1174888	1986-12-05	1986-12-05	1	6182
3696	248	1125315	1981-02-16	1981-03-02	1	4078
48744	3314	1119510	2008-12-21	2009-01-04	1	14248
669	41	1177480	1990-01-18	1990-02-22	1	7357
46454	3157	933724	2008-07-25	2008-08-01	1	14092
48990	3334	1759842	1955-04-12	1955-05-03	1	-5357
2830	187	1125315	1999-04-21	1999-05-26	1	10737
43748	2955	1125315	1998-01-10	1998-01-17	1	10243
1322	90	1125315	1980-09-19	1980-10-10	1	3935
939	63	1713332	1962-07-17	1962-08-07	1	-2704
43898	2965	1125315	1972-04-28	1972-05-12	1	862
43237	2925	19127890	1975-12-27	1977-12-16	2	2906
7056	487	1713332	1991-12-28	1992-01-11	1	8045
51145	3483	1119510	2006-06-25	2006-07-09	1	13338
196	11	1729720	1966-04-08	1966-04-19	1	-1353
47056	3191	1759842	1999-12-16	1999-12-30	1	10955
1499	99	1149380	1998-10-10	1998-10-10	1	10509
45705	3103	1713332	2018-10-07	2018-10-28	1	17832
52111	3549	1115008	2015-05-31	2015-06-21	1	16607
44344	3001	1759842	1952-11-06	1952-11-13	1	-6258
2215	148	1118084	2012-12-25	2012-12-25	1	15699
1105	74	1729720	1986-02-04	1986-02-11	1	5885
47814	3244	1125315	1996-09-10	1996-09-17	1	9756
4962	338	738818	2008-11-01	2008-11-15	1	14198
43002	2909	1729720	1997-02-08	1997-02-20	1	9912
169	9	1149380	1982-07-26	1982-07-26	1	4589
2743	184	738818	1983-12-02	1983-12-09	1	5090
17	1	1539403	2006-03-09	2006-03-09	1	13216
2961	195	1125315	1977-11-23	1977-12-28	1	2918
48086	3263	1119510	2011-02-15	2011-02-22	1	15027
4524	311	1125315	1987-09-23	1987-12-22	1	6564
45296	3074	1118084	1986-07-20	1986-07-20	1	6044
781	49	1124300	2009-06-13	2009-06-13	1	14408
70158	4792	1125315	1969-03-11	1969-03-11	1	-296
47877	3248	1367571	2016-06-26	2016-06-26	1	16978
542	35	1125315	1978-11-14	1978-11-28	1	3253
40513	2752	1112807	1954-04-01	1954-04-15	1	-5740
75701	5184	1125315	1965-05-15	1965-06-14	1	-1662
49646	3382	738818	1978-11-01	1978-11-08	1	3233
2418	160	1125315	2019-04-02	2019-04-16	1	18002
40931	2777	738818	2000-08-30	2000-09-13	1	11213
101	5	1125315	2012-02-10	2012-02-17	1	15387
689	42	1759842	2008-02-22	2008-02-29	1	13938
46477	3158	1112807	1971-09-18	1971-10-16	1	653
3404	227	1728416	1974-04-04	1974-04-18	1	1568
47597	3231	1713332	2012-02-04	2012-02-25	1	15395
3752	254	1713332	1993-03-08	1993-04-05	1	8495
45618	3096	1125315	2015-02-22	2015-03-15	1	16509
2896	191	1713332	1931-03-10	1931-03-17	1	-14170
40593	2758	1759842	2006-01-14	2006-01-28	1	13176
55009	3743	1125315	1981-11-22	1981-11-29	1	4350
1874	123	1125315	1952-02-03	1952-02-10	1	-6535
434	30	1717327	1974-11-09	1974-11-23	1	1787
31235	2114	1125315	1974-11-27	1974-12-18	1	1812
2858	189	1125315	1961-11-05	1961-11-19	1	-2965
43779	2957	920293	1978-08-01	1978-08-08	1	3141
998	67	1759842	2000-07-09	2000-07-23	1	11161
44918	3049	1322184	1997-09-12	1997-09-12	1	10116
3697	248	1125315	1995-09-21	1995-10-05	1	9408
48745	3314	1125315	1976-08-25	1976-08-25	1	2428
670	41	1728416	1978-05-30	1978-06-13	1	3085
46455	3157	1112807	1953-07-29	1953-08-26	1	-5972
50542	3440	1112807	1945-11-19	1945-12-03	1	-8795
2831	187	1728416	1947-09-28	1947-10-11	1	-8118
43749	2955	1125315	2015-05-19	2015-06-02	1	16588
1323	90	1503184	1981-01-17	1982-01-12	1	4394
940	63	1728416	1956-10-10	1956-10-24	1	-4817
43899	2965	1177480	1988-08-01	1988-08-31	1	6817
43238	2925	1112807	1963-10-22	1963-11-04	1	-2250
7057	487	1728416	1971-03-14	1971-03-28	1	451
51146	3483	1713332	1970-05-05	1970-05-26	1	145
197	11	1759842	1974-01-21	1974-01-28	1	1488
47057	3191	1112807	1960-04-13	1960-04-27	1	-3536
1500	99	1177480	2001-01-01	2001-01-15	1	11337
45706	3103	1759842	2018-10-07	2018-10-28	1	17832
52112	3549	1118084	1995-06-15	1995-06-15	1	9296
44345	3001	1112807	1956-11-27	1956-12-18	1	-4762
2216	148	1125315	2008-09-09	2008-09-23	1	14145
1106	74	1729720	1995-09-11	1995-09-19	1	9392
47815	3244	1343916	1991-05-02	1991-05-02	1	7791
4963	338	1112807	1969-02-07	1969-03-07	1	-300
43003	2909	19003953	1962-04-07	1962-04-07	1	-2826
170	9	1549786	1994-07-06	1995-07-01	1	9312
2744	184	1119510	1964-01-25	1964-02-08	1	-2154
18	1	1717327	1978-06-22	1978-07-27	1	3129
2962	195	1729720	1965-12-07	1965-12-16	1	-1477
48087	3263	1125315	2004-06-13	2004-06-20	1	12589
4525	311	1177480	2014-02-17	2014-03-03	1	16132
45297	3074	1125315	2005-09-30	2005-10-21	1	13077
782	49	1125315	1979-12-21	1980-01-04	1	3655
70159	4792	1125315	1996-10-09	1996-10-16	1	9785
47878	3248	1728416	1948-02-12	1948-02-26	1	-7980
543	35	1125315	2007-02-25	2007-03-04	1	13576
40514	2752	1125315	1964-12-08	1964-12-15	1	-1843
75702	5184	1521369	1980-06-05	1981-05-31	1	4168
49647	3382	1115008	2005-07-11	2005-08-01	1	12996
2419	160	1174888	2016-08-05	2016-08-05	1	17018
40932	2777	1124300	1999-11-07	1999-11-07	1	10902
1725	115	1125315	1978-05-23	1978-06-06	1	3078
690	42	1112807	1914-07-09	1914-07-23	1	-20251
46478	3158	1125315	1979-02-12	1979-02-26	1	3343
3405	227	1759842	2017-07-21	2017-07-28	1	17375
49689	3386	933724	2009-12-17	2009-12-24	1	14602
3753	254	1759842	1975-07-13	1975-08-03	1	2040
45619	3096	1177480	2011-01-14	2011-02-13	1	15018
2897	191	1759842	1931-03-10	1931-03-17	1	-14170
40594	2758	1112807	1941-12-21	1942-01-11	1	-10217
55010	3743	1521369	1993-07-31	1994-07-26	1	8972
1875	123	1125315	1962-07-15	1962-07-15	1	-2727
435	30	738818	2013-12-07	2013-12-14	1	16053
31236	2114	1125315	1990-04-18	1990-04-25	1	7419
2859	189	1125315	2003-07-16	2003-07-30	1	12263
43780	2957	933724	1978-08-01	1978-08-08	1	3141
999	67	1759842	2018-06-07	2018-06-21	1	17703
44919	3049	1332418	1994-11-25	1994-11-25	1	9094
3698	248	1177480	1982-11-07	1982-12-07	1	4723
48746	3314	1125315	2008-12-21	2009-01-04	1	14248
671	41	1759842	1977-10-21	1977-11-11	1	2871
46456	3157	1119510	1984-06-17	1984-07-01	1	5295
50543	3440	1112807	1960-12-14	1960-12-28	1	-3291
4173	286	1102527	1976-10-11	1976-10-11	1	2475
43750	2955	1177480	1974-03-05	1974-03-19	1	1538
1324	90	1713332	1968-06-08	1968-06-29	1	-551
941	63	1729720	1960-11-18	1960-11-30	1	-3319
43900	2965	1192710	1972-03-15	1972-03-15	1	804
43239	2925	1125315	2001-04-25	2001-05-09	1	11451
7058	487	1759842	1991-12-28	1992-01-11	1	8045
51147	3483	738818	2006-06-25	2006-07-09	1	13338
198	11	1759842	1994-07-31	1994-08-14	1	8991
47058	3191	1125315	1969-11-06	1970-01-05	1	4
1501	99	1521369	1976-09-30	1977-09-25	1	2824
45707	3103	738818	1984-10-08	1984-10-22	1	5408
52113	3549	1125315	2012-02-16	2012-02-16	1	15386
44346	3001	1124300	1981-12-26	1981-12-26	1	4377
2217	148	1174888	1993-06-12	1993-06-12	1	8563
1107	74	1125315	1973-09-28	1973-10-12	1	1380
47816	3244	1515774	1991-03-25	1993-03-14	2	8473
4964	338	1125315	2003-10-21	2003-11-04	1	12360
43004	2909	708298	1962-04-07	1962-04-07	1	-2826
171	9	1549786	1996-06-25	1997-06-20	1	10032
2745	184	1119510	2019-03-06	2019-03-13	1	17968
19	1	1125315	1958-03-11	1958-06-09	1	-4224
2963	195	1119510	1970-01-14	1970-01-21	1	20
48088	3263	1125315	2018-01-18	2018-02-17	1	17579
4526	311	1729720	1991-03-31	1991-04-07	1	7766
45298	3074	1115008	1998-11-15	1998-12-06	1	10566
783	49	1125315	2010-04-20	2010-05-04	1	14733
70160	4792	1174888	1969-03-11	1969-03-11	1	-296
47879	3248	1729720	1958-09-07	1958-09-18	1	-4123
544	35	1125315	2014-07-26	2014-08-02	1	16284
40515	2752	1125315	1967-03-22	1967-04-12	1	-995
75703	5184	1738521	1969-03-16	1969-03-30	1	-277
49648	3382	1125315	1992-04-20	1992-04-20	1	8145
2420	160	1729720	1998-05-31	1998-06-11	1	10388
40933	2777	1125315	1968-05-21	1968-05-28	1	-583
1726	115	1713332	1964-04-27	1964-05-18	1	-2054
691	42	1112807	1922-01-28	1922-02-18	1	-17484
46479	3158	1125315	1985-10-20	1985-11-03	1	5785
3406	227	1549786	1996-07-17	1997-07-12	1	10054
49690	3386	1713332	2006-07-18	2006-07-25	1	13354
3754	254	1125315	1988-05-28	1988-06-04	1	6729
45620	3096	1310149	2011-10-02	2011-10-02	1	15249
2898	191	715997	1997-10-14	1997-10-14	1	10148
40595	2758	1112807	1942-07-06	1942-07-20	1	-10027
55011	3743	1119510	1990-05-18	1990-05-25	1	7449
1876	123	1174888	1962-07-15	1962-07-15	1	-2727
436	30	920293	1999-09-05	1999-09-12	1	10846
31237	2114	1125315	1996-05-06	1996-05-13	1	9629
2860	189	1125315	2012-09-24	2012-10-08	1	15621
43781	2957	1119510	2007-01-10	2007-01-24	1	13537
1000	67	738818	1992-08-09	1992-08-23	1	8270
46177	3135	738818	1979-12-27	1980-01-03	1	3654
4383	299	1125315	2017-06-06	2017-06-20	1	17337
48747	3314	1125315	2019-01-18	2019-01-25	1	17921
1400	95	1112807	1962-04-05	1962-04-19	1	-2814
46457	3157	1125315	1964-07-29	1964-10-27	2	-1892
50544	3440	1112807	1973-04-24	1973-05-15	1	1230
4174	286	1119510	1934-05-22	1934-05-29	1	-13001
43751	2955	1759842	1978-08-16	1978-08-30	1	3163
1325	90	1713332	1970-06-28	1970-08-09	1	220
942	63	1738521	1978-03-31	1978-04-14	1	3025
43901	2965	1503184	1985-02-14	1986-02-09	1	5883
43240	2925	1503184	1975-12-27	1977-12-16	2	2906
7059	487	19127890	1981-05-12	1982-05-07	1	4509
51148	3483	1124300	1988-12-31	1988-12-31	1	6939
2163	145	920293	1983-04-03	1983-04-10	1	4847
47059	3191	1125315	2013-10-08	2013-10-15	1	15993
1502	99	1713332	1976-09-30	1976-10-14	1	2478
45708	3103	1125315	1984-10-08	1984-10-22	1	5408
52114	3549	1729720	1997-01-13	1997-01-23	1	9884
44347	3001	1125315	1998-12-27	1999-01-10	1	10601
2218	148	1515774	1997-09-15	1998-09-10	1	10479
1108	74	1125315	1977-07-07	1977-07-21	1	2758
47817	3244	19127890	1994-03-09	1996-02-27	2	9553
4965	338	1125315	2008-11-01	2008-11-15	1	14198
43005	2909	738818	1972-03-13	1972-03-20	1	809
172	9	1729720	1996-02-09	1996-02-17	1	9543
2746	184	1125315	1983-12-02	1983-12-09	1	5090
20	1	1125315	1976-10-20	1976-11-03	1	2498
2964	195	1177480	1997-08-15	1997-11-13	1	10178
48089	3263	1343916	2007-09-11	2007-09-11	1	13767
4527	311	1119510	1993-11-10	1993-11-17	1	8721
45299	3074	1119510	1972-09-28	1972-10-12	1	1015
784	49	1309944	2003-07-12	2003-07-12	1	12245
70161	4792	1125315	2017-04-03	2017-04-24	1	17280
47880	3248	1741122	2016-06-26	2016-06-26	1	16978
545	35	1503184	1978-03-03	1979-02-26	1	3343
40516	2752	1125315	1989-12-07	1989-12-14	1	7287
75704	5184	738818	1984-01-07	1984-01-21	1	5133
49649	3382	1177480	2018-06-24	2018-07-08	1	17720
2421	160	1119510	1980-01-14	1980-01-28	1	3679
40934	2777	1125315	1975-06-04	1975-06-11	1	1987
1727	115	920293	1975-11-28	1975-12-05	1	2164
692	42	1112807	1970-06-04	1970-07-04	1	184
46480	3158	1322184	2002-01-10	2002-01-10	1	11697
3407	227	1713332	2014-07-03	2014-07-31	1	16282
49691	3386	1738521	1974-11-14	1974-11-28	1	1792
3755	254	1347450	2006-05-05	2006-05-05	1	13273
45621	3096	1503184	1986-11-01	1987-10-27	1	6508
2899	191	738818	1957-10-12	1957-10-19	1	-4457
40596	2758	1119510	2012-02-07	2012-02-21	1	15391
55012	3743	1503184	1993-07-31	1994-07-26	1	8972
1877	123	1729720	1998-11-18	1998-11-25	1	10555
437	30	1112807	1975-06-11	1975-08-10	1	2047
31238	2114	1125315	2018-01-20	2018-02-10	1	17572
2861	189	1713332	1997-09-20	1997-10-11	1	10145
43782	2957	1125315	1949-06-24	1949-07-08	1	-7482
1001	67	1118084	2011-08-29	2011-08-29	1	15215
46178	3135	1125315	1990-09-08	1990-09-22	1	7569
4384	299	1137529	2014-12-27	2014-12-27	1	16431
48748	3314	705944	1969-09-06	1980-09-13	1	3908
1401	95	1125315	1968-12-29	1969-01-12	1	-354
46458	3157	1177480	2011-02-12	2011-03-05	1	15038
50545	3440	1112807	1978-02-18	1978-03-11	1	2991
4175	286	1124300	1970-08-08	1970-08-08	1	219
43752	2955	914335	2017-07-25	2017-07-25	1	17372
1326	90	1729720	1991-12-05	1991-12-12	1	8015
2507	165	738818	1983-05-26	1983-06-09	1	4907
46036	3125	738818	1967-08-20	1967-09-03	1	-851
43241	2925	1713332	2001-05-04	2001-05-18	1	11460
7060	487	1125315	1972-09-11	1972-09-25	1	998
51149	3483	1125315	1965-10-20	1965-10-27	1	-1527
2164	145	1125315	1984-04-12	1984-04-26	1	5229
47060	3191	1125315	2016-07-03	2016-07-17	1	16999
1503	99	1713332	1994-04-02	1994-04-16	1	8871
45709	3103	1322184	2018-05-16	2018-05-16	1	17667
52115	3549	1115008	2012-02-16	2012-03-17	1	15416
44348	3001	1112807	1958-10-09	1958-11-13	1	-4067
2219	148	1112807	1980-09-04	1980-09-18	1	3913
1109	74	1125315	1998-12-02	1998-12-16	1	10576
48415	3290	1115008	1997-12-06	1997-12-20	1	10215
4966	338	1192710	1971-05-09	1971-05-09	1	493
43006	2909	920293	1969-05-20	1969-05-27	1	-219
4501	310	1112807	1961-11-26	1962-02-24	1	-2868
2747	184	1125315	1991-03-24	1991-03-24	1	7752
21	1	1125315	1982-09-11	1982-10-02	1	4657
2965	195	1112807	1959-01-11	1959-02-01	1	-3987
48090	3263	738818	2011-02-15	2011-02-22	1	15027
4528	311	1124300	2011-10-06	2011-10-06	1	15253
45300	3074	1125315	2018-07-15	2018-07-29	1	17741
785	49	1343916	2003-07-12	2003-07-12	1	12245
70162	4792	19127890	1974-01-28	1975-01-23	1	1848
48152	3270	1125315	1976-02-23	1976-04-23	1	2304
546	35	1713332	1973-02-07	1973-02-21	1	1147
40517	2752	1125315	2010-04-15	2010-04-29	1	14728
75705	5184	1112807	1969-03-16	1969-03-30	1	-277
49650	3382	1728416	1963-02-10	1963-02-24	1	-2503
2422	160	1119510	2003-06-06	2003-06-13	1	12216
40935	2777	1125315	2000-08-30	2000-09-13	1	11213
1728	115	933724	1975-11-28	1975-12-05	1	2164
693	42	1118084	1950-05-16	1950-05-16	1	-7170
46481	3158	1713332	1957-03-24	1957-04-07	1	-4652
3408	227	19127890	1987-09-03	1988-08-28	1	6814
49692	3386	19127890	1988-10-27	1989-10-22	1	7234
3756	254	1713332	1975-07-13	1975-08-03	1	2040
45622	3096	1713332	2003-04-26	2003-05-17	1	12189
2900	191	738818	1981-11-29	1981-12-06	1	4357
40597	2758	1125315	1978-06-22	1978-07-06	1	3108
55013	3743	1713332	1992-10-19	1992-11-09	1	8348
3374	225	1125315	1971-09-28	1971-10-19	1	656
438	30	1119510	2013-12-07	2013-12-14	1	16053
31239	2114	1728416	1969-12-02	1969-12-16	1	-16
2862	189	1728416	1959-04-06	1959-04-20	1	-3909
43783	2957	1125315	1981-11-30	1981-12-14	1	4365
1002	67	1125315	1992-08-09	1992-08-23	1	8270
46179	3135	1125315	2011-08-19	2011-08-26	1	15212
4385	299	19127890	1975-12-06	1976-11-30	1	2525
48749	3314	933724	2015-11-29	2015-12-06	1	16775
1402	95	1125315	1979-02-24	1979-03-03	1	3348
46459	3157	1728416	1957-10-29	1957-11-12	1	-4433
50546	3440	1125315	1957-10-16	1957-10-23	1	-4453
4176	286	1125315	1973-07-19	1973-07-26	1	1302
43753	2955	1115008	2002-11-08	2002-11-22	1	12013
1327	90	1759842	1965-01-21	1965-02-18	1	-1778
2508	165	1118084	2006-10-21	2006-10-21	1	13442
46037	3125	1125315	1953-06-17	1953-07-08	1	-6021
43242	2925	1759842	1981-09-11	1981-09-25	1	4285
7061	487	1125315	1988-08-10	1988-08-24	1	6810
51150	3483	1125315	2006-06-25	2006-07-09	1	13338
2165	145	1154343	1952-12-06	1952-12-06	1	-6235
47061	3191	1177480	1995-04-15	1995-05-20	1	9270
1504	99	1728416	1959-06-22	1959-07-06	1	-3832
45710	3103	1347450	2018-05-16	2018-05-16	1	17667
52116	3549	1174888	2012-02-16	2012-02-16	1	15386
44349	3001	1125315	2013-02-02	2013-02-16	1	15752
2220	148	1177480	2000-08-09	2000-09-13	1	11213
1110	74	1125315	2012-07-01	2012-07-15	1	15536
48416	3290	1115008	2017-12-05	2017-12-19	1	17519
4967	338	1551099	1975-09-04	1975-09-04	1	2072
43007	2909	1110410	1962-04-07	1962-04-07	1	-2826
4502	310	1118084	1984-02-25	1984-02-25	1	5168
2748	184	1174888	1991-03-24	1991-03-24	1	7752
22	1	1759842	1967-05-30	1967-06-20	1	-926
2966	195	1125315	1974-04-01	1974-04-15	1	1565
48091	3263	1125315	2011-02-15	2011-02-22	1	15027
4529	311	1125315	1986-09-09	1986-09-16	1	6102
45301	3074	1347450	1993-11-10	1993-11-10	1	8714
786	49	1713332	2006-03-26	2006-04-16	1	13254
70469	4814	1112807	1953-09-28	1953-10-26	1	-5911
48153	3270	1738521	1974-11-30	1974-12-14	1	1808
547	35	1713332	1990-10-23	1990-11-06	1	7614
40518	2752	1728416	1960-01-15	1960-01-28	1	-3626
75706	5184	1112807	1973-12-29	1974-02-02	1	1493
49781	3392	1125315	1968-04-25	1968-05-09	1	-602
2423	160	1125315	1966-01-03	1966-01-17	1	-1445
40936	2777	1713332	1988-06-28	1988-07-12	1	6767
1729	115	1112807	1961-07-07	1961-07-21	1	-3086
694	42	1119510	1985-02-03	1985-02-17	1	5526
46482	3158	1729720	1986-02-25	1986-03-09	1	5911
3409	227	19127890	1989-08-23	1990-08-18	1	7534
49693	3386	705944	1976-11-29	1986-12-07	1	6184
3757	254	1713332	1991-11-29	1991-12-06	1	8009
45623	3096	1717327	1965-04-28	1965-05-12	1	-1695
2901	191	1112807	1924-02-11	1924-03-12	1	-16731
40598	2758	1125315	2012-02-07	2012-02-21	1	15391
55014	3743	1713332	2008-12-21	2008-12-28	1	14241
3375	225	920293	1987-02-07	1987-02-14	1	6253
439	30	1125315	1977-08-29	1977-09-28	1	2827
31240	2114	914335	1988-06-15	1988-06-15	1	6740
4110	280	738818	1947-08-13	1947-08-27	1	-8163
43784	2957	738818	2007-01-10	2007-01-24	1	13537
1003	67	1125315	1973-03-06	1973-03-20	1	1174
46180	3135	738818	1978-12-24	1979-01-07	1	3293
4386	299	19127890	1978-11-20	1979-11-15	1	3605
48750	3314	1124957	1976-08-25	1976-08-25	1	2428
1403	95	1125315	2002-08-01	2002-08-29	1	11928
48258	3279	933724	2015-10-25	2015-11-01	1	16740
50547	3440	1125315	1959-12-20	1960-02-18	1	-3605
4177	286	1125315	1975-10-26	1975-11-09	1	2138
43754	2955	1309944	2017-07-25	2017-07-25	1	17372
2720	182	1125315	1984-03-17	1984-03-31	1	5203
2509	165	933724	2005-07-12	2005-07-19	1	12983
46038	3125	1125315	1967-08-20	1967-09-03	1	-851
43243	2925	19127890	1979-12-06	1981-11-25	2	4346
7062	487	1125315	1998-10-23	1998-11-06	1	10536
51151	3483	1713332	1956-03-07	1956-03-28	1	-5027
2166	145	920293	1980-03-01	1980-03-08	1	3719
47062	3191	1713332	1995-04-30	1995-05-14	1	9264
1505	99	1118084	2000-01-03	2000-01-03	1	10959
45711	3103	1112807	1987-12-10	1988-01-09	1	6582
52117	3549	1759842	1963-09-27	1963-10-18	1	-2267
44350	3001	1729720	1959-07-03	1959-07-12	1	-3826
2221	148	1549786	1997-09-15	1998-09-10	1	10479
1111	74	1515774	1990-12-06	1991-12-01	1	8004
48417	3290	1125315	1970-03-29	1970-04-05	1	94
4968	338	1759842	2014-02-18	2014-02-25	1	16126
43008	2909	1112807	1956-07-27	1956-08-10	1	-4892
4503	310	1119510	1952-02-04	1952-02-18	1	-6527
2749	184	1713332	1953-05-28	1953-06-11	1	-6048
1790	119	920293	2009-01-24	2009-02-07	2	14282
5237	358	1322184	2012-07-31	2012-07-31	1	15552
48092	3263	1177480	2002-11-03	2002-11-17	1	12008
4530	311	738818	1993-11-10	1993-11-17	1	8721
45302	3074	1125315	1996-03-24	1996-04-07	1	9593
787	49	1713332	2011-11-25	2011-12-09	1	15317
70470	4814	1118084	1981-10-17	1981-10-17	1	4307
48154	3270	1125315	2019-05-09	2019-05-16	1	18032
548	35	1713332	1995-08-11	1995-09-15	1	9388
41835	2835	1102527	1983-01-28	1983-01-28	1	4775
75707	5184	1125315	1967-01-05	1967-01-19	1	-1078
49782	3392	1521369	1981-12-22	1982-12-17	1	4733
2424	160	1717327	1964-03-13	1964-03-27	1	-2106
40937	2777	1759842	2014-12-10	2014-12-31	1	16435
1730	115	1125315	1960-12-25	1961-01-08	1	-3280
695	42	1125315	1989-05-16	1989-05-23	1	7082
47982	3258	1112807	1993-04-15	1993-05-20	1	8540
3410	227	1112807	1974-04-04	1974-04-18	1	1568
49694	3386	920293	2009-12-17	2009-12-24	1	14602
3758	254	1759842	1991-11-29	1991-12-06	1	8009
45624	3096	1759842	2003-04-26	2003-05-17	1	12189
2902	191	1119510	1968-09-30	1968-10-07	1	-451
40599	2758	1307863	2005-11-18	2005-11-18	1	13105
55015	3743	1112807	1980-04-14	1980-04-28	1	3770
3376	225	933724	1987-02-07	1987-02-14	1	6253
440	30	1125315	2013-12-07	2013-12-14	1	16053
31241	2114	1125315	1971-09-23	1971-10-14	1	651
4111	280	1124300	1975-01-07	1975-01-07	1	1832
43785	2957	920293	1977-06-10	1977-06-17	1	2724
1004	67	1125315	1980-01-31	1980-02-14	1	3696
46181	3135	1125315	1978-12-24	1979-01-07	1	3293
4387	299	738818	2017-06-06	2017-06-20	1	17337
48751	3314	1125315	1999-08-01	1999-08-08	1	10811
1404	95	1177480	2013-06-02	2013-06-23	1	15879
48259	3279	1125315	1966-09-14	1966-09-28	1	-1191
50548	3440	1177480	1981-09-21	1981-10-12	1	4302
4178	286	1125315	1995-12-27	1996-01-10	1	9505
43755	2955	1343916	2017-07-25	2017-07-25	1	17372
2721	182	1125315	1987-05-29	1987-06-26	1	6385
2510	165	1125315	1983-05-26	1983-06-09	1	4907
46039	3125	1177480	1975-09-30	1975-10-21	1	2119
43244	2925	19127890	1982-11-20	1983-11-15	1	5066
7063	487	1503184	1981-05-12	1982-05-07	1	4509
51152	3483	1729720	1963-11-29	1963-12-07	1	-2217
2167	145	933724	1980-03-01	1980-03-08	1	3719
47063	3191	1713332	2001-02-28	2001-03-07	1	11388
1506	99	1137529	1998-10-10	1998-10-10	1	10509
45712	3103	1125315	1982-05-04	1982-05-18	1	4520
54482	3707	1112807	1973-11-19	1973-12-03	1	1432
44351	3001	1759842	1980-01-08	1980-01-15	1	3666
2222	148	1115008	1995-06-02	1995-07-07	1	9318
1112	74	1515774	1992-11-25	1993-11-20	1	8724
48418	3290	1125315	1990-01-10	1990-01-24	1	7328
4969	338	1125315	1974-06-13	1974-06-20	1	1631
43009	2909	1125315	1952-03-21	1952-03-28	1	-6488
4504	310	1125315	1981-06-14	1981-07-05	1	4203
2750	184	1119510	1983-12-02	1983-12-09	1	5090
1791	119	933724	2012-03-25	2012-04-08	1	15438
5238	358	1347450	2012-07-31	2012-07-31	1	15552
48093	3263	1759842	1997-04-02	1997-04-16	1	9967
4531	311	1125315	2008-01-04	2008-01-18	1	13896
47490	3224	1125315	1971-01-18	1971-02-01	1	396
788	49	1759842	2006-03-26	2006-04-16	1	13254
70471	4814	1557272	2016-08-15	2016-08-15	1	17028
48155	3270	1115008	1995-06-13	1995-07-18	1	9329
549	35	1717327	1964-07-10	1964-07-24	1	-1987
41836	2835	1125315	1983-01-28	1983-02-11	1	4789
75708	5184	1125315	1984-01-07	1984-01-21	1	5133
49783	3392	1521369	1983-12-12	1984-12-06	1	5453
2425	160	738818	1990-01-13	1990-01-27	1	7331
40938	2777	1759842	2016-07-31	2016-08-07	1	17020
1731	115	1177480	2006-06-09	2006-07-09	1	13338
696	42	1125315	1992-04-09	1992-04-16	1	8141
47983	3258	1124300	2019-01-15	2019-01-15	1	17911
3411	227	1125315	1980-07-01	1980-09-29	1	3924
49695	3386	1174888	1984-12-31	1984-12-31	1	5478
3759	254	1112807	1992-12-10	1992-12-31	1	8400
45625	3096	19127890	1977-12-18	1979-12-08	2	3628
2903	191	1125315	1957-10-12	1957-10-19	1	-4457
40600	2758	1729720	1947-01-27	1947-02-06	1	-8365
55016	3743	1125315	1990-05-18	1990-05-25	1	7449
3377	225	1119510	1973-10-21	1973-10-28	1	1396
441	30	1738521	1972-04-06	1972-04-20	1	840
31242	2114	1125315	1999-12-07	1999-12-28	1	10953
4112	280	1125315	2019-05-31	2019-05-31	1	18047
43786	2957	933724	1977-06-10	1977-06-17	1	2724
1005	67	1125315	1988-10-07	1988-10-21	1	6868
46182	3135	1125315	2005-05-02	2005-05-09	1	12912
4388	299	1125315	2011-11-27	2011-12-04	1	15312
48752	3314	1177480	2012-04-18	2012-05-09	1	15469
1405	95	1717327	1962-04-05	1962-04-19	1	-2814
48260	3279	1125315	1972-10-23	1972-10-23	1	1026
50549	3440	1729720	1980-12-12	1980-12-22	1	4008
4179	286	1177480	1993-01-22	1993-02-26	1	8457
43756	2955	1729720	2012-07-10	2012-07-19	1	15540
2722	182	1713332	2018-06-16	2018-06-23	1	17705
2511	165	1125315	1991-02-26	1991-03-12	1	7740
46040	3125	1759842	2017-07-27	2017-08-17	1	17395
43561	2945	738818	1964-11-05	1964-11-12	1	-1876
7064	487	1713332	2000-05-09	2000-05-23	1	11100
51153	3483	1738521	1978-02-26	1978-03-19	1	2999
2168	145	933724	1983-04-03	1983-04-10	1	4847
47540	3227	1125315	1976-01-22	1976-02-05	1	2226
1507	99	1729720	1972-01-30	1972-02-11	1	771
45713	3103	1738521	1978-11-06	1978-11-20	1	3245
54483	3707	1118084	2008-07-05	2008-07-05	1	14065
44352	3001	1759842	2016-11-25	2016-12-09	1	17144
2223	148	1177480	2007-05-10	2007-06-07	1	13671
1113	74	1521369	1986-01-01	1989-12-11	4	7284
48419	3290	1125315	1991-01-07	1991-02-11	1	7711
4970	338	1503184	1983-04-05	1984-03-30	1	5202
43010	2909	1125315	1954-08-18	1954-08-25	1	-5608
4505	310	1729720	1998-01-28	1998-02-08	1	10265
2751	184	1125315	2019-03-06	2019-03-13	1	17968
1792	119	1118084	1995-05-01	1995-05-01	1	9251
5239	358	1713332	1953-10-21	1953-11-11	1	-5895
50439	3436	738818	1996-02-07	1996-02-21	1	9547
4532	311	1729720	2016-01-11	2016-01-22	1	16822
47491	3224	1125315	1983-01-18	1983-02-01	1	4779
789	49	1759842	2011-11-25	2011-12-09	1	15317
70472	4814	1112807	1939-04-26	1939-05-26	1	-11178
48156	3270	1124300	2005-10-03	2005-10-03	1	13059
550	35	1729720	2011-02-21	2011-02-28	1	15033
41837	2835	1125315	1998-01-23	1998-02-06	1	10263
75709	5184	1503184	1980-06-05	1981-05-31	1	4168
49784	3392	1521369	1985-12-01	1986-11-26	1	6173
2426	160	1118084	2006-02-01	2006-02-01	1	13180
43819	2960	1115008	2009-03-24	2009-04-07	1	14341
1732	115	1521369	1974-10-23	1975-10-18	1	2116
2630	176	1112807	1971-07-22	1971-08-05	1	581
47984	3258	1125315	1985-03-31	1985-04-14	1	5582
3412	227	1515774	1991-08-13	1992-08-07	1	8254
49696	3386	1177480	1986-02-24	1986-03-17	1	5919
3760	254	1124300	1985-06-05	1985-06-05	1	5634
49415	3367	738818	1965-12-19	1966-01-02	1	-1460
2904	191	1125315	1981-11-29	1981-12-06	1	4357
41881	2837	738818	1992-04-19	1992-05-03	1	8158
55017	3743	1125315	2018-09-26	2018-10-10	1	17814
3378	225	1125315	1975-06-21	1975-07-21	1	2027
442	30	19127890	1984-08-11	1985-08-06	1	5696
31243	2114	1309944	1988-06-15	1988-06-15	1	6740
4113	280	1332418	2015-02-27	2015-02-27	1	16493
43787	2957	1125315	1954-02-15	1954-03-01	1	-5785
1006	67	1729720	2017-07-12	2017-07-22	1	17369
46183	3135	1118084	2005-10-13	2005-10-13	1	13069
4389	299	1125315	2019-01-12	2019-01-19	1	17915
48753	3314	1713332	2006-11-15	2006-11-22	1	13474
1406	95	1728416	1962-10-08	1962-10-22	1	-2628
48261	3279	1125315	1998-11-14	1998-11-28	1	10558
50550	3440	1759842	1944-11-26	1944-12-17	1	-9146
4180	286	1177480	2013-07-09	2013-07-23	1	15909
43757	2955	1112807	1981-12-23	1982-01-27	1	4409
2723	182	1729720	1961-06-16	1961-06-28	1	-3109
2512	165	1125315	1992-09-23	1992-09-30	1	8308
46041	3125	1112807	1988-11-09	1988-11-23	1	6901
43562	2945	1112807	1950-11-18	1950-12-02	1	-6970
7065	487	1759842	1989-05-08	1989-05-15	1	7074
52326	3565	920293	1966-04-03	1966-04-10	1	-1362
2169	145	1112807	1952-02-27	1952-03-12	1	-6504
47541	3227	1174888	1986-02-26	1986-02-26	1	5900
2120	143	1119510	1982-10-29	1982-11-12	1	4698
45714	3103	19127890	1992-06-06	1993-06-01	1	8552
54484	3707	1521369	1983-06-27	1984-06-21	1	5285
44353	3001	1112807	1951-06-27	1951-07-11	1	-6749
2224	148	1713332	1989-07-26	1989-08-09	1	7160
5973	409	1118084	1993-01-13	1993-01-13	1	8413
48420	3290	1713332	2011-03-10	2011-03-31	1	15064
4971	338	1521369	1983-04-05	1984-03-30	1	5202
43011	2909	1125315	1957-05-13	1957-05-27	1	-4602
4506	310	1759842	1983-01-04	1983-01-25	1	4772
2752	184	1177480	1984-07-07	1984-07-28	1	5322
1793	119	1177480	2008-12-18	2009-01-08	1	14252
5240	358	1729720	1988-08-16	1988-08-26	1	6812
50440	3436	1112807	1970-03-05	1970-03-26	1	84
4533	311	1125315	1993-11-10	1993-11-17	1	8721
47492	3224	1503184	1975-01-06	1976-01-01	1	2191
2575	171	1118084	2007-12-21	2007-12-21	1	13868
70473	4814	1112807	1940-03-21	1940-05-04	2	-10850
48157	3270	1125315	1974-11-30	1974-12-14	1	1808
551	35	1759842	1990-10-23	1990-11-06	1	7614
41838	2835	1347450	1988-07-05	1988-07-05	1	6760
52	3	1112807	1923-12-22	1924-01-12	1	-16791
49785	3392	1759842	1974-01-28	1974-02-18	1	1509
2427	160	1125315	1980-01-14	1980-01-28	1	3679
43820	2960	1125315	1957-11-19	1957-12-03	1	-4412
1733	115	1728416	1960-12-25	1961-01-08	1	-3280
2631	176	1119510	2013-07-21	2013-07-28	1	15914
47985	3258	1125315	1997-10-26	1997-11-23	1	10188
3413	227	1515774	1996-07-17	1997-07-12	1	10054
49697	3386	1177480	1988-12-31	1989-01-21	1	6960
3761	254	1125315	2000-10-07	2000-10-21	1	11251
49416	3367	738818	2009-10-06	2009-10-13	1	14530
2905	191	1125315	1991-07-25	1991-08-01	1	7882
41882	2837	1118084	2008-01-10	2008-01-10	1	13888
55018	3743	19127890	1993-07-31	1994-07-26	1	8972
3379	225	1125315	2010-08-28	2010-09-11	1	14863
443	30	19127890	1986-08-01	1987-07-27	1	6416
31244	2114	1343916	1988-06-15	1988-06-15	1	6740
4114	280	1361711	2015-02-27	2019-05-31	1	18047
43788	2957	1125315	1956-10-13	1956-11-02	1	-4808
1007	67	1119510	1992-08-09	1992-08-23	1	8270
46184	3135	1119510	1979-12-27	1980-01-03	1	3654
4390	299	1307863	2018-06-30	2018-06-30	1	17712
48754	3314	1125315	2007-07-16	2007-07-30	1	13724
1407	95	1759842	1978-04-18	1978-04-25	1	3036
48262	3279	1177480	1995-03-27	1995-06-25	1	9306
50551	3440	1112807	1944-01-29	1944-02-28	1	-9439
4181	286	1177480	2017-06-02	2017-08-31	1	17409
43758	2955	1118084	2004-08-04	2004-08-04	1	12634
2724	182	1119510	2007-10-17	2007-10-31	1	13817
2513	165	1125315	2012-11-18	2012-11-25	1	15669
46042	3125	1118084	1985-01-05	1985-01-05	1	5483
43563	2945	1125315	1964-11-05	1964-11-12	1	-1876
7066	487	1112807	1971-03-14	1971-03-28	1	451
52327	3565	933724	1966-04-03	1966-04-10	1	-1362
2170	145	1124300	1990-10-06	1990-10-06	1	7583
47542	3227	1177480	1998-07-23	1998-08-29	1	10467
2121	143	1174888	1981-04-27	1981-04-27	1	4134
45715	3103	19127890	1995-05-22	1996-05-16	1	9632
54485	3707	1125315	1984-09-10	1984-09-17	1	5373
44354	3001	1112807	1952-06-27	1952-07-11	1	-6383
2225	148	19127890	1997-09-15	1998-09-10	1	10479
5974	409	1129625	1955-10-26	1955-10-26	1	-5181
48421	3290	1125315	1985-01-18	1985-02-01	1	5510
4972	338	1713332	1998-11-28	1998-12-05	1	10565
43012	2909	1125315	1962-04-08	1962-04-08	1	-2825
4507	310	738818	1952-02-04	1952-02-18	1	-6527
2753	184	1177480	1991-03-24	1991-05-23	1	7812
1794	119	1177480	2015-02-15	2015-03-01	1	16495
5241	358	1112807	1944-12-29	1945-01-12	1	-9120
50441	3436	1125315	1969-04-19	1969-05-03	1	-243
4534	311	1125315	2016-09-18	2016-10-23	1	17097
47493	3224	1729720	1960-03-19	1960-04-01	1	-3562
2576	171	1125315	1981-10-30	1981-11-06	1	4327
70474	4814	1112807	1960-05-04	1960-05-18	1	-3515
48158	3270	1729720	1985-01-02	1985-01-10	1	5488
552	35	1759842	1995-08-11	1995-09-15	1	9388
41839	2835	1759842	1949-09-02	1949-09-23	1	-7405
53	3	1118084	1957-12-08	1957-12-08	1	-4407
49786	3392	1503184	1981-12-22	1982-12-17	1	4733
2428	160	1125315	1990-01-13	1990-01-27	1	7331
43821	2960	1503184	1976-12-19	1977-12-14	1	2904
1734	115	1112807	1962-08-17	1962-09-14	1	-2666
2632	176	1125315	2013-07-21	2013-07-28	1	15914
47986	3258	1177480	1994-06-14	1994-08-13	1	8990
3414	227	1521369	1987-09-03	1988-08-28	1	6814
49698	3386	1177480	1990-11-12	1990-12-03	1	7641
3762	254	1322184	2006-05-05	2006-05-05	1	13273
49417	3367	738818	2017-08-17	2017-08-24	1	17402
2906	191	1125315	2002-03-09	2002-03-16	1	11762
41883	2837	1125315	1992-04-19	1992-05-03	1	8158
55019	3743	738818	1990-05-18	1990-05-25	1	7449
3380	225	1125315	2016-12-01	2016-12-22	1	17157
4224	289	1112807	1962-11-12	1962-11-26	1	-2593
31245	2114	1738521	1970-07-06	1970-07-20	1	200
4115	280	1759842	1947-03-20	1947-04-10	1	-8302
43789	2957	1125315	2007-01-10	2007-01-24	1	13537
1008	67	1125315	1996-10-05	1996-10-12	1	9781
46185	3135	1177480	2001-07-16	2001-07-30	1	11533
4391	299	1503184	1975-12-06	1976-11-30	1	2525
48755	3314	1713332	1964-10-04	1964-10-25	1	-1894
1408	95	1118084	1993-06-06	1993-06-06	1	8557
48263	3279	738818	1998-11-14	1998-11-28	1	10558
50552	3440	1115008	2004-12-22	2005-01-05	1	12788
4182	286	1119510	1928-08-05	1928-08-19	1	-15110
43759	2955	1125315	1975-04-30	1975-05-07	1	1952
2725	182	1125315	1986-09-17	1986-09-24	1	6110
2514	165	1521369	1986-05-19	1987-05-14	1	6342
46043	3125	1125315	1954-04-15	1954-04-29	1	-5726
43564	2945	1125315	1973-11-18	1973-12-02	1	1431
7067	487	1118084	2000-01-26	2000-01-26	1	10982
52328	3565	1112807	1945-12-24	1946-01-07	1	-8760
2171	145	1124957	2003-05-17	2003-05-17	1	12189
47543	3227	1713332	1980-03-07	1980-03-14	1	3725
2122	143	1713332	2007-12-18	2008-01-08	1	13886
46790	3177	1112807	1934-10-27	1934-11-17	1	-12829
54486	3707	1125315	1986-10-08	1986-10-15	1	6131
44355	3001	1125315	1961-12-03	1961-12-10	1	-2944
4763	327	1112807	1972-12-22	1973-01-05	1	1100
5975	409	1177480	1995-09-10	1995-10-01	1	9404
48422	3290	1713332	1971-07-28	1971-08-04	1	580
4973	338	1759842	1998-11-28	1998-12-05	1	10565
43013	2909	1125315	1972-03-13	1972-03-20	1	809
4508	310	1112807	1955-02-17	1955-03-03	1	-5418
2754	184	1729720	1950-02-25	1950-03-10	1	-7237
1795	119	1521369	1974-12-06	1975-12-01	1	2160
5242	358	1125315	1957-03-27	1957-04-03	1	-4656
50442	3436	1125315	1971-07-30	1971-08-13	1	589
4675	321	738818	1973-04-13	1973-04-27	1	1212
47494	3224	1759842	1975-07-27	1975-08-10	1	2047
2577	171	1177480	1994-05-15	1994-06-05	1	8921
70475	4814	1115008	1995-12-06	1996-01-03	1	9498
48159	3270	1729720	1983-05-16	1983-05-26	1	4893
2766	185	1112807	1948-08-16	1948-08-30	1	-7794
41840	2835	738818	1998-01-23	1998-02-06	1	10263
54	3	1119510	1948-06-14	1948-06-21	1	-7864
49787	3392	1503184	1983-12-12	1984-12-06	1	5453
2429	160	1125315	2004-10-01	2004-10-08	1	12699
43822	2960	1729720	1955-03-07	1955-03-14	1	-5407
1735	115	1118084	2001-04-04	2001-04-04	1	11416
2633	176	1177480	1990-08-02	1990-08-23	1	7539
47987	3258	1503184	1995-05-31	1996-05-25	1	9641
3415	227	1729720	1999-08-07	1999-08-14	1	10817
49699	3386	1503184	1988-10-27	1989-10-22	1	7234
3763	254	1759842	1993-03-08	1993-04-05	1	8495
49418	3367	1125315	1965-12-19	1966-01-02	1	-1460
2907	191	1137529	1990-09-25	1990-09-25	1	7572
41884	2837	1125315	1998-09-25	1998-10-02	1	10501
55020	3743	1118084	2017-10-23	2017-10-23	1	17462
3381	225	738818	1973-10-21	1973-10-28	1	1396
4225	289	1728416	1962-11-12	1962-11-26	1	-2593
31246	2114	1112807	1969-12-02	1969-12-16	1	-16
4116	280	1125315	1947-08-13	1947-08-27	1	-8163
43790	2957	1713332	1950-09-04	1950-09-24	1	-7039
1009	67	1713332	2000-07-09	2000-07-23	1	11161
46186	3135	1119510	1978-12-24	1979-01-07	1	3293
4392	299	1503184	1978-11-20	1979-11-15	1	3605
48756	3314	1729720	1980-04-30	1980-05-10	1	3782
1409	95	1125315	1973-11-04	1973-11-11	1	1410
48264	3279	1112807	1955-07-25	1955-08-08	1	-5260
50553	3440	1125315	1955-05-31	1955-06-30	1	-5299
4183	286	1125315	1943-01-01	1943-01-08	1	-9855
43760	2955	1125315	1983-05-02	1983-05-09	1	4876
2726	182	1125315	2007-10-17	2007-10-31	1	13817
2515	165	920293	2005-07-12	2005-07-19	1	12983
46044	3125	1125315	1962-10-20	1962-11-03	1	-2616
43565	2945	1125315	1981-06-25	1981-07-09	1	4207
7068	487	1125315	1995-11-29	1995-12-13	1	9477
52329	3565	1125315	1973-11-30	1973-12-14	1	1443
2172	145	1125315	1950-10-21	1950-11-04	1	-6998
47544	3227	1759842	1980-03-07	1980-03-14	1	3725
2123	143	1115008	2004-08-24	2004-09-28	1	12689
46791	3177	1125315	1942-03-10	1942-03-10	1	-10159
54487	3707	1125315	2002-08-23	2002-09-06	1	11936
44356	3001	1177480	1980-12-15	1981-01-05	1	4022
4764	327	1112807	1974-10-13	1975-01-11	1	1836
5976	409	1177480	2007-01-31	2007-02-21	1	13565
48423	3290	1729720	1979-09-09	1979-09-22	1	3551
4974	338	1118084	2001-08-03	2001-08-03	1	11537
43014	2909	1741122	1962-04-07	1962-04-07	1	-2826
4509	310	1125315	1952-02-04	1952-02-18	1	-6527
2755	184	1759842	1953-05-28	1953-06-11	1	-6048
1796	119	920293	2012-03-25	2012-04-08	2	15438
5243	358	1729720	1982-02-27	1982-03-10	1	4451
50443	3436	1125315	1996-02-07	1996-02-21	1	9547
4676	321	738818	1991-12-29	1992-01-12	1	8046
47495	3224	933724	2000-01-30	2000-02-13	1	11000
2578	171	1115008	2000-03-04	2000-03-18	1	11034
70476	4814	1125315	2010-12-13	2010-12-27	1	14970
48160	3270	1729720	2006-12-20	2007-01-02	1	13515
2767	185	1125315	1950-11-06	1950-11-20	1	-6982
41841	2835	920293	1957-12-07	1957-12-14	1	-4401
55	3	1125315	1969-03-17	1969-03-24	1	-283
49788	3392	1503184	1985-12-01	1986-11-26	1	6173
2430	160	1503184	1975-07-24	1977-07-13	2	2750
43823	2960	1729720	2011-02-25	2011-03-07	1	15040
1736	115	1125315	2001-06-30	2001-07-14	1	11517
2634	176	738818	1986-08-20	1986-09-03	1	6089
47988	3258	1518198	2005-04-08	2006-04-03	1	13241
3416	227	1102527	2014-07-03	2014-07-03	1	16254
49700	3386	1729720	1982-06-04	1982-06-12	1	4545
3764	254	738818	1953-07-09	1953-07-16	1	-6013
49419	3367	1125315	2000-08-18	2000-08-25	1	11194
2908	191	1729720	1924-12-24	1925-01-06	1	-16431
41885	2837	1713332	1984-06-13	1984-06-27	1	5291
55021	3743	1125315	1979-07-05	1979-10-03	1	3562
3382	225	1112807	1965-11-30	1965-12-28	1	-1465
4226	289	1729720	2005-08-13	2005-08-23	1	13018
31247	2114	1125315	1970-07-06	1970-07-20	1	200
4117	280	1322184	2015-02-27	2019-05-31	1	18047
43791	2957	1713332	1953-08-15	1953-08-29	1	-5969
1010	67	1713332	2018-06-07	2018-06-21	1	17703
46187	3135	1125315	1963-09-05	1963-09-12	1	-2303
4393	299	1713332	1971-02-11	1971-03-04	1	427
48757	3314	1729720	1989-06-24	1989-07-07	1	7127
1410	95	1125315	1962-10-08	1962-10-22	1	-2628
48265	3279	1112807	1972-10-23	1972-12-22	1	1086
50554	3440	1125315	1959-01-10	1959-01-24	2	-3995
4184	286	1729720	1934-02-04	1934-02-17	1	-13102
43761	2955	1713332	1978-08-16	1978-08-30	1	3163
2727	182	738818	2007-10-17	2007-10-31	1	13817
2516	165	1119510	1983-05-26	1983-06-09	1	4907
46045	3125	1125315	1979-06-22	1979-07-06	1	3473
43566	2945	1149380	1970-09-22	1970-09-22	1	264
7069	487	1521369	1981-05-12	1982-05-07	1	4509
52330	3565	1112807	1950-01-02	1950-01-30	1	-7276
2173	145	1125315	1969-05-17	1969-05-31	1	-215
47545	3227	1118084	2004-10-04	2004-10-04	1	12695
2124	143	1768849	2001-04-05	2001-04-19	1	11431
46792	3177	1125315	1946-07-10	1946-07-17	1	-8569
54488	3707	1177480	1975-09-27	1975-11-01	1	2130
44357	3001	1713332	1952-11-06	1952-11-13	1	-6258
4765	327	1125315	1976-01-20	1976-02-03	1	2224
5977	409	1729720	1968-12-03	1968-12-15	1	-382
48424	3290	1759842	2011-03-10	2011-03-31	1	15064
4975	338	1119510	2003-10-21	2003-11-04	1	12360
43015	2909	753626	1962-04-07	1962-04-07	1	-2826
4510	310	1125315	1972-09-08	1972-09-15	1	988
2756	184	1177480	2017-10-03	2017-10-17	1	17456
1797	119	1112807	1967-05-28	1967-07-27	1	-889
5244	358	1759842	1953-10-21	1953-11-11	1	-5895
50444	3436	1713332	2015-10-08	2015-10-22	1	16730
4677	321	1112807	1967-11-11	1967-11-25	1	-768
47496	3224	1118084	2001-12-20	2001-12-20	1	11676
2579	171	1713332	1988-05-31	1988-06-14	1	6739
70477	4814	1729720	1936-12-11	1936-12-18	1	-12067
50285	3427	705944	1975-04-04	1984-04-11	1	5214
2768	185	1125315	1977-04-30	1977-05-14	1	2690
41842	2835	933724	1957-12-07	1957-12-14	1	-4401
56	3	1177480	2015-08-21	2015-09-04	1	16682
49789	3392	1713332	1974-01-28	1974-02-18	1	1509
2431	160	19127890	1975-07-24	1977-07-13	2	2750
43824	2960	1759842	1968-08-30	1968-09-06	1	-482
1737	115	1729720	1983-11-08	1983-11-15	1	5066
2635	176	738818	2013-07-21	2013-07-28	1	15914
47989	3258	1729720	2010-09-15	2010-09-28	1	14880
3417	227	1125315	2005-10-20	2005-10-27	1	13083
49701	3386	1729720	2012-04-06	2012-04-17	1	15447
3765	254	738818	1962-10-29	1962-11-12	1	-2607
49420	3367	1125315	2001-05-24	2001-06-07	1	11480
2909	191	738818	1946-04-17	1946-05-01	1	-8646
41886	2837	1759842	1984-06-13	1984-06-27	1	5291
55022	3743	1717327	1978-07-10	1978-07-24	1	3126
3383	225	1112807	1973-08-09	1973-08-30	1	1337
4227	289	1125315	1964-11-09	1964-11-23	1	-1865
31248	2114	1177480	2008-08-12	2008-09-09	1	14131
4118	280	1713332	1947-03-20	1947-04-10	1	-8302
43792	2957	1713332	1999-01-20	1999-02-03	1	10625
1011	67	1738521	1973-03-06	1973-03-20	1	1174
46188	3135	1125315	1979-12-27	1980-01-03	1	3654
4394	299	1119510	2017-06-06	2017-06-20	1	17337
48758	3314	1759842	2006-11-15	2006-11-22	1	13474
1411	95	1125315	1990-09-19	1990-10-03	1	7580
48266	3279	1119510	1998-11-14	1998-11-28	1	10558
50555	3440	1125315	1998-09-20	1998-10-25	1	10524
4185	286	738818	1934-05-22	1934-05-29	1	-13001
43762	2955	1729720	1969-12-29	1970-01-07	1	6
2728	182	1124300	1995-05-17	1995-05-17	1	9267
2517	165	1503184	1986-05-19	1987-05-14	1	6342
46046	3125	1125315	2014-08-28	2014-09-25	1	16338
43567	2945	1713332	1979-03-05	1979-03-19	1	3364
7070	487	1713332	1989-05-08	1989-05-15	1	7074
52331	3565	1125315	1951-08-27	1951-09-03	1	-6695
2174	145	1125315	1995-02-02	1995-02-16	1	9177
47546	3227	1125315	1990-04-26	1990-05-03	1	7427
2125	143	1112807	1965-11-26	1965-12-10	1	-1483
46793	3177	1125315	1975-05-21	1975-06-11	1	1987
54489	3707	1713332	2009-12-20	2010-01-03	1	14612
44358	3001	1713332	2001-09-25	2001-10-02	1	11597
4766	327	1713332	2000-11-03	2000-11-17	1	11278
5978	409	920293	1991-11-01	1991-11-08	1	7981
48425	3290	1118084	2004-06-12	2004-06-12	1	12581
4976	338	1119510	2008-11-01	2008-11-15	1	14198
43016	2909	1000560	1962-04-07	1962-04-07	2	-2826
4511	310	1125315	2002-07-15	2002-08-05	1	11904
2757	184	1713332	1955-12-05	1955-12-26	1	-5120
1798	119	1521369	1976-11-25	1978-11-15	2	3240
5245	358	1713332	1943-08-16	1943-09-06	1	-9614
50445	3436	1759842	1970-09-22	1970-10-13	1	285
4678	321	1125315	1966-08-18	1966-10-17	1	-1172
47497	3224	1125315	1981-02-18	1981-02-25	1	4073
2580	171	1125315	2001-01-03	2001-01-17	1	11339
70478	4814	1112807	1970-07-29	1970-08-19	1	230
50286	3427	1115008	2013-01-04	2013-04-04	1	15799
2769	185	1361711	1996-02-18	1996-02-18	1	9544
41843	2835	1112807	1914-12-02	1914-12-23	1	-20098
57	3	1307863	2001-07-23	2001-07-23	1	11526
49790	3392	1124300	2002-02-10	2002-02-10	1	11728
5432	371	933724	2000-02-28	2000-03-06	1	11022
43825	2960	1118084	1988-10-12	1988-10-12	1	6859
1738	115	19127890	1974-10-23	1975-10-18	1	2116
2636	176	738818	1966-08-19	1966-08-26	1	-1224
47990	3258	1778162	1983-03-25	1983-04-08	1	4845
3418	227	1177480	2019-05-06	2019-05-27	1	18043
49702	3386	19127890	1984-11-17	1985-11-12	1	5794
3766	254	1125315	1953-07-09	1953-07-16	1	-6013
49421	3367	1125315	2017-08-17	2017-08-24	1	17402
2910	191	1115008	1994-05-07	1994-08-05	1	8982
41887	2837	1119510	2008-10-11	2008-10-25	1	14177
55023	3743	1759842	1992-10-19	1992-11-09	1	8348
3384	225	1118084	2005-07-13	2005-07-13	1	12977
4228	289	1125315	1970-09-15	1970-12-13	1	346
32796	2222	1112807	1992-08-19	1992-09-09	1	8287
4119	280	1112807	1946-10-16	1946-10-30	1	-8464
43793	2957	1759842	1989-08-13	1989-08-20	1	7171
1012	67	1738521	1976-01-04	1976-01-18	1	2208
46189	3135	1125315	2003-08-03	2003-08-10	1	12274
4395	299	1124300	2000-07-22	2000-07-22	1	11160
48759	3314	1118084	2003-07-20	2003-07-20	1	12253
1412	95	1713332	1978-04-18	1978-04-25	1	3036
48267	3279	1125315	2010-07-28	2010-08-04	1	14825
50556	3440	1177480	1995-10-06	1995-11-05	1	9439
4186	286	1112807	1929-06-26	1929-07-10	1	-14785
43763	2955	1729720	1974-08-27	1974-09-09	1	1712
2729	182	1759842	2018-06-16	2018-06-23	1	17705
2518	165	1738521	1972-08-20	1972-09-03	1	976
46047	3125	1177480	1976-05-29	1976-06-12	1	2354
43568	2945	1759842	1972-07-18	1972-08-01	1	943
7071	487	1729720	2013-10-06	2013-10-16	1	15994
52332	3565	1125315	1977-06-12	1977-06-19	1	2726
2175	145	1149380	1952-12-06	1952-12-06	1	-6235
47547	3227	1125315	1986-02-26	1986-02-26	1	5900
2126	143	1125315	1981-04-27	1981-05-27	2	4164
46794	3177	1125315	1984-03-27	1984-04-10	1	5213
54490	3707	1738521	1970-04-07	1970-04-21	1	110
44359	3001	1729720	1995-01-04	1995-01-15	1	9145
4767	327	1759842	2004-04-08	2004-04-15	1	12523
5979	409	933724	1991-11-01	1991-11-08	1	7981
48426	3290	1729720	1998-06-26	1998-07-04	1	10411
4977	338	1125315	1995-06-01	1995-06-15	1	9296
43017	2909	1112807	1967-01-15	1967-02-19	1	-1047
4512	310	1713332	1952-08-08	1953-01-16	1	-6194
2758	184	1729720	1949-04-14	1949-04-27	1	-7554
1799	119	1759842	1968-04-07	1968-04-21	1	-620
5246	358	1713332	1971-06-10	1971-07-01	1	546
50446	3436	1759842	2015-10-08	2015-10-22	1	16730
4679	321	1125315	1973-04-13	1973-04-27	1	1212
47498	3224	1501700	2016-12-31	2016-12-31	1	17166
2581	171	1729720	1991-11-02	1991-11-10	1	7983
70479	4814	1125315	1998-12-18	1999-01-15	1	10606
50287	3427	1118084	2000-11-13	2000-11-13	1	11274
2770	185	1728416	1948-01-16	1948-01-30	1	-8007
41844	2835	1124300	1950-10-19	1950-10-19	1	-7014
58	3	1361711	2012-09-24	2012-09-24	1	15607
49791	3392	1125315	1969-04-19	1969-05-03	1	-243
5433	371	1759842	1971-02-21	1971-03-07	1	430
43826	2960	1125315	1996-02-10	1996-03-02	1	9557
1739	115	920293	1976-02-17	1976-03-02	2	2252
2637	176	1102527	1996-04-25	1996-04-25	1	9611
47991	3258	19127890	1995-05-31	1996-05-25	1	9641
3419	227	1515774	1989-08-23	1990-08-18	1	7534
49703	3386	1112807	1970-10-22	1970-11-05	1	308
3767	254	1125315	1962-10-29	1962-11-12	1	-2607
49422	3367	1112807	1968-02-06	1968-02-20	1	-681
2911	191	1119510	1957-10-12	1957-10-19	1	-4457
41888	2837	738818	2008-10-11	2008-10-25	1	14177
55024	3743	1759842	2008-12-21	2008-12-28	1	14241
3385	225	1125315	1973-10-21	1973-10-28	1	1396
4229	289	1125315	2010-10-17	2010-10-31	1	14913
32797	2222	1119510	1967-07-03	1967-07-10	1	-906
4120	280	1112807	1949-11-13	1950-01-12	1	-7294
43794	2957	1759842	1996-11-09	1996-11-23	1	9823
3265	217	1119510	1981-05-08	1981-05-22	1	4159
46317	3145	738818	1987-09-01	1987-09-08	1	6459
4396	299	1125315	1975-01-31	1975-02-07	1	1863
48760	3314	1125315	1964-01-30	1964-02-13	1	-2149
1413	95	1713332	2002-03-18	2002-04-08	1	11785
48268	3279	1713332	1972-03-16	1972-03-30	1	819
50557	3440	1177480	2009-11-10	2009-12-15	1	14593
4187	286	1115008	2006-10-16	2006-12-15	1	13497
43764	2955	1738521	1974-03-05	1974-03-19	1	1538
2916	192	1112807	1952-04-12	1952-04-26	1	-6459
2519	165	1125315	1972-08-20	1972-09-03	1	976
46048	3125	1713332	1966-05-03	1966-05-17	1	-1325
43569	2945	1115008	1998-06-26	1998-07-10	1	10417
7072	487	1759842	2000-05-09	2000-05-23	1	11100
52333	3565	1125315	2000-04-04	2000-04-11	1	11058
2176	145	1729720	1991-08-21	1991-08-31	1	7912
47548	3227	1112807	1986-02-26	1986-04-27	1	5960
2127	143	1125315	2001-04-05	2001-04-19	1	11431
46795	3177	1326303	2012-05-09	2012-05-09	1	15469
54491	3707	1759842	2009-12-20	2010-01-03	1	14612
44360	3001	1759842	2001-09-25	2001-10-02	1	11597
4768	327	1124300	2010-12-03	2010-12-03	1	14946
5980	409	1125315	2011-11-17	2011-11-24	1	15302
48427	3290	1759842	1971-07-28	1971-08-04	1	580
4978	338	19127890	1983-04-05	1984-03-30	1	5202
43018	2909	1124957	1962-04-08	1962-04-08	1	-2825
4513	310	1713332	1957-10-31	1957-11-21	1	-4424
2759	184	1729720	1966-10-28	1966-11-05	1	-1153
1800	119	1759842	1976-05-18	1976-05-25	1	2336
5247	358	1729720	2009-03-23	2009-04-03	1	14337
50447	3436	1119510	1996-02-07	1996-02-21	1	9547
4680	321	1125315	1983-11-22	1983-12-06	1	5087
47499	3224	1521369	1975-01-06	1976-01-01	1	2191
2582	171	1125315	1983-06-21	1983-07-12	1	4940
70480	4814	1729720	1944-07-28	1944-08-09	1	-9276
50288	3427	1125315	1973-12-27	1974-01-03	1	1463
2771	185	1728416	1950-11-06	1950-11-20	1	-6982
41845	2835	1125315	1966-05-12	1966-05-19	1	-1323
59	3	1112807	1967-05-26	1967-06-16	1	-930
49792	3392	1125315	1974-11-10	1974-11-24	1	1788
5434	371	1119510	1991-12-10	1991-12-24	1	8027
43827	2960	1125315	2011-11-16	2011-11-23	1	15301
1740	115	933724	1976-02-17	1976-03-02	1	2252
2638	176	1118084	2003-03-06	2003-03-06	1	12117
47992	3258	19127890	1997-05-20	1998-05-15	1	10361
3420	227	1549786	1989-08-23	1990-08-18	1	7534
49704	3386	1124300	2007-09-08	2007-09-08	1	13764
5066	347	1125315	1982-10-11	1982-10-11	1	4666
49423	3367	1119510	2009-10-06	2009-10-13	1	14530
2912	191	1125315	1946-04-17	1946-05-01	1	-8646
41889	2837	1119510	1992-04-19	1992-05-03	1	8158
56031	3817	1125315	1968-08-18	1968-08-25	1	-494
3386	225	1125315	1978-04-06	1978-04-20	1	3031
4230	289	1125315	2014-08-19	2014-08-26	1	16308
32798	2222	1125315	1963-12-20	1964-01-03	1	-2190
4121	280	1125315	1988-05-20	1988-06-10	1	6735
45182	3067	738818	1991-09-10	1991-09-17	1	7929
3266	217	738818	1981-05-08	1981-05-22	1	4159
46318	3145	1125315	1987-09-01	1987-09-08	1	6459
4397	299	1125315	2015-07-29	2015-08-26	1	16673
48761	3314	1125315	1986-08-05	1986-08-12	1	6067
1414	95	1759842	2002-03-18	2002-04-08	1	11785
48269	3279	1112807	1956-05-03	1956-05-17	1	-4977
50558	3440	1501700	2015-02-20	2015-02-20	1	16486
4188	286	1119510	1982-03-16	1982-03-30	1	4471
45231	3069	1125315	1991-02-12	1991-02-26	1	7726
2917	192	1124300	1981-10-27	1981-10-27	1	4317
2520	165	1125315	1974-02-11	1974-02-25	1	1516
46049	3125	1728416	1951-12-25	1952-01-08	1	-6568
43570	2945	1125315	1950-08-20	1950-09-03	1	-7060
7073	487	738818	2007-05-27	2007-06-03	1	13667
52334	3565	1713332	2008-03-16	2008-04-06	1	13975
2177	145	1115008	2003-05-17	2003-08-15	1	12279
47549	3227	1125315	1974-11-26	1974-12-10	1	1804
2128	143	1729720	1979-05-20	1979-05-29	1	3435
46796	3177	1347450	2012-05-30	2012-05-30	1	15490
54492	3707	1125315	1969-09-28	1969-10-12	1	-81
44610	3023	920293	2008-11-29	2008-12-06	1	14219
4769	327	1125315	1983-10-26	1983-11-16	1	5067
5981	409	1177480	2013-02-19	2013-03-19	1	15783
49017	3337	1125315	1991-08-29	1991-09-12	1	7924
4979	338	1713332	2014-02-18	2014-02-25	1	16126
43019	2909	1149380	1972-03-26	1972-03-26	1	815
4514	310	1713332	1983-01-04	1983-01-25	1	4772
2760	184	738818	1964-01-25	1964-02-08	1	-2154
1801	119	1759842	2000-01-23	2000-02-13	1	11000
5248	358	1124300	1976-10-02	1976-10-02	1	2466
50448	3436	1713332	1970-09-22	1970-10-13	1	285
4681	321	1125315	1991-12-29	1992-01-12	1	8046
47500	3224	1713332	1975-07-27	1975-08-10	1	2047
2583	171	1177480	1979-09-10	1979-10-10	1	3569
70481	4814	738818	2000-05-07	2000-05-14	1	11091
50289	3427	1125315	1976-12-20	1977-01-03	1	2559
2772	185	1112807	1986-02-25	1986-03-25	1	5927
41846	2835	1125315	1988-11-11	1988-11-25	1	6903
60	3	1125315	1948-06-14	1948-06-21	1	-7864
49793	3392	1125315	2013-09-12	2013-09-19	1	15967
5435	371	1124300	2008-05-11	2008-05-11	1	14010
43828	2960	1521369	1976-12-19	1977-12-14	1	2904
1741	115	1102527	2006-06-09	2006-06-09	1	13308
2639	176	1125315	1966-08-19	1966-08-26	1	-1224
47993	3258	1102527	1995-07-09	1995-07-09	1	9320
3421	227	1549786	1991-08-13	1992-08-07	1	8254
49705	3386	1125315	1974-08-02	1974-08-23	1	1695
5067	347	1713332	1992-12-24	1993-01-07	1	8407
49424	3367	1119510	2017-08-17	2017-08-24	1	17402
2913	191	1125315	1967-06-30	1967-07-07	1	-909
41890	2837	1125315	2008-10-11	2008-10-25	1	14177
56032	3817	1125315	1991-03-30	1991-04-06	1	7765
3387	225	1125315	1966-10-24	1966-11-23	1	-1135
4231	289	1125315	1961-01-04	1961-01-18	1	-3270
32799	2222	1177480	2014-02-16	2014-03-02	1	16131
4122	280	1125315	1992-09-21	1992-09-28	1	8306
45183	3067	1115008	2009-12-26	2010-01-09	1	14618
3267	217	1125315	1981-05-08	1981-05-22	1	4159
46319	3145	1713332	1991-05-13	1991-06-03	1	7823
4398	299	1326303	2018-06-30	2018-06-30	1	17712
48762	3314	1728416	1964-01-30	1964-02-13	1	-2149
1415	95	1125315	1969-12-08	1970-03-08	2	66
48270	3279	1124957	1972-10-23	1972-10-23	1	1026
50559	3440	1713332	1944-11-26	1944-12-17	1	-9146
4189	286	1125315	1934-05-22	1934-05-29	1	-13001
45232	3069	1125315	1997-04-26	1997-05-10	1	9991
2918	192	1125315	1987-02-04	1987-03-04	1	6271
2521	165	1125315	2013-04-15	2013-06-14	1	15870
46050	3125	1112807	1963-12-27	1964-01-31	1	-2162
43571	2945	1125315	1974-03-01	1974-04-05	1	1555
7074	487	1119510	2007-05-27	2007-06-03	1	13667
52335	3565	1729720	1947-12-17	1947-12-30	1	-8038
2178	145	1125315	1955-06-27	1955-08-01	1	-5267
47550	3227	1125315	1984-05-24	1984-06-07	1	5271
2129	143	738818	1982-10-29	1982-11-12	1	4698
46797	3177	1729720	1931-11-14	1931-11-25	1	-13917
54493	3707	19127890	1983-06-27	1984-06-21	1	5285
44611	3023	1112807	1993-04-24	1993-05-29	1	8549
4770	327	1125315	1985-11-05	1985-12-10	1	5822
5982	409	1759842	1997-03-09	1997-03-23	1	9943
49018	3337	1125315	2019-06-10	2019-06-17	1	18064
4980	338	1729720	1979-03-05	1979-03-13	1	3358
43020	2909	1746114	1962-04-07	1962-04-07	1	-2826
4515	310	1728416	1951-09-06	1951-09-20	1	-6678
2761	184	738818	2019-03-06	2019-03-13	1	17968
1802	119	1503184	1976-11-25	1978-11-15	2	3240
5249	358	1125315	1976-02-16	1976-03-01	1	2251
50449	3436	1713332	1983-05-14	1983-06-04	1	4902
4682	321	1125315	1996-06-30	1996-07-21	1	9698
47501	3224	920293	2000-01-30	2000-02-13	2	11000
2584	171	1759842	1988-05-31	1988-06-14	1	6739
70482	4814	1112807	1946-01-03	1946-01-17	1	-8750
50290	3427	1125315	1993-08-15	1993-08-29	1	8641
2773	185	1118084	1986-01-22	1986-01-22	1	5865
41847	2835	1125315	2004-11-11	2004-11-18	1	12740
61	3	1713332	1956-12-15	1956-12-29	1	-4751
49794	3392	1728416	1969-04-19	1969-05-03	1	-243
5436	371	738818	1991-12-10	1991-12-24	1	8027
43829	2960	1713332	1968-08-30	1968-09-06	1	-482
1742	115	1125315	1997-10-13	1997-10-27	1	10161
2640	176	1125315	1975-05-16	1975-07-22	1	2028
47994	3258	1125315	1989-08-22	1989-08-29	1	7180
3422	227	1713332	2017-07-21	2017-07-28	1	17375
49706	3386	1125315	1976-05-14	1976-06-18	1	2360
5068	347	1759842	1992-12-24	1993-01-07	1	8407
49425	3367	1125315	1976-02-24	1976-04-24	1	2305
2914	191	1125315	1987-08-07	1987-09-11	1	6462
41891	2837	1125315	2015-01-23	2015-01-30	1	16465
56033	3817	1125315	2017-06-25	2017-07-09	1	17356
3388	225	1125315	1981-05-04	1981-06-08	1	4176
4232	289	1728416	1961-01-04	1961-01-18	1	-3270
32800	2222	1713332	1968-12-24	1968-12-31	1	-366
4123	280	1125315	1993-11-18	1993-12-09	1	8743
45184	3067	1118084	1976-07-27	1976-07-27	1	2399
3268	217	1125315	2013-06-15	2013-07-13	1	15899
46320	3145	1759842	1974-11-14	1974-11-28	1	1792
4399	299	1729720	1967-04-09	1967-04-17	1	-990
48763	3314	1759842	1964-10-04	1964-10-25	1	-1894
1416	95	1174888	1969-12-08	1969-12-08	1	-24
48271	3279	1728416	1955-07-25	1955-08-08	1	-5260
50560	3440	1728416	1945-11-19	1945-12-03	1	-8795
4190	286	1125315	1978-12-30	1979-02-05	1	3322
45233	3069	1177480	1977-05-29	1977-06-19	1	2726
2919	192	1713332	1991-08-12	1991-08-19	1	7900
2522	165	19127890	1986-05-19	1987-05-14	1	6342
46051	3125	1125315	1972-04-19	1972-04-26	1	846
43572	2945	1759842	1979-03-05	1979-03-19	1	3364
7075	487	1125315	1969-03-29	1969-04-12	1	-264
52336	3565	1759842	1979-06-14	1979-06-28	1	3465
2179	145	1125315	1957-12-15	1957-12-22	1	-4393
47551	3227	1768849	1984-05-24	1984-06-07	1	5271
2130	143	1124300	1999-01-17	1999-01-17	1	10608
46798	3177	920293	1946-08-22	1946-09-05	2	-8519
54494	3707	1112807	1970-04-07	1970-04-21	1	110
44612	3023	1125315	2017-06-26	2017-07-03	1	17350
4771	327	1713332	2004-04-08	2004-04-15	1	12523
5983	409	1112807	1955-10-10	1955-11-09	1	-5167
49019	3337	1309944	1983-12-05	1983-12-05	1	5086
9240	642	701322	2016-12-12	2016-12-12	1	17147
43021	2909	782043	1962-04-07	1962-04-07	1	-2826
4516	310	1759842	1973-10-26	1973-11-23	1	1422
2762	184	1118084	1987-01-03	1987-01-03	1	6211
1803	119	1713332	1968-04-07	1968-04-21	1	-620
5250	358	1713332	2004-06-09	2004-06-23	1	12592
50450	3436	1738521	1976-04-23	1976-05-21	1	2332
4683	321	1521369	1976-11-03	1978-10-24	2	3218
47502	3224	1729720	1971-09-05	1971-09-16	1	623
3965	270	1115008	1995-08-15	1995-09-05	1	9378
70483	4814	1112807	1946-11-13	1946-12-04	1	-8429
50291	3427	1728416	1967-01-01	1967-01-15	1	-1082
2774	185	1125315	1958-08-07	1958-11-05	1	-4075
41848	2835	1125315	2018-01-29	2018-03-05	1	17595
62	3	1713332	1985-03-22	1985-03-29	1	5566
49795	3392	1738521	1974-11-10	1974-11-24	1	1788
5437	371	920293	2000-02-28	2000-03-06	1	11022
43830	2960	1729720	1969-05-06	1969-05-13	1	-233
1743	115	1125315	2011-04-14	2011-04-28	1	15092
2641	176	1125315	1986-08-20	1986-09-03	1	6089
47995	3258	1125315	1990-09-14	1990-09-28	1	7575
3423	227	1759842	1989-09-27	1989-10-11	1	7223
49707	3386	1125315	1978-07-08	1978-08-05	1	3138
5069	347	1177480	2015-07-20	2015-08-17	1	16664
49426	3367	1125315	1997-07-06	1997-07-20	1	10062
2915	191	1713332	1997-10-13	1997-10-20	1	10154
43093	2915	975125	1967-05-11	1967-05-11	1	-966
56034	3817	1112807	1967-02-07	1967-02-21	1	-1045
3389	225	1192710	1969-01-24	1969-01-24	1	-342
4233	289	1118084	1992-12-22	1992-12-22	1	8391
32801	2222	738818	1979-05-13	1979-05-20	1	3426
4124	280	1125315	2014-02-15	2014-03-01	1	16130
45185	3067	1119510	1970-10-09	1970-10-23	1	295
3269	217	1125315	2016-03-06	2016-03-13	1	16873
46321	3145	1759842	1991-05-13	1991-06-03	1	7823
4400	299	1149380	2014-12-27	2014-12-27	1	16431
50136	3415	1102527	1983-09-09	1983-09-09	1	4999
1417	95	1729720	1965-11-18	1965-11-25	1	-1498
48272	3279	1728416	1956-05-03	1956-05-17	1	-4977
50561	3440	1759842	2004-07-22	2004-08-05	1	12635
4191	286	1177480	2008-01-09	2008-02-06	1	13915
45234	3069	1102527	1986-08-08	1986-08-08	1	6063
2920	192	1729720	1986-03-10	1986-03-23	1	5925
3180	211	738818	2006-11-25	2006-12-09	1	13491
46052	3125	1177480	2003-03-10	2003-04-14	1	12156
43573	2945	1778162	1998-06-26	1998-07-10	1	10417
7076	487	1125315	2007-05-27	2007-06-03	1	13667
52337	3565	1112807	1957-11-19	1957-12-24	1	-4391
2180	145	1125315	1979-10-24	1979-11-14	1	3604
54383	3700	1112807	1978-08-04	1978-08-18	1	3151
2131	143	1125315	1979-06-16	1979-07-07	1	3474
46799	3177	933724	1946-08-22	1946-09-05	1	-8519
54495	3707	1503184	1983-06-27	1984-06-21	1	5285
44613	3023	1519936	2005-08-29	2006-08-24	1	13384
4772	327	1738521	1972-12-22	1973-01-05	1	1100
5984	409	1551099	1951-12-30	1951-12-30	1	-6577
49020	3337	1343916	1983-12-05	1983-12-05	1	5086
9241	642	1112807	1938-04-30	1938-05-14	1	-11555
43022	2909	920293	1963-03-30	1963-04-06	1	-2462
4517	310	1112807	1951-09-06	1951-09-20	1	-6678
2763	184	1125315	1964-01-25	1964-02-08	1	-2154
1804	119	1713332	1976-05-18	1976-05-25	1	2336
5251	358	1759842	1943-08-16	1943-09-06	1	-9614
50451	3436	920293	1997-12-12	1997-12-19	1	10214
4684	321	1521369	1979-10-19	1980-10-13	1	3938
47503	3224	19127890	1975-01-06	1976-01-01	1	2191
3966	270	1713332	2006-04-07	2006-04-14	1	13252
70484	4814	1119510	2000-05-07	2000-05-14	1	11091
50292	3427	1112807	1970-06-09	1970-06-23	1	173
2775	185	1125315	2018-05-23	2018-05-30	1	17681
41849	2835	1177480	2012-01-31	2012-03-31	1	15430
63	3	1759842	1985-03-22	1985-03-29	1	5566
49796	3392	920293	1997-01-21	1997-01-28	1	9889
5438	371	1125315	1968-08-30	1968-09-13	1	-475
43831	2960	1125315	1958-10-16	1958-10-23	1	-4088
1744	115	1503184	1974-10-23	1975-10-18	1	2116
2642	176	1713332	1969-02-09	1969-02-16	1	-319
47996	3258	1125315	1990-12-23	1990-12-30	1	7668
3424	227	19127890	1991-08-13	1992-08-07	1	8254
49708	3386	1125315	2019-02-04	2019-02-18	1	17945
5070	347	1124957	1982-10-11	1982-10-11	1	4666
49427	3367	1125315	2009-10-06	2009-10-13	1	14530
5314	364	738818	1948-01-20	1948-02-03	1	-8003
43094	2915	1118084	1981-11-14	1981-11-14	1	4335
56035	3817	1112807	1968-07-31	1968-08-14	1	-505
3390	225	1729720	2013-09-25	2013-10-02	1	15980
4234	289	1177480	2000-02-09	2000-03-08	1	11024
32802	2222	1118084	2005-11-04	2005-11-04	1	13091
4125	280	1174888	2019-05-31	2019-05-31	1	18047
45186	3067	1125315	1967-03-09	1967-04-08	1	-999
3270	217	1118084	2017-07-11	2017-07-11	1	17358
46322	3145	1119510	1987-09-01	1987-09-08	1	6459
4401	299	1310149	2018-06-30	2018-06-30	1	17712
50137	3415	1125315	1999-06-20	1999-06-27	1	10769
2991	197	1112807	1975-10-26	1975-11-16	1	2145
48273	3279	1729720	1966-08-29	1966-09-11	1	-1208
50562	3440	1115008	2009-07-11	2009-07-25	1	14450
4192	286	1177480	2019-05-23	2019-06-13	1	18060
45235	3069	1112807	1986-08-01	1986-10-07	1	6123
2921	192	1102527	2014-04-02	2014-04-02	1	16162
3181	211	1119510	1969-08-03	1969-08-10	1	-144
46053	3125	1177480	2011-09-29	2011-10-13	1	15260
43574	2945	1115008	2010-12-06	2011-01-10	1	14984
7077	487	1125315	2009-11-08	2009-11-22	1	14570
52338	3565	1124300	1982-05-14	1982-05-14	1	4516
2181	145	1125315	1981-07-06	1981-08-05	1	4234
54384	3700	1118084	2005-04-13	2005-04-13	1	12886
2132	143	1125315	1982-10-29	1982-11-12	1	4698
46800	3177	933724	1948-10-18	1948-10-25	1	-7738
54496	3707	1729720	1980-10-03	1980-10-14	1	3939
44614	3023	1549786	2000-09-24	2001-09-19	1	11584
4773	327	1738521	1976-01-20	1976-02-03	1	2224
5985	409	1713332	1997-03-09	1997-03-23	1	9943
49021	3337	1119510	2010-07-24	2010-07-31	1	14821
9242	642	1119510	1995-12-03	1995-12-10	1	9474
43023	2909	933724	1963-03-30	1963-04-06	1	-2462
4518	310	1177480	2014-03-05	2014-03-26	1	16155
2764	184	1557272	2016-08-01	2016-08-01	1	17014
1805	119	1713332	2018-03-12	2018-04-09	1	17630
5252	358	1759842	1971-06-10	1971-07-01	1	546
50452	3436	933724	1997-12-12	1997-12-19	1	10214
4685	321	1125315	1968-08-08	1968-08-22	1	-497
49728	3389	1125315	1973-01-15	1973-02-14	2	1140
3967	270	1112807	1965-07-27	1965-08-10	1	-1605
70485	4814	1125315	2000-05-07	2000-05-14	1	11091
50293	3427	1125315	1970-02-14	1970-04-22	1	111
2776	185	1322184	1997-02-23	1997-02-23	1	9915
41850	2835	1347450	1994-09-27	1994-09-27	1	9035
64	3	738818	1948-06-14	1948-06-21	1	-7864
49797	3392	933724	1997-01-21	1997-01-28	1	9889
5439	371	1125315	1991-12-10	1991-12-24	1	8027
43832	2960	1125315	1993-02-11	1993-02-25	1	8456
1745	115	1759842	1964-04-27	1964-05-18	1	-2054
2643	176	1119510	1966-08-19	1966-08-26	1	-1224
47997	3258	1500211	2002-04-24	2003-04-19	1	12161
3425	227	19127890	1996-07-17	1997-07-12	1	10054
49709	3386	1503184	1984-11-17	1985-11-12	1	5794
5071	347	1149380	1999-11-07	1999-11-07	1	10902
49428	3367	1125315	2015-05-01	2015-05-22	1	16577
5315	364	1112807	1947-10-20	1947-11-03	1	-8095
43095	2915	1557272	2005-04-03	2005-04-03	1	12876
56036	3817	1115008	2019-02-18	2019-03-25	1	17980
7622	526	1521369	1988-02-05	1989-01-30	1	6969
4235	289	1713332	2005-02-19	2005-03-12	1	12854
32803	2222	1125315	1979-05-13	1979-05-20	1	3426
4126	280	1177480	1976-06-24	1976-07-22	1	2394
45187	3067	1125315	1974-08-31	1974-09-07	1	1710
3271	217	1713332	1979-08-15	1979-08-29	1	3527
46323	3145	1124300	2010-12-03	2010-12-03	1	14946
4402	299	1521369	1975-12-06	1976-11-30	1	2525
50138	3415	1125315	1983-09-09	1983-10-09	1	5029
2992	197	1118084	1996-07-31	1996-07-31	1	9708
48274	3279	1759842	1972-03-16	1972-03-30	1	819
50563	3440	1115008	2015-10-29	2015-11-28	1	16767
4193	286	738818	1928-08-05	1928-08-19	1	-15110
45236	3069	1125315	1963-04-08	1963-04-22	1	-2446
2922	192	1115008	1996-04-15	1996-05-06	1	9622
3182	211	1119510	2006-11-25	2006-12-09	1	13491
46054	3125	1738521	1976-05-29	1976-06-12	1	2354
43575	2945	1119510	1964-11-05	1964-11-12	1	-1876
7078	487	1125315	2015-02-24	2015-03-10	1	16504
52339	3565	1125315	2019-03-10	2019-03-24	1	17979
2182	145	1125315	2003-05-17	2003-05-17	1	12189
54385	3700	1125315	1981-01-21	1981-02-04	1	4052
2133	143	1125315	2000-08-16	2000-08-23	1	11192
46801	3177	1112807	1918-03-24	1918-04-07	1	-18897
54497	3707	1738521	1969-09-28	1969-10-12	1	-81
44615	3023	1713332	1985-11-02	1985-11-16	1	5798
4774	327	1759842	2000-11-03	2000-11-17	1	11278
5986	409	1125315	1965-05-20	1965-06-19	2	-1657
49022	3337	1125315	1982-07-03	1982-07-17	1	4580
9243	642	1125315	1992-04-16	1992-04-30	1	8155
43024	2909	933724	1969-05-20	1969-05-27	1	-219
4519	310	1713332	1973-10-26	1973-11-23	1	1422
2765	184	1759842	1955-12-05	1955-12-26	1	-5120
1806	119	1759842	2018-03-12	2018-04-09	1	17630
5253	358	1759842	2004-06-09	2004-06-23	1	12592
50453	3436	1115008	1995-09-09	1995-09-30	1	9403
4686	321	1728416	1962-05-11	1962-05-25	1	-2778
49729	3389	1713332	2010-08-12	2010-09-02	1	14854
3968	270	1125315	1985-06-17	1985-07-08	1	5667
72724	4971	1112807	1940-04-19	1940-05-19	1	-10819
50294	3427	1125315	2008-04-02	2008-04-30	1	13999
2777	185	1713332	1947-04-12	1947-05-03	1	-8279
41851	2835	1125315	1915-10-29	1915-11-05	1	-19781
65	3	1125315	1950-01-25	1950-02-24	1	-7251
49798	3392	19127890	1981-12-22	1982-12-17	1	4733
5440	371	1713332	1971-02-21	1971-03-07	1	430
43833	2960	1713332	1997-09-21	1997-09-28	1	10132
2377	159	1119510	1997-08-18	1997-08-25	1	10098
2644	176	1119510	1986-08-20	1986-09-03	1	6089
47998	3258	1549786	1997-05-20	1998-05-15	1	10361
4440	304	1119510	2003-09-03	2003-09-10	1	12305
49710	3386	1521369	1988-10-27	1989-10-22	1	7234
5072	347	1177480	1982-10-11	1982-11-10	1	4696
49429	3367	1177480	1993-05-25	1993-06-22	1	8573
5316	364	1112807	1961-03-10	1961-03-31	1	-3198
43096	2915	1729720	1950-07-18	1950-07-30	1	-7095
56037	3817	1118084	2000-05-29	2000-05-29	1	11106
7623	526	920293	2004-03-21	2004-03-28	1	12505
4236	289	1717327	1964-11-09	1964-11-23	1	-1865
32804	2222	1729720	2008-02-10	2008-02-20	1	13929
4127	280	1177480	2010-10-11	2011-01-09	1	14983
45188	3067	1125315	1991-09-10	1991-09-17	1	7929
3272	217	1729720	1979-12-27	1980-01-04	1	3655
46324	3145	1125315	1974-05-11	1974-06-10	1	1621
4403	299	1521369	1978-11-20	1979-11-15	1	3605
50139	3415	1729720	2008-09-28	2008-10-06	1	14158
2993	197	1125315	1969-02-03	1969-03-03	1	-304
48275	3279	920293	2015-10-25	2015-11-01	1	16740
50564	3440	1125315	1954-02-18	1954-03-04	1	-5782
4194	286	738818	1982-03-16	1982-03-30	1	4471
45237	3069	1125315	1971-12-13	1971-12-27	1	725
2923	192	1347450	2014-07-02	2014-07-02	1	16253
3183	211	1125315	2006-11-25	2006-12-09	1	13491
46055	3125	1112807	1951-12-25	1952-01-08	1	-6568
43576	2945	1124300	1981-11-25	1981-11-25	1	4346
7079	487	1728416	1969-03-29	1969-04-12	1	-264
52340	3565	1728416	1945-12-24	1946-01-07	1	-8760
2183	145	1177480	1982-06-01	1982-06-22	1	4555
54386	3700	1125315	1982-07-31	1982-08-14	1	4608
2134	143	1717327	1965-11-26	1965-12-10	1	-1483
46802	3177	1125315	1980-02-21	1980-02-28	1	3710
54498	3707	1738521	1973-11-19	1973-12-03	1	1432
44616	3023	1118084	2018-02-02	2018-02-02	1	17564
4775	327	738818	2000-07-17	2000-07-31	1	11169
5987	409	1174888	1965-05-20	1965-05-20	1	-1687
49023	3337	1125315	2010-07-24	2010-07-31	1	14821
9244	642	1125315	1993-10-01	1993-10-15	1	8688
43025	2909	967823	1962-04-07	1962-04-08	1	-2825
4520	310	1759842	1952-08-08	1953-01-16	1	-6194
4166	285	1125315	1984-11-09	1984-11-23	1	5440
1807	119	19127890	1974-12-06	1975-12-01	1	2160
5719	394	738818	1982-01-22	1982-01-29	1	4411
50454	3436	1125315	1965-03-31	1965-04-14	1	-1723
4687	321	1759842	1991-04-21	1991-05-12	1	7801
49730	3389	1759842	2007-04-01	2007-04-22	1	13625
3969	270	1125315	1990-06-27	1990-07-04	1	7489
72725	4971	1125315	1974-10-04	1974-10-18	1	1751
50295	3427	1112807	1967-01-01	1967-01-15	1	-1082
2778	185	1112807	1948-01-16	1948-01-30	1	-8007
41852	2835	1125315	1963-02-14	1963-03-14	1	-2485
66	3	1125315	2010-08-27	2010-10-26	1	14908
49799	3392	19127890	1983-12-12	1984-12-06	1	5453
5441	371	1729720	1980-04-13	1980-04-23	1	3765
43834	2960	1728416	1957-11-19	1957-12-03	1	-4412
2378	159	1125315	1959-07-09	1959-07-23	1	-3815
2645	176	1729720	2003-12-19	2003-12-28	1	12414
47999	3258	1549786	2003-04-19	2004-04-13	1	12521
4441	304	1125315	1959-05-24	1959-06-07	1	-3861
49711	3386	1759842	2006-07-18	2006-07-25	1	13354
5073	347	1118084	2011-12-28	2011-12-28	1	15336
49430	3367	1102527	1976-02-24	1976-02-24	1	2245
5317	364	1125315	1948-01-20	1948-02-03	1	-8003
43097	2915	1729720	1969-09-16	1969-09-23	1	-100
56038	3817	1125315	1997-06-12	1997-06-19	1	10031
7624	526	1118084	2002-04-12	2002-04-12	1	11789
4237	289	1759842	2005-02-19	2005-03-12	1	12854
32805	2222	1759842	1968-12-24	1968-12-31	1	-366
4128	280	1729720	1949-04-06	1949-04-18	1	-7563
45189	3067	1309944	1965-11-23	1965-11-23	1	-1500
3273	217	1112807	1979-08-15	1979-08-29	1	3527
46325	3145	1125315	1976-03-01	1976-05-30	1	2341
4404	299	1729720	1962-04-09	1962-04-17	1	-2816
50140	3415	738818	1992-01-28	1992-02-04	1	8069
2994	197	1125315	1982-07-12	1982-08-02	1	4596
48276	3279	1112807	1974-08-14	1974-10-13	1	1746
50565	3440	1728416	1959-01-10	1959-01-24	1	-3995
4195	286	1112807	1929-01-30	1929-02-13	1	-14932
45238	3069	1503184	1975-08-13	1976-08-07	1	2410
2924	192	1713332	2014-04-02	2014-04-16	1	16176
3184	211	738818	1969-08-03	1969-08-10	1	-144
46056	3125	1112807	1957-07-17	1957-07-31	1	-4537
43577	2945	1125315	1984-10-10	1984-10-24	1	5410
7080	487	1729720	1972-08-12	1972-08-22	1	964
52341	3565	1125315	1955-11-21	1955-11-28	1	-5148
2184	145	1728416	1952-02-27	1952-03-12	1	-6504
54387	3700	1174888	2010-04-03	2010-04-03	1	14702
2135	143	1759842	2007-12-18	2008-01-08	1	13886
46803	3177	1125315	1985-09-03	1985-09-10	1	5731
57082	3890	1125315	1976-09-07	1976-09-21	1	2455
44617	3023	1521369	2000-09-24	2001-09-19	1	11584
4776	327	1119510	2000-07-17	2000-07-31	1	11169
5988	409	1177480	1980-10-28	1981-01-26	1	4043
49024	3337	1759842	1981-02-13	1981-03-06	1	4082
9245	642	1322184	2017-10-08	2017-10-08	1	17447
43026	2909	1367571	1962-04-07	1962-04-07	1	-2826
4521	310	1759842	1957-10-31	1957-11-21	1	-4424
4167	285	1729720	1971-08-20	1971-09-01	1	608
1808	119	933724	2009-01-24	2009-02-07	1	14282
5720	394	1125315	1982-01-22	1982-01-29	1	4411
50455	3436	1125315	1992-07-18	1992-07-25	1	8241
4688	321	1759842	1998-10-26	1998-11-09	1	10539
49731	3389	1125315	1961-01-18	1961-02-01	1	-3256
3970	270	1713332	1994-06-19	1994-07-03	1	8949
72726	4971	1125315	1983-11-28	1983-12-12	1	5093
50296	3427	1115008	2018-08-06	2018-08-20	1	17763
2779	185	1125315	1982-05-03	1982-05-17	1	4519
41853	2835	1125315	2013-10-12	2013-10-19	1	15997
67	3	1310149	2001-07-23	2001-07-23	1	11526
49800	3392	19127890	1985-12-01	1986-11-26	1	6173
5442	371	1729720	1982-04-02	1982-04-09	1	4481
43835	2960	1759842	1997-09-21	1997-09-28	1	10132
2379	159	1177480	1976-05-19	1976-06-16	1	2358
2646	176	1759842	1969-02-09	1969-02-16	1	-319
48000	3258	1768849	1993-04-15	1993-05-20	1	8540
4442	304	1125315	1965-10-31	1965-11-14	1	-1509
49712	3386	1125315	1974-11-14	1974-11-28	1	1792
5074	347	1125315	1975-08-21	1975-09-04	1	2072
49431	3367	1124300	2002-10-10	2002-10-10	1	11970
5318	364	1125315	1950-02-13	1950-02-27	1	-7248
43098	2915	1759842	1985-08-30	1985-09-20	1	5741
56039	3817	1125315	1995-10-08	1995-12-07	1	9471
7625	526	1503184	1988-02-05	1989-01-30	1	6969
5026	343	1192710	1972-02-21	1972-02-21	1	781
32806	2222	1119510	1979-05-13	1979-05-20	1	3426
4129	280	1759842	1960-12-06	1960-12-27	1	-3292
45190	3067	1343916	1965-11-23	1965-11-23	1	-1500
3274	217	1125315	1993-09-30	1993-10-28	1	8701
46326	3145	1125315	2001-12-15	2002-01-05	1	11692
4405	299	1759842	1971-02-11	1971-03-04	1	427
50141	3415	1112807	1979-11-22	1980-02-20	1	3702
2995	197	1713332	1972-08-24	1972-09-14	1	987
48277	3279	1118084	1993-05-11	1993-05-11	1	8531
50566	3440	1778162	2009-07-11	2009-07-25	1	14450
4196	286	1125315	1928-08-05	1928-08-19	1	-15110
45239	3069	1521369	1975-08-13	1976-08-07	1	2410
2925	192	1728416	1952-04-12	1952-04-26	1	-6459
3185	211	1118084	2009-02-13	2009-02-13	1	14288
46057	3125	1112807	1986-12-22	1987-01-19	1	6227
43578	2945	1125315	2007-12-31	2008-01-07	1	13885
9956	685	1118084	2000-06-18	2000-06-18	1	11126
52342	3565	1713332	1979-06-14	1979-06-28	1	3465
2185	145	920293	1974-01-08	1974-01-15	1	1475
54388	3700	1125315	1970-06-11	1970-08-10	1	221
3699	249	1124300	2016-12-06	2016-12-06	1	17141
46804	3177	1125315	1985-12-15	1986-03-15	1	5917
57083	3890	1118084	1993-01-28	1993-01-28	1	8428
44618	3023	1549786	2005-08-29	2006-08-24	1	13384
4777	327	1125315	1976-04-07	1976-04-21	1	2302
5989	409	1713332	1994-12-06	1994-12-13	1	9112
49025	3337	1759842	2007-11-17	2007-12-01	1	13848
9246	642	1326303	2007-09-09	2007-09-09	1	13765
43027	2909	1501700	1999-02-12	1999-02-12	1	10634
4653	320	1102527	1974-03-01	1974-03-01	1	1520
4168	285	1125315	1982-09-19	1982-10-10	1	4665
1809	119	1503184	1974-12-06	1975-12-01	1	2160
5721	394	1125315	1997-01-28	1997-02-04	1	9896
50456	3436	1728416	1965-03-31	1965-04-14	1	-1723
4689	321	1112807	1962-05-11	1962-05-25	1	-2778
49732	3389	1125315	1976-07-28	1976-09-26	1	2460
3971	270	1713332	1995-10-02	1995-10-09	1	9412
72727	4971	1125315	1991-08-06	1991-08-20	1	7901
50297	3427	1125315	1969-11-29	1969-12-13	1	-19
2780	185	1125315	2015-02-21	2015-03-28	1	16522
41854	2835	1713332	1949-09-02	1949-09-23	1	-7405
68	3	1759842	1956-12-15	1956-12-29	1	-4751
54499	3708	1119510	1979-03-06	1979-03-20	1	3365
7104	489	1551099	1976-10-23	1976-10-23	1	2487
43836	2960	19127890	1976-12-19	1977-12-14	1	2904
2380	159	1322184	1997-08-26	1997-08-26	1	10099
4061	277	1125315	1986-11-20	1986-11-27	1	6174
48001	3258	920293	2008-06-30	2008-07-07	1	14067
4443	304	1125315	2003-09-03	2003-09-10	1	12305
49713	3386	1125315	1984-12-31	1984-12-31	1	5478
5075	347	1137529	1999-11-07	1999-11-07	1	10902
49432	3367	1177480	1994-06-17	1994-07-22	1	8968
5319	364	1125315	2014-09-05	2014-09-12	1	16325
43099	2915	1125315	1950-12-02	1950-12-23	1	-6949
56040	3817	1125315	2010-07-13	2010-07-27	1	14817
7626	526	1759842	2008-10-16	2008-10-23	1	14175
5027	343	1713332	2010-10-14	2010-10-21	1	14903
32807	2222	1125315	1973-05-08	1973-05-15	1	1230
4130	280	1112807	1962-03-10	1962-04-09	1	-2824
45191	3067	1713332	1968-04-02	1968-04-30	1	-611
3275	217	1125315	1997-09-04	1997-09-11	1	10115
46327	3145	1125315	2005-05-08	2005-05-15	1	12918
5094	349	1177480	2014-05-18	2014-06-08	1	16229
50142	3415	1115008	2015-08-22	2015-09-05	1	16683
2996	197	1112807	1973-01-11	1973-02-08	1	1134
48278	3279	1125315	1957-11-28	1957-12-12	1	-4403
50567	3440	1115008	2014-09-20	2014-10-04	1	16347
4197	286	1125315	1976-10-04	1976-11-10	1	2505
45240	3069	1713332	1995-08-23	1995-09-13	1	9386
2926	192	1112807	1944-04-24	1944-05-15	1	-9362
3186	211	1125315	1969-08-03	1969-08-10	1	-144
46058	3125	1119510	1967-08-20	1967-09-03	1	-851
43579	2945	1137529	1970-09-22	1970-09-22	1	264
9957	685	1125315	1966-03-09	1966-03-23	1	-1380
52343	3565	1759842	2008-03-16	2008-04-06	1	13975
2186	145	933724	1974-01-08	1974-01-15	1	1475
54389	3700	1713332	1982-07-31	1982-08-14	1	4608
3700	249	1177480	2004-11-19	2004-12-10	1	12762
46805	3177	1125315	2008-02-18	2008-03-19	1	13957
57084	3890	1125315	1955-07-07	1955-07-21	1	-5278
44619	3023	1729720	1995-07-15	1995-07-26	1	9337
4778	327	1125315	2000-07-17	2000-07-31	1	11169
5990	409	1759842	1994-12-06	1994-12-13	1	9112
49026	3337	914335	1983-12-05	1983-12-05	1	5086
9247	642	1759842	1955-06-09	1955-06-16	1	-5313
43028	2909	1759842	1992-02-08	1992-02-29	1	8094
4654	320	1112807	1973-02-06	1973-02-27	1	1153
4169	285	1118084	2006-07-30	2006-07-30	1	13359
1810	119	1713332	2000-01-23	2000-02-13	1	11000
5722	394	1174888	1989-03-27	1989-03-27	1	7025
50457	3436	1729720	1987-01-23	1987-02-01	1	6240
4690	321	1118084	2003-06-20	2003-06-20	1	12223
49733	3389	1125315	1998-04-05	1998-04-19	1	10335
3972	270	1759842	1994-06-19	1994-07-03	1	8949
72728	4971	1137529	2000-12-05	2000-12-05	1	11296
50298	3427	1125315	2014-04-28	2014-05-12	1	16202
2781	185	1149380	2014-06-01	2014-06-01	1	16222
41855	2835	1729720	1981-10-28	1981-11-04	1	4325
69	3	1125315	1956-12-15	1956-12-22	1	-4758
54500	3708	1129625	1978-01-26	1978-01-26	1	2947
7105	489	19127890	1995-04-27	1996-04-21	1	9607
43837	2960	1125315	1970-02-14	1970-03-14	1	72
2381	159	1728416	1959-07-09	1959-07-23	1	-3815
4062	277	1322184	2005-11-29	2005-11-29	1	13116
48002	3258	933724	2008-06-30	2008-07-07	1	14067
4444	304	1125315	2004-03-22	2004-04-19	1	12527
49714	3386	1177480	1984-12-31	1985-03-01	1	5538
6331	439	738818	2007-08-11	2007-08-18	1	13743
49433	3367	1177480	2010-10-10	2010-10-24	1	14906
5320	364	1125315	2017-08-18	2017-09-08	1	17417
43100	2915	1125315	1974-01-12	1974-01-26	1	1486
56041	3817	1125315	2011-05-17	2011-05-31	1	15125
7627	526	933724	2004-05-28	2004-06-04	1	12573
5028	343	1551099	1971-02-25	1971-02-25	1	420
32808	2222	1125315	1987-06-07	1987-06-21	1	6380
4131	280	1119510	1947-08-13	1947-08-27	1	-8163
45192	3067	738818	1970-10-09	1970-10-23	1	295
3276	217	1125315	2010-09-16	2010-09-30	1	14882
46328	3145	1112807	1975-04-06	1975-04-20	1	1935
5095	349	1503184	1976-08-01	1977-07-27	1	2764
50143	3415	1118084	2005-04-14	2005-04-14	1	12887
2997	197	1119510	1968-09-08	1968-09-15	1	-473
48279	3279	1125315	1958-07-11	1958-07-25	1	-4178
50568	3440	1124300	1980-10-21	1980-10-21	1	3946
4198	286	1125315	1982-03-16	1982-03-30	1	4471
45241	3069	1729720	1967-07-30	1967-08-08	1	-877
2927	192	1112807	1946-07-04	1946-08-08	1	-8547
3187	211	1125315	2003-03-07	2003-03-28	1	12139
46059	3125	1125315	2010-07-06	2010-07-13	1	14803
43580	2945	1177480	1979-12-05	1979-12-19	1	3639
9958	685	1125315	1968-02-05	1968-02-19	1	-682
55743	3793	1125315	1994-04-14	1994-04-21	1	8876
2187	145	1112807	1973-01-28	1973-03-29	1	1183
54390	3700	1713332	2007-06-12	2007-07-03	1	13697
3701	249	1515774	2000-07-23	2001-07-18	1	11521
46806	3177	1310149	2012-05-09	2012-05-09	1	15469
57085	3890	1125315	1962-09-29	1962-10-13	1	-2637
44620	3023	1759842	2013-01-09	2013-01-16	1	15721
4779	327	1177480	2010-09-30	2010-10-21	1	14903
7181	495	1125315	1971-03-04	1971-03-25	1	448
49027	3337	1118084	2007-02-15	2007-02-15	1	13559
9248	642	757627	2016-01-17	2016-01-17	1	16817
43029	2909	19059528	1962-04-07	1962-04-07	1	-2826
4655	320	1125315	1971-09-14	1971-09-21	1	628
4170	285	1115008	2009-08-28	2009-09-11	1	14498
1811	119	1778162	2015-02-15	2015-03-01	1	16495
5723	394	1361711	1989-10-23	1997-12-29	1	10224
50458	3436	1102527	1976-04-23	1976-04-23	1	2304
4691	321	1119510	1973-04-13	1973-04-27	1	1212
49734	3389	1728416	1961-01-18	1961-02-01	1	-3256
3973	270	1759842	1995-10-02	1995-10-09	1	9412
72729	4971	1174888	2000-11-12	2000-11-12	1	11273
50299	3427	1729720	1974-07-24	1974-07-31	1	1672
2782	185	1332418	1996-02-18	1996-02-18	1	9544
41856	2835	1112807	1913-11-07	1913-12-07	1	-20479
70	3	1125315	1986-10-04	1986-12-03	2	6180
54501	3708	1154343	1979-05-20	1979-05-20	1	3426
7106	489	1118084	2016-09-03	2016-09-03	1	17047
43838	2960	1729720	1956-03-19	1956-03-29	1	-5026
2382	159	1729720	1968-04-20	1968-04-30	1	-611
4063	277	1717327	1966-09-16	1966-09-30	1	-1189
48003	3258	1115008	1995-07-09	1995-10-07	1	9410
4445	304	1125315	2017-12-14	2017-12-14	1	17514
49715	3386	1521369	1984-11-17	1985-11-12	1	5794
6332	439	1115008	2002-12-21	2003-01-04	1	12056
49434	3367	1119510	1965-12-19	1966-01-02	1	-1460
5321	364	1713332	1961-05-18	1961-06-01	1	-3136
43101	2915	1125315	2007-07-07	2007-07-14	1	13708
56042	3817	1102527	1995-10-08	1995-10-08	1	9411
7628	526	1112807	1977-01-23	1977-02-06	1	2593
5029	343	1713332	2007-08-11	2007-08-25	1	13750
32809	2222	1361711	2012-07-24	2012-07-24	1	15545
4132	280	1125315	1962-03-10	1962-03-10	1	-2854
45193	3067	738818	2018-07-13	2018-07-20	1	17732
3277	217	1713332	1982-05-28	1982-06-18	1	4551
46329	3145	1713332	1974-11-14	1974-11-28	1	1792
5096	349	1503184	1978-07-22	1979-07-17	1	3484
50144	3415	1125315	1985-10-22	1985-10-29	1	5780
2998	197	1125315	1984-08-24	1984-09-07	1	5363
48280	3279	1125315	2010-02-06	2010-02-20	1	14660
50569	3440	1125315	1942-10-07	1942-10-14	1	-9941
4199	286	1125315	2016-05-08	2016-08-06	1	17019
45242	3069	1759842	1995-08-23	1995-09-13	1	9386
2928	192	1125315	1973-10-21	1973-10-28	1	1396
3188	211	1738521	1973-02-12	1973-02-26	1	1152
46060	3125	1713332	2017-07-27	2017-08-17	1	17395
43581	2945	1713332	1972-07-18	1972-08-01	1	943
9959	685	1728416	1968-02-05	1968-02-19	1	-682
55744	3793	1112807	1959-05-22	1959-06-12	1	-3856
2188	145	1125315	1953-04-01	1953-04-15	1	-6105
54391	3700	1738521	1971-04-02	1971-04-16	1	470
3702	249	19127890	2000-07-23	2001-07-18	1	11521
46807	3177	920293	1948-10-18	1948-10-25	1	-7738
57086	3890	1728416	1955-07-07	1955-07-21	1	-5278
44621	3023	933724	2008-11-29	2008-12-06	1	14219
7594	525	1000560	1952-05-22	1952-05-22	2	-6433
7182	495	1713332	2018-09-27	2018-10-18	1	17822
49028	3337	1125315	1977-08-26	1977-09-25	1	2824
9249	642	1102527	1989-12-23	1989-12-23	1	7296
44253	2993	1125315	2007-12-17	2008-01-07	2	13885
4656	320	1125315	1984-10-10	1984-10-17	1	5403
4171	285	1125315	2010-06-15	2010-07-20	1	14810
1812	119	19127890	1976-11-25	1978-11-15	2	3240
5724	394	1539403	1991-11-04	1991-11-04	1	7977
50459	3436	1124300	2003-02-20	2003-02-20	1	12103
4692	321	1125315	1978-03-02	1978-03-23	1	3003
49735	3389	1115008	2016-12-25	2017-01-08	1	17174
3974	270	1759842	2006-04-07	2006-04-14	1	13252
72730	4971	1177480	2000-11-12	2000-12-12	1	11303
50300	3427	1102527	2018-08-06	2018-08-06	1	17749
2783	185	1539403	1996-02-18	1996-02-18	1	9544
41857	2835	1112807	1956-07-15	1956-08-19	1	-4883
71	3	1174888	1986-10-04	1986-10-04	1	6120
54502	3708	1503184	2000-03-23	2001-03-18	1	11399
7107	489	1125315	1987-04-29	1987-05-13	1	6341
47778	3242	1118084	2015-11-25	2015-11-25	1	16764
2383	159	1112807	1962-04-07	1962-04-28	1	-2805
4064	277	738818	1986-11-20	1986-11-27	1	6174
48004	3258	1125315	1983-03-25	1983-04-08	1	4845
4446	304	1125315	2018-05-26	2018-06-09	1	17691
49716	3386	1738521	1970-10-22	1970-11-05	1	308
6333	439	1125315	1993-04-08	1993-06-07	1	8558
49435	3367	1125315	1992-04-23	1992-04-30	1	8155
5322	364	1713332	1975-04-22	1975-04-29	1	1944
43102	2915	1759842	1947-04-01	1947-04-22	1	-8290
56043	3817	1125315	1964-12-21	1965-01-04	1	-1823
7629	526	1115008	1998-11-29	1998-12-27	1	10587
5030	343	1738521	1971-11-22	1971-12-06	1	704
32810	2222	738818	1967-07-03	1967-07-10	1	-906
4133	280	1125315	1981-01-08	1981-01-15	1	4032
45194	3067	914335	1960-12-20	1960-12-20	1	-3299
3278	217	1713332	1994-05-21	1994-06-11	1	8927
46330	3145	1717327	1975-04-06	1975-04-20	1	1935
5097	349	1521369	1981-07-06	1983-06-26	2	4924
50145	3415	1125315	1992-01-28	1992-02-04	1	8069
2999	197	1729720	2015-02-26	2015-03-07	1	16501
48281	3279	1125315	2016-08-04	2016-08-18	1	17031
50570	3440	1174888	1959-01-10	1959-01-10	1	-4009
5663	388	723013	2017-09-26	2018-01-09	1	17540
45243	3069	1125315	1969-01-27	1969-03-28	1	-279
2929	192	1125315	2017-07-17	2017-07-24	1	17371
3189	211	740275	1967-10-12	1968-03-28	1	-644
46061	3125	1759842	1966-05-03	1966-05-17	1	-1325
43582	2945	1713332	1988-10-02	1988-10-23	1	6870
9960	685	1759842	1968-05-04	1968-05-25	1	-586
55745	3793	1125315	2008-08-07	2008-08-21	1	14112
2189	145	1125315	1977-12-17	1977-12-31	1	2921
54392	3700	1728416	1970-03-13	1970-03-27	1	85
3703	249	1503184	1997-08-08	1998-08-03	1	10441
46808	3177	1112807	1917-03-16	1917-03-30	1	-19270
57087	3890	1729720	1960-03-16	1960-03-29	1	-3565
44622	3023	1125315	2014-04-05	2014-04-12	1	16172
7595	525	1112807	1955-01-03	1955-01-17	1	-5463
7183	495	1125315	1998-12-08	1998-12-22	1	10582
49029	3337	1713332	1981-02-13	1981-03-06	1	4082
9250	642	1112807	1935-10-26	1936-01-08	1	-12412
44254	2993	1177480	2017-01-19	2017-02-09	1	17206
4657	320	1137529	1993-06-20	1993-06-20	1	8571
4172	285	1778162	2009-08-28	2009-09-11	1	14498
2321	155	1125315	2011-05-22	2011-06-19	1	15144
5725	394	1125315	1962-11-14	1962-11-21	1	-2598
50460	3436	1125315	1964-08-05	1964-08-12	1	-1968
4693	321	1729720	1989-08-17	1989-08-27	1	7178
49736	3389	1124300	1996-06-08	1996-06-08	1	9655
3975	270	914335	2012-06-05	2012-06-05	1	15496
72731	4971	1322184	2008-01-15	2008-01-15	1	13893
50301	3427	1713332	2018-08-06	2018-08-20	1	17763
2784	185	1728416	1948-08-16	1948-08-30	1	-7794
41858	2835	1119510	1998-01-23	1998-02-06	1	10263
72	3	1177480	1987-11-28	1987-12-26	1	6568
54503	3708	1549786	2001-03-18	2002-03-13	1	11759
7108	489	1177480	1999-09-07	1999-10-07	1	10871
47779	3242	1125315	1988-04-24	1988-05-08	1	6702
2384	159	1119510	1971-12-17	1971-12-31	1	729
4065	277	1124300	2001-01-05	2001-01-05	1	11327
48005	3258	1515774	1997-05-20	1998-05-15	1	10361
4447	304	1713332	1964-05-24	1964-06-14	1	-2027
51193	3488	1102527	1991-06-29	1991-06-29	1	7849
6334	439	1125315	2007-08-11	2007-08-18	1	13743
50010	3409	933724	2002-07-01	2002-07-15	1	11883
5323	364	1728416	1950-02-13	1950-02-27	1	-7248
43103	2915	1112807	1955-10-28	1955-11-18	1	-5158
56044	3817	1125315	2012-09-16	2012-09-23	1	15606
7630	526	1115008	2008-09-05	2008-09-19	1	14141
5031	343	1759842	2007-08-11	2007-08-25	1	13750
32811	2222	1125315	1967-07-03	1967-07-10	1	-906
4134	280	1125315	2009-01-03	2009-01-10	1	14254
45195	3067	914335	1965-11-23	1965-11-23	1	-1500
3279	217	1759842	1982-05-28	1982-06-18	1	4551
47680	3237	1112807	1928-05-02	1928-05-23	1	-15198
5098	349	1713332	1990-10-06	1990-10-20	1	7597
50146	3415	1125315	2005-11-12	2005-11-26	1	13113
3000	197	1125315	1985-09-15	1985-09-29	1	5750
48282	3279	1728416	1957-11-28	1957-12-12	1	-4403
50571	3440	1713332	2004-07-22	2004-08-05	1	12635
5664	388	1112807	1957-08-20	1957-09-03	1	-4503
45244	3069	1125315	1971-04-28	1971-05-05	1	489
2930	192	1322184	2014-07-02	2014-07-02	1	16253
3190	211	723013	1968-06-20	1968-12-26	1	-371
48393	3289	738818	2007-04-04	2007-04-11	1	13614
43583	2945	1728416	1950-11-18	1950-12-02	1	-6970
9961	685	1125315	1991-03-24	1991-04-07	1	7766
55746	3793	1713332	2012-08-24	2012-08-31	1	15583
2190	145	1728416	1953-04-01	1953-04-15	1	-6105
54393	3700	1738521	1978-08-04	1978-08-18	1	3151
3704	249	1515774	1995-08-19	1996-08-13	1	9721
46809	3177	1112807	1942-03-10	1942-03-24	1	-10145
60483	4124	1729720	2002-06-11	2002-06-19	1	11857
44623	3023	1595799	2000-09-24	2001-09-19	1	11584
7596	525	1115008	2013-03-04	2013-03-18	1	15782
7184	495	1125315	2006-01-22	2006-01-29	1	13177
49030	3337	1713332	2007-11-17	2007-12-01	1	13848
9251	642	1112807	1936-06-06	1936-06-20	1	-12248
44255	2993	1713332	1994-11-29	1994-12-20	1	9119
4658	320	1729720	1981-11-19	1981-11-29	1	4350
5293	363	738818	1977-05-01	1977-05-15	1	2691
2322	155	1713332	1961-09-03	1961-09-17	1	-3028
5726	394	1125315	1997-12-29	1997-12-29	1	10224
50461	3436	1125315	1979-04-12	1979-04-19	1	3395
4694	321	19127890	1976-11-03	1978-10-24	2	3218
49737	3389	1125315	1963-02-21	1963-03-07	1	-2492
3976	270	1125315	1966-08-23	1966-08-30	1	-1220
72732	4971	920293	1992-10-06	1992-10-13	1	8321
50302	3427	1738521	1969-11-29	1969-12-13	1	-19
2785	185	1112807	1947-04-07	1947-04-21	1	-8291
41859	2835	1125315	1989-10-21	1989-11-27	1	7270
73	3	1322184	2012-09-24	2012-09-24	1	15607
54504	3708	1713332	1992-02-09	1992-02-16	1	8081
7109	489	19127890	1990-05-23	1991-05-18	1	7807
47780	3242	1729720	1989-07-03	1989-07-14	1	7134
2385	159	1124300	1989-08-28	1989-08-28	1	7179
4066	277	1125315	1987-09-26	1987-10-17	1	6498
48006	3258	1713332	1996-04-05	1996-04-19	1	9605
4448	304	1729720	2005-09-14	2005-09-23	1	13049
51194	3488	1112807	1954-04-20	1954-05-04	1	-5721
6335	439	1713332	1982-06-26	1982-07-10	1	4573
50011	3409	920293	2002-07-01	2002-07-15	2	11883
5324	364	1119510	1948-01-20	1948-02-03	1	-8003
43104	2915	1125315	1954-10-03	1955-01-01	1	-5479
56045	3817	1728416	1968-07-31	1968-08-14	1	-505
7631	526	1713332	2008-10-16	2008-10-23	1	14175
5032	343	920293	1999-03-05	1999-03-12	1	10662
32812	2222	1322184	2012-07-24	2012-07-24	1	15545
4135	280	1125315	2017-08-17	2017-08-31	1	17409
45196	3067	1112807	1945-09-02	1945-09-16	1	-8873
3280	217	1759842	1994-05-21	1994-06-11	1	8927
47681	3237	1119510	1981-12-04	1981-12-18	1	4369
5099	349	1759842	1990-10-06	1990-10-20	1	7597
50147	3415	1119510	1992-01-28	1992-02-04	1	8069
3001	197	1759842	1972-08-24	1972-09-14	1	987
50393	3434	1112807	1965-08-12	1965-11-10	1	-1513
50572	3440	1729720	1985-06-30	1985-07-11	1	5670
5665	388	1115008	2000-04-04	2000-04-18	1	11065
45245	3069	1177480	1991-06-13	1991-06-27	1	7847
2931	192	1125315	2014-04-02	2014-04-16	1	16176
3191	211	1112807	1973-02-12	1973-02-26	1	1152
48394	3289	1112807	1961-06-24	1961-07-15	1	-3092
43584	2945	1729720	1945-10-19	1945-11-01	1	-8827
9962	685	1713332	1968-05-04	1968-05-25	1	-586
55747	3793	1125315	1967-05-01	1967-05-29	2	-948
4481	308	1125315	1961-08-11	1961-08-18	1	-3058
54394	3700	1112807	1970-03-13	1970-03-27	1	85
3705	249	1549786	1995-08-19	1996-08-13	1	9721
46810	3177	1124300	1950-04-27	1950-04-27	1	-7189
60484	4124	1125315	1977-02-28	1977-03-14	1	2629
44624	3023	1713332	2013-01-09	2013-01-16	1	15721
7597	525	1125315	1994-09-07	1994-09-14	1	9022
7185	495	1713332	2017-04-16	2017-04-30	1	17286
49031	3337	738818	2010-07-24	2010-07-31	1	14821
9252	642	1115008	2017-11-18	2017-12-18	1	17518
44256	2993	19127890	1991-05-04	1992-04-28	1	8153
4659	320	1729720	2008-10-09	2008-10-22	1	14174
5294	363	1112807	1965-08-01	1965-09-05	1	-1579
2323	155	1759842	1994-05-22	1994-05-29	1	8914
5727	394	1174888	1997-12-29	1997-12-29	1	10224
50462	3436	1177480	1976-04-23	1976-05-21	1	2332
4695	321	19127890	1979-10-19	1980-10-13	1	3938
49738	3389	1125315	2005-02-04	2005-02-18	1	12832
3977	270	1309944	2012-06-05	2012-06-05	1	15496
72733	4971	1125315	1964-08-29	1964-09-12	1	-1937
52524	3577	1112807	1963-03-30	1963-04-13	1	-2455
2786	185	1137529	2014-06-01	2014-06-01	1	16222
41860	2835	1713332	1983-01-28	1983-02-11	1	4789
74	3	1326303	2001-07-23	2001-07-23	1	11526
54505	3708	1713332	2014-05-20	2014-05-27	1	16217
7110	489	1129625	1976-11-03	1976-11-03	1	2498
47781	3242	738818	1985-04-02	1985-04-09	1	5577
2386	159	1125315	1984-04-05	1984-06-04	1	5268
4067	277	1347450	2005-11-29	2005-11-29	1	13116
48007	3258	1759842	1996-04-05	1996-04-19	1	9605
4449	304	738818	2003-09-03	2003-09-10	1	12305
51195	3488	1125315	1960-04-20	1960-05-04	1	-3529
6336	439	1778162	2002-12-21	2003-01-04	1	12056
50012	3409	1112807	1966-11-15	1966-12-06	1	-1122
5325	364	1119510	1951-05-12	1951-05-19	1	-6802
43105	2915	1713332	1947-04-01	1947-04-22	1	-8290
57381	3916	1115008	2003-07-23	2003-10-21	1	12346
7632	526	920293	2004-05-28	2004-06-04	1	12573
5033	343	1125315	1981-10-01	1981-10-08	1	4298
32813	2222	1332418	2012-07-24	2012-07-24	1	15545
4136	280	1174888	1962-03-10	1962-03-10	1	-2854
45197	3067	1119510	1971-07-21	1971-08-04	1	580
3924	266	1125315	1967-05-27	1967-07-10	1	-906
47682	3237	1124300	1964-09-15	1964-09-15	1	-1934
5100	349	1115008	2001-09-09	2001-09-23	1	11588
50148	3415	1729720	2008-05-22	2008-05-29	1	14028
3002	197	738818	1968-09-08	1968-09-15	1	-473
50394	3434	1728416	1954-01-10	1954-01-24	1	-5821
52294	3562	1118084	2014-03-28	2014-03-28	1	16157
5666	388	1125315	1969-09-16	1969-10-14	1	-79
45246	3069	1713332	2011-07-13	2011-07-20	1	15175
2932	192	1125315	2018-09-18	2018-09-25	1	17799
3192	211	1713332	2016-11-27	2016-12-11	1	17146
48395	3289	1119510	1986-10-13	1986-10-20	1	6136
43585	2945	1729720	1992-03-25	1992-04-04	1	8129
9963	685	1713332	2016-01-11	2016-01-25	1	16825
55748	3793	1557272	1999-05-25	1999-05-25	1	10736
4482	308	1125315	2006-04-07	2006-04-21	1	13259
54395	3700	1125315	1971-04-02	1971-04-16	1	470
3706	249	1549786	1998-08-03	2001-07-18	3	11521
46811	3177	1125315	1936-05-16	1936-05-30	1	-12269
60485	4124	1125315	1985-08-29	1985-09-12	1	5733
44625	3023	1125315	1985-11-02	1985-11-16	1	5798
7598	525	1713332	1964-04-22	1964-06-03	1	-2038
7186	495	1729720	1979-01-18	1979-01-25	1	3311
50786	3455	1503184	1993-03-31	1994-03-26	1	8850
9253	642	1118084	1971-06-09	1971-06-09	1	524
44257	2993	1112807	1989-02-03	1989-02-24	1	6994
4660	320	920293	1977-04-01	1977-04-08	1	2654
5295	363	1125315	1977-05-01	1977-05-15	1	2691
2324	155	1118084	1990-09-20	1990-09-20	1	7567
5728	394	1322184	1997-02-03	1997-12-29	1	10224
50463	3436	1759842	1983-05-14	1983-06-04	1	4902
4696	321	1119510	1991-12-29	1992-01-12	1	8046
49739	3389	1174888	1973-01-15	1973-01-15	1	1110
3978	270	1343916	2012-06-05	2012-06-05	1	15496
72734	4971	1125315	1968-03-06	1968-03-20	1	-652
52525	3577	1118084	1996-05-09	1996-05-09	1	9625
2787	185	1728416	1947-04-07	1947-04-21	1	-8291
43117	2917	701322	2019-03-07	2019-03-07	1	17962
75	3	1332418	2012-09-24	2012-09-24	1	15607
54506	3708	1759842	1992-02-09	1992-02-16	1	8081
7111	489	1521369	1990-05-23	1991-05-18	1	7807
47782	3242	1125315	1982-01-09	1982-01-16	1	4398
2387	159	1177480	2013-11-06	2013-12-11	1	16050
4068	277	1119510	1986-11-20	1986-11-27	1	6174
48008	3258	1768849	1985-03-31	1985-04-14	1	5582
4450	304	1125315	1957-04-02	1957-07-01	1	-4567
51196	3488	1125315	1990-06-13	1990-07-04	1	7489
6337	439	1115008	2002-10-18	2002-11-08	1	11999
50013	3409	1124300	1999-08-19	1999-08-19	1	10822
5326	364	1124300	1983-08-07	1983-08-07	1	4966
43106	2915	1713332	1985-08-30	1985-09-20	1	5741
57382	3916	1177480	2010-11-20	2010-12-25	1	14968
7633	526	933724	2004-03-21	2004-03-28	1	12505
5034	343	1125315	1988-11-25	1988-12-09	1	6917
32814	2222	1539403	2012-07-24	2012-07-24	1	15545
4137	280	1177480	1991-02-02	1991-04-03	1	7762
45198	3067	1125315	1958-05-11	1958-05-25	1	-4239
3925	266	1125315	2018-09-26	2018-09-26	1	17800
47683	3237	1125315	2012-02-19	2012-03-11	1	15410
5101	349	1125315	1994-01-21	1994-02-04	1	8800
51887	3533	1125315	1972-06-04	1972-06-18	1	899
3003	197	1125315	1968-09-08	1968-09-15	1	-473
50395	3434	1729720	1994-07-30	1994-08-12	1	8989
52295	3562	1125315	1974-07-21	1974-08-20	1	1692
5667	388	1728416	1957-08-20	1957-09-03	1	-4503
45247	3069	1759842	2011-07-13	2011-07-20	1	15175
2933	192	1759842	1991-08-12	1991-08-19	1	7900
3193	211	1759842	2016-11-27	2016-12-11	1	17146
48396	3289	1125315	1960-10-18	1960-11-01	1	-3348
43586	2945	1759842	1988-10-02	1988-10-23	1	6870
9964	685	1759842	2016-01-11	2016-01-25	1	16825
55749	3793	1729720	2002-02-06	2002-02-17	1	11735
4483	308	1125315	2016-11-25	2016-12-09	1	17144
54396	3700	1125315	1971-07-06	1971-09-11	1	618
3707	249	1595799	1998-08-03	2000-07-23	2	11161
46812	3177	1125315	1986-09-08	1986-09-15	1	6101
60486	4124	1713332	2000-04-13	2000-05-04	1	11081
46935	3183	1125315	1998-02-11	1998-02-25	1	10282
7599	525	1713332	1988-06-04	1988-09-03	1	6820
7187	495	1759842	2017-04-16	2017-04-30	1	17286
50787	3455	1713332	1979-08-08	1979-08-29	1	3527
9254	642	1119510	1950-06-06	1950-06-13	1	-7142
44258	2993	1521369	1988-05-19	1989-05-14	1	7073
4661	320	933724	1977-04-01	1977-04-08	1	2654
5296	363	1174888	2005-07-01	2005-07-01	1	12965
2325	155	1125315	2014-04-02	2014-04-16	1	16176
5729	394	1332418	1994-11-21	1994-11-21	1	9090
50815	3456	1125315	1978-10-07	1978-11-25	2	3236
4697	321	1503184	1976-11-03	1978-10-24	2	3218
49740	3389	1713332	2007-04-01	2007-04-22	1	13625
3979	270	1713332	2000-08-21	2000-08-28	1	11197
72735	4971	1125315	2000-11-12	2000-11-12	1	11273
52526	3577	1521369	1975-02-24	1976-02-19	1	2240
2788	185	1729720	1982-09-24	1982-10-07	1	4662
43118	2917	757627	2017-02-15	2017-02-15	1	17212
76	3	1539403	2012-09-24	2012-09-24	1	15607
54507	3708	1759842	2014-05-20	2014-05-27	1	16217
7112	489	1551099	1977-10-19	1977-10-19	1	2848
47783	3242	1125315	1985-04-02	1985-04-09	1	5577
2388	159	1539403	1991-03-26	1991-03-26	1	7754
4069	277	1125315	1976-01-29	1976-02-05	1	2226
48009	3258	1521369	1995-05-31	1996-05-25	1	9641
4451	304	1125315	1968-10-01	1968-11-05	1	-422
51197	3488	1729720	1993-03-19	1993-03-30	1	8489
6338	439	1119510	2007-08-11	2007-08-18	1	13743
50014	3409	1125315	1982-05-27	1982-06-03	1	4536
5327	364	1713332	1986-12-05	1986-12-12	1	6189
43107	2915	1729720	1955-03-19	1955-03-31	1	-5390
57383	3916	1503184	1995-09-15	1996-09-09	1	9748
7634	526	1125315	1973-07-15	1973-07-22	1	1298
5035	343	1551099	1972-10-19	1972-10-19	1	1022
32815	2222	1717327	1963-12-20	1964-01-03	1	-2190
4138	280	1539403	2015-02-27	2015-02-27	1	16493
45199	3067	1125315	1970-10-09	1970-10-23	1	295
3926	266	1551099	1973-02-24	1973-02-24	1	1150
47684	3237	1713332	1931-10-04	1931-10-11	1	-13962
5102	349	1557272	2018-04-28	2018-04-28	1	17649
51888	3533	1177480	1996-07-03	1996-08-07	1	9715
5175	352	1115008	2002-01-27	2002-02-17	1	11735
50396	3434	738818	1978-08-22	1978-09-05	1	3169
52296	3562	1125315	1983-10-30	1983-12-04	1	5085
5668	388	1112807	1965-06-18	1965-07-09	1	-1637
45248	3069	19127890	1975-08-13	1976-08-07	1	2410
5219	357	1125315	1959-12-16	1960-01-15	1	-3639
5459	374	705944	1992-11-04	1997-11-13	1	10178
48397	3289	1503184	1974-11-23	1975-11-18	1	2147
45719	3105	738818	1990-06-04	1990-06-18	1	7473
9965	685	1125315	1977-07-09	1977-07-30	1	2767
55750	3793	1738521	1967-05-01	1967-05-29	1	-948
4484	308	1112807	1962-02-05	1962-03-05	1	-2859
54397	3700	1125315	1973-12-23	1974-01-06	1	1466
3708	249	1729720	2013-07-21	2013-08-01	1	15918
46813	3177	1125315	1993-10-04	1993-11-03	1	8707
60487	4124	1759842	2000-04-13	2000-05-04	1	11081
46936	3183	1177480	1983-04-29	1983-05-13	1	4880
7600	525	1746114	1952-05-22	1952-05-22	1	-6433
7188	495	1115008	2001-10-13	2001-11-03	1	11629
50788	3455	1717327	1971-03-17	1971-03-31	1	454
9255	642	1125315	1985-06-08	1985-06-22	1	5651
44259	2993	1713332	2007-12-17	2008-01-07	1	13885
4662	320	1118084	1995-08-28	1995-08-28	1	9370
5297	363	1759842	1965-06-09	1965-06-16	1	-1660
2326	155	1177480	1985-09-21	1985-10-05	1	5756
5730	394	1361711	1978-06-05	1989-03-27	1	7025
50816	3456	1713332	1986-05-12	1986-05-26	1	5989
4698	321	1503184	1979-10-19	1980-10-13	1	3938
49741	3389	1728416	1963-02-21	1963-03-07	1	-2492
3980	270	1728416	1958-12-01	1958-12-15	1	-4035
72736	4971	1149380	2000-12-05	2000-12-05	1	11296
52527	3577	1112807	1961-05-28	1961-06-11	1	-3126
2789	185	1759842	1947-04-12	1947-05-03	1	-8279
43119	2917	1125315	2016-08-31	2016-09-14	1	17058
1771	117	1124957	1982-09-22	1982-09-22	1	4647
54508	3708	19127890	1992-05-04	1995-04-19	3	9239
7113	489	1125315	1975-11-28	1975-12-12	1	2171
47784	3242	1125315	2002-10-04	2002-10-18	1	11978
2389	159	1729720	1957-12-02	1957-12-12	1	-4403
4070	277	1125315	2010-12-09	2010-12-16	1	14959
48010	3258	1549786	2005-04-08	2006-04-03	1	13241
4452	304	1125315	2010-04-21	2010-04-28	1	14727
51198	3488	1112807	1967-12-08	1968-01-05	1	-727
6339	439	1125315	1980-06-15	1980-06-29	1	3832
50015	3409	1125315	1985-10-25	1985-11-01	1	5783
5328	364	1728416	1947-10-20	1947-11-03	1	-8095
43805	2959	1125315	1975-03-31	1975-06-29	1	2005
57384	3916	1503184	1997-09-04	1998-08-30	1	10468
7635	526	1125315	1988-04-06	1988-04-13	1	6677
5036	343	1759842	2010-10-14	2010-10-21	1	14903
33344	2264	1728416	1972-06-15	1972-06-29	1	910
4139	280	1545958	2019-05-31	2019-05-31	1	18047
45200	3067	1125315	1994-10-18	1994-11-01	1	9070
3927	266	1713332	2003-07-31	2003-08-21	1	12285
47685	3237	1759842	1931-10-04	1931-10-11	1	-13962
5103	349	1759842	1997-06-11	1997-06-25	1	10037
51889	3533	1738521	1969-02-04	1969-02-18	1	-317
5176	352	1125315	1996-10-03	1996-10-10	1	9779
50397	3434	738818	2001-04-11	2001-04-25	1	11437
52297	3562	1713332	1998-06-02	1998-09-01	1	10470
5669	388	1125315	1956-08-04	1956-08-18	1	-4884
45249	3069	1112807	1968-02-11	1968-03-03	1	-669
5220	357	1728416	1977-06-28	1977-07-12	1	2749
5460	374	1115008	1995-01-23	1995-02-20	1	9181
48398	3289	1118084	1995-09-29	1995-09-29	1	9402
45720	3105	1119510	2016-07-02	2016-07-16	1	16998
9966	685	1125315	1980-04-15	1980-05-20	1	3792
55751	3793	1112807	1944-12-01	1945-01-05	1	-9127
4485	308	1112807	1964-11-21	1964-12-05	1	-1853
54398	3700	1125315	2010-04-03	2010-04-03	1	14702
3709	249	920293	2017-09-10	2017-09-17	1	17426
46814	3177	1125315	2006-04-08	2006-04-15	1	13253
60488	4124	1124300	2014-03-01	2014-03-01	1	16130
46937	3183	975125	2014-02-10	2014-02-10	1	16111
7601	525	1759842	1988-06-04	1988-09-03	1	6820
7189	495	1759842	2018-09-27	2018-10-18	1	17822
50789	3455	1729720	1983-01-15	1983-01-26	1	4773
9256	642	1177480	1989-12-23	1990-01-20	1	7324
44260	2993	1149380	2007-09-01	2007-09-01	1	13757
4663	320	1125315	1959-11-30	1960-01-29	1	-3625
5298	363	1125315	2005-07-01	2005-07-01	1	12965
2327	155	1728416	1958-12-12	1958-12-26	1	-4024
5731	394	1112807	1922-03-21	1922-06-19	1	-17363
50817	3456	1728416	1945-10-07	1945-10-21	1	-8838
4699	321	1713332	1991-04-21	1991-05-12	1	7801
49742	3389	1729720	2003-03-28	2003-04-10	1	12152
3981	270	1759842	1964-10-31	1964-11-07	1	-1881
72737	4971	1361711	1995-11-07	1995-11-07	1	9441
52528	3577	1125315	1966-05-21	1966-06-04	1	-1307
3118	207	1125315	1996-10-25	1996-11-01	1	9801
43120	2917	1177480	2013-08-19	2013-09-16	1	15964
1772	117	1125315	2015-01-21	2015-01-28	1	16463
54509	3708	19127890	1996-04-13	1997-04-08	1	9959
7114	489	1177480	2000-08-02	2000-08-30	1	11199
47785	3242	1177480	1988-03-06	1988-05-05	1	6699
2390	159	1729720	1968-08-29	1968-09-05	1	-483
4071	277	1125315	1966-09-16	1966-09-30	1	-1189
48011	3258	1589505	2003-04-19	2004-04-13	1	12521
4453	304	1759842	1964-05-24	1964-06-14	1	-2027
51199	3488	1125315	1955-05-23	1955-06-06	1	-5323
6340	439	1125315	1983-05-31	1983-06-30	1	4928
50016	3409	1125315	2002-11-11	2002-12-09	1	12030
5329	364	1759842	1961-05-18	1961-06-01	1	-3136
43806	2959	1125315	2018-06-03	2018-06-17	1	17699
57385	3916	1521369	1997-09-04	1998-08-30	1	10468
7636	526	1125315	2018-04-14	2018-04-21	1	17642
5037	343	933724	1999-03-05	1999-03-12	1	10662
33345	2264	933724	1989-05-31	1989-06-07	1	7097
4140	280	1713332	1960-12-06	1960-12-27	1	-3292
45201	3067	1125315	1998-03-08	1998-03-29	1	10314
3928	266	1738521	1967-06-26	1967-07-10	1	-906
47686	3237	1759842	1950-03-05	1950-03-26	1	-7221
5104	349	1759842	2012-09-11	2012-10-02	1	15615
51890	3533	1112807	1969-02-04	1969-02-18	1	-317
5177	352	1125315	2007-04-18	2007-04-25	1	13628
50398	3434	1112807	1954-01-10	1954-01-24	1	-5821
52298	3562	1125315	1975-06-16	1975-07-14	1	2020
5670	388	1129625	1956-10-04	1956-10-04	1	-4837
45250	3069	1118084	2001-10-25	2001-10-25	1	11620
5221	357	1112807	1956-03-06	1956-03-20	1	-5035
5461	374	1521369	1993-11-04	1994-10-30	1	9068
48399	3289	1125315	1957-12-29	1958-01-12	1	-4372
45721	3105	1125315	1981-12-26	1982-01-02	1	4384
9967	685	1125315	2005-05-23	2005-06-13	1	12947
55752	3793	1112807	1949-12-10	1950-02-08	1	-7267
4486	308	1125315	1963-01-11	1963-01-18	1	-2540
54399	3700	1177480	2010-04-03	2010-04-24	1	14723
3710	249	1115008	2005-11-05	2005-11-26	1	13113
46815	3177	1309944	2003-01-08	2003-01-08	1	12060
60489	4124	1125315	2013-03-22	2013-03-29	1	15793
46938	3183	1118084	2017-07-14	2017-07-14	1	17361
7602	525	1112807	1965-03-25	1965-06-23	1	-1653
7190	495	1118084	2005-06-28	2005-06-28	1	12962
50790	3455	1759842	1979-08-08	1979-08-29	1	3527
9257	642	1307863	2007-09-09	2007-09-09	1	13765
44261	2993	1174888	2007-12-17	2007-12-17	1	13864
4664	320	1125315	1974-02-22	1974-04-30	1	1580
5299	363	1729720	1974-06-19	1974-07-02	1	1643
2328	155	1192710	1959-05-27	1959-05-27	1	-3872
5732	394	1124300	1957-06-10	1957-06-10	1	-4588
50818	3456	1728416	1946-10-11	1946-10-25	1	-8469
4700	321	1713332	1998-10-26	1998-11-09	1	10539
49743	3389	1759842	2010-08-12	2010-09-02	1	14854
3982	270	1759842	2000-08-21	2000-08-28	1	11197
72738	4971	933724	1992-10-06	1992-10-13	1	8321
52529	3577	1177480	1993-04-10	1993-06-09	1	8560
3119	207	1557272	2011-04-10	2011-04-10	1	15074
43121	2917	1307863	1989-09-13	1989-09-13	1	7195
1773	117	1118084	2009-01-13	2009-01-13	1	14257
54510	3708	19127890	2002-03-13	2002-05-31	1	11838
7115	489	1503184	1990-05-23	1991-05-18	1	7807
47786	3242	1759842	1986-12-05	1986-12-26	1	6203
2391	159	738818	1971-12-17	1971-12-31	1	729
4072	277	1729720	1964-03-02	1964-03-10	1	-2123
48012	3258	1729720	1989-04-26	1989-05-03	1	7062
4454	304	1115008	2017-12-07	2018-01-13	1	17544
51200	3488	1125315	1990-04-05	1990-04-12	1	7406
6341	439	19127890	1992-09-20	1993-09-15	1	8658
50017	3409	1177480	1984-06-04	1984-06-18	1	5282
5330	364	1759842	1975-04-22	1975-04-29	1	1944
43807	2959	1551099	1977-09-17	1977-09-17	1	2816
57386	3916	1549786	1993-09-25	1994-09-20	1	9028
7637	526	1713332	2000-10-29	2000-11-12	1	11273
5038	343	1112807	1971-11-22	1971-12-06	1	704
33346	2264	1112807	1972-06-15	1972-06-29	1	910
5349	366	738818	1983-02-22	1983-03-08	1	4814
45202	3067	1125315	2003-10-21	2003-10-28	1	12353
3929	266	1759842	2003-07-31	2003-08-21	1	12285
47687	3237	1119510	1928-07-02	1928-07-16	1	-15144
5105	349	19127890	1976-08-01	1977-07-27	1	2764
51891	3533	1177480	2000-04-18	2000-05-09	1	11086
5178	352	1713332	1988-12-04	1988-12-18	1	6926
50399	3434	1125315	1968-09-06	1968-09-13	1	-475
52299	3562	1729720	1997-02-04	1997-02-11	1	9903
5671	388	1728416	1956-08-04	1956-08-18	1	-4884
45862	3115	933724	2006-02-24	2006-03-03	1	13210
5222	357	1118084	1996-04-20	1996-04-20	1	9606
5462	374	1125315	2004-07-10	2004-07-17	1	12616
48400	3289	1125315	1958-10-27	1958-11-10	1	-4070
45722	3105	1125315	1990-06-04	1990-06-18	1	7473
9968	685	1717327	1966-03-09	1966-03-23	1	-1380
55753	3793	1115008	2003-11-16	2003-12-21	1	12407
4487	308	1125315	1964-11-09	1964-11-16	1	-1872
54400	3700	1713332	2010-04-03	2010-04-24	1	14723
3711	249	1521369	1997-08-08	2000-07-23	3	11161
46816	3177	1322184	2012-05-30	2012-05-30	1	15490
61556	4202	1125315	1995-02-10	1995-02-24	1	9185
46939	3183	1125315	1982-05-06	1982-05-13	1	4515
7603	525	1118084	1990-03-15	1990-03-15	1	7378
7191	495	1125315	1969-08-11	1969-08-25	1	-129
50791	3455	19127890	1986-05-07	1987-05-02	1	6330
9258	642	1713332	1955-06-09	1955-06-16	1	-5313
44262	2993	1503184	1991-05-04	1992-04-28	1	8153
4665	320	1177480	1998-06-14	1998-07-12	1	10419
5300	363	1759842	1973-10-06	1974-03-16	1	1535
2329	155	1759842	1961-09-03	1961-09-17	1	-3028
5733	394	1125315	1989-03-27	1989-03-27	1	7025
50819	3456	738818	1959-01-17	1959-01-24	1	-3995
10819	743	1119510	2006-09-15	2006-09-29	1	13420
49930	3403	1768849	1982-10-19	1982-11-02	1	4688
3983	270	1112807	1958-12-01	1958-12-15	1	-4035
72739	4971	1112807	1971-07-06	1971-08-03	1	579
52530	3577	1713332	1971-07-29	1971-08-19	1	595
3120	207	1728416	1945-10-08	1945-10-22	1	-8837
43122	2917	1759842	2014-02-22	2014-03-08	1	16137
1774	117	1125315	1979-09-08	1979-09-22	1	3551
54511	3708	738818	1979-03-06	1979-03-20	1	3365
7116	489	1503184	1995-04-27	1996-04-21	1	9607
47787	3242	1713332	2013-07-08	2013-07-22	1	15908
2392	159	738818	1997-08-18	1997-08-25	1	10098
5784	399	1112807	1960-01-07	1960-02-11	1	-3612
52427	3571	1125315	2017-07-17	2017-07-31	1	17378
4455	304	1125315	1978-01-17	1978-02-07	1	2959
51201	3488	1137529	1991-08-02	1991-08-02	1	7883
6342	439	1125315	1987-08-17	1987-08-24	1	6444
50018	3409	1521369	1974-05-17	1975-05-12	1	1957
5331	364	1759842	1986-12-05	1986-12-12	1	6189
43808	2959	1115008	2005-01-22	2005-02-05	1	12819
57387	3916	1118084	2016-05-07	2016-05-07	1	16928
7638	526	1759842	2000-10-29	2000-11-12	1	11273
5039	343	1118084	2005-09-09	2005-09-09	1	13035
33347	2264	1738521	1972-03-26	1972-04-09	1	829
5350	366	920293	1951-03-06	1951-03-13	1	-6869
45203	3067	1125315	2015-11-09	2015-12-09	1	16778
3930	266	1124300	2006-10-04	2006-10-04	1	13425
47688	3237	1125315	1959-01-16	1959-01-30	1	-3989
5106	349	19127890	1978-07-22	1979-07-17	1	3484
51892	3533	1521369	1979-11-05	1980-10-30	1	3955
5179	352	1118084	2012-08-28	2012-08-28	1	15580
50400	3434	1125315	1978-08-22	1978-09-05	1	3169
52300	3562	1125315	2005-11-06	2005-11-27	1	13114
5672	388	1118084	1988-10-25	1988-10-25	1	6872
45863	3115	1112807	1968-10-26	1968-11-09	1	-418
5223	357	1125315	2000-02-24	2000-03-02	1	11018
5463	374	1713332	1987-08-05	1987-08-19	1	6439
48401	3289	1728416	1957-07-15	1957-07-29	1	-4539
45723	3105	1738521	1971-12-17	1971-12-31	1	729
11348	776	738818	1979-08-22	1979-08-29	1	3527
55754	3793	1118084	1982-11-07	1982-11-07	1	4693
4488	308	1713332	2013-11-01	2013-11-15	1	16024
54401	3700	1759842	2007-06-12	2007-07-03	1	13697
3712	249	1521369	2002-07-13	2003-07-08	1	12241
46817	3177	1343916	2003-01-08	2003-01-08	1	12060
61557	4202	1129625	1976-06-03	1976-06-03	1	2345
46940	3183	1125315	1999-07-04	1999-09-02	2	10836
7604	525	1125315	1950-03-30	1950-04-13	1	-7203
9863	677	1125315	1967-03-03	1967-04-07	1	-1000
50792	3455	723013	2000-04-03	2000-10-09	1	11239
9259	642	1713332	2005-08-17	2005-08-24	1	13019
44263	2993	19127890	1988-05-19	1989-05-14	1	7073
4666	320	1112807	1968-07-27	1968-08-31	1	-488
5301	363	1759842	2003-09-12	2003-10-03	1	12328
2330	155	1112807	1958-12-12	1958-12-26	1	-4024
5734	394	1545958	1997-12-29	1997-12-29	1	10224
50820	3456	1112807	1943-07-08	1943-07-22	1	-9660
10820	743	1125315	1983-08-23	1983-09-06	1	4996
49931	3403	19127890	1986-03-12	1987-03-07	1	6274
3984	270	1112807	1982-04-13	1982-05-04	1	4506
72740	4971	1118084	1978-02-10	1978-02-10	1	2962
52531	3577	1713332	1973-08-16	1973-08-30	1	1337
3121	207	1125315	1961-08-31	1961-10-05	1	-3010
43123	2917	1112807	1939-01-20	1939-02-03	1	-11290
1775	117	1125315	1984-11-29	1984-12-06	1	5453
54512	3708	920293	1999-06-05	1999-06-12	1	10754
7117	489	1521369	1995-04-27	1996-04-21	1	9607
47788	3242	1729720	2014-09-13	2014-09-25	1	16338
2393	159	1112807	1955-08-12	1955-08-26	1	-5242
5785	399	1118084	1997-05-07	1997-05-07	1	9988
52428	3571	1192710	1975-09-13	1975-09-13	1	2081
4456	304	1118084	1998-03-18	1998-03-18	1	10303
51202	3488	1177480	1991-06-29	1991-07-29	1	7879
6343	439	1503184	1992-09-20	1993-09-15	1	8658
50019	3409	1729720	1955-11-17	1955-11-25	1	-5151
5332	364	738818	1951-05-12	1951-05-19	1	-6802
43809	2959	1124300	2009-12-27	2009-12-27	1	14605
57388	3916	1125315	1997-06-17	1997-07-24	2	10066
7639	526	19127890	1988-02-05	1989-01-30	1	6969
5040	343	1125315	1987-06-01	1987-08-30	1	6450
33348	2264	920293	1989-05-31	1989-06-07	1	7097
5351	366	1112807	1923-01-17	1923-02-07	1	-17130
45204	3067	1125315	2018-07-13	2018-07-20	1	17732
3931	266	1177480	2018-09-26	2018-11-25	1	17860
47689	3237	1713332	1931-06-24	1931-07-01	1	-14064
5107	349	1125315	1969-08-28	1969-10-27	1	-66
51893	3533	1112807	1963-04-23	1963-05-07	1	-2431
5180	352	1125315	1981-09-26	1981-10-10	1	4300
50401	3434	1125315	2001-04-11	2001-04-25	1	11437
52301	3562	1759842	1998-06-02	1998-09-01	1	10470
5673	388	1125315	1994-08-16	1994-08-30	1	9007
45864	3115	1119510	2008-03-12	2008-03-26	1	13964
5224	357	1557272	2014-12-10	2014-12-10	1	16414
5464	374	1759842	1987-08-05	1987-08-19	1	6439
48402	3289	1728416	1957-12-29	1958-01-12	1	-4372
45724	3105	1112807	1970-11-22	1970-12-20	1	353
11349	776	920293	1991-08-27	1991-09-03	1	7915
55755	3793	1174888	1967-05-01	1967-05-01	1	-976
4489	308	1759842	2013-11-01	2013-11-15	1	16024
54925	3736	1118084	1987-07-20	1987-07-20	1	6409
3713	249	933724	2017-09-10	2017-09-17	1	17426
46818	3177	914335	2003-01-08	2003-01-08	1	12060
61558	4202	1759842	1999-11-15	1999-11-22	1	10917
46941	3183	1125315	2017-05-30	2017-06-29	1	17346
7605	525	1125315	2000-09-17	2000-10-08	1	11238
9864	677	1729720	1972-03-22	1972-03-31	1	820
50793	3455	1115008	2017-09-02	2017-10-07	1	17446
9260	642	1729720	2013-12-31	2014-01-10	1	16080
44264	2993	1118084	2012-09-15	2012-09-15	1	15598
4667	320	1125315	1961-02-23	1961-03-09	1	-3220
5302	363	1112807	1968-08-15	1968-08-29	1	-490
2331	155	1125315	2005-07-09	2005-07-16	1	12980
5735	394	1713332	1956-01-27	1956-02-10	1	-5074
50821	3456	1112807	1945-10-07	1945-10-21	1	-8838
10821	743	1125315	2006-09-15	2006-09-29	1	13420
49932	3403	1115008	2012-10-07	2012-11-11	1	15655
3985	270	1118084	1995-05-16	1995-05-16	1	9266
72741	4971	1322184	1997-11-18	2007-09-04	1	13760
52532	3577	1125315	2013-08-28	2013-09-04	1	15952
3122	207	1729720	2018-08-09	2018-08-16	1	17759
43124	2917	1125315	1941-02-10	1941-02-17	1	-10545
1776	117	1125315	2002-03-21	2002-03-28	1	11774
54513	3708	1124300	2015-06-18	2015-06-18	1	16604
7118	489	1717327	1975-11-28	1975-12-12	1	2171
47789	3242	1759842	2013-07-08	2013-07-22	1	15908
2394	159	1125315	1971-12-17	1971-12-31	1	729
5786	399	1119510	2016-12-01	2016-12-15	1	17150
52429	3571	1729720	1977-05-28	1977-06-08	1	2715
4457	304	1174888	2017-12-14	2017-12-14	1	17514
51203	3488	1728416	1954-04-20	1954-05-04	1	-5721
6344	439	1118084	2013-05-08	2013-05-08	1	15833
50020	3409	1729720	1955-12-27	1956-01-06	1	-5109
5333	364	1125315	1951-05-12	1951-05-19	1	-6802
43810	2959	1125315	1993-02-24	1993-03-10	1	8469
57389	3916	1125315	2007-08-01	2007-10-07	1	13793
10742	738	1118084	2014-01-11	2014-01-11	1	16081
5041	343	1125315	1994-04-13	1994-04-27	1	8882
33349	2264	1112807	1972-03-26	1972-04-09	1	829
5352	366	1119510	1966-10-18	1966-11-01	1	-1157
45205	3067	1343916	1960-12-20	1960-12-20	1	-3299
3932	266	1551099	1984-12-25	1984-12-25	1	5472
47690	3237	1729720	1928-06-05	1928-06-17	1	-15173
5108	349	1713332	2008-09-11	2008-09-25	1	14147
51894	3533	1124300	2001-01-03	2001-01-03	1	11325
5181	352	1713332	1983-03-12	1983-03-26	1	4832
50402	3434	1729720	1964-01-19	1964-02-01	1	-2161
52302	3562	1125315	1990-01-01	1990-01-29	1	7333
5674	388	1125315	2006-02-16	2006-03-02	1	13209
45865	3115	1125315	2008-03-12	2008-03-26	1	13964
5225	357	1729720	1967-06-11	1967-06-21	1	-925
5465	374	1124300	2015-07-17	2015-07-17	1	16633
48403	3289	19127890	1974-11-23	1975-11-18	1	2147
45725	3105	1112807	1971-12-17	1971-12-31	1	729
11350	776	933724	1991-08-27	1991-09-03	1	7915
55756	3793	1759842	2012-08-24	2012-08-31	1	15583
4490	308	1729720	1963-12-30	1964-01-08	1	-2185
54926	3736	1119510	1964-09-13	1964-09-20	1	-1929
3714	249	1125315	2011-01-19	2011-01-26	1	15000
46819	3177	1112807	1924-12-04	1924-12-18	1	-16450
61559	4202	975125	1976-01-04	1976-01-18	1	2208
46942	3183	1713332	1983-04-29	1983-05-13	1	4880
7606	525	1713332	2003-02-10	2003-03-03	1	12114
9865	677	1112807	1977-09-11	1977-10-16	1	2845
50794	3455	1118084	2009-11-02	2009-11-02	1	14550
9261	642	715997	2016-12-12	2016-12-12	1	17147
44265	2993	1137529	2007-09-01	2007-09-01	1	13757
4668	320	1125315	1995-08-08	1995-08-29	1	9371
5303	363	1115008	1996-01-24	1996-02-28	1	9554
2332	155	1713332	1994-05-22	1994-05-29	1	8914
5736	394	1112807	1938-07-25	1938-08-08	1	-11469
50822	3456	1112807	1946-10-11	1946-10-25	1	-8469
10822	743	19127890	1992-10-13	1993-10-08	1	8681
49933	3403	1118084	2008-08-08	2008-08-08	1	14099
3986	270	1713332	1964-10-31	1964-11-07	1	-1881
72742	4971	1539403	1995-11-07	1995-11-07	1	9441
52533	3577	1503184	1975-02-24	1976-02-19	1	2240
3123	207	1112807	1941-03-19	1941-04-02	1	-10501
43125	2917	1310149	1989-09-13	1989-09-13	1	7195
1777	117	1713332	1970-04-06	1970-04-20	1	109
54514	3708	1125315	1979-03-06	1979-03-20	1	3365
8172	569	933724	1935-05-26	1935-06-02	1	-12632
47790	3242	1119510	1985-04-02	1985-04-09	1	5577
2395	159	1361711	1985-03-19	1985-03-19	1	5556
5787	399	1125315	1969-02-23	1969-02-23	1	-312
52430	3571	1759842	1975-11-01	1975-11-15	1	2144
4458	304	1729720	2018-12-27	2019-01-03	1	17899
51204	3488	1728416	1955-05-23	1955-06-06	1	-5323
6345	439	1125315	1980-10-14	1980-10-21	1	3946
50021	3409	920293	2004-08-25	2004-09-01	1	12662
5334	364	1125315	1988-05-05	1988-05-12	1	6706
43811	2959	1149380	1973-12-28	1993-02-23	1	8454
57390	3916	1125315	2012-10-07	2012-10-21	1	15634
10743	738	1125315	1988-04-22	1988-05-06	1	6700
5042	343	1713332	1989-05-08	1989-05-22	1	7081
33350	2264	1124300	2009-06-15	2009-06-15	1	14410
5353	366	1125315	1983-02-22	1983-03-08	1	4814
45206	3067	920293	1983-01-20	1983-01-27	1	4774
3933	266	1728416	1971-09-17	1971-10-01	1	638
47691	3237	738818	1981-12-04	1981-12-18	1	4369
5109	349	1759842	2008-09-11	2008-09-25	1	14147
51895	3533	1125315	2000-05-25	2000-06-08	1	11116
5182	352	1125315	1991-09-11	1991-09-18	1	7930
50403	3434	1112807	1951-06-06	1951-08-12	1	-6717
52303	3562	1713332	1980-09-23	1980-10-07	1	3932
7222	498	738818	1972-04-16	1972-04-30	1	850
45866	3115	1125315	2009-09-09	2009-09-30	1	14517
5226	357	1729720	1992-07-11	1992-07-24	1	8240
5466	374	1125315	1991-03-05	1991-03-19	1	7747
48404	3289	1119510	2007-04-04	2007-04-11	1	13614
45726	3105	1112807	1972-02-29	1972-03-14	1	803
11351	776	1119510	1961-09-15	1961-09-29	1	-3016
57987	3956	738818	1924-03-22	1924-04-05	1	-16707
4491	308	1112807	1976-01-21	1976-02-11	1	2232
54927	3736	1125315	1985-07-31	1985-08-07	1	5697
3715	249	1521369	2004-07-06	2005-07-01	1	12965
46820	3177	1112807	1959-04-24	1959-05-15	1	-3884
61560	4202	1177480	1974-02-28	1974-03-30	1	1549
46943	3183	1112807	1988-05-02	1988-06-01	1	6726
7607	525	1728416	1950-03-30	1950-04-13	1	-7203
9866	677	1177480	1982-01-23	1982-02-13	1	4426
50795	3455	1125315	2014-08-19	2014-09-18	1	16331
9262	642	738818	1950-06-06	1950-06-13	1	-7142
44266	2993	1503184	1988-05-19	1989-05-14	1	7073
4669	320	1177480	2004-08-09	2004-08-23	1	12653
5304	363	1115008	2005-07-01	2005-07-31	1	12995
4616	318	738818	2004-07-05	2004-07-19	1	12618
5737	394	1119510	1982-01-22	1982-01-29	1	4411
50823	3456	1112807	1949-10-04	1949-10-18	1	-7380
10823	743	19127890	1997-09-17	1998-09-12	1	10481
49934	3403	1521369	1984-03-22	1985-03-17	1	5554
5479	376	1112807	1964-03-12	1964-03-26	1	-2107
72743	4971	1557272	2015-02-24	2015-02-24	1	16490
52534	3577	1728416	1963-03-30	1963-04-13	1	-2455
3124	207	1112807	1945-10-08	1945-10-22	1	-8837
43126	2917	1713332	1941-10-12	1941-10-19	1	-10301
1778	117	1713332	1981-09-24	1981-10-08	1	4298
54515	3708	1125315	1980-10-24	1980-11-07	1	3963
8173	569	933724	1941-07-06	1941-07-13	1	-10399
47791	3242	1713332	1986-12-05	1986-12-26	1	6203
2396	159	1102527	1997-12-30	1997-12-30	1	10225
5788	399	1125315	1972-03-09	1972-03-30	1	819
52431	3571	1125315	1980-10-07	1980-10-14	1	3939
4755	326	1125315	1980-01-10	1980-04-09	1	3751
51205	3488	1112807	1957-06-18	1957-07-02	1	-4566
6346	439	1125315	1982-06-26	1982-07-10	1	4573
50022	3409	933724	2004-08-25	2004-09-01	1	12662
5335	364	1125315	2016-09-10	2016-09-24	1	17068
43812	2959	1154343	1973-12-28	1993-02-23	1	8454
57391	3916	1500211	1992-09-30	1993-09-25	1	8668
10744	738	1125315	1990-07-04	1990-07-18	1	7503
5043	343	1759842	1989-05-08	1989-05-22	1	7081
34094	2315	1125315	1984-08-23	1984-08-30	1	5355
5354	366	1125315	1999-07-03	1999-07-10	1	10782
45207	3067	933724	1983-01-20	1983-01-27	1	4774
3934	266	1112807	1971-09-17	1971-10-01	1	638
47692	3237	738818	2000-01-17	2000-01-31	1	10987
5110	349	19127890	1981-07-06	1983-06-26	2	4924
51896	3533	1503184	1979-11-05	1980-10-30	1	3955
5183	352	1112807	1978-06-13	1978-06-27	1	3099
50404	3434	1115008	2009-04-23	2009-05-14	1	14378
52304	3562	1759842	1980-09-23	1980-10-07	1	3932
7223	498	1125315	1972-04-16	1972-04-30	1	850
45867	3115	1503184	1985-12-21	1986-12-16	1	6193
5227	357	1112807	1968-04-16	1968-05-16	1	-595
5467	374	1503184	1993-11-04	1994-10-30	1	9068
48405	3289	1125315	1989-06-07	1989-06-14	1	7104
45727	3105	1112807	1972-12-30	1973-01-13	1	1108
11352	776	1125315	1967-05-27	1967-06-10	1	-936
57988	3956	1119510	1944-09-12	1944-09-19	1	-9235
4492	308	1124300	1999-02-26	1999-02-26	1	10648
54928	3736	1309944	2006-06-28	2006-06-28	1	13327
3716	249	1713332	1987-01-31	1987-02-07	1	6246
46821	3177	1124957	1942-03-10	1942-03-10	1	-10159
61561	4202	1551099	1972-10-06	1972-10-06	1	1009
46944	3183	1124957	1999-07-04	1999-07-04	1	10776
7608	525	1729720	1952-12-18	1952-12-31	1	-6210
9867	677	1728416	1965-03-13	1965-03-27	1	-1741
50796	3455	1177480	2012-08-08	2012-08-29	1	15581
9263	642	1112807	1940-07-24	1940-08-07	1	-10739
44267	2993	1521369	1991-05-04	1992-04-28	1	8153
4670	320	1728416	1957-11-10	1957-11-24	1	-4421
5305	363	1124300	2001-01-09	2001-01-09	1	11331
4617	318	1119510	1961-04-23	1961-05-07	1	-3161
5738	394	1125315	1953-03-10	1953-03-24	1	-6127
50824	3456	1125315	1959-01-17	1959-01-24	1	-3995
10824	743	738818	2006-09-15	2006-09-29	1	13420
49935	3403	1112807	1986-07-21	1986-08-04	1	6059
5480	376	1112807	1965-04-06	1965-07-05	1	-1641
72744	4971	1112807	1936-06-25	1936-07-09	1	-12229
52535	3577	1125315	2011-03-08	2011-03-15	1	15048
3125	207	1118084	1975-07-29	1975-07-29	1	2035
43127	2917	1713332	1952-06-20	1952-06-27	1	-6397
1779	117	1125315	1974-07-08	1974-07-15	1	1656
54516	3708	1125315	2011-01-15	2011-02-05	1	15010
8174	569	1112807	1915-02-11	1915-02-25	1	-20034
49102	3343	1125315	2001-03-30	2001-04-06	1	11418
2397	159	1112807	1963-05-23	1963-06-27	1	-2380
5789	399	1125315	1999-03-30	1999-05-04	1	10715
52432	3571	1125315	2001-04-04	2001-04-11	1	11423
4756	326	1177480	1995-06-20	1995-07-11	1	9322
51206	3488	1125315	2000-01-19	2000-01-26	1	10982
6347	439	1521369	1992-09-20	1993-09-15	1	8658
50023	3409	1102527	2011-04-26	2011-04-26	1	15090
5336	364	1125315	2018-07-05	2018-08-04	1	17747
43813	2959	1177480	1986-09-29	1986-12-28	1	6205
57392	3916	1713332	1980-12-22	1981-01-05	1	4022
10745	738	1125315	2000-08-29	2000-09-05	1	11205
6405	443	1112807	1970-01-10	1970-01-24	1	23
34095	2315	1759842	1980-04-21	1980-05-05	1	3777
5355	366	1729720	2011-12-23	2012-01-04	1	15343
45208	3067	1112807	1943-02-01	1943-03-01	1	-9803
3935	266	1174888	2018-09-26	2018-09-26	1	17800
47693	3237	1119510	2000-01-17	2000-01-31	1	10987
5111	349	1124300	1994-02-08	1994-02-08	1	8804
51897	3533	1112807	1973-07-13	1973-08-03	1	1310
5184	352	1112807	1980-11-13	1980-11-27	1	3983
50405	3434	1119510	2001-04-11	2001-04-25	1	11437
53807	3660	920293	1998-09-23	1998-09-30	1	10499
7224	498	1125315	2007-05-16	2007-06-06	1	13670
45868	3115	1521369	1990-11-25	1991-11-20	1	7993
5228	357	1125315	1992-03-28	1992-04-04	1	8129
5468	374	1729720	2002-07-24	2002-08-03	1	11902
48406	3289	1125315	2007-04-04	2007-04-11	1	13614
45728	3105	1119510	1990-06-04	1990-06-18	1	7473
11353	776	1125315	1979-08-22	1979-08-29	1	3527
57989	3956	1119510	1975-11-07	1975-11-14	1	2143
4493	308	1125315	1996-04-04	1996-04-18	1	9604
54929	3736	1343916	2006-06-28	2006-06-28	1	13327
3717	249	1759842	1987-01-31	1987-02-07	1	6246
46822	3177	1125315	1920-02-01	1920-02-08	1	-18225
61562	4202	1713332	1999-11-15	1999-11-22	1	10917
46945	3183	1125315	1993-10-19	1993-11-02	1	8706
7609	525	1729720	1997-04-03	1997-04-13	1	9964
9868	677	1112807	1965-03-13	1965-03-27	1	-1741
50797	3455	1503184	1986-05-07	1987-05-02	1	6330
9264	642	1112807	1949-12-11	1950-01-01	1	-7305
44268	2993	1759842	1994-11-29	1994-12-20	1	9119
4671	320	1112807	1957-11-10	1957-11-24	1	-4421
5306	363	1125315	1990-08-25	1990-09-22	1	7569
4618	318	1119510	1974-03-07	1974-03-21	1	1540
5739	394	1759842	1956-01-27	1956-02-10	1	-5074
50825	3456	1118084	1982-07-13	1982-07-13	1	4576
10825	743	1119510	1983-08-23	1983-09-06	1	4996
49936	3403	1125315	1980-03-03	1980-03-24	1	3735
5481	376	1521369	1979-04-03	1980-03-28	1	3739
72745	4971	1125315	1979-01-09	1979-01-16	1	3302
52536	3577	1177480	1978-05-29	1978-08-27	1	3160
3126	207	1125315	1963-02-23	1963-03-09	1	-2490
43128	2917	1729720	1990-02-08	1990-02-15	1	7350
1780	117	1759842	1970-04-06	1970-04-20	1	109
54517	3708	1177480	1981-05-12	1981-05-26	1	4163
8175	569	1174888	2009-01-29	2009-01-29	1	14273
49103	3343	1149380	1978-06-13	1978-06-13	1	3085
2398	159	1125315	1997-08-18	1997-08-25	1	10098
5790	399	1713332	1977-04-02	1977-04-23	1	2669
52433	3571	1551099	1972-12-17	1972-12-17	1	1081
4757	326	1729720	1972-02-22	1972-02-29	1	789
51207	3488	1149380	1991-08-02	1991-08-02	1	7883
6348	439	1713332	1986-07-23	1986-08-13	1	6068
50024	3409	1125315	1957-05-06	1957-08-04	1	-4533
5337	364	1177480	1991-08-21	1991-09-04	1	7916
43814	2959	1551099	1972-05-15	1972-05-15	1	865
57393	3916	1778162	2010-11-20	2010-12-25	1	14968
10746	738	1729720	1989-08-21	1989-08-28	1	7179
6406	443	1124300	2005-09-29	2005-09-29	1	13055
34096	2315	1177480	1984-01-24	1984-02-21	1	5164
5356	366	1759842	1914-09-05	1914-11-28	1	-20123
45209	3067	1119510	1991-09-10	1991-09-17	1	7929
3936	266	1729720	1999-04-22	1999-05-05	1	10716
47694	3237	1125315	1951-08-21	1951-09-04	1	-6694
5112	349	1503184	1981-07-06	1983-06-26	2	4924
51898	3533	1125315	1994-10-09	1994-10-23	1	9061
5185	352	1112807	1988-12-04	1988-12-18	1	6926
50406	3434	1112807	1961-02-20	1961-03-06	1	-3223
53808	3660	1125315	1979-03-18	1979-04-15	1	3391
7225	498	1125315	1974-08-02	1974-08-16	1	1688
45869	3115	1713332	1988-12-07	1988-12-14	1	6922
5229	357	1713332	1983-10-09	1984-01-08	1	5120
5469	374	1729720	2015-10-17	2015-10-27	1	16735
48407	3289	1521369	1974-11-23	1975-11-18	1	2147
45729	3105	1713332	1981-05-03	1981-05-10	1	4147
11354	776	1177480	2011-08-16	2011-09-15	1	15232
57990	3956	1125315	1924-03-22	1924-04-05	1	-16707
4494	308	1717327	1964-11-21	1964-12-05	1	-1853
54930	3736	1728416	1954-03-05	1954-03-19	1	-5767
3718	249	19127890	1995-08-19	1996-08-13	1	9721
46823	3177	1125315	1964-02-18	1964-03-19	1	-2114
61563	4202	1729720	1990-09-29	1990-10-07	1	7584
46946	3183	1192710	1981-08-20	1981-08-20	1	4249
7610	525	708298	1952-05-22	1952-05-22	1	-6433
9869	677	1118084	1997-01-09	1997-01-09	1	9870
50798	3455	1521369	1983-05-23	1985-05-12	2	5610
9265	642	1115008	2010-12-20	2011-01-10	1	14984
46733	3175	738818	2010-07-09	2010-07-23	1	14813
4672	320	1112807	1960-12-24	1961-01-07	1	-3281
5307	363	1125315	1995-10-16	1995-10-23	1	9426
4619	318	1124957	2011-02-11	2011-02-11	1	15016
10237	704	975125	1986-12-15	1986-12-15	1	6192
50826	3456	1125315	1977-08-22	1977-09-12	1	2811
10826	743	1124300	2011-11-08	2011-11-08	1	15286
49937	3403	1177480	2005-11-22	2005-12-13	1	13130
5482	376	1759842	1966-09-07	1966-09-14	1	-1205
72746	4971	1125315	2000-05-27	2000-06-03	1	11111
52537	3577	1728416	1961-05-28	1961-06-11	1	-3126
3127	207	1125315	2009-03-23	2009-03-30	1	14333
43129	2917	715997	2019-03-07	2019-03-07	1	17962
1781	117	1125315	1982-09-22	1982-10-22	2	4677
54518	3708	1503184	1996-04-13	1997-04-08	1	9959
8176	569	1177480	1999-10-05	1999-12-04	1	10929
49104	3343	1177480	2016-03-08	2016-04-12	1	16903
2399	159	1177480	1997-12-23	1998-02-28	1	10285
5791	399	738818	2016-12-01	2016-12-15	1	17150
52434	3571	1759842	2004-11-18	2004-12-02	1	12754
4758	326	1729720	1979-09-23	1979-10-06	1	3565
51208	3488	1124300	1992-05-30	1992-05-30	1	8185
6349	439	1713332	1990-01-03	1990-01-17	1	7321
50025	3409	1125315	1960-08-18	1960-09-01	1	-3409
5604	384	738818	2008-02-10	2008-02-17	1	13926
43815	2959	914335	1997-10-07	1997-10-07	1	10141
57394	3916	19127890	1993-09-25	1994-09-20	1	9028
10747	738	1759842	2016-03-09	2016-03-23	1	16883
6407	443	1125315	1991-06-23	1991-07-07	1	7857
34097	2315	1713332	1989-10-09	1989-10-23	1	7235
5357	366	1112807	1912-01-15	1912-01-29	1	-21157
45210	3067	1119510	2018-07-13	2018-07-20	1	17732
5549	380	738818	2009-08-25	2009-09-08	1	14495
47695	3237	1125315	1954-06-20	1954-07-11	1	-5653
5113	349	1521369	1976-08-01	1977-07-27	1	2764
51899	3533	1717327	1963-04-23	1963-05-07	1	-2431
5186	352	1125315	1983-03-12	1983-03-26	1	4832
50407	3434	1119510	1978-08-22	1978-09-05	1	3169
53809	3660	1125315	2005-04-28	2005-05-05	1	12908
7226	498	1125315	1977-08-16	1977-09-20	1	2819
45870	3115	1717327	1968-10-26	1968-11-09	1	-418
5230	357	1728416	1956-03-06	1956-03-20	1	-5035
5470	374	1125315	1986-04-06	1986-04-20	1	5953
48408	3289	1729720	1993-04-20	1993-05-03	1	8523
45730	3105	1759842	1981-05-03	1981-05-10	1	4147
11355	776	1713332	2002-01-22	2002-02-12	1	11730
57991	3956	1177480	1974-12-10	1974-12-24	1	1818
6226	430	1112807	1938-10-11	1938-12-10	1	-11345
54931	3736	1729720	1985-04-12	1985-04-24	1	5592
3719	249	19127890	1997-08-08	1998-08-03	1	10441
46824	3177	1125315	2008-06-05	2008-06-19	1	14049
61564	4202	1118084	2009-01-20	2009-01-20	1	14264
46947	3183	1551099	1981-08-07	1981-08-07	1	4236
7611	525	1110410	1952-05-22	1952-05-22	1	-6433
9870	677	1125315	2016-11-11	2016-11-25	1	17130
50799	3455	1521369	1993-03-31	1994-03-26	1	8850
9266	642	1125315	1950-06-06	1950-06-13	1	-7142
46734	3175	933724	2006-12-17	2006-12-24	1	13506
4673	320	1112807	1961-11-03	1961-12-01	1	-2953
5308	363	1125315	2000-03-08	2000-03-29	1	11045
4620	318	1557272	2013-09-02	2013-09-02	1	15950
10238	704	1112807	1977-06-08	1977-07-06	1	2743
50827	3456	1309944	1991-12-12	1991-12-12	1	8015
10827	743	1125315	1991-11-08	1991-12-06	2	8009
49938	3403	1729720	1980-11-01	1980-11-08	1	3964
5483	376	1112807	1969-02-14	1969-05-15	1	-231
72747	4971	1125315	2004-01-26	2004-02-25	1	12473
52538	3577	1728416	1966-05-21	1966-06-04	1	-1307
3128	207	1177480	2009-07-25	2009-09-23	1	14510
43130	2917	1112807	1940-04-28	1940-05-12	1	-10826
1782	117	1759842	1981-09-24	1981-10-08	1	4298
54519	3708	1515774	1992-05-04	1995-04-19	3	9239
8177	569	1347450	1998-05-30	1998-05-30	1	10376
49105	3343	1192710	1977-07-13	1977-07-13	1	2750
2400	159	1332418	1994-01-25	1994-01-25	1	8790
5792	399	1125315	2016-12-01	2016-12-15	1	17150
52435	3571	975125	1986-12-08	1986-12-22	1	6199
4759	326	1118084	2004-03-09	2004-03-09	1	12486
51209	3488	1125315	1959-10-14	1959-10-28	1	-3718
6350	439	1729720	1981-07-07	1981-07-19	1	4217
50026	3409	1125315	1968-05-06	1968-05-20	1	-591
5605	384	920293	2013-06-27	2013-07-04	1	15890
43816	2959	1125315	1977-08-19	1977-08-26	1	2794
57395	3916	19127890	1995-09-15	1996-09-09	1	9748
10748	738	1768849	1981-08-17	1981-08-31	1	4260
6408	443	1177480	1983-02-01	1983-03-08	1	4814
34098	2315	1738521	1978-08-23	1978-09-06	1	3170
5358	366	1115008	1995-08-25	1995-09-29	1	9402
45211	3067	1125315	1968-11-28	1968-12-26	1	-371
5550	380	1125315	1973-03-14	1973-03-28	1	1182
47696	3237	1125315	1981-12-04	1981-12-18	1	4369
5114	349	1521369	1978-07-22	1979-07-17	1	3484
51900	3533	19127890	1979-11-05	1980-10-30	1	3955
5187	352	1125315	1987-06-26	1987-07-24	1	6413
50408	3434	1124300	1983-11-05	1983-11-05	1	5056
53810	3660	1125315	2017-10-09	2017-11-13	1	17483
7227	498	1125315	1988-02-06	1988-02-13	1	6617
45871	3115	914335	1991-01-04	1991-01-04	1	7673
5231	357	1759842	1983-10-09	1984-01-08	1	5120
5471	374	1125315	1993-11-24	1993-12-29	1	8763
48409	3289	738818	1986-10-13	1986-10-20	1	6136
45731	3105	738818	2016-07-02	2016-07-16	1	16998
11356	776	933724	1995-10-04	1995-10-11	1	9414
57992	3956	1713332	1977-09-25	1977-10-02	1	2831
6227	430	1115008	1997-12-05	1998-01-04	1	10230
54932	3736	914335	2006-06-28	2006-06-28	1	13327
4350	298	1112807	1968-05-05	1968-06-09	1	-571
46825	3177	1177480	2002-07-19	2002-08-18	1	11917
61565	4202	1729720	1981-12-30	1982-01-11	1	4393
46948	3183	1713332	1983-03-06	1983-03-20	1	4826
7612	525	1125315	2002-02-19	2002-02-26	1	11744
10520	723	933724	1997-12-03	1997-12-10	1	10205
50800	3455	723013	1991-05-21	1994-08-15	1	8992
9267	642	1177480	2006-01-10	2006-02-14	1	13193
46735	3175	1119510	2010-07-09	2010-07-23	1	14813
4674	320	1149380	1993-06-20	1993-06-20	1	8571
5309	363	1713332	1965-06-09	1965-06-16	1	-1660
4621	318	705944	1966-05-01	1966-09-04	1	-1215
10239	704	1125315	1976-03-19	1976-04-02	1	2283
50828	3456	1343916	1991-12-12	1991-12-12	1	8015
10828	743	1177480	1977-01-25	1977-02-08	1	2595
49939	3403	19127890	1984-03-22	1985-03-17	1	5554
5484	376	1125315	1973-05-26	1973-06-02	1	1248
72748	4971	1332418	1995-11-07	1995-11-07	1	9441
52539	3577	1729720	2014-05-14	2014-05-23	1	16213
5281	362	1112807	1989-10-06	1989-11-03	1	7246
43131	2917	1118084	1976-02-10	1976-02-10	1	2231
2287	153	933724	1997-07-03	1997-07-10	1	10052
54520	3708	1521369	2000-03-23	2002-05-31	3	11838
8178	569	1713332	1989-01-26	1989-02-09	1	6979
49106	3343	1551099	1978-11-25	1978-11-25	1	3250
4847	332	738818	1982-09-26	1982-10-10	1	4665
5793	399	1129625	1958-04-23	1958-04-23	1	-4271
52436	3571	1118084	2007-02-01	2007-02-01	1	13545
4760	326	1125315	1973-05-18	1973-06-01	1	1247
51210	3488	1125315	1978-05-12	1978-06-16	1	3088
6351	439	1759842	1986-07-23	1986-08-13	1	6068
50027	3409	1125315	2001-12-27	2002-01-10	1	11697
5606	384	933724	2018-08-09	2018-08-16	1	17759
43817	2959	1309944	1997-10-07	1997-10-07	1	10141
57396	3916	1112807	1980-12-22	1981-01-05	1	4022
10749	738	1125315	1983-03-10	1983-03-31	1	4837
6409	443	1729720	1979-09-24	1979-10-03	1	3562
34099	2315	1112807	1978-08-23	1978-09-06	1	3170
5359	366	1119510	1961-10-03	1961-10-17	1	-2998
45212	3067	1125315	1971-07-21	1971-08-04	1	580
5551	380	1125315	1986-08-25	1986-10-24	1	6140
47697	3237	1125315	2000-01-17	2000-01-31	1	10987
5115	349	1713332	1997-06-11	1997-06-25	1	10037
53016	3613	1112807	1981-01-15	1981-01-29	1	4046
5188	352	1177480	1988-08-17	1988-09-07	1	6824
50409	3434	1125315	1950-05-12	1950-05-26	1	-7160
53811	3660	1177480	1987-11-29	1987-12-20	1	6562
7228	498	1119510	1972-04-16	1972-04-30	1	850
45872	3115	1112807	1972-01-15	1972-03-15	1	804
5232	357	1115008	2016-08-23	2016-09-13	1	17057
5472	374	19127890	1993-11-04	1994-10-30	1	9068
48410	3289	1102527	1968-01-12	1968-01-12	1	-720
45732	3105	1125315	2016-07-02	2016-07-16	1	16998
11357	776	1118084	1998-01-12	1998-01-12	1	10238
57993	3956	1729720	1928-07-31	1928-08-07	1	-15122
6228	430	1557272	2011-11-19	2011-11-19	1	15297
54933	3736	1119510	1969-01-11	1969-01-25	1	-341
4351	298	1125315	1953-01-03	1953-01-17	1	-6193
46826	3177	1307863	2012-05-09	2012-05-09	1	15469
64222	4387	1118084	2007-11-24	2007-11-24	1	13841
46949	3183	1759842	1983-03-06	1983-03-20	1	4826
7613	525	1367571	1952-05-22	1952-05-22	1	-6433
10521	723	1112807	1961-10-06	1961-10-20	1	-2995
50801	3455	723013	1997-03-31	1997-07-07	1	10049
9268	642	1310149	2007-09-09	2007-09-09	1	13765
46736	3175	1125315	1959-08-09	1959-08-23	1	-3784
6846	474	1729720	1982-12-04	1982-12-16	1	4732
5310	363	1119510	1977-05-01	1977-05-15	1	2691
4622	318	738818	1961-04-23	1961-05-07	1	-3161
10240	704	1129625	1986-12-25	1986-12-25	1	6202
50829	3456	1361711	1989-12-21	1989-12-21	1	7294
10829	743	1521369	1999-09-07	2000-09-01	1	11201
49940	3403	1112807	1982-10-19	1982-11-02	1	4688
5485	376	1125315	1986-12-31	1987-01-14	1	6222
72749	4971	1347450	2007-09-04	2007-09-04	1	13760
52540	3577	1759842	1971-07-29	1971-08-19	1	595
5282	362	1125315	1996-12-14	1996-12-28	1	9858
43132	2917	1713332	1987-12-26	1988-01-02	1	6575
2288	153	1112807	1956-08-30	1956-09-20	1	-4851
54521	3708	1549786	1992-05-04	1995-04-19	3	9239
8179	569	1713332	2009-01-29	2009-02-12	1	14287
49107	3343	1551099	1993-04-11	1993-04-11	1	8501
4848	332	1118084	2007-05-19	2007-05-19	1	13652
5794	399	1713332	2000-10-18	2000-11-08	1	11269
52437	3571	1713332	1979-03-07	1979-03-28	1	3373
4761	326	1112807	1973-03-17	1973-03-31	1	1185
51211	3488	1728416	1957-06-18	1957-07-02	1	-4566
6352	439	1759842	1990-01-03	1990-01-17	1	7321
50028	3409	1125315	2011-04-26	2011-07-25	1	15180
5607	384	1125315	1966-04-30	1966-05-14	1	-1328
43818	2959	1343916	1997-10-07	1997-10-07	1	10141
57397	3916	1124957	1997-06-24	1997-06-24	1	10036
10750	738	1125315	1990-08-21	1990-09-04	1	7551
6410	443	1759842	1971-09-11	1971-10-02	1	639
34100	2315	1119510	2002-03-31	2002-04-07	1	11784
5360	366	1119510	1983-02-22	1983-03-08	1	4814
45213	3067	1174888	2010-12-05	2010-12-05	1	14948
5552	380	1125315	2009-08-25	2009-09-08	1	14495
47698	3237	1768849	1986-05-08	1986-06-05	1	5999
5116	349	1713332	2012-09-11	2012-10-02	1	15615
53017	3613	1118084	2010-06-05	2010-06-05	1	14765
10342	710	1112807	1973-02-14	1973-04-15	1	1200
50410	3434	1125315	1973-06-21	1973-07-05	1	1281
53812	3660	933724	1998-09-23	1998-09-30	1	10499
7229	498	1118084	2010-06-09	2010-06-09	1	14769
45873	3115	1125315	1968-01-15	1968-02-05	1	-696
5233	357	1125315	1961-11-05	1961-11-19	1	-2965
5991	410	1125315	1975-02-18	1975-02-25	1	1881
48411	3289	1112807	1957-07-15	1957-07-29	1	-4539
45733	3105	1177480	2000-10-13	2000-11-03	1	11264
11358	776	1119510	1979-08-22	1979-08-29	1	3527
57994	3956	1112807	1917-07-25	1917-08-08	1	-19139
6229	430	920293	1978-07-21	1978-07-28	1	3130
54934	3736	1125315	1954-03-05	1954-03-19	1	-5767
4352	298	1125315	1955-09-03	1955-09-17	1	-5220
48764	3315	933724	2004-05-15	2004-05-22	1	12560
64223	4387	1729720	1974-11-13	1974-11-25	1	1789
46950	3183	1125315	2004-11-30	2004-12-07	1	12759
7614	525	1741122	1952-05-22	1952-05-22	1	-6433
10522	723	1115008	2013-12-21	2014-02-19	1	16120
50802	3455	933724	1998-07-04	1998-07-18	1	10425
9269	642	1759842	2005-08-17	2005-08-24	1	13019
46737	3175	1125315	1995-02-01	1995-02-01	1	9162
6847	474	1729720	2002-03-03	2002-03-13	1	11759
5311	363	1177480	2016-10-08	2016-10-22	1	17096
4623	318	1112807	1955-01-24	1955-02-07	1	-5442
10241	704	1115008	1994-10-26	1994-11-16	1	9085
50830	3456	1729720	1952-06-07	1952-06-20	1	-6404
10830	743	1713332	1981-07-09	1981-07-23	1	4221
49941	3403	1503184	1984-03-22	1985-03-17	1	5554
5486	376	1125315	2012-02-13	2012-03-12	1	15411
73137	4999	1503184	1975-10-20	1976-10-14	1	2478
52541	3577	1759842	1973-08-16	1973-08-30	1	1337
5283	362	1177480	1998-07-03	1998-07-17	1	10424
43133	2917	1713332	2007-08-31	2007-09-07	1	13763
2289	153	1118084	1984-05-15	1984-05-15	1	5248
54522	3708	1551099	1978-01-08	1978-01-08	1	2929
8180	569	1729720	1922-01-07	1922-01-18	1	-17515
49108	3343	1118084	2019-05-17	2019-05-17	1	18033
4849	332	1125315	1980-08-27	1980-09-24	1	3919
5795	399	1112807	1969-02-23	1969-03-25	1	-282
52438	3571	1759842	1979-03-07	1979-03-28	1	3373
4762	326	1717327	1973-03-17	1973-03-31	1	1185
52011	3542	1125315	1957-05-09	1957-05-23	1	-4606
6491	449	1125315	1981-07-23	1981-08-06	1	4235
50029	3409	1177480	2005-01-27	2005-02-26	1	12840
5608	384	1125315	1967-12-25	1968-01-08	1	-724
45150	3065	1125315	1976-10-19	1976-11-02	1	2497
57398	3916	1154343	1980-10-10	1980-10-10	1	3935
10751	738	1177480	1981-08-17	1981-08-31	1	4260
6411	443	1115008	2006-03-19	2006-04-03	1	13241
34101	2315	1124300	2012-04-11	2012-04-11	1	15441
5361	366	1125315	1954-11-21	1954-12-28	1	-5483
45214	3067	1177480	2010-12-05	2011-01-04	1	14978
5553	380	1125315	2013-07-12	2013-07-26	1	15912
47699	3237	701322	2007-03-22	2007-03-22	1	13594
6591	455	1112807	1960-02-11	1960-03-12	1	-3582
53018	3613	1125315	1977-10-16	1977-10-30	1	2859
10343	710	1124300	2004-04-27	2004-04-27	1	12535
50411	3434	1728416	1950-05-12	1950-05-26	1	-7160
53813	3660	1177480	1992-06-17	1992-09-15	1	8293
7230	498	1738521	1974-08-02	1974-08-16	1	1688
45874	3115	1125315	1973-04-27	1973-05-04	1	1219
5234	357	1177480	1977-06-28	1977-07-12	1	2749
5992	410	1125315	1982-10-17	1982-10-31	1	4686
48412	3289	1112807	1966-12-16	1967-01-15	1	-1082
45734	3105	1717327	1972-02-29	1972-03-14	1	803
11359	776	1125315	2009-10-11	2009-10-25	1	14542
57995	3956	1112807	1920-08-29	1920-09-12	1	-18008
6230	430	933724	1978-07-21	1978-07-28	1	3130
54935	3736	1713332	2004-11-04	2004-11-11	1	12733
4353	298	1125315	1959-03-05	1959-03-19	1	-3941
48765	3315	1102527	2006-09-24	2006-09-24	1	13415
64224	4387	1729720	1990-01-05	1990-01-17	1	7321
46951	3183	1729720	1992-05-27	1992-06-09	1	8195
7615	525	1759842	1964-04-22	1964-06-03	1	-2038
10523	723	1124957	2013-12-21	2013-12-21	1	16060
50803	3455	1102527	2012-08-08	2012-08-08	1	15560
9270	642	1778162	1989-12-23	1990-01-20	1	7324
46738	3175	1125315	2010-07-09	2010-07-23	1	14813
6848	474	1125315	1975-03-24	1975-04-07	1	1922
5312	363	1713332	1973-10-06	1974-03-16	1	1535
4624	318	1112807	1956-12-14	1957-01-04	1	-4745
10242	704	1119510	2015-12-07	2015-12-14	1	16783
50831	3456	1759842	1956-11-04	1956-11-25	1	-4785
10831	743	1759842	2016-01-13	2016-01-20	1	16820
49942	3403	1503184	1986-03-12	1987-03-07	1	6274
5487	376	1503184	1979-04-03	1980-03-28	1	3739
73138	4999	1713332	1993-08-31	1993-09-21	1	8664
52542	3577	19127890	1975-02-24	1976-02-19	1	2240
5284	362	1729720	1991-10-30	1991-11-12	1	7985
43134	2917	1759842	1987-12-26	1988-01-02	1	6575
2290	153	1125315	1996-10-22	1996-11-05	1	9805
54523	3708	1589505	1999-03-29	2000-03-23	1	11039
8181	569	920293	1935-05-26	1935-06-02	1	-12632
49109	3343	1125315	1995-11-26	1995-12-03	1	9467
4850	332	1125315	1982-09-26	1982-10-10	1	4665
5796	399	1125315	1959-09-11	1959-09-25	1	-3751
52439	3571	975125	1977-05-05	1977-05-26	1	2702
6187	426	1125315	1966-02-12	1966-02-26	1	-1405
52012	3542	1713332	1988-05-30	1988-06-06	1	6731
6492	449	1713332	1999-11-09	2000-02-29	1	11016
50030	3409	19127890	1974-05-17	1975-05-12	1	1957
5609	384	1713332	1962-09-23	1962-10-07	1	-2643
45151	3065	1125315	1992-09-29	1992-10-13	1	8321
57399	3916	1192710	1979-04-17	1979-04-17	1	3393
10752	738	1713332	2016-03-09	2016-03-23	1	16883
6412	443	1125315	1984-03-02	1984-04-01	1	5204
34102	2315	1125315	2018-10-30	2018-11-13	1	17848
5362	366	1125315	1970-11-13	1970-11-20	1	323
45215	3067	1728416	1945-09-02	1945-09-16	1	-8873
5554	380	1738521	1972-01-11	1972-01-25	1	754
47700	3237	738818	1928-07-02	1928-07-16	1	-15144
6592	455	1112807	1954-04-22	1954-05-13	1	-5712
53019	3613	1713332	1981-01-15	1981-01-29	1	4046
10344	710	1125315	1992-07-05	1992-07-12	1	8228
50901	3462	1125315	1969-12-05	1969-12-19	1	-13
53814	3660	1177480	1997-03-23	1997-04-06	1	9957
7845	546	1125315	2010-05-17	2010-06-16	2	14746
45875	3115	1125315	1987-04-26	1987-05-10	1	6338
5235	357	1177480	1983-04-28	1983-05-19	1	4886
5993	410	1125315	2019-02-06	2019-02-06	1	17933
48413	3289	1125315	1986-10-13	1986-10-20	1	6136
45735	3105	1738521	1975-04-23	1975-05-07	1	1952
11360	776	920293	1995-10-04	1995-10-11	1	9414
57996	3956	1118084	1959-02-10	1959-02-10	1	-3978
6231	430	1112807	1933-06-20	1933-07-04	1	-13330
54936	3736	1728416	1952-02-29	1952-03-14	1	-6502
4354	298	1125315	1973-07-16	1973-07-30	1	1306
48766	3315	1125315	1962-10-30	1962-11-13	1	-2606
64225	4387	1112807	1993-05-26	1993-06-09	1	8560
49997	3408	1125315	1974-08-29	1974-09-12	1	1715
7616	525	1759842	2003-02-10	2003-03-03	1	12114
10524	723	1125315	1966-12-23	1967-03-23	1	-1015
50804	3455	1112807	1971-03-17	1971-03-31	1	454
9271	642	738818	1995-12-03	1995-12-10	1	9474
46739	3175	1728416	1959-08-09	1959-08-23	1	-3784
6849	474	1125315	1976-05-11	1976-06-01	1	2343
5313	363	1713332	2003-09-12	2003-10-03	1	12328
4625	318	1115008	2011-02-11	2011-05-12	1	15106
10243	704	1125315	1982-08-03	1982-08-10	1	4604
50832	3456	1759842	1986-05-12	1986-05-26	1	5989
10832	743	738818	1983-08-23	1983-09-06	1	4996
49943	3403	1521369	1986-03-12	1987-03-07	1	6274
5488	376	1713332	1966-09-07	1966-09-14	1	-1205
73139	4999	1713332	2009-04-06	2009-04-27	1	14361
53217	3625	1112807	1968-07-21	1968-08-20	1	-499
5285	362	1713332	1982-07-15	1982-07-29	1	4592
43135	2917	1759842	2007-08-31	2007-09-07	1	13763
2291	153	1177480	2011-02-02	2011-02-16	1	15021
54524	3708	1595799	2001-03-18	2002-03-13	1	11759
8182	569	920293	1941-07-06	1941-07-13	1	-10399
49110	3343	1125315	2017-04-07	2017-04-28	1	17284
4851	332	1149380	1965-06-20	1965-06-20	1	-1656
5797	399	1125315	1968-03-30	1968-04-29	1	-612
52440	3571	1124957	2005-05-27	2005-05-27	1	12930
6188	426	1728416	1966-02-12	1966-02-26	1	-1405
52013	3542	1713332	1994-12-12	1994-12-26	1	9125
6493	449	1759842	1999-11-09	2000-02-29	1	11016
50031	3409	1503184	1974-05-17	1975-05-12	1	1957
5610	384	920293	2018-08-09	2018-08-16	1	17759
45152	3065	1177480	1981-02-23	1981-04-24	1	4131
57400	3916	1515774	1993-09-25	1994-09-20	1	9028
10753	738	1125315	1978-08-04	1978-08-18	1	3151
6413	443	1125315	1993-07-27	1993-08-03	1	8615
34103	2315	738818	2002-03-31	2002-04-07	1	11784
5363	366	1125315	1996-08-24	1996-09-14	1	9753
45216	3067	1729720	1951-06-22	1951-07-02	1	-6758
5555	380	1102527	1986-08-25	1986-08-25	1	6080
47701	3237	757627	2006-04-26	2006-04-26	1	13264
6593	455	1118084	1986-08-15	1986-08-15	1	6070
53020	3613	1729720	1981-04-29	1981-05-11	1	4148
10345	710	1177480	1974-10-28	1974-11-11	1	1775
50902	3462	1125315	1985-06-21	1985-08-20	1	5710
53815	3660	1713332	2016-02-15	2016-02-29	1	16860
7846	546	1759842	1948-03-21	1948-04-11	1	-7935
45876	3115	1125315	1994-10-07	1994-10-28	1	9066
5236	357	1551099	1955-09-08	1955-09-08	1	-5229
5994	410	1713332	1996-03-02	1996-03-16	1	9571
48414	3289	1125315	1991-06-05	1991-06-12	1	7832
45736	3105	1115008	2004-07-15	2004-08-05	1	12635
11361	776	1112807	1959-08-25	1959-09-15	1	-3761
57997	3956	1119510	1924-03-22	1924-04-05	1	-16707
6232	430	1112807	1941-10-25	1941-11-24	1	-10265
54937	3736	1759842	2004-11-04	2004-11-11	1	12733
4355	298	1125315	1996-07-18	1996-07-25	1	9702
48767	3315	920293	2004-05-15	2004-05-22	1	12560
64226	4387	1713332	2018-03-27	2018-04-03	1	17624
49998	3408	1125315	1997-01-13	1997-01-20	1	9881
7617	525	19016749	1952-05-22	1952-05-22	1	-6433
10525	723	1125315	1990-10-25	1990-11-01	1	7609
50805	3455	1125315	2000-05-15	2000-05-29	1	11106
9272	642	1112807	1967-07-31	1967-08-21	1	-864
46740	3175	1729720	1987-02-12	1987-02-22	1	6261
6850	474	1125315	2017-09-04	2017-09-18	1	17427
7828	545	933724	2018-01-15	2018-01-22	1	17553
4626	318	1118084	1994-12-10	1994-12-10	1	9109
10244	704	1125315	1985-12-21	1986-01-11	1	5854
50833	3456	914335	1991-12-12	1991-12-12	1	8015
10833	743	1115008	2004-05-01	2004-05-15	1	12553
51295	3495	920293	2017-07-08	2017-07-15	1	17362
5489	376	920293	1996-05-13	1996-05-20	1	9636
73140	4999	1759842	2007-01-14	2007-01-21	1	13534
53218	3625	1125315	1991-09-10	1991-09-24	1	7936
5286	362	1729720	2009-10-09	2009-10-22	1	14539
43136	2917	1125315	1964-11-14	1964-11-28	1	-1860
2292	153	1729720	1948-05-09	1948-05-19	1	-7897
54525	3708	1713332	1984-07-28	1984-08-11	1	5336
8183	569	1115008	2011-01-03	2011-02-07	1	15012
49111	3343	1154343	1978-06-13	1978-06-13	1	3085
4852	332	1759842	1990-04-08	1990-04-29	1	7423
5798	399	1125315	1980-07-16	1980-09-14	1	3909
52441	3571	1125315	1983-10-20	1984-01-18	1	5130
6189	426	1759842	1990-06-14	1990-07-05	1	7490
52014	3542	1729720	1941-01-28	1941-02-06	1	-10556
6494	449	920293	1996-11-24	1996-12-08	2	9838
50032	3409	1713332	2016-02-06	2016-02-20	1	16851
5611	384	1717327	1961-08-23	1961-09-06	1	-3039
45153	3065	1713332	2018-05-18	2018-06-01	1	17683
57401	3916	1713332	1987-01-26	1987-02-09	1	6248
11852	817	1112807	1958-09-21	1958-10-05	1	-4106
6414	443	1174888	2013-05-26	2013-05-26	1	15851
34104	2315	1125315	1989-10-09	1989-10-23	1	7235
5364	366	1125315	1998-11-03	1999-02-01	1	10623
45217	3067	738818	1971-07-21	1971-08-04	1	580
5556	380	1118084	2012-06-14	2012-06-14	1	15505
47702	3237	1124957	1986-05-08	1986-05-08	1	5971
6594	455	1125315	1966-04-30	1966-05-14	1	-1328
53021	3613	1729720	1991-10-18	1991-10-26	1	7968
10346	710	1759842	1980-02-18	1980-03-10	1	3721
50903	3462	1729720	1961-11-18	1961-11-25	1	-2959
53816	3660	920293	1997-08-09	1997-08-16	1	10089
7847	546	920293	1982-11-30	1982-12-07	1	4723
45877	3115	1309944	1991-01-04	1991-01-04	1	7673
5708	393	738818	1967-01-28	1967-02-11	1	-1055
5995	410	1759842	1996-03-02	1996-03-16	1	9571
52227	3558	1125315	1964-01-01	1964-02-09	2	-2171
45737	3105	1124300	2008-07-05	2008-07-05	1	14065
11362	776	1112807	1962-07-01	1962-07-22	1	-2720
57998	3956	1124957	1958-11-22	1958-11-22	1	-4058
6233	430	1119510	1949-12-15	1949-12-29	1	-7308
54938	3736	738818	1964-09-13	1964-09-20	1	-1929
4356	298	1713332	2010-11-07	2010-11-28	1	14941
48768	3315	1125315	1977-07-16	1977-08-06	1	2774
64227	4387	1717327	1967-07-07	1967-08-04	1	-881
49999	3408	1125315	2010-01-06	2010-01-27	1	14636
7618	525	753626	1952-05-22	1952-05-22	1	-6433
10526	723	920293	1997-12-03	1997-12-10	1	10205
50806	3455	1503184	1983-05-23	1985-05-12	2	5610
9273	642	1115008	2017-01-08	2017-01-22	1	17188
46741	3175	920293	2006-12-17	2006-12-24	1	13506
6851	474	1177480	1978-03-23	1978-04-27	1	3038
7829	545	19127890	1985-10-05	1987-09-25	2	6476
4627	318	1125315	2011-02-11	2011-02-11	1	15016
10245	704	738818	2015-12-07	2015-12-14	1	16783
50834	3456	1119510	1959-01-17	1959-01-24	1	-3995
10834	743	1515774	1992-10-13	1993-10-08	1	8681
51296	3495	1115008	2014-08-22	2014-09-26	1	16339
5490	376	1124300	1999-07-07	1999-07-07	1	10779
73141	4999	19127890	1980-09-23	1981-09-18	1	4278
53219	3625	1177480	2011-08-26	2011-09-16	1	15233
5287	362	1102527	1995-09-17	1995-09-17	1	9390
43137	2917	1326303	1989-09-13	1989-09-13	1	7195
2293	153	1112807	1970-02-09	1970-02-23	1	53
54526	3708	933724	1999-06-05	1999-06-12	1	10754
8184	569	1119510	1947-10-05	1947-10-19	1	-8110
49112	3343	1551099	1977-07-01	1977-07-01	1	2738
4853	332	19127890	1979-05-31	1980-05-25	1	3797
5799	399	1174888	1969-02-23	1969-02-23	1	-312
52442	3571	1125315	2005-05-27	2005-07-26	2	12990
6190	426	1112807	1969-09-02	1969-09-16	1	-107
52015	3542	1759842	1988-05-30	1988-06-06	1	6731
6495	449	933724	1996-11-24	1996-12-08	1	9838
50033	3409	1728416	1960-08-18	1960-09-01	1	-3409
5612	384	1759842	1962-09-23	1962-10-07	1	-2643
45154	3065	1759842	2004-09-22	2004-11-17	1	12739
57402	3916	1759842	1987-01-26	1987-02-09	1	6248
11853	817	1112807	1972-11-21	1972-12-26	1	1090
6415	443	1738521	1970-01-10	1970-01-24	1	23
34105	2315	1125315	2002-03-31	2002-04-07	1	11784
5365	366	738818	1961-10-03	1961-10-17	1	-2998
45218	3067	1112807	1941-01-12	1941-01-26	1	-10567
5557	380	1713332	1998-04-22	1998-04-29	1	10345
47703	3237	1125315	1928-07-02	1928-07-16	1	-15144
6595	455	1177480	2001-07-05	2001-08-09	1	11543
53022	3613	1738521	1977-10-16	1977-10-30	1	2859
10347	710	738818	1985-01-21	1985-01-28	1	5506
50904	3462	1102527	1985-06-21	1985-06-21	1	5650
53817	3660	933724	1997-08-09	1997-08-16	1	10089
7848	546	933724	1982-11-30	1982-12-07	1	4723
45878	3115	1343916	1991-01-04	1991-01-04	1	7673
5709	393	1125315	1962-08-13	1962-08-20	1	-2691
5996	410	920293	1995-09-21	1995-09-28	1	9401
52228	3558	1125315	2011-03-09	2011-03-23	1	15056
45738	3105	1125315	1975-04-23	1975-05-07	1	1952
11363	776	1137529	2010-08-12	2010-08-12	1	14833
57999	3956	1125315	1932-12-26	1933-01-09	1	-13506
6234	430	1119510	1954-10-11	1954-10-18	1	-5554
54939	3736	1125315	1962-06-07	1962-06-14	1	-2758
4357	298	1713332	2013-06-22	2013-07-13	1	15899
48769	3315	1177480	1983-03-08	1983-03-22	1	4828
64228	4387	1729720	1985-05-20	1985-05-30	1	5628
50000	3408	1177480	1999-06-12	1999-07-03	1	10775
7619	525	782043	1952-05-22	1952-05-22	1	-6433
10527	723	1125315	1969-07-28	1969-08-04	1	-150
50807	3455	1515774	1991-04-11	1992-04-05	1	8130
9274	642	1125315	1944-03-14	1944-03-28	1	-9410
46742	3175	1112807	1954-11-19	1954-12-03	1	-5508
6852	474	1177480	1982-12-02	1982-12-16	1	4732
7830	545	19127890	1988-09-19	1989-09-14	1	7196
4628	318	738818	1974-03-07	1974-03-21	1	1540
10246	704	1112807	1968-01-27	1968-03-11	1	-661
50835	3456	1713332	1956-11-04	1956-11-25	1	-4785
10835	743	1515774	1997-09-17	1998-09-12	1	10481
51297	3495	1118084	2001-02-27	2001-02-27	1	11380
5491	376	1125315	1977-12-29	1978-01-12	1	2933
73142	4999	920293	2007-12-12	2007-12-19	1	13866
53220	3625	1326303	2012-09-04	2012-09-04	1	15587
5288	362	1177480	1982-07-15	1982-07-29	1	4592
43138	2917	1713332	2014-02-22	2014-03-08	1	16137
2294	153	1125315	1990-01-23	1990-02-22	1	7357
54527	3708	1125315	1984-07-20	1984-07-27	1	5321
8185	569	1125315	1976-04-08	1976-07-07	1	2379
51070	3477	975125	1986-04-02	1986-04-02	1	5935
4854	332	1125315	1978-04-12	1978-04-19	1	3030
5800	399	1729720	1979-09-17	1979-09-27	1	3556
52443	3571	1713332	1975-11-01	1975-11-15	1	2144
6191	426	1125315	1981-03-26	1981-04-09	1	4116
52016	3542	1759842	1994-12-12	1994-12-26	1	9125
6496	449	975125	1984-11-03	1984-11-03	1	5420
50034	3409	1729720	2011-06-01	2011-06-09	1	15134
5613	384	1115008	2003-07-03	2003-07-17	1	12250
45155	3065	738818	1995-04-27	1995-05-04	1	9254
57403	3916	19127890	1997-09-04	1998-08-30	1	10468
11854	817	1125315	1971-11-01	1971-11-08	1	676
6416	443	1115008	2012-05-01	2012-06-30	1	15521
34106	2315	1713332	1980-04-21	1980-05-05	1	3777
5366	366	738818	1966-10-18	1966-11-01	1	-1157
45219	3067	1125315	1979-08-01	1979-08-15	1	3513
5558	380	1713332	2016-06-28	2016-07-05	1	16987
47704	3237	1125315	1971-01-27	1971-02-26	1	421
6596	455	1759842	1950-03-07	1950-03-21	1	-7226
54237	3691	738818	2005-08-28	2005-09-04	1	13030
10348	710	1112807	1964-01-20	1964-02-03	1	-2159
50905	3462	1115008	2018-04-29	2018-05-13	1	17664
53818	3660	1115008	1999-12-22	2000-01-12	1	10968
7849	546	1112807	1944-12-08	1945-02-06	1	-9095
45879	3115	1503184	1990-11-25	1991-11-20	1	7993
5710	393	1125315	1967-01-28	1967-02-11	1	-1055
5997	410	1125315	1999-10-03	1999-10-17	1	10881
52229	3558	1149380	2016-05-07	2016-05-07	1	16928
45739	3105	1125315	2007-09-10	2007-09-17	1	13773
11364	776	1149380	2010-08-12	2010-08-12	1	14833
58000	3956	1759842	1977-09-25	1977-10-02	1	2831
6235	430	1125315	1940-11-30	1940-12-14	1	-10610
54940	3736	1125315	1964-09-13	1964-09-20	1	-1929
4358	298	1717327	1974-09-30	1974-10-14	1	1747
48770	3315	1112807	1968-06-28	1968-08-02	1	-517
64229	4387	1738521	1968-04-02	1968-04-16	1	-625
50001	3408	1717327	1974-08-29	1974-09-12	1	1715
7620	525	967823	1952-05-22	1952-05-23	1	-6432
10528	723	1125315	1984-10-19	1984-11-02	1	5419
50808	3455	1521369	1986-05-07	1987-05-02	1	6330
9275	642	1125315	1995-12-03	1995-12-10	1	9474
46743	3175	1124300	1999-05-02	1999-05-02	1	10713
6853	474	1759842	2008-11-20	2008-12-04	1	14217
7831	545	1125315	1974-10-23	1974-11-20	1	1784
4629	318	1119510	2004-07-05	2004-07-19	1	12618
10247	704	1119510	1999-03-20	1999-04-03	1	10684
53149	3622	914335	1953-04-22	1953-04-22	1	-6098
10836	743	1549786	1997-09-17	1998-09-12	1	10481
51298	3495	1125315	1979-05-06	1979-05-20	1	3426
5492	376	1713332	1969-04-29	1969-05-20	1	-226
73143	4999	1112807	1971-10-01	1971-10-15	1	652
53221	3625	1501700	2010-06-30	2010-06-30	1	14790
5289	362	1177480	1995-09-17	1995-11-16	1	9450
43139	2917	1759842	1941-10-12	1941-10-19	1	-10301
2295	153	1729720	1951-07-07	1951-07-15	1	-6745
54528	3708	1149380	1979-05-20	1979-05-20	1	3426
8186	569	1125315	2009-01-29	2009-01-29	1	14273
51071	3477	1118084	1997-01-08	1997-01-08	1	9869
4855	332	1125315	2019-03-30	2019-04-13	1	17999
5801	399	1112807	1957-03-23	1957-04-06	1	-4653
52444	3571	1713332	2004-11-18	2004-12-02	1	12754
6192	426	1125315	2015-12-05	2015-12-12	1	16781
52017	3542	1119510	1948-06-05	1948-06-12	1	-7873
6497	449	1112807	1976-03-03	1976-03-17	1	2267
50035	3409	1738521	1968-05-06	1968-05-20	1	-591
5614	384	1118084	1996-05-11	1996-05-11	1	9627
45156	3065	1119510	1989-09-23	1989-09-30	1	7212
57404	3916	1125315	1987-10-17	1987-11-07	1	6519
11855	817	1174888	2007-01-27	2007-01-27	1	13540
6417	443	1125315	1980-11-15	1980-11-29	1	3985
37246	2535	1119510	1979-02-28	1979-03-14	1	3359
5367	366	933724	1951-03-06	1951-03-13	1	-6869
45220	3067	1125315	1984-11-14	1984-11-21	1	5438
5559	380	1759842	1998-04-22	1998-04-29	1	10345
47705	3237	1125315	1986-05-08	1986-06-05	2	5999
6597	455	738818	1985-08-10	1985-08-17	1	5707
54238	3691	1115008	2012-07-17	2012-08-07	1	15559
10349	710	1125315	1964-10-30	1964-11-06	1	-1882
50906	3462	1124300	1995-03-09	1995-03-09	1	9198
53819	3660	1125315	1988-12-14	1989-01-04	1	6943
7850	546	1118084	1981-05-28	1981-05-28	1	4165
45880	3115	1729720	1974-03-15	1974-03-26	1	1545
5711	393	1125315	1976-08-01	1976-08-15	1	2418
5998	410	1125315	2004-08-30	2004-09-13	1	12674
52230	3558	1729720	2010-02-06	2010-02-16	1	14656
45740	3105	1738521	1972-12-30	1973-01-13	1	1108
11365	776	1729720	1971-05-28	1971-06-10	1	525
58001	3956	738818	1944-09-12	1944-09-19	1	-9235
6236	430	1125315	2009-09-03	2009-09-24	1	14511
54941	3736	1729720	1965-05-16	1965-05-26	1	-1681
4359	298	1728416	1953-01-03	1953-01-17	1	-6193
48771	3315	1118084	1990-10-11	1990-10-11	1	7588
64230	4387	1759842	2018-03-27	2018-04-03	1	17624
50002	3408	1738521	1971-10-25	1971-11-08	1	676
7621	525	19003953	1952-05-22	1952-05-22	1	-6433
10529	723	1125315	1990-09-02	1990-09-23	1	7570
50809	3455	1713332	2012-08-08	2012-08-29	1	15581
9276	642	1347450	2017-10-08	2017-10-08	1	17447
46744	3175	1713332	1960-09-14	1960-09-28	1	-3382
6854	474	1118084	2005-08-17	2005-08-17	1	13012
7832	545	1503184	1985-10-05	1987-09-25	2	6476
4630	318	1125315	1961-04-23	1961-05-07	1	-3161
10248	704	1125315	1978-07-04	1978-07-18	1	3120
53150	3622	920293	1970-06-16	1970-06-23	1	173
10837	743	1549786	1999-09-07	2000-09-01	1	11201
51299	3495	1125315	1981-05-14	1981-05-28	1	4165
5493	376	1717327	1964-03-12	1964-03-26	1	-2107
73144	4999	1125315	1978-12-25	1979-01-08	1	3294
53222	3625	1557272	2013-09-10	2013-09-10	1	15958
5290	362	1118084	2017-08-05	2017-08-05	1	17383
43140	2917	1759842	1952-06-20	1952-06-27	1	-6397
2296	153	1759842	1948-04-22	1948-04-29	1	-7917
54529	3708	1177480	2003-07-26	2003-09-24	1	12319
8187	569	1322184	1998-05-30	1998-05-30	1	10376
51072	3477	1125315	1969-03-18	1969-03-25	1	-282
4856	332	1154343	1965-06-20	1965-06-20	1	-1656
5802	399	1125315	1986-06-15	1986-07-06	1	6030
55413	3769	738818	1954-04-02	1954-04-09	1	-5746
6193	426	1729720	1967-12-05	1967-12-15	1	-748
52018	3542	1124300	1980-08-05	1980-08-05	1	3869
6498	449	1119510	2001-02-19	2001-02-26	1	11379
50036	3409	1759842	2016-02-06	2016-02-20	1	16851
5615	384	1119510	2014-04-18	2014-05-02	1	16192
45157	3065	1125315	1995-04-27	1995-05-04	1	9254
57405	3916	1149380	1980-10-10	1980-10-10	1	3935
11856	817	1521369	1974-04-27	1975-04-22	1	1937
6418	443	1125315	2013-05-26	2013-06-25	2	15881
37247	2535	1125315	1998-10-26	1998-11-02	1	10532
5368	366	1102527	1954-11-28	1954-11-28	1	-5513
45221	3067	1125315	2010-12-05	2010-12-05	1	14948
5560	380	1759842	2016-06-28	2016-07-05	1	16987
47706	3237	1713332	1950-03-05	1950-03-26	1	-7221
6598	455	1125315	1951-05-28	1951-06-04	1	-6786
54239	3691	1119510	2005-08-28	2005-09-04	1	13030
10350	710	1713332	2009-09-16	2009-09-23	1	14510
50907	3462	1125315	1994-09-26	1994-10-03	1	9041
53820	3660	1125315	2003-03-14	2003-03-21	1	12132
7851	546	1125315	1961-10-10	1962-01-08	1	-2915
45881	3115	19127890	1985-12-21	1986-12-16	1	6193
5712	393	1125315	1998-09-06	1998-09-20	1	10489
5999	410	1713332	2010-05-31	2010-06-14	1	14774
52231	3558	1759842	1973-04-20	1973-05-11	1	1226
46483	3159	920293	2014-07-05	2014-07-12	1	16263
11366	776	1759842	2002-01-22	2002-02-12	1	11730
58002	3956	738818	1975-11-07	1975-11-14	1	2143
6237	430	701322	2006-12-08	2006-12-08	1	13490
54942	3736	1759842	1974-01-06	1974-01-20	1	1480
4360	298	1759842	2010-11-07	2010-11-28	1	14941
48772	3315	1177480	2013-12-16	2014-01-20	1	16090
64231	4387	1112807	1972-07-15	1972-08-14	1	956
50003	3408	1759842	1988-12-14	1989-01-04	1	6943
12126	836	1125315	1979-05-31	1979-06-14	1	3451
10530	723	1729720	2011-08-17	2011-08-29	1	15215
50810	3455	920293	1998-07-04	1998-07-18	2	10425
9277	642	1713332	1992-04-16	1992-04-30	1	8155
46745	3175	1713332	1994-08-07	1994-08-28	1	9005
6855	474	1713332	1975-07-21	1975-08-11	1	2048
7833	545	1503184	1988-09-19	1989-09-14	1	7196
4631	318	1125315	1962-04-08	1962-04-29	1	-2804
10249	704	1125315	2015-12-07	2015-12-14	1	16783
53151	3622	933724	1970-06-16	1970-06-23	1	173
10838	743	1595799	1999-09-07	2000-09-01	1	11201
51300	3495	1177480	1995-10-10	1995-10-31	1	9434
5494	376	933724	1996-05-13	1996-05-20	1	9636
73145	4999	1307863	2018-01-21	2018-01-21	1	17552
53223	3625	1112807	1957-11-05	1957-11-19	1	-4426
5291	362	1125315	1981-08-21	1981-09-04	1	4264
43722	2953	1125315	1999-02-18	1999-02-25	1	10647
2297	153	920293	1997-07-03	1997-07-10	1	10052
54530	3708	1503184	2002-03-13	2002-05-31	1	11838
8188	569	1713332	2014-11-02	2014-11-16	1	16390
51073	3477	1713332	2008-12-03	2008-12-24	1	14237
4857	332	1551099	1979-09-18	1979-09-18	1	3547
5803	399	1728416	1957-03-23	1957-04-06	1	-4653
55414	3769	738818	1981-07-29	1981-08-05	1	4234
6194	426	1118084	2011-01-22	2011-01-22	1	14996
52019	3542	1174888	2002-09-22	2002-09-22	1	11952
6499	449	1124300	1993-08-11	1993-08-11	1	8623
51840	3531	1125315	1982-09-07	1982-09-21	1	4646
5616	384	1125315	1961-08-23	1961-09-06	1	-3039
45158	3065	1713332	1990-04-09	1990-04-30	1	7424
57406	3916	1521369	1995-09-15	1996-09-09	1	9748
11857	817	1521369	1976-04-16	1977-04-11	1	2657
6419	443	1177480	1985-03-27	1985-04-24	1	5592
37248	2535	1125315	2015-02-02	2015-02-16	1	16482
5369	366	1118084	1944-08-29	1944-08-29	1	-9256
45222	3067	1759842	1968-04-02	1968-04-30	1	-611
5561	380	1119510	2009-08-25	2009-09-08	1	14495
47707	3237	1759842	1931-06-24	1931-07-01	1	-14064
6599	455	1125315	1951-09-23	1951-10-14	1	-6654
54240	3691	1125315	1959-07-02	1959-07-16	1	-3822
10351	710	1717327	1961-10-15	1961-10-29	1	-2986
50908	3462	1729720	1975-01-27	1975-02-07	1	1863
53821	3660	1125315	2006-06-30	2006-07-14	1	13343
7852	546	1713332	1948-03-21	1948-04-11	1	-7935
45882	3115	738818	2008-03-12	2008-03-26	1	13964
5713	393	1119510	1967-01-28	1967-02-11	1	-1055
6000	410	1115008	2004-08-09	2004-08-23	1	12653
52232	3558	19127890	1977-03-03	1978-02-26	1	2978
46484	3159	933724	2014-07-05	2014-07-12	1	16263
11367	776	738818	1961-09-15	1961-09-29	1	-3016
58003	3956	1112807	1939-05-01	1939-06-05	1	-11168
6238	430	738818	1949-12-15	1949-12-29	1	-7308
54943	3736	738818	1969-01-11	1969-01-25	1	-341
4361	298	1759842	2013-06-22	2013-07-13	1	15899
48773	3315	1125315	2006-09-17	2006-10-24	1	13445
64232	4387	1125315	1967-07-07	1967-08-04	1	-881
50004	3408	1112807	1971-10-25	1971-11-08	1	676
12127	836	1503184	2001-07-14	2002-07-09	1	11877
10531	723	1125315	2013-12-21	2013-12-21	1	16060
50811	3455	1549786	1991-04-11	1992-04-05	1	8130
9278	642	1729720	1972-01-28	1972-02-07	1	767
46746	3175	1728416	1954-11-19	1954-12-03	1	-5508
6856	474	1713332	2008-11-20	2008-12-04	1	14217
7834	545	1551099	1974-06-25	1974-06-25	1	1636
4632	318	1125315	1974-03-07	1974-03-21	1	1540
10250	704	1713332	1970-09-10	1970-09-17	1	259
53152	3622	1125315	2019-03-26	2019-04-09	1	17995
10839	743	1713332	1991-11-08	1991-12-06	1	8009
51301	3495	1713332	1996-02-21	1996-03-06	1	9561
5495	376	1177480	2014-04-01	2014-05-06	1	16196
73146	4999	1503184	1980-09-23	1981-09-18	1	4278
53224	3625	1125315	1954-11-20	1954-12-04	1	-5507
5292	362	1125315	1991-07-26	1991-08-09	1	7890
43723	2953	1177480	1984-11-01	1984-12-31	1	5478
2298	153	1112807	1943-10-08	1943-10-22	1	-9568
54531	3708	1521369	1996-04-13	1997-04-08	1	9959
8189	569	1759842	2014-11-02	2014-11-16	1	16390
51074	3477	1759842	2008-12-03	2008-12-24	1	14237
4858	332	738818	2005-10-28	2005-11-04	1	13091
5804	399	1759842	1977-04-02	1977-04-23	1	2669
55415	3769	1125315	1964-02-10	1964-02-24	1	-2138
6195	426	1713332	1990-06-14	1990-07-05	1	7490
52020	3542	1759842	1993-02-08	1993-02-15	1	8446
6500	449	1125315	2001-02-19	2001-02-26	1	11379
51841	3531	1177480	1979-05-25	1979-06-24	1	3461
5617	384	1125315	2014-04-18	2014-05-02	1	16192
45159	3065	1729720	1977-11-13	1977-11-26	1	2886
57407	3916	1729720	2001-11-20	2001-11-30	1	11656
11858	817	1713332	1983-02-27	1983-03-20	1	4826
6420	443	1713332	1971-09-11	1971-10-02	1	639
37249	2535	1347450	2000-08-27	2000-08-27	1	11196
5370	366	1125315	1961-10-03	1961-10-17	1	-2998
45909	3117	920293	1997-08-23	1997-08-30	1	10103
5562	380	1125315	1972-01-11	1972-01-25	1	754
48311	3283	920293	2005-08-03	2005-08-17	2	13012
6600	455	1125315	1952-08-09	1952-08-30	1	-6333
54241	3691	1125315	2005-08-28	2005-09-04	1	13030
10352	710	1717327	1962-11-21	1962-12-05	1	-2584
52375	3568	1102527	2002-07-31	2002-07-31	1	11899
53822	3660	1124300	2009-09-26	2009-09-26	1	14513
7853	546	1124957	2010-05-17	2010-05-17	1	14746
45883	3115	920293	2006-02-24	2006-03-03	1	13210
5714	393	1118084	1997-07-13	1997-07-13	1	10055
6001	410	1124300	1986-12-16	1986-12-16	1	6193
52233	3558	1112807	1961-01-16	1961-01-30	1	-3258
46485	3159	1119510	2002-08-01	2002-08-15	1	11914
11368	776	1112807	1969-06-29	1969-09-27	1	-96
58004	3956	1125315	1944-09-12	1944-09-19	1	-9235
6239	430	757627	2005-07-16	2005-07-16	1	12980
54944	3736	1112807	1952-02-29	1952-03-14	1	-6502
4362	298	1102527	2014-02-11	2014-02-11	1	16112
50122	3414	738818	1969-08-17	1969-08-31	1	-123
64233	4387	1125315	2002-08-04	2002-08-11	1	11910
50005	3408	1115008	1998-05-04	1998-05-18	1	10364
12128	836	1515774	1997-08-04	1998-07-30	1	10437
10532	723	1118084	2005-01-18	2005-01-18	1	12801
50812	3455	19127890	1983-05-23	1985-05-12	2	5610
11027	756	1112807	1992-10-25	1992-11-08	1	8347
46747	3175	1729720	1954-02-25	1954-03-08	1	-5778
6857	474	1729720	1976-02-14	1976-02-22	1	2243
7835	545	920293	2018-01-15	2018-01-22	1	17553
4633	318	1125315	2004-07-05	2004-07-19	1	12618
10251	704	738818	1999-03-20	1999-04-03	1	10684
53153	3622	1310149	1999-10-27	1999-10-27	1	10891
10840	743	1713332	2016-01-13	2016-01-20	1	16820
51302	3495	1738521	1968-01-19	1968-02-02	1	-699
5496	376	1177480	2017-04-20	2017-05-25	1	17311
73147	4999	1713332	2008-09-17	2008-10-01	1	14153
53225	3625	1125315	1979-10-20	1979-11-03	1	3593
5676	390	920293	2016-02-22	2016-02-29	1	16860
43724	2953	1729720	1993-12-14	1993-12-22	1	8756
2299	153	1713332	1985-11-15	1985-12-06	1	5818
54532	3708	1713332	1980-10-24	1980-11-07	1	3963
8190	569	738818	1947-10-05	1947-10-19	1	-8110
51075	3477	1125315	2010-08-18	2010-09-01	1	14853
4859	332	1112807	1979-09-18	1979-10-02	1	3561
5805	399	1759842	2000-10-18	2000-11-08	1	11269
55416	3769	1125315	1981-07-29	1981-08-05	1	4234
6196	426	1729720	1975-05-06	1975-05-13	1	1958
52021	3542	738818	1948-06-05	1948-06-12	1	-7873
6501	449	1125315	2001-06-27	2001-07-11	1	11514
51842	3531	1503184	1984-03-09	1985-03-04	1	5541
5618	384	738818	2014-04-18	2014-05-02	1	16192
45160	3065	1759842	1990-04-09	1990-04-30	1	7424
60378	4116	1115008	1994-03-01	1994-03-15	1	8839
11859	817	1713332	1998-09-01	1998-09-15	1	10484
6421	443	1125315	1973-02-07	1973-02-21	1	1147
37250	2535	1713332	2015-04-03	2015-04-17	1	16542
5371	366	1125315	1965-07-10	1965-07-17	1	-1629
45910	3117	1125315	1985-10-28	1985-11-04	1	5786
5563	380	1125315	1974-02-14	1974-02-28	1	1519
48312	3283	1118084	2016-05-25	2016-05-25	1	16946
6601	455	1125315	1985-08-10	1985-08-17	1	5707
54242	3691	1125315	2011-06-23	2011-09-21	1	15238
10353	710	1759842	2009-09-16	2009-09-23	1	14510
52376	3568	1125315	1975-06-27	1975-08-01	1	2038
53823	3660	1759842	2016-02-15	2016-02-29	1	16860
7854	546	1125315	1946-02-03	1946-02-10	1	-8726
45884	3115	1118084	2006-04-30	2006-04-30	1	13268
5715	393	1713332	2004-01-18	2004-02-01	1	12449
6002	410	1125315	1950-08-27	1950-10-01	1	-7032
52234	3558	1118084	1994-12-09	1994-12-09	1	9108
46486	3159	1177480	1994-12-18	1995-02-16	1	9177
11369	776	1125315	1961-09-15	1961-09-29	1	-3016
58005	3956	1125315	1975-11-07	1975-11-14	1	2143
6240	430	1124300	1972-10-27	1972-10-27	1	1030
54945	3736	1125315	1969-01-11	1969-01-25	1	-341
4363	298	1115008	2000-12-16	2001-01-06	1	11328
50123	3414	738818	1982-04-05	1982-04-19	1	4491
64234	4387	1713332	1994-09-28	1994-10-05	1	9043
50006	3408	1118084	2008-10-15	2008-10-15	1	14167
12129	836	1521369	1994-08-20	1995-08-15	1	9357
10533	723	1125315	2017-08-12	2017-08-26	1	17404
50813	3455	19127890	1991-04-11	1992-04-05	1	8130
11028	756	1125315	1968-04-04	1968-04-18	1	-623
46748	3175	1124957	1995-02-01	1995-02-01	1	9162
6858	474	1729720	1980-08-02	1980-08-14	1	3878
7836	545	933724	2017-11-08	2017-11-15	1	17485
4634	318	1728416	1955-01-24	1955-02-07	1	-5442
10252	704	1118084	2001-02-17	2001-02-17	1	11370
53154	3622	1343916	1953-04-22	1953-04-22	1	-6098
10841	743	1759842	1981-07-09	1981-07-23	1	4221
51303	3495	1759842	1996-02-21	1996-03-06	1	9561
5497	376	1729720	1972-01-01	1972-01-13	1	742
73148	4999	1759842	1971-08-17	1971-08-24	1	600
53226	3625	1125315	1987-04-26	1987-05-03	1	6331
5677	390	1125315	1989-10-20	1989-10-27	1	7239
43725	2953	1124300	2019-01-17	2019-01-17	1	17913
2300	153	1759842	1985-11-15	1985-12-06	1	5818
54533	3708	19127890	2000-03-23	2001-03-18	1	11399
8191	569	1112807	1916-09-03	1916-09-24	1	-19457
51076	3477	1177480	1995-11-25	1995-12-23	1	9487
4860	332	1119510	2005-10-28	2005-11-04	1	13091
7327	505	920293	1998-06-21	1998-07-05	2	10412
55417	3769	1322184	2016-04-17	2016-04-17	1	16908
6197	426	1738521	1969-09-02	1969-09-16	1	-107
52022	3542	1112807	1950-11-21	1950-12-12	1	-6960
6502	449	1125315	1975-02-09	1975-02-23	1	1879
51843	3531	1503184	1986-02-27	1987-02-22	1	6261
5619	384	933724	2013-06-27	2013-07-04	1	15890
45161	3065	19127890	1992-04-13	1993-04-08	1	8498
60379	4116	1177480	1979-07-05	1979-07-19	1	3486
11860	817	1729720	1970-01-22	1970-01-29	1	28
6422	443	1738521	1973-02-07	1973-02-21	1	1147
37251	2535	1729720	1994-12-04	1994-12-13	1	9112
5372	366	1125315	1966-10-18	1966-11-01	1	-1157
45911	3117	1503184	1994-06-22	1995-06-17	1	9298
5564	380	1713332	1985-08-06	1985-08-20	1	5710
48313	3283	1124957	2018-10-12	2018-10-12	1	17816
6602	455	1125315	2007-11-27	2007-12-11	1	13858
54243	3691	1118084	1991-01-16	1991-01-16	1	7685
10354	710	1112807	1962-11-21	1962-12-05	1	-2584
52377	3568	1125315	1986-06-21	1986-07-05	1	6029
55025	3744	1125315	2016-03-03	2016-03-10	1	16870
7855	546	1125315	1950-12-28	1951-01-04	1	-6937
45885	3115	1125315	1968-09-12	1968-09-19	1	-469
5716	393	1713332	2017-09-28	2017-10-19	1	17458
6003	410	1125315	1990-04-04	1990-04-25	1	7419
52235	3558	1713332	1973-04-20	1973-05-11	1	1226
46487	3159	1503184	1979-05-21	1980-05-15	1	3787
11370	776	1125315	2003-02-01	2003-02-15	1	12098
58006	3956	1177480	1983-05-20	1983-06-03	1	4901
6241	430	1125315	1949-12-15	1949-12-29	1	-7308
54946	3736	1125315	1991-12-31	1992-01-21	1	8055
4364	298	1115008	2010-06-18	2010-07-02	1	14792
50124	3414	1118084	2004-04-04	2004-04-04	1	12512
64235	4387	1759842	1994-09-28	1994-10-05	1	9043
50007	3408	1713332	1988-12-14	1989-01-04	1	6943
12130	836	1549786	2002-07-09	2003-07-04	1	12237
12984	886	738818	2016-02-19	2016-02-26	1	16857
50814	3455	19127890	1993-03-31	1994-03-26	1	8850
11029	756	1125315	1973-08-23	1973-08-30	1	1337
46749	3175	1177480	1995-02-01	1995-03-03	1	9192
6859	474	1759842	1976-03-17	1976-03-24	1	2274
7837	545	1102527	2015-10-16	2015-10-16	1	16724
4780	328	1125315	1981-12-12	1981-12-26	1	4377
10253	704	1125315	1999-03-20	1999-04-03	1	10684
53155	3622	1759842	1970-11-02	1970-11-09	1	312
10842	743	1124957	1991-11-08	1991-11-08	1	7981
51304	3495	738818	1980-07-14	1980-07-28	1	3861
5498	376	1759842	1969-04-29	1969-05-20	1	-226
73149	4999	1759842	2008-09-17	2008-10-01	1	14153
53227	3625	1310149	2012-09-04	2012-09-04	1	15587
5678	390	1515774	1993-01-11	1994-01-06	1	8771
43726	2953	1177480	1988-12-10	1989-03-10	1	7008
2301	153	705944	1957-06-06	1960-01-14	1	-3640
54534	3708	1125315	1988-09-12	1988-10-12	1	6859
8192	569	1112807	1949-02-08	1949-03-01	1	-7611
51077	3477	1713332	1993-06-28	1993-07-05	1	8586
4861	332	1125315	1993-12-29	1994-01-12	1	8777
7328	505	933724	1998-06-21	1998-07-05	1	10412
55418	3769	1347450	2016-04-17	2016-04-17	1	16908
6198	426	1125315	1988-01-08	1988-01-15	1	6588
52023	3542	1125315	1948-06-05	1948-06-12	1	-7873
6503	449	1137529	1995-12-14	1995-12-14	1	9478
51844	3531	1503184	1988-02-17	1989-02-11	1	6981
5620	384	1119510	2008-02-10	2008-02-17	1	13926
45162	3065	19127890	1994-04-03	1995-03-29	1	9218
60380	4116	1503184	1984-10-03	1985-09-28	1	5749
11861	817	1759842	1983-02-27	1983-03-20	1	4826
6675	461	1112807	1950-06-17	1950-07-01	1	-7124
37252	2535	1738521	1970-10-11	1970-11-08	1	311
5373	366	1125315	1949-05-31	1949-06-07	1	-7513
45912	3117	1515774	1993-06-27	1994-06-22	1	8938
5565	380	1738521	1973-03-14	1973-03-28	1	1182
48314	3283	1125315	1981-02-28	1981-05-29	1	4166
6603	455	1119510	1985-08-10	1985-08-17	1	5707
54244	3691	1125315	1969-07-26	1969-08-02	1	-152
10355	710	1125315	1961-10-15	1961-10-29	1	-2986
52378	3568	1177480	1984-03-16	1984-04-06	1	5209
55026	3744	1112807	1975-07-14	1975-07-28	1	2034
7856	546	1125315	1953-10-22	1954-01-20	1	-5825
45886	3115	1125315	2000-07-06	2000-07-20	1	11158
5717	393	1759842	2004-01-18	2004-02-01	1	12449
6004	410	1174888	2019-02-06	2019-02-06	1	17933
52236	3558	920293	1992-04-19	1992-04-26	1	8151
46488	3159	1503184	1981-05-10	1982-05-05	1	4507
13334	914	1115008	2013-05-20	2013-07-19	1	15905
58007	3956	1728416	1958-11-22	1958-12-27	1	-4023
6242	430	1125315	2006-02-15	2006-02-22	1	13201
54947	3736	1713332	1974-01-06	1974-01-20	1	1480
4365	298	1728416	1955-09-03	1955-09-17	1	-5220
50125	3414	1125315	1969-08-17	1969-08-31	1	-123
64236	4387	1112807	1968-04-02	1968-04-16	1	-625
50008	3408	1177480	1984-02-19	1984-03-18	1	5190
12131	836	1589505	1999-07-25	2000-07-19	1	11157
12985	886	1125315	1985-09-21	1985-10-05	1	5756
53391	3637	1125315	2009-01-24	2009-02-07	1	14282
11030	756	19127890	1981-07-21	1982-07-16	1	4579
46750	3175	1729720	1999-05-16	1999-05-28	1	10739
6860	474	1125315	1974-02-21	1974-03-07	1	1526
7838	545	1118084	2004-05-23	2004-05-23	1	12561
4781	328	920293	2012-01-15	2012-01-22	1	15361
10254	704	1125315	1999-06-23	1999-07-21	1	10793
53156	3622	1112807	1922-12-20	1923-01-03	1	-17165
10843	743	1549786	1992-10-13	1993-10-08	1	8681
51305	3495	1125315	1980-07-14	1980-07-28	1	3861
5499	376	19127890	1979-04-03	1980-03-28	1	3739
73150	4999	19127890	1975-10-20	1976-10-14	1	2478
53228	3625	1713332	2010-10-20	2010-11-03	1	14916
5679	390	933724	2016-02-22	2016-02-29	1	16860
43727	2953	1729720	1993-11-02	1993-11-11	1	8715
2302	153	1112807	1972-10-10	1972-10-24	1	1027
54535	3708	1125315	1998-06-30	1998-07-14	1	10421
8193	569	1115008	2009-01-29	2009-02-12	1	14287
51078	3477	1729720	1968-02-22	1968-03-04	1	-668
4862	332	1125315	2005-10-28	2005-11-04	1	13091
7329	505	1112807	1987-11-06	1987-12-04	1	6546
55419	3769	1112807	1951-03-18	1951-04-15	1	-6836
6872	476	1112807	1972-06-21	1972-07-05	1	916
52024	3542	1125315	1993-01-14	1993-02-04	1	8435
6504	449	1738521	1976-03-03	1976-03-17	1	2267
51845	3531	1521369	1981-03-25	1983-03-15	2	4821
5621	384	1125315	1962-04-20	1962-05-25	1	-2778
45163	3065	738818	1989-09-23	1989-09-30	1	7212
60381	4116	1102527	1996-11-06	1996-11-06	1	9806
11862	817	1759842	1998-09-01	1998-09-15	1	10484
6676	461	1125315	2017-05-10	2017-06-14	2	17331
37253	2535	1759842	2015-04-03	2015-04-17	1	16542
5374	366	1125315	1987-01-14	1987-01-28	1	6236
45913	3117	1521369	1989-07-18	1990-07-13	1	7498
5566	380	1738521	1974-02-14	1974-02-28	1	1519
48315	3283	1713332	1993-09-21	1993-10-12	1	8685
6604	455	1125315	1993-03-10	1993-03-17	1	8476
54245	3691	1125315	1984-01-05	1984-01-19	1	5131
10356	710	1125315	1985-01-21	1985-01-28	1	5506
52379	3568	1729720	1984-01-15	1984-01-28	1	5140
55027	3744	1125315	1979-09-18	1979-10-02	1	3561
7857	546	1125315	1990-04-22	1990-04-29	1	7423
45887	3115	1521369	1985-12-21	1986-12-16	1	6193
5718	393	1759842	2017-09-28	2017-10-19	1	17458
6005	410	1177480	2019-02-06	2019-03-08	1	17963
52237	3558	1137529	2016-05-07	2016-05-07	1	16928
46489	3159	1521369	1981-05-10	1982-05-05	1	4507
13335	914	1177480	2016-08-02	2016-08-23	1	17036
58008	3956	1112807	1924-06-18	1924-08-17	1	-16573
6243	430	1501700	1990-06-05	1990-06-05	1	7460
54948	3736	1729720	1964-06-09	1964-06-17	1	-2024
4366	298	1119510	2004-11-11	2004-11-18	1	12740
50126	3414	1125315	1982-04-05	1982-04-19	1	4491
64237	4387	1729720	1974-07-04	1974-07-15	1	1656
50009	3408	1729720	1992-08-30	1992-09-11	1	8289
12132	836	1589505	2004-06-28	2005-04-03	1	12876
12986	886	1125315	1995-11-29	1995-12-06	1	9470
53392	3637	1119510	1991-05-21	1991-05-28	1	7817
11031	756	1112807	1972-12-25	1973-01-24	1	1119
46751	3175	1759842	1960-09-14	1960-09-28	1	-3382
6861	474	1125315	1990-09-05	1990-09-26	1	7573
7839	545	1177480	2018-09-30	2018-10-21	1	17825
4782	328	738818	2014-03-31	2014-04-07	1	16167
10255	704	1713332	1983-02-17	1983-03-10	1	4816
53157	3622	1112807	1925-02-07	1925-04-08	1	-16339
10844	743	1713332	2004-05-01	2004-05-15	1	12553
51306	3495	1125315	1985-03-08	1985-04-05	1	5573
5888	404	705944	1970-06-12	1971-11-05	1	673
73151	4999	738818	2001-09-19	2001-09-26	1	11591
53229	3625	1112807	1954-06-09	1954-06-23	1	-5671
5680	390	1124300	2016-05-15	2016-05-15	1	16936
43728	2953	1729720	2012-08-10	2012-08-20	1	15572
2303	153	1125315	1944-06-06	1944-06-20	1	-9326
54536	3708	1759842	1984-07-28	1984-08-11	1	5336
8194	569	1118084	1956-03-02	1956-03-02	1	-5053
51079	3477	1759842	1993-06-28	1993-07-05	1	8586
4863	332	1503184	1979-05-31	1980-05-25	1	3797
7330	505	1125315	1972-04-27	1972-05-11	1	861
55420	3769	1115008	2003-11-06	2003-11-20	1	12376
6873	476	1729720	1968-06-14	1968-06-23	1	-557
52025	3542	1177480	2002-09-15	2002-11-21	1	12012
6505	449	738818	2001-02-19	2001-02-26	1	11379
51846	3531	1102527	1979-05-25	1979-05-25	1	3431
5622	384	1125315	2008-02-10	2008-02-17	1	13926
45164	3065	1115008	2018-05-18	2018-06-01	1	17683
60382	4116	1115008	2004-07-27	2004-08-17	1	12647
11863	817	1125315	2006-09-07	2006-09-14	1	13405
6677	461	1729720	1954-07-15	1954-07-24	1	-5640
37254	2535	1125315	2003-11-24	2003-12-01	1	12387
5375	366	1713332	1914-09-05	1914-11-28	1	-20123
45914	3117	933724	1997-08-23	1997-08-30	1	10103
5567	380	1759842	1985-08-06	1985-08-20	1	5710
48316	3283	1759842	1993-09-21	1993-10-12	1	8685
6605	455	1177480	2014-06-02	2014-06-16	1	16237
54246	3691	1125315	1988-03-20	1988-04-03	1	6667
10357	710	1713332	1980-02-18	1980-03-10	1	3721
52380	3568	1112807	1970-02-23	1970-03-09	1	67
55028	3744	1125315	1990-11-08	1991-02-06	1	7706
7858	546	1125315	2001-01-03	2001-01-17	1	11339
45888	3115	1713332	1980-08-15	1980-08-29	1	3893
8032	559	1118084	2011-06-03	2011-06-03	1	15128
6006	410	1713332	1974-03-01	1974-03-15	1	1534
52238	3558	1503184	1977-03-03	1978-02-26	1	2978
46490	3159	1521369	1983-04-30	1984-04-24	1	5227
13336	914	738818	2006-07-09	2006-07-16	1	13345
58009	3956	1115008	2013-02-25	2013-04-26	1	15821
6244	430	1729720	1965-05-23	1965-06-05	1	-1671
54949	3736	1729720	1968-02-26	1968-03-10	1	-662
4367	298	1125315	1954-12-24	1955-01-14	1	-5466
50127	3414	1125315	2013-10-27	2013-11-10	1	16019
64958	4437	1112807	1970-06-15	1970-06-29	1	179
51607	3516	701322	2012-01-02	2012-01-02	1	15341
12133	836	1595799	2002-07-09	2003-07-04	1	12237
12987	886	1125315	1998-11-19	1998-12-03	1	10563
53393	3637	1125315	1964-11-21	1964-12-05	1	-1853
11032	756	1115008	1996-08-26	1996-09-23	1	9762
46752	3175	1115008	1996-10-23	1996-11-27	1	9827
6862	474	1713332	1976-03-17	1976-03-24	1	2274
7840	545	1729720	1983-06-04	1983-06-12	1	4910
4783	328	920293	2005-12-08	2005-12-15	1	13132
10256	704	1713332	2015-09-28	2015-10-19	1	16727
53158	3622	1112807	1927-09-07	1927-09-21	1	-15443
10845	743	1717327	1977-01-25	1977-02-08	1	2595
51307	3495	1125315	2002-12-01	2002-12-08	1	12029
5889	404	738818	2011-11-10	2011-11-17	1	15295
73152	4999	933724	2007-12-12	2007-12-19	1	13866
53230	3625	1125315	1955-03-06	1955-04-10	1	-5380
5681	390	1521369	1992-01-17	1993-01-11	1	8411
43729	2953	738818	2002-03-20	2002-04-03	1	11780
2304	153	1713332	1948-04-22	1948-04-29	1	-7917
54537	3708	1768849	1981-05-12	1981-05-26	1	4163
8195	569	1125315	1947-10-05	1947-10-19	1	-8110
51080	3477	705944	1972-03-25	1972-07-01	1	912
4864	332	1112807	1972-08-25	1972-10-24	1	1027
7331	505	1125315	2019-02-28	2019-03-07	1	17962
55421	3769	1125315	1954-04-02	1954-04-09	1	-5746
6874	476	738818	1985-07-31	1985-08-14	1	5704
52026	3542	1177480	2009-05-18	2009-06-08	1	14403
6506	449	1125315	1985-08-17	1985-08-31	1	5721
51847	3531	1112807	1969-01-17	1969-04-17	1	-259
7283	502	1119510	1955-03-31	1955-04-07	1	-5383
45165	3065	1119510	1995-04-27	1995-05-04	1	9254
60383	4116	1125315	2006-01-28	2006-02-11	1	13190
11864	817	1125315	2007-01-27	2007-01-27	1	13540
6678	461	1729720	1958-03-06	1958-03-15	1	-4310
37255	2535	1322184	2000-08-27	2000-08-27	1	11196
7259	500	738818	1966-06-27	1966-07-04	1	-1277
45915	3117	1118084	2008-04-14	2008-04-14	1	13983
5568	380	705944	1983-11-09	1984-03-21	1	5193
48317	3283	1177480	1987-11-24	1988-02-22	1	6626
6606	455	1713332	1950-03-07	1950-03-21	1	-7226
54247	3691	1177480	1989-12-24	1990-01-14	1	7318
10358	710	1738521	1974-10-28	1974-11-11	1	1775
52381	3568	1112807	1971-11-28	1971-12-12	1	710
55029	3744	1177480	2019-01-17	2019-01-31	1	17927
7859	546	1125315	2004-11-23	2004-12-14	1	12766
45889	3115	1717327	1968-04-14	1968-04-28	1	-613
8033	559	1177480	1974-02-22	1974-03-15	1	1534
6007	410	1728416	1951-04-24	1951-05-08	1	-6813
52239	3558	933724	1992-04-19	1992-04-26	1	8151
46491	3159	1713332	1961-08-19	1961-09-09	1	-3036
13337	914	1112807	1947-01-18	1947-02-01	1	-8370
58010	3956	1125315	1958-11-22	1958-11-22	2	-4023
6245	430	1759842	1964-03-05	1964-03-19	1	-2114
56085	3822	1112807	1945-08-21	1945-09-11	1	-8878
4368	298	1125315	1974-09-30	1974-10-14	1	1747
50128	3414	1112807	1971-08-06	1971-08-20	1	596
64959	4437	1125315	1969-10-05	1969-10-19	1	-74
51608	3516	757627	2010-09-09	2010-09-09	1	14861
12134	836	1738521	1980-12-06	1980-12-20	1	4006
12988	886	1729720	1992-07-06	1992-07-18	1	8234
53394	3637	1713332	1971-07-10	1971-07-24	1	569
11033	756	1125315	1982-09-04	1982-09-18	1	4643
46753	3175	1125315	1989-11-17	1989-11-24	1	7267
6863	474	1738521	1975-03-24	1975-04-07	1	1922
7841	545	920293	2017-11-08	2017-11-15	1	17485
4784	328	933724	2012-01-15	2012-01-22	1	15361
10257	704	1738521	1976-03-19	1976-04-02	1	2283
53159	3622	1125315	1948-12-04	1948-12-11	1	-7691
11908	820	1118084	2004-12-27	2004-12-27	1	12779
51308	3495	1521369	1982-05-28	1983-05-23	1	4890
5890	404	1177480	1983-01-20	1983-02-03	1	4781
73153	4999	1124300	1991-06-28	1991-06-28	1	7848
53231	3625	1125315	1960-01-14	1960-02-04	1	-3619
5682	390	1521369	1994-01-06	1995-01-01	1	9131
43730	2953	1115008	2019-03-28	2019-04-11	1	17997
2305	153	1729720	1943-09-11	1943-09-18	1	-9602
54803	3728	1125315	1995-04-13	1995-05-04	1	9254
8196	569	1125315	1964-05-21	1964-06-04	1	-2037
51081	3477	1129625	1986-04-20	1986-04-20	1	5953
4865	332	1119510	1982-09-26	1982-10-10	1	4665
7332	505	1129625	1970-06-25	1970-06-25	1	175
55422	3769	1125315	2019-03-20	2019-04-03	1	17989
6875	476	1125315	1985-07-31	1985-08-14	1	5704
52027	3542	1177480	2010-07-03	2010-09-01	1	14853
6507	449	1149380	1995-12-14	1995-12-14	1	9478
51848	3531	1112807	1971-04-15	1971-04-29	1	483
7284	502	1125315	1979-06-01	1979-06-08	1	3445
45166	3065	1125315	1974-10-28	1974-11-11	1	1775
60384	4116	1521369	1984-10-03	1985-09-28	1	5749
11865	817	1177480	2012-12-26	2013-02-01	1	15737
6679	461	1112807	1954-05-11	1954-05-25	1	-5700
37256	2535	1729720	1962-10-08	1962-10-16	1	-2634
7260	500	1118084	1998-09-25	1998-09-25	1	10494
45916	3117	1125315	2005-03-16	2005-03-30	1	12872
5569	380	1729720	1996-07-16	1996-07-27	1	9704
48318	3283	1713332	1980-07-03	1980-07-17	1	3850
8824	609	1118084	2001-04-22	2001-04-22	1	11434
54248	3691	1728416	1957-05-29	1957-06-12	1	-4586
10359	710	1119510	1985-01-21	1985-01-28	1	5506
52382	3568	1125315	1976-04-24	1976-05-08	1	2319
55030	3744	1112807	1971-05-22	1971-06-05	1	520
7860	546	1713332	1995-02-17	1995-03-03	1	9192
45890	3115	1729720	1987-03-20	1987-03-28	1	6295
8034	559	738818	1989-01-26	1989-02-09	1	6979
6008	410	1729720	1957-07-24	1957-08-03	1	-4534
52240	3558	1521369	1977-03-03	1978-02-26	1	2978
46492	3159	738818	1971-05-25	1971-06-08	1	523
13338	914	1115008	2015-06-09	2015-07-09	1	16625
58011	3956	1125315	2012-10-02	2012-10-09	1	15622
6246	430	738818	1954-10-11	1954-10-18	1	-5554
56086	3822	1112807	1969-05-22	1969-06-19	1	-196
4369	298	1125315	1982-07-26	1982-08-23	1	4617
50129	3414	1717327	1971-08-06	1971-08-20	1	596
64960	4437	1728416	1969-10-05	1969-10-19	1	-74
51609	3516	1119510	2002-05-05	2002-05-19	1	11826
12135	836	1768849	1979-05-31	1979-06-14	1	3451
12989	886	1125315	2016-02-19	2016-02-26	1	16857
53395	3637	1713332	2014-05-25	2014-06-08	1	16229
11034	756	1125315	1985-04-12	1985-04-26	1	5594
46754	3175	1177480	1993-12-24	1994-01-07	1	8772
6864	474	1759842	1975-07-21	1975-08-11	1	2048
7842	545	1177480	2015-10-16	2016-01-14	1	16814
4785	328	1125315	2014-03-31	2014-04-07	1	16167
10258	704	1759842	1970-09-10	1970-09-17	1	259
53160	3622	1125315	1993-07-20	1993-07-27	1	8608
11909	820	1125315	2009-10-14	2009-10-21	1	14538
51309	3495	1729720	1968-06-02	1968-06-14	1	-566
5891	404	1759842	1969-11-02	1969-11-16	1	-46
73154	4999	1125315	2001-09-19	2001-09-26	1	11591
53232	3625	1125315	1964-10-15	1964-10-29	1	-1890
5683	390	1713332	2017-09-30	2017-10-14	1	17453
43731	2953	1125315	2002-03-20	2002-04-03	1	11780
3555	239	1112807	1963-12-25	1964-01-08	1	-2185
54804	3728	1125315	2007-07-30	2007-09-28	1	13784
8197	569	1125315	2012-03-31	2012-04-07	1	15437
55915	3807	705944	1956-09-18	1964-09-26	1	-1923
4866	332	1125315	1969-02-14	1969-02-21	1	-314
7333	505	1729720	1979-05-10	1979-05-20	1	3426
55423	3769	1112807	1970-05-05	1970-06-02	1	152
6876	476	1177480	1992-06-27	1992-08-01	1	8248
52028	3542	1557272	2017-09-23	2017-09-23	1	17432
6508	449	1192710	1984-11-21	1984-11-21	1	5438
51849	3531	1115008	2009-02-16	2009-03-16	1	14319
7285	502	1309944	2016-03-05	2016-03-05	1	16865
45167	3065	1125315	1982-05-19	1982-06-25	1	4558
60385	4116	1729720	2002-11-12	2002-11-25	1	12016
11866	817	1713332	1989-08-11	1989-08-25	1	7176
6680	461	1125315	1951-12-10	1951-12-24	1	-6583
37257	2535	1112807	1961-03-02	1961-03-16	1	-3213
7261	500	1125315	1966-06-27	1966-07-04	1	-1277
45917	3117	1125315	2015-03-24	2015-04-07	1	16532
7049	486	920293	1996-12-01	1996-12-08	1	9838
48319	3283	1713332	1981-10-15	1981-10-29	1	4319
8825	609	1125315	1975-12-01	1975-12-15	1	2174
54249	3691	1112807	1964-03-21	1964-04-25	1	-2077
10360	710	1125315	1992-04-05	1992-04-26	1	8151
52383	3568	1125315	1977-07-15	1977-07-22	1	2759
55031	3744	1125315	1971-06-23	1971-06-30	1	545
7861	546	1759842	1947-06-03	1947-09-16	1	-8143
45891	3115	1759842	1980-08-15	1980-08-29	1	3893
8035	559	1125315	1973-05-12	1973-05-19	1	1234
6009	410	1759842	2010-05-31	2010-06-14	1	14774
53410	3638	1124300	2002-12-13	2002-12-13	1	12034
46493	3159	738818	2002-08-01	2002-08-15	1	11914
13339	914	1118084	1989-03-08	1989-03-08	1	7006
59791	4078	1112807	1968-03-09	1968-03-23	1	-649
6247	430	1112807	1931-09-18	1931-10-02	1	-13971
56087	3822	1125315	1972-08-31	1972-09-14	1	987
4370	298	1125315	2004-11-11	2004-11-18	1	12740
50130	3414	1119510	1969-08-17	1969-08-31	1	-123
64961	4437	1729720	1976-10-01	1976-10-08	1	2472
51610	3516	1729720	1957-09-25	1957-10-04	1	-4472
12136	836	19127890	2001-07-14	2002-07-09	1	11877
12990	886	1759842	1999-02-11	1999-02-25	1	10647
53396	3637	1759842	1974-02-05	1974-02-12	1	1503
11035	756	1174888	1995-09-01	1995-09-01	1	9374
46755	3175	1759842	1994-08-07	1994-08-28	1	9005
9168	636	738818	1998-11-16	1998-11-23	1	10553
7843	545	1521369	1985-10-05	1987-09-25	2	6476
4786	328	1713332	1984-08-05	1984-08-19	1	5344
10259	704	1759842	1983-02-17	1983-03-10	1	4816
53161	3622	1307863	1999-10-27	1999-10-27	1	10891
11910	820	1713332	1982-06-17	1982-07-01	1	4564
51310	3495	933724	2017-07-08	2017-07-15	1	17362
5892	404	738818	2007-01-21	2007-01-28	1	13541
73155	4999	1326303	2018-01-21	2018-01-21	1	17552
53233	3625	1125315	2000-07-03	2000-07-24	1	11162
5684	390	1729720	1988-06-10	1988-06-23	1	6748
43732	2953	1729720	2009-05-15	2009-05-27	1	14391
3556	239	1118084	1992-04-26	1992-04-26	1	8151
54805	3728	1125315	2012-05-03	2012-05-17	1	15477
8198	569	1347450	1998-02-21	1998-02-21	1	10278
55916	3807	920293	1973-10-16	1973-10-23	1	1391
4867	332	1521369	1979-05-31	1980-05-25	1	3797
7334	505	1738521	1969-03-31	1969-04-14	1	-262
55424	3769	1118084	1990-09-04	1990-09-04	1	7551
6877	476	1124300	2002-07-29	2002-07-29	1	11897
52029	3542	1713332	1961-06-23	1961-07-14	1	-3093
6509	449	1713332	1992-11-29	1992-12-20	1	8389
51850	3531	1124300	2001-07-08	2001-07-08	1	11511
7286	502	1310149	2011-04-02	2011-04-02	1	15066
45168	3065	1125315	1983-12-03	1983-12-10	1	5091
60386	4116	1112807	1969-08-13	1969-08-27	1	-127
11867	817	1713332	1998-12-21	1999-01-11	1	10602
6681	461	1125315	1953-03-27	1953-04-03	1	-6117
37258	2535	1118084	1999-03-13	1999-03-13	1	10663
7262	500	1125315	1981-12-27	1982-01-31	1	4413
45918	3117	1503184	1989-07-18	1990-07-13	1	7498
7050	486	920293	1997-02-04	1997-02-11	1	9903
48320	3283	1713332	2008-10-18	2008-11-08	1	14191
8826	609	1125315	1991-02-01	1991-02-15	1	7715
54250	3691	1729720	1999-01-04	1999-01-16	1	10607
11541	789	1115008	2000-06-25	2000-07-09	1	11147
52384	3568	1717327	1970-02-23	1970-03-09	1	67
55032	3744	975125	2002-12-28	2002-12-28	1	12049
7862	546	1759842	1995-02-17	1995-03-03	1	9192
45892	3115	1112807	1973-02-08	1973-03-01	1	1155
8036	559	1125315	1981-01-07	1981-03-08	2	4084
6010	410	933724	1995-09-21	1995-09-28	1	9401
53411	3638	1125315	1987-07-09	1987-07-30	1	6419
46494	3159	1115008	2015-06-01	2015-06-29	1	16615
13340	914	1125315	2006-07-09	2006-07-16	1	13345
59792	4078	1192710	1953-08-26	1953-08-26	1	-5972
6248	430	1125315	1954-10-11	1954-10-18	1	-5554
56088	3822	1125315	1988-07-09	1988-10-07	1	6854
4371	298	1361711	2019-02-12	2019-02-12	1	17939
50131	3414	1119510	1982-04-05	1982-04-19	1	4491
64962	4437	1729720	1984-03-15	1984-03-25	1	5197
51611	3516	1125315	1984-06-10	1984-06-24	1	5288
12137	836	1119510	2001-01-29	2001-02-05	1	11358
12991	886	1759842	2007-06-21	2007-07-12	1	13706
53397	3637	1759842	2014-05-25	2014-06-08	1	16229
11036	756	1759842	2013-08-14	2013-08-28	1	15945
47252	3211	1112807	1965-06-09	1965-06-23	1	-1653
9169	636	1102527	2018-01-04	2018-01-04	1	17535
7844	545	1521369	1988-09-19	1989-09-14	1	7196
4787	328	1759842	1984-08-05	1984-08-19	1	5344
10260	704	1759842	2015-09-28	2015-10-19	1	16727
53162	3622	1347450	1991-07-03	1991-07-03	1	7853
11911	820	1713332	1989-12-27	1990-01-10	1	7314
51311	3495	1119510	1980-07-14	1980-07-28	1	3861
5893	404	1119510	1988-02-10	1988-02-17	1	6621
73156	4999	1521369	1980-09-23	1981-09-18	1	4278
53234	3625	1307863	2012-09-04	2012-09-04	1	15587
5685	390	1125315	1998-08-21	1998-09-04	1	10473
43733	2953	1778162	1986-04-25	1986-05-09	1	5972
3557	239	1119510	1984-10-23	1984-10-30	1	5416
54806	3728	1713332	1988-01-07	1988-01-14	1	6587
8199	569	1759842	1989-01-26	1989-02-09	1	6979
55917	3807	933724	1973-10-16	1973-10-23	1	1391
4868	332	1713332	1990-04-08	1990-04-29	1	7423
7335	505	1112807	1969-03-31	1969-04-14	1	-262
55425	3769	1119510	1954-04-02	1954-04-09	1	-5746
6878	476	1125315	1977-05-28	1977-06-11	1	2718
52030	3542	1713332	1993-02-08	1993-02-15	1	8446
6510	449	1759842	1992-11-29	1992-12-20	1	8389
51851	3531	1729720	1981-09-07	1981-09-16	1	4276
7287	502	1343916	2016-03-05	2016-03-05	1	16865
45169	3065	1125315	1987-10-01	1987-10-08	1	6489
60387	4116	1112807	1970-09-07	1970-10-12	1	284
11868	817	1728416	1958-02-10	1958-02-24	1	-4329
6682	461	1125315	1955-04-24	1955-05-01	1	-5359
37259	2535	1119510	1998-10-26	1998-11-02	1	10532
7263	500	1174888	2013-03-19	2013-03-19	1	15783
45919	3117	1503184	1992-07-02	1993-06-27	1	8578
7051	486	933724	1996-12-01	1996-12-08	1	9838
48321	3283	19127890	1992-07-10	1993-07-05	1	8586
8827	609	1125315	2018-03-08	2018-03-15	1	17605
54251	3691	1112807	1955-09-07	1955-09-21	1	-5216
11542	789	1125315	1972-07-26	1972-08-09	1	951
52385	3568	1115008	2002-07-31	2002-08-30	1	11929
55033	3744	1124300	2004-12-09	2004-12-09	1	12761
7863	546	738818	2004-01-21	2004-01-28	1	12445
45893	3115	1125315	1968-04-14	1968-04-28	1	-613
8037	559	1125315	1989-01-26	1989-02-09	1	6979
6011	410	1112807	1951-04-24	1951-05-08	1	-6813
53412	3638	1125315	1988-09-19	1988-09-26	1	6843
46495	3159	1125315	1959-10-23	1959-11-06	1	-3709
13341	914	1112807	1948-08-10	1948-08-24	1	-7800
59793	4078	1728416	1955-11-13	1955-11-27	1	-5149
6249	430	1125315	1973-03-11	1973-04-15	1	1200
56089	3822	1307863	2015-04-27	2015-04-27	1	16552
4372	298	1539403	2019-02-12	2019-02-12	1	17939
50132	3414	1125315	1974-11-18	1974-12-09	1	1803
64963	4437	1759842	1971-05-06	1971-05-27	1	511
51612	3516	1115008	1996-09-24	1996-11-23	1	9823
12138	836	1177480	1979-12-10	1979-12-24	1	3644
12992	886	1112807	1989-01-03	1989-01-17	1	6956
53398	3637	1125315	1989-03-15	1989-03-29	1	7027
11037	756	1125315	2005-01-04	2005-01-11	1	12794
47253	3211	1125315	1958-11-13	1958-11-27	1	-4053
9170	636	1307863	1999-05-28	1999-05-28	1	10739
17560	1214	1112807	1940-03-27	1940-04-10	1	-10858
4788	328	1768849	1981-12-12	1981-12-26	1	4377
11522	787	1729720	1988-06-14	1988-06-26	1	6751
53163	3622	1713332	1970-11-02	1970-11-09	1	312
11912	820	1759842	1989-12-27	1990-01-10	1	7314
51312	3495	1125315	1966-04-12	1966-04-26	1	-1346
5894	404	1119510	2011-11-10	2011-11-17	1	15295
73157	4999	1713332	1971-08-17	1971-08-24	1	600
53235	3625	1759842	2010-10-20	2010-11-03	1	14916
5686	390	1503184	1992-01-17	1993-01-11	1	8411
43734	2953	1119510	2002-03-20	2002-04-03	1	11780
3558	239	1125315	1963-10-21	1963-11-04	1	-2250
54807	3728	1713332	1995-04-12	1995-04-26	1	9246
8200	569	1112807	1939-09-24	1939-10-29	1	-11022
55918	3807	1112807	1949-08-23	1949-09-06	1	-7422
6800	470	1112807	1961-08-07	1961-08-28	1	-3048
7336	505	1125315	1971-03-21	1971-04-04	1	458
55426	3769	1119510	1981-07-29	1981-08-05	1	4234
6879	476	1125315	1983-05-25	1983-06-15	1	4913
52031	3542	1112807	1938-03-29	1938-04-12	1	-11587
8926	615	738818	1982-05-22	1982-06-05	1	4538
51852	3531	1738521	1967-04-28	1967-05-12	1	-965
7288	502	1759842	1974-08-05	1974-08-12	1	1684
45170	3065	1125315	1989-09-23	1989-09-30	1	7212
60388	4116	1125315	1980-06-21	1980-07-12	1	3845
11869	817	1124300	1999-07-20	1999-07-20	1	10792
6683	461	1125315	1993-02-07	1993-02-14	1	8445
37260	2535	1125315	1961-11-05	1961-11-19	1	-2965
7264	500	1125315	1965-06-21	1965-07-05	1	-1641
45920	3117	1521369	1992-07-02	1993-06-27	1	8578
7052	486	920293	1998-03-29	1998-04-05	1	10321
48322	3283	1119510	2001-12-12	2001-12-19	1	11675
8828	609	1759842	1974-10-28	1974-11-18	1	1782
54252	3691	1112807	1957-05-29	1957-06-12	1	-4586
11543	789	1713332	1993-01-23	1993-02-13	1	8444
52386	3568	1118084	2012-12-04	2012-12-04	1	15678
55034	3744	1125315	1994-12-17	1995-02-22	2	9183
7864	546	1112807	1946-11-28	1946-12-28	1	-8405
45894	3115	1759842	1988-12-07	1988-12-14	1	6922
8038	559	1125315	1992-04-09	1992-05-09	1	8164
6012	410	1125315	2010-09-26	2010-10-10	1	14892
53413	3638	1125315	2014-07-27	2014-08-10	1	16292
46496	3159	1125315	1963-11-12	1963-11-26	1	-2228
13342	914	1112807	1967-04-17	1967-05-08	1	-969
59794	4078	975125	1961-01-31	1961-02-21	1	-3236
6250	430	1125315	1986-01-05	1986-01-19	1	5862
56090	3822	1326303	2015-04-27	2015-04-27	1	16552
4373	298	1729720	1952-10-08	1952-10-20	1	-6282
50133	3414	1125315	1981-05-01	1981-05-08	1	4145
64964	4437	1713332	1971-05-06	1971-05-27	1	511
51613	3516	1118084	1978-04-09	1978-04-09	1	3020
12139	836	1177480	1987-06-02	1987-06-23	1	6382
12993	886	1124300	2018-06-15	2018-06-15	1	17697
53399	3637	1713332	1974-02-05	1974-02-12	1	1503
11038	756	1503184	1981-07-21	1982-07-16	1	4579
47254	3211	1125315	1961-06-02	1961-06-16	1	-3121
9171	636	1713332	1993-05-26	1993-06-09	1	8560
17561	1214	1118084	1978-01-07	1978-01-07	1	2928
4789	328	933724	2005-12-08	2005-12-15	1	13132
11523	787	1118084	2017-01-07	2017-01-07	1	17173
53164	3622	1326303	1999-10-27	1999-10-27	1	10891
11913	820	1713332	2002-08-05	2003-02-03	1	12086
51313	3495	1728416	1966-04-12	1966-04-26	1	-1346
5895	404	1125315	1965-03-22	1965-04-05	1	-1732
73158	4999	1713332	2007-01-14	2007-01-21	1	13534
53236	3625	1118084	1997-07-18	1997-07-18	1	10060
5687	390	1503184	1994-01-06	1995-01-01	1	9131
43735	2953	1125315	1986-04-25	1986-05-09	1	5972
3559	239	1125315	2012-07-05	2012-07-05	1	15526
54808	3728	1112807	1984-09-09	1984-09-23	1	5379
8201	569	1115008	2006-04-01	2006-04-15	1	13253
55919	3807	1118084	1988-06-27	1988-06-27	1	6752
6801	470	1125315	2013-01-27	2013-02-10	1	15746
7337	505	1177480	1993-08-04	1993-09-08	1	8651
55427	3769	1125315	1957-04-25	1957-05-09	1	-4620
6880	476	1125315	2002-02-11	2002-02-25	1	11743
52032	3542	1125315	2002-09-22	2002-09-22	1	11952
8927	615	1112807	1915-03-27	1915-04-10	1	-19990
51853	3531	19127890	1984-03-09	1985-03-04	1	5541
7289	502	914335	2016-03-05	2016-03-05	1	16865
45171	3065	1503184	1992-04-13	1993-04-08	1	8498
60389	4116	1125315	1996-10-30	1997-01-05	1	9866
11870	817	1125315	1989-08-11	1989-08-25	1	7176
6684	461	1174888	2017-05-10	2017-05-10	1	17296
37261	2535	1713332	1994-04-17	1994-05-01	1	8886
7265	500	1717327	1962-03-18	1962-04-01	1	-2832
45921	3117	1521369	1994-06-22	1995-06-17	1	9298
7053	486	933724	1997-02-04	1997-02-11	1	9903
48323	3283	1125315	2018-10-12	2018-10-12	1	17816
8829	609	914335	2014-12-02	2014-12-02	1	16406
54668	3719	1177480	1999-06-03	1999-07-01	1	10773
11544	789	738818	1994-12-28	1995-01-04	1	9134
52387	3568	1728416	1971-11-28	1971-12-12	1	710
55035	3744	1125315	2009-10-27	2009-11-03	1	14551
7865	546	1119510	2004-01-21	2004-01-28	1	12445
45895	3115	19127890	1990-11-25	1991-11-20	1	7993
8039	559	1174888	1981-01-07	1981-01-07	1	4024
6013	410	1759842	1974-03-01	1974-03-15	1	1534
53414	3638	1177480	1976-04-23	1976-05-07	1	2318
46497	3159	1125315	2002-08-01	2002-08-15	1	11914
13343	914	1119510	2006-07-09	2006-07-16	1	13345
59795	4078	1119510	1975-03-23	1975-03-30	1	1914
6251	430	1713332	1964-03-05	1964-03-19	1	-2114
56091	3822	1713332	1980-03-07	1980-03-28	1	3739
4374	298	1778162	2014-02-11	2014-03-04	1	16133
50134	3414	1125315	1994-07-24	1994-08-07	1	8984
64965	4437	1118084	2010-11-14	2010-11-14	1	14927
51614	3516	1119510	1949-01-07	1949-01-21	1	-7650
12140	836	1515774	1992-08-30	1993-08-25	1	8637
12994	886	1713332	1999-02-11	1999-02-25	1	10647
53400	3637	1717327	1964-11-21	1964-12-05	1	-1853
11039	756	1713332	1985-04-12	1985-04-26	1	5594
47255	3211	1125315	2001-11-19	2001-12-03	1	11659
9172	636	1759842	2005-05-18	2005-05-25	1	12928
17562	1214	1713332	1955-03-14	1955-03-21	1	-5400
4790	328	1118084	2014-04-13	2014-04-13	1	16173
11524	787	1125315	1978-02-17	1978-02-24	1	2976
53165	3622	1729720	1925-09-08	1925-09-20	1	-16174
11914	820	1729720	1964-10-22	1964-10-29	1	-1890
51314	3495	19127890	1982-05-28	1983-05-23	1	4890
5896	404	1125315	2007-01-21	2007-01-28	1	13541
73159	4999	1759842	1993-08-31	1993-09-21	1	8664
53237	3625	1728416	1957-11-05	1957-11-19	1	-4426
5688	390	1549786	1993-01-11	1994-01-06	1	8771
43736	2953	1713332	2019-03-28	2019-04-11	1	17997
3560	239	1361711	2012-01-12	2012-07-05	1	15526
54809	3728	1118084	2011-01-21	2011-01-21	1	14995
8202	569	1125315	1912-10-25	1912-11-01	1	-20880
55920	3807	1125315	1958-06-09	1958-06-23	1	-4210
6802	470	1112807	1955-11-07	1955-11-21	1	-5155
7338	505	1551099	1983-09-14	1983-09-14	1	5004
55713	3791	1112807	1915-08-24	1915-09-07	1	-19840
6881	476	1728416	1972-06-21	1972-07-05	1	916
52033	3542	1729720	1938-01-02	1938-01-13	1	-11676
8928	615	1118084	1941-12-05	1941-12-05	1	-10254
51854	3531	19127890	1986-02-27	1987-02-22	1	6261
7290	502	1112807	1977-02-02	1977-02-16	1	2603
45172	3065	1521369	1992-04-13	1993-04-08	1	8498
60390	4116	1713332	1969-11-17	1969-12-01	1	-31
11871	817	1125315	2008-12-03	2008-12-10	1	14223
6685	461	1713332	2000-01-25	2000-02-01	1	10988
37262	2535	1729720	1972-09-09	1972-09-18	1	991
7266	500	1729720	1967-05-23	1967-06-03	1	-943
45922	3117	1549786	1993-06-27	1994-06-22	1	8938
7054	486	1124300	1999-03-14	1999-03-14	1	10664
48324	3283	1503184	1992-07-10	1993-07-05	1	8586
8830	609	1119510	1991-02-01	1991-02-15	1	7715
54669	3719	1177480	2004-06-04	2004-09-02	1	12663
11545	789	1118084	2014-09-04	2014-09-04	1	16317
53068	3616	1125315	2012-03-15	2012-03-22	1	15421
55036	3744	1153428	2003-01-08	2003-01-08	1	12060
7866	546	1125315	2004-01-21	2004-01-28	1	12445
47881	3249	738818	1962-09-17	1962-09-24	1	-2656
8040	559	1713332	1986-04-25	1986-05-02	1	5965
7147	492	920293	1983-01-03	1983-01-10	1	4757
53415	3638	1729720	1999-10-29	1999-11-10	1	10905
46498	3159	1713332	1970-02-14	1970-03-07	1	65
13344	914	1177480	2004-01-24	2004-02-07	1	12455
59796	4078	1125315	1957-01-12	1957-01-26	1	-4723
6820	472	1125315	1992-06-29	1992-06-29	1	8215
56092	3822	1759842	1980-03-07	1980-03-28	1	3739
4375	298	738818	2004-11-11	2004-11-18	1	12740
50135	3414	1125315	1985-03-05	1985-03-12	1	5549
64966	4437	1125315	1976-08-31	1976-09-07	1	2441
51615	3516	1124957	1981-12-12	1981-12-12	1	4363
12141	836	1713332	1988-11-09	1989-02-15	1	6985
12995	886	1713332	2007-06-21	2007-07-12	1	13706
53401	3637	1729720	1970-11-09	1970-11-19	1	322
11040	756	1713332	2013-08-14	2013-08-28	1	15945
47256	3211	1503184	1977-10-14	1978-10-09	1	3203
9173	636	1124300	1982-11-19	1982-11-19	1	4705
17563	1214	1112807	1945-10-27	1945-11-17	1	-8811
4791	328	1119510	2014-03-31	2014-04-07	1	16167
11525	787	1125315	1979-07-11	1979-08-15	1	3513
53166	3622	738818	2005-01-23	2005-02-06	1	12820
11915	820	1759842	2018-05-04	2018-05-25	1	17676
51315	3495	1112807	1967-02-19	1967-03-05	1	-1033
5897	404	1125315	2007-12-24	2008-01-07	1	13885
73160	4999	1759842	2009-04-06	2009-04-27	1	14361
53238	3625	1729720	1965-10-18	1965-10-30	1	-1524
5689	390	1125315	2015-05-20	2015-05-27	1	16582
46597	3167	1125315	1974-01-23	1974-02-13	1	1504
3561	239	738818	1984-10-23	1984-10-30	1	5416
54810	3728	1125315	2005-11-19	2005-11-26	1	13113
8203	569	1125315	1956-06-10	1956-06-17	1	-4946
55921	3807	1125315	1977-03-06	1977-03-13	1	2628
6803	470	1112807	1967-03-30	1967-04-13	1	-994
7339	505	1115008	1996-10-22	1996-11-05	1	9805
55714	3791	1115008	2012-04-08	2012-06-07	1	15498
6882	476	1759842	1970-04-10	1970-05-01	1	120
52034	3542	1759842	1961-06-23	1961-07-14	1	-3093
8929	615	1125315	1914-01-03	1914-01-17	1	-20438
51855	3531	19127890	1988-02-17	1989-02-11	1	6981
7291	502	1118084	1979-08-26	1979-08-26	1	3524
45173	3065	1549786	1994-04-03	1995-03-29	1	9218
60391	4116	1118084	2012-06-23	2012-06-23	1	15514
11872	817	1177480	2007-01-27	2007-04-27	1	13630
6686	461	1713332	2017-05-10	2017-06-14	1	17331
37263	2535	1759842	1994-04-17	1994-05-01	1	8886
7267	500	1125315	1962-07-28	1962-08-11	1	-2700
45923	3117	1729720	1981-08-01	1981-08-11	1	4240
7055	486	933724	1998-03-29	1998-04-05	1	10321
48325	3283	738818	2001-12-12	2001-12-19	1	11675
8831	609	1343916	2014-12-02	2014-12-02	1	16406
54670	3719	920293	2015-01-22	2015-01-29	1	16464
11546	789	1125315	1990-02-22	1990-03-29	1	7392
53069	3616	1125315	2019-06-01	2019-06-15	1	18062
55037	3744	1174888	1994-12-24	1994-12-24	1	9123
7867	546	1713332	1947-06-03	1947-09-16	1	-8143
47882	3249	1115008	2008-02-29	2008-03-30	1	13968
8041	559	1729720	1973-06-16	1973-06-24	1	1270
7148	492	1124300	1986-06-16	1986-06-16	1	6010
53416	3638	738818	2013-02-19	2013-03-05	1	15769
46499	3159	1728416	1963-11-12	1963-11-26	1	-2228
13345	914	1728416	1948-08-10	1948-08-24	1	-7800
59797	4078	1125315	1967-09-12	1967-09-19	1	-835
6821	472	1768849	1992-06-29	1992-07-13	1	8229
56093	3822	1112807	1964-06-03	1964-06-17	1	-2024
4376	298	1118084	1990-02-18	1990-02-18	1	7353
51560	3514	1125315	1989-09-09	1989-09-16	1	7198
64967	4437	1177480	2018-02-20	2018-03-13	1	17603
51616	3516	1125315	1954-04-20	1954-05-04	1	-5721
12142	836	1759842	1988-11-09	1989-02-15	1	6985
12996	886	1119510	2016-02-19	2016-02-26	1	16857
53402	3637	1759842	1971-07-10	1971-07-24	1	569
11041	756	1728416	1966-08-29	1966-09-12	1	-1207
47257	3211	19127890	1974-10-30	1975-10-25	1	2123
9174	636	1125315	1952-01-21	1952-02-04	1	-6541
17564	1214	1119510	1985-06-06	1985-06-20	1	5649
4792	328	1125315	1985-04-27	1985-05-11	1	5609
11526	787	1713332	1985-08-05	1985-08-19	1	5709
53167	3622	1115008	2008-11-18	2008-12-18	1	14231
11916	820	1125315	1967-02-05	1967-02-19	1	-1047
51316	3495	1112807	1968-01-19	1968-02-02	1	-699
5898	404	1125315	2011-11-10	2011-11-17	1	15295
73161	4999	1119510	2001-09-19	2001-09-26	1	11591
56681	3862	1112807	1957-12-22	1958-01-05	1	-4379
5690	390	1177480	1980-04-09	1980-04-23	1	3765
46598	3167	1717327	1964-11-22	1964-12-06	1	-1852
3562	239	738818	2003-11-21	2003-12-05	1	12391
54811	3728	1125315	1987-08-09	1987-08-23	1	6443
8204	569	1322184	1998-02-21	1998-02-21	1	10278
55922	3807	1177480	1995-09-04	1995-09-18	1	9391
6804	470	1728416	1955-11-07	1955-11-21	1	-5155
7340	505	1118084	2001-11-13	2001-11-13	1	11639
55715	3791	1125315	1932-06-26	1932-07-03	1	-13696
6883	476	1119510	1985-07-31	1985-08-14	1	5704
59473	4053	1115008	2016-01-12	2016-01-26	1	16826
8930	615	1125315	1982-05-22	1982-06-05	1	4538
51856	3531	920293	1994-05-08	1994-05-15	1	8900
7292	502	1119510	2017-06-20	2017-06-27	1	17344
45174	3065	1118084	2014-05-26	2014-05-26	1	16216
60392	4116	1125315	2008-12-23	2008-12-30	1	14243
11873	817	1503184	1974-04-27	1975-04-22	1	1937
6687	461	1759842	2000-01-25	2000-02-01	1	10988
37264	2535	738818	1979-02-28	1979-03-14	1	3359
7268	500	1125315	1962-09-14	1962-10-05	1	-2645
45924	3117	1778162	2005-03-16	2005-03-30	1	12872
8281	576	1115008	1997-04-18	1997-05-09	1	9990
48326	3283	933724	2005-08-03	2005-08-17	1	13012
8832	609	1759842	1970-01-09	1970-01-23	1	22
54671	3719	1759842	1964-02-09	1964-02-23	1	-2139
11547	789	1125315	1994-12-28	1995-01-04	1	9134
53070	3616	1728416	1960-05-15	1960-05-29	1	-3504
55038	3744	1343916	2003-01-08	2003-01-08	1	12060
7868	546	1729720	1986-03-11	1986-03-24	1	5926
47883	3249	1125315	1962-09-17	1962-09-24	1	-2656
8042	559	1729720	2005-05-11	2005-05-18	1	12921
7149	492	1125315	2016-03-31	2016-04-14	1	16905
53417	3638	1119510	2013-02-19	2013-03-05	1	15769
46500	3159	1729720	1975-07-03	1975-07-15	1	2021
13346	914	1729720	1945-11-27	1945-12-06	1	-8792
59798	4078	1177480	1986-09-15	1986-10-13	1	6129
6822	472	1115008	2003-06-16	2003-08-15	1	12279
56094	3822	1118084	1986-09-30	1986-09-30	1	6116
4377	298	1125315	1967-02-24	1967-03-10	1	-1028
51561	3514	1125315	1994-02-23	1994-03-09	1	8833
64968	4437	1717327	1970-06-15	1970-06-29	1	179
51617	3516	1125315	1956-11-01	1956-11-08	1	-4802
12143	836	19127890	1997-08-04	1998-07-30	1	10437
14591	1004	933724	2011-10-25	2011-11-01	1	15279
53403	3637	738818	1991-05-21	1991-05-28	1	7817
11042	756	1738521	1968-04-04	1968-04-18	1	-623
47258	3211	1112807	1970-05-12	1970-06-02	1	152
9175	636	1125315	1998-11-16	1998-11-23	1	10553
17565	1214	1125315	1978-05-31	1978-06-14	1	3086
4793	328	1125315	2004-08-12	2004-08-19	1	12649
11527	787	1759842	1985-08-05	1985-08-19	1	5709
53168	3622	1118084	1964-11-29	1964-11-29	1	-1859
11917	820	1125315	1991-05-01	1991-05-08	1	7797
51317	3495	1125315	2008-10-06	2008-10-20	1	14172
5899	404	1192710	1965-07-04	1965-07-04	1	-1642
73162	4999	1125315	1988-08-31	1988-09-07	1	6824
56682	3862	1118084	1995-06-11	1995-06-11	1	9292
5691	390	1759842	2017-09-30	2017-10-14	1	17453
46599	3167	1759842	2008-09-07	2008-09-21	1	14143
3563	239	1112807	1966-08-25	1966-09-15	1	-1204
54812	3728	1759842	1988-01-07	1988-01-14	1	6587
9821	675	1112807	1949-10-09	1949-10-23	1	-7375
55923	3807	1728416	1948-03-29	1948-04-12	1	-7934
6805	470	1112807	1958-03-09	1958-03-23	1	-4302
7341	505	1125315	2013-11-06	2013-11-20	1	16029
55716	3791	1125315	1953-09-17	1953-10-01	1	-5936
6884	476	1713332	1970-04-10	1970-05-01	1	120
59474	4053	1713332	1975-08-05	1975-08-12	1	2049
8931	615	1177480	1996-04-23	1996-05-14	1	9630
51857	3531	933724	1994-05-08	1994-05-15	1	8900
7293	502	1125315	2000-10-13	2000-10-13	1	11243
45175	3065	1125315	1999-02-25	1999-03-11	1	10661
60393	4116	1713332	1979-07-05	1979-07-19	1	3486
11874	817	1503184	1976-04-16	1977-04-11	1	2657
6688	461	1115008	2001-02-19	2001-03-05	1	11386
37265	2535	738818	1998-10-26	1998-11-02	1	10532
7269	500	1125315	2013-03-19	2013-03-19	1	15783
45925	3117	1177480	2018-09-18	2018-10-09	1	17813
8282	576	1115008	1999-06-28	1999-07-12	1	10784
48327	3283	1125315	1980-07-03	1980-07-17	1	3850
8833	609	738818	1991-02-01	1991-02-15	1	7715
54672	3719	738818	1986-11-19	1986-12-03	1	6180
11548	789	1125315	1987-12-07	1987-12-21	1	6563
53071	3616	19127890	1974-02-11	1975-02-06	1	1862
55039	3744	1728416	1975-07-14	1975-07-28	1	2034
8592	596	715997	2001-03-06	2001-03-06	1	11387
47884	3249	1728416	1957-08-13	1957-08-27	1	-4510
8043	559	1729720	2009-06-30	2009-07-12	1	14437
7150	492	1177480	2010-07-16	2010-07-30	1	14820
53418	3638	1125315	2013-02-19	2013-03-05	1	15769
46501	3159	19127890	1979-05-21	1980-05-15	1	3787
15777	1092	1112807	1955-09-10	1955-09-24	1	-5213
59799	4078	1729720	1964-01-17	1964-01-25	1	-2168
6823	472	1119510	1979-04-10	1979-04-17	1	3393
56095	3822	1729720	1948-01-12	1948-01-24	1	-8013
4378	298	1125315	1989-11-18	1989-11-25	1	7268
51562	3514	1515774	1991-07-31	1992-07-25	1	8241
66756	4559	933724	2005-02-05	2005-02-12	1	12826
51618	3516	1125315	1966-03-08	1966-04-05	1	-1367
12144	836	920293	2007-10-04	2007-10-11	1	13797
14592	1004	1112807	1965-06-27	1965-07-11	1	-1635
53404	3637	1118084	2001-01-21	2001-01-21	1	11343
11043	756	1112807	1966-08-29	1966-09-12	1	-1207
47259	3211	1118084	1996-11-03	1996-11-03	1	9803
9176	636	1177480	2018-01-04	2018-04-04	1	17625
17566	1214	1125315	1987-02-11	1987-02-25	1	6264
9615	664	1125315	1983-11-26	1983-12-10	1	5091
12660	869	738818	1997-04-04	1997-04-18	1	9969
53169	3622	1119510	2005-01-23	2005-02-06	1	12820
11918	820	1177480	1982-06-17	1982-07-01	1	4564
51318	3495	1177480	1975-05-25	1975-06-15	1	1991
5900	404	1713332	1969-11-02	1969-11-16	1	-46
73163	4999	1310149	2018-01-21	2018-01-21	1	17552
56683	3862	1119510	1995-04-20	1995-05-04	1	9254
5692	390	19127890	1992-01-17	1995-01-01	3	9131
46600	3167	1119510	1966-07-06	1966-07-20	1	-1261
3564	239	1124957	2012-03-01	2012-03-01	1	15400
54813	3728	1759842	1995-04-12	1995-04-26	1	9246
9822	675	1112807	1958-08-21	1958-10-20	1	-4091
55924	3807	1729720	1953-07-04	1953-07-14	1	-6015
6806	470	1112807	1959-03-14	1959-03-28	1	-3932
7342	505	1738521	1972-04-27	1972-05-11	1	861
55717	3791	1125315	1976-09-19	1976-09-26	1	2460
9584	662	1112807	1971-04-27	1971-05-25	1	509
59475	4053	1729720	1971-07-10	1971-07-21	1	566
8932	615	1177480	1999-03-30	1999-04-13	1	10694
51858	3531	1112807	1967-04-28	1967-05-12	1	-965
7294	502	1177480	2000-10-13	2001-01-11	1	11333
45176	3065	1515774	1994-04-03	1995-03-29	1	9218
60394	4116	1717327	1969-08-13	1969-08-27	1	-127
11875	817	1759842	1998-12-21	1999-01-11	1	10602
6689	461	1118084	1985-01-04	1985-01-04	1	5482
37266	2535	1112807	1970-10-11	1970-11-08	1	311
7270	500	1112807	1962-03-18	1962-04-01	1	-2832
45926	3117	19127890	1992-07-02	1995-06-17	3	9298
8283	576	1118084	2001-12-10	2001-12-10	1	11666
48328	3283	1125315	1981-10-15	1981-10-29	1	4319
8834	609	1713332	1974-10-28	1974-11-18	1	1782
54673	3719	1118084	2003-08-16	2003-08-16	1	12280
11549	789	1125315	1989-05-07	1989-05-21	1	7080
53072	3616	1112807	1960-05-15	1960-05-29	1	-3504
57968	3955	1125315	1994-02-28	1994-02-28	1	8824
8593	596	1115008	2000-05-03	2000-05-17	1	11094
47885	3249	1759842	1974-09-17	1974-10-08	1	1741
8044	559	1759842	1986-04-25	1986-05-02	1	5965
7151	492	1759842	1961-06-26	1961-07-03	1	-3104
53419	3638	1149380	1967-05-08	1985-06-27	1	5656
46502	3159	1124300	2000-01-26	2000-01-26	1	10982
15778	1092	1125315	1960-03-11	1960-03-25	1	-3569
59800	4078	1118084	1995-10-09	1995-10-09	1	9412
6824	472	738818	1979-04-10	1979-04-17	1	3393
56096	3822	1729720	1958-02-28	1958-03-10	1	-4315
4379	298	1125315	2008-02-02	2008-02-16	1	13925
51563	3514	1515774	1993-07-20	1994-07-15	1	8961
66757	4559	1112807	1947-03-09	1947-03-23	1	-8320
51619	3516	1125315	1981-12-12	1982-02-10	2	4423
12145	836	1125315	1980-12-06	1980-12-20	1	4006
14593	1004	1125315	2003-10-29	2003-11-05	1	12361
53405	3637	1125315	1973-04-09	1973-04-16	1	1201
11044	756	1118084	2001-02-06	2001-02-06	1	11359
47260	3211	1125315	1968-06-07	1968-06-21	1	-559
9177	636	1310149	1999-05-28	1999-05-28	1	10739
17567	1214	1125315	1993-05-19	1993-06-02	1	8553
9616	664	1125315	2006-07-03	2006-07-24	1	13353
12661	869	1112807	1914-01-11	1914-01-25	1	-20430
53170	3622	1125315	2005-01-23	2005-02-06	1	12820
11919	820	1713332	2018-05-04	2018-05-25	1	17676
51319	3495	1503184	1982-05-28	1983-05-23	1	4890
5901	404	19127890	1975-06-06	1976-05-31	1	2342
73164	4999	1521369	1975-10-20	1976-10-14	1	2478
56684	3862	1177480	2011-04-13	2011-05-04	1	15098
8632	598	1112807	1987-02-14	1987-02-28	1	6267
46601	3167	1125315	1983-02-11	1983-02-25	1	4803
3565	239	1125315	1984-10-23	1984-10-30	1	5416
55989	3814	1112807	1976-07-23	1976-08-06	1	2409
9823	675	1115008	2019-06-07	2019-06-07	1	18054
55925	3807	1112807	1948-01-14	1948-01-28	1	-8009
6807	470	1125315	2009-04-29	2009-05-06	1	14370
7343	505	1177480	1983-10-20	1983-11-03	1	5054
55718	3791	1125315	2003-11-25	2003-12-02	1	12388
9585	662	1177480	1992-10-01	1992-11-04	1	8343
59476	4053	1112807	1964-09-11	1964-10-02	1	-1917
8933	615	1713332	2015-08-16	2015-09-06	1	16684
51859	3531	19127890	1981-03-25	1983-03-15	2	4821
7295	502	1713332	1974-08-05	1974-08-12	1	1684
45177	3065	1713332	2004-09-22	2004-11-17	1	12739
60395	4116	1759842	1969-11-17	1969-12-01	1	-31
11876	817	1112807	1958-02-10	1958-02-24	1	-4329
6690	461	1347450	1998-01-06	1998-01-06	1	10232
37267	2535	1125315	1979-02-28	1979-03-14	1	3359
7271	500	1112807	1968-06-19	1968-07-03	1	-547
45927	3117	19127890	1989-07-18	1990-07-13	1	7498
8284	576	1125315	2013-09-24	2013-10-08	1	15986
48329	3283	1125315	2001-12-12	2001-12-19	1	11675
8835	609	1309944	2014-12-02	2014-12-02	1	16406
54674	3719	1125315	1986-11-19	1986-12-03	1	6180
11550	789	1125315	2005-12-03	2005-12-17	1	13134
53073	3616	1112807	1964-02-13	1964-02-27	1	-2135
57969	3955	1125315	2004-03-09	2004-03-16	1	12493
8594	596	1125315	1958-02-26	1958-03-12	1	-4313
47886	3249	1119510	1962-09-17	1962-09-24	1	-2656
8045	559	738818	1969-06-19	1969-07-03	1	-182
7152	492	933724	1983-01-03	1983-01-10	1	4757
53420	3638	1713332	1997-11-12	1997-11-19	1	10184
46503	3159	1125315	1971-05-25	1971-06-08	1	523
15779	1092	1713332	1994-01-13	1994-01-27	1	8792
59801	4078	1713332	1952-08-08	1952-08-22	1	-6341
6825	472	975125	1998-01-30	1998-01-30	1	10256
56097	3822	1112807	1947-04-13	1947-04-27	1	-8285
4380	298	1125315	2014-02-11	2014-03-04	1	16133
51564	3514	1589505	1994-07-15	1995-07-10	1	9321
66758	4559	1119510	1981-11-25	1981-12-09	1	4360
51620	3516	1713332	1967-03-14	1967-05-23	1	-954
12146	836	1125315	1983-06-11	1983-06-18	1	4916
14594	1004	1115008	2016-09-27	2016-10-11	1	17085
53406	3637	1125315	1991-05-21	1991-05-28	1	7817
11045	756	1125315	1974-02-18	1974-05-19	1	1599
47261	3211	1503184	1974-10-30	1975-10-25	1	2123
9178	636	1728416	1952-01-21	1952-02-04	1	-6541
17568	1214	1177480	2012-05-14	2012-06-04	1	15495
9617	664	1549786	1995-07-06	1996-06-30	1	9677
12662	869	1112807	1937-11-25	1938-02-23	1	-11635
53171	3622	1729720	2012-09-04	2012-09-15	1	15598
11920	820	1717327	1970-03-12	1970-03-26	1	84
51938	3537	1112807	1966-01-30	1966-02-20	1	-1411
5902	404	738818	1988-02-10	1988-02-17	1	6621
73165	4999	1713332	2004-10-26	2004-11-16	1	12738
56685	3862	1728416	1957-12-22	1958-01-05	1	-4379
8633	598	1124300	2009-10-26	2009-10-26	1	14543
46602	3167	1125315	1990-11-06	1990-11-13	1	7621
3566	239	1125315	2003-11-21	2003-12-05	1	12391
55990	3814	1521369	1992-11-06	1993-11-01	1	8705
9824	675	1149380	1952-02-23	1952-02-23	1	-6522
55926	3807	1125315	1951-10-27	1951-11-10	1	-6627
6808	470	1729720	1960-02-15	1960-02-22	1	-3601
7344	505	1778162	1983-10-20	1983-11-03	1	5054
55719	3791	1713332	1955-09-02	1955-09-23	1	-5214
9586	662	1361711	1995-03-21	2012-06-06	1	15497
59477	4053	1125315	1965-06-18	1965-06-25	1	-1651
8934	615	1759842	1917-07-19	1917-07-26	1	-19152
51860	3531	1125315	1987-05-30	1987-06-13	1	6372
7296	502	1112807	1953-10-06	1953-10-20	1	-5917
45178	3065	1738521	1974-10-28	1974-11-11	1	1775
60396	4116	19127890	1984-10-03	1985-09-28	1	5749
11877	817	1125315	1961-12-21	1962-01-18	1	-2905
6691	461	1728416	1950-06-17	1950-07-01	1	-7124
38440	2615	1118084	1987-01-25	1987-01-25	1	6233
7272	500	1112807	1971-04-19	1971-05-10	1	494
50303	3428	738818	1973-03-20	1973-04-03	1	1188
8285	576	1129625	1971-09-20	1971-09-20	1	627
48330	3283	1177480	2018-10-12	2018-11-11	1	17846
8836	609	1713332	1970-01-09	1970-01-23	1	22
54675	3719	1177480	1985-10-09	1985-12-08	1	5820
11551	789	1177480	1991-02-22	1991-05-23	1	7812
53074	3616	1177480	1997-10-28	1997-11-18	1	10183
57970	3955	1759842	1957-04-08	1957-04-15	1	-4644
8595	596	1125315	1979-12-15	1980-01-05	1	3656
47887	3249	1125315	2001-08-10	2001-08-17	1	11551
8046	559	1119510	1989-01-26	1989-02-09	1	6979
7153	492	1112807	1949-09-28	1949-10-12	1	-7386
53421	3638	1125315	1968-06-04	1968-06-18	1	-562
46504	3159	1322184	2001-05-03	2001-05-03	1	11445
15780	1092	1118084	1992-10-20	1992-10-20	1	8328
59802	4078	738818	1975-03-23	1975-03-30	1	1914
6826	472	1125315	1979-04-10	1979-04-17	1	3393
56098	3822	1322184	2009-03-23	2009-03-23	1	14326
4381	298	1322184	2019-02-12	2019-02-12	1	17939
51565	3514	19127890	1996-07-04	1997-06-29	1	10041
66759	4559	1119510	2015-05-25	2015-06-01	1	16587
51621	3516	1729720	1947-05-04	1947-05-17	1	-8265
12147	836	1177480	1992-03-28	1992-06-26	1	8212
14595	1004	1119510	1986-12-13	1986-12-20	1	6197
53407	3637	1125315	2018-08-04	2018-08-18	1	17761
11046	756	1125315	1981-04-01	1981-04-08	1	4115
47262	3211	1713332	1963-01-30	1963-02-13	1	-2514
9179	636	1119510	1998-11-16	1998-11-23	1	10553
17569	1214	1759842	1955-03-14	1955-03-21	1	-5400
9618	664	1759842	2011-11-18	2011-12-09	1	15317
12663	869	1119510	1997-04-04	1997-04-18	1	9969
55439	3772	1112807	1970-06-10	1970-06-24	1	174
11921	820	1728416	1967-02-05	1967-02-19	1	-1047
51939	3537	1119510	2008-06-03	2008-06-10	1	14040
5903	404	1125315	1988-02-10	1988-02-17	1	6621
73166	4999	1717327	1971-10-01	1971-10-15	1	652
56686	3862	738818	1995-04-20	1995-05-04	1	9254
8634	598	1125315	2014-01-07	2014-02-04	1	16105
46603	3167	1125315	2006-08-29	2006-09-26	1	13417
3567	239	1174888	2012-07-05	2012-07-05	1	15526
55991	3814	1521369	1996-10-16	1998-10-06	2	10505
9825	675	1177480	2013-11-05	2014-02-03	1	16104
55927	3807	1125315	1956-01-02	1956-03-02	1	-5053
6809	470	1118084	1989-06-26	1989-06-26	1	7116
8786	607	1112807	1954-07-27	1954-08-26	1	-5607
55720	3791	738818	1937-07-08	1937-07-22	1	-11851
9587	662	1361711	2012-10-03	2012-10-03	1	15616
59478	4053	1125315	1988-06-28	1988-07-12	1	6767
8935	615	1759842	2009-10-20	2009-11-10	1	14558
51861	3531	1177480	1975-07-15	1975-10-13	1	2111
7297	502	1115008	2009-03-30	2009-05-04	1	14368
45951	3119	1112807	1982-01-05	1982-01-19	1	4401
61438	4194	1729720	2010-03-06	2010-03-17	1	14685
11878	817	1713332	2004-08-01	2004-08-15	1	12645
6692	461	1125315	2011-03-11	2011-03-18	1	15051
38441	2615	1125315	1987-05-04	1987-07-10	1	6399
7273	500	1115008	2013-03-19	2013-05-18	1	15843
50304	3428	1118084	2006-09-02	2006-09-02	1	13393
8286	576	1738521	1971-06-06	1971-06-20	1	535
48331	3283	1521369	1992-07-10	1993-07-05	1	8586
8837	609	1729720	2010-01-03	2010-01-11	1	14620
54676	3719	1729720	1972-05-21	1972-05-29	1	879
11552	789	1729720	1985-03-21	1985-03-30	1	5567
53075	3616	1717327	1964-02-13	1964-02-27	1	-2135
57971	3955	1125315	2007-03-02	2007-03-09	1	13581
8596	596	1729720	1981-12-12	1981-12-22	1	4373
47888	3249	1177480	1988-07-01	1988-07-15	1	6770
8047	559	1125315	1969-06-19	1969-07-03	1	-182
7154	492	1125315	1950-05-17	1950-05-31	1	-7155
53422	3638	1125315	2001-01-17	2001-02-16	1	11369
46505	3159	1759842	1970-02-14	1970-03-07	1	65
15781	1092	1125315	1981-01-10	1981-01-17	1	4034
59803	4078	975125	1966-01-28	1966-02-18	1	-1413
6827	472	1153428	1998-02-10	1998-02-10	1	10267
56099	3822	1332418	2009-03-23	2009-03-23	1	14326
4382	298	1332418	2019-02-12	2019-02-12	1	17939
51566	3514	19127890	1998-06-24	1999-06-19	1	10761
66760	4559	1177480	1985-03-06	1985-03-27	1	5564
51622	3516	738818	1949-01-07	1949-01-21	1	-7650
12148	836	1503184	1994-08-20	1995-08-15	1	9357
14596	1004	1125315	1970-12-30	1971-01-06	1	370
53408	3637	1713332	1990-01-25	1990-02-08	1	7343
11047	756	1125315	1995-08-25	1995-10-01	2	9404
47263	3211	1713332	1985-02-08	1985-02-22	1	5531
9180	636	1125315	2013-07-14	2013-07-28	1	15914
17570	1214	1112807	1942-03-28	1942-04-11	1	-10127
9619	664	19127890	1995-07-06	1996-06-30	1	9677
12664	869	1125315	1998-08-10	1998-08-17	1	10455
55440	3772	1125315	1980-07-17	1980-09-15	1	3910
11922	820	1729720	1969-05-09	1969-05-22	1	-224
51940	3537	1713332	1985-04-12	1985-04-26	1	5594
5904	404	1125315	2001-11-07	2001-11-21	1	11647
73167	4999	1729720	1968-05-20	1968-06-02	1	-578
56687	3862	1125315	1995-04-20	1995-05-04	1	9254
8635	598	1125315	2014-10-21	2014-10-28	1	16371
46604	3167	1125315	2011-09-30	2011-10-30	1	15277
3568	239	1332418	2012-01-12	2012-01-12	1	15351
55992	3814	1713332	1975-12-03	1975-12-17	1	2176
9826	675	1728416	1951-04-19	1951-05-03	1	-6818
55928	3807	1125315	1960-04-03	1960-04-17	1	-3546
6810	470	1728416	1959-03-14	1959-03-28	1	-3932
8787	607	1125315	1964-12-03	1964-12-10	1	-1848
55721	3791	1118084	1947-10-10	1947-10-10	1	-8119
9588	662	1713332	1970-09-21	1970-10-12	1	284
59479	4053	1125315	2017-11-21	2017-12-26	1	17526
8936	615	1119510	1920-07-16	1920-07-30	1	-18052
51862	3531	1503184	1981-03-25	1983-03-15	2	4821
7298	502	1125315	1955-03-31	1955-04-07	1	-5383
45952	3119	1115008	1996-11-01	1996-11-15	1	9815
61439	4194	1118084	2014-07-06	2014-07-06	1	16257
11879	817	1728416	1958-09-21	1958-10-05	1	-4106
6693	461	1322184	1998-01-06	1998-01-06	1	10232
38442	2615	1125315	1993-01-28	1993-02-11	1	8442
7274	500	1119510	1966-06-27	1966-07-04	1	-1277
50305	3428	1124957	2004-06-04	2004-06-04	1	12573
8287	576	1102527	2001-07-01	2001-07-01	1	11504
48332	3283	1759842	2008-10-18	2008-11-08	1	14191
9464	653	1125315	1975-01-21	1975-01-28	1	1853
54677	3719	701322	2013-04-27	2013-04-27	1	15822
11553	789	1738521	1972-07-26	1972-08-09	1	951
53076	3616	920293	2004-03-29	2004-04-05	1	12513
57972	3955	1177480	1976-03-20	1976-04-03	1	2284
8597	596	715997	2001-12-31	2001-12-31	1	11687
47889	3249	1177480	1999-09-14	1999-10-14	1	10878
8048	559	1729720	1992-04-03	1992-04-16	1	8141
7155	492	1125315	1954-10-03	1954-10-17	1	-5555
53423	3638	1154343	1967-05-08	1985-06-27	1	5656
46506	3159	19127890	1981-05-10	1982-05-05	1	4507
15782	1092	1125315	2009-09-05	2009-09-12	1	14499
59804	4078	1125315	1955-11-13	1955-11-27	1	-5149
6828	472	1343916	1998-02-10	1998-02-10	1	10267
56100	3822	1539403	2009-03-23	2009-03-23	1	14326
5076	348	1115008	1994-03-25	1994-04-15	1	8870
51567	3514	1112807	1975-09-13	1975-10-04	1	2102
66761	4559	1713332	1962-01-14	1962-01-28	1	-2895
51623	3516	738818	2002-05-05	2002-05-19	1	11826
12149	836	1549786	1992-08-30	1993-08-25	1	8637
14597	1004	1125315	1974-02-02	1974-02-16	1	1507
53409	3637	1759842	1990-01-25	1990-02-08	1	7343
11048	756	1521369	1981-07-21	1982-07-16	1	4579
47264	3211	1729720	2009-03-31	2009-04-12	1	14346
9181	636	1125315	2017-03-19	2017-03-26	1	17251
17571	1214	1112807	1955-12-23	1956-01-22	1	-5093
9620	664	975125	2010-07-15	2010-07-15	1	14805
12665	869	1177480	1975-09-05	1975-09-26	1	2094
55441	3772	1177480	1974-07-04	1974-07-18	1	1659
11923	820	1729720	1999-06-09	1999-06-18	1	10760
51941	3537	1759842	1987-03-24	1987-04-14	1	6312
5905	404	1521369	1975-06-06	1976-05-31	1	2342
73168	4999	1759842	2004-10-26	2004-11-16	1	12738
56688	3862	1115008	2013-11-19	2013-12-03	1	16042
8636	598	1728416	1977-01-07	1977-01-21	1	2577
46605	3167	1125315	2017-08-25	2017-09-08	1	17417
3569	239	1539403	2012-01-12	2012-01-12	1	15351
55993	3814	1125315	1977-08-19	1977-09-02	1	2801
9827	675	738818	1975-12-16	1975-12-30	1	2189
55929	3807	1728416	1948-01-14	1948-01-28	1	-8009
7504	518	1112807	1974-04-01	1974-04-15	1	1565
8788	607	1112807	1960-03-27	1960-04-10	1	-3553
55722	3791	1125315	1937-07-08	1937-07-22	1	-11851
9589	662	1717327	1963-05-21	1963-06-04	1	-2403
59480	4053	1115008	2014-09-24	2014-10-08	1	16351
8937	615	1177480	2019-06-27	2019-06-27	1	18074
51863	3531	1521369	1984-03-09	1985-03-04	1	5541
7299	502	1326303	2011-04-02	2011-04-02	1	15066
45953	3119	1118084	2015-06-27	2015-06-27	1	16613
61440	4194	1177480	2005-11-19	2005-12-17	1	13134
11880	817	1759842	2004-08-01	2004-08-15	1	12645
6694	461	1557272	2018-12-18	2018-12-18	1	17883
38443	2615	738818	1979-12-29	1980-01-05	1	3656
7275	500	1125315	1963-04-25	1963-05-09	1	-2429
50306	3428	1125315	1973-03-20	1973-04-03	1	1188
8288	576	1112807	1971-06-06	1971-06-20	1	535
50667	3446	738818	1959-12-01	1959-12-08	1	-3677
9465	653	1728416	1954-12-21	1955-01-04	1	-5476
54678	3719	757627	2012-01-03	2012-01-03	1	15342
11554	789	1759842	1993-01-23	1993-02-13	1	8444
53077	3616	933724	2004-03-29	2004-04-05	1	12513
57973	3955	1713332	1969-02-09	1969-03-02	1	-305
8598	596	1118084	1984-02-28	1984-02-28	1	5171
47890	3249	1729720	2000-06-19	2000-06-27	1	11135
8049	559	1119510	1969-06-19	1969-07-03	1	-182
7156	492	1125315	2006-09-02	2006-09-09	1	13400
53424	3638	1717327	1968-06-04	1968-06-18	1	-562
46507	3159	19127890	1983-04-30	1984-04-24	1	5227
15783	1092	1125315	2017-05-04	2017-05-18	1	17304
59805	4078	1125315	1975-03-23	1975-03-30	1	1914
6829	472	1729720	1983-12-16	1983-12-25	1	5106
56101	3822	1310149	2015-04-27	2015-04-27	1	16552
5077	348	1125315	2003-11-29	2003-12-06	1	12392
51568	3514	1177480	1982-05-30	1982-06-27	1	4560
66762	4559	1759842	2011-10-14	2011-10-28	1	15275
51624	3516	1125315	1949-01-07	1949-01-21	1	-7650
12150	836	1549786	1997-08-04	1998-07-30	1	10437
14598	1004	1729720	1977-09-10	1977-09-20	1	2819
53664	3651	1177480	1975-07-04	1975-07-25	1	2031
11748	807	1102527	1991-10-25	1991-10-25	1	7967
47265	3211	19127890	1977-10-14	1978-10-09	1	3203
9182	636	1326303	1999-05-28	1999-05-28	1	10739
17572	1214	1125315	1954-02-17	1954-03-03	1	-5783
9621	664	1112807	1988-11-29	1989-01-03	1	6942
12666	869	1347450	2006-09-29	2006-09-29	1	13420
55442	3772	1118084	2007-10-29	2007-10-29	1	13815
11924	820	1759842	2002-08-05	2003-02-03	1	12086
51942	3537	975125	1967-05-04	1967-05-18	1	-959
5906	404	1112807	1962-06-04	1962-07-09	1	-2733
76012	5201	1125315	2001-10-21	2001-10-28	1	11623
56689	3862	1125315	1977-05-12	1977-05-19	1	2695
8637	598	1125315	1977-01-07	1977-01-21	1	2577
46606	3167	1728416	1960-09-03	1960-09-17	1	-3393
3570	239	1112807	1947-07-17	1947-08-21	1	-8169
55994	3814	1125315	1983-02-01	1983-02-15	1	4793
9828	675	738818	1985-03-25	1985-04-08	1	5576
55930	3807	1728416	1960-04-03	1960-04-17	1	-3546
7505	518	1125315	1974-10-02	1974-10-16	1	1749
8789	607	1115008	2016-12-28	2017-01-25	1	17191
55723	3791	1125315	1982-10-13	1983-01-11	2	4758
9590	662	1125315	1977-09-13	1977-09-27	1	2826
59481	4053	1119510	1963-08-20	1963-08-27	1	-2319
8938	615	1557272	2000-09-09	2000-09-09	1	11209
51864	3531	1521369	1986-02-27	1987-02-22	1	6261
7300	502	1713332	2001-05-13	2001-05-27	1	11469
45954	3119	1125315	2012-06-16	2012-07-07	1	15528
61441	4194	1713332	1981-08-28	1981-09-11	1	4271
11881	817	19127890	1974-04-27	1975-04-22	1	1937
6695	461	1728416	1954-05-11	1954-05-25	1	-5700
38444	2615	1125315	1953-10-16	1953-10-30	1	-5907
7276	500	1125315	1974-06-23	1974-07-07	1	1648
50307	3428	1115008	2004-06-04	2004-08-03	1	12633
8289	576	1125315	2001-07-01	2001-09-29	1	11594
50668	3446	738818	2015-10-04	2015-10-18	1	16726
9466	653	1112807	1957-09-20	1957-10-04	1	-4472
54679	3719	933724	2015-01-22	2015-01-29	1	16464
11555	789	1119510	1994-12-28	1995-01-04	1	9134
53078	3616	1503184	1974-02-11	1975-02-06	1	1862
57974	3955	1759842	1973-06-14	1973-06-21	1	1267
8599	596	1728416	1949-02-11	1949-02-25	1	-7615
47891	3249	1729720	2008-02-04	2008-02-15	1	13924
8676	601	1177480	1974-10-21	1974-11-25	1	1789
7157	492	1713332	1961-06-26	1961-07-03	1	-3104
53425	3638	1729720	1977-05-15	1977-05-24	1	2700
46508	3159	1112807	1970-06-27	1970-07-27	1	207
15784	1092	1728416	1955-09-10	1955-09-24	1	-5213
59806	4078	1759842	1952-08-08	1952-08-22	1	-6341
6830	472	1124300	2018-10-06	2018-10-06	1	17810
56102	3822	1361711	2009-03-23	2009-03-23	1	14326
5078	348	1713332	1977-05-25	1977-06-08	1	2715
51569	3514	1515774	1996-07-04	1997-06-29	1	10041
66763	4559	1112807	1945-12-14	1946-02-12	1	-8724
51625	3516	1125315	2002-05-05	2002-05-19	1	11826
12151	836	738818	2001-01-29	2001-02-05	1	11358
14599	1004	738818	1986-12-13	1986-12-20	1	6197
53665	3651	1713332	1998-07-27	1998-09-21	1	10490
11749	807	1118084	1994-09-22	1994-09-22	1	9030
47266	3211	1125315	1992-02-07	1992-03-06	1	8100
9183	636	1713332	2005-05-18	2005-05-25	1	12928
17573	1214	1125315	1979-04-03	1979-04-24	1	3400
9622	664	1125315	2007-05-20	2007-06-03	1	13667
12667	869	1347450	2012-04-20	2012-04-20	1	15450
55443	3772	1125315	1984-07-27	1984-08-03	1	5328
11925	820	1112807	1970-03-12	1970-03-26	1	84
51943	3537	975125	1972-06-21	1972-07-12	1	923
5907	404	1118084	2001-12-21	2001-12-21	1	11677
76013	5201	1521369	1995-03-17	1996-03-11	1	9566
56690	3862	1713332	2005-07-20	2005-08-03	1	12998
15999	1107	1118084	1964-09-30	1964-09-30	1	-1919
46607	3167	1729720	1985-04-26	1985-05-06	1	5604
3571	239	1112807	1970-07-26	1970-08-09	1	220
55995	3814	1177480	1995-09-12	1995-10-10	1	9413
9829	675	933724	1986-03-21	1986-03-28	1	5930
55931	3807	1112807	1948-03-29	1948-04-12	1	-7934
7506	518	1125315	1977-04-24	1977-05-24	1	2700
8790	607	1125315	1977-11-04	1977-11-11	1	2871
55724	3791	1307863	2011-06-25	2011-06-25	1	15150
9591	662	1125315	1989-03-01	1989-03-15	1	7013
59482	4053	1713332	2016-01-12	2016-01-26	1	16826
8939	615	1729720	1929-07-17	1929-07-26	1	-14769
51865	3531	1521369	1988-02-17	1989-02-11	1	6981
7301	502	1738521	1977-02-02	1977-02-16	1	2603
45955	3119	1177480	1978-02-25	1978-03-11	1	2991
61442	4194	1125315	2012-06-18	2012-07-02	1	15523
11882	817	19127890	1976-04-16	1977-04-11	1	2657
6696	461	1729720	1969-06-28	1969-07-06	1	-179
38445	2615	1125315	1956-02-02	1956-02-16	1	-5068
7277	500	1728416	1963-04-25	1963-05-09	1	-2429
50308	3428	1125315	1978-07-22	1978-08-05	1	3138
8290	576	1125315	2015-06-01	2015-06-08	1	16594
50669	3446	1125315	1959-12-01	1959-12-08	1	-3677
9467	653	1118084	1990-05-11	1990-05-11	1	7435
54680	3719	1119510	1986-11-19	1986-12-03	1	6180
11556	789	1125315	1992-03-18	1992-04-08	1	8133
53079	3616	1713332	1960-12-16	1961-01-06	1	-3282
57975	3955	1759842	1981-03-18	1981-04-01	1	4108
8600	596	1729720	1952-07-09	1952-07-20	1	-6374
47892	3249	1118084	2002-02-18	2002-02-18	1	11736
8677	601	1713332	1996-01-04	1996-01-11	1	9506
7158	492	1728416	1949-09-28	1949-10-12	1	-7386
53426	3638	1759842	1997-11-12	1997-11-19	1	10184
46509	3159	1119510	1971-05-25	1971-06-08	1	523
15785	1092	1729720	1967-01-06	1967-01-17	1	-1080
62648	4278	1149380	1988-03-11	1988-03-11	1	6644
6831	472	1174888	1992-06-29	1992-06-29	1	8215
56103	3822	1728416	1947-04-13	1947-04-27	1	-8285
5079	348	1713332	1979-08-25	1979-09-08	1	3537
51570	3514	1515774	1998-06-24	1999-06-19	1	10761
66764	4559	1119510	1990-03-09	1990-03-23	1	7386
51626	3516	1177480	2017-03-08	2017-05-14	1	17300
12152	836	933724	2007-10-04	2007-10-11	1	13797
14600	1004	920293	2011-10-25	2011-11-01	1	15279
53666	3651	1119510	1992-01-07	1992-01-21	1	8055
11750	807	1119510	1973-11-17	1973-11-24	1	1423
47267	3211	1521369	1977-10-14	1978-10-09	1	3203
9184	636	1759842	1993-05-26	1993-06-09	1	8560
17574	1214	1713332	2018-12-17	2018-12-31	1	17896
9623	664	1521369	1998-06-24	1999-06-19	1	10761
12668	869	1112807	1915-12-02	1915-12-16	1	-19740
55444	3772	1728416	1970-06-10	1970-06-24	1	174
11926	820	1713332	1995-02-10	1995-03-03	1	9192
51944	3537	1118084	2002-04-01	2002-04-01	1	11778
5908	404	1119510	2007-01-21	2007-01-28	1	13541
76014	5201	1768849	1979-06-29	1979-07-13	1	3480
56691	3862	1759842	2005-07-20	2005-08-03	1	12998
16000	1107	1125315	1979-07-28	1979-08-25	1	3523
46608	3167	738818	1966-07-06	1966-07-20	1	-1261
3572	239	1119510	2003-11-21	2003-12-05	1	12391
55996	3814	1515774	1998-10-06	1999-10-01	1	10865
9830	675	1125315	1959-10-15	1959-10-29	1	-3717
55932	3807	1112807	1974-08-25	1974-10-24	1	1757
7507	518	1125315	2013-07-28	2013-08-27	1	15944
8791	607	1713332	1969-08-16	1969-08-23	1	-131
55725	3791	1322184	2014-11-01	2014-11-01	1	16375
9592	662	1125315	1993-10-01	1993-10-15	1	8688
59483	4053	1759842	1975-08-05	1975-08-12	1	2049
8940	615	920293	1958-02-20	1958-02-27	1	-4326
51866	3531	1713332	1994-01-27	1994-02-03	1	8799
7302	502	1759842	2001-05-13	2001-05-27	1	11469
45956	3119	1125315	2008-06-27	2008-07-04	1	14064
61443	4194	1125315	1981-08-28	1981-09-11	1	4271
13730	939	1177480	1981-03-29	1981-04-19	1	4126
10953	753	1119510	1973-02-25	1973-03-04	1	1158
38446	2615	1125315	1961-04-28	1961-05-05	1	-3163
10391	712	1119510	2018-12-25	2019-01-01	1	17897
50309	3428	1713332	2019-03-16	2019-04-06	1	17992
8291	576	1551099	2000-10-31	2000-10-31	1	11261
50670	3446	1125315	1972-08-01	1972-08-08	1	950
9468	653	1125315	1965-12-23	1966-01-13	2	-1449
54681	3719	1125315	1964-02-04	1964-02-11	1	-2151
11557	789	1125315	1995-12-01	1995-12-15	1	9479
53080	3616	1115008	2013-05-28	2013-07-02	1	15888
57976	3955	1759842	1998-07-25	1998-08-01	1	10439
8601	596	1729720	1972-01-09	1972-01-17	1	746
47893	3249	1125315	1972-03-16	1972-03-30	1	819
8678	601	1729720	2007-06-21	2007-07-04	1	13698
7159	492	1728416	1950-05-17	1950-05-31	1	-7155
55215	3756	1102527	1953-06-16	1953-06-16	1	-6043
46510	3159	1347450	2001-05-03	2001-05-03	1	11445
15786	1092	1112807	1962-08-04	1962-09-10	1	-2670
62649	4278	1713332	1957-11-16	1957-12-07	1	-4408
6832	472	1177480	1992-06-29	1992-07-13	1	8229
57207	3901	1112807	1939-01-02	1939-01-16	1	-11308
5080	348	1125315	1991-05-05	1991-06-09	1	7829
51571	3514	1549786	1998-06-24	1999-06-19	1	10761
66765	4559	1125315	1962-04-03	1962-05-01	1	-2802
51627	3516	1759842	1967-03-14	1967-05-23	1	-954
12153	836	1118084	2016-11-07	2016-11-07	1	17112
14601	1004	1118084	2001-01-19	2001-01-19	1	11341
53667	3651	1125315	2009-10-03	2009-10-10	1	14527
11751	807	1125315	1965-10-27	1965-11-10	1	-1513
47268	3211	1728416	1958-11-13	1958-11-27	1	-4053
9509	656	705944	1971-01-02	1971-11-06	1	674
17575	1214	1729720	1941-03-26	1941-04-04	1	-10499
9624	664	1713332	1986-10-17	1986-10-31	1	6147
12669	869	1112807	1936-10-10	1936-10-31	1	-12115
55445	3772	1738521	1974-07-04	1974-07-18	1	1659
11927	820	1713332	2000-05-26	2000-06-09	1	11117
51945	3537	1125315	1980-08-01	1980-08-31	1	3895
5909	404	1503184	1975-06-06	1976-05-31	1	2342
76015	5201	738818	1982-01-26	1982-02-02	1	4415
57713	3936	1112807	1962-02-01	1962-02-22	1	-2870
16001	1107	1539403	1991-02-08	1991-02-08	1	7708
46609	3167	1118084	2002-08-14	2002-08-14	1	11913
3573	239	1125315	2012-03-01	2012-04-30	2	15460
55997	3814	1728416	1976-07-23	1976-08-06	1	2409
9831	675	1125315	1975-12-16	1975-12-30	1	2189
55933	3807	1125315	1965-10-18	1965-10-25	1	-1529
7508	518	1717327	1973-01-27	1973-02-10	1	1136
8792	607	1713332	1989-05-25	1989-06-08	1	7098
55726	3791	1347450	2014-11-01	2014-11-01	1	16375
9593	662	1174888	2012-06-06	2012-06-06	1	15497
59484	4053	738818	1963-08-20	1963-08-27	1	-2319
8941	615	933724	1958-02-20	1958-02-27	1	-4326
51867	3531	1738521	1971-04-15	1971-04-29	1	483
7303	502	738818	1955-03-31	1955-04-07	1	-5383
45957	3119	1125315	1985-07-03	1985-09-01	1	5722
62085	4238	914335	1978-12-28	1978-12-28	1	3283
13731	939	705944	1977-07-11	1977-12-12	1	2902
10954	753	1119510	1999-11-30	1999-12-14	1	10939
38447	2615	1713332	1963-01-23	1963-02-06	1	-2521
10392	712	1309944	2011-04-14	2011-04-14	1	15078
50310	3428	701322	2018-05-26	2018-05-26	1	17677
8292	576	1729720	1997-07-31	1997-08-13	1	10086
50671	3446	1125315	2007-02-25	2007-03-11	1	13583
9469	653	1125315	1971-11-23	1971-12-07	1	705
54682	3719	1125315	1968-11-07	1968-12-07	1	-390
12621	867	757627	2012-07-31	2012-07-31	1	15552
53081	3616	1124300	1991-09-05	1991-09-05	1	7917
57977	3955	1124957	1994-02-28	1994-02-28	1	8824
8602	596	1112807	1949-02-11	1949-02-25	1	-7615
47894	3249	1125315	2008-02-29	2008-02-29	1	13938
8679	601	1759842	1996-01-04	1996-01-11	1	9506
7160	492	1729720	1954-03-18	1954-03-29	1	-5757
55216	3756	1125315	1946-02-03	1946-02-10	1	-8726
46511	3159	1503184	1983-04-30	1984-04-24	1	5227
15787	1092	1125315	1960-04-30	1960-05-14	1	-3519
62650	4278	1115008	1995-06-08	1995-06-22	1	9303
7521	520	920293	1974-12-10	1974-12-24	2	1818
57208	3901	1112807	1943-01-25	1943-02-15	1	-9817
5081	348	1177480	2015-11-21	2015-12-05	1	16774
51572	3514	1759842	2015-12-07	2015-12-14	1	16783
66766	4559	1125315	1965-01-27	1965-02-10	1	-1786
51820	3530	1309944	2003-01-03	2003-01-03	1	12055
12154	836	1125315	1990-06-09	1990-06-16	1	7471
14602	1004	1125315	1986-12-13	1986-12-20	1	6197
53668	3651	1124300	1995-10-07	1995-10-07	1	9410
11752	807	1125315	1991-10-25	1991-12-24	1	8027
47269	3211	1729720	1963-10-19	1963-11-01	1	-2253
9510	656	1115008	1999-09-27	1999-11-01	1	10896
17576	1214	1759842	1964-03-26	1964-04-09	1	-2093
9625	664	1124300	2016-12-17	2016-12-17	1	17152
12670	869	1118084	1949-11-23	1949-11-23	1	-7344
55446	3772	738818	2014-06-28	2014-07-12	1	16263
11928	820	1713332	2017-09-21	2017-09-28	1	17437
51946	3537	1125315	1990-12-22	1990-12-29	1	7667
6982	482	1125315	1979-04-10	1979-04-24	1	3400
76016	5201	1125315	1979-05-02	1979-05-16	1	3422
57714	3936	1115008	2006-11-28	2007-01-27	1	13540
16002	1107	1713332	1952-10-20	1952-10-27	1	-6275
46610	3167	1125315	1964-11-22	1964-12-06	1	-1852
3574	239	1545958	2012-07-05	2012-07-05	1	15526
55998	3814	1759842	1975-12-03	1975-12-17	1	2176
9832	675	1125315	1985-03-25	1985-04-08	1	5576
55934	3807	1728416	1949-08-23	1949-09-06	1	-7422
7509	518	1759842	1971-05-03	1971-05-17	1	501
8793	607	1729720	1984-09-05	1984-09-16	1	5372
55727	3791	1112807	1980-11-22	1981-01-21	1	4038
9594	662	1322184	1998-03-24	2012-06-06	1	15497
59485	4053	1118084	1999-03-07	1999-03-07	1	10657
8942	615	1112807	1944-11-19	1944-12-17	1	-9146
51868	3531	1759842	1994-01-27	1994-02-03	1	8799
7304	502	738818	2017-06-20	2017-06-27	1	17344
45958	3119	1125315	1997-09-12	1997-10-03	1	10137
62086	4238	920293	1992-10-05	1992-10-12	1	8320
13732	939	738818	1989-11-02	1989-11-09	1	7252
10955	753	1125315	1999-11-30	1999-12-14	1	10939
38448	2615	1713332	2006-03-19	2006-04-02	1	13240
10393	712	1343916	2011-04-14	2011-04-14	1	15078
50311	3428	715997	2018-05-26	2018-05-26	1	17677
8293	576	1759842	2015-12-17	2015-12-31	1	16800
50672	3446	1125315	2015-10-04	2015-10-18	1	16726
9470	653	1713332	1989-11-13	1989-12-04	1	7277
54683	3719	1125315	1985-10-09	1985-10-09	1	5760
12622	867	1125315	1971-05-29	1971-06-12	1	527
53082	3616	1177480	1975-11-23	1976-02-21	1	2242
57978	3955	1713332	1973-06-14	1973-06-21	1	1267
8603	596	1112807	1962-10-01	1962-10-15	1	-2635
47895	3249	1112807	1957-08-13	1957-08-27	1	-4510
8680	601	1115008	1996-08-20	1996-09-17	1	9756
7161	492	1729720	1961-03-23	1961-04-02	1	-3196
55217	3756	1137529	2004-05-01	2004-05-01	1	12539
46512	3159	1521369	1979-05-21	1980-05-15	1	3787
15788	1092	1125315	1982-12-22	1983-01-05	1	4752
62651	4278	1125315	1989-12-25	1990-01-08	1	7312
7522	520	1112807	1972-03-05	1972-03-19	1	808
57209	3901	1115008	2013-10-04	2013-10-25	1	16003
5082	348	1759842	1977-05-25	1977-06-08	1	2715
51573	3514	1125315	1981-06-14	1981-06-21	1	4189
66767	4559	1174888	1966-11-06	1966-11-06	1	-1152
51821	3530	1332418	1996-08-09	1996-08-09	1	9717
12155	836	1125315	2001-01-29	2001-02-05	1	11358
14603	1004	1125315	1997-05-27	1997-06-10	1	10022
53669	3651	1759842	1998-07-27	1998-09-21	1	10490
11753	807	1177480	2014-10-15	2014-11-19	1	16393
47270	3211	1729720	1972-02-29	1972-03-10	1	799
9511	656	1729720	1971-06-06	1971-06-19	1	534
17577	1214	1759842	2018-12-17	2018-12-31	1	17896
9626	664	1125315	1987-09-07	1987-09-14	1	6465
12671	869	1125315	1960-09-04	1960-09-11	1	-3399
55447	3772	1119510	2014-06-28	2014-07-12	1	16263
11929	820	1729720	1992-06-30	1992-07-11	1	8227
51947	3537	1125315	2015-08-28	2015-09-11	1	16689
6983	482	1521369	1983-10-20	1984-10-14	1	5400
76017	5201	1125315	1982-01-26	1982-02-02	1	4415
57715	3936	1728416	1959-01-16	1959-01-30	1	-3989
16003	1107	1729720	2002-05-30	2002-06-06	1	11844
46611	3167	1125315	1966-07-06	1966-07-20	1	-1261
3575	239	1717327	1963-10-21	1963-11-04	1	-2250
55999	3814	1124300	2013-04-10	2013-04-10	1	15805
9833	675	1729720	1959-04-06	1959-04-17	1	-3912
55935	3807	1729720	1952-02-26	1952-03-10	1	-6506
7510	518	1177480	1995-10-17	1995-10-31	1	9434
8794	607	1729720	2009-05-09	2009-05-21	1	14385
55728	3791	1119510	1937-07-08	1937-07-22	1	-11851
9595	662	1322184	2012-10-03	2012-10-03	1	15616
59486	4053	1125315	1963-08-20	1963-08-27	1	-2319
8943	615	1115008	2003-02-21	2003-03-23	1	12134
56213	3831	1112807	1971-08-20	1971-11-18	1	686
7305	502	1125315	2017-06-20	2017-06-27	1	17344
45959	3119	1125315	2000-02-02	2000-02-16	1	11003
62087	4238	933724	1992-10-05	1992-10-12	1	8320
13733	939	1112807	1976-01-27	1976-02-24	1	2245
10956	753	1503184	1981-09-20	1983-09-10	2	5000
38449	2615	1102527	1987-05-11	1987-05-11	1	6339
10394	712	1729720	1977-08-25	1977-09-04	1	2803
50312	3428	1119510	1973-03-20	1973-04-03	1	1188
8294	576	1112807	1969-04-17	1969-05-01	1	-245
50673	3446	1177480	1977-01-23	1977-02-27	1	2614
9471	653	1759842	1989-11-13	1989-12-04	1	7277
54684	3719	1174888	1985-10-09	1985-10-09	1	5760
12623	867	1125315	1973-05-15	1973-05-22	1	1237
53083	3616	1521369	1974-02-11	1975-02-06	1	1862
57979	3955	1729720	1996-01-15	1996-01-22	1	9517
8604	596	1125315	1950-10-18	1950-11-01	1	-7001
47896	3249	1124957	2008-02-29	2008-02-29	1	13938
8681	601	1118084	2010-06-24	2010-06-24	1	14784
7162	492	1112807	1950-12-17	1950-12-31	1	-6941
55218	3756	1322184	2006-02-04	2006-02-04	1	13183
46513	3159	1759842	1961-08-19	1961-09-09	1	-3036
15789	1092	1125315	1997-03-13	1997-05-19	2	10000
62652	4278	1137529	1988-03-11	1988-03-11	1	6644
7523	520	1125315	1964-07-08	1964-07-15	1	-1996
57210	3901	1125315	1962-04-12	1962-04-19	1	-2814
5083	348	1118084	2010-07-09	2010-07-09	1	14799
51574	3514	1125315	1987-03-03	1987-03-17	1	6284
66768	4559	1713332	2009-05-18	2009-06-08	1	14403
51822	3530	1343916	2003-01-03	2003-01-03	1	12055
12156	836	1125315	2008-03-04	2008-04-01	1	13970
14604	1004	1759842	1971-12-29	1972-01-05	1	734
53670	3651	738818	1992-01-07	1992-01-21	1	8055
11754	807	1729720	1981-10-25	1981-11-05	1	4326
47271	3211	1759842	1985-02-08	1985-02-22	1	5531
9512	656	1759842	1984-08-30	1984-09-06	1	5362
17578	1214	738818	1985-06-06	1985-06-20	1	5649
9627	664	1177480	1997-10-30	1997-11-13	1	10178
12672	869	1125315	1980-06-30	1980-07-14	1	3847
55448	3772	1125315	2014-06-28	2014-07-12	1	16263
11930	820	1759842	1995-02-10	1995-03-03	1	9192
51948	3537	1192710	1963-07-16	1963-07-16	1	-2361
6984	482	19127890	1989-09-18	1991-09-08	2	7920
76018	5201	1503184	1995-03-17	1996-03-11	1	9566
57716	3936	1729720	1991-05-27	1991-06-08	1	7828
16004	1107	1112807	1927-12-14	1928-03-13	1	-15269
46612	3167	1177480	1979-02-17	1979-03-03	1	3348
3576	239	1125315	1956-12-31	1957-03-31	1	-4659
56000	3814	1125315	1988-10-29	1988-11-05	1	6883
9834	675	1102527	2013-11-05	2013-11-05	1	16014
56540	3852	1125315	2003-09-19	2003-10-10	1	12335
7511	518	1713332	1971-05-03	1971-05-17	1	501
8795	607	1115008	2001-07-20	2001-09-18	1	11583
55729	3791	1125315	1944-06-01	1944-06-15	1	-9331
9596	662	1545958	2012-06-06	2012-06-06	1	15497
59487	4053	1125315	2015-12-29	2016-01-05	1	16805
8944	615	1119510	1982-05-22	1982-06-05	1	4538
56214	3831	1125315	1958-03-11	1958-03-25	1	-4300
7306	502	1174888	2000-10-13	2000-10-13	1	11243
45960	3119	1738521	1978-02-25	1978-03-11	1	2991
62088	4238	933724	1998-02-05	1998-02-19	1	10276
13734	939	1125315	1989-11-02	1989-11-09	1	7252
10957	753	1713332	1978-10-13	1978-10-27	1	3221
38450	2615	1119510	1979-12-29	1980-01-05	1	3656
10395	712	1738521	1977-01-25	1977-02-08	1	2595
50313	3428	1729720	1970-06-05	1970-06-15	1	165
8295	576	1125315	1982-06-22	1982-07-06	1	4569
50674	3446	1713332	1991-11-23	1991-12-14	1	8017
9472	653	1112807	1954-12-21	1955-01-04	1	-5476
54685	3719	1177480	1989-11-17	1989-12-22	1	7295
12624	867	1322184	2016-08-23	2016-08-23	1	17036
53084	3616	1759842	1960-12-16	1961-01-06	1	-3282
57980	3955	1759842	1969-02-09	1969-03-02	1	-305
8605	596	1125315	1953-09-18	1953-11-17	1	-5889
47897	3249	1125315	1959-06-12	1959-06-26	1	-3842
8682	601	1125315	1979-01-03	1979-01-24	1	3310
7163	492	1112807	1968-07-25	1968-08-08	1	-511
55219	3756	1729720	1948-05-27	1948-06-08	1	-7877
48013	3259	1112807	1966-12-23	1967-01-06	1	-1091
15790	1092	1177480	1993-07-11	1993-08-01	1	8613
62653	4278	1322184	1998-01-23	1998-01-23	1	10249
7524	520	1125315	1965-09-26	1965-10-17	1	-1537
57211	3901	1125315	1976-01-28	1976-03-03	1	2253
5084	348	1125315	1979-08-25	1979-09-08	1	3537
51575	3514	1549786	1991-07-31	1992-07-25	1	8241
66769	4559	1717327	1966-11-06	1966-12-11	1	-1117
51823	3530	1361711	1970-05-01	1970-05-01	1	120
12157	836	1125315	2010-09-04	2010-09-18	1	14870
14605	1004	1713332	1971-12-29	1972-01-05	1	734
53671	3651	1125315	1973-02-14	1973-05-15	1	1230
11755	807	738818	1973-11-17	1973-11-24	1	1423
47272	3211	1112807	1966-04-19	1966-07-18	1	-1263
9513	656	1102527	2011-03-31	2011-03-31	1	15064
17579	1214	1112807	1947-10-08	1947-11-05	1	-8093
9628	664	1343916	2010-07-27	2010-07-27	1	14817
12673	869	1125315	1997-04-04	1997-04-18	1	9969
55449	3772	1551099	1983-01-03	1983-01-03	1	4750
11931	820	1759842	2000-05-26	2000-06-09	1	11117
51949	3537	1713332	1989-11-23	1989-12-07	1	7280
6985	482	19127890	1994-08-23	1995-08-18	1	9360
76019	5201	1515774	1993-03-27	1994-03-22	1	8846
57717	3936	1759842	2010-09-27	2010-10-11	1	14893
16005	1107	1112807	1928-08-10	1928-08-24	1	-15105
46613	3167	1177480	1996-01-03	1996-01-24	1	9519
3577	239	1125315	1964-01-20	1964-02-03	1	-2159
56001	3814	1177480	1975-09-27	1975-12-26	1	2185
9835	675	1112807	1972-04-23	1972-05-14	1	864
56541	3852	1125315	2013-05-05	2013-05-19	1	15844
7512	518	1713332	1982-09-25	1982-10-09	1	4664
8796	607	1118084	1991-02-23	1991-02-23	1	7723
55730	3791	1125315	1966-03-15	1966-04-10	1	-1362
9597	662	1729720	1964-01-07	1964-01-20	1	-2173
60412	4119	1112807	1949-04-27	1949-06-01	1	-7519
8945	615	1125315	1965-05-01	1965-05-22	1	-1685
56215	3831	1713332	1987-10-25	1987-11-08	1	6520
7307	502	1307863	2011-04-02	2011-04-02	1	15066
45961	3119	1177480	1992-12-03	1992-12-17	1	8386
62089	4238	1124300	2005-11-03	2005-11-03	1	13090
13735	939	1125315	1997-11-26	1997-12-10	1	10205
10958	753	19127890	1985-09-04	1986-08-30	1	6085
38451	2615	1125315	2010-05-10	2010-05-24	1	14753
10396	712	1759842	1983-10-10	1983-10-31	1	5051
50314	3428	1759842	1966-10-28	1966-11-04	1	-1154
8296	576	1713332	1991-12-27	1992-01-03	1	8037
50675	3446	1713332	1997-11-19	1997-12-10	1	10205
9473	653	1112807	1971-09-14	1971-10-05	1	642
54686	3719	1713332	1964-02-09	1964-02-23	1	-2139
12625	867	1332418	2014-08-12	2014-08-12	1	16294
55661	3788	1125315	1987-04-22	1987-04-29	1	6327
57981	3955	1115008	1994-02-28	1994-05-29	1	8914
8606	596	1125315	1982-09-21	1982-10-05	1	4660
47898	3249	1125315	1973-06-16	1973-06-30	1	1276
8683	601	1125315	1980-09-15	1980-09-29	1	3924
7164	492	1728416	1950-12-17	1950-12-31	1	-6941
55220	3756	1729720	1948-09-07	1948-09-16	1	-7777
48014	3259	1124300	1999-10-11	1999-10-11	1	10875
15791	1092	1759842	1994-01-13	1994-01-27	1	8792
62654	4278	1539403	1992-01-10	1992-01-10	1	8044
7525	520	1177480	2001-12-15	2001-12-29	1	11685
57212	3901	1125315	2010-04-28	2010-05-05	1	14734
5085	348	1125315	1984-10-08	1985-01-06	1	5484
51576	3514	1549786	1993-07-20	1994-07-15	1	8961
66770	4559	1759842	1976-08-18	1976-08-25	1	2428
51824	3530	1713332	1982-05-01	1982-05-08	1	4510
12158	836	1177480	1985-03-30	1985-04-13	1	5581
14606	1004	1717327	1965-06-27	1965-07-11	1	-1635
53672	3651	1125315	1992-01-07	1992-01-21	1	8055
11756	807	1125315	1973-11-17	1973-11-24	1	1423
47273	3211	1521369	1974-10-30	1975-10-25	1	2123
9514	656	1115008	2004-10-05	2004-10-26	1	12717
17580	1214	1112807	1968-09-15	1968-10-06	1	-452
9629	664	1549786	1998-06-24	1999-06-19	1	10761
12674	869	1307863	1993-04-23	1993-04-23	1	8513
55627	3786	1124300	1995-04-19	1995-04-19	1	9239
11932	820	1759842	2017-09-21	2017-09-28	1	17437
51950	3537	1738521	1967-12-21	1968-01-04	1	-728
6986	482	933724	1991-11-16	1991-11-23	1	7996
76020	5201	1515774	1996-03-11	1997-03-06	1	9926
57718	3936	1112807	1959-01-16	1959-01-30	1	-3989
16006	1107	1112807	1980-08-19	1980-09-02	1	3897
46614	3167	1713332	2008-09-07	2008-09-21	1	14143
3578	239	1125315	1988-09-01	1988-09-08	1	6825
56002	3814	1503184	1996-10-16	1998-10-06	2	10505
9836	675	1118084	1984-04-03	1984-04-03	1	5206
56542	3852	1759842	1982-12-18	1983-01-01	1	4748
7513	518	1738521	1971-01-26	1971-02-09	1	404
8797	607	1125315	1989-05-25	1989-06-08	1	7098
55731	3791	1125315	2000-07-04	2000-07-11	1	11149
9598	662	1759842	1970-09-21	1970-10-12	1	284
60413	4119	1112807	1964-09-10	1964-09-24	1	-1925
8946	615	1125315	1995-01-29	1995-04-29	1	9249
56216	3831	1759842	1987-10-25	1987-11-08	1	6520
7906	550	1112807	1950-06-09	1950-06-30	1	-7125
45962	3119	1713332	1992-12-03	1992-12-17	1	8386
62090	4238	1343916	1978-12-28	1978-12-28	1	3283
13736	939	1125315	1966-06-04	1966-06-18	1	-1293
10959	753	738818	1999-11-30	1999-12-14	1	10939
38452	2615	1759842	2006-03-19	2006-04-02	1	13240
10397	712	914335	2011-04-14	2011-04-14	1	15078
50315	3428	1759842	2019-03-16	2019-04-06	1	17992
8297	576	1729720	1969-03-22	1969-04-03	1	-273
50676	3446	1759842	1991-11-23	1991-12-14	1	8017
9474	653	1174888	1965-12-23	1965-12-23	1	-1470
56137	3825	1125315	1956-05-31	1956-06-30	1	-4933
12626	867	701322	2013-06-26	2013-06-26	1	15882
55662	3788	1713332	2009-12-11	2010-01-01	1	14610
57982	3955	1118084	1995-03-16	1995-03-16	1	9205
8607	596	1728416	1950-10-18	1950-11-01	1	-7001
47899	3249	1177480	1998-08-22	1998-09-19	1	10488
8684	601	1177480	2008-12-13	2009-01-03	1	14247
7165	492	1728416	1952-08-13	1952-09-17	1	-6315
55221	3756	738818	1943-11-07	1943-11-21	1	-9538
48015	3259	738818	1969-12-08	1969-12-22	1	-10
15792	1092	1124957	1997-03-20	1997-03-20	1	9940
62655	4278	1759842	1957-11-16	1957-12-07	1	-4408
7526	520	1713332	1969-10-06	1969-10-27	1	-66
57213	3901	1177480	2002-02-15	2002-03-01	1	11747
5086	348	1125315	1990-01-10	1990-04-10	2	7404
51577	3514	1549786	1996-07-04	1997-06-29	1	10041
66771	4559	1759842	2009-05-18	2009-06-08	1	14403
51825	3530	1728416	1960-10-15	1960-10-29	1	-3351
12159	836	1521369	2001-07-14	2003-07-04	2	12237
14607	1004	1729720	1964-07-06	1964-07-16	1	-1995
53673	3651	1729720	1985-02-23	1985-03-06	1	5543
11757	807	1177480	1998-04-21	1998-05-12	1	10358
47274	3211	1759842	1963-01-30	1963-02-13	1	-2514
9515	656	1118084	2008-04-07	2008-04-07	1	13976
17581	1214	1125315	1944-02-07	1944-02-14	1	-9453
9630	664	1713332	1983-11-26	1983-12-10	1	5091
12675	869	1322184	2006-09-29	2006-09-29	1	13420
55628	3786	1125315	1981-04-12	1981-04-19	1	4126
12102	834	1112807	1956-08-08	1956-08-22	1	-4880
51951	3537	1125315	1978-08-14	1978-09-11	1	3175
6987	482	1118084	2008-09-28	2008-09-28	1	14150
76021	5201	1549786	1993-03-27	1994-03-22	1	8846
57719	3936	1112807	1960-02-28	1960-03-13	1	-3581
16007	1107	1119510	1956-12-20	1956-12-27	1	-4753
46615	3167	1729720	2011-09-29	2011-10-10	1	15257
3579	239	1322184	2012-01-12	2012-07-05	1	15526
56003	3814	1549786	1998-10-06	1999-10-01	1	10865
9837	675	1119510	1975-12-16	1975-12-30	1	2189
56543	3852	738818	1997-01-02	1997-01-16	1	9877
7514	518	1118084	2007-05-12	2007-05-12	1	13645
8798	607	1112807	1957-06-11	1957-09-09	1	-4497
55732	3791	1326303	2011-06-25	2011-06-25	1	15150
9599	662	1759842	1982-09-06	1982-09-13	1	4638
60414	4119	1347450	2001-09-29	2001-09-29	1	11594
8947	615	1174888	2003-02-21	2003-02-21	1	12104
56217	3831	1125315	1956-04-19	1956-05-10	1	-4984
7907	550	1177480	1977-07-29	1977-09-27	1	2826
46536	3161	1112807	1970-07-08	1970-07-29	1	209
62091	4238	1713332	2011-08-13	2011-09-03	1	15220
13737	939	1125315	1986-06-22	1986-07-06	1	6030
10960	753	1125315	2009-11-11	2009-11-18	1	14566
38453	2615	1125315	1979-12-29	1980-01-05	1	3656
10398	712	1125315	2003-08-07	2003-08-07	1	12271
50316	3428	757627	2017-05-31	2017-05-31	1	17317
8298	576	1759842	1991-12-27	1992-01-03	1	8037
50677	3446	1759842	1997-11-19	1997-12-10	1	10205
9475	653	1717327	1965-12-23	1966-01-13	1	-1449
56138	3825	1125315	1988-01-28	1988-02-18	1	6622
12627	867	1124957	1998-09-29	1998-09-29	1	10498
55663	3788	1112807	1967-08-26	1967-09-25	1	-829
57983	3955	1125315	1989-08-10	1989-08-24	1	7175
10443	718	914335	1974-10-19	1974-10-19	1	1752
47900	3249	1713332	1974-09-17	1974-10-08	1	1741
8685	601	1728416	1972-08-02	1972-08-16	1	958
7166	492	1759842	1956-03-14	1956-04-04	1	-5020
55222	3756	1125315	1943-11-07	1943-11-21	1	-9538
48016	3259	1125315	1969-12-08	1969-12-22	1	-10
15793	1092	1125315	1958-04-29	1958-05-13	1	-4251
62656	4278	1112807	1978-03-18	1978-04-08	1	3019
7527	520	1713332	1976-09-22	1976-09-29	1	2463
57214	3901	1713332	1955-01-22	1955-02-12	1	-5437
5087	348	1174888	1990-01-10	1990-01-10	1	7314
51578	3514	1118084	2014-03-02	2014-03-02	1	16131
66772	4559	738818	1981-11-25	1981-12-09	1	4360
51826	3530	1759842	1982-05-01	1982-05-08	1	4510
12160	836	1713332	1979-12-10	1979-12-24	1	3644
15592	1082	1118084	1989-09-30	1989-09-30	1	7212
55284	3759	975125	1983-08-18	1983-08-18	1	4977
11758	807	1112807	1964-09-04	1964-10-02	1	-1917
48871	3325	1717327	1964-05-12	1964-05-26	1	-2046
9516	656	1713332	2004-08-28	2004-09-04	1	12665
17582	1214	1125315	1969-10-01	1969-10-22	1	-71
9631	664	1713332	2011-11-18	2011-12-09	1	15317
12676	869	1728416	1947-05-01	1947-05-15	1	-8267
55629	3786	1177480	1978-02-27	1978-03-13	1	2993
12103	834	1125315	1963-05-04	1963-08-02	1	-2344
51952	3537	1713332	1987-03-24	1987-04-14	1	6312
6988	482	1125315	1983-06-03	1983-06-24	1	4922
76022	5201	1549786	1996-03-11	1997-03-06	1	9926
57720	3936	1729720	1968-11-23	1968-12-02	1	-395
16008	1107	1125315	2001-10-29	2001-11-12	1	11638
46616	3167	1112807	1960-09-03	1960-09-17	1	-3393
4568	316	738818	2007-11-23	2007-12-07	1	13854
56004	3814	19127890	1991-11-12	1993-11-01	2	8705
9838	675	1119510	1985-03-25	1985-04-08	1	5576
56544	3852	1125315	1964-12-28	1965-01-27	1	-1800
7515	518	1125315	2015-03-07	2015-03-21	1	16515
8799	607	1125315	2009-09-09	2009-09-16	1	14503
55733	3791	1112807	1939-05-20	1939-06-03	1	-11170
9600	662	1118084	2001-05-29	2001-05-29	1	11471
60415	4119	1728416	1947-02-24	1947-03-10	1	-8333
8948	615	1551099	1926-12-24	1926-12-24	1	-15714
56218	3831	738818	2013-03-18	2013-03-25	1	15789
7908	550	1759842	1946-04-10	1946-05-01	1	-8646
46537	3161	1728416	1953-03-14	1953-03-28	1	-6123
62092	4238	1759842	2011-08-13	2011-09-03	1	15220
13738	939	1125315	2001-06-05	2001-06-19	1	11492
10961	753	1503184	1985-09-04	1986-08-30	1	6085
38454	2615	1177480	1992-03-15	1992-06-13	1	8199
10399	712	1125315	2011-07-27	2011-08-03	1	15189
50317	3428	1125315	1976-12-20	1976-12-27	1	2552
8299	576	1713332	2015-12-17	2015-12-31	1	16800
50678	3446	715997	2018-03-30	2018-03-30	1	17620
11157	763	933724	2018-04-06	2018-04-13	1	17634
56139	3825	1322184	1998-01-02	1998-01-02	1	10228
12628	867	1125315	1986-05-07	1986-05-21	1	5984
55664	3788	1125315	1974-05-21	1974-06-25	1	1636
57984	3955	1713332	1957-04-08	1957-04-15	1	-4644
10444	718	738818	1983-10-26	1983-11-09	1	5060
47901	3249	1728416	1959-06-12	1959-06-26	1	-3842
8686	601	1112807	1972-08-02	1972-08-16	1	958
7167	492	1112807	1952-08-13	1952-09-17	1	-6315
55223	3756	1125315	1950-07-02	1950-08-01	1	-7093
48017	3259	1125315	1977-07-15	1977-07-29	1	2766
15794	1092	1125315	1972-07-19	1972-08-16	1	958
62657	4278	1124300	1993-07-26	1993-07-26	1	8607
7528	520	1729720	1971-07-08	1971-07-17	1	562
57215	3901	1713332	1992-08-17	1992-08-24	1	8271
5088	348	1125315	1994-12-16	1994-12-30	1	9129
51579	3514	1713332	2015-12-07	2015-12-14	1	16783
66773	4559	738818	2015-05-25	2015-06-01	1	16587
51827	3530	1112807	1960-10-15	1960-10-29	1	-3351
12161	836	19127890	1992-08-30	1993-08-25	1	8637
15593	1082	1119510	1961-09-04	1961-09-11	1	-3034
55285	3759	1119510	1966-03-03	1966-03-17	1	-1386
14197	971	920293	2005-06-21	2005-07-05	2	12969
48872	3325	1717327	1966-01-16	1966-01-30	1	-1432
9517	656	1759842	2004-08-28	2004-09-04	1	12665
17583	1214	1125315	1985-06-06	1985-06-20	1	5649
9632	664	1112807	1986-02-27	1986-03-13	1	5915
12677	869	1112807	1920-12-19	1921-01-02	1	-17896
55630	3786	1729720	2013-05-01	2013-05-12	1	15837
12104	834	1125315	1971-06-01	1971-07-06	1	551
51953	3537	1759842	1985-04-12	1985-04-26	1	5594
6989	482	1125315	1988-05-28	1988-07-02	1	6757
76023	5201	1595799	2000-02-19	2002-02-08	2	11726
57721	3936	1124300	1997-12-15	1997-12-15	1	10210
16009	1107	1322184	1997-03-14	2007-06-15	1	13679
46617	3167	1713332	1990-05-25	1990-08-31	1	7547
4569	316	1112807	1929-03-24	1929-04-28	1	-14858
56005	3814	1125315	1987-06-26	1987-08-25	1	6445
9839	675	1125315	1950-12-03	1950-12-31	1	-6941
56545	3852	1125315	1982-09-20	1982-10-04	1	4659
7516	518	1729720	1982-05-14	1982-05-22	1	4524
8800	607	1125315	2018-01-26	2018-02-09	1	17571
55734	3791	1124957	1982-10-13	1982-10-13	1	4668
9601	662	1177480	2018-02-05	2018-02-26	1	17588
60416	4119	1729720	2012-05-08	2012-05-19	1	15479
8949	615	1713332	2017-03-07	2017-03-14	1	17239
56219	3831	1119510	2013-03-18	2013-03-25	1	15789
7909	550	1759842	1969-07-30	1969-08-20	1	-134
46538	3161	1728416	1953-09-19	1953-10-03	1	-5934
62093	4238	1112807	1969-12-17	1970-01-21	1	20
13739	939	1118084	2005-03-26	2005-03-26	1	12868
10962	753	1717327	1970-12-07	1970-12-21	1	354
38455	2615	1713332	2010-02-16	2010-02-23	1	14663
10400	712	1125315	2018-12-25	2019-01-01	1	17897
50318	3428	1125315	2003-10-25	2003-11-08	1	12364
10634	730	1112807	1965-11-02	1965-12-02	1	-1491
50679	3446	1112807	1944-09-08	1944-09-22	1	-9232
11158	763	1112807	1987-06-21	1987-07-05	1	6394
56140	3825	1713332	1988-02-21	1988-03-06	1	6639
12629	867	1177480	2005-04-25	2005-07-24	1	12988
55665	3788	1125315	2005-07-12	2005-08-02	1	12997
57985	3955	1713332	1981-03-18	1981-04-01	1	4108
10445	718	738818	2016-01-27	2016-02-03	1	16834
47902	3249	1738521	1972-03-16	1972-03-30	1	819
8687	601	1125315	2017-03-10	2017-03-24	1	17249
7168	492	1177480	2014-08-07	2014-09-06	1	16319
55224	3756	1125315	1957-07-25	1957-08-15	1	-4522
48018	3259	1125315	1982-03-30	1982-04-20	1	4492
15795	1092	1125315	2000-11-29	2001-02-27	1	11380
62658	4278	1125315	1959-02-05	1959-02-26	1	-3962
7529	520	933724	1974-12-10	1974-12-24	1	1818
57216	3901	1112807	1958-08-25	1958-09-08	1	-4133
5089	348	1177480	1977-08-16	1977-08-30	1	2798
51580	3514	19127890	1991-07-31	1992-07-25	1	8241
66774	4559	920293	2001-12-31	2002-01-07	1	11694
51828	3530	1322184	1999-04-30	1999-04-30	1	10711
12162	836	19127890	1994-08-20	1995-08-15	1	9357
15594	1082	1119510	2005-12-20	2005-12-27	1	13144
55286	3759	1125315	1974-07-18	1974-09-16	1	1719
14198	971	1118084	1980-09-15	1980-09-15	1	3910
48873	3325	1729720	1974-05-02	1974-05-14	1	1594
9518	656	1115008	2011-03-31	2011-04-30	1	15094
17584	1214	1713332	1964-03-26	1964-04-09	1	-2093
9633	664	1125315	2005-04-09	2005-06-08	1	12942
12678	869	1112807	1947-02-06	1947-02-20	1	-8351
55631	3786	738818	1964-12-08	1964-12-15	1	-1843
12105	834	1125315	1989-11-09	1989-11-23	1	7266
51954	3537	738818	2008-06-03	2008-06-10	1	14040
6990	482	1125315	1991-05-09	1991-05-23	1	7812
76024	5201	920293	2015-05-12	2015-05-19	1	16574
57722	3936	1713332	2010-09-27	2010-10-11	1	14893
16010	1107	1713332	1955-02-23	1955-03-16	1	-5405
46618	3167	1759842	1990-05-25	1990-08-31	1	7547
4570	316	1112807	1932-05-12	1932-06-02	1	-13727
56006	3814	1500211	1993-11-01	1994-10-27	1	9065
9840	675	1728416	1949-10-09	1949-10-23	1	-7375
56546	3852	1125315	1997-01-02	1997-01-16	1	9877
7517	518	1759842	1982-09-25	1982-10-09	1	4664
8801	607	1728416	1960-03-27	1960-04-10	1	-3553
55735	3791	1310149	2011-06-25	2011-06-25	1	15150
9602	662	1539403	1995-03-21	1995-03-21	1	9210
60417	4119	1124300	1984-08-26	1984-08-26	1	5351
8950	615	1729720	1911-07-20	1911-07-31	1	-21339
56220	3831	1124957	1971-08-20	1971-08-20	1	596
7910	550	738818	1974-10-25	1974-11-08	1	1772
46539	3161	1759842	1958-07-08	1958-07-22	1	-4181
62094	4238	1119510	1973-12-05	1973-12-19	1	1448
13740	939	1119510	1989-11-02	1989-11-09	1	7252
10963	753	1759842	2019-01-21	2019-02-04	1	17931
38456	2615	1759842	1963-01-23	1963-02-06	1	-2521
10401	712	1713332	2010-03-17	2010-04-07	1	14706
50319	3428	1125315	2004-06-04	2004-06-04	1	12573
10635	730	1125315	1962-09-16	1962-09-30	1	-2650
50680	3446	1112807	1965-05-21	1965-06-20	1	-1656
11159	763	1125315	1966-07-11	1966-07-25	1	-1256
56141	3825	1112807	1965-10-11	1965-10-25	1	-1529
12630	867	1322184	2014-08-12	2016-07-05	1	16987
55666	3788	1729720	1975-11-25	1975-12-02	1	2161
57986	3955	1713332	1998-07-25	1998-08-01	1	10439
10446	718	1125315	1967-03-23	1967-04-13	1	-994
51002	3470	1119510	2008-12-20	2008-12-27	1	14240
8688	601	1125315	1985-06-05	1985-06-19	1	5648
7169	492	1713332	1956-03-14	1956-04-04	1	-5020
55225	3756	1125315	1964-07-28	1964-08-25	1	-1955
48019	3259	1119510	1969-12-08	1969-12-22	1	-10
15796	1092	1729720	1959-08-21	1959-08-29	1	-3778
62659	4278	1361711	1978-12-29	1978-12-29	1	3284
7530	520	1112807	1969-04-29	1969-05-20	1	-226
57217	3901	1115008	2012-11-03	2012-12-08	1	15682
5090	348	1713332	1984-10-29	1984-11-12	1	5429
51581	3514	19127890	1993-07-20	1994-07-15	1	8961
66775	4559	1112807	1956-12-04	1956-12-18	1	-4762
51829	3530	1729720	1980-10-05	1980-10-18	1	3943
13695	936	1118084	2002-05-06	2002-05-06	1	11813
15595	1082	1125315	1958-04-20	1958-05-04	1	-4260
55287	3759	1125315	1987-03-26	1987-04-16	1	6314
14199	971	1125315	1961-09-12	1961-09-26	1	-3019
48874	3325	1729720	1981-03-24	1981-04-03	1	4110
9519	656	1713332	1969-11-01	1969-11-08	1	-54
17585	1214	1729720	1967-09-19	1967-09-29	1	-825
9634	664	1153428	2010-07-27	2010-07-27	1	14817
12679	869	1112807	1947-05-01	1947-05-15	1	-8267
55632	3786	1125315	1964-12-08	1964-12-15	1	-1843
12106	834	1125315	2014-05-17	2014-05-24	1	16214
51955	3537	975125	1978-01-13	1978-02-03	1	2955
6991	482	1503184	1983-10-20	1984-10-14	1	5400
76025	5201	1119510	1982-01-26	1982-02-02	1	4415
57723	3936	1728416	1958-08-07	1958-08-21	1	-4151
16011	1107	1713332	1992-05-23	1992-06-06	1	8192
52543	3578	1112807	1991-01-10	1991-01-24	1	7693
4571	316	1119510	2007-11-23	2007-12-07	1	13854
56007	3814	1503184	1992-11-06	1993-11-01	1	8705
9841	675	920293	1986-03-21	1986-03-28	1	5930
56547	3852	1309944	2008-03-31	2008-03-31	1	13969
7518	518	1112807	1971-01-26	1971-02-09	1	404
8802	607	1729720	1984-10-20	1984-10-30	1	5416
55736	3791	1759842	1955-09-02	1955-09-23	1	-5214
9603	662	1713332	1982-09-06	1982-09-13	1	4638
60418	4119	1322184	2001-09-29	2001-09-29	1	11594
8951	615	1759842	2017-03-07	2017-03-14	1	17239
56221	3831	1125315	1962-07-13	1962-07-27	1	-2715
7911	550	738818	1975-12-14	1975-12-28	1	2187
46540	3161	1102527	1979-11-09	1979-11-09	1	3599
62095	4238	1174888	2013-06-25	2013-06-25	1	15881
13741	939	1125315	2014-09-13	2014-09-20	1	16333
10964	753	19127890	1981-09-20	1983-09-10	2	5000
42901	2904	920293	2012-06-06	2012-06-20	2	15511
10402	712	1729720	1989-04-05	1989-04-16	1	7045
50320	3428	1125315	2010-06-03	2010-06-24	1	14784
10636	730	1521369	1977-03-09	1979-02-27	2	3344
50681	3446	1125315	1968-09-23	1968-09-30	1	-458
11160	763	738818	1972-06-10	1972-06-17	1	898
56142	3825	1124300	1994-06-21	1994-06-21	1	8937
12631	867	1347450	2016-07-05	2016-07-05	1	16987
55667	3788	1729720	2004-03-06	2004-03-14	1	12491
60677	4139	920293	1996-12-02	1996-12-16	2	9846
10447	718	1125315	1983-10-26	1983-11-09	1	5060
51003	3470	1174888	1998-08-10	1998-08-10	1	10448
10091	693	738818	1975-10-16	1975-10-23	1	2121
8229	572	738818	2008-09-26	2008-10-10	1	14162
55226	3756	1729720	1949-09-14	1949-09-24	1	-7404
48020	3259	1125315	1966-08-25	1966-09-22	1	-1197
18073	1246	757627	2012-11-02	2012-11-02	1	15646
62660	4278	1729720	2000-12-24	2001-01-05	1	11327
7531	520	1118084	1988-05-18	1988-05-18	1	6712
57218	3901	1119510	1990-06-10	1990-06-17	1	7472
5091	348	1713332	1994-03-25	1994-04-15	1	8870
51869	3532	1112807	1973-09-13	1973-09-27	1	1365
66776	4559	1124300	1983-05-29	1983-05-29	1	4896
51830	3530	1125315	1978-11-12	1978-11-26	1	3251
13696	936	1125315	1988-03-03	1988-03-17	1	6650
15596	1082	1125315	1959-09-29	1959-10-13	1	-3733
55288	3759	1177480	2008-12-21	2009-01-25	1	14269
14200	971	1125315	2010-01-26	2010-02-02	1	14642
48875	3325	1112807	1966-01-16	1966-01-30	1	-1432
9520	656	1713332	1984-08-30	1984-09-06	1	5362
17586	1214	1729720	2018-04-05	2018-04-15	1	17636
9635	664	1177480	1986-10-17	1986-10-31	1	6147
12680	869	1112807	1952-06-23	1952-07-07	1	-6387
55633	3786	1177480	2007-06-28	2007-08-02	1	13727
12107	834	1713332	2012-03-16	2012-04-06	1	15436
51956	3537	1112807	1967-12-21	1968-01-04	1	-728
6992	482	1515774	1989-09-18	1991-09-08	2	7920
76026	5201	1521369	2000-02-19	2002-02-08	2	11726
57724	3936	1112807	1958-08-07	1958-08-21	1	-4151
16012	1107	1759842	1944-10-12	1944-11-02	1	-9191
52544	3578	1125315	1998-01-20	1998-02-03	1	10260
4572	316	1124957	1975-12-21	1975-12-21	1	2180
56008	3814	1515774	1991-11-12	1992-11-06	1	8345
9842	675	1112807	1951-04-19	1951-05-03	1	-6818
56548	3852	1343916	2008-03-31	2008-03-31	1	13969
7519	518	1112807	1973-01-27	1973-02-10	1	1136
8803	607	1759842	1969-08-16	1969-08-23	1	-131
57863	3946	1112807	1964-01-01	1964-01-15	1	-2178
9604	662	1728416	1961-02-17	1961-03-03	1	-3226
60419	4119	1729720	1949-10-12	1949-10-23	1	-7375
8952	615	738818	1920-07-16	1920-07-30	1	-18052
56222	3831	1125315	2001-12-07	2001-12-14	1	11670
7912	550	1125315	1962-07-27	1962-08-17	1	-2694
46541	3161	1112807	1951-06-15	1951-06-29	1	-6761
62096	4238	1177480	2013-06-18	2013-07-25	1	15911
16694	1149	1115008	2004-12-21	2005-01-04	1	12787
10965	753	1112807	1968-08-19	1968-09-02	1	-486
42902	2904	1112807	1973-07-24	1973-08-07	1	1314
10403	712	1729720	1990-07-13	1990-07-26	1	7511
50321	3428	1713332	1966-10-28	1966-11-04	1	-1154
10637	730	1729720	1973-12-18	1973-12-28	1	1457
50682	3446	1125315	1970-10-21	1970-11-04	1	307
11161	763	738818	1990-05-17	1990-05-24	1	7448
56143	3825	1125315	1958-08-15	1958-08-29	1	-4143
12632	867	1125315	1981-09-14	1981-09-28	1	4288
55668	3788	1112807	1968-07-21	1968-08-04	1	-515
60678	4139	1115008	1994-11-30	1995-02-28	1	9189
10448	718	1177480	1992-09-05	1992-09-26	1	8304
51004	3470	1759842	1975-11-05	1976-02-11	1	2232
10092	693	1112807	1951-11-28	1951-12-12	1	-6595
8230	572	1115008	2001-02-13	2001-03-20	1	11401
55227	3756	1112807	1960-11-25	1960-12-16	1	-3303
48021	3259	1125315	1974-08-11	1974-09-08	1	1711
18074	1246	1112807	1947-07-03	1947-09-01	1	-8158
62661	4278	701322	2019-03-26	2019-03-26	1	17981
7532	520	1125315	1958-03-04	1958-03-11	1	-4314
57219	3901	1125315	1942-11-14	1942-11-21	1	-9903
5092	348	1729720	1986-03-16	1986-03-27	1	5929
51870	3532	1125315	1986-12-15	1987-03-15	2	6192
66777	4559	1125315	1950-09-21	1950-10-05	1	-7028
51831	3530	1539403	1993-07-16	1993-07-16	1	8597
13697	936	1125315	2008-10-28	2008-11-25	1	14208
15597	1082	1125315	1962-10-24	1962-11-07	1	-2612
55289	3759	1503184	1981-07-21	1982-07-16	1	4579
14201	971	1728416	1946-01-02	1946-01-16	1	-8751
48876	3325	1119510	1963-09-16	1963-09-23	1	-2292
9521	656	1759842	1966-10-22	1966-11-12	1	-1146
20423	1389	1125315	1956-10-27	1956-11-10	1	-4800
9636	664	1515774	1995-07-06	1996-06-30	1	9677
12681	869	1112807	1979-03-09	1979-03-23	1	3368
55634	3786	1112807	1962-11-18	1962-12-02	1	-2587
12108	834	1759842	2012-03-16	2012-04-06	1	15436
51957	3537	1125315	1989-11-23	1989-12-07	1	7280
6993	482	1515774	1994-08-23	1995-08-18	1	9360
76027	5201	1768849	1980-04-04	1980-04-18	1	3760
58341	3980	1713332	1980-02-28	1980-03-13	1	3724
16013	1107	1759842	1992-05-23	1992-06-06	1	8192
52545	3578	1729720	1976-08-28	1976-09-07	1	2441
4573	316	1125315	1932-12-04	1932-12-18	1	-13528
56009	3814	1549786	1991-11-12	1992-11-06	1	8345
9843	675	1125315	1950-08-06	1950-08-20	1	-7074
56549	3852	914335	2008-03-31	2008-03-31	1	13969
7520	518	1728416	1974-04-01	1974-04-15	1	1565
10052	691	738818	1993-08-17	1993-08-31	1	8643
57864	3946	1125315	1999-01-04	1999-01-11	1	10602
9605	662	1112807	1961-02-17	1961-03-03	1	-3226
60420	4119	1759842	1946-08-19	1946-09-09	1	-8515
8953	615	1125315	1920-07-16	1920-07-30	1	-18052
56223	3831	1125315	2013-03-18	2013-03-25	1	15789
7913	550	1125315	1966-08-23	1966-09-06	1	-1213
46542	3161	1112807	1967-05-11	1967-05-25	1	-952
62097	4238	1717327	1963-04-23	1963-05-07	1	-2431
16695	1149	1125315	1981-09-30	1981-10-14	1	4304
10966	753	1125315	1978-10-14	1978-10-21	1	3215
42903	2904	1125315	2005-06-17	2005-06-24	1	12958
10404	712	1759842	2010-03-17	2010-04-07	1	14706
50934	3464	1149196	2009-05-29	2009-05-29	1	14393
10638	730	738818	2013-08-10	2013-08-24	1	15941
50683	3446	1125315	1982-10-20	1982-11-10	1	4696
11162	763	738818	1990-12-21	1991-01-04	1	7673
56144	3825	1347450	1998-01-02	1998-01-02	1	10228
12633	867	1125315	1984-02-02	1984-02-16	1	5159
55669	3788	1125315	1968-12-19	1968-12-26	1	-371
60679	4139	1115008	2006-06-30	2006-08-29	1	13389
10449	718	1713332	1991-04-20	1991-05-11	1	7800
51005	3470	1112807	1971-10-28	1971-11-11	1	679
10093	693	1125315	1965-05-20	1965-05-27	1	-1680
8231	572	1118084	1992-04-01	1992-04-01	1	8126
55228	3756	1119510	1943-11-07	1943-11-21	1	-9538
48022	3259	1125315	1967-12-02	1967-12-16	1	-747
18075	1246	1118084	1980-08-23	1980-08-23	1	3887
62662	4278	715997	2019-03-26	2019-03-26	1	17981
7533	520	1125315	1975-06-30	1975-07-07	1	2013
57220	3901	1125315	1959-08-04	1959-08-25	2	-3782
5093	348	1759842	1984-10-29	1984-11-12	1	5429
51871	3532	1738521	1972-09-29	1972-10-13	1	1016
66778	4559	1125315	1950-11-18	1950-12-02	1	-6970
51832	3530	1713332	1994-04-12	1994-05-03	1	8888
13698	936	1728416	1965-11-01	1965-11-15	1	-1508
15598	1082	1503184	1976-07-10	1977-07-05	1	2742
55290	3759	19127890	1979-08-01	1980-07-26	1	3859
14202	971	1728416	1946-06-18	1946-07-02	1	-8584
48877	3325	1713332	1975-08-17	1975-09-07	1	2075
9522	656	1125315	2011-05-28	2011-06-04	1	15129
20424	1389	1125315	2007-08-29	2007-09-19	1	13775
9637	664	1595799	1998-06-24	1999-06-19	1	10761
12682	869	1125315	1992-04-11	1992-04-18	1	8143
55635	3786	1125315	1982-07-13	1982-07-27	1	4590
12109	834	1125315	1957-06-12	1957-06-26	1	-4572
51958	3537	1125315	1998-10-09	1998-10-23	1	10522
6994	482	1549786	1994-08-23	1995-08-18	1	9360
76028	5201	933724	2015-05-12	2015-05-19	1	16574
58342	3980	1515774	1992-10-02	1994-09-22	2	9030
16014	1107	1115008	2000-02-20	2000-03-05	1	11021
52546	3578	1112807	1973-11-25	1973-12-09	1	1438
4574	316	1125315	1987-03-23	1987-04-13	1	6311
56010	3814	1729720	1987-12-08	1987-12-17	1	6559
9844	675	1125315	1968-04-19	1968-04-26	1	-615
56550	3852	1125315	1965-11-25	1965-12-09	1	-1484
9059	624	738818	1969-10-17	1969-10-24	1	-69
10053	691	1112807	1961-06-21	1961-07-05	1	-3102
57865	3946	1713332	1973-04-22	1973-04-29	1	1214
9606	662	1112807	1963-05-21	1963-06-04	1	-2403
60421	4119	933724	1967-08-11	1967-08-18	1	-867
8954	615	1125315	1933-06-28	1933-07-05	1	-13329
56224	3831	1118084	1991-04-11	1991-04-11	1	7770
7914	550	1125315	1974-10-25	1974-11-08	1	1772
46543	3161	1125315	1953-03-14	1953-03-28	1	-6123
62098	4238	1759842	1993-09-23	1993-10-14	1	8687
16696	1149	1125315	1986-11-19	1986-12-26	1	6203
10967	753	1521369	1981-09-20	1983-09-10	2	5000
42904	2904	933724	2012-06-06	2012-06-20	1	15511
10405	712	738818	2018-12-25	2019-01-01	1	17897
50935	3464	1343916	2009-05-29	2009-05-29	1	14393
10639	730	1112807	1960-05-02	1960-07-31	1	-3441
50684	3446	1125315	1995-11-02	1995-11-16	1	9450
11163	763	920293	2018-04-06	2018-04-13	1	17634
56145	3825	1125315	1992-06-06	1992-06-13	1	8199
12634	867	1125315	2002-06-10	2002-09-08	1	11938
55670	3788	1717327	1968-07-21	1968-08-04	1	-515
60680	4139	1125315	1971-07-04	1971-07-18	1	563
10450	718	1115008	2007-06-10	2007-07-08	1	13702
51006	3470	1115008	1998-08-03	1998-10-09	1	10508
10094	693	1125315	1975-10-16	1975-10-23	1	2121
8232	572	1125315	1959-03-02	1959-03-16	1	-3944
55229	3756	1124300	1976-06-25	1976-06-25	1	2367
48023	3259	1125315	1980-01-03	1980-01-17	1	3668
18076	1246	1124957	1969-09-26	1969-09-26	1	-97
62663	4278	757627	2017-12-01	2017-12-01	1	17501
7534	520	1557272	2011-01-06	2011-01-06	1	14980
57221	3901	1174888	1959-08-04	1959-08-04	1	-3803
6263	432	1124300	1973-01-07	1973-01-07	1	1102
51872	3532	1118084	2007-06-23	2007-06-23	1	13687
66779	4559	1125315	1981-11-25	1981-12-09	1	4360
51833	3530	1729720	1972-09-24	1972-10-02	1	1005
13699	936	1759842	1992-12-07	1992-12-21	1	8390
15599	1082	1728416	1958-04-20	1958-05-04	1	-4260
55291	3759	1119510	1977-11-14	1977-11-28	1	2888
14203	971	1729720	1966-08-18	1966-08-28	1	-1222
48878	3325	1713332	1985-07-23	1985-08-06	1	5696
9523	656	1125315	2012-05-24	2012-06-07	1	15498
20425	1389	1729720	2012-03-28	2012-04-04	1	15434
9638	664	1778162	1986-02-27	1986-03-13	1	5915
12683	869	1322184	2012-04-20	2012-04-20	1	15450
55636	3786	1125315	2002-07-25	2002-08-08	1	11907
12110	834	1125315	1965-09-20	1965-10-25	1	-1529
51959	3537	1125315	2008-06-03	2008-06-10	1	14040
6995	482	1713332	1979-04-10	1979-04-24	1	3400
76029	5201	1118084	2015-02-10	2015-02-10	1	16476
58343	3980	920293	1992-11-19	1992-11-26	1	8365
16015	1107	1125315	1930-04-03	1930-04-10	1	-14511
52547	3578	1118084	2016-11-09	2016-11-09	1	17114
4575	316	1125315	2007-10-25	2007-12-07	2	13854
56011	3814	19127890	1996-10-16	1999-10-01	3	10865
9845	675	1125315	2001-01-17	2001-01-24	1	11346
56551	3852	1177480	1995-01-20	1995-02-03	1	9164
9060	624	1112807	1947-01-23	1947-04-23	1	-8289
10054	691	1125315	1993-08-17	1993-08-31	1	8643
57866	3946	1125315	1970-04-01	1970-04-15	1	104
9607	662	1125315	1976-01-01	1976-01-15	1	2205
60422	4119	1112807	1947-02-24	1947-03-10	1	-8333
8955	615	1125315	1991-05-06	1991-05-20	1	7809
56225	3831	1125315	1971-08-20	1971-08-20	1	596
7915	550	1713332	1946-04-10	1946-05-01	1	-8646
46544	3161	1177480	1979-11-09	1980-01-08	1	3659
62099	4238	1112807	1963-04-23	1963-05-07	1	-2431
16697	1149	1125315	2011-11-29	2011-12-27	1	15335
10968	753	1713332	2019-01-21	2019-02-04	1	17931
42905	2904	1112807	1973-03-05	1973-03-19	1	1173
10406	712	1115008	2003-08-07	2003-10-06	1	12331
50936	3464	1521369	1998-04-20	2000-04-09	2	11056
10640	730	1119510	2013-08-10	2013-08-24	1	15941
50685	3446	1177480	1981-01-07	1981-01-28	1	4045
11164	763	1125315	1972-06-10	1972-06-17	1	898
56146	3825	1177480	1988-12-14	1988-12-28	1	6936
12635	867	1713332	1933-03-14	1933-04-04	1	-13421
55671	3788	1729720	1965-02-10	1965-02-21	1	-1775
60681	4139	1177480	2010-08-22	2010-10-21	1	14903
10451	718	1119510	1983-10-26	1983-11-09	1	5060
51007	3470	1115008	2013-01-23	2013-02-06	1	15742
10095	693	1759842	1980-03-19	1980-04-02	1	3744
8233	572	1125315	1961-10-12	1961-10-26	1	-2989
55230	3756	1125315	1958-09-09	1958-10-07	1	-4104
48024	3259	1768849	1980-01-03	1980-01-17	1	3668
18077	1246	1125315	1971-09-30	1971-10-07	1	644
62664	4278	1115008	2010-09-01	2010-09-15	1	14867
7535	520	1713332	1983-12-02	1983-12-09	1	5090
57222	3901	1728416	1959-08-04	1959-08-25	1	-3782
6264	432	1557272	2001-04-09	2001-04-09	1	11421
51873	3532	1125315	1994-06-06	1994-06-27	1	8943
66780	4559	1125315	2015-05-25	2015-06-01	1	16587
51834	3530	1759842	1994-04-12	1994-05-03	1	8888
13700	936	1112807	1965-11-01	1965-11-15	1	-1508
15600	1082	1729720	1966-02-25	1966-03-10	1	-1393
55292	3759	1124300	2009-03-16	2009-03-16	1	14319
14204	971	1759842	1970-11-28	1970-12-12	1	345
48879	3325	738818	1963-09-16	1963-09-23	1	-2292
9524	656	1713332	1966-10-22	1966-11-12	1	-1146
20426	1389	1102527	2007-08-29	2007-08-29	1	13754
12044	829	738818	1977-01-28	1977-02-04	1	2591
12684	869	1326303	1993-04-23	1993-04-23	1	8513
55637	3786	1125315	2017-10-08	2017-11-12	1	17482
12111	834	1125315	1983-01-04	1983-01-25	1	4772
51960	3537	1177480	1974-12-05	1975-01-02	1	1827
6996	482	920293	1991-11-16	1991-11-23	1	7996
76030	5201	1125315	1980-04-04	1980-04-18	1	3760
58344	3980	933724	1992-11-19	1992-11-26	1	8365
16016	1107	1125315	1956-12-20	1956-12-27	1	-4753
52548	3578	1713332	1983-12-09	1983-12-16	1	5097
4576	316	1125315	2010-01-19	2010-01-26	1	14635
57112	3893	1118084	2011-04-28	2011-04-28	1	15092
9846	675	1154343	1952-02-23	1952-02-23	1	-6522
56552	3852	1713332	1982-12-18	1983-01-01	1	4748
9061	624	1125315	1966-07-22	1966-08-05	1	-1245
10055	691	1759842	1985-11-18	1985-11-25	1	5807
57867	3946	1177480	2007-07-12	2007-08-02	1	13727
9608	662	1125315	2012-06-06	2012-06-06	1	15497
60423	4119	1125315	2001-10-22	2001-10-29	1	11624
8956	615	1125315	2003-02-21	2003-02-21	1	12104
56872	3876	738818	2016-12-10	2016-12-17	1	17152
7916	550	1713332	1969-07-30	1969-08-20	1	-134
46545	3161	1759842	2016-11-13	2016-11-27	1	17132
62100	4238	1115008	1998-10-21	1998-11-04	1	10534
16698	1149	1177480	1980-02-24	1980-03-09	1	3720
10969	753	1729720	1976-02-26	1976-03-08	1	2258
42906	2904	1759842	1987-02-18	1987-03-11	1	6278
10407	712	1124300	2013-07-15	2013-07-15	1	15901
50937	3464	1759842	2014-12-16	2014-12-23	1	16427
10641	730	1125315	2013-08-10	2013-08-24	1	15941
50686	3446	1729720	1991-10-18	1991-10-27	1	7969
11165	763	1125315	1990-05-17	1990-05-24	1	7448
56147	3825	1759842	1988-02-21	1988-03-06	1	6639
12636	867	1759842	1933-03-14	1933-04-04	1	-13421
55672	3788	1729720	1997-11-24	1997-12-07	1	10202
60682	4139	1515774	1991-09-27	1994-09-11	3	9019
10452	718	1119510	2016-01-27	2016-02-03	1	16834
51008	3470	1125315	1969-04-12	1969-04-19	1	-257
10096	693	1759842	2018-05-29	2018-06-05	1	17687
8234	572	1125315	1976-11-21	1977-01-20	1	2576
55231	3756	1125315	1968-12-13	1968-12-27	1	-370
48232	3277	1112807	1965-08-23	1965-09-06	1	-1578
18078	1246	1713332	1957-09-26	1957-10-03	1	-4473
62665	4278	1332418	1994-01-14	1994-01-14	1	8779
7536	520	1759842	1969-10-06	1969-10-27	1	-66
57223	3901	1729720	1939-12-29	1940-01-06	1	-10953
6265	432	1112807	1934-12-08	1934-12-22	1	-12794
51874	3532	1713332	1999-08-04	1999-08-18	1	10821
66781	4559	1713332	1976-08-18	1976-08-25	1	2428
51835	3530	914335	2003-01-03	2003-01-03	1	12055
13701	936	1125315	1991-08-19	1991-08-26	1	7907
15601	1082	1115008	2018-07-20	2018-08-10	1	17753
55293	3759	1129625	1983-08-31	1983-08-31	1	4990
14205	971	933724	2005-06-21	2005-07-05	1	12969
48880	3325	1112807	1965-05-07	1965-06-11	1	-1665
9525	656	1759842	1969-11-01	1969-11-08	1	-54
20427	1389	1125315	1962-04-27	1962-06-26	1	-2746
12045	829	1119510	2016-01-13	2016-01-20	1	16820
12685	869	1729720	1961-01-02	1961-01-09	1	-3279
55638	3786	1177480	1991-10-01	1991-10-15	1	7957
12112	834	1728416	1956-08-08	1956-08-22	1	-4880
51961	3537	1551099	1962-06-20	1962-06-20	1	-2752
6997	482	1125315	1980-09-25	1980-10-16	1	3941
76031	5201	1177480	1979-06-29	1979-07-13	1	3480
58345	3980	1112807	1980-02-28	1980-03-13	1	3724
16017	1107	1125315	2007-06-15	2007-06-15	1	13679
52549	3578	1713332	1991-01-10	1991-01-24	1	7693
4577	316	1125315	2012-02-01	2012-05-01	1	15461
57113	3893	1115008	1999-11-15	1999-11-29	1	10924
9847	675	1729720	1956-12-03	1956-12-14	1	-4766
56553	3852	975125	1970-10-12	1970-10-12	1	284
9062	624	1125315	1969-10-17	1969-10-24	1	-69
10056	691	1759842	2004-04-24	2004-05-15	1	12553
57868	3946	1713332	1988-09-28	1988-10-12	1	6859
9609	662	1332418	1995-03-21	1995-03-21	1	9210
60424	4119	920293	1967-08-11	1967-08-18	1	-867
8957	615	1713332	1917-07-19	1917-07-26	1	-19152
56873	3876	1125315	1975-05-10	1975-05-24	1	1969
7917	550	1713332	1999-02-22	1999-03-01	1	10651
46546	3161	1112807	1963-08-23	1963-09-13	1	-2302
62101	4238	1125315	2013-06-25	2013-06-25	1	15881
16699	1149	1118084	2013-08-09	2013-08-09	1	15926
10970	753	1759842	1978-10-13	1978-10-27	1	3221
44453	3010	1115008	1996-08-13	1996-09-10	1	9749
10408	712	1125315	1977-01-25	1977-02-08	1	2595
50938	3464	1177480	1997-04-15	1997-05-15	1	9996
10642	730	1503184	1977-03-09	1979-02-27	2	3344
50687	3446	701322	2018-03-30	2018-03-30	1	17620
11166	763	1125315	1990-12-21	1991-01-04	1	7673
56148	3825	920293	1988-07-18	1988-08-01	2	6787
12637	867	1112807	1931-02-18	1931-03-11	1	-14176
55673	3788	1759842	2009-12-11	2010-01-01	1	14610
60683	4139	1521369	1987-10-18	1989-10-07	2	7219
10453	718	1309944	1974-10-19	1974-10-19	1	1752
51009	3470	1713332	1975-11-05	1976-02-11	1	2232
10097	693	738818	2018-01-11	2018-01-25	1	17556
8235	572	1125315	2008-09-26	2008-10-10	1	14162
55232	3756	1125315	1974-01-01	1974-01-08	1	1468
48233	3277	1115008	2017-06-24	2017-09-22	1	17431
18079	1246	1713332	2011-03-12	2011-03-26	1	15059
62795	4288	1125315	1998-12-01	1998-12-15	1	10575
7537	520	1759842	1976-09-22	1976-09-29	1	2463
57224	3901	1759842	1954-06-29	1954-07-20	1	-5644
6266	432	1125315	1989-12-24	1990-01-07	1	7311
51875	3532	1717327	1973-09-13	1973-09-27	1	1365
66782	4559	1713332	2011-10-14	2011-10-28	1	15275
51836	3530	1112807	1968-12-02	1968-12-23	1	-374
13702	936	1125315	1992-03-12	1992-03-19	1	8113
15602	1082	1125315	1961-09-04	1961-09-11	1	-3034
55294	3759	1503184	1979-08-01	1980-07-26	1	3859
14206	971	1125315	1965-08-20	1965-09-17	1	-1567
48881	3325	1125315	1963-09-16	1963-09-23	1	-2292
10793	742	738818	1926-06-10	1926-06-24	1	-15897
20428	1389	1396131	1962-03-03	1962-03-03	1	-2861
12046	829	1125315	1977-01-28	1977-02-04	1	2591
12686	869	1729720	1970-06-25	1970-07-02	1	182
55639	3786	1717327	1962-11-18	1962-12-02	1	-2587
12113	834	1759842	1980-02-03	1980-02-17	1	3699
54437	3703	1112807	1971-10-30	1971-11-13	1	681
6998	482	1549786	1989-09-18	1991-09-08	2	7920
76032	5201	1549786	2000-02-19	2002-02-08	2	11726
58346	3980	1713332	1997-02-02	1997-02-23	1	9915
16018	1107	1332418	1994-02-25	1994-02-25	1	8821
52550	3578	1759842	1983-12-09	1983-12-16	1	5097
4578	316	1332418	1994-11-08	1994-11-08	1	9077
57114	3893	1119510	1994-07-07	1994-07-21	1	8967
11311	774	1759842	1971-05-06	1971-05-20	1	504
56554	3852	1118084	1990-03-17	1990-03-17	1	7380
9063	624	1125315	2019-05-16	2019-05-27	2	18039
10057	691	1778162	1992-09-09	1992-09-23	1	8301
57869	3946	1713332	1992-06-28	1992-07-12	1	8228
9610	662	1717327	1971-04-27	1971-05-25	1	509
60425	4119	1112807	1946-02-12	1946-02-26	1	-8710
8958	615	1713332	2009-10-20	2009-11-10	1	14558
56874	3876	1125315	2016-12-10	2016-12-17	1	17152
7918	550	1729720	1927-03-16	1927-03-25	1	-15623
46547	3161	1124300	1989-10-23	1989-10-23	1	7235
62102	4238	1713332	2007-07-09	2007-07-30	1	13724
16700	1149	1177480	2007-10-21	2008-01-19	1	13897
10971	753	738818	1973-02-25	1973-03-04	1	1158
44454	3010	1124957	1980-10-06	1980-10-06	1	3931
10409	712	1713332	1983-10-10	1983-10-31	1	5051
50939	3464	1738521	1981-04-09	1981-04-23	1	4130
10643	730	1115008	2000-04-02	2000-05-07	1	11084
50688	3446	723013	1957-12-09	1958-08-11	1	-4161
11167	763	1177480	1981-08-21	1981-11-19	1	4340
56149	3825	933724	1988-07-18	1988-08-01	1	6787
12638	867	1115008	1998-09-29	1998-11-28	1	10558
55674	3788	705944	1975-08-09	1982-08-17	1	4611
60684	4139	1102527	2010-08-22	2010-08-22	1	14843
10454	718	1343916	1974-10-19	1974-10-19	1	1752
51010	3470	1119510	1980-10-18	1980-11-01	1	3957
10098	693	1112807	1959-05-25	1959-06-08	1	-3860
8236	572	1728416	1954-01-21	1954-02-04	1	-5810
55233	3756	1112807	1941-02-19	1941-03-05	1	-10529
48234	3277	1125315	1971-07-24	1971-08-07	1	583
18080	1246	1125315	1943-11-22	1943-11-29	1	-9530
62796	4288	1125315	2000-08-08	2000-08-15	1	11184
7538	520	1768849	1983-02-19	1983-03-05	1	4811
57225	3901	738818	1990-06-10	1990-06-17	1	7472
6267	432	1310149	2014-06-23	2014-06-23	1	16244
51876	3532	1125315	1995-10-31	1995-11-14	1	9448
66783	4559	1717327	1965-01-27	1965-02-10	1	-1786
51837	3530	1112807	1981-06-18	1981-07-23	1	4221
13703	936	1125315	2010-09-23	2010-09-30	1	14882
15603	1082	1177480	2011-02-18	2011-03-04	1	15037
55295	3759	19127890	1981-07-21	1982-07-16	1	4579
14207	971	1112807	1946-01-02	1946-01-16	1	-8751
48882	3325	1759842	1985-07-23	1985-08-06	1	5696
10794	742	1125315	1926-06-10	1926-06-24	1	-15897
20429	1389	1729720	1967-06-01	1967-06-10	1	-936
12047	829	1515774	1991-05-28	1992-05-22	1	8177
12687	869	738818	1998-08-10	1998-08-17	1	10455
55640	3786	920293	1988-01-17	1988-01-24	1	6597
12114	834	1759842	2018-02-09	2018-02-23	1	17585
54438	3703	1112807	1973-08-04	1973-09-08	1	1346
6999	482	19127890	1983-10-20	1984-10-14	1	5400
76033	5201	19127890	1993-03-27	1994-03-22	1	8846
58347	3980	1759842	1997-02-02	1997-02-23	1	9915
16019	1107	1361711	1964-01-24	2007-06-15	1	13679
52551	3578	1125315	1992-03-18	1992-05-17	1	8172
4579	316	1361711	1976-07-06	1976-07-06	1	2378
57115	3893	1729720	1979-10-07	1979-10-14	1	3573
11312	774	933724	2003-09-01	2003-09-08	1	12303
56555	3852	1119510	1997-01-02	1997-01-16	1	9877
9064	624	1713332	2009-08-06	2009-08-13	1	14469
10058	691	1125315	1997-04-25	1997-05-09	1	9990
57870	3946	1759842	1973-04-22	1973-04-29	1	1214
9611	662	1738521	1977-09-13	1977-09-27	1	2826
60426	4119	1125315	1981-04-28	1981-05-12	1	4149
8959	615	1759842	2015-08-16	2015-09-06	1	16684
56875	3876	1125315	2017-12-23	2018-01-22	1	17553
7919	550	1759842	1999-02-22	1999-03-01	1	10651
46548	3161	1125315	1957-09-11	1957-10-09	1	-4467
62103	4238	1759842	2007-07-09	2007-07-30	1	13724
16701	1149	1713332	1981-09-30	1981-10-14	1	4304
10972	753	1112807	1970-12-07	1970-12-21	1	354
44455	3010	1125315	1980-10-06	1980-12-05	2	3991
10410	712	1759842	1978-09-21	1978-09-28	1	3192
50940	3464	920293	2005-06-04	2005-06-11	1	12945
10644	730	1124300	2002-11-18	2002-11-18	1	12009
50689	3446	757627	2016-12-05	2016-12-05	1	17140
11168	763	1521369	1981-03-04	1982-02-27	1	4440
56150	3825	1125315	1955-07-06	1955-07-20	1	-5279
12639	867	1124300	1966-01-05	1966-01-05	1	-1457
55675	3788	1124300	2006-12-14	2006-12-14	1	13496
60685	4139	1115008	2007-09-23	2007-10-07	1	13793
10455	718	1759842	1991-04-20	1991-05-11	1	7800
51011	3470	1125315	1998-08-10	1998-08-10	1	10448
10099	693	1112807	1968-09-16	1968-11-15	1	-412
8237	572	1115008	2003-11-05	2003-11-26	1	12382
55234	3756	1112807	1944-09-09	1944-09-23	1	-9231
48235	3277	1717327	1965-08-23	1965-09-06	1	-1578
18081	1246	1125315	1947-11-06	1947-11-20	1	-8078
62797	4288	1713332	1952-12-10	1952-12-24	1	-6217
7539	520	1112807	1983-02-19	1983-03-05	1	4811
57226	3901	1118084	1976-06-26	1976-06-26	1	2368
6268	432	1326303	2014-06-23	2014-06-23	1	16244
51877	3532	1174888	1986-12-15	1986-12-15	1	6192
66784	4559	1728416	1950-11-18	1950-12-02	1	-6970
51838	3530	1124300	1995-04-30	1995-04-30	1	9250
13704	936	1112807	1971-10-01	1971-10-29	1	666
15604	1082	1521369	1976-07-10	1977-07-05	1	2742
55296	3759	1521369	1979-08-01	1980-07-26	1	3859
14208	971	1112807	1946-06-18	1946-07-02	1	-8584
48883	3325	1112807	1964-05-12	1964-05-26	1	-2046
10795	742	1125315	1952-10-20	1952-11-10	1	-6261
20430	1389	1112807	1965-03-12	1965-06-10	1	-1666
12048	829	1729720	1984-04-26	1984-05-06	1	5239
12688	869	1112807	1914-09-16	1914-09-30	1	-20182
55641	3786	933724	1988-01-17	1988-01-24	1	6597
12115	834	1112807	1967-09-15	1967-10-20	1	-804
54439	3703	1119510	2013-08-09	2013-08-16	1	15933
7000	482	1112807	1971-11-12	1972-02-10	1	770
76034	5201	19127890	1995-03-17	1997-03-06	2	9926
58348	3980	19127890	1990-10-13	1991-10-08	1	7950
16020	1107	1713332	1944-10-12	1944-11-02	1	-9191
52552	3578	1125315	2008-05-03	2008-05-17	1	14016
4580	316	1713332	1934-03-22	1934-04-26	1	-13034
57116	3893	1759842	1998-09-18	1998-10-02	1	10501
11313	774	1102527	2006-11-05	2006-11-05	1	13457
56556	3852	1125315	1953-08-28	1953-09-11	1	-5956
9065	624	1759842	2009-08-06	2009-08-13	1	14469
10059	691	1125315	2019-06-20	2019-06-20	1	18067
57871	3946	1759842	1988-09-28	1988-10-12	1	6859
10726	736	738818	1982-10-06	1982-10-20	1	4675
60427	4119	1125315	2018-04-10	2018-04-17	1	17638
9426	651	933724	2014-07-29	2014-08-05	1	16287
56876	3876	1717327	1975-05-10	1975-05-24	1	1969
7920	550	1118084	1956-07-02	1956-07-02	1	-4931
46549	3161	1125315	1978-05-26	1978-06-09	1	3081
62104	4238	738818	1973-12-05	1973-12-19	1	1448
16702	1149	1713332	2011-11-29	2011-12-27	1	15335
10973	753	1115008	1997-08-31	1997-09-14	1	10118
44456	3010	1713332	1989-03-30	1989-04-13	1	7042
10411	712	1115008	2018-04-20	2018-05-04	1	17655
50941	3464	975125	2009-05-20	2009-05-20	1	14384
10645	730	1125315	1962-02-07	1962-02-21	1	-2871
50690	3446	1112807	1950-08-08	1950-09-07	1	-7056
11169	763	1729720	1991-12-12	1991-12-21	1	8024
56151	3825	1125315	1958-02-21	1958-02-28	1	-4325
12640	867	1125315	1963-08-31	1963-09-07	1	-2308
56802	3871	1119510	2010-12-15	2010-12-22	1	14965
60686	4139	1503184	1987-10-18	1989-10-07	2	7219
10456	718	1112807	1970-03-28	1970-05-04	1	123
51012	3470	1125315	2009-03-29	2009-04-05	1	14339
10100	693	1124300	1995-08-14	1995-08-14	1	9356
8238	572	1119510	2008-09-26	2008-10-10	1	14162
55235	3756	1112807	1953-06-16	1953-08-15	1	-5983
48236	3277	1759842	2015-12-28	2016-01-11	1	16811
18082	1246	1125315	1955-01-22	1955-03-23	1	-5398
62798	4288	1728416	1953-06-29	1953-07-13	1	-6016
7540	520	1125315	1983-06-21	1983-06-28	1	4926
57227	3901	1125315	1990-06-10	1990-06-17	1	7472
6269	432	1729720	1994-02-20	1994-03-04	1	8828
51878	3532	1177480	2017-01-27	2017-02-17	1	17214
66785	4559	1728416	1956-12-04	1956-12-18	1	-4762
51839	3530	1125315	2001-12-05	2001-12-26	1	11682
13705	936	1713332	1992-12-07	1992-12-21	1	8390
15605	1082	1759842	1986-04-17	1986-04-24	1	5957
55297	3759	1717327	1964-11-07	1964-11-21	1	-1867
14209	971	1125315	1979-07-02	1979-07-09	1	3476
48884	3325	1118084	2004-12-23	2004-12-23	1	12775
10796	742	1310149	2008-07-21	2008-07-21	1	14081
20431	1389	1125315	2008-09-10	2008-09-24	1	14146
12049	829	738818	2016-01-13	2016-01-20	1	16820
12689	869	1119510	1998-08-10	1998-08-17	1	10455
55642	3786	1115008	1998-06-10	1998-07-15	1	10422
12116	834	1115008	2012-11-18	2012-12-02	1	15676
54440	3703	1177480	1982-01-24	1982-03-25	1	4466
7001	482	1112807	1974-08-28	1974-09-11	1	1714
77668	5309	920293	1977-02-25	1977-03-04	1	2619
58349	3980	1118084	2015-02-04	2015-02-04	1	16470
16021	1107	1759842	1955-02-23	1955-03-16	1	-5405
52553	3578	1177480	1980-04-22	1980-05-20	1	3792
4581	316	1759842	1934-03-22	1934-04-26	1	-13034
57117	3893	1125315	1988-09-17	1988-09-24	1	6841
11314	774	1124300	2008-04-30	2008-04-30	1	13999
56557	3852	1713332	2005-04-19	2005-05-10	1	12913
9066	624	1125315	1973-04-23	1973-05-07	1	1222
10060	691	1102527	2019-06-20	2019-06-20	1	18067
57872	3946	1759842	1992-06-28	1992-07-12	1	8228
10727	736	1125315	1982-10-06	1982-10-20	1	4675
60428	4119	1713332	1946-08-19	1946-09-09	1	-8515
9427	651	1112807	1987-08-11	1987-09-10	1	6461
56877	3876	1125315	1974-04-17	1974-04-24	1	1574
7921	550	1119510	1974-10-25	1974-11-08	1	1772
46550	3161	1125315	1990-04-26	1990-05-10	1	7434
62105	4238	920293	1992-12-23	1993-01-06	2	8406
16703	1149	1713332	1992-12-20	1992-12-27	1	8396
10974	753	1124300	2005-08-05	2005-08-05	1	13000
44457	3010	1112807	1973-07-24	1973-08-14	1	1321
10412	712	1124957	2003-08-07	2003-08-07	1	12271
50942	3464	1124300	2017-04-25	2017-04-25	1	17281
10646	730	1125315	1966-04-17	1966-04-24	1	-1348
50691	3446	1119510	2015-10-04	2015-10-18	1	16726
11170	763	1759842	1982-06-23	1982-07-14	1	4577
56152	3825	1125315	2009-03-13	2009-03-27	1	14330
12641	867	1125315	1998-09-29	1998-09-29	1	10498
56803	3871	1124300	1999-10-18	1999-10-18	1	10882
60687	4139	19127890	1991-09-27	1994-09-11	3	9019
10457	718	1124300	2005-09-29	2005-09-29	1	13055
51013	3470	1729720	1962-06-19	1962-06-28	1	-2744
10101	693	1125315	1955-01-11	1955-02-15	1	-5434
8239	572	1125315	1956-01-22	1956-02-05	1	-5079
55236	3756	1125315	1970-04-07	1970-04-21	1	110
48237	3277	738818	1971-07-24	1971-08-07	1	583
18083	1246	1125315	1974-09-14	1974-11-13	1	1777
62799	4288	1729720	1960-08-22	1960-08-31	1	-3410
7541	520	1125315	1993-09-23	1993-10-07	1	8680
57228	3901	1759842	1955-01-22	1955-02-12	1	-5437
6270	432	1729720	1939-03-21	1939-03-31	1	-11234
51879	3532	1713332	2002-08-10	2002-08-31	1	11930
66786	4559	738818	1990-03-09	1990-03-23	1	7386
52965	3610	1125315	1992-07-14	1992-07-28	1	8244
13706	936	1125315	2013-11-15	2013-11-22	1	16031
15606	1082	738818	1961-09-04	1961-09-11	1	-3034
55298	3759	738818	1966-03-03	1966-03-17	1	-1386
14210	971	1177480	1994-03-03	1994-03-24	1	8848
48885	3325	1729720	1964-06-12	1964-06-22	1	-2019
10797	742	1729720	1933-07-29	1933-08-10	1	-13293
20432	1389	1112807	1955-07-03	1955-07-17	1	-5282
12050	829	1118084	2010-03-30	2010-03-30	1	14698
12690	869	1125315	1947-07-19	1947-07-26	1	-8195
55643	3786	1119510	1964-12-08	1964-12-15	1	-1843
12117	834	1124300	1996-08-18	1996-08-18	1	9726
54441	3703	1729720	2014-07-22	2014-07-31	1	16282
7002	482	1125315	1985-07-03	1985-07-10	1	5669
77669	5309	933724	1977-02-25	1977-03-04	1	2619
58350	3980	1177480	1977-07-13	1977-08-03	1	2771
16022	1107	738818	1956-12-20	1956-12-27	1	-4753
52554	3578	1738521	1973-11-25	1973-12-09	1	1438
4582	316	1759842	1952-12-01	1952-12-22	1	-6219
57118	3893	1125315	1996-10-17	1996-10-31	1	9800
11315	774	1125315	1991-04-16	1991-04-23	1	7782
56558	3852	1728416	1953-08-28	1953-09-11	1	-5956
9067	624	1713332	1992-11-06	1992-11-13	1	8352
10061	691	1112807	1966-11-22	1966-12-13	1	-1115
57873	3946	1118084	2003-02-25	2003-02-25	1	12108
10728	736	1713332	2003-04-29	2003-05-20	1	12192
60429	4119	1728416	1946-02-12	1946-02-26	1	-8710
9428	651	19127890	1992-04-26	1993-04-21	1	8511
56878	3876	1129625	1971-06-11	1971-06-11	1	526
7922	550	1119510	1975-12-14	1975-12-28	1	2187
46551	3161	1125315	2018-03-22	2018-03-29	1	17619
62106	4238	920293	1998-02-05	1998-02-19	2	10276
16704	1149	1759842	1992-12-20	1992-12-27	1	8396
10975	753	1125315	1973-02-25	1973-03-04	1	1158
44458	3010	1124300	2003-12-26	2003-12-26	1	12412
10413	712	1713332	1978-09-21	1978-09-28	1	3192
50943	3464	1125315	2004-01-09	2004-04-08	1	12516
10647	730	1557272	2017-09-16	2017-09-16	1	17425
50692	3446	1124300	1989-02-19	1989-02-19	1	6989
11171	763	1759842	1994-08-09	1994-08-16	1	8993
56153	3825	1713332	1996-01-10	1996-01-24	1	9519
12642	867	1125315	2018-01-17	2018-03-12	2	17597
56804	3871	1125315	2010-12-15	2010-12-22	1	14965
60688	4139	933724	1996-12-02	1996-12-16	1	9846
10458	718	1125315	2000-04-22	2000-05-06	1	11083
51014	3470	738818	1980-10-18	1980-11-01	1	3957
10102	693	1125315	2018-01-11	2018-01-25	1	17556
8240	572	1728416	1959-03-02	1959-03-16	1	-3944
55237	3756	1125315	1988-07-20	1988-08-10	1	6796
48238	3277	1112807	1967-11-11	1967-12-02	1	-761
18084	1246	1125315	1985-11-30	1985-12-14	1	5826
62800	4288	1125315	1953-06-29	1953-07-13	1	-6016
7542	520	1177480	1997-02-25	1997-03-11	1	9931
57229	3901	740275	1936-03-18	1936-11-18	1	-12097
6271	432	1125315	1939-01-17	1939-01-24	1	-11300
51880	3532	1729720	1976-09-10	1976-09-23	1	2457
66787	4559	920293	2005-02-05	2005-02-12	1	12826
52966	3610	1102527	2017-06-26	2017-06-26	1	17343
14898	1032	1112807	1986-09-01	1986-09-15	1	6101
15607	1082	1112807	1955-12-18	1956-01-01	1	-5114
55299	3759	738818	1977-11-14	1977-11-28	1	2888
14211	971	1713332	1970-11-28	1970-12-12	1	345
48886	3325	1729720	2007-10-29	2007-11-08	1	13825
10798	742	757627	2012-12-17	2012-12-17	1	15691
20433	1389	1118084	1997-07-12	1997-07-12	1	10054
12051	829	1125315	1980-03-12	1980-04-16	1	3758
12691	869	1310149	1993-04-23	1993-04-23	1	8513
55644	3786	1729720	1961-10-27	1961-11-06	1	-2978
12118	834	1125315	1977-09-18	1977-09-25	1	2824
54442	3703	1738521	1969-01-22	1969-02-05	1	-330
7003	482	1125315	2013-12-18	2014-01-01	1	16071
77670	5309	1112807	1953-04-18	1953-05-02	1	-6088
58351	3980	1177480	1986-04-18	1986-05-18	1	5981
16023	1107	1112807	1929-01-07	1929-01-21	1	-14955
52555	3578	1125315	2009-02-17	2009-03-03	1	14306
4583	316	1112807	1927-10-01	1927-10-15	1	-15419
57119	3893	738818	1994-07-07	1994-07-21	1	8967
11316	774	1125315	2017-05-15	2017-05-29	1	17315
56559	3852	1729720	1993-04-17	1993-04-30	1	8520
9068	624	1713332	2012-06-15	2012-07-06	1	15527
10062	691	1119510	1993-08-17	1993-08-31	1	8643
57874	3946	1125315	1972-06-01	1972-06-15	1	896
10729	736	1759842	2003-04-29	2003-05-20	1	12192
63594	4347	19127890	1980-04-06	1982-03-27	2	4468
9429	651	920293	2014-07-29	2014-08-05	1	16287
56879	3876	1118084	2004-07-26	2004-07-26	1	12625
7923	550	1125315	1963-09-30	1963-10-07	1	-2278
46552	3161	1713332	1995-01-27	1995-02-10	1	9171
62107	4238	933724	1992-12-23	1993-01-06	1	8406
16705	1149	1102527	2011-11-29	2011-11-29	1	15307
10976	753	1125315	2007-01-17	2007-01-24	1	13537
44459	3010	1125315	1989-05-22	1989-07-21	1	7141
11594	795	738818	1978-02-20	1978-02-27	1	2979
50944	3464	1177480	1981-04-09	1981-04-23	1	4130
10648	730	1728416	1958-10-05	1958-10-19	1	-4092
50693	3446	1125315	1958-07-29	1958-08-05	1	-4167
11172	763	1118084	2002-11-29	2002-11-29	1	12020
56154	3825	1729720	1988-11-25	1988-12-04	1	6912
12643	867	1361711	2014-08-12	2014-08-12	1	16294
56805	3871	738818	2010-12-15	2010-12-22	1	14965
60689	4139	1125315	2017-05-04	2017-05-11	1	17297
10459	718	1125315	2016-01-27	2016-02-03	1	16834
51015	3470	738818	2008-12-20	2008-12-27	1	14240
10103	693	1112807	1966-09-13	1966-09-27	1	-1192
8241	572	1729720	1961-11-29	1961-12-06	1	-2948
55238	3756	1125315	2001-08-02	2001-10-01	1	11596
48239	3277	1124300	2004-09-12	2004-09-12	1	12673
18085	1246	1125315	2005-04-12	2005-04-19	1	12892
62801	4288	1125315	1954-03-10	1954-03-24	1	-5762
7543	520	1759842	1983-12-02	1983-12-09	1	5090
57230	3901	1125315	1993-11-03	1993-11-17	1	8721
6272	432	1125315	1979-06-15	1979-07-20	1	3487
51881	3532	1729720	1981-10-13	1981-10-25	1	4315
66788	4559	933724	2001-12-31	2002-01-07	1	11694
52967	3610	1115008	2017-04-18	2017-04-18	1	17274
14899	1032	1115008	1994-02-08	1994-03-01	1	8825
15608	1082	738818	2005-12-20	2005-12-27	1	13144
55300	3759	920293	1987-09-10	1987-09-17	1	6468
14212	971	1177480	1985-12-01	1985-12-15	1	5827
48887	3325	1759842	1975-08-17	1975-09-07	1	2075
10799	742	1112807	1930-09-16	1930-09-30	1	-14338
20434	1389	1125315	1972-08-15	1972-08-22	1	964
12052	829	1125315	2016-01-13	2016-01-20	1	16820
12692	869	1713332	1979-03-09	1979-03-23	1	3368
56702	3865	1125315	1957-04-24	1957-05-24	1	-4605
12119	834	1728416	1957-06-12	1957-06-26	1	-4572
54443	3703	1759842	1973-08-05	1973-08-12	1	1319
7004	482	1717327	1974-08-28	1974-09-11	1	1714
77671	5309	1112807	1967-10-28	1968-01-26	1	-706
58352	3980	1515774	1990-10-13	1991-10-08	1	7950
16024	1107	1174888	2007-06-15	2007-06-15	1	13679
52556	3578	1729720	1992-06-28	1992-07-06	1	8222
4584	316	1124300	1962-09-12	1962-09-12	1	-2668
57120	3893	1125315	1978-11-07	1978-11-21	1	3246
11317	774	1713332	1971-05-06	1971-05-20	1	504
56560	3852	1759842	2005-04-19	2005-05-10	1	12913
9069	624	1112807	1964-07-22	1964-08-19	1	-1961
10063	691	1125315	1958-12-06	1958-12-20	1	-4030
57875	3946	1729720	1989-07-22	1989-08-04	1	7155
10730	736	1125315	1976-08-14	1976-08-28	1	2431
63595	4347	1124300	2002-10-18	2002-10-18	1	11978
9430	651	933724	2011-06-10	2011-06-17	1	15142
56880	3876	1119510	2016-12-10	2016-12-17	1	17152
7924	550	715997	1997-09-11	1997-09-11	1	10115
46553	3161	1728416	1951-06-15	1951-06-29	1	-6761
62108	4238	1125315	1962-04-29	1962-05-06	1	-2797
16706	1149	1125315	1987-08-18	1987-08-25	1	6445
10977	753	1521369	1985-09-04	1986-08-30	1	6085
44460	3010	1125315	2000-01-07	2000-01-14	1	10970
11595	795	933724	1973-09-12	1973-09-19	1	1357
50945	3464	1549786	1998-04-20	2000-04-09	2	11056
10649	730	1728416	1959-09-17	1959-10-01	1	-3745
50694	3446	1125315	1975-02-28	1975-04-04	1	1919
11173	763	1119510	1972-06-10	1972-06-17	1	898
56155	3825	1759842	1996-01-10	1996-01-24	1	9519
12644	867	1539403	2014-08-12	2014-08-12	1	16294
56806	3871	1112807	1968-06-12	1968-09-10	1	-478
60690	4139	1115008	2016-01-23	2016-02-27	1	16858
17758	1227	757627	2016-04-06	2016-04-06	1	16897
51016	3470	1112807	1988-09-12	1988-10-03	1	6850
10104	693	1125315	1984-05-25	1984-06-24	1	5288
8242	572	1112807	1954-01-21	1954-02-04	1	-5810
55239	3756	1149380	2004-05-01	2004-05-01	1	12539
48240	3277	1125315	1990-03-06	1990-03-13	1	7376
18086	1246	1551099	1939-02-16	1939-02-16	1	-11277
62802	4288	1728416	1954-03-10	1954-03-24	1	-5762
7544	520	1112807	1951-11-04	1951-11-18	1	-6619
57231	3901	1125315	2017-07-16	2017-07-23	1	17370
6273	432	1307863	2014-06-23	2014-06-23	1	16244
51882	3532	1759842	2002-08-10	2002-08-31	1	11930
66789	4559	1112807	1966-11-06	1966-12-11	1	-1117
52968	3610	1125315	2001-01-01	2001-01-08	1	11330
14900	1032	1713332	1975-08-19	1975-08-26	1	2063
15609	1082	975125	1988-08-22	1988-08-22	1	6808
55301	3759	933724	1987-09-10	1987-09-17	1	6468
15159	1053	723013	1984-09-21	1984-12-07	1	5454
51459	3508	1112807	1958-09-03	1958-09-17	1	-4124
10800	742	1118084	1968-02-19	1968-02-19	1	-682
20435	1389	1728416	1955-07-03	1955-07-17	1	-5282
12053	829	1515774	1989-06-07	1990-06-02	1	7457
13201	905	740275	1976-03-06	1976-08-14	1	2417
56703	3865	1125315	2009-08-06	2009-08-13	1	14469
12120	834	1713332	1980-02-03	1980-02-17	1	3699
54444	3703	1112807	1969-12-18	1970-01-08	1	7
8360	580	738818	1980-12-01	1980-12-15	1	4001
77672	5309	1119510	1954-04-14	1954-04-21	1	-5734
58353	3980	1549786	1990-10-13	1991-10-08	1	7950
16025	1107	1177480	2004-12-09	2005-03-09	1	12851
53239	3626	1125315	1988-08-06	1988-08-27	1	6813
4585	316	1125315	1956-11-04	1956-11-18	1	-4792
57121	3893	1125315	1994-07-07	1994-07-21	1	8967
11318	774	1713332	2006-03-23	2006-03-30	1	13237
58090	3962	920293	1997-06-21	1997-06-28	1	10040
9070	624	1118084	1978-04-30	1978-04-30	1	3041
10064	691	1713332	1985-11-18	1985-11-25	1	5807
59830	4080	1112807	1970-10-03	1970-10-24	1	296
10731	736	1713332	1979-03-05	1979-03-19	1	3364
63596	4347	1503184	1980-04-06	1982-03-27	2	4468
9431	651	1125315	2013-11-22	2013-12-06	1	16045
56881	3876	1729720	1977-05-03	1977-05-12	1	2688
7925	550	836654	1996-10-16	1996-10-16	1	9785
46554	3161	1759842	1995-01-27	1995-02-10	1	9171
62109	4238	1125315	1973-12-05	1973-12-19	1	1448
16707	1149	1768849	1980-02-24	1980-03-09	1	3720
10978	753	1713332	2006-09-23	2006-09-30	1	13421
44461	3010	1713332	1982-03-10	1982-03-31	1	4472
11596	795	1119510	1987-07-23	1987-07-30	1	6419
50946	3464	933724	2005-06-04	2005-06-11	1	12945
10650	730	1728416	1962-02-07	1962-02-21	1	-2871
50695	3446	1177480	2006-09-03	2006-09-24	1	13415
11174	763	1119510	1990-05-17	1990-05-24	1	7448
56832	3874	738818	2012-06-15	2012-06-29	1	15520
13291	911	1125315	1986-01-16	1986-01-30	1	5873
56807	3871	1125315	1968-01-14	1968-01-28	1	-704
60691	4139	1118084	2011-09-17	2011-09-17	1	15234
17759	1227	1124300	1980-05-31	1980-05-31	1	3803
51017	3470	1118084	1999-02-08	1999-02-08	1	10630
10105	693	1174888	1999-09-11	1999-09-11	1	10845
8243	572	1713332	2007-04-06	2007-04-13	1	13616
55240	3756	1347450	2006-02-04	2006-02-04	1	13183
48241	3277	1125315	1998-11-19	1998-12-10	1	10570
18087	1246	1759842	1957-09-26	1957-10-03	1	-4473
62803	4288	1729720	1973-02-21	1973-03-06	1	1160
7545	520	1112807	1953-12-07	1953-12-28	1	-5848
57232	3901	1713332	1954-06-29	1954-07-20	1	-5644
6558	454	701322	2014-02-11	2014-02-11	1	16112
51883	3532	1125315	1972-09-29	1972-10-13	1	1016
66790	4559	1125315	1966-11-06	1966-11-06	1	-1152
52969	3610	1713332	2017-06-26	2017-07-10	1	17357
14901	1032	1125315	1980-10-13	1980-10-20	1	3945
15610	1082	1112807	1956-08-25	1956-09-08	1	-4863
55302	3759	1112807	1964-11-07	1964-11-21	1	-1867
15160	1053	1125315	1979-10-22	1979-10-29	1	3588
51460	3508	1125315	2013-03-10	2013-03-17	1	15781
10801	742	1125315	1972-08-22	1972-08-29	1	971
20436	1389	1778162	2007-08-29	2007-09-19	1	13775
12054	829	1549786	1989-06-07	1990-06-02	1	7457
13202	905	1125315	1979-02-26	1979-03-12	1	3357
56704	3865	1759842	1982-02-01	1982-02-08	1	4421
12121	834	1713332	2018-02-09	2018-02-23	1	17585
54445	3703	1125315	1970-11-21	1970-12-05	1	338
8361	580	1112807	1930-03-05	1930-03-19	1	-14533
77673	5309	1125315	1957-05-04	1957-05-18	1	-4611
58354	3980	1549786	1992-10-02	1994-09-22	2	9030
16026	1107	1545958	2007-06-15	2007-06-15	1	13679
53240	3626	19127890	1990-03-09	1992-02-27	2	8092
4586	316	1713332	1928-02-07	1928-02-14	1	-15297
57122	3893	1713332	1998-09-18	1998-10-02	1	10501
11319	774	1759842	2006-03-23	2006-03-30	1	13237
58091	3962	1115008	1999-09-08	1999-10-13	1	10877
9071	624	1125315	1957-01-30	1957-03-31	1	-4659
10065	691	1713332	2004-04-24	2004-05-15	1	12553
59831	4080	1125315	1971-11-18	1972-01-17	1	746
10732	736	1759842	1983-12-02	1983-12-23	1	5104
63597	4347	1713332	1998-01-09	1998-01-23	1	10249
9432	651	1309944	1999-01-28	1999-01-28	1	10619
56882	3876	1177480	1977-07-28	1977-08-25	1	2793
7926	550	920293	1957-12-09	1957-12-16	1	-4399
46555	3161	1112807	1953-09-19	1953-10-03	1	-5934
62110	4238	1309944	1978-12-28	1978-12-28	1	3283
16944	1169	914335	2012-02-20	2012-02-20	1	15390
10979	753	1729720	1973-04-27	1973-05-08	1	1223
44462	3010	1713332	1996-08-10	1996-08-17	1	9725
11597	795	1119510	1988-06-08	1988-06-15	1	6740
50947	3464	1595799	1998-04-20	2000-04-09	2	11056
10651	730	920293	1978-05-20	1978-05-27	1	3068
50696	3446	1713332	1947-07-30	1947-08-06	1	-8184
11175	763	1119510	1990-12-21	1991-01-04	1	7673
56833	3874	1125315	2012-06-15	2012-06-29	1	15520
13292	911	1713332	1984-11-13	1984-11-27	1	5444
56808	3871	1768849	2003-09-24	2003-10-08	1	12333
60692	4139	1549786	1991-09-27	1994-09-11	3	9019
17760	1227	1124957	1950-04-03	1950-04-03	1	-7213
51018	3470	1125315	1980-10-18	1980-11-01	1	3957
10106	693	1177480	1999-09-04	1999-10-11	1	10875
8244	572	1728416	1956-01-22	1956-02-05	1	-5079
55241	3756	1713332	1985-10-01	1985-10-15	1	5766
48242	3277	1713332	2015-12-28	2016-01-11	1	16811
18088	1246	1112807	1969-09-26	1969-11-25	1	-37
62804	4288	1759842	1952-12-10	1952-12-24	1	-6217
7546	520	1112807	1978-01-17	1978-02-14	1	2966
57233	3901	1759842	1992-08-17	1992-08-24	1	8271
6559	454	1112807	1936-01-08	1936-01-22	1	-12398
51884	3532	1125315	1977-07-05	1977-10-03	1	2832
66791	4559	1125315	1990-03-09	1990-03-23	1	7386
52970	3610	920293	1966-06-08	1966-06-22	2	-1289
14902	1032	1713332	1980-08-04	1980-08-11	1	3875
15611	1082	1112807	1962-11-11	1962-12-11	1	-2578
55303	3759	1125315	1966-03-03	1966-03-17	1	-1386
15161	1053	1125315	2004-09-23	2004-10-07	1	12698
51461	3508	1102527	2019-05-02	2019-05-02	1	18018
10802	742	1125315	1991-11-12	1992-01-11	1	8045
20682	1409	1112807	1946-05-23	1946-07-22	1	-8564
12055	829	1549786	1991-05-28	1992-05-22	1	8177
13203	905	1521369	1988-08-17	1989-08-12	1	7163
56705	3865	1118084	1990-04-06	1990-04-06	1	7400
16573	1144	738818	2013-10-16	2013-10-30	1	16008
54446	3703	1112807	1969-01-22	1969-02-05	1	-330
8362	580	1112807	1946-02-07	1946-02-28	1	-8708
77674	5309	1125315	1974-08-23	1974-09-06	1	1709
58355	3980	1729720	2016-08-27	2016-09-07	1	17051
16027	1107	1759842	1952-10-20	1952-10-27	1	-6275
53241	3626	1503184	1990-03-09	1992-02-27	2	8092
4587	316	1713332	1952-12-01	1952-12-22	1	-6219
57123	3893	1728416	1978-11-07	1978-11-21	1	3246
11320	774	1768849	1983-03-27	1983-04-10	1	4847
58092	3962	1125315	1963-10-13	1963-10-20	1	-2265
9072	624	1102527	2011-07-17	2011-07-17	1	15172
10066	691	1729720	1959-05-07	1959-05-14	1	-3885
59832	4080	1503184	1986-04-22	1987-04-17	1	6315
10733	736	1118084	2009-10-13	2009-10-13	1	14530
63598	4347	1759842	1998-01-09	1998-01-23	1	10249
9433	651	1713332	1995-02-28	1995-03-07	1	9196
59300	4040	1125315	1982-11-04	1982-11-18	1	4704
7927	550	933724	1957-12-09	1957-12-16	1	-4399
46556	3161	1112807	1960-06-25	1960-07-09	1	-3463
62111	4238	1713332	1993-09-23	1993-10-14	1	8687
16945	1169	920293	1989-11-04	1989-11-18	2	7261
10980	753	1759842	2006-09-23	2006-09-30	1	13421
44463	3010	1729720	1964-12-12	1964-12-22	1	-1836
11598	795	1125315	1978-02-20	1978-02-27	1	2979
50948	3464	1713332	2014-12-16	2014-12-23	1	16427
10652	730	933724	1978-05-20	1978-05-27	1	3068
50697	3446	1713332	1998-05-17	1998-06-07	1	10384
11176	763	1125315	2000-11-17	2000-12-01	1	11292
56834	3874	1521369	1998-12-04	1999-11-29	1	10924
13293	911	1738521	1976-04-06	1976-04-20	1	2301
56809	3871	705944	1969-09-10	1980-09-17	1	3912
60693	4139	19127890	1987-10-18	1989-10-07	2	7219
17761	1227	1125315	1949-12-22	1950-01-05	1	-7301
51019	3470	1125315	1991-10-18	1991-11-08	1	7981
10107	693	1713332	1980-03-19	1980-04-02	1	3744
8245	572	1729720	1954-05-24	1954-06-05	1	-5689
55242	3756	1759842	1985-10-01	1985-10-15	1	5766
48243	3277	1729720	1974-06-20	1974-06-29	1	1640
18089	1246	1125315	1945-05-23	1945-06-06	1	-8975
62805	4288	1118084	1994-09-17	1994-09-17	1	9025
7547	520	1125315	1980-12-30	1981-01-20	1	4037
59403	4049	1115008	1991-03-28	1991-03-28	1	7756
6560	454	1112807	1943-03-20	1943-04-03	1	-9770
51885	3532	1729720	1978-12-14	1978-12-24	1	3279
66792	4559	1557272	2015-07-28	2015-07-28	1	16644
52971	3610	933724	1966-06-08	1966-06-22	1	-1289
14903	1032	1759842	1975-08-19	1975-08-26	1	2063
15612	1082	1125315	1989-12-16	1989-12-30	1	7303
55304	3759	1125315	1977-11-14	1977-11-28	1	2888
15162	1053	1177480	2017-03-23	2017-04-13	1	17269
51462	3508	1112807	1966-08-08	1966-10-07	1	-1182
10803	742	1729720	1926-11-18	1926-11-29	1	-15739
20683	1409	1125315	1931-10-14	1931-10-28	1	-13945
12056	829	19127890	1991-05-28	1992-05-22	1	8177
13204	905	1713332	1998-12-30	1999-01-13	1	10604
56706	3865	1119510	1985-12-10	1985-12-24	1	5836
16574	1144	1119510	1992-10-15	1992-10-29	1	8337
54447	3703	1124300	2010-07-01	2010-07-01	1	14791
8363	580	1118084	1962-07-16	1962-07-16	1	-2726
77675	5309	1125315	1989-04-07	1989-04-21	1	7050
58356	3980	19127890	1992-10-02	1994-09-22	2	9030
17587	1215	1347450	1993-05-08	1993-05-08	1	8528
53242	3626	1549786	1993-02-21	1994-02-16	1	8812
4588	316	1115008	2014-02-20	2014-03-06	1	16135
60472	4123	1112807	1963-08-14	1963-08-28	1	-2318
11321	774	920293	2003-09-01	2003-09-08	1	12303
58093	3962	1125315	1969-02-22	1969-03-08	1	-299
9073	624	1112807	1965-07-15	1965-08-12	1	-1603
10067	691	1729720	1999-05-24	1999-06-01	1	10743
59833	4080	1713332	1981-02-14	1981-03-07	1	4083
10734	736	1119510	2002-08-21	2002-09-04	1	11934
63599	4347	1125315	2001-05-07	2001-05-21	1	11463
9434	651	914335	1999-01-28	1999-01-28	1	10619
59301	4040	1759842	2015-03-12	2015-03-26	1	16520
7928	550	1112807	1920-12-13	1921-03-13	1	-17826
46557	3161	1713332	1958-07-08	1958-07-22	1	-4181
64364	4395	1112807	1949-10-26	1949-12-25	1	-7312
16946	1169	933724	1989-11-04	1989-11-18	1	7261
14265	974	1112807	1971-08-05	1971-09-09	1	616
44464	3010	1759842	1982-03-10	1982-03-31	1	4472
11599	795	1729720	1940-03-02	1940-03-14	1	-10885
52625	3582	1125315	1989-09-01	1989-10-01	2	7213
10653	730	1112807	1958-10-05	1958-10-19	1	-4092
50698	3446	1728416	1954-10-29	1954-11-12	1	-5529
11177	763	1713332	1982-06-23	1982-07-14	1	4577
56835	3874	1759842	1994-06-16	1994-06-30	1	8946
13294	911	1759842	1984-11-13	1984-11-27	1	5444
56810	3871	1125315	1963-09-08	1963-09-15	1	-2300
62871	4295	1119510	1992-06-18	1992-07-02	1	8218
17762	1227	1332418	2013-03-20	2013-03-20	1	15784
51020	3470	1125315	2008-12-20	2008-12-27	1	14240
10108	693	1713332	2018-05-29	2018-06-05	1	17687
8246	572	1729720	1975-01-29	1975-02-06	1	1862
56489	3849	933724	2005-12-14	2005-12-21	1	13138
48244	3277	1119510	1971-07-24	1971-08-07	1	583
18090	1246	1125315	1969-09-26	1969-09-26	1	-97
62806	4288	1125315	1974-06-28	1974-07-05	1	1646
11957	823	1112807	1949-10-25	1949-11-15	1	-7352
59404	4049	1125315	1973-08-29	1973-09-12	1	1350
6561	454	1119510	1959-06-04	1959-06-11	1	-3857
51886	3532	1759842	1999-08-04	1999-08-18	1	10821
66793	4559	1713332	1992-05-28	1992-06-11	1	8197
52972	3610	1115008	2017-06-26	2017-07-10	1	17357
14904	1032	1759842	1980-08-04	1980-08-11	1	3875
15613	1082	1125315	2005-12-20	2005-12-27	1	13144
55305	3759	1125315	1982-08-05	1982-08-19	1	4613
15163	1053	1729720	1981-02-04	1981-02-13	1	4061
51463	3508	1125315	1996-03-21	1996-03-28	1	9583
10804	742	1729720	1990-03-29	1990-04-09	1	7403
20684	1409	1125315	2006-03-13	2006-03-27	1	13234
12057	829	1125315	2012-03-29	2012-05-28	2	15488
13205	905	1729720	1972-01-18	1972-01-29	1	758
56707	3865	1112807	1969-06-20	1969-07-20	1	-165
16575	1144	1119510	1999-06-27	1999-07-04	1	10776
54448	3703	1125315	1999-07-24	1999-08-07	1	10810
8364	580	1125315	1980-12-01	1980-12-15	1	4001
77676	5309	1713332	1978-05-19	1978-06-02	1	3074
59980	4090	1102527	1955-01-21	1955-01-21	1	-5459
17588	1215	1717327	1975-04-23	1975-05-07	1	1952
53243	3626	1768849	1979-03-18	1979-04-01	1	3377
4589	316	1125315	1975-12-14	1976-02-19	2	2240
60473	4123	1118084	1999-01-07	1999-01-07	1	10598
11322	774	1125315	1994-12-22	1994-12-29	1	9128
58094	3962	1177480	2015-09-03	2015-09-24	1	16702
9074	624	1119510	1969-10-17	1969-10-24	1	-69
10068	691	1729720	1999-09-30	1999-10-08	1	10872
59834	4080	1713332	1988-09-03	1988-09-10	1	6827
10735	736	1713332	1983-12-02	1983-12-23	1	5104
63600	4347	1112807	1969-05-24	1969-06-07	1	-208
9435	651	920293	2011-06-10	2011-06-17	1	15142
59302	4040	1177480	1994-08-17	1994-09-21	1	9029
7929	550	1125315	1975-12-14	1975-12-28	1	2187
46558	3161	1713332	2016-11-13	2016-11-27	1	17132
64365	4395	1729720	1981-12-17	1981-12-27	1	4378
16947	1169	1124300	1975-12-23	1975-12-23	1	2182
14266	974	1118084	1993-04-06	1993-04-06	1	8496
44465	3010	1759842	1996-08-10	1996-08-17	1	9725
11600	795	738818	1965-06-20	1965-06-27	1	-1649
52626	3582	1521369	1977-04-17	1978-04-12	1	3023
10654	730	1112807	1959-05-03	1959-06-07	1	-3861
50699	3446	1759842	1998-05-17	1998-06-07	1	10384
11178	763	1713332	1994-08-09	1994-08-16	1	8993
56836	3874	1192710	1984-01-13	1984-01-13	1	5125
13295	911	1118084	2015-06-16	2015-06-16	1	16602
56811	3871	1125315	1969-11-20	1969-12-04	1	-28
62872	4295	1713332	1975-10-09	1975-10-30	1	2128
17763	1227	1729720	1967-01-21	1967-02-02	1	-1064
51021	3470	1729720	1967-05-06	1967-05-19	1	-958
10109	693	1729720	2005-05-31	2005-06-13	1	12947
8247	572	1759842	2007-04-06	2007-04-13	1	13616
56490	3849	1112807	1964-11-15	1964-12-06	1	-1852
48245	3277	1125315	1997-10-25	1998-01-23	1	10249
18091	1246	1125315	1983-08-04	1983-08-11	1	4970
62807	4288	1759842	1966-11-16	1966-11-23	1	-1135
11958	823	1119510	1970-05-08	1970-05-15	1	134
59405	4049	1125315	1974-08-08	1974-08-22	1	1694
6562	454	1177480	1981-08-11	1981-09-08	1	4268
52988	3612	933724	2004-01-08	2004-01-15	1	12432
66794	4559	1729720	1956-11-18	1956-11-28	1	-4782
52973	3610	1124300	1985-02-10	1985-02-10	1	5519
14905	1032	1125315	1979-03-21	1979-04-11	1	3387
15614	1082	1192710	1988-09-06	1988-09-06	1	6823
55306	3759	1125315	2010-07-05	2010-07-19	1	14809
15164	1053	723013	1982-09-10	1984-03-02	1	5174
51464	3508	1717327	1961-09-20	1961-10-04	1	-3011
10805	742	1759842	2011-03-16	2011-03-23	1	15056
20685	1409	1729720	1993-05-27	1993-06-03	1	8554
12058	829	1174888	2012-03-29	2012-03-29	1	15428
13206	905	1738521	1972-02-03	1972-02-17	1	777
56708	3865	1125315	1977-07-10	1977-07-24	1	2761
16576	1144	1125315	1980-01-16	1980-01-30	1	3681
54449	3703	1551099	1985-03-29	1985-03-29	1	5566
8365	580	1177480	1994-07-30	1994-08-13	1	8990
77677	5309	1112807	1964-11-07	1964-12-12	1	-1846
59981	4090	1125315	1952-02-01	1952-02-08	1	-6537
17589	1215	1759842	1976-10-11	1976-10-18	1	2482
53244	3626	19127890	1993-02-21	1994-02-16	1	8812
4590	316	1125315	2016-03-26	2016-04-02	1	16893
60474	4123	1102527	2013-02-09	2013-02-09	1	15745
11323	774	1125315	1983-03-27	1983-04-10	1	4847
58095	3962	1728416	1956-12-17	1956-12-31	1	-4749
9075	624	1125315	1961-11-07	1961-11-14	1	-2970
10069	691	1112807	1971-07-20	1971-08-03	1	579
59835	4080	1759842	1981-02-14	1981-03-07	1	4083
10736	736	1759842	1979-03-05	1979-03-19	1	3364
63601	4347	1112807	1971-12-10	1972-01-14	1	743
9436	651	1343916	1999-01-28	1999-01-28	1	10619
59303	4040	1713332	2005-11-20	2005-12-04	1	13121
7930	550	1125315	1983-06-20	1983-06-27	1	4925
46559	3161	1738521	1967-05-11	1967-05-25	1	-952
64366	4395	1759842	1965-11-02	1965-11-23	1	-1500
16948	1169	1125315	1944-09-09	1944-09-23	1	-9231
14267	974	1125315	2014-04-08	2014-06-07	1	16228
44466	3010	1125315	1972-07-31	1972-08-28	1	970
11601	795	1112807	1937-04-16	1937-04-30	1	-11934
52627	3582	1115008	2000-03-07	2000-04-04	1	11051
10655	730	1112807	1959-09-17	1959-10-01	1	-3745
50700	3446	1112807	1954-10-29	1954-11-12	1	-5529
11179	763	19127890	1981-03-04	1982-02-27	1	4440
56837	3874	1515774	1996-12-14	1998-12-04	2	10564
13296	911	1125315	2003-12-23	2003-12-30	1	12416
56812	3871	1713332	1985-12-25	1986-01-01	1	5844
62873	4295	1713332	1997-08-17	1997-08-31	1	10104
17764	1227	1759842	2019-04-27	2019-05-04	1	18020
52506	3576	1124300	2000-05-21	2000-05-21	1	11098
10110	693	1112807	1962-02-22	1962-03-08	1	-2856
8248	572	1125315	1958-04-19	1958-05-03	1	-4261
56491	3849	1112807	1969-01-23	1969-02-06	1	-329
48246	3277	1177480	2013-12-21	2014-01-11	1	16081
18092	1246	1125315	1994-03-03	1994-03-24	1	8848
62808	4288	1125315	1955-09-18	1955-09-25	1	-5212
11959	823	1149380	2009-02-09	2009-02-09	1	14284
59406	4049	1125315	1989-11-01	1989-11-29	1	7272
6563	454	1177480	1991-12-15	1991-12-29	1	8032
52989	3612	933724	2008-06-27	2008-07-11	1	14071
66795	4559	1759842	1962-01-14	1962-01-28	1	-2895
52974	3610	1125315	1985-08-31	1985-09-07	1	5728
14906	1032	1177480	1991-07-19	1991-08-23	1	7904
15615	1082	1343916	1988-09-06	1988-09-06	1	6823
55307	3759	1521369	1981-07-21	1982-07-16	1	4579
15165	1053	920293	2018-04-11	2018-04-18	1	17639
51465	3508	1728416	1958-09-03	1958-09-17	1	-4124
10806	742	1112807	1961-04-27	1961-06-01	1	-3136
20686	1409	1112807	1928-09-03	1928-09-24	1	-15074
12059	829	1729720	1983-05-19	1983-05-31	1	4898
13207	905	1759842	1998-12-30	1999-01-13	1	10604
56709	3865	1125315	1985-12-10	1985-12-24	1	5836
16577	1144	1125315	2013-10-16	2013-10-30	1	16008
54450	3703	738818	2013-08-09	2013-08-16	1	15933
8366	580	1759842	1958-03-24	1958-03-31	1	-4294
77678	5309	1118084	1993-05-08	1993-05-08	1	8528
59982	4090	1125315	1955-01-14	1955-03-22	1	-5399
17590	1215	1115008	1998-09-19	1998-11-18	1	10548
53245	3626	1124300	2016-07-25	2016-07-25	1	17007
4591	316	1539403	1991-10-22	1991-10-22	1	7964
60475	4123	1112807	1976-12-24	1977-01-14	1	2570
11324	774	1125315	1985-08-14	1985-08-28	1	5718
58096	3962	1112807	1956-12-17	1956-12-31	1	-4749
9076	624	1125315	1968-07-27	1968-08-17	1	-502
10070	691	1118084	1994-12-20	1994-12-20	1	9119
59836	4080	1759842	1988-09-03	1988-09-10	1	6827
10737	736	738818	2002-08-21	2002-09-04	1	11934
63602	4347	1112807	1972-11-09	1973-01-08	1	1103
9437	651	1713332	1987-07-04	1987-07-18	1	6407
59304	4040	1738521	1977-02-03	1977-02-17	1	2604
7931	550	1125315	1994-09-24	1994-10-08	1	9046
47927	3253	1503184	1991-04-09	1993-03-29	2	8488
64367	4395	1112807	1982-07-10	1982-07-24	1	4587
16949	1169	1125315	1952-02-08	1952-03-07	1	-6509
14268	974	723013	1956-06-24	1957-03-03	2	-4701
44467	3010	1125315	2008-09-30	2008-10-07	1	14159
11602	795	1125315	1965-06-20	1965-06-27	1	-1649
52628	3582	1124300	2001-07-30	2001-07-30	1	11533
10656	730	1713332	1990-06-27	1990-07-18	1	7503
50701	3446	1119510	1959-12-01	1959-12-08	1	-3677
11180	763	1112807	1970-06-05	1970-06-19	1	169
56838	3874	1768849	1983-08-15	1983-08-29	1	4988
13297	911	1129625	1977-06-15	1977-06-15	1	2722
56813	3871	1729720	1966-05-25	1966-06-05	1	-1306
62874	4295	1728416	1975-10-01	1975-10-15	1	2113
17765	1227	715997	2018-12-22	2018-12-22	1	17887
52507	3576	1125315	1972-10-10	1972-11-09	1	1043
10111	693	1119510	1975-10-16	1975-10-23	1	2121
8249	572	1728416	1958-04-19	1958-05-03	1	-4261
56492	3849	1521369	1981-11-03	1982-10-29	1	4684
50365	3432	1177480	1986-09-25	1986-10-16	1	6132
18093	1246	1125315	2005-07-24	2005-08-23	1	13018
62809	4288	1713332	1966-11-16	1966-11-23	1	-1135
11960	823	1557272	2005-01-17	2005-01-17	1	12800
59407	4049	1729720	1993-08-15	1993-08-23	1	8635
6564	454	1307863	2005-03-05	2005-03-05	1	12847
52990	3612	1119510	2000-04-30	2000-05-14	1	11091
66796	4559	1759842	1992-05-28	1992-06-11	1	8197
52975	3610	1125315	1987-06-20	1987-07-04	1	6393
14907	1032	1713332	1953-04-13	1953-05-04	1	-6086
15616	1082	1713332	1986-04-17	1986-04-24	1	5957
58399	3984	738818	1958-03-26	1958-04-02	1	-4292
15166	1053	1118084	2015-03-11	2015-03-11	1	16505
51466	3508	1124300	1995-11-09	1995-11-09	1	9443
10807	742	1119510	1926-06-10	1926-06-24	1	-15897
20687	1409	1177480	2012-09-03	2012-09-24	1	15607
12060	829	1729720	1987-04-23	1987-04-30	1	6328
13208	905	740275	1977-03-12	1977-03-12	1	2627
56710	3865	1125315	2009-05-28	2009-07-04	1	14429
16578	1144	1738521	1971-03-04	1971-03-18	1	441
54451	3703	1125315	1995-03-09	1995-03-16	1	9205
8367	580	1112807	1930-06-03	1930-07-01	1	-14429
77679	5309	1125315	1966-04-20	1966-05-04	1	-1338
59983	4090	1125315	1988-06-21	1988-06-28	1	6753
17591	1215	1125315	1975-11-20	1975-12-04	1	2163
53246	3626	1177480	1977-02-05	1977-02-19	1	2606
4592	316	1759842	1928-02-07	1928-02-14	1	-15297
60476	4123	1713332	1994-12-31	1995-01-07	1	9137
11325	774	1177480	2006-11-05	2006-12-05	1	13487
58097	3962	1118084	1989-11-24	1989-11-24	1	7267
9077	624	1125315	2014-08-30	2014-09-20	1	16333
10071	691	1125315	1991-09-17	1991-10-15	1	7957
59837	4080	19127890	1979-05-29	1980-05-23	1	3795
10738	736	1119510	1982-10-06	1982-10-20	1	4675
63603	4347	1125315	1974-02-02	1974-03-04	1	1523
9438	651	1729720	1988-11-29	1988-12-06	1	6914
59305	4040	1759842	2005-11-20	2005-12-04	1	13121
8525	592	1500211	1992-10-08	1993-10-03	1	8676
47928	3253	1549786	1996-03-13	1997-03-08	1	9928
64368	4395	1125315	1981-08-09	1981-09-13	1	4273
16950	1169	1125315	1961-10-16	1961-11-06	1	-2978
14269	974	933724	1999-07-25	1999-08-01	1	10804
44468	3010	1729720	1984-07-24	1984-08-06	1	5331
11603	795	1125315	1984-02-16	1984-03-01	1	5173
52629	3582	1137529	1996-06-02	1996-06-02	1	9649
10657	730	1759842	1990-06-27	1990-07-18	1	7503
50702	3446	1125315	2000-09-20	2000-10-04	1	11234
11181	763	1115008	1995-04-24	1995-05-15	1	9265
56839	3874	1118084	2014-10-06	2014-10-06	1	16349
13298	911	1177480	1976-04-06	1976-04-20	1	2301
56814	3871	1759842	1985-12-25	1986-01-01	1	5844
62875	4295	1115008	1997-12-18	1998-01-08	1	10234
17766	1227	1112807	1940-10-08	1940-10-22	1	-10663
52508	3576	1125315	2005-11-12	2005-11-19	1	13106
10112	693	1119510	2018-01-11	2018-01-25	1	17556
10481	720	933724	1998-09-17	1998-09-24	1	10493
56493	3849	1729720	1969-04-20	1969-05-03	1	-243
50366	3432	1728416	1957-04-04	1957-04-18	1	-4641
18094	1246	1125315	2011-03-12	2011-03-26	1	15059
67478	4607	1125315	1988-10-13	1988-12-12	1	6920
11961	823	1118084	1979-01-26	1979-01-26	1	3312
59408	4049	738818	1983-02-10	1983-02-24	1	4802
6565	454	1713332	1953-07-05	1953-07-19	1	-6010
52991	3612	1125315	1991-12-02	1992-03-01	1	8095
67971	4639	1503184	1988-01-27	1989-01-21	1	6960
52976	3610	1759842	1950-06-19	1950-07-03	1	-7122
14908	1032	1713332	1976-08-25	1976-11-17	1	2512
15617	1082	1728416	1955-12-18	1956-01-01	1	-5114
58400	3984	1112807	1964-08-27	1964-09-10	1	-1939
15167	1053	1125315	2001-11-12	2002-02-10	1	11728
51467	3508	1125315	2010-12-25	2011-01-08	1	14982
10808	742	1125315	1975-05-19	1975-06-09	1	1985
20688	1409	1729720	1971-04-10	1971-04-20	1	474
12061	829	1729720	2006-09-13	2006-09-23	1	13414
13209	905	1112807	1972-06-25	1972-07-09	1	920
56711	3865	1713332	1982-02-01	1982-02-08	1	4421
16579	1144	738818	1999-06-27	1999-07-04	1	10776
54452	3703	1125315	2013-08-09	2013-08-16	1	15933
8368	580	1112807	1958-04-26	1958-05-10	1	-4254
77680	5309	1174888	1967-10-28	1967-10-28	1	-796
59984	4090	1307863	2017-08-14	2017-08-14	1	17392
17592	1215	1125315	1998-09-19	1998-09-19	1	10488
53247	3626	1125315	1979-03-18	1979-04-01	1	3377
4593	316	1125315	1937-10-24	1937-11-07	1	-11743
60477	4123	1759842	1994-12-31	1995-01-07	1	9137
11326	774	1713332	1982-08-29	1982-09-12	1	4637
58098	3962	933724	1997-06-21	1997-06-28	1	10040
9078	624	1177480	2011-07-17	2011-09-15	1	15232
10072	691	1125315	1992-09-09	1992-09-23	1	8301
59838	4080	19127890	1982-05-13	1983-05-08	1	4875
10739	736	1125315	2000-10-22	2000-10-29	1	11259
63604	4347	1125315	2012-06-12	2012-07-03	1	15524
9439	651	1759842	1987-07-04	1987-07-18	1	6407
59306	4040	1118084	2013-01-20	2013-01-20	1	15725
8526	592	1713332	1995-03-14	1995-03-28	1	9217
47929	3253	1759842	1983-11-27	1983-12-04	1	5085
64369	4395	1713332	2010-12-31	2011-02-11	1	15016
16951	1169	1125315	1971-05-18	1971-05-18	1	502
14270	974	1112807	1956-12-21	1957-01-04	1	-4745
44469	3010	1322184	2015-03-18	2015-03-18	1	16512
11604	795	1125315	1987-07-23	1987-07-30	1	6419
52630	3582	1503184	1977-04-17	1978-04-12	1	3023
10658	730	19127890	1977-03-09	1979-02-27	2	3344
50703	3446	1759842	1947-07-30	1947-08-06	1	-8184
11182	763	1503184	1981-03-04	1982-02-27	1	4440
56840	3874	1125315	1983-08-15	1983-08-29	1	4988
13299	911	1551099	1984-05-24	1984-05-24	1	5257
56815	3871	1115008	1994-03-28	1994-05-27	1	8912
62876	4295	1118084	2007-09-28	2007-09-28	1	13784
17767	1227	1125315	1950-04-03	1950-05-03	2	-7183
52509	3576	1125315	2010-11-11	2010-12-11	1	14954
10113	693	1125315	1999-09-11	1999-09-11	1	10845
10482	720	1112807	1968-08-08	1968-10-07	1	-451
56494	3849	920293	2005-12-14	2005-12-21	1	13138
50367	3432	1759842	1955-12-17	1955-12-24	1	-5122
18095	1246	701322	2013-09-28	2013-09-28	1	15976
67479	4607	1115008	2007-08-05	2007-09-09	1	13765
11962	823	1137529	2009-02-09	2009-02-09	1	14284
59409	4049	1125315	1983-02-10	1983-02-24	1	4802
6566	454	1759842	1969-11-29	1969-12-06	1	-26
52992	3612	1177480	2009-02-28	2009-03-28	1	14331
67972	4639	1589505	1996-12-10	1997-12-05	1	10200
52977	3610	1125315	2003-12-05	2003-12-12	1	12398
14909	1032	1112807	1969-08-10	1969-11-08	1	-54
15618	1082	1728416	1956-08-25	1956-09-08	1	-4863
58401	3984	1125315	1958-03-26	1958-04-02	1	-4292
15168	1053	1125315	2018-05-08	2018-05-22	1	17673
51468	3508	1112807	1961-09-20	1961-10-04	1	-3011
10809	742	1137529	1961-10-09	1961-10-09	1	-3006
20689	1409	1112807	1922-02-02	1922-03-09	1	-17465
12062	829	1119510	1977-01-28	1977-02-04	1	2591
13210	905	1124300	2009-04-29	2009-04-29	1	14363
56712	3865	738818	1985-12-10	1985-12-24	1	5836
16580	1144	1115008	2009-05-02	2009-07-01	1	14426
54453	3703	1713332	1973-08-05	1973-08-12	1	1319
8369	580	1115008	2005-10-14	2005-11-04	1	13091
77681	5309	1361711	1988-12-26	1988-12-26	1	6934
59985	4090	1326303	2017-08-14	2017-08-14	1	17392
17593	1215	1115008	2001-12-16	2002-01-06	1	11693
53248	3626	1125315	2012-04-04	2012-04-18	1	15448
4594	316	1125315	1963-06-01	1963-06-15	1	-2392
60478	4123	1112807	1965-07-04	1965-07-25	1	-1621
11327	774	1759842	1982-08-29	1982-09-12	1	4637
58099	3962	1125315	1953-07-06	1953-07-20	1	-6009
9079	624	1759842	1992-11-06	1992-11-13	1	8352
10073	691	1125315	2008-01-25	2008-02-08	1	13917
59839	4080	738818	1985-01-19	1985-02-02	1	5511
10740	736	1125315	2002-08-21	2002-09-04	1	11934
63605	4347	1521369	1980-04-06	1982-03-27	2	4468
9440	651	1112807	1983-04-04	1983-04-18	1	4855
59307	4040	1125315	2009-03-12	2009-03-26	1	14329
8527	592	19127890	1990-10-19	1991-10-14	1	7956
47930	3253	1759842	1987-01-23	1987-01-30	1	6238
64370	4395	1759842	2010-12-31	2011-02-11	1	15016
16952	1169	1309944	2012-02-20	2012-02-20	1	15390
14271	974	1125315	1960-03-05	1960-05-04	1	-3529
44470	3010	1347450	2015-03-18	2015-03-18	1	16512
11605	795	1177480	2000-11-02	2000-11-16	1	11277
52631	3582	1729720	1997-01-08	1997-01-19	1	9880
13104	895	1125315	1963-12-16	1963-12-30	1	-2194
53538	3644	738818	1961-02-05	1961-02-19	1	-3238
11183	763	1713332	1995-05-19	1995-06-09	1	9290
56841	3874	1595799	1998-12-04	1999-11-29	1	10924
14718	1017	740275	1970-06-12	1970-10-09	1	281
56816	3871	1125315	1991-05-25	1991-06-01	1	7821
62877	4295	1125315	2009-04-09	2009-04-23	1	14357
17768	1227	1125315	1960-07-14	1960-08-04	1	-3437
52510	3576	1503184	1985-12-11	1986-12-06	1	6183
10114	693	1728416	1951-11-28	1951-12-12	1	-6595
10483	720	1125315	1997-02-28	1997-03-14	1	9934
56495	3849	920293	2007-01-19	2007-01-26	1	13539
50368	3432	723013	1953-11-08	1954-02-21	1	-5793
18096	1246	1112807	1939-04-16	1939-04-30	1	-11204
67480	4607	1125315	1975-04-25	1975-05-09	1	1954
11963	823	1713332	1980-05-24	1980-06-14	1	3817
59410	4049	1125315	1990-10-27	1990-11-03	1	7611
6567	454	738818	1961-09-08	1961-09-22	1	-3023
52993	3612	1729720	2017-06-02	2017-06-13	1	17330
67973	4639	1112807	1986-03-26	1986-04-25	1	5958
52978	3610	1305058	2017-04-18	2017-04-18	1	17274
14910	1032	1124300	1989-05-22	1989-05-22	1	7081
15619	1082	19127890	1976-07-10	1977-07-05	1	2742
58402	3984	1125315	1961-03-19	1961-03-26	1	-3203
15169	1053	1177480	1981-06-12	1981-06-26	1	4194
51469	3508	1125315	1957-10-24	1957-11-07	1	-4438
10810	742	1149380	1961-10-09	1961-10-09	1	-3006
20690	1409	1119510	1997-11-17	1997-12-01	1	10196
12063	829	1729720	1973-12-16	1973-12-23	1	1452
13211	905	1125315	1988-02-23	1988-03-15	1	6648
56713	3865	1102527	1969-06-20	1969-06-20	1	-195
16581	1144	1118084	2014-09-14	2014-09-14	1	16327
54961	3739	1503184	1984-08-02	1985-07-28	1	5687
8370	580	1125315	1942-08-16	1942-08-23	1	-9993
77682	5309	1539403	1991-04-22	1991-04-22	1	7781
59986	4090	1361711	2015-08-03	2015-08-03	1	16650
17594	1215	1124300	2009-04-19	2009-04-19	1	14353
53249	3626	1515774	1993-02-21	1994-02-16	1	8812
4595	316	1125315	1996-05-08	1996-05-15	1	9631
60479	4123	1125315	1997-12-25	1998-01-29	1	10255
13506	924	1112807	1969-06-28	1969-07-12	1	-173
58100	3962	1112807	1981-09-21	1981-10-12	1	4302
9080	624	1759842	2012-06-15	2012-07-06	1	15527
10074	691	1728416	1961-06-21	1961-07-05	1	-3102
59840	4080	1115008	1998-01-30	1998-03-01	1	10286
10741	736	1177480	2010-07-15	2010-08-05	1	14826
64316	4392	1115008	2001-09-18	2001-10-09	1	11604
9441	651	1115008	2007-08-26	2007-09-09	1	13765
59308	4040	1125315	1977-02-03	1977-02-17	1	2604
8528	592	1124300	2007-03-09	2007-03-09	1	13581
47931	3253	19010482	2001-03-10	2001-03-31	1	11412
64371	4395	1102527	1963-03-17	1963-03-17	1	-2482
16953	1169	1343916	2012-02-20	2012-02-20	1	15390
14272	974	1177480	2013-02-21	2013-03-14	1	15778
44471	3010	1759842	1989-03-30	1989-04-13	1	7042
11606	795	1729720	1968-03-16	1968-03-23	1	-649
52632	3582	1124957	1989-09-01	1989-09-01	1	7183
13105	895	1125315	1980-02-22	1980-03-07	1	3718
53539	3644	914335	1982-02-24	1982-02-24	1	4437
11184	763	1717327	1966-07-11	1966-07-25	1	-1256
56842	3874	1713332	1994-06-16	1994-06-30	1	8946
14719	1017	740275	1970-11-15	1971-06-13	1	528
56817	3871	1177480	2003-09-24	2003-10-08	1	12333
62878	4295	1713332	1995-07-09	1995-07-23	1	9334
17769	1227	1125315	1974-12-25	1975-01-08	1	1833
52511	3576	1125315	1992-03-25	1992-04-01	1	8126
11493	784	1125315	1982-04-01	1982-05-01	1	4503
10484	720	1521369	1979-08-21	1980-08-15	1	3879
56496	3849	933724	2007-01-19	2007-01-26	1	13539
50369	3432	740275	1954-09-03	1955-04-01	1	-5389
18097	1246	1112807	1961-11-16	1961-12-07	1	-2947
67481	4607	1729720	1973-09-15	1973-09-26	1	1364
11964	823	1125315	2009-02-01	2009-02-08	1	14283
59411	4049	1729720	2018-03-01	2018-03-12	1	17602
6568	454	757627	2013-02-16	2013-02-16	1	15752
52994	3612	1118084	2004-09-24	2004-09-24	1	12685
67974	4639	1503184	1993-12-26	1994-12-21	1	9120
52979	3610	1713332	1950-06-19	1950-07-03	1	-7122
14911	1032	1125315	1985-08-09	1985-08-23	1	5713
15893	1100	1118084	2019-05-08	2019-05-08	1	18024
58403	3984	1125315	1963-12-13	1963-12-27	1	-2197
15170	1053	19127890	1990-01-26	1992-01-16	2	8050
51470	3508	1125315	1961-11-04	1961-11-11	1	-2973
10811	742	1326303	2008-07-21	2008-07-21	1	14081
20691	1409	738818	1997-11-17	1997-12-01	1	10196
12064	829	19127890	1989-06-07	1990-06-02	1	7457
13212	905	1125315	1989-01-16	1989-01-30	1	6969
56714	3865	1115008	2004-11-13	2004-12-20	1	12772
16582	1144	1125315	1999-06-27	1999-07-04	1	10776
54962	3739	1503184	1986-07-23	1987-07-18	1	6407
8371	580	1125315	1964-05-17	1964-05-31	1	-2041
77683	5309	1112807	1955-08-06	1955-09-12	1	-5225
59987	4090	1322184	2015-08-03	2015-08-03	1	16650
17595	1215	1124957	1998-09-19	1998-09-19	1	10488
53250	3626	1521369	1990-03-09	1992-02-27	2	8092
4596	316	1125315	2006-08-31	2006-10-30	1	13451
60480	4123	1177480	2013-02-09	2013-03-11	1	15775
13507	924	1115008	1998-04-01	1998-05-07	1	10353
58101	3962	1177480	2011-12-09	2011-12-23	1	15331
11975	825	1112807	1971-08-18	1971-09-01	1	608
10313	709	738818	1953-04-14	1953-04-21	1	-6099
59841	4080	1125315	1985-01-19	1985-02-02	1	5511
14917	1033	1118084	2007-07-17	2007-07-17	1	13711
64317	4392	1118084	2018-03-06	2018-03-06	1	17596
9442	651	1118084	2012-04-11	2012-04-11	1	15441
59309	4040	1125315	1979-11-22	1979-12-06	1	3626
8529	592	1549786	1990-10-19	1991-10-14	1	7956
47932	3253	19010482	2005-04-15	2005-05-06	1	12909
64372	4395	1112807	1963-03-17	1963-04-16	1	-2452
16954	1169	1713332	1979-08-05	1979-08-26	1	3524
14273	974	1729720	1960-02-07	1960-02-17	1	-3606
45551	3092	1112807	1956-05-22	1956-06-05	1	-4958
11607	795	1729720	2018-12-17	2018-12-26	1	17891
52633	3582	1125315	1999-10-11	1999-10-18	1	10882
13106	895	1112807	1988-02-03	1988-02-17	1	6621
53540	3644	1125315	1959-11-11	1959-11-18	1	-3697
11185	763	1729720	1970-01-10	1970-01-23	1	22
56843	3874	1729720	1986-06-14	1986-06-23	1	6017
14720	1017	1112807	1960-01-06	1960-01-20	1	-3634
56818	3871	1717327	1968-01-14	1968-01-28	1	-704
62879	4295	1729720	2018-01-04	2018-01-15	1	17546
17770	1227	1125315	2000-06-03	2000-06-10	1	11118
52512	3576	1521369	1985-12-11	1986-12-06	1	6183
11494	784	1112807	1992-08-06	1992-08-27	1	8274
10485	720	1713332	1998-02-05	1998-02-26	1	10283
56497	3849	1115008	2016-11-06	2016-12-11	1	17146
50370	3432	1112807	1957-04-04	1957-04-18	1	-4641
18098	1246	1125315	1950-06-13	1950-06-20	1	-7135
67482	4607	1124300	2014-12-30	2014-12-30	1	16434
11965	823	1177480	2017-10-19	2017-11-18	1	17488
59412	4049	1119510	1983-02-10	1983-02-24	1	4802
6569	454	920293	1954-05-16	1954-05-23	1	-5702
52995	3612	1119510	1982-06-24	1982-07-08	1	4571
67975	4639	1515774	1991-01-11	1993-12-26	3	8760
56200	3830	1115008	2008-07-26	2008-08-09	1	14100
14912	1032	1125315	1990-07-26	1990-08-23	1	7539
15894	1100	1125315	1996-03-03	1996-05-02	1	9618
58404	3984	1125315	1970-06-25	1970-07-30	1	210
15171	1053	740275	1982-12-03	1983-05-06	1	4873
51471	3508	1125315	1971-12-20	1971-12-27	1	725
10812	742	1713332	2011-03-16	2011-03-23	1	15056
20692	1409	1124300	1960-03-04	1960-03-04	1	-3590
12269	843	1515774	1997-04-22	1998-04-17	1	10333
13213	905	1125315	1997-10-07	1997-10-21	1	10155
56715	3865	1177480	1978-10-01	1978-11-30	1	3255
16583	1144	1729720	2013-09-13	2013-09-22	1	15970
54963	3739	1521369	1986-07-23	1987-07-18	1	6407
8372	580	1125315	2011-08-05	2011-08-19	1	15205
77684	5309	1115008	2018-06-16	2018-09-14	1	17788
59988	4090	1332418	2015-08-03	2015-08-03	1	16650
17596	1215	1177480	1975-04-23	1975-05-07	1	1952
53251	3626	1713332	2014-03-17	2014-03-31	1	16160
4597	316	1322184	1997-11-25	1997-11-25	1	10190
60481	4123	1125315	1977-11-10	1978-01-09	1	2930
13508	924	1177480	1987-06-15	1987-06-29	1	6388
58102	3962	1729720	2003-11-13	2003-11-22	1	12378
11976	825	1125315	1997-09-22	1997-09-29	1	10133
10314	709	1125315	1953-04-14	1953-04-21	1	-6099
59842	4080	1177480	2014-05-06	2014-05-20	1	16210
14918	1033	1177480	1980-12-20	1981-03-20	1	4096
64318	4392	1125315	2005-09-18	2005-09-18	1	13044
9443	651	1125315	1997-01-22	1997-02-05	1	9897
59310	4040	1125315	2017-03-02	2017-03-09	1	17234
8530	592	1713332	2012-11-11	2012-11-18	1	15662
47933	3253	19127890	1996-03-13	1997-03-08	1	9928
64373	4395	1729720	2018-05-31	2018-06-08	1	17690
16955	1169	1112807	1936-10-08	1936-10-29	1	-12117
14274	974	1728416	1956-12-21	1957-01-04	1	-4745
45552	3092	1118084	1994-06-02	1994-06-02	1	8918
11608	795	920293	1973-09-12	1973-09-19	1	1357
52634	3582	1125315	2011-12-03	2012-02-01	1	15371
13107	895	1322184	1999-01-15	1999-01-15	1	10606
53541	3644	1125315	1961-02-05	1961-02-19	1	-3238
11186	763	1759842	1995-05-19	1995-06-09	1	9290
56844	3874	19127890	1996-12-14	1998-12-04	2	10564
14721	1017	1115008	2009-09-27	2009-12-26	1	14604
58250	3973	1759842	1980-07-12	1980-07-19	1	3852
62880	4295	1759842	1995-07-09	1995-07-23	1	9334
17771	1227	1307863	2016-04-06	2016-04-06	1	16897
52513	3576	1713332	1987-02-26	1987-03-19	1	6286
11495	784	1125315	1979-01-17	1979-01-24	1	3310
10486	720	1759842	1998-02-05	1998-02-26	1	10283
56498	3849	1125315	1976-06-06	1976-07-04	1	2376
50371	3432	1125315	1964-06-03	1964-06-24	1	-2017
18099	1246	1125315	1972-01-14	1972-01-28	1	757
67483	4607	1125315	1974-07-08	1974-07-22	1	1663
11966	823	1322184	2019-04-15	2019-04-15	1	18001
59413	4049	1125315	1979-11-24	1980-02-22	1	3704
6570	454	933724	1954-05-16	1954-05-23	1	-5702
52996	3612	1125315	2013-10-20	2013-11-03	1	16012
67976	4639	1549786	1991-01-11	1993-12-26	3	8760
56201	3830	1713332	1986-12-25	1987-01-01	1	6209
14913	1032	1125315	2010-08-28	2010-10-24	2	14884
15895	1100	1125315	2004-02-20	2004-04-20	2	12528
58405	3984	1125315	1975-05-09	1975-05-16	1	1961
15172	1053	920293	2014-02-25	2014-03-04	1	16133
51472	3508	1177480	2019-05-02	2019-05-02	1	18018
10813	742	1102527	1991-11-12	1991-11-12	1	7985
20693	1409	1125315	1937-09-07	1937-09-21	1	-11790
12270	843	1549786	1997-04-22	1998-04-17	1	10333
13214	905	1125315	2007-11-01	2007-12-06	1	13853
56716	3865	1192710	1960-07-18	1960-07-18	1	-3454
16584	1144	1112807	1990-10-04	1990-11-08	1	7616
54964	3739	1729720	1971-01-26	1971-02-03	1	398
8373	580	1557272	1997-10-05	1997-10-05	1	10139
77685	5309	1125315	1967-10-28	1967-10-28	1	-796
59989	4090	1112807	1944-07-10	1944-07-24	1	-9292
17597	1215	1177480	1999-12-13	1999-12-27	1	10952
53252	3626	1738521	1977-02-05	1977-02-19	1	2606
6136	422	1124300	2000-12-20	2000-12-20	1	11311
60482	4123	1125315	1984-10-24	1984-11-07	1	5424
13509	924	1729720	1995-08-11	1995-08-20	1	9362
59586	4064	975125	1982-02-12	1982-02-26	1	4439
11977	825	1717327	1971-01-10	1971-01-24	1	388
10315	709	1125315	1987-06-05	1987-06-19	1	6378
59843	4080	1521369	1986-04-22	1987-04-17	1	6315
14919	1033	1729720	1984-01-28	1984-02-06	1	5149
64319	4392	1177480	1991-01-02	1991-01-30	1	7699
9444	651	1515774	1992-04-26	1993-04-21	1	8511
59311	4040	1713332	2015-03-12	2015-03-26	1	16520
8531	592	1759842	2012-11-11	2012-11-18	1	15662
47934	3253	1124300	2005-12-31	2005-12-31	1	13148
64374	4395	1112807	1960-11-27	1961-02-25	1	-3232
16956	1169	1115008	2009-02-21	2009-03-07	1	14310
14275	974	920293	1999-07-25	1999-08-01	1	10804
45553	3092	1125315	1964-05-24	1964-08-22	1	-1958
11609	795	1112807	1946-07-28	1946-08-18	1	-8537
52635	3582	1125315	2017-02-14	2017-02-28	1	17225
13108	895	1332418	1996-01-12	1996-01-12	1	9507
53542	3644	1309944	1982-02-24	1982-02-24	1	4437
12515	862	1125315	1977-02-10	1977-02-24	1	2611
56845	3874	1119510	2012-06-15	2012-06-29	1	15520
14722	1017	1713332	1970-01-21	1970-01-28	1	27
58251	3973	1118084	2004-03-03	2004-03-03	1	12480
62881	4295	1125315	1973-07-14	1973-07-28	1	1304
17772	1227	1322184	2013-03-20	2013-03-20	1	15784
52514	3576	1759842	1987-02-26	1987-03-19	1	6286
11496	784	1125315	2002-09-27	2002-10-04	1	11964
10487	720	738818	2013-03-17	2013-03-31	1	15795
56499	3849	1503184	1981-11-03	1982-10-29	1	4684
50372	3432	1125315	1989-09-30	1989-10-07	1	7219
18833	1293	1102527	1970-03-18	1970-03-18	1	76
67484	4607	1125315	1998-01-04	1998-01-11	1	10237
11967	823	1347450	2019-04-15	2019-04-15	1	18001
59414	4049	1177480	1999-06-10	1999-07-01	1	10773
6571	454	1112807	1935-07-30	1935-08-13	1	-12560
52997	3612	1713332	2018-01-08	2018-01-29	1	17560
67977	4639	1717327	1975-07-24	1975-08-07	1	2044
56202	3830	1713332	2007-07-21	2007-08-11	1	13736
14914	1032	1125315	2017-03-07	2017-03-14	1	17239
15896	1100	1174888	2004-02-20	2004-02-20	1	12468
58406	3984	1310149	2014-11-26	2014-11-26	1	16400
15173	1053	933724	2014-02-25	2014-03-04	1	16133
51473	3508	1728416	1957-10-24	1957-11-07	1	-4438
10814	742	1125315	1974-08-14	1974-08-21	1	1693
20694	1409	1125315	1997-11-17	1997-12-01	1	10196
12271	843	1549786	2001-04-01	2002-03-27	1	11773
13215	905	1125315	2008-10-01	2008-10-22	1	14174
57920	3951	1112807	1946-03-13	1946-03-27	1	-8681
16585	1144	1119510	2013-10-16	2013-10-30	1	16008
54965	3739	1729720	2007-02-01	2007-02-12	1	13556
8374	580	1713332	1958-03-24	1958-03-31	1	-4294
77686	5309	1332418	1995-05-01	1995-05-01	1	9251
59990	4090	1112807	1944-10-27	1944-11-10	1	-9183
17598	1215	1713332	1976-10-11	1976-10-18	1	2482
53253	3626	1759842	2014-03-17	2014-03-31	1	16160
6137	422	1125315	1983-01-04	1983-01-18	1	4765
61610	4205	1118084	2011-01-13	2011-01-13	1	14987
13510	924	1759842	2018-09-11	2018-09-18	1	17792
59587	4064	975125	1999-12-07	1999-12-28	1	10953
11978	825	1738521	1972-08-13	1972-08-27	1	969
10316	709	1322184	1999-07-04	2005-08-28	1	13023
59844	4080	1102527	1998-01-30	1998-01-30	1	10256
14920	1033	19127890	1988-07-16	1989-07-11	1	7131
64320	4392	1177480	2005-09-18	2005-11-17	1	13104
9445	651	1549786	1992-04-26	1993-04-21	1	8511
59312	4040	1729720	1981-02-13	1981-02-25	1	4073
8532	592	19127890	1985-11-14	1986-11-09	1	6156
47935	3253	1149380	1974-05-25	1974-05-25	1	1605
64375	4395	1118084	1992-04-13	1992-04-13	1	8138
16957	1169	1124957	1971-05-18	1971-05-18	1	502
14276	974	920293	2001-09-03	2001-09-10	1	11575
45554	3092	1713332	2004-08-11	2004-09-01	1	12662
11610	795	1119510	1965-06-20	1965-06-27	1	-1649
52636	3582	1149380	1996-06-02	1996-06-02	1	9649
13109	895	1361711	1980-02-29	1980-02-29	1	3711
53543	3644	1343916	1982-02-24	1982-02-24	1	4437
12516	862	1125315	1987-02-21	1987-03-07	1	6274
56846	3874	1125315	1986-09-28	1986-11-27	1	6174
14723	1017	1713332	2018-05-09	2018-05-30	1	17681
58252	3973	1125315	2005-07-09	2005-10-07	1	13063
62882	4295	1125315	1976-12-25	1977-01-08	1	2564
17773	1227	1539403	2013-03-20	2013-03-20	1	15784
52515	3576	1125315	1969-07-28	1969-08-11	1	-143
11497	784	1118084	2000-09-13	2000-09-13	1	11213
10488	720	1119510	2013-03-17	2013-03-31	1	15795
56500	3849	1729720	1965-02-14	1965-02-25	1	-1771
50373	3432	1713332	1955-12-17	1955-12-24	1	-5122
18834	1293	1112807	1945-10-25	1945-11-24	1	-8804
67485	4607	1177480	1984-10-13	1984-11-03	1	5420
11968	823	1759842	1980-05-24	1980-06-14	1	3817
59415	4049	1717327	1961-07-03	1961-07-17	1	-3090
6572	454	1125315	1958-01-01	1958-01-08	1	-4376
52998	3612	920293	2004-03-15	2004-03-22	1	12499
67978	4639	1729720	1971-07-18	1971-07-25	1	570
56203	3830	1729720	1983-03-13	1983-03-21	1	4827
14915	1032	1759842	1953-04-13	1953-05-04	1	-6086
15897	1100	1713332	2009-05-20	2009-05-27	1	14391
58407	3984	1759842	1963-06-12	1963-07-03	1	-2374
15174	1053	1125315	1976-06-28	1976-07-12	1	2384
54687	3720	1112807	1954-07-05	1954-07-19	1	-5645
10815	742	1125315	2009-10-08	2009-10-22	1	14539
25644	1739	1115008	1997-03-15	1997-06-13	1	10025
12272	843	1729720	1996-02-15	1996-02-28	1	9554
13216	905	1125315	1974-03-24	1974-06-22	1	1633
57921	3951	1118084	1986-08-30	1986-08-30	1	6085
16586	1144	1125315	1972-06-09	1972-06-23	1	904
54966	3739	1115008	2006-06-11	2006-08-10	1	13370
8375	580	1119510	1980-12-01	1980-12-15	1	4001
77687	5309	1728416	1953-04-18	1953-05-02	1	-6088
59991	4090	1112807	1949-09-12	1949-12-11	1	-7326
19005	1306	933724	2008-10-17	2008-10-31	1	14183
54036	3676	738818	1978-05-22	1978-05-29	1	3070
6138	422	1729720	2016-04-28	2016-05-11	1	16932
61611	4205	1125315	2004-07-18	2004-08-22	1	12652
13511	924	1768849	1998-04-01	1998-05-07	1	10353
59588	4064	1112807	1969-11-18	1970-02-16	1	46
11979	825	1119510	1988-02-06	1988-02-13	1	6617
10317	709	1361711	1999-07-04	2005-08-28	1	13023
59845	4080	1125315	1993-09-05	1993-09-19	1	8662
14921	1033	1503184	1988-07-16	1989-07-11	1	7131
64321	4392	1115008	2016-10-20	2016-11-19	1	17124
9446	651	1759842	1995-02-28	1995-03-07	1	9196
59313	4040	1729720	1986-11-27	1986-12-04	1	6181
8533	592	19127890	1987-11-04	1988-10-29	1	6876
47936	3253	1515774	1996-03-13	1997-03-08	1	9928
64376	4395	1125315	2013-11-08	2013-12-08	1	16047
16958	1169	1125315	1937-12-03	1937-12-17	1	-11703
14277	974	933724	2001-09-03	2001-09-10	1	11575
45555	3092	1728416	1955-10-25	1955-11-08	1	-5168
11611	795	1125315	1980-06-21	1980-06-28	1	3831
52637	3582	1177480	2014-12-17	2015-03-17	1	16511
13110	895	1539403	1993-01-08	1993-01-08	1	8408
53544	3644	1361711	1947-12-31	1947-12-31	1	-8037
12517	862	1125315	1997-06-29	1997-07-06	1	10048
56847	3874	1549786	1996-12-14	1999-11-29	3	10924
14724	1017	740275	1972-03-26	1972-07-02	1	913
58253	3973	1310149	2018-08-30	2018-08-30	1	17773
62883	4295	1125315	1982-08-25	1982-09-08	1	4633
17774	1227	701322	2018-12-22	2018-12-22	1	17887
52516	3576	1713332	1995-08-17	1995-08-24	1	9366
11498	784	1125315	1970-12-22	1970-12-29	1	362
10489	720	1125315	2013-03-17	2013-03-31	1	15795
56501	3849	1738521	1969-01-23	1969-02-06	1	-329
50374	3432	1112807	1955-01-22	1955-02-05	1	-5444
18835	1293	1125315	2014-10-24	2014-10-31	1	16374
67486	4607	1738521	1975-04-25	1975-05-09	1	1954
11969	823	738818	1970-05-08	1970-05-15	1	134
59416	4049	1112807	1961-07-03	1961-07-17	1	-3090
6573	454	1125315	1961-08-01	1961-08-08	1	-3068
52999	3612	920293	2007-05-06	2007-05-13	1	13646
67979	4639	1729720	1984-05-30	1984-06-10	1	5274
56204	3830	1112807	1985-07-11	1985-07-25	1	5684
14916	1032	1759842	1976-08-25	1976-11-17	1	2512
15898	1100	1125315	2011-11-17	2011-12-08	1	15316
58408	3984	1778162	2004-07-19	2004-08-02	1	12632
15175	1053	1125315	1989-01-21	1989-02-18	1	6988
54688	3720	1112807	1956-12-02	1956-12-16	1	-4764
10816	742	1307863	2008-07-21	2008-07-21	1	14081
25645	1739	1125315	1973-02-14	1973-03-07	1	1161
12273	843	1112807	1983-11-22	1983-12-06	1	5087
13217	905	1177480	1974-06-17	1974-07-01	1	1642
57922	3951	1115008	2011-05-31	2011-07-30	1	15185
16587	1144	1125315	1981-06-10	1981-06-17	1	4185
54967	3739	1115008	2009-08-24	2009-10-23	1	14540
8376	580	1112807	1928-01-01	1928-01-15	1	-15327
77688	5309	1759842	1978-05-19	1978-06-02	1	3074
59992	4090	1112807	1964-03-04	1964-03-25	1	-2108
19006	1306	1125315	1970-03-29	1970-04-05	1	94
54037	3676	738818	1997-03-31	1997-04-14	1	9965
6139	422	1759842	2014-12-06	2015-02-28	1	16494
61612	4205	1729720	1978-03-11	1978-03-18	1	2998
13512	924	19127890	1979-06-16	1980-06-10	1	3813
59589	4064	1118084	1997-12-16	1997-12-16	1	10211
11980	825	1119510	2010-04-13	2010-04-20	1	14719
10318	709	738818	1973-11-24	1973-12-08	1	1437
59846	4080	1125315	2007-01-25	2007-02-01	1	13545
14922	1033	1713332	2013-12-02	2013-12-09	1	16048
64322	4392	1125315	2003-11-27	2003-12-11	1	12397
11823	814	920293	2011-08-13	2011-08-20	1	15206
60227	4106	1112807	1947-06-16	1947-06-30	1	-8221
8534	592	1503184	1985-11-14	1986-11-09	1	6156
47937	3253	1521369	1991-04-09	1993-03-29	2	8488
64377	4395	1713332	1965-11-02	1965-11-23	1	-1500
16959	1169	1332418	2014-09-22	2014-09-22	1	16335
14278	974	1125315	1976-06-14	1976-07-05	1	2377
45556	3092	1729720	1970-07-20	1970-08-01	1	212
11612	795	1557272	2006-11-01	2006-11-01	1	13453
52638	3582	19127890	1977-04-17	1978-04-12	1	3023
13111	895	1717327	1963-12-16	1963-12-30	1	-2194
53545	3644	1112807	1962-03-04	1962-04-03	1	-2830
12518	862	1177480	1977-09-23	1977-10-21	1	2850
56848	3874	1729720	1985-03-08	1985-03-18	1	5555
14725	1017	1112807	1962-12-21	1963-01-11	1	-2547
58254	3973	1713332	1992-11-17	1992-12-08	1	8377
62884	4295	1125315	1999-10-20	1999-10-27	1	10891
17775	1227	1112807	1954-01-12	1954-02-16	1	-5798
52517	3576	1717327	1969-07-28	1969-08-11	1	-143
11499	784	1125315	1991-06-29	1991-07-13	1	7863
10490	720	1503184	1979-08-21	1980-08-15	1	3879
56502	3849	1124300	2003-06-29	2003-06-29	1	12232
50375	3432	1124300	1994-06-16	1994-06-16	1	8932
18836	1293	1729720	1976-07-11	1976-07-22	1	2394
68184	4655	1124300	1990-08-28	1990-08-28	1	7544
11970	823	1102527	2011-07-23	2011-07-23	1	15178
59417	4049	1118084	1997-08-13	1997-08-13	1	10086
6574	454	1125315	1961-09-08	1961-09-22	1	-3023
53000	3612	1102527	1974-04-05	1974-04-05	1	1555
67980	4639	19127890	1988-01-27	1989-01-21	1	6960
56205	3830	1118084	2016-10-22	2016-10-22	1	17096
16708	1150	1125315	1951-12-04	1951-12-18	1	-6589
15899	1100	1759842	2009-05-20	2009-05-27	1	14391
58409	3984	738818	1989-08-31	1989-09-14	1	7196
15176	1053	1125315	2017-05-28	2017-06-04	1	17321
54689	3720	1112807	1968-09-10	1968-12-09	1	-388
10817	742	1713332	1992-03-26	1992-04-02	1	8127
25646	1739	1125315	1985-06-13	1985-06-27	1	5656
12274	843	1515774	2001-04-01	2002-03-27	1	11773
13218	905	1713332	1980-06-24	1980-07-15	1	3848
57923	3951	1125315	1950-01-21	1950-04-21	1	-7195
16588	1144	1125315	1987-10-04	1987-10-11	1	6492
54968	3739	1125315	2005-05-27	2005-06-03	1	12937
8377	580	1112807	1929-06-24	1929-07-08	1	-14787
77689	5309	738818	1954-04-14	1954-04-21	1	-5734
59993	4090	1115008	2011-08-14	2011-08-28	1	15214
19007	1306	1125315	2019-04-11	2019-04-11	1	17997
54038	3676	1119510	1979-10-23	1979-10-30	1	3589
6140	422	19127890	1974-01-01	1974-12-27	1	1821
61613	4205	19127890	1986-01-04	1986-12-30	1	6207
13513	924	19127890	1981-06-05	1982-05-31	1	4533
59590	4064	1125315	2004-02-23	2004-02-23	1	12471
11981	825	1125315	1971-03-12	1971-04-05	2	459
10319	709	1119510	1953-04-14	1953-04-21	1	-6099
59847	4080	1503184	1979-05-29	1980-05-23	1	3795
14923	1033	1729720	1982-03-25	1982-04-02	1	4474
64323	4392	1125315	2004-12-08	2004-12-15	1	12767
11824	814	1118084	2019-05-24	2019-05-24	1	18040
60228	4106	1112807	1960-01-09	1960-02-06	1	-3617
8535	592	1503184	1987-11-04	1988-10-29	1	6876
47938	3253	1713332	1974-03-06	1974-03-20	1	1539
66296	4529	1118084	1997-08-30	1997-08-30	1	10103
16960	1169	1361711	2014-09-22	2018-08-20	1	17763
16427	1134	1112807	1940-09-23	1940-10-07	1	-10678
45557	3092	1759842	2013-07-24	2013-08-14	1	15931
11613	795	1729720	2018-09-09	2018-09-16	1	17790
53316	3630	1125315	1979-05-07	1979-05-07	1	3413
13112	895	1125315	1989-12-28	1990-01-04	1	7308
53546	3644	1124300	1981-10-25	1981-10-25	1	4315
12519	862	1713332	2006-07-28	2006-08-18	1	13378
56849	3874	1729720	2016-06-09	2016-06-16	1	16968
14726	1017	1124300	1997-08-24	1997-08-24	1	10097
58255	3973	1713332	2008-09-08	2008-09-29	1	14151
62885	4295	1125315	2017-03-02	2017-03-09	1	17234
17776	1227	1112807	1961-08-29	1961-11-04	1	-2980
52518	3576	1759842	1995-08-17	1995-08-24	1	9366
11500	784	1125315	1967-11-18	1967-11-25	1	-768
10491	720	920293	1998-09-17	1998-09-24	1	10493
56503	3849	1125315	1983-12-07	1983-12-21	1	5102
50376	3432	1125315	1951-12-10	1951-12-17	1	-6590
18837	1293	1112807	1970-03-18	1970-05-17	1	136
68185	4655	1125315	1982-11-20	1982-12-25	1	4741
11971	823	1115008	2011-07-23	2011-09-21	1	15238
59418	4049	1125315	2017-11-13	2017-11-27	1	17497
6575	454	1125315	1992-12-17	1992-12-31	1	8400
53001	3612	1125315	1993-01-25	1993-02-22	1	8453
67981	4639	19127890	1991-01-11	1994-12-21	4	9120
56206	3830	1738521	1982-07-13	1982-07-27	1	4590
16709	1150	1125315	1983-03-20	1983-04-03	1	4840
15900	1100	1125315	2010-11-15	2010-12-22	1	14965
58410	3984	1125315	1956-08-28	1956-09-11	1	-4860
15177	1053	1521369	1991-01-21	1992-01-16	1	8050
54690	3720	1125315	1957-02-19	1957-03-12	1	-4678
10818	742	1759842	1992-03-26	1992-04-02	1	8127
25647	1739	1177480	2011-09-28	2011-10-19	1	15266
12275	843	1589505	2006-03-06	2007-03-01	1	13573
13219	905	1738521	1972-06-25	1972-07-09	1	920
57924	3951	1713332	1948-04-06	1948-04-27	1	-7919
16589	1144	738818	1992-10-15	1992-10-29	1	8337
54969	3739	1729720	2001-10-28	2001-11-08	1	11634
8378	580	1125315	1991-08-25	1991-09-08	1	7920
77690	5309	1112807	1962-01-22	1962-03-23	1	-2841
59994	4090	1118084	1984-06-30	1984-06-30	1	5294
19008	1306	1503184	1975-07-10	1976-07-04	1	2376
54039	3676	1125315	1978-05-22	1978-05-29	1	3070
6141	422	19127890	1977-12-11	1978-12-06	1	3261
61614	4205	1125315	2003-04-26	2003-05-10	1	12182
13514	924	1115008	2008-03-15	2008-03-29	1	13967
59591	4064	1129625	1963-05-30	1963-05-30	1	-2408
11982	825	1125315	1982-01-31	1982-02-14	1	4427
10320	709	1125315	1961-03-12	1961-03-26	1	-3203
59848	4080	1521369	1979-05-29	1980-05-23	1	3795
14924	1033	1729720	1983-03-31	1983-04-13	1	4850
64324	4392	1500211	1997-07-09	1998-07-04	1	10411
11825	814	1125315	1984-12-18	1985-01-01	1	5479
60229	4106	1125315	1963-01-21	1963-02-04	1	-2523
8536	592	1759842	1995-03-14	1995-03-28	1	9217
47939	3253	19010482	1989-08-17	1989-09-07	1	7189
66297	4529	1149380	1988-12-04	1988-12-04	1	6912
16961	1169	1713332	1980-11-23	1980-11-30	1	3986
16428	1134	1125315	1955-06-08	1955-06-22	1	-5307
45558	3092	914335	1995-09-20	1995-09-20	1	9393
11614	795	738818	1987-07-23	1987-07-30	1	6419
53317	3630	1112807	1979-05-07	1979-08-05	1	3503
13113	895	1713332	2003-09-22	2003-10-13	1	12338
53547	3644	1125315	1977-09-11	1977-10-02	1	2831
12520	862	1729720	1972-05-23	1972-06-02	1	883
59077	4024	738818	2006-04-29	2006-05-13	1	13281
14727	1017	1125315	2007-02-09	2007-02-16	1	13560
58256	3973	1759842	1992-11-17	1992-12-08	1	8377
62886	4295	1177480	1975-10-01	1975-10-15	1	2113
17777	1227	1125315	1965-03-07	1965-03-14	1	-1754
52519	3576	19127890	1985-12-11	1986-12-06	1	6183
11501	784	1713332	2008-02-10	2008-03-02	1	13940
10492	720	1118084	2000-09-04	2000-09-04	1	11204
56504	3849	1177480	2009-10-09	2009-11-13	1	14561
50377	3432	1125315	1967-05-10	1967-08-08	1	-877
18838	1293	1125315	2016-09-12	2016-12-11	1	17146
68186	4655	920293	2016-01-12	2016-01-19	1	16819
11972	823	1125315	1964-08-08	1964-08-22	1	-1958
59419	4049	1305058	1991-03-28	1995-05-06	1	9256
6576	454	1125315	1999-02-06	1999-02-20	1	10642
53002	3612	1125315	1994-06-21	1994-07-05	1	8951
67982	4639	1112807	1975-07-24	1975-08-07	1	2044
56207	3830	1778162	1985-07-11	1985-07-25	1	5684
16710	1150	1125315	1992-03-16	1992-04-13	1	8138
15901	1100	1177480	1995-04-24	1995-05-08	1	9258
58411	3984	1125315	1989-08-31	1989-09-14	1	7196
15178	1053	1713332	1981-06-12	1981-06-26	1	4194
54691	3720	1125315	1957-11-17	1957-11-24	1	-4421
11933	821	1125315	1968-08-08	1968-08-15	1	-504
25648	1739	1713332	2017-01-19	2017-02-02	1	17199
12276	843	1595799	2009-02-18	2010-02-13	1	14653
13220	905	1759842	1980-06-24	1980-07-15	1	3848
57925	3951	1713332	2004-04-24	2004-05-15	1	12553
16590	1144	1125315	1971-03-04	1971-03-18	1	441
54970	3739	1729720	2014-12-15	2014-12-27	1	16431
8379	580	1125315	2017-04-29	2017-05-13	1	17299
77691	5309	1125315	1954-04-14	1954-04-21	1	-5734
59995	4090	1539403	2015-08-03	2015-08-03	1	16650
19009	1306	1729720	1959-05-28	1959-06-07	1	-3861
54040	3676	1125315	1997-03-31	1997-04-14	1	9965
6142	422	1112807	1967-01-28	1967-04-28	1	-979
61615	4205	1503184	1986-01-04	1986-12-30	1	6207
13515	924	1738521	1969-06-28	1969-07-12	1	-173
59592	4064	1503184	1977-04-20	1978-04-15	1	3026
11983	825	738818	1988-02-06	1988-02-13	1	6617
10321	709	1125315	1973-11-24	1973-12-08	1	1437
59849	4080	1521369	1982-05-13	1983-05-08	1	4875
14925	1033	1759842	2013-12-02	2013-12-09	1	16048
64325	4392	1521369	1996-07-14	1997-07-09	1	10051
11826	814	1713332	1994-03-17	1994-03-24	1	8848
60230	4106	1125315	1985-10-25	1985-11-01	1	5783
8537	592	1125315	1975-08-01	1975-08-08	1	2045
47940	3253	975125	2001-03-10	2001-03-31	1	11412
66298	4529	1521369	1984-10-10	1985-10-05	1	5756
16962	1169	1738521	1971-05-18	1971-06-22	1	537
16429	1134	1125315	1999-06-16	1999-07-16	2	10788
45559	3092	1112807	1955-10-25	1955-11-08	1	-5168
11615	795	738818	1988-06-08	1988-06-15	1	6740
53318	3630	1124300	1992-05-23	1992-05-23	1	8178
13114	895	1729720	2011-10-15	2011-10-24	1	15271
53548	3644	1729720	1947-11-21	1947-12-01	1	-8067
12521	862	1729720	1980-10-14	1980-10-23	1	3948
59078	4024	1119510	2006-04-29	2006-05-13	1	13281
14728	1017	1125315	1971-03-11	1971-03-18	1	441
58257	3973	1759842	2008-09-08	2008-09-29	1	14151
62887	4295	1738521	1976-12-25	1977-01-08	1	2564
17778	1227	1125315	1981-02-22	1981-04-23	1	4130
52520	3576	1125315	1967-11-08	1967-11-22	1	-771
11502	784	1729720	1972-09-03	1972-09-11	1	984
10493	720	1125315	1975-05-04	1975-05-25	1	1970
56505	3849	1729720	1968-04-13	1968-04-21	1	-620
50378	3432	1177480	2007-09-10	2007-11-09	1	13826
18839	1293	1154343	1942-01-01	1942-01-01	1	-10227
68187	4655	1125315	1965-04-11	1965-05-02	1	-1705
11973	823	1125315	1970-05-08	1970-05-15	1	134
59420	4049	1713332	2003-11-30	2003-12-14	1	12400
6577	454	1326303	2005-03-05	2005-03-05	1	12847
53003	3612	1125315	1995-05-15	1995-05-22	1	9272
67983	4639	1125315	1994-07-15	1994-07-29	1	8975
56208	3830	1125315	1982-07-13	1982-07-27	1	4590
16711	1150	1713332	1998-06-20	1998-07-11	1	10418
17970	1238	1112807	1957-10-28	1957-11-11	1	-4434
58412	3984	1125315	2004-07-19	2004-08-02	1	12632
15179	1053	1728416	1978-08-31	1978-09-14	1	3178
54692	3720	1125315	1967-01-07	1967-01-14	1	-1083
11934	821	1125315	1969-08-12	1969-09-02	1	-121
25649	1739	1759842	1970-11-17	1970-11-24	1	327
12277	843	19127890	2001-04-01	2002-03-27	1	11773
13221	905	19127890	1988-08-17	1989-08-12	1	7163
57926	3951	1102527	2011-05-31	2011-05-31	1	15125
16591	1144	1125315	1992-10-15	1992-10-29	1	8337
54971	3739	19127890	1984-08-02	1985-07-28	1	5687
9896	680	738818	1989-03-19	1989-04-02	1	7031
77692	5309	1125315	1986-04-21	1986-05-05	1	5968
59996	4090	1713332	1968-09-01	1968-09-22	1	-466
19010	1306	1112807	1967-02-03	1967-05-04	1	-973
54041	3676	1125315	2005-07-07	2005-07-21	1	12985
6143	422	1125315	1976-12-08	1976-12-22	1	2547
61616	4205	1759842	1982-11-16	1982-12-07	1	4723
13516	924	1118084	2004-10-07	2004-10-07	1	12698
59593	4064	19010482	1985-12-08	1985-12-22	1	5834
11984	825	738818	1997-09-22	1997-09-29	1	10133
10322	709	1125315	1977-09-16	1977-09-23	1	2822
59850	4080	1118084	2002-10-10	2002-10-10	1	11970
14926	1033	1115008	1995-02-05	1995-03-05	1	9194
64326	4392	1713332	2016-12-14	2017-01-04	1	17170
11827	814	1759842	1994-03-17	1994-03-24	1	8848
60231	4106	1729720	1944-07-05	1944-07-17	1	-9299
8538	592	1515774	1990-10-19	1991-10-14	1	7956
47941	3253	975125	2005-04-15	2005-05-06	1	12909
66299	4529	1729720	1993-07-14	1993-07-21	1	8602
16963	1169	1759842	1956-09-15	1956-10-06	1	-4835
16430	1134	1124300	1978-09-09	1978-09-09	1	3173
45560	3092	1125315	2011-07-31	2011-08-21	1	15207
11616	795	920293	1979-11-01	1979-11-08	1	3598
53319	3630	1125315	1964-06-25	1964-07-09	1	-2002
13115	895	1759842	2003-09-22	2003-10-13	1	12338
53549	3644	1125315	1965-09-05	1965-09-12	1	-1572
12522	862	1125315	1973-09-16	1973-09-30	1	1368
59079	4024	1125315	2006-04-29	2006-05-13	1	13281
14729	1017	1738521	1976-10-25	1976-11-08	1	2503
58258	3973	1125315	2009-05-19	2009-06-16	1	14411
62888	4295	1759842	1975-10-09	1975-10-30	1	2128
17779	1227	1326303	2016-04-06	2016-04-06	1	16897
52521	3576	1125315	1978-12-26	1979-01-02	1	3288
11503	784	1759842	2008-02-10	2008-03-02	1	13940
10494	720	1729720	2001-09-13	2001-09-23	1	11588
56506	3849	19127890	1981-11-03	1982-10-29	1	4684
50379	3432	1112807	1974-12-29	1975-01-26	1	1851
18840	1293	1322184	2010-02-23	2010-02-23	1	14663
68188	4655	1125315	1998-06-14	1998-06-28	1	10405
11974	823	1125315	2013-07-12	2013-09-10	1	15958
59421	4049	1759842	2003-11-30	2003-12-14	1	12400
6578	454	1713332	1969-11-29	1969-12-06	1	-26
53004	3612	1177480	1974-04-05	1974-06-04	1	1615
67984	4639	1112807	1973-03-06	1973-04-03	1	1188
56209	3830	1759842	1986-12-25	1987-01-01	1	6209
16712	1150	1713332	2014-05-07	2014-05-21	1	16211
17971	1238	1118084	1997-09-13	1997-09-13	1	10117
58413	3984	1177480	2018-07-21	2018-08-20	1	17763
15180	1053	1738521	1976-06-28	1976-07-12	1	2384
54693	3720	1125315	1979-01-16	1979-02-15	1	3332
11935	821	1125315	2008-11-15	2008-11-29	1	14212
25650	1739	1759842	2017-01-19	2017-02-02	1	17199
12278	843	1118084	2017-09-04	2017-09-04	1	17413
13222	905	723013	1974-09-20	1975-02-28	1	1884
57927	3951	1125315	1997-12-11	1997-12-25	1	10220
16592	1144	1125315	2003-01-04	2003-02-03	1	12086
54972	3739	1102527	2006-06-11	2006-06-11	1	13310
9897	680	1112807	1968-08-20	1968-09-03	1	-485
77693	5309	1322184	1997-05-05	1997-05-05	1	9986
59997	4090	914335	2015-03-23	2015-03-23	1	16517
19011	1306	1118084	2001-01-14	2001-01-14	1	11336
54042	3676	1503184	1991-10-03	1992-09-27	1	8305
6144	422	1503184	1974-01-01	1974-12-27	1	1821
61617	4205	1713332	1982-11-16	1982-12-07	1	4723
13517	924	1503184	1979-06-16	1980-06-10	1	3813
59594	4064	738818	1984-11-01	1984-11-08	1	5425
11985	825	1112807	1972-08-13	1972-08-27	1	969
10323	709	1332418	1999-07-04	1999-07-04	1	10776
59851	4080	1119510	1985-01-19	1985-02-02	1	5511
14927	1033	1125315	1977-03-06	1977-04-10	1	2656
64327	4392	1759842	2016-12-14	2017-01-04	1	17170
11828	814	19127890	1995-07-04	1996-06-28	1	9675
60232	4106	1118084	1984-02-07	1984-02-07	1	5150
8539	592	1521369	1985-11-14	1986-11-09	1	6156
47942	3253	1154343	1974-05-25	1974-05-25	1	1605
66300	4529	1115008	1998-09-28	1998-11-04	1	10534
16964	1169	1759842	1980-11-23	1980-11-30	1	3986
16431	1134	1125315	1966-08-01	1966-08-15	1	-1235
45561	3092	1309944	1995-09-20	1995-09-20	1	9393
11617	795	933724	1979-11-01	1979-11-08	1	3598
53320	3630	1125315	1986-06-29	1986-07-13	1	6037
13116	895	1112807	1962-11-21	1962-12-05	1	-2584
53550	3644	1759842	1962-04-08	1962-04-22	1	-2811
12523	862	1729720	1981-02-24	1981-03-05	1	4081
59080	4024	1549786	1997-12-29	1998-12-24	1	10584
14730	1017	1759842	2018-05-09	2018-05-30	1	17681
58259	3973	1307863	2018-08-30	2018-08-30	1	17773
62889	4295	738818	1992-06-18	1992-07-02	1	8218
17780	1227	1361711	2013-03-20	2013-03-20	1	15784
52522	3576	1125315	1991-04-04	1991-04-25	1	7784
12693	870	738818	1979-05-19	1979-05-26	1	3432
10495	720	19127890	1979-08-21	1980-08-15	1	3879
58142	3967	920293	2000-06-03	2000-06-10	1	11118
50380	3432	1125315	1992-07-16	1992-07-30	1	8246
18841	1293	1332418	2010-02-23	2010-02-23	1	14663
68189	4655	1177480	1980-01-14	1980-02-04	1	3686
14395	987	738818	1991-10-01	1991-10-15	1	7957
61456	4197	1112807	1986-06-20	1986-07-04	1	6028
6579	454	1759842	1953-07-05	1953-07-19	1	-6010
53005	3612	738818	1982-06-24	1982-07-08	1	4571
67985	4639	1118084	2004-07-01	2004-07-01	1	12600
56210	3830	1759842	2007-07-21	2007-08-11	1	13736
16713	1150	1729720	1959-08-25	1959-09-02	1	-3774
17972	1238	1125315	1985-07-10	1985-08-14	1	5704
58414	3984	1713332	1963-06-12	1963-07-03	1	-2374
15181	1053	933724	2018-04-11	2018-04-18	1	17639
54694	3720	1713332	1999-07-19	1999-08-09	1	10812
11936	821	1728416	1951-08-26	1951-09-09	1	-6689
25651	1739	1112807	1972-04-20	1972-05-04	1	854
12279	843	1125315	1983-07-26	1983-08-02	1	4961
13223	905	1112807	1972-02-03	1972-02-17	1	777
57928	3951	1728416	1946-03-13	1946-03-27	1	-8681
16593	1144	1125315	2006-03-31	2006-04-14	1	13252
54973	3739	1521369	1984-08-02	1985-07-28	1	5687
9898	680	1112807	1971-03-22	1971-04-05	1	459
40101	2724	1112807	1959-11-23	1959-12-28	1	-3657
59998	4090	1112807	1968-01-04	1968-02-01	1	-700
19012	1306	1125315	1971-04-02	1971-04-09	1	463
54043	3676	1521369	1991-10-03	1992-09-27	1	8305
6145	422	1503184	1977-12-11	1978-12-06	1	3261
61618	4205	1396131	1995-01-02	1995-01-02	1	9132
13518	924	1503184	1981-06-05	1982-05-31	1	4533
59595	4064	975125	1988-08-09	1988-08-30	1	6816
11986	825	1118084	2011-02-14	2011-02-14	1	15019
10324	709	1539403	1999-07-04	1999-07-04	1	10776
59852	4080	1503184	1982-05-13	1983-05-08	1	4875
14928	1033	1308738	1999-07-29	1999-07-29	1	10801
64328	4392	19127890	1996-07-14	1997-07-09	1	10051
11829	814	19127890	1997-06-23	1998-06-18	1	10395
60233	4106	1728416	1947-06-16	1947-06-30	1	-8221
8540	592	1521369	1987-11-04	1988-10-29	1	6876
47943	3253	1192710	1972-06-08	1972-06-08	1	889
66301	4529	1124957	1998-10-05	1998-10-05	1	10504
16965	1169	1112807	1971-05-18	1971-06-22	1	537
16432	1134	1174888	1999-06-16	1999-06-16	1	10758
45562	3092	1343916	1995-09-20	1995-09-20	1	9393
11618	795	1118084	1982-08-23	1982-08-23	1	4617
53321	3630	1177480	2009-02-12	2009-03-14	1	14317
13117	895	1112807	1971-11-18	1971-12-02	1	700
53551	3644	1112807	1948-11-12	1948-11-26	1	-7706
12524	862	1115008	1994-02-24	1994-03-26	1	8850
59081	4024	1713332	1997-09-29	1997-10-20	1	10154
14731	1017	1125315	1976-10-25	1976-11-08	1	2503
58260	3973	1326303	2018-08-30	2018-08-30	1	17773
62890	4295	1125315	1992-06-18	1992-07-02	1	8218
17781	1227	1713332	2019-04-27	2019-05-04	1	18020
52523	3576	1125315	1994-11-19	1994-11-26	1	9095
12694	870	1112807	1978-02-01	1978-02-15	1	2967
11270	771	1521369	1978-11-05	1979-10-31	1	3590
58143	3967	920293	2004-07-16	2004-07-23	1	12622
50381	3432	1125315	1994-12-01	1994-12-08	1	9107
18842	1293	1539403	2010-02-23	2010-02-23	1	14663
68190	4655	1177480	2006-10-03	2006-10-17	1	13438
14396	987	1125315	1991-10-01	1991-10-15	1	7957
61457	4197	1118084	2017-04-30	2017-04-30	1	17286
6580	454	738818	1959-06-04	1959-06-11	1	-3857
53006	3612	738818	2000-04-30	2000-05-14	1	11091
67986	4639	1125315	2004-10-09	2004-10-23	1	12714
56211	3830	1177480	2005-08-11	2005-09-15	1	13041
16714	1150	1759842	2011-11-12	2011-11-19	1	15297
17973	1238	1729720	2002-05-05	2002-05-16	1	11823
58415	3984	1728416	1956-08-28	1956-09-11	1	-4860
15182	1053	1125315	1978-08-19	1978-09-14	2	3178
54695	3720	1728416	1954-07-05	1954-07-19	1	-5645
11937	821	738818	1953-07-18	1953-07-25	1	-6004
25652	1739	1119510	1985-06-13	1985-06-27	1	5656
12280	843	1521369	2009-02-18	2010-02-13	1	14653
13224	905	1115008	2019-03-29	2019-04-26	1	18012
57929	3951	1759842	2004-04-24	2004-05-15	1	12553
16594	1144	1729720	1975-03-14	1975-03-23	1	1907
54974	3739	1112807	1968-09-07	1968-09-28	1	-460
9899	680	1118084	2002-10-01	2002-10-01	1	11961
40102	2724	1729720	1957-01-24	1957-02-01	1	-4717
59999	4090	1125315	1957-03-11	1957-06-09	1	-4589
19013	1306	1125315	1980-06-29	1980-07-13	1	3846
54044	3676	1521369	1993-09-22	1994-09-17	1	9025
6146	422	1557272	2019-04-27	2019-04-27	1	18013
61619	4205	1521369	1986-01-04	1986-12-30	1	6207
13519	924	1759842	1971-04-08	1971-04-22	1	476
59596	4064	1125315	1990-01-02	1990-01-16	1	7320
11987	825	1125315	1972-04-15	1972-04-29	1	849
10325	709	1713332	1991-11-17	1991-12-08	1	8011
59853	4080	19127890	1986-04-22	1987-04-17	1	6315
14929	1033	1125315	1974-07-22	1974-08-05	1	1677
64329	4392	1115008	1997-07-27	1997-08-10	1	10083
11830	814	933724	2011-08-13	2011-08-20	1	15206
60234	4106	1112807	1966-02-18	1966-03-18	1	-1385
8541	592	1713332	1993-08-30	1993-09-13	1	8656
47944	3253	1729720	1972-04-09	1972-04-22	1	842
66302	4529	1521369	1986-09-30	1987-09-25	1	6476
16966	1169	1125315	1980-02-05	1980-03-11	1	3722
16433	1134	1115008	2013-07-02	2013-08-01	1	15918
45563	3092	1717327	1961-01-07	1961-01-21	1	-3267
11619	795	1119510	1978-02-20	1978-02-27	1	2979
53322	3630	1112807	1956-06-06	1956-06-20	1	-4943
13118	895	1118084	2005-12-10	2005-12-10	1	13127
53552	3644	1119510	1961-02-05	1961-02-19	1	-3238
12525	862	1119510	1997-06-29	1997-07-06	1	10048
59082	4024	1729720	1989-08-04	1989-08-11	1	7162
14732	1017	1125315	1984-10-17	1984-11-07	1	5424
58261	3973	1112807	1979-06-28	1979-07-12	1	3479
62891	4295	1759842	1997-08-17	1997-08-31	1	10104
17782	1227	1112807	1943-03-27	1943-05-26	1	-9717
53195	3624	738818	1957-03-10	1957-03-17	1	-4673
12695	870	1125315	1965-12-01	1965-12-15	1	-1478
11271	771	738818	1965-04-08	1965-04-15	1	-1722
58144	3967	1112807	1966-01-30	1966-02-20	1	-1411
50382	3432	1728416	1955-01-22	1955-02-05	1	-5444
18843	1293	1713332	1971-12-15	1971-12-29	1	727
68191	4655	1177480	2009-04-28	2009-05-12	1	14376
14397	987	1125315	2003-03-18	2003-03-25	1	12136
61458	4197	1521369	1999-09-12	2001-09-01	2	11566
6581	454	920293	1954-03-24	1954-03-31	1	-5755
53007	3612	920293	2004-01-08	2004-01-15	1	12432
67987	4639	1521369	1988-01-27	1989-01-21	1	6960
56212	3830	1713332	2008-07-26	2008-08-09	1	14100
16715	1150	1118084	1991-10-14	1991-10-14	1	7956
17974	1238	1102527	1982-08-25	1982-08-25	1	4619
58416	3984	1118084	1995-02-01	1995-02-01	1	9162
15183	1053	1503184	1991-01-21	1992-01-16	1	8050
54696	3720	1759842	1971-12-11	1971-12-25	1	723
11938	821	1119510	1968-08-08	1968-08-15	1	-504
25653	1739	1125315	1999-10-14	1999-10-28	1	10892
12281	843	1549786	2006-03-06	2007-03-01	1	13573
13225	905	1125315	1973-01-30	1973-02-13	1	1139
57930	3951	1125315	2014-03-09	2014-03-16	1	16145
18151	1250	1112807	1955-03-13	1955-06-11	1	-5318
54975	3739	1124300	2007-02-15	2007-02-15	1	13559
9900	680	1119510	2001-03-01	2001-03-15	1	11396
40103	2724	1759842	1985-01-01	1985-01-15	1	5493
60000	4090	1309944	2015-03-23	2015-03-23	1	16517
19014	1306	1125315	1983-05-16	1983-05-30	1	4897
54045	3676	1549786	1990-10-08	1991-10-03	1	7945
6147	422	1729720	2009-07-02	2009-07-11	1	14436
61620	4205	1713332	2000-12-26	2001-01-16	1	11338
13520	924	1102527	1977-02-15	1977-02-15	1	2602
59597	4064	1551099	1961-10-01	1961-10-01	1	-3014
11988	825	1125315	1984-07-30	1984-08-13	1	5338
10326	709	1728416	1949-10-01	1949-10-15	1	-7383
63840	4365	723013	1982-11-24	1983-04-06	1	4843
14930	1033	1521369	1988-07-16	1989-07-11	1	7131
64330	4392	1124957	2005-09-18	2005-09-18	1	13044
11831	814	1503184	1995-07-04	1996-06-28	1	9675
60235	4106	1728416	1949-01-01	1949-01-15	1	-7656
8542	592	1729720	1975-11-29	1975-12-09	1	2168
47945	3253	19127890	1991-04-09	1993-03-29	2	8488
66303	4529	1729720	1970-03-26	1970-04-05	1	94
16967	1169	1125315	1982-01-30	1982-02-13	1	4426
16434	1134	1112807	1942-02-04	1942-02-18	1	-10179
45564	3092	1125315	1982-04-27	1982-05-04	1	4506
11620	795	1125315	1988-06-08	1988-06-15	1	6740
53323	3630	1728416	1959-04-06	1959-04-20	1	-3909
13119	895	1729720	2007-08-11	2007-08-22	1	13747
53553	3644	1125315	1956-08-03	1956-08-17	1	-4885
12526	862	1759842	2006-07-28	2006-08-18	1	13378
59083	4024	1759842	1997-09-29	1997-10-20	1	10154
14733	1017	1728416	1960-01-06	1960-01-20	1	-3634
58262	3973	1125315	1970-05-16	1970-05-30	1	149
63963	4372	933724	2013-07-04	2013-07-11	1	15897
17783	1227	1112807	1946-04-10	1946-07-09	1	-8577
53196	3624	1112807	1963-11-30	1963-12-14	1	-2210
12696	870	1125315	1979-05-19	1979-05-26	1	3432
11272	771	1125315	1965-04-08	1965-04-15	1	-1722
58145	3967	1125315	1965-09-02	1965-09-16	1	-1568
52407	3570	1112807	1961-10-03	1961-12-02	1	-2952
18844	1293	1713332	1993-06-21	1993-06-28	1	8579
68192	4655	1551099	1963-05-22	1963-05-22	1	-2416
14398	987	1713332	1972-08-09	1972-08-16	1	958
61459	4197	1549786	1999-09-12	2000-09-06	1	11206
6582	454	933724	1954-03-24	1954-03-31	1	-5755
53008	3612	920293	2008-06-27	2008-07-11	2	14071
67988	4639	1521369	1993-12-26	1994-12-21	1	9120
60238	4107	1125315	1971-04-09	1971-04-23	1	477
16716	1150	1125315	2008-08-17	2008-09-14	1	14136
17975	1238	1125315	2004-06-05	2004-09-03	1	12664
58417	3984	1119510	1989-08-31	1989-09-14	1	7196
15184	1053	1515774	1990-01-26	1991-01-21	1	7690
54697	3720	1118084	1990-06-11	1990-06-11	1	7466
11939	821	1125315	1953-07-18	1953-07-25	1	-6004
25654	1739	738818	1985-06-13	1985-06-27	1	5656
12282	843	1729720	1984-02-24	1984-03-05	1	5177
13226	905	1125315	2018-09-22	2018-09-29	1	17803
57931	3951	1177480	2006-04-18	2006-05-02	1	13270
18152	1250	1124300	1991-08-01	1991-08-01	1	7882
54976	3739	1729720	2000-09-19	2000-10-01	1	11231
9901	680	1125315	1987-08-09	1987-08-23	1	6443
40785	2770	738818	1996-04-07	1996-04-14	1	9600
60001	4090	1310149	2017-08-14	2017-08-14	1	17392
19015	1306	1521369	1975-07-10	1976-07-04	1	2376
54046	3676	914335	1997-02-13	1997-02-13	1	9905
6148	422	1768849	1983-01-04	1983-01-18	1	4765
61621	4205	1759842	2000-12-26	2001-01-16	1	11338
13521	924	1125315	1968-02-04	1968-02-11	1	-690
59598	4064	1551099	1966-02-08	1966-02-08	1	-1423
11989	825	1125315	1988-02-06	1988-02-13	1	6617
10327	709	1759842	1986-04-24	1986-05-08	1	5971
63841	4365	1119510	1989-08-27	1989-09-03	1	7185
16728	1151	1125315	1987-12-19	1988-01-02	1	6575
64331	4392	1125315	2017-02-22	2017-03-01	1	17226
11832	814	1503184	1997-06-23	1998-06-18	1	10395
60236	4106	1112807	1949-01-01	1949-01-15	1	-7656
8543	592	1759842	1993-08-30	1993-09-13	1	8656
47946	3253	975125	1989-08-17	1989-09-07	1	7189
66304	4529	920293	1993-12-22	1993-12-29	1	8763
16968	1169	1125315	2018-08-20	2018-08-20	1	17763
16435	1134	1112807	1947-07-19	1947-08-18	1	-8172
45565	3092	1112807	1961-01-07	1961-01-21	1	-3267
11621	795	1729720	1950-05-25	1950-06-05	1	-7150
53324	3630	1729720	1965-05-30	1965-06-07	1	-1669
13347	915	1112807	1971-10-11	1971-10-25	1	662
53554	3644	1125315	1975-05-29	1975-06-12	1	1988
12527	862	738818	1997-06-29	1997-07-06	1	10048
59084	4024	1125315	2005-07-10	2005-08-07	1	13002
14734	1017	1759842	1970-01-21	1970-01-28	1	27
58263	3973	1125315	1973-04-14	1973-04-28	1	1213
63964	4372	1125315	1987-07-11	1987-07-25	1	6414
17784	1227	1112807	1949-05-24	1949-06-07	1	-7513
53197	3624	1713332	1989-06-23	1989-07-07	1	7127
12697	870	1125315	2008-03-10	2008-03-24	1	13962
11273	771	1125315	1975-12-13	1976-03-12	1	2262
58146	3967	1125315	1980-01-18	1980-01-25	1	3676
52408	3570	1112807	1966-12-06	1966-12-27	1	-1101
18845	1293	1759842	1993-06-21	1993-06-28	1	8579
68193	4655	1729720	1970-03-27	1970-04-06	1	95
14399	987	1728416	1954-06-26	1954-07-10	1	-5654
61460	4197	1713332	1988-06-14	1988-06-28	1	6753
6583	454	1118084	1970-09-09	1970-09-09	1	251
53009	3612	933724	2004-03-15	2004-03-22	1	12499
69054	4713	738818	1978-09-02	1978-09-16	1	3180
60239	4107	1717327	1971-04-09	1971-04-23	1	477
16717	1150	1125315	2010-09-04	2010-10-09	1	14891
17976	1238	1125315	1982-08-18	1982-09-24	1	4649
58418	3984	1125315	1955-12-13	1955-12-27	1	-5119
15185	1053	1549786	1990-01-26	1991-01-21	1	7690
54698	3720	1125315	1996-09-13	1996-09-27	1	9766
11940	821	1125315	1967-02-22	1967-03-08	1	-1030
25655	1739	1177480	2016-08-23	2016-09-27	1	17071
12283	843	1768849	1984-11-03	1984-11-17	1	5434
13227	905	1503184	1988-08-17	1989-08-12	1	7163
57932	3951	1759842	1948-04-06	1948-04-27	1	-7919
18153	1250	1713332	1988-03-15	1988-04-05	1	6669
54977	3739	19127890	1986-07-23	1987-07-18	1	6407
9902	680	1125315	1989-03-19	1989-04-02	1	7031
40786	2770	1125315	1952-01-28	1952-02-11	1	-6534
60002	4090	1343916	2015-03-23	2015-03-23	1	16517
19016	1306	920293	2008-10-17	2008-10-31	2	14183
54047	3676	1112807	1973-07-29	1973-08-28	1	1335
6149	422	920293	1982-01-31	1982-02-07	1	4420
61909	4225	1112807	1983-04-28	1983-05-12	1	4879
13522	924	1125315	1977-02-15	1977-03-08	1	2623
59599	4064	1729720	1972-11-30	1972-12-11	1	1075
11990	825	1738521	1971-03-22	1971-04-05	1	459
10328	709	1759842	1993-03-08	1993-03-29	1	8488
63842	4365	1125315	1976-03-12	1976-03-26	1	2276
16729	1151	1125315	1990-04-17	1990-05-01	1	7425
64332	4392	1503184	1996-07-14	1997-07-09	1	10051
11833	814	1125315	1995-12-21	1996-03-20	1	9575
60237	4106	1125315	1991-06-05	1991-06-12	1	7832
10177	700	1118084	2014-12-27	2014-12-27	1	16431
47947	3253	1102527	2012-02-08	2012-02-08	1	15378
66305	4529	1112807	1985-04-25	1985-05-09	1	5607
16969	1169	1125315	1944-04-13	1944-04-20	1	-9387
16436	1134	1729720	1940-07-26	1940-08-05	1	-10741
45566	3092	1125315	1965-08-05	1965-08-12	1	-1603
12808	877	1125315	1984-01-27	1984-02-10	1	5153
53325	3630	1112807	1959-04-06	1959-04-20	1	-3909
13348	915	1118084	1995-08-04	1995-08-04	1	9346
53555	3644	1125315	1979-09-22	1979-10-06	1	3565
12528	862	1102527	1986-06-06	1986-06-06	1	6000
59085	4024	1137529	2006-05-07	2006-05-07	1	13275
16082	1113	920293	2007-12-07	2007-12-14	1	13861
58264	3973	1125315	1984-09-01	1984-09-08	1	5364
63965	4372	1125315	2012-10-13	2012-10-20	1	15633
17785	1227	1115008	2004-05-22	2004-07-21	1	12620
53198	3624	1728416	1946-12-31	1947-01-14	1	-8388
12698	870	1521369	1986-09-27	1989-09-11	3	7193
11274	771	1521369	1980-10-25	1981-10-20	1	4310
58147	3967	1125315	2009-07-23	2009-08-06	1	14462
52409	3570	1118084	1988-06-08	1988-06-08	1	6733
18846	1293	1118084	1979-07-09	1979-07-09	1	3476
68194	4655	723013	1984-02-19	1984-09-23	1	5379
14400	987	1729720	1999-09-17	1999-09-28	1	10862
61461	4197	1713332	1990-10-10	1990-10-24	1	7601
6584	454	1125315	1959-06-04	1959-06-11	1	-3857
53010	3612	933724	2007-05-06	2007-05-13	1	13646
69055	4713	1125315	1970-11-12	1971-01-11	2	359
60240	4107	1729720	1987-04-18	1987-05-01	1	6329
16718	1150	1112807	1953-12-22	1954-02-20	1	-5794
18719	1285	1124957	1989-08-20	1989-08-20	1	7171
58419	3984	1125315	1957-05-07	1957-05-21	1	-4608
15186	1053	1729720	1985-03-25	1985-04-02	1	5570
54699	3720	1125315	2010-10-04	2010-10-11	1	14893
11941	821	1759842	1955-01-15	1955-01-22	1	-5458
25656	1739	1713332	1970-11-17	1970-11-24	1	327
12284	843	19127890	1997-04-22	1998-04-17	1	10333
13228	905	1713332	1989-01-16	1989-01-30	1	6969
59892	4085	738818	2006-08-25	2006-09-01	1	13392
18154	1250	1713332	1993-02-13	1993-03-06	1	8465
63606	4348	1115008	1995-11-07	1995-11-28	1	9462
9903	680	1729720	1991-06-20	1991-07-01	1	7851
40787	2770	1125315	1996-04-07	1996-04-14	1	9600
60003	4090	1759842	1968-09-01	1968-09-22	1	-466
19017	1306	933724	2006-09-10	2006-09-17	1	13408
54048	3676	1119510	1997-03-31	1997-04-14	1	9965
6150	422	920293	1984-03-18	1984-04-01	2	5204
61910	4225	1125315	1983-11-11	1983-11-18	1	5069
13523	924	1177480	2013-09-29	2013-12-27	1	16066
59600	4064	1124957	2004-02-23	2004-02-23	1	12471
11991	825	738818	2010-04-13	2010-04-20	1	14719
10329	709	1112807	1949-10-01	1949-10-15	1	-7383
63843	4365	1310149	2001-07-23	2001-07-23	1	11526
16730	1151	1125315	2000-01-15	2000-01-22	1	10978
65067	4446	1112807	1963-04-14	1963-04-28	1	-2440
11834	814	1125315	2003-04-15	2003-04-22	1	12164
61835	4220	1119510	1986-03-09	1986-03-23	1	5925
10178	700	1515774	1995-05-26	1996-05-20	1	9636
47948	3253	1115008	2012-02-08	2012-03-09	1	15408
66306	4529	1125315	1998-10-05	1998-10-05	1	10504
16970	1169	1174888	2018-08-20	2018-08-20	1	17763
16437	1134	1729720	1948-01-30	1948-02-06	1	-8000
45567	3092	1125315	2007-06-08	2007-06-22	1	13686
12809	877	1125315	1992-05-28	1992-06-11	1	8197
53326	3630	1124957	1979-05-07	1979-05-07	1	3413
13349	915	1177480	2018-03-19	2018-04-02	1	17623
53556	3644	1713332	1962-04-08	1962-04-22	1	-2811
12529	862	1124300	2004-08-07	2004-08-07	1	12637
59086	4024	1500211	1995-01-14	1996-01-09	1	9504
16083	1113	933724	2007-12-07	2007-12-14	1	13861
58265	3973	1125315	1996-11-15	1996-11-29	1	9829
63966	4372	1125315	2019-06-04	2019-06-25	1	18072
17786	1227	1115008	2017-09-11	2017-10-11	1	17450
53199	3624	1728416	1948-08-04	1948-08-18	1	-7806
12699	870	1125315	1979-02-10	1979-03-17	1	3362
11275	771	1759842	1968-01-18	1968-01-25	1	-707
58148	3967	1125315	2018-06-17	2018-07-01	1	17713
52410	3570	1119510	1963-11-19	1963-11-26	1	-2228
18847	1293	1361711	2010-02-23	2010-02-23	1	14663
68195	4655	738818	1998-06-14	1998-06-28	1	10405
14401	987	19127890	1974-07-21	1975-07-16	1	2022
61462	4197	1102527	2009-12-15	2009-12-15	1	14593
6585	454	1713332	1951-06-30	1951-07-07	1	-6753
53011	3612	1125315	1982-06-24	1982-07-08	1	4571
69056	4713	1125315	1978-09-02	1978-09-16	1	3180
60241	4107	1112807	1972-01-12	1972-01-26	1	755
16719	1150	1125315	2007-11-30	2007-12-14	1	13861
18720	1285	1125315	1989-08-20	1989-09-10	2	7192
58420	3984	1125315	1965-05-23	1965-05-30	1	-1677
16371	1131	1112807	1966-04-08	1966-04-22	1	-1350
54700	3720	1713332	1971-12-11	1971-12-25	1	723
11942	821	1759842	1966-10-10	1966-10-24	1	-1165
25657	1739	1118084	2009-04-26	2009-04-26	1	14360
12285	843	1125315	1984-11-03	1984-11-17	1	5434
13229	905	1738521	1974-06-17	1974-07-01	1	1642
59893	4085	738818	2014-05-20	2014-05-27	1	16217
18155	1250	1759842	1988-03-15	1988-04-05	1	6669
63607	4348	1125315	1982-11-16	1982-11-23	1	4709
9904	680	1125315	2012-07-17	2012-08-23	2	15575
40788	2770	1177480	2001-10-23	2001-11-20	1	11646
63033	4308	1124957	1981-10-09	1981-10-09	1	4299
19018	1306	1112807	1961-08-12	1961-08-26	1	-3050
54049	3676	1125315	1975-10-19	1975-11-02	1	2131
6151	422	933724	1982-01-31	1982-02-07	1	4420
61911	4225	1713332	1980-04-29	1980-05-13	1	3785
13524	924	1521369	1979-06-16	1980-06-10	1	3813
59601	4064	1125315	1984-11-01	1984-11-08	1	5425
11992	825	1112807	1971-01-10	1971-01-24	1	388
10330	709	1112807	1972-03-04	1972-03-25	1	814
63844	4365	1729720	1960-03-23	1960-04-05	1	-3558
16731	1151	1549786	1998-11-17	1999-11-12	1	10907
65068	4446	1118084	2002-03-05	2002-03-05	1	11751
11835	814	1521369	1995-07-04	1996-06-28	1	9675
61836	4220	1119510	2012-07-26	2012-08-09	1	15561
10179	700	1549786	1995-05-26	1996-05-20	1	9636
47949	3253	1125315	1980-04-26	1980-05-26	1	3798
66307	4529	1125315	2016-10-30	2016-12-04	1	17139
16971	1169	1322184	2014-09-22	2018-08-20	1	17763
16768	1154	1112807	1971-10-31	1971-11-14	1	682
45568	3092	1713332	2013-07-24	2013-08-14	1	15931
12810	877	1125315	1998-03-16	1998-03-30	1	10315
53327	3630	1125315	2015-09-15	2015-09-22	1	16700
13350	915	1713332	1987-07-27	1987-08-17	1	6437
53557	3644	1728416	1948-11-12	1948-11-26	1	-7706
12530	862	1125315	1986-06-06	1986-09-04	1	6090
59087	4024	1713332	2003-08-13	2003-08-27	1	12291
16084	1113	1125315	1974-08-10	1974-08-24	1	1696
58266	3973	1713332	1980-07-12	1980-07-19	1	3852
63967	4372	1192710	1981-01-19	1981-01-19	1	4036
17787	1227	1125315	1956-01-08	1956-01-22	1	-5093
53200	3624	1759842	1989-06-23	1989-07-07	1	7127
12700	870	1503184	1986-09-27	1989-09-11	3	7193
11276	771	1177480	1999-09-08	1999-10-13	1	10877
58149	3967	1177480	1998-11-13	1998-12-04	1	10564
52411	3570	1125315	1980-09-14	1980-10-05	1	3930
18848	1293	1759842	1971-12-15	1971-12-29	1	727
68196	4655	933724	2016-01-12	2016-01-19	1	16819
14402	987	1102527	1965-10-26	1965-10-26	1	-1528
61463	4197	1115008	2007-02-22	2007-04-23	1	13626
6586	454	1115008	2006-02-13	2006-05-14	1	13282
53012	3612	1125315	2000-04-30	2000-05-14	1	11091
69057	4713	1125315	1982-08-11	1982-08-25	1	4619
60242	4107	1713332	1984-09-11	1984-09-25	1	5381
16720	1150	1729720	1973-05-25	1973-06-02	1	1248
18721	1285	1125315	2014-03-08	2014-03-22	1	16151
58421	3984	1125315	1969-05-17	1969-05-31	1	-215
16372	1131	1112807	1967-07-15	1967-07-29	1	-887
54701	3720	1713332	1997-04-16	1997-04-23	1	9974
11943	821	738818	1968-08-08	1968-08-15	1	-504
25658	1739	1125315	1976-05-20	1976-06-03	1	2345
12286	843	1192710	1983-05-08	1983-05-08	1	4875
20173	1376	1112807	1979-12-31	1980-01-14	1	3665
59894	4085	1112807	1960-02-10	1960-02-24	1	-3599
18156	1250	1759842	1993-02-13	1993-03-06	1	8465
63608	4348	1149380	1985-10-27	1985-10-27	1	5778
9905	680	1192710	1971-10-15	1971-10-15	1	652
40789	2770	1322184	2015-08-15	2015-08-15	1	16662
63034	4308	1125315	1956-11-14	1956-11-21	1	-4789
19019	1306	1112807	1962-04-09	1962-04-30	1	-2803
54050	3676	1309944	1997-02-13	1997-02-13	1	9905
6152	422	933724	1984-03-18	1984-04-01	1	5204
61912	4225	1729720	1991-08-01	1991-08-10	1	7891
13525	924	1521369	1981-06-05	1982-05-31	1	4533
59602	4064	1177480	1999-06-28	1999-07-19	1	10791
11993	825	1119510	1997-09-22	1997-09-29	1	10133
10331	709	1124300	1988-07-13	1988-07-13	1	6768
63845	4365	1768849	1985-07-08	1985-07-29	1	5688
16732	1151	1125315	2014-01-26	2014-02-09	1	16110
65069	4446	1713332	2009-09-26	2009-10-17	1	14534
11836	814	1521369	1997-06-23	1998-06-18	1	10395
61837	4220	1125315	1962-01-16	1962-01-23	1	-2900
10180	700	1589505	1994-05-31	1995-05-26	1	9276
47950	3253	1177480	2018-08-05	2018-08-19	1	17762
66308	4529	1137529	1988-12-04	1988-12-04	1	6912
16972	1169	1539403	2014-09-22	2014-09-22	1	16335
16769	1154	1503184	1988-08-12	1989-08-07	1	7158
45569	3092	1759842	2004-08-11	2004-09-01	1	12662
12811	877	738818	1998-03-16	1998-03-30	1	10315
53328	3630	1713332	1996-01-09	1996-01-23	1	9518
13351	915	1728416	1971-10-11	1971-10-25	1	662
53779	3658	738818	1983-02-08	1983-02-15	1	4793
12531	862	1125315	1995-08-31	1995-09-07	1	9380
59088	4024	1149380	2006-05-07	2006-05-07	1	13275
16085	1113	1177480	2012-12-10	2012-12-31	1	15705
60767	4145	738818	1993-11-25	1993-12-09	1	8743
63968	4372	1521369	1995-04-30	1996-04-24	1	9610
17788	1227	1125315	2012-03-06	2012-03-20	1	15419
53201	3624	1768849	1981-02-12	1981-02-26	1	4074
12701	870	1717327	1963-07-20	1963-08-03	1	-2343
11277	771	1503184	1980-10-25	1981-10-20	1	4310
58150	3967	1177480	2008-04-26	2008-05-10	1	14009
52412	3570	1713332	1956-07-03	1956-08-14	1	-4888
18849	1293	1112807	1941-05-19	1941-06-02	1	-10440
68197	4655	1119510	1998-06-14	1998-06-28	1	10405
14403	987	1112807	1970-08-01	1970-09-05	1	247
61464	4197	1177480	2009-12-08	2010-02-13	1	14653
6587	454	1119510	1961-09-08	1961-09-22	1	-3023
53013	3612	1729720	1967-07-12	1967-07-22	1	-894
69058	4713	1124300	2010-08-14	2010-08-14	1	14835
60243	4107	1729720	1995-01-21	1995-01-29	1	9159
16721	1150	1729720	1990-03-02	1990-03-12	1	7375
18722	1285	1307863	2014-05-19	2014-05-19	1	16209
58422	3984	1125315	2006-10-19	2006-11-23	1	13475
16373	1131	1119510	1988-01-22	1988-02-05	1	6609
54702	3720	1713332	2016-07-25	2016-08-08	1	17021
11944	821	1112807	1951-08-26	1951-09-09	1	-6689
25659	1739	1308738	1986-04-07	1986-04-07	1	5940
12287	843	1521369	2003-03-22	2004-03-16	1	12493
20174	1376	1125315	1983-06-13	1983-09-11	1	5001
59895	4085	1119510	2006-08-25	2006-09-01	1	13392
18157	1250	1125315	1970-10-03	1970-10-17	1	289
63609	4348	1177480	2000-11-01	2000-11-15	1	11276
9906	680	1713332	1994-11-07	1994-11-21	1	9090
40790	2770	1322184	2018-12-15	2018-12-15	1	17880
63035	4308	1125315	1981-10-09	1981-11-06	2	4327
19020	1306	1124957	2019-04-11	2019-04-11	1	17997
54051	3676	1343916	1997-02-13	1997-02-13	1	9905
6153	422	1521369	1974-01-01	1974-12-27	1	1821
61913	4225	1125315	2002-09-01	2002-10-06	1	11966
13526	924	1713332	1971-04-08	1971-04-22	1	476
59603	4064	1177480	2004-02-23	2004-05-23	1	12561
11994	825	1125315	1976-02-05	1976-02-19	1	2240
10332	709	1174888	2005-08-28	2005-08-28	1	13023
63846	4365	723013	1986-06-30	1986-12-28	1	6205
16733	1151	1521369	1998-11-17	1999-11-12	1	10907
65070	4446	1759842	2009-09-26	2009-10-17	1	14534
12442	856	1124300	2006-02-24	2006-02-24	1	13203
61838	4220	1125315	1992-03-29	1992-04-05	1	8130
10181	700	1713332	1980-12-30	1981-01-13	1	4030
47951	3253	1713332	1983-11-27	1983-12-04	1	5085
66309	4529	1503184	1984-10-10	1985-10-05	1	5756
16973	1169	1545958	2018-08-20	2018-08-20	1	17763
16770	1154	1521369	1985-08-28	1986-08-23	1	6078
46638	3170	1112807	1958-06-13	1958-06-27	1	-4206
12812	877	1125315	1984-12-06	1985-01-05	1	5483
53329	3630	1728416	1956-06-06	1956-06-20	1	-4943
13352	915	1125315	2010-01-27	2010-02-10	1	14650
53780	3658	1125315	1962-07-27	1962-08-10	1	-2701
12532	862	1177480	1979-09-11	1979-10-11	1	3570
59089	4024	1713332	2000-05-16	2000-05-23	1	11100
16086	1113	1503184	1989-10-30	1990-10-25	1	7602
60768	4145	1153428	2006-07-29	2006-07-29	1	13358
63969	4372	1759842	1996-11-04	1996-11-11	1	9811
17789	1227	1310149	2016-04-06	2016-04-06	1	16897
53202	3624	1112807	1946-12-31	1947-01-14	1	-8388
12702	870	1112807	1963-07-20	1963-08-03	1	-2343
11278	771	1713332	1968-01-18	1968-01-25	1	-707
58151	3967	1503184	1975-04-23	1976-04-17	1	2298
52413	3570	1759842	2017-05-20	2017-06-10	1	17327
18850	1293	1149380	1942-01-01	1942-01-01	1	-10227
68198	4655	1125315	2011-11-27	2011-12-04	1	15312
14404	987	1124300	1988-01-09	1988-01-09	1	6582
61465	4197	1322184	2011-02-20	2011-02-20	1	15025
6588	454	1125315	1975-03-28	1975-04-11	1	1926
53014	3612	1729720	1996-01-11	1996-01-20	1	9515
69059	4713	705944	1975-01-05	1984-01-13	1	5125
60244	4107	1177480	1992-01-19	1992-02-02	1	8067
16722	1150	1125315	1982-05-24	1982-06-07	1	4540
18723	1285	1759842	2016-10-08	2016-10-29	1	17103
58423	3984	1125315	2008-10-16	2008-10-30	1	14182
16374	1131	1119510	2016-04-05	2016-04-12	1	16903
54703	3720	1729720	2002-09-02	2002-09-13	1	11943
11945	821	1118084	1985-01-24	1985-01-24	1	5502
25660	1739	1728416	1972-04-20	1972-05-04	1	854
12288	843	1549786	2009-02-18	2010-02-13	1	14653
20175	1376	1125315	1986-11-25	1986-12-09	1	6186
59896	4085	1124300	1998-03-13	1998-03-13	1	10298
18158	1250	1125315	1997-10-03	1997-10-17	1	10151
63610	4348	1118084	2015-01-01	2015-01-01	1	16436
9907	680	1729720	1994-05-17	1994-05-30	1	8915
40791	2770	1713332	1951-03-08	1951-03-29	1	-6853
63036	4308	1759842	1943-01-08	1943-01-15	1	-9848
19021	1306	1177480	2019-04-11	2019-05-11	1	18027
54052	3676	1713332	1989-10-01	1989-10-08	1	7220
6154	422	1521369	1977-12-11	1978-12-06	1	3261
61914	4225	1713332	2003-03-11	2003-03-18	1	12129
13527	924	1713332	2018-09-11	2018-09-18	1	17792
59604	4064	1521369	1977-04-20	1978-04-15	1	3026
11995	825	1125315	2010-04-13	2010-04-20	1	14719
10333	709	1545958	2005-08-28	2005-08-28	1	13023
63847	4365	1125315	1954-05-08	1954-05-22	1	-5703
16734	1151	1713332	1985-11-15	1985-11-29	1	5811
65071	4446	1115008	2014-06-20	2014-07-04	1	16255
12443	856	1125315	1970-10-06	1970-10-20	1	292
61839	4220	1125315	2012-07-26	2012-08-10	2	15561
10182	700	1713332	1998-08-29	1998-09-05	1	10474
47952	3253	1713332	1987-01-23	1987-01-30	1	6238
66310	4529	1503184	1986-09-30	1987-09-25	1	6476
16974	1169	1713332	1956-09-15	1956-10-06	1	-4835
16771	1154	1759842	1971-04-10	1971-05-01	1	485
46639	3170	1119510	1974-04-20	1974-04-27	1	1577
12813	877	1192710	1978-06-07	1978-06-07	1	3079
53330	3630	1759842	1996-01-09	1996-01-23	1	9518
13353	915	1125315	2012-08-03	2012-08-17	1	15569
53781	3658	1125315	2005-05-17	2005-05-31	1	12934
12533	862	1177480	2017-08-22	2017-11-20	1	17490
59090	4024	1759842	2000-05-16	2000-05-23	1	11100
16087	1113	1503184	1992-10-14	1993-10-09	1	8682
60769	4145	1343916	2006-07-29	2006-07-29	1	13358
63970	4372	738818	1982-01-30	1982-02-06	1	4419
17790	1227	1729720	1984-12-27	1985-01-04	1	5482
53203	3624	1112807	1948-08-04	1948-08-18	1	-7806
12703	870	1119510	1979-05-19	1979-05-26	1	3432
11279	771	19127890	1978-11-05	1979-10-31	1	3590
58152	3967	1503184	1979-04-02	1980-03-27	1	3738
52414	3570	1119510	1990-02-09	1990-02-16	1	7351
18851	1293	1713332	2012-12-07	2012-12-14	1	15688
68199	4655	740275	1982-12-08	1983-04-13	1	4850
14405	987	1503184	1974-07-21	1975-07-16	1	2022
61466	4197	1503184	2000-09-06	2001-09-01	1	11566
6589	454	1310149	2005-03-05	2005-03-05	1	12847
53015	3612	1759842	2018-01-08	2018-01-29	1	17560
69060	4713	738818	2000-02-12	2000-02-26	1	11013
60245	4107	1124300	2014-08-16	2014-08-16	1	16298
16723	1150	1125315	1985-11-17	1985-11-24	1	5806
18724	1285	1118084	1990-11-28	1990-11-28	1	7636
58424	3984	1125315	2016-01-05	2016-02-02	1	16833
16375	1131	1125315	1982-03-16	1982-03-23	1	4464
54704	3720	1759842	1997-04-16	1997-04-23	1	9974
11946	821	1729720	1956-11-30	1956-12-09	1	-4771
28035	1902	1125315	1966-01-03	1966-01-17	1	-1445
13680	935	1102527	1961-08-26	1961-08-26	1	-3050
20176	1376	1125315	2004-09-06	2004-09-13	1	12674
59897	4085	1125315	1971-05-25	1971-06-01	1	516
18159	1250	1125315	2002-12-02	2002-12-16	1	12037
63611	4348	1125315	2007-05-17	2007-05-31	1	13664
9908	680	1738521	1967-10-25	1967-11-08	1	-785
40792	2770	740275	1945-03-31	1945-09-01	1	-8888
63037	4308	738818	1992-08-29	1992-09-05	1	8283
19022	1306	1713332	1965-06-30	1965-07-21	1	-1625
54053	3676	1738521	1971-06-10	1971-06-24	1	539
6155	422	1713332	2014-12-06	2015-02-28	1	16494
61915	4225	1112807	1980-04-29	1980-05-13	1	3785
13528	924	1728416	1977-02-15	1977-03-08	1	2623
59605	4064	19010482	1988-08-09	1988-08-30	1	6816
11996	825	1125315	2013-08-02	2013-08-23	1	15940
10334	709	1729720	1950-09-27	1950-10-08	1	-7025
63848	4365	1125315	1989-08-27	1989-09-03	1	7185
16735	1151	1713332	2016-12-01	2016-12-15	1	17150
65072	4446	1729720	1972-02-23	1972-03-07	1	796
12444	856	1125315	1982-01-25	1982-02-08	1	4421
61840	4220	1177480	2012-08-10	2012-11-08	1	15652
10183	700	1713332	2000-10-17	2000-10-31	1	11261
47953	3253	1713332	2018-08-05	2018-08-19	1	17762
66311	4529	19127890	1986-09-30	1987-09-25	1	6476
16975	1169	1759842	1979-08-05	1979-08-26	1	3524
16772	1154	920293	1995-10-05	1995-10-19	2	9422
46640	3170	1125315	1954-09-14	1954-09-28	1	-5574
12814	877	19127890	1994-04-14	1996-04-03	2	9589
53988	3672	1112807	1965-06-05	1965-06-19	1	-1657
13354	915	1713332	1964-08-10	1964-08-24	1	-1956
53782	3658	1119510	2017-01-17	2017-01-31	1	17197
13801	946	738818	1985-08-09	1985-08-23	1	5713
59091	4024	19127890	1997-12-29	1998-12-24	1	10584
16088	1113	1521369	1985-11-12	1987-11-02	2	6514
60770	4145	975125	2006-07-12	2006-07-12	1	13341
63971	4372	920293	2013-07-04	2013-07-11	1	15897
20437	1390	1118084	2006-10-11	2006-10-11	1	13432
53204	3624	1115008	2008-05-26	2008-06-16	1	14046
12704	870	1125315	1962-09-24	1962-10-01	1	-2649
11280	771	1119510	1965-04-08	1965-04-15	1	-1722
58153	3967	1521369	1979-04-02	1980-03-27	1	3738
52415	3570	1125315	1957-01-16	1957-01-23	1	-4726
18852	1293	1729720	1951-01-28	1951-02-09	1	-6901
68200	4655	740275	1996-06-23	1996-09-01	1	9740
14406	987	1557272	2013-10-27	2013-10-27	1	16005
61467	4197	1521369	2007-08-14	2007-12-16	1	13863
6590	454	1759842	1951-06-30	1951-07-07	1	-6753
54641	3718	1112807	1970-10-11	1970-10-25	1	297
69061	4713	1119510	1978-09-02	1978-09-16	1	3180
60246	4107	1125315	1984-09-11	1984-09-25	1	5381
16724	1150	1713332	1983-03-20	1983-04-03	1	4840
18725	1285	1125315	1962-01-09	1962-02-13	1	-2879
58425	3984	1326303	2014-11-26	2014-11-26	1	16400
16376	1131	738818	1995-10-14	1995-10-21	1	9424
54705	3720	1759842	2016-07-25	2016-08-08	1	17021
11947	821	1112807	1960-06-09	1960-06-30	1	-3472
28036	1902	1177480	2000-06-01	2000-06-29	1	11137
13681	935	1713332	1992-08-28	1992-10-30	1	8338
20177	1376	1713332	1985-08-24	1985-09-07	1	5728
59898	4085	1125315	2006-08-25	2006-09-01	1	13392
18160	1250	920293	1984-04-23	1984-04-30	1	5233
63612	4348	1154343	1985-10-27	1985-10-27	1	5778
9909	680	1759842	1989-04-23	1989-04-30	1	7059
40793	2770	1118084	1972-06-12	1972-06-12	1	893
63038	4308	1112807	1913-10-23	1913-11-06	1	-20510
19023	1306	1717327	1961-08-12	1961-08-26	1	-3050
54054	3676	1759842	1981-02-24	1981-06-16	1	4184
6718	464	1115008	2016-06-24	2016-07-15	1	16997
61916	4225	1713332	1983-04-28	1983-05-12	1	4879
15636	1084	1118084	2016-06-15	2016-06-15	1	16967
59606	4064	975125	1978-11-15	1978-11-29	1	3254
11997	825	1177480	2011-06-23	2011-07-14	1	15169
10335	709	1119510	1973-11-24	1973-12-08	1	1437
63849	4365	1326303	2001-07-23	2001-07-23	1	11526
16736	1151	1759842	2016-12-01	2016-12-15	1	17150
65073	4446	1125315	1964-12-06	1964-12-20	1	-1838
12445	856	1125315	2011-09-06	2011-10-06	1	15253
61841	4220	1112807	1944-02-18	1944-03-03	1	-9435
10184	700	19127890	1997-05-15	1997-12-17	1	10212
47954	3253	1759842	1974-03-06	1974-03-20	1	1539
66312	4529	933724	1993-12-22	1993-12-29	1	8763
19502	1332	1112807	1971-08-30	1971-09-27	1	634
16773	1154	933724	1995-10-05	1995-10-19	1	9422
46641	3170	1713332	1965-06-23	1965-07-07	1	-1639
12815	877	1118084	2016-02-13	2016-02-13	1	16844
53989	3672	1125315	1986-02-07	1986-02-21	1	5895
13355	915	1729720	2010-06-28	2010-07-06	1	14796
53783	3658	1177480	1980-05-14	1980-05-28	1	3800
13802	946	1125315	1985-08-09	1985-08-23	1	5713
59092	4024	1118084	2016-05-08	2016-05-08	1	16929
16089	1113	1549786	1993-10-09	1994-10-04	1	9042
60771	4145	1119510	2017-07-22	2017-08-05	1	17383
63972	4372	933724	2009-05-28	2009-06-04	1	14399
20438	1390	1177480	2013-12-21	2014-03-21	1	16150
53205	3624	1125315	1950-08-31	1950-09-14	1	-7049
12705	870	1125315	1971-10-06	1971-11-05	1	673
11281	771	1124300	1998-05-19	1998-05-19	1	10365
58154	3967	1728416	1965-09-02	1965-09-16	1	-1568
52416	3570	1728416	1953-03-14	1953-03-28	1	-6123
18853	1293	1759842	2012-12-07	2012-12-14	1	15688
68201	4655	1125315	1992-09-03	1992-09-24	1	8302
14407	987	1112807	1954-06-26	1954-07-10	1	-5654
61468	4197	1549786	2006-08-19	2007-08-14	1	13739
7701	534	933724	1996-07-21	1996-07-28	1	9705
54642	3718	1119510	1994-02-02	1994-02-09	1	8805
69062	4713	1125315	2000-02-12	2000-02-26	1	11013
62159	4241	738818	1972-12-15	1972-12-22	1	1086
16725	1150	1713332	2011-11-12	2011-11-19	1	15297
18726	1285	1768849	1989-08-20	1989-09-10	1	7192
58426	3984	1729720	1968-01-21	1968-02-01	1	-700
16377	1131	1124957	1979-01-30	1979-01-30	1	3316
54706	3720	1125315	2008-05-09	2008-05-16	1	14015
11948	821	1119510	1953-07-18	1953-07-25	1	-6004
28037	1902	1713332	1995-01-20	1995-02-10	1	9171
13682	935	1759842	1992-08-28	1992-10-30	1	8338
20178	1376	1115008	1999-12-16	2000-01-13	1	10969
59899	4085	1125315	2014-05-20	2014-05-27	1	16217
18161	1250	1177480	1981-03-26	1981-04-30	1	4137
66582	4547	1112807	1933-09-12	1933-09-26	1	-13246
9910	680	738818	2001-03-01	2001-03-15	1	11396
40794	2770	1119510	1973-06-10	1973-06-17	1	1263
63039	4308	1112807	1925-05-06	1925-08-04	1	-16221
19024	1306	19127890	1975-07-10	1976-07-04	1	2376
54055	3676	1125315	1971-06-10	1971-06-24	1	539
6719	464	1118084	2014-10-23	2014-10-23	1	16366
61917	4225	1713332	2002-10-29	2002-11-05	1	11996
15637	1084	1125315	2019-02-20	2019-03-06	1	17961
59607	4064	975125	1985-12-08	1985-12-22	1	5834
11998	825	1713332	2017-09-16	2017-09-30	1	17439
10336	709	1125315	2005-08-28	2005-08-28	1	13023
63850	4365	1347450	2016-01-10	2016-01-10	1	16810
16737	1151	1768849	1987-12-19	1988-01-02	1	6575
65074	4446	1112807	1964-05-08	1964-05-29	1	-2043
12446	856	1738521	1971-10-16	1971-10-30	1	667
61842	4220	1125315	1973-03-18	1973-04-01	1	1186
10185	700	1124957	1997-06-05	1997-06-05	1	10017
50327	3430	1112807	1964-01-31	1964-02-14	1	-2148
66313	4529	1125315	1965-04-12	1965-04-19	1	-1718
19503	1332	1115008	2002-12-25	2003-01-08	1	12060
16774	1154	1115008	2016-08-17	2016-11-15	1	17120
46642	3170	1728416	1954-09-14	1954-09-28	1	-5574
12816	877	1125315	1999-04-06	1999-04-27	1	10708
53990	3672	1125315	2009-03-09	2009-03-16	1	14319
13356	915	1125315	1961-01-19	1961-03-20	1	-3209
53784	3658	1713332	1998-07-28	1998-08-18	1	10456
13803	946	1125315	2003-12-30	2004-01-06	1	12423
59093	4024	1125315	1981-09-16	1981-09-23	1	4283
16090	1113	1713332	1978-04-17	1978-04-24	1	3035
60772	4145	738818	2017-07-22	2017-08-05	1	17383
63973	4372	1125315	1982-01-30	1982-02-06	1	4419
20439	1390	1713332	2017-05-07	2017-05-28	1	17314
53206	3624	1728416	1950-08-31	1950-09-14	1	-7049
12706	870	1125315	1975-10-08	1975-10-15	1	2113
11282	771	1125315	1971-12-04	1971-12-04	1	702
58155	3967	1728416	1975-05-30	1975-06-13	1	1989
52417	3570	1729720	1968-03-09	1968-03-21	1	-651
20962	1431	1112807	1952-05-18	1952-06-01	1	-6423
68202	4655	1125315	1993-06-14	1993-06-21	1	8572
14408	987	1125315	1954-01-28	1954-02-11	1	-5803
61469	4197	19127890	2000-09-06	2001-09-01	1	11566
7702	534	1112807	1983-09-09	1983-09-23	1	5013
54643	3718	1125315	1966-03-24	1966-04-07	1	-1365
69063	4713	1717327	1970-11-12	1970-11-26	1	329
62160	4241	1125315	1972-12-15	1972-12-22	1	1086
16726	1150	1759842	1998-06-20	1998-07-11	1	10418
18727	1285	1177480	1991-08-01	1991-08-22	1	7903
58427	3984	1119510	1958-03-26	1958-04-02	1	-4292
16378	1131	1125315	1995-10-14	1995-10-21	1	9424
54707	3720	1177480	2013-01-01	2013-01-15	1	15720
11949	821	1125315	1978-04-18	1978-07-17	1	3119
28038	1902	1713332	2011-11-30	2011-12-07	1	15315
13683	935	1310149	1990-05-09	1990-05-09	1	7433
20179	1376	1713332	1996-08-18	1996-09-08	1	9747
59900	4085	1759842	1994-01-07	1994-01-14	1	8779
18162	1250	1759842	1968-09-24	1968-10-08	1	-450
66583	4547	1115008	2004-06-02	2004-07-07	1	12606
9911	680	1112807	1967-10-25	1967-11-08	1	-785
40795	2770	1125315	2004-11-04	2004-11-04	1	12726
63040	4308	1118084	1947-12-31	1947-12-31	1	-8037
19025	1306	920293	2006-09-10	2006-09-17	1	13408
54056	3676	1503184	1993-09-22	1994-09-17	1	9025
6720	464	1713332	1983-04-26	1983-05-03	1	4870
61918	4225	1759842	2002-10-29	2002-11-05	1	11996
15638	1084	1549786	1992-01-03	1992-12-28	1	8397
59608	4064	1119510	1984-11-01	1984-11-08	1	5425
11999	825	1738521	1971-08-18	1971-09-01	1	608
10337	709	1713332	1986-04-24	1986-05-08	1	5971
63851	4365	1729720	1993-12-09	1993-12-20	1	8754
16738	1151	1115008	2009-04-14	2009-05-12	1	14376
65075	4446	1125315	1977-04-21	1977-05-05	1	2681
12447	856	1125315	2015-05-18	2015-05-18	1	16573
61843	4220	1125315	1995-04-21	1995-05-12	1	9262
10186	700	1503184	1997-05-15	1997-12-17	1	10212
50328	3430	1118084	2003-06-20	2003-06-20	1	12223
66314	4529	1729720	1965-11-08	1965-11-15	1	-1508
19504	1332	1124957	1979-12-05	1979-12-05	1	3625
16775	1154	1125315	2002-05-21	2002-08-19	1	11918
46643	3170	738818	1968-02-22	1968-03-07	1	-665
12817	877	1125315	2014-07-22	2014-07-29	1	16280
53991	3672	1118084	2002-02-21	2002-02-21	1	11739
13357	915	1125315	1973-08-23	1973-09-06	1	1344
53785	3658	1112807	1972-09-02	1972-10-02	1	1005
13804	946	1174888	1975-04-23	1975-04-23	1	1938
59094	4024	1515774	1997-12-29	1998-12-24	1	10584
16091	1113	1717327	1974-08-10	1974-08-24	1	1696
60773	4145	1115008	2012-09-15	2012-09-29	1	15612
63974	4372	1177480	1993-10-27	1993-11-26	1	8730
20440	1390	1759842	1976-12-07	1976-12-21	1	2546
53207	3624	1115008	2011-06-01	2011-06-22	1	15147
12707	870	1125315	2002-11-11	2002-12-02	1	12023
11283	771	1125315	1980-10-17	1980-12-16	1	4002
58156	3967	1125315	1978-08-16	1978-08-30	1	3163
52418	3570	1759842	1956-07-03	1956-08-14	1	-4888
20963	1431	1125315	1954-07-28	1954-08-11	1	-5622
68203	4655	1713332	2006-10-03	2006-10-17	1	13438
14409	987	1125315	1959-08-12	1959-08-19	1	-3788
61470	4197	1125315	1985-10-15	1985-10-29	1	5780
7703	534	1503184	1992-06-16	1993-06-11	1	8562
54644	3718	1125315	1972-09-18	1972-10-16	1	1019
69064	4713	1119510	2000-02-12	2000-02-26	1	11013
62161	4241	1125315	1996-02-07	1996-02-21	1	9547
16727	1150	1759842	2014-05-07	2014-05-21	1	16211
18728	1285	1310149	2014-05-19	2014-05-19	1	16209
58428	3984	1307863	2014-11-26	2014-11-26	1	16400
16379	1131	1717327	1966-04-08	1966-04-22	1	-1350
54708	3720	1759842	1999-07-19	1999-08-09	1	10812
11950	821	1713332	1955-01-15	1955-01-22	1	-5458
28039	1902	1728416	1946-11-12	1946-11-26	1	-8437
13684	935	1326303	1990-05-09	1990-05-09	1	7433
20180	1376	1759842	1996-08-18	1996-09-08	1	9747
59901	4085	738818	1994-04-21	1994-04-28	1	8883
18163	1250	933724	1984-04-23	1984-04-30	1	5233
66584	4547	1125315	1982-01-17	1982-04-17	1	4489
9912	680	1119510	1989-03-19	1989-04-02	1	7031
40796	2770	1177480	2009-10-09	2009-11-08	1	14556
63041	4308	1125315	1992-08-29	1992-09-05	1	8283
19026	1306	1112807	1968-05-28	1968-07-02	1	-548
54057	3676	1713332	1981-02-24	1981-06-16	1	4184
6721	464	1759842	1983-04-26	1983-05-03	1	4870
61919	4225	1124300	2014-06-20	2014-06-20	1	16241
15639	1084	1768849	1979-09-28	1979-10-12	1	3571
59609	4064	1125315	1991-01-06	1991-01-13	1	7682
12000	825	1759842	2017-09-16	2017-09-30	1	17439
10338	709	1713332	1993-03-08	1993-03-29	1	8488
63852	4365	1759842	1955-02-10	1955-02-24	1	-5425
16739	1151	1125315	1985-11-15	1985-11-29	1	5811
65076	4446	1717327	1963-04-14	1963-04-28	1	-2440
12448	856	1112807	1971-10-16	1971-10-30	1	667
61844	4220	738818	1986-03-09	1986-03-23	1	5925
10187	700	19127890	1995-05-26	1996-05-20	1	9636
50329	3430	1119510	1975-03-06	1975-03-13	1	1897
66315	4529	19127890	1984-10-10	1985-10-05	1	5756
19505	1332	1125315	1970-08-14	1970-09-04	1	246
16776	1154	1503184	1985-08-28	1986-08-23	1	6078
46644	3170	1125315	1967-10-08	1967-11-12	1	-781
12818	877	1119510	1998-03-16	1998-03-30	1	10315
53992	3672	1125315	1976-01-09	1976-01-09	1	2199
13358	915	1717327	1965-05-28	1965-06-11	1	-1665
53786	3658	1119510	1983-02-08	1983-02-15	1	4793
13805	946	1759842	2014-07-17	2014-10-23	1	16366
59095	4024	1759842	2003-08-13	2003-08-27	1	12291
16092	1113	1729720	1976-05-27	1976-06-04	1	2346
60774	4145	1125315	1975-05-03	1975-05-17	1	1962
63975	4372	1515774	1996-04-24	1998-04-14	2	10330
20441	1390	1125315	1967-10-21	1967-11-11	1	-782
53208	3624	1118084	1982-08-14	1982-08-14	1	4608
12708	870	1729720	2011-11-23	2011-12-04	1	15312
11284	771	1174888	1971-12-04	1971-12-04	1	702
58157	3967	1125315	2013-02-25	2013-03-11	1	15775
52419	3570	738818	1963-11-19	1963-11-26	1	-2228
20964	1431	1125315	1956-01-28	1956-02-18	1	-5066
68204	4655	1729720	1962-12-09	1962-12-19	1	-2570
14410	987	1125315	1979-07-20	1979-08-24	1	3522
61471	4197	1177480	1988-06-14	1988-06-28	1	6753
7704	534	1759842	1978-08-27	1978-09-10	1	3174
54645	3718	1125315	1974-08-07	1974-10-06	1	1739
69065	4713	1125315	1986-07-05	1986-07-26	1	6050
62162	4241	1503184	1979-10-19	1980-10-13	1	3938
19564	1335	1503184	1992-11-16	1993-11-11	1	8715
18729	1285	1713332	2016-10-08	2016-10-29	1	17103
58429	3984	1728416	1955-12-13	1955-12-27	1	-5119
16380	1131	738818	1988-01-22	1988-02-05	1	6609
56999	3885	933724	1995-12-22	1996-01-05	1	9500
11951	821	1713332	1966-10-10	1966-10-24	1	-1165
28040	1902	1759842	1964-03-12	1964-03-26	1	-2107
13685	935	1759842	1946-01-03	1946-01-10	1	-8757
20181	1376	1124300	2019-04-20	2019-04-20	1	18006
59902	4085	1112807	1959-09-29	1959-10-13	1	-3733
18164	1250	1125315	1961-06-11	1961-06-18	1	-3119
66585	4547	1713332	1938-07-16	1938-07-30	1	-11478
9913	680	1125315	1986-06-18	1986-07-02	1	6026
40797	2770	1551099	1948-02-04	1948-02-04	1	-8002
63042	4308	1149380	1915-08-28	1915-08-28	1	-19850
19027	1306	1115008	2001-12-20	2002-01-10	1	11697
54058	3676	1759842	1989-10-01	1989-10-08	1	7220
7406	512	738818	1963-10-02	1963-10-16	1	-2269
61920	4225	1759842	2003-03-11	2003-03-18	1	12129
15640	1084	19127890	2002-11-06	2003-11-01	1	12357
59610	4064	1729720	1966-11-18	1966-11-30	1	-1128
12333	847	914335	1970-07-24	1970-07-24	1	204
10339	709	1729720	1967-11-09	1967-11-22	1	-771
63853	4365	723013	1983-06-27	1983-12-18	1	5099
16740	1151	1595799	1998-11-17	1999-11-12	1	10907
66316	4530	738818	1990-01-25	1990-02-08	1	7343
12449	856	1115008	2015-05-18	2015-07-17	1	16633
61845	4220	1112807	1947-05-22	1947-06-05	1	-8246
10188	700	1115008	2017-06-11	2017-07-02	1	17349
50330	3430	1137529	1992-03-07	1992-03-07	1	8101
66656	4551	1713332	2017-08-30	2017-09-13	1	17422
19506	1332	1174888	2019-01-02	2019-01-02	1	17898
16777	1154	1521369	1988-08-12	1989-08-07	1	7158
46645	3170	1125315	1968-02-22	1968-03-07	1	-665
12819	877	1125315	2005-10-22	2005-11-05	1	13092
53993	3672	1125315	1982-08-27	1982-09-10	1	4635
13359	915	1729720	2015-08-24	2015-09-05	1	16683
53787	3658	1125315	1992-12-10	1992-12-17	1	8386
13806	946	1119510	1985-08-09	1985-08-23	1	5713
62222	4246	1125315	1969-10-14	1969-10-28	1	-65
16093	1113	1124300	2013-07-23	2013-07-23	1	15909
60775	4145	1125315	1993-11-25	1993-12-09	1	8743
63976	4372	1551099	1981-01-03	1981-01-03	1	4020
20442	1390	1125315	1980-03-07	1980-04-04	1	3746
53209	3624	1125315	1957-03-10	1957-03-17	1	-4673
12709	870	19127890	1986-09-27	1989-09-11	3	7193
11285	771	1503184	1978-11-05	1979-10-31	1	3590
58158	3967	19127890	1975-04-23	1976-04-17	1	2298
52420	3570	1112807	1950-09-26	1950-10-31	1	-7002
20965	1431	1125315	1967-08-04	1967-08-18	1	-867
73212	5002	1125315	1977-09-13	1977-09-27	1	2826
14411	987	1125315	1984-01-13	1984-01-20	1	5132
61472	4197	1177480	1997-03-16	1997-04-15	1	9966
7705	534	1515774	2000-05-09	2001-05-04	1	11446
54646	3718	1503184	1988-09-04	1989-08-30	1	7181
74132	5068	1112807	1936-09-10	1936-09-24	1	-12152
62163	4241	1515774	1989-08-27	1990-08-22	1	7538
19565	1335	1521369	1992-11-16	1993-11-11	1	8715
18730	1285	1125315	1996-04-27	1996-06-26	1	9673
64101	4379	1125315	1975-06-17	1975-06-24	1	2000
16381	1131	738818	2016-04-05	2016-04-12	1	16903
57000	3885	1112807	1968-09-06	1968-10-06	1	-452
14991	1039	1125315	1977-08-17	1977-09-07	1	2806
28041	1902	1112807	1946-11-12	1946-11-26	1	-8437
13686	935	1112807	1931-04-06	1931-06-05	1	-14090
20182	1376	1125315	2007-09-11	2007-09-25	1	13781
59903	4085	1119510	2014-05-20	2014-05-27	1	16217
18165	1250	1125315	1963-11-18	1963-11-25	1	-2229
66586	4547	1713332	1955-12-06	1955-12-20	1	-5126
9914	680	1125315	2001-03-01	2001-03-15	1	11396
40798	2770	1759842	1951-03-08	1951-03-29	1	-6853
63043	4308	1713332	1943-01-08	1943-01-15	1	-9848
19028	1306	1125315	1966-01-09	1966-04-09	1	-1363
54059	3676	738818	1979-10-23	1979-10-30	1	3589
7407	512	1112807	1956-03-10	1956-04-07	1	-5017
63535	4343	1115008	1999-07-04	1999-07-18	1	10790
15641	1084	1125315	1982-12-11	1983-02-09	1	4787
59611	4064	19010482	1999-12-07	1999-12-28	1	10953
12334	847	1309944	1970-07-24	1970-07-24	1	204
10340	709	1729720	1995-06-19	1995-07-02	1	9313
63854	4365	723013	1993-09-13	1994-03-13	1	8837
16741	1151	1713332	1997-04-24	1997-05-15	1	9996
66317	4530	1124957	1980-07-19	1980-07-19	1	3852
12450	856	1174888	2015-05-18	2015-05-18	1	16573
61846	4220	1125315	1986-03-09	1986-03-23	1	5925
10189	700	1125315	1980-12-30	1981-01-13	1	4030
50331	3430	1177480	2005-09-22	2005-10-13	1	13069
66657	4551	1729720	1990-04-30	1990-05-07	1	7431
19507	1332	1545958	2019-01-02	2019-01-02	1	17898
16778	1154	1551099	1971-03-05	1971-03-05	1	428
46646	3170	1125315	1972-12-18	1972-12-25	1	1089
12820	877	1125315	2009-07-15	2009-07-29	1	14454
53994	3672	1174888	1976-01-09	1976-01-09	1	2199
13360	915	1759842	1964-08-10	1964-08-24	1	-1956
53788	3658	1125315	1998-01-10	1998-01-24	1	10250
13807	946	1125315	2001-03-21	2001-04-04	1	11416
62223	4246	1729720	1974-01-16	1974-01-28	1	1488
16094	1113	1515774	1993-10-09	1994-10-04	1	9042
60776	4145	1125315	2017-07-22	2017-08-05	1	17383
63977	4372	1768849	1985-12-08	1985-12-22	1	5834
20443	1390	1713332	1976-12-07	1976-12-21	1	2546
53210	3624	1125315	1981-02-12	1981-02-26	2	4074
12710	870	1102527	1993-04-02	1993-04-02	1	8492
11286	771	1729720	1975-05-28	1975-06-06	1	1982
58159	3967	1118084	2003-12-07	2003-12-07	1	12393
52421	3570	1125315	1963-11-19	1963-11-26	1	-2228
20966	1431	1177480	1994-09-26	1994-10-17	1	9055
73213	5002	1177480	1985-11-05	1985-11-19	1	5801
14412	987	1125315	2018-05-15	2018-05-29	1	17680
61473	4197	1347450	2011-02-20	2011-02-20	1	15025
7706	534	1521369	1997-05-25	1999-05-15	2	10726
54647	3718	1521369	1980-10-16	1981-10-11	1	4301
74133	5068	1112807	1987-10-08	1987-10-22	1	6503
62164	4241	1549786	1989-08-27	1990-08-22	1	7538
19566	1335	1549786	1993-11-11	1994-11-06	1	9075
18731	1285	1326303	2014-05-19	2014-05-19	1	16209
64102	4379	1125315	1987-04-14	1987-07-13	1	6402
16382	1131	1118084	2004-12-14	2004-12-14	1	12766
57001	3885	1125315	1978-07-27	1978-08-10	1	3143
14992	1039	1125315	1996-09-27	1996-12-03	1	9833
28042	1902	1125315	1958-01-13	1958-01-13	1	-4371
13687	935	1112807	1936-04-09	1936-07-08	1	-12230
20183	1376	1125315	2012-07-17	2012-07-24	1	15545
59904	4085	1125315	1964-04-07	1964-04-21	1	-2081
18166	1250	1125315	1985-05-09	1985-05-23	1	5621
66587	4547	1713332	1966-06-30	1966-07-14	1	-1267
9915	680	1125315	2010-12-16	2010-12-23	1	14966
40799	2770	738818	1973-06-10	1973-06-17	1	1263
63044	4308	1713332	1981-10-07	1981-10-28	1	4318
19029	1306	1125315	1999-11-17	1999-12-01	1	10926
54060	3676	1118084	2015-09-22	2015-09-22	1	16700
7408	512	1115008	1994-12-14	1994-12-28	1	9127
63536	4343	1118084	1995-06-20	1995-06-20	1	9301
15642	1084	1125315	1987-10-18	1987-10-25	1	6506
59612	4064	19127890	1977-04-20	1978-04-15	1	3026
12335	847	1343916	1970-07-24	1970-07-24	1	204
10341	709	1759842	1991-11-17	1991-12-08	1	8011
63855	4365	738818	1989-08-27	1989-09-03	1	7185
16742	1151	1729720	1986-11-14	1986-11-25	1	6172
66318	4530	1125315	1990-01-25	1990-02-08	1	7343
12451	856	1177480	1984-12-28	1985-01-25	1	5503
61847	4220	738818	2012-07-26	2012-08-09	1	15561
10190	700	1521369	1997-05-15	1997-12-17	1	10212
50332	3430	1322184	2001-03-17	2011-10-08	1	15255
66658	4551	1759842	2017-08-30	2017-09-13	1	17422
19508	1332	1713332	1976-06-14	1976-06-21	1	2363
16779	1154	1713332	1971-04-10	1971-05-01	1	485
46647	3170	1125315	1979-05-15	1979-05-29	1	3435
12821	877	1125315	2017-09-03	2017-09-24	1	17433
53995	3672	1177480	1976-01-09	1976-02-08	1	2229
13361	915	1759842	1987-07-27	1987-08-17	1	6437
53789	3658	1717327	1962-07-27	1962-08-10	1	-2701
13808	946	1713332	2000-01-12	2000-01-26	1	10982
62224	4246	1738521	1972-04-30	1972-05-14	1	864
16095	1113	1521369	1989-10-30	1990-10-25	1	7602
60777	4145	1119510	1993-11-25	1993-12-09	1	8743
63978	4372	1119510	1982-01-30	1982-02-06	1	4419
20444	1390	1729720	1981-04-22	1981-05-05	1	4142
53211	3624	1125315	2001-03-22	2001-03-29	1	11410
12711	870	1124300	1998-08-20	1998-08-20	1	10458
11287	771	19127890	1980-10-25	1981-10-20	1	4310
58160	3967	1713332	2008-04-26	2008-05-10	1	14009
52422	3570	1713332	2017-05-20	2017-06-10	1	17327
20967	1431	1713332	1966-02-26	1966-03-05	1	-1398
73214	5002	1125315	2009-09-15	2009-09-29	1	14516
14413	987	1759842	1972-08-09	1972-08-16	1	958
61474	4197	1595799	1999-09-12	2000-09-06	1	11206
7707	534	1713332	1978-08-27	1978-09-10	1	3174
54648	3718	757627	2016-10-31	2016-10-31	1	17105
74134	5068	1307863	2009-11-28	2009-11-28	1	14576
62165	4241	1713332	1986-08-30	1986-09-20	1	6106
19567	1335	1713332	2003-10-14	2003-10-21	1	12346
18732	1285	1713332	1983-06-23	1983-07-07	1	4935
64103	4379	1729720	1983-04-08	1983-04-17	1	4854
16383	1131	1125315	1989-05-07	1989-06-04	1	7094
57002	3885	1125315	1987-11-29	1987-12-20	1	6562
14993	1039	1174888	1978-10-02	1978-10-02	1	3196
28043	1902	1713332	1964-03-12	1964-03-26	1	-2107
13688	935	1713332	1946-01-03	1946-01-10	1	-8757
20184	1376	1396131	1979-11-11	1979-11-11	1	3601
59905	4085	1729720	1969-09-08	1969-09-19	1	-104
18167	1250	1125315	1987-05-13	1987-06-17	1	6376
66588	4547	1112807	1916-10-06	1916-10-20	1	-19431
9916	680	1177480	2008-09-01	2008-10-06	1	14158
40800	2770	1115008	2004-11-04	2004-12-04	1	12756
63045	4308	920293	1958-11-05	1958-11-12	1	-4068
19030	1306	1759842	1965-06-30	1965-07-21	1	-1625
54061	3676	1119510	1978-05-22	1978-05-29	1	3070
7409	512	1125315	1963-10-02	1963-10-16	1	-2269
63537	4343	1125315	1963-04-11	1963-04-25	1	-2443
15643	1084	1125315	2004-06-29	2004-07-06	1	12605
60539	4130	1115008	1998-11-19	1998-12-24	1	10584
12336	847	1521369	1980-04-04	1981-03-30	1	4106
12565	864	1112807	1923-08-21	1923-09-04	1	-16921
63856	4365	1112807	1985-07-08	1985-07-29	1	5688
16743	1151	1759842	1997-04-24	1997-05-15	1	9996
66319	4530	1118084	2008-11-29	2008-11-29	1	14212
12452	856	1177480	1989-01-03	1989-01-17	1	6956
61848	4220	1118084	1977-04-05	1977-04-05	1	2651
10191	700	1729720	1991-11-20	1991-12-01	1	8004
50333	3430	1322184	2012-04-14	2012-04-14	1	15444
66659	4551	1118084	2015-10-09	2015-10-09	1	16717
19509	1332	1713332	2002-08-09	2002-08-16	1	11915
16780	1154	1125315	2009-11-01	2009-11-22	1	14570
46648	3170	1759842	1965-06-23	1965-07-07	1	-1639
12822	877	1515774	1994-04-14	1996-04-03	2	9589
53996	3672	1729720	1967-09-26	1967-10-07	1	-817
13362	915	1112807	1965-05-28	1965-06-11	1	-1665
53790	3658	738818	2017-01-17	2017-01-31	1	17197
13809	946	1729720	2015-02-23	2015-03-07	1	16501
62225	4246	1112807	1972-04-30	1972-05-14	1	864
16096	1113	1521369	1992-10-14	1993-10-09	1	8682
60778	4145	1124300	2009-07-18	2009-07-18	1	14443
63979	4372	1503184	1995-04-30	1996-04-24	1	9610
20445	1390	1115008	2007-05-13	2007-05-27	1	13660
53212	3624	1119510	1957-03-10	1957-03-17	1	-4673
12712	870	1125315	1977-09-15	1977-09-22	1	2821
12969	885	1102527	1992-12-30	1992-12-30	1	8399
58161	3967	19127890	1979-04-02	1980-03-27	1	3738
52423	3570	738818	1990-02-09	1990-02-16	1	7351
20968	1431	1728416	1954-07-28	1954-08-11	1	-5622
73215	5002	1177480	1988-07-05	1988-08-09	1	6795
14414	987	1112807	1965-10-26	1966-01-24	1	-1438
61475	4197	1125315	1990-10-10	1990-10-24	1	7601
7708	534	1713332	1982-04-10	1982-05-02	1	4504
54649	3718	1125315	1994-02-02	1994-02-09	1	8805
74135	5068	1729720	1984-12-02	1984-12-10	1	5457
62166	4241	1713332	1987-12-26	1988-01-09	1	6582
19568	1335	1759842	2003-10-14	2003-10-21	1	12346
18733	1285	1759842	1983-06-23	1983-07-07	1	4935
64104	4379	1118084	2007-11-30	2007-11-30	1	13847
16384	1131	1125315	2016-04-05	2016-04-12	1	16903
57003	3885	1125315	2011-12-19	2012-01-02	1	15341
14994	1039	1717327	1965-04-28	1965-05-12	1	-1695
28044	1902	1713332	1986-06-07	1986-06-28	1	6022
13689	935	1112807	1976-11-05	1976-11-19	1	2514
20185	1376	1759842	1985-08-24	1985-09-07	1	5728
59906	4085	1729720	1997-09-04	1997-09-13	1	10117
18168	1250	1713332	1968-09-24	1968-10-08	1	-450
66589	4547	1119510	1965-05-27	1965-06-03	1	-1673
9917	680	1713332	1989-04-23	1989-04-30	1	7059
40801	2770	1119510	1996-04-07	1996-04-14	1	9600
63046	4308	933724	1953-09-16	1953-09-23	1	-5944
20658	1408	1112807	1953-12-13	1953-12-27	1	-5849
54062	3676	1125315	1979-10-23	1979-10-30	1	3589
7410	512	1125315	2001-09-12	2001-09-26	1	11591
63538	4343	1125315	1997-02-27	1997-03-13	1	9933
15644	1084	1521369	1997-12-02	1999-11-22	2	10917
60540	4130	1125315	1997-03-02	1997-03-16	1	9936
12337	847	1521369	1982-03-25	1983-03-20	1	4826
12566	864	1115008	1997-08-03	1997-08-31	1	10104
63857	4365	1125315	1958-03-18	1958-04-01	1	-4293
16744	1151	1768849	1990-04-17	1990-05-01	1	7425
66320	4530	1125315	1976-08-04	1976-09-08	1	2442
12453	856	1713332	1989-01-03	1989-01-17	1	6956
61849	4220	1125315	1995-01-21	1995-01-28	1	9158
10192	700	1759842	1998-08-29	1998-09-05	1	10474
50334	3430	1521369	1977-07-01	1978-06-26	1	3098
66660	4551	1177480	1977-02-25	1977-03-11	1	2626
19510	1332	1759842	2002-08-09	2002-08-16	1	11915
16781	1154	1713332	1976-02-16	1976-03-01	1	2251
46649	3170	1119510	1968-02-22	1968-03-07	1	-665
12823	877	1549786	1994-04-14	1996-04-03	2	9589
53997	3672	1125315	1979-06-23	1979-07-07	1	3474
13363	915	1125315	1969-08-06	1969-08-13	1	-141
53791	3658	1124300	1999-06-13	1999-06-13	1	10755
13810	946	1759842	2000-01-12	2000-01-26	1	10982
62226	4246	1125315	1989-05-02	1989-05-09	1	7068
16097	1113	1713332	1977-02-23	1977-03-16	1	2631
60779	4145	1125315	1992-04-03	1992-06-02	1	8188
63980	4372	1521369	2002-03-24	2003-03-19	1	12130
20446	1390	1759842	2017-05-07	2017-05-28	1	17314
53213	3624	1125315	1958-07-01	1958-07-29	1	-4174
12713	870	1125315	1993-04-02	1993-07-01	1	8582
12970	885	1125315	1979-12-03	1979-12-17	1	3637
58162	3967	933724	2000-06-03	2000-06-10	1	11118
52424	3570	1112807	1953-03-14	1953-03-28	1	-6123
20969	1431	738818	2019-03-21	2019-04-04	1	17990
73216	5002	1717327	1977-09-13	1977-09-27	1	2826
14415	987	1112807	1988-08-06	1988-09-10	1	6827
61476	4197	1518198	2006-08-19	2007-08-14	1	13739
7709	534	19127890	1992-06-16	1993-06-11	1	8562
54650	3718	1125315	2003-12-03	2003-12-17	1	12403
74136	5068	1112807	1933-10-07	1933-10-21	1	-13221
62167	4241	1713332	1998-07-16	1998-10-01	1	10500
19569	1335	1768849	1979-11-15	1979-11-29	1	3619
21114	1439	738818	2003-07-20	2003-07-27	1	12260
64105	4379	1729720	2003-12-29	2004-01-09	1	12426
16385	1131	1738521	1967-07-15	1967-07-29	1	-887
57004	3885	1521369	1983-10-07	1985-09-26	2	5747
14995	1039	1125315	2008-08-14	2008-09-18	1	14140
28045	1902	1759842	1986-06-07	1986-06-28	1	6022
13690	935	1118084	1972-06-24	1972-06-24	1	905
23264	1578	1125315	1948-02-02	1948-02-09	1	-7997
59907	4085	1119510	1994-04-21	1994-04-28	1	8883
24593	1659	1125315	1971-06-07	1971-06-14	1	529
66590	4547	1125315	1943-10-17	1943-10-24	1	-9566
9918	680	1717327	1969-08-23	1969-09-06	1	-117
40802	2770	1125315	1941-12-08	1941-12-22	1	-10237
63047	4308	933724	1958-11-05	1958-11-12	1	-4068
20659	1408	1112807	1972-09-24	1972-10-08	1	1011
54063	3676	1515774	1990-10-08	1991-10-03	1	7945
7411	512	1729720	1960-05-03	1960-05-11	1	-3522
63539	4343	1119510	1961-07-28	1961-08-11	1	-3065
15645	1084	1521369	2002-11-06	2003-11-01	1	12357
60541	4130	1310149	2014-05-08	2014-05-08	1	16198
12338	847	1118084	2011-06-11	2011-06-11	1	15136
12567	864	1125315	1925-11-10	1925-11-17	1	-16116
63858	4365	1307863	2001-07-23	2001-07-23	1	11526
16745	1151	1118084	2019-06-06	2019-06-06	1	18053
66321	4530	1125315	1988-07-07	1988-09-05	1	6822
12454	856	1729720	1981-03-15	1981-03-26	1	4102
61850	4220	1174888	2012-08-10	2012-08-10	1	15562
10193	700	1759842	2000-10-17	2000-10-31	1	11261
50335	3430	738818	1975-03-06	1975-03-13	1	1897
66661	4551	1115008	2001-04-20	2001-07-19	1	11522
19511	1332	1112807	1975-05-09	1975-05-30	1	1975
16782	1154	19127890	1988-08-12	1990-08-02	2	7518
46650	3170	1125315	1962-05-07	1962-07-06	1	-2736
14682	1015	738818	2010-06-30	2010-07-07	1	14797
53998	3672	1728416	1965-06-05	1965-06-19	1	-1657
13364	915	1177480	2000-04-24	2000-05-08	1	11085
53792	3658	1125315	1983-02-08	1983-02-15	1	4793
13811	946	1125315	1969-03-22	1969-04-05	1	-271
62227	4246	1729720	1973-05-10	1973-05-18	1	1233
16098	1113	1713332	2014-03-13	2014-03-27	1	16156
60780	4145	1713332	1995-06-29	1995-07-13	1	9324
63981	4372	1521369	2004-03-13	2005-03-08	1	12850
20695	1410	914335	2010-03-25	2010-03-25	1	14693
53214	3624	1125315	1983-08-02	1983-08-09	1	4968
12714	870	1177480	2006-08-01	2006-08-15	1	13375
12971	885	1125315	1983-03-02	1983-03-23	1	4829
58163	3967	933724	2004-07-16	2004-07-23	1	12622
52425	3570	1125315	1952-04-19	1952-04-26	1	-6459
20970	1431	1112807	1965-05-31	1965-06-30	1	-1646
73217	5002	1738521	1970-06-10	1976-10-20	1	2484
14416	987	1119510	1991-10-01	1991-10-15	1	7957
61477	4197	1521369	2005-08-24	2006-08-19	1	13379
7710	534	19127890	2000-05-09	2001-05-04	1	11446
54651	3718	1503184	1980-10-16	1981-10-11	1	4301
74137	5068	1118084	1973-03-26	1973-03-26	1	1180
62168	4241	1729720	2008-10-02	2008-10-10	1	14162
19570	1335	1125315	1981-07-08	1981-07-15	1	4213
21115	1439	1118084	2018-12-26	2018-12-26	1	17891
64106	4379	1125315	1974-11-18	1974-12-02	1	1796
16386	1131	1119510	1995-10-14	1995-10-21	1	9424
57005	3885	1119510	1981-10-29	1981-11-12	1	4333
14996	1039	1713332	2012-01-30	2012-02-13	1	15383
28046	1902	1112807	1949-09-20	1949-10-04	1	-7394
13691	935	1125315	1961-08-26	1961-09-25	1	-3020
23265	1578	1713332	1992-07-31	1992-08-21	1	8268
59908	4085	1125315	1976-10-03	1976-10-10	1	2474
24594	1659	1738521	1976-07-17	1976-07-31	1	2403
66591	4547	1125315	1997-09-07	1997-12-06	2	10201
9919	680	1759842	1994-11-07	1994-11-21	1	9090
40803	2770	1125315	1973-06-10	1973-06-17	1	1263
63048	4308	1112807	1912-10-20	1912-11-03	1	-20878
20660	1408	1759842	1994-08-11	1995-02-09	1	9170
54064	3676	1729720	1989-08-07	1989-08-18	1	7169
7412	512	1102527	1967-03-11	1967-03-11	1	-1027
63540	4343	1125315	1955-07-17	1955-07-31	1	-5268
15646	1084	19127890	2004-10-26	2005-10-21	1	13077
60542	4130	1125315	1965-06-17	1965-07-01	1	-1645
12339	847	1125315	1973-08-29	1973-09-19	1	1357
12568	864	1322184	2003-07-28	2003-07-28	1	12261
63859	4365	1713332	1955-02-10	1955-02-24	1	-5425
16746	1151	1125315	1994-12-30	1995-01-06	1	9136
66322	4530	19127890	1988-04-13	1989-04-08	1	7037
12455	856	1729720	1982-04-24	1982-05-05	1	4507
61851	4220	1728416	1947-05-22	1947-06-05	1	-8246
10194	700	1125315	1997-06-05	1997-06-05	1	10017
50336	3430	1125315	1975-03-06	1975-03-13	1	1897
66662	4551	1125315	1981-09-03	1981-09-17	1	4277
19512	1332	1118084	1979-12-10	1979-12-10	1	3630
16783	1154	1124300	2006-07-14	2006-07-14	1	13343
46651	3170	1713332	1953-06-30	1953-07-21	1	-6008
14683	1015	1112807	1957-11-04	1957-11-18	1	-4427
55513	3778	1717327	1965-11-28	1965-12-12	1	-1481
17274	1193	738818	2008-07-08	2008-07-15	1	14075
53793	3658	1125315	2017-01-17	2017-01-31	1	17197
13812	946	1125315	1975-04-23	1975-06-22	2	1998
62228	4246	1118084	2005-01-12	2005-01-12	1	12795
16099	1113	1729720	1986-10-11	1986-10-19	1	6135
60781	4145	1759842	1995-06-29	1995-07-13	1	9324
63982	4372	1549786	1996-04-24	1998-04-14	2	10330
20696	1410	1112807	1970-12-24	1971-01-07	1	371
53215	3624	1174888	1981-02-12	1981-02-12	1	4060
12715	870	1729720	1970-04-17	1970-04-30	1	119
12972	885	1177480	1992-12-30	1993-02-28	1	8459
58164	3967	1177480	1975-05-30	1975-06-13	1	1989
52426	3570	1125315	1990-02-09	1990-02-16	1	7351
20971	1431	1125315	2003-02-16	2003-03-21	2	12120
73218	5002	1124300	2019-03-15	2019-03-15	1	17970
14417	987	1125315	1970-09-29	1970-10-13	1	285
65022	4442	1118084	2015-04-28	2015-04-28	1	16553
7711	534	1118084	2014-10-29	2014-10-29	1	16372
54652	3718	1503184	1984-09-25	1985-09-20	1	5741
74138	5068	1125315	2007-11-06	2008-02-04	1	13913
62169	4241	1759842	1986-01-10	1986-01-24	1	5867
19571	1335	1125315	1987-12-03	1987-12-17	1	6559
21116	1439	1119510	2019-05-12	2019-05-26	1	18042
64107	4379	1125315	1997-07-08	1997-07-15	1	10057
16387	1131	1125315	1979-01-30	1979-04-30	2	3406
57006	3885	1177480	2001-10-28	2001-11-11	1	11637
14997	1039	1759842	1980-02-01	1980-02-08	1	3690
28047	1902	1118084	1985-09-03	1985-09-03	1	5724
13692	935	1307863	1990-05-09	1990-05-09	1	7433
23266	1578	933724	1977-04-26	1977-05-03	1	2679
59909	4085	1728416	1960-02-10	1960-02-24	1	-3599
24595	1659	1115008	2011-08-02	2011-08-16	1	15202
66592	4547	738818	1965-05-27	1965-06-03	1	-1673
9920	680	1124957	2012-07-24	2012-07-24	1	15545
40804	2770	1174888	2004-11-04	2004-11-04	1	12726
63049	4308	1112807	1921-10-03	1921-10-24	1	-17601
20661	1408	1125315	1956-07-25	1956-08-01	1	-4901
54065	3676	19127890	1990-10-08	1992-09-27	2	8305
7413	512	1112807	1967-03-11	1967-04-10	1	-997
63541	4343	1125315	1978-10-03	1978-10-24	1	3218
15647	1084	1125315	2010-12-04	2010-12-18	1	14961
60543	4130	1192710	1966-12-10	1966-12-10	1	-1118
12340	847	1125315	2007-11-30	2007-12-14	1	13861
12569	864	1332418	2003-07-28	2003-07-28	1	12261
63860	4365	740275	1982-07-15	1991-12-15	1	8018
16747	1151	1125315	2019-04-01	2019-04-08	1	17994
66323	4530	1521369	1988-04-13	1989-04-08	1	7037
12456	856	1125315	1971-11-30	1972-01-06	1	735
62136	4240	738818	1963-04-29	1963-05-13	1	-2425
10195	700	1125315	2003-05-06	2003-05-13	1	12185
50337	3430	1503184	1977-07-01	1978-06-26	1	3098
66663	4551	1713332	1989-02-04	1989-02-11	1	6981
19513	1332	1119510	1970-05-12	1970-05-19	1	138
16784	1154	1125315	2005-05-05	2005-05-26	1	12929
46652	3170	738818	1974-04-20	1974-04-27	1	1577
14684	1015	1119510	1984-11-21	1984-11-28	1	5445
55514	3778	1759842	1966-04-06	1966-04-27	1	-1345
17275	1193	1112807	1951-11-14	1952-01-13	1	-6563
53794	3658	1177480	1977-05-09	1977-05-30	1	2706
13813	946	1713332	2010-07-12	2010-08-02	1	14823
62229	4246	1125315	2005-08-14	2005-08-28	1	13023
16100	1113	1713332	2013-11-01	2013-11-08	1	16017
61105	4167	1177480	1979-08-16	1979-08-30	1	3528
63983	4372	920293	2009-05-28	2009-06-04	1	14399
20697	1410	1125315	1991-12-05	1991-12-19	1	8022
53216	3624	1177480	1984-12-07	1984-12-28	1	5475
12716	870	1778162	2006-08-01	2006-08-15	1	13375
12973	885	1112807	1976-07-06	1976-07-20	1	2392
58165	3967	1521369	1975-04-23	1976-04-17	1	2298
53085	3618	933724	1931-02-12	1931-02-19	1	-14196
20972	1431	1125315	2019-03-21	2019-04-04	1	17990
73219	5002	1125315	1996-03-30	1996-06-28	1	9675
14418	987	1125315	2002-10-27	2003-01-25	1	12077
65023	4442	1713332	2005-12-01	2005-12-08	1	13125
7712	534	1503184	1997-05-25	1999-05-15	2	10726
54653	3718	1521369	1984-09-25	1985-09-20	1	5741
74139	5068	1322184	2009-11-28	2009-11-28	1	14576
62170	4241	1503184	1988-09-01	1989-08-27	1	7178
19572	1335	1125315	2008-03-27	2008-04-10	1	13979
21117	1439	1125315	1978-03-13	1978-03-27	1	3007
64108	4379	1125315	1985-12-29	1986-01-05	1	5848
16388	1131	1125315	1988-01-22	1988-02-05	1	6609
57007	3885	1738521	1973-09-10	1973-10-01	1	1369
14998	1039	1112807	1965-04-28	1965-05-12	1	-1695
28048	1902	1174888	1958-01-13	1958-01-13	1	-4371
13693	935	1347450	1994-05-25	1994-05-25	1	8910
23267	1578	1125315	1954-01-29	1954-02-19	1	-5795
59910	4085	1125315	1961-11-02	1961-11-16	1	-2968
24596	1659	1118084	2006-08-25	2006-08-25	1	13385
66593	4547	1112807	1918-10-10	1918-10-31	1	-18690
9921	680	1125315	1969-08-23	1969-09-06	1	-117
40805	2770	1347450	2015-08-15	2015-08-15	1	16662
63050	4308	1119510	1992-08-29	1992-09-05	1	8283
20662	1408	1125315	2007-07-07	2007-07-21	1	13715
54066	3676	19127890	1993-09-22	1994-09-17	1	9025
7414	512	1112807	1970-01-24	1970-03-02	1	60
63542	4343	1125315	2007-08-31	2007-09-07	1	13763
15648	1084	1503184	2002-11-06	2003-11-01	1	12357
60544	4130	1307863	2014-05-08	2014-05-08	1	16198
12341	847	1549786	1991-02-06	1992-02-01	1	8066
12570	864	1539403	2003-07-28	2003-07-28	1	12261
63861	4365	1102527	1985-07-08	1985-07-08	1	5667
18194	1253	1125315	1960-11-24	1960-12-08	1	-3311
66324	4530	1115008	2008-09-20	2008-10-04	1	14156
12457	856	1717327	1970-10-06	1970-10-20	1	292
62137	4240	1112807	1946-05-01	1946-05-29	1	-8618
10196	700	1125315	2008-09-05	2008-09-26	1	14148
50338	3430	1759842	1989-02-28	1989-03-14	1	7012
66664	4551	1738521	1977-02-25	1977-03-11	1	2626
19514	1332	1125315	1950-12-22	1951-01-05	1	-6936
16785	1154	1125315	2014-07-19	2014-08-02	1	16284
46653	3170	1118084	1985-08-30	1985-08-30	1	5720
14685	1015	1119510	2010-06-30	2010-07-07	1	14797
55515	3778	1118084	2000-01-14	2000-01-14	1	10970
17276	1193	1112807	1953-09-04	1953-09-18	1	-5949
53795	3658	1759842	1998-07-28	1998-08-18	1	10456
13814	946	1759842	2010-07-12	2010-08-02	1	14823
63213	4320	967823	1970-05-14	1970-05-15	1	134
16101	1113	1759842	1977-02-23	1977-03-16	1	2631
61106	4167	1515774	1995-09-08	1996-09-02	1	9741
63984	4372	1118084	2017-10-16	2017-10-16	1	17455
20698	1410	1309944	2010-03-25	2010-03-25	1	14693
54072	3678	1102527	2009-10-30	2009-10-30	1	14547
13230	906	1125315	1974-05-03	1974-05-17	1	1597
12974	885	1118084	2018-11-23	2018-11-23	1	17858
58465	3987	738818	2010-08-17	2010-08-31	1	14852
53086	3618	1112807	1936-01-02	1936-01-23	1	-12397
20973	1431	1177480	2000-05-18	2000-06-01	1	11109
73220	5002	1768849	1985-11-05	1985-11-19	1	5801
14419	987	1177480	2004-02-19	2004-03-11	1	12488
65024	4442	1759842	1984-11-05	1984-11-19	1	5436
7713	534	1549786	2000-05-09	2001-05-04	1	11446
54654	3718	1521369	1988-09-04	1989-08-30	1	7181
74140	5068	1326303	2009-11-28	2009-11-28	1	14576
62171	4241	1521369	1988-09-01	1989-08-27	1	7178
19573	1335	1177480	2003-12-19	2004-01-02	1	12419
21118	1439	1125315	2003-07-20	2003-07-27	1	12260
64109	4379	1125315	1986-11-25	1986-12-02	1	6179
16838	1159	1125315	1986-05-21	1986-06-04	1	5998
57008	3885	19127890	1987-09-16	1989-09-05	2	7187
14999	1039	1115008	2001-09-08	2001-10-06	1	11601
28049	1902	1112807	1958-01-13	1958-02-12	1	-4341
13694	935	1729720	1946-02-19	1946-02-26	1	-8710
23268	1578	1174888	1999-08-22	1999-08-22	1	10825
59911	4085	1125315	1966-03-26	1966-06-01	2	-1333
24597	1659	1125315	1983-05-03	1983-05-17	1	4884
66594	4547	1112807	1943-06-06	1943-07-11	1	-9671
13431	919	1112807	1979-05-19	1979-06-23	1	3460
40806	2770	1347450	2018-12-15	2018-12-15	1	17880
63051	4308	1125315	1913-11-15	1913-11-22	1	-20494
20663	1408	1539403	2015-03-23	2015-03-23	1	16517
57749	3939	1125315	2008-09-28	2008-10-05	1	14157
7415	512	1118084	1993-02-24	1993-02-24	1	8455
63543	4343	1557272	2014-12-15	2014-12-15	1	16419
15649	1084	1512674	2004-10-26	2005-10-21	1	13077
60545	4130	1738521	1967-07-24	1967-08-07	1	-878
12342	847	1713332	1975-09-09	1975-09-30	1	2098
12571	864	1729720	1935-03-08	1935-03-20	1	-12706
63862	4365	1118084	1991-05-29	1991-05-29	1	7818
18195	1253	1125315	1990-11-14	1990-12-19	1	7657
66325	4530	1119510	1990-01-25	1990-02-08	1	7343
12458	856	1768849	1982-01-25	1982-02-08	1	4421
62138	4240	1125315	1963-04-29	1963-05-13	1	-2425
10197	700	1713332	2004-12-16	2004-12-30	1	12782
50339	3430	1112807	1972-10-15	1973-01-13	1	1108
66665	4551	1759842	1989-02-04	1989-02-11	1	6981
19515	1332	1125315	1979-12-05	1980-01-04	2	3655
16786	1154	1515774	1989-08-07	1990-08-02	1	7518
46654	3170	1125315	1951-07-20	1951-08-03	1	-6726
14686	1015	1125315	1979-12-29	1980-01-05	1	3656
55516	3778	1125315	2003-01-15	2003-01-22	1	12074
17277	1193	1112807	1984-10-27	1984-12-01	1	5448
55119	3750	738818	1987-11-13	1987-11-27	1	6539
13815	946	1112807	1969-01-19	1969-02-23	1	-312
63214	4320	1124300	2010-02-07	2010-02-07	1	14647
16102	1113	1759842	2013-11-01	2013-11-08	1	16017
61107	4167	1713332	1981-05-21	1981-06-04	1	4172
63985	4372	1125315	1985-12-08	1985-12-22	1	5834
20699	1410	1343916	2010-03-25	2010-03-25	1	14693
54073	3678	1119510	1985-09-23	1985-09-30	1	5751
13231	906	1177480	2001-10-08	2001-10-29	1	11624
12975	885	1125315	1993-12-10	1993-12-24	1	8758
58466	3987	920293	2004-01-26	2004-02-02	1	12450
53087	3618	1125315	1916-08-20	1916-08-27	1	-19485
20974	1431	1177480	2018-11-08	2018-12-08	1	17873
73221	5002	1177480	1976-10-06	1976-10-20	1	2484
14420	987	1521369	1974-07-21	1975-07-16	1	2022
65025	4442	19127890	1995-06-12	1996-06-06	1	9653
7714	534	920293	1996-07-21	1996-07-28	1	9705
54655	3718	1125315	1989-08-01	1989-08-08	1	7159
74141	5068	1729720	1956-09-14	1956-09-23	1	-4848
62172	4241	1713332	1966-08-23	1966-08-30	1	-1220
19574	1335	1515774	1993-11-11	1994-11-06	1	9075
21119	1439	1125315	2006-08-30	2006-09-13	1	13404
64110	4379	1177480	1990-05-28	1990-06-25	1	7480
16839	1159	1125315	2010-11-05	2010-11-19	1	14932
57009	3885	1112807	1984-03-21	1984-04-18	1	5221
15000	1039	1115008	2002-09-01	2002-09-15	1	11945
28050	1902	1125315	2012-01-29	2012-02-12	1	15382
16468	1137	1118084	1991-10-24	1991-10-24	1	7966
23269	1578	1539403	2015-07-19	2015-07-19	1	16635
59912	4085	1125315	1983-06-09	1983-06-16	1	4914
24598	1659	1713332	1974-12-19	1975-06-05	1	1981
66595	4547	1125315	1965-05-27	1965-06-03	1	-1673
13432	919	1118084	2009-06-05	2009-06-05	1	14400
40807	2770	1125315	1961-10-09	1961-10-23	1	-2992
63052	4308	1125315	1973-01-22	1973-01-29	1	1124
20664	1408	1728416	1953-12-13	1953-12-27	1	-5849
57750	3939	1713332	1987-07-22	1987-08-12	1	6432
7416	512	1125315	1960-02-05	1960-02-19	1	-3604
63544	4343	1729720	1967-09-26	1967-10-04	1	-820
15650	1084	1549786	2004-10-26	2005-10-21	1	13077
60546	4130	1112807	1967-07-24	1967-08-07	1	-878
12343	847	19127890	1984-03-14	1985-03-09	1	5546
12572	864	1729720	1947-07-19	1947-07-26	1	-8195
63863	4365	1125315	1963-06-11	1963-06-25	1	-2382
18196	1253	1503184	1977-01-22	1978-01-17	1	2938
66326	4530	1125315	1969-05-13	1969-06-12	1	-203
13830	948	1112807	1960-05-11	1960-05-25	1	-3508
62139	4240	1125315	1984-09-03	1984-09-17	1	5373
10198	700	1759842	2004-12-16	2004-12-30	1	12782
50340	3430	1347450	2011-10-08	2011-10-08	1	15255
66666	4551	1125315	1980-09-15	1980-09-29	1	3924
19516	1332	1125315	1984-07-11	1984-08-01	1	5326
16787	1154	1549786	1989-08-07	1990-08-02	1	7518
46655	3170	1125315	1974-04-20	1974-04-27	1	1577
14687	1015	1125315	2010-06-30	2010-07-07	1	14797
55517	3778	1713332	1966-04-06	1966-04-27	1	-1345
17278	1193	1119510	2008-07-08	2008-07-15	1	14075
55120	3750	1125315	1987-11-13	1987-11-27	1	6539
13816	946	1118084	2001-09-13	2001-09-13	1	11578
63215	4320	1125315	2004-02-01	2004-02-08	1	12456
16103	1113	19127890	1985-11-12	1987-11-02	2	6514
61108	4167	1125315	1981-05-21	1981-06-04	1	4172
63986	4372	1125315	1997-06-08	1997-06-29	1	10041
20700	1410	1503184	1983-03-01	1984-02-24	1	5167
54074	3678	1119510	2008-10-01	2008-10-08	1	14160
13232	906	1515774	1989-02-09	1990-02-04	1	7339
12976	885	1717327	1976-07-06	1976-07-20	1	2392
58467	3987	1102527	2008-03-01	2008-03-01	1	13939
53088	3618	1125315	1956-12-23	1957-01-06	1	-4743
20975	1431	1551099	1950-05-30	1950-05-30	1	-7156
74756	5116	1125315	1970-05-07	1970-05-21	1	140
14421	987	1713332	2009-09-07	2009-09-21	1	14508
65026	4442	19127890	1998-05-27	1999-05-22	1	10733
7715	534	1177480	1980-02-09	1980-02-23	1	3705
54656	3718	1717327	1966-03-24	1966-04-07	1	-1365
74142	5068	1125315	1975-07-19	1975-08-02	1	2039
62173	4241	1713332	1998-05-25	1998-06-08	1	10385
19575	1335	1515774	1997-10-21	1998-10-16	1	10515
21120	1439	1503184	1995-07-20	1996-07-14	1	9691
68717	4689	1112807	1969-11-13	1969-11-27	1	-35
16840	1159	1177480	1982-03-18	1982-04-17	1	4489
57010	3885	1124300	2004-10-26	2004-10-26	1	12717
15001	1039	1124300	2003-03-29	2003-03-29	1	12140
28051	1902	1728416	1949-09-20	1949-10-04	1	-7394
16469	1137	1125315	1956-11-18	1956-11-25	1	-4785
23270	1578	738818	1950-09-27	1950-10-11	1	-7022
59913	4085	1125315	1994-04-21	1994-04-28	1	8883
24599	1659	1125315	1980-01-29	1980-02-05	1	3687
66596	4547	1125315	1983-03-13	1983-04-03	1	4840
13433	919	1125315	1975-09-09	1975-09-16	1	2084
40808	2770	1125315	1991-01-30	1991-02-06	1	7706
63053	4308	1125315	1988-07-10	1988-07-24	1	6779
20665	1408	1729720	1992-11-20	1992-12-01	1	8370
57751	3939	1713332	2017-03-28	2017-04-04	1	17260
7417	512	1125315	1969-01-29	1969-02-28	1	-307
63545	4343	1759842	1959-08-01	1959-08-22	1	-3785
15651	1084	1713332	2008-04-23	2008-05-07	1	14006
60547	4130	1112807	1968-03-24	1968-04-07	1	-634
12344	847	1112807	1967-02-02	1967-04-03	1	-1004
12573	864	1759842	1925-04-08	1925-04-29	1	-16318
63864	4365	1125315	2005-12-09	2005-12-23	1	13140
18197	1253	1503184	1979-01-12	1981-01-01	2	4018
66327	4530	1125315	1980-07-19	1980-10-17	2	3942
13831	948	1115008	2007-12-29	2008-01-19	1	13897
62140	4240	1713332	1996-07-28	1996-08-04	1	9712
11569	793	1118084	2010-05-14	2010-05-14	1	14743
50341	3430	1361711	2001-03-17	2001-03-17	1	11398
66667	4551	1125315	2016-07-20	2016-07-27	1	17009
19517	1332	1125315	1999-12-14	1999-12-21	1	10946
16788	1154	1759842	1976-02-16	1976-03-01	1	2251
46656	3170	1125315	1987-10-01	1987-10-15	1	6496
14688	1015	738818	1979-12-29	1980-01-05	1	3656
55518	3778	1713332	1997-01-12	1997-02-02	1	9894
17279	1193	1125315	1979-12-05	1979-12-12	1	3632
55121	3750	1125315	1999-03-20	1999-06-18	1	10760
13817	946	1125315	1970-08-18	1970-08-25	1	236
63216	4320	1367571	1970-05-14	1970-05-14	1	133
16104	1113	19127890	1992-10-14	1994-10-04	2	9042
61109	4167	1125315	1992-12-06	1992-12-13	1	8382
63987	4372	1515774	1994-05-05	1995-04-30	1	9250
20701	1410	1717327	1970-12-24	1971-01-07	1	371
54075	3678	1713332	1986-08-19	1986-09-02	1	6088
13233	906	1515774	1992-01-25	1993-01-19	1	8419
12977	885	1729720	1984-03-22	1984-04-04	1	5207
58468	3987	1119510	2010-08-17	2010-08-31	1	14852
53089	3618	1125315	1960-07-13	1960-07-27	1	-3445
20976	1431	1759842	1985-05-25	1985-06-15	1	5644
74757	5116	1125315	2011-04-24	2011-05-01	1	15095
14422	987	1717327	1970-08-01	1970-09-05	1	247
65027	4442	1503184	1998-05-27	1999-05-22	1	10733
7716	534	1521369	1992-06-16	1993-06-11	1	8562
54657	3718	19127890	1988-09-04	1990-08-25	2	7541
74143	5068	1125315	1983-08-29	1983-09-05	1	4995
62174	4241	1729720	1973-11-13	1973-11-24	1	1423
19576	1335	1549786	1997-10-21	1998-10-16	1	10515
21121	1439	1521369	1995-07-20	1996-07-14	1	9691
68718	4689	1125315	1998-10-01	1998-10-15	1	10514
16841	1159	1177480	2007-09-03	2007-09-24	1	13780
57011	3885	1125315	1980-05-27	1980-06-10	1	3813
15002	1039	1125315	1978-10-02	1978-10-02	1	3196
28052	1902	1759842	1995-01-20	1995-02-10	1	9171
16470	1137	1125315	1957-01-06	1957-04-06	1	-4653
23271	1578	920293	1977-04-26	1977-05-03	1	2679
59914	4085	1713332	1994-01-07	1994-01-14	1	8779
24600	1659	1125315	2004-08-24	2004-09-07	1	12668
66597	4547	1125315	1994-02-02	1994-02-09	1	8805
13434	919	1125315	1998-11-09	1998-11-16	1	10546
43386	2935	1125315	1984-12-21	1985-01-20	1	5498
63054	4308	1154343	1915-08-28	1915-08-28	1	-19850
20666	1408	1112807	1954-09-03	1954-10-01	1	-5571
57752	3939	1738521	1976-05-09	1976-05-23	1	2334
7418	512	1778162	1994-12-14	1994-12-28	1	9127
63546	4343	1115008	2009-10-23	2009-11-06	1	14554
15652	1084	1759842	2008-04-23	2008-05-07	1	14006
60548	4130	1118084	2004-04-28	2004-04-28	1	12536
12345	847	1503184	1980-04-04	1981-03-30	1	4106
12574	864	715997	1997-07-31	1997-07-31	1	10073
63865	4365	1322184	2016-01-10	2016-01-10	1	16810
18198	1253	1713332	1995-09-13	1995-10-04	1	9407
66328	4530	1125315	1991-11-14	1991-11-21	1	7994
13832	948	1124957	1972-05-15	1972-05-15	1	865
62141	4240	1759842	1971-08-26	1971-09-02	1	609
11570	793	1125315	1992-07-02	1992-07-09	1	8225
50342	3430	1713332	1966-05-20	1966-05-27	1	-1315
67839	4631	738818	1913-10-09	1913-10-16	1	-20531
19518	1332	1713332	1982-08-28	1982-09-18	1	4643
16789	1154	19127890	1985-08-28	1986-08-23	1	6078
46657	3170	1728416	1951-07-20	1951-08-03	1	-6726
14689	1015	738818	1984-11-21	1984-11-28	1	5445
55519	3778	1759842	1997-01-12	1997-02-02	1	9894
17280	1193	1125315	2008-07-08	2008-07-15	1	14075
55122	3750	1728416	1960-12-18	1961-01-01	1	-3287
13818	946	1713332	2014-07-17	2014-10-23	1	16366
63217	4320	1717327	1973-04-03	1973-04-17	1	1202
16105	1113	1125315	1971-12-16	1971-12-30	1	728
61110	4167	1125315	2002-01-13	2002-01-20	1	11707
63988	4372	1549786	1994-05-05	1995-04-30	1	9250
20702	1410	1729720	1973-02-24	1973-03-04	1	1158
54076	3678	1729720	1982-03-27	1982-04-06	1	4478
13234	906	1549786	1989-02-09	1990-02-04	1	7339
12978	885	1768849	1979-12-03	1979-12-17	1	3637
58469	3987	1124300	1997-02-03	1997-02-03	1	9895
53090	3618	1125315	1982-06-20	1982-09-18	1	4643
20977	1431	1759842	2012-08-28	2012-09-04	1	15587
74758	5116	1192710	1967-06-19	1967-06-19	1	-927
14423	987	1759842	2009-09-07	2009-09-21	1	14508
65028	4442	1549786	1995-06-12	1996-06-06	1	9653
7717	534	1713332	1980-02-09	1980-02-23	1	3705
54658	3718	701322	2017-09-26	2017-09-26	1	17435
74144	5068	1310149	2009-11-28	2009-11-28	1	14576
62175	4241	1759842	1970-07-18	1970-08-08	1	219
19577	1335	1713332	1984-02-06	1984-02-20	1	5163
21122	1439	1112807	1978-12-06	1978-12-20	1	3275
68719	4689	1503184	1981-05-06	1982-05-01	1	4503
16842	1159	1759842	2001-11-28	2001-12-12	1	11668
57012	3885	1125315	1987-09-19	1987-09-26	1	6477
15003	1039	1112807	1964-09-24	1964-10-08	1	-1911
28053	1902	1759842	2011-11-30	2011-12-07	1	15315
16471	1137	1361711	1983-08-12	1983-08-12	1	4971
23272	1578	1115008	2018-11-01	2019-01-30	1	17926
59915	4085	1728416	1959-09-29	1959-10-13	1	-3733
24601	1659	1125315	1971-03-07	1971-03-21	1	444
66598	4547	1125315	2016-10-02	2016-12-01	1	17136
13435	919	1503184	1986-07-21	1987-07-16	1	6405
43387	2935	1125315	2002-04-22	2002-04-29	1	11806
63055	4308	1759842	1981-10-07	1981-10-28	1	4318
20667	1408	1112807	1978-05-10	1978-07-09	1	3111
57753	3939	1759842	1987-07-22	1987-08-12	1	6432
7419	512	1177480	2013-07-14	2013-07-28	1	15914
63547	4343	1125315	1992-02-13	1992-03-12	1	8106
15653	1084	19127890	1992-01-03	1992-12-28	1	8397
60549	4130	1177480	1995-12-07	1996-01-04	1	9499
12346	847	1503184	1982-03-25	1983-03-20	1	4826
12575	864	1112807	1923-12-19	1924-01-23	1	-16780
63866	4365	1728416	1963-06-11	1963-06-25	1	-2382
18199	1253	1713332	2000-06-16	2000-07-07	1	11145
66329	4530	1503184	1988-04-13	1989-04-08	1	7037
13833	948	1125315	1972-05-15	1972-07-14	2	925
62142	4240	1759842	1996-07-28	1996-08-04	1	9712
11571	793	1125315	2017-11-18	2017-11-25	1	17495
50343	3430	1717327	1964-01-31	1964-02-14	1	-2148
67840	4631	1115008	2013-05-01	2013-05-22	1	15847
19519	1332	1759842	1976-06-14	1976-06-21	1	2363
19991	1361	1112807	1955-01-13	1955-03-14	1	-5407
46658	3170	1759842	1953-06-30	1953-07-21	1	-6008
14690	1015	1112807	1983-02-05	1983-03-12	1	4818
55520	3778	1125315	1965-11-28	1965-12-12	1	-1481
17281	1193	1729720	1953-03-12	1953-03-25	1	-6126
55123	3750	1729720	1981-01-29	1981-02-11	1	4059
13819	946	1729720	1979-07-16	1979-07-28	1	3495
63218	4320	19003953	1970-05-14	1970-05-14	1	133
16106	1113	1503184	1985-11-12	1987-11-02	2	6514
61111	4167	1549786	1995-09-08	1996-09-02	1	9741
63989	4372	1713332	1996-11-04	1996-11-11	1	9811
20703	1410	19127890	1983-03-01	1984-02-24	1	5167
54077	3678	738818	2016-02-16	2016-02-23	1	16854
13235	906	1549786	1992-01-25	1993-01-19	1	8419
12979	885	705944	1987-04-10	1989-02-17	1	6987
58470	3987	1125315	2010-08-17	2010-08-31	1	14852
53091	3618	920293	1931-02-12	1931-02-19	1	-14196
20978	1431	1118084	1989-01-09	1989-01-09	1	6948
74759	5116	1125315	1998-03-25	1998-04-01	1	10317
14424	987	1768849	1979-07-20	1979-08-24	1	3522
65029	4442	1177480	1987-02-14	1987-03-07	1	6274
7718	534	1713332	1983-09-09	1983-09-23	1	5013
54659	3718	715997	2017-09-26	2017-09-26	1	17435
74145	5068	1361711	2008-11-22	2008-11-22	1	14205
62176	4241	1759842	1978-12-03	1978-12-10	1	3265
19578	1335	1713332	2007-06-27	2007-07-04	1	13698
21123	1439	1125315	1982-06-09	1982-06-23	1	4556
68720	4689	1503184	1990-03-19	1991-03-14	1	7742
16843	1159	1125315	1984-03-15	1984-03-29	1	5201
57013	3885	1125315	2003-06-06	2003-06-13	1	12216
15004	1039	1112807	1978-10-02	1978-12-01	1	3256
31006	2094	1125315	1966-08-11	1966-08-25	1	-1225
16472	1137	1713332	1984-09-07	1984-09-14	1	5370
23273	1578	1125315	1950-09-27	1950-10-11	1	-7022
59916	4085	1728416	1961-11-02	1961-11-16	1	-2968
24602	1659	1177480	1976-07-17	1976-07-31	1	2403
66599	4547	1174888	1997-09-07	1997-09-07	1	10111
13436	919	1119510	1992-08-19	1992-09-02	1	8280
43388	2935	1177480	2004-02-08	2004-02-22	1	12470
63056	4308	1768849	1981-10-09	1981-11-06	1	4327
20668	1408	1322184	2015-03-23	2015-03-23	1	16517
57754	3939	1759842	2017-03-28	2017-04-04	1	17260
7420	512	1112807	1955-08-13	1955-08-27	1	-5241
63548	4343	1713332	1959-08-01	1959-08-22	1	-3785
15654	1084	1115008	2016-10-13	2016-11-10	1	17115
60550	4130	1326303	2014-05-08	2014-05-08	1	16198
12347	847	1503184	1984-03-14	1985-03-09	1	5546
12576	864	1125315	1930-05-07	1930-05-21	1	-14470
65495	4475	1112807	1987-06-04	1987-06-18	1	6377
18200	1253	1759842	2002-01-04	2002-01-25	1	11712
66608	4548	1125315	1987-01-02	1987-01-16	1	6224
13834	948	1125315	1974-05-09	1974-05-23	1	1603
62143	4240	1118084	1985-12-02	1985-12-02	1	5814
11572	793	1125315	1982-03-23	1982-03-30	1	4471
50344	3430	19127890	1977-07-01	1978-06-26	1	3098
67841	4631	1125315	1982-06-03	1982-06-24	1	4557
19520	1332	738818	1970-05-12	1970-05-19	1	138
19992	1361	1124957	1999-10-31	1999-10-31	1	10895
47318	3214	1118084	2008-11-27	2008-11-27	1	14210
14691	1015	1118084	1988-06-04	1988-06-04	1	6729
55521	3778	1177480	2003-12-09	2003-12-23	1	12409
17282	1193	1112807	1965-05-12	1965-05-26	1	-1681
55124	3750	1738521	1974-02-25	1974-03-11	1	1530
14072	964	1125315	1995-02-16	1995-03-02	1	9191
63219	4320	19127890	1988-03-04	1990-02-22	2	7357
16107	1113	1759842	1978-04-17	1978-04-24	1	3035
61112	4167	1729720	1983-10-24	1983-11-02	1	5053
63990	4372	19127890	1994-05-05	1998-04-14	4	10330
20704	1410	19127890	1988-02-03	1989-01-28	1	6967
54078	3678	1118084	2017-07-30	2017-07-30	1	17377
13236	906	1729720	1976-03-10	1976-03-19	1	2269
12980	885	1713332	1993-12-10	1993-12-24	1	8758
58471	3987	1177480	2008-03-01	2008-04-30	1	13999
53092	3618	1118084	1953-01-31	1953-01-31	1	-6179
20979	1431	1119510	2019-03-21	2019-04-04	1	17990
74760	5116	1112807	1969-12-28	1970-01-11	1	10
17049	1175	1112807	1943-06-02	1943-06-16	1	-9696
65030	4442	1177480	1991-09-12	1991-12-11	1	8014
7719	534	1759842	1982-04-10	1982-05-02	1	4504
54660	3718	738818	1994-02-02	1994-02-09	1	8805
74146	5068	1125315	1962-04-09	1962-04-16	1	-2817
62177	4241	1759842	1998-05-25	1998-06-08	1	10385
19579	1335	1729720	1984-12-15	1984-12-27	1	5474
21124	1439	1177480	1991-10-29	1992-01-27	1	8061
68721	4689	1728416	1969-04-29	1969-05-13	1	-233
16844	1159	1713332	1980-09-24	1980-10-08	1	3933
57014	3885	1729720	1973-06-17	1973-06-26	1	1272
15005	1039	1125315	1995-06-15	1995-06-29	1	9310
31007	2094	1115008	2014-08-04	2014-08-18	1	16300
16473	1137	1759842	1984-09-07	1984-09-14	1	5370
23274	1578	1125315	1999-08-22	1999-11-20	2	10915
62526	4269	738818	2010-03-23	2010-03-30	1	14698
24603	1659	1177480	1980-03-19	1980-06-17	1	3820
66600	4547	1713332	2001-07-14	2001-07-28	1	11531
13437	919	1549786	1992-06-19	1993-06-14	1	8565
43389	2935	1177480	2018-06-08	2018-06-22	1	17704
63057	4308	920293	1953-09-16	1953-09-23	1	-5944
20669	1408	1332418	2015-03-23	2015-03-23	1	16517
57755	3939	1713332	1979-07-21	1979-08-04	1	3502
7421	512	1119510	1963-10-02	1963-10-16	1	-2269
63549	4343	1729720	2019-06-24	2019-06-24	1	18071
15655	1084	1125315	1979-09-28	1979-10-12	1	3571
60551	4130	1728416	1966-05-25	1966-06-08	1	-1303
12348	847	1515774	1989-02-16	1990-02-11	1	7346
12577	864	1125315	1935-12-21	1935-12-21	1	-12430
65496	4475	1759842	2004-06-12	2004-06-26	1	12595
18201	1253	19127890	1979-01-12	1981-01-01	2	4018
66609	4548	1125315	1988-10-15	1988-10-29	1	6876
13835	948	1729720	1980-08-08	1980-08-15	1	3879
62144	4240	1125315	1981-05-26	1981-06-09	1	4177
11573	793	1125315	1983-11-04	1983-11-11	1	5062
50345	3430	1149380	1992-03-07	1992-03-07	1	8101
67842	4631	1125315	2002-06-28	2002-06-28	1	11866
19521	1332	1125315	1970-05-12	1970-05-19	1	138
19993	1361	1125315	1978-10-13	1978-10-27	1	3221
47319	3214	1125315	1991-05-02	1991-05-16	2	7805
14692	1015	1125315	1984-11-21	1984-11-28	1	5445
56612	3857	1112807	1945-12-24	1946-01-07	1	-8760
17283	1193	1125315	1964-03-20	1964-04-17	1	-2085
55125	3750	1102527	1999-03-20	1999-03-20	1	10670
14073	964	1713332	2015-06-28	2015-07-05	1	16621
63220	4320	782043	1970-05-14	1970-05-14	1	133
16108	1113	1759842	2014-03-13	2014-03-27	1	16156
61113	4167	19127890	1995-09-08	1996-09-02	1	9741
65119	4450	1125315	1970-03-16	1970-03-30	1	88
20705	1410	1118084	2004-05-25	2004-05-25	1	12563
54079	3678	1125315	1978-06-15	1978-06-29	1	3101
13237	906	1119510	1991-05-21	1991-05-28	1	7817
12981	885	1177480	2002-07-11	2002-07-25	1	11893
58472	3987	1310149	2016-03-05	2016-03-05	1	16865
53093	3618	1125315	1943-03-21	1943-03-28	1	-9776
20980	1431	1125315	1963-06-22	1963-07-06	1	-2371
74761	5116	1125315	1969-01-03	1969-01-10	1	-356
17050	1175	1125315	1979-06-25	1979-07-09	1	3476
65031	4442	1521369	1998-05-27	1999-05-22	1	10733
7720	534	19127890	1997-05-25	1999-05-15	2	10726
54661	3718	1124300	2002-03-10	2002-03-10	1	11756
74147	5068	1125315	1966-06-16	1966-06-30	1	-1281
62178	4241	19127890	1979-10-19	1980-10-13	1	3938
19580	1335	1125315	1984-02-06	1984-02-20	1	5163
21125	1439	1713332	1980-10-05	1980-10-19	1	3944
68722	4689	1729720	1968-07-07	1968-07-15	1	-535
16845	1159	1118084	2014-11-30	2014-11-30	1	16404
57015	3885	19127890	1983-10-07	1985-09-26	2	5747
15006	1039	1713332	1980-02-01	1980-02-08	1	3690
31008	2094	1112807	1948-09-14	1948-10-14	1	-7749
16474	1137	701322	2009-02-10	2009-02-10	1	14285
23275	1578	1125315	2017-10-16	2017-11-06	1	17476
62527	4269	1125315	1988-02-28	1988-03-13	1	6646
24604	1659	1738521	1971-03-07	1971-03-21	1	444
66601	4547	1759842	1955-12-06	1955-12-20	1	-5126
13438	919	1713332	2002-02-06	2002-02-13	1	11731
43390	2935	1713332	1980-10-02	1980-10-16	1	3941
63058	4308	1713332	1938-10-11	1938-10-25	1	-11391
20670	1408	1713332	1959-04-06	1959-04-27	1	-3902
57756	3939	1125315	1993-05-12	1993-05-26	1	8546
7422	512	1125315	2013-06-07	2013-06-14	1	15870
63550	4343	738818	1961-07-28	1961-08-11	1	-3065
15656	1084	1503184	1997-12-02	1998-11-27	1	10557
60552	4130	1112807	1966-05-25	1966-06-08	1	-1303
12349	847	1515774	1991-02-06	1992-02-01	1	8066
12578	864	1361711	2003-07-28	2003-07-28	1	12261
65497	4475	1759842	2017-08-04	2017-08-11	1	17389
18202	1253	1112807	1969-02-23	1969-03-09	1	-298
66610	4548	1125315	1989-06-27	1989-07-04	1	7124
13836	948	1717327	1961-08-21	1961-09-04	1	-3041
62145	4240	1713332	1971-08-26	1971-09-02	1	609
11574	793	1125315	1988-01-30	1988-02-13	1	6617
50346	3430	1332418	2001-03-17	2001-03-17	1	11398
67843	4631	1322184	2015-09-18	2015-09-18	1	16696
19522	1332	1125315	2019-01-02	2019-01-02	1	17898
19994	1361	738818	2000-06-08	2000-06-22	1	11130
47320	3214	1713332	2018-11-27	2018-12-18	1	17883
14693	1015	1125315	1994-11-25	1994-12-09	1	9108
56613	3857	1119510	1972-05-25	1972-06-08	1	889
17284	1193	1125315	1975-04-15	1975-04-29	1	1944
55126	3750	1112807	1960-12-18	1961-01-01	1	-3287
14074	964	1759842	2009-12-30	2010-01-06	1	14615
63221	4320	1503184	1984-03-25	1985-03-20	1	5557
16109	1113	19127890	1989-10-30	1990-10-25	1	7602
61114	4167	705944	1992-09-16	1996-09-25	1	9764
65120	4450	1174888	2015-04-16	2015-04-16	1	16541
20706	1410	1521369	1991-01-26	1992-01-21	1	8055
54080	3678	1125315	2016-02-16	2016-02-23	1	16854
13238	906	1729720	1979-01-07	1979-01-15	1	3301
12982	885	1713332	1988-12-18	1989-01-01	1	6940
58473	3987	1326303	2016-03-05	2016-03-05	1	16865
53094	3618	1759842	1991-02-20	1991-03-13	1	7741
20981	1431	1125315	2018-07-09	2018-07-16	1	17728
74762	5116	1125315	1989-04-14	1989-04-28	1	7057
17051	1175	1125315	1981-05-16	1981-05-30	1	4167
65032	4442	1713332	1984-11-05	1984-11-19	1	5436
8804	608	1118084	2012-11-29	2012-11-29	1	15673
54662	3718	1125315	1973-10-15	1973-10-22	1	1390
74148	5068	1125315	1969-10-26	1969-11-09	1	-53
62179	4241	1119510	1972-12-15	1972-12-22	1	1086
19581	1335	1125315	1990-09-02	1990-10-07	1	7584
21126	1439	1717327	1978-12-06	1978-12-20	1	3275
68723	4689	19127890	1983-04-26	1984-04-19	1	5222
16846	1159	1125315	1986-01-27	1986-02-10	1	5884
57016	3885	738818	1981-10-29	1981-11-12	1	4333
15007	1039	1717327	1964-09-24	1964-10-08	1	-1911
31009	2094	1125315	1989-12-09	1989-12-16	1	7289
16475	1137	1125315	1952-08-09	1952-08-30	1	-6333
23276	1578	1322184	2015-07-19	2015-07-19	1	16635
62528	4269	1503184	1988-03-27	1989-03-22	1	7020
24605	1659	1759842	1974-12-19	1975-06-05	1	1981
66602	4547	1759842	1966-06-30	1966-07-14	1	-1267
13439	919	1759842	2002-02-06	2002-02-13	1	11731
43391	2935	1729720	2001-01-27	2001-02-09	1	11362
63059	4308	1713332	1988-05-29	1988-06-05	1	6730
20671	1408	1713332	1994-08-11	1995-02-09	1	9170
57757	3939	1125315	2013-03-29	2013-04-12	1	15807
7423	512	1713332	1999-02-11	1999-02-25	1	10647
63551	4343	1112807	1958-07-29	1958-10-04	1	-4107
15657	1084	1515774	1992-01-03	1992-12-28	1	8397
60553	4130	1115008	1999-12-19	2000-01-02	1	10958
12350	847	1521369	1984-03-14	1985-03-09	1	5546
12579	864	1112807	1935-12-21	1936-01-25	1	-12395
65498	4475	1124300	2013-09-30	2013-09-30	1	15978
18203	1253	1713332	1984-12-13	1985-01-03	1	5481
66611	4548	1125315	2016-04-17	2016-04-24	1	16915
13837	948	1728416	1960-05-11	1960-05-25	1	-3508
62146	4240	1102527	2010-10-04	2010-10-04	1	14886
11575	793	1125315	1993-08-10	1993-08-17	1	8629
50347	3430	1539403	2001-03-17	2001-03-17	1	11398
67844	4631	1332418	2015-09-18	2015-09-18	1	16696
19523	1332	1332418	1999-08-04	1999-08-04	1	10807
19995	1361	1112807	1952-07-18	1952-08-01	1	-6362
47321	3214	1738521	1976-09-14	1976-09-28	1	2462
14694	1015	1309944	1973-07-23	1973-07-23	1	1299
56614	3857	1729720	1954-10-11	1954-10-21	1	-5551
17285	1193	1125315	1976-01-29	1976-02-28	1	2249
55127	3750	1125315	1977-08-22	1977-09-05	1	2804
14075	964	1768849	1979-11-07	1979-11-21	1	3611
63222	4320	19127890	1984-03-25	1985-03-20	1	5557
17405	1205	1112807	1961-03-15	1961-03-29	1	-3200
61115	4167	1118084	2015-11-30	2015-11-30	1	16769
65121	4450	1177480	2015-04-16	2015-05-16	1	16571
20707	1410	1112807	1971-04-23	1971-05-08	1	492
54081	3678	1778162	1988-12-24	1989-01-07	1	6946
13239	906	19127890	1989-02-09	1990-02-04	1	7339
12983	885	1759842	1988-12-18	1989-01-01	1	6940
58474	3987	1759842	1974-08-05	1974-08-12	1	1684
53095	3618	1112807	1913-07-05	1913-07-19	1	-20620
20982	1431	1713332	1985-05-25	1985-06-15	1	5644
74763	5116	1728416	1966-10-16	1966-10-30	1	-1159
17052	1175	1177480	1981-07-14	1981-07-28	1	4226
65033	4442	1759842	2005-12-01	2005-12-08	1	13125
8805	608	1125315	1975-03-16	1975-03-30	1	1914
54663	3718	1515774	1989-08-30	1990-08-25	1	7541
74149	5068	1322184	2008-11-22	2009-07-11	1	14436
62180	4241	1125315	1987-12-26	1988-01-09	1	6582
19582	1335	1125315	2017-06-24	2017-07-01	1	17348
21127	1439	738818	2019-05-12	2019-05-26	1	18042
68724	4689	19127890	1986-04-09	1987-04-04	1	6302
16847	1159	1500211	2001-06-23	2002-06-18	1	11856
57017	3885	920293	1995-12-22	1996-01-05	2	9500
15008	1039	1759842	2012-01-30	2012-02-13	1	15383
31010	2094	1125315	2018-12-17	2018-12-24	1	17889
16476	1137	1125315	1989-10-02	1989-10-23	1	7235
23277	1578	1332418	2015-07-19	2015-07-19	1	16635
62529	4269	1521369	1988-03-27	1989-03-22	1	7020
26020	1761	1124300	1995-03-02	1995-03-02	1	9191
66603	4547	1759842	2001-07-14	2001-07-28	1	11531
13440	919	19127890	1986-07-21	1987-07-16	1	6405
43392	2935	19127890	1990-04-04	1994-03-14	4	8838
63060	4308	1729720	1916-12-29	1917-01-05	1	-19354
20672	1408	1728416	1947-08-11	1947-08-25	1	-8165
57758	3939	1729720	1982-12-22	1982-12-30	1	4746
7424	512	1728416	1960-02-05	1960-02-19	1	-3604
63552	4343	1112807	1967-03-05	1967-04-04	1	-1003
15658	1084	1549786	1998-11-27	1999-11-22	1	10917
60554	4130	1125315	1986-07-28	1986-08-11	1	6066
12351	847	1729720	1992-01-23	1992-02-03	1	8068
12580	864	1115008	2001-07-11	2001-09-09	1	11574
65499	4475	1125315	1983-08-24	1983-09-23	1	5013
18204	1253	1728416	1956-12-28	1957-01-11	1	-4738
66612	4548	1150770	1986-11-07	1986-11-07	1	6154
13838	948	1729720	1993-06-19	1993-06-26	1	8577
62147	4240	1112807	1943-06-11	1943-07-16	1	-9666
11576	793	1125315	2003-02-27	2003-03-06	1	12117
50348	3430	1713332	1989-02-28	1989-03-14	1	7012
67845	4631	1713332	1950-02-15	1950-03-01	1	-7246
19524	1332	1361711	1999-08-04	2019-01-02	1	17898
19996	1361	1119510	2000-06-08	2000-06-22	1	11130
47322	3214	1759842	1979-01-17	1979-02-07	1	3324
14695	1015	1343916	1973-07-23	1973-07-23	1	1299
56615	3857	738818	1960-06-10	1960-06-17	1	-3485
17286	1193	1125315	1998-06-07	1998-06-21	1	10398
55128	3750	1125315	2003-11-24	2003-12-01	1	12387
14076	964	1768849	1981-04-17	1981-05-01	1	4138
63223	4320	738818	2013-05-25	2013-06-08	1	15864
17406	1205	1119510	1975-07-20	1975-08-03	1	2040
61116	4167	1125315	1979-10-15	1979-10-29	1	3588
65122	4450	1713332	1999-10-16	1999-10-23	1	10887
20708	1410	1115008	2008-02-22	2008-03-07	1	13945
54082	3678	738818	1985-09-23	1985-09-30	1	5751
13240	906	19127890	1992-01-25	1993-01-19	1	8419
13455	921	1118084	2004-04-02	2004-04-02	1	12510
58475	3987	1759842	2003-09-25	2003-10-02	1	12327
53096	3618	1112807	1926-12-22	1927-01-19	1	-15688
20983	1431	1713332	2012-08-28	2012-09-04	1	15587
74764	5116	1112807	1966-10-16	1966-10-30	1	-1159
17053	1175	1713332	1981-07-14	1981-07-28	1	4226
65034	4442	1125315	1994-03-10	1994-03-17	1	8841
8806	608	1177480	2004-10-21	2004-11-04	1	12726
54664	3718	1549786	1989-08-30	1990-08-25	1	7541
74150	5068	1332418	2008-11-22	2008-11-22	1	14205
62181	4241	1177480	1985-02-28	1985-03-21	1	5558
19583	1335	1759842	2007-06-27	2007-07-04	1	13698
21128	1439	1125315	2019-05-12	2019-05-26	1	18042
68725	4689	1125315	1969-04-29	1969-05-13	1	-233
16848	1159	1549786	1995-07-25	1996-07-19	1	9696
57018	3885	1112807	1973-09-10	1973-10-01	1	1369
16595	1145	738818	2002-06-08	2002-06-15	1	11853
31011	2094	1177480	2002-07-17	2002-08-07	1	11906
16477	1137	1125315	2011-04-06	2011-04-20	1	15084
23278	1578	1729720	1952-01-11	1952-01-18	1	-6558
62530	4269	1115008	2013-12-27	2014-01-31	1	16101
26021	1761	1125315	1960-10-12	1960-11-15	1	-3334
66604	4547	1112807	1910-04-11	1910-04-25	1	-21801
13441	919	19127890	1992-06-19	1993-06-14	1	8565
43393	2935	19127890	1998-02-21	1999-02-16	1	10638
63061	4308	1729720	1938-04-16	1938-04-26	1	-11573
20673	1408	1759842	1948-05-16	1948-06-06	1	-7879
57759	3939	1118084	2011-12-02	2011-12-02	1	15310
7425	512	1759842	1999-02-11	1999-02-25	1	10647
63553	4343	1125315	1961-07-28	1961-08-11	1	-3065
15659	1084	1595799	1998-11-27	1999-11-22	1	10917
60555	4130	1125315	2019-05-17	2019-05-31	1	18047
12352	847	1125315	1985-03-20	1985-04-10	1	5578
12581	864	1118084	1958-05-04	1958-05-04	1	-4260
65500	4475	1125315	1988-08-27	1988-10-26	1	6873
18205	1253	1728416	1960-11-24	1960-12-08	1	-3311
66613	4548	1177480	1995-05-18	1995-06-01	1	9282
13839	948	1125315	1964-05-13	1964-05-27	1	-2045
62148	4240	1115008	2010-10-04	2010-12-03	1	14946
11577	793	1177480	2012-02-13	2012-04-20	1	15450
50349	3430	1759842	1966-05-20	1966-05-27	1	-1315
67846	4631	738818	1939-10-21	1939-11-04	1	-11016
19525	1332	1539403	1999-08-04	1999-08-04	1	10807
19997	1361	1125315	2000-06-08	2000-06-22	1	11130
47323	3214	1759842	2018-11-27	2018-12-18	1	17883
14696	1015	1713332	2009-12-29	2010-01-05	1	14614
56616	3857	1112807	1956-07-20	1956-08-17	1	-4885
17287	1193	1713332	2004-04-07	2004-04-28	1	12536
55129	3750	1125315	2012-01-11	2012-03-11	1	15410
14077	964	738818	1981-04-02	1981-04-16	1	4123
63224	4320	920293	2016-04-27	2016-05-04	1	16925
17407	1205	1125315	1964-12-26	1965-01-09	1	-1818
61117	4167	1125315	2016-01-12	2016-01-19	1	16819
65123	4450	1124300	2008-12-19	2008-12-19	1	14232
20709	1410	1125315	2016-12-19	2017-01-02	1	17168
54083	3678	1125315	1980-06-06	1980-06-20	1	3823
13241	906	738818	1991-05-21	1991-05-28	1	7817
13456	921	1125315	1983-03-25	1983-06-23	1	4921
58476	3987	933724	2004-01-26	2004-02-02	1	12450
53097	3618	1713332	1991-02-20	1991-03-13	1	7741
20984	1431	1728416	1967-08-04	1967-08-18	1	-867
74765	5116	1118084	2010-05-03	2010-05-03	1	14732
17054	1175	1729720	1949-01-15	1949-01-24	1	-7647
65035	4442	1515774	1995-06-12	1996-06-06	1	9653
8807	608	1177480	2008-11-13	2008-11-27	1	14210
54665	3718	1738521	1970-10-11	1970-10-25	1	297
74151	5068	1347450	2009-07-11	2009-07-11	1	14436
62182	4241	1713332	1970-07-18	1970-08-08	1	219
19584	1335	1112807	1979-11-15	1979-11-29	1	3619
21129	1439	1729720	1985-01-05	1985-01-12	1	5490
68726	4689	1125315	1972-01-13	1972-02-03	1	763
16849	1159	1713332	1984-03-15	1984-03-29	1	5201
57019	3885	1115008	1995-02-11	1995-03-04	1	9193
16596	1145	920293	1957-10-21	1957-10-28	1	-4448
31012	2094	1728416	1945-02-02	1945-02-16	1	-9085
16478	1137	1322184	1998-06-26	1998-06-26	1	10403
23279	1578	1759842	1962-08-03	1962-08-24	1	-2687
62531	4269	1124300	2007-06-11	2007-06-11	1	13675
26022	1761	1125315	1995-09-30	1995-10-07	1	9410
66605	4547	1124300	1948-08-24	1948-08-24	1	-7800
13442	919	738818	1992-08-19	1992-09-02	1	8280
43394	2935	1124300	2013-08-16	2013-08-16	1	15933
63062	4308	1759842	1938-10-11	1938-10-25	1	-11391
20674	1408	1112807	1947-08-11	1947-08-25	1	-8165
57760	3939	1177480	1976-05-09	1976-05-23	1	2334
12204	841	975125	1965-07-04	1965-07-25	1	-1621
63554	4343	1125315	1994-01-28	1994-02-11	1	8807
15660	1084	19127890	1997-12-02	1998-11-27	1	10557
60556	4130	1717327	1965-06-17	1965-07-01	1	-1645
12353	847	1549786	1989-02-16	1990-02-11	1	7346
12582	864	1125315	1963-09-26	1963-10-10	1	-2275
65501	4475	1125315	2016-01-19	2016-02-02	1	16833
18206	1253	1759842	1984-12-13	1985-01-03	1	5481
66614	4548	1361711	2018-07-03	2018-07-03	1	17715
13840	948	1125315	1965-12-13	1965-12-20	1	-1473
62149	4240	1119510	1963-04-29	1963-05-13	1	-2425
11578	793	1102527	2012-02-20	2012-02-20	1	15390
52577	3580	738818	2006-10-15	2006-10-22	1	13443
67847	4631	1112807	1921-12-24	1922-01-21	1	-17512
19526	1332	1713332	1947-01-01	1947-01-08	1	-8394
19998	1361	1177480	1974-07-02	1974-07-30	1	1671
47324	3214	738818	2017-05-17	2017-05-24	1	17310
14697	1015	1759842	2009-12-29	2010-01-05	1	14614
56617	3857	1118084	1978-01-15	1978-01-15	1	2936
17288	1193	1759842	2004-04-07	2004-04-28	1	12536
55130	3750	1729720	1977-11-23	1977-12-02	1	2892
14078	964	1124300	2012-08-15	2012-08-15	1	15567
63225	4320	933724	2016-04-27	2016-05-04	1	16925
17408	1205	1125315	1974-08-04	1974-09-01	1	1704
61118	4167	1177480	2016-08-15	2016-09-19	1	17063
65124	4450	1125315	2008-01-09	2008-01-23	1	13901
20710	1410	1503184	1991-01-26	1992-01-21	1	8055
54084	3678	1125315	1985-09-23	1985-09-30	1	5751
13242	906	920293	2017-03-22	2017-04-05	2	17261
13457	921	1125315	2004-02-04	2004-02-18	1	12466
58477	3987	1177480	1993-01-21	1993-02-18	1	8449
53098	3618	1112807	1923-05-14	1923-06-11	1	-17006
20985	1431	1759842	1966-02-26	1966-03-05	1	-1398
74766	5116	1125315	1977-05-29	1977-06-05	1	2712
17055	1175	1759842	2017-02-15	2017-03-08	1	17233
66402	4534	723013	1956-10-23	1957-10-22	1	-4454
8808	608	1738521	1975-04-13	1975-04-27	1	1942
54666	3718	19127890	1980-10-16	1981-10-11	1	4301
74152	5068	1539403	2008-11-22	2008-11-22	1	14205
62183	4241	1713332	1978-12-03	1978-12-10	1	3265
19585	1335	1115008	1998-05-28	1998-06-18	1	10395
21130	1439	1119510	2003-07-20	2003-07-27	1	12260
68727	4689	1177480	2014-03-06	2014-03-28	1	16157
16850	1159	1713332	2001-11-28	2001-12-12	1	11668
57020	3885	1125315	1963-11-11	1963-12-02	1	-2222
16597	1145	933724	1957-10-21	1957-10-28	1	-4448
31013	2094	1729720	1950-08-08	1950-08-21	1	-7073
16479	1137	1521369	1974-07-25	1975-07-20	1	2026
23280	1578	1759842	1992-07-31	1992-08-21	1	8268
62532	4269	1125315	1975-02-24	1975-03-17	1	1901
26023	1761	1125315	2014-04-21	2014-05-21	1	16211
66606	4547	1125315	1990-11-22	1990-12-13	1	7651
13443	919	1125315	1992-08-19	1992-09-02	1	8280
43395	2935	1125315	1978-06-26	1978-07-10	1	3112
63063	4308	1759842	1988-05-29	1988-06-05	1	6730
20675	1408	1112807	1959-08-06	1959-09-03	1	-3773
57761	3939	1729720	1978-08-01	1978-08-13	1	3146
12205	841	1125315	1966-08-31	1966-09-07	1	-1212
63555	4343	1713332	1979-07-01	1979-07-08	1	3475
15857	1098	933724	1998-01-14	1998-01-21	1	10247
64123	4381	1112807	1965-03-29	1965-06-04	2	-1688
12354	847	1729720	2008-05-22	2008-05-29	1	14028
12583	864	1125315	1988-09-28	1988-10-19	1	6866
65502	4475	1125315	1992-10-06	1992-10-13	1	8321
18207	1253	19127890	1977-01-22	1978-01-17	1	2938
66615	4548	1539403	2018-07-03	2018-07-03	1	17715
13841	948	1125315	1967-05-12	1967-08-10	1	-875
62150	4240	1125315	1964-07-23	1964-08-06	1	-1974
12842	879	1728416	1953-04-06	1953-04-20	1	-6100
52578	3580	1125315	2006-10-15	2006-10-22	1	13443
67848	4631	1119510	1913-10-09	1913-10-16	1	-20531
19527	1332	1759842	1982-08-28	1982-09-18	1	4643
19999	1361	1738521	1978-10-13	1978-10-27	1	3221
47325	3214	1124957	1991-05-02	1991-05-02	1	7791
14698	1015	914335	1973-07-23	1973-07-23	1	1299
56618	3857	1125315	1960-06-10	1960-06-17	1	-3485
17289	1193	1102527	1976-01-29	1976-01-29	1	2219
55131	3750	1729720	2001-10-16	2001-10-25	1	11620
14079	964	1125315	1981-04-02	1981-04-16	1	4123
63226	4320	1000560	1970-05-14	1970-05-14	2	133
17409	1205	1125315	1976-07-22	1976-08-21	1	2424
61119	4167	1192710	1979-06-28	1979-06-28	1	3465
65125	4450	1717327	1967-12-10	1967-12-24	1	-739
20711	1410	1515774	1996-01-09	1997-01-03	1	9864
54085	3678	1177480	1986-08-19	1986-09-02	1	6088
13243	906	933724	2017-03-22	2017-04-05	1	17261
13458	921	1177480	2011-07-22	2011-08-26	1	15212
58478	3987	1125315	1964-11-19	1965-02-17	1	-1779
53910	3668	1112807	1991-05-09	1991-07-08	1	7858
22079	1505	738818	1983-12-02	1983-12-09	1	5090
74767	5116	1125315	1979-07-24	1979-08-14	1	3512
17056	1175	1125315	2009-04-19	2009-05-03	1	14367
66403	4534	738818	1995-01-05	1995-01-12	1	9142
8809	608	1738521	1978-11-08	1978-11-22	1	3247
54667	3718	19127890	1984-09-25	1985-09-20	1	5741
74153	5068	1729720	1945-08-06	1945-08-18	1	-8902
62184	4241	1713332	1986-01-10	1986-01-24	1	5867
19586	1335	1124300	2017-06-28	2017-06-28	1	17345
21131	1439	1125315	1979-07-20	1979-08-03	1	3501
68728	4689	1347450	1993-03-02	1993-03-02	1	8461
16851	1159	19127890	1995-07-25	1996-07-19	1	9696
57021	3885	1125315	1981-10-29	1981-11-12	1	4333
16598	1145	1112807	1938-11-22	1938-12-06	1	-11349
31014	2094	1112807	1945-02-02	1945-02-16	1	-9085
16480	1137	1539403	1991-09-20	1991-09-20	1	7932
23281	1578	1119510	1950-09-27	1950-10-11	1	-7022
62533	4269	1177480	1981-04-14	1981-05-05	1	4142
26024	1761	1729720	2001-01-01	2001-01-10	1	11332
66607	4547	1759842	1938-07-16	1938-07-30	1	-11478
13444	919	1125315	2002-01-30	2002-02-06	1	11724
43396	2935	1125315	1980-10-02	1980-10-16	1	3941
63769	4359	1115008	2012-06-17	2012-08-16	1	15568
20676	1408	1118084	1981-03-10	1981-03-10	1	4086
57762	3939	1759842	1979-07-21	1979-08-04	1	3502
12206	841	1713332	1997-04-07	1997-04-28	1	9979
63556	4343	1759842	1979-07-01	1979-07-08	1	3475
15858	1098	1112807	1975-02-19	1975-03-05	1	1889
64124	4381	1125315	1987-10-23	1987-11-06	1	6518
12355	847	1729720	2008-10-27	2008-11-05	1	14188
12584	864	1125315	2002-07-14	2002-07-21	1	11889
65503	4475	1125315	1994-03-28	1994-04-28	1	8883
18208	1253	1112807	1956-12-28	1957-01-11	1	-4738
66616	4548	1759842	1988-03-17	1988-03-31	1	6664
13842	948	1177480	2000-11-05	2000-12-05	1	11296
62151	4240	1125315	1973-03-10	1973-03-24	1	1178
12843	879	1759842	1998-04-01	1998-04-08	1	10324
52579	3580	1713332	2014-11-17	2015-02-09	1	16475
67849	4631	1125315	1913-10-09	1913-10-16	1	-20531
19528	1332	1112807	1966-11-12	1966-12-03	1	-1125
20000	1361	1112807	1942-04-21	1942-05-05	1	-10103
47326	3214	1125315	1976-03-25	1976-04-22	1	2303
14699	1015	1125315	1976-07-29	1976-08-05	1	2408
56619	3857	1137529	1972-03-14	1972-03-14	1	803
17290	1193	1112807	1955-08-09	1955-09-13	1	-5224
55132	3750	1118084	1993-11-10	1993-11-10	1	8714
14080	964	1503184	1991-10-15	1992-10-09	1	8317
63227	4320	1112807	1973-02-11	1973-02-25	1	1151
17410	1205	1503184	1977-09-27	1978-09-22	1	3186
61120	4167	1713332	1979-08-16	1979-08-30	1	3528
65126	4450	1729720	1982-06-28	1982-07-09	1	4572
20712	1410	1521369	1983-03-01	1984-02-24	1	5167
54086	3678	1177480	1988-12-24	1989-01-07	1	6946
13244	906	1112807	1974-01-19	1974-02-02	1	1493
13459	921	1310149	2016-06-21	2016-06-21	1	16973
58479	3987	1125315	1989-05-23	1989-06-06	1	7096
53911	3668	1119510	2000-08-30	2000-09-06	1	11206
22080	1505	1112807	1968-04-19	1968-05-24	1	-587
74768	5116	1729720	1992-06-04	1992-06-16	1	8202
17057	1175	1112807	1941-04-24	1941-05-08	1	-10465
66404	4534	740275	1957-02-26	1957-02-26	1	-4692
8810	608	1125315	2004-03-27	2004-04-03	1	12511
56850	3875	933724	2005-12-06	2005-12-20	1	13137
75215	5146	1112807	1953-08-19	1953-09-02	1	-5965
62185	4241	1759842	1966-08-23	1966-08-30	1	-1220
19587	1335	19127890	1992-11-16	1994-11-06	2	9075
21132	1439	1125315	1979-09-16	1979-09-30	1	3559
68729	4689	1503184	1983-04-26	1984-04-19	1	5222
16852	1159	1125315	1980-09-24	1980-10-08	1	3933
57022	3885	1125315	2005-09-19	2005-09-26	1	13052
16599	1145	1112807	1941-04-21	1941-05-05	1	-10468
31015	2094	1118084	1985-08-16	1985-08-16	1	5706
16481	1137	738818	1974-07-27	1974-08-03	1	1675
23282	1578	1124300	1986-05-16	1986-05-16	1	5979
62534	4269	1717327	1968-05-31	1968-06-14	1	-566
26025	1761	1125315	1957-10-27	1957-11-10	1	-4435
69019	4709	1112807	1962-03-07	1962-03-21	1	-2843
13445	919	1177480	1998-02-13	1998-03-06	1	10291
43397	2935	1125315	1987-01-10	1987-01-24	1	6232
63770	4359	1125315	1952-07-04	1952-07-18	1	-6376
20677	1408	1361711	2015-03-23	2015-03-23	1	16517
61184	4173	1125315	1964-11-06	1964-11-20	1	-1868
12207	841	1738521	1972-11-26	1972-12-17	1	1081
64238	4388	1115008	1996-10-21	1996-12-27	1	9857
15859	1098	1124300	1996-09-10	1996-09-10	1	9749
64125	4381	1125315	1992-08-29	1992-09-12	1	8290
12356	847	1759842	1975-09-09	1975-09-30	1	2098
12585	864	1713332	1925-04-08	1925-04-29	1	-16318
65504	4475	1125315	2012-09-10	2012-09-17	1	15600
18209	1253	1125315	1975-08-05	1975-10-04	1	2102
66617	4548	1759842	2013-01-26	2013-02-16	1	15752
13843	948	1112807	1961-08-21	1961-09-04	1	-3041
62152	4240	1125315	1981-11-21	1981-12-05	1	4356
12844	879	1115008	2009-03-16	2009-04-06	1	14340
52580	3580	1738521	1979-03-18	1979-04-01	1	3377
67850	4631	1125315	1918-12-21	1918-12-28	1	-18632
19529	1332	1322184	1999-08-04	2019-01-02	1	17898
20001	1361	1115008	1999-10-31	1999-12-30	1	10955
47327	3214	1177480	1975-06-12	1975-06-26	1	2002
14700	1015	1177480	2003-07-25	2003-08-08	1	12272
56620	3857	738818	1972-05-25	1972-06-08	1	889
17291	1193	1177480	2000-02-11	2000-03-03	1	11019
55133	3750	1119510	1987-11-13	1987-11-27	1	6539
14081	964	1549786	1992-10-09	1993-10-04	1	8677
63228	4320	1112807	1973-04-03	1973-04-17	1	1202
17411	1205	1521369	1983-08-27	1984-08-21	1	5346
61121	4167	1713332	1988-08-24	1988-09-14	1	6831
65127	4450	1112807	1967-12-10	1967-12-24	1	-739
20713	1410	1521369	1988-02-03	1989-01-28	1	6967
54087	3678	1177480	2018-03-17	2018-06-15	1	17697
13245	906	1125315	1986-12-12	1986-12-26	1	6203
13460	921	1521369	1980-06-17	1981-06-12	1	4180
58480	3987	1177480	2010-04-20	2010-05-20	1	14749
53912	3668	1125315	2000-08-30	2000-09-06	1	11206
22081	1505	1125315	1974-09-02	1974-09-16	1	1719
74769	5116	1729720	2016-08-23	2016-09-04	1	17048
17058	1175	1118084	1974-05-06	1974-05-06	1	1586
66405	4534	1102527	1996-05-21	1996-05-21	1	9637
8811	608	1125315	2005-07-13	2005-07-13	1	12977
56851	3875	1125315	1982-02-09	1982-02-23	1	4436
75216	5146	1125315	1950-11-26	1950-12-03	1	-6969
62186	4241	1759842	1986-08-30	1986-09-20	1	6106
19588	1335	19127890	1997-10-21	1998-10-16	1	10515
21133	1439	1713332	1982-06-09	1982-06-23	1	4556
68730	4689	1503184	1986-04-09	1987-04-04	1	6302
16853	1159	1515774	1995-07-25	1996-07-19	1	9696
57023	3885	1125315	2014-06-18	2014-06-25	1	16246
16600	1145	1125315	1948-12-30	1949-01-06	1	-7665
31016	2094	1125315	1950-07-06	1950-10-04	1	-7029
16482	1137	757627	2007-10-19	2007-10-19	1	13805
23283	1578	1361711	2015-07-19	2015-07-19	1	16635
62535	4269	1119510	2010-03-23	2010-03-30	1	14698
26026	1761	1125315	1985-12-21	1986-01-04	1	5847
69020	4709	1124300	1998-08-15	1998-08-15	1	10453
13446	919	1515774	1992-06-19	1993-06-14	1	8565
43398	2935	1503184	1993-03-19	1994-03-14	1	8838
63771	4359	1713332	1987-06-13	1987-06-20	1	6379
20678	1408	1713332	1948-05-16	1948-06-06	1	-7879
61185	4173	1125315	1967-03-11	1967-03-25	1	-1013
12208	841	1102527	1972-11-26	1972-11-26	1	1060
64239	4388	1125315	1971-03-02	1971-03-16	1	439
15860	1098	1717327	1961-03-13	1961-03-27	1	-3202
64126	4381	1713332	2013-08-01	2013-08-15	1	15932
12357	847	19127890	1980-04-04	1981-03-30	1	4106
12586	864	1728416	1946-08-21	1946-09-25	1	-8499
65505	4475	1125315	2014-10-18	2014-10-25	1	16368
18210	1253	1125315	2012-07-05	2012-07-19	1	15540
66618	4548	1115008	2000-01-11	2000-02-08	1	10995
13844	948	1124300	1998-03-03	1998-03-03	1	10288
62153	4240	1322184	2010-11-08	2010-11-08	1	14921
12845	879	1124300	1989-02-16	1989-02-16	1	6986
52581	3580	1759842	1995-10-20	1995-10-27	1	9430
67851	4631	1125315	1936-04-01	1936-04-08	1	-12321
19530	1332	1759842	1947-01-01	1947-01-08	1	-8394
20002	1361	1118084	1982-02-10	1982-02-10	1	4423
47328	3214	1177480	1976-09-14	1976-09-28	1	2462
14701	1015	1119510	1979-12-29	1980-01-05	1	3656
56621	3857	1112807	1944-11-29	1944-12-20	1	-9143
17292	1193	1112807	1959-05-25	1959-06-15	1	-3853
55134	3750	1112807	1961-09-28	1961-10-12	1	-3003
14082	964	1729720	1980-11-04	1980-11-14	1	3970
63229	4320	1125315	2013-05-25	2013-06-08	1	15864
17412	1205	1125315	2016-10-06	2016-10-13	1	17087
61122	4167	1729720	1981-11-18	1981-11-29	1	4350
65128	4450	1125315	1968-07-09	1968-07-16	1	-534
20714	1410	1549786	1996-01-09	1997-01-03	1	9864
54088	3678	1738521	1978-06-15	1978-06-29	1	3101
13246	906	1125315	1991-05-21	1991-05-28	1	7817
13461	921	1521369	1984-05-27	1985-05-22	1	5620
58481	3987	1557272	2014-02-22	2014-02-22	1	16123
53913	3668	1177480	2018-01-16	2018-02-13	1	17575
22082	1505	1125315	1983-12-02	1983-12-09	1	5090
17059	1175	1729720	1965-04-01	1965-04-09	1	-1728
66406	4534	1125315	1995-01-05	1995-01-12	1	9142
8812	608	1322184	1999-07-21	2005-07-27	2	12977
56852	3875	1125315	1997-08-20	1997-09-03	1	10107
75217	5146	1125315	1952-08-03	1952-08-24	1	-6339
62187	4241	1759842	1998-07-16	1998-10-01	1	10500
19688	1345	1177480	1993-07-21	1993-10-19	1	8692
21134	1439	1759842	1980-10-05	1980-10-19	1	3944
68731	4689	1521369	1990-03-19	1991-03-14	1	7742
16854	1159	1713332	1981-07-28	1981-08-04	1	4233
57024	3885	1503184	1983-10-07	1985-09-26	2	5747
16601	1145	1125315	1977-02-05	1977-02-05	1	2592
31562	2136	738818	1983-12-11	1983-12-25	1	5106
16483	1137	1112807	1993-09-02	1993-09-23	1	8666
23284	1578	1713332	1962-08-03	1962-08-24	1	-2687
62536	4269	1125315	2010-03-23	2010-03-30	1	14698
26027	1761	1521369	1975-07-06	1976-06-30	1	2372
69021	4709	1125315	1983-03-31	1983-04-21	1	4858
13447	919	1521369	1986-07-21	1987-07-16	1	6405
43399	2935	1503184	1998-02-21	1999-02-16	1	10638
63772	4359	1759842	1959-09-21	1959-10-05	1	-3741
20679	1408	1713332	1982-07-18	1982-11-07	1	4693
61186	4173	1713332	2007-09-12	2007-09-26	1	13782
12209	841	1125315	2017-08-23	2017-09-20	1	17429
64240	4388	1125315	1996-10-28	1996-10-28	1	9797
15861	1098	1729720	1962-11-14	1962-11-21	1	-2598
64127	4381	1738521	1967-01-01	1967-01-15	1	-1082
12358	847	19127890	1982-03-25	1983-03-20	1	4826
12587	864	836654	1996-08-05	1996-08-05	1	9713
65506	4475	1177480	2008-05-14	2008-06-04	1	14034
18211	1253	1125315	2017-01-28	2017-02-04	1	17201
66619	4548	1177480	2016-08-03	2016-09-02	1	17046
13845	948	1177480	1978-03-15	1978-04-05	1	3016
62154	4240	1332418	2010-11-08	2010-11-08	1	14921
12846	879	1124957	2009-03-16	2009-03-16	1	14319
52582	3580	19127890	1986-03-21	1987-03-16	1	6283
67852	4631	1125315	1939-10-21	1939-11-04	1	-11016
21390	1454	1118084	2009-11-14	2009-11-14	1	14562
20003	1361	1125315	1987-06-22	1987-07-06	1	6395
47329	3214	1177480	1988-07-02	1988-07-16	1	6771
14702	1015	1125315	2012-10-31	2012-11-07	1	15651
56622	3857	1112807	1960-03-29	1960-04-26	1	-3537
17293	1193	1118084	1987-03-15	1987-03-15	1	6282
55135	3750	1125315	1974-02-25	1974-03-11	1	1530
14083	964	1119510	1985-12-04	1985-12-18	1	5830
63230	4320	1503184	1988-03-04	1990-02-22	2	7357
17413	1205	19127890	1977-09-27	1978-09-22	1	3186
61123	4167	1759842	1988-08-24	1988-09-14	1	6831
65129	4450	1759842	1973-11-23	1973-12-07	1	1436
20715	1410	1503184	1988-02-03	1989-01-28	1	6967
54089	3678	738818	2008-10-01	2008-10-08	1	14160
13247	906	1738521	1974-05-03	1974-05-17	1	1597
13462	921	1713332	1977-06-11	1977-06-25	1	2732
58482	3987	1713332	1974-08-05	1974-08-12	1	1684
53914	3668	738818	1976-09-26	1976-10-03	1	2467
22083	1505	1125315	1995-03-04	1995-03-25	1	9214
17060	1175	1112807	1942-07-01	1942-07-15	1	-10032
66407	4534	1322184	2005-03-02	2011-11-30	1	15308
8813	608	1332418	1999-07-21	1999-07-21	1	10793
56853	3875	19127890	1975-10-30	1976-10-24	1	2488
75218	5146	1125315	2000-01-18	2000-01-25	1	10981
62188	4241	1112807	1965-10-22	1965-11-12	1	-1511
19689	1345	1361711	2008-03-25	2008-03-25	1	13963
21135	1439	19127890	1995-07-20	1996-07-14	1	9691
68732	4689	1729720	1981-01-08	1981-01-21	1	4038
16855	1159	1713332	2009-05-13	2009-05-20	1	14384
57025	3885	1503184	1987-09-16	1989-09-05	2	7187
16602	1145	1125315	2002-06-08	2002-06-15	1	11853
31563	2136	920293	2013-06-27	2013-07-04	1	15890
16484	1137	1125315	1959-03-15	1959-03-22	1	-3938
23285	1578	1713332	1983-05-08	1983-05-15	1	4882
62537	4269	1177480	2006-07-07	2006-09-05	1	13396
26028	1761	1713332	1980-04-25	1980-05-17	1	3789
69022	4709	1717327	1961-11-15	1961-11-29	1	-2955
15548	1079	920293	2016-05-14	2016-05-21	1	16942
43400	2935	1515774	1992-03-24	1993-03-19	1	8478
63773	4359	1112807	1987-04-02	1987-04-30	1	6328
20680	1408	1759842	1959-04-06	1959-04-27	1	-3902
61187	4173	1759842	2007-09-12	2007-09-26	1	13782
12210	841	975125	1961-12-07	1961-12-21	1	-2933
64241	4388	1154343	1970-08-26	1970-08-26	1	237
15862	1098	1125315	1982-02-26	1982-03-19	1	4460
64128	4381	1112807	1967-11-05	1967-11-19	1	-774
12359	847	19127890	1989-02-16	1990-02-11	1	7346
12588	864	1112807	1939-10-06	1939-10-27	1	-11024
65507	4475	1713332	2004-06-12	2004-06-26	1	12595
18212	1253	1177480	2015-08-10	2015-09-14	1	16692
66620	4548	1322184	2018-07-03	2018-07-03	1	17715
13846	948	1728416	1964-05-13	1964-05-27	1	-2045
62155	4240	1539403	2010-11-08	2010-11-08	1	14921
12847	879	1713332	1982-08-14	1982-09-04	1	4629
52583	3580	933724	1998-04-25	1998-05-02	1	10348
67853	4631	1125315	1984-08-12	1984-09-02	1	5358
21391	1454	1125315	1985-05-09	1985-05-16	1	5614
20004	1361	1125315	2008-08-28	2008-09-11	1	14133
47330	3214	1713332	1979-01-17	1979-02-07	1	3324
15238	1057	738818	1963-02-11	1963-02-25	1	-2502
56623	3857	1125315	1972-05-25	1972-06-08	1	889
17294	1193	1125315	1968-01-20	1968-02-03	1	-698
55136	3750	1125315	1993-04-29	1993-05-20	1	8540
14084	964	1515774	1992-10-09	1993-10-04	1	8677
63231	4320	1521369	1988-03-04	1990-02-22	2	7357
17414	1205	920293	1981-11-26	1981-12-03	1	4354
61124	4167	1729720	1990-07-02	1990-07-10	1	7495
65130	4450	1759842	1999-10-16	1999-10-23	1	10887
20716	1410	1713332	2004-08-07	2004-08-28	1	12658
54090	3678	1115008	2009-10-30	2009-11-29	1	14577
13248	906	1115008	2011-10-07	2012-01-05	1	15344
13463	921	1759842	1998-08-07	1998-08-14	1	10452
58483	3987	1729720	1965-12-06	1965-12-17	1	-1476
53915	3668	1112807	1992-07-02	1992-08-31	1	8278
22084	1505	1728416	1959-05-22	1959-06-05	1	-3863
17061	1175	1112807	1945-12-29	1946-01-19	1	-8748
66408	4534	1361711	2005-03-02	2011-11-30	1	15308
8814	608	1361711	1999-07-21	2005-07-27	2	12977
56854	3875	920293	2005-12-06	2005-12-20	2	13137
75219	5146	1125315	2017-01-29	2017-01-29	1	17195
62189	4241	1112807	1967-10-03	1967-10-17	1	-807
19690	1345	1115008	2005-03-05	2009-06-12	1	14407
22233	1513	1118084	2011-01-01	2011-01-01	1	14975
68733	4689	1738521	1969-11-13	1969-11-27	1	-35
16856	1159	1759842	1981-07-28	1981-08-04	1	4233
57026	3885	1521369	1987-09-16	1989-09-05	2	7187
16603	1145	1125315	2012-08-14	2012-08-28	1	15580
31564	2136	1124300	2008-01-08	2008-01-08	1	13886
16485	1137	1125315	1974-07-27	1974-08-03	1	1675
23286	1578	1759842	1983-05-08	1983-05-15	1	4882
62538	4269	1738521	1970-06-28	1970-07-12	1	192
26029	1761	1115008	2019-04-16	2019-05-21	1	18037
69023	4709	1112807	1961-11-15	1961-11-29	1	-2955
15549	1079	1118084	1993-11-26	1993-11-26	1	8730
43401	2935	1521369	1990-04-04	1992-03-24	2	8118
63774	4359	1118084	1985-02-14	1985-02-14	1	5523
20681	1408	1759842	1982-07-18	1982-11-07	1	4693
61188	4173	1119510	1983-01-03	1983-01-10	1	4757
12211	841	1713332	1994-06-23	1994-07-14	1	8960
64242	4388	1174888	1996-10-28	1996-10-28	1	9797
15863	1098	1125315	1999-11-30	1999-12-07	1	10932
64129	4381	1118084	2005-11-04	2005-11-04	1	13091
12360	847	19127890	1991-02-06	1992-02-01	1	8066
12589	864	1112807	1946-08-21	1946-09-25	1	-8499
65508	4475	1713332	2017-08-04	2017-08-11	1	17389
18213	1253	1521369	1979-01-12	1981-01-01	2	4018
66621	4548	1332418	2018-07-03	2018-07-03	1	17715
14054	962	1102527	1964-03-27	1964-03-27	1	-2106
62156	4240	757627	2018-12-24	2018-12-24	1	17889
12848	879	1759842	1956-08-23	1956-08-30	1	-4872
52584	3580	1124300	2017-07-31	2017-07-31	1	17378
67854	4631	1125315	1995-03-09	1995-03-23	1	9212
21392	1454	1521369	1987-08-27	1988-08-21	1	6807
20005	1361	920293	1973-10-10	1973-10-17	1	1385
47331	3214	1717327	1975-06-12	1975-06-26	1	2002
15239	1057	1125315	1963-02-11	1963-03-26	2	-2488
56624	3857	1125315	1997-03-22	1997-04-05	1	9956
17295	1193	1125315	1980-12-03	1980-12-17	1	4003
55137	3750	1728416	1961-09-28	1961-10-12	1	-3003
14085	964	19127890	1991-10-15	1993-10-04	2	8677
63232	4320	1746114	1970-05-14	1970-05-14	1	133
17415	1205	1112807	1965-08-05	1965-08-19	1	-1596
61125	4167	1768849	1979-10-15	1979-10-29	1	3588
65131	4450	1125315	1969-02-13	1969-02-27	1	-308
20717	1410	1729720	1976-01-21	1976-01-31	1	2221
54091	3678	1119510	2016-02-16	2016-02-23	1	16854
13249	906	1118084	2011-09-07	2011-09-07	1	15224
13464	921	1112807	1971-01-10	1971-02-07	1	402
58484	3987	1125315	1956-08-12	1956-09-02	1	-4869
53916	3668	1125315	1976-09-26	1976-10-03	1	2467
22085	1505	1728416	1974-09-02	1974-09-16	1	1719
17062	1175	1112807	1967-02-28	1967-04-29	1	-978
66409	4534	1728416	1949-06-20	1949-07-04	1	-7486
8815	608	1539403	1999-07-21	1999-07-21	1	10793
56855	3875	1118084	2000-02-01	2000-02-01	1	10988
75220	5146	1322184	2013-07-15	2013-07-15	1	15901
62190	4241	1118084	2006-08-08	2006-08-08	1	13368
19691	1345	1125315	2013-10-13	2013-10-20	1	15998
22234	1513	1125315	1969-12-17	1969-12-31	1	-1
68734	4689	19127890	1981-05-06	1982-05-01	1	4503
16857	1159	1759842	2009-05-13	2009-05-20	1	14384
57027	3885	1713332	1967-01-20	1967-01-27	1	-1070
16604	1145	1174888	1977-02-05	1977-02-05	1	2592
31565	2136	1125315	1971-07-16	1971-07-30	1	575
16486	1137	1125315	1984-11-24	1984-12-29	1	5476
26800	1813	1125315	1990-10-09	1990-10-16	1	7593
62539	4269	1112807	1970-06-28	1970-07-12	1	192
26030	1761	1729720	1959-04-10	1959-04-20	1	-3909
69024	4709	1125315	2000-11-20	2000-12-04	1	11295
15550	1079	1759842	2004-09-02	2004-09-23	1	12684
43402	2935	1125315	1981-01-11	1981-03-12	1	4088
63775	4359	1177480	2013-07-12	2013-08-09	1	15926
22417	1526	1503184	1994-11-09	1995-11-04	1	9438
61189	4173	1125315	2012-06-18	2012-07-02	1	15523
12212	841	1713332	2018-03-16	2018-03-23	1	17613
64243	4388	1717327	1968-05-11	1968-05-25	1	-586
15864	1098	1177480	2016-11-06	2016-11-27	1	17132
64130	4381	1125315	1972-04-23	1972-05-07	1	857
13624	931	1112807	1963-01-04	1963-01-18	1	-2540
12590	864	1124957	1935-12-21	1935-12-21	1	-12430
65509	4475	1778162	1987-06-04	1987-06-18	1	6377
18214	1253	1713332	2002-01-04	2002-01-25	1	11712
66622	4548	1102527	2016-08-03	2016-08-03	1	17016
14055	962	1112807	1962-02-01	1962-03-08	1	-2856
62157	4240	1361711	2010-11-08	2010-11-08	1	14921
12849	879	1759842	1982-08-14	1982-09-04	1	4629
52585	3580	1125315	2003-02-25	2003-03-04	1	12115
67855	4631	1174888	2002-06-28	2002-06-28	1	11866
21393	1454	1713332	1992-05-18	1992-06-08	1	8194
20006	1361	933724	1973-10-10	1973-10-17	1	1385
47332	3214	1738521	1972-11-11	1972-11-25	1	1059
15240	1057	1125315	1989-01-08	1989-02-07	1	6977
56625	3857	1149380	1972-03-14	1972-03-14	1	803
17296	1193	1125315	2017-08-01	2017-08-15	1	17393
56396	3843	1124300	2008-06-21	2008-06-21	1	14051
14086	964	19127890	1995-09-24	1996-09-18	1	9757
63233	4320	708298	1970-05-14	1970-05-14	1	133
17416	1205	1503184	1983-08-27	1984-08-21	1	5346
63172	4317	1125315	1998-11-05	1999-02-03	1	10625
65132	4450	1125315	1976-11-22	1977-01-21	1	2577
20718	1410	1738521	1971-04-23	1971-05-08	1	492
54092	3678	1125315	2008-10-01	2008-10-08	1	14160
16147	1116	1112807	1969-10-20	1969-11-24	1	-38
13465	921	1326303	2016-06-21	2016-06-21	1	16973
58485	3987	1307863	2016-03-05	2016-03-05	1	16865
53917	3668	1125315	1993-06-27	1993-07-11	1	8592
22086	1505	1112807	1959-05-22	1959-06-05	1	-3863
17063	1175	1124957	2018-11-11	2018-11-11	1	17846
66410	4534	1729720	1953-01-01	1953-01-13	1	-6197
8816	608	1713332	1984-06-03	1984-06-10	1	5274
56856	3875	1125315	1971-06-04	1971-06-18	1	533
75221	5146	1347450	2013-07-15	2013-07-15	1	15901
62191	4241	1125315	1976-05-02	1976-05-16	1	2327
19692	1345	1305058	2005-03-05	2009-06-12	1	14407
22235	1513	1125315	1995-12-01	1995-12-15	1	9479
68735	4689	933724	2012-05-26	2012-06-02	1	15493
18378	1265	1125315	1981-04-06	1981-04-20	1	4127
57028	3885	1759842	1967-01-20	1967-01-27	1	-1070
16605	1145	1713332	1995-04-22	1995-05-06	1	9256
31566	2136	1125315	1983-12-11	1983-12-25	1	5106
16487	1137	1125315	1988-10-09	1988-11-06	1	6884
26801	1813	1713332	1984-04-05	1984-04-19	1	5222
62540	4269	1125315	1968-05-31	1968-06-14	1	-566
26031	1761	1759842	1980-04-25	1980-05-17	1	3789
69025	4709	1728416	1956-06-06	1956-06-20	1	-4943
15551	1079	933724	2016-05-14	2016-05-21	1	16942
43403	2935	1125315	1994-03-18	1994-04-01	1	8856
63776	4359	1713332	1999-11-23	1999-11-30	1	10925
22418	1526	1549786	1995-11-04	1996-10-29	1	9798
61190	4173	1729720	1974-03-03	1974-03-11	1	1530
12213	841	1759842	1994-06-23	1994-07-14	1	8960
64244	4388	1729720	1967-05-02	1967-05-09	1	-968
15865	1098	920293	1998-01-14	1998-01-21	1	10247
64131	4381	1713332	1995-01-15	1995-01-22	1	9152
13625	931	1118084	2000-03-25	2000-03-25	1	11041
12591	864	1125315	1960-03-18	1960-03-25	1	-3569
65907	4503	738818	1977-08-20	1977-08-27	1	2795
18215	1253	1759842	1995-09-13	1995-10-04	1	9407
66623	4548	1118084	2017-09-29	2017-09-29	1	17438
14056	962	1125315	1989-09-15	1989-09-29	1	7211
62158	4240	1778162	1984-09-03	1984-09-17	1	5373
12850	879	1112807	1953-04-06	1953-04-20	1	-6100
52586	3580	1177480	1993-03-16	1993-04-20	1	8510
67856	4631	1177480	1997-03-12	1997-03-26	1	9946
21394	1454	1738521	1973-09-29	1973-10-13	1	1381
20007	1361	1125315	1980-09-30	1980-10-14	1	3939
47333	3214	1119510	2017-05-17	2017-05-24	1	17310
15241	1057	1125315	1985-09-01	1985-09-15	1	5736
56626	3857	1728416	1945-12-24	1946-01-07	1	-8760
18812	1292	1112807	1960-05-24	1960-06-28	1	-3474
56397	3843	1125315	1972-02-21	1972-03-06	1	795
14087	964	738818	1985-12-04	1985-12-18	1	5830
63234	4320	753626	1970-05-14	1970-05-14	1	133
17417	1205	1521369	1977-09-27	1978-09-22	1	3186
63173	4317	1125315	2012-03-19	2012-04-02	1	15432
65133	4450	1125315	2000-08-28	2000-09-04	1	11204
20719	1410	1759842	2004-08-07	2004-08-28	1	12658
60004	4091	738818	1994-03-08	1994-03-15	1	8839
16148	1116	1177480	1996-02-20	1996-04-20	1	9606
13466	921	1713332	2015-03-29	2015-04-12	1	16537
58486	3987	1713332	2003-09-25	2003-10-02	1	12327
53918	3668	1177480	2001-08-26	2001-09-23	1	11588
22087	1505	1119510	1983-12-02	1983-12-09	1	5090
17064	1175	1125315	1953-09-20	1953-09-27	1	-5940
66411	4534	738818	2003-02-11	2003-02-18	1	12101
8817	608	1759842	1984-06-03	1984-06-10	1	5274
56857	3875	1713332	1985-06-20	1985-06-27	1	5656
75222	5146	1124300	1979-02-13	1979-02-13	1	3330
62192	4241	1125315	1977-01-01	1977-01-15	1	2571
19693	1345	1728416	1968-06-19	1968-07-03	1	-547
22236	1513	1503184	1984-05-12	1985-05-07	1	5605
68736	4689	1115008	1994-08-07	1994-08-28	1	9005
18379	1265	1125315	1999-05-02	1999-05-23	1	10734
59227	4033	1118084	2014-07-25	2014-07-25	1	16276
16606	1145	1729720	1940-12-10	1940-12-23	1	-10601
31567	2136	1153428	2001-06-22	2001-06-22	1	11495
16488	1137	1503184	1974-07-25	1975-07-20	1	2026
26802	1813	1118084	2016-10-29	2016-10-29	1	17103
62541	4269	19127890	1988-03-27	1989-03-22	1	7020
26032	1761	19127890	1975-07-06	1976-06-30	1	2372
69026	4709	1125315	1984-09-09	1984-09-23	1	5379
15552	1079	1125315	1964-01-03	1964-01-17	1	-2176
43404	2935	1503184	1990-04-04	1992-03-24	2	8118
63777	4359	1759842	1999-11-23	1999-11-30	1	10925
22419	1526	1713332	1979-09-18	1979-10-09	1	3568
61191	4173	1759842	1965-02-01	1965-02-22	1	-1774
12214	841	1759842	2018-03-16	2018-03-23	1	17613
64245	4388	1759842	1991-04-02	1991-04-23	1	7782
15866	1098	1112807	1961-09-09	1961-09-30	1	-3015
64132	4381	1713332	2007-02-09	2007-02-16	1	13560
13626	931	1125315	1965-12-20	1965-12-27	1	-1466
12592	864	1729720	1967-12-16	1967-12-25	1	-738
65908	4503	1112807	1939-01-07	1939-01-21	1	-11303
18216	1253	1759842	2000-06-16	2000-07-07	1	11145
66624	4548	1125315	1984-10-12	1984-11-16	1	5433
14057	962	1112807	1957-06-06	1957-06-27	1	-4571
64501	4405	738818	1968-10-25	1968-11-01	1	-426
12851	879	1112807	1967-04-23	1967-05-28	1	-949
52587	3580	1112807	1979-03-18	1979-04-01	1	3377
67857	4631	1112807	1925-01-05	1925-02-02	1	-16404
21395	1454	19127890	1989-08-16	1990-08-11	1	7527
20008	1361	1125315	1999-10-31	1999-10-31	1	10895
47334	3214	1125315	2003-12-31	2004-01-07	1	12424
15242	1057	1125315	1989-12-10	1989-12-24	1	7297
56627	3857	1119510	1960-06-10	1960-06-17	1	-3485
18813	1292	1119510	1959-05-31	1959-06-14	1	-3854
56398	3843	1125315	1974-02-03	1974-02-17	1	1508
14088	964	1112807	1981-04-17	1981-05-01	1	4138
63235	4320	1110410	1970-05-14	1970-05-14	1	133
17418	1205	1717327	1965-08-05	1965-08-19	1	-1596
63174	4317	1322184	2018-11-01	2018-11-01	1	17836
65134	4450	1125315	2015-04-16	2015-04-16	1	16541
20720	1410	19127890	1991-01-26	1992-01-21	1	8055
60005	4091	1125315	1970-05-16	1970-05-30	1	149
16149	1116	1729720	1972-12-04	1972-12-16	1	1080
13467	921	1759842	2015-03-29	2015-04-12	1	16537
62957	4299	1125315	1978-03-18	1978-04-01	1	3012
53919	3668	1177480	2016-02-28	2016-03-27	1	16887
22088	1505	1125315	1968-06-19	1968-06-26	1	-554
17065	1175	1125315	2018-11-11	2018-12-02	2	17867
66412	4534	1125315	2003-02-11	2003-02-18	1	12101
8818	608	1125315	1978-11-08	1978-11-22	1	3247
56858	3875	933724	2010-01-23	2010-01-30	1	14639
75223	5146	1177480	2017-01-29	2017-03-05	1	17230
62193	4241	1521369	1979-10-19	1980-10-13	1	3938
19694	1345	1759842	2011-03-20	2011-04-03	1	15067
22237	1513	723013	1983-03-27	1983-03-27	1	4833
68737	4689	1118084	2007-10-12	2007-10-12	1	13798
18380	1265	1177480	1991-04-14	1991-07-13	1	7863
59228	4033	1125315	2010-09-06	2010-09-20	1	14872
16607	1145	1759842	2016-09-29	2017-03-30	1	17255
31568	2136	1343916	2001-06-22	2001-06-22	1	11495
16489	1137	1119510	1974-07-27	1974-08-03	1	1675
26803	1813	1119510	1987-07-20	1987-08-03	1	6423
65837	4498	738818	1996-03-01	1996-03-15	1	9570
26033	1761	1112807	1972-10-14	1972-10-28	1	1031
69027	4709	1713332	1997-01-30	1997-02-13	1	9905
15553	1079	1713332	1983-05-30	1983-06-06	1	4904
43405	2935	1521369	1993-03-19	1994-03-14	1	8838
63778	4359	1112807	1943-09-08	1943-09-22	1	-9598
22420	1526	1729720	2018-12-03	2018-12-14	1	17879
61192	4173	1759842	1976-06-02	1976-06-16	1	2358
12215	841	975125	1966-08-24	1966-09-14	1	-1205
64246	4388	1112807	1968-05-11	1968-05-25	1	-586
15867	1098	1112807	1969-01-17	1969-01-31	1	-335
64133	4381	1717327	1965-03-29	1965-04-12	1	-1725
13627	931	1177480	1974-01-04	1974-02-08	1	1499
14735	1018	1115008	2014-12-12	2015-01-09	1	16444
65909	4503	1115008	2001-02-10	2001-03-19	1	11400
18217	1253	1118084	1997-03-13	1997-03-13	1	9933
66625	4548	1713332	2011-05-21	2011-05-28	1	15122
14058	962	1118084	1995-04-18	1995-04-18	1	9238
64502	4405	1124300	2006-09-24	2006-09-24	1	13415
12852	879	1125315	1986-02-17	1986-03-19	1	5921
52588	3580	1119510	2006-10-15	2006-10-22	1	13443
67858	4631	1118084	1953-09-17	1953-09-17	1	-5950
21396	1454	738818	1979-01-02	1979-01-09	1	3295
20009	1361	1728416	1952-07-18	1952-08-01	1	-6362
47335	3214	1177480	2005-10-29	2005-11-26	1	13113
15243	1057	1125315	1991-10-25	1991-11-15	1	7988
56628	3857	1125315	2015-07-09	2015-07-16	1	16632
18814	1292	1125315	1981-06-24	1981-07-08	1	4206
56399	3843	1119510	2004-05-08	2004-05-15	1	12553
14089	964	1119510	1981-04-02	1981-04-16	1	4123
63236	4320	1112807	1979-07-10	1979-07-24	1	3491
17419	1205	1728416	1961-03-15	1961-03-29	1	-3200
63175	4317	1332418	2018-11-01	2018-11-01	1	17836
65135	4450	1713332	1973-11-23	1973-12-07	1	1436
20721	1410	19127890	1996-01-09	1997-01-03	1	9864
60006	4091	1125315	1982-02-24	1982-03-10	1	4451
16150	1116	1738521	1967-02-03	1967-02-17	1	-1049
13468	921	1102527	1983-03-25	1983-03-25	1	4831
62958	4299	1125315	2015-02-02	2015-02-16	1	16482
53920	3668	1549786	1989-08-27	1990-08-22	1	7538
22089	1505	1118084	1992-04-13	1992-04-13	1	8138
17066	1175	1713332	2017-02-15	2017-03-08	1	17233
66413	4534	1125315	2011-11-30	2011-11-30	1	15308
8819	608	1125315	1988-04-04	1988-04-18	1	6682
56859	3875	1125315	1967-09-23	1967-11-22	1	-771
75224	5146	1124957	2017-01-29	2017-01-29	1	17195
62194	4241	19127890	1988-09-01	1990-08-22	2	7538
19695	1345	1112807	1977-09-13	1977-10-13	1	2842
22238	1513	1125315	1968-07-26	1968-08-09	1	-510
68738	4689	1521369	1983-04-26	1984-04-19	1	5222
18381	1265	1549786	1995-05-03	1996-04-27	1	9613
59229	4033	1713332	2017-02-03	2017-02-17	1	17214
16608	1145	920293	1956-09-17	1956-09-24	1	-4847
31569	2136	1503184	1984-05-18	1985-05-13	1	5611
16490	1137	1125315	1975-06-01	1975-06-15	1	1991
26804	1813	1125315	2016-03-18	2016-04-17	1	16908
65838	4498	1112807	1983-11-19	1984-02-17	1	5160
26034	1761	1115008	2016-05-10	2016-05-31	1	16952
69028	4709	1759842	1997-01-30	1997-02-13	1	9905
15554	1079	1728416	1964-01-03	1964-01-17	1	-2176
43406	2935	1521369	1998-02-21	1999-02-16	1	10638
63779	4359	1112807	1959-12-13	1960-01-10	1	-3644
22421	1526	1759842	1979-09-18	1979-10-09	1	3568
61193	4173	1112807	1973-03-24	1973-04-23	1	1208
12216	841	1118084	1991-05-26	1991-05-26	1	7815
64247	4388	1118084	2007-12-28	2007-12-28	1	13875
15868	1098	1125315	1980-06-11	1980-06-25	1	3828
64134	4381	1759842	1995-01-15	1995-01-22	1	9152
13628	931	1177480	1978-10-13	1978-10-27	1	3221
14736	1018	1124300	2012-02-20	2012-02-20	1	15390
65910	4503	1125315	1998-12-24	1998-12-31	1	10591
18218	1253	1125315	1970-12-16	1970-12-23	1	356
66626	4548	1759842	2011-05-21	2011-05-28	1	15122
14059	962	1728416	1962-02-01	1962-03-08	1	-2856
64503	4405	1125315	1968-10-25	1968-11-01	1	-426
12853	879	1125315	2007-06-27	2007-07-25	1	13719
52589	3580	1125315	1986-03-13	1986-05-01	2	5950
67859	4631	1729720	1920-12-01	1920-12-10	1	-17919
21397	1454	1119510	1989-12-23	1989-12-30	1	7303
20010	1361	1729720	1955-09-06	1955-09-16	1	-5221
47336	3214	1125315	1972-11-11	1972-11-25	1	1059
15244	1057	1125315	2002-05-21	2002-06-18	1	11856
57820	3943	1125315	1962-08-21	1962-08-28	1	-2683
18815	1292	1125315	1987-01-20	1987-02-17	1	6256
56400	3843	1125315	1978-02-21	1978-03-07	1	2987
14090	964	1125315	1985-12-04	1985-12-18	1	5830
63237	4320	1119510	2013-05-25	2013-06-08	1	15864
17420	1205	1729720	1963-04-07	1963-04-17	1	-2451
63176	4317	1112807	1961-11-19	1961-12-19	1	-2935
65136	4450	1729720	1975-12-11	1975-12-21	1	2180
22393	1524	1112807	1973-01-10	1973-01-24	1	1119
60007	4091	1125315	1990-11-09	1990-11-23	1	7631
16151	1116	1759842	1966-05-17	1966-05-24	1	-1318
13469	921	1112807	1972-03-03	1972-03-31	1	820
62959	4299	1177480	1974-11-17	1974-12-08	1	1802
53921	3668	1738521	1975-09-30	1975-10-14	1	2112
22090	1505	1125315	1954-12-29	1955-01-12	1	-5468
17067	1175	1729720	1942-07-20	1942-08-02	1	-10014
66414	4534	1332418	2005-03-02	2005-03-02	1	12844
8820	608	1112807	1975-04-13	1975-04-27	1	1942
56860	3875	1125315	1977-01-17	1977-01-31	1	2587
75225	5146	1125315	1947-03-04	1947-03-11	1	-8332
64716	4418	1125315	1992-10-21	1992-10-28	1	8336
19696	1345	1115008	1996-06-05	1996-06-26	1	9673
22239	1513	1125315	2010-03-31	2010-04-14	1	14713
68739	4689	1521369	1986-04-09	1987-04-04	1	6302
18382	1265	1759842	2001-05-17	2001-06-07	1	11480
59230	4033	1729720	1979-11-21	1979-12-03	1	3623
16609	1145	933724	1956-09-17	1956-09-24	1	-4847
31570	2136	1521369	1988-04-27	1989-04-22	1	7051
16491	1137	1125315	2010-05-15	2010-05-22	1	14751
26805	1813	1177480	1986-07-24	1986-10-22	1	6138
65839	4498	1118084	2013-12-26	2013-12-26	1	16065
26035	1761	1125315	1967-07-09	1967-07-23	1	-893
69029	4709	1112807	1956-06-06	1956-06-20	1	-4943
15555	1079	1729720	1970-10-15	1970-10-27	1	299
43407	2935	1549786	1992-03-24	1993-03-19	1	8478
63780	4359	1125315	1970-10-17	1970-10-24	1	296
22422	1526	19127890	1988-12-10	1989-12-05	1	7278
61194	4173	1125315	1964-06-09	1964-08-08	1	-1972
12217	841	1125315	1972-11-26	1972-12-17	1	1081
64248	4388	1125315	1970-04-01	1970-05-06	1	125
15869	1098	1125315	2011-10-13	2011-11-03	1	15281
64135	4381	1759842	2007-02-09	2007-02-16	1	13560
13629	931	1361711	2015-10-16	2015-10-16	1	16724
14737	1018	1125315	1987-04-18	1987-05-02	1	6330
65911	4503	1713332	2004-07-24	2004-07-31	1	12630
18219	1253	1125315	2000-03-22	2000-04-05	1	11052
66627	4548	1115008	2010-06-15	2010-07-06	1	14796
14060	962	1119510	1982-09-25	1982-10-09	1	4664
64504	4405	1125315	1975-12-26	1976-01-09	1	2199
12854	879	1713332	2011-09-13	2011-09-27	1	15244
52590	3580	1125315	1990-05-10	1990-05-31	1	7455
67860	4631	1729720	1921-03-14	1921-03-23	1	-17816
21398	1454	1125315	1979-01-02	1979-01-09	1	3295
23028	1563	1124300	1997-09-01	1997-09-01	1	10105
47337	3214	1125315	2017-05-17	2017-05-24	1	17310
15245	1057	1119510	1963-02-11	1963-02-25	1	-2502
57821	3943	1125315	1985-03-01	1985-03-15	1	5552
18816	1292	1129625	1954-09-04	1954-09-04	1	-5598
56401	3843	1738521	1972-02-21	1972-03-06	1	795
14091	964	1177480	1979-11-07	1979-11-21	1	3611
63238	4320	1125315	2018-07-22	2018-07-29	1	17741
17421	1205	738818	1975-07-20	1975-08-03	1	2040
63177	4317	1125315	1961-11-19	1961-11-19	1	-2965
65137	4450	1738521	1969-02-13	1969-02-27	1	-308
22394	1524	1713332	1981-04-02	1981-04-23	1	4130
60008	4091	1125315	1994-03-08	1994-03-15	1	8839
16152	1116	1118084	2007-01-19	2007-01-19	1	13532
13470	921	1115008	2007-07-08	2007-08-12	1	13737
62960	4299	1119510	2015-02-02	2015-02-16	1	16482
53922	3668	19127890	1989-08-27	1990-08-22	1	7538
22091	1505	1125315	1978-03-25	1978-04-01	1	3012
17068	1175	1778162	2018-11-11	2018-12-02	1	17867
66415	4534	1539403	2005-03-02	2005-03-02	1	12844
8821	608	1174888	2005-07-13	2005-07-13	1	12977
56861	3875	1125315	2017-07-03	2017-07-10	1	17357
75226	5146	1125315	1966-07-14	1966-07-28	1	-1253
64717	4418	1125315	2010-01-20	2010-01-27	1	14636
19697	1345	1125315	1967-11-05	1967-11-19	1	-774
22240	1513	1717327	1972-07-21	1972-08-04	1	946
68740	4689	1713332	1986-03-22	1986-04-12	1	5945
18383	1265	19127890	1995-05-03	1996-04-27	1	9613
59231	4033	705944	1978-10-12	1981-12-09	1	4360
16610	1145	1115008	2011-12-18	2012-01-17	1	15356
31571	2136	933724	2013-06-27	2013-07-04	1	15890
16492	1137	1332418	1995-09-29	1995-09-29	1	9402
26806	1813	738818	1987-07-20	1987-08-03	1	6423
65840	4498	1177480	1989-01-21	1989-02-25	1	6995
26036	1761	1503184	1975-07-06	1976-06-30	1	2372
69030	4709	1115008	2008-06-08	2008-06-29	1	14059
15556	1079	1759842	1983-05-30	1983-06-06	1	4904
43408	2935	1713332	2012-10-07	2012-10-21	1	15634
63781	4359	1125315	1979-06-29	1979-07-13	1	3480
22423	1526	1112807	1972-11-24	1972-12-22	1	1086
61195	4173	1125315	1977-02-18	1977-03-04	1	2619
12218	841	1192710	1954-02-05	1954-02-05	1	-5809
64249	4388	1125315	1974-01-29	1974-02-19	1	1510
15870	1098	1112807	1961-03-13	1961-03-27	1	-3202
64136	4381	1112807	1967-01-01	1967-01-15	1	-1082
13630	931	1713332	2015-12-09	2015-12-23	1	16792
14738	1018	1125315	2009-06-20	2009-07-11	1	14436
65912	4503	1713332	2018-05-29	2018-06-12	1	17694
18220	1253	1125315	2010-09-20	2010-09-27	1	14879
66628	4548	1177480	1986-10-07	1986-10-21	1	6137
14061	962	1125315	2016-05-20	2016-05-27	1	16948
64505	4405	1125315	1996-04-28	1996-05-05	1	9621
12855	879	1713332	2013-05-28	2013-06-11	1	15867
52591	3580	1174888	1989-05-15	1989-05-15	1	7074
67861	4631	1729720	2009-09-08	2009-09-17	1	14504
21399	1454	1503184	1987-08-27	1988-08-21	1	6807
23029	1563	1125315	1971-06-06	1971-06-20	1	535
47338	3214	1177480	1982-12-17	1982-12-31	1	4747
15246	1057	1125315	2011-04-29	2011-05-06	1	15100
57822	3943	1125315	1986-02-11	1986-03-13	1	5915
18817	1292	1177480	1986-02-26	1986-03-26	1	5928
56402	3843	1738521	1974-02-03	1974-02-17	1	1508
14092	964	1515774	1995-09-24	1996-09-18	1	9757
63239	4320	1125315	2019-02-26	2019-03-05	1	17960
17422	1205	933724	1981-11-26	1981-12-03	1	4354
63178	4317	1125315	1977-11-23	1977-11-30	1	2890
70310	4804	1119510	1978-10-14	1978-10-21	1	3215
22395	1524	933724	2008-02-06	2008-02-13	1	13922
60009	4091	1125315	1999-05-22	1999-05-29	1	10740
16153	1116	1713332	1966-05-17	1966-05-24	1	-1318
13471	921	1177480	1999-12-26	2000-01-16	1	10972
62961	4299	1713332	1985-09-06	1985-09-20	1	5741
53923	3668	738818	2000-08-30	2000-09-06	1	11206
22092	1505	1713332	2014-01-17	2014-03-07	1	16136
18133	1249	1115008	2002-08-24	2002-09-23	1	11953
66416	4534	1713332	1994-04-02	1994-04-16	1	8871
8822	608	1545958	2005-07-13	2005-07-13	1	12977
56862	3875	1177480	2004-02-09	2004-03-15	1	12492
75227	5146	1125315	2012-05-29	2012-06-05	1	15496
64718	4418	1125315	2018-11-29	2018-12-13	1	17878
19698	1345	1125315	2015-03-15	2015-03-29	1	16523
22241	1513	1729720	1975-09-30	1975-10-12	1	2110
68741	4689	1713332	1998-01-07	1998-01-28	1	10254
18384	1265	920293	2017-06-09	2017-06-16	1	17333
59232	4033	1125315	2016-04-11	2016-04-18	1	16909
16611	1145	1119510	1964-02-27	1964-03-12	1	-2121
31572	2136	1125315	1988-01-26	1988-02-02	1	6606
16493	1137	19127890	1974-07-25	1975-07-20	1	2026
26807	1813	1125315	1987-07-20	1987-08-03	1	6423
65841	4498	1521369	1992-05-15	1993-05-10	1	8530
26037	1761	1729720	1958-02-25	1958-03-04	1	-4321
69031	4709	1125315	1993-08-23	1993-09-06	1	8649
15557	1079	920293	2010-04-04	2010-04-18	2	14717
43409	2935	1759842	2012-10-07	2012-10-21	1	15634
63782	4359	1125315	1991-02-08	1991-02-15	1	7715
22424	1526	1115008	2007-09-04	2007-09-25	1	13781
61196	4173	1713332	1965-02-01	1965-02-22	1	-1774
12219	841	1551099	1966-01-02	1966-01-02	1	-1460
64250	4388	1125315	1981-06-03	1981-06-10	1	4178
15871	1098	1125315	1956-11-05	1956-11-12	1	-4798
64137	4381	1112807	1973-02-22	1973-05-23	1	1238
13631	931	1729720	1966-01-01	1966-01-09	1	-1453
14739	1018	1125315	1982-11-09	1983-01-08	1	4755
65913	4503	738818	1998-12-24	1998-12-31	1	10591
18221	1253	1125315	2012-04-20	2012-05-04	1	15464
66629	4548	1713332	1988-03-17	1988-03-31	1	6664
14062	962	738818	1982-09-25	1982-10-09	1	4664
64506	4405	1738521	1969-09-01	1969-09-15	1	-108
12856	879	1759842	2013-05-28	2013-06-11	1	15867
52592	3580	1503184	1986-03-21	1987-03-16	1	6283
67862	4631	1112807	1929-10-09	1929-12-08	1	-14634
21400	1454	1503184	1989-08-16	1990-08-11	1	7527
23030	1563	1125315	1978-04-04	1978-04-18	1	3029
47339	3214	1713332	1991-05-02	1991-05-16	1	7805
15247	1057	738818	2007-03-13	2007-03-20	1	13592
57823	3943	1713332	2005-06-05	2005-06-26	1	12960
18818	1292	1713332	1974-11-14	1974-12-05	1	1799
56403	3843	1125315	1998-05-24	1998-06-07	1	10384
14093	964	1521369	1991-10-15	1992-10-09	1	8317
63240	4320	1521369	1984-03-25	1985-03-20	1	5557
17423	1205	1118084	2002-01-29	2002-01-29	1	11716
63179	4317	1174888	1961-11-19	1961-11-19	1	-2965
70311	4804	1125315	2006-09-16	2006-09-23	1	13414
22396	1524	1118084	2004-02-17	2004-02-17	1	12465
60010	4091	1118084	2009-05-29	2009-05-29	1	14393
16154	1116	1112807	1967-02-03	1967-02-17	1	-1049
13472	921	1307863	2016-06-21	2016-06-21	1	16973
62962	4299	1124300	2013-08-20	2013-08-20	1	15937
53924	3668	933724	2006-10-08	2006-10-15	1	13436
22093	1505	1728416	1954-12-29	1955-01-12	1	-5468
18134	1249	1115008	2018-03-03	2018-04-07	1	17628
66417	4534	1713332	2008-06-10	2008-06-24	1	14054
8823	608	1729720	1981-04-26	1981-05-03	1	4140
56863	3875	1503184	1975-10-30	1976-10-24	1	2488
75228	5146	1713332	2017-01-29	2017-03-05	1	17230
64719	4418	1177480	1994-07-23	1994-08-06	1	8983
19699	1345	1322184	2008-03-25	2008-03-25	1	13963
22242	1513	19127890	1984-05-12	1985-05-07	1	5605
68742	4689	1759842	1986-03-22	1986-04-12	1	5945
18385	1265	1515774	1995-05-03	1996-04-27	1	9613
59233	4033	1125315	2017-02-03	2017-02-17	1	17214
16612	1145	1119510	1968-11-28	1968-12-05	1	-392
31573	2136	1503184	1988-04-27	1989-04-22	1	7051
18305	1259	738818	2001-03-14	2001-03-21	1	11402
26808	1813	1713332	1984-09-23	1984-10-07	1	5393
65842	4498	1729720	1978-07-19	1978-07-26	1	3128
27246	1842	1729720	1997-08-08	1997-08-17	1	10090
69517	4745	1118084	2016-10-08	2016-10-08	1	17082
15558	1079	1125315	1988-07-26	1988-08-02	1	6788
44961	3053	1115008	2009-03-02	2009-03-16	1	14319
63783	4359	1125315	1999-06-11	1999-06-18	1	10760
22425	1526	1118084	2012-10-05	2012-10-05	1	15618
61197	4173	1713332	1976-06-02	1976-06-16	1	2358
12220	841	1759842	1997-04-07	1997-04-28	1	9979
64251	4388	1729720	1975-02-28	1975-03-10	1	1894
15872	1098	1738521	1969-01-17	1969-01-31	1	-335
64138	4381	1125315	2012-11-20	2012-12-04	1	15678
13632	931	1759842	2015-12-09	2015-12-23	1	16792
14740	1018	1125315	1998-03-06	1998-03-20	1	10305
65914	4503	1119510	1998-12-24	1998-12-31	1	10591
18222	1253	1521369	1977-01-22	1978-01-17	1	2938
66630	4548	1713332	2013-01-26	2013-02-16	1	15752
14063	962	1112807	1964-03-27	1964-04-26	1	-2076
64507	4405	705944	1977-02-13	1982-02-22	1	4435
12857	879	1125315	2009-03-16	2009-03-16	1	14319
52593	3580	1713332	2007-08-08	2007-08-29	1	13754
67863	4631	1119510	1939-10-21	1939-11-04	1	-11016
21401	1454	738818	1989-12-23	1989-12-30	1	7303
23031	1563	1149380	1977-06-25	1977-06-25	1	2732
48810	3320	1125315	1967-03-09	1967-03-23	1	-1015
15248	1057	1118084	2003-11-27	2003-11-27	1	12383
57824	3943	1759842	2005-06-05	2005-06-26	1	12960
18819	1292	738818	1995-09-16	1995-09-30	1	9403
56404	3843	1729720	2000-03-08	2000-03-18	1	11034
14094	964	1549786	1995-09-24	1996-09-18	1	9757
63241	4320	1728416	1973-02-11	1973-02-25	1	1151
17424	1205	1125315	1975-07-20	1975-08-03	1	2040
63180	4317	1713332	1949-12-01	1949-12-08	1	-7329
70312	4804	1503184	1997-02-14	1999-02-04	2	10626
22397	1524	1729720	2003-04-19	2003-04-30	1	12172
60011	4091	1125315	1978-04-02	1978-04-16	1	3027
16155	1116	1112807	1970-07-01	1970-07-15	1	195
13473	921	1713332	1998-08-07	1998-08-14	1	10452
62963	4299	1729720	1993-01-10	1993-01-17	1	8417
53925	3668	1119510	1976-09-26	1976-10-03	1	2467
22094	1505	1759842	2014-01-17	2014-03-07	1	16136
18135	1249	1125315	2017-07-03	2017-07-17	1	17364
66418	4534	1729720	1955-02-03	1955-02-16	1	-5433
9447	652	1112807	1969-08-06	1969-08-20	1	-134
56864	3875	1521369	1975-10-30	1976-10-24	1	2488
76453	5228	920293	1960-07-30	1960-08-06	1	-3435
64720	4418	1361711	2008-02-01	2008-02-01	1	13910
19700	1345	1332418	2008-03-25	2008-03-25	1	13963
22243	1513	920293	2007-06-10	2007-06-17	1	13681
68743	4689	1759842	1998-01-07	1998-01-28	1	10254
18386	1265	1713332	1987-12-23	1988-01-13	1	6586
59234	4033	1125315	2003-09-17	2003-10-01	1	12326
16613	1145	1119510	2002-06-08	2002-06-15	1	11853
31574	2136	1521369	1984-05-18	1985-05-13	1	5611
18306	1259	975125	1981-04-02	1981-04-02	1	4109
26809	1813	1729720	2002-06-04	2002-06-16	1	11854
65843	4498	1125315	1983-12-01	1983-12-15	1	5096
27247	1842	1759842	1974-12-09	1974-12-23	1	1817
69518	4745	1503184	1991-03-19	1993-03-08	2	8467
15559	1079	1177480	1988-01-25	1988-02-15	1	6619
44962	3053	1125315	1997-10-31	1997-10-31	1	10165
63784	4359	1557272	2013-09-04	2013-09-04	1	15952
22426	1526	1503184	1988-12-10	1989-12-05	1	7278
61198	4173	1717327	1964-11-06	1964-11-20	1	-1868
13652	933	1112807	1983-10-11	1983-11-01	1	5052
64252	4388	1112807	1970-09-15	1970-09-29	1	271
17874	1232	1112807	1966-03-09	1966-03-23	1	-1380
64139	4381	1759842	2013-08-01	2013-08-15	1	15932
13633	931	1112807	1965-05-07	1965-05-21	1	-1686
14741	1018	1125315	1972-02-05	1972-02-19	1	779
65915	4503	1125315	1992-06-11	1992-06-25	1	8211
19550	1334	1112807	1972-08-04	1972-10-10	1	1013
66631	4548	1768849	1995-05-18	1995-06-01	1	9282
14064	962	1125315	1982-09-25	1982-10-09	1	4664
64508	4405	1112807	1964-11-13	1964-11-27	1	-1861
12858	879	1125315	2011-09-13	2011-09-27	1	15244
52594	3580	1759842	2007-08-08	2007-08-29	1	13754
67864	4631	1125315	1921-10-25	1921-11-08	1	-17586
21402	1454	1119510	1979-01-02	1979-01-09	1	3295
23032	1563	1112807	1976-08-21	1976-09-18	1	2452
48811	3320	1125315	1978-02-07	1978-02-21	1	2973
15249	1057	1119510	2007-03-13	2007-03-20	1	13592
57825	3943	1125315	1956-05-23	1956-06-06	1	-4957
18820	1292	1102527	1999-01-22	1999-01-22	1	10613
56405	3843	738818	2004-05-08	2004-05-15	1	12553
14095	964	1713332	2009-12-30	2010-01-06	1	14615
63242	4320	1741122	1970-05-14	1970-05-14	1	133
17425	1205	19127890	1983-08-27	1984-08-21	1	5346
63181	4317	1713332	2002-10-16	2002-10-23	1	11983
70313	4804	1551099	1978-01-15	1978-01-15	1	2936
22398	1524	1759842	1981-04-02	1981-04-23	1	4130
60012	4091	1125315	2012-09-28	2012-10-12	1	15625
16156	1116	1177480	1993-03-23	1993-04-06	1	8496
13474	921	19127890	1980-06-17	1981-06-12	1	4180
62964	4299	738818	2015-02-02	2015-02-16	1	16482
53926	3668	1125315	1992-07-02	1992-07-02	1	8218
23333	1585	1112807	1930-02-23	1930-03-09	1	-14543
18136	1249	1713332	1981-07-14	1981-08-04	1	4233
66419	4534	1112807	1946-10-28	1946-11-11	1	-8452
9448	652	1112807	1973-10-01	1973-10-15	1	1383
56865	3875	1717327	1962-10-28	1962-11-18	1	-2601
76454	5228	933724	1960-07-30	1960-08-06	1	-3435
64721	4418	1539403	2008-02-01	2008-02-01	1	13910
19701	1345	1539403	2008-03-25	2008-03-25	1	13963
22244	1513	1112807	1972-07-21	1972-08-04	1	946
68744	4689	920293	2012-05-26	2012-06-02	1	15493
18387	1265	1713332	1989-12-09	1989-12-23	1	7296
64633	4412	1102527	2000-09-21	2000-09-21	1	11221
16614	1145	1713332	1944-08-10	1944-09-07	1	-9247
31575	2136	1759842	1995-10-21	1995-11-04	1	9438
18307	1259	1125315	1988-05-26	1988-06-30	1	6755
26810	1813	1729720	2007-09-03	2007-09-16	1	13772
65844	4498	1125315	1996-03-01	1996-03-15	1	9570
27248	1842	1759842	1975-12-26	1976-01-09	1	2199
69519	4745	705944	1985-03-30	1993-04-07	1	8497
15560	1079	1177480	2002-04-02	2002-04-23	1	11800
44963	3053	1521369	1999-12-16	2001-12-05	2	11661
63785	4359	1713332	1959-09-21	1959-10-05	1	-3741
22427	1526	1729720	1985-08-05	1985-08-17	1	5707
61199	4173	1729720	1977-11-23	1977-12-03	1	2893
13653	933	1112807	1986-11-15	1986-12-13	1	6190
64253	4388	1125315	2017-09-13	2017-09-27	1	17436
17875	1232	1112807	1971-10-09	1971-11-08	1	676
65261	4459	1115008	1999-07-11	1999-08-15	1	10818
13634	931	1125315	1975-12-30	1976-01-27	1	2217
14742	1018	1125315	1972-11-01	1972-12-01	1	1065
65916	4503	1307863	2014-04-01	2014-04-01	1	16161
19551	1334	1125315	1973-09-05	1973-09-26	1	1364
67784	4628	1112807	1970-05-05	1970-05-19	1	138
14065	962	1729720	1994-03-02	1994-03-10	1	8834
64509	4405	1759842	1973-09-03	1973-09-10	1	1348
12859	879	1713332	1956-08-23	1956-08-30	1	-4872
52595	3580	1778162	1983-05-22	1983-06-05	1	4903
67865	4631	1125315	1978-03-27	1978-04-03	1	3014
21403	1454	1125315	1973-09-29	1973-10-13	1	1381
23033	1563	1125315	1998-02-03	1998-02-10	1	10267
48812	3320	1729720	1974-10-28	1974-11-04	1	1768
15250	1057	1125315	2007-03-13	2007-03-20	1	13592
57826	3943	1125315	1968-03-12	1968-04-09	1	-632
18821	1292	1112807	1972-02-26	1972-03-11	1	800
56406	3843	1115008	2007-11-19	2007-12-10	1	13857
14096	964	1759842	2015-06-28	2015-07-05	1	16621
63243	4320	19016749	1970-05-14	1970-05-14	1	133
17639	1219	701322	2014-11-09	2014-11-09	1	16383
63182	4317	1728416	1947-09-04	1947-09-18	1	-8141
70314	4804	19127890	1992-03-12	1993-03-07	1	8466
22399	1524	920293	2008-02-06	2008-02-13	1	13922
60013	4091	1729720	1980-03-04	1980-03-11	1	3722
16157	1116	1125315	1997-09-25	1997-10-02	1	10136
13475	921	19127890	1984-05-27	1985-05-22	1	5620
62965	4299	1115008	1996-10-11	1996-11-08	1	9808
53927	3668	1174888	1992-07-02	1992-07-02	1	8218
23334	1585	1112807	1931-01-01	1931-01-15	1	-14231
18137	1249	1115008	2019-05-02	2019-06-06	1	18053
66420	4534	1118084	1985-04-09	1985-04-09	1	5577
9449	652	1177480	1986-08-07	1986-09-11	1	6097
56866	3875	920293	2010-01-23	2010-01-30	1	14639
76455	5228	1112807	1952-05-21	1952-06-04	1	-6420
64722	4418	1102527	2006-10-07	2006-10-07	1	13428
19702	1345	1713332	2011-03-20	2011-04-03	1	15067
22245	1513	1738521	1969-12-17	1969-12-31	1	-1
68745	4689	1125315	1981-07-27	1981-08-03	1	4232
18388	1265	1713332	2008-02-09	2008-02-16	1	13925
64634	4412	1124300	2002-09-11	2002-09-11	1	11941
16615	1145	738818	1964-02-27	1964-03-12	1	-2121
31576	2136	1759842	2017-06-28	2017-07-05	1	17352
18308	1259	1125315	2001-03-14	2001-03-21	1	11402
26811	1813	1112807	1984-09-23	1984-10-07	1	5393
65845	4498	1551099	1978-02-18	1978-02-18	1	2970
27249	1842	1118084	2004-11-28	2004-11-28	1	12750
69520	4745	738818	1981-11-27	1981-12-04	1	4355
15561	1079	1501700	2016-03-05	2016-03-05	1	16865
44964	3053	1549786	1997-12-26	1998-12-21	1	10581
63786	4359	1713332	1985-04-01	1985-04-15	1	5583
22428	1526	1125315	2005-09-30	2005-10-14	1	13070
61200	4173	738818	1983-01-03	1983-01-10	1	4757
13654	933	1125315	1981-09-30	1981-10-21	1	4311
64254	4388	1149380	1970-08-26	1970-08-26	1	237
17876	1232	1119510	1996-07-30	1996-08-13	1	9721
65262	4459	1115008	2015-10-04	2015-11-01	1	16740
13635	931	1119510	2009-07-26	2009-08-09	1	14465
15373	1068	738818	1987-05-05	1987-05-12	1	6340
65917	4503	1118084	1971-01-04	1971-01-04	1	368
19552	1334	1124300	2008-11-30	2008-11-30	1	14213
67785	4628	1125315	1979-03-06	1979-04-10	1	3386
16236	1122	1125315	1972-01-08	1972-01-22	1	751
64510	4405	1759842	2011-06-20	2011-07-11	1	15166
12860	879	1713332	1998-04-01	1998-04-08	1	10324
52596	3580	920293	1998-04-25	1998-05-02	1	10348
67866	4631	1177480	2002-06-28	2002-09-26	1	11956
21404	1454	1125315	1989-12-23	1989-12-30	1	7303
23034	1563	1728416	1959-01-09	1959-01-23	1	-3996
48813	3320	1118084	1999-02-02	1999-02-02	1	10624
17492	1211	738818	1992-01-31	1992-02-07	1	8072
57827	3943	1125315	2013-05-20	2013-05-27	1	15852
18822	1292	1118084	1990-03-23	1990-03-23	1	7386
56407	3843	1125315	1979-06-14	1979-07-19	1	3486
16262	1124	1112807	1939-09-15	1939-10-06	1	-11045
64468	4403	1713332	1955-05-09	1955-05-23	1	-5337
17640	1219	757627	2014-01-13	2014-01-13	1	16083
63183	4317	1759842	1967-09-25	1967-10-09	1	-815
70315	4804	19127890	1994-03-02	1995-02-25	1	9186
22400	1524	1125315	1988-02-23	1988-03-01	1	6634
60014	4091	914335	2017-09-10	2017-09-10	1	17419
16158	1116	1738521	1970-07-01	1970-07-15	1	195
13476	921	1112807	1968-05-11	1968-05-25	1	-586
62966	4299	1125315	1973-12-08	1973-12-22	1	1451
53928	3668	1713332	1991-12-13	1991-12-27	1	8030
23335	1585	1119510	1959-10-20	1959-11-03	1	-3712
18138	1249	1119510	1973-05-29	1973-06-05	1	1251
66421	4534	1125315	1996-05-21	1996-07-20	1	9697
9450	652	1728416	1969-08-06	1969-08-20	1	-134
56867	3875	1112807	1962-10-28	1962-11-18	1	-2601
76456	5228	1119510	1949-03-10	1949-03-24	1	-7588
64723	4418	1119510	1979-10-22	1979-10-29	1	3588
19703	1345	738818	2001-02-10	2001-02-17	1	11370
22246	1513	933724	2007-06-10	2007-06-17	1	13681
68746	4689	1125315	1993-12-29	1994-01-12	1	8777
18389	1265	1759842	1987-12-23	1988-01-13	1	6586
64635	4412	1125315	1979-12-07	1979-12-21	1	3641
16616	1145	738818	1968-11-28	1968-12-05	1	-392
31577	2136	1125315	1974-01-24	1974-02-07	1	1498
18309	1259	1125315	2016-07-23	2016-07-30	1	17012
26812	1813	1125315	1984-04-05	1984-04-19	1	5222
65846	4498	1125315	2005-04-29	2005-05-13	1	12916
27250	1842	1713332	1974-12-09	1974-12-23	1	1817
69521	4745	1129625	1978-04-22	1978-04-22	1	3033
15562	1079	1713332	2004-09-02	2004-09-23	1	12684
44965	3053	1118084	2018-07-24	2018-07-24	1	17736
63787	4359	1102527	2012-06-17	2012-06-17	1	15508
22429	1526	1515774	1995-11-04	1996-10-29	1	9798
61201	4173	1118084	2002-10-23	2002-10-23	1	11983
13655	933	1177480	1977-08-18	1977-09-01	1	2800
64255	4388	1177480	1975-01-15	1975-03-16	1	1900
17877	1232	1713332	2014-01-15	2014-04-09	1	16169
65263	4459	1125315	1966-09-07	1966-09-14	1	-1205
13636	931	1125315	1964-05-28	1964-06-11	1	-2030
15374	1068	1125315	1992-12-13	1992-12-27	1	8396
65918	4503	1119510	1977-08-20	1977-08-27	1	2795
19553	1334	1713332	1982-06-02	1982-06-16	1	4549
67786	4628	1738521	1971-10-31	1971-11-14	1	682
16237	1122	1154343	1973-11-23	1973-11-23	1	1422
64511	4405	1119510	1968-10-25	1968-11-01	1	-426
12861	879	1713332	2009-03-16	2009-04-06	1	14340
52597	3580	1125315	1983-05-22	1983-06-05	1	4903
67867	4631	1361711	2015-09-18	2015-09-18	1	16696
21405	1454	1125315	1999-11-19	1999-11-26	1	10921
23035	1563	1112807	1959-01-09	1959-01-23	1	-3996
48814	3320	1125315	1970-02-13	1970-02-20	1	50
17493	1211	1125315	1990-04-02	1990-04-16	1	7410
57828	3943	1125315	2018-07-23	2018-10-21	1	17825
18823	1292	1125315	1995-09-16	1995-09-30	1	9403
56408	3843	1125315	2004-05-08	2004-05-15	1	12553
16263	1124	1112807	1940-08-31	1940-09-14	1	-10701
64469	4403	1717327	1964-06-02	1964-06-16	1	-2025
17641	1219	1125315	2013-10-08	2013-10-15	1	15993
63184	4317	1118084	1988-08-14	1988-08-14	1	6800
70316	4804	1118084	2013-06-25	2013-06-25	1	15881
23169	1572	1112807	1972-11-26	1972-12-10	1	1074
60015	4091	1112807	1970-09-11	1970-09-25	1	267
17677	1222	1112807	1958-10-29	1958-11-12	1	-4068
13477	921	1125315	1981-04-13	1981-05-04	1	4141
62967	4299	1125315	1982-01-12	1982-01-19	1	4401
53929	3668	920293	2006-10-08	2006-10-15	1	13436
23336	1585	1119510	1976-03-26	1976-04-09	1	2290
18139	1249	1125315	2016-02-26	2016-03-04	1	16864
66422	4534	1759842	1943-12-02	1943-12-09	1	-9520
9451	652	1118084	2007-01-14	2007-01-14	1	13527
56868	3875	1125315	1963-06-26	1963-07-10	1	-2367
76457	5228	1125315	1958-08-10	1958-08-17	1	-4155
64724	4418	1124300	1993-05-07	1993-05-07	1	8527
19704	1345	1112807	1968-06-19	1968-07-03	1	-547
22247	1513	1521369	1984-05-12	1985-05-07	1	5605
68747	4689	1125315	2005-12-27	2006-01-17	1	13165
18390	1265	1759842	1989-12-09	1989-12-23	1	7296
64636	4412	1125315	2016-03-13	2016-03-20	1	16880
16617	1145	1115008	2018-08-13	2018-10-12	1	17816
31578	2136	1713332	1995-10-21	1995-11-04	1	9438
18310	1259	1150770	1981-04-14	1981-04-14	1	4121
26813	1813	1125315	1990-02-02	1990-02-09	1	7344
65847	4498	1503184	1992-05-15	1993-05-10	1	8530
27251	1842	1713332	1975-12-26	1976-01-09	1	2199
69522	4745	1521369	1991-03-19	1993-03-08	2	8467
15563	1079	1729720	1962-07-16	1962-07-26	1	-2716
44966	3053	1515774	1997-12-26	1998-12-21	1	10581
63788	4359	1125315	2016-01-31	2016-02-14	1	16845
22430	1526	1521369	1994-11-09	1995-11-04	1	9438
61202	4173	1125315	1983-01-03	1983-01-10	1	4757
13656	933	1125315	1975-04-14	1975-05-05	1	1950
64256	4388	1713332	1991-04-02	1991-04-23	1	7782
17878	1232	1759842	2014-01-15	2014-04-09	1	16169
65264	4459	1112807	1970-11-13	1970-11-27	1	330
13637	931	1125315	1975-06-09	1975-06-23	1	1999
15375	1068	1115008	2011-12-24	2012-01-07	1	15346
65919	4503	1125315	1944-07-11	1944-07-18	1	-9298
19554	1334	1738521	1974-05-19	1974-06-02	1	1613
67787	4628	975125	1986-10-08	1986-10-08	1	6124
16238	1122	1713332	1985-11-23	1985-12-07	1	5819
64512	4405	1713332	1973-09-03	1973-09-10	1	1348
17471	1209	1125315	1980-03-09	1980-03-23	1	3734
52598	3580	1125315	1989-05-15	1989-06-14	2	7104
67868	4631	1539403	2015-09-18	2015-09-18	1	16696
21406	1454	1521369	1989-08-16	1990-08-11	1	7527
23036	1563	1125315	1975-10-12	1975-10-26	1	2124
48815	3320	1729720	2012-10-01	2012-10-13	1	15626
17494	1211	1125315	1992-01-31	1992-02-07	1	8072
57829	3943	1728416	1956-05-23	1956-06-06	1	-4957
18824	1292	1551099	1960-09-21	1960-09-21	1	-3389
58012	3957	933724	2002-10-18	2002-10-25	1	11985
16264	1124	1125315	1938-06-23	1938-06-30	1	-11508
64470	4403	1102527	1964-06-02	1964-06-02	1	-2039
17642	1219	1713332	2008-04-23	2008-05-14	1	14013
63185	4317	1119510	1980-05-20	1980-06-03	1	3806
70317	4804	1125315	1978-10-14	1978-10-21	1	3215
23170	1572	1125315	1976-01-24	1976-04-23	1	2304
60016	4091	1119510	1994-03-08	1994-03-15	1	8839
17678	1222	1118084	1995-10-30	1995-10-30	1	9433
13478	921	1125315	1989-01-22	1989-02-21	1	6991
62968	4299	1125315	1985-09-06	1985-09-20	1	5741
53930	3668	1115008	1996-04-26	1996-05-24	1	9640
23337	1585	1124300	1966-02-04	1966-02-04	1	-1427
18140	1249	1729720	1971-12-09	1971-12-21	1	719
66423	4534	1759842	1994-04-02	1994-04-16	1	8871
9452	652	1125315	1971-08-28	1971-09-11	1	618
56869	3875	1557272	2018-07-14	2018-07-14	1	17726
76458	5228	1125315	1969-06-21	1969-06-28	1	-187
64725	4418	1125315	1955-01-07	1955-01-21	1	-5459
19705	1345	1118084	2005-04-19	2005-04-19	1	12892
22248	1513	1729720	2009-11-28	2009-12-10	1	14588
68748	4689	1177480	2017-02-09	2017-04-11	1	17267
18391	1265	1759842	2008-02-09	2008-02-16	1	13925
64637	4412	1713332	1979-12-21	1980-01-04	1	3655
16618	1145	1125315	1964-02-27	1964-03-12	1	-2121
31579	2136	1713332	2017-06-28	2017-07-05	1	17352
18311	1259	1729720	1990-10-03	1990-10-16	1	7593
26814	1813	1125315	2007-04-21	2007-05-05	1	13638
65848	4498	1589505	1991-05-21	1992-05-15	1	8170
27252	1842	1112807	1967-02-11	1967-02-25	1	-1041
69523	4745	1759842	1983-03-30	1983-04-06	1	4843
15564	1079	933724	2010-04-04	2010-04-18	1	14717
44967	3053	1549786	1999-12-16	2001-12-05	2	11661
63789	4359	1177480	1985-04-01	1985-04-15	1	5583
22431	1526	1713332	1977-05-09	1977-05-23	1	2699
61203	4173	1177480	2008-08-17	2008-09-07	1	14129
13657	933	1125315	1991-08-19	1991-09-16	1	7928
64257	4388	1717327	1970-09-15	1970-09-29	1	271
17879	1232	1125315	1968-12-08	1968-12-22	1	-375
65265	4459	1125315	1972-11-16	1972-12-07	1	1071
13638	931	1125315	1975-09-17	1975-10-01	1	2099
15376	1068	1713332	1992-03-14	1992-03-28	1	8122
65920	4503	1125315	1999-07-31	1999-08-14	1	10817
19555	1334	1759842	1997-04-07	1997-04-28	1	9979
67788	4628	1115008	2016-08-23	2016-09-13	1	17057
16239	1122	1125315	1991-09-07	1991-09-28	1	7940
64513	4405	1728416	1964-11-13	1964-11-27	1	-1861
17472	1209	1174888	2004-09-23	2004-09-23	1	12684
52599	3580	1521369	1986-03-21	1987-03-16	1	6283
67869	4631	1759842	1950-02-15	1950-03-01	1	-7246
21407	1454	1729720	1984-04-06	1984-04-15	1	5218
23037	1563	1154343	1977-06-25	1977-06-25	1	2732
48816	3320	1125315	2000-12-10	2000-12-24	1	11315
17495	1211	1177480	1980-10-07	1980-10-21	1	3946
57830	3943	1729720	1954-12-02	1954-12-15	1	-5496
18825	1292	1551099	1963-06-14	1963-06-14	1	-2393
58013	3957	1125315	1971-03-04	1971-03-11	1	434
16265	1124	1125315	1940-07-21	1940-07-28	1	-10749
64471	4403	1112807	1946-11-29	1947-01-28	1	-8374
17643	1219	1112807	1978-08-11	1978-08-25	1	3158
63186	4317	1125315	1970-12-03	1970-12-17	1	350
70318	4804	1125315	1994-08-07	1994-08-14	1	8991
23171	1572	1174888	1974-10-31	1974-10-31	1	1764
60017	4091	1729720	1974-04-07	1974-04-18	1	1568
17679	1222	1125315	1971-08-13	1971-11-11	2	679
13479	921	1503184	1980-06-17	1981-06-12	1	4180
62969	4299	1125315	1989-05-23	1989-06-20	1	7110
53931	3668	1118084	2013-12-04	2013-12-04	1	16043
23338	1585	1125315	1949-02-15	1949-02-22	1	-7618
18141	1249	1729720	2004-04-29	2004-05-06	1	12544
66424	4534	1759842	2008-06-10	2008-06-24	1	14054
9453	652	1738521	1973-10-01	1973-10-15	1	1383
56870	3875	1729720	1965-04-16	1965-04-23	1	-1714
76459	5228	1125315	2013-08-30	2013-08-30	1	15947
64726	4418	1322184	2008-02-01	2008-02-01	1	13910
19706	1345	1119510	2001-02-10	2001-02-17	1	11370
23469	1593	738818	1976-08-03	1976-08-10	1	2413
68749	4689	1521369	1981-05-06	1982-05-01	1	4503
18392	1265	1768849	1981-04-06	1981-04-20	1	4127
64638	4412	1728416	1965-11-19	1965-12-03	1	-1490
16619	1145	1125315	1977-03-12	1977-03-26	1	2641
31580	2136	1738521	1971-07-16	1971-07-30	1	575
18312	1259	1759842	1968-10-28	1968-11-04	1	-423
28576	1935	1119510	2004-05-04	2004-05-18	1	12556
65849	4498	705944	1986-05-22	1995-05-30	1	9280
27253	1842	1119510	1981-07-29	1981-08-12	1	4241
69524	4745	1759842	2017-06-23	2017-06-30	1	17347
15565	1079	1112807	1962-02-12	1962-02-26	1	-2866
44968	3053	920293	2014-02-03	2014-02-17	2	16118
63790	4359	1729720	1950-01-20	1950-01-30	1	-7276
22432	1526	1729720	1979-09-23	1979-10-03	1	3562
61204	4173	1717327	1967-03-11	1967-03-25	1	-1013
13658	933	1738521	1977-08-18	1977-09-01	1	2800
64258	4388	1729720	2000-04-04	2000-04-15	1	11062
17880	1232	1177480	1993-12-12	1993-12-26	1	8760
65266	4459	1759842	1985-04-07	1985-04-21	1	5589
13639	931	1125315	2009-07-26	2009-08-09	1	14465
15377	1068	1729720	1984-10-05	1984-10-15	1	5401
65921	4503	1174888	2001-02-17	2001-02-17	1	11370
19556	1334	1759842	2008-08-06	2008-08-27	1	14118
67789	4628	1150836	1986-10-24	1986-10-24	1	6140
16240	1122	1125315	1992-07-24	1992-09-22	1	8300
64514	4405	1112807	1969-09-01	1969-09-15	1	-108
17473	1209	1177480	2004-09-16	2004-10-23	1	12714
52600	3580	1713332	1995-10-20	1995-10-27	1	9430
68964	4705	920293	2010-07-13	2010-07-20	1	14810
21408	1454	1759842	1992-05-18	1992-06-08	1	8194
23038	1563	1729720	1958-06-17	1958-06-28	1	-4205
48817	3320	1125315	2015-06-30	2015-07-07	1	16623
17496	1211	1112807	1966-12-06	1966-12-20	1	-1108
57831	3943	1759842	2013-11-16	2013-11-30	1	16039
18826	1292	1759842	1974-11-14	1974-12-05	1	1799
58014	3957	1125315	1978-10-09	1978-10-23	1	3217
16266	1124	1125315	1954-05-29	1954-06-12	1	-5682
64472	4403	1112807	1969-06-20	1969-07-18	1	-167
17644	1219	1125315	1949-01-19	1949-02-02	1	-7638
63187	4317	1361711	2018-11-01	2018-11-01	1	17836
70319	4804	1150770	1978-01-28	1978-01-28	1	2949
23172	1572	738818	1995-07-30	1995-08-06	1	9348
60018	4091	920293	1988-01-03	1988-01-10	1	6583
17680	1222	1125315	1990-01-29	1990-02-05	1	7340
13480	921	1503184	1984-05-27	1985-05-22	1	5620
62970	4299	1177480	2011-11-20	2011-12-11	1	15319
53932	3668	1125315	1975-09-30	1975-10-14	1	2112
23339	1585	1125315	1953-12-30	1954-01-13	1	-5832
18142	1249	738818	1973-05-29	1973-06-05	1	1251
66425	4534	1112807	1945-04-19	1945-05-03	1	-9009
9454	652	1112807	1991-05-18	1991-06-08	1	7828
56871	3875	1759842	1985-06-20	1985-06-27	1	5656
76460	5228	1728416	1952-05-21	1952-06-04	1	-6420
64727	4418	1332418	2008-02-01	2008-02-01	1	13910
19707	1345	1125315	2001-02-10	2001-02-17	1	11370
23470	1593	920293	1981-10-31	1981-11-07	1	4328
68750	4689	19127890	1990-03-19	1991-03-14	1	7742
18393	1265	933724	2017-06-09	2017-06-16	1	17333
64639	4412	1729720	1982-10-17	1982-10-25	1	4680
16620	1145	1729720	1939-04-24	1939-05-06	1	-11198
31581	2136	19127890	1984-05-18	1985-05-13	1	5611
18313	1259	738818	2008-03-15	2008-03-29	1	13967
28577	1935	738818	1980-01-12	1980-01-26	1	3677
65850	4498	1119510	1996-03-01	1996-03-15	1	9570
27254	1842	1713332	2001-02-13	2001-02-27	1	11380
69525	4745	738818	2011-09-28	2011-10-12	1	15259
15566	1079	1125315	1983-02-06	1983-02-20	1	4798
44969	3053	920293	2015-03-25	2015-04-01	1	16526
63791	4359	1759842	1987-06-13	1987-06-20	1	6379
22433	1526	1125315	1974-05-18	1974-06-01	1	1612
61205	4173	1738521	1977-02-18	1977-03-04	1	2619
13659	933	1713332	2009-10-17	2009-10-24	1	14541
69448	4738	738818	1917-11-05	1917-11-12	1	-19043
17881	1232	1759842	1980-05-14	1980-05-21	1	3793
65267	4459	1118084	2005-05-29	2005-05-29	1	12932
13640	931	1539403	2015-10-16	2015-10-16	1	16724
15378	1068	705944	1985-09-11	1991-09-20	1	7932
65922	4503	1326303	2014-04-01	2014-04-01	1	16161
19557	1334	1112807	1971-10-11	1971-10-25	1	662
67790	4628	1729720	1979-12-16	1979-12-25	1	3645
16241	1122	1149380	1973-11-23	1973-11-23	1	1422
64515	4405	1125315	1983-05-10	1983-05-17	1	4884
17474	1209	1717327	1978-01-06	1978-01-20	1	2941
52601	3580	1759842	2014-11-17	2015-02-09	1	16475
68965	4705	1118084	2009-03-23	2009-03-23	1	14326
21409	1454	19127890	1987-08-27	1988-08-21	1	6807
23039	1563	1729720	2002-10-24	2002-10-31	1	11991
48818	3320	1729720	1977-04-23	1977-05-04	1	2680
17497	1211	1119510	1967-01-07	1967-01-14	1	-1083
57832	3943	1125315	1961-09-24	1961-10-15	1	-3000
18827	1292	738818	1959-05-31	1959-06-14	1	-3854
58015	3957	1125315	1980-07-12	1980-07-26	1	3859
16267	1124	1125315	1991-10-01	1991-10-22	1	7964
64473	4403	1119510	1982-07-12	1982-07-26	1	4589
17645	1219	1310149	2007-12-10	2007-12-10	1	13857
63188	4317	1539403	2018-11-01	2018-11-01	1	17836
70320	4804	1154343	1997-03-23	1997-03-23	1	9943
23173	1572	920293	1987-08-01	1987-08-08	1	6428
60019	4091	933724	1988-01-03	1988-01-10	1	6583
17681	1222	1728416	1958-10-29	1958-11-12	1	-4068
13481	921	1759842	1977-06-11	1977-06-25	1	2732
64053	4376	738818	1929-02-15	1929-03-01	1	-14916
53933	3668	1177480	1991-12-13	1991-12-27	1	8030
23340	1585	1125315	1987-04-12	1987-04-26	1	6324
18143	1249	1125315	1973-05-29	1973-06-05	1	1251
66426	4534	1112807	1949-06-20	1949-07-04	1	-7486
9455	652	1125315	2003-01-27	2003-02-17	1	12100
60266	4109	1112807	1965-05-30	1965-06-13	1	-1663
76461	5228	1118084	1968-12-03	1968-12-03	1	-394
64728	4418	1728416	1955-01-07	1955-01-21	1	-5459
19708	1345	1738521	1967-11-05	1967-11-19	1	-774
23471	1593	933724	1981-10-31	1981-11-07	1	4328
70415	4811	1125315	1962-09-16	1962-09-23	1	-2657
18394	1265	1118084	2017-12-18	2017-12-18	1	17518
64640	4412	1125315	1965-11-19	1965-12-03	1	-1490
16621	1145	1112807	1961-10-22	1961-11-26	1	-2958
31582	2136	975125	2001-06-03	2001-06-03	1	11476
18314	1259	1115008	2007-07-05	2007-07-19	1	13713
28578	1935	738818	2004-05-04	2004-05-18	1	12556
65851	4498	1125315	1979-12-12	1979-12-26	1	3646
27255	1842	1759842	2001-02-13	2001-02-27	1	11380
69526	4745	1119510	1981-11-27	1981-12-04	1	4355
15567	1079	1125315	2004-12-07	2004-12-14	1	12766
44970	3053	933724	2014-02-03	2014-02-17	1	16118
65333	4465	1112807	1976-01-11	1976-01-25	1	2215
22434	1526	1521369	1988-12-10	1989-12-05	1	7278
65341	4466	1125315	1996-07-16	1996-07-30	1	9707
13660	933	1717327	1974-03-20	1974-04-03	1	1553
69449	4738	1125315	1917-11-05	1917-11-12	1	-19043
17882	1232	1124300	2003-01-19	2003-01-19	1	12071
65268	4459	1125315	1977-12-04	1977-12-11	1	2901
13641	931	1729720	1965-11-20	1965-11-30	1	-1493
15379	1068	1118084	2014-11-23	2014-11-23	1	16397
65923	4503	1759842	2004-07-24	2004-07-31	1	12630
19558	1334	1125315	1982-06-02	1982-06-16	1	4549
67791	4628	1738521	1970-05-05	1970-05-19	1	138
16242	1122	1124300	2004-01-28	2004-01-28	1	12445
64516	4405	1177480	2011-06-10	2011-07-01	1	15156
17475	1209	1125315	1978-01-06	1978-01-20	1	2941
53267	3628	738818	1931-02-06	1931-02-20	1	-14195
68966	4705	1125315	1983-01-09	1983-01-23	1	4770
21959	1496	1112807	1933-05-10	1933-06-14	1	-13350
23040	1563	1125315	1976-04-06	1976-04-13	1	2294
49463	3371	1125315	1977-07-05	1977-07-19	1	2756
17498	1211	1125315	1984-11-26	1984-12-10	1	5457
57833	3943	1112807	1973-03-14	1973-04-20	1	1205
18828	1292	1125315	1959-05-31	1959-06-14	1	-3854
58016	3957	1759842	1966-10-01	1966-10-08	1	-1181
16268	1124	738818	1991-05-11	1991-05-25	1	7814
64474	4403	1125315	1964-06-02	1964-06-16	1	-2025
17646	1219	1729720	1942-11-14	1942-11-25	1	-9899
63189	4317	1759842	2002-10-16	2002-10-23	1	11983
70321	4804	1515774	1992-03-12	1993-03-07	1	8466
23174	1572	933724	1987-08-01	1987-08-08	1	6428
60020	4091	1177480	2015-03-31	2015-04-21	1	16546
17682	1222	1759842	2013-09-06	2013-09-20	1	15968
15582	1081	1124300	2001-03-24	2001-03-24	1	11405
64054	4376	1102527	1956-10-20	1956-10-20	1	-4821
53934	3668	1177480	2008-08-17	2008-09-07	1	14129
23341	1585	1729720	1942-09-30	1942-10-08	1	-9947
18144	1249	1125315	1984-09-27	1984-12-26	1	5473
66427	4534	1119510	1995-01-05	1995-01-12	1	9142
9456	652	1759842	1993-09-03	1993-09-17	1	8660
60267	4109	1119510	2015-03-21	2015-04-04	1	16529
76462	5228	1125315	1939-01-09	1939-01-23	1	-11301
64729	4418	1729720	1996-10-09	1996-10-22	1	9791
24624	1661	738818	1963-02-19	1963-02-26	1	-2501
23472	1593	1112807	1944-01-09	1944-01-23	1	-9475
70416	4811	1125315	2011-02-17	2011-03-10	1	15043
18395	1265	1129625	1983-06-01	1983-06-01	1	4899
64641	4412	1713332	1995-07-02	1995-07-23	1	9334
16622	1145	1118084	1981-12-01	1981-12-01	1	4352
31583	2136	1119510	1983-12-11	1983-12-25	1	5106
18315	1259	1119510	2001-03-14	2001-03-21	1	11402
28579	1935	1125315	1980-01-12	1980-01-26	1	3677
65852	4498	1192710	1978-03-01	1978-03-01	1	2981
27256	1842	738818	1981-07-29	1981-08-12	1	4241
69527	4745	1119510	2011-09-28	2011-10-12	1	15259
17337	1197	738818	1980-08-23	1980-09-06	1	3901
44971	3053	933724	2015-03-25	2015-04-01	1	16526
65334	4465	1125315	1987-05-04	1987-06-03	1	6362
22435	1526	1713332	2009-09-26	2009-10-10	1	14527
65342	4466	1177480	2016-09-04	2016-09-18	1	17062
13661	933	1759842	2009-10-17	2009-10-24	1	14541
69450	4738	1112807	1924-03-02	1924-03-30	1	-16713
17883	1232	1125315	1989-06-30	1989-07-14	1	7134
65269	4459	1125315	1982-05-20	1982-06-10	1	4543
13642	931	738818	2009-07-26	2009-08-09	1	14465
15380	1068	1125315	1987-05-05	1987-05-12	1	6340
65924	4503	1759842	2018-05-29	2018-06-12	1	17694
19559	1334	1713332	1997-04-07	1997-04-28	1	9979
67792	4628	1112807	1971-10-31	1971-11-14	1	682
16243	1122	1125315	1972-08-03	1972-11-01	1	1035
64517	4405	1713332	2011-06-20	2011-07-11	1	15166
17476	1209	1125315	1981-11-07	1981-11-21	1	4342
53268	3628	1125315	1931-02-06	1931-02-20	1	-14195
68967	4705	1125315	1997-07-14	1997-07-28	1	10070
21960	1496	1115008	1994-06-16	1994-07-16	1	8962
26408	1783	1118084	2002-03-03	2002-03-03	1	11749
49464	3371	1129625	1976-03-23	1976-03-23	1	2273
17499	1211	1125315	2013-08-02	2013-09-06	1	15954
57834	3943	1124300	1990-07-24	1990-07-24	1	7509
18829	1292	1728416	1953-05-31	1953-06-14	1	-6045
58017	3957	920293	2002-10-18	2002-10-25	1	11985
16269	1124	1112807	1945-08-19	1945-10-18	1	-8841
64475	4403	1125315	1969-02-21	1969-03-07	1	-300
17647	1219	1112807	1968-03-01	1968-04-05	1	-636
63190	4317	738818	1980-05-20	1980-06-03	1	3806
70322	4804	1515774	1994-03-02	1995-02-25	1	9186
23175	1572	1118084	1997-12-25	1997-12-25	1	10220
60021	4091	1309944	2017-09-10	2017-09-10	1	17419
17683	1222	1112807	1960-05-21	1960-06-11	1	-3491
15583	1081	1125315	1977-12-09	1977-12-23	1	2913
64055	4376	1115008	2011-10-14	2011-11-04	1	15282
53935	3668	1515774	1989-08-27	1990-08-22	1	7538
23342	1585	1112807	1935-03-16	1935-03-30	1	-12696
18145	1249	1125315	2000-06-24	2000-07-01	1	11139
66428	4534	1119510	2003-02-11	2003-02-18	1	12101
9457	652	920293	1991-03-12	1991-03-19	1	7747
60268	4109	1125315	1973-05-19	1973-05-26	1	1241
76463	5228	1125315	1971-03-04	1971-03-11	1	434
64730	4418	738818	1979-10-22	1979-10-29	1	3588
24625	1661	1112807	1993-06-02	1993-06-16	1	8567
23473	1593	1112807	1953-06-01	1953-06-15	1	-6044
70417	4811	1759842	1964-10-08	1964-10-28	1	-1891
18396	1265	1713332	2001-05-17	2001-06-07	1	11480
64642	4412	1759842	1995-07-02	1995-07-23	1	9334
16623	1145	1125315	1958-04-20	1958-04-27	1	-4267
31584	2136	19127890	1988-04-27	1989-04-22	1	7051
18316	1259	1125315	1960-12-05	1960-12-19	1	-3300
28580	1935	1125315	1989-12-13	1989-12-27	1	7300
65853	4498	1713332	1981-08-09	1981-08-16	1	4245
27257	1842	1125315	1981-07-29	1981-08-12	1	4241
69528	4745	1125315	1981-11-27	1982-01-16	2	4376
17338	1197	1119510	1997-11-04	1997-11-11	1	10176
44972	3053	1125315	1982-11-05	1982-11-19	1	4705
65335	4465	1713332	2011-10-27	2011-11-17	1	15295
22436	1526	1738521	1974-05-18	1974-06-01	1	1612
65343	4466	1125315	1977-07-31	1977-08-14	1	2782
13662	933	1115008	2014-10-15	2014-11-05	1	16379
69451	4738	1759842	1926-07-11	1926-08-01	1	-15859
17884	1232	1125315	1991-10-04	1991-10-11	1	7953
65270	4459	1713332	1985-04-07	1985-04-21	1	5589
13643	931	1322184	2015-10-16	2015-10-16	1	16724
15381	1068	1177480	2006-10-05	2006-11-02	1	13454
65925	4503	1125315	1973-08-16	1973-08-23	1	1330
19560	1334	1713332	2008-08-06	2008-08-27	1	14118
67793	4628	1118084	2004-09-05	2004-09-05	1	12666
16244	1122	1125315	1976-11-10	1976-11-24	1	2519
64739	4419	1125315	1983-07-04	1983-08-08	1	4967
17477	1209	1125315	2004-09-23	2004-09-23	1	12684
53269	3628	1125315	1965-10-25	1965-11-01	1	-1522
68968	4705	1521369	1991-05-17	1993-05-06	2	8526
21961	1496	1125315	1970-11-23	1970-11-23	1	326
26409	1783	1125315	1968-04-11	1968-04-18	1	-623
49465	3371	1515774	1994-07-16	1995-07-11	1	9322
17500	1211	1154343	1966-10-29	1966-10-29	1	-1160
57835	3943	1125315	1973-03-21	1973-03-21	1	1175
18830	1292	1112807	1953-05-31	1953-06-14	1	-6045
58018	3957	1125315	1994-01-22	1994-01-29	1	8794
16270	1124	1124300	1968-10-12	1968-10-12	1	-446
64476	4403	1125315	1992-10-04	1992-11-03	1	8342
17648	1219	1124300	1978-12-24	1978-12-24	1	3279
63191	4317	1112807	1947-09-04	1947-09-18	1	-8141
70323	4804	1549786	1992-03-12	1993-03-07	1	8466
23176	1572	1125315	1989-07-12	1989-08-09	1	7160
60022	4091	1343916	2017-09-10	2017-09-10	1	17419
17684	1222	1119510	1988-12-27	1989-01-03	1	6942
15584	1081	1713332	1981-02-23	1981-03-02	1	4078
64056	4376	1125315	1929-02-15	1929-03-01	1	-14916
55696	3790	1125315	1969-05-23	1969-06-06	1	-209
23343	1585	1112807	1950-10-06	1950-10-27	1	-7006
18146	1249	1308738	1988-01-20	1988-01-20	1	6593
66429	4534	1125315	1973-02-22	1973-03-08	1	1162
9458	652	933724	1991-03-12	1991-03-19	1	7747
60269	4109	1149380	1967-12-08	1967-12-08	1	-755
76464	5228	933724	1966-09-18	1966-10-02	1	-1187
64731	4418	1125315	1979-10-22	1979-10-29	1	3588
24626	1661	1119510	2003-08-16	2003-08-30	1	12294
23474	1593	1118084	1975-08-17	1975-08-17	1	2054
70418	4811	1112807	1965-12-26	1966-03-26	1	-1377
18397	1265	1713332	1994-02-08	1994-02-15	1	8811
64643	4412	1112807	1969-07-20	1969-08-03	1	-151
16624	1145	1125315	1968-11-28	1968-12-05	1	-392
32877	2228	738818	1958-12-17	1958-12-31	1	-4019
18317	1259	1125315	2008-03-15	2008-03-29	1	13967
28581	1935	1125315	2004-05-04	2004-05-18	1	12556
65854	4498	1759842	1981-08-09	1981-08-16	1	4245
27258	1842	1177480	1986-05-02	1986-05-30	1	5993
69529	4745	1125315	1982-11-12	1982-12-10	1	4726
17339	1197	1124300	2015-05-16	2015-05-16	1	16571
44973	3053	1174888	1997-10-31	1997-10-31	1	10165
65336	4465	1759842	2011-10-27	2011-11-17	1	15295
22437	1526	1759842	1977-05-09	1977-05-23	1	2699
65344	4466	1759842	2013-05-13	2013-05-27	1	15852
13663	933	1124300	2011-07-09	2011-07-09	1	15164
69452	4738	920293	1935-10-09	1935-10-16	1	-12496
17885	1232	1717327	1966-03-09	1966-03-23	1	-1380
65271	4459	1125315	1968-12-03	1968-12-10	1	-387
13644	931	1332418	2015-10-16	2015-10-16	1	16724
15382	1068	1759842	1992-03-14	1992-03-28	1	8122
65926	4503	1125315	1977-08-20	1977-08-27	1	2795
19561	1334	1125315	1969-12-20	1970-01-17	1	16
67794	4628	1125315	1969-06-26	1969-07-10	1	-175
16245	1122	1125315	1985-11-23	1985-12-07	1	5819
64740	4419	1112807	1971-03-06	1971-04-03	1	457
17478	1209	1177480	1995-06-17	1995-07-01	1	9312
53270	3628	1125315	1999-03-10	1999-03-24	1	10674
68969	4705	1738521	1976-08-23	1976-09-06	1	2440
21962	1496	1125315	1979-08-29	1979-10-28	1	3587
26410	1783	1729720	2008-12-19	2008-12-26	1	14239
49466	3371	1738521	1977-07-05	1977-07-19	1	2756
17501	1211	1713332	1993-06-13	1993-07-04	1	8585
57836	3943	1174888	1973-03-21	1973-03-21	1	1175
18831	1292	1119510	1995-09-16	1995-09-30	1	9403
58019	3957	1177480	1988-04-01	1988-04-22	1	6686
16271	1124	1125315	1958-04-24	1958-05-08	1	-4256
64477	4403	1713332	1980-03-26	1980-04-02	1	3744
17649	1219	1759842	2008-04-23	2008-05-14	1	14013
63192	4317	1112807	1954-01-30	1954-04-30	1	-5725
70324	4804	1549786	1994-03-02	1995-02-25	1	9186
23177	1572	1125315	1995-07-30	1995-08-06	1	9348
60023	4091	1713332	2010-12-22	2011-01-12	1	14986
17685	1222	1125315	1975-06-12	1975-06-19	1	1995
15585	1081	1729720	2003-07-01	2003-07-09	1	12242
64057	4376	1310149	1978-07-18	1978-07-18	1	3120
55697	3790	1125315	2005-05-01	2005-05-08	1	12911
23344	1585	1125315	1960-11-17	1960-12-01	1	-3318
18147	1249	1759842	1981-07-14	1981-08-04	1	4233
66430	4534	1125315	1998-06-10	1998-08-16	1	10454
9459	652	1125315	1973-11-07	1973-11-14	1	1413
60270	4109	19010482	2018-08-29	2018-09-19	1	17793
76465	5228	1112807	1939-01-21	1939-02-11	1	-11282
64732	4418	1177480	2006-09-30	2006-11-06	1	13458
24627	1661	1125315	1962-03-14	1962-03-28	1	-2836
23475	1593	1125315	1976-02-04	1976-02-18	1	2239
70419	4811	1125315	1992-04-09	1992-04-23	1	8148
18398	1265	1759842	1994-02-08	1994-02-15	1	8811
64644	4412	1125315	1989-01-31	1989-02-14	1	6984
16625	1145	1177480	1977-02-05	1977-04-06	1	2652
32878	2228	1125315	2001-02-26	2001-03-12	1	11393
18318	1259	1713332	1954-05-04	1954-05-11	1	-5714
28582	1935	1521369	1981-01-15	1982-01-10	1	4392
65855	4498	19127890	1992-05-15	1993-05-10	1	8530
27259	1842	1729720	1968-08-07	1968-08-15	1	-504
69530	4745	1125315	1988-02-23	1988-03-01	1	6634
17340	1197	1125315	1980-08-23	1980-09-06	1	3901
44974	3053	1595799	1999-12-16	2001-12-05	2	11661
65337	4465	1118084	2010-09-04	2010-09-04	1	14856
22438	1526	1759842	2009-09-26	2009-10-10	1	14527
65345	4466	1713332	2005-01-10	2005-01-31	1	12814
13664	933	1125315	1974-03-20	1974-04-03	1	1553
69453	4738	920293	1937-11-11	1937-11-25	2	-11725
17886	1232	1729720	1965-09-14	1965-09-27	1	-1557
65272	4459	1177480	2012-12-03	2012-12-17	1	15691
13645	931	1728416	1963-01-04	1963-01-18	1	-2540
15383	1068	1115008	2013-07-28	2013-08-18	1	15935
65927	4503	1125315	2001-02-17	2001-02-17	1	11370
19562	1334	1125315	1974-05-19	1974-06-02	1	1613
67795	4628	1738521	1969-06-26	1969-07-10	1	-175
18489	1272	1125315	1985-04-06	1985-04-20	1	5588
64741	4419	1124300	1990-12-31	1990-12-31	1	7669
17479	1209	1118084	2014-01-17	2014-01-17	1	16087
53271	3628	1174888	2006-08-19	2006-08-19	1	13379
68970	4705	1759842	2019-06-21	2019-06-21	1	18068
21963	1496	1713332	1984-09-12	1984-09-19	1	5375
26411	1783	1115008	1994-03-09	1994-03-30	1	8854
49467	3371	1125315	1979-08-19	1979-09-02	1	3531
17502	1211	1713332	1998-04-12	1998-05-03	1	10349
57837	3943	1713332	2013-11-16	2013-11-30	1	16039
18832	1292	1125315	1999-01-15	1999-03-23	1	10673
58020	3957	1759842	2010-05-11	2010-05-25	1	14754
16272	1124	1125315	1975-07-25	1975-08-01	1	2038
64478	4403	1713332	1996-11-20	1996-12-04	1	9834
17650	1219	1125315	1947-08-20	1947-08-27	1	-8163
63193	4317	1112807	1964-10-04	1964-11-03	1	-1885
70325	4804	19127890	1997-02-14	1999-02-04	2	10626
23178	1572	1713332	2019-02-13	2019-03-06	1	17961
60024	4091	1759842	2010-12-22	2011-01-12	1	14986
17686	1222	1174888	1971-08-13	1971-08-13	1	589
15586	1081	1759842	1981-02-23	1981-03-02	1	4078
64058	4376	1326303	1978-07-18	1978-07-18	1	3120
55698	3790	1713332	1976-12-17	1976-12-31	1	2556
23345	1585	1713332	1942-05-28	1942-06-04	1	-10073
18148	1249	1102527	1984-09-27	1984-09-27	1	5383
66431	4534	1174888	2011-11-30	2011-11-30	1	15308
9460	652	1125315	2004-12-02	2004-12-16	1	12768
60271	4109	738818	1988-09-17	1988-09-24	1	6841
76466	5228	1125315	1937-01-11	1937-01-18	1	-12036
64733	4418	1115008	2003-02-20	2003-03-20	1	12131
24628	1661	1125315	1979-01-05	1979-01-12	1	3298
23476	1593	1125315	2014-09-22	2014-09-29	1	16342
70420	4811	1728416	1964-07-22	1964-08-05	1	-1975
19163	1314	1112807	1935-05-03	1935-05-17	1	-12648
64645	4412	1125315	2000-09-14	2000-11-20	1	11281
16626	1145	1177480	2006-08-02	2006-08-16	1	13376
32879	2228	1177480	2010-04-20	2010-05-18	1	14747
18319	1259	1713332	1962-01-06	1962-01-27	1	-2896
28583	1935	1729720	1981-05-01	1981-05-13	1	4150
67112	4580	920293	2008-04-03	2008-04-10	1	13979
27543	1860	1125315	1984-05-13	1984-07-12	1	5306
69531	4745	1125315	2011-09-28	2011-10-12	1	15259
17341	1197	1125315	1988-10-30	1988-11-27	1	6905
44975	3053	1713332	2018-12-21	2018-12-28	1	17893
65338	4465	1125315	1977-07-04	1977-07-25	1	2762
22439	1526	19127890	1994-11-09	1996-10-29	2	9798
65346	4466	1729720	1976-02-09	1976-02-18	1	2239
18263	1257	1119510	1980-10-20	1980-10-27	1	3952
69454	4738	1112807	1911-03-11	1911-03-25	1	-21467
17887	1232	738818	1996-07-30	1996-08-13	1	9721
65680	4487	738818	1990-10-03	1990-10-10	1	7587
17097	1177	1118084	2004-01-04	2004-01-04	1	12421
15384	1068	1119510	1987-05-05	1987-05-12	1	6340
65928	4503	1310149	2014-04-01	2014-04-01	1	16161
19563	1334	1125315	1997-01-23	1997-02-27	1	9919
69600	4750	1125315	1977-09-25	1977-10-02	1	2831
18490	1272	1125315	1986-11-08	1986-11-22	1	6169
64742	4419	1125315	1956-01-21	1956-01-28	1	-5087
17480	1209	1125315	1978-07-16	1978-07-30	1	3132
53272	3628	1332418	2002-04-13	2002-04-13	1	11790
68971	4705	933724	2010-07-13	2010-07-20	1	14810
21964	1496	1729720	1948-08-17	1948-08-24	1	-7800
26412	1783	1125315	1981-03-15	1981-03-22	1	4098
49468	3371	1125315	1985-09-19	1985-10-10	1	5761
17503	1211	1717327	1969-03-25	1969-04-08	1	-268
60981	4159	1115008	2006-06-23	2006-07-14	1	13343
20943	1430	933724	1997-12-25	1998-01-01	1	10227
58021	3957	1112807	1964-05-07	1964-08-05	1	-1975
16273	1124	1125315	1991-05-11	1991-05-25	1	7814
64479	4403	738818	1982-07-12	1982-07-26	1	4589
17651	1219	1307863	2007-12-10	2007-12-10	1	13857
63194	4317	1125315	1980-05-20	1980-06-03	1	3806
70326	4804	738818	1978-10-14	1978-10-21	1	3215
23179	1572	1759842	2019-02-13	2019-03-06	1	17961
60891	4153	1119510	2015-03-20	2015-04-03	1	16528
17687	1222	1177480	2017-12-09	2017-12-30	1	17530
15587	1081	1125315	1963-03-10	1963-03-17	1	-2482
64059	4376	1557272	2010-12-28	2010-12-28	1	14971
55699	3790	1713332	1989-04-05	1989-04-19	1	7048
23346	1585	1713332	2015-05-14	2015-06-04	1	16590
18149	1249	1124300	2009-10-06	2009-10-06	1	14523
66432	4534	1545958	2011-11-30	2011-11-30	1	15308
9461	652	1125315	2017-10-31	2017-11-21	1	17491
60272	4109	920293	2008-02-10	2008-02-17	1	13926
76467	5228	1125315	2007-11-16	2007-11-30	1	13847
64734	4418	1125315	1952-07-21	1952-08-11	1	-6352
24629	1661	1125315	1986-06-18	1986-07-09	1	6033
23477	1593	1322184	2009-10-01	2009-10-01	1	14518
70421	4811	1759842	1968-02-07	1968-02-14	1	-687
19164	1314	1713332	1953-09-22	1953-10-13	1	-5924
64646	4412	1759842	1979-12-21	1980-01-04	1	3655
16627	1145	1713332	2016-09-29	2017-03-30	1	17255
32880	2228	1713332	2015-11-16	2015-11-30	1	16769
18320	1259	738818	1994-02-27	1994-03-13	1	8837
28584	1935	1759842	1973-10-20	1973-11-03	1	1402
67113	4580	1125315	1967-05-26	1967-06-09	1	-937
27544	1860	1309944	1991-12-23	1991-12-23	1	8026
69532	4745	1713332	1983-03-30	1983-04-06	1	4843
17342	1197	738818	1997-11-04	1997-11-11	1	10176
44976	3053	1759842	2018-12-21	2018-12-28	1	17893
65339	4465	1125315	1986-09-17	1986-09-24	1	6110
23193	1574	1118084	2000-12-11	2000-12-11	1	11302
65347	4466	1738521	1977-07-31	1977-08-14	1	2782
18264	1257	1124300	2010-03-08	2010-03-08	1	14676
69455	4738	1119510	1917-11-05	1917-11-12	1	-19043
17888	1232	1125315	1969-08-21	1969-09-04	1	-119
65681	4487	1125315	1960-05-10	1960-05-17	1	-3516
17098	1177	1125315	2016-01-03	2016-01-24	1	16824
15385	1068	1177480	2004-10-01	2004-10-15	1	12706
67051	4577	1125315	2017-05-03	2017-05-10	1	17296
22001	1498	1125315	1969-01-19	1969-02-02	1	-333
69601	4750	1177480	2014-04-12	2014-05-17	1	16207
18491	1272	738818	2008-10-04	2008-10-18	1	14170
64743	4419	1125315	1959-07-02	1959-08-06	1	-3801
17481	1209	1125315	1986-06-29	1986-07-13	1	6037
53273	3628	1539403	2002-04-13	2002-04-13	1	11790
68972	4705	1125315	1975-11-27	1975-12-27	1	2186
21965	1496	1759842	1984-09-12	1984-09-19	1	5375
26413	1783	1149380	1961-08-02	1961-08-02	1	-3074
49469	3371	1515774	1990-08-06	1991-08-01	1	7882
17504	1211	1759842	1993-06-13	1993-07-04	1	8585
60982	4159	1174888	1972-10-30	1972-10-30	1	1033
20944	1430	1124300	1986-03-02	1986-03-02	1	5904
58022	3957	1125315	1989-11-26	1989-12-10	1	7283
16274	1124	1125315	1998-11-20	1998-12-04	1	10564
64480	4403	1112807	1940-10-01	1940-11-30	1	-10624
17652	1219	1326303	2007-12-10	2007-12-10	1	13857
63195	4317	1125315	2007-11-25	2007-12-09	1	13856
70327	4804	1729720	1990-04-13	1990-04-24	1	7418
23180	1572	19127890	1981-05-31	1983-05-21	2	4888
60892	4153	1125315	1975-12-26	1976-01-09	1	2199
17688	1222	1713332	1954-11-09	1954-11-16	1	-5525
15588	1081	1125315	1985-01-19	1985-02-02	1	5511
64060	4376	1713332	2008-03-05	2008-03-19	1	13957
55700	3790	1759842	1976-12-17	1976-12-31	1	2556
23347	1585	1728416	1959-12-09	1959-12-23	1	-3662
18150	1249	1729720	1979-01-17	1979-01-25	1	3311
66433	4534	1713332	1943-12-02	1943-12-09	1	-9520
9462	652	1177480	1997-04-07	1997-04-28	1	9979
60273	4109	933724	2008-02-10	2008-02-17	1	13926
76468	5228	1729720	2015-05-03	2015-05-15	1	16570
64735	4418	1125315	1956-05-22	1956-06-12	1	-4951
24630	1661	1125315	2003-08-16	2003-08-30	1	12294
23478	1593	1347450	2009-10-01	2009-10-01	1	14518
70422	4811	1759842	2007-10-10	2007-10-17	1	13803
19165	1314	1713332	2013-09-08	2013-09-22	1	15970
64647	4412	1112807	1967-03-14	1967-03-28	1	-1010
16628	1145	1729720	2018-09-01	2018-09-10	1	17784
32881	2228	1729720	1950-12-01	1950-12-09	1	-6963
18321	1259	1118084	1981-10-07	1981-10-07	1	4297
28585	1935	1119510	1980-01-12	1980-01-26	1	3677
67114	4580	1738521	1970-12-05	1970-12-19	1	352
27545	1860	1332418	1996-01-15	1996-01-15	1	9510
69533	4745	1713332	2017-06-23	2017-06-30	1	17347
17343	1197	1125315	1987-01-18	1987-02-08	1	6247
44977	3053	19127890	1997-12-26	1998-12-21	1	10581
65340	4465	1738521	1976-01-11	1976-01-25	1	2215
23194	1574	1125315	1966-07-25	1966-08-08	1	-1242
65348	4466	1759842	2005-01-10	2005-01-31	1	12814
18265	1257	1125315	1977-02-20	1977-02-27	1	2614
69456	4738	1713332	1926-07-11	1926-08-01	1	-15859
17889	1232	1125315	1996-07-30	1996-08-13	1	9721
65682	4487	1125315	1980-09-01	1980-09-08	1	3903
17099	1177	1713332	1989-09-02	1989-09-16	1	7198
15386	1068	1713332	2011-12-24	2012-01-07	1	15346
67052	4577	1174888	2002-04-07	2002-04-07	1	11784
22002	1498	1713332	1965-10-17	1965-10-31	1	-1523
69602	4750	1503184	1979-03-27	1980-03-21	1	3732
18492	1272	1119510	1986-11-08	1986-11-22	1	6169
64744	4419	1125315	2005-05-12	2005-05-26	1	12929
17482	1209	1713332	1981-11-07	1981-11-21	1	4342
53274	3628	1545958	2006-08-19	2006-08-19	1	13379
68973	4705	1503184	1991-05-17	1993-05-06	2	8526
21966	1496	1112807	1922-08-06	1922-08-20	1	-17301
26414	1783	1551099	1962-03-13	1962-03-13	1	-2851
49470	3371	1549786	1990-08-06	1991-08-01	1	7882
17505	1211	1759842	1998-04-12	1998-05-03	1	10349
60983	4159	1521369	1976-12-18	1977-12-13	1	2903
20945	1430	1125315	1986-04-25	1986-05-09	1	5972
58023	3957	1149380	1998-12-24	1998-12-24	1	10584
16275	1124	1125315	2005-03-26	2005-04-23	1	12896
64481	4403	1112807	1943-11-15	1944-02-13	1	-9454
20265	1382	1125315	2003-08-04	2003-08-11	1	12275
63196	4317	1713332	1967-09-25	1967-10-09	1	-815
70328	4804	1149380	1997-03-23	1997-03-23	1	9943
23181	1572	1119510	1995-07-30	1995-08-06	1	9348
60893	4153	1125315	1999-11-08	1999-11-08	1	10903
17689	1222	1713332	1986-02-15	1986-03-08	1	5910
15589	1081	1125315	2001-06-26	2001-07-03	1	11506
64061	4376	1729720	1951-05-01	1951-05-12	1	-6809
55701	3790	1759842	1989-04-05	1989-04-19	1	7048
23348	1585	1759842	1963-10-21	1963-11-25	1	-2229
19735	1348	1112807	1919-09-16	1919-11-15	1	-18310
66532	4544	1112807	1970-07-13	1970-07-27	1	207
9463	652	1713332	1993-09-03	1993-09-17	1	8660
60274	4109	1115008	2013-08-05	2013-08-19	1	15936
76469	5228	1759842	1956-07-23	1956-08-06	1	-4896
64736	4418	1125315	1968-11-25	1968-12-09	1	-388
24631	1661	1177480	2018-01-06	2018-01-20	1	17551
23479	1593	1713332	1975-02-24	1975-03-10	1	1894
70423	4811	1125315	2006-08-22	2006-08-29	1	13389
19166	1314	1759842	1952-12-04	1952-12-18	1	-6223
64648	4412	1115008	2007-01-18	2007-02-01	1	13545
16629	1145	1759842	1944-08-10	1944-09-07	1	-9247
32882	2228	933724	2007-02-27	2007-03-06	1	13578
18322	1259	1119510	2008-03-15	2008-03-29	1	13967
28586	1935	1729720	1972-12-21	1972-12-29	1	1093
67115	4580	19127890	1983-02-10	1984-02-05	1	5148
27546	1860	1343916	1991-12-23	1991-12-23	1	8026
69534	4745	19127890	1991-03-19	1993-03-08	2	8467
17344	1197	1729720	1981-12-17	1981-12-27	1	4378
44978	3053	1115008	1997-10-31	1998-01-29	1	10255
66001	4509	1112807	1968-09-22	1968-11-21	1	-406
23195	1574	1125315	1986-10-04	1986-11-08	1	6155
65349	4466	1124300	2008-02-09	2008-02-09	1	13918
18266	1257	1125315	1987-06-19	1987-07-03	1	6392
69457	4738	1729720	1915-12-17	1915-12-27	1	-19729
17890	1232	1713332	1980-05-14	1980-05-21	1	3793
65683	4487	1125315	1990-10-03	1990-10-10	1	7587
17100	1177	1713332	1992-11-07	1992-11-14	1	8353
17426	1206	975125	1988-02-14	1988-02-14	1	6618
67053	4577	1713332	1988-04-04	1988-04-18	1	6682
22003	1498	1717327	1969-01-19	1969-02-02	1	-333
69603	4750	1521369	1979-03-27	1980-03-21	1	3732
18493	1272	1119510	2008-10-04	2008-10-18	1	14170
64745	4419	1112807	1972-01-28	1972-03-03	1	792
17483	1209	1729720	1991-05-13	1991-05-24	1	7813
53275	3628	1112807	1917-01-29	1917-02-12	1	-19316
68974	4705	1549786	1993-05-06	1994-05-01	1	8886
21967	1496	1112807	1925-11-07	1925-11-21	1	-16112
26415	1783	1551099	1974-06-14	1974-06-14	1	1625
49471	3371	1549786	1994-07-16	1995-07-11	1	9322
17506	1211	920293	2007-11-27	2007-12-11	2	13858
60984	4159	933724	2017-05-31	2017-06-07	1	17324
20946	1430	1759842	1954-04-04	1954-04-18	1	-5737
58024	3957	1768849	1980-07-12	1980-07-26	1	3859
16276	1124	1347450	1999-08-29	1999-08-29	1	10832
64482	4403	1112807	1949-10-14	1949-11-04	1	-7363
20266	1382	1713332	1982-04-20	1982-05-04	1	4506
63197	4317	1759842	1949-12-01	1949-12-08	1	-7329
70329	4804	1521369	1997-02-14	1999-02-04	2	10626
23182	1572	1177480	1987-09-23	1987-10-21	1	6502
60894	4153	1738521	1967-01-02	1967-01-16	1	-1081
17690	1222	1759842	1957-04-21	1957-05-12	1	-4617
15590	1081	1729720	1962-09-14	1962-09-27	1	-2653
64062	4376	1729720	1971-09-27	1971-10-06	1	643
55702	3790	1118084	2001-11-03	2001-11-03	1	11629
23349	1585	738818	1976-03-26	1976-04-09	1	2290
19736	1348	1112807	1932-12-06	1932-12-27	1	-13519
66533	4544	1119510	1942-03-14	1942-03-28	1	-10141
11143	762	1112807	1955-08-08	1955-08-29	1	-5239
60275	4109	1125315	1978-09-19	1978-10-10	1	3204
76470	5228	738818	1949-03-10	1949-03-24	1	-7588
64737	4418	1125315	1996-12-07	1996-12-21	1	9851
24632	1661	1307863	2007-07-12	2007-07-12	1	13706
23480	1593	1112807	1936-10-30	1936-11-13	1	-12102
70424	4811	1713332	1964-10-08	1964-10-28	1	-1891
19167	1314	1759842	1970-06-07	1970-06-21	1	171
64649	4412	1738521	1969-07-20	1969-08-03	1	-151
16630	1145	1759842	1995-04-22	1995-05-06	1	9256
32883	2228	1112807	1952-12-17	1953-01-07	1	-6203
18323	1259	1125315	1994-02-27	1994-03-13	1	8837
28587	1935	19127890	1981-01-15	1982-01-10	1	4392
67116	4580	933724	2008-04-03	2008-04-10	1	13979
27547	1860	1539403	1992-08-10	1992-08-10	1	8257
69535	4745	1115008	1995-10-03	1995-10-31	1	9434
17345	1197	1119510	1980-08-23	1980-09-06	1	3901
46369	3149	1119510	1982-08-05	1982-08-12	1	4606
66002	4509	1125315	1977-01-08	1977-01-22	1	2578
23196	1574	1759842	1972-06-18	1972-12-17	1	1081
65350	4466	1125315	1983-03-04	1983-03-18	1	4824
18267	1257	1713332	1977-09-09	1977-09-16	1	2815
69458	4738	933724	1935-10-09	1935-10-16	1	-12496
17891	1232	1729720	2001-09-28	2001-10-10	1	11605
65684	4487	1125315	2005-10-26	2005-11-16	1	13103
17101	1177	1729720	1978-04-23	1978-05-02	1	3043
17427	1206	1112807	1965-07-17	1965-07-31	1	-1615
67054	4577	1729720	1996-05-15	1996-05-27	1	9643
22004	1498	1119510	1987-10-15	1987-10-28	1	6509
69604	4750	1521369	1983-03-06	1984-02-29	1	5172
18494	1272	1124300	2015-11-24	2015-11-24	1	16763
64746	4419	1125315	2013-03-03	2013-03-24	1	15788
17484	1209	1125315	1984-04-04	1984-07-03	1	5297
53276	3628	1125315	1920-04-30	1920-05-14	1	-18129
68975	4705	1713332	1982-05-27	1982-06-10	1	4543
21968	1496	1112807	1940-04-08	1940-04-29	1	-10839
26416	1783	933724	2017-09-11	2017-09-18	1	17427
49472	3371	19127890	1994-07-16	1996-07-05	2	9682
17507	1211	1119510	1992-01-31	1992-02-07	1	8072
60985	4159	1112807	1972-10-30	1973-01-28	1	1123
20947	1430	920293	1997-12-25	1998-01-01	1	10227
58025	3957	1124300	1998-08-02	1998-08-02	1	10440
16277	1124	1759842	2013-06-29	2013-07-06	1	15892
64483	4403	1118084	1973-08-09	1973-08-09	1	1316
20267	1382	1119510	2019-06-19	2019-06-19	1	18066
63867	4366	1125315	1984-01-04	1984-01-18	1	5130
70330	4804	1551099	1990-09-10	1990-09-10	1	7557
23183	1572	1322184	1997-06-06	1997-06-06	1	10018
60895	4153	738818	2015-03-20	2015-04-03	1	16528
17691	1222	1759842	1986-02-15	1986-03-08	1	5910
15591	1081	1729720	2018-04-25	2018-05-07	1	17658
64063	4376	1115008	1999-06-12	1999-08-18	1	10821
55703	3790	1125315	1966-06-29	1966-07-13	1	-1268
23350	1585	1102527	1959-12-09	1959-12-09	1	-3676
19737	1348	1125315	1942-09-03	1942-09-17	1	-9968
66534	4544	1125315	1949-06-20	1949-07-04	1	-7486
11144	762	1115008	2007-04-28	2007-05-12	1	13645
60276	4109	1125315	1988-09-17	1988-09-24	1	6841
76471	5228	920293	1966-09-18	1966-10-02	2	-1187
64738	4418	1729720	1959-04-20	1959-05-03	1	-3896
24633	1661	1326303	2007-07-12	2007-07-12	1	13706
23481	1593	1112807	1938-02-11	1938-02-25	1	-11633
70425	4811	1713332	2007-10-10	2007-10-17	1	13803
19168	1314	1759842	2013-09-08	2013-09-22	1	15970
66797	4560	1112807	1969-06-23	1969-07-07	1	-178
17009	1173	1112807	1947-06-15	1947-06-29	1	-8222
32884	2228	1124300	1984-08-26	1984-08-26	1	5351
18324	1259	1759842	1954-05-04	1954-05-11	1	-5714
28588	1935	1124300	2009-03-09	2009-03-09	1	14312
67117	4580	1125315	1971-01-21	1971-02-04	1	399
27548	1860	1713332	1995-12-20	1996-01-10	1	9505
69536	4745	1768849	1982-11-12	1982-12-10	1	4726
17346	1197	1125315	1997-11-04	1997-11-11	1	10176
46370	3149	1125315	2001-01-31	2001-02-14	1	11367
66003	4509	1137529	1993-04-13	1993-04-13	1	8503
23197	1574	738818	2017-09-26	2017-10-10	1	17449
65351	4466	1713332	2013-05-13	2013-05-27	1	15852
18268	1257	1713332	2015-02-01	2015-03-29	1	16523
69459	4738	933724	1937-11-11	1937-11-25	1	-11725
18676	1283	1115008	2010-07-26	2010-08-16	1	14837
65685	4487	1125315	2010-02-12	2010-02-12	1	14652
17102	1177	1112807	1964-01-24	1964-02-07	1	-2155
17428	1206	1118084	1999-10-19	1999-10-19	1	10883
67055	4577	1112807	1988-04-04	1988-04-18	1	6682
22005	1498	1124300	2007-04-21	2007-04-21	1	13624
69605	4750	920293	1997-04-30	1997-05-07	1	9988
18495	1272	1125315	2008-10-04	2008-10-18	1	14170
66266	4527	1112807	1964-02-20	1964-03-05	1	-2128
17485	1209	1713332	1980-03-09	1980-03-23	1	3734
53277	3628	1125315	2000-08-16	2000-08-30	1	11199
68976	4705	19127890	1989-05-27	1990-05-22	1	7446
21969	1496	1112807	1949-07-11	1949-08-15	1	-7444
26417	1783	1154343	1961-08-02	1961-08-02	1	-3074
49473	3371	19127890	1997-06-30	1998-06-25	1	10402
17508	1211	1149380	1966-10-29	1966-10-29	1	-1160
60986	4159	1125315	2000-09-01	2000-09-22	1	11222
20948	1430	1102527	1993-12-28	1993-12-28	1	8762
58026	3957	1125315	1978-08-31	1978-09-07	1	3171
16278	1124	1125315	1951-09-20	1951-10-04	1	-6664
64484	4403	1125315	1950-08-12	1950-08-19	1	-7075
20268	1382	1124300	2014-07-07	2014-07-07	1	16258
63868	4366	1125315	1984-09-01	1984-09-15	1	5371
73248	5005	738818	2013-12-08	2013-12-15	1	16054
23184	1572	1332418	1994-06-03	1994-06-03	1	8919
60896	4153	1118084	2001-09-20	2001-09-20	1	11585
17692	1222	738818	1988-12-27	1989-01-03	1	6942
17955	1237	1125315	1979-07-15	1979-07-29	1	3496
64064	4376	1124300	1961-01-07	1961-01-07	1	-3281
55704	3790	1717327	1965-05-21	1965-06-04	1	-1672
23351	1585	1112807	1959-12-09	1959-12-23	1	-3662
19738	1348	1729720	1979-07-22	1979-08-01	1	3499
66535	4544	1125315	1994-02-01	1994-02-01	1	8797
11145	762	1124300	1996-05-19	1996-05-19	1	9635
60277	4109	1713332	1966-10-01	1966-10-15	1	-1174
76472	5228	920293	1972-10-24	1972-10-31	1	1034
66239	4526	1713332	1980-10-10	1980-10-24	1	3949
24634	1661	738818	2003-08-16	2003-08-30	1	12294
23482	1593	1112807	1940-01-06	1940-01-20	1	-10939
70426	4811	738818	2002-10-31	2002-11-14	1	12005
19169	1314	715997	2018-05-11	2018-05-11	1	17662
66798	4560	1125315	2012-10-07	2012-10-21	1	15634
17010	1173	1112807	1949-03-19	1949-04-18	1	-7563
32885	2228	1125315	1958-12-17	1958-12-31	1	-4019
18325	1259	1759842	1962-01-06	1962-01-27	1	-2896
28589	1935	1125315	1965-09-26	1965-10-10	1	-1544
67118	4580	1125315	1972-11-29	1972-12-13	1	1077
27549	1860	914335	1991-12-23	1991-12-23	1	8026
73796	5046	1119510	2009-05-18	2009-06-01	1	14396
20881	1426	1112807	1958-02-27	1958-03-13	1	-4312
46371	3149	1713332	1951-10-24	1951-11-07	1	-6630
66004	4509	1759842	1978-02-07	1978-02-21	1	2973
23198	1574	1112807	1967-04-19	1967-07-18	1	-898
70565	4820	1115008	2016-10-07	2016-11-11	1	17116
18269	1257	1728416	1977-04-05	1977-04-19	1	2665
69460	4738	1124300	1944-12-27	1944-12-27	1	-9136
18677	1283	1125315	1967-01-01	1967-01-15	1	-1082
65686	4487	1322184	2004-10-22	2010-02-12	1	14652
17103	1177	1115008	2000-07-04	2000-07-25	1	11163
17429	1206	1125315	1964-11-06	1964-11-20	1	-1868
67056	4577	1125315	1983-08-08	1983-08-22	1	4981
22006	1498	1759842	1965-10-17	1965-10-31	1	-1523
69606	4750	1129625	1968-04-29	1968-04-29	1	-612
18496	1272	1115008	1994-12-24	1995-01-07	1	9137
66267	4527	1347450	2001-03-02	2001-03-02	1	11383
17486	1209	1738521	1978-07-16	1978-07-30	1	3132
53278	3628	1713332	1924-07-13	1924-07-27	1	-16594
68977	4705	1125315	1973-03-14	1973-03-28	1	1182
21970	1496	1124957	1970-11-23	1970-11-23	1	326
26418	1783	920293	2017-09-11	2017-09-18	1	17427
49474	3371	1115008	1998-06-25	1998-07-16	1	10423
17509	1211	1177480	2012-06-17	2012-07-08	1	15529
60987	4159	920293	2017-05-31	2017-06-07	1	17324
20949	1430	1115008	2010-01-01	2010-01-22	1	14631
58027	3957	1125315	2001-12-10	2001-12-24	1	11680
16279	1124	1125315	1971-10-02	1971-10-16	1	653
64485	4403	1125315	1982-07-12	1982-07-26	1	4589
20269	1382	1125315	1985-06-16	1985-06-30	1	5659
63869	4366	1125315	1999-01-01	1999-02-05	1	10627
73249	5005	1119510	2013-12-08	2013-12-15	1	16054
23185	1572	1361711	1968-03-01	1968-03-01	1	-671
60897	4153	1125315	1967-01-02	1967-01-16	1	-1081
17693	1222	1125315	1969-06-04	1969-06-11	1	-204
17956	1237	738818	1979-07-15	1979-07-29	1	3496
64065	4376	1125315	2008-03-05	2008-03-19	1	13957
55705	3790	1738521	1969-05-23	1969-06-06	1	-209
23352	1585	1125315	1957-03-26	1957-04-02	1	-4657
19739	1348	1759842	1971-04-20	1971-05-11	1	495
66536	4544	1174888	1994-02-01	1994-02-01	1	8797
11146	762	1125315	1959-01-20	1959-02-03	1	-3985
60278	4109	1717327	1965-05-30	1965-06-13	1	-1663
76473	5228	933724	1972-10-24	1972-10-31	1	1034
66240	4526	1713332	2012-05-02	2012-06-06	1	15497
24635	1661	738818	2016-08-03	2016-08-17	1	17030
23483	1593	1112807	1941-08-05	1941-10-04	1	-10316
70427	4811	1112807	1964-07-22	1964-08-05	1	-1975
19170	1314	1125315	1977-07-01	1977-07-15	1	2752
66799	4560	1177480	1975-06-22	1975-07-27	1	2033
17011	1173	1112807	1959-05-17	1959-05-31	1	-3868
32886	2228	1177480	1987-07-06	1987-07-20	1	6409
18326	1259	1112807	1953-01-02	1953-01-16	1	-6194
28590	1935	1125315	1978-03-22	1978-04-21	1	3032
67119	4580	1125315	1984-06-18	1984-06-25	1	5289
27550	1860	1118084	1996-10-02	1996-10-02	1	9771
73797	5046	1125315	2009-05-18	2009-06-01	1	14396
20882	1426	1125315	1954-12-26	1955-01-23	1	-5457
46372	3149	1713332	1993-02-27	1993-03-06	1	8465
66005	4509	1125315	1978-02-02	1978-04-03	1	3014
23199	1574	1125315	2017-09-26	2017-10-10	1	17449
70566	4820	1125315	1982-12-05	1982-12-19	1	4735
18270	1257	738818	1987-06-19	1987-07-03	1	6392
69461	4738	1125315	1922-12-17	1922-12-24	1	-17175
18678	1283	1125315	1993-11-08	1993-11-22	1	8726
65687	4487	1713332	1980-11-09	1980-11-16	1	3972
17104	1177	1125315	1998-06-24	1998-07-08	1	10415
17430	1206	1125315	1991-03-04	1991-03-18	1	7746
67057	4577	1125315	1992-03-24	1992-04-07	1	8132
22007	1498	1125315	2008-09-11	2008-09-18	1	14140
69607	4750	1322184	2019-02-13	2019-02-13	1	17940
18497	1272	1125315	1982-06-30	1982-07-14	1	4577
66268	4527	1125315	1963-08-26	1963-09-02	1	-2313
17487	1209	1768849	1986-06-29	1986-07-13	1	6037
53279	3628	1759842	1998-09-25	1998-10-16	1	10515
68978	4705	1125315	1982-05-27	1982-06-10	1	4543
21971	1496	1112807	1970-11-23	1970-12-14	1	347
26419	1783	1125315	1986-08-04	1986-08-18	1	6073
49475	3371	1177480	1977-10-17	1977-10-31	1	2860
17510	1211	738818	1967-01-07	1967-01-14	1	-1083
60988	4159	933724	2015-02-28	2015-03-07	1	16501
20950	1430	1125315	2000-09-02	2000-09-16	1	11216
58028	3957	1125315	2006-08-22	2006-09-05	1	13396
16280	1124	1177480	1992-10-16	1992-10-30	1	8338
64486	4403	1125315	1987-01-15	1987-01-29	1	6237
20270	1382	1125315	1987-12-25	1988-01-08	1	6581
63870	4366	1125315	2000-09-27	2000-10-11	1	11241
73250	5005	1125315	2008-08-28	2008-09-11	1	14133
23186	1572	1521369	1981-05-31	1983-05-21	2	4888
60898	4153	1125315	1975-09-19	1975-09-26	1	2094
17694	1222	1125315	1988-12-27	1989-01-03	1	6942
17957	1237	1112807	1947-04-23	1947-05-07	1	-8275
64066	4376	1112807	1921-10-24	1921-11-07	1	-17587
55706	3790	1759842	1976-03-24	1976-04-14	1	2295
23353	1585	1177480	1990-04-19	1990-05-03	1	7427
19740	1348	738818	1920-03-15	1920-03-22	1	-18182
66537	4544	738818	1955-09-17	1955-09-24	1	-5213
11147	762	738818	1996-12-31	1997-01-07	1	9868
60279	4109	738818	2015-03-21	2015-04-04	1	16529
76474	5228	1112807	1938-02-04	1938-02-25	1	-11633
66241	4526	1729720	1959-02-07	1959-02-19	1	-3969
24636	1661	1102527	1991-06-13	1991-06-13	1	7833
23484	1593	1112807	1945-03-17	1945-04-14	1	-9028
70428	4811	1118084	1999-10-25	1999-10-25	1	10889
19171	1314	1125315	1998-10-04	1998-10-11	1	10510
66800	4560	1177480	1976-08-20	1976-09-10	1	2444
17012	1173	1125315	1994-08-27	1994-09-03	1	9011
32887	2228	1759842	2015-11-16	2015-11-30	1	16769
18327	1259	1119510	1994-02-27	1994-03-13	1	8837
28591	1935	1125315	1993-01-23	1993-01-30	1	8430
67120	4580	1713332	1986-07-20	1986-08-10	1	6065
27551	1860	1119510	1971-04-24	1971-05-08	1	492
73798	5046	1729720	1968-12-20	1968-12-29	1	-368
20883	1426	1125315	1978-11-22	1978-12-06	1	3261
46373	3149	1759842	1993-02-27	1993-03-06	1	8465
66006	4509	1149380	1993-04-13	1993-04-13	1	8503
23200	1574	1713332	1972-06-18	1972-12-17	1	1081
70567	4820	1713332	1981-05-23	1981-06-13	1	4181
18271	1257	1322184	2016-11-12	2016-11-12	1	17117
71026	4852	738818	1977-07-25	1977-08-08	1	2776
18679	1283	1503184	1976-02-25	1977-02-19	1	2606
65688	4487	1713332	1990-01-26	1990-02-09	1	7344
17105	1177	1521369	1980-04-17	1982-04-07	2	4479
17431	1206	1125315	1979-11-19	1979-11-26	1	3616
67058	4577	1768849	1985-06-06	1985-06-20	1	5649
22008	1498	738818	1987-10-15	1987-10-28	1	6509
69608	4750	1347450	2019-02-13	2019-02-13	1	17940
18498	1272	1125315	2002-01-07	2002-01-21	1	11708
66269	4527	1125315	1980-05-06	1980-05-20	1	3792
17848	1231	738818	1960-07-15	1960-07-29	1	-3443
53280	3628	1112807	1915-10-23	1915-11-06	1	-19780
68979	4705	1125315	1984-11-28	1984-12-05	1	5452
21972	1496	1125315	1989-06-07	1989-07-12	1	7132
26420	1783	1129625	1961-08-16	1961-08-16	1	-3060
49476	3371	1177480	1981-04-21	1981-05-05	1	4142
17511	1211	933724	2007-11-27	2007-12-11	1	13858
60989	4159	1125315	1967-04-02	1967-04-09	1	-998
20951	1430	1713332	1954-04-04	1954-04-18	1	-5737
58029	3957	1137529	1998-12-24	1998-12-24	1	10584
16281	1124	1322184	1999-08-29	1999-08-29	1	10832
64487	4403	1125315	1989-09-15	1989-10-20	1	7232
20271	1382	1125315	2002-08-02	2002-08-09	1	11908
63871	4366	1125315	2003-09-26	2003-10-24	1	12349
73251	5005	1125315	2010-03-24	2010-03-24	1	14692
23187	1572	1539403	1991-05-31	1991-05-31	1	7820
60899	4153	1125315	2015-03-20	2015-04-03	1	16528
17695	1222	1713332	1957-04-21	1957-05-12	1	-4617
17958	1237	1118084	1983-10-06	1983-10-06	1	5026
64067	4376	1125315	1956-10-20	1956-11-24	1	-4786
55707	3790	1125315	1965-05-21	1965-06-04	1	-1672
23354	1585	1713332	1963-10-21	1963-11-25	1	-2229
19741	1348	1112807	1913-01-20	1913-02-03	1	-20786
66538	4544	1112807	1943-09-03	1943-09-17	1	-9603
11148	762	1125315	1996-12-31	1997-01-07	1	9868
60280	4109	920293	2004-12-24	2004-12-31	1	12783
76475	5228	1112807	1939-10-27	1939-11-10	1	-11010
66242	4526	1759842	1980-10-10	1980-10-24	1	3949
24637	1661	1112807	1991-06-13	1991-08-12	1	7893
23485	1593	1112807	1961-12-30	1962-01-13	1	-2910
70429	4811	1119510	2002-10-31	2002-11-14	1	12005
19172	1314	1713332	1952-12-04	1952-12-18	1	-6223
66801	4560	1759842	1979-10-04	1979-10-18	1	3577
17013	1173	1729720	1951-03-11	1951-03-22	1	-6860
32888	2228	920293	2007-02-27	2007-03-06	1	13578
18328	1259	1125315	1991-02-15	1991-03-01	1	7729
28592	1935	1503184	1981-01-15	1982-01-10	1	4392
67121	4580	1118084	2004-06-09	2004-06-09	1	12578
27552	1860	1125315	1995-09-30	1995-10-07	1	9410
73799	5046	738818	2009-05-18	2009-06-01	1	14396
20884	1426	1177480	2009-09-27	2009-10-18	1	14535
46374	3149	1118084	1989-10-31	1989-10-31	1	7243
66007	4509	1738521	1977-01-08	1977-01-22	1	2578
23201	1574	1729720	1970-03-25	1970-04-07	1	96
70568	4820	1112807	1956-11-20	1956-12-04	1	-4776
18272	1257	1332418	2016-11-12	2016-11-12	1	17117
71027	4852	920293	1993-11-30	1993-12-07	1	8741
18680	1283	1746114	1972-04-22	1972-04-22	1	842
65689	4487	1729720	1985-03-11	1985-03-18	1	5555
17106	1177	1713332	1983-05-18	1983-06-08	1	4906
17432	1206	1125315	1990-01-24	1990-02-07	1	7342
67059	4577	1125315	1986-01-13	1986-01-27	1	5870
22009	1498	1125315	1987-10-15	1987-10-28	1	6509
69609	4750	1503184	1983-03-06	1984-02-29	1	5172
18499	1272	1309944	1991-08-30	1991-08-30	1	7911
66270	4527	1125315	2011-09-02	2011-12-01	1	15309
17849	1231	1119510	1982-01-07	1982-01-14	1	4396
53281	3628	1112807	1973-04-26	1973-05-31	1	1246
68980	4705	1125315	2007-04-13	2007-05-18	1	13651
21973	1496	1729720	1933-10-07	1933-10-17	1	-13225
27710	1874	1118084	2014-12-20	2014-12-20	1	16424
49477	3371	1177480	1982-12-06	1983-01-05	1	4752
17512	1211	1112807	1969-03-25	1969-04-08	1	-268
60990	4159	1125315	1972-10-30	1972-10-30	1	1033
20952	1430	1112807	1972-02-24	1972-03-09	1	798
58030	3957	1713332	1966-10-01	1966-10-08	1	-1181
16282	1124	1119510	1991-05-11	1991-05-25	1	7814
64488	4403	1149380	1990-05-19	1990-05-19	1	7443
20272	1382	1729720	1992-12-05	1992-12-15	1	8384
63872	4366	1713332	1998-10-20	1998-11-03	1	10533
73252	5005	1125315	2013-12-08	2013-12-15	1	16054
23188	1572	1713332	1974-11-19	1974-12-10	1	1804
60900	4153	1717327	1973-05-14	1973-05-28	1	1243
17696	1222	1713332	2013-09-06	2013-09-20	1	15968
17959	1237	1125315	1971-01-11	1971-01-18	1	382
64068	4376	1125315	1989-05-05	1989-08-03	1	7154
55708	3790	1125315	1981-03-29	1981-04-05	1	4112
23355	1585	1759842	1942-05-28	1942-06-04	1	-10073
19742	1348	1119510	1920-03-15	1920-03-22	1	-18182
66539	4544	738818	1942-03-14	1942-03-28	1	-10141
11149	762	1125315	2017-01-23	2017-01-30	1	17196
60281	4109	1112807	1967-02-01	1967-02-15	1	-1051
76476	5228	1112807	1941-01-01	1941-04-01	1	-10502
66243	4526	1112807	1962-08-19	1962-09-02	1	-2678
24638	1661	1118084	1995-02-05	1995-02-05	1	9166
23486	1593	1125315	1957-02-24	1957-03-26	1	-4664
70430	4811	1125315	1963-12-07	1963-12-21	1	-2203
19173	1314	1713332	1970-06-07	1970-06-21	1	171
66802	4560	1759842	2000-02-26	2000-03-04	1	11020
17014	1173	1125315	1989-08-06	1989-08-20	1	7171
32889	2228	1115008	2016-01-17	2016-02-07	1	16838
18329	1259	1713332	1968-10-28	1968-11-04	1	-423
28593	1935	1713332	1973-10-20	1973-11-03	1	1402
67122	4580	1125315	2002-01-23	2002-02-06	1	11724
27553	1860	1361711	1973-12-03	1985-11-11	1	5793
73800	5046	1112807	1961-12-10	1961-12-24	1	-2930
20885	1426	1125315	1984-07-19	1984-08-09	1	5334
46375	3149	738818	1982-08-05	1982-08-12	1	4606
66008	4509	1118084	2006-11-07	2006-11-07	1	13459
23202	1574	1119510	2017-09-26	2017-10-10	1	17449
70569	4820	1119510	1982-12-05	1982-12-19	1	4735
18273	1257	738818	1980-10-20	1980-10-27	1	3952
71028	4852	1112807	1951-03-11	1951-03-25	1	-6857
18681	1283	1759842	2000-09-03	2000-09-10	1	11210
65690	4487	1112807	1965-05-03	1965-05-24	1	-1683
17107	1177	1713332	2008-01-30	2008-02-20	1	13929
17433	1206	1125315	1993-11-12	1993-11-26	1	8730
67060	4577	1125315	2002-03-31	2002-06-06	2	11844
22010	1498	1125315	2015-04-17	2015-05-01	1	16556
69610	4750	1125315	1964-04-04	1964-04-18	1	-2084
18500	1272	1343916	1991-08-30	1991-08-30	1	7911
66271	4527	1125315	2012-03-21	2012-04-04	1	15434
17850	1231	1125315	1960-07-15	1960-07-29	1	-3443
53282	3628	1119510	1931-02-06	1931-02-20	1	-14195
68981	4705	1515774	1993-05-06	1994-05-01	1	8886
21974	1496	1124300	1957-12-25	1957-12-25	1	-4390
27711	1874	1713332	2010-10-28	2010-11-04	1	14917
49478	3371	1177480	1996-08-13	1996-09-03	1	9742
17513	1211	1118084	2004-12-31	2004-12-31	1	12783
60991	4159	19127890	1976-12-18	1977-12-13	1	2903
20953	1430	1125315	1946-02-11	1946-02-25	1	-8711
58031	3957	1713332	2010-05-11	2010-05-25	1	14754
16283	1124	1713332	2013-06-29	2013-07-06	1	15892
64489	4403	1759842	1955-05-09	1955-05-23	1	-5337
20273	1382	1115008	2019-05-17	2019-06-07	1	18054
63873	4366	1713332	2018-10-06	2018-10-13	1	17817
73253	5005	1521369	1990-06-12	1991-06-07	1	7827
23189	1572	1125315	1974-10-31	1974-12-30	2	1824
60901	4153	1759842	1968-07-01	1968-07-22	1	-528
17697	1222	1729720	2017-08-10	2017-08-22	1	17400
17960	1237	1137529	1991-04-28	1991-04-28	1	7787
64069	4376	1137529	1976-07-06	1976-07-06	1	2378
55709	3790	1713332	1976-03-24	1976-04-14	1	2295
23356	1585	1778162	1987-04-12	1987-04-26	1	6324
19743	1348	1125315	1920-03-15	1920-03-22	1	-18182
66540	4544	920293	1961-11-21	1961-11-28	1	-2956
11150	762	1557272	2014-09-10	2014-09-10	1	16323
60282	4109	1125315	1991-12-31	1992-02-04	1	8069
76477	5228	1112807	1972-03-19	1972-04-23	1	843
66244	4526	1729720	1954-12-17	1954-12-28	1	-5483
24639	1661	1119510	1979-01-05	1979-01-12	1	3298
23487	1593	1713332	1945-11-17	1945-12-01	1	-8797
70431	4811	1125315	1979-01-27	1979-02-10	1	3327
19174	1314	1759842	1953-09-22	1953-10-13	1	-5924
66803	4560	1118084	2007-02-04	2007-02-04	1	13548
17015	1173	1125315	1993-02-01	1993-02-22	1	8453
32890	2228	1119510	1958-12-17	1958-12-31	1	-4019
19932	1358	1119510	1969-04-01	1969-04-15	1	-261
30187	2041	1112807	1966-01-15	1966-02-05	1	-1426
67123	4580	1177480	1975-07-12	1975-08-16	1	2053
27554	1860	1717327	1963-03-24	1963-04-07	1	-2461
73801	5046	1118084	1995-09-22	1995-09-22	1	9395
20886	1426	1177480	2007-10-08	2008-01-06	1	13884
46376	3149	1112807	1958-02-11	1958-03-04	1	-4321
66009	4509	1125315	1970-04-16	1970-04-23	1	112
23203	1574	1125315	2002-08-08	2002-08-15	1	11914
70570	4820	1125315	2003-07-17	2003-07-31	1	12264
18274	1257	1125315	1980-10-20	1980-10-27	1	3952
71029	4852	1112807	1952-01-07	1952-01-21	1	-6555
18682	1283	967823	1972-04-22	1972-04-28	1	848
65691	4487	1112807	1968-06-07	1968-06-28	1	-552
17108	1177	1738521	1968-10-12	1968-10-26	1	-432
17434	1206	1150836	1988-02-28	1988-02-28	1	6632
67061	4577	1177480	1985-06-06	1985-06-20	1	5649
22011	1498	1713332	2000-06-12	2000-07-03	1	11141
69611	4750	1728416	1964-04-04	1964-04-18	1	-2084
18501	1272	1729720	1990-12-16	1990-12-23	1	7661
66272	4527	1322184	2001-03-02	2001-03-02	1	11383
17851	1231	1125315	1986-10-05	1986-10-26	1	6142
53283	3628	1124300	1954-03-07	1954-03-07	1	-5779
68982	4705	1521369	1989-05-27	1990-05-22	1	7446
21975	1496	1125315	1924-06-28	1924-07-05	1	-16616
27712	1874	19127890	1989-10-27	1990-10-22	1	7599
49479	3371	1500211	2005-05-19	2006-05-14	1	13282
17514	1211	1125315	1967-01-07	1967-01-14	1	-1083
60992	4159	920293	2015-02-28	2015-03-07	1	16501
20954	1430	1125315	1993-12-28	1994-01-25	1	8790
58549	3993	1125315	1976-08-11	1976-08-25	1	2428
19413	1325	738818	2009-10-29	2009-11-12	1	14560
64490	4403	1759842	1980-03-26	1980-04-02	1	3744
20274	1382	1125315	1979-07-16	1979-07-30	1	3497
63874	4366	1729720	1983-09-25	1983-10-02	1	5022
73254	5005	1174888	2010-03-24	2010-03-24	1	14692
23190	1572	1125315	2016-07-27	2016-08-10	1	17023
60902	4153	1759842	2005-01-14	2005-01-28	1	12811
17698	1222	1759842	1954-11-09	1954-11-16	1	-5525
17961	1237	1177480	1981-09-05	1981-09-19	1	4279
64070	4376	1307863	1981-07-14	1981-07-14	1	4212
55710	3790	1713332	2019-01-31	2019-03-07	1	17962
23357	1585	738818	1959-10-20	1959-11-03	1	-3712
19744	1348	1125315	1988-10-04	1988-10-18	1	6865
66541	4544	933724	1961-11-21	1961-11-28	1	-2956
11151	762	738818	1980-04-20	1980-04-27	1	3769
60283	4109	1154343	1967-12-08	1967-12-08	1	-755
76478	5228	1125315	1949-03-10	1949-03-24	1	-7588
66245	4526	1729720	1997-07-29	1997-08-10	1	10083
24640	1661	1125315	1963-02-19	1963-02-26	1	-2501
23488	1593	1717327	1976-02-04	1976-02-18	1	2239
70432	4811	1125315	1994-03-13	1994-04-18	1	8873
19175	1314	1759842	1996-06-22	1996-10-12	1	9781
66804	4560	1124957	1983-07-06	1983-07-06	1	4934
17016	1173	1177480	1982-09-22	1982-10-06	1	4661
32891	2228	1125315	1962-02-19	1962-03-19	1	-2845
19933	1358	1125315	1987-03-04	1987-03-18	1	6285
30188	2041	1112807	1969-11-01	1969-11-15	1	-47
67124	4580	1728416	1971-07-25	1971-08-08	1	584
27555	1860	738818	1971-04-24	1971-05-08	1	492
73802	5046	1112807	1971-09-03	1971-10-08	1	645
20887	1426	1115008	2005-10-18	2005-11-17	1	13104
46377	3149	1125315	1965-10-23	1965-12-29	2	-1464
66010	4509	1125315	1991-11-21	1991-12-05	1	8008
23204	1574	1713332	2014-01-20	2014-01-27	1	16097
70571	4820	1717327	1963-06-15	1963-07-13	1	-2364
18275	1257	1361711	2016-11-12	2016-11-12	1	17117
71030	4852	1112807	1967-03-26	1967-05-26	1	-951
18683	1283	1102527	1971-06-23	1971-06-23	1	538
65692	4487	1125315	1984-11-17	1984-12-01	1	5448
17109	1177	1759842	1983-05-18	1983-06-08	1	4906
17435	1206	1728416	1964-11-06	1964-11-20	1	-1868
67062	4577	1713332	1983-08-08	1983-08-22	1	4981
22012	1498	1759842	2000-06-12	2000-07-03	1	11141
69612	4750	933724	1997-04-30	1997-05-07	1	9988
18502	1272	1729720	2018-12-14	2018-12-27	1	17892
66273	4527	1521369	1977-05-22	1978-05-17	1	3058
17852	1231	1729720	1955-04-11	1955-04-20	1	-5370
53284	3628	1125315	1926-09-11	1926-09-25	1	-15804
68983	4705	1713332	1990-03-17	1990-04-07	1	7401
21976	1496	1125315	1977-03-31	1977-04-14	1	2660
27713	1874	1125315	2000-11-27	2000-12-11	1	11302
49480	3371	1503184	1995-07-11	1996-07-05	1	9682
17515	1211	1125315	2004-04-02	2004-04-16	1	12524
60993	4159	920293	2016-04-17	2016-04-24	1	16915
20955	1430	1557272	2004-10-12	2004-10-12	1	12703
58550	3993	1125315	2013-09-05	2013-09-12	1	15960
19414	1325	1118084	2000-12-19	2000-12-19	1	11310
64491	4403	1759842	1996-11-20	1996-12-04	1	9834
20275	1382	1125315	1982-04-20	1982-05-04	1	4506
63875	4366	1759842	2018-10-06	2018-10-13	1	17817
73255	5005	1177480	2004-08-31	2004-09-14	1	12675
23191	1572	1503184	1981-05-31	1983-05-21	2	4888
60903	4153	1112807	1981-01-18	1981-02-08	1	4056
20219	1379	1124300	1998-11-20	1998-11-20	1	10550
17962	1237	1112807	1950-02-20	1950-04-21	1	-7195
64071	4376	1713332	1948-02-12	1948-02-19	1	-7987
55711	3790	1729720	2001-02-05	2001-02-18	1	11371
23358	1585	1112807	1969-09-15	1969-10-06	1	-87
19745	1348	1713332	1971-04-20	1971-05-11	1	495
66542	4544	1112807	1944-09-18	1944-10-02	1	-9222
11152	762	1119510	1996-12-31	1997-01-07	1	9868
60284	4109	1713332	2013-08-05	2013-08-19	1	15936
76479	5228	1174888	2013-08-30	2013-08-30	1	15947
66246	4526	1729720	2006-06-26	2006-07-09	1	13338
24641	1661	1125315	1981-06-09	1981-07-14	1	4212
23489	1593	1729720	1946-11-03	1946-11-15	1	-8448
70433	4811	1125315	2002-10-31	2002-11-14	1	12005
19176	1314	1102527	1946-07-22	1946-07-22	1	-8564
66805	4560	1125315	1983-07-06	1983-08-05	2	4964
17017	1173	1713332	1991-08-16	1991-08-30	1	7911
32892	2228	1557272	2007-04-21	2007-04-21	1	13624
19934	1358	1729720	1976-07-27	1976-08-05	1	2408
30189	2041	1125315	1972-07-14	1972-07-21	1	932
67125	4580	1759842	1986-07-20	1986-08-10	1	6065
27556	1860	914335	1997-07-07	1997-07-07	1	10049
73803	5046	1115008	2000-05-06	2000-05-20	1	11097
20888	1426	1118084	1986-09-19	1986-09-19	1	6105
46378	3149	1125315	1982-08-05	1982-08-12	1	4606
66011	4509	1125315	2005-02-19	2005-03-05	1	12847
23205	1574	1759842	2014-01-20	2014-01-27	1	16097
70572	4820	1112807	1961-06-11	1961-06-25	1	-3112
18276	1257	1539403	2016-11-12	2016-11-12	1	17117
71031	4852	1125315	1975-11-23	1975-11-30	1	2159
18684	1283	1112807	1960-12-05	1960-12-19	1	-3300
65693	4487	1174888	2010-02-12	2010-02-12	1	14652
17110	1177	1759842	2008-01-30	2008-02-20	1	13929
17436	1206	1738521	1969-05-01	1969-05-15	1	-231
67063	4577	1124300	2019-03-17	2019-03-17	1	17972
26115	1766	1125315	1957-05-29	1957-06-12	1	-4586
69613	4750	1118084	2000-05-15	2000-05-15	1	11092
18503	1272	1778162	1985-04-06	1985-04-20	1	5588
66274	4527	1717327	1964-02-20	1964-03-05	1	-2128
17853	1231	1759842	1968-08-05	1968-08-19	1	-500
53285	3628	1125315	1967-07-22	1967-08-26	1	-859
68984	4705	1759842	1990-03-17	1990-04-07	1	7401
21977	1496	1713332	1988-08-06	1988-08-27	1	6813
27714	1874	1503184	1989-10-27	1990-10-22	1	7599
49481	3371	1503184	1997-06-30	1998-06-25	1	10402
17516	1211	1177480	2009-07-19	2009-08-02	1	14458
60994	4159	933724	2016-04-17	2016-04-24	1	16915
20956	1430	1759842	1958-02-23	1958-03-16	1	-4309
58551	3993	1713332	1987-12-09	1987-12-23	1	6565
19415	1325	1119510	1966-01-03	1966-01-10	1	-1452
64492	4403	1112807	1962-06-29	1962-07-13	1	-2729
20276	1382	1768849	1979-07-16	1979-07-30	1	3497
63876	4366	1125315	1983-01-25	1983-02-08	1	4786
73256	5005	1713332	2003-05-28	2003-06-11	1	12214
23192	1572	1759842	1974-11-19	1974-12-10	1	1804
60904	4153	1713332	2005-01-14	2005-01-28	1	12811
20220	1379	1149380	2000-02-19	2000-02-19	1	11006
17963	1237	1125315	1951-08-01	1951-08-15	1	-6714
64072	4376	1713332	1973-03-09	1973-03-23	1	1177
55712	3790	1759842	2019-01-31	2019-03-07	1	17962
23359	1585	1125315	1939-05-08	1939-05-15	1	-11189
19746	1348	1759842	2001-08-09	2001-08-30	1	11564
66543	4544	1119510	1955-09-17	1955-09-24	1	-5213
11153	762	1125315	1980-04-20	1980-04-27	1	3769
60285	4109	1759842	1966-10-01	1966-10-15	1	-1174
76480	5228	1177480	2013-08-30	2013-09-29	1	15977
66247	4526	738818	1968-04-03	1968-04-17	1	-624
24642	1661	1125315	1994-02-11	1994-02-25	1	8821
23490	1593	1112807	1970-09-03	1970-09-17	1	259
70434	4811	1713332	1968-02-07	1968-02-14	1	-687
19177	1314	1112807	1980-05-22	1980-06-12	1	3815
66806	4560	1713332	1979-10-04	1979-10-18	1	3577
17018	1173	1713332	1994-10-19	1994-11-02	1	9071
32893	2228	1713332	1996-01-21	1996-02-04	1	9530
19935	1358	1759842	1957-08-10	1957-10-05	1	-4471
30190	2041	1125315	1993-04-12	1993-05-03	1	8523
67126	4580	1112807	1970-12-05	1970-12-19	1	352
27557	1860	1125315	1963-03-24	1963-04-07	1	-2461
73804	5046	1125315	1992-08-18	1992-09-15	1	8293
20889	1426	1125315	1954-04-30	1954-05-14	1	-5711
46379	3149	1729720	1968-10-17	1968-10-30	1	-428
66012	4509	1713332	1978-02-07	1978-02-21	1	2973
23206	1574	1112807	1972-05-22	1972-06-19	1	900
70573	4820	1124300	1995-10-07	1995-10-07	1	9410
18277	1257	1729720	1976-02-28	1976-03-09	1	2259
71032	4852	1125315	1985-03-19	1985-04-16	1	5584
18685	1283	1124300	1998-06-24	1998-06-24	1	10401
65694	4487	1545958	2010-02-12	2010-02-12	1	14652
17111	1177	1112807	1966-04-13	1966-05-04	1	-1338
17437	1206	1125315	1998-07-19	1998-08-29	2	10454
67064	4577	1713332	1986-01-13	1986-01-27	1	5870
26116	1766	1125315	1994-05-13	1994-05-27	1	8912
69614	4750	19127890	1979-03-27	1980-03-21	1	3732
18504	1272	738818	1986-11-08	1986-11-22	1	6169
66275	4527	1124300	2002-01-21	2002-01-21	1	11708
17854	1231	920293	1965-02-13	1965-02-27	2	-1769
53286	3628	1125315	1985-09-25	1985-10-25	1	5776
68985	4705	1112807	1976-08-23	1976-09-06	1	2440
21978	1496	1729720	1952-08-04	1952-08-17	1	-6346
27715	1874	1549786	1992-10-11	1993-10-06	1	8679
49482	3371	1503184	2001-06-09	2002-06-04	1	11842
17517	1211	1192710	1967-11-12	1967-11-12	1	-781
60995	4159	1115008	2012-01-14	2012-02-11	1	15381
20957	1430	1125315	1955-05-24	1955-08-22	1	-5246
58552	3993	1729720	1949-05-26	1949-06-04	1	-7516
19416	1325	1119510	1970-11-18	1970-12-02	1	335
64493	4403	1115008	1999-05-01	1999-05-29	1	10740
20277	1382	738818	2019-06-19	2019-06-19	1	18066
63877	4366	1149380	1984-05-11	2001-04-03	1	11415
73257	5005	1759842	2003-05-28	2003-06-11	1	12214
23927	1618	1118084	2013-05-21	2013-05-21	1	15846
60905	4153	1115008	2005-05-10	2005-07-09	1	12973
20221	1379	1309944	1987-09-05	1987-09-05	1	6456
17964	1237	1125315	1971-02-18	1971-02-25	1	420
64073	4376	1713332	2010-07-02	2010-07-23	1	14813
56768	3869	738818	1941-06-30	1941-07-14	1	-10398
23360	1585	1125315	1959-10-20	1959-11-03	1	-3712
19747	1348	1125315	1931-07-07	1931-07-14	1	-14051
66544	4544	1125315	1942-03-14	1942-03-28	1	-10141
11154	762	1713332	1962-06-06	1962-06-27	1	-2745
60286	4109	933724	2004-12-24	2004-12-31	1	12783
76481	5228	1713332	1956-07-23	1956-08-06	1	-4896
66248	4526	1125315	1962-10-23	1962-11-06	1	-2613
24643	1661	1125315	2016-08-03	2016-08-17	1	17030
23491	1593	1119510	1976-08-03	1976-08-10	1	2413
70435	4811	1713332	2003-07-07	2003-07-28	1	12261
19178	1314	1125315	1955-04-06	1955-05-04	1	-5356
66807	4560	1713332	2000-02-26	2000-03-04	1	11020
17019	1173	1728416	1946-06-03	1946-06-17	1	-8599
32894	2228	1728416	1952-12-17	1953-01-07	1	-6203
19936	1358	1125315	1964-05-27	1964-06-10	1	-2031
30191	2041	1125315	1994-04-28	1994-06-02	1	8918
67127	4580	1125315	1971-07-25	1971-08-08	1	584
27558	1860	1125315	1971-04-24	1971-05-08	1	492
73805	5046	1728416	1961-12-10	1961-12-24	1	-2930
20890	1426	1713332	1975-07-27	1975-08-17	1	2054
46380	3149	1112807	1961-12-13	1962-01-12	1	-2911
66013	4509	1713332	2003-11-04	2003-11-18	1	12374
23207	1574	1729720	1965-11-26	1965-12-06	1	-1487
70574	4820	1729720	1961-05-30	1961-06-06	1	-3131
18278	1257	1759842	2015-02-01	2015-03-29	1	16523
71033	4852	1125315	1995-01-24	1995-02-07	1	9168
18686	1283	1125315	1971-06-23	1971-08-22	1	598
65695	4487	1112807	1950-08-29	1950-09-12	1	-7051
17112	1177	1717327	1964-01-24	1964-02-07	1	-2155
17438	1206	1125315	2001-02-12	2001-02-19	1	11372
67065	4577	1713332	1987-12-21	1988-01-04	1	6577
26117	1766	1149380	1984-01-10	1984-01-10	1	5122
69615	4750	19127890	1983-03-06	1984-02-29	1	5172
18505	1272	914335	1991-08-30	1991-08-30	1	7911
66276	4527	1177480	1986-05-25	1986-06-15	1	6009
17855	1231	933724	1965-02-13	1965-02-27	1	-1769
53287	3628	1125315	2006-08-19	2006-08-19	1	13379
68986	4705	1125315	1979-05-22	1979-05-29	1	3435
21979	1496	1729720	1980-06-12	1980-06-24	1	3827
27716	1874	1125315	1987-06-22	1987-07-06	1	6395
49483	3371	1521369	2001-06-09	2002-06-04	1	11842
17518	1211	1729720	1978-01-22	1978-01-29	1	2950
60996	4159	1118084	1991-10-06	1991-10-06	1	7948
20958	1430	1125315	1971-12-16	1971-12-23	1	721
58553	3993	1738521	1974-07-03	1974-07-31	1	1672
19417	1325	1125315	2009-10-29	2009-11-12	1	14560
64494	4403	1125315	1986-04-20	1986-04-27	1	5960
20278	1382	1125315	2019-06-19	2019-06-19	1	18066
63878	4366	1177480	1998-10-20	1998-11-03	1	10533
73258	5005	1118084	2008-01-09	2008-01-09	1	13887
23928	1618	1174888	2006-04-12	2006-04-12	1	13250
60906	4153	1124957	1999-11-08	1999-11-08	1	10903
20222	1379	1343916	1987-09-05	1987-09-05	1	6456
17965	1237	1728416	1947-04-23	1947-05-07	1	-8275
64074	4376	1728416	1956-10-20	1956-11-24	1	-4786
56769	3869	1112807	1909-05-17	1909-05-31	1	-22130
23361	1585	1125315	1976-03-26	1976-04-09	1	2290
19748	1348	1125315	1947-07-10	1947-07-24	1	-8197
66545	4544	1125315	1953-04-21	1953-04-28	1	-6092
11155	762	1119510	1980-04-20	1980-04-27	1	3769
60287	4109	975125	2018-08-29	2018-09-19	1	17793
47711	3238	1115008	2006-03-11	2006-04-01	1	13239
66249	4526	1125315	1968-04-03	1968-04-17	1	-624
24644	1661	1310149	2007-07-12	2007-07-12	1	13706
23492	1593	1729720	1935-06-12	1935-06-21	1	-12613
70436	4811	1713332	2012-07-01	2012-07-08	1	15529
19179	1314	1125315	2012-04-22	2012-05-06	1	15466
67487	4608	1177480	2006-12-04	2007-01-01	1	13514
17020	1173	1759842	1991-08-16	1991-08-30	1	7911
32895	2228	1759842	1996-01-21	1996-02-04	1	9530
19937	1358	1125315	1965-02-20	1965-03-20	2	-1748
30192	2041	1177480	1974-09-21	1974-10-19	1	1752
67128	4580	1177480	1993-10-10	1993-10-24	1	8697
27559	1860	1728416	1960-12-15	1960-12-29	1	-3290
73806	5046	1115008	2012-11-12	2012-12-03	1	15677
20891	1426	1728416	1954-04-30	1954-05-14	1	-5711
46381	3149	1125315	1992-05-22	1992-06-05	1	8191
66014	4509	1759842	2003-11-04	2003-11-18	1	12374
25417	1724	1102527	1986-05-27	1986-05-27	1	5990
70575	4820	1729720	1989-01-25	1989-02-07	1	6977
18279	1257	1119510	1987-06-19	1987-07-03	1	6392
71034	4852	1728416	1951-03-11	1951-03-25	1	-6857
18687	1283	1125315	1984-12-31	1985-01-14	1	5492
65696	4487	1112807	1953-09-12	1953-12-11	1	-5865
17113	1177	1729720	1978-01-11	1978-01-20	1	2941
17439	1206	1125315	2011-03-11	2011-03-18	1	15051
67066	4577	1759842	1987-12-21	1988-01-04	1	6577
26118	1766	1713332	2001-02-08	2001-02-22	1	11375
71805	4907	738818	1949-09-16	1949-09-30	1	-7398
18506	1272	1129625	1980-05-24	1980-05-24	1	3796
66277	4527	19127890	1977-05-22	1978-05-17	1	3058
17856	1231	1112807	1972-03-18	1972-04-22	1	842
53288	3628	1361711	2002-04-13	2006-08-19	1	13379
68987	4705	1503184	1989-05-27	1990-05-22	1	7446
21980	1496	1738521	1970-11-23	1970-12-14	1	347
27717	1874	1713332	1978-12-20	1979-01-17	1	3303
49484	3371	1521369	2003-05-30	2005-05-19	2	12922
17817	1229	1118084	1990-09-18	1990-09-18	1	7565
60997	4159	1125315	1991-08-22	1991-09-19	1	7931
20959	1430	1125315	2017-11-18	2017-12-02	1	17502
58554	3993	738818	1991-06-24	1991-07-01	1	7851
19418	1325	1729720	2018-05-12	2018-05-21	1	17672
64495	4403	1137529	1990-05-19	1990-05-19	1	7443
20279	1382	1177480	1994-08-26	1994-10-25	1	9063
63879	4366	1549786	2000-04-05	2002-03-26	2	11772
73259	5005	1515774	1991-06-07	1993-05-27	2	8547
23929	1618	1515774	1990-04-27	1992-04-16	2	8141
60907	4153	1125315	1973-05-14	1973-05-28	1	1243
20223	1379	19127890	1977-01-24	1978-01-19	1	2940
17966	1237	1112807	1948-05-17	1948-05-31	1	-7885
64075	4376	1759842	1953-02-28	1953-03-14	1	-6137
56770	3869	1124300	1943-07-03	1943-07-03	1	-9679
23362	1585	1759842	2015-05-14	2015-06-04	1	16590
19749	1348	1177480	1977-12-01	1977-12-22	1	2912
66546	4544	1539403	1991-11-05	1991-11-05	1	7978
11156	762	1759842	1962-06-06	1962-06-27	1	-2745
60288	4109	1118084	2002-02-10	2002-02-10	1	11728
47712	3238	1125315	1972-11-27	1972-12-27	1	1091
66250	4526	1125315	1987-08-12	1987-11-10	2	6522
24645	1661	1729720	1977-01-07	1977-01-18	1	2574
23493	1593	1759842	1945-11-17	1945-12-01	1	-8797
70437	4811	1759842	2003-07-07	2003-07-28	1	12261
19180	1314	1361711	2012-01-14	2012-01-14	1	15353
67488	4608	1713332	2006-12-04	2007-01-01	1	13514
17021	1173	1759842	1994-10-19	1994-11-02	1	9071
33100	2242	1119510	1976-02-23	1976-03-08	1	2258
19938	1358	1125315	1969-04-01	1969-04-15	1	-261
30193	2041	1322184	1998-09-01	1998-09-01	1	10470
67129	4580	1503184	1983-02-10	1984-02-05	1	5148
27560	1860	1112807	1960-12-15	1960-12-29	1	-3290
73807	5046	1125315	1959-08-07	1959-08-21	1	-3786
20892	1426	1759842	1963-11-14	1963-11-21	1	-2233
46382	3149	1125315	2012-11-22	2012-12-22	1	15696
67178	4587	1112807	1936-02-07	1936-02-21	1	-12368
25418	1724	1125315	1954-06-18	1954-07-16	1	-5648
70576	4820	1759842	1981-05-23	1981-06-13	1	4181
18280	1257	1125315	1973-12-24	1974-01-07	1	1467
71035	4852	1728416	1952-01-07	1952-01-21	1	-6555
18688	1283	19127890	1976-02-25	1977-02-19	1	2606
65697	4487	1112807	1962-07-27	1962-08-17	1	-2694
17114	1177	19127890	1980-04-17	1982-04-07	2	4479
17440	1206	1343916	1988-02-28	1988-02-28	1	6632
68231	4657	1119510	1993-05-05	1993-05-19	1	8539
26119	1766	1728416	1957-05-29	1957-06-12	1	-4586
71806	4907	738818	1982-04-28	1982-05-05	1	4507
18507	1272	1713332	2001-12-24	2001-12-31	1	11687
66278	4527	1503184	1977-05-22	1978-05-17	1	3058
17857	1231	1118084	1978-01-21	1978-01-21	1	2942
53289	3628	1713332	1998-09-25	1998-10-16	1	10515
68988	4705	1713332	2019-06-21	2019-06-21	1	18068
21981	1496	1759842	1988-08-06	1988-08-27	1	6813
27718	1874	19127890	1992-10-11	1993-10-06	1	8679
49485	3371	1713332	1979-04-15	1979-04-29	1	3405
17818	1229	1125315	1957-07-29	1957-08-05	1	-4532
60998	4159	1503184	1976-12-18	1977-12-13	1	2903
20960	1430	1713332	1958-02-23	1958-03-16	1	-4309
58555	3993	1112807	1957-10-09	1957-10-30	1	-4446
19419	1325	1125315	1989-12-27	1990-01-10	1	7314
66144	4521	738818	1972-12-10	1972-12-17	1	1081
20808	1418	1125315	1988-03-09	1988-03-16	1	6649
63880	4366	1595799	2000-04-05	2002-03-26	2	11772
73260	5005	1115008	2010-03-17	2010-04-23	1	14722
23930	1618	1545958	2006-04-12	2006-04-12	1	13250
60908	4153	1125315	2018-01-21	2018-01-28	1	17559
20224	1379	738818	2001-02-03	2001-02-17	1	11370
17967	1237	1119510	1979-07-15	1979-07-29	1	3496
64076	4376	1759842	2010-07-02	2010-07-23	1	14813
56771	3869	1125315	1941-06-30	1941-07-14	1	-10398
25184	1707	1125315	1976-06-02	1976-06-16	1	2358
19750	1348	1713332	1959-10-20	1959-10-27	1	-3719
66547	4544	1112807	1949-10-31	1949-12-30	1	-7307
12534	863	1112807	1944-12-20	1945-01-10	1	-9122
60289	4109	1119510	1988-09-17	1988-09-24	1	6841
47713	3238	1137529	2018-03-12	2018-03-12	1	17602
66251	4526	1125315	1989-02-04	1989-02-18	1	6988
24646	1661	738818	1979-01-05	1979-01-12	1	3298
23494	1593	1112807	1964-12-28	1965-01-11	1	-1816
70438	4811	1759842	2012-07-01	2012-07-08	1	15529
19181	1314	1713332	1996-06-22	1996-10-12	1	9781
67489	4608	1713332	2015-11-19	2015-12-03	1	16772
17022	1173	1112807	1946-06-03	1946-06-17	1	-8599
33101	2242	1322184	2013-12-21	2013-12-21	1	16060
19939	1358	1177480	2004-02-15	2004-03-21	1	12498
30194	2041	1332418	1998-09-01	1998-09-01	1	10470
67130	4580	1521369	1983-02-10	1984-02-05	1	5148
27561	1860	1125315	1985-11-11	1985-11-11	1	5793
73945	5056	1112807	1945-12-14	1945-12-28	1	-8770
20893	1426	1125315	1983-11-23	1983-11-30	1	5081
46383	3149	1174888	1965-10-30	1965-10-30	1	-1524
67179	4587	1115008	2011-09-29	2011-11-28	1	15306
25419	1724	1125315	1975-02-20	1975-03-06	1	1890
70577	4820	738818	1982-12-05	1982-12-19	1	4735
18281	1257	1177480	1977-04-05	1977-04-19	1	2665
71036	4852	1759842	1986-10-24	1986-10-30	1	6146
18689	1283	708298	1972-04-22	1972-04-22	1	842
65698	4487	1125315	1977-08-10	1977-08-24	1	2792
17115	1177	1112807	1968-10-12	1968-10-26	1	-432
17441	1206	1713332	1965-01-10	1965-01-17	1	-1810
68232	4657	1124957	1995-06-13	1995-06-13	1	9294
26120	1766	1759842	2001-02-08	2001-02-22	1	11375
71807	4907	1112807	1950-05-03	1950-05-17	1	-7169
18508	1272	1713332	2009-08-28	2009-09-18	1	14505
66279	4527	1729720	1986-03-28	1986-04-04	1	5937
17858	1231	1125315	1982-01-07	1982-01-14	1	4396
53290	3628	1759842	1924-07-13	1924-07-27	1	-16594
68989	4705	19127890	1991-05-17	1994-05-01	3	8886
21982	1496	1778162	1989-06-07	1989-07-12	1	7132
27719	1874	1125315	1982-04-29	1982-05-06	1	4508
49486	3371	1729720	1984-01-26	1984-02-03	1	5146
17819	1229	1759842	1983-06-02	1983-06-23	1	4921
62427	4261	738818	1962-07-19	1962-08-02	1	-2709
20961	1430	1713332	1993-12-28	1994-01-25	1	8790
58556	3993	1115008	1999-03-13	1999-04-03	1	10684
19420	1325	1177480	2013-09-22	2013-10-06	1	15984
66145	4521	1112807	1928-03-12	1928-05-11	1	-15210
20809	1418	1125315	2016-12-21	2017-01-04	1	17170
63881	4366	1713332	1983-09-24	1983-10-08	1	5028
73261	5005	1125315	1980-07-24	1980-08-07	1	3871
23931	1618	1125315	2006-04-12	2006-04-12	1	13250
60909	4153	1177480	1999-11-01	1999-12-08	1	10933
20225	1379	914335	1987-09-05	1987-09-05	1	6456
17968	1237	1149380	1991-04-28	1991-04-28	1	7787
64077	4376	1115008	2010-09-19	2010-10-19	1	14901
56772	3869	738818	1953-08-31	1953-09-07	1	-5960
25185	1707	1713332	1998-08-23	1998-09-06	1	10475
19751	1348	1713332	2001-08-09	2001-08-30	1	11564
66548	4544	1118084	1984-04-25	1984-04-25	1	5228
12535	863	1115008	2003-05-09	2003-06-13	1	12216
60290	4109	1125315	2015-03-21	2015-04-04	1	16529
47714	3238	1118084	2006-12-09	2006-12-09	1	13491
66252	4526	1174888	1987-08-12	1987-08-12	1	6432
24647	1661	1119510	2016-08-03	2016-08-17	1	17030
23495	1593	1112807	1968-10-22	1968-11-12	1	-415
74665	5108	738818	1999-01-28	1999-02-11	1	10633
19182	1314	1729720	1936-04-28	1936-05-09	1	-12290
67490	4608	1717327	1967-12-08	1967-12-22	1	-741
17023	1173	1125315	1957-08-06	1957-08-20	1	-4517
33102	2242	1713332	1934-08-09	1934-08-30	1	-12908
19940	1358	1713332	1957-08-10	1957-10-05	1	-4471
30195	2041	1539403	1998-09-01	1998-09-01	1	10470
67131	4580	1729720	1976-11-04	1976-11-15	1	2510
27562	1860	1125315	1992-08-04	1992-08-18	1	8265
73946	5056	1118084	1979-07-04	1979-07-04	1	3471
20894	1426	1125315	2013-10-27	2013-11-17	1	16026
46384	3149	1759842	1951-10-24	1951-11-07	1	-6630
67180	4587	1322184	2018-02-17	2018-02-17	1	17579
25420	1724	1125315	1995-07-23	1995-08-06	1	9348
70578	4820	1112807	1963-06-15	1963-07-13	1	-2364
18282	1257	1759842	1977-09-09	1977-09-16	1	2815
71037	4852	1112807	1969-05-15	1969-06-12	1	-203
18690	1283	753626	1972-04-22	1972-04-22	1	842
65699	4487	1125315	1997-09-04	1997-09-11	1	10115
17116	1177	1125315	1989-05-13	1989-05-27	1	7086
17442	1206	1717327	1965-07-17	1965-07-31	1	-1615
68233	4657	1125315	1977-06-12	1977-06-26	1	2733
26121	1766	1137529	1984-01-10	1984-01-10	1	5122
71808	4907	1112807	1953-03-27	1953-05-26	1	-6064
18509	1272	1759842	2001-12-24	2001-12-31	1	11687
66928	4569	1125315	1964-12-08	1964-12-22	1	-1836
17859	1231	1125315	2000-11-01	2001-01-30	1	11352
53291	3628	1125315	1987-09-15	1987-09-29	1	6480
69585	4749	1125315	1994-04-08	1994-04-22	1	8877
24656	1662	1125315	1964-07-11	1964-07-25	1	-1986
27720	1874	1177480	1978-05-18	1978-06-01	1	3073
49487	3371	1729720	1988-12-11	1988-12-21	1	6929
17820	1229	1125315	2001-04-17	2001-04-24	1	11436
62428	4261	1118084	1954-09-25	1954-09-25	1	-5577
22055	1504	1119510	1993-12-05	1993-12-12	1	8746
58557	3993	1124300	1980-08-09	1980-08-09	1	3873
19421	1325	1759842	1987-11-09	1987-11-23	1	6535
66146	4521	1112807	1933-04-15	1933-06-14	1	-13350
20810	1418	1521369	1992-07-29	1993-03-08	1	8467
63882	4366	1124300	2015-06-16	2015-06-16	1	16602
73262	5005	1125315	1986-02-23	1986-03-09	1	5911
23932	1618	1322184	1999-03-03	2006-04-12	1	13250
60910	4153	1713332	1968-07-01	1968-07-22	1	-528
20226	1379	1112807	1987-08-30	1987-09-13	1	6464
17969	1237	1729720	1949-06-25	1949-07-08	1	-7482
64078	4376	1119510	1929-02-15	1929-03-01	1	-14916
56773	3869	1112807	1911-03-08	1911-04-05	1	-21456
25186	1707	1759842	1998-08-23	1998-09-06	1	10475
19752	1348	1124300	1954-03-06	1954-03-06	1	-5780
66549	4544	1125315	1955-09-17	1955-09-24	1	-5213
12536	863	1125315	1967-08-11	1967-08-25	1	-860
62230	4247	1125315	1987-05-18	1987-06-01	1	6360
47715	3238	1124957	1997-05-27	1997-05-27	1	10008
66253	4526	1728416	1955-10-13	1955-10-27	1	-5180
24648	1661	1125315	1957-09-17	1957-10-01	1	-4475
23496	1593	1125315	1976-08-03	1976-08-10	1	2413
74666	5108	1125315	1961-06-22	1961-07-06	1	-3101
19183	1314	1729720	1977-01-01	1977-01-12	1	2568
67491	4608	1112807	1964-02-27	1964-03-12	1	-2121
17024	1173	1125315	1987-06-12	1987-07-03	1	6392
33103	2242	1713332	1977-07-06	1977-07-20	1	2757
19941	1358	1729720	1965-12-21	1965-12-28	1	-1465
30196	2041	1728416	1964-04-25	1964-05-09	1	-2063
68265	4660	1729720	1968-07-26	1968-08-06	1	-513
27563	1860	1174888	1985-11-11	1985-11-11	1	5793
73947	5056	1119510	1967-04-25	1967-05-02	1	-975
20895	1426	1713332	1963-11-14	1963-11-21	1	-2233
48358	3287	920293	1988-08-10	1988-08-17	1	6803
67181	4587	1332418	2003-07-12	2003-07-12	1	12245
25421	1724	1177480	1987-06-21	1987-07-05	1	6394
70579	4820	1112807	1966-01-28	1966-02-18	1	-1413
19607	1338	738818	1992-05-24	1992-05-31	1	8186
71038	4852	1119510	1986-06-09	1986-06-23	1	6017
18691	1283	1000560	1972-04-22	1972-04-22	2	842
65700	4487	1361711	2004-10-22	2010-02-12	1	14652
17117	1177	1503184	1980-04-17	1982-04-07	2	4479
17443	1206	1125315	1969-05-01	1969-05-15	1	-231
68234	4657	1125315	1987-08-07	1987-08-21	1	6441
26122	1766	1759842	2001-07-31	2001-08-07	1	11541
71809	4907	1118084	1984-09-10	1984-09-10	1	5366
18510	1272	1759842	2009-08-28	2009-09-18	1	14505
66929	4569	1102527	1997-10-16	1997-10-16	1	10150
17860	1231	1729720	1958-06-21	1958-07-02	1	-4201
53292	3628	1322184	2002-04-13	2006-08-19	1	13379
69586	4749	1729720	2008-11-25	2008-12-05	1	14218
24657	1662	1713332	1988-11-14	1988-11-28	1	6906
27721	1874	1177480	1987-04-15	1987-05-06	1	6334
49488	3371	19127890	1990-08-06	1991-08-01	1	7882
17821	1229	1125315	2005-07-29	2005-08-12	1	13007
62429	4261	1125315	1962-07-19	1962-08-02	1	-2709
22056	1504	1125315	1957-04-01	1957-04-01	2	-4658
58558	3993	1125315	1947-07-06	1947-07-13	1	-8208
19422	1325	738818	1966-01-03	1966-01-10	1	-1452
66147	4521	1125315	1972-12-10	1972-12-17	1	1081
20811	1418	1713332	1979-05-31	1979-06-07	1	3444
63883	4366	1125315	1982-05-02	1982-05-16	1	4518
73263	5005	1503184	1990-06-12	1991-06-07	1	7827
23933	1618	1361711	2008-03-12	2008-03-12	1	13950
63064	4309	1112807	1954-12-02	1954-12-16	1	-5495
20227	1379	1119510	2001-02-03	2001-02-17	1	11370
23836	1612	1118084	2003-05-07	2003-05-07	1	12179
64079	4376	1149380	1976-07-06	1976-07-06	1	2378
56774	3869	1125315	1953-08-31	1953-09-07	1	-5960
25187	1707	1118084	2006-04-18	2006-04-18	1	13256
19753	1348	1713332	1919-07-15	1919-08-05	1	-18412
66550	4544	1361711	1989-10-24	1994-02-01	1	8797
12537	863	1326303	1981-01-29	1981-01-29	1	4046
62231	4247	1154343	1986-03-25	2002-12-28	1	12049
47716	3238	1125315	1986-02-27	1986-03-13	1	5915
66254	4526	1112807	1955-10-13	1955-10-27	1	-5180
24649	1661	1728416	1957-09-17	1957-10-01	1	-4475
23497	1593	1713332	1983-06-22	1983-07-06	1	4934
74667	5108	1125315	1962-04-19	1962-05-04	1	-2799
19184	1314	701322	2018-05-11	2018-05-11	1	17662
67492	4608	1112807	1987-10-08	1987-11-14	1	6526
17025	1173	1713332	2009-01-23	2009-02-13	1	14288
33104	2242	1729720	1980-10-22	1980-11-04	1	3960
19942	1358	1115008	2010-08-17	2010-10-16	1	14898
30197	2041	1729720	1964-06-25	1964-07-07	1	-2004
68266	4660	1759842	2005-06-24	2005-07-15	1	12979
27564	1860	1309944	1997-07-07	1997-07-07	1	10049
73948	5056	1119510	2000-09-14	2000-09-28	1	11228
20896	1426	1759842	1975-07-27	1975-08-17	1	2054
48359	3287	1112807	1949-02-01	1949-02-15	1	-7625
67182	4587	1539403	2003-07-12	2003-07-12	1	12245
25422	1724	1177480	2019-02-01	2019-02-22	1	17949
70580	4820	1112807	1967-02-13	1967-05-14	1	-963
19608	1338	933724	1974-11-07	1974-11-14	1	1778
71039	4852	1125315	1950-01-24	1950-02-07	1	-7268
18692	1283	1110410	1972-04-22	1972-04-22	1	842
65701	4487	1118084	1988-01-22	1988-01-22	1	6595
17118	1177	1759842	1989-09-02	1989-09-16	1	7198
17444	1206	1759842	1965-01-10	1965-01-17	1	-1810
68235	4657	1125315	2009-06-11	2009-06-18	1	14413
26123	1766	1118084	1996-08-27	1996-08-27	1	9735
71810	4907	1125315	1949-09-16	1949-09-30	1	-7398
19382	1323	1119510	1984-03-08	1984-03-15	1	5187
66930	4569	1119510	1999-02-02	1999-02-16	1	10638
17861	1231	738818	1982-01-07	1982-01-14	1	4396
53293	3628	1713332	1929-07-09	1929-07-16	1	-14779
69587	4749	1115008	2014-02-18	2014-03-27	1	16156
24658	1662	1124300	1999-05-24	1999-05-24	1	10735
27722	1874	1177480	2006-11-22	2006-12-13	1	13495
49489	3371	1112807	1979-04-15	1979-04-29	1	3405
17822	1229	705944	1966-05-12	1972-05-20	1	870
62430	4261	1125315	1974-01-29	1974-02-19	1	1510
22057	1504	1713332	1944-02-06	1944-02-27	1	-9440
58559	3993	1125315	1974-07-03	1974-07-31	2	1672
19423	1325	738818	1970-11-18	1970-12-02	1	335
66148	4521	1125315	1976-02-19	1976-02-26	1	2247
20812	1418	1713332	2004-06-04	2004-06-11	1	12580
63884	4366	1125315	1985-09-24	1985-10-01	1	5752
73264	5005	1549786	1991-06-07	1993-05-27	2	8547
23934	1618	1549786	1990-04-27	1992-04-16	2	8141
63065	4309	1125315	1970-11-30	1970-12-14	1	347
20228	1379	1125315	1962-10-30	1962-11-29	1	-2590
23837	1612	1125315	1982-01-19	1982-02-02	1	4415
64080	4376	1713332	1953-02-28	1953-03-14	1	-6137
56775	3869	1102527	1980-12-03	1980-12-03	1	3989
25188	1707	1125315	1973-10-23	1973-11-06	1	1405
19754	1348	1759842	1919-07-15	1919-08-05	1	-18412
71210	4860	1125315	1980-06-21	1980-07-05	1	3838
12538	863	1332418	1994-04-14	1994-04-14	1	8869
62232	4247	1768849	1983-05-18	1983-06-01	1	4899
47717	3238	1125315	1997-05-20	1997-07-26	2	10068
66255	4526	1118084	1993-01-17	1993-01-17	1	8417
24650	1661	1112807	1963-04-19	1963-05-24	1	-2414
23498	1593	1729720	1944-10-03	1944-10-13	1	-9211
74668	5108	1125315	1962-07-29	1962-08-12	1	-2699
19185	1314	757627	2017-07-15	2017-07-15	1	17362
67493	4608	1119510	1962-11-18	1962-11-25	1	-2594
17026	1173	1728416	1959-05-17	1959-05-31	1	-3868
33105	2242	1759842	1934-08-09	1934-08-30	1	-12908
19943	1358	1124300	1996-08-01	1996-08-01	1	9709
30198	2041	738818	1974-06-13	1974-06-27	1	1638
68267	4660	1118084	1998-08-12	1998-08-12	1	10450
27565	1860	1343916	1997-07-07	1997-07-07	1	10049
73949	5056	1125315	1982-04-16	1982-07-15	1	4578
22118	1508	1112807	1934-03-09	1934-03-30	1	-13061
48360	3287	1125315	1988-11-12	1988-11-12	1	6890
67183	4587	1713332	1945-05-20	1945-05-27	1	-8985
25423	1724	1729720	2013-04-29	2013-05-08	1	15833
70581	4820	1115008	2002-08-08	2002-08-22	1	11921
19609	1338	1112807	1947-04-19	1947-05-03	1	-8279
71040	4852	1125315	1962-12-15	1962-12-22	1	-2567
18693	1283	1125315	1989-01-19	1989-02-02	1	6972
65702	4487	1119510	1990-10-03	1990-10-10	1	7587
17119	1177	1759842	1992-11-07	1992-11-14	1	8353
17599	1216	920293	1988-08-27	1988-09-10	2	6827
68236	4657	1713332	1966-10-12	1966-11-02	1	-1156
26124	1766	1125315	1961-05-09	1961-05-16	1	-3152
71811	4907	1125315	2004-09-07	2004-09-14	1	12675
19383	1323	1125315	1962-03-02	1962-03-16	1	-2848
66931	4569	1713332	1989-08-23	1989-09-13	1	7195
17862	1231	1112807	1949-11-14	1950-01-13	1	-7293
53294	3628	1713332	1992-02-06	1992-02-20	1	8085
69588	4749	1125315	1978-07-23	1978-08-06	1	3139
24659	1662	1759842	1988-11-14	1988-11-28	1	6906
27723	1874	1515774	1992-10-11	1993-10-06	1	8679
49490	3371	1118084	2011-04-23	2011-04-23	1	15087
17823	1229	1115008	2012-06-09	2012-06-23	1	15514
62431	4261	1307863	2010-01-24	2010-01-24	1	14633
22058	1504	738818	2004-10-17	2004-10-31	1	12722
58560	3993	1125315	1991-06-24	1991-07-01	1	7851
19424	1325	1125315	1966-01-03	1966-01-10	1	-1452
66149	4521	1307863	2000-06-08	2000-06-08	1	11116
20813	1418	1759842	2005-07-12	2005-07-26	1	12990
63885	4366	1129625	1982-04-19	1982-04-19	1	4491
73265	5005	19127890	1990-06-12	1993-05-27	3	8547
23935	1618	19127890	1990-04-27	1992-04-16	2	8141
63066	4309	1125315	2018-12-28	2019-01-04	1	17900
20229	1379	1125315	2001-02-03	2001-02-17	1	11370
23838	1612	1347450	2014-04-16	2014-04-16	1	16176
64081	4376	1759842	1948-02-12	1948-02-19	1	-7987
56776	3869	1112807	1914-10-26	1914-11-09	1	-20142
25189	1707	1728416	1973-10-23	1973-11-06	1	1405
19755	1348	1759842	1959-10-20	1959-10-27	1	-3719
71211	4860	1125315	2006-09-28	2006-10-05	1	13426
12539	863	1347450	2014-07-03	2014-07-03	1	16254
62233	4247	738818	2006-12-08	2006-12-22	1	13504
47718	3238	1149380	2018-03-12	2018-03-12	1	17602
66256	4526	1119510	1968-04-03	1968-04-17	1	-624
24651	1661	1115008	2018-11-16	2019-02-14	1	17941
23499	1593	1759842	1975-02-24	1975-03-10	1	1894
74669	5108	1125315	1998-11-20	1998-11-27	1	10557
19186	1314	1112807	1930-10-13	1930-10-27	1	-14311
67494	4608	1125315	1956-04-11	1956-04-25	1	-4999
17027	1173	1759842	2009-01-23	2009-02-13	1	14288
33106	2242	1118084	1964-09-16	1964-09-16	1	-1933
19944	1358	1125315	1976-04-07	1976-05-07	2	2318
30199	2041	1125315	1965-02-27	1965-03-13	1	-1755
68268	4660	1125315	1995-11-24	1995-12-08	1	9472
27566	1860	1361711	1987-01-05	1987-01-05	1	6213
73950	5056	1713332	1952-09-02	1952-09-23	1	-6309
22119	1508	1713332	1980-07-04	1980-07-18	1	3851
48361	3287	1759842	1971-06-07	1971-08-30	1	606
67184	4587	1713332	1991-01-16	1991-02-06	1	7706
25424	1724	738818	2015-01-23	2015-01-30	1	16465
70582	4820	1713332	2003-07-17	2003-07-31	1	12264
19610	1338	1125315	1992-05-24	1992-05-31	1	8186
71041	4852	1125315	1967-03-26	1967-03-26	1	-1012
18694	1283	1713332	2000-09-03	2000-09-10	1	11210
65703	4487	1125315	1987-09-11	1987-09-18	1	6469
19640	1340	1112807	1927-12-17	1928-01-07	1	-15335
17600	1216	933724	1988-08-27	1988-09-10	1	6827
68237	4657	1713332	1985-03-04	1985-03-18	1	5555
26125	1766	1713332	2001-07-31	2001-08-07	1	11541
71812	4907	1125315	2008-03-18	2008-04-01	1	13970
19384	1323	1729720	1986-07-10	1986-07-17	1	6041
66932	4569	1713332	1997-10-16	1997-11-20	1	10185
17863	1231	1119510	1960-07-15	1960-07-29	1	-3443
53295	3628	1729720	1927-05-27	1927-06-08	1	-15548
69589	4749	1125315	1979-11-14	1979-11-28	1	3618
24660	1662	1125315	1969-11-14	1969-11-28	1	-34
27724	1874	1521369	1989-10-27	1990-10-22	1	7599
49491	3371	1125315	1983-12-01	1983-12-29	1	5110
17824	1229	1125315	2001-08-24	2001-09-07	1	11572
62432	4261	1326303	2010-01-24	2010-01-24	1	14633
22059	1504	920293	2003-07-08	2003-07-15	1	12248
58561	3993	1729720	1965-04-15	1965-04-23	1	-1714
19425	1325	1125315	1974-04-24	1974-05-01	1	1581
66150	4521	1326303	2000-06-08	2000-06-08	1	11116
20814	1418	1125315	2016-01-18	2016-01-25	1	16825
63886	4366	1713332	1983-01-25	1983-02-08	1	4786
75451	5165	1118084	2008-02-20	2008-02-20	1	13929
23936	1618	1125315	1986-01-09	1986-01-23	1	5866
63067	4309	1759842	1961-07-03	1961-07-24	1	-3083
20230	1379	1137529	2000-02-19	2000-02-19	1	11006
23839	1612	1717327	1966-11-11	1966-11-25	1	-1133
64082	4376	1759842	1973-03-09	1973-03-23	1	1177
56777	3869	1112807	1943-07-16	1943-08-06	1	-9645
32627	2210	738818	1951-01-21	1951-02-04	1	-6906
21272	1448	1125315	1973-12-24	1974-01-07	1	1467
71212	4860	1174888	1995-08-01	1995-08-01	1	9343
12540	863	1112807	1930-02-16	1930-03-09	1	-14543
62234	4247	1119510	2006-12-08	2006-12-22	1	13504
47719	3238	1729720	2009-01-13	2009-01-24	1	14268
66257	4526	1125315	1954-09-04	1954-09-18	1	-5584
24652	1661	1119510	1963-02-19	1963-02-26	1	-2501
23500	1593	1759842	1983-06-22	1983-07-06	1	4934
74670	5108	1125315	1999-01-28	1999-02-11	1	10633
19187	1314	1118084	1966-08-25	1966-08-25	1	-1225
67495	4608	1125315	2008-08-23	2008-09-22	1	14144
17028	1173	1124300	1986-01-19	1986-01-19	1	5862
33107	2242	1125315	1942-05-25	1942-05-25	1	-10083
19945	1358	1728416	1959-09-20	1959-10-04	1	-3742
30200	2041	1125315	1974-06-13	1974-06-27	1	1638
68269	4660	1713332	1964-03-24	1964-04-07	1	-2095
27567	1860	1759842	1995-12-20	1996-01-10	1	9505
73951	5056	738818	1967-04-25	1967-05-02	1	-975
22120	1508	1729720	1933-09-11	1933-09-23	1	-13249
48362	3287	1118084	1980-04-17	1980-04-17	1	3759
67185	4587	1759842	1991-01-16	1991-02-06	1	7706
25425	1724	1125315	2015-01-23	2015-01-30	1	16465
72837	4977	708298	2010-12-08	2010-12-08	1	14951
19611	1338	1125315	1997-02-22	1997-03-01	1	9921
71042	4852	1125315	1977-07-25	1977-08-08	1	2776
18695	1283	1729720	1959-09-13	1959-09-23	1	-3753
65704	4487	1332418	2004-10-22	2004-10-22	1	12713
19641	1340	1125315	1955-04-26	1955-05-10	1	-5350
17601	1216	1124300	2012-05-09	2012-05-09	1	15469
68238	4657	1713332	2005-10-09	2005-10-23	1	13079
26126	1766	1759842	1970-02-10	1970-03-03	1	61
71813	4907	1729720	1949-05-20	1949-05-28	1	-7523
19385	1323	1115008	2016-04-29	2016-05-29	1	16950
66933	4569	1759842	1971-01-14	1971-01-21	1	385
17864	1231	1125315	1957-07-07	1957-07-21	1	-4547
53296	3628	1759842	1929-07-09	1929-07-16	1	-14779
69590	4749	1729720	1983-12-09	1983-12-22	1	5103
24661	1662	1717327	1964-07-11	1964-07-25	1	-1986
27725	1874	1759842	1978-12-20	1979-01-17	1	3303
49492	3371	1125315	1999-08-11	1999-08-18	1	10821
17825	1229	1713332	1983-06-02	1983-06-23	1	4921
62433	4261	1125315	1983-03-14	1983-03-21	1	4827
22060	1504	1112807	1959-06-20	1959-09-18	1	-3758
58562	3993	933724	1965-03-01	1965-03-08	1	-1760
19426	1325	1713332	2002-02-14	2002-02-28	1	11746
66151	4521	1361711	1970-04-16	1970-04-16	1	105
20815	1418	1729720	1978-01-02	1978-01-15	1	2936
63887	4366	1713332	1991-02-06	1991-02-13	1	7713
75452	5165	1125315	1993-04-29	1993-05-06	1	8526
23937	1618	1125315	1992-12-21	1993-01-04	1	8404
63068	4309	1759842	1968-05-27	1968-06-03	1	-577
20231	1379	1503184	1977-01-24	1978-01-19	1	2940
23840	1612	1713332	1980-11-28	1980-12-12	1	3998
65298	4462	1112807	1955-12-30	1956-01-13	1	-5102
56778	3869	1119510	1941-06-30	1941-07-14	1	-10398
32628	2210	738818	1954-01-05	1954-01-12	1	-5833
21273	1448	1503184	1987-03-25	1988-03-19	1	6652
71213	4860	1521369	1997-08-30	1998-08-25	1	10463
12541	863	1112807	1943-08-10	1943-08-24	1	-9627
62235	4247	1124300	2018-03-30	2018-03-30	1	17620
47720	3238	1759842	1987-01-17	1987-02-07	1	6246
66258	4526	1177480	2012-05-02	2012-06-06	1	15497
24653	1661	1125315	1980-05-24	1980-06-14	1	3817
25077	1699	1112807	1967-08-26	1967-09-09	1	-845
74671	5108	1177480	1974-03-14	1974-04-13	1	1563
19188	1314	1125315	1970-12-14	1970-12-21	1	354
67496	4608	1125315	2017-10-10	2017-10-24	1	17463
19457	1328	1125315	1976-02-26	1976-04-26	1	2307
33108	2242	1759842	1977-07-06	1977-07-20	1	2757
19946	1358	1729720	1968-09-15	1968-09-24	1	-464
30201	2041	1738521	1968-02-18	1968-03-03	1	-669
68270	4660	1713332	2005-06-24	2005-07-15	1	12979
28935	1960	933724	1951-08-14	1951-08-21	1	-6708
73952	5056	738818	2004-02-12	2004-02-19	1	12467
22121	1508	1759842	1980-07-04	1980-07-18	1	3851
48363	3287	1713332	2012-05-24	2012-06-14	1	15505
67186	4587	701322	2016-01-26	2016-01-26	1	16826
25426	1724	1177480	1986-05-27	1986-08-25	1	6080
72838	4977	1102527	2010-12-13	2010-12-13	1	14956
19612	1338	920293	1974-11-07	1974-11-14	1	1778
71043	4852	1125315	2003-01-26	2003-03-02	1	12113
18696	1283	1741122	1972-04-22	1972-04-22	1	842
65705	4487	1539403	2004-10-22	2004-10-22	1	12713
19642	1340	1177480	2014-04-29	2014-05-29	1	16219
17602	1216	1149380	2015-01-13	2015-01-13	1	16448
68239	4657	1729720	1972-05-27	1972-06-05	1	886
26127	1766	1713332	1970-02-10	1970-03-03	1	61
71814	4907	1759842	1974-07-14	1974-10-13	1	1746
19386	1323	1125315	2018-06-18	2018-07-16	1	17728
66934	4569	1125315	1968-11-03	1968-11-10	1	-417
17865	1231	1125315	1975-03-09	1975-04-06	1	1921
53297	3628	1759842	1992-02-06	1992-02-20	1	8085
69591	4749	1759842	1979-11-23	1979-12-14	1	3634
26071	1764	1115008	2008-12-01	2009-02-06	1	14281
27726	1874	1759842	2010-10-28	2010-11-04	1	14917
49493	3371	1521369	1995-07-11	1996-07-05	1	9682
17826	1229	920293	1977-06-11	1977-06-18	1	2725
62434	4261	1713332	1977-10-30	1977-11-06	1	2866
22061	1504	1118084	1985-01-15	1985-01-15	1	5493
58563	3993	1125315	1990-07-20	1990-07-27	1	7512
19427	1325	1713332	2013-09-22	2013-10-06	1	15984
66152	4521	1539403	1991-01-24	1991-01-24	1	7693
20816	1418	1503184	1992-07-29	1993-03-08	1	8467
63888	4366	1759842	1991-02-06	1991-02-13	1	7713
75453	5165	1177480	2008-03-21	2008-04-04	1	13973
23938	1618	1322184	2008-03-12	2008-03-12	1	13950
63069	4309	1119510	1981-08-05	1981-08-12	1	4241
20232	1379	1713332	1979-04-04	1979-04-18	1	3394
23841	1612	1713332	1997-02-06	1997-02-13	1	9905
65299	4462	1503184	1974-12-30	1975-12-25	1	2184
56779	3869	1125315	1961-07-16	1961-08-15	1	-3061
32629	2210	1112807	1943-08-20	1943-11-18	1	-9541
21274	1448	1515774	1994-02-16	1995-02-11	1	9172
71214	4860	1177480	1979-10-24	1979-11-07	1	3597
12542	863	1119510	1932-07-23	1932-07-30	1	-13669
62236	4247	1125315	2002-04-30	2002-05-07	1	11814
47721	3238	738818	1974-06-21	1974-06-28	1	1639
66259	4526	1713332	1986-05-02	1986-05-09	1	5972
24654	1661	1125315	2017-03-31	2017-04-14	1	17270
25078	1699	1125315	1995-02-06	1995-02-20	1	9181
74672	5108	1322184	2012-12-30	2012-12-30	1	15704
19189	1314	1322184	2012-01-14	2012-01-14	1	15353
67497	4608	1137529	1992-01-30	1992-01-30	1	8064
19458	1328	1125315	1987-12-25	1988-01-01	1	6574
33109	2242	1112807	1939-08-04	1939-09-08	1	-11073
19947	1358	738818	1969-04-01	1969-04-15	1	-261
30202	2041	1112807	1968-02-18	1968-03-03	1	-669
68271	4660	1759842	1976-07-23	1976-08-27	1	2430
28936	1960	933724	1955-11-13	1955-11-20	1	-5156
73953	5056	920293	1993-03-08	1993-03-15	1	8474
22122	1508	1115008	2014-10-06	2015-01-04	1	16439
48364	3287	933724	1988-08-10	1988-08-17	1	6803
67187	4587	715997	2016-01-26	2016-01-26	1	16826
25427	1724	1759842	1979-09-26	1979-10-17	1	3576
72839	4977	1119510	1988-07-15	1988-07-22	1	6777
19613	1338	1112807	1956-07-06	1956-07-20	1	-4913
71044	4852	1728416	1950-01-24	1950-02-07	1	-7268
18697	1283	19039298	1972-04-22	1972-04-22	1	842
65706	4487	1759842	1980-11-09	1980-11-16	1	3972
19643	1340	1759842	1912-12-29	1913-08-31	1	-20577
17603	1216	1521369	1987-07-05	1989-06-24	2	7114
68240	4657	1729720	1982-05-25	1982-06-03	1	4536
26128	1766	1729720	1958-10-10	1958-10-19	1	-4092
71815	4907	1759842	2005-07-29	2005-08-05	1	13000
19387	1323	1177480	1997-09-15	1997-10-06	1	10140
66935	4569	1125315	1997-10-16	1997-11-20	1	10185
17866	1231	1729720	1946-12-01	1946-12-09	1	-8424
55487	3776	1124300	2007-09-12	2007-09-12	1	13768
69592	4749	1102527	1999-08-08	1999-08-08	1	10811
26072	1764	1119510	1968-11-16	1968-11-30	1	-397
29288	1982	1112807	1927-06-25	1927-07-09	1	-15517
49494	3371	1521369	1997-06-30	1998-06-25	1	10402
17827	1229	933724	1977-06-11	1977-06-18	1	2725
62435	4261	1112807	1927-03-16	1927-03-30	1	-15618
22062	1504	1119510	2004-10-17	2004-10-31	1	12722
58564	3993	1125315	1991-08-31	1991-09-21	1	7933
19428	1325	1759842	2002-02-14	2002-02-28	1	11746
66153	4521	715997	2001-10-01	2001-10-01	1	11596
20817	1418	1118084	2014-08-08	2014-08-08	1	16290
63889	4366	1125315	1996-11-12	1997-01-11	1	9872
75454	5165	1713332	2010-11-09	2010-11-16	1	14929
23939	1618	1332418	1999-03-03	1999-03-03	1	10653
63070	4309	1125315	1963-09-27	1963-10-11	1	-2274
20233	1379	738818	2000-07-23	2000-08-06	1	11175
23842	1612	1112807	1971-05-20	1971-06-03	1	518
65300	4462	1521369	1974-12-30	1975-12-25	1	2184
56780	3869	1125315	1980-12-03	1981-03-03	1	4079
32630	2210	1112807	1966-07-11	1966-08-01	1	-1249
21275	1448	1521369	1990-03-09	1991-03-04	1	7732
71215	4860	1177480	1999-07-11	1999-08-01	1	10804
12543	863	1125315	1953-12-24	1954-01-21	1	-5824
62237	4247	1125315	2006-12-08	2006-12-22	1	13504
47722	3238	1125315	1974-06-21	1974-06-28	1	1639
66260	4526	1713332	1995-03-01	1995-03-15	1	9204
24655	1661	1717327	1962-03-14	1962-03-28	1	-2836
25079	1699	1112807	1968-12-18	1969-02-16	1	-319
74673	5108	1332418	2012-12-30	2012-12-30	1	15704
19190	1314	1332418	2012-01-14	2012-01-14	1	15353
67498	4608	1174888	1987-10-15	1987-10-15	1	6496
19459	1328	1713332	1967-06-25	1967-07-09	1	-907
33110	2242	1112807	1942-05-25	1942-08-23	1	-9993
19948	1358	1112807	1959-09-20	1959-10-04	1	-3742
30203	2041	1115008	2008-02-14	2011-05-29	1	15123
68272	4660	1112807	1967-06-01	1967-06-15	1	-931
28937	1960	1112807	1969-11-15	1969-12-06	1	-26
73954	5056	933724	1993-03-08	1993-03-15	1	8474
22123	1508	1125315	2011-09-17	2011-10-22	1	15269
48365	3287	1112807	1946-04-01	1946-04-15	1	-8662
67188	4587	1112807	1940-01-17	1940-04-16	1	-10852
25428	1724	1112807	1954-11-15	1954-11-29	1	-5512
72840	4977	1125315	1964-06-14	1964-06-28	1	-2013
19614	1338	1115008	2007-11-30	2007-12-21	1	13868
71045	4852	1729720	1970-05-08	1970-05-17	1	136
18698	1283	19078219	1972-04-22	1972-04-22	1	842
65707	4487	1759842	1990-01-26	1990-02-09	1	7344
19644	1340	1112807	1916-05-19	1916-06-02	1	-19571
17604	1216	1112807	1973-03-10	1973-04-09	1	1194
68241	4657	920293	1990-12-22	1991-01-05	2	7674
27305	1845	1112807	1964-08-31	1964-09-14	1	-1935
71816	4907	920293	1985-03-10	1985-03-17	1	5554
19388	1323	1713332	1970-07-14	1970-07-28	1	208
66936	4569	1759842	1989-08-23	1989-09-13	1	7195
17867	1231	1729720	1970-09-15	1970-09-22	1	264
55488	3776	1729720	1979-12-29	1980-01-05	1	3656
69593	4749	1118084	2011-05-25	2011-05-25	1	15119
26073	1764	1124957	1993-05-28	1993-05-28	1	8548
29289	1982	1119510	1939-03-25	1939-04-08	1	-11226
49495	3371	1738521	1977-10-17	1977-10-31	1	2860
17828	1229	1713332	2011-05-10	2011-05-31	1	15125
62436	4261	1112807	1957-08-05	1957-08-26	1	-4511
22063	1504	1125315	1986-04-29	1986-05-27	1	5990
58565	3993	920293	1961-01-20	1961-02-03	2	-3254
19429	1325	1119510	2009-10-29	2009-11-12	1	14560
66154	4521	1112807	1972-05-11	1972-08-09	1	951
20818	1418	1125315	1973-09-22	1973-10-13	1	1381
63890	4366	1154343	1984-05-11	2001-04-03	1	11415
75455	5165	1759842	2010-11-09	2010-11-16	1	14929
23940	1618	1361711	1999-03-03	2006-04-12	1	13250
63071	4309	1713332	1996-03-11	1996-03-18	1	9573
20234	1379	1125315	1998-02-17	1998-03-10	1	10295
23843	1612	1125315	1976-02-06	1976-02-20	1	2241
65301	4462	1521369	1978-12-09	1979-12-04	1	3624
56781	3869	914335	1926-10-09	1926-10-09	1	-15790
32631	2210	1118084	1974-05-04	1974-05-04	1	1584
21276	1448	1521369	1992-02-27	1993-02-21	1	8452
71216	4860	1177480	2016-06-02	2016-07-07	1	16989
12544	863	1307863	1981-01-29	1981-01-29	1	4046
62238	4247	1713332	1985-10-12	1985-10-26	1	5777
47723	3238	1713332	1979-12-15	1979-12-29	1	3649
66261	4526	1717327	1962-08-19	1962-09-02	1	-2678
27291	1844	1118084	2002-10-13	2002-10-13	1	11973
25080	1699	1124300	2003-11-10	2003-11-10	1	12366
74674	5108	1539403	2012-12-30	2012-12-30	1	15704
19191	1314	1539403	2012-01-14	2012-01-14	1	15353
67499	4608	738818	1962-11-18	1962-11-25	1	-2594
19460	1328	1728416	1946-09-01	1946-09-15	1	-8509
33111	2242	1115008	1996-07-24	1996-08-14	1	9722
19949	1358	1112807	1986-10-12	1986-10-26	1	6142
30204	2041	1124300	2007-07-09	2007-07-09	1	13703
68273	4660	1125315	1967-08-02	1967-08-16	1	-869
28938	1960	1112807	1973-08-17	1973-09-21	1	1359
73955	5056	1112807	1973-08-31	1973-09-30	1	1368
22124	1508	1729720	1959-07-07	1959-07-15	1	-3823
48366	3287	1125315	1965-02-20	1965-03-20	1	-1748
67189	4587	1125315	1967-02-25	1967-03-04	1	-1034
25429	1724	1125315	2015-06-30	2015-07-14	1	16630
72841	4977	1125315	1982-06-02	1982-06-09	1	4542
19615	1338	1118084	1978-08-09	1978-08-09	1	3142
71046	4852	738818	1986-06-09	1986-06-23	1	6017
18699	1283	1112807	1962-11-25	1962-12-23	1	-2566
67261	4593	1112807	1965-11-29	1965-12-13	1	-1480
19645	1340	1112807	1980-01-25	1980-02-29	1	3711
17605	1216	1177480	2006-05-21	2006-06-04	1	13303
68242	4657	933724	1990-12-22	1991-01-05	1	7674
27306	1845	1124300	1997-07-24	1997-07-24	1	10066
71817	4907	933724	1985-03-10	1985-03-17	1	5554
19389	1323	1124957	1987-05-11	1987-05-11	1	6339
66937	4569	738818	1999-02-02	1999-02-16	1	10638
17868	1231	1729720	1989-06-27	1989-07-04	1	7124
55489	3776	1125315	1987-03-21	1987-06-19	1	6378
69594	4749	1125315	2007-03-29	2007-04-26	1	13629
26074	1764	1125315	1970-05-27	1970-07-28	2	181
29290	1982	1119510	1987-08-16	1987-08-30	1	6450
49496	3371	19127890	2001-06-09	2002-06-04	1	11842
17829	1229	1759842	2011-05-10	2011-05-31	1	15125
62437	4261	1115008	1995-10-27	1995-11-10	1	9444
22064	1504	1125315	2004-10-17	2004-10-31	1	12722
58566	3993	920293	1965-03-01	1965-03-08	1	-1760
19430	1325	1125315	1970-11-18	1970-12-02	1	335
66155	4521	1124957	1972-05-11	1972-05-11	1	861
20819	1418	1713332	2005-07-12	2005-07-26	1	12990
63891	4366	1521369	2000-04-05	2002-03-26	2	11772
75456	5165	738818	1970-09-09	1970-09-16	1	258
23941	1618	1539403	1999-03-03	1999-03-03	1	10653
63072	4309	1729720	1990-12-12	1990-12-22	1	7660
20235	1379	1125315	2000-07-23	2000-08-06	1	11175
23844	1612	1154343	1966-08-06	1982-12-14	1	4730
65302	4462	920293	1984-03-08	1984-03-15	1	5187
56782	3869	1112807	1950-09-28	1950-10-12	1	-7021
32632	2210	1125315	1951-01-21	1951-02-04	1	-6906
21277	1448	1713332	1984-10-01	1984-10-22	1	5408
71217	4860	1515774	1992-09-25	1993-09-20	1	8663
12545	863	1539403	1991-03-28	1991-03-28	1	7756
62239	4247	1713332	2013-08-20	2013-09-10	1	15958
47724	3238	1717327	1968-03-23	1968-04-06	1	-635
66262	4526	1728416	1954-09-04	1954-09-18	1	-5584
27292	1844	1125315	1994-10-31	1994-11-14	1	9083
25081	1699	1125315	1979-01-25	1979-01-25	1	3311
74675	5108	1728416	1962-07-29	1962-08-12	1	-2699
21503	1464	738818	1996-03-31	1996-04-07	1	9593
67500	4608	1112807	1967-12-08	1967-12-22	1	-741
19461	1328	1729720	2010-04-08	2010-04-18	1	14717
33112	2242	1124957	1942-05-25	1942-05-25	1	-10083
19950	1358	1115008	2002-01-05	2002-01-26	1	11713
30205	2041	1305058	2008-02-14	2011-05-29	1	15123
68274	4660	1125315	1989-01-02	1989-01-16	1	6955
28939	1960	1119510	1983-10-04	1983-10-11	1	5031
73956	5056	1119510	1991-02-26	1991-03-05	1	7733
22125	1508	1759842	1990-03-05	1990-03-12	1	7375
48367	3287	1125315	2009-07-31	2009-08-07	1	14463
67190	4587	1322184	2003-07-12	2017-11-18	1	17488
25430	1724	1729720	1952-08-29	1952-09-08	1	-6324
72842	4977	1125315	1990-08-13	1990-08-27	1	7543
19616	1338	1125315	2019-03-23	2019-06-21	1	18068
71047	4852	920293	1994-02-06	1994-02-20	2	8816
18700	1283	1367571	1972-04-22	1972-04-22	1	842
67262	4593	1503184	1979-08-29	1980-08-23	1	3887
19646	1340	1125315	1916-06-04	1916-06-18	1	-19555
17606	1216	1503184	1987-07-05	1989-06-24	2	7114
68243	4657	1115008	1995-06-06	1995-07-13	1	9324
27307	1845	738818	1972-04-22	1972-05-06	1	856
71818	4907	1102527	1983-07-02	1983-07-02	1	4930
19390	1323	1125315	1977-12-08	1977-12-29	1	2919
66938	4569	1124300	2002-08-01	2002-08-01	1	11900
17869	1231	1729720	2002-05-13	2002-05-23	1	11830
55490	3776	1125315	1991-12-25	1992-01-15	1	8049
69595	4749	1177480	1999-08-01	1999-10-07	1	10871
26075	1764	1125315	1993-05-28	1993-06-18	2	8569
29291	1982	1124957	1957-05-25	1957-05-25	1	-4604
51418	3505	1729720	1977-07-01	1977-07-09	1	2746
19097	1310	1112807	1968-09-30	1968-10-14	1	-444
62438	4261	1115008	1999-11-19	1999-12-10	1	10935
22065	1504	1759842	1944-02-06	1944-02-27	1	-9440
58567	3993	933724	1961-01-20	1961-02-03	1	-3254
19431	1325	1125315	1990-05-03	1990-05-17	1	7441
66156	4521	1125315	1951-12-07	1951-12-28	1	-6579
20820	1418	1759842	1979-05-31	1979-06-07	1	3444
63892	4366	1759842	1983-09-24	1983-10-08	1	5028
75457	5165	920293	1989-12-31	1990-01-07	1	7311
25571	1736	738818	1999-06-20	1999-07-04	1	10776
63073	4309	1759842	1969-11-30	1969-12-07	1	-25
20236	1379	1521369	1977-01-24	1978-01-19	1	2940
23845	1612	1322184	2014-04-16	2014-04-16	1	16176
65303	4462	933724	1984-03-08	1984-03-15	1	5187
56783	3869	1119510	1953-08-31	1953-09-07	1	-5960
32633	2210	1125315	1954-01-05	1954-01-12	1	-5833
21278	1448	1728416	1977-11-23	1977-12-07	1	2897
71218	4860	1515774	1996-09-04	1997-08-30	1	10103
12546	863	1713332	1994-02-12	1994-02-19	1	8815
62240	4247	1729720	1995-07-16	1995-07-27	1	9338
47725	3238	1759842	1979-12-15	1979-12-29	1	3649
66263	4526	1729720	1954-08-07	1954-08-17	1	-5616
27293	1844	1149380	1963-04-13	1963-04-13	1	-2455
25082	1699	1174888	1979-01-25	1979-01-25	1	3311
74676	5108	1125315	2002-03-10	2002-03-17	1	11763
21504	1464	1112807	1965-09-01	1965-11-30	1	-1493
67501	4608	1118084	1997-03-25	1997-03-25	1	9945
19462	1328	1112807	1946-09-01	1946-09-15	1	-8509
33113	2242	738818	1976-02-23	1976-03-08	1	2258
19951	1358	1174888	1976-04-07	1976-04-07	1	2288
30206	2041	1717327	1965-02-27	1965-03-13	1	-1755
68275	4660	1125315	1989-07-19	1989-08-23	1	7174
28940	1960	738818	1955-09-27	1955-10-11	1	-5196
73957	5056	1125315	1955-08-08	1955-09-05	1	-5232
22126	1508	1759842	2004-04-26	2004-09-06	1	12667
48368	3287	1309944	1967-07-10	1967-07-10	1	-906
67191	4587	1347450	2017-11-18	2017-11-18	1	17488
25431	1724	1112807	1957-03-02	1957-03-30	1	-4660
72843	4977	1125315	2015-03-31	2015-04-14	1	16539
19617	1338	1713332	2002-02-24	2002-03-10	1	11756
71048	4852	920293	1995-04-06	1995-04-20	2	9240
18701	1283	1521369	1976-02-25	1977-02-19	1	2606
67263	4593	1112807	1967-05-15	1967-05-29	1	-948
19647	1340	1125315	1975-03-01	1975-03-22	1	1906
17607	1216	1729720	1971-03-22	1971-04-01	1	455
68244	4657	1115008	2002-01-07	2002-01-28	1	11715
27308	1845	1119510	2006-02-07	2006-02-21	1	13200
71819	4907	1112807	1948-12-18	1949-01-01	1	-7670
19391	1323	1125315	1987-05-11	1987-07-10	2	6399
66939	4569	1125315	1963-04-19	1963-04-26	1	-2442
17870	1231	1125315	1968-04-21	1968-05-06	1	-605
55491	3776	1125315	2006-10-08	2006-10-15	1	13436
69596	4749	1713332	1979-11-14	1979-12-14	2	3634
26076	1764	1728416	1959-11-02	1959-11-16	1	-3699
29292	1982	1125315	1957-05-18	1957-07-24	2	-4544
51419	3505	1759842	2004-02-17	2004-03-09	1	12486
19098	1310	1119510	1945-04-11	1945-04-18	1	-9024
62439	4261	1119510	1962-07-19	1962-08-02	1	-2709
22066	1504	738818	1993-12-05	1993-12-12	1	8746
58568	3993	1119510	1991-06-24	1991-07-01	1	7851
19432	1325	1125315	2001-04-06	2001-04-13	1	11425
66157	4521	1125315	1967-08-16	1967-08-23	1	-862
20821	1418	1759842	2004-06-04	2004-06-11	1	12580
63893	4366	1778162	1984-01-04	1984-01-18	1	5130
75458	5165	1125315	1970-09-09	1970-09-16	1	258
25572	1736	920293	1989-10-20	1989-11-03	2	7246
63074	4309	738818	1981-08-05	1981-08-12	1	4241
20237	1379	1112807	1968-08-29	1968-09-19	1	-469
23846	1612	1112807	1966-11-11	1966-11-25	1	-1133
65304	4462	1125315	1956-09-09	1956-09-23	1	-4848
56784	3869	1125315	1947-03-16	1947-03-23	1	-8320
32634	2210	1125315	1985-11-24	1986-01-23	1	5866
21279	1448	1729720	1986-04-05	1986-04-14	1	5947
71219	4860	1713332	1986-08-26	1986-09-16	1	6102
12547	863	1759842	1963-04-07	1963-04-21	1	-2447
62241	4247	1125315	1985-10-12	1985-10-26	1	5777
48283	3280	1118084	1986-12-18	1986-12-18	1	6195
66264	4526	1759842	1986-05-02	1986-05-09	1	5972
27294	1844	1713332	1977-09-26	1977-10-31	1	2860
25083	1699	1713332	2000-12-23	2000-12-30	1	11321
74677	5108	1361711	2012-12-30	2012-12-30	1	15704
21505	1464	1115008	2017-06-21	2017-07-05	1	17352
67502	4608	1125315	1962-11-18	1962-11-25	1	-2594
19463	1328	1118084	1989-05-01	1989-05-01	1	7060
33114	2242	1125315	1969-02-02	1969-02-16	1	-319
19952	1358	1729720	1970-07-18	1970-07-25	1	205
30207	2041	1112807	1964-04-25	1964-05-09	1	-2063
68276	4660	1713332	1976-07-23	1976-08-27	1	2430
28941	1960	1112807	1932-04-28	1932-05-12	1	-13748
73958	5056	1125315	1967-04-25	1967-05-02	1	-975
22127	1508	1112807	1943-01-12	1943-01-26	1	-9837
48369	3287	1343916	1967-07-10	1967-07-10	1	-906
67192	4587	1759842	2012-07-18	2012-08-08	1	15560
25432	1724	1119510	2015-01-23	2015-01-30	1	16465
72844	4977	1741122	2010-12-08	2010-12-08	1	14951
19618	1338	1728416	1947-04-19	1947-05-03	1	-8279
71049	4852	933724	1993-11-30	1993-12-07	1	8741
18702	1283	1729720	1975-10-09	1975-10-19	1	2117
67264	4593	1119510	1984-06-09	1984-06-23	1	5287
19648	1340	1125315	1986-09-09	1986-09-23	1	6109
17608	1216	1759842	1997-04-12	1997-04-19	1	9970
68245	4657	1125315	2010-07-15	2010-07-29	1	14819
27309	1845	1125315	1972-04-22	1972-05-06	1	856
71820	4907	1125315	1951-02-21	1951-03-07	1	-6875
19392	1323	1125315	2011-08-23	2011-09-06	1	15223
66940	4569	1125315	1999-02-02	1999-02-16	1	10638
17871	1231	1125315	1977-02-04	1977-02-18	1	2605
55492	3776	1125315	2010-11-27	2010-11-27	1	14940
69597	4749	1713332	1994-04-08	1994-04-22	1	8877
26077	1764	1759842	1961-06-30	1961-07-07	1	-3100
29293	1982	1322184	1997-11-27	2006-10-19	1	13440
51420	3505	1112807	1942-12-06	1942-12-20	1	-9874
19099	1310	1125315	1954-07-27	1954-08-10	1	-5623
62440	4261	1119510	1998-11-12	1998-11-19	1	10549
22067	1504	933724	2003-07-08	2003-07-15	1	12248
58569	3993	1124957	1974-07-03	1974-07-03	1	1644
19433	1325	1125315	2011-10-17	2012-01-15	1	15354
66158	4521	1322184	1997-05-22	1997-05-22	1	10003
20822	1418	19127890	1992-07-29	1993-03-08	1	8467
65423	4472	1119510	1960-09-16	1960-09-30	1	-3380
75459	5165	933724	1989-12-31	1990-01-07	1	7311
25573	1736	920293	1990-12-03	1990-12-10	1	7648
63075	4309	1112807	1967-10-25	1967-11-22	1	-771
20238	1379	1112807	1969-08-15	1969-08-29	1	-125
23847	1612	1125315	1965-09-19	1965-09-26	1	-1558
65305	4462	1149380	1999-04-01	1999-04-01	1	10682
56785	3869	1125315	1981-11-11	1981-11-25	1	4346
32635	2210	1177480	2014-12-22	2015-01-05	1	16440
21280	1448	1118084	2009-03-09	2009-03-09	1	14312
71220	4860	1759842	1986-08-26	1986-09-16	1	6102
12548	863	1112807	1923-01-24	1923-02-07	1	-17130
62242	4247	1125315	1991-08-04	1991-08-25	1	7906
48284	3280	1713332	1971-07-04	1971-07-18	1	563
66265	4526	1759842	1995-03-01	1995-03-15	1	9204
27295	1844	1729720	2009-04-21	2009-04-29	1	14363
25084	1699	1112807	1982-04-09	1982-05-07	1	4509
74678	5108	1112807	1967-08-20	1967-09-17	1	-837
21506	1464	1125315	1996-03-31	1996-04-07	1	9593
67503	4608	1125315	1987-10-15	1987-10-15	1	6496
19464	1328	1125315	1953-04-15	1953-05-13	1	-6077
33115	2242	1125315	1976-02-23	1976-03-08	1	2258
21161	1442	1115008	2004-12-18	2005-02-16	1	12830
30208	2041	1119510	1974-06-13	1974-06-27	1	1638
68277	4660	1759842	1964-03-24	1964-04-07	1	-2095
28942	1960	1112807	1934-12-31	1935-01-14	1	-12771
73959	5056	1174888	1950-09-03	1950-09-03	1	-7060
22128	1508	1112807	1949-02-23	1949-05-24	1	-7527
48370	3287	1713332	1971-06-07	1971-08-30	1	606
67193	4587	757627	2015-01-31	2015-01-31	1	16466
25433	1724	1124300	1992-11-15	1992-11-15	1	8354
72845	4977	782043	2010-12-08	2010-12-08	1	14951
19619	1338	1729720	1959-02-03	1959-02-15	1	-3973
71050	4852	1124957	1967-03-26	1967-03-26	1	-1012
18703	1283	19003953	1972-04-22	1972-04-22	1	842
67265	4593	1125315	1977-02-01	1977-02-15	1	2602
19649	1340	1713332	1914-10-31	1914-11-14	1	-20137
17609	1216	1125315	1993-11-20	1993-12-25	1	8759
68246	4657	1521369	1974-10-04	1975-09-29	1	2097
27310	1845	1125315	1996-04-15	1996-04-29	1	9615
71821	4907	1177480	1983-07-02	1983-08-06	1	4965
19393	1323	738818	1984-03-08	1984-03-15	1	5187
66941	4569	1713332	1971-01-14	1971-01-21	1	385
17872	1231	1125315	1992-07-26	1992-08-16	1	8263
55493	3776	19127890	1988-05-24	1989-05-19	1	7078
69598	4749	1713332	2011-07-22	2011-07-29	1	15184
26078	1764	738818	1981-09-24	1981-10-08	1	4298
29294	1982	1713332	1925-01-01	1925-01-22	1	-16415
51421	3505	1125315	1992-09-28	1992-10-05	1	8313
19100	1310	1125315	1959-07-17	1959-07-24	1	-3814
62441	4261	1125315	1998-03-14	1998-03-21	1	10306
22068	1504	1112807	1942-06-05	1942-06-19	1	-10058
58570	3993	1759842	1987-12-09	1987-12-23	1	6565
19434	1325	1713332	1987-11-09	1987-11-23	1	6535
66159	4521	1557272	2008-11-13	2008-11-13	1	14196
22541	1532	1515774	1992-09-19	1994-09-09	2	9017
65424	4472	1125315	2005-11-13	2006-01-12	1	13160
75460	5165	1115008	2011-09-16	2011-10-21	1	15268
25574	1736	933724	1985-06-17	1985-06-24	1	5653
63076	4309	1119510	1963-01-20	1963-02-03	1	-2524
20239	1379	1112807	1970-07-25	1970-08-24	1	235
23848	1612	1149380	1966-08-06	1982-12-14	1	4730
65306	4462	1503184	1978-12-09	1979-12-04	1	3624
56786	3869	1343916	1926-10-09	1926-10-09	1	-15790
32636	2210	1713332	1948-03-28	1948-04-04	1	-7942
21281	1448	1125315	1976-01-12	1976-01-26	1	2216
71221	4860	1124300	2011-10-11	2011-10-11	1	15258
12549	863	1322184	1997-05-01	2004-09-30	1	12691
62243	4247	1125315	1994-01-21	1994-01-28	1	8793
48285	3280	1713332	2001-05-12	2001-05-26	1	11468
69658	4754	1119510	2016-06-28	2016-07-05	1	16987
27296	1844	1125315	1996-02-08	1996-02-22	1	9548
25085	1699	1125315	1973-02-26	1973-03-12	1	1166
74679	5108	1119510	1999-01-28	1999-02-11	1	10633
21507	1464	1713332	2004-09-05	2004-09-12	1	12673
67504	4608	1125315	1992-05-15	1992-08-19	2	8237
19465	1328	1177480	1980-12-31	1981-02-04	1	4052
33116	2242	1125315	2001-08-02	2001-08-09	1	11543
21162	1442	1125315	1963-01-25	1963-02-01	1	-2526
30209	2041	1361711	1998-09-01	1998-09-01	1	10470
68472	4674	1124300	2005-04-28	2005-04-28	1	12901
28943	1960	1112807	1936-02-07	1936-03-13	1	-12347
73960	5056	1322184	2003-05-22	2003-05-22	1	12194
22129	1508	1118084	1963-12-07	1963-12-07	1	-2217
48371	3287	1759842	2012-05-24	2012-06-14	1	15505
67194	4587	1102527	1960-04-08	1960-04-08	1	-3555
25434	1724	1125315	1950-05-12	1950-05-19	1	-7167
72846	4977	1000560	2010-12-07	2010-12-08	2	14950
19620	1338	1759842	2002-02-24	2002-03-10	1	11756
71051	4852	1125315	1956-12-28	1957-01-11	1	-4738
20512	1397	1115008	1998-01-12	1998-01-26	1	10252
67266	4593	1713332	1985-01-16	1985-02-06	1	5515
19650	1340	1713332	1931-03-28	1931-04-18	1	-14138
17610	1216	19127890	1987-07-05	1989-06-24	2	7114
68247	4657	738818	1993-05-05	1993-05-19	1	8539
27311	1845	1125315	2006-02-07	2006-02-21	1	13200
71822	4907	1119510	1949-09-16	1949-09-30	1	-7398
19394	1323	1124300	2005-02-09	2005-02-09	1	12823
69388	4735	1115008	1998-06-22	1998-07-22	1	10429
17873	1231	1713332	1968-08-05	1968-08-19	1	-500
55494	3776	1115008	1994-12-30	1995-01-13	1	9143
69599	4749	1759842	2011-07-22	2011-07-29	1	15184
26079	1764	1112807	1959-11-02	1959-11-16	1	-3699
29295	1982	1713332	1963-12-05	1963-12-12	1	-2212
51422	3505	1124300	1975-11-13	1975-11-13	1	2142
19101	1310	1713332	1987-09-30	1987-10-14	1	6495
62442	4261	1310149	2010-01-24	2010-01-24	1	14633
22069	1504	1124957	1957-04-01	1957-04-01	1	-4658
62666	4279	738818	1970-10-20	1970-11-03	1	306
20108	1371	1729720	2008-11-13	2008-11-21	1	14204
66160	4521	1713332	1950-06-28	1950-07-12	1	-7113
22542	1532	738818	2010-04-06	2010-04-20	1	14719
65425	4472	1125315	2015-10-03	2015-10-03	1	16711
75461	5165	1119510	1970-09-09	1970-09-16	1	258
25575	1736	933724	1989-10-20	1989-11-03	1	7246
63077	4309	1125315	1981-08-05	1981-08-12	1	4241
20240	1379	1119510	2000-07-23	2000-08-06	1	11175
23849	1612	1759842	1980-11-28	1980-12-12	1	3998
65307	4462	1728416	1955-12-30	1956-01-13	1	-5102
59854	4081	1125315	1988-10-25	1988-11-01	1	6879
32637	2210	738818	2016-05-10	2016-05-24	1	16945
21282	1448	1125315	1977-11-23	1978-01-15	2	2911
71222	4860	1125315	1995-08-01	1995-08-31	2	9373
12550	863	1361711	1961-08-24	1961-08-24	1	-3052
62244	4247	1713332	1987-05-18	1987-06-01	1	6360
48286	3280	1112807	1952-10-07	1952-11-04	1	-6267
69659	4754	1125315	1971-08-12	1971-08-26	1	602
27297	1844	1759842	1977-09-26	1977-10-31	1	2860
25086	1699	1125315	1991-06-20	1991-07-04	1	7854
74680	5108	1125315	2002-11-14	2002-11-28	1	12019
21508	1464	1112807	1970-11-04	1970-11-25	1	328
67505	4608	1125315	2010-07-14	2010-10-12	1	14894
19466	1328	1729720	1973-04-11	1973-04-23	1	1208
33117	2242	1347450	2013-12-21	2013-12-21	1	16060
21163	1442	1125315	1973-04-09	1973-04-16	1	1201
31522	2133	1112807	1970-09-09	1970-09-23	1	265
68473	4674	1125315	2017-06-28	2017-06-28	1	17345
28944	1960	1125315	1955-09-27	1955-10-11	1	-5196
73961	5056	1759842	1952-09-02	1952-09-23	1	-6309
22130	1508	1125315	1967-05-20	1967-06-10	1	-936
48372	3287	914335	1967-07-10	1967-07-10	1	-906
67195	4587	1125315	1960-04-01	1960-06-07	1	-3495
25435	1724	1125315	1958-06-08	1958-06-22	1	-4211
72847	4977	1118084	1997-11-23	1997-11-23	1	10188
19621	1338	1112807	1948-04-08	1948-04-22	1	-7924
71052	4852	1125315	1967-10-29	1967-11-11	1	-782
20513	1397	1500211	1994-10-26	1995-10-21	1	9424
67267	4593	1717327	1966-05-18	1966-06-01	1	-1310
19651	1340	1759842	1914-10-31	1914-11-14	1	-20137
17611	1216	1125315	2005-12-18	2005-12-25	1	13142
68248	4657	920293	1987-11-04	1987-11-11	1	6523
27312	1845	1125315	2019-02-06	2019-02-13	1	17940
71823	4907	1119510	1982-04-28	1982-05-05	1	4507
19395	1323	1125315	1984-03-08	1984-03-15	1	5187
69389	4735	1118084	2012-04-14	2012-04-14	1	15444
22328	1520	738818	1952-01-08	1952-01-22	1	-6554
55495	3776	1174888	2010-11-27	2010-11-27	1	14940
71174	4859	738818	1963-10-17	1963-10-31	1	-2254
26080	1764	1119510	1992-12-22	1992-12-29	1	8398
29296	1982	1713332	1987-09-29	1987-10-20	1	6501
51423	3505	1125315	1946-02-20	1946-02-27	1	-8709
19102	1310	1759842	1951-03-10	1951-03-17	1	-6865
62443	4261	1729720	1928-08-10	1928-08-17	1	-15112
22070	1504	1125315	1993-12-05	1993-12-12	1	8746
62667	4279	1102527	1966-11-14	1966-11-14	1	-1144
20109	1371	1125315	1991-08-01	1991-08-01	1	7882
66161	4521	1713332	1961-06-23	1961-07-14	1	-3093
22543	1532	1112807	1986-04-14	1986-07-13	1	6037
65426	4472	1332418	2010-04-24	2010-04-24	1	14723
75462	5165	1125315	1974-12-26	1975-01-02	1	1827
25576	1736	933724	1990-12-03	1990-12-10	1	7648
63078	4309	1713332	1961-07-03	1961-07-24	1	-3083
20241	1379	1125315	1973-02-06	1973-02-13	1	1139
23850	1612	1759842	1997-02-06	1997-02-13	1	9905
65308	4462	1728416	1956-09-09	1956-09-23	1	-4848
59855	4081	1322184	2016-10-31	2016-10-31	1	17105
32638	2210	1112807	1937-09-20	1937-10-04	1	-11777
21283	1448	1515774	1989-03-14	1990-03-09	1	7372
71223	4860	1503184	1997-08-30	1998-08-25	1	10463
12551	863	1713332	1963-04-07	1963-04-21	1	-2447
62245	4247	1102527	2013-08-20	2013-08-20	1	15937
48287	3280	1112807	1954-09-25	1954-10-25	1	-5547
69660	4754	1125315	1981-02-23	1981-03-16	1	4092
27298	1844	1125315	1977-07-15	1977-09-13	1	2812
25087	1699	1729720	1969-10-18	1969-10-29	1	-64
74681	5108	1118084	2002-05-28	2002-05-28	1	11835
21509	1464	1125315	1963-02-15	1963-02-22	1	-2505
67506	4608	1713332	2008-09-25	2008-10-02	1	14154
19467	1328	1729720	1993-02-22	1993-03-06	1	8465
35952	2443	1118084	1999-04-09	1999-04-09	1	10690
21164	1442	920293	1974-03-11	1974-03-18	1	1537
31523	2133	1118084	2003-08-17	2003-08-17	1	12281
68474	4674	1177480	2017-06-28	2017-08-27	1	17405
28945	1960	1125315	1983-10-04	1983-10-11	1	5031
73962	5056	1115008	2013-09-30	2013-10-14	1	15992
22131	1508	1125315	1967-09-13	1967-09-27	1	-827
48373	3287	1125315	1966-12-10	1966-12-31	1	-1097
67196	4587	1125315	2003-07-02	2003-07-16	1	12249
25436	1724	1713332	1979-09-26	1979-10-17	1	3576
72848	4977	1125315	2013-11-09	2013-12-14	1	16053
19622	1338	1119510	1992-05-24	1992-05-31	1	8186
71053	4852	1125315	1986-06-09	1986-06-23	1	6017
20514	1397	1503184	1990-11-16	1991-11-11	1	7984
67268	4593	1729720	1975-09-11	1975-09-21	1	2089
19652	1340	1759842	1931-03-28	1931-04-18	1	-14138
17612	1216	1137529	2015-01-13	2015-01-13	1	16448
68249	4657	933724	1987-11-04	1987-11-11	1	6523
27313	1845	1717327	1964-08-31	1964-09-14	1	-1935
71824	4907	1125315	1959-10-28	1959-11-04	1	-3711
19396	1323	1717327	1962-03-02	1962-03-16	1	-2848
69390	4735	1125315	1982-04-17	1982-07-16	1	4579
22329	1520	1118084	1971-01-11	1971-01-11	1	375
55496	3776	1503184	1988-05-24	1989-05-19	1	7078
71175	4859	1118084	1993-11-01	1993-11-01	1	8705
26081	1764	1125315	1981-09-24	1981-10-08	1	4298
29297	1982	1759842	1925-01-01	1925-01-22	1	-16415
51424	3505	1125315	1970-07-12	1970-08-16	1	227
19103	1310	1759842	1972-09-14	1972-09-28	1	1001
62444	4261	1729720	1995-11-03	1995-11-15	1	9449
22071	1504	1713332	1989-03-01	1989-03-08	1	7006
62668	4279	1124300	1987-08-16	1987-08-16	1	6436
20110	1371	1125315	2015-09-29	2015-10-13	1	16721
66162	4521	1729720	1991-01-17	1991-01-24	1	7693
22544	1532	1124300	2014-03-13	2014-03-13	1	16142
65427	4472	1361711	2010-04-24	2015-10-03	1	16711
75463	5165	1729720	1969-05-31	1969-06-09	1	-206
25577	1736	1119510	1999-06-20	1999-07-04	1	10776
63079	4309	1713332	1968-05-27	1968-06-03	1	-577
20242	1379	1125315	1979-04-04	1979-04-18	1	3394
25844	1750	1118084	2002-08-24	2002-08-24	1	11923
65309	4462	1115008	2006-12-23	2007-01-20	1	13533
59856	4081	1332418	2016-10-31	2016-10-31	1	17105
32639	2210	1125315	1975-03-17	1975-04-21	1	1936
21284	1448	1521369	1987-03-25	1988-03-19	1	6652
71224	4860	1549786	1996-09-04	1997-08-30	1	10103
12552	863	738818	1932-07-23	1932-07-30	1	-13669
62246	4247	1115008	2013-08-20	2013-09-10	1	15958
48288	3280	1125315	1957-03-15	1957-03-29	1	-4661
69661	4754	1125315	1991-06-22	1991-07-27	1	7877
27299	1844	1177480	1986-07-28	1986-08-11	1	6066
25088	1699	1759842	2000-12-23	2000-12-30	1	11321
74682	5108	1717327	1961-06-22	1961-07-06	1	-3101
21510	1464	1713332	1982-08-08	1982-08-29	1	4623
67507	4608	1759842	1977-07-13	1977-07-27	1	2764
19468	1328	1759842	1967-06-25	1967-07-09	1	-907
35953	2443	1119510	1994-11-08	1994-11-15	1	9084
21165	1442	933724	1974-03-11	1974-03-18	1	1537
31524	2133	1125315	1996-11-28	1996-11-28	1	9828
68475	4674	1112807	1971-09-04	1971-10-02	1	639
28946	1960	1713332	1939-03-10	1939-03-17	1	-11248
73963	5056	1119510	2004-02-12	2004-02-19	1	12467
22132	1508	1174888	1949-02-23	1949-02-23	1	-7617
48374	3287	1174888	1988-11-12	1988-11-12	1	6890
67197	4587	1118084	1968-04-24	1968-04-24	1	-617
25437	1724	1728416	1954-11-15	1954-11-29	1	-5512
72849	4977	1521369	1975-12-04	1976-11-28	1	2523
19623	1338	1125315	2004-10-22	2004-10-29	1	12720
71054	4852	1717327	1969-05-15	1969-06-12	1	-203
20515	1397	1589505	1992-11-05	1993-10-31	1	8704
67269	4593	1759842	1996-10-08	1996-10-22	1	9791
19653	1340	920293	1948-08-17	1948-08-24	1	-7800
17613	1216	1713332	1997-04-12	1997-04-19	1	9970
68250	4657	1112807	1969-03-24	1969-04-23	1	-253
27314	1845	738818	2006-02-07	2006-02-21	1	13200
71825	4907	1557272	2016-05-14	2016-05-14	1	16935
19397	1323	1729720	1971-05-18	1971-05-28	1	512
69391	4735	914335	1983-06-16	1983-06-16	1	4914
22330	1520	1119510	1963-05-04	1963-05-11	1	-2427
55497	3776	1115008	2017-03-25	2017-04-15	1	17271
71176	4859	1125315	1980-03-14	1980-03-21	1	3732
26082	1764	1713332	1961-06-30	1961-07-07	1	-3100
29298	1982	1759842	1960-12-06	1960-12-13	1	-3306
51425	3505	1729720	2000-02-08	2000-02-18	1	11005
19104	1310	1125315	1953-04-07	1953-04-14	1	-6106
62445	4261	1759842	1977-10-30	1977-11-06	1	2866
22072	1504	1759842	1942-02-11	1942-02-25	1	-10172
62669	4279	1125315	1976-03-08	1976-03-22	1	2272
20111	1371	1177480	1991-08-01	1991-08-31	1	7912
66163	4521	1759842	1922-01-19	1922-02-09	1	-17493
22545	1532	1177480	1981-01-01	1981-01-15	1	4032
65428	4472	1759842	1969-03-16	1969-03-23	1	-284
75464	5165	1729720	1973-02-15	1973-02-27	1	1153
25578	1736	1125315	1999-06-20	1999-07-04	1	10776
63080	4309	1717327	1963-09-27	1963-10-11	1	-2274
20243	1379	1125315	1986-07-31	1986-09-04	1	6090
25845	1750	1125315	2001-05-22	2001-05-29	1	11471
65310	4462	1118084	1990-09-12	1990-09-12	1	7559
59857	4081	1759842	2013-11-18	2013-12-09	1	16048
32640	2210	1125315	2016-05-10	2016-05-24	1	16945
21285	1448	1713332	1982-04-19	1982-05-10	1	4512
71225	4860	1125315	1988-05-27	1988-06-03	1	6728
12553	863	1112807	1922-07-14	1922-07-28	1	-17324
62247	4247	1125315	1993-07-15	1993-08-05	1	8617
48289	3280	1149380	2017-12-14	2017-12-14	1	17514
69662	4754	1125315	1994-08-07	1994-08-21	1	8998
27300	1844	1729720	1962-11-18	1962-11-30	1	-2589
25089	1699	1115008	2005-07-26	2005-09-24	1	13050
21511	1464	1759842	1982-08-08	1982-08-29	1	4623
67508	4608	1759842	2008-09-25	2008-10-02	1	14154
19469	1328	933724	1999-08-07	1999-08-14	1	10817
35954	2443	1125315	1979-10-26	1979-12-24	2	3644
21166	1442	1125315	2017-06-13	2017-06-27	1	17344
31525	2133	1125315	2009-10-16	2009-10-23	1	14540
68476	4674	1125315	2001-05-31	2001-06-14	1	11487
28947	1960	1729720	1983-05-27	1983-06-06	1	4904
73964	5056	1125315	1989-10-05	1989-10-19	1	7231
22133	1508	1112807	1924-03-01	1924-03-15	1	-16728
48375	3287	1177480	1988-11-12	1988-12-12	1	6920
67198	4587	1177480	2004-04-17	2004-05-08	1	12546
25622	1738	1125315	1971-10-31	1971-11-16	2	684
72850	4977	1713332	1974-10-19	1974-10-26	1	1759
19624	1338	1728416	1948-04-08	1948-04-22	1	-7924
71055	4852	1729720	1966-10-12	1966-10-22	1	-1167
20516	1397	19127890	1993-10-31	1994-10-26	1	9064
67270	4593	19127890	1979-08-29	1980-08-23	1	3887
19654	1340	933724	1948-08-17	1948-08-24	1	-7800
20248	1381	1125315	2017-04-25	2017-05-02	1	17288
68251	4657	1124300	1999-02-15	1999-02-15	1	10637
27315	1845	1119510	1972-04-22	1972-05-06	1	856
71826	4907	1713332	2005-07-29	2005-08-05	1	13000
19398	1323	1759842	1970-07-14	1970-07-28	1	208
69392	4735	1102527	1998-06-22	1998-06-22	1	10399
22331	1520	1119510	1969-08-08	1969-08-15	1	-139
55498	3776	1177480	2010-11-20	2011-01-26	1	15000
71177	4859	1177480	2013-07-28	2013-08-18	1	15935
26083	1764	738818	1992-12-22	1992-12-29	1	8398
29299	1982	1759842	1987-09-29	1987-10-20	1	6501
51426	3505	1729720	2003-06-06	2003-06-16	1	12219
19105	1310	1125315	1968-02-03	1968-05-03	1	-608
62446	4261	738818	1998-11-12	1998-11-19	1	10549
22073	1504	1759842	1942-10-30	1942-11-06	1	-9918
62670	4279	1125315	1986-12-05	1986-12-12	1	6189
20112	1371	1503184	1989-03-19	1990-03-14	1	7377
66164	4521	1759842	1976-11-22	1976-11-29	1	2524
22546	1532	1177480	1983-04-23	1983-05-07	1	4874
65429	4472	738818	1940-05-18	1940-05-25	1	-10813
75465	5165	1729720	1977-02-07	1977-02-15	1	2602
25579	1736	1521369	1986-04-19	1987-04-14	1	6312
63081	4309	1717327	1970-11-30	1970-12-14	1	347
22466	1529	738818	2001-06-10	2001-06-24	1	11497
25846	1750	1177480	1995-04-23	1995-05-07	1	9257
65311	4462	1125315	1972-06-03	1972-06-24	1	905
59858	4081	1112807	1965-03-20	1965-04-19	1	-1718
32641	2210	1713332	1985-10-15	1985-10-29	1	5780
21286	1448	1759842	1982-04-19	1982-05-10	1	4512
71226	4860	1125315	2015-11-14	2015-11-21	1	16760
12554	863	1112807	1923-07-09	1923-07-23	1	-16964
62248	4247	1149380	1986-03-25	2002-12-28	1	12049
48290	3280	1177480	1991-05-17	1991-06-14	1	7834
69663	4754	1125315	1968-07-03	1968-07-17	1	-533
27301	1844	1729720	1976-11-29	1976-12-08	1	2533
25090	1699	1115008	2011-03-27	2011-04-10	1	15074
21512	1464	1118084	2002-08-13	2002-08-13	1	11912
67509	4608	920293	1990-01-12	1990-01-19	1	7323
19470	1328	1112807	1945-12-23	1946-01-06	1	-8761
35955	2443	1713332	1995-06-12	1995-09-25	1	9398
21167	1442	1177480	2012-09-07	2012-12-06	1	15680
31526	2133	1713332	1966-01-10	1966-01-31	1	-1431
68477	4674	1125315	2012-01-25	2012-02-08	1	15378
28948	1960	920293	1951-08-14	1951-08-21	1	-6708
73965	5056	1125315	2004-02-12	2004-02-19	1	12467
22134	1508	1112807	1925-01-03	1925-01-17	1	-16420
48376	3287	1713332	1981-04-12	1981-04-26	1	4133
67199	4587	1177480	2018-04-25	2018-06-24	1	17706
25623	1738	1125315	1980-11-12	1980-12-17	1	4003
72851	4977	1717327	1962-03-07	1962-03-21	1	-2843
19625	1338	1728416	1956-07-06	1956-07-20	1	-4913
71056	4852	933724	1994-02-06	1994-02-20	1	8816
20517	1397	19127890	1995-10-21	1997-10-10	2	10144
67271	4593	1124300	2007-05-19	2007-05-19	1	13652
19655	1340	1112807	1912-10-22	1912-11-05	1	-20876
20249	1381	1729720	2016-08-21	2016-09-02	1	17046
68252	4657	1125315	1961-08-03	1961-08-17	1	-3059
27316	1845	1125315	1979-01-31	1979-02-14	1	3331
71827	4907	1728416	1948-12-18	1949-01-01	1	-7670
24825	1677	1729720	1985-06-02	1985-06-10	1	5639
69393	4735	1177480	2014-05-29	2014-06-12	1	16233
22332	1520	1125315	1952-01-08	1952-01-22	1	-6554
55499	3776	1521369	1988-05-24	1989-05-19	1	7078
71178	4859	1713332	1967-10-19	1967-11-09	1	-784
26084	1764	1112807	1963-10-23	1963-11-06	1	-2248
29300	1982	1112807	1933-11-20	1933-12-20	1	-13161
51427	3505	1102527	1970-07-12	1970-07-12	1	192
19106	1310	1713332	1951-03-10	1951-03-17	1	-6865
62447	4261	1125315	1929-09-02	1929-09-09	1	-14724
22074	1504	1759842	1989-03-01	1989-03-08	1	7006
62671	4279	1177480	2018-03-16	2018-05-15	1	17666
20113	1371	1728416	1972-07-06	1972-07-20	1	931
66165	4521	715997	2000-06-08	2000-06-08	1	11116
22547	1532	1521369	1998-08-19	1999-08-14	1	10817
65430	4472	1112807	1955-09-25	1955-10-16	1	-5191
25580	1736	1521369	1988-04-08	1989-04-03	1	7032
63082	4309	1728416	1954-12-02	1954-12-16	1	-5495
22467	1529	1112807	1966-04-25	1966-05-09	1	-1333
25847	1750	1115008	1996-04-01	1996-04-15	1	9601
65312	4462	1125315	1978-09-02	1978-09-16	1	3180
59859	4081	1539403	2016-10-31	2016-10-31	1	17105
32642	2210	1729720	1978-12-26	1979-01-06	1	3292
21287	1448	19127890	1994-02-16	1995-02-11	1	9172
71227	4860	1549786	1992-09-25	1993-09-20	1	8663
12555	863	1124300	1964-10-26	1964-10-26	1	-1893
62249	4247	1177480	1983-05-18	1983-06-01	1	4899
48291	3280	1557272	2011-11-10	2011-11-10	1	15288
69664	4754	1125315	1991-09-13	1991-09-20	1	7932
27302	1844	1154343	1963-04-13	1963-04-13	1	-2455
25091	1699	1125315	2004-06-10	2004-07-01	1	12600
21513	1464	1125315	2018-11-09	2018-11-16	1	17851
67510	4608	933724	1990-01-12	1990-01-19	1	7323
19471	1328	1112807	1947-08-29	1947-09-12	1	-8147
35956	2443	1729720	1962-12-25	1963-01-04	1	-2554
21168	1442	1118084	1980-12-18	1980-12-18	1	4004
31527	2133	1174888	1996-11-28	1996-11-28	1	9828
68478	4674	1713332	2014-01-10	2014-01-17	1	16087
28949	1960	920293	1954-09-22	1954-09-29	1	-5573
73966	5056	1125315	2005-10-12	2006-01-10	1	13158
22135	1508	1112807	1928-03-24	1928-04-07	1	-15244
48377	3287	1713332	1996-12-20	1997-01-10	1	9871
67200	4587	1361711	2003-07-12	2003-07-12	1	12245
25624	1738	1125315	1986-07-15	1986-07-29	1	6053
72852	4977	753626	2010-12-08	2010-12-08	1	14951
19626	1338	1729720	1946-10-25	1946-11-06	1	-8457
71057	4852	933724	1995-04-06	1995-04-20	1	9240
20518	1397	738818	2008-12-18	2008-12-25	1	14238
67272	4593	1177480	1978-09-21	1978-10-12	1	3206
19656	1340	1112807	1926-12-08	1926-12-22	1	-15716
20250	1381	1713332	2001-12-16	2001-12-30	1	11686
68253	4657	1125315	1993-05-05	1993-05-19	1	8539
29032	1967	1112807	1956-09-07	1956-11-06	1	-4804
71828	4907	1729720	1992-09-14	1992-09-24	1	8302
24826	1677	1112807	1971-03-17	1971-03-31	1	454
69394	4735	1309944	1983-06-16	1983-06-16	1	4914
22333	1520	1729720	1982-08-31	1982-09-10	1	4635
56639	3859	1112807	1923-05-14	1923-05-28	1	-17020
71179	4859	1759842	1983-06-25	1983-07-02	1	4930
26085	1764	1115008	2000-09-09	2000-10-14	1	11244
29301	1982	1112807	1987-05-05	1987-06-09	1	6368
51428	3505	1125315	1970-02-10	1970-02-24	1	54
19107	1310	1713332	1972-09-14	1972-09-28	1	1001
62448	4261	1125315	1998-11-12	1998-11-19	1	10549
22075	1504	1125315	1954-05-03	1954-05-17	1	-5708
62672	4279	1713332	1980-10-25	1980-11-08	1	3964
20114	1371	1729720	2009-05-22	2009-05-29	1	14393
66166	4521	1112807	1924-04-02	1924-07-01	1	-16620
22548	1532	1713332	1980-08-13	1980-08-27	1	3891
65431	4472	1125315	1940-05-18	1940-05-25	1	-10813
25581	1736	1118084	2010-01-13	2010-01-13	1	14622
63083	4309	1759842	1996-03-11	1996-03-18	1	9573
22468	1529	1119510	2001-06-10	2001-06-24	1	11497
25848	1750	1102527	2012-09-09	2012-09-09	1	15592
65313	4462	1713332	1965-08-14	1965-09-04	1	-1580
59860	4081	1124300	1999-04-21	1999-04-21	1	10702
32643	2210	1729720	2016-06-21	2016-07-03	1	16985
21288	1448	1500211	1997-01-31	1998-01-26	1	10252
71228	4860	1738521	1979-10-24	1979-11-07	1	3597
12556	863	1125315	1932-07-23	1932-07-30	1	-13669
63244	4321	1125315	1968-09-30	1968-10-07	1	-451
48292	3280	1728416	1957-03-15	1957-03-29	1	-4661
69665	4754	1713332	2012-09-04	2012-09-11	1	15594
27303	1844	1177480	1976-06-06	1976-06-20	1	2362
25092	1699	1177480	1979-01-25	1979-04-25	1	3401
21514	1464	1713332	1986-02-18	1986-03-11	1	5913
67511	4608	1125315	1977-07-04	1977-07-18	1	2755
19472	1328	1112807	1948-04-11	1948-07-10	1	-7845
35957	2443	1729720	1975-06-04	1975-06-17	1	1993
21169	1442	1125315	2005-03-11	2005-03-18	1	12860
31528	2133	1177480	1996-11-21	1996-12-28	1	9858
68479	4674	1759842	2014-01-10	2014-01-17	1	16087
28950	1960	920293	1955-11-13	1955-11-20	1	-5156
73967	5056	1347450	2003-05-22	2003-05-22	1	12194
22136	1508	1125315	1949-02-23	1949-02-23	1	-7617
48378	3287	1759842	1981-04-12	1981-04-26	1	4133
67201	4587	1713332	2012-07-18	2012-08-08	1	15560
25625	1738	1125315	2006-03-19	2006-04-02	1	13240
72853	4977	1110410	2010-12-07	2010-12-08	1	14951
19908	1356	738818	1988-11-04	1988-11-11	1	6889
71058	4852	1118084	1990-09-17	1990-09-17	1	7564
20519	1397	1124300	2016-08-26	2016-08-26	1	17039
67273	4593	1713332	1992-05-06	1992-05-27	1	8182
19657	1340	1125315	1919-05-01	1919-05-15	1	-18494
20251	1381	1118084	2018-11-10	2018-11-10	1	17845
68254	4657	1125315	1995-06-13	1995-06-13	1	9294
29033	1967	1125315	1969-01-02	1969-01-16	1	-350
71829	4907	1112807	1964-06-27	1964-07-11	1	-2000
24827	1677	1112807	1970-05-08	1970-05-22	1	141
69395	4735	1343916	1983-06-16	1983-06-16	1	4914
22334	1520	1125315	1963-06-28	1963-07-26	1	-2351
56640	3859	1124300	1957-11-26	1957-11-26	1	-4419
71180	4859	19003953	1971-06-05	1971-06-05	1	520
26086	1764	1118084	1996-12-12	1996-12-12	1	9842
29302	1982	1115008	1997-02-07	1997-05-08	1	9989
51429	3505	1125315	1993-02-16	1993-03-09	1	8468
19108	1310	1112807	1944-01-10	1944-03-10	1	-9428
63668	4352	738818	2018-08-14	2018-08-21	1	17764
22076	1504	1713332	1942-02-11	1942-02-25	1	-10172
62673	4279	1729720	1954-01-20	1954-01-30	1	-5815
20115	1371	19127890	1989-03-19	1990-03-14	1	7377
66167	4521	1124300	1958-10-11	1958-10-11	1	-4100
22549	1532	1713332	1983-04-23	1983-05-07	1	4874
65432	4472	1125315	1967-03-12	1967-03-19	1	-1019
25582	1736	1125315	1970-09-01	1970-09-08	1	250
63084	4309	738818	1963-01-20	1963-02-03	1	-2524
22469	1529	1125315	1993-02-24	1993-03-31	1	8490
25849	1750	1125315	1974-01-13	1974-04-13	1	1563
65314	4462	1125315	1997-05-20	1997-06-03	1	10015
59861	4081	1125315	2007-08-07	2007-09-11	1	13767
32644	2210	1759842	1948-03-28	1948-04-04	1	-7942
21289	1448	1503184	1990-03-09	1991-03-04	1	7732
71229	4860	19127890	1992-09-25	1993-09-20	1	8663
12557	863	1125315	1985-03-23	1985-04-13	1	5581
63245	4321	1713332	2015-08-23	2015-09-13	1	16691
48293	3280	1759842	1971-07-04	1971-07-18	1	563
69666	4754	1729720	1972-03-13	1972-03-25	1	814
27304	1844	1729720	1979-10-27	1979-11-06	1	3596
25093	1699	1713332	1998-06-10	1998-07-01	1	10408
21515	1464	1729720	2016-07-26	2016-08-04	1	17017
67512	4608	1149380	1992-01-30	1992-01-30	1	8064
19473	1328	1112807	1969-04-19	1969-05-03	1	-243
35958	2443	1759842	1965-09-12	1965-09-19	1	-1565
21170	1442	1125315	2006-08-23	2006-08-30	1	13390
31529	2133	1717327	1970-09-09	1970-09-23	1	265
68480	4674	19127890	1983-08-12	1984-08-06	1	5331
28951	1960	933724	1954-09-22	1954-09-29	1	-5573
73968	5056	701322	2013-12-16	2013-12-16	1	16055
22137	1508	1713332	1990-03-05	1990-03-12	1	7375
48379	3287	1759842	1996-12-20	1997-01-10	1	9871
67202	4587	1759842	1945-05-20	1945-05-27	1	-8985
25626	1738	1521369	1986-04-25	1987-04-20	1	6318
72854	4977	1125315	1962-03-07	1962-03-21	1	-2843
19909	1356	1118084	2016-09-11	2016-09-11	1	17055
71059	4852	1119510	1977-07-25	1977-08-08	1	2776
20520	1397	1125315	1989-02-15	1989-03-01	1	6999
67274	4593	1717327	1965-11-29	1965-12-13	1	-1480
19658	1340	1125315	1985-09-30	1985-10-28	1	5779
20252	1381	1125315	1982-07-12	1982-07-26	1	4589
68255	4657	1503184	1974-10-04	1975-09-29	1	2097
29034	1967	1125315	2016-03-17	2016-03-31	1	16891
71830	4907	1125315	1982-04-28	1982-05-05	1	4507
24828	1677	1115008	2018-08-08	2018-08-22	1	17765
69396	4735	1729720	1985-08-01	1985-08-09	1	5699
22335	1520	1125315	2002-09-22	2003-01-27	3	12049
56641	3859	1310149	2016-04-16	2016-04-16	1	16907
71181	4859	708298	1971-06-05	1971-06-05	1	520
26087	1764	1119510	1981-09-24	1981-10-08	1	4298
29303	1982	1125315	1960-07-08	1960-07-29	1	-3443
51430	3505	1125315	2018-04-28	2018-05-12	1	17663
19109	1310	1118084	1980-07-09	1980-07-09	1	3842
63669	4352	1112807	1949-08-05	1949-08-19	1	-7440
22077	1504	1713332	1942-10-30	1942-11-06	1	-9918
62674	4279	1729720	2007-03-03	2007-03-16	1	13588
20116	1371	1112807	1972-02-07	1972-03-13	1	802
66168	4521	1125315	1996-12-15	1997-02-13	1	9905
22550	1532	1713332	2004-10-11	2004-10-25	1	12716
65433	4472	1322184	2010-04-24	2015-10-03	1	16711
25583	1736	1125315	2011-10-24	2011-11-07	1	15285
63085	4309	1115008	1994-08-02	1994-09-06	1	9014
22470	1529	1125315	2001-06-10	2001-06-24	1	11497
25850	1750	1177480	2010-10-29	2010-11-19	1	14932
65315	4462	1137529	1999-04-01	1999-04-01	1	10682
59862	4081	1713332	2013-11-18	2013-12-09	1	16048
32645	2210	1125315	1943-03-25	1943-04-01	1	-9772
21290	1448	1503184	1992-02-27	1993-02-21	1	8452
71230	4860	19127890	1996-09-04	1998-08-25	2	10463
12558	863	1125315	2018-02-10	2018-02-24	1	17586
63246	4321	1125315	1992-09-14	1992-10-05	1	8313
48294	3280	1125315	1974-02-15	1974-03-01	1	1520
69667	4754	1738521	1968-10-29	1968-11-12	1	-415
29011	1966	920293	1992-05-31	1992-06-07	1	8193
25094	1699	1759842	1998-06-10	1998-07-01	1	10408
21516	1464	1759842	1986-02-18	1986-03-11	1	5913
67513	4608	1551099	1967-02-11	1967-02-11	1	-1055
19474	1328	1137529	1983-12-08	1983-12-08	1	5089
35959	2443	1759842	1989-09-19	1989-10-03	1	7215
21171	1442	1713332	1995-01-17	1995-01-31	1	9161
31530	2133	1759842	1966-01-10	1966-01-31	1	-1431
68481	4674	1112807	1969-01-17	1969-01-31	1	-335
28952	1960	1119510	1955-09-27	1955-10-11	1	-5196
73969	5056	738818	1991-02-26	1991-03-05	1	7733
22138	1508	1713332	2004-04-26	2004-09-06	1	12667
48951	3332	1119510	1982-03-25	1982-04-01	1	4473
68659	4685	1125315	1957-12-10	1957-12-24	1	-4391
25627	1738	1713332	1976-09-09	1976-09-16	1	2450
72855	4977	1125315	1963-02-01	1963-02-15	1	-2512
19910	1356	1125315	1988-11-04	1988-11-11	1	6889
71060	4852	1125315	1950-08-12	1950-08-26	1	-7068
20521	1397	1515774	1993-10-31	1994-10-26	1	9064
67275	4593	1759842	1992-05-06	1992-05-27	1	8182
19659	1340	1713332	1912-12-29	1913-08-31	1	-20577
20253	1381	1125315	1983-12-04	1984-02-02	1	5145
68256	4657	1759842	1985-03-04	1985-03-18	1	5555
29035	1967	1129625	1958-11-02	1958-11-02	1	-4078
71831	4907	1713332	1974-07-14	1974-10-13	1	1746
24829	1677	1125315	1974-01-17	1974-01-31	1	1491
69397	4735	1738521	1973-11-30	1973-12-14	1	1443
22336	1520	738818	1963-05-04	1963-05-11	1	-2427
56642	3859	1759842	1954-02-05	1954-02-19	1	-5795
71182	4859	1102527	1971-06-10	1971-06-10	1	525
26088	1764	1125315	1960-01-09	1960-01-23	1	-3631
29304	1982	1125315	1993-03-09	1993-03-30	1	8489
51431	3505	1177480	2009-08-12	2009-11-10	1	14558
19110	1310	1125315	1987-09-30	1987-10-14	1	6495
63670	4352	1125315	1952-04-26	1952-05-10	1	-6445
22078	1504	1729720	1960-11-30	1960-12-12	1	-3307
62675	4279	1759842	1993-03-22	1993-03-29	1	8488
20117	1371	1125315	1972-07-06	1972-07-20	1	931
66169	4521	1332418	1994-02-10	1994-02-10	1	8806
22551	1532	1759842	2001-06-13	2001-06-20	1	11493
65434	4472	1713332	1969-03-16	1969-03-23	1	-284
25584	1736	1503184	1986-04-19	1987-04-14	1	6312
63086	4309	1118084	1994-01-16	1994-01-16	1	8781
22471	1529	1177480	2013-04-15	2013-05-20	1	15845
25851	1750	1728416	1968-08-12	1968-08-26	1	-493
65316	4462	1759842	1965-08-14	1965-09-04	1	-1580
59863	4081	1125315	1968-02-04	1968-02-11	1	-690
32646	2210	1125315	1958-06-02	1958-06-23	1	-4210
21291	1448	1549786	1994-02-16	1995-02-11	1	9172
73778	5045	738818	1985-02-08	1985-02-22	1	5531
12559	863	1310149	1981-01-29	1981-01-29	1	4046
63247	4321	1125315	1993-08-18	1993-09-01	1	8644
48295	3280	1125315	1982-12-02	1982-12-30	1	4746
69668	4754	1112807	1968-10-29	1968-11-12	1	-415
29012	1966	933724	1992-05-31	1992-06-07	1	8193
29952	2026	1102527	2016-05-04	2016-05-04	1	16925
21517	1464	1119510	1996-03-31	1996-04-07	1	9593
67514	4608	1713332	1977-07-13	1977-07-27	1	2764
19475	1328	1177480	1995-02-21	1995-03-07	1	9196
35960	2443	1778162	1992-08-18	1992-09-22	1	8300
21172	1442	1728416	1948-02-25	1948-03-10	1	-7967
32963	2233	1118084	2014-07-10	2014-07-10	1	16261
68482	4674	1112807	1973-07-23	1973-08-06	1	1313
28953	1960	1759842	1939-03-10	1939-03-17	1	-11248
73970	5056	738818	2000-09-14	2000-09-28	1	11228
23397	1588	738818	2010-09-03	2010-09-10	1	14862
48952	3332	1125315	1981-03-21	1981-04-11	1	4118
68660	4685	1112807	1940-04-01	1940-04-15	1	-10853
25628	1738	920293	2009-06-07	2009-06-14	1	14409
72856	4977	1177480	1980-06-01	1980-07-06	1	3839
19911	1356	1713332	1981-06-19	1981-07-03	1	4201
71061	4852	1125315	1951-10-17	1951-10-24	1	-6644
20522	1397	1515774	1995-10-21	1997-10-10	2	10144
67276	4593	738818	1984-06-09	1984-06-23	1	5287
19660	1340	1118084	1952-01-31	1952-01-31	1	-6545
20254	1381	1125315	1990-01-03	1990-01-10	1	7314
68257	4657	1759842	2005-10-09	2005-10-23	1	13079
29036	1967	1551099	1960-07-18	1960-07-18	1	-3454
71832	4907	1713332	1982-01-10	1982-03-07	1	4448
24830	1677	1118084	2003-04-20	2003-04-20	1	12162
69398	4735	1112807	1973-11-30	1973-12-14	1	1443
22337	1520	738818	1969-08-08	1969-08-15	1	-139
56643	3859	1125315	1926-12-25	1927-01-08	1	-15699
71183	4859	1110410	1971-06-05	1971-06-05	1	520
26089	1764	1125315	1978-11-01	1978-11-08	1	3233
29305	1982	1125315	2006-10-19	2006-10-19	1	13440
51432	3505	1713332	2004-02-17	2004-03-09	1	12486
19111	1310	1729720	1953-11-02	1953-11-11	1	-5895
63671	4352	1125315	2015-08-07	2015-08-28	1	16675
23711	1606	1112807	1953-12-12	1954-01-16	1	-5829
62676	4279	1125315	1964-01-24	1964-02-28	1	-2134
20118	1371	1177480	1999-06-20	1999-07-04	1	10776
66170	4521	1713332	1922-01-19	1922-02-09	1	-17493
22552	1532	1125315	1980-08-13	1980-08-27	1	3891
65435	4472	1729720	1938-10-26	1938-11-07	1	-11378
25585	1736	1503184	1988-04-08	1989-04-03	1	7032
63087	4309	1125315	1963-01-20	1963-02-03	1	-2524
22472	1529	1713332	2009-07-03	2009-07-24	1	14449
25852	1750	1125315	1968-08-12	1968-08-26	1	-493
65317	4462	19127890	1974-12-30	1975-12-25	1	2184
59864	4081	1361711	2016-10-31	2016-10-31	1	17105
32647	2210	1125315	2002-05-01	2002-05-15	1	11822
21292	1448	1729720	1981-05-19	1981-05-29	1	4166
73779	5045	1118084	1995-05-14	1995-05-14	1	9264
12560	863	1322184	2005-06-16	2014-07-03	1	16254
63248	4321	1125315	2002-10-05	2002-10-19	1	11979
48296	3280	1137529	2017-12-14	2017-12-14	1	17514
69669	4754	1759842	2012-09-04	2012-09-11	1	15594
29013	1966	1112807	1968-04-18	1968-05-02	1	-609
29953	2026	1759842	2016-03-07	2016-03-28	1	16888
21518	1464	1729720	1998-03-08	1998-03-20	1	10305
67515	4608	1759842	2015-11-19	2015-12-03	1	16772
19476	1328	1177480	2014-03-25	2014-04-15	1	16175
35961	2443	757627	2018-01-25	2018-01-25	1	17556
21173	1442	1759842	1995-01-17	1995-01-31	1	9161
32964	2233	1119510	2013-06-03	2013-06-10	1	15866
68483	4674	1125315	1984-03-11	1984-03-25	1	5197
28954	1960	701322	2004-04-05	2004-04-05	1	12513
73971	5056	757627	2012-08-23	2012-08-23	1	15575
23398	1588	1119510	2015-07-05	2015-07-12	1	16628
48953	3332	1174888	2014-06-15	2014-06-15	1	16236
68661	4685	1118084	1971-11-20	1971-11-20	1	688
25629	1738	1124300	2013-02-27	2013-02-27	1	15763
72857	4977	1367571	2010-12-07	2010-12-07	1	14950
19912	1356	975125	1995-02-07	1995-02-07	1	9168
71062	4852	1713332	1986-10-24	1986-10-30	1	6146
20523	1397	1521369	1990-11-16	1991-11-11	1	7984
67277	4593	1125315	1966-05-18	1966-06-01	1	-1310
19661	1340	1125315	1948-03-09	1948-03-23	1	-7954
20255	1381	1125315	1993-11-11	1994-02-09	1	8805
68258	4657	1713332	2001-09-08	2001-09-22	1	11587
29037	1967	1713332	1959-06-01	1959-06-15	1	-3853
71833	4907	1713332	1983-07-02	1983-08-06	1	4965
24831	1677	1728416	1971-03-17	1971-03-31	1	454
69399	4735	1115008	2011-01-15	2011-04-15	1	15079
22338	1520	738818	2002-09-22	2002-09-29	1	11959
56644	3859	1125315	1931-03-10	1931-03-24	1	-14163
71184	4859	1119510	1985-09-22	1985-10-06	1	5757
26090	1764	1125315	1992-12-22	1992-12-29	1	8398
29306	1982	1177480	2004-05-01	2004-07-30	1	12629
51433	3505	1738521	1970-07-12	1970-08-16	1	227
19112	1310	738818	1945-04-11	1945-04-18	1	-9024
63672	4352	1125315	2018-08-14	2018-08-21	1	17764
23712	1606	1112807	1962-04-04	1962-04-25	1	-2808
62677	4279	1125315	1980-12-23	1980-12-30	1	4016
20119	1371	1713332	1990-08-06	1990-08-20	1	7536
66171	4521	1119510	1972-12-10	1972-12-17	1	1081
22553	1532	1125315	2006-03-02	2006-03-16	1	13223
65436	4472	1119510	1940-05-18	1940-05-25	1	-10813
25586	1736	1759842	1980-08-13	1980-08-20	1	3884
63088	4309	1713332	1969-11-30	1969-12-07	1	-25
22473	1529	1728416	1968-02-07	1968-02-21	1	-680
25853	1750	1125315	2012-09-09	2012-10-14	1	15627
65318	4462	19127890	1978-12-09	1979-12-04	1	3624
61068	4165	738818	1960-10-22	1960-11-05	1	-3344
32648	2210	1713332	1950-08-28	1950-09-18	1	-7045
21293	1448	19127890	1987-03-25	1988-03-19	1	6652
73780	5045	1125315	1985-02-08	1985-02-22	1	5531
12561	863	1322184	2014-08-07	2014-08-07	1	16289
63249	4321	1713332	1984-04-06	1984-04-27	1	5230
48297	3280	1759842	1967-06-02	1967-06-16	1	-930
69670	4754	738818	2016-06-28	2016-07-05	1	16987
29014	1966	1112807	1984-05-08	1984-05-22	1	5255
29954	2026	920293	1975-04-05	1975-04-12	1	1927
21519	1464	1759842	2004-09-05	2004-09-12	1	12673
70902	4844	1125315	1960-02-21	1960-03-06	1	-3588
19477	1328	1322184	2019-06-13	2019-06-13	1	18060
35962	2443	1125315	1963-10-22	1963-10-28	1	-2257
21174	1442	1112807	1948-02-25	1948-03-10	1	-7967
32965	2233	1503184	1991-12-28	1992-12-22	1	8391
68484	4674	1503184	1983-08-12	1984-08-06	1	5331
28955	1960	738818	1983-10-04	1983-10-11	1	5031
73972	5056	1112807	1939-02-19	1939-03-05	1	-11260
23399	1588	1125315	1992-03-23	1992-04-06	1	8131
48954	3332	1713332	2006-11-23	2006-12-07	1	13489
68662	4685	1125315	1967-05-12	1967-05-19	1	-958
25630	1738	1177480	2014-12-19	2015-01-02	1	16437
72858	4977	1746114	2010-12-08	2010-12-08	1	14951
19913	1356	1119510	1988-11-04	1988-11-11	1	6889
71063	4852	1728416	1950-08-12	1950-08-26	1	-7068
20524	1397	1112807	1986-01-31	1986-02-14	1	5888
67278	4593	1125315	1971-05-03	1971-05-31	1	515
19857	1354	1119510	1980-06-26	1980-07-03	1	3836
20256	1381	1137529	2009-08-15	2009-08-15	1	14471
68259	4657	1729720	1973-01-02	1973-01-10	1	1105
29038	1967	1112807	1960-11-15	1960-11-29	1	-3320
71834	4907	1759842	1982-01-10	1982-03-07	1	4448
30703	2078	1115008	2014-01-13	2014-02-19	1	16120
69400	4735	1125315	1993-06-20	1993-06-27	1	8578
22339	1520	1119510	1952-01-08	1952-01-22	1	-6554
56645	3859	1137529	1988-09-17	1988-09-17	1	6834
71185	4859	1125315	1962-02-03	1962-02-17	1	-2875
26091	1764	1125315	1995-01-19	1995-01-26	1	9156
29307	1982	1361711	1976-09-23	2006-10-19	1	13440
51774	3527	1112807	1979-01-15	1979-04-15	1	3391
19113	1310	975125	1969-03-03	1969-03-03	1	-304
63673	4352	1728416	1952-04-26	1952-05-10	1	-6445
23713	1606	1119510	2000-12-28	2001-01-04	1	11326
62678	4279	1177480	2011-07-21	2011-09-19	1	15236
20120	1371	1729720	1974-05-30	1974-06-09	1	1620
66172	4521	1125315	1972-05-11	1972-05-11	1	861
22554	1532	1125315	2014-05-04	2014-05-18	1	16208
65437	4472	1124300	1975-03-19	1975-03-19	1	1903
25587	1736	920293	1985-06-17	1985-06-24	1	5653
67167	4586	920293	1989-11-24	1989-12-01	1	7274
22474	1529	1728416	1978-10-23	1978-11-06	1	3231
25854	1750	1125315	2017-11-03	2017-11-17	1	17487
65615	4482	1125315	1952-04-13	1952-04-27	1	-6458
61069	4165	1112807	1913-01-27	1913-02-10	1	-20779
32649	2210	1713332	1973-05-07	1973-05-14	1	1229
21294	1448	1549786	1989-03-14	1990-03-09	1	7372
73781	5045	1729720	1974-09-16	1974-09-24	1	1727
12562	863	1347450	2004-09-30	2004-09-30	1	12691
63250	4321	1759842	1984-04-06	1984-04-27	1	5230
48298	3280	1112807	1967-09-17	1967-10-08	1	-816
69671	4754	1118084	2006-02-02	2006-02-02	1	13181
29015	1966	1124300	2000-04-05	2000-04-05	1	11052
29955	2026	933724	1975-04-05	1975-04-12	1	1927
21818	1486	1129625	1960-07-29	1960-07-29	1	-3443
70903	4844	1125315	2013-07-26	2013-08-09	1	15926
19478	1328	1347450	2019-06-13	2019-06-13	1	18060
35963	2443	1125315	2009-09-05	2009-09-12	1	14499
21175	1442	1125315	1955-01-21	1955-02-04	1	-5445
32966	2233	1713332	1973-11-30	1973-12-07	1	1436
68485	4674	738818	2006-04-17	2006-04-24	1	13262
28956	1960	757627	2002-11-12	2002-11-12	1	12003
73973	5056	1112807	1942-11-12	1942-11-26	1	-9898
23400	1588	1125315	2010-09-03	2010-09-10	1	14862
48955	3332	1717327	1962-04-30	1962-05-14	1	-2789
68663	4685	1125315	1975-01-22	1975-01-22	1	1847
25631	1738	1503184	1986-04-25	1987-04-20	1	6318
72859	4977	19003953	2010-12-08	2010-12-08	1	14951
19914	1356	1125315	1983-08-01	1983-08-29	1	4988
71064	4852	1729720	1960-11-30	1960-12-08	1	-3311
20525	1397	1150770	1977-11-27	1977-11-27	1	2887
67279	4593	1125315	1984-06-09	1984-06-23	1	5287
19858	1354	1125315	1982-03-12	1982-03-19	1	4460
20257	1381	1713332	2010-08-08	2010-08-29	1	14850
68260	4657	1759842	1966-10-12	1966-11-02	1	-1156
29039	1967	1112807	1983-11-29	1983-12-27	1	5108
72524	4957	1118084	2004-05-16	2004-05-16	1	12554
30704	2078	1115008	2019-01-24	2019-03-25	1	17980
69401	4735	1729720	1974-08-30	1974-09-09	1	1712
22340	1520	1119510	2002-09-22	2002-09-29	1	11959
56646	3859	1326303	2016-04-16	2016-04-16	1	16907
71186	4859	1125315	1982-07-11	1982-09-09	1	4634
26092	1764	1713332	1974-06-01	1974-07-13	1	1654
29308	1982	1713332	1960-12-06	1960-12-13	1	-3306
51775	3527	1177480	1974-02-19	1974-03-12	1	1531
19114	1310	1115008	2013-10-10	2013-10-24	1	16002
63674	4352	1112807	1949-02-24	1949-03-10	1	-7602
23714	1606	1125315	1956-11-19	1956-12-03	1	-4777
62679	4279	1713332	1978-10-04	1978-10-18	1	3212
20121	1371	1759842	1990-08-06	1990-08-20	1	7536
66173	4521	1125315	1992-09-23	1992-10-07	1	8315
22555	1532	1549786	1992-09-19	1994-09-09	2	9017
65438	4472	1125315	2009-01-28	2009-02-04	1	14279
25588	1736	920293	1989-08-09	1989-08-16	1	7167
67168	4586	933724	1989-11-24	1989-12-01	1	7274
22475	1529	1729720	1968-05-03	1968-05-12	1	-599
25855	1750	1778162	2012-09-09	2012-10-14	1	15627
65616	4482	1728416	1952-02-12	1952-02-26	1	-6519
61070	4165	1125315	1912-03-15	1912-03-29	1	-21097
32650	2210	1759842	1985-10-15	1985-10-29	1	5780
21295	1448	1738521	1976-01-12	1976-01-26	1	2216
73782	5045	19127890	1975-03-25	1978-03-09	3	2989
12563	863	1729720	1923-04-14	1923-04-21	1	-17057
63251	4321	1115008	2011-03-30	2011-04-13	1	15077
48299	3280	1112807	1969-08-28	1969-09-11	1	-112
69672	4754	1125315	2016-06-28	2016-07-05	1	16987
29016	1966	1125315	1978-10-24	1978-11-07	1	3232
29956	2026	1118084	1995-07-14	1995-07-14	1	9325
21819	1486	1728416	1960-01-15	1960-01-29	1	-3625
70904	4844	1713332	1978-06-05	1978-06-19	1	3091
19479	1328	920293	1999-08-07	1999-08-14	1	10817
35964	2443	1125315	2019-02-02	2019-02-23	1	17950
21176	1442	1125315	1968-12-02	1968-12-16	1	-381
32967	2233	19127890	1988-01-18	1989-01-12	1	6951
68486	4674	1119510	2006-04-17	2006-04-24	1	13262
28957	1960	1115008	2007-01-26	2007-03-27	1	13599
73974	5056	1125315	1950-09-03	1950-10-03	2	-7030
23401	1588	1503184	1977-11-15	1978-11-10	1	3235
48956	3332	1759842	1973-04-12	1973-04-26	1	1211
68664	4685	1729720	1944-08-21	1944-09-03	1	-9251
25632	1738	1713332	2004-02-16	2004-03-08	1	12485
72860	4977	19127890	1975-12-04	1976-11-28	1	2523
19915	1356	1107830	1995-02-23	1995-02-23	1	9184
72369	4945	1125315	1982-05-03	1982-05-17	1	4519
20526	1397	1549786	1993-10-31	1994-10-26	1	9064
67280	4593	1521369	1979-08-29	1980-08-23	1	3887
19859	1354	1125315	1998-04-18	1998-05-02	1	10348
20258	1381	1759842	2010-08-08	2010-08-29	1	14850
68261	4657	1759842	2001-09-08	2001-09-22	1	11587
29040	1967	1177480	1985-10-17	1985-11-07	1	5789
72525	4957	1125315	1971-12-01	1971-12-15	1	713
30705	2078	1118084	2017-07-25	2017-07-25	1	17372
69673	4755	1112807	1928-06-19	1928-07-03	1	-15157
22341	1520	1124957	2002-10-29	2002-10-29	1	11989
56647	3859	1759842	1926-12-03	1926-12-17	1	-15721
71187	4859	1728416	1955-10-17	1955-10-31	1	-5176
26093	1764	1713332	1977-11-01	1977-11-15	1	2875
29309	1982	1759842	1963-12-05	1963-12-12	1	-2212
51776	3527	1729720	1971-07-03	1971-07-15	1	560
19115	1310	1125315	1944-02-11	1944-02-25	1	-9442
63675	4352	1125315	1985-04-17	1985-05-01	1	5599
23715	1606	1125315	1990-04-09	1990-04-23	1	7417
62680	4279	1119510	1970-10-20	1970-11-03	1	306
20122	1371	1115008	1998-04-26	1998-06-25	1	10402
66174	4521	1125315	1996-05-06	1996-05-20	1	9636
22556	1532	1713332	2001-06-13	2001-06-20	1	11493
65439	4472	1174888	2015-10-03	2015-10-03	1	16711
25589	1736	933724	1989-08-09	1989-08-16	1	7167
67169	4586	1521369	1974-10-04	1975-09-29	1	2097
22476	1529	1759842	2009-07-03	2009-07-24	1	14449
28835	1951	1115008	2018-01-25	2018-03-01	1	17591
65617	4482	1729720	1955-06-07	1955-06-16	1	-5313
61071	4165	1729720	1922-02-24	1922-03-09	1	-17465
32651	2210	1119510	1951-01-21	1951-02-04	1	-6906
21296	1448	1759842	1984-10-01	1984-10-22	1	5408
73783	5045	1125315	1989-12-29	1990-01-12	1	7316
12564	863	1759842	1994-02-12	1994-02-19	1	8815
63252	4321	1124300	2006-05-13	2006-05-13	1	13281
48300	3280	1115008	2001-05-12	2001-05-26	1	11468
72157	4929	1115008	2004-10-20	2004-11-03	1	12725
29017	1966	1125315	2016-07-20	2016-07-27	1	17009
29957	2026	1125315	2009-02-11	2009-02-25	1	14300
21820	1486	19127890	1976-05-30	1977-05-25	1	2701
70905	4844	1713332	1978-08-24	1978-09-14	1	3178
19480	1328	1125315	1966-11-05	1966-11-12	1	-1146
35965	2443	1729720	1980-08-20	1980-08-30	1	3894
21177	1442	1177480	1975-07-03	1975-07-24	1	2030
32968	2233	738818	1986-01-03	1986-01-10	1	5853
68487	4674	1125315	1987-02-08	1987-03-01	1	6268
28958	1960	1118084	1971-05-14	1971-05-14	1	498
73975	5056	1125315	1991-02-26	1991-03-05	1	7733
23402	1588	1503184	1980-10-30	1981-10-25	1	4315
48957	3332	1759842	2006-11-23	2006-12-07	1	13489
68665	4685	1729720	1949-04-28	1949-05-10	1	-7541
25633	1738	1713332	2014-12-19	2015-01-02	1	16437
72861	4977	738818	1988-07-15	1988-07-22	1	6777
19916	1356	1177480	2016-08-07	2016-08-21	1	17034
72370	4945	1125315	1992-11-22	1992-12-06	1	8375
20527	1397	1549786	1995-10-21	1997-10-10	2	10144
67281	4593	1713332	1996-10-08	1996-10-22	1	9791
19860	1354	1713332	2009-11-23	2009-11-30	1	14578
20259	1381	738818	2009-08-14	2009-08-28	1	14484
68262	4657	19127890	1974-10-04	1975-09-29	1	2097
29041	1967	1118084	1994-02-20	1994-02-20	1	8816
72526	4957	1125315	1983-09-05	1983-09-19	1	5009
30706	2078	1125315	2005-05-09	2005-06-08	1	12942
69674	4755	1112807	1930-03-01	1930-03-15	1	-14537
22342	1520	1125315	1963-05-04	1963-05-11	1	-2427
56648	3859	1102527	1995-10-23	1995-10-23	1	9426
71188	4859	1728416	1969-03-24	1969-04-07	1	-269
26094	1764	1717327	1963-10-23	1963-11-06	1	-2248
29310	1982	738818	1939-03-25	1939-04-08	1	-11226
51777	3527	1759842	2001-05-19	2001-06-09	1	11482
19116	1310	1125315	1945-04-11	1945-04-18	1	-9024
63676	4352	1728416	1949-08-05	1949-08-19	1	-7440
23716	1606	1125315	2018-02-10	2018-02-17	1	17579
62681	4279	1129625	1954-04-27	1954-04-27	1	-5728
20123	1371	1118084	2008-02-23	2008-02-23	1	13932
66175	4521	1310149	2000-06-08	2000-06-08	1	11116
22557	1532	1759842	2004-10-11	2004-10-25	1	12716
65440	4472	1177480	2000-12-18	2001-01-08	1	11330
25590	1736	1115008	2010-07-02	2010-09-30	1	14882
67170	4586	1759842	1983-02-19	1983-02-26	1	4804
22477	1529	1124300	2000-07-12	2000-07-12	1	11150
28836	1951	1125315	1995-11-27	1995-12-11	1	9475
65618	4482	1112807	1952-02-12	1952-02-26	1	-6519
61072	4165	1759842	1945-12-30	1946-01-13	1	-8754
32652	2210	1119510	1954-01-05	1954-01-12	1	-5833
21297	1448	19127890	1989-03-14	1991-03-04	2	7732
73784	5045	1503184	1975-03-25	1978-03-09	3	2989
13820	947	1125315	2002-07-24	2002-07-31	1	11899
63253	4321	1125315	1991-03-23	1991-03-30	1	7758
48301	3280	1713332	1967-06-02	1967-06-16	1	-930
72158	4929	1125315	1984-07-16	1984-08-06	1	5331
29018	1966	1717327	1965-07-03	1965-07-17	1	-1629
29958	2026	920293	1974-02-18	1974-03-04	2	1523
21821	1486	920293	1995-08-07	1995-08-21	2	9363
70906	4844	1713332	1994-01-07	1994-01-14	1	8779
19481	1328	1125315	1980-11-16	1980-11-30	1	3986
35966	2443	1729720	1986-03-04	1986-03-13	1	5915
21178	1442	1501700	2016-01-19	2016-01-19	1	16819
32969	2233	738818	2013-06-03	2013-06-10	1	15866
68488	4674	1125315	2006-04-17	2006-04-24	1	13262
30342	2052	1119510	2013-02-02	2013-02-09	1	15745
73976	5056	1125315	2000-09-14	2000-09-28	1	11228
23403	1588	1713332	1989-11-01	1989-11-22	1	7265
48958	3332	19127890	1975-11-28	1977-11-17	2	2877
68666	4685	1729720	1952-01-28	1952-02-06	1	-6539
25634	1738	1759842	1976-09-09	1976-09-16	1	2450
72862	4977	967823	2010-12-07	2010-12-13	1	14956
19917	1356	1759842	1981-06-19	1981-07-03	1	4201
72371	4945	1125315	2008-03-10	2008-03-24	1	13962
20528	1397	1729720	1977-02-21	1977-03-04	1	2619
67282	4593	1738521	1967-05-15	1967-05-29	1	-948
19861	1354	1759842	1984-07-04	1984-07-11	1	5305
20260	1381	1119510	2009-08-14	2009-08-28	1	14484
70696	4829	738818	1999-12-03	1999-12-17	1	10942
29042	1967	1759842	1959-06-01	1959-06-15	1	-3853
72527	4957	1521369	1985-09-28	1987-09-18	2	6469
30707	2078	1177480	1983-04-13	1983-04-27	1	4864
69675	4755	1112807	1933-01-24	1933-02-14	1	-13470
22343	1520	1125315	1969-08-08	1969-08-15	1	-139
56649	3859	1112807	1936-12-01	1936-12-31	1	-12054
71189	4859	1741122	1971-06-05	1971-06-05	1	520
26095	1764	738818	1968-11-16	1968-11-30	1	-397
29311	1982	738818	1987-08-16	1987-08-30	1	6450
51778	3527	1112807	1971-04-22	1971-05-06	1	490
19117	1310	1778162	2013-10-10	2013-10-24	1	16002
63677	4352	1118084	1987-04-11	1987-04-11	1	6309
23717	1606	1713332	2006-05-06	2006-08-12	1	13372
62682	4279	1713332	1993-03-22	1993-03-29	1	8488
20124	1371	1124957	1991-08-01	1991-08-01	1	7882
66176	4521	1713332	1976-11-22	1976-11-29	1	2524
22558	1532	1768849	1981-01-01	1981-01-15	1	4032
65441	4472	1539403	2010-04-24	2010-04-24	1	14723
25591	1736	1125315	1989-09-06	1989-09-13	1	7195
67171	4586	1118084	1992-06-01	1992-06-01	1	8187
22478	1529	1125315	2010-04-19	2010-05-03	1	14732
28837	1951	1713332	1987-02-25	1987-03-11	1	6278
65619	4482	1112807	1962-01-20	1962-02-17	1	-2875
61073	4165	1112807	1916-07-12	1916-07-26	1	-19517
32653	2210	1119510	2016-05-10	2016-05-24	1	16945
21298	1448	19127890	1992-02-27	1993-02-21	1	8452
73785	5045	1521369	1979-03-04	1981-02-21	2	4069
13821	947	1729720	1976-06-27	1976-07-10	1	2382
63254	4321	1759842	2015-08-23	2015-09-13	1	16691
48302	3280	1729720	2000-07-26	2000-08-05	1	11174
72159	4929	1729720	1972-12-05	1972-12-14	1	1078
29019	1966	1115008	2010-04-30	2010-07-06	1	14796
29959	2026	933724	1974-02-18	1974-03-04	1	1523
21822	1486	933724	1995-08-07	1995-08-21	1	9363
70907	4844	1119510	2001-09-12	2001-09-19	1	11584
19482	1328	1125315	2008-02-17	2008-02-24	1	13933
35967	2443	738818	1994-11-08	1994-11-15	1	9084
22697	1540	1125315	2004-12-08	2004-12-15	1	12767
32970	2233	920293	1998-03-03	1998-03-10	1	10295
68489	4674	1174888	2017-06-28	2017-06-28	1	17345
30343	2052	1125315	2015-03-03	2015-03-10	1	16504
75120	5142	738818	1963-11-12	1963-11-26	1	-2228
23404	1588	1729720	1975-08-29	1975-09-09	1	2077
48959	3332	920293	1979-12-31	1980-01-07	1	3658
68667	4685	1729720	1953-10-01	1953-10-09	1	-5928
25635	1738	1102527	2014-12-19	2014-12-19	1	16423
72863	4977	1125315	1988-07-15	1988-07-22	1	6777
19918	1356	1125315	2007-09-22	2007-10-29	2	13815
72372	4945	1759842	1964-03-14	1964-04-04	1	-2098
20529	1397	19127890	1990-11-16	1991-11-11	1	7984
67283	4593	1759842	1985-01-16	1985-02-06	1	5515
19862	1354	1759842	1993-03-15	1993-03-29	1	8488
20261	1381	1125315	1982-02-12	1982-03-14	1	4455
70697	4829	1119510	1999-12-03	1999-12-17	1	10942
29043	1967	920293	1980-11-08	1980-11-15	1	3971
72528	4957	1738521	1971-12-01	1971-12-15	1	713
30708	2078	1177480	1995-08-30	1995-11-28	1	9462
69676	4755	1112807	1945-03-13	1945-03-27	1	-9046
22344	1520	1177480	2010-10-17	2010-12-16	1	14959
56650	3859	1125315	1973-06-01	1973-06-15	1	1261
71190	4859	738818	1985-09-22	1985-10-06	1	5757
26096	1764	1125315	1968-11-16	1968-11-30	1	-397
29312	1982	1112807	1961-06-24	1961-07-29	1	-3078
51779	3527	1124957	1979-01-15	1979-01-15	1	3301
20302	1384	1118084	2016-11-27	2016-11-27	1	17132
63678	4352	1125315	1950-04-04	1950-04-18	1	-7198
23718	1606	1728416	1953-03-17	1953-03-31	1	-6120
62683	4279	1729720	1975-10-09	1975-10-16	1	2114
20125	1371	1125315	1985-03-02	1985-03-09	1	5546
66177	4521	1759842	1950-06-28	1950-07-12	1	-7113
22559	1532	19127890	1992-09-19	1994-09-09	2	9017
65442	4472	1545958	2015-10-03	2015-10-03	1	16711
25592	1736	1125315	1992-05-02	1992-05-09	1	8164
67172	4586	1125315	1989-04-08	1989-04-29	1	7058
22479	1529	1713332	1991-09-18	1991-10-09	1	7951
28838	1951	1713332	1993-06-04	1993-07-02	1	8583
65620	4482	1118084	1987-08-27	1987-08-27	1	6447
61074	4165	1112807	1925-09-23	1925-10-14	1	-16150
32654	2210	1125315	1982-09-08	1982-09-15	1	4640
22836	1550	1137529	1999-10-23	1999-10-23	1	10887
73786	5045	1729720	1965-07-25	1965-08-03	1	-1612
13822	947	1124300	2000-06-08	2000-06-08	1	11116
63255	4321	1125315	1965-11-14	1965-12-05	1	-1488
51109	3481	914335	2001-05-12	2001-05-12	1	11454
72160	4929	19127890	1976-12-07	1978-11-27	2	3252
29020	1966	1124957	2010-05-07	2010-05-07	1	14736
29960	2026	1713332	2016-03-07	2016-03-28	1	16888
21823	1486	1125315	1960-01-15	1960-01-29	1	-3625
70908	4844	1124300	2001-01-06	2001-01-06	1	11328
19483	1328	1125315	2013-01-31	2013-02-28	1	15764
35968	2443	1112807	1965-05-12	1965-05-26	1	-1681
22698	1540	1713332	1998-09-21	1998-10-05	1	10504
32971	2233	933724	1998-03-03	1998-03-10	1	10295
68490	4674	1521369	1983-08-12	1984-08-06	1	5331
30344	2052	1177480	2014-06-30	2014-07-28	1	16279
75121	5142	738818	1972-07-25	1972-08-01	1	943
23405	1588	1759842	1998-12-11	1999-01-01	1	10592
48960	3332	933724	1979-12-31	1980-01-07	1	3658
68668	4685	920293	1974-10-12	1974-10-19	1	1752
25636	1738	1717327	1971-10-31	1971-11-14	1	682
72864	4977	1503184	1975-12-04	1976-11-28	1	2523
19919	1356	1174888	2007-09-29	2007-09-29	1	13785
72373	4945	920293	1985-05-21	1985-05-28	1	5626
20530	1397	1119510	2008-12-18	2008-12-25	1	14238
67994	4641	1149380	2001-09-06	2001-09-06	1	11571
19863	1354	1112807	1980-01-27	1980-02-17	1	3699
20262	1381	1125315	2009-08-14	2009-08-28	1	14484
70698	4829	1125315	1999-12-03	1999-12-17	1	10942
29044	1967	933724	1980-11-08	1980-11-15	1	3971
72529	4957	1125315	2003-09-05	2003-09-12	1	12307
30709	2078	1713332	1996-12-15	1997-01-05	1	9866
69677	4755	1125315	1925-06-06	1925-06-20	1	-16266
22345	1520	1112807	1955-02-19	1955-03-12	1	-5409
56651	3859	1125315	1993-07-08	1993-07-22	1	8603
71191	4859	753626	1971-06-05	1971-06-05	1	520
26097	1764	1713332	1993-05-28	1993-06-18	1	8569
29313	1982	1125315	1939-03-25	1939-04-08	1	-11226
51780	3527	1125315	1987-09-13	1987-09-20	1	6471
20303	1384	1177480	1996-04-15	1996-06-14	1	9661
63679	4352	1112807	1965-11-27	1966-01-26	1	-1436
23719	1606	1728416	1956-11-19	1956-12-03	1	-4777
62684	4279	1759842	1978-10-04	1978-10-18	1	3212
20126	1371	1521369	1989-03-19	1990-03-14	1	7377
66178	4521	1759842	1961-06-23	1961-07-14	1	-3093
22560	1532	19127890	1998-08-19	1999-08-14	1	10817
65443	4472	1713332	1956-08-28	1956-11-13	1	-4797
25593	1736	1713332	1980-08-13	1980-08-20	1	3884
67173	4586	1503184	1974-10-04	1975-09-29	1	2097
22480	1529	1713332	2018-03-15	2018-04-05	1	17626
28839	1951	1177480	1993-05-31	1993-07-30	1	8611
65621	4482	1119510	2019-01-19	2019-01-26	1	17922
61075	4165	1119510	1932-01-15	1932-01-29	1	-13852
32655	2210	1713332	1937-12-25	1938-01-15	1	-11674
22837	1550	1729720	1981-12-18	1981-12-25	1	4376
73787	5045	1729720	1999-12-08	1999-12-20	1	10945
13823	947	1125315	1968-07-21	1968-08-04	1	-515
63256	4321	1125315	1995-01-29	1995-02-12	1	9173
51110	3481	1112807	1981-04-09	1981-04-30	1	4137
72161	4929	19127890	1981-11-11	1982-11-06	1	4692
29021	1966	1729720	1973-04-25	1973-05-02	1	1217
29961	2026	1729720	1960-03-23	1960-04-03	1	-3560
21824	1486	1125315	2001-03-11	2001-03-18	1	11399
70909	4844	1125315	1965-12-05	1966-02-03	1	-1428
19484	1328	1149380	1983-12-08	1983-12-08	1	5089
35969	2443	1124957	1979-10-26	1979-10-26	1	3585
22699	1540	1759842	1965-04-11	1965-05-30	1	-1677
32972	2233	1119510	2009-04-10	2009-04-24	1	14358
68491	4674	1713332	1987-11-16	1987-12-07	1	6549
30345	2052	914335	2015-10-19	2015-10-19	1	16727
75122	5142	1125315	1965-07-02	1965-09-30	2	-1554
23406	1588	19127890	1980-10-30	1981-10-25	1	4315
48961	3332	1125315	1969-07-22	1969-10-20	1	-73
68669	4685	933724	1974-10-12	1974-10-19	1	1752
25637	1738	1759842	2004-02-16	2004-03-08	1	12485
72865	4977	1729720	1981-06-24	1981-07-06	1	4204
19920	1356	1343916	1995-02-23	1995-02-23	1	9184
72374	4945	933724	1985-05-21	1985-05-28	1	5626
20531	1397	1125315	2001-01-10	2001-01-31	1	11353
67995	4641	1177480	1975-05-02	1975-05-16	1	1961
19864	1354	1125315	1986-06-24	1986-07-08	1	6032
20263	1381	1149380	2009-08-15	2009-08-15	1	14471
70699	4829	1503184	1987-11-26	1988-11-20	1	6898
29045	1967	1125315	2001-12-12	2001-12-19	1	11675
72530	4957	1125315	2009-09-30	2009-10-07	1	14524
30710	2078	1738521	1982-07-09	1982-07-23	1	4586
69678	4755	1125315	1932-12-04	1932-12-18	1	-13528
23085	1568	1125315	1993-01-12	1993-02-16	1	8447
56652	3859	1125315	1995-10-23	1996-01-21	1	9516
71192	4859	782043	1971-06-05	1971-06-05	1	520
26098	1764	1759842	1974-06-01	1974-07-13	1	1654
29314	1982	1125315	1987-08-16	1987-08-30	1	6450
51781	3527	1551099	1962-03-10	1962-03-10	1	-2854
20304	1384	1759842	2003-09-20	2003-10-11	1	12336
63680	4352	1119510	2018-08-14	2018-08-21	1	17764
23720	1606	1729720	1958-06-12	1958-06-25	1	-4208
62685	4279	1759842	1980-10-25	1980-11-08	1	3964
22880	1553	738818	1979-11-09	1979-11-16	1	3606
67714	4623	738818	1986-08-26	1986-09-09	1	6095
22561	1532	1119510	2010-04-06	2010-04-20	1	14719
65444	4472	1759842	1966-07-14	1966-07-21	1	-1260
25594	1736	1759842	1976-06-16	1976-06-30	1	2372
67174	4586	1713332	1983-02-19	1983-02-26	1	4804
22481	1529	1112807	1963-02-27	1963-03-13	1	-2486
28840	1951	1112807	1985-10-19	1985-11-09	1	5791
65622	4482	1713332	1991-02-22	1991-03-15	1	7743
61076	4165	1125315	1944-02-11	1944-02-18	1	-9449
32656	2210	1759842	1937-12-25	1938-01-15	1	-11674
22838	1550	1124300	2004-08-25	2004-08-25	1	12655
73788	5045	1125315	1979-05-23	1979-06-06	1	3443
13824	947	1729720	2006-06-06	2006-06-13	1	13312
66113	4520	1112807	1935-10-24	1935-11-07	1	-12474
51111	3481	1332418	1995-06-24	1995-06-24	1	9305
72162	4929	1125315	1991-09-11	1991-09-18	1	7930
29022	1966	1729720	1992-09-19	1992-10-02	1	8310
29962	2026	1115008	2016-05-04	2016-06-03	1	16955
21825	1486	1125315	2007-06-16	2007-06-23	1	13687
70910	4844	1125315	2001-09-12	2001-09-19	1	11584
19485	1328	1728416	1945-12-23	1946-01-06	1	-8761
35970	2443	1125315	1989-12-11	1989-12-18	1	7291
22700	1540	1125315	1964-07-26	1964-08-09	1	-1971
32973	2233	1125315	1986-01-03	1986-01-10	1	5853
68492	4674	1738521	1969-01-17	1969-01-31	1	-335
30346	2052	1118084	2003-07-13	2003-07-13	1	12246
75123	5142	1125315	1972-07-25	1972-08-01	1	943
23407	1588	19127890	1982-10-20	1985-10-04	3	5755
48962	3332	1713332	1973-04-12	1973-04-26	1	1211
68670	4685	1112807	1941-09-23	1941-10-28	1	-10292
25638	1738	933724	2009-06-07	2009-06-14	1	14409
72866	4977	1759842	1974-10-19	1974-10-26	1	1759
19921	1356	1729720	1981-02-14	1981-02-26	1	4074
72375	4945	1119510	1982-05-03	1982-05-17	1	4519
20532	1397	1125315	2008-12-18	2008-12-25	1	14238
67996	4641	1713332	1999-06-02	1999-06-09	1	10751
19865	1354	1174888	1995-05-29	1995-05-29	1	9279
20264	1381	1759842	2001-12-16	2001-12-30	1	11686
70700	4829	1521369	1992-10-30	1993-10-25	1	8698
29046	1967	1177480	2006-09-18	2006-10-18	1	13439
72531	4957	1713332	1978-05-06	1978-05-20	1	3061
30711	2078	1759842	1996-12-15	1997-01-05	1	9866
69679	4755	1713332	1973-08-30	1973-09-13	1	1351
23086	1568	738818	1975-02-12	1975-02-19	1	1875
56653	3859	1149380	1988-09-17	1988-09-17	1	6834
71193	4859	933724	2002-05-25	2002-06-01	1	11839
26099	1764	1759842	1977-11-01	1977-11-15	1	2875
29315	1982	1125315	1996-07-17	1996-07-24	1	9701
51782	3527	1551099	1963-04-09	1963-04-09	1	-2459
20305	1384	1759842	2012-08-16	2012-08-23	1	15575
63681	4352	1125315	1956-03-19	1956-06-17	1	-4946
23721	1606	1759842	2006-05-06	2006-08-12	1	13372
62686	4279	1112807	1966-11-14	1967-02-12	1	-1054
22881	1553	1125315	1977-08-24	1977-08-31	1	2799
67715	4623	1112807	1946-04-15	1946-04-29	1	-8648
22562	1532	1125315	2010-04-06	2010-04-20	1	14719
65445	4472	1759842	1970-12-22	1971-01-05	1	369
25595	1736	1125315	1974-04-12	1974-04-26	1	1576
67175	4586	19127890	1974-10-04	1975-09-29	1	2097
22482	1529	1112807	1967-07-06	1967-09-04	1	-850
28841	1951	1125315	1987-02-25	1987-03-11	1	6278
65623	4482	1112807	1952-11-15	1952-11-29	1	-6242
61077	4165	1125315	1960-10-22	1960-11-05	1	-3344
32657	2210	1759842	1950-08-28	1950-09-18	1	-7045
22839	1550	1125315	1993-05-07	1993-05-14	1	8534
73789	5045	1729720	1963-08-19	1963-09-01	1	-2314
13825	947	1125315	2009-09-28	2009-10-19	1	14536
66114	4520	1112807	1937-08-28	1937-09-18	1	-11793
51112	3481	1115008	2007-07-02	2007-07-16	1	13710
72163	4929	1503184	1976-12-07	1978-11-27	2	3252
29023	1966	1125315	1965-07-03	1965-07-17	1	-1629
32741	2218	933724	2016-07-23	2016-07-30	1	17012
21826	1486	1118084	1991-07-16	1991-07-16	1	7866
70911	4844	1125315	2011-11-09	2011-11-30	1	15308
19486	1328	1728416	1947-08-29	1947-09-12	1	-8147
35971	2443	1125315	1992-08-18	1992-09-22	1	8300
22701	1540	1125315	1971-11-11	1971-11-18	1	686
32974	2233	1125315	2013-06-03	2013-06-10	1	15866
68493	4674	1759842	1987-11-16	1987-12-07	1	6549
30347	2052	1343916	2015-10-19	2015-10-19	1	16727
75124	5142	1125315	1988-07-10	1988-07-17	1	6772
23408	1588	933724	2011-12-16	2011-12-23	1	15331
48963	3332	933724	1980-02-25	1980-03-10	1	3721
68671	4685	1112807	1955-06-08	1955-07-06	1	-5293
25639	1738	1125315	1979-05-03	1979-05-17	1	3423
72867	4977	19059528	2010-12-08	2010-12-08	1	14951
22727	1542	1125315	2007-11-03	2007-12-03	1	13850
72376	4945	1759842	1995-07-10	1995-07-17	1	9328
20533	1397	1551099	1977-11-14	1977-11-14	1	2874
67997	4641	1713332	2013-04-28	2013-05-12	1	15837
19866	1354	1177480	1995-05-29	1995-06-28	1	9309
22583	1535	738818	1980-09-20	1980-09-27	1	3922
70701	4829	1521369	1995-10-15	1996-10-09	1	9778
29047	1967	1728416	1960-11-15	1960-11-29	1	-3320
72532	4957	1759842	1978-05-06	1978-05-20	1	3061
30712	2078	1778162	1983-04-13	1983-04-27	1	4864
69680	4755	1729720	1944-09-06	1944-09-16	1	-9238
23087	1568	1112807	1964-09-27	1964-10-11	1	-1908
56654	3859	1307863	2016-04-16	2016-04-16	1	16907
71194	4859	967823	1971-06-05	1971-06-10	1	525
27338	1847	1112807	1928-05-28	1928-08-26	1	-15103
29316	1982	1174888	2006-10-19	2006-10-19	1	13440
51783	3527	1713332	2015-07-16	2015-07-23	1	16639
20306	1384	1102527	1996-04-15	1996-04-15	1	9601
63682	4352	1125315	2006-03-27	2006-04-03	1	13241
23722	1606	1112807	1953-03-17	1953-03-31	1	-6120
62687	4279	1125315	1970-10-20	1970-11-03	1	306
22882	1553	1125315	1979-11-09	1979-11-16	1	3606
67716	4623	1125315	1986-08-26	1986-09-09	1	6095
22563	1532	1503184	1998-08-19	1999-08-14	1	10817
65446	4472	738818	1960-09-16	1960-09-30	1	-3380
25596	1736	1125315	2006-07-15	2006-07-29	1	13358
67176	4586	1125315	1968-05-29	1968-06-05	1	-575
22483	1529	1112807	1968-02-07	1968-02-21	1	-680
28842	1951	1729720	1991-04-25	1991-05-08	1	7797
65624	4482	1112807	1966-12-23	1967-01-22	1	-1075
61078	4165	1759842	1946-03-20	1946-03-27	1	-8681
32658	2210	1759842	1973-05-07	1973-05-14	1	1229
22840	1550	1125315	2015-03-11	2015-04-15	1	16540
73790	5045	19127890	1979-03-04	1981-02-21	2	4069
13826	947	1713332	2008-02-22	2008-06-20	1	14050
66115	4520	1112807	1945-10-27	1945-11-10	1	-8818
51113	3481	1125315	1987-02-03	1987-02-17	1	6256
72164	4929	1503184	1981-11-11	1982-11-06	1	4692
29024	1966	1125315	1990-01-21	1990-02-25	1	7360
32742	2218	1129625	1979-03-30	1979-03-30	1	3375
21827	1486	1125315	1960-05-24	1960-06-07	1	-3495
70912	4844	1551099	1959-09-24	1959-09-24	1	-3752
21313	1450	1112807	1966-02-12	1966-02-26	1	-1405
35972	2443	1125315	1994-11-08	1994-11-15	1	9084
22702	1540	1125315	1984-11-27	1984-12-04	1	5451
32975	2233	1503184	1988-01-18	1989-01-12	1	6951
70039	4782	1125315	1995-06-12	1995-06-26	1	9307
30348	2052	738818	2013-02-02	2013-02-09	1	15745
75125	5142	1125315	2014-06-18	2014-08-17	1	16299
23409	1588	1118084	2005-03-13	2005-03-13	1	12855
48964	3332	1112807	1964-04-03	1964-04-17	1	-2085
68672	4685	1125315	1950-07-13	1950-08-03	1	-7091
25640	1738	1713332	1991-04-06	1991-04-13	1	7772
74546	5099	1119510	1949-10-01	1949-10-08	1	-7390
22728	1542	1310149	2015-11-25	2015-11-25	1	16764
72377	4945	1759842	1997-02-14	1997-02-21	1	9913
20999	1433	738818	1970-01-13	1970-01-27	1	26
67998	4641	920293	1987-08-18	1987-08-25	1	6445
19867	1354	1119510	2013-12-06	2013-12-13	1	16052
22584	1535	738818	1986-10-28	1986-11-11	1	6158
70702	4829	1738521	1973-11-13	1973-11-27	1	1426
29048	1967	1729720	1971-06-03	1971-06-15	1	530
72533	4957	19127890	1985-09-28	1987-09-18	2	6469
30713	2078	1124957	1995-08-30	1995-08-30	1	9372
69681	4755	738818	1941-07-27	1941-08-03	1	-10378
23088	1568	1125315	1956-10-09	1956-10-23	1	-4818
56655	3859	1125315	1949-08-25	1949-09-08	1	-7420
71195	4859	1000560	1971-06-05	1971-06-05	2	520
27339	1847	1118084	1958-01-16	1958-01-16	1	-4368
29317	1982	1539403	1991-10-24	1991-10-24	1	7966
51784	3527	1759842	2015-07-16	2015-07-23	1	16639
20307	1384	1125315	1989-03-09	1989-04-08	1	7037
63683	4352	1728416	1950-04-04	1950-04-18	1	-7198
23723	1606	1112807	1964-05-14	1964-07-13	1	-1998
62810	4289	738818	2018-01-18	2018-01-25	1	17556
22883	1553	738818	1969-03-30	1969-04-06	1	-270
67717	4623	1729720	1943-09-22	1943-10-05	1	-9585
24023	1626	914335	2010-10-10	2010-10-10	1	14892
65447	4472	1112807	1936-07-06	1936-07-20	1	-12218
25597	1736	1713332	1976-06-16	1976-06-30	1	2372
67177	4586	1177480	2003-08-14	2003-09-04	1	12299
22484	1529	1125315	1979-02-05	1979-02-19	1	3336
28843	1951	1759842	1993-06-04	1993-07-02	1	8583
65625	4482	1125315	1976-10-01	1976-10-22	1	2486
61079	4165	914335	1991-01-27	1991-01-27	1	7696
33299	2260	1118084	1983-11-19	1983-11-19	1	5070
22841	1550	1729720	1972-05-29	1972-06-05	1	886
73791	5045	1112807	1981-04-26	1981-05-24	1	4161
13827	947	1759842	2008-02-22	2008-06-20	1	14050
66116	4520	1118084	1962-05-15	1962-05-15	1	-2788
51114	3481	1309944	2001-05-12	2001-05-12	1	11454
72165	4929	1112807	1965-11-25	1965-12-09	1	-1484
29025	1966	1125315	1990-12-22	1991-01-12	1	7681
32743	2218	1515774	2002-03-28	2003-03-23	1	12134
21828	1486	1309944	2001-12-23	2001-12-23	1	11679
70913	4844	1759842	1978-06-05	1978-06-19	1	3091
21314	1450	1119510	2015-11-24	2015-12-08	1	16777
35973	2443	1713332	1965-09-12	1965-09-19	1	-1565
22703	1540	1322184	2018-12-10	2018-12-10	1	17875
32976	2233	1521369	1991-12-28	1992-12-22	1	8391
70040	4782	1500211	2004-03-04	2005-02-27	1	12841
30349	2052	1119510	2000-11-29	2000-12-06	1	11297
75126	5142	1174888	2012-04-03	2012-04-03	1	15433
23410	1588	1521369	1977-11-15	1978-11-10	1	3235
48965	3332	1124300	1999-04-16	1999-04-16	1	10697
68673	4685	1177480	1974-09-24	1974-10-08	1	1741
25641	1738	1729720	1976-07-13	1976-07-21	1	2393
74547	5099	1125315	1978-11-27	1978-12-18	1	3273
22729	1542	1112807	1992-11-16	1992-12-21	1	8390
72378	4945	738818	1982-05-03	1982-05-17	1	4519
21000	1433	1125315	1970-01-13	1970-01-27	1	26
67999	4641	933724	1987-08-18	1987-08-25	1	6445
19868	1354	1125315	1994-09-14	1994-09-28	1	9036
22585	1535	1119510	1998-03-29	1998-04-05	1	10321
70703	4829	1118084	2012-06-17	2012-06-17	1	15508
30322	2051	1729720	1993-06-13	1993-06-26	1	8577
72534	4957	1115008	2019-06-20	2019-06-20	1	18067
30714	2078	1125315	1994-08-07	1994-08-14	1	8991
69682	4755	1118084	1963-09-19	1963-09-19	1	-2296
23089	1568	1125315	1959-04-29	1959-05-13	1	-3886
56656	3859	1125315	1954-10-15	1954-10-22	1	-5550
71196	4859	1112807	1969-03-24	1969-04-07	1	-269
27340	1847	1125315	1931-08-15	1931-08-22	1	-14012
29318	1982	1545958	2006-10-19	2006-10-19	1	13440
51785	3527	1118084	2002-03-25	2002-03-25	1	11771
20308	1384	1125315	1994-01-12	1994-02-18	1	8814
63684	4352	1729720	2003-04-22	2003-05-01	1	12173
23724	1606	1125315	1977-08-04	1977-08-18	1	2786
62811	4289	1125315	2018-01-18	2018-01-25	1	17556
22884	1553	1125315	1969-03-30	1969-04-06	1	-270
67718	4623	1112807	1970-12-10	1970-12-31	1	364
24024	1626	920293	1994-02-14	1994-02-21	1	8817
65448	4472	1112807	1938-02-11	1938-02-25	1	-11633
25598	1736	19127890	1986-04-19	1987-04-14	1	6312
68359	4666	1125315	1984-03-03	1984-03-10	1	5182
22485	1529	1125315	1996-12-19	1997-01-02	1	9863
28844	1951	1768849	1982-10-05	1982-10-19	1	4674
65626	4482	738818	2019-01-19	2019-01-26	1	17922
61080	4165	1112807	1912-08-11	1912-08-25	1	-20948
33300	2260	1119510	1969-10-15	1969-10-22	1	-71
22842	1550	1125315	2007-12-03	2007-12-17	1	13864
73792	5045	1119510	1985-02-08	1985-02-22	1	5531
13828	947	1125315	2008-05-02	2008-05-16	1	14015
66117	4520	1539403	1992-01-11	1992-01-11	1	8045
51115	3481	1322184	1999-07-03	2015-04-04	1	16529
72166	4929	1124300	2002-07-24	2002-07-24	1	11892
29026	1966	1125315	2010-05-07	2010-05-07	1	14736
32744	2218	1551099	1994-01-01	1994-01-01	1	8766
21829	1486	1343916	2001-12-23	2001-12-23	1	11679
70914	4844	1759842	1978-08-24	1978-09-14	1	3178
21315	1450	1124300	1996-03-19	1996-03-19	1	9574
35974	2443	1713332	1989-09-19	1989-10-03	1	7215
22704	1540	1347450	2018-12-10	2018-12-10	1	17875
32977	2233	738818	2009-04-10	2009-04-24	1	14358
70041	4782	1503184	2000-03-25	2001-03-20	1	11401
30350	2052	1125315	2013-02-02	2013-02-09	1	15745
75127	5142	1332418	1995-09-12	1995-09-12	1	9385
23411	1588	1717327	1961-08-31	1961-09-14	1	-3031
48966	3332	1125315	1974-11-24	1974-12-01	1	1795
68674	4685	1177480	1975-01-22	1975-04-22	1	1937
25642	1738	1759842	1991-04-06	1991-04-13	1	7772
74548	5099	1729720	1972-11-04	1972-11-16	1	1050
22730	1542	1118084	2005-07-02	2005-07-02	1	12966
72379	4945	1118084	1989-03-06	1989-03-06	1	7004
21001	1433	1125315	1977-04-11	1977-04-18	1	2664
68000	4641	1124300	2004-10-21	2004-10-21	1	12712
19869	1354	1713332	1984-07-04	1984-07-11	1	5305
22586	1535	1125315	1980-09-20	1980-09-27	1	3922
70704	4829	1177480	1994-10-10	1994-11-07	1	9076
30323	2051	933724	2013-12-16	2013-12-23	1	16062
72535	4957	1125315	1977-02-04	1977-02-11	1	2598
30715	2078	1713332	1982-08-17	1982-08-24	1	4618
69683	4755	1119510	2001-03-22	2001-04-05	1	11417
23090	1568	1125315	1967-07-28	1967-10-26	1	-798
56657	3859	1125315	1971-09-24	1971-10-08	1	645
71197	4859	1125315	1955-08-19	1955-08-26	1	-5242
27341	1847	1125315	1956-02-29	1956-03-14	1	-5041
29319	1982	1118084	1963-08-05	1963-08-05	1	-2341
51786	3527	1322184	2013-11-28	2013-11-28	1	16037
20309	1384	1521369	1997-03-07	1999-02-25	2	10647
65388	4470	1125315	2011-03-29	2011-04-12	1	15076
23725	1606	1125315	1985-01-29	1985-02-05	1	5514
62812	4289	1713332	1968-12-18	1968-12-25	1	-372
22885	1553	1125315	1978-01-11	1978-02-01	1	2953
67719	4623	1125315	1937-11-30	1937-12-14	1	-11706
24025	1626	967823	1989-12-17	1989-12-17	1	7290
65449	4472	1112807	1940-02-07	1940-02-21	1	-10907
25599	1736	19127890	1988-04-08	1989-04-03	1	7032
68360	4666	1177480	1978-11-04	1979-01-03	1	3289
22486	1529	1177480	1978-10-23	1978-11-06	1	3231
28845	1951	1115008	2015-04-11	2015-07-10	1	16626
65627	4482	1125315	1994-04-12	1994-04-26	1	8881
61081	4165	1112807	1917-12-13	1918-01-03	1	-18991
33301	2260	1125315	2009-04-16	2009-05-07	1	14371
22843	1550	1149380	1999-10-23	1999-10-23	1	10887
73793	5045	1125315	1967-04-28	1967-05-12	1	-965
13829	947	1729720	1974-02-22	1974-03-06	1	1525
66118	4520	1112807	1929-04-28	1929-05-12	1	-14844
51116	3481	1343916	2001-05-12	2001-05-12	1	11454
72167	4929	1125315	1979-10-27	1979-11-10	1	3600
29027	1966	1125315	2013-07-12	2013-07-26	1	15912
32745	2218	19127890	2002-03-28	2003-03-23	1	12134
21830	1486	1521369	1976-05-30	1977-05-25	1	2701
70915	4844	1119510	1970-05-30	1970-06-13	1	163
21316	1450	1125315	1968-09-03	1968-09-17	1	-471
35975	2443	1717327	1965-05-12	1965-05-26	1	-1681
22705	1540	1713332	1965-04-11	1965-05-30	1	-1677
32978	2233	1115008	2001-09-06	2001-09-20	1	11585
70042	4782	1549786	2001-03-20	2002-03-15	1	11761
30351	2052	738818	2000-11-29	2000-12-06	1	11297
75128	5142	1361711	2012-12-18	2012-12-18	1	15692
23412	1588	738818	2015-07-05	2015-07-12	1	16628
48967	3332	1125315	2014-06-15	2014-06-15	1	16236
68675	4685	1347450	1992-05-25	1992-05-25	1	8180
25643	1738	19127890	1986-04-25	1987-04-20	1	6318
74549	5099	1125315	1953-10-18	1953-11-01	1	-5905
22731	1542	1119510	1970-09-01	1970-09-15	1	257
72380	4945	1713332	1964-03-14	1964-04-04	1	-2098
21002	1433	738818	1975-05-28	1975-06-11	1	1987
68001	4641	1125315	1981-07-12	1981-07-26	1	4224
19870	1354	1713332	1993-03-15	1993-03-29	1	8488
22587	1535	1125315	1986-10-28	1986-11-11	1	6158
70705	4829	1503184	1992-10-30	1993-10-25	1	8698
30324	2051	933724	2018-01-15	2018-01-22	1	17553
72536	4957	1125315	1978-11-12	1978-11-19	1	3244
30716	2078	1112807	1982-07-09	1982-07-23	1	4586
69684	4755	1125315	1941-07-27	1941-08-03	1	-10378
23091	1568	1125315	1975-02-12	1975-02-19	1	1875
56658	3859	1713332	1926-12-03	1926-12-17	1	-15721
71198	4859	1125315	1963-10-17	1963-10-31	1	-2254
27342	1847	1125315	1961-09-24	1961-10-08	1	-3007
29320	1982	1125315	1960-02-14	1960-02-21	1	-3602
51787	3527	1347450	2013-11-28	2013-11-28	1	16037
20310	1384	1713332	1984-06-03	1984-06-17	1	5281
65389	4470	1738521	1972-02-08	1972-02-22	1	782
23726	1606	1125315	1995-05-04	1995-05-18	1	9268
62813	4289	1759842	2001-11-23	2001-12-14	1	11670
22886	1553	1125315	1982-10-03	1982-10-17	1	4672
67720	4623	975125	1955-05-18	1955-05-18	1	-5342
24026	1626	1118084	1970-01-10	1970-01-10	1	9
65450	4472	1125315	1960-09-16	1960-09-30	1	-3380
26896	1819	1115008	1999-09-26	1999-10-10	1	10874
68361	4666	1503184	1988-06-19	1989-06-14	1	7104
22487	1529	1717327	1966-07-06	1966-07-20	1	-1261
28846	1951	1118084	2013-10-27	2013-10-27	1	16005
65628	4482	1125315	2003-10-08	2003-10-22	1	12347
61082	4165	1118084	1950-06-28	1950-06-28	1	-7127
33302	2260	1177480	1994-09-02	1994-12-01	1	9100
22844	1550	1713332	2014-11-13	2014-12-04	1	16408
73794	5045	1503184	1979-03-04	1981-02-21	2	4069
16284	1125	1112807	1952-09-11	1952-10-09	1	-6293
66119	4520	1112807	1930-11-08	1930-11-22	1	-14285
51117	3481	1539403	1995-06-24	1995-06-24	1	9305
72168	4929	1713332	1989-02-23	1989-03-16	1	7014
29028	1966	1125315	2019-04-20	2019-05-04	1	18020
32746	2218	920293	2015-06-19	2015-06-26	1	16612
21831	1486	1728416	1960-05-24	1960-06-07	1	-3495
70916	4844	1125315	1960-04-21	1960-05-05	1	-3528
21317	1450	1713332	2009-01-29	2009-02-05	1	14280
35976	2443	1759842	1995-06-12	1995-09-25	1	9398
22706	1540	1713332	2009-05-27	2009-06-17	1	14412
32979	2233	1125315	1973-01-28	1973-02-04	1	1130
70043	4782	1729720	2018-03-17	2018-03-24	1	17614
30352	2052	1125315	1964-02-24	1964-03-09	1	-2124
75129	5142	1539403	1995-09-12	1995-09-12	1	9385
23413	1588	920293	2011-12-16	2011-12-23	1	15331
48968	3332	1177480	1983-01-01	1983-01-22	1	4769
68676	4685	1124957	1975-01-22	1975-01-22	1	1847
28054	1903	723013	1975-06-16	1976-01-05	1	2195
74550	5099	1713332	1949-03-09	1949-03-16	1	-7596
22732	1542	1125315	2012-10-13	2012-10-27	1	15640
72381	4945	1713332	1995-07-10	1995-07-17	1	9328
21003	1433	1119510	1970-01-13	1970-01-27	1	26
68002	4641	1125315	2017-07-20	2017-08-03	1	17381
19871	1354	1759842	2009-11-23	2009-11-30	1	14578
22588	1535	1177480	1999-09-10	1999-10-01	1	10865
70706	4829	1503184	1995-10-15	1996-10-09	1	9778
30325	2051	1112807	1967-03-27	1967-04-10	1	-997
72537	4957	1177480	1986-08-14	1986-11-12	1	6159
30717	2078	1177480	2008-05-23	2008-06-13	1	14043
69685	4755	1713332	2013-11-04	2013-11-25	1	16034
23092	1568	1125315	1986-01-03	1986-01-10	1	5853
56659	3859	1713332	1954-02-05	1954-02-19	1	-5795
71199	4859	1125315	1985-09-22	1985-10-06	1	5757
27343	1847	1759842	1947-04-24	1947-05-15	1	-8267
29321	1982	1177480	1983-10-02	1983-10-23	1	5043
51788	3527	1713332	2001-05-19	2001-06-09	1	11482
20311	1384	1713332	1986-12-09	1986-12-23	1	6200
65390	4470	1738521	1973-06-10	1973-06-24	1	1270
23727	1606	1768849	1995-05-04	1995-05-18	1	9268
62814	4289	1112807	1951-05-03	1951-06-07	1	-6783
22887	1553	1713332	1989-11-18	1989-12-09	1	7282
67721	4623	1112807	1938-03-28	1938-05-02	1	-11567
24027	1626	1125315	1977-07-22	1977-08-19	1	2787
65451	4472	1125315	1987-02-03	1987-02-17	1	6256
26897	1819	1177480	2007-02-14	2007-03-14	1	13586
68362	4666	1521369	1991-06-04	1992-05-29	1	8184
22488	1529	1728416	1966-04-25	1966-05-09	1	-1333
28847	1951	1125315	1982-10-05	1982-10-19	1	4674
65629	4482	1125315	2019-01-19	2019-01-26	1	17922
61083	4165	1119510	1960-10-22	1960-11-05	1	-3344
33303	2260	1125315	1952-02-17	1952-02-24	1	-6521
22845	1550	1759842	2014-11-13	2014-12-04	1	16408
73795	5045	1521369	1975-03-25	1978-03-09	3	2989
16285	1125	1118084	1986-06-30	1986-06-30	1	6024
66120	4520	1125315	1981-02-24	1981-03-10	1	4086
51118	3481	1112807	1986-03-05	1986-04-09	1	5942
72169	4929	1729720	1994-01-12	1994-01-19	1	8784
29029	1966	1728416	1966-10-02	1966-10-16	1	-1173
32747	2218	1112807	1984-02-12	1984-02-26	1	5169
21832	1486	914335	2001-12-23	2001-12-23	1	11679
70917	4844	1125315	1990-01-12	1990-01-19	1	7323
21318	1450	1728416	1968-09-03	1968-09-17	1	-471
38987	2651	1119510	1963-09-17	1963-09-24	1	-2291
22707	1540	1728416	1964-07-26	1964-08-09	1	-1971
32980	2233	1125315	2009-04-10	2009-04-24	1	14358
70044	4782	19127890	2000-03-25	2001-03-20	1	11401
30353	2052	1125315	1973-03-28	1973-04-04	1	1189
75130	5142	1545958	2012-04-03	2012-04-03	1	15433
23414	1588	1125315	1961-08-31	1961-09-14	1	-3031
48969	3332	1503184	1975-11-28	1977-11-17	2	2877
68677	4685	1728416	1957-12-10	1957-12-24	1	-4391
28055	1903	723013	1978-05-02	1978-07-18	1	3120
74551	5099	1713332	1989-02-23	1989-03-09	1	7007
22733	1542	738818	1970-09-01	1970-09-15	1	257
72382	4945	1713332	1997-02-14	1997-02-21	1	9913
21004	1433	1119510	1980-07-12	1980-07-26	1	3859
68003	4641	1137529	2001-09-06	2001-09-06	1	11571
19872	1354	738818	1980-06-26	1980-07-03	1	3836
22589	1535	1713332	1981-11-03	1981-11-10	1	4331
70707	4829	1549786	1994-10-20	1995-10-15	1	9418
30326	2051	1125315	1969-03-18	1969-04-01	1	-275
72538	4957	1177480	2004-11-07	2004-12-05	1	12757
30718	2078	1125315	1995-08-30	1995-08-30	1	9372
69686	4755	1112807	1925-12-02	1926-03-02	1	-16011
23093	1568	1728416	1956-10-09	1956-10-23	1	-4818
57793	3941	920293	1992-02-10	1992-02-17	1	8082
71200	4859	1746114	1971-06-05	1971-06-05	1	520
27344	1847	920293	1963-12-06	1963-12-13	1	-2211
29322	1982	1332418	1994-11-10	1994-11-10	1	9079
51789	3527	1729720	1975-06-28	1975-07-08	1	2014
20312	1384	1112807	1984-06-03	1984-06-17	1	5281
65391	4470	1112807	1992-05-23	1992-06-13	1	8199
23728	1606	738818	1999-04-16	1999-04-30	1	10711
62815	4289	1112807	1965-03-25	1965-04-08	1	-1729
22888	1553	1713332	2009-12-14	2009-12-21	1	14599
67722	4623	1119510	1986-08-26	1986-09-09	1	6095
24028	1626	1125315	1989-12-17	1989-12-17	1	7290
65452	4472	1713332	1966-07-14	1966-07-21	1	-1260
26898	1819	1503184	1992-05-15	1993-05-10	1	8530
68363	4666	1521369	1988-06-19	1989-06-14	1	7104
22489	1529	1759842	1991-09-18	1991-10-09	1	7951
28848	1951	1125315	2003-04-10	2003-04-24	1	12166
65630	4482	1728416	1952-11-15	1952-11-29	1	-6242
61084	4165	1125315	1992-02-08	1992-02-15	1	8080
33304	2260	1125315	1997-05-29	1997-06-12	1	10024
22846	1550	1125315	1981-02-07	1981-05-08	1	4145
42754	2896	738818	2013-07-27	2013-08-03	1	15920
16286	1125	1119510	1958-09-11	1958-09-25	1	-4116
66121	4520	1112807	1938-10-13	1938-11-03	1	-11382
51119	3481	1174888	2015-04-04	2015-04-04	1	16529
72170	4929	1759842	1989-02-23	1989-03-16	1	7014
29030	1966	1112807	1966-10-02	1966-10-16	1	-1173
32748	2218	1125315	1980-12-08	1980-12-22	1	4008
21833	1486	1112807	1970-08-20	1970-09-03	1	245
70918	4844	1125315	1994-06-25	1994-07-09	1	8955
21319	1450	738818	2015-11-24	2015-12-08	1	16777
38988	2651	1125315	1951-04-27	1951-05-04	1	-6817
22708	1540	1115008	1998-09-21	1998-10-05	1	10504
32981	2233	1521369	1988-01-18	1989-01-12	1	6951
70045	4782	1119510	2004-05-18	2004-05-25	1	12563
30354	2052	1125315	1978-05-04	1978-05-18	1	3059
75131	5142	1713332	1981-11-28	1981-12-19	1	4370
23415	1588	1125315	2004-01-17	2004-01-24	1	12441
48970	3332	738818	1982-03-25	1982-04-01	1	4473
73411	5022	1521369	1983-12-18	1984-12-12	1	5459
28056	1903	1115008	2019-01-01	2019-01-22	1	17918
74552	5099	1729720	2017-04-07	2017-04-16	1	17272
22734	1542	1112807	1966-06-22	1966-07-06	1	-1275
72383	4945	1729720	1994-11-08	1994-11-18	1	9087
21005	1433	1125315	1975-05-28	1975-06-11	1	1987
68004	4641	1729720	1967-10-14	1967-10-27	1	-797
19873	1354	738818	2013-12-06	2013-12-13	1	16052
22590	1535	1717327	1978-05-03	1978-05-17	1	3058
70708	4829	1549786	1996-10-09	1998-09-29	2	10498
30327	2051	1125315	1981-08-22	1981-09-12	1	4272
72539	4957	1503184	1985-09-28	1987-09-18	2	6469
30719	2078	1759842	1982-08-17	1982-08-24	1	4618
69687	4755	1119510	1941-07-27	1941-08-03	1	-10378
23094	1568	1713332	2003-05-20	2003-05-27	1	12199
57794	3941	933724	1992-02-10	1992-02-17	1	8082
71201	4859	1759842	1967-10-19	1967-11-09	1	-784
27345	1847	1112807	1926-06-08	1926-07-08	1	-15883
29323	1982	1729720	1954-01-14	1954-01-27	1	-5818
51790	3527	1112807	1963-04-04	1963-07-03	1	-2374
20313	1384	1500211	2001-02-14	2002-02-09	1	11727
65392	4470	1713332	1996-04-05	1996-04-19	1	9605
23729	1606	1119510	1999-04-16	1999-04-30	1	10711
62816	4289	1125315	1994-06-26	1994-07-10	1	8956
22889	1553	1759842	1989-11-18	1989-12-09	1	7282
67723	4623	1124300	1971-08-22	1971-08-22	1	598
24029	1626	1149380	2001-09-30	2001-09-30	1	11595
65453	4472	1713332	1970-12-22	1971-01-05	1	369
26899	1819	1549786	1994-05-05	1996-04-24	2	9610
68364	4666	1759842	1993-08-29	1993-09-19	1	8662
22490	1529	1759842	2018-03-15	2018-04-05	1	17626
28849	1951	1177480	2012-01-22	2012-02-26	1	15396
65631	4482	1759842	1991-02-22	1991-03-15	1	7743
61085	4165	1177480	1983-09-10	1983-09-24	1	5014
33305	2260	1174888	1994-09-02	1994-09-02	1	9010
24500	1656	1118084	2018-07-04	2018-07-04	1	17716
42755	2896	1125315	2013-07-27	2013-08-03	1	15920
16287	1125	1125315	1956-07-20	1956-08-03	1	-4899
66122	4520	1125315	1972-01-13	1972-01-20	1	749
51120	3481	1545958	2015-04-04	2015-04-04	1	16529
72171	4929	1125315	1969-12-18	1970-03-18	1	76
29031	1966	1115008	2003-06-08	2003-07-06	1	12239
32749	2218	1521369	1999-04-13	2001-04-02	2	11414
21834	1486	1503184	1976-05-30	1977-05-25	1	2701
70919	4844	1551099	1973-10-17	1973-10-17	1	1385
21320	1450	1112807	1965-11-27	1966-01-01	1	-1461
38989	2651	1729720	1973-11-08	1973-11-17	1	1416
22709	1540	1125315	1966-06-18	1966-07-02	1	-1279
32982	2233	1713332	2015-03-15	2015-03-29	1	16523
70046	4782	1125315	2004-05-18	2004-05-25	1	12563
30355	2052	1125315	2000-11-29	2000-12-06	1	11297
75132	5142	1738521	1978-01-23	1978-02-27	1	2979
23416	1588	1125315	2015-07-05	2015-07-12	1	16628
48971	3332	920293	1980-02-25	1980-03-10	2	3721
73412	5022	1759842	1998-01-01	1998-01-08	1	10234
28057	1903	1125315	1995-09-14	1995-09-28	1	9401
74553	5099	738818	1949-10-01	1949-10-08	1	-7390
22735	1542	1125315	1970-09-01	1970-09-15	1	257
73922	5053	738818	2018-07-21	2018-07-28	1	17740
21006	1433	1125315	1978-11-11	1978-11-18	1	3243
68005	4641	19127890	1985-06-18	1986-06-13	1	6007
19874	1354	1124300	2019-06-16	2019-06-16	1	18063
22591	1535	1729720	1999-10-19	1999-10-28	1	10892
70709	4829	19127890	1987-11-26	1988-11-20	1	6898
30328	2051	1125315	2002-08-07	2002-08-14	1	11913
73711	5041	1112807	1971-04-23	1971-05-07	1	491
31811	2152	1125315	1972-11-25	1972-12-09	1	1073
69688	4755	1177480	2014-05-24	2014-06-23	1	16244
23095	1568	1759842	2003-05-20	2003-05-27	1	12199
57795	3941	1115008	2017-02-07	2017-02-28	1	17225
71202	4859	920293	2002-05-25	2002-06-01	1	11839
27346	1847	1125315	1926-12-24	1927-01-07	1	-15700
29324	1982	1729720	1992-10-26	1992-11-05	1	8344
51791	3527	1125315	1969-06-03	1969-06-17	1	-198
20314	1384	1503184	1997-03-07	1999-02-25	2	10647
65393	4470	1759842	1996-04-05	1996-04-19	1	9605
23730	1606	1124300	1989-05-12	1989-05-12	1	7071
62817	4289	1125315	2017-05-10	2017-08-08	1	17386
22890	1553	1759842	2009-12-14	2009-12-21	1	14599
67724	4623	1729720	1931-06-06	1931-06-14	1	-14081
24030	1626	1154029	1989-12-17	1989-12-17	1	7290
65454	4472	1759842	1956-08-28	1956-11-13	1	-4797
26900	1819	1713332	2013-03-14	2013-04-04	1	15799
68365	4666	1115008	2015-08-22	2015-09-05	1	16683
22491	1529	1112807	1966-07-06	1966-07-20	1	-1261
28850	1951	1713332	2015-12-22	2016-01-05	1	16805
67324	4596	738818	1958-11-14	1958-11-21	1	-4059
61086	4165	1309944	1991-01-27	1991-01-27	1	7696
33306	2260	1557272	2012-09-30	2012-09-30	1	15613
24501	1656	1521369	1997-10-22	1998-10-17	1	10516
42756	2896	1112807	1970-10-14	1970-10-28	1	300
16288	1125	1125315	1959-11-20	1959-11-27	1	-3688
66123	4520	1125315	1985-02-13	1985-03-06	1	5543
51121	3481	1118084	2014-06-05	2014-06-05	1	16226
72172	4929	1521369	1976-12-07	1978-11-27	2	3252
31976	2164	1125315	1982-10-07	1982-10-28	1	4683
32750	2218	920293	2016-07-23	2016-07-30	1	17012
23059	1566	1118084	2002-11-10	2002-11-10	1	12001
70920	4844	1551099	1978-03-27	1978-03-27	1	3007
21321	1450	1125315	1970-03-08	1970-03-15	1	73
38990	2651	1729720	2014-07-28	2014-08-06	1	16288
22710	1540	1174888	1973-04-10	1973-04-10	1	1195
32983	2233	1729720	1976-01-15	1976-01-27	1	2217
70047	4782	1519936	2008-02-12	2009-02-06	1	14281
30356	2052	1309944	2015-10-19	2015-10-19	1	16727
75133	5142	1118084	1985-03-19	1985-03-19	1	5556
23417	1588	1521369	1980-10-30	1981-10-25	1	4315
48972	3332	1115008	2014-06-08	2014-08-14	1	16296
73413	5022	920293	1993-01-21	1993-01-28	1	8428
28058	1903	1125315	2016-07-20	2016-07-27	1	17009
74554	5099	1124957	1989-02-23	1989-02-23	1	6993
22736	1542	1125315	2016-10-19	2016-11-02	1	17107
73923	5053	1124300	1987-06-05	1987-06-05	1	6364
21007	1433	933724	2019-02-13	2019-02-20	1	17947
68006	4641	1503184	1985-06-18	1986-06-13	1	6007
19875	1354	1125315	1980-06-26	1980-07-03	1	3836
22592	1535	1759842	1981-11-03	1981-11-10	1	4331
70710	4829	1125315	1972-11-04	1972-11-18	1	1052
30329	2051	1177480	2012-12-28	2013-01-27	1	15732
73712	5041	1503184	1984-11-20	1985-11-15	1	5797
31812	2152	1347450	2007-09-08	2007-09-08	1	13764
69689	4755	1759842	1973-08-30	1973-09-13	1	1351
23096	1568	1112807	1960-03-22	1960-05-21	1	-3512
57796	3941	1118084	1999-08-01	1999-08-01	1	10804
71203	4859	1112807	1955-10-17	1955-10-31	1	-5176
27347	1847	1177480	1981-05-03	1981-05-17	1	4154
29458	1992	920293	2011-04-22	2011-04-29	1	15093
51792	3527	1125315	1979-01-15	1979-01-15	1	3301
20315	1384	1713332	2003-09-20	2003-10-11	1	12336
65394	4470	1125315	1996-11-30	1996-12-07	1	9837
23731	1606	1125315	1999-04-16	1999-04-30	1	10711
62818	4289	1729720	2001-06-24	2001-07-05	1	11508
22891	1553	1119510	1979-11-09	1979-11-16	1	3606
67725	4623	1728416	1946-04-15	1946-04-29	1	-8648
24031	1626	1322184	2006-10-29	2006-10-29	1	13450
65860	4500	723013	1962-08-22	1963-04-10	1	-2458
26901	1819	1759842	2013-03-14	2013-04-04	1	15799
68366	4666	1177480	1978-04-03	1978-04-17	1	3028
22492	1529	1112807	1968-06-30	1968-08-04	1	-515
28851	1951	1759842	2015-12-22	2016-01-05	1	16805
67325	4596	1115008	2013-06-22	2013-07-06	1	15892
61087	4165	1343916	1991-01-27	1991-01-27	1	7696
33307	2260	1125315	1994-09-02	1994-09-02	1	9010
24502	1656	1521369	2013-08-13	2014-08-08	1	16290
42757	2896	1124300	2002-03-05	2002-03-05	1	11751
16289	1125	1713332	1964-10-02	1964-10-23	1	-1896
66124	4520	1125315	1996-09-28	1996-09-28	1	9767
51122	3481	1125315	2015-04-04	2015-04-04	1	16529
72173	4929	1521369	1981-11-11	1982-11-06	1	4692
31977	2164	1125315	1992-02-07	1992-02-14	1	8079
32751	2218	1124300	2011-08-03	2011-08-03	1	15189
23060	1566	1119510	2000-08-13	2000-08-20	1	11189
70921	4844	1713332	2005-03-28	2005-04-04	1	12877
21322	1450	1125315	1991-12-31	1992-01-14	1	8048
38991	2651	1112807	1952-05-24	1952-06-23	1	-6401
22711	1540	1729720	1960-01-23	1960-01-30	1	-3624
32984	2233	1759842	2015-03-15	2015-03-29	1	16523
70048	4782	1595799	2001-03-20	2002-03-15	1	11761
30357	2052	1729720	1987-03-26	1987-04-07	1	6305
75134	5142	1125315	1963-11-12	1963-11-26	1	-2228
23418	1588	1521369	1982-10-20	1985-10-04	3	5755
48973	3332	1125315	1962-04-30	1962-05-14	1	-2789
73414	5022	933724	1993-01-21	1993-01-28	1	8428
28059	1903	1177480	2014-01-29	2014-02-26	1	16127
74555	5099	1125315	1949-10-01	1949-10-08	1	-7390
22737	1542	1713332	1976-09-02	1976-09-16	1	2450
73924	5053	1125315	2001-07-15	2001-07-29	1	11532
21008	1433	1118084	1995-08-18	1995-08-18	1	9360
68007	4641	1515774	1992-05-12	1993-05-07	1	8527
19876	1354	1125315	1981-07-29	1981-08-12	1	4241
22593	1535	738818	1998-03-29	1998-04-05	1	10321
70711	4829	1125315	1983-09-10	1983-09-24	1	5014
30330	2051	1521369	1977-11-09	1978-11-04	1	3229
73713	5041	1521369	1987-11-05	1989-10-25	2	7237
31813	2152	1729720	1924-06-18	1924-06-27	1	-16624
69690	4755	1759842	2013-11-04	2013-11-25	1	16034
23097	1568	1118084	1993-05-13	1993-05-13	1	8533
57797	3941	1125315	1963-12-19	1964-01-02	1	-2191
71204	4859	1119510	1963-10-17	1963-10-31	1	-2254
27348	1847	1125315	1949-05-10	1949-05-17	1	-7534
29459	1992	1115008	2016-09-18	2016-10-23	1	17097
54750	3725	1112807	1970-09-23	1970-10-14	1	286
20316	1384	1713332	2012-08-16	2012-08-23	1	15575
65395	4470	1125315	2007-04-24	2007-05-01	1	13634
23732	1606	1125315	2011-04-13	2011-04-20	1	15084
62819	4289	920293	1984-08-24	1984-08-31	1	5356
22892	1553	1119510	1969-03-30	1969-04-06	1	-270
67726	4623	1729720	1968-02-05	1968-02-16	1	-685
24032	1626	1326303	1995-08-27	1995-08-27	1	9369
65861	4500	1125315	1989-10-17	1989-10-24	1	7236
26902	1819	1778162	1999-09-26	1999-10-10	1	10874
68367	4666	1503184	1991-06-04	1992-05-29	1	8184
22493	1529	1125315	1974-10-02	1974-12-31	1	1825
29909	2025	738818	1926-06-22	1926-06-29	1	-15892
67326	4596	1118084	1979-01-27	1979-01-27	1	3313
61088	4165	1713332	1946-03-20	1946-03-27	1	-8681
33308	2260	738818	1969-10-15	1969-10-22	1	-71
24503	1656	1549786	1993-11-12	1994-11-07	1	9076
42758	2896	1125315	1987-05-23	1987-05-30	1	6358
16290	1125	738818	1958-09-11	1958-09-25	1	-4116
66125	4520	1137529	1957-09-14	1957-09-14	1	-4492
51123	3481	1361711	1995-06-24	2015-04-04	1	16529
72174	4929	1729720	1968-02-15	1968-02-26	1	-675
31978	2164	1177480	2014-05-04	2014-05-18	1	16208
32752	2218	1125315	2005-06-02	2005-06-09	1	12943
23061	1566	1119510	2017-03-16	2017-03-23	1	17248
70922	4844	1728416	1960-04-21	1960-05-05	1	-3528
21323	1450	1125315	2015-11-24	2015-12-08	1	16777
38992	2651	1115008	2006-07-11	2006-07-25	1	13354
22712	1540	1729720	1986-04-12	1986-04-25	1	5958
32985	2233	1115008	1997-06-24	1997-07-29	1	10071
70049	4782	19127890	1995-04-21	1996-04-15	1	9601
32555	2206	1118084	2008-03-13	2008-03-13	1	13951
75135	5142	1125315	2013-07-23	2013-08-22	1	15939
23419	1588	1713332	1998-12-11	1999-01-01	1	10592
48974	3332	1125315	1976-07-31	1976-08-07	1	2410
73415	5022	1112807	1977-07-10	1977-09-08	1	2807
28060	1903	1729720	1969-05-16	1969-05-29	1	-217
74556	5099	1125315	1969-02-13	1969-02-27	1	-308
22738	1542	1125315	1986-12-27	1987-01-10	1	6218
73925	5053	1125315	2018-07-21	2018-07-28	1	17740
21009	1433	1125315	2004-01-09	2004-01-16	1	12433
68008	4641	1521369	1985-06-18	1986-06-13	1	6007
19877	1354	1125315	1995-05-29	1995-05-29	1	9279
22594	1535	1102527	2008-02-16	2008-02-16	1	13925
70712	4829	1515774	1994-10-20	1995-10-15	1	9418
30331	2051	1112807	1963-11-13	1963-12-04	1	-2220
73714	5041	1115008	1994-08-20	1994-09-24	1	9032
31814	2152	738818	2005-01-26	2005-02-09	1	12823
69691	4755	738818	2001-03-22	2001-04-05	1	11417
23098	1568	1119510	1975-02-12	1975-02-19	1	1875
57798	3941	1713332	1983-06-26	1983-07-10	1	4938
71205	4859	1125315	1956-08-29	1956-09-12	1	-4859
27349	1847	1713332	1947-04-24	1947-05-15	1	-8267
29460	1992	1124957	2015-10-24	2015-10-24	1	16732
54751	3725	1118084	2006-11-13	2006-11-13	1	13465
20317	1384	1125315	1986-12-09	1986-12-23	1	6200
65396	4470	1112807	1972-02-08	1972-02-22	1	782
23733	1606	1728416	1953-12-12	1954-01-16	1	-5829
62820	4289	933724	1984-08-24	1984-08-31	1	5356
22893	1553	1124300	2011-05-18	2011-05-18	1	15112
69312	4729	738818	2018-07-02	2018-07-09	1	17721
24033	1626	1332418	2006-10-29	2006-10-29	1	13450
65862	4500	1177480	1984-03-16	1984-03-30	1	5202
26903	1819	738818	1989-08-20	1989-08-27	1	7178
68368	4666	1515774	1993-05-24	1995-05-14	2	9264
22494	1529	1717327	1963-02-27	1963-03-13	1	-2486
29910	2025	738818	2014-05-16	2014-05-30	1	16220
67327	4596	1119510	1957-10-25	1957-11-08	1	-4437
61089	4165	738818	1932-01-15	1932-01-29	1	-13852
33309	2260	1125315	1969-10-15	1969-10-22	1	-71
24504	1656	1589505	2009-08-24	2010-08-24	1	14845
42759	2896	1125315	2017-09-29	2017-10-13	1	17452
16291	1125	1112807	1967-01-08	1967-03-09	1	-1029
66126	4520	1149380	1957-09-14	1957-09-14	1	-4492
52359	3567	1119510	1991-12-21	1992-01-04	1	8038
73656	5037	1119510	2014-08-03	2014-08-17	1	16299
31979	2164	1713332	1984-02-02	1984-02-23	1	5166
32753	2218	1515774	1995-05-04	1996-04-28	1	9614
23062	1566	1154343	1970-11-10	1970-11-10	1	313
70923	4844	1759842	2005-03-28	2005-04-04	1	12877
21324	1450	1177480	1994-11-21	1994-12-12	1	9111
38993	2651	1125315	1951-06-24	1951-07-29	1	-6731
22713	1540	1759842	2009-05-27	2009-06-17	1	14412
32986	2233	1119510	1986-01-03	1986-01-10	1	5853
70050	4782	738818	2004-05-18	2004-05-25	1	12563
32556	2206	1125315	2006-08-25	2006-09-08	1	13399
75136	5142	1322184	2012-12-18	2012-12-18	1	15692
23420	1588	1759842	1989-11-01	1989-11-22	1	7265
48975	3332	1125315	1982-03-25	1982-04-01	1	4473
73416	5022	1119510	1987-08-29	1987-09-12	1	6463
28061	1903	723013	1976-04-20	1977-01-11	1	2567
74557	5099	1125315	2017-02-16	2017-03-02	1	17227
22739	1542	1177480	1978-02-19	1978-03-05	1	2985
73926	5053	1759842	1989-06-13	1989-06-20	1	7110
21010	1433	1713332	1994-01-25	1994-02-15	1	8811
68009	4641	1713332	2006-08-07	2006-08-28	1	13388
19878	1354	1125315	2013-12-06	2013-12-13	1	16052
22595	1535	1119510	1986-10-28	1986-11-11	1	6158
70713	4829	1515774	1996-10-09	1998-09-29	2	10498
30332	2051	1125315	1984-04-14	1984-04-21	1	5224
73715	5041	1125315	2007-02-14	2007-02-28	1	13572
31815	2152	1119510	2005-01-26	2005-02-09	1	12823
69692	4755	920293	1981-11-18	1981-11-25	1	4346
23099	1568	1125315	1960-01-22	1960-01-29	1	-3625
57799	3941	1759842	1982-01-20	1982-01-27	1	4409
71206	4859	1125315	1958-11-30	1958-12-14	1	-4036
27350	1847	1713332	1981-05-03	1981-05-17	1	4154
29461	1992	1150770	1978-04-12	1978-04-12	1	3023
54752	3725	1125315	1972-06-05	1972-08-04	1	946
20318	1384	1177480	1991-03-29	1991-04-28	1	7787
65397	4470	1118084	2012-09-20	2012-09-20	1	15603
23734	1606	1729720	1958-04-01	1958-04-11	1	-4283
62821	4289	1102527	2017-05-10	2017-05-10	1	17296
22894	1553	1125315	1967-12-05	1968-04-03	2	-654
69313	4729	1112807	1967-11-07	1968-01-06	1	-726
24034	1626	1367571	1989-12-17	1989-12-17	1	7290
65863	4500	1177480	2011-06-19	2011-07-24	1	15179
26904	1819	738818	1998-04-13	1998-04-27	1	10343
68369	4666	1549786	1993-05-24	1995-05-14	2	9264
22495	1529	1729720	1994-02-21	1994-02-28	1	8824
29911	2025	1112807	1963-04-02	1963-04-23	1	-2445
67328	4596	1125315	1978-11-24	1978-12-08	1	3263
61090	4165	1124957	1981-10-20	1981-10-20	1	4310
34048	2311	1119510	1973-08-31	1973-09-14	1	1352
24505	1656	1125315	1992-06-10	1992-08-09	1	8256
42760	2896	1112807	1989-02-04	1989-02-18	1	6988
16292	1125	1125315	1958-09-11	1958-09-25	1	-4116
66127	4520	1174888	1996-09-28	1996-09-28	1	9767
52360	3567	1125315	2002-06-29	2002-07-13	1	11881
73657	5037	1177480	1994-12-14	1995-01-04	1	9134
31980	2164	1759842	1984-02-02	1984-02-23	1	5166
32754	2218	1549786	1995-05-04	1996-04-28	1	9614
23063	1566	738818	2017-03-16	2017-03-23	1	17248
70924	4844	738818	1970-05-30	1970-06-13	1	163
21325	1450	1717327	1963-10-09	1963-10-23	1	-2262
38994	2651	1125315	1956-04-11	1956-04-25	1	-4999
22714	1540	1118084	1994-03-11	1994-03-11	1	8835
32987	2233	1125315	1987-01-13	1987-02-17	1	6256
70051	4782	1125315	1998-07-16	1998-07-23	1	10430
32557	2206	1125315	2017-09-09	2017-09-23	1	17432
75137	5142	1729720	1973-08-06	1973-08-17	1	1324
23421	1588	1119510	2010-09-03	2010-09-10	1	14862
48976	3332	1125315	1987-12-15	1987-12-29	1	6571
73417	5022	1125315	2010-01-23	2010-02-27	1	14667
28062	1903	723013	1979-06-26	1979-09-18	1	3547
74558	5099	1729720	1950-05-20	1950-05-31	1	-7155
22740	1542	1307863	2015-11-25	2015-11-25	1	16764
73927	5053	1125315	1986-02-18	1986-03-04	1	5906
21011	1433	1759842	1994-01-25	1994-02-15	1	8811
68010	4641	1738521	1975-05-02	1975-05-16	1	1961
19879	1354	1125315	2018-02-22	2018-03-01	1	17591
22596	1535	1125315	1978-05-03	1978-05-17	1	3058
70714	4829	1521369	1987-11-26	1988-11-20	1	6898
30333	2051	19127890	1977-11-09	1978-11-04	1	3229
73716	5041	1503184	1987-11-05	1989-10-25	2	7237
31816	2152	1119510	2016-10-17	2016-10-31	1	17105
69693	4755	933724	1981-11-18	1981-11-25	1	4346
23100	1568	1125315	1977-09-08	1977-09-15	1	2814
57800	3941	1125315	1964-10-30	1964-11-13	1	-1875
71207	4859	1154029	1971-06-05	1971-06-05	1	520
27351	1847	1713332	1981-11-09	1981-11-16	1	4337
29462	1992	19127890	1992-03-03	1996-02-11	4	9537
54753	3725	1713332	2007-01-14	2007-01-21	1	13534
20319	1384	1713332	1985-04-25	1985-05-09	1	5607
65398	4470	1125315	1973-06-10	1973-06-24	1	1270
23735	1606	738818	2000-12-28	2001-01-04	1	11326
62822	4289	1125315	1967-01-28	1967-02-18	1	-1048
22895	1553	1125315	1990-06-28	1990-07-19	1	7504
69314	4729	1115008	2006-12-31	2007-01-28	1	13541
24035	1626	1713332	1984-06-20	1984-07-04	1	5298
65864	4500	1192710	1963-10-04	1963-10-04	1	-2281
26905	1819	933724	2006-06-29	2006-07-06	1	13335
68370	4666	1713332	1993-08-29	1993-09-19	1	8662
23237	1577	708298	1997-01-31	1997-01-31	1	9892
29912	2025	1119510	1926-06-22	1926-06-29	1	-15892
67329	4596	1125315	1988-01-15	1988-01-29	1	6602
61091	4165	1125315	1932-01-15	1932-01-29	1	-13852
34049	2311	1124300	1993-05-11	1993-05-11	1	8531
24506	1656	1125315	1994-06-01	1994-06-15	1	8931
42761	2896	1119510	2013-07-27	2013-08-03	1	15920
16293	1125	1102527	2014-07-30	2014-07-30	1	16281
66128	4520	1332418	1994-01-22	1994-01-22	1	8787
52361	3567	1125315	2012-03-03	2012-03-17	1	15416
73658	5037	1500211	1992-02-08	1993-02-02	1	8433
31981	2164	1125315	1979-05-12	1979-05-26	1	3432
32755	2218	1549786	2000-04-07	2001-04-02	1	11414
23064	1566	1125315	1970-08-20	1970-09-19	1	261
70925	4844	738818	2001-09-12	2001-09-19	1	11584
21326	1450	1728416	1966-02-12	1966-02-26	1	-1405
38995	2651	1125315	1963-03-18	1963-04-01	1	-2467
22715	1540	1125315	1973-04-10	1973-05-10	2	1225
32988	2233	1759842	1973-11-30	1973-12-07	1	1436
70052	4782	1521369	2000-03-25	2002-03-15	2	11761
32558	2206	1503184	1985-11-29	1986-11-24	1	6171
75138	5142	1112807	1976-04-19	1976-05-03	1	2314
23422	1588	1125315	1984-10-01	1984-10-15	1	5401
48977	3332	1521369	1975-11-28	1977-11-17	2	2877
73418	5022	1738521	1972-09-06	1972-09-20	1	993
28063	1903	1112807	1964-06-08	1964-06-22	1	-2019
74559	5099	1759842	1949-03-09	1949-03-16	1	-7596
22741	1542	1326303	2015-11-25	2015-11-25	1	16764
73928	5053	1125315	1991-06-24	1991-08-23	1	7904
21012	1433	738818	1980-07-12	1980-07-26	1	3859
68011	4641	1759842	2006-08-07	2006-08-28	1	13388
19880	1354	1713332	1989-12-15	1989-12-22	1	7295
22597	1535	1125315	1989-01-03	1989-01-17	1	6956
70715	4829	1713332	2015-12-12	2015-12-19	1	16788
30334	2051	920293	2013-12-16	2013-12-23	1	16062
73717	5041	19127890	1984-11-20	1985-11-15	1	5797
31817	2152	1125315	2005-01-26	2005-02-09	1	12823
69694	4755	1125315	2001-03-22	2001-04-05	1	11417
23101	1568	1125315	2017-12-07	2017-12-28	1	17528
57801	3941	1125315	1969-06-20	1969-06-27	1	-188
71208	4859	1367571	1971-06-05	1971-06-05	1	520
27352	1847	1729720	1952-09-07	1952-09-20	1	-6312
29463	1992	933724	2011-04-22	2011-04-29	1	15093
54754	3725	1759842	2007-01-14	2007-01-21	1	13534
20320	1384	1713332	2000-01-19	2000-02-02	1	10989
65399	4470	1125315	2003-02-15	2003-03-01	1	12112
23736	1606	1125315	1988-10-08	1988-10-15	1	6862
62823	4289	1125315	2003-12-24	2003-12-31	1	12417
26473	1789	738818	1988-04-21	1988-05-05	1	6699
69315	4729	1118084	2000-03-08	2000-03-08	1	11024
24036	1626	1759842	1976-03-18	1976-04-01	1	2282
65865	4500	1551099	1962-08-09	1962-08-09	1	-2702
26906	1819	1119510	1998-04-13	1998-04-27	1	10343
68371	4666	19127890	1988-06-19	1989-06-14	1	7104
23238	1577	1000560	1997-01-31	1997-01-31	2	9892
29913	2025	1125315	1926-06-22	1926-06-29	1	-15892
67330	4596	1125315	2017-01-01	2017-01-08	1	17174
61092	4165	1125315	1981-10-20	1981-12-19	2	4370
34050	2311	1125315	1960-10-28	1960-11-04	1	-3345
24507	1656	1515774	2010-08-24	2011-08-19	1	15205
42762	2896	1125315	1972-11-02	1972-11-30	1	1064
16294	1125	1125315	2006-02-24	2006-03-10	1	13217
66129	4520	1545958	1996-09-28	1996-09-28	1	9767
52362	3567	738818	1991-12-21	1992-01-04	1	8038
73659	5037	1515774	1993-02-02	1994-01-28	1	8793
31982	2164	1125315	2018-12-26	2019-01-09	1	17905
32756	2218	1551099	1989-03-26	1989-03-26	1	7024
23065	1566	1125315	2017-03-16	2017-03-23	1	17248
70926	4844	1112807	1981-05-15	1981-06-19	1	4187
21327	1450	1125315	1963-10-09	1963-10-23	1	-2262
38996	2651	1125315	1969-11-20	1969-12-04	1	-28
27413	1851	723013	1991-01-03	1991-05-23	1	7812
32989	2233	19127890	1991-12-28	1992-12-22	1	8391
70053	4782	1729720	2006-03-11	2006-03-19	1	13226
32559	2206	1515774	1996-10-02	1997-09-27	1	10131
75139	5142	1119510	1963-11-12	1963-11-26	1	-2228
23423	1588	1125315	2018-12-30	2019-01-13	1	17909
48978	3332	1728416	1964-04-03	1964-04-17	1	-2085
73419	5022	1125315	1972-09-06	1972-09-20	1	993
28064	1903	1119510	1978-06-11	1978-06-18	1	3090
74560	5099	920293	1989-03-25	1989-04-01	1	7030
22742	1542	1728416	1966-06-22	1966-07-06	1	-1275
73929	5053	1125315	1992-07-18	1992-08-01	1	8248
21013	1433	920293	2019-02-13	2019-02-20	1	17947
68012	4641	1125315	1978-03-19	1978-03-26	1	3006
19881	1354	1713332	2007-12-04	2007-12-25	1	13872
22598	1535	1713332	1979-10-03	1979-11-06	2	3583
70716	4829	1759842	2015-12-12	2015-12-19	1	16788
30335	2051	920293	2018-01-15	2018-01-22	1	17553
73718	5041	1177480	2013-01-17	2013-03-18	1	15782
31818	2152	1310149	2008-02-23	2008-02-23	1	13932
69695	4755	1125315	2011-12-15	2011-12-22	1	15330
23963	1622	1124300	2012-12-08	2012-12-08	1	15682
57802	3941	920293	1993-03-15	1993-03-22	1	8481
71209	4859	1713332	1983-06-25	1983-07-02	1	4930
27353	1847	1759842	1981-11-09	1981-11-16	1	4337
29464	1992	1118084	2019-01-26	2019-01-26	1	17922
54755	3725	1115008	1998-07-19	1998-08-23	1	10461
20321	1384	1729720	1997-08-30	1997-09-10	1	10114
65400	4470	1125315	2017-08-09	2017-08-16	1	17394
23737	1606	1125315	2000-12-28	2001-01-04	1	11326
62824	4289	1125315	2017-11-11	2017-11-18	1	17488
26474	1789	1102527	1991-11-21	1991-11-21	1	7994
69316	4729	1125315	2018-07-02	2018-07-09	1	17721
24037	1626	753626	1989-12-17	1989-12-17	1	7290
65866	4500	1729720	2006-07-18	2006-07-27	1	13356
26907	1819	1124300	2014-08-28	2014-08-28	1	16310
68372	4666	1115008	2016-09-29	2016-10-20	1	17094
23239	1577	1112807	1926-07-19	1926-08-02	1	-15858
29914	2025	1125315	1953-08-25	1953-09-01	1	-5966
67331	4596	1326303	2013-04-14	2013-04-14	1	15809
61093	4165	1177480	1990-08-18	1990-11-16	1	7624
34051	2311	1125315	2010-11-03	2010-12-01	1	14944
24508	1656	1519936	2014-08-08	2015-08-03	1	16650
42763	2896	1125315	1985-06-29	1985-07-06	1	5665
16295	1125	1177480	2014-07-30	2014-08-29	1	16311
66130	4520	1713332	1957-09-10	1957-09-17	1	-4489
52363	3567	1124300	2004-05-10	2004-05-10	1	12548
73660	5037	1515774	1996-01-18	1998-01-07	2	10233
31983	2164	1738521	1973-08-25	1973-09-08	1	1346
32757	2218	1595799	2000-04-07	2001-04-02	1	11414
23066	1566	1149380	1970-11-10	1970-11-10	1	313
70927	4844	1125315	1970-05-30	1970-06-13	1	163
21328	1450	1125315	1995-02-09	1995-02-16	1	9177
38997	2651	1125315	2017-01-28	2017-03-04	1	17229
27414	1851	723013	1994-01-20	1994-01-20	1	8785
34369	2332	1112807	1964-08-11	1964-09-10	1	-1939
70054	4782	1118084	2017-09-07	2017-09-07	1	17416
32560	2206	1515774	1999-09-17	2000-09-11	1	11211
75140	5142	1119510	1972-07-25	1972-08-01	1	943
23424	1588	1503184	1982-10-20	1985-10-04	3	5755
48979	3332	1729720	1998-06-19	1998-06-28	1	10405
73420	5022	1125315	1984-05-04	1984-06-03	2	5267
28065	1903	1713332	2001-05-14	2001-05-21	1	11463
74561	5099	933724	1989-03-25	1989-04-01	1	7030
22743	1542	1729720	1984-10-16	1984-10-29	1	5415
73930	5053	1177480	2013-09-22	2013-10-13	1	15991
21014	1433	1119510	1975-05-28	1975-06-11	1	1987
68013	4641	1549786	1992-05-12	1993-05-07	1	8527
19882	1354	1759842	1989-12-15	1989-12-22	1	7295
22599	1535	1115008	1999-12-26	2000-01-09	1	10965
70717	4829	1125315	1973-11-13	1973-11-27	1	1426
30336	2051	1118084	2005-06-25	2005-06-25	1	12959
73719	5041	1521369	1984-11-20	1985-11-15	1	5797
31819	2152	1347450	1988-01-23	1988-01-23	1	6596
69696	4755	1713332	1928-12-22	1929-01-12	1	-14964
23964	1622	1125315	1995-11-14	1995-11-28	1	9462
57803	3941	933724	1993-03-15	1993-03-22	1	8481
74007	5060	1125315	1988-06-01	1988-07-01	1	6756
27354	1847	933724	1963-12-06	1963-12-13	1	-2211
29465	1992	1503184	1993-02-26	1994-02-21	1	8817
54756	3725	1177480	1981-09-16	1981-12-15	1	4366
20322	1384	1759842	1985-04-25	1985-05-09	1	5607
65965	4506	1125315	1960-02-22	1960-03-07	1	-3587
23738	1606	1125315	2012-08-14	2012-08-28	1	15580
62825	4289	1729720	1944-11-07	1944-11-19	1	-9174
26475	1789	1112807	1991-11-21	1992-01-20	1	8054
69317	4729	1521369	1981-01-15	1982-01-10	1	4392
24038	1626	1112807	1935-10-26	1935-11-09	1	-12472
65867	4500	1738521	1974-12-12	1974-12-26	1	1820
26908	1819	1177480	1991-06-10	1991-07-08	1	7858
68373	4666	1124300	2015-04-09	2015-04-09	1	16534
23240	1577	1125315	1972-08-25	1972-09-08	1	981
29915	2025	1125315	1979-09-01	1979-10-31	1	3590
67332	4596	1729720	1951-11-09	1951-11-17	1	-6620
61094	4165	1713332	1945-12-30	1946-01-13	1	-8754
34052	2311	1759842	1965-10-21	1965-11-11	1	-1512
24509	1656	1521369	2003-09-21	2004-09-15	1	12676
42764	2896	1125315	1999-09-24	1999-10-15	1	10879
16296	1125	1759842	1964-10-02	1964-10-23	1	-1896
66131	4520	1728416	1950-03-04	1950-03-18	1	-7229
52364	3567	1125315	1991-12-21	1992-01-04	1	8038
73661	5037	1589505	2006-11-21	2007-11-24	1	13841
31984	2164	1112807	1973-08-25	1973-09-08	1	1346
32758	2218	1713332	1980-12-08	1980-12-22	1	4008
23067	1566	1177480	1979-10-02	1979-10-30	1	3589
70928	4844	1125315	1976-05-14	1976-05-21	1	2332
21329	1450	1177480	1976-01-09	1976-01-30	1	2220
38998	2651	1154343	1948-09-24	1966-03-02	1	-1401
27415	1851	738818	2014-10-12	2014-10-19	1	16362
34370	2332	1119510	1960-06-13	1960-06-20	1	-3482
70055	4782	1503184	1995-04-21	1996-04-15	1	9601
32561	2206	1595799	2001-09-06	2002-09-01	1	11931
75141	5142	1124957	1965-07-02	1965-07-02	1	-1644
23425	1588	1713332	1985-08-11	1985-08-18	1	5708
50585	3442	1125315	1962-02-02	1962-02-16	1	-2876
73421	5022	1503184	1983-12-18	1984-12-12	1	5459
28066	1903	1759842	2001-05-14	2001-05-21	1	11463
74562	5099	1118084	1978-09-18	1978-09-18	1	3182
22744	1542	1759842	1976-09-02	1976-09-16	1	2450
73931	5053	1115008	2004-03-15	2004-04-12	1	12520
21015	1433	1125315	1980-07-12	1980-07-26	1	3859
68014	4641	1759842	1999-06-02	1999-06-09	1	10751
19883	1354	1759842	2007-12-04	2007-12-25	1	13872
22600	1535	1118084	2013-04-14	2013-04-14	1	15809
70718	4829	1125315	2007-10-07	2007-10-14	1	13800
30337	2051	1125315	1980-03-17	1980-03-31	1	3742
73720	5041	1738521	1971-04-23	1971-05-07	1	491
31820	2152	1539403	1991-03-16	1991-03-16	1	7744
69697	4755	1759842	1928-12-22	1929-01-12	1	-14964
23965	1622	1125315	1998-10-29	1998-11-05	1	10535
57804	3941	1125315	1986-05-31	1986-06-14	1	6008
74008	5060	1713332	2018-06-22	2018-06-29	1	17711
27355	1847	1112807	1915-07-06	1915-07-20	1	-19889
29466	1992	1515774	1992-03-03	1993-02-26	1	8457
54757	3725	1729720	2016-03-20	2016-04-01	1	16892
20323	1384	1759842	2000-01-19	2000-02-02	1	10989
65966	4506	1713332	1983-12-21	1984-01-04	1	5116
25940	1756	1118084	2013-05-18	2013-05-18	1	15843
62826	4289	1729720	2016-09-24	2016-10-07	1	17081
26476	1789	1125315	1988-04-21	1988-05-05	1	6699
69318	4729	1125315	1984-12-27	1985-01-03	1	5481
24039	1626	1112807	1937-07-30	1937-08-13	1	-11829
65868	4500	740275	1961-09-13	1962-01-03	1	-2920
26909	1819	1515774	1994-05-05	1996-04-24	2	9610
68374	4666	1125315	1976-11-09	1976-12-14	1	2539
23241	1577	1125315	1990-06-07	1990-06-21	1	7476
29916	2025	1125315	1984-07-06	1984-08-03	1	5328
67333	4596	1759842	1957-11-11	1957-12-02	1	-4413
61095	4165	1729720	1938-05-15	1938-05-28	1	-11541
34053	2311	738818	1972-04-22	1972-05-06	1	856
24510	1656	19127890	2010-08-24	2011-08-19	1	15205
42765	2896	1125315	2016-01-19	2016-02-09	1	16840
24798	1674	1125315	1990-06-09	1990-06-16	1	7471
66132	4520	1729720	1940-04-04	1940-04-12	1	-10856
52365	3567	1521369	1987-06-02	1989-05-22	2	7081
73662	5037	1595799	1999-12-28	2000-12-22	1	11313
31985	2164	1118084	2012-08-05	2012-08-05	1	15557
32759	2218	19127890	1999-04-13	2000-04-07	1	11054
23068	1566	1713332	1994-08-31	1994-09-07	1	9015
70929	4844	1125315	1993-10-19	1993-10-26	1	8699
21330	1450	738818	1999-11-03	1999-11-17	1	10912
38999	2651	1728416	1951-05-25	1951-06-08	1	-6782
27416	1851	1125315	2014-10-12	2014-10-19	1	16362
34371	2332	1119510	1994-12-30	1995-01-13	1	9143
70056	4782	1521369	1995-04-21	1996-04-15	1	9601
32562	2206	738818	2001-04-08	2001-04-22	1	11434
75142	5142	1125315	1999-03-30	1999-04-13	1	10694
23426	1588	1713332	2010-07-20	2010-07-27	1	14817
50586	3442	1125315	1965-03-19	1965-03-26	1	-1742
73422	5022	1713332	1998-01-01	1998-01-08	1	10234
28067	1903	738818	1978-06-11	1978-06-18	1	3090
74563	5099	1125315	1989-02-23	1989-03-09	2	7007
25006	1692	1759842	2000-08-05	2000-08-12	1	11181
73932	5053	1119510	2018-07-21	2018-07-28	1	17740
21016	1433	1125315	1989-05-01	1989-05-29	1	7088
68015	4641	1759842	2013-04-28	2013-05-12	1	15837
21237	1446	1177480	2008-09-25	2008-10-16	1	14168
22601	1535	1125315	1995-11-21	1995-11-28	1	9462
70719	4829	1738521	1972-11-04	1972-11-18	1	1052
30338	2051	1177480	1974-05-10	1974-05-31	1	1611
73721	5041	1118084	2013-10-04	2013-10-04	1	15982
31821	2152	1112807	1949-08-02	1949-08-16	1	-7443
70808	4837	1112807	1949-09-17	1949-10-01	1	-7397
23966	1622	1125315	2000-10-28	2000-12-02	1	11293
57805	3941	1713332	1982-01-20	1982-01-27	1	4409
74009	5060	1738521	1976-12-31	1977-01-14	1	2570
27356	1847	1125315	1919-12-13	1919-12-20	1	-18275
29467	1992	1515774	1994-02-21	1996-02-11	2	9537
56287	3835	1112807	1966-08-14	1966-09-11	1	-1208
20324	1384	19127890	1997-03-07	1999-02-25	2	10647
65967	4506	1759842	1983-12-21	1984-01-04	1	5116
25941	1756	1119510	2008-02-19	2008-02-26	1	13935
62827	4289	1759842	1968-12-18	1968-12-25	1	-372
26477	1789	1154343	1979-03-05	1979-03-05	1	3350
69319	4729	1119510	2018-07-02	2018-07-09	1	17721
24040	1626	1112807	1967-08-30	1967-09-13	1	-841
65869	4500	1177480	2010-04-25	2010-07-24	1	14814
26910	1819	1521369	1992-05-15	1993-05-10	1	8530
68375	4666	1125315	1981-02-03	1981-02-17	1	4065
23242	1577	1125315	1991-01-16	1991-01-16	1	7685
29917	2025	1125315	2012-04-21	2012-04-28	1	15458
67334	4596	1112807	1971-03-24	1971-04-14	1	468
63199	4319	1115008	2013-04-19	2013-05-03	1	15828
34054	2311	1112807	1976-11-06	1976-11-20	1	2515
24511	1656	933724	2001-12-26	2002-01-02	1	11689
42766	2896	1177480	2014-10-26	2014-12-25	1	16429
24799	1674	1125315	2004-12-22	2005-01-05	1	12788
66133	4520	1759842	1946-11-02	1946-11-16	1	-8447
52366	3567	1759842	2001-07-13	2001-08-03	1	11537
73663	5037	1729720	1985-06-22	1985-07-03	1	5662
31986	2164	1125315	1978-08-30	1978-09-13	1	3177
32760	2218	933724	2015-06-19	2015-06-26	1	16612
23069	1566	1759842	1994-08-31	1994-09-07	1	9015
70930	4844	1125315	2000-09-16	2000-09-30	1	11230
21331	1450	1119510	1999-11-03	1999-11-17	1	10912
39000	2651	1728416	1963-03-18	1963-04-01	1	-2467
27417	1851	1713332	1980-02-26	1980-03-11	1	3722
34372	2332	1125315	1975-12-31	1976-01-07	1	2197
74471	5095	1102527	1978-03-09	1978-03-09	1	2989
32563	2206	1177480	1986-01-18	1986-02-17	1	5891
75143	5142	1361711	1995-09-12	2012-04-03	1	15433
23427	1588	1759842	1985-08-11	1985-08-18	1	5708
50587	3442	1177480	2014-08-03	2014-08-24	1	16306
73423	5022	19127890	1983-12-18	1984-12-12	1	5459
28068	1903	1112807	1973-07-21	1973-08-11	1	1318
74564	5099	1713332	2000-01-06	2000-01-27	1	10983
25007	1692	1515774	1991-08-08	1992-08-02	1	8249
73933	5053	1125315	1979-08-27	1979-09-10	1	3539
23580	1599	1112807	1966-11-09	1966-12-09	1	-1119
68016	4641	19127890	1992-05-12	1993-05-07	1	8527
21238	1446	1549786	2002-10-02	2004-09-21	2	12682
22602	1535	1729720	1997-01-22	1997-01-29	1	9890
70720	4829	19127890	1992-10-30	1993-10-25	1	8698
30339	2051	1503184	1977-11-09	1978-11-04	1	3229
73722	5041	19127890	1987-11-05	1989-10-25	2	7237
31822	2152	1125315	1922-08-12	1922-08-19	1	-17302
70809	4837	1119510	2006-10-28	2006-11-04	1	13456
23967	1622	1549786	1999-03-27	2000-03-21	1	11037
57806	3941	1759842	1983-06-26	1983-07-10	1	4938
74010	5060	1759842	2018-06-22	2018-06-29	1	17711
27357	1847	1125315	1990-10-28	1990-11-04	1	7612
29468	1992	1549786	1994-02-21	1996-02-11	2	9537
56288	3835	1118084	2004-08-29	2004-08-29	1	12659
20742	1412	738818	2018-07-31	2018-08-14	1	17757
65968	4506	1102527	2001-10-13	2001-10-13	1	11608
25942	1756	1125315	1995-11-06	1995-11-20	1	9454
62828	4289	1112807	1944-06-08	1944-08-07	1	-9278
26478	1789	1125315	2014-11-16	2014-11-30	1	16404
69320	4729	1177480	2000-09-05	2000-10-03	1	11233
24041	1626	1307863	1995-08-27	1995-08-27	1	9369
65870	4500	1713332	2012-03-20	2012-04-03	1	15433
26911	1819	1713332	1977-07-31	1977-10-16	1	2845
68376	4666	1125315	2003-06-16	2003-06-23	1	12226
23243	1577	1174888	1991-01-16	1991-01-16	1	7685
29918	2025	1125315	2013-10-03	2013-10-17	1	15995
67335	4596	1119510	1978-11-24	1978-12-08	1	3263
63200	4319	1125315	1998-09-19	1998-09-26	1	10495
34055	2311	1125315	1963-03-25	1963-04-08	1	-2460
24512	1656	1177480	1981-06-08	1981-07-08	1	4206
42767	2896	1192710	1974-04-12	1974-04-12	1	1562
24800	1674	1125315	2008-09-07	2008-09-16	2	14136
66134	4520	1759842	1955-03-13	1955-03-20	1	-5401
52367	3567	1759842	2016-09-15	2016-10-06	1	17080
73664	5037	738818	2014-08-03	2014-08-17	1	16299
31987	2164	1125315	1991-10-01	1991-10-08	1	7950
32761	2218	1177480	1986-09-08	1986-09-29	1	6115
23070	1566	738818	2000-08-13	2000-08-20	1	11189
70931	4844	1551099	1975-03-12	1975-03-12	1	1896
21332	1450	1125315	1965-01-13	1965-01-27	1	-1800
39001	2651	738818	1963-09-17	1963-09-24	1	-2291
27418	1851	738818	2001-01-15	2001-01-22	1	11344
34373	2332	1125315	1978-07-29	1978-08-19	1	3152
74472	5095	1119510	1985-06-20	1985-07-04	1	5663
32564	2206	1521369	1985-11-29	1986-11-24	1	6171
75144	5142	1759842	1981-11-28	1981-12-19	1	4370
23428	1588	1759842	2010-07-20	2010-07-27	1	14817
50588	3442	1713332	1983-10-27	1983-11-24	1	5075
73424	5022	738818	1987-08-29	1987-09-12	1	6463
28069	1903	1125315	1971-03-05	1971-03-19	1	442
74565	5099	1729720	1999-02-27	1999-03-11	1	10661
25008	1692	1515774	1993-07-28	1994-07-23	1	8969
73934	5053	1501700	2017-02-07	2017-02-07	1	17204
23581	1599	1118084	1997-12-21	1997-12-21	1	10216
70172	4795	920293	1999-02-07	1999-02-14	1	10636
21239	1446	1713332	2001-03-30	2001-04-06	1	11418
22603	1535	1759842	1979-10-30	1979-11-06	1	3596
70721	4829	19127890	1994-10-20	1998-09-29	4	10498
30340	2051	1729720	1976-10-18	1976-10-26	1	2490
74034	5063	738818	1944-05-20	1944-05-27	1	-9350
31823	2152	1322184	2008-02-23	2008-02-23	1	13932
70810	4837	1124300	1981-11-03	1981-11-03	1	4324
23968	1622	1729720	1989-01-21	1989-01-31	1	6970
63010	4305	738818	1999-10-14	1999-10-28	1	10892
74011	5060	1102527	2012-10-23	2012-10-23	1	15636
29000	1965	1125315	1980-07-13	1980-07-27	1	3860
29469	1992	1112807	1992-10-19	1992-11-23	1	8362
56289	3835	920293	2006-10-10	2006-10-17	1	13438
20743	1412	933724	2007-06-09	2007-06-16	1	13680
65969	4506	1125315	1978-11-21	1978-11-28	1	3253
25943	1756	1102527	2017-07-11	2017-07-11	1	17358
62829	4289	1118084	1978-09-28	1978-09-28	1	3192
26479	1789	1125315	2018-06-13	2018-06-27	1	17709
69321	4729	1503184	1981-01-15	1982-01-10	1	4392
24042	1626	1713332	1976-03-18	1976-04-01	1	2282
65871	4500	1759842	2012-03-20	2012-04-03	1	15433
26912	1819	920293	2006-06-29	2006-07-06	1	13335
68377	4666	1713332	1993-05-19	1993-05-26	1	8546
23244	1577	1177480	2013-12-16	2014-01-06	1	16076
29919	2025	1125315	2014-05-16	2014-05-30	1	16220
67336	4596	1125315	1951-10-16	1951-10-16	1	-6652
63201	4319	1149380	2002-12-25	2002-12-25	1	12046
34056	2311	1125315	1972-04-22	1972-05-06	1	856
24513	1656	1503184	1997-10-22	1998-10-17	1	10516
42768	2896	1713332	2001-10-01	2001-10-22	1	11617
24801	1674	1125315	2013-11-01	2013-11-15	1	16024
66135	4520	1112807	1950-03-04	1950-03-18	1	-7229
52368	3567	1112807	1972-11-29	1972-12-13	1	1077
73665	5037	1125315	2012-09-01	2012-09-15	1	15598
31988	2164	1125315	2006-09-22	2006-10-13	1	13434
32762	2218	1503184	1999-04-13	2000-04-07	1	11054
23071	1566	1125315	1985-05-01	1985-05-15	1	5613
70932	4844	1759842	1994-01-07	1994-01-14	1	8779
21333	1450	1125315	1979-04-29	1979-05-06	1	3412
39002	2651	1112807	1951-05-25	1951-06-08	1	-6782
27419	1851	1115008	1997-09-24	1997-10-08	1	10142
34374	2332	738818	1997-03-05	1997-03-19	1	9939
74473	5095	1125315	2016-05-02	2016-05-09	1	16930
32565	2206	1521369	1994-10-13	1996-10-02	2	9771
75145	5142	1112807	1970-09-04	1970-09-18	1	260
23429	1588	19127890	1977-11-15	1978-11-10	1	3235
50589	3442	1759842	1983-10-27	1983-11-24	1	5075
73425	5022	1112807	1992-01-07	1992-01-28	1	8062
28070	1903	1125315	1981-12-30	1982-01-06	1	4388
74566	5099	1759842	2000-01-06	2000-01-27	1	10983
25009	1692	723013	1982-08-15	1982-12-19	1	4735
73935	5053	1713332	1989-06-13	1989-06-20	1	7110
23582	1599	1119510	1962-09-28	1962-10-12	1	-2638
70173	4795	1115008	2001-02-27	2001-04-03	1	11415
21240	1446	1112807	1984-09-08	1984-09-22	1	5378
22604	1535	1115008	2008-02-16	2008-05-16	1	14015
71456	4878	1112807	1969-10-21	1969-11-11	1	-51
30341	2051	1738521	1967-03-27	1967-04-10	1	-997
74035	5063	1125315	1944-05-20	1944-05-27	1	-9350
31824	2152	1326303	2008-02-23	2008-02-23	1	13932
70811	4837	1125315	1952-02-17	1952-03-02	1	-6514
23969	1622	19127890	1991-05-08	1993-04-27	2	8517
63011	4305	1125315	1999-10-14	1999-10-28	1	10892
74012	5060	1125315	2004-09-07	2004-09-21	1	12682
29001	1965	1125315	1986-04-20	1986-05-11	1	5974
29470	1992	1125315	1984-03-06	1984-03-13	1	5185
56290	3835	933724	2006-10-10	2006-10-17	1	13438
20744	1412	1119510	2011-01-12	2011-01-19	1	14993
65970	4506	1125315	1980-03-20	1980-04-03	1	3745
25944	1756	1115008	2017-07-11	2017-10-09	1	17448
62830	4289	1119510	2018-01-18	2018-01-25	1	17556
26480	1789	1118084	2017-01-07	2017-01-07	1	17173
69322	4729	1125315	1965-09-18	1965-10-18	1	-1536
24043	1626	1729720	1956-07-19	1956-07-26	1	-4907
65872	4500	1118084	1997-05-22	1997-05-22	1	10003
26913	1819	1125315	1989-08-20	1989-08-27	1	7178
68378	4666	1738521	1978-04-03	1978-04-17	1	3028
23245	1577	1367571	1997-01-31	1997-01-31	1	9892
29920	2025	1326303	1973-11-10	1973-11-10	1	1409
67337	4596	1125315	1957-06-18	1957-06-25	1	-4573
63202	4319	1125315	1982-12-11	1982-12-25	1	4741
34057	2311	1125315	1982-08-05	1982-08-12	1	4606
24514	1656	1515774	1993-11-12	1994-11-07	1	9076
42769	2896	1738521	1970-10-14	1970-10-28	1	300
24802	1674	1177480	1995-12-01	1995-12-15	1	9479
66136	4520	1125315	1948-10-16	1948-10-30	1	-7733
52369	3567	1503184	1987-06-02	1989-05-22	2	7081
73666	5037	1125315	2014-08-03	2014-08-17	1	16299
32475	2200	1125315	1982-07-07	1982-07-28	1	4591
32763	2218	1549786	2002-03-28	2003-03-23	1	12134
23072	1566	1125315	2000-08-13	2000-08-20	1	11189
72104	4927	1112807	1978-05-18	1978-06-08	1	3080
21334	1450	1125315	1999-11-03	1999-11-17	1	10912
39003	2651	1112807	1957-06-27	1957-07-25	1	-4543
27420	1851	1118084	2016-07-16	2016-07-16	1	16998
34375	2332	1102527	1988-11-15	1988-11-15	1	6893
74474	5095	1322184	2007-01-15	2007-01-15	1	13528
32566	2206	1521369	1997-09-27	1999-09-17	2	10851
75146	5142	1125315	1978-01-23	1978-02-27	1	2979
23635	1602	738818	1969-09-04	1969-09-18	1	-105
50590	3442	920293	1999-07-12	1999-07-19	1	10791
73426	5022	1118084	2005-06-05	2005-06-05	1	12939
28071	1903	1125315	2009-05-04	2009-05-25	1	14389
75871	5195	1124300	1995-05-29	1995-05-29	1	9279
25010	1692	1713332	2000-08-05	2000-08-12	1	11181
74103	5067	1118084	2012-02-08	2012-02-08	1	15378
23583	1599	1125315	1962-06-28	1962-07-12	1	-2730
70174	4795	1125315	1991-06-28	1991-07-12	1	7862
21241	1446	1595799	2002-10-02	2004-09-21	2	12682
22605	1535	1119510	1980-09-20	1980-09-27	1	3922
71457	4878	1125315	1970-12-06	1970-12-20	1	353
31989	2165	1118084	1991-09-15	1991-09-15	1	7927
74036	5063	1125315	1957-10-07	1958-01-05	2	-4379
31825	2152	1361711	1980-01-12	1980-01-12	1	3663
70812	4837	1125315	1954-07-16	1954-07-30	1	-5634
23970	1622	19127890	1994-04-22	1997-04-06	3	9957
63012	4305	1125315	2012-08-01	2012-08-15	1	15567
74013	5060	1125315	2012-10-23	2012-12-22	1	15696
29002	1965	1118084	2010-04-09	2010-04-09	1	14708
29471	1992	1521369	1993-02-26	1994-02-21	1	8817
56291	3835	1125315	1984-10-06	1984-10-27	2	5413
20745	1412	1125315	1964-09-24	1964-10-08	1	-1911
65971	4506	1118084	1992-02-28	1992-02-28	1	8093
25945	1756	738818	2008-02-19	2008-02-26	1	13935
62831	4289	1125315	1952-07-01	1952-08-30	1	-6333
26481	1789	1125315	1978-11-08	1978-11-29	1	3254
69323	4729	1125315	1980-05-03	1980-05-10	1	3782
24044	1626	19003953	1989-12-17	1989-12-17	1	7290
65873	4500	1125315	1961-11-12	1961-11-26	1	-2958
26914	1819	1125315	1998-04-13	1998-04-27	1	10343
68379	4666	1759842	1993-05-19	1993-05-26	1	8546
23246	1577	1713332	1954-09-17	1954-09-24	1	-5578
29921	2025	1347450	2009-05-30	2009-05-30	1	14394
67338	4596	1125315	1958-11-14	1958-11-21	1	-4059
63203	4319	1137529	2002-12-25	2002-12-25	1	12046
34058	2311	738818	1973-08-31	1973-09-14	1	1352
24515	1656	1515774	1996-10-27	1997-10-22	1	10156
42770	2896	1759842	2001-10-01	2001-10-22	1	11617
24803	1674	1118084	2012-04-20	2012-04-20	1	15450
66137	4520	1177480	1987-03-26	1987-04-23	1	6321
52370	3567	1713332	2011-02-25	2011-03-11	1	15044
73667	5037	1515774	1991-02-13	1992-02-08	1	8073
32476	2200	1759842	1978-08-19	1978-09-02	1	3166
32764	2218	1713332	1984-02-12	1984-02-26	1	5169
24298	1640	757627	2013-08-21	2013-08-21	1	15938
72105	4927	1119510	1990-07-15	1990-07-22	1	7507
21335	1450	1728416	1965-01-13	1965-01-27	1	-1800
39004	2651	1118084	1989-07-24	1989-07-24	1	7144
27421	1851	1119510	2014-10-12	2014-10-19	1	16362
34376	2332	1112807	1987-01-04	1987-01-25	1	6233
74475	5095	1717327	1965-12-30	1966-01-13	1	-1449
32567	2206	1112807	1976-03-30	1976-04-13	1	2294
75147	5142	1125315	2012-04-03	2012-04-03	1	15433
23636	1602	1124300	2001-11-23	2001-11-23	1	11649
50591	3442	1118084	2001-03-24	2001-03-24	1	11405
73427	5022	1124957	1984-05-04	1984-05-04	1	5237
28072	1903	1713332	2009-10-14	2009-11-04	1	14552
75872	5195	738818	1985-04-07	1985-04-14	1	5582
25011	1692	19127890	1991-08-08	1992-08-02	1	8249
74104	5067	1521369	1988-05-29	1989-05-24	1	7083
23584	1599	1125315	1980-05-23	1980-06-06	1	3809
70175	4795	1521369	1981-10-20	1982-10-15	1	4670
21242	1446	1768849	1984-03-30	1984-04-13	1	5216
22606	1535	1125315	1979-10-03	1979-10-17	1	3576
71458	4878	1125315	1988-01-25	1988-02-08	1	6612
31990	2165	1125315	1959-07-17	1959-07-31	1	-3807
74037	5063	1174888	1957-10-07	1957-10-07	1	-4469
31826	2152	738818	2016-10-17	2016-10-31	1	17105
70813	4837	1125315	1979-01-15	1979-01-29	1	3315
23971	1622	738818	2015-04-08	2015-04-22	1	16547
63013	4305	1729720	1984-08-31	1984-09-09	1	5365
74014	5060	1118084	2009-10-09	2009-10-09	1	14526
29003	1965	1125315	1982-04-12	1982-04-19	1	4491
29472	1992	1549786	1992-03-03	1993-02-26	1	8457
56292	3835	1125315	1986-09-17	1986-10-01	1	6117
20746	1412	1125315	2006-11-05	2006-11-19	1	13471
65972	4506	1125315	1955-11-14	1956-01-13	1	-5102
25946	1756	1125315	2008-02-19	2008-02-26	1	13935
62832	4289	1125315	1964-05-25	1964-06-01	1	-2040
26482	1789	1177480	1977-09-14	1977-09-28	1	2827
69324	4729	1177480	1993-11-20	1993-12-11	1	8745
24045	1626	708298	1989-12-17	1989-12-17	1	7290
65874	4500	1125315	1974-12-12	1974-12-26	1	1820
26915	1819	1759842	1977-07-31	1977-10-16	1	2845
68380	4666	19127890	1991-06-04	1992-05-29	1	8184
23247	1577	1741122	1997-01-31	1997-01-31	1	9892
29922	2025	1713332	1969-04-18	1969-04-25	1	-251
67339	4596	1125315	1962-11-09	1962-11-16	1	-2603
63204	4319	1102527	2014-05-28	2014-05-28	1	16218
34059	2311	1112807	1964-06-07	1964-06-21	1	-2020
24516	1656	1521369	2007-09-04	2008-08-29	1	14120
44380	3004	1118084	1991-05-16	1991-05-16	1	7805
24804	1674	1125315	1997-05-07	1997-05-21	1	10002
66138	4520	1361711	1991-01-05	1996-09-28	1	9767
52371	3567	1759842	2011-02-25	2011-03-11	1	15044
73668	5037	1549786	1991-02-13	1992-02-08	1	8073
32477	2200	1118084	2014-04-16	2014-04-16	1	16176
32765	2218	1729720	1988-01-18	1988-01-31	1	6604
24299	1640	1119510	1989-03-18	1989-04-01	1	7030
72106	4927	1125315	1983-06-02	1983-06-16	1	4914
21336	1450	1759842	2009-01-29	2009-02-05	1	14280
39005	2651	1125315	1952-12-26	1953-01-02	1	-6208
27422	1851	1125315	2000-11-08	2000-11-15	1	11276
34377	2332	1125315	1988-11-15	1988-12-15	1	6923
74476	5095	1728416	1978-03-09	1978-04-06	1	3017
32568	2206	1112807	1990-11-23	1990-12-14	1	7652
75148	5142	1322184	1997-09-23	2012-04-03	1	15433
23637	1602	1125315	1969-09-04	1969-09-18	1	-105
50592	3442	1125315	2006-06-12	2006-06-26	1	13325
73428	5022	1125315	1978-01-10	1978-01-17	1	2938
28073	1903	1759842	2009-10-14	2009-11-04	1	14552
75873	5195	1124957	2015-09-08	2015-09-08	1	16686
25012	1692	19127890	1993-07-28	1994-07-23	1	8969
74105	5067	1713332	1980-12-02	1980-12-16	1	4002
23585	1599	920293	2002-06-06	2002-06-13	1	11851
70176	4795	1738521	1969-12-12	1969-12-26	1	-6
21243	1446	1125315	1984-03-30	1984-04-13	1	5216
22607	1535	1125315	1998-03-29	1998-04-05	1	10321
71459	4878	1149380	1965-01-11	1985-02-16	1	5525
31991	2165	1728416	1959-07-17	1959-07-31	1	-3807
74038	5063	1728416	1947-03-04	1947-03-18	1	-8325
31827	2152	1112807	1933-07-13	1933-07-27	1	-13307
70814	4837	1309944	2004-03-23	2004-03-23	1	12500
23972	1622	1119510	1982-03-09	1982-03-23	1	4464
63014	4305	1119510	1999-10-14	1999-10-28	1	10892
74015	5060	1125315	1976-12-31	1977-01-14	1	2570
29004	1965	1713332	1995-03-11	1995-03-25	1	9214
29473	1992	1125315	2015-10-24	2015-11-23	2	16762
56293	3835	1713332	1988-04-06	1988-04-20	1	6684
20747	1412	1125315	2018-07-31	2018-08-14	1	17757
65973	4506	1713332	2009-07-26	2009-08-09	1	14465
25947	1756	1729720	1977-05-13	1977-05-20	1	2696
62833	4289	1713332	2001-11-23	2001-12-14	1	11670
26483	1789	1551099	1976-02-22	1976-02-22	1	2243
69325	4729	19127890	1981-01-15	1982-01-10	1	4392
24046	1626	933724	1994-02-14	1994-02-21	1	8817
65875	4500	1177480	2003-12-16	2004-01-06	1	12423
26916	1819	19127890	1994-05-05	1996-04-24	2	9610
68381	4666	19127890	1993-05-24	1995-05-14	2	9264
23248	1577	782043	1997-01-31	1997-01-31	1	9892
29923	2025	1729720	1921-03-29	1921-04-06	1	-17802
67340	4596	1307863	2013-04-14	2013-04-14	1	15809
63205	4319	1118084	2012-07-21	2012-07-21	1	15542
34060	2311	1738521	1976-11-06	1976-11-20	1	2515
24517	1656	1549786	1996-10-27	1997-10-22	1	10156
44381	3004	1125315	1951-01-01	1951-01-15	1	-6926
24805	1674	1177480	2008-09-07	2008-12-06	1	14219
66139	4520	1713332	1946-11-02	1946-11-16	1	-8447
52372	3567	1713332	2001-07-13	2001-08-03	1	11537
73669	5037	1549786	1993-02-02	1994-01-28	1	8793
32478	2200	1125315	1981-09-27	1981-10-11	1	4301
32766	2218	19127890	1995-05-04	1996-04-28	1	9614
24300	1640	1119510	2003-06-18	2003-07-02	1	12235
72107	4927	1125315	2000-10-10	2000-10-24	1	11254
22029	1500	1112807	1965-07-26	1965-08-09	1	-1606
39006	2651	1125315	1963-09-17	1963-09-24	1	-2291
27423	1851	1347450	2017-12-28	2017-12-28	1	17528
34378	2332	738818	1960-06-13	1960-06-20	1	-3482
74477	5095	1759842	1991-08-19	1991-09-09	1	7921
32569	2206	1125315	1974-02-20	1974-03-06	1	1525
553	36	920293	2014-11-17	2014-11-24	1	16398
23638	1602	1125315	1975-06-13	1975-06-27	1	2003
50593	3442	1177480	2015-06-20	2015-07-04	1	16620
73429	5022	1125315	1987-08-29	1987-09-12	1	6463
28074	1903	1118084	2005-02-28	2005-02-28	1	12842
75874	5195	1125315	1964-07-25	1964-08-08	1	-1972
25013	1692	1118084	2017-01-23	2017-01-23	1	17189
74106	5067	738818	2006-11-18	2006-12-02	1	13484
23586	1599	1119510	1971-10-24	1971-10-31	1	668
70177	4795	738818	1977-11-22	1977-12-06	1	2896
21244	1446	1125315	2003-10-17	2003-11-21	1	12377
22608	1535	1713332	1999-12-26	2000-01-09	1	10965
71460	4878	1551099	1963-08-03	1963-08-03	1	-2343
31992	2165	738818	1975-01-25	1975-02-01	1	1857
74039	5063	1759842	1972-06-28	1972-07-12	1	923
31828	2152	1124300	1963-05-17	1963-05-17	1	-2421
70815	4837	1343916	2004-03-23	2004-03-23	1	12500
23973	1622	1125315	1978-04-07	1978-04-21	1	3032
63015	4305	1551099	2004-04-20	2004-04-20	1	12528
75056	5138	1124300	2018-05-11	2018-05-11	1	17662
29005	1965	1738521	1980-07-13	1980-07-27	1	3860
32254	2184	1102527	2004-03-21	2004-03-21	1	12498
56294	3835	1729720	1967-12-10	1967-12-17	1	-746
20748	1412	1759842	1966-03-07	1966-03-28	1	-1375
65974	4506	1759842	2009-07-26	2009-08-09	1	14465
28671	1941	1119510	1995-03-13	1995-03-27	1	9216
63947	4370	1112807	1966-10-06	1966-10-27	1	-1162
26484	1789	1717327	1977-09-14	1977-09-28	1	2827
69719	4757	920293	2008-04-14	2008-04-21	1	13990
24047	1626	1000560	1989-12-17	1989-12-17	2	7290
65876	4500	1177480	2007-07-19	2007-08-09	1	13734
26917	1819	1119510	1989-08-20	1989-08-27	1	7178
70588	4822	1112807	1952-04-02	1952-04-16	1	-6469
23249	1577	967823	1997-01-31	1997-02-01	1	9893
29924	2025	1759842	1946-08-09	1946-08-23	1	-8532
67341	4596	1713332	1957-11-11	1957-12-02	1	-4413
63206	4319	1125315	1995-10-30	1996-01-28	1	9523
34061	2311	1119510	1972-04-22	1972-05-06	1	856
24518	1656	1549786	2014-08-08	2015-08-03	1	16650
44382	3004	1125315	2008-07-17	2008-07-31	1	14091
24806	1674	1729720	1980-06-23	1980-07-06	1	3839
66140	4520	1713332	1955-03-13	1955-03-20	1	-5401
52373	3567	1713332	2016-09-15	2016-10-06	1	17080
73670	5037	1713332	1982-05-04	1982-05-18	1	4520
32479	2200	1125315	1991-05-12	1991-08-10	1	7891
34145	2319	1125315	1967-06-14	1967-07-05	1	-911
24301	1640	701322	2014-06-17	2014-06-17	1	16238
72108	4927	1125315	2014-11-20	2014-12-04	1	16408
22030	1500	1759842	1985-02-20	1985-02-27	1	5536
39007	2651	1125315	1972-11-03	1972-11-17	1	1051
27424	1851	1713332	1982-11-01	1982-11-15	1	4701
34379	2332	1118084	1996-10-27	1996-10-27	1	9796
74478	5095	1125315	1970-12-04	1970-12-25	1	358
32570	2206	1515774	1991-10-29	1992-10-23	1	8331
554	36	975125	1965-10-27	1965-11-17	1	-1506
23639	1602	1177480	2001-06-20	2001-07-20	1	11523
50594	3442	1759842	1999-12-05	1999-12-19	1	10944
73430	5022	1177480	1974-04-29	1974-05-27	1	1607
28075	1903	1125315	1978-06-11	1978-06-18	1	3090
75875	5195	1125315	1985-04-07	1985-04-14	1	5582
25014	1692	1125315	1982-08-17	1982-08-24	1	4618
74107	5067	1102527	1988-12-06	1988-12-06	1	6914
23587	1599	1728416	1964-12-26	1965-01-09	1	-1818
70178	4795	738818	1991-06-28	1991-07-12	1	7862
21245	1446	1177480	1985-06-06	1985-06-20	1	5649
26742	1808	738818	1963-03-05	1963-03-12	1	-2487
71461	4878	1729720	1963-11-02	1963-11-09	1	-2245
31993	2165	1125315	1968-11-24	1968-12-01	1	-396
74040	5063	1125315	1967-05-09	1967-05-16	1	-961
31829	2152	1125315	1992-07-01	1992-07-15	1	8231
70816	4837	1728416	1952-02-17	1952-03-02	1	-6514
23974	1622	1125315	2011-11-05	2011-11-26	1	15304
63016	4305	1115008	2013-07-15	2013-08-12	1	15929
75057	5138	1125315	1978-09-28	1978-10-12	1	3206
29006	1965	1125315	1976-01-13	1976-01-27	1	2217
32255	2184	1124300	2002-12-23	2002-12-23	1	12044
56295	3835	1125315	2001-02-14	2001-03-21	1	11402
20749	1412	738818	2011-01-12	2011-01-19	1	14993
65975	4506	1115008	2001-10-13	2001-12-12	1	11668
28672	1941	1177480	1981-11-21	1981-12-21	1	4372
63948	4370	1118084	1999-03-24	1999-03-24	1	10674
26485	1789	1729720	1985-03-07	1985-03-15	1	5552
69720	4757	1112807	1975-02-17	1975-03-17	1	1901
24048	1626	1110410	1989-12-17	1989-12-17	1	7290
67067	4578	1112807	1967-01-09	1967-02-06	1	-1060
26918	1819	19127890	1992-05-15	1993-05-10	1	8530
70589	4822	1112807	1967-08-29	1967-09-12	1	-842
23250	1577	1112807	1925-07-01	1925-07-15	1	-16241
29925	2025	1112807	1918-09-01	1918-09-15	1	-18736
67342	4596	738818	1957-10-25	1957-11-08	1	-4437
63207	4319	1125315	2009-04-04	2009-04-11	1	14345
34062	2311	1125315	1973-08-31	1973-09-14	1	1352
24519	1656	1589505	2012-08-13	2013-08-13	1	15930
44383	3004	1125315	2018-04-04	2018-04-11	1	17632
24807	1674	1125315	1985-01-28	1985-02-04	1	5513
66141	4520	1713332	1990-01-07	1990-01-28	1	7332
52374	3567	19127890	1987-06-02	1989-05-22	2	7081
73671	5037	1713332	2007-03-15	2007-04-05	1	13608
32480	2200	1713332	1978-08-19	1978-09-02	1	3166
34146	2319	1125315	1983-09-07	1983-10-07	1	5027
24302	1640	1177480	1992-03-17	1992-03-31	1	8125
72109	4927	1521369	1996-06-22	1997-06-17	1	10029
22031	1500	1125315	1968-03-26	1968-04-16	1	-625
39008	2651	1125315	1977-07-24	1977-08-21	1	2789
27425	1851	740275	1994-04-28	1994-09-29	1	9037
34380	2332	1125315	1957-05-21	1957-06-04	1	-4594
74479	5095	1125315	1985-06-20	1985-07-04	1	5663
32571	2206	1515774	1993-10-18	1994-10-13	1	9051
555	36	975125	1993-05-26	1993-06-16	1	8567
23640	1602	1728416	1975-06-13	1975-06-27	1	2003
50595	3442	1759842	2017-06-10	2017-07-01	1	17348
73431	5022	1177480	1986-01-24	1986-02-07	1	5881
28076	1903	1125315	2014-08-21	2014-08-28	1	16310
75876	5195	1728416	1964-07-25	1964-08-08	1	-1972
25015	1692	1549786	1991-08-08	1992-08-02	1	8249
74108	5067	1112807	1978-04-03	1978-05-03	1	3044
23588	1599	738818	1962-09-28	1962-10-12	1	-2638
70179	4795	933724	1995-12-09	1995-12-23	1	9487
21246	1446	1778162	1985-06-06	1985-06-20	1	5649
26743	1808	1125315	1963-03-05	1963-03-12	1	-2487
71462	4878	1118084	1999-06-15	1999-06-15	1	10757
31994	2165	1125315	1975-01-25	1975-02-01	1	1857
74041	5063	1125315	2000-05-19	2000-06-02	1	11110
31830	2152	1125315	2016-10-17	2016-10-31	1	17105
70817	4837	1125315	2008-05-29	2008-06-12	1	14042
23975	1622	1125315	2015-04-08	2015-04-22	1	16547
63017	4305	1118084	1997-12-27	1997-12-27	1	10222
75058	5138	1177480	2009-05-18	2009-06-08	1	14403
29007	1965	1759842	1995-03-11	1995-03-25	1	9214
32256	2184	1149380	1970-02-21	1970-02-21	1	51
56296	3835	1174888	1984-10-06	1984-10-06	1	5392
20750	1412	920293	2007-06-09	2007-06-16	1	13680
65976	4506	1125315	1959-01-27	1959-02-10	1	-3978
28673	1941	1713332	1982-05-16	1982-05-23	1	4525
63949	4370	1125315	1968-08-30	1968-09-13	1	-475
26486	1789	1119510	1988-04-21	1988-05-05	1	6699
69721	4757	1112807	1982-09-06	1982-09-20	1	4645
24049	1626	1112807	1939-10-26	1939-11-09	1	-11011
67068	4578	1112807	1979-02-03	1979-05-04	1	3410
28337	1921	1112807	1957-02-05	1957-02-19	1	-4699
70590	4822	1125315	1951-08-04	1951-08-25	1	-6704
23251	1577	1177480	1991-01-16	1991-03-17	1	7745
29926	2025	1112807	1943-06-06	1943-06-27	1	-9685
67343	4596	1112807	1951-10-16	1951-11-13	1	-6624
63208	4319	1177480	1997-12-18	1998-01-08	1	10234
34063	2311	1713332	1965-10-21	1965-11-11	1	-1512
24520	1656	1595799	2003-09-21	2004-09-15	1	12676
44384	3004	1713332	1995-10-21	1995-10-28	1	9431
24808	1674	1125315	1993-12-29	1994-01-12	1	8777
66142	4520	1759842	1957-09-10	1957-09-17	1	-4489
53579	3647	1125315	1950-12-08	1950-12-15	1	-6957
73672	5037	19127890	1993-02-02	1994-01-28	1	8793
32481	2200	1738521	1978-01-15	1978-01-29	1	2950
34147	2319	1125315	1986-10-21	1986-11-11	1	6158
24303	1640	1713332	2000-09-22	2000-10-13	1	11243
72110	4927	1549786	2001-05-27	2003-05-17	2	12189
22032	1500	1125315	1973-11-12	1973-11-26	1	1425
39009	2651	1177480	2000-11-18	2000-12-09	1	11300
27426	1851	1125315	1982-11-01	1982-11-15	1	4701
34381	2332	1125315	1960-06-13	1960-06-20	1	-3482
74480	5095	1347450	2007-01-15	2007-01-15	1	13528
32572	2206	1549786	1991-10-29	1992-10-23	1	8331
556	36	975125	2015-07-08	2015-07-29	1	16645
23641	1602	1125315	2013-04-18	2013-05-23	1	15848
50596	3442	933724	1999-07-12	1999-07-19	1	10791
73432	5022	1713332	1991-02-22	1991-03-15	1	7743
28374	1923	738818	2013-03-27	2013-04-03	1	15798
75877	5195	1729720	1986-09-12	1986-09-24	1	6110
25016	1692	1549786	1993-07-28	1994-07-23	1	8969
74109	5067	1119510	1990-07-30	1990-08-13	1	7529
23589	1599	738818	1971-10-24	1971-10-31	1	668
70180	4795	1115008	2011-10-09	2011-10-23	1	15270
21247	1446	1124300	2017-08-09	2017-08-09	1	17387
26744	1808	1125315	1993-12-11	1994-01-08	1	8773
71463	4878	1713332	2007-06-23	2007-06-30	1	13694
31995	2165	1125315	1989-09-16	1989-10-23	2	7235
74042	5063	1118084	1981-09-11	1981-09-11	1	4271
31831	2152	1307863	2008-02-23	2008-02-23	1	13932
70818	4837	1307863	2008-11-18	2008-11-18	1	14201
23976	1622	1503184	1994-04-22	1996-04-11	2	9597
63018	4305	1125315	1973-09-29	1973-10-13	1	1381
75059	5138	1713332	1985-07-30	1985-08-20	1	5710
29008	1965	1125315	1988-06-11	1988-06-25	1	6750
32257	2184	1729720	1973-01-15	1973-01-23	1	1118
56297	3835	1713332	1984-10-06	1984-10-27	1	5413
20751	1412	1118084	1997-05-24	1997-05-24	1	10005
65977	4506	1125315	1964-09-20	1964-10-04	1	-1915
28674	1941	1728416	1973-03-17	1973-03-31	1	1185
63950	4370	1124957	1991-11-22	1991-11-22	1	7995
26487	1789	1129625	1976-03-06	1976-03-06	1	2256
69722	4757	1125315	2018-10-17	2018-10-24	1	17828
24050	1626	1112807	1943-09-14	1943-10-05	1	-9585
67069	4578	1125315	1998-06-05	1998-06-19	1	10396
28338	1921	1118084	1995-03-02	1995-03-02	1	9191
70591	4822	1728416	1952-04-02	1952-04-16	1	-6469
23252	1577	1759842	1954-09-17	1954-09-24	1	-5578
29927	2025	1112807	1948-01-02	1948-01-16	1	-8021
67344	4596	1119510	1958-11-14	1958-11-21	1	-4059
63209	4319	1177480	2014-05-28	2014-07-27	1	16278
34064	2311	1717327	1964-06-07	1964-06-21	1	-2020
24521	1656	920293	2001-12-26	2002-01-02	1	11689
44385	3004	1759842	1965-08-07	1965-08-28	1	-1587
24809	1674	1174888	2008-09-07	2008-09-07	1	14129
66143	4520	1759842	1990-01-07	1990-01-28	1	7332
53580	3647	1125315	1954-05-21	1954-05-28	1	-5697
73673	5037	19127890	1995-01-23	1998-01-07	3	10233
32482	2200	1729720	1978-05-16	1978-05-28	1	3069
34148	2319	1129625	1952-03-06	1952-03-06	1	-6510
24304	1640	1759842	2019-05-16	2019-06-06	1	18053
72111	4927	1549786	2004-05-11	2005-04-01	1	12874
22033	1500	1713332	1985-02-20	1985-02-27	1	5536
39010	2651	1112807	1956-04-03	1956-07-02	1	-4931
27427	1851	1149380	2012-07-19	2012-07-19	1	15540
34382	2332	1125315	1967-08-26	1967-10-25	1	-799
74481	5095	738818	1985-06-20	1985-07-04	1	5663
32573	2206	1549786	1993-10-18	1994-10-13	1	9051
557	36	1112807	1964-10-19	1964-11-02	1	-1886
23642	1602	1177480	1995-09-15	1995-10-06	1	9409
50597	3442	1112807	1963-02-14	1963-02-28	1	-2499
73433	5022	1759842	1991-02-22	1991-03-15	1	7743
28375	1923	1118084	1972-06-29	1972-06-29	1	910
75878	5195	738818	2001-02-08	2001-02-22	1	11375
25017	1692	1713332	2016-04-24	2016-05-08	1	16929
74110	5067	1125315	2006-11-18	2006-12-02	1	13484
23590	1599	933724	2002-06-06	2002-06-13	1	11851
70181	4795	1125315	1969-12-12	1969-12-26	1	-6
21248	1446	1150770	1984-09-08	1984-09-08	1	5364
26745	1808	1177480	2018-07-29	2018-08-19	1	17762
71464	4878	1759842	2007-06-23	2007-06-30	1	13694
31996	2165	1125315	2009-12-14	2010-01-13	1	14622
74043	5063	1119510	1957-08-20	1957-08-27	1	-4510
31832	2152	1322184	1997-04-19	2007-09-08	1	13764
70819	4837	738818	2006-10-28	2006-11-04	1	13456
23977	1622	1515774	1991-05-08	1993-04-27	2	8517
63019	4305	1112807	1958-12-17	1958-12-31	1	-4019
75060	5138	738818	1993-02-12	1993-02-26	1	8457
29009	1965	1729720	1974-05-26	1974-06-02	1	1613
32258	2184	1125315	2012-05-19	2012-06-02	1	15493
56298	3835	1759842	1988-04-06	1988-04-20	1	6684
20752	1412	1125315	1975-11-27	1975-12-11	1	2170
65978	4506	1728416	1959-01-27	1959-02-10	1	-3978
28675	1941	1759842	1982-05-16	1982-05-23	1	4525
63951	4370	1125315	1969-06-27	1969-07-11	1	-174
26488	1789	1149380	1979-03-05	1979-03-05	1	3350
69723	4757	723013	2001-03-17	2001-08-18	1	11552
24051	1626	1137529	2001-09-30	2001-09-30	1	11595
67070	4578	1125315	1998-09-19	1998-10-03	1	10502
28339	1921	1177480	2015-01-26	2015-02-23	1	16489
70592	4822	1729720	1953-12-23	1954-01-03	1	-5842
23253	1577	19003953	1997-01-31	1997-01-31	1	9892
29928	2025	1124300	1946-12-28	1946-12-28	1	-8405
67345	4596	1125315	1947-08-09	1947-08-16	1	-8174
63210	4319	1125315	1986-04-15	1986-05-20	1	5983
36200	2461	1713332	2013-01-17	2013-01-24	1	15729
24522	1656	1500211	2004-09-15	2006-09-05	2	13396
44386	3004	1759842	1995-10-21	1995-10-28	1	9431
24810	1674	1713332	2008-09-06	2008-09-20	1	14142
67008	4574	1112807	1958-10-02	1958-10-16	1	-4095
53581	3647	1125315	2018-06-25	2018-07-09	1	17721
73674	5037	1125315	1982-05-04	1982-05-18	1	4520
32483	2200	1112807	1978-01-15	1978-01-29	1	2950
34149	2319	1713332	1976-08-03	1976-08-10	1	2413
24305	1640	738818	2003-06-18	2003-07-02	1	12235
72112	4927	1759842	1982-08-01	1982-08-15	1	4609
22034	1500	1124300	2001-10-25	2001-10-25	1	11620
39011	2651	1125315	1954-02-28	1954-03-14	1	-5772
27428	1851	1322184	2017-12-28	2017-12-28	1	17528
34383	2332	1125315	1997-03-05	1997-03-19	1	9939
74482	5095	1118084	2002-09-17	2002-09-17	1	11947
32574	2206	1549786	1996-10-02	1997-09-27	1	10131
558	36	1115008	2011-07-06	2011-07-27	1	15182
23643	1602	1119510	1967-10-25	1967-11-08	1	-785
50598	3442	1125315	2011-07-15	2011-08-19	1	15205
74489	5096	1124300	2008-08-20	2008-08-20	1	14111
28376	1923	1125315	1962-06-13	1962-06-27	1	-2745
75879	5195	1112807	1963-12-28	1964-01-18	1	-2175
25018	1692	1759842	2016-04-24	2016-05-08	1	16929
74111	5067	1177480	1988-12-06	1989-02-04	1	6974
23591	1599	1112807	1964-12-14	1965-01-09	1	-1818
70182	4795	1125315	1977-11-22	1977-12-06	1	2896
21249	1446	1521369	2002-10-02	2004-09-21	2	12682
26746	1808	1115008	1997-11-18	1997-12-16	1	10211
71465	4878	1125315	1964-01-30	1964-02-20	1	-2142
31997	2165	1174888	1989-09-23	1989-09-23	1	7205
74044	5063	1125315	1979-05-06	1979-06-03	1	3440
31833	2152	1332418	1994-04-02	1994-04-02	1	8857
70820	4837	914335	2004-03-23	2004-03-23	1	12500
23978	1622	1515774	1996-04-11	1997-04-06	1	9957
63020	4305	1125315	1969-09-20	1969-12-19	1	-13
75061	5138	1125315	1993-02-12	1993-02-26	1	8457
29010	1965	1738521	1976-01-13	1976-01-27	1	2217
32259	2184	1177480	2004-03-21	2004-04-18	1	12526
57677	3934	1125315	1939-02-16	1939-03-02	1	-11263
20753	1412	1125315	1991-02-08	1991-02-22	1	7722
68399	4668	1112807	1957-03-31	1957-04-14	1	-4645
28676	1941	705944	1986-02-12	1987-01-28	1	6236
63952	4370	1125315	1991-11-22	1992-01-21	2	8055
26489	1789	1729720	2014-09-10	2014-09-21	1	16334
69724	4757	1125315	1961-10-29	1961-11-05	1	-2979
24052	1626	1309944	2010-10-10	2010-10-10	1	14892
67071	4578	1713332	1964-09-30	1964-10-14	1	-1905
28340	1921	738818	1955-02-06	1955-02-13	1	-5436
70593	4822	1759842	2013-04-04	2013-04-11	1	15806
23254	1577	753626	1997-01-31	1997-01-31	1	9892
29929	2025	1125315	1938-07-18	1938-08-01	1	-11476
67346	4596	1125315	1957-10-25	1957-11-08	1	-4437
63211	4319	1177480	1982-09-12	1982-10-03	1	4658
36201	2461	1759842	2013-01-17	2013-01-24	1	15729
24523	1656	1519936	2011-08-19	2012-08-13	1	15565
44387	3004	1125315	1992-10-22	1992-11-05	1	8344
24811	1674	1759842	2008-09-06	2008-09-20	1	14142
67009	4574	1729720	1958-12-02	1958-12-14	1	-4036
53582	3647	1347450	1992-08-19	1992-08-19	1	8266
73675	5037	1125315	2002-04-08	2002-04-15	1	11792
32484	2200	1112807	1978-10-12	1978-10-26	1	3220
34150	2319	1759842	1964-06-26	1964-07-10	1	-2001
24306	1640	1125315	1978-08-30	1978-09-06	1	3170
72113	4927	738818	2007-05-22	2007-05-29	1	13662
22035	1500	1125315	2015-04-30	2015-05-07	1	16562
39012	2651	1125315	2008-09-23	2008-10-07	1	14159
27429	1851	740275	1989-12-28	1990-06-07	1	7462
34384	2332	1713332	1963-07-02	1963-07-09	1	-2368
74483	5095	1125315	2012-11-27	2012-12-11	1	15685
32575	2206	19127890	1985-11-29	1986-11-24	1	6171
559	36	1125315	1961-10-17	1961-10-31	1	-2984
23644	1602	1177480	2006-05-25	2006-07-24	1	13353
50599	3442	1713332	1962-03-13	1962-03-27	1	-2837
74490	5096	1125315	1989-04-29	1989-05-13	1	7072
28377	1923	1125315	2013-03-27	2013-04-03	1	15798
75880	5195	1125315	1968-12-22	1969-01-12	1	-354
26179	1770	920293	2010-07-11	2010-07-18	1	14808
74112	5067	19127890	1991-05-14	1992-05-08	1	8163
23592	1599	1125315	1962-09-28	1962-10-12	1	-2638
70183	4795	1521369	1986-09-24	1987-09-19	1	6470
21250	1446	1759842	2001-03-30	2001-04-06	1	11418
26747	1808	1125315	2014-04-27	2014-05-04	1	16194
71466	4878	1154343	1965-01-11	1985-02-16	1	5525
31998	2165	1713332	1970-11-25	1970-12-16	1	349
74045	5063	1125315	1999-06-08	1999-06-22	1	10764
31834	2152	1729720	1936-06-28	1936-07-05	1	-12233
70821	4837	1112807	1963-02-06	1963-02-20	1	-2507
23979	1622	1549786	1996-04-11	1997-04-06	1	9957
63021	4305	1125315	2019-06-12	2019-06-12	1	18059
75062	5138	1713332	1998-06-21	1998-07-05	1	10412
32029	2167	1119510	1993-07-26	1993-08-09	1	8621
32260	2184	1177480	2019-05-30	2019-05-30	1	18046
57678	3934	1309944	1984-09-19	1984-09-19	1	5375
20754	1412	1125315	2011-01-12	2011-01-19	1	14993
68400	4668	1115008	1998-06-01	1998-06-15	1	10392
28677	1941	1112807	1974-01-11	1974-02-01	1	1492
63953	4370	1125315	1964-09-18	1964-10-16	1	-1903
29350	1986	1713332	1981-05-13	1981-05-27	1	4164
69725	4757	933724	2008-04-14	2008-04-21	1	13990
24053	1626	1310149	1995-08-27	1995-08-27	1	9369
67072	4578	1713332	2019-02-21	2019-02-28	1	17955
28341	1921	920293	1992-10-16	1992-10-23	1	8331
70594	4822	738818	2018-06-01	2018-06-15	1	17697
23255	1577	920293	1955-03-22	1955-03-29	1	-5392
29930	2025	1125315	1972-10-29	1972-11-05	1	1039
67347	4596	1125315	1983-12-07	1983-12-28	1	5109
63212	4319	1713332	1982-12-11	1982-12-25	1	4741
36202	2461	1125315	1991-02-24	1991-03-10	1	7738
24524	1656	1549786	2003-09-21	2004-09-15	1	12676
44388	3004	1713332	1965-08-07	1965-08-28	1	-1587
26459	1788	1125315	1977-09-22	1977-10-06	1	2835
67010	4574	1738521	1968-04-03	1968-04-17	1	-624
53583	3647	1713332	1958-11-20	1958-11-27	1	-4053
73676	5037	1521369	1995-01-23	1996-01-18	1	9513
32485	2200	1125315	1997-05-10	1997-06-14	1	10026
34151	2319	738818	1980-10-11	1980-10-18	1	3943
24307	1640	1125315	1992-03-25	1992-04-01	1	8126
72114	4927	1125315	2007-05-22	2007-05-29	1	13662
22036	1500	1713332	1994-08-16	1994-08-23	1	9000
39013	2651	1149380	1948-09-24	1966-03-02	1	-1401
27430	1851	740275	1992-01-09	1992-06-25	1	8211
34385	2332	1728416	1958-12-11	1958-12-25	1	-4025
74484	5095	1713332	1991-08-19	1991-09-09	1	7921
32576	2206	19127890	1993-10-18	2000-09-11	7	11211
560	36	1125315	1974-05-20	1974-05-27	1	1607
23645	1602	738818	1967-10-25	1967-11-08	1	-785
50600	3442	1713332	1971-12-08	1971-12-22	1	720
74491	5096	1125315	2000-09-02	2000-09-16	1	11216
28378	1923	1713332	1940-05-14	1940-08-06	1	-10740
75881	5195	1125315	1980-03-05	1980-03-19	1	3730
26180	1770	1112807	1992-09-23	1992-10-21	1	8329
74113	5067	19127890	1993-05-03	1994-04-28	1	8883
23593	1599	1125315	1971-10-24	1971-10-31	1	668
70184	4795	933724	1999-02-07	1999-02-14	1	10636
22609	1536	1112807	1912-08-25	1912-09-08	1	-20934
26748	1808	1713332	1979-04-18	1979-05-02	1	3408
75556	5172	1125315	1956-08-24	1956-09-21	1	-4850
31999	2165	738818	2014-07-03	2014-07-10	1	16261
74046	5063	1125315	2010-05-21	2010-06-04	1	14764
31835	2152	1729720	1949-07-14	1949-07-25	1	-7465
70822	4837	1125315	2006-10-28	2006-11-04	1	13456
23980	1622	1549786	2001-03-22	2002-03-17	1	11763
63022	4305	1728416	1958-12-17	1958-12-31	1	-4019
75063	5138	1759842	1998-06-21	1998-07-05	1	10412
32030	2167	1177480	1993-08-23	1993-09-06	1	8649
32261	2184	1713332	2004-03-21	2004-04-18	1	12526
57679	3934	1343916	1984-09-19	1984-09-19	1	5375
20755	1412	1713332	1966-03-07	1966-03-28	1	-1375
68401	4668	1115008	2011-10-05	2011-10-26	1	15273
28678	1941	1115008	2009-04-28	2009-05-19	1	14383
63954	4370	1125315	1993-05-17	1993-05-24	1	8544
29351	1986	1713332	2009-12-31	2010-01-14	1	14623
69726	4757	1118084	1994-10-05	1994-10-05	1	9043
24054	1626	1343916	2010-10-10	2010-10-10	1	14892
67073	4578	1759842	2019-02-21	2019-02-28	1	17955
28342	1921	933724	1992-10-16	1992-10-23	1	8331
70595	4822	1112807	1950-11-01	1950-11-15	1	-6987
23256	1577	933724	1955-03-22	1955-03-29	1	-5392
29931	2025	1307863	1981-12-26	1981-12-26	1	4377
67348	4596	738818	1978-11-24	1978-12-08	1	3263
63819	4364	1112807	1963-09-24	1963-10-31	1	-2254
36203	2461	1125315	2006-01-19	2006-02-18	1	13197
24525	1656	1549786	2010-08-24	2011-08-19	1	15205
44389	3004	1728416	1951-01-01	1951-01-15	1	-6926
26460	1788	1125315	2011-10-09	2011-10-16	1	15263
67011	4574	738818	1990-02-06	1990-02-13	1	7348
53584	3647	1713332	1988-11-28	1988-12-05	1	6913
73677	5037	1549786	2004-12-01	2005-11-26	1	13113
33642	2286	1119510	1969-12-29	1970-01-05	1	4
34152	2319	1112807	1948-11-06	1948-11-20	1	-7712
24308	1640	1125315	2003-06-18	2003-07-02	1	12235
72115	4927	1125315	2016-12-09	2016-12-16	1	17151
22037	1500	1713332	2008-07-19	2008-08-02	1	14093
40332	2743	19127890	1975-03-29	1977-03-18	2	2633
27431	1851	1119510	2001-01-15	2001-01-22	1	11344
34386	2332	1729720	1963-09-01	1963-09-10	1	-2305
74485	5095	1112807	1977-01-22	1977-02-12	1	2599
32577	2206	1119510	2001-04-08	2001-04-22	1	11434
561	36	1125315	1988-10-26	1988-11-09	1	6887
23646	1602	1102527	2001-06-20	2001-06-20	1	11493
50601	3442	1717327	1962-02-02	1962-02-16	1	-2876
74492	5096	1503184	1985-03-19	1986-03-14	1	5916
28379	1923	1713332	2011-08-09	2011-08-23	1	15209
75882	5195	1125315	2001-02-08	2001-02-22	1	11375
26181	1770	1119510	1986-06-01	1986-06-15	1	6009
74114	5067	1112807	1983-10-13	1983-10-27	1	5047
23594	1599	1125315	1972-11-19	1972-12-03	1	1067
70185	4795	1119510	1977-11-22	1977-12-06	1	2896
22610	1536	1119510	1919-02-08	1919-02-22	1	-18576
26749	1808	1738521	1967-01-11	1967-01-25	1	-1072
75557	5172	1125315	1957-01-23	1957-02-06	1	-4712
32000	2165	1112807	1961-03-26	1961-05-25	1	-3143
74047	5063	738818	1957-08-20	1957-08-27	1	-4510
32230	2180	1124300	2017-08-06	2017-08-06	1	17384
70823	4837	1192710	1952-01-11	1952-01-11	1	-6565
23981	1622	1595799	2001-03-22	2002-03-17	1	11763
63023	4305	1729720	1963-07-28	1963-08-08	1	-2338
75064	5138	1102527	2011-02-28	2011-02-28	1	15033
32031	2167	1713332	2013-03-15	2013-03-22	1	15786
32262	2184	1738521	1969-02-16	1969-03-02	1	-305
57680	3934	1112807	1941-10-01	1941-10-22	1	-10298
20756	1412	920293	2010-07-13	2010-07-20	1	14810
68402	4668	1124957	1987-06-29	1987-06-29	1	6388
28679	1941	1125315	1975-05-14	1975-05-28	1	1973
65164	4452	1125315	1977-01-28	1977-02-04	1	2591
29352	1986	738818	2005-11-05	2005-11-12	1	13099
69727	4757	1125315	1985-09-02	1985-09-09	1	5730
24055	1626	1539403	2006-10-29	2006-10-29	1	13450
67074	4578	19127890	1987-04-04	1988-03-29	1	6662
28343	1921	1119510	1965-08-20	1965-08-27	1	-1588
70596	4822	1112807	1952-07-20	1952-08-03	1	-6360
23257	1577	1110410	1997-01-31	1997-01-31	1	9892
29932	2025	1713332	1915-11-22	1915-11-29	1	-19757
67349	4596	1112807	1954-07-30	1954-08-20	1	-5613
63820	4364	1124957	1963-10-01	1963-10-01	1	-2284
36204	2461	1125315	2010-04-04	2010-04-11	1	14710
24526	1656	19127890	1993-11-12	1994-11-07	1	9076
44390	3004	1759842	2006-06-22	2006-06-29	1	13328
26461	1788	1177480	2008-11-18	2008-12-09	1	14222
67012	4574	1112807	1968-04-03	1968-04-17	1	-624
53585	3647	1728416	1956-05-09	1956-05-23	1	-4971
73678	5037	1589505	2000-12-22	2001-12-17	1	11673
33643	2286	1759842	1958-12-03	1958-12-24	1	-4026
34153	2319	1125315	1980-10-11	1980-10-18	1	3943
24309	1640	1174888	2006-09-14	2006-09-14	1	13405
72116	4927	1177480	1977-10-20	1977-11-03	1	2863
22038	1500	1759842	1994-08-16	1994-08-23	1	9000
40333	2743	1112807	1968-02-24	1968-03-23	1	-649
27432	1851	1125315	1980-02-26	1980-03-11	1	3722
34387	2332	738818	1994-12-30	1995-01-13	1	9143
74486	5095	1112807	1979-01-31	1979-02-21	1	3338
32578	2206	1125315	1987-11-10	1987-11-17	1	6529
562	36	1521369	1975-10-02	1976-09-26	1	2460
23647	1602	1112807	1967-05-26	1967-06-30	1	-916
50602	3442	1125315	1974-12-05	1974-12-19	1	1813
74493	5096	1503184	1987-03-09	1989-02-26	2	6996
28380	1923	1759842	2011-08-09	2011-08-23	1	15209
75883	5195	1125315	2015-09-08	2015-12-07	2	16776
26182	1770	1125315	1983-03-17	1983-03-31	1	4837
74115	5067	1119510	2006-11-18	2006-12-02	1	13484
23595	1599	1125315	1979-12-31	1980-02-29	1	3711
70186	4795	1119510	1991-06-28	1991-07-12	1	7862
22611	1536	1149380	1967-02-26	1967-02-26	1	-1040
26750	1808	738818	1971-08-03	1971-08-10	1	586
75558	5172	1125315	2006-04-30	2006-05-21	1	13289
32001	2165	1119510	2014-07-03	2014-07-10	1	16261
74048	5063	920293	1964-05-07	1964-05-14	1	-2058
32231	2180	1759842	2003-06-30	2003-07-21	1	12254
70824	4837	1310149	2008-11-18	2008-11-18	1	14201
23982	1622	19127890	1988-05-23	1989-05-18	1	7077
65929	4504	1124957	2003-11-05	2003-11-05	1	12361
75065	5138	1115008	2011-02-28	2011-04-29	1	15093
32032	2167	1713332	1997-07-20	1997-08-10	1	10083
32263	2184	1125315	1987-01-02	1987-01-09	1	6217
57681	3934	1112807	1981-08-07	1981-08-28	1	4257
20757	1412	933724	2010-07-13	2010-07-20	1	14810
68403	4668	1125315	1985-06-02	1985-08-31	1	5721
28680	1941	1717327	1976-04-19	1976-05-03	1	2314
65165	4452	1125315	1987-07-15	1987-07-22	1	6411
29353	1986	1125315	1982-02-24	1982-03-10	1	4451
69728	4757	1177480	2004-05-27	2004-06-17	1	12586
24056	1626	1713332	1995-01-25	1995-02-01	1	9162
67075	4578	1112807	1973-06-04	1973-07-04	1	1280
28344	1921	1125315	1955-02-06	1955-02-13	1	-5436
70597	4822	1112807	1966-08-20	1966-09-03	1	-1216
23258	1577	1124300	1962-03-29	1962-03-29	1	-2835
29933	2025	1729720	1920-08-18	1920-08-28	1	-18023
67350	4596	1124957	1951-10-16	1951-10-16	1	-6652
63821	4364	1125315	2012-11-15	2012-11-22	1	15666
36205	2461	1177480	1976-01-13	1976-01-27	1	2217
24527	1656	19127890	1996-10-27	1998-10-17	2	10516
44391	3004	738818	2001-12-06	2001-12-20	1	11676
26462	1788	1347450	2018-05-24	2018-05-24	1	17675
67013	4574	1118084	1992-06-25	1992-06-25	1	8211
53586	3647	1112807	1941-05-28	1941-06-11	1	-10431
73679	5037	1759842	2007-03-15	2007-04-05	1	13608
33644	2286	1115008	1996-01-09	1996-02-06	1	9532
34154	2319	1125315	1995-06-21	1995-06-28	1	9309
24310	1640	1322184	2015-06-10	2015-06-10	1	16596
72117	4927	1503184	1996-06-22	1997-06-17	1	10029
22039	1500	1759842	2008-07-19	2008-08-02	1	14093
40334	2743	1118084	1992-02-18	1992-02-18	1	8083
27433	1851	1125315	2001-01-15	2001-01-22	1	11344
34388	2332	1112807	1958-12-11	1958-12-25	1	-4025
74487	5095	1125315	1965-12-30	1966-01-13	1	-1449
32579	2206	1125315	2001-04-08	2001-04-22	1	11434
563	36	1521369	1977-09-21	1978-09-16	1	3180
23648	1602	1119510	1969-09-04	1969-09-18	1	-105
50603	3442	1713332	1999-12-05	1999-12-19	1	10944
74494	5096	1521369	1987-03-09	1989-02-26	2	6996
28381	1923	1112807	1938-10-16	1938-10-30	1	-11386
75884	5195	1119510	1985-04-07	1985-04-14	1	5582
26183	1770	1729720	1996-01-21	1996-01-28	1	9523
74116	5067	1125315	1976-12-20	1977-01-03	1	2559
23596	1599	1713332	1980-05-23	1980-06-06	1	3809
70187	4795	1125315	1974-02-20	1974-03-06	1	1525
22612	1536	1713332	1967-02-14	1967-02-21	1	-1045
26751	1808	1119510	1963-03-05	1963-03-12	1	-2487
75559	5172	1177480	1988-11-16	1988-11-30	1	6908
32002	2165	1125315	1954-11-28	1954-12-12	1	-5499
74049	5063	933724	1964-05-07	1964-05-14	1	-2058
32232	2180	1125315	1989-04-05	1989-04-19	1	7048
70825	4837	1728416	1949-09-17	1949-10-01	1	-7397
23983	1622	19127890	1999-03-27	2000-03-21	1	11037
65930	4504	1713332	1974-05-05	1974-05-19	1	1599
75066	5138	1119510	1993-02-12	1993-02-26	1	8457
32033	2167	1759842	1997-07-20	1997-08-10	1	10083
32264	2184	1125315	1993-05-27	1993-06-17	1	8568
57682	3934	1125315	1991-02-07	1991-02-21	1	7721
20758	1412	1112807	1970-06-25	1970-07-09	1	189
68404	4668	1125315	2003-10-07	2003-10-21	1	12346
28681	1941	1112807	1973-03-17	1973-03-31	1	1185
65166	4452	1125315	1995-02-06	1995-04-07	1	9227
29354	1986	1119510	2005-11-05	2005-11-12	1	13099
70785	4835	1112807	1974-03-10	1974-04-09	1	1559
24057	1626	1729720	1958-09-15	1958-09-26	1	-4115
67076	4578	1125315	1979-02-03	1979-02-03	1	3320
28345	1921	1125315	2003-03-13	2003-03-20	1	12131
70598	4822	1125315	1966-08-25	1966-09-01	1	-1218
23259	1577	1125315	1989-10-14	1989-10-28	1	7240
29934	2025	1759842	1942-12-29	1943-01-19	1	-9844
67351	4596	1125315	2016-01-09	2016-02-06	1	16837
63822	4364	1713332	2013-06-03	2013-06-24	1	15880
36206	2461	1713332	1995-09-22	1995-10-13	1	9416
26038	1762	920293	2002-12-09	2002-12-16	1	12037
44392	3004	1119510	2001-12-06	2001-12-20	1	11676
26463	1788	1124300	2004-12-24	2004-12-24	1	12776
67014	4574	1125315	1990-02-06	1990-02-13	1	7348
53587	3647	1118084	1970-01-01	1970-01-01	1	0
73680	5037	1124300	2009-07-28	2009-07-28	1	14453
33645	2286	1125315	1957-11-01	1957-11-15	1	-4430
34155	2319	1177480	1980-11-23	1980-12-21	1	4007
24311	1640	1347450	2015-06-10	2015-06-10	1	16596
72118	4927	1515774	2004-05-11	2005-04-01	1	12874
24550	1658	1125315	1971-04-02	1971-04-09	1	463
40335	2743	1125315	1964-02-15	1964-02-29	1	-2133
27434	1851	1137529	2012-07-19	2012-07-19	1	15540
34389	2332	1119510	1997-03-05	1997-03-19	1	9939
74488	5095	1125315	1978-03-09	1978-04-06	1	3017
32580	2206	1503184	1994-10-13	1996-10-02	2	9771
564	36	1713332	1969-05-04	1969-05-18	1	-228
23649	1602	1125315	1967-10-25	1967-11-08	1	-785
50604	3442	1713332	2017-06-10	2017-07-01	1	17348
74495	5096	1112807	1972-11-12	1972-11-26	1	1060
28382	1923	1125315	1953-06-13	1953-07-11	1	-6018
75885	5195	1119510	2001-02-08	2001-02-22	1	11375
26184	1770	933724	2010-07-11	2010-07-18	1	14808
74117	5067	1154343	1978-06-08	1978-06-08	1	3080
23597	1599	1729720	1962-11-26	1962-12-03	1	-2586
70188	4795	1503184	1981-10-20	1982-10-15	1	4670
22613	1536	1729720	1915-04-14	1915-04-22	1	-19978
26752	1808	1125315	1971-08-03	1971-08-10	1	586
75560	5172	1729720	1957-01-13	1957-01-22	1	-4727
32003	2165	1125315	1957-10-14	1957-10-21	1	-4455
74050	5063	1112807	1947-03-04	1947-03-18	1	-8325
32233	2180	1713332	1991-04-15	1991-05-06	1	7795
70826	4837	1729720	1956-08-15	1956-08-25	1	-4877
23984	1622	738818	1982-03-09	1982-03-23	1	4464
65931	4504	1125315	1983-11-11	1983-11-18	1	5069
75067	5138	1713332	1990-04-04	1990-04-25	1	7419
32034	2167	1768849	1979-05-09	1979-05-23	1	3429
32265	2184	1112807	1969-02-16	1969-03-02	1	-305
57683	3934	1713332	1988-02-01	1988-03-07	1	6640
20759	1412	1125315	1983-12-12	1984-01-02	1	5114
68405	4668	1125315	2014-12-09	2014-12-23	1	16427
28682	1941	1125315	1988-11-25	1989-01-13	1	6952
65167	4452	920293	1978-07-10	1978-07-17	1	3119
29355	1986	1125315	2005-11-05	2005-11-12	1	13099
70786	4835	1118084	2010-04-10	2010-04-10	1	14709
24058	1626	1729720	1987-10-28	1987-11-09	1	6521
67077	4578	1125315	2008-08-25	2008-09-08	1	14130
28346	1921	1125315	2012-12-17	2012-12-24	1	15698
70599	4822	1125315	2018-06-01	2018-06-15	1	17697
23260	1577	1125315	2003-05-15	2003-05-22	1	12194
29935	2025	1112807	1965-01-12	1965-01-26	1	-1801
67352	4596	1310149	2013-04-14	2013-04-14	1	15809
63823	4364	1729720	1961-03-26	1961-04-04	1	-3194
36207	2461	1759842	1995-09-22	1995-10-13	1	9416
26039	1762	1118084	1979-10-12	1979-10-12	1	3571
44393	3004	1125315	2001-12-06	2001-12-20	1	11676
26464	1788	1125315	1990-07-21	1990-08-11	1	7527
67015	4574	1177480	1985-10-15	1985-10-29	1	5780
53588	3647	1125315	1963-06-11	1963-06-25	1	-2382
73681	5037	1125315	1977-11-13	1977-11-27	1	2887
33646	2286	1125315	1969-12-29	1970-01-05	1	4
34156	2319	1557272	2017-10-14	2017-10-14	1	17453
24312	1640	1713332	2019-05-16	2019-06-06	1	18053
72119	4927	1519936	2001-05-27	2002-05-22	1	11829
24551	1658	1125315	1974-10-12	1974-10-19	1	1752
40336	2743	1503184	1975-03-29	1977-03-18	2	2633
28872	1953	738818	1957-06-26	1957-07-03	1	-4565
34390	2332	1125315	1994-12-30	1995-01-13	1	9143
75521	5169	1759842	1983-10-26	1983-11-09	1	5060
32581	2206	1503184	1997-09-27	1999-09-17	2	10851
565	36	933724	2014-11-17	2014-11-24	1	16398
23650	1602	1125315	1971-04-10	1971-04-24	1	478
50605	3442	1759842	1962-03-13	1962-03-27	1	-2837
74496	5096	1115008	2001-02-14	2001-02-28	1	11381
28383	1923	1728416	1948-09-29	1948-10-13	1	-7750
75886	5195	1125315	1993-09-01	1993-09-15	1	8658
26185	1770	1118084	2014-12-19	2014-12-19	1	16423
74118	5067	1503184	1991-05-14	1992-05-08	1	8163
23782	1609	1125315	1960-11-01	1960-12-06	1	-3313
70189	4795	19127890	1986-09-24	1987-09-19	1	6470
22614	1536	738818	1919-02-08	1919-02-22	1	-18576
26753	1808	920293	2001-03-14	2001-03-28	2	11409
75561	5172	1759842	2008-01-05	2008-01-26	1	13904
32004	2165	1125315	2014-07-03	2014-07-10	1	16261
74051	5063	1112807	1968-02-12	1968-03-04	1	-668
32234	2180	1713332	2013-11-17	2013-11-24	1	16033
70827	4837	1125315	1964-02-15	1964-02-29	1	-2133
23985	1622	1115008	1998-11-17	1998-12-08	1	10568
65932	4504	1125315	2008-08-10	2008-08-24	1	14115
75068	5138	1759842	1990-04-04	1990-04-25	1	7419
32035	2167	738818	1993-07-26	1993-08-09	1	8621
32266	2184	1112807	1973-01-14	1973-02-11	1	1137
57684	3934	1759842	1988-02-01	1988-03-07	1	6640
20760	1412	1125315	2002-02-25	2002-03-04	1	11750
68406	4668	1713332	1981-09-09	1981-09-30	1	4290
28683	1941	738818	1995-03-13	1995-03-27	1	9216
65168	4452	933724	1978-07-10	1978-07-17	1	3119
29356	1986	1177480	1981-05-13	1981-05-27	1	4164
70787	4835	1759842	1981-03-09	1981-03-23	1	4099
24059	1626	1741122	1989-12-17	1989-12-17	1	7290
67078	4578	1759842	1964-09-30	1964-10-14	1	-1905
28347	1921	1728416	1951-12-23	1952-01-06	1	-6570
70600	4822	1137529	2004-11-03	2004-11-03	1	12725
23261	1577	1177480	2017-01-20	2017-04-20	1	17276
29936	2025	1125315	2012-10-26	2012-11-02	1	15646
67353	4596	1713332	2013-06-22	2013-07-06	1	15892
63824	4364	1729720	1961-09-05	1961-09-18	1	-3027
36208	2461	1118084	2003-03-07	2003-03-07	1	12118
26040	1762	1125315	1975-09-20	1975-09-27	1	2095
44394	3004	1729720	1957-08-01	1957-08-14	1	-4523
26465	1788	1717327	1977-09-22	1977-10-06	1	2835
67016	4574	1728416	1958-10-02	1958-10-16	1	-4095
53589	3647	1177480	2007-01-01	2007-01-29	1	13542
73682	5037	1500211	2001-12-17	2002-12-12	1	12033
33647	2286	1713332	1958-12-03	1958-12-24	1	-4026
34157	2319	1713332	1958-09-17	1958-09-24	1	-4117
24313	1640	1729720	2005-03-24	2005-04-06	1	12879
72120	4927	1521369	1999-06-07	2000-06-01	1	11109
24552	1658	1125315	1978-08-24	1978-09-21	1	3185
40337	2743	1713332	1995-11-01	1995-11-15	1	9449
28873	1953	1112807	1964-06-17	1964-07-17	1	-1994
34391	2332	1759842	1963-07-02	1963-07-09	1	-2368
75522	5169	1125315	1997-01-20	1997-02-03	1	9895
32582	2206	1521369	2001-09-06	2002-09-01	1	11931
566	36	975125	1978-06-06	1978-06-27	1	3099
23651	1602	1125315	1972-03-19	1972-04-18	1	838
50606	3442	1759842	1971-12-08	1971-12-22	1	720
74497	5096	1125315	1971-03-25	1971-04-08	1	462
28384	1923	1759842	1980-11-01	1980-11-22	1	3978
78014	5329	920293	1996-02-09	1996-02-16	1	9542
26186	1770	1125315	1981-05-26	1981-06-23	1	4191
74119	5067	1515774	1993-05-03	1994-04-28	1	8883
23783	1609	1125315	1986-11-14	1986-11-28	1	6175
70190	4795	920293	1995-12-09	1995-12-23	2	9487
22615	1536	1112807	1944-03-10	1944-03-24	1	-9414
26754	1808	933724	2001-03-14	2001-03-28	1	11409
75562	5172	1125315	2013-09-20	2013-09-27	1	15975
32005	2165	1728416	1954-11-28	1954-12-12	1	-5499
74052	5063	1119510	1944-05-20	1944-05-27	1	-9350
32235	2180	1759842	1991-04-15	1991-05-06	1	7795
70828	4837	1125315	1968-07-26	1968-08-09	1	-510
23986	1622	1119510	2015-04-08	2015-04-22	1	16547
65933	4504	1177480	1978-01-20	1978-03-21	1	3001
75069	5138	1125315	2001-08-28	2001-11-26	1	11652
32036	2167	1125315	1993-07-26	1993-08-09	1	8621
32267	2184	1125315	1967-08-14	1967-08-28	1	-857
57685	3934	1112807	1945-08-02	1945-10-31	1	-8828
20761	1412	1149380	1963-05-20	1963-05-20	1	-2418
68407	4668	1759842	1981-09-09	1981-09-30	1	4290
28684	1941	1124300	2009-11-23	2009-11-23	1	14571
65169	4452	1124300	1996-11-14	1996-11-14	1	9814
29357	1986	1115008	2009-12-31	2010-01-14	1	14623
70788	4835	1768849	1987-06-30	1987-07-14	1	6403
24060	1626	1746114	1989-12-17	1989-12-17	1	7290
67079	4578	1759842	1980-03-03	1980-03-10	1	3721
28348	1921	920293	1992-12-31	1993-01-07	1	8407
70601	4822	1308738	1993-09-12	1993-09-12	1	8655
23262	1577	1746114	1997-01-31	1997-01-31	1	9892
29937	2025	1310149	1973-11-10	1973-11-10	1	1409
67354	4596	1728416	1951-10-16	1951-11-13	1	-6624
63825	4364	1759842	2013-06-03	2013-06-24	1	15880
38495	2619	1112807	1945-10-24	1945-11-07	1	-8821
26041	1762	1125315	1982-01-25	1982-02-08	1	4421
44395	3004	1729720	1958-10-12	1958-10-22	1	-4089
26466	1788	1115008	1999-05-26	1999-06-09	1	10751
67017	4574	1759842	1986-12-18	1987-01-01	1	6209
53590	3647	1713332	1991-02-01	1991-02-15	1	7715
73683	5037	1503184	1995-01-23	1996-01-18	1	9513
33648	2286	1728416	1957-11-01	1957-11-15	1	-4430
34158	2319	1713332	1989-01-11	1989-02-01	1	6971
24314	1640	1759842	2000-09-22	2000-10-13	1	11243
72121	4927	1521369	2002-05-22	2003-05-17	1	12189
24553	1658	1322184	1997-02-24	1997-02-24	1	9916
40338	2743	1713332	2009-03-04	2009-03-11	1	14314
28874	1953	1125315	1957-06-26	1957-07-03	1	-4565
35879	2438	1118084	2016-08-27	2016-08-27	1	17040
75523	5169	738818	1977-12-24	1977-12-31	1	2921
32583	2206	1549786	1999-09-17	2000-09-11	1	11211
567	36	975125	2004-09-19	2004-10-10	1	12701
23652	1602	1177480	2000-08-10	2000-08-24	1	11193
51162	3486	1119510	1994-04-01	1994-04-08	1	8863
74498	5096	1521369	1985-03-19	1986-03-14	1	5916
28385	1923	1112807	1948-09-29	1948-10-13	1	-7750
78015	5329	1124300	1980-09-04	1980-09-04	1	3899
26187	1770	1125315	1986-06-01	1986-06-15	1	6009
74120	5067	1549786	1993-05-03	1994-04-28	1	8883
23784	1609	1125315	1992-11-03	1992-11-10	1	8349
70191	4795	1124300	2005-10-09	2005-10-09	1	13065
22616	1536	1112807	1971-02-01	1971-03-01	1	424
26755	1808	1112807	1967-01-11	1967-01-25	1	-1072
75563	5172	1729720	1990-04-26	1990-05-08	1	7432
32006	2165	1759842	1970-11-25	1970-12-16	1	349
74053	5063	1125315	1957-08-20	1957-08-27	1	-4510
32236	2180	1759842	2013-11-17	2013-11-24	1	16033
70829	4837	1326303	2008-11-18	2008-11-18	1	14201
23987	1622	1125315	1982-03-09	1982-03-23	1	4464
65934	4504	1310149	2019-06-22	2019-06-22	1	18069
75070	5138	1125315	2013-03-19	2013-04-02	1	15797
32037	2167	1759842	2013-03-15	2013-03-22	1	15786
32268	2184	1154343	1970-02-21	1970-02-21	1	51
57686	3934	1112807	1967-06-08	1967-06-22	1	-924
20762	1412	1177480	1999-11-30	1999-12-14	1	10939
68408	4668	1125315	1958-07-13	1958-07-27	1	-4176
28685	1941	1125315	1995-03-13	1995-03-27	1	9216
65170	4452	1125315	1964-04-18	1964-04-25	1	-2077
29358	1986	1118084	2014-04-30	2014-04-30	1	16190
70789	4835	1115008	2011-03-26	2011-04-16	1	15080
24061	1626	1759842	1995-01-25	1995-02-01	1	9162
67080	4578	19127890	1979-05-16	1980-05-10	1	3782
28349	1921	1112807	1951-12-23	1952-01-06	1	-6570
70602	4822	1112807	1949-02-15	1949-03-01	1	-7611
23263	1577	19016749	1997-01-31	1997-01-31	1	9892
29938	2025	1322184	2009-05-30	2009-05-30	1	14394
68050	4644	1112807	1985-12-01	1986-01-05	1	5848
63826	4364	738818	2007-05-28	2007-06-04	1	13668
38496	2619	1112807	1966-02-17	1966-03-17	1	-1386
26042	1762	738818	1967-10-06	1967-10-20	1	-804
44396	3004	1713332	2006-06-22	2006-06-29	1	13328
26467	1788	1125315	1991-07-12	1991-07-26	1	7876
67018	4574	1125315	1968-04-14	1968-04-21	1	-620
53591	3647	1713332	2014-02-22	2014-03-08	1	16137
73684	5037	1512674	2004-12-01	2005-11-26	1	13113
33649	2286	1729720	1998-01-28	1998-02-06	1	10263
34159	2319	1728416	1949-08-20	1949-09-03	1	-7425
24315	1640	738818	1989-03-18	1989-04-01	1	7030
72122	4927	1549786	1999-06-07	2000-06-01	1	11109
24554	1658	1713332	1940-01-29	1940-02-12	1	-10916
40339	2743	1759842	1995-11-01	1995-11-15	1	9449
28875	1953	1125315	1960-07-27	1960-08-10	1	-3431
35880	2438	1125315	2010-01-21	2010-02-04	1	14644
75524	5169	1125315	1977-12-24	1977-12-31	1	2921
32584	2206	1549786	2001-09-06	2002-09-01	1	11931
568	36	1118084	1993-05-30	1993-05-30	1	8550
25875	1752	1125315	1979-10-17	1979-10-30	1	3589
51163	3486	1125315	1969-08-05	1969-08-12	1	-142
74499	5096	738818	1993-11-07	1993-11-21	1	8725
28386	1923	1713332	2004-06-25	2004-07-09	1	12608
78016	5329	1125315	1947-01-03	1947-01-17	1	-8385
26188	1770	1713332	2000-05-30	2000-06-13	1	11121
74121	5067	1729720	1974-08-04	1974-08-14	1	1686
23785	1609	1347450	1998-10-28	1998-10-29	1	10528
70192	4795	1177480	2003-03-24	2003-04-14	1	12156
22617	1536	1118084	1945-05-09	1945-05-09	1	-9003
26756	1808	1119510	1971-08-03	1971-08-10	1	586
75564	5172	1125315	1967-06-08	1967-06-22	1	-924
32007	2165	1112807	1962-04-20	1962-05-11	1	-2792
74054	5063	1125315	1970-03-03	1970-03-17	1	75
32237	2180	1125315	1985-02-26	1985-03-12	1	5549
70830	4837	1728416	1968-07-26	1968-08-09	1	-510
23988	1622	1500211	1993-04-27	1994-04-22	1	8877
65935	4504	1759842	1974-05-05	1974-05-19	1	1599
75071	5138	1177480	1989-03-17	1989-03-31	1	7029
32038	2167	1118084	2017-09-21	2017-09-21	1	17430
34756	2349	1118084	2004-12-22	2004-12-22	1	12774
57687	3934	1125315	2015-12-03	2015-12-31	1	16800
20763	1412	1729720	1969-02-02	1969-02-10	1	-325
68409	4668	1125315	1976-05-22	1976-05-29	1	2340
28686	1941	1125315	1997-03-18	1997-04-01	1	9952
65171	4452	1125315	1970-05-29	1970-06-19	1	169
29359	1986	1125315	2007-08-25	2007-09-22	1	13778
70790	4835	1124957	2011-03-26	2011-03-26	1	15059
24062	1626	19039298	1989-12-17	1989-12-17	1	7290
67081	4578	19127890	1982-04-30	1983-04-25	1	4862
28350	1921	1112807	1964-08-16	1964-08-30	1	-1950
70603	4822	1124300	1987-07-31	1987-07-31	1	6420
25277	1715	1125315	1972-09-20	1972-10-04	1	1007
29939	2025	1347450	2007-07-21	2007-07-21	1	13715
68051	4644	1125315	1968-01-26	1968-02-09	1	-692
63827	4364	1112807	1967-05-13	1967-06-17	1	-929
38497	2619	1125315	2010-05-30	2010-06-13	1	14773
26043	1762	933724	2002-12-09	2002-12-16	1	12037
45646	3100	1112807	1967-11-29	1967-12-13	1	-750
26468	1788	1125315	2010-03-09	2010-03-16	1	14684
67019	4574	1713332	1986-12-18	1987-01-01	1	6209
53592	3647	1759842	1943-10-20	1943-11-03	1	-9556
73685	5037	1521369	1999-12-28	2000-12-22	1	11313
33650	2286	738818	1969-12-29	1970-01-05	1	4
34160	2319	1759842	1989-01-11	1989-02-01	1	6971
24316	1640	1118084	1976-04-20	1976-04-20	1	2301
72123	4927	1728416	1977-10-20	1977-11-03	1	2863
24555	1658	1759842	1940-01-29	1940-02-12	1	-10916
40340	2743	1759842	2009-03-04	2009-03-11	1	14314
28876	1953	1557272	2014-10-27	2014-10-27	1	16370
35881	2438	1119510	1988-06-12	1988-06-26	1	6751
75525	5169	1125315	1984-11-25	1984-12-09	1	5456
32585	2206	1713332	2018-03-06	2018-03-13	1	17603
569	36	1125315	2001-06-17	2001-07-01	1	11504
25876	1752	1713332	1996-11-19	1996-12-10	1	9840
51164	3486	1125315	1971-03-06	1971-03-20	1	443
74500	5096	1115008	2019-03-11	2019-04-15	1	18001
28387	1923	1729720	1946-08-09	1946-08-16	1	-8539
78017	5329	1125315	1977-05-01	1977-05-15	1	2691
26189	1770	1713332	2008-11-10	2008-12-15	1	14228
74122	5067	1759842	1980-12-02	1980-12-16	1	4002
23786	1609	738818	1986-11-14	1986-11-28	1	6175
70193	4795	1503184	1986-09-24	1987-09-19	1	6470
22618	1536	1125315	1919-02-08	1919-02-22	1	-18576
26757	1808	1124300	2003-12-18	2003-12-18	1	12404
75565	5172	1713332	1956-06-23	1956-07-14	1	-4919
32008	2165	1119510	1975-01-25	1975-02-01	1	1857
74055	5063	1125315	1985-08-11	1985-08-18	1	5708
32238	2180	1125315	2010-12-25	2011-01-15	1	14989
74966	5132	1112807	1973-03-04	1973-06-02	1	1248
23989	1622	1500211	1997-04-06	1998-04-01	1	10317
65936	4504	1759842	1995-07-06	1995-07-20	1	9331
75072	5138	1738521	1978-09-28	1978-10-12	1	3206
32039	2167	1125315	1979-05-09	1979-05-23	1	3429
34757	2349	1713332	1992-08-28	1992-10-16	1	8324
57688	3934	1343916	1957-03-06	1957-03-06	1	-4684
20764	1412	1119510	2018-07-31	2018-08-14	1	17757
68410	4668	1713332	2001-11-28	2001-12-12	1	11668
28687	1941	1177480	1976-04-19	1976-05-03	1	2314
65172	4452	1112807	1958-08-16	1958-08-30	1	-4142
29360	1986	1713332	1982-02-24	1982-03-10	1	4451
70791	4835	1713332	1983-06-19	1983-07-03	1	4931
24063	1626	1124957	1989-12-17	1989-12-17	1	7290
67082	4578	1118084	2000-04-05	2000-04-05	1	11052
28351	1921	1119510	1991-07-06	1991-07-13	1	7863
70604	4822	1149380	2004-11-03	2004-11-03	1	12725
25278	1715	738818	1994-03-06	1994-03-13	1	8837
29940	2025	1713332	1942-12-29	1943-01-19	1	-9844
68052	4644	1125315	1968-11-17	1968-12-01	1	-396
63828	4364	1125315	2005-03-18	2005-04-01	1	12874
38498	2619	1361711	2004-10-22	2004-10-22	1	12713
26044	1762	1115008	2012-05-16	2012-05-30	1	15490
45647	3100	1125315	1964-09-10	1964-09-24	1	-1925
26469	1788	1112807	1963-10-06	1963-11-10	1	-2244
67020	4574	1112807	1970-11-28	1971-01-02	1	366
53593	3647	1759842	1991-02-01	1991-02-15	1	7715
73686	5037	1549786	1996-01-18	1998-01-07	2	10233
33651	2286	1118084	1996-10-07	1996-10-07	1	9776
34161	2319	1119510	1980-10-11	1980-10-18	1	3943
24317	1640	1125315	1989-03-18	1989-04-01	1	7030
72124	4927	19127890	2004-05-11	2005-04-01	1	12874
24556	1658	738818	2008-03-13	2008-03-27	1	13965
40341	2743	933724	1995-05-12	1995-05-19	1	9269
28877	1953	1713332	1969-04-01	1969-04-22	1	-254
35882	2438	1125315	1987-03-18	1987-04-08	1	6306
75526	5169	1112807	1954-06-26	1954-07-17	1	-5647
32586	2206	1738521	1976-03-30	1976-04-13	1	2294
570	36	1125315	2008-06-08	2008-06-22	1	14052
25877	1752	1759842	1996-11-19	1996-12-10	1	9840
51165	3486	1125315	1974-12-06	1975-01-03	1	1828
74501	5096	1125315	1985-01-30	1985-02-13	1	5522
28388	1923	1759842	2004-06-25	2004-07-09	1	12608
78018	5329	1177480	2011-02-25	2011-03-25	1	15058
26190	1770	1759842	1996-07-15	1996-07-29	1	9706
74123	5067	19127890	1988-05-29	1989-05-24	1	7083
23787	1609	1112807	1980-11-21	1980-12-19	1	4005
70194	4795	19127890	1981-10-20	1982-10-15	1	4670
22619	1536	1137529	1967-02-26	1967-02-26	1	-1040
26758	1808	1125315	1969-12-26	1970-01-16	1	15
75566	5172	1713332	2004-05-04	2004-05-25	1	12563
32009	2165	1177480	2003-01-13	2003-02-12	1	12095
74056	5063	1125315	2010-10-18	2010-11-22	1	14935
32239	2180	1713332	2003-06-30	2003-07-21	1	12254
74967	5132	1729720	1972-12-24	1973-01-02	1	1097
23990	1622	1503184	1988-05-23	1989-05-18	1	7077
65937	4504	1118084	2010-12-23	2010-12-23	1	14966
75073	5138	1759842	1985-07-30	1985-08-20	1	5710
32040	2167	1125315	2018-02-27	2018-04-03	1	17624
34758	2349	1112807	1973-03-05	1973-04-30	2	1208
57689	3934	1729720	1976-11-15	1976-11-26	1	2521
20765	1412	1125315	1979-08-23	1979-08-30	1	3528
68411	4668	1717327	1963-01-24	1963-02-07	1	-2520
28688	1941	1713332	1979-12-16	1979-12-23	1	3643
65173	4452	1125315	1956-06-27	1956-09-25	1	-4846
29361	1986	1729720	1988-12-03	1988-12-13	1	6921
70792	4835	1759842	1983-06-19	1983-07-03	1	4931
24064	1626	1361711	2006-10-29	2006-10-29	1	13450
67083	4578	1124957	1979-02-03	1979-02-03	1	3320
28352	1921	1728416	1957-02-05	1957-02-19	1	-4699
70605	4822	1713332	2013-04-04	2013-04-11	1	15806
25279	1715	738818	2019-06-27	2019-06-27	1	18074
29941	2025	1729720	2012-01-28	2012-02-05	1	15375
68053	4644	1728416	1968-11-17	1968-12-01	1	-396
63829	4364	1125315	2007-05-28	2007-06-04	1	13668
38499	2619	1759842	1980-02-26	1980-03-11	1	3722
26045	1762	1125315	1967-10-06	1967-10-20	1	-804
45648	3100	1125315	1990-06-11	1990-06-18	1	7473
26470	1788	1115008	2012-10-19	2012-11-16	1	15660
67021	4574	1119510	1990-02-06	1990-02-13	1	7348
53594	3647	1759842	2014-02-22	2014-03-08	1	16137
73687	5037	1549786	1999-12-28	2000-12-22	1	11313
33652	2286	1177480	2004-02-24	2004-03-09	1	12486
34162	2319	1551099	1947-08-14	1947-08-14	1	-8176
24318	1640	1125315	2006-09-14	2006-11-13	2	13465
72125	4927	1595799	2002-05-22	2003-05-17	1	12189
24557	1658	920293	1946-05-19	1946-05-26	1	-8621
40342	2743	1124957	1977-07-04	1977-07-04	1	2741
28878	1953	1728416	1960-07-27	1960-08-10	1	-3431
35883	2438	1125315	2014-01-12	2014-01-19	1	16089
75527	5169	1118084	1996-07-05	1996-07-05	1	9682
32587	2206	1759842	2018-03-06	2018-03-13	1	17603
571	36	1174888	2001-03-30	2001-03-30	1	11411
25878	1752	1713332	1982-06-20	1982-07-04	1	4567
51166	3486	1125315	1988-09-21	1988-10-19	1	6866
74502	5096	1125315	1993-11-07	1993-11-21	1	8725
28389	1923	701322	2011-04-16	2011-04-16	1	15080
78019	5329	1347450	1989-03-01	1989-03-01	1	6999
26191	1770	1515774	1993-06-02	1994-05-28	1	8913
74124	5067	738818	1990-07-30	1990-08-13	1	7529
23788	1609	1322184	1998-10-28	1998-10-29	1	10528
22620	1536	1729720	1968-10-29	1968-11-09	1	-418
26759	1808	1125315	1979-04-18	1979-05-02	1	3408
75567	5172	1728416	1948-06-16	1948-06-30	1	-7855
33658	2287	914335	2014-01-24	2014-01-24	1	16094
74057	5063	1125315	2019-02-08	2019-03-10	1	17965
33715	2290	738818	1998-06-19	1998-07-03	1	10410
74968	5132	1729720	1974-02-28	1974-03-08	1	1527
23991	1622	1515774	1999-03-27	2000-03-21	1	11037
65938	4504	1125315	1970-08-01	1970-08-15	1	226
76896	5256	1125315	1963-09-23	1963-10-07	1	-2278
34952	2366	1119510	1982-01-18	1982-01-25	1	4407
34759	2349	1125315	1972-10-06	1972-10-20	1	1023
57690	3934	914335	1957-03-06	1957-03-06	1	-4684
20766	1412	1125315	1981-12-08	1981-12-22	1	4373
68412	4668	1728416	1957-03-31	1957-04-14	1	-4645
28689	1941	1713332	1997-12-27	1998-01-10	1	10236
65174	4452	1177480	1978-03-23	1978-04-06	1	3017
33768	2292	1125315	1965-09-07	1965-09-21	1	-1563
70793	4835	1125315	2004-06-02	2004-06-09	1	12578
24065	1626	1759842	1984-06-20	1984-07-04	1	5298
67084	4578	1125315	1967-04-09	1967-04-23	1	-984
28353	1921	738818	1965-08-20	1965-08-27	1	-1588
70606	4822	1728416	1949-06-07	1949-06-21	1	-7499
25280	1715	1125315	1964-01-15	1964-01-22	1	-2171
29942	2025	1112807	1969-04-05	1969-04-26	1	-250
68054	4644	1759842	1968-12-09	1968-12-30	1	-367
63830	4364	1119510	2007-05-28	2007-06-04	1	13668
38500	2619	1759842	1989-01-17	1989-02-07	1	6977
26046	1762	1310149	1998-04-09	1998-04-09	1	10325
45649	3100	1713332	2009-10-19	2009-11-09	1	14557
26471	1788	1125315	2007-01-16	2007-01-23	1	13536
67022	4574	1713332	2000-03-31	2000-04-21	1	11068
53595	3647	1112807	1991-09-01	1991-09-22	1	7934
73688	5037	19127890	1991-02-13	1992-02-08	1	8073
33653	2286	1728416	1959-03-04	1959-03-18	1	-3942
34163	2319	1713332	1964-06-26	1964-07-10	1	-2001
24319	1640	1557272	1996-05-08	1996-05-08	1	9624
72126	4927	1713332	2005-06-10	2005-07-01	1	12965
24558	1658	933724	1946-05-19	1946-05-26	1	-8621
40343	2743	1125315	1961-08-31	1961-09-14	1	-3031
28879	1953	1112807	1969-05-06	1969-05-20	1	-226
35884	2438	1549786	1995-06-14	1996-06-08	1	9655
75528	5169	1119510	1977-12-24	1977-12-31	1	2921
32588	2206	19127890	1991-10-29	1992-10-23	1	8331
572	36	1177480	2001-03-23	2001-04-29	1	11441
25879	1752	1729720	2009-08-08	2009-08-21	1	14477
51167	3486	1713332	1965-09-03	1965-09-24	1	-1560
74503	5096	1713332	1981-10-03	1981-12-19	1	4370
28390	1923	757627	2010-05-21	2010-05-21	1	14750
78020	5329	1713332	1957-07-28	1957-08-04	1	-4533
26192	1770	1549786	1993-06-02	1994-05-28	1	8913
74125	5067	1125315	1977-04-17	1977-05-08	1	2684
23789	1609	1551099	1959-07-29	1959-07-29	1	-3809
22621	1536	1759842	1913-01-27	1913-02-03	1	-20786
30226	2044	1713332	2015-05-17	2015-05-31	1	16586
75568	5172	1728416	1957-01-23	1957-02-06	1	-4712
33659	2287	1124957	1954-09-10	1954-09-10	1	-5592
74058	5063	1713332	1972-06-28	1972-07-12	1	923
33716	2290	1112807	1969-01-24	1969-02-23	1	-312
74969	5132	19127890	1981-07-30	1983-07-20	2	4948
23992	1622	1521369	1994-04-22	1996-04-11	2	9597
65939	4504	1326303	2019-06-22	2019-06-22	1	18069
76897	5256	1125315	1964-05-15	1964-05-29	1	-2043
34953	2366	1125315	2008-06-06	2008-06-20	1	14050
34760	2349	1125315	1974-02-03	1974-02-17	1	1508
57691	3934	914335	1984-09-19	1984-09-19	1	5375
20767	1412	1125315	1987-08-14	1987-09-04	1	6455
68413	4668	1728416	1958-07-13	1958-07-27	1	-4176
28690	1941	1759842	1979-12-16	1979-12-23	1	3643
65175	4452	1102527	1995-02-06	1995-02-06	1	9167
33769	2292	1125315	1988-08-03	1988-08-31	1	6817
70794	4835	1125315	2011-03-26	2011-03-26	1	15059
25324	1718	1119510	1991-10-27	1991-11-03	1	7976
67085	4578	1503184	1987-04-04	1988-03-29	1	6662
28354	1921	738818	1991-07-06	1991-07-13	1	7863
70607	4822	1728416	1951-04-06	1951-04-20	1	-6831
25281	1715	1125315	1994-03-06	1994-03-13	1	8837
29943	2025	1119510	2014-05-16	2014-05-30	1	16220
68055	4644	738818	1964-03-27	1964-04-10	1	-2092
63831	4364	1125315	1963-10-01	1963-10-01	1	-2284
38501	2619	738818	2013-02-24	2013-03-03	1	15767
26047	1762	1322184	2002-12-26	2002-12-26	1	12047
45650	3100	1759842	2009-10-19	2009-11-09	1	14557
26472	1788	1322184	2018-05-24	2018-05-24	1	17675
67023	4574	1729720	1982-09-21	1982-10-02	1	4657
53596	3647	1713332	1943-10-20	1943-11-03	1	-9556
73689	5037	19127890	2004-12-01	2005-11-26	1	13113
33654	2286	1738521	1973-08-26	1973-09-09	1	1347
34164	2319	1759842	1976-08-03	1976-08-10	1	2413
24320	1640	1729720	1948-05-11	1948-05-24	1	-7892
72127	4927	1713332	2006-04-03	2006-04-10	1	13248
24559	1658	1112807	1918-02-23	1918-03-30	1	-18905
40344	2743	1125315	1989-05-02	1989-05-16	1	7075
28880	1953	1118084	1998-03-11	1998-03-11	1	10296
35885	2438	1729720	1995-01-03	1995-01-14	1	9144
75529	5169	1713332	1983-10-26	1983-11-09	1	5060
33547	2280	975125	1975-06-11	1978-03-14	1	2994
573	36	1310149	2018-01-09	2018-01-09	1	17540
25880	1752	1118084	2016-03-10	2016-03-10	1	16870
51168	3486	1102527	1991-09-04	1991-09-04	1	7916
74504	5096	1759842	1981-10-03	1981-12-19	1	4370
28391	1923	1112807	1937-06-23	1937-07-07	1	-11866
78021	5329	1713332	1967-05-13	1967-05-20	1	-957
26193	1770	1713332	1996-07-15	1996-07-29	1	9706
74126	5067	1125315	1990-07-30	1990-08-13	1	7529
23790	1609	1728416	1946-10-15	1946-10-29	1	-8465
22622	1536	1759842	1967-02-14	1967-02-21	1	-1045
30227	2044	1717327	1964-11-27	1964-12-11	1	-1847
75569	5172	1759842	2004-05-04	2004-05-25	1	12563
33660	2287	1125315	1981-01-06	1981-01-20	1	4037
75029	5137	933724	1997-07-18	1997-07-25	1	10067
33717	2290	1115008	1999-08-13	1999-09-03	1	10837
74970	5132	19127890	1984-07-14	1985-07-09	1	5668
23993	1622	1549786	1991-05-08	1993-04-27	2	8517
65940	4504	1738521	1972-11-17	1972-12-01	1	1065
76898	5256	1125315	2008-03-05	2008-06-03	1	14033
34954	2366	19127890	1985-08-09	1986-08-04	1	6059
34761	2349	1728416	1972-10-06	1972-10-20	1	1023
57692	3934	914335	2005-11-16	2005-11-16	1	13103
20768	1412	1154343	1963-05-20	1963-05-20	1	-2418
68414	4668	1759842	1995-01-20	1995-01-27	1	9157
28691	1941	1759842	1997-12-27	1998-01-10	1	10236
65176	4452	1112807	1971-05-15	1971-05-29	1	513
33770	2292	1149380	2013-02-01	2013-02-01	1	15737
70795	4835	1177480	1987-06-30	1987-07-14	1	6403
25325	1718	1125315	1980-07-26	1980-08-09	1	3873
67086	4578	1521369	1979-05-16	1980-05-10	1	3782
28355	1921	933724	1992-12-31	1993-01-07	1	8407
70608	4822	920293	1989-10-21	1989-11-04	2	7247
25282	1715	1125315	2019-06-27	2019-06-27	1	18074
29944	2025	1125315	1954-09-11	1954-10-16	1	-5556
68056	4644	1115008	1995-08-16	1995-08-30	1	9372
63832	4364	1713332	1955-04-16	1955-04-30	1	-5360
38502	2619	1112807	1948-06-21	1948-07-21	1	-7834
26048	1762	1326303	1998-04-09	1998-04-09	1	10325
45651	3100	1119510	1990-06-11	1990-06-18	1	7473
29112	1973	1112807	1974-03-23	1974-04-06	1	1556
67024	4574	1759842	2000-03-31	2000-04-21	1	11068
53597	3647	1729720	1940-08-05	1940-08-13	1	-10733
74355	5083	1125315	1992-08-20	1992-09-24	1	8302
33655	2286	1112807	1959-03-04	1959-03-18	1	-3942
34165	2319	1112807	1949-03-06	1949-03-20	1	-7592
26288	1778	738818	2017-10-01	2017-10-15	1	17454
72128	4927	1759842	2005-06-10	2005-07-01	1	12965
24560	1658	1112807	1939-03-24	1939-04-21	1	-11213
40345	2743	1717327	1964-02-15	1964-02-29	1	-2133
28881	1953	1125315	1993-07-26	1993-08-09	1	8621
35886	2438	1115008	2017-11-05	2017-11-19	1	17489
75806	5191	738818	2014-09-03	2014-09-10	1	16323
33548	2280	975125	1983-10-17	1983-10-31	1	5051
574	36	1503184	1975-10-02	1976-09-26	1	2460
25881	1752	1125315	1982-06-20	1982-07-04	1	4567
51169	3486	1118084	2000-12-24	2000-12-24	1	11315
74505	5096	1778162	2001-02-14	2001-02-28	1	11381
28392	1923	1119510	2013-03-27	2013-04-03	1	15798
78022	5329	1112807	1946-10-03	1946-10-24	1	-8470
26194	1770	1759842	2000-05-30	2000-06-13	1	11121
74127	5067	1125315	2002-04-27	2002-05-11	1	11818
23791	1609	1112807	1943-06-23	1943-07-07	1	-9675
22623	1536	1125315	1917-12-28	1918-01-11	1	-18983
30228	2044	1729720	1978-04-20	1978-05-02	1	3043
75570	5172	1112807	1948-06-16	1948-06-30	1	-7855
33661	2287	1174888	2001-01-26	2001-01-26	1	11348
75030	5137	1125315	1972-06-30	1972-07-14	1	925
33718	2290	1119510	1998-06-19	1998-07-03	1	10410
74971	5132	1102527	1979-09-29	1979-09-29	1	3558
23994	1622	1125315	2002-06-12	2002-06-26	1	11864
65941	4504	1112807	1972-11-17	1972-12-01	1	1065
76899	5256	1759842	2013-09-25	2013-10-09	1	15987
34955	2366	738818	1982-01-18	1982-01-25	1	4407
34762	2349	1125315	2010-03-23	2010-03-30	1	14698
57693	3934	1118084	1972-09-23	1972-09-23	1	996
20769	1412	1717327	1964-09-24	1964-10-08	1	-1911
68415	4668	914335	2011-04-26	2011-04-26	1	15090
31135	2105	1713332	1989-01-29	1989-02-12	1	6982
65177	4452	1729720	1955-11-03	1955-11-16	1	-5160
33771	2292	1115008	2018-01-22	2018-02-12	1	17574
70796	4835	1713332	1981-03-09	1981-03-23	1	4099
25326	1718	1738521	1969-08-02	1969-08-16	1	-138
67087	4578	1521369	1982-04-30	1983-04-25	1	4862
28356	1921	1112807	1968-07-10	1968-10-08	1	-450
70609	4822	933724	1989-10-21	1989-11-04	1	7247
25283	1715	1177480	1996-02-08	1996-03-14	1	9569
29945	2025	1125315	1965-10-30	1965-11-13	1	-1510
68057	4644	1125315	1964-03-27	1964-04-10	1	-2092
63833	4364	1112807	1952-09-21	1952-10-05	1	-6297
38503	2619	1118084	1978-08-18	1978-08-18	1	3151
26049	1762	1347450	2002-12-26	2002-12-26	1	12047
45652	3100	1112807	1954-06-06	1954-06-20	1	-5674
29113	1973	1125315	1996-12-20	1996-12-20	1	9850
67697	4622	1112807	1962-12-20	1963-01-24	1	-2534
53598	3647	1759842	1988-11-28	1988-12-05	1	6913
74356	5083	1118084	1984-01-27	1984-01-27	1	5139
33656	2286	1112807	1967-03-14	1967-04-11	1	-996
34166	2319	1112807	1949-08-20	1949-09-03	1	-7425
26289	1778	1125315	2017-10-01	2017-10-15	1	17454
72129	4927	1759842	2006-04-03	2006-04-10	1	13248
24561	1658	1125315	1928-07-31	1928-08-14	1	-15115
40346	2743	1729720	2008-03-19	2008-03-26	1	13964
28882	1953	920293	2002-09-04	2002-09-11	1	11941
35887	2438	1125315	1997-05-15	1997-05-29	1	10010
75807	5191	1112807	1981-05-20	1981-06-03	1	4171
33549	2280	1177480	1974-09-27	1974-10-11	1	1744
575	36	1503184	1977-09-21	1978-09-16	1	3180
25882	1752	1125315	1993-06-07	1993-06-21	1	8572
51170	3486	1125315	1995-12-30	1996-01-13	1	9508
74506	5096	19127890	1987-03-09	1989-02-26	2	6996
28393	1923	1125315	2008-08-10	2008-08-24	1	14115
78023	5329	1115008	2001-09-01	2001-09-15	1	11580
26195	1770	1759842	2008-11-10	2008-12-15	1	14228
74128	5067	1149380	1978-06-08	1978-06-08	1	3080
23792	1609	1112807	1946-10-15	1946-10-29	1	-8465
22624	1536	1125315	1964-02-03	1964-02-10	1	-2152
30229	2044	1759842	1962-12-14	1962-12-21	1	-2568
75571	5172	1112807	1952-10-23	1952-11-13	1	-6258
33662	2287	1177480	2014-01-22	2014-01-22	1	16092
75031	5137	1125315	1989-05-17	1989-06-07	1	7097
33719	2290	1125315	1988-02-28	1988-04-28	1	6692
74972	5132	1115008	2014-05-03	2014-06-02	1	16223
23995	1622	1125315	2015-02-08	2015-02-22	1	16488
65942	4504	1125315	2003-11-05	2003-12-05	2	12391
76900	5256	738818	1987-08-23	1987-08-30	1	6450
34956	2366	1125315	1966-06-10	1966-06-24	1	-1287
34763	2349	1177480	1987-02-09	1987-05-10	1	6338
57694	3934	1125315	1952-03-26	1952-04-09	1	-6476
25372	1720	1125315	1998-03-21	1998-06-19	1	10396
68416	4668	1125315	1987-06-22	1987-08-28	2	6448
31136	2105	1713332	2000-06-20	2000-07-11	1	11149
65178	4452	1729720	1958-05-07	1958-05-17	1	-4247
33772	2292	1125315	2009-01-16	2009-01-30	1	14274
70797	4835	1713332	2011-03-26	2011-04-16	1	15080
25327	1718	738818	2011-10-14	2011-10-28	1	15275
67088	4578	1713332	1980-03-03	1980-03-10	1	3721
28357	1921	1119510	1955-02-06	1955-02-13	1	-5436
70610	4822	1112807	1949-06-07	1949-06-21	1	-7499
25284	1715	1728416	1959-04-09	1959-04-23	1	-3906
29946	2025	1322184	2007-07-21	2007-07-21	1	13715
68058	4644	1125315	2007-07-31	2007-08-14	1	13739
63834	4364	1112807	1960-10-09	1960-11-08	1	-3341
38504	2619	1125315	1943-09-18	1943-10-02	1	-9588
26050	1762	1713332	1989-05-25	1989-06-15	1	7105
45653	3100	1125315	1951-10-03	1951-10-24	1	-6644
29114	1973	1521369	1989-05-13	1990-05-08	1	7432
67698	4622	1112807	1966-06-19	1966-07-03	1	-1278
53599	3647	1112807	1947-04-11	1947-04-25	1	-8287
74357	5083	1713332	1975-06-15	1975-09-07	1	2075
33657	2286	1112807	1973-08-26	1973-09-09	1	1347
34167	2319	1124300	1990-02-24	1990-02-24	1	7359
26290	1778	1115008	2015-01-14	2015-02-04	1	16470
72130	4927	1778162	1983-06-02	1983-06-16	1	4914
24562	1658	1125315	1982-01-12	1982-01-26	1	4408
40347	2743	920293	1995-05-12	1995-05-19	1	9269
28883	1953	933724	2002-09-04	2002-09-11	1	11941
35888	2438	1515774	1995-06-14	1996-06-08	1	9655
75808	5191	1125315	1993-01-22	1993-01-29	1	8429
33550	2280	1177480	2000-08-27	2000-09-10	1	11210
576	36	1717327	1961-10-17	1961-10-31	1	-2984
25883	1752	1125315	2004-11-03	2004-11-17	1	12739
51171	3486	1759842	1965-09-03	1965-09-24	1	-1560
74507	5096	1119510	1993-11-07	1993-11-21	1	8725
28394	1923	1713332	1980-11-01	1980-11-22	1	3978
78024	5329	1125315	1953-09-17	1953-10-08	1	-5929
26196	1770	738818	1986-06-01	1986-06-15	1	6009
74129	5067	1500211	1996-04-17	1997-04-12	1	9963
23793	1609	1112807	1949-03-17	1949-03-31	1	-7581
22625	1536	1713332	1913-01-27	1913-02-03	1	-20786
30230	2044	1112807	1966-04-14	1966-04-28	1	-1344
75572	5172	1112807	1959-07-08	1959-07-22	1	-3816
33663	2287	1309944	2014-01-24	2014-01-24	1	16094
75032	5137	1177480	1998-04-21	1998-05-05	1	10351
33720	2290	1177480	1975-05-23	1975-06-06	1	1982
74973	5132	1125315	1991-09-26	1991-10-31	1	7973
23996	1622	1521369	1988-05-23	1989-05-18	1	7077
65943	4504	1125315	2012-03-05	2012-03-19	1	15418
76901	5256	920293	1983-12-03	1983-12-17	2	5098
34957	2366	1125315	1982-01-18	1982-01-25	1	4407
34764	2349	1728416	1973-04-16	1973-04-30	1	1215
57695	3934	1177480	2011-11-03	2011-11-24	1	15302
25373	1720	1729720	1980-02-27	1980-03-09	1	3720
68417	4668	1309944	2011-04-26	2011-04-26	1	15090
31137	2105	1729720	1980-07-31	1980-08-13	1	3877
65708	4488	1124300	2018-02-10	2018-02-10	1	17572
33773	2292	1177480	1979-02-24	1979-03-24	1	3369
73574	5034	738818	1973-12-22	1973-12-29	1	1458
25328	1718	1124300	2010-07-28	2010-07-28	1	14818
67089	4578	1125315	1970-11-21	1970-11-28	1	331
28358	1921	1125315	1965-08-20	1965-08-27	1	-1588
70611	4822	1112807	1951-04-06	1951-04-20	1	-6831
25285	1715	1738521	1972-09-20	1972-10-04	1	1007
29947	2025	1713332	1946-08-09	1946-08-23	1	-8532
68059	4644	1713332	1968-12-09	1968-12-30	1	-367
63835	4364	1118084	1987-05-16	1987-05-16	1	6344
38505	2619	1125315	1980-06-27	1980-07-04	1	3837
26051	1762	1729720	1985-08-23	1985-09-05	1	5726
45654	3100	1713332	1987-03-07	1987-03-14	1	6281
29115	1973	1713332	1972-01-12	1972-01-19	1	748
67699	4622	1118084	1997-08-03	1997-08-03	1	10076
53600	3647	1112807	1956-05-09	1956-05-23	1	-4971
74358	5083	1713332	1993-08-20	1993-09-10	1	8653
37689	2561	1115008	1998-03-27	1998-04-10	1	10326
34168	2319	1125315	1971-06-11	1971-06-18	1	533
26291	1778	1713332	1983-04-02	1983-04-16	1	4853
72131	4927	738818	1990-07-15	1990-07-22	1	7507
24563	1658	1125315	1982-05-03	1982-06-07	1	4540
40348	2743	1125315	1977-07-04	1977-10-02	2	2831
28884	1953	1119510	1957-06-26	1957-07-03	1	-4565
35889	2438	1515774	1997-06-03	1998-05-29	1	10375
75809	5191	1125315	1998-03-06	1998-03-20	1	10305
33551	2280	1192710	1974-06-24	1974-06-24	1	1635
577	36	1759842	1969-05-04	1969-05-18	1	-228
25884	1752	1713332	2015-01-26	2015-03-02	1	16496
51172	3486	19127890	1979-11-20	1981-11-09	2	4330
74508	5096	19127890	1985-03-19	1986-03-14	1	5916
28395	1923	1759842	1940-05-14	1940-08-06	1	-10740
78025	5329	1125315	1968-12-18	1969-02-16	1	-319
26197	1770	1125315	1995-01-04	1995-01-18	1	9148
74130	5067	1503184	1988-05-29	1989-05-24	1	7083
23794	1609	1124300	1980-01-29	1980-01-29	1	3680
22626	1536	1713332	1964-05-30	1964-06-20	1	-2021
30231	2044	1125315	1964-11-27	1964-12-11	1	-1847
75573	5172	1118084	1980-03-15	1980-03-15	1	3726
33664	2287	1322184	1997-04-11	2001-01-26	1	11348
75033	5137	1503184	1983-06-07	1984-06-01	1	5265
33721	2290	1729720	1999-10-07	1999-10-17	1	10881
74974	5132	1124300	2003-06-15	2003-06-15	1	12218
23997	1622	1521369	2001-03-22	2003-03-12	2	12123
65944	4504	1177480	1992-03-07	1992-05-06	1	8161
76902	5256	933724	1983-12-03	1983-12-17	1	5098
34958	2366	1549786	1989-07-19	1990-07-14	1	7499
34765	2349	1729720	1973-05-07	1973-05-20	1	1235
57696	3934	1309944	2005-11-16	2005-11-16	1	13103
25374	1720	1768849	1981-06-01	1981-06-15	1	4183
68418	4668	1343916	2011-04-26	2011-04-26	1	15090
31138	2105	1759842	1989-01-29	1989-02-12	1	6982
65709	4488	1125315	1992-08-26	1992-09-09	1	8287
33774	2292	1713332	2015-02-20	2015-03-06	1	16500
73575	5034	1125315	1930-12-22	1930-12-29	1	-14248
25329	1718	1125315	1969-08-02	1969-08-16	1	-138
67090	4578	1177480	1981-10-20	1981-11-10	1	4331
28359	1921	1125315	1987-03-06	1987-03-20	1	6287
70612	4822	1119510	2018-06-01	2018-06-15	1	17697
25286	1715	1112807	1959-04-09	1959-04-23	1	-3906
29948	2025	1729720	1910-11-29	1910-12-10	1	-21572
68060	4644	1124300	2001-02-10	2001-02-10	1	11363
63836	4364	1125315	1956-01-21	1956-02-04	1	-5080
38506	2619	1125315	2011-07-26	2011-08-02	1	15188
26052	1762	1119510	1967-10-06	1967-10-20	1	-804
45655	3100	1713332	1995-05-08	1995-05-29	1	9279
29116	1973	1503184	1989-05-13	1990-05-08	1	7432
67700	4622	1119510	1983-01-06	1983-01-20	1	4767
53601	3647	1125315	2004-03-31	2004-04-07	1	12515
74359	5083	1729720	1973-12-14	1973-12-24	1	1453
37690	2561	1119510	2014-04-22	2014-05-06	1	16196
34169	2319	1501700	2015-01-29	2015-01-29	1	16464
26292	1778	1119510	2017-10-01	2017-10-15	1	17454
72132	4927	1118084	2017-06-27	2017-06-27	1	17344
24564	1658	1125315	1990-03-27	1990-04-10	1	7404
40349	2743	1125315	2004-10-24	2004-10-31	1	12722
28885	1953	1125315	1956-08-28	1956-09-11	1	-4860
35890	2438	1549786	1997-06-03	1998-05-29	1	10375
75810	5191	1125315	2014-09-03	2014-09-10	1	16323
33552	2280	738818	1995-08-28	1995-09-04	1	9377
578	36	19010482	1993-05-26	1993-06-16	1	8567
25885	1752	1759842	2015-01-26	2015-03-02	1	16496
51173	3486	738818	1994-04-01	1994-04-08	1	8863
77298	5284	1124300	2008-07-29	2008-07-29	1	14089
30143	2037	1125315	1966-02-13	1966-03-13	1	-1390
78026	5329	1125315	2012-05-04	2012-05-18	1	15478
26198	1770	1125315	2006-04-30	2006-05-14	1	13282
74131	5067	1521369	1991-05-14	1992-05-08	1	8163
23795	1609	1125315	1957-03-01	1957-03-22	1	-4668
22627	1536	1112807	1913-12-02	1913-12-16	1	-20470
30232	2044	1125315	1967-03-19	1967-03-26	1	-1012
75574	5172	1125315	2017-05-11	2017-05-25	1	17311
33665	2287	1343916	2014-01-24	2014-01-24	1	16094
75034	5137	1768849	1991-04-03	1991-04-17	1	7776
33722	2290	1102527	1988-02-28	1988-02-28	1	6632
74975	5132	1125315	1970-05-21	1970-05-28	1	147
25661	1740	1118084	1989-10-12	1989-10-12	1	7224
65945	4504	1307863	2019-06-22	2019-06-22	1	18069
76903	5256	1125315	1972-11-23	1972-12-07	1	1071
34959	2366	19127890	1980-09-04	1981-08-30	1	4259
34766	2349	1759842	1992-08-28	1992-10-16	1	8324
57697	3934	1343916	2005-11-16	2005-11-16	1	13103
25375	1720	1118084	2014-05-11	2014-05-11	1	16201
68419	4668	1713332	1995-01-20	1995-01-27	1	9157
31139	2105	1759842	2000-06-20	2000-07-11	1	11149
65710	4488	1125315	2012-02-27	2012-05-27	2	15487
33775	2292	1759842	2015-02-20	2015-03-06	1	16500
73576	5034	1125315	1971-03-08	1971-04-14	2	468
25330	1718	1125315	1980-03-09	1980-03-23	1	3734
67091	4578	1503184	1979-05-16	1980-05-10	1	3782
28360	1921	1125315	1988-07-25	1988-08-15	1	6801
70613	4822	1125315	1947-10-26	1947-11-02	1	-8096
25287	1715	1119510	2019-06-27	2019-06-27	1	18074
29949	2025	1729720	2017-08-10	2017-08-17	1	17395
68061	4644	1125315	1963-12-27	1964-01-10	1	-2183
63837	4364	1125315	2019-01-08	2019-01-15	1	17911
38507	2619	1125315	2013-02-24	2013-03-03	1	15767
26053	1762	1125315	1948-08-22	1948-09-05	1	-7788
45656	3100	1728416	1952-09-12	1952-09-26	1	-6306
29117	1973	1713332	1983-03-01	1983-03-08	1	4814
67701	4622	1713332	1983-03-08	1983-03-22	1	4828
53602	3647	1177480	2010-11-09	2010-12-14	1	14957
74360	5083	1102527	1993-08-20	1993-08-20	1	8632
37691	2561	1125315	1981-08-02	1981-08-23	1	4252
34170	2319	1728416	1948-11-06	1948-11-20	1	-7712
26293	1778	1125315	1993-07-08	1993-09-06	2	8649
72133	4927	1119510	2007-05-22	2007-05-29	1	13662
24565	1658	1125315	2008-03-13	2008-03-27	1	13965
40350	2743	1521369	1975-03-29	1977-03-18	2	2633
28886	1953	1717327	1969-05-06	1969-05-20	1	-226
35891	2438	1729720	1981-12-15	1981-12-25	1	4376
75811	5191	1503184	1988-07-26	1989-07-21	1	7141
33553	2280	1115008	1997-04-08	1997-05-15	1	9996
579	36	19010482	2015-07-08	2015-07-29	1	16645
25886	1752	1768849	1979-10-17	1979-10-30	1	3589
51174	3486	1125315	1991-09-04	1991-11-03	1	7976
77299	5284	1125315	1969-03-11	1969-03-25	1	-282
30144	2037	1125315	1970-07-23	1970-08-06	1	217
78027	5329	1713332	1979-04-20	1979-05-04	1	3410
26199	1770	1713332	1983-03-17	1983-03-31	1	4837
76875	5255	1112807	1971-10-06	1971-10-20	1	657
23796	1609	1125315	1984-06-19	1984-06-26	1	5290
22628	1536	1112807	1926-11-10	1927-01-09	1	-15698
30233	2044	1713332	1962-12-14	1962-12-21	1	-2568
75575	5172	1713332	2008-01-05	2008-01-26	1	13904
33666	2287	1539403	1991-03-08	1991-03-08	1	7736
75035	5137	19127890	1983-06-07	1984-06-01	1	5265
33723	2290	1125315	1976-11-13	1976-11-27	1	2522
74976	5132	1125315	2009-10-01	2009-10-08	1	14525
25662	1740	1119510	1962-10-16	1962-10-23	1	-2627
65946	4504	1713332	1995-07-06	1995-07-20	1	9331
76904	5256	1125315	1987-08-23	1987-08-30	1	6450
34960	2366	19127890	1989-07-19	1990-07-14	1	7499
34767	2349	1115008	1994-05-03	1994-05-17	1	8902
58967	4018	1112807	1978-07-22	1978-08-12	1	3145
25376	1720	1125315	1991-09-26	1991-10-03	1	7945
68420	4668	1759842	2001-11-28	2001-12-12	1	11668
31140	2105	1118084	2013-01-25	2013-01-25	1	15730
65711	4488	1177480	1982-09-27	1982-12-26	1	4742
33776	2292	1112807	1964-12-09	1965-02-07	1	-1789
73577	5034	1125315	1973-12-22	1973-12-29	1	1458
25331	1718	1125315	1986-12-20	1987-01-03	1	6211
67092	4578	1503184	1982-04-30	1983-04-25	1	4862
28361	1921	1125315	1991-07-06	1991-07-13	1	7863
70614	4822	1728416	1949-02-15	1949-03-01	1	-7611
25288	1715	1125315	1970-06-20	1970-06-27	1	177
29950	2025	1759842	1915-11-22	1915-11-29	1	-19757
68062	4644	1125315	1965-03-08	1965-03-22	1	-1746
63838	4364	1728416	1956-01-21	1956-02-04	1	-5080
38508	2619	1119510	2013-02-24	2013-03-03	1	15767
26054	1762	1137529	1964-03-12	1964-03-12	1	-2121
45657	3100	1759842	1987-03-07	1987-03-14	1	6281
29118	1973	1759842	1983-03-01	1983-03-08	1	4814
67702	4622	1125315	1957-09-17	1957-10-01	1	-4475
53603	3647	1759842	1958-11-20	1958-11-27	1	-4053
74361	5083	1112807	1948-09-12	1948-09-26	1	-7767
37692	2561	1125315	1984-03-21	1984-04-04	1	5207
34171	2319	1729720	2001-12-25	2002-01-01	1	11688
26294	1778	1118084	2017-09-25	2017-09-25	1	17434
72134	4927	1125315	1990-07-15	1990-07-22	1	7507
24566	1658	1177480	2010-12-21	2011-01-11	1	14985
41815	2834	1119510	1970-06-10	1970-06-24	1	174
28887	1953	1728416	1956-08-28	1956-09-11	1	-4860
35892	2438	738818	1988-06-12	1988-06-26	1	6751
75812	5191	1713332	2007-04-06	2007-04-20	1	13623
33554	2280	1119510	1993-12-20	1994-01-03	1	8768
580	36	975125	2011-02-07	2011-02-28	1	15033
28295	1917	1112807	1983-01-06	1983-02-10	1	4788
51175	3486	1125315	1994-04-01	1994-04-08	1	8863
77300	5284	1125315	1971-07-24	1971-07-31	1	576
30145	2037	1728416	1960-05-15	1960-05-29	1	-3504
78028	5329	920293	1991-01-10	1991-01-17	1	7686
26200	1770	19127890	1993-06-02	1994-05-28	1	8913
76876	5255	1115008	1999-02-17	1999-03-03	1	10653
23797	1609	1125315	1996-09-27	1996-10-18	1	9787
22629	1536	1125315	1919-09-17	1919-09-24	1	-18362
30234	2044	1713332	1996-09-24	1996-10-01	1	9770
75576	5172	1759842	1956-06-23	1956-07-14	1	-4919
33667	2287	1125315	2001-01-26	2001-01-26	1	11348
75036	5137	1118084	2004-03-28	2004-03-28	1	12505
33724	2290	1125315	1984-03-07	1984-03-14	1	5186
74977	5132	1503184	1981-07-30	1983-07-20	2	4948
25663	1740	1125315	2010-08-24	2010-09-23	1	14875
67230	4590	1125315	1962-06-10	1962-07-01	1	-2741
76905	5256	1177480	1988-04-14	1988-05-19	1	6713
34961	2366	1112807	1970-07-02	1970-07-16	1	196
34768	2349	1125315	2016-12-21	2016-12-28	1	17163
58968	4018	1125315	1990-05-04	1990-05-11	1	7435
25377	1720	1125315	2009-12-23	2010-01-06	1	14615
68421	4668	1112807	1963-01-24	1963-02-07	1	-2520
31141	2105	1119510	2015-03-06	2015-03-20	1	16514
65712	4488	1729720	1996-05-03	1996-05-15	1	9631
33777	2292	1125315	1984-05-13	1984-05-27	1	5260
73578	5034	1125315	1994-02-26	1994-02-26	1	8822
25332	1718	1125315	2011-10-14	2011-10-28	1	15275
67093	4578	1521369	1987-04-04	1988-03-29	1	6662
28362	1921	1125315	2016-01-19	2016-02-09	1	16840
70615	4822	1728416	1950-11-01	1950-11-15	1	-6987
25289	1715	1125315	2010-09-27	2010-10-25	1	14907
29951	2025	1759842	1969-04-18	1969-04-25	1	-251
68063	4644	1125315	1970-03-14	1970-03-21	1	79
63839	4364	1759842	1955-04-16	1955-04-30	1	-5360
38509	2619	1713332	1980-02-26	1980-03-11	1	3722
26055	1762	1149380	1964-03-12	1964-03-12	1	-2121
45658	3100	1759842	1995-05-08	1995-05-29	1	9279
29119	1973	1115008	1996-12-20	1997-01-19	1	9880
67703	4622	1713332	1999-10-13	1999-11-03	1	10898
55757	3795	1119510	2004-04-03	2004-04-17	1	12525
74362	5083	1112807	1949-08-22	1949-09-05	1	-7423
37693	2561	1125315	2014-04-22	2014-05-06	1	16196
34172	2319	1759842	1958-09-17	1958-09-24	1	-4117
26295	1778	1174888	1993-07-08	1993-07-08	1	8589
72135	4927	1500211	1995-06-28	1996-06-22	1	9669
24567	1658	1713332	1999-12-17	2000-01-07	1	10963
41816	2834	1119510	1980-07-03	1980-07-17	1	3850
28888	1953	1759842	1969-04-01	1969-04-22	1	-254
35893	2438	1125315	1988-06-12	1988-06-26	1	6751
75813	5191	1759842	2007-04-06	2007-04-20	1	13623
33555	2280	1124957	1997-04-15	1997-04-15	1	9966
581	36	1112807	1959-04-19	1959-05-03	1	-3896
28296	1917	1728416	1952-05-18	1952-06-01	1	-6423
51176	3486	1177480	2012-04-16	2012-07-15	1	15536
77301	5284	1129625	1971-09-13	1971-09-13	1	620
30146	2037	1112807	1963-02-07	1963-02-21	1	-2506
78029	5329	933724	1991-01-10	1991-01-17	1	7686
29645	2005	1713332	1985-06-13	1985-07-04	1	5663
76877	5255	1119510	1984-11-22	1984-11-29	1	5446
23798	1609	1112807	1950-10-13	1950-11-03	1	-6999
22630	1536	1759842	1964-05-30	1964-06-20	1	-2021
30235	2044	1759842	1996-09-24	1996-10-01	1	9770
2730	183	1112807	1979-02-25	1979-03-11	1	3356
33668	2287	1332418	1994-03-25	1994-03-25	1	8849
75037	5137	1125315	1975-01-17	1975-01-24	1	1849
33725	2290	1125315	1992-07-02	1992-07-09	1	8225
74978	5132	1503184	1984-07-14	1985-07-09	1	5668
25664	1740	1728416	1957-02-12	1957-02-26	1	-4692
67231	4590	1177480	2002-09-29	2002-12-28	1	12049
76906	5256	1729720	1970-07-21	1970-07-28	1	208
34962	2366	1112807	1972-03-10	1972-03-24	1	813
35280	2395	1112807	1964-06-07	1964-06-21	1	-2020
58969	4018	1125315	2005-07-12	2005-07-26	1	12990
25378	1720	1713332	1980-11-20	1980-12-04	1	3990
68422	4668	1118084	1997-05-20	1997-05-20	1	10001
31142	2105	1125315	1979-09-29	1979-10-13	1	3572
65713	4488	1759842	1984-06-03	1984-06-17	1	5281
33778	2292	1125315	1997-10-13	1997-11-03	1	10168
73579	5034	1361711	1993-01-23	1993-11-13	1	8717
25333	1718	1713332	1973-09-19	1973-10-03	1	1371
68544	4676	933724	1996-08-25	1996-09-01	1	9740
32923	2231	705944	1977-05-07	1988-05-14	1	6708
72873	4979	1124300	2014-08-28	2014-08-28	1	16310
25290	1715	1119510	1994-03-06	1994-03-13	1	8837
32716	2217	1115008	1995-02-05	1995-02-19	1	9180
68064	4644	1361711	1990-11-22	1990-11-22	1	7630
65472	4474	738818	1966-10-04	1966-10-18	1	-1171
38510	2619	1713332	1989-01-17	1989-02-07	1	6977
26056	1762	1307863	1998-04-09	1998-04-09	1	10325
45659	3100	738818	1990-06-11	1990-06-18	1	7473
29120	1973	1124957	1996-12-20	1996-12-20	1	9850
67704	4622	1728416	1957-09-17	1957-10-01	1	-4475
55758	3795	1124957	1993-06-28	1993-06-28	1	8579
74363	5083	1125315	1970-04-21	1970-05-05	1	124
37694	2561	1177480	2014-02-16	2014-03-02	1	16131
35690	2425	738818	2008-09-20	2008-10-04	1	14156
26296	1778	1177480	1983-04-02	1983-04-16	1	4853
72136	4927	1595799	1999-06-07	2000-06-01	1	11109
24568	1658	1729720	1925-03-16	1925-03-24	1	-16354
41817	2834	1125315	1964-06-02	1964-06-09	1	-2032
29688	2007	1125315	1987-12-27	1988-01-10	1	6583
35894	2438	19127890	1995-06-14	1996-06-08	1	9655
75814	5191	1125315	1973-10-03	1973-11-07	1	1406
33556	2280	738818	2015-11-01	2015-11-15	1	16754
582	36	1125315	1996-04-29	1996-05-13	1	9629
28297	1917	1759842	1955-04-10	1955-04-17	1	-5373
51177	3486	1503184	1979-11-20	1981-11-09	2	4330
77302	5284	1177480	1997-04-13	1997-07-12	1	10054
30147	2037	1118084	2000-05-20	2000-05-20	1	11097
78030	5329	1125315	1996-03-22	1996-04-05	1	9591
29646	2005	1729720	1979-11-12	1979-11-25	1	3615
76878	5255	1125315	2004-06-04	2004-06-18	1	12587
23799	1609	1119510	1986-11-14	1986-11-28	1	6175
24971	1690	1125315	2002-07-03	2002-08-07	1	11906
30236	2044	1124300	1997-01-18	1997-01-18	1	9879
2731	183	1125315	1975-10-19	1975-11-02	1	2131
33669	2287	1361711	2001-05-04	2001-05-04	1	11446
75038	5137	1125315	1987-06-06	1987-06-27	1	6386
33726	2290	1125315	1998-06-19	1998-07-03	1	10410
74979	5132	1125315	1979-09-29	1979-10-29	1	3588
25665	1740	738818	1962-10-16	1962-10-23	1	-2627
67232	4590	1118084	1995-11-24	1995-11-24	1	9458
76907	5256	1729720	2018-08-02	2018-08-15	1	17758
34963	2366	1115008	2001-05-21	2001-06-11	1	11484
35281	2395	1112807	1973-01-21	1973-04-21	1	1206
58970	4018	1717327	1964-06-23	1964-07-07	1	-2004
25379	1720	1759842	2005-12-12	2006-01-02	1	13150
68423	4668	1713332	2004-09-06	2004-09-20	1	12681
31143	2105	1125315	2008-06-04	2008-06-18	1	14048
65714	4488	1125315	1986-12-07	1986-12-14	1	6191
33779	2292	1728416	1966-08-31	1966-09-14	1	-1205
73580	5034	1713332	1975-02-20	1975-03-13	1	1897
25334	1718	1729720	1982-11-23	1982-12-05	1	4721
68545	4676	1177480	1997-12-25	1998-01-29	1	10255
32924	2231	1119510	1990-08-28	1990-09-04	1	7551
72874	4979	1515774	1997-06-13	1998-06-08	1	10385
25291	1715	1124300	1999-05-29	1999-05-29	1	10740
32717	2217	1115008	1995-12-02	1996-03-01	1	9556
68065	4644	1713332	1993-03-29	1993-04-05	1	8495
65473	4474	738818	2018-10-02	2018-10-09	1	17813
38511	2619	1112807	1941-01-29	1941-02-12	1	-10550
26057	1762	1728416	1946-08-01	1946-08-15	1	-8540
45660	3100	1112807	1952-09-12	1952-09-26	1	-6306
29121	1973	1125315	1985-08-24	1985-09-07	1	5728
67705	4622	1729720	1961-09-28	1961-10-09	1	-3006
55759	3795	1759842	2012-07-28	2012-08-11	1	15563
74364	5083	1125315	1993-08-20	1993-09-10	1	8653
37695	2561	1503184	1990-10-24	1991-10-19	1	7961
35691	2425	1112807	1966-01-08	1966-04-08	1	-1364
27778	1879	1102527	1994-11-25	1994-11-25	1	9094
72137	4927	1713332	1982-08-01	1982-08-15	1	4609
24569	1658	1112807	1914-11-25	1914-12-09	1	-20112
41818	2834	1112807	1941-10-17	1941-10-31	1	-10289
29689	2007	1125315	1993-07-29	1993-08-05	1	8617
35895	2438	19127890	1997-06-03	1998-05-29	1	10375
75815	5191	1125315	1977-08-18	1977-09-08	1	2807
33557	2280	1125315	1972-04-19	1972-05-03	1	853
583	36	1125315	2001-03-30	2001-03-30	1	11411
28298	1917	1759842	1999-09-17	1999-10-01	1	10865
51178	3486	1729720	1964-01-17	1964-01-26	1	-2167
77303	5284	19127890	1982-08-17	1983-08-12	1	4971
30148	2037	1125315	1974-01-30	1974-04-30	1	1580
78031	5329	1125315	2009-12-01	2009-12-15	1	14593
29647	2005	1738521	1976-09-07	1976-09-21	1	2455
76879	5255	738818	1984-11-22	1984-11-29	1	5446
23800	1609	1125315	1955-05-19	1955-06-02	1	-5327
24972	1690	1177480	1978-05-10	1978-08-08	1	3141
30237	2044	1125315	1993-08-07	1993-08-14	1	8626
2732	183	1118084	2017-03-02	2017-03-02	1	17227
33670	2287	1545958	2001-01-26	2001-01-26	1	11348
75039	5137	1125315	1992-07-20	1992-08-03	1	8250
33727	2290	1729720	1984-05-14	1984-05-25	1	5258
74980	5132	1125315	2011-06-01	2011-06-15	1	15140
25666	1740	1112807	1957-02-12	1957-02-26	1	-4692
67233	4590	1713332	1989-04-12	1989-04-26	1	7055
76908	5256	1125315	1965-07-16	1965-07-23	1	-1623
34964	2366	1118084	2006-06-25	2006-06-25	1	13324
35282	2395	1177480	1989-07-26	1989-08-16	1	7167
58971	4018	1728416	1966-06-25	1966-07-09	1	-1272
25380	1720	1768849	1979-12-26	1980-01-09	1	3660
68424	4668	1759842	2004-09-06	2004-09-20	1	12681
31144	2105	1713332	1982-05-06	1982-05-13	1	4515
65715	4488	1177480	1990-08-16	1990-09-06	1	7553
33780	2292	1729720	1966-11-02	1966-11-15	1	-1143
73581	5034	1112807	1922-11-08	1922-11-22	1	-17207
25335	1718	738818	1991-10-27	1991-11-03	1	7976
68546	4676	1768849	1982-11-03	1982-11-17	1	4703
32925	2231	1125315	1981-07-11	1981-07-25	1	4223
72875	4979	1521369	1993-07-04	1994-06-29	1	8945
25292	1715	1125315	1984-09-24	1984-10-08	1	5394
32718	2217	1549786	2000-05-19	2002-05-09	2	11816
68066	4644	1738521	1968-01-26	1968-02-09	1	-692
65474	4474	1112807	1966-11-18	1966-12-02	1	-1126
38512	2619	1112807	1944-10-10	1944-11-09	1	-9184
26058	1762	1759842	1989-05-25	1989-06-15	1	7105
45661	3100	1115008	2007-04-17	2007-05-08	1	13641
29122	1973	1738521	1974-03-23	1974-04-06	1	1556
67706	4622	1759842	1999-10-13	1999-11-03	1	10898
55760	3795	1717327	1974-02-08	1974-02-22	1	1513
74365	5083	1125315	2013-06-11	2013-07-02	1	15888
37696	2561	1713332	2014-02-16	2014-03-02	1	16131
35692	2425	1112807	1968-04-27	1968-06-26	1	-554
27779	1879	1118084	1995-10-15	1995-10-15	1	9418
72138	4927	1738521	1978-05-18	1978-06-08	1	3080
24570	1658	1112807	1928-01-07	1928-01-21	1	-15321
41819	2834	1174888	1999-12-04	1999-12-04	1	10929
29690	2007	1125315	2015-01-14	2015-01-28	1	16463
38915	2646	738818	1986-11-16	1986-11-23	1	6170
75816	5191	1713332	2006-04-26	2006-08-02	1	13362
33558	2280	1125315	1984-05-02	1984-05-16	1	5249
584	36	1125315	2012-06-04	2012-06-11	1	15502
28299	1917	1125315	1955-11-30	1955-12-07	1	-5139
51179	3486	1125315	1988-02-24	1988-03-02	1	6635
77304	5284	1102527	1997-04-13	1997-04-13	1	9964
30149	2037	1729720	1980-10-01	1980-10-08	1	3933
78032	5329	1177480	2000-09-22	2000-10-06	1	11236
29648	2005	1759842	1985-06-13	1985-07-04	1	5663
76880	5255	738818	1991-07-28	1991-08-04	1	7885
23801	1609	1125315	1993-10-13	1994-01-10	1	8775
24973	1690	1515774	1995-08-19	1999-07-29	4	10801
30238	2044	1125315	2016-10-14	2016-10-28	1	17102
2733	183	1125315	1976-02-18	1976-02-25	1	2246
33671	2287	1729720	1970-02-17	1970-03-01	1	59
75040	5137	1125315	2008-07-13	2008-07-27	1	14087
33728	2290	1118084	1993-04-08	1993-04-08	1	8498
74981	5132	1177480	2019-06-06	2019-06-06	1	18053
25667	1740	1112807	1961-06-21	1961-07-12	1	-3095
67234	4590	1713332	1990-12-24	1990-12-31	1	7669
76909	5256	1717327	1964-05-15	1964-05-29	1	-2043
34965	2366	1503184	1980-09-04	1981-08-30	1	4259
35283	2395	1125315	2012-10-19	2012-10-26	1	15639
58972	4018	1729720	1987-06-09	1987-06-17	1	6376
25381	1720	1177480	2007-10-30	2007-12-04	1	13851
68626	4682	1115008	2000-09-09	2000-09-23	1	11223
31145	2105	738818	2015-03-06	2015-03-20	1	16514
65716	4488	1713332	1987-06-09	1987-06-23	1	6382
33781	2292	1112807	1966-08-31	1966-09-14	1	-1205
73582	5034	1119510	1965-01-30	1965-02-06	1	-1790
25336	1718	1119510	2011-10-14	2011-10-28	1	15275
68547	4676	920293	1996-08-25	1996-09-01	1	9740
32926	2231	1125315	1982-09-03	1982-09-03	1	4628
72876	4979	1713332	1976-09-27	1976-10-11	1	2475
25293	1715	1125315	1998-09-04	1998-09-18	1	10487
32719	2217	1729720	1993-11-01	1993-11-08	1	8712
68067	4644	1759842	1993-03-29	1993-04-05	1	8495
65475	4474	1125315	2018-10-02	2018-10-09	1	17813
38513	2619	1112807	1976-06-22	1976-07-20	1	2392
26059	1762	1112807	1946-08-01	1946-08-15	1	-8540
45662	3100	1118084	1989-10-18	1989-10-18	1	7230
29123	1973	19127890	1989-05-13	1990-05-08	1	7432
67707	4622	738818	1983-01-06	1983-01-20	1	4767
55761	3795	1729720	2009-10-06	2009-10-16	1	14533
74366	5083	1177480	1995-06-02	1995-07-02	1	9313
37697	2561	1729720	2018-03-06	2018-03-15	1	17605
35693	2425	1125315	2008-09-20	2008-10-04	1	14156
27780	1879	738818	1980-05-12	1980-05-26	1	3798
72139	4927	19127890	1996-06-22	1997-06-17	1	10029
24571	1658	1115008	1995-04-14	1995-06-13	1	9294
41820	2834	1545958	1999-12-04	1999-12-04	1	10929
29691	2007	1177480	1991-11-25	1991-12-09	1	8012
38916	2646	1112807	1977-12-23	1978-01-06	1	2927
75817	5191	19127890	1988-07-26	1989-07-21	1	7141
33559	2280	1125315	1995-08-28	1995-09-04	1	9377
585	36	1326303	2018-01-09	2018-01-09	1	17540
28300	1917	1125315	1982-08-08	1982-08-22	1	4616
51180	3486	1521369	1979-11-20	1981-11-09	2	4330
77305	5284	1125315	2002-05-17	2002-05-31	1	11838
30150	2037	1729720	1982-08-01	1982-08-14	1	4608
78033	5329	1729720	1985-01-28	1985-02-09	1	5518
29649	2005	1112807	1977-10-12	1977-10-26	1	2855
76881	5255	1112807	1961-05-17	1961-05-31	1	-3137
23802	1609	1125315	2014-02-15	2014-05-17	1	16207
24974	1690	1521369	1991-09-09	1992-09-03	1	8281
30239	2044	1759842	2015-05-17	2015-05-31	1	16586
2734	183	1177480	1981-05-04	1981-08-02	1	4231
33672	2287	757627	2013-07-12	2013-07-12	1	15898
75041	5137	1154343	1970-06-27	1970-06-27	1	177
33729	2290	1125315	1972-10-05	1972-12-04	1	1068
74982	5132	1521369	1981-07-30	1983-07-20	2	4948
25668	1740	1125315	1962-10-16	1962-10-23	1	-2627
67235	4590	1759842	1989-04-12	1989-04-26	1	7055
76910	5256	1119510	1987-08-23	1987-08-30	1	6450
34966	2366	1515774	1989-07-19	1990-07-14	1	7499
35284	2395	1717327	1964-06-07	1964-06-21	1	-2020
58973	4018	738818	2000-06-18	2000-07-02	1	11140
25382	1720	1112807	1979-12-26	1980-01-09	1	3660
68627	4682	1119510	1992-05-11	1992-05-25	1	8180
31146	2105	1125315	1978-11-27	1978-12-04	1	3259
65717	4488	1729720	2011-11-23	2011-11-30	1	15308
33782	2292	1124300	2006-06-22	2006-06-22	1	13321
73583	5034	1125315	1967-04-07	1967-04-28	1	-979
25337	1718	1125315	1991-10-27	1991-11-03	1	7976
68548	4676	1119510	2014-10-29	2014-11-12	1	16386
32927	2231	1177480	2017-07-06	2017-07-27	1	17374
72877	4979	1729720	1986-04-05	1986-04-14	1	5947
25294	1715	1125315	2015-01-08	2015-01-15	1	16450
32720	2217	19127890	1993-06-25	1996-06-09	3	9656
68068	4644	1119510	1964-03-27	1964-04-10	1	-2092
65476	4474	1177480	1983-06-13	1983-06-27	1	4925
38514	2619	1125315	1964-04-18	1964-05-02	1	-2070
29758	2013	1124957	1975-10-16	1975-10-16	1	2114
45663	3100	1125315	1952-03-31	1952-04-14	1	-6471
29124	1973	1112807	1978-04-15	1978-04-29	1	3040
67708	4622	1125315	1983-01-06	1983-01-20	1	4767
55762	3795	1124300	2010-05-25	2010-05-25	1	14754
74367	5083	1729720	1988-03-25	1988-04-06	1	6670
37698	2561	1768849	1980-10-14	1980-10-28	1	3953
35694	2425	1177480	1991-04-27	1991-05-11	1	7800
27781	1879	1125315	1980-05-12	1980-05-26	1	3798
76575	5235	1112807	1940-03-02	1940-03-16	1	-10883
24572	1658	1118084	1948-01-07	1948-01-07	1	-8030
41821	2834	1118084	1972-01-06	1972-01-06	1	735
29692	2007	1778162	1988-11-05	1988-11-19	1	6897
38917	2646	1119510	2002-02-21	2002-02-28	1	11746
75818	5191	920293	2018-09-06	2018-09-13	1	17787
33560	2280	1125315	2015-11-01	2015-11-15	1	16754
586	36	1713332	1959-01-28	1959-02-18	1	-3970
28301	1917	1118084	1987-03-11	1987-03-11	1	6278
52258	3560	1125315	1976-07-11	1976-07-25	1	2397
77306	5284	1125315	2010-08-07	2010-08-21	1	14842
30151	2037	1759842	1995-10-23	1995-11-13	1	9447
78034	5329	933724	1996-02-09	1996-02-16	1	9542
29650	2005	1118084	2010-01-14	2010-01-14	1	14623
76882	5255	1112807	1961-11-13	1961-11-27	1	-2957
23803	1609	1728416	1955-05-19	1955-06-02	1	-5327
24975	1690	1729720	1979-12-31	1980-01-12	1	3663
33187	2250	1112807	1960-10-12	1960-10-26	1	-3354
2735	183	1729720	1988-07-27	1988-08-07	1	6793
33673	2287	1112807	1940-12-26	1941-01-16	1	-10577
75042	5137	1717327	1971-08-29	1971-09-12	1	619
33730	2290	1125315	1993-10-28	1993-11-11	1	8715
74983	5132	1521369	1984-07-14	1985-07-09	1	5668
25669	1740	1125315	1992-08-26	1992-09-09	1	8287
67236	4590	1759842	1990-12-24	1990-12-31	1	7669
76911	5256	1124300	2004-02-15	2004-02-15	1	12463
34967	2366	1521369	1985-08-09	1986-08-04	1	6059
35285	2395	1112807	1966-01-28	1966-04-28	1	-1344
58974	4018	1125315	1975-12-14	1976-01-04	1	2194
25383	1720	1125315	1981-06-01	1981-06-15	1	4183
68628	4682	1125315	1981-02-07	1981-02-21	1	4069
31147	2105	1125315	1981-02-12	1981-04-13	1	4120
65718	4488	1759842	1987-06-09	1987-06-23	1	6382
33783	2292	1125315	1986-08-14	1986-09-13	1	6099
73584	5034	1125315	1980-09-25	1980-10-09	1	3934
25338	1718	1125315	2006-02-19	2006-03-12	1	13219
68549	4676	1125315	1981-11-19	1981-12-03	1	4354
32928	2231	1729720	2012-12-02	2012-12-15	1	15689
72878	4979	19127890	2001-05-23	2002-05-18	1	11825
25295	1715	1125315	2019-03-12	2019-04-16	1	18002
32721	2217	738818	2001-01-06	2001-01-13	1	11335
68069	4644	1125315	1981-07-01	1981-07-15	1	4213
65477	4474	1728416	1966-11-18	1966-12-02	1	-1126
38515	2619	1322184	2004-10-22	2004-10-22	1	12713
29759	2013	1125315	1964-05-06	1964-05-20	1	-2052
45664	3100	1125315	1959-12-22	1959-12-29	1	-3656
29125	1973	1118084	2011-07-17	2011-07-17	1	15172
67709	4622	1125315	1996-01-15	1996-01-29	1	9524
55763	3795	1177480	1974-02-08	1974-02-22	1	1513
74368	5083	1177480	2011-06-08	2011-06-22	1	15147
37699	2561	19127890	1994-10-03	1995-09-28	1	9401
35695	2425	1177480	2003-01-08	2003-01-22	1	12074
27782	1879	1125315	1983-02-23	1983-03-23	1	4829
76576	5235	1112807	1954-01-15	1954-01-29	1	-5816
24573	1658	1125315	1984-09-17	1984-10-01	1	5387
41822	2834	1125315	1980-07-03	1980-07-17	1	3850
29693	2007	914335	1994-07-17	1994-07-17	1	8963
38918	2646	1125315	1980-02-13	1980-02-20	1	3702
75819	5191	1119510	2014-09-03	2014-09-10	1	16323
33561	2280	1713332	1983-03-20	1983-08-21	1	4980
587	36	1713332	1991-10-16	1991-10-30	1	7972
28302	1917	1347450	2006-06-04	2006-06-04	1	13303
52259	3560	1125315	1991-08-22	1991-08-29	1	7910
77307	5284	1713332	2006-08-24	2006-09-14	1	13405
30152	2037	1177480	2002-04-03	2002-05-01	1	11808
78035	5329	1125315	1951-07-30	1951-09-28	1	-6670
29651	2005	1125315	1976-09-07	1976-09-21	1	2455
76883	5255	1125315	1962-01-14	1962-01-21	1	-2902
28730	1946	1125315	1974-11-08	1974-11-15	1	1779
24976	1690	1521369	1994-08-24	1995-08-19	1	9361
33188	2250	1125315	1973-02-11	1973-02-18	1	1144
2736	183	1713332	2006-07-11	2006-07-18	1	13347
33674	2287	1112807	1945-12-12	1945-12-26	1	-8772
75043	5137	920293	1997-07-18	1997-07-25	1	10067
33731	2290	1125315	1998-09-03	1998-09-17	1	10486
74984	5132	1729720	1968-11-28	1968-12-11	1	-386
25670	1740	933724	2012-10-04	2012-10-11	1	15624
67237	4590	738818	1968-08-09	1968-08-16	1	-503
76912	5256	1713332	2013-09-25	2013-10-09	1	15987
34968	2366	1729720	1968-11-13	1968-11-21	1	-406
35286	2395	1118084	1996-06-23	1996-06-23	1	9670
58975	4018	1125315	2000-06-18	2000-07-02	1	11140
25384	1720	1713332	2005-12-12	2006-01-02	1	13150
68629	4682	1125315	1984-03-23	1984-04-06	1	5209
31148	2105	1125315	2015-03-06	2015-03-20	1	16514
65719	4488	1174888	2012-02-27	2012-02-27	1	15397
33784	2292	1125315	2001-12-26	2002-01-09	1	11696
73585	5034	1125315	1993-11-13	1993-11-13	1	8717
25339	1718	1713332	1980-07-26	1980-08-09	1	3873
68550	4676	1177480	1981-08-21	1981-09-20	1	4280
32929	2231	738818	1990-08-28	1990-09-04	1	7551
72879	4979	1125315	1986-02-01	1986-02-15	1	5889
25554	1733	738818	2001-03-06	2001-03-13	1	11394
32722	2217	1119510	2001-01-06	2001-01-13	1	11335
68070	4644	1322184	1999-12-02	1999-12-02	1	10927
65478	4474	1118084	1998-12-15	1998-12-15	1	10575
38516	2619	1332418	2004-10-22	2004-10-22	1	12713
29760	2013	1125315	1971-12-22	1972-01-05	1	734
45665	3100	1125315	1986-03-03	1986-03-17	1	5919
29126	1973	1125315	1974-06-21	1974-07-05	1	1646
67710	4622	1125315	2010-11-23	2010-12-07	1	14950
55764	3795	1713332	2012-07-28	2012-08-11	1	15563
74369	5083	1759842	1975-06-15	1975-09-07	1	2075
37700	2561	1125315	1980-10-14	1980-10-28	1	3953
35696	2425	1729720	1961-10-13	1961-10-20	1	-2995
27783	1879	1177480	1982-01-01	1982-01-29	1	4411
76577	5235	1118084	1960-05-29	1960-05-29	1	-3504
24574	1658	1125315	1989-05-01	1989-05-31	2	7090
41823	2834	1322184	1997-08-16	1999-12-04	1	10929
29694	2007	1309944	1994-07-17	1994-07-17	1	8963
38919	2646	1177480	1988-04-29	1988-07-28	1	6783
75820	5191	1125315	2002-11-07	2002-11-21	1	12012
33562	2280	1729720	1976-04-16	1976-04-28	1	2309
588	36	1729720	1959-11-18	1959-11-29	1	-3686
28303	1917	1713332	1999-09-17	1999-10-01	1	10865
52260	3560	1729720	1994-05-22	1994-06-04	1	8920
77308	5284	1759842	1990-08-25	1990-09-15	1	7562
30153	2037	1728416	1963-02-07	1963-02-21	1	-2506
78036	5329	1125315	1960-05-12	1960-05-19	1	-3514
29652	2005	1125315	1988-07-24	1988-08-07	1	6793
76884	5255	1125315	1984-11-22	1984-11-29	1	5446
28731	1946	1125315	2008-10-23	2008-11-22	1	14205
24977	1690	1713332	2012-08-15	2012-10-17	1	15630
33189	2250	1125315	1988-07-17	1988-08-07	1	6793
2737	183	1738521	1978-08-04	1978-08-18	1	3151
33675	2287	1112807	1954-09-10	1954-10-10	1	-5562
75044	5137	1112807	1971-08-29	1971-09-12	1	619
33732	2290	1713332	2013-04-08	2013-04-29	1	15824
76712	5242	1125315	1964-09-14	1964-09-28	1	-1921
25671	1740	1125315	1988-08-09	1988-08-16	1	6802
67238	4590	1125315	1968-08-09	1968-08-16	1	-503
34969	2366	1729720	1978-10-04	1978-10-11	1	3205
35287	2395	1729720	1972-08-06	1972-08-13	1	955
58976	4018	1738521	1968-01-25	1968-02-08	1	-693
25385	1720	1759842	1980-11-20	1980-12-04	1	3990
68630	4682	1515774	1997-08-22	1999-08-12	2	10815
31149	2105	1713332	1979-09-29	1979-10-13	1	3572
65720	4488	1729720	1978-10-08	1978-10-21	1	3215
33785	2292	1125315	2007-02-05	2007-02-19	1	13563
73586	5034	1174888	1971-03-15	1971-03-15	1	438
25340	1718	1759842	1973-09-19	1973-10-03	1	1371
68551	4676	1515774	1993-07-29	1996-07-13	3	9690
32930	2231	1125315	1990-08-28	1990-09-04	1	7551
72880	4979	1177480	1978-03-15	1978-06-13	1	3085
25555	1733	1125315	1983-03-10	1983-03-24	1	4830
32723	2217	1125315	1995-12-02	1995-12-02	1	9466
68071	4644	1332418	1996-11-28	1996-11-28	1	9828
65479	4474	1119510	1966-02-23	1966-03-09	1	-1394
38517	2619	1539403	2004-10-22	2004-10-22	1	12713
29761	2013	1503184	1974-02-21	1975-02-16	1	1872
45666	3100	1728416	1952-03-31	1952-04-14	1	-6471
29127	1973	1125315	1995-09-22	1995-10-06	1	9409
67711	4622	1729720	1968-11-04	1968-11-15	1	-412
55765	3795	738818	2004-04-03	2004-04-17	1	12525
47955	3254	1124300	2005-02-08	2005-02-08	1	12822
37701	2561	1515774	1994-10-03	1995-09-28	1	9401
35697	2425	19127890	1979-01-19	1980-01-14	1	3665
27784	1879	1729720	1967-10-31	1967-11-13	1	-780
76578	5235	1310149	1981-12-12	1981-12-12	1	4363
24575	1658	1125315	2000-06-14	2000-06-21	1	11129
41824	2834	1539403	1991-07-13	1991-07-13	1	7863
29695	2007	1343916	1994-07-17	1994-07-17	1	8963
38920	2646	1713332	1985-01-23	1985-02-13	1	5522
75821	5191	1521369	1988-07-26	1989-07-21	1	7141
33563	2280	1759842	1983-03-20	1983-08-21	1	4980
589	36	1729720	2006-11-22	2006-11-30	1	13482
28304	1917	1729720	1959-06-27	1959-07-07	1	-3831
52261	3560	1102527	1988-04-12	1988-04-12	1	6676
77309	5284	1521369	1982-08-17	1983-08-12	1	4971
30154	2037	1729720	1962-02-08	1962-02-20	1	-2872
78037	5329	1125315	1998-07-14	1998-08-04	1	10442
29653	2005	1125315	2018-03-18	2018-04-08	1	17629
76885	5255	1125315	1991-07-28	1991-08-04	1	7885
28732	1946	1310149	2014-01-04	2014-01-04	1	16074
24978	1690	1125315	1985-05-05	1985-05-12	1	5610
33190	2250	1125315	2007-10-14	2007-10-28	1	13814
2738	183	1759842	2006-07-11	2006-07-18	1	13347
33676	2287	1118084	1982-05-10	1982-05-10	1	4512
75045	5137	1125315	1970-11-04	1970-11-18	1	321
33733	2290	1759842	2013-04-08	2013-04-29	1	15824
76713	5242	1713332	1987-10-18	1987-10-25	1	6506
25672	1740	723013	1952-09-06	1953-01-31	1	-6179
67239	4590	1125315	1980-11-13	1980-11-20	1	3976
34970	2366	1125315	1974-12-09	1975-03-09	1	1893
35288	2395	1729720	1975-05-03	1975-05-13	1	1958
58977	4018	1112807	1964-12-20	1965-01-19	1	-1808
26951	1821	1119510	1978-07-07	1978-07-21	1	3123
68631	4682	1115008	2009-12-19	2010-01-02	1	14611
31150	2105	1759842	1982-05-06	1982-05-13	1	4515
65721	4488	1729720	2002-01-17	2002-01-30	1	11717
33786	2292	1137529	2013-02-01	2013-02-01	1	15737
73587	5034	1174888	1993-11-13	1993-11-13	1	8717
28502	1929	1125315	1954-09-18	1954-10-02	1	-5570
68552	4676	738818	2014-10-29	2014-11-12	1	16386
32931	2231	1177480	1982-09-03	1982-11-02	1	4688
72881	4979	1503184	1993-07-04	1994-06-29	1	8945
25556	1733	1125315	2002-04-08	2002-04-15	1	11792
32724	2217	1125315	2001-01-06	2001-01-13	1	11335
68072	4644	1539403	1993-11-25	1993-11-25	1	8729
65480	4474	1125315	1966-10-04	1966-10-18	1	-1171
38518	2619	1728416	1945-10-24	1945-11-07	1	-8821
29762	2013	1125315	1956-10-13	1956-10-27	1	-4814
45667	3100	1728416	1954-06-06	1954-06-20	1	-5674
29128	1973	1125315	2004-11-04	2004-11-18	1	12740
67712	4622	1759842	1983-03-08	1983-03-22	1	4828
55766	3795	1125315	1993-06-28	1993-07-28	2	8609
47956	3254	1125315	1964-04-07	1964-04-21	1	-2081
37702	2561	1521369	1990-10-24	1991-10-19	1	7961
35698	2425	1112807	1962-01-08	1962-01-29	1	-2894
27785	1879	1729720	1968-09-11	1968-09-23	1	-465
76579	5235	1713332	1947-02-02	1947-02-23	1	-8348
24576	1658	1125315	2016-04-18	2016-04-25	1	16916
41825	2834	738818	1970-06-10	1970-06-24	1	174
29696	2007	1713332	1996-11-08	1996-11-29	1	9829
38921	2646	1759842	1985-01-23	1985-02-13	1	5522
75822	5191	1759842	2006-04-26	2006-08-02	1	13362
33564	2280	738818	1993-12-20	1994-01-03	1	8768
590	36	1759842	1972-09-19	1972-10-03	1	1006
28305	1917	1729720	1984-03-01	1984-03-10	1	5182
52262	3560	1125315	1978-03-01	1978-03-15	1	2995
77310	5284	1778162	2002-05-17	2002-05-31	1	11838
30155	2037	1729720	2002-12-29	2003-01-08	1	12060
78038	5329	1759842	1957-07-28	1957-08-04	1	-4533
29654	2005	738818	2013-05-02	2013-05-09	1	15834
76886	5255	1177480	2015-12-18	2016-01-01	1	16801
28733	1946	1713332	1958-08-31	1958-09-07	1	-4134
24979	1690	1503184	1991-09-09	1992-09-03	1	8281
33191	2250	1728416	1960-10-12	1960-10-26	1	-3354
2739	183	1125315	1978-08-04	1978-08-18	1	3151
33677	2287	1125315	1954-09-10	1954-09-10	1	-5592
75046	5137	1125315	1972-02-20	1972-03-05	1	794
34515	2337	1115008	1999-12-23	2000-01-06	1	10962
76714	5242	1759842	1987-10-18	1987-10-25	1	6506
25673	1740	740275	1953-02-14	1953-08-15	1	-5983
67240	4590	1119510	1968-08-09	1968-08-16	1	-503
34971	2366	1125315	1983-06-25	1983-09-23	1	5013
35289	2395	1112807	1961-08-31	1961-09-14	1	-3031
58978	4018	1112807	1966-06-25	1966-07-09	1	-1272
26952	1821	1174888	1967-06-01	1967-06-01	1	-945
68632	4682	1125315	2005-04-02	2005-04-09	1	12882
31151	2105	1125315	1974-10-17	1974-10-31	1	1764
65722	4488	1713332	1984-06-03	1984-06-17	1	5281
33787	2292	1177480	2005-02-24	2005-03-17	1	12859
73588	5034	1332418	1994-01-29	1994-01-29	1	8794
28503	1929	1713332	1990-12-01	1990-12-15	1	7653
68553	4676	1125315	2002-11-04	2002-11-25	1	12016
32932	2231	1177480	2006-12-26	2007-01-09	1	13522
72882	4979	1515774	1995-06-24	1996-06-18	1	9665
25557	1733	1177480	1986-09-20	1986-10-18	1	6134
32725	2217	1174888	1995-12-02	1995-12-02	1	9466
68073	4644	1717327	1963-12-27	1964-01-10	1	-2183
65481	4474	1177480	1980-07-07	1980-07-28	1	3861
38519	2619	1729720	1948-03-24	1948-04-06	1	-7940
29763	2013	1125315	1975-10-16	1975-12-15	2	2174
46827	3178	708298	2014-03-14	2014-03-14	1	16143
29129	1973	1759842	1972-01-12	1972-01-19	1	748
67713	4622	1125315	1986-09-14	1986-09-28	1	6114
55767	3795	1125315	2004-04-03	2004-04-17	1	12525
47957	3254	1759842	2001-07-17	2001-08-07	1	11541
37703	2561	1713332	1997-10-17	1997-10-31	1	10165
35699	2425	1503184	1979-01-19	1980-01-14	1	3665
27786	1879	1729720	2019-04-24	2019-05-07	1	18023
76580	5235	1713332	1957-02-21	1957-03-14	1	-4676
24577	1658	1361711	1996-02-19	1996-02-19	1	9545
41826	2834	738818	1980-07-03	1980-07-17	1	3850
29697	2007	1729720	1994-05-27	1994-06-06	1	8922
38922	2646	1125315	2008-11-25	2008-12-02	1	14215
75823	5191	933724	2018-09-06	2018-09-13	1	17787
33565	2280	1119510	1995-08-28	1995-09-04	1	9377
591	36	1759842	1991-10-16	1991-10-30	1	7972
28306	1917	1112807	1952-05-18	1952-06-01	1	-6423
52263	3560	1713332	1961-01-08	1961-01-29	1	-3259
77311	5284	1125315	1969-11-08	1969-11-15	1	-47
30156	2037	1112807	1960-05-15	1960-05-29	1	-3504
78039	5329	1759842	1967-05-13	1967-05-20	1	-957
29655	2005	1115008	2013-08-11	2013-10-10	1	15988
76887	5255	1119510	1991-07-28	1991-08-04	1	7885
28734	1946	738818	1985-07-21	1985-08-04	1	5694
24980	1690	1515774	1992-09-03	1993-08-29	1	8641
33192	2250	1119510	1965-12-03	1965-12-10	1	-1483
2740	183	1125315	1983-01-26	1983-02-09	1	4787
33678	2287	1125315	1969-07-19	1969-08-18	1	-136
75047	5137	1125315	1991-04-03	1991-04-17	1	7776
34516	2337	1177480	1990-02-22	1990-03-15	1	7378
76715	5242	1124300	2000-02-03	2000-02-03	1	10990
25674	1740	920293	2012-10-04	2012-10-11	1	15624
68430	4670	738818	1993-07-03	1993-07-10	1	8591
34972	2366	1125315	2003-08-14	2003-08-21	1	12285
35290	2395	1125315	1962-03-29	1962-04-19	1	-2814
58979	4018	1112807	1968-01-25	1968-02-08	1	-693
26953	1821	1713332	1981-07-04	1981-07-11	1	4209
68633	4682	1521369	1996-08-27	1997-08-22	1	10095
31152	2105	1177480	1994-07-04	1994-07-18	1	8964
67467	4606	1118084	2016-12-17	2016-12-17	1	17152
33788	2292	1713332	1986-01-10	1986-01-17	1	5860
73589	5034	1361711	1994-01-29	1994-02-26	1	8822
28504	1929	1728416	1954-09-18	1954-10-02	1	-5570
68554	4676	1125315	2014-10-29	2014-11-12	1	16386
32933	2231	1759842	1979-11-26	1979-12-03	1	3623
72883	4979	1549786	1995-06-24	1996-06-18	1	9665
25558	1733	1759842	2011-12-30	2012-01-13	1	15352
32726	2217	1521369	2000-05-19	2002-05-09	2	11816
68074	4644	1717327	1965-03-08	1965-03-22	1	-1746
65482	4474	1177480	2017-10-17	2017-11-21	1	17491
40054	2721	1112807	1971-11-20	1971-12-04	1	702
29764	2013	19127890	1974-02-21	1975-02-16	1	1872
46828	3178	967823	2014-03-13	2014-03-14	1	16143
29362	1987	1115008	2003-07-25	2003-08-15	1	12279
69698	4756	757627	2018-12-01	2018-12-01	1	17866
58032	3958	1118084	2001-11-22	2001-11-22	1	11648
47958	3254	1112807	1967-03-26	1967-04-09	1	-998
37704	2561	1713332	1999-11-27	1999-12-18	1	10943
35700	2425	1112807	1965-02-21	1965-03-07	1	-1761
27787	1879	1759842	1965-10-02	1965-10-23	1	-1531
76581	5235	1713332	1970-04-29	1970-05-06	1	125
24578	1658	1729720	2005-02-26	2005-03-08	1	12850
41827	2834	1112807	1938-07-18	1938-08-01	1	-11476
29698	2007	1778162	1987-12-27	1988-01-10	1	6583
38923	2646	1728416	1977-12-23	1978-01-06	1	2927
75824	5191	1118084	2012-11-27	2012-11-27	1	15671
33566	2280	1119510	2015-11-01	2015-11-15	1	16754
592	36	19010482	2004-09-19	2004-10-10	1	12701
28307	1917	1322184	2006-06-04	2006-06-04	1	13303
52264	3560	1112807	1988-04-12	1988-05-12	1	6706
77312	5284	1503184	1982-08-17	1983-08-12	1	4971
30157	2037	1713332	1995-10-23	1995-11-13	1	9447
78040	5329	1759842	1979-04-20	1979-05-04	1	3410
29656	2005	1119510	2013-05-02	2013-05-09	1	15834
76888	5255	1124300	1996-08-26	1996-08-26	1	9734
28735	1946	1125315	2017-10-20	2017-10-27	1	17466
24981	1690	1549786	1992-09-03	1993-08-29	1	8641
33193	2250	1125315	1958-07-27	1958-08-10	1	-4162
2741	183	1729720	1996-11-26	1996-12-07	1	9837
33679	2287	1310149	2004-05-21	2004-05-21	1	12559
75048	5137	1125315	2011-02-24	2011-03-10	1	15043
34517	2337	1521369	1980-06-26	1982-06-16	2	4549
76716	5242	1310149	2018-08-31	2018-08-31	1	17774
25675	1740	1713332	1995-10-10	1995-10-17	1	9420
68431	4670	1115008	1994-04-26	1994-05-17	1	8902
34973	2366	1503184	1985-08-09	1986-08-04	1	6059
35291	2395	1125315	1990-06-01	1990-06-15	1	7470
58980	4018	1119510	2000-06-18	2000-07-02	1	11140
26954	1821	1759842	1964-01-13	1964-01-27	1	-2166
68634	4682	738818	1992-05-11	1992-05-25	1	8180
31430	2127	1118084	1997-01-07	1997-01-07	1	9868
67468	4606	1125315	1987-09-07	1987-09-14	1	6465
33789	2292	1729720	1971-03-27	1971-04-04	1	458
73590	5034	1713332	1922-06-20	1922-07-04	1	-17348
28505	1929	1759842	1962-11-11	1962-12-02	1	-2587
68555	4676	19127890	1993-07-29	1996-07-13	3	9690
32934	2231	1118084	2008-07-18	2008-07-18	1	14078
72884	4979	1549786	1997-06-13	1998-06-08	1	10385
25559	1733	1115008	1999-04-20	1999-05-18	1	10729
32727	2217	1500211	1999-05-25	2000-05-19	1	11096
68751	4690	920293	2010-07-10	2010-07-17	1	14807
65483	4474	1729720	1965-11-26	1965-12-08	1	-1485
40055	2721	1118084	2010-07-23	2010-07-23	1	14813
29765	2013	1118084	1996-08-19	1996-08-19	1	9727
46829	3178	1112807	1984-08-07	1984-08-21	1	5346
29363	1987	1125315	1993-10-19	1993-11-09	1	8713
69699	4756	1112807	1969-05-25	1969-06-22	1	-193
58033	3958	1125315	1965-04-20	1965-05-11	1	-1696
47959	3254	1177480	1974-09-04	1974-09-18	1	1721
37705	2561	1759842	1997-10-17	1997-10-31	1	10165
35701	2425	1124300	1994-07-29	1994-07-29	1	8975
27788	1879	1112807	1988-04-16	1988-04-30	1	6694
76582	5235	1759842	1961-10-08	1961-10-15	1	-3000
24579	1658	1759842	1943-12-28	1944-01-04	1	-9494
41828	2834	1112807	1938-11-30	1938-12-14	1	-11341
29699	2007	1115008	2014-09-06	2014-10-11	1	16354
38924	2646	738818	2002-02-21	2002-02-28	1	11746
77390	5291	1125315	1981-03-06	1981-03-20	1	4096
33567	2280	1124300	2002-06-16	2002-06-16	1	11854
593	36	19127890	1975-10-02	1976-09-26	1	2460
28308	1917	1713332	1955-04-10	1955-04-17	1	-5373
52265	3560	1124300	1994-08-14	1994-08-14	1	8991
77313	5284	1713332	1990-08-25	1990-09-15	1	7562
33118	2243	738818	1982-07-23	1982-08-06	1	4600
35805	2433	1539403	2014-03-16	2014-03-16	1	16145
29657	2005	1125315	1974-05-08	1974-05-22	1	1602
76889	5255	1125315	1983-03-03	1983-04-07	1	4844
28736	1946	1713332	1927-10-24	1927-11-14	1	-15389
24982	1690	1759842	2012-08-15	2012-10-17	1	15630
33194	2250	1125315	1993-12-27	1994-01-03	1	8768
2742	183	1768849	1979-02-25	1979-03-11	1	3356
33680	2287	1322184	2001-05-04	2001-05-04	1	11446
75049	5137	1713332	2010-04-24	2010-05-08	1	14737
34518	2337	1521369	1983-06-11	1984-06-05	1	5269
76717	5242	1326303	2018-08-31	2018-08-31	1	17774
25676	1740	1759842	1995-10-10	1995-10-17	1	9420
68432	4670	1118084	1989-07-15	1989-07-15	1	7135
34974	2366	1521369	1980-09-04	1981-08-30	1	4259
36559	2487	920293	1979-04-08	1979-04-15	1	3391
58981	4018	1713332	1966-01-19	1966-02-02	1	-1429
26955	1821	1759842	1981-07-04	1981-07-11	1	4209
68635	4682	738818	2008-05-24	2008-06-07	1	14037
31431	2127	1503184	1975-08-26	1976-08-20	1	2423
67469	4606	1125315	1992-05-12	1992-06-09	1	8195
33790	2292	1729720	1978-11-09	1978-11-22	1	3247
73591	5034	1729720	1973-06-24	1973-07-05	1	1281
28506	1929	19127890	1976-07-07	1977-07-02	1	2739
68556	4676	1118084	2018-09-11	2018-09-11	1	17785
32935	2231	1124957	1982-09-03	1982-09-03	1	4628
72885	4979	1595799	2000-05-28	2001-05-23	1	11465
25560	1733	1118084	2015-11-27	2015-11-27	1	16766
32728	2217	1503184	1993-06-25	1995-06-15	2	9296
68752	4690	1112807	1971-11-18	1971-12-02	1	700
65484	4474	1729720	1973-02-24	1973-03-09	1	1163
40056	2721	1713332	1973-01-19	1973-02-02	1	1128
29766	2013	1125315	1965-07-28	1965-08-25	1	-1590
46830	3178	1125315	1972-04-22	1972-05-06	1	856
29364	1987	1728416	1945-06-03	1945-06-17	1	-8964
69700	4756	1125315	1952-03-19	1952-03-26	1	-6490
58034	3958	1125315	1993-10-25	1993-11-22	2	8726
47960	3254	920293	1985-01-01	1985-01-08	1	5486
37706	2561	1759842	1999-11-27	1999-12-18	1	10943
35702	2425	1125315	1971-06-21	1971-07-05	1	550
27789	1879	1119510	1980-05-12	1980-05-26	1	3798
76583	5235	1112807	1927-11-25	1927-12-09	1	-15364
24580	1658	1759842	1952-03-09	1952-03-30	1	-6486
41829	2834	1125315	1970-06-10	1970-06-24	1	174
29700	2007	1118084	2018-08-21	2018-08-21	1	17764
38925	2646	914335	2007-12-14	2007-12-14	1	13861
77391	5291	1515774	1992-09-29	1993-09-24	1	8667
33568	2280	1125315	1982-07-28	1982-08-11	1	4605
594	36	19127890	1977-09-21	1978-09-16	1	3180
28616	1937	1119510	1980-12-12	1980-12-26	1	4012
52266	3560	1125315	1980-06-12	1980-06-19	1	3822
77314	5284	1729720	1973-12-19	1974-01-01	1	1461
33119	2243	1112807	1968-01-25	1968-02-08	1	-693
35806	2433	1125315	1966-09-21	1966-11-20	1	-1138
29658	2005	1125315	2013-05-02	2013-05-09	1	15834
76890	5255	1177480	1996-05-28	1996-07-02	1	9679
28737	1946	1759842	1927-10-24	1927-11-14	1	-15389
24983	1690	19127890	1994-08-24	1999-07-29	5	10801
33195	2250	738818	1965-12-03	1965-12-10	1	-1483
5698	392	1125315	1979-02-14	1979-02-28	1	3345
33681	2287	1729720	1969-09-06	1969-09-17	1	-106
75050	5137	1115008	2010-04-24	2010-05-08	1	14737
34519	2337	1713332	2012-09-29	2012-10-20	1	15633
76718	5242	1125315	1996-12-07	1996-12-14	1	9844
28406	1925	1102527	1957-06-16	1957-06-16	1	-4582
68433	4670	1125315	1958-02-08	1958-02-22	1	-4331
34975	2366	1717327	1966-06-10	1966-06-24	1	-1287
36560	2487	1119510	1993-09-30	1993-10-07	1	8680
58982	4018	1118084	2001-08-08	2001-08-08	1	11542
26956	1821	1124300	1982-08-12	1982-08-12	1	4606
68636	4682	1115008	2008-11-10	2008-11-24	1	14207
31432	2127	1713332	2005-06-28	2005-07-12	1	12976
67470	4606	1125315	2018-04-10	2018-04-17	1	17638
33791	2292	1759842	1986-01-10	1986-01-17	1	5860
73592	5034	1759842	1975-02-20	1975-03-13	1	1897
28507	1929	1112807	1957-08-15	1957-08-29	1	-4508
68557	4676	1125315	1982-11-03	1982-11-17	1	4703
32936	2231	1177480	2010-09-20	2010-10-11	1	14893
72886	4979	19127890	1997-06-13	1998-06-08	1	10385
25561	1733	1119510	2001-03-06	2001-03-13	1	11394
32729	2217	1515774	1995-06-15	1996-06-09	1	9656
68753	4690	1557272	2016-10-01	2016-10-01	1	17075
65485	4474	738818	1966-02-23	1966-03-09	1	-1394
40057	2721	1307863	2017-04-22	2017-04-22	1	17278
29767	2013	1521369	1974-02-21	1975-02-16	1	1872
46831	3178	1174888	2014-03-14	2014-03-14	1	16143
29365	1987	1728416	1948-06-03	1948-06-17	1	-7868
69701	4756	1125315	1997-10-26	1997-11-09	1	10174
58035	3958	1759842	1973-08-29	1973-09-19	1	1357
47961	3254	933724	1985-01-01	1985-01-08	1	5486
37707	2561	738818	2014-04-22	2014-05-06	1	16196
35703	2425	1521369	1979-01-19	1980-01-14	1	3665
27790	1879	1125315	1984-03-17	1984-04-07	1	5210
76584	5235	1112807	1930-04-07	1930-04-21	1	-14500
24581	1658	1759842	1999-12-17	2000-01-07	1	10963
41830	2834	1125315	1985-01-12	1985-02-02	1	5511
29701	2007	1125315	1988-11-05	1988-11-19	1	6897
38926	2646	1125315	1986-11-16	1986-11-23	1	6170
77392	5291	1515774	1997-09-03	1998-08-29	1	10467
33569	2280	1125315	1993-12-20	1994-01-03	1	8768
595	36	975125	1968-09-08	1968-09-22	1	-466
28617	1937	933724	2004-06-09	2004-06-16	1	12585
52267	3560	1125315	1987-02-26	1987-03-19	1	6286
77315	5284	1738521	1969-03-11	1969-03-25	1	-282
33120	2243	1125315	1977-08-22	1977-09-05	1	2804
35807	2433	1322184	2014-03-16	2014-03-16	1	16145
29659	2005	1713332	2001-04-12	2001-05-03	1	11445
76891	5255	1717327	1961-05-17	1961-05-31	1	-3137
28738	1946	1759842	1958-08-31	1958-09-07	1	-4134
24984	1690	1115008	2009-12-27	2010-01-17	1	14626
33196	2250	1118084	1995-03-18	1995-03-18	1	9207
5699	392	1125315	2019-01-31	2019-02-14	1	17941
33682	2287	1112807	1944-11-26	1944-12-17	1	-9146
75051	5137	1125315	2002-09-05	2002-09-12	1	11942
34520	2337	738818	2004-07-08	2004-07-15	1	12614
76719	5242	1717327	1964-09-14	1964-09-28	1	-1921
28407	1925	1112807	1957-06-16	1957-07-16	1	-4552
68434	4670	1125315	1993-07-03	1993-07-10	1	8591
36280	2468	738818	1939-12-03	1939-12-10	1	-10980
36561	2487	1125315	1986-05-17	1986-05-24	1	5987
58983	4018	1125315	1964-06-23	1964-07-07	1	-2004
26957	1821	1125315	1939-11-22	1939-12-06	1	-10984
68637	4682	1125315	1992-05-11	1992-05-25	1	8180
31433	2127	1125315	1966-10-03	1966-10-10	1	-1179
67471	4606	1115008	2013-06-03	2013-07-03	1	15889
34621	2343	1112807	1986-03-12	1986-04-09	1	5942
73593	5034	738818	1965-01-30	1965-02-06	1	-1790
28508	1929	1118084	1993-05-26	1993-05-26	1	8546
68558	4676	1549786	1993-07-29	1996-07-13	3	9690
32937	2231	1713332	1979-11-26	1979-12-03	1	3623
72887	4979	1115008	1996-01-10	1996-01-24	1	9519
25562	1733	1125315	1989-08-03	1989-10-09	1	7221
32730	2217	1549786	1995-06-15	1996-06-09	1	9656
68754	4690	1713332	1964-11-07	1964-11-28	1	-1860
65486	4474	1125315	1966-02-23	1966-03-09	1	-1394
40058	2721	1713332	2016-06-14	2016-06-28	1	16980
33592	2283	701322	2019-05-07	2019-05-07	1	18023
46832	3178	1307863	2006-09-23	2006-09-23	1	13414
29366	1987	1102527	1967-10-06	1967-10-06	1	-818
69702	4756	1177480	1994-08-15	1994-09-12	1	9020
58036	3958	1125315	1968-10-31	1968-11-14	1	-413
47962	3254	1125315	1963-12-31	1964-01-14	1	-2179
37708	2561	1549786	1994-10-03	1995-09-28	1	9401
35704	2425	1713332	2017-01-15	2017-02-05	1	17202
27791	1879	1729720	1984-02-05	1984-02-16	1	5159
76585	5235	1125315	1973-10-19	1973-10-26	1	1394
24582	1658	1112807	1912-09-22	1912-10-06	1	-20906
41831	2834	1125315	1990-06-26	1990-07-03	1	7488
29702	2007	1713332	1991-11-25	1991-12-09	1	8012
38927	2646	1125315	1991-05-14	1991-05-28	1	7817
77393	5291	738818	2002-01-02	2002-01-16	1	11703
33570	2280	1125315	1997-04-15	1997-04-15	1	9966
596	36	975125	1982-10-06	1982-10-20	1	4675
28618	1937	1759842	1990-07-29	1990-08-05	1	7521
52268	3560	1125315	2012-04-28	2012-05-12	1	15472
77316	5284	1759842	2006-08-24	2006-09-14	1	13405
33121	2243	1125315	1982-07-23	1982-08-06	1	4600
35808	2433	1332418	2014-03-16	2014-03-16	1	16145
29660	2005	1729720	2003-12-04	2003-12-12	1	12398
76892	5255	1112807	1973-08-31	1973-09-21	1	1359
28739	1946	1112807	1930-01-04	1930-01-18	1	-14593
24985	1690	1118084	2009-12-12	2009-12-12	1	14590
33197	2250	1125315	1965-12-03	1965-12-10	1	-1483
5700	392	1177480	1988-02-26	1988-03-11	1	6644
33683	2287	1112807	1965-07-19	1965-08-09	1	-1606
75052	5137	1149380	1970-06-27	1970-06-27	1	177
34521	2337	920293	1985-08-26	1985-09-02	1	5723
76720	5242	1115008	1997-12-20	1998-01-10	1	10236
28408	1925	1112807	1959-06-06	1959-07-06	1	-3832
68435	4670	1177480	1993-04-03	1993-05-01	1	8521
36281	2468	738818	1994-03-27	1994-04-03	1	8858
36562	2487	1501700	2010-02-16	2010-02-16	1	14656
58984	4018	1125315	1967-08-08	1967-08-15	1	-870
26958	1821	1125315	1955-09-19	1955-10-10	1	-5197
68638	4682	1125315	1993-04-10	1993-04-24	1	8514
31434	2127	1177480	1992-07-17	1992-08-07	1	8254
67472	4606	1174888	2013-06-03	2013-06-03	1	15859
34622	2343	1125315	2010-04-03	2010-04-24	1	14723
73594	5034	1112807	1945-02-10	1945-03-03	1	-9070
28509	1929	1503184	1976-07-07	1977-07-02	1	2739
68559	4676	1713332	1981-11-19	1981-12-03	1	4354
35377	2404	1112807	1968-01-06	1968-01-20	1	-712
72888	4979	1125315	1978-07-14	1978-07-28	1	3130
25563	1733	1125315	2001-03-06	2001-03-13	1	11394
32731	2217	1549786	1998-05-30	1999-05-25	1	10736
68755	4690	738818	1978-10-14	1978-10-28	1	3222
65487	4474	1713332	2017-11-17	2017-11-21	1	17491
40059	2721	1759842	2016-06-14	2016-06-28	1	16980
33593	2283	1118084	1975-07-21	1975-07-21	1	2027
46833	3178	19003953	2014-03-14	2014-03-14	1	16143
29367	1987	1115008	1996-10-24	1996-11-28	1	9828
69703	4756	1557272	2004-09-11	2004-09-11	1	12672
58037	3958	1125315	1980-06-21	1980-07-05	1	3838
47963	3254	1125315	1978-03-31	1978-05-05	1	3046
37709	2561	19127890	1990-10-24	1991-10-19	1	7961
35705	2425	1759842	2017-01-15	2017-02-05	1	17202
27792	1879	1112807	1963-05-11	1963-05-25	1	-2413
76586	5235	1125315	1982-01-23	1982-01-23	1	4405
24583	1658	1119510	2008-03-13	2008-03-27	1	13965
41832	2834	1125315	1999-12-04	1999-12-04	1	10929
29703	2007	1759842	1996-11-08	1996-11-29	1	9829
38928	2646	1125315	2002-02-21	2002-02-28	1	11746
77394	5291	1119510	2002-01-02	2002-01-16	1	11703
33571	2280	1729720	1993-04-04	1993-04-15	1	8505
597	36	1112807	1963-07-20	1963-08-03	1	-2343
28619	1937	738818	2015-04-06	2015-04-13	1	16538
52269	3560	1125315	2016-11-27	2016-12-04	1	17139
52823	3601	920293	1980-07-21	1980-07-28	1	3861
33122	2243	1118084	2005-09-03	2005-09-03	1	13029
35809	2433	1713332	2019-02-28	2019-03-14	1	17969
29661	2005	1738521	1974-05-08	1974-05-22	1	1602
76893	5255	1125315	1965-08-08	1965-09-12	1	-1572
28740	1946	1112807	1935-02-07	1935-02-28	1	-12726
24986	1690	1503184	1994-08-24	1995-08-19	1	9361
33198	2250	1125315	1974-08-13	1974-08-20	1	1692
5701	392	1713332	1989-01-01	1989-01-22	1	6961
33684	2287	1125315	1958-04-28	1958-05-05	1	-4259
75053	5137	1521369	1983-06-07	1984-06-01	1	5265
34522	2337	1119510	2004-07-08	2004-07-15	1	12614
76721	5242	1125315	1975-11-18	1975-12-02	1	2161
28409	1925	1115008	2006-11-10	2006-12-08	1	13490
68436	4670	1713332	1965-08-17	1965-08-24	1	-1591
36282	2468	1112807	1939-04-05	1939-04-19	1	-11215
36563	2487	933724	1979-04-08	1979-04-15	1	3391
58985	4018	1759842	1966-01-19	1966-02-02	1	-1429
26959	1821	1125315	1963-04-01	1963-04-22	1	-2446
68639	4682	1125315	2001-05-10	2001-05-24	1	11466
31435	2127	1713332	1976-08-21	1976-09-04	1	2438
67473	4606	1125315	2013-06-03	2013-06-03	1	15859
34623	2343	1713332	2006-08-05	2006-08-26	1	13386
73595	5034	1125315	1923-01-08	1923-01-22	1	-17146
28510	1929	1713332	1981-10-12	1981-10-26	1	4316
69965	4776	1119510	1981-12-10	1981-12-24	1	4375
35378	2404	1124300	2008-04-18	2008-04-18	1	13987
72889	4979	1521369	2000-05-28	2002-05-18	2	11825
25564	1733	1713332	2011-12-30	2012-01-13	1	15352
32732	2217	1595799	2000-05-19	2002-05-09	2	11816
68756	4690	1112807	1965-02-22	1965-04-23	1	-1714
65488	4474	1729720	1969-10-22	1969-10-30	1	-63
40060	2721	1125315	1971-04-26	1971-05-10	1	494
33594	2283	1125315	1987-03-07	1987-03-07	1	6274
46834	3178	738818	1999-08-19	1999-09-02	1	10836
29368	1987	1115008	2012-04-29	2012-05-20	1	15480
69704	4756	1713332	1987-10-02	1987-10-09	1	6490
58038	3958	1174888	1993-10-25	1993-10-25	1	8698
47964	3254	1713332	2001-07-17	2001-08-07	1	11541
37710	2561	1118084	2017-08-08	2017-08-08	1	17386
35706	2425	1119510	2008-09-20	2008-10-04	1	14156
27793	1879	1115008	1994-11-25	1995-01-24	1	9154
76587	5235	1174888	1982-01-23	1982-01-23	1	4405
24584	1658	1124957	1989-05-01	1989-05-01	1	7060
41833	2834	1332418	1994-07-30	1994-07-30	1	8976
32456	2199	1125315	1984-04-26	1984-07-25	1	5319
38929	2646	1309944	2007-12-14	2007-12-14	1	13861
77395	5291	1124300	2014-08-25	2014-08-25	1	16307
33572	2280	1738521	1974-09-27	1974-10-11	1	1744
598	36	1125315	1966-07-12	1966-07-26	1	-1255
28620	1937	920293	2009-07-12	2009-07-19	1	14444
52270	3560	1125315	2017-04-10	2017-05-01	1	17287
52824	3601	933724	1980-07-21	1980-07-28	1	3861
33123	2243	1119510	1982-07-23	1982-08-06	1	4600
35810	2433	1759842	2019-02-28	2019-03-14	1	17969
29662	2005	1738521	1977-10-12	1977-10-26	1	2855
76894	5255	1729720	1993-07-02	1993-07-12	1	8593
28741	1946	1115008	1997-05-24	1997-06-23	1	10035
24987	1690	1549786	1995-08-19	1999-07-29	4	10801
34331	2329	1177480	1976-08-06	1976-08-20	1	2423
5702	392	1759842	1989-01-01	1989-01-22	1	6961
33685	2287	1125315	1960-07-10	1960-08-14	1	-3427
75054	5137	1729720	1999-11-22	1999-11-30	1	10925
34523	2337	1125315	2004-07-08	2004-07-15	1	12614
76722	5242	1125315	1993-10-30	1993-11-13	1	8717
28410	1925	1125315	1975-06-08	1975-06-15	1	1991
68437	4670	1125315	1962-03-21	1962-03-28	1	-2836
36283	2468	1125315	1966-11-06	1966-11-13	1	-1145
36564	2487	1125315	1965-06-24	1965-07-01	1	-1645
60162	4102	1124300	2006-06-25	2006-06-25	1	13324
26960	1821	1125315	1974-11-18	1974-11-25	1	1789
68640	4682	1549786	1997-08-22	1999-08-12	2	10815
31436	2127	1713332	2018-11-15	2018-11-22	1	17857
67474	4606	1713332	1994-12-16	1994-12-30	1	9129
34624	2343	1118084	1995-12-25	1995-12-25	1	9489
73596	5034	1125315	1965-01-30	1965-02-06	1	-1790
28511	1929	1728416	1955-02-23	1955-03-09	1	-5412
69966	4776	1125315	1965-02-21	1965-03-07	1	-1761
35379	2404	1347450	1997-07-13	1997-07-13	1	10055
72890	4979	1713332	1986-02-01	1986-02-15	1	5889
25565	1733	1729720	2005-03-16	2005-03-26	1	12868
32733	2217	1713332	1995-02-05	1995-02-19	1	9180
68757	4690	1112807	1991-05-26	1991-06-09	1	7829
65489	4474	1119510	1966-10-04	1966-10-18	1	-1171
40061	2721	1125315	2013-04-07	2013-04-14	1	15809
33595	2283	1125315	2003-05-03	2003-05-24	1	12196
46835	3178	753626	2014-03-14	2014-03-14	1	16143
29369	1987	1124300	1981-04-25	1981-04-25	1	4132
69705	4756	1759842	1987-10-02	1987-10-09	1	6490
58039	3958	1713332	1973-08-29	1973-09-19	1	1357
47965	3254	1717327	1964-04-07	1964-04-21	1	-2081
37711	2561	1125315	1976-11-26	1976-12-10	1	2535
35707	2425	1717327	1965-02-21	1965-03-07	1	-1761
27794	1879	1557272	2019-05-04	2019-05-04	1	18020
76588	5235	1326303	1981-12-12	1981-12-12	1	4363
24585	1658	1125315	1952-01-16	1952-01-30	1	-6546
41834	2834	1361711	1948-05-08	1999-12-04	1	10929
32457	2199	1713332	2005-04-03	2005-04-17	1	12890
38930	2646	1343916	2007-12-14	2007-12-14	1	13861
77396	5291	1125315	1976-12-25	1977-01-08	1	2564
35099	2381	738818	1997-11-25	1997-12-09	1	10204
599	36	1307863	2018-01-09	2018-01-09	1	17540
28621	1937	933724	2009-07-12	2009-07-19	1	14444
52271	3560	1759842	1961-01-08	1961-01-29	1	-3259
52825	3601	1112807	1974-03-02	1974-04-06	1	1556
33124	2243	1125315	1967-01-16	1967-01-30	1	-1067
35811	2433	1124957	1986-02-27	1986-02-27	1	5901
29663	2005	1759842	2001-04-12	2001-05-03	1	11445
76895	5255	1738521	1971-10-06	1971-10-20	1	657
28742	1946	1118084	1963-01-06	1963-01-06	1	-2552
24988	1690	19127890	1991-09-09	1993-08-29	2	8641
34332	2329	1503184	1985-01-08	1986-01-03	1	5846
5703	392	1118084	2012-03-16	2012-03-16	1	15415
33686	2287	1125315	1984-12-13	1984-12-20	1	5467
75055	5137	1738521	1972-06-30	1972-07-14	1	925
34524	2337	933724	1985-08-26	1985-09-02	1	5723
76723	5242	1307863	2018-08-31	2018-08-31	1	17774
28411	1925	1177480	2019-02-03	2019-02-17	1	17944
68438	4670	1759842	1965-08-17	1965-08-24	1	-1591
36284	2468	1125315	1981-08-08	1981-08-15	1	4244
36565	2487	1125315	1989-04-20	1989-05-04	1	7063
60163	4102	1125315	1969-09-28	1969-10-05	1	-88
26961	1821	1125315	1998-10-07	1998-10-21	1	10520
68641	4682	1713332	1984-01-28	1984-02-18	1	5161
31437	2127	1759842	1978-05-02	1978-05-23	1	3064
67475	4606	1759842	1994-12-16	1994-12-30	1	9129
34625	2343	1119510	1990-07-11	1990-07-25	1	7510
73597	5034	1125315	1989-05-02	1989-05-16	1	7075
28512	1929	1112807	1955-02-23	1955-03-09	1	-5412
69967	4776	1310149	2011-04-24	2011-04-24	1	15088
35380	2404	1729720	2003-07-14	2003-07-21	1	12254
72891	4979	1759842	1976-09-27	1976-10-11	1	2475
26815	1814	708298	2018-04-03	2018-04-03	1	17624
32734	2217	1729720	1983-08-11	1983-08-22	1	4981
68758	4690	1125315	1978-10-14	1978-10-28	1	3222
65490	4474	1119510	2018-10-02	2018-10-09	1	17813
40062	2721	1326303	2017-04-22	2017-04-22	1	17278
33596	2283	1177480	1987-02-28	1987-04-06	1	6304
46836	3178	1119510	1999-08-19	1999-09-02	1	10836
29370	1987	1759842	1951-10-07	1951-10-21	1	-6647
69706	4756	1124300	1985-04-16	1985-04-16	1	5584
58040	3958	1115008	1996-10-07	1996-10-28	1	9797
47966	3254	1717327	1967-03-26	1967-04-09	1	-998
37712	2561	1717327	1976-11-26	1976-12-10	1	2535
38393	2611	1125315	1961-07-04	1961-07-18	1	-3089
27795	1879	1713332	1965-10-02	1965-10-23	1	-1531
76589	5235	1759842	1947-02-02	1947-02-23	1	-8348
24586	1658	1332418	1996-02-19	1996-02-19	1	9545
45251	3070	1118084	1999-12-31	1999-12-31	1	10956
32458	2199	1759842	2005-04-03	2005-04-17	1	12890
38931	2646	1118084	2009-07-18	2009-07-18	1	14443
77397	5291	1125315	1979-10-29	1979-11-12	1	3602
35100	2381	1112807	1948-05-14	1948-06-18	1	-7867
600	36	1713332	1972-09-19	1972-10-03	1	1006
28622	1937	1112807	1969-12-08	1969-12-22	1	-10
55068	3746	920293	1992-01-10	1992-01-17	1	8051
52826	3601	1125315	1971-05-18	1971-05-25	1	509
33125	2243	1125315	1978-12-08	1978-12-22	1	3277
37522	2551	920293	2000-12-04	2000-12-11	1	11302
30488	2063	1125315	1979-05-08	1979-06-12	1	3449
45370	3080	920293	1969-01-08	1969-01-22	2	-344
28743	1946	1119510	1985-07-21	1985-08-04	1	5694
27498	1855	1118084	2016-11-20	2016-11-20	1	17125
34333	2329	1729720	1977-03-14	1977-03-26	1	2641
5704	392	1177480	1978-03-20	1978-04-19	1	3030
33687	2287	1177480	1987-12-12	1988-01-09	1	6582
76399	5223	1118084	2004-10-27	2004-10-27	1	12718
34525	2337	1125315	2011-02-28	2011-03-14	1	15047
76724	5242	1729720	2017-05-12	2017-05-21	1	17307
28412	1925	1729720	1966-02-13	1966-02-23	1	-1408
68439	4670	920293	1990-05-08	1990-05-22	2	7446
36285	2468	1125315	1994-03-27	1994-04-03	1	8858
36566	2487	1124300	1992-08-09	1992-08-09	1	8256
60164	4102	1125315	1973-11-03	1973-12-03	1	1432
26962	1821	1125315	2010-02-20	2010-03-13	1	14681
68642	4682	1729720	1996-02-21	1996-03-01	1	9556
31438	2127	1759842	2018-11-15	2018-11-22	1	17857
67476	4606	1125315	1990-10-09	1990-10-16	1	7593
34626	2343	1125315	1959-05-28	1959-06-11	1	-3857
73598	5034	1539403	1993-01-23	1993-01-23	1	8423
28513	1929	1125315	1975-09-19	1975-10-10	1	2108
69968	4776	1713332	1965-09-27	1965-10-04	1	-1550
35381	2404	1112807	1975-12-04	1975-12-18	1	2177
72892	4979	1503184	2001-05-23	2002-05-18	1	11825
26816	1814	967823	2018-04-03	2018-04-03	1	17624
32735	2217	19127890	1998-05-30	1999-05-25	1	10736
68759	4690	1759842	1964-11-07	1964-11-28	1	-1860
65491	4474	1125315	1981-09-29	1981-10-06	1	4296
40063	2721	1738521	1971-11-20	1971-12-04	1	702
33597	2283	1112807	1939-03-12	1939-03-26	1	-11239
46837	3178	1125315	1999-08-19	1999-09-02	1	10836
29371	1987	1112807	1964-09-10	1964-09-24	1	-1925
69707	4756	1125315	1949-05-12	1949-05-26	1	-7525
58041	3958	1115008	2000-08-08	2000-08-29	1	11198
49146	3347	1125315	1984-12-13	1984-12-27	1	5474
39384	2679	1112807	1989-08-02	1989-08-30	1	7181
38394	2611	738818	1955-06-29	1955-07-13	1	-5286
27796	1879	1717327	1963-05-11	1963-05-25	1	-2413
76590	5235	1759842	1957-02-21	1957-03-14	1	-4676
24587	1658	1539403	1996-02-19	1996-02-19	1	9545
45252	3070	1125315	1967-12-19	1968-01-02	1	-730
32459	2199	738818	2016-02-27	2016-03-12	1	16872
38932	2646	1119510	1986-11-16	1986-11-23	1	6170
77398	5291	1125315	2002-01-02	2002-01-16	1	11703
35101	2381	1322184	1997-05-21	1997-05-21	1	10002
601	36	1717327	1963-07-20	1963-08-03	1	-2343
28623	1937	1125315	1977-07-13	1977-09-18	2	2817
55069	3746	933724	1992-01-10	1992-01-17	1	8051
52827	3601	1154343	1962-06-25	1962-06-25	1	-2747
33126	2243	1125315	1980-06-11	1980-06-25	1	3828
37523	2551	933724	2000-09-17	2000-09-24	1	11224
30489	2063	1125315	2008-04-30	2008-05-14	1	14013
45371	3080	933724	1969-01-08	1969-01-22	1	-344
28744	1946	1125315	1942-10-30	1942-11-13	1	-9911
27499	1855	1125315	2016-10-31	2016-11-14	1	17119
34334	2329	1738521	1973-12-27	1974-01-10	1	1470
5705	392	1759842	2015-10-22	2015-11-05	1	16744
33688	2287	1307863	2004-05-21	2004-05-21	1	12559
76400	5223	1125315	1968-06-20	1968-07-04	1	-546
34526	2337	1125315	2016-09-11	2016-09-18	1	17062
1060	72	1759842	1952-04-20	1952-05-11	1	-6444
28413	1925	1759842	1953-07-06	1953-07-27	1	-6002
68440	4670	933724	1990-05-08	1990-05-22	1	7446
36286	2468	1125315	1998-07-21	1998-07-28	1	10435
36567	2487	1729720	1961-04-17	1961-04-29	1	-3169
60165	4102	1503184	1988-01-31	1989-01-25	1	6964
26963	1821	1307863	1986-08-03	1986-08-03	1	6058
68643	4682	1759842	1984-01-28	1984-02-18	1	5161
31439	2127	19127890	1975-08-26	1976-08-20	1	2423
67477	4606	1125315	2006-10-24	2006-11-07	1	13459
34627	2343	1322184	2016-05-21	2016-05-21	1	16942
73599	5034	1759842	1922-06-20	1922-07-04	1	-17348
28514	1929	1125315	2016-11-03	2016-11-17	1	17122
69969	4776	1112807	1964-12-22	1965-01-05	1	-1822
35382	2404	1125315	1987-05-15	1987-05-22	1	6350
72893	4979	1549786	2000-05-28	2001-05-23	1	11465
26817	1814	1000560	2018-04-03	2018-04-03	2	17624
32736	2217	1124300	2018-11-06	2018-11-06	1	17841
68760	4690	920293	2012-08-26	2012-09-09	2	15592
65492	4474	1125315	1994-08-01	1994-08-08	1	8985
40064	2721	1112807	1989-10-16	1989-11-20	1	7263
33598	2283	1112807	1951-04-22	1951-05-06	1	-6815
46838	3178	1326303	2006-09-23	2006-09-23	1	13414
29372	1987	1112807	1967-10-06	1967-12-05	1	-758
69708	4756	1125315	1953-06-21	1953-06-28	1	-6031
58042	3958	1717327	1965-04-20	1965-05-11	1	-1696
49147	3347	1125315	1986-02-26	1986-03-12	1	5914
39385	2679	1177480	2012-02-22	2012-03-21	1	15420
38395	2611	1125315	1955-06-29	1955-07-13	1	-5286
30595	2071	738818	1972-10-08	1972-10-22	1	1025
76591	5235	1759842	1970-04-29	1970-05-06	1	125
24588	1658	1713332	1937-07-16	1937-08-06	1	-11836
45253	3070	1125315	1986-12-11	1986-12-18	1	6195
32460	2199	1125315	2016-02-27	2016-03-12	1	16872
38933	2646	1125315	1982-02-19	1982-02-26	1	4439
77399	5291	1503184	1991-10-05	1992-09-29	1	8307
35102	2381	1118084	1973-04-28	1973-04-28	1	1213
602	36	1728416	1959-04-19	1959-05-03	1	-3896
28624	1937	1125315	1979-07-10	1979-07-31	1	3498
55070	3746	1112807	1970-01-12	1970-02-16	1	46
52828	3601	1503184	1976-05-30	1977-05-25	1	2701
33127	2243	1125315	1984-12-29	1985-01-05	1	5483
37524	2551	1115008	2016-09-06	2016-10-04	1	17078
30490	2063	1713332	1973-11-11	1973-11-25	1	1424
45372	3080	1115008	2002-07-16	2002-08-06	1	11905
28745	1946	1125315	1953-12-19	1953-12-26	1	-5850
27500	1855	1177480	1978-10-31	1978-11-14	1	3239
34335	2329	1125315	1982-10-25	1983-01-23	1	4770
5706	392	1729720	1985-12-11	1985-12-19	1	5831
33689	2287	1326303	2004-05-21	2004-05-21	1	12559
76401	5223	1125315	1970-10-20	1970-10-27	1	299
34527	2337	1347450	2002-10-01	2002-10-01	1	11961
1061	72	1112807	1964-11-11	1964-11-25	1	-1863
28414	1925	1112807	1945-06-19	1945-07-03	1	-8948
68441	4670	1112807	1954-05-30	1954-06-13	1	-5681
36287	2468	1713332	2012-04-27	2012-05-18	1	15478
36568	2487	738818	1993-09-30	1993-10-07	1	8680
60166	4102	1521369	1980-03-13	1981-03-08	1	4084
26964	1821	738818	1978-07-07	1978-07-21	1	3123
68644	4682	1118084	2011-11-02	2011-11-02	1	15280
31440	2127	920293	1978-09-29	1978-10-06	1	3200
68836	4696	1125315	1962-02-03	1962-02-10	1	-2882
34628	2343	1728416	1959-05-28	1959-06-11	1	-3857
73600	5034	1119510	1973-12-22	1973-12-29	1	1458
28515	1929	1521369	1976-07-07	1977-07-02	1	2739
69970	4776	1125315	1974-06-03	1974-07-08	1	1649
35383	2404	1177480	1980-06-24	1980-07-15	1	3848
72894	4979	19127890	1993-07-04	1994-06-29	1	8945
26818	1814	1112807	1941-09-12	1941-09-26	1	-10324
32737	2217	1515774	1998-05-30	1999-05-25	1	10736
68761	4690	933724	2012-08-26	2012-09-09	1	15592
65493	4474	1177480	2002-05-18	2002-06-08	1	11846
40065	2721	1125315	1990-06-10	1990-06-17	1	7472
33599	2283	1124957	1987-03-07	1987-03-07	1	6274
46839	3178	1741122	2014-03-14	2014-03-14	1	16143
29373	1987	1713332	1951-10-07	1951-10-21	1	-6647
69709	4756	1125315	2010-12-01	2010-12-15	1	14958
58043	3958	1738521	1968-10-31	1968-11-14	1	-413
49148	3347	1125315	1993-10-22	1993-11-28	1	8732
39386	2679	1729720	1978-09-29	1978-10-07	1	3201
38396	2611	1713332	1987-06-25	1987-07-16	1	6405
30596	2071	1125315	1972-10-08	1972-10-22	1	1025
76592	5235	1112807	1922-10-16	1922-10-30	1	-17230
24589	1658	1713332	1943-12-28	1944-01-04	1	-9494
45254	3070	1125315	2008-04-24	2008-05-24	1	14023
32461	2199	1713332	1982-07-11	1982-08-01	1	4595
40671	2764	1118084	2009-10-09	2009-10-09	1	14526
77400	5291	1515774	1989-10-15	1990-10-10	1	7587
35103	2381	1125315	1987-07-13	1987-08-10	1	6430
603	36	1759842	1959-01-28	1959-02-18	1	-3970
28625	1937	1125315	2015-04-06	2015-04-13	1	16538
55071	3746	1125315	1957-06-28	1957-07-12	1	-4556
52829	3601	1503184	1979-05-15	1980-05-09	1	3781
34173	2320	738818	1947-11-01	1947-11-15	1	-8083
37525	2551	1119510	1991-01-09	1991-01-23	1	7692
30491	2063	1118084	2014-05-19	2014-05-19	1	16209
45373	3080	1125315	1950-06-23	1950-07-07	1	-7118
28746	1946	1125315	1975-01-29	1975-02-19	1	1875
27501	1855	1177480	1996-12-05	1996-12-26	1	9856
34336	2329	19127890	1985-01-08	1986-01-03	1	5846
5707	392	1713332	2015-10-22	2015-11-05	1	16744
33690	2287	1361711	1962-05-04	2001-01-26	1	11348
76402	5223	1125315	2010-10-17	2010-10-31	1	14913
34528	2337	1729720	1963-11-17	1963-11-24	1	-2230
1062	72	1118084	1984-12-26	1984-12-26	1	5473
28415	1925	1112807	1952-07-12	1952-08-11	1	-6352
68442	4670	1119510	1993-07-03	1993-07-10	1	8591
36288	2468	1729720	1972-09-18	1972-09-26	1	999
36569	2487	1125315	1980-11-17	1980-12-01	1	3987
60167	4102	1521369	1984-02-21	1985-02-15	1	5524
26965	1821	1125315	1952-12-12	1953-01-02	1	-6208
68645	4682	1119510	2008-05-24	2008-06-07	1	14037
31441	2127	1112807	1962-11-22	1962-12-06	1	-2583
68837	4696	1713332	1968-12-13	1968-12-27	1	-370
34629	2343	1125315	1958-09-30	1958-11-04	1	-4076
73601	5034	1124300	1959-07-27	1959-07-27	1	-3811
28516	1929	1713332	1989-07-23	1989-08-06	1	7157
69971	4776	1125315	2008-04-23	2008-05-07	1	14006
35384	2404	1112807	1974-01-22	1974-02-12	1	1503
72895	4979	19127890	1995-06-24	1996-06-18	1	9665
26819	1814	1112807	1953-07-11	1953-09-09	1	-5958
32738	2217	1521369	1993-06-25	1995-06-15	2	9296
68762	4690	1112807	1974-01-20	1974-02-10	1	1501
65494	4474	1729720	1972-07-19	1972-07-28	1	939
40066	2721	1310149	2017-04-22	2017-04-22	1	17278
33600	2283	1125315	2001-08-07	2001-08-14	1	11548
46840	3178	782043	2014-03-14	2014-03-14	1	16143
29374	1987	1112807	1945-06-03	1945-06-17	1	-8964
69710	4756	1759842	2000-10-22	2000-11-12	1	11273
58044	3958	1759842	1969-07-07	1969-07-14	1	-171
49149	3347	1177480	2011-02-16	2011-04-17	1	15081
39387	2679	1125315	1976-12-05	1977-01-04	1	2560
38397	2611	1729720	1974-07-14	1974-07-27	1	1668
30597	2071	19127890	1980-06-07	1981-06-02	1	4170
76593	5235	1112807	1927-01-31	1927-02-14	1	-15662
24590	1658	1713332	1952-03-09	1952-03-30	1	-6486
45255	3070	1713332	1973-01-18	1973-01-25	1	1120
32462	2199	1729720	1996-01-02	1996-01-10	1	9505
40672	2764	1500211	1992-07-25	1993-07-20	1	8601
77401	5291	1549786	1989-10-15	1990-10-10	1	7587
35104	2381	1125315	1997-11-25	1997-12-09	1	10204
604	36	19010482	2011-02-07	2011-02-28	1	15033
28626	1937	1713332	1990-07-29	1990-08-05	1	7521
55072	3746	1177480	2012-11-02	2012-12-02	1	15676
52830	3601	1521369	1979-05-15	1980-05-09	1	3781
34174	2320	1112807	1945-03-14	1945-04-18	1	-9024
37526	2551	1521369	1974-08-07	1975-08-02	1	2039
30492	2063	1125315	1984-11-08	1984-11-22	1	5439
45374	3080	1125315	1959-11-05	1959-11-19	1	-3696
28747	1946	1307863	2014-01-04	2014-01-04	1	16074
27502	1855	1738521	1976-12-10	1976-12-24	1	2549
34337	2329	1118084	2014-03-22	2014-03-22	1	16151
7384	510	1115008	2012-02-05	2012-02-26	1	15396
36332	2470	920293	1998-02-20	1998-02-27	1	10284
76403	5223	1503184	1983-01-11	1984-01-06	1	5118
34529	2337	1759842	2012-09-29	2012-10-20	1	15633
1063	72	1125315	1979-07-10	1979-08-07	1	3505
28416	1925	1112807	1971-09-22	1971-10-06	1	643
68443	4670	1125315	1967-02-23	1967-03-02	1	-1036
36289	2468	1759842	2012-04-27	2012-05-18	1	15478
36570	2487	1125315	1993-09-30	1993-10-07	1	8680
60168	4102	1729720	1979-09-09	1979-09-18	1	3547
26966	1821	1125315	1967-06-01	1967-06-01	1	-945
68646	4682	1125315	2008-05-24	2008-06-07	1	14037
31442	2127	1115008	1995-06-23	1995-07-07	1	9318
68838	4696	1713332	1989-08-12	1989-08-26	1	7177
34630	2343	1125315	1970-06-30	1970-07-14	1	194
73602	5034	1125315	1927-11-28	1927-12-05	1	-15368
28517	1929	1728416	1957-08-15	1957-08-29	1	-4508
69972	4776	1759842	1965-09-27	1965-10-04	1	-1550
35385	2404	1125315	1966-05-04	1966-05-18	1	-1324
73434	5023	1118084	2015-06-12	2015-06-12	1	16598
26820	1814	1118084	1981-10-22	1981-10-22	1	4312
32739	2217	1713332	2009-11-23	2009-12-07	1	14585
68763	4690	1115008	2004-05-06	2004-05-20	1	12558
67029	4576	738818	1988-05-03	1988-05-17	1	6711
40067	2721	1713332	2015-12-25	2016-01-08	1	16808
33601	2283	1361711	2018-11-19	2018-11-19	1	17854
46841	3178	1125315	1962-09-11	1962-10-09	1	-2641
29375	1987	1112807	1948-04-18	1948-06-17	1	-7868
69711	4756	1125315	1977-06-03	1977-06-10	1	2717
58045	3958	1125315	1974-02-03	1974-02-10	1	1501
49150	3347	1115008	2008-06-10	2008-07-01	1	14061
39388	2679	1125315	1982-11-09	1982-12-07	1	4723
38398	2611	1729720	2008-08-26	2008-09-08	1	14130
30598	2071	1112807	1970-02-20	1970-05-21	1	140
76594	5235	1125315	1967-07-20	1967-08-10	1	-875
24591	1658	1729720	1926-06-21	1926-06-29	1	-15892
45256	3070	19127890	1984-08-31	1986-08-21	2	6076
32463	2199	1119510	2016-02-27	2016-03-12	1	16872
40673	2764	1503184	1987-08-21	1988-08-15	1	6801
77402	5291	1549786	1992-09-29	1993-09-24	1	8667
35105	2381	1177480	1982-11-15	1982-12-06	1	4722
1203	82	1125315	2006-03-11	2006-03-18	1	13225
28627	1937	1729720	1966-08-10	1966-08-19	1	-1231
55073	3746	1728416	1957-06-28	1957-07-12	1	-4556
52831	3601	1118084	1992-03-27	1992-03-27	1	8121
34175	2320	1125315	1954-05-01	1954-06-30	1	-5664
37527	2551	1521369	1976-07-27	1977-07-22	1	2759
30493	2063	1125315	2018-08-06	2018-08-13	1	17756
45375	3080	1177480	2015-09-27	2015-10-25	1	16733
28748	1946	1326303	2014-01-04	2014-01-04	1	16074
27503	1855	1125315	1976-12-10	1976-12-24	1	2549
34338	2329	1119510	2008-07-27	2008-08-10	1	14101
7385	510	1118084	2008-01-10	2008-01-10	1	13888
36333	2470	933724	1998-02-20	1998-02-27	1	10284
76404	5223	1112807	1970-09-06	1970-09-20	1	262
34530	2337	19127890	1980-06-26	1982-06-16	2	4549
1064	72	1713332	1952-04-20	1952-05-11	1	-6444
28417	1925	1125315	1954-02-04	1954-02-11	1	-5803
68444	4670	1125315	1978-09-12	1978-09-26	1	3190
36290	2468	1119510	1963-04-29	1963-05-06	1	-2432
36571	2487	1125315	2003-12-22	2004-01-05	1	12422
60169	4102	1305058	1997-03-14	2001-12-18	1	11674
26967	1821	1125315	2016-02-14	2016-02-21	1	16852
68647	4682	1503184	1996-08-27	1997-08-22	1	10095
31443	2127	1125315	2004-09-11	2004-09-25	1	12686
68839	4696	1729720	1953-02-02	1953-02-11	1	-6168
34631	2343	1125315	2002-11-05	2002-11-12	1	12003
73603	5034	1125315	1956-12-14	1956-12-28	1	-4752
28518	1929	1759842	1989-07-23	1989-08-06	1	7157
69973	4776	738818	1981-12-10	1981-12-24	1	4375
35386	2404	1713332	1987-11-30	1987-12-21	1	6563
73435	5023	1125315	1994-04-13	1994-05-20	1	8905
26821	1814	1125315	1964-08-21	1964-09-04	1	-1945
32740	2217	1759842	2009-11-23	2009-12-07	1	14585
68764	4690	1125315	1980-02-09	1980-02-23	1	3705
67030	4576	1125315	1955-04-25	1955-05-09	1	-5351
40068	2721	1759842	1973-01-19	1973-02-02	1	1128
33602	2283	1713332	1953-09-02	1953-09-16	1	-5951
46842	3178	1125315	2018-09-04	2018-09-18	1	17792
29376	1987	1125315	1950-03-11	1950-03-25	1	-7222
69712	4756	1125315	1991-07-18	1991-08-01	1	7882
58046	3958	1125315	2017-06-26	2017-07-10	1	17357
49151	3347	1125315	2002-08-31	2002-09-14	1	11944
39389	2679	1125315	2016-09-07	2016-09-21	1	17065
38399	2611	1115008	2016-08-27	2016-09-17	1	17061
30599	2071	1112807	1977-02-13	1977-03-15	1	2630
76595	5235	1307863	1981-12-12	1981-12-12	1	4363
24592	1658	1759842	1937-07-16	1937-08-06	1	-11836
45257	3070	1112807	1967-08-28	1967-10-27	1	-797
32464	2199	1125315	1985-06-03	1985-06-17	1	5646
40674	2764	1515774	1995-07-20	1996-07-14	1	9691
77403	5291	19127890	1991-10-05	1993-09-24	2	8667
35106	2381	1361711	1996-05-15	1996-05-15	1	9631
1204	82	1521369	1976-03-12	1977-03-07	1	2622
28628	1937	738818	1980-12-12	1980-12-26	1	4012
55074	3746	1759842	2014-09-29	2014-10-13	1	16356
52832	3601	1125315	1971-09-24	1971-10-08	1	645
34176	2320	1125315	1955-08-11	1955-08-25	1	-5243
37528	2551	1713332	1964-10-25	1964-11-08	1	-1880
30494	2063	1729720	1987-01-11	1987-01-24	1	6232
45376	3080	1713332	2009-03-01	2009-03-08	1	14311
28749	1946	1729720	1977-09-20	1977-10-01	1	2830
27504	1855	1125315	1991-12-27	1992-01-10	1	8044
34339	2329	1521369	1985-01-08	1986-01-03	1	5846
7386	510	1124957	1983-09-30	1983-09-30	1	5020
36334	2470	1125315	2000-01-11	2000-01-18	1	10974
76405	5223	1125315	1996-06-21	1996-07-26	1	9703
34531	2337	19127890	1983-06-11	1984-06-05	1	5269
1065	72	1713332	1990-11-15	1990-11-29	1	7637
28418	1925	1125315	1962-01-23	1962-02-06	1	-2886
68445	4670	1125315	1982-03-24	1982-03-31	1	4472
36291	2468	1125315	1959-01-09	1959-01-23	1	-3996
36572	2487	1125315	2007-12-27	2008-01-03	1	13881
60170	4102	1503184	1980-03-13	1981-03-08	1	4084
26968	1821	1729720	1944-07-30	1944-08-06	1	-9279
68648	4682	1515774	1995-09-02	1996-08-27	1	9735
31444	2127	1713332	1978-05-02	1978-05-23	1	3064
68840	4696	1112807	1966-01-08	1966-01-29	1	-1433
34632	2343	1759842	2006-08-05	2006-08-26	1	13386
73604	5034	1174888	1994-02-26	1994-02-26	1	8822
28519	1929	1112807	1966-08-16	1966-09-06	1	-1213
69974	4776	1118084	2001-01-17	2001-01-17	1	11339
35387	2404	1717327	1968-01-06	1968-01-20	1	-712
73436	5023	1125315	2003-02-01	2003-02-15	1	12098
26822	1814	1367571	2018-04-03	2018-04-03	1	17624
37139	2528	1118084	2007-08-03	2007-08-03	1	13728
68765	4690	1177480	1992-05-04	1992-05-25	1	8180
67031	4576	1125315	1956-03-30	1956-04-13	1	-5011
40069	2721	1759842	2015-12-25	2016-01-08	1	16808
33603	2283	1759842	1962-10-06	1962-10-27	1	-2623
46843	3178	1310149	2006-09-23	2006-09-23	1	13414
29377	1987	1717327	1964-09-10	1964-09-24	1	-1925
69713	4756	1713332	2000-10-22	2000-11-12	1	11273
58047	3958	1713332	1969-07-07	1969-07-14	1	-171
49152	3347	1125315	2005-04-29	2005-05-27	1	12930
39390	2679	1177480	2009-12-13	2010-01-03	1	14612
38400	2611	1118084	1990-06-29	1990-06-29	1	7484
30600	2071	1125315	1968-04-01	1968-04-15	1	-626
76596	5235	1361711	1925-08-22	1982-01-23	1	4405
24917	1686	1125315	1980-06-15	1980-06-29	1	3832
45258	3070	1125315	2001-09-04	2001-09-18	1	11583
32465	2199	1713332	1980-05-17	1980-05-31	1	3803
40675	2764	1515774	1997-07-09	1998-03-20	1	10305
77404	5291	19127890	1997-09-03	1998-08-29	1	10467
35107	2381	1729720	1945-05-06	1945-05-16	1	-8996
1205	82	1521369	1978-03-02	1979-02-25	1	3342
28629	1937	920293	2004-06-09	2004-06-16	1	12585
55075	3746	738818	1999-12-24	2000-01-07	1	10963
52833	3601	1125315	1992-06-26	1992-07-10	1	8226
34177	2320	1125315	1957-11-20	1957-12-04	1	-4411
37529	2551	738818	1991-01-09	1991-01-23	1	7692
30495	2063	1759842	1973-11-11	1973-11-25	1	1424
45377	3080	1759842	1959-01-27	1959-02-03	1	-3985
28750	1946	1759842	1960-01-06	1960-01-13	1	-3641
27505	1855	1125315	1995-01-24	1995-02-14	1	9175
34340	2329	1713332	2001-09-19	2001-09-26	1	11591
7387	510	1112807	1969-09-28	1969-10-12	1	-81
36335	2470	1728416	1959-09-11	1959-09-25	1	-3751
76406	5223	1125315	2019-01-11	2019-02-01	1	17928
34532	2337	1124300	2003-07-26	2003-07-26	1	12259
1066	72	1125315	1969-09-30	1969-10-30	1	-63
28419	1925	1177480	2002-12-17	2002-12-31	1	12052
68446	4670	1125315	2018-07-10	2018-07-31	1	17743
36292	2468	1125315	1979-05-19	1979-06-09	1	3446
36573	2487	1125315	2013-01-07	2013-01-14	1	15719
60171	4102	1503184	1984-02-21	1985-02-15	1	5524
26969	1821	1729720	1950-06-09	1950-06-19	1	-7136
68649	4682	1549786	1995-09-02	1996-08-27	1	9735
31445	2127	1759842	1976-08-21	1976-09-04	1	2438
68841	4696	1177480	2017-06-30	2017-07-14	1	17361
34633	2343	738818	1990-07-11	1990-07-25	1	7510
73605	5034	1713332	1936-06-28	1936-07-05	1	-12233
28520	1929	1125315	1990-12-01	1990-12-15	1	7653
69975	4776	1125315	1981-12-10	1981-12-24	1	4375
35388	2404	1729720	1979-11-07	1979-11-16	1	3606
73437	5023	1149380	1974-08-13	1974-08-13	1	1685
26823	1814	1728416	1945-07-29	1945-08-12	1	-8908
37140	2528	1119510	2011-03-28	2011-04-11	1	15075
68766	4690	1728416	1958-03-31	1958-04-14	1	-4280
67032	4576	1125315	1988-05-03	1988-05-17	1	6711
44897	3048	1118084	2008-08-24	2008-08-24	1	14115
33604	2283	757627	2017-11-13	2017-11-13	1	17483
46844	3178	1768849	1984-08-07	1984-08-21	1	5346
29378	1987	1729720	1947-11-21	1947-11-29	1	-8069
69714	4756	1729720	2006-04-02	2006-04-11	1	13249
58048	3958	1713332	1983-02-07	1983-02-21	1	4799
49153	3347	1713332	1961-11-12	1961-12-03	1	-2951
39391	2679	1124300	2013-01-05	2013-01-05	1	15710
38401	2611	1119510	1955-06-29	1955-07-13	1	-5286
30601	2071	1118084	2004-05-22	2004-05-22	1	12560
76597	5235	1713332	1961-10-08	1961-10-15	1	-3000
24918	1686	1713332	1998-09-23	1998-10-14	1	10513
45259	3070	1759842	1973-01-18	1973-01-25	1	1120
32466	2199	1759842	1982-07-11	1982-08-01	1	4595
40676	2764	1521369	1994-07-25	1995-07-20	1	9331
77405	5291	1119510	2007-09-05	2007-09-12	1	13768
35108	2381	1729720	2012-11-25	2012-12-06	1	15680
1206	82	1521369	1980-02-20	1981-02-14	1	4062
28630	1937	1112807	1968-10-14	1968-11-13	1	-414
55076	3746	1119510	1999-12-24	2000-01-07	1	10963
52834	3601	1551099	1965-01-18	1965-01-18	1	-1809
34178	2320	1713332	2004-11-02	2004-11-16	1	12738
37530	2551	920293	2000-09-17	2000-09-24	1	11224
34803	2352	740275	1970-10-26	1971-09-27	1	634
45378	3080	1112807	1966-07-13	1966-08-03	1	-1247
28751	1946	1125315	1985-07-21	1985-08-04	1	5694
27506	1855	1125315	1998-11-16	1998-11-23	1	10553
34341	2329	1729720	1978-04-23	1978-05-03	1	3044
7388	510	1125315	1979-11-19	1979-12-03	1	3623
36336	2470	1728416	1960-09-18	1960-10-02	1	-3378
76407	5223	19127890	1983-01-11	1984-01-06	1	5118
34533	2337	1125315	1978-01-28	1978-02-25	1	2977
1067	72	1125315	1985-10-04	1985-10-18	1	5769
28420	1925	1728416	1946-06-26	1946-07-10	1	-8576
68447	4670	1125315	1964-03-18	1964-03-25	1	-2108
36293	2468	1729720	1941-09-23	1941-10-05	1	-10315
36688	2497	1112807	1963-03-24	1963-04-07	1	-2461
60172	4102	1521369	1988-01-31	1989-01-25	1	6964
26970	1821	1125315	1960-08-18	1960-09-01	1	-3409
68650	4682	1768849	1981-02-07	1981-02-21	1	4069
31446	2127	933724	1978-09-29	1978-10-06	1	3200
68842	4696	1759842	1968-12-13	1968-12-27	1	-370
34634	2343	1115008	2012-11-09	2012-11-23	1	15667
73606	5034	1759842	1936-06-28	1936-07-05	1	-12233
28521	1929	1713332	1962-11-11	1962-12-02	1	-2587
69976	4776	1307863	2011-04-24	2011-04-24	1	15088
35389	2404	1759842	1987-11-30	1987-12-21	1	6563
73438	5023	1177480	2017-11-15	2017-12-13	1	17513
26824	1814	1729720	2018-02-25	2018-03-06	1	17596
37141	2528	1125315	1977-05-03	1977-05-17	1	2693
68767	4690	933724	2010-07-10	2010-07-17	1	14807
67033	4576	1521369	1976-09-11	1977-09-06	1	2805
44898	3048	1521369	1989-05-06	1992-04-20	3	8145
33605	2283	1125315	1941-01-31	1941-02-07	1	-10555
46845	3178	19059528	2014-03-14	2014-03-14	1	16143
30616	2073	1125315	1978-04-27	1978-05-18	1	3059
69715	4756	1759842	1973-06-23	1973-07-14	1	1290
58049	3958	1759842	1983-02-07	1983-02-21	1	4799
49154	3347	1759842	2001-04-20	2001-05-11	1	11453
39392	2679	1125315	1981-11-09	1981-12-14	1	4365
38402	2611	1177480	1977-12-28	1978-01-18	1	2939
30602	2071	1119510	1972-10-08	1972-10-22	1	1025
77228	5279	1119510	1955-11-27	1955-12-11	1	-5135
24919	1686	1713332	2018-02-22	2018-03-08	1	17598
45260	3070	1115008	2018-12-28	2019-01-25	1	17921
32467	2199	1112807	1980-05-17	1980-05-31	1	3803
40677	2764	1549786	1990-08-05	1991-07-31	1	7881
77406	5291	1125315	1976-07-15	1976-07-29	1	2401
35109	2381	914335	2013-01-30	2013-01-30	1	15735
1207	82	1118084	1995-12-03	1995-12-03	1	9467
28631	1937	1118084	2001-03-25	2001-03-25	1	11406
55077	3746	1125315	1999-12-24	2000-01-07	1	10963
52835	3601	1551099	1976-03-25	1976-03-25	1	2275
34179	2320	1729720	1997-01-19	1997-02-01	1	9893
37531	2551	1112807	1959-03-19	1959-04-02	1	-3927
34804	2352	1729720	2013-02-10	2013-02-18	1	15754
45379	3080	1118084	1981-09-18	1981-09-18	1	4278
28752	1946	1125315	1997-05-24	1997-05-24	1	10005
27507	1855	1177480	1979-10-10	1979-10-31	1	3590
34342	2329	1738521	1976-08-06	1976-08-20	1	2423
7389	510	1125315	1984-09-27	1984-10-11	1	5397
36337	2470	920293	1994-01-16	1994-01-23	1	8788
76408	5223	1125315	1974-05-11	1974-05-25	1	1605
34534	2337	1125315	1993-09-08	1993-09-15	1	8658
1068	72	1177480	2008-06-19	2008-07-17	1	14077
28421	1925	1759842	1981-08-11	1981-08-25	1	4254
68448	4670	1125315	1969-12-21	1970-01-04	1	3
36294	2468	1729720	1970-07-07	1970-07-15	1	195
36689	2497	1125315	1971-06-20	1971-06-27	1	542
60173	4102	1102527	1981-08-14	1981-08-14	1	4243
26971	1821	1125315	1978-07-07	1978-08-23	2	3144
68651	4682	19127890	1995-09-02	1999-08-12	4	10815
31447	2127	1115008	2005-06-28	2005-07-12	1	12976
68843	4696	1112807	1955-01-22	1955-02-05	1	-5444
34635	2343	1125315	1990-07-11	1990-07-25	1	7510
77036	5264	1119510	2016-02-22	2016-02-29	1	16860
28522	1929	1759842	1981-10-12	1981-10-26	1	4316
69977	4776	1326303	2011-04-24	2011-04-24	1	15088
35390	2404	1112807	1968-08-21	1968-11-19	1	-408
73439	5023	1154343	1974-08-13	1974-08-13	1	1685
26825	1814	1741122	2018-04-03	2018-04-03	1	17624
37142	2528	1125315	1991-10-16	1991-10-30	1	7972
68768	4690	1112807	1958-03-31	1958-04-14	1	-4280
67034	4576	1728416	1955-04-25	1955-05-09	1	-5351
44899	3048	1713332	2015-02-28	2015-05-09	1	16564
33606	2283	1125315	1986-06-21	1986-06-28	1	6022
46846	3178	1000560	2014-03-13	2014-03-14	2	16142
30617	2073	1125315	1982-04-07	1982-04-14	1	4486
69716	4756	1125315	1985-11-25	1985-12-16	1	5828
58050	3958	1778162	1993-10-25	1993-11-22	1	8726
49155	3347	933724	2005-06-11	2005-06-18	1	12952
39393	2679	1729720	1985-10-04	1985-10-13	1	5764
38403	2611	1759842	1987-06-25	1987-07-16	1	6405
30603	2071	1125315	1976-12-08	1976-12-15	1	2540
77229	5279	1713332	1975-01-19	1975-01-26	1	1851
24920	1686	1729720	1991-10-23	1991-11-01	1	7974
45261	3070	1125315	2011-10-07	2011-10-14	1	15261
32468	2199	1118084	2016-10-30	2016-10-30	1	17104
40678	2764	1521369	1987-08-21	1988-08-15	1	6801
77407	5291	1125315	1992-09-09	1992-09-16	1	8294
35110	2381	1112807	1939-05-02	1939-05-16	1	-11188
1208	82	1125315	2004-04-05	2004-04-19	1	12527
28632	1937	1119510	2015-04-06	2015-04-13	1	16538
55078	3746	1125315	1945-01-04	1945-01-18	1	-9114
52836	3601	1713332	1998-07-24	1998-07-31	1	10438
34180	2320	1118084	1980-01-15	1980-01-15	1	3666
37532	2551	1125315	1991-01-09	1991-01-23	1	7692
34805	2352	1118084	2012-08-01	2012-08-01	1	15553
45380	3080	1713332	1959-01-27	1959-02-03	1	-3985
28753	1946	1174888	1997-05-24	1997-05-24	1	10005
27508	1855	705944	1989-03-17	1989-09-22	1	7204
34343	2329	1759842	2001-09-19	2001-09-26	1	11591
7390	510	738818	2006-08-03	2006-08-17	1	13377
36338	2470	1112807	1959-09-11	1959-09-25	1	-3751
76409	5223	1125315	1978-02-08	1978-02-22	1	2974
34535	2337	1125315	2001-12-26	2002-01-16	1	11703
1069	72	1759842	1990-11-15	1990-11-29	1	7637
28422	1925	1759842	1998-12-05	1998-12-19	1	10579
68603	4680	1112807	1910-06-11	1910-06-25	1	-21740
36295	2468	1759842	2003-09-09	2003-09-30	1	12325
36690	2497	1125315	1983-09-24	1983-10-08	1	5028
60174	4102	1115008	1997-03-14	2001-12-18	2	11674
26972	1821	1310149	1986-08-03	1986-08-03	1	6058
70499	4816	1119510	1994-03-08	1994-03-22	1	8846
31448	2127	1125315	1970-07-23	1970-08-06	1	217
68844	4696	1112807	1953-03-03	1953-03-17	1	-6134
34636	2343	1347450	2016-05-21	2016-05-21	1	16942
77037	5264	1125315	1968-08-26	1968-09-09	1	-479
31496	2131	1115008	2003-06-10	2003-07-01	1	12234
69978	4776	1717327	1964-12-22	1965-01-05	1	-1822
35391	2404	1125315	1986-11-11	1986-12-11	1	6188
73440	5023	1102527	1994-04-20	1994-04-20	1	8875
26826	1814	1759842	2000-10-11	2000-11-01	1	11262
37143	2528	1729720	1978-09-04	1978-09-12	1	3176
68769	4690	1112807	1959-02-24	1959-04-25	1	-3904
67035	4576	1112807	1957-08-12	1957-09-09	1	-4497
44900	3048	1759842	2015-02-28	2015-05-09	1	16564
33607	2283	1322184	2018-11-19	2018-11-19	1	17854
46847	3178	1110410	2014-03-13	2014-03-14	1	16143
30618	2073	1768849	1987-06-21	1987-07-05	1	6394
69717	4756	1125315	2003-05-26	2003-06-09	1	12212
60724	4142	1115008	2015-10-19	2015-11-09	1	16748
49156	3347	1102527	1993-10-29	1993-10-29	1	8702
39983	2715	1361711	1979-04-26	2017-11-23	1	17493
38404	2611	1729720	2002-03-15	2002-03-28	1	11774
30604	2071	1503184	1980-06-07	1981-06-02	1	4170
77230	5279	1729720	1949-12-09	1949-12-22	1	-7315
24921	1686	1759842	1998-09-23	1998-10-14	1	10513
45262	3070	1503184	1984-08-31	1986-08-21	2	6076
32469	2199	1125315	1981-05-13	1981-05-27	1	4164
40679	2764	1759842	1988-12-10	1988-12-17	1	6925
77408	5291	1177480	2008-03-29	2008-04-12	1	13981
35111	2381	1119510	1997-11-25	1997-12-09	1	10204
1209	82	1503184	1978-03-02	1979-02-25	1	3342
28633	1937	1125315	1980-12-12	1980-12-26	1	4012
55079	3746	1125315	1985-04-14	1985-04-28	1	5596
52837	3601	1759842	1967-05-13	1967-06-03	1	-943
34181	2320	1125315	1947-11-01	1947-11-15	1	-8083
37533	2551	1125315	2008-02-08	2008-02-22	1	13931
34806	2352	1125315	1977-03-23	1977-04-22	1	2668
45381	3080	1713332	1988-11-02	1988-12-28	1	6936
28754	1946	1713332	1960-01-06	1960-01-13	1	-3641
27509	1855	1149380	1977-03-27	1977-03-27	1	2642
34344	2329	738818	2008-07-27	2008-08-10	1	14101
7391	510	1112807	1984-12-23	1985-01-20	1	5498
36339	2470	1112807	1968-04-17	1968-05-15	1	-596
76410	5223	1125315	2005-10-07	2005-10-21	1	13077
34536	2337	1322184	2002-10-01	2002-10-01	1	11961
1070	72	1125315	1985-05-26	1985-06-02	1	5631
28423	1925	933724	2000-02-05	2000-02-12	1	10999
68604	4680	1112807	1910-11-22	1910-12-06	1	-21576
36296	2468	738818	1963-04-29	1963-05-06	1	-2432
36691	2497	1717327	1967-08-17	1967-08-31	1	-854
60175	4102	1125315	1977-11-12	1977-12-03	1	2893
26973	1821	1326303	1986-08-03	1986-08-03	1	6058
70500	4816	1125315	1984-10-11	1984-10-25	1	5411
31449	2127	1521369	1975-08-26	1976-08-20	1	2423
68845	4696	1124300	1985-12-25	1985-12-25	1	5837
34637	2343	1729720	1965-03-30	1965-04-10	1	-1727
77038	5264	1125315	1980-04-26	1980-05-03	1	3775
31497	2131	1119510	1958-07-17	1958-07-24	1	-4179
72972	4987	738818	2004-06-29	2004-07-13	1	12612
35392	2404	1125315	1998-08-10	1998-08-31	1	10469
73441	5023	1125315	1972-10-05	1972-10-19	1	1022
26827	1814	782043	2018-04-03	2018-04-03	1	17624
37144	2528	1112807	1974-09-15	1974-10-15	1	1748
68770	4690	1119510	1978-10-14	1978-10-28	1	3222
67036	4576	1125315	1962-02-15	1962-04-16	1	-2817
44901	3048	1503184	1989-05-06	1992-04-20	3	8145
33608	2283	1332418	2018-11-19	2018-11-19	1	17854
46848	3178	1118084	1994-07-30	1994-07-30	1	8976
30619	2073	1347450	2012-04-13	2012-04-13	1	15443
69718	4756	1713332	1973-06-23	1973-07-14	1	1290
60725	4142	1177480	2013-12-14	2013-12-28	1	16067
49157	3347	1118084	1992-06-19	1992-06-19	1	8205
39984	2715	1332418	1994-06-09	1994-06-09	1	8925
43902	2966	1112807	1963-10-02	1963-10-16	1	-2269
30605	2071	1521369	1980-06-07	1981-06-02	1	4170
77231	5279	738818	1974-04-14	1974-04-28	1	1578
24922	1686	1759842	2018-02-22	2018-03-08	1	17598
45263	3070	1713332	1969-08-16	1969-08-30	1	-124
32470	2199	1713332	1998-12-14	1998-12-28	1	10588
40680	2764	19127890	1990-08-05	1991-07-31	1	7881
77409	5291	1549786	1997-09-03	1998-08-29	1	10467
35112	2381	1125315	1961-06-10	1961-07-08	1	-3099
1210	82	1503184	1980-02-20	1981-02-14	1	4062
28634	1937	1174888	1977-07-20	1977-07-20	1	2757
55080	3746	1557272	2014-06-12	2014-06-12	1	16233
52838	3601	19127890	1976-05-30	1977-05-25	1	2701
34182	2320	1112807	1947-05-03	1947-05-17	1	-8265
37534	2551	1177480	1990-07-04	1990-07-25	1	7510
34807	2352	1125315	2000-01-24	2000-02-07	1	10994
45382	3080	1759842	1988-11-02	1988-12-28	1	6936
28755	1946	1729720	1936-09-13	1936-09-25	1	-12151
27510	1855	1125315	2004-03-22	2004-04-05	1	12513
34345	2329	1112807	1973-12-27	1974-01-10	1	1470
7392	510	1125315	1967-06-08	1967-06-22	1	-924
36340	2470	1115008	2015-08-07	2015-08-28	1	16675
76411	5223	1738521	1971-10-28	1971-11-11	1	679
34537	2337	1503184	1980-06-26	1982-06-16	2	4549
1071	72	1713332	2005-06-20	2005-07-11	1	12975
28424	1925	1112807	1946-06-26	1946-07-10	1	-8576
68605	4680	1112807	1928-09-25	1928-12-24	1	-14983
36297	2468	1112807	1943-05-14	1943-05-28	1	-9715
36692	2497	1118084	2006-06-06	2006-06-06	1	13305
60176	4102	19127890	1988-01-31	1989-01-25	1	6964
26974	1821	1713332	1964-01-13	1964-01-27	1	-2166
70501	4816	1177480	1983-06-02	1983-06-16	1	4914
31450	2127	1713332	1995-08-29	1995-09-19	1	9392
68846	4696	1125315	1954-12-24	1954-12-31	1	-5480
36829	2507	1115008	1996-11-16	1997-01-15	1	9876
77039	5264	1125315	1977-09-08	1977-12-07	1	2897
31498	2131	1125315	1962-06-19	1962-07-10	1	-2732
72973	4987	933724	2014-10-25	2014-11-01	1	16375
35393	2404	1322184	1997-07-13	1997-07-13	1	10055
73442	5023	1125315	1994-09-12	1994-09-26	1	9034
26828	1814	1102527	1953-07-11	1953-07-11	1	-6018
37145	2528	1115008	2018-11-23	2018-12-07	1	17872
68771	4690	1124300	2001-03-20	2001-03-20	1	11401
67037	4576	1125315	1983-06-02	1983-06-16	1	4914
44902	3048	19127890	1989-05-06	1992-04-20	3	8145
33609	2283	1713332	1962-10-06	1962-10-27	1	-2623
46849	3178	1125315	1956-12-11	1956-12-25	1	-4755
30620	2073	1713332	1969-05-13	1969-05-20	1	-226
70763	4834	933724	2016-06-14	2016-06-21	1	16973
60726	4142	1713332	2009-06-06	2009-06-13	1	14408
49158	3347	1125315	1982-02-18	1982-02-25	1	4438
39985	2715	1539403	1991-06-06	1991-06-06	1	7826
43903	2966	1125315	2002-06-12	2002-07-17	1	11885
30606	2071	1115008	2005-12-13	2006-01-03	1	13151
77232	5279	920293	1990-02-26	1990-03-05	1	7368
24923	1686	1112807	1964-08-30	1964-09-13	1	-1936
45264	3070	1738521	1967-12-19	1968-01-02	1	-730
32471	2199	1713332	2018-05-08	2018-05-22	1	17673
40681	2764	1112807	1977-12-01	1977-12-15	1	2905
77410	5291	1713332	1981-03-06	1981-03-20	1	4096
35113	2381	1115008	2003-08-16	2003-08-30	1	12294
1211	82	723013	1973-03-18	1973-11-18	1	1417
31183	2109	1112807	1971-02-16	1971-03-02	1	425
55081	3746	1713332	2014-09-29	2014-10-13	1	16356
52839	3601	738818	1984-10-01	1984-10-15	1	5401
34183	2320	1125315	1976-08-03	1976-08-17	1	2420
37535	2551	1729720	1970-06-22	1970-07-02	1	182
34808	2352	1149380	1972-11-01	1972-11-01	1	1035
45383	3080	1112807	1944-08-23	1944-09-06	1	-9248
29975	2028	723013	1980-02-06	1980-07-23	1	3856
27511	1855	1154343	1977-03-27	1977-03-27	1	2642
34346	2329	1112807	1976-12-11	1976-12-25	1	2550
7393	510	1125315	1983-09-30	1983-09-30	1	5020
36341	2470	1125315	1962-09-25	1962-10-16	1	-2634
76412	5223	1125315	1970-12-30	1971-01-13	1	377
34538	2337	1503184	1983-06-11	1984-06-05	1	5269
1072	72	1759842	2005-06-20	2005-07-11	1	12975
28425	1925	1112807	1949-07-28	1949-08-27	1	-7432
68606	4680	1112807	1967-07-31	1967-08-14	1	-871
36298	2468	1125315	1939-12-03	1939-12-10	1	-10980
36693	2497	1125315	1990-04-22	1990-05-13	1	7437
60177	4102	1112807	1972-02-14	1972-03-06	1	795
26975	1821	1729720	1971-08-17	1971-08-29	1	605
70502	4816	1515774	1997-10-26	1998-10-21	1	10520
31451	2127	1717327	1962-11-22	1962-12-06	1	-2583
68847	4696	1125315	1958-12-31	1959-01-14	1	-4005
36830	2507	1125315	1996-11-16	1996-11-16	1	9816
77040	5264	1177480	1978-11-02	1978-11-30	1	3255
31499	2131	1118084	1986-12-04	1986-12-04	1	6181
72974	4987	1115008	2002-03-15	2002-04-12	1	11789
35394	2404	1728416	1966-05-04	1966-05-18	1	-1324
73443	5023	1728416	1972-10-05	1972-10-19	1	1022
26829	1814	1112807	1945-07-29	1945-08-12	1	-8908
37146	2528	1713332	1979-05-06	1979-05-27	1	3433
68772	4690	1125315	1993-05-20	1993-06-03	1	8554
67038	4576	1503184	1976-09-11	1977-09-06	1	2805
46149	3134	1119510	1974-03-22	1974-04-05	1	1555
33610	2283	1728416	1951-04-22	1951-05-06	1	-6815
46850	3178	1125315	2014-03-14	2014-03-14	1	16143
30621	2073	1759842	1966-12-03	1966-12-17	1	-1111
70764	4834	1112807	1969-02-27	1969-04-03	1	-273
60727	4142	1759842	2009-06-06	2009-06-13	1	14408
49159	3347	1713332	2007-03-20	2007-04-10	1	13613
39986	2715	1124300	1999-05-25	1999-05-25	1	10736
43904	2966	1125315	2016-11-23	2016-12-07	1	17142
30607	2071	1125315	1973-03-06	1973-05-05	1	1220
77233	5279	933724	1990-02-26	1990-03-05	1	7368
24924	1686	1112807	1978-03-20	1978-04-24	1	3035
45265	3070	1521369	1984-08-31	1986-08-21	2	6076
32472	2199	1759842	1998-12-14	1998-12-28	1	10588
40682	2764	1503184	1994-07-25	1995-07-20	1	9331
77411	5291	1729720	2000-09-09	2000-09-22	1	11222
35114	2381	1125315	2003-10-29	2003-11-12	1	12368
1212	82	933724	2006-04-24	2006-05-01	1	13269
31184	2109	1112807	1979-02-04	1979-02-25	1	3342
55082	3746	705944	1956-12-05	1961-12-14	1	-2940
52840	3601	1125315	1976-11-21	1976-12-26	1	2551
34184	2320	1713332	1946-02-16	1946-03-09	1	-8699
37536	2551	1125315	2014-12-22	2015-01-05	1	16440
34809	2352	1729720	2018-08-02	2018-08-13	1	17756
45384	3080	1112807	1946-06-09	1946-06-23	1	-8593
29976	2028	1119510	2007-01-12	2007-01-19	1	13532
32147	2175	920293	1992-03-06	1992-03-13	1	8107
34347	2329	1125315	2008-07-27	2008-08-10	1	14101
7394	510	1125315	2006-08-03	2006-08-17	1	13377
36342	2470	1125315	2007-02-26	2007-03-12	1	13584
76413	5223	1125315	1971-10-28	1971-11-11	1	679
34539	2337	1729720	1998-12-05	1998-12-17	1	10577
2492	164	1125315	1979-11-22	1979-11-29	1	3619
28426	1925	1118084	1984-01-31	1984-01-31	1	5143
68607	4680	1112807	1985-06-24	1985-08-23	1	5713
36299	2468	1125315	1985-01-08	1985-02-05	1	5514
36694	2497	1307863	2017-08-17	2017-08-17	1	17395
60178	4102	1112807	1981-08-14	1981-11-12	1	4333
30071	2033	1119510	2004-10-17	2004-10-31	1	12722
70503	4816	1759842	2019-03-29	2019-04-12	1	17998
31452	2127	1759842	1995-08-29	1995-09-19	1	9392
68848	4696	1125315	1989-08-12	1989-08-26	1	7177
36831	2507	1503184	1983-04-18	1985-04-07	2	5575
77041	5264	1759842	2010-07-12	2010-08-02	1	14823
31500	2131	1119510	1959-06-20	1959-06-27	1	-3841
72975	4987	1125315	2007-01-30	2007-02-06	1	13550
40274	2740	1118084	2010-04-19	2010-04-19	1	14718
74509	5097	738818	1983-05-05	1983-05-19	1	4886
26830	1814	1125315	2000-05-05	2000-06-02	1	11110
37147	2528	1713332	1992-06-06	1992-06-13	1	8199
68773	4690	1125315	2007-05-05	2007-05-26	1	13659
67039	4576	19127890	1983-08-06	1984-07-31	1	5325
46150	3134	1125315	1977-08-22	1977-08-29	1	2797
33611	2283	1759842	1953-09-02	1953-09-16	1	-5951
46851	3178	1367571	2014-03-13	2014-03-13	1	16142
30622	2073	1119510	2007-11-18	2007-11-25	1	13842
70765	4834	1115008	2001-06-05	2001-07-10	1	11513
60728	4142	1125315	1998-12-12	1999-01-02	1	10593
49160	3347	1759842	1961-11-12	1961-12-03	1	-2951
39987	2715	1125315	1970-07-21	1970-08-25	1	236
43905	2966	1118084	2001-02-19	2001-02-19	1	11372
30608	2071	1125315	1989-01-19	1989-01-26	1	6965
77234	5279	1118084	1985-01-02	1985-01-02	1	5480
24925	1686	1118084	1999-04-29	1999-04-29	1	10710
45266	3070	1759842	1969-08-16	1969-08-30	1	-124
32473	2199	1759842	2018-05-08	2018-05-22	1	17673
40683	2764	1549786	1995-07-20	1996-07-14	1	9691
77412	5291	19127890	1989-10-15	1990-10-10	1	7587
35115	2381	1309944	2013-01-30	2013-01-30	1	15735
1213	82	1503184	1976-03-12	1977-03-07	1	2622
31185	2109	1759842	1996-09-12	1996-10-03	1	9772
55083	3746	1112807	1947-10-19	1947-11-09	1	-8089
52841	3601	1125315	1979-01-15	1979-02-05	1	3322
34185	2320	1713332	1962-08-10	1962-08-24	1	-2687
37537	2551	1125315	2017-03-04	2017-03-18	1	17243
34810	2352	1713332	2001-02-22	2001-03-08	1	11389
45385	3080	1115008	2007-04-12	2007-04-26	1	13629
29977	2028	1119510	2016-09-24	2016-10-01	1	17075
32148	2175	933724	1992-03-06	1992-03-13	1	8107
35821	2435	1503184	1992-10-12	1993-10-07	1	8680
7395	510	1125315	2012-07-27	2012-08-03	1	15555
36343	2470	1124300	1992-12-21	1992-12-21	1	8390
76414	5223	1125315	1997-08-01	1997-08-08	1	10081
36872	2509	920293	2006-07-08	2006-07-15	1	13344
2493	164	1729720	1966-06-05	1966-06-15	1	-1296
28427	1925	1125315	1960-05-01	1960-05-31	1	-3502
68608	4680	1124957	1979-10-24	1979-10-24	1	3583
36300	2468	1125315	2003-01-10	2003-01-17	1	12069
36695	2497	1713332	1983-11-28	1983-12-12	1	5093
60179	4102	1125315	1974-08-11	1974-08-25	1	1697
30072	2033	1125315	1980-08-03	1980-08-17	1	3881
70504	4816	1125315	1997-03-09	1997-06-07	1	10019
32659	2211	705944	1985-06-16	1986-10-19	1	6135
68849	4696	1125315	2017-12-20	2018-01-03	1	17534
36832	2507	1738521	1973-01-19	1973-02-02	1	1128
77042	5264	1118084	2004-07-13	2004-07-13	1	12612
31501	2131	1125315	2014-09-07	2014-09-14	1	16327
72976	4987	1713332	2018-10-17	2018-11-07	1	17842
40275	2740	1119510	1975-11-05	1975-11-12	1	2141
74510	5097	975125	1992-07-02	1992-07-02	1	8218
26831	1814	1154029	2018-04-03	2018-04-03	1	17624
37148	2528	1778162	1991-10-16	1991-10-30	1	7972
68774	4690	1125315	2013-09-08	2013-09-15	1	15963
67040	4576	1124300	1993-03-31	1993-03-31	1	8490
46151	3134	1177480	1988-12-07	1989-03-07	1	7005
33612	2283	715997	2019-05-07	2019-05-07	1	18023
46852	3178	1728416	1956-12-11	1956-12-25	1	-4755
30623	2073	1125315	1979-05-13	1979-06-12	1	3449
70766	4834	1503184	1974-05-12	1975-05-07	1	1952
60729	4142	1713332	1999-04-16	1999-04-23	1	10704
49161	3347	1759842	2007-03-20	2007-04-10	1	13613
39988	2715	1125315	1982-05-15	1982-07-14	1	4577
43906	2966	1539403	2013-11-23	2013-11-23	1	16032
30609	2071	1125315	1993-04-22	1993-04-29	1	8519
77235	5279	1125315	1955-11-27	1955-12-11	1	-5135
24926	1686	1759842	1998-05-03	1998-07-19	1	10426
47903	3250	1759842	1977-12-19	1977-12-26	1	2916
32474	2199	1768849	1985-06-03	1985-06-17	1	5646
40684	2764	1713332	1988-12-10	1988-12-17	1	6925
77413	5291	738818	2007-09-05	2007-09-12	1	13768
35116	2381	1332418	1996-05-15	1996-05-15	1	9631
1214	82	19127890	1976-03-12	1977-03-07	1	2622
31186	2109	1125315	1973-10-18	1973-11-01	1	1400
55084	3746	1118084	1987-02-11	1987-02-11	1	6250
52842	3601	1125315	1984-10-01	1984-10-15	1	5401
34186	2320	740275	1942-01-10	1942-05-23	1	-10085
37538	2551	19127890	1974-08-07	1975-08-02	1	2039
34811	2352	1759842	2001-02-22	2001-03-08	1	11389
45386	3080	1115008	2014-10-02	2014-12-01	1	16405
29978	2028	1125315	1980-01-18	1980-02-01	1	3683
32149	2175	1112807	1977-09-20	1977-10-04	1	2833
35822	2435	1549786	1993-10-07	1994-10-02	1	9040
7396	510	1728416	1967-06-08	1967-06-22	1	-924
36344	2470	1125315	1960-09-18	1960-10-02	1	-3378
76415	5223	1521369	1983-01-11	1984-01-06	1	5118
36873	2509	1119510	1979-04-27	1979-05-11	1	3417
2494	164	738818	1986-07-27	1986-08-10	1	6065
28428	1925	1728416	1945-06-19	1945-07-03	1	-8948
68609	4680	1125315	1987-05-15	1987-07-14	1	6403
36301	2468	1125315	2016-10-07	2016-10-21	1	17095
36696	2497	1713332	2011-04-27	2011-05-11	1	15105
60180	4102	19127890	1980-03-13	1981-03-08	1	4084
30073	2033	1125315	2004-10-17	2004-10-31	1	12722
70505	4816	19127890	1997-10-26	1998-10-21	1	10520
32660	2211	1125315	2001-08-16	2001-08-23	1	11557
70109	4788	1125315	1976-07-20	1976-08-03	1	2406
36833	2507	1115008	2017-07-20	2017-08-03	1	17381
77043	5264	1713332	2010-07-12	2010-08-02	1	14823
31502	2131	738818	1959-06-20	1959-06-27	1	-3841
72977	4987	1729720	1960-12-31	1961-01-07	1	-3281
40276	2740	1521369	1984-11-26	1986-11-16	2	6163
74511	5097	1125315	1969-11-24	1969-12-08	1	-24
26832	1814	19003953	2018-04-03	2018-04-03	1	17624
37149	2528	738818	2011-03-28	2011-04-11	1	15075
68775	4690	1729720	2008-05-03	2008-05-12	1	14011
67041	4576	1125315	1955-10-23	1955-10-30	1	-5177
46152	3134	1347450	2015-04-16	2015-04-16	1	16541
33613	2283	1115008	2017-09-07	2017-10-07	1	17446
46853	3178	1746114	2014-03-14	2014-03-14	1	16143
30624	2073	1729720	2015-07-08	2015-07-17	1	16633
70767	4834	1717327	1962-06-21	1962-07-05	1	-2737
60730	4142	1759842	1993-02-17	1993-03-10	1	8469
49162	3347	920293	2005-06-11	2005-06-18	1	12952
39989	2715	1125315	2017-11-23	2017-11-23	1	17493
43907	2966	1713332	2007-10-24	2007-11-07	1	13824
31680	2145	1118084	1999-09-28	1999-09-28	1	10862
77236	5279	1125315	1965-11-19	1965-11-26	1	-1497
24927	1686	1713332	1998-05-03	1998-07-19	1	10426
47904	3250	1759842	2001-12-01	2001-12-08	1	11664
33470	2273	1118084	2016-05-03	2016-05-03	1	16924
40685	2764	19127890	1987-08-21	1988-08-15	1	6801
77414	5291	1125315	1996-08-01	1996-08-15	1	9723
35117	2381	1343916	2013-01-30	2013-01-30	1	15735
1215	82	19127890	1978-03-02	1979-02-25	1	3342
31187	2109	1713332	1975-07-15	1975-08-05	1	2042
55085	3746	1713332	2005-10-17	2005-11-07	1	13094
52843	3601	1125315	2011-08-26	2011-09-09	1	15226
34187	2320	1115008	2017-12-10	2017-12-31	1	17531
37539	2551	19127890	1976-07-27	1977-07-22	1	2759
34812	2352	1129625	1974-11-15	1974-11-15	1	1779
45387	3080	1125315	1980-11-29	1980-12-06	1	3992
29979	2028	1125315	2007-01-12	2007-01-19	1	13532
32150	2175	1125315	1981-01-02	1981-03-03	1	4079
35823	2435	1729720	1979-07-17	1979-07-24	1	3491
7397	510	1759842	1975-06-17	1975-07-08	1	2014
36345	2470	933724	1994-01-16	1994-01-23	1	8788
76416	5223	1728416	1970-12-30	1971-01-13	1	377
36874	2509	1125315	1972-06-24	1972-07-01	1	912
2495	164	1112807	1967-12-24	1968-01-07	1	-725
28429	1925	920293	2000-02-05	2000-02-12	1	10999
68610	4680	1125315	1988-08-07	1988-08-28	1	6814
36302	2468	1713332	1952-12-27	1953-01-17	1	-6193
36697	2497	1759842	1983-11-28	1983-12-12	1	5093
60181	4102	19127890	1984-02-21	1985-02-15	1	5524
30074	2033	738818	1978-05-08	1978-05-15	1	3056
70506	4816	738818	1994-03-08	1994-03-22	1	8846
32661	2211	1125315	1997-02-03	1997-03-05	1	9925
70110	4788	1729720	1978-09-10	1978-09-20	1	3184
36834	2507	1118084	2006-05-12	2006-05-12	1	13280
77044	5264	1738521	1968-08-26	1968-09-09	1	-479
31503	2131	1112807	1956-06-29	1956-07-20	1	-4913
72978	4987	1119510	2004-06-29	2004-07-13	1	12612
40277	2740	1503184	1984-11-26	1986-11-16	2	6163
74512	5097	1125315	1983-05-05	1983-05-19	1	4886
26833	1814	1112807	1945-02-07	1945-02-21	1	-9080
37150	2528	1125315	2010-07-30	2010-08-13	1	14834
74701	5111	1125315	1960-06-17	1960-07-01	1	-3471
67042	4576	1125315	1955-12-03	1955-12-17	1	-5129
46153	3134	1713332	1969-01-15	1969-01-22	1	-344
33614	2283	1125315	1960-01-15	1960-01-29	1	-3625
49362	3363	1112807	1964-05-27	1964-06-17	1	-2024
30625	2073	738818	2007-11-18	2007-11-25	1	13842
70768	4834	1717327	1964-10-10	1964-10-24	1	-1895
60731	4142	1119510	2003-08-28	2003-09-11	1	12306
49163	3347	1125315	1990-10-17	1990-11-07	1	7615
39990	2715	1729720	1974-10-01	1974-10-11	1	1744
43908	2966	1759842	2007-10-24	2007-11-07	1	13824
31681	2145	1125315	1969-02-22	1969-03-08	1	-299
77237	5279	1125315	1969-02-09	1969-03-02	1	-305
24928	1686	1729720	1969-03-11	1969-03-21	1	-286
47905	3250	1115008	2009-08-04	2009-08-18	1	14474
33471	2273	1125315	1994-05-24	1994-06-21	1	8937
40686	2764	19127890	1994-07-25	1996-07-14	2	9691
77415	5291	1125315	2007-09-05	2007-09-12	1	13768
35118	2381	1539403	1996-05-15	1996-05-15	1	9631
1216	82	19127890	1980-02-20	1981-02-14	1	4062
31188	2109	1728416	1973-10-18	1973-11-01	1	1400
55086	3746	1759842	2005-10-17	2005-11-07	1	13094
52844	3601	1125315	2011-12-28	2012-02-01	1	15371
34188	2320	1119510	1947-11-01	1947-11-15	1	-8083
37540	2551	933724	2000-12-04	2000-12-11	1	11302
34813	2352	1154343	1972-11-01	1972-11-01	1	1035
45388	3080	1759842	2009-03-01	2009-03-08	1	14311
29980	2028	1125315	2015-12-03	2015-12-31	1	16800
32151	2175	1125315	1992-02-06	1992-02-13	1	8078
35824	2435	1738521	1974-08-02	1974-08-16	1	1688
7398	510	705944	1975-09-30	1983-10-08	1	5028
36346	2470	1125315	2014-01-20	2014-01-27	1	16097
76417	5223	1729720	1972-06-08	1972-06-17	1	898
36875	2509	1125315	1974-07-12	1974-07-26	1	1667
2496	164	1115008	2000-10-31	2000-11-28	1	11289
28430	1925	1112807	1947-06-26	1947-07-10	1	-8211
68611	4680	1177480	1976-01-29	1976-02-12	1	2233
36303	2468	1713332	2003-09-09	2003-09-30	1	12325
36698	2497	1759842	2011-04-27	2011-05-11	1	15105
61639	4208	757627	2008-04-08	2008-04-08	1	13977
30075	2033	738818	2004-10-17	2004-10-31	1	12722
70507	4816	1102527	1999-03-29	1999-03-29	1	10679
32662	2211	1118084	2007-01-27	2007-01-27	1	13540
70111	4788	1738521	1977-08-27	1977-09-10	1	2809
36835	2507	1177480	2010-12-03	2010-12-24	1	14967
77045	5264	738818	2016-02-22	2016-02-29	1	16860
31504	2131	1125315	1955-12-03	1955-12-10	1	-5136
72979	4987	1125315	2004-06-29	2004-07-13	1	12612
40278	2740	1549786	1990-10-26	1991-10-21	1	7963
74513	5097	1717327	1972-09-18	1972-10-02	1	1005
26834	1814	753626	2018-04-03	2018-04-03	1	17624
37151	2528	1125315	2011-03-28	2011-04-11	1	15075
74702	5111	1729720	1949-04-09	1949-04-17	1	-7564
67043	4576	1125315	1963-04-02	1963-04-09	1	-2459
46154	3134	1713332	1973-03-11	1973-04-01	1	1186
33615	2283	1125315	1988-04-30	1988-05-21	1	6715
49363	3363	1125315	1956-05-04	1956-06-08	1	-4955
30626	2073	1124300	2003-12-22	2003-12-22	1	12408
70769	4834	920293	2016-06-14	2016-06-21	1	16973
60732	4142	1125315	2000-07-05	2000-07-12	1	11150
49164	3347	1713332	2001-04-20	2001-05-11	1	11453
39991	2715	1112807	1971-08-20	1971-09-10	1	617
43909	2966	1322184	2013-11-23	2013-11-23	1	16032
31682	2145	1125315	1978-07-27	1978-08-03	1	3136
77238	5279	1125315	1974-04-14	1974-04-28	1	1578
24929	1686	1125315	1976-11-27	1976-12-04	1	2529
47906	3250	1115008	2017-04-24	2017-05-22	1	17308
33472	2273	1713332	1997-05-28	1997-07-02	1	10044
40687	2764	19127890	1997-07-09	1998-03-20	1	10305
77416	5291	1521369	1991-10-05	1992-09-29	1	8307
35119	2381	1729720	1945-12-16	1945-12-25	1	-8773
1217	82	920293	2006-04-24	2006-05-01	1	13269
31189	2109	1125315	1985-06-23	1985-07-07	1	5666
55768	3796	1115008	2003-08-26	2003-11-24	1	12380
52845	3601	1129625	1964-07-08	1964-07-08	1	-2003
34189	2320	1125315	2001-08-23	2001-08-30	1	11564
37541	2551	1118084	1998-06-27	1998-06-27	1	10404
37088	2524	1112807	1951-09-20	1951-10-04	1	-6664
45389	3080	1115008	2018-10-09	2018-10-30	1	17834
29981	2028	1713332	2004-08-03	2004-08-24	1	12654
32152	2175	1153428	2009-02-17	2009-02-17	1	14292
35825	2435	1125315	1974-08-02	1974-08-16	1	1688
7399	510	1119510	2006-08-03	2006-08-17	1	13377
42624	2889	1115008	2007-06-12	2007-07-17	1	13711
76418	5223	1738521	1970-09-06	1970-09-20	1	262
36876	2509	1521369	1987-05-15	1989-05-04	2	7063
2497	164	1124300	2009-02-11	2009-02-11	1	14286
28431	1925	1713332	1953-07-06	1953-07-27	1	-6002
68612	4680	1322184	2000-01-01	2000-01-01	1	10957
36304	2468	1112807	1946-05-12	1946-06-11	1	-8605
36699	2497	1115008	2004-06-28	2004-09-26	1	12687
61640	4208	1119510	1943-10-15	1943-10-29	1	-9561
30076	2033	1112807	1956-04-25	1956-07-24	1	-4909
70508	4816	1125315	1990-05-26	1990-06-09	1	7464
32663	2211	1125315	1973-04-10	1973-06-09	1	1255
70112	4788	1118084	2014-01-02	2014-01-02	1	16072
36836	2507	1503184	1981-04-28	1982-04-23	1	4495
77046	5264	1125315	2016-02-22	2016-02-29	1	16860
31505	2131	1125315	1956-06-09	1956-06-23	1	-4940
72980	4987	920293	2014-10-25	2014-11-01	1	16375
40279	2740	1713332	2000-07-14	2000-08-04	1	11173
74514	5097	1738521	1968-01-22	1968-02-05	1	-696
26835	1814	975125	1971-04-23	1971-04-23	1	477
37152	2528	1713332	1977-04-01	1977-04-08	1	2654
74703	5111	1174888	1984-12-03	1984-12-03	1	5450
67044	4576	1125315	1981-11-02	1981-11-16	1	4337
46155	3134	1713332	1978-04-11	1978-05-02	1	3043
33616	2283	1539403	2018-11-19	2018-11-19	1	17854
49364	3363	1729720	1965-08-02	1965-08-15	1	-1600
30627	2073	1125315	1973-11-19	1973-12-03	1	1432
70770	4834	1118084	2003-04-25	2003-04-25	1	12167
60733	4142	1713332	1993-02-17	1993-03-10	1	8469
52639	3583	1115008	2003-02-10	2003-03-17	1	12128
39992	2715	1125315	1966-06-14	1966-06-28	1	-1283
43910	2966	1332418	2013-11-23	2013-11-23	1	16032
31683	2145	1125315	1989-09-05	1989-09-19	1	7201
77239	5279	1125315	1988-05-15	1988-05-22	1	6716
26001	1760	738818	2015-01-02	2015-01-16	1	16451
47907	3250	1118084	2002-08-16	2002-08-16	1	11915
33473	2273	1713332	2010-08-03	2010-08-17	1	14838
40688	2764	1125315	1977-04-07	1977-04-21	1	2667
77417	5291	1738521	1976-07-15	1976-07-29	1	2401
37778	2567	738818	1986-10-24	1986-10-31	1	6147
1218	82	1125315	1973-09-14	1973-11-13	1	1412
31190	2109	1713332	1996-09-12	1996-10-03	1	9772
55769	3796	1125315	1973-09-14	1973-09-28	1	1366
52846	3601	1149380	1962-06-25	1962-06-25	1	-2747
34190	2320	1125315	2015-06-19	2015-07-03	1	16619
37542	2551	1125315	1985-10-29	1985-11-05	1	5787
37089	2524	1125315	1950-08-12	1950-08-26	1	-7068
45390	3080	1125315	1991-12-20	1992-01-10	1	8044
29982	2028	738818	2007-01-12	2007-01-19	1	13532
32153	2175	1177480	1990-07-14	1990-08-04	1	7520
35826	2435	1521369	1992-10-12	1993-10-07	1	8680
7400	510	1125315	1966-08-28	1966-09-11	1	-1208
42625	2889	1125315	1961-06-15	1961-06-22	1	-3115
76962	5259	738818	1973-02-11	1973-02-18	1	1144
36877	2509	1728416	1974-07-12	1974-07-26	1	1667
2498	164	1125315	1986-07-27	1986-08-10	1	6065
28432	1925	1713332	1981-08-11	1981-08-25	1	4254
68613	4680	1112807	1913-04-13	1913-04-27	1	-20703
36305	2468	1119510	1939-12-03	1939-12-10	1	-10980
36700	2497	1119510	1964-01-20	1964-01-27	1	-2166
61641	4208	1125315	1941-11-08	1941-11-22	1	-10267
30077	2033	1125315	1978-05-08	1978-05-15	1	3056
70509	4816	1125315	1994-03-08	1994-03-22	1	8846
32664	2211	1125315	1984-03-15	1984-03-22	1	5194
70113	4788	1125315	1977-08-27	1977-09-10	1	2809
36837	2507	1759842	2003-03-03	2003-03-17	1	12128
77047	5264	1713332	1992-02-11	1992-02-25	1	8090
31506	2131	1125315	1959-06-20	1959-06-27	1	-3841
72981	4987	1112807	1970-01-27	1970-02-17	1	47
40280	2740	1713332	2007-12-01	2007-12-22	1	13869
74515	5097	1118084	2005-08-05	2005-08-05	1	13000
26836	1814	1110410	2018-04-03	2018-04-03	1	17624
37153	2528	1729720	1969-11-12	1969-11-25	1	-37
74704	5111	1713332	1961-05-31	1961-06-21	1	-3116
67045	4576	1521369	1983-08-06	1984-07-31	1	5325
46156	3134	1713332	2003-09-26	2003-10-10	1	12335
36249	2466	1118084	2018-11-24	2018-11-24	1	17859
49365	3363	1112807	1958-06-28	1958-09-26	1	-4115
30628	2073	1125315	1984-12-30	1985-01-06	1	5484
70771	4834	1119510	1999-07-10	1999-07-17	1	10789
60734	4142	1729720	1992-10-28	1992-11-04	1	8343
52640	3583	1177480	2018-12-23	2019-03-23	1	17978
39993	2715	1125315	1966-11-09	1966-11-23	1	-1135
43911	2966	1361711	2013-11-23	2013-11-23	1	16032
31684	2145	1125315	1993-09-09	1993-10-28	2	8680
77240	5279	1713332	2010-10-04	2010-10-25	1	14907
26002	1760	1112807	1979-02-23	1979-03-09	1	3354
47908	3250	1713332	1977-12-19	1977-12-26	1	2916
33474	2273	1759842	1997-05-28	1997-07-02	1	10044
40689	2764	1515774	1990-08-05	1991-07-31	1	7881
37779	2567	1115008	2018-08-30	2018-10-04	1	17808
2863	190	701322	2010-12-22	2010-12-22	1	14965
31191	2109	1759842	1975-07-15	1975-08-05	1	2042
55770	3796	1539403	2018-11-20	2018-11-20	1	17855
52847	3601	1713332	1967-05-13	1967-06-03	1	-943
34191	2320	1728416	1947-05-03	1947-05-17	1	-8265
37543	2551	1503184	1974-08-07	1975-08-02	1	2039
37090	2524	1728416	1950-08-12	1950-08-26	1	-7068
45391	3080	1713332	2007-04-12	2007-06-02	2	13650
29983	2028	1102527	1997-11-16	1997-11-16	1	10181
32154	2175	1343916	2009-02-17	2009-02-17	1	14292
35827	2435	1713332	1988-02-07	1988-02-21	1	6625
7401	510	1125315	2005-06-04	2005-08-10	1	13005
42626	2889	1729720	1969-09-29	1969-10-12	1	-81
76963	5259	1125315	1973-02-11	1973-02-18	1	1144
36878	2509	1729720	1983-10-26	1983-11-03	1	5054
2499	164	1738521	1971-04-26	1971-05-10	1	494
28433	1925	1713332	1998-12-05	1998-12-19	1	10579
68614	4680	1112807	1957-04-10	1957-04-24	1	-4635
36306	2468	1119510	1994-03-27	1994-04-03	1	8858
36701	2497	1125315	1967-08-17	1967-08-31	1	-854
61642	4208	1125315	1961-02-17	1961-02-24	1	-3233
30078	2033	1729720	1992-09-01	1992-09-08	1	8286
70510	4816	1500211	1996-10-31	1997-10-26	1	10160
33310	2261	1112807	1969-07-19	1969-08-02	1	-152
70114	4788	1125315	1978-07-27	1978-08-10	1	3143
36838	2507	1759842	2005-09-09	2006-04-21	1	13259
77048	5264	1759842	1992-02-11	1992-02-25	1	8090
31507	2131	1125315	1978-10-14	1978-10-28	1	3222
72982	4987	1125315	1980-05-25	1980-06-08	1	3811
40281	2740	1729720	1988-03-28	1988-04-10	1	6674
74516	5097	1343916	1992-07-19	1992-07-19	1	8235
26837	1814	1112807	1949-09-30	1949-11-29	1	-7338
37154	2528	1759842	1979-05-06	1979-05-27	1	3433
74705	5111	1118084	1979-12-06	1979-12-06	1	3626
67046	4576	1728416	1955-12-03	1955-12-17	1	-5129
46157	3134	1759842	2003-09-26	2003-10-10	1	12335
36250	2466	1125315	1993-07-04	1993-10-02	2	8675
49366	3363	1118084	1995-08-08	1995-08-08	1	9350
30629	2073	1125315	1986-09-03	1986-09-24	1	6110
70772	4834	1125315	1962-06-21	1962-07-05	1	-2737
60735	4142	1759842	1999-04-16	1999-04-23	1	10704
52641	3583	1192710	1973-11-25	1973-11-25	1	1424
39994	2715	1125315	1990-09-30	1990-12-29	1	7667
43912	2966	1713332	1991-10-25	1991-11-08	1	7981
31685	2145	1177480	2015-06-05	2015-06-19	1	16605
77241	5279	1759842	2010-10-04	2010-10-25	1	14907
26003	1760	1118084	2017-08-23	2017-08-23	1	17401
47909	3250	1713332	1981-07-30	1981-08-20	1	4249
33475	2273	1759842	2010-08-03	2010-08-17	1	14838
40690	2764	1549786	1997-07-09	1998-03-20	1	10305
37780	2567	1119510	1977-11-14	1977-11-21	1	2881
2864	190	757627	2010-01-26	2010-01-26	1	14635
31192	2109	1118084	2005-12-04	2005-12-04	1	13121
55771	3796	1759842	1970-12-25	1971-01-08	1	372
52848	3601	19127890	1979-05-15	1980-05-09	1	3781
34192	2320	1759842	1946-02-16	1946-03-09	1	-8699
37544	2551	1503184	1976-07-27	1977-07-22	1	2759
37091	2524	1118084	1987-03-26	1987-03-26	1	6293
45392	3080	1728416	1946-06-09	1946-06-23	1	-8593
29984	2028	1125315	1967-04-02	1967-04-16	1	-991
32155	2175	1713332	1977-07-29	1977-08-12	1	2780
35828	2435	1713332	2014-12-12	2014-12-26	1	16430
7402	510	1713332	1975-06-17	1975-07-08	1	2014
42627	2889	1118084	2002-02-23	2002-02-23	1	11741
76964	5259	1759842	1972-02-10	1972-02-24	1	784
36879	2509	1729720	1984-03-03	1984-03-14	1	5186
2500	164	19127890	1987-11-19	1988-11-13	1	6891
28434	1925	1728416	1947-06-26	1947-07-10	1	-8211
68615	4680	1125315	1950-06-21	1950-06-28	1	-7127
36307	2468	1124300	1976-01-21	1976-01-21	1	2211
36702	2497	1125315	1969-07-20	1969-08-10	1	-144
61643	4208	1125315	1995-04-16	1995-05-21	1	9271
30079	2033	1125315	1958-03-16	1958-03-30	1	-4295
70511	4816	1713332	1984-10-11	1984-10-25	1	5411
33311	2261	1125315	1975-08-18	1975-09-22	1	2090
70115	4788	1177480	1989-08-11	1989-09-01	1	7183
36839	2507	19127890	1981-04-28	1982-04-23	1	4495
36058	2450	1118084	1986-05-15	1986-05-15	1	5978
31508	2131	1125315	1988-06-07	1988-06-28	1	6753
72983	4987	1125315	2013-07-05	2013-07-12	1	15898
40282	2740	1759842	2000-07-14	2000-08-04	1	11173
74517	5097	1713332	1993-10-01	1993-10-15	1	8688
26838	1814	1115008	2009-12-12	2010-02-10	1	14650
37155	2528	1759842	1992-06-06	1992-06-13	1	8199
74706	5111	1125315	1948-09-10	1948-09-17	1	-7776
67047	4576	1119510	1988-05-03	1988-05-17	1	6711
46158	3134	1112807	1924-08-09	1924-09-13	1	-16546
36251	2466	1125315	1996-08-17	1996-09-07	1	9746
49367	3363	1125315	1985-04-30	1985-05-14	1	5612
30630	2073	1125315	1987-09-25	1987-10-02	1	6483
70773	4834	1125315	1964-10-10	1964-10-24	1	-1895
60736	4142	738818	2003-08-28	2003-09-11	1	12306
52642	3583	1124300	2002-11-12	2002-11-12	1	12003
39995	2715	1125315	1997-03-18	1997-03-25	1	9945
43913	2966	1713332	2018-02-05	2018-02-26	1	17588
31686	2145	1729720	1968-06-30	1968-07-11	1	-539
77242	5279	738818	1955-11-27	1955-12-11	1	-5135
26004	1760	1125315	2015-01-02	2015-01-16	1	16451
47910	3250	1729720	1970-01-03	1970-01-14	1	13
35012	2372	738818	1998-10-30	1998-11-13	1	10543
40691	2764	1717327	1977-12-01	1977-12-15	1	2905
37781	2567	1125315	1986-10-24	1986-10-31	1	6147
2865	190	1112807	1930-08-07	1930-08-21	1	-14378
31193	2109	1125315	1994-05-21	1994-06-04	1	8920
55772	3796	738818	1986-05-03	1986-05-17	1	5980
52849	3601	975125	1967-08-22	1967-09-12	1	-842
34193	2320	1759842	1962-08-10	1962-08-24	1	-2687
37545	2551	1759842	1964-10-25	1964-11-08	1	-1880
37092	2524	1728416	1951-09-20	1951-10-04	1	-6664
45393	3080	1759842	2007-05-12	2007-06-02	1	13666
29985	2028	1729720	1956-11-09	1956-11-18	1	-4792
32156	2175	1125315	2003-04-16	2003-04-23	1	12165
35829	2435	1515774	1993-10-07	1994-10-02	1	9040
7403	510	1738521	1969-09-28	1969-10-12	1	-81
45323	3077	738818	2007-10-09	2007-10-23	1	13809
76965	5259	1759842	2012-02-01	2012-02-22	1	15392
36880	2509	1112807	1975-11-04	1975-12-04	1	2163
2501	164	1119510	1986-07-27	1986-08-10	1	6065
34271	2326	1119510	1999-04-05	1999-04-19	1	10700
68616	4680	1713332	1980-05-09	1980-05-30	1	3802
36308	2468	1125315	1963-04-29	1963-05-06	1	-2432
36703	2497	1125315	1988-08-23	1988-08-30	1	6816
61644	4208	1551099	1972-11-13	1972-11-27	1	1061
30080	2033	1125315	1959-05-11	1959-05-25	1	-3874
70512	4816	1713332	1999-03-29	1999-05-03	1	10714
33312	2261	1125315	2017-04-12	2017-04-26	1	17282
70116	4788	1728416	1978-07-27	1978-08-10	1	3143
36840	2507	19127890	1983-04-18	1985-04-07	2	5575
36059	2450	1125315	1966-11-13	1966-11-27	1	-1131
31509	2131	1551099	1962-03-30	1962-03-30	1	-2834
72984	4987	1125315	2019-06-10	2019-06-10	1	18057
40283	2740	1759842	2007-12-01	2007-12-22	1	13869
74518	5097	1728416	1969-11-24	1969-12-08	1	-24
26839	1814	1125315	1940-12-17	1940-12-24	1	-10600
37156	2528	1713332	1994-04-10	1994-04-17	1	8872
74707	5111	1125315	1984-12-03	1984-12-03	1	5450
67048	4576	1125315	1968-05-13	1968-05-20	1	-591
46159	3134	1125315	1981-10-24	1981-11-14	1	4335
36252	2466	1125315	2000-06-14	2000-06-28	1	11136
49368	3363	1713332	1956-05-09	1956-06-06	1	-4957
30631	2073	1125315	2007-11-18	2007-11-25	1	13842
70774	4834	1125315	1999-07-10	1999-07-17	1	10789
60737	4142	1118084	2019-01-21	2019-01-21	1	17917
52643	3583	1125315	1985-10-07	1985-11-11	1	5793
39996	2715	1174888	2017-11-23	2017-11-23	1	17493
43914	2966	1717327	1963-10-02	1963-10-16	1	-2269
31687	2145	1729720	2013-08-09	2013-08-21	1	15938
77243	5279	1119510	1975-08-07	1975-08-21	1	2058
26005	1760	1177480	1978-06-14	1978-06-28	1	3100
47911	3250	1759842	1981-07-30	1981-08-20	1	4249
35013	2372	1112807	1965-04-01	1965-04-15	1	-1722
42010	2847	1118084	2001-11-18	2001-11-18	1	11644
37782	2567	1125315	2018-01-10	2018-01-17	1	17548
2866	190	920293	1963-08-13	1963-08-20	1	-2326
31194	2109	1738521	1971-02-16	1971-03-02	1	425
55773	3796	1115008	2019-02-28	2019-03-14	1	17969
52850	3601	1115008	2000-06-08	2005-01-13	1	12796
34194	2320	1759842	2004-11-02	2004-11-16	1	12738
38226	2599	1118084	2011-05-05	2011-05-05	1	15099
37093	2524	1759842	1975-12-20	1976-01-10	1	2200
47396	3218	1125315	1973-09-30	1973-10-07	1	1375
29986	2028	723013	1983-02-09	1983-09-21	1	5011
32157	2175	1361711	2000-11-09	2000-11-09	1	11270
35830	2435	1729720	1981-04-15	1981-04-28	1	4135
8020	558	705944	1968-11-01	1970-09-25	1	267
45324	3077	920293	2011-07-07	2011-07-14	1	15169
76966	5259	1125315	1959-02-24	1959-03-10	1	-3950
36881	2509	1713332	2018-05-17	2018-05-31	1	17682
2502	164	1125315	1971-04-26	1971-05-10	1	494
34272	2326	1125315	1999-04-05	1999-04-19	1	10700
68617	4680	1759842	1980-05-09	1980-05-30	1	3802
36309	2468	1125315	1986-11-19	1986-11-26	1	6173
36704	2497	1326303	2017-08-17	2017-08-17	1	17395
61645	4208	1713332	1999-11-28	1999-12-12	1	10937
30081	2033	1125315	1962-03-17	1962-03-31	1	-2833
70513	4816	1713332	2019-03-29	2019-04-12	1	17998
33313	2261	1778162	1990-11-30	1990-12-14	1	7652
70117	4788	1738521	1976-07-20	1976-08-03	1	2406
36841	2507	1112807	1973-01-19	1973-02-02	1	1128
36060	2450	1125315	2005-07-01	2005-07-15	1	12979
31510	2131	738818	1958-07-17	1958-07-24	1	-4179
72985	4987	1112807	1962-10-06	1962-10-20	1	-2630
40284	2740	19127890	1982-12-07	1983-12-02	1	5083
74519	5097	1759842	1993-10-01	1993-10-15	1	8688
26840	1814	1125315	1991-05-30	1991-06-06	1	7826
37157	2528	1729720	1970-10-24	1970-11-02	1	305
74708	5111	1361711	1967-07-24	1984-12-03	1	5450
67049	4576	1503184	1983-08-06	1984-07-31	1	5325
46160	3134	1310149	2007-02-15	2007-02-15	1	13559
36253	2466	1177480	1989-06-25	1989-08-24	1	7175
49369	3363	1125315	1972-06-10	1972-06-17	1	898
30632	2073	1177480	1987-06-21	1987-07-05	1	6394
70775	4834	1521369	1974-05-12	1975-05-07	1	1952
60738	4142	1125315	2003-08-28	2003-09-11	1	12306
52644	3583	1125315	1988-01-26	1988-02-09	1	6613
39997	2715	1322184	1997-03-27	2017-11-23	1	17493
43915	2966	1759842	1991-10-25	1991-11-08	1	7981
31688	2145	1738521	1969-02-22	1969-03-08	1	-299
77244	5279	738818	1975-08-07	1975-08-21	1	2058
26006	1760	1177480	1980-05-21	1980-06-04	1	3807
47912	3250	1778162	2009-08-04	2009-08-18	1	14474
35014	2372	1729720	1966-07-27	1966-08-09	1	-1241
42011	2847	1125315	1973-06-13	1973-07-11	1	1287
37783	2567	1118084	2014-02-01	2014-02-01	1	16102
2867	190	933724	1963-08-13	1963-08-20	1	-2326
31372	2123	738818	1967-01-24	1967-01-31	1	-1066
55774	3796	1119510	2016-09-07	2016-09-14	1	17058
52851	3601	1119510	1984-10-01	1984-10-15	1	5401
35401	2406	1118084	1979-04-20	1979-04-20	1	3396
38227	2599	1125315	1981-11-22	1981-12-13	1	4364
37094	2524	1713332	1975-12-20	1976-01-10	1	2200
47397	3218	1713332	1993-04-18	1993-05-02	1	8522
29987	2028	738818	2016-09-24	2016-10-01	1	17075
32158	2175	1729720	1979-12-12	1979-12-22	1	3642
35831	2435	1118084	2015-11-20	2015-11-20	1	16759
8021	558	1115008	2000-11-01	2000-11-22	1	11283
45325	3077	1125315	1975-03-16	1975-03-30	1	1914
76967	5259	1177480	2004-05-19	2004-06-09	1	12578
36882	2509	1125315	2004-04-06	2004-04-20	1	12528
2503	164	1503184	1987-11-19	1988-11-13	1	6891
34273	2326	1177480	1985-02-23	1985-03-16	1	5553
68618	4680	723013	1946-04-08	1946-04-08	1	-8669
36310	2468	1759842	1952-12-27	1953-01-17	1	-6193
36705	2497	738818	1964-01-20	1964-01-27	1	-2166
61646	4208	1112807	1940-05-15	1940-05-29	1	-10809
30082	2033	1125315	2013-03-25	2013-04-01	1	15796
70514	4816	1118084	2017-12-15	2017-12-15	1	17515
33314	2261	1112807	1964-08-12	1964-08-26	1	-1954
70295	4802	1119510	1970-03-23	1970-03-30	1	88
36842	2507	1125315	1969-08-19	1969-09-02	1	-121
36061	2450	1125315	2014-03-09	2014-04-06	1	16166
31511	2131	1125315	1958-07-17	1958-07-24	1	-4179
72986	4987	1118084	1997-06-04	1997-06-04	1	10016
40285	2740	1125315	1975-11-05	1975-11-12	1	2141
74520	5097	1107830	1992-07-19	1992-07-19	1	8235
26841	1814	1713332	2000-10-11	2000-11-01	1	11262
37158	2528	1729720	1977-05-30	1977-06-08	1	2715
74709	5111	1759842	1961-05-31	1961-06-21	1	-3116
67050	4576	19127890	1976-09-11	1977-09-06	1	2805
46161	3134	1759842	1969-01-15	1969-01-22	1	-344
36254	2466	1125315	1979-10-17	1979-10-30	1	3589
49370	3363	1729720	1963-03-31	1963-04-12	1	-2456
30633	2073	1322184	2012-04-13	2012-04-13	1	15443
70776	4834	1112807	1971-03-24	1971-04-23	1	477
62626	4276	1119510	1964-01-07	1964-01-21	1	-2172
52645	3583	1551099	1975-07-05	1975-07-05	1	2011
39998	2715	1545958	2017-11-23	2017-11-23	1	17493
43916	2966	1759842	2018-02-05	2018-02-26	1	17588
31689	2145	1738521	1976-07-17	1976-07-31	1	2403
77245	5279	1112807	1963-04-28	1963-06-27	1	-2380
26007	1760	1729720	1993-03-19	1993-03-31	1	8490
47913	3250	1125315	1964-05-03	1964-05-10	1	-2062
35015	2372	1729720	1984-08-17	1984-08-24	1	5349
42012	2847	1125315	1983-10-17	1983-11-21	1	5072
37784	2567	1125315	1978-05-01	1978-05-08	1	3049
2868	190	1125315	1949-12-26	1950-01-09	1	-7297
31373	2123	1112807	1952-07-22	1952-08-05	1	-6358
55775	3796	1125315	1968-11-08	1968-11-22	1	-405
52852	3601	1305058	2000-06-08	2005-01-13	1	12796
35402	2406	1119510	1991-03-02	1991-03-09	1	7737
38228	2599	1125315	1986-08-19	1986-09-16	1	6102
37839	2572	1115008	2011-10-17	2011-11-07	1	15285
47398	3218	1728416	1960-10-21	1960-11-04	1	-3345
29988	2028	740275	1977-11-27	1977-11-27	1	2887
32159	2175	19127890	1992-01-15	1993-01-09	1	8409
35832	2435	1125315	1988-02-07	1988-02-21	1	6625
8022	558	1125315	1974-09-22	1974-10-06	1	1739
45326	3077	1125315	1991-09-16	1991-09-30	1	7942
76968	5259	1713332	1992-09-18	1992-09-25	1	8303
36883	2509	19127890	1987-05-15	1989-05-04	2	7063
2504	164	1738521	1967-12-24	1968-01-07	1	-725
34274	2326	1713332	1983-06-25	1983-07-02	1	4930
68619	4680	1124300	1952-07-25	1952-07-25	1	-6369
39936	2712	1112807	1968-01-09	1968-02-08	1	-693
36706	2497	914335	2008-02-28	2008-02-28	1	13937
61647	4208	1125315	1950-07-26	1950-08-09	1	-7085
30083	2033	1728416	1958-03-16	1958-03-30	1	-4295
70515	4816	1125315	1993-04-24	1993-05-29	1	8549
33315	2261	1177480	1993-02-19	1993-05-20	1	8540
70296	4802	1119510	2003-05-17	2003-05-31	1	12203
36843	2507	1125315	2009-03-11	2009-03-25	1	14328
38608	2626	738818	2018-08-15	2018-08-22	1	17765
34348	2330	1112807	1979-08-29	1979-09-12	1	3541
72987	4987	1125315	2016-05-28	2016-06-25	1	16977
40286	2740	1177480	2016-02-02	2016-02-16	1	16847
74521	5097	1112807	1968-01-22	1968-02-05	1	-696
26842	1814	1746114	2018-04-03	2018-04-03	1	17624
37159	2528	1759842	1977-04-01	1977-04-08	1	2654
75315	5153	1125315	1955-10-03	1955-10-10	1	-5197
68205	4656	1125315	1950-10-06	1950-11-03	1	-6999
46162	3134	1759842	1973-03-11	1973-04-01	1	1186
36255	2466	1124957	1993-07-04	1993-07-04	1	8585
49371	3363	1759842	1956-05-09	1956-06-06	1	-4957
30634	2073	1713332	1966-12-03	1966-12-17	1	-1111
70777	4834	1125315	1994-02-21	1994-03-14	1	8838
62627	4276	1174888	1977-07-17	1977-07-17	1	2754
52646	3583	1738521	1971-01-24	1971-02-07	1	402
39999	2715	1551099	1974-01-31	1974-01-31	1	1491
43917	2966	1125315	1976-11-06	1976-12-11	1	2536
31690	2145	1177480	1982-03-16	1982-04-15	1	4487
77246	5279	1119510	1974-04-14	1974-04-28	1	1578
26008	1760	19127890	1992-06-10	1994-05-31	2	8916
47914	3250	1125315	1986-08-15	1986-08-22	1	6077
35016	2372	1119510	1998-10-30	1998-11-13	1	10543
42013	2847	1125315	2009-06-09	2009-06-23	1	14418
37785	2567	1713332	1980-10-27	1980-11-10	1	3966
2869	190	1125315	1979-03-02	1979-03-16	1	3361
31374	2123	1112807	1958-01-11	1958-01-25	1	-4359
55776	3796	1125315	1986-05-03	1986-06-05	2	5994
52853	3601	1521369	1976-05-30	1977-05-25	1	2701
35403	2406	1125315	1949-01-08	1949-01-15	1	-7656
38229	2599	1515774	1993-01-19	1994-01-14	1	8779
37840	2572	1118084	2009-07-04	2009-07-04	1	14429
47399	3218	1759842	1993-04-18	1993-05-02	1	8522
29989	2028	1112807	1984-07-13	1984-07-27	1	5321
32160	2175	975125	2009-01-31	2009-01-31	1	14275
35833	2435	1125315	2014-03-07	2014-03-21	1	16150
8023	558	1125315	1977-11-04	1977-11-04	1	2864
45327	3077	1322184	2013-11-20	2014-06-11	1	16232
76969	5259	1728416	1959-02-24	1959-03-10	1	-3950
36884	2509	738818	1979-04-27	1979-05-11	1	3417
2505	164	1115008	2018-09-25	2018-10-09	1	17813
34275	2326	1729720	1985-01-10	1985-01-17	1	5495
68620	4680	1125315	1933-01-13	1933-01-20	1	-13495
39937	2712	1119510	1995-10-30	1995-11-13	1	9447
36707	2497	1125315	1964-01-20	1964-01-27	1	-2166
61648	4208	1125315	1960-05-30	1960-06-13	1	-3489
30084	2033	1119510	1978-05-08	1978-05-15	1	3056
70516	4816	1125315	1999-03-29	1999-05-03	1	10714
33316	2261	1177480	1994-04-15	1994-04-29	1	8884
70297	4802	738818	2003-05-17	2003-05-31	1	12203
36844	2507	1174888	1996-11-16	1996-11-16	1	9816
38609	2626	1125315	1966-07-03	1966-07-17	1	-1264
34349	2330	1119510	2015-10-21	2015-10-28	1	16736
72988	4987	1759842	2018-10-17	2018-11-07	1	17842
40287	2740	1521369	1982-12-07	1983-12-02	1	5083
74522	5097	1112807	1972-09-18	1972-10-02	1	1005
30732	2080	1118084	2019-05-20	2019-05-20	1	18036
37160	2528	1759842	1994-04-10	1994-04-17	1	8872
75316	5153	1125315	1977-03-30	1977-04-29	1	2675
68206	4656	1125315	2008-06-29	2008-06-29	1	14059
46163	3134	1759842	1978-04-11	1978-05-02	1	3043
36256	2466	1125315	2004-04-26	2004-05-03	1	12541
49372	3363	1112807	1951-05-01	1951-05-15	1	-6806
30635	2073	1728416	1973-11-19	1973-12-03	1	1432
70778	4834	1759842	1968-11-06	1968-11-13	1	-414
62628	4276	1125315	1953-01-25	1953-02-01	1	-6178
52647	3583	1112807	1971-01-24	1971-02-07	1	402
40000	2715	1728416	1966-11-09	1966-11-23	1	-1135
43918	2966	1125315	1989-01-07	1989-01-21	1	6960
31691	2145	1112807	1965-12-10	1966-02-08	1	-1423
77247	5279	1125315	1954-05-16	1954-05-30	1	-5695
26009	1760	1125315	1988-12-18	1989-01-17	1	6956
47915	3250	1713332	2001-12-01	2001-12-08	1	11664
35017	2372	1125315	1966-07-08	1966-07-22	1	-1259
42014	2847	1729720	1968-12-23	1969-01-05	1	-361
37786	2567	1125315	1980-10-27	1980-11-10	1	3966
2870	190	1177480	2011-01-07	2011-01-21	1	14995
31375	2123	1119510	1974-03-12	1974-03-19	1	1538
55777	3796	1177480	1992-10-31	1992-11-21	1	8360
52854	3601	1759842	1998-07-24	1998-07-31	1	10438
35404	2406	1347450	1993-09-23	1993-09-23	1	8666
38230	2599	1521369	1997-01-06	1999-12-22	3	10947
37841	2572	1125315	2015-02-04	2015-02-11	1	16477
47400	3218	1115008	1994-01-03	1994-04-03	1	8858
29990	2028	1118084	1987-02-08	1987-02-08	1	6247
32161	2175	1125315	1980-08-22	1980-09-05	1	3900
35834	2435	1729720	2011-01-26	2011-02-06	1	15011
8024	558	1174888	1977-11-04	1977-11-04	1	2864
45328	3077	1539403	2013-11-20	2013-11-20	1	16029
76970	5259	1729720	1966-05-20	1966-05-31	1	-1311
36885	2509	933724	2006-07-08	2006-07-15	1	13344
2506	164	1521369	1987-11-19	1988-11-13	1	6891
34276	2326	738818	1999-04-05	1999-04-19	1	10700
68621	4680	1125315	1979-10-24	1980-01-22	2	3673
39938	2712	1112807	1964-05-29	1964-06-12	1	-2029
36708	2497	1125315	2012-06-16	2012-07-07	1	15528
61649	4208	1125315	1972-10-08	1972-10-22	1	1025
30085	2033	1124300	1995-02-25	1995-02-25	1	9186
70517	4816	1549786	1997-10-26	1998-10-21	1	10520
33317	2261	1112807	1964-02-03	1964-02-17	1	-2145
70298	4802	1112807	1971-12-05	1972-03-04	1	793
36845	2507	1713332	1982-01-21	1982-02-11	1	4424
38610	2626	1125315	1968-02-06	1968-04-06	1	-635
34350	2330	1118084	2008-06-27	2008-06-27	1	14057
73351	5015	1112807	1982-05-22	1982-06-12	1	4545
40288	2740	1759842	1973-06-22	1973-06-29	1	1275
74523	5097	1119510	1983-05-05	1983-05-19	1	4886
30733	2080	1125315	1993-03-23	1993-06-21	2	8572
38686	2630	1125315	2007-09-18	2007-09-25	1	13781
75317	5153	1102527	2014-06-21	2014-06-21	1	16242
68207	4656	1332418	1995-10-01	1995-10-01	1	9404
46164	3134	1759842	2001-08-18	2001-09-01	1	11566
37727	2564	1112807	1979-07-07	1979-07-21	1	3488
49373	3363	1112807	1969-02-21	1969-03-14	1	-293
30636	2073	1759842	1969-05-13	1969-05-20	1	-226
70779	4834	19127890	1974-05-12	1975-05-07	1	1952
62629	4276	1125315	2001-02-03	2001-02-17	1	11370
52648	3583	1551099	1971-11-20	1971-11-20	1	688
42468	2878	1713332	1997-01-06	1997-01-13	1	9874
44809	3040	1713332	1972-10-27	1972-11-03	1	1037
31692	2145	1125315	1968-06-29	1968-07-13	1	-537
77248	5279	1125315	1965-05-17	1965-05-31	1	-1676
26010	1760	1177480	2005-02-22	2005-03-29	1	12871
47916	3250	1112807	1973-06-14	1973-09-12	1	1350
35018	2372	1125315	1974-04-14	1974-05-05	1	1585
42015	2847	1729720	1975-03-09	1975-03-18	1	1902
37787	2567	1125315	1984-12-05	1984-12-26	1	5473
2871	190	1729720	1994-07-14	1994-07-23	1	8969
31376	2123	1119510	1988-12-21	1989-01-04	1	6943
55778	3796	1713332	1970-12-25	1971-01-08	1	372
57617	3928	1118084	2012-08-17	2012-08-17	1	15569
35405	2406	1728416	1946-02-22	1946-03-08	1	-8700
38231	2599	1768849	1980-09-14	1980-09-28	1	3923
37842	2572	1521369	1986-06-05	1987-05-31	1	6359
47401	3218	1124300	1992-10-04	1992-10-04	1	8312
29991	2028	1125315	1997-11-16	1998-01-15	1	10241
32162	2175	1125315	2019-02-03	2019-02-17	1	17944
35835	2435	1759842	2014-12-12	2014-12-26	1	16430
8025	558	1322184	2003-09-04	2003-09-04	1	12299
45329	3077	1729720	1987-07-03	1987-07-15	1	6404
76971	5259	1729720	2011-03-21	2011-04-02	1	15066
36886	2509	1118084	2006-05-20	2006-05-20	1	13288
6014	411	1125315	1972-08-14	1972-08-21	1	963
34277	2326	1112807	1966-11-16	1966-11-30	1	-1128
68622	4680	1112807	1925-04-23	1925-05-14	1	-16303
39939	2712	1112807	1966-04-01	1966-04-15	1	-1357
36709	2497	1309944	2008-02-28	2008-02-28	1	13937
61650	4208	1125315	2013-10-04	2013-10-04	1	15982
30086	2033	1177480	2006-11-29	2006-12-27	1	13509
70518	4816	1713332	1983-06-02	1983-07-27	2	4955
33318	2261	1118084	2001-08-17	2001-08-17	1	11551
70299	4802	1118084	2005-06-20	2005-06-20	1	12954
36846	2507	1759842	1982-01-21	1982-02-11	1	4424
38611	2626	1125315	1974-03-08	1974-03-15	1	1534
34351	2330	1177480	1980-03-26	1980-04-09	1	3751
73352	5015	1118084	2006-08-14	2006-08-14	1	13374
40289	2740	19127890	1990-10-26	1991-10-21	1	7963
74524	5097	1125315	1979-02-23	1979-03-16	1	3361
30734	2080	1177480	2000-11-11	2000-12-09	1	11300
38687	2630	1125315	2015-09-04	2015-09-18	1	16696
75318	5153	1118084	1987-02-05	1987-02-05	1	6244
68208	4656	1361711	2008-11-02	2014-05-11	1	16201
46165	3134	738818	1974-03-22	1974-04-05	1	1555
37728	2564	1125315	1986-06-05	1986-07-05	1	6029
50099	3413	1102527	2007-04-22	2007-04-22	1	13625
34602	2342	1118084	2018-06-25	2018-06-25	1	17707
70780	4834	738818	1999-07-10	1999-07-17	1	10789
62630	4276	1729720	2016-09-24	2016-10-07	1	17081
53331	3631	738818	2015-03-22	2015-03-29	1	16523
42469	2878	1759842	1997-01-06	1997-01-13	1	9874
44810	3040	1713332	1988-05-26	1988-06-02	1	6727
31693	2145	1125315	1976-07-17	1976-07-31	1	2403
77249	5279	1125315	1975-08-07	1975-08-21	1	2058
26011	1760	1515774	1992-06-10	1994-05-31	2	8916
48134	3268	1119510	1988-11-23	1988-12-07	1	6915
35019	2372	1115008	2007-07-11	2007-07-25	1	13719
42016	2847	1729720	1989-11-12	1989-11-19	1	7262
37788	2567	1125315	2011-10-21	2011-11-04	1	15282
2872	190	1112807	1936-02-07	1936-05-07	1	-12292
31377	2123	1728416	1952-07-22	1952-08-05	1	-6358
55779	3796	738818	2010-08-18	2010-09-01	1	14853
57618	3928	1729720	2006-06-02	2006-06-14	1	13313
35406	2406	738818	1965-10-05	1965-10-19	1	-1535
38232	2599	1778162	1988-08-24	1988-09-07	1	6824
37843	2572	1713332	1986-01-31	1986-02-07	1	5881
47402	3218	1125315	1957-10-23	1957-11-06	1	-4439
29992	2028	1125315	2003-09-16	2003-10-07	1	12332
32163	2175	1521369	1992-01-15	1993-01-09	1	8409
35836	2435	19127890	1992-10-12	1994-10-02	2	9040
8026	558	1177480	1977-11-04	1978-02-02	1	2954
45330	3077	1112807	1968-01-01	1968-03-01	1	-671
76972	5259	1759842	1992-09-18	1992-09-25	1	8303
36887	2509	1125315	1979-04-27	1979-05-11	1	3417
6015	411	1125315	1981-12-24	1981-12-31	1	4382
34278	2326	1125315	1963-01-07	1963-01-14	1	-2544
68623	4680	1112807	1944-12-30	1945-01-13	1	-9119
39940	2712	1112807	1966-09-05	1966-09-19	1	-1200
36710	2497	1310149	2017-08-17	2017-08-17	1	17395
61651	4208	1177480	2012-09-18	2012-10-09	1	15622
30962	2091	1125315	1984-11-09	1984-11-23	1	5440
70519	4816	1759842	1983-06-08	1983-07-27	1	4955
33319	2261	1125315	1974-01-13	1974-01-20	1	1480
70300	4802	1125315	1968-11-21	1968-12-05	1	-392
36847	2507	1125315	1979-08-27	1979-09-17	1	3546
38612	2626	1125315	1994-07-30	1994-08-13	1	8990
34352	2330	1713332	1979-08-29	1979-09-12	1	3541
73353	5015	1125315	1971-02-27	1971-03-13	1	436
40290	2740	19127890	1994-10-05	1995-09-30	1	9403
74525	5097	1125315	2009-01-11	2009-01-18	1	14262
30735	2080	1177480	2009-08-24	2009-09-07	1	14494
38688	2630	1713332	1988-11-24	1988-12-01	1	6909
75319	5153	1125315	1960-01-08	1960-01-29	1	-3625
68209	4656	1545958	2008-06-29	2008-06-29	1	14059
46166	3134	1112807	1966-11-07	1966-12-12	1	-1116
37729	2564	1125315	1993-08-23	1993-09-06	1	8649
50100	3413	1115008	2007-04-22	2007-05-22	1	13655
34603	2342	1521369	1989-01-13	1990-01-08	1	7312
70781	4834	1112807	1962-02-04	1962-02-18	1	-2874
62631	4276	1759842	2006-07-01	2006-07-08	1	13337
53332	3631	1125315	1981-03-31	1981-04-30	1	4137
42470	2878	19127890	1995-08-16	1996-08-10	1	9718
44811	3040	1759842	1988-05-26	1988-06-02	1	6727
32320	2189	1118084	2012-11-16	2012-11-16	1	15660
77250	5279	1713332	2005-07-13	2005-07-27	1	12991
26012	1760	1713332	1981-03-08	1981-03-15	1	4091
48135	3268	1125315	1974-10-15	1974-10-29	1	1762
35020	2372	1124300	1997-12-09	1997-12-09	1	10204
42017	2847	1125315	1985-06-12	1985-06-26	1	5655
37789	2567	1515774	1990-07-17	1991-07-12	1	7862
2873	190	1115008	1997-09-19	1997-10-17	1	10151
31378	2123	738818	1988-12-21	1989-01-04	1	6943
55780	3796	1118084	2007-05-23	2007-05-23	1	13656
57619	3928	1125315	2005-03-27	2005-05-01	1	12904
35407	2406	1112807	1946-02-22	1946-03-08	1	-8700
38233	2599	1125315	1980-09-14	1980-09-28	1	3923
37844	2572	1112807	1971-05-15	1971-05-29	1	513
47403	3218	1759842	1992-03-27	1992-04-17	1	8142
29993	2028	1125315	2016-09-24	2016-10-01	1	17075
32164	2175	1759842	1977-07-29	1977-08-12	1	2780
38188	2597	1118084	2010-08-31	2010-08-31	1	14852
8027	558	1347450	2003-09-04	2003-09-04	1	12299
45331	3077	1112807	1972-03-10	1972-03-31	1	820
76973	5259	1115008	2012-03-06	2012-03-27	1	15426
36888	2509	1503184	1987-05-15	1989-05-04	2	7063
6016	411	1125315	2012-03-25	2012-04-01	1	15431
34279	2326	1125315	1986-01-14	1986-01-28	1	5871
68624	4680	1125315	1995-01-24	1995-02-23	1	9184
39941	2712	1125315	1980-07-01	1980-07-08	1	3841
36711	2497	1343916	2008-02-28	2008-02-28	1	13937
61652	4208	1713332	1998-02-09	1998-03-02	1	10287
30963	2091	1125315	2013-02-05	2013-02-19	1	15755
71276	4867	1125315	1988-08-21	1988-09-04	1	6821
33320	2261	1125315	2012-03-31	2012-04-07	1	15437
70301	4802	1125315	2003-05-17	2003-05-31	1	12203
36848	2507	1125315	1992-05-22	1992-06-05	1	8191
38613	2626	1125315	2007-12-19	2008-01-02	1	13880
34353	2330	738818	2015-10-21	2015-10-28	1	16736
73354	5015	1125315	2010-09-25	2010-10-16	1	14898
40291	2740	738818	1975-11-05	1975-11-12	1	2141
75838	5193	1310149	2015-09-24	2015-09-24	1	16702
30736	2080	1125315	1989-02-21	1989-05-22	1	7081
38689	2630	1713332	2005-11-04	2005-11-25	1	13112
75320	5153	1125315	1970-03-27	1970-04-10	1	99
68210	4656	1717327	1963-05-15	1963-05-29	1	-2409
46167	3134	1124300	1963-09-04	1963-09-04	1	-2311
37730	2564	1125315	1995-12-15	1996-01-05	1	9500
50101	3413	1503184	1986-03-23	1987-03-18	1	6285
34604	2342	1713332	2008-05-01	2008-05-22	1	14021
70782	4834	1125315	1983-09-13	1983-09-27	1	5017
62632	4276	1118084	1996-10-30	1996-10-30	1	9799
53333	3631	1125315	1989-05-24	1989-05-31	1	7090
42471	2878	19127890	1997-08-05	1998-07-31	1	10438
44812	3040	738818	2011-10-02	2011-10-09	1	15256
32321	2189	1125315	1981-03-31	1981-04-07	1	4114
77251	5279	1759842	1975-01-19	1975-01-26	1	1851
26013	1760	1713332	1979-02-23	1979-03-09	1	3354
48136	3268	738818	1988-11-23	1988-12-07	1	6915
35021	2372	1713332	2017-02-17	2017-02-24	1	17221
42018	2847	1125315	1989-12-20	1990-01-03	1	7307
37790	2567	1729720	1978-11-09	1978-11-19	1	3244
2874	190	1118084	1969-01-19	1969-01-19	1	-347
31379	2123	1119510	1954-03-28	1954-04-11	1	-5744
55781	3796	1125315	2006-08-10	2006-08-31	1	13391
57620	3928	1125315	1982-09-24	1982-10-08	1	4663
35408	2406	1125315	1954-09-07	1954-09-21	1	-5581
38234	2599	1125315	1983-01-07	1983-02-06	1	4784
37845	2572	1125315	1999-10-29	1999-11-19	1	10914
47404	3218	1713332	1992-03-27	1992-04-17	1	8142
29994	2028	1501700	2018-11-17	2018-11-17	1	17852
32165	2175	1118084	2013-08-07	2013-08-07	1	15924
38189	2597	1119510	2001-06-05	2001-06-12	1	11485
8028	558	1118084	2002-03-13	2002-03-13	1	11759
45332	3077	1118084	1992-05-03	1992-05-03	1	8158
76974	5259	1118084	1999-11-06	1999-11-06	1	10901
36889	2509	1729720	1976-06-20	1976-07-02	1	2374
6017	411	1713332	2002-07-13	2002-08-03	1	11902
34280	2326	1125315	1991-10-02	1991-11-06	1	7979
68625	4680	1347450	2000-01-01	2000-01-01	1	10957
39942	2712	1125315	1998-11-23	1998-12-30	2	10590
36712	2497	1728416	1963-03-24	1963-04-07	1	-2461
61653	4208	1759842	1998-02-09	1998-03-02	1	10287
30964	2091	1759842	1967-09-08	1967-09-15	1	-839
71277	4867	1713332	1941-10-12	1941-11-02	1	-10287
33321	2261	1102527	1993-02-19	1993-02-19	1	8450
70302	4802	738818	1970-03-23	1970-03-30	1	88
36849	2507	1521369	1981-04-28	1982-04-23	1	4495
38614	2626	1125315	2018-08-15	2018-08-22	1	17765
34354	2330	1125315	2015-10-21	2015-10-28	1	16736
73355	5015	1759842	1970-03-25	1970-04-15	1	104
40292	2740	1125315	1996-10-14	1997-01-12	1	9873
75839	5193	1347450	2010-06-10	2010-06-10	1	14770
30737	2080	1149380	1982-10-18	1982-10-18	1	4673
38690	2630	1729720	1972-12-23	1973-01-04	1	1099
75321	5153	1713332	2001-12-09	2001-12-23	1	11679
68211	4656	1728416	1951-08-02	1951-08-16	1	-6713
46168	3134	1125315	1965-05-06	1965-05-20	1	-1687
37731	2564	1521369	1999-07-02	2000-06-26	1	11134
50102	3413	1521369	1980-04-23	1981-04-18	1	4125
34605	2342	1759842	2008-05-01	2008-05-22	1	14021
70783	4834	1177480	2008-12-30	2009-01-20	1	14264
62633	4276	1119510	1995-08-07	1995-08-21	1	9363
53334	3631	1125315	2015-03-22	2015-03-29	1	16523
42472	2878	1125315	1982-05-16	1982-05-30	1	4532
44813	3040	1118084	2010-09-27	2010-09-27	1	14879
32322	2189	1125315	1988-09-18	1988-10-02	1	6849
77252	5279	1759842	2005-07-13	2005-07-27	1	12991
26014	1760	1759842	1981-03-08	1981-03-15	1	4091
48137	3268	1125315	1988-11-23	1988-12-07	1	6915
35022	2372	1729720	1977-11-13	1977-11-20	1	2880
42019	2847	1125315	1993-03-03	1993-03-24	1	8483
37791	2567	738818	1977-11-14	1977-11-21	1	2881
2875	190	1112807	1971-07-17	1971-08-07	1	583
31380	2123	1125315	1951-01-12	1951-01-26	1	-6915
55782	3796	1125315	2010-08-18	2010-09-01	1	14853
59004	4020	1119510	1965-02-23	1965-03-02	1	-1766
35409	2406	1125315	1965-10-05	1965-10-19	1	-1535
38235	2599	1125315	1988-08-24	1988-09-07	1	6824
37846	2572	1503184	1986-06-05	1987-05-31	1	6359
47405	3218	1112807	1960-10-21	1960-11-04	1	-3345
29995	2028	1759842	1946-07-12	1946-07-19	1	-8567
32166	2175	1322184	2000-11-09	2000-11-09	1	11270
38190	2597	1125315	2001-06-05	2001-06-12	1	11485
8029	558	1125315	1985-04-26	1985-05-24	1	5622
45333	3077	1125315	1954-06-17	1954-08-16	1	-5617
76975	5259	1125315	1973-09-29	1973-11-28	1	1427
36890	2509	1729720	2006-05-02	2006-05-13	1	13281
6018	411	1729720	1995-11-07	1995-11-19	1	9453
34281	2326	1125315	2010-02-20	2010-03-06	1	14674
71255	4865	1125315	1981-11-24	1982-01-30	1	4412
39943	2712	1125315	2018-03-11	2018-04-08	1	17629
37892	2577	975125	1983-04-05	1983-04-26	1	4863
61654	4208	701322	2009-02-02	2009-02-02	1	14277
30965	2091	1759842	1968-10-04	1968-10-18	1	-440
71278	4867	1713332	2011-10-17	2011-10-31	1	15278
33322	2261	1112807	1973-10-13	1973-10-27	1	1395
70303	4802	1125315	1970-03-23	1970-03-30	1	88
36850	2507	1521369	1983-04-18	1985-04-07	2	5575
38615	2626	1713332	1986-07-03	1986-07-10	1	6034
35455	2412	1112807	1951-02-20	1951-03-06	1	-6876
73356	5015	1112807	1968-04-05	1968-04-19	1	-622
40293	2740	1125315	2008-08-31	2008-09-14	1	14136
75840	5193	1729720	1975-06-06	1975-06-14	1	1990
30738	2080	1729720	1984-01-20	1984-01-29	1	5141
38691	2630	1759842	2006-10-29	2006-11-05	1	13457
75322	5153	1125315	1982-11-21	1982-11-28	1	4714
68212	4656	1112807	1951-08-02	1951-08-16	1	-6713
46169	3134	1125315	1974-03-22	1974-04-05	1	1555
37732	2564	1729720	1991-08-06	1991-08-17	1	7898
50103	3413	1729720	1983-02-09	1983-02-21	1	4799
34606	2342	1115008	2018-11-18	2018-12-23	1	17888
70784	4834	1713332	1968-11-06	1968-11-13	1	-414
62634	4276	1125315	2016-11-14	2016-11-21	1	17126
53335	3631	738818	1978-09-10	1978-09-17	1	3181
42473	2878	1125315	1999-12-14	1999-12-21	1	10946
44814	3040	1125315	1987-04-24	1987-05-01	1	6329
32323	2189	975125	2010-02-03	2010-02-03	1	14643
26015	1760	1119510	2015-01-02	2015-01-16	1	16451
48138	3268	1125315	2018-05-21	2018-06-11	1	17693
35023	2372	1759842	2017-02-17	2017-02-24	1	17221
42020	2847	1713332	1980-08-24	1980-09-07	1	3902
37792	2567	1119510	1986-10-24	1986-10-31	1	6147
2876	190	1125315	1954-11-29	1955-01-28	1	-5452
31381	2123	1125315	1959-05-30	1959-08-28	1	-3779
55783	3796	1125315	2019-03-11	2019-03-18	1	17973
59005	4020	1124957	1972-09-08	1972-09-08	1	981
35410	2406	738818	1991-03-02	1991-03-09	1	7737
38236	2599	1549786	1993-01-19	1994-01-14	1	8779
37847	2572	1759842	1986-01-31	1986-02-07	1	5881
47406	3218	1125315	1966-01-09	1966-01-30	1	-1432
29996	2028	1759842	2004-08-03	2004-08-24	1	12654
32167	2175	1332418	2000-11-09	2000-11-09	1	11270
38191	2597	1759842	1997-06-24	1997-07-08	1	10050
8030	558	1177480	2002-12-12	2003-01-09	1	12061
45334	3077	1125315	2013-04-01	2013-04-08	1	15803
76976	5259	1125315	2008-04-19	2008-05-26	1	14025
36891	2509	1759842	2018-05-17	2018-05-31	1	17682
6019	411	1759842	1968-09-28	1968-10-12	1	-446
34282	2326	1713332	2000-12-04	2000-12-18	1	11309
71256	4865	1125315	1985-01-14	1985-02-11	1	5520
39944	2712	1177480	2003-08-06	2003-08-27	1	12291
37893	2577	975125	2013-10-18	2013-11-08	1	16017
61655	4208	1112807	1944-11-20	1944-12-20	1	-9143
30966	2091	1112807	1965-06-12	1965-06-26	1	-1650
71279	4867	1717327	1968-09-21	1968-10-05	1	-453
33323	2261	1112807	1990-11-30	1990-12-14	1	7652
70304	4802	1125315	2003-12-17	2004-01-07	1	12424
36851	2507	1713332	2003-03-03	2003-03-17	1	12128
38616	2626	1728416	1965-04-22	1965-05-06	1	-1701
35456	2412	1713332	2008-02-14	2008-03-06	1	13944
73357	5015	1125315	1983-05-10	1983-05-24	1	4891
40294	2740	1503184	1982-12-07	1983-12-02	1	5083
75841	5193	1112807	1964-06-05	1964-06-19	1	-2022
30739	2080	738818	2009-04-09	2009-04-23	1	14357
38692	2630	738818	1975-05-01	1975-05-15	1	1960
75323	5153	1729720	1972-01-07	1972-01-17	1	746
68213	4656	1124300	1993-06-12	1993-06-12	1	8563
46170	3134	1125315	2001-08-01	2001-08-22	1	11556
37733	2564	1515774	1996-07-17	1997-07-12	1	10054
50104	3413	1759842	1980-05-14	1980-06-25	1	3828
34607	2342	1125315	1976-05-11	1976-05-25	1	2336
71901	4913	738818	2017-09-23	2017-10-07	1	17446
62635	4276	1713332	2006-07-01	2006-07-08	1	13337
53336	3631	1125315	1978-09-10	1978-09-17	1	3181
42474	2878	1503184	1997-08-05	1998-07-31	1	10438
44815	3040	1125315	2011-10-02	2011-10-09	1	15256
32324	2189	1149196	2010-02-17	2010-02-17	1	14657
26016	1760	1177480	2006-01-23	2006-02-22	1	13201
48139	3268	1713332	1992-08-14	1992-10-30	1	8338
35024	2372	1125315	1965-05-02	1965-05-16	1	-1691
42021	2847	1759842	1980-08-24	1980-09-07	1	3902
37793	2567	1125315	1977-11-14	1977-11-21	1	2881
2877	190	1125315	1969-08-12	1969-08-26	1	-128
31382	2123	1125315	1961-06-06	1961-06-13	1	-3124
55784	3796	1177480	2018-12-26	2019-01-16	1	17912
59006	4020	1125315	1958-12-16	1958-12-30	1	-4020
35411	2406	1125315	1981-01-30	1981-02-13	1	4061
38237	2599	19127890	1997-01-06	1998-01-01	1	10227
37848	2572	19127890	1986-06-05	1987-05-31	1	6359
47407	3218	1125315	1997-03-18	1997-04-01	1	9952
29997	2028	1125315	1959-03-29	1959-04-12	1	-3917
32168	2175	1503184	1992-01-15	1993-01-09	1	8409
38192	2597	1125315	1983-12-30	1984-01-29	1	5141
8031	558	1177480	2003-11-05	2003-11-26	1	12382
45335	3077	1332418	2013-11-20	2013-11-20	1	16029
76977	5259	1713332	1972-02-10	1972-02-24	1	784
38075	2589	1115008	2016-10-08	2016-10-22	1	17096
6020	411	1759842	2002-07-13	2002-08-03	1	11902
34283	2326	1125315	1988-10-14	1988-10-28	1	6875
71257	4865	1125315	2005-04-28	2005-05-05	1	12908
39945	2712	1728416	1968-01-30	1968-02-08	1	-693
37894	2577	1112807	1986-07-03	1986-07-24	1	6048
61656	4208	1115008	1972-11-13	1972-11-27	1	1061
30967	2091	1119510	1967-12-31	1968-01-07	1	-725
71280	4867	1729720	1931-09-07	1931-09-17	1	-13986
33324	2261	1115008	2007-11-17	2007-12-08	1	13855
71478	4881	1124300	1988-11-18	1988-11-18	1	6896
36852	2507	1713332	2005-09-09	2006-04-21	1	13259
38617	2626	1729720	1968-11-03	1968-11-15	1	-412
35457	2412	1713332	2018-10-15	2018-10-22	1	17826
73358	5015	1125315	1991-02-06	1991-02-13	1	7713
40295	2740	1515774	1990-10-26	1991-10-21	1	7963
75842	5193	1112807	1965-07-30	1965-09-28	1	-1556
30740	2080	1125315	1992-02-06	1992-02-27	1	8092
38693	2630	738818	1980-04-27	1980-05-04	1	3776
75324	5153	1729720	1998-04-02	1998-04-09	1	10325
68214	4656	1125315	1966-11-09	1966-11-09	1	-1149
46171	3134	1322184	2015-04-16	2015-04-16	1	16541
37734	2564	738818	2002-09-24	2002-10-08	1	11968
50105	3413	1759842	2006-10-27	2006-11-17	1	13469
34608	2342	1125315	1978-09-13	1978-09-27	1	3191
71902	4913	1125315	1976-12-03	1976-12-17	1	2542
62636	4276	738818	1964-01-07	1964-01-21	1	-2172
53337	3631	1125315	1980-04-30	1980-06-04	1	3807
42475	2878	1503184	2000-07-20	2001-07-15	1	11518
44816	3040	1759842	1972-10-27	1972-11-03	1	1037
32325	2189	1729720	1998-04-02	1998-04-11	1	10327
26017	1760	1549786	1992-06-10	1994-05-31	2	8916
48140	3268	1118084	2009-04-17	2009-04-17	1	14351
35025	2372	1125315	1998-10-30	1998-11-13	1	10543
43175	2921	1112807	1940-07-18	1940-08-01	1	-10745
37794	2567	1549786	1990-07-17	1991-07-12	1	7862
2878	190	1177480	2014-12-01	2014-12-22	1	16426
31383	2123	1125315	1988-12-21	1989-01-04	1	6943
55785	3796	1322184	2018-11-20	2018-11-20	1	17855
59007	4020	1125315	1960-10-27	1960-11-10	1	-3339
35412	2406	1125315	1991-03-02	1991-03-09	1	7737
38238	2599	1125315	2001-03-01	2001-03-22	1	11403
37849	2572	1125315	2005-01-18	2005-01-25	1	12808
47408	3218	1728416	1957-10-23	1957-11-06	1	-4439
29998	2028	1713332	1946-07-12	1946-07-19	1	-8567
32169	2175	1539403	2000-11-09	2000-11-09	1	11270
38193	2597	1125315	1990-06-26	1990-07-24	1	7509
8652	600	914335	1997-02-19	1997-02-19	1	9911
45336	3077	1125315	1979-11-18	1979-12-18	1	3638
76978	5259	1102527	2008-04-26	2008-04-26	1	13995
38076	2589	1125315	1993-07-29	1993-08-12	1	8624
6021	411	738818	1973-11-17	1973-12-01	1	1430
34284	2326	1115008	2000-12-04	2000-12-18	1	11309
71258	4865	1177480	1977-11-08	1978-01-14	1	2935
39946	2712	738818	1995-10-30	1995-11-13	1	9447
37895	2577	1119510	1992-01-17	1992-01-31	1	8065
61657	4208	1115008	2013-10-04	2013-11-03	1	16012
30968	2091	1124300	2001-10-26	2001-10-26	1	11621
71281	4867	1759842	1927-02-07	1927-02-28	1	-15648
33325	2261	1125315	1990-05-30	1990-06-13	1	7468
71479	4881	1125315	1952-05-21	1952-06-18	1	-6406
39247	2669	1118084	2019-01-12	2019-01-12	1	17908
38618	2626	1112807	1965-04-22	1965-05-06	1	-1701
35458	2412	1729720	1955-08-12	1955-08-24	1	-5244
73359	5015	1729720	1969-04-02	1969-04-10	1	-266
40296	2740	1515774	1994-10-05	1995-09-30	1	9403
75843	5193	1115008	2008-10-12	2008-11-02	1	14185
30741	2080	1125315	2009-04-09	2009-04-23	1	14357
38694	2630	1125315	1975-05-01	1975-05-15	1	1960
75325	5153	1115008	2014-06-14	2014-08-20	1	16302
68215	4656	1174888	2014-05-11	2014-05-11	1	16201
46172	3134	1326303	2007-02-15	2007-02-15	1	13559
37735	2564	1112807	1978-08-11	1978-08-25	1	3158
50106	3413	1125315	1974-09-13	1974-09-20	1	1723
34609	2342	1125315	1980-06-29	1980-07-13	1	3846
71903	4913	1713332	2005-11-29	2005-12-06	1	13123
62637	4276	738818	1995-08-07	1995-08-21	1	9363
53338	3631	1125315	1994-03-03	1994-03-10	1	8834
42476	2878	1515774	1995-08-16	1996-08-10	1	9718
44817	3040	1119510	2011-10-02	2011-10-09	1	15256
32326	2189	1125315	2004-04-08	2004-04-22	1	12530
26018	1760	1738521	1978-06-14	1978-06-28	1	3100
48141	3268	1125315	2014-06-10	2014-06-17	1	16238
35026	2372	1717327	1966-07-08	1966-07-22	1	-1259
43176	2921	1112807	1989-05-07	1989-07-06	1	7126
37795	2567	19127890	1990-07-17	1991-07-12	1	7862
4146	283	1115008	1998-04-21	1998-07-20	1	10427
31384	2123	1713332	1954-05-02	1954-05-23	1	-5702
55786	3796	1332418	2018-11-20	2018-11-20	1	17855
59008	4020	1322184	2014-10-02	2014-10-02	1	16345
35413	2406	1343916	1961-05-11	1961-05-11	1	-3157
38239	2599	1177480	1979-12-19	1980-01-02	1	3653
39436	2682	1177480	2017-02-04	2017-05-05	1	17291
48533	3300	1125315	2009-10-12	2009-10-26	1	14543
32767	2220	738818	1980-08-24	1980-08-31	1	3895
32170	2175	1738521	1977-09-20	1977-10-04	1	2833
38194	2597	1125315	1996-06-04	1996-06-18	1	9665
8653	600	920293	1985-01-27	1985-02-03	1	5512
45337	3077	1347450	2014-06-11	2014-06-11	1	16232
76979	5259	1112807	1972-10-13	1972-11-03	1	1037
38077	2589	1549786	2001-02-25	2002-02-20	1	11738
6022	411	1124957	1980-08-29	1980-08-29	1	3893
34285	2326	1124300	1994-01-13	1994-01-13	1	8778
71259	4865	1713332	1981-08-09	1981-08-30	1	4259
39947	2712	1118084	2000-08-08	2000-08-08	1	11177
37896	2577	1129625	1975-06-02	1975-06-02	1	1978
61658	4208	1118084	1978-10-03	1978-10-03	1	3197
30969	2091	1713332	2004-01-01	2004-01-15	1	12432
71282	4867	1124957	1926-11-01	1926-11-01	1	-15767
33326	2261	1728416	1964-08-12	1964-08-26	1	-1954
71480	4881	1125315	1984-11-09	1984-12-07	1	5454
39248	2669	1177480	1979-10-24	1979-11-28	1	3618
38619	2626	1118084	2000-03-09	2000-03-09	1	11025
35459	2412	1759842	1970-07-23	1970-08-13	1	224
73360	5015	1738521	1971-02-27	1971-03-13	1	436
40297	2740	1549786	1994-10-05	1995-09-30	1	9403
75844	5193	1118084	2001-08-05	2001-08-05	1	11539
30742	2080	1174888	1993-03-23	1993-03-23	1	8482
38695	2630	1125315	2014-04-24	2014-05-29	1	16219
75326	5153	1759842	2001-12-09	2001-12-23	1	11679
68216	4656	1322184	2008-11-02	2014-05-11	1	16201
46173	3134	1102527	1988-12-07	1988-12-07	1	6915
37736	2564	1125315	1983-05-31	1983-06-21	1	4919
50107	3413	1125315	1982-08-23	1982-08-30	1	4624
34610	2342	1125315	1990-01-28	1990-02-18	1	7353
71904	4913	1125315	1981-04-25	1981-07-24	1	4222
62638	4276	1125315	1964-01-07	1964-01-21	1	-2172
53339	3631	1119510	1978-09-10	1978-09-17	1	3181
42477	2878	1759842	2004-05-24	2004-06-07	1	12576
44818	3040	1125315	1976-08-31	1976-11-29	1	2524
32327	2189	1343916	2010-02-17	2010-02-17	1	14657
26019	1760	1738521	1980-05-21	1980-06-04	1	3807
48142	3268	1112807	1970-07-06	1970-08-10	1	221
37115	2526	1115008	2000-07-16	2000-08-06	1	11175
43177	2921	1149380	1978-06-13	1978-06-13	1	3085
39288	2673	1124300	2016-08-16	2016-08-16	1	17029
4147	283	1125315	1993-05-27	1993-06-10	1	8561
31385	2123	1728416	1951-01-12	1951-01-26	1	-6915
55787	3796	1361711	2018-11-20	2018-11-20	1	17855
59009	4020	1728416	1958-12-16	1958-12-30	1	-4020
35414	2406	1728416	1947-04-11	1947-04-25	1	-8287
38240	2599	1503184	1997-01-06	1998-01-01	1	10227
39437	2682	1738521	1978-01-20	1978-02-03	1	2955
48534	3300	1503184	1997-07-27	1998-07-22	1	10429
32768	2220	1112807	1949-07-07	1949-07-28	1	-7462
32171	2175	1768849	1980-08-22	1980-09-05	1	3900
38195	2597	1177480	1999-06-07	1999-06-28	1	10770
8654	600	933724	1985-01-27	1985-02-03	1	5512
45338	3077	1361711	2013-11-20	2013-11-20	1	16029
76980	5259	1119510	1973-02-11	1973-02-18	1	1144
38078	2589	1115008	1998-01-02	1998-01-16	1	10242
6023	411	1125315	1961-02-11	1961-02-25	1	-3232
34286	2326	1125315	1952-10-30	1952-11-13	1	-6258
71260	4865	1115008	1995-02-10	1995-02-24	1	9185
39948	2712	1124957	1998-11-30	1998-11-30	1	10560
37897	2577	1551099	1991-02-07	1991-02-07	1	7707
61659	4208	1125315	1984-07-21	1984-08-11	1	5336
30970	2091	738818	1967-12-31	1968-01-07	1	-725
71283	4867	1125315	2001-07-17	2001-07-24	1	11527
36184	2460	1125315	1991-04-04	1991-04-18	1	7777
71481	4881	1322184	2017-03-05	2017-03-05	1	17230
39249	2669	1713332	1996-11-21	1996-11-28	1	9828
38620	2626	1713332	1992-11-11	1992-12-02	1	8371
35460	2412	738818	1985-10-20	1985-10-27	1	5778
73361	5015	1112807	1970-11-21	1971-02-19	1	414
40298	2740	1713332	1973-06-22	1973-06-29	1	1275
75845	5193	1326303	2015-09-24	2015-09-24	1	16702
30743	2080	1713332	2000-07-05	2000-09-20	1	11220
38696	2630	1174888	1978-01-14	1978-01-14	1	2935
76130	5207	920293	1980-02-20	1980-03-05	2	3716
68217	4656	1545958	2014-05-11	2014-05-11	1	16201
46174	3134	1112807	1949-06-04	1949-07-09	1	-7481
37737	2564	1125315	2002-09-24	2002-10-08	1	11968
50108	3413	19127890	1986-03-23	1987-03-18	1	6285
34611	2342	1759842	2010-03-19	2010-04-09	1	14708
71905	4913	1125315	2017-09-23	2017-10-07	1	17446
62639	4276	1125315	1977-07-17	1977-10-15	2	2844
53340	3631	1119510	2015-03-22	2015-03-29	1	16523
42478	2878	19127890	2000-07-20	2001-07-15	1	11518
44819	3040	1125315	1985-06-17	1985-07-01	1	5660
34638	2344	1112807	1983-09-02	1983-09-16	1	5006
27260	1843	1125315	1992-04-21	1992-05-12	1	8167
48143	3268	1177480	2013-07-25	2013-08-15	1	15932
37116	2526	1124300	2012-12-28	2012-12-28	1	15702
43178	2921	1177480	2005-11-09	2005-11-30	1	13117
39289	2673	1125315	2009-03-21	2009-03-21	1	14324
4148	283	1154343	1984-09-07	1984-09-07	1	5363
31386	2123	1728416	1953-12-20	1954-01-03	1	-5842
55788	3796	1713332	1982-03-16	1982-03-23	1	4464
59010	4020	1729720	1979-04-04	1979-04-14	1	3390
35415	2406	1729720	1975-05-30	1975-06-10	1	1986
38241	2599	1549786	1998-01-01	1999-12-22	2	10947
39438	2682	1118084	2016-05-25	2016-05-25	1	16946
48535	3300	1521369	1997-07-27	1998-07-22	1	10429
32769	2220	1118084	1987-07-23	1987-07-23	1	6412
33505	2277	1112807	1971-04-07	1971-07-06	1	551
38196	2597	1112807	1973-01-12	1973-01-26	1	1121
8655	600	1115008	2002-01-20	2002-04-20	1	11797
45339	3077	933724	2011-07-07	2011-07-14	1	15169
76981	5259	1125315	1987-09-05	1987-09-12	1	6463
38079	2589	1118084	2015-10-30	2015-10-30	1	16738
6024	411	1125315	1970-08-03	1970-08-17	1	228
34287	2326	1125315	2008-06-03	2008-06-17	1	14047
71261	4865	1124300	2013-06-09	2013-06-09	1	15865
39949	2712	1125315	1995-10-30	1995-11-13	1	9447
37898	2577	1738521	1976-08-24	1976-09-07	1	2441
61660	4208	738818	1943-10-15	1943-10-29	1	-9561
30971	2091	1125315	1967-12-31	1968-01-07	1	-725
71284	4867	1177480	1979-09-08	1979-11-07	1	3597
36185	2460	1125315	1988-04-06	1988-04-20	1	6684
71482	4881	1728416	1952-09-18	1952-10-02	1	-6300
39250	2669	1759842	1996-11-21	1996-11-28	1	9828
38621	2626	1729720	2003-12-20	2004-01-02	1	12419
35461	2412	1112807	1952-06-05	1952-06-26	1	-6398
73362	5015	1713332	1970-03-25	1970-04-15	1	104
40299	2740	19127890	1984-11-26	1986-11-16	2	6163
75846	5193	1713332	1986-05-31	1986-06-14	1	6008
30744	2080	1759842	2000-07-05	2000-09-20	1	11220
38697	2630	1177480	1978-01-14	1978-02-13	1	2965
76131	5207	933724	1980-02-20	1980-03-05	1	3716
68218	4656	1557272	2009-11-08	2009-11-08	1	14556
46175	3134	1307863	2007-02-15	2007-02-15	1	13559
37738	2564	1549786	1999-07-02	2000-06-26	1	11134
50109	3413	738818	2009-03-12	2009-03-19	1	14322
34612	2342	920293	2010-02-08	2010-02-15	1	14655
71906	4913	1521369	1988-04-14	1989-04-09	1	7038
62640	4276	1125315	1995-08-07	1995-08-21	1	9363
53341	3631	1177480	2006-04-19	2006-05-03	1	13271
42479	2878	1125315	1984-03-06	1984-03-27	1	5199
44820	3040	1759842	1973-08-26	1973-09-02	1	1340
34639	2344	1503184	1984-02-18	1985-02-12	1	5521
27261	1843	1125315	2012-06-04	2012-06-11	1	15502
48144	3268	1759842	1992-08-14	1992-10-30	1	8338
37117	2526	1713332	2002-06-04	2002-06-11	1	11849
43179	2921	1759842	1950-10-19	1950-10-26	1	-7007
39290	2673	1150770	1982-02-27	1982-02-27	1	4440
4149	283	1515774	1995-08-24	1998-08-08	3	10446
31387	2123	738818	1954-03-28	1954-04-11	1	-5744
55789	3796	1713332	2019-02-28	2019-03-14	1	17969
59011	4020	1729720	1991-03-08	1991-03-16	1	7744
35416	2406	914335	1961-05-11	1961-05-11	1	-3157
38242	2599	1595799	1998-01-01	1999-12-22	2	10947
39439	2682	1125315	1989-09-24	1989-10-29	1	7241
48536	3300	1729720	1997-04-17	1997-04-28	1	9979
32770	2220	1119510	1978-06-20	1978-07-04	1	3106
33506	2277	1125315	2005-10-09	2005-10-23	1	13079
38197	2597	1125315	1981-08-30	1981-09-13	1	4273
8656	600	1118084	1987-08-21	1987-08-21	1	6441
45340	3077	1112807	1965-04-18	1965-05-16	1	-1691
76982	5259	1713332	2012-02-01	2012-02-22	1	15392
38080	2589	1521369	2001-02-25	2002-02-20	1	11738
6025	411	1125315	1973-11-17	1973-12-01	1	1430
34288	2326	1177480	1990-09-16	1990-10-07	1	7584
71262	4865	1125315	1980-06-29	1980-07-06	1	3839
39950	2712	1713332	1987-07-18	1987-08-08	1	6428
37899	2577	975125	1980-02-23	1980-03-15	1	3726
61661	4208	914335	1981-04-07	1981-04-07	1	4114
30972	2091	1125315	1979-07-29	1979-08-12	1	3510
71285	4867	1347450	2009-08-26	2009-08-26	1	14482
36186	2460	1503184	2000-07-29	2001-07-24	1	11527
71483	4881	1729720	1957-05-10	1957-05-17	1	-4612
39251	2669	1125315	2018-03-08	2018-04-12	1	17633
38622	2626	1759842	1992-11-11	1992-12-02	1	8371
35462	2412	1125315	1982-11-16	1982-12-14	1	4730
73363	5015	1778162	1983-05-10	1983-05-24	1	4891
41796	2833	701322	2009-02-12	2009-02-12	1	14287
75847	5193	1307863	2015-09-24	2015-09-24	1	16702
30745	2080	1119510	2009-04-09	2009-04-23	1	14357
38698	2630	1177480	2013-03-30	2013-04-29	1	15824
76132	5207	1112807	1957-12-31	1958-01-14	1	-4370
68219	4656	1713332	2008-10-29	2008-11-05	1	14188
46176	3134	1713332	2001-08-18	2001-09-01	1	11566
37739	2564	1713332	1979-07-07	1979-07-21	1	3488
50110	3413	1125315	2017-02-28	2017-03-14	1	17239
34613	2342	1125315	1976-09-10	1976-09-17	1	2451
71907	4913	1713332	2010-01-21	2010-01-28	1	14637
62641	4276	1177480	2005-05-21	2005-07-20	1	12984
53342	3631	1118084	2010-08-06	2010-08-06	1	14827
42480	2878	1177480	1994-06-01	1994-06-22	1	8938
44821	3040	738818	2010-07-01	2010-07-08	1	14798
34640	2344	1503184	1988-01-28	1989-01-22	1	6961
27262	1843	1125315	2014-04-03	2014-04-17	1	16177
39286	2672	1125315	1958-08-17	1958-08-31	1	-4141
37118	2526	1759842	2002-06-04	2002-06-11	1	11849
43180	2921	1125315	1989-05-07	1989-05-07	1	7066
39291	2673	1177480	2009-03-21	2009-05-20	1	14384
4150	283	1177480	1986-12-29	1987-01-19	1	6227
31388	2123	933724	2007-05-20	2007-05-27	1	13660
55790	3796	1738521	1968-11-08	1968-11-22	1	-405
59012	4020	1112807	1968-02-18	1968-03-03	1	-669
35417	2406	1112807	1947-04-11	1947-04-25	1	-8287
38243	2599	1125315	1981-09-10	1981-09-24	1	4284
39440	2682	1125315	2009-12-01	2009-12-08	1	14586
48537	3300	920293	2018-09-12	2018-09-26	2	17800
32771	2220	1124957	2005-02-04	2005-02-04	1	12818
33507	2277	1717327	1970-10-15	1970-10-29	1	301
38198	2597	1713332	1997-06-24	1997-07-08	1	10050
8657	600	1125315	1978-03-30	1978-04-13	1	3024
45341	3077	1119510	2007-10-09	2007-10-23	1	13809
76983	5259	1729720	1973-08-24	1973-09-04	1	1342
38081	2589	1759842	1998-09-01	1998-10-13	1	10512
6026	411	1759842	2017-09-20	2017-10-04	1	17443
34289	2326	1177480	2000-07-21	2000-08-04	1	11173
71263	4865	1125315	1991-01-11	1991-02-01	1	7701
39951	2712	1713332	1988-09-08	1988-09-29	1	6846
37900	2577	975125	1989-11-22	1989-12-13	1	7286
61662	4208	1125315	1943-10-15	1943-10-29	1	-9561
30973	2091	1125315	1988-06-25	1988-07-16	1	6771
71286	4867	1759842	1949-03-15	1949-03-29	1	-7583
36187	2460	1518198	2003-07-14	2004-07-08	1	12607
71484	4881	1124957	1981-12-25	1981-12-25	1	4376
39252	2669	1759842	1987-11-10	1987-12-01	1	6543
38623	2626	1115008	2018-05-07	2018-05-21	1	17672
35463	2412	1713332	1970-07-23	1970-08-13	1	224
73364	5015	1125315	1977-11-16	1977-11-30	1	2890
41797	2833	1177480	1977-08-04	1977-08-18	1	2786
75848	5193	1729720	1965-09-29	1965-10-09	1	-1545
30746	2080	1154343	1982-10-18	1982-10-18	1	4673
38699	2630	1713332	2007-04-26	2007-05-31	1	13664
76133	5207	1118084	1995-03-22	1995-03-22	1	9211
68220	4656	1112807	1966-11-09	1967-01-08	1	-1089
46293	3144	1119510	1992-03-10	1992-03-24	1	8118
37740	2564	19127890	1992-08-07	1993-08-02	1	8614
50111	3413	1713332	1980-05-14	1980-06-25	1	3828
34614	2342	1125315	2012-04-20	2012-04-27	1	15457
71908	4913	1729720	2018-03-02	2018-03-12	1	17602
65743	4491	1112807	1952-02-02	1952-05-02	1	-6453
53343	3631	1713332	1980-11-03	1980-11-17	1	3973
42481	2878	1713332	1982-05-16	1982-05-30	1	4532
44822	3040	1119510	2010-07-01	2010-07-08	1	14798
34641	2344	1728416	1970-10-04	1970-10-18	1	290
27263	1843	1150770	1982-09-26	1982-09-26	1	4651
39287	2672	1759842	1991-02-09	1991-03-02	1	7730
37119	2526	1125315	1996-06-30	1996-09-05	1	9744
43181	2921	1124300	1979-05-25	1979-05-25	1	3431
39292	2673	1515774	1993-01-24	1994-01-19	1	8784
4151	283	1549786	1995-08-24	1998-08-08	3	10446
31389	2123	1125315	1954-03-28	1954-04-11	1	-5744
55791	3796	1759842	1982-03-16	1982-03-23	1	4464
59013	4020	1124300	1999-03-11	1999-03-11	1	10661
35418	2406	1119510	1965-10-05	1965-10-19	1	-1535
38244	2599	1125315	1984-10-28	1984-11-27	1	5444
39441	2682	1125315	2017-02-04	2017-02-04	1	17201
48538	3300	933724	2018-09-12	2018-09-26	1	17800
32772	2220	1125315	1991-06-07	1991-06-14	1	7834
33508	2277	1112807	1970-10-15	1970-10-29	1	301
38199	2597	738818	2001-06-05	2001-06-12	1	11485
8658	600	1125315	1984-09-09	1984-09-30	1	5386
45342	3077	1125315	1963-03-02	1963-03-30	1	-2469
76984	5259	1729720	1994-09-03	1994-09-15	1	9023
38082	2589	1595799	2001-02-25	2002-02-20	1	11738
6027	411	1112807	1980-08-29	1980-09-28	1	3923
34290	2326	1177480	2015-10-15	2015-11-12	1	16751
71264	4865	1729720	1991-10-26	1991-11-02	1	7975
39952	2712	1717327	1964-05-29	1964-06-12	1	-2029
37901	2577	975125	1995-04-22	1995-05-06	1	9256
61663	4208	1174888	2013-10-04	2013-10-04	1	15982
30974	2091	1125315	1995-12-27	1996-01-10	1	9505
71287	4867	1112807	1926-11-01	1927-01-30	1	-15677
36188	2460	1124300	2018-02-16	2018-02-16	1	17578
71485	4881	1125315	1981-12-18	1982-02-23	2	4436
39253	2669	1125315	1980-05-22	1980-05-29	1	3801
38624	2626	1125315	1991-08-04	1991-09-03	1	7915
35464	2412	1728416	1951-02-20	1951-03-06	1	-6876
73365	5015	1125315	1991-04-26	1991-05-17	1	7806
41798	2833	1713332	1959-09-13	1959-09-27	1	-3749
75849	5193	1759842	1986-05-31	1986-06-14	1	6008
31531	2134	738818	2013-11-14	2013-11-21	1	16030
38700	2630	1118084	1999-07-28	1999-07-28	1	10800
76134	5207	1125315	1969-03-03	1969-04-07	1	-269
68221	4656	1125315	2014-05-11	2014-05-11	1	16201
46294	3144	1759842	2003-08-06	2003-08-20	1	12284
37741	2564	1118084	2018-12-24	2018-12-24	1	17889
50112	3413	1713332	2006-10-27	2006-11-17	1	13469
34615	2342	19127890	1989-01-13	1990-01-08	1	7312
71909	4913	1759842	2010-01-21	2010-01-28	1	14637
65744	4491	1125315	1975-05-02	1975-05-23	1	1968
53344	3631	1713332	2002-02-20	2002-03-06	1	11752
42482	2878	1713332	2004-05-24	2004-06-07	1	12576
44823	3040	1125315	2010-07-01	2010-07-08	1	14798
34642	2344	920293	2008-03-31	2008-04-07	1	13976
27264	1843	1595799	2004-06-29	2005-06-24	1	12958
42728	2895	1112807	1962-04-16	1962-04-30	1	-2803
37120	2526	1125315	2014-04-23	2014-05-21	1	16211
43182	2921	1112807	1941-01-22	1941-02-05	1	-10557
39293	2673	1515774	1995-01-14	1996-01-09	1	9504
4152	283	1759842	2004-03-06	2004-03-13	1	12490
31390	2123	1125315	1967-01-24	1967-01-31	1	-1066
55792	3796	738818	2016-09-07	2016-09-14	1	17058
59014	4020	1125315	1972-09-08	1972-09-22	2	995
35419	2406	1125315	1958-01-20	1958-02-17	1	-4336
38245	2599	19127890	1993-01-19	1994-01-14	1	8779
39442	2682	1759842	2014-11-01	2014-11-15	1	16389
48539	3300	1119510	1983-05-03	1983-05-10	1	4877
32773	2220	1713332	1976-03-20	1976-04-03	1	2284
33509	2277	1112807	1987-07-12	1987-08-02	1	6422
38200	2597	1125315	2008-10-05	2008-10-12	1	14164
8659	600	1125315	2012-08-25	2012-09-15	1	15598
45343	3077	1125315	2007-10-09	2007-10-23	1	13809
41007	2782	715997	1997-02-18	1997-02-18	1	9910
38083	2589	1713332	1998-09-01	1998-10-13	1	10512
6028	411	1119510	1973-11-17	1973-12-01	1	1430
34291	2326	1728416	1952-10-30	1952-11-13	1	-6258
71265	4865	1177480	1974-12-26	1975-01-23	1	1848
39953	2712	1717327	1966-09-05	1966-09-19	1	-1200
37902	2577	975125	2012-10-04	2012-10-18	1	15631
61664	4208	1309944	1981-04-07	1981-04-07	1	4114
30975	2091	1125315	2004-01-01	2004-01-15	1	12432
71288	4867	1112807	1968-09-21	1968-10-05	1	-453
36189	2460	1125315	2012-10-11	2012-10-18	1	15631
71486	4881	1112807	1952-09-18	1952-10-02	1	-6300
39254	2669	1125315	1982-09-17	1982-10-01	1	4656
38625	2626	1177480	1976-01-25	1976-03-25	1	2275
35465	2412	1112807	1951-05-21	1951-06-11	1	-6779
73366	5015	1177480	2002-05-19	2002-06-09	1	11847
41799	2833	1713332	2001-04-28	2001-05-05	1	11447
75850	5193	1322184	2010-06-10	2010-06-10	1	14770
31532	2134	1119510	2013-11-14	2013-11-21	1	16030
38701	2630	1119510	1975-05-01	1975-05-15	1	1960
76135	5207	19127890	1978-11-21	1980-11-10	2	3966
68222	4656	1361711	1959-09-20	2008-06-29	1	14059
46295	3144	1119510	1974-11-16	1974-11-30	1	1794
37742	2564	1119510	2002-09-24	2002-10-08	1	11968
50113	3413	19127890	1980-04-23	1981-04-18	1	4125
34616	2342	933724	2010-02-08	2010-02-15	1	14655
71910	4913	19127890	1988-04-14	1989-04-09	1	7038
65745	4491	920293	1976-02-22	1976-02-29	1	2250
53345	3631	1759842	1980-11-03	1980-11-17	1	3973
42483	2878	1729720	1981-09-21	1981-09-30	1	4290
44824	3040	1713332	1973-08-26	1973-09-02	1	1340
34643	2344	1112807	1970-10-04	1970-10-18	1	290
27265	1843	1713332	2013-04-23	2013-05-14	1	15839
42729	2895	1125315	1959-12-13	1959-12-20	1	-3665
37121	2526	1177480	2004-05-17	2004-05-31	1	12569
43183	2921	1112807	1941-05-14	1941-06-04	1	-10438
39294	2673	1549786	1995-01-14	1996-01-09	1	9504
4153	283	19127890	1995-08-24	1998-08-08	3	10446
31391	2123	1125315	1980-03-30	1980-04-06	1	3748
55793	3796	1112807	1971-12-23	1972-01-06	1	735
59015	4020	1759842	1979-10-28	1979-11-04	1	3594
35936	2442	1118084	2008-09-19	2008-09-19	1	14141
40426	2749	1119510	1966-09-19	1966-09-26	1	-1193
39443	2682	1125315	1974-08-10	1974-08-24	1	1696
48540	3300	1154343	1985-08-11	1985-08-11	1	5701
32774	2220	738818	1966-12-15	1966-12-22	1	-1106
33510	2277	1124300	2001-03-15	2001-03-15	1	11396
38201	2597	1713332	1990-12-15	1990-12-22	1	7660
8660	600	1729720	1983-08-17	1983-08-29	1	4988
45344	3077	1177480	1978-02-12	1978-02-26	1	2978
41008	2782	1112807	1945-07-03	1945-07-24	1	-8927
41257	2801	738818	1959-04-13	1959-04-20	1	-3909
6029	411	1125315	1980-08-29	1980-08-29	1	3893
34292	2326	1759842	1983-06-25	1983-07-02	1	4930
71266	4865	1759842	1981-08-09	1981-08-30	1	4259
39954	2712	1759842	1974-03-15	1974-03-22	1	1541
37903	2577	1118084	2012-03-18	2012-03-18	1	15417
61665	4208	1343916	1981-04-07	1981-04-07	1	4114
30976	2091	1713332	1967-09-08	1967-09-15	1	-839
71289	4867	1115008	1995-04-01	1995-06-30	1	9311
36190	2460	1149380	1988-08-14	1988-08-14	1	6800
71487	4881	1125315	1994-04-19	1994-05-17	1	8902
39255	2669	1125315	2010-03-19	2010-03-26	1	14694
38626	2626	1717327	1966-07-03	1966-07-17	1	-1264
35466	2412	1119510	1985-10-20	1985-10-27	1	5778
73367	5015	1713332	2017-12-23	2017-12-30	1	17530
41800	2833	738818	2011-08-28	2011-09-04	1	15221
77317	5285	1112807	1970-04-13	1970-04-27	1	116
31533	2134	1125315	2013-11-14	2013-11-21	1	16030
38702	2630	1125315	1980-04-27	1980-05-04	1	3776
76136	5207	1125315	1960-09-05	1960-09-19	1	-3391
68223	4656	1539403	1991-09-22	1991-09-22	1	7934
46296	3144	1125315	1965-02-18	1965-02-25	1	-1771
37743	2564	1177480	2009-12-22	2010-01-19	1	14628
50114	3413	1118084	2001-07-07	2001-07-07	1	11510
34617	2342	1125315	1985-06-27	1985-07-11	1	5670
71911	4913	1119510	2017-09-23	2017-10-07	1	17446
65746	4491	933724	1976-02-22	1976-02-29	1	2250
53346	3631	1759842	2002-02-20	2002-03-06	1	11752
42484	2878	1112807	1993-07-08	1993-08-05	1	8617
47566	3230	1118084	1997-08-03	1997-08-03	1	10076
34644	2344	1521369	1984-02-18	1985-02-12	1	5521
27266	1843	1124957	1997-03-17	1997-03-17	1	9937
42730	2895	1713332	1960-07-14	1960-07-28	1	-3444
37122	2526	1738521	1976-08-14	1976-08-28	1	2431
43184	2921	1112807	1964-07-03	1964-07-17	1	-1994
39295	2673	1759842	1979-06-06	1979-06-13	1	3450
4154	283	1149380	1984-09-07	1984-09-07	1	5363
31392	2123	1125315	1984-06-17	1984-07-15	1	5309
55794	3796	1119510	1986-05-03	1986-05-17	1	5980
59016	4020	1759842	1996-04-26	1996-05-17	1	9633
35937	2442	1125315	1975-07-31	1975-08-07	1	2044
40427	2749	1125315	1980-08-09	1980-09-13	1	3908
39444	2682	1125315	1977-03-06	1977-03-13	1	2628
48541	3300	1759842	2004-06-08	2004-06-22	1	12591
32775	2220	738818	1973-10-06	1973-10-13	1	1381
33511	2277	1125315	1970-03-13	1970-03-27	1	85
38202	2597	1759842	1990-12-15	1990-12-22	1	7660
8661	600	738818	1960-06-04	1960-06-11	1	-3491
45345	3077	1322184	2014-11-26	2014-11-26	1	16400
41009	2782	1112807	1955-05-03	1955-07-09	1	-5290
41258	2801	836654	1996-07-05	1996-07-05	1	9682
6030	411	1125315	1982-06-01	1982-06-15	1	4548
35977	2444	1125315	1965-04-23	1965-05-07	1	-1700
74572	5101	933724	1996-01-18	1996-01-25	1	9520
39955	2712	1759842	1987-07-18	1987-08-08	1	6428
37904	2577	19010482	2013-10-18	2013-11-08	1	16017
61666	4208	1759842	1999-11-28	1999-12-12	1	10937
30977	2091	1713332	1968-10-04	1968-10-18	1	-440
71290	4867	1118084	1950-01-14	1950-01-14	1	-7292
36191	2460	1177480	1986-03-31	1986-04-14	1	5947
71488	4881	1729720	2018-03-14	2018-03-24	1	17614
39256	2669	1713332	1987-11-10	1987-12-01	1	6543
38627	2626	1115008	2014-01-05	2014-01-19	1	16089
35467	2412	1118084	1994-12-01	1994-12-01	1	9100
73368	5015	1738521	1968-04-05	1968-04-19	1	-622
41801	2833	757627	2008-02-18	2008-02-18	1	13927
77318	5285	1125315	1968-12-20	1968-12-27	1	-370
31534	2134	1322184	2017-04-02	2017-04-02	1	17258
38703	2630	1125315	2007-04-26	2007-05-31	1	13664
76137	5207	1125315	1967-01-15	1967-01-22	1	-1075
68224	4656	1112807	1963-05-15	1963-05-29	1	-2409
46297	3144	1125315	1965-05-02	1965-05-16	1	-1691
37744	2564	1515774	1992-08-07	1993-08-02	1	8614
50115	3413	1119510	2009-03-12	2009-03-19	1	14322
34618	2342	1503184	1989-01-13	1990-01-08	1	7312
71912	4913	1124300	2004-05-25	2004-05-25	1	12563
65747	4491	1112807	1949-11-23	1949-12-14	1	-7323
55522	3779	1115008	2003-06-10	2003-07-08	1	12241
42485	2878	1118084	2019-04-02	2019-04-02	1	17988
47567	3230	1125315	2018-04-02	2018-04-16	1	17637
34645	2344	1521369	1988-01-28	1989-01-22	1	6961
27267	1843	1515774	2002-07-10	2003-07-05	1	12238
42731	2895	975125	1985-12-27	1985-12-27	1	5839
37123	2526	1738521	1977-04-28	1977-05-12	1	2688
43185	2921	1124957	1989-05-07	1989-05-07	1	7066
39296	2673	920293	2014-03-12	2014-03-19	1	16148
4155	283	1177480	2010-10-29	2010-11-12	1	14925
31393	2123	1125315	1991-07-25	1991-08-08	1	7889
55795	3796	1119510	2010-08-18	2010-09-01	1	14853
59017	4020	738818	1965-02-23	1965-03-02	1	-1766
35938	2442	1154343	1973-06-27	1973-06-27	1	1273
40428	2749	1112807	1966-08-18	1966-11-16	1	-1142
39445	2682	1177480	1978-01-20	1978-02-03	1	2955
48542	3300	1125315	1983-05-03	1983-05-10	1	4877
32776	2220	1112807	1942-05-15	1942-05-29	1	-10079
33512	2277	1125315	1977-04-05	1977-05-05	1	2681
40644	2761	1125315	2006-11-20	2006-11-27	1	13479
8662	600	1125315	1960-06-04	1960-06-11	1	-3491
882	61	1112807	1974-03-20	1974-04-24	1	1574
41010	2782	1118084	1955-03-30	1955-03-30	1	-5391
41259	2801	1125315	1959-04-13	1959-04-20	1	-3909
6031	411	1125315	2005-10-13	2005-10-27	1	13083
35978	2444	1125315	2011-01-18	2011-01-25	1	14999
74573	5101	1102527	2002-12-17	2002-12-17	1	12038
39956	2712	1759842	1988-09-08	1988-09-29	1	6846
37905	2577	738818	1992-01-17	1992-01-31	1	8065
63374	4330	738818	1959-06-13	1959-06-27	1	-3841
30978	2091	1713332	2004-07-17	2004-07-31	1	12630
71291	4867	1125315	1926-11-01	1926-11-01	1	-15767
36192	2460	1515774	2002-07-19	2003-07-14	1	12247
71489	4881	1125315	1967-09-28	1967-11-02	1	-791
42793	2898	920293	2015-03-30	2015-04-06	1	16531
38628	2626	1119510	2018-08-15	2018-08-22	1	17765
35468	2412	1125315	1985-10-20	1985-10-27	1	5778
73369	5015	1759842	2017-12-23	2017-12-30	1	17530
41802	2833	1119510	1980-04-01	1980-04-08	1	3750
77319	5285	1759842	2013-09-08	2013-09-29	1	15977
31535	2134	1713332	1959-08-26	1959-09-16	1	-3760
38704	2630	1125315	2008-08-22	2008-08-29	1	14120
76138	5207	1125315	1997-09-13	1997-09-27	1	10131
68225	4656	1124957	1966-11-09	1966-11-09	1	-1149
46298	3144	1713332	1990-11-03	1990-11-24	1	7632
37745	2564	1549786	1992-08-07	1993-08-02	1	8614
50116	3413	1125315	1975-08-08	1975-09-07	1	2075
34619	2342	1713332	2010-03-19	2010-04-09	1	14708
71913	4913	1125315	1979-05-24	1979-05-31	1	3437
65748	4491	1125315	1984-04-25	1984-05-02	1	5235
55523	3779	1738521	1975-02-07	1975-02-21	1	1877
42486	2878	1125315	2000-07-20	2000-08-03	1	11172
47568	3230	1713332	2000-07-16	2000-08-06	1	11175
34646	2344	933724	2008-03-31	2008-04-07	1	13976
27268	1843	1589505	2005-06-24	2006-06-19	1	13318
42732	2895	1112807	1961-11-01	1961-11-15	1	-2969
37124	2526	1102527	1996-07-07	1996-07-07	1	9684
43186	2921	1137529	1978-06-13	1978-06-13	1	3085
39297	2673	1125315	2007-10-30	2007-11-13	1	13830
4156	283	1713332	2004-03-06	2004-03-13	1	12490
31394	2123	1125315	1994-10-21	1994-12-27	2	9126
55796	3796	1125315	2016-09-07	2016-09-14	1	17058
59018	4020	1112807	1959-12-11	1960-01-01	1	-3653
35939	2442	1729720	1979-12-18	1979-12-28	1	3648
40429	2749	1118084	1994-04-08	1994-04-08	1	8863
39446	2682	1124957	2017-02-04	2017-02-04	1	17201
48543	3300	1149380	1985-08-11	1985-08-11	1	5701
32777	2220	1125315	1966-12-15	1966-12-22	1	-1106
33513	2277	1125315	1977-10-04	1977-10-18	1	2847
40645	2761	1177480	1984-09-25	1984-10-09	1	5395
8663	600	1125315	2018-07-16	2018-09-21	2	17795
883	61	1118084	2005-08-29	2005-08-29	1	13024
41011	2782	1125315	1962-11-19	1962-11-26	1	-2593
41260	2801	1729720	1926-04-30	1926-05-08	1	-15944
6032	411	1177480	1981-10-23	1981-11-13	1	4334
35979	2444	1322184	2013-08-11	2013-08-11	1	15928
74574	5101	1112807	1962-02-01	1962-02-15	1	-2877
39957	2712	1112807	1968-12-04	1968-12-25	1	-372
37906	2577	1115008	2013-02-02	2013-02-23	1	15759
63375	4330	1112807	1951-06-15	1951-06-29	1	-6761
30979	2091	1759842	2004-07-17	2004-07-31	1	12630
71292	4867	1125315	1987-05-29	1987-07-28	1	6417
36193	2460	1521369	2000-07-29	2001-07-24	1	11527
71490	4881	1347450	2017-03-05	2017-03-05	1	17230
42794	2898	1521369	1993-01-12	1994-01-07	1	8772
38629	2626	1125315	1981-11-07	1981-11-14	1	4335
35469	2412	1125315	1990-11-02	1990-11-16	1	7624
75710	5185	1125315	1956-07-09	1956-07-23	1	-4910
41803	2833	1119510	2011-08-28	2011-09-04	1	15221
77320	5285	1759842	2014-10-31	2014-11-21	1	16395
31536	2134	1125315	1978-08-21	1978-09-04	1	3168
38705	2630	1713332	2006-10-29	2006-11-05	1	13457
76139	5207	1125315	2001-07-21	2001-07-28	1	11531
68226	4656	1125315	1989-05-12	1989-06-02	1	7092
46299	3144	1759842	1990-11-03	1990-11-24	1	7632
37746	2564	1549786	1996-07-17	1997-07-12	1	10054
50117	3413	1125315	2009-03-12	2009-03-19	1	14322
34620	2342	1738521	1978-09-13	1978-09-27	1	3191
71914	4913	1125315	1995-12-17	1995-12-31	1	9495
65749	4491	1125315	2018-06-08	2018-06-22	1	17704
55524	3779	19127890	1988-03-10	1989-03-05	1	7003
42487	2878	1521369	1997-08-05	1998-07-31	1	10438
47569	3230	738818	2018-04-02	2018-04-16	1	17637
34647	2344	1713332	1988-10-18	1988-11-08	1	6886
27269	1843	1589505	2007-06-14	2008-06-08	1	14038
42733	2895	1119510	1962-02-08	1962-02-22	1	-2870
37125	2526	1112807	1977-04-28	1977-05-12	1	2688
43187	2921	1713332	1950-10-19	1950-10-26	1	-7007
39298	2673	1174888	2009-03-21	2009-03-21	1	14324
4157	283	1729720	1984-02-15	1984-02-25	1	5168
31395	2123	1177480	1995-10-23	1995-12-22	1	9486
58609	3997	1112807	1967-09-17	1967-10-08	1	-816
59019	4020	1125315	1964-07-19	1964-07-26	1	-1985
35940	2442	1125315	2012-06-24	2012-07-08	1	15529
40430	2749	1125315	1983-05-31	1983-06-21	1	4919
39447	2682	1125315	1978-05-20	1978-06-24	1	3096
48544	3300	19127890	1997-07-27	1998-07-22	1	10429
32778	2220	1125315	1973-10-06	1973-10-13	1	1381
33514	2277	1125315	1992-07-06	1992-07-20	1	8236
40646	2761	1119510	1982-09-08	1982-09-15	1	4640
8664	600	1124957	2018-07-23	2018-07-23	1	17735
884	61	1125315	1969-12-23	1970-01-06	1	5
41012	2782	1717327	1964-01-07	1964-01-28	1	-2165
41261	2801	1112807	1925-02-01	1925-03-08	1	-16370
6033	411	1713332	1968-09-28	1968-10-12	1	-446
35980	2444	1112807	1963-02-26	1963-05-04	1	-2434
74575	5101	1125315	1962-07-01	1962-07-22	1	-2720
39958	2712	1125315	1978-11-13	1978-11-20	1	3245
37907	2577	1125315	1988-09-21	1988-10-05	1	6852
63376	4330	1112807	1963-09-01	1963-11-30	1	-2224
30980	2091	1728416	1965-06-12	1965-06-26	1	-1650
71293	4867	1322184	2009-08-26	2009-08-26	1	14482
36194	2460	1549786	2002-07-19	2004-07-08	2	12607
71491	4881	1729720	1992-03-16	1992-03-29	1	8123
42795	2898	1521369	1995-01-02	1995-12-28	1	9492
38630	2626	1713332	2018-05-07	2018-05-21	1	17672
35470	2412	1125315	2009-06-11	2009-06-18	1	14413
75711	5185	1125315	1989-01-01	1989-04-01	2	6940
41804	2833	1125315	1979-12-20	1980-01-10	1	3661
77321	5285	1322184	2007-02-25	2008-07-06	1	14066
31537	2134	1125315	1997-02-08	1997-02-22	1	9914
38706	2630	1759842	1988-11-24	1988-12-01	1	6909
76140	5207	1503184	1978-11-21	1980-11-10	2	3966
68227	4656	1125315	2009-08-29	2009-09-12	1	14499
46300	3144	738818	1992-03-10	1992-03-24	1	8118
37747	2564	1595799	1999-07-02	2000-06-26	1	11134
50118	3413	1503184	1980-04-23	1981-04-18	1	4125
35145	2384	933724	2013-03-25	2013-04-01	1	15796
71915	4913	1177480	2002-06-04	2002-07-09	1	11877
65750	4491	1729720	2015-02-09	2015-02-19	1	16485
55525	3779	738818	1975-08-07	1975-08-14	1	2051
42488	2878	1521369	2000-07-20	2001-07-15	1	11518
47570	3230	1112807	1962-09-07	1962-10-05	1	-2645
34648	2344	1713332	1990-02-06	1990-02-20	1	7355
27270	1843	19127890	2001-07-15	2003-07-05	2	12238
42734	2895	1150836	1986-01-09	1986-01-09	1	5852
37126	2526	1115008	2012-04-19	2012-05-03	1	15463
43188	2921	1713332	1995-12-24	1995-12-31	1	9495
39299	2673	1549786	1991-02-04	1992-01-30	1	8064
4158	283	1124300	2018-10-12	2018-10-12	1	17816
31396	2123	1557272	2009-06-19	2009-06-19	1	14414
58610	3997	1125315	1979-06-07	1979-06-21	1	3458
59020	4020	1125315	1965-02-23	1965-03-02	1	-1766
35941	2442	1713332	1981-06-10	1981-07-01	1	4199
40431	2749	1125315	1991-03-21	1991-03-28	1	7756
39448	2682	1125315	2014-07-16	2014-07-30	1	16281
48545	3300	738818	1983-05-03	1983-05-10	1	4877
32779	2220	1759842	1976-03-20	1976-04-03	1	2284
34874	2358	1125315	1977-10-04	1977-10-18	1	2847
40647	2761	1125315	2011-07-06	2011-07-13	1	15168
8665	600	1125315	1994-11-07	1994-11-28	1	9097
885	61	1154343	1971-01-27	1971-01-27	1	391
41013	2782	1729720	1922-02-08	1922-02-20	1	-17482
41262	2801	1112807	1928-02-21	1928-03-20	1	-15262
6034	411	1713332	2017-09-20	2017-10-04	1	17443
35981	2444	1115008	2007-12-23	2008-01-20	1	13898
74576	5101	1521369	1974-12-05	1975-11-30	1	2159
39959	2712	1125315	1988-09-26	1988-10-03	1	6850
37908	2577	1125315	1992-01-17	1992-01-31	1	8065
63377	4330	1125315	1959-06-13	1959-06-27	1	-3841
31634	2141	1112807	1956-01-31	1956-03-01	1	-5054
71294	4867	1713332	1932-08-17	1932-08-24	1	-13644
36195	2460	1713332	1986-03-31	1986-04-14	1	5947
72672	4967	1125315	2014-11-19	2014-11-26	1	16400
42796	2898	1521369	1997-12-17	1998-12-12	1	10572
38631	2626	1759842	1986-07-03	1986-07-10	1	6034
35471	2412	1759842	2008-02-14	2008-03-06	1	13944
75712	5185	1174888	1989-01-01	1989-01-01	1	6940
41805	2833	1125315	2011-08-28	2011-09-04	1	15221
77322	5285	1322184	2008-09-21	2008-09-21	1	14143
31538	2134	1125315	2000-08-14	2000-09-11	1	11211
38707	2630	1759842	2005-11-04	2005-11-25	1	13112
76141	5207	1503184	1981-11-05	1982-10-31	1	4686
68228	4656	1174888	2008-06-29	2008-06-29	1	14059
46301	3144	933724	1998-06-24	1998-07-08	1	10415
37748	2564	19127890	1996-07-17	1997-07-12	1	10054
50119	3413	1521369	1986-03-23	1987-03-18	1	6285
35146	2384	1729720	1985-02-19	1985-03-04	1	5541
71916	4913	1503184	1988-04-14	1989-04-09	1	7038
65751	4491	1125315	1992-04-07	1992-06-06	1	8192
55526	3779	1115008	2012-06-20	2012-07-18	1	15539
42489	2878	1549786	1995-08-16	1996-08-10	1	9718
47571	3230	1177480	2006-02-16	2006-03-02	1	13209
34649	2344	1729720	1968-07-02	1968-07-13	1	-537
27271	1843	1115008	1997-03-17	1997-05-16	1	9997
42735	2895	1177480	2003-05-25	2003-06-29	1	12232
37127	2526	1177480	1976-08-14	1976-08-28	1	2431
43189	2921	1759842	1995-12-24	1995-12-31	1	9495
39300	2673	1549786	1993-01-24	1994-01-19	1	8784
4159	283	1177480	2004-06-18	2004-07-02	1	12601
31397	2123	1728416	1958-01-11	1958-01-25	1	-4359
58611	3997	1396131	2018-11-08	2018-11-08	1	17843
59021	4020	1347450	2014-10-02	2014-10-02	1	16345
35942	2442	1713332	2007-05-15	2007-05-22	1	13655
40432	2749	1125315	1961-05-16	1961-05-30	1	-3138
39449	2682	1125315	2017-12-04	2017-12-11	1	17511
48546	3300	1124300	2016-08-16	2016-08-16	1	17029
32780	2220	738818	1947-12-16	1947-12-23	1	-8045
34875	2358	1125315	1984-07-29	1984-08-19	1	5344
40648	2761	1713332	1989-04-20	1989-04-27	1	7056
8666	600	1728416	1954-03-07	1954-03-21	1	-5765
886	61	1503184	1983-01-12	1984-01-07	1	5119
41014	2782	836654	1996-04-24	1996-04-24	1	9610
41263	2801	1112807	1968-10-16	1968-12-15	1	-382
6035	411	1729720	1964-01-07	1964-01-14	1	-2179
35982	2444	1124300	1998-11-14	1998-11-14	1	10544
74577	5101	1759842	1979-11-29	1979-12-06	1	3626
39960	2712	1177480	1978-04-07	1978-05-12	1	3053
37909	2577	1177480	1976-08-24	1976-09-07	1	2441
63378	4330	1125315	1987-11-24	1987-12-08	1	6550
31635	2141	1125315	1961-09-01	1961-10-08	2	-3007
71295	4867	1713332	1935-01-20	1935-02-10	1	-12744
36196	2460	1778162	1988-04-06	1988-04-20	1	6684
72673	4967	1759842	1978-09-02	1978-10-28	1	3222
42797	2898	1551099	1980-03-12	1980-03-12	1	3723
40893	2776	1107830	2005-07-26	2005-07-26	1	12990
35472	2412	1759842	2018-10-15	2018-10-22	1	17826
75713	5185	1177480	2010-09-22	2010-11-21	1	14934
41806	2833	1112807	1975-12-13	1976-01-10	1	2200
77323	5285	1501700	2011-11-19	2011-11-19	1	15297
31539	2134	1125315	2014-09-19	2014-10-03	1	16346
38708	2630	1119510	1980-04-27	1980-05-04	1	3776
76142	5207	19127890	1981-11-05	1982-10-31	1	4686
68229	4656	1322184	1997-10-05	2008-06-29	1	14059
46302	3144	1112807	1964-07-22	1964-08-05	1	-1975
39308	2674	1115008	1996-08-09	1996-08-23	1	9731
50120	3413	1713332	2014-09-15	2014-10-06	1	16349
35147	2384	1118084	2017-03-04	2017-03-04	1	17229
71917	4913	1759842	2005-11-29	2005-12-06	1	13123
65752	4491	1557272	2006-07-09	2006-07-09	1	13338
55527	3779	1125315	1975-08-07	1975-08-14	1	2051
42490	2878	1729720	1986-08-08	1986-08-16	1	6071
47572	3230	1112807	1967-02-11	1967-05-12	1	-965
34650	2344	1759842	1988-10-18	1988-11-08	1	6886
27272	1843	1125315	1984-08-03	1984-08-17	1	5342
42736	2895	1177480	2005-05-19	2005-06-02	1	12936
37861	2574	1125315	1961-05-04	1961-05-18	1	-3150
43653	2949	1112807	1950-10-23	1950-11-06	1	-6996
39301	2673	933724	2014-03-12	2014-03-19	1	16148
4160	283	1729720	1985-01-23	1985-02-02	1	5511
31398	2123	738818	1974-03-12	1974-03-19	1	1538
58612	3997	738818	1983-08-26	1983-09-02	1	4992
59022	4020	1557272	2016-04-28	2016-04-28	1	16919
35943	2442	1729720	1978-05-30	1978-06-08	1	3080
40433	2749	1125315	1974-04-08	1974-04-29	1	1579
39450	2682	1713332	2014-11-01	2014-11-15	1	16389
48547	3300	1589505	1999-07-17	2000-07-11	1	11149
32781	2220	1119510	1966-12-15	1966-12-22	1	-1106
34876	2358	1713332	1981-08-03	1981-08-17	1	4246
40649	2761	1729720	1992-12-23	1992-12-31	1	8400
8667	600	1112807	1954-03-07	1954-03-21	1	-5765
887	61	1713332	1981-05-22	1981-06-12	1	4180
41015	2782	1102527	1955-05-10	1955-05-10	1	-5350
41264	2801	1112807	1984-03-01	1984-05-30	1	5263
6036	411	1124300	2003-03-02	2003-03-02	1	12113
35983	2444	1347450	2013-08-11	2013-08-11	1	15928
74578	5101	1118084	1998-10-10	1998-10-10	1	10509
39961	2712	1713332	1974-03-15	1974-03-22	1	1541
37910	2577	1729720	1976-01-15	1976-01-23	1	2213
63379	4330	1125315	2012-03-20	2012-06-18	1	15509
31636	2141	1174888	1961-09-08	1961-09-08	1	-3037
71296	4867	1759842	1932-08-17	1932-08-24	1	-13644
36197	2460	19127890	2002-07-19	2003-07-14	1	12247
72674	4967	1124300	2003-11-10	2003-11-10	1	12366
42798	2898	1713332	1979-09-13	1979-09-27	1	3556
40894	2776	1119510	1980-09-16	1980-09-30	1	3925
37499	2550	920293	2012-02-08	2012-02-15	1	15385
75714	5185	1713332	1943-11-27	1943-12-04	1	-9525
41807	2833	1118084	1977-05-21	1977-05-21	1	2697
77324	5285	1713332	1982-11-21	1982-11-28	1	4714
31540	2134	1759842	1959-08-26	1959-09-16	1	-3760
38709	2630	1125315	1978-01-14	1978-01-14	1	2935
76143	5207	1177480	1980-12-05	1980-12-26	1	4012
68230	4656	1759842	2008-10-29	2008-11-05	1	14188
46303	3144	1118084	2007-05-03	2007-05-03	1	13636
39309	2674	1118084	2013-07-01	2013-07-01	1	15887
50121	3413	1759842	2014-09-15	2014-10-06	1	16349
35148	2384	920293	2013-03-25	2013-04-01	1	15796
72226	4935	975125	1985-09-27	1985-09-27	1	5748
65753	4491	1112807	1948-04-02	1948-04-16	1	-7930
55528	3779	1177480	1975-02-07	1975-02-21	1	1877
42491	2878	1729720	1986-10-16	1986-10-29	1	6145
47573	3230	1125315	1987-11-05	1987-11-12	1	6524
34651	2344	1759842	1990-02-06	1990-02-20	1	7355
27273	1843	1125315	1997-03-17	1997-03-17	1	9937
42737	2895	1717327	1962-04-16	1962-04-30	1	-2803
37862	2574	1118084	2005-05-08	2005-05-08	1	12911
43654	2949	1177480	2006-08-05	2006-08-19	1	13379
39302	2673	1713332	1979-06-06	1979-06-13	1	3450
10199	701	920293	1990-09-18	1990-09-25	1	7572
31399	2123	920293	2007-05-20	2007-05-27	1	13660
58613	3997	738818	2017-07-22	2017-07-29	1	17376
59023	4020	1713332	1979-10-28	1979-11-04	1	3594
35944	2442	1759842	1981-06-10	1981-07-01	1	4199
40434	2749	1729720	1974-03-17	1974-03-25	1	1544
42307	2867	1177480	1979-06-11	1979-06-25	1	3462
48548	3300	1713332	2004-06-08	2004-06-22	1	12591
32782	2220	1119510	1973-10-06	1973-10-13	1	1381
34877	2358	1713332	2002-07-31	2002-08-21	1	11920
40650	2761	1778162	1984-09-25	1984-10-09	1	5395
8668	600	1119510	1960-06-04	1960-06-11	1	-3491
888	61	1125315	1983-12-03	1984-01-07	1	5119
41016	2782	1310149	1977-01-26	1977-01-26	1	2582
41265	2801	1119510	1930-08-06	1930-08-13	1	-14386
6037	411	1192710	1961-03-13	1961-03-13	1	-3216
35984	2444	1713332	1963-11-21	1963-12-05	1	-2219
74579	5101	1125315	1973-08-23	1973-09-06	1	1344
41207	2798	738818	1988-04-21	1988-04-28	1	6692
37911	2577	19010482	1995-04-22	1995-05-06	1	9256
63380	4330	1713332	2006-06-03	2006-06-24	1	13323
31637	2141	1713332	1950-06-23	1950-07-14	1	-7111
71297	4867	1759842	1935-01-20	1935-02-10	1	-12744
36198	2460	1154343	1988-08-14	1988-08-14	1	6800
72675	4967	1729720	1968-12-07	1968-12-20	1	-377
42799	2898	1713332	1980-03-24	1980-04-07	1	3749
40895	2776	1713332	2016-01-04	2016-01-11	1	16811
37500	2550	1124300	2019-06-26	2019-06-26	1	18073
75715	5185	1112807	1949-08-01	1949-08-15	1	-7444
41808	2833	1717327	1977-08-04	1977-08-18	1	2786
77325	5285	1729720	1971-10-26	1971-11-06	1	674
31541	2134	1125315	1951-07-03	1951-07-17	1	-6743
38710	2630	1125315	1992-07-29	1992-08-12	1	8259
76144	5207	1521369	1978-11-21	1980-11-10	2	3966
68582	4678	738818	2016-07-02	2016-07-16	1	16998
46304	3144	1125315	1966-01-02	1966-01-16	1	-1446
39310	2674	1125315	2006-12-29	2007-01-26	1	13539
51540	3513	920293	2008-04-16	2008-04-23	1	13992
35149	2384	1115008	1998-08-06	1998-08-20	1	10458
72227	4935	1118084	2003-08-01	2003-08-01	1	12265
65754	4491	1112807	1983-04-11	1983-04-25	1	4862
55529	3779	1503184	1988-03-10	1989-03-05	1	7003
44050	2980	738818	1983-05-22	1983-05-29	1	4896
47574	3230	1728416	1957-08-13	1957-08-27	1	-4510
34652	2344	1118084	1999-11-21	1999-11-21	1	10916
27274	1843	1503184	2001-07-15	2002-07-10	1	11878
42738	2895	1728416	1966-04-09	1966-04-23	1	-1349
37863	2574	1125315	1978-12-31	1979-01-14	1	3300
43655	2949	1102527	1974-10-24	1974-10-24	1	1757
39303	2673	19127890	1991-02-04	1992-01-30	1	8064
10200	701	933724	1990-09-18	1990-09-25	1	7572
31400	2123	1112807	1953-12-20	1954-01-03	1	-5842
58614	3997	1125315	2017-07-22	2017-07-29	1	17376
59024	4020	1713332	1996-04-26	1996-05-17	1	9633
35945	2442	1759842	2007-05-15	2007-05-22	1	13655
40435	2749	738818	1966-09-19	1966-09-26	1	-1193
42308	2867	1515774	1996-07-21	1997-07-16	1	10058
49651	3383	1125315	1989-05-31	1989-06-14	1	7104
32783	2220	1119510	2007-01-31	2007-02-07	1	13551
34878	2358	1729720	1973-12-25	1974-01-07	1	1467
40651	2761	1118084	2017-07-04	2017-07-04	1	17351
8669	600	1125315	1956-02-25	1956-03-26	1	-5029
889	61	1551099	1977-03-04	1977-03-04	1	2619
41017	2782	1326303	1977-01-26	1977-01-26	1	2582
41266	2801	1125315	1971-02-17	1971-02-24	1	419
6038	411	1729720	1963-11-28	1963-12-05	1	-2219
35985	2444	1125315	1985-02-02	1985-02-09	1	5518
74580	5101	1125315	1994-04-26	1994-05-03	1	8888
41208	2798	933724	1999-12-12	1999-12-26	1	10951
37912	2577	19010482	2012-10-04	2012-10-18	1	15631
63381	4330	1713332	2015-09-30	2015-10-21	1	16729
31638	2141	1713332	1958-05-03	1958-05-10	1	-4254
71298	4867	1759842	1941-10-12	1941-11-02	1	-10287
36199	2460	19127890	2000-07-29	2001-07-24	1	11527
72676	4967	1125315	1961-06-28	1961-07-12	1	-3095
42800	2898	1713332	1981-04-20	1981-05-04	1	4141
40896	2776	1729720	1989-04-01	1989-04-12	1	7041
37501	2550	1177480	1997-01-02	1997-03-03	1	9923
75716	5185	1125315	1955-03-05	1955-03-12	1	-5409
41809	2833	1759842	1959-09-13	1959-09-27	1	-3749
77326	5285	1759842	1982-11-21	1982-11-28	1	4714
31542	2134	1125315	1955-04-15	1955-04-22	1	-5368
40964	2780	738818	1993-12-13	1993-12-20	1	8754
76145	5207	1713332	1991-01-03	1991-01-24	1	7693
68583	4678	1118084	1991-01-02	1991-01-02	1	7671
46305	3144	1125315	1980-10-31	1980-11-28	1	3984
39311	2674	1713332	2003-06-28	2003-07-26	1	12259
51541	3513	1118084	2007-12-01	2007-12-01	1	13848
35150	2384	1177480	1997-05-13	1997-08-11	1	10084
72228	4935	1124957	1999-02-14	1999-02-14	1	10636
65755	4491	1118084	1984-07-22	1984-07-22	1	5316
55530	3779	1713332	2001-08-15	2001-08-29	1	11563
44051	2980	1118084	2007-11-25	2007-11-25	1	13842
47575	3230	1759842	2000-07-16	2000-08-06	1	11175
34653	2344	1125315	1967-07-07	1967-07-21	1	-895
27275	1843	1519936	2009-06-03	2010-05-29	1	14758
42739	2895	1729720	1967-07-06	1967-07-14	1	-902
37864	2574	1125315	1982-08-31	1982-09-28	1	4653
43656	2949	1112807	1951-03-03	1951-03-17	1	-6865
39304	2673	1125315	2017-07-07	2017-08-11	1	17389
10201	701	1112807	1959-05-07	1959-05-21	1	-3878
31401	2123	1118084	1986-11-29	1986-11-29	1	6176
58615	3997	1713332	1992-08-30	1992-09-13	1	8291
59025	4020	1729720	1979-07-15	1979-07-27	1	3494
35946	2442	1177480	1979-07-09	1979-09-07	1	3536
40436	2749	1115008	2007-10-13	2007-10-27	1	13813
42309	2867	1549786	1996-07-21	1997-07-16	1	10058
49652	3383	1125315	1995-09-27	1995-10-18	1	9421
32784	2220	1125315	1947-12-16	1947-12-23	1	-8045
34879	2358	1759842	2002-07-31	2002-08-21	1	11920
40652	2761	1713332	2007-08-14	2007-08-21	1	13746
8670	600	1125315	1973-06-25	1973-07-09	1	1285
890	61	19127890	1983-01-12	1984-01-07	1	5119
41018	2782	1759842	1989-07-25	1989-08-15	1	7166
41267	2801	1125315	1977-07-31	1977-09-04	1	2803
6039	411	1729720	1971-10-05	1971-10-14	1	651
35986	2444	1759842	1963-11-21	1963-12-05	1	-2219
74581	5101	1125315	2002-12-17	2003-01-16	1	12068
41209	2798	1112807	1958-04-18	1958-06-17	1	-4216
39171	2663	1713332	2015-09-22	2015-10-06	1	16714
63382	4330	1759842	1967-03-26	1967-04-09	1	-998
31639	2141	1713332	1981-06-24	1981-07-08	1	4206
71299	4867	1125315	1918-03-20	1918-03-27	1	-18908
38776	2636	1119510	2011-11-11	2011-11-18	1	15296
72677	4967	1177480	1982-07-08	1982-10-06	1	4661
42801	2898	933724	2012-02-09	2012-02-16	1	15386
40897	2776	1759842	2002-11-01	2002-11-15	1	12006
37502	2550	1503184	1998-01-07	1999-01-02	1	10593
75717	5185	1177480	2002-11-26	2003-01-02	1	12054
41810	2833	738818	1980-04-01	1980-04-08	1	3750
77327	5285	701322	2017-04-24	2017-04-24	1	17280
31543	2134	1118084	1988-02-19	1988-02-19	1	6623
40965	2780	1119510	2018-08-21	2018-08-28	1	17771
76146	5207	1728416	1957-12-31	1958-01-14	1	-4370
68584	4678	1112807	1957-08-13	1957-09-03	1	-4503
46306	3144	1125315	1992-03-10	1992-03-24	1	8118
39312	2674	1729720	1973-02-14	1973-02-25	1	1151
51542	3513	1125315	2016-07-08	2016-07-29	1	17011
35151	2384	1177480	2018-01-05	2018-02-02	1	17564
72229	4935	1125315	1999-02-07	1999-03-16	2	10666
65756	4491	1125315	2001-05-29	2001-06-05	1	11478
55531	3779	1729720	1970-07-07	1970-07-18	1	198
44052	2980	1125315	1975-12-10	1975-12-24	1	2183
47576	3230	1112807	1957-08-13	1957-08-27	1	-4510
34654	2344	1125315	1969-05-27	1969-06-17	1	-198
27276	1843	1549786	2002-07-10	2003-07-05	1	12238
42740	2895	1759842	1963-02-22	1963-03-01	1	-2498
37865	2574	1729720	1975-05-04	1975-05-16	1	1961
43657	2949	1124300	1986-04-02	1986-04-02	1	5935
39305	2673	1515774	1991-02-04	1992-01-30	1	8064
10202	701	1124300	1994-10-11	1994-10-11	1	9049
31402	2123	1119510	1967-01-24	1967-01-31	1	-1066
58616	3997	1713332	2013-03-22	2013-04-12	1	15807
59026	4020	1738521	1972-09-08	1972-09-22	1	995
35947	2442	1759842	1974-10-11	1974-10-25	1	1758
40437	2749	1125315	1966-09-19	1966-09-26	1	-1193
42310	2867	1118084	2014-12-24	2014-12-24	1	16428
49653	3383	1125315	2014-11-07	2014-11-28	1	16402
32785	2220	1125315	1980-08-24	1980-08-31	1	3895
34880	2358	1125315	2016-10-01	2016-10-15	1	17089
40653	2761	1729720	1985-07-24	1985-07-31	1	5690
8671	600	1125315	1987-04-09	1987-04-16	1	6314
891	61	1112807	1968-08-18	1968-09-01	1	-487
41019	2782	1112807	1964-01-07	1964-01-28	1	-2165
41268	2801	1177480	1985-03-26	1985-04-23	1	5591
8250	573	1118084	1996-01-10	1996-01-10	1	9505
37584	2554	920293	1967-08-18	1967-08-25	1	-860
74582	5101	1717327	1962-02-01	1962-02-15	1	-2877
41210	2798	1124300	1994-02-18	1994-02-18	1	8814
39172	2663	1115008	2007-08-21	2011-05-02	1	15096
63383	4330	1759842	2013-08-15	2013-09-05	1	15953
31640	2141	1728416	1950-11-14	1950-11-28	1	-6974
71300	4867	1125315	1948-01-20	1948-02-03	1	-8003
38777	2636	1125315	1973-09-06	1973-09-13	1	1351
72678	4967	1717327	1963-11-23	1963-12-07	1	-2217
42802	2898	1112807	1982-07-22	1982-08-05	1	4599
40898	2776	1768849	1982-01-28	1982-02-11	1	4424
37503	2550	1503184	1999-12-28	2000-12-22	1	11313
75718	5185	1729720	1936-05-13	1936-05-21	1	-12278
41811	2833	1125315	1947-06-15	1947-06-22	1	-8229
77328	5285	715997	2017-04-24	2017-04-24	1	17280
31544	2134	1347450	2017-04-02	2017-04-02	1	17258
40966	2780	1125315	1968-04-16	1968-04-30	1	-611
76147	5207	1759842	1991-01-03	1991-01-24	1	7693
68585	4678	1119510	2016-07-02	2016-07-16	1	16998
46307	3144	1713332	2003-08-06	2003-08-20	1	12284
39313	2674	1759842	2003-06-28	2003-07-26	1	12259
51543	3513	1759842	2016-04-07	2016-04-21	1	16912
35152	2384	1729720	1989-03-02	1989-03-12	1	7010
72230	4935	1177480	1981-08-26	1981-09-09	1	4269
65757	4491	1728416	1948-04-02	1948-04-16	1	-7930
55532	3779	1759842	2001-08-15	2001-08-29	1	11563
44053	2980	1125315	1980-02-10	1980-02-24	1	3706
47577	3230	1112807	1991-10-03	1991-12-02	1	8005
34655	2344	1125315	1970-11-19	1970-11-26	1	329
27277	1843	1549786	2004-06-29	2005-06-24	1	12958
42741	2895	738818	1962-02-08	1962-02-22	1	-2870
37866	2574	1112807	1973-01-30	1973-03-06	1	1160
43658	2949	1125315	1974-10-17	1974-11-23	1	1787
39306	2673	19127890	1993-01-24	1994-01-19	1	8784
10203	701	1125315	1970-12-22	1970-12-29	1	362
31403	2123	1124957	1994-10-28	1994-10-28	1	9066
58617	3997	1115008	1998-02-25	1998-03-11	1	10296
61747	4214	738818	2005-03-09	2005-03-16	1	12858
35948	2442	1115008	1997-07-25	1997-08-15	1	10088
40438	2749	1125315	1978-09-05	1978-09-19	1	3183
42311	2867	1125315	1988-06-07	1988-07-07	1	6762
49654	3383	1503184	2002-04-03	2003-03-29	1	12140
32786	2220	738818	1978-06-20	1978-07-04	1	3106
34881	2358	1738521	1977-10-04	1977-10-18	1	2847
40654	2761	1759842	2007-08-14	2007-08-21	1	13746
8672	600	1309944	1997-02-19	1997-02-19	1	9911
892	61	1115008	2009-08-21	2009-09-25	1	14512
41020	2782	1322184	2002-03-06	2002-03-06	1	11752
41269	2801	1713332	1966-03-25	1966-06-03	1	-1308
8251	573	1125315	1974-04-15	1974-04-29	1	1579
37585	2554	1112807	1936-06-11	1936-06-25	1	-12243
74583	5101	1125315	1991-02-20	1991-03-20	1	7748
41211	2798	1125315	1988-04-21	1988-04-28	1	6692
39173	2663	1713332	2013-06-06	2013-06-27	1	15883
63384	4330	1112807	1946-01-21	1946-02-04	1	-8732
31641	2141	975125	1970-07-14	1970-07-14	1	194
71301	4867	1125315	2011-03-08	2011-04-14	1	15078
38778	2636	1125315	1995-12-13	1995-12-27	1	9491
72679	4967	1728416	1961-06-28	1961-07-12	1	-3095
42803	2898	1125315	2017-04-02	2017-04-09	1	17265
40899	2776	1177480	2013-02-23	2013-03-16	1	15780
37504	2550	1515774	1997-01-12	1998-01-07	1	10233
75719	5185	1729720	1950-07-09	1950-07-17	1	-7108
41812	2833	1125315	1980-04-01	1980-04-08	1	3750
77329	5285	1125315	2008-07-06	2008-07-06	1	14066
35423	2409	933724	2013-12-16	2013-12-23	1	16062
40967	2780	1125315	1979-05-05	1979-05-12	1	3418
76148	5207	1112807	1960-05-19	1960-08-17	1	-3424
68586	4678	1125315	1973-01-23	1973-02-06	1	1132
46308	3144	1717327	1967-11-25	1967-12-09	1	-754
39314	2674	1125315	1971-05-25	1971-06-01	1	516
51544	3513	19127890	1988-03-05	1989-02-28	1	6998
35153	2384	1115008	2005-10-12	2005-10-26	1	13082
72231	4935	1177480	2008-06-11	2008-06-25	1	14055
68157	4653	1125315	1965-07-22	1965-07-29	1	-1617
55533	3779	1119510	1975-08-07	1975-08-14	1	2051
44054	2980	1125315	1993-01-11	1993-01-18	1	8418
47578	3230	1119510	2018-04-02	2018-04-16	1	17637
34656	2344	1728416	1967-07-07	1967-07-21	1	-895
27278	1843	1549786	2007-06-14	2008-06-08	1	14038
42742	2895	1125315	2000-03-21	2000-04-04	1	11051
37867	2574	1125315	1976-02-19	1976-03-04	1	2254
43659	2949	1713332	1962-03-31	1962-04-21	1	-2812
39307	2673	19127890	1995-01-14	1996-01-09	1	9504
10204	701	1112807	1958-07-27	1958-08-10	1	-4162
31404	2123	1125315	1974-03-12	1974-03-19	1	1538
58618	3997	1115008	2005-05-03	2005-06-07	1	12941
61748	4214	1119510	2005-03-09	2005-03-16	1	12858
35949	2442	1125315	1982-06-23	1982-07-14	1	4577
40439	2749	1125315	2014-03-29	2014-04-05	1	16165
42312	2867	19127890	1996-07-21	1997-07-16	1	10058
49655	3383	1512674	2005-03-18	2006-03-13	1	13220
32787	2220	738818	2007-01-31	2007-02-07	1	13551
34882	2358	1118084	2007-09-17	2007-09-17	1	13773
40655	2761	738818	1982-09-08	1982-09-15	1	4640
8673	600	1343916	1997-02-19	1997-02-19	1	9911
893	61	1521369	1983-01-12	1984-01-07	1	5119
41731	2829	1125315	1952-06-06	1952-06-20	1	-6404
41270	2801	1729720	1928-12-24	1929-01-02	1	-14974
8252	573	1177480	2013-07-17	2013-08-14	1	15931
37586	2554	1112807	1944-11-05	1944-11-19	1	-9174
74584	5101	1125315	1997-12-23	1998-01-06	1	10232
41212	2798	1713332	2017-10-13	2017-10-20	1	17459
39174	2663	1759842	2013-06-06	2013-06-27	1	15883
63385	4330	1115008	1995-12-31	1996-01-14	1	9509
31642	2141	1125315	1958-04-07	1958-04-14	1	-4280
71302	4867	1125315	2011-07-03	2011-07-10	1	15165
38779	2636	1125315	2015-12-12	2015-12-19	1	16788
72680	4967	1125315	1963-11-23	1963-12-07	1	-2217
42804	2898	1713332	1982-04-19	1982-05-03	1	4505
40900	2776	1343916	2005-07-26	2005-07-26	1	12990
37505	2550	1549786	1997-01-12	1998-01-07	1	10233
75720	5185	914335	1961-11-13	1961-11-13	1	-2971
41813	2833	1729720	1940-04-03	1940-04-15	1	-10853
77330	5285	1125315	2009-09-03	2009-09-10	1	14497
35424	2409	1125315	1993-11-12	1993-11-26	1	8730
40968	2780	1125315	2008-02-07	2008-02-14	1	13923
76149	5207	1125315	2017-02-06	2017-02-20	1	17217
68587	4678	1713332	1972-03-06	1972-03-27	1	816
46309	3144	1728416	1966-01-02	1966-01-16	1	-1446
39315	2674	1125315	1987-01-01	1987-01-15	1	6223
51545	3513	933724	2008-04-16	2008-04-23	1	13992
35154	2384	1125315	2003-10-11	2003-10-18	1	12343
72232	4935	920293	1996-10-28	1996-11-04	1	9804
68158	4653	1125315	1993-07-04	1993-07-18	1	8599
55534	3779	1118084	2003-01-16	2003-01-16	1	12068
44055	2980	1129625	1974-01-08	1974-01-08	1	1468
47579	3230	1125315	1993-03-05	1993-03-19	1	8478
34657	2344	19127890	1984-02-18	1985-02-12	1	5521
27279	1843	1713332	1983-11-13	1983-11-20	1	5071
42743	2895	1759842	1960-07-14	1960-07-28	1	-3444
37868	2574	1717327	1961-05-04	1961-05-18	1	-3150
43660	2949	1125315	1956-05-24	1956-06-23	1	-4940
42402	2872	1112807	1968-04-07	1968-04-21	1	-620
10205	701	1115008	2008-06-04	2008-07-09	1	14069
31405	2123	1125315	2018-08-27	2018-09-10	1	17784
58619	3997	1125315	1978-04-13	1978-06-12	1	3084
61749	4214	1125315	1978-06-23	1978-07-07	1	3109
35950	2442	1149380	1973-06-27	1973-06-27	1	1273
43245	2926	920293	2000-10-21	2000-10-28	1	11258
42313	2867	1125315	2003-10-05	2003-10-19	1	12344
49656	3383	1521369	2004-03-23	2005-03-18	1	12860
32788	2220	1115008	2005-02-04	2005-05-05	1	12908
34883	2358	1125315	1986-04-22	1986-05-06	1	5969
40656	2761	1125315	1982-09-08	1982-09-15	1	4640
8674	600	1713332	1992-02-10	1992-02-17	1	8082
894	61	1129625	1972-02-10	1972-02-10	1	770
41732	2829	1125315	1990-09-04	1990-09-18	1	7565
41271	2801	738818	1930-08-06	1930-08-13	1	-14386
8253	573	1125315	1971-04-08	1971-04-22	1	476
37587	2554	1118084	1968-02-09	1968-02-09	1	-692
74585	5101	1125315	2004-09-07	2004-09-28	1	12689
41213	2798	1759842	2013-08-06	2013-08-27	1	15944
39175	2663	1112807	1972-03-17	1972-05-16	1	866
63386	4330	1125315	1963-09-01	1963-09-01	1	-2314
31643	2141	1759842	1950-06-23	1950-07-14	1	-7111
71303	4867	1713332	1927-02-07	1927-02-28	1	-15648
38780	2636	1125315	2017-08-22	2017-09-05	1	17414
72681	4967	1713332	1978-09-02	1978-10-28	1	3222
42805	2898	920293	2012-02-09	2012-02-16	1	15386
40901	2776	1717327	1978-05-28	1978-06-11	1	3083
37506	2550	1713332	1997-07-24	1997-10-02	1	10136
75721	5185	1112807	1938-06-30	1938-07-14	1	-11494
41814	2833	1759842	2001-04-28	2001-05-05	1	11447
77331	5285	1332418	2007-02-25	2007-02-25	1	13569
35425	2409	1729720	2017-04-10	2017-04-22	1	17278
40969	2780	1118084	2001-09-23	2001-09-23	1	11588
76150	5207	1521369	1981-11-05	1982-10-31	1	4686
68588	4678	1759842	1975-06-15	1975-07-06	1	2012
46310	3144	1729720	1964-01-28	1964-02-07	1	-2155
39316	2674	1125315	1989-02-03	1989-02-10	1	6980
51546	3513	1115008	2007-02-12	2007-02-26	1	13570
35155	2384	1177480	2008-09-10	2008-09-24	1	14146
72233	4935	1713332	1989-09-26	1989-10-10	1	7222
68159	4653	1713332	1982-12-19	1983-01-09	1	4756
55535	3779	1521369	1988-03-10	1989-03-05	1	7003
44056	2980	1177480	1974-06-06	1974-06-20	1	1631
48589	3304	738818	1984-10-17	1984-10-31	1	5417
34658	2344	19127890	1988-01-28	1989-01-22	1	6961
27280	1843	1713332	1992-11-02	1992-11-09	1	8348
42744	2895	1112807	1966-04-09	1966-04-23	1	-1349
39394	2680	1125315	1975-06-23	1975-07-07	1	2013
43661	2949	1125315	1978-12-11	1978-12-25	1	3280
42403	2872	1125315	1988-01-03	1988-01-10	1	6583
10206	701	1728416	1959-05-07	1959-05-21	1	-3878
31406	2123	1177480	2002-05-19	2002-08-17	1	11916
58620	3997	1125315	1983-08-26	1983-09-02	1	4992
61750	4214	1125315	2005-03-09	2005-03-16	1	12858
35951	2442	1713332	1974-10-11	1974-10-25	1	1758
43246	2926	1515774	2005-07-24	2006-07-19	1	13348
44106	2985	1112807	1968-07-19	1968-08-02	1	-517
49657	3383	19127890	2011-02-15	2012-02-10	1	15380
32789	2220	1119510	1947-12-16	1947-12-23	1	-8045
34884	2358	1759842	1981-08-03	1981-08-17	1	4246
40657	2761	1759842	1989-04-20	1989-04-27	1	7056
8675	600	1759842	1992-02-10	1992-02-17	1	8082
895	61	1149380	1971-01-27	1971-01-27	1	391
41733	2829	1125315	1992-08-11	1992-08-18	1	8265
41272	2801	738818	1931-06-16	1931-06-30	1	-14065
8254	573	1125315	1977-03-25	1977-04-01	1	2647
37588	2554	1119510	1973-12-29	1974-01-05	1	1465
74586	5101	1125315	2016-03-29	2016-05-03	1	16924
41214	2798	19127890	1978-08-11	1980-07-31	2	3864
39176	2663	1115008	2018-05-15	2018-06-05	1	17687
63387	4330	1125315	1977-08-29	1977-09-12	1	2811
31644	2141	1759842	1958-05-03	1958-05-10	1	-4254
71304	4867	1713332	1949-03-15	1949-03-29	1	-7583
38781	2636	1129625	1963-05-06	1963-05-06	1	-2432
74770	5117	1115008	2017-12-09	2017-12-30	1	17530
42806	2898	1124300	2016-08-29	2016-08-29	1	17042
40902	2776	1778162	1991-07-21	1991-08-04	1	7885
37507	2550	1759842	2000-09-22	2000-10-13	1	11243
75722	5185	1124300	1968-09-20	1968-09-20	1	-468
43149	2919	1137529	2013-11-23	2013-11-23	1	16032
77332	5285	1361711	2007-02-25	2008-07-06	1	14066
35426	2409	19127890	1994-09-24	1995-09-19	1	9392
40970	2780	1125315	2018-08-21	2018-08-28	1	17771
77940	5325	1124957	1989-10-22	1989-10-22	1	7234
68589	4678	1125315	1974-01-06	1974-01-13	1	1473
46311	3144	738818	1974-11-16	1974-11-30	1	1794
39317	2674	1125315	2007-03-23	2007-03-30	1	13602
51547	3513	1125315	1974-04-10	1974-04-17	1	1567
38037	2586	1729720	1973-11-18	1973-11-27	1	1426
72234	4935	1759842	1989-09-26	1989-10-10	1	7222
68160	4653	1729720	1964-09-24	1964-10-04	1	-1915
56587	3856	1521369	1992-09-03	1993-08-29	1	8641
44057	2980	1713332	1984-04-16	1984-05-07	1	5240
48590	3304	1118084	2001-05-19	2001-05-19	1	11461
36482	2482	1102527	1995-03-03	1995-03-03	1	9192
27281	1843	1729720	1993-10-02	1993-10-15	1	8688
42745	2895	1124300	1997-05-06	1997-05-06	1	9987
39395	2680	1125315	1986-02-08	1986-04-16	1	5949
43662	2949	1728416	1950-10-23	1950-11-06	1	-6996
42404	2872	1545958	1999-08-17	1999-08-17	1	10820
10207	701	1729720	1962-05-11	1962-05-24	1	-2779
31407	2123	1729720	1952-01-08	1952-01-17	1	-6559
58621	3997	1125315	1997-01-17	1997-01-31	1	9892
61751	4214	1539403	2018-12-18	2018-12-18	1	17883
37633	2556	1119510	1982-07-01	1982-07-15	1	4578
43247	2926	1521369	1997-09-04	1999-08-25	2	10828
44107	2985	1125315	1976-10-16	1976-10-30	1	2494
49658	3383	1500211	2010-02-20	2011-02-15	1	15020
32790	2220	1119510	1980-08-24	1980-08-31	1	3895
36390	2476	1119510	2010-06-30	2010-07-07	1	14797
41924	2842	738818	2002-02-23	2002-03-02	1	11748
11504	785	1112807	1968-10-12	1968-10-26	1	-432
896	61	1177480	1988-10-12	1988-11-09	1	6887
41734	2829	1501700	2017-08-18	2017-08-18	1	17396
41273	2801	1112807	1923-11-09	1923-11-23	1	-16841
8255	573	1125315	1992-07-07	1992-07-14	1	8230
37589	2554	1322184	1999-12-02	1999-12-02	1	10927
74587	5101	1713332	1979-11-29	1979-12-06	1	3626
41215	2798	920293	1998-11-02	1998-11-09	1	10539
39177	2663	1118084	2002-09-11	2002-09-11	1	11941
63388	4330	1557272	2006-02-18	2006-02-18	1	13197
31645	2141	1759842	1981-06-24	1981-07-08	1	4206
71305	4867	1729720	1948-02-09	1948-02-20	1	-7986
38782	2636	738818	2011-11-11	2011-11-18	1	15296
74771	5117	1118084	1998-02-13	1998-02-13	1	10270
42807	2898	1125315	1984-01-21	1984-01-28	1	5140
40903	2776	738818	1980-09-16	1980-09-30	1	3925
37508	2550	1177480	2001-07-10	2001-07-31	1	11534
75723	5185	1125315	1965-09-17	1965-09-24	1	-1560
43150	2919	1713332	1958-12-29	1959-01-19	1	-4000
77333	5285	1361711	2008-09-21	2008-09-21	1	14143
35427	2409	1124300	2018-10-06	2018-10-06	1	17810
40971	2780	1729720	1958-06-10	1958-06-18	1	-4215
77941	5325	1125315	1973-03-16	1973-03-30	1	1184
68590	4678	1125315	1982-09-22	1982-10-06	1	4661
46312	3144	920293	1998-06-24	1998-07-08	2	10415
39318	2674	1125315	1983-03-01	1983-03-08	1	4814
51548	3513	1125315	1985-02-09	1985-02-23	1	5532
38038	2586	1118084	2007-09-04	2007-09-04	1	13760
72235	4935	1125315	1970-10-24	1970-11-07	1	310
68161	4653	1759842	1972-09-17	1972-10-08	1	1011
56588	3856	1729720	1976-10-18	1976-10-25	1	2489
44058	2980	1759842	2008-05-06	2008-05-13	1	14012
48591	3304	1119510	1997-06-06	1997-06-13	1	10025
36483	2482	1115008	2002-03-26	2002-06-24	1	11862
27282	1843	1759842	1983-11-13	1983-11-20	1	5071
42746	2895	1125315	1962-02-08	1962-02-22	1	-2870
39396	2680	1125315	2017-09-19	2017-10-03	1	17442
43663	2949	1115008	1995-12-03	1995-12-31	1	9495
42405	2872	1112807	1954-10-27	1954-11-17	1	-5524
10208	701	1177480	2015-05-04	2015-05-25	1	16580
31408	2123	1759842	1954-05-02	1954-05-23	1	-5702
58622	3997	1713332	1991-02-14	1991-02-28	1	7728
61752	4214	1118084	2005-07-13	2005-07-13	1	12977
37634	2556	1125315	1970-06-13	1970-06-27	1	177
43248	2926	1549786	2005-07-24	2006-07-19	1	13348
44108	2985	1125315	1982-11-28	1982-12-05	1	4721
49659	3383	1515774	2007-03-08	2008-03-02	1	13940
32791	2220	1125315	1978-06-20	1978-07-04	1	3106
36391	2476	1125315	1978-08-05	1978-08-19	1	3152
41925	2842	1112807	1970-03-26	1970-04-30	1	119
11505	785	1717327	1969-06-15	1969-06-29	1	-186
897	61	1551099	1978-07-29	1978-07-29	1	3131
41735	2829	1728416	1952-06-06	1952-06-20	1	-6404
41274	2801	1118084	1966-02-21	1966-02-21	1	-1410
8256	573	1125315	2014-08-08	2014-08-22	1	16304
37590	2554	1332418	1999-12-02	1999-12-02	1	10927
74588	5101	19127890	1974-12-05	1975-11-30	1	2159
41216	2798	920293	1999-12-12	1999-12-26	2	10951
39178	2663	1125315	1973-04-20	1973-04-27	1	1212
63389	4330	1713332	1967-03-26	1967-04-09	1	-998
31646	2141	1112807	1950-11-14	1950-11-28	1	-6974
71306	4867	1729720	1962-12-18	1962-12-27	1	-2562
38783	2636	1112807	1964-03-25	1964-04-08	1	-2094
74772	5117	1759842	2010-11-14	2010-11-28	1	14941
42808	2898	1125315	2000-08-02	2000-08-16	1	11185
40904	2776	1124300	2014-01-14	2014-01-14	1	16084
37509	2550	19127890	1997-01-12	1999-01-02	2	10593
75724	5185	1125315	1993-01-01	1993-01-15	1	8415
43151	2919	1118084	1984-03-29	1984-03-29	1	5201
77334	5285	1713332	2013-09-08	2013-09-29	1	15977
35428	2409	1125315	1986-07-21	1986-10-19	1	6135
40972	2780	738818	2018-08-21	2018-08-28	1	17771
77942	5325	1728416	1946-06-05	1946-06-19	1	-8597
68591	4678	1125315	2016-07-02	2016-07-16	1	16998
46313	3144	1112807	1968-01-03	1968-02-07	1	-694
41128	2792	1112807	1961-09-16	1961-11-15	1	-2969
51549	3513	1503184	1988-03-05	1989-02-28	1	6998
38039	2586	1192710	1973-07-20	1973-07-20	1	1296
72236	4935	1129625	1985-10-11	1985-10-11	1	5762
68162	4653	738818	2011-06-28	2011-07-12	1	15167
56589	3856	1738521	1976-01-04	1976-01-18	1	2208
44059	2980	1112807	1975-02-22	1975-03-08	1	1892
48592	3304	1125315	1984-10-17	1984-10-31	1	5417
36484	2482	1118084	2015-05-20	2015-05-20	1	16575
27283	1843	1759842	1992-11-02	1992-11-09	1	8348
42747	2895	1125315	1968-01-31	1968-02-07	1	-694
39397	2680	1503184	1988-02-24	1989-02-18	1	6988
43664	2949	1125315	1960-03-04	1960-05-03	1	-3530
42406	2872	1125315	1992-07-14	1992-08-04	1	8251
10418	715	1118084	2017-06-26	2017-06-26	1	17343
36110	2456	738818	1959-11-30	1959-12-14	1	-3671
58623	3997	1729720	1969-08-23	1969-09-01	1	-122
61753	4214	1125315	1981-12-13	1981-12-20	1	4371
37635	2556	1125315	1975-09-07	1975-09-21	1	2089
43249	2926	1713332	1982-11-12	1982-11-26	1	4712
44109	2985	1177480	2016-07-13	2016-10-11	1	17085
49660	3383	1521369	2002-04-03	2003-03-29	1	12140
32792	2220	1125315	2005-02-04	2005-02-04	1	12818
36392	2476	1125315	2010-06-30	2010-07-07	1	14797
41926	2842	1119510	1982-06-19	1982-07-03	1	4566
11506	785	19127890	1977-12-04	1978-11-29	1	3254
898	61	1729720	1977-12-03	1977-12-12	1	2902
41736	2829	705944	1958-09-02	1968-09-09	1	-479
41275	2801	1119510	1959-04-13	1959-04-20	1	-3909
8257	573	1729720	1974-01-22	1974-02-03	1	1494
37591	2554	1539403	1999-12-02	1999-12-02	1	10927
74589	5101	920293	1996-01-18	1996-01-25	1	9520
41217	2798	933724	1998-11-02	1998-11-09	1	10539
39179	2663	1759842	2015-09-22	2015-10-06	1	16714
63390	4330	1728416	1951-06-15	1951-06-29	1	-6761
31647	2141	1112807	1955-03-23	1955-04-06	1	-5384
71307	4867	1729720	1988-04-12	1988-04-25	1	6689
38784	2636	1118084	2002-04-25	2002-04-25	1	11802
74773	5117	1125315	1988-03-16	1988-06-14	2	6739
42809	2898	1177480	1982-04-19	1982-05-03	1	4505
40905	2776	1125315	1978-05-28	1978-06-11	1	3083
37510	2550	920293	2018-03-13	2018-03-20	1	17610
75725	5185	1343916	1961-11-13	1961-11-13	1	-2971
43152	2919	1149380	2013-11-23	2013-11-23	1	16032
77335	5285	1713332	2014-10-31	2014-11-21	1	16395
35429	2409	1125315	2008-06-14	2008-06-21	1	14051
40973	2780	1112807	1960-04-10	1960-04-24	1	-3539
77943	5325	1759842	1963-02-04	1963-02-25	1	-2502
68592	4678	1125315	2017-12-01	2017-12-22	1	17522
46314	3144	1125315	1967-11-25	1967-12-09	1	-754
41129	2792	1125315	1975-05-12	1975-05-26	1	1971
51550	3513	920293	2010-06-01	2010-06-08	1	14768
38040	2586	1125315	1983-12-11	1983-12-25	1	5106
72237	4935	1738521	1969-01-01	1969-01-15	1	-351
68163	4653	1125315	2011-06-28	2011-07-12	1	15167
56590	3856	1759842	1975-04-04	1975-04-11	1	1926
44060	2980	1119510	1983-05-22	1983-05-29	1	4896
48593	3304	1125315	2012-05-14	2012-05-28	1	15488
36485	2482	1125315	1976-07-03	1976-09-01	1	2435
27284	1843	1118084	2016-10-29	2016-10-29	1	17103
42748	2895	1125315	1968-06-23	1968-07-07	1	-543
39398	2680	1713332	1996-05-16	1996-05-30	1	9646
43665	2949	1125315	1964-05-13	1964-05-20	1	-2052
42407	2872	1174888	1999-08-17	1999-08-17	1	10820
10419	715	19127890	1998-02-06	1999-02-01	1	10623
36111	2456	1119510	1972-11-06	1972-11-20	1	1054
58624	3997	1759842	1991-02-14	1991-02-28	1	7728
61754	4214	1125315	1998-10-24	1998-10-31	1	10530
37636	2556	1125315	1981-09-12	1981-10-17	1	4307
43250	2926	1713332	1989-08-15	1989-08-29	1	7180
44110	2985	1309944	1967-06-17	1967-06-17	1	-929
49661	3383	1549786	2004-03-23	2006-03-13	2	13220
32793	2220	1125315	2007-01-31	2007-02-07	1	13551
36393	2476	1713332	2000-01-18	2000-02-08	1	10995
41927	2842	1119510	1989-07-16	1989-07-23	1	7143
11507	785	1125315	1969-06-15	1969-06-29	1	-186
899	61	1729720	1990-05-10	1990-05-20	1	7444
41737	2829	1125315	1992-10-18	1992-11-01	1	8340
41276	2801	1125315	1930-08-06	1930-08-13	1	-14386
8258	573	1125315	1964-03-10	1964-03-24	1	-2109
37592	2554	1713332	1969-05-30	1969-06-13	1	-202
74590	5101	1125315	1971-04-16	1971-04-30	1	484
41218	2798	1119510	1988-04-21	1988-04-28	1	6692
39180	2663	1125315	1965-07-23	1965-07-30	1	-1616
63391	4330	738818	1964-03-31	1964-04-07	1	-2095
31648	2141	1118084	1978-06-20	1978-06-20	1	3092
71308	4867	1759842	2011-10-17	2011-10-31	1	15278
38785	2636	1125315	2011-11-11	2011-11-18	1	15296
74774	5117	1521369	1974-02-24	1975-02-19	1	1875
42810	2898	1500211	1994-01-07	1995-01-02	1	9132
40906	2776	1125315	1980-09-16	1980-09-30	1	3925
37511	2550	933724	2018-03-13	2018-03-20	1	17610
75726	5185	1729720	1948-06-19	1948-07-01	1	-7854
77336	5285	757627	2016-05-29	2016-05-29	1	16950
35430	2409	1177480	2011-01-25	2011-04-25	1	15089
40974	2780	1119510	1993-12-13	1993-12-20	1	8754
77944	5325	1125315	1970-12-17	1970-12-31	1	364
68593	4678	1713332	1975-06-15	1975-07-06	1	2012
46315	3144	1125315	1974-11-16	1974-11-30	1	1794
41130	2792	1177480	2008-07-25	2008-08-15	1	14106
51551	3513	1125315	1979-08-10	1979-10-09	1	3568
38041	2586	1177480	1980-01-13	1980-02-10	1	3692
72238	4935	1778162	2008-06-11	2008-06-25	1	14055
68164	4653	1125315	2016-12-17	2016-12-24	1	17159
56591	3856	1759842	1992-03-08	1992-03-22	1	8116
44061	2980	1125315	1981-02-18	1981-03-18	1	4094
48594	3304	1713332	2010-01-13	2010-01-20	1	14629
36486	2482	1549786	1989-09-03	1990-08-29	1	7545
27285	1843	1125315	1983-01-13	1983-01-27	1	4774
42749	2895	1125315	1984-05-20	1984-05-27	1	5260
39399	2680	1102527	1986-02-15	1986-02-15	1	5889
43666	2949	1125315	2010-05-30	2010-07-04	1	14794
42408	2872	1332418	1994-03-22	1994-03-22	1	8846
10420	715	1125315	1992-11-26	1992-12-10	1	8379
36112	2456	1125315	1959-11-30	1959-12-14	1	-3671
58625	3997	1118084	2011-09-26	2011-09-26	1	15243
61755	4214	1361711	2018-12-18	2018-12-18	1	17883
37637	2556	1174888	2007-12-14	2007-12-14	1	13861
43251	2926	1713332	1990-07-30	1990-08-06	1	7522
44111	2985	1343916	1967-06-17	1967-06-17	1	-929
49662	3383	1549786	2007-03-08	2008-03-02	1	13940
32794	2220	1713332	2014-09-06	2014-09-13	1	16326
36394	2476	738818	1966-07-15	1966-07-29	1	-1252
41928	2842	1125315	1964-08-24	1964-11-22	1	-1866
11508	785	1177480	1984-12-17	1985-01-07	1	5485
900	61	1738521	1969-12-23	1970-01-06	1	5
41738	2829	1112807	1951-01-02	1951-01-16	1	-6925
41277	2801	1125315	1931-06-16	1931-06-30	1	-14065
8259	573	1125315	1982-10-31	1982-11-07	1	4693
37593	2554	1759842	2016-04-01	2016-04-22	1	16913
74591	5101	1503184	1974-12-05	1975-11-30	1	2159
41219	2798	1125315	1973-03-21	1973-04-04	1	1189
39181	2663	1125315	1980-12-20	1981-01-03	1	4020
63392	4330	1112807	1955-08-16	1955-09-13	1	-5224
31649	2141	1125315	1959-03-12	1959-03-26	1	-3934
73373	5017	1125315	1983-10-23	1983-11-13	1	5064
38786	2636	1125315	2019-03-08	2019-03-08	1	17963
74775	5117	1174888	1988-03-16	1988-03-16	1	6649
42811	2898	19127890	1993-01-12	1994-01-07	1	8772
40907	2776	1125315	1991-07-21	1991-08-04	1	7885
37512	2550	1125315	1997-01-02	1997-01-02	1	9863
75727	5185	1729720	2014-10-27	2014-11-04	1	16378
77337	5285	1112807	1943-06-04	1943-06-18	1	-9694
35431	2409	1515774	1994-09-24	1995-09-19	1	9392
40975	2780	1125315	1956-12-21	1957-01-04	1	-4745
77945	5325	1177480	2008-11-18	2008-12-02	1	14215
68594	4678	1759842	1972-03-06	1972-03-27	1	816
46316	3144	1717327	1965-05-02	1965-05-16	1	-1691
41131	2792	1728416	1962-07-24	1962-08-07	1	-2704
51552	3513	1177480	1976-07-26	1976-08-09	1	2412
38042	2586	1713332	1995-06-28	1995-07-12	1	9323
72239	4935	933724	1996-10-28	1996-11-04	1	9804
68165	4653	1713332	2002-06-17	2002-07-01	1	11869
56592	3856	1768849	1979-07-22	1979-08-05	1	3503
44062	2980	1112807	1973-12-08	1974-01-12	1	1472
48595	3304	738818	1990-08-03	1990-08-10	1	7526
36487	2482	1738521	1974-12-11	1974-12-25	1	1819
27286	1843	1125315	1989-06-26	1989-07-03	1	7123
42750	2895	1125315	2013-06-10	2013-06-24	1	15880
39400	2680	1112807	1974-01-28	1974-02-11	1	1502
43667	2949	1728416	1951-03-03	1951-03-17	1	-6865
42409	2872	914335	1971-09-07	1971-09-07	1	614
10421	715	1713332	1986-06-29	1986-07-13	1	6037
36113	2456	1125315	1971-12-03	1971-12-10	1	708
58626	3997	1119510	1983-08-26	1983-09-02	1	4992
61756	4214	1729720	2008-01-17	2008-01-27	1	13905
37638	2556	1713332	1998-08-06	1998-08-27	1	10465
43252	2926	1713332	2006-02-23	2006-03-09	1	13216
44112	2985	1503184	1983-09-14	1986-08-29	3	6084
49663	3383	1549786	2011-02-15	2012-02-10	1	15380
32795	2220	1759842	2014-09-06	2014-09-13	1	16326
36395	2476	738818	2010-06-30	2010-07-07	1	14797
41929	2842	1125315	2017-02-12	2017-02-26	1	17223
11509	785	1118084	2004-07-15	2004-07-15	1	12614
901	61	1759842	1981-05-22	1981-06-12	1	4180
41739	2829	1125315	1959-01-21	1959-02-04	1	-3984
41278	2801	1174888	2002-03-25	2002-03-25	1	11771
8260	573	1177480	1988-08-13	1988-08-27	1	6813
37594	2554	975125	1964-07-31	1964-07-31	1	-1980
75904	5197	753626	1962-06-06	1962-06-06	1	-2766
41220	2798	1125315	1977-05-25	1977-06-08	1	2715
39182	2663	1305058	2007-08-21	2011-05-02	1	15096
63393	4330	1118084	1987-02-25	1987-02-25	1	6264
31650	2141	1177480	2006-02-14	2006-03-07	1	13214
73374	5017	1125315	2011-10-15	2011-10-29	1	15276
38787	2636	1332418	1997-07-04	1997-07-04	1	10046
74776	5117	19127890	1974-02-24	1975-02-19	1	1875
42812	2898	19127890	1995-01-02	1995-12-28	1	9492
40908	2776	1713332	2002-11-01	2002-11-15	1	12006
37513	2550	1174888	1997-01-02	1997-01-02	1	9863
75728	5185	701322	2010-11-02	2010-11-02	1	14915
77338	5285	1118084	1980-12-16	1980-12-16	1	4002
35432	2409	738818	2013-06-27	2013-07-04	1	15890
40976	2780	1177480	1997-07-11	1997-07-25	1	10067
77946	5325	1713332	1989-10-22	1989-11-05	1	7248
70679	4828	1177480	1984-05-01	1984-06-30	1	5294
47650	3236	1112807	1992-07-05	1992-08-02	1	8249
41132	2792	1738521	1975-05-12	1975-05-26	1	1971
51553	3513	1521369	1988-03-05	1989-02-28	1	6998
38043	2586	1729720	1972-09-09	1972-09-21	1	994
72240	4935	1125315	1969-01-01	1969-01-15	1	-351
68166	4653	1728416	1959-06-22	1959-07-06	1	-3832
56593	3856	933724	1998-10-23	1998-10-29	1	10528
44063	2980	1125315	1983-05-22	1983-05-29	1	4896
48596	3304	738818	1997-06-06	1997-06-13	1	10025
36488	2482	1125315	1975-09-08	1975-09-22	1	2090
27287	1843	1177480	1985-06-13	1985-06-27	1	5656
42751	2895	1177480	2013-01-21	2013-02-04	1	15740
39401	2680	1125315	1976-09-14	1976-09-28	1	2462
43668	2949	1759842	1962-03-31	1962-04-21	1	-2812
42410	2872	1125315	1999-08-17	1999-08-17	1	10820
10422	715	1729720	1997-10-11	1997-10-23	1	10157
36114	2456	1118084	1995-05-04	1995-05-04	1	9254
58627	3997	1119510	2017-07-22	2017-07-29	1	17376
61757	4214	1125315	1975-11-13	1975-11-27	1	2156
37639	2556	1713332	2006-04-24	2006-05-15	1	13283
43253	2926	1713332	2016-01-10	2016-01-24	1	16824
44113	2985	1112807	1964-12-12	1964-12-26	1	-1832
49664	3383	1759842	1993-10-13	1993-10-27	1	8700
33360	2266	1112807	1969-06-12	1969-06-26	1	-189
36396	2476	1118084	1994-01-12	1994-01-12	1	8777
41930	2842	738818	1982-06-19	1982-07-03	1	4566
11510	785	1125315	1966-09-24	1966-10-08	1	-1181
3150	209	933724	1985-04-02	1985-04-09	1	5577
41740	2829	1125315	1978-02-09	1978-04-10	1	3021
41279	2801	1713332	1923-06-17	1923-06-24	1	-16993
8261	573	1713332	2015-11-27	2015-12-04	1	16773
37595	2554	1112807	1940-07-07	1940-07-21	1	-10756
75905	5197	1112807	1954-02-15	1954-03-01	1	-5785
41221	2798	1125315	1977-12-27	1978-01-03	1	2924
39183	2663	1729720	1965-12-21	1966-01-01	1	-1461
63394	4330	1119510	1959-06-13	1959-06-27	1	-3841
31651	2141	1713332	1995-10-30	1995-11-13	1	9447
73375	5017	1118084	2015-06-27	2015-06-27	1	16613
38788	2636	1539403	1997-07-04	1997-07-04	1	10046
74777	5117	1112807	1984-03-23	1984-04-06	1	5209
42813	2898	19127890	1997-12-17	1998-12-12	1	10572
40909	2776	1759842	2016-01-04	2016-01-11	1	16811
37514	2550	1521369	1999-12-28	2000-12-22	1	11313
75729	5185	738818	2012-03-23	2012-03-30	1	15429
77339	5285	1125315	1985-05-08	1985-05-22	1	5620
35433	2409	920293	2007-11-04	2007-11-11	1	13828
40977	2780	1728416	1956-02-17	1956-03-02	1	-5053
77947	5325	1112807	1989-10-22	1989-11-05	1	7248
70680	4828	1729720	1982-04-19	1982-04-28	1	4500
47651	3236	1112807	1993-06-28	1993-07-12	1	8593
41133	2792	1759842	1973-09-19	1973-10-03	1	1371
51554	3513	1713332	2016-04-07	2016-04-21	1	16912
38044	2586	1759842	1995-06-28	1995-07-12	1	9323
73607	5035	738818	1982-03-02	1982-03-16	1	4457
68167	4653	1112807	1959-06-22	1959-07-06	1	-3832
56594	3856	1125315	1975-05-26	1975-07-04	2	1992
44064	2980	1125315	2013-01-03	2013-01-17	1	15722
48597	3304	1112807	1964-11-29	1964-12-20	1	-1838
36489	2482	1125315	1991-05-16	1991-06-15	1	7835
27288	1843	1521369	2001-07-15	2002-07-10	1	11878
42752	2895	1713332	1963-02-22	1963-03-01	1	-2498
39402	2680	1125315	1981-04-09	1981-04-23	1	4130
45037	3059	1118084	2012-11-29	2012-11-29	1	15673
42411	2872	1361711	1968-08-06	1999-08-17	1	10820
10423	715	1125315	1986-06-29	1986-07-13	1	6037
36115	2456	1713332	2018-06-09	2018-06-23	1	17705
58628	3997	1125315	1987-02-16	1987-03-02	1	6269
61758	4214	1322184	2018-12-18	2018-12-18	1	17883
37640	2556	1759842	1998-08-06	1998-08-27	1	10465
43254	2926	1729720	1995-12-03	1995-12-11	1	9475
44114	2985	1124300	2001-12-23	2001-12-23	1	11679
49665	3383	19127890	2005-03-18	2006-03-13	1	13220
33361	2266	1125315	1971-12-11	1971-12-25	1	723
36397	2476	1125315	1958-09-23	1958-10-28	1	-4083
41931	2842	738818	1989-07-16	1989-07-23	1	7143
11511	785	1125315	1989-08-15	1989-08-22	1	7173
3151	209	1118084	1988-07-08	1988-07-08	1	6763
41741	2829	1118084	1988-01-13	1988-01-13	1	6586
41280	2801	1759842	1923-06-17	1923-06-24	1	-16993
8262	573	1729720	1960-03-03	1960-03-11	1	-3583
37596	2554	1112807	1965-12-27	1966-01-17	1	-1445
75906	5197	1124300	1995-09-28	1995-09-28	1	9401
41222	2798	1125315	1986-08-20	1986-09-03	1	6089
39184	2663	1729720	1974-10-19	1974-10-29	1	1762
63395	4330	1125315	1953-07-13	1953-07-27	1	-6002
31652	2141	1729720	1949-09-07	1949-09-18	1	-7410
73376	5017	1125315	1997-07-21	1997-07-28	1	10070
38789	2636	1119510	2014-11-15	2014-11-29	1	16403
74778	5117	1125315	1979-09-17	1979-10-01	1	3560
42814	2898	933724	2015-03-30	2015-04-06	1	16531
40910	2776	975125	2005-07-13	2005-07-13	1	12977
37515	2550	1713332	2000-09-22	2000-10-13	1	11243
75730	5185	757627	2009-12-07	2009-12-07	1	14585
77340	5285	1125315	2007-09-05	2007-09-12	1	13768
35434	2409	1102527	2011-01-25	2011-01-25	1	14999
40978	2780	1728416	1956-12-21	1957-01-04	1	-4745
77948	5325	1115008	2009-04-24	2009-05-22	1	14386
70681	4828	1119510	2000-07-17	2000-07-31	1	11169
47652	3236	1119510	1987-03-27	1987-04-10	1	6308
41134	2792	1125315	1962-10-12	1962-10-19	1	-2631
51555	3513	1717327	1976-07-26	1976-08-09	1	2412
38045	2586	1125315	2014-09-19	2014-09-26	1	16339
73608	5035	1112807	1932-09-19	1932-10-03	1	-13604
68168	4653	1118084	2002-10-29	2002-10-29	1	11989
56595	3856	1125315	1991-06-21	1991-07-05	1	7855
44065	2980	1713332	2008-05-06	2008-05-13	1	14012
48598	3304	1119510	1984-10-17	1984-10-31	1	5417
36490	2482	19127890	1989-09-03	1990-08-29	1	7545
27289	1843	1521369	2004-06-29	2005-06-24	1	12958
42753	2895	1728416	1961-11-01	1961-11-15	1	-2969
39403	2680	1521369	1988-02-24	1989-02-18	1	6988
45038	3059	1125315	2013-05-15	2013-05-29	1	15854
42412	2872	1728416	1954-03-31	1954-04-14	1	-5741
10424	715	1125315	2002-09-03	2002-09-17	1	11947
36116	2456	1125315	2001-08-03	2001-08-17	1	11551
58629	3997	1125315	2001-04-01	2001-04-15	1	11427
61759	4214	1332418	2018-12-18	2018-12-18	1	17883
37641	2556	1759842	2006-04-24	2006-05-15	1	13283
43255	2926	1759842	1998-12-12	1998-12-26	1	10586
44115	2985	1125315	1967-06-21	1967-07-05	1	-911
49666	3383	19127890	2007-03-08	2008-03-02	1	13940
33362	2266	1717327	1969-06-12	1969-06-26	1	-189
36398	2476	1125315	1970-02-27	1970-03-20	1	78
41932	2842	1112807	1979-11-09	1979-11-23	1	3613
11512	785	1503184	1977-12-04	1978-11-29	1	3254
3152	209	1125315	1958-10-15	1958-10-22	1	-4089
43455	2939	1112807	1964-06-21	1964-07-19	1	-1992
41281	2801	715997	1997-12-27	1997-12-27	1	10222
8263	573	1759842	2015-11-27	2015-12-04	1	16773
37597	2554	1125315	1942-06-20	1942-07-04	1	-10043
75907	5197	1322184	2012-05-08	2012-05-08	1	15468
41223	2798	1778162	2015-05-19	2015-06-02	1	16588
39678	2699	738818	1980-11-18	1980-11-25	1	3981
63396	4330	1125315	1964-03-31	1964-04-07	1	-2095
31653	2141	1729720	1955-10-20	1955-10-27	1	-5180
73377	5017	1125315	1996-09-16	1996-09-23	1	9762
38790	2636	1125315	1975-06-26	1975-07-31	1	2037
74779	5117	1125315	1993-07-02	1993-07-09	1	8590
42815	2898	1177480	1979-09-13	1979-09-27	1	3556
40911	2776	1125315	1982-01-28	1982-02-11	1	4424
37516	2550	1759842	1997-07-24	1997-10-02	1	10136
75731	5185	1115008	2000-01-04	2000-03-11	1	11027
77341	5285	1174888	2008-07-06	2008-07-06	1	14066
35435	2409	1125315	2002-12-16	2002-12-23	1	12044
40979	2780	1729720	1958-12-30	1959-01-11	1	-4008
77949	5325	1125315	1955-01-10	1955-02-09	1	-5440
70682	4828	1177480	1974-11-28	1974-12-19	1	1813
47653	3236	1125315	1953-08-06	1953-08-20	1	-5978
41135	2792	1125315	2012-04-26	2012-05-03	1	15463
51556	3513	933724	2010-06-01	2010-06-08	1	14768
38046	2586	1177480	1979-01-04	1979-01-18	1	3304
73609	5035	1112807	1935-05-07	1935-05-28	1	-12637
68169	4653	1119510	2011-06-28	2011-07-12	1	15167
56596	3856	1515774	1991-09-09	1992-09-03	1	8281
44066	2980	1728416	1975-02-22	1975-03-08	1	1892
48599	3304	1125315	1990-08-03	1990-08-10	1	7526
36491	2482	19127890	1991-08-24	1994-08-08	3	8985
27290	1843	1759842	2013-04-23	2013-05-14	1	15839
47018	3189	1102527	1985-09-27	1985-09-27	1	5748
39404	2680	1759842	2008-12-26	2009-01-02	1	14246
45039	3059	1112807	1975-03-13	1975-03-27	1	1911
42413	2872	1112807	1954-03-31	1954-04-14	1	-5741
10425	715	1125315	2008-06-17	2008-07-01	1	14061
36117	2456	1125315	2002-04-17	2002-05-01	1	11808
58630	3997	1729720	1967-05-21	1967-06-02	1	-944
61760	4214	1728416	1975-11-13	1975-11-27	1	2156
37642	2556	1125315	1978-05-14	1978-05-21	1	3062
43256	2926	19127890	2005-07-24	2006-07-19	1	13348
44116	2985	1125315	1981-04-16	1981-04-30	1	4137
49667	3383	1112807	1988-04-06	1988-05-06	1	6700
33363	2266	1125315	1978-06-25	1978-07-16	1	3118
36399	2476	1125315	1971-04-08	1971-04-22	1	476
41933	2842	1118084	1995-12-05	1995-12-05	1	9469
11513	785	1521369	1977-12-04	1978-11-29	1	3254
3153	209	1713332	2003-01-21	2003-02-04	1	12087
43456	2939	1125315	1963-12-24	1964-01-07	1	-2186
41282	2801	1119510	1931-06-16	1931-06-30	1	-14065
8458	587	1118084	2015-06-01	2015-06-01	1	16587
37598	2554	1361711	1999-12-02	1999-12-02	1	10927
75908	5197	1728416	1956-06-17	1956-07-01	1	-4932
41224	2798	1112807	1967-11-27	1967-12-25	1	-738
39679	2699	933724	2008-12-07	2008-12-14	1	14227
63397	4330	1125315	1968-09-04	1968-11-03	1	-424
31654	2141	1759842	1995-10-30	1995-11-13	1	9447
73378	5017	1729720	1981-11-05	1981-11-15	1	4336
38791	2636	1125315	1989-12-25	1990-01-01	1	7305
74780	5117	1192710	1960-03-30	1960-03-30	1	-3564
42816	2898	1177480	1980-03-24	1980-04-07	1	3749
40912	2776	1125315	1984-11-21	1984-12-05	1	5452
37517	2550	933724	2012-02-08	2012-02-15	1	15385
75732	5185	1115008	2009-09-06	2009-09-20	1	14507
77342	5285	1539403	2007-02-25	2007-02-25	1	13569
35436	2409	1125315	2013-06-27	2013-07-04	1	15890
40980	2780	1125315	1956-02-17	1956-03-02	1	-5053
77950	5325	1125315	1989-10-22	1989-10-22	1	7234
70683	4828	738818	2009-07-14	2009-07-21	1	14446
47654	3236	1125315	1958-10-29	1958-10-29	1	-4082
41136	2792	1713332	1973-09-19	1973-10-03	1	1371
51557	3513	1125315	1991-02-18	1991-02-25	1	7725
39527	2688	1713332	1987-07-06	1987-07-13	1	6402
73610	5035	1125315	1976-07-21	1976-08-04	1	2407
68170	4653	1125315	1960-02-17	1960-03-09	1	-3585
56597	3856	1521369	1989-09-19	1990-09-14	1	7561
44067	2980	1738521	1974-06-06	1974-06-20	1	1631
48600	3304	1729720	1985-10-13	1985-10-21	1	5772
36492	2482	1115008	1995-03-03	1995-05-02	1	9252
27568	1861	1115008	1995-02-28	1995-04-29	1	9249
47019	3189	1503184	1984-05-17	1985-05-12	1	5610
39405	2680	1125315	1978-12-18	1979-01-01	1	3287
45040	3059	1124957	2008-09-17	2008-09-17	1	14139
42414	2872	1118084	1998-10-11	1998-10-11	1	10510
10426	715	1503184	1998-02-06	1999-02-01	1	10623
36118	2456	1717327	1961-01-06	1961-01-20	1	-3268
58631	3997	1729720	1973-04-27	1973-05-10	1	1225
61761	4214	1729720	1990-03-08	1990-03-20	1	7383
37643	2556	1125315	2007-12-14	2008-01-18	2	13896
43257	2926	1125315	1984-09-04	1984-09-11	1	5367
44117	2985	1125315	1990-10-09	1991-01-07	2	7676
49668	3383	1595799	2004-03-23	2005-03-18	1	12860
33364	2266	1125315	1985-10-17	1985-10-24	1	5775
36400	2476	1713332	1985-05-29	1985-06-12	1	5641
41934	2842	1119510	2002-02-23	2002-03-02	1	11748
11514	785	1713332	2007-07-21	2007-08-11	1	13736
3154	209	914335	1976-12-31	1976-12-31	1	2556
43457	2939	1503184	1978-11-15	1979-11-10	1	3600
41283	2801	1125315	2002-03-25	2002-03-25	2	11771
8459	587	1177480	1983-10-22	1983-11-05	1	5056
37599	2554	1759842	1969-05-30	1969-06-13	1	-202
75909	5197	738818	1986-10-21	1986-11-04	1	6151
41225	2798	1112807	1973-05-27	1973-06-24	1	1270
39680	2699	1119510	2018-06-03	2018-06-17	1	17699
63398	4330	1125315	2000-01-04	2000-01-11	1	10967
35358	2402	1125315	1978-03-20	1978-04-03	1	3014
74595	5103	738818	1992-07-21	1992-08-04	1	8251
38792	2636	1174888	2019-03-08	2019-03-08	1	17963
74781	5117	1503184	1974-02-24	1975-02-19	1	1875
42817	2898	1177480	1981-04-20	1981-05-04	1	4141
40913	2776	1125315	1987-03-01	1987-03-08	1	6275
37518	2550	1125315	2018-02-09	2018-04-10	1	17631
75733	5185	1119510	2012-03-23	2012-03-30	1	15429
77343	5285	1545958	2008-07-06	2008-07-06	1	14066
35437	2409	920293	2013-12-16	2013-12-23	1	16062
40981	2780	1125315	1993-12-13	1993-12-20	1	8754
77951	5325	1125315	1991-11-22	1991-11-29	1	8002
70684	4828	1118084	2014-01-07	2014-01-07	1	16077
47655	3236	1174888	1958-10-29	1958-10-29	1	-4082
41137	2792	1713332	2014-07-10	2014-07-17	1	16268
51558	3513	1177480	1992-12-13	1992-12-27	1	8396
39528	2688	1717327	1963-01-17	1963-01-31	1	-2527
73611	5035	1125315	1982-03-02	1982-03-16	1	4457
68171	4653	1759842	1982-12-19	1983-01-09	1	4756
56598	3856	1713332	1975-04-04	1975-04-11	1	1926
44068	2980	1738521	1975-12-10	1975-12-24	1	2183
48601	3304	1112807	1986-05-29	1986-06-19	1	6013
36493	2482	1125315	1974-12-11	1974-12-25	1	1819
27569	1861	1115008	2000-02-02	2000-02-23	1	11010
47020	3189	1503184	1986-05-07	1987-05-02	1	6330
39406	2680	1125315	2014-12-13	2015-01-03	1	16438
45041	3059	1177480	2012-06-28	2012-07-19	1	15540
42415	2872	1309944	1971-09-07	1971-09-07	1	614
10427	715	1521369	1998-02-06	1999-02-01	1	10623
36119	2456	1728416	1956-05-18	1956-06-01	1	-4962
58632	3997	1759842	1992-08-30	1992-09-13	1	8291
61762	4214	1738521	1978-06-23	1978-07-07	1	3109
37644	2556	738818	1982-07-01	1982-07-15	1	4578
43258	2926	1125315	1990-10-12	1990-10-26	1	7603
44118	2985	1125315	1994-12-03	1994-12-17	1	9116
49669	3383	1713332	1989-05-31	1989-06-14	1	7104
33365	2266	1713332	1980-03-24	1980-04-07	1	3749
36401	2476	1759842	1985-05-29	1985-06-12	1	5641
41935	2842	1125315	1973-01-10	1973-01-17	1	1112
11515	785	1738521	1968-10-12	1968-10-26	1	-432
3155	209	920293	1985-04-02	1985-04-09	1	5577
43458	2939	1503184	1981-10-30	1982-10-25	1	4680
41284	2801	1759842	1966-03-25	1966-06-03	1	-1308
8460	587	1503184	1998-02-15	1999-02-10	1	10632
37600	2554	933724	1967-08-18	1967-08-25	1	-860
75910	5197	782043	1962-06-06	1962-06-06	1	-2766
41226	2798	1125315	1963-06-23	1963-07-07	1	-2370
39681	2699	1125315	1980-11-18	1980-11-25	1	3981
63399	4330	1713332	1987-11-24	1987-12-08	1	6550
35359	2402	1125315	1983-03-11	1983-04-08	1	4845
74596	5103	1115008	2014-12-05	2015-01-02	1	16437
38793	2636	1177480	2013-04-26	2013-05-31	1	15856
74782	5117	1713332	2010-11-14	2010-11-28	1	14941
42818	2898	1192710	1980-03-29	1980-03-29	1	3740
41697	2827	933724	1968-06-27	1968-07-11	1	-539
37519	2550	1521369	1998-01-07	1999-01-02	1	10593
75734	5185	1125315	2012-03-23	2012-03-30	1	15429
77344	5285	1729720	1950-09-27	1950-10-04	1	-7029
35438	2409	933724	2007-11-04	2007-11-11	1	13828
40982	2780	1125315	2014-10-24	2014-11-14	1	16388
77952	5325	757627	2018-03-11	2018-03-11	1	17601
70685	4828	1713332	1969-09-02	1969-09-16	1	-107
47656	3236	1177480	1994-06-07	1994-06-21	1	8937
41138	2792	1729720	1968-12-28	1969-01-04	1	-362
51559	3513	1729720	1985-12-04	1985-12-12	1	5824
39529	2688	1759842	1987-07-06	1987-07-13	1	6402
73612	5035	1177480	1997-08-14	1997-10-13	1	10147
68172	4653	1177480	2002-06-17	2002-07-01	1	11869
56599	3856	1729720	1983-01-04	1983-01-11	1	4758
44069	2980	1759842	1984-04-16	1984-05-07	1	5240
48602	3304	1119510	1990-08-03	1990-08-10	1	7526
36494	2482	1125315	1990-06-04	1990-06-11	1	7466
27570	1861	1118084	2019-02-02	2019-02-02	1	17929
47021	3189	1521369	1981-06-02	1982-05-28	1	4530
39407	2680	19127890	1990-02-13	1991-02-08	1	7708
45042	3059	1717327	1975-03-13	1975-03-27	1	1911
42416	2872	1322184	1998-03-31	1999-08-17	1	10820
10428	715	1713332	2000-11-10	2000-11-17	1	11278
36120	2456	1729720	1981-10-21	1981-10-28	1	4318
58633	3997	1759842	2013-03-22	2013-04-12	1	15807
62277	4250	1112807	1949-01-11	1949-01-25	1	-7646
37645	2556	1118084	2004-06-03	2004-06-03	1	12572
43259	2926	1177480	2018-10-04	2018-11-08	1	17843
44119	2985	1125315	2006-05-01	2006-05-08	1	13276
49670	3383	19127890	2002-04-03	2003-03-29	1	12140
33366	2266	1759842	1980-03-24	1980-04-07	1	3749
36402	2476	1119510	1966-07-15	1966-07-29	1	-1252
41936	2842	1125315	1982-06-19	1982-07-03	1	4566
11516	785	1759842	2007-07-21	2007-08-11	1	13736
3156	209	1124957	2003-01-21	2003-01-21	1	12073
43459	2939	1503184	1983-10-20	1984-10-14	1	5400
44318	3000	1125315	1951-07-01	1951-07-15	1	-6745
8461	587	1503184	2000-02-05	2001-01-30	1	11352
37601	2554	1112807	1939-05-18	1939-06-01	1	-11172
75911	5197	1000560	1962-06-05	1962-06-06	2	-2767
41227	2798	1503184	1978-08-11	1980-07-31	2	3864
39682	2699	1177480	1989-07-20	1989-08-10	1	7161
63400	4330	1713332	2013-08-15	2013-09-05	1	15953
35360	2402	1125315	1998-02-16	1998-02-23	1	10280
74597	5103	1125315	1992-07-21	1992-08-04	1	8251
38794	2636	1322184	1997-07-04	2019-03-08	1	17963
76233	5213	1713332	2010-07-31	2010-08-14	1	14835
42819	2898	1503184	1993-01-12	1994-01-07	1	8772
41698	2827	1112807	1936-11-04	1936-12-02	1	-12083
37520	2550	1729720	1986-05-02	1986-05-09	1	5972
75735	5185	1713332	2019-02-17	2019-02-17	1	17944
78055	5331	1125315	2017-02-17	2017-03-24	2	17249
35439	2409	1119510	2013-06-27	2013-07-04	1	15890
40983	2780	1728416	1960-04-10	1960-04-24	1	-3539
77953	5325	1112807	1946-06-05	1946-06-19	1	-8597
70686	4828	1738521	1972-02-20	1972-03-05	1	794
47657	3236	1307863	1982-12-24	1982-12-24	1	4740
41139	2792	1112807	1962-07-24	1962-08-07	1	-2704
53051	3615	1125315	1962-05-30	1962-05-30	1	-2773
39530	2688	1125315	1964-06-12	1964-06-26	1	-2015
73613	5035	1310149	2011-08-15	2011-08-15	1	15201
68173	4653	1713332	1972-09-17	1972-10-08	1	1011
56600	3856	1738521	1975-05-26	1975-06-09	1	1985
44649	3026	1112807	1971-07-28	1971-10-26	1	663
48603	3304	1124957	1975-06-26	1975-06-26	1	2002
36495	2482	1515774	1989-09-03	1990-08-29	1	7545
27571	1861	1125315	1982-03-28	1982-04-11	1	4483
47022	3189	738818	2002-12-01	2002-12-15	1	12036
39408	2680	1115008	1996-05-16	1996-05-30	1	9646
45043	3059	1759842	2001-11-04	2001-11-25	1	11651
42417	2872	1343916	1971-09-07	1971-09-07	1	614
10429	715	1759842	2000-11-10	2000-11-17	1	11278
36121	2456	1759842	2018-06-09	2018-06-23	1	17705
60645	4137	1115008	2006-08-09	2006-08-23	1	13383
62278	4250	1125315	1974-03-11	1974-03-25	1	1544
37646	2556	1125315	1982-07-01	1982-07-15	1	4578
43260	2926	1515774	1999-08-25	2001-08-14	2	11548
44120	2985	1738521	1968-07-19	1968-08-02	1	-517
49671	3383	1124300	2018-06-03	2018-06-03	1	17685
33367	2266	1768849	1984-03-18	1984-04-01	1	5204
36403	2476	1125315	1966-07-15	1966-07-29	1	-1252
41937	2842	1125315	1989-07-16	1989-07-23	1	7143
12717	871	1118084	2003-12-30	2003-12-30	1	12416
3157	209	1759842	1981-01-07	1981-01-21	1	4038
43460	2939	1521369	1974-12-06	1975-12-01	1	2160
44319	3000	1177480	2010-04-20	2010-05-25	1	14754
8462	587	1713332	1986-06-17	1986-07-08	1	6032
37602	2554	1125315	1933-12-26	1934-01-02	1	-13148
75912	5197	1125315	1987-07-27	1987-08-10	1	6430
41228	2798	1125315	1976-07-08	1976-07-29	1	2401
39683	2699	1503184	1986-11-03	1988-10-23	2	6870
63401	4330	1728416	1948-04-18	1948-05-02	1	-7914
35361	2402	1759842	2011-09-16	2011-10-07	1	15254
74598	5103	1112807	1944-08-06	1944-09-03	1	-9251
38795	2636	1545958	2019-03-08	2019-03-08	1	17963
76234	5213	1759842	1952-07-08	1952-07-22	1	-6372
42820	2898	1503184	1995-01-02	1995-12-28	1	9492
41699	2827	1112807	1968-03-19	1968-04-02	1	-639
37521	2550	19127890	1999-12-28	2000-12-22	1	11313
75736	5185	1729720	1949-10-25	1949-11-07	1	-7360
78056	5331	19127890	1979-07-17	1980-07-11	1	3844
35440	2409	1125315	1989-07-05	1989-07-19	1	7139
43880	2965	1112807	1987-09-06	1987-10-06	1	6487
77954	5325	1112807	1948-11-21	1948-12-21	1	-7681
70687	4828	738818	2000-07-17	2000-07-31	1	11169
47658	3236	1112807	1930-07-28	1930-10-26	1	-14312
41140	2792	1125315	2008-05-21	2008-05-28	1	14027
53052	3615	1713332	1990-07-08	1990-07-29	1	7514
39531	2688	1125315	2008-12-27	2009-01-10	1	14254
73614	5035	1713332	1976-06-28	1976-07-05	1	2377
70128	4791	738818	1970-03-12	1970-03-26	1	84
56601	3856	920293	1998-10-23	1998-10-29	1	10528
44650	3026	1124957	2019-06-07	2019-06-07	1	18054
48604	3304	1125315	1963-09-06	1963-09-20	1	-2295
36496	2482	1515774	1991-08-24	1994-08-08	3	8985
27572	1861	1125315	1986-10-24	1986-11-07	1	6154
47023	3189	1112807	1965-09-14	1965-09-28	1	-1556
39409	2680	1118084	2007-10-17	2007-10-17	1	13803
45044	3059	1177480	2008-09-17	2008-10-17	1	14169
42418	2872	1539403	1992-03-17	1992-03-17	1	8111
15251	1058	975125	1958-02-27	1958-03-13	1	-4312
36122	2456	738818	1972-11-06	1972-11-20	1	1054
60646	4137	1112807	1963-01-15	1963-01-29	1	-2529
62279	4250	1713332	1971-03-01	1971-03-15	1	438
37647	2556	1125315	1991-05-28	1991-06-11	1	7831
43261	2926	1515774	2002-08-09	2003-08-04	1	12268
44121	2985	1738521	1976-10-16	1976-10-30	1	2494
49672	3383	1512674	2011-02-15	2012-02-10	1	15380
33368	2266	1118084	2008-04-28	2008-04-28	1	13997
36404	2476	1759842	2000-01-18	2000-02-08	1	10995
41938	2842	1125315	2002-02-23	2002-03-02	1	11748
12718	871	1125315	1967-11-09	1968-01-08	1	-724
3158	209	1778162	1992-04-18	1992-05-02	1	8157
43461	2939	19127890	1983-10-20	1984-10-14	1	5400
44320	3000	1112807	1965-12-13	1966-01-03	1	-1459
8463	587	1759842	1986-06-17	1986-07-08	1	6032
37603	2554	1125315	1950-08-27	1950-09-17	1	-7046
75913	5197	1125315	1995-08-28	1995-09-18	1	9391
41229	2798	1125315	2005-09-27	2005-10-04	1	13060
39684	2699	1521369	1991-10-08	1992-10-02	1	8310
63402	4330	1728416	1948-06-28	1948-07-12	1	-7843
35362	2402	1112807	1987-01-17	1987-02-07	1	6246
74599	5103	1112807	1962-02-20	1962-03-13	1	-2851
38796	2636	1717327	1964-03-25	1964-04-08	1	-2094
76235	5213	1759842	2010-07-31	2010-08-14	1	14835
42821	2898	1503184	1997-12-17	1998-12-12	1	10572
41700	2827	1307863	2000-12-26	2000-12-26	1	11317
38203	2598	1119510	2017-04-29	2017-05-13	1	17299
75737	5185	1759842	1943-11-27	1943-12-04	1	-9525
78057	5331	19127890	1981-07-06	1982-07-01	1	4564
35441	2409	1549786	1994-09-24	1995-09-19	1	9392
43881	2965	1125315	2000-08-15	2000-08-29	1	11198
77955	5325	1112807	1952-01-05	1952-01-26	1	-6550
70688	4828	1112807	1967-07-09	1967-07-23	1	-893
47659	3236	1124300	1958-05-12	1958-05-12	1	-4252
41141	2792	1713332	1959-05-08	1959-05-29	1	-3870
53053	3615	1759842	1990-07-08	1990-07-29	1	7514
39532	2688	1713332	2010-12-16	2010-12-23	1	14966
73615	5035	1713332	1995-01-21	1995-02-11	1	9172
70129	4791	1118084	2004-08-03	2004-08-03	1	12633
56602	3856	1112807	1979-07-22	1979-08-05	1	3503
44651	3026	1125315	1955-03-25	1955-04-08	1	-5382
48605	3304	1729720	1989-03-05	1989-03-16	1	7014
36497	2482	1549786	1991-08-24	1994-08-08	3	8985
27573	1861	1125315	1995-02-28	1995-02-28	1	9189
47024	3189	1112807	1973-01-05	1973-01-26	1	1121
39410	2680	1125315	1987-05-11	1987-08-09	1	6429
45045	3059	1713332	2005-08-12	2005-08-19	1	13014
42704	2894	715997	1999-11-13	1999-11-13	1	10908
15252	1058	1115008	1996-07-20	1996-08-10	1	9718
36123	2456	1112807	1956-05-18	1956-06-01	1	-4962
60647	4137	1118084	2002-07-09	2002-07-09	1	11877
62280	4250	920293	1964-03-29	1964-04-12	2	-2090
37648	2556	1713332	2007-12-14	2008-01-18	1	13896
43262	2926	1521369	1995-09-15	1996-09-09	1	9748
44122	2985	1759842	2001-06-19	2001-07-10	1	11513
49673	3383	1713332	1993-10-13	1993-10-27	1	8700
33369	2266	1125315	1991-04-28	1991-05-05	1	7794
37072	2522	1124300	1991-01-24	1991-01-24	1	7693
41939	2842	1125315	1995-04-23	1995-04-30	1	9250
12719	871	1125315	2001-09-03	2001-09-10	1	11575
3159	209	1125315	1992-04-18	1992-05-02	1	8157
43462	2939	1728416	1963-12-24	1964-01-07	1	-2186
44321	3000	1125315	1975-08-28	1975-11-03	1	2132
8464	587	1521369	1998-02-15	1999-02-10	1	10632
37604	2554	1125315	1991-07-22	1991-07-29	1	7879
75914	5197	1154029	1962-06-06	1962-06-06	1	-2766
41230	2798	1125315	2015-05-19	2015-06-02	1	16588
39685	2699	1713332	1989-09-09	1989-09-23	1	7205
63403	4330	1759842	2006-06-03	2006-06-24	1	13323
35363	2402	1125315	1977-07-10	1977-07-24	1	2761
74600	5103	1322184	2014-02-03	2014-02-03	1	16104
38797	2636	738818	2014-11-15	2014-11-29	1	16403
76236	5213	1112807	1942-09-14	1942-09-28	1	-9957
42822	2898	1729720	1991-09-27	1991-10-05	1	7947
41701	2827	1713332	1927-09-29	1927-10-13	1	-15421
38204	2598	1125315	2003-07-19	2003-07-26	1	12259
75738	5185	1759842	2019-02-17	2019-02-17	1	17944
78058	5331	1503184	1979-07-17	1980-07-11	1	3844
35864	2437	1125315	1995-05-13	1995-05-20	1	9270
43669	2950	701322	2013-02-24	2013-02-24	1	15760
77956	5325	1118084	1985-08-14	1985-08-14	1	5704
70689	4828	1112807	1972-02-20	1972-03-05	1	794
47660	3236	1125315	1948-05-26	1948-06-09	1	-7876
41142	2792	1728416	1958-02-04	1958-02-18	1	-4335
53054	3615	738818	1977-06-15	1977-06-29	1	2736
39533	2688	1759842	2015-12-03	2015-12-17	1	16786
73616	5035	1713332	1997-02-06	1997-02-13	1	9905
70130	4791	1125315	1969-11-10	1969-11-24	1	-38
56603	3856	1124300	2012-02-05	2012-02-05	1	15375
44652	3026	1125315	1958-07-06	1958-07-20	1	-4183
48606	3304	1729720	1998-11-27	1998-12-08	1	10568
37943	2580	1119510	1963-07-15	1963-07-29	1	-2348
27574	1861	1174888	1995-02-28	1995-02-28	1	9189
47025	3189	1112807	1987-10-17	1987-11-07	1	6519
39411	2680	1125315	2009-06-14	2009-07-12	1	14437
45046	3059	1759842	2005-08-12	2005-08-19	1	13014
42705	2894	738818	1986-05-08	1986-05-22	1	5985
15253	1058	1125315	1956-07-20	1956-08-03	1	-4899
36124	2456	1119510	1959-11-30	1959-12-14	1	-3671
60648	4137	1125315	1999-04-06	1999-05-04	1	10715
62281	4250	933724	1964-03-29	1964-04-12	1	-2090
38307	2604	1115008	2017-05-18	2017-06-01	1	17318
43263	2926	1589505	2003-08-04	2004-07-29	1	12628
44123	2985	19127890	1983-09-14	1986-08-29	3	6084
51353	3501	1112807	1968-02-17	1968-03-23	1	-649
33370	2266	1125315	1995-05-31	1995-06-14	1	9295
37073	2522	1174888	2000-07-24	2000-07-24	1	11162
41940	2842	1713332	2000-10-06	2000-10-20	1	11250
12720	871	1503184	1980-01-15	1981-01-09	1	4026
3160	209	1125315	2003-01-21	2003-01-21	1	12073
43463	2939	1729720	1977-03-27	1977-04-07	1	2653
44322	3000	1125315	2003-03-24	2003-03-31	1	12142
8465	587	1521369	2000-02-05	2001-01-30	1	11352
37605	2554	1177480	2015-12-26	2016-03-25	1	16885
75915	5197	1177480	2009-04-07	2009-05-05	1	14369
41231	2798	1521369	1978-08-11	1980-07-31	2	3864
39686	2699	1713332	1992-04-29	1992-05-20	1	8175
63404	4330	1759842	2015-09-30	2015-10-21	1	16729
35364	2402	1125315	1980-02-26	1980-03-04	1	3715
74601	5103	1332418	2014-02-03	2014-02-03	1	16104
38798	2636	1125315	2014-11-15	2014-11-29	1	16403
76237	5213	1118084	1977-11-23	1977-11-23	1	2883
42823	2898	1768849	1982-07-22	1982-08-05	1	4599
41702	2827	1759842	1985-08-22	1985-08-29	1	5719
38205	2598	1713332	2004-02-05	2004-02-19	1	12467
75739	5185	1778162	2009-09-06	2009-09-20	1	14507
78059	5331	1503184	1981-07-06	1982-07-01	1	4564
35865	2437	1759842	1972-11-04	1972-11-18	1	1052
43670	2950	1112807	1982-04-15	1982-06-14	1	4547
77957	5325	1713332	1963-02-04	1963-02-25	1	-2502
70690	4828	1115008	2000-11-02	2000-11-23	1	11284
47661	3236	1125315	1952-02-05	1952-02-12	1	-6533
41143	2792	1112807	1958-02-04	1958-02-18	1	-4335
53055	3615	1118084	1983-12-11	1983-12-11	1	5092
39534	2688	1124300	2001-08-25	2001-08-25	1	11559
73617	5035	1759842	1995-01-21	1995-02-11	1	9172
70131	4791	1125315	1970-03-12	1970-03-26	1	84
56604	3856	1125315	1984-06-18	1984-06-25	1	5289
44653	3026	1125315	1966-06-09	1966-06-16	1	-1295
48607	3304	1125315	1975-06-26	1975-07-26	2	2032
37944	2580	1119510	1989-07-29	1989-08-12	1	7163
27575	1861	1713332	1993-08-30	1993-09-20	1	8663
47026	3189	1118084	2000-03-29	2000-03-29	1	11045
39412	2680	1515774	1990-02-13	1991-02-08	1	7708
45047	3059	1125315	1972-07-07	1972-07-21	1	932
42706	2894	1125315	1986-11-30	1986-12-07	1	6184
15254	1058	1125315	1976-09-05	1976-09-19	1	2453
36125	2456	1125315	1961-01-06	1961-01-20	1	-3268
60649	4137	1713332	2002-10-07	2002-11-18	1	12009
62282	4250	1112807	1950-07-05	1950-07-19	1	-7106
38308	2604	1119510	2016-11-21	2016-12-05	1	17140
43264	2926	19127890	1999-08-25	2001-08-14	2	11548
44124	2985	1125315	1969-10-18	1969-10-25	1	-68
51354	3501	1112807	1969-01-17	1969-02-07	1	-328
33371	2266	1125315	2006-12-07	2006-12-21	1	13503
37074	2522	1521369	1976-06-16	1978-06-06	2	3078
41941	2842	1759842	2000-10-06	2000-10-20	1	11250
12721	871	1713332	2014-09-28	2014-10-19	1	16362
3161	209	1125315	2016-05-03	2016-05-17	1	16938
43464	2939	1729720	1977-08-06	1977-08-17	1	2785
44323	3000	1112807	1948-09-13	1948-09-27	1	-7766
8466	587	1515774	1995-03-03	1997-02-20	2	9912
37606	2554	1557272	2003-12-25	2003-12-25	1	12411
75916	5197	1713332	2005-08-12	2005-08-19	1	13014
41232	2798	1713332	2013-08-06	2013-08-27	1	15944
39687	2699	1729720	2007-01-08	2007-01-15	1	13528
63405	4330	1112807	1948-04-18	1948-05-02	1	-7914
35365	2402	1154343	1978-09-20	1978-09-20	1	3184
74602	5103	1759842	1948-04-10	1948-04-24	1	-7922
38799	2636	1125315	2018-07-04	2018-07-18	1	17730
76238	5213	1125315	1942-11-23	1942-11-30	1	-9894
46756	3176	738818	1979-04-28	1979-05-12	1	3418
41703	2827	1177480	1984-04-08	1984-05-13	1	5246
38206	2598	1759842	2004-02-05	2004-02-19	1	12467
1022	69	1112807	1949-05-28	1949-06-18	1	-7502
78060	5331	1759842	2001-07-21	2001-08-11	1	11545
35866	2437	1778162	2001-11-24	2001-12-29	1	11685
43671	2950	1125315	2014-02-11	2014-04-12	2	16172
77958	5325	1729720	1952-10-03	1952-10-14	1	-6288
70691	4828	1119510	2009-07-14	2009-07-21	1	14446
47662	3236	1322184	2016-07-15	2016-07-15	1	16997
41144	2792	1112807	1958-11-01	1958-12-01	1	-4049
53056	3615	1125315	1960-09-02	1960-10-07	1	-3373
39535	2688	1125315	1964-08-17	1964-08-31	1	-1949
73618	5035	1759842	1997-02-06	1997-02-13	1	9905
70132	4791	1125315	1989-10-27	1989-11-10	1	7253
56605	3856	1503184	1989-09-19	1990-09-14	1	7561
44654	3026	1728416	1958-07-06	1958-07-20	1	-4183
48608	3304	1125315	1977-07-15	1977-10-13	1	2842
37945	2580	1119510	1991-10-03	1991-10-10	1	7952
27576	1861	1125315	1993-12-30	1994-02-03	1	8799
47027	3189	1125315	2002-12-01	2002-12-15	1	12036
39413	2680	1549786	1990-02-13	1991-02-08	1	7708
45048	3059	1125315	1978-01-09	1978-01-16	1	2937
42707	2894	1125315	1991-02-24	1991-02-24	2	7724
15255	1058	1125315	2009-03-09	2009-03-23	1	14326
36126	2456	1125315	1968-02-15	1968-03-16	1	-656
60650	4137	1115008	2013-02-17	2013-03-17	1	15781
62283	4250	1124300	1982-05-13	1982-05-13	1	4515
38309	2604	1125315	1957-10-15	1957-10-29	1	-4447
43265	2926	19127890	2002-08-09	2003-08-04	1	12268
44125	2985	1125315	1993-01-26	1993-02-09	1	8440
51355	3501	1118084	1985-03-09	1985-03-09	1	5546
33372	2266	1738521	1971-12-11	1971-12-25	1	723
37075	2522	738818	1959-05-08	1959-05-15	1	-3884
43538	2944	738818	1981-09-02	1981-09-16	1	4276
12722	871	1728416	1968-12-03	1968-12-17	1	-380
3162	209	1713332	1981-01-07	1981-01-21	1	4038
43465	2939	19127890	1978-11-15	1979-11-10	1	3600
44324	3000	1112807	1961-04-08	1961-07-07	1	-3100
8467	587	1521369	1994-03-08	1995-03-03	1	9192
37607	2554	1713332	1988-09-28	1988-10-05	1	6852
75917	5197	1112807	1959-03-21	1959-04-25	1	-3904
41233	2798	1759842	2017-10-13	2017-10-20	1	17459
39688	2699	1759842	1989-09-09	1989-09-23	1	7205
63406	4330	1112807	1948-06-28	1948-07-12	1	-7843
35366	2402	1192710	1977-11-19	1977-11-19	1	2879
74603	5103	1112807	1946-07-25	1946-08-15	1	-8540
38800	2636	1361711	1997-07-04	2019-03-08	1	17963
76239	5213	1125315	2003-11-11	2003-11-18	1	12374
46757	3176	1177480	1989-02-16	1989-03-16	1	7014
41704	2827	1177480	1999-06-24	1999-07-29	1	10801
38207	2598	1119510	1994-02-24	1994-03-03	1	8827
1023	69	738818	2000-11-15	2000-11-22	1	11283
78061	5331	1118084	2004-09-03	2004-09-03	1	12664
35867	2437	1112807	1963-08-11	1963-09-10	1	-2305
43672	2950	1713332	1943-03-15	1943-04-05	1	-9768
77959	5325	1729720	2009-02-28	2009-03-08	1	14311
70692	4828	1125315	2000-07-17	2000-07-31	1	11169
47663	3236	738818	1987-03-27	1987-04-10	1	6308
41145	2792	1112807	1972-03-22	1972-04-05	1	825
53057	3615	1125315	1970-07-13	1970-07-20	1	200
39536	2688	1125315	1970-01-27	1970-02-10	1	40
73619	5035	701322	2010-07-29	2010-07-29	1	14819
70133	4791	1119510	1970-03-12	1970-03-26	1	84
56606	3856	1549786	1991-09-09	1992-09-03	1	8281
44655	3026	1119510	1966-06-09	1966-06-16	1	-1295
48609	3304	1125315	1997-06-06	1997-06-13	1	10025
37946	2580	1125315	1962-10-07	1962-10-21	1	-2629
27577	1861	1125315	2015-05-05	2015-05-19	1	16574
47028	3189	1177480	2015-10-11	2015-12-10	1	16779
39414	2680	1713332	2008-12-26	2009-01-02	1	14246
45049	3059	1125315	1978-05-07	1978-05-28	1	3069
42708	2894	1112807	1923-01-07	1923-02-13	1	-17124
15256	1058	1713332	2007-02-09	2007-02-23	1	13567
36127	2456	1125315	1972-11-06	1972-11-20	1	1054
60651	4137	1125315	1976-08-23	1976-08-30	1	2433
62284	4250	1713332	2008-07-19	2008-08-09	1	14100
38310	2604	1125315	1962-01-08	1962-01-22	1	-2901
43266	2926	1118084	2017-10-29	2017-10-29	1	17468
44126	2985	1125315	2017-10-12	2017-10-26	1	17465
51356	3501	1125315	1995-07-13	1995-07-27	1	9338
33373	2266	1112807	1993-03-29	1993-04-19	1	8509
37076	2522	1125315	1959-05-08	1959-05-15	1	-3884
43539	2944	1112807	1960-03-31	1960-04-14	1	-3549
12723	871	1759842	2014-09-28	2014-10-19	1	16362
3163	209	1177480	2003-01-21	2003-02-04	1	12087
43466	2939	19127890	1981-10-30	1982-10-25	1	4680
44325	3000	1115008	1994-09-29	1994-10-20	1	9058
8468	587	1768849	1983-10-22	1983-11-05	1	5056
37608	2554	1729720	1940-02-08	1940-02-20	1	-10908
75918	5197	1119510	1986-10-21	1986-11-04	1	6151
42642	2891	1125315	1974-10-20	1974-10-27	1	1760
39689	2699	1759842	1992-04-29	1992-05-20	1	8175
63407	4330	1119510	1964-03-31	1964-04-07	1	-2095
35367	2402	1551099	1990-08-31	1990-08-31	1	7547
74604	5103	1112807	1957-12-15	1958-01-12	1	-4372
40855	2774	1112807	1941-01-16	1941-01-30	1	-10563
76240	5213	1112807	1941-03-02	1941-03-16	1	-10518
46758	3176	1759842	1999-06-11	1999-06-25	1	10767
41705	2827	1729720	1934-10-14	1934-10-21	1	-12856
38208	2598	1125315	2007-04-25	2007-05-02	1	13635
1024	69	1119510	1955-12-24	1956-01-07	1	-5108
78062	5331	1125315	1970-03-26	1970-05-25	1	144
35868	2437	1124300	1998-10-17	1998-10-17	1	10516
43673	2950	1713332	2014-06-13	2014-07-04	1	16255
697	43	1112807	1987-03-10	1987-04-09	1	6307
70693	4828	1125315	2009-07-14	2009-07-21	1	14446
47664	3236	1112807	1958-10-29	1958-11-26	1	-4054
41146	2792	1124300	2001-12-10	2001-12-10	1	11666
53058	3615	1125315	1997-09-25	1997-10-09	1	10143
39537	2688	1112807	1963-01-17	1963-01-31	1	-2527
73620	5035	1115008	1996-06-20	1996-09-18	1	9757
70134	4791	1125315	1968-06-18	1968-07-18	1	-532
56607	3856	1713332	1992-03-08	1992-03-22	1	8116
44656	3026	1125315	1995-11-03	1995-11-17	1	9451
48610	3304	1717327	1963-09-06	1963-09-20	1	-2295
37947	2580	1125315	2005-05-13	2005-05-20	1	12923
27578	1861	1125315	1983-10-19	1983-11-09	1	5060
47029	3189	19127890	1984-05-17	1985-05-12	1	5610
39415	2680	1713332	2014-12-13	2015-01-03	1	16438
45050	3059	1125315	2008-09-17	2008-09-17	1	14139
42709	2894	1112807	1927-11-03	1927-11-17	1	-15386
15257	1058	1728416	1956-07-20	1956-08-03	1	-4899
36128	2456	1125315	1998-10-10	1998-10-17	1	10516
60652	4137	1125315	2004-04-01	2004-04-15	1	12523
62285	4250	1728416	1950-07-05	1950-07-19	1	-7106
38311	2604	1125315	1978-10-03	1978-10-10	1	3204
43267	2926	1125315	1982-11-12	1982-11-26	1	4712
44127	2985	1177480	2008-12-17	2009-01-21	1	14265
51357	3501	1125315	1962-08-16	1962-08-23	1	-2688
33374	2266	1125315	1984-03-18	1984-04-01	1	5204
37077	2522	1125315	2000-07-24	2000-09-22	2	11222
43540	2944	1125315	1981-09-02	1981-09-16	1	4276
12724	871	933724	2014-02-17	2014-02-24	1	16125
3164	209	1309944	1976-12-31	1976-12-31	1	2556
43467	2939	920293	1994-02-23	1994-03-02	1	8826
44326	3000	1124300	1983-09-20	1983-09-20	1	5010
8469	587	1778162	1994-08-12	1994-08-26	1	9003
37609	2554	1759842	1959-07-25	1959-08-01	1	-3806
75919	5197	1125315	1964-08-24	1964-09-07	1	-1942
42643	2891	1125315	2011-03-13	2011-03-27	1	15060
39690	2699	920293	2008-12-07	2008-12-14	1	14227
63408	4330	1125315	1988-12-02	1989-01-06	1	6945
35368	2402	1713332	2003-03-01	2003-03-08	1	12119
74605	5103	1125315	1950-01-23	1950-01-30	1	-7276
40856	2774	1112807	1941-04-29	1941-05-13	1	-10460
76241	5213	1125315	1984-03-24	1984-03-31	1	5203
46759	3176	19127890	1989-11-09	1992-10-24	3	8332
41706	2827	920293	1968-06-27	1968-07-11	2	-539
38209	2598	1125315	2011-11-16	2011-12-07	1	15315
1025	69	1125315	1975-02-28	1975-03-14	1	1898
78063	5331	1125315	1989-10-13	1989-10-27	1	7239
35869	2437	1125315	1962-08-02	1962-08-16	1	-2695
43674	2950	1729720	1993-01-13	1993-01-20	1	8420
698	43	1125315	1978-12-23	1979-01-06	1	3292
70694	4828	1729720	1974-07-04	1974-07-17	1	1658
47665	3236	1125315	1933-05-15	1933-05-22	1	-13373
41147	2792	1125315	1994-01-10	1994-04-10	1	8865
53059	3615	920293	1982-09-30	1982-10-14	2	4669
39538	2688	1112807	1973-06-23	1973-07-21	1	1297
73621	5035	1119510	1982-03-02	1982-03-16	1	4457
70135	4791	1125315	2002-04-21	2002-04-21	1	11798
56608	3856	19127890	1991-09-09	1993-08-29	2	8641
44657	3026	1177480	2017-05-11	2017-08-09	1	17387
48611	3304	1759842	2010-01-13	2010-01-20	1	14629
37948	2580	1332418	1995-02-20	1995-02-20	1	9181
27579	1861	1125315	2004-02-02	2004-02-16	1	12464
47030	3189	19127890	1986-05-07	1987-05-02	1	6330
39416	2680	19127890	1988-02-24	1989-02-18	1	6988
45051	3059	1713332	2001-11-04	2001-11-25	1	11651
42710	2894	1112807	1932-07-30	1932-10-05	1	-13602
15258	1058	1729720	1959-08-07	1959-08-17	1	-3790
36129	2456	1729720	1969-04-14	1969-04-26	1	-250
60653	4137	1137529	2013-02-06	2013-02-06	1	15742
62286	4250	1759842	1971-03-01	1971-03-15	1	438
38312	2604	1728416	1957-10-15	1957-10-29	1	-4447
43268	2926	1503184	1995-09-15	1996-09-09	1	9748
44128	2985	1713332	1981-02-07	1981-02-21	1	4069
51358	3501	1713332	1956-04-26	1956-05-11	1	-4983
33375	2266	1177480	2015-07-07	2015-08-11	1	16658
37078	2522	1503184	1976-06-16	1978-06-06	2	3078
43541	2944	1503184	1975-01-22	1978-01-06	3	2927
12725	871	1125315	1975-10-28	1975-11-11	1	2140
3165	209	1343916	1976-12-31	1976-12-31	1	2556
43468	2939	1124300	1997-10-31	1997-10-31	1	10165
44327	3000	1124957	1970-11-08	1970-11-08	1	311
8470	587	19127890	2000-02-05	2001-01-30	1	11352
37610	2554	1759842	1988-09-28	1988-10-05	1	6852
75920	5197	1728416	1954-02-15	1954-03-01	1	-5785
42644	2891	1713332	1979-11-27	1980-02-26	1	3708
39691	2699	1125315	1980-05-13	1980-05-20	1	3792
63409	4330	1174888	1963-09-01	1963-09-01	1	-2314
35369	2402	1728416	1977-07-10	1977-07-24	1	2761
74606	5103	1125315	1956-01-25	1956-03-25	2	-5030
40857	2774	1115008	2016-10-26	2016-11-16	1	17121
76242	5213	1177480	1981-11-11	1981-11-25	1	4346
46760	3176	1125315	1979-04-28	1979-05-12	1	3418
41707	2827	1124300	1958-04-08	1958-04-08	1	-4286
38210	2598	1713332	1985-04-17	1985-05-08	1	5606
1026	69	1125315	1997-12-24	1998-01-07	1	10233
78064	5331	1125315	1998-03-02	1998-03-16	1	10301
35870	2437	1125315	1977-10-26	1977-11-30	1	2890
43675	2950	1759842	2014-06-13	2014-07-04	1	16255
699	43	1112807	1957-03-17	1957-03-31	1	-4659
70695	4828	1759842	1969-09-02	1969-09-16	1	-107
47666	3236	1177480	2013-10-09	2013-11-08	1	16017
41148	2792	1759842	1959-05-08	1959-05-29	1	-3870
53060	3615	933724	1982-09-30	1982-10-14	1	4669
39539	2688	1125315	1975-09-09	1975-10-14	1	2112
73622	5035	1125315	1996-12-10	1996-12-24	1	9854
70136	4791	1124957	2002-04-21	2002-04-21	1	11798
56609	3856	1125315	1976-01-04	1976-01-18	1	2208
44658	3026	1729720	2018-08-26	2018-09-06	1	17780
51212	3489	1515774	1990-10-04	1991-09-29	1	7941
37949	2580	1728416	1962-10-07	1962-10-21	1	-2629
27580	1861	1713332	1982-03-28	1982-04-11	1	4483
47031	3189	705944	1973-06-14	1975-01-02	1	1827
39817	2708	1115008	2000-05-18	2000-06-08	1	11116
45774	3109	1125315	1964-06-29	1964-07-06	1	-2005
42711	2894	1125315	1956-07-01	1956-07-29	1	-4904
15259	1058	1759842	2010-03-01	2010-03-22	1	14690
37351	2542	738818	1994-10-11	1994-10-18	1	9056
60654	4137	1149380	2013-02-06	2013-02-06	1	15742
62287	4250	738818	1984-02-22	1984-03-07	1	5179
38313	2604	1112807	1973-01-24	1973-02-28	1	1154
43269	2926	1595799	1998-08-30	1999-08-25	1	10828
44129	2985	1713332	1983-08-18	1983-08-25	1	4984
51359	3501	1728416	1950-06-22	1950-07-06	1	-7119
35768	2431	1125315	1976-05-25	1976-06-08	1	2350
37079	2522	1119510	1959-05-08	1959-05-15	1	-3884
43542	2944	1112807	1970-11-09	1970-11-30	1	333
12726	871	1177480	2001-10-25	2001-11-24	1	11650
3166	209	1347450	1992-07-31	1992-07-31	1	8247
43469	2939	1125315	1974-09-29	1974-10-06	1	1739
44328	3000	1125315	1976-10-28	1976-12-02	1	2527
8471	587	1125315	1980-11-07	1980-11-14	1	3970
37611	2554	738818	1973-12-29	1974-01-05	1	1465
75921	5197	1746114	1962-06-06	1962-06-06	1	-2766
42645	2891	19127890	1987-11-19	1988-11-13	1	6891
39692	2699	1125315	2018-06-03	2018-06-17	1	17699
64573	4409	1112807	1967-07-18	1967-08-01	1	-884
35370	2402	1759842	2003-03-01	2003-03-08	1	12119
74607	5103	1125315	1993-06-28	1993-08-27	1	8639
40858	2774	1125315	1952-01-18	1952-01-25	1	-6551
76243	5213	1177480	2007-03-14	2007-04-11	1	13614
46761	3176	1125315	2000-08-17	2000-08-31	1	11200
41708	2827	1125315	1945-07-21	1945-08-04	1	-8916
38211	2598	1729720	1985-09-09	1985-09-22	1	5743
1027	69	1125315	2000-11-15	2000-11-22	1	11283
78065	5331	1174888	2017-02-17	2017-02-17	1	17214
35871	2437	1125315	2001-11-24	2001-12-29	1	11685
43676	2950	757627	2011-10-03	2011-10-03	1	15250
700	43	1119510	1979-10-19	1979-11-02	1	3592
73314	5013	738818	1966-10-12	1966-10-19	1	-1170
47667	3236	1310149	1982-12-24	1982-12-24	1	4740
41149	2792	1759842	2014-07-10	2014-07-17	1	16268
53061	3615	1119510	1977-06-15	1977-06-29	1	2736
39540	2688	1713332	2015-12-03	2015-12-17	1	16786
73623	5035	1326303	2011-08-15	2011-08-15	1	15201
70137	4791	1125315	1981-01-24	1981-01-31	1	4048
56610	3856	1503184	1992-09-03	1993-08-29	1	8641
44659	3026	1125315	1971-01-22	1971-02-05	1	400
51213	3489	1713332	2005-02-07	2005-02-14	1	12828
37950	2580	1118084	1995-01-16	1995-01-16	1	9146
27581	1861	1729720	1990-07-01	1990-07-10	1	7495
47032	3189	1119510	2002-12-01	2002-12-15	1	12036
39818	2708	1125315	1994-11-18	1994-12-16	1	9115
45775	3109	1125315	1968-07-22	1968-08-05	1	-514
42712	2894	1125315	1986-05-08	1986-05-22	1	5985
15260	1058	1125315	1961-12-08	1961-12-22	1	-2932
37352	2542	920293	2015-06-17	2015-06-24	1	16610
60655	4137	1177480	2002-12-14	2002-12-28	1	12049
62288	4250	1115008	1996-11-14	1996-12-12	1	9842
38314	2604	1118084	1997-08-12	1997-08-12	1	10085
43270	2926	1713332	1998-12-12	1998-12-26	1	10586
44130	2985	1713332	1993-02-07	1993-02-14	1	8445
51360	3501	1729720	1957-09-01	1957-09-13	1	-4493
35769	2431	1125315	1992-09-29	1992-10-06	1	8314
37080	2522	1125315	1985-02-17	1985-03-24	1	5561
43543	2944	1112807	1972-09-20	1972-10-18	1	1021
12727	871	1177480	2002-10-20	2002-11-03	1	11994
3167	209	1713332	1999-10-28	1999-11-18	1	10913
43470	2939	1521369	1983-10-20	1984-10-14	1	5400
44329	3000	1713332	1976-04-15	1976-05-06	1	2317
8472	587	1125315	1983-02-17	1983-02-24	1	4802
37612	2554	1125315	1973-12-29	1974-01-05	1	1465
75922	5197	1759842	2005-08-12	2005-08-19	1	13014
42646	2891	1115008	2012-08-11	2012-09-01	1	15584
39693	2699	1177480	1976-07-02	1976-07-23	1	2395
64574	4409	1125315	2016-09-29	2016-10-13	1	17087
35371	2402	1713332	2011-09-16	2011-10-07	1	15254
74608	5103	1174888	1956-01-25	1956-01-25	1	-5090
40859	2774	1125315	1968-03-03	1968-03-17	1	-655
76244	5213	1713332	1952-07-08	1952-07-22	1	-6372
46762	3176	1125315	2006-10-13	2006-11-03	1	13455
41709	2827	1125315	1971-01-22	1971-01-29	1	393
38212	2598	738818	2017-04-29	2017-05-13	1	17299
1028	69	1713332	1977-10-05	1977-10-26	1	2855
78066	5331	1521369	1979-07-17	1980-07-11	1	3844
35872	2437	1717327	1964-08-21	1964-09-04	1	-1945
43677	2950	1125315	1955-04-16	1955-05-07	1	-5353
701	43	1125315	1990-03-24	1990-04-07	1	7401
73315	5013	1112807	1966-07-12	1966-08-02	1	-1248
47668	3236	1326303	1982-12-24	1982-12-24	1	4740
42685	2893	1112807	1966-07-22	1966-08-19	1	-1231
53062	3615	1125315	2011-01-02	2011-01-09	1	14983
39541	2688	1728416	1964-08-17	1964-08-31	1	-1949
73624	5035	1729720	1976-04-21	1976-05-01	1	2312
70138	4791	1125315	2007-11-21	2007-12-19	1	13866
56611	3856	19127890	1989-09-19	1990-09-14	1	7561
44660	3026	1125315	2010-03-28	2010-04-04	1	14703
51214	3489	1717327	1977-12-22	1978-01-05	1	2926
37951	2580	1125315	2012-06-14	2012-06-28	1	15519
27582	1861	1759842	1993-08-30	1993-09-20	1	8663
47033	3189	19127890	1981-06-02	1982-05-28	1	4530
39819	2708	1177480	2010-02-16	2010-03-02	1	14670
45776	3109	1177480	1987-09-04	1987-09-25	1	6476
42713	2894	1177480	1993-11-10	1993-12-01	1	8735
15261	1058	975125	1965-01-08	1965-01-22	1	-1805
37353	2542	1150836	1986-06-26	1986-06-26	1	6020
60656	4137	1759842	2002-10-07	2002-11-18	1	12009
62289	4250	1115008	2015-04-07	2015-07-06	1	16622
38315	2604	1177480	1986-05-21	1986-06-18	1	6012
43271	2926	1759842	1989-08-15	1989-08-29	1	7180
44131	2985	1717327	1966-06-19	1966-07-03	1	-1278
51361	3501	1125315	1949-11-24	1949-12-01	1	-7336
35770	2431	1177480	1995-05-16	1995-05-30	1	9280
37081	2522	1125315	2009-07-07	2009-07-21	1	14446
43544	2944	1115008	2006-10-16	2006-12-22	1	13504
12728	871	19127890	1980-01-15	1981-01-09	1	4026
3168	209	1713332	2009-05-02	2009-05-16	1	14380
43471	2939	1729720	1953-03-25	1953-04-04	1	-6116
44330	3000	1713332	2007-11-21	2007-11-28	1	13845
8473	587	1125315	1994-08-12	1994-08-26	1	9003
37613	2554	1125315	1979-08-09	1979-08-23	1	3521
75923	5197	19003953	1962-06-06	1962-06-06	1	-2766
42647	2891	1124300	2014-05-01	2014-05-01	1	16191
39694	2699	1503184	1991-10-08	1992-10-02	1	8310
64575	4409	1521369	1988-12-11	1989-12-06	1	7279
35372	2402	1738521	1978-03-20	1978-04-03	1	3014
74609	5103	1713332	2019-03-31	2019-04-14	1	18000
40860	2774	1125315	1995-12-03	1995-12-17	1	9481
76245	5213	1125315	1975-03-04	1975-03-18	1	1902
46763	3176	1503184	1990-11-04	1991-10-30	1	7972
41710	2827	1125315	1984-03-23	1984-04-06	1	5209
38213	2598	1118084	2008-07-18	2008-07-18	1	14078
1029	69	1759842	1976-03-21	1976-04-04	1	2285
78067	5331	1521369	1981-07-06	1982-07-01	1	4564
35873	2437	1729720	1971-06-06	1971-06-17	1	532
43678	2950	1125315	1999-04-05	1999-04-26	1	10707
702	43	1713332	1962-06-11	1962-06-18	1	-2754
73316	5013	1115008	2003-04-11	2003-04-25	1	12167
47669	3236	1557272	2014-09-05	2014-09-05	1	16318
42686	2893	1124300	1985-08-05	1985-08-05	1	5695
53063	3615	1112807	1962-05-30	1962-06-29	1	-2743
39542	2688	1759842	2010-12-16	2010-12-23	1	14966
73625	5035	757627	2009-08-03	2009-08-03	1	14459
70139	4791	1125315	2016-06-04	2016-06-18	1	16970
57807	3942	19127890	1992-04-16	1993-04-11	1	8501
44661	3026	1125315	2019-06-07	2019-06-07	1	18054
51215	3489	1759842	1998-05-30	1998-06-20	1	10397
37952	2580	1361711	1963-05-20	1963-05-20	1	-2418
30358	2053	1125315	1957-06-28	1957-07-12	1	-4556
47034	3189	1125315	1985-09-20	1985-11-26	1	5808
39820	2708	738818	1968-03-05	1968-03-12	1	-660
45777	3109	1713332	1985-03-24	1985-07-14	1	5673
42714	2894	1177480	1997-02-13	1997-04-21	1	9972
15262	1058	1118084	1992-12-03	1992-12-03	1	8372
37354	2542	1713332	1970-05-12	1970-05-19	1	138
60657	4137	1112807	1966-06-17	1966-07-01	1	-1280
62290	4250	1115008	2016-05-31	2016-06-30	1	16982
38316	2604	1729720	1991-02-28	1991-03-11	1	7739
43272	2926	1759842	1990-07-30	1990-08-06	1	7522
44132	2985	1759842	1981-02-07	1981-02-21	1	4069
51362	3501	1125315	1961-05-15	1961-05-22	1	-3146
35771	2431	1503184	1986-07-12	1987-07-07	1	6396
37082	2522	1177480	1998-06-14	1998-07-05	1	10412
43545	2944	1119510	1965-12-01	1965-12-15	1	-1478
12729	871	920293	2014-02-17	2014-02-24	1	16125
3169	209	1759842	1999-10-28	1999-11-18	1	10913
43472	2939	19127890	1974-12-06	1975-12-01	1	2160
44331	3000	1759842	1977-12-03	1977-12-17	1	2907
8474	587	1503184	1994-03-08	1995-03-03	1	9192
37614	2554	1713332	1959-07-25	1959-08-01	1	-3806
75924	5197	708298	1962-06-06	1962-06-06	1	-2766
42648	2891	1125315	1978-12-26	1979-01-09	1	3295
39695	2699	1515774	1994-09-22	1995-09-17	1	9390
64576	4409	1521369	1990-12-01	1991-11-26	1	7999
35373	2402	738818	1998-02-16	1998-02-23	1	10280
74610	5103	1759842	2019-03-31	2019-04-14	1	18000
40861	2774	1125315	2011-03-27	2011-04-26	2	15090
76246	5213	1125315	1991-09-23	1991-10-07	1	7949
46764	3176	1549786	1989-11-09	1990-11-04	1	7612
41711	2827	1125315	1987-05-28	1987-08-26	1	6446
38214	2598	1125315	1976-02-27	1976-03-12	1	2262
1030	69	1759842	1979-01-27	1979-02-03	1	3320
78068	5331	1713332	1993-07-14	1993-07-28	1	8609
35874	2437	1102527	2001-11-24	2001-11-24	1	11650
43679	2950	1713332	2010-05-19	2010-05-26	1	14755
703	43	920293	1992-01-07	1992-01-14	1	8048
73317	5013	1125315	1966-10-12	1966-10-19	1	-1170
47670	3236	1759842	1944-07-12	1944-08-02	1	-9283
42687	2893	1125315	2009-02-02	2009-02-16	1	14291
53064	3615	1124957	1962-05-30	1962-05-30	1	-2773
41353	2806	920293	1987-05-12	1987-05-19	1	6347
73626	5035	1112807	1948-04-19	1948-07-18	1	-7837
70140	4791	1177480	2002-04-21	2002-07-20	1	11888
57808	3942	1125315	1989-06-21	1989-07-21	1	7141
44662	3026	1729720	2004-08-09	2004-08-21	1	12651
51216	3489	19127890	1986-10-25	1987-10-20	1	6501
37953	2580	1539403	1992-08-17	1992-08-17	1	8264
30359	2053	1125315	2010-03-24	2010-04-23	1	14722
47035	3189	1503184	1981-06-02	1982-05-28	1	4530
39821	2708	1119510	1965-09-29	1965-10-06	1	-1548
45778	3109	1729720	1928-11-18	1928-11-27	1	-15010
42715	2894	715997	2002-12-27	2002-12-27	1	12048
15263	1058	1125315	1960-07-30	1960-08-13	1	-3428
37355	2542	1759842	1975-03-29	1975-04-12	1	1927
60658	4137	1125315	1973-02-23	1973-03-09	1	1163
62291	4250	1125315	1984-02-22	1984-03-07	1	5179
38317	2604	738818	2016-11-21	2016-12-05	1	17140
43273	2926	1759842	2006-02-23	2006-03-09	1	13216
44133	2985	1759842	1983-08-18	1983-08-25	1	4984
51363	3501	1125315	2012-02-03	2012-02-17	1	15387
35772	2431	1503184	1988-07-01	1989-06-26	1	7116
37083	2522	1125315	1961-05-26	1961-06-23	1	-3114
43546	2944	1124957	2006-10-23	2006-10-23	1	13444
12730	871	1112807	1968-12-03	1968-12-17	1	-380
3170	209	1759842	2009-05-02	2009-05-16	1	14380
43473	2939	933724	1994-02-23	1994-03-02	1	8826
44332	3000	1759842	2007-11-21	2007-11-28	1	13845
8475	587	1549786	1995-03-03	1997-02-20	2	9912
37615	2554	1713332	2016-04-01	2016-04-22	1	16913
75925	5197	967823	1962-06-05	1962-06-06	1	-2766
42649	2891	1125315	1982-08-07	1982-08-28	1	4622
39696	2699	1549786	1994-09-22	1995-09-17	1	9390
64577	4409	1729720	1968-11-13	1968-11-23	1	-404
35374	2402	1119510	1998-02-16	1998-02-23	1	10280
74611	5103	1118084	1985-02-12	1985-02-12	1	5521
40862	2774	1729720	2004-04-06	2004-04-13	1	12521
76247	5213	1713332	1994-06-04	1994-06-18	1	8934
46765	3176	1549786	1991-10-30	1992-10-24	1	8332
41712	2827	1310149	2000-12-26	2000-12-26	1	11317
38215	2598	1125315	1986-09-02	1986-10-02	2	6118
1031	69	738818	1955-12-24	1956-01-07	1	-5108
78069	5331	1713332	2017-02-17	2017-03-24	1	17249
35875	2437	1125315	1964-08-21	1964-09-04	1	-1945
43680	2950	1729720	1983-08-12	1983-08-19	1	4978
704	43	933724	1992-01-07	1992-01-14	1	8048
73318	5013	1125315	1990-07-26	1990-08-09	1	7525
47671	3236	1125315	1940-04-17	1940-05-01	1	-10837
42688	2893	1713332	1964-09-15	1964-09-22	1	-1927
53065	3615	1125315	1977-06-15	1977-06-29	1	2736
41354	2806	933724	1987-05-12	1987-05-19	1	6347
73627	5035	1118084	1969-06-07	1969-06-07	1	-208
70270	4801	1112807	1991-01-10	1991-01-24	1	7693
57809	3942	1177480	1978-09-17	1978-10-01	1	3195
44663	3026	1759842	1972-12-19	1973-01-02	1	1097
51217	3489	1503184	1986-10-25	1987-10-20	1	6501
37954	2580	1729720	1995-02-16	1995-03-01	1	9190
30360	2053	1728416	1954-10-06	1954-10-20	1	-5552
47036	3189	1521369	1984-05-17	1985-05-12	1	5610
39822	2708	1125315	1954-09-05	1954-09-19	1	-5583
45779	3109	1112807	1920-03-03	1920-03-17	1	-18187
42716	2894	1112807	1923-09-04	1923-09-18	1	-16907
15264	1058	1125315	2003-11-16	2003-11-30	1	12386
37356	2542	19127890	1977-05-27	1978-05-22	1	3063
60659	4137	1125315	2013-08-05	2013-08-19	1	15936
62292	4250	1729720	1947-07-22	1947-07-31	1	-8190
38318	2604	1125315	1966-02-18	1966-03-04	1	-1399
43274	2926	1759842	2016-01-10	2016-01-24	1	16824
44134	2985	1759842	1993-02-07	1993-02-14	1	8445
51364	3501	1729720	1961-01-27	1961-02-09	1	-3248
35773	2431	1713332	1989-09-20	1989-10-04	1	7216
37084	2522	1125315	1970-06-23	1970-06-30	1	180
43547	2944	1521369	1975-01-22	1978-01-06	3	2927
12731	871	1125315	1971-09-20	1971-10-04	1	641
3171	209	1778162	2016-05-03	2016-05-17	1	16938
43474	2939	1503184	1974-12-06	1975-12-01	1	2160
44333	3000	1125315	1970-11-08	1970-11-22	2	325
8476	587	19127890	1994-03-08	1997-02-20	3	9912
38263	2602	914335	1964-11-04	1964-11-04	1	-1884
75926	5197	1110410	1962-06-05	1962-06-06	1	-2766
42650	2891	1125315	1996-05-05	1996-05-12	1	9628
39697	2699	1759842	1977-07-20	1977-07-27	1	2764
64578	4409	1729720	1969-06-24	1969-07-06	1	-179
35375	2402	1124300	2014-03-18	2014-03-18	1	16147
74612	5103	1119510	1992-07-21	1992-08-04	1	8251
40863	2774	738818	1975-04-23	1975-05-07	1	1952
76248	5213	1759842	1994-06-04	1994-06-18	1	8934
46766	3176	933724	2001-01-11	2001-01-25	1	11347
41713	2827	1713332	1980-09-01	1980-09-08	1	3903
38216	2598	1125315	2017-04-29	2017-05-13	1	17299
1032	69	1125315	1955-12-24	1956-01-07	1	-5108
78070	5331	1759842	1993-07-14	1993-07-28	1	8609
35876	2437	1125315	2018-04-04	2018-05-02	1	17653
43681	2950	1759842	1943-03-15	1943-04-05	1	-9768
705	43	1177480	1994-11-12	1994-12-03	1	9102
73319	5013	1125315	2013-05-31	2013-05-31	1	15856
47672	3236	1125315	1979-12-06	1980-01-10	1	3661
42689	2893	1713332	2005-10-21	2005-11-11	1	13098
53066	3615	1125315	2006-10-06	2006-10-27	1	13448
41355	2806	1102527	1983-03-13	1983-03-13	1	4819
73628	5035	1729720	1940-07-23	1940-08-01	1	-10745
70271	4801	1124300	2002-08-10	2002-08-10	1	11909
57810	3942	1503184	1992-04-16	1993-04-11	1	8501
44664	3026	738818	1966-06-09	1966-06-16	1	-1295
51218	3489	1549786	1990-10-04	1991-09-29	1	7941
37955	2580	19127890	1975-05-21	1976-05-15	1	2326
30361	2053	1728416	1956-06-01	1956-06-15	1	-4948
47037	3189	1521369	1986-05-07	1987-05-02	1	6330
39823	2708	1125315	1959-07-12	1959-07-26	1	-3812
45780	3109	1112807	1923-05-10	1923-05-24	1	-17024
42717	2894	1112807	1924-08-16	1924-08-30	1	-16560
15265	1058	1125315	2004-05-30	2004-07-06	2	12605
37357	2542	933724	2015-06-17	2015-06-24	1	16610
60660	4137	1728416	1963-01-15	1963-01-29	1	-2529
62293	4250	1759842	1966-05-14	1966-05-21	1	-1321
38319	2604	1125315	1997-08-19	1997-09-16	1	10120
43275	2926	19127890	1997-09-04	1998-08-30	1	10468
44135	2985	914335	1967-06-17	1967-06-17	1	-929
51365	3501	1112807	1950-06-22	1950-07-06	1	-7119
35774	2431	1759842	2017-12-14	2018-01-04	1	17535
37085	2522	19127890	1976-06-16	1978-06-06	2	3078
43548	2944	1728416	1960-03-31	1960-04-14	1	-3549
12732	871	1521369	1980-01-15	1981-01-09	1	4026
5443	372	1112807	1968-02-06	1968-02-27	1	-674
43475	2939	1521369	1978-11-15	1979-11-10	1	3600
44334	3000	1177480	1996-11-08	1996-11-29	1	9829
8477	587	19127890	1998-02-15	1999-02-10	1	10632
38264	2602	1125315	1954-07-30	1954-08-20	1	-5613
75927	5197	1112807	1956-06-17	1956-07-01	1	-4932
42651	2891	1192710	1975-04-27	1975-04-27	1	1942
39698	2699	19127890	1986-11-03	1988-10-23	2	6870
64579	4409	19127890	1983-01-05	1983-12-31	1	5112
35376	2402	1149380	1978-09-20	1978-09-20	1	3184
74613	5103	1125315	1944-02-09	1944-02-23	1	-9444
40864	2774	1125315	1971-07-11	1971-07-25	1	570
38471	2616	1125315	1997-03-12	1997-03-26	1	9946
46767	3176	1112807	1982-04-10	1982-04-24	1	4496
41714	2827	1729720	1923-01-21	1923-02-03	1	-17134
38217	2598	1177480	1992-07-07	1992-07-28	1	8244
1033	69	1125315	1988-02-24	1988-03-16	1	6649
78071	5331	1125315	2017-08-19	2017-08-26	1	17404
35877	2437	1713332	1972-11-04	1972-11-18	1	1052
43682	2950	1759842	2006-11-28	2006-12-12	1	13494
706	43	1728416	1957-03-17	1957-03-31	1	-4659
73320	5013	1119510	1966-10-12	1966-10-19	1	-1170
47673	3236	1125315	1987-03-27	1987-04-10	1	6308
42690	2893	1728416	1954-06-04	1954-06-18	1	-5676
53067	3615	1125315	2007-11-21	2007-12-19	1	13866
41356	2806	1112807	1958-05-20	1958-06-03	1	-4230
73629	5035	1759842	1976-06-28	1976-07-05	1	2377
70272	4801	1125315	1988-08-24	1988-08-31	1	6817
57811	3942	1521369	1996-03-26	1997-03-21	1	9941
44665	3026	1124300	1996-04-27	1996-04-27	1	9613
51219	3489	1125315	1985-01-25	1985-02-08	1	5517
37956	2580	19127890	1977-05-10	1978-05-05	1	3046
30362	2053	1102527	2010-03-24	2010-03-24	1	14692
47038	3189	1728416	1965-09-14	1965-09-28	1	-1556
39824	2708	1125315	1968-03-05	1968-03-12	1	-660
45781	3109	1118084	1953-10-16	1953-10-16	1	-5921
42718	2894	1112807	1929-11-08	1929-12-13	1	-14629
15266	1058	1174888	2004-06-06	2004-06-06	1	12575
37358	2542	1125315	1994-10-11	1994-10-18	1	9056
61378	4191	738818	1999-08-15	1999-08-29	1	10832
62294	4250	1759842	2008-07-19	2008-08-09	1	14100
38320	2604	1125315	2000-07-02	2000-07-16	1	11154
43276	2926	933724	2000-10-21	2000-10-28	1	11258
44136	2985	1112807	1966-06-19	1966-07-03	1	-1278
51366	3501	1115008	1994-03-19	1994-06-18	1	8934
35775	2431	19127890	1986-07-12	1987-07-07	1	6396
37803	2570	1119510	1936-10-17	1936-10-24	1	-12122
43549	2944	738818	1965-12-01	1965-12-15	1	-1478
14760	1021	1112807	1962-07-22	1962-08-12	1	-2699
5444	372	1125315	1962-05-08	1962-07-07	1	-2735
43476	2939	1521369	1981-10-30	1982-10-25	1	4680
44335	3000	1713332	1977-12-03	1977-12-17	1	2907
9884	679	1713332	1980-07-04	1980-07-18	1	3851
38265	2602	1309944	1964-11-04	1964-11-04	1	-1884
75928	5197	1124957	1972-09-13	1972-09-13	1	986
42652	2891	1503184	1987-11-19	1988-11-13	1	6891
39699	2699	1124300	2012-02-20	2012-02-20	1	15390
64580	4409	19127890	1986-12-15	1987-12-10	1	6552
39048	2654	1112807	1949-11-02	1949-11-16	1	-7351
74614	5103	1125315	1967-12-29	1968-01-05	1	-727
40865	2774	1125315	1975-04-23	1975-05-07	1	1952
38472	2616	1557272	2012-01-10	2012-01-10	1	15349
46768	3176	1118084	2007-10-11	2007-10-11	1	13797
41715	2827	1759842	1980-09-01	1980-09-08	1	3903
38218	2598	1713332	1995-12-22	1995-12-29	1	9493
1034	69	1112807	1947-11-05	1947-11-19	1	-8079
78072	5331	1713332	2001-07-21	2001-08-11	1	11545
35878	2437	1729720	1967-10-09	1967-10-21	1	-803
43683	2950	1112807	1936-08-09	1936-08-23	1	-12184
707	43	1759842	1962-06-11	1962-06-18	1	-2754
73321	5013	1174888	2013-05-31	2013-05-31	1	15856
47674	3236	1125315	1988-07-26	1988-10-24	1	6871
42691	2893	1729720	1980-11-25	1980-12-07	1	3993
54212	3689	738818	1975-03-10	1975-03-24	1	1908
41357	2806	1112807	1983-03-06	1983-05-12	1	4879
73630	5035	914335	2003-03-03	2003-03-03	1	12114
70273	4801	1713332	2006-03-15	2006-03-22	1	13229
57812	3942	1125315	1993-03-02	1993-04-06	1	8496
44666	3026	1177480	1980-05-11	1980-05-25	1	3797
51220	3489	1125315	2009-09-07	2009-09-21	1	14508
37957	2580	920293	1980-07-05	1980-07-12	1	3845
30363	2053	1759842	1981-03-04	1981-03-25	1	4101
48676	3311	975125	1990-03-21	1990-03-21	1	7384
39825	2708	1125315	1973-01-28	1973-04-28	2	1213
44167	2987	1119510	1995-07-16	1995-07-30	1	9341
42719	2894	1115008	2004-09-18	2004-10-23	1	12714
15267	1058	1713332	2018-01-26	2018-05-04	1	17655
37359	2542	1177480	1974-12-29	1975-03-29	1	1913
61379	4191	1125315	1961-08-25	1961-09-08	1	-3037
62295	4250	1119510	1984-02-22	1984-03-07	1	5179
38321	2604	1125315	2016-11-21	2016-12-05	1	17140
43277	2926	1503184	1997-09-04	1998-08-30	1	10468
44137	2985	1112807	1979-08-26	1979-09-16	1	3545
51367	3501	1125315	1993-04-02	1993-04-24	1	8514
35776	2431	19127890	1988-07-01	1989-06-26	1	7116
37804	2570	1177480	2015-05-22	2015-07-21	1	16637
43550	2944	1112807	1991-07-02	1991-08-06	1	7887
14761	1021	1124300	1990-01-16	1990-01-16	1	7320
5445	372	1125315	1996-03-30	1996-04-13	1	9599
43477	2939	1729720	1954-03-03	1954-03-16	1	-5770
44336	3000	1717327	1970-11-08	1970-11-22	1	325
9885	679	738818	2007-11-01	2007-11-15	1	13832
38266	2602	1343916	1964-11-04	1964-11-04	1	-1884
75929	5197	1125315	1954-06-17	1954-06-24	1	-5670
42653	2891	1713332	2002-07-15	2002-08-05	1	11904
39700	2699	1521369	1986-11-03	1988-10-23	2	6870
64581	4409	914335	1999-10-28	1999-10-28	1	10892
39049	2654	1118084	1983-04-18	1983-04-18	1	4855
74615	5103	1361711	2014-02-03	2014-02-03	1	16104
40866	2774	1118084	1977-09-29	1977-09-29	1	2828
43322	2929	1118084	2014-08-22	2014-08-22	1	16304
46769	3176	1119510	1979-04-28	1979-05-12	1	3418
41716	2827	1102527	1987-05-28	1987-05-28	1	6356
38219	2598	1738521	1976-02-27	1976-03-12	1	2262
1035	69	1118084	1984-08-02	1984-08-02	1	5327
40361	2745	1177480	2007-08-28	2007-10-02	1	13788
43684	2950	1125315	1983-06-09	1983-06-23	1	4921
708	43	738818	1979-10-19	1979-11-02	1	3592
73322	5013	1322184	2010-09-10	2013-05-31	1	15856
47675	3236	1125315	2003-06-28	2003-07-12	1	12245
42692	2893	1125315	1973-09-11	1973-10-11	1	1379
54213	3689	1112807	1963-11-17	1964-01-16	1	-2177
41358	2806	1322184	1997-05-01	1997-05-01	1	9982
73631	5035	1102527	1996-06-20	1996-06-20	1	9667
70274	4801	1759842	2006-03-15	2006-03-22	1	13229
57813	3942	1503184	1996-03-26	1997-03-21	1	9941
44667	3026	1177480	2019-05-31	2019-05-31	1	18047
51221	3489	1125315	2012-10-28	2012-11-11	1	15655
37958	2580	933724	1980-07-05	1980-07-12	1	3845
30364	2053	1112807	1954-10-06	1954-10-20	1	-5552
48677	3311	1115008	2011-09-18	2011-10-09	1	15256
39826	2708	1125315	1993-11-02	1993-11-23	1	8727
44168	2987	1125315	2003-09-12	2003-10-17	1	12342
42720	2894	1125315	1995-10-22	1996-01-20	1	9515
15268	1058	1759842	2018-01-26	2018-05-04	1	17655
37360	2542	1713332	1975-03-29	1975-04-12	1	1927
61380	4191	1125315	1999-08-15	1999-08-29	1	10832
62296	4250	1125315	1947-11-20	1947-11-27	1	-8071
38322	2604	1713332	1969-03-17	1969-04-07	1	-269
43278	2926	1549786	1998-08-30	2001-08-14	3	11548
44138	2985	1112807	1989-01-26	1989-02-16	1	6986
51368	3501	1125315	2017-12-27	2018-01-17	1	17548
35777	2431	1112807	1975-06-30	1975-07-30	1	2036
37805	2570	1759842	1936-07-24	1936-08-07	1	-12200
43551	2944	1125315	1965-12-01	1965-12-15	1	-1478
14762	1021	1125315	1992-09-24	1992-10-15	1	8323
5446	372	920293	1984-06-03	1984-06-10	1	5274
44825	3041	1150770	1978-08-06	1978-08-06	1	3139
44337	3000	1759842	1976-04-15	1976-05-06	1	2317
9886	679	738818	2011-06-11	2011-06-18	1	15143
38267	2602	1713332	1986-05-08	1986-05-22	1	5985
75930	5197	1125315	1960-11-20	1960-12-04	1	-3315
42654	2891	1738521	1978-12-26	1979-01-09	1	3295
39701	2699	738818	2018-06-03	2018-06-17	1	17699
64582	4409	1125315	1983-07-15	1983-08-19	1	4978
39050	2654	1125315	1983-04-20	1983-04-20	1	4857
74616	5103	1539403	2014-02-03	2014-02-03	1	16104
40867	2774	1125315	1941-04-17	1941-04-24	1	-10479
43323	2929	1174888	1990-10-29	1990-10-29	1	7606
46770	3176	1125315	1997-06-30	1997-07-07	1	10049
41717	2827	1112807	1924-02-11	1924-02-25	1	-16747
38220	2598	1759842	1995-12-22	1995-12-29	1	9493
1036	69	1119510	2000-11-15	2000-11-22	1	11283
40362	2745	1713332	2005-10-06	2005-10-13	1	13069
43685	2950	1177480	2005-06-23	2005-07-28	1	12992
709	43	1118084	1997-03-22	1997-03-22	1	9942
73323	5013	1545958	2013-05-31	2013-05-31	1	15856
42693	2893	1112807	1948-03-07	1948-06-05	1	-7880
54214	3689	1112807	1984-09-28	1984-10-26	1	5412
41359	2806	1503184	1976-02-25	1977-02-19	1	2606
73632	5035	1125315	1990-04-07	1990-04-14	1	7408
70275	4801	19127890	1986-07-15	1987-07-10	1	6399
57814	3942	1521369	1992-04-16	1993-04-11	1	8501
44668	3026	1713332	1972-12-19	1973-01-02	1	1097
51222	3489	1521369	1986-10-25	1987-10-20	1	6501
37959	2580	1125315	1961-04-24	1961-05-08	1	-3160
30365	2053	1112807	1956-06-01	1956-06-15	1	-4948
48678	3311	1125315	1974-07-20	1974-08-03	1	1675
39827	2708	1174888	1973-01-28	1973-01-28	1	1123
44169	2987	1729720	1992-10-01	1992-10-13	1	8321
42721	2894	1177480	1998-03-17	1998-05-23	1	10369
15269	1058	975125	1970-06-26	1970-07-17	1	197
37361	2542	1759842	1970-05-12	1970-05-19	1	138
61381	4191	1347450	2004-09-17	2004-09-17	1	12678
62297	4250	1125315	1980-07-03	1980-07-10	1	3843
38323	2604	1728416	1957-04-04	1957-04-18	1	-4641
43279	2926	1549786	2002-08-09	2004-07-29	2	12628
44139	2985	1124957	1990-10-09	1990-10-09	1	7586
51369	3501	1759842	1956-04-26	1956-05-11	1	-4983
35778	2431	1118084	2013-07-30	2013-07-30	1	15916
37806	2570	1759842	2004-01-31	2004-02-07	1	12455
43552	2944	1125315	1998-03-08	1998-03-15	1	10300
14763	1021	1112807	1958-02-13	1958-02-27	1	-4326
5447	372	933724	1984-06-03	1984-06-10	1	5274
44826	3041	1759842	1981-08-04	1981-10-27	1	4317
44593	3022	1125315	1976-03-16	1976-03-30	1	2280
9887	679	1118084	2009-02-12	2009-02-12	1	14287
38268	2602	1759842	1986-05-08	1986-05-22	1	5985
75931	5197	1125315	1966-09-28	1966-10-05	1	-1184
42655	2891	1759842	2002-07-15	2002-08-05	1	11904
39702	2699	1112807	1973-08-03	1973-08-17	1	1324
64583	4409	1309944	1999-10-28	1999-10-28	1	10892
39051	2654	1125315	1989-12-05	1989-12-26	1	7299
74617	5103	1713332	1948-04-10	1948-04-24	1	-7922
40868	2774	1125315	1946-11-01	1946-11-08	1	-8455
43324	2929	1713332	1998-12-17	1998-12-31	1	10591
46771	3176	1322184	2014-01-04	2014-01-04	1	16074
41718	2827	1326303	2000-12-26	2000-12-26	1	11317
38221	2598	738818	1994-02-24	1994-03-03	1	8827
1037	69	1713332	1976-03-21	1976-04-04	1	2285
40363	2745	1729720	1972-06-17	1972-06-30	1	911
43686	2950	1713332	2006-11-28	2006-12-12	1	13494
710	43	1125315	1979-10-19	1979-11-02	1	3592
73324	5013	1112807	1969-06-17	1969-07-08	1	-177
42694	2893	1112807	1952-06-14	1952-07-05	1	-6389
54215	3689	1125315	1956-07-28	1956-08-04	1	-4898
41360	2806	1557272	2013-06-13	2013-06-13	1	15869
73633	5035	1307863	2011-08-15	2011-08-15	1	15201
70276	4801	1112807	1972-12-15	1972-12-29	1	1093
57815	3942	1729720	1991-09-29	1991-10-12	1	7954
44669	3026	1729720	1971-12-26	1972-01-07	1	736
51223	3489	1713332	1998-05-30	1998-06-20	1	10397
37960	2580	1125315	1980-01-03	1980-01-17	1	3668
30366	2053	1124300	1993-11-04	1993-11-04	1	8708
48679	3311	1150770	1990-03-30	1990-03-30	1	7393
39828	2708	1713332	2009-11-21	2009-12-05	1	14583
45436	3083	933724	1990-06-01	1990-06-08	1	7463
42722	2894	1729720	1966-08-01	1966-08-11	1	-1239
15270	1058	1125315	1986-10-07	1986-10-14	1	6130
37362	2542	1115008	1998-11-23	1998-12-07	1	10567
61382	4191	1503184	1975-07-23	1977-07-12	2	2749
62298	4250	1125315	1988-08-26	1988-09-02	1	6819
38324	2604	1112807	1957-04-04	1957-04-18	1	-4641
43280	2926	19127890	1995-09-15	1996-09-09	1	9748
44140	2985	1521369	1983-09-14	1986-08-29	3	6084
52095	3547	1125315	1977-12-03	1978-01-02	1	2923
35779	2431	1177480	1989-09-20	1989-10-04	1	7216
37807	2570	738818	1954-02-23	1954-03-09	1	-5777
43553	2944	1125315	2010-10-07	2010-10-21	1	14903
14764	1021	1125315	1976-06-29	1976-07-20	1	2392
5448	372	1115008	2017-11-27	2017-12-27	1	17527
44827	3041	1118084	2018-04-12	2018-04-12	1	17633
44594	3022	1125315	1991-12-04	1991-12-25	1	8028
9888	679	1125315	1996-08-01	1996-08-15	1	9723
38269	2602	1125315	1959-08-18	1959-08-25	1	-3782
75932	5197	1125315	1972-09-13	1972-11-12	2	1046
42656	2891	933724	1996-01-02	1996-01-09	1	9504
39703	2699	1119510	1980-11-18	1980-11-25	1	3981
64584	4409	1343916	1999-10-28	1999-10-28	1	10892
39052	2654	1125315	2004-08-09	2004-09-06	1	12667
75957	5199	1112807	1966-08-23	1966-09-06	1	-1213
40869	2774	1125315	1981-11-26	1981-12-31	1	4382
43325	2929	1738521	1975-10-11	1975-10-25	1	2123
46772	3176	1343916	2001-12-23	2001-12-23	1	11679
41719	2827	1713332	1985-08-22	1985-08-29	1	5719
38222	2598	1125315	1988-08-22	1988-09-26	1	6843
1038	69	1713332	1979-01-27	1979-02-03	1	3320
40364	2745	1729720	1988-11-04	1988-11-13	1	6891
43687	2950	1759842	2010-05-19	2010-05-26	1	14755
711	43	1125315	1999-07-10	1999-08-14	1	10817
73325	5013	1118084	2005-08-01	2005-08-01	1	12996
42695	2893	1112807	1954-06-04	1954-06-18	1	-5676
54216	3689	1125315	1963-07-23	1963-08-06	1	-2340
41361	2806	19127890	1976-02-25	1977-02-19	1	2606
73634	5035	1309944	2003-03-03	2003-03-03	1	12114
70277	4801	1125315	1983-03-23	1983-06-21	1	4919
57816	3942	1738521	1978-09-17	1978-10-01	1	3195
45305	3076	1115008	1997-03-08	1997-03-29	1	9949
51224	3489	1759842	2005-02-07	2005-02-14	1	12828
37961	2580	1309944	1979-05-07	1979-05-07	1	3413
30367	2053	1125315	1953-09-30	1953-10-14	1	-5923
48680	3311	1343916	1990-03-30	1990-03-30	1	7393
39829	2708	1112807	1987-05-17	1987-06-07	1	6366
45437	3083	1125315	1955-04-22	1955-07-21	1	-5278
42723	2894	1112807	1967-07-02	1967-07-30	1	-886
15271	1058	1713332	2010-03-01	2010-03-22	1	14690
37363	2542	1125315	2005-04-04	2005-04-11	1	12884
61383	4191	1539403	2010-09-03	2010-09-03	1	14855
62299	4250	1177480	2000-06-24	2000-07-24	1	11162
38325	2604	1125315	2011-05-19	2011-05-26	1	15120
45052	3060	738818	1928-07-23	1928-08-06	1	-15123
44141	2985	1713332	2001-06-19	2001-07-10	1	11513
52096	3547	1738521	1972-10-30	1972-11-13	1	1047
35780	2431	1713332	1986-04-02	1986-04-16	1	5949
37808	2570	933724	1993-10-01	1993-10-15	1	8688
43554	2944	19127890	1975-01-22	1978-01-06	3	2927
14765	1021	1728416	1958-02-13	1958-02-27	1	-4326
5449	372	1125315	1994-11-27	1994-12-04	1	9103
44828	3041	1713332	2013-02-23	2013-03-09	1	15773
44595	3022	1177480	2003-03-27	2003-04-24	1	12166
9889	679	1125315	2007-11-01	2007-11-15	1	13832
38270	2602	1177480	2014-02-27	2014-03-13	1	16142
75933	5197	1125315	1986-10-21	1986-11-04	1	6151
42657	2891	1125315	1993-10-29	1993-11-19	1	8723
39704	2699	1125315	1971-10-15	1971-10-29	1	666
64585	4409	1503184	1983-01-05	1983-12-31	1	5112
39053	2654	1125315	1988-12-19	1989-01-09	1	6948
75958	5199	1112807	1971-01-29	1971-02-12	1	407
40870	2774	1322184	1997-12-26	1997-12-26	1	10221
43326	2929	1759842	1998-12-17	1998-12-31	1	10591
46773	3176	1347450	2014-01-04	2014-01-04	1	16074
41720	2827	1759842	1927-09-29	1927-10-13	1	-15421
38223	2598	1125315	1994-02-24	1994-03-03	1	8827
1039	69	1759842	1977-10-05	1977-10-26	1	2855
40365	2745	738818	1995-06-24	1995-07-01	1	9312
43688	2950	920293	1964-11-17	1964-12-01	2	-1857
712	43	1713332	1997-12-03	1997-12-17	1	10212
73326	5013	1332418	2010-09-10	2010-09-10	1	14862
42696	2893	1125315	1946-05-18	1946-06-01	1	-8615
54217	3689	1310149	2011-04-04	2011-04-04	1	15068
41362	2806	1125315	1964-07-08	1964-08-12	1	-1968
73635	5035	1343916	2003-03-03	2003-03-03	1	12114
70278	4801	1177480	1997-01-14	1997-01-28	1	9889
57817	3942	1118084	2019-05-30	2019-05-30	1	18046
45306	3076	1125315	1974-03-22	1974-04-12	1	1562
51225	3489	920293	1990-11-25	1990-12-02	1	7640
37962	2580	1322184	1998-02-23	1998-02-23	1	10280
30368	2053	1125315	1954-09-26	1954-10-03	1	-5569
48681	3311	1713332	1977-12-24	1977-12-31	1	2921
39830	2708	1125315	1965-09-29	1965-10-06	1	-1548
45438	3083	1125315	1964-02-04	1964-05-04	2	-2068
42724	2894	1119510	1986-05-08	1986-05-22	1	5985
15272	1058	1759842	2007-02-09	2007-02-23	1	13567
37364	2542	1177480	1978-05-12	1978-07-11	1	3113
61384	4191	1713332	1959-04-07	1959-05-19	1	-3880
62300	4250	1713332	1966-05-14	1966-05-21	1	-1321
38326	2604	1729720	1994-07-27	1994-08-07	1	8984
45053	3060	1102527	1945-09-12	1945-09-12	1	-8877
44142	2985	1717327	1967-06-21	1967-07-05	1	-911
52097	3547	1738521	1976-02-07	1976-02-21	1	2242
35781	2431	1713332	2001-10-04	2001-10-25	1	11620
37809	2570	1118084	1971-03-06	1971-03-06	1	429
43555	2944	1112807	1969-10-10	1969-11-14	1	-48
14766	1021	1125315	1993-09-10	1993-10-15	1	8688
5450	372	1150836	1985-05-29	1985-05-29	1	5627
44829	3041	1713332	2017-04-22	2017-05-13	1	17299
44596	3022	1713332	1990-09-03	1990-09-17	1	7564
9890	679	1125315	2011-06-11	2011-06-18	1	15143
38271	2602	1729720	2019-06-11	2019-06-23	1	18070
75934	5197	1347450	2012-05-08	2012-05-08	1	15468
42658	2891	1125315	2000-09-21	2000-10-05	1	11235
39705	2699	1125315	1978-07-13	1978-08-17	1	3150
64586	4409	1503184	1986-12-15	1987-12-10	1	6552
39054	2654	1759842	1985-01-04	1985-02-22	1	5531
75959	5199	1119510	2010-01-27	2010-02-10	1	14650
40871	2774	1332418	1997-12-26	1997-12-26	1	10221
43327	2929	1713332	1990-10-17	1990-10-24	1	7601
46774	3176	1515774	1994-10-14	1995-10-09	1	9412
43839	2961	933724	2017-10-09	2017-10-16	1	17455
38224	2598	1174888	1986-09-02	1986-09-02	1	6088
3941	268	1729720	1969-10-12	1969-10-22	1	-71
40366	2745	1102527	2007-08-28	2007-08-28	1	13753
43689	2950	933724	1964-11-17	1964-12-01	1	-1857
713	43	1729720	1959-08-08	1959-08-19	1	-3788
73327	5013	1361711	2010-09-10	2013-05-31	1	15856
42697	2893	1713332	1990-05-20	1990-06-03	1	7458
54218	3689	1729720	1961-12-01	1961-12-10	1	-2944
41363	2806	1125315	1985-02-28	1985-03-14	1	5551
73636	5035	1347450	1995-06-19	1995-06-19	1	9300
70279	4801	1503184	1986-07-15	1987-07-10	1	6399
57818	3942	1125315	2004-09-05	2004-10-10	1	12701
45307	3076	1125315	1978-04-21	1978-05-12	1	3053
51226	3489	933724	1990-11-25	1990-12-02	1	7640
37963	2580	1521369	1975-05-21	1976-05-15	1	2326
30369	2053	1125315	1989-09-21	1989-10-12	1	7224
48682	3311	1729720	2015-10-02	2015-10-12	1	16720
39831	2708	1125315	1983-08-03	1983-08-10	1	4969
45439	3083	1713332	1962-10-25	1962-11-01	1	-2618
42725	2894	1124300	1958-04-23	1958-04-23	1	-4271
16028	1108	920293	2014-02-27	2014-03-13	2	16142
37365	2542	1503184	1977-05-27	1978-05-22	1	3063
61385	4191	914335	2013-07-26	2013-07-26	1	15912
66857	4563	1125315	2001-11-03	2001-11-10	1	11636
38327	2604	1759842	1969-03-17	1969-04-07	1	-269
45054	3060	1112807	1945-09-05	1945-10-12	1	-8847
45394	3081	1177480	1976-07-14	1976-08-11	1	2414
52098	3547	1112807	1973-12-13	1973-12-27	1	1456
35782	2431	1759842	1986-04-02	1986-04-16	1	5949
37810	2570	1125315	1954-02-23	1954-03-09	1	-5777
43556	2944	1118084	1997-09-13	1997-09-13	1	10117
16159	1117	1112807	1936-09-18	1936-10-02	1	-12144
5451	372	1118084	2004-10-14	2004-10-14	1	12705
44830	3041	1759842	2013-02-23	2013-03-09	1	15773
44597	3022	1738521	1972-12-01	1972-12-15	1	1079
9891	679	1729720	1978-05-10	1978-05-17	1	3058
38272	2602	1125315	1972-10-17	1972-10-24	1	1027
75935	5197	1367571	1962-06-05	1962-06-05	1	-2767
42659	2891	1125315	2017-02-07	2017-02-28	1	17225
39706	2699	1125315	2013-09-05	2013-09-19	1	15967
64587	4409	1503184	1988-12-11	1989-12-06	1	7279
39055	2654	1112807	1945-06-26	1945-07-31	1	-8920
75960	5199	1125315	2005-06-06	2005-06-20	1	12954
40872	2774	1539403	1997-12-26	1997-12-26	1	10221
43328	2929	1759842	1990-10-17	1990-10-24	1	7601
46775	3176	1521369	1990-11-04	1991-10-30	1	7972
43840	2961	1125315	2005-12-28	2006-01-04	1	13152
38225	2598	1759842	1985-04-17	1985-05-08	1	5606
3942	268	1125315	1990-03-23	1990-03-30	1	7393
40367	2745	1125315	1995-06-24	1995-07-01	1	9312
43690	2950	1112807	1949-11-29	1949-12-13	1	-7324
714	43	1729720	1961-02-11	1961-02-18	1	-3239
73328	5013	1539403	2010-09-10	2010-09-10	1	14862
42698	2893	1759842	1964-09-15	1964-09-22	1	-1927
54219	3689	1729720	1988-10-19	1988-10-26	1	6873
41364	2806	1539403	1991-03-14	1991-03-14	1	7742
74372	5085	1118084	2013-11-14	2013-11-14	1	16023
70280	4801	1515774	1989-07-07	1990-07-02	1	7487
57819	3942	19127890	1996-03-26	1997-03-21	1	9941
45308	3076	1125315	1983-06-05	1983-06-12	1	4910
51227	3489	1118084	2012-08-09	2012-08-09	1	15561
37964	2580	1521369	1977-05-10	1978-05-05	1	3046
30370	2053	1347450	2007-09-20	2007-09-20	1	13776
48683	3311	738818	1981-02-18	1981-02-25	1	4073
39832	2708	1125315	1993-02-07	1993-02-14	1	8445
45440	3083	1729720	1962-01-19	1962-01-27	1	-2896
42726	2894	1124957	1991-02-24	1991-02-24	1	7724
16029	1108	933724	2011-10-07	2011-10-14	1	15261
37366	2542	1759842	1969-03-21	1969-04-11	1	-265
61386	4191	920293	2010-09-11	2010-09-18	1	14870
66858	4563	1125315	2005-01-04	2005-02-01	1	12815
632	40	1112807	1952-11-29	1952-12-13	1	-6228
45055	3060	1118084	1961-02-08	1961-02-08	1	-3249
45395	3081	1177480	1978-06-02	1978-06-30	1	3102
52099	3547	1125315	1987-02-16	1987-02-23	1	6262
35783	2431	1759842	2001-10-04	2001-10-25	1	11620
37811	2570	1177480	2009-06-08	2009-06-22	1	14417
43557	2944	1119510	1981-09-02	1981-09-16	1	4276
16160	1117	1112807	1937-11-12	1937-12-03	1	-11717
5452	372	1125315	1980-02-05	1980-02-12	1	3694
44831	3041	1759842	2017-04-22	2017-05-13	1	17299
44598	3022	1738521	1976-08-24	1976-09-07	1	2441
9892	679	1729720	1984-10-27	1984-11-09	1	5426
38273	2602	1125315	2017-01-26	2017-04-26	1	17282
75936	5197	1713332	2009-04-07	2009-05-05	1	14369
42660	2891	920293	1996-01-02	1996-01-09	1	9504
39707	2699	1713332	1977-07-20	1977-07-27	1	2764
64588	4409	1503184	1990-12-01	1991-11-26	1	7999
39056	2654	1174888	1983-04-20	1983-04-20	1	4857
75961	5199	1503184	1981-12-12	1982-12-07	1	4723
40873	2774	1119510	1975-04-23	1975-05-07	1	1952
43329	2929	1125315	1990-10-22	1990-12-28	2	7666
46776	3176	1549786	1994-10-14	1995-10-09	1	9412
43841	2961	1174888	1999-05-03	1999-05-03	1	10714
41910	2841	1125315	1986-10-06	1986-12-05	1	6182
3943	268	1717327	1967-11-18	1967-12-02	1	-761
40368	2745	1125315	2017-09-09	2017-09-30	1	17439
43691	2950	1112807	1986-09-05	1986-10-10	1	6126
715	43	1759842	1997-12-03	1997-12-17	1	10212
77447	5295	715997	1997-01-28	1997-01-28	1	9889
42699	2893	1759842	1990-05-20	1990-06-03	1	7458
54220	3689	1759842	1978-04-09	1978-04-16	1	3027
41365	2806	1728416	1958-05-20	1958-06-03	1	-4230
74373	5085	1729720	1977-04-11	1977-04-18	1	2664
70281	4801	1549786	1989-07-07	1990-07-02	1	7487
60025	4092	738818	1987-09-24	1987-10-08	1	6489
45309	3076	1759842	1970-04-13	1970-04-20	1	109
51228	3489	1125315	1975-05-16	1975-05-30	1	1975
37965	2580	738818	1963-07-15	1963-07-29	1	-2348
30371	2053	1713332	1981-03-04	1981-03-25	1	4101
48684	3311	1112807	1965-01-03	1965-01-17	1	-1810
39833	2708	1728416	1954-09-05	1954-09-19	1	-5583
45441	3083	1125315	2013-02-19	2013-04-20	1	15815
42727	2894	1713332	2004-09-18	2004-10-23	1	12714
16030	1108	1125315	1971-05-21	1971-06-04	1	519
37367	2542	975125	1986-06-07	1986-06-07	1	6001
61387	4191	1118084	1996-10-25	1996-10-25	1	9794
66859	4563	1759842	1972-08-21	1972-09-04	1	977
633	40	1118084	1993-07-12	1993-07-12	1	8593
45056	3060	1125315	1928-07-23	1928-08-06	1	-15123
45396	3081	1347450	2011-09-07	2011-09-07	1	15224
52100	3547	1112807	1972-10-30	1972-11-13	1	1047
35784	2431	1521369	1986-07-12	1987-07-07	1	6396
37812	2570	738818	1936-10-17	1936-10-24	1	-12122
43558	2944	1125315	2006-10-23	2006-10-23	1	13444
16161	1117	1125315	1980-04-12	1980-04-26	1	3768
5453	372	1125315	2004-04-14	2004-04-28	1	12536
44832	3041	1125315	1987-02-09	1987-03-09	1	6276
44599	3022	1759842	1990-09-03	1990-09-17	1	7564
9893	679	1759842	1980-07-04	1980-07-18	1	3851
38274	2602	1557272	2009-03-25	2009-03-25	1	14328
75937	5197	1741122	1962-06-06	1962-06-06	1	-2766
42661	2891	1521369	1987-11-19	1988-11-13	1	6891
39708	2699	19127890	1991-10-08	1992-10-02	1	8310
64589	4409	1515774	1989-12-06	1990-12-01	1	7639
39057	2654	1177480	2010-03-09	2010-06-07	1	14767
75962	5199	1503184	1984-11-26	1985-11-21	1	5803
40874	2774	1124957	2011-03-27	2011-03-27	1	15060
43330	2929	1125315	1992-10-13	1992-10-20	1	8328
46777	3176	1713332	1999-06-11	1999-06-25	1	10767
43842	2961	1521369	1986-09-17	1987-09-12	1	6463
41911	2841	1174888	1994-08-21	1994-08-21	1	8998
3944	268	1112807	1967-11-18	1967-12-02	1	-761
40369	2745	1177480	2004-12-13	2005-01-10	1	12793
43692	2950	1118084	1978-04-26	1978-04-26	1	3037
2647	177	1124300	2000-05-31	2000-05-31	1	11108
77448	5295	836654	1995-09-06	1995-09-06	1	9379
42700	2893	1125315	1949-05-25	1949-06-01	1	-7519
54221	3689	1119510	2014-07-10	2014-07-17	1	16268
41366	2806	1118084	1996-03-21	1996-03-21	1	9576
74374	5085	1717327	1976-12-08	1976-12-22	1	2547
70282	4801	1759842	2006-04-26	2006-05-03	1	13271
60026	4092	1125315	1976-11-18	1976-12-02	1	2527
45310	3076	1115008	2017-10-20	2017-11-19	1	17489
51229	3489	1125315	1977-12-22	1978-01-05	1	2926
37966	2580	738818	1989-07-29	1989-08-12	1	7163
30372	2053	1729720	1955-07-25	1955-08-02	1	-5266
48685	3311	1118084	1995-07-05	1995-07-05	1	9316
39834	2708	738818	1965-09-29	1965-10-06	1	-1548
45442	3083	1729720	1996-11-13	1996-11-24	1	9824
16031	1108	1125315	2000-05-12	2000-05-19	1	11096
37368	2542	1119510	1994-10-11	1994-10-18	1	9056
61388	4191	1119510	1999-08-15	1999-08-29	1	10832
66860	4563	1759842	2019-03-14	2019-03-21	1	17976
634	40	1119510	1985-05-29	1985-06-12	1	5641
45057	3060	1125315	1932-12-16	1932-12-23	1	-13523
45397	3081	1729720	1957-06-27	1957-07-08	1	-4560
52101	3547	1124300	2014-05-23	2014-05-23	1	16213
35785	2431	1521369	1988-07-01	1989-06-26	1	7116
37813	2570	920293	1993-10-01	1993-10-15	2	8688
43559	2944	1125315	2016-05-30	2016-06-13	1	16965
16162	1117	1713332	1988-03-27	1988-04-03	1	6667
5454	372	1177480	2018-12-22	2019-02-20	1	17947
44833	3041	1713332	1981-08-04	1981-10-27	1	4317
44600	3022	1125315	1985-04-09	1985-06-08	1	5637
9894	679	1119510	2007-11-01	2007-11-15	1	13832
38275	2602	1728416	1948-11-28	1948-12-12	1	-7690
78136	5335	1112807	1964-03-22	1964-04-12	1	-2090
42662	2891	1759842	1979-11-27	1980-02-26	1	3708
39709	2699	19127890	1994-09-22	1995-09-17	1	9390
64590	4409	1549786	1989-12-06	1990-12-01	1	7639
39058	2654	1728416	1949-11-02	1949-11-16	1	-7351
75963	5199	1503184	1987-11-11	1988-11-05	1	6883
40875	2774	1125315	1977-04-07	1977-04-21	1	2667
43331	2929	1125315	2004-10-05	2004-10-19	1	12710
46778	3176	920293	2001-01-11	2001-01-25	2	11347
43843	2961	1729720	1982-12-12	1982-12-21	1	4737
41912	2841	1177480	1979-12-14	1980-01-11	1	3662
3945	268	1717327	1977-05-29	1977-06-19	1	2726
40370	2745	1118084	2012-12-25	2012-12-25	1	15699
43693	2950	1174888	2014-02-11	2014-02-11	1	16112
2648	177	1125315	2002-05-14	2002-05-14	1	11821
77449	5295	1118084	1943-02-08	1943-02-08	1	-9824
42701	2893	1125315	1956-05-15	1956-07-14	1	-4919
54222	3689	1125315	1975-03-10	1975-03-24	1	1908
41367	2806	1125315	1982-01-10	1982-04-10	1	4482
74375	5085	1177480	1976-12-08	1976-12-22	1	2547
70283	4801	1115008	2016-12-08	2017-02-06	1	17203
60027	4092	1125315	1987-09-24	1987-10-08	1	6489
45311	3076	1125315	1952-05-16	1952-05-30	1	-6425
51230	3489	1713332	1987-12-15	1987-12-29	1	6571
37967	2580	738818	1991-10-03	1991-10-10	1	7952
30373	2053	1177480	2000-11-13	2000-12-11	1	11302
48686	3311	1125315	1969-10-10	1969-10-24	1	-69
39835	2708	1119510	1968-03-05	1968-03-12	1	-660
45443	3083	920293	1994-07-21	1994-07-28	1	8974
16032	1108	920293	2006-08-18	2006-09-01	2	13392
37369	2542	1124300	2003-03-07	2003-03-07	1	12118
61389	4191	1309944	2013-07-26	2013-07-26	1	15912
66861	4563	1119510	1984-04-10	1984-04-17	1	5220
635	40	1177480	1994-11-19	1994-12-03	1	9102
45058	3060	1125315	1991-11-21	1991-11-28	1	8001
45398	3081	1118084	1984-05-08	1984-05-08	1	5241
52102	3547	1112807	1976-02-07	1976-02-21	1	2242
35786	2431	1713332	2017-12-14	2018-01-04	1	17535
37814	2570	1112807	1958-08-21	1958-09-04	1	-4137
43560	2944	1177480	1976-03-01	1976-03-22	1	2272
16163	1117	1759842	1988-03-27	1988-04-03	1	6667
5455	372	1759842	1969-10-05	1969-10-19	1	-74
44834	3041	1551099	2005-08-04	2005-08-04	1	12999
44601	3022	1125315	1991-07-18	1991-07-25	1	7875
9895	679	1119510	2011-06-11	2011-06-18	1	15143
38276	2602	1112807	1948-11-28	1948-12-12	1	-7690
78137	5335	1125315	1980-03-30	1980-04-06	1	3748
44628	3025	975125	1971-12-02	1971-12-02	1	700
41464	2813	1115008	1994-02-17	1994-03-10	1	8834
64591	4409	1713332	1985-12-31	1986-01-14	1	5857
39059	2654	1125315	1955-01-06	1955-01-20	1	-5460
75964	5199	1521369	1987-11-11	1988-11-05	1	6883
40876	2774	1177480	2007-03-20	2007-04-17	1	13620
43332	2929	1177480	1975-10-11	1975-10-25	1	2123
2432	161	1115008	2009-06-10	2009-07-01	1	14426
43844	2961	1759842	1990-10-28	1990-11-18	1	7626
41913	2841	1174888	1981-11-01	1981-11-01	1	4322
3946	268	1112807	1977-05-29	1977-06-19	1	2726
40371	2745	1119510	1995-06-24	1995-07-01	1	9312
43694	2950	1713332	2001-04-29	2001-05-20	1	11462
2649	177	920293	2016-05-28	2016-06-04	1	16956
77450	5295	1125315	1939-11-22	1939-11-29	1	-10991
42702	2893	1125315	1997-08-06	1997-09-03	1	10107
54223	3689	1326303	2011-04-04	2011-04-04	1	15068
41368	2806	1125315	2009-05-25	2009-07-24	1	14449
74376	5085	1177480	2003-05-21	2003-06-11	1	12214
70284	4801	1119510	2013-03-04	2013-03-18	1	15782
60028	4092	19127890	1988-05-29	1993-05-03	5	8523
45312	3076	1713332	1970-04-13	1970-04-20	1	109
51231	3489	1738521	1975-05-16	1975-05-30	1	1975
37968	2580	914335	1979-05-07	1979-05-07	1	3413
30374	2053	1322184	2007-09-20	2007-09-20	1	13776
48687	3311	1125315	1981-02-18	1981-02-25	1	4073
39836	2708	1124300	1988-10-16	1988-10-16	1	6863
45444	3083	933724	1994-07-21	1994-07-28	1	8974
16033	1108	920293	2012-11-10	2012-11-17	1	15661
37370	2542	1125315	1980-03-02	1980-04-01	1	3743
61390	4191	1322184	2004-09-17	2004-09-17	1	12678
66862	4563	1125315	1970-04-12	1970-04-26	1	115
636	40	1177480	2003-08-18	2003-09-01	1	12296
45059	3060	1125315	1994-03-18	1994-03-25	1	8849
45399	3081	1119510	1975-05-31	1975-06-14	1	1990
52103	3547	1115008	2018-01-23	2018-02-13	1	17575
35787	2431	1717327	1976-05-25	1976-06-08	1	2350
37815	2570	1125315	1936-10-17	1936-10-24	1	-12122
45491	3087	1125315	2002-03-12	2002-03-26	1	11772
16164	1117	1125315	1974-05-03	1974-05-10	1	1590
5456	372	975125	1985-05-15	1985-05-15	1	5613
46208	3137	920293	1943-06-21	1943-06-28	1	-9684
44602	3022	1125315	2011-11-08	2011-11-22	1	15300
12938	884	1118084	2017-09-16	2017-09-16	1	17425
38277	2602	1124300	1986-11-14	1986-11-14	1	6161
78138	5335	1125315	1981-09-29	1981-10-27	1	4317
44629	3025	1112807	1946-10-22	1946-11-05	1	-8458
41465	2813	1119510	1980-06-14	1980-06-21	1	3824
64592	4409	1729720	1975-08-08	1975-08-21	1	2058
39060	2654	1125315	1968-05-21	1968-06-04	1	-576
75965	5199	19127890	1976-01-13	1977-01-07	1	2563
40877	2774	1361711	1997-12-26	1997-12-26	1	10221
46132	3133	1112807	1956-09-19	1956-10-03	1	-4838
2433	161	1124300	2011-01-01	2011-01-01	1	14975
43845	2961	1119510	1994-06-29	1994-07-13	1	8959
41914	2841	1361711	1983-09-11	1984-10-21	1	5407
3947	268	1124300	2004-01-28	2004-01-28	1	12445
40372	2745	1125315	1977-01-20	1977-01-27	1	2583
43695	2950	1759842	2001-04-29	2001-05-20	1	11462
2650	177	933724	2016-05-28	2016-06-04	1	16956
77451	5295	1125315	1944-05-08	1944-05-15	1	-9362
42703	2893	1759842	2005-10-21	2005-11-11	1	13098
54224	3689	1118084	1987-05-11	1987-05-11	1	6339
41369	2806	1332418	1995-04-27	1995-04-27	1	9247
76745	5245	1713332	1984-09-10	1984-09-24	1	5380
70285	4801	1521369	1986-07-15	1987-07-10	1	6399
60029	4092	1118084	2015-02-12	2015-02-12	1	16478
45313	3076	1728416	1952-05-16	1952-05-30	1	-6425
51232	3489	1759842	1987-12-15	1987-12-29	1	6571
37969	2580	1125315	1963-07-15	1963-07-29	1	-2348
30375	2053	1728416	1953-09-30	1953-10-14	1	-5923
48688	3311	1125315	1986-02-13	1986-02-27	1	5901
39837	2708	1759842	2009-11-21	2009-12-05	1	14583
45445	3083	1112807	1952-02-23	1952-03-08	1	-6508
16034	1108	920293	2013-01-16	2013-01-23	1	15728
37371	2542	1125315	1989-02-14	1989-02-21	1	6991
61391	4191	1343916	2013-07-26	2013-07-26	1	15912
66863	4563	1521369	1978-12-04	1979-11-29	1	3619
637	40	1177480	2018-06-14	2018-07-14	1	17726
45060	3060	1125315	2012-03-29	2012-04-28	1	15458
45400	3081	1119510	2005-10-30	2005-11-06	1	13093
52104	3547	1125315	2004-07-04	2004-07-18	1	12617
35788	2431	1729720	1979-05-04	1979-05-17	1	3423
37816	2570	1713332	1936-07-24	1936-08-07	1	-12200
45492	3087	1309944	2001-02-28	2001-02-28	1	11381
16165	1117	1125315	1982-05-16	1982-06-13	1	4546
5457	372	1125315	1999-05-15	1999-06-05	1	10747
46209	3137	933724	1943-06-21	1943-06-28	1	-9684
44603	3022	1177480	1976-08-24	1976-09-07	1	2441
12939	884	1125315	1982-09-17	1982-10-22	1	4677
38278	2602	1125315	1948-11-30	1948-12-14	1	-7688
78139	5335	1759842	1973-05-18	1973-06-08	1	1254
44630	3025	1118084	1984-08-03	1984-08-03	1	5328
41466	2813	1125315	1940-05-27	1940-06-03	1	-10804
64593	4409	1729720	1978-11-07	1978-11-16	1	3241
39061	2654	1125315	1980-06-16	1980-06-23	1	3826
75966	5199	738818	2010-01-27	2010-02-10	1	14650
40878	2774	1729720	1978-08-28	1978-09-08	1	3172
46133	3133	1112807	1958-10-21	1958-11-04	1	-4076
2434	161	1125315	1978-02-24	1978-03-10	1	2990
43846	2961	1125315	1999-05-03	1999-05-03	1	10714
41915	2841	1361711	1986-09-14	1994-08-21	1	8998
5910	406	1713332	1959-05-31	1959-06-07	1	-3861
40373	2745	1125315	2003-12-28	2004-01-18	1	12435
44995	3056	1124300	1997-05-12	1997-05-12	1	9993
2651	177	1115008	2002-05-07	2002-07-13	1	11881
77452	5295	1125315	1961-09-22	1961-09-29	1	-3016
47039	3191	738818	1992-05-26	1992-06-09	1	8195
54225	3689	1713332	1978-04-09	1978-04-16	1	3027
41370	2806	1112807	1957-09-22	1957-10-13	1	-4463
76746	5245	1118084	2015-12-10	2015-12-10	1	16779
70286	4801	1713332	1980-10-09	1980-10-16	1	3941
60030	4092	1503184	1988-05-29	1991-05-14	3	7803
45314	3076	1102527	2017-10-20	2017-10-20	1	17459
51233	3489	19127890	1990-10-04	1991-09-29	1	7941
37970	2580	1125315	1989-07-29	1989-08-12	1	7163
30376	2053	1729720	1959-09-08	1959-09-16	1	-3760
48689	3311	1119510	1981-02-18	1981-02-25	1	4073
41040	2786	1112807	1935-06-24	1935-07-08	1	-12596
45446	3083	1112807	1969-09-05	1969-09-19	1	-104
16035	1108	933724	2006-08-18	2006-09-01	1	13392
37372	2542	1125315	2001-06-15	2001-06-22	1	11495
61392	4191	1759842	1975-11-26	1975-12-10	1	2169
66864	4563	1713332	2016-05-16	2016-05-23	1	16944
638	40	1347450	2006-11-29	2006-11-29	1	13481
45061	3060	1713332	2017-01-19	2017-01-26	1	17192
45401	3081	1125315	1985-09-21	1985-11-20	1	5802
52105	3547	1125315	2009-10-05	2009-10-12	1	14529
38412	2613	1115008	2016-04-27	2016-04-27	1	16918
37817	2570	1713332	2004-01-31	2004-02-07	1	12455
45493	3087	1343916	2001-02-28	2001-02-28	1	11381
16166	1117	1759842	2012-09-23	2012-10-07	1	15620
5458	372	1713332	1969-10-05	1969-10-19	1	-74
46210	3137	1119510	1910-06-13	1910-06-27	1	-21738
44604	3022	1729720	1975-04-24	1975-05-07	1	1952
12940	884	1125315	1985-08-21	1985-08-28	1	5718
38279	2602	1125315	1992-01-03	1992-01-24	1	8058
78140	5335	705944	1966-08-19	1968-04-05	1	-636
44631	3025	1125315	1979-09-01	1979-09-08	1	3537
41467	2813	1310149	2013-10-18	2013-10-18	1	15996
64594	4409	1118084	2005-06-28	2005-06-28	1	12962
39062	2654	1125315	2015-03-31	2015-04-07	1	16532
75967	5199	1125315	1963-10-09	1963-10-23	1	-2262
41582	2821	738818	1983-11-07	1983-11-14	1	5065
46134	3133	1112807	1961-01-26	1961-03-27	1	-3202
2435	161	1125315	2018-07-03	2018-07-17	1	17729
43847	2961	738818	1994-06-29	1994-07-13	1	8959
41916	2841	1112807	1950-04-22	1950-05-20	1	-7166
5911	406	1713332	2008-10-29	2008-11-19	1	14202
40374	2745	1759842	2005-10-06	2005-10-13	1	13069
44996	3056	1125315	1958-01-22	1958-02-05	1	-4348
2652	177	1125315	1969-12-04	1969-12-18	1	-14
77453	5295	1125315	1971-02-18	1971-04-19	1	473
1418	96	1112807	1942-02-26	1942-04-27	1	-10111
54226	3689	738818	2014-07-10	2014-07-17	1	16268
41371	2806	1361711	1985-03-07	1985-03-07	1	5544
76747	5245	1729720	1984-03-11	1984-03-23	1	5195
70287	4801	1713332	1997-01-14	1997-01-28	1	9889
60031	4092	1515774	1991-05-14	1993-05-03	2	8523
45315	3076	1115008	2012-11-24	2012-12-15	1	15689
52035	3543	933724	2018-09-13	2018-09-20	1	17794
37971	2580	1125315	1991-10-03	1991-10-10	1	7952
30377	2053	1729720	1971-02-27	1971-03-10	1	433
48690	3311	1125315	2012-01-07	2012-01-21	1	15360
41041	2786	1112807	1936-09-16	1936-09-30	1	-12146
45447	3083	1118084	1994-07-07	1994-07-07	1	8953
16036	1108	933724	2013-01-16	2013-01-23	1	15728
37373	2542	1125315	2018-12-30	2019-01-06	1	17902
61393	4191	19127890	1975-07-23	1977-07-12	2	2749
66865	4563	1759842	2016-05-16	2016-05-23	1	16944
639	40	1728416	1961-03-31	1961-04-14	1	-3184
45062	3060	1759842	1964-08-20	1964-09-10	1	-1939
45402	3081	738818	2005-10-30	2005-11-06	1	13093
52106	3547	1177480	2001-03-02	2001-03-23	1	11404
38413	2613	1125315	1967-06-15	1967-06-22	1	-924
37818	2570	1713332	2004-03-22	2004-04-05	1	12513
45494	3087	1119510	2002-03-12	2002-03-26	1	11772
16167	1117	738818	1986-07-06	1986-07-20	1	6044
5951	408	1124300	2004-07-16	2004-07-16	1	12615
46211	3137	1125315	1933-06-10	1933-06-10	1	-13354
44605	3022	1118084	2012-04-15	2012-04-15	1	15445
12941	884	1309944	2005-05-24	2005-05-24	1	12927
38280	2602	1125315	2006-02-28	2006-03-14	1	13221
78141	5335	1118084	1992-10-01	1992-10-01	1	8309
44632	3025	1125315	2002-10-14	2002-10-14	1	11974
41468	2813	1361711	2017-03-03	2017-03-03	1	17228
64595	4409	1521369	1983-01-05	1983-12-31	1	5112
39063	2654	1177480	1983-04-13	1983-06-19	1	4917
75968	5199	1125315	1973-01-02	1973-01-30	1	1125
41583	2821	1125315	1946-04-02	1946-04-09	1	-8668
46135	3133	1125315	2010-04-08	2010-04-22	1	14721
2436	161	1125315	2013-07-31	2013-08-28	1	15945
43848	2961	920293	2017-10-09	2017-10-16	1	17455
41917	2841	1125315	1981-11-01	1981-12-31	2	4382
5912	406	1728416	1952-09-16	1952-09-30	1	-6302
40375	2745	1778162	2007-08-28	2007-10-02	1	13788
44997	3056	1154343	1960-01-04	1960-01-04	1	-3650
2653	177	1125315	1973-10-15	1973-11-04	1	1403
77454	5295	1322184	1998-06-10	1998-06-10	1	10387
1419	96	1112807	1942-12-23	1943-01-06	1	-9857
54227	3689	1119510	1975-03-10	1975-03-24	1	1908
41372	2806	1521369	1976-02-25	1977-02-19	1	2606
76748	5245	1125315	1990-12-02	1990-12-16	1	7654
70288	4801	1759842	1980-10-09	1980-10-16	1	3941
60032	4092	1549786	1991-05-14	1993-05-03	2	8523
45316	3076	1118084	1989-02-06	1989-02-06	1	6976
52036	3543	1112807	1978-07-14	1978-09-19	1	3183
37972	2580	1125315	2015-08-21	2015-08-28	1	16675
32589	2207	1112807	1982-01-14	1982-01-28	1	4410
48691	3311	1759842	1977-12-24	1977-12-31	1	2921
41042	2786	1112807	1947-01-26	1947-02-09	1	-8362
45448	3083	1124957	1964-02-04	1964-02-04	1	-2158
16037	1108	933724	2014-02-27	2014-03-13	1	16142
37374	2542	1521369	1977-05-27	1978-05-22	1	3063
61394	4191	933724	2010-09-11	2010-09-18	1	14870
66866	4563	738818	1984-04-10	1984-04-17	1	5220
640	40	1729720	1983-09-01	1983-09-14	1	5004
45063	3060	738818	1968-02-25	1968-03-03	1	-669
45403	3081	1125315	1955-04-06	1955-06-05	1	-5324
52749	3595	1112807	1951-05-04	1951-06-08	1	-6782
38414	2613	1728416	1960-04-16	1960-04-30	1	-3533
37819	2570	1759842	1951-06-13	1951-06-27	1	-6763
45495	3087	1713332	1978-02-28	1978-03-14	1	2994
16168	1117	1118084	1978-09-28	1978-09-28	1	3192
5952	408	1125315	2011-06-03	2011-06-10	1	15135
46212	3137	1729720	1927-03-18	1927-03-27	1	-15621
44606	3022	1125315	1972-12-01	1972-12-15	1	1079
12942	884	19010482	2013-10-28	2013-11-11	1	16020
38281	2602	1125315	2018-02-20	2018-03-20	1	17610
78142	5335	1713332	1973-05-18	1973-06-08	1	1254
44633	3025	1545958	2002-10-14	2002-10-14	1	11974
41469	2813	1713332	1937-01-08	1937-01-15	1	-12039
64596	4409	1521369	1986-12-15	1987-12-10	1	6552
39064	2654	1713332	1985-01-04	1985-02-22	1	5531
75969	5199	1125315	2010-01-27	2010-02-10	1	14650
41584	2821	1125315	1983-11-07	1983-11-14	1	5065
46136	3133	1713332	2011-01-24	2011-02-07	1	15012
2437	161	1125315	2016-01-19	2016-01-26	1	16826
43849	2961	1125315	1976-11-27	1976-12-11	1	2536
41918	2841	1125315	1984-10-21	1984-10-21	1	5407
5913	406	1759842	2008-10-29	2008-11-19	1	14202
40728	2767	757627	2019-04-10	2019-04-10	1	17996
44998	3056	1728416	1958-01-22	1958-02-05	1	-4348
2654	177	1174888	2002-05-14	2002-05-14	1	11821
77455	5295	1713332	1993-05-20	1993-06-03	1	8554
1420	96	1115008	1996-10-01	1996-10-15	1	9784
54228	3689	1125315	1959-09-10	1959-09-17	1	-3759
42077	2853	1125315	1973-04-13	1973-04-20	1	1205
76749	5245	1125315	2004-06-02	2004-06-23	1	12592
70289	4801	19127890	1989-07-07	1990-07-02	1	7487
60033	4092	1729720	1982-07-08	1982-07-21	1	4584
45317	3076	1177480	2004-09-18	2004-10-09	1	12700
52037	3543	1125315	1978-07-21	1978-07-21	1	3123
37973	2580	1343916	1979-05-07	1979-05-07	1	3413
32590	2207	1119510	1989-01-08	1989-01-22	1	6961
48692	3311	1112807	1965-11-13	1965-12-04	1	-1489
41043	2786	1112807	1956-01-19	1956-02-09	1	-5075
45449	3083	1125315	1951-05-30	1951-06-13	1	-6777
16038	1108	1119510	1981-02-19	1981-02-26	1	4074
37375	2542	1713332	1969-03-21	1969-04-11	1	-265
61395	4191	1125315	1973-08-24	1973-08-31	1	1338
66867	4563	1124300	2003-07-21	2003-07-21	1	12254
641	40	1112807	1961-03-17	1961-04-14	1	-3184
45064	3060	1112807	1926-12-14	1926-12-28	1	-15710
45404	3081	1125315	1969-09-20	1969-09-27	1	-96
52750	3595	738818	1980-04-19	1980-05-03	1	3775
38415	2613	1125315	1957-10-01	1957-10-15	1	-4461
37820	2570	1112807	1946-09-23	1946-12-22	1	-8411
45496	3087	914335	2001-02-28	2001-02-28	1	11381
16169	1117	1125315	1984-05-03	1984-05-24	1	5257
5953	408	19127890	1978-05-19	1979-05-14	1	3420
46213	3137	1759842	1957-12-08	1957-12-29	1	-4386
44607	3022	1125315	2003-02-08	2003-02-15	1	12098
12943	884	19127890	1991-09-03	1994-08-18	3	8995
40245	2736	1125315	1982-08-04	1982-08-18	1	4612
78143	5335	1713332	2004-11-27	2004-12-11	1	12763
44634	3025	1112807	1948-08-26	1948-09-09	1	-7784
41470	2813	1759842	1937-01-08	1937-01-15	1	-12039
64597	4409	1713332	2008-09-18	2008-12-18	1	14231
41893	2839	1125315	1977-11-22	1977-12-06	1	2896
75970	5199	1503184	1976-01-13	1977-01-07	1	2563
41585	2821	1125315	2003-11-13	2003-11-20	1	12376
46137	3133	1728416	1956-09-19	1956-10-03	1	-4838
2438	161	1177480	1991-05-16	1991-05-30	1	7819
43850	2961	1125315	1994-06-29	1994-07-13	1	8959
41919	2841	1174888	1984-10-21	1984-10-21	1	5407
5914	406	975125	1974-02-22	1974-02-22	1	1513
40729	2767	1000560	1939-05-23	1939-05-24	2	-11181
44999	3056	1119510	1983-08-03	1983-08-17	1	4976
2655	177	1177480	2011-12-03	2011-12-17	1	15325
77456	5295	1125315	1981-11-16	1981-11-23	1	4344
1421	96	1177480	1979-07-12	1979-08-02	1	3500
54229	3689	1125315	2014-07-10	2014-07-17	1	16268
42078	2853	1713332	1983-05-10	1983-05-31	1	4898
76750	5245	1177480	1989-09-07	1989-09-21	1	7203
70290	4801	738818	2013-03-04	2013-03-18	1	15782
60034	4092	1729720	1996-08-08	1996-08-18	1	9726
45318	3076	914335	1952-11-26	1952-11-26	1	-6245
52038	3543	1503184	1977-06-24	1978-06-19	1	3091
37974	2580	1503184	1975-05-21	1976-05-15	1	2326
32591	2207	1125315	1981-02-18	1981-03-04	1	4080
48693	3311	1125315	1979-01-15	1979-01-29	1	3315
41044	2786	1112807	1957-03-05	1957-04-02	1	-4657
45450	3083	920293	1990-06-01	1990-06-08	1	7463
16039	1108	1125315	1980-06-30	1980-07-21	1	3854
37376	2542	1713332	2006-07-24	2006-08-14	1	13374
61396	4191	1713332	1975-11-26	1975-12-10	1	2169
66868	4563	1125315	1976-06-27	1976-07-11	1	2383
642	40	1112807	1967-08-13	1967-09-12	1	-842
45065	3060	1115008	1998-06-06	1998-09-04	1	10473
45405	3081	1125315	1984-05-14	1984-05-21	1	5254
52751	3595	1125315	1980-04-19	1980-05-03	1	3775
38416	2613	1713332	1989-04-07	1989-04-28	1	7057
37821	2570	1115008	2004-03-22	2004-04-05	1	12513
45497	3087	1115008	1996-07-15	1996-10-13	1	9782
16170	1117	1125315	1986-07-06	1986-07-20	1	6044
5954	408	19127890	1981-05-03	1982-04-28	1	4500
46214	3137	738818	1910-06-13	1910-06-27	1	-21738
44608	3022	1177480	1975-04-20	1975-05-25	1	1970
12944	884	1124957	2007-02-25	2007-02-25	1	13569
40246	2736	1768849	1982-08-04	1982-08-18	1	4612
78144	5335	1759842	2004-11-27	2004-12-11	1	12763
44635	3025	1174888	2002-10-14	2002-10-14	1	11974
41471	2813	1759842	1944-03-09	1944-03-30	1	-9408
64598	4409	1717327	1967-07-18	1967-08-01	1	-884
41894	2839	1125315	1987-08-16	1987-08-30	1	6450
75971	5199	19127890	1981-12-12	1982-12-07	1	4723
41586	2821	1729720	1993-06-25	1993-07-08	1	8589
46138	3133	1729720	1960-07-03	1960-07-16	1	-3456
2439	161	1177480	2011-07-21	2011-08-11	1	15197
43851	2961	1503184	1986-09-17	1987-09-12	1	6463
41920	2841	1728416	1950-04-22	1950-05-20	1	-7166
5915	406	1112807	1952-09-16	1952-09-30	1	-6302
40730	2767	1118084	1970-10-17	1970-10-17	1	289
45000	3056	1125315	1991-01-26	1991-02-02	1	7702
2656	177	1322184	2009-11-08	2009-11-08	1	14556
77457	5295	1177480	1995-04-13	1995-04-27	1	9247
1422	96	1347450	1989-09-16	1989-09-16	1	7198
54230	3689	1307863	2011-04-04	2011-04-04	1	15068
42079	2853	1729720	1964-08-29	1964-09-09	1	-1940
76751	5245	1115008	2001-09-18	2001-10-16	1	11611
70291	4801	1125315	2013-03-04	2013-03-18	1	15782
60035	4092	1759842	1991-10-02	1991-10-16	1	7958
45319	3076	1112807	1967-07-27	1967-08-26	1	-859
52039	3543	1503184	1980-06-08	1981-06-03	1	4171
37975	2580	1503184	1977-05-10	1978-05-05	1	3046
32592	2207	19127890	1996-04-14	1997-04-09	1	9960
48694	3311	1729720	2011-09-12	2011-09-20	1	15237
41045	2786	1112807	1966-03-16	1966-03-30	1	-1373
45451	3083	1115008	2004-10-20	2004-11-03	1	12725
16040	1108	1717327	1971-05-21	1971-06-04	1	519
37377	2542	1729720	2006-12-30	2007-01-11	1	13524
61397	4191	1717327	1961-08-25	1961-09-08	1	-3037
66869	4563	1125315	1980-04-17	1980-05-15	1	3787
643	40	1124957	2018-06-14	2018-06-14	1	17696
45066	3060	1115008	2010-03-19	2010-04-09	1	14708
45406	3081	1125315	2005-10-30	2005-11-06	1	13093
52752	3595	1125315	1985-06-09	1985-09-07	1	5728
38417	2613	1112807	1960-04-16	1960-04-30	1	-3533
37822	2570	1119510	1954-02-23	1954-03-09	1	-5777
45498	3087	1119510	1984-07-18	1984-07-25	1	5319
16171	1117	1125315	2002-06-30	2002-07-07	1	11875
5955	408	738818	2003-04-27	2003-05-04	1	12176
46215	3137	933724	1939-05-11	1939-05-18	1	-11186
44609	3022	1125315	1978-11-12	1979-01-11	1	3297
12945	884	1125315	1981-04-19	1981-04-26	1	4133
40247	2736	1112807	1970-05-03	1970-05-17	1	136
78145	5335	1112807	1972-06-29	1972-08-03	1	945
44636	3025	1322184	1997-06-02	2002-10-14	1	11974
41472	2813	1112807	1936-07-16	1936-08-20	1	-12187
64599	4409	1759842	2008-09-18	2008-12-18	1	14231
41895	2839	1713332	2015-07-27	2015-08-17	1	16664
75972	5199	19127890	1984-11-26	1985-11-21	1	5803
41587	2821	715997	2002-11-08	2002-11-08	1	11999
46139	3133	1759842	1973-06-22	1973-07-13	1	1289
2440	161	1713332	2000-02-28	2000-03-06	1	11022
43852	2961	1717327	1976-11-27	1976-12-11	1	2536
41921	2841	1118084	1990-11-03	1990-11-03	1	7611
5916	406	1115008	2010-10-26	2010-11-30	1	14943
40731	2767	1125315	1967-03-01	1967-03-15	1	-1023
45001	3056	1125315	1960-05-12	1960-05-19	1	-3514
2657	177	1521369	1981-04-15	1982-04-10	1	4482
77458	5295	1347450	1998-06-10	1998-06-10	1	10387
1423	96	1759842	1933-11-16	1933-12-07	1	-13174
54628	3717	1125315	1977-07-04	1977-07-11	1	2748
42080	2853	1759842	2008-06-18	2008-07-02	1	14062
76752	5245	1759842	1984-09-10	1984-09-24	1	5380
70292	4801	1177480	1975-09-15	1975-09-29	1	2097
60036	4092	1174888	1986-12-26	1986-12-26	1	6203
45320	3076	1115008	2010-12-07	2011-01-04	1	14978
52040	3543	920293	2013-08-09	2013-08-16	1	15933
39733	2702	738818	1986-03-30	1986-04-06	1	5939
32593	2207	1125315	2018-10-03	2018-10-17	1	17821
51285	3494	1125315	1968-03-22	1968-03-29	1	-643
41046	2786	1115008	2004-01-08	2004-02-24	1	12472
45452	3083	1125315	1955-12-21	1955-12-28	1	-5118
16041	1108	933724	2012-11-10	2012-11-17	1	15661
37378	2542	1759842	2006-07-24	2006-08-14	1	13374
61398	4191	1729720	1977-07-10	1977-07-22	1	2759
66870	4563	1125315	1984-04-10	1984-04-17	1	5220
644	40	1125315	1964-12-28	1965-01-04	1	-1823
45067	3060	1119510	1928-07-23	1928-08-06	1	-15123
45407	3081	1125315	2015-09-03	2015-09-17	1	16695
52753	3595	1125315	1989-08-08	1989-09-12	1	7194
38418	2613	1125315	1974-10-14	1974-11-04	1	1768
37823	2570	1347450	1992-11-19	1992-11-19	1	8358
45499	3087	1125315	1954-07-07	1954-07-14	1	-5650
16172	1117	1112807	1943-10-03	1943-10-24	1	-9566
5956	408	1119510	2003-04-27	2003-05-04	1	12176
46216	3137	1112807	1933-06-10	1933-07-08	1	-13326
45597	3096	1112807	1968-08-12	1968-08-26	1	-493
12946	884	1125315	2013-11-26	2013-12-03	1	16042
40248	2736	1125315	2019-05-16	2019-06-06	1	18053
78146	5335	1125315	1975-08-18	1975-09-01	1	2069
44637	3025	1332418	1995-03-06	1995-03-06	1	9195
41473	2813	1112807	1937-09-09	1937-09-23	1	-11788
64600	4409	19127890	1988-12-11	1991-11-26	3	7999
41896	2839	1125315	2012-11-06	2012-11-13	1	15657
75973	5199	723013	1977-10-18	1978-04-04	1	3015
41588	2821	738818	1999-03-26	1999-04-02	1	10683
46140	3133	1112807	1972-09-25	1972-12-24	1	1088
2441	161	1713332	2012-02-11	2012-02-25	1	15395
43853	2961	1115008	2004-03-06	2004-04-03	1	12511
41922	2841	1125315	1994-08-21	1994-08-21	1	8998
5917	406	1124300	1996-06-27	1996-06-27	1	9674
40732	2767	1125315	1984-03-28	1984-04-04	1	5207
45002	3056	1125315	1962-11-16	1962-11-30	1	-2589
2658	177	1713332	2011-12-03	2011-12-17	1	15325
77459	5295	1728416	1949-05-15	1949-05-29	1	-7522
1424	96	1759842	1970-04-05	1970-04-26	1	115
54629	3717	1125315	1989-11-14	1989-11-21	1	7264
42081	2853	738818	1995-03-24	1995-04-07	1	9227
77049	5265	1112807	1971-02-06	1971-02-20	1	415
70293	4801	1713332	2006-04-26	2006-05-03	1	13271
60037	4092	1521369	1988-05-29	1991-05-14	3	7803
45321	3076	1177480	1993-05-23	1993-06-27	1	8578
52041	3543	920293	2018-09-13	2018-09-20	1	17794
39734	2702	1125315	1986-03-30	1986-04-06	1	5939
32594	2207	1713332	1982-01-14	1982-01-28	1	4410
51286	3494	1125315	1981-04-01	1981-04-15	1	4122
41047	2786	1728416	1947-01-26	1947-02-09	1	-8362
45453	3083	1125315	1979-06-29	1979-07-20	1	3487
16042	1108	1115008	2008-07-24	2008-08-14	1	14105
38560	2622	1102527	1998-10-03	1998-10-03	1	10502
61399	4191	1322184	2010-09-03	2010-09-03	1	14855
66871	4563	1503184	1978-12-04	1979-11-29	1	3619
645	40	1713332	1998-10-12	1998-10-26	1	10525
45068	3060	1119510	1987-03-09	1987-03-16	1	6283
45408	3081	1177480	2016-07-10	2016-07-31	1	17013
52754	3595	1728416	1951-08-02	1951-08-16	1	-6713
38419	2613	1125315	2001-01-27	2001-02-10	1	11363
37824	2570	1713332	1951-06-13	1951-06-27	1	-6763
45500	3087	1125315	1966-11-25	1966-12-02	1	-1126
16173	1117	1119510	1986-07-06	1986-07-20	1	6044
5957	408	1125315	2003-04-27	2003-05-04	1	12176
46217	3137	1118084	1945-04-23	1945-04-23	1	-9019
45598	3096	1125315	2011-01-14	2011-01-14	1	14988
12947	884	1125315	2017-06-16	2017-06-23	1	17340
41742	2830	1125315	1982-07-02	1982-07-09	1	4572
199	12	933724	2002-03-06	2002-03-13	1	11759
44638	3025	1125315	1992-08-31	1992-09-07	1	8285
41474	2813	1177480	2015-07-18	2015-09-16	1	16694
64601	4409	1125315	1976-12-27	1977-01-17	1	2573
41897	2839	1521369	1988-02-07	1989-02-01	1	6971
75974	5199	920293	2011-02-10	2011-02-17	1	15022
41589	2821	1112807	1923-07-24	1923-08-07	1	-16949
46141	3133	1717327	1964-03-28	1964-04-11	1	-2091
2442	161	1713332	2018-06-18	2018-07-09	1	17721
43854	2961	1118084	2007-11-01	2007-11-01	1	13818
41923	2841	1539403	1991-07-07	1991-07-07	1	7857
5918	406	1759842	1959-05-31	1959-06-07	1	-3861
40733	2767	1557272	1996-06-05	1996-06-05	1	9652
45003	3056	1125315	1981-02-20	1981-03-06	1	4082
2659	177	1717327	1969-12-04	1969-12-18	1	-14
77460	5295	1112807	1949-05-15	1949-05-29	1	-7522
1425	96	1124957	1942-02-26	1942-02-26	1	-10171
54630	3717	1129625	1977-02-15	1977-02-15	1	2602
42082	2853	1118084	1999-06-13	1999-06-13	1	10755
77050	5265	1115008	2008-03-12	2008-04-02	1	13971
70294	4801	1717327	1975-09-15	1975-09-29	1	2097
60038	4092	1119510	1987-09-24	1987-10-08	1	6489
45322	3076	1343916	1952-11-26	1952-11-26	1	-6245
52042	3543	933724	2013-08-09	2013-08-16	1	15933
39735	2702	1177480	1999-09-18	1999-10-09	1	10873
32595	2207	1713332	1992-02-14	1992-03-06	1	8100
51287	3494	1125315	2003-07-03	2003-07-17	1	12250
41048	2786	1759842	1962-06-21	1962-07-12	1	-2730
45454	3083	1125315	1997-02-15	1997-03-01	1	9921
16043	1108	1118084	2013-02-04	2013-02-04	1	15740
38561	2622	1115008	2018-05-21	2018-06-04	1	17686
61400	4191	1332418	2010-09-03	2010-09-03	1	14855
66872	4563	1713332	2019-03-14	2019-03-21	1	17976
646	40	738818	1985-05-29	1985-06-12	1	5641
45069	3060	1125315	1968-02-25	1968-03-03	1	-669
45409	3081	1322184	2011-09-07	2011-09-07	1	15224
52755	3595	1112807	1951-08-02	1951-08-16	1	-6713
38420	2613	1759842	1989-04-07	1989-04-28	1	7057
39471	2684	1125315	1977-02-09	1977-02-23	1	2610
45501	3087	1729720	1943-05-05	1943-05-16	1	-9727
16174	1117	1713332	2012-09-23	2012-10-07	1	15620
5958	408	1125315	2011-09-27	2011-10-04	1	15251
46218	3137	1124957	1933-06-10	1933-06-10	1	-13354
45599	3096	1503184	1977-12-18	1979-12-08	2	3628
12948	884	1503184	1991-09-03	1993-08-23	2	8635
41743	2830	1521369	1994-07-08	1995-07-03	1	9314
200	12	1112807	1986-11-16	1986-12-16	1	6193
44639	3025	1125315	2001-01-14	2001-01-21	1	11343
41475	2813	1326303	2013-10-18	2013-10-18	1	15996
64602	4409	1759842	1985-12-31	1986-01-14	1	5857
41898	2839	1118084	2006-08-06	2006-08-06	1	13366
75975	5199	1115008	2011-06-08	2011-09-06	1	15223
41590	2821	1112807	1937-07-02	1937-07-23	1	-11850
46142	3133	1728416	1961-09-14	1961-09-28	1	-3017
2443	161	1759842	2000-02-28	2000-03-06	1	11022
43855	2961	1713332	1990-10-28	1990-11-18	1	7626
43281	2927	1112807	1942-10-21	1942-11-04	1	-9920
5919	406	738818	2007-07-22	2007-08-05	1	13730
40734	2767	19059528	1939-05-24	1939-05-24	1	-11180
45004	3056	1149380	1960-01-04	1960-01-04	1	-3650
2660	177	1759842	1976-05-07	1976-05-14	1	2325
77461	5295	1112807	1958-10-03	1958-10-24	1	-4087
1426	96	1149380	1954-05-29	1954-05-29	1	-5696
54631	3717	705944	1983-05-07	1983-08-06	1	4965
42083	2853	1125315	1962-08-26	1962-09-25	1	-2655
77051	5265	1118084	2003-03-05	2003-03-05	1	12116
72627	4964	738818	1966-05-13	1966-05-27	1	-1315
60039	4092	1125315	1986-12-26	1987-01-25	2	6233
47565	3230	1112807	1961-08-22	1961-09-12	1	-3033
52043	3543	1112807	1961-04-30	1961-05-14	1	-3154
39736	2702	1125315	1978-01-28	1978-02-04	1	2956
32596	2207	738818	2010-02-08	2010-02-15	1	14655
51288	3494	1112807	1984-01-27	1984-02-10	1	5153
41049	2786	933724	1965-05-13	1965-05-20	1	-1687
45455	3083	1759842	1962-10-25	1962-11-01	1	-2618
16044	1108	1125315	1975-07-29	1975-08-26	1	2063
38562	2622	1729720	1945-06-15	1945-06-28	1	-8953
61401	4191	1361711	2010-09-03	2010-09-03	1	14855
66873	4563	1125315	1981-04-10	1981-07-09	1	4207
647	40	1125315	1972-02-28	1972-03-06	1	795
45070	3060	1713332	1964-08-20	1964-09-10	1	-1939
45410	3081	738818	1975-05-31	1975-06-14	1	1990
52756	3595	1118084	1993-10-20	1993-10-20	1	8693
38421	2613	1112807	1958-11-23	1958-12-07	1	-4043
39472	2684	1125315	1985-06-07	1985-06-21	1	5650
45502	3087	1112807	1941-02-13	1941-02-27	1	-10535
17366	1201	1118084	2007-10-23	2007-10-23	1	13809
5959	408	1759842	2013-11-06	2013-11-27	1	16036
46219	3137	1125315	1982-05-06	1982-06-03	1	4536
45600	3096	1713332	1987-10-12	1987-10-19	1	6500
12949	884	1515774	1993-08-23	1994-08-18	1	8995
41744	2830	1729720	1986-01-24	1986-01-31	1	5874
201	12	1125315	1986-10-23	1986-10-30	1	6146
44640	3025	1361711	1949-10-31	2002-10-14	1	11974
41476	2813	1713332	1939-10-11	1939-10-25	1	-11026
66880	4565	933724	1999-08-29	1999-09-05	1	10839
41899	2839	1125315	2017-08-14	2017-08-28	1	17406
75976	5199	1118084	2001-03-27	2001-03-27	1	11408
41591	2821	1112807	1961-01-18	1961-02-08	1	-3249
46143	3133	1124300	1989-06-03	1989-06-03	1	7093
2444	161	1759842	2012-02-11	2012-02-25	1	15395
43856	2961	1729720	1987-12-10	1987-12-18	1	6560
43282	2927	1125315	1950-05-06	1950-05-20	1	-7166
5920	406	1119510	2007-07-22	2007-08-05	1	13730
40735	2767	1125315	1947-03-31	1947-04-07	1	-8305
45005	3056	1713332	1966-12-12	1966-12-19	1	-1109
2661	177	1347450	2009-11-08	2009-11-08	1	14556
77462	5295	1177480	1977-12-13	1978-02-11	1	2963
1427	96	1174888	1997-01-25	1997-01-25	1	9886
54632	3717	1125315	1981-03-13	1981-03-27	1	4103
42084	2853	1125315	1982-07-03	1982-07-24	1	4587
77052	5265	1125315	2018-12-15	2018-12-29	1	17894
72628	4964	1118084	2000-05-23	2000-05-23	1	11100
60040	4092	1125315	1989-07-15	1989-07-29	1	7149
2306	154	1503184	1991-11-02	1992-10-27	1	8335
52044	3543	1361711	1992-09-29	1992-09-29	1	8307
39737	2702	1125315	1992-11-09	1992-11-23	1	8362
32597	2207	920293	2002-05-27	2002-06-03	1	11841
51289	3494	1149380	2001-05-03	2001-05-03	1	11445
41050	2786	1115008	2006-12-23	2007-01-06	1	13519
47385	3217	1119510	2006-06-09	2006-06-16	1	13315
16045	1108	1125315	2014-09-05	2014-09-19	1	16332
38563	2622	920293	1971-12-06	1971-12-13	1	711
61402	4191	1521369	1975-07-23	1977-07-12	2	2749
66874	4563	1713332	1972-08-21	1972-09-04	1	977
648	40	1125315	1985-05-29	1985-06-12	1	5641
45071	3060	738818	1925-06-24	1925-07-01	1	-16255
45411	3081	1125315	1975-05-31	1975-06-14	1	1990
52757	3595	1125315	1952-07-16	1952-07-30	1	-6364
38422	2613	1118084	1996-09-14	1996-09-14	1	9753
39473	2684	1503184	1975-02-09	1976-02-04	1	2225
45503	3087	1112807	1958-08-13	1958-09-03	1	-4138
17367	1201	1115008	2013-06-13	2013-06-27	1	15883
5960	408	920293	1985-07-05	1985-07-12	1	5671
46220	3137	920293	1939-05-11	1939-05-18	1	-11186
12950	884	1549786	1993-08-23	1994-08-18	1	8995
41745	2830	1119510	1992-06-18	1992-07-02	1	8218
202	12	1503184	1982-12-26	1983-12-21	1	5102
44641	3025	1539403	1991-02-25	1991-02-25	1	7725
41477	2813	1713332	1975-06-13	1975-07-04	1	2010
66881	4565	1119510	1972-02-18	1972-03-03	1	792
41900	2839	1177480	1984-06-17	1984-07-08	1	5302
75977	5199	1125315	1999-01-08	1999-01-22	1	10613
41592	2821	1112807	1962-01-04	1962-01-18	1	-2905
46144	3133	1112807	1961-09-14	1961-09-28	1	-3017
2445	161	1759842	2018-06-18	2018-07-09	1	17721
43857	2961	19127890	1986-09-17	1987-09-12	1	6463
43283	2927	1125315	1958-05-21	1958-06-04	1	-4229
5921	406	1125315	1966-02-06	1966-02-20	1	-1411
40736	2767	1125315	1957-11-11	1957-11-18	1	-4427
45006	3056	1728416	1962-11-16	1962-11-30	1	-2589
2662	177	1503184	1981-04-15	1982-04-10	1	4482
77463	5295	1759842	1993-05-20	1993-06-03	1	8554
1428	96	1545958	1997-01-25	1997-01-25	1	9886
54633	3717	1125315	2008-10-31	2008-11-28	1	14211
42085	2853	1125315	1988-06-02	1988-06-09	1	6734
77053	5265	1177480	1982-08-21	1982-09-25	1	4650
72629	4964	1124957	1978-06-13	1978-06-13	1	3085
60041	4092	1125315	2018-04-09	2018-04-16	1	17637
2307	154	1515774	1993-10-22	1994-10-17	1	9055
52045	3543	19127890	1977-06-24	1978-06-19	1	3091
39738	2702	1322184	1998-08-09	1998-08-09	1	10447
32598	2207	1125315	2010-02-08	2010-02-15	1	14655
51290	3494	1729720	1964-10-23	1964-11-01	1	-1887
41051	2786	1119510	1963-04-29	1963-05-13	1	-2425
47386	3217	738818	2006-06-09	2006-06-16	1	13315
16046	1108	738818	1981-02-19	1981-02-26	1	4074
38564	2622	1112807	1964-07-12	1964-08-02	1	-1978
61403	4191	1759842	1959-04-07	1959-05-19	1	-3880
66875	4563	1729720	1969-05-16	1969-05-26	1	-220
649	40	1125315	2002-03-21	2002-03-28	1	11774
45072	3060	1115008	2002-09-13	2002-09-27	1	11957
47133	3199	1112807	1975-08-19	1975-09-02	1	2070
52758	3595	1125315	1957-07-03	1957-07-10	1	-4558
38423	2613	1125315	1965-08-05	1965-08-12	1	-1603
39474	2684	1125315	1969-12-27	1970-01-17	1	16
45504	3087	1118084	1976-04-05	1976-04-05	1	2286
17368	1201	1125315	1987-06-26	1987-07-10	1	6399
5961	408	933724	1985-07-05	1985-07-12	1	5671
46221	3137	920293	1947-08-07	1947-08-14	1	-8176
12951	884	914335	2005-05-24	2005-05-24	1	12927
41746	2830	1129625	1975-06-22	1975-06-22	1	1998
203	12	1717327	1964-08-22	1964-09-05	1	-1944
44642	3025	1728416	1948-08-26	1948-09-09	1	-7784
41478	2813	1729720	1947-05-21	1947-06-03	1	-8248
66882	4565	1125315	1955-12-13	1955-12-27	1	-5119
41901	2839	1503184	1988-02-07	1989-02-01	1	6971
75978	5199	1177480	1975-01-20	1975-02-17	1	1873
41593	2821	1118084	1959-02-12	1959-02-12	1	-3976
46145	3133	1112807	1964-03-28	1964-04-11	1	-2091
2446	161	1177480	1990-07-20	1990-10-18	1	7595
44870	3047	738818	1990-03-26	1990-04-09	1	7403
43284	2927	1177480	2013-10-27	2013-11-10	1	16019
5922	406	1125315	2007-07-22	2007-08-05	1	13730
40737	2767	1125315	1961-08-01	1961-08-15	1	-3061
45007	3056	738818	1983-08-03	1983-08-17	1	4976
2663	177	1713332	1976-05-07	1976-05-14	1	2325
77464	5295	1112807	1910-05-27	1910-06-10	1	-21755
1429	96	1713332	1970-04-05	1970-04-26	1	115
54634	3717	1729720	1999-06-22	1999-07-02	1	10774
42086	2853	1125315	1995-03-24	1995-04-07	1	9227
77054	5265	1309944	2008-06-05	2008-06-05	1	14035
72630	4964	1125315	2015-09-27	2015-12-26	1	16795
60042	4092	1713332	1991-10-02	1991-10-16	1	7958
2308	154	1549786	1993-10-22	1994-10-17	1	9055
52046	3543	19127890	1980-06-08	1981-06-03	1	4171
39739	2702	1729720	2007-10-10	2007-10-20	1	13806
32599	2207	1515774	1996-04-14	1997-04-09	1	9960
51291	3494	705944	1970-08-03	1977-08-11	1	2779
41052	2786	1177480	2014-12-25	2015-01-15	1	16450
47387	3217	1115008	1998-05-08	1998-05-29	1	10375
16047	1108	920293	2011-10-07	2011-10-14	1	15261
38565	2622	1118084	1975-03-17	1975-03-17	1	1901
62614	4275	1125315	1988-03-02	1988-03-09	1	6642
66876	4563	19127890	1978-12-04	1979-11-29	1	3619
650	40	1125315	2018-06-14	2018-06-14	1	17696
45073	3060	1125315	2000-08-19	2000-09-02	1	11202
47134	3199	1119510	2009-12-28	2010-01-11	1	14620
52759	3595	1125315	1999-11-02	1999-11-16	1	10911
38424	2613	1125315	1990-11-19	1990-12-03	1	7641
39475	2684	1125315	2014-07-23	2014-08-06	1	16288
45505	3087	1125315	1955-12-07	1955-12-21	1	-5125
17369	1201	1713332	1994-05-21	1994-05-28	1	8913
5962	408	1125315	1994-06-16	1994-06-30	1	8946
46222	3137	933724	1947-08-07	1947-08-14	1	-8176
12952	884	975125	1987-05-30	1987-06-20	1	6379
41747	2830	1149380	2006-08-11	2006-08-11	1	13371
204	12	1112807	1988-01-10	1988-02-14	1	6618
44643	3025	1125315	1950-05-25	1950-06-08	1	-7147
41479	2813	738818	1980-06-14	1980-06-21	1	3824
66883	4565	1125315	1961-06-28	1961-07-19	2	-3088
41902	2839	1738521	1973-05-16	1973-05-30	1	1245
75979	5199	1521369	1981-12-12	1982-12-07	1	4723
41594	2821	1119510	1999-03-26	1999-04-02	1	10683
46146	3133	1125315	1962-09-20	1962-10-04	1	-2646
2447	161	1177480	2016-07-13	2016-09-11	1	17055
44871	3047	920293	2007-08-11	2007-08-18	1	13743
43285	2927	1112807	1957-02-18	1957-03-25	1	-4665
5923	406	1125315	2014-10-08	2014-10-22	1	16365
40738	2767	1125315	1973-02-23	1973-03-23	1	1177
45008	3056	1112807	1959-01-31	1959-02-14	1	-3974
2664	177	1729720	1969-03-13	1969-03-24	1	-283
77465	5295	1112807	1933-07-25	1933-08-15	1	-13288
1430	96	920293	1986-02-05	1986-02-12	1	5886
54635	3717	1124300	2014-01-19	2014-01-19	1	16089
42087	2853	1177480	1980-05-23	1980-06-13	1	3816
77055	5265	1343916	2008-06-05	2008-06-05	1	14035
72631	4964	1521369	1976-01-30	1978-01-19	2	2940
60043	4092	1738521	1976-11-18	1976-12-02	1	2527
2309	154	1589505	1995-10-12	1996-10-06	1	9775
52047	3543	1124957	1978-07-21	1978-07-21	1	3123
39740	2702	1729720	2014-08-17	2014-08-30	1	16312
32600	2207	1549786	1996-04-14	1997-04-09	1	9960
51292	3494	1177480	1991-02-03	1991-02-24	1	7724
41053	2786	1713332	1962-06-21	1962-07-12	1	-2730
47388	3217	1125315	1995-12-24	1995-12-31	1	9495
16048	1108	1125315	1978-06-14	1978-06-28	1	3100
38566	2622	1119510	1941-05-16	1941-05-30	1	-10443
62615	4275	1322184	1997-03-02	1997-03-02	1	9922
69280	4725	1129625	1976-10-13	1976-10-13	1	2477
651	40	1322184	2006-11-29	2006-11-29	1	13481
45074	3060	1322184	2003-01-25	2003-01-25	1	12077
47135	3199	1125315	1989-05-08	1989-05-15	1	7074
52760	3595	1177480	1987-07-29	1987-08-19	1	6439
38425	2613	1305058	2016-04-27	2016-04-27	1	16918
39476	2684	1521369	1975-02-09	1976-02-04	1	2225
45506	3087	1729720	2013-03-21	2013-04-03	1	15798
17370	1201	1759842	1994-05-21	1994-05-28	1	8913
5963	408	1125315	2013-01-05	2013-02-02	1	15738
46223	3137	1125315	1910-06-13	1910-06-27	1	-21738
12953	884	975125	2013-10-28	2013-11-11	1	16020
41748	2830	1515774	1990-07-29	1992-07-18	2	8234
205	12	1125315	1980-01-31	1980-02-21	1	3703
44644	3025	1125315	1953-10-15	1953-11-05	1	-5901
41480	2813	1112807	1961-09-26	1961-10-10	1	-3005
66884	4565	1125315	2011-11-04	2011-11-11	1	15289
41903	2839	1759842	2015-07-27	2015-08-17	1	16664
75980	5199	1521369	1984-11-26	1985-11-21	1	5803
41595	2821	1125315	1999-03-26	1999-04-02	1	10683
46147	3133	1125315	2011-01-24	2011-02-07	1	15012
3803	260	1102527	1990-08-17	1990-08-17	1	7533
44872	3047	933724	2007-08-11	2007-08-18	1	13743
43286	2927	1115008	2010-09-13	2010-12-12	1	14955
5924	406	1759842	1965-04-26	1965-05-10	1	-1697
40739	2767	1125315	2002-12-27	2003-01-10	1	12062
45009	3056	1125315	1983-08-03	1983-08-17	1	4976
2665	177	1115008	2007-09-15	2007-10-06	1	13792
77466	5295	1125315	1946-01-06	1946-01-13	1	-8754
1431	96	933724	1986-02-05	1986-02-12	1	5886
54636	3717	1125315	1992-10-11	1992-10-25	1	8333
42088	2853	1729720	1965-07-10	1965-07-23	1	-1623
77056	5265	914335	2008-06-05	2008-06-05	1	14035
72632	4964	1729720	1990-08-29	1990-09-11	1	7558
61126	4168	1125315	1973-12-18	1974-01-03	2	1463
2310	154	1177480	1979-05-29	1979-07-03	1	3470
52048	3543	1125315	1975-05-19	1975-06-02	1	1978
39741	2702	920293	1980-11-17	1980-11-24	1	3980
32601	2207	1759842	1992-02-14	1992-03-06	1	8100
51293	3494	1118084	1999-01-18	1999-01-18	1	10609
41054	2786	1728416	1957-03-05	1957-04-02	1	-4657
47389	3217	1125315	2006-06-09	2006-06-16	1	13315
16049	1108	1125315	1981-02-19	1981-02-26	1	4074
38567	2622	1119510	1991-08-04	1991-08-18	1	7899
62616	4275	1115008	1995-04-01	1995-04-23	1	9243
69281	4725	1177480	1975-08-19	1975-11-17	1	2146
652	40	1759842	1998-10-12	1998-10-26	1	10525
45075	3060	1347450	2003-01-25	2003-01-25	1	12077
47136	3199	738818	2009-12-28	2010-01-11	1	14620
52761	3595	1119510	1980-04-19	1980-05-03	1	3775
38426	2613	1713332	2016-05-13	2016-05-27	1	16948
39477	2684	920293	1995-03-09	1995-03-16	1	9205
45507	3087	1759842	1978-02-28	1978-03-14	1	2994
17371	1201	1115008	1995-11-01	1995-11-15	1	9449
5964	408	1177480	2014-12-24	2015-01-28	1	16463
46224	3137	1125315	1975-04-13	1975-05-13	1	1958
12954	884	1125315	2006-07-11	2006-07-25	1	13354
41749	2830	1713332	1996-08-12	1996-08-26	1	9734
206	12	1521369	1982-12-26	1983-12-21	1	5102
44645	3025	1125315	1996-05-16	1996-05-30	1	9646
41481	2813	1118084	1967-11-01	1967-11-01	1	-792
66885	4565	1728416	1961-06-28	1961-07-19	1	-3088
41904	2839	1778162	1987-08-16	1987-08-30	1	6450
75981	5199	723013	1976-10-12	1977-03-01	1	2616
41596	2821	1177480	2000-06-11	2000-07-02	1	11140
46148	3133	1713332	1973-06-22	1973-07-13	1	1289
3804	260	1125315	1979-09-06	1979-09-13	1	3542
44873	3047	1125315	1978-02-16	1978-03-02	1	2982
43287	2927	1119510	1990-12-31	1991-01-14	1	7683
5925	406	1125315	1987-06-15	1987-06-29	1	6388
40740	2767	1125315	2004-01-17	2004-01-31	1	12448
45010	3056	1729720	1964-02-22	1964-03-02	1	-2131
2666	177	19127890	1981-04-15	1982-04-10	1	4482
77467	5295	1729720	1917-01-01	1917-01-09	1	-19350
1432	96	1112807	1931-07-24	1931-08-23	1	-14011
54637	3717	1713332	2006-06-12	2006-06-26	1	13325
42089	2853	738818	1964-08-16	1964-08-30	1	-1950
77057	5265	1729720	1973-09-26	1973-10-07	1	1375
72633	4964	1125315	1966-05-13	1966-05-27	1	-1315
61127	4168	1713332	1981-07-03	1981-07-17	1	4215
2311	154	19127890	1991-11-02	1992-10-27	1	8335
52049	3543	1125315	1994-09-25	1994-10-30	1	9068
39742	2702	933724	1980-11-17	1980-11-24	1	3980
32602	2207	738818	1989-01-08	1989-01-22	1	6961
51294	3494	1137529	2001-05-03	2001-05-03	1	11445
41055	2786	715997	2003-09-07	2003-09-07	1	12302
47390	3217	1729720	1997-04-18	1997-04-27	1	9978
16050	1108	1729720	1979-07-11	1979-07-23	1	3490
38568	2622	738818	1941-05-16	1941-05-30	1	-10443
62617	4275	1124957	1992-05-17	1992-05-17	1	8172
69282	4725	1177480	1996-02-19	1996-03-18	1	9573
1378	94	1125315	1958-02-27	1958-03-13	1	-4312
45076	3060	1759842	1966-05-07	1966-05-21	1	-1321
47137	3199	1125315	1983-06-29	1983-07-13	1	4941
52762	3595	1125315	1973-03-31	1973-04-14	1	1199
38427	2613	1729720	1960-09-17	1960-09-24	1	-3386
39478	2684	933724	1995-03-09	1995-03-16	1	9205
47430	3221	705944	1970-05-30	1972-01-08	1	737
17372	1201	1119510	2005-12-13	2005-12-20	1	13137
5965	408	1503184	1978-05-19	1979-05-14	1	3420
46225	3137	1729720	1919-02-27	1919-03-10	1	-18560
12955	884	1125315	2007-02-25	2007-05-26	2	13659
41750	2830	1738521	1976-12-29	1977-01-12	1	2568
207	12	1713332	1997-01-16	1997-01-30	1	9891
44646	3025	1177480	1996-02-23	1996-03-15	1	9570
41482	2813	1125315	1980-06-14	1980-06-21	1	3824
66886	4565	1729720	1963-03-30	1963-04-07	1	-2461
41905	2839	1112807	1986-04-29	1986-06-28	1	6022
75982	5199	738818	1999-01-08	1999-01-22	1	10613
41597	2821	1112807	1977-11-25	1977-12-09	1	2899
46336	3147	1125315	2014-07-28	2014-08-18	1	16300
3805	260	1177480	1986-04-28	1986-06-02	1	5996
44874	3047	1125315	1990-03-26	1990-04-09	1	7403
43288	2927	1119510	2004-07-05	2004-07-19	1	12618
5926	406	1125315	2011-05-23	2011-05-30	1	15124
40741	2767	753626	1939-05-24	1939-05-24	1	-11180
45011	3056	1759842	1966-12-12	1966-12-19	1	-1109
3016	199	1112807	1942-04-27	1942-05-11	1	-10097
77468	5295	1729720	1985-08-06	1985-08-19	1	5709
1433	96	1124300	1963-04-02	1963-04-02	1	-2466
54638	3717	1759842	2006-06-12	2006-06-26	1	13325
42090	2853	1119510	1995-03-24	1995-04-07	1	9227
77058	5265	1738521	1971-02-06	1971-02-20	1	415
72634	4964	1125315	1973-11-23	1973-12-07	1	1436
61128	4168	1729720	1973-04-26	1973-05-08	1	1223
2312	154	19127890	1993-10-22	1994-10-17	1	9055
52050	3543	1521369	1977-06-24	1978-06-19	1	3091
39743	2702	1112807	1944-02-16	1944-03-01	1	-9437
32603	2207	933724	2002-05-27	2002-06-03	1	11841
51916	3536	920293	2010-01-13	2010-01-20	1	14629
41056	2786	738818	1963-04-29	1963-05-13	1	-2425
47391	3217	1124300	2018-10-14	2018-10-14	1	17818
17454	1208	1174888	1961-12-21	1961-12-21	1	-2933
38569	2622	933724	1971-12-06	1971-12-13	1	711
62618	4275	1361711	1994-02-13	1994-02-13	1	8809
69283	4725	1515774	1991-09-04	1992-08-29	1	8276
1379	94	1125315	1972-04-27	1972-05-11	1	861
45077	3060	1759842	2017-01-19	2017-01-26	1	17192
47138	3199	1125315	2009-12-28	2010-01-11	1	14620
52763	3595	1728416	1952-07-16	1952-07-30	1	-6364
38428	2613	1759842	2016-05-13	2016-05-27	1	16948
39479	2684	1112807	1962-08-06	1962-08-20	1	-2691
47431	3221	738818	2001-01-29	2001-02-05	1	11358
17373	1201	1738521	1977-04-11	1977-04-25	1	2671
5966	408	1503184	1981-05-03	1982-04-28	1	4500
46226	3137	1729720	1928-06-23	1928-07-03	1	-15157
12956	884	1125315	2008-03-21	2008-04-18	1	13987
41751	2830	1759842	1996-08-12	1996-08-26	1	9734
208	12	1738521	1967-10-23	1967-11-06	1	-787
44647	3025	1728416	1946-10-22	1946-11-05	1	-8458
41483	2813	1125315	2002-08-10	2002-08-24	1	11923
66887	4565	1759842	1976-05-04	1976-05-18	1	2329
41906	2839	1125315	1973-05-16	1973-05-30	1	1245
75983	5199	740275	1978-10-24	1979-01-30	1	3316
41598	2821	1115008	2005-05-07	2005-06-06	1	12940
46337	3147	1713332	1998-02-20	1998-02-27	1	10284
3806	260	1713332	1974-12-20	1975-01-10	1	1835
44875	3047	1177480	1989-04-28	1989-05-26	1	7085
43289	2927	1125315	1962-07-20	1962-07-27	1	-2715
5927	406	1713332	1965-04-26	1965-05-10	1	-1697
40742	2767	1102527	1971-04-05	1971-04-05	1	459
48025	3260	1112807	1968-11-05	1968-11-26	1	-401
3017	199	1119510	1951-01-12	1951-01-19	1	-6922
78159	5337	1125315	1981-07-24	1981-08-23	1	4252
1434	96	1125315	1942-02-26	1942-02-26	1	-10171
54639	3717	1768849	1981-03-13	1981-03-27	1	4103
42091	2853	1125315	1964-08-16	1964-08-30	1	-1950
77059	5265	1125315	1990-08-26	1990-09-09	1	7556
72635	4964	1125315	1978-06-13	1978-08-12	2	3145
61129	4168	1713332	1977-09-10	1977-09-17	1	2816
2313	154	1500211	1994-10-17	1995-10-12	1	9415
52051	3543	1521369	1980-06-08	1981-06-03	1	4171
39744	2702	1112807	1944-09-15	1944-09-29	1	-9225
32604	2207	1115008	2011-10-23	2011-11-20	1	15298
51917	3536	933724	2006-11-28	2006-12-12	1	13494
41057	2786	1112807	1926-03-13	1926-05-12	1	-15940
47392	3217	1125315	1993-08-13	1993-08-27	1	8639
17455	1208	1307863	1993-11-09	1993-11-09	1	8713
38570	2622	1112807	1931-10-04	1931-10-18	1	-13955
62619	4275	1125315	1993-03-27	1993-04-03	1	8493
69284	4725	1549786	1991-09-04	1992-08-29	1	8276
1380	94	1125315	1983-07-14	1983-07-14	1	4942
45078	3060	738818	1987-03-09	1987-03-16	1	6283
47139	3199	1118084	2009-06-11	2009-06-11	1	14406
57105	3892	1118084	2001-10-03	2001-10-03	1	11598
39345	2675	1713332	1999-10-12	1999-10-19	1	10883
39480	2684	1115008	1999-06-28	1999-07-26	1	10798
47432	3221	1119510	1977-04-16	1977-04-30	1	2676
17374	1201	738818	2005-12-13	2005-12-20	1	13137
5967	408	1713332	2013-11-06	2013-11-27	1	16036
46227	3137	1729720	1981-04-13	1981-04-21	1	4128
12957	884	1177480	1979-04-29	1979-05-13	1	3419
41752	2830	738818	1992-06-18	1992-07-02	1	8218
209	12	920293	2002-03-06	2002-03-13	1	11759
44648	3025	1728416	1950-05-25	1950-06-08	1	-7147
41484	2813	1307863	2013-10-18	2013-10-18	1	15996
66888	4565	1119510	1991-08-27	1991-09-03	1	7915
41907	2839	19127890	1988-02-07	1989-02-01	1	6971
75984	5199	933724	2011-02-10	2011-02-17	1	15022
41599	2821	1119510	1983-11-07	1983-11-14	1	5065
46338	3147	1759842	1973-02-02	1973-02-23	1	1149
3807	260	1717327	1969-10-10	1969-10-24	1	-69
44876	3047	19127890	1986-07-23	1987-07-18	1	6407
43290	2927	738818	2004-07-05	2004-07-19	1	12618
6932	480	738818	1975-09-23	1975-10-07	1	2105
40743	2767	1110410	1939-05-23	1939-05-24	1	-11180
48026	3260	1119510	1983-02-02	1983-02-09	1	4787
3018	199	1112807	1945-12-21	1946-01-04	1	-8763
78160	5337	1177480	2009-06-27	2009-07-25	1	14450
1435	96	1125315	1944-09-01	1944-09-15	1	-9239
54640	3717	1125315	1989-04-10	1989-04-17	1	7046
42092	2853	1713332	2009-03-06	2009-03-20	1	14323
77060	5265	1125315	2012-02-11	2012-03-03	1	15402
72636	4964	1503184	1976-01-30	1978-01-19	2	2940
61130	4168	1728416	1973-12-18	1974-01-01	1	1461
2314	154	1521369	1991-11-02	1992-10-27	1	8335
52052	3543	1118084	1993-10-24	1993-10-24	1	8697
39745	2702	1112807	1947-04-10	1947-04-24	1	-8288
32605	2207	1119510	2010-02-08	2010-02-15	1	14655
51918	3536	933724	2010-01-13	2010-01-20	1	14629
41058	2786	1118084	1959-10-11	1959-10-11	1	-3735
47393	3217	1125315	1992-01-19	1992-02-09	1	8074
17456	1208	1326303	1993-11-09	1993-11-09	1	8713
38571	2622	1115008	1998-10-03	1998-11-02	1	10532
62620	4275	1118084	2018-02-17	2018-02-17	1	17579
69285	4725	1717327	1977-03-11	1977-03-25	1	2640
1381	94	1125315	2015-11-30	2015-12-14	1	16783
45079	3060	1119510	1925-06-24	1925-07-01	1	-16255
47140	3199	1125315	2012-04-14	2012-04-21	1	15451
57106	3892	1125315	1970-12-15	1971-01-05	1	369
39346	2675	1717327	1963-02-18	1963-03-04	1	-2495
39481	2684	1115008	2014-04-08	2014-06-07	1	16228
47433	3221	1119510	2001-01-29	2001-02-05	1	11358
17375	1201	1125315	1976-01-24	1976-02-07	1	2228
5968	408	1729720	1964-08-22	1964-09-02	1	-1947
46228	3137	738818	1920-07-27	1920-08-03	1	-18048
12958	884	1177480	1989-06-08	1989-09-06	1	7188
41753	2830	1125315	1992-06-18	1992-07-02	1	8218
210	12	1112807	1967-10-23	1967-11-06	1	-787
45355	3079	1112807	1934-07-14	1934-07-28	1	-12941
41485	2813	1539403	2017-03-03	2017-03-03	1	17228
66889	4565	1125315	2012-10-23	2012-10-30	1	15643
43061	2913	1112807	1948-01-14	1948-02-13	1	-7993
75985	5199	1119510	1999-01-08	1999-01-22	1	10613
41600	2821	1125315	1936-11-05	1936-11-19	1	-12096
46339	3147	1759842	1998-02-20	1998-02-27	1	10284
3808	260	1112807	1971-06-02	1971-06-16	1	531
44877	3047	19127890	1988-07-12	1989-07-07	1	7127
43291	2927	1124300	1982-07-03	1982-07-03	1	4566
6933	480	738818	2010-05-02	2010-05-16	1	14745
40744	2767	1112807	1975-01-12	1975-02-18	1	1874
48027	3260	1125315	1983-09-09	1983-09-23	1	5013
3019	199	1119510	1954-01-27	1954-02-10	1	-5804
78161	5337	1112807	1973-10-04	1973-11-03	1	1402
1436	96	1125315	1962-05-22	1962-05-29	1	-2774
56166	3827	1118084	2001-08-29	2001-08-29	1	11563
42093	2853	1759842	2009-03-06	2009-03-20	1	14323
77061	5265	1112807	1970-12-08	1970-12-22	1	355
72637	4964	1729720	1970-04-20	1970-04-30	1	119
61131	4168	1759842	1981-07-03	1981-07-17	1	4215
2315	154	1759842	1977-09-11	1977-10-02	1	2831
52053	3543	1125315	1960-05-05	1960-05-19	1	-3514
39746	2702	1118084	1983-04-21	1983-04-21	1	4858
32606	2207	1124300	2013-05-06	2013-05-06	1	15831
51919	3536	1177480	2006-08-07	2006-08-28	1	13388
41059	2786	1125315	1963-04-29	1963-05-13	1	-2425
47394	3217	1125315	1999-07-28	1999-08-11	1	10814
17457	1208	1713332	1971-12-22	1971-12-29	1	727
38572	2622	1125315	1941-05-16	1941-05-30	1	-10443
62621	4275	1125315	1992-05-10	1992-06-16	2	8202
69286	4725	1125315	1977-03-11	1977-03-25	1	2640
1382	94	1174888	1983-07-14	1983-07-14	1	4942
45080	3060	1119510	1968-02-25	1968-03-03	1	-669
47141	3199	1713332	2017-10-18	2017-11-08	1	17478
57107	3892	1177480	2014-04-03	2014-04-17	1	16177
39347	2675	1125315	1964-09-10	1964-09-24	1	-1925
39482	2684	914335	1967-05-21	1967-05-21	1	-956
47434	3221	1125315	2001-01-29	2001-02-05	1	11358
17376	1201	1125315	1977-04-11	1977-04-25	1	2671
5969	408	1729720	2010-06-29	2010-07-11	1	14801
46229	3137	1112807	1912-03-02	1912-03-16	1	-21110
12959	884	1192710	1978-11-13	1978-11-13	1	3238
41754	2830	1154343	2006-08-11	2006-08-11	1	13371
211	12	1115008	1997-02-26	1997-03-19	1	9939
45356	3079	1125315	1957-05-16	1957-05-30	1	-4599
41486	2813	1713332	2011-05-18	2011-06-01	1	15126
66890	4565	1713332	1945-09-11	1945-09-25	1	-8864
43062	2913	1125315	1964-02-20	1964-02-27	1	-2135
75986	5199	1125315	1974-08-21	1974-09-04	1	1707
41601	2821	1125315	1960-12-14	1960-12-21	1	-3298
46340	3147	1125315	1988-11-29	1988-12-27	1	6935
3809	260	1118084	2010-03-19	2010-03-19	1	14687
44878	3047	738818	1993-09-28	1993-10-05	1	8678
43292	2927	1124957	1987-05-17	1987-05-17	1	6345
6934	480	1125315	1944-07-20	1944-07-27	1	-9289
40745	2767	1125315	1942-08-06	1942-08-20	1	-9996
48028	3260	1125315	1994-03-31	1994-04-14	1	8869
3020	199	1115008	2007-07-06	2007-08-05	1	13730
78162	5337	1129625	1974-03-14	1974-03-14	1	1533
1437	96	1125315	1997-01-25	1997-01-25	1	9886
56167	3827	1125315	1986-07-08	1986-07-22	1	6046
42094	2853	1119510	1964-08-16	1964-08-30	1	-1950
77062	5265	1713332	1991-11-27	1991-12-18	1	8021
72638	4964	1112807	1965-01-08	1965-01-22	1	-1805
61132	4168	1118084	2010-06-12	2010-06-12	1	14772
2316	154	1118084	2012-03-06	2012-03-06	1	15405
52054	3543	1322184	1998-07-21	1998-07-21	1	10428
39747	2702	1125315	2000-02-20	2000-02-27	1	11014
32607	2207	1125315	1989-01-08	1989-01-22	1	6961
51920	3536	1192710	1967-11-27	1967-11-27	1	-766
41060	2786	1713332	1927-06-19	1927-07-03	1	-15523
47395	3217	1729720	1993-07-27	1993-08-03	1	8615
17458	1208	1728416	1945-08-11	1945-08-25	1	-8895
38573	2622	1729720	1942-12-17	1942-12-27	1	-9867
62622	4275	1125315	2005-02-16	2005-03-02	1	12844
69287	4725	1125315	1979-07-29	1979-08-26	1	3524
1383	94	1713332	1989-10-13	1989-10-27	1	7239
45081	3060	1125315	1925-06-24	1925-07-01	1	-16255
47142	3199	1738521	1975-08-19	1975-09-02	1	2070
57108	3892	1177480	2013-02-23	2013-03-09	1	15773
39348	2675	1125315	1978-02-13	1978-02-13	1	2965
39483	2684	1118084	1995-09-27	1995-09-27	1	9400
47435	3221	1717327	1965-05-21	1965-06-04	1	-1672
17377	1201	1125315	1979-03-09	1979-03-30	1	3375
5970	408	1521369	1978-05-19	1979-05-14	1	3420
46230	3137	1119510	1920-07-27	1920-08-03	1	-18048
12960	884	1343916	2005-05-24	2005-05-24	1	12927
41755	2830	1503184	1994-07-08	1995-07-03	1	9314
212	12	1118084	2008-04-08	2008-04-08	1	13977
45357	3079	1125315	1971-03-02	1971-03-16	1	439
41487	2813	1759842	1975-06-13	1975-07-04	1	2010
66891	4565	1713332	2001-04-29	2001-05-20	1	11462
43063	2913	1177480	2002-05-14	2002-06-04	1	11842
75987	5199	1125315	1978-05-15	1978-05-22	1	3063
41602	2821	715997	2001-11-13	2001-11-13	1	11639
46341	3147	1149380	1973-02-12	1973-02-12	1	1138
3810	260	1738521	1971-03-15	1971-03-29	1	452
44879	3047	1125315	1993-09-28	1993-10-05	1	8678
43293	2927	1125315	1954-05-21	1954-06-04	1	-5690
6935	480	1125315	1954-02-10	1954-03-12	1	-5774
40746	2767	1125315	1971-04-05	1971-05-05	1	489
48029	3260	738818	1983-02-02	1983-02-09	1	4787
3021	199	1729720	1993-08-14	1993-08-24	1	8636
78163	5337	1177480	1974-12-15	1974-12-29	1	1823
1438	96	1137529	1954-05-29	1954-05-29	1	-5696
56168	3827	920293	1998-12-19	1998-12-26	1	10586
42095	2853	1713332	2008-06-18	2008-07-02	1	14062
77063	5265	1713332	2008-04-14	2008-05-05	1	14004
72639	4964	1119510	1966-05-13	1966-05-27	1	-1315
61133	4168	1713332	1998-08-31	1998-09-07	1	10476
2317	154	1125315	1985-03-29	1985-04-05	1	5573
52055	3543	1332418	1995-10-03	1995-10-03	1	9406
39748	2702	1728416	1946-10-18	1946-11-01	1	-8462
35083	2380	1112807	1952-12-26	1953-01-09	1	-6201
51921	3536	1521369	1979-10-24	1980-10-18	1	3943
41061	2786	1713332	2004-02-10	2004-02-24	1	12472
49811	3394	738818	1975-11-19	1975-11-26	1	2155
17459	1208	1112807	1945-08-11	1945-08-25	1	-8895
38574	2622	738818	1991-08-04	1991-08-18	1	7899
62623	4275	1332418	1994-02-13	1994-02-13	1	8809
69288	4725	19127890	1991-09-04	1992-08-29	1	8276
1384	94	1738521	1978-01-30	1978-02-13	1	2965
45082	3060	1125315	1987-03-09	1987-03-16	1	6283
47143	3199	1759842	2017-10-18	2017-11-08	1	17478
57109	3892	1125315	2019-02-02	2019-02-16	1	17943
39349	2675	1125315	1993-09-25	1993-10-02	1	8675
39484	2684	1125315	1991-04-25	1991-05-09	1	7798
47436	3221	1728416	1967-01-30	1967-02-13	1	-1053
17378	1201	1125315	2005-12-13	2005-12-20	1	13137
5971	408	1521369	1981-05-03	1982-04-28	1	4500
46231	3137	1125315	1919-01-12	1919-01-19	1	-18610
12961	884	19010482	2012-01-15	2012-02-05	1	15375
41756	2830	1551099	1985-11-12	1985-11-12	1	5794
213	12	1125315	1964-08-22	1964-09-05	1	-1944
45358	3079	1125315	2014-04-04	2014-05-09	2	16199
41488	2813	1759842	2011-05-18	2011-06-01	1	15126
66892	4565	1713332	2019-05-26	2019-06-02	1	18049
43064	2913	1713332	1949-05-16	1949-05-23	1	-7528
75988	5199	1521369	1976-01-13	1977-01-07	1	2563
41603	2821	1112807	1920-07-01	1920-07-15	1	-18067
46342	3147	1713332	1947-12-12	1947-12-19	1	-8049
3811	260	1738521	1974-03-05	1974-03-19	1	1538
44880	3047	1177480	2008-05-16	2008-05-30	1	14029
43294	2927	1125315	1987-05-17	1987-07-16	2	6405
6936	480	1125315	1975-09-23	1975-10-07	1	2105
40747	2767	1367571	1939-05-23	1939-05-23	1	-11181
48030	3260	1112807	1961-04-27	1961-05-18	1	-3150
3022	199	738818	1951-01-12	1951-01-19	1	-6922
78164	5337	1112807	1971-12-14	1971-12-28	1	726
1439	96	1361711	1984-02-18	1997-01-25	1	9886
56169	3827	1112807	1959-08-10	1959-09-14	1	-3762
42096	2853	1759842	1983-05-10	1983-05-31	1	4898
77064	5265	1759842	1991-11-27	1991-12-18	1	8021
72640	4964	1729720	2000-05-31	2000-06-12	1	11120
61134	4168	1759842	1977-09-10	1977-09-17	1	2816
2318	154	1125315	1990-01-14	1990-01-28	1	7332
52056	3543	1539403	1992-09-29	1992-09-29	1	8307
39749	2702	1112807	1943-05-31	1943-06-14	1	-9698
35084	2380	1125315	1950-08-25	1950-09-08	1	-7055
51922	3536	1729720	1974-06-24	1974-07-04	1	1645
41062	2786	1759842	1927-06-19	1927-07-03	1	-15523
49812	3394	1124300	1999-10-09	1999-10-09	1	10873
17460	1208	1759842	1971-12-22	1971-12-29	1	727
38575	2622	920293	1976-01-07	1976-01-14	1	2204
62624	4275	1539403	1994-02-13	1994-02-13	1	8809
69289	4725	920293	2000-10-20	2000-10-27	1	11257
1385	94	1778162	1983-07-14	1983-08-11	1	4970
45083	3060	1125315	1994-08-26	1994-09-25	1	9033
47144	3199	1125315	1980-08-22	1980-09-19	1	3914
57110	3892	1713332	2014-05-29	2014-06-05	1	16226
39350	2675	1125315	2005-12-29	2006-01-12	1	13160
39485	2684	1309944	1967-05-21	1967-05-21	1	-956
47437	3221	1112807	1965-05-21	1965-06-04	1	-1672
17379	1201	1717327	1976-01-24	1976-02-07	1	2228
5972	408	1551099	1962-02-03	1962-02-03	1	-2889
46232	3137	1125315	1920-07-27	1920-08-03	1	-18048
12962	884	975125	2012-01-15	2012-02-05	1	15375
41757	2830	1118084	2007-12-22	2007-12-22	1	13869
214	12	1125315	1974-08-01	1974-08-08	1	1680
45359	3079	1729720	1934-06-18	1934-06-30	1	-12969
41489	2813	1322184	2017-03-03	2017-03-03	1	17228
66893	4565	1759842	2001-04-29	2001-05-20	1	11462
42113	2857	1125315	1967-08-24	1967-09-07	1	-847
75989	5199	19127890	1987-11-11	1988-11-05	1	6883
41604	2821	1125315	1990-05-05	1990-06-04	1	7459
46343	3147	1112807	1949-10-27	1949-11-10	1	-7357
3812	260	1759842	1974-12-20	1975-01-10	1	1835
44881	3047	1503184	1986-07-23	1987-07-18	1	6407
43295	2927	1125315	1990-12-31	1991-01-14	1	7683
6937	480	1125315	2002-08-20	2002-09-03	1	11933
40748	2767	1746114	1939-05-24	1939-05-24	1	-11180
48031	3260	1112807	1962-01-22	1962-02-05	1	-2887
3023	199	738818	1954-01-27	1954-02-10	1	-5804
78165	5337	1118084	2010-09-30	2010-09-30	1	14882
1440	96	1539403	1991-03-30	1991-03-30	1	7758
56170	3827	1119510	1961-10-07	1961-10-14	1	-3001
42824	2899	1177480	1979-01-25	1979-02-24	1	3341
77065	5265	1759842	2008-04-14	2008-05-05	1	14004
72641	4964	19127890	1976-01-30	1978-01-19	2	2940
61135	4168	1759842	1998-08-31	1998-09-07	1	10476
2319	154	1125315	2017-07-15	2017-07-22	1	17369
52057	3543	1713332	2004-04-02	2004-04-23	1	12531
39750	2702	1112807	1946-10-18	1946-11-01	1	-8462
35085	2380	738818	2008-12-15	2008-12-29	1	14242
51923	3536	738818	1990-11-16	1990-11-30	1	7638
41063	2786	757627	2002-10-12	2002-10-12	1	11972
49813	3394	1125315	2016-02-17	2016-03-02	1	16862
17461	1208	1759842	1991-10-25	1991-11-01	1	7974
38576	2622	920293	1982-02-23	1982-03-09	2	4450
62625	4275	1729720	2008-07-29	2008-08-08	1	14099
69290	4725	933724	2000-10-20	2000-10-27	1	11257
1386	94	1112807	1954-05-17	1954-05-31	1	-5694
45084	3060	1713332	1966-05-07	1966-05-21	1	-1321
47145	3199	1713332	1983-06-29	1983-07-13	1	4941
57111	3892	1759842	2014-05-29	2014-06-05	1	16226
39351	2675	1713332	1963-12-24	1963-12-31	1	-2193
39486	2684	1343916	1967-05-21	1967-05-21	1	-956
47438	3221	1125315	1967-09-09	1967-09-23	1	-831
17699	1223	1118084	1989-10-20	1989-10-20	1	7232
10509	722	1729720	1980-05-30	1980-06-11	1	3814
46233	3137	1125315	1944-01-16	1944-01-23	1	-9475
12963	884	1115008	2011-12-29	2012-02-04	1	15374
41758	2830	1125315	1976-12-29	1977-01-12	1	2568
215	12	1125315	1974-10-08	1974-10-15	1	1748
45360	3079	1124957	2014-04-04	2014-04-04	1	16164
41490	2813	1332418	2017-03-03	2017-03-03	1	17228
66894	4565	1759842	2019-05-26	2019-06-02	1	18049
42114	2857	1125315	1984-11-27	1984-12-04	1	5451
77275	5283	1119510	1989-06-28	1989-07-12	1	7132
41605	2821	1729720	1927-03-14	1927-03-23	1	-15625
46344	3147	1112807	1962-09-03	1962-09-17	1	-2663
3813	260	1112807	1969-10-10	1969-10-24	1	-69
44882	3047	1503184	1988-07-12	1989-07-07	1	7127
43296	2927	1125315	2004-07-05	2004-07-19	1	12618
6938	480	1125315	2010-05-02	2010-05-16	1	14745
40749	2767	19002770	1939-05-24	1939-05-24	1	-11180
48032	3260	1124300	1998-06-07	1998-06-07	1	10384
3024	199	920293	2003-05-06	2003-05-13	1	12185
78166	5337	1125315	2014-08-31	2014-09-07	1	16320
1441	96	1713332	1971-09-23	1971-10-07	1	644
56171	3827	1125315	2015-08-24	2015-10-23	1	16731
42825	2899	1729720	1955-12-06	1955-12-15	1	-5131
1699	114	1177480	1988-08-14	1988-08-28	1	6814
72642	4964	1112807	1961-02-07	1961-02-28	1	-3229
62410	4260	757627	2018-10-30	2018-10-30	1	17834
2320	154	1713332	1977-09-11	1977-10-02	1	2831
52058	3543	1728416	1960-05-05	1960-05-19	1	-3514
39751	2702	1119510	1986-03-30	1986-04-06	1	5939
35086	2380	920293	1998-06-13	1998-06-20	1	10397
51924	3536	1125315	1990-11-16	1990-11-30	1	7638
41064	2786	920293	1965-05-13	1965-05-20	1	-1687
49814	3394	1322184	2010-08-21	2010-08-21	1	14842
17462	1208	1112807	1941-09-16	1941-10-07	1	-10313
38577	2622	933724	1976-01-07	1976-01-14	1	2204
64003	4374	738818	1980-09-15	1980-09-22	1	3917
69291	4725	1112807	1988-09-07	1988-09-28	1	6845
1387	94	1124300	1988-06-07	1988-06-07	1	6732
45741	3106	1119510	1973-12-23	1973-12-30	1	1459
47409	3219	1119510	2018-12-11	2018-12-18	1	17883
57283	3906	1112807	1947-01-28	1947-02-11	1	-8360
39352	2675	1717327	1966-01-22	1966-02-05	1	-1426
39487	2684	1728416	1962-08-06	1962-08-20	1	-2691
47439	3221	1125315	1977-02-07	1977-02-14	1	2601
17700	1223	1713332	2012-09-18	2012-10-09	1	15622
10510	722	1125315	1969-07-12	1969-07-19	1	-166
46234	3137	1125315	1961-02-11	1961-02-25	1	-3232
12964	884	1125315	1981-08-16	1981-10-22	1	4312
41759	2830	1125315	1987-10-03	1987-10-17	1	6498
216	12	1759842	1997-01-16	1997-01-30	1	9891
45361	3079	1177480	1975-08-22	1975-09-12	1	2080
41491	2813	1713332	1944-03-09	1944-03-30	1	-9408
66895	4565	738818	1972-02-18	1972-03-03	1	792
42115	2857	1729720	1979-01-15	1979-01-26	1	3312
77276	5283	1125315	1982-06-16	1982-06-23	1	4556
43982	2975	1112807	1965-05-22	1965-06-05	1	-1671
46345	3147	1112807	1964-08-09	1964-09-06	1	-1943
3814	260	1115008	2015-04-08	2015-07-07	1	16623
44883	3047	1713332	1985-06-14	1985-07-05	1	5664
43297	2927	738818	1990-12-31	1991-01-14	1	7683
6939	480	1361711	2016-10-05	2016-10-05	1	17079
40750	2767	19003953	1939-05-24	1939-05-24	1	-11180
48033	3260	1125315	1964-11-28	1964-12-26	1	-1832
3025	199	933724	2003-05-06	2003-05-13	1	12185
78167	5337	1717327	1971-12-14	1971-12-28	1	726
1442	96	1125315	1935-03-06	1935-03-13	1	-12713
56172	3827	1728416	1960-10-03	1960-10-17	1	-3363
42826	2899	1112807	1953-01-18	1953-02-01	1	-6178
1700	114	1503184	1988-02-28	1989-02-22	1	6992
72643	4964	1713332	2003-08-27	2003-09-17	1	12312
62411	4260	1118084	1979-11-11	1979-11-11	1	3601
3520	236	1112807	1956-06-10	1956-06-24	1	-4939
52059	3543	1759842	2004-04-02	2004-04-23	1	12531
39752	2702	1347450	1998-08-09	1998-08-09	1	10447
35087	2380	1119510	2008-12-15	2008-12-29	1	14242
51925	3536	1177480	1994-11-24	1994-12-08	1	9107
41065	2786	1112807	1939-07-17	1939-10-15	1	-11036
49815	3394	1503184	1985-08-30	1987-08-20	2	6440
17463	1208	1124300	1975-01-31	1975-01-31	1	1856
38578	2622	933724	1982-02-23	1982-03-09	1	4450
64004	4374	1125315	1978-08-27	1978-09-10	1	3174
69292	4725	1124300	2009-07-31	2009-07-31	1	14456
1388	94	1125315	1982-07-03	1982-07-10	1	4573
45742	3106	1119510	2012-12-28	2013-01-11	1	15716
47410	3219	1174888	1996-08-27	1996-08-27	1	9735
57284	3906	1119510	2001-10-20	2001-10-27	1	11622
42663	2892	738818	1975-06-18	1975-06-25	1	2001
39488	2684	19127890	1975-02-09	1976-02-04	1	2225
47440	3221	738818	1977-04-16	1977-04-30	1	2676
17701	1223	1729720	1975-12-07	1975-12-14	1	2173
10511	722	1713332	2000-08-16	2000-08-30	1	11199
46235	3137	1347450	1987-11-14	1987-11-14	1	6526
12965	884	1177480	1984-09-11	1984-10-02	1	5388
41760	2830	1549786	1990-07-29	1992-07-18	2	8234
217	12	19127890	1982-12-26	1983-12-21	1	5102
45362	3079	1713332	1937-04-05	1937-04-26	1	-11938
41492	2813	1717327	1961-09-26	1961-10-10	1	-3005
66896	4565	1112807	1962-07-14	1962-09-19	1	-2661
42116	2857	1125315	1979-12-02	1979-12-16	1	3636
77277	5283	1125315	1982-11-12	1982-12-17	1	4733
43983	2975	1118084	1997-09-16	1997-09-16	1	10120
46346	3147	1118084	1983-09-19	1983-09-19	1	5009
3815	260	1125315	1990-08-10	1990-09-16	1	7563
44884	3047	1713332	1985-09-09	1985-09-30	1	5751
43298	2927	1125315	1945-04-10	1945-04-24	1	-9018
6940	480	1557272	1998-03-18	1998-03-18	1	10303
40751	2767	708298	1939-05-24	1939-05-24	1	-11180
48034	3260	1125315	1983-02-02	1983-02-09	1	4787
3026	199	1112807	1965-01-26	1965-02-16	1	-1780
78168	5337	1738521	1974-12-15	1974-12-29	1	1823
1443	96	1125315	1940-05-16	1940-05-30	1	-10808
56173	3827	933724	1998-12-19	1998-12-26	1	10586
42827	2899	1118084	1990-09-04	1990-09-04	1	7551
1701	114	1713332	2012-01-23	2012-02-06	1	15376
72644	4964	1759842	2003-08-27	2003-09-17	1	12312
62412	4260	1713332	1973-10-28	1973-11-18	1	1417
3521	236	1125315	1983-12-29	1984-03-28	1	5200
54330	3697	1115008	2017-01-09	2017-02-13	1	17210
42160	2859	1112807	1943-10-08	1943-10-22	1	-9568
35088	2380	1125315	1950-06-28	1950-07-12	1	-7113
51926	3536	1503184	1979-10-24	1980-10-18	1	3943
41066	2786	1125315	1957-03-05	1957-03-05	1	-4685
49816	3394	1738521	1978-02-13	1978-02-27	1	2979
17464	1208	1125315	1961-12-21	1962-02-19	2	-2873
38579	2622	1125315	1991-08-04	1991-08-18	1	7899
64005	4374	1125315	2000-07-27	2000-08-10	1	11179
69810	4761	1115008	1998-01-01	1998-01-31	1	10257
1389	94	1347450	2005-01-28	2005-01-28	1	12811
45743	3106	1124300	1990-03-22	1990-03-22	1	7385
47411	3219	1713332	2003-02-09	2003-03-02	1	12113
57285	3906	1125315	1989-10-18	1989-10-25	1	7237
42664	2892	1115008	2002-09-11	2002-10-02	1	11962
39773	2704	933724	2004-09-14	2004-09-21	1	12682
47441	3221	1112807	1967-01-30	1967-02-13	1	-1053
17702	1223	1112807	1954-04-22	1954-05-20	1	-5705
10512	722	1125315	1975-08-19	1975-08-26	1	2063
46236	3137	1713332	1914-04-28	1914-05-05	1	-20330
12966	884	1177480	1991-08-27	1991-09-17	1	7929
41761	2830	1551099	1988-12-02	1988-12-02	1	6910
218	12	1112807	1970-08-27	1970-10-20	2	282
45363	3079	1115008	2003-07-17	2003-07-31	1	12264
41493	2813	1759842	1939-10-11	1939-10-25	1	-11026
66897	4565	1124300	1981-10-17	1981-10-17	1	4307
42117	2857	1125315	1989-07-27	1989-08-17	1	7168
77278	5283	1503184	1988-08-22	1989-08-17	1	7168
43984	2975	1125315	1997-08-06	1997-08-20	1	10093
46347	3147	1125315	1955-01-29	1955-04-29	1	-5361
3816	260	1125315	1971-03-15	1971-03-29	1	452
44885	3047	1717327	1975-02-11	1975-02-25	1	1881
43299	2927	1125315	1983-03-09	1983-06-07	1	4905
6941	480	1119510	2010-05-02	2010-05-16	1	14745
40752	2767	967823	1939-05-23	1939-05-24	1	-11180
48035	3260	1125315	1998-02-07	1998-02-21	1	10278
3027	199	1124300	1983-04-07	1983-04-07	1	4844
1444	96	1322184	1997-01-25	1997-01-25	1	9886
56174	3827	1112807	1960-10-03	1960-10-17	1	-3363
42828	2899	1119510	2017-08-27	2017-09-10	1	17419
1702	114	1729720	1974-12-31	1975-01-08	1	1833
73169	5000	757627	2016-08-16	2016-08-16	1	17029
62413	4260	1729720	1959-12-04	1959-12-11	1	-3674
3522	236	1521369	1984-12-14	1985-12-09	1	5821
54331	3697	1177480	2015-02-28	2015-03-21	1	16515
42161	2859	1112807	1945-01-15	1945-01-29	1	-9103
35089	2380	1125315	1961-04-30	1961-05-07	1	-3161
51927	3536	920293	2016-02-29	2016-03-07	1	16867
41067	2786	1125315	1987-11-05	1987-12-03	1	6545
49817	3394	1759842	2001-07-21	2001-08-04	1	11538
17465	1208	1310149	1993-11-09	1993-11-09	1	8713
38580	2622	1729720	1950-06-04	1950-06-12	1	-7143
64006	4374	1177480	1976-12-16	1976-12-30	1	2555
69811	4761	1118084	2018-12-12	2018-12-12	1	17877
1390	94	1729720	1955-10-12	1955-10-19	1	-5188
45744	3106	1125315	1951-07-05	1951-08-02	1	-6727
47412	3219	1759842	2003-02-09	2003-03-02	1	12113
57286	3906	1759842	1968-05-24	1968-06-14	1	-566
42665	2892	1125315	1974-01-22	1974-02-05	1	1496
39774	2704	1118084	2011-05-26	2011-05-26	1	15120
47442	3221	1124300	2000-06-11	2000-06-11	1	11119
17703	1223	1125315	1966-01-21	1966-01-28	1	-1434
10513	722	1125315	2011-11-28	2011-12-19	1	15327
46237	3137	1713332	1957-12-08	1957-12-29	1	-4386
12967	884	1521369	1991-09-03	1993-08-23	2	8635
41762	2830	19127890	1990-07-29	1992-07-18	2	8234
219	12	1713332	1996-03-24	1996-04-14	1	9600
45364	3079	1125315	1965-11-28	1965-12-12	1	-1481
42228	2862	1115008	2000-12-25	2001-01-22	1	11344
66898	4565	1125315	1972-02-18	1972-03-03	1	792
42118	2857	1125315	1965-11-02	1965-11-16	1	-1507
77279	5283	1125315	1984-09-07	1984-11-06	2	5423
43985	2975	1125315	2004-04-06	2004-04-13	1	12521
46348	3147	1125315	1992-02-24	1992-03-02	1	8096
3817	260	1125315	1974-03-05	1974-03-19	1	1538
44886	3047	1729720	1976-11-06	1976-11-16	1	2511
43608	2947	1174888	2000-07-07	2000-07-07	1	11145
6942	480	1125315	1941-11-25	1941-12-02	1	-10257
40753	2767	1741122	1939-05-24	1939-05-24	1	-11180
48036	3260	1125315	2013-06-08	2013-06-22	1	15878
3028	199	1125315	1951-01-12	1951-01-19	1	-6922
1445	96	1332418	1994-04-16	1994-04-16	1	8871
56175	3827	1112807	1960-11-27	1960-12-11	1	-3308
42829	2899	1125315	1950-03-23	1950-04-06	1	-7210
1703	114	1729720	1975-10-07	1975-10-18	1	2116
73170	5000	1125315	2011-03-06	2011-06-04	1	15129
62414	4260	1759842	2010-02-23	2010-03-02	1	14670
3523	236	1115008	2009-01-21	2009-02-11	1	14286
54332	3697	1728416	1957-01-21	1957-02-04	1	-4714
42162	2859	1713332	1982-07-04	1982-07-25	1	4588
35090	2380	1125315	1969-05-27	1969-06-10	1	-205
51928	3536	920293	2016-05-03	2016-05-17	2	16938
41068	2786	1125315	2002-03-19	2002-05-18	1	11825
49818	3394	1119510	2018-12-29	2019-01-05	1	17901
17466	1208	1713332	1991-10-25	1991-11-01	1	7974
40087	2724	1118084	1999-11-23	1999-11-23	1	10918
64007	4374	1192710	1979-06-10	1979-06-10	1	3447
69812	4761	1125315	1989-12-31	1990-01-14	1	7318
1391	94	1125315	1960-10-04	1960-10-18	1	-3362
45745	3106	1125315	2008-05-15	2008-05-22	1	14021
47413	3219	1118084	2018-04-24	2018-04-24	1	17645
57287	3906	1759842	2010-05-23	2010-05-30	1	14759
42666	2892	1177480	1990-12-22	1991-01-12	1	7681
39775	2704	1177480	1994-12-11	1994-12-25	1	9124
47443	3221	1125315	1974-09-01	1974-09-15	1	1718
17704	1223	1125315	1983-07-17	1983-09-15	1	5005
10514	722	1174888	1989-07-26	1989-07-26	1	7146
46238	3137	1759842	1914-04-28	1914-05-05	1	-20330
12968	884	1738521	1979-04-29	1979-05-13	1	3419
41763	2830	19127890	1994-07-08	1995-07-03	1	9314
220	12	1729720	1972-05-13	1972-05-22	1	872
45365	3079	1125315	1995-08-30	1995-09-13	1	9386
42229	2862	1713332	2010-05-16	2010-05-30	1	14759
66899	4565	1125315	2004-11-03	2004-11-17	1	12739
42119	2857	1125315	1969-08-02	1969-08-09	1	-145
77280	5283	1125315	2008-05-08	2008-05-15	1	14014
43986	2975	1713332	2018-07-16	2018-07-30	1	17742
46349	3147	1125315	2008-06-18	2008-07-02	1	14062
3818	260	1125315	1979-02-22	1979-03-08	1	3353
44887	3047	1738521	1978-02-16	1978-03-02	1	2982
43609	2947	1503184	1994-04-17	1995-04-12	1	9232
6943	480	1125315	1958-10-13	1958-10-20	1	-4091
41956	2844	738818	1964-11-11	1964-11-25	1	-1863
48037	3260	1713332	1977-09-16	1977-09-30	1	2829
3029	199	1125315	1954-01-27	1954-02-10	1	-5804
1446	96	1713332	1933-11-16	1933-12-07	1	-13174
56176	3827	1125315	1961-10-07	1961-10-14	1	-3001
42830	2899	1125315	1972-12-09	1972-12-16	1	1080
1704	114	920293	1999-04-04	1999-04-11	1	10692
73171	5000	701322	2017-11-09	2017-11-09	1	17479
62415	4260	738818	1968-12-19	1968-12-26	1	-371
3524	236	1118084	1990-10-28	1990-10-28	1	7605
54333	3697	1102527	2002-08-21	2002-08-21	1	11920
42163	2859	1713332	1995-02-20	1995-03-06	1	9195
35091	2380	1125315	2008-12-15	2008-12-29	1	14242
51929	3536	933724	2016-02-29	2016-03-07	1	16867
41069	2786	1125315	2003-11-17	2003-12-01	1	12387
49819	3394	1125315	1972-11-25	1972-12-02	1	1066
17467	1208	1729720	1945-05-02	1945-05-09	1	-9003
40088	2724	1174888	2011-07-10	2011-07-10	1	15165
64008	4374	1125315	1980-09-15	1980-09-22	1	3917
69813	4761	1102527	1998-01-01	1998-01-01	1	10227
1392	94	1125315	1994-10-24	1994-11-07	1	9076
45746	3106	738818	1973-12-23	1973-12-30	1	1459
47414	3219	1119510	1994-05-16	1994-05-30	1	8915
57288	3906	738818	2001-10-20	2001-10-27	1	11622
42667	2892	1729720	1981-05-24	1981-06-02	1	4170
39776	2704	920293	2004-09-14	2004-09-21	1	12682
47444	3221	1125315	1966-03-17	1966-04-16	1	-1356
17705	1223	1125315	1989-07-31	1989-08-07	1	7158
10515	722	1759842	2000-08-16	2000-08-30	1	11199
50766	3454	1112807	1983-09-11	1983-09-25	1	5015
15925	1102	1124957	2003-02-21	2003-02-21	1	12104
43410	2936	738818	1997-06-22	1997-06-29	1	10041
221	12	1729720	1995-10-22	1995-10-29	1	9432
45366	3079	1118084	1972-11-26	1972-11-26	1	1060
42230	2862	1759842	2012-11-21	2012-12-12	1	15686
66900	4565	1125315	2016-11-04	2017-02-02	1	17199
42120	2857	1125315	1987-07-08	1987-10-06	1	6487
77281	5283	1177480	1978-04-07	1978-04-21	1	3032
43987	2975	1717327	1965-05-22	1965-06-05	1	-1671
46350	3147	1137529	1973-02-12	1973-02-12	1	1138
3819	260	1192710	1972-08-01	1972-08-01	1	943
44888	3047	1119510	1990-03-26	1990-04-09	1	7403
43610	2947	1515774	2002-03-10	2003-03-05	1	12116
6944	480	1125315	1984-03-03	1984-03-17	1	5189
41957	2844	1118084	1992-01-17	1992-01-17	1	8051
48038	3260	1115008	1996-09-14	1996-10-05	1	9774
3030	199	1125315	2010-02-04	2010-02-18	1	14658
1447	96	1759842	1971-09-23	1971-10-07	1	644
56177	3827	1125315	1963-10-06	1963-10-20	1	-2265
42831	2899	1125315	2013-10-24	2013-11-07	1	16016
1705	114	933724	1999-04-04	1999-04-11	1	10692
73172	5000	715997	2017-11-09	2017-11-09	1	17479
62416	4260	1125315	1968-12-19	1968-12-26	1	-371
3525	236	1125315	1985-05-02	1985-05-09	1	5607
54334	3697	1118084	1993-06-06	1993-06-06	1	8557
42164	2859	1729720	1951-06-13	1951-06-25	1	-6765
35092	2380	1125315	2010-09-23	2010-09-30	1	14882
51930	3536	19127890	1979-10-24	1980-10-18	1	3943
41070	2786	1125315	2009-07-24	2009-08-23	1	14479
49820	3394	1125315	1975-11-19	1975-11-26	1	2155
17468	1208	1112807	1941-03-20	1941-04-03	1	-10500
40089	2724	1713332	1985-01-01	1985-01-15	1	5493
64009	4374	1125315	1989-06-07	1989-06-21	1	7111
69814	4761	1115008	2002-02-09	2002-02-23	1	11741
1393	94	1728416	1954-05-17	1954-05-31	1	-5694
45747	3106	1125315	1957-03-03	1957-03-31	1	-4659
47415	3219	1125315	1996-08-27	1996-09-26	2	9765
57289	3906	1124300	1984-04-28	1984-04-28	1	5231
42668	2892	1125315	1975-06-18	1975-06-25	1	2001
39777	2704	1115008	2018-12-19	2019-01-16	1	17912
47445	3221	1125315	1977-04-16	1977-04-30	1	2676
17706	1223	1307863	2012-05-11	2012-05-11	1	15471
10516	722	1124300	2010-04-17	2010-04-17	1	14716
50767	3454	1125315	1983-04-06	1983-04-20	1	4857
15926	1102	1125315	1970-10-06	1970-10-20	1	292
43411	2936	738818	1963-11-26	1963-12-10	1	-2214
222	12	1759842	1996-03-24	1996-04-14	1	9600
45367	3079	1177480	1979-05-24	1979-06-23	1	3460
42231	2862	738818	1972-05-03	1972-05-10	1	860
66901	4565	1125315	2018-11-24	2018-12-15	1	17880
42121	2857	1729720	1968-03-22	1968-03-30	1	-642
77282	5283	1549786	1989-08-17	1990-08-12	1	7528
43988	2975	738818	1973-09-09	1973-09-16	1	1354
46351	3147	1759842	1947-12-12	1947-12-19	1	-8049
5418	370	1125315	1970-03-15	1970-03-29	1	87
44889	3047	1119510	1993-09-28	1993-10-05	1	8678
43611	2947	1589505	2003-03-05	2004-02-28	1	12476
6945	480	1125315	1995-02-13	1995-02-27	1	9188
41958	2844	1124957	2019-04-25	2019-04-25	1	18011
48039	3260	1125315	1989-10-07	1989-10-21	1	7233
3031	199	1728416	1945-12-21	1946-01-04	1	-8763
1448	96	1768849	1979-07-12	1979-08-02	1	3500
56178	3827	738818	1961-10-07	1961-10-14	1	-3001
42832	2899	1728416	1950-03-23	1950-04-06	1	-7210
1706	114	1119510	2009-11-30	2009-12-07	1	14585
73173	5000	1102527	2011-03-06	2011-03-06	1	15039
62417	4260	1729720	1940-05-02	1940-05-15	1	-10823
3526	236	1503184	1984-12-14	1985-12-09	1	5821
54335	3697	1119510	1986-09-10	1986-09-17	1	6103
42165	2859	1729720	2005-04-08	2005-04-17	1	12890
35093	2380	1728416	1950-08-25	1950-09-08	1	-7055
51931	3536	738818	2005-12-09	2005-12-16	1	13133
41071	2786	1174888	1957-03-05	1957-03-05	1	-4685
49821	3394	1125315	1980-02-16	1980-05-16	1	3788
17469	1208	1713332	2006-01-20	2006-02-03	1	13182
40090	2724	1713332	2011-07-10	2011-07-24	1	15179
64010	4374	1713332	1989-06-07	1989-06-21	1	7111
69815	4761	1125315	1986-08-03	1986-08-17	1	6072
1394	94	1729720	1959-12-30	1960-01-10	1	-3644
45748	3106	1125315	1973-05-11	1973-05-25	1	1240
47416	3219	1729720	1983-05-04	1983-05-16	1	4883
57290	3906	1125315	2001-10-20	2001-10-27	1	11622
42669	2892	1177480	1974-09-19	1974-10-17	1	1750
39778	2704	1125315	2014-05-02	2014-05-09	1	16199
47446	3221	1177480	1992-07-12	1992-08-16	1	8263
17707	1223	1713332	2003-12-19	2004-01-02	1	12419
10517	722	1125315	1989-07-26	1989-08-25	2	7176
50768	3454	1125315	1998-02-27	1998-03-13	1	10298
15927	1102	1713332	1975-04-24	1975-05-01	1	1946
43412	2936	1119510	1997-06-22	1997-06-29	1	10041
3358	224	1112807	1944-11-01	1944-11-15	1	-9178
45368	3079	1713332	2014-04-04	2014-05-09	1	16199
42232	2862	1125315	1972-05-03	1972-05-10	1	860
66902	4565	1174888	1961-06-28	1961-06-28	1	-3109
42122	2857	1124300	2006-03-16	2006-03-16	1	13223
77283	5283	1713332	2005-05-26	2005-06-09	1	12943
43989	2975	738818	1997-08-06	1997-08-20	1	10093
46352	3147	1125315	1947-11-09	1947-11-23	1	-8075
5419	370	1125315	1994-01-27	1994-02-26	1	8822
44890	3047	1500211	1994-06-11	1995-06-06	1	9287
43612	2947	19127890	1989-05-13	1990-05-08	1	7432
6946	480	1125315	2010-09-15	2010-09-22	1	14874
41959	2844	1125315	1964-11-11	1964-11-25	1	-1863
48040	3260	1728416	1962-01-22	1962-02-05	1	-2887
4039	276	1124300	2013-01-16	2013-01-16	1	15721
2076	140	1124300	2003-11-14	2003-11-14	1	12370
56179	3827	1125315	1961-07-31	1961-08-07	1	-3069
42833	2899	1728416	1953-01-18	1953-02-01	1	-6178
1707	114	1125315	1977-06-15	1977-06-29	1	2736
73174	5000	1112807	1938-09-22	1938-10-06	1	-11410
62418	4260	1759842	1973-10-28	1973-11-18	1	1417
3527	236	1729720	1981-11-22	1981-12-04	1	4355
54336	3697	1119510	1987-04-16	1987-04-23	1	6321
42166	2859	1759842	1955-02-16	1955-03-09	1	-5412
35094	2380	1124300	1987-04-08	1987-04-08	1	6306
51932	3536	920293	2006-11-28	2006-12-12	2	13494
42280	2865	1125315	1974-01-20	1974-02-03	1	1494
49822	3394	1347450	2010-08-21	2010-08-21	1	14842
17470	1208	1759842	2006-01-20	2006-02-03	1	13182
40091	2724	1115008	2011-07-10	2011-07-24	1	15179
64011	4374	1713332	1993-09-12	1993-10-03	1	8676
69816	4761	1112807	1989-11-14	1989-12-14	1	7287
1395	94	1125315	1998-07-23	1998-08-27	1	10465
45749	3106	1125315	1973-12-23	1973-12-30	1	1459
47417	3219	738818	1994-05-16	1994-05-30	1	8915
57291	3906	1125315	2004-05-03	2004-06-07	1	12576
42670	2892	1713332	1986-06-21	1986-07-05	1	6029
41099	2790	1112807	1973-07-02	1973-08-01	1	1308
47447	3221	1729720	1970-02-26	1970-03-07	1	65
17708	1223	1713332	2010-11-24	2010-12-08	1	14951
10518	722	1713332	1990-05-25	1990-06-08	1	7463
50769	3454	1125315	2019-03-12	2019-04-16	1	18002
15928	1102	1125315	1998-07-26	1998-08-02	1	10440
43413	2936	1125315	1963-11-26	1963-12-10	1	-2214
3359	224	1119510	1985-12-28	1986-01-11	1	5854
45369	3079	1759842	1937-04-05	1937-04-26	1	-11938
42233	2862	1112807	1974-12-16	1975-01-20	1	1845
66903	4565	1759842	1945-09-11	1945-09-25	1	-8864
42123	2857	1125315	1980-10-12	1980-10-12	2	3996
77284	5283	1729720	1981-02-22	1981-03-05	1	4081
43990	2975	1115008	2011-01-19	2011-04-19	1	15083
46353	3147	1125315	1980-01-01	1980-01-15	1	3666
5420	370	1125315	2004-09-25	2004-10-02	1	12693
44891	3047	1759842	1985-06-14	1985-07-05	1	5664
43613	2947	19127890	2001-03-15	2003-03-05	2	12116
6947	480	1125315	2013-09-12	2013-09-19	1	15967
41960	2844	1125315	1978-08-03	1978-08-10	1	3143
48041	3260	1759842	1977-09-16	1977-09-30	1	2829
4040	276	1125315	1978-06-04	1978-07-04	1	3106
2077	140	1125315	1995-01-07	1995-01-28	1	9158
56180	3827	1125315	1967-08-03	1967-08-17	1	-868
42834	2899	738818	2017-08-27	2017-09-10	1	17419
1708	114	1347450	2004-11-22	2004-11-22	1	12744
73175	5000	1112807	1940-10-19	1940-11-02	1	-10652
62419	4260	1112807	1941-05-14	1941-05-28	1	-10445
3528	236	1125315	1987-03-13	1987-03-27	1	6294
54337	3697	1125315	2002-08-21	2002-10-20	1	11980
42167	2859	1759842	1982-07-04	1982-07-25	1	4588
35095	2380	1125315	1960-04-20	1960-05-04	1	-3529
51933	3536	933724	2016-05-03	2016-05-17	1	16938
42281	2865	1728416	1974-01-20	1974-02-03	1	1494
49823	3394	1521369	1985-08-30	1987-08-20	2	6440
19060	1309	708298	1994-03-22	1994-03-22	1	8846
40092	2724	1557272	2015-04-19	2015-04-19	1	16544
64012	4374	1713332	2015-03-24	2015-04-07	1	16532
69817	4761	1115008	2008-03-23	2008-04-13	1	13982
1396	94	1177480	1978-01-30	1978-02-13	1	2965
45750	3106	1728416	1952-01-01	1952-01-15	1	-6561
47418	3219	1125315	1990-08-24	1990-09-28	1	7575
57292	3906	1557272	2012-10-31	2012-10-31	1	15644
42671	2892	1759842	1986-06-21	1986-07-05	1	6029
41100	2790	1124957	1973-07-02	1973-07-02	1	1278
47448	3221	1729720	1986-03-01	1986-03-14	1	5916
17709	1223	1759842	2003-12-19	2004-01-02	1	12419
10519	722	1759842	1990-05-25	1990-06-08	1	7463
50770	3454	1778162	2019-03-12	2019-04-16	1	18002
15929	1102	1125315	2003-02-21	2003-02-21	1	12104
43414	2936	1125315	2008-02-26	2008-03-11	1	13949
3360	224	1125315	2008-02-27	2008-03-12	1	13950
42234	2862	1115008	1999-03-15	1999-04-06	1	10687
66904	4565	738818	1991-08-27	1991-09-03	1	7915
42124	2857	1174888	1980-10-12	1980-10-12	1	3937
77285	5283	1759842	2005-05-26	2005-06-09	1	12943
43991	2975	1125315	1973-09-09	1973-09-16	1	1354
46354	3147	1125315	1993-12-31	1994-01-14	1	8779
5421	370	1124300	2000-01-08	2000-01-08	1	10964
44892	3047	1759842	1985-09-09	1985-09-30	1	5751
43614	2947	1124300	2018-09-28	2018-09-28	1	17802
6948	480	1322184	2016-10-05	2016-10-05	1	17079
41961	2844	1713332	1959-12-08	1959-12-22	1	-3663
49209	3353	738818	1976-11-01	1976-11-08	1	2503
4041	276	1503184	1997-05-11	1998-05-06	1	10352
2078	140	1521369	1988-05-06	1989-05-01	1	7060
56181	3827	1177480	1977-10-09	1977-10-23	1	2852
42835	2899	1115008	2004-03-14	2004-04-04	1	12512
1709	114	1515774	1990-02-17	1991-02-12	1	7712
73176	5000	1125315	1979-01-28	1979-02-04	1	3321
62420	4260	1112807	1945-11-19	1945-12-10	1	-8788
3529	236	1125315	2000-06-16	2000-07-07	1	11145
54338	3697	1125315	2009-07-15	2009-07-29	1	14454
42168	2859	1759842	1995-02-20	1995-03-06	1	9195
35096	2380	1125315	2002-09-28	2002-10-12	1	11972
51934	3536	1118084	2000-01-17	2000-01-17	1	10973
42282	2865	1125315	2002-07-31	2002-08-07	1	11906
49824	3394	738818	2018-12-29	2019-01-05	1	17901
19061	1309	738818	1957-02-18	1957-03-04	1	-4686
40093	2724	1729720	1994-12-30	1995-01-07	1	9137
64013	4374	1717327	1978-08-27	1978-09-10	1	3174
69818	4761	1125315	2000-08-20	2000-08-27	1	11196
1397	94	1177480	1983-07-14	1983-08-11	1	4970
45751	3106	1759842	1968-04-28	1968-05-12	1	-599
47419	3219	1125315	1994-05-16	1994-05-30	1	8915
57293	3906	1713332	1968-05-24	1968-06-14	1	-566
42672	2892	1125315	1974-11-03	1974-11-17	1	1781
41101	2790	1125315	1984-12-01	1985-01-05	1	5483
49538	3376	1759842	1976-01-15	1976-01-22	1	2212
17710	1223	1102527	1983-07-17	1983-07-17	1	4945
12997	887	1125315	2007-06-12	2007-06-19	1	13683
50771	3454	1124957	1997-02-21	1997-02-21	1	9913
15930	1102	1129625	1970-02-13	1970-02-13	1	43
43415	2936	1729720	1967-03-09	1967-03-17	1	-1021
3361	224	1177480	2009-07-24	2009-08-23	1	14479
42235	2862	1118084	2006-04-03	2006-04-03	1	13241
66905	4565	920293	1999-08-29	1999-09-05	1	10839
44491	3013	738818	1982-05-15	1982-05-22	1	4524
77286	5283	738818	1989-06-28	1989-07-12	1	7132
43992	2975	1713332	1988-10-06	1988-10-13	1	6860
46355	3147	1713332	1973-02-02	1973-02-23	1	1149
5422	370	1125315	1979-08-09	1979-09-13	2	3542
44893	3047	1118084	2017-10-28	2017-10-28	1	17467
43615	2947	1125315	1987-08-13	1987-08-20	1	6440
6949	480	1332418	2016-10-05	2016-10-05	1	17079
41962	2844	1119510	1953-02-07	1953-02-21	1	-6158
49210	3353	738818	1978-08-02	1978-08-16	1	3149
4042	276	1515774	1994-05-21	1995-05-16	1	9266
2079	140	1729720	1972-08-22	1972-09-04	1	977
56182	3827	1177480	1998-07-19	1998-08-23	1	10461
42836	2899	1125315	1960-08-29	1960-09-12	1	-3398
1710	114	1521369	1988-02-28	1989-02-22	1	6992
73177	5000	1125315	1980-08-17	1980-09-14	1	3909
62421	4260	1125315	1976-12-15	1976-12-22	1	2547
3530	236	1728416	1956-06-10	1956-06-24	1	-4939
54339	3697	1713332	1960-11-17	1960-12-01	1	-3318
42169	2859	1125315	1955-12-25	1956-01-08	1	-5107
35097	2380	933724	1998-06-13	1998-06-20	1	10397
51935	3536	1119510	1990-11-16	1990-11-30	1	7638
42283	2865	1177480	2003-03-24	2003-04-07	1	12149
49825	3394	1125315	2018-12-29	2019-01-05	1	17901
19062	1309	967823	1994-03-21	1994-03-22	1	8846
40094	2724	920293	1989-06-29	1989-07-13	2	7133
64014	4374	1729720	1985-02-18	1985-02-27	1	5536
69819	4761	1125315	2014-06-19	2014-06-26	1	16247
1398	94	1322184	2005-01-28	2005-01-28	1	12811
45752	3106	738818	2012-12-28	2013-01-11	1	15716
47420	3219	1125315	1997-09-15	1997-09-29	1	10133
57294	3906	1728416	1947-01-28	1947-02-11	1	-8360
42673	2892	1125315	1978-06-10	1978-06-17	1	3089
41102	2790	1125315	1986-01-28	1986-02-04	1	5878
49539	3376	1112807	1982-10-21	1982-11-11	1	4697
17711	1223	1115008	1995-01-15	1995-02-05	1	9166
12998	887	1728416	1960-04-30	1960-05-14	1	-3519
50772	3454	1177480	2005-09-07	2005-09-21	1	13047
15931	1102	1713332	1981-09-04	1981-09-11	1	4271
43416	2936	1759842	1993-12-15	1994-01-05	1	8770
3362	224	1125315	1992-02-19	1992-03-11	1	8105
42236	2862	1125315	1994-03-16	1994-03-23	1	8847
66906	4565	1125315	1977-05-23	1977-05-30	1	2706
44492	3013	1112807	1962-03-13	1962-03-27	1	-2837
77287	5283	1115008	2013-12-04	2014-01-08	1	16078
43993	2975	1713332	2016-12-24	2017-01-14	1	17180
46356	3147	1717327	1962-09-03	1962-09-17	1	-2663
5423	370	1112807	1970-10-20	1970-11-10	1	313
44894	3047	1177480	1975-02-11	1975-02-25	1	1881
43616	2947	1125315	1998-09-09	1998-10-14	1	10513
6950	480	1729720	1980-02-29	1980-03-07	1	3718
41963	2844	1125315	1951-08-22	1951-08-29	1	-6700
49211	3353	1112807	1927-11-12	1927-11-26	1	-15377
4043	276	1515774	1998-05-06	1999-05-01	1	10712
2080	140	19127890	1988-05-06	1990-04-26	2	7420
57578	3926	738818	2005-01-23	2005-02-06	1	12820
42837	2899	1125315	2017-08-27	2017-09-10	1	17419
1711	114	738818	2009-11-30	2009-12-07	1	14585
73178	5000	1125315	1983-01-28	1983-02-11	1	4789
62422	4260	1713332	2010-02-23	2010-03-02	1	14670
3531	236	19127890	1984-12-14	1985-12-09	1	5821
54340	3697	738818	1986-09-10	1986-09-17	1	6103
42170	2859	1125315	1966-01-17	1966-01-31	1	-1431
35098	2380	1125315	1994-03-18	1994-03-25	1	8849
51936	3536	1119510	2005-12-09	2005-12-16	1	13133
42284	2865	1713332	2003-03-24	2003-04-07	1	12149
49826	3394	1177480	1978-02-13	1978-02-27	1	2979
19063	1309	1112807	1958-04-12	1958-06-12	1	-4221
40095	2724	1112807	1962-09-13	1962-10-04	1	-2646
64015	4374	1759842	1993-09-12	1993-10-03	1	8676
69820	4761	1150770	1984-05-25	1984-05-25	1	5258
1399	94	1759842	1989-10-13	1989-10-27	1	7239
45753	3106	1112807	1952-01-01	1952-01-15	1	-6561
47421	3219	1729720	1986-12-28	1987-01-10	1	6218
57295	3906	1729720	1982-04-01	1982-04-12	1	4484
42674	2892	1125315	1997-07-18	1997-08-01	1	10074
41103	2790	1729720	1982-11-18	1982-11-27	1	4713
49540	3376	1124300	1994-05-06	1994-05-06	1	8891
17712	1223	1119510	1982-08-20	1982-08-27	1	4621
12999	887	1729720	1969-07-25	1969-08-06	1	-148
50773	3454	1713332	1986-09-02	1986-09-16	1	6102
15932	1102	1759842	1975-04-24	1975-05-01	1	1946
43417	2936	1102527	1975-07-24	1975-07-24	1	2030
3363	224	1125315	1959-09-14	1959-10-19	1	-3727
42237	2862	1125315	2008-10-08	2008-10-15	1	14167
66907	4565	1125315	1991-08-27	1991-09-03	1	7915
44493	3013	1125315	1982-05-15	1982-05-22	1	4524
77288	5283	1118084	2011-02-08	2011-02-08	1	15013
43994	2975	1759842	1976-03-01	1976-03-08	1	2258
46357	3147	1729720	1948-07-05	1948-07-12	1	-7843
5424	370	1125315	2002-10-12	2002-11-02	1	11993
44895	3047	1521369	1986-07-23	1987-07-18	1	6407
43617	2947	1125315	2000-07-07	2000-07-07	1	11145
6951	480	975125	1971-05-19	1971-05-19	1	503
41964	2844	1125315	1959-09-19	1959-09-26	1	-3750
49212	3353	1112807	1937-11-19	1937-12-19	1	-11701
4044	276	1549786	1994-05-21	1995-05-16	1	9266
2081	140	1125315	2015-11-09	2015-11-23	1	16762
57579	3926	920293	1991-10-29	1991-11-12	2	7985
42838	2899	1557272	2009-10-22	2009-10-22	1	14539
1712	114	1125315	1973-04-07	1973-05-05	1	1220
73179	5000	1125315	2000-06-01	2000-07-01	1	11139
62423	4260	1119510	1968-12-19	1968-12-26	1	-371
3532	236	1125315	1951-09-18	1951-10-02	1	-6666
54341	3697	920293	1974-04-26	1974-05-03	1	1583
37002	2518	920293	1976-11-04	1976-11-11	1	2506
51937	3536	1125315	2005-12-09	2005-12-16	1	13133
42285	2865	1125315	1970-06-17	1970-07-01	1	181
49827	3394	1713332	1971-09-06	1971-09-13	1	620
19064	1309	1112807	1964-01-11	1964-01-25	1	-2168
40096	2724	1125315	1997-10-30	1997-11-20	1	10185
64016	4374	1759842	2015-03-24	2015-04-07	1	16532
69821	4761	1177480	1981-09-27	1981-10-11	1	4301
2967	196	1119510	1967-07-29	1967-08-05	1	-880
45754	3106	1125315	2012-12-28	2013-01-11	1	15716
47422	3219	738818	2018-12-11	2018-12-18	1	17883
57296	3906	1112807	1989-09-14	1989-10-19	1	7231
42675	2892	1713332	1985-04-21	1985-05-05	1	5603
41104	2790	19127890	1974-06-09	1976-05-29	2	2340
49541	3376	1125315	2017-10-08	2017-10-08	1	17447
17713	1223	1125315	2015-01-24	2015-02-07	1	16473
13000	887	1729720	2019-06-24	2019-06-24	1	18071
50774	3454	1115008	1997-02-21	1997-05-22	1	10003
15933	1102	1768849	1983-11-26	1983-12-10	1	5091
43418	2936	1118084	1999-10-16	1999-10-16	1	10880
3364	224	1125315	1969-11-25	1969-12-16	1	-16
42238	2862	1713332	2012-11-21	2012-12-12	1	15686
66908	4565	1125315	1993-08-25	1993-09-01	1	8644
44494	3013	1125315	2005-02-22	2005-03-08	1	12850
77289	5283	1124957	1984-09-07	1984-09-07	1	5363
43995	2975	1759842	1988-10-06	1988-10-13	1	6860
46358	3147	1729720	1953-06-20	1953-06-28	1	-6031
5425	370	1112807	1965-08-19	1965-09-02	1	-1582
44896	3047	1521369	1988-07-12	1989-07-07	1	7127
43618	2947	1500211	1999-03-26	2000-03-20	1	11036
6952	480	1112807	1943-10-15	1943-11-05	1	-9554
41965	2844	1759842	1959-12-08	1959-12-22	1	-3663
49213	3353	1112807	1954-03-16	1954-04-20	1	-5735
4045	276	1549786	1998-05-06	1999-05-01	1	10712
2082	140	1500211	1996-03-25	1997-03-20	1	9940
57580	3926	933724	1991-10-29	1991-11-12	1	7985
42839	2899	1112807	1967-08-21	1967-09-25	1	-829
1713	114	1125315	2009-11-30	2009-12-07	1	14585
73180	5000	1125315	2007-06-12	2007-06-26	1	13690
62424	4260	1713332	1984-09-26	1984-10-10	1	5396
3533	236	1125315	1952-01-28	1952-02-11	1	-6534
54342	3697	920293	1978-06-13	1978-06-27	2	3099
37003	2518	933724	1976-11-04	1976-11-11	1	2506
56059	3820	1124300	2005-07-23	2005-07-23	1	12987
42286	2865	1125315	1970-08-16	1970-09-20	1	262
49828	3394	19127890	1985-08-30	1987-08-20	2	6440
19065	1309	1119510	2017-06-23	2017-07-07	1	17354
40097	2724	1125315	2011-07-10	2011-07-10	1	15165
64017	4374	1118084	2013-01-31	2013-01-31	1	15736
69822	4761	1729720	1989-03-23	1989-04-03	1	7032
2968	196	1119510	2008-08-31	2008-09-14	1	14136
45755	3106	1713332	1968-04-28	1968-05-12	1	-599
47423	3219	1115008	2005-11-08	2006-02-06	1	13185
57297	3906	1125315	1978-03-13	1978-03-20	1	3000
42676	2892	1713332	2006-12-01	2006-12-22	1	13504
41105	2790	1112807	1966-07-11	1966-08-08	1	-1242
49542	3376	1713332	1976-01-15	1976-01-22	1	2212
17714	1223	1326303	2012-05-11	2012-05-11	1	15471
13001	887	1125315	1965-06-05	1965-06-12	1	-1664
50775	3454	1119510	1998-02-27	1998-03-13	1	10298
15934	1102	19127890	1984-01-05	1984-12-30	1	5477
43419	2936	1125315	1971-03-03	1971-03-10	1	433
3365	224	1125315	1985-12-28	1986-01-11	1	5854
42239	2862	1729720	1968-01-05	1968-01-16	1	-716
66909	4565	1713332	1976-05-04	1976-05-18	1	2329
44495	3013	1115008	2014-05-05	2014-08-03	1	16285
77290	5283	1125315	1975-08-21	1975-11-19	1	2148
43996	2975	1759842	2016-12-24	2017-01-14	1	17180
48921	3330	1125315	1975-04-30	1975-05-14	1	1959
5426	370	1125315	1967-12-07	1968-01-04	1	-728
48432	3293	1112807	1917-04-19	1917-05-03	1	-19236
43619	2947	1521369	1994-04-17	1995-04-12	1	9232
6953	480	1118084	1983-06-22	1983-06-22	1	4920
41966	2844	738818	1953-02-07	1953-02-21	1	-6158
49214	3353	1125315	1976-11-01	1976-11-08	1	2503
4046	276	1549786	2001-04-20	2002-04-15	1	11792
2083	140	1503184	1988-05-06	1989-05-01	1	7060
57581	3926	1124300	1988-01-07	1988-01-07	1	6580
42840	2899	1125315	1967-07-17	1967-07-31	1	-885
1714	114	1322184	2004-11-22	2004-11-22	1	12744
73181	5000	1759842	2013-06-03	2013-06-10	1	15866
62425	4260	1728416	1945-11-19	1945-12-10	1	-8788
3534	236	1125315	1952-09-25	1952-10-09	1	-6293
54343	3697	933724	1974-04-26	1974-05-03	1	1583
37004	2518	1102527	1997-10-09	1997-10-09	1	10143
56060	3820	1125315	1979-09-05	1979-09-19	1	3548
42287	2865	1125315	1971-02-26	1971-03-12	1	435
49829	3394	1112807	1971-02-03	1971-02-17	1	412
19066	1309	1124957	1994-03-22	1994-03-22	1	8846
40098	2724	1729720	1969-04-19	1969-04-29	1	-247
64018	4374	1119510	1980-09-15	1980-09-22	1	3917
69823	4761	1125315	1983-11-16	1984-02-14	1	5157
2969	196	1125315	1956-04-08	1956-04-22	1	-5002
48247	3278	1102527	1977-02-02	1977-02-02	1	2589
47424	3219	1125315	1985-05-24	1985-05-31	1	5629
57298	3906	1125315	1978-06-20	1978-07-04	1	3106
42677	2892	1728416	1974-11-03	1974-11-17	1	1781
41106	2790	1124300	1985-08-30	1985-08-30	1	5720
49543	3376	1124957	2017-10-08	2017-10-08	1	17447
17715	1223	1759842	2012-09-18	2012-10-09	1	15622
13002	887	1112807	1960-04-30	1960-05-14	1	-3519
50776	3454	1177480	1984-07-11	1984-07-25	1	5319
15935	1102	1115008	2003-02-14	2003-03-23	1	12134
43420	2936	1125315	1976-08-17	1976-09-07	1	2441
3366	224	1125315	1996-02-19	1996-03-04	1	9559
42240	2862	1759842	2010-05-16	2010-05-30	1	14759
67562	4613	1102527	1990-03-13	1990-03-13	1	7376
44496	3013	1125315	1962-09-17	1962-10-01	1	-2649
77291	5283	1125315	1989-06-28	1989-07-12	1	7132
43997	2975	1119510	1997-08-06	1997-08-20	1	10093
48922	3330	1177480	1975-06-29	1975-07-13	1	2019
5427	370	1125315	1971-10-06	1971-10-20	1	657
48433	3293	1112807	1944-02-27	1944-03-28	1	-9410
43620	2947	1177480	1991-03-28	1991-04-19	1	7778
6954	480	1125315	1961-06-17	1961-07-08	1	-3099
41967	2844	1125315	1953-02-07	1953-02-21	1	-6158
49215	3353	1125315	1978-08-02	1978-08-16	1	3149
4047	276	1589505	2005-04-06	2006-04-09	1	13247
2084	140	1515774	1997-03-20	1998-03-15	1	10300
57582	3926	1125315	1992-12-07	1992-12-14	1	8383
44417	3007	1118084	2007-08-28	2007-08-28	1	13753
1715	114	1549786	1990-02-17	1991-02-12	1	7712
73182	5000	1112807	1947-05-22	1947-06-12	1	-8239
62426	4260	1759842	1984-09-26	1984-10-10	1	5396
3535	236	1125315	1978-01-01	1978-01-08	1	2929
54344	3697	1125315	1960-07-05	1960-07-19	1	-3453
37005	2518	1125315	1993-05-25	1993-06-08	1	8559
56061	3820	1177480	2015-08-31	2015-09-28	1	16706
42288	2865	1118084	2003-03-11	2003-03-11	1	12122
49830	3394	1119510	1975-11-19	1975-11-26	1	2155
19067	1309	1125315	1957-02-18	1957-03-04	1	-4686
40099	2724	1729720	1974-11-17	1974-11-29	1	1793
64019	4374	1125315	1976-08-20	1976-09-03	1	2437
69824	4761	1713332	1981-09-27	1981-10-11	1	4301
2970	196	1521369	1981-08-05	1982-07-31	1	4594
48248	3278	1118084	1994-01-30	1994-01-30	1	8795
47425	3219	1125315	2018-12-11	2018-12-18	1	17883
57299	3906	1125315	1990-06-23	1990-07-07	1	7492
42678	2892	1729720	1979-05-12	1979-05-24	1	3430
41107	2790	1177480	1999-09-19	1999-10-03	1	10867
49544	3376	1125315	1961-11-11	1961-11-25	1	-2959
17716	1223	738818	1982-08-20	1982-08-27	1	4621
13003	887	1115008	2000-08-03	2000-09-07	1	11207
50777	3454	1713332	1984-07-11	1984-07-25	1	5319
15936	1102	1118084	2012-05-02	2012-05-02	1	15462
43421	2936	1177480	1975-07-24	1975-09-22	1	2090
3367	224	1177480	2010-06-19	2010-07-19	1	14809
42241	2862	1119510	1972-05-03	1972-05-10	1	860
67563	4613	1112807	1967-04-17	1967-05-22	1	-955
44497	3013	1521369	1974-07-04	1975-06-29	1	2005
77292	5283	1125315	1998-08-29	1998-09-12	1	10481
43998	2975	1125315	2000-01-19	2000-02-16	1	11003
48923	3330	1177480	2007-08-24	2007-09-14	1	13770
5428	370	1174888	1979-08-09	1979-08-09	1	3507
48434	3293	1115008	2000-10-17	2000-12-16	1	11307
43621	2947	1503184	1989-05-13	1990-05-08	1	7432
6955	480	1177480	1994-11-12	1994-11-26	1	9095
41968	2844	1125315	1986-09-07	1986-09-14	1	6100
49216	3353	1713332	1935-03-10	1935-03-17	1	-12709
4048	276	1125315	1983-04-11	1983-04-18	1	4855
2085	140	1521369	1993-04-10	1995-03-31	2	9220
57583	3926	1728416	1950-05-29	1950-06-12	1	-7143
44418	3007	1125315	1967-01-20	1967-02-03	1	-1063
1716	114	1738521	1977-06-15	1977-06-29	1	2736
73183	5000	1125315	1956-01-12	1956-01-26	1	-5089
63685	4353	1125315	1967-04-04	1967-04-18	1	-989
3536	236	1728416	1952-01-28	1952-02-11	1	-6534
54345	3697	1125315	1982-07-26	1982-08-09	1	4603
37006	2518	1177480	1997-10-09	1997-11-13	1	10178
56062	3820	1503184	1986-10-06	1989-09-20	3	7202
42289	2865	1729720	1969-01-25	1969-02-01	1	-334
49831	3394	1125315	2003-12-01	2003-12-08	1	12394
19068	1309	1125315	1970-08-25	1970-09-01	1	243
40100	2724	933724	1989-06-29	1989-07-13	1	7133
64020	4374	1125315	1986-03-29	1986-04-19	1	5952
69825	4761	1713332	2002-09-16	2002-10-14	1	11974
2971	196	738818	2008-08-31	2008-09-14	1	14136
48249	3278	1125315	1969-05-01	1969-07-30	1	-155
48549	3301	1125315	2016-12-30	2017-01-13	1	17179
57300	3906	1713332	1945-08-13	1945-08-27	1	-8893
42679	2892	1738521	1974-01-22	1974-02-05	1	1496
41108	2790	1759842	2013-04-22	2013-04-29	1	15824
49545	3376	1125315	1979-10-20	1979-10-27	1	3586
17717	1223	1125315	1982-08-20	1982-08-27	1	4621
13004	887	1125315	1967-10-21	1967-11-11	1	-782
50778	3454	738818	1998-02-27	1998-03-13	1	10298
15937	1102	1521369	1984-01-05	1984-12-30	1	5477
43422	2936	1713332	1988-01-23	1988-02-06	1	6610
3368	224	1501700	2016-09-24	2016-09-24	1	17068
42242	2862	1125315	2016-08-06	2016-08-13	1	17026
67564	4613	1521369	2006-01-11	2007-01-06	1	13519
44498	3013	1717327	1962-03-13	1962-03-27	1	-2837
77293	5283	1521369	1988-08-22	1989-08-17	1	7168
43999	2975	1125315	2008-05-24	2008-05-31	1	14030
48924	3330	1738521	1975-04-30	1975-05-14	1	1959
5429	370	1728416	1967-12-07	1968-01-04	1	-728
48435	3293	1125315	1990-12-25	1991-01-08	1	7677
43622	2947	1521369	2001-03-15	2002-03-10	1	11756
6956	480	1539403	2016-10-05	2016-10-05	1	17079
41969	2844	1125315	2019-04-25	2019-05-25	2	18041
49217	3353	1112807	1930-04-21	1930-05-05	1	-14486
4049	276	1125315	2011-08-10	2011-08-24	1	15210
2086	140	1549786	1989-05-01	1990-04-26	1	7420
57584	3926	1112807	1948-05-26	1948-06-09	1	-7876
44419	3007	1125315	1983-01-28	1983-02-04	1	4782
1717	114	1759842	2012-01-23	2012-02-06	1	15376
73184	5000	1759842	1950-12-06	1950-12-27	1	-6945
63686	4353	1125315	1972-11-03	1972-12-10	1	1074
6126	421	1112807	1972-03-10	1972-03-31	1	820
54346	3697	1125315	1986-09-10	1986-09-17	1	6103
37007	2518	1713332	1978-01-07	1978-01-14	1	2935
56063	3820	1549786	1990-09-15	1991-09-10	1	7922
42290	2865	1738521	1970-06-17	1970-07-01	1	181
49832	3394	1713332	2001-07-21	2001-08-04	1	11538
19069	1309	1125315	1993-09-11	1993-09-18	1	8661
38303	2603	1717327	1962-11-23	1962-12-07	1	-2582
64021	4374	1177480	2003-12-16	2004-01-06	1	12423
69826	4761	1759842	2002-09-16	2002-10-14	1	11974
2972	196	920293	1988-10-31	1988-11-07	1	6885
48250	3278	1177480	2011-02-25	2011-04-01	1	15065
48550	3301	1713332	2008-07-12	2008-08-02	1	14093
57301	3906	1759842	1978-05-31	1978-06-07	1	3079
42680	2892	1759842	1985-04-21	1985-05-05	1	5603
41109	2790	920293	1989-08-27	1989-09-03	1	7185
49546	3376	1112807	1964-03-29	1964-06-27	1	-2014
17718	1223	1125315	1989-05-23	1989-05-30	1	7089
13005	887	1125315	1982-04-15	1982-04-22	1	4494
50779	3454	1118084	2016-10-19	2016-10-19	1	17093
15938	1102	1759842	1981-09-04	1981-09-11	1	4271
43423	2936	1759842	1972-12-24	1973-01-14	1	1109
3369	224	738818	1985-12-28	1986-01-11	1	5854
42243	2862	1713332	1994-11-22	1994-11-29	1	9098
67565	4613	1521369	2008-01-01	2010-12-16	3	14959
44499	3013	1729720	1997-09-24	1997-10-03	1	10137
77294	5283	1728416	1978-04-07	1978-04-21	1	3032
44000	2975	1713332	1976-03-01	1976-03-08	1	2258
48925	3330	19127890	1990-09-18	1992-09-07	2	8285
5430	370	1738521	1970-03-15	1970-03-29	1	87
48436	3293	1177480	1996-11-07	1997-02-05	1	9897
43623	2947	19127890	1994-04-17	1995-04-12	1	9232
6957	480	1713332	1950-05-01	1950-05-15	1	-7171
41970	2844	1557272	2018-07-02	2018-07-02	1	17714
49218	3353	1112807	1943-10-19	1943-11-09	1	-9550
4050	276	19127890	1994-05-21	1995-05-16	1	9266
2087	140	1729720	1974-06-30	1974-07-08	1	1649
57585	3926	1112807	1950-05-29	1950-06-12	1	-7143
44420	3007	1125315	1999-06-20	1999-06-27	1	10769
1718	114	19127890	1990-02-17	1991-02-12	1	7712
73185	5000	1112807	1941-10-25	1941-11-08	1	-10281
63687	4353	1125315	1980-08-30	1980-09-29	1	3924
6127	421	1124300	2001-04-28	2001-04-28	1	11440
54347	3697	1759842	1960-11-17	1960-12-01	1	-3318
37008	2518	1729720	1993-12-21	1993-12-28	1	8762
56064	3820	1729720	1968-07-05	1968-07-12	1	-538
42291	2865	1738521	1971-02-26	1971-03-12	1	435
49833	3394	1717327	1971-02-03	1971-02-17	1	412
19070	1309	1154029	1994-03-22	1994-03-22	1	8846
38304	2603	1728416	1960-10-22	1960-11-05	1	-3344
64022	4374	1500211	1992-05-06	1993-05-01	1	8521
70953	4847	1125315	1953-09-28	1953-10-19	1	-5918
2973	196	933724	1988-10-31	1988-11-07	1	6885
48251	3278	1115008	2001-09-10	2001-09-24	1	11589
48551	3301	1713332	2011-09-03	2011-09-10	1	15227
57302	3906	1115008	2011-04-02	2011-06-01	1	15126
42681	2892	1759842	2006-12-01	2006-12-22	1	13504
41110	2790	933724	1989-08-27	1989-09-03	1	7185
49547	3376	1125315	1963-10-23	1963-11-06	1	-2248
17719	1223	1125315	2010-11-24	2010-12-08	1	14951
13006	887	1557272	2018-02-24	2018-02-24	1	17586
50780	3454	1125315	1995-10-02	1995-10-09	1	9412
15939	1102	738818	1998-07-26	1998-08-02	1	10440
43424	2936	1759842	1988-01-23	1988-02-06	1	6610
3370	224	740275	1955-11-22	1956-04-03	1	-5021
42244	2862	1729720	1967-10-28	1967-11-04	1	-789
67566	4613	1589505	1995-03-03	1996-02-26	1	9552
44500	3013	1102527	2014-05-05	2014-05-05	1	16195
77295	5283	1729720	1996-08-17	1996-08-29	1	9737
44001	2975	1759842	2018-07-16	2018-07-30	1	17742
48926	3330	19127890	1993-09-02	1995-08-23	2	9365
5431	370	1768849	1979-08-09	1979-09-13	1	3542
48437	3293	1322184	2006-11-25	2006-11-25	1	13477
43624	2947	1125315	1981-10-12	1981-11-15	1	4336
6958	480	1112807	1937-10-16	1937-10-30	1	-11751
41971	2844	1729720	1967-02-14	1967-02-27	1	-1039
49219	3353	1125315	1947-01-27	1947-02-03	1	-8368
4051	276	19127890	1997-05-11	1999-05-01	2	10712
2088	140	1112807	1970-05-31	1970-06-21	1	171
57586	3926	1112807	1957-05-09	1957-07-15	1	-4553
44421	3007	1125315	2006-09-18	2006-10-02	1	13423
1719	114	1118084	2017-04-16	2017-04-16	1	17272
73186	5000	1112807	1943-06-28	1943-07-12	1	-9670
63688	4353	1125315	1991-11-26	1991-12-03	1	8006
6128	421	1713332	2009-03-22	2009-04-12	1	14346
54348	3697	738818	1987-04-16	1987-04-23	1	6321
37009	2518	1125315	1961-01-11	1961-02-10	1	-3247
56065	3820	1729720	1968-11-10	1968-11-21	1	-406
44157	2987	738818	1995-07-16	1995-07-30	1	9341
49834	3394	1759842	1971-09-06	1971-09-13	1	620
19071	1309	1177480	2018-07-25	2018-08-08	1	17751
38305	2603	1759842	1961-05-29	1961-06-19	1	-3118
64023	4374	1738521	1976-12-16	1976-12-30	1	2555
70954	4847	1125315	1969-11-06	1969-11-27	1	-35
2974	196	1112807	1957-06-02	1957-08-01	1	-4536
48252	3278	1125315	1988-08-20	1988-09-03	1	6820
48552	3301	1759842	1983-12-02	1983-12-09	1	5090
57303	3906	1125315	1955-07-17	1955-07-24	1	-5275
42682	2892	1118084	2007-06-08	2007-06-08	1	13672
41111	2790	1125315	2009-04-13	2009-06-12	1	14407
49548	3376	1177480	2017-10-08	2017-11-07	1	17477
17720	1223	1310149	2012-05-11	2012-05-11	1	15471
13007	887	1124300	1991-06-27	1991-06-27	1	7847
50781	3454	1125315	1997-02-21	1997-02-21	1	9913
15940	1102	1119510	1998-07-26	1998-08-02	1	10440
43425	2936	1112807	1989-03-03	1989-05-09	1	7068
3371	224	1112807	1946-05-28	1946-06-11	1	-8605
42245	2862	1759842	1994-11-22	1994-11-29	1	9098
67567	4613	1729720	2005-10-07	2005-10-16	1	13072
44501	3013	1125315	1951-09-23	1951-10-07	1	-6661
77296	5283	19127890	1988-08-22	1990-08-12	2	7528
44002	2975	1119510	1973-09-09	1973-09-16	1	1354
48927	3330	1118084	2018-01-14	2018-01-14	1	17545
7081	488	1112807	1977-02-02	1977-04-03	1	2649
48438	3293	1759842	1941-11-24	1941-12-15	1	-10244
43625	2947	1503184	2001-03-15	2002-03-10	1	11756
6959	480	1119510	1975-09-23	1975-10-07	1	2105
41972	2844	1119510	1964-11-11	1964-11-25	1	-1863
49220	3353	1125315	1947-12-14	1947-12-28	1	-8040
4052	276	1515774	2001-04-20	2002-04-15	1	11792
2089	140	1125315	1992-03-25	1992-04-22	1	8147
57587	3926	1112807	1963-07-14	1963-07-28	1	-2349
44422	3007	1713332	1998-01-21	1998-01-28	1	10254
1720	114	1125315	1999-11-18	1999-12-02	1	10927
73187	5000	1118084	1973-12-02	1973-12-02	1	1431
63689	4353	1713332	2004-09-26	2004-10-17	1	12708
6129	421	1125315	1977-09-02	1977-09-02	1	2801
54349	3697	933724	1978-06-13	1978-06-27	1	3099
37010	2518	1125315	1973-06-07	1973-06-28	1	1274
56066	3820	1125315	1967-08-07	1967-08-21	1	-864
44158	2987	1102527	1989-01-28	1989-01-28	1	6967
52696	3592	738818	2007-04-01	2007-04-15	1	13618
19072	1309	1729720	1964-05-13	1964-05-21	1	-2051
38306	2603	1759842	1968-03-10	1968-03-31	1	-641
65090	4448	1124300	1995-01-20	1995-01-20	1	9150
70955	4847	1149380	1978-01-25	1978-01-25	1	2946
2975	196	1112807	1966-06-15	1966-08-14	1	-1236
48253	3278	1177480	2015-10-07	2015-10-21	1	16729
48553	3301	1759842	2006-05-10	2006-05-17	1	13285
57304	3906	1125315	1957-03-12	1957-03-19	1	-4671
42683	2892	1119510	1975-06-18	1975-06-25	1	2001
41112	2790	1503184	1974-06-09	1976-05-29	2	2340
54893	3734	1119510	1950-04-10	1950-04-24	1	-7192
17721	1223	1729720	1955-06-03	1955-06-16	1	-5313
13008	887	1125315	1974-10-05	1974-10-19	1	1752
50782	3454	1125315	2014-08-24	2014-08-31	1	16313
15941	1102	1125315	1983-11-26	1983-12-10	1	5091
43426	2936	1119510	1963-11-26	1963-12-10	1	-2214
3372	224	1124300	1977-02-21	1977-02-21	1	2608
42896	2904	1713332	1987-02-18	1987-03-11	1	6278
67568	4613	1759842	1995-07-12	1995-08-02	1	9344
44502	3013	1125315	1952-06-19	1952-07-03	1	-6391
77297	5283	1515774	1989-08-17	1990-08-12	1	7528
44003	2975	1125315	1965-11-18	1965-12-18	1	-1475
48928	3330	1503184	1990-09-18	1992-09-07	2	8285
7082	488	1115008	2001-10-24	2001-11-07	1	11633
48439	3293	738818	1912-08-14	1912-08-28	1	-20945
43626	2947	1521369	1989-05-13	1990-05-08	1	7432
6960	480	1125315	1960-07-08	1960-07-22	1	-3450
41973	2844	1125315	1960-10-31	1961-01-29	1	-3259
49221	3353	1125315	1962-04-23	1962-04-30	1	-2803
4053	276	1521369	1997-05-11	1998-05-06	1	10352
2090	140	1515774	1989-05-01	1990-04-26	1	7420
57588	3926	1119510	2005-01-23	2005-02-06	1	12820
44423	3007	1112807	1969-04-09	1969-05-14	1	-232
1721	114	1125315	2018-08-24	2018-09-07	1	17781
73188	5000	1125315	1953-04-08	1953-04-15	1	-6105
63690	4353	1102527	1980-08-30	1980-08-30	1	3894
6130	421	1717327	1966-07-11	1966-07-25	1	-1256
54350	3697	1112807	1955-02-01	1955-03-10	1	-5411
37011	2518	1125315	1983-08-05	1983-08-26	1	4985
56067	3820	1125315	1998-03-07	1998-03-21	1	10306
44159	2987	1125315	1995-07-16	1995-07-30	1	9341
52697	3592	1125315	2007-04-01	2007-04-15	1	13618
19073	1309	1741122	1994-03-22	1994-03-22	1	8846
41861	2836	738818	1994-12-19	1994-12-26	1	9125
65091	4448	1125315	1987-11-28	1987-12-12	1	6554
70956	4847	1322184	2013-03-27	2013-03-27	1	15791
2976	196	1125315	1957-10-17	1957-10-31	1	-4445
48254	3278	1177480	1977-02-02	1977-03-04	1	2619
48554	3301	1713332	1972-12-10	1972-12-24	1	1088
57305	3906	1713332	1978-05-31	1978-06-07	1	3079
42684	2892	1177480	2014-03-03	2014-03-17	1	16146
41113	2790	1521369	1974-06-09	1976-05-29	2	2340
54894	3734	1125315	1977-01-30	1977-03-01	1	2616
17722	1223	1729720	1959-12-23	1959-12-30	1	-3655
13009	887	1177480	1989-11-29	1990-02-27	1	7362
50783	3454	1177480	1986-09-02	1986-09-16	1	6102
15942	1102	1125315	2005-07-01	2005-07-08	1	12972
43427	2936	1125315	1997-06-22	1997-06-29	1	10041
3373	224	1729720	1959-07-04	1959-07-17	1	-3821
42897	2904	1738521	1973-03-05	1973-03-19	1	1173
67569	4613	19127890	1982-05-08	1983-05-03	1	4870
44503	3013	1125315	1963-12-24	1964-02-22	1	-2140
78084	5333	1728416	1950-12-25	1951-01-08	1	-6933
44004	2975	1125315	1984-11-03	1984-11-10	1	5427
48929	3330	1515774	1993-09-02	1995-08-23	2	9365
7083	488	1125315	1962-09-21	1962-09-28	1	-2652
48440	3293	1119510	1912-08-14	1912-08-28	1	-20945
43627	2947	1549786	2002-03-10	2003-03-05	1	12116
6961	480	1125315	1994-11-07	1994-11-14	1	9083
41974	2844	1125315	1967-05-24	1967-05-31	1	-946
49222	3353	1125315	1983-01-18	1983-02-22	1	4800
4054	276	1713332	2008-01-26	2008-02-16	1	13925
2091	140	19127890	1993-04-10	1995-03-31	2	9220
57589	3926	1125315	1962-09-11	1962-09-25	1	-2655
44424	3007	1174888	1979-07-21	1979-07-21	1	3488
1722	114	1308738	2006-03-05	2006-03-05	1	13212
73189	5000	1125315	1992-11-06	1992-11-13	1	8352
63691	4353	1713332	1978-12-07	1978-12-28	1	3283
6131	421	1759842	2009-03-22	2009-04-12	1	14346
54351	3697	1112807	1957-01-21	1957-02-04	1	-4714
37012	2518	1759842	1978-01-07	1978-01-14	1	2935
56068	3820	1125315	2002-12-25	2003-01-08	1	12060
44160	2987	1717327	1975-08-10	1975-08-24	1	2061
52698	3592	1713332	2005-11-08	2005-11-29	1	13116
19074	1309	1759842	1963-02-07	1963-02-21	1	-2506
41862	2836	920293	2007-09-28	2007-10-05	1	13791
65092	4448	1713332	2000-08-22	2000-09-05	1	11205
70957	4847	1332418	2013-03-27	2013-03-27	1	15791
2977	196	1125315	2008-08-31	2008-09-14	1	14136
48255	3278	1713332	2001-09-10	2001-09-24	1	11589
48555	3301	1112807	1938-10-02	1938-10-16	1	-11400
57306	3906	1713332	2010-05-23	2010-05-30	1	14759
44007	2976	723013	1955-12-01	1956-07-19	1	-4914
41114	2790	1729720	1967-08-28	1967-09-06	1	-848
54895	3734	1738521	1978-03-26	1978-04-09	1	3020
20197	1378	975125	1974-06-26	1974-06-26	1	1637
13010	887	1177480	2002-07-29	2002-08-19	1	11918
50784	3454	1713332	1983-04-06	1983-04-20	1	4857
15943	1102	1125315	2013-10-26	2013-11-09	1	16018
43428	2936	1713332	1972-12-24	1973-01-14	1	1109
4465	307	1177480	1991-06-20	1991-07-25	1	7875
42898	2904	1738521	1973-07-24	1973-08-07	1	1314
67570	4613	1112807	1971-08-08	1971-08-22	1	598
44504	3013	1717327	1962-09-17	1962-10-01	1	-2649
78085	5333	1112807	1962-12-22	1963-02-20	1	-2507
963	65	1713332	1991-07-03	1991-07-10	1	7860
48930	3330	1521369	1987-10-04	1989-09-23	2	7205
7084	488	1125315	1977-02-02	1977-02-02	1	2589
48441	3293	1125315	1912-08-14	1912-08-28	1	-20945
43628	2947	1713332	1983-07-13	1983-07-20	1	4948
6962	480	1125315	1995-11-21	1995-12-05	1	9469
49223	3353	1125315	1991-05-02	1991-06-06	1	7826
4055	276	1759842	2008-01-26	2008-02-16	1	13925
2092	140	1125315	1976-05-20	1976-06-17	1	2359
57590	3926	1125315	2005-01-23	2005-02-06	1	12820
44425	3007	1738521	1967-01-20	1967-02-03	1	-1063
1723	114	1729720	1976-01-17	1976-01-28	1	2218
73190	5000	1713332	1950-12-06	1950-12-27	1	-6945
63692	4353	1729720	1990-05-20	1990-05-28	1	7452
6132	421	1112807	1977-09-02	1977-10-02	1	2831
54352	3697	1125315	1987-04-16	1987-04-23	1	6321
37013	2518	1759842	1999-09-03	1999-09-10	1	10844
56069	3820	1728416	1967-08-07	1967-08-21	1	-864
44161	2987	1729720	1983-02-24	1983-03-05	1	4811
52699	3592	1759842	1965-10-30	1965-11-06	1	-1517
19075	1309	1000560	1994-03-21	1994-03-22	2	8845
41863	2836	920293	2011-01-05	2011-01-12	1	14986
65093	4448	1759842	2000-08-22	2000-09-05	1	11205
70958	4847	1539403	2013-03-27	2013-03-27	1	15791
2978	196	1503184	1981-08-05	1982-07-31	1	4594
48256	3278	1112807	1970-07-25	1970-08-08	1	219
48556	3301	1112807	1948-06-11	1948-07-11	1	-7844
57307	3906	1759842	1945-08-13	1945-08-27	1	-8893
44008	2976	1112807	1958-01-08	1958-01-22	1	-4362
41115	2790	1125315	1973-07-02	1973-07-02	1	1278
54896	3734	1759842	1991-12-14	1992-01-04	1	8038
20198	1378	1713332	1962-06-11	1962-06-25	1	-2747
13011	887	1729720	1971-10-27	1971-11-05	1	673
50785	3454	1713332	1983-09-11	1983-09-25	1	5015
15944	1102	1503184	1984-01-05	1984-12-30	1	5477
43429	2936	1713332	1993-12-15	1994-01-05	1	8770
4466	307	1768849	1979-10-27	1979-11-10	1	3600
42899	2904	1124300	2007-03-27	2007-03-27	1	13599
67571	4613	1500211	1993-03-13	1994-03-08	1	8832
44505	3013	19127890	1974-07-04	1975-06-29	1	2005
78086	5333	1124300	1986-08-13	1986-08-13	1	6068
964	65	1713332	1998-03-29	1998-04-05	1	10321
48931	3330	1549786	1993-09-02	1995-08-23	2	9365
7085	488	1713332	1965-05-14	1965-05-28	1	-1679
48442	3293	1125315	1996-11-07	1996-11-07	1	9807
43629	2947	1759842	1983-07-13	1983-07-20	1	4948
6963	480	1125315	2004-04-11	2004-04-25	1	12533
49224	3353	1125315	2012-06-20	2012-06-27	1	15518
4056	276	19127890	2001-04-20	2002-04-15	1	11792
2093	140	1125315	1986-12-05	1986-12-19	1	6196
57591	3926	1728416	1948-05-26	1948-06-09	1	-7876
44426	3007	1125315	1979-07-21	1979-07-21	1	3488
1724	114	19127890	1988-02-28	1989-02-22	1	6992
73191	5000	1713332	2013-06-03	2013-06-10	1	15866
63693	4353	19127890	1988-06-22	1990-06-12	2	7467
6133	421	1124957	1977-09-02	1977-09-02	1	2801
54353	3697	1125315	1988-10-12	1988-11-02	1	6880
37014	2518	920293	1973-10-01	1973-10-08	1	1376
56070	3820	19127890	1986-10-06	1989-09-20	3	7202
44162	2987	1125315	1979-05-21	1979-08-19	1	3517
52700	3592	1759842	2005-11-08	2005-11-29	1	13116
19076	1309	1118084	1995-03-09	1995-03-09	1	9198
41864	2836	933724	2008-11-08	2008-11-22	1	14205
65094	4448	1125315	1962-04-05	1962-04-12	1	-2821
70959	4847	1713332	1963-05-17	1963-05-24	1	-2414
2979	196	1713332	2008-09-28	2008-10-12	1	14164
48257	3278	1177480	1986-11-12	1986-12-03	1	6180
48557	3301	1115008	2011-05-31	2011-07-30	1	15185
58890	4014	1112807	1983-10-14	1983-10-28	1	5048
44009	2976	1125315	2013-07-04	2013-07-11	1	15897
41116	2790	1557272	2013-04-11	2013-04-11	1	15806
54897	3734	1174888	1966-02-27	1966-02-27	1	-1404
20199	1378	1728416	1949-09-22	1949-10-06	1	-7392
13012	887	1729720	1992-10-17	1992-10-25	1	8333
52214	3556	1125315	2000-08-22	2000-08-29	1	11198
15945	1102	1713332	1997-01-21	1997-02-04	1	9896
47819	3246	1125315	2013-07-03	2013-07-10	1	15896
4467	307	1177480	1994-08-08	1994-10-07	1	9045
42900	2904	1729720	2006-05-12	2006-05-24	1	13292
67572	4613	1503184	1982-05-08	1983-05-03	1	4870
44506	3013	1112807	1960-01-23	1960-02-13	1	-3610
78087	5333	1125315	1960-03-09	1960-03-23	1	-3571
965	65	920293	2016-05-02	2016-05-16	2	16937
48932	3330	1549786	1996-08-17	1998-08-07	2	10445
7086	488	1713332	1990-10-23	1990-11-20	1	7628
48443	3293	1125315	2005-06-23	2005-07-23	1	12987
6964	480	1729720	1939-11-08	1939-11-17	1	-11003
49225	3353	1112807	1948-05-16	1948-06-15	1	-7870
4057	276	1125315	1983-08-18	1983-08-25	1	4984
2094	140	1503184	1993-04-10	1995-03-31	2	9220
57592	3926	1729720	1952-07-07	1952-07-16	1	-6378
44427	3007	1177480	1979-07-21	1979-09-19	1	3548
2357	158	1112807	1948-10-25	1949-01-23	1	-7648
74783	5118	738818	2013-08-18	2013-09-01	1	15949
63694	4353	1118084	2008-01-09	2008-01-09	1	13887
6134	421	1125315	1966-07-11	1966-07-25	1	-1256
54354	3697	1713332	1981-10-23	1981-12-11	1	4362
37015	2518	1125315	1993-08-09	1993-08-16	1	8628
56071	3820	19127890	1990-09-15	1991-09-10	1	7922
44163	2987	1125315	1989-01-28	1989-02-27	1	6997
52701	3592	920293	2016-02-18	2016-02-25	1	16856
19077	1309	1125315	1984-04-25	1984-05-10	1	5243
41865	2836	933724	2011-01-05	2011-01-12	1	14986
65095	4448	1125315	1978-05-09	1978-06-06	1	3078
70960	4847	1713332	2005-03-26	2005-04-02	1	12875
2980	196	1728416	1957-10-17	1957-10-31	1	-4445
50412	3435	738818	1989-08-23	1989-09-06	1	7188
48558	3301	1125315	1975-11-19	1975-11-26	1	2155
58891	4014	1118084	2006-10-02	2006-10-02	1	13423
44010	2976	1149380	1981-04-16	1981-04-16	1	4123
41117	2790	1713332	2013-04-22	2013-04-29	1	15824
54898	3734	920293	1987-08-19	1987-08-26	1	6446
20200	1378	1112807	1949-09-22	1949-10-06	1	-7392
13484	923	1112807	1961-06-29	1961-07-13	1	-3094
52215	3556	1713332	1995-07-14	1995-07-28	1	9339
15946	1102	1759842	1997-01-21	1997-02-04	1	9896
47820	3246	1177480	1981-10-28	1981-11-11	1	4332
4468	307	1177480	2004-12-13	2005-01-12	1	12795
102	6	1124957	1976-05-01	1976-05-01	1	2312
67573	4613	1519936	2013-11-30	2014-11-25	1	16399
44507	3013	1112807	1971-11-12	1971-12-17	1	715
78088	5333	1728416	1952-07-04	1952-07-18	1	-6376
966	65	1115008	2018-07-31	2018-09-29	1	17803
48933	3330	1713332	2005-03-30	2005-04-06	1	12879
7087	488	1713332	2013-11-23	2013-12-14	1	16053
48444	3293	1177480	1984-10-29	1984-11-26	1	5443
6965	480	1759842	1950-05-01	1950-05-15	1	-7171
49226	3353	1112807	1971-06-20	1971-07-20	1	565
4058	276	1515774	2009-03-24	2009-07-16	1	14441
2095	140	1549786	1997-03-20	1998-03-15	1	10300
57593	3926	1125315	1977-02-14	1977-03-14	1	2629
44428	3007	1177480	1989-11-25	1989-12-16	1	7289
2358	158	1112807	1952-01-29	1952-02-19	1	-6526
74784	5118	1118084	2008-02-24	2008-02-24	1	13933
63695	4353	1125315	1992-01-30	1992-03-30	1	8124
6135	421	1125315	1999-07-09	1999-07-30	1	10802
54355	3697	1713332	2011-04-10	2011-04-24	1	15088
37016	2518	1125315	2000-01-22	2000-02-05	1	10992
56072	3820	1112807	1989-08-16	1989-09-20	1	7202
44164	2987	1125315	1989-05-30	1989-06-13	1	7103
52702	3592	1112807	1978-09-07	1978-11-06	1	3231
19078	1309	1125315	2012-11-07	2012-11-14	1	15658
41866	2836	1125315	1994-12-19	1994-12-26	1	9125
65096	4448	1729720	1955-05-14	1955-05-24	1	-5336
70961	4847	738818	1996-04-11	1996-04-18	1	9604
2981	196	1759842	2008-09-28	2008-10-12	1	14164
50413	3435	1125315	1977-05-15	1977-06-12	1	2719
48559	3301	1125315	1985-01-27	1985-02-10	1	5519
58892	4014	1125315	1976-09-11	1976-09-18	1	2452
44011	2976	740275	1955-06-23	1955-11-03	1	-5173
42344	2869	738818	1976-04-27	1976-05-11	1	2322
54899	3734	933724	1987-08-19	1987-08-26	1	6446
20201	1378	1119510	1964-09-26	1964-10-10	1	-1909
13485	923	1124300	1995-02-26	1995-02-26	1	9187
52216	3556	1759842	1995-07-14	1995-07-28	1	9339
17922	1236	1112807	1922-08-02	1922-08-16	1	-17305
47821	3246	1713332	1984-08-15	1984-08-26	1	5351
4469	307	1729720	1981-02-02	1981-02-12	1	4060
103	6	19127890	1977-12-27	1978-12-22	1	3277
67574	4613	1521369	1988-04-06	1989-04-01	1	7030
44508	3013	1118084	1992-10-02	1992-10-02	1	8310
78089	5333	1729720	1987-09-01	1987-09-10	1	6461
967	65	1125315	2005-09-21	2005-10-05	1	13061
48934	3330	19127890	1996-08-17	1998-08-07	2	10445
7088	488	1728416	1956-06-22	1956-07-06	1	-4927
48445	3293	1347450	2006-11-25	2006-11-25	1	13477
8391	582	1115008	2016-09-10	2016-10-10	1	17084
49227	3353	1112807	1983-12-19	1984-01-09	1	5121
4059	276	1549786	2009-03-24	2009-07-16	1	14441
2096	140	19127890	1997-03-20	1998-03-15	1	10300
57594	3926	1125315	1982-11-13	1982-12-11	1	4727
44429	3007	1729720	1967-11-20	1967-12-01	1	-762
2359	158	1112807	1961-12-28	1962-01-18	1	-2905
74785	5118	1125315	1993-05-24	1993-06-28	1	8579
63696	4353	1521369	1988-06-22	1990-06-12	2	7467
7446	515	738818	1966-05-11	1966-05-25	1	-1317
54356	3697	1759842	1981-10-23	1981-12-11	1	4362
37017	2518	1137529	1983-11-25	1983-11-25	1	5076
56073	3820	1125315	1977-11-12	1977-12-17	1	2907
44165	2987	1177480	1975-08-10	1975-08-24	1	2061
52703	3592	1118084	2001-07-07	2001-07-07	1	11510
19079	1309	1177480	1989-12-09	1989-12-23	1	7296
41867	2836	1125315	1998-09-09	1998-10-14	1	10513
65758	4492	1112807	1949-06-21	1949-07-05	1	-7485
70962	4847	1112807	1947-05-12	1947-05-26	1	-8256
2982	196	738818	1967-07-29	1967-08-05	1	-880
50414	3435	1125315	1983-11-08	1983-12-06	1	5087
48560	3301	1177480	1988-11-06	1988-11-27	1	6905
58893	4014	1125315	2018-10-29	2018-10-29	1	17833
44012	2976	1125315	2011-05-06	2011-05-20	1	15114
42345	2869	1112807	1951-11-18	1951-12-09	1	-6598
54900	3734	1124300	1986-02-28	1986-02-28	1	5902
20202	1378	1125315	1950-12-18	1951-01-01	1	-6940
13486	923	1125315	2001-05-22	2001-06-05	1	11478
52217	3556	1112807	1987-09-28	1987-10-12	1	6493
17923	1236	1112807	1925-08-21	1925-09-04	1	-16190
47822	3246	705944	1989-10-19	1997-10-27	1	10161
4470	307	1112807	1979-10-27	1979-11-10	1	3600
104	6	1112807	1965-06-23	1965-07-07	1	-1639
67575	4613	1521369	2012-12-05	2013-11-30	1	16039
44509	3013	1119510	1982-05-15	1982-05-22	1	4524
78090	5333	1759842	1999-01-27	1999-02-10	1	10632
968	65	1759842	1968-07-29	1968-08-19	1	-500
48935	3330	1759842	2005-03-30	2005-04-06	1	12879
7089	488	1729720	1958-10-24	1958-11-05	1	-4075
48446	3293	1713332	1999-03-05	1999-03-26	1	10676
8392	582	1118084	2005-02-05	2005-02-05	1	12819
49228	3353	1119510	1978-08-02	1978-08-16	1	3149
4060	276	19127890	2009-03-24	2009-07-16	1	14441
3720	250	1549786	1992-01-20	1993-01-14	1	8414
57595	3926	1125315	1991-08-26	1991-09-30	1	7942
44430	3007	1729720	2016-12-03	2016-12-15	1	17150
2360	158	1125315	1950-02-17	1950-03-10	1	-7237
74786	5118	1125315	2013-08-18	2013-09-01	1	15949
63697	4353	1503184	1988-06-22	1990-06-12	2	7467
7447	515	738818	1971-09-12	1971-09-26	1	633
54357	3697	1759842	2011-04-10	2011-04-24	1	15088
37018	2518	1309944	1986-08-08	1986-08-08	1	6063
56074	3820	1125315	2015-12-11	2015-12-18	1	16787
44166	2987	1118084	2015-05-02	2015-05-02	1	16557
52704	3592	1119510	2007-04-01	2007-04-15	1	13618
19080	1309	1713332	1980-09-24	1980-10-15	1	3940
41868	2836	1729720	1985-08-09	1985-08-22	1	5712
65759	4492	1118084	1987-09-10	1987-09-10	1	6461
70963	4847	1112807	1950-12-06	1951-01-12	1	-6929
2983	196	1118084	2000-09-19	2000-09-19	1	11219
50415	3435	1125315	1985-09-01	1985-09-15	1	5736
48561	3301	1713332	1983-12-02	1983-12-09	1	5090
58894	4014	1153428	1997-12-09	1997-12-09	1	10204
44013	2976	1137529	1981-04-16	1981-04-16	1	4123
42346	2869	1112807	1960-07-31	1960-08-30	1	-3411
54901	3734	1125315	1952-11-04	1952-11-18	1	-6253
20203	1378	1125315	1952-06-29	1952-07-13	1	-6381
13487	923	1713332	1961-10-15	1961-10-29	1	-2986
52218	3556	1115008	2000-01-23	2000-02-13	1	11000
17924	1236	1115008	2012-12-31	2013-01-14	1	15719
47823	3246	1119510	1982-02-10	1982-02-17	1	4430
4471	307	1125315	1983-08-05	1983-08-26	1	4985
105	6	1118084	2005-07-13	2005-07-13	1	12977
67576	4613	1549786	2013-11-30	2014-11-25	1	16399
44510	3013	1125315	1986-12-21	1987-01-04	1	6212
78091	5333	738818	1954-05-10	1954-05-24	1	-5701
969	65	1759842	1969-05-25	1969-06-01	1	-214
48936	3330	19127890	1987-10-04	1989-09-23	2	7205
7090	488	1759842	1990-10-23	1990-11-20	1	7628
48447	3293	1729720	1958-05-22	1958-06-04	1	-4229
8393	582	1125315	1973-09-17	1973-10-01	1	1369
49229	3353	1125315	1930-03-03	1930-03-17	1	-14535
5189	354	738818	2001-10-18	2001-10-25	1	11620
3721	250	1713332	1980-10-26	1980-11-09	1	3965
57596	3926	1137529	1984-10-15	1984-10-15	1	5401
44431	3007	1759842	1998-01-21	1998-01-28	1	10254
2361	158	1125315	1992-06-23	1992-07-07	1	8223
74787	5118	1551099	1968-10-11	1968-10-11	1	-447
63698	4353	1729720	1968-05-31	1968-06-11	1	-569
7448	515	1125315	1966-05-11	1966-05-25	1	-1317
57156	3896	1347450	2010-06-18	2010-06-18	1	14778
37019	2518	1713332	1997-10-09	1997-11-13	1	10178
56075	3820	1515774	1990-09-15	1991-09-10	1	7922
50980	3469	1112807	1956-11-09	1956-11-23	1	-4787
52705	3592	1177480	1989-01-12	1989-01-26	1	6965
19081	1309	1768849	1984-04-25	1984-05-10	1	5243
41869	2836	920293	2008-11-08	2008-11-22	2	14205
65760	4492	1125315	1959-05-19	1959-06-23	2	-3866
70964	4847	1119510	1959-12-06	1959-12-20	1	-3665
2984	196	1125315	1959-10-22	1959-10-29	1	-3717
50416	3435	1125315	1989-08-23	1989-09-06	1	7188
48562	3301	1713332	2006-05-10	2006-05-17	1	13285
58895	4014	1343916	1997-12-09	1997-12-09	1	10204
44014	2976	1124300	1995-09-26	1995-09-26	1	9399
42347	2869	1112807	1974-03-04	1974-03-25	1	1544
54902	3734	1125315	1966-02-27	1966-02-27	1	-1404
20204	1378	1125315	1981-08-10	1981-09-14	1	4274
13488	923	1713332	2010-05-24	2010-06-07	1	14767
52219	3556	1713332	1987-09-28	1987-10-12	1	6493
17925	1236	1118084	1963-09-07	1963-09-07	1	-2308
47824	3246	1125315	1981-05-14	1981-05-28	1	4165
4472	307	1125315	1987-10-04	1987-10-18	1	6499
106	6	1177480	1976-05-01	1976-06-30	1	2372
67577	4613	1118084	2003-06-27	2003-06-27	1	12230
44511	3013	1125315	2007-05-02	2007-05-09	1	13642
78092	5333	738818	1955-12-06	1955-12-20	1	-5126
970	65	1125315	1996-10-25	1996-11-08	1	9808
48937	3330	1125315	2009-06-02	2009-06-09	1	14404
7091	488	1759842	2013-11-23	2013-12-14	1	16053
48448	3293	1778162	1994-03-23	1994-04-06	1	8861
8394	582	1125315	1996-10-02	1996-10-09	1	9778
49230	3353	1125315	1933-03-03	1933-03-10	1	-13446
5190	354	920293	1981-01-27	1981-02-03	1	4051
3722	250	19127890	1988-02-10	1989-02-04	1	6974
57597	3926	1149380	1984-10-15	1984-10-15	1	5401
44549	3017	738818	1966-03-03	1966-03-10	1	-1393
2362	158	1125315	2014-03-29	2014-04-05	1	16165
74788	5118	1738521	1969-09-06	1969-09-20	1	-103
63699	4353	1738521	1967-04-04	1967-04-18	1	-989
7449	515	1125315	1971-09-12	1971-09-26	1	633
57157	3896	1729720	1987-02-21	1987-03-02	1	6269
37020	2518	914335	1986-08-08	1986-08-08	1	6063
56076	3820	1115008	2013-09-12	2013-10-10	1	15988
50981	3469	1125315	1953-08-27	1953-09-10	1	-5957
52706	3592	1713332	1965-10-30	1965-11-06	1	-1517
19082	1309	753626	1994-03-22	1994-03-22	1	8846
41870	2836	933724	2007-09-28	2007-10-05	1	13791
65761	4492	1177480	1996-12-21	1997-01-04	1	9865
70965	4847	738818	1959-12-06	1959-12-20	1	-3665
2985	196	1125315	1967-07-29	1967-08-05	1	-880
50417	3435	1759842	1979-06-10	1979-06-24	1	3461
48563	3301	1729720	1976-08-02	1976-08-13	1	2416
58896	4014	1713332	2008-12-22	2009-01-12	1	14256
44015	2976	1125315	1966-08-26	1966-09-09	1	-1210
42348	2869	1115008	2000-12-03	2000-12-24	1	11315
54903	3734	1713332	1960-05-09	1960-05-23	1	-3510
20205	1378	1125315	2013-08-27	2013-09-10	1	15958
13489	923	1759842	2005-01-31	2005-02-14	1	12828
52220	3556	1115008	1994-01-24	1994-04-24	1	8879
17926	1236	1124957	1939-10-23	1939-10-23	1	-11028
47825	3246	1112807	1990-04-27	1990-05-18	1	7442
4473	307	1125315	1990-08-03	1990-08-24	1	7540
107	6	1717327	1966-10-03	1966-10-17	1	-1172
67578	4613	1125315	1980-09-10	1980-10-01	1	3926
44512	3013	1503184	1974-07-04	1975-06-29	1	2005
78093	5333	836654	1996-01-14	1996-01-14	1	9509
971	65	1125315	2001-09-15	2001-09-22	1	11587
48938	3330	1177480	2013-03-16	2013-04-20	1	15815
7092	488	1112807	1956-06-22	1956-07-06	1	-4927
48449	3293	1118084	1950-04-26	1950-04-26	1	-7190
8395	582	1177480	1986-03-17	1986-04-21	1	5954
49231	3353	1125315	1955-04-02	1955-04-16	1	-5374
5191	354	1119510	2001-10-18	2001-10-25	1	11620
3723	250	1112807	1975-01-09	1975-01-30	1	1855
59096	4026	1112807	1962-09-25	1962-10-09	1	-2641
44550	3017	1112807	1958-04-13	1958-04-27	1	-4267
2363	158	1759842	2017-08-17	2017-09-07	1	17416
74789	5118	1124957	1980-10-08	1980-10-08	1	3933
63700	4353	1759842	1978-12-07	1978-12-28	1	3283
7450	515	1125315	1976-11-13	1976-12-20	2	2545
57158	3896	738818	2000-10-31	2000-11-07	1	11268
37021	2518	933724	1973-10-01	1973-10-08	1	1376
56077	3820	1521369	1986-10-06	1989-09-20	3	7202
50982	3469	1125315	1983-02-26	1983-02-26	2	4832
52707	3592	1713332	1981-10-26	1981-11-09	1	4330
19083	1309	1110410	1994-03-21	1994-03-22	1	8846
41871	2836	1119510	1994-12-19	1994-12-26	1	9125
65762	4492	1347450	1992-10-27	1992-10-27	1	8335
70966	4847	1112807	1943-11-29	1943-12-13	1	-9516
2986	196	1728416	1956-04-08	1956-04-22	1	-5002
50418	3435	1759842	2004-11-02	2004-11-23	1	12745
48564	3301	1729720	1996-07-08	1996-07-21	1	9698
58897	4014	1759842	2008-12-22	2009-01-12	1	14256
44016	2976	1713332	1964-05-11	1964-05-25	1	-2047
42349	2869	1124957	2013-01-20	2013-01-20	1	15725
54904	3734	1729720	1981-04-30	1981-05-12	1	4149
20206	1378	1137529	2000-07-25	2000-07-25	1	11163
13490	923	1778162	1985-06-14	1985-06-28	1	5657
52221	3556	1118084	2013-10-01	2013-10-01	1	15979
17927	1236	1125315	2005-12-08	2006-01-07	1	13155
47826	3246	1118084	2016-12-31	2016-12-31	1	17166
4474	307	1125315	2019-03-03	2019-03-17	1	17972
108	6	723013	2003-12-21	2003-12-21	1	12407
67579	4613	1125315	1990-03-13	1990-04-12	1	7406
44513	3013	1729720	1963-05-06	1963-05-14	1	-2424
78094	5333	1124957	1962-12-22	1962-12-22	1	-2567
972	65	1125315	2009-05-28	2009-06-04	1	14399
48939	3330	1503184	1987-10-04	1989-09-23	2	7205
7093	488	1112807	1966-06-30	1966-07-30	1	-1251
48450	3293	1124957	1996-11-07	1996-11-07	1	9807
8396	582	1125315	2008-03-23	2008-03-30	1	13968
49232	3353	1125315	1971-06-20	1971-06-20	1	535
5192	354	1125315	1957-06-30	1957-07-14	1	-4554
3724	250	1125315	1995-01-25	1995-02-08	1	9169
59097	4026	1177480	1977-04-16	1977-05-07	1	2683
44551	3017	1124300	1991-04-30	1991-04-30	1	7789
2364	158	1112807	1975-02-09	1975-02-23	1	1879
74790	5118	1125315	1980-10-08	1980-12-07	2	3993
63701	4353	1759842	2004-09-26	2004-10-17	1	12708
7451	515	1322184	1997-11-29	2014-05-24	1	16214
57159	3896	1125315	1987-09-06	1987-10-11	1	6492
37022	2518	1118084	1988-05-29	1988-05-29	1	6723
57357	3913	975125	1981-10-23	1981-10-23	1	4313
50983	3469	1125315	2006-11-11	2006-11-25	1	13477
52708	3592	933724	2016-02-18	2016-02-25	1	16856
19084	1309	1367571	1994-03-21	1994-03-21	1	8845
41872	2836	1125315	1984-02-13	1984-04-13	1	5216
65763	4492	1713332	2002-04-18	2002-05-09	1	11816
70967	4847	1112807	1960-09-03	1960-09-24	1	-3386
2987	196	1112807	1970-12-21	1971-01-25	1	389
50419	3435	1595799	1998-03-06	1999-03-01	1	10651
48565	3301	1759842	1972-12-10	1972-12-24	1	1088
58898	4014	975125	1997-11-27	1997-11-27	1	10192
44017	2976	1728416	1958-01-08	1958-01-22	1	-4362
42350	2869	1125315	1968-11-20	1968-12-30	2	-386
54905	3734	738818	1950-04-10	1950-04-24	1	-7192
20207	1378	1729720	1962-10-29	1962-11-05	1	-2614
13491	923	1125315	1985-06-14	1985-06-28	1	5657
52222	3556	1177480	2002-01-03	2002-01-17	1	11704
17928	1236	1177480	2012-01-06	2012-03-06	1	15405
47827	3246	1119510	2002-10-10	2002-10-17	1	11977
4475	307	1713332	1979-11-02	1979-11-09	1	3599
109	6	1112807	1966-10-03	1966-10-17	1	-1172
67580	4613	1519936	2004-01-22	2005-01-16	1	12799
50180	3418	1729720	1990-06-14	1990-06-25	1	7480
78095	5333	1125315	1952-07-04	1952-07-18	1	-6376
973	65	1729720	2004-11-06	2004-11-14	1	12736
48940	3330	1515774	1996-08-17	1998-08-07	2	10445
7094	488	1124957	1977-02-02	1977-02-02	1	2589
48451	3293	1125315	1975-11-11	1975-12-16	1	2175
8397	582	1112807	1965-11-27	1966-01-01	1	-1461
49233	3353	1125315	1998-11-26	1999-01-25	1	10616
5193	354	1125315	2001-10-18	2001-10-25	1	11620
3725	250	1738521	1975-12-05	1975-12-19	1	2178
59098	4026	1717327	1962-09-25	1962-10-09	1	-2641
44552	3017	1125315	1966-03-03	1966-03-10	1	-1393
2365	158	1118084	1983-11-11	1983-11-11	1	5062
74791	5118	1125315	1982-08-18	1982-09-01	1	4626
65401	4471	1118084	1998-05-18	1998-05-18	1	10364
7452	515	1332418	1996-11-23	1996-11-23	1	9823
57160	3896	1125315	2000-10-31	2000-11-07	1	11268
37023	2518	1149380	1983-11-25	1983-11-25	1	5076
57358	3913	1119510	1982-07-14	1982-07-28	1	4591
50984	3469	1728416	1956-11-09	1956-11-23	1	-4787
52709	3592	1125315	1998-11-27	1998-12-11	1	10571
19085	1309	1713332	1963-02-07	1963-02-21	1	-2506
41873	2836	1125315	1986-02-02	1986-02-23	1	5897
65764	4492	1759842	1969-11-07	1970-05-01	1	120
70968	4847	1119510	1996-04-11	1996-04-18	1	9604
2988	196	1125315	1984-04-16	1984-05-14	1	5247
50420	3435	19127890	1993-04-01	1994-03-27	1	8851
48566	3301	1759842	2008-07-12	2008-08-02	1	14093
58899	4014	1125315	1977-02-27	1977-03-13	1	2628
44018	2976	1125315	2005-09-19	2005-10-03	1	13059
42351	2869	1125315	1976-04-27	1976-05-11	1	2322
54906	3734	1112807	1949-07-12	1949-07-26	1	-7464
20208	1378	1759842	1962-06-11	1962-06-25	1	-2747
13492	923	1125315	1987-02-02	1987-02-16	1	6255
53369	3636	738818	2006-05-03	2006-05-17	1	13285
17929	1236	1557272	2010-07-29	2010-07-29	1	14819
47828	3246	1125315	2009-05-16	2009-05-30	1	14394
4476	307	1759842	1979-11-02	1979-11-09	1	3599
110	6	1112807	1967-12-10	1967-12-31	1	-732
67581	4613	1521369	2003-01-27	2004-01-22	1	12439
50181	3418	920293	1974-11-17	1974-11-24	1	1788
78096	5333	1125315	1954-05-10	1954-05-24	1	-5701
974	65	933724	2016-05-02	2016-05-16	1	16937
48941	3330	1521369	1990-09-18	1992-09-07	2	8285
7095	488	1125315	1969-08-13	1969-09-12	1	-111
48452	3293	1177480	1994-03-23	1994-04-06	1	8861
8398	582	1177480	1977-06-08	1977-06-22	1	2729
49234	3353	1174888	1971-06-20	1971-06-20	1	535
5194	354	1137529	1998-01-15	1998-01-15	1	10241
3726	250	19127890	1992-01-20	1993-01-14	1	8414
59099	4026	738818	1981-07-30	1981-08-06	1	4235
44553	3017	1713332	1973-12-08	1974-02-16	1	1507
2366	158	1177480	2001-10-18	2001-11-08	1	11634
74792	5118	1729720	1968-11-27	1968-12-08	1	-389
65402	4471	1322184	2001-01-08	2001-01-08	1	11330
7453	515	1361711	1996-11-23	1996-11-23	1	9823
57161	3896	1124300	2018-11-11	2018-11-11	1	17846
37024	2518	1177480	1992-11-06	1992-12-04	1	8373
57359	3913	1125315	1964-04-10	1964-04-24	1	-2078
50985	3469	1112807	1958-06-08	1958-06-22	1	-4211
52710	3592	1713332	1984-05-04	1984-05-25	1	5258
19086	1309	1746114	1994-03-22	1994-03-22	1	8846
41874	2836	1125315	2012-01-04	2012-02-08	1	15378
65765	4492	1119510	1992-02-06	1992-02-20	1	8085
70969	4847	1124300	1977-07-08	1977-07-08	1	2745
2989	196	1125315	1985-03-10	1985-03-31	1	5568
50421	3435	19127890	1996-03-16	1998-03-06	2	10291
48567	3301	1759842	2011-09-03	2011-09-10	1	15227
58900	4014	1177480	2018-10-29	2018-12-28	1	17893
44019	2976	1759842	1964-05-11	1964-05-25	1	-2047
42352	2869	1112807	1954-10-24	1954-12-30	1	-5481
54907	3734	1112807	1966-02-27	1966-05-28	1	-1314
20209	1378	738818	1964-09-26	1964-10-10	1	-1909
13493	923	1713332	1999-05-14	1999-05-28	1	10739
53370	3636	1119510	1993-11-17	1993-12-01	1	8735
17930	1236	1713332	1922-03-26	1922-04-02	1	-17441
47829	3246	1125315	2012-07-29	2012-08-05	1	15557
4477	307	1118084	2009-09-29	2009-09-29	1	14516
111	6	1112807	1971-08-12	1971-08-26	1	602
67582	4613	1521369	2015-11-25	2016-11-19	1	17124
50182	3418	933724	1974-11-17	1974-11-24	1	1788
78097	5333	1125315	1955-12-06	1955-12-20	1	-5126
975	65	1112807	1969-06-18	1969-07-02	1	-183
50629	3444	1713332	1953-12-26	1954-01-02	1	-5843
7096	488	1759842	1965-05-14	1965-05-28	1	-1679
48453	3293	1729720	1940-02-14	1940-02-23	1	-10905
8399	582	1728416	1959-07-02	1959-07-16	1	-3822
49235	3353	1729720	1962-05-02	1962-05-10	1	-2793
5195	354	933724	1981-01-27	1981-02-03	1	4051
3727	250	1112807	1975-12-05	1975-12-19	1	2178
59100	4026	975125	1977-01-30	1977-01-30	1	2586
44554	3017	933724	2002-09-09	2002-09-23	1	11953
2367	158	1713332	1983-04-18	1983-05-09	1	4876
74793	5118	1119510	2013-08-18	2013-09-01	1	15949
65403	4471	1759842	1975-05-16	1975-05-23	1	1968
7454	515	1713332	1958-06-26	1958-09-11	1	-4130
57162	3896	1125315	1990-12-29	1991-01-12	1	7681
37025	2518	1343916	1986-08-08	1986-08-08	1	6063
57360	3913	1125315	1972-01-01	1972-01-15	1	744
50986	3469	1112807	1969-04-19	1969-05-10	1	-236
52711	3592	1759842	1984-05-04	1984-05-25	1	5258
19087	1309	1759842	1980-09-24	1980-10-15	1	3940
41875	2836	1713332	2014-08-20	2014-08-27	1	16309
65766	4492	1125315	1981-03-24	1981-04-14	1	4121
70970	4847	1125315	1959-12-06	1959-12-20	1	-3665
2990	196	19127890	1981-08-05	1982-07-31	1	4594
50422	3435	1115008	2018-04-27	2018-05-27	1	17678
46398	3150	1729720	1950-07-25	1950-08-06	1	-7088
58901	4014	1713332	1993-11-27	1993-12-18	1	8752
44704	3030	1125315	1989-04-08	1989-05-06	1	7065
42353	2869	1115008	2013-01-20	2013-02-19	1	15755
54908	3734	1112807	1978-03-26	1978-04-09	1	3020
20210	1378	1125315	1964-09-26	1964-10-10	1	-1909
13494	923	1717327	1961-06-29	1961-07-13	1	-3094
53371	3636	1125315	1981-12-24	1982-01-23	1	4405
17931	1236	1713332	1957-05-11	1957-05-25	1	-4604
47830	3246	738818	1982-02-10	1982-02-17	1	4430
4478	307	1125315	1994-08-08	1994-08-08	1	8985
112	6	1115008	2004-05-09	2004-05-23	1	12561
67583	4613	1717327	1971-08-08	1971-08-22	1	598
50183	3418	1125315	1991-07-09	1991-07-23	1	7873
78098	5333	1125315	1993-08-27	1993-09-03	1	8646
976	65	1124300	2009-06-03	2009-06-03	1	14398
50630	3444	1729720	1989-09-28	1989-10-05	1	7217
7097	488	1119510	2002-04-01	2002-04-15	1	11792
48454	3293	1125315	1960-12-12	1960-12-19	1	-3300
8400	582	1729720	2014-04-02	2014-04-14	1	16174
49236	3353	1729720	1979-04-14	1979-04-23	1	3399
5196	354	1118084	1989-12-12	1989-12-12	1	7285
3728	250	1118084	2008-12-26	2008-12-26	1	14239
59101	4026	1112807	1973-04-07	1973-06-06	1	1252
44555	3017	920293	2002-09-09	2002-09-23	2	11953
2368	158	1729720	1952-05-08	1952-05-16	1	-6439
74794	5118	1125315	1977-12-23	1978-02-21	1	2973
65404	4471	1759842	1986-04-24	1986-05-15	1	5978
7455	515	1713332	1998-11-16	1998-11-30	1	10560
57163	3896	1112807	1985-01-28	1985-02-18	1	5527
37026	2518	1713332	1999-09-03	1999-09-10	1	10844
57361	3913	1125315	2004-06-28	2004-07-12	1	12611
50987	3469	1125315	2015-09-18	2015-10-02	1	16710
52712	3592	1125315	1973-12-11	1974-01-01	1	1461
19088	1309	19003953	1994-03-22	1994-03-22	1	8846
41876	2836	1729720	2001-02-02	2001-02-13	1	11366
65767	4492	1713332	1969-11-07	1970-05-01	1	120
70971	4847	1137529	1978-01-25	1978-01-25	1	2946
4082	279	1119510	1998-04-05	1998-04-19	1	10335
50423	3435	1115008	2019-05-22	2019-05-22	1	18038
47623	3234	1112807	1949-06-19	1949-07-03	1	-7487
58902	4014	1778162	1993-07-04	1993-07-18	1	8599
44705	3030	1125315	1995-12-31	1996-01-14	1	9509
42354	2869	1119510	1970-03-04	1970-03-11	1	69
54909	3734	1115008	2006-07-11	2006-08-10	1	13370
20211	1378	1125315	2017-07-18	2017-08-01	1	17379
13495	923	1729720	1986-11-05	1986-11-12	1	6159
53372	3636	1125315	1993-04-25	1993-05-23	1	8543
17932	1236	1713332	1993-04-14	1993-04-21	1	8511
47831	3246	738818	2002-10-10	2002-10-17	1	11977
4479	307	1174888	1994-08-08	1994-08-08	1	8985
113	6	1125315	1969-12-20	1970-01-03	1	2
67584	4613	19127890	1988-04-06	1989-04-01	1	7030
50184	3418	1118084	1977-07-30	1977-07-30	1	2767
78099	5333	1125315	1993-12-20	1994-01-03	1	8768
977	65	1713332	1968-07-29	1968-08-19	1	-500
50631	3444	1759842	1963-09-01	1963-09-15	1	-2300
7098	488	1124300	1993-12-10	1993-12-10	1	8744
48455	3293	1125315	1998-10-02	1998-10-16	1	10515
8401	582	1112807	1959-07-02	1959-07-16	1	-3822
49237	3353	1759842	1935-03-10	1935-03-17	1	-12709
5197	354	1125315	1968-12-27	1969-01-17	1	-349
3729	250	1125315	2018-06-05	2018-06-19	1	17701
59102	4026	1119510	2013-06-05	2013-06-19	1	15875
44556	3017	1119510	1966-03-03	1966-03-10	1	-1393
2369	158	1759842	1983-04-18	1983-05-09	1	4876
74795	5118	1177480	1990-05-19	1990-06-09	1	7464
65405	4471	19127890	1979-06-12	1980-06-06	1	3809
7456	515	1713332	2012-01-13	2012-02-03	1	15373
57164	3896	1119510	2000-10-31	2000-11-07	1	11268
37027	2518	1729720	2004-08-06	2004-08-19	1	12649
57362	3913	1150770	1981-11-09	1981-11-09	1	4330
50988	3469	1177480	1986-02-08	1986-05-09	1	5972
52713	3592	1125315	1986-05-09	1986-05-16	1	5979
19089	1309	738818	2017-06-23	2017-07-07	1	17354
41877	2836	1759842	2014-08-20	2014-08-27	1	16309
65768	4492	738818	1992-02-06	1992-02-20	1	8085
70972	4847	1361711	2013-03-27	2013-03-27	1	15791
4083	279	1125315	1958-10-25	1958-11-01	1	-4079
50424	3435	1125315	1978-04-10	1978-04-24	1	3035
47624	3234	1119510	1977-06-24	1977-07-08	1	2745
58903	4014	1112807	1968-02-24	1968-03-09	1	-663
44706	3030	1177480	1986-05-24	1986-08-22	1	6077
42355	2869	1119510	1976-04-27	1976-05-11	1	2322
54910	3734	1125315	1950-04-10	1950-04-24	1	-7192
20212	1378	1149380	2000-07-25	2000-07-25	1	11163
13496	923	1759842	1999-05-14	1999-05-28	1	10739
53373	3636	1125315	2006-05-03	2006-05-17	1	13285
17933	1236	1729720	1933-12-04	1933-12-16	1	-13165
47832	3246	1112807	1984-06-27	1984-08-26	1	5351
4480	307	1177480	1981-08-17	1981-09-14	1	4274
114	6	1125315	1976-05-01	1976-05-01	1	2312
67585	4613	920293	1987-06-26	1987-07-03	1	6392
50185	3418	1125315	2008-12-27	2009-01-03	1	14247
78100	5333	715997	1997-07-07	1997-07-07	1	10049
978	65	1713332	1969-05-25	1969-06-01	1	-214
50632	3444	1124300	1970-12-12	1970-12-12	1	345
7099	488	738818	2002-04-01	2002-04-15	1	11792
48456	3293	1713332	1941-11-24	1941-12-15	1	-10244
8402	582	1112807	1961-01-22	1961-04-22	1	-3176
49238	3353	1118084	1959-04-08	1959-04-08	1	-3921
5198	354	1713332	2013-08-18	2013-08-25	1	15942
3730	250	1503184	1988-02-10	1989-02-04	1	6974
59103	4026	1125315	1981-07-30	1981-08-06	1	4235
44557	3017	1125315	1960-07-01	1960-09-29	1	-3381
2370	158	738818	1995-03-23	1995-04-06	1	9226
74796	5118	1713332	1982-08-18	1982-09-01	1	4626
65406	4471	1102527	1996-04-03	1996-04-03	1	9589
7457	515	1759842	1998-11-16	1998-11-30	1	10560
57165	3896	1125315	1978-08-03	1978-08-17	1	3150
37754	2566	920293	1982-11-15	1982-11-22	1	4708
57363	3913	1759842	1966-10-05	1967-04-12	1	-995
50989	3469	1713332	1961-06-14	1961-06-28	1	-3109
52714	3592	1759842	1981-10-26	1981-11-09	1	4330
19090	1309	782043	1994-03-22	1994-03-22	1	8846
41878	2836	1118084	2019-01-10	2019-01-10	1	17906
65769	4492	1112807	1959-05-19	1959-06-18	1	-3850
70973	4847	1759842	1963-05-17	1963-05-24	1	-2414
4084	279	1759842	2001-12-13	2001-12-27	1	11683
50425	3435	1515774	1993-04-01	1994-03-27	1	8851
47625	3234	1759842	1953-11-30	1953-12-14	1	-5862
58904	4014	1112807	1993-07-04	1993-07-18	1	8599
44707	3030	1595799	1998-07-30	1999-07-25	1	10797
42356	2869	1125315	1991-05-06	1991-05-20	1	7809
54911	3734	1125315	1957-03-07	1957-03-14	1	-4676
20213	1378	1713332	2001-10-17	2001-10-31	1	11626
13497	923	1112807	1989-04-03	1989-04-24	1	7053
53374	3636	1125315	2010-02-10	2010-02-17	1	14657
17934	1236	1759842	1922-03-26	1922-04-02	1	-17441
47833	3246	1115008	2010-01-03	2010-01-31	1	14640
6908	479	738818	1944-02-29	1944-03-14	1	-9424
115	6	1125315	1980-01-11	1980-02-15	1	3697
67586	4613	933724	1987-06-26	1987-07-03	1	6392
50186	3418	1177480	2005-11-20	2005-12-04	1	13121
78101	5333	1112807	1950-12-25	1951-01-08	1	-6933
979	65	1759842	1991-07-03	1991-07-10	1	7860
50633	3444	1125315	1978-06-04	1978-06-11	1	3083
7100	488	1125315	1988-01-17	1988-01-31	1	6604
48457	3293	1729720	1996-11-07	1996-11-19	1	9819
8403	582	1728416	1977-06-08	1977-06-22	1	2729
49239	3353	1119510	1976-11-01	1976-11-08	1	2503
5199	354	19127890	1974-12-06	1977-11-20	3	2880
3731	250	738818	2002-08-13	2002-08-27	1	11926
59104	4026	1125315	2013-06-05	2013-06-19	1	15875
2678	180	738818	1999-06-27	1999-07-04	1	10776
2371	158	1125315	1953-08-31	1953-09-14	1	-5953
74797	5118	1713332	1987-05-06	1987-05-20	1	6348
65407	4471	1119510	1963-11-14	1963-11-21	1	-2233
7458	515	1119510	1971-09-12	1971-09-26	1	633
57166	3896	1322184	2010-06-18	2010-06-18	1	14778
37755	2566	933724	1982-11-15	1982-11-22	1	4708
57364	3913	738818	1982-07-14	1982-07-28	1	4591
50990	3469	1115008	1998-08-30	1998-10-04	1	10503
54831	3730	920293	2005-05-29	2005-06-05	1	12939
19091	1309	1119510	1957-02-18	1957-03-04	1	-4686
41879	2836	1125315	1991-11-24	1991-12-15	1	8018
65770	4492	1112807	1975-01-25	1975-04-25	1	1940
70974	4847	738818	2002-01-20	2002-02-03	1	11721
4085	279	1759842	2018-09-16	2018-09-30	1	17804
50426	3435	1515774	1996-03-16	1998-03-06	2	10291
47626	3234	1124300	1990-02-03	1990-02-03	1	7338
58905	4014	1713332	1983-10-14	1983-10-28	1	5048
44708	3030	1759842	2014-01-24	2014-02-14	1	16115
42357	2869	1310149	2009-12-15	2009-12-15	1	14593
54912	3734	1713332	1991-12-14	1992-01-04	1	8038
20214	1378	1729720	1967-03-15	1967-03-23	1	-1015
13498	923	1729720	1970-11-02	1970-11-13	1	316
53375	3636	1515774	1989-07-02	1990-06-27	1	7482
17935	1236	1759842	1993-04-14	1993-04-21	1	8511
47834	3246	1125315	1982-02-10	1982-02-17	1	4430
6909	479	1119510	2009-06-18	2009-07-02	1	14427
116	6	1521369	1977-12-27	1978-12-22	1	3277
67587	4613	1112807	1967-10-14	1967-10-28	1	-796
50187	3418	1713332	1965-03-29	1965-04-19	1	-1718
78102	5333	1119510	1954-05-10	1954-05-24	1	-5701
980	65	1759842	1998-03-29	1998-04-05	1	10321
50634	3444	1322184	2018-10-29	2018-10-29	1	17833
7101	488	1125315	2002-04-01	2002-04-15	1	11792
48458	3293	1759842	1999-03-05	1999-03-26	1	10676
9941	682	1118084	2008-06-26	2008-06-26	1	14056
49240	3353	1557272	1995-11-25	1995-11-25	1	9459
5200	354	1125315	1957-12-25	1958-01-08	1	-4376
3732	250	1119510	2002-08-13	2002-08-27	1	11926
59105	4026	1137529	2013-02-10	2013-02-10	1	15746
2679	180	920293	1997-05-18	1997-05-25	1	10006
2372	158	1125315	1954-07-13	1954-07-20	1	-5644
74798	5118	1759842	1987-05-06	1987-05-20	1	6348
65408	4471	1347450	2001-01-08	2001-01-08	1	11330
7459	515	1125315	2001-01-11	2001-02-01	1	11354
57167	3896	1729720	1988-03-28	1988-04-05	1	6669
37756	2566	1115008	2014-01-01	2014-03-02	1	16131
57365	3913	1112807	1969-11-10	1970-01-09	1	8
50991	3469	1118084	1991-04-15	1991-04-15	1	7774
54832	3730	1102527	2002-07-23	2002-07-23	1	11891
19092	1309	1125315	1987-09-17	1987-09-24	1	6475
41880	2836	1729720	2009-06-04	2009-06-12	1	14407
65771	4492	1119510	1952-06-06	1952-06-13	1	-6411
70975	4847	1112807	1959-09-18	1959-10-09	1	-3737
4086	279	1112807	1956-07-25	1956-08-08	1	-4894
50427	3435	1549786	1996-03-16	1999-03-01	3	10651
47627	3234	1125315	2005-10-27	2005-11-02	1	13089
58906	4014	1759842	1970-07-19	1970-08-02	1	213
44709	3030	1768849	1981-10-17	1981-10-31	1	4321
42358	2869	1326303	2009-12-15	2009-12-15	1	14593
54913	3734	1759842	1960-05-09	1960-05-23	1	-3510
20215	1378	1759842	2001-10-17	2001-10-31	1	11626
13499	923	1759842	1961-10-15	1961-10-29	1	-2986
53376	3636	1119510	2006-05-03	2006-05-17	1	13285
17936	1236	1112807	1966-12-28	1967-03-05	1	-1033
47835	3246	1125315	1984-12-14	1984-12-21	1	5468
6910	479	1125315	1949-02-17	1949-03-03	1	-7609
117	6	1717327	1965-06-23	1965-07-07	1	-1639
67588	4613	1125315	1996-02-15	1996-02-22	1	9548
50188	3418	1728416	1949-07-17	1949-07-31	1	-7459
78103	5333	1119510	1955-12-06	1955-12-20	1	-5126
2597	173	1112807	1977-11-02	1978-01-01	1	2922
50635	3444	1347450	2018-10-29	2018-10-29	1	17833
7102	488	1125315	2015-08-18	2015-09-01	1	16679
49063	3342	1112807	1923-07-24	1923-08-14	1	-16942
9942	682	1125315	1982-02-20	1982-03-06	1	4447
50511	3439	1112807	1967-01-02	1967-04-02	1	-1005
5201	354	1125315	1989-10-29	1989-11-19	1	7262
3733	250	1125315	1980-10-26	1980-11-09	1	3965
59106	4026	1177480	1992-04-18	1992-05-09	1	8164
2680	180	1125315	1999-06-27	1999-07-04	1	10776
2373	158	1125315	1967-10-12	1967-10-19	1	-805
74799	5118	1125315	1969-09-06	1969-09-20	1	-103
65409	4471	1503184	1979-06-12	1980-06-06	1	3809
7460	515	1125315	1985-04-07	1985-05-05	1	5603
57168	3896	1738521	1978-08-03	1978-08-17	1	3150
37757	2566	1125315	1946-09-18	1946-09-25	1	-8499
57366	3913	1124300	2001-07-05	2001-07-05	1	11508
50992	3469	1124957	1983-02-26	1983-02-26	1	4804
54833	3730	1125315	2007-01-24	2007-02-07	1	13551
19093	1309	1125315	1994-03-22	1994-03-22	1	8846
43072	2914	1119510	1962-09-26	1962-10-10	1	-2640
65772	4492	1124957	1959-05-19	1959-05-19	1	-3880
70976	4847	1119510	2002-01-20	2002-02-03	1	11721
4087	279	1125315	1965-12-05	1965-12-12	1	-1481
50428	3435	1713332	1979-06-10	1979-06-24	1	3461
47628	3234	1125315	2010-01-18	2010-01-19	1	14628
58907	4014	1759842	1993-11-27	1993-12-18	1	8752
44710	3030	1768849	1984-02-12	1984-02-26	1	5169
42359	2869	1124300	1989-02-06	1989-02-06	1	6976
57088	3891	1125315	2002-08-12	2002-08-19	1	11918
20216	1378	1112807	1945-05-16	1945-06-06	1	-8975
13500	923	1125315	1968-07-23	1968-08-06	1	-513
53377	3636	1125315	2002-07-22	2002-08-05	1	11904
17937	1236	1729720	1971-04-26	1971-05-06	1	490
47836	3246	1125315	2002-10-10	2002-10-17	1	11977
6911	479	1177480	2011-11-15	2011-11-29	1	15307
118	6	1717327	1969-12-20	1970-01-03	1	2
67589	4613	1125315	1996-09-21	1996-09-28	1	9767
50189	3418	1729720	1980-12-17	1980-12-30	1	4016
78104	5333	1125315	1962-12-22	1962-12-22	1	-2567
2598	173	1119510	2001-02-02	2001-02-09	1	11362
50636	3444	1713332	1963-09-01	1963-09-15	1	-2300
7103	488	1729720	1958-06-13	1958-06-25	1	-4208
49064	3342	1118084	1950-04-18	1950-04-18	1	-7198
9943	682	1112807	1972-07-10	1972-07-24	1	935
50512	3439	1118084	1995-05-06	1995-05-06	1	9256
5202	354	1503184	1974-12-06	1977-11-20	3	2880
3734	250	1125315	1983-02-17	1983-03-10	1	4816
59107	4026	1713332	2008-01-19	2008-02-02	1	13911
2681	180	1503184	1995-03-28	1996-03-22	1	9577
2374	158	1125315	1995-03-23	1995-04-06	1	9226
77488	5298	1124300	1973-12-06	1973-12-06	1	1435
65410	4471	1759842	1969-11-09	1969-11-23	1	-39
7461	515	1174888	1976-11-20	1976-11-20	1	2515
59451	4052	1112807	1979-05-19	1979-06-02	1	3439
37758	2566	1713332	1959-05-02	1959-05-23	1	-3876
57367	3913	1125315	1982-07-14	1982-07-28	1	4591
50993	3469	1125315	1993-03-22	1993-04-28	1	8518
54834	3730	1728416	1954-09-28	1954-10-12	1	-5560
19094	1309	1125315	2017-06-23	2017-07-07	1	17354
43073	2914	1309944	1986-09-06	1986-09-06	1	6092
65773	4492	1125315	1957-07-07	1957-07-28	1	-4540
70977	4847	1125315	1996-04-11	1996-04-18	1	9604
4088	279	1125315	1992-02-12	1992-02-26	1	8091
50429	3435	1713332	2004-11-02	2004-11-23	1	12745
47629	3234	1539403	1992-07-28	1992-07-28	1	8244
58908	4014	1124957	2018-10-29	2018-10-29	1	17833
44711	3030	738818	1984-09-03	1984-09-17	1	5373
42360	2869	1125315	1962-09-19	1962-10-19	1	-2631
57089	3891	1129625	1983-11-05	1983-11-05	1	5056
20217	1378	1124300	1981-07-26	1981-07-26	1	4224
13501	923	1125315	1976-10-30	1976-11-06	1	2501
53378	3636	1125315	2017-03-18	2017-04-08	1	17264
17938	1236	1759842	1957-05-11	1957-05-25	1	-4604
47837	3246	1713332	1981-05-14	1981-05-28	1	4165
6912	479	1713332	2003-12-19	2003-12-26	1	12412
119	6	1115008	2005-06-17	2005-07-22	1	12986
67590	4613	1125315	2018-05-21	2018-06-04	1	17686
50190	3418	757627	2019-03-03	2019-03-03	1	17958
78105	5333	1177480	1990-03-30	1990-05-04	1	7428
2599	173	1125315	1985-07-03	1985-07-17	1	5676
50637	3444	1729720	1958-01-12	1958-01-20	1	-4364
11328	775	1112807	1940-03-10	1940-03-24	1	-10875
49065	3342	1125315	1927-06-04	1927-06-18	1	-15538
9944	682	1728416	1972-07-10	1972-07-24	1	935
50513	3439	1124957	1967-01-02	1967-01-02	1	-1095
5203	354	1125315	1973-03-24	1973-04-07	1	1192
3735	250	1125315	2002-08-13	2002-08-27	1	11926
59108	4026	1717327	1961-04-01	1961-04-15	1	-3183
2682	180	1503184	1997-03-17	1998-03-12	1	10297
2375	158	1119510	1995-03-23	1995-04-06	1	9226
77489	5298	1125315	1986-07-24	1986-08-07	1	6062
65411	4471	1125315	1962-07-03	1962-07-10	1	-2732
7462	515	1177480	2012-08-02	2012-10-31	1	15644
59452	4052	1112807	1985-11-24	1985-12-24	1	5836
37759	2566	1713332	1980-02-10	1980-03-02	1	3713
57368	3913	1713332	1966-10-05	1967-04-12	1	-995
50994	3469	1177480	1991-06-17	1991-07-01	1	7851
54835	3730	914335	1994-07-28	1994-07-28	1	8974
19095	1309	1713332	1992-06-05	1992-06-12	1	8198
43074	2914	1343916	1986-09-06	1986-09-06	1	6092
65774	4492	1125315	1964-03-23	1964-05-22	1	-2050
70978	4847	1125315	2002-01-20	2002-02-03	1	11721
4089	279	1125315	2014-10-24	2014-10-31	1	16374
50430	3435	1118084	2016-06-29	2016-06-29	1	16981
47630	3234	1545958	2010-01-18	2010-01-19	1	14628
58909	4014	1713332	1970-07-19	1970-08-02	1	213
44712	3030	1125315	1984-09-03	1984-09-17	1	5373
42361	2869	1125315	2013-01-20	2013-01-20	1	15725
57090	3891	1713332	1998-08-09	1998-08-30	1	10468
20218	1378	1125315	1968-01-10	1968-01-24	1	-708
13502	923	1125315	2000-10-21	2000-10-28	1	11258
53379	3636	1713332	1984-04-20	1984-05-11	1	5244
17939	1236	1112807	1921-07-24	1921-08-07	1	-17679
47838	3246	1713332	1981-10-28	1981-11-11	1	4332
6913	479	1112807	1955-12-27	1956-01-17	1	-5098
120	6	1503184	1977-12-27	1978-12-22	1	3277
67591	4613	1500211	2007-01-06	2008-01-01	1	13879
50191	3418	1112807	1949-07-17	1949-07-31	1	-7459
78106	5333	1713332	1999-01-27	1999-02-10	1	10632
2600	173	738818	2001-02-02	2001-02-09	1	11362
50638	3444	1759842	1953-12-26	1954-01-02	1	-5843
11329	775	1112807	1955-04-19	1955-05-17	1	-5343
49066	3342	1125315	1981-07-20	1981-09-18	1	4278
9945	682	1125315	1974-10-15	1974-10-29	1	1762
50514	3439	1125315	1972-06-20	1972-07-04	1	915
5204	354	1125315	2012-04-13	2012-05-18	1	15478
3736	250	1515774	1992-01-20	1993-01-14	1	8414
59109	4026	1759842	2008-01-19	2008-02-02	1	13911
2683	180	1515774	1992-04-12	1993-04-07	1	8497
2376	158	1713332	2017-08-17	2017-09-07	1	17416
77490	5298	1125315	1993-03-07	1993-03-14	1	8473
65412	4471	1713332	1975-05-16	1975-05-23	1	1968
7463	515	1501700	2009-03-05	2009-03-05	1	14308
59453	4052	1115008	1999-06-28	1999-07-12	1	10784
37760	2566	1112807	1958-11-13	1958-12-11	1	-4039
57369	3913	1115008	2017-11-12	2017-11-26	1	17496
50995	3469	1759842	1961-06-14	1961-06-28	1	-3109
54836	3730	920293	2002-04-28	2002-05-05	1	11812
19096	1309	1759842	1992-06-05	1992-06-12	1	8198
43075	2914	1119510	1977-12-19	1977-12-26	1	2916
65775	4492	1713332	2005-09-29	2005-10-20	1	13076
70979	4847	1759842	2005-03-26	2005-04-02	1	12875
4090	279	1713332	1996-10-19	1996-11-02	1	9802
50431	3435	1119510	1989-08-23	1989-09-06	1	7188
47631	3234	1713332	1953-11-30	1953-12-14	1	-5862
58910	4014	1713332	1999-11-26	1999-12-03	1	10928
44713	3030	1549786	1998-07-30	1999-07-25	1	10797
42362	2869	738818	1970-03-04	1970-03-11	1	69
57091	3891	1759842	1984-04-23	1984-05-07	1	5240
22451	1528	1115008	2007-02-24	2007-05-25	1	13658
13503	923	1713332	2005-01-31	2005-02-14	1	12828
53380	3636	1118084	2010-10-23	2010-10-23	1	14905
17940	1236	1112807	1938-11-06	1938-11-20	1	-11365
49041	3339	1112807	1967-08-07	1967-11-05	1	-788
6914	479	1125315	1964-03-23	1964-04-06	1	-2096
2333	156	1115008	2013-08-19	2013-09-02	1	15950
67592	4613	1503184	1988-04-06	1989-04-01	1	7030
50192	3418	1759842	1965-03-29	1965-04-19	1	-1718
2601	173	1125315	2001-02-02	2001-02-09	1	11362
50639	3444	920293	1996-11-17	1996-11-24	1	9824
11330	775	1118084	1976-05-25	1976-05-25	1	2336
49067	3342	1713332	1912-05-27	1912-06-17	1	-21017
9946	682	1112807	1972-10-08	1972-11-05	1	1039
50515	3439	1307863	2015-12-10	2015-12-10	1	16779
5205	354	1149380	1998-01-15	1998-01-15	1	10241
3737	250	1521369	1988-02-10	1989-02-04	1	6974
59110	4026	738818	2013-06-05	2013-06-19	1	15875
2684	180	1549786	1998-03-12	2000-03-01	2	11017
3461	232	1112807	1948-11-10	1948-11-24	1	-7708
77491	5298	1713332	1963-11-21	1963-12-05	1	-2219
65413	4471	1717327	1963-03-28	1963-04-11	1	-2457
7464	515	1539403	1996-11-23	1996-11-23	1	9823
59454	4052	1124300	2015-09-18	2015-09-18	1	16696
37761	2566	1119510	1946-09-18	1946-09-25	1	-8499
57370	3913	1125315	1996-10-19	1996-11-02	1	9802
50996	3469	1125315	1989-06-22	1989-07-27	1	7147
54837	3730	933724	2005-05-29	2005-06-05	1	12939
20390	1387	920293	2013-04-21	2013-05-05	2	15830
43076	2914	1125315	1985-07-28	1985-08-04	1	5694
65776	4492	1759842	2005-09-29	2005-10-20	1	13076
72057	4924	738818	2011-05-29	2011-06-05	1	15130
4091	279	1713332	2002-12-29	2003-01-19	1	12071
50432	3435	1125315	1979-12-24	1980-01-07	1	3658
47632	3234	1728416	1949-06-19	1949-07-03	1	-7487
58911	4014	1728416	1968-02-24	1968-03-09	1	-663
44714	3030	1177480	1981-10-17	1981-10-31	1	4321
42363	2869	1125315	1953-11-07	1953-11-21	1	-5885
57092	3891	1112807	1984-09-14	1984-12-13	1	5460
22452	1528	1728416	1960-03-04	1960-03-18	1	-3576
13504	923	1729720	1965-09-21	1965-09-28	1	-1556
53381	3636	1125315	1973-10-07	1973-10-21	1	1389
17941	1236	1112807	1961-04-30	1961-05-28	1	-3140
49042	3339	1112807	1970-02-10	1970-02-24	1	54
6915	479	1125315	1967-12-15	1968-01-05	1	-727
2334	156	1125315	1982-07-05	1982-07-12	1	4575
67593	4613	1521369	1982-05-08	1983-05-03	1	4870
51500	3510	1125315	1935-10-06	1935-10-13	1	-12499
2602	173	1125315	2011-07-10	2011-07-24	1	15179
50640	3444	738818	2013-08-07	2013-08-21	1	15938
11331	775	1119510	1962-07-23	1962-08-06	1	-2705
49068	3342	1713332	1921-11-30	1921-12-14	1	-17550
9947	682	1112807	1983-04-12	1983-04-26	1	4863
50516	3439	1759842	1960-05-19	1960-06-02	1	-3500
5206	354	1177480	2008-06-12	2008-07-03	1	14063
4334	297	1713332	2000-08-04	2000-08-18	1	11187
59111	4026	1125315	1970-07-22	1970-08-21	2	232
2685	180	1595799	1998-03-12	2000-03-01	2	11017
3462	232	1112807	1953-08-30	1953-09-20	1	-5947
77492	5298	738818	1942-03-20	1942-04-03	1	-10135
65414	4471	1729720	1975-04-27	1975-05-09	1	1954
7465	515	1759842	1958-06-26	1958-09-11	1	-4130
59455	4052	1125315	1990-07-02	1990-07-09	1	7494
37762	2566	1125315	2015-11-22	2016-01-21	2	16821
57371	3913	1717327	1964-04-10	1964-04-24	1	-2078
50997	3469	1125315	2001-07-18	2001-08-01	1	11535
54838	3730	1112807	1954-09-28	1954-10-12	1	-5560
20391	1387	1102527	2001-12-09	2001-12-09	1	11665
43077	2914	1125315	1991-03-17	1991-04-07	1	7766
65777	4492	738818	1952-06-06	1952-06-13	1	-6411
72058	4924	975125	1989-02-17	1989-03-10	1	7008
4092	279	1728416	1952-08-26	1952-09-09	1	-6323
50433	3435	1125315	2009-04-23	2009-07-22	1	14447
47633	3234	1728416	1952-12-16	1952-12-30	1	-6211
58912	4014	1759842	1999-11-26	1999-12-03	1	10928
44715	3030	1177480	2013-08-26	2013-09-09	1	15957
42364	2869	1125315	1970-03-04	1970-03-11	1	69
57093	3891	1115008	2007-10-14	2007-11-04	1	13821
22453	1528	1728416	1964-06-25	1964-07-09	1	-2002
13505	923	1759842	2010-05-24	2010-06-07	1	14767
53382	3636	1125315	1997-10-13	1997-10-27	1	10161
17942	1236	1115008	1994-08-24	1994-09-23	1	9031
49043	3339	1115008	1999-04-05	1999-07-04	1	10776
6916	479	1125315	1989-05-11	1989-05-25	1	7084
2335	156	1759842	1981-12-11	1981-12-18	1	4369
67594	4613	1549786	2004-01-22	2005-01-16	1	12799
51501	3510	1125315	1982-04-19	1982-05-03	1	4505
2603	173	1729720	1968-04-27	1968-05-04	1	-607
50641	3444	920293	2000-01-08	2000-01-22	2	10978
11332	775	1119510	1982-09-05	1982-09-12	1	4637
49069	3342	1759842	1912-05-27	1912-06-17	1	-21017
10663	732	1119510	2009-06-04	2009-06-18	1	14413
50517	3439	1759842	2000-10-03	2000-10-17	1	11247
5207	354	1521369	1974-12-06	1977-11-20	3	2880
4335	297	1759842	2000-08-04	2000-08-18	1	11187
59112	4026	1125315	1970-11-21	1970-12-05	1	338
2686	180	1595799	2001-02-24	2003-02-14	2	12097
3463	232	1112807	1959-02-05	1959-04-13	1	-3916
77493	5298	738818	1993-03-07	1993-03-14	1	8473
65415	4471	738818	1963-11-14	1963-11-21	1	-2233
7466	515	1759842	2012-01-13	2012-02-03	1	15373
59456	4052	1125315	1995-01-15	1995-01-22	1	9152
37763	2566	1729720	1943-09-05	1943-09-14	1	-9606
57372	3913	1729720	1979-06-24	1979-07-01	1	3468
50998	3469	1125315	2001-11-30	2001-12-14	1	11670
54839	3730	1115008	2002-07-23	2002-10-21	1	11981
20392	1387	1119510	1989-03-19	1989-03-26	1	7024
43078	2914	738818	1977-12-19	1977-12-26	1	2916
65778	4492	920293	1976-09-14	1976-09-21	1	2455
72059	4924	1125315	2011-05-29	2011-06-05	1	15130
4093	279	1728416	1954-03-02	1954-03-16	1	-5770
50434	3435	1177480	2014-04-27	2014-05-18	1	16208
47634	3234	1174888	2010-01-18	2010-01-19	1	14628
60464	4122	1125315	2004-06-12	2004-06-19	1	12588
44716	3030	1521369	1998-07-30	1999-07-25	1	10797
42365	2869	1307863	2009-12-15	2009-12-15	1	14593
57094	3891	1154343	1984-11-30	1984-11-30	1	5447
22454	1528	1112807	1964-06-25	1964-07-09	1	-2002
14608	1005	1521369	1982-02-12	1983-02-07	1	4785
53383	3636	1549786	1989-07-02	1990-06-27	1	7482
17943	1236	1115008	1999-03-31	1999-04-14	1	10695
49044	3339	1119510	1993-06-17	1993-06-24	1	8575
6917	479	1125315	2004-11-03	2004-11-10	1	12732
2336	156	1119510	2005-06-23	2005-06-30	1	12964
67595	4613	1589505	2014-11-25	2015-11-25	1	16764
51502	3510	1729720	1935-09-07	1935-09-18	1	-12524
2604	173	1759842	2005-08-02	2005-08-16	1	13011
50642	3444	933724	1996-11-17	1996-11-24	1	9824
11333	775	1125315	2000-02-20	2000-03-19	1	11035
49070	3342	1759842	1921-11-30	1921-12-14	1	-17550
10664	732	1125315	1977-03-18	1977-04-15	1	2661
50518	3439	738818	1972-06-20	1972-07-04	1	915
5208	354	1728416	1957-12-25	1958-01-08	1	-4376
4336	297	1125315	1999-11-21	1999-12-05	1	10930
59113	4026	1149380	1960-02-02	1960-02-02	1	-3621
2687	180	1738521	1977-12-17	1977-12-31	1	2921
3464	232	1118084	1982-12-07	1982-12-07	1	4723
77494	5298	757627	2011-07-24	2011-07-24	1	15179
65416	4471	975125	1984-07-13	1984-07-13	1	5307
7467	515	1112807	1942-08-14	1942-08-28	1	-9988
59457	4052	1515774	1993-03-27	1994-03-22	1	8846
37764	2566	1759842	1959-05-02	1959-05-23	1	-3876
58706	4005	1124300	2012-03-27	2012-03-27	1	15426
50999	3469	1713332	1983-02-26	1983-03-26	1	4832
54840	3730	1177480	2019-03-31	2019-04-21	1	18007
20393	1387	1125315	2001-12-09	2002-01-06	1	11693
43079	2914	914335	1986-09-06	1986-09-06	1	6092
65779	4492	933724	1976-09-14	1976-09-21	1	2455
72060	4924	1177480	1989-04-15	1989-05-13	1	7072
4094	279	1729720	1993-06-13	1993-06-20	1	8571
50435	3435	1521369	1998-03-06	1999-03-01	1	10651
47635	3234	1322184	1997-10-27	2010-01-19	1	14628
60465	4122	1503184	1985-12-27	1986-12-22	1	6199
44717	3030	1713332	2014-01-24	2014-02-14	1	16115
42366	2869	1728416	1953-11-07	1953-11-21	1	-5885
57095	3891	1713332	1988-11-03	1988-11-24	1	6902
22455	1528	1112807	1972-01-31	1972-02-14	1	774
14609	1005	1124300	2007-07-01	2007-07-01	1	13695
53384	3636	1713332	1986-05-08	1986-05-29	1	5992
17944	1236	1115008	2001-03-04	2001-04-03	1	11415
49045	3339	1728416	1963-01-25	1963-02-08	1	-2519
6918	479	1125315	2018-09-21	2018-10-05	1	17809
2337	156	1125315	2005-06-23	2005-06-30	1	12964
67596	4613	1713332	1995-07-12	1995-08-02	1	9344
51503	3510	1729720	1952-05-09	1952-05-17	1	-6438
2605	173	1125315	1971-01-08	1971-01-22	1	386
50643	3444	933724	2000-01-08	2000-01-22	1	10978
11334	775	1125315	2016-05-24	2016-06-30	1	16982
49071	3342	738818	1938-11-26	1938-12-10	1	-11345
10665	732	1515774	1989-03-25	1990-03-20	1	7383
50519	3439	1112807	1955-09-08	1955-10-06	1	-5201
5209	354	1759842	2013-08-18	2013-08-25	1	15942
4337	297	1125315	2011-04-08	2011-05-13	1	15107
59114	4026	1149380	2013-02-10	2013-02-10	1	15746
2688	180	1738521	1981-11-09	1981-11-23	1	4344
3465	232	1125315	1959-02-12	1959-02-12	1	-3976
77495	5298	1112807	1991-08-11	1991-09-01	1	7913
65417	4471	1112807	1963-03-28	1963-04-11	1	-2457
7468	515	1112807	1943-04-25	1943-05-09	1	-9734
59458	4052	1713332	1985-07-20	1985-08-03	1	5693
37765	2566	738818	1946-09-18	1946-09-25	1	-8499
58707	4005	1125315	1975-02-20	1975-03-06	1	1890
51000	3469	1728416	1958-06-08	1958-06-22	1	-4211
54841	3730	1309944	1994-07-28	1994-07-28	1	8974
20394	1387	1177480	1980-08-31	1980-11-29	1	3985
43080	2914	920293	1979-11-10	1979-11-17	1	3607
65780	4492	1125315	1952-06-06	1952-06-13	1	-6411
72061	4924	1177480	2006-11-01	2006-11-15	1	13467
4095	279	1759842	1996-10-19	1996-11-02	1	9802
50436	3435	1549786	1993-04-01	1994-03-27	1	8851
47636	3234	1332418	1994-08-02	1994-08-02	1	8979
60466	4122	1521369	1985-12-27	1986-12-22	1	6199
44718	3030	1119510	1984-09-03	1984-09-17	1	5373
42549	2883	738818	1994-03-14	1994-03-28	1	8852
57096	3891	1759842	1988-11-03	1988-11-24	1	6902
22456	1528	1118084	2001-11-14	2001-11-14	1	11640
14610	1005	1125315	2008-10-15	2008-10-22	1	14174
53385	3636	1759842	1986-05-08	1986-05-29	1	5992
17945	1236	1125315	1939-10-23	1939-10-23	1	-11028
49046	3339	1729720	1969-02-14	1969-02-21	1	-314
6919	479	1112807	1943-01-04	1943-01-18	1	-9845
2338	156	1713332	1980-02-14	1980-02-28	1	3710
72015	4922	933724	2000-09-07	2000-09-14	1	11214
51504	3510	1125315	1970-02-12	1970-02-19	1	49
2606	173	1125315	1983-11-03	1983-11-10	1	5061
50644	3444	1112807	1940-05-23	1940-06-06	1	-10801
11335	775	1322184	2017-03-15	2017-03-15	1	17240
49072	3342	1112807	1926-10-18	1926-11-22	1	-15746
10666	732	1119510	1984-05-11	1984-05-25	1	5258
50520	3439	1112807	1962-04-02	1962-04-23	1	-2810
5770	398	1125315	1957-04-20	1957-04-20	1	-4639
4338	297	1177480	1986-07-13	1986-08-17	1	6072
59115	4026	1150770	1977-02-07	1977-02-07	1	2594
2689	180	19127890	1997-03-17	1998-03-12	1	10297
3466	232	1125315	1983-05-07	1983-07-06	1	4934
77496	5298	1125315	1942-03-20	1942-04-03	1	-10135
65418	4471	1125315	1963-11-14	1963-11-21	1	-2233
7469	515	1118084	1981-03-27	1981-03-27	1	4103
59459	4052	19127890	1997-03-06	1998-03-01	1	10286
37766	2566	1112807	1941-02-15	1941-03-01	1	-10533
58708	4005	1125315	1992-09-02	1992-09-16	1	8294
51001	3469	1778162	2001-11-30	2001-12-14	1	11670
54842	3730	1343916	1994-07-28	1994-07-28	1	8974
20395	1387	1713332	1983-05-06	1983-05-20	1	4887
43081	2914	1112807	1960-05-07	1960-05-28	1	-3505
65781	4492	1125315	1992-02-06	1992-02-20	1	8085
72062	4924	1515774	1995-11-24	1996-11-18	1	9818
4096	279	1759842	2002-12-29	2003-01-19	1	12071
50437	3435	1713332	2009-06-05	2009-06-12	1	14407
47637	3234	1729720	1976-09-20	1976-10-02	1	2466
60467	4122	1118084	2013-08-22	2013-08-22	1	15939
44719	3030	1124300	2018-07-25	2018-07-25	1	17737
42550	2883	1125315	1994-03-14	1994-03-28	1	8852
57097	3891	1149380	1984-11-30	1984-11-30	1	5447
22457	1528	1713332	2018-10-14	2018-10-28	1	17832
14611	1005	1521369	1987-01-17	1989-01-06	2	6945
53386	3636	738818	1993-11-17	1993-12-01	1	8735
17946	1236	1125315	1979-01-23	1979-01-30	1	3316
49047	3339	1759842	1971-01-19	1971-02-02	1	397
6920	479	1112807	1959-11-11	1959-11-25	1	-3690
2339	156	1125315	1980-02-14	1980-02-28	1	3710
72016	4922	1124957	2013-11-16	2013-11-16	1	16025
51505	3510	1557272	2015-11-27	2015-11-27	1	16766
2607	173	1738521	1971-01-08	1971-01-22	1	386
50645	3444	1112807	1941-02-04	1941-02-18	1	-10544
11336	775	1102527	2016-05-31	2016-05-31	1	16952
49073	3342	1125315	1938-11-26	1938-12-10	1	-11345
10667	732	1125315	1986-07-18	1986-08-01	1	6056
50521	3439	1713332	1977-02-28	1977-03-14	1	2629
5771	398	1112807	1925-12-22	1926-01-05	1	-16067
4339	297	1713332	2018-11-26	2018-12-17	1	17882
59116	4026	1177480	2009-10-07	2009-11-11	1	14559
2690	180	1129625	1980-05-11	1980-05-11	1	3783
3467	232	1125315	2007-08-31	2007-09-07	1	13763
77497	5298	1125315	1943-01-26	1943-02-09	1	-9823
65419	4471	1177480	1996-04-03	1996-06-02	1	9649
7470	515	1119510	1966-05-11	1966-05-25	1	-1317
59460	4052	975125	1981-12-26	1982-01-09	1	4391
37767	2566	1115008	2000-08-02	2000-09-06	1	11206
58709	4005	1125315	2006-11-23	2006-12-07	1	13489
52557	3579	738818	1990-02-19	1990-03-05	1	7368
54843	3730	1759842	2004-10-03	2004-10-10	1	12701
20396	1387	1759842	1983-05-06	1983-05-20	1	4887
43082	2914	1125315	1977-12-19	1977-12-26	1	2916
65782	4492	1729720	1948-02-28	1948-03-12	1	-7965
72063	4924	1729720	2000-09-24	2000-10-04	1	11234
4097	279	738818	1998-04-05	1998-04-19	1	10335
50438	3435	1759842	2009-06-05	2009-06-12	1	14407
47638	3234	738818	1977-06-24	1977-07-08	1	2745
60468	4122	1125315	2010-09-17	2010-10-01	1	14883
44720	3030	1125315	1984-02-12	1984-02-26	1	5169
42551	2883	1759842	1965-05-27	1965-06-03	1	-1673
57098	3891	1551099	1998-01-04	1998-01-04	1	10230
22458	1528	1729720	1973-01-11	1973-01-23	1	1118
14612	1005	1729720	1969-09-09	1969-09-18	1	-105
53387	3636	1125315	1979-03-12	1979-03-26	1	3371
17947	1236	1713332	1950-08-23	1950-09-06	1	-7057
49048	3339	1125315	1993-06-17	1993-06-24	1	8575
6921	479	1115008	2016-09-03	2016-10-03	1	17077
2340	156	1713332	2009-02-26	2009-03-05	1	14308
72017	4922	1125315	1983-05-29	1983-08-04	1	4963
51506	3510	1112807	1956-02-16	1956-03-22	1	-5033
2608	173	1124300	2003-07-04	2003-07-04	1	12237
50646	3444	1119510	2013-08-07	2013-08-21	1	15938
11337	775	1125315	2012-09-06	2012-09-20	1	15603
49074	3342	1125315	1995-09-17	1995-10-01	1	9404
10668	732	1125315	2000-09-16	2000-09-30	1	11230
50522	3439	1713332	1984-12-09	1984-12-16	1	5463
5772	398	1112807	1955-07-09	1955-07-30	1	-5269
4340	297	1729720	1970-10-27	1970-11-07	1	310
59117	4026	1713332	1960-07-19	1960-08-09	1	-3432
2691	180	1549786	2001-02-24	2003-02-14	2	12097
3468	232	1713332	1988-11-06	1988-11-27	1	6905
77498	5298	1713332	1988-03-15	1988-03-29	1	6662
65420	4471	1521369	1979-06-12	1980-06-06	1	3809
7471	515	1322184	2015-01-31	2015-01-31	1	16466
59461	4052	1115008	2007-01-01	2007-01-22	1	13535
37768	2566	1174888	2015-11-22	2015-11-22	1	16761
58710	4005	1713332	1978-12-22	1978-12-29	1	3284
52558	3579	738818	2017-07-22	2017-07-29	1	17376
54844	3730	933724	2002-04-28	2002-05-05	1	11812
20397	1387	1521369	1986-03-20	1987-03-15	1	6282
43083	2914	1125315	2008-06-05	2008-06-19	1	14049
65783	4492	1759842	2002-04-18	2002-05-09	1	11816
72064	4924	1125315	2002-06-07	2002-06-14	1	11852
4098	279	1177480	2012-02-27	2012-03-19	1	15418
52388	3569	1112807	1966-01-26	1966-02-16	1	-1415
47639	3234	1112807	1952-12-16	1952-12-30	1	-6211
60469	4122	19127890	1985-12-27	1986-12-22	1	6199
44721	3030	1177480	2001-01-17	2001-01-31	1	11353
42552	2883	19127890	1982-02-01	1983-01-27	1	4774
57099	3891	1713332	1984-06-13	1984-06-20	1	5284
22459	1528	1125315	1970-05-12	1970-05-26	1	145
14613	1005	1759842	2004-07-12	2004-08-09	1	12639
53388	3636	1125315	1993-11-17	1993-12-01	1	8735
17948	1236	1713332	2017-02-06	2017-02-20	1	17217
49049	3339	1729720	1960-10-08	1960-10-18	1	-3362
6922	479	1118084	1979-12-01	1979-12-01	1	3621
2341	156	1759842	2009-02-26	2009-03-05	1	14308
72018	4922	1125315	1983-11-27	1983-12-04	1	5085
51507	3510	1118084	1971-11-14	1971-11-14	1	682
2609	173	1125315	2002-04-06	2002-04-20	1	11797
50647	3444	1125315	2013-08-07	2013-08-21	1	15938
11338	775	738818	1962-07-23	1962-08-06	1	-2705
49075	3342	1174888	2011-10-11	2011-10-11	1	15258
10669	732	738818	1984-05-11	1984-05-25	1	5258
50523	3439	1728416	1957-01-30	1957-02-13	1	-4705
5773	398	1125315	1925-02-26	1925-03-05	1	-16373
4341	297	920293	1995-07-02	1995-07-09	1	9320
59118	4026	1729720	1959-01-22	1959-02-02	1	-3986
2692	180	19127890	1992-04-12	1993-04-07	1	8497
3469	232	1729720	1945-10-29	1945-11-10	1	-8818
77499	5298	1759842	1963-11-21	1963-12-05	1	-2219
65421	4471	1713332	1969-11-09	1969-11-23	1	-39
7472	515	1347450	2014-05-24	2014-05-24	1	16214
59462	4052	1125315	2004-02-26	2004-03-04	1	12481
37769	2566	1713332	2003-04-16	2003-04-30	1	12172
58711	4005	1729720	1989-01-08	1989-01-19	1	6958
52559	3579	1115008	1996-04-21	1996-06-27	1	9674
54845	3730	1118084	1989-08-10	1989-08-10	1	7161
20398	1387	738818	1989-03-19	1989-03-26	1	7024
43084	2914	1728416	1959-09-01	1959-09-15	1	-3761
67401	4602	738818	2015-07-16	2015-07-30	1	16646
72065	4924	1129625	1978-06-24	1978-06-24	1	3096
4099	279	1112807	1952-08-26	1952-09-09	1	-6323
52389	3569	1503184	1979-09-25	1980-09-19	1	3914
47640	3234	1125315	1977-06-24	1977-07-08	1	2745
60470	4122	1177480	1995-11-25	1996-02-23	1	9549
45272	3072	914335	1964-02-01	1964-02-01	1	-2161
42553	2883	738818	1981-05-08	1981-05-15	1	4152
57100	3891	1759842	1984-06-13	1984-06-20	1	5284
22460	1528	1125315	2004-05-26	2004-06-09	1	12578
14614	1005	1102527	1989-03-04	1989-03-04	1	7002
53389	3636	1759842	1984-04-20	1984-05-11	1	5244
17949	1236	1759842	2017-02-06	2017-02-20	1	17217
49050	3339	1729720	1968-08-09	1968-08-16	1	-503
6923	479	1119510	1944-02-29	1944-03-14	1	-9424
2342	156	19127890	1997-09-22	1998-09-17	1	10486
72019	4922	1759842	2003-01-12	2003-02-02	1	12085
51508	3510	1119510	1983-01-22	1983-02-05	1	4783
2610	173	1713332	2005-08-02	2005-08-16	1	13011
50648	3444	1125315	2019-03-03	2019-03-17	1	17972
11339	775	738818	1982-09-05	1982-09-12	1	4637
49076	3342	1310149	2005-03-30	2005-03-30	1	12872
10670	732	738818	2009-06-04	2009-06-18	1	14413
50524	3439	1729720	1999-07-23	1999-07-30	1	10802
5774	398	1112807	1957-04-20	1957-05-18	1	-4611
4342	297	1125315	2010-02-12	2010-02-19	1	14659
59119	4026	1729720	2018-04-01	2018-04-13	1	17634
2693	180	19127890	1995-03-28	1996-03-22	1	9577
3470	232	1124957	1959-02-12	1959-02-12	1	-3976
77500	5298	1759842	1988-03-15	1988-03-29	1	6662
65422	4471	1713332	1986-04-24	1986-05-15	1	5978
9639	665	1125315	1993-01-08	1993-01-22	2	8422
59463	4052	1125315	1985-07-20	1985-08-03	1	5693
37770	2566	1713332	2007-03-17	2007-03-24	1	13596
58712	4005	1119510	1973-04-10	1973-04-17	1	1202
52560	3579	1125315	1968-09-10	1968-09-24	1	-464
54846	3730	1125315	2011-06-06	2011-07-11	1	15166
20399	1387	933724	2013-07-18	2013-07-25	1	15911
43085	2914	738818	1962-09-26	1962-10-10	1	-2640
67402	4602	1125315	2015-07-16	2015-07-30	1	16646
72066	4924	1515774	1993-12-04	1994-11-29	1	9098
4100	279	1112807	1954-03-02	1954-03-16	1	-5770
52390	3569	1521369	1982-09-09	1983-09-04	1	4994
47641	3234	1177480	1980-04-06	1980-04-28	1	3770
60471	4122	1729720	2013-06-23	2013-07-05	1	15891
45273	3072	1115008	1995-11-27	1995-12-27	1	9491
42554	2883	1118084	2002-06-06	2002-06-06	1	11844
57101	3891	1112807	1986-11-03	1987-01-02	1	6210
22461	1528	1759842	2018-10-14	2018-10-28	1	17832
14615	1005	1154343	1970-02-27	1986-07-22	1	6046
53390	3636	19127890	1989-07-02	1990-06-27	1	7482
17950	1236	1112807	1932-01-28	1932-02-11	1	-13839
49051	3339	1759842	1978-09-30	1978-10-14	1	3208
6924	479	1125315	1957-04-13	1957-04-27	1	-4632
2343	156	738818	2005-06-23	2005-06-30	1	12964
72020	4922	920293	2000-09-07	2000-09-14	1	11214
51509	3510	1125315	1951-02-12	1951-04-13	1	-6838
2611	173	1729720	1976-10-23	1976-11-03	1	2498
52344	3566	1119510	1965-09-08	1965-09-22	1	-1562
11340	775	920293	1966-12-13	1966-12-20	1	-1108
49077	3342	1729720	1914-03-17	1914-03-30	1	-20366
10671	732	1124300	2015-11-19	2015-11-19	1	16758
50525	3439	1759842	1984-12-09	1984-12-16	1	5463
5775	398	1118084	1962-03-08	1962-03-08	1	-2856
4343	297	1729720	1989-07-20	1989-08-02	1	7153
59120	4026	1112807	1960-10-12	1960-10-26	1	-3354
2694	180	1118084	2012-09-29	2012-09-29	1	15612
3471	232	1125315	1977-04-14	1977-04-28	1	2674
77501	5298	1119510	1942-03-20	1942-04-03	1	-10135
9640	665	1713332	1964-07-08	1964-07-15	1	-1996
59464	4052	1125315	1986-12-19	1987-01-02	1	6210
37771	2566	1759842	2003-04-16	2003-04-30	1	12172
58713	4005	1125315	1990-05-01	1990-05-08	1	7432
52561	3579	1125315	2017-07-22	2017-07-29	1	17376
54847	3730	1713332	1965-10-04	1965-10-18	1	-1536
20400	1387	1124300	2008-10-13	2008-10-13	1	14165
43086	2914	933724	1979-11-10	1979-11-17	1	3607
67403	4602	1713332	1996-12-11	1996-12-25	1	9855
72067	4924	19127890	1995-11-24	1996-11-18	1	9818
4101	279	1112807	1968-10-01	1968-10-15	1	-443
52391	3569	1557272	2018-12-11	2018-12-11	1	17876
47642	3234	1361711	1955-05-03	2010-01-19	1	14628
61593	4204	1115008	1994-05-16	1994-06-20	1	8936
45274	3072	1118084	2003-05-23	2003-05-23	1	12195
42555	2883	1125315	1981-05-08	1981-05-15	1	4152
57102	3891	1124300	2019-06-03	2019-06-03	1	18050
22462	1528	1112807	1960-03-04	1960-03-18	1	-3576
14616	1005	1177480	1989-02-25	1989-05-03	1	7062
53630	3650	738818	1992-02-28	1992-03-13	1	8107
17951	1236	1112807	1939-10-16	1939-11-22	1	-10998
49052	3339	1759842	2011-08-07	2011-08-28	1	15214
6925	479	1125315	1984-08-09	1984-08-23	1	5348
2344	156	1118084	2019-01-30	2019-01-30	1	17926
72021	4922	933724	2002-10-14	2002-10-21	1	11981
51510	3510	1125315	1975-08-05	1975-08-19	1	2056
3283	219	1125315	1968-08-28	1968-09-11	1	-477
52345	3566	1124300	1988-06-23	1988-06-23	1	6748
11341	775	933724	1966-12-13	1966-12-20	1	-1108
49078	3342	1759842	1913-03-19	1913-04-09	1	-20721
10672	732	1125315	1984-05-11	1984-05-25	1	5258
50526	3439	1112807	1957-01-30	1957-02-13	1	-4705
5776	398	1124957	1957-04-20	1957-04-20	1	-4639
4344	297	1759842	2018-11-26	2018-12-17	1	17882
59121	4026	1118084	1998-02-05	1998-02-05	1	10262
2695	180	1125315	1981-11-09	1981-11-23	1	4344
3472	232	1713332	2014-08-01	2014-08-22	1	16304
77502	5298	1125315	2013-07-29	2013-08-05	1	15922
9641	665	1713332	1988-11-12	1988-11-19	1	6897
59465	4052	19127890	1993-03-27	1994-03-22	1	8846
37772	2566	1759842	2007-03-17	2007-03-24	1	13596
58714	4005	1177480	1999-03-14	1999-04-04	1	10685
52562	3579	1521369	1981-10-12	1982-10-07	1	4662
54848	3730	1125315	1980-04-14	1980-05-19	1	3791
20401	1387	1125315	1989-03-19	1989-03-26	1	7024
43087	2914	1112807	1959-09-01	1959-09-15	1	-3761
67404	4602	1729720	1985-12-26	1986-01-07	1	5850
72068	4924	1112807	1991-06-02	1991-06-23	1	7843
4102	279	1118084	1991-05-09	1991-05-09	1	7798
52392	3569	1118084	1999-09-10	1999-09-10	1	10844
48991	3335	1125315	1975-05-12	1975-05-26	1	1971
61594	4204	1119510	1950-09-15	1950-09-29	1	-7034
45275	3072	1125315	2008-01-23	2008-02-13	1	13922
42556	2883	1503184	1982-02-01	1983-01-27	1	4774
57103	3891	1713332	1984-04-23	1984-05-07	1	5240
22463	1528	1125315	1971-03-31	1971-04-07	1	461
14617	1005	1503184	1982-02-12	1983-02-07	1	4785
53631	3650	1112807	1931-06-04	1931-06-18	1	-14077
17952	1236	1125315	1978-11-02	1978-11-16	1	3241
49053	3339	1112807	1963-01-25	1963-02-08	1	-2519
6926	479	1728416	1957-04-13	1957-04-27	1	-4632
2345	156	1515774	1997-09-22	1998-09-17	1	10486
72022	4922	1124300	2013-06-15	2013-06-15	1	15871
51511	3510	1713332	1973-04-18	1973-04-25	1	1210
3284	219	1125315	1979-07-15	1979-08-19	1	3517
52346	3566	1125315	1957-03-21	1957-04-04	1	-4655
11342	775	1112807	1947-05-03	1947-06-02	1	-8249
49079	3342	1759842	1936-12-22	1937-01-12	1	-12042
10673	732	1125315	2009-06-04	2009-06-18	1	14413
50527	3439	1112807	1969-02-20	1969-04-21	1	-255
5777	398	1125315	1948-02-13	1948-02-27	1	-7979
4345	297	933724	1995-07-02	1995-07-09	1	9320
59122	4026	1119510	1981-07-30	1981-08-06	1	4235
2696	180	1177480	1979-03-12	1979-04-11	1	3387
3473	232	1728416	1953-08-30	1953-09-20	1	-5947
77503	5298	701322	2013-06-13	2013-06-13	1	15869
9642	665	1759842	1988-11-12	1988-11-19	1	6897
59466	4052	975125	1979-06-15	1979-07-06	1	3473
37773	2566	1112807	1942-03-27	1942-04-10	1	-10128
58715	4005	1729720	2013-09-08	2013-09-19	1	15967
52563	3579	1112807	1965-10-26	1965-11-16	1	-1507
54849	3730	1713332	2004-10-03	2004-10-10	1	12701
20402	1387	1503184	1986-03-20	1987-03-15	1	6282
43088	2914	1118084	1997-03-09	1997-03-09	1	9929
67405	4602	1124300	2011-05-21	2011-05-21	1	15115
72069	4924	1119510	2011-05-29	2011-06-05	1	15130
4103	279	1125315	1967-03-18	1967-04-01	1	-1006
52393	3569	1125315	1977-01-14	1977-01-28	1	2584
48992	3335	1125315	1986-04-10	1986-06-09	1	6003
61595	4204	1728416	1952-12-01	1952-12-15	1	-6226
45276	3072	1125315	1960-08-11	1960-08-25	1	-3416
42557	2883	1119510	1981-05-08	1981-05-15	1	4152
57104	3891	1759842	1998-08-09	1998-08-30	1	10468
22464	1528	1125315	2009-05-14	2009-05-28	1	14392
14618	1005	1713332	2004-07-12	2004-08-09	1	12639
53632	3650	1112807	1940-11-04	1940-12-04	1	-10620
17953	1236	1125315	2017-07-22	2017-08-05	1	17383
49054	3339	1124300	1995-11-23	1995-11-23	1	9457
6927	479	1728416	1959-11-11	1959-11-25	1	-3690
2346	156	1549786	1997-09-22	1998-09-17	1	10486
72023	4922	1125315	1977-12-26	1978-01-09	1	2930
51512	3510	738818	1983-01-22	1983-02-05	1	4783
3285	219	1149380	1971-04-06	1971-04-06	1	460
52347	3566	1759842	1955-04-01	1955-04-15	1	-5375
11343	775	1112807	1948-03-28	1948-04-25	1	-7921
49080	3342	1759842	2002-11-09	2003-03-08	1	12119
10674	732	1729720	2008-08-09	2008-08-18	1	14109
50528	3439	1125315	1970-02-22	1970-03-01	1	59
5778	398	1361711	1947-12-06	1967-02-11	1	-1055
4346	297	1118084	1993-08-25	1993-08-25	1	8637
59123	4026	1125315	1961-04-01	1961-04-15	1	-3183
2697	180	1521369	1997-03-17	2000-03-01	3	11017
3474	232	1112807	1958-02-26	1958-03-12	1	-4313
77504	5298	1112807	1975-12-21	1976-01-18	1	2208
9643	665	1118084	1993-08-10	1993-08-10	1	8622
59467	4052	1112807	1978-06-04	1978-06-18	1	3090
37774	2566	1118084	1978-12-03	1978-12-03	1	3258
58716	4005	1759842	1971-08-16	1971-08-23	1	599
52564	3579	1124300	1997-09-08	1997-09-08	1	10112
54850	3730	1713332	2011-06-06	2011-07-11	1	15166
20403	1387	705944	1981-03-29	1987-01-25	1	6233
43089	2914	1125315	1958-06-17	1958-07-01	1	-4202
67406	4602	1125315	1996-04-30	1996-05-07	1	9623
72070	4924	1177480	2013-03-13	2013-04-17	1	15812
4104	279	1125315	1971-02-06	1971-02-13	1	408
52394	3569	1125315	2011-07-15	2011-07-22	1	15177
48993	3335	1177480	2005-03-31	2005-04-28	1	12901
61596	4204	1112807	1952-12-01	1952-12-15	1	-6226
45277	3072	1713332	1986-02-28	1986-03-14	1	5916
42558	2883	1713332	1965-05-27	1965-06-03	1	-1673
57315	3909	1125315	1964-09-03	1964-09-17	1	-1932
22465	1528	1125315	2012-03-13	2012-04-10	1	15440
14619	1005	19127890	1987-01-17	1989-01-06	2	6945
53633	3650	1125315	1968-09-18	1968-10-02	1	-456
17954	1236	1759842	1950-08-23	1950-09-06	1	-7057
49055	3339	1125315	2012-09-13	2012-09-27	1	15610
6928	479	1759842	2003-12-19	2003-12-26	1	12412
2347	156	1713332	1981-12-11	1981-12-18	1	4369
72024	4922	1549786	1990-07-31	1991-07-26	1	7876
51513	3510	1125315	1960-03-31	1960-04-14	1	-3549
3286	219	740275	1977-03-26	1979-06-30	1	3467
52348	3566	1125315	1977-02-23	1977-03-02	1	2617
11344	775	1125315	1959-07-01	1959-07-08	1	-3830
49081	3342	920293	1932-07-30	1932-08-06	1	-13662
10675	732	19127890	1989-03-25	1990-03-20	1	7383
50529	3439	1125315	2009-02-20	2009-03-20	1	14323
5779	398	1728416	1957-04-20	1957-05-18	1	-4611
4347	297	1125315	1953-01-09	1953-01-23	1	-6187
59124	4026	1125315	1962-11-01	1962-12-01	1	-2588
2698	180	1521369	2001-02-24	2003-02-14	2	12097
3475	232	1115008	2016-03-05	2016-06-03	1	16955
77505	5298	1119510	1993-03-07	1993-03-14	1	8473
9644	665	1125315	1966-12-30	1967-03-30	1	-1008
59468	4052	1129625	1977-12-04	1977-12-04	1	2894
37775	2566	1125315	2012-01-07	2012-02-11	1	15381
58717	4005	738818	1973-04-10	1973-04-17	1	1202
52565	3579	1125315	1990-02-19	1990-03-05	1	7368
54851	3730	1759842	1965-10-04	1965-10-18	1	-1536
20404	1387	738818	2000-08-26	2000-09-02	1	11202
43090	2914	1125315	1962-09-26	1962-10-10	1	-2640
67407	4602	1713332	1983-09-10	1983-09-24	1	5014
72071	4924	1549786	1993-12-04	1994-11-29	1	9098
4105	279	1125315	1997-03-03	1997-03-10	1	9930
52395	3569	1125315	2015-08-13	2015-08-27	1	16674
48994	3335	1713332	1990-01-11	1990-02-22	1	7357
61597	4204	1125315	1972-04-20	1972-05-11	1	861
45278	3072	1728416	1960-08-11	1960-08-25	1	-3416
42559	2883	1119510	1994-03-14	1994-03-28	1	8852
57316	3909	1125315	1995-06-08	1995-06-15	1	9296
23222	1576	1118084	2007-04-15	2007-04-15	1	13618
14620	1005	1149380	1970-02-27	1986-07-22	1	6046
53634	3650	1125315	1992-02-28	1992-03-13	1	8107
23851	1613	1118084	1992-06-19	1992-06-19	1	8205
49056	3339	1713332	1971-01-19	1971-02-02	1	397
6929	479	738818	2009-06-18	2009-07-02	1	14427
4919	335	738818	1986-10-25	1986-11-08	1	6155
72025	4922	1729720	2013-01-04	2013-01-14	1	15719
51514	3510	1125315	1983-01-22	1983-02-05	1	4783
3287	219	1125315	1975-10-06	1975-10-20	1	2118
52349	3566	1125315	1996-02-14	1996-03-06	1	9561
11345	775	1125315	1982-09-05	1982-09-12	1	4637
49082	3342	1119510	1938-11-26	1938-12-10	1	-11345
10676	732	1125315	1988-12-27	1989-01-10	1	6949
50530	3439	1326303	2015-12-10	2015-12-10	1	16779
5780	398	1112807	1941-08-30	1941-09-20	1	-10330
4348	297	1713332	2014-01-08	2014-01-15	1	16085
59125	4026	1125315	2003-01-20	2003-01-27	1	12079
2699	180	1729720	1983-09-28	1983-10-06	1	5026
3476	232	1125315	1988-11-06	1988-11-27	1	6905
77506	5298	1125315	1963-10-10	1963-10-24	1	-2261
9645	665	1125315	2011-08-23	2011-09-06	1	15223
59469	4052	1503184	1997-03-06	1998-03-01	1	10286
37776	2566	1729720	1947-10-24	1947-10-31	1	-8098
58718	4005	1125315	1973-04-10	1973-04-17	1	1202
52566	3579	1177480	2004-11-12	2004-12-03	1	12755
57130	3895	1112807	1953-06-30	1953-07-30	1	-5999
20405	1387	920293	2013-07-18	2013-07-25	1	15911
43091	2914	1125315	1972-12-25	1973-01-08	1	1103
67408	4602	1759842	1983-09-10	1983-09-24	1	5014
72072	4924	1549786	1995-11-24	1996-11-18	1	9818
4106	279	1125315	1998-04-05	1998-04-19	1	10335
52396	3569	1521369	1986-08-19	1989-08-03	3	7154
48995	3335	1713332	1997-11-18	1997-12-09	1	10204
61598	4204	1125315	1993-03-18	1993-04-01	1	8491
45279	3072	1125315	1983-03-15	1983-03-22	1	4828
42560	2883	1125315	1966-01-16	1966-01-30	1	-1432
57317	3909	1717327	1962-08-21	1962-09-04	1	-2676
23223	1576	1124957	1982-02-20	1982-02-20	1	4433
14621	1005	1503184	1987-01-17	1989-01-06	2	6945
53635	3650	1177480	1984-12-13	1985-01-19	1	5497
23852	1613	1125315	1959-12-17	1959-12-24	1	-3661
49057	3339	1713332	2011-08-07	2011-08-28	1	15214
6930	479	1125315	1944-02-29	1944-03-14	1	-9424
4920	335	1125315	1986-03-21	1986-03-28	1	5930
72026	4922	1125315	2007-08-01	2007-08-08	1	13733
51515	3510	1125315	1997-08-06	1997-08-20	1	10093
3288	219	1125315	1991-11-27	1991-12-11	1	8014
52350	3566	1177480	1975-10-27	1975-12-01	1	2160
11346	775	1347450	2017-03-15	2017-03-15	1	17240
49083	3342	1125315	1952-11-13	1952-11-20	1	-6251
10677	732	1549786	1989-03-25	1990-03-20	1	7383
50531	3439	1713332	2000-10-03	2000-10-17	1	11247
5781	398	1112807	1966-08-29	1966-09-26	1	-1193
4349	297	1759842	2014-01-08	2014-01-15	1	16085
59126	4026	1154343	1960-02-02	1960-02-02	1	-3621
2700	180	933724	1997-05-18	1997-05-25	1	10006
3477	232	1728416	1948-11-10	1948-11-24	1	-7708
77507	5298	1177480	2003-11-27	2003-12-11	1	12397
9646	665	1174888	1993-01-08	1993-01-08	1	8408
59470	4052	1521369	1997-03-06	1998-03-01	1	10286
37777	2566	1759842	1980-02-10	1980-03-02	1	3713
58719	4005	1759842	1978-12-22	1978-12-29	1	3284
52567	3579	1503184	1981-10-12	1982-10-07	1	4662
57131	3895	1125315	1933-09-14	1933-09-28	1	-13244
20406	1387	933724	2013-04-21	2013-05-05	1	15830
43092	2914	1728416	1958-06-17	1958-07-01	1	-4202
67409	4602	705944	1987-05-07	1989-03-02	1	7000
72073	4924	1729720	2002-02-09	2002-02-18	1	11736
4107	279	1713332	2001-12-13	2001-12-27	1	11683
52397	3569	19127890	1979-09-25	1980-09-19	1	3914
48996	3335	1759842	1990-01-11	1990-02-22	1	7357
61599	4204	1759842	2017-02-07	2017-02-21	1	17218
45280	3072	1713332	2013-08-22	2013-09-05	1	15953
42561	2883	1125315	1970-01-27	1970-02-03	1	33
57318	3909	19127890	1977-08-04	1978-07-30	1	3132
23224	1576	1125315	1983-12-17	1984-02-15	1	5158
14622	1005	19127890	1982-02-12	1983-02-07	1	4785
53636	3650	1177480	1986-12-10	1986-12-24	1	6201
23853	1613	19127890	1974-04-10	1976-03-30	2	2280
49058	3339	738818	1993-06-17	1993-06-24	1	8575
6931	479	1125315	2009-06-18	2009-07-02	1	14427
4921	335	1125315	1986-10-25	1986-11-08	1	6155
72027	4922	19127890	1990-07-31	1991-07-26	1	7876
51516	3510	1729720	1996-05-19	1996-05-31	1	9647
3289	219	1118084	2005-11-01	2005-11-01	1	13088
52351	3566	1713332	1955-04-01	1955-04-15	1	-5375
11347	775	1125315	1962-07-23	1962-08-06	1	-2705
49084	3342	1125315	1977-08-13	1977-08-20	1	2788
10678	732	1713332	2010-11-05	2010-11-12	1	14925
50532	3439	1759842	1977-02-28	1977-03-14	1	2629
5782	398	1125315	1927-08-23	1927-08-30	1	-15465
5148	351	738818	2017-11-17	2017-12-01	1	17501
59127	4026	1174888	1970-07-22	1970-07-22	1	202
2701	180	1119510	1999-06-27	1999-07-04	1	10776
3478	232	1112807	1947-08-18	1947-09-01	1	-8158
77787	5316	1118084	1995-05-23	1995-05-23	1	9273
9647	665	1713332	2006-07-05	2006-07-19	1	13348
59471	4052	1549786	1993-03-27	1994-03-22	1	8846
39268	2672	1112807	1956-05-28	1956-06-11	1	-4952
58720	4005	1125315	1971-02-12	1971-02-19	1	414
52568	3579	914335	2006-05-20	2006-05-20	1	13288
57132	3895	1125315	1963-07-29	1963-08-05	1	-2341
20407	1387	1119510	2000-08-26	2000-09-02	1	11202
45132	3064	1112807	1962-05-24	1962-06-07	1	-2765
67410	4602	1119510	2015-07-16	2015-07-30	1	16646
72074	4924	975125	1980-04-11	1980-05-02	1	3774
4108	279	1713332	2018-09-16	2018-09-30	1	17804
52398	3569	1125315	1995-06-02	1995-06-16	1	9297
48997	3335	1759842	1997-11-18	1997-12-09	1	10204
61600	4204	1112807	1954-07-20	1954-08-03	1	-5630
45281	3072	1759842	2013-08-22	2013-09-05	1	15953
42562	2883	1521369	1982-02-01	1983-01-27	1	4774
57319	3909	1112807	1961-10-17	1961-10-31	1	-2984
23225	1576	19127890	1982-10-05	1983-09-30	1	5020
15620	1083	1112807	1967-05-14	1967-06-18	1	-928
53637	3650	1322184	2014-07-04	2014-07-04	1	16255
23854	1613	738818	1962-07-02	1962-07-09	1	-2733
49059	3339	1125315	1961-08-03	1961-09-07	1	-3038
10754	739	1112807	1910-09-30	1910-10-14	1	-21629
4922	335	1125315	1978-04-23	1978-04-30	1	3041
72028	4922	920293	2002-10-14	2002-10-21	1	11981
51517	3510	1759842	1973-04-18	1973-04-25	1	1210
3290	219	1125315	1974-11-24	1974-12-08	1	1802
52352	3566	738818	1965-09-08	1965-09-22	1	-1562
13529	925	1115008	2008-07-02	2008-07-23	1	14083
49085	3342	1125315	1997-02-01	1997-02-08	1	9900
10679	732	1759842	2010-11-05	2010-11-12	1	14925
50533	3439	1119510	1972-06-20	1972-07-04	1	915
5783	398	1729720	1940-04-08	1940-04-18	1	-10850
5149	351	1118084	2018-06-07	2018-06-07	1	17689
59128	4026	1759842	1960-07-19	1960-08-09	1	-3432
2702	180	1125315	1977-12-17	1977-12-31	1	2921
3479	232	1729720	2007-11-11	2007-11-20	1	13837
77788	5316	1125315	1957-08-15	1957-08-29	1	-4508
9648	665	1759842	2013-06-02	2013-06-23	1	15879
59472	4052	1713332	1979-05-19	1979-06-02	1	3439
39269	2672	1112807	1972-02-18	1972-03-10	1	799
58721	4005	1125315	1971-05-12	1971-05-26	1	510
52569	3579	1102527	1996-04-28	1996-04-28	1	9614
57133	3895	1125315	1974-04-02	1974-04-16	1	1566
20408	1387	1125315	2000-08-26	2000-09-02	1	11202
45133	3064	1112807	1971-10-18	1971-12-17	1	715
67411	4602	1759842	1996-12-11	1996-12-25	1	9855
72075	4924	1124300	2014-01-19	2014-01-19	1	16089
4109	279	1728416	1956-07-25	1956-08-08	1	-4894
52399	3569	1125315	2005-07-04	2005-07-11	1	12975
48998	3335	1118084	2011-01-01	2011-01-01	1	14975
61601	4204	1118084	1988-10-23	1988-10-23	1	6870
45282	3072	1125315	1975-10-22	1975-11-12	1	2141
42563	2883	1713332	1985-11-22	1985-12-13	1	5825
57320	3909	1112807	1967-02-02	1967-02-16	1	-1050
23226	1576	1125315	1982-02-20	1982-03-27	2	4468
15621	1083	1119510	2016-03-20	2016-03-27	1	16887
53638	3650	1729720	1938-05-31	1938-06-10	1	-11528
23855	1613	920293	1990-06-04	1990-06-11	1	7466
49060	3339	1125315	1987-06-23	1987-07-07	1	6396
10755	739	1112807	1935-06-21	1935-09-19	1	-12523
4923	335	1125315	1990-07-01	1990-07-22	1	7507
72029	4922	1125315	2011-12-05	2011-12-26	1	15334
54186	3686	738818	1991-11-29	1991-12-06	1	8009
3291	219	1125315	1985-06-18	1985-07-18	1	5677
52353	3566	1125315	1954-06-07	1954-07-05	1	-5659
13530	925	1177480	2005-06-18	2005-08-17	1	13012
49086	3342	1713332	1913-03-19	1913-04-09	1	-20721
13369	917	738818	1990-04-16	1990-04-23	1	7417
50534	3439	1125315	1964-12-08	1965-01-12	1	-1815
7937	552	738818	1969-07-17	1969-07-31	1	-154
5150	351	1119510	1985-02-28	1985-03-14	1	5551
59361	4044	1119510	1975-01-19	1975-02-02	1	1858
2703	180	1521369	1995-03-28	1996-03-22	1	9577
3480	232	1759842	2014-08-01	2014-08-22	1	16304
77789	5316	1125315	1958-10-23	1958-11-06	1	-4074
9649	665	1112807	1992-02-22	1992-03-14	1	8108
64333	4393	738818	2011-12-20	2011-12-27	1	15335
39270	2672	1118084	1995-03-05	1995-03-05	1	9194
58722	4005	1125315	1981-05-03	1981-06-02	1	4170
52570	3579	1112807	1969-12-25	1970-01-08	1	7
57134	3895	1713332	1952-07-18	1952-08-01	1	-6362
20409	1387	1713332	2001-12-09	2002-01-06	1	11693
45134	3064	1177480	1990-07-01	1990-07-15	1	7500
68876	4700	1112807	1953-01-11	1953-01-25	1	-6185
72076	4924	1729720	1980-03-07	1980-03-17	1	3728
7351	507	738818	1944-01-21	1944-01-28	1	-9470
52400	3569	1503184	1986-08-19	1989-08-03	3	7154
48999	3335	1177480	1984-01-23	1984-02-20	1	5163
61602	4204	1125315	2006-07-17	2006-07-31	1	13360
45283	3072	1309944	1964-02-01	1964-02-01	1	-2161
42564	2883	1759842	1985-11-22	1985-12-13	1	5825
57321	3909	1119510	1995-06-08	1995-06-15	1	9296
23227	1576	1125315	2009-11-27	2009-12-04	1	14582
15622	1083	1125315	1987-10-28	1987-11-04	1	6516
53639	3650	1729720	1961-09-18	1961-09-25	1	-3020
23856	1613	933724	1990-06-04	1990-06-11	1	7466
49061	3339	1713332	1978-09-30	1978-10-14	1	3208
10756	739	1119510	1937-06-17	1937-07-01	1	-11872
4924	335	1125315	2005-12-15	2005-12-22	1	13139
72030	4922	1125315	2013-11-16	2013-11-16	1	16025
54187	3686	1125315	1972-09-25	1972-10-09	1	1012
3292	219	723013	1975-10-25	1977-12-24	1	2914
52354	3566	1125315	1965-09-08	1965-09-22	1	-1562
13531	925	1728416	1973-07-27	1973-08-10	1	1317
49087	3342	1713332	1936-12-22	1937-01-12	1	-12042
13370	917	1102527	1977-07-31	1977-07-31	1	2768
50535	3439	1125315	1967-01-02	1967-01-02	1	-1095
7938	552	920293	1982-10-14	1982-10-21	1	4676
5151	351	1125315	1985-10-18	1985-11-01	1	5783
59362	4044	1125315	2004-03-12	2004-03-19	1	12496
2704	180	1549786	1992-04-12	1993-04-07	1	8497
6811	471	738818	1997-10-28	1997-11-11	1	10176
77790	5316	1728416	1957-08-15	1957-08-29	1	-4508
9650	665	1119510	2006-07-31	2006-08-07	1	13367
64334	4393	1125315	1987-10-30	1988-01-28	1	6601
39271	2672	1177480	1999-11-14	1999-12-12	1	10937
58723	4005	1713332	1971-08-16	1971-08-23	1	599
52571	3579	1119510	1990-02-19	1990-03-05	1	7368
57135	3895	1729720	1946-02-19	1946-03-02	1	-8706
20410	1387	19127890	1986-03-20	1987-03-15	1	6282
45135	3064	1177480	1997-01-30	1997-03-06	1	9926
68877	4700	1112807	1952-03-17	1952-04-07	1	-6478
72077	4924	1729720	1985-05-24	1985-06-01	1	5630
7352	507	1112807	1943-06-24	1943-07-08	1	-9674
52401	3569	19127890	1982-09-09	1983-09-04	1	4994
49000	3335	1102527	2013-02-15	2013-02-15	1	15751
61603	4204	1713332	2017-02-07	2017-02-21	1	17218
45284	3072	1343916	1964-02-01	1964-02-01	1	-2161
44214	2991	1125315	1968-02-22	1968-03-07	1	-665
57322	3909	1503184	1977-08-04	1978-07-30	1	3132
23228	1576	19127890	1984-09-24	1985-09-19	1	5740
15623	1083	19127890	1984-04-24	1985-04-19	1	5587
53640	3650	738818	2002-06-08	2002-06-22	1	11860
23857	1613	1112807	1958-01-07	1958-01-21	1	-4363
49062	3339	1717327	1970-02-10	1970-02-24	1	54
10757	739	1177480	1975-08-20	1975-09-19	1	2087
4925	335	1177480	2012-07-26	2012-08-23	1	15575
72031	4922	1515774	1990-07-31	1991-07-26	1	7876
54188	3686	1125315	1991-11-29	1991-12-06	1	8009
3293	219	740275	1974-03-29	1974-06-07	1	1618
52355	3566	1125315	1992-01-01	1992-01-15	1	8049
13532	925	1124300	2005-01-09	2005-01-09	1	12792
49088	3342	1713332	1947-09-29	1947-10-20	1	-8109
13371	917	1119510	1996-11-18	1996-12-02	1	9832
50536	3439	1125315	1988-04-26	1988-05-03	1	6697
7939	552	933724	1982-10-14	1982-10-21	1	4676
5152	351	1125315	1991-11-26	1991-12-10	1	8013
59363	4044	1112807	1965-08-05	1965-09-02	1	-1582
2705	180	1589505	2003-02-14	2004-02-09	1	12457
6812	471	1125315	1992-03-27	1992-04-24	1	8149
77791	5316	1728416	1960-11-16	1960-11-30	1	-3319
9651	665	1125315	1986-08-17	1986-09-21	1	6107
64335	4393	1125315	1995-10-20	1995-10-27	1	9430
39272	2672	1713332	1975-03-20	1975-03-27	1	1911
58724	4005	1713332	1986-04-08	1986-04-15	1	5948
52572	3579	1119510	2017-07-22	2017-07-29	1	17376
57136	3895	1112807	1925-08-26	1925-09-09	1	-16185
20781	1415	1125315	1988-09-15	1988-09-22	1	6839
45136	3064	1759842	1972-08-11	1972-09-01	1	974
68878	4700	1118084	1990-10-24	1990-10-24	1	7601
72078	4924	19127890	1993-12-04	1994-11-29	1	9098
7353	507	1112807	1946-11-05	1946-11-19	1	-8444
52402	3569	1125315	1972-07-25	1972-08-01	1	943
49001	3335	1115008	2013-02-15	2013-03-01	1	15765
61604	4204	1729720	1955-12-20	1956-01-02	1	-5113
45285	3072	1759842	1986-02-28	1986-03-14	1	5916
44215	2991	738818	1968-02-22	1968-03-07	1	-665
57323	3909	1759842	1977-02-21	1977-03-07	1	2622
23229	1576	1503184	1982-10-05	1983-09-30	1	5020
15624	1083	975125	1976-08-04	1976-08-25	1	2428
53641	3650	1119510	1931-03-08	1931-03-15	1	-14172
23858	1613	1119510	1987-10-28	1987-11-04	1	6516
52241	3559	1112807	1950-05-23	1950-06-06	1	-7149
10758	739	1125315	1987-10-16	1987-11-20	1	6532
4926	335	1713332	2006-11-03	2006-11-17	1	13469
72032	4922	1713332	2003-01-12	2003-02-02	1	12085
54189	3686	1125315	2013-02-15	2013-03-01	1	15765
3294	219	740275	1975-05-24	1975-08-02	1	2039
52356	3566	1125315	2005-07-31	2005-08-14	1	13009
13533	925	1125315	1982-01-21	1982-02-04	1	4417
49089	3342	1713332	2002-11-09	2003-03-08	1	12119
13372	917	1125315	1965-05-05	1965-05-19	1	-1688
50537	3439	1310149	2015-12-10	2015-12-10	1	16779
7940	552	1112807	1952-03-16	1952-03-30	1	-6486
5153	351	1125315	2017-11-17	2017-12-01	1	17501
59364	4044	1119510	2008-06-06	2008-06-13	1	14043
2706	180	1729720	1980-01-07	1980-01-16	1	3667
6813	471	1115008	2017-09-10	2017-10-01	1	17440
77792	5316	1112807	1960-11-16	1960-11-30	1	-3319
9652	665	1713332	1993-01-08	1993-01-22	1	8422
64336	4393	1125315	2011-12-20	2011-12-27	1	15335
39273	2672	1112807	1962-01-27	1962-02-10	1	-2882
58725	4005	1759842	1986-04-08	1986-04-15	1	5948
52573	3579	1309944	2006-05-20	2006-05-20	1	13288
57137	3895	1174888	1982-03-30	1982-03-30	1	4471
20782	1415	1125315	1995-01-27	1995-02-03	1	9164
45137	3064	738818	1993-12-29	1994-01-12	1	8777
68879	4700	1125315	1963-03-21	1963-04-04	1	-2464
76528	5232	1713332	1973-10-14	1973-10-28	1	1396
7354	507	1125315	1944-01-21	1944-01-28	1	-9470
52403	3569	1347450	1987-07-14	1987-07-14	1	6403
49002	3335	1125315	2014-05-27	2014-06-03	1	16224
61605	4204	738818	1950-09-15	1950-09-29	1	-7034
47516	3226	738818	2008-06-25	2008-07-02	1	14062
44216	2991	1125315	1990-12-14	1990-12-28	1	7666
57324	3909	738818	1995-06-08	1995-06-15	1	9296
23230	1576	1503184	1984-09-24	1985-09-19	1	5740
15625	1083	975125	1982-02-28	1982-03-14	1	4455
53642	3650	1124300	1964-08-09	1964-08-09	1	-1971
23859	1613	1125315	1961-01-27	1961-02-03	1	-3254
52242	3559	1125315	1951-06-17	1951-07-01	1	-6759
10759	739	1125315	1988-10-15	1988-10-29	1	6876
4927	335	1759842	2006-11-03	2006-11-17	1	13469
72033	4922	1729720	1981-08-11	1981-08-20	1	4249
54190	3686	1177480	2016-10-01	2016-10-29	1	17103
3295	219	1125315	1987-08-07	1987-09-11	1	6462
52357	3566	1192710	1953-08-12	1953-08-12	1	-5986
13534	925	1125315	2007-04-30	2007-05-14	1	13647
49090	3342	933724	1932-07-30	1932-08-06	1	-13662
13373	917	1125315	1967-11-10	1967-11-24	1	-769
50538	3439	1713332	1960-05-19	1960-06-02	1	-3500
7941	552	1125315	1962-01-23	1962-03-24	1	-2840
5154	351	1595799	2000-10-09	2001-10-04	1	11599
59365	4044	1125315	1961-12-25	1962-01-08	1	-2915
2948	194	1124300	2015-01-31	2015-01-31	1	16466
6814	471	1125315	1997-10-28	1997-11-11	1	10176
77793	5316	1119510	2014-12-10	2014-12-24	1	16428
9653	665	738818	2006-07-31	2006-08-07	1	13367
64337	4393	1729720	1990-12-30	1991-01-07	1	7676
39274	2672	1125315	1980-04-12	1980-04-26	1	3768
59433	4051	1112807	1979-04-15	1979-04-29	1	3405
52574	3579	1343916	2006-05-20	2006-05-20	1	13288
57138	3895	1713332	2019-03-13	2019-04-03	1	17989
20783	1415	1125315	2004-06-05	2004-07-05	2	12604
45138	3064	1112807	1936-08-28	1936-10-02	1	-12144
68880	4700	1728416	1953-01-11	1953-01-25	1	-6185
76529	5232	1729720	1989-04-14	1989-04-27	1	7056
7355	507	1729720	1949-01-27	1949-02-09	1	-7631
52404	3569	1503184	1982-09-09	1983-09-04	1	4994
49003	3335	1125315	1987-07-04	1987-08-03	1	6423
61606	4204	1125315	1950-09-15	1950-09-29	1	-7034
47517	3226	1112807	1971-02-23	1971-03-09	1	432
44217	2991	1125315	1996-04-14	1996-04-21	1	9607
57325	3909	1125315	1997-12-03	1997-12-10	1	10205
23231	1576	1521369	1984-09-24	1985-09-19	1	5740
15626	1083	1503184	1984-04-24	1985-04-19	1	5587
53643	3650	1125315	1955-09-30	1955-10-14	1	-5193
23860	1613	1125315	1962-07-02	1962-07-09	1	-2733
52243	3559	1125315	1975-11-13	1975-12-11	1	2170
10760	739	1112807	1914-04-27	1914-05-11	1	-20324
4928	335	1119510	1986-10-25	1986-11-08	1	6155
72034	4922	1738521	1977-12-26	1978-01-09	1	2930
54191	3686	1729720	1980-01-17	1980-01-26	1	3677
3296	219	1154343	1971-04-06	1971-04-06	1	460
52358	3566	1729720	1986-05-20	1986-05-30	1	5993
13535	925	1177480	2018-02-01	2018-03-03	1	17593
49091	3342	1112807	1910-02-02	1910-02-16	1	-21869
13374	917	1125315	1990-04-16	1990-04-23	1	7417
50539	3439	1713332	2003-01-14	2003-01-28	1	12080
7942	552	1125315	1969-07-17	1969-07-31	1	-154
5155	351	19127890	1996-10-30	1997-10-25	1	10159
59366	4044	1124300	1993-06-19	1993-06-19	1	8570
2949	194	1125315	1981-06-13	1981-06-27	1	4195
6815	471	1309944	1990-04-06	1990-04-06	1	7400
77794	5316	1729720	1957-07-17	1957-07-28	1	-4540
9654	665	1125315	1995-08-02	1995-08-16	1	9358
64338	4393	1759842	2004-05-07	2004-05-28	1	12566
39275	2672	1177480	2005-08-12	2005-09-02	1	13028
59434	4051	1125315	1975-08-09	1975-08-23	1	2060
52575	3579	1738521	1968-09-10	1968-09-24	1	-464
57139	3895	1738521	1982-03-30	1982-04-27	1	4499
20784	1415	1713332	1974-05-07	1974-05-21	1	1601
45139	3064	1112807	1941-04-25	1941-05-09	1	-10464
68881	4700	1125315	2015-03-13	2015-03-20	1	16514
76530	5232	1112807	1972-06-12	1972-09-10	1	983
7356	507	757627	2010-09-17	2010-09-17	1	14869
52405	3569	1521369	1979-09-25	1980-09-19	1	3914
49004	3335	1713332	1985-08-20	1985-08-27	1	5717
61607	4204	1125315	2015-05-19	2015-06-02	1	16588
47518	3226	1119510	1982-01-28	1982-02-11	1	4424
44218	2991	1177480	2018-10-01	2018-10-15	1	17819
57326	3909	1738521	1967-02-02	1967-02-16	1	-1050
23232	1576	1713332	1982-02-20	1982-03-27	1	4468
15627	1083	738818	2016-03-20	2016-03-27	1	16887
53644	3650	1125315	1977-01-29	1977-02-12	1	2599
23861	1613	1177480	2002-03-04	2002-03-18	1	11764
52244	3559	1125315	1995-09-18	1995-11-17	1	9451
10761	739	1118084	1947-12-15	1947-12-15	1	-8053
4929	335	1125315	1973-03-27	1973-04-10	1	1195
74265	5078	1115008	1998-09-27	1998-10-18	1	10517
54192	3686	1759842	1983-05-13	1983-05-20	1	4887
3880	264	1125315	1975-10-15	1975-11-05	1	2134
55091	3748	1125315	2015-12-28	2016-01-11	1	16811
13536	925	1738521	1971-05-18	1971-06-01	1	516
49092	3342	1112807	1924-08-08	1924-08-29	1	-16561
13375	917	1738521	1977-07-31	1977-09-04	1	2803
50540	3439	1729720	1983-06-06	1983-06-19	1	4917
7943	552	1713332	1952-05-17	1952-05-31	1	-6424
5156	351	19127890	1998-10-20	1999-10-15	1	10879
59367	4044	1125315	1971-03-18	1971-03-25	1	448
2950	194	1729720	1991-11-11	1991-11-19	1	7992
6816	471	1343916	1990-04-06	1990-04-06	1	7400
77795	5316	738818	2014-12-10	2014-12-24	1	16428
9655	665	1125315	2006-07-31	2006-08-07	1	13367
64339	4393	1115008	2016-08-28	2016-09-27	1	17071
39276	2672	1713332	1991-02-09	1991-03-02	1	7730
59435	4051	1177480	2018-07-20	2018-08-03	1	17746
52576	3579	19127890	1981-10-12	1982-10-07	1	4662
57140	3895	1759842	1947-04-03	1947-04-24	1	-8288
20785	1415	1713332	1987-06-05	1987-06-19	1	6378
45140	3064	1112807	1947-01-08	1947-01-29	1	-8373
68882	4700	1177480	1998-06-05	1998-06-19	1	10396
76531	5232	1124957	2016-09-19	2016-09-19	1	17063
7357	507	1125315	1994-08-04	1994-08-18	1	8995
52406	3569	19127890	1986-08-19	1989-08-03	3	7154
49005	3335	1713332	2013-02-15	2013-03-01	1	15765
61608	4204	1728416	1954-07-20	1954-08-03	1	-5630
47519	3226	1125315	2008-06-25	2008-07-02	1	14062
44219	2991	1119510	1968-02-22	1968-03-07	1	-665
57327	3909	1102527	2011-02-27	2011-02-27	1	15032
23233	1576	1713332	1986-03-01	1986-03-22	1	5924
15628	1083	1124300	2005-04-29	2005-04-29	1	12902
53645	3650	1125315	2002-06-08	2002-06-22	1	11860
23862	1613	1503184	1974-04-10	1976-03-30	2	2280
52245	3559	1102527	1995-09-18	1995-09-18	1	9391
10762	739	1125315	1923-06-26	1923-07-03	1	-16984
4930	335	1125315	1974-07-22	1974-08-05	1	1677
74266	5078	1118084	1945-06-06	1945-06-06	1	-8975
54193	3686	1119510	1991-11-29	1991-12-06	1	8009
3881	264	1125315	1978-06-15	1978-06-29	1	3101
55092	3748	1713332	1983-02-20	1983-03-06	1	4812
13537	925	1112807	1973-07-27	1973-08-10	1	1317
49093	3342	1112807	1968-07-14	1968-07-28	1	-522
13376	917	1759842	1967-03-02	1967-03-09	1	-1029
50541	3439	1759842	2003-01-14	2003-01-28	1	12080
7944	552	1713332	1975-04-02	1975-07-02	1	2008
5157	351	1713332	1984-08-03	1984-08-24	1	5349
59368	4044	1713332	1987-07-03	1987-07-24	1	6413
2951	194	1125315	1988-05-07	1988-05-21	1	6715
6817	471	1118084	2016-12-16	2016-12-16	1	17151
77796	5316	914335	1984-01-02	1984-01-02	1	5114
9656	665	1713332	2013-06-02	2013-06-23	1	15879
64340	4393	1118084	2019-03-01	2019-03-01	1	17956
39277	2672	1728416	1956-05-28	1956-06-11	1	-4952
59436	4051	1717327	1975-08-09	1975-08-23	1	2060
55319	3761	738818	2002-03-18	2002-04-01	1	11778
57141	3895	738818	2004-08-30	2004-09-13	1	12674
20786	1415	1125315	2005-05-31	2005-06-28	1	12962
45141	3064	1125315	1993-03-01	1993-03-22	1	8481
68883	4700	1729720	1958-01-03	1958-01-13	1	-4371
76532	5232	1125315	1969-01-29	1969-02-12	1	-323
7358	507	1125315	1999-07-24	1999-08-07	1	10810
55428	3771	1112807	1966-11-13	1966-12-11	1	-1117
49006	3335	1759842	1985-08-20	1985-08-27	1	5717
61609	4204	1729720	2010-12-15	2010-12-24	1	14967
47520	3226	1177480	1983-09-13	1983-09-27	1	5017
44220	2991	1125315	1989-09-12	1989-10-03	1	7215
57328	3909	1118084	1999-08-29	1999-08-29	1	10832
23234	1576	1729720	1980-03-19	1980-03-27	1	3738
15629	1083	1125315	2006-10-21	2006-11-19	2	13463
53646	3650	1177480	1992-05-26	1992-06-16	1	8202
23863	1613	1728416	1955-03-23	1955-04-06	1	-5384
52246	3559	1112807	1953-06-20	1953-07-20	1	-6009
10763	739	1125315	1927-10-11	1927-10-25	1	-15409
4931	335	1118084	2003-04-29	2003-04-29	1	12171
74267	5078	1125315	1988-05-31	1988-06-21	1	6746
54194	3686	1125315	1985-02-25	1985-03-04	1	5541
3882	264	1177480	1987-03-26	1987-04-09	1	6307
55093	3748	1125315	2012-11-15	2012-12-13	1	15687
13538	925	1115008	1999-04-21	1999-07-20	1	10792
49094	3342	1115008	2011-10-11	2012-01-09	1	15348
13377	917	1759842	1975-10-20	1975-11-10	1	2139
52470	3573	1112807	1936-02-19	1936-03-20	1	-12340
7945	552	1729720	1955-04-15	1955-04-22	1	-5368
5158	351	19127890	1992-11-20	1993-11-15	1	8719
59369	4044	1759842	1987-07-03	1987-07-24	1	6413
2952	194	1125315	2010-07-25	2010-08-22	1	14843
6818	471	1119510	1997-10-28	1997-11-11	1	10176
77797	5316	1125315	1966-09-27	1966-10-18	1	-1171
9657	665	1759842	1964-07-08	1964-07-15	1	-1996
64341	4393	1119510	2011-12-20	2011-12-27	1	15335
39278	2672	1759842	1975-03-20	1975-03-27	1	1911
59437	4051	1129625	1979-02-05	1979-02-05	1	3322
55320	3761	1112807	1959-10-26	1959-11-09	1	-3706
57142	3895	738818	2008-07-08	2008-07-15	1	14075
20787	1415	1729720	1984-05-12	1984-05-19	1	5252
45142	3064	1125315	1993-12-29	1994-01-12	1	8777
70067	4784	1112807	1958-11-10	1958-12-15	1	-4035
76533	5232	1125315	1983-02-17	1983-02-24	1	4802
7359	507	1307863	1990-08-31	1990-08-31	1	7547
55429	3771	1125315	1989-06-18	1989-07-23	1	7143
53824	3661	920293	2008-03-05	2008-03-19	2	13957
61896	4224	1118084	1986-01-19	1986-01-19	1	5862
47521	3226	1177480	1995-03-01	1995-04-05	1	9225
44221	2991	1118084	1998-10-16	1998-10-16	1	10515
57329	3909	1125315	1962-08-13	1962-09-04	1	-2676
23235	1576	1759842	1986-03-01	1986-03-22	1	5924
15630	1083	1125315	2016-03-20	2016-03-27	1	16887
53647	3650	738818	1931-03-08	1931-03-15	1	-14172
23864	1613	1112807	1955-03-23	1955-04-06	1	-5384
52247	3559	1125315	1967-04-08	1967-04-29	1	-978
10764	739	738818	1937-06-17	1937-07-01	1	-11872
4932	335	1125315	1982-03-24	1982-04-14	1	4486
74268	5078	1154343	1914-05-07	1914-05-07	1	-20328
54195	3686	1125315	2000-12-26	2001-01-23	1	11345
3883	264	1361711	2005-09-02	2011-11-11	1	15289
55094	3748	1729720	1992-10-22	1992-11-01	1	8340
13539	925	1149380	2014-10-03	2014-10-03	1	16346
49095	3342	1125315	2011-10-11	2011-10-11	1	15258
13378	917	19127890	1979-05-02	1980-04-26	1	3768
52471	3573	1118084	1963-09-30	1963-09-30	1	-2285
7946	552	1112807	1966-01-02	1966-01-23	1	-1439
5159	351	1119510	2017-11-17	2017-12-01	1	17501
59370	4044	738818	1975-01-19	1975-02-02	1	1858
2953	194	1125315	1990-03-12	1990-04-11	1	7405
6819	471	914335	1990-04-06	1990-04-06	1	7400
77798	5316	1125315	2011-08-04	2011-08-18	1	15204
9658	665	1759842	2006-07-05	2006-07-19	1	13348
64342	4393	1125315	2000-08-02	2000-08-09	1	11178
39279	2672	1125315	1978-07-13	1978-07-20	1	3122
59438	4051	1177480	1977-08-15	1977-08-29	1	2797
55321	3761	1112807	1961-11-16	1961-11-30	1	-2954
57143	3895	1125315	1958-06-26	1958-07-10	1	-4193
20788	1415	1112807	1984-02-07	1984-02-21	1	5164
45143	3064	1125315	1995-01-03	1995-01-10	1	9140
70068	4784	1115008	1998-07-09	1998-07-23	1	10430
76534	5232	1729720	1978-02-04	1978-02-13	1	2965
7360	507	1759842	1962-08-20	1962-09-10	1	-2670
55430	3771	1713332	1967-06-18	1967-06-25	1	-921
53825	3661	920293	2011-05-03	2011-05-10	1	15104
61897	4224	1192710	1951-01-29	1951-01-29	1	-6912
47522	3226	1713332	1971-04-30	1971-05-07	1	491
44222	2991	1177480	1984-04-27	1984-05-11	1	5244
57330	3909	1125315	2011-02-27	2011-03-29	1	15062
23236	1576	1521369	1982-10-05	1983-09-30	1	5020
15631	1083	1129625	1968-06-08	1968-06-08	1	-572
53648	3650	1119510	1992-02-28	1992-03-13	1	8107
23865	1613	1119510	1966-03-04	1966-03-11	1	-1392
52248	3559	1125315	1978-10-26	1978-11-16	1	3241
10765	739	920293	1964-07-26	1964-08-02	1	-1978
6103	419	1112807	1916-06-22	1916-07-06	1	-19537
74269	5078	1322184	1997-06-02	1997-06-02	1	10014
54196	3686	1177480	1991-01-18	1991-04-18	1	7777
3884	264	1713332	1965-06-01	1965-06-08	1	-1668
55095	3748	1125315	2008-08-09	2008-08-16	1	14107
13540	925	1729720	1999-09-22	1999-10-04	1	10868
49096	3342	1177480	1979-07-01	1979-07-31	1	3498
13379	917	1125315	1981-02-11	1981-02-25	1	4073
52472	3573	1125315	1968-11-30	1968-12-07	1	-390
7947	552	1119510	1969-07-17	1969-07-31	1	-154
5160	351	1125315	1982-10-05	1982-10-12	1	4667
59371	4044	738818	2008-06-06	2008-06-13	1	14043
2954	194	1125315	2013-06-27	2013-07-04	1	15890
9081	625	1729720	1979-06-17	1979-06-28	1	3465
77799	5316	1125315	2014-12-10	2014-12-24	1	16428
12032	828	1112807	1971-04-14	1971-06-20	1	535
64343	4393	1125315	2006-04-12	2006-04-19	1	13257
39280	2672	1125315	1995-12-12	1995-12-26	1	9490
59439	4051	1713332	1979-04-15	1979-04-29	1	3405
55322	3761	1119510	2002-03-18	2002-04-01	1	11778
57144	3895	1125315	1982-03-30	1982-04-27	2	4499
20789	1415	1124300	2002-12-09	2002-12-09	1	12030
45144	3064	1177480	1980-05-03	1980-05-24	1	3796
70069	4784	1125315	1953-10-08	1953-10-15	1	-5922
76535	5232	1759842	1973-10-14	1973-10-28	1	1396
7361	507	1177480	1994-05-11	1994-05-25	1	8910
55431	3771	1713332	1983-01-21	1983-02-04	1	4782
53826	3661	1125315	1988-01-13	1988-01-27	1	6600
61898	4224	1112807	1956-01-24	1956-02-07	1	-5077
47523	3226	1759842	1997-05-22	1997-07-17	1	10059
45486	3087	738818	1984-07-18	1984-07-25	1	5319
57331	3909	1125315	2012-12-23	2013-01-06	1	15711
27910	1889	1177480	2015-10-31	2015-11-21	1	16760
15632	1083	1521369	1984-04-24	1985-04-19	1	5587
53649	3650	1119510	2002-06-08	2002-06-22	1	11860
23866	1613	1125315	1954-10-12	1954-10-26	1	-5546
52249	3559	1125315	1983-04-29	1983-05-13	1	4880
10766	739	933724	1964-07-26	1964-08-02	1	-1978
6104	419	1124957	1964-09-15	1964-09-15	1	-1934
74270	5078	1539403	1991-05-27	1991-05-27	1	7816
54197	3686	1713332	1983-05-13	1983-05-20	1	4887
3885	264	1713332	1987-05-26	1987-06-02	1	6361
55096	3748	1713332	2004-11-04	2004-11-25	1	12747
13541	925	1112807	1971-05-18	1971-06-01	1	516
49097	3342	1307863	2005-03-30	2005-03-30	1	12872
13380	917	1503184	1979-05-02	1980-04-26	1	3768
52473	3573	1125315	1978-09-04	1978-09-25	1	3189
7948	552	1124300	1986-05-27	1986-05-27	1	5990
5161	351	1500211	1997-10-25	1998-10-20	1	10519
59372	4044	1115008	1997-03-18	1997-04-08	1	9959
2955	194	1713332	1981-06-13	1981-06-27	1	4195
9082	625	1729720	1979-04-07	1979-04-15	1	3391
77800	5316	1177480	1993-03-30	1993-04-13	1	8503
12033	828	1118084	1992-11-29	1992-11-29	1	8368
64344	4393	1713332	2018-04-16	2018-05-07	1	17658
39281	2672	1713332	2012-11-03	2012-11-10	1	15654
59440	4051	1713332	2011-05-30	2011-06-13	1	15138
55323	3761	1124300	1990-11-29	1990-11-29	1	7637
57145	3895	1125315	2004-08-30	2004-09-13	1	12674
20790	1415	1759842	1987-06-05	1987-06-19	1	6378
45145	3064	1713332	1972-08-11	1972-09-01	1	974
70070	4784	738818	1987-01-06	1987-01-13	1	6221
76536	5232	1118084	2011-04-09	2011-04-09	1	15073
7362	507	1326303	1990-08-31	1990-08-31	1	7547
55432	3771	1759842	1983-01-21	1983-02-04	1	4782
53827	3661	1729720	1986-07-04	1986-07-11	1	6035
61899	4224	1125315	1978-07-24	1978-08-07	1	3140
47524	3226	1118084	2012-07-07	2012-07-07	1	15528
45487	3087	738818	2002-03-12	2002-03-26	1	11772
57332	3909	1521369	1977-08-04	1978-07-30	1	3132
27911	1889	1115008	2009-04-14	2009-05-05	1	14369
15633	1083	1551099	1980-05-06	1980-05-06	1	3778
53650	3650	1125315	1931-03-08	1931-03-15	1	-14172
23867	1613	1521369	1974-04-10	1976-03-30	2	2280
52250	3559	1759842	2011-07-24	2011-07-31	1	15186
10767	739	1102527	1975-08-20	1975-08-20	1	2057
6105	419	1112807	1923-11-15	1923-11-29	1	-16835
74271	5078	1729720	1962-04-14	1962-04-21	1	-2812
54198	3686	1118084	2009-10-30	2009-10-30	1	14547
3886	264	1759842	1987-05-26	1987-06-02	1	6361
55097	3748	1759842	2004-11-04	2004-11-25	1	12747
13542	925	1137529	2014-10-03	2014-10-03	1	16346
49098	3342	1326303	2005-03-30	2005-03-30	1	12872
13381	917	1738521	1967-11-10	1967-11-24	1	-769
52474	3573	1119510	2010-06-13	2010-06-20	1	14780
7949	552	1728416	1952-03-16	1952-03-30	1	-6486
5162	351	1500211	2001-10-04	2003-09-24	2	12319
59373	4044	1115008	2017-01-23	2017-02-27	1	17224
2956	194	1729720	1986-06-18	1986-06-25	1	6019
9083	625	1738521	1975-05-24	1975-06-07	1	1983
77801	5316	1177480	1998-10-14	1998-11-04	1	10534
12034	828	1322184	2005-06-14	2005-06-14	1	12948
64345	4393	1729720	1987-10-02	1987-10-14	1	6495
39282	2672	1729720	1953-07-15	1953-07-23	1	-6006
59441	4051	1717327	1977-08-15	1977-08-29	1	2797
55324	3761	1125315	1958-01-11	1958-02-08	1	-4345
57146	3895	1125315	2008-07-08	2008-07-15	1	14075
20791	1415	1174888	2004-06-05	2004-06-05	1	12574
45146	3064	1112807	1938-08-18	1938-09-01	1	-11445
70071	4784	1112807	1967-04-02	1967-04-23	1	-984
76537	5232	1125315	1976-07-21	1976-08-20	1	2423
7363	507	1713332	1962-08-20	1962-09-10	1	-2670
55433	3771	1112807	1970-12-20	1971-01-24	1	388
53828	3661	933724	2008-03-05	2008-03-19	1	13957
61900	4224	1125315	2008-12-14	2008-12-21	1	14234
47525	3226	1125315	1995-10-09	1995-10-16	1	9419
45488	3087	1102527	1996-07-15	1996-07-15	1	9692
57333	3909	1713332	1977-02-21	1977-03-07	1	2622
27912	1889	1124300	2018-04-28	2018-04-28	1	17649
15634	1083	975125	1967-12-23	1968-01-13	1	-719
53651	3650	1125315	1935-04-03	1935-04-17	1	-12678
23868	1613	1728416	1958-01-07	1958-01-21	1	-4363
52251	3559	1124300	1991-08-06	1991-08-06	1	7887
10768	739	1125315	1937-06-17	1937-07-01	1	-11872
6106	419	1112807	1924-12-23	1925-01-13	1	-16424
74272	5078	1778162	1983-06-12	1983-06-22	1	4920
56299	3836	705944	1989-03-01	1995-03-10	1	9199
3887	264	1112807	1952-06-21	1952-07-19	1	-6375
55098	3748	738818	2009-06-14	2009-06-21	1	14416
15661	1085	1125315	1968-11-12	1969-01-18	1	-348
49099	3342	1713332	1938-12-10	1938-12-24	1	-11331
13382	917	1119510	1990-04-16	1990-04-23	1	7417
52475	3573	1125315	1957-07-12	1957-09-10	1	-4496
7950	552	1759842	1952-05-17	1952-05-31	1	-6424
5163	351	1503184	1992-11-20	1993-11-15	1	8719
59374	4044	1125315	1973-03-09	1973-03-16	1	1170
4007	273	738818	2003-01-08	2003-01-22	1	12074
9084	625	1112807	1975-05-24	1975-06-07	1	1983
77802	5316	1309944	1984-01-02	1984-01-02	1	5114
12035	828	1112807	1965-06-14	1965-09-12	1	-1572
64346	4393	1759842	2018-04-16	2018-05-07	1	17658
39283	2672	1759842	2012-11-03	2012-11-10	1	15654
59442	4051	738818	2005-01-08	2005-01-15	1	12798
55325	3761	1125315	1959-07-22	1959-08-05	1	-3802
57147	3895	1322184	1999-02-12	1999-02-12	1	10634
20792	1415	1759842	1974-05-07	1974-05-21	1	1601
45147	3064	1119510	1993-12-29	1994-01-12	1	8777
70072	4784	1124300	1987-11-08	1987-11-08	1	6520
76538	5232	1125315	2016-09-19	2016-09-19	1	17063
7364	507	701322	2011-09-12	2011-09-12	1	15229
55434	3771	1118084	1996-09-11	1996-09-11	1	9750
53829	3661	933724	2011-05-03	2011-05-10	1	15104
61901	4224	1125315	2019-03-30	2019-04-13	1	17999
47526	3226	1738521	1971-02-23	1971-03-09	1	432
45489	3087	1125315	1984-07-18	1984-07-25	1	5319
57334	3909	1728416	1961-10-17	1961-10-31	1	-2984
27913	1889	1125315	1994-06-18	1994-07-02	1	8948
15635	1083	1551099	1967-10-11	1967-10-11	1	-813
53652	3650	1125315	1940-11-04	1940-11-04	1	-10650
23869	1613	738818	1966-03-04	1966-03-11	1	-1392
52252	3559	1713332	2011-07-24	2011-07-31	1	15186
10769	739	1125315	1991-08-15	1991-10-14	1	7956
6107	419	1112807	1969-07-21	1969-08-20	1	-134
74273	5078	1125315	1983-05-23	1983-06-22	1	4920
56300	3836	738818	2002-05-19	2002-06-02	1	11840
3888	264	1112807	1969-10-18	1969-11-24	1	-38
55099	3748	1118084	2015-10-30	2015-10-30	1	16738
15662	1085	1759842	1976-01-28	1976-02-11	1	2232
49100	3342	1759842	1938-12-10	1938-12-24	1	-11331
13383	917	1125315	1977-07-31	1977-09-04	1	2803
52476	3573	1125315	2010-11-27	2010-12-18	1	14961
7951	552	1759842	1975-04-02	1975-07-02	1	2008
5164	351	1521369	2000-10-09	2001-10-04	1	11599
59375	4044	1125315	1975-01-19	1975-02-02	1	1858
4008	273	1119510	2014-03-27	2014-04-10	1	16170
9085	625	1118084	2014-02-13	2014-02-13	1	16114
77803	5316	1343916	1984-01-02	1984-01-02	1	5114
12036	828	1102527	1971-04-21	1971-04-21	1	475
64347	4393	19127890	2000-05-04	2001-04-29	1	11441
39284	2672	920293	1977-12-22	1977-12-29	1	2919
59443	4051	1118084	2009-09-29	2009-09-29	1	14516
55326	3761	1125315	1987-05-29	1987-06-12	1	6371
57148	3895	1759842	1952-07-18	1952-08-01	1	-6362
23102	1569	738818	1974-08-15	1974-08-22	1	1694
45148	3064	1112807	1949-02-17	1949-03-03	1	-7609
70073	4784	1125315	1987-01-06	1987-01-13	1	6221
76539	5232	1125315	2003-07-09	2003-07-16	1	12249
7365	507	1118084	1977-10-03	1977-10-03	1	2832
55435	3771	1125315	2000-03-20	2000-03-27	1	11043
53830	3661	1149380	1982-02-18	1982-02-18	1	4431
61902	4224	1759842	1959-04-08	1959-04-29	1	-3900
47527	3226	1759842	1971-04-30	1971-05-07	1	491
45490	3087	1125315	1993-10-08	1993-10-15	1	8688
57335	3909	1729720	2015-03-05	2015-03-12	1	16506
28549	1933	1177480	2015-05-01	2015-05-22	1	16577
15902	1101	1125315	1974-10-19	1974-11-02	1	1766
53653	3650	1125315	2000-03-21	2000-03-28	1	11044
23870	1613	738818	1987-10-28	1987-11-04	1	6516
52253	3559	1728416	1950-05-23	1950-06-06	1	-7149
10770	739	1177480	1978-05-06	1978-07-05	1	3107
6108	419	1112807	1991-07-01	1991-07-31	1	7881
74274	5078	1125315	1987-06-01	1987-07-06	1	6395
56301	3836	1118084	2018-12-14	2018-12-14	1	17879
3889	264	1115008	2008-07-31	2008-08-21	1	14112
55100	3748	1119510	2009-06-14	2009-06-21	1	14416
15663	1085	1118084	2004-11-08	2004-11-08	1	12730
49101	3342	1759842	1947-09-29	1947-10-20	1	-8109
13384	917	1521369	1979-05-02	1980-04-26	1	3768
52477	3573	1557272	2003-10-18	2003-10-18	1	12343
7952	552	1115008	2015-06-05	2015-09-03	1	16681
5165	351	1549786	1996-10-30	1997-10-25	1	10159
59376	4044	1125315	1999-04-29	1999-05-06	1	10717
4009	273	1125315	2014-03-27	2014-04-10	1	16170
9086	625	1125315	1974-12-25	1975-01-24	1	1849
77804	5316	1729720	1963-06-28	1963-07-08	1	-2369
12037	828	1125315	1954-06-12	1954-06-26	1	-5668
64348	4393	1102527	2016-08-28	2016-08-28	1	17041
39285	2672	933724	1977-12-22	1977-12-29	1	2919
59444	4051	1125315	1993-10-08	1993-10-29	1	8702
55327	3761	1125315	1991-06-06	1991-06-13	1	7833
57149	3895	1759842	2019-03-13	2019-04-03	1	17989
23103	1569	738818	2016-06-24	2016-07-08	1	16990
45149	3064	1118084	1975-05-16	1975-05-16	1	1961
70074	4784	1125315	2010-07-18	2010-08-01	1	14822
76540	5232	1125315	2007-11-15	2007-11-22	1	13839
7366	507	1119510	1944-01-21	1944-01-28	1	-9470
55436	3771	1729720	1972-05-19	1972-05-26	1	876
53831	3661	1713332	1982-09-18	1982-10-02	1	4657
61903	4224	1125315	1950-11-14	1951-02-26	2	-6907
47528	3226	1125315	1984-04-06	1984-04-27	1	5230
58784	4009	723013	2005-07-26	2006-05-02	1	13270
28550	1933	1125315	1960-05-19	1960-08-17	1	-3424
15903	1101	1125315	1981-06-12	1981-07-03	1	4201
53654	3650	1125315	2013-12-17	2013-12-31	1	16070
23871	1613	920293	1994-07-14	1994-07-28	2	8974
52254	3559	1125315	1956-10-20	1956-11-03	1	-4807
13709	938	1112807	1952-05-13	1952-07-12	1	-6382
6109	419	1118084	1954-08-08	1954-08-08	1	-5625
74275	5078	1361711	1980-07-07	1980-07-07	1	3840
56302	3836	1125315	1981-01-27	1981-02-19	2	4065
3890	264	1125315	1977-07-27	1977-08-24	1	2792
55101	3748	1125315	1987-11-27	1987-12-27	1	6569
15664	1085	1125315	1977-02-05	1977-03-05	1	2620
53358	3634	1177480	2002-10-17	2003-01-15	1	12067
13385	917	1717327	1965-05-05	1965-05-19	1	-1688
52478	3573	1713332	1949-06-04	1949-06-25	1	-7495
7953	552	1125315	1991-08-31	1991-09-14	1	7926
5166	351	1729720	1986-04-04	1986-04-13	1	5946
59377	4044	1125315	2008-06-06	2008-06-13	1	14043
4010	273	1174888	2001-09-27	2001-09-27	1	11592
9692	669	920293	1995-11-07	1995-11-14	1	9448
301	19	738818	2007-04-21	2007-04-28	1	13631
12038	828	1177480	1999-10-21	1999-11-04	1	10899
64349	4393	1503184	2000-05-04	2001-04-29	1	11441
59445	4051	1125315	2005-01-08	2005-01-15	1	12798
55328	3761	1125315	2002-03-18	2002-04-01	1	11778
57150	3895	1118084	1958-05-20	1958-05-20	1	-4244
23104	1569	920293	1976-11-25	1976-12-02	1	2527
45928	3118	1713332	1966-05-09	1966-05-16	1	-1326
70075	4784	1177480	2009-11-22	2009-12-13	1	14591
76541	5232	1177480	2016-09-19	2016-11-18	1	17123
7367	507	1310149	1990-08-31	1990-08-31	1	7547
55437	3771	1729720	1981-04-13	1981-04-21	1	4128
53832	3661	1713332	1994-03-27	1994-04-17	1	8872
61904	4224	1125315	1973-12-15	1973-12-29	1	1458
47529	3226	1177480	1980-07-05	1980-07-26	1	3859
58785	4009	1112807	1952-03-30	1952-04-13	1	-6472
28551	1933	1125315	1980-12-02	1980-12-16	1	4002
15904	1101	1125315	2009-02-01	2009-02-15	1	14290
53655	3650	1125315	2017-03-07	2017-03-21	1	17246
23872	1613	933724	1994-07-14	1994-07-28	1	8974
52255	3559	1125315	1977-05-22	1977-05-29	1	2705
13710	938	1125315	1963-12-12	1963-12-12	1	-2212
6110	419	1125315	1943-02-22	1943-03-01	1	-9803
74276	5078	1713332	1915-07-27	1915-08-17	1	-19861
56303	3836	1125315	2002-05-19	2002-06-02	1	11840
3891	264	1174888	2011-11-11	2011-11-11	1	15289
55102	3748	1125315	2009-06-14	2009-06-21	1	14416
15665	1085	1174888	2000-07-02	2000-07-02	1	11140
53359	3634	1115008	2000-11-12	2000-11-26	1	11287
13386	917	738818	1996-11-18	1996-12-02	1	9832
52479	3573	1713332	1957-09-05	1957-09-19	1	-4487
7954	552	1713332	1962-04-18	1962-05-09	1	-2794
5167	351	738818	1985-02-28	1985-03-14	1	5551
64440	4401	920293	2005-01-23	2005-01-30	1	12813
4011	273	1729720	1976-02-14	1976-02-27	1	2248
9693	669	1125315	1974-04-09	1974-04-16	1	1566
302	19	1125315	2003-07-16	2003-07-16	1	12249
12039	828	1347450	2005-06-14	2005-06-14	1	12948
64350	4393	1521369	2000-05-04	2001-04-29	1	11441
59446	4051	1729720	1986-12-11	1986-12-24	1	6201
55329	3761	1729720	1957-02-16	1957-02-24	1	-4694
57151	3895	1119510	2004-08-30	2004-09-13	1	12674
23105	1569	933724	1976-11-25	1976-12-02	1	2527
45929	3118	1729720	1950-10-15	1950-10-24	1	-7009
70076	4784	1115008	2018-08-28	2018-10-02	1	17806
76542	5232	1738521	1969-01-29	1969-02-12	1	-323
8736	605	1503184	1977-05-06	1978-05-01	1	3042
55438	3771	1759842	1967-06-18	1967-06-25	1	-921
53833	3661	1759842	1982-09-18	1982-10-02	1	4657
61905	4224	1125315	1996-12-04	1996-12-11	1	9841
47530	3226	1177480	2008-05-26	2008-06-16	1	14046
58786	4009	1112807	1955-08-18	1955-09-08	1	-5229
28552	1933	920293	1979-06-29	1979-07-06	1	3473
15905	1101	1149380	2003-06-29	2003-06-29	1	12232
53656	3650	1347450	2014-07-04	2014-07-04	1	16255
23873	1613	1119510	1962-07-02	1962-07-09	1	-2733
52256	3559	1713332	2015-01-20	2015-02-03	1	16469
13711	938	1125315	1993-12-21	1994-01-04	1	8769
6111	419	1125315	1964-09-15	1964-09-15	1	-1934
74277	5078	1759842	1939-09-02	1939-09-23	1	-11058
56304	3836	1177480	1978-05-10	1978-05-24	1	3065
3892	264	1322184	2005-09-02	2011-11-11	1	15289
55103	3748	1177480	1983-02-20	1983-03-06	1	4812
15666	1085	1713332	1968-03-23	1968-03-30	1	-642
53360	3634	1124300	2007-03-31	2007-03-31	1	13603
13387	917	1118084	2005-03-31	2005-03-31	1	12873
52480	3573	738818	2010-06-13	2010-06-20	1	14780
7955	552	1728416	1954-10-21	1954-11-04	1	-5537
5168	351	1125315	1985-02-28	1985-03-14	1	5551
64441	4401	1115008	2012-03-10	2012-03-31	1	15430
4012	273	1119510	1980-11-17	1980-11-24	1	3980
9694	669	1125315	1996-01-13	1996-01-27	1	9522
303	19	1125315	2007-04-21	2007-04-28	1	13631
12040	828	1713332	1957-12-28	1958-01-04	1	-4380
64351	4393	1713332	2004-05-07	2004-05-28	1	12566
59447	4051	1759842	2011-05-30	2011-06-13	1	15138
55330	3761	1125315	1958-10-10	1958-10-24	1	-4087
57152	3895	1119510	2008-07-08	2008-07-15	1	14075
23106	1569	1112807	1956-01-26	1956-02-09	1	-5075
45930	3118	1759842	2004-06-22	2004-07-13	1	12612
70077	4784	1119510	1987-01-06	1987-01-13	1	6221
77162	5276	933724	1975-02-23	1975-03-02	1	1886
8737	605	19127890	1977-05-06	1978-05-01	1	3042
55676	3789	933724	1994-06-08	1994-06-15	1	8931
53834	3661	1759842	1994-03-27	1994-04-17	1	8872
61906	4224	1177480	2010-10-21	2010-11-04	1	14917
47531	3226	1713332	1978-12-06	1978-12-20	1	3275
58787	4009	1119510	1956-07-18	1956-07-25	1	-4908
28553	1933	933724	1979-06-29	1979-07-06	1	3473
15906	1101	738818	1978-03-10	1978-03-24	1	3004
53657	3650	1713332	1978-04-12	1978-07-12	1	3114
23874	1613	1125315	1966-03-04	1966-03-11	1	-1392
52257	3559	1759842	2015-01-20	2015-02-03	1	16469
13712	938	1729720	1957-11-01	1957-11-10	1	-4435
6112	419	1177480	1988-12-08	1989-01-12	1	6951
74278	5078	1112807	1942-02-17	1942-03-10	1	-10159
56305	3836	1177480	1986-10-04	1986-11-03	1	6150
3893	264	1729720	1958-05-04	1958-05-13	1	-4251
56373	3841	738818	1975-04-13	1975-04-20	1	1935
15667	1085	1713332	1998-07-24	1998-08-14	1	10452
53361	3634	1125315	1974-05-03	1974-05-17	1	1597
13388	917	1125315	1996-11-18	1996-12-02	1	9832
52481	3573	1112807	1937-03-15	1937-03-29	1	-11966
7956	552	1729720	1954-02-08	1954-02-18	1	-5796
5169	351	1515774	1996-10-30	1997-10-25	1	10159
64442	4401	1503184	1983-01-01	1984-12-21	2	5468
4013	273	1119510	2003-01-08	2003-01-22	1	12074
9695	669	1515774	1991-08-17	1992-08-11	1	8258
304	19	1125315	2017-05-07	2017-05-21	1	17307
12041	828	1728416	1954-06-12	1954-06-26	1	-5668
65077	4447	1125315	1955-08-30	1955-09-29	1	-5208
59448	4051	1119510	2005-01-08	2005-01-15	1	12798
55331	3761	1125315	1981-11-29	1981-12-06	1	4357
57153	3895	1125315	1977-02-01	1977-02-15	1	2602
23107	1569	1125315	1943-03-03	1943-03-17	1	-9787
45931	3118	1112807	1972-08-22	1972-09-28	1	1001
70078	4784	1125315	1971-01-15	1971-01-29	1	393
77163	5276	1102527	1970-10-04	1970-10-04	1	276
8738	605	1119510	1961-03-22	1961-04-05	1	-3193
55677	3789	1115008	2010-07-29	2010-08-28	1	14849
53835	3661	1125315	1980-08-02	1980-08-16	1	3880
61907	4224	1713332	1959-04-08	1959-04-29	1	-3900
47532	3226	1713332	1997-05-22	1997-07-17	1	10059
58788	4009	1125315	1983-07-13	1983-07-27	1	4955
28554	1933	1118084	1998-05-10	1998-05-10	1	10356
15907	1101	914335	1982-08-22	1982-08-22	1	4616
53658	3650	1729720	2015-07-03	2015-07-14	1	16630
23875	1613	1125315	1973-03-30	1973-04-13	1	1198
53427	3639	715997	2001-01-13	2001-01-13	1	11335
13713	938	920293	1974-08-27	1974-09-03	1	1706
6113	419	1347450	1994-07-31	1994-07-31	1	8977
74279	5078	1125315	1956-10-03	1956-10-17	1	-4824
56306	3836	1713332	1994-02-12	1994-02-26	1	8822
3894	264	1759842	1965-06-01	1965-06-08	1	-1668
56374	3841	1125315	1982-09-27	1982-10-11	1	4666
15668	1085	1717327	1965-10-29	1965-11-12	1	-1511
53362	3634	1125315	2008-04-06	2008-04-20	1	13989
13389	917	1125315	2004-01-19	2004-02-02	1	12450
52482	3573	1115008	2000-01-24	2000-03-24	1	11040
7957	552	1112807	1954-10-21	1954-11-04	1	-5537
5170	351	1515774	1998-10-20	1999-10-15	1	10879
64443	4401	1154343	1973-01-10	1990-01-20	1	7324
4014	273	1124300	2011-09-25	2011-09-25	1	15242
9696	669	1521369	1987-09-07	1988-09-01	1	6818
305	19	1729720	2000-05-15	2000-05-27	1	11104
12042	828	1125315	2000-01-13	2000-01-27	1	10983
65078	4447	1115008	2008-09-04	2008-09-25	1	14147
59449	4051	1125315	1995-11-23	1995-12-07	1	9471
55332	3761	1713332	1987-06-11	1987-06-18	1	6377
57154	3895	1347450	1999-02-12	1999-02-12	1	10634
23108	1569	1125315	1974-08-15	1974-08-22	1	1694
45932	3118	1118084	1985-12-21	1985-12-21	1	5833
70079	4784	1125315	2009-05-16	2009-05-23	1	14387
77164	5276	1112807	1970-10-04	1970-10-25	1	297
8739	605	1119510	1987-03-09	1987-03-16	1	6283
55678	3789	1118084	1977-03-01	1977-03-01	1	2616
53836	3661	1549786	1992-02-09	1993-02-03	1	8434
61908	4224	1728416	1951-02-12	1951-02-26	1	-6884
47533	3226	1729720	2004-10-24	2004-11-03	1	12725
58789	4009	1728416	1954-09-04	1954-09-18	1	-5584
28555	1933	1125315	1959-11-21	1959-12-05	1	-3680
15908	1101	1119510	1989-07-01	1989-07-08	1	7128
53659	3650	1112807	1928-05-20	1928-06-10	1	-15180
23876	1613	1125315	1979-10-13	1979-10-20	1	3579
53428	3639	1119510	1929-03-07	1929-03-21	1	-14896
13714	938	933724	1974-08-27	1974-09-03	1	1706
6114	419	1729720	1941-06-17	1941-06-29	1	-10413
74280	5078	1177480	1997-09-02	1997-10-02	1	10136
56307	3836	1125315	1984-10-23	1984-11-13	1	5430
3895	264	738818	2010-11-12	2010-11-26	1	14939
56375	3841	1515774	1990-08-30	1993-08-14	3	8626
15669	1085	1759842	1998-07-24	1998-08-14	1	10452
53363	3634	1738521	1974-05-03	1974-05-17	1	1597
13390	917	1177480	2005-11-06	2006-02-04	1	13183
52483	3573	1125315	1926-06-12	1926-06-26	1	-15895
7958	552	1759842	1962-04-18	1962-05-09	1	-2794
5171	351	1521369	1992-11-20	1993-11-15	1	8719
64444	4401	1713332	1997-02-06	1997-02-20	1	9912
4015	273	1125315	2001-09-27	2001-09-27	1	11592
9697	669	1729720	1972-03-22	1972-04-01	1	821
306	19	1119510	2007-04-21	2007-04-28	1	13631
12043	828	1759842	1957-12-28	1958-01-04	1	-4380
65079	4447	1124300	1990-07-27	1990-07-27	1	7512
59450	4051	1177480	1982-05-04	1982-06-08	1	4541
55333	3761	1125315	1994-08-28	1994-10-27	1	9065
57155	3895	1713332	1947-04-03	1947-04-24	1	-8288
23109	1569	1125315	2007-06-21	2007-07-05	1	13699
45933	3118	1125315	1964-04-06	1964-04-06	1	-2096
70080	4784	1713332	1970-02-17	1970-03-03	1	61
77165	5276	1125315	1962-06-13	1962-06-27	1	-2745
8740	605	1125315	1970-01-31	1970-02-14	1	44
55679	3789	1125315	1949-05-24	1949-05-31	1	-7520
53837	3661	19127890	1992-02-09	1993-02-03	1	8434
63517	4342	1125315	1959-02-09	1959-02-23	1	-3965
47534	3226	1768849	1983-09-13	1983-09-27	1	5017
58790	4009	933724	1996-08-23	1996-08-30	1	9738
28556	1933	1728416	1959-11-21	1959-12-05	1	-3680
15909	1101	1137529	2003-06-29	2003-06-29	1	12232
53660	3650	1124957	1940-11-04	1940-11-04	1	-10650
23877	1613	1125315	1987-10-28	1987-11-04	1	6516
53429	3639	1119510	1978-03-01	1978-03-08	1	2988
13715	938	1124300	1987-05-30	1987-05-30	1	6358
6115	419	1112807	1913-10-17	1913-10-31	1	-20516
74281	5078	1332418	1994-05-16	1994-05-16	1	8901
56308	3836	1125315	1997-11-09	1997-11-23	1	10188
3896	264	1102527	1969-10-25	1969-10-25	1	-68
56376	3841	1515774	1994-08-09	1995-08-04	1	9346
15670	1085	1125315	2000-07-02	2000-08-01	2	11170
53364	3634	1125315	2002-10-17	2002-10-17	1	11977
13391	917	1713332	1967-03-02	1967-03-09	1	-1029
52484	3573	1125315	1940-04-10	1940-04-24	1	-10844
8757	606	920293	1997-03-03	1997-03-10	1	9930
5172	351	1549786	1998-10-20	1999-10-15	1	10879
64445	4401	1759842	1989-01-10	1989-01-17	1	6956
4016	273	1125315	2003-01-08	2003-01-22	1	12074
9698	669	1125315	2007-05-31	2007-06-14	1	13678
307	19	1177480	1981-11-08	1981-12-08	1	4359
12221	842	1112807	1948-08-04	1948-09-01	1	-7792
65080	4447	1125315	1989-06-16	1989-09-14	1	7196
60336	4113	1125315	1972-02-04	1972-02-18	1	778
55334	3761	1717327	1961-11-16	1961-11-30	1	-2954
58872	4013	1125315	1975-11-12	1975-11-26	1	2155
23110	1569	1177480	2003-12-22	2004-01-12	1	12429
45934	3118	1129625	1952-12-25	1952-12-25	1	-6216
70081	4784	1729720	2004-02-08	2004-02-19	1	12467
77166	5276	1125315	1969-12-24	1969-12-31	1	-1
8741	605	1177480	1997-05-02	1997-05-23	1	10004
55680	3789	1125315	1950-09-02	1950-09-09	1	-7054
53838	3661	1118084	2016-02-18	2016-02-18	1	16849
63518	4342	1125315	1975-07-01	1975-07-15	1	2021
47535	3226	738818	1982-01-28	1982-02-11	1	4424
58791	4009	1125315	1954-09-04	1954-09-18	1	-5584
30212	2043	1112807	1958-05-28	1958-06-11	1	-4222
15910	1101	1177480	2009-12-03	2009-12-31	1	14609
53661	3650	1125315	2007-01-31	2007-02-14	1	13558
23878	1613	1728416	1954-10-12	1954-10-26	1	-5546
53430	3639	1125315	1964-10-17	1964-10-31	1	-1888
13716	938	1125315	1976-06-20	1976-07-18	1	2390
6116	419	1112807	1915-06-09	1915-06-30	1	-19909
74282	5078	1713332	1939-09-02	1939-09-23	1	-11058
56309	3836	1125315	2007-10-22	2007-10-29	1	13815
3897	264	1112807	1954-08-10	1954-08-24	1	-5609
56377	3841	1521369	1989-09-04	1990-08-30	1	7546
15671	1085	1729720	1971-06-03	1971-06-10	1	525
53365	3634	1124957	2002-10-17	2002-10-17	1	11977
13392	917	1713332	1975-10-20	1975-11-10	1	2139
52485	3573	1125315	1989-03-31	1989-04-21	1	7050
8758	606	1118084	2010-07-28	2010-07-28	1	14818
5173	351	1549786	2000-10-09	2001-10-04	1	11599
64446	4401	1759842	1995-11-29	1995-12-06	1	9470
4017	273	1177480	2019-02-25	2019-04-01	1	17987
9699	669	1125315	2018-11-07	2018-11-14	1	17849
308	19	1177480	2003-07-16	2003-08-15	1	12279
12222	842	1119510	2011-07-13	2011-07-20	1	15175
65081	4447	1154343	1953-08-27	1953-08-27	1	-5971
60337	4113	1125315	1997-01-24	1997-01-24	1	9885
55335	3761	1112807	1957-11-12	1957-11-26	1	-4419
58873	4013	1125315	1977-07-18	1977-08-01	1	2769
23111	1569	1713332	1939-05-15	1939-06-26	1	-11147
45935	3118	1728416	1949-11-30	1949-12-14	1	-7323
70082	4784	1125315	1976-09-06	1976-09-20	1	2454
77167	5276	1125315	2012-08-19	2012-09-02	1	15585
8742	605	1728416	1957-01-11	1957-01-25	1	-4724
55681	3789	1125315	1974-11-30	1974-12-14	1	1808
53839	3661	1154343	1982-02-18	1982-02-18	1	4431
63519	4342	1551099	1993-01-30	1993-01-30	1	8430
47536	3226	1119510	2008-06-25	2008-07-02	1	14062
58792	4009	1125315	1959-01-12	1959-01-19	1	-4000
30213	2043	1125315	1995-09-23	1995-09-30	1	9403
15911	1101	1713332	1979-01-24	1979-02-07	1	3324
53662	3650	1557272	1997-05-30	1997-05-30	1	10011
25856	1751	738818	1979-04-22	1979-04-29	1	3405
53431	3639	1310149	2004-01-31	2004-01-31	1	12448
13717	938	1125315	1990-08-10	1990-08-24	1	7540
6117	419	1112807	1964-09-15	1964-11-14	1	-1874
74283	5078	1759842	1915-07-27	1915-08-17	1	-19861
56310	3836	1125315	2008-09-24	2008-10-01	1	14153
3898	264	1119510	1958-05-23	1958-05-30	1	-4234
56378	3841	1112807	1988-10-29	1988-11-19	1	6897
15672	1085	1759842	1968-03-23	1968-03-30	1	-642
53366	3634	1177480	1982-04-21	1982-07-20	1	4583
15525	1077	738818	1983-10-06	1983-10-13	1	5033
52486	3573	1125315	2010-06-13	2010-06-20	1	14780
8759	606	1125315	1976-06-18	1976-07-02	1	2374
5174	351	1759842	1984-08-03	1984-08-24	1	5349
64447	4401	19127890	1983-01-01	1984-12-21	2	5468
4018	273	1551099	1981-04-15	1981-04-15	1	4122
9700	669	19127890	1989-08-27	1992-08-11	3	8258
309	19	1501700	2004-01-17	2004-01-17	1	12434
12223	842	1125315	1914-08-04	1914-08-18	1	-20225
65082	4447	1149380	1953-08-27	1953-08-27	1	-5971
60338	4113	1125315	2007-01-01	2007-01-15	1	13528
55336	3761	1728416	1957-11-12	1957-11-26	1	-4419
58874	4013	1125315	1980-04-25	1980-05-09	1	3781
23112	1569	1713332	1979-04-03	1979-04-10	1	3386
45936	3118	1728416	1952-07-05	1952-07-19	1	-6375
70083	4784	1125315	1996-03-02	1996-03-16	1	9571
77168	5276	1310149	2009-12-27	2009-12-27	1	14605
8743	605	738818	1961-03-22	1961-04-05	1	-3193
55682	3789	1125315	2006-06-10	2006-06-24	1	13323
53840	3661	1515774	1992-02-09	1993-02-03	1	8434
63520	4342	1729720	1980-04-02	1980-04-15	1	3757
47537	3226	1125315	1982-01-28	1982-02-11	1	4424
58793	4009	1125315	1979-03-06	1979-03-20	1	3365
30214	2043	1713332	1974-12-08	1975-03-30	1	1914
15912	1101	1759842	2012-02-17	2012-03-09	1	15408
53663	3650	1759842	1978-04-12	1978-07-12	1	3114
25857	1751	1125315	1979-04-22	1979-04-29	1	3405
53432	3639	1713332	1999-02-11	1999-02-18	1	10640
13718	938	1125315	2000-12-30	2001-01-06	1	11328
6118	419	1112807	1979-12-26	1980-03-25	1	3736
74284	5078	1125315	1956-05-25	1956-06-15	1	-4948
56311	3836	1717327	1978-05-10	1978-05-24	1	3065
3899	264	1124300	1984-04-04	1984-04-04	1	5207
56379	3841	1119510	2002-08-29	2002-09-05	1	11935
15673	1085	1112807	1965-10-29	1965-11-12	1	-1511
53367	3634	1729720	1995-07-13	1995-07-25	1	9336
15526	1077	1125315	2006-03-04	2006-04-08	1	13246
52487	3573	1729720	1941-07-02	1941-07-15	1	-10397
8760	606	1125315	1978-07-27	1978-08-03	1	3136
6546	453	1115008	2004-02-05	2004-03-04	1	12481
64448	4401	933724	2005-01-23	2005-01-30	1	12813
4019	273	1713332	1975-10-21	1975-11-04	1	2133
9701	669	933724	1995-11-07	1995-11-14	1	9448
310	19	1713332	2018-08-13	2018-08-20	1	17763
12224	842	1125315	1940-08-16	1940-08-16	1	-10730
65083	4447	1177480	2012-10-04	2012-10-25	1	15638
60339	4113	1177480	1997-01-17	1997-02-23	1	9915
55337	3761	1728416	1959-07-22	1959-08-05	1	-3802
58875	4013	1177480	1978-12-17	1978-12-31	1	3286
23113	1569	1713332	2003-12-22	2004-01-12	1	12429
45937	3118	1728416	1953-12-01	1953-12-15	1	-5861
70084	4784	1729720	1963-03-23	1963-03-31	1	-2468
77169	5276	1521369	1975-12-26	1976-12-20	1	2545
8744	605	1112807	1957-01-11	1957-01-25	1	-4724
55683	3789	1728416	1945-08-11	1945-08-25	1	-8895
55040	3745	738818	1944-02-28	1944-03-13	1	-9425
63521	4342	1125315	1987-05-07	1987-05-14	1	6342
47538	3226	1729720	1971-01-09	1971-01-19	1	383
58794	4009	1713332	1987-06-13	1987-07-04	1	6393
30215	2043	1713332	2004-09-08	2004-11-24	1	12746
15913	1101	738818	1989-07-01	1989-07-08	1	7128
56510	3851	920293	1931-06-10	1931-06-24	2	-14071
25858	1751	1125315	2008-04-02	2008-04-09	1	13978
53433	3639	1759842	1948-12-26	1949-01-09	1	-7662
13719	938	1713332	2017-12-09	2017-12-16	1	17516
6119	419	1125315	1952-02-13	1952-02-27	1	-6518
74285	5078	1125315	1973-04-22	1973-05-06	1	1221
56312	3836	1738521	1977-08-01	1977-08-15	1	2783
3900	264	1125315	1972-10-09	1972-10-30	1	1033
56380	3841	1125315	1975-04-02	1975-04-20	2	1935
15674	1085	1125315	1965-12-30	1966-01-13	1	-1449
53674	3652	1112807	1975-10-11	1975-10-25	1	2123
15527	1077	1713332	1999-11-26	1999-12-10	1	10935
52488	3573	1759842	1949-06-04	1949-06-25	1	-7495
8761	606	1503184	1996-01-03	1996-12-28	1	9858
6547	453	1112807	1992-04-17	1992-05-08	1	8163
64449	4401	1112807	1971-11-20	1971-12-11	1	709
4020	273	738818	1980-11-17	1980-11-24	1	3980
9702	669	1118084	2004-10-07	2004-10-07	1	12698
311	19	1759842	1970-03-31	1970-04-21	1	110
12225	842	1125315	1992-01-28	1992-03-01	2	8095
65084	4447	1112807	1953-07-11	1953-07-25	1	-6004
60340	4113	1713332	1976-07-20	1976-08-03	1	2406
55338	3761	1728416	1959-10-26	1959-11-09	1	-3706
58876	4013	19127890	1988-11-13	1989-11-08	1	7251
23114	1569	1102527	1987-04-13	1987-04-13	1	6311
45938	3118	1759842	1966-05-09	1966-05-16	1	-1326
70085	4784	1738521	1976-09-06	1976-09-20	1	2454
77170	5276	1521369	1978-12-10	1979-12-05	1	3625
8745	605	1118084	1995-02-21	1995-02-21	1	9182
55684	3789	1738521	1976-04-15	1976-04-29	1	2310
55041	3745	738818	1984-05-13	1984-05-20	1	5253
63522	4342	1125315	1998-08-05	1998-08-12	1	10450
47539	3226	1759842	1978-12-06	1978-12-20	1	3275
58795	4009	740275	2007-03-28	2007-03-28	1	13600
30216	2043	1728416	1958-05-28	1958-06-11	1	-4222
15914	1101	1112807	1979-01-24	1979-02-07	1	3324
56511	3851	1112807	1913-05-20	1913-06-03	1	-20666
25859	1751	1177480	1995-05-16	1995-06-13	1	9294
53434	3639	1759842	1984-07-07	1984-07-28	1	5322
13720	938	1759842	2017-12-09	2017-12-16	1	17516
6120	419	1125315	1922-10-31	1922-11-07	1	-17222
74286	5078	1125315	1981-03-06	1981-04-03	1	4110
56313	3836	1125315	1977-08-01	1977-08-15	1	2783
3901	264	1125315	1995-04-03	1995-04-10	1	9230
56381	3841	1125315	2002-08-29	2002-09-05	1	11935
15675	1085	1713332	1976-01-28	1976-02-11	1	2232
53675	3652	1125315	1974-04-07	1974-04-21	1	1571
15528	1077	1759842	1977-07-13	1977-07-27	1	2764
52489	3573	1759842	1957-09-05	1957-09-19	1	-4487
8762	606	1515774	1994-01-13	1996-01-03	2	9498
6548	453	1118084	2004-05-26	2004-05-26	1	12564
64450	4401	1115008	2017-05-04	2017-05-25	1	17311
4021	273	738818	2014-03-27	2014-04-10	1	16170
9703	669	1125315	1985-06-09	1985-06-23	1	5652
312	19	1759842	2018-08-13	2018-08-20	1	17763
12226	842	1137529	1949-12-03	1949-12-03	1	-7334
65085	4447	1125315	1988-05-10	1988-05-24	1	6718
60341	4113	1118084	1992-05-13	1992-05-13	1	8168
55339	3761	1759842	1987-06-11	1987-06-18	1	6377
58877	4013	738818	1984-06-28	1984-07-05	1	5299
23115	1569	1112807	1938-12-08	1938-12-22	1	-11333
45939	3118	1112807	1949-11-30	1949-12-14	1	-7323
70086	4784	1759842	1970-02-17	1970-03-03	1	61
77171	5276	1713332	2001-02-05	2001-02-19	1	11372
8746	605	1125315	1961-03-22	1961-04-05	1	-3193
55685	3789	920293	1994-06-08	1994-06-15	1	8931
55042	3745	1112807	1932-03-01	1932-04-05	1	-13785
63523	4342	1125315	2015-08-05	2015-08-26	1	16673
48643	3308	1112807	1947-10-08	1947-10-22	1	-8107
58796	4009	1112807	1951-09-03	1951-10-07	1	-6661
30217	2043	1125315	1966-09-15	1966-09-29	1	-1190
15915	1101	1119510	1978-03-10	1978-03-24	1	3004
56512	3851	1112807	1916-12-21	1917-01-04	1	-19355
25860	1751	1729720	1985-06-20	1985-06-29	1	5658
53435	3639	738818	1929-03-07	1929-03-21	1	-14896
13721	938	1112807	1963-12-12	1964-01-11	1	-2182
6121	419	1125315	1987-03-08	1987-03-22	1	6289
74287	5078	1149380	1914-05-07	1914-05-07	1	-20328
56314	3836	1759842	1994-02-12	1994-02-26	1	8822
3902	264	1125315	2010-11-12	2010-11-26	1	14939
56382	3841	1503184	1989-09-04	1990-08-30	1	7546
15873	1099	738818	1955-02-27	1955-03-06	1	-5415
53676	3652	1125315	2015-03-04	2015-03-11	1	16505
15529	1077	1118084	1979-11-26	1979-11-26	1	3616
52490	3573	1112807	1928-03-02	1928-03-16	1	-15266
8763	606	1713332	2010-02-24	2010-03-03	1	14671
6549	453	1728416	1971-10-07	1971-10-21	1	658
64451	4401	1118084	2009-02-08	2009-02-08	1	14283
4022	273	1115008	2001-09-27	2001-11-26	1	11652
9704	669	1125315	2002-10-16	2002-10-23	1	11983
313	19	1124300	1985-05-16	1985-05-16	1	5614
12227	842	1149380	1949-12-03	1949-12-03	1	-7334
65086	4447	1125315	1998-06-03	1998-06-17	1	10394
60342	4113	1177480	1990-04-10	1990-04-24	1	7418
55573	3783	933724	1999-05-04	1999-05-11	1	10722
58878	4013	738818	1988-01-10	1988-01-24	1	6597
23116	1569	1112807	1941-07-29	1941-08-12	1	-10369
45940	3118	1137529	1986-06-08	1986-06-08	1	6002
72616	4963	1124300	2009-03-21	2009-03-21	1	14324
77172	5276	1759842	2001-02-05	2001-02-19	1	11372
8747	605	1177480	1982-11-26	1982-12-17	1	4733
55686	3789	1112807	1963-04-09	1963-05-09	1	-2429
55043	3745	1112807	1933-03-01	1933-03-31	1	-13425
63524	4342	1551099	1958-10-28	1958-10-28	1	-4083
48644	3308	1112807	1949-09-14	1949-09-28	1	-7400
58797	4009	1115008	2004-06-06	2004-06-20	1	12589
30218	2043	1713332	2017-10-08	2017-10-15	1	17454
15916	1101	1124300	2016-01-25	2016-01-25	1	16825
56513	3851	1112807	1927-10-04	1927-11-10	1	-15393
25861	1751	1729720	1990-05-07	1990-05-17	1	7441
53436	3639	738818	1954-06-03	1954-06-17	1	-5677
13722	938	1112807	1971-04-04	1971-04-18	1	472
6774	469	933724	1976-01-06	1976-01-13	1	2203
74288	5078	1713332	1982-06-14	1982-06-28	1	4561
56315	3836	1768849	1981-01-27	1981-02-10	1	4058
3903	264	1125315	2011-11-11	2011-11-11	1	15289
56383	3841	1549786	1990-08-30	1993-08-14	3	8626
15874	1099	1112807	1969-06-12	1969-07-03	1	-182
53677	3652	1503184	1996-07-20	1997-07-15	1	10057
15530	1077	1125315	1950-08-27	1950-09-10	1	-7053
52491	3573	1112807	1934-10-27	1935-01-25	1	-12760
8764	606	1102527	2013-12-24	2013-12-24	1	16063
6550	453	1112807	1971-04-10	1971-05-08	1	492
64452	4401	1521369	1983-01-01	1984-12-21	2	5468
4023	273	1125315	1980-11-17	1980-11-24	1	3980
9705	669	1503184	1987-09-07	1988-09-01	1	6818
314	19	1307863	2011-04-10	2011-04-10	1	15074
12228	842	1308738	1991-11-07	1991-11-07	1	7980
65087	4447	1125315	2015-01-05	2015-01-12	1	16447
60343	4113	1112807	1963-04-11	1963-04-25	1	-2443
55574	3783	1125315	2003-10-06	2003-10-13	1	12338
58879	4013	1118084	2015-04-26	2015-04-26	1	16551
23117	1569	1112807	1987-04-06	1987-06-12	1	6371
45941	3118	1174888	1964-04-06	1964-04-06	1	-2096
72617	4963	1125315	1976-05-29	1976-06-05	1	2347
77173	5276	1125315	1975-07-31	1975-08-21	1	2058
8748	605	738818	1987-03-09	1987-03-16	1	6283
55687	3789	1125315	1971-10-21	1971-10-28	1	665
55044	3745	1125315	1944-02-28	1944-03-13	1	-9425
63525	4342	1759842	2005-10-24	2005-11-14	1	13101
48645	3308	1125315	1951-07-19	1951-08-16	1	-6713
58798	4009	1118084	1992-05-15	1992-05-15	1	8170
30219	2043	1729720	1970-05-28	1970-06-04	1	154
15917	1101	1125315	1989-07-01	1989-07-08	1	7128
56514	3851	1125315	1969-02-17	1969-03-03	1	-304
25862	1751	1115008	2004-03-18	2004-04-01	1	12509
53437	3639	1112807	1961-02-16	1961-03-09	1	-3220
13723	938	1115008	2015-10-22	2015-11-21	1	16760
6775	469	1112807	1937-04-04	1937-04-18	1	-11946
74289	5078	1759842	1982-06-14	1982-06-28	1	4561
56316	3836	1115008	2015-02-04	2015-02-18	1	16484
3904	264	1177480	1995-06-05	1995-06-19	1	9300
56384	3841	19127890	1989-09-04	1995-08-04	6	9346
15875	1099	1112807	1983-08-24	1983-09-14	1	5004
53678	3652	1729720	1978-04-06	1978-04-16	1	3027
15531	1077	1125315	1958-11-18	1958-11-25	1	-4055
52492	3573	1112807	1970-04-05	1970-04-19	1	108
8765	606	1177480	1992-01-19	1992-03-19	1	8113
6551	453	1125315	1976-03-28	1976-04-11	1	2292
64453	4401	1713332	1989-01-10	1989-01-17	1	6956
4024	273	1125315	1981-05-15	1981-05-29	1	4166
9706	669	1521369	1989-08-27	1991-08-17	2	7898
315	19	1326303	2011-04-10	2011-04-10	1	15074
12229	842	1322184	2017-11-04	2017-11-04	1	17474
65088	4447	1177480	1975-01-17	1975-01-31	1	1856
60344	4113	1124957	1997-01-24	1997-01-24	1	9885
55575	3783	1551099	1940-12-01	1940-12-01	1	-10623
58880	4013	1125315	1988-01-10	1988-01-24	1	6597
23118	1569	1118084	1971-03-15	1971-03-15	1	438
45942	3118	1729720	1950-03-03	1950-03-16	1	-7231
72618	4963	1125315	1980-10-29	1980-11-05	1	3961
77174	5276	1503184	1975-12-26	1976-12-20	1	2545
8749	605	1125315	1961-08-30	1961-09-13	1	-3032
55688	3789	1713332	1951-04-30	1951-05-21	1	-6800
55045	3745	1125315	1984-05-13	1984-05-20	1	5253
63526	4342	1115008	2016-07-21	2016-08-11	1	17024
48646	3308	1125315	1979-11-17	1979-11-24	1	3614
58799	4009	1125315	1952-11-26	1952-12-10	1	-6231
30220	2043	1759842	2017-10-08	2017-10-15	1	17454
15918	1101	1125315	2014-10-06	2014-10-20	1	16363
56515	3851	1713332	1989-11-08	1989-11-15	1	7258
25863	1751	1177480	1980-09-12	1980-09-26	1	3921
53438	3639	1118084	1957-01-18	1957-01-18	1	-4731
13724	938	1124957	1963-12-12	1963-12-12	1	-2212
6776	469	1112807	1939-03-03	1939-03-17	1	-11248
77149	5274	1125315	1956-12-11	1957-02-09	1	-4709
56317	3836	1119510	2002-05-19	2002-06-02	1	11840
3905	264	1332418	2005-09-02	2005-09-02	1	13028
56385	3841	1125315	1974-04-16	1974-04-30	1	1580
15876	1099	1118084	1990-07-27	1990-07-27	1	7512
53679	3652	1729720	2002-05-11	2002-05-21	1	11828
15532	1077	1728416	1947-05-13	1947-05-27	1	-8255
53128	3621	1125315	1930-01-23	1930-01-30	1	-14581
8766	606	1515774	1989-02-08	1990-02-03	1	7338
6552	453	1125315	1977-02-09	1977-02-23	1	2610
64454	4401	1713332	1995-11-29	1995-12-06	1	9470
4025	273	1129625	1976-09-25	1976-09-25	1	2459
9707	669	1729720	2008-04-22	2008-04-30	1	13999
316	19	1124957	2003-07-16	2003-07-16	1	12249
12230	842	1332418	2017-11-04	2017-11-04	1	17474
65089	4447	1729720	1959-02-24	1959-03-08	1	-3952
60345	4113	1125315	1958-07-08	1958-07-15	1	-4188
55576	3783	1759842	1959-02-17	1959-03-03	1	-3957
58881	4013	1125315	2008-11-10	2008-11-17	1	14200
23119	1569	1125315	2016-06-24	2016-07-08	1	16990
45943	3118	1112807	1956-07-26	1956-08-16	1	-4886
72619	4963	1125315	2006-02-25	2006-03-18	1	13225
77175	5276	1503184	1978-12-10	1979-12-05	1	3625
8750	605	1125315	1972-04-09	1972-04-23	1	843
55689	3789	1759842	2016-12-29	2017-01-19	1	17185
55046	3745	1177480	2012-06-10	2012-06-24	1	15515
63527	4342	1118084	1993-02-16	1993-02-16	1	8447
48647	3308	1112807	1952-09-09	1952-09-30	1	-6302
58800	4009	1728416	1952-03-30	1952-04-13	1	-6472
30221	2043	1112807	1973-01-09	1973-02-08	1	1134
15919	1101	1713332	2012-02-17	2012-03-09	1	15408
56516	3851	1759842	1989-11-08	1989-11-15	1	7258
25864	1751	1759842	2015-11-18	2015-11-25	1	16764
53439	3639	1125315	1929-03-07	1929-03-21	1	-14896
13725	938	1125315	1958-02-12	1958-02-19	1	-4334
6777	469	1118084	1977-02-02	1977-02-02	1	2589
77150	5274	1118084	1989-11-13	1989-11-13	1	7256
56318	3836	1125315	1987-11-17	1987-12-01	1	6543
3906	264	1539403	2005-09-02	2005-09-02	1	13028
56386	3841	1521369	1993-08-14	1994-08-09	1	8986
15877	1099	1125315	1963-07-23	1963-07-30	1	-2347
53680	3652	1738521	1974-04-07	1974-04-21	1	1571
15533	1077	1112807	1947-05-13	1947-05-27	1	-8255
53129	3621	1125315	1989-01-16	1989-03-17	1	7015
8767	606	1713332	2013-12-24	2014-01-07	1	16077
6553	453	1125315	2014-04-18	2014-04-25	1	16185
64455	4401	1759842	1997-02-06	1997-02-20	1	9912
4026	273	1713332	1996-07-06	1996-07-27	1	9704
9708	669	1125315	1998-06-15	1998-07-06	1	10413
317	19	1125315	1977-09-01	1977-09-08	1	2807
12231	842	1759842	1950-12-04	1950-12-11	1	-6961
66330	4531	1112807	1948-05-28	1948-06-11	1	-7874
60346	4113	1125315	1961-07-20	1961-08-03	1	-3073
55577	3783	740275	1953-05-01	1953-11-06	1	-5900
58882	4013	1738521	1975-11-12	1975-11-26	1	2155
23120	1569	1557272	2007-03-02	2007-03-02	1	13574
45944	3118	1112807	1964-04-06	1964-06-05	1	-2036
72620	4963	1125315	2011-12-24	2011-12-31	1	15339
77176	5276	1118084	1998-03-25	1998-03-25	1	10310
8751	605	1125315	1987-03-09	1987-03-16	1	6283
55690	3789	1177480	1976-04-15	1976-04-29	1	2310
55047	3745	1759842	1969-07-04	1969-07-25	1	-160
63528	4342	1177480	2014-07-20	2014-08-10	1	16292
48648	3308	1125315	1977-12-18	1978-01-22	1	2943
58801	4009	1759842	1987-06-13	1987-07-04	1	6393
30222	2043	1118084	1997-08-21	1997-08-21	1	10094
15920	1101	1125315	1978-03-10	1978-03-24	1	3004
56517	3851	738818	1962-11-05	1962-11-12	1	-2607
25865	1751	1124300	2017-09-08	2017-09-08	1	17417
53440	3639	1125315	1954-06-03	1954-06-17	1	-5677
13726	938	1125315	1975-05-22	1975-05-29	1	1974
6778	469	1119510	1946-07-06	1946-07-13	1	-8573
77151	5274	1125315	1976-03-29	1976-04-19	1	2300
57036	3887	1112807	1968-12-08	1969-01-07	1	-359
3907	264	1545958	2011-11-11	2011-11-11	1	15289
56387	3841	1717327	1975-04-02	1975-04-16	1	1931
15878	1099	1125315	1968-05-05	1968-05-12	1	-599
53681	3652	19127890	1989-08-26	1990-08-21	1	7537
15534	1077	1112807	1963-10-16	1964-01-14	1	-2179
53130	3621	1119510	1993-11-01	1993-11-15	1	8719
8768	606	19127890	1993-01-18	1996-12-28	4	9858
6554	453	1738521	1976-03-28	1976-04-11	1	2292
64456	4401	1125315	2011-05-25	2011-06-08	1	15133
4027	273	1729720	2002-07-25	2002-08-02	1	11901
9709	669	1503184	1989-08-27	1991-08-17	2	7898
318	19	1125315	1997-08-25	1997-09-01	1	10105
12232	842	1759842	1969-03-12	1969-04-02	1	-274
66331	4531	1119510	2008-07-24	2008-07-31	1	14091
60347	4113	1125315	1964-06-04	1964-06-25	1	-2016
55578	3783	920293	1999-05-04	1999-05-11	1	10722
58883	4013	1738521	1977-07-18	1977-08-01	1	2769
23121	1569	1713332	1968-09-29	1968-10-20	1	-438
45945	3118	1125315	1951-05-08	1951-05-22	1	-6799
72621	4963	1713332	1980-01-08	1980-01-22	1	3673
77177	5276	1307863	2009-12-27	2009-12-27	1	14605
8752	605	1125315	2013-06-09	2013-06-16	1	15872
55691	3789	1759842	1951-04-30	1951-05-21	1	-6800
55048	3745	1115008	1997-02-23	1997-04-01	1	9952
63529	4342	1713332	1977-10-25	1977-11-01	1	2861
48649	3308	1539403	1991-02-11	1991-02-11	1	7711
58802	4009	738818	1956-07-18	1956-07-25	1	-4908
30223	2043	1125315	1973-12-30	1974-01-06	1	1466
15921	1101	1125315	1993-09-09	1993-09-16	1	8659
56518	3851	933724	1931-06-10	1931-06-24	1	-14071
25866	1751	1125315	1986-05-28	1986-07-02	1	6026
53441	3639	1125315	1994-03-15	1994-03-22	1	8846
13727	938	1125315	2017-05-22	2017-06-05	1	17322
6779	469	1125315	2004-10-20	2004-10-27	1	12718
77152	5274	1125315	1981-03-24	1981-04-28	1	4135
57037	3887	1125315	1957-06-20	1957-07-18	1	-4550
3908	264	1713332	1977-01-27	1977-02-17	1	2604
56388	3841	738818	2002-08-29	2002-09-05	1	11935
15879	1099	1125315	2007-05-23	2007-06-06	1	13670
53682	3652	19127890	1992-08-10	1993-08-05	1	8617
15535	1077	1119510	1983-10-06	1983-10-13	1	5033
53131	3621	1125315	1963-12-08	1964-03-07	2	-2126
8769	606	738818	2004-02-20	2004-02-27	1	12475
6555	453	1102527	2004-02-05	2004-02-05	1	12453
64457	4401	1149380	1973-01-10	1990-01-20	1	7324
4028	273	1759842	1996-07-06	1996-07-27	1	9704
9710	669	1549786	1991-08-17	1992-08-11	1	8258
319	19	1310149	2011-04-10	2011-04-10	1	15074
12233	842	1759842	1987-02-02	1987-02-16	1	6255
66332	4531	1124300	1950-03-13	1950-03-13	1	-7234
60348	4113	1125315	1969-03-31	1969-04-30	1	-246
55579	3783	1112807	1943-06-19	1943-07-03	1	-9679
58884	4013	1738521	1978-12-17	1978-12-31	1	3286
23122	1569	1713332	1976-12-14	1977-01-04	1	2560
45946	3118	1125315	1952-07-05	1952-07-19	1	-6375
72622	4963	1729720	2010-08-31	2010-09-07	1	14859
77178	5276	1728416	1958-02-18	1958-03-04	1	-4321
8753	605	1177480	2015-04-19	2015-05-10	1	16565
55692	3789	1112807	1945-08-11	1945-08-25	1	-8895
55049	3745	1124957	1997-03-02	1997-03-02	1	9922
63530	4342	1125315	1958-06-30	1958-07-14	1	-4189
48650	3308	1545958	1996-11-18	1996-11-18	1	9818
58803	4009	920293	1996-08-23	1996-08-30	1	9738
30224	2043	1759842	1974-12-08	1975-03-30	1	1914
15922	1101	1309944	1982-08-22	1982-08-22	1	4616
56519	3851	1112807	1924-07-08	1924-07-22	1	-16599
25867	1751	1125315	1987-05-28	1987-06-27	1	6386
53442	3639	1125315	1998-06-27	1998-07-04	1	10411
13728	938	1713332	2000-02-19	2000-03-04	1	11020
6780	469	1125315	2014-12-19	2015-03-19	2	16513
77153	5274	1125315	1966-02-22	1966-03-22	1	-1381
57038	3887	1125315	1960-05-03	1960-05-24	1	-3509
3909	264	1728416	1955-11-26	1955-12-10	1	-5136
56389	3841	1119510	1975-04-13	1975-04-20	1	1935
15880	1099	1112807	1957-06-28	1957-07-12	1	-4556
53683	3652	19127890	1994-07-31	1995-07-26	1	9337
15536	1077	1125315	1999-08-14	1999-08-28	1	10831
53132	3621	1125315	1972-02-28	1972-03-06	1	795
8770	606	933724	1997-03-03	1997-03-10	1	9930
6556	453	1112807	1971-10-07	1971-10-21	1	658
64793	4423	1125315	1998-09-22	1998-09-29	1	10498
4029	273	1177480	2002-11-21	2002-12-21	1	12042
9711	669	1778162	1996-01-13	1996-01-27	1	9522
320	19	1713332	1970-03-31	1970-04-21	1	110
12234	842	1759842	1990-01-09	1990-01-16	1	7320
66333	4531	1125315	1924-02-26	1924-03-11	1	-16732
60349	4113	1728416	1963-04-11	1963-04-25	1	-2443
55580	3783	1119510	1985-07-21	1985-07-28	1	5687
58885	4013	1119510	1984-06-28	1984-07-05	1	5299
23123	1569	1729720	1945-04-09	1945-04-20	1	-9022
45947	3118	1125315	1953-12-01	1953-12-15	1	-5861
72623	4963	1112807	1981-12-28	1982-02-01	1	4414
77179	5276	1729720	1962-10-26	1962-11-08	1	-2611
8754	605	1192710	1959-07-06	1959-07-06	1	-3832
55693	3789	1115008	2014-12-05	2015-01-09	1	16444
55050	3745	1551099	1935-05-19	1935-05-19	1	-12646
63531	4342	1125315	1964-01-02	1964-01-09	1	-2184
48651	3308	1728416	1947-10-08	1947-10-22	1	-8107
58804	4009	1125315	1956-07-18	1956-07-25	1	-4908
30225	2043	1759842	2004-09-08	2004-11-24	1	12746
15923	1101	1343916	1982-08-22	1982-08-22	1	4616
56520	3851	1112807	1963-09-02	1963-10-07	1	-2278
25868	1751	1125315	2017-05-24	2017-06-07	1	17324
53443	3639	1125315	1999-12-27	2000-01-10	1	10966
13729	938	1759842	2000-02-19	2000-03-04	1	11020
6781	469	1310149	2013-09-28	2013-09-28	1	15976
77154	5274	1125315	1998-03-16	1998-03-30	1	10315
57039	3887	1125315	1973-05-08	1973-05-22	1	1237
3910	264	738818	1958-05-23	1958-05-30	1	-4234
56390	3841	1124300	2017-03-01	2017-03-01	1	17226
15881	1099	1125315	1955-02-27	1955-03-06	1	-5415
53684	3652	1118084	2009-05-23	2009-05-23	1	14387
15537	1077	1759842	1999-11-26	1999-12-10	1	10935
53133	3621	1137529	1971-07-17	1971-07-17	1	562
8771	606	1125315	1987-06-09	1987-07-14	1	6403
6557	453	1713332	2004-02-05	2004-03-04	1	12481
64794	4423	1119510	2001-10-15	2001-10-29	1	11624
4030	273	1759842	1975-10-21	1975-11-04	1	2133
9712	669	19127890	1987-09-07	1988-09-01	1	6818
1517	101	1112807	1955-06-20	1955-07-25	1	-5274
12235	842	738818	2011-07-13	2011-07-20	1	15175
66334	4531	1125315	2008-07-24	2008-07-31	1	14091
60350	4113	1729720	1984-05-05	1984-05-13	1	5246
55581	3783	1125315	1946-03-06	1946-03-20	1	-8688
58886	4013	1119510	1988-01-10	1988-01-24	1	6597
23124	1569	1729720	1945-06-22	1945-07-03	1	-8948
45948	3118	1149380	1986-06-08	1986-06-08	1	6002
72624	4963	1729720	1986-08-26	1986-09-07	1	6093
77180	5276	1738521	1970-10-04	1970-10-25	1	297
8755	605	1521369	1977-05-06	1978-05-01	1	3042
55694	3789	1125315	1970-10-29	1970-11-26	1	329
55051	3745	1713332	1985-01-21	1985-01-28	1	5506
63532	4342	1713332	2005-10-24	2005-11-14	1	13101
48652	3308	1728416	1949-09-14	1949-09-28	1	-7400
58805	4009	1125315	1984-01-08	1984-01-15	1	5127
31545	2135	1112807	1957-08-18	1957-10-17	1	-4459
15924	1101	1729720	1976-03-12	1976-03-19	1	2269
56521	3851	1112807	1987-08-02	1987-08-16	1	6436
25869	1751	1713332	2015-11-18	2015-11-25	1	16764
53444	3639	1322184	2007-07-07	2007-07-07	1	13701
16682	1148	1118084	2001-07-01	2001-07-01	1	11504
6782	469	738818	1955-07-02	1955-07-09	1	-5290
77155	5274	1125315	1999-12-18	2000-01-01	1	10957
57040	3887	1125315	1975-06-22	1975-06-29	1	2005
3911	264	1112807	1955-11-26	1955-12-10	1	-5136
56391	3841	1125315	2009-10-30	2009-12-04	1	14582
15882	1099	1125315	1977-05-09	1977-05-23	1	2699
53685	3652	1503184	1989-08-26	1990-08-21	1	7537
15538	1077	1125315	1983-10-06	1983-10-13	1	5033
53134	3621	1729720	1932-03-07	1932-03-14	1	-13807
8772	606	1125315	2004-02-20	2004-02-27	1	12475
7683	533	1112807	1968-02-01	1968-02-15	1	-686
64795	4423	1125315	1984-03-21	1984-04-04	1	5207
5254	359	1125315	1988-01-08	1988-01-22	1	6595
10885	747	1115008	2003-07-14	2003-08-04	1	12268
1518	101	1112807	1960-04-29	1960-05-13	1	-3520
12236	842	1112807	1940-08-16	1940-09-15	1	-10700
66335	4531	1125315	2009-12-24	2009-12-31	1	14609
60351	4113	1115008	2011-08-14	2011-09-04	1	15221
55582	3783	1125315	1969-03-21	1969-04-04	1	-272
58887	4013	1503184	1988-11-13	1989-11-08	1	7251
23125	1569	1112807	1957-05-17	1957-06-07	1	-4591
45949	3118	1713332	2004-06-22	2004-07-13	1	12612
72625	4963	1125315	1980-01-08	1980-01-22	1	3673
77181	5276	19127890	1975-12-26	1976-12-20	1	2545
8756	605	1728416	1961-08-30	1961-09-13	1	-3032
55695	3789	1713332	2016-12-29	2017-01-19	1	17185
55052	3745	1759842	1986-03-02	1986-03-23	1	5925
63533	4342	1728416	1958-06-30	1958-07-14	1	-4189
48653	3308	1729720	1949-05-04	1949-05-17	1	-7534
60490	4125	738818	2015-05-20	2015-05-27	1	16582
31546	2135	1112807	1961-06-28	1961-09-26	1	-3019
17179	1185	738818	2011-06-06	2011-06-20	1	15145
56522	3851	1124957	1927-10-11	1927-10-11	1	-15423
25870	1751	1119510	1979-04-22	1979-04-29	1	3405
53445	3639	1326303	2004-01-31	2004-01-31	1	12448
16683	1148	1125315	1965-12-07	1966-01-11	1	-1451
6783	469	920293	1976-01-06	1976-01-13	1	2203
77156	5274	738818	1998-03-16	1998-03-30	1	10315
57041	3887	1713332	2010-08-01	2010-08-08	1	14829
3912	264	1119510	2010-11-12	2010-11-26	1	14939
56392	3841	1503184	1993-08-14	1994-08-09	1	8986
15883	1099	1125315	2005-09-06	2005-09-20	1	13046
53686	3652	1515774	1992-08-10	1993-08-05	1	8617
15539	1077	1177480	2007-05-03	2007-05-17	1	13650
53135	3621	738818	1993-11-01	1993-11-15	1	8719
8773	606	1125315	2013-12-24	2014-01-07	1	16077
7684	533	1119510	1981-05-29	1981-06-12	1	4180
64796	4423	1125315	2001-10-15	2001-10-29	1	11624
5255	359	1729720	1990-06-12	1990-06-23	1	7478
10886	747	1125315	1994-06-11	1994-06-18	1	8934
1519	101	1115008	2014-07-21	2014-08-20	1	16302
12237	842	1115008	1997-11-30	1998-01-04	1	10230
66336	4531	1125315	2017-04-29	2017-04-29	1	17285
60352	4113	1125315	1978-05-25	1978-06-01	1	3073
55583	3783	1125315	2006-04-01	2006-04-08	1	13246
58888	4013	1125315	1984-06-28	1984-07-05	1	5299
23126	1569	1119510	1974-08-15	1974-08-22	1	1694
45950	3118	1728416	1951-05-08	1951-05-22	1	-6799
72626	4963	1125315	1982-07-06	1982-07-13	1	4576
77182	5276	19127890	1978-12-10	1979-12-05	1	3625
10021	689	1115008	1995-04-14	1995-05-12	1	9262
58238	3972	1112807	1967-10-26	1967-12-25	1	-738
55053	3745	1112807	1930-06-10	1930-06-24	1	-14436
63534	4342	1759842	1977-10-25	1977-11-01	1	2861
48654	3308	1729720	1950-08-14	1950-08-22	1	-7072
60491	4125	1125315	2015-05-20	2015-05-27	1	16582
31547	2135	1112807	1968-09-03	1968-09-17	1	-471
17180	1185	1102527	2008-02-11	2008-02-11	1	13920
56523	3851	1125315	1918-12-22	1918-12-29	1	-18631
25871	1751	1125315	1988-02-21	1988-02-28	1	6632
53446	3639	1332418	2007-07-07	2007-07-07	1	13701
16684	1148	1729720	1963-02-03	1963-02-10	1	-2517
6784	469	1112807	1937-06-07	1937-06-21	1	-11882
77157	5274	1119510	1998-03-16	1998-03-30	1	10315
57042	3887	920293	1977-07-16	1977-07-23	1	2760
3913	264	1125315	1958-05-23	1958-05-30	1	-4234
56393	3841	1549786	1994-08-09	1995-08-04	1	9346
15884	1099	1177480	2018-10-24	2018-11-07	1	17842
53687	3652	1515774	1994-07-31	1995-07-26	1	9337
15540	1077	1713332	1977-07-13	1977-07-27	1	2764
53136	3621	1112807	1923-07-06	1923-07-20	1	-16967
8774	606	1503184	1993-01-18	1994-01-13	1	8778
7685	533	1713332	2000-07-01	2000-07-22	1	11160
64797	4423	1778162	1991-05-20	1991-06-03	1	7823
5256	359	1759842	2006-03-31	2006-04-07	1	13245
10887	747	1177480	2008-06-08	2008-07-06	1	14066
1520	101	1119510	1962-04-19	1962-04-26	1	-2807
12238	842	1118084	1943-05-08	1943-05-08	1	-9735
66337	4531	1177480	1983-07-22	1983-10-20	1	5040
60353	4113	1125315	2005-11-08	2005-11-29	1	13116
55584	3783	1177480	2008-11-02	2008-12-02	1	14215
58889	4013	1521369	1988-11-13	1989-11-08	1	7251
23127	1569	1177480	2018-01-28	2018-02-18	1	17580
50350	3431	1322184	2001-10-17	2001-10-17	1	11612
73268	5007	723013	2000-08-13	2001-02-25	1	11378
77183	5276	920293	1975-02-23	1975-03-02	1	1886
10022	689	1115008	1997-05-31	1997-07-30	1	10072
58239	3972	1125315	2014-01-09	2014-01-16	1	16086
55054	3745	1118084	1973-03-21	1973-03-21	1	1175
64930	4435	1115008	2018-11-11	2018-12-09	1	17874
48655	3308	1729720	1960-11-14	1960-11-27	1	-3322
60492	4125	1738521	1971-06-30	1971-07-14	1	559
31548	2135	1112807	1969-07-14	1969-08-11	1	-143
17181	1185	1112807	1971-05-30	1971-06-20	1	535
56524	3851	1125315	1962-11-05	1962-11-12	1	-2607
25872	1751	1125315	2013-01-14	2013-02-18	1	15754
53447	3639	1539403	2007-07-07	2007-07-07	1	13701
16685	1148	1112807	1967-09-03	1967-10-03	1	-821
6785	469	1119510	2010-08-28	2010-09-11	1	14863
77158	5274	1125315	1953-09-29	1953-10-06	1	-5931
57043	3887	933724	1977-07-16	1977-07-23	1	2760
3914	264	1125315	1984-09-16	1984-09-30	1	5386
56394	3841	1713332	2018-03-10	2018-03-31	1	17621
15885	1099	1728416	1953-01-07	1953-01-21	1	-6189
53688	3652	1549786	1992-08-10	1993-08-05	1	8617
15541	1077	1729720	1996-02-05	1996-02-13	1	9539
53137	3621	1112807	1929-08-03	1929-09-02	1	-14731
8775	606	1521369	1993-01-18	1994-01-13	1	8778
7686	533	1112807	1971-04-16	1971-05-07	1	491
64798	4423	738818	1998-09-22	1998-09-29	1	10498
5257	359	1729720	1982-07-13	1982-07-23	1	4586
10888	747	1713332	1992-08-29	1992-09-05	1	8283
1521	101	1125315	1932-04-23	1932-05-07	1	-13753
12239	842	1119510	1938-03-25	1938-04-01	1	-11598
66338	4531	1332418	1994-10-29	1994-10-29	1	9067
60354	4113	1177480	2008-10-14	2008-10-28	1	14180
55585	3783	1177480	2016-01-25	2016-02-29	1	16860
60440	4121	1112807	1933-06-30	1933-08-04	1	-13299
23128	1569	1728416	1956-01-26	1956-02-09	1	-5075
50351	3431	920293	1988-10-29	1988-11-05	1	6883
73269	5007	723013	2001-08-19	2001-11-25	1	11651
77184	5276	1112807	1958-02-18	1958-03-04	1	-4321
10023	689	1125315	1983-08-15	1983-08-29	1	4988
58240	3972	1125315	2018-05-27	2018-06-10	1	17692
55055	3745	1119510	1944-02-28	1944-03-13	1	-9425
64931	4435	1118084	2000-10-14	2000-10-14	1	11244
48656	3308	1118084	1984-06-15	1984-06-15	1	5279
60493	4125	1759842	1985-11-15	1985-11-22	1	5804
31549	2135	1115008	2004-05-09	2004-05-30	1	12568
17182	1185	1119510	2011-06-06	2011-06-20	1	15145
56525	3851	1322184	1997-08-04	1997-08-04	1	10077
25873	1751	1177480	1999-04-23	1999-05-14	1	10725
53448	3639	1713332	1982-05-19	1982-06-09	1	4542
16686	1148	1115008	2002-02-15	2002-03-01	1	11747
6786	469	1124957	2014-12-19	2014-12-19	1	16423
77159	5274	1177480	2006-06-16	2006-09-14	1	13405
57044	3887	1125315	1980-09-01	1980-09-08	1	3903
3915	264	1177480	2007-06-16	2007-07-07	1	13701
56395	3841	1759842	2018-03-10	2018-03-31	1	17621
15886	1099	1125315	1990-02-09	1990-02-23	1	7358
53689	3652	1549786	1994-07-31	1995-07-26	1	9337
15746	1091	1119510	1985-04-18	1985-04-25	1	5593
53138	3621	1112807	1950-01-15	1950-01-29	1	-7277
8776	606	1521369	1996-01-03	1996-12-28	1	9858
7687	533	1125315	1981-05-29	1981-06-12	1	4180
64799	4423	1118084	2011-03-01	2011-03-01	1	15034
5258	359	1118084	2014-10-28	2014-10-28	1	16371
10889	747	1729720	2005-07-07	2005-07-19	1	12983
1522	101	1125315	2016-05-11	2016-06-15	1	16967
12240	842	1119510	1988-05-10	1988-05-17	1	6711
66339	4531	1545958	2017-04-29	2017-04-29	1	17285
60355	4113	1717327	1961-07-20	1961-08-03	1	-3073
55586	3783	1729720	1953-05-15	1953-05-28	1	-6062
60441	4121	1177480	1979-10-30	1979-12-04	1	3624
23129	1569	1729720	2006-06-15	2006-06-22	1	13321
50352	3431	1112807	1966-06-21	1966-07-05	1	-1276
73270	5007	723013	2002-08-25	2002-12-22	1	12043
77185	5276	1115008	2015-05-14	2015-06-20	1	16606
10024	689	1125315	2010-03-27	2010-04-10	1	14709
58241	3972	1177480	2016-03-22	2016-04-19	1	16910
55056	3745	1119510	1984-05-13	1984-05-20	1	5253
64932	4435	1125315	1989-12-01	1989-12-08	1	7281
48657	3308	1125315	1977-08-02	1977-08-16	1	2784
60494	4125	1125315	1971-06-30	1971-07-14	1	559
31550	2135	1115008	2011-05-24	2011-06-07	1	15132
17183	1185	1125315	2011-06-06	2011-06-20	1	15145
56526	3851	1361711	1992-07-06	1992-07-06	1	8222
25874	1751	1729720	2011-05-15	2011-05-22	1	15116
53449	3639	1713332	2004-10-28	2005-06-23	1	12957
16687	1148	1125315	1958-09-15	1958-09-29	1	-4112
6787	469	1125315	1955-07-02	1955-07-09	1	-5290
1652	111	933724	1994-05-25	1994-06-01	1	8917
57045	3887	1177480	1984-11-14	1984-11-28	1	5445
3916	264	1713332	1987-03-26	1987-04-09	1	6307
58575	3995	920293	2014-02-27	2014-03-06	1	16135
15887	1099	1738521	1977-05-09	1977-05-23	1	2699
53690	3652	1759842	1992-11-27	1992-12-11	1	8380
15747	1091	1125315	1966-05-18	1966-05-25	1	-1317
53139	3621	1124300	1955-08-27	1955-08-27	1	-5241
8777	606	1549786	1989-02-08	1990-02-03	1	7338
7688	533	1717327	1968-02-01	1968-02-15	1	-686
64800	4423	1119510	1998-09-22	1998-09-29	1	10498
5259	359	1125315	1983-09-21	1983-10-19	1	5039
10890	747	1112807	1985-12-24	1986-01-14	1	5857
1523	101	1309944	2001-01-12	2001-01-12	1	11334
12241	842	1125315	1985-08-09	1985-08-23	1	5713
66340	4531	1713332	1983-02-03	1983-02-17	1	4795
60356	4113	1759842	1976-07-20	1976-08-03	1	2406
55587	3783	1102527	2008-11-02	2008-11-02	1	14185
60442	4121	1729720	1930-12-30	1931-01-12	1	-14234
23130	1569	920293	1972-10-01	1972-10-15	2	1018
50353	3431	1118084	1999-05-19	1999-05-19	1	10730
73271	5007	738818	1999-08-02	1999-08-16	1	10819
77186	5276	1125315	1960-06-08	1960-06-22	1	-3480
10025	689	1515774	2004-01-07	2005-01-01	1	12784
58242	3972	738818	2018-05-27	2018-06-10	1	17692
55057	3745	1125315	2003-12-03	2003-12-17	1	12403
64933	4435	1322184	2002-04-15	2002-04-15	1	11792
48658	3308	1125315	1991-02-05	1991-02-19	1	7719
60495	4125	1125315	1972-08-25	1972-09-01	1	974
31551	2135	1713332	1983-12-07	1983-12-28	1	5109
17184	1185	1322184	2018-09-23	2018-09-23	1	17797
56527	3851	1759842	1952-07-03	1952-07-24	1	-6370
26612	1796	1177480	2016-05-01	2016-06-05	1	16957
53450	3639	1759842	1982-05-19	1982-06-09	1	4542
16688	1148	1125315	1959-01-21	1959-02-04	1	-3984
6788	469	1326303	2013-09-28	2013-09-28	1	15976
1653	111	1118084	2012-02-07	2012-02-07	1	15377
57046	3887	1125315	1963-09-19	1963-09-26	1	-2289
3917	264	1728416	1954-08-10	1954-08-24	1	-5609
58576	3995	1119510	1998-04-23	1998-04-30	1	10346
15888	1099	1112807	1953-01-07	1953-01-21	1	-6189
53691	3652	1759842	2007-03-02	2007-03-23	1	13595
15748	1091	1503184	1976-05-03	1977-04-28	1	2674
53140	3621	1124957	1963-12-08	1963-12-08	1	-2216
8778	606	1549786	1994-01-13	1996-01-03	2	9498
7689	533	738818	1981-05-29	1981-06-12	1	4180
64801	4423	1125315	1977-07-12	1977-07-26	1	2763
5260	359	1125315	1986-09-06	1986-09-13	1	6099
10891	747	1759842	1992-08-29	1992-09-05	1	8283
1524	101	1343916	2001-01-12	2001-01-12	1	11334
12242	842	1125315	2011-07-13	2011-07-20	1	15175
66341	4531	1759842	1983-02-03	1983-02-17	1	4795
61487	4199	1112807	1946-11-12	1946-12-17	1	-8416
55588	3783	1125315	1974-06-22	1974-07-06	1	1647
60443	4121	1102527	1948-05-17	1948-05-17	1	-7899
23131	1569	933724	1972-10-01	1972-10-15	1	1018
50354	3431	1125315	2000-08-17	2000-09-07	1	11207
73272	5007	1125315	1999-08-02	1999-08-16	1	10819
77187	5276	1125315	1965-08-10	1965-08-31	1	-1584
10026	689	1549786	2002-01-17	2003-01-12	1	12064
58243	3972	1112807	1972-12-03	1973-01-07	1	1102
55058	3745	1125315	1997-03-02	1997-03-02	1	9922
64934	4435	1332418	2002-04-15	2002-04-15	1	11792
48659	3308	1332418	1995-02-20	1995-02-20	1	9181
60496	4125	1309944	1988-10-25	1988-10-25	1	6872
31552	2135	1759842	1983-12-07	1983-12-28	1	5109
17185	1185	1347450	2018-09-23	2018-09-23	1	17797
56528	3851	1112807	1913-11-05	1913-11-19	1	-20497
26613	1796	1515774	2004-02-02	2005-01-27	1	12810
53451	3639	1759842	2004-10-28	2005-06-23	1	12957
16689	1148	1125315	1964-03-19	1964-03-26	1	-2107
6789	469	1759842	1990-04-18	1990-04-25	1	7419
1654	111	1125315	1985-12-26	1986-01-09	1	5852
57047	3887	1125315	1982-11-28	1982-12-12	1	4728
3918	264	1759842	1977-01-27	1977-02-17	1	2604
58577	3995	1125315	1973-05-03	1973-05-17	1	1232
15889	1099	1119510	1955-02-27	1955-03-06	1	-5415
53692	3652	19127890	1987-09-06	1988-08-31	1	6817
15749	1091	1503184	1978-04-23	1979-04-18	1	3394
53141	3621	1125315	1924-11-29	1924-12-13	1	-16455
8779	606	1738521	1976-06-18	1976-07-02	1	2374
7690	533	1112807	1963-06-27	1963-08-26	1	-2320
64802	4423	1309944	1989-04-21	1989-04-21	1	7050
5261	359	1125315	1992-06-05	1992-06-19	1	8205
10892	747	1118084	1996-01-31	1996-01-31	1	9526
1525	101	1713332	2008-07-30	2008-08-06	1	14097
12243	842	1361711	2017-11-04	2017-11-04	1	17474
66342	4531	738818	2008-07-24	2008-07-31	1	14091
61488	4199	1118084	1979-08-06	1979-08-06	1	3504
55589	3783	1177480	2005-09-21	2005-10-19	1	13075
60444	4121	1112807	1925-11-18	1925-12-09	1	-16094
23132	1569	1112807	1937-11-28	1937-12-12	1	-11708
50355	3431	1154343	1964-10-16	1964-10-16	1	-1903
73273	5007	1177480	2000-06-25	2000-07-09	1	11147
77188	5276	1177480	1994-05-13	1994-06-03	1	8919
10027	689	1549786	2004-01-07	2005-01-01	1	12784
58244	3972	1125315	1960-04-06	1960-04-13	1	-3550
55059	3745	1125315	2013-04-07	2013-05-12	1	15837
64935	4435	1539403	2002-04-15	2002-04-15	1	11792
48660	3308	1361711	1981-04-27	1996-11-18	1	9818
60497	4125	1343916	1988-10-25	1988-10-25	1	6872
31553	2135	920293	1991-03-01	1991-03-08	1	7736
17186	1185	1713332	1988-01-12	1988-01-26	1	6599
56529	3851	1119510	1962-11-05	1962-11-12	1	-2607
26614	1796	1521369	1998-03-05	2000-02-23	2	11010
53452	3639	701322	2004-05-27	2004-05-27	1	12565
16690	1148	1728416	1958-09-15	1958-09-29	1	-4112
6790	469	1119510	1955-07-02	1955-07-09	1	-5290
1655	111	1729720	1979-01-13	1979-01-25	1	3311
57048	3887	1759842	2010-08-01	2010-08-08	1	14829
7019	484	1125315	1958-03-21	1958-04-04	1	-4290
58578	3995	1125315	1974-02-27	1974-05-28	1	1608
15890	1099	1177480	1979-09-09	1979-10-14	1	3573
53693	3652	19127890	1996-07-20	1997-07-15	1	10057
15750	1091	1713332	2016-09-15	2016-09-29	1	17073
53142	3621	1125315	1960-05-06	1960-05-27	1	-3506
8780	606	1119510	2004-02-20	2004-02-27	1	12475
7691	533	1125315	1979-07-24	1979-08-23	1	3521
64803	4423	1343916	1989-04-21	1989-04-21	1	7050
5262	359	1713332	2006-03-31	2006-04-07	1	13245
17069	1176	738818	1981-07-29	1981-08-12	1	4241
1526	101	1713332	2017-08-24	2017-09-14	1	17423
12244	842	1713332	1950-12-04	1950-12-11	1	-6961
66343	4531	1124957	1930-04-21	1930-04-21	1	-14500
61489	4199	1125315	1970-06-14	1970-06-14	1	164
55590	3783	1551099	1948-09-25	1948-09-25	1	-7768
60445	4121	1112807	1986-08-29	1986-09-26	1	6112
23133	1569	1112807	1973-01-14	1973-02-18	1	1144
50356	3431	1177480	1981-09-05	1981-09-26	1	4286
73274	5007	1115008	2008-08-26	2008-09-09	1	14131
77189	5276	1326303	2009-12-27	2009-12-27	1	14605
10028	689	19127890	2004-01-07	2005-01-01	1	12784
58245	3972	1119510	2018-05-27	2018-06-10	1	17692
55060	3745	1137529	1993-05-26	1993-05-26	1	8546
64936	4435	1729720	2005-11-09	2005-11-17	1	13104
48661	3308	1728416	1948-11-14	1948-11-28	1	-7704
60498	4125	914335	1988-10-25	1988-10-25	1	6872
31554	2135	933724	1991-03-01	1991-03-08	1	7736
17187	1185	1729720	1947-04-22	1947-05-03	1	-8279
56530	3851	1125315	1935-12-31	1936-01-14	1	-12406
26615	1796	1713332	2015-11-28	2015-12-12	1	16781
53453	3639	738818	1978-03-01	1978-03-08	1	2988
16691	1148	1112807	1976-05-18	1976-06-01	1	2343
6791	469	1125315	1969-07-04	1969-07-18	1	-167
1656	111	19127890	1994-04-07	1998-03-17	4	10302
57049	3887	1118084	1990-04-08	1990-04-08	1	7402
7020	484	1125315	1976-06-12	1976-06-26	1	2368
58579	3995	1738521	1973-05-03	1973-05-17	1	1232
15891	1099	1728416	1957-06-28	1957-07-12	1	-4556
53694	3652	920293	2011-10-13	2011-10-20	1	15267
15751	1091	1729720	2017-02-26	2017-03-08	1	17233
53143	3621	1125315	1967-07-03	1967-07-10	1	-906
8781	606	1125315	1975-07-12	1975-07-26	1	2032
7692	533	1125315	1988-08-05	1988-08-19	1	6805
64804	4423	1713332	1984-03-21	1984-04-04	1	5207
5740	395	1112807	1961-11-07	1961-11-21	1	-2963
17070	1176	1112807	1967-08-24	1967-09-28	1	-826
1527	101	1729720	1983-04-17	1983-04-25	1	4862
12245	842	1713332	1969-03-12	1969-04-02	1	-274
66344	4531	1125315	1949-05-21	1949-06-04	1	-7516
61490	4199	1125315	1976-01-04	1976-01-18	1	2208
55591	3783	1713332	1999-02-28	1999-03-14	1	10664
60446	4121	1149380	1968-05-12	1968-05-12	1	-599
23134	1569	1119510	2016-06-24	2016-07-08	1	16990
50357	3431	1347450	2001-10-17	2001-10-17	1	11612
73275	5007	1713332	1999-11-18	1999-11-25	1	10920
42388	2871	1174888	2017-03-15	2017-03-15	1	17240
10029	689	1503184	1999-02-02	2000-01-28	1	10984
58246	3972	1729720	1979-07-09	1979-07-19	1	3486
55061	3745	1149380	1993-05-26	1993-05-26	1	8546
64937	4435	1102527	2015-09-28	2015-09-28	1	16706
48662	3308	1112807	1948-11-14	1948-11-28	1	-7704
60499	4125	1119510	2015-05-20	2015-05-27	1	16582
31555	2135	1125315	1967-05-12	1967-05-19	1	-958
17188	1185	738818	1946-04-13	1946-04-27	1	-8650
56531	3851	1332418	1994-07-18	1994-07-18	1	8964
26616	1796	19127890	2004-02-02	2005-01-27	1	12810
53454	3639	738818	2002-09-06	2002-09-20	1	11950
16692	1148	1728416	1959-01-21	1959-02-04	1	-3984
6792	469	1713332	1990-04-18	1990-04-25	1	7419
1657	111	920293	1994-05-25	1994-06-01	1	8917
57050	3887	1125315	1977-05-20	1977-06-03	1	2710
7021	484	1125315	1997-03-15	1997-03-15	1	9935
58580	3995	19127890	1986-02-04	1987-01-30	1	6238
15892	1099	1729720	1979-03-23	1979-04-02	1	3378
53695	3652	933724	2011-10-13	2011-10-20	1	15267
15752	1091	1759842	2016-09-15	2016-09-29	1	17073
53144	3621	1125315	1973-12-15	1974-01-05	1	1465
8782	606	1728416	1975-07-12	1975-07-26	1	2032
7693	533	1129625	1966-08-21	1966-08-21	1	-1229
64805	4423	738818	2001-10-15	2001-10-29	1	11624
5741	395	1112807	1964-11-08	1965-01-11	2	-1845
17071	1176	1125315	1981-07-29	1981-08-12	1	4241
1528	101	1759842	2008-07-30	2008-08-06	1	14097
12246	842	738818	1938-03-25	1938-04-01	1	-11598
66345	4531	1174888	2017-04-29	2017-04-29	1	17285
61491	4199	1125315	1987-12-15	1987-12-29	1	6571
55592	3783	1759842	1999-02-28	1999-03-14	1	10664
60447	4121	1728416	1948-05-17	1948-06-14	1	-7871
23135	1569	1125315	2005-02-12	2005-02-26	1	12840
50358	3431	1729720	1967-10-15	1967-10-28	1	-796
73276	5007	723013	1995-03-24	1995-07-28	1	9339
42389	2871	1177480	2017-03-15	2017-04-14	1	17270
10030	689	1521369	1998-02-07	2000-01-28	2	10984
58247	3972	1112807	1971-10-05	1971-11-09	1	677
55062	3745	1177480	2018-05-16	2018-08-14	1	17757
64938	4435	1125315	1982-03-15	1982-03-29	1	4470
48663	3308	1125315	1996-11-18	1996-11-18	1	9818
60500	4125	1125315	1969-07-10	1969-07-24	1	-161
31556	2135	975125	1968-02-10	1968-02-10	1	-691
17189	1185	738818	1948-04-22	1948-04-29	1	-7917
56532	3851	1539403	1992-07-06	1992-07-06	1	8222
26617	1796	1515774	1995-03-21	1998-03-05	3	10290
53455	3639	1112807	1924-05-31	1924-06-14	1	-16637
16693	1148	1729720	1958-08-17	1958-08-24	1	-4148
6793	469	738818	1946-07-06	1946-07-13	1	-8573
1658	111	1521369	1999-03-12	2000-03-06	1	11022
57621	3929	1125315	2004-10-09	2004-10-23	1	12714
7022	484	1177480	1997-03-15	1997-05-14	1	9995
58581	3995	738818	1998-04-23	1998-04-30	1	10346
18652	1282	933724	1998-05-05	1998-05-12	1	10358
53696	3652	1125315	1992-06-01	1992-06-15	1	8201
15753	1091	738818	1971-01-22	1971-01-29	1	393
53145	3621	1125315	1993-11-01	1993-11-15	1	8719
8783	606	1729720	2008-04-12	2008-04-25	1	13994
7694	533	1729720	1984-05-08	1984-05-17	1	5250
64806	4423	914335	1989-04-21	1989-04-21	1	7050
5742	395	1125315	1982-02-22	1982-03-08	1	4449
17072	1176	1551099	1963-10-14	1963-10-14	1	-2271
1529	101	1759842	2017-08-24	2017-09-14	1	17423
12247	842	738818	1988-05-10	1988-05-17	1	6711
66346	4531	1322184	1997-11-15	2017-04-29	1	17285
61492	4199	1125315	2014-09-28	2014-10-05	1	16348
55593	3783	738818	1985-07-21	1985-07-28	1	5687
60448	4121	920293	1966-05-14	1966-05-21	1	-1321
23136	1569	1177480	1998-12-11	1999-01-17	1	10608
50359	3431	933724	1988-10-29	1988-11-05	1	6883
73277	5007	1778162	1983-06-25	1983-07-09	1	4937
42390	2871	1713332	1951-06-18	1951-06-25	1	-6765
10031	689	1521369	2002-01-17	2003-01-12	1	12064
58248	3972	1118084	1999-07-25	1999-07-25	1	10797
55063	3745	1551099	1931-03-07	1931-03-07	1	-14180
64939	4435	1125315	2015-09-28	2015-10-28	1	16736
48664	3308	1174888	1996-11-18	1996-11-18	1	9818
60501	4125	1125315	1992-06-14	1992-07-14	1	8230
31557	2135	1125315	1953-02-05	1953-03-12	2	-6139
17190	1185	738818	2012-08-30	2012-09-13	1	15596
56533	3851	1713332	1952-07-03	1952-07-24	1	-6370
26618	1796	1515774	2000-02-23	2002-02-12	2	11730
53456	3639	1119510	2002-09-06	2002-09-20	1	11950
19531	1333	1112807	1981-07-18	1981-08-22	1	4251
6794	469	738818	2010-08-28	2010-09-11	1	14863
1659	111	1521369	2002-02-24	2004-02-14	2	12462
57622	3929	1177480	1983-09-04	1983-10-02	1	5022
7023	484	1713332	1954-07-10	1954-07-17	1	-5647
58582	3995	1125315	1978-01-07	1978-01-21	1	2942
18653	1282	1713332	1993-10-28	1993-11-04	1	8708
53697	3652	1503184	1987-09-06	1988-08-31	1	6817
15754	1091	1115008	2016-04-07	2016-04-28	1	16919
53146	3621	1112807	1927-05-30	1927-06-13	1	-15543
8784	606	1759842	2010-02-24	2010-03-03	1	14671
7695	533	1759842	2000-07-01	2000-07-22	1	11160
64807	4423	1112807	1979-03-04	1979-04-03	1	3379
5743	395	1759842	1993-08-27	1993-09-10	1	8653
17073	1176	1551099	1981-09-13	1981-09-13	1	4273
1530	101	738818	1984-09-07	1984-09-14	1	5370
12248	842	738818	1992-01-28	1992-02-11	1	8076
66347	4531	1557272	2004-12-25	2004-12-25	1	12777
61493	4199	1713332	1987-08-30	1987-09-13	1	6464
55594	3783	1118084	1984-04-09	1984-04-09	1	5212
60449	4121	920293	1971-08-30	1971-09-13	2	620
23137	1569	1759842	1939-05-15	1939-06-26	1	-11147
50360	3431	1112807	1967-06-16	1967-07-07	1	-909
73278	5007	723013	1996-04-21	1996-07-21	1	9698
42391	2871	1713332	2007-11-27	2007-12-04	1	13851
10032	689	1549786	1996-02-18	1997-02-12	1	9904
58249	3972	1729720	1962-04-29	1962-05-10	1	-2793
55064	3745	1713332	1969-07-04	1969-07-25	1	-160
64940	4435	1177480	1978-04-03	1978-04-24	1	3035
49764	3391	1119510	1994-10-19	1994-10-26	1	9064
60502	4125	1125315	2017-11-03	2017-11-10	1	17480
31558	2135	1729720	2000-12-30	2001-01-08	1	11330
17191	1185	1112807	1939-08-16	1939-08-30	1	-11082
56534	3851	836654	1994-07-18	1994-07-18	1	8964
26619	1796	1713332	1994-11-11	1994-11-25	1	9094
53457	3639	1125315	1960-09-29	1960-10-06	1	-3374
19532	1333	1177480	2013-05-27	2013-06-17	1	15873
6795	469	1112807	1936-03-29	1936-04-12	1	-12317
1660	111	1729720	1979-07-28	1979-08-10	1	3508
57623	3929	1112807	1956-04-14	1956-04-28	1	-4996
7024	484	1729720	1947-08-16	1947-08-29	1	-8161
58583	3995	1177480	2010-03-25	2010-04-15	1	14714
18654	1282	1713332	2015-02-10	2015-02-24	1	16490
53698	3652	1521369	1989-08-26	1990-08-21	1	7537
15755	1091	1118084	1997-12-14	1997-12-14	1	10209
53147	3621	1125315	1959-02-28	1959-03-07	1	-3953
8785	606	19127890	1989-02-08	1990-02-03	1	7338
7696	533	920293	1991-08-31	1991-09-07	1	7919
64808	4423	1125315	1991-05-20	1991-06-03	1	7823
5744	395	1728416	1964-11-08	1964-11-22	1	-1866
17074	1176	1759842	1993-09-15	1993-10-06	1	8679
1531	101	914335	2001-01-12	2001-01-12	1	11334
12249	842	1112807	1912-03-16	1912-03-30	1	-21096
66348	4531	1112807	1915-01-26	1915-02-09	1	-20050
61494	4199	1713332	2016-03-31	2016-06-09	1	16961
55595	3783	1125315	1982-08-16	1982-08-23	1	4617
60450	4121	933724	1966-05-14	1966-05-21	1	-1321
23138	1569	1759842	1968-09-29	1968-10-20	1	-438
50361	3431	1125315	1975-11-22	1975-12-06	1	2165
73279	5007	723013	1998-05-03	1998-09-13	1	10482
42392	2871	1713332	2013-02-12	2013-02-26	1	15762
10033	689	1549786	1998-02-07	1999-02-02	1	10624
65455	4473	920293	1999-08-28	1999-09-04	1	10838
55065	3745	1713332	1986-03-02	1986-03-23	1	5925
64941	4435	1125315	2000-03-29	2000-04-19	1	11066
49765	3391	1124300	2019-05-29	2019-05-29	1	18045
60503	4125	1713332	1985-11-15	1985-11-22	1	5804
31559	2135	1112807	1963-06-18	1963-07-02	1	-2375
17192	1185	1115008	2004-06-26	2004-07-31	1	12630
56535	3851	914335	1985-10-14	1985-10-14	1	5765
26620	1796	19127890	2000-02-23	2002-02-12	2	11730
53458	3639	1125315	1978-03-01	1978-03-08	1	2988
19533	1333	1713332	1973-10-09	1973-10-16	1	1384
6796	469	1112807	1938-03-06	1938-03-20	1	-11610
1661	111	1125315	1977-05-21	1977-06-04	1	2711
57624	3929	1124300	1989-10-18	1989-10-18	1	7230
7025	484	1112807	1939-08-26	1939-09-09	1	-11072
58584	3995	1503184	1986-02-04	1987-01-30	1	6238
18655	1282	1759842	1993-10-28	1993-11-04	1	8708
53699	3652	1713332	2010-07-11	2010-07-25	1	14815
15756	1091	1119510	1973-12-25	1974-01-08	1	1468
53148	3621	1149380	1971-07-17	1971-07-17	1	562
12593	865	1125315	1945-09-01	1945-09-08	1	-8881
7697	533	933724	1991-08-31	1991-09-07	1	7919
64809	4423	1738521	1977-07-12	1977-07-26	1	2763
5745	395	1729720	1983-12-16	1983-12-26	1	5107
17075	1176	738818	1971-02-06	1971-02-20	1	415
1532	101	1125315	1960-04-29	1960-04-29	1	-3534
12250	842	1112807	1968-11-15	1968-11-29	1	-398
66349	4531	1112807	1930-04-21	1930-05-19	1	-14472
61495	4199	1738521	1970-06-14	1970-06-28	1	178
55596	3783	1125315	1985-07-21	1985-07-28	1	5687
60451	4121	933724	1971-08-30	1971-09-13	1	620
23139	1569	1759842	1976-12-14	1977-01-04	1	2560
50362	3431	1149380	1964-10-16	1964-10-16	1	-1903
73280	5007	1118084	2019-04-07	2019-04-07	1	17993
42393	2871	1759842	1951-06-18	1951-06-25	1	-6765
10034	689	1713332	1987-12-21	1987-12-28	1	6570
65456	4473	933724	1999-08-28	1999-09-04	1	10838
55066	3745	1759842	1985-01-21	1985-01-28	1	5506
64942	4435	1361711	2002-04-15	2002-04-15	1	11792
49766	3391	1125315	2009-12-04	2010-02-02	1	14642
60504	4125	1729720	1976-07-04	1976-07-12	1	2384
31560	2135	1118084	1983-11-15	1983-11-15	1	5066
17193	1185	1125315	1946-04-13	1946-04-27	1	-8650
56536	3851	1118084	1948-10-08	1948-10-08	1	-7755
26621	1796	1115008	1994-11-11	1994-11-25	1	9094
53459	3639	1125315	1995-08-15	1995-08-29	1	9371
19534	1333	1729720	1957-12-18	1957-12-27	1	-4388
6797	469	1125315	1946-07-06	1946-07-13	1	-8573
1662	111	1125315	1981-01-30	1981-02-13	1	4061
57625	3929	1125315	1968-02-13	1968-02-27	1	-674
7026	484	1118084	1974-06-18	1974-06-18	1	1629
58585	3995	1759842	1986-09-30	1986-10-07	1	6123
18656	1282	1759842	2015-02-10	2015-02-24	1	16490
53700	3652	1759842	2010-07-11	2010-07-25	1	14815
15757	1091	1125315	1971-01-22	1971-01-29	1	393
53887	3667	1125315	1985-02-02	1985-02-16	1	5525
12594	865	1125315	1992-07-22	1992-08-05	1	8252
7698	533	1115008	1997-02-03	1997-03-03	1	9923
66188	4523	738818	2004-08-06	2004-08-20	1	12650
5746	395	740275	1972-02-13	1972-08-27	1	969
17076	1176	1119510	2002-02-24	2002-03-03	1	11749
1533	101	1125315	1989-05-22	1989-06-05	1	7095
12251	842	1125315	1938-03-25	1938-04-01	1	-11598
66350	4531	1112807	1943-09-08	1943-09-22	1	-9598
61496	4199	1759842	1987-08-30	1987-09-13	1	6464
55597	3783	1713332	1959-02-17	1959-03-03	1	-3957
60452	4121	1124300	1964-10-19	1964-10-19	1	-1900
23140	1569	1759842	1979-04-03	1979-04-10	1	3386
50363	3431	1717327	1966-06-21	1966-07-05	1	-1276
73281	5007	1119510	1999-08-02	1999-08-16	1	10819
42394	2871	1759842	2013-02-12	2013-02-26	1	15762
10035	689	1759842	1987-12-21	1987-12-28	1	6570
65457	4473	1115008	2004-06-29	2004-08-03	1	12633
55067	3745	1778162	2012-06-10	2012-06-24	1	15515
64943	4435	1729720	1976-08-26	1976-09-08	1	2442
49767	3391	1759842	1994-07-26	1994-10-04	1	9042
60505	4125	1124300	2006-11-28	2006-11-28	1	13480
31561	2135	1729720	1958-02-13	1958-02-23	1	-4330
17194	1185	1125315	1948-04-22	1948-04-29	1	-7917
56537	3851	1125315	1927-10-11	1927-10-11	1	-15423
26622	1796	1177480	1997-06-28	1997-07-12	1	10054
53460	3639	1125315	2002-09-06	2002-09-20	1	11950
19535	1333	1112807	1976-12-06	1977-01-10	1	2566
6798	469	1125315	2010-08-28	2010-09-11	1	14863
1663	111	1521369	1994-04-07	1995-04-02	1	9222
57626	3929	1125315	1970-06-27	1970-07-04	1	184
7027	484	1125315	1953-08-12	1953-09-02	1	-5965
58586	3995	1124300	2005-11-21	2005-11-21	1	13108
18657	1282	19127890	1991-04-02	1994-03-17	3	8841
53701	3652	1521369	1987-09-06	1988-08-31	1	6817
15758	1091	1129625	1961-06-27	1961-06-27	1	-3110
53888	3667	1503184	1981-07-07	1982-07-02	1	4565
12595	865	1125315	1993-04-11	1993-04-25	1	8515
7699	533	1118084	2003-11-14	2003-11-14	1	12370
66189	4523	1112807	1984-01-13	1984-02-17	1	5160
5747	395	1118084	1998-04-27	1998-04-27	1	10343
17077	1176	1125315	1991-03-01	1991-04-30	1	7789
1534	101	1125315	2000-06-24	2000-07-29	1	11167
12252	842	1125315	1970-10-20	1970-11-10	1	313
66351	4531	1125315	1916-05-21	1916-05-28	1	-19576
61497	4199	1759842	2016-03-31	2016-06-09	1	16961
56660	3860	1125315	1980-05-27	1980-07-01	1	3834
60453	4121	1125315	1926-02-18	1926-03-04	1	-16009
23998	1623	738818	1958-12-21	1959-01-04	1	-4015
50364	3431	1729720	1971-11-19	1971-12-02	1	700
73282	5007	1177480	1983-06-25	1983-07-09	1	4937
42395	2871	1125315	1952-05-16	1952-05-30	1	-6425
10036	689	1118084	2017-08-01	2017-08-01	1	17379
65458	4473	1713332	2005-06-09	2005-06-16	1	12950
55824	3799	1119510	2007-07-12	2007-07-26	1	13720
66517	4543	1521369	1993-09-04	1994-08-30	1	9007
49768	3391	1759842	1999-08-18	1999-09-08	1	10842
60506	4125	1125315	1978-01-08	1978-04-08	1	3019
32994	2235	738818	2002-09-09	2002-09-16	1	11946
17195	1185	1125315	1962-07-16	1962-07-30	1	-2712
56538	3851	1309944	1985-10-14	1985-10-14	1	5765
26623	1796	1515774	1993-03-31	1994-03-26	1	8850
53461	3639	1307863	2004-01-31	2004-01-31	1	12448
19536	1333	1759842	1955-10-04	1955-10-25	1	-5182
6799	469	1307863	2013-09-28	2013-09-28	1	15976
1664	111	1521369	1997-03-22	1998-03-17	1	10302
57627	3929	1125315	1992-04-01	1992-04-15	1	8140
7028	484	1125315	2012-06-24	2012-07-08	1	15529
58587	3995	1125315	1986-01-09	1986-01-30	1	5873
18658	1282	1118084	2015-07-13	2015-07-13	1	16629
53702	3652	1521369	1996-07-20	1997-07-15	1	10057
15759	1091	1759842	2005-11-14	2005-12-05	1	13122
53889	3667	1729720	1968-07-06	1968-07-19	1	-531
12596	865	1177480	1998-12-25	1999-01-15	1	10606
7700	533	1125315	1980-03-30	1980-04-06	1	3748
66190	4523	1115008	2013-12-09	2013-12-30	1	16069
5748	395	1713332	1993-08-27	1993-09-10	1	8653
17078	1176	1713332	2009-06-23	2009-07-07	1	14432
1535	101	1174888	1960-04-29	1960-04-29	1	-3534
12253	842	1125315	1988-05-10	1988-05-17	1	6711
66352	4531	1125315	1941-09-17	1941-10-01	1	-10319
61498	4199	920293	1957-06-27	1957-07-04	1	-4564
56661	3860	1125315	2014-02-07	2014-02-14	1	16115
60454	4121	1125315	1934-05-31	1934-06-14	1	-12985
23999	1623	738818	2009-04-08	2009-04-22	1	14356
53298	3629	1112807	1957-06-13	1957-06-27	1	-4571
73283	5007	1759842	1999-11-18	1999-11-25	1	10920
42396	2871	1713332	1956-02-07	1956-02-14	1	-5070
10037	689	1500211	1997-02-12	1998-02-07	1	10264
65459	4473	1759842	2018-10-12	2018-10-26	1	17830
55825	3799	1125315	1981-11-19	1981-11-26	1	4347
66518	4543	1118084	2017-10-13	2017-10-13	1	17452
49769	3391	1125315	2008-07-16	2008-07-30	1	14090
60507	4125	1125315	1987-11-17	1987-12-08	1	6550
32995	2235	1112807	1959-03-28	1959-04-25	1	-3904
17196	1185	1125315	2000-07-23	2000-07-30	1	11168
56539	3851	1343916	1985-10-14	1985-10-14	1	5765
26624	1796	1549786	1993-03-31	1994-03-26	1	8850
53462	3639	1361711	2007-07-07	2007-07-07	1	13701
19537	1333	738818	2006-02-08	2006-02-15	1	13194
12001	826	933724	1998-08-07	1998-08-14	1	10452
1665	111	1589505	2004-02-14	2005-02-08	1	12822
57628	3929	1728416	1952-12-01	1952-12-15	1	-6226
7029	484	1759842	1954-07-10	1954-07-17	1	-5647
58588	3995	1125315	1998-04-23	1998-04-30	1	10346
18659	1282	1125315	1980-06-25	1980-09-23	1	3918
53703	3652	1713332	1992-11-27	1992-12-11	1	8380
15760	1091	19127890	1976-05-03	1977-04-28	1	2674
53890	3667	1738521	1972-05-15	1972-05-29	1	879
12597	865	1713332	2010-05-16	2010-06-06	1	14766
9487	655	738818	1991-12-12	1991-12-19	1	8022
66191	4523	1119510	1998-11-27	1998-12-04	1	10564
5749	395	723013	1973-03-13	1973-09-04	1	1342
17079	1176	1717327	1966-12-16	1966-12-30	1	-1098
1536	101	1307863	2010-06-25	2010-06-25	1	14785
12254	842	1125315	1990-04-29	1990-05-13	1	7437
66353	4531	1177480	2004-10-29	2004-11-19	1	12741
61499	4199	933724	1957-06-27	1957-07-04	1	-4564
56662	3860	1729720	1984-12-03	1984-12-10	1	5457
60455	4121	1713332	1925-09-28	1925-10-19	1	-16145
24000	1623	1125315	1958-12-21	1959-01-04	1	-4015
53299	3629	1119510	1994-11-18	1994-12-02	1	9101
74717	5113	723013	1977-05-21	1977-11-05	1	2865
42397	2871	1713332	1963-12-26	1964-01-02	1	-2191
10038	689	1595799	1998-02-07	1999-02-02	1	10624
65460	4473	1125315	1991-02-27	1991-03-13	1	7741
55826	3799	1125315	2007-07-12	2007-07-26	1	13720
66519	4543	1125315	1984-07-13	1984-08-03	1	5328
49770	3391	738818	1994-10-19	1994-10-26	1	9064
63459	4337	738818	1984-09-13	1984-09-20	1	5376
32996	2235	1112807	1960-02-16	1960-03-01	1	-3593
17197	1185	1125315	2012-08-30	2012-09-13	1	15596
59680	4071	1112807	1952-11-01	1952-11-15	1	-6256
26625	1796	1595799	1998-03-05	2000-02-23	2	11010
53463	3639	1713332	1984-07-07	1984-07-28	1	5322
19538	1333	1118084	1993-07-10	1993-07-10	1	8591
12002	826	1125315	1993-03-16	1993-03-30	1	8489
1666	111	1713332	1985-12-26	1986-01-09	1	5852
57629	3929	920293	1977-05-23	1977-05-30	1	2706
7030	484	1112807	1943-04-08	1943-04-22	1	-9751
58589	3995	933724	2014-02-27	2014-03-06	1	16135
18660	1282	1503184	1993-03-22	1994-03-17	1	8841
53704	3652	1713332	2007-03-02	2007-03-23	1	13595
15761	1091	19127890	1978-04-23	1979-04-18	1	3394
53891	3667	933724	2000-07-31	2000-08-07	1	11176
12598	865	1713332	2017-07-08	2017-07-22	1	17369
9488	655	933724	1989-02-18	1989-02-25	1	6995
66192	4523	1119510	2004-08-06	2004-08-20	1	12650
8700	603	1118084	1995-12-15	1995-12-15	1	9479
17080	1176	1759842	2009-06-23	2009-07-07	1	14432
1537	101	1759842	1931-08-01	1931-08-22	1	-14012
12255	842	1539403	2017-11-04	2017-11-04	1	17474
66354	4531	1177480	2017-04-15	2017-04-29	1	17285
61500	4199	1112807	1963-01-17	1963-01-31	1	-2527
56663	3860	1729720	1986-09-04	1986-09-17	1	6103
60456	4121	1729720	1923-12-22	1924-01-02	1	-16801
24001	1623	1125315	2006-08-08	2006-08-22	1	13382
53300	3629	1729720	1961-02-24	1961-03-09	1	-3220
74718	5113	1729720	2011-07-31	2011-08-10	1	15196
42398	2871	1728416	1952-05-16	1952-05-30	1	-6425
10039	689	1713332	1983-08-15	1983-08-29	1	4988
65461	4473	1713332	1977-04-29	1977-05-20	1	2696
55827	3799	1713332	1989-09-17	1989-10-01	1	7213
66520	4543	1125315	2001-06-05	2001-06-26	1	11499
49771	3391	1102527	1997-06-10	1997-06-10	1	10022
63460	4337	1112807	1963-03-31	1963-04-21	1	-2447
32997	2235	1119510	2002-09-09	2002-09-16	1	11946
17198	1185	1557272	1997-01-05	1997-01-05	1	9866
59681	4071	1125315	1961-04-18	1961-05-23	1	-3145
26626	1796	1759842	2015-11-28	2015-12-12	1	16781
53464	3639	1759842	1999-02-11	1999-02-18	1	10640
19539	1333	1174888	2002-05-25	2002-05-25	1	11832
12003	826	1347450	1988-06-09	1988-06-09	1	6734
1667	111	1717327	1978-01-05	1978-01-19	1	2940
57630	3929	933724	1977-05-23	1977-05-30	1	2706
7031	484	1112807	1947-10-13	1948-01-11	1	-8026
58590	3995	1521369	1986-02-04	1987-01-30	1	6238
18661	1282	1515774	1992-03-27	1993-03-22	1	8481
53705	3652	1738521	1975-10-11	1975-10-25	1	2123
15762	1091	738818	1985-04-18	1985-04-25	1	5593
53892	3667	1115008	2010-01-22	2010-02-12	1	14652
12599	865	1759842	2010-05-16	2010-06-06	1	14766
9489	655	1125315	1991-12-12	1991-12-19	1	8022
66193	4523	1125315	2004-08-06	2004-08-20	1	12650
8701	603	1125315	1979-04-09	1979-04-23	1	3399
17081	1176	1102527	1991-03-01	1991-03-01	1	7729
1538	101	723013	1986-11-04	1987-03-10	1	6277
12256	842	1713332	1937-01-20	1937-02-03	1	-12020
66355	4531	1539403	1994-10-29	1994-10-29	1	9067
61501	4199	1119510	2011-02-08	2011-02-15	1	15020
56664	3860	1759842	2001-07-26	2001-08-16	1	11550
60457	4121	1759842	1925-09-28	1925-10-19	1	-16145
24002	1623	1125315	2009-04-08	2009-04-22	1	14356
53301	3629	738818	1994-11-18	1994-12-02	1	9101
74719	5113	1729720	2013-05-02	2013-05-11	1	15836
42399	2871	1759842	1960-08-22	1960-09-05	1	-3405
10040	689	19127890	1996-02-18	1997-02-12	1	9904
65462	4473	1118084	2012-06-29	2012-06-29	1	15520
55828	3799	1125315	1973-10-15	1973-10-22	1	1390
66521	4543	1503184	1993-09-04	1994-08-30	1	9007
49772	3391	1125315	1994-10-19	1994-10-26	1	9064
63461	4337	1119510	1977-02-07	1977-02-21	1	2608
32998	2235	1125315	2002-09-09	2002-09-16	1	11946
17199	1185	1713332	1980-10-22	1980-10-29	1	3954
59682	4071	1125315	1992-11-27	1992-12-18	1	8387
26627	1796	19127890	1995-03-21	1998-03-05	3	10290
53465	3639	1112807	1931-12-21	1932-02-19	1	-13831
19540	1333	1177480	1990-04-07	1990-04-21	1	7415
12004	826	19127890	1976-06-22	1977-06-17	1	2724
1668	111	1115008	2018-08-28	2018-09-18	1	17792
57631	3929	1112807	1952-12-01	1952-12-15	1	-6226
7032	484	1174888	1997-03-15	1997-03-15	1	9935
58591	3995	1713332	1986-09-30	1986-10-07	1	6123
18662	1282	1521369	1991-04-02	1992-03-27	1	8121
55144	3752	1112807	1959-08-04	1959-09-03	1	-3773
15763	1091	933724	1999-06-26	1999-07-03	1	10775
53893	3667	1125315	1978-03-16	1978-03-30	1	3010
12600	865	1759842	2017-07-08	2017-07-22	1	17369
9490	655	1125315	2000-04-29	2000-05-13	1	11090
66194	4523	1125315	2017-04-30	2017-05-07	1	17293
8702	603	1125315	1983-09-12	1983-12-11	2	5092
17082	1176	1112807	1966-12-16	1966-12-30	1	-1098
1539	101	1115008	2007-07-23	2007-08-27	1	13752
12257	842	1713332	1942-03-15	1942-03-22	1	-10147
66356	4531	1729720	1941-02-18	1941-02-28	1	-10534
61502	4199	1125315	1948-03-08	1948-03-22	1	-7955
56665	3860	1118084	2007-03-22	2007-03-22	1	13594
60458	4121	920293	1971-06-15	1971-06-22	1	537
24003	1623	1125315	2019-01-19	2019-02-02	1	17929
53302	3629	1112807	1959-07-20	1959-08-03	1	-3804
74720	5113	1125315	1986-01-02	1986-02-01	1	5875
42400	2871	1759842	1976-06-23	1976-06-30	1	2372
10041	689	1515774	1996-02-18	1997-02-12	1	9904
65463	4473	1125315	1973-04-15	1973-04-29	1	1214
55829	3799	1125315	1976-02-13	1976-02-27	1	2248
66522	4543	1521369	1998-08-09	2000-07-29	2	11167
49773	3391	1125315	2015-08-05	2015-08-19	1	16666
63462	4337	1125315	1984-09-13	1984-09-20	1	5376
32999	2235	1713332	1975-09-16	1975-09-23	1	2091
17200	1185	1759842	1976-09-28	1976-10-05	1	2469
59683	4071	1125315	2003-12-07	2003-12-14	1	12400
26628	1796	1118084	2017-09-06	2017-09-06	1	17415
53466	3639	1112807	1980-12-24	1981-01-07	1	4024
19541	1333	1177480	2002-05-18	2002-06-24	1	11862
12005	826	19127890	1982-05-22	1983-05-17	1	4884
1669	111	1125315	1978-01-05	1978-01-19	1	2940
57632	3929	1125315	1991-05-23	1991-06-06	1	7826
7033	484	1177480	2011-03-02	2011-05-31	1	15125
59777	4077	1119510	1990-11-04	1990-11-18	1	7626
18663	1282	1551099	1991-06-14	1991-06-14	1	7834
55145	3752	1503184	1976-11-12	1977-11-07	1	2867
15764	1091	1119510	1971-01-22	1971-01-29	1	393
53894	3667	19127890	1981-07-07	1982-07-02	1	4565
12601	865	1125315	1972-07-28	1972-08-04	1	946
9491	655	738818	1979-04-10	1979-04-17	1	3393
66195	4523	1515774	1990-01-21	1992-01-11	2	8045
8703	603	1125315	2002-06-04	2002-06-11	1	11849
17083	1176	1118084	1999-04-28	1999-04-28	1	10709
1540	101	1115008	2017-07-10	2017-10-08	1	17447
12258	842	1713332	1952-02-13	1952-02-20	1	-6525
66357	4531	1112807	1916-07-19	1916-08-02	1	-19510
61503	4199	1125315	1980-06-05	1980-06-19	1	3822
56666	3860	1125315	1994-02-21	1994-03-07	1	8831
60459	4121	933724	1971-06-15	1971-06-22	1	537
24004	1623	1322184	2017-07-14	2017-07-14	1	17361
53303	3629	1118084	2000-07-27	2000-07-27	1	11165
74721	5113	1713332	2017-04-22	2017-05-13	1	17299
42401	2871	1759842	2007-11-27	2007-12-04	1	13851
10042	689	1595799	2002-01-17	2003-01-12	1	12064
65464	4473	1713332	1991-02-27	1991-03-13	1	7741
55830	3799	1125315	1985-03-19	1985-04-02	1	5570
66523	4543	1549786	1998-08-09	2000-07-29	2	11167
49774	3391	1177480	1997-06-10	1997-08-09	1	10082
63463	4337	1713332	1965-01-10	1965-01-24	1	-1803
33000	2235	1713332	2002-10-10	2002-10-17	1	11977
17201	1185	1759842	1980-10-22	1980-10-29	1	3954
59684	4071	1729720	2014-01-08	2014-01-17	1	16087
26629	1796	1125315	2015-03-10	2015-04-07	1	16532
53467	3639	1119510	1954-06-03	1954-06-17	1	-5677
19542	1333	1759842	1973-10-09	1973-10-16	1	1384
12006	826	1713332	2009-06-10	2009-07-01	1	14426
1670	111	1503184	1994-04-07	1995-04-02	1	9222
57633	3929	1137529	1990-04-09	1990-04-09	1	7403
7034	484	1713332	1962-06-01	1962-06-22	1	-2750
59778	4077	1729720	1988-10-26	1988-11-03	1	6881
18664	1282	1759842	1987-05-05	1987-05-26	1	6354
55146	3752	1503184	1978-11-02	1981-10-17	3	4307
15765	1091	1125315	1985-04-18	1985-04-25	1	5593
53895	3667	1112807	1972-05-15	1972-05-29	1	879
12602	865	1729720	1955-12-10	1955-12-23	1	-5123
9492	655	920293	1986-01-08	1986-01-15	1	5858
66196	4523	1589505	1993-12-31	1994-12-26	1	9125
8704	603	1729720	1960-11-17	1960-11-30	1	-3319
17084	1176	1119510	1971-02-06	1971-02-20	1	415
1541	101	1119510	1984-09-07	1984-09-14	1	5370
12259	842	1759842	1937-01-20	1937-02-03	1	-12020
66358	4531	1112807	1918-02-21	1918-03-07	1	-18928
61504	4199	1125315	2011-02-08	2011-02-15	1	15020
56667	3860	1713332	2018-11-16	2018-11-30	1	17865
60460	4121	1112807	1948-05-17	1948-06-14	1	-7871
24005	1623	1332418	2017-07-14	2017-07-14	1	17361
53304	3629	1125315	1988-09-30	1988-10-07	1	6854
74722	5113	1759842	2017-04-22	2017-05-13	1	17299
44194	2989	1115008	2010-07-16	2010-08-06	1	14827
10043	689	1713332	2005-08-07	2005-11-20	1	13107
65465	4473	1729720	1981-09-15	1981-09-23	1	4283
55831	3799	1717327	1976-02-13	1976-02-27	1	2248
66524	4543	1713332	2018-05-06	2018-05-20	1	17671
49775	3391	1713332	1982-08-27	1982-09-10	1	4635
63464	4337	1717327	1961-08-08	1961-08-22	1	-3054
33001	2235	1759842	2002-10-10	2002-10-17	1	11977
17202	1185	1112807	1941-10-25	1941-11-08	1	-10281
59685	4071	1125315	1962-09-11	1962-09-18	1	-2662
26630	1796	1549786	1995-03-21	2002-02-12	7	11730
53468	3639	1713332	1948-12-26	1949-01-09	1	-7662
19543	1333	1119510	2006-02-08	2006-02-15	1	13194
12007	826	1759842	1989-11-02	1989-11-16	1	7259
1671	111	1503184	1997-03-22	1998-03-17	1	10302
57634	3929	1112807	1954-01-07	1954-01-21	1	-5824
7035	484	1729720	2001-11-07	2001-11-17	1	11643
59779	4077	1125315	1975-03-23	1975-04-06	1	1921
18665	1282	1125315	1985-09-14	1985-09-28	1	5749
55147	3752	1713332	1995-03-05	1995-03-12	1	9201
15766	1091	1125315	1998-07-27	1998-08-10	1	10448
53896	3667	1115008	2000-02-14	2000-04-14	1	11061
12603	865	1125315	1974-03-31	1974-04-14	1	1564
9493	655	920293	1989-02-18	1989-02-25	1	6995
66197	4523	738818	1998-11-27	1998-12-04	1	10564
8705	603	1768849	1985-05-31	1985-06-14	1	5643
17085	1176	1129625	1966-11-08	1966-11-08	1	-1150
1542	101	1124300	1965-05-28	1965-05-28	1	-1679
12260	842	1119510	1992-01-28	1992-02-11	1	8076
66359	4531	1125315	1930-04-21	1930-04-21	1	-14500
61505	4199	1728416	1963-01-17	1963-01-31	1	-2527
56668	3860	1759842	2018-11-16	2018-11-30	1	17865
60461	4121	1112807	1952-05-24	1952-07-23	1	-6371
24006	1623	1729720	2017-07-05	2017-07-18	1	17365
53305	3629	1125315	1990-02-27	1990-03-13	1	7376
74723	5113	740275	1976-03-06	1976-07-17	1	2389
44195	2989	1124300	1998-02-27	1998-02-27	1	10284
10044	689	1759842	2005-08-07	2005-11-20	1	13107
65466	4473	1738521	1973-04-15	1973-04-29	1	1214
55832	3799	1112807	1982-08-11	1982-08-25	1	4619
66525	4543	1729720	1988-08-23	1988-09-02	1	6819
49776	3391	1729720	1990-09-09	1990-09-17	1	7564
63465	4337	1759842	1981-04-22	1981-04-29	1	4136
33002	2235	1112807	1968-11-03	1968-12-01	1	-396
17203	1185	1118084	1978-08-06	1978-08-06	1	3139
59686	4071	1125315	1965-10-03	1965-10-17	1	-1537
26631	1796	1549786	2004-02-02	2005-01-27	1	12810
53469	3639	1729720	1958-11-08	1958-11-15	1	-4065
19544	1333	1125315	1970-02-13	1970-02-20	1	50
12008	826	19127890	1974-07-03	1975-06-28	1	2004
1672	111	1503184	1999-03-12	2000-03-06	1	11022
57635	3929	1125315	1999-12-14	1999-12-21	1	10946
7036	484	1112807	1942-11-25	1942-12-09	1	-9885
59780	4077	1125315	1979-08-18	1979-10-17	1	3576
18666	1282	1192710	1977-08-12	1977-08-12	1	2780
55148	3752	1728416	1960-04-17	1960-05-01	1	-3532
15767	1091	1729720	2007-11-20	2007-12-01	1	13848
53897	3667	1124300	2007-01-22	2007-01-22	1	13535
12604	865	1738521	1974-03-31	1974-04-14	1	1564
9494	655	933724	1986-01-08	1986-01-15	1	5858
66198	4523	1102527	1989-01-21	1989-01-21	1	6960
8706	603	738818	1983-11-03	1983-11-10	1	5061
17086	1176	1713332	1995-02-05	1995-02-19	1	9180
1543	101	1125315	1955-02-17	1955-02-24	1	-5425
12261	842	1124957	1940-08-16	1940-08-16	1	-10730
66360	4531	1125315	1944-05-20	1944-06-03	1	-9343
61506	4199	1729720	1945-02-03	1945-02-16	1	-9085
56669	3860	1125315	1985-02-05	1985-03-05	1	5542
60462	4121	1125315	1928-06-23	1928-06-30	1	-15160
24007	1623	1112807	1955-09-05	1955-09-19	1	-5218
53306	3629	1125315	1994-11-18	1994-12-02	1	9101
74724	5113	740275	1977-03-12	1977-03-12	1	2627
44196	2989	1125315	1972-03-14	1972-03-28	1	817
10045	689	19127890	1999-02-02	2000-01-28	1	10984
65467	4473	1125315	1996-04-15	1996-04-29	1	9615
55833	3799	1125315	1989-09-17	1989-10-01	1	7213
66526	4543	1759842	2018-05-06	2018-05-20	1	17671
49777	3391	1759842	1982-08-27	1982-09-10	1	4635
63466	4337	920293	2004-07-15	2004-07-22	1	12621
33003	2235	1322184	2012-12-12	2012-12-12	1	15686
17204	1185	1119510	1946-04-13	1946-04-27	1	-8650
59687	4071	1759842	1990-05-23	1990-06-06	1	7461
26632	1796	19127890	1993-03-31	1994-03-26	1	8850
55243	3757	1119510	1973-01-12	1973-01-19	1	1114
19545	1333	1125315	1974-10-29	1974-11-12	1	1776
12009	826	920293	1998-08-07	1998-08-14	1	10452
1673	111	1515774	1995-04-02	1997-03-22	2	9942
57636	3929	1149380	1990-04-09	1990-04-09	1	7403
7037	484	1729720	1940-01-27	1940-02-08	1	-10920
59781	4077	1125315	1983-11-22	1983-11-29	1	5080
18667	1282	1503184	1991-04-02	1992-03-27	1	8121
55149	3752	933724	1996-03-19	1996-03-26	1	9581
15768	1091	738818	1973-12-25	1974-01-08	1	1468
53898	3667	1125315	1977-09-28	1977-10-12	1	2841
12605	865	1118084	1980-06-02	1980-06-02	1	3805
9495	655	1118084	2003-06-19	2003-06-19	1	12222
66199	4523	1125315	1989-01-21	1989-02-20	1	6990
8707	603	1119510	1973-05-10	1973-05-24	1	1239
17087	1176	1759842	1995-02-05	1995-02-19	1	9180
1544	101	1310149	2010-06-25	2010-06-25	1	14785
12262	842	1125315	2009-01-17	2009-01-24	1	14268
66361	4531	1125315	1967-12-11	1967-12-25	1	-738
61507	4199	738818	2011-02-08	2011-02-15	1	15020
56670	3860	1125315	1986-09-24	1986-10-01	1	6117
60463	4121	1137529	1968-05-12	1968-05-12	1	-599
24008	1623	1119510	2009-04-08	2009-04-22	1	14356
53307	3629	1125315	2014-03-24	2014-03-31	1	16160
74725	5113	1177480	1999-11-20	1999-12-18	1	10943
44197	2989	1125315	1986-11-16	1986-11-30	1	6177
10361	711	708298	1967-01-29	1967-01-29	1	-1068
65468	4473	1177480	1997-08-07	1997-09-04	1	10108
55834	3799	1174888	2000-04-22	2000-04-22	1	11069
66527	4543	1125315	1984-04-16	1984-04-30	1	5233
49778	3391	1125315	2005-12-25	2006-01-24	1	13172
63467	4337	933724	2004-07-15	2004-07-22	1	12621
33004	2235	1347450	2012-12-12	2012-12-12	1	15686
17205	1185	1119510	1948-04-22	1948-04-29	1	-7917
59688	4071	1125315	1986-02-11	1986-03-04	1	5906
28114	1906	1124300	1997-09-25	1997-09-25	1	10129
55244	3757	1125315	1956-08-22	1956-09-19	1	-4852
19546	1333	1125315	2002-05-25	2002-05-25	1	11832
12010	826	1115008	2013-09-26	2013-12-25	1	16064
1674	111	1549786	1995-04-02	1997-03-22	2	9942
57637	3929	1729720	1961-04-05	1961-04-17	1	-3181
7038	484	1759842	1962-06-01	1962-06-22	1	-2750
59782	4077	1125315	2013-07-17	2013-07-31	1	15917
18668	1282	1521369	1993-03-22	1994-03-17	1	8841
55150	3752	1125315	1960-04-17	1960-05-01	1	-3532
15769	1091	920293	1999-06-26	1999-07-03	1	10775
53899	3667	1125315	2007-10-05	2007-10-19	1	13805
12606	865	1125315	1957-06-05	1957-06-12	1	-4586
9496	655	1125315	1964-06-18	1964-07-09	1	-2002
66200	4523	1177480	1994-07-24	1994-08-21	1	8998
8708	603	1125315	1964-11-22	1964-12-20	1	-1838
17088	1176	738818	2002-02-24	2002-03-03	1	11749
1545	101	1713332	1931-08-01	1931-08-22	1	-14012
12263	842	1177480	2010-01-01	2010-04-01	1	14700
66362	4531	1177480	1982-06-13	1982-06-27	1	4560
61508	4199	920293	1955-05-25	1955-06-01	1	-5328
56671	3860	1713332	2001-07-26	2001-08-16	1	11550
61938	4227	1118084	1988-06-29	1988-06-29	1	6754
24009	1623	1125315	1956-02-04	1956-02-18	1	-5066
53308	3629	1713332	2018-09-26	2018-10-03	1	17807
74726	5113	1177480	2014-04-03	2014-04-24	1	16184
44198	2989	1729720	1958-10-02	1958-10-13	1	-4098
10362	711	933724	2010-01-03	2010-01-10	1	14619
65469	4473	1713332	2018-10-12	2018-10-26	1	17830
55835	3799	1177480	1980-07-08	1980-07-22	1	3855
66528	4543	1595799	1998-08-09	2000-07-29	2	11167
49779	3391	1713332	1994-07-26	1994-10-04	1	9042
63468	4337	1112807	1961-08-08	1961-08-22	1	-3054
33005	2235	1713332	1953-12-30	1954-01-20	1	-5825
17206	1185	1713332	1983-09-22	1983-09-29	1	5019
59689	4071	1308738	2005-09-19	2005-09-19	1	13045
28115	1906	1713332	1968-08-13	1968-08-27	1	-492
55245	3757	1125315	2004-11-20	2004-12-04	1	12756
19547	1333	1125315	2006-02-08	2006-02-15	1	13194
12011	826	1503184	1982-05-22	1983-05-17	1	4884
1675	111	1738521	1977-05-21	1977-06-04	1	2711
59027	4021	738818	1970-06-24	1970-07-08	1	188
8093	564	1115008	2007-09-04	2007-09-25	1	13781
59783	4077	1713332	2006-11-18	2006-11-25	1	13477
18669	1282	1549786	1992-03-27	1993-03-22	1	8481
55151	3752	1125315	1962-11-05	1962-11-19	1	-2600
15770	1091	1125315	1973-12-25	1974-01-08	1	1468
53900	3667	1521369	1981-07-07	1982-07-02	1	4565
12607	865	1125315	1983-01-13	1983-02-03	1	4781
9497	655	1125315	1975-05-24	1975-05-31	1	1976
66201	4523	1177480	2017-12-15	2017-12-29	1	17529
8709	603	1728416	1959-08-21	1959-09-04	1	-3772
17089	1176	1112807	1964-10-08	1964-10-22	1	-1897
1546	101	1713332	1988-11-23	1988-12-07	1	6915
12264	842	1713332	1987-02-02	1987-02-16	1	6255
66363	4531	1177480	1995-04-20	1995-05-20	1	9270
61509	4199	933724	1955-05-25	1955-06-01	1	-5328
56672	3860	1125315	1985-12-30	1986-02-03	1	5877
61939	4227	1119510	1977-10-17	1977-10-31	1	2860
24010	1623	1713332	1957-08-18	1957-09-01	1	-4505
53309	3629	1728416	1959-07-20	1959-08-03	1	-3804
74727	5113	1112807	1970-02-08	1970-03-08	1	66
44199	2989	1125315	1960-01-28	1960-03-05	1	-3589
10363	711	1110410	1967-01-29	1967-01-29	1	-1068
65470	4473	1759842	1977-04-29	1977-05-20	1	2696
55836	3799	1729720	1978-03-22	1978-03-29	1	3009
66529	4543	1125315	1981-07-29	1981-08-12	1	4241
49780	3391	1713332	1999-08-18	1999-09-08	1	10842
63469	4337	1125315	1964-12-31	1965-01-14	1	-1813
33006	2235	1728416	1955-07-17	1955-07-31	1	-5268
17207	1185	1759842	1983-09-22	1983-09-29	1	5019
59690	4071	1713332	1990-05-23	1990-06-06	1	7461
28116	1906	1717327	1963-01-01	1963-01-15	1	-2543
55246	3757	1361711	2018-10-17	2018-10-17	1	17821
19548	1333	1713332	1955-10-04	1955-10-25	1	-5182
12012	826	1521369	1974-07-03	1975-06-28	1	2004
1676	111	19127890	1999-03-12	2000-03-06	1	11022
59028	4021	1115008	2016-06-21	2016-07-05	1	16987
8094	564	1125315	1956-07-16	1956-07-30	1	-4903
59784	4077	1759842	2006-11-18	2006-11-25	1	13477
18670	1282	1551099	1994-03-31	1994-03-31	1	8855
55152	3752	1125315	1963-07-14	1963-07-28	1	-2349
15771	1091	1125315	1989-02-04	1989-02-18	1	6988
53901	3667	1729720	1976-04-11	1976-04-21	1	2302
12608	865	1125315	2000-01-01	2000-01-08	1	10964
9498	655	1125315	1979-04-10	1979-04-17	1	3393
66202	4523	1549786	1990-01-21	1992-01-11	2	8045
8710	603	1759842	2009-04-07	2009-04-21	1	14355
17090	1176	1119510	1981-07-29	1981-08-12	1	4241
1547	101	1729720	1995-03-25	1995-04-06	1	9226
12265	842	1713332	1990-01-09	1990-01-16	1	7320
66364	4531	1361711	1994-10-29	2017-04-29	1	17285
61510	4199	1112807	1970-06-14	1970-06-28	1	178
57735	3938	933724	1938-04-26	1938-05-10	1	-11559
61940	4227	1125315	1969-06-29	1969-07-13	1	-172
24011	1623	1125315	1968-01-14	1968-02-04	1	-697
53310	3629	1174888	1973-05-27	1973-05-27	1	1242
74728	5113	1115008	2016-03-14	2016-04-18	1	16909
44200	2989	1713332	1976-06-02	1976-06-09	1	2351
10364	711	1112807	1955-05-30	1955-06-13	1	-5316
65471	4473	1759842	2005-06-09	2005-06-16	1	12950
55837	3799	1729720	1983-09-01	1983-09-08	1	4998
66530	4543	1500211	1994-08-30	1995-08-25	1	9367
49906	3401	1112807	1965-10-14	1965-12-20	1	-1473
63470	4337	1713332	1962-01-10	1962-01-17	1	-2906
33007	2235	1729720	2000-10-19	2000-10-26	1	11256
17208	1185	1115008	2008-02-11	2008-04-11	1	13980
59691	4071	1102527	1969-12-07	1969-12-07	1	-25
28117	1906	1717327	1964-01-15	1964-01-29	1	-2164
55247	3757	1112807	1947-02-11	1947-02-25	1	-8346
19549	1333	1729720	1969-04-02	1969-04-09	1	-267
12013	826	1713332	1989-11-02	1989-11-16	1	7259
3626	245	1125315	2012-11-23	2012-11-30	1	15674
59029	4021	1125315	1970-06-24	1970-07-08	1	188
8095	564	1713332	1984-08-07	1984-08-14	1	5339
59785	4077	1125315	1971-11-30	1971-12-14	1	712
18671	1282	920293	1998-05-05	1998-05-12	1	10358
55153	3752	1521369	1976-11-12	1977-11-07	1	2867
15772	1091	1521369	1976-05-03	1977-04-28	1	2674
53902	3667	1729720	1977-09-15	1977-09-27	1	2826
16127	1115	1112807	1958-01-14	1958-02-13	1	-4340
9499	655	1322184	2013-03-30	2013-03-30	1	15794
66203	4523	1729720	1977-10-19	1977-10-30	1	2859
8711	603	1112807	1959-08-21	1959-09-04	1	-3772
17091	1176	1125315	1971-02-06	1971-02-20	1	415
1548	101	738818	1962-04-19	1962-04-26	1	-2807
12266	842	1759842	1942-03-15	1942-03-22	1	-10147
66365	4531	1713332	1935-06-28	1935-07-05	1	-12599
61511	4199	1124957	1970-06-14	1970-06-14	1	164
57736	3938	1119510	1956-02-04	1956-02-11	1	-5073
61941	4227	1115008	1997-08-15	1997-08-29	1	10102
24012	1623	1361711	2017-07-14	2017-07-14	1	17361
53311	3629	1177480	1992-03-02	1992-03-23	1	8117
74729	5113	1118084	2004-03-26	2004-03-26	1	12503
44201	2989	1759842	1974-10-26	1974-11-02	1	1766
10365	711	1125315	1967-01-30	1967-01-30	1	-1067
65877	4501	1119510	1979-11-25	1979-12-09	1	3629
55838	3799	738818	2007-07-12	2007-07-26	1	13720
66531	4543	19127890	1993-09-04	1994-08-30	1	9007
49907	3401	1125315	1960-07-13	1960-07-27	1	-3445
63471	4337	1713332	1976-11-29	1976-12-06	1	2531
33008	2235	1759842	1968-06-11	1968-07-02	1	-548
17209	1185	1119510	2012-08-30	2012-09-13	1	15596
59692	4071	1124300	1998-08-07	1998-08-07	1	10445
28118	1906	1759842	1973-12-24	1974-01-15	1	1475
55248	3757	1118084	1985-02-01	1985-02-01	1	5510
21983	1497	1112807	1940-11-10	1940-11-24	1	-10630
12014	826	1717327	1963-11-18	1963-12-02	1	-2222
3627	245	1125315	2014-07-23	2014-07-30	1	16281
59030	4021	1521369	1974-12-08	1975-12-03	1	2162
8096	564	1728416	1956-07-16	1956-07-30	1	-4903
59786	4077	1125315	2006-01-12	2006-01-26	1	13174
18672	1282	1115008	2010-10-16	2010-11-06	1	14919
55154	3752	920293	1996-01-07	1996-01-14	1	9509
15773	1091	1521369	1978-04-23	1979-04-18	1	3394
53903	3667	738818	2012-12-04	2012-12-18	1	15692
16128	1115	1119510	2010-10-11	2010-10-18	1	14900
9500	655	1347450	2013-03-30	2013-03-30	1	15794
66204	4523	19127890	1990-01-21	1992-01-11	2	8045
8712	603	1115008	2015-09-29	2015-10-20	1	16728
17092	1176	1125315	1976-05-13	1976-06-17	1	2359
1549	101	1112807	1988-11-23	1988-12-07	1	6915
12267	842	1759842	1952-02-13	1952-02-20	1	-6525
66366	4531	1713332	1985-01-12	1985-01-19	1	5497
61512	4199	975125	1962-05-03	1962-05-03	1	-2800
57737	3938	1125315	1926-07-06	1926-07-13	1	-15878
61942	4227	1125315	1960-10-20	1960-11-03	1	-3346
24013	1623	1539403	2017-07-14	2017-07-14	1	17361
53312	3629	1728416	1957-06-13	1957-06-27	1	-4571
74730	5113	1125315	1974-02-15	1974-03-24	1	1543
44202	2989	1112807	1956-04-13	1956-05-18	1	-4976
10366	711	1125315	1978-07-28	1978-10-03	1	3197
65878	4501	1124300	2014-11-10	2014-11-10	1	16384
55839	3799	1112807	1972-09-18	1972-10-02	1	1005
67883	4633	1102527	1974-01-12	1974-01-12	1	1472
49908	3401	1125315	1962-10-30	1962-11-13	1	-2606
63472	4337	1729720	1974-08-04	1974-08-15	1	1687
33009	2235	1112807	1955-07-17	1955-07-31	1	-5268
17210	1185	1713332	1976-09-28	1976-10-05	1	2469
59693	4071	1125315	1969-12-07	1970-02-05	1	35
28119	1906	1713332	1973-12-24	1974-01-15	1	1475
55249	3757	1125315	1959-05-11	1959-05-25	1	-3874
21984	1497	1112807	1943-09-26	1943-10-24	1	-9566
12015	826	1759842	2009-06-10	2009-07-01	1	14426
3628	245	1125315	2015-09-20	2015-10-20	1	16728
59031	4021	1759842	2015-04-05	2015-04-26	1	16551
8097	564	1759842	1984-08-07	1984-08-14	1	5339
59787	4077	1177480	2012-02-26	2012-04-01	1	15431
18673	1282	1177480	1977-03-29	1977-04-12	1	2658
55155	3752	933724	1996-01-07	1996-01-14	1	9509
15774	1091	1713332	2005-11-14	2005-12-05	1	13122
53904	3667	920293	2000-07-31	2000-08-07	1	11176
16129	1115	1125315	1984-11-14	1984-12-05	1	5452
9501	655	1521369	1975-11-28	1976-11-22	1	2517
66205	4523	1115008	2015-11-20	2015-12-04	1	16773
8713	603	1125315	1985-05-31	1985-06-14	1	5643
17093	1176	1125315	2002-02-24	2002-03-03	1	11749
1550	101	1115008	2011-05-08	2011-08-06	1	15192
12268	842	1778162	1985-08-09	1985-08-23	1	5713
66367	4531	1759842	1935-06-28	1935-07-05	1	-12599
61513	4199	1112807	1940-02-17	1940-05-17	1	-10821
57738	3938	1738521	1969-07-11	1969-07-25	1	-160
61943	4227	1728416	1960-10-20	1960-11-03	1	-3346
24014	1623	1759842	1957-08-18	1957-09-01	1	-4505
53313	3629	1759842	2018-09-26	2018-10-03	1	17807
74731	5113	1125315	1978-11-23	1979-01-18	2	3283
44203	2989	1125315	1966-08-20	1966-09-03	1	-1216
10367	711	1125315	1983-06-09	1983-07-07	1	4935
65879	4501	1503184	1999-09-20	2000-09-14	1	11214
55840	3799	1118084	2006-04-08	2006-04-08	1	13246
67884	4633	1112807	1960-09-28	1960-10-12	1	-3368
49909	3401	1759842	1960-12-16	1960-12-23	1	-3296
63473	4337	738818	1977-02-07	1977-02-21	1	2608
33010	2235	1713332	1968-06-11	1968-07-02	1	-548
17211	1185	1759842	1988-01-12	1988-01-26	1	6599
59694	4071	1177480	2003-06-24	2003-07-08	1	12241
28120	1906	1713332	2017-05-18	2017-06-08	1	17325
55250	3757	1713332	1967-07-15	1967-07-29	1	-887
21985	1497	1125315	1979-05-21	1979-06-04	1	3441
12016	826	1118084	1991-06-29	1991-06-29	1	7849
3629	245	1124957	1942-04-03	1942-04-03	1	-10135
59032	4021	920293	1989-01-31	1989-02-07	1	6977
8098	564	933724	1991-11-10	1991-11-17	1	7990
59788	4077	738818	1990-11-04	1990-11-18	1	7626
18674	1282	1713332	1980-09-09	1980-09-23	1	3918
55156	3752	1118084	1997-11-17	1997-11-17	1	10182
15775	1091	1729720	1967-09-23	1967-10-02	1	-822
53905	3667	1119510	2012-12-04	2012-12-18	1	15692
16130	1115	1713332	1988-02-11	1988-02-25	1	6629
9502	655	1759842	1972-10-10	1972-10-31	1	1034
66206	4523	1118084	2018-01-04	2018-01-04	1	17535
8714	603	738818	1973-05-10	1973-05-24	1	1239
17094	1176	1551099	1999-11-13	1999-11-13	1	10908
1551	101	1125315	1945-06-01	1945-06-08	1	-8973
16450	1136	738818	2003-05-22	2003-06-05	1	12208
66368	4531	1759842	1985-01-12	1985-01-19	1	5497
61514	4199	1125315	1994-05-29	1994-06-05	1	8921
57739	3938	1759842	1977-10-09	1977-10-16	1	2845
61944	4227	1778162	1997-08-15	1997-08-29	1	10102
24015	1623	1112807	1952-08-23	1952-09-20	1	-6312
53314	3629	1112807	1965-09-29	1965-12-28	1	-1465
74732	5113	1125315	1981-02-06	1981-02-27	1	4075
44204	2989	1115008	2002-05-24	2002-06-28	1	11866
10368	711	1741122	1967-01-29	1967-01-29	1	-1068
65880	4501	1521369	1987-11-22	1989-11-11	2	7254
55841	3799	1125315	2000-04-22	2000-07-21	2	11159
67885	4633	1118084	1992-09-07	1992-09-07	1	8285
49910	3401	1124300	1997-08-02	1997-08-02	1	10075
63474	4337	1118084	2006-02-13	2006-02-13	1	13192
33011	2235	1728416	1960-02-16	1960-03-01	1	-3593
17977	1239	1503184	1984-06-21	1985-06-16	1	5645
60582	4133	1112807	1978-05-21	1978-06-04	1	3076
28121	1906	1717327	1965-06-13	1965-06-27	1	-1649
55251	3757	738818	1973-01-12	1973-01-19	1	1114
21986	1497	1125315	2007-05-01	2007-05-15	1	13648
12017	826	1125315	1963-11-18	1963-12-02	1	-2222
3630	245	1125315	1991-04-10	1991-04-17	1	7776
59033	4021	933724	1989-01-31	1989-02-07	1	6977
8099	564	1118084	1995-10-30	1995-10-30	1	9433
59789	4077	1118084	2010-10-14	2010-10-14	1	14896
18675	1282	1713332	1987-05-05	1987-05-26	1	6354
55157	3752	19127890	1976-11-12	1977-11-07	1	2867
15776	1091	1729720	1987-01-16	1987-01-29	1	6237
53906	3667	1125315	1972-03-16	1972-04-06	1	826
16131	1115	1759842	1988-02-11	1988-02-25	1	6629
9503	655	1503184	1975-11-28	1976-11-22	1	2517
66207	4523	1125315	1998-11-27	1998-12-04	1	10564
8715	603	738818	2014-03-12	2014-03-26	1	16155
17095	1176	1713332	1993-09-15	1993-10-06	1	8679
1552	101	1125315	1962-04-19	1962-04-26	1	-2807
16451	1136	1119510	2003-05-22	2003-06-05	1	12208
69005	4707	738818	1986-04-12	1986-04-26	1	5959
61515	4199	1729720	1939-01-25	1939-02-02	1	-11291
57740	3938	1124300	1949-06-06	1949-06-06	1	-7514
61945	4227	738818	1977-10-17	1977-10-31	1	2860
24016	1623	1118084	1988-12-17	1988-12-17	1	6925
53315	3629	1125315	1973-05-20	1973-07-26	2	1302
74733	5113	1728416	1978-11-23	1978-12-07	1	3262
44205	2989	1125315	1993-11-10	1993-11-24	1	8728
10369	711	19016749	1967-01-29	1967-01-29	1	-1068
65881	4501	1589505	1998-09-25	1999-09-20	1	10854
55842	3799	1729720	1984-03-09	1984-03-18	1	5190
67886	4633	1119510	1991-08-03	1991-08-10	1	7891
49911	3401	1759842	2002-06-25	2002-07-16	1	11884
63475	4337	1125315	1962-04-07	1962-04-14	1	-2819
33012	2235	1759842	1953-12-30	1954-01-20	1	-5825
17978	1239	1549786	1989-05-26	1990-05-21	1	7445
60583	4133	1124300	2009-10-10	2009-10-10	1	14527
28122	1906	1759842	1968-08-13	1968-08-27	1	-492
55252	3757	1119510	2009-08-19	2009-08-26	1	14482
21987	1497	1551099	1941-05-10	1941-05-10	1	-10463
12018	826	1177480	2014-10-21	2014-11-04	1	16378
3631	245	1177480	2004-12-20	2005-01-03	1	12786
59034	4021	1112807	1955-02-11	1955-02-25	1	-5424
8100	564	1149380	1991-10-24	1991-10-24	1	7966
59790	4077	1125315	1990-11-04	1990-11-18	1	7626
20986	1432	738818	1972-06-04	1972-06-11	1	892
55158	3752	19127890	1978-11-02	1981-10-17	3	4307
22152	1510	933724	1995-11-18	1995-11-25	1	9459
53907	3667	1125315	1974-10-23	1974-11-13	1	1777
16132	1115	738818	2010-10-11	2010-10-18	1	14900
9504	655	1713332	1972-10-10	1972-10-31	1	1034
66208	4523	1177480	2016-11-28	2016-12-19	1	17154
8716	603	1119510	1983-11-03	1983-11-10	1	5061
17096	1176	1717327	1964-10-08	1964-10-22	1	-1897
1553	101	1125315	1965-04-17	1965-05-08	1	-1699
16452	1136	1124957	1984-11-02	1984-11-02	1	5419
69006	4707	1112807	1977-03-19	1977-06-17	1	2724
62047	4235	738818	2011-05-13	2011-05-20	1	15114
57741	3938	1125315	1984-09-20	1984-10-18	1	5404
61946	4227	1125315	1957-08-31	1957-09-14	1	-4492
24017	1623	1119510	1958-12-21	1959-01-04	1	-4015
54024	3675	1112807	1968-04-11	1968-06-10	1	-570
77562	5301	1112807	1936-03-07	1936-04-04	1	-12325
44206	2989	1177480	1998-10-12	1998-11-11	1	10541
10370	711	738818	1983-04-05	1983-04-12	1	4849
65882	4501	1500211	1997-09-30	1998-09-25	1	10494
56409	3844	738818	1975-07-01	1975-07-15	1	2021
67887	4633	1307863	2009-12-01	2009-12-01	1	14579
49912	3401	1125315	1982-08-02	1982-08-09	1	4603
63476	4337	1125315	1977-02-07	1977-02-21	1	2608
33013	2235	1118084	1983-05-21	1983-05-21	1	4888
17979	1239	1729720	1983-06-03	1983-06-12	1	4910
60584	4133	1125315	1985-04-15	1985-04-22	1	5590
28123	1906	1112807	1963-01-01	1963-01-15	1	-2543
55253	3757	1125315	1973-01-12	1973-01-19	1	1114
21988	1497	1728416	1945-05-07	1945-05-21	1	-8991
12019	826	1503184	1974-07-03	1975-06-28	1	2004
3632	245	1713332	1978-01-18	1978-03-15	1	2995
59035	4021	1125315	1958-04-04	1958-04-18	1	-4276
8101	564	1713332	2015-01-25	2015-02-01	1	16467
60739	4143	1728416	1968-11-08	1968-11-22	1	-405
20987	1432	1125315	2018-09-16	2018-09-23	1	17797
55159	3752	920293	1996-03-19	1996-03-26	1	9581
22153	1510	1112807	1970-07-16	1970-08-20	1	231
53908	3667	1125315	1985-11-14	1985-11-21	1	5803
16133	1115	1102527	2014-12-12	2014-12-12	1	16416
9505	655	1119510	1979-04-10	1979-04-17	1	3393
66209	4523	1713332	2008-07-13	2008-07-27	1	14087
8717	603	1119510	2014-03-12	2014-03-26	1	16155
19884	1355	1125315	1966-11-22	1966-12-06	1	-1122
1554	101	1125315	1973-02-28	1973-03-07	1	1161
16453	1136	1125315	2001-08-21	2001-08-28	1	11562
69007	4707	1125315	1986-04-12	1986-04-26	1	5959
62048	4235	1119510	1995-06-06	1995-06-20	1	9301
57742	3938	1713332	1977-10-09	1977-10-16	1	2845
61947	4227	1125315	1959-04-14	1959-04-28	1	-3901
28396	1924	1112807	1978-08-26	1978-11-24	1	3249
54025	3675	1112807	1990-08-14	1990-09-04	1	7551
77563	5301	1119510	1974-06-14	1974-06-21	1	1632
44207	2989	1713332	1974-10-26	1974-11-02	1	1766
10371	711	920293	2010-01-03	2010-01-10	1	14619
65883	4501	1521369	1999-09-20	2000-09-14	1	11214
56410	3844	1112807	1965-02-22	1965-03-22	1	-1746
67888	4633	1326303	2009-12-01	2009-12-01	1	14579
49913	3401	1125315	1994-07-21	1994-08-04	1	8981
63477	4337	1347450	1991-02-22	1991-02-22	1	7722
33014	2235	1125315	2012-03-24	2012-03-31	1	15430
17980	1239	1119510	2010-02-27	2010-03-13	1	14681
60585	4133	1125315	2004-11-14	2004-12-05	1	12757
28124	1906	1119510	1975-10-27	1975-11-03	1	2132
55254	3757	1539403	2018-10-17	2018-10-17	1	17821
21989	1497	1729720	1978-06-08	1978-06-19	1	3091
12020	826	1503184	1976-06-22	1977-06-17	1	2724
3633	245	1729720	1987-10-18	1987-10-31	1	6512
59036	4021	1713332	1962-03-13	1962-03-27	1	-2837
8102	564	1759842	2012-08-09	2012-08-23	1	15575
60740	4143	19127890	1981-08-25	1982-08-20	1	4614
20988	1432	1717327	1963-10-18	1963-11-01	1	-2253
55160	3752	1115008	2002-10-01	2002-10-29	1	11989
22154	1510	1118084	2002-01-10	2002-01-10	1	11697
53909	3667	1125315	2012-12-04	2012-12-18	1	15692
16134	1115	1125315	1950-06-27	1950-07-04	1	-7121
9506	655	1119510	1991-12-12	1991-12-19	1	8022
66210	4523	1759842	2008-07-13	2008-07-27	1	14087
8718	603	1125315	1973-05-10	1973-05-24	1	1239
19885	1355	1125315	1968-02-25	1968-03-03	1	-669
1555	101	1125315	1978-10-27	1979-01-02	1	3288
16454	1136	1125315	2003-05-22	2003-06-05	1	12208
69008	4707	1125315	2018-07-12	2018-09-10	1	17784
62049	4235	1124300	2014-02-05	2014-02-05	1	16106
57743	3938	1112807	1969-07-11	1969-07-25	1	-160
61948	4227	1125315	2001-06-25	2001-07-02	1	11505
28397	1924	1118084	2017-03-04	2017-03-04	1	17229
54026	3675	1125315	1970-03-03	1970-03-17	1	75
77564	5301	1124300	1953-01-12	1953-01-12	1	-6198
44208	2989	1759842	1976-06-02	1976-06-09	1	2351
10372	711	1118084	1991-06-30	1991-06-30	1	7850
65884	4501	1549786	1993-10-21	1994-10-16	1	9054
56411	3844	1118084	1991-02-06	1991-02-06	1	7706
67889	4633	1713332	1975-06-20	1975-08-29	1	2066
49914	3401	1713332	1960-12-16	1960-12-23	1	-3296
63478	4337	1713332	1981-04-22	1981-04-29	1	4136
33015	2235	1729720	1963-12-05	1963-12-17	1	-2207
17981	1239	1125315	1975-11-10	1975-11-24	1	2153
60586	4133	1177480	2005-10-31	2005-11-14	1	13101
28125	1906	1125315	1965-06-13	1965-06-27	1	-1649
55255	3757	1728416	1947-02-11	1947-02-25	1	-8346
21990	1497	1125315	1992-03-11	1992-03-18	1	8112
12021	826	1521369	1976-06-22	1977-06-17	1	2724
3634	245	1112807	1917-03-15	1917-03-29	1	-19271
59037	4021	1728416	1958-04-04	1958-04-18	1	-4276
8103	564	920293	1991-11-10	1991-11-17	1	7990
60741	4143	1125315	1963-04-22	1963-05-06	1	-2432
20989	1432	1112807	1963-08-19	1963-09-16	1	-2299
55161	3752	1125315	1959-06-05	1959-06-19	1	-3849
22155	1510	1125315	1960-05-26	1960-06-09	1	-3493
56717	3866	933724	2004-11-04	2004-11-18	1	12740
16135	1115	1125315	1954-01-05	1954-01-19	1	-5826
9507	655	1125315	1999-06-06	1999-07-04	1	10776
66211	4523	1778162	2017-12-15	2017-12-29	1	17529
8719	603	1125315	2014-03-12	2014-03-26	1	16155
19886	1355	1521369	1980-07-20	1981-07-15	1	4213
1556	101	1125315	1984-09-07	1984-09-14	1	5370
16455	1136	1125315	2014-07-08	2014-07-22	1	16273
69009	4707	1738521	1975-03-30	1975-04-13	1	1928
62050	4235	1125315	2011-05-13	2011-05-20	1	15114
57744	3938	1125315	1915-01-26	1915-02-02	1	-20057
61949	4227	1125315	2007-09-06	2007-10-04	1	13790
28398	1924	1307863	2019-06-28	2019-06-28	1	18075
54027	3675	1125315	2018-02-28	2018-03-07	1	17597
77565	5301	1125315	1949-04-30	1949-05-07	1	-7544
44752	3035	738818	1974-08-25	1974-09-01	1	1704
10373	711	1125315	1983-04-05	1983-04-12	1	4849
65885	4501	738818	1979-11-25	1979-12-09	1	3629
56412	3844	1125315	1975-07-01	1975-07-15	1	2021
67890	4633	1729720	1991-03-26	1991-04-05	1	7764
49915	3401	1713332	2002-06-25	2002-07-16	1	11884
63479	4337	1717327	1961-11-14	1961-11-28	1	-2956
33016	2235	1729720	1992-07-19	1992-07-31	1	8247
17982	1239	1125315	2015-10-20	2015-10-27	1	16735
60587	4133	1515774	1996-06-25	1997-06-20	1	10032
28126	1906	1125315	1981-03-16	1981-03-30	1	4106
55256	3757	1759842	1967-07-15	1967-07-29	1	-887
21991	1497	1125315	2000-07-26	2000-08-23	1	11192
12022	826	1521369	1982-05-22	1983-05-17	1	4884
3635	245	1112807	1942-04-03	1942-05-01	1	-10107
59038	4021	1118084	1992-05-22	1992-05-22	1	8177
8104	564	1125315	1980-06-10	1980-07-15	1	3848
60742	4143	1177480	1996-06-27	1996-07-11	1	9688
20990	1432	1125315	1972-06-04	1972-06-11	1	892
55162	3752	1177480	1997-12-26	1998-03-26	1	10311
22156	1510	1125315	1970-05-21	1970-06-04	1	154
56718	3866	1118084	1990-02-18	1990-02-18	1	7353
16136	1115	1125315	1970-05-09	1970-05-16	1	135
9508	655	19127890	1975-11-28	1976-11-22	1	2517
67683	4621	1124300	2012-07-07	2012-07-07	1	15528
8720	603	1177480	2008-04-03	2008-05-08	1	14007
19887	1355	1729720	1966-09-07	1966-09-17	1	-1202
1557	101	1125315	1986-12-21	1987-01-04	1	6212
16456	1136	1177480	1984-11-02	1985-01-31	1	5509
69010	4707	1125315	2014-03-20	2014-03-27	1	16156
62051	4235	738818	1995-06-06	1995-06-20	1	9301
57745	3938	738818	1956-02-04	1956-02-11	1	-5073
61950	4227	1728416	1959-04-14	1959-04-28	1	-3901
28399	1924	1326303	2019-06-28	2019-06-28	1	18075
54028	3675	1713332	1978-03-14	1978-07-18	1	3120
77566	5301	1307863	1999-01-07	1999-01-07	1	10598
44753	3035	1112807	1968-05-27	1968-07-26	1	-524
10374	711	1125315	2002-03-29	2002-04-26	1	11803
65886	4501	1125315	1979-11-25	1979-12-09	1	3629
56413	3844	738818	1981-04-01	1981-04-08	1	4115
67891	4633	738818	1991-08-03	1991-08-10	1	7891
49916	3401	1717327	1962-10-30	1962-11-13	1	-2606
63480	4337	1759842	1962-01-10	1962-01-17	1	-2906
33017	2235	1759842	1975-09-16	1975-09-23	1	2091
17983	1239	1515774	1989-05-26	1990-05-21	1	7445
60588	4133	1521369	1990-07-27	1992-07-16	2	8232
28127	1906	1129625	1964-12-02	1964-12-02	1	-1856
55257	3757	738818	2009-08-19	2009-08-26	1	14482
21992	1497	1112807	1945-05-07	1945-05-21	1	-8991
12023	826	1729720	1998-12-30	1999-01-08	1	10599
3636	245	1118084	1954-06-24	1954-06-24	1	-5670
59039	4021	1125315	1961-09-03	1961-11-02	1	-2982
8105	564	1137529	1991-10-24	1991-10-24	1	7966
60743	4143	1503184	1981-08-25	1982-08-20	1	4614
20991	1432	1119510	1972-06-04	1972-06-11	1	892
55163	3752	1521369	1978-11-02	1981-10-17	3	4307
22157	1510	1125315	1995-05-12	1995-05-26	1	9276
56719	3866	1125315	1984-04-12	1984-04-19	1	5222
16137	1115	1125315	2010-10-11	2010-10-18	1	14900
11119	761	1119510	2015-03-29	2015-04-12	1	16537
67684	4621	1177480	1980-10-22	1980-11-05	1	3961
8721	603	1713332	2009-04-07	2009-04-21	1	14355
19888	1355	738818	1971-12-24	1972-01-07	1	736
1558	101	1326303	2010-06-25	2010-06-25	1	14785
16457	1136	1309944	1972-10-07	1972-10-07	1	1010
69011	4707	1713332	1990-03-28	1990-04-11	1	7405
62052	4235	1125315	1995-06-06	1995-06-20	1	9301
57746	3938	920293	1938-04-26	1938-05-10	2	-11559
61951	4227	914335	2003-04-06	2003-04-06	1	12148
28400	1924	1713332	1981-12-05	1982-02-20	1	4433
54029	3675	1713332	2012-02-26	2012-03-18	1	15417
77567	5301	1326303	1999-01-07	1999-01-07	1	10598
44754	3035	1112807	1990-04-08	1990-04-22	1	7416
10375	711	1713332	1987-08-26	1987-09-16	1	6467
65887	4501	1503184	1987-11-22	1989-11-11	2	7254
56414	3844	1125315	1981-04-01	1981-04-08	1	4115
67892	4633	1125315	1965-06-05	1965-06-19	1	-1657
49917	3401	1729720	2007-05-13	2007-05-21	1	13654
63481	4337	1759842	1976-11-29	1976-12-06	1	2531
34448	2334	1112807	1936-02-29	1936-03-14	1	-12346
17984	1239	1728416	1975-11-10	1975-11-24	1	2153
60589	4133	1125315	2012-07-10	2012-07-31	1	15552
28128	1906	1174888	2017-05-18	2017-05-18	1	17304
55258	3757	1112807	1957-09-14	1957-12-13	1	-4402
21993	1497	1124300	1974-07-25	1974-07-25	1	1666
12289	844	1125315	1989-04-02	1989-04-16	1	7045
3637	245	1119510	1917-05-16	1917-05-30	1	-19209
59040	4021	1713332	2015-04-05	2015-04-26	1	16551
8106	564	1177480	1996-06-21	1996-07-12	1	9689
60744	4143	1729720	1997-04-05	1997-04-13	1	9964
20992	1432	1125315	1979-07-06	1979-07-13	1	3480
55164	3752	1728416	1959-06-05	1959-06-19	1	-3849
22158	1510	1125315	2005-09-05	2005-09-12	1	13038
56720	3866	1125315	2003-04-28	2003-05-05	1	12177
16138	1115	1129625	1950-07-26	1950-07-26	1	-7099
11120	761	1154343	1980-12-21	1998-06-05	1	10382
67685	4621	1738521	1980-10-22	1980-11-05	1	3961
10118	695	1125315	1969-11-15	1969-12-06	1	-26
19889	1355	1125315	1965-11-28	1965-12-12	1	-1481
1559	101	1728416	1960-04-29	1960-05-13	1	-3520
16458	1136	1125315	1974-08-28	1974-09-11	1	1714
69012	4707	1125315	1990-03-28	1990-04-11	1	7405
62053	4235	1713332	2008-02-09	2008-03-01	1	13939
57747	3938	1125315	1929-11-14	1929-11-21	1	-14651
61952	4227	1125315	1977-10-17	1977-10-31	1	2860
28401	1924	1713332	2000-06-10	2000-07-01	1	11139
54030	3675	1125315	1967-11-13	1967-11-27	1	-766
77568	5301	920293	1940-11-24	1940-12-01	1	-10623
44755	3035	1118084	2004-09-30	2004-09-30	1	12691
10376	711	1713332	1994-03-21	1994-03-28	1	8852
65888	4501	1729720	1986-05-09	1986-05-22	1	5985
56415	3844	1177480	1985-09-03	1985-09-24	1	5745
67893	4633	1125315	1991-08-03	1991-08-10	1	7891
49918	3401	1115008	1995-05-31	1995-06-28	1	9309
63482	4337	1112807	1961-11-14	1961-11-28	1	-2956
34449	2334	1115008	1996-10-23	1996-11-27	1	9827
17985	1239	1729720	1987-10-23	1987-11-02	1	6514
60590	4133	1503184	1990-07-27	1992-07-16	2	8232
28129	1906	738818	1975-10-27	1975-11-03	1	2132
55259	3757	1125315	2009-08-19	2009-08-26	1	14482
21994	1497	1125315	1975-11-05	1975-12-05	1	2164
12290	844	1177480	1979-01-15	1979-03-16	1	3361
3638	245	1125315	1984-02-25	1984-04-25	1	5228
59041	4021	1759842	1962-03-13	1962-03-27	1	-2837
8107	564	1177480	2006-08-19	2006-09-09	1	13400
60745	4143	1112807	1968-11-08	1968-11-22	1	-405
20993	1432	1125315	1983-03-06	1983-03-20	1	4826
55165	3752	1759842	1995-03-05	1995-03-12	1	9201
22159	1510	1177480	1989-06-18	1989-08-17	1	7168
56721	3866	1759842	1951-06-11	1951-06-25	1	-6765
16139	1115	1177480	2014-12-12	2015-02-10	1	16476
11121	761	1177480	1994-04-25	1994-05-16	1	8901
67686	4621	1759842	1978-07-21	1978-07-28	1	3130
10119	695	1729720	1976-06-12	1976-06-20	1	2362
19890	1355	1125315	1967-07-22	1967-08-05	1	-880
2038	137	975125	2002-06-30	2002-06-30	1	11868
16459	1136	1125315	1984-11-02	1984-11-02	1	5419
69013	4707	1125315	1999-07-28	1999-08-04	1	10807
62054	4235	1115008	2007-03-09	2007-04-15	1	13618
57748	3938	1125315	1956-02-04	1956-02-11	1	-5073
61953	4227	1125315	1992-02-27	1992-03-05	1	8099
28402	1924	1759842	1981-12-05	1982-02-20	1	4433
54031	3675	1125315	1998-11-16	1998-11-23	1	10553
77569	5301	1112807	1921-10-22	1921-11-05	1	-17589
44756	3035	1125315	1974-08-25	1974-09-01	1	1704
10377	711	1746114	1967-01-29	1967-01-29	1	-1068
65889	4501	1738521	1976-03-14	1976-03-28	1	2278
56416	3844	1713332	2017-08-19	2017-08-26	1	17404
67894	4633	1310149	2009-12-01	2009-12-01	1	14579
49919	3401	1125315	2002-02-21	2002-03-21	1	11767
63483	4337	1112807	1966-12-01	1967-01-05	1	-1092
34450	2334	1124957	1964-08-14	1964-08-14	1	-1966
17986	1239	1738521	1972-11-11	1972-11-25	1	1059
60591	4133	1549786	1996-06-25	1997-06-20	1	10032
28130	1906	1125315	1964-01-15	1964-01-29	1	-2164
55260	3757	1177480	2004-11-06	2004-11-20	1	12742
21995	1497	1125315	1983-10-25	1983-11-08	1	5059
12291	844	1177480	1995-04-21	1995-05-12	1	9262
3639	245	1125315	2005-10-30	2005-11-20	1	13107
59042	4021	19127890	1974-12-08	1975-12-03	1	2162
8108	564	1713332	1975-04-28	1975-05-19	1	1964
60746	4143	1125315	1991-04-26	1991-05-10	1	7799
20994	1432	1125315	1984-05-28	1984-06-25	1	5289
58529	3991	1112807	1945-12-28	1946-01-11	1	-8756
22160	1510	1521369	1978-09-28	1979-09-23	1	3552
56722	3866	1112807	1964-08-19	1964-09-18	1	-1931
16140	1115	1728416	1954-01-05	1954-01-19	1	-5826
11122	761	1713332	2010-09-23	2010-10-07	1	14889
67687	4621	1759842	2018-01-08	2018-01-15	1	17546
10120	695	1112807	1984-12-17	1985-01-14	1	5492
19891	1355	1125315	1971-12-24	1972-01-07	1	736
2039	137	1118084	2005-04-12	2005-04-12	1	12885
16460	1136	1177480	2013-02-03	2013-05-04	1	15829
69014	4707	1102527	2018-07-12	2018-07-12	1	17724
62055	4235	1125315	1987-10-15	1987-11-19	1	6531
58363	3982	738818	1942-03-06	1942-03-13	1	-10156
61954	4227	1125315	1993-10-27	1993-11-03	1	8707
28403	1924	1759842	2000-06-10	2000-07-01	1	11139
54032	3675	1759842	2012-02-26	2012-03-18	1	15417
77570	5301	1112807	1923-05-30	1923-06-13	1	-17004
44757	3035	1347450	2014-09-12	2014-09-12	1	16325
10378	711	19002770	1967-01-29	1967-01-29	1	-1068
65890	4501	19127890	1987-11-22	1989-11-11	2	7254
56417	3844	1119510	1981-04-01	1981-04-08	1	4115
67895	4633	1713332	1994-02-27	1994-03-20	1	8844
51973	3539	738818	2000-10-14	2000-10-28	1	11258
63484	4337	1119510	1984-09-13	1984-09-20	1	5376
34451	2334	1125315	1979-06-25	1979-07-25	1	3492
17987	1239	1759842	1974-12-16	1975-01-06	1	1831
60592	4133	1595799	1998-06-15	1999-06-10	1	10752
28131	1906	1125315	1975-10-27	1975-11-03	1	2132
55261	3757	1322184	2018-10-17	2018-10-17	1	17821
21996	1497	1396131	1983-03-05	1983-03-05	1	4811
12292	844	1177480	2002-03-06	2002-04-10	1	11787
3640	245	1177480	2013-09-09	2013-09-30	1	15978
59043	4021	1112807	1957-08-29	1957-09-19	1	-4487
8109	564	1729720	1960-01-01	1960-01-10	1	-3644
60747	4143	1717327	1963-04-22	1963-05-06	1	-2432
20995	1432	1125315	2012-08-29	2012-09-05	1	15588
58530	3991	1728416	1945-12-28	1946-01-11	1	-8756
22161	1510	1112807	1960-11-21	1961-01-20	1	-3268
56723	3866	1125315	1958-01-22	1958-02-05	1	-4348
16141	1115	1118084	1987-05-17	1987-05-17	1	6345
11123	761	1759842	2010-09-23	2010-10-07	1	14889
67688	4621	1125315	1978-11-30	1978-12-14	1	3269
10121	695	1759842	2014-10-25	2014-11-08	1	16382
19892	1355	1125315	1975-11-20	1975-12-04	1	2163
2040	137	1503184	1985-06-26	1986-06-21	1	6015
16461	1136	1115008	2007-06-05	2007-08-04	1	13729
69015	4707	1118084	2012-08-12	2012-08-12	1	15564
62056	4235	738818	2001-12-23	2001-12-30	1	11686
58364	3982	738818	1956-02-23	1956-03-08	1	-5047
61955	4227	1125315	1997-08-15	1997-08-15	1	10088
28404	1924	1310149	2019-06-28	2019-06-28	1	18075
54033	3675	1118084	2008-11-22	2008-11-22	1	14205
77571	5301	1112807	1923-09-03	1923-09-17	1	-16908
44758	3035	1713332	1991-01-21	1991-02-11	1	7711
10379	711	19003953	1967-01-29	1967-01-29	1	-1068
65891	4501	19127890	1993-10-21	1994-10-16	1	9054
56418	3844	1125315	1970-03-26	1970-03-26	1	84
67896	4633	1125315	1974-01-05	1974-03-13	1	1532
51974	3539	1118084	2016-06-21	2016-06-21	1	16973
63485	4337	1125315	2016-07-06	2016-07-13	1	16995
34452	2334	1149380	1963-02-14	1963-02-14	1	-2513
17988	1239	19127890	1984-06-21	1985-06-16	1	5645
60593	4133	1713332	1999-01-04	1999-01-18	1	10609
28132	1906	1125315	1980-01-13	1980-01-20	1	3671
55262	3757	1332418	2018-10-17	2018-10-17	1	17821
21997	1497	1112807	1942-06-16	1942-06-30	1	-10047
12293	844	1738521	1967-12-14	1967-12-28	1	-735
3641	245	1778162	2005-10-30	2005-11-20	1	13107
59044	4021	1112807	1966-04-10	1966-05-01	1	-1341
8110	564	920293	1992-01-21	1992-01-28	1	8062
60748	4143	1118084	2000-12-03	2000-12-03	1	11294
20996	1432	1177480	2005-04-06	2005-04-27	1	12900
58531	3991	1125315	1994-01-17	1994-01-31	1	8796
22162	1510	1119510	1995-05-12	1995-05-26	1	9276
56724	3866	1125315	1964-08-19	1964-08-19	1	-1961
16142	1115	1125315	1959-07-20	1959-08-03	1	-3804
11124	761	738818	2007-11-08	2007-11-15	1	13832
67689	4621	1125315	2006-06-22	2006-07-06	1	13335
10122	695	1759842	2016-11-03	2016-11-10	1	17115
19893	1355	1125315	1995-11-07	1995-11-14	1	9448
2041	137	1521369	1985-06-26	1986-06-21	1	6015
16462	1136	1118084	2013-01-19	2013-01-19	1	15724
69016	4707	1119510	1986-04-12	1986-04-26	1	5959
62057	4235	1102527	2007-03-16	2007-03-16	1	13588
58365	3982	1112807	1988-11-18	1988-12-02	1	6910
61956	4227	1174888	1997-08-15	1997-08-15	1	10088
28405	1924	1125315	1985-10-18	1985-11-01	1	5783
54034	3675	1738521	1967-11-13	1967-11-27	1	-766
77572	5301	1125315	1929-09-11	1929-09-18	1	-14715
44759	3035	1759842	1991-01-21	1991-02-11	1	7711
10380	711	753626	1967-01-29	1967-01-29	1	-1068
65892	4501	1125315	1976-03-14	1976-03-28	1	2278
56419	3844	1174888	1970-03-26	1970-03-26	1	84
67897	4633	1728416	1960-09-28	1960-10-12	1	-3368
51975	3539	1125315	2000-10-14	2000-10-28	1	11258
63486	4337	1759842	1965-01-10	1965-01-24	1	-1803
34453	2334	1310149	2011-06-23	2011-06-23	1	15148
17989	1239	1112807	1980-06-02	1980-06-23	1	3826
60594	4133	1713332	2002-09-05	2002-09-19	1	11949
28133	1906	1125315	2017-05-18	2017-06-08	2	17325
55861	3803	1112807	1961-12-04	1961-12-18	1	-2936
21998	1497	1177480	2007-02-18	2007-03-20	1	13592
12294	844	1124957	1979-01-15	1979-01-15	1	3301
3642	245	738818	1917-05-16	1917-05-30	1	-19209
59045	4021	1115008	2010-02-09	2010-02-23	1	14663
8111	564	933724	1992-01-21	1992-01-28	1	8062
60749	4143	1521369	1981-08-25	1982-08-20	1	4614
20997	1432	1112807	1963-10-18	1963-11-01	1	-2253
58532	3991	1713332	1971-02-02	1971-03-02	1	425
22163	1510	1125315	1978-08-15	1978-08-15	1	3148
56725	3866	1125315	2009-12-03	2009-12-10	1	14588
16143	1115	1125315	1964-10-09	1964-10-30	1	-1889
11125	761	1118084	2015-05-30	2015-05-30	1	16585
67690	4621	1713332	1978-07-21	1978-07-28	1	3130
10123	695	1125315	1990-08-18	1990-09-01	1	7548
19894	1355	1177480	2000-01-02	2000-01-23	1	10979
2042	137	1551099	1981-11-08	1981-11-08	1	4329
16463	1136	1125315	1995-05-26	1995-06-09	1	9290
69017	4707	1125315	1975-03-30	1975-04-13	1	1928
62058	4235	1119510	2001-12-23	2001-12-30	1	11686
58366	3982	1115008	1995-09-13	1995-10-04	1	9407
61957	4227	1309944	2003-04-06	2003-04-06	1	12148
30087	2034	1115008	2011-08-26	2011-11-01	1	15279
54035	3675	1759842	1978-03-14	1978-07-18	1	3120
77573	5301	1125315	1959-01-04	1959-02-08	1	-3980
44760	3035	1125315	1972-04-06	1972-04-27	1	847
10381	711	967823	1967-01-29	1967-01-30	1	-1067
65893	4501	1125315	1983-01-31	1983-02-07	1	4785
56420	3844	1713332	1967-05-02	1967-05-16	1	-961
67898	4633	1112807	1959-07-23	1959-08-06	1	-3801
51976	3539	1125315	2015-12-30	2016-01-20	1	16820
64944	4436	1125315	2017-06-29	2017-06-29	1	17346
34454	2334	1322184	2016-11-17	2016-11-17	1	17122
17990	1239	1125315	1972-11-11	1972-11-25	1	1059
60595	4133	1729720	1981-03-08	1981-03-18	1	4094
28134	1906	1729720	2012-03-26	2012-04-04	1	15434
55862	3803	1503184	1976-03-30	1978-03-20	2	3000
21999	1497	1713332	2006-05-14	2006-05-21	1	13289
12295	844	1125315	1982-01-29	1982-04-29	1	4501
3643	245	1112807	1920-06-10	1920-06-24	1	-18088
59046	4021	1119510	1970-06-24	1970-07-08	1	188
8112	564	1713332	2012-08-09	2012-08-23	1	15575
62840	4291	1125315	1982-12-08	1982-12-15	1	4731
20998	1432	1118084	2005-01-30	2005-01-30	1	12813
58533	3991	1713332	1988-08-06	1988-08-20	1	6806
22164	1510	1174888	1978-08-15	1978-08-15	1	3148
56726	3866	1177480	2000-08-15	2000-09-19	1	11219
16144	1115	1125315	2000-10-11	2000-10-25	1	11255
11126	761	1119510	2007-11-08	2007-11-15	1	13832
67691	4621	723013	1976-07-26	1976-10-18	1	2482
10124	695	1713332	2014-10-25	2014-11-08	1	16382
19895	1355	1713332	2009-04-22	2009-04-29	1	14363
2043	137	1125315	1984-08-11	1984-09-10	2	5366
16464	1136	914335	1972-10-07	1972-10-07	1	1010
69018	4707	1125315	1980-11-30	1980-12-14	1	4000
62059	4235	1119510	2011-05-13	2011-05-20	1	15114
58367	3982	1125315	1942-03-06	1942-03-13	1	-10156
61958	4227	1343916	2003-04-06	2003-04-06	1	12148
30088	2034	1118084	1963-09-25	1963-09-25	1	-2290
55383	3767	1125315	1997-03-15	1997-03-29	1	9949
77574	5301	1310149	1999-01-07	1999-01-07	1	10598
44761	3035	1713332	1968-02-04	1968-02-11	1	-690
10382	711	1125315	1985-10-30	1985-11-06	1	5788
65894	4501	1515774	1993-10-21	1994-10-16	1	9054
56421	3844	1729720	1990-03-09	1990-03-20	1	7383
67899	4633	1115008	2014-10-11	2014-10-25	1	16368
51977	3539	1713332	1984-09-15	1984-09-29	1	5385
64945	4436	1177480	2017-06-22	2017-08-28	1	17406
34455	2334	1347450	2015-08-27	2015-08-27	1	16674
17991	1239	1149380	2014-07-10	2014-07-10	1	16261
60596	4133	19127890	1996-06-25	1997-06-20	1	10032
28815	1950	1149380	1985-01-10	1985-01-10	1	5488
55863	3803	1521369	1974-04-10	1975-04-05	1	1920
22000	1497	1759842	2006-05-14	2006-05-21	1	13289
12296	844	1551099	1980-05-09	1980-05-09	1	3781
3644	245	1112807	1968-06-13	1968-07-18	1	-532
59047	4021	1125315	1958-10-14	1958-11-18	1	-4062
8113	564	1759842	1975-04-28	1975-05-19	1	1964
62841	4291	1125315	1994-11-03	1994-11-24	1	9093
22301	1518	1112807	1957-03-21	1957-04-04	1	-4655
58534	3991	1759842	1988-08-06	1988-08-20	1	6806
22165	1510	1177480	2014-01-06	2014-01-20	1	16090
56727	3866	1713332	1951-06-11	1951-06-25	1	-6765
16145	1115	1125315	2007-01-09	2007-01-23	1	13536
11127	761	1125315	1988-07-26	1988-08-02	1	6788
67692	4621	1115008	2005-05-30	2005-06-27	1	12961
10125	695	1713332	2016-11-03	2016-11-10	1	17115
19896	1355	1717327	1975-11-20	1975-12-04	1	2163
2044	137	1177480	1974-03-16	1974-04-06	1	1556
16465	1136	1343916	1972-10-07	1972-10-07	1	1010
76369	5222	1112807	1919-03-11	1919-03-25	1	-18545
62060	4235	1125315	2001-12-23	2001-12-30	1	11686
58368	3982	1125315	1956-02-23	1956-03-08	1	-5047
64267	4390	1112807	1970-11-29	1970-12-13	1	346
30089	2034	1119510	1996-09-15	1996-09-29	1	9768
55384	3767	1177480	1986-10-08	1986-10-22	1	6138
77575	5301	1729720	1986-03-28	1986-04-04	1	5937
44762	3035	1112807	1968-01-28	1968-02-11	1	-690
10383	711	1177480	1990-01-01	1990-03-02	1	7365
65895	4501	19127890	1999-09-20	2000-09-14	1	11214
56422	3844	1759842	2017-08-19	2017-08-26	1	17404
67900	4633	1115008	2017-08-10	2017-08-31	1	17409
51978	3539	1119510	2000-10-14	2000-10-28	1	11258
64946	4436	1309944	2003-06-13	2003-06-13	1	12216
34456	2334	1713332	1965-11-16	1965-11-30	1	-1493
17992	1239	1521369	1984-06-21	1985-06-16	1	5645
60597	4133	1125315	2005-05-02	2005-05-16	1	12919
28816	1950	1557272	2011-01-06	2011-01-06	1	14980
55864	3803	1713332	2014-09-13	2014-12-06	1	16410
22780	1545	705944	1981-12-03	1986-12-12	1	6189
12297	844	1112807	1967-12-14	1967-12-28	1	-735
3645	245	1125315	1917-05-16	1917-05-30	1	-19209
59048	4021	1503184	1974-12-08	1975-12-03	1	2162
8114	564	1759842	2015-01-25	2015-02-01	1	16467
62842	4291	1125315	1997-10-24	1997-11-07	1	10172
22302	1518	1125315	1997-12-24	1997-12-31	1	10226
58535	3991	1112807	1948-07-15	1948-08-19	1	-7805
22166	1510	1503184	1978-09-28	1979-09-23	1	3552
56728	3866	1728416	1958-01-22	1958-02-05	1	-4348
16146	1115	1729720	1967-01-29	1967-02-08	1	-1058
11128	761	1125315	1991-04-19	1991-05-03	1	7792
67693	4621	1125315	1978-01-17	1978-01-31	1	2952
10126	695	1118084	2006-03-01	2006-03-01	1	13208
19897	1355	1729720	1987-07-02	1987-07-09	1	6398
2045	137	1515774	1990-05-31	1991-05-26	1	7815
16466	1136	1713332	2007-12-30	2008-01-20	1	13898
76370	5222	1112807	1926-04-03	1926-04-17	1	-15965
62061	4235	1177480	2012-11-14	2012-12-05	1	15679
58369	3982	738818	1952-08-18	1952-09-01	1	-6331
64268	4390	1503184	1974-01-28	1975-01-23	1	1848
30090	2034	1125315	1987-01-26	1987-03-02	1	6269
55385	3767	1778162	1989-07-19	1989-08-02	1	7153
77576	5301	920293	1940-09-01	1940-09-15	2	-10700
44763	3035	1125315	1978-02-25	1978-03-18	1	2998
10384	711	1000560	1967-01-29	1967-01-29	2	-1068
67094	4579	738818	1982-07-18	1982-08-01	1	4595
56423	3844	705944	1964-08-26	1970-09-04	1	246
67901	4633	1125315	1961-08-12	1961-08-26	1	-3050
51979	3539	1125315	1983-06-01	1983-06-15	1	4913
64947	4436	1759842	1970-12-03	1970-12-24	1	357
34457	2334	1713332	1973-11-25	1973-12-02	1	1431
17993	1239	738818	2010-02-27	2010-03-13	1	14681
60598	4133	1521369	1998-06-15	1999-06-10	1	10752
28817	1950	1713332	1989-07-06	1989-07-20	1	7140
55865	3803	1759842	1961-08-12	1961-09-02	1	-3043
22781	1545	1115008	2000-12-16	2001-02-14	1	11367
12298	844	1125315	1979-01-15	1979-01-15	1	3301
3646	245	1125315	1942-04-03	1942-04-03	1	-10135
59049	4021	1713332	1992-03-21	1992-04-11	1	8136
8307	578	738818	1969-02-21	1969-02-28	1	-307
62843	4291	1738521	1974-02-21	1974-03-07	1	1526
22303	1518	1713332	1992-12-04	1992-12-11	1	8380
58536	3991	1118084	1981-08-11	1981-08-11	1	4240
22167	1510	1759842	1987-12-20	1988-01-10	1	6583
56729	3866	1729720	1966-02-10	1966-02-17	1	-1414
17614	1217	1112807	1973-09-09	1973-09-23	1	1361
11129	761	1125315	2007-11-08	2007-11-15	1	13832
67694	4621	1125315	1978-04-17	1978-05-01	1	3042
10127	695	1125315	1974-10-21	1974-11-04	1	1768
19898	1355	1717327	1966-11-22	1966-12-06	1	-1122
2046	137	1549786	1990-05-31	1991-05-26	1	7815
16467	1136	1759842	2007-12-30	2008-01-20	1	13898
76371	5222	1125315	1924-01-15	1924-01-22	1	-16781
62062	4235	1759842	2008-02-09	2008-03-01	1	13939
58370	3982	1119510	1942-03-06	1942-03-13	1	-10156
64269	4390	1503184	1977-01-12	1978-01-07	1	2928
30091	2034	1125315	1995-07-14	1995-07-21	1	9332
55386	3767	1119510	2000-11-29	2000-12-06	1	11297
77577	5301	933724	1940-09-01	1940-09-15	1	-10700
44764	3035	1125315	1986-10-30	1986-11-06	1	6153
10385	711	1119510	1983-04-05	1983-04-12	1	4849
67095	4579	1112807	1969-10-01	1969-10-15	1	-78
56424	3844	1112807	1970-03-26	1970-06-24	1	174
67902	4633	1728416	1959-07-23	1959-08-06	1	-3801
51980	3539	1125315	1983-12-27	1984-01-10	1	5122
64948	4436	914335	2003-06-13	2003-06-13	1	12216
34458	2334	1778162	1996-10-23	1996-11-27	1	9827
17994	1239	1118084	2006-02-26	2006-02-26	1	13205
60599	4133	1759842	1999-01-04	1999-01-18	1	10609
28818	1950	1759842	1989-07-06	1989-07-20	1	7140
55866	3803	920293	2002-05-10	2002-05-17	1	11824
22782	1545	1125315	1996-09-12	1996-09-19	1	9758
12299	844	1129625	1970-05-13	1970-05-13	1	132
3647	245	1125315	1961-07-08	1961-07-15	1	-3092
59050	4021	1728416	1955-02-11	1955-02-25	1	-5424
8308	578	1125315	1970-01-15	1970-04-15	1	104
62844	4291	1738521	1975-10-25	1975-11-08	1	2137
22304	1518	1729720	1981-08-20	1981-08-31	1	4260
58537	3991	1557272	2016-01-23	2016-01-23	1	16823
22168	1510	1112807	1968-05-13	1968-05-27	1	-584
56730	3866	1125315	1955-05-13	1955-06-10	1	-5319
17615	1217	1124300	2013-02-26	2013-02-26	1	15762
11130	761	1759842	1982-08-05	1982-08-12	1	4606
67695	4621	1125315	1989-09-30	1989-10-21	1	7233
10128	695	1125315	1996-10-15	1996-10-29	1	9798
19899	1355	19127890	1980-07-20	1981-07-15	1	4213
2047	137	1551099	1972-10-23	1972-10-23	1	1026
17138	1180	1112807	1968-01-09	1968-02-06	1	-695
76372	5222	1125315	1935-02-21	1935-02-28	1	-12726
62063	4235	1768849	1987-10-15	1987-11-19	1	6531
58371	3982	1119510	1956-02-23	1956-03-08	1	-5047
64270	4390	1717327	1970-11-29	1970-12-13	1	346
30092	2034	1125315	1996-09-10	1996-10-10	2	9779
55387	3767	1125315	2000-11-29	2000-12-06	1	11297
77578	5301	933724	1940-11-24	1940-12-01	1	-10623
44765	3035	1125315	2017-02-26	2017-03-05	1	17230
10386	711	1124957	1967-01-30	1967-01-30	1	-1067
67096	4579	1119510	1976-11-12	1976-11-19	1	2514
56425	3844	1119510	1975-07-01	1975-07-15	1	2021
67903	4633	1759842	1975-06-20	1975-08-29	1	2066
51981	3539	1713332	1998-12-05	1998-12-26	1	10586
64949	4436	1118084	2008-06-01	2008-06-01	1	14031
34459	2334	757627	2018-08-02	2018-08-02	1	17745
17995	1239	1125315	1991-09-24	1991-10-08	1	7950
60600	4133	1759842	2002-09-05	2002-09-19	1	11949
28819	1950	1102527	2016-01-26	2016-01-26	1	16826
55867	3803	1118084	2003-12-24	2003-12-24	1	12410
22783	1545	1125315	2017-04-03	2017-04-17	1	17273
12300	844	1729720	1972-05-22	1972-05-29	1	879
3648	245	1125315	1996-07-21	1996-08-04	1	9712
59051	4021	1759842	1992-03-21	1992-04-11	1	8136
8309	578	1125315	1970-05-22	1970-06-05	1	155
62845	4291	1759842	1989-05-30	1989-06-06	1	7096
22305	1518	1759842	1975-09-16	1975-09-30	1	2098
58538	3991	1112807	1947-07-02	1947-07-16	1	-8205
22169	1510	1112807	1978-08-08	1978-10-14	1	3208
56731	3866	1177480	1977-10-31	1977-11-14	1	2874
17616	1217	1125315	1974-02-19	1974-03-05	1	1524
11131	761	1759842	1983-06-25	1983-07-09	1	4937
67696	4621	1713332	2018-01-08	2018-01-15	1	17546
10129	695	1125315	2011-10-31	2011-11-07	1	15285
19900	1355	1118084	1996-05-22	1996-05-22	1	9638
2048	137	1713332	1983-07-17	1983-08-07	1	4966
17139	1180	1125315	1977-07-31	1977-08-07	1	2775
76373	5222	1125315	2015-07-21	2015-08-04	1	16651
63613	4349	1125315	1984-11-21	1985-02-19	1	5528
58372	3982	1124300	1977-11-21	1977-11-21	1	2881
64271	4390	19127890	1977-01-12	1978-01-07	1	2928
30093	2034	1322184	2004-11-10	2018-01-17	1	17548
55388	3767	1177480	1988-08-15	1988-08-29	1	6815
77579	5301	1112807	1925-11-30	1925-12-30	1	-16073
44766	3035	1713332	1990-04-08	1990-04-22	1	7416
10387	711	1367571	1967-01-29	1967-01-29	1	-1068
67097	4579	1125315	1982-07-18	1982-08-01	1	4595
56426	3844	1759842	1967-05-02	1967-05-16	1	-961
67904	4633	1759842	1994-02-27	1994-03-20	1	8844
51982	3539	1759842	1998-12-05	1998-12-26	1	10586
64950	4436	1125315	1980-05-23	1980-06-22	1	3825
34460	2334	1112807	1942-11-24	1943-02-22	1	-9810
17996	1239	1125315	2010-02-27	2010-03-13	1	14681
60601	4133	1549786	1998-06-15	1999-06-10	1	10752
28820	1950	1112807	1944-06-23	1944-07-07	1	-9309
55868	3803	1125315	1975-05-04	1975-05-11	1	1956
22784	1545	1125315	2018-06-27	2018-07-04	1	17716
12301	844	1118084	2002-09-26	2002-09-26	1	11956
3649	245	1557272	2006-07-16	2006-07-16	1	13345
59254	4035	1118084	2007-04-02	2007-04-02	1	13605
8310	578	1125315	2005-10-27	2005-11-10	1	13097
62846	4291	1768849	1997-10-24	1997-11-07	1	10172
22306	1518	1759842	1992-12-04	1992-12-11	1	8380
58539	3991	1125315	1958-01-29	1958-03-30	1	-4295
22170	1510	1125315	1963-09-21	1963-10-05	1	-2280
56732	3866	1501700	2017-09-24	2017-09-24	1	17433
17617	1217	1125315	2010-11-22	2010-12-06	1	14949
11132	761	1125315	2004-01-31	2004-02-14	1	12462
69341	4731	1177480	1975-01-15	1975-01-29	1	1854
14767	1022	738818	1988-12-18	1989-01-01	1	6940
19901	1355	1119510	1971-12-24	1972-01-07	1	736
2049	137	1713332	2011-04-18	2011-04-25	1	15089
17140	1180	1174888	2010-09-28	2010-09-28	1	14880
76374	5222	1713332	1933-10-29	1933-11-05	1	-13206
63614	4349	1177480	1987-01-10	1987-01-31	1	6239
58373	3982	1125315	1952-08-18	1952-09-01	1	-6331
64272	4390	1112807	1962-08-19	1962-09-02	1	-2678
30094	2034	1332418	2004-11-10	2004-11-10	1	12732
55389	3767	1713332	1986-10-08	1986-10-22	1	6138
77580	5301	1347450	2003-05-01	2003-05-01	1	12173
44767	3035	1729720	2007-11-08	2007-11-15	1	13832
10388	711	1728416	1955-05-30	1955-06-13	1	-5316
67098	4579	1125315	1985-09-18	1985-09-25	1	5746
58634	3998	1112807	1970-09-09	1970-11-08	1	311
69127	4719	1102527	2003-06-06	2003-06-06	1	12209
51983	3539	1125315	1984-09-15	1984-09-29	1	5385
64951	4436	1125315	2007-08-30	2007-09-13	1	13769
34461	2334	1112807	1964-08-14	1964-10-13	1	-1906
17997	1239	1137529	2014-07-10	2014-07-10	1	16261
60602	4133	1738521	1978-05-21	1978-06-04	1	3076
28821	1950	1112807	1944-11-15	1944-11-29	1	-9164
55869	3803	1125315	1983-08-29	1983-09-12	1	5002
22785	1545	1124300	2006-05-16	2006-05-16	1	13284
12302	844	1125315	1966-11-20	1966-11-27	1	-1131
3650	245	1759842	1978-01-18	1978-03-15	1	2995
59255	4035	1521369	1987-03-13	1988-03-07	1	6640
8311	578	1177480	2001-12-19	2002-01-16	1	11703
62847	4291	1124300	2016-08-29	2016-08-29	1	17042
22307	1518	1115008	2009-12-16	2010-01-06	1	14615
58540	3991	1728416	1947-07-02	1947-07-16	1	-8205
22171	1510	1717327	1974-02-17	1974-03-03	1	1522
56733	3866	1728416	1953-03-24	1953-04-07	1	-6113
17618	1217	1322184	2018-10-19	2018-10-19	1	17823
11133	761	1125315	2008-01-16	2008-01-23	1	13901
69342	4731	1177480	1975-05-08	1975-05-22	1	1967
14768	1022	914335	2010-02-09	2010-02-09	1	14649
19902	1355	1125315	1965-07-29	1965-09-02	1	-1582
2050	137	1738521	1972-08-23	1972-09-06	1	979
17141	1180	738818	1961-03-18	1961-03-25	1	-3204
76375	5222	1759842	1933-10-29	1933-11-05	1	-13206
63615	4349	1729720	1992-07-14	1992-07-23	1	8239
58374	3982	1125315	2015-01-17	2015-01-24	1	16459
64273	4390	1112807	1986-01-27	1986-02-17	1	5891
30095	2034	1347450	2018-01-17	2018-01-17	1	17548
55390	3767	1729720	1986-05-13	1986-05-23	1	5986
77581	5301	738818	1974-06-14	1974-06-21	1	1632
44768	3035	1119510	1974-08-25	1974-09-01	1	1704
10389	711	1759842	1987-08-26	1987-09-16	1	6467
67099	4579	1125315	2001-02-28	2001-03-14	1	11395
58635	3998	1119510	1964-02-15	1964-02-22	1	-2140
69128	4719	1125315	1953-01-28	1953-02-11	1	-6168
51984	3539	1115008	1996-03-23	1996-04-13	1	9599
64952	4436	1343916	2003-06-13	2003-06-13	1	12216
34462	2334	1115008	2005-06-13	2005-06-27	1	12961
17998	1239	1713332	1974-12-16	1975-01-06	1	1831
60603	4133	19127890	1990-07-27	1992-07-16	2	8232
28822	1950	1124300	1978-12-17	1978-12-17	1	3272
55870	3803	1729720	1974-05-03	1974-05-14	1	1594
22786	1545	1125315	1992-12-30	1993-01-27	1	8427
12303	844	1125315	1993-10-03	1993-10-17	1	8690
6636	458	1112807	1973-03-11	1973-03-25	1	1179
59256	4035	1125315	1975-07-06	1975-07-20	1	2026
8312	578	19127890	1987-04-26	1988-04-20	1	6684
62848	4291	1177480	1987-06-02	1987-06-16	1	6375
22308	1518	1118084	1998-07-14	1998-07-14	1	10421
58541	3991	1729720	1972-02-22	1972-02-29	1	789
22172	1510	1759842	1959-01-08	1959-01-22	1	-3997
56734	3866	1729720	1957-05-16	1957-05-24	1	-4605
17619	1217	1347450	2018-10-19	2018-10-19	1	17823
11134	761	1150770	1979-09-26	1979-09-26	1	3555
69343	4731	705944	1981-10-30	1983-11-11	1	5062
14769	1022	1125315	1982-01-05	1982-01-19	1	4401
19903	1355	1125315	1966-08-23	1966-09-06	1	-1213
2051	137	19127890	1985-06-26	1986-06-21	1	6015
17142	1180	1112807	1963-12-31	1964-03-30	1	-2103
76376	5222	1112807	1937-06-18	1937-07-09	1	-11864
63616	4349	1177480	1991-02-09	1991-03-09	1	7737
58375	3982	757627	2011-11-11	2011-11-11	1	15289
64274	4390	1119510	1962-11-19	1962-12-03	1	-2586
30096	2034	1539403	2004-11-10	2004-11-10	1	12732
55391	3767	738818	2000-11-29	2000-12-06	1	11297
77582	5301	1125315	1974-06-14	1974-06-21	1	1632
44769	3035	1125315	1995-04-07	1995-04-14	1	9234
10390	711	1759842	1994-03-21	1994-03-28	1	8852
67100	4579	1729720	1973-04-15	1973-04-24	1	1209
58636	3998	1125315	2006-07-10	2006-07-17	1	13346
69129	4719	1713332	2003-06-06	2003-06-20	1	12223
51985	3539	1125315	1998-08-02	1998-08-16	1	10454
64953	4436	1713332	1970-12-03	1970-12-24	1	357
34463	2334	1125315	1977-06-21	1977-07-05	1	2742
17999	1239	1713332	1987-08-24	1987-10-12	1	6493
62910	4297	753626	1991-02-19	1991-02-19	1	7719
28823	1950	1125315	1956-06-20	1956-07-18	1	-4915
55871	3803	19127890	1976-03-30	1978-03-20	2	3000
22787	1545	1177480	1974-10-06	1974-10-20	1	1753
14805	1024	1118084	1983-01-05	1983-01-05	1	4752
6637	458	1515774	1991-07-15	1992-07-09	1	8225
59257	4035	19127890	1987-03-13	1988-03-07	1	6640
8313	578	19127890	1989-04-15	1990-04-10	1	7404
62849	4291	1177480	1978-09-28	1978-12-27	1	3282
22309	1518	1125315	1959-02-23	1959-03-09	1	-3951
58542	3991	1759842	1971-02-02	1971-03-02	1	425
22173	1510	19127890	1978-09-28	1979-09-23	1	3552
56735	3866	1729720	1973-07-12	1973-07-25	1	1301
17620	1217	738818	2003-07-05	2003-07-12	1	12245
11135	761	1177480	1981-09-30	1981-10-14	1	4304
69344	4731	1125315	2005-08-07	2005-08-14	1	13009
14770	1022	1125315	1988-12-18	1989-01-01	1	6940
19904	1355	1125315	2007-01-16	2007-01-30	1	13543
2052	137	1115008	2007-04-13	2007-04-27	1	13630
17143	1180	1125315	1961-03-18	1961-03-25	1	-3204
76377	5222	1119510	1977-04-29	1977-05-13	1	2689
63617	4349	1112807	1983-05-01	1983-05-15	1	4882
58376	3982	920293	1968-11-29	1968-12-06	1	-391
64275	4390	1124300	1994-10-15	1994-10-15	1	9053
30097	2034	1713332	1968-01-10	1968-01-24	1	-708
55392	3767	1119510	2016-03-13	2016-03-20	1	16880
77583	5301	1322184	2003-05-01	2003-05-01	1	12173
44770	3035	1125315	1999-09-21	1999-09-28	1	10862
11528	788	1112807	1972-01-28	1972-02-11	1	771
67101	4579	1778162	1999-05-14	1999-05-28	1	10739
58637	3998	1713332	1991-05-25	1991-06-15	1	7835
69130	4719	1112807	1944-10-10	1944-11-14	1	-9179
51986	3539	1125315	2011-08-19	2011-09-02	1	15219
64954	4436	1192710	1984-06-17	1984-06-17	1	5281
34464	2334	1759842	1965-11-16	1965-11-30	1	-1493
18000	1239	1759842	1987-08-24	1987-10-12	1	6493
62911	4297	920293	2019-02-09	2019-02-16	1	17943
28824	1950	1125315	1988-08-29	1988-09-19	1	6836
55872	3803	738818	1966-07-12	1966-07-19	1	-1262
22788	1545	1125315	1970-09-27	1970-11-26	1	329
14806	1024	1125315	1955-07-17	1955-07-31	1	-5268
6638	458	1521369	1989-07-25	1990-07-20	1	7505
59258	4035	1503184	1987-03-13	1988-03-07	1	6640
8314	578	1125315	1968-11-21	1968-12-05	1	-392
62850	4291	1713332	1987-06-02	1987-06-16	1	6375
22310	1518	1713332	1975-09-16	1975-09-30	1	2098
60557	4131	1118084	2018-05-22	2018-05-22	1	17673
22174	1510	738818	1995-05-12	1995-05-26	1	9276
56736	3866	920293	2004-11-04	2004-11-18	2	12740
17621	1217	1125315	2003-07-05	2003-07-12	1	12245
11136	761	1713332	1981-09-30	1981-10-14	1	4304
69345	4731	1125315	2014-06-14	2014-06-21	1	16242
14771	1022	1713332	2004-04-30	2004-05-07	1	12545
19905	1355	1503184	1980-07-20	1981-07-15	1	4213
2053	137	1174888	1984-08-11	1984-08-11	1	5336
17144	1180	1125315	2010-09-28	2010-11-27	2	14940
76378	5222	1125315	1973-07-09	1973-07-16	1	1292
63618	4349	1119510	2008-05-20	2008-05-27	1	14026
58377	3982	933724	1968-11-29	1968-12-06	1	-391
64276	4390	1125315	2006-11-18	2006-12-02	1	13484
30098	2034	1729720	1991-07-28	1991-08-09	1	7890
55393	3767	738818	2016-03-13	2016-03-20	1	16880
77773	5315	1112807	1916-09-16	1916-09-30	1	-19451
44771	3035	1322184	2014-09-12	2014-09-12	1	16325
11529	788	1112807	1973-04-06	1973-04-20	1	1205
67102	4579	1125315	1977-11-18	1978-02-16	1	2968
58638	3998	1112807	1974-12-17	1975-01-14	1	1839
69131	4719	1119510	1953-01-28	1953-02-11	1	-6168
51987	3539	1713332	1983-12-27	1984-01-10	1	5122
64955	4436	975125	1984-06-02	1984-06-02	1	5266
34465	2334	1759842	1973-11-25	1973-12-02	1	1431
18001	1239	19127890	1989-05-26	1990-05-21	1	7445
62912	4297	1110410	1991-02-19	1991-02-19	1	7719
28825	1950	1137529	1985-01-10	1985-01-10	1	5488
55873	3803	1125315	1966-07-12	1966-07-19	1	-1262
22789	1545	1125315	2012-08-15	2012-08-29	1	15581
14807	1024	1125315	1971-03-15	1971-03-29	1	452
6639	458	1717327	1973-03-11	1973-03-25	1	1179
63423	4333	738818	1983-08-27	1983-09-10	1	5000
8315	578	1125315	1996-10-06	1996-10-20	1	9789
62851	4291	1115008	2017-01-27	2017-02-26	1	17223
22311	1518	1729720	1956-10-05	1956-10-13	1	-4828
60558	4131	1177480	1989-04-04	1989-05-02	1	7061
22175	1510	920293	1995-11-18	1995-11-25	1	9459
56737	3866	1112807	1953-03-24	1953-04-07	1	-6113
17622	1217	1177480	2014-07-11	2014-08-08	1	16290
11137	761	1713332	1982-08-05	1982-08-12	1	4606
69346	4731	1738521	1975-05-08	1975-05-22	1	1967
14772	1022	1729720	1973-11-09	1973-11-21	1	1420
19906	1355	1738521	1967-07-22	1967-08-05	1	-880
2054	137	19127890	1990-05-31	1991-05-26	1	7815
17145	1180	1728416	1956-09-08	1956-09-22	1	-4849
76379	5222	1125315	2016-05-15	2016-06-12	1	16964
63619	4349	738818	2008-05-20	2008-05-27	1	14026
58378	3982	1119510	1952-08-18	1952-09-01	1	-6331
64277	4390	1177480	2009-04-22	2009-05-20	1	14384
30099	2034	1759842	2003-05-03	2003-05-17	1	12189
55394	3767	1118084	2018-10-20	2018-10-20	1	17824
77774	5315	1125315	1949-10-23	1949-11-06	1	-7361
44772	3035	1713332	2015-07-11	2015-08-01	1	16648
11530	788	1177480	1985-09-16	1985-10-07	1	5758
67103	4579	1728416	1969-10-01	1969-10-15	1	-78
58639	3998	1125315	1975-03-07	1975-03-14	1	1898
69132	4719	1125315	2009-10-22	2009-10-29	1	14546
54402	3701	738818	1980-06-16	1980-06-23	1	3826
64956	4436	1125315	1968-05-12	1968-05-26	1	-585
34466	2334	1124300	1971-07-05	1971-07-05	1	550
21096	1438	1112807	1954-05-31	1954-06-14	1	-5680
62913	4297	1118084	2017-02-14	2017-02-14	1	17211
28826	1950	1177480	2016-01-26	2016-03-26	1	16886
55874	3803	1125315	2011-04-21	2011-05-05	1	15099
22790	1545	1125315	2013-06-25	2013-07-23	1	15909
14808	1024	1125315	1979-04-11	1979-05-02	1	3408
6640	458	1729720	1978-05-10	1978-05-18	1	3059
63424	4333	1125315	1970-12-27	1971-01-03	1	367
8316	578	1125315	2009-07-22	2009-07-29	1	14454
62852	4291	1125315	1974-02-21	1974-03-07	1	1526
22312	1518	1112807	1967-04-26	1967-05-10	1	-967
60559	4131	1503184	1997-05-02	1998-04-27	1	10343
22176	1510	1115008	2010-01-29	2010-02-26	1	14666
56738	3866	1124957	1964-08-19	1964-08-19	1	-1961
17623	1217	1713332	2015-07-15	2015-08-05	1	16652
11138	761	1713332	1983-06-25	1983-07-09	1	4937
69347	4731	1728416	1975-01-15	1975-01-29	1	1854
14773	1022	1759842	2004-04-30	2004-05-07	1	12545
19907	1355	1759842	2009-04-22	2009-04-29	1	14363
2055	137	1112807	1972-08-23	1972-09-06	1	979
17146	1180	1112807	1986-12-28	1987-02-01	1	6240
76380	5222	1149380	1999-01-14	1999-01-14	1	10605
63620	4349	1118084	2019-05-12	2019-05-12	1	18028
58379	3982	1125315	1986-09-22	1986-09-29	1	6115
64278	4390	1521369	1974-01-28	1975-01-23	1	1848
30100	2034	1119510	1939-12-22	1939-12-29	1	-10961
55395	3767	1125315	1989-07-19	1989-08-02	1	7153
77775	5315	1729720	1944-04-19	1944-05-02	1	-9375
44773	3035	1717327	1968-01-28	1968-02-11	1	-690
11531	788	1728416	1972-01-28	1972-02-11	1	771
67104	4579	738818	1976-11-12	1976-11-19	1	2514
58640	3998	1125315	1990-02-05	1990-02-12	1	7347
69133	4719	1177480	2013-12-24	2014-01-07	1	16077
54403	3701	1125315	1980-06-16	1980-06-23	1	3826
64957	4436	1174888	2017-06-29	2017-06-29	1	17346
34467	2334	1125315	1964-08-14	1964-08-14	1	-1966
21097	1438	1118084	1986-04-29	1986-04-29	1	5962
62914	4297	1125315	1978-09-07	1978-11-06	1	3231
28827	1950	920293	1966-10-23	1966-10-30	1	-1159
55875	3803	1503184	1974-04-10	1975-04-05	1	1920
22791	1545	1738521	1974-10-06	1974-10-20	1	1753
14809	1024	1125315	1981-12-17	1981-12-24	1	4375
6641	458	1125315	1974-02-06	1974-02-13	1	1504
63425	4333	1125315	1983-08-27	1983-09-10	1	5000
8317	578	1503184	1989-04-15	1990-04-10	1	7404
62853	4291	1177480	1975-10-25	1975-11-08	1	2137
22313	1518	1125315	1968-06-03	1968-06-24	1	-556
60560	4131	1521369	1997-05-02	2000-04-16	3	11063
22177	1510	1125315	1959-10-28	1959-11-11	1	-3704
56739	3866	1125315	1960-10-11	1960-11-08	1	-3341
17624	1217	1729720	2012-11-21	2012-12-01	1	15675
11139	761	738818	2015-03-29	2015-04-12	1	16537
69348	4731	1112807	1972-10-27	1973-01-25	1	1120
14774	1022	1177480	2005-12-21	2006-01-11	1	13159
21251	1447	1112807	1972-06-27	1972-07-27	1	938
2056	137	1115008	1996-10-07	1997-01-05	1	9866
17147	1180	1118084	1990-05-23	1990-05-23	1	7447
76381	5222	1310149	2004-02-12	2004-02-12	1	12460
63621	4349	1125315	2008-05-20	2008-05-27	1	14026
58380	3982	1125315	2007-12-10	2007-12-24	1	13871
64279	4390	738818	1962-11-19	1962-12-03	1	-2586
30101	2034	1125315	1954-12-20	1954-12-27	1	-5484
55396	3767	1125315	2016-03-13	2016-03-20	1	16880
77776	5315	1112807	1920-09-18	1920-10-02	1	-17988
44774	3035	1759842	1968-02-04	1968-02-11	1	-690
11532	788	1728416	1973-04-06	1973-04-20	1	1205
67105	4579	1115008	2009-01-04	2009-02-08	1	14283
58641	3998	1729720	2005-05-13	2005-05-26	1	12929
69134	4719	1729720	1997-08-19	1997-08-31	1	10104
54404	3701	1125315	1986-09-16	1986-10-14	1	6130
69041	4712	1124300	2005-10-01	2005-10-01	1	13057
34468	2334	1125315	1966-10-03	1966-10-17	1	-1172
21098	1438	1125315	1952-04-19	1952-05-03	1	-6452
62915	4297	1713332	1983-10-20	1983-11-10	1	5061
28828	1950	933724	1966-10-23	1966-10-30	1	-1159
55876	3803	1521369	1976-03-30	1978-03-20	2	3000
24871	1683	1125315	1981-04-30	1981-05-28	1	4165
14810	1024	1125315	1992-02-10	1992-02-24	1	8089
6642	458	1125315	1975-07-11	1975-07-25	1	2031
63426	4333	1177480	2011-12-01	2011-12-15	1	15323
8318	578	1549786	1991-04-05	1992-03-30	1	8124
62854	4291	1713332	1989-05-30	1989-06-06	1	7096
22314	1518	1125315	1997-01-22	1997-02-05	1	9897
60561	4131	1549786	1996-05-07	1997-05-02	1	9983
22178	1510	1125315	1992-11-14	1992-11-21	1	8360
56740	3866	1125315	1968-04-30	1968-05-21	1	-590
17625	1217	1738521	1974-02-19	1974-03-05	1	1524
11140	761	1125315	2015-03-29	2015-04-12	1	16537
69349	4731	1124300	2008-09-08	2008-09-08	1	14130
14775	1022	1309944	2010-02-09	2010-02-09	1	14649
21252	1447	1125315	1974-03-05	1974-03-19	1	1538
2057	137	1729720	1978-11-04	1978-11-13	1	3238
17148	1180	1119510	1961-03-18	1961-03-25	1	-3204
76382	5222	1326303	2004-02-12	2004-02-12	1	12460
63622	4349	1713332	1983-05-01	1983-05-15	1	4882
58381	3982	1713332	1976-01-29	1976-02-05	1	2226
64280	4390	738818	2004-12-20	2004-12-27	1	12779
30102	2034	1177480	2006-02-25	2006-03-25	1	13232
55397	3767	1729720	2017-09-20	2017-10-02	1	17441
77777	5315	1118084	1957-03-25	1957-03-25	1	-4665
44775	3035	1759842	2015-07-11	2015-08-01	1	16648
11533	788	1729720	1970-11-06	1970-11-16	1	319
67106	4579	1119510	1982-07-18	1982-08-01	1	4595
58642	3998	738818	1964-02-15	1964-02-22	1	-2140
69135	4719	1759842	1945-03-04	1945-04-22	1	-9020
54405	3701	1729720	1959-12-16	1959-12-25	1	-3660
69042	4712	1125315	1988-03-04	1988-03-18	1	6651
34469	2334	1137529	1963-02-14	1963-02-14	1	-2513
21099	1438	1125315	1953-12-08	1953-12-22	1	-5854
62916	4297	1746114	1991-02-19	1991-02-19	1	7719
28829	1950	1713332	1973-06-18	1973-07-09	1	1285
55877	3803	1713332	1961-08-12	1961-09-02	1	-3043
24872	1683	1738521	1977-05-10	1977-05-24	1	2700
14811	1024	1125315	2012-08-16	2012-09-15	1	15598
6643	458	1125315	2002-06-23	2002-07-07	1	11875
63427	4333	1713332	2002-01-19	2002-02-02	1	11720
8319	578	1759842	2010-11-06	2010-11-20	1	14933
65183	4454	738818	1985-12-08	1985-12-15	1	5827
22315	1518	1125315	2010-04-29	2010-05-06	1	14735
60562	4131	1549786	1998-04-27	1999-04-22	1	10703
22179	1510	1177480	1974-02-17	1974-03-03	1	1522
56741	3866	1125315	2003-07-06	2003-07-27	1	12260
17626	1217	1759842	2015-07-15	2015-08-05	1	16652
11141	761	1149380	1980-12-21	1998-06-05	1	10382
69350	4731	1713332	1992-03-19	1992-03-26	1	8120
14776	1022	1343916	2010-02-09	2010-02-09	1	14649
21253	1447	1125315	1988-09-18	1988-10-02	1	6849
2058	137	1729720	1985-11-10	1985-11-17	1	5799
17149	1180	1125315	1983-04-09	1983-04-16	1	4853
76383	5222	1729720	1922-12-21	1922-12-30	1	-17169
64404	4398	1125315	1984-02-07	1984-02-21	1	5164
58382	3982	1729720	1965-02-20	1965-02-27	1	-1769
64281	4390	1125315	1962-11-19	1962-12-03	1	-2586
30103	2034	1361711	2004-11-10	2004-11-10	1	12732
55398	3767	1768849	1988-08-15	1988-08-29	1	6815
77778	5315	1125315	1957-09-09	1957-09-23	1	-4483
47084	3195	1118084	1984-10-09	1984-10-09	1	5395
11534	788	1759842	2000-02-24	2000-03-16	1	11032
67107	4579	1124300	2008-03-20	2008-03-20	1	13958
58643	3998	914335	1982-08-26	1982-08-26	1	4620
69136	4719	1124300	1972-05-11	1972-05-11	1	861
54406	3701	1759842	2005-02-22	2005-03-08	1	12850
69043	4712	1307863	2017-03-17	2017-03-17	1	17242
34470	2334	1307863	2011-06-23	2011-06-23	1	15148
21100	1438	1125315	1980-09-01	1980-09-22	1	3917
62917	4297	1759842	1999-06-01	1999-06-22	1	10764
28830	1950	1729720	1952-10-10	1952-10-22	1	-6280
55878	3803	1728416	1961-12-04	1961-12-18	1	-2936
24873	1683	19127890	1990-06-22	1991-06-17	1	7837
14812	1024	1539403	2016-05-29	2016-05-29	1	16950
6644	458	1177480	2010-06-25	2010-07-25	1	14815
63428	4333	1759842	2002-01-19	2002-02-02	1	11720
8320	578	19127890	1981-05-27	1982-05-22	1	4524
65184	4454	1112807	1948-12-24	1949-01-21	1	-7650
22316	1518	1729720	1955-07-03	1955-07-11	1	-5288
60563	4131	1713332	2018-06-25	2018-07-09	1	17721
22180	1510	1713332	1959-01-08	1959-01-22	1	-3997
58166	3968	1119510	1913-10-01	1913-10-15	1	-20532
17627	1217	1112807	1988-10-20	1988-11-24	1	6902
11142	761	1729720	1987-01-04	1987-01-13	1	6221
69351	4731	1759842	1992-03-19	1992-03-26	1	8120
14777	1022	1717327	1966-02-19	1966-03-05	1	-1398
21254	1447	1125315	2009-01-17	2009-01-31	1	14275
2059	137	1759842	1983-07-17	1983-08-07	1	4966
17150	1180	1125315	1956-09-08	1956-09-22	1	-4849
76384	5222	738818	1977-04-29	1977-05-13	1	2689
64405	4398	1125315	1993-04-15	1993-04-22	1	8512
58383	3982	1768849	1988-11-18	1988-12-02	1	6910
64282	4390	1125315	1963-07-28	1963-08-11	1	-2335
30104	2034	1729720	2006-06-22	2006-07-04	1	13333
55500	3777	1125315	2000-03-05	2000-03-12	1	11028
77779	5315	1125315	1977-03-02	1977-03-16	1	2631
47085	3195	1124957	2015-09-14	2015-09-14	1	16692
11535	788	1759842	2013-04-24	2013-05-08	1	15833
67108	4579	1125315	1969-07-05	1969-07-19	1	-166
58644	3998	1118084	1986-06-22	1986-06-22	1	6016
69137	4719	1125315	1966-07-05	1966-07-12	1	-1269
54407	3701	1112807	1955-12-16	1956-02-14	1	-5070
69044	4712	1326303	2017-03-17	2017-03-17	1	17242
34471	2334	1322184	2015-08-27	2015-08-27	1	16674
21101	1438	1728416	1953-12-08	1953-12-22	1	-5854
62918	4297	19016749	1991-02-19	1991-02-19	1	7719
28831	1950	1125315	1998-12-09	1998-12-16	1	10576
55879	3803	933724	2002-05-10	2002-05-17	1	11824
24874	1683	1102527	2012-10-01	2012-10-01	1	15614
14813	1024	1713332	1987-11-13	1987-11-27	1	6539
6645	458	1729720	1978-03-31	1978-04-07	1	3018
63429	4333	1119510	1983-08-27	1983-09-10	1	5000
8321	578	19127890	1984-05-11	1985-05-06	1	5604
65185	4454	1119510	1932-10-04	1932-10-18	1	-13589
23554	1598	920293	1977-02-27	1977-03-06	1	2621
60564	4131	1759842	2018-06-25	2018-07-09	1	17721
22181	1510	1713332	1987-12-20	1988-01-10	1	6583
58167	3968	1125315	1913-10-01	1913-10-15	1	-20532
17628	1217	1119510	2003-07-05	2003-07-12	1	12245
16877	1162	715997	2000-07-07	2000-07-07	1	11145
69755	4759	738818	2000-08-10	2000-08-24	1	11193
14778	1022	1124300	2006-07-09	2006-07-09	1	13338
21255	1447	1551099	1970-08-23	1970-08-23	1	234
2060	137	1759842	2011-04-18	2011-04-25	1	15089
18283	1258	920293	1984-04-04	1984-04-11	1	5214
76385	5222	1124300	1961-03-25	1961-03-25	1	-3204
64406	4398	1177480	1990-08-08	1990-09-07	1	7554
58384	3982	701322	2012-11-05	2012-11-05	1	15649
64283	4390	1125315	2001-05-29	2001-07-03	1	11506
30105	2034	1759842	1968-01-10	1968-01-24	1	-708
55501	3777	1177480	1987-07-10	1987-07-24	1	6413
77780	5315	738818	1945-02-14	1945-02-28	1	-9073
47086	3195	1125315	1990-03-19	1990-04-02	1	7396
11536	788	1115008	2015-08-01	2015-08-22	1	16669
67109	4579	1125315	1976-11-12	1976-11-19	1	2514
58645	3998	1125315	1964-02-15	1964-02-22	1	-2140
69138	4719	1713332	1945-03-04	1945-04-22	1	-9020
54408	3701	1112807	1962-05-13	1962-06-03	1	-2769
69045	4712	1759842	1972-10-03	1972-10-17	1	1020
34472	2334	1326303	2011-06-23	2011-06-23	1	15148
21102	1438	738818	1965-12-15	1965-12-29	1	-1464
62919	4297	738818	2008-01-28	2008-02-04	1	13913
28832	1950	1125315	2017-02-03	2017-02-10	1	17207
55880	3803	1112807	1962-04-20	1962-05-04	1	-2799
24875	1683	1112807	1973-09-09	1973-09-23	1	1361
14814	1024	1759842	1987-11-13	1987-11-27	1	6539
6646	458	1738521	1975-07-11	1975-07-25	1	2031
63430	4333	1124300	1994-06-03	1994-06-03	1	8919
8322	578	19127890	1991-04-05	1992-03-30	1	8124
65186	4454	1125315	1985-12-08	1985-12-15	1	5827
23555	1598	933724	1977-02-27	1977-03-06	1	2621
60565	4131	1125315	2014-09-23	2014-09-30	1	16343
22182	1510	1728416	1959-10-28	1959-11-11	1	-3704
58168	3968	1125315	1944-02-04	1944-02-11	1	-9456
17629	1217	1137529	1995-06-30	1995-06-30	1	9311
16878	1162	1119510	1933-09-13	1933-09-20	1	-13252
69756	4759	1118084	2018-05-25	2018-05-25	1	17676
14779	1022	1125315	1966-02-19	1966-03-05	1	-1398
21256	1447	1717327	1974-03-05	1974-03-19	1	1538
4406	300	1124300	2009-11-30	2009-11-30	1	14578
18284	1258	933724	1984-04-04	1984-04-11	1	5214
76386	5222	1125315	1947-12-21	1948-01-04	1	-8033
64407	4398	1713332	1986-07-01	1986-10-14	1	6130
58385	3982	1125315	1940-08-03	1940-08-17	1	-10729
64284	4390	1713332	1974-07-06	1974-07-20	1	1661
30106	2034	738818	1996-09-15	1996-09-29	1	9768
55502	3777	1177480	2005-01-27	2005-02-24	1	12838
77781	5315	1112807	1917-10-22	1917-11-05	1	-19050
47087	3195	1177480	2015-09-07	2015-11-13	1	16752
11537	788	1118084	2012-11-18	2012-11-18	1	15662
67110	4579	1125315	2010-06-10	2010-06-24	1	14784
58646	3998	1125315	1972-10-28	1973-01-26	1	1121
69139	4719	1729720	1957-09-04	1957-09-15	1	-4491
54409	3701	1112807	1966-12-09	1966-12-23	1	-1105
69046	4712	1125315	2007-05-25	2007-06-01	1	13665
34473	2334	1347450	2016-11-17	2016-11-17	1	17122
21103	1438	1125315	1955-04-21	1955-04-28	1	-5362
62920	4297	782043	1991-02-19	1991-02-19	1	7719
28833	1950	1729720	1951-04-08	1951-04-17	1	-6834
55881	3803	1115008	2000-12-09	2001-01-13	1	11335
24876	1683	1125315	1985-11-03	1986-02-01	1	5875
14815	1024	1125315	1987-07-21	1987-08-04	1	6424
6647	458	19127890	1991-07-15	1992-07-09	1	8225
63431	4333	1112807	1955-11-15	1955-11-29	1	-5147
8323	578	1118084	2001-12-08	2001-12-08	1	11664
65187	4454	1125315	2000-05-07	2000-05-28	1	11105
23556	1598	1112807	1970-02-16	1970-03-02	1	60
60566	4131	1503184	1999-04-22	2000-04-16	1	11063
23431	1590	738818	2006-10-23	2006-11-05	1	13457
58169	3968	1125315	1954-01-03	1954-02-02	1	-5812
17630	1217	1115008	2019-04-14	2019-04-28	1	18014
16879	1162	1125315	1952-10-08	1952-10-08	1	-6294
69757	4759	1177480	2017-01-02	2017-01-16	1	17182
14780	1022	1125315	1969-07-17	1969-07-31	1	-154
21257	1447	1177480	1975-03-14	1975-04-13	1	1928
4407	300	1125315	2007-08-21	2007-08-28	1	13753
18285	1258	1125315	2013-10-18	2013-10-25	1	16003
76387	5222	1125315	1977-04-29	1977-05-13	1	2689
64408	4398	1728416	1960-01-13	1960-01-27	1	-3627
58386	3982	1125315	1984-05-16	1984-05-30	1	5263
64285	4390	19127890	1974-01-28	1975-01-23	1	1848
30107	2034	1102527	2011-09-02	2011-09-02	1	15219
55503	3777	1125315	2005-01-27	2005-01-27	1	12810
77782	5315	1112807	1919-06-18	1919-07-02	1	-18446
47088	3195	740275	1953-11-21	1954-06-12	1	-5682
11538	788	1125315	1998-11-08	1998-11-22	1	10552
67111	4579	1177480	1999-05-14	1999-05-28	1	10739
58647	3998	1759842	1991-05-25	1991-06-15	1	7835
69140	4719	1729720	2006-10-15	2006-10-27	1	13448
54410	3701	1124300	1994-05-10	1994-05-10	1	8895
69047	4712	1177480	2017-05-01	2017-05-15	1	17301
34474	2334	1713332	1951-10-28	1951-11-11	1	-6626
21104	1438	1125315	1965-09-07	1965-09-14	1	-1570
62921	4297	933724	2019-02-09	2019-02-16	1	17943
28834	1950	1759842	1973-06-18	1973-07-09	1	1285
55882	3803	1119510	1966-07-12	1966-07-19	1	-1262
24877	1683	1125315	1987-01-27	1987-03-03	1	6270
14816	1024	1174888	2004-08-23	2004-08-23	1	12653
6648	458	920293	2009-09-09	2009-09-16	1	14503
63432	4333	1112807	1959-08-26	1959-09-30	1	-3746
8324	578	1119510	1969-02-21	1969-02-28	1	-307
65188	4454	1310149	2006-10-07	2006-10-07	1	13428
23557	1598	1125315	1969-06-23	1969-06-30	1	-185
60567	4131	1549786	1991-06-03	1992-05-28	1	8183
23432	1590	1125315	2006-10-23	2006-11-05	1	13457
58170	3968	1125315	1965-02-19	1965-02-26	1	-1770
17631	1217	1125315	2006-12-13	2006-12-27	1	13509
16880	1162	1174888	1952-10-08	1952-10-08	1	-6294
69758	4759	1729720	1986-06-30	1986-07-10	1	6034
14781	1022	1125315	1970-03-31	1970-04-07	1	96
21258	1447	1521369	1974-07-13	1976-07-02	2	2374
4408	300	1503184	1991-02-23	1992-02-18	1	8083
18286	1258	1713332	2000-05-14	2000-05-28	1	11105
76388	5222	1137529	1999-01-14	1999-01-14	1	10605
64409	4398	1759842	1986-07-01	1986-10-14	1	6130
58387	3982	1177480	2010-06-17	2010-07-15	1	14805
64286	4390	1112807	1966-05-30	1966-06-20	1	-1291
30108	2034	1125315	1999-07-27	1999-08-31	1	10834
55504	3777	1713332	1996-07-27	1996-11-30	1	9830
77783	5315	1125315	1942-01-04	1942-01-18	1	-10210
47089	3195	1125315	1968-02-13	1968-02-20	1	-681
11539	788	1713332	2000-02-24	2000-03-16	1	11032
68560	4677	738818	1981-03-02	1981-03-16	1	4092
58648	3998	1102527	2016-10-24	2016-10-24	1	17098
69141	4719	738818	1953-01-28	1953-02-11	1	-6168
54411	3701	1125315	1984-12-18	1985-01-24	2	5502
69048	4712	1713332	1972-10-03	1972-10-17	1	1020
34475	2334	1729720	1942-05-10	1942-05-17	1	-10091
21105	1438	1125315	1965-12-15	1965-12-29	1	-1464
62922	4297	967823	1991-02-19	1991-02-20	1	7720
31051	2098	1125315	1973-11-19	1973-12-03	1	1432
55883	3803	1717327	1962-04-20	1962-05-04	1	-2799
24878	1683	1521369	1985-07-18	1986-07-13	1	6037
14817	1024	1713332	1995-09-25	1995-10-16	1	9419
6649	458	1124300	2007-06-21	2007-06-21	1	13685
63433	4333	1112807	1980-05-03	1980-05-17	1	3789
8325	578	1129625	1971-06-20	1971-06-20	1	535
65189	4454	1112807	1933-06-20	1933-07-11	1	-13323
23558	1598	1125315	2009-09-12	2009-09-26	1	14513
60568	4131	1729720	1985-04-26	1985-05-05	1	5603
23433	1590	1177480	2014-08-23	2014-10-22	1	16365
58171	3968	1125315	2019-01-27	2019-02-10	1	17937
17632	1217	1125315	2015-05-28	2015-06-11	1	16597
16881	1162	1713332	1943-04-06	1943-04-27	1	-9746
69759	4759	723013	2009-09-01	2009-11-24	1	14572
14782	1022	1119510	1988-12-18	1989-01-01	1	6940
21259	1447	1713332	1985-12-08	1985-12-29	1	5841
4409	300	1713332	1995-01-20	1995-01-27	1	9157
18287	1258	1713332	2004-07-12	2004-07-26	1	12625
76389	5222	1759842	1959-12-05	1959-12-26	1	-3659
64410	4398	1112807	1960-01-13	1960-01-27	1	-3627
58388	3982	1322184	2018-04-27	2018-04-27	1	17648
64287	4390	1119510	2004-12-20	2004-12-27	1	12779
30109	2034	1713332	2003-05-03	2003-05-17	1	12189
55505	3777	1759842	1996-07-27	1996-11-30	1	9830
77784	5315	1125315	1945-02-14	1945-02-28	1	-9073
47090	3195	1728416	1951-02-10	1951-02-24	1	-6886
11540	788	1713332	2013-04-24	2013-05-08	1	15833
68561	4677	1112807	1966-03-01	1966-03-29	1	-1374
58649	3998	1112807	1953-06-10	1953-06-24	1	-6035
69142	4719	1112807	1935-04-01	1935-04-15	1	-12680
54412	3701	1125315	2000-01-09	2000-01-30	1	10986
69049	4712	1729720	1979-03-18	1979-03-25	1	3370
34476	2334	1729720	1949-08-12	1949-08-19	1	-7440
21106	1438	1728416	1954-05-31	1954-06-14	1	-5680
62923	4297	1112807	1979-11-01	1979-11-22	1	3612
31052	2098	1503184	1979-06-15	1980-06-09	1	3812
55884	3803	1729720	1973-07-22	1973-08-03	1	1310
24879	1683	1112807	1977-05-10	1977-05-24	1	2700
14818	1024	1125315	1982-03-17	1982-03-31	1	4472
6650	458	1503184	1989-07-25	1990-07-20	1	7505
63434	4333	1125315	1980-01-17	1980-01-31	1	3682
8326	578	1503184	1981-05-27	1982-05-22	1	4524
65190	4454	1125315	1950-02-15	1950-04-16	2	-7200
23559	1598	1728416	1958-05-20	1958-06-03	1	-4230
60569	4131	1729720	1996-09-07	1996-09-17	1	9756
23434	1590	738818	1985-05-24	1985-06-07	1	5636
58172	3968	1174888	1977-07-01	1977-07-01	1	2738
17633	1217	1149380	1995-06-30	1995-06-30	1	9311
16882	1162	1729720	1981-09-24	1981-10-01	1	4291
69760	4759	723013	2016-01-12	2016-09-06	1	17050
16175	1118	920293	2000-11-08	2000-11-15	1	11276
21260	1447	1759842	1985-12-08	1985-12-29	1	5841
4410	300	1759842	1995-01-20	1995-01-27	1	9157
18288	1258	1759842	2000-05-14	2000-05-28	1	11105
76390	5222	975125	1946-07-24	1946-07-24	1	-8562
64411	4398	1112807	1961-02-06	1961-05-07	1	-3161
58389	3982	1347450	2018-04-27	2018-04-27	1	17648
64288	4390	1125315	1973-02-13	1973-03-06	1	1160
30110	2034	1759842	1955-04-27	1955-05-11	1	-5349
55506	3777	1778162	2005-01-27	2005-02-24	1	12838
77785	5315	1119510	1945-02-14	1945-02-28	1	-9073
47091	3195	1759842	2015-12-10	2015-12-31	1	16800
12609	866	1759842	2000-03-16	2000-03-30	1	11046
68562	4677	1118084	1996-09-19	1996-09-19	1	9758
58650	3998	1115008	2008-08-02	2008-09-06	1	14128
69143	4719	1112807	1992-06-19	1992-07-03	1	8219
54413	3701	1125315	2004-10-01	2004-10-08	1	12699
69050	4712	1759842	2019-03-31	2019-04-21	1	18007
34477	2334	1112807	1951-06-10	1951-06-24	1	-6766
21107	1438	1729720	2009-01-13	2009-01-21	1	14265
62924	4297	1115008	1999-11-12	1999-12-03	1	10928
31053	2098	1713332	2007-08-28	2008-07-22	1	14082
55885	3803	1759842	2014-09-13	2014-12-06	1	16410
24880	1683	1115008	2012-10-01	2012-11-30	1	15674
14819	1024	1125315	1991-10-10	1991-10-31	1	7973
6651	458	1549786	1991-07-15	1992-07-09	1	8225
63435	4333	1125315	1968-04-15	1968-05-06	1	-605
8327	578	1503184	1984-05-11	1985-05-06	1	5604
65191	4454	1125315	1969-09-03	1969-09-17	1	-106
23560	1598	1759842	2008-09-21	2008-10-05	1	14157
60570	4131	19127890	1991-06-03	1992-05-28	1	8183
23435	1590	1119510	2006-10-23	2006-11-05	1	13457
58173	3968	1310149	2006-03-31	2006-03-31	1	13238
17634	1217	1713332	1993-06-01	1993-06-15	1	8566
16883	1162	715997	1999-02-13	1999-02-13	1	10635
69761	4759	740275	2012-11-06	2012-11-06	1	15650
16176	1118	933724	2003-12-29	2004-01-12	1	12429
21261	1447	920293	2009-08-31	2009-09-07	1	14494
4411	300	19127890	1986-03-21	1989-03-05	3	7003
18289	1258	1759842	2004-07-12	2004-07-26	1	12625
76391	5222	1112807	1919-10-24	1919-11-07	1	-18318
64412	4398	1119510	1993-04-15	1993-04-22	1	8512
58390	3982	1759842	1976-01-29	1976-02-05	1	2226
64289	4390	1125315	1985-09-13	1985-09-27	1	5748
30111	2034	738818	1939-12-22	1939-12-29	1	-10961
55507	3777	1118084	2018-07-02	2018-07-02	1	17714
77786	5315	1361711	1967-12-10	1979-04-15	1	3391
47092	3195	1112807	1951-02-10	1951-02-24	1	-6886
12610	866	1119510	1972-10-31	1972-11-14	1	1048
68563	4677	1125315	1981-03-02	1981-03-16	1	4092
58651	3998	1125315	1978-10-25	1978-11-08	1	3233
69144	4719	1125315	1969-06-06	1969-06-20	1	-195
54414	3701	1174888	1984-12-25	1984-12-25	1	5472
69051	4712	1125315	2013-02-28	2013-03-07	1	15771
34478	2334	1125315	1942-09-26	1942-10-10	1	-9945
21108	1438	1125315	1975-04-17	1975-05-01	1	1946
62925	4297	1119510	1977-12-13	1977-12-27	1	2917
31054	2098	1112807	1962-11-01	1962-11-15	1	-2604
55886	3803	19127890	1974-04-10	1975-04-05	1	1920
24881	1683	1125315	1998-12-28	1999-01-04	1	10595
14820	1024	1713332	2004-08-23	2004-09-27	1	12688
6652	458	933724	2009-09-09	2009-09-16	1	14503
63436	4333	1125315	1995-12-10	1995-12-17	1	9481
8328	578	1515774	1991-04-05	1992-03-30	1	8124
65192	4454	1759842	1922-01-24	1922-02-14	1	-17488
23561	1598	19127890	1979-12-06	1980-11-30	1	3986
60571	4131	19127890	1996-05-07	1998-04-27	2	10343
23436	1590	1125315	1985-05-24	1985-06-07	1	5636
58174	3968	1738521	1977-07-01	1977-07-29	1	2766
17635	1217	1759842	1993-06-01	1993-06-15	1	8566
16884	1162	1112807	1924-09-05	1924-09-19	1	-16540
69762	4759	1102527	1989-06-16	1989-06-16	1	7106
16177	1118	1118084	2014-05-19	2014-05-19	1	16209
21262	1447	933724	2009-08-31	2009-09-07	1	14494
4412	300	1115008	2004-02-05	2004-03-04	1	12481
18290	1258	19127890	1983-02-27	1984-02-22	1	5165
76392	5222	1112807	1920-02-23	1920-03-08	1	-18196
64413	4398	1125315	2005-05-23	2005-06-06	1	12940
62361	4256	708298	1963-11-14	1963-11-14	1	-2240
64290	4390	1125315	1994-06-10	1994-06-24	1	8940
30112	2034	738818	2006-05-19	2006-05-26	1	13294
55508	3777	1124957	2005-01-27	2005-01-27	1	12810
462	32	1112807	1951-07-17	1951-09-15	1	-6683
47093	3195	1115008	2001-12-14	2002-01-18	1	11705
12611	866	1125315	2007-03-22	2007-04-05	1	13608
68564	4677	1125315	1983-10-15	1983-11-05	1	5056
58652	3998	1177480	2016-10-24	2016-12-23	1	17158
69145	4719	1177480	2003-06-06	2003-06-20	1	12223
54415	3701	1119510	1980-06-16	1980-06-23	1	3826
69052	4712	1310149	2017-03-17	2017-03-17	1	17242
34479	2334	1759842	1951-10-28	1951-11-11	1	-6626
21109	1438	1125315	2017-04-29	2017-05-13	1	17299
62926	4297	1124957	1991-02-20	1991-02-20	1	7720
31055	2098	1118084	2001-11-06	2001-11-06	1	11632
58122	3966	920293	2017-01-08	2017-01-15	1	17181
24882	1683	1515774	1990-06-22	1991-06-17	1	7837
14821	1024	1759842	1995-09-25	1995-10-16	1	9419
6653	458	1125315	1991-12-12	1991-12-19	1	8022
66827	4562	1112807	1963-02-17	1963-03-03	1	-2496
8329	578	1521369	1987-04-26	1988-04-20	1	6684
65193	4454	1759842	1991-01-14	1991-02-04	1	7704
23562	1598	738818	2011-06-19	2011-07-03	1	15158
60572	4131	1125315	1988-06-09	1988-06-23	1	6748
23437	1590	1174888	2014-08-23	2014-08-23	1	16305
58175	3968	1759842	1921-07-03	1921-07-10	1	-17707
25296	1716	1102527	1993-06-18	1993-06-18	1	8569
16885	1162	1112807	1993-03-07	1993-04-06	1	8496
69763	4759	1125315	1992-06-30	1992-07-14	1	8230
16178	1118	1125315	1980-06-06	1980-06-20	1	3823
21263	1447	1112807	1963-06-01	1963-06-15	1	-2392
4413	300	1738521	1973-04-18	1973-05-02	1	1217
18291	1258	1125315	2004-07-11	2004-07-18	1	12617
76393	5222	1112807	1928-02-06	1928-03-07	1	-15275
64414	4398	1713332	1980-08-04	1980-08-25	1	3889
62362	4256	1110410	1963-11-14	1963-11-14	1	-2240
64291	4390	1125315	1997-02-21	1997-02-28	1	9920
30113	2034	1112807	1940-12-14	1941-02-12	1	-10550
55509	3777	1125315	1992-04-21	1992-05-05	1	8160
463	32	1125315	1956-03-20	1956-04-10	1	-5014
47094	3195	1125315	1951-10-29	1951-11-12	1	-6625
12612	866	1713332	2000-03-16	2000-03-30	1	11046
68565	4677	1125315	1984-12-13	1984-12-27	1	5474
58653	3998	1309944	1982-08-26	1982-08-26	1	4620
69146	4719	1551099	1940-09-01	1940-09-01	1	-10714
54416	3701	1125315	1955-08-20	1955-09-03	1	-5234
69053	4712	1713332	2019-03-31	2019-04-21	1	18007
35837	2436	1112807	1922-07-27	1922-08-24	1	-17297
21110	1438	1759842	1958-04-21	1958-05-05	1	-4259
62927	4297	1125315	1986-04-19	1986-05-24	1	5987
31056	2098	1119510	1970-12-21	1970-12-28	1	361
58123	3966	1112807	1974-05-02	1974-05-16	1	1596
24883	1683	1549786	1990-06-22	1991-06-17	1	7837
14822	1024	1125315	1952-02-02	1952-03-03	1	-6513
6654	458	19127890	1989-07-25	1990-07-20	1	7505
66828	4562	1112807	1965-05-26	1965-06-09	1	-1667
8330	578	1521369	1989-04-15	1990-04-10	1	7404
65194	4454	1112807	1932-04-26	1932-06-25	1	-13704
23563	1598	1112807	1958-05-20	1958-06-03	1	-4230
60573	4131	1125315	1989-09-22	1989-09-29	1	7211
23438	1590	1112807	1965-12-02	1965-12-23	1	-1470
58176	3968	1112807	1936-10-29	1936-11-19	1	-12096
25297	1716	1112807	1971-08-31	1971-09-21	1	628
16886	1162	1125315	1922-12-31	1923-01-14	1	-17154
69764	4759	1125315	2005-01-07	2005-02-04	1	12818
16179	1118	1125315	1996-07-26	1996-08-16	1	9724
21264	1447	1125315	2017-07-22	2017-08-26	1	17404
4414	300	19127890	1991-02-23	1992-02-18	1	8083
18292	1258	1125315	2015-11-16	2015-11-23	1	16762
76394	5222	1125315	1928-10-28	1928-11-11	1	-15026
64415	4398	1729720	1964-01-25	1964-02-03	1	-2159
62363	4256	1125315	1985-11-21	1985-11-28	1	5810
64292	4390	1125315	2004-12-20	2004-12-27	1	12779
30114	2034	1115008	2016-11-04	2017-01-03	1	17169
55510	3777	1125315	2012-04-09	2012-04-23	1	15453
464	32	1125315	1959-04-25	1959-05-09	1	-3890
47095	3195	1125315	2006-10-21	2006-12-23	2	13486
12613	866	1728416	1962-10-23	1962-11-06	1	-2613
68566	4677	1713332	2008-08-11	2008-08-18	1	14109
58654	3998	1343916	1982-08-26	1982-08-26	1	4620
69462	4739	738818	1962-08-08	1962-08-15	1	-2696
54417	3701	1125315	1968-05-06	1968-05-20	1	-591
73899	5051	1119510	1992-05-18	1992-06-01	1	8187
35838	2436	1125315	1961-09-18	1961-10-02	1	-3013
21111	1438	1119510	1965-12-15	1965-12-29	1	-1464
62928	4297	1125315	2008-01-28	2008-02-04	1	13913
31057	2098	1125315	2005-07-18	2005-08-01	1	12996
58124	3966	1124300	2003-05-20	2003-05-20	1	12192
24884	1683	1549786	1996-05-21	1997-05-16	1	9997
14823	1024	1125315	1995-02-21	1995-03-07	1	9196
9222	640	1112807	1957-04-10	1957-07-09	1	-4559
66829	4562	1112807	1971-10-17	1971-11-07	1	675
8331	578	1729720	1979-05-31	1979-06-08	1	3445
65195	4454	1112807	1938-05-16	1938-06-06	1	-11532
23564	1598	1119510	1995-08-15	1995-08-22	1	9364
60574	4131	1515774	1991-06-03	1992-05-28	1	8183
23439	1590	1125315	1979-02-13	1979-02-27	1	3344
58177	3968	1115008	2018-05-25	2018-08-23	1	17766
25298	1716	1125315	1965-03-06	1965-03-13	1	-1755
16887	1162	1125315	1942-02-15	1942-02-22	1	-10175
69765	4759	1125315	2007-06-08	2007-06-15	1	13679
16180	1118	1149380	1976-08-18	1976-08-18	1	2421
21265	1447	1713332	2016-11-14	2016-11-28	1	17133
4415	300	1125315	1973-02-19	1973-03-05	1	1159
18293	1258	1177480	1986-05-23	1986-06-20	1	6014
76395	5222	1125315	1983-10-13	1983-10-27	1	5047
64416	4398	1729720	1965-01-31	1965-02-13	1	-1783
62364	4256	1728416	1957-08-29	1957-09-12	1	-4494
64293	4390	1521369	1977-01-12	1978-01-07	1	2928
30115	2034	1119510	2006-05-19	2006-05-26	1	13294
55511	3777	1177480	1990-04-25	1990-07-01	1	7486
465	32	1125315	1966-02-08	1966-02-22	1	-1409
47096	3195	1125315	2015-09-14	2015-09-14	1	16692
12614	866	738818	1972-10-31	1972-11-14	1	1048
68567	4677	1713332	2017-03-03	2017-03-17	1	17242
58655	3998	1713332	1999-12-19	2000-01-09	1	10965
69463	4739	1119510	1930-08-05	1930-08-12	1	-14387
54418	3701	1125315	1986-03-26	1986-04-02	1	5935
73900	5051	1125315	1980-05-12	1980-05-26	1	3798
35839	2436	1125315	1980-08-21	1980-09-04	1	3899
21112	1438	1125315	1992-05-18	1992-05-25	1	8180
62929	4297	1717327	1974-10-28	1974-11-11	1	1775
31058	2098	1521369	1979-06-15	1980-06-09	1	3812
58125	3966	19127890	1986-11-05	1989-10-20	3	7232
24885	1683	1738521	1973-09-09	1973-09-23	1	1361
14824	1024	1125315	2004-08-23	2004-09-27	2	12688
9223	640	1125315	1960-03-26	1960-04-02	1	-3561
66830	4562	1119510	1975-09-14	1975-09-21	1	2089
8332	578	1729720	1996-12-18	1996-12-28	1	9858
65196	4454	1112807	1955-12-16	1956-01-15	1	-5100
23565	1598	1119510	2011-06-19	2011-07-03	1	15158
60575	4131	1515774	1996-05-07	1997-05-02	1	9983
23440	1590	1125315	2003-05-20	2003-05-27	1	12199
58178	3968	1125315	1952-02-29	1952-03-14	1	-6502
25299	1716	1125315	1990-01-30	1990-02-06	1	7341
16888	1162	1759842	1943-04-06	1943-04-27	1	-9746
69766	4759	1713332	1980-05-29	1980-06-12	1	3815
16181	1118	1549786	1992-07-13	1993-07-08	1	8589
21266	1447	1759842	2016-11-14	2016-11-28	1	17133
4416	300	1125315	1973-04-18	1973-05-02	1	1217
18294	1258	1729720	1997-11-30	1997-12-10	1	10205
76396	5222	1125315	2009-10-15	2009-10-29	1	14546
64417	4398	738818	1993-04-15	1993-04-22	1	8512
62365	4256	1729720	1956-12-14	1956-12-26	1	-4754
64294	4390	1717327	1963-07-28	1963-08-11	1	-2335
30116	2034	1125315	1939-12-22	1939-12-29	1	-10961
55512	3777	1768849	1987-07-10	1987-07-24	1	6413
466	32	1125315	1991-03-22	1991-04-12	1	7771
47097	3195	1728416	1951-10-29	1951-11-12	1	-6625
12615	866	1112807	1962-10-23	1962-11-06	1	-2613
68568	4677	1759842	2008-08-11	2008-08-18	1	14109
58656	3998	1759842	1999-12-19	2000-01-09	1	10965
69464	4739	1174888	1993-06-26	1993-06-26	1	8577
54419	3701	1713332	2005-02-22	2005-03-08	1	12850
73901	5051	1125315	1983-08-25	1983-09-29	1	5019
35840	2436	1177480	1990-01-20	1990-03-21	1	7384
21113	1438	1713332	1958-04-21	1958-05-05	1	-4259
62930	4297	19003953	1991-02-19	1991-02-19	1	7719
31059	2098	738818	1970-12-21	1970-12-28	1	361
58126	3966	1503184	1986-11-05	1989-10-20	3	7232
24886	1683	19127890	1985-07-18	1986-07-13	1	6037
14825	1024	1322184	2016-05-29	2016-05-29	1	16950
9224	640	1125315	1962-09-11	1962-10-02	1	-2648
66831	4562	1125315	1985-04-30	1985-05-07	1	5605
8333	578	1738521	1968-11-21	1968-12-05	1	-392
65197	4454	1115008	1996-02-28	1996-03-29	1	9584
23566	1598	1125315	2011-06-19	2011-07-03	1	15158
60576	4131	1595799	1998-04-27	1999-04-22	1	10703
23441	1590	1125315	2014-08-23	2014-08-23	1	16305
58179	3968	1125315	1968-08-28	1968-09-04	1	-484
25300	1716	1129625	1948-11-09	1948-11-09	1	-7723
16889	1162	738818	1933-09-13	1933-09-20	1	-13252
69767	4759	1729720	1998-06-12	1998-06-23	1	10400
16182	1118	19127890	1991-07-19	1993-07-08	2	8589
21267	1447	19127890	1974-07-13	1976-07-02	2	2374
4417	300	1503184	1986-03-21	1989-03-05	3	7003
18295	1258	1738521	1968-11-02	1968-11-16	1	-411
76397	5222	1307863	2004-02-12	2004-02-12	1	12460
64418	4398	1118084	1998-07-27	1998-07-27	1	10434
62366	4256	1741122	1963-11-14	1963-11-14	1	-2240
64295	4390	1759842	1974-07-06	1974-07-20	1	1661
30117	2034	1125315	1958-02-13	1958-02-27	1	-4326
58284	3976	1112807	1966-12-28	1967-01-11	1	-1086
467	32	1125315	2002-07-21	2002-07-28	1	11896
47098	3195	1729720	1962-03-30	1962-04-10	1	-2823
12616	866	1124300	1998-01-17	1998-01-17	1	10243
68569	4677	738818	1967-12-23	1967-12-30	1	-733
59695	4072	1118084	2011-11-17	2011-11-17	1	15295
69465	4739	1539403	1992-01-04	1992-01-04	1	8038
54420	3701	1125315	1995-10-30	1995-11-06	1	9440
73902	5051	1177480	1987-12-02	1987-12-23	1	6565
35841	2436	1759842	1966-01-03	1966-01-17	1	-1445
22205	1512	1125315	1979-11-04	1979-11-18	1	3608
62931	4297	19127890	1989-12-18	1990-12-13	1	7651
31060	2098	1125315	1970-12-21	1970-12-28	1	361
58127	3966	1521369	1991-10-10	1992-10-04	1	8312
24887	1683	19127890	1996-05-21	1997-05-16	1	9997
14826	1024	1332418	2016-05-29	2016-05-29	1	16950
9225	640	1125315	1980-05-15	1980-05-29	1	3801
66832	4562	738818	1975-09-14	1975-09-21	1	2089
8334	578	1125315	1969-02-21	1969-02-28	1	-307
65198	4454	1125315	1934-02-20	1934-03-06	1	-13085
23567	1598	738818	1995-08-15	1995-08-22	1	9364
60577	4131	19127890	1999-04-22	2000-04-16	1	11063
23442	1590	1119510	1985-05-24	1985-06-07	1	5636
58180	3968	914335	1928-02-03	1928-02-03	1	-15308
25301	1716	1728416	1951-10-31	1951-11-14	1	-6623
16890	1162	1125315	1921-08-24	1921-09-07	1	-17648
69768	4759	1759842	2009-03-25	2009-04-01	1	14335
16183	1118	19127890	1995-06-28	1996-06-22	1	9669
21268	1447	1112807	1990-09-21	1990-10-12	1	7589
4418	300	1521369	1991-02-23	1992-02-18	1	8083
18296	1258	1112807	1982-03-24	1982-04-23	1	4495
76398	5222	1713332	1959-12-05	1959-12-26	1	-3659
64419	4398	1125315	1996-09-05	1996-09-19	1	9758
62367	4256	19016749	1963-11-14	1963-11-14	1	-2240
64897	4432	1125315	1978-09-03	1978-09-17	1	3181
30118	2034	1125315	2006-05-19	2006-05-26	1	13294
58285	3976	1118084	2007-09-24	2007-09-24	1	13780
468	32	1125315	2003-07-09	2003-07-23	1	12256
47099	3195	1112807	1962-04-13	1962-05-13	1	-2790
12617	866	1125315	1970-11-10	1970-12-01	1	334
68570	4677	1115008	2017-03-03	2017-03-17	1	17242
59696	4072	1119510	1995-10-18	1995-11-01	1	9435
69466	4739	1551099	1915-03-31	1915-03-31	1	-20000
54421	3701	1177480	1996-07-23	1996-08-27	1	9735
73903	5051	1118084	2013-12-30	2013-12-30	1	16069
35842	2436	1759842	1984-03-21	1984-03-28	1	5200
22206	1512	1515774	1991-05-24	1992-05-18	1	8173
62932	4297	19127890	1992-12-02	1993-11-27	1	8731
31061	2098	1177480	2007-04-23	2007-05-14	1	13647
58128	3966	19127890	1981-12-01	1982-11-26	1	4712
24888	1683	738818	1998-12-28	1999-01-04	1	10595
14827	1024	1361711	2016-05-29	2016-05-29	1	16950
9226	640	1125315	1992-04-24	1992-05-01	1	8156
66833	4562	738818	1982-08-26	1982-09-09	1	4634
8335	578	1177480	1979-10-25	1979-11-15	1	3605
65199	4454	1125315	1998-02-17	1998-04-18	1	10334
23568	1598	1118084	2003-09-26	2003-09-26	1	12321
64111	4380	1124300	2001-09-28	2001-09-28	1	11593
23443	1590	1124300	1999-02-07	1999-02-07	1	10629
58181	3968	1118084	1950-07-18	1950-07-18	1	-7107
25302	1716	1759842	1959-06-22	1959-06-29	1	-3839
16891	1162	1112807	1952-10-08	1952-11-07	1	-6264
69769	4759	723013	2012-09-04	2013-08-13	1	15930
16184	1118	920293	2003-12-29	2004-01-12	2	12429
21269	1447	1118084	1996-01-09	1996-01-09	1	9504
4419	300	1125315	2005-06-16	2005-06-30	1	12964
18297	1258	1125315	1970-05-28	1970-06-11	1	161
76945	5258	738818	1984-09-22	1984-10-06	1	5392
64420	4398	1125315	1998-04-28	1998-05-26	1	10372
62368	4256	782043	1963-11-14	1963-11-14	1	-2240
64898	4432	1713332	1959-11-21	1959-11-28	1	-3687
30119	2034	1713332	1955-04-27	1955-05-11	1	-5349
58286	3976	1125315	1996-03-13	1996-03-27	1	9582
469	32	701322	2007-07-26	2007-07-26	1	13720
47100	3195	1713332	2015-12-10	2015-12-31	1	16800
12618	866	1125315	1972-10-31	1972-11-14	1	1048
68571	4677	1119510	1981-03-02	1981-03-16	1	4092
59697	4072	1125315	1980-06-19	1980-07-03	1	3836
69467	4739	1729720	1948-02-18	1948-02-28	1	-7978
54422	3701	1713332	1979-07-09	1979-07-30	1	3497
73904	5051	1125315	1996-12-05	1997-01-02	1	9863
35843	2436	975125	1930-03-21	1930-03-21	1	-14531
22207	1512	1521369	1998-04-17	1998-12-09	1	10569
62933	4297	708298	1991-02-19	1991-02-19	1	7719
31062	2098	19127890	1979-06-15	1980-06-09	1	3812
58129	3966	19127890	1983-11-21	1984-11-15	1	5432
24889	1683	1118084	2014-01-22	2014-01-22	1	16092
14828	1024	1713332	2014-05-15	2014-05-29	1	16219
9227	640	1713332	1960-05-02	1960-05-23	1	-3510
66834	4562	975125	1966-09-12	1966-10-03	1	-1186
8336	578	1503184	1987-04-26	1988-04-20	1	6684
65200	4454	1125315	2018-02-23	2018-05-24	1	17675
23569	1598	1125315	1995-08-15	1995-08-22	1	9364
64112	4380	1125315	1983-07-27	1983-08-10	1	4969
23444	1590	1125315	1965-01-06	1965-02-05	1	-1791
58182	3968	1125315	1977-07-01	1977-07-29	2	2766
25303	1716	1112807	1951-10-31	1951-11-14	1	-6623
16892	1162	1124300	1963-07-08	1963-07-08	1	-2369
69770	4759	723013	2017-09-12	2018-05-01	1	17652
16185	1118	1192710	1978-09-01	1978-09-01	1	3165
21270	1447	1177480	2019-05-18	2019-06-01	1	18048
4420	300	1521369	1986-03-21	1989-03-05	3	7003
18298	1258	1125315	1994-06-06	1994-06-20	1	8936
76946	5258	1125315	1984-09-22	1984-10-06	1	5392
64421	4398	1759842	1980-08-04	1980-08-25	1	3889
62369	4256	967823	1963-11-14	1963-11-15	1	-2239
64899	4432	1119510	1966-01-11	1966-01-25	1	-1437
30888	2088	738818	1983-06-11	1983-06-25	1	4923
58287	3976	1125315	2018-04-15	2018-04-22	1	17643
470	32	757627	2006-08-30	2006-08-30	1	13390
47470	3223	738818	1923-07-14	1923-07-28	1	-16959
12619	866	1729720	1966-08-18	1966-08-27	1	-1223
68572	4677	1125315	1967-12-23	1967-12-30	1	-733
59698	4072	738818	2010-10-28	2010-11-11	1	14924
69468	4739	1759842	1944-02-27	1944-03-05	1	-9433
54423	3701	1759842	1979-07-09	1979-07-30	1	3497
73905	5051	1125315	1998-07-08	1998-07-22	1	10429
35844	2436	1102527	1963-02-11	1963-02-11	1	-2516
22208	1512	1118084	2016-10-19	2016-10-19	1	17093
62934	4297	738818	1977-12-13	1977-12-27	1	2917
31063	2098	1717327	1962-11-01	1962-11-15	1	-2604
58130	3966	1125315	1977-06-29	1977-07-13	1	2750
24890	1683	1119510	1998-12-28	1999-01-04	1	10595
14829	1024	1729720	1999-01-30	1999-02-11	1	10633
9228	640	1125315	1974-01-11	1974-01-18	1	1478
66835	4562	975125	1971-11-04	1971-11-18	1	686
8337	578	1521369	1981-05-27	1982-05-22	1	4524
65201	4454	1326303	2006-10-07	2006-10-07	1	13428
23570	1598	1125315	1997-05-28	1997-06-04	1	10016
64113	4380	1125315	2014-04-19	2014-05-10	1	16200
23598	1600	920293	1984-12-20	1984-12-27	1	5474
58183	3968	1125315	2003-06-13	2003-09-11	1	12306
25304	1716	1119510	1982-07-02	1982-07-16	1	4579
16893	1162	1125315	1933-09-13	1933-09-20	1	-13252
69771	4759	1112807	1989-06-16	1989-09-14	1	7196
16186	1118	1503184	1991-07-19	1992-07-13	1	8229
21271	1447	1503184	1974-07-13	1976-07-02	2	2374
4421	300	1729720	1982-08-31	1982-09-09	1	4634
18299	1258	1521369	1983-02-27	1984-02-22	1	5165
76947	5258	1125315	1997-11-02	1997-11-16	1	10181
64422	4398	1112807	1962-03-03	1962-04-07	1	-2826
62370	4256	1125315	1954-10-25	1954-11-08	1	-5533
64900	4432	1125315	1959-05-16	1959-06-13	1	-3855
30889	2088	1112807	1910-02-14	1910-02-28	1	-21857
58288	3976	1177480	1977-05-25	1977-06-08	1	2715
471	32	1112807	1947-08-07	1947-08-21	1	-8169
47471	3223	1125315	1923-07-14	1923-07-28	1	-16959
12620	866	1729720	2015-12-16	2015-12-27	1	16796
68573	4677	1125315	1977-04-14	1977-05-19	1	2695
59699	4072	1112807	1977-10-21	1977-12-20	1	2910
69469	4739	1112807	1911-09-02	1911-09-16	1	-21292
56104	3823	1112807	1959-05-20	1959-06-19	1	-3849
73906	5051	1150770	1978-10-04	1978-10-04	1	3198
35845	2436	1112807	1915-12-26	1916-01-30	1	-19695
22209	1512	1177480	1977-03-12	1977-03-26	1	2641
62935	4297	1125315	1976-11-03	1976-11-17	1	2512
31064	2098	1759842	2007-08-28	2008-07-22	1	14082
58131	3966	1125315	2005-10-18	2005-10-25	1	13081
24891	1683	1177480	2006-11-18	2006-12-02	1	13484
14830	1024	1759842	2014-05-15	2014-05-29	1	16219
9229	640	1759842	1960-05-02	1960-05-23	1	-3510
66836	4562	1118084	1999-10-06	1999-10-06	1	10870
8338	578	1521369	1984-05-11	1985-05-06	1	5604
65202	4454	1361711	2004-05-15	2004-05-15	1	12553
23571	1598	1125315	2002-08-21	2002-09-04	1	11934
64114	4380	1713332	1986-12-29	1987-01-19	1	6227
23599	1600	933724	1984-12-20	1984-12-27	1	5474
58184	3968	1307863	2006-03-31	2006-03-31	1	13238
25305	1716	1125315	1993-06-18	1993-09-16	1	8659
16894	1162	1125315	1994-07-27	1994-08-10	1	8987
69772	4759	1119510	2000-08-10	2000-08-24	1	11193
16187	1118	1549786	1995-06-28	1996-06-22	1	9669
22631	1537	1112807	1960-08-12	1960-08-26	1	-3415
7646	528	738818	1971-08-25	1971-09-08	1	615
18300	1258	1112807	1968-11-02	1968-11-16	1	-411
76948	5258	1503184	1974-07-16	1975-07-11	1	2017
64423	4398	1125315	1963-05-10	1963-05-24	1	-2414
62371	4256	1125315	1958-03-09	1958-03-16	1	-4309
64901	4432	1177480	1995-08-03	1995-08-31	1	9373
30890	2088	1112807	1911-09-07	1911-12-06	1	-21211
58289	3976	738818	1985-10-29	1985-11-05	1	5787
472	32	1112807	1955-04-27	1955-05-25	1	-5335
47472	3223	1713332	1978-09-28	1978-10-12	1	3206
14703	1016	1125315	2009-06-15	2009-06-22	1	14417
68574	4677	1713332	2000-06-29	2000-07-27	1	11165
59700	4072	1115008	2010-01-18	2010-02-01	1	14641
69470	4739	1112807	1913-09-07	1913-09-21	1	-20556
56105	3823	1115008	2014-10-19	2014-11-23	1	16397
73907	5051	1713332	1979-04-23	1979-05-07	1	3413
35846	2436	1112807	1957-07-21	1957-08-11	1	-4526
22210	1512	1521369	1992-05-18	1993-05-13	1	8533
62936	4297	1125315	1977-12-13	1977-12-27	1	2917
31267	2116	701322	2019-01-15	2019-01-15	1	17911
58132	3966	1503184	1981-12-01	1982-11-26	1	4712
24892	1683	1503184	1985-07-18	1986-07-13	1	6037
19844	1353	1112807	1960-06-01	1960-06-15	1	-3487
9230	640	1115008	2002-10-02	2002-10-23	1	11983
66837	4562	1125315	1975-09-14	1975-09-21	1	2089
8339	578	1551099	1967-12-27	1967-12-27	1	-736
65203	4454	1713332	1922-01-24	1922-02-14	1	-17488
23572	1598	1177480	1989-03-22	1989-04-05	1	7034
64115	4380	1112807	1970-05-19	1970-07-18	1	198
23600	1600	1177480	2013-09-01	2013-10-31	1	16009
58185	3968	1343916	1928-02-03	1928-02-03	1	-15308
25306	1716	1713332	1959-06-22	1959-06-29	1	-3839
16895	1162	1125315	2002-07-15	2002-07-29	1	11897
69773	4759	1125315	1979-02-06	1979-02-13	1	3330
16188	1118	1549786	1997-06-17	1998-06-12	1	10389
22632	1537	1112807	1969-07-19	1969-08-16	1	-138
7647	528	1125315	1971-08-25	1971-09-08	1	615
18301	1258	1118084	2003-11-14	2003-11-14	1	12370
76949	5258	1717327	1962-11-23	1962-12-07	1	-2582
64424	4398	1125315	1970-08-23	1970-11-21	1	324
62372	4256	1125315	1961-04-21	1961-06-20	1	-3117
64902	4432	1728416	1959-05-16	1959-06-13	1	-3855
30891	2088	1125315	1909-09-18	1909-10-02	1	-22006
58290	3976	738818	1996-03-13	1996-03-27	1	9582
473	32	1118084	1987-04-04	1987-04-04	1	6302
47473	3223	1112807	1938-04-25	1938-05-23	1	-11546
14704	1016	1503184	1983-05-31	1984-05-25	1	5258
68575	4677	1102527	2000-06-29	2000-06-29	1	11137
59701	4072	1119510	2010-10-28	2010-11-11	1	14924
69471	4739	1125315	1919-09-15	1919-09-29	1	-18357
56106	3823	1125315	1997-07-09	1997-07-23	1	10065
73908	5051	1713332	1997-08-06	1997-08-20	1	10093
35847	2436	1119510	2014-12-08	2014-12-22	1	16426
22211	1512	1713332	2005-09-13	2005-10-04	1	13060
62937	4297	1125315	1991-02-20	1991-02-20	1	7720
31268	2116	715997	2019-01-15	2019-01-15	1	17911
58133	3966	1503184	1983-11-21	1984-11-15	1	5432
24893	1683	1515774	1996-05-21	1997-05-16	1	9997
19845	1353	1125315	1986-05-05	1986-05-26	1	5989
9231	640	1115008	2011-06-08	2011-06-29	1	15154
66838	4562	1125315	1978-04-09	1978-04-16	1	3027
8340	578	1713332	2010-11-06	2010-11-20	1	14933
65204	4454	1713332	1991-01-14	1991-02-04	1	7704
23573	1598	1503184	1979-12-06	1980-11-30	1	3986
64116	4380	1125315	1977-04-23	1977-04-30	1	2676
23601	1600	1713332	1965-05-13	1965-05-20	1	-1687
58186	3968	1713332	1921-07-03	1921-07-10	1	-17707
25307	1716	1112807	1966-01-26	1966-03-02	1	-1401
16896	1162	1729720	1987-12-01	1987-12-13	1	6555
69774	4759	1125315	1980-05-29	1980-06-12	1	3815
16189	1118	1713332	1990-06-03	1990-06-17	1	7472
22633	1537	1118084	1992-01-21	1992-01-21	1	8055
7648	528	1713332	1969-04-18	1969-05-02	1	-244
18302	1258	1125315	1983-05-18	1983-06-08	1	4906
76950	5258	1728416	1958-11-27	1958-12-11	1	-4039
66369	4532	1112807	1911-03-08	1911-03-22	1	-21470
62373	4256	1125315	1991-06-01	1991-06-15	1	7835
64903	4432	1759842	1959-11-21	1959-11-28	1	-3687
30892	2088	1125315	1930-05-09	1930-05-16	1	-14475
58291	3976	738818	2018-04-15	2018-04-22	1	17643
474	32	1125315	1944-06-24	1944-07-01	1	-9315
47474	3223	1118084	1959-12-21	1959-12-21	1	-3664
14705	1016	1521369	1983-05-31	1984-05-25	1	5258
68576	4677	1112807	1973-07-20	1973-08-03	1	1310
59702	4072	1125315	2010-10-28	2010-11-11	1	14924
69472	4739	1125315	1930-10-13	1930-10-27	1	-14311
56107	3823	1125315	2013-08-07	2013-08-21	1	15938
73909	5051	1759842	1979-04-23	1979-05-07	1	3413
35848	2436	1125315	1963-02-11	1963-04-12	1	-2456
22212	1512	1713332	2014-02-16	2014-04-27	1	16187
62938	4297	1367571	1991-02-19	1991-02-19	1	7719
31269	2116	1119510	2005-12-02	2005-12-16	1	13133
58134	3966	1503184	1991-10-10	1992-10-04	1	8312
27317	1846	738818	2002-11-30	2002-12-14	1	12035
19846	1353	1112807	1964-09-08	1964-09-29	1	-1920
9232	640	1124300	1992-11-07	1992-11-07	1	8346
66839	4562	1125315	1982-08-26	1982-09-09	1	4634
8341	578	1738521	1970-05-22	1970-06-05	1	155
65205	4454	738818	1932-10-04	1932-10-18	1	-13589
23574	1598	1557272	2018-08-06	2018-08-06	1	17749
64117	4380	1729720	1994-06-08	1994-06-20	1	8936
23602	1600	1728416	1945-12-26	1946-01-09	1	-8758
58187	3968	1713332	1948-05-02	1948-05-16	1	-7900
25308	1716	1115008	2009-06-24	2009-07-31	1	14456
18540	1276	723013	1968-03-05	1968-08-27	1	-492
69775	4759	1125315	2000-08-10	2000-08-24	1	11193
16190	1118	933724	2000-09-06	2000-09-13	1	11213
22634	1537	1125315	1961-05-26	1961-06-09	1	-3128
7649	528	19127890	1978-04-29	1980-04-18	2	3760
18303	1258	1177480	2006-02-05	2006-02-26	1	13205
76951	5258	1112807	1958-11-27	1958-12-11	1	-4039
66370	4532	1112807	1974-06-10	1974-06-24	1	1635
62374	4256	1367571	1963-11-14	1963-11-14	1	-2240
64904	4432	1125315	1994-08-09	1994-08-16	1	8993
30893	2088	1125315	1983-06-11	1983-06-25	1	4923
58292	3976	1115008	2003-03-24	2003-04-28	1	12170
475	32	1713332	1991-06-01	1991-06-15	1	7835
47475	3223	1119510	1923-07-14	1923-07-28	1	-16959
14706	1016	1521369	1986-05-15	1987-05-10	1	6338
68577	4677	1115008	2000-06-29	2000-07-27	1	11165
59703	4072	1125315	2013-12-09	2013-12-23	1	16062
69473	4739	1125315	1943-12-27	1944-01-10	1	-9488
56108	3823	1125315	2014-05-20	2014-06-03	1	16224
73910	5051	1759842	1997-08-06	1997-08-20	1	10093
35849	2436	1125315	1992-03-10	1992-03-31	1	8125
22213	1512	1717327	1977-03-12	1977-03-26	1	2641
62939	4297	1521369	1989-12-18	1990-12-13	1	7651
31270	2116	1713332	2012-10-07	2012-11-11	1	15655
58135	3966	1521369	1986-11-05	1989-10-20	3	7232
27318	1846	1115008	2018-01-26	2018-02-25	1	17587
19847	1353	1119510	1985-06-12	1985-06-19	1	5648
9233	640	1125315	1967-07-04	1967-07-18	1	-898
66840	4562	1125315	1984-12-28	1985-01-27	1	5505
9969	686	1125315	1963-07-11	1963-08-15	1	-2331
65206	4454	1112807	1927-01-23	1927-04-23	1	-15594
23575	1598	1713332	1964-01-22	1964-02-12	1	-2150
64118	4380	1112807	1980-04-26	1980-05-17	1	3789
23603	1600	1759842	1958-11-06	1958-11-13	1	-4067
58188	3968	1713332	1966-12-06	1966-12-27	1	-1101
25309	1716	1125315	1970-09-07	1970-10-05	1	277
18541	1276	738818	2017-04-13	2017-04-27	1	17283
69776	4759	1713332	2009-03-25	2009-04-01	1	14335
16191	1118	1115008	2001-02-21	2001-03-21	1	11402
22635	1537	1125315	1977-11-04	1977-11-11	1	2871
7650	528	1125315	2002-04-13	2002-07-12	1	11880
18304	1258	1503184	1983-02-27	1984-02-22	1	5165
76952	5258	1118084	1999-07-10	1999-07-10	1	10782
66371	4532	1124300	1945-08-26	1945-08-26	1	-8894
62375	4256	1728416	1954-10-25	1954-11-08	1	-5533
64905	4432	1125315	2004-08-13	2004-09-17	1	12678
30894	2088	1149380	1968-11-19	1968-11-19	1	-408
58293	3976	1115008	2017-11-10	2018-01-09	1	17540
476	32	1759842	1991-06-01	1991-06-15	1	7835
47476	3223	1125315	1929-02-11	1929-02-11	1	-14934
14707	1016	920293	2007-07-08	2007-07-15	1	13709
68578	4677	1177480	1993-10-13	1993-11-03	1	8707
59704	4072	1738521	1975-02-04	1975-02-18	1	1874
69474	4739	1125315	1962-08-08	1962-08-15	1	-2696
56109	3823	1310149	2008-11-05	2008-11-05	1	14188
73911	5051	1768849	1980-05-12	1980-05-26	1	3798
35850	2436	1125315	2009-04-13	2009-04-27	1	14361
22214	1512	1729720	1987-10-03	1987-10-16	1	6497
62940	4297	1713332	1984-03-04	1984-03-18	1	5190
31271	2116	1713332	2019-06-11	2019-06-18	1	18065
58136	3966	933724	2017-01-08	2017-01-15	1	17181
27319	1846	1125315	1963-05-25	1963-06-01	1	-2406
19848	1353	1125315	1968-08-09	1968-11-07	1	-420
9234	640	1125315	1973-05-07	1973-05-14	1	1229
66841	4562	1129625	1966-02-17	1966-02-17	1	-1414
9970	686	1713332	1959-03-08	1959-03-15	1	-3945
65207	4454	1112807	1945-04-30	1945-05-14	1	-8998
23576	1598	1521369	1979-12-06	1980-11-30	1	3986
64119	4380	1125315	1971-09-13	1971-09-20	1	627
23604	1600	1759842	1972-02-18	1972-02-25	1	785
58189	3968	1729720	1985-05-02	1985-05-15	1	5613
25310	1716	1125315	2010-08-25	2010-10-24	1	14906
18542	1276	1119510	1967-03-18	1967-03-25	1	-1013
69777	4759	1729720	1992-05-21	1992-05-29	1	8184
16192	1118	1125315	1975-11-30	1975-12-14	1	2173
22636	1537	1521369	1982-04-10	1983-04-05	1	4842
7651	528	1759842	1969-04-18	1969-05-02	1	-244
19953	1359	738818	1976-08-21	1976-08-28	1	2431
76953	5258	1521369	1974-07-16	1975-07-11	1	2017
66372	4532	1713332	1926-05-14	1926-05-21	1	-15931
62376	4256	1759842	2011-12-26	2012-01-02	1	15341
64906	4432	738818	1966-01-11	1966-01-25	1	-1437
30895	2088	1174888	1969-03-02	1969-03-02	1	-305
58294	3976	1125315	1985-10-29	1985-11-05	1	5787
477	32	1115008	2000-10-12	2004-09-21	1	12682
47477	3223	1125315	1981-06-06	1981-06-20	1	4188
14708	1016	920293	2010-08-18	2010-09-01	2	14853
68579	4677	1119510	1967-12-23	1967-12-30	1	-733
59705	4072	1115008	2004-04-16	2004-04-30	1	12538
69475	4739	1361711	1982-11-13	1993-06-26	1	8577
56110	3823	1322184	2016-11-16	2016-11-16	1	17121
73912	5051	1125315	2016-02-22	2016-03-28	1	16888
35851	2436	1177480	2000-05-18	2000-06-08	1	11116
22215	1512	1112807	1976-05-02	1976-05-16	1	2327
62941	4297	1728416	1976-11-03	1976-11-17	1	2512
31272	2116	1759842	2019-06-11	2019-06-18	1	18065
58137	3966	1521369	1981-12-01	1982-11-26	1	4712
27320	1846	1125315	1963-12-20	1963-12-20	1	-2204
19849	1353	1118084	1992-11-05	1992-11-05	1	8344
9235	640	1728416	1951-06-11	1951-06-25	1	-6765
66842	4562	1154343	1964-02-04	1964-02-04	1	-2158
9971	686	1713332	1968-01-19	1968-01-26	1	-706
65208	4454	1118084	1963-06-08	1963-06-08	1	-2399
23577	1598	1713332	2008-09-21	2008-10-05	1	14157
64120	4380	1125315	1999-01-29	1999-02-05	1	10627
23605	1600	1112807	1945-12-26	1946-01-09	1	-8758
58190	3968	738818	1913-10-01	1913-10-15	1	-20532
25311	1716	738818	1982-07-02	1982-07-16	1	4579
18543	1276	1124300	1995-08-21	1995-08-21	1	9363
69778	4759	1125315	1980-12-25	1981-01-29	1	4046
16193	1118	1154343	1976-08-18	1976-08-18	1	2421
22637	1537	1728416	1958-05-04	1958-05-18	1	-4246
7652	528	19127890	1975-05-15	1977-05-04	2	2680
19954	1359	1118084	1971-05-14	1971-05-14	1	498
76954	5258	1112807	1962-11-23	1962-12-07	1	-2582
66373	4532	1729720	1912-02-07	1912-02-14	1	-21141
62377	4256	753626	1963-11-14	1963-11-14	1	-2240
64907	4432	1118084	1997-02-05	1997-02-05	1	9897
30896	2088	1759842	1914-01-20	1914-01-27	1	-20428
58295	3976	1713332	1998-10-24	1998-11-07	1	10537
478	32	1125315	1986-07-05	1986-07-19	1	6043
47478	3223	1759842	1953-08-30	1953-09-20	1	-5947
14709	1016	1503184	1986-05-15	1987-05-10	1	6338
68580	4677	1729720	1965-10-18	1965-10-26	1	-1528
59706	4072	1125315	1995-10-18	1995-11-01	1	9435
69476	4739	1729720	1916-10-22	1916-11-01	1	-19419
56111	3823	1347450	2016-11-16	2016-11-16	1	17121
73913	5051	1713332	1983-04-10	1983-04-17	1	4854
35852	2436	1713332	1966-01-03	1966-01-17	1	-1445
22216	1512	1119510	1983-04-05	1983-04-12	1	4849
62942	4297	1729720	1975-04-08	1975-04-16	1	1931
31273	2116	757627	2018-02-19	2018-02-19	1	17581
58138	3966	1521369	1983-11-21	1984-11-15	1	5432
27321	1846	1713332	1971-10-10	1971-10-31	1	668
19850	1353	1125315	2017-04-18	2017-04-25	1	17281
9236	640	1112807	1951-06-11	1951-06-25	1	-6765
66843	4562	1759842	1979-03-21	1979-04-11	1	3387
9972	686	1713332	1969-10-26	1969-11-02	1	-60
65209	4454	1119510	1985-12-08	1985-12-15	1	5827
23578	1598	1729720	1965-08-13	1965-08-25	1	-1590
64121	4380	1125315	2006-06-26	2006-07-10	1	13339
23606	1600	1115008	2002-07-21	2002-08-04	1	11903
58191	3968	1125315	2007-05-21	2007-05-28	1	13661
25312	1716	1112807	1950-06-21	1950-07-05	1	-7120
18544	1276	1125315	2017-04-13	2017-04-27	1	17283
69779	4759	1125315	1987-03-05	1987-03-12	1	6279
16194	1118	1515774	1997-06-17	1998-06-12	1	10389
22638	1537	1759842	1970-07-05	1970-07-19	1	199
7653	528	920293	1981-06-18	1981-06-25	1	4193
19955	1359	1125315	1976-08-21	1976-08-28	1	2431
76955	5258	1112807	1965-03-25	1965-04-29	1	-1708
66374	4532	1759842	1926-05-14	1926-05-21	1	-15931
62378	4256	1118084	1992-06-12	1992-06-12	1	8198
64908	4432	1125315	1966-01-11	1966-01-25	1	-1437
30897	2088	1759842	1981-05-14	1981-05-28	1	4165
58296	3976	1728416	1966-12-28	1967-01-11	1	-1086
479	32	1125315	1998-10-02	1998-10-09	1	10508
47479	3223	1112807	1929-02-11	1929-03-13	1	-14904
14710	1016	933724	2007-07-08	2007-07-15	1	13709
68581	4677	1729720	2016-04-22	2016-05-03	1	16924
59707	4072	1125315	2002-11-10	2002-11-17	1	12008
69477	4739	738818	1930-08-05	1930-08-12	1	-14387
56112	3823	1503184	1976-08-28	1977-08-23	1	2791
73914	5051	1759842	1983-04-10	1983-04-17	1	4854
35853	2436	738818	2014-12-08	2014-12-22	1	16426
22217	1512	1125315	1979-07-17	1979-07-24	1	3491
62943	4297	1741122	1991-02-19	1991-02-19	1	7719
31274	2116	1118084	1990-10-04	1990-10-04	1	7581
58139	3966	1713332	2001-06-02	2001-06-09	1	11482
27322	1846	1759842	1984-03-01	1984-03-08	1	5180
19851	1353	1713332	1985-10-21	1985-11-11	1	5793
9237	640	1738521	1980-05-15	1980-05-29	1	3801
66844	4562	975125	1967-11-30	1967-12-21	1	-742
9973	686	1713332	1989-01-29	1989-02-12	1	6982
65210	4454	1125315	1931-12-30	1932-01-06	1	-13875
23579	1598	1759842	1964-01-22	1964-02-12	1	-2150
64122	4380	1759842	1986-12-29	1987-01-19	1	6227
23607	1600	1115008	2008-03-10	2008-03-31	1	13969
58192	3968	1326303	2006-03-31	2006-03-31	1	13238
25313	1716	1112807	1978-11-13	1978-12-04	1	3259
18545	1276	738818	1967-03-18	1967-03-25	1	-1013
69780	4759	1177480	1979-12-01	1980-02-29	1	3711
16195	1118	1521369	1991-07-19	1992-07-13	1	8229
22639	1537	1759842	1978-01-15	1978-01-22	1	2943
7654	528	933724	1981-06-18	1981-06-25	1	4193
19956	1359	1125315	1994-05-06	1994-05-20	1	8905
76956	5258	1125315	1968-01-14	1968-02-13	1	-688
66375	4532	1102527	1984-03-03	1984-03-03	1	5175
62379	4256	1713332	2011-12-26	2012-01-02	1	15341
64909	4432	1125315	1970-03-11	1970-03-18	1	76
30898	2088	1759842	1990-01-22	1990-02-12	1	7347
58297	3976	1729720	1989-09-03	1989-09-13	1	7195
480	32	1305058	2000-10-12	2004-09-21	1	12682
47480	3223	1115008	1997-11-23	1997-12-14	1	10209
14711	1016	933724	2010-08-18	2010-09-01	1	14853
69979	4777	1174888	1974-11-29	1974-11-29	1	1793
59708	4072	1713332	1977-06-02	1977-06-23	1	2730
69478	4739	1112807	1910-11-22	1910-12-06	1	-21576
56113	3823	1713332	2014-06-10	2014-07-01	1	16252
73915	5051	738818	1992-05-18	1992-06-01	1	8187
35854	2436	1124300	1948-06-25	1948-06-25	1	-7860
22218	1512	1500211	1995-05-03	1996-04-27	1	9613
62944	4297	1000560	1991-02-19	1991-02-19	2	7719
31275	2116	1119510	1972-07-04	1972-07-18	1	929
58140	3966	1759842	2001-06-02	2001-06-09	1	11482
27323	1846	1112807	1963-12-20	1964-03-19	1	-2114
19852	1353	1729720	1980-12-26	1981-01-08	1	4025
11070	758	738818	2000-05-04	2000-05-11	1	11088
66845	4562	1125315	2011-10-06	2011-10-27	1	15274
9974	686	1118084	1980-12-22	1980-12-22	1	4008
65211	4454	1125315	1932-10-04	1932-10-18	1	-13589
23752	1608	1112807	1951-11-03	1951-11-24	1	-6613
68803	4694	1124300	2018-01-17	2018-01-17	1	17548
23608	1600	1125315	2008-08-06	2008-08-13	1	14104
58193	3968	1713332	1931-09-23	1931-10-14	1	-13959
25314	1716	1118084	1977-11-01	1977-11-01	1	2861
18546	1276	1112807	1961-10-13	1961-10-27	1	-2988
69781	4759	1177480	1985-05-08	1985-06-07	1	5636
16196	1118	1728416	1975-11-30	1975-12-14	1	2173
22640	1537	1115008	1994-02-13	1994-02-27	1	8823
7655	528	1112807	1960-07-22	1960-08-05	1	-3436
19957	1359	1310149	1987-04-14	1987-04-14	1	6312
76957	5258	1125315	1982-11-23	1982-11-30	1	4716
66376	4532	1112807	1912-10-17	1912-10-31	1	-20881
62380	4256	19003953	1963-11-14	1963-11-14	1	-2240
64910	4432	1125315	2014-06-27	2014-07-25	1	16276
30899	2088	1112807	1955-09-21	1955-10-12	1	-5195
58298	3976	1759842	1998-10-24	1998-11-07	1	10537
481	32	1728416	1947-08-07	1947-08-21	1	-8169
47481	3223	1125315	1945-02-12	1945-02-19	1	-9082
14712	1016	1118084	2010-01-24	2010-01-24	1	14633
69980	4777	738818	1978-05-29	1978-06-12	1	3084
59709	4072	1768849	1980-06-19	1980-07-03	1	3836
69479	4739	1112807	1927-09-11	1927-09-25	1	-15439
56114	3823	1728416	1956-06-04	1956-06-18	1	-4945
73916	5051	1125315	1986-10-09	1986-10-16	1	6132
35855	2436	1125315	1919-07-09	1919-07-23	1	-18425
22219	1512	1503184	1992-05-18	1993-05-13	1	8533
62945	4297	1112807	1984-03-04	1984-03-18	1	5190
31276	2116	1125315	1965-02-04	1965-02-11	1	-1785
58141	3966	19127890	1991-10-10	1992-10-04	1	8312
27324	1846	1759842	1971-10-10	1971-10-31	1	668
19853	1353	1759842	1985-10-21	1985-11-11	1	5793
11071	758	1125315	1977-02-02	1977-02-16	1	2603
66846	4562	1551099	1970-11-08	1970-11-08	1	311
9975	686	1125315	1958-11-04	1958-11-18	1	-4062
65212	4454	1125315	1955-11-08	1955-11-22	1	-5154
23753	1608	1125315	1945-01-26	1945-02-02	1	-9099
68804	4694	1125315	2001-02-25	2001-03-27	1	11408
23609	1600	1177480	2005-04-20	2005-05-25	1	12928
58194	3968	1729720	1923-04-12	1923-04-24	1	-17054
25315	1716	1125315	1963-04-14	1963-05-12	1	-2426
18547	1276	1125315	1967-03-18	1967-03-25	1	-1013
72186	4932	1119510	1967-02-18	1967-03-04	1	-1034
16197	1118	740275	1983-08-10	1983-11-23	1	5074
22641	1537	1501700	2010-05-31	2010-05-31	1	14760
7656	528	1118084	2002-07-02	2002-07-02	1	11870
19958	1359	1119510	1962-01-22	1962-01-29	1	-2894
76958	5258	19127890	1974-07-16	1975-07-11	1	2017
66377	4532	1112807	1984-03-03	1984-05-02	1	5235
62381	4256	1000560	1963-11-14	1963-11-14	2	-2240
67905	4634	738818	2002-03-15	2002-03-29	1	11775
30900	2088	1118084	1945-03-02	1945-03-02	1	-9071
58299	3976	1112807	1969-01-16	1969-02-15	1	-320
1265	86	1125315	1952-04-03	1952-05-02	1	-6453
47482	3223	1713332	1953-08-30	1953-09-20	1	-5947
14713	1016	1125315	2000-12-19	2001-01-02	1	11324
69981	4777	933724	1982-06-23	1982-06-30	1	4563
59710	4072	738818	1995-10-18	1995-11-01	1	9435
69480	4739	1112807	1954-09-03	1954-09-17	1	-5585
56115	3823	1124300	1993-10-23	1993-10-23	1	8696
73917	5051	1125315	1992-05-18	1992-06-01	1	8187
35856	2436	1125315	1942-10-28	1942-11-11	1	-9913
22220	1512	1549786	1991-05-24	1992-05-18	1	8173
62946	4297	1119510	2008-01-28	2008-02-04	1	13913
31277	2116	1125315	1979-03-26	1979-04-09	1	3385
58439	3986	1115008	2014-08-18	2014-09-08	1	16321
27325	1846	1112807	1952-07-20	1952-08-03	1	-6360
19854	1353	738818	1985-06-12	1985-06-19	1	5648
11072	758	1125315	2000-05-04	2000-05-11	1	11088
66847	4562	1717327	1963-02-17	1963-03-03	1	-2496
9976	686	1125315	1966-06-18	1966-06-25	1	-1286
65213	4454	1125315	2005-09-20	2005-10-04	1	13060
23754	1608	1125315	1979-04-22	1979-06-21	1	3458
68805	4694	1503184	1996-07-31	1997-07-26	1	10068
23610	1600	1713332	1958-11-06	1958-11-13	1	-4067
58195	3968	1729720	1923-11-24	1923-12-05	1	-16829
25316	1716	1125315	1982-07-02	1982-07-16	1	4579
18548	1276	1125315	1992-02-03	1992-02-17	1	8082
72187	4932	1125315	1964-12-08	1964-12-22	1	-1836
16198	1118	920293	2000-09-06	2000-09-13	1	11213
22642	1537	1778162	1994-02-13	1994-02-27	1	8823
7657	528	1119510	1971-08-25	1971-09-08	1	615
19959	1359	1307863	1987-04-14	1987-04-14	1	6312
76959	5258	1119510	1984-09-22	1984-10-06	1	5392
66378	4532	1125315	1943-04-20	1943-05-04	1	-9739
62382	4256	1112807	1957-08-29	1957-09-12	1	-4494
67906	4634	1118084	1997-10-20	1997-10-20	1	10154
30901	2088	1119510	1983-06-11	1983-06-25	1	4923
58300	3976	1125315	1976-06-08	1976-07-16	2	2378
1266	86	1729720	1990-03-14	1990-03-27	1	7390
47483	3223	1729720	1985-09-24	1985-10-06	1	5757
14714	1016	1729720	1996-03-16	1996-03-23	1	9578
69982	4777	1112807	1959-01-08	1959-01-22	1	-3997
59711	4072	1125315	1975-02-04	1975-02-18	1	1874
69481	4739	1118084	1952-01-31	1952-01-31	1	-6545
56116	3823	1174888	1976-01-21	1976-01-21	1	2211
73918	5051	1778162	1983-09-15	1983-09-29	1	5019
35857	2436	1125315	1970-10-25	1970-11-08	1	311
22221	1512	1595799	1998-04-17	1998-12-09	1	10569
62947	4297	1177480	1974-10-28	1974-11-11	1	1775
31278	2116	1759842	1987-03-09	1987-03-23	1	6290
58440	3986	1124300	1996-06-07	1996-06-07	1	9654
27326	1846	1115008	2003-06-23	2003-07-14	1	12247
19855	1353	1112807	1969-11-02	1969-11-30	1	-32
11073	758	1717327	1977-03-29	1977-04-12	1	2658
66848	4562	1717327	1965-05-26	1965-06-09	1	-1667
9977	686	1125315	1976-07-30	1976-08-06	1	2409
65214	4454	1125315	2007-03-23	2007-05-22	1	13655
23755	1608	1125315	1990-09-17	1990-09-24	1	7571
68806	4694	1515774	1999-07-16	2000-07-10	1	11148
23611	1600	1713332	1972-02-18	1972-02-25	1	785
58196	3968	1759842	1931-09-23	1931-10-14	1	-13959
25317	1716	1728416	1950-06-21	1950-07-05	1	-7120
18549	1276	1713332	1984-11-16	1984-11-30	1	5447
72188	4932	1125315	1990-09-06	1990-09-20	1	7567
16199	1118	933724	2000-11-08	2000-11-15	1	11276
22643	1537	1503184	1982-04-10	1983-04-05	1	4842
7658	528	1503184	1975-05-15	1977-05-04	2	2680
19960	1359	1729720	1961-06-02	1961-06-11	1	-3126
76960	5258	1125315	1960-03-02	1960-03-16	1	-3578
66379	4532	1125315	1983-02-02	1983-02-16	1	4794
62383	4256	1125315	2009-12-26	2010-02-01	2	14641
67907	4634	1125315	1963-07-06	1963-07-20	1	-2357
30902	2088	1125315	1973-04-21	1973-04-28	1	1213
58301	3976	1729720	1988-10-27	1988-11-03	1	6881
1267	86	1759842	1967-05-22	1967-06-05	1	-941
47484	3223	1112807	1919-08-03	1919-11-01	1	-18324
14715	1016	19127890	1983-05-31	1984-05-25	1	5258
69983	4777	1115008	2004-03-17	2004-04-07	1	12515
59712	4072	1125315	1999-08-27	1999-09-10	1	10844
69482	4739	1119510	1919-06-09	1919-06-16	1	-18462
56117	3823	1326303	2008-11-05	2008-11-05	1	14188
76482	5229	1125315	2001-12-17	2001-12-31	1	11687
35858	2436	1125315	2014-12-08	2014-12-22	1	16426
22222	1512	1713332	1979-11-04	1979-11-18	1	3608
62948	4297	1503184	1989-12-18	1990-12-13	1	7651
31279	2116	1102527	2012-10-07	2012-10-07	1	15620
58441	3986	1125315	1971-03-07	1971-03-14	1	437
27327	1846	1115008	2007-04-24	2007-06-23	1	13687
19856	1353	1125315	1985-06-12	1985-06-19	1	5648
11074	758	1738521	1977-02-02	1977-02-16	1	2603
66849	4562	1112807	1966-07-01	1966-07-15	1	-1266
9978	686	1759842	1959-03-08	1959-03-15	1	-3945
65215	4454	1125315	2015-12-21	2015-12-28	1	16797
23756	1608	1177480	1982-04-06	1982-04-20	1	4492
68807	4694	1549786	1999-07-16	2000-07-10	1	11148
23612	1600	1759842	1965-05-13	1965-05-20	1	-1687
58197	3968	1759842	1948-05-02	1948-05-16	1	-7900
26760	1809	1124300	1995-01-23	1995-01-23	1	9153
18550	1276	1551099	1958-05-02	1958-05-02	1	-4262
72189	4932	1125315	1997-04-18	1997-04-25	1	9976
16200	1118	1125315	1990-06-03	1990-06-17	1	7472
22644	1537	1713332	1970-07-05	1970-07-19	1	199
7659	528	1521369	1978-04-29	1980-04-18	2	3760
19961	1359	1759842	1947-06-04	1947-06-18	1	-8233
76961	5258	1728416	1960-03-02	1960-03-16	1	-3578
66380	4532	1729720	1911-04-27	1911-05-10	1	-21421
62384	4256	1174888	2010-01-02	2010-01-02	1	14611
67908	4634	1125315	2002-03-15	2002-03-29	1	11775
30903	2088	1125315	2002-10-24	2002-11-14	1	12005
58302	3976	1119510	1985-10-29	1985-11-05	1	5787
1268	86	1125315	1965-11-10	1965-11-24	1	-1499
47485	3223	1124957	1929-02-11	1929-02-11	1	-14934
14716	1016	19127890	1986-05-15	1987-05-10	1	6338
69984	4777	1118084	1992-10-16	1992-10-16	1	8324
59713	4072	1713332	1998-01-21	1998-02-11	1	10268
69483	4739	1119510	1938-11-26	1938-12-10	1	-11345
56118	3823	1713332	2010-12-12	2011-02-20	1	15025
76483	5229	1713332	1967-09-14	1967-10-05	1	-819
35859	2436	1322184	2008-02-02	2008-02-02	1	13911
22223	1512	1713332	1994-05-05	1994-05-12	1	8897
62949	4297	1515774	1992-12-02	1993-11-27	1	8731
31280	2116	1115008	2006-10-25	2006-11-08	1	13460
58442	3986	1125315	1973-09-24	1973-10-01	1	1369
27328	1846	1118084	1987-11-09	1987-11-09	1	6521
21899	1491	1545958	2011-07-12	2011-07-12	1	15167
11075	758	1118084	2012-10-31	2012-10-31	1	15644
66850	4562	1119510	1982-08-26	1982-09-09	1	4634
9979	686	1759842	1968-01-19	1968-01-26	1	-706
65216	4454	1174888	1950-02-15	1950-02-15	1	-7260
23757	1608	1713332	1992-04-08	1992-04-22	1	8147
68808	4694	1759842	1993-01-16	1993-01-30	1	8430
23613	1600	1102527	1978-08-26	1978-08-26	1	3159
58198	3968	1759842	1966-12-06	1966-12-27	1	-1101
26761	1809	1125315	2004-12-01	2004-12-15	1	12767
18551	1276	1759842	1984-11-16	1984-11-30	1	5447
72190	4932	1125315	2010-10-22	2010-10-29	1	14911
16201	1118	1515774	1992-07-13	1993-07-08	1	8589
22645	1537	1713332	1978-01-15	1978-01-22	1	2943
7660	528	1713332	1963-01-30	1963-02-13	1	-2514
19962	1359	738818	1962-01-22	1962-01-29	1	-2894
42258	2864	1112807	1945-02-24	1945-03-10	1	-9063
66381	4532	1759842	1983-06-30	1983-07-07	1	4935
62385	4256	1177480	1974-09-10	1974-10-01	1	1734
67909	4634	1503184	1981-10-09	1982-10-04	1	4659
30904	2088	1137529	1968-11-19	1968-11-19	1	-408
58303	3976	1119510	1996-03-13	1996-03-27	1	9582
1269	86	1177480	2001-04-20	2001-05-11	1	11453
47486	3223	1125315	1925-11-24	1925-12-01	1	-16102
14717	1016	1125315	2013-06-02	2013-06-16	1	15872
69985	4777	1125315	1978-05-29	1978-06-12	1	3084
59714	4072	1713332	2010-01-18	2010-02-01	1	14641
69484	4739	1125315	1930-08-05	1930-08-12	1	-14387
56119	3823	1759842	2010-12-12	2011-02-20	1	15025
76484	5229	1717327	1963-11-26	1963-12-10	1	-2214
35860	2436	1332418	2008-02-02	2008-02-02	1	13911
22224	1512	1759842	1994-05-05	1994-05-12	1	8897
62950	4297	1549786	1992-12-02	1993-11-27	1	8731
31281	2116	1125315	2015-09-27	2015-12-26	1	16795
58443	3986	1177480	2007-07-23	2007-08-27	1	13752
27329	1846	1119510	2002-11-30	2002-12-14	1	12035
21900	1491	1729720	1970-12-28	1971-01-05	1	369
11076	758	1119510	2000-05-04	2000-05-11	1	11088
66851	4562	1125315	1985-12-23	1986-01-20	1	5863
9980	686	1759842	1969-10-26	1969-11-02	1	-60
65217	4454	1307863	2006-10-07	2006-10-07	1	13428
23758	1608	1728416	1945-03-08	1945-03-22	1	-9051
68809	4694	1759842	1993-12-03	1993-12-24	1	8758
23614	1600	1713332	1981-10-12	1981-11-09	1	4330
59917	4086	1137529	2010-06-10	2010-06-10	1	14770
26762	1809	1125315	1978-08-20	1978-10-19	1	3213
18552	1276	1115008	2009-07-17	2009-09-15	1	14502
72191	4932	1125315	2016-09-09	2016-09-16	1	17060
16202	1118	1515774	1995-06-28	1996-06-22	1	9669
22646	1537	1717327	1961-05-26	1961-06-09	1	-3128
7661	528	1503184	1978-04-29	1980-04-18	2	3760
19963	1359	757627	2002-03-12	2002-03-12	1	11758
42259	2864	1125315	1998-09-01	1998-09-08	1	10477
66382	4532	1112807	1911-07-20	1911-08-03	1	-21336
62386	4256	1713332	1980-04-27	1980-05-04	1	3776
67910	4634	1728416	1963-07-06	1963-07-20	1	-2357
30905	2088	1729720	1941-04-17	1941-04-24	1	-10479
58304	3976	1119510	2018-04-15	2018-04-22	1	17643
1270	86	1322184	2013-04-30	2013-04-30	1	15825
47487	3223	1125315	1944-02-09	1944-02-16	1	-9451
15396	1070	1125315	2017-06-26	2017-07-03	1	17350
69986	4777	1503184	1977-04-13	1979-04-03	2	3379
59715	4072	1759842	1977-06-02	1977-06-23	1	2730
69485	4739	1125315	1950-10-03	1950-10-24	1	-7009
56120	3823	19127890	1976-08-28	1977-08-23	1	2791
76485	5229	1729720	1975-01-31	1975-02-07	1	1863
35861	2436	1539403	2008-02-02	2008-02-02	1	13911
22225	1512	738818	1983-04-05	1983-04-12	1	4849
62951	4297	1713332	1999-06-01	1999-06-22	1	10764
31282	2116	1177480	2012-10-07	2012-11-11	1	15655
58444	3986	1713332	1966-02-05	1966-02-26	1	-1405
27330	1846	1125315	2002-11-30	2002-12-14	1	12035
21901	1491	1729720	1979-05-08	1979-05-19	1	3425
11077	758	1177480	1977-03-29	1977-04-12	1	2658
66852	4562	1125315	2015-10-09	2015-10-23	1	16731
9981	686	1112807	1948-01-30	1948-02-13	1	-7993
65218	4454	1322184	2004-05-15	2004-05-15	1	12553
23759	1608	1729720	1960-06-23	1960-07-03	1	-3469
68810	4694	1503184	2001-07-05	2002-06-30	1	11868
23615	1600	1759842	1981-10-12	1981-11-09	1	4330
59918	4086	1759842	1998-01-16	1998-02-06	1	10263
26763	1809	1728416	1978-12-18	1979-01-01	1	3287
18553	1276	1119510	2017-04-13	2017-04-27	1	17283
72192	4932	1713332	2005-04-24	2005-05-08	1	12911
16203	1118	19127890	1997-06-17	1998-06-12	1	10389
22647	1537	1728416	1960-08-12	1960-08-26	1	-3415
7662	528	1521369	1975-05-15	1977-05-04	2	2680
19964	1359	1112807	1932-05-28	1932-06-11	1	-13718
42260	2864	1125315	2005-01-03	2005-01-17	1	12800
66383	4532	1125315	1949-03-04	1949-03-11	1	-7601
62387	4256	1746114	1963-11-14	1963-11-14	1	-2240
67911	4634	1729720	1989-06-30	1989-07-09	1	7129
30906	2088	1119510	1915-12-29	1916-01-05	1	-19720
60059	4094	738818	1958-09-09	1958-09-23	1	-4118
1271	86	1332418	2013-04-30	2013-04-30	1	15825
47488	3223	1729720	1948-07-05	1948-07-12	1	-7843
15397	1070	1713332	2011-04-29	2011-05-06	1	15100
69987	4777	19127890	1977-04-13	1979-04-03	2	3379
59716	4072	1759842	1998-01-21	1998-02-11	1	10268
69486	4739	1551099	1922-02-25	1922-02-25	1	-17477
56121	3823	1307863	2008-11-05	2008-11-05	1	14188
76486	5229	1112807	1963-11-26	1963-12-10	1	-2214
35862	2436	1713332	1984-03-21	1984-03-28	1	5200
22226	1512	1115008	2010-10-01	2010-10-15	1	14897
62952	4297	1759842	1983-10-20	1983-11-10	1	5061
31283	2116	1713332	1966-04-15	1966-04-29	1	-1343
58445	3986	1713332	1990-08-01	1990-08-22	1	7538
27331	1846	1713332	1964-05-13	1964-05-27	1	-2045
21902	1491	1125315	2001-06-06	2001-06-27	1	11500
11078	758	1729720	1985-05-23	1985-06-04	1	5633
66853	4562	1125315	2016-04-28	2016-05-12	1	16933
9982	686	1112807	1954-02-27	1954-03-29	1	-5757
65219	4454	1332418	2004-05-15	2004-05-15	1	12553
23760	1608	1759842	1942-03-20	1942-03-27	1	-10142
68811	4694	19127890	1996-07-31	1997-07-26	1	10068
23616	1600	1124300	1978-01-12	1978-01-12	1	2933
59919	4086	1778162	1991-02-03	1991-02-17	1	7717
26764	1809	1729720	1964-07-05	1964-07-13	1	-1998
18554	1276	1125315	1976-09-15	1976-09-29	1	2463
72193	4932	1713332	2008-09-19	2008-10-03	1	14155
17380	1202	920293	2013-08-14	2013-08-21	1	15938
22648	1537	1112807	1958-05-04	1958-05-18	1	-4246
7663	528	1728416	1960-07-22	1960-08-05	1	-3436
19965	1359	1125315	1962-01-22	1962-01-29	1	-2894
42261	2864	1713332	1956-06-17	1956-06-24	1	-4939
66384	4532	1177480	1998-08-17	1998-09-07	1	10476
62388	4256	1759842	1980-04-27	1980-05-04	1	3776
67912	4634	1759842	2015-08-01	2015-08-22	1	16669
30907	2088	1125315	1938-12-28	1939-01-04	1	-11320
60060	4094	1112807	1959-09-02	1959-11-01	1	-3714
1272	86	1713332	1967-05-22	1967-06-05	1	-941
47489	3223	1759842	1978-09-28	1978-10-12	1	3206
15398	1070	1759842	2011-04-29	2011-05-06	1	15100
69988	4777	920293	1982-06-23	1982-06-30	1	4563
63991	4373	1177480	1978-10-06	1978-10-20	1	3214
69487	4739	1713332	1944-02-27	1944-03-05	1	-9433
56122	3823	1759842	2014-06-10	2014-07-01	1	16252
76487	5229	1112807	1968-07-02	1968-07-23	1	-527
35863	2436	1361711	2008-02-02	2008-02-02	1	13911
22227	1512	1125315	1983-04-05	1983-04-12	1	4849
65273	4460	1125315	1961-03-19	1961-04-09	1	-3189
31284	2116	738818	1972-07-04	1972-07-18	1	929
58446	3986	1729720	1967-02-27	1967-03-08	1	-1030
27332	1846	1124957	1963-12-20	1963-12-20	1	-2204
21903	1491	1125315	2011-07-12	2011-07-12	1	15167
11079	758	1115008	2000-07-15	2000-08-05	1	11174
66854	4562	1149380	1964-02-04	1964-02-04	1	-2158
9983	686	1112807	1971-03-17	1971-03-31	1	454
65220	4454	1539403	2004-05-15	2004-05-15	1	12553
23761	1608	1759842	1992-04-08	1992-04-22	1	8147
68812	4694	19127890	1999-07-16	2000-07-10	1	11148
23617	1600	1125315	1952-02-23	1952-03-15	1	-6501
59920	4086	920293	2016-12-16	2016-12-23	1	17158
26765	1809	1125315	1996-10-05	1996-10-19	1	9788
18555	1276	1125315	2015-09-14	2015-09-28	1	16706
72194	4932	1759842	2005-04-24	2005-05-08	1	12911
17381	1202	933724	2013-08-14	2013-08-21	1	15938
22649	1537	1125315	1956-08-13	1956-08-27	1	-4875
7664	528	1759842	1963-01-30	1963-02-13	1	-2514
19966	1359	1326303	1987-04-14	1987-04-14	1	6312
42262	2864	1728416	1945-02-24	1945-03-10	1	-9063
66385	4532	1713332	1983-06-30	1983-07-07	1	4935
65352	4467	1124957	1979-10-21	1979-10-21	1	3580
67913	4634	1125315	1996-04-27	1996-05-25	1	9641
30908	2088	1125315	1972-07-10	1972-07-24	1	935
60061	4094	1112807	1963-03-15	1963-03-29	1	-2470
1273	86	1112807	1961-03-15	1961-04-05	1	-3193
49560	3378	1125315	1959-12-07	1959-12-21	1	-3664
15399	1070	1112807	1976-09-12	1976-10-03	1	2467
69989	4777	1125315	1974-11-29	1975-02-27	2	1883
63992	4373	1551099	1976-07-04	1976-07-04	1	2376
69488	4739	738818	1919-06-09	1919-06-16	1	-18462
56123	3823	1125315	1956-06-04	1956-06-18	1	-4945
76488	5229	1112807	1986-11-30	1986-12-21	1	6198
37437	2546	738818	1989-09-12	1989-09-19	1	7201
22228	1512	1549786	1998-04-17	1998-12-09	1	10569
65274	4460	1174888	2003-07-19	2003-07-19	1	12252
31285	2116	738818	2005-12-02	2005-12-16	1	13133
58447	3986	19127890	1978-08-06	1980-07-26	2	3859
27333	1846	1125315	1975-10-24	1975-11-07	1	2136
21904	1491	1174888	2011-07-12	2011-07-12	1	15167
11080	758	1125315	1996-08-23	1996-09-06	1	9745
66855	4562	1551099	1962-06-22	1962-06-22	1	-2750
9984	686	1115008	1994-07-17	1994-08-21	1	8998
65729	4490	1112807	1926-04-21	1926-05-05	1	-15947
23762	1608	1112807	1945-03-08	1945-03-22	1	-9051
68813	4694	920293	2015-08-29	2015-09-05	1	16683
23618	1600	1125315	1965-04-17	1965-04-24	1	-1713
59921	4086	933724	2016-12-16	2016-12-23	1	17158
26766	1809	1177480	1978-12-18	1979-01-01	1	3287
18556	1276	1177480	2010-08-11	2010-09-10	1	14862
72195	4932	1759842	2008-09-19	2008-10-03	1	14155
17382	1202	1713332	2008-08-03	2008-08-17	1	14108
22650	1537	1125315	1960-11-19	1960-12-03	1	-3316
8912	614	1112807	1964-06-05	1964-06-19	1	-2022
19967	1359	1729720	1945-04-17	1945-04-24	1	-9018
42263	2864	1729720	1947-02-15	1947-02-25	1	-8346
66386	4532	1729720	1912-07-15	1912-07-25	1	-20979
65353	4467	1125315	1956-05-02	1956-05-23	1	-4971
67914	4634	1521369	1981-10-09	1982-10-04	1	4659
30909	2088	1125315	2012-05-25	2012-06-15	1	15506
60062	4094	1112807	1967-03-24	1967-04-21	1	-986
1274	86	1125315	1952-07-05	1952-07-19	1	-6375
49561	3378	1125315	1961-03-01	1961-03-15	1	-3214
15400	1070	1125315	1982-06-05	1982-06-19	1	4552
69990	4777	1125315	1979-09-04	1979-09-25	1	3554
63993	4373	1738521	1976-11-01	1976-12-06	1	2531
69489	4739	738818	1938-11-26	1938-12-10	1	-11345
56124	3823	1125315	1969-10-25	1969-11-01	1	-61
76489	5229	1174888	1977-06-20	1977-06-20	1	2727
37438	2546	1112807	1976-12-31	1977-01-14	1	2570
22229	1512	1728416	1976-05-02	1976-05-16	1	2327
65275	4460	1729720	1951-12-08	1951-12-16	1	-6591
31286	2116	1125315	1972-07-04	1972-07-18	1	929
58448	3986	723013	2009-08-13	2010-01-21	1	14630
27334	1846	1125315	1979-09-29	1979-10-13	1	3572
21905	1491	1322184	1997-02-18	2011-07-12	1	15167
11081	758	1177480	1974-03-20	1974-05-19	1	1599
66856	4562	1713332	1979-03-21	1979-04-11	1	3387
9985	686	1125315	1951-01-03	1951-01-17	1	-6924
65730	4490	1112807	1931-12-19	1932-01-16	1	-13865
23763	1608	1119510	1952-03-01	1952-03-08	1	-6508
68814	4694	1102527	2001-02-25	2001-02-25	1	11378
23619	1600	1125315	1971-10-02	1971-12-31	1	729
59922	4086	1124300	2016-08-31	2016-08-31	1	17044
26767	1809	1125315	1971-03-02	1971-03-09	1	432
18557	1276	1713332	1998-02-07	1998-02-28	1	10285
72196	4932	738818	1967-02-18	1967-03-04	1	-1034
17383	1202	1521369	2001-05-27	2002-05-22	1	11829
22651	1537	1125315	2010-12-29	2011-01-05	1	14979
8913	614	1759842	1991-04-19	1991-04-26	1	7785
19968	1359	715997	2003-03-07	2003-03-07	1	12118
42264	2864	1112807	1949-08-02	1949-10-31	1	-7367
66387	4532	1112807	1946-03-04	1946-03-18	1	-8690
65354	4467	1125315	1991-05-03	1991-05-17	1	7806
67915	4634	1717327	1967-07-02	1967-07-16	1	-900
30910	2088	1713332	1935-02-09	1935-02-16	1	-12738
60063	4094	1125315	1958-09-09	1958-09-23	1	-4118
1275	86	1125315	1957-02-23	1957-03-02	1	-4688
49562	3378	1728416	1959-12-07	1959-12-21	1	-3664
15401	1070	1125315	2007-02-11	2007-02-18	1	13562
69991	4777	1125315	1983-06-02	1983-06-09	1	4907
63994	4373	1738521	1977-05-30	1977-06-13	1	2720
69490	4739	1112807	1934-10-01	1934-10-22	1	-12855
56125	3823	1125315	1976-01-21	1976-04-20	2	2301
76490	5229	1713332	2000-06-20	2000-07-04	1	11142
37439	2546	1125315	1976-01-22	1976-02-12	1	2233
22230	1512	1759842	2005-09-13	2005-10-04	1	13060
65276	4460	738818	1989-04-05	1989-04-12	1	7041
31287	2116	1125315	2005-12-02	2005-12-16	1	13133
58449	3986	1112807	1967-04-26	1967-05-10	1	-967
27335	1846	1713332	1984-03-01	1984-03-08	1	5180
21906	1491	1539403	1997-02-18	1997-02-18	1	9910
11082	758	1125315	1988-12-01	1988-12-15	1	6923
69237	4724	975125	1945-07-30	1945-08-20	1	-8900
9986	686	1177480	1976-01-08	1976-01-22	1	2212
65731	4490	1125315	1956-04-15	1956-04-29	1	-4995
23764	1608	1125315	1950-01-17	1950-01-31	1	-7275
68815	4694	1125315	1982-02-07	1982-02-21	1	4434
23620	1600	1125315	1978-08-26	1978-10-25	1	3219
59923	4086	1125315	1979-11-23	1979-12-07	1	3627
30849	2087	1112807	1927-09-23	1927-10-23	1	-15411
18558	1276	1759842	1998-02-07	1998-02-28	1	10285
72197	4932	1125315	1967-02-18	1967-03-04	1	-1034
17384	1202	1549786	1996-06-22	1999-06-07	3	10749
22652	1537	19127890	1982-04-10	1983-04-05	1	4842
8914	614	1112807	1968-05-07	1968-06-06	1	-574
19969	1359	1112807	1949-05-13	1949-06-10	1	-7510
42265	2864	1112807	1951-08-22	1951-09-19	1	-6679
66388	4532	1112807	1956-10-21	1956-11-11	1	-4799
65355	4467	1125315	2016-01-10	2016-01-31	1	16831
67916	4634	1729720	1975-10-15	1975-10-22	1	2120
30911	2088	1728416	1977-03-18	1977-04-08	1	2654
60064	4094	1125315	2010-09-02	2010-09-09	1	14861
1276	86	1177480	2014-12-28	2015-01-25	1	16460
49563	3378	1729720	1998-12-10	1998-12-18	1	10578
15402	1070	1713332	2018-12-30	2019-01-06	1	17902
69992	4777	1125315	1990-10-18	1990-11-01	1	7609
63995	4373	1118084	2018-01-10	2018-01-10	1	17541
69491	4739	1112807	1944-05-02	1944-06-06	1	-9340
56126	3823	1125315	2009-01-27	2009-02-17	1	14292
76491	5229	1119510	2000-07-16	2000-07-23	1	11161
37440	2546	1125315	1976-08-19	1976-09-02	1	2436
22231	1512	1759842	2014-02-16	2014-04-27	1	16187
65277	4460	738818	2009-07-26	2009-08-02	1	14458
31288	2116	1713332	1987-03-09	1987-03-23	1	6290
58450	3986	1119510	1971-03-07	1971-03-14	1	437
27336	1846	1728416	1952-07-20	1952-08-03	1	-6360
21907	1491	1112807	1990-10-11	1990-11-01	1	7609
11083	758	1125315	2000-07-12	2000-07-19	1	11157
69238	4724	975125	1971-04-17	1971-05-01	1	485
9987	686	1717327	1971-03-17	1971-03-31	1	454
65732	4490	1361711	1984-02-18	1988-04-23	1	6687
23765	1608	1125315	1957-09-10	1957-09-17	1	-4489
68816	4694	1125315	1982-08-04	1982-11-02	1	4688
23621	1600	1729720	1959-11-30	1959-12-13	1	-3672
59924	4086	1102527	1991-02-03	1991-02-03	1	7703
30850	2087	1112807	1989-04-19	1989-07-18	1	7138
21471	1461	1503184	1982-10-13	1983-10-08	1	5028
72198	4932	1713332	2012-09-21	2012-10-12	1	15625
17385	1202	1118084	2016-11-14	2016-11-14	1	17119
24484	1655	738818	1990-11-03	1990-11-10	1	7618
8915	614	1124300	2000-06-08	2000-06-08	1	11116
19970	1359	1119510	1976-08-21	1976-08-28	1	2431
42266	2864	1124300	1976-04-02	1976-04-02	1	2283
66389	4532	1125315	1980-06-28	1980-07-12	1	3845
65356	4467	1521369	1974-05-08	1976-04-27	2	2308
67917	4634	1729720	1976-09-17	1976-09-27	1	2461
30912	2088	1759842	1935-02-09	1935-02-16	1	-12738
60065	4094	1729720	2004-09-16	2004-09-23	1	12684
1277	86	1361711	2013-04-30	2013-04-30	1	15825
49564	3378	1115008	1996-07-10	2000-08-18	1	11187
15403	1070	1118084	2009-09-14	2009-09-14	1	14501
69993	4777	1713332	2010-06-17	2010-07-15	1	14805
63996	4373	1125315	1976-11-01	1976-12-06	1	2531
69492	4739	1119510	1962-08-08	1962-08-15	1	-2696
56127	3823	1521369	1976-08-28	1977-08-23	1	2791
76492	5229	1177480	1989-10-06	1989-11-05	1	7248
37441	2546	1125315	1987-07-14	1987-08-13	2	6433
22232	1512	19127890	1991-05-24	1993-05-13	2	8533
65278	4460	1115008	2012-04-02	2012-06-01	1	15492
31289	2116	1759842	1966-04-15	1966-04-29	1	-1343
58451	3986	1119510	2005-10-17	2005-10-31	1	13087
27337	1846	1759842	1964-05-13	1964-05-27	1	-2045
21908	1491	1124300	2006-05-20	2006-05-20	1	13288
11084	758	1125315	2006-05-03	2006-05-10	1	13278
69239	4724	975125	1975-10-12	1975-10-26	1	2124
9988	686	1728416	1951-01-03	1951-01-17	1	-6924
65733	4490	1112807	1925-12-22	1926-01-05	1	-16067
23766	1608	1125315	2017-12-05	2017-12-12	1	17512
68817	4694	1125315	1998-02-11	1998-03-13	1	10298
26679	1801	1115008	2003-09-28	2003-10-19	1	12344
59925	4086	1115008	1994-08-31	1994-09-21	1	9029
30851	2087	1119510	1941-06-07	1941-06-21	1	-10421
21472	1461	1713332	2016-09-11	2016-09-25	1	17069
72199	4932	1759842	2012-09-21	2012-10-12	1	15625
17386	1202	1595799	2001-05-27	2002-05-22	1	11829
24485	1655	1125315	1990-11-03	1990-11-10	1	7618
8916	614	1125315	1986-12-18	1987-01-08	1	6216
19971	1359	1713332	1947-06-04	1947-06-18	1	-8233
42267	2864	1125315	1954-09-06	1954-09-13	1	-5589
66390	4532	1501700	1964-04-03	1964-04-03	1	-2099
65357	4467	1728416	1957-04-27	1957-05-11	1	-4618
67918	4634	1112807	1964-09-11	1964-09-25	1	-1924
30913	2088	1759842	1974-06-15	1974-08-10	1	1682
60066	4094	1119510	1974-09-08	1974-09-22	1	1725
1278	86	1124300	1988-09-02	1988-09-02	1	6819
49565	3378	1125315	2017-04-20	2017-04-20	1	17276
15404	1070	1125315	1979-11-27	1979-12-11	1	3631
69994	4777	1728416	1959-01-08	1959-01-22	1	-3997
63997	4373	1177480	1977-05-30	1977-06-13	1	2720
69493	4739	1125315	1919-06-09	1919-06-16	1	-18462
57199	3900	1521369	1983-06-20	1984-06-14	1	5278
76493	5229	738818	2000-07-16	2000-07-23	1	11161
37442	2546	1125315	1989-09-12	1989-09-19	1	7201
25797	1748	1125315	1955-05-01	1955-05-08	1	-5352
65279	4460	1125315	1989-04-05	1989-04-12	1	7041
33432	2270	1521369	1996-05-06	1997-05-01	1	9982
58452	3986	1125315	1990-04-09	1990-04-23	1	7417
28993	1964	1115008	2009-04-25	2009-05-23	1	14387
21909	1491	1125315	1970-08-27	1970-09-10	1	252
12378	851	1125315	1982-05-27	1982-07-26	2	4573
69240	4724	1112807	1946-11-26	1946-12-10	1	-8423
9989	686	1759842	1989-01-29	1989-02-12	1	6982
65734	4490	1112807	1932-12-11	1933-03-11	1	-13445
23767	1608	1713332	1942-03-20	1942-03-27	1	-10142
68818	4694	1177480	2012-12-24	2013-01-07	1	15712
26680	1801	1310149	2007-08-08	2007-08-08	1	13733
59926	4086	1125315	1987-05-14	1987-06-04	1	6363
30852	2087	1119510	2009-10-13	2009-10-27	1	14544
21473	1461	1738521	1969-07-13	1969-07-27	1	-158
72200	4932	975125	1976-11-22	1976-11-22	1	2517
17387	1202	19127890	1996-06-22	1999-06-07	3	10749
24486	1655	1729720	1974-04-28	1974-05-11	1	1591
8917	614	1728416	1964-06-05	1964-06-19	1	-2022
19972	1359	1713332	1998-09-12	1998-10-03	1	10502
42268	2864	1125315	1990-06-10	1990-06-17	1	7472
66391	4532	1729720	1937-01-17	1937-01-30	1	-12024
65358	4467	1759842	1989-10-04	1989-10-25	1	7237
67919	4634	1125315	1967-07-02	1967-07-16	1	-900
30914	2088	738818	1915-12-29	1916-01-05	1	-19720
60067	4094	1729720	1957-10-15	1957-10-24	1	-4452
1279	86	1125315	1977-12-14	1977-12-28	1	2918
49566	3378	1305058	1996-07-10	2000-08-18	1	11187
15405	1070	1125315	1987-01-02	1987-01-16	1	6224
69995	4777	1759842	2010-06-17	2010-07-15	1	14805
63998	4373	1713332	1990-03-08	1990-03-15	1	7378
69494	4739	1125315	1938-11-26	1938-12-10	1	-11345
57200	3900	1729720	1967-08-06	1967-08-16	1	-869
76494	5229	1112807	1964-11-09	1964-11-23	1	-1865
37443	2546	1515774	1995-02-21	1996-02-16	1	9542
25798	1748	1125315	1987-09-01	1987-09-15	1	6466
65280	4460	1125315	2003-07-19	2003-08-18	2	12282
33433	2270	1521369	1998-04-26	1999-04-21	1	10702
58453	3986	1125315	1992-06-18	1992-06-25	1	8211
28994	1964	1118084	2000-08-10	2000-08-10	1	11179
21910	1491	1125315	1995-08-07	1995-09-06	2	9379
12379	851	1729720	1989-08-22	1989-09-04	1	7186
69241	4724	1119510	2005-06-13	2005-06-20	1	12954
9990	686	1728416	1948-01-30	1948-02-13	1	-7993
65735	4490	1112807	1936-01-25	1936-02-24	1	-12365
23768	1608	1759842	1988-05-26	1988-07-21	1	6776
68819	4694	1192710	1982-07-22	1982-07-22	1	4585
26681	1801	738818	1964-01-31	1964-02-14	1	-2148
59927	4086	1125315	2019-02-09	2019-02-16	1	17943
30853	2087	1125315	1923-08-16	1923-08-23	1	-16933
21474	1461	1112807	1969-07-13	1969-07-27	1	-158
72201	4932	1115008	1997-11-14	1997-11-28	1	10193
17388	1202	1125315	1993-01-01	1993-01-08	1	8408
24487	1655	1729720	1986-04-10	1986-04-18	1	5951
8918	614	1112807	1963-10-31	1963-11-14	1	-2240
19973	1359	1759842	1998-09-12	1998-10-03	1	10502
42269	2864	1125315	2015-04-07	2015-04-14	1	16539
66562	4546	933724	2005-07-15	2005-07-22	1	12986
65359	4467	920293	1987-07-26	1987-08-02	1	6422
67920	4634	1713332	2015-08-01	2015-08-22	1	16669
30915	2088	738818	1922-03-15	1922-03-22	1	-17452
60068	4094	1759842	2006-09-28	2006-10-12	1	13433
1280	86	1539403	2013-04-30	2013-04-30	1	15825
49567	3378	1729720	1977-05-03	1977-05-16	1	2692
15406	1070	1759842	2018-12-30	2019-01-06	1	17902
69996	4777	1119510	1978-05-29	1978-06-12	1	3084
63999	4373	1729720	1977-02-03	1977-02-12	1	2599
69495	4739	1125315	1993-06-26	1993-06-26	1	8577
57201	3900	1503184	1983-06-20	1984-06-14	1	5278
76495	5229	1112807	1973-06-27	1973-07-11	1	1287
37444	2546	1521369	1991-03-14	1992-03-08	1	8102
25799	1748	1125315	1989-07-03	1989-08-09	2	7160
65281	4460	1125315	2009-07-26	2009-08-02	1	14458
33434	2270	738818	2016-04-12	2016-04-26	1	16917
58454	3986	1759842	1966-02-05	1966-02-26	1	-1405
28995	1964	1125315	1966-07-05	1966-08-09	1	-1241
21911	1491	1124957	1995-08-07	1995-08-07	1	9349
12380	851	1729720	1990-10-30	1990-11-07	1	7615
69242	4724	1125315	2003-09-14	2003-12-13	1	12399
9991	686	1729720	1967-06-12	1967-06-19	1	-927
65736	4490	1125315	1980-10-03	1980-10-10	1	3935
23769	1608	738818	1952-03-01	1952-03-08	1	-6508
68820	4694	1500211	2002-06-30	2003-03-30	1	12141
26682	1801	1112807	1963-12-01	1963-12-22	1	-2202
59928	4086	1149380	2010-06-10	2010-06-10	1	14770
30854	2087	1125315	1938-04-16	1938-04-23	1	-11576
21475	1461	1115008	2007-11-12	2007-12-10	1	13857
72202	4932	1118084	1996-02-23	1996-02-23	1	9549
17389	1202	1125315	2019-05-23	2019-06-06	1	18053
24488	1655	1118084	2005-10-12	2005-10-12	1	13068
8919	614	1112807	1971-08-20	1971-09-10	1	617
21179	1443	1125315	1983-03-25	1983-04-08	1	4845
42270	2864	1729720	1941-02-17	1941-02-28	1	-10534
66563	4546	1124300	2010-10-31	2010-10-31	1	14913
65360	4467	1112807	1973-02-19	1973-03-26	1	1180
67921	4634	1119510	2002-03-15	2002-03-29	1	11775
30916	2088	920293	1951-10-25	1951-11-01	1	-6636
60069	4094	738818	1974-09-08	1974-09-22	1	1725
1281	86	1729720	1953-05-03	1953-05-15	1	-6075
49568	3378	1119510	2000-06-12	2000-06-26	1	11134
16072	1112	1125315	1990-11-05	1990-11-12	1	7620
69997	4777	1125315	1971-04-05	1971-04-19	1	473
64000	4373	1759842	1990-03-08	1990-03-15	1	7378
71065	4853	1125315	2000-07-20	2000-08-03	1	11172
57202	3900	1112807	1977-07-11	1977-08-01	1	2769
76496	5229	1115008	2007-08-03	2007-09-07	1	13763
37445	2546	1729720	1981-04-27	1981-05-09	1	4146
25800	1748	1713332	2005-09-21	2005-09-28	1	13054
65282	4460	1118084	1979-10-21	1979-10-21	1	3580
33435	2270	1115008	2012-01-24	2012-02-07	1	15377
58455	3986	738818	1971-03-07	1971-03-14	1	437
28996	1964	738818	2013-08-13	2013-08-20	1	15937
21912	1491	1125315	1974-06-24	1974-07-08	1	1649
12381	851	1729720	2009-07-08	2009-07-15	1	14440
69243	4724	1149380	1945-05-13	1961-03-29	1	-3200
10601	728	1119510	1983-12-11	1983-12-18	1	5099
65737	4490	1174888	1988-04-23	1988-04-23	1	6687
23770	1608	1112807	1943-08-03	1943-08-17	1	-9634
68821	4694	1521369	1996-07-31	1997-07-26	1	10068
26683	1801	1326303	2007-08-08	2007-08-08	1	13733
59929	4086	1177480	1990-03-19	1990-04-10	1	7404
30855	2087	1125315	1974-03-04	1974-03-18	1	1537
21476	1461	1124300	2008-07-28	2008-07-28	1	14088
72203	4932	1125315	2002-10-12	2002-10-26	1	11986
17390	1202	1177480	2012-07-18	2012-08-22	1	15574
24489	1655	1149380	2004-09-29	2004-09-29	1	12690
8920	614	1125315	1990-12-09	1990-12-16	1	7654
21180	1443	1177480	2001-05-13	2001-06-03	1	11476
42271	2864	1759842	1956-06-17	1956-06-24	1	-4939
66564	4546	1521369	1983-06-20	1984-06-14	1	5278
65361	4467	933724	1987-07-26	1987-08-02	1	6422
67922	4634	1177480	1989-09-17	1989-10-01	1	7213
30917	2088	933724	1951-10-25	1951-11-01	1	-6636
60070	4094	738818	1992-09-27	1992-10-04	1	8312
1282	86	1729720	1995-11-29	1995-12-07	1	9471
49569	3378	1125315	1970-05-05	1970-05-19	1	138
16073	1112	1738521	1967-01-09	1967-01-23	1	-1074
69998	4777	1125315	2004-08-21	2004-08-28	1	12658
64001	4373	1129625	1976-07-18	1976-07-18	1	2390
71066	4853	1124300	1999-04-20	1999-04-20	1	10701
57203	3900	1115008	2002-05-22	2002-06-12	1	11850
76497	5229	1118084	2004-04-14	2004-04-14	1	12522
37446	2546	1738521	1976-08-19	1976-09-02	1	2436
25801	1748	1729720	1959-02-12	1959-02-21	1	-3967
65283	4460	1119510	1989-04-05	1989-04-12	1	7041
33436	2270	1125315	2016-04-12	2016-04-26	1	16917
58456	3986	1125315	1987-04-11	1987-04-25	1	6323
28997	1964	1125315	1997-08-22	1997-09-05	1	10109
21913	1491	1177480	1982-04-26	1982-07-25	1	4588
12382	851	1759842	2015-12-24	2016-01-07	1	16807
69244	4724	1728416	1946-11-26	1946-12-10	1	-8423
10602	728	1112807	1970-10-14	1970-10-28	1	300
65738	4490	1112807	1929-12-15	1929-12-29	1	-14613
23771	1608	1125315	1952-03-01	1952-03-08	1	-6508
68822	4694	19127890	2001-07-05	2002-06-30	1	11868
26684	1801	1729720	1981-12-27	1982-01-03	1	4385
59930	4086	1177480	2006-06-20	2006-09-18	1	13409
30856	2087	1125315	2009-10-13	2009-10-27	1	14544
21477	1461	19127890	1982-10-13	1983-10-08	1	5028
72204	4932	1129625	1976-12-03	1976-12-03	1	2528
17391	1202	1515774	1996-06-22	1999-06-07	3	10749
24490	1655	1713332	1994-04-22	1994-05-06	1	8891
8921	614	1125315	1992-05-11	1992-06-08	1	8194
21181	1443	1503184	1993-03-11	1994-03-06	1	8830
42272	2864	1125315	1969-08-27	1969-09-10	1	-113
66565	4546	920293	2005-07-15	2005-07-22	1	12986
65362	4467	1124300	1987-07-09	1987-07-09	1	6398
67923	4634	19127890	1981-10-09	1982-10-04	1	4659
30918	2088	1112807	1912-11-14	1912-11-28	1	-20853
60071	4094	1115008	2017-10-25	2017-11-08	1	17478
2790	186	1115008	2005-02-25	2005-03-18	1	12860
49570	3378	1125315	2000-06-12	2000-06-26	1	11134
16074	1112	1759842	2011-11-04	2011-11-18	1	15296
69999	4777	1521369	1977-04-13	1979-04-03	2	3379
64002	4373	1738521	1978-10-06	1978-10-20	1	3214
71067	4853	1125315	1963-07-03	1963-07-17	1	-2360
57204	3900	1118084	1999-02-16	1999-02-16	1	10638
76498	5229	1125315	1977-06-20	1977-08-19	2	2787
37447	2546	933724	1993-04-26	1993-05-03	1	8523
25802	1748	1759842	2005-09-21	2005-09-28	1	13054
65284	4460	1125315	2008-08-21	2008-08-28	1	14119
33437	2270	1521369	1994-05-17	1995-05-12	1	9262
58457	3986	1503184	1978-08-06	1980-07-26	2	3859
28998	1964	1125315	2013-08-13	2013-08-20	1	15937
21914	1491	1332418	1997-02-18	1997-02-18	1	9910
12383	851	1118084	2016-03-09	2016-03-09	1	16869
69245	4724	1759842	1971-05-17	1971-06-07	1	522
10603	728	1119510	1982-07-21	1982-07-28	1	4591
65739	4490	1125315	1956-02-09	1956-03-01	1	-5054
23772	1608	1125315	1974-11-23	1974-12-14	1	1808
68823	4694	933724	2015-08-29	2015-09-05	1	16683
26685	1801	1125315	1964-01-31	1964-02-14	1	-2148
59931	4086	1125315	1979-02-28	1979-03-07	1	3352
30857	2087	1322184	2011-11-09	2016-08-03	1	17016
21478	1461	1125315	1994-09-30	1994-10-21	1	9059
74377	5086	1125315	2017-05-23	2017-05-30	1	17316
17392	1202	1549786	2001-05-27	2002-05-22	1	11829
24491	1655	1713332	2016-03-31	2016-04-14	1	16905
8922	614	1125315	1994-05-31	1994-06-07	1	8923
21182	1443	1549786	1994-03-06	1995-03-01	1	9190
42273	2864	1125315	2013-05-05	2013-05-19	1	15844
66566	4546	1119510	1994-04-03	1994-04-10	1	8865
65363	4467	1125315	1980-07-26	1980-08-09	1	3873
69402	4736	738818	1979-11-23	1979-11-30	1	3620
30919	2088	1112807	1921-09-14	1921-09-28	1	-17627
60072	4094	1119510	1958-09-09	1958-09-23	1	-4118
2791	186	1125315	1991-01-11	1991-01-25	1	7694
49571	3378	738818	2000-06-12	2000-06-26	1	11134
16075	1112	1125315	2012-07-05	2012-07-12	1	15533
70000	4777	1729720	1964-03-14	1964-03-27	1	-2106
65138	4451	1112807	1955-05-15	1955-05-29	1	-5331
71068	4853	1728416	1963-12-14	1963-12-28	1	-2196
57205	3900	1125315	1978-01-08	1978-01-15	1	2936
76499	5229	1125315	2000-07-16	2000-07-23	1	11161
37448	2546	1119510	1990-05-19	1990-06-02	1	7457
25803	1748	1125315	1949-04-23	1949-04-30	1	-7551
65285	4460	1759842	1950-03-22	1950-04-05	1	-7211
33438	2270	920293	2001-06-19	2001-06-26	1	11499
58458	3986	1738521	1967-04-26	1967-05-10	1	-967
28999	1964	1119510	2013-08-13	2013-08-20	1	15937
21915	1491	1361711	1997-02-18	2011-07-12	1	15167
12384	851	1125315	1992-10-01	1992-10-22	1	8330
69246	4724	19010482	1988-06-09	1988-06-23	1	6748
10604	728	1125315	1973-02-17	1973-03-03	1	1157
65740	4490	1125315	1988-04-23	1988-04-23	1	6687
23773	1608	1729720	1943-08-05	1943-08-14	1	-9637
68824	4694	1521369	2001-07-05	2002-06-30	1	11868
26686	1801	1125315	1967-01-05	1967-01-26	1	-1071
59932	4086	1125315	1986-06-04	1986-06-18	1	6012
30858	2087	1347450	2016-08-03	2016-08-03	1	17016
21479	1461	1521369	1982-10-13	1983-10-08	1	5028
74378	5086	1177480	2003-02-20	2003-03-27	1	12138
17393	1202	1759842	2008-08-03	2008-08-17	1	14108
24492	1655	1115008	2002-09-18	2002-10-02	1	11962
8923	614	1112807	1970-04-27	1970-07-26	1	206
21183	1443	19127890	1993-03-11	1995-03-01	2	9190
42274	2864	1713332	1947-09-21	1947-09-28	1	-8131
66567	4546	1125315	2012-12-19	2012-12-26	1	15700
65364	4467	1713332	1989-10-04	1989-10-25	1	7237
69403	4736	1125315	1979-11-23	1979-11-30	1	3620
30920	2088	1112807	1923-10-18	1923-11-08	1	-16856
60073	4094	1125315	1974-09-08	1974-09-22	1	1725
2792	186	1549786	1989-10-28	1990-10-23	1	7600
49572	3378	914335	2014-05-10	2014-05-10	1	16200
16076	1112	1112807	1967-01-09	1967-01-23	1	-1074
70735	4831	738818	1991-12-18	1992-01-01	1	8035
65139	4451	1125315	1957-03-14	1957-03-21	1	-4669
71069	4853	1125315	1968-03-25	1968-04-08	1	-633
57206	3900	19127890	1983-06-20	1984-06-14	1	5278
76500	5229	1717327	1964-11-09	1964-11-23	1	-1865
37449	2546	1124300	2011-09-10	2011-09-10	1	15227
25804	1748	1125315	2006-02-21	2006-02-28	1	13207
65286	4460	1112807	1944-01-18	1944-02-01	1	-9466
33439	2270	1118084	2019-03-12	2019-03-12	1	17967
58459	3986	738818	2005-10-17	2005-10-31	1	13087
32010	2166	738818	1970-01-08	1970-01-15	1	14
21916	1491	1717327	1970-08-27	1970-09-10	1	252
12385	851	1177480	1983-06-05	1983-06-19	1	4917
69247	4724	738818	1977-12-26	1978-01-02	1	2923
10605	728	1125315	1973-08-16	1973-08-30	1	1337
65741	4490	1729720	1971-03-29	1971-04-07	1	461
23774	1608	738818	2013-05-07	2013-05-21	1	15846
68825	4694	1713332	1993-01-16	1993-01-30	1	8430
26687	1801	1125315	2009-11-24	2009-12-01	1	14579
59933	4086	1125315	1991-02-03	1991-02-17	1	7717
30859	2087	1539403	2001-07-18	2001-07-18	1	11521
21480	1461	1729720	2005-05-20	2005-06-01	1	12935
74379	5086	738818	2009-04-30	2009-05-14	1	14378
18966	1303	738818	1981-11-03	1981-11-17	1	4338
24493	1655	1125315	1989-08-28	1989-09-11	1	7193
8924	614	1177480	1981-04-20	1981-05-18	1	4155
21184	1443	1125315	1981-06-03	1981-06-17	1	4185
42275	2864	1729720	1955-02-25	1955-03-07	1	-5414
66568	4546	1503184	1983-06-20	1984-06-14	1	5278
65365	4467	19127890	1974-05-08	1976-04-27	2	2308
69404	4736	1177480	2002-08-23	2002-10-29	1	11989
30921	2088	1119510	1922-03-15	1922-03-22	1	-17452
60074	4094	1125315	1992-09-27	1992-10-04	1	8312
2793	186	1551099	1991-07-18	1991-07-18	1	7868
49573	3378	1112807	1961-09-11	1961-09-25	1	-3020
16077	1112	1112807	1968-07-02	1968-07-16	1	-534
70736	4831	1112807	1964-09-08	1964-09-22	1	-1927
65140	4451	1125315	1999-03-29	1999-04-05	1	10686
71070	4853	1125315	2002-06-29	2002-07-13	1	11881
58726	4006	1112807	1966-03-09	1966-03-23	1	-1380
76501	5229	1759842	1967-09-14	1967-10-05	1	-819
37450	2546	1174888	1987-07-14	1987-07-14	1	6403
25805	1748	1759842	1997-05-06	1997-05-20	1	10001
65287	4460	1119510	2009-07-26	2009-08-02	1	14458
33440	2270	1119510	2016-04-12	2016-04-26	1	16917
58460	3986	740275	2011-07-29	2012-03-16	1	15415
32011	2166	738818	2001-06-13	2001-06-27	1	11500
24947	1689	1125315	1986-06-08	1986-06-22	1	6016
12386	851	1713332	1985-02-16	1985-03-09	1	5546
69248	4724	738818	1996-10-20	1996-10-27	1	9796
10606	728	1177480	1993-06-29	1993-07-20	1	8601
65742	4490	1124300	1963-09-04	1963-09-04	1	-2311
23775	1608	1112807	1947-12-10	1947-12-24	1	-8044
68826	4694	1713332	1993-12-03	1993-12-24	1	8758
26688	1801	1551099	1955-05-18	1955-05-18	1	-5342
59934	4086	1125315	1991-10-02	1991-10-16	1	7958
30860	2087	1713332	2012-04-02	2012-04-23	1	15453
21481	1461	1759842	2016-09-11	2016-09-25	1	17069
74380	5086	1112807	1974-02-24	1974-03-10	1	1529
18967	1303	1125315	1977-02-18	1977-02-25	1	2612
24494	1655	1154343	2004-09-29	2004-09-29	1	12690
8925	614	1713332	1991-04-19	1991-04-26	1	7785
21185	1443	1125315	1988-09-24	1988-10-15	1	6862
42276	2864	920293	1961-06-07	1961-06-14	1	-3123
66569	4546	1713332	1990-07-29	1990-08-05	1	7521
65366	4467	1112807	1957-04-27	1957-05-11	1	-4618
69405	4736	1738521	1974-11-04	1974-11-18	1	1782
30922	2088	1125315	1915-12-29	1916-01-05	1	-19720
60075	4094	1713332	1997-10-26	1997-11-09	1	10174
2794	186	1713332	1982-05-10	1982-05-17	1	4519
49574	3378	1118084	1994-12-03	1994-12-03	1	9102
16078	1112	1125315	1971-03-03	1971-04-07	1	461
70737	4831	1125315	1991-12-18	1992-01-01	1	8035
65141	4451	1759842	1963-02-11	1963-03-04	1	-2495
71071	4853	1125315	2018-09-06	2018-09-20	1	17794
58727	4006	1115008	1997-12-09	1998-02-07	1	10264
76502	5229	1759842	2000-06-20	2000-07-04	1	11142
37451	2546	738818	1990-05-19	1990-06-02	1	7457
25806	1748	738818	1975-02-28	1975-03-07	1	1891
65288	4460	1125315	1952-07-05	1952-07-19	1	-6375
33441	2270	1503184	1996-05-06	1997-05-01	1	9982
58461	3986	1125315	2005-10-17	2005-10-31	1	13087
32012	2166	920293	1992-06-15	1992-06-22	1	8208
24948	1689	1713332	1943-03-26	1943-04-02	1	-9771
12387	851	1759842	1985-02-16	1985-03-09	1	5546
69249	4724	738818	2005-06-13	2005-06-20	1	12954
10607	728	1729720	1966-04-10	1966-04-20	1	-1352
67434	4604	738818	1986-08-14	1986-08-28	1	6083
23776	1608	1119510	2013-05-07	2013-05-21	1	15846
70439	4812	1125315	1967-03-09	1967-04-06	1	-1001
26689	1801	1118084	1994-07-31	1994-07-31	1	8977
59935	4086	1125315	2016-11-12	2016-11-19	1	17124
30861	2087	1112807	1950-11-21	1950-12-05	1	-6967
21661	1475	1112807	1951-02-25	1951-04-26	1	-6825
74381	5086	1119510	2009-04-30	2009-05-14	1	14378
18968	1303	1125315	1977-10-26	1977-11-09	1	2869
24495	1655	1729720	1984-06-02	1984-06-15	1	5279
11187	764	1124300	2003-12-24	2003-12-24	1	12410
21186	1443	1125315	1990-11-03	1990-12-01	1	7639
42277	2864	933724	1961-06-07	1961-06-14	1	-3123
66570	4546	1729720	1984-06-18	1984-06-27	1	5291
65367	4467	1112807	1959-02-07	1959-03-07	1	-3953
69406	4736	1759842	1974-10-10	1974-10-31	1	1764
30923	2088	1125315	1922-03-15	1922-03-22	1	-17452
60076	4094	1717327	1963-03-15	1963-03-29	1	-2470
2795	186	19127890	1989-10-28	1991-10-18	2	7960
49575	3378	1125315	1965-10-08	1965-10-22	1	-1532
16079	1112	1713332	2011-11-04	2011-11-18	1	15296
70738	4831	1729720	1966-08-14	1966-08-27	1	-1223
65142	4451	1119510	1974-12-27	1975-01-03	1	1828
71072	4853	1713332	2009-11-17	2009-12-08	1	14586
58728	4006	1119510	1970-10-05	1970-10-12	1	284
76776	5249	738818	1963-07-10	1963-07-17	1	-2360
37452	2546	1125315	1985-05-25	1985-06-24	1	5653
25807	1748	738818	2012-03-06	2012-03-20	1	15419
65289	4460	1125315	1987-11-04	1987-11-11	1	6523
33442	2270	1549786	1998-04-26	1999-04-21	1	10702
58462	3986	1125315	2011-08-06	2011-09-03	1	15220
32013	2166	933724	1992-06-15	1992-06-22	1	8208
24949	1689	1713332	2008-02-12	2008-02-26	1	13935
12388	851	1768849	1982-05-27	1982-06-10	1	4543
69250	4724	975125	1965-05-28	1965-06-11	1	-1665
10608	728	1759842	1986-06-11	1986-06-18	1	6012
67435	4604	1125315	1971-03-26	1971-04-09	1	463
23777	1608	1124300	1977-06-25	1977-06-25	1	2732
70440	4812	1521369	1981-08-10	1982-01-13	1	4395
26690	1801	1119510	1964-01-31	1964-02-14	1	-2148
59936	4086	1713332	1998-01-16	1998-02-06	1	10263
30862	2087	1124957	1989-04-19	1989-04-19	1	7048
21662	1475	1112807	1966-04-21	1966-05-05	1	-1337
74382	5086	1124300	2010-02-27	2010-02-27	1	14667
18969	1303	1118084	2012-03-05	2012-03-05	1	15404
24496	1655	1759842	1994-04-22	1994-05-06	1	8891
11188	764	1125315	1997-01-08	1997-01-15	1	9876
21187	1443	1177480	1993-07-19	1993-08-23	1	8635
42278	2864	1125315	2012-03-19	2012-04-02	1	15432
66571	4546	1729720	2015-12-02	2015-12-09	1	16778
65368	4467	1125315	1966-08-27	1966-09-24	1	-1195
69407	4736	1118084	2013-08-21	2013-08-21	1	15938
30924	2088	1125315	1932-12-07	1932-12-14	1	-13532
60077	4094	1759842	1961-11-18	1961-12-02	1	-2952
2796	186	933724	2012-12-22	2012-12-29	1	15703
49576	3378	1174888	2017-04-20	2017-04-20	1	17276
16080	1112	1124300	2007-06-03	2007-06-03	1	13667
70739	4831	1729720	1980-07-31	1980-08-09	1	3873
65143	4451	1125315	2001-07-08	2001-07-15	1	11518
71073	4853	1728416	1968-03-25	1968-04-08	1	-633
58729	4006	1124300	1994-12-25	1994-12-25	1	9124
76777	5249	1112807	1963-05-20	1963-06-03	1	-2404
37453	2546	1125315	1990-05-19	1990-06-02	1	7457
25808	1748	1118084	1987-05-08	1987-05-08	1	6336
65290	4460	1125315	1993-12-17	1994-01-07	1	8772
33443	2270	19127890	1994-05-17	1995-05-12	1	9262
58463	3986	1521369	1978-08-06	1980-07-26	2	3859
32014	2166	1125315	1970-01-08	1970-01-15	1	14
24950	1689	1729720	1945-12-03	1945-12-12	1	-8786
12389	851	1713332	2015-12-24	2016-01-07	1	16807
69251	4724	1112807	1943-06-09	1943-06-23	1	-9689
10609	728	1125315	1960-11-21	1960-12-05	1	-3314
67436	4604	1125315	1986-08-14	1986-08-28	1	6083
23778	1608	1125315	2013-05-07	2013-05-21	1	15846
70441	4812	1118084	1989-12-18	1989-12-18	1	7291
26691	1801	1177480	1996-12-19	1997-01-02	1	9863
62542	4270	1112807	1970-07-30	1970-08-13	1	224
30863	2087	1177480	2015-01-03	2015-04-03	1	16528
21663	1475	1125315	1961-01-03	1961-01-17	1	-3271
74383	5086	1125315	1978-04-02	1978-05-02	1	3043
18970	1303	1125315	1981-11-03	1981-11-17	1	4338
24497	1655	1759842	2016-03-31	2016-04-14	1	16905
11189	764	1125315	2010-01-08	2010-01-15	1	14624
21188	1443	1515774	1994-03-06	1995-03-01	1	9190
42279	2864	1759842	1947-09-21	1947-09-28	1	-8131
66572	4546	1759842	1990-07-29	1990-08-05	1	7521
65369	4467	1125315	1979-10-21	1979-10-21	1	3580
69408	4736	1125315	1982-08-17	1982-08-24	1	4618
30925	2088	1125315	1969-03-02	1969-05-01	2	-245
60078	4094	1759842	1997-10-26	1997-11-09	1	10174
2797	186	975125	1977-12-01	1977-12-22	1	2912
49577	3378	1177480	2017-04-20	2017-05-20	1	17306
16081	1112	1125315	2000-06-11	2000-06-18	1	11126
70740	4831	1115008	2019-02-16	2019-03-02	1	17957
65144	4451	1177480	1976-04-01	1976-05-01	1	2312
71074	4853	1729720	1964-09-27	1964-10-08	1	-1911
58730	4006	1125315	1951-04-11	1951-04-25	1	-6826
76778	5249	1124300	1988-05-13	1988-05-13	1	6707
37454	2546	1125315	1992-09-01	1992-09-08	1	8286
25809	1748	1119510	2012-03-06	2012-03-20	1	15419
65291	4460	1125315	2006-08-24	2006-09-07	1	13398
33444	2270	933724	2001-06-19	2001-06-26	1	11499
58464	3986	1759842	1990-08-01	1990-08-22	1	7538
32015	2166	1125315	2001-06-13	2001-06-27	1	11500
24951	1689	1759842	1973-02-19	1973-03-12	1	1166
12390	851	1778162	1983-06-05	1983-06-19	1	4917
69252	4724	1125315	1977-12-26	1978-01-02	1	2923
10610	728	1713332	1986-06-11	1986-06-18	1	6012
67437	4604	1177480	2000-04-21	2000-05-05	1	11082
23779	1608	1322184	2016-04-16	2016-04-16	1	16907
70442	4812	1177480	1981-12-16	1982-01-06	1	4388
26692	1801	1307863	2007-08-08	2007-08-08	1	13733
62543	4270	1125315	1994-01-06	1994-01-13	1	8778
30864	2087	1322184	2001-07-18	2011-06-15	1	15140
21664	1475	1125315	2000-01-09	2000-01-23	1	10979
74384	5086	1125315	2009-04-30	2009-05-14	1	14378
18971	1303	1729720	1976-08-23	1976-09-03	1	2437
24498	1655	1119510	1990-11-03	1990-11-10	1	7618
11190	764	1713332	1990-05-04	1990-05-25	1	7449
21189	1443	1713332	1986-01-13	1986-02-03	1	5877
42593	2886	1112807	1953-02-15	1953-03-01	1	-6150
66573	4546	738818	1994-04-03	1994-04-10	1	8865
65370	4467	1177480	1979-10-21	1979-12-20	1	3640
69409	4736	1125315	1987-10-29	1987-11-05	1	6517
30926	2088	1125315	1974-01-05	1974-02-02	1	1493
60079	4094	1118084	1991-02-26	1991-02-26	1	7726
2798	186	1125315	1981-09-30	1981-10-29	1	4319
49578	3378	1309944	2014-05-10	2014-05-10	1	16200
18876	1297	933724	2013-09-08	2013-09-15	1	15963
70741	4831	1717327	1965-11-25	1965-12-09	1	-1484
65145	4451	1713332	1961-07-28	1961-08-11	1	-3065
71075	4853	1729720	1965-04-09	1965-04-22	1	-1715
58731	4006	1125315	1952-07-23	1952-08-06	1	-6357
76779	5249	1125315	1955-10-31	1955-11-14	1	-5162
37455	2546	1125315	2014-12-13	2014-12-20	1	16424
25810	1748	1124957	1989-07-10	1989-07-10	1	7130
65292	4460	1713332	1950-03-22	1950-04-05	1	-7211
33445	2270	1125315	1988-05-08	1988-05-29	1	6723
60604	4134	1125315	1953-05-13	1953-05-27	1	-6063
32016	2166	1729720	1976-12-16	1976-12-28	1	2553
24952	1689	1759842	2008-02-12	2008-02-26	1	13935
13989	959	1102527	1970-05-13	1970-05-13	1	132
69253	4724	1125315	1996-10-20	1996-10-27	1	9796
10611	728	1729720	1997-04-20	1997-04-27	1	9978
67438	4604	1119510	1977-09-12	1977-09-19	1	2818
23780	1608	1347450	2016-04-16	2016-04-16	1	16907
70443	4812	1503184	1981-08-10	1982-01-13	1	4395
32665	2213	1125315	1974-06-26	1974-06-26	1	1637
62544	4270	1118084	2005-06-26	2005-06-26	1	12960
30865	2087	1322184	2016-12-07	2016-12-07	1	17142
21665	1475	738818	1944-03-05	1944-03-12	1	-9426
74385	5086	1729720	1980-02-16	1980-02-27	1	3709
18972	1303	1717327	1977-10-26	1977-11-09	1	2869
24499	1655	1729720	1981-08-03	1981-08-14	1	4243
11191	764	1125315	1992-05-16	1992-05-30	1	8185
21190	1443	1759842	1986-01-13	1986-02-03	1	5877
42594	2886	1713332	2001-11-27	2002-01-01	1	11688
66574	4546	1125315	1999-01-16	1999-01-30	1	10621
65371	4467	1503184	1974-05-08	1976-04-27	2	2308
69410	4736	1125315	2002-08-30	2002-08-30	1	11929
30927	2088	1125315	1992-06-18	1992-09-16	1	8294
60080	4094	1119510	1992-09-27	1992-10-04	1	8312
2799	186	1125315	1995-06-21	1995-06-28	1	9309
49579	3378	1343916	2014-05-10	2014-05-10	1	16200
18877	1297	1125315	2007-10-16	2007-10-30	1	13816
70742	4831	1729720	1973-02-25	1973-03-06	1	1160
65146	4451	1728416	1954-06-26	1954-07-10	1	-5654
71076	4853	1729720	1965-08-22	1965-09-04	1	-1580
58732	4006	1125315	1981-08-17	1981-08-31	1	4260
76780	5249	1125315	1963-07-10	1963-07-17	1	-2360
37456	2546	1503184	1991-03-14	1992-03-08	1	8102
25811	1748	1125315	1964-10-08	1964-10-22	1	-1897
65569	4480	1118084	1998-08-10	1998-08-10	1	10448
33446	2270	1500211	2001-04-10	2002-04-05	1	11782
60605	4134	1125315	1972-01-06	1972-01-13	1	742
32017	2166	1729720	1978-05-26	1978-06-05	1	3077
24953	1689	757627	2019-01-10	2019-01-10	1	17906
13990	959	1125315	1958-11-21	1958-12-05	1	-4045
69254	4724	1125315	2005-06-13	2005-06-20	1	12954
10612	728	738818	1982-07-21	1982-07-28	1	4591
67439	4604	1119510	1986-08-14	1986-08-28	1	6083
23781	1608	1713332	1988-05-26	1988-07-21	1	6776
70444	4812	1729720	1997-05-27	1997-06-06	1	10018
32666	2213	1125315	2011-12-16	2011-12-23	1	15331
62545	4270	1125315	1980-12-06	1980-12-13	1	3999
30866	2087	1713332	1941-09-15	1941-09-22	1	-10328
21666	1475	1102527	1951-02-25	1951-02-25	1	-6885
74386	5086	19127890	1986-09-06	1987-09-01	1	6452
18973	1303	1738521	1977-04-18	1977-05-02	1	2678
24989	1691	1112807	1950-01-30	1950-02-13	1	-7262
11192	764	1125315	2012-05-30	2012-06-29	1	15520
21191	1443	1768849	1981-06-03	1981-06-17	1	4185
42595	2886	1112807	1965-05-26	1965-06-09	1	-1667
66575	4546	1125315	2004-06-15	2004-06-22	1	12591
68342	4665	1503184	1999-07-22	2000-07-16	1	11154
69411	4736	1713332	1974-10-10	1974-10-31	1	1764
30928	2088	1177480	1977-03-18	1977-04-08	1	2654
60081	4094	1125315	1959-12-17	1959-12-24	1	-3661
2800	186	1503184	1990-10-23	1991-10-18	1	7960
49580	3378	1713332	1989-04-06	1989-04-20	1	7049
18878	1297	1125315	2011-06-30	2011-07-07	1	15162
70743	4831	1112807	1965-11-25	1965-12-09	1	-1484
65147	4451	1759842	1969-09-04	1969-09-18	1	-105
71077	4853	1759842	2009-11-17	2009-12-08	1	14586
58733	4006	738818	1970-10-05	1970-10-12	1	284
76781	5249	1125315	2007-12-03	2007-12-17	1	13864
37457	2546	19127890	1995-02-21	1996-02-16	1	9542
25812	1748	1125315	1975-02-28	1975-03-07	1	1891
65570	4480	1125315	1974-08-21	1974-09-04	1	1707
33447	2270	1503184	1994-05-17	1995-05-12	1	9262
60606	4134	1125315	1976-12-19	1977-01-02	1	2558
32018	2166	19127890	1983-05-08	1984-05-02	1	5235
24954	1689	1119510	1959-10-21	1959-11-04	1	-3711
13991	959	1713332	1977-05-21	1977-06-11	1	2718
69255	4724	1713332	1971-05-17	1971-06-07	1	522
10613	728	738818	1983-12-11	1983-12-18	1	5099
67440	4604	1125315	1987-10-23	1987-10-30	1	6511
25752	1746	920293	2014-06-16	2014-06-23	1	16244
70445	4812	1759842	1997-08-04	1997-08-18	1	10091
32667	2213	1343916	1991-08-01	1991-08-01	1	7882
62546	4270	1728416	1970-07-30	1970-08-13	1	224
30867	2087	1713332	2007-06-12	2007-06-19	1	13683
21667	1475	1115008	2003-02-04	2003-03-11	1	12122
74387	5086	1125315	1971-05-02	1971-05-16	1	500
18974	1303	1119510	1981-11-03	1981-11-17	1	4338
24990	1691	1125315	2005-06-01	2005-06-08	1	12942
11193	764	1174888	1989-01-01	1989-01-01	1	6940
21192	1443	1124300	2014-05-31	2014-05-31	1	16221
42596	2886	1125315	1956-12-10	1956-12-24	1	-4756
66576	4546	19127890	1989-05-19	1990-05-14	1	7438
68343	4665	1729720	1988-09-07	1988-09-16	1	6833
69412	4736	1125315	1981-04-01	1981-04-15	1	4122
30929	2088	1713332	1914-01-20	1914-01-27	1	-20428
60082	4094	1713332	1961-11-18	1961-12-02	1	-2952
2801	186	1515774	1989-10-28	1990-10-23	1	7600
49581	3378	1713332	2003-11-10	2003-11-17	1	12373
18879	1297	1759842	1979-10-27	1979-11-10	1	3600
70744	4831	1115008	2015-05-24	2015-06-07	1	16593
65148	4451	1112807	1954-06-26	1954-07-10	1	-5654
71078	4853	1112807	1963-12-14	1963-12-28	1	-2196
58734	4006	1125315	1970-10-05	1970-10-12	1	284
76782	5249	1717327	1963-05-20	1963-06-03	1	-2404
37458	2546	920293	1993-04-26	1993-05-03	1	8523
25813	1748	1125315	2012-03-06	2012-03-20	1	15419
65571	4480	1125315	1979-06-10	1979-07-01	1	3468
33448	2270	1595799	1998-04-26	1999-04-21	1	10702
60607	4134	1713332	1979-09-15	1979-10-06	1	3565
32019	2166	1119510	2001-06-13	2001-06-27	1	11500
24955	1689	1125315	1952-07-28	1952-09-26	1	-6306
13992	959	1713332	2014-10-01	2014-10-22	1	16365
69256	4724	19010482	2018-04-21	2018-05-05	1	17656
10614	728	1124300	1990-03-04	1990-03-04	1	7367
67441	4604	738818	1977-09-12	1977-09-19	1	2818
25753	1746	933724	2005-01-25	2005-02-01	1	12815
70446	4812	19127890	1975-09-11	1976-09-05	1	2439
32668	2213	1713332	2008-11-28	2008-12-05	1	14218
62547	4270	1102527	1992-01-07	1992-01-07	1	8041
30868	2087	1759842	2007-06-12	2007-06-19	1	13683
21668	1475	1125315	1944-03-05	1944-03-12	1	-9426
74388	5086	1125315	1972-10-26	1972-11-09	1	1043
18975	1303	1125315	1977-04-18	1977-05-02	1	2678
24991	1691	1177480	1977-06-25	1977-08-24	1	2792
11194	764	1759842	1990-05-04	1990-05-25	1	7449
21193	1443	1177480	2018-10-02	2018-11-05	1	17840
42597	2886	1125315	1963-10-03	1963-10-10	1	-2275
66577	4546	1125315	1973-02-03	1973-02-17	1	1143
68344	4665	1125315	1988-09-09	1988-09-16	1	6833
69413	4736	1125315	1994-09-30	1994-10-14	1	9052
30930	2088	1713332	1974-06-15	1974-08-10	1	1682
60083	4094	1713332	2006-09-28	2006-10-12	1	13433
2802	186	1713332	2009-07-05	2009-07-19	1	14444
49582	3378	1729720	1978-11-10	1978-11-22	1	3247
18880	1297	1119510	1989-11-04	1989-11-18	1	7261
70745	4831	1118084	2002-08-05	2002-08-05	1	11904
65149	4451	1118084	1992-08-20	1992-08-20	1	8267
71079	4853	1125315	1978-04-15	1978-05-06	1	3047
58735	4006	1177480	2011-04-30	2011-05-28	1	15122
76783	5249	1112807	1963-02-19	1963-03-12	1	-2487
37459	2546	1119510	1989-09-12	1989-09-19	1	7201
25814	1748	1713332	1997-05-06	1997-05-20	1	10001
65572	4480	1521369	1975-01-28	1976-01-23	1	2213
33449	2270	19127890	1996-05-06	1997-05-01	1	9982
60608	4134	1759842	1961-07-09	1961-07-30	1	-3077
32020	2166	1119510	1970-01-08	1970-01-15	1	14
24956	1689	1125315	1982-03-23	1982-03-30	1	4471
13993	959	738818	1996-10-18	1996-10-25	1	9794
69257	4724	975125	1986-01-05	1986-01-19	1	5862
10615	728	1125315	1959-12-27	1960-01-10	1	-3644
67442	4604	738818	1991-09-10	1991-09-24	1	7936
25754	1746	933724	2005-04-12	2005-04-19	1	12892
70447	4812	1112807	1955-03-12	1955-03-26	1	-5395
32669	2213	1759842	2008-11-28	2008-12-05	1	14218
62548	4270	1125315	1978-03-15	1978-03-29	1	3009
30869	2087	738818	2009-10-13	2009-10-27	1	14544
21669	1475	1125315	2017-12-29	2018-01-05	1	17536
74389	5086	1521369	1986-09-06	1987-09-01	1	6452
18976	1303	1713332	2013-07-17	2013-08-07	1	15924
24992	1691	1728416	1946-01-04	1946-01-18	1	-8749
11195	764	1125315	1989-01-01	1989-01-31	2	6970
21194	1443	1521369	1993-03-11	1994-03-06	1	8830
42598	2886	1125315	1985-08-03	1985-08-10	1	5700
66578	4546	1125315	1994-04-03	1994-04-10	1	8865
68345	4665	1521369	1996-08-06	1998-07-27	2	10434
69414	4736	1177480	2009-01-25	2009-03-26	1	14329
30931	2088	1713332	1981-05-14	1981-05-28	1	4165
60084	4094	1729720	1968-03-31	1968-04-11	1	-630
2803	186	1729720	1984-11-15	1984-11-23	1	5440
49583	3378	1759842	1989-04-06	1989-04-20	1	7049
18881	1297	1713332	1981-05-09	1981-05-23	1	4160
70746	4831	1119510	2015-01-15	2015-01-22	1	16457
65150	4451	1125315	1997-02-24	1997-04-02	2	9953
71080	4853	1125315	1995-03-18	1995-04-01	1	9221
58736	4006	1713332	2004-04-24	2004-05-01	1	12539
76784	5249	1713332	1981-11-15	1981-11-29	1	4350
37460	2546	1549786	1995-02-21	1996-02-16	1	9542
25815	1748	1728416	1948-03-28	1948-04-11	1	-7935
65573	4480	1713332	1987-08-17	1987-08-31	1	6451
35709	2427	1125315	1994-11-29	1994-12-13	1	9112
60609	4134	1759842	1979-09-15	1979-10-06	1	3565
32021	2166	1125315	1970-12-13	1970-12-20	1	353
24957	1689	1177480	1986-02-14	1986-03-07	1	5909
13994	959	1112807	1970-05-13	1970-07-12	1	192
69258	4724	975125	2018-04-21	2018-05-05	1	17656
10616	728	1125315	1982-07-21	1982-07-28	1	4591
67443	4604	1124300	2002-05-06	2002-05-06	1	11813
25755	1746	1119510	1997-05-30	1997-06-13	1	10025
70448	4812	1112807	1968-03-01	1968-03-29	1	-643
32670	2213	975125	1991-07-21	1991-07-21	1	7871
62549	4270	1125315	1995-09-22	1995-10-06	1	9409
30870	2087	1115008	1997-02-06	1997-04-07	1	9958
21670	1475	1177480	1984-12-26	1985-01-09	1	5487
74390	5086	1729720	1974-07-18	1974-07-29	1	1670
18977	1303	1729720	2005-07-16	2005-07-29	1	12993
24993	1691	1729720	1951-01-11	1951-01-24	1	-6917
11196	764	1713332	2013-07-01	2013-07-15	1	15901
21924	1493	1125315	1960-09-05	1960-09-12	1	-3398
42599	2886	1154343	1954-12-17	1954-12-17	1	-5494
66579	4546	1515774	1989-05-19	1990-05-14	1	7438
68346	4665	1521369	1999-07-22	2000-07-16	1	11154
69415	4736	1112807	1976-11-06	1976-11-20	1	2515
30932	2088	1713332	1990-01-22	1990-02-12	1	7347
60922	4156	1112807	1966-09-22	1966-10-06	1	-1183
2804	186	1759842	1976-05-28	1976-06-04	1	2346
49584	3378	1759842	2003-11-10	2003-11-17	1	12373
18882	1297	1759842	1981-05-09	1981-05-23	1	4160
70747	4831	1125315	2009-10-17	2009-11-21	1	14569
65151	4451	1125315	2003-09-28	2003-12-27	1	12413
71081	4853	1717327	1963-07-03	1963-07-17	1	-2360
58737	4006	1125315	1950-09-12	1950-09-26	1	-7037
76785	5249	1759842	1981-11-15	1981-11-29	1	4350
37461	2546	19127890	1991-03-14	1992-03-08	1	8102
25816	1748	1112807	1948-03-28	1948-04-11	1	-7935
65574	4480	1759842	1987-08-17	1987-08-31	1	6451
35710	2427	1125315	1998-08-29	1998-09-12	1	10481
60610	4134	1112807	1959-08-13	1959-10-12	1	-3734
32022	2166	1125315	1990-04-10	1990-04-24	1	7418
24958	1689	1759842	1993-01-02	1993-01-09	1	8409
13995	959	1125315	1967-02-08	1967-02-15	1	-1051
69259	4724	1112807	1942-03-03	1942-03-17	1	-10152
10617	728	1125315	1983-12-11	1983-12-18	1	5099
67444	4604	1125315	1977-09-12	1977-09-19	1	2818
25756	1746	1125315	1963-11-14	1963-12-05	1	-2219
70449	4812	1112807	1972-03-08	1972-06-06	1	887
32671	2213	1112807	1972-05-23	1972-06-06	1	887
62550	4270	1713332	2015-11-22	2015-12-06	1	16775
30871	2087	1125315	1936-09-15	1936-09-22	1	-12154
21671	1475	1759842	1997-12-12	1997-12-19	1	10214
74391	5086	1738521	1972-10-26	1972-11-09	1	1043
18978	1303	1759842	2013-07-17	2013-08-07	1	15924
24994	1691	1729720	1951-07-27	1951-08-08	1	-6721
11197	764	1759842	2013-07-01	2013-07-15	1	15901
21925	1493	1125315	2007-04-18	2007-04-25	1	13628
42600	2886	1728416	1953-02-15	1953-03-01	1	-6150
66580	4546	1549786	1989-05-19	1990-05-14	1	7438
68347	4665	1118084	2015-11-30	2015-11-30	1	16769
69416	4736	1119510	1979-11-23	1979-11-30	1	3620
32844	2226	1112807	1942-09-20	1942-10-04	1	-9951
60923	4156	1174888	2006-02-27	2006-02-27	1	13206
2805	186	920293	2012-12-22	2012-12-29	1	15703
52118	3550	1115008	2005-08-12	2005-09-09	1	13035
18883	1297	1768849	1981-10-26	1981-11-09	1	4330
70748	4831	1713332	1981-01-08	1981-01-15	1	4032
65152	4451	1713332	1969-09-04	1969-09-18	1	-105
74089	5066	933724	2000-05-08	2000-05-15	1	11092
58738	4006	1322184	2016-08-02	2016-08-02	1	17015
76786	5249	1112807	1966-05-25	1966-06-08	1	-1303
38148	2594	1125315	1980-11-08	1980-11-22	1	3978
25817	1748	1112807	1980-08-05	1980-08-19	1	3883
65575	4480	1112807	1966-09-02	1966-12-01	1	-1127
35711	2427	1759842	1965-01-15	1965-01-29	1	-1798
60611	4134	1125315	1956-07-15	1956-07-29	1	-4904
32023	2166	1521369	1983-05-08	1984-05-02	1	5235
24959	1689	738818	1959-10-21	1959-11-04	1	-3711
13996	959	1125315	1978-07-01	1978-07-15	1	3117
69260	4724	1115008	2011-03-06	2011-05-05	1	15099
10618	728	1713332	1990-08-02	1990-08-23	1	7539
67445	4604	1125315	1991-09-10	1991-09-24	1	7936
25757	1746	1125315	1964-03-26	1964-04-02	1	-2100
70450	4812	1125315	1956-12-13	1956-12-27	1	-4753
32672	2213	1125315	1975-07-07	1975-07-14	1	2020
62551	4270	1738521	1978-03-15	1978-03-29	1	3009
30872	2087	1125315	1989-04-19	1989-04-19	1	7048
21672	1475	1112807	1935-01-20	1935-02-03	1	-12751
74392	5086	1112807	1970-08-21	1970-09-04	1	246
20186	1377	1125315	1982-11-18	1982-12-02	1	4718
24995	1691	1759842	1957-06-14	1957-06-21	1	-4577
12459	857	1728416	1955-02-04	1955-02-18	1	-5431
21926	1493	1713332	1967-06-07	1967-06-28	1	-918
42601	2886	1759842	1999-02-27	1999-03-06	1	10656
66581	4546	19127890	1983-06-20	1984-06-14	1	5278
68348	4665	1177480	2005-09-22	2005-10-27	1	13083
69417	4736	1125315	1974-11-04	1974-11-19	2	1783
32845	2226	1119510	1957-08-11	1957-08-25	1	-4512
60924	4156	1174888	2007-12-24	2007-12-24	1	13871
2806	186	1118084	2010-07-05	2010-07-05	1	14795
52119	3550	1119510	1995-10-03	1995-10-10	1	9413
18884	1297	738818	2000-12-26	2001-01-02	1	11324
70749	4831	1728416	1964-09-08	1964-09-22	1	-1927
65153	4451	1713332	1984-09-05	1984-09-26	1	5382
74090	5066	1125315	1971-08-15	1971-08-29	1	605
58739	4006	1347450	2016-08-02	2016-08-02	1	17015
76787	5249	1119510	1963-07-10	1963-07-17	1	-2360
38149	2594	1713332	1984-07-30	1984-08-20	1	5345
25818	1748	1119510	1975-02-28	1975-03-07	1	1891
65576	4480	1125315	1993-12-14	1994-03-14	1	8838
35712	2427	1125315	1968-10-01	1968-10-15	1	-443
60612	4134	1713332	1961-07-09	1961-07-30	1	-3077
32024	2166	1729720	2015-04-26	2015-05-09	1	16564
24960	1689	1112807	1964-10-23	1964-11-06	1	-1882
13997	959	1125315	1996-10-18	1996-10-25	1	9794
69261	4724	1119510	1977-12-26	1978-01-02	1	2923
10619	728	1713332	2014-09-22	2014-10-13	1	16356
67446	4604	1125315	2014-04-06	2014-04-20	1	16180
25758	1746	1125315	1970-11-15	1970-11-29	1	332
70451	4812	1361711	2011-07-27	2011-07-27	1	15182
32673	2213	1125315	2004-09-04	2004-09-18	1	12679
62552	4270	1759842	2015-11-22	2015-12-06	1	16775
30873	2087	1177480	1977-09-28	1977-10-19	1	2848
21673	1475	1118084	1981-03-24	1981-03-24	1	4100
74393	5086	1125315	1970-10-20	1970-11-10	1	313
20187	1377	1118084	2015-07-13	2015-07-13	1	16629
24996	1691	1112807	1953-01-27	1953-03-03	1	-6148
12460	857	1112807	1954-02-20	1954-03-06	1	-5780
21927	1493	1112807	1962-10-24	1962-11-23	1	-2596
42602	2886	1125315	1983-11-26	1983-12-10	1	5091
67749	4626	975125	1997-11-07	1997-11-07	1	10172
68349	4665	1347450	2009-01-31	2009-01-31	1	14275
69418	4736	1174888	2002-08-30	2002-08-30	1	11929
32846	2226	1125315	1971-02-23	1971-03-02	1	425
60925	4156	1322184	2004-11-15	2006-02-27	1	13206
2807	186	1129625	1973-12-11	1973-12-11	1	1440
52120	3550	1125315	1986-05-12	1986-05-26	1	5989
18885	1297	1125315	1983-09-18	1983-10-02	1	5022
70750	4831	1759842	1981-01-08	1981-01-15	1	4032
65154	4451	1729720	1976-07-03	1976-07-15	1	2387
74091	5066	1503184	1981-04-04	1982-03-30	1	4471
58740	4006	1728416	1950-09-12	1950-09-26	1	-7037
76788	5249	1347450	2004-04-25	2004-04-25	1	12533
38150	2594	1729720	1975-03-30	1975-04-08	1	1923
25819	1748	1177480	1976-12-26	1977-01-23	1	2579
65577	4480	1503184	1975-01-28	1976-01-23	1	2213
35713	2427	1125315	1972-05-11	1972-05-18	1	868
60613	4134	1124300	1988-11-15	1988-11-15	1	6893
32025	2166	1112807	1986-09-09	1986-12-08	1	6185
24961	1689	1118084	1984-05-06	1984-05-06	1	5239
13998	959	1129625	1963-04-15	1963-04-15	1	-2453
69262	4724	1119510	1993-05-14	1993-05-21	1	8541
10620	728	1729720	1963-11-09	1963-11-21	1	-2233
67447	4604	1729720	1971-02-27	1971-03-11	1	434
25759	1746	1125315	2000-03-25	2000-06-23	1	11131
70452	4812	1521369	1975-09-11	1976-09-05	1	2439
32674	2213	1729720	1997-09-14	1997-09-22	1	10126
63103	4312	920293	1987-10-04	1987-10-11	1	6492
30874	2087	1332418	2001-07-18	2001-07-18	1	11521
21674	1475	1125315	1963-12-30	1964-01-13	1	-2180
74394	5086	1503184	1986-09-06	1987-09-01	1	6452
20188	1377	1500211	1995-11-20	1996-11-14	1	9814
24997	1691	1115008	2015-12-24	2016-01-07	1	16807
12461	857	1125315	2000-02-27	2000-03-05	1	11021
21928	1493	1112807	1972-07-03	1972-09-01	1	974
42603	2886	1149380	1954-12-17	1954-12-17	1	-5494
67750	4626	1124957	2016-05-01	2016-05-01	1	16922
68350	4665	1503184	1996-08-06	1998-07-27	2	10434
69419	4736	1713332	2001-07-29	2001-08-12	1	11546
32847	2226	1125315	1988-09-30	1988-10-07	1	6854
60926	4156	1322184	2006-06-26	2007-12-24	1	13871
2808	186	1177480	2009-07-05	2009-07-19	1	14444
52121	3550	1125315	2005-08-12	2005-08-12	1	13007
18886	1297	1125315	2000-12-26	2001-01-02	1	11324
70751	4831	738818	2015-01-15	2015-01-22	1	16457
65155	4451	1759842	1961-07-28	1961-08-11	1	-3065
74092	5066	1738521	1971-08-15	1971-08-29	1	605
58741	4006	1759842	2004-04-24	2004-05-01	1	12539
76789	5249	1729720	1957-09-21	1957-09-30	1	-4476
38151	2594	1118084	2015-05-07	2015-05-07	1	16562
25820	1748	1729720	1949-05-23	1949-06-01	1	-7519
65578	4480	1713332	1997-06-18	1997-07-02	1	10044
35714	2427	1125315	1975-07-21	1975-08-04	1	2041
60614	4134	1125315	1987-05-24	1987-06-07	1	6366
32026	2166	1118084	2000-12-24	2000-12-24	1	11315
24962	1689	1125315	1959-10-21	1959-11-04	1	-3711
13999	959	1728416	1958-11-21	1958-12-05	1	-4045
69263	4724	1124300	1977-12-14	1977-12-14	1	2904
10621	728	1759842	1990-08-02	1990-08-23	1	7539
67448	4604	1119510	1991-09-10	1991-09-24	1	7936
25760	1746	1125315	2005-10-28	2005-11-04	1	13091
70453	4812	1713332	1997-08-04	1997-08-18	1	10091
32675	2213	1112807	1974-06-26	1974-09-24	1	1727
63104	4312	1112807	1963-04-09	1963-04-23	1	-2445
30875	2087	1347450	2011-06-15	2011-06-15	1	15140
21675	1475	1125315	1993-04-29	1993-05-13	1	8533
74395	5086	1717327	1970-08-21	1970-09-04	1	246
20189	1377	1503184	1994-11-25	1995-11-20	1	9454
24998	1691	1177480	2014-12-08	2014-12-29	1	16433
12462	857	1759842	1981-02-23	1981-06-15	1	4183
21929	1493	1115008	1994-04-09	1994-04-23	1	8878
42604	2886	1713332	1999-02-27	1999-03-06	1	10656
67751	4626	1503184	1989-10-30	1990-10-25	1	7602
68351	4665	1515774	1995-08-12	1996-08-06	1	9714
69420	4736	1759842	2001-07-29	2001-08-12	1	11546
32848	2226	1125315	2001-06-12	2001-07-03	1	11506
60927	4156	1322184	2008-07-07	2008-07-07	1	14067
2809	186	1521369	1990-10-23	1991-10-18	1	7960
52122	3550	1778162	2005-08-12	2005-09-09	1	13035
18887	1297	1713332	1979-10-27	1979-11-10	1	3600
70752	4831	1112807	1971-04-05	1971-05-10	1	494
65156	4451	1759842	1984-09-05	1984-09-26	1	5382
74093	5066	1112807	1973-01-06	1973-02-03	1	1129
58742	4006	1125315	1966-09-18	1966-10-23	1	-1166
76790	5249	1729720	1994-03-17	1994-03-28	1	8852
38152	2594	1125315	2013-05-23	2013-06-06	1	15862
28090	1905	1112807	1966-07-18	1966-08-01	1	-1249
65579	4480	19127890	1981-12-25	1982-12-20	1	4736
35715	2427	1177480	2008-12-20	2009-01-19	1	14263
60615	4134	1125315	2017-06-13	2017-06-20	1	17337
32027	2166	1125315	2006-01-27	2006-02-17	1	13196
24963	1689	1125315	1992-02-04	1992-02-18	1	8083
14000	959	1728416	1962-07-16	1962-07-30	1	-2712
69264	4724	1125315	1994-01-17	1994-01-24	1	8789
10622	728	1759842	2014-09-22	2014-10-13	1	16356
67449	4604	1125315	2007-05-22	2007-05-29	1	13662
25761	1746	920293	2002-12-08	2002-12-15	1	12036
70454	4812	1322184	2011-07-27	2011-07-27	1	15182
32676	2213	1118084	1995-08-05	1995-08-05	1	9347
63105	4312	1119510	1994-04-02	1994-04-16	1	8871
30876	2087	1361711	2001-07-18	2001-07-18	1	11521
21676	1475	1729720	1934-11-23	1934-12-01	1	-12815
74396	5086	1738521	1974-02-24	1974-03-10	1	1529
20190	1377	1521369	1994-11-25	1995-11-20	1	9454
24999	1691	1759842	2000-10-14	2000-11-04	1	11265
12463	857	914335	1983-09-18	1983-09-18	1	5008
21930	1493	1124300	1989-11-06	1989-11-06	1	7249
42605	2886	1102527	2001-11-27	2001-11-27	1	11653
67752	4626	1515774	1990-10-25	1991-10-20	1	7962
68352	4665	1549786	1995-08-12	1996-08-06	1	9714
74070	5065	1118084	2002-02-23	2002-02-23	1	11741
32849	2226	1729720	1999-03-09	1999-03-19	1	10669
60928	4156	1332418	2004-11-15	2004-11-15	1	12737
2810	186	1551099	1972-11-16	1972-11-16	1	1050
52123	3550	1177480	1994-10-11	1994-11-08	1	9077
18888	1297	738818	1989-11-04	1989-11-18	1	7261
70753	4831	1119510	1991-12-18	1992-01-01	1	8035
65157	4451	738818	1974-12-27	1975-01-03	1	1828
74094	5066	1125315	1982-08-15	1982-09-05	1	4630
58743	4006	1717327	1966-03-09	1966-03-23	1	-1380
76791	5249	1112807	1951-08-21	1951-11-19	1	-6618
38153	2594	1759842	1984-07-30	1984-08-20	1	5345
28091	1905	1118084	2008-08-31	2008-08-31	1	14122
65580	4480	19127890	1983-12-15	1984-12-09	1	5456
35716	2427	1118084	1984-12-23	1984-12-23	1	5470
60616	4134	1713332	1976-02-18	1976-02-25	1	2246
32028	2166	1503184	1983-05-08	1984-05-02	1	5235
24964	1689	1125315	2000-09-20	2000-10-04	1	11234
14001	959	1112807	1962-07-16	1962-07-30	1	-2712
69265	4724	1154343	1945-05-13	1961-03-29	1	-3200
13077	893	920293	1981-10-26	1981-11-02	1	4323
70256	4800	1125315	1977-04-12	1977-04-27	1	2673
25762	1746	933724	2014-06-16	2014-06-23	1	16244
70455	4812	1332418	2011-07-27	2011-07-27	1	15182
32677	2213	1129625	1991-08-01	1991-08-01	1	7882
63106	4312	1125315	1989-09-08	1989-09-29	1	7211
30877	2087	738818	1941-06-07	1941-06-21	1	-10421
21677	1475	1119510	1944-03-05	1944-03-12	1	-9426
74917	5128	1112807	1929-08-25	1929-09-08	1	-14725
20191	1377	1549786	1993-11-30	1994-11-25	1	9094
25000	1691	1112807	1946-01-04	1946-01-18	1	-8749
12464	857	920293	1981-03-30	1981-04-13	2	4120
21931	1493	1713332	1982-10-03	1982-10-24	1	4679
42606	2886	1112807	1963-06-06	1963-08-05	1	-2341
67753	4626	1549786	1990-10-25	1991-10-20	1	7962
68353	4665	19127890	1995-08-12	1998-07-27	3	10434
74071	5065	1119510	1989-02-04	1989-02-11	1	6981
32850	2226	1125315	1945-05-08	1945-05-15	1	-8997
60929	4156	1545958	2006-02-27	2006-02-27	1	13206
2811	186	1551099	1975-01-09	1975-01-09	1	1834
52124	3550	1729720	1988-07-02	1988-07-10	1	6765
18889	1297	920293	2013-09-08	2013-09-15	1	15963
70754	4831	1125315	2015-01-15	2015-01-22	1	16457
65158	4451	1112807	1980-01-11	1980-01-25	1	3676
74095	5066	1125315	2011-06-18	2011-07-02	1	15157
58744	4006	1729720	1993-07-12	1993-07-19	1	8600
76792	5249	1125315	1979-02-02	1979-02-09	1	3326
38154	2594	1125315	1975-07-26	1975-08-09	1	2046
28092	1905	1125315	1986-02-19	1986-02-26	1	5900
65581	4480	1115008	2013-12-29	2014-01-26	1	16096
35717	2427	1125315	1957-07-24	1957-07-31	1	-4537
60617	4134	1112807	1955-06-16	1955-07-21	1	-5278
32495	2202	1119510	1982-08-26	1982-09-09	1	4634
24965	1689	1713332	1973-02-19	1973-03-12	1	1166
14002	959	1124300	1995-01-31	1995-01-31	1	9161
69266	4724	1174888	2008-12-16	2008-12-16	1	14229
13078	893	933724	1981-10-26	1981-11-02	1	4323
70257	4800	1125315	1985-10-16	1985-11-14	2	5796
25763	1746	1102527	2000-03-25	2000-03-25	1	11041
70456	4812	1503184	1975-09-11	1976-09-05	1	2439
32678	2213	1729720	1987-03-19	1987-03-29	1	6296
63107	4312	1551099	1978-06-10	1978-06-10	1	3082
30878	2087	1118084	1956-04-18	1956-04-18	1	-5006
21678	1475	1125315	1980-09-11	1980-09-25	1	3920
74918	5128	1124300	1965-04-23	1965-04-23	1	-1714
20192	1377	1713332	1982-11-18	1982-12-02	1	4718
25001	1691	1118084	1985-07-23	1985-07-23	1	5682
12465	857	933724	1981-03-30	1981-04-13	1	4120
21932	1493	1759842	1964-09-03	1964-09-17	1	-1932
42607	2886	1118084	1983-04-22	1983-04-22	1	4859
67754	4626	1713332	1979-06-30	1979-07-14	1	3481
68354	4665	19127890	1999-07-22	2000-07-16	1	11154
74072	5065	1125315	2002-01-06	2002-01-13	1	11700
32851	2226	1713332	2002-03-19	2002-04-02	1	11779
60930	4156	1545958	2007-12-24	2007-12-24	1	13871
2812	186	1713332	1976-05-28	1976-06-04	1	2346
52125	3550	1729720	2019-05-20	2019-05-29	1	18045
18890	1297	1119510	2000-12-26	2001-01-02	1	11324
71436	4876	1115008	2018-01-19	2018-03-20	1	17610
65159	4451	1125315	1974-12-27	1975-01-03	1	1828
74096	5066	1521369	1981-04-04	1982-03-30	1	4471
67732	4625	1119510	1976-10-23	1976-10-30	1	2494
76793	5249	1322184	2004-04-25	2004-04-25	1	12533
38155	2594	1125315	1977-02-17	1977-02-24	1	2611
28093	1905	1125315	2003-11-28	2003-12-05	1	12391
65582	4480	1125315	1965-09-08	1965-09-22	1	-1562
35718	2427	1125315	1959-10-01	1959-10-15	1	-3731
60618	4134	1112807	1960-09-06	1960-11-05	1	-3344
32496	2202	1125315	1974-01-09	1974-01-23	1	1483
24966	1689	1713332	1993-01-02	1993-01-09	1	8409
14003	959	1125315	1992-04-17	1992-04-24	1	8149
69267	4724	1759842	1977-03-31	1977-04-14	1	2660
13079	893	1112807	1967-01-11	1967-02-01	1	-1065
70258	4800	1729720	1970-12-29	1971-01-09	1	373
25764	1746	1125315	2014-07-10	2014-08-07	1	16289
70457	4812	1539403	2011-07-27	2011-07-27	1	15182
32679	2213	1124957	1974-06-26	1974-06-26	1	1637
63108	4312	1713332	1989-12-20	1989-12-27	1	7300
30879	2087	1125315	1941-06-07	1941-06-21	1	-10421
21679	1475	1557272	2005-02-17	2005-02-17	1	12831
74919	5128	1326303	2017-09-20	2017-09-20	1	17429
20193	1377	1125315	1988-05-13	1988-05-27	1	6721
25002	1691	1125315	1970-06-29	1970-07-13	1	193
12466	857	1112807	1955-02-04	1955-02-18	1	-5431
21933	1493	1125315	1961-11-28	1961-12-12	1	-2942
42608	2886	1125315	1952-08-02	1952-08-16	1	-6347
67755	4626	1713332	1984-04-24	1984-05-15	1	5248
68355	4665	1115008	2003-08-20	2003-09-03	1	12298
74073	5065	1125315	2005-03-15	2005-03-15	1	12857
32852	2226	1729720	2003-11-10	2003-11-17	1	12373
60931	4156	1759842	1966-04-09	1966-04-30	1	-1342
2813	186	1759842	1982-05-10	1982-05-17	1	4519
52126	3550	1778162	1986-05-12	1986-05-26	1	5989
18891	1297	1124300	2014-10-23	2014-10-23	1	16366
71437	4876	1503184	1988-05-10	1990-04-30	2	7424
65160	4451	1174888	1997-03-03	1997-03-03	1	9923
74097	5066	1125315	2015-02-28	2015-03-30	1	16524
67733	4625	1125315	1964-01-28	1964-02-11	1	-2151
38156	2594	1125315	1993-07-03	1993-07-10	1	8591
28094	1905	1361711	1983-08-05	1983-08-05	1	4964
65583	4480	1125315	2016-09-19	2016-09-26	1	17070
35719	2427	1125315	1986-04-23	1986-05-07	1	5970
60619	4134	1125315	2019-05-13	2019-05-20	1	18036
32497	2202	1125315	1997-12-24	1997-12-31	1	10226
24967	1689	1729720	1953-01-07	1953-01-19	1	-6191
14004	959	1729720	1979-01-16	1979-01-27	1	3313
69268	4724	738818	1993-05-14	1993-05-21	1	8541
13080	893	1713332	2014-08-01	2014-08-22	1	16304
70259	4800	1112807	1978-11-30	1979-02-28	1	3345
25765	1746	1125315	2015-06-03	2015-06-24	1	16610
70458	4812	1713332	2011-10-12	2011-11-02	1	15280
32680	2213	1125315	1980-11-15	1980-11-22	1	3978
63109	4312	1729720	1963-08-28	1963-09-10	1	-2305
30880	2087	1125315	1955-09-07	1955-09-21	1	-5216
21680	1475	1713332	1997-12-12	1997-12-19	1	10214
74920	5128	1713332	1930-11-24	1930-12-15	1	-14262
20194	1377	1125315	2008-12-02	2008-12-09	1	14222
25003	1691	1713332	1957-06-14	1957-06-21	1	-4577
12467	857	1118084	1985-10-15	1985-10-15	1	5766
21934	1493	1322184	2016-03-08	2016-03-08	1	16868
42609	2886	1125315	2001-11-27	2002-01-01	1	11688
67756	4626	1118084	2009-11-09	2009-11-09	1	14557
68356	4665	1322184	2009-01-31	2009-01-31	1	14275
74074	5065	1361711	2004-03-02	2005-03-15	1	12857
32853	2226	1112807	1943-05-31	1943-06-14	1	-9698
60932	4156	738818	1992-04-19	1992-04-26	1	8151
4200	287	1125315	1976-10-13	1976-10-20	1	2484
52127	3550	738818	1995-10-03	1995-10-10	1	9413
18892	1297	1125315	1989-11-04	1989-11-18	1	7261
71438	4876	1729720	1977-11-24	1977-12-01	1	2891
65161	4451	1713332	1963-02-11	1963-03-04	1	-2495
74098	5066	920293	2000-05-08	2000-05-15	1	11092
67734	4625	1119510	2003-09-27	2003-10-04	1	12329
38157	2594	1125315	2002-04-25	2002-05-09	1	11816
28095	1905	1728416	1966-07-18	1966-08-01	1	-1249
65584	4480	1503184	1981-12-25	1982-12-20	1	4736
35720	2427	1125315	2004-02-15	2004-02-29	1	12477
60620	4134	1177480	2014-09-23	2014-10-07	1	16350
32498	2202	738818	1997-12-24	1997-12-31	1	10226
24968	1689	1759842	1943-03-26	1943-04-02	1	-9771
14005	959	1759842	2014-10-01	2014-10-22	1	16365
69269	4724	757627	2018-02-28	2018-02-28	1	17590
13081	893	1759842	2018-02-11	2018-03-04	1	17594
70260	4800	1174888	1985-10-16	1985-10-16	1	5767
25766	1746	1729720	1972-01-04	1972-01-11	1	740
70459	4812	1728416	1955-03-12	1955-03-26	1	-5395
32681	2213	1125315	2003-04-05	2003-04-12	1	12154
63110	4312	1759842	1989-12-20	1989-12-27	1	7300
30881	2087	1125315	2004-01-20	2004-02-03	1	12451
26507	1791	1112807	1957-01-13	1957-01-27	1	-4722
74921	5128	1713332	1983-12-07	1984-01-04	1	5116
20195	1377	1515774	1993-11-30	1994-11-25	1	9094
25004	1691	1713332	2000-10-14	2000-11-04	1	11265
12468	857	1125315	1967-04-14	1967-04-21	1	-986
21935	1493	1347450	2016-03-08	2016-03-08	1	16868
42610	2886	1728416	1952-08-02	1952-08-16	1	-6347
67757	4626	1119510	1994-12-08	1994-12-22	1	9121
68357	4665	1713332	1983-01-15	1983-01-22	1	4769
74075	5065	1759842	1969-10-09	1969-10-16	1	-77
32854	2226	1112807	1947-02-11	1947-02-25	1	-8346
60933	4156	1125315	1962-12-12	1963-02-10	1	-2517
4201	287	1125315	2002-05-07	2002-05-21	1	11828
52128	3550	1118084	2016-11-05	2016-11-05	1	17110
18893	1297	1177480	1981-10-26	1981-11-09	1	4330
71439	4876	1759842	1986-10-12	1986-10-19	1	6135
65162	4451	1728416	1955-05-15	1955-05-29	1	-5331
74099	5066	1112807	1983-08-31	1983-10-30	1	5050
67735	4625	1125315	2003-09-27	2003-10-04	1	12329
38158	2594	1177480	1979-09-03	1979-10-03	1	3562
28096	1905	1125315	1973-06-12	1973-06-26	1	1272
65585	4480	1503184	1983-12-15	1984-12-09	1	5456
35721	2427	1768849	1985-10-24	1985-11-07	1	5789
60621	4134	1713332	1980-07-11	1980-08-01	1	3865
32499	2202	1112807	1987-06-30	1987-07-14	1	6403
24969	1689	1125315	1975-02-19	1975-02-26	1	1882
14006	959	1119510	1996-10-18	1996-10-25	1	9794
69270	4724	975125	1953-10-09	1953-10-23	1	-5914
13082	893	19127890	1976-08-01	1977-07-27	1	2764
70261	4800	1729720	1975-03-22	1975-03-29	1	1913
25767	1746	738818	1997-05-30	1997-06-13	1	10025
70460	4812	1729720	1964-02-17	1964-02-26	1	-2136
36138	2458	1112807	1972-03-14	1972-03-28	1	817
63111	4312	19127890	1974-09-14	1975-09-09	1	2077
30882	2087	1125315	2009-08-06	2009-08-13	1	14469
26508	1791	1115008	1997-08-31	1997-09-28	1	10132
74922	5128	920293	1962-09-10	1962-09-17	1	-2663
20196	1377	19127890	1993-11-30	1995-11-20	2	9454
25005	1691	1728416	1950-01-30	1950-02-13	1	-7262
12469	857	1137529	1992-03-15	1992-03-15	1	8109
21936	1493	1759842	1967-06-07	1967-06-28	1	-918
44143	2986	914335	1946-03-12	1946-03-12	1	-8696
67758	4626	1119510	2017-11-16	2017-11-30	1	17500
68358	4665	1759842	1983-01-15	1983-01-22	1	4769
74076	5065	1125315	1984-06-23	1984-07-07	1	5301
32855	2226	1125315	1945-08-29	1945-09-12	1	-8877
60934	4156	1125315	1992-04-19	1992-04-26	1	8151
4202	287	1125315	2014-08-28	2014-09-04	1	16317
52129	3550	1125315	1985-07-16	1985-07-30	1	5689
22564	1533	1102527	2009-03-09	2009-03-09	1	14312
71440	4876	1119510	1994-12-23	1995-01-06	1	9136
65163	4451	1729720	2005-03-22	2005-04-04	1	12877
74100	5066	1115008	1997-08-17	1997-08-31	1	10104
67736	4625	1177480	1977-04-17	1977-05-08	1	2684
38159	2594	1729720	1983-07-30	1983-08-08	1	4967
28097	1905	1125315	1996-12-01	1996-12-15	1	9845
65586	4480	1729720	1995-10-07	1995-10-18	1	9421
35722	2427	1102527	2008-12-20	2008-12-20	1	14233
60622	4134	1713332	2003-09-22	2003-10-13	1	12338
32500	2202	1119510	1997-12-24	1997-12-31	1	10226
24970	1689	1125315	2019-03-28	2019-05-02	1	18018
14007	959	1125315	1969-05-27	1969-06-17	1	-198
69271	4724	975125	1988-06-09	1988-06-23	1	6748
13083	893	738818	2001-01-22	2001-01-29	1	11351
70262	4800	1125315	1973-06-17	1973-07-01	1	1277
25768	1746	920293	2005-01-25	2005-02-01	1	12815
70461	4812	1729720	1986-07-26	1986-08-06	1	6061
36139	2458	1177480	2015-02-28	2015-04-29	1	16554
63112	4312	933724	1987-10-04	1987-10-11	1	6492
30883	2087	1501700	1968-05-30	1968-05-30	1	-581
26509	1791	1125315	1963-05-14	1963-05-21	1	-2417
74923	5128	933724	1962-09-10	1962-09-17	1	-2663
23287	1579	1112807	1959-08-06	1959-08-27	1	-3780
26219	1773	1125315	1988-04-04	1988-05-02	1	6696
12470	857	1309944	1983-09-18	1983-09-18	1	5008
21937	1493	1759842	1982-10-03	1982-10-24	1	4679
44144	2986	1125315	1974-12-02	1974-12-23	1	1817
67759	4626	1177480	2016-05-01	2016-05-31	1	16952
69911	4771	1112807	1958-08-24	1958-09-07	1	-4134
74077	5065	1174888	2005-03-15	2005-03-15	1	12857
32856	2226	1125315	2008-11-23	2008-12-14	1	14227
60935	4156	1361711	2004-11-15	2006-02-27	1	13206
4203	287	1177480	1995-03-05	1995-03-19	1	9208
52130	3550	1125315	1991-07-17	1991-07-24	1	7874
22565	1533	1177480	2017-08-29	2017-09-19	1	17428
71441	4876	1713332	1987-12-28	1988-01-11	1	6584
68121	4649	1125315	2004-05-11	2004-05-18	1	12556
74101	5066	1118084	2011-07-16	2011-07-16	1	15171
67737	4625	1729720	2015-12-28	2016-01-04	1	16804
38160	2594	1738521	1975-07-26	1975-08-09	1	2046
28098	1905	1125315	1997-12-02	1997-12-16	1	10211
65587	4480	1759842	1963-09-23	1963-10-14	1	-2271
35723	2427	1125315	1985-10-24	1985-11-07	1	5789
60623	4134	1729720	1985-08-18	1985-08-29	1	5719
32501	2202	738818	1982-08-26	1982-09-09	1	4634
27435	1852	738818	1974-05-03	1974-05-10	1	1590
14008	959	1759842	1977-05-21	1977-06-11	1	2718
69272	4724	1119510	1996-10-20	1996-10-27	1	9796
13084	893	1119510	2001-01-22	2001-01-29	1	11351
70263	4800	1125315	1974-11-07	1974-11-21	1	1785
25769	1746	920293	2005-04-12	2005-04-19	1	12892
70462	4812	1759842	2011-10-12	2011-11-02	1	15280
36140	2458	1515774	1991-04-14	1992-04-08	1	8133
63113	4312	975125	1973-03-26	1973-04-09	1	1194
30884	2087	1557272	1998-07-01	1998-07-01	1	10408
26510	1791	1125315	1963-11-19	1963-11-26	1	-2228
74924	5128	1102527	2009-12-26	2009-12-26	1	14604
23288	1579	1125315	1965-06-26	1965-07-10	1	-1636
26220	1773	1551099	1965-01-14	1965-01-14	1	-1813
12471	857	1343916	1983-09-18	1983-09-18	1	5008
21938	1493	1125315	2003-12-28	2004-01-11	1	12428
44145	2986	1137529	1990-10-30	1990-10-30	1	7607
67760	4626	1738521	1981-08-28	1981-09-11	1	4271
69912	4771	1124300	1994-09-29	1994-09-29	1	9037
74078	5065	1332418	2004-03-02	2004-03-02	1	12479
32857	2226	1728416	1947-02-11	1947-02-25	1	-8346
60936	4156	1361711	2006-06-26	2007-12-24	1	13871
4204	287	1738521	1977-10-06	1977-10-20	1	2849
52131	3550	1125315	1995-10-03	1995-10-10	1	9413
22566	1533	19127890	1986-12-15	1987-12-10	1	6552
71442	4876	1713332	2004-06-12	2004-07-03	1	12602
68122	4649	1503184	1983-02-07	1984-02-02	1	5145
74102	5066	19127890	1981-04-04	1982-03-30	1	4471
67738	4625	738818	1976-10-23	1976-10-30	1	2494
38161	2594	1768849	1980-11-08	1980-11-22	1	3978
28099	1905	1125315	2018-01-20	2018-02-03	1	17565
65588	4480	19127890	1975-01-28	1976-01-23	1	2213
35724	2427	1177480	1994-06-09	1994-07-07	1	8953
60624	4134	1759842	1976-02-18	1976-02-25	1	2246
32502	2202	1118084	2011-04-20	2011-04-20	1	15084
27436	1852	1112807	1989-05-12	1989-06-02	1	7092
14152	969	1177480	1997-09-24	1997-10-08	1	10142
69273	4724	1125315	1952-12-05	1953-01-09	1	-6201
13085	893	1125315	1954-09-16	1954-09-30	1	-5572
70264	4800	1125315	2001-01-28	2001-02-04	1	11357
25770	1746	933724	2011-05-17	2011-05-24	1	15118
70463	4812	19127890	1981-08-10	1982-01-13	1	4395
36141	2458	1549786	1991-04-14	1992-04-08	1	8133
63114	4312	1125315	1959-12-15	1959-12-29	1	-3656
30885	2087	1729720	1951-06-21	1951-06-29	1	-6761
26511	1791	1125315	1969-12-30	1970-01-13	1	12
74925	5128	1125315	1947-10-22	1947-10-29	1	-8100
23289	1579	1361711	2017-02-23	2017-02-23	1	17220
26221	1773	1713332	1984-09-10	1984-09-24	1	5380
12472	857	1728416	1954-02-20	1954-03-06	1	-5780
21939	1493	1125315	2006-08-09	2006-08-16	1	13376
44146	2986	1729720	1948-05-10	1948-05-17	1	-7899
67761	4626	19127890	1989-10-30	1991-10-20	2	7962
69913	4771	1713332	2006-06-28	2006-07-12	1	13341
74079	5065	1539403	2004-03-02	2004-03-02	1	12479
32858	2226	1759842	2002-03-19	2002-04-02	1	11779
60937	4156	1361711	2008-07-07	2008-07-07	1	14067
4205	287	1759842	2018-05-15	2018-05-29	1	17680
52132	3550	1125315	2012-07-04	2012-07-25	1	15546
22567	1533	1125315	2016-09-29	2016-10-06	1	17080
71443	4876	1759842	2004-06-12	2004-07-03	1	12602
68123	4649	1515774	1990-12-27	1991-12-22	1	8025
75234	5148	1118084	1998-01-21	1998-01-21	1	10247
67739	4625	738818	2003-09-27	2003-10-04	1	12329
38897	2644	1112807	1985-05-28	1985-06-11	1	5640
28100	1905	1332418	1995-03-10	1995-03-10	1	9199
65589	4480	1125315	2013-10-15	2013-10-29	1	16007
35725	2427	1713332	1965-01-15	1965-01-29	1	-1798
60625	4134	1759842	1980-07-11	1980-08-01	1	3865
32503	2202	1125315	1982-08-26	1982-09-09	1	4634
27437	1852	1125315	1974-05-03	1974-05-10	1	1590
14153	969	1713332	1984-07-26	1984-08-09	1	5334
69274	4724	1125315	1993-05-14	1993-05-21	1	8541
13086	893	1125315	2001-01-22	2001-01-29	1	11351
70265	4800	1125315	2005-11-29	2005-12-27	1	13144
25771	1746	1112807	1957-10-16	1958-01-14	1	-4370
74655	5107	1125315	1997-10-05	1997-10-12	1	10146
36142	2458	1713332	2008-05-09	2008-05-23	1	14022
63115	4312	1125315	2019-05-16	2019-05-30	1	18046
30886	2087	1759842	1941-09-15	1941-09-22	1	-10328
26512	1791	1174888	1995-07-08	1995-07-08	1	9319
74926	5128	1125315	1966-08-22	1966-08-29	1	-1221
23290	1579	1729720	1989-03-10	1989-03-20	1	7018
26222	1773	1759842	1984-09-10	1984-09-24	1	5380
12473	857	1125315	1979-02-09	1979-02-23	1	3340
21940	1493	1713332	1964-09-03	1964-09-17	1	-1932
44147	2986	1501700	2015-09-23	2015-09-23	1	16701
67762	4626	1107830	1997-11-21	1997-11-21	1	10186
69914	4771	1729720	1962-07-15	1962-07-28	1	-2714
74080	5065	1545958	2005-03-15	2005-03-15	1	12857
32859	2226	738818	1957-08-11	1957-08-25	1	-4512
60938	4156	1713332	1966-04-09	1966-04-30	1	-1342
4206	287	1125315	1977-10-06	1977-10-20	1	2849
52133	3550	1174888	2005-08-12	2005-08-12	1	13007
22568	1533	1503184	1986-12-15	1987-12-10	1	6552
71444	4876	19127890	1988-05-10	1990-04-30	2	7424
68124	4649	1738521	1971-06-14	1971-06-28	1	543
75235	5148	1125315	1974-09-30	1974-12-28	1	1822
67740	4625	1112807	1974-05-19	1974-06-02	1	1613
38898	2644	1118084	2014-11-19	2014-11-19	1	16393
28101	1905	1521369	1984-01-30	1985-01-24	1	5502
65590	4480	1521369	1981-12-25	1982-12-20	1	4736
35726	2427	1729720	1978-09-17	1978-09-26	1	3190
60626	4134	1759842	2003-09-22	2003-10-13	1	12338
34976	2367	1112807	1975-04-27	1975-05-11	1	1956
27438	1852	1713332	2012-11-02	2012-11-23	1	15667
14154	969	19127890	1992-05-03	1995-04-18	3	9238
69275	4724	1125315	2008-12-16	2009-02-14	2	14289
13087	893	1503184	1976-08-01	1977-07-27	1	2764
70266	4800	1125315	2007-11-14	2007-11-21	1	13838
25772	1746	1118084	1988-04-23	1988-04-23	1	6687
74656	5107	1713332	2015-05-04	2015-05-25	1	16580
36143	2458	1717327	1972-03-14	1972-03-28	1	817
63116	4312	1149380	1963-09-22	1981-09-16	1	4276
30887	2087	1759842	2012-04-02	2012-04-23	1	15453
26513	1791	1177480	2006-06-13	2006-07-04	1	13333
74927	5128	1125315	1983-05-28	1983-06-18	1	4916
23291	1579	738818	1974-08-18	1974-09-01	1	1704
26223	1773	1118084	1986-01-29	1986-01-29	1	5872
12474	857	1149380	1992-03-15	1992-03-15	1	8109
21941	1493	1713332	2006-08-20	2006-09-03	1	13394
44148	2986	1118084	1980-05-24	1980-05-24	1	3796
67763	4626	1125315	1977-02-25	1977-03-11	1	2626
69915	4771	1759842	1957-07-08	1957-07-22	1	-4546
74081	5065	1729720	2000-07-31	2000-08-10	1	11179
32860	2226	1124300	1978-02-03	1978-02-03	1	2955
60939	4156	1118084	1997-03-02	1997-03-02	1	9922
4207	287	1124300	2013-04-25	2013-04-25	1	15820
52780	3598	1112807	1945-01-20	1945-03-21	1	-9052
22569	1533	1759842	1991-02-16	1991-03-02	1	7730
71445	4876	1118084	2013-08-28	2013-08-28	1	15945
68125	4649	920293	2015-03-09	2015-03-16	1	16510
75236	5148	1713332	1966-01-19	1966-04-28	1	-1344
67741	4625	1125315	1976-10-23	1976-10-30	1	2494
38899	2644	1713332	1985-05-28	1985-06-11	1	5640
28102	1905	1539403	1992-03-06	1992-03-06	1	8100
65591	4480	1521369	1983-12-15	1984-12-09	1	5456
35727	2427	1729720	2007-09-06	2007-09-15	1	13771
61227	4176	1112807	1918-10-01	1918-10-15	1	-18706
34977	2367	1125315	1983-03-16	1983-04-13	1	4850
27439	1852	1717327	1974-06-30	1974-07-14	1	1655
14155	969	19127890	1996-04-12	1997-04-07	1	9958
69276	4724	1713332	1977-03-31	1977-04-14	1	2660
13088	893	1728416	1954-09-16	1954-09-30	1	-5572
70267	4800	1177480	1989-07-27	1989-10-25	1	7237
25773	1746	1125315	1996-05-16	1996-05-30	1	9646
74657	5107	1729720	2018-03-02	2018-03-14	1	17604
36144	2458	19127890	1985-05-15	1986-05-10	1	5973
63117	4312	1192710	1962-10-06	1962-10-06	1	-2644
33024	2237	920293	1971-01-13	1971-01-20	1	384
26514	1791	1503184	1974-10-21	1975-10-16	1	2114
74928	5128	1125315	1993-01-11	1993-01-25	1	8425
23292	1579	1112807	1964-04-02	1964-07-01	1	-2010
26224	1773	1125315	1969-12-21	1970-01-04	1	3
12475	857	1713332	1981-02-23	1981-06-15	1	4183
21942	1493	1717327	1961-11-28	1961-12-12	1	-2942
44149	2986	1125315	1958-08-29	1958-09-12	1	-4129
67764	4626	1125315	1979-06-30	1979-07-14	1	3481
69916	4771	1729720	1956-12-05	1956-12-12	1	-4768
74082	5065	1738521	1971-06-01	1971-06-15	1	530
32861	2226	1125315	1957-08-11	1957-08-25	1	-4512
60940	4156	1112807	1960-03-06	1960-03-27	1	-3567
4208	287	1713332	2018-05-15	2018-05-29	1	17680
52781	3598	1118084	1980-07-05	1980-07-05	1	3838
22570	1533	738818	2013-07-22	2013-08-05	1	15922
71446	4876	1125315	1987-12-28	1988-01-11	1	6584
68126	4649	933724	2015-03-09	2015-03-16	1	16510
75237	5148	1717327	1962-10-03	1962-10-17	1	-2633
67742	4625	1115008	2000-01-20	2000-02-17	1	11004
38900	2644	1713332	1988-06-07	1988-06-21	1	6746
28103	1905	1729720	1990-01-27	1990-02-04	1	7339
65592	4480	1713332	1963-09-23	1963-10-14	1	-2271
38360	2609	914335	2018-12-14	2018-12-14	1	17879
61228	4176	1112807	1979-03-27	1979-04-17	1	3393
34978	2367	1118084	2016-04-06	2016-04-06	1	16897
27440	1852	1729720	1978-05-24	1978-06-06	1	3078
14156	969	1125315	1988-07-15	1988-07-29	1	6784
69277	4724	1713332	2014-10-30	2014-11-06	1	16380
13089	893	1177480	2012-06-25	2012-07-09	1	15530
70268	4800	1124300	2009-03-09	2009-03-09	1	14312
25774	1746	1768849	1996-05-16	1996-05-30	1	9646
74658	5107	1124300	2011-05-19	2011-05-19	1	15113
36145	2458	19127890	1988-04-29	1989-04-24	1	7053
63118	4312	1728416	1959-12-15	1959-12-29	1	-3656
33025	2237	933724	1971-01-13	1971-01-20	1	384
26515	1791	1713332	1980-12-27	1981-01-10	1	4027
74929	5128	1125315	1994-11-17	1994-11-24	1	9093
23293	1579	1539403	2017-02-23	2017-02-23	1	17220
26225	1773	1112807	1966-08-07	1966-08-28	1	-1222
12476	857	1729720	1954-07-22	1954-07-30	1	-5634
21943	1493	1759842	2006-08-20	2006-09-03	1	13394
44150	2986	1125315	1978-12-06	1978-12-13	1	3268
67765	4626	1125315	1981-08-28	1981-09-11	1	4271
69917	4771	1778162	1984-08-05	1984-09-02	1	5358
74083	5065	738818	1989-02-04	1989-02-11	1	6981
32862	2226	1729720	1949-08-17	1949-08-27	1	-7432
60941	4156	1119510	1992-04-19	1992-04-26	1	8151
4209	287	1729720	2003-02-16	2003-02-25	1	12108
52782	3598	1125315	1985-02-19	1985-04-20	1	5588
22571	1533	1115008	2009-03-09	2009-04-13	1	14347
71447	4876	1500211	1992-04-19	1993-04-14	1	8504
68127	4649	1112807	1971-06-14	1971-06-28	1	543
75238	5148	1102527	1974-09-30	1974-09-30	1	1733
67743	4625	1118084	2001-10-25	2001-10-25	1	11620
38901	2644	1125315	2018-10-28	2018-11-04	1	17839
28104	1905	933724	2006-03-09	2006-03-16	1	13223
65593	4480	1759842	1997-06-18	1997-07-02	1	10044
38361	2609	1112807	1961-11-12	1961-11-26	1	-2958
61229	4176	1119510	1923-07-09	1923-07-23	1	-16964
34979	2367	1713332	1978-10-17	1978-11-07	1	3232
27441	1852	738818	2001-01-19	2001-01-26	1	11348
14157	969	1125315	1998-11-02	1998-11-30	1	10560
69278	4724	1759842	2014-10-30	2014-11-06	1	16380
13090	893	1115008	1996-01-30	1996-02-20	1	9546
70269	4800	1125315	1983-02-07	1983-02-28	1	4806
25775	1746	920293	2011-05-17	2011-05-24	1	15118
74659	5107	1125315	1987-01-03	1987-01-31	1	6239
36146	2458	738818	1982-05-23	1982-05-30	1	4532
63119	4312	1759842	1990-04-04	1990-04-11	1	7405
33026	2237	1112807	1933-09-09	1933-09-23	1	-13249
26516	1791	1112807	1968-03-21	1968-04-25	1	-616
74930	5128	1125315	2019-05-08	2019-06-07	1	18054
23294	1579	1713332	1993-08-11	1993-08-25	1	8637
26226	1773	1125315	1957-04-26	1957-05-10	1	-4619
13847	949	1125315	1959-11-09	1959-11-16	1	-3699
22716	1541	1112807	1963-09-26	1963-10-10	1	-2275
44151	2986	1713332	1971-09-10	1971-10-01	1	638
67766	4626	1125315	1990-12-14	1990-12-28	1	7666
69918	4771	1759842	2006-06-28	2006-07-12	1	13341
74084	5065	1112807	1971-06-01	1971-06-15	1	530
32863	2226	1729720	1993-11-06	1993-11-19	1	8723
60942	4156	1125315	2006-02-27	2006-02-27	1	13206
4210	287	1713332	1994-08-02	1994-08-09	1	8986
52783	3598	1174888	2014-12-14	2014-12-14	1	16418
22572	1533	1118084	2009-09-10	2009-09-10	1	14497
71448	4876	1521369	1988-05-10	1990-04-30	2	7424
68128	4649	1115008	2010-01-25	2010-02-15	1	14655
75239	5148	1112807	1970-08-22	1970-11-19	1	322
67744	4625	1125315	1975-03-29	1975-06-27	2	2003
38902	2644	1713332	1980-11-07	1980-11-21	1	3977
28105	1905	1125315	2000-10-31	2000-11-21	1	11282
68078	4646	738818	1947-07-03	1947-07-17	1	-8204
38362	2609	1125315	2017-03-02	2017-03-09	1	17234
61230	4176	1119510	1977-09-29	1977-10-06	1	2835
34980	2367	1125315	1978-03-14	1978-03-21	1	3001
27442	1852	1119510	2001-01-19	2001-01-26	1	11348
14158	969	1174888	2004-08-07	2004-08-07	1	12637
69279	4724	19010482	1986-01-05	1986-01-19	1	5862
13091	893	1124300	1993-09-26	1993-09-26	1	8669
71501	4883	1102527	1973-04-24	1973-04-24	1	1209
25776	1746	933724	2002-12-08	2002-12-15	1	12036
74660	5107	1713332	1980-07-10	1980-07-24	1	3857
36147	2458	1118084	2006-03-01	2006-03-01	1	13208
63120	4312	1768849	1982-01-06	1982-01-20	1	4402
33027	2237	1112807	1940-08-10	1940-09-14	1	-10701
26517	1791	1112807	1970-04-15	1970-05-20	1	139
74931	5128	1307863	2017-09-20	2017-09-20	1	17429
23295	1579	1713332	2007-02-21	2007-03-07	1	13579
26227	1773	1125315	1992-01-12	1992-02-16	1	8081
13848	949	1137529	1983-08-29	1983-08-29	1	4988
22717	1541	1125315	1983-03-13	1983-03-27	1	4833
44152	2986	1729720	1949-10-12	1949-10-24	1	-7374
67767	4626	1125315	2016-05-01	2016-05-01	1	16922
69919	4771	920293	1981-03-25	1981-04-08	2	4115
74085	5065	1125315	1989-02-04	1989-02-11	1	6981
33128	2244	1124957	1975-03-22	1975-03-22	1	1906
60943	4156	1125315	2007-12-24	2007-12-24	1	13871
4211	287	1729720	1978-01-04	1978-01-17	1	2938
52784	3598	1545958	2014-12-14	2014-12-14	1	16418
22573	1533	1125315	1983-10-24	1983-10-31	1	5051
71449	4876	1713332	1991-11-21	1991-12-12	1	8015
68129	4649	1124300	2003-05-28	2003-05-28	1	12200
75240	5148	1503184	1978-01-21	1979-01-16	1	3302
67745	4625	1125315	1981-11-13	1981-12-04	1	4355
38903	2644	1713332	2004-03-20	2004-03-27	1	12504
28106	1905	1322184	1999-12-17	1999-12-17	1	10942
68079	4646	738818	2001-09-20	2001-10-04	1	11599
38363	2609	1309944	2018-12-14	2018-12-14	1	17879
61231	4176	1119510	1983-05-01	1983-05-15	1	4882
34981	2367	1125315	1990-01-06	1990-01-27	1	7331
27443	1852	1125315	1974-06-30	1974-07-14	1	1655
14159	969	1322184	2014-12-07	2014-12-07	1	16411
69782	4760	738818	1974-12-08	1974-12-22	1	1816
13092	893	1125315	1963-08-31	1963-09-07	1	-2308
71502	4883	1112807	1947-06-14	1947-06-28	1	-8223
25777	1746	1125315	1953-10-09	1953-11-06	1	-5900
74661	5107	1125315	1980-07-10	1980-07-24	1	3857
36148	2458	1125315	2016-12-19	2017-01-02	1	17168
63121	4312	1115008	1999-04-10	1999-05-01	1	10712
33028	2237	1177480	2005-10-29	2005-12-28	1	13145
26518	1791	1119510	2005-07-07	2005-07-14	1	12978
74932	5128	1557272	1997-02-19	1997-02-19	1	9911
23296	1579	1759842	2008-05-05	2008-05-12	1	14011
26228	1773	1129625	1954-09-15	1954-09-15	1	-5587
13849	949	1759842	2012-08-26	2012-09-02	1	15585
22718	1541	1503184	1982-03-30	1983-03-25	1	4831
44153	2986	1125315	2018-06-05	2018-06-19	1	17701
67768	4626	1759842	1984-04-24	1984-05-15	1	5248
69920	4771	933724	1981-03-25	1981-04-08	1	4115
74086	5065	1729720	1993-01-26	1993-02-04	1	8435
33129	2244	1125315	1962-02-08	1962-02-22	1	-2870
60944	4156	1125315	2017-12-24	2017-12-31	1	17531
4212	287	1729720	1993-07-01	1993-07-09	1	8590
52785	3598	1729720	1963-02-03	1963-02-15	1	-2512
22574	1533	1125315	2013-07-22	2013-08-05	1	15922
71450	4876	1729720	1987-04-24	1987-05-06	1	6334
68130	4649	1125315	1970-02-05	1970-02-19	1	49
75241	5148	1521369	1978-01-21	1979-01-16	1	3302
67746	4625	1125315	1985-08-24	1985-08-31	1	5721
38904	2644	1759842	2004-03-20	2004-03-27	1	12504
28107	1905	1729720	1980-01-09	1980-01-17	1	3668
68080	4646	1118084	1986-12-15	1986-12-15	1	6192
38364	2609	738818	1960-07-21	1960-07-28	1	-3444
61232	4176	1125315	1945-03-07	1945-03-14	1	-9059
34982	2367	1125315	2003-04-01	2003-04-08	1	12150
27444	1852	1125315	2001-01-19	2001-01-26	1	11348
14160	969	1515774	1993-04-28	1995-04-18	2	9238
69783	4760	1112807	1956-10-16	1956-11-22	1	-4788
13093	893	1521369	1976-08-01	1977-07-27	1	2764
71503	4883	1112807	1947-12-11	1948-01-01	1	-8036
25778	1746	1125315	1954-04-08	1954-04-22	1	-5733
74662	5107	1125315	1981-12-02	1981-12-30	1	4381
36149	2458	1177480	1996-05-05	1996-06-09	1	9656
63122	4312	1125315	2005-09-02	2005-09-16	1	13042
33029	2237	1361711	2005-12-04	2005-12-04	1	13121
26519	1791	1125315	1975-04-25	1975-05-02	1	1947
74933	5128	1713332	2005-08-12	2005-09-02	1	13028
23297	1579	1118084	1988-03-11	1988-03-11	1	6644
26229	1773	1551099	1967-10-04	1967-10-04	1	-820
13850	949	1759842	2018-01-13	2018-01-27	1	17558
22719	1541	1521369	1982-03-30	1983-03-25	1	4831
44154	2986	1149380	1990-10-30	1990-10-30	1	7607
67769	4626	738818	1994-12-08	1994-12-22	1	9121
69921	4771	1124957	1984-08-05	1984-08-05	1	5330
74087	5065	1322184	2004-03-02	2005-03-15	1	12857
33130	2244	1125315	1975-03-22	1975-05-21	2	1966
60945	4156	1539403	2004-11-15	2004-11-15	1	12737
4213	287	1759842	1994-08-02	1994-08-09	1	8986
52786	3598	1125315	2004-03-21	2004-04-04	1	12512
22575	1533	1549786	1989-11-29	1990-11-24	1	7632
71451	4876	1759842	1991-11-21	1991-12-12	1	8015
68131	4649	1125315	2015-03-01	2015-03-15	1	16509
75242	5148	1759842	1966-01-19	1966-04-28	1	-1344
67747	4625	1174888	1975-03-29	1975-03-29	1	1913
38905	2644	1119510	2006-05-26	2006-06-02	1	13301
28108	1905	1729720	2010-04-04	2010-04-16	1	14715
68081	4646	1119510	2001-09-20	2001-10-04	1	11599
38365	2609	1112807	1961-04-16	1961-05-07	1	-3161
61233	4176	1125315	2010-02-02	2010-02-09	1	14649
34983	2367	1729720	2018-06-26	2018-07-08	1	17720
27445	1852	1125315	2011-09-05	2011-09-26	1	15243
14161	969	1515774	1996-04-12	1997-04-07	1	9958
69784	4760	1125315	1971-03-04	1971-03-11	1	434
13094	893	1713332	2018-02-11	2018-03-04	1	17594
71504	4883	1112807	1973-04-24	1973-06-23	1	1269
25779	1746	1125315	1957-07-07	1957-07-21	1	-4547
74663	5107	1125315	1984-05-21	1984-06-04	1	5268
36150	2458	1729720	1975-09-25	1975-10-08	1	2106
63123	4312	1154343	1963-09-22	1981-09-16	1	4276
33030	2237	1112807	1931-10-27	1931-11-10	1	-13932
26520	1791	1729720	1955-08-24	1955-08-31	1	-5237
74934	5128	1713332	2018-09-27	2018-10-18	1	17822
23298	1579	1125315	1974-08-18	1974-09-01	1	1704
26230	1773	1728416	1957-04-26	1957-05-10	1	-4619
13851	949	1112807	1961-01-30	1961-02-13	1	-3244
22720	1541	1118084	2007-02-07	2007-02-07	1	13551
44155	2986	1343916	1946-03-12	1946-03-12	1	-8696
67770	4626	738818	2017-11-16	2017-11-30	1	17500
69922	4771	1125315	1971-06-17	1971-07-15	1	560
74088	5065	1713332	1969-10-09	1969-10-16	1	-77
33131	2244	1326303	2017-10-13	2017-10-13	1	17452
60946	4156	1729720	1958-10-29	1958-11-07	1	-4073
7231	499	738818	2009-12-25	2010-01-01	1	14610
52787	3598	1125315	2006-01-30	2006-03-06	1	13213
22576	1533	1713332	1991-02-16	1991-03-02	1	7730
71452	4876	738818	1994-12-23	1995-01-06	1	9136
68132	4649	1549786	1989-01-06	1990-01-01	1	7305
75243	5148	1177480	1975-09-16	1975-09-30	1	2098
67748	4625	1177480	1991-07-15	1991-08-05	1	7886
38906	2644	1125315	2006-05-26	2006-06-02	1	13301
28109	1905	1738521	1972-01-30	1972-02-13	1	773
68082	4646	1125315	1945-09-22	1945-09-29	1	-8860
38366	2609	1343916	2018-12-14	2018-12-14	1	17879
61234	4176	1713332	1981-01-09	1981-01-23	1	4040
34984	2367	1759842	1978-10-17	1978-11-07	1	3232
27446	1852	1177480	1977-04-26	1977-05-10	1	2686
14162	969	1729720	1979-05-05	1979-05-18	1	3424
69785	4760	1125315	1972-07-31	1972-10-29	2	1032
13095	893	1759842	2014-08-01	2014-08-22	1	16304
71505	4883	1125315	2004-08-23	2004-08-30	1	12660
25780	1746	1125315	1958-07-15	1958-07-29	1	-4174
74664	5107	1759842	2015-05-04	2015-05-25	1	16580
36151	2458	19127890	1991-04-14	1992-04-08	1	8133
63124	4312	1177480	1982-01-06	1982-01-20	1	4402
33031	2237	1112807	1943-10-29	1943-11-19	1	-9540
26521	1791	1729720	1966-02-19	1966-03-03	1	-1400
74935	5128	1759842	2005-08-12	2005-09-02	1	13028
23299	1579	1125315	2000-11-30	2000-12-07	1	11298
26231	1773	1125315	1982-08-01	1982-08-08	1	4602
13852	949	1125315	1990-03-09	1990-03-23	1	7386
22721	1541	1125315	1982-01-19	1982-02-16	1	4429
44156	2986	1759842	1971-09-10	1971-10-01	1	638
67771	4626	1125315	1982-01-31	1982-02-07	1	4420
69923	4771	1125315	1984-08-05	1984-09-02	2	5358
75278	5151	1112807	1969-09-09	1969-10-14	1	-79
33132	2244	1112807	1966-08-15	1966-09-14	1	-1205
62998	4304	723013	1981-10-18	1982-04-25	1	4497
7232	499	975125	1969-07-29	1969-08-19	1	-135
52788	3598	920293	1978-04-20	1978-05-04	2	3045
22577	1533	19127890	1989-11-29	1990-11-24	1	7632
71453	4876	1125315	1994-12-23	1995-01-06	1	9136
68133	4649	1549786	1990-12-27	1991-12-22	1	8025
75244	5148	1112807	1962-10-03	1962-10-17	1	-2633
71231	4861	1124300	1989-05-14	1989-05-14	1	7073
38907	2644	1759842	1988-06-07	1988-06-21	1	6746
28110	1905	19127890	1984-01-30	1985-01-24	1	5502
68083	4646	1125315	2001-09-20	2001-10-04	1	11599
38367	2609	1717327	1961-11-12	1961-11-26	1	-2958
61235	4176	1112807	1920-04-23	1920-06-22	1	-18090
34985	2367	1125315	1986-09-20	1986-10-04	1	6120
27447	1852	1729720	1976-07-22	1976-07-29	1	2401
14163	969	1125315	2004-08-07	2004-10-06	2	12697
69786	4760	1125315	1974-12-08	1974-12-22	1	1816
15432	1073	1112807	1936-11-22	1936-12-06	1	-12079
71506	4883	1125315	2006-03-11	2006-03-18	1	13225
25781	1746	1125315	1967-10-13	1967-10-20	1	-804
75358	5157	1112807	1963-11-07	1963-11-21	1	-2233
36152	2458	1125315	1981-09-23	1981-10-21	1	4311
63125	4312	1503184	1974-09-14	1975-09-09	1	2077
33032	2237	1119510	1968-02-05	1968-02-19	1	-682
26522	1791	19127890	1974-10-21	1975-10-16	1	2114
74936	5128	1759842	2018-09-27	2018-10-18	1	17822
23300	1579	1347450	1999-04-29	1999-04-29	1	10710
26232	1773	1729720	1959-07-19	1959-07-29	1	-3809
13853	949	1115008	2005-06-22	2005-07-13	1	12977
22722	1541	1125315	1996-01-08	1996-01-22	1	9517
45412	3082	914335	1988-05-04	1988-05-04	1	6698
67772	4626	1125315	1994-12-08	1994-12-22	1	9121
69924	4771	1713332	1957-07-08	1957-07-22	1	-4546
75279	5151	1125315	1957-11-27	1958-01-10	2	-4390
33133	2244	1307863	2017-10-13	2017-10-13	1	17452
62999	4304	738818	1967-05-11	1967-05-25	1	-952
7233	499	1112807	1961-12-09	1961-12-23	1	-2931
52789	3598	933724	1978-04-20	1978-05-04	1	3045
22578	1533	1119510	2013-07-22	2013-08-05	1	15922
71454	4876	1713332	1986-10-12	1986-10-19	1	6135
68134	4649	1713332	1982-05-10	1982-05-31	1	4533
75245	5148	1177480	1996-05-07	1996-07-06	1	9683
71232	4861	1154343	1982-06-02	1982-06-02	1	4535
38908	2644	738818	2006-05-26	2006-06-02	1	13301
28111	1905	920293	2006-03-09	2006-03-16	1	13223
68084	4646	1125315	2010-04-22	2010-05-06	1	14735
38368	2609	1759842	1966-07-14	1966-07-28	1	-1253
61236	4176	1112807	1942-12-08	1943-01-05	1	-9858
34986	2367	1125315	1999-09-04	1999-09-18	1	10852
27448	1852	1115008	2018-10-29	2018-11-12	1	17847
14164	969	1347450	2014-12-07	2014-12-07	1	16411
69787	4760	1177480	2012-11-28	2012-12-19	1	15693
15433	1073	1112807	1964-10-10	1964-11-14	1	-1874
71507	4883	1729720	1954-01-12	1954-01-21	1	-5824
25782	1746	1125315	1997-05-30	1997-06-13	1	10025
75359	5157	1112807	1966-12-08	1966-12-22	1	-1106
36153	2458	1125315	1982-05-23	1982-05-30	1	4532
63126	4312	1713332	1990-04-04	1990-04-11	1	7405
33033	2237	1125315	1936-05-05	1936-05-12	1	-12287
26523	1791	920293	2011-12-12	2011-12-19	1	15327
74937	5128	914335	1955-07-27	1955-07-27	1	-5272
23301	1579	1119510	1974-08-18	1974-09-01	1	1704
27477	1854	1125315	1973-06-21	1973-07-05	1	1281
13854	949	1125315	1960-01-06	1960-01-20	1	-3634
22723	1541	1729720	1972-08-04	1972-08-16	1	958
45413	3082	1125315	1967-12-22	1968-01-05	1	-727
67773	4626	1125315	2007-01-05	2007-01-12	1	13525
69925	4771	1728416	1958-08-24	1958-09-07	1	-4134
75280	5151	1125315	2005-10-31	2005-11-14	1	13101
33134	2244	1118084	1993-09-27	1993-09-27	1	8670
63000	4304	1125315	1988-05-03	1988-05-17	1	6711
7234	499	1119510	1973-05-20	1973-06-03	1	1249
52790	3598	1112807	1948-07-28	1948-08-11	1	-7813
22579	1533	1515774	1989-11-29	1990-11-24	1	7632
72948	4986	920293	2000-05-22	2000-05-29	1	11106
68135	4649	1738521	1970-02-05	1970-02-19	1	49
75246	5148	1717327	1975-09-16	1975-09-30	1	2098
71233	4861	1557272	2007-05-22	2007-05-22	1	13655
38909	2644	1125315	1980-11-07	1980-11-21	1	3977
28112	1905	1125315	1972-01-30	1972-02-13	1	773
68085	4646	1326303	2001-10-02	2001-10-02	1	11597
38369	2609	705944	1967-04-30	1976-05-07	1	2318
61237	4176	1322184	2003-10-23	2003-10-23	1	12348
34987	2367	1125315	2004-05-04	2004-05-11	1	12549
27449	1852	1125315	2016-10-29	2016-11-19	1	17124
14165	969	1503184	1992-05-03	1993-04-28	1	8518
69788	4760	1322184	2018-03-28	2018-03-28	1	17618
15434	1073	1713332	1995-12-21	1996-01-11	1	9506
71508	4883	1124300	1986-03-31	1986-03-31	1	5933
25783	1746	1728416	1958-07-15	1958-07-29	1	-4174
75360	5157	1124300	2000-08-19	2000-08-19	1	11188
36154	2458	1521369	1985-05-15	1986-05-10	1	5973
63127	4312	1717327	1963-04-09	1963-04-23	1	-2445
33034	2237	1125315	1960-06-15	1960-06-29	1	-3473
26524	1791	1115008	1996-08-01	1996-09-05	1	9744
74938	5128	1112807	1943-05-14	1943-05-28	1	-9715
23302	1579	1125315	2013-05-29	2013-07-03	1	15889
27478	1854	1125315	1992-08-17	1992-08-24	1	8271
13855	949	1125315	2005-10-17	2005-10-31	1	13087
22724	1541	1717327	1963-09-26	1963-10-10	1	-2275
45414	3082	1515774	1994-05-21	1995-05-16	1	9266
67774	4626	1125315	2017-11-16	2017-11-30	1	17500
72810	4976	933724	1941-12-19	1941-12-26	1	-10233
75281	5151	1177480	1987-04-13	1987-04-27	1	6325
33135	2244	1125315	1972-04-15	1972-05-06	1	856
63001	4304	1729720	1996-05-24	1996-06-03	1	9650
7235	499	1125315	1976-06-19	1976-07-03	1	2375
52791	3598	1125315	1950-05-25	1950-06-01	1	-7154
22580	1533	1521369	1986-12-15	1987-12-10	1	6552
72949	4986	1112807	1951-08-16	1951-08-30	1	-6699
68136	4649	1759842	1982-05-10	1982-05-31	1	4533
75247	5148	19127890	1978-01-21	1979-01-16	1	3302
71234	4861	1759842	1956-07-16	1956-07-30	1	-4903
41975	2845	920293	2009-10-28	2009-11-04	1	14552
28113	1905	1503184	1984-01-30	1985-01-24	1	5502
68086	4646	1713332	1970-09-23	1971-01-13	1	377
38370	2609	1112807	1960-03-22	1960-04-21	1	-3542
61238	4176	738818	1977-09-29	1977-10-06	1	2835
36311	2469	1112807	1971-10-30	1971-11-13	1	681
27450	1852	1738521	1976-09-25	1976-10-09	1	2473
14166	969	1549786	1993-04-28	1995-04-18	2	9238
69789	4760	1713332	2015-11-04	2015-12-02	1	16771
15435	1073	1759842	1944-11-25	1944-12-16	1	-9147
71509	4883	1125315	1975-06-13	1975-07-04	1	2010
25784	1746	1729720	1962-06-28	1962-07-08	1	-2734
75361	5157	1521369	1984-03-01	1985-02-24	1	5533
36155	2458	1521369	1988-04-29	1989-04-24	1	7053
63128	4312	738818	1994-04-02	1994-04-16	1	8871
33035	2237	1125315	1991-03-17	1991-05-16	1	7805
26525	1791	1124300	1992-01-05	1992-01-05	1	8039
74939	5128	1177480	2008-01-08	2008-02-05	1	13914
23303	1579	1322184	1999-04-29	1999-04-29	1	10710
27479	1854	1125315	2006-04-26	2006-07-25	1	13354
13856	949	1149380	1983-08-29	1983-08-29	1	4988
22725	1541	1729720	1966-12-20	1967-01-01	1	-1096
45415	3082	1125315	1998-03-28	1998-04-27	1	10343
67775	4626	1343916	1997-11-21	1997-11-21	1	10186
72811	4976	1112807	1917-08-16	1917-11-14	1	-19041
75282	5151	1361711	2017-01-27	2017-01-27	1	17193
33136	2244	1125315	1993-01-16	1993-02-06	1	8437
63002	4304	1759842	1968-07-08	1968-07-15	1	-535
7236	499	1125315	1987-02-26	1987-03-12	1	6279
52792	3598	1322184	1997-04-13	2014-12-14	1	16418
22581	1533	1713332	2009-03-09	2009-04-13	1	14347
72950	4986	1125315	1965-03-05	1965-03-26	1	-1742
68137	4649	19127890	1983-02-07	1984-02-02	1	5145
1878	124	1119510	1998-03-11	1998-03-25	1	10310
71235	4861	1112807	1948-04-23	1948-05-08	1	-7908
41976	2845	1125315	2014-02-10	2014-02-24	1	16125
29963	2027	1112807	1968-02-09	1968-03-15	1	-657
68087	4646	1112807	1946-09-16	1946-09-30	1	-8494
38371	2609	1118084	1993-07-12	1993-07-12	1	8593
61239	4176	738818	1983-05-01	1983-05-15	1	4882
36312	2469	1112807	1981-09-07	1981-10-12	1	4302
27451	1852	1119510	1974-05-03	1974-05-10	1	1590
14167	969	1549786	1996-04-12	1997-04-07	1	9958
69790	4760	1729720	1968-09-06	1968-09-17	1	-471
15436	1073	738818	1966-11-24	1966-12-01	1	-1127
71510	4883	1125315	1987-05-17	1987-05-24	1	6352
25785	1746	1729720	1997-08-09	1997-08-20	1	10093
75362	5157	1717327	1963-11-07	1963-11-21	1	-2233
36156	2458	1759842	2008-05-09	2008-05-23	1	14022
63129	4312	975125	1966-11-23	1966-12-07	1	-1121
33036	2237	1557272	1999-10-24	1999-10-24	1	10888
26526	1791	1125315	1988-06-07	1988-06-21	1	6746
74940	5128	1177480	2009-12-26	2010-01-25	1	14634
23304	1579	1322184	2017-02-23	2017-02-23	1	17220
27480	1854	1125315	2015-02-08	2015-02-08	1	16474
13857	949	1713332	1992-04-25	1992-05-02	1	8157
22726	1541	19127890	1982-03-30	1983-03-25	1	4831
45416	3082	1174888	1980-03-02	1980-03-02	1	3713
67776	4626	1521369	1989-10-30	1990-10-25	1	7602
72812	4976	1115008	1995-01-25	1995-02-15	1	9176
75283	5151	1713332	1973-12-24	1973-12-31	1	1460
33137	2244	1728416	1954-07-19	1954-08-02	1	-5631
63003	4304	1125315	1967-05-11	1967-05-25	1	-952
7237	499	1125315	1997-03-17	1997-03-31	1	9951
52793	3598	1332418	1996-04-07	1996-04-07	1	9593
22582	1533	1729720	2014-08-27	2014-09-03	1	16316
72951	4986	1125315	1979-03-13	1979-04-10	1	3386
68138	4649	1125315	1984-05-06	1984-06-05	1	5269
1879	124	1125315	1989-09-12	1989-09-26	1	7208
71236	4861	1125315	1994-01-22	1994-02-21	1	8817
41977	2845	1713332	1973-07-13	1973-07-20	1	1296
29964	2027	1119510	2019-01-04	2019-01-18	1	17914
68088	4646	1125315	1947-07-03	1947-07-17	1	-8204
38372	2609	1119510	1960-07-21	1960-07-28	1	-3444
61240	4176	1112807	1927-11-13	1927-11-27	1	-15376
36313	2469	1713332	1992-08-28	1992-09-04	1	8282
27452	1852	1124300	2007-05-18	2007-05-18	1	13651
14168	969	1118084	2014-07-17	2014-07-17	1	16268
69791	4760	1118084	1995-03-06	1995-03-06	1	9195
15437	1073	738818	2006-01-25	2006-02-01	1	13180
71511	4883	1112807	1951-07-14	1951-08-18	1	-6711
25786	1746	1729720	2014-03-27	2014-04-09	1	16169
75363	5157	1717327	1965-02-11	1965-02-25	1	-1771
36157	2458	1115008	2003-03-05	2003-04-02	1	12144
63130	4312	975125	1971-07-19	1971-08-02	1	578
33037	2237	1713332	1971-12-29	1972-01-12	1	741
26527	1791	1521369	1974-10-21	1975-10-16	1	2114
74941	5128	1310149	2017-09-20	2017-09-20	1	17429
23305	1579	1332418	2017-02-23	2017-02-23	1	17220
27481	1854	1149380	1972-11-09	1993-01-05	1	8405
13858	949	1713332	2001-09-19	2001-10-03	1	11598
25031	1695	738818	2007-02-27	2007-03-13	1	13585
45417	3082	1309944	1988-05-04	1988-05-04	1	6698
71838	4909	1177480	1975-07-16	1975-07-30	1	2036
72813	4976	1125315	1920-11-10	1920-11-17	1	-17942
75284	5151	1728416	1957-12-27	1958-01-10	1	-4374
33138	2244	1759842	1968-02-10	1968-02-24	1	-677
63004	4304	1125315	1993-10-30	1993-11-06	1	8710
7238	499	1154343	1962-04-30	1962-04-30	1	-2803
52794	3598	1361711	2015-05-31	2015-05-31	1	16586
24066	1627	920293	1977-10-12	1977-10-19	1	2848
72952	4986	705944	1960-04-20	1968-04-28	1	-613
68139	4649	1515774	1989-01-06	1990-01-01	1	7305
1880	124	1149380	1986-03-12	1986-03-12	1	5914
71237	4861	1149380	1982-06-02	1982-06-02	1	4535
41978	2845	920293	2015-11-28	2015-12-05	1	16774
29965	2027	1125315	1963-04-16	1963-04-30	1	-2438
68089	4646	1759842	1970-09-23	1971-01-13	1	377
38373	2609	1125315	1960-07-21	1960-07-28	1	-3444
61241	4176	1125315	1977-09-29	1977-10-06	1	2835
36314	2469	1759842	1992-08-28	1992-09-04	1	8282
27453	1852	1177480	1976-09-25	1976-10-09	1	2473
14169	969	1521369	1992-05-03	1993-04-28	1	8518
69792	4760	1119510	1986-07-21	1986-07-28	1	6052
15438	1073	1115008	2004-06-17	2004-07-22	1	12621
71512	4883	1125315	1983-03-24	1983-04-14	1	4851
26549	1793	1112807	1919-07-07	1919-09-05	1	-18381
75364	5157	1759842	2004-11-04	2004-11-18	1	12740
36158	2458	1119510	1982-05-23	1982-05-30	1	4532
63131	4312	1124300	1995-07-29	1995-07-29	1	9340
33038	2237	1729720	1955-10-18	1955-10-31	1	-5176
26528	1791	1728416	1957-01-13	1957-01-27	1	-4722
74942	5128	1713332	1935-11-26	1935-12-10	1	-12441
23306	1579	1713332	2008-05-05	2008-05-12	1	14011
27482	1854	1503184	1989-10-04	1990-09-29	1	7576
13859	949	1728416	1960-01-06	1960-01-20	1	-3634
25032	1695	933724	2018-02-01	2018-02-08	1	17570
45418	3082	1343916	1988-05-04	1988-05-04	1	6698
71839	4909	1177480	1978-04-14	1978-04-28	1	3039
72814	4976	1125315	1950-12-05	1950-12-19	1	-6953
75285	5151	1125315	1983-10-14	1983-10-21	1	5041
33139	2244	1125315	1954-07-19	1954-08-02	1	-5631
63005	4304	1713332	1968-07-08	1968-07-15	1	-535
7239	499	975125	1964-09-07	1964-09-21	1	-1928
52795	3598	1539403	1996-04-07	1996-04-07	1	9593
24067	1627	933724	1972-08-20	1972-08-27	1	969
72953	4986	1125315	1959-07-23	1959-08-06	1	-3801
68140	4649	1521369	1983-02-07	1984-02-02	1	5145
1881	124	1177480	2001-05-06	2001-06-03	1	11476
71238	4861	1177480	2008-05-09	2008-06-08	1	14038
41979	2845	933724	2015-11-28	2015-12-05	1	16774
29966	2027	1112807	1965-09-06	1965-09-20	1	-1564
68090	4646	1119510	1947-07-03	1947-07-17	1	-8204
38374	2609	1125315	1967-08-04	1967-08-25	1	-860
61242	4176	1125315	1979-01-01	1979-01-15	1	3301
36315	2469	19127890	1988-07-12	1989-07-07	1	7127
27454	1852	1713332	2018-10-29	2018-11-12	1	17847
14170	969	1759842	1984-07-26	1984-08-09	1	5334
69793	4760	1125315	1969-05-18	1969-07-17	1	-168
15439	1073	1119510	2006-01-25	2006-02-01	1	13180
71513	4883	1125315	2008-08-15	2008-08-29	1	14120
26550	1793	1119510	1934-04-14	1934-04-28	1	-13032
75365	5157	1112807	1976-03-28	1976-04-11	1	2292
36159	2458	1503184	1985-05-15	1986-05-10	1	5973
63132	4312	1125315	1982-10-16	1982-10-23	1	4678
33039	2237	920293	1968-12-03	1968-12-17	2	-380
26529	1791	738818	2005-07-07	2005-07-14	1	12978
74943	5128	1759842	1935-11-26	1935-12-10	1	-12441
23307	1579	1759842	1993-08-11	1993-08-25	1	8637
27483	1854	1713332	2015-02-08	2015-03-08	1	16502
13860	949	1759842	1992-04-25	1992-05-02	1	8157
25033	1695	1119510	2007-02-27	2007-03-13	1	13585
45419	3082	1503184	1984-07-05	1987-06-20	3	6379
71840	4909	1515774	1992-05-27	1993-05-22	1	8542
72815	4976	1125315	1981-06-05	1981-06-19	1	4187
75286	5151	1729720	1958-11-23	1958-12-02	1	-4048
33140	2244	1125315	1976-01-16	1976-01-23	1	2213
63006	4304	740275	1979-10-07	1980-03-16	1	3727
7240	499	1551099	1959-10-21	1959-10-21	1	-3725
52796	3598	1713332	1964-01-07	1964-01-28	1	-2165
24068	1627	933724	1977-10-12	1977-10-19	1	2848
72954	4986	1310149	2001-04-29	2001-04-29	1	11441
68141	4649	19127890	1989-01-06	1990-01-01	1	7305
1882	124	1343916	1987-04-02	1987-04-02	1	6300
71239	4861	1713332	2012-07-05	2012-07-26	1	15547
41980	2845	1112807	1961-03-24	1961-04-14	1	-3184
29967	2027	1118084	2002-03-27	2002-03-27	1	11773
68091	4646	1125315	1986-06-11	1986-06-25	1	6019
38375	2609	1713332	1966-07-14	1966-07-28	1	-1253
61243	4176	1125315	1983-05-01	1983-05-15	1	4882
36316	2469	738818	1993-08-14	1993-08-28	1	8640
27455	1852	1759842	2012-11-02	2012-11-23	1	15667
18413	1267	1125315	1955-10-21	1955-10-28	1	-5179
69794	4760	1125315	1985-06-28	1985-07-12	1	5671
15440	1073	1124300	1974-04-02	1974-04-02	1	1552
71514	4883	1728416	1947-06-14	1947-06-28	1	-8223
26551	1793	1124957	1943-04-02	1943-04-02	1	-9771
75366	5157	1125315	1974-02-12	1974-03-14	1	1533
36160	2458	1503184	1988-04-29	1989-04-24	1	7053
63133	4312	1125315	1994-04-02	1994-04-16	1	8871
33040	2237	933724	1968-12-03	1968-12-17	1	-380
26530	1791	933724	2011-12-12	2011-12-19	1	15327
74944	5128	1112807	1930-04-15	1930-04-29	1	-14492
23308	1579	1759842	2007-02-21	2007-03-07	1	13579
27484	1854	933724	2009-02-03	2009-02-10	1	14285
13861	949	1759842	2001-09-19	2001-10-03	1	11598
25034	1695	1124300	2010-05-03	2010-05-03	1	14732
45420	3082	1515774	1992-05-24	1993-05-19	1	8539
71841	4909	1717327	1975-07-16	1975-07-30	1	2036
72816	4976	1174888	1952-10-09	1952-10-09	1	-6293
75287	5151	1729720	1961-11-18	1961-11-28	1	-2956
33141	2244	1310149	2017-10-13	2017-10-13	1	17452
63007	4304	1118084	2002-02-19	2002-02-19	1	11737
7241	499	1759842	1962-08-27	1962-09-17	1	-2663
52797	3598	1728416	1947-10-07	1947-10-21	1	-8108
24069	1627	1112807	1955-09-13	1955-09-27	1	-5210
72955	4986	1713332	2005-02-07	2005-02-21	1	12835
68142	4649	19127890	1990-12-27	1991-12-22	1	8025
1883	124	1713332	1984-09-07	1984-09-14	1	5370
71240	4861	1759842	1955-07-24	1955-09-11	1	-5226
41981	2845	1125315	1961-01-19	1961-02-02	1	-3255
29968	2027	1125315	1961-08-15	1961-08-22	1	-3054
68092	4646	1307863	2001-10-02	2001-10-02	1	11597
38376	2609	1713332	1993-12-04	1993-12-18	1	8752
61244	4176	1347450	2003-10-23	2003-10-23	1	12348
36317	2469	933724	1988-09-03	1988-09-10	1	6827
28923	1958	1115008	1996-02-25	1996-03-10	1	9565
18414	1267	1125315	1995-02-27	1995-03-29	1	9218
69795	4760	1729720	1955-03-27	1955-04-05	1	-5385
15441	1073	1125315	1953-10-24	1953-11-07	1	-5899
71515	4883	1729720	1981-12-09	1981-12-22	1	4373
26552	1793	1125315	1977-01-13	1977-01-20	1	2576
75367	5157	1125315	1980-08-10	1980-08-24	1	3888
36161	2458	1713332	2013-01-03	2013-01-24	1	15729
63134	4312	1521369	1974-09-14	1975-09-09	1	2077
33041	2237	1112807	1934-08-18	1934-09-01	1	-12906
26531	1791	1112807	1965-05-01	1965-06-05	1	-1671
74945	5128	1125315	2009-07-26	2009-08-02	1	14458
25251	1713	1124957	2011-07-13	2011-07-13	1	15168
27485	1854	1124957	2015-02-08	2015-02-08	1	16474
13862	949	1118084	2000-02-25	2000-02-25	1	11012
25035	1695	1125315	2007-02-27	2007-03-13	1	13585
45421	3082	1521369	1984-07-05	1987-06-20	3	6379
71842	4909	920293	1999-07-08	1999-07-15	1	10787
72817	4976	1728416	1952-10-09	1952-11-06	1	-6265
75288	5151	1759842	1961-03-20	1961-04-10	1	-3188
33142	2244	1713332	1968-02-10	1968-02-24	1	-677
63008	4304	723013	1977-09-08	1978-05-11	1	3052
7242	499	1759842	2011-05-29	2011-06-05	1	15130
52798	3598	1729720	1980-09-10	1980-09-21	1	3916
24070	1627	1112807	1964-12-24	1965-01-23	1	-1804
72956	4986	1713332	2015-08-04	2015-08-18	1	16665
68143	4649	1112807	1978-08-22	1978-09-05	1	3169
1884	124	19010482	2006-01-11	2006-02-01	1	13180
71241	4861	1759842	2012-07-05	2012-07-26	1	15547
41982	2845	1125315	2001-04-14	2001-04-14	1	11426
29969	2027	1728416	1968-02-09	1968-03-15	1	-657
68093	4646	1125315	1983-09-17	1983-09-24	1	5014
38377	2609	1729720	2013-04-11	2013-04-22	1	15817
61245	4176	1759842	1981-01-09	1981-01-23	1	4040
36318	2469	1118084	2008-08-06	2008-08-06	1	14097
28924	1958	1125315	1979-05-16	1979-05-30	1	3436
18415	1267	1125315	2004-02-26	2004-03-11	1	12488
69796	4760	1729720	1968-02-28	1968-03-07	1	-665
15442	1073	1125315	1966-11-24	1966-12-01	1	-1127
73192	5001	1112807	1975-04-25	1975-07-01	1	2007
26553	1793	1125315	1990-05-28	1990-06-11	1	7466
75368	5157	1310149	2019-05-16	2019-05-16	1	18032
36162	2458	1759842	2013-01-03	2013-01-24	1	15729
63135	4312	1551099	1961-02-08	1961-02-08	1	-3249
33042	2237	1125315	2005-10-29	2005-10-29	1	13085
26532	1791	1115008	1995-07-08	1995-09-06	1	9379
74946	5128	1343916	1955-07-27	1955-07-27	1	-5272
25252	1713	1125315	1972-04-03	1972-04-17	1	837
27486	1854	1125315	1993-05-07	1993-05-14	1	8534
13863	949	1125315	1974-07-05	1974-10-03	1	1736
25036	1695	1521369	1982-12-11	1983-12-06	1	5087
45422	3082	1521369	1989-06-09	1991-05-30	2	7819
71843	4909	920293	2003-08-30	2003-09-06	1	12301
72818	4976	1729720	1970-08-16	1970-08-28	1	239
75289	5151	1118084	1997-12-12	1997-12-12	1	10207
33143	2244	1729720	1956-09-07	1956-09-15	1	-4856
63009	4304	1119510	1967-05-11	1967-05-25	1	-952
7243	499	738818	1973-05-20	1973-06-03	1	1249
52799	3598	1112807	1947-10-07	1947-10-21	1	-8108
24071	1627	1112807	1972-03-12	1972-03-26	1	815
72957	4986	1759842	2005-02-07	2005-02-21	1	12835
68144	4649	1125315	1999-01-06	1999-01-20	1	10611
1885	124	738818	1998-03-11	1998-03-25	1	10310
71242	4861	1125315	1958-08-31	1958-09-14	1	-4127
41983	2845	1713332	2001-04-14	2001-05-12	1	11454
29970	2027	1729720	1969-01-15	1969-01-25	1	-341
68094	4646	1177480	2017-10-17	2017-11-07	1	17477
38378	2609	1759842	1993-12-04	1993-12-18	1	8752
61246	4176	738818	1923-07-09	1923-07-23	1	-16964
36319	2469	1125315	1993-04-08	1993-04-15	1	8505
28925	1958	1125315	1989-09-20	1989-10-25	1	7237
18416	1267	1713332	1961-01-13	1961-01-27	1	-3261
69797	4760	1759842	1955-08-29	1955-09-12	1	-5225
15443	1073	1125315	1983-05-07	1983-05-21	1	4888
73193	5001	1119510	1961-01-19	1961-02-02	1	-3255
26554	1793	1347450	2006-08-30	2006-08-30	1	13390
75369	5157	1322184	2015-05-14	2015-05-14	1	16569
37308	2540	1112807	1953-11-28	1953-12-19	1	-5857
65538	4477	1125315	1970-10-13	1970-11-12	1	315
33043	2237	1322184	2005-12-04	2005-12-04	1	13121
26533	1791	1125315	1980-12-27	1981-01-10	1	4027
74947	5128	1759842	1930-11-24	1930-12-15	1	-14262
25253	1713	1177480	2009-06-09	2009-06-23	1	14418
27487	1854	1177480	1999-08-03	1999-08-31	1	10834
13864	949	1125315	2018-05-06	2018-05-20	1	17671
25037	1695	1521369	1984-11-30	1985-11-25	1	5807
45423	3082	19127890	1994-05-21	1995-05-16	1	9266
71844	4909	933724	1999-07-08	1999-07-15	1	10787
72819	4976	920293	1941-12-19	1941-12-26	1	-10233
75290	5151	1125315	1959-01-05	1959-01-19	1	-4000
34293	2327	1125315	1970-11-08	1970-11-15	1	318
63712	4355	1119510	2018-07-08	2018-07-15	1	17727
7244	499	975125	1971-12-08	1971-12-29	1	727
52800	3598	1125315	2014-12-14	2014-12-14	1	16418
24072	1627	1503184	1977-04-08	1978-04-03	1	3014
72958	4986	1759842	2015-08-04	2015-08-18	1	16665
68145	4649	1125315	2002-07-31	2002-09-04	1	11934
1886	124	975125	1989-03-23	1989-04-14	1	7043
71243	4861	1125315	2017-09-10	2017-09-17	1	17426
41984	2845	933724	2009-10-28	2009-11-04	1	14552
29971	2027	738818	2019-01-04	2019-01-18	1	17914
68095	4646	1310149	2001-10-02	2001-10-02	1	11597
38711	2631	1728416	1954-09-24	1954-10-08	1	-5564
61247	4176	1124300	1952-05-20	1952-05-20	1	-6435
36320	2469	1125315	1993-08-14	1993-08-28	1	8640
28926	1958	1125315	2008-03-10	2008-03-17	1	13955
18417	1267	19127890	1974-03-24	1975-03-19	1	1903
69798	4760	1112807	1960-05-28	1960-06-11	1	-3491
15444	1073	1125315	2006-01-25	2006-02-01	1	13180
73194	5001	1125315	1961-10-14	1961-10-28	1	-2987
26555	1793	1539403	1991-06-12	1991-06-12	1	7832
75370	5157	1347450	2015-05-14	2015-05-14	1	16569
37309	2540	1112807	1962-08-04	1962-08-25	1	-2686
65539	4477	1125315	1978-10-01	1978-10-22	1	3216
33044	2237	1332418	2005-12-04	2005-12-04	1	13121
26534	1791	1125315	1995-07-08	1995-07-08	1	9319
74948	5128	1759842	1983-12-07	1984-01-04	1	5116
25254	1713	1503184	1988-09-16	1989-09-11	1	7193
27488	1854	1177480	2015-02-08	2015-03-08	1	16502
13865	949	1713332	2012-08-26	2012-09-02	1	15585
25038	1695	1713332	2009-11-24	2009-12-15	1	14593
45424	3082	1125315	1970-10-07	1970-10-21	1	293
71845	4909	1118084	2008-08-26	2008-08-26	1	14117
72820	4976	1112807	1913-12-07	1914-01-04	1	-20451
75291	5151	1539403	2017-01-27	2017-01-27	1	17193
34294	2327	1125315	2001-05-15	2001-06-05	1	11478
63713	4355	1125315	1994-03-13	1994-03-20	1	8844
7245	499	1118084	1997-08-02	1997-08-02	1	10075
52801	3598	1322184	2015-05-31	2015-05-31	1	16586
24073	1627	1713332	1978-08-15	1978-08-29	1	3162
72959	4986	933724	2000-05-22	2000-05-29	1	11106
68146	4649	1125315	2010-05-03	2010-05-17	1	14746
1887	124	975125	1995-09-14	1995-10-05	1	9408
71244	4861	1713332	1956-07-16	1956-07-30	1	-4903
41985	2845	1124957	2001-04-14	2001-04-14	1	11426
29972	2027	1125315	1962-03-12	1962-03-26	1	-2838
68096	4646	1729720	1977-01-23	1977-02-02	1	2589
38712	2631	1728416	1960-07-24	1960-08-21	1	-3420
61248	4176	1125315	1923-07-09	1923-07-23	1	-16964
36321	2469	1125315	2017-02-07	2017-02-21	1	17218
28927	1958	1115008	2003-09-12	2003-10-17	1	12342
18418	1267	19127890	1976-03-13	1977-03-08	1	2623
69799	4760	1112807	1964-07-13	1964-08-12	1	-1968
15445	1073	1174888	1950-09-10	1950-09-10	1	-7053
73195	5001	1125315	1993-09-24	1993-10-15	1	8688
26556	1793	1713332	1986-05-09	1986-05-23	1	5986
75371	5157	1713332	2004-11-04	2004-11-18	1	12740
37310	2540	1174888	1950-11-30	1950-11-30	1	-6972
65540	4477	1125315	2009-12-21	2010-01-04	1	14613
33045	2237	1539403	2005-12-04	2005-12-04	1	13121
26535	1791	1125315	2005-07-07	2005-07-14	1	12978
25255	1713	1713332	2004-12-22	2004-12-29	1	12781
27489	1854	19127890	1989-10-04	1990-09-29	1	7576
13866	949	1713332	2018-01-13	2018-01-27	1	17558
25039	1695	1125315	1999-09-01	1999-09-08	1	10842
45425	3082	1125315	2001-11-03	2001-11-10	1	11636
71846	4909	1549786	1992-05-27	1993-05-22	1	8542
72821	4976	1112807	1952-10-09	1952-11-06	1	-6265
75292	5151	1713332	1961-03-20	1961-04-10	1	-3188
34295	2327	1177480	1995-04-19	1995-05-03	1	9253
63714	4355	1177480	2013-05-14	2013-05-28	1	15853
7246	499	1119510	2009-12-25	2010-01-01	1	14610
52802	3598	1361711	1996-04-07	2014-12-14	1	16418
24074	1627	1713332	2002-10-25	2002-11-08	1	11999
72960	4986	1118084	1981-12-06	1981-12-06	1	4357
70331	4805	1361711	2017-10-27	2017-10-27	1	17466
1888	124	975125	2006-01-11	2006-02-01	1	13180
71245	4861	1125315	2003-04-12	2003-04-26	1	12168
41986	2845	1125315	1955-06-19	1955-07-24	1	-5275
29973	2027	1125315	2002-11-03	2002-11-10	1	12001
72787	4975	1125315	1983-05-25	1983-06-01	1	4899
38713	2631	738818	1991-10-20	1991-11-03	1	7976
61249	4176	1125315	1972-12-01	1972-12-08	1	1072
36322	2469	1503184	1988-07-12	1989-07-07	1	7127
28928	1958	1115008	2004-09-11	2004-09-25	1	12686
18419	1267	920293	1996-05-27	1996-06-03	1	9650
69800	4760	1115008	2015-11-04	2015-12-02	1	16771
15446	1073	1177480	2017-02-14	2017-04-15	1	17271
73196	5001	1125315	2000-06-07	2000-06-21	1	11129
26557	1793	1738521	1971-06-20	1971-07-04	1	549
75372	5157	1717327	1976-03-28	1976-04-11	1	2292
37311	2540	1728416	1950-11-30	1950-12-14	1	-6958
65541	4477	1125315	2012-06-25	2012-08-31	2	15583
33046	2237	738818	1968-02-05	1968-02-19	1	-682
26536	1791	1125315	2017-02-12	2017-02-19	1	17216
25256	1713	1729720	2010-10-20	2010-10-29	1	14911
27490	1854	920293	2005-12-06	2005-12-20	2	13137
16246	1123	1738521	1968-09-08	1968-09-22	1	-466
25040	1695	1125315	2003-06-19	2003-07-26	1	12259
45426	3082	1503184	1989-06-09	1991-05-30	2	7819
71847	4909	1125315	2017-02-07	2017-02-14	1	17211
72822	4976	1501700	1983-10-26	1983-10-26	1	5046
75293	5151	1713332	1986-02-01	1986-02-08	1	5882
34296	2327	1729720	1960-06-06	1960-06-13	1	-3489
63715	4355	1713332	1981-11-14	1981-11-28	1	4349
7247	499	1125315	1973-05-20	1973-06-03	1	1249
52803	3598	1759842	1964-01-07	1964-01-28	1	-2165
24075	1627	920293	1971-07-04	1971-07-11	1	556
72961	4986	1125315	1955-12-25	1956-01-01	1	-5114
70332	4805	1539403	2017-10-27	2017-10-27	1	17466
1889	124	1112807	1993-11-13	1994-01-12	1	8777
71246	4861	1713332	1955-07-24	1955-09-11	1	-5226
41987	2845	1759842	1973-07-13	1973-07-20	1	1296
29974	2027	1125315	2019-01-04	2019-01-18	1	17914
72788	4975	1713332	1968-08-16	1968-12-13	1	-384
38714	2631	1118084	1992-10-19	1992-10-19	1	8327
61250	4176	1125315	2010-07-03	2010-07-17	1	14807
36323	2469	1738521	1971-10-30	1971-11-13	1	681
28929	1958	1118084	2010-08-01	2010-08-01	1	14822
18420	1267	1124300	1990-05-14	1990-05-14	1	7438
69801	4760	1125315	1971-07-11	1971-07-25	1	570
15447	1073	1713332	1942-11-20	1942-11-27	1	-9897
73197	5001	738818	2006-12-19	2006-12-26	1	13508
26558	1793	1759842	1986-05-09	1986-05-23	1	5986
75373	5157	19127890	1984-03-01	1985-02-24	1	5533
37312	2540	757627	2018-04-10	2018-04-10	1	17631
65542	4477	1521369	1978-11-12	1979-11-07	1	3597
33047	2237	1124300	1967-01-16	1967-01-16	1	-1081
26537	1791	1125315	2017-03-22	2017-04-05	1	17261
25257	1713	1759842	2004-12-22	2004-12-29	1	12781
27491	1854	1125315	1986-07-05	1986-07-12	1	6036
16247	1123	1738521	1970-01-26	1970-02-09	1	39
25041	1695	920293	2018-04-24	2018-05-08	2	17659
45427	3082	1549786	1992-05-24	1993-05-19	1	8539
71848	4909	1728416	1976-03-20	1976-04-03	1	2284
72823	4976	1713332	1994-04-24	1994-05-15	1	8900
75294	5151	1728416	1959-01-05	1959-01-19	1	-4000
34297	2327	1124300	1999-11-25	1999-11-25	1	10920
63716	4355	1713332	1999-05-29	1999-06-12	1	10754
7248	499	1125315	1989-08-29	1989-09-12	1	7194
54866	3732	1112807	1958-04-02	1958-07-01	1	-4202
24076	1627	1119510	1970-06-28	1970-07-05	1	185
72962	4986	1125315	1989-03-20	1989-04-03	1	7032
70333	4805	1759842	1986-01-22	1986-02-05	1	5879
1890	124	1125315	1985-05-30	1985-06-13	1	5642
71247	4861	1728416	1948-04-23	1948-05-08	1	-7908
41988	2845	1115008	2001-04-14	2001-05-12	1	11454
31036	2097	1177480	1993-02-07	1993-02-21	1	8452
72789	4975	1713332	1983-10-15	1983-10-22	1	5042
38715	2631	1125315	1955-07-14	1955-07-28	1	-5271
62738	4284	1112807	1947-07-01	1947-07-15	1	-8206
36324	2469	1759842	1978-02-16	1978-03-09	1	2989
28930	1958	1713332	1979-05-16	1979-05-30	1	3436
18421	1267	1125315	1969-10-18	1969-11-01	1	-61
69802	4760	1713332	1955-08-29	1955-09-12	1	-5225
15448	1073	1729720	1996-08-08	1996-08-16	1	9724
73198	5001	1112807	1973-05-05	1973-06-04	1	1250
26559	1793	1125315	1953-11-10	1953-12-08	1	-5868
75374	5157	1125315	1965-02-11	1965-02-25	1	-1771
37313	2540	1112807	1942-08-23	1942-09-13	1	-9972
65543	4477	1713332	2002-12-13	2002-12-20	1	12041
33048	2237	1125315	1968-02-05	1968-02-19	1	-682
26538	1791	1713332	1996-08-01	1996-09-05	1	9744
25258	1713	933724	2004-10-26	2004-11-02	1	12724
27492	1854	1125315	2012-12-12	2012-12-26	1	15700
16248	1123	1759842	1994-06-22	1994-06-29	1	8945
25042	1695	1125315	2016-09-15	2016-09-29	1	17073
45428	3082	19127890	1984-07-05	1987-06-20	3	6379
71849	4909	1728416	1978-04-14	1978-04-28	1	3039
72824	4976	1729720	1913-01-15	1913-01-25	1	-20795
75295	5151	1729720	1964-12-13	1964-12-21	1	-1837
34298	2327	920293	2012-11-04	2012-11-11	1	15655
63717	4355	738818	2019-04-12	2019-04-19	1	18005
7249	499	1125315	2009-12-25	2010-01-01	1	14610
54867	3732	1347450	2016-09-18	2016-09-18	1	17062
24077	1627	1124300	1987-11-04	1987-11-04	1	6516
72963	4986	1307863	2001-04-29	2001-04-29	1	11441
70334	4805	1125315	1996-03-30	1996-04-13	1	9599
1891	124	1125315	1988-03-29	1988-04-13	1	6677
71248	4861	1729720	1952-04-19	1952-05-03	1	-6452
41989	2845	1118084	1994-10-12	1994-10-12	1	9050
31037	2097	1713332	1982-09-24	1982-10-08	1	4663
72790	4975	1713332	1985-04-22	1985-05-06	1	5604
38716	2631	1125315	1991-10-20	1991-11-03	1	7976
62739	4284	1125315	2003-02-16	2003-03-09	1	12120
36325	2469	1119510	1993-08-14	1993-08-28	1	8640
28931	1958	1713332	1996-02-25	1996-03-10	1	9565
18422	1267	1503184	1974-03-24	1975-03-19	1	1903
69803	4760	738818	1986-07-21	1986-07-28	1	6052
15449	1073	1125315	1950-09-10	1950-09-10	1	-7053
73199	5001	1119510	1965-02-11	1965-02-18	1	-1778
26560	1793	1125315	1955-01-06	1955-01-20	1	-5460
75375	5157	1177480	2018-01-22	2018-03-23	1	17613
37314	2540	1112807	1972-02-04	1972-02-25	1	785
65544	4477	1759842	2002-12-13	2002-12-20	1	12041
33049	2237	1125315	1990-02-15	1990-03-22	1	7385
27811	1882	738818	1973-02-17	1973-03-03	1	1157
25259	1713	1125315	1999-01-14	1999-01-28	1	10619
27493	1854	1521369	1989-10-04	1990-09-29	1	7576
16249	1123	738818	1977-03-26	1977-04-09	1	2655
25043	1695	1125315	2016-11-02	2016-11-16	1	17121
45429	3082	19127890	1992-05-24	1993-05-19	1	8539
71850	4909	19127890	1992-05-27	1993-05-22	1	8542
72825	4976	1125315	1913-03-14	1913-03-21	1	-20740
75296	5151	1729720	1995-03-11	1995-03-21	1	9210
34299	2327	933724	2012-11-04	2012-11-11	1	15655
63718	4355	1112807	1983-12-16	1983-12-30	1	5111
7250	499	1192710	1963-05-14	1963-05-14	1	-2424
54868	3732	1125315	2015-11-09	2015-12-16	2	16785
24078	1627	1713332	1985-07-29	1985-08-05	1	5695
72964	4986	1326303	2001-04-29	2001-04-29	1	11441
70335	4805	1125315	1999-08-12	1999-08-26	1	10829
1892	124	1125315	1990-02-03	1990-02-10	1	7345
71249	4861	1729720	1985-04-21	1985-04-29	1	5597
41990	2845	1125315	1965-08-11	1965-08-25	1	-1590
31038	2097	1759842	2009-11-20	2009-12-04	1	14582
72791	4975	1759842	1983-10-15	1983-10-22	1	5042
38717	2631	757627	2012-09-30	2012-09-30	1	15613
62740	4284	1728416	1945-04-21	1945-05-05	1	-9007
36326	2469	1738521	1977-04-12	1977-04-26	1	2672
28932	1958	1125315	1987-09-02	1987-09-16	1	6467
18423	1267	1503184	1976-03-13	1977-03-08	1	2623
69804	4760	1119510	1974-12-08	1974-12-22	1	1816
15450	1073	1125315	2010-08-20	2010-09-19	1	14871
73200	5001	1125315	2006-12-19	2006-12-26	1	13508
26561	1793	1125315	1972-03-03	1972-03-17	1	806
75376	5157	1307863	2019-05-16	2019-05-16	1	18032
37315	2540	1115008	1997-11-20	1997-12-11	1	10206
65545	4477	1112807	1964-09-16	1964-10-14	1	-1905
33050	2237	1125315	2001-11-01	2001-11-15	1	11641
27812	1882	1112807	1969-09-04	1969-09-18	1	-105
25260	1713	1177480	2011-07-13	2011-08-17	1	15203
27494	1854	920293	2009-02-03	2009-02-10	1	14285
16250	1123	1118084	2007-02-01	2007-02-01	1	13545
25044	1695	1177480	2000-06-29	2000-08-03	1	11172
45430	3082	1118084	2004-03-12	2004-03-12	1	12489
71851	4909	933724	2003-08-30	2003-09-06	1	12301
72826	4976	1125315	1982-09-21	1982-10-05	1	4660
75297	5151	1759842	1986-02-01	1986-02-08	1	5882
34300	2327	1112807	1958-10-11	1959-01-09	1	-4010
63719	4355	1118084	2019-04-24	2019-04-24	1	18010
7251	499	1713332	2011-05-29	2011-06-05	1	15130
54869	3732	1177480	1985-06-09	1985-06-23	1	5652
24079	1627	1729720	1965-04-26	1965-05-08	1	-1699
72965	4986	1713332	1956-12-25	1957-01-01	1	-4748
70336	4805	1125315	1972-05-04	1972-05-18	1	868
1893	124	1137529	2014-03-25	2014-03-25	1	16154
72452	4952	1112807	1971-05-15	1971-05-29	1	513
41991	2845	1729720	1953-10-30	1953-11-08	1	-5898
31039	2097	1768849	1979-04-24	1979-05-08	1	3414
72792	4975	1759842	1985-04-22	1985-05-06	1	5604
38718	2631	1112807	1960-07-24	1960-08-21	1	-3420
62741	4284	1728416	1945-10-02	1945-10-16	1	-8843
36327	2469	920293	1988-09-03	1988-09-10	1	6827
28933	1958	1729720	1981-05-19	1981-05-26	1	4163
18424	1267	1759842	1960-06-01	1960-06-08	1	-3494
69805	4760	1125315	1986-07-21	1986-07-28	1	6052
15451	1073	1557272	1996-08-29	1996-08-29	1	9737
73201	5001	1713332	1974-02-05	1974-02-12	1	1503
26562	1793	1125315	1978-07-01	1978-07-08	1	3110
75377	5157	1326303	2019-05-16	2019-05-16	1	18032
37316	2540	1125315	1950-11-30	1950-11-30	1	-6972
65546	4477	1112807	1967-08-30	1967-09-29	1	-825
33051	2237	1174888	2005-10-29	2005-10-29	1	13085
27813	1882	1112807	1972-12-17	1973-01-21	1	1116
25261	1713	1713332	1982-11-08	1983-02-07	1	4785
27495	1854	933724	2005-12-06	2005-12-20	1	13137
16251	1123	1125315	1970-01-26	1970-02-09	1	39
25045	1695	1759842	2009-11-24	2009-12-15	1	14593
45431	3082	1125315	1980-03-02	1980-03-02	2	3713
71852	4909	1125315	1976-03-20	1976-04-03	1	2284
72827	4976	1125315	1987-01-10	1987-01-24	1	6232
75298	5151	1125315	2000-11-05	2000-11-26	1	11287
34301	2327	1125315	1967-12-23	1968-01-13	1	-719
63720	4355	1119510	1994-03-13	1994-03-20	1	8844
7252	499	1125315	1963-10-01	1963-10-15	1	-2270
54870	3732	1322184	2016-09-18	2016-09-18	1	17062
24080	1627	1759842	1985-07-29	1985-08-05	1	5695
72966	4986	1713332	1970-06-13	1970-07-04	1	184
70337	4805	1125315	1983-07-07	1983-07-21	1	4949
1894	124	1154343	1986-03-12	1986-03-12	1	5914
72453	4952	1125315	1978-05-12	1978-05-19	1	3060
43696	2951	738818	1965-03-06	1965-03-13	1	-1755
31040	2097	920293	1996-04-06	1996-04-13	1	9599
72793	4975	1112807	1961-05-12	1961-05-26	1	-3142
38719	2631	1125315	1963-04-12	1963-04-19	1	-2449
62742	4284	1112807	1945-04-21	1945-05-05	1	-9007
36328	2469	1125315	1977-04-12	1977-04-26	1	2672
30407	2058	920293	2008-11-16	2008-11-30	2	14213
18425	1267	933724	1996-05-27	1996-06-03	1	9650
69806	4760	1174888	1972-07-31	1972-07-31	1	942
15452	1073	1729720	1980-03-23	1980-04-02	1	3744
73202	5001	1729720	1969-12-19	1969-12-27	1	-5
26563	1793	1322184	1997-07-16	2006-08-30	1	13390
75378	5157	1503184	1984-03-01	1985-02-24	1	5533
37317	2540	1125315	1972-12-21	1973-01-04	1	1099
65547	4477	1174888	2012-07-02	2012-07-02	1	15523
33052	2237	1759842	1971-12-29	1972-01-12	1	741
27814	1882	1118084	2004-07-22	2004-07-22	1	12621
25262	1713	1713332	2011-07-13	2011-08-17	1	15203
27496	1854	1118084	2012-04-06	2012-04-06	1	15436
16252	1123	1125315	1977-03-26	1977-04-09	1	2655
25046	1695	19127890	1982-12-11	1983-12-06	1	5087
45432	3082	1125315	1997-05-19	1997-05-26	1	10007
71853	4909	1125315	1977-06-05	1977-07-10	1	2747
72828	4976	1759842	1994-04-24	1994-05-15	1	8900
75299	5151	1125315	2007-03-21	2007-04-04	1	13607
34302	2327	1177480	1985-10-10	1985-11-07	1	5789
63721	4355	1125315	2017-05-07	2017-05-28	1	17314
7253	499	1149380	1962-04-30	1962-04-30	1	-2803
54871	3732	1115008	1997-12-17	1998-01-14	1	10240
24081	1627	19127890	1977-04-08	1978-04-03	1	3014
72967	4986	1112807	1952-10-24	1952-11-07	1	-6264
70338	4805	1125315	2019-02-13	2019-02-20	1	17947
1895	124	1729720	1994-10-14	1994-10-27	1	9065
72454	4952	1125315	1994-07-13	1994-08-03	2	8980
43697	2951	1112807	1959-11-11	1959-11-25	1	-3690
31041	2097	933724	1996-04-06	1996-04-13	1	9599
72794	4975	1112807	1965-03-09	1965-03-30	1	-1738
38720	2631	701322	2013-08-26	2013-08-26	1	15943
62743	4284	1112807	1945-10-02	1945-10-16	1	-8843
36329	2469	1125315	1979-09-18	1979-11-17	1	3607
30408	2058	1115008	2013-08-09	2013-09-15	1	15963
18426	1267	1115008	2009-05-14	2009-05-28	1	14392
69807	4760	1347450	2018-03-28	2018-03-28	1	17618
15453	1073	1759842	1942-11-20	1942-11-27	1	-9897
73203	5001	738818	1961-01-19	1961-02-02	1	-3255
26564	1793	1713332	1964-06-05	1964-06-12	1	-2029
75379	5157	1713332	2004-08-17	2004-08-31	1	12661
37318	2540	1125315	1990-10-27	1990-11-03	1	7611
65548	4477	1729720	1971-11-24	1971-12-05	1	703
34305	2328	1112807	1955-08-23	1955-09-06	1	-5231
27815	1882	1125315	1973-02-17	1973-03-03	1	1157
25263	1713	1729720	2013-05-19	2013-05-27	1	15852
27497	1854	1154343	1972-11-09	1993-01-05	1	8405
16253	1123	1738521	1971-09-29	1971-10-13	1	650
25047	1695	19127890	1984-11-30	1985-11-25	1	5807
45433	3082	1549786	1994-05-21	1995-05-16	1	9266
71854	4909	1125315	1993-01-08	1993-02-05	1	8436
72829	4976	1112807	1936-09-05	1936-09-19	1	-12157
75300	5151	1125315	2015-11-26	2015-12-03	1	16772
34303	2327	1177480	1996-04-27	1996-05-11	1	9627
63722	4355	1125315	2019-04-12	2019-04-19	1	18005
7254	499	1551099	1972-03-19	1972-03-19	1	808
54872	3732	1118084	1993-12-24	1993-12-24	1	8758
24082	1627	738818	1970-06-28	1970-07-05	1	185
72968	4986	1125315	1983-06-09	1983-06-16	1	4914
70339	4805	1713332	1986-01-22	1986-02-05	1	5879
1896	124	975125	1994-11-30	1994-12-14	1	9113
72455	4952	1308738	1991-03-16	1991-03-16	1	7744
43698	2951	1125315	1965-03-06	1965-03-13	1	-1755
31042	2097	1125315	1979-04-24	1979-05-08	1	3414
72795	4975	1115008	2014-01-08	2014-01-22	1	16092
38721	2631	1112807	1954-09-24	1954-10-08	1	-5564
62744	4284	1125315	1979-12-29	1980-01-12	1	3663
36330	2469	1521369	1988-07-12	1989-07-07	1	7127
30409	2058	1125315	1968-06-17	1968-07-08	1	-542
18427	1267	1125315	1959-05-13	1959-05-20	1	-3879
69808	4760	1728416	1960-05-28	1960-06-11	1	-3491
15454	1073	1759842	1995-12-21	1996-01-11	1	9506
73204	5001	1118084	1997-01-03	1997-01-03	1	9864
26565	1793	1729720	1967-06-13	1967-06-21	1	-925
75380	5157	1728416	1966-12-08	1966-12-22	1	-1106
37319	2540	701322	2019-04-05	2019-04-05	1	17991
65549	4477	1729720	1975-08-28	1975-09-04	1	2072
34306	2328	1118084	1999-05-04	1999-05-04	1	10715
27816	1882	19127890	1984-07-27	1985-07-22	1	5681
25264	1713	19127890	1988-09-16	1989-09-11	1	7193
27591	1864	1115008	2014-02-03	2014-02-17	1	16118
16254	1123	1112807	1968-12-30	1969-01-13	1	-353
25048	1695	920293	2018-02-01	2018-02-08	1	17570
45434	3082	1738521	1967-12-22	1968-01-05	1	-727
71855	4909	1177480	1985-12-25	1986-01-15	1	5858
72830	4976	1112807	1937-10-02	1937-10-16	1	-11765
75301	5151	1177480	1989-03-17	1989-04-07	1	7036
34304	2327	1729720	1965-12-17	1965-12-30	1	-1463
63723	4355	738818	1994-03-13	1994-03-20	1	8844
7255	499	1713332	1962-08-27	1962-09-17	1	-2663
54873	3732	1124957	2015-11-16	2015-11-16	1	16755
24083	1627	920293	1972-08-20	1972-08-27	1	969
72969	4986	1729720	1959-04-20	1959-04-30	1	-3899
70340	4805	1124300	2003-07-01	2003-07-01	1	12234
1897	124	1125315	1998-03-11	1998-03-25	1	10310
72456	4952	1521369	1990-02-14	1991-02-09	1	7709
43699	2951	1125315	1983-09-21	1983-09-28	1	5018
31043	2097	1729720	1986-12-15	1986-12-23	1	6200
72796	4975	1118084	2004-01-14	2004-01-14	1	12431
38722	2631	1119510	1991-10-20	1991-11-03	1	7976
62745	4284	1728416	1947-07-01	1947-07-15	1	-8206
36331	2469	1713332	1978-02-16	1978-03-09	1	2989
30410	2058	1347450	2017-11-15	2017-11-15	1	17485
18428	1267	1125315	1960-12-17	1960-12-31	1	-3288
69809	4760	1729720	1979-07-08	1979-07-19	1	3486
15455	1073	1112807	1950-09-10	1950-10-10	1	-7023
73205	5001	1119510	2006-12-19	2006-12-26	1	13508
26566	1793	738818	1932-07-29	1932-08-12	1	-13656
75381	5157	1759842	2004-08-17	2004-08-31	1	12661
37320	2540	1115008	1996-11-04	1996-11-25	1	9825
65550	4477	19127890	1978-11-12	1979-11-07	1	3597
34307	2328	1119510	1972-05-15	1972-05-22	1	872
27817	1882	1119510	2018-10-20	2018-11-03	1	17838
25265	1713	1521369	1988-09-16	1989-09-11	1	7193
27592	1864	1125315	1971-04-08	1971-04-22	1	476
16255	1123	1112807	1971-09-29	1971-10-13	1	650
25049	1695	933724	2018-04-24	2018-05-08	1	17659
45435	3082	19127890	1989-06-09	1991-05-30	2	7819
75149	5143	738818	1967-03-09	1967-03-23	1	-1015
72831	4976	1118084	1953-12-22	1953-12-22	1	-5854
75302	5151	1322184	2017-01-27	2017-01-27	1	17193
35987	2445	1112807	1928-10-27	1928-11-10	1	-15027
63724	4355	738818	2018-07-08	2018-07-15	1	17727
7256	499	1713332	1995-10-13	1995-11-03	1	9437
54874	3732	1177480	1999-01-09	1999-02-06	1	10628
24084	1627	1112807	1981-09-26	1981-10-26	1	4316
72970	4986	1759842	1956-12-25	1957-01-01	1	-4748
70341	4805	1125315	2003-08-28	2003-09-04	1	12299
1898	124	1149380	2014-03-25	2014-03-25	1	16154
72457	4952	1713332	1976-12-10	1976-12-17	1	2542
43700	2951	1729720	1962-03-31	1962-04-09	1	-2824
31044	2097	1729720	1990-11-05	1990-11-12	1	7620
72797	4975	1125315	1977-08-04	1977-08-18	1	2786
40153	2731	1112807	1960-12-08	1960-12-22	1	-3297
62746	4284	1729720	2011-09-29	2011-10-07	1	15254
37720	2563	1115008	2000-03-06	2000-03-27	1	11043
30411	2058	933724	2008-11-16	2008-11-30	1	14213
18429	1267	1125315	1981-01-17	1981-01-31	1	4048
73538	5031	723013	1945-05-26	1945-09-08	1	-8881
15456	1073	1119510	1966-11-24	1966-12-01	1	-1127
73206	5001	1125315	1961-01-19	1961-02-02	1	-3255
26567	1793	738818	1934-04-14	1934-04-28	1	-13032
76058	5203	1112807	1938-03-31	1938-04-14	1	-11585
37321	2540	1124300	1975-01-02	1975-01-02	1	1827
65551	4477	1118084	2005-08-27	2005-08-27	1	13022
34308	2328	1125315	1975-09-06	1975-09-20	1	2088
27818	1882	1125315	1971-09-24	1971-12-23	1	721
25266	1713	1713332	1988-11-05	1988-11-19	1	6897
27593	1864	1149380	2011-12-23	2011-12-23	1	15331
16256	1123	1125315	1968-09-08	1968-09-22	1	-466
25050	1695	1102527	2003-06-26	2003-06-26	1	12229
47101	3196	738818	2011-09-07	2011-09-14	1	15231
75150	5143	738818	1968-04-20	1968-05-04	1	-607
72832	4976	1125315	1952-10-09	1952-10-09	1	-6293
75303	5151	1332418	2017-01-27	2017-01-27	1	17193
35988	2445	1125315	1979-09-24	1979-09-24	1	3553
63725	4355	1125315	2010-10-13	2010-10-27	1	14909
7257	499	1717327	1961-12-09	1961-12-23	1	-2931
57059	3889	1112807	1961-12-26	1962-01-16	1	-2907
24085	1627	1125315	1970-06-28	1970-07-05	1	185
72971	4986	1759842	1970-06-13	1970-07-04	1	184
70342	4805	1177480	2016-10-24	2016-11-14	1	17119
1899	124	1759842	1984-09-07	1984-09-14	1	5370
72458	4952	1738521	1973-02-17	1973-03-03	1	1157
43701	2951	19127890	1976-10-22	1977-10-17	1	2846
31045	2097	1115008	1998-10-23	1998-11-27	1	10557
72798	4975	1125315	1999-01-01	1999-01-29	1	10620
40154	2731	1118084	2003-07-21	2003-07-21	1	12254
62747	4284	1124300	1976-07-17	1976-07-17	1	2389
37721	2563	1112807	1979-01-12	1979-04-12	1	3388
30412	2058	1118084	2000-08-03	2000-08-03	1	11172
18430	1267	1125315	1990-01-25	1990-02-08	1	7343
73539	5031	1115008	2019-01-04	2019-01-18	1	17914
15457	1073	1125315	1949-07-18	1949-07-25	1	-7465
73207	5001	1759842	1974-02-05	1974-02-12	1	1503
26568	1793	1112807	1943-04-02	1943-05-07	1	-9736
76059	5203	1112807	1942-01-09	1942-02-13	1	-10184
37322	2540	1125315	1985-05-31	1985-07-05	1	5664
65552	4477	1503184	1978-11-12	1979-11-07	1	3597
34309	2328	1125315	2007-10-04	2007-10-18	1	13804
27819	1882	1125315	1985-11-27	1985-12-11	1	5823
25267	1713	1729720	1999-07-09	1999-07-17	1	10789
27594	1864	1503184	1982-11-14	1983-11-09	1	5060
16257	1123	1177480	2015-02-25	2015-03-18	1	16512
25051	1695	1125315	1986-09-12	1986-09-19	1	6105
47102	3196	1125315	1972-08-24	1972-09-07	1	980
75151	5143	1125315	1967-03-09	1967-03-23	1	-1015
72833	4976	1125315	1956-11-20	1956-12-04	1	-4776
75304	5151	1759842	1973-12-24	1973-12-31	1	1460
35989	2445	1174888	1979-09-24	1979-09-24	1	3553
63726	4355	1125315	2018-07-08	2018-07-15	1	17727
7258	499	1759842	1995-10-13	1995-11-03	1	9437
57060	3889	1124300	1976-03-21	1976-03-21	1	2271
24086	1627	1521369	1977-04-08	1978-04-03	1	3014
73329	5014	1112807	1938-02-20	1938-03-22	1	-11608
70343	4805	1322184	2017-10-27	2017-10-27	1	17466
1900	124	1778162	1989-09-12	1989-09-26	1	7208
72459	4952	1125315	1979-06-02	1979-07-02	1	3469
43702	2951	738818	1968-10-24	1968-10-31	1	-427
31046	2097	1118084	2014-03-21	2014-03-21	1	16150
72799	4975	1125315	1999-11-25	1999-12-23	1	10948
40155	2731	1119510	1977-09-16	1977-09-30	1	2829
62748	4284	1125315	1958-03-20	1958-04-03	1	-4291
37722	2563	1118084	2009-01-22	2009-01-22	1	14266
30413	2058	1124957	2013-08-16	2013-08-16	1	15933
18431	1267	1521369	1974-03-24	1975-03-19	1	1903
73540	5031	1119510	1922-07-28	1922-08-11	1	-17310
15458	1073	1713332	1944-11-25	1944-12-16	1	-9147
73208	5001	738818	1965-02-11	1965-02-18	1	-1778
26569	1793	1112807	1971-06-20	1971-07-04	1	549
76060	5203	1125315	1996-10-10	1996-10-17	1	9786
37323	2540	1728416	1969-02-02	1969-02-16	1	-319
65821	4497	1125315	1996-04-13	1996-04-27	1	9613
34310	2328	1125315	2015-12-26	2016-01-02	1	16802
27820	1882	1125315	1987-06-13	1987-06-20	1	6379
25268	1713	1759842	1982-11-08	1983-02-07	1	4785
27595	1864	1713332	1984-08-23	1984-08-30	1	5355
16258	1123	1713332	1994-06-22	1994-06-29	1	8945
25052	1695	1125315	2001-01-31	2001-02-14	1	11367
47103	3196	1125315	1984-12-18	1984-12-25	1	5472
75152	5143	1125315	1968-04-20	1968-05-04	1	-607
72834	4976	1551099	1931-07-06	1931-07-06	1	-14059
76845	5253	1115008	1997-07-02	1997-07-30	1	10072
35990	2445	1713332	1947-04-26	1947-05-10	1	-8272
63727	4355	1713332	2001-05-08	2001-05-22	1	11464
8608	597	1112807	1967-09-14	1967-09-28	1	-826
57061	3889	1125315	2004-03-09	2004-03-16	1	12493
24087	1627	1729720	1971-02-09	1971-02-22	1	417
73330	5014	1112807	1943-02-24	1943-05-02	1	-9741
70344	4805	1332418	2017-10-27	2017-10-27	1	17466
1901	124	975125	1992-02-29	1992-03-14	1	8108
72460	4952	1515774	1989-02-19	1990-02-14	1	7349
43703	2951	1112807	1963-10-21	1964-01-19	1	-2174
31047	2097	1125315	1988-02-01	1988-02-15	1	6619
72800	4975	1125315	2001-11-25	2001-12-02	1	11658
40156	2731	1125315	1969-02-21	1969-03-07	1	-300
62749	4284	1125315	1965-11-04	1965-11-11	1	-1512
37723	2563	1125315	1983-04-16	1983-04-23	1	4860
30414	2058	1125315	1972-09-26	1972-10-03	1	1006
18432	1267	1521369	1976-03-13	1977-03-08	1	2623
73541	5031	1125315	1995-05-23	1995-06-13	1	9294
18032	1245	1112807	1949-02-18	1949-03-11	1	-7601
73209	5001	1102527	1973-05-05	1973-05-05	1	1220
26570	1793	1115008	1996-12-04	1996-12-18	1	9848
76061	5203	1174888	1999-02-17	1999-02-17	1	10639
37324	2540	715997	2019-04-05	2019-04-05	1	17991
65822	4497	1177480	1978-01-31	1978-03-07	1	2987
34311	2328	1713332	1991-01-07	1991-02-04	1	7704
27821	1882	1125315	2015-04-09	2015-05-09	1	16564
25269	1713	920293	2004-10-26	2004-11-02	1	12724
27596	1864	1759842	1966-07-10	1966-07-31	1	-1250
16259	1123	1119510	1977-03-26	1977-04-09	1	2655
25053	1695	1503184	1982-12-11	1983-12-06	1	5087
47104	3196	1125315	2011-09-07	2011-09-14	1	15231
75153	5143	1125315	1976-10-06	1976-10-27	1	2491
72835	4976	1713332	1991-09-14	1991-09-28	1	7940
76846	5253	1149380	1984-08-25	1984-08-25	1	5350
35991	2445	1713332	1962-06-18	1962-07-09	1	-2733
63728	4355	1759842	2001-05-08	2001-05-22	1	11464
8609	597	1119510	1993-09-05	1993-09-19	1	8662
57062	3889	1177480	2018-05-06	2018-05-27	1	17678
24088	1627	1738521	1980-06-25	1980-07-09	1	3842
73331	5014	1125315	1915-11-29	1915-12-06	1	-19750
70345	4805	1713332	1981-03-20	1981-04-10	1	4117
1902	124	1124300	2016-12-17	2016-12-17	1	17152
72461	4952	1713332	1984-02-14	1984-02-21	1	5164
43704	2951	1125315	1968-10-24	1968-10-31	1	-427
31048	2097	1112807	1982-11-04	1982-12-02	1	4718
72801	4975	1728416	1960-02-04	1960-02-18	1	-3605
40157	2731	1125315	1990-07-01	1990-07-15	1	7500
62750	4284	1728416	1958-03-20	1958-04-03	1	-4291
37724	2563	1125315	1991-02-12	1991-02-26	1	7726
30415	2058	1125315	2013-08-16	2013-08-16	1	15933
18433	1267	1713332	1960-06-01	1960-06-08	1	-3494
73542	5031	1125315	2015-01-07	2015-01-14	1	16449
18033	1245	1125315	1984-07-05	1984-08-09	1	5334
73210	5001	1125315	1965-02-11	1965-02-18	1	-1778
26571	1793	1125315	1932-07-29	1932-08-12	1	-13656
76062	5203	1174888	2003-03-19	2003-03-19	1	12130
37325	2540	1112807	1950-11-30	1950-12-14	1	-6958
65823	4497	1177480	1987-07-18	1987-09-16	1	6467
34312	2328	1729720	1960-12-26	1961-01-04	1	-3284
27822	1882	1177480	2010-06-20	2010-07-04	1	14794
25270	1713	1118084	2010-05-14	2010-05-14	1	14743
27597	1864	933724	2012-12-19	2012-12-26	1	15700
16260	1123	1177480	1974-11-06	1974-11-27	1	1791
25054	1695	1503184	1984-11-30	1985-11-25	1	5807
47105	3196	738818	1983-09-16	1983-09-23	1	5013
75154	5143	1713332	1990-03-05	1990-03-26	1	7389
72836	4976	1759842	1991-09-14	1991-09-28	1	7940
76847	5253	1177480	2011-01-18	2011-02-01	1	15006
35992	2445	738818	1955-11-07	1955-11-21	1	-5155
63729	4355	1768849	1983-12-16	1983-12-30	1	5111
8610	597	1125315	2012-07-27	2012-07-27	1	15548
57063	3889	1326303	2003-10-12	2003-10-12	1	12337
24089	1627	1759842	1978-08-15	1978-08-29	1	3162
73332	5014	1112807	1917-01-20	1917-02-03	1	-19325
70346	4805	1759842	1981-03-20	1981-04-10	1	4117
1903	124	1192710	1987-03-26	1987-03-26	1	6293
72462	4952	1759842	1976-12-10	1976-12-17	1	2542
43705	2951	1125315	2017-09-10	2017-09-17	1	17426
31049	2097	1125315	1982-09-06	1982-10-08	2	4659
72802	4975	1728416	1965-03-09	1965-03-30	1	-1738
40158	2731	1177480	2001-07-19	2001-08-09	1	11543
62751	4284	1729720	1951-04-02	1951-04-13	1	-6838
37725	2563	1112807	1972-04-11	1972-05-18	1	868
30416	2058	1112807	1970-04-29	1970-05-27	1	146
18434	1267	1729720	1961-06-29	1961-07-10	1	-3097
73543	5031	1759842	1986-05-31	1986-06-21	1	6015
18034	1245	1307863	2016-07-01	2016-07-01	1	16983
73211	5001	1125315	1970-01-30	1970-02-20	1	50
26572	1793	1125315	1943-04-02	1943-04-02	1	-9771
76063	5203	1545958	1999-02-17	1999-02-17	1	10639
37326	2540	1112807	1969-02-02	1969-02-16	1	-319
65824	4497	1728416	1958-02-17	1958-03-03	1	-4322
34313	2328	1759842	1993-08-22	1993-10-03	1	8676
27823	1882	1713332	2007-07-09	2007-07-16	1	13710
25271	1713	1125315	2000-04-10	2000-04-24	1	11071
27598	1864	1118084	2004-09-14	2004-09-14	1	12675
16261	1123	1729720	2002-10-03	2002-10-12	1	11972
25055	1695	1713332	1996-06-12	1996-06-26	1	9673
47106	3196	1118084	2008-05-22	2008-05-22	1	14021
75155	5143	1759842	1990-03-05	1990-03-26	1	7389
75851	5194	1125315	1958-05-30	1958-06-06	1	-4227
76848	5253	1717327	1961-01-12	1961-01-26	1	-3262
35993	2445	1112807	1955-10-27	1955-11-17	1	-5159
63730	4355	1119510	2019-04-12	2019-04-19	1	18005
8611	597	1125315	2015-07-27	2015-08-03	1	16650
57064	3889	1759842	1994-10-23	1994-11-06	1	9075
24090	1627	933724	1971-07-04	1971-07-11	1	556
73333	5014	1112807	1936-01-11	1936-02-01	1	-12388
71540	4886	1112807	1973-08-25	1973-10-24	1	1392
1904	124	1713332	1988-03-29	1988-04-13	1	6677
72463	4952	1759842	1984-02-14	1984-02-21	1	5164
43706	2951	1503184	1976-10-22	1977-10-17	1	2846
31050	2097	1713332	2009-11-20	2009-12-04	1	14582
72803	4975	1729720	1973-10-19	1973-10-30	1	1398
40159	2731	1521369	1974-07-08	1975-07-03	1	2009
62752	4284	1125315	1996-01-31	1996-02-07	1	9533
37726	2563	1112807	1986-06-04	1986-06-18	1	6012
30417	2058	1322184	2017-11-15	2017-11-15	1	17485
18435	1267	1112807	1954-02-27	1954-03-13	1	-5773
73544	5031	723013	1941-05-24	1941-10-25	1	-10295
18035	1245	1713332	1984-02-19	1984-02-26	1	5169
74800	5119	1125315	1997-10-24	1997-11-07	1	10172
26573	1793	1125315	1947-02-16	1947-03-02	1	-8341
76064	5203	1545958	2003-03-19	2003-03-19	1	12130
37327	2540	1125315	1971-08-23	1971-09-06	1	613
65825	4497	1729720	1971-04-07	1971-04-15	1	469
34314	2328	1759842	2005-11-13	2005-11-27	1	13114
27824	1882	1738521	1969-09-04	1969-09-18	1	-105
25272	1713	1125315	2011-07-13	2011-07-13	1	15168
27599	1864	1503184	1979-11-30	1980-11-24	1	3980
18511	1273	757627	2011-10-24	2011-10-24	1	15271
25056	1695	1759842	1996-06-12	1996-06-26	1	9673
47107	3196	1119510	1978-04-27	1978-05-04	1	3045
75156	5143	1118084	2000-10-20	2000-10-20	1	11250
75852	5194	1551099	1953-04-10	1953-04-10	1	-6110
76849	5253	738818	1974-09-03	1974-09-10	1	1713
35994	2445	1112807	1965-12-24	1966-01-14	1	-1448
63731	4355	1125315	1981-11-14	1981-11-28	1	4349
8612	597	1729720	1962-06-14	1962-06-26	1	-2746
57065	3889	1112807	1941-06-23	1941-07-07	1	-10405
24091	1627	1125315	1977-01-13	1977-01-27	1	2583
73334	5014	1125315	1936-01-11	1936-01-11	1	-12409
71541	4886	1118084	2002-04-15	2002-04-15	1	11792
1905	124	1768849	1985-05-30	1985-06-13	1	5642
72464	4952	1118084	2008-11-01	2008-11-01	1	14184
43707	2951	1713332	2006-11-29	2006-12-20	1	13502
31315	2119	1112807	1962-05-08	1962-06-07	1	-2765
72804	4975	1125315	1960-04-16	1960-04-30	1	-3533
40160	2731	1717327	1961-07-18	1961-08-01	1	-3075
62753	4284	1729720	1981-11-13	1981-11-25	1	4346
39361	2677	1112807	1974-11-30	1974-12-30	1	1824
30418	2058	1729720	2001-06-26	2001-07-03	1	11506
18436	1267	1112807	1955-02-06	1955-03-08	1	-5413
73545	5031	738818	1922-07-28	1922-08-11	1	-17310
18036	1245	1713332	1990-11-29	1990-12-13	1	7651
74801	5119	1125315	2000-09-24	2000-10-08	1	11238
26574	1793	1125315	1962-05-25	1962-07-24	1	-2718
76065	5203	1713332	1998-06-23	1998-07-07	1	10414
37328	2540	1125315	1991-11-30	1991-12-07	1	8010
65826	4497	1112807	1958-06-01	1958-06-15	1	-4218
34315	2328	1125315	1969-12-09	1969-12-16	1	-16
27825	1882	1759842	2007-07-09	2007-07-16	1	13710
25273	1713	1177480	1990-10-26	1990-11-16	1	7624
27600	1864	1521369	1979-11-30	1980-11-24	1	3980
18512	1273	1115008	2009-11-14	2009-11-28	1	14576
26148	1769	738818	2012-08-11	2012-08-18	1	15570
47108	3196	1125315	1983-09-16	1983-09-23	1	5013
75157	5143	1119510	1967-03-09	1967-03-23	1	-1015
75853	5194	1728416	1946-05-17	1946-05-31	1	-8616
76850	5253	1118084	1996-01-14	1996-01-14	1	9509
35995	2445	1118084	1964-03-12	1964-03-12	1	-2121
63732	4355	1759842	1999-05-29	1999-06-12	1	10754
8613	597	1125315	1993-09-05	1993-09-19	1	8662
57066	3889	1125315	1954-02-03	1954-02-10	1	-5804
24092	1627	1125315	1980-06-25	1980-07-09	1	3842
73335	5014	1125315	1987-04-19	1987-04-26	1	6324
71542	4886	1124957	1982-06-07	1982-06-07	1	4540
2136	144	1125315	1980-10-21	1980-11-04	1	3960
72465	4952	1125315	1973-02-17	1973-03-03	1	1157
43708	2951	1717327	1964-01-03	1964-01-19	1	-2174
31316	2119	1118084	2001-05-23	2001-05-23	1	11465
72805	4975	1728416	1960-04-16	1960-04-30	1	-3533
40161	2731	1759842	2014-07-24	2014-07-31	1	16282
62754	4284	1729720	1998-04-01	1998-04-08	1	10324
39362	2677	1125315	2016-05-04	2016-05-11	1	16932
32084	2172	1124300	2012-07-20	2012-07-20	1	15541
18437	1267	1112807	1968-03-29	1968-04-19	1	-622
73546	5031	1125315	1922-07-28	1922-08-11	1	-17310
18037	1245	1729720	1947-08-31	1947-09-08	1	-8151
74802	5119	1738521	1968-02-06	1968-02-20	1	-681
26575	1793	1125315	1975-12-27	1976-01-24	1	2214
76066	5203	1759842	1998-06-23	1998-07-07	1	10414
38520	2620	1112807	1988-09-01	1988-09-22	1	6839
65827	4497	1125315	2005-01-22	2005-01-29	1	12812
34316	2328	1728416	1955-08-23	1955-09-06	1	-5231
27826	1882	738818	2018-10-20	2018-11-03	1	17838
25274	1713	1759842	1988-11-05	1988-11-19	1	6897
27601	1864	1521369	1982-11-14	1983-11-09	1	5060
18513	1273	1125315	2004-09-03	2004-09-10	1	12671
26149	1769	1119510	1978-06-07	1978-06-21	1	3093
47109	3196	1125315	1995-10-31	1995-11-07	1	9441
75158	5143	1119510	1968-04-20	1968-05-04	1	-607
75854	5194	1728416	1948-10-17	1948-10-31	1	-7732
76851	5253	1124957	1971-04-20	1971-04-20	1	474
35996	2445	1125315	1955-11-07	1955-11-21	1	-5155
65947	4505	1102527	1993-03-29	1993-03-29	1	8488
8614	597	1174888	2012-07-27	2012-07-27	1	15548
57067	3889	1125315	1958-04-16	1958-04-23	1	-4271
24093	1627	1125315	1995-10-05	1995-10-12	1	9415
73336	5014	1729720	1927-11-20	1927-12-03	1	-15370
71543	4886	1125315	1989-08-12	1989-08-26	1	7177
2137	144	1125315	2010-07-21	2010-07-28	1	14818
72466	4952	1125315	1973-04-06	1973-04-20	1	1205
43709	2951	1119510	1968-10-24	1968-10-31	1	-427
31317	2119	1119510	2017-12-12	2017-12-19	1	17519
72806	4975	1729720	2011-07-03	2011-07-15	1	15170
40162	2731	738818	1977-09-16	1977-09-30	1	2829
68776	4691	1729720	1967-04-03	1967-04-12	1	-995
39363	2677	1713332	1986-06-27	1986-07-04	1	6028
32085	2172	1119510	2004-01-25	2004-02-08	1	12456
18438	1267	1729720	2016-01-21	2016-02-02	1	16833
73547	5031	1177480	2017-01-02	2017-01-30	1	17196
18038	1245	1759842	1947-12-18	1948-01-01	1	-8036
74803	5119	1118084	2001-08-16	2001-08-16	1	11550
26576	1793	1125315	2002-10-14	2002-10-28	1	11988
76067	5203	738818	1973-08-03	1973-08-10	1	1317
38521	2620	1125315	1989-01-31	1989-02-14	1	6984
65828	4497	1125315	2013-11-06	2013-11-13	1	16022
34317	2328	1729720	1961-04-08	1961-04-18	1	-3180
27827	1882	1102527	2015-04-09	2015-04-09	1	16534
26785	1812	738818	1973-01-21	1973-02-04	1	1130
27602	1864	1713332	1966-07-10	1966-07-31	1	-1250
18514	1273	1713332	1977-06-05	1977-06-26	1	2733
26150	1769	1119510	2012-08-11	2012-08-18	1	15570
47110	3196	1729720	1989-06-28	1989-07-08	1	7128
75159	5143	1125315	2006-01-01	2006-01-15	1	13163
75855	5194	1728416	1950-10-29	1950-11-12	1	-6990
76852	5253	1125315	1974-09-03	1974-09-10	1	1713
35997	2445	1177480	1979-09-17	1979-11-23	1	3613
65948	4505	1119510	1999-07-25	1999-08-08	1	10811
8615	597	1713332	2012-07-27	2012-08-17	1	15569
57068	3889	1125315	1964-02-23	1964-03-08	1	-2125
24094	1627	1759842	2002-10-25	2002-11-08	1	11999
73337	5014	1759842	1932-10-05	1932-10-26	1	-13581
71544	4886	1125315	1996-10-13	1996-10-20	1	9789
2138	144	1521369	1998-10-25	1999-10-20	1	10884
72467	4952	1125315	1975-02-07	1975-02-21	1	1877
43710	2951	1125315	1986-04-07	1986-04-07	1	5940
31318	2119	1125315	1980-04-03	1980-05-08	1	3780
72807	4975	1759842	1968-08-16	1968-12-13	1	-384
40163	2731	1112807	1972-09-06	1972-09-27	1	1000
68777	4691	1125315	1962-03-28	1962-06-26	1	-2746
39364	2677	1713332	1988-01-29	1988-02-05	1	6609
32086	2172	1125315	1980-01-14	1980-01-28	1	3679
18439	1267	1759842	1961-01-13	1961-01-27	1	-3261
73548	5031	1557272	2000-10-14	2000-10-14	1	11244
18039	1245	1112807	1937-07-23	1937-08-20	1	-11822
74804	5119	1125315	1976-11-21	1976-11-28	1	2523
26577	1793	1177480	1991-01-05	1991-03-06	1	7734
76068	5203	1118084	1973-02-25	1973-02-25	1	1151
38522	2620	1713332	2005-02-18	2005-03-04	1	12846
65829	4497	1728416	1974-01-11	1974-01-25	1	1485
34318	2328	1124957	1991-01-07	1991-01-07	1	7676
27828	1882	1125315	2018-10-20	2018-11-03	1	17838
26786	1812	738818	2005-09-02	2005-09-16	1	13042
27603	1864	1125315	2008-04-22	2008-04-29	1	13998
18515	1273	701322	2012-10-18	2012-10-18	1	15631
26151	1769	1124300	2011-09-06	2011-09-06	1	15223
47111	3196	1119510	1983-09-16	1983-09-23	1	5013
75160	5143	1759842	1986-05-11	1986-05-18	1	5981
75856	5194	1729720	1953-08-03	1953-08-11	1	-5987
76853	5253	1713332	1964-02-17	1964-03-02	1	-2131
35998	2445	1119510	1955-11-07	1955-11-21	1	-5155
65949	4505	1713332	2007-09-26	2007-10-10	1	13796
8616	597	738818	1993-09-05	1993-09-19	1	8662
57069	3889	1310149	2003-10-12	2003-10-12	1	12337
25341	1719	1112807	1958-02-03	1958-02-17	1	-4336
73338	5014	1118084	1948-10-19	1948-10-19	1	-7744
71545	4886	738818	2005-04-06	2005-04-20	1	12893
2139	144	1713332	1979-09-04	1979-09-25	1	3554
72468	4952	1503184	1990-02-14	1991-02-09	1	7709
43711	2951	1174888	1986-04-07	1986-04-07	1	5940
31319	2119	1125315	1992-05-05	1992-05-19	1	8174
72808	4975	1112807	1960-02-04	1960-02-18	1	-3605
40164	2731	1125315	1964-02-22	1964-03-07	1	-2126
68778	4691	1729720	1974-02-28	1974-03-13	1	1532
39365	2677	1112807	1980-09-21	1980-10-21	1	3946
32087	2172	1125315	1984-05-29	1984-06-12	1	5276
21525	1466	1115008	1998-03-12	1998-03-26	1	10311
73549	5031	1713332	1930-08-30	1930-09-20	1	-14348
18040	1245	1112807	1986-06-30	1986-08-04	1	6059
74805	5119	1192710	1966-05-28	1966-05-28	1	-1314
26578	1793	1713332	1936-10-11	1936-10-25	1	-12121
76069	5203	1125315	1973-08-03	1973-08-10	1	1317
38523	2620	1759842	2005-02-18	2005-03-04	1	12846
65830	4497	1729720	1963-08-04	1963-08-14	1	-2332
34319	2328	1125315	1991-01-07	1991-02-04	2	7704
27829	1882	1129625	1970-08-31	1970-08-31	1	242
26787	1812	1125315	1973-01-21	1973-02-04	1	1130
27604	1864	1137529	2011-12-23	2011-12-23	1	15331
18516	1273	738818	1941-09-13	1941-09-20	1	-10330
26152	1769	1125315	2012-08-11	2012-08-18	1	15570
47112	3196	1125315	2004-01-19	2004-02-02	1	12450
75161	5143	1125315	1979-09-12	1979-10-10	1	3569
75857	5194	1112807	1946-05-17	1946-05-31	1	-8616
76854	5253	1713332	2009-12-17	2009-12-31	1	14609
35999	2445	1125315	1969-01-28	1969-02-11	1	-324
65950	4505	1112807	1942-02-20	1942-03-13	1	-10156
8617	597	1115008	2001-11-26	2001-12-31	1	11687
57070	3889	1713332	2018-12-16	2018-12-23	1	17888
25342	1719	1112807	1961-09-15	1961-10-06	1	-3009
73339	5014	1124957	1936-01-11	1936-01-11	1	-12409
71546	4886	1119510	1984-03-10	1984-03-17	1	5189
2140	144	933724	2011-01-04	2011-01-11	1	14985
72469	4952	1174888	1994-07-13	1994-07-13	1	8959
43712	2951	1177480	1983-08-07	1983-08-21	1	4980
31320	2119	1125315	2018-12-13	2019-01-03	1	17899
72809	4975	1728416	1961-05-12	1961-05-26	1	-3142
40165	2731	1125315	1977-09-16	1977-09-30	1	2829
68779	4691	1759842	1973-11-15	1973-11-29	1	1428
39366	2677	1713332	1975-12-25	1976-01-01	1	2191
32088	2172	1125315	2004-01-25	2004-02-08	1	12456
21526	1466	1125315	2004-12-19	2005-01-09	1	12792
73550	5031	1713332	2019-01-04	2019-01-18	1	17914
18041	1245	1118084	1976-09-06	1976-09-06	1	2440
74806	5119	1124957	1998-08-11	1998-08-11	1	10449
26579	1793	1713332	1991-01-05	1991-01-12	1	7681
76070	5203	1125315	1999-02-17	1999-02-17	1	10639
38524	2620	19127890	1978-11-03	1979-10-29	1	3588
65831	4497	1112807	1958-02-17	1958-03-03	1	-4322
34320	2328	1713332	1981-10-02	1981-10-09	1	4299
27830	1882	1503184	1984-07-27	1985-07-22	1	5681
26788	1812	1125315	1992-05-09	1992-05-23	1	8178
27605	1864	1177480	1996-08-22	1996-09-05	1	9744
18517	1273	738818	1969-04-28	1969-05-12	1	-234
26153	1769	1500211	1993-08-26	1994-08-21	1	8998
47113	3196	1729720	2011-01-10	2011-01-19	1	14993
75162	5143	1125315	1986-06-25	1986-07-09	1	6033
75858	5194	1112807	1948-10-17	1948-10-31	1	-7732
76855	5253	1759842	2009-12-17	2009-12-31	1	14609
36000	2445	1729720	1933-02-22	1933-03-01	1	-13455
65951	4505	1124300	1981-10-23	1981-10-23	1	4313
8618	597	1115008	2005-10-11	2005-11-01	1	13088
57071	3889	1759842	1952-01-02	1952-01-09	1	-6567
25343	1719	1112807	1987-02-22	1987-03-29	1	6296
73340	5014	1125315	1925-10-29	1925-11-05	1	-16128
71547	4886	1125315	1968-05-23	1968-06-06	1	-574
2141	144	1124300	2011-12-01	2011-12-01	1	15309
72470	4952	1549786	1989-02-19	1990-02-14	1	7349
43713	2951	1177480	1986-04-07	1986-05-07	1	5970
31321	2119	1713332	2014-05-29	2014-06-19	1	16240
40166	2731	1125315	2012-11-20	2012-12-04	1	15678
68780	4691	1112807	1978-12-29	1979-01-28	1	3314
39367	2677	1713332	2000-09-01	2000-09-22	1	11222
32089	2172	1125315	2016-01-19	2016-01-26	1	16826
21527	1466	1713332	1980-12-04	1980-12-25	1	4011
73551	5031	1759842	1930-08-30	1930-09-20	1	-14348
18042	1245	1125315	1940-04-10	1940-04-17	1	-10851
74807	5119	1125315	1980-12-09	1980-12-23	1	4009
26580	1793	1759842	1936-10-11	1936-10-25	1	-12121
76071	5203	1125315	2003-03-19	2003-03-19	1	12130
38525	2620	920293	2002-12-18	2002-12-25	1	12046
65832	4497	1112807	1973-05-29	1973-06-26	1	1272
34321	2328	1713332	1985-12-25	1986-01-15	1	5858
27831	1882	1115008	1999-03-06	1999-03-20	1	10670
26789	1812	1759842	2012-01-19	2012-02-09	1	15379
27606	1864	19127890	1979-11-30	1980-11-24	1	3980
18518	1273	1125315	1941-09-13	1941-09-20	1	-10330
26154	1769	1549786	1989-09-16	1990-09-11	1	7558
47114	3196	1738521	1972-08-24	1972-09-07	1	980
75163	5143	1125315	1965-04-07	1965-05-07	1	-1700
75859	5194	1112807	1949-10-21	1949-11-04	1	-7363
76856	5253	933724	1995-01-12	1995-01-26	1	9156
36001	2445	1759842	1947-04-26	1947-05-10	1	-8272
65952	4505	1125315	1985-04-26	1985-05-10	1	5608
8619	597	1125315	1964-11-29	1964-12-06	1	-1852
57072	3889	1759842	2018-12-16	2018-12-23	1	17888
25344	1719	1119510	1961-03-05	1961-03-19	1	-3210
73341	5014	1137529	1986-10-28	1986-10-28	1	6144
71548	4886	1125315	1979-09-25	1979-10-02	1	3561
2142	144	1125315	1977-02-07	1977-02-21	1	2608
72471	4952	1713332	1994-07-13	1994-08-03	1	8980
43714	2951	1728416	1959-11-11	1959-11-25	1	-3690
31322	2119	975125	1983-06-18	1983-06-18	1	4916
40167	2731	1177480	2008-04-04	2008-04-25	1	13994
68781	4691	1125315	1969-05-20	1969-08-18	1	-136
39368	2677	1729720	1981-12-08	1981-12-17	1	4368
32090	2172	1177480	1980-08-12	1980-08-26	1	3890
21528	1466	1729720	1975-06-30	1975-07-09	1	2015
73552	5031	723013	1948-05-29	1949-01-29	1	-7642
18043	1245	1125315	1949-02-18	1949-02-18	1	-7622
74808	5119	1125315	1998-08-11	1998-10-10	2	10509
26581	1793	1759842	1964-06-05	1964-06-12	1	-2029
76072	5203	1332418	1994-10-05	1994-10-05	1	9043
38526	2620	1118084	2000-10-23	2000-10-23	1	11253
65833	4497	1124300	1992-11-05	1992-11-05	1	8344
34322	2328	1759842	1981-10-02	1981-10-09	1	4299
27832	1882	1119510	1973-02-17	1973-03-03	1	1157
26790	1812	1119510	1973-01-21	1973-02-04	1	1130
27607	1864	19127890	1982-11-14	1983-11-09	1	5060
18519	1273	1125315	1947-11-29	1947-12-13	1	-8055
26155	1769	1549786	1992-08-31	1993-08-26	1	8638
47115	3196	738818	1978-04-27	1978-05-04	1	3045
75164	5143	1125315	1966-10-31	1966-11-07	1	-1151
75860	5194	1112807	1950-10-29	1950-11-12	1	-6990
76857	5253	1119510	1974-09-03	1974-09-10	1	1713
36002	2445	1759842	1962-06-18	1962-07-09	1	-2733
65953	4505	1125315	2016-04-02	2016-04-23	1	16914
8620	597	1125315	1977-07-02	1977-07-16	1	2753
57073	3889	1125315	1943-11-12	1943-11-26	1	-9533
25345	1719	1119510	1973-03-18	1973-03-25	1	1179
73342	5014	1347450	1996-05-28	1996-05-28	1	9644
71549	4886	1125315	2005-04-06	2005-04-20	1	12893
2143	144	1125315	1984-01-21	1984-01-28	1	5140
72472	4952	19127890	1989-02-19	1991-02-09	2	7709
43715	2951	1759842	2006-11-29	2006-12-20	1	13502
31323	2119	1768849	1980-04-03	1980-05-08	1	3780
40168	2731	933724	2008-07-29	2008-08-05	1	14096
68782	4691	1713332	1973-11-15	1973-11-29	1	1428
39369	2677	1759842	2000-09-01	2000-09-22	1	11222
32091	2172	1177480	2007-07-07	2007-09-05	1	13761
21529	1466	19127890	1983-02-25	1984-02-20	1	5163
73553	5031	740275	1941-02-01	1941-02-01	1	-10561
18044	1245	1125315	2013-06-05	2013-06-19	1	15875
74809	5119	1112807	1968-02-06	1968-02-20	1	-681
26582	1793	1759842	1991-01-05	1991-01-12	1	7681
76073	5203	1361711	1988-08-31	1999-02-17	1	10639
38527	2620	1125315	1973-03-24	1973-05-23	1	1238
65834	4497	1125315	1978-03-06	1978-03-20	1	3000
34323	2328	1759842	1985-12-25	1986-01-15	1	5858
27833	1882	1521369	1984-07-27	1985-07-22	1	5681
26791	1812	1713332	2015-06-13	2015-06-27	1	16613
27608	1864	920293	2012-12-19	2012-12-26	1	15700
18520	1273	1125315	1969-04-28	1969-05-12	1	-234
26156	1769	1713332	1982-10-30	1982-11-13	1	4699
47116	3196	1112807	1975-08-23	1975-09-06	1	2074
75165	5143	1125315	1982-03-01	1982-03-15	1	4456
75861	5194	1112807	1969-03-22	1969-04-05	1	-271
76858	5253	1125315	1979-05-08	1979-08-06	1	3504
36003	2445	1112807	1928-08-28	1928-09-18	1	-15080
65954	4505	1713332	1957-03-30	1957-04-13	1	-4646
8621	597	1125315	1985-08-08	1985-08-22	1	5712
57074	3889	1713332	2010-01-15	2010-01-29	1	14638
25346	1719	1125315	1959-08-28	1959-09-11	1	-3765
73343	5014	1713332	1932-10-05	1932-10-26	1	-13581
71550	4886	1125315	2017-12-16	2017-12-23	1	17523
2144	144	1503184	1991-12-01	1992-11-25	1	8364
73768	5044	1729720	1979-08-26	1979-09-07	1	3536
43716	2951	1119510	1965-03-06	1965-03-13	1	-1755
31324	2119	1102527	1980-04-03	1980-04-03	1	3745
40169	2731	1112807	1990-03-21	1990-04-18	1	7412
68783	4691	1713332	1991-05-24	1991-06-14	1	7834
39370	2677	1112807	1975-10-26	1975-11-16	1	2145
32092	2172	1713332	1981-05-11	1981-05-25	1	4162
21530	1466	1112807	1972-02-13	1972-02-27	1	787
73554	5031	1112807	1924-08-03	1924-08-17	1	-16573
18045	1245	1713332	1982-04-07	1982-04-21	1	4493
74810	5119	1125315	1985-04-02	1985-04-16	1	5584
26583	1793	1112807	1921-02-26	1921-03-12	1	-17827
76074	5203	1361711	1999-11-10	2003-03-19	1	12130
38528	2620	1125315	1992-11-05	1993-02-03	1	8434
65835	4497	1177480	1974-01-11	1974-01-25	1	1485
34324	2328	738818	1972-05-15	1972-05-22	1	872
31883	2156	920293	2008-08-17	2008-08-24	1	14115
26792	1812	1759842	2015-06-13	2015-06-27	1	16613
27609	1864	1112807	1971-02-05	1971-02-19	1	414
18521	1273	1125315	1974-04-20	1974-05-18	1	1598
26157	1769	1759842	1982-10-30	1982-11-13	1	4699
47117	3196	1115008	2000-11-25	2000-12-30	1	11321
75166	5143	1125315	1992-04-04	1992-04-25	1	8150
75862	5194	1125315	1952-01-16	1952-02-20	1	-6525
76859	5253	1125315	1991-10-18	1991-10-25	1	7967
36004	2445	1125315	1981-09-08	1981-09-15	1	4275
65955	4505	1112807	1938-04-12	1938-06-11	1	-11527
8622	597	1125315	2003-09-08	2003-09-22	1	12317
57075	3889	1759842	2010-01-15	2010-01-29	1	14638
25347	1719	1125315	2004-12-27	2005-01-26	1	12809
73344	5014	1729720	1916-09-24	1916-10-05	1	-19446
71551	4886	1728416	1968-05-23	1968-06-06	1	-574
2145	144	1515774	1999-10-20	2000-10-14	1	11244
73769	5044	1125315	1986-08-06	1986-08-20	1	6075
43717	2951	1124300	1999-12-26	1999-12-26	1	10951
31325	2119	1125315	1976-04-25	1976-05-02	1	2313
40170	2731	1125315	1961-07-18	1961-08-01	1	-3075
68784	4691	1759842	1991-05-24	1991-06-14	1	7834
39371	2677	1778162	2015-01-29	2015-02-12	1	16478
32093	2172	1713332	1996-11-20	1996-11-27	1	9827
21531	1466	19127890	1987-02-04	1988-01-30	1	6603
73555	5031	1119510	1973-04-30	1973-05-07	1	1222
18046	1245	1713332	1991-06-17	1991-07-01	1	7851
74811	5119	1177480	1978-05-14	1978-05-28	1	3069
26584	1793	1112807	1942-01-28	1942-02-11	1	-10186
76075	5203	1713332	1996-12-14	1996-12-21	1	9851
38529	2620	1125315	2015-11-09	2015-11-23	1	16762
65836	4497	1728416	1958-06-01	1958-06-15	1	-4218
34325	2328	1112807	1959-06-03	1959-06-24	1	-3844
31884	2156	933724	2008-08-17	2008-08-24	1	14115
26793	1812	1119510	2005-09-02	2005-09-16	1	13042
27610	1864	1125315	1979-11-04	1979-11-11	1	3601
18522	1273	1759842	1977-06-05	1977-06-26	1	2733
26158	1769	1119510	2007-12-21	2008-01-04	1	13882
47118	3196	1119510	2011-09-07	2011-09-14	1	15231
75167	5143	1713332	1986-05-11	1986-05-18	1	5981
75863	5194	1125315	2009-01-27	2009-02-03	1	14278
76860	5253	1137529	1984-08-25	1984-08-25	1	5350
36005	2445	1729720	1935-08-19	1935-08-27	1	-12546
65956	4505	1125315	1993-03-29	1993-05-03	1	8523
8623	597	1177480	2012-07-27	2012-08-17	1	15569
57076	3889	1112807	1949-06-11	1949-07-02	1	-7488
25348	1719	1154343	1961-04-15	1961-04-15	1	-3183
73345	5014	1112807	1953-09-06	1953-10-11	1	-5926
71552	4886	1729720	1972-01-16	1972-01-28	1	757
2146	144	1521369	1991-12-01	1992-11-25	1	8364
73770	5044	1125315	1993-05-15	1993-05-29	1	8549
43718	2951	1125315	1963-08-23	1963-09-06	1	-2309
31326	2119	1729720	1961-10-13	1961-10-24	1	-2991
40171	2731	1125315	1970-12-16	1971-01-15	1	379
68785	4691	1124300	2002-01-12	2002-01-12	1	11699
39372	2677	1115008	2014-02-24	2014-03-18	1	16147
32094	2172	1759842	1996-11-20	1996-11-27	1	9827
21532	1466	1112807	1969-07-28	1969-08-11	1	-143
73556	5031	1124957	1982-10-07	1982-10-07	1	4662
18047	1245	1759842	1951-03-21	1951-04-11	1	-6840
76257	5215	914335	1960-07-11	1960-07-11	1	-3461
26585	1793	1118084	1963-03-18	1963-03-18	1	-2481
76076	5203	1729720	1967-01-14	1967-01-24	1	-1073
38530	2620	1521369	1978-11-03	1979-10-29	1	3588
70027	4781	738818	1998-12-03	1998-12-10	1	10570
34326	2328	1125315	1972-05-15	1972-05-22	1	872
31885	2156	1115008	2017-02-15	2017-03-22	1	17247
26794	1812	1124957	2005-09-28	2005-09-28	1	13054
27611	1864	1759842	1984-08-23	1984-08-30	1	5355
18523	1273	1112807	1943-05-05	1943-06-02	1	-9710
26159	1769	1125315	1986-05-25	1986-06-22	1	6016
47119	3196	1125315	1978-04-27	1978-05-04	1	3045
75864	5194	1729720	1948-12-15	1948-12-24	1	-7678
76861	5253	1713332	1988-07-24	1988-07-31	1	6786
37616	2555	1112807	1953-11-10	1953-11-24	1	-5882
65957	4505	1759842	1957-03-30	1957-04-13	1	-4646
8624	597	1729720	2003-06-21	2003-06-29	1	12232
57077	3889	1125315	2010-05-04	2010-05-18	1	14747
25349	1719	1729720	1965-06-12	1965-06-23	1	-1653
73346	5014	1125315	1949-05-05	1949-05-19	1	-7532
71553	4886	738818	1984-03-10	1984-03-17	1	5189
2147	144	1112807	1978-10-30	1978-11-20	1	3245
73771	5044	1115008	2013-02-13	2013-02-27	1	15763
43719	2951	1521369	1976-10-22	1977-10-17	1	2846
31327	2119	1759842	2014-05-29	2014-06-19	1	16240
40172	2731	1125315	1973-05-25	1973-06-01	1	1247
68786	4691	1125315	1978-12-29	1978-12-29	1	3284
39373	2677	1118084	2006-11-27	2006-11-27	1	13479
32095	2172	1768849	1979-09-02	1979-09-16	1	3545
21533	1466	1125315	2016-02-23	2016-03-01	1	16861
73557	5031	1125315	1990-08-17	1990-10-16	1	7593
18048	1245	1759842	1963-11-08	1963-11-22	1	-2232
76258	5215	1115008	2004-03-30	2004-05-29	1	12567
26586	1793	1119510	1932-07-29	1932-08-12	1	-13656
76077	5203	1119510	1973-08-03	1973-08-10	1	1317
38531	2620	933724	2002-12-18	2002-12-25	1	12046
70028	4781	1118084	2018-05-16	2018-05-16	1	17667
34327	2328	1125315	2009-12-08	2009-12-15	1	14593
31886	2156	1125315	1967-06-08	1967-08-07	1	-878
26795	1812	1729720	1971-03-04	1971-03-13	1	436
28912	1956	1729720	1994-01-27	1994-02-07	1	8803
18524	1273	1118084	1976-08-19	1976-08-19	1	2422
26160	1769	1125315	1989-03-10	1989-03-24	1	7022
47367	3216	738818	2002-06-13	2002-06-27	1	11865
75865	5194	1759842	1990-01-30	1990-02-06	1	7341
76862	5253	1759842	1988-07-24	1988-07-31	1	6786
37617	2555	1119510	2004-09-22	2004-09-29	1	12690
65958	4505	1759842	2007-09-26	2007-10-10	1	13796
8625	597	920293	2006-06-01	2006-06-08	1	13307
57078	3889	1307863	2003-10-12	2003-10-12	1	12337
25350	1719	738818	1961-03-05	1961-03-19	1	-3210
73347	5014	1149380	1986-10-28	1986-10-28	1	6144
71554	4886	920293	1987-09-27	1987-10-04	1	6485
2148	144	1503184	1998-10-25	1999-10-20	1	10884
73772	5044	1118084	2015-07-23	2015-07-23	1	16639
45012	3057	1112807	1938-07-28	1938-08-11	1	-11466
31328	2119	738818	2017-12-12	2017-12-19	1	17519
40173	2731	1125315	1986-03-21	1986-04-11	1	5944
68787	4691	1125315	2006-03-09	2006-03-16	1	13223
39374	2677	1125315	2009-07-02	2009-07-09	1	14434
32096	2172	1177480	1981-05-11	1981-05-25	1	4162
21534	1466	1503184	1983-02-25	1984-02-20	1	5163
73558	5031	1125315	2002-02-06	2002-02-13	1	11731
18049	1245	1759842	1968-11-02	1968-11-23	1	-404
76259	5215	1125315	1954-09-14	1954-09-28	1	-5574
26587	1793	1125315	1934-04-14	1934-04-28	1	-13032
76078	5203	1125315	1961-09-15	1961-09-22	1	-3023
38532	2620	1115008	2005-03-07	2005-04-11	1	12884
70029	4781	1115008	1998-10-03	1998-10-31	1	10530
34328	2328	1713332	1993-08-22	1993-10-03	1	8676
31887	2156	19127890	1980-07-09	1981-07-04	1	4202
26796	1812	1118084	2003-10-04	2003-10-04	1	12329
28913	1956	1125315	1972-11-04	1973-02-02	1	1128
18525	1273	1119510	1941-09-13	1941-09-20	1	-10330
26161	1769	1515774	1992-08-31	1993-08-26	1	8638
47368	3216	1112807	1958-06-01	1958-07-31	1	-4172
75866	5194	1115008	2003-11-03	2003-12-01	1	12387
76863	5253	920293	1995-01-12	1995-01-26	2	9156
37618	2555	1125315	2004-09-22	2004-09-29	1	12690
65959	4505	738818	1999-07-25	1999-08-08	1	10811
8626	597	933724	2006-06-01	2006-06-08	1	13307
57079	3889	1713332	1952-01-02	1952-01-09	1	-6567
25351	1719	738818	2015-01-28	2015-02-04	1	16470
73348	5014	1713332	1930-06-20	1930-07-11	1	-14419
71555	4886	933724	1987-09-27	1987-10-04	1	6485
2149	144	1713332	1986-01-28	1986-02-18	1	5892
73773	5044	1361711	2010-02-03	2010-02-03	1	14643
45013	3057	1112807	1950-10-12	1950-10-26	1	-7007
31329	2119	1125315	1994-03-10	1994-03-24	1	8848
40174	2731	1125315	1986-09-21	1986-10-05	1	6121
68788	4691	1174888	1978-12-29	1978-12-29	1	3284
39375	2677	1125315	2015-01-29	2015-02-12	1	16478
32097	2172	1713332	1980-01-14	1980-01-28	1	3679
21535	1466	1503184	1987-02-04	1988-01-30	1	6603
73559	5031	1347450	1995-08-19	1995-08-19	1	9361
18050	1245	1759842	1982-04-07	1982-04-21	1	4493
76260	5215	1125315	2008-07-29	2008-08-05	1	14096
26588	1793	1125315	1982-04-20	1982-05-04	1	4506
76079	5203	1125315	1980-03-25	1980-04-22	1	3764
38533	2620	1125315	1989-08-18	1989-09-22	1	7204
70030	4781	1119510	2013-09-15	2013-09-22	1	15970
34329	2328	1713332	2005-11-13	2005-11-27	1	13114
31888	2156	1118084	2009-03-04	2009-03-04	1	14307
26797	1812	1125315	1984-06-12	1984-06-19	1	5283
28914	1956	1125315	1996-04-23	1996-05-07	1	9623
18526	1273	1119510	1969-04-28	1969-05-12	1	-234
26162	1769	1515774	1994-08-21	1995-08-16	1	9358
47369	3216	1119510	2002-06-13	2002-06-27	1	11865
75867	5194	1124300	1982-08-26	1982-08-26	1	4620
76864	5253	1125315	1961-01-12	1961-01-26	1	-3262
37619	2555	1728416	1953-04-02	1953-04-16	1	-6104
65960	4505	1125315	1945-05-07	1945-05-21	1	-8991
8627	597	1118084	1987-01-17	1987-01-17	1	6225
57080	3889	1713332	1994-10-23	1994-11-06	1	9075
25352	1719	1125315	1959-06-11	1959-06-25	1	-3843
73349	5014	1729720	1921-09-11	1921-09-19	1	-17636
71556	4886	1112807	1968-07-22	1968-10-20	1	-438
2150	144	1759842	1986-01-28	1986-02-18	1	5892
73774	5044	1322184	2010-02-03	2010-02-03	1	14643
45014	3057	1115008	2017-10-04	2017-12-03	1	17503
31330	2119	1125315	2017-12-12	2017-12-19	1	17519
40175	2731	1309944	2007-07-09	2007-07-09	1	13703
68789	4691	1729720	1969-10-09	1969-10-20	1	-73
39376	2677	1759842	1975-12-25	1976-01-01	1	2191
32098	2172	1713332	1984-05-29	1984-06-12	1	5276
21536	1466	1521369	1987-02-04	1988-01-30	1	6603
73560	5031	1713332	1986-05-31	1986-06-21	1	6015
18051	1245	1759842	1991-06-17	1991-07-01	1	7851
76261	5215	1177480	2002-05-12	2002-06-09	1	11847
26589	1793	1125315	2002-06-16	2002-06-30	1	11868
76080	5203	1729720	1949-11-23	1949-12-03	1	-7334
38534	2620	1177480	1979-09-19	1979-11-18	1	3608
70031	4781	1125315	1998-12-03	1998-12-10	1	10570
34330	2328	1729720	2016-07-08	2016-07-19	1	17001
31889	2156	738818	2014-02-12	2014-02-26	1	16127
26798	1812	1125315	2005-09-02	2005-11-27	3	13102
28915	1956	1177480	2002-07-21	2002-08-11	1	11910
18527	1273	1713332	2009-11-14	2009-11-28	1	14576
26163	1769	1549786	1994-08-21	1995-08-16	1	9358
47370	3216	1125315	1955-02-17	1955-03-03	1	-5418
75868	5194	1125315	2000-05-08	2000-05-15	1	11092
76865	5253	1125315	1971-04-20	1971-05-20	2	504
37620	2555	1728416	1953-11-10	1953-11-24	1	-5882
65961	4505	1125315	1992-12-12	1992-12-26	1	8395
8628	597	1125315	1966-10-06	1966-10-13	1	-1176
57081	3889	1729720	1966-02-25	1966-03-07	1	-1396
25353	1719	1125315	1961-03-05	1961-03-19	1	-3210
73350	5014	1759842	1930-06-20	1930-07-11	1	-14419
71557	4886	1119510	2005-04-06	2005-04-20	1	12893
2151	144	19127890	1991-12-01	1992-11-25	1	8364
73775	5044	1332418	2010-02-03	2010-02-03	1	14643
45015	3057	1125315	1979-11-10	1979-11-17	1	3607
31331	2119	1129625	1983-06-29	1983-06-29	1	4927
40176	2731	1503184	1974-07-08	1975-07-03	1	2009
70235	4799	920293	1986-12-14	1986-12-21	1	6198
39377	2677	1759842	1986-06-27	1986-07-04	1	6028
32099	2172	738818	2004-01-25	2004-02-08	1	12456
21537	1466	1118084	2004-11-16	2004-11-16	1	12738
73561	5031	1768849	1982-10-07	1982-10-28	1	4683
18052	1245	1112807	1935-10-02	1935-10-16	1	-12496
76262	5215	1343916	1960-07-11	1960-07-11	1	-3461
26590	1793	1332418	1994-06-29	1994-06-29	1	8945
76081	5203	1759842	1996-12-14	1996-12-21	1	9851
38535	2620	1713332	1974-12-20	1975-01-03	1	1828
70032	4781	1125315	2013-09-15	2013-09-22	1	15970
35493	2414	738818	1950-06-10	1950-06-24	1	-7131
31890	2156	1102527	1988-04-18	1988-04-18	1	6682
26799	1812	1713332	2012-01-19	2012-02-09	1	15379
28916	1956	1124300	2005-07-29	2005-07-29	1	12993
19352	1322	1118084	1958-09-01	1958-09-01	1	-4140
26164	1769	1713332	2003-03-05	2003-03-19	1	12130
47371	3216	1125315	2002-06-13	2002-06-27	1	11865
75869	5194	1713332	1990-01-30	1990-02-06	1	7341
76866	5253	1125315	1980-04-13	1980-04-20	1	3762
37621	2555	1124300	1990-11-13	1990-11-13	1	7621
65962	4505	1125315	1999-07-25	1999-08-08	1	10811
8629	597	1125315	1984-06-30	1984-07-14	1	5308
60511	4127	1115008	1994-03-16	1994-04-06	1	8861
25354	1719	1125315	1973-03-18	1973-03-25	1	1179
75587	5174	1112807	1938-08-21	1938-09-04	1	-11442
71558	4886	1125315	1970-11-09	1971-02-07	1	402
2152	144	19127890	1993-11-20	1994-11-15	1	9084
73776	5044	1539403	2010-02-03	2010-02-03	1	14643
45016	3057	1112807	1941-05-30	1941-06-13	1	-10429
31332	2119	1713332	1987-05-20	1987-06-03	1	6362
40177	2731	1728416	1960-12-08	1960-12-22	1	-3297
70236	4799	933724	1986-12-14	1986-12-21	1	6198
39378	2677	1759842	1988-01-29	1988-02-05	1	6609
32100	2172	1125315	1979-09-02	1979-09-16	1	3545
21538	1466	1521369	1983-02-25	1984-02-20	1	5163
73562	5031	738818	1973-04-30	1973-05-07	1	1222
18053	1245	1115008	2008-08-08	2008-11-06	1	14189
76263	5215	1713332	1958-12-13	1958-12-27	1	-4023
26591	1793	1361711	1980-07-23	1980-07-23	1	3856
76082	5203	1125315	1941-05-16	1941-05-30	1	-10443
38536	2620	1713332	2005-04-09	2005-04-30	1	12903
70033	4781	1778162	1997-11-07	1997-11-21	1	10186
35494	2414	738818	1989-07-08	1989-07-22	1	7142
31891	2156	1112807	1968-08-01	1968-08-15	1	-504
28557	1934	1115008	2001-11-02	2001-11-23	1	11649
28917	1956	1125315	1967-03-07	1967-03-21	1	-1017
19353	1322	1125315	1989-05-17	1989-05-24	1	7083
26165	1769	1759842	2011-03-28	2011-04-11	1	15075
47372	3216	1177480	1974-02-12	1974-03-19	1	1538
75870	5194	1125315	1946-06-17	1946-06-24	1	-8592
76867	5253	1125315	1991-03-13	1991-03-20	1	7748
37622	2555	1125315	1971-04-08	1971-05-14	1	498
65963	4505	1729720	1981-05-21	1981-06-03	1	4171
8630	597	1729720	1963-03-26	1963-04-04	1	-2464
60512	4127	1125315	2005-09-27	2005-10-11	1	13067
25355	1719	1125315	1993-02-23	1993-03-30	1	8489
75588	5174	1124300	1981-01-07	1981-01-07	1	4024
71559	4886	1125315	1978-09-28	1978-10-26	1	3220
2153	144	19127890	1996-11-04	1997-10-30	1	10164
73777	5044	1713332	2013-02-13	2013-02-27	1	15763
45017	3057	1118084	1973-06-14	1973-06-14	1	1260
31333	2119	1713332	1991-04-22	1991-05-06	1	7795
40178	2731	914335	2007-07-09	2007-07-09	1	13703
70237	4799	1124300	1997-02-19	1997-02-19	1	9911
41234	2799	1177480	1985-04-06	1985-04-20	1	5588
32101	2172	1713332	1980-08-12	1980-08-26	1	3890
21539	1466	1717327	1969-07-28	1969-08-11	1	-143
73563	5031	1112807	1920-06-06	1920-06-20	1	-18092
18054	1245	1125315	2011-05-29	2011-06-05	1	15130
76264	5215	1713332	1960-11-22	1960-12-13	1	-3306
26592	1793	1729720	2005-12-28	2006-01-07	1	13155
76083	5203	1322184	1997-10-29	1999-02-17	1	10639
38537	2620	1759842	2005-04-09	2005-04-30	1	12903
70034	4781	738818	2013-09-15	2013-09-22	1	15970
35495	2414	836654	1996-08-29	1996-08-29	1	9737
31892	2156	1119510	2014-02-12	2014-02-26	1	16127
28558	1934	1717327	1963-12-03	1963-12-17	1	-2207
28918	1956	1125315	1975-01-23	1975-02-13	1	1869
19354	1322	1125315	2007-06-20	2007-06-27	1	13691
26166	1769	1713332	2011-03-28	2011-04-11	1	15075
47373	3216	1125315	1959-10-26	1959-11-09	1	-3706
77975	5328	738818	1974-08-13	1974-08-27	1	1699
76868	5253	1759842	1964-02-17	1964-03-02	1	-2131
37623	2555	738818	2004-09-22	2004-09-29	1	12690
65964	4505	1778162	1993-03-29	1993-05-03	1	8523
8631	597	1729720	1970-06-30	1970-07-13	1	193
60513	4127	1347450	2012-04-01	2012-04-01	1	15431
25356	1719	1125315	2015-01-28	2015-02-04	1	16470
75589	5174	1125315	1960-10-26	1960-11-09	1	-3340
71560	4886	1125315	1982-06-07	1982-09-05	2	4630
2154	144	920293	2011-01-04	2011-01-11	1	14985
73979	5058	1112807	1943-08-05	1943-09-09	1	-9611
45018	3057	1125315	1966-12-28	1967-03-28	1	-1010
31334	2119	1759842	1987-05-20	1987-06-03	1	6362
40179	2731	920293	2008-07-29	2008-08-05	1	14096
70238	4799	1125315	1958-04-15	1958-04-29	1	-4265
41235	2799	1713332	1985-04-06	1985-04-20	1	5588
32353	2192	738818	1997-11-15	1997-11-29	1	10194
21540	1466	1759842	1980-12-04	1980-12-25	1	4011
73564	5031	1112807	1922-01-08	1922-01-22	1	-17511
18055	1245	1310149	2016-07-01	2016-07-01	1	16983
76265	5215	1728416	1954-09-14	1954-09-28	1	-5574
28180	1911	738818	1959-11-23	1959-12-07	1	-3678
76084	5203	1322184	1999-11-10	2003-03-19	1	12130
38538	2620	1102527	1992-11-05	1992-11-05	1	8344
70035	4781	1115008	1997-11-07	1997-11-21	1	10186
35496	2414	1112807	1929-06-05	1929-06-19	1	-14806
31893	2156	1125315	1978-10-10	1978-10-17	1	3211
28559	1934	1124300	2000-08-12	2000-08-12	1	11181
28919	1956	1125315	2016-01-07	2016-01-14	1	16814
19355	1322	1557272	2003-08-13	2003-08-13	1	12277
26167	1769	1759842	2003-03-05	2003-03-19	1	12130
47374	3216	1125315	1961-08-14	1961-09-04	1	-3041
77976	5328	920293	1966-10-09	1966-10-16	1	-1173
37624	2555	1112807	1953-04-02	1953-04-16	1	-6104
67241	4591	1125315	1964-06-18	1964-06-25	1	-2016
10144	697	738818	1986-04-16	1986-04-23	1	5956
60514	4127	1728416	1949-04-19	1949-05-03	1	-7548
25357	1719	1149380	1961-04-15	1961-04-15	1	-3183
75590	5174	738818	1978-11-19	1978-11-26	1	3251
71561	4886	1125315	1984-03-10	1984-03-17	1	5189
2155	144	1515774	1993-11-20	1994-11-15	1	9084
73980	5058	1118084	1978-05-18	1978-05-18	1	3059
45019	3057	1322184	2016-10-24	2016-10-24	1	17098
31335	2119	1759842	1991-04-22	1991-05-06	1	7795
40180	2731	1112807	1966-02-24	1966-03-10	1	-1393
70239	4799	1125315	1969-04-17	1969-05-01	1	-245
41236	2799	1115008	2000-05-17	2000-05-31	1	11108
32354	2192	1125315	1997-11-15	1997-11-29	1	10194
24338	1642	1125315	1951-06-22	1951-07-06	1	-6754
73565	5031	1112807	1946-02-20	1946-03-20	1	-8688
18056	1245	1713332	1951-03-21	1951-04-11	1	-6840
76266	5215	1728416	1978-07-14	1978-08-11	1	3144
28181	1911	920293	1987-12-23	1987-12-30	1	6572
76085	5203	1539403	1991-09-18	1991-09-18	1	7930
38539	2620	1115008	2001-06-21	2001-07-26	1	11529
70036	4781	1125315	2007-05-17	2007-08-15	1	13740
35497	2414	1112807	1970-09-12	1970-10-17	1	289
31894	2156	1125315	2014-02-12	2014-02-26	1	16127
28560	1934	1125315	1963-04-29	1963-05-13	1	-2425
29612	2002	1125315	1980-05-17	1980-05-31	1	3803
19356	1322	1713332	1960-04-30	1960-05-21	1	-3512
26168	1769	1778162	1989-03-10	1989-03-24	1	7022
47375	3216	1125315	1963-07-26	1963-08-09	1	-2337
77977	5328	933724	1966-10-09	1966-10-16	1	-1173
37625	2555	1112807	1969-04-28	1969-05-19	1	-227
67242	4591	1125315	1982-10-05	1982-10-19	1	4674
10145	697	1112807	1973-08-30	1973-09-13	1	1351
60515	4127	1115008	2011-11-03	2011-12-01	1	15309
25358	1719	1557272	2017-06-13	2017-06-13	1	17330
75591	5174	933724	1966-02-20	1966-02-27	1	-1404
72569	4960	1125315	1930-09-03	1930-09-17	1	-14351
2156	144	1515774	1996-11-04	1997-10-30	1	10164
73981	5058	1125315	1991-04-19	1991-05-03	1	7792
45020	3057	1347450	2016-10-24	2016-10-24	1	17098
34120	2318	1177480	1984-03-11	1984-04-08	1	5211
40181	2731	1112807	1975-07-14	1975-08-11	1	2048
70240	4799	1125315	1971-04-07	1971-04-14	1	468
41237	2799	1125315	1995-05-14	1995-06-13	1	9294
32355	2192	1503184	1983-10-05	1984-09-29	1	5385
24339	1642	1125315	1978-07-15	1978-07-22	1	3124
73566	5031	1115008	2009-08-28	2009-09-11	1	14498
18057	1245	1713332	1963-11-08	1963-11-22	1	-2232
76267	5215	1125315	1970-02-05	1970-04-06	1	95
28182	1911	1124300	1984-05-05	1984-05-05	1	5238
76086	5203	1713332	1997-01-29	1997-02-19	1	9911
38540	2620	1503184	1978-11-03	1979-10-29	1	3588
70037	4781	1729720	1987-03-09	1987-03-20	1	6287
35498	2414	1119510	1981-10-29	1981-11-05	1	4326
31895	2156	1177480	1988-04-18	1988-06-17	1	6742
28561	1934	1125315	2013-01-22	2013-01-29	1	15734
29613	2002	1125315	1982-07-02	1982-08-06	1	4600
19357	1322	1729720	1945-09-09	1945-09-22	1	-8867
26169	1769	19127890	1989-09-16	1990-09-11	1	7558
47376	3216	1713332	2005-09-04	2005-09-18	1	13044
77978	5328	1112807	1913-08-21	1913-09-04	1	-20573
37626	2555	1125315	2013-08-10	2013-08-24	1	15941
67243	4591	1177480	1974-07-25	1974-08-29	1	1701
10146	697	1118084	2000-03-21	2000-03-21	1	11037
60516	4127	1125315	1965-11-22	1965-12-06	1	-1487
25359	1719	1728416	1959-06-11	1959-06-25	1	-3843
75592	5174	1112807	1947-02-08	1947-03-10	1	-8333
72570	4960	1125315	1948-01-02	1948-01-16	1	-8021
2157	144	1549786	1993-11-20	1994-11-15	1	9084
73982	5058	1125315	1995-04-27	1995-05-04	1	9254
45021	3057	1557272	1997-03-03	1997-03-03	1	9923
34121	2318	19127890	1978-01-17	1979-01-12	1	3298
40182	2731	1125315	1984-06-08	1984-06-29	1	5293
70241	4799	1309944	2010-05-01	2010-05-01	1	14730
41238	2799	1102527	1995-05-14	1995-05-14	1	9264
32356	2192	1713332	1979-06-07	1979-09-06	1	3535
24340	1642	1125315	1981-08-12	1981-08-26	1	4255
73567	5031	1118084	1956-06-17	1956-06-17	1	-4946
18058	1245	1713332	1968-11-02	1968-11-23	1	-404
76268	5215	1713332	2017-12-22	2018-01-05	1	17536
28183	1911	1125315	1959-11-23	1959-12-07	1	-3678
76087	5203	1729720	1947-01-24	1947-02-05	1	-8366
38541	2620	1759842	1974-12-20	1975-01-03	1	1828
70038	4781	1119510	1998-12-03	1998-12-10	1	10570
35499	2414	1125315	1919-05-31	1919-06-14	1	-18464
31896	2156	1521369	1980-07-09	1981-07-04	1	4202
28562	1934	1713332	1987-12-01	1987-12-22	1	6564
29614	2002	1125315	1983-08-01	1983-10-07	1	5027
19358	1322	738818	1957-02-07	1957-02-14	1	-4704
26170	1769	738818	1978-06-07	1978-06-21	1	3093
47377	3216	1713332	2017-11-17	2017-12-01	1	17501
77979	5328	1119510	1975-12-26	1976-01-09	1	2199
37627	2555	1729720	1958-02-26	1958-03-06	1	-4319
67244	4591	1177480	1989-11-22	1989-12-06	1	7279
10147	697	1125315	1986-04-16	1986-04-23	1	5956
60517	4127	1125315	1976-07-05	1976-07-19	1	2391
25360	1719	738818	1973-03-18	1973-03-25	1	1179
75593	5174	1125315	1978-11-19	1978-11-26	1	3251
72571	4960	1125315	1991-02-14	1991-03-07	1	7735
2158	144	1549786	1996-11-04	1997-10-30	1	10164
73983	5058	1125315	2014-07-17	2014-09-22	2	16335
45022	3057	1729720	1942-03-08	1942-03-15	1	-10154
34122	2318	708298	1969-03-09	1969-03-09	1	-298
40183	2731	1177480	1977-07-01	1977-07-15	1	2752
70242	4799	1343916	2010-05-01	2010-05-01	1	14730
41239	2799	1118084	2018-01-13	2018-01-13	1	17544
32357	2192	1728416	1957-01-11	1957-01-25	1	-4724
24341	1642	1347450	2008-06-17	2008-06-17	1	14047
73568	5031	1125315	1928-02-17	1928-02-24	1	-15287
18059	1245	1759842	1984-02-19	1984-02-26	1	5169
76269	5215	1102527	1978-07-14	1978-07-14	1	3116
28184	1911	1125315	1960-03-12	1960-06-10	1	-3492
76088	5203	1759842	1997-01-29	1997-02-19	1	9911
40754	2768	1729720	2006-04-04	2006-04-16	1	13254
70663	4827	1112807	1970-12-18	1971-01-01	1	365
35500	2414	1125315	1950-06-10	1950-06-24	1	-7131
31897	2156	1713332	1988-12-31	1989-01-07	1	6946
28563	1934	1112807	1963-12-03	1963-12-17	1	-2207
29615	2002	1125315	1996-02-09	1996-02-16	1	9542
19359	1322	1125315	1957-02-07	1957-02-14	1	-4704
26171	1769	738818	2007-12-21	2008-01-04	1	13882
47378	3216	1728416	1955-02-17	1955-03-03	1	-5418
77980	5328	1125315	1939-02-03	1939-02-17	1	-11276
37628	2555	1125315	1950-06-07	1950-06-21	1	-7134
67245	4591	1119510	1964-06-18	1964-06-25	1	-2016
10148	697	1125315	1989-03-28	1989-04-04	1	7033
60518	4127	1125315	1985-08-09	1985-08-30	1	5720
25361	1719	1112807	1967-03-09	1967-04-08	1	-999
75594	5174	1177480	2003-05-13	2003-06-12	1	12215
72572	4960	1501700	1977-03-31	1977-03-31	1	2646
2159	144	1549786	1999-10-20	2000-10-14	1	11244
73984	5058	1125315	1975-06-23	1975-07-14	1	2020
45023	3057	1112807	1992-02-13	1992-03-05	1	8099
34123	2318	967823	1969-03-09	1969-03-09	1	-298
40184	2731	1343916	2007-07-09	2007-07-09	1	13703
70243	4799	738818	1963-12-16	1963-12-23	1	-2201
41240	2799	1177480	1986-08-29	1986-11-27	1	6174
32358	2192	1729720	1955-10-20	1955-10-30	1	-5177
24342	1642	738818	2018-07-05	2018-07-12	1	17724
73569	5031	1125315	1943-08-05	1943-08-19	1	-9632
18060	1245	1759842	1990-11-29	1990-12-13	1	7651
76270	5215	1112807	1941-11-04	1941-11-18	1	-10271
28185	1911	1137529	1998-09-07	1998-09-07	1	10476
40755	2768	1729720	2009-10-30	2009-11-11	1	14559
70664	4827	1125315	1983-04-28	1983-05-28	1	4895
35501	2414	1125315	1989-07-08	1989-07-22	1	7142
31898	2156	1759842	1988-12-31	1989-01-07	1	6946
28564	1934	1112807	1964-07-02	1964-07-16	1	-1995
29616	2002	1125315	2007-10-21	2007-11-04	1	13821
19360	1322	1125315	1996-12-02	1996-12-23	1	9853
26172	1769	1125315	1978-06-07	1978-06-21	1	3093
47379	3216	1125315	1963-10-22	1963-11-05	1	-2249
77981	5328	1125315	1974-08-13	1974-08-27	1	1699
37629	2555	1125315	1955-09-04	1955-09-18	1	-5219
67246	4591	1125315	2003-03-19	2003-03-26	1	12137
10149	697	1125315	1995-12-10	1995-12-17	1	9481
60519	4127	1112807	1948-07-23	1948-08-13	1	-7811
25362	1719	1118084	1996-05-19	1996-05-19	1	9635
75595	5174	1112807	1939-01-18	1939-02-22	1	-11271
72573	4960	1713332	1943-05-05	1943-05-12	1	-9731
2160	144	1738521	1977-02-07	1977-02-21	1	2608
73985	5058	1174888	2014-07-24	2014-07-24	1	16275
45024	3057	1115008	2004-10-28	2004-11-11	1	12733
34124	2318	1125315	1963-08-24	1963-09-07	1	-2308
40185	2731	1713332	2014-07-24	2014-07-31	1	16282
70244	4799	914335	2010-05-01	2010-05-01	1	14730
42450	2876	920293	2004-10-24	2004-10-31	1	12722
32359	2192	1759842	1979-06-07	1979-09-06	1	3535
24343	1642	1125315	2018-07-05	2018-07-12	1	17724
73570	5031	1125315	1973-04-30	1973-05-07	1	1222
18061	1245	914335	2003-10-10	2003-10-10	1	12335
76271	5215	1115008	2008-08-06	2008-09-10	1	14132
28186	1911	1728416	1950-05-17	1950-05-31	1	-7155
40756	2768	19127890	1984-06-01	1986-05-22	2	5985
70665	4827	1125315	1995-02-02	1995-02-09	1	9170
35502	2414	1310149	1994-08-18	1994-08-18	1	8995
31899	2156	1503184	1980-07-09	1981-07-04	1	4202
28565	1934	1112807	1965-09-06	1965-09-20	1	-1564
29617	2002	1177480	1976-04-06	1976-05-04	1	2315
19361	1322	1729720	1937-06-18	1937-06-25	1	-11878
26173	1769	1125315	2007-12-21	2008-01-04	1	13882
47380	3216	1728416	1956-03-26	1956-04-09	1	-5015
77982	5328	1713332	1941-12-23	1941-12-30	1	-10229
37630	2555	1125315	1995-04-08	1995-04-22	1	9242
67247	4591	1713332	1989-01-28	1989-02-04	1	6974
10150	697	1119510	1973-08-01	1973-08-15	1	1322
60520	4127	1125315	1951-08-28	1951-10-02	1	-6666
25363	1719	1125315	1973-06-25	1973-07-02	1	1278
75596	5174	1112807	1940-12-13	1941-01-10	1	-10583
72574	4960	1112807	1909-06-16	1909-06-30	1	-22100
2161	144	1759842	1979-09-04	1979-09-25	1	3554
73986	5058	1557272	2017-03-05	2017-03-05	1	17230
45025	3057	1125315	1941-04-15	1941-04-29	1	-10474
34125	2318	1367571	1969-03-09	1969-03-09	1	-298
40186	2731	19127890	1974-07-08	1975-07-03	1	2009
70245	4799	1125315	1963-12-16	1963-12-23	1	-2201
42451	2876	1112807	1966-09-07	1966-09-21	1	-1198
32360	2192	19127890	1974-11-18	1975-11-13	1	2142
24344	1642	1713332	1981-08-12	1981-08-26	1	4255
73571	5031	1125315	1982-10-07	1982-10-28	2	4683
18062	1245	1112807	1959-02-17	1959-05-18	1	-3881
76272	5215	1124300	1982-03-19	1982-03-19	1	4460
28187	1911	1729720	1948-03-17	1948-03-29	1	-7948
40757	2768	1125315	1988-02-15	1988-03-07	1	6640
70666	4827	1125315	2016-02-29	2016-03-14	1	16874
35503	2414	1539403	1991-08-01	1991-08-01	1	7882
32172	2176	1118084	2000-06-30	2000-06-30	1	11138
28566	1934	1125315	1961-05-24	1961-06-07	1	-3130
29618	2002	1177480	2019-02-14	2019-03-14	1	17969
19362	1322	1759842	1960-04-30	1960-05-21	1	-3512
26174	1769	1515774	1989-09-16	1990-09-11	1	7558
47381	3216	1759842	2005-09-04	2005-09-18	1	13044
77983	5328	738818	1929-01-18	1929-01-25	1	-14951
37631	2555	1728416	1950-06-07	1950-06-21	1	-7134
67248	4591	1118084	1995-01-26	1995-01-26	1	9156
10151	697	1119510	1986-04-16	1986-04-23	1	5956
60521	4127	1125315	1957-06-02	1957-07-07	1	-4561
25364	1719	1125315	1991-03-08	1991-04-05	1	7764
3328	222	1115008	2003-09-07	2003-11-13	1	12369
72575	4960	1112807	1943-09-30	1943-10-28	1	-9562
2162	144	19127890	1998-10-25	2000-10-14	2	11244
73987	5058	1125315	1980-11-19	1980-11-26	1	3982
45026	3057	1177480	1978-06-28	1978-07-26	1	3128
34126	2318	1741122	1969-03-09	1969-03-09	1	-298
40984	2781	1713332	1986-01-26	1986-02-09	1	5883
70246	4799	1177480	1977-01-10	1977-03-11	1	2626
42452	2876	1125315	1967-05-22	1967-06-12	1	-934
32361	2192	19127890	1976-11-07	1977-11-02	1	2862
24345	1642	1713332	2000-07-06	2000-07-27	1	11165
74205	5073	701322	2008-06-13	2008-06-13	1	14043
18063	1245	1124957	1949-02-18	1949-02-18	1	-7622
76273	5215	1125315	1944-02-23	1944-03-01	1	-9437
28188	1911	933724	1987-12-23	1987-12-30	1	6572
40758	2768	1125315	2002-08-26	2002-09-09	1	11939
70667	4827	1728416	1954-04-16	1954-04-30	1	-5725
35504	2414	1713332	1984-11-22	1984-12-13	1	5460
32173	2176	1503184	1975-07-22	1976-07-16	1	2388
28567	1934	1125315	1992-04-11	1992-04-25	1	8150
29619	2002	1118084	2013-03-23	2013-03-23	1	15787
19363	1322	1759842	1995-12-06	1995-12-13	1	9477
26175	1769	1713332	2003-09-23	2003-10-07	1	12332
47382	3216	1759842	2017-11-17	2017-12-01	1	17501
77984	5328	738818	1981-09-19	1981-10-03	1	4293
37632	2555	1728416	1955-09-04	1955-09-18	1	-5219
67249	4591	1125315	2012-01-09	2012-01-23	1	15362
10152	697	1125315	2012-04-22	2012-04-29	1	15459
60522	4127	1125315	1973-06-24	1973-07-01	1	1277
25365	1719	1125315	2007-01-07	2007-01-21	1	13534
3329	222	1125315	2014-07-18	2014-08-01	1	16283
72576	4960	1124957	1943-09-30	1943-09-30	1	-9590
6252	431	1115008	1999-01-22	1999-04-22	1	10703
73988	5058	1177480	2011-10-31	2011-11-30	1	15308
45027	3057	1728416	1950-10-12	1950-10-26	1	-7007
34127	2318	19127890	1982-12-22	1983-12-17	1	5098
40985	2781	1713332	2013-02-07	2013-02-21	1	15757
70247	4799	1521369	1978-10-07	1980-09-26	2	3921
42453	2876	1149380	1992-08-06	1992-08-06	1	8253
32362	2192	1112807	1957-01-11	1957-01-25	1	-4724
24346	1642	19127890	1974-04-01	1976-03-21	2	2271
74206	5073	1125315	1970-03-08	1970-03-15	1	73
18064	1245	1125315	1948-11-11	1948-11-25	1	-7707
76274	5215	1125315	2014-09-04	2014-09-11	1	16324
28189	1911	1112807	1946-07-24	1946-08-07	1	-8548
40759	2768	1729720	1974-11-13	1974-11-22	1	1786
70668	4827	1125315	1963-08-27	1963-10-26	1	-2259
35505	2414	1713332	1985-06-19	1985-07-03	1	5662
32174	2176	1728416	1960-08-13	1960-08-27	1	-3414
28568	1934	1713332	1963-05-03	1963-05-24	1	-2414
29620	2002	1713332	2007-10-21	2007-11-04	1	13821
19364	1322	1112807	1929-02-15	1929-03-08	1	-14909
26176	1769	1759842	2003-09-23	2003-10-07	1	12332
47383	3216	1112807	1956-03-26	1956-04-09	1	-5015
77985	5328	933724	1969-11-24	1969-12-01	1	-31
38282	2603	1177480	2012-03-28	2012-04-18	1	15448
67250	4591	1177480	2018-04-08	2018-04-29	1	17650
10153	697	1125315	2015-10-13	2015-10-27	1	16735
60523	4127	1322184	2012-04-01	2012-04-01	1	15431
25366	1719	1115008	2006-02-20	2006-03-13	1	13220
3330	222	1729720	1974-03-09	1974-03-19	1	1538
72577	4960	1125315	1964-10-19	1964-11-02	1	-1886
6253	431	1125315	1964-11-03	1964-11-10	1	-1878
73989	5058	1713332	2001-10-16	2001-10-23	1	11618
45028	3057	1729720	1949-01-08	1949-01-15	1	-7656
34128	2318	782043	1969-03-09	1969-03-09	1	-298
40986	2781	1759842	2013-02-07	2013-02-21	1	15757
70248	4799	1729720	1998-08-25	1998-09-02	1	10471
42454	2876	1174888	2011-03-23	2011-03-23	1	15056
32363	2192	1119510	1997-11-15	1997-11-29	1	10194
24347	1642	1102527	1981-08-12	1981-08-12	1	4241
74207	5073	1361711	2009-08-29	2009-08-29	1	14485
18065	1245	1125315	1970-06-04	1970-06-18	1	168
76275	5215	1177480	1978-07-14	1978-08-11	1	3144
28190	1911	1125315	1957-06-28	1957-07-05	1	-4563
40760	2768	1738521	1973-12-16	1973-12-30	1	1459
70669	4827	1125315	1990-01-21	1990-02-20	1	7355
35506	2414	1729720	1940-07-07	1940-07-16	1	-10761
32175	2176	1729720	1975-02-19	1975-03-01	1	1885
28569	1934	1717327	1963-04-29	1963-05-13	1	-2425
29621	2002	1125315	2010-04-19	2010-04-26	1	14725
19365	1322	1115008	2003-01-18	2003-02-01	1	12084
26177	1769	19127890	1992-08-31	1993-08-26	1	8638
47384	3216	1118084	1995-10-30	1995-10-30	1	9433
77986	5328	1112807	1914-05-06	1914-06-03	1	-20301
38283	2603	1713332	1961-05-29	1961-06-19	1	-3118
67251	4591	738818	1964-06-18	1964-06-25	1	-2016
10154	697	1759842	1988-07-01	1988-07-15	1	6770
60524	4127	1112807	1949-04-19	1949-05-03	1	-7548
25367	1719	1119510	2015-01-28	2015-02-04	1	16470
3331	222	1759842	1988-04-26	1988-05-10	1	6704
72578	4960	1125315	1989-12-21	1990-03-21	1	7384
6254	431	1125315	1989-05-04	1989-05-18	1	7077
73990	5058	1759842	2001-10-16	2001-10-23	1	11618
34129	2318	1000560	1969-03-09	1969-03-09	2	-298
40987	2781	1124300	2016-12-29	2016-12-29	1	17164
70249	4799	1125315	2010-01-16	2010-01-30	1	14639
42455	2876	1717327	1964-08-05	1964-08-19	1	-1961
32364	2192	1125315	1956-05-18	1956-05-25	1	-4969
24348	1642	1118084	1990-09-24	1990-09-24	1	7571
74208	5073	1713332	1956-02-15	1956-02-22	1	-5062
18066	1245	1309944	2003-10-10	2003-10-10	1	12335
76276	5215	1729720	1943-08-28	1943-09-04	1	-9616
28191	1911	1149380	1998-09-07	1998-09-07	1	10476
40761	2768	1112807	1973-12-16	1973-12-30	1	1459
70670	4827	1112807	1954-04-16	1954-04-30	1	-5725
35507	2414	1729720	1964-11-23	1964-12-04	1	-1854
32176	2176	1112807	1957-09-14	1957-09-28	1	-4478
28570	1934	1717327	1965-09-06	1965-09-20	1	-1564
29622	2002	1177480	1986-05-24	1986-07-23	1	6047
19366	1322	1119510	1957-02-07	1957-02-14	1	-4704
26178	1769	19127890	1994-08-21	1995-08-16	1	9358
49609	3381	1125315	2018-06-05	2018-06-12	1	17694
77987	5328	1112807	1921-07-26	1921-08-30	1	-17656
38284	2603	1713332	1968-03-10	1968-03-31	1	-641
67252	4591	1177480	1977-08-13	1977-08-27	1	2795
10155	697	738818	1973-08-01	1973-08-15	1	1322
60525	4127	1124300	1988-02-04	1988-02-04	1	6608
25368	1719	1125315	2007-12-17	2008-01-07	1	13885
3332	222	1759842	1994-02-09	1994-02-23	1	8819
72579	4960	1759842	1943-05-05	1943-05-12	1	-9731
6255	431	1125315	1992-05-11	1992-05-18	1	8173
73991	5058	1125315	1966-11-03	1966-11-17	1	-1141
34130	2318	1118084	2003-05-01	2003-05-01	1	12173
40988	2781	1125315	2014-01-18	2014-01-25	1	16095
70250	4799	1112807	1972-02-15	1972-03-07	1	796
42456	2876	1759842	1977-09-01	1977-09-15	1	2814
32365	2192	1125315	1959-08-10	1959-08-17	1	-3790
24349	1642	1521369	1974-04-01	1976-03-21	2	2271
74209	5073	1729720	1959-09-29	1959-10-09	1	-3737
18067	1245	1326303	2016-07-01	2016-07-01	1	16983
76277	5215	1759842	1958-12-13	1958-12-27	1	-4023
28192	1911	1119510	1959-11-23	1959-12-07	1	-3678
40762	2768	1118084	2010-07-15	2010-07-15	1	14805
70671	4827	1125315	1982-05-20	1982-05-27	1	4529
35508	2414	1759842	1927-06-25	1927-07-09	1	-15517
32177	2176	1112807	1960-08-13	1960-08-27	1	-3414
28571	1934	1728416	1961-05-24	1961-06-07	1	-3130
29623	2002	1125315	1995-05-07	1995-05-21	1	9271
19367	1322	1125315	1963-05-09	1963-05-30	1	-2408
27387	1850	1112807	1957-12-09	1957-12-30	1	-4385
49610	3381	1177480	1979-04-19	1979-05-03	1	3409
77988	5328	1119510	1974-08-13	1974-08-27	1	1699
38285	2603	19127890	1977-05-06	1978-05-01	1	3042
67253	4591	1759842	1989-01-28	1989-02-04	1	6974
10156	697	1115008	2001-08-17	2001-10-16	1	11611
61970	4229	1112807	1967-07-08	1967-08-05	1	-880
25369	1719	1713332	2005-06-30	2005-07-14	1	12978
3333	222	933724	2008-09-23	2008-10-07	1	14159
72580	4960	738818	1918-09-28	1918-10-05	1	-18716
6256	431	1177480	1985-09-18	1985-10-02	1	5753
73992	5058	1177480	2000-12-29	2001-01-26	1	11348
34131	2318	1125315	1964-11-16	1964-12-21	1	-1837
40989	2781	1729720	1990-04-22	1990-04-30	1	7424
70251	4799	1119510	1963-12-16	1963-12-23	1	-2201
42457	2876	933724	2004-10-24	2004-10-31	1	12722
32366	2192	1125315	1972-04-23	1972-04-30	1	850
24350	1642	1759842	1977-08-09	1977-08-16	1	2784
74210	5073	1759842	1977-10-04	1977-12-06	1	2896
18068	1245	1343916	2003-10-10	2003-10-10	1	12335
76278	5215	1759842	1960-11-22	1960-12-13	1	-3306
28193	1911	1729720	1960-01-13	1960-01-23	1	-3631
40763	2768	1125315	1972-07-24	1972-08-07	1	949
70672	4827	1125315	2006-07-12	2006-07-19	1	13348
35509	2414	715997	1997-08-24	1997-08-24	1	10097
32178	2176	1112807	1966-07-20	1966-08-24	1	-1226
28572	1934	1759842	1987-12-01	1987-12-22	1	6564
29624	2002	1125315	2002-08-02	2002-08-09	1	11908
19368	1322	1322184	2019-01-30	2019-01-30	1	17926
27388	1850	1112807	1962-05-17	1962-05-31	1	-2772
49611	3381	1738521	1972-05-04	1972-05-18	1	868
77989	5328	1125315	1929-01-18	1929-01-25	1	-14951
38286	2603	19127890	1979-04-26	1980-04-20	1	3762
69930	4773	1713332	1966-06-26	1966-07-17	1	-1264
10157	697	1125315	1973-08-01	1973-08-15	1	1322
61971	4229	1115008	1998-01-07	1998-01-21	1	10247
25370	1719	1728416	1958-02-03	1958-02-17	1	-4336
3334	222	1112807	1953-09-03	1953-09-17	1	-5950
72581	4960	1112807	1935-01-01	1935-01-15	1	-12770
6257	431	1713332	1970-11-22	1970-11-29	1	332
76994	5262	1119510	2012-08-23	2012-09-06	1	15589
34132	2318	1503184	1978-01-17	1979-01-12	1	3298
40990	2781	1759842	1989-04-22	1989-05-06	1	7065
70252	4799	1177480	1983-03-10	1983-04-14	1	4851
42458	2876	1125315	1981-07-08	1981-07-15	1	4213
32367	2192	1125315	1975-06-30	1975-07-07	1	2013
24351	1642	1759842	2000-07-06	2000-07-27	1	11165
74211	5073	757627	2007-08-18	2007-08-18	1	13743
18069	1245	1713332	1947-12-18	1948-01-01	1	-8036
76279	5215	1112807	1941-04-08	1941-07-07	1	-10405
28194	1911	1729720	1989-08-02	1989-08-11	1	7162
40764	2768	1521369	1984-06-01	1986-05-22	2	5985
70673	4827	1713332	2014-12-17	2014-12-31	1	16435
35510	2414	738818	1954-05-30	1954-06-13	1	-5681
32179	2176	1521369	1975-07-22	1976-07-16	1	2388
28573	1934	1125315	1999-01-19	1999-02-16	1	10638
30391	2056	1713332	1991-12-12	1991-12-26	1	8029
19369	1322	1347450	2019-01-30	2019-01-30	1	17926
27389	1850	1118084	1998-07-22	1998-07-22	1	10429
49612	3381	1738521	1973-12-07	1973-12-21	1	1450
77990	5328	1125315	1955-02-03	1955-05-04	1	-5356
38287	2603	738818	1980-02-11	1980-02-25	1	3707
69931	4773	1713332	1992-10-06	1992-10-27	1	8335
10158	697	1125315	2016-06-24	2016-07-08	1	16990
61972	4229	1125315	1963-06-26	1963-07-10	1	-2367
25371	1719	1759842	2005-06-30	2005-07-14	1	12978
3335	222	1112807	1958-05-10	1958-06-09	1	-4224
72582	4960	1112807	1952-08-11	1952-09-01	1	-6331
6258	431	920293	1988-01-15	1988-01-22	1	6595
76995	5262	1125315	1983-12-27	1984-01-10	1	5122
34133	2318	1521369	1982-12-22	1983-12-17	1	5098
40991	2781	1125315	1985-05-02	1985-05-09	1	5607
70253	4799	1503184	1978-10-07	1980-09-26	2	3921
42459	2876	1125315	2011-03-23	2011-05-22	2	15116
32368	2192	1125315	1986-07-11	1986-07-25	1	6049
24352	1642	1112807	1951-11-18	1951-12-02	1	-6605
74212	5073	1112807	1936-01-08	1936-01-22	1	-12398
18070	1245	1713332	2012-02-01	2012-02-08	1	15378
76280	5215	1112807	1973-10-17	1973-11-07	1	1406
28195	1911	1112807	1950-05-17	1950-05-31	1	-7155
40765	2768	1713332	1975-08-06	1975-08-13	1	2050
70674	4827	1759842	2014-12-17	2014-12-31	1	16435
35511	2414	920293	1984-06-12	1984-06-19	1	5283
32180	2176	1112807	1957-07-16	1957-08-06	1	-4531
28574	1934	1728416	1964-07-02	1964-07-16	1	-1995
30392	2056	1124300	2016-02-26	2016-02-26	1	16857
19370	1322	1713332	1946-07-07	1946-07-14	1	-8572
27390	1850	1119510	1979-10-05	1979-10-19	1	3578
49613	3381	1119510	1974-08-23	1974-09-06	1	1709
77991	5328	1125315	1981-09-19	1981-10-03	1	4293
38288	2603	1102527	1983-01-30	1983-01-30	1	4777
69932	4773	1124300	1997-03-30	1997-03-30	1	9950
10159	697	1174888	2001-08-17	2001-08-17	1	11551
61973	4229	1125315	1963-08-10	1963-08-24	1	-2322
25514	1729	1115008	2004-03-03	2004-04-07	1	12515
3336	222	1118084	1988-02-22	1988-02-22	1	6626
72583	4960	1119510	1918-09-28	1918-10-05	1	-18716
6259	431	933724	1988-01-15	1988-01-22	1	6595
76996	5262	1713332	1993-10-31	1993-11-21	1	8725
34134	2318	1729720	1999-03-09	1999-03-16	1	10666
40992	2781	1125315	1986-01-26	1986-02-09	1	5883
70254	4799	1728416	1958-04-15	1958-04-29	1	-4265
42460	2876	1713332	1977-09-01	1977-09-15	1	2814
32369	2192	1521369	1983-10-05	1984-09-29	1	5385
24353	1642	1119510	2018-07-05	2018-07-12	1	17724
74213	5073	1124957	1967-08-19	1967-08-19	1	-866
18071	1245	1728416	1949-02-18	1949-03-11	1	-7601
76281	5215	1115008	2017-12-22	2018-01-05	1	17536
28196	1911	1112807	1979-08-30	1979-09-13	1	3542
40766	2768	1125315	1980-07-13	1980-07-20	1	3853
70675	4827	920293	1994-12-30	1995-01-06	1	9136
35512	2414	933724	1984-06-12	1984-06-19	1	5283
32181	2176	1125315	1959-01-08	1959-01-22	1	-3997
28575	1934	1759842	1963-05-03	1963-05-24	1	-2414
30393	2056	1177480	1987-12-10	1987-12-24	1	6566
19371	1322	1713332	1949-08-04	1949-08-18	1	-7441
27391	1850	1125315	1959-01-24	1959-02-07	1	-3981
49614	3381	1119510	2015-07-24	2015-08-07	1	16654
77992	5328	1713332	1921-10-31	1921-11-14	1	-17580
38289	2603	1112807	1962-11-23	1962-12-07	1	-2582
69933	4773	1125315	1963-10-02	1963-10-09	1	-2276
10160	697	1713332	1988-07-01	1988-07-15	1	6770
61974	4229	1125315	1974-07-29	1974-08-19	1	1691
25515	1729	1124300	2011-08-15	2011-08-15	1	15201
3337	222	1125315	1960-04-29	1960-05-20	1	-3513
72584	4960	1125315	1918-09-28	1918-10-05	1	-18716
6260	431	1118084	1985-01-06	1985-01-06	1	5484
76997	5262	1729720	2005-06-11	2005-06-19	1	12953
34135	2318	1746114	1969-03-09	1969-03-09	1	-298
40993	2781	1125315	1988-10-12	1988-10-26	1	6873
70255	4799	19127890	1978-10-07	1980-09-26	2	3921
42461	2876	1112807	1964-08-05	1964-08-19	1	-1961
32370	2192	914335	2001-12-06	2001-12-06	1	11662
24354	1642	1322184	2008-06-17	2008-06-17	1	14047
74214	5073	1307863	2001-07-14	2001-07-14	1	11517
18072	1245	1759842	2012-02-01	2012-02-08	1	15378
76282	5215	1125315	1982-08-20	1982-09-24	1	4649
28197	1911	1125315	2002-07-30	2002-08-13	1	11912
40767	2768	1125315	2010-09-08	2010-09-29	1	14881
70676	4827	933724	1994-12-30	1995-01-06	1	9136
35513	2414	1112807	1924-01-03	1924-01-17	1	-16786
32182	2176	1125315	2007-01-26	2007-02-09	1	13553
30754	2082	1102527	2007-12-10	2007-12-10	1	13857
30394	2056	1759842	2010-08-01	2010-08-22	1	14843
19372	1322	1713332	1995-12-06	1995-12-13	1	9477
27392	1850	1125315	1999-02-20	1999-02-27	1	10649
49615	3381	1125315	1988-01-11	1988-01-25	1	6598
77993	5328	1729720	1954-08-04	1954-08-14	1	-5619
38290	2603	1118084	1996-09-03	1996-09-03	1	9742
69934	4773	1125315	1977-12-26	1978-01-02	1	2923
10161	697	1729720	1979-11-29	1979-12-07	1	3627
61975	4229	1125315	2008-08-14	2008-08-28	1	14119
25516	1729	1713332	1983-07-16	1983-07-30	1	4958
3338	222	1112807	1954-11-16	1954-11-30	1	-5511
72585	4960	1125315	1943-09-30	1943-09-30	1	-9590
6261	431	1759842	1970-11-22	1970-11-29	1	332
76998	5262	1759842	1993-10-31	1993-11-21	1	8725
34136	2318	1759842	1973-04-11	1973-05-02	1	1217
40994	2781	1125315	1996-01-18	1996-02-01	1	9527
71588	4890	920293	1976-12-06	1976-12-20	2	2545
42462	2876	1137529	1992-08-06	1992-08-06	1	8253
32371	2192	920293	2002-01-26	2002-02-02	1	11720
24355	1642	1503184	1974-04-01	1976-03-21	2	2271
74215	5073	1112807	1937-05-15	1937-06-22	2	-11884
18854	1294	738818	1978-09-19	1978-10-03	1	3197
76283	5215	1125315	2000-01-08	2000-01-22	1	10978
28198	1911	1728416	1946-07-24	1946-08-07	1	-8548
40768	2768	1503184	1984-06-01	1986-05-22	2	5985
70677	4827	975125	1967-12-16	1967-12-16	1	-747
35514	2414	1112807	1933-04-29	1933-07-28	1	-13306
32183	2176	1713332	2000-06-01	2000-06-15	1	11123
30755	2082	1112807	1969-02-18	1969-03-04	1	-303
30395	2056	1125315	1990-09-25	1990-10-25	1	7602
19373	1322	1768849	2003-01-18	2003-02-01	1	12084
27393	1850	1713332	1974-09-13	1974-10-04	1	1737
49616	3381	1112807	1973-12-07	1973-12-21	1	1450
77994	5328	1759842	1921-10-31	1921-11-14	1	-17580
38291	2603	1125315	1980-02-11	1980-02-25	1	3707
69935	4773	1125315	2009-06-04	2009-06-18	1	14413
10162	697	1125315	2001-08-17	2001-08-17	1	11551
61976	4229	1713332	2018-10-05	2018-10-19	1	17823
25517	1729	1125315	1984-06-02	1984-06-16	1	5280
3339	222	1125315	1965-10-31	1965-11-07	1	-1516
72586	4960	1729720	1919-05-13	1919-05-26	1	-18483
6262	431	1125315	1967-01-21	1967-02-25	1	-1041
76999	5262	19127890	1989-12-04	1990-11-29	1	7637
34137	2318	753626	1969-03-09	1969-03-09	1	-298
40995	2781	1713332	1989-04-22	1989-05-06	1	7065
71589	4890	933724	1979-01-24	1979-01-31	1	3317
42463	2876	1729720	1971-03-03	1971-03-10	1	433
32372	2192	933724	2002-01-26	2002-02-02	1	11720
24356	1642	1713332	1977-08-09	1977-08-16	1	2784
74216	5073	1112807	1946-03-07	1946-04-11	1	-8666
18855	1294	1125315	1978-08-19	1978-11-17	2	3242
77508	5299	740275	2009-05-10	2009-10-25	1	14542
28756	1947	738818	1950-02-11	1950-02-25	1	-7250
40769	2768	1759842	1975-08-06	1975-08-13	1	2050
70678	4827	1124300	1991-01-17	1991-01-17	1	7686
35515	2414	1118084	1957-04-14	1957-04-14	1	-4645
32184	2176	1759842	2000-06-01	2000-06-15	1	11123
30756	2082	1713332	1943-12-25	1944-01-01	1	-9497
30396	2056	1125315	1991-12-12	1991-12-26	1	8029
19374	1322	1112807	1928-02-21	1928-03-22	1	-15260
27394	1850	1713332	1993-09-12	1993-09-19	1	8662
49617	3381	1118084	2011-01-15	2011-01-15	1	14989
77995	5328	1759842	1941-12-23	1941-12-30	1	-10229
38292	2603	1125315	1983-01-30	1983-04-30	1	4867
69936	4773	1728416	1964-09-24	1964-10-29	1	-1890
10460	719	920293	2016-03-26	2016-04-02	1	16893
61977	4229	1759842	2018-10-05	2018-10-19	1	17823
25518	1729	1125315	1985-07-28	1985-08-11	1	5701
3340	222	1728416	1953-09-03	1953-09-17	1	-5950
72587	4960	1759842	1960-04-16	1960-04-23	1	-3540
9196	639	1102527	2007-04-27	2007-04-27	1	13630
77000	5262	19127890	1991-11-27	1994-11-11	3	9080
34138	2318	1110410	1969-03-09	1969-03-09	1	-298
40996	2781	1729720	1987-07-24	1987-08-05	1	6425
71590	4890	1115008	1998-09-28	1998-10-28	1	10527
42464	2876	1115008	2016-05-25	2016-06-15	1	16967
32373	2192	1125315	1997-01-11	1997-01-18	1	9879
24748	1670	1118084	2004-06-13	2004-06-13	1	12582
74217	5073	1124300	1977-05-17	1977-05-17	1	2693
18856	1294	1177480	1986-11-24	1986-12-08	1	6185
77509	5299	1515774	1989-05-19	1990-05-14	1	7438
28757	1947	738818	1995-05-16	1995-05-30	1	9280
43359	2933	1112807	1958-08-29	1958-09-26	1	-4115
71348	4872	1112807	1930-11-14	1930-11-28	1	-14279
35516	2414	1125315	1933-04-29	1933-04-29	1	-13396
32185	2176	19127890	1975-07-22	1976-07-16	1	2388
30757	2082	1759842	1990-08-15	1990-08-22	1	7538
30397	2056	1729720	1981-05-17	1981-05-28	1	4165
19375	1322	1125315	1940-07-18	1940-07-25	1	-10752
27395	1850	1717327	1962-05-17	1962-05-31	1	-2772
49618	3381	1713332	1979-04-19	1979-05-03	1	3409
77996	5328	738818	1975-12-26	1976-01-09	1	2199
38293	2603	1503184	1977-05-06	1978-05-01	1	3042
69937	4773	1112807	1964-09-24	1964-10-29	1	-1890
10461	719	933724	2010-02-06	2010-02-13	1	14653
61978	4229	1112807	1959-08-14	1959-08-28	1	-3779
25519	1729	1177480	2014-02-14	2014-03-14	1	16143
3341	222	1759842	1973-07-06	1973-09-07	1	1345
72588	4960	1112807	1955-08-17	1955-09-07	1	-5230
9197	639	1728416	1956-12-04	1956-12-18	1	-4762
77001	5262	19127890	1997-10-26	1998-10-21	1	10520
34139	2318	1125315	1979-09-01	1979-09-15	1	3544
71591	4890	1310149	2009-12-09	2009-12-09	1	14587
42465	2876	1118084	2004-12-18	2004-12-18	1	12770
32374	2192	1309944	2001-12-06	2001-12-06	1	11662
24749	1670	1125315	2017-01-01	2017-01-22	1	17188
74218	5073	1125315	1963-09-15	1963-09-22	1	-2293
18857	1294	1729720	2014-07-12	2014-07-24	1	16275
77510	5299	1521369	1986-06-04	1987-05-30	1	6358
28758	1947	933724	1976-11-04	1976-11-11	1	2506
43360	2933	1112807	1978-06-13	1978-06-27	1	3099
71349	4872	1125315	1960-07-25	1960-08-08	1	-3433
35517	2414	1125315	1954-05-30	1954-06-13	1	-5681
32186	2176	1125315	1962-04-20	1962-05-04	1	-2799
30758	2082	1115008	2007-12-10	2008-03-09	1	13947
30398	2056	1125315	1994-04-09	1994-04-23	1	8878
19376	1322	1713332	1933-04-16	1933-05-07	1	-13388
27396	1850	1125315	1976-09-26	1976-10-17	1	2481
49619	3381	1713332	2013-05-18	2013-06-01	1	15857
77997	5328	920293	1969-11-24	1969-12-01	1	-31
38294	2603	1503184	1979-04-26	1980-04-20	1	3762
69938	4773	1125315	1989-01-21	1989-02-11	1	6981
10462	719	1177480	1982-06-07	1982-06-21	1	4554
61979	4229	1118084	1993-09-24	1993-09-24	1	8667
25520	1729	1729720	2015-01-03	2015-01-16	1	16451
3342	222	920293	2008-09-23	2008-10-07	2	14159
72589	4960	1118084	1949-11-28	1949-11-28	1	-7339
9198	639	1759842	1976-01-06	1976-01-20	1	2210
77002	5262	1115008	2007-01-29	2007-02-19	1	13563
34140	2318	1503184	1982-12-22	1983-12-17	1	5098
71592	4890	1557272	2000-09-06	2000-09-06	1	11206
42466	2876	1717327	1966-09-07	1966-09-21	1	-1198
32375	2192	1343916	2001-12-06	2001-12-06	1	11662
24750	1670	1729720	1967-09-02	1967-09-11	1	-843
74219	5073	1125315	1976-11-29	1976-12-27	1	2552
18858	1294	1118084	2011-03-29	2011-03-29	1	15062
77511	5299	1521369	1988-05-24	1989-05-19	1	7078
28759	1947	1125315	1950-02-11	1950-02-25	1	-7250
43361	2933	1361711	2011-10-10	2011-10-10	1	15257
71350	4872	1125315	1960-09-20	1960-10-11	1	-3369
35518	2414	1174888	1994-05-26	1994-05-26	1	8911
32187	2176	1125315	1994-12-25	1995-01-29	1	9159
30759	2082	1118084	1975-09-15	1975-09-15	1	2083
30399	2056	1177480	1982-01-10	1982-04-10	1	4482
19377	1322	1729720	1945-05-02	1945-05-09	1	-9003
27397	1850	1125315	2006-11-29	2006-12-13	1	13495
49620	3381	1717327	1974-10-10	1974-10-24	1	1757
77998	5328	1119510	1929-01-18	1929-01-25	1	-14951
38295	2603	1729720	1965-09-16	1965-09-28	1	-1556
69939	4773	1729720	1961-04-02	1961-04-10	1	-3188
10463	719	1713332	1992-08-21	1992-09-11	1	8289
61980	4229	1119510	1985-05-05	1985-05-19	1	5617
25521	1729	1759842	1983-07-16	1983-07-30	1	4958
3343	222	1102527	2003-09-14	2003-09-14	1	12309
72590	4960	1713332	1960-04-16	1960-04-23	1	-3540
9199	639	1112807	1955-07-07	1955-07-21	1	-5278
77003	5262	1118084	2010-04-13	2010-04-13	1	14712
34141	2318	1521369	1978-01-17	1979-01-12	1	3298
71593	4890	1729720	1934-08-15	1934-08-28	1	-12910
42628	2890	920293	2010-01-08	2010-01-15	1	14624
32376	2192	1503184	1974-11-18	1975-11-13	1	2142
24751	1670	1125315	2014-10-13	2014-10-20	1	16363
74220	5073	1326303	2001-07-14	2001-07-14	1	11517
18859	1294	1125315	2000-10-06	2000-10-13	1	11243
77512	5299	1713332	1978-06-11	1978-07-02	1	3104
28760	1947	1125315	1968-02-01	1968-02-15	1	-686
43362	2933	1729720	1958-01-09	1958-01-22	1	-4362
71351	4872	1713332	1921-12-30	1922-01-06	1	-17527
35519	2414	1174888	2000-04-27	2000-04-27	1	11074
32188	2176	1729720	1991-09-13	1991-09-20	1	7932
30760	2082	1759842	1943-12-25	1944-01-01	1	-9497
30400	2056	1177480	2001-04-30	2001-05-14	1	11456
19378	1322	1729720	2014-07-30	2014-08-12	1	16294
27398	1850	1759842	1974-09-13	1974-10-04	1	1737
49621	3381	1729720	1972-03-09	1972-03-17	1	806
77999	5328	1119510	1981-09-19	1981-10-03	1	4293
38296	2603	1729720	1988-10-12	1988-10-22	1	6869
69940	4773	1759842	1992-10-06	1992-10-27	1	8335
10464	719	1759842	1992-08-21	1992-09-11	1	8289
61981	4229	1125315	1957-03-02	1957-05-01	1	-4628
25522	1729	1125315	1978-07-04	1978-07-18	1	3120
3344	222	1112807	1966-11-15	1966-12-20	1	-1108
73233	5004	975125	1990-12-05	1990-12-19	1	7657
9200	639	1125315	1954-03-29	1954-04-12	1	-5743
77004	5262	1125315	1978-04-10	1978-05-01	1	3042
34142	2318	1713332	1973-04-11	1973-05-02	1	1217
71594	4890	1759842	1928-10-29	1928-11-19	1	-15018
42629	2890	1118084	2001-12-13	2001-12-13	1	11669
32377	2192	1503184	1976-11-07	1977-11-02	1	2862
24752	1670	1125315	2015-10-01	2015-10-08	1	16716
74221	5073	1112807	1936-04-07	1936-07-06	1	-12232
18860	1294	1778162	1989-04-14	1989-04-28	1	7057
77513	5299	1738521	1973-10-30	1973-11-13	1	1412
28761	1947	1125315	1995-05-16	1995-05-30	1	9280
43363	2933	1112807	1955-11-13	1955-11-27	1	-5149
71352	4872	1759842	1925-06-25	1925-07-16	1	-16240
35520	2414	1545958	2000-04-27	2000-04-27	1	11074
33792	2294	1102527	1978-06-29	1978-06-29	1	3101
30761	2082	1112807	1945-01-20	1945-02-24	1	-9077
30401	2056	1713332	2010-08-01	2010-08-22	1	14843
19379	1322	1759842	1933-04-16	1933-05-07	1	-13388
27399	1850	1112807	1961-12-23	1962-02-21	1	-2871
49622	3381	1759842	2013-05-18	2013-06-01	1	15857
78000	5328	1125315	1934-03-01	1934-03-08	1	-13083
38297	2603	1125315	1960-10-22	1960-11-05	1	-3344
69941	4773	1112807	1964-05-27	1964-06-10	1	-2031
10465	719	920293	2010-02-06	2010-02-13	1	14653
61982	4229	1125315	1995-07-30	1995-09-03	1	9376
25523	1729	1738521	1978-07-04	1978-07-18	1	3120
3345	222	1713332	1973-07-06	1973-09-07	1	1345
73234	5004	1125315	1979-06-26	1979-07-10	1	3477
9201	639	1125315	1983-02-01	1983-02-15	1	4793
77005	5262	1177480	2015-05-08	2015-06-12	1	16598
34143	2318	19003953	1969-03-09	1969-03-09	1	-298
71595	4890	920293	1979-01-24	1979-01-31	1	3317
42630	2890	19127890	1980-11-08	1981-11-03	1	4324
32378	2192	1729720	1963-04-12	1963-04-20	1	-2448
24753	1670	1154343	1968-01-11	1983-11-27	1	5078
74222	5073	1112807	1967-08-19	1967-09-18	1	-836
18861	1294	1112807	1989-04-14	1989-04-28	1	7057
77514	5299	740275	2006-05-07	2006-12-31	1	13513
28762	1947	1125315	2012-08-10	2012-09-07	1	15590
43364	2933	1713332	1987-09-20	1987-10-04	1	6485
71353	4872	1759842	1953-11-05	1953-11-12	1	-5894
35521	2414	1729720	1921-08-18	1921-08-31	1	-17655
33793	2294	1112807	1972-04-17	1972-05-01	1	851
30762	2082	1125315	1997-04-06	1997-05-06	1	9987
30402	2056	1768849	1987-12-10	1987-12-24	1	6566
19380	1322	1759842	1946-07-07	1946-07-14	1	-8572
27400	1850	1119510	1973-10-17	1973-10-31	1	1399
49623	3381	738818	1974-08-23	1974-09-06	1	1709
78001	5328	1125315	1962-01-27	1962-02-17	1	-2875
38298	2603	1125315	1975-05-07	1975-06-11	1	1987
69942	4773	1713332	2015-11-25	2015-12-09	1	16778
10466	719	1125315	1983-07-19	1983-09-28	2	4989
61983	4229	1125315	1996-03-10	1996-03-17	1	9572
27921	1892	738818	2006-05-24	2006-05-31	1	13299
3346	222	1713332	1988-04-26	1988-05-10	1	6704
73235	5004	1125315	1984-07-30	1984-08-13	1	5338
9202	639	1125315	2007-04-20	2007-05-27	1	13660
77006	5262	1503184	1992-11-21	1993-11-16	1	8720
34144	2318	19016749	1969-03-09	1969-03-09	1	-298
71596	4890	1112807	1925-07-26	1925-08-09	1	-16216
42631	2890	1112807	1964-02-26	1964-03-11	1	-2122
32379	2192	19127890	1983-10-05	1984-09-29	1	5385
24754	1670	1729720	1964-06-07	1964-06-18	1	-2023
74223	5073	1125315	1967-08-19	1967-08-19	1	-866
18862	1294	1119510	1978-09-19	1978-10-03	1	3197
77515	5299	740275	2011-09-18	2011-09-18	1	15235
28763	1947	1177480	1976-04-07	1976-07-06	1	2378
43365	2933	1729720	1954-07-25	1954-08-04	1	-5629
71354	4872	1112807	1918-07-14	1918-07-28	1	-18785
35522	2414	1119510	1944-10-31	1944-11-07	1	-9186
33794	2294	1125315	1972-01-22	1972-02-05	1	765
30763	2082	1125315	2017-02-20	2017-04-21	1	17277
32129	2174	738818	2000-08-02	2000-08-09	1	11178
19381	1322	1759842	1949-08-04	1949-08-18	1	-7441
27401	1850	1125315	1963-01-17	1963-02-07	1	-2520
49624	3381	738818	2015-07-24	2015-08-07	1	16654
78002	5328	1125315	1975-03-11	1975-04-01	1	1916
38299	2603	1501700	2014-05-12	2014-05-12	1	16202
69943	4773	1729720	1960-04-21	1960-05-03	1	-3530
10467	719	1125315	1992-06-16	1992-06-30	1	8216
61984	4229	1713332	1960-04-15	1960-05-06	1	-3527
27922	1892	1112807	1968-02-24	1968-03-16	1	-656
3347	222	1713332	1994-02-09	1994-02-23	1	8819
73236	5004	1125315	2015-07-17	2015-07-17	1	16633
9203	639	1521369	1975-11-14	1976-11-08	1	2503
77007	5262	1503184	1997-10-26	1998-10-21	1	10520
35657	2424	738818	1991-10-31	1991-11-07	1	7980
71597	4890	1112807	1972-02-10	1972-03-18	1	807
42632	2890	1125315	2013-08-12	2013-08-19	1	15936
32380	2192	1112807	1962-08-13	1962-10-12	1	-2638
24755	1670	1125315	1989-01-03	1989-01-17	1	6956
74224	5073	1310149	2001-07-14	2001-07-14	1	11517
18863	1294	1125315	1975-01-07	1975-01-21	1	1846
77516	5299	1115008	2018-12-17	2019-01-07	1	17903
28764	1947	1308738	1961-10-14	1961-10-14	1	-3001
43366	2933	1729720	1957-10-31	1957-11-08	1	-4437
71355	4872	1112807	1941-04-28	1941-06-02	1	-10440
35523	2414	1119510	1954-05-30	1954-06-13	1	-5681
33795	2294	1729720	1990-10-08	1990-10-17	1	7594
30764	2082	1713332	1990-08-15	1990-08-22	1	7538
32130	2174	1125315	1991-06-03	1991-06-17	1	7837
21711	1478	1000560	1975-05-03	1975-05-03	2	1948
27402	1850	1713332	1959-04-09	1959-04-23	1	-3906
49625	3381	1112807	1972-05-04	1972-05-18	1	868
78003	5328	1125315	1975-12-26	1976-01-09	1	2199
38300	2603	1521369	1977-05-06	1978-05-01	1	3042
69944	4773	1729720	1987-01-28	1987-02-06	1	6245
10468	719	1177480	2009-09-11	2009-10-11	1	14528
61985	4229	1729720	1953-10-16	1953-10-27	1	-5910
27923	1892	1125315	2006-05-24	2006-05-31	1	13299
3348	222	1728416	1954-11-16	1954-11-30	1	-5511
73237	5004	1361711	1995-05-02	1995-05-02	1	9252
9204	639	1521369	1977-11-03	1978-10-29	1	3223
77008	5262	1515774	1989-12-04	1990-11-29	1	7637
35658	2424	753626	1997-06-06	1997-06-06	1	10018
71598	4890	1125315	1938-10-12	1938-10-26	1	-11390
42633	2890	933724	2010-01-08	2010-01-15	1	14624
32381	2192	1118084	1996-04-01	1996-04-01	1	9587
24756	1670	1125315	1991-04-13	1991-04-27	1	7786
74225	5073	1322184	2009-08-29	2009-08-29	1	14485
18864	1294	1125315	1989-11-19	1989-12-03	1	7276
77517	5299	1124300	2007-01-20	2007-01-20	1	13533
28765	1947	1713332	1949-04-21	1949-04-28	1	-7553
43367	2933	1759842	1987-09-20	1987-10-04	1	6485
71356	4872	1118084	1955-11-07	1955-11-07	1	-5169
35524	2414	1124957	1933-04-29	1933-04-29	1	-13396
33796	2294	1112807	1961-11-20	1961-12-11	1	-2943
30765	2082	1729720	1978-08-11	1978-08-20	1	3153
32131	2174	1125315	2000-08-02	2000-08-09	1	11178
21712	1478	1112807	1962-04-15	1962-04-29	1	-2804
27403	1850	1713332	1972-06-28	1972-07-19	1	930
49626	3381	1125315	1974-08-23	1974-09-06	1	1709
78004	5328	1125315	1988-09-05	1988-09-12	1	6829
38301	2603	1521369	1979-04-26	1980-04-20	1	3762
69945	4773	1759842	1966-06-26	1966-07-17	1	-1264
10469	719	920293	2003-12-25	2004-01-01	1	12418
61986	4229	1125315	2011-10-20	2011-10-27	1	15274
27924	1892	1125315	2008-11-08	2008-11-22	1	14205
5530	379	1124300	2014-01-28	2014-01-28	1	16098
73238	5004	1150770	1977-11-26	1977-11-26	1	2886
9205	639	1713332	1979-10-06	1979-10-27	1	3586
77009	5262	1515774	1991-11-27	1992-11-21	1	8360
35659	2424	1110410	1997-06-06	1997-06-06	1	10018
71599	4890	1125315	1951-06-16	1951-06-30	1	-6760
42634	2890	1125315	1985-01-08	1985-01-15	1	5493
32382	2192	1125315	1957-06-22	1957-07-06	1	-4562
24757	1670	1125315	2002-10-26	2002-11-16	1	12007
74226	5073	1332418	2009-08-29	2009-08-29	1	14485
18865	1294	1713332	1983-10-14	1983-10-28	1	5048
77518	5299	1125315	1973-10-30	1973-11-13	1	1412
28766	1947	1125315	1951-12-17	1951-12-24	1	-6583
43368	2933	1124300	1998-07-30	1998-07-30	1	10437
71357	4872	1119510	1968-03-01	1968-03-08	1	-664
35525	2414	1125315	1978-07-25	1978-08-08	1	3141
33797	2294	1125315	1984-12-20	1985-01-03	1	5481
32938	2232	1521369	1983-04-05	1985-03-25	2	5562
32132	2174	1738521	1974-12-27	1975-01-10	1	1835
21713	1478	1125315	1980-07-26	1980-08-02	1	3866
27404	1850	1729720	1969-05-14	1969-05-24	1	-222
49627	3381	1125315	1974-10-10	1974-10-24	1	1757
78005	5328	1125315	2002-11-18	2002-11-25	1	12016
38302	2603	1119510	1980-02-11	1980-02-25	1	3707
69946	4773	1759842	2015-11-25	2015-12-09	1	16778
10470	719	933724	2016-03-26	2016-04-02	1	16893
61987	4229	1713332	1993-05-30	1993-06-13	1	8564
27925	1892	1717327	1964-07-23	1964-08-06	1	-1974
5531	379	1125315	1985-06-06	1985-06-13	1	5642
73239	5004	1177480	2015-07-17	2015-09-15	1	16693
9206	639	1728416	1954-03-29	1954-04-12	1	-5743
77010	5262	1515774	1993-11-16	1994-11-11	1	9080
35660	2424	1119510	1975-12-05	1975-12-12	1	2171
71600	4890	1125315	1965-10-31	1965-11-14	1	-1509
42635	2890	1125315	1991-07-13	1991-07-27	1	7877
32383	2192	1125315	2000-05-01	2000-05-08	1	11085
24758	1670	1125315	2002-12-24	2002-12-31	1	12052
74227	5073	1539403	2009-08-29	2009-08-29	1	14485
18866	1294	1713332	1986-11-24	1986-12-08	1	6185
77519	5299	1549786	1989-05-19	1990-05-14	1	7438
28767	1947	1125315	1979-04-05	1979-04-12	1	3388
43369	2933	1322184	2011-10-10	2011-10-10	1	15257
71358	4872	1125315	2008-07-06	2008-08-10	1	14101
35526	2414	1125315	1981-10-29	1981-11-05	1	4326
33798	2294	1717327	1964-09-05	1964-09-19	1	-1930
32939	2232	1729720	2019-06-18	2019-06-25	1	18072
32133	2174	1759842	2013-03-21	2013-04-04	1	15799
21714	1478	1125315	2009-12-13	2009-12-27	1	14605
27405	1850	738818	1973-10-17	1973-10-31	1	1399
49628	3381	1125315	1986-10-10	1986-10-24	1	6140
78006	5328	1557272	2000-01-26	2000-01-26	1	10982
395	28	1124300	2015-05-10	2015-05-10	1	16565
70537	4819	738818	1993-12-03	1993-12-17	1	8751
10471	719	1125315	2010-09-06	2010-09-20	1	14872
61988	4229	1728416	1959-08-14	1959-08-28	1	-3779
27926	1892	1112807	1962-06-04	1962-06-25	1	-2747
5532	379	1177480	1980-01-02	1980-01-16	1	3667
73240	5004	1332418	1995-05-02	1995-05-02	1	9252
9207	639	1759842	1979-10-06	1979-10-27	1	3586
77011	5262	1549786	1993-11-16	1994-11-11	1	9080
35661	2424	1125315	1964-03-05	1964-03-19	1	-2114
71601	4890	1125315	1969-04-12	1969-04-26	1	-250
42636	2890	1503184	1980-11-08	1981-11-03	1	4324
32384	2192	1521369	1974-11-18	1975-11-13	1	2142
24759	1670	1149380	1968-01-11	1983-11-27	1	5078
74228	5073	1713332	1977-10-04	1977-12-06	1	2896
18867	1294	1759842	1983-10-14	1983-10-28	1	5048
77520	5299	19127890	1988-05-24	1990-05-14	2	7438
28768	1947	1125315	1991-08-17	1991-08-31	1	7912
43370	2933	1332418	2011-10-10	2011-10-10	1	15257
71359	4872	1713332	1953-11-05	1953-11-12	1	-5894
35527	2414	1125315	1982-03-07	1982-03-14	1	4455
33799	2294	1112807	1964-09-05	1964-09-19	1	-1930
32940	2232	738818	1981-07-13	1981-07-27	1	4225
32134	2174	1118084	2012-02-06	2012-02-06	1	15376
21715	1478	1129625	1964-04-10	1964-04-10	1	-2092
27406	1850	738818	1979-10-05	1979-10-19	1	3578
49629	3381	1125315	2007-01-15	2007-02-19	1	13563
78007	5328	1112807	1910-02-26	1910-03-12	1	-21845
396	28	1713332	1979-11-30	1979-12-14	1	3634
70538	4819	1112807	1963-11-30	1963-12-14	1	-2210
10472	719	1729720	1992-05-17	1992-05-28	1	8183
61989	4229	1759842	1960-04-15	1960-05-06	1	-3527
27927	1892	1119510	2006-05-24	2006-05-31	1	13299
5533	379	1759842	1982-09-27	1982-10-04	1	4659
73241	5004	1539403	1995-05-02	1995-05-02	1	9252
9208	639	1112807	1956-12-04	1956-12-18	1	-4762
77012	5262	1589505	1996-10-31	1997-10-26	1	10160
35662	2424	1125315	1967-11-02	1967-11-16	1	-777
71602	4890	1125315	1980-05-26	1980-06-09	1	3812
42637	2890	1713332	1979-10-20	1979-10-27	1	3586
32385	2192	1521369	1976-11-07	1977-11-02	1	2862
24760	1670	1713332	1964-12-07	1964-12-21	1	-1837
74229	5073	1759842	1956-02-15	1956-02-22	1	-5062
18868	1294	1125315	1985-09-05	1985-09-12	1	5733
77521	5299	723013	2011-06-19	2012-01-22	1	15361
28769	1947	1713332	1970-09-21	1970-10-05	1	277
43371	2933	1539403	2011-10-10	2011-10-10	1	15257
71360	4872	1729720	1915-09-30	1915-10-12	1	-19805
35528	2414	1125315	1994-05-26	1994-05-26	1	8911
33800	2294	1115008	1999-06-09	1999-06-23	1	10765
32941	2232	1115008	2011-12-29	2012-01-12	1	15351
32135	2174	1119510	2000-08-02	2000-08-09	1	11178
21716	1478	1367571	1975-05-03	1975-05-03	1	1948
27407	1850	1125315	1973-10-17	1973-10-31	1	1399
49630	3381	1125315	2015-07-24	2015-08-07	1	16654
78008	5328	1124300	1945-04-08	1945-04-08	1	-9034
397	28	1112807	1991-06-30	1991-07-21	1	7871
70539	4819	1119510	1982-01-26	1982-02-02	1	4415
10473	719	1768849	1983-07-19	1983-08-02	1	4961
61990	4229	1759842	1993-05-30	1993-06-13	1	8564
27928	1892	1125315	1981-03-28	1981-04-28	1	4135
5534	379	1125315	2014-06-12	2014-06-26	1	16247
73242	5004	975125	1990-02-11	1990-03-04	1	7367
9209	639	1125315	2008-02-16	2008-02-23	1	13932
77013	5262	1759842	2003-06-06	2003-06-27	1	12230
35663	2424	1125315	1979-08-14	1979-08-14	1	3512
71603	4890	1174888	1972-02-17	1972-02-17	1	777
42638	2890	1728416	1964-02-26	1964-03-11	1	-2122
32386	2192	1728416	1957-06-22	1957-07-06	1	-4562
24761	1670	1125315	1981-11-03	1981-11-10	1	4331
74907	5127	1112807	1980-03-25	1980-04-24	1	3766
18869	1294	1125315	1997-04-11	1997-04-18	1	9969
77522	5299	1125315	1979-09-30	1979-10-07	1	3566
28770	1947	920293	1976-11-04	1976-11-11	1	2506
43372	2933	1728416	1955-11-13	1955-11-27	1	-5149
71361	4872	1729720	1946-11-05	1946-11-13	1	-8450
35529	2414	1322184	1997-09-04	2000-04-27	1	11074
33801	2294	1177480	1978-06-29	1978-07-29	1	3131
32942	2232	1125315	1979-03-18	1979-03-25	1	3370
32136	2174	1713332	1978-03-16	1978-04-06	1	3017
21717	1478	1741122	1975-05-03	1975-05-03	1	1948
27408	1850	1125315	1979-10-05	1979-10-19	1	3578
49631	3381	1729720	1982-01-25	1982-02-05	1	4418
78009	5328	1125315	1969-05-03	1969-05-10	1	-236
398	28	1125315	1979-11-30	1979-12-14	1	3634
70540	4819	1125315	1993-12-03	1993-12-17	1	8751
10474	719	933724	2003-12-25	2004-01-01	1	12418
61991	4229	738818	1985-05-05	1985-05-19	1	5617
27929	1892	1125315	2018-06-13	2018-09-11	1	17785
5535	379	1177480	1977-02-16	1977-03-18	1	2633
73243	5004	975125	1994-02-06	1994-02-27	1	8823
9210	639	1125315	2009-03-11	2009-03-18	1	14321
77014	5262	738818	2012-08-23	2012-09-06	1	15589
35664	2424	1125315	1991-10-31	1991-11-07	1	7980
71604	4890	1177480	2000-10-17	2000-11-21	1	11282
42639	2890	1759842	1979-10-20	1979-10-27	1	3586
32387	2192	1729720	2013-10-15	2013-10-28	1	16006
24762	1670	1759842	1964-12-07	1964-12-21	1	-1837
74908	5127	1125315	1972-07-07	1972-07-14	1	925
20917	1428	1115008	1995-08-22	1995-09-19	1	9392
77523	5299	1125315	2000-04-20	2000-05-04	1	11081
28771	1947	1102527	1976-04-07	1976-04-07	1	2288
43925	2969	1125315	2002-02-28	2002-03-21	1	11767
71362	4872	1729720	1971-08-08	1971-08-19	1	595
35530	2414	1326303	1994-08-18	1994-08-18	1	8995
33802	2294	1713332	2006-02-04	2006-02-18	1	13197
32943	2232	1125315	1981-07-13	1981-07-27	1	4225
32137	2174	1713332	1995-03-15	1995-03-29	1	9218
21718	1478	708298	1975-05-03	1975-05-03	1	1948
27409	1850	1729720	1984-10-06	1984-10-14	1	5400
52066	3545	1125315	1973-01-21	1973-02-04	1	1130
78010	5328	1125315	1993-12-17	1993-12-24	1	8758
5006	341	1125315	1989-04-10	1989-05-01	1	7060
70541	4819	1713332	1998-03-15	1998-03-29	1	10314
10475	719	1124300	2014-08-23	2014-08-23	1	16305
61992	4229	1112807	1953-05-17	1953-05-31	1	-6059
27930	1892	1137529	2009-05-21	2009-05-21	1	14385
5536	379	1549786	1991-03-15	1992-03-09	1	8103
73244	5004	1174888	2015-07-17	2015-07-17	1	16633
9211	639	1713332	1976-01-06	1976-01-20	1	2210
77015	5262	1125315	1973-08-20	1973-09-03	1	1341
35665	2424	1728416	1964-03-05	1964-03-19	1	-2114
71605	4890	1713332	1926-11-09	1926-11-30	1	-15738
42640	2890	1112807	1970-08-23	1970-10-22	1	294
34846	2357	933724	1995-12-19	1995-12-26	1	9490
26242	1776	753626	1984-10-13	1984-10-13	1	5399
74909	5127	1125315	1984-02-16	1984-02-23	1	5166
20918	1428	1125315	1952-09-10	1952-09-30	1	-6302
77524	5299	19127890	1986-06-04	1987-05-30	1	6358
28772	1947	1112807	1956-05-22	1956-08-20	1	-4882
43926	2969	1177480	1986-03-03	1986-03-24	1	5926
71363	4872	738818	1968-03-01	1968-03-08	1	-664
35531	2414	1332418	1994-08-18	1994-08-18	1	8995
33803	2294	1713332	2009-06-09	2009-06-23	1	14418
32944	2232	1503184	1983-04-05	1985-03-25	2	5562
32138	2174	1713332	1996-06-26	1996-07-10	1	9687
21719	1478	920293	1990-04-10	1990-04-17	1	7411
27410	1850	1759842	1959-04-09	1959-04-23	1	-3906
52067	3545	1125315	1973-03-24	1973-03-31	1	1185
78011	5328	1177480	1995-09-13	1995-09-27	1	9400
5007	341	1149380	2018-09-03	2018-09-03	1	17777
70542	4819	1729720	1967-08-14	1967-08-23	1	-862
10476	719	1125315	2005-05-31	2005-06-07	1	12941
61993	4229	1125315	1956-02-15	1956-03-07	1	-5048
27931	1892	1729720	1999-10-29	1999-11-06	1	10901
5537	379	1713332	1980-01-02	1980-01-16	1	3667
73245	5004	1322184	1999-05-11	1999-05-11	1	10722
9212	639	19127890	1975-11-14	1976-11-08	1	2503
77016	5262	1125315	2008-06-22	2008-06-29	1	14059
35666	2424	1746114	1997-06-06	1997-06-06	1	10018
71606	4890	1713332	1998-02-17	1998-03-03	1	10288
42641	2890	1521369	1980-11-08	1981-11-03	1	4324
34847	2357	1112807	1941-10-19	1941-11-02	1	-10287
26243	1776	1112807	1918-08-04	1918-08-18	1	-18764
74910	5127	1125315	1994-10-26	1994-11-09	1	9078
20919	1428	1125315	1962-12-07	1962-12-14	1	-2575
77525	5299	705944	1980-06-10	1981-03-17	1	4093
28773	1947	1118084	1989-10-22	1989-10-22	1	7234
43927	2969	1729720	1970-06-28	1970-07-07	1	187
71364	4872	1112807	1926-12-29	1927-01-12	1	-15695
35532	2414	738818	1944-10-31	1944-11-07	1	-9186
33804	2294	1759842	2006-02-04	2006-02-18	1	13197
32945	2232	19127890	1977-05-06	1978-05-01	1	3042
32139	2174	1759842	1995-03-15	1995-03-29	1	9218
21720	1478	1110410	1975-05-03	1975-05-03	1	1948
27411	1850	1759842	1972-06-28	1972-07-19	1	930
52068	3545	1125315	1983-05-29	1983-08-27	1	4986
78012	5328	1729720	1923-05-07	1923-05-18	1	-17030
5008	341	1713332	1969-02-03	1969-02-17	1	-318
70543	4819	1759842	1998-03-15	1998-03-29	1	10314
10477	719	1177480	2016-08-19	2016-11-17	1	17122
61994	4229	1125315	1985-05-05	1985-05-19	1	5617
27932	1892	920293	1999-08-02	1999-08-09	1	10812
5538	379	1713332	1994-07-08	1994-07-29	1	8975
73246	5004	1118084	2012-08-21	2012-08-21	1	15573
9213	639	19127890	1977-11-03	1978-10-29	1	3223
77017	5262	1125315	2012-08-23	2012-09-06	1	15589
35667	2424	1759842	1964-05-11	1964-06-01	1	-2040
71607	4890	1759842	1926-11-09	1926-11-30	1	-15738
46952	3184	738818	1973-01-29	1973-02-12	1	1138
34848	2357	1125315	1955-03-19	1955-04-02	1	-5388
26244	1776	1112807	1940-11-24	1940-12-15	1	-10609
74911	5127	1713332	1999-06-13	1999-07-04	1	10776
20920	1428	1125315	1998-09-18	1998-10-02	1	10501
77526	5299	723013	2003-05-04	2003-07-20	1	12253
28774	1947	1125315	1952-12-25	1953-01-08	1	-6202
43928	2969	1112807	1969-12-31	1970-01-28	1	27
71365	4872	1115008	2011-04-27	2011-05-18	1	15112
35533	2414	738818	1981-10-29	1981-11-05	1	4326
33805	2294	1759842	2009-06-09	2009-06-23	1	14418
32946	2232	19127890	1979-04-26	1980-04-20	1	3762
32140	2174	1759842	1996-06-26	1996-07-10	1	9687
21721	1478	1125315	1975-05-04	1975-05-04	1	1949
27412	1850	1759842	1993-09-12	1993-09-19	1	8662
52069	3545	1713332	1988-10-13	1988-10-27	1	6874
78013	5328	1729720	2019-06-17	2019-06-17	1	18064
5009	341	1759842	1990-09-14	1990-10-05	1	7582
70544	4819	1119510	2015-11-03	2015-11-10	1	16749
10478	719	1713332	1982-06-07	1982-06-21	1	4554
61995	4229	1125315	2001-07-03	2001-07-24	1	11527
27933	1892	933724	1999-08-02	1999-08-09	1	10812
5539	379	1713332	2000-03-08	2000-06-07	1	11115
73247	5004	1713332	1979-06-26	1979-07-10	1	3477
9214	639	920293	1990-01-31	1990-02-07	1	7342
77018	5262	1521369	1997-10-26	1998-10-21	1	10520
35668	2424	19003953	1997-06-06	1997-06-06	1	10018
71608	4890	1759842	1998-02-17	1998-03-03	1	10288
46953	3184	1112807	1963-03-22	1963-04-05	1	-2463
34849	2357	1125315	1957-09-26	1957-10-10	1	-4466
26245	1776	1713332	2012-11-24	2012-12-15	1	15689
74912	5127	1125315	1975-12-17	1975-12-31	1	2190
20921	1428	1759842	1982-11-20	1982-11-27	1	4713
77527	5299	1112807	1988-11-10	1989-01-09	1	6948
28775	1947	1125315	1954-03-20	1954-04-03	1	-5752
43929	2969	1118084	2009-05-25	2009-05-25	1	14389
71366	4872	1115008	2018-11-07	2018-11-21	1	17856
35534	2414	920293	1980-05-01	1980-05-08	1	3780
33806	2294	1118084	1997-09-02	1997-09-02	1	10106
32947	2232	1118084	2005-09-16	2005-09-16	1	13042
32141	2174	19127890	1990-06-16	1991-06-11	1	7831
21722	1478	1125315	1975-09-05	1975-09-19	1	2087
28852	1952	920293	2006-09-03	2006-09-10	1	13401
52070	3545	1115008	1994-07-30	1994-08-27	1	9004
5010	341	1124300	1995-08-27	1995-08-27	1	9369
70545	4819	1713332	1969-12-17	1969-12-24	1	-8
10479	719	1713332	2010-03-15	2010-04-12	1	14711
61996	4229	1713332	1998-01-07	1998-01-21	1	10247
27934	1892	1112807	1964-07-23	1964-08-06	1	-1974
5540	379	1759842	1994-07-08	1994-07-29	1	8975
76163	5210	1112807	1975-05-20	1975-06-03	1	1979
9215	639	933724	1990-01-31	1990-02-07	1	7342
77019	5262	1713332	2003-06-06	2003-06-27	1	12230
35669	2424	19016749	1997-06-06	1997-06-06	1	10018
71609	4890	933724	1976-12-06	1976-12-20	1	2545
46954	3184	1119510	2017-08-11	2017-08-18	1	17396
34850	2357	1125315	1999-07-10	1999-08-07	1	10810
26246	1776	1746114	1984-10-13	1984-10-13	1	5399
74913	5127	1124300	2009-11-13	2009-11-13	1	14561
20922	1428	1125315	1954-02-03	1954-02-17	1	-5797
77528	5299	1125315	1974-09-09	1974-09-23	1	1726
28776	1947	1125315	1986-12-20	1986-12-27	1	6204
43930	2969	1115008	2007-01-24	2007-02-28	1	13572
71367	4872	1125315	1952-08-14	1952-08-21	1	-6342
35535	2414	933724	1980-05-01	1980-05-08	1	3780
33807	2294	1177480	2018-11-10	2018-12-01	1	17866
32948	2232	1119510	2009-08-29	2009-09-05	1	14492
32142	2174	1125315	1974-12-27	1975-01-10	1	1835
21723	1478	1177480	2013-08-04	2013-08-18	1	15935
28853	1952	1112807	1991-03-24	1991-04-21	1	7780
52071	3545	1119510	1974-10-03	1974-10-17	1	1750
5011	341	1125315	2000-05-10	2000-05-17	1	11094
70546	4819	1729720	1962-10-18	1962-10-25	1	-2625
10480	719	1759842	2010-03-15	2010-04-12	1	14711
64193	4384	1112807	1968-02-11	1968-02-25	1	-676
27935	1892	1124300	1993-09-19	1993-09-19	1	8662
5541	379	1759842	2000-03-08	2000-06-07	1	11115
76164	5210	1115008	2000-05-29	2000-06-19	1	11127
9216	639	1124300	1989-05-14	1989-05-14	1	7073
77020	5262	1729720	2008-07-05	2008-07-17	1	14077
35670	2424	708298	1997-06-06	1997-06-06	1	10018
71610	4890	1112807	1924-08-24	1924-09-07	1	-16552
46955	3184	1124300	2003-10-08	2003-10-08	1	12333
34851	2357	1125315	2005-01-25	2005-02-01	1	12815
26247	1776	19003953	1984-10-13	1984-10-13	1	5399
74914	5127	1112807	1971-02-11	1971-02-25	1	420
20923	1428	1125315	1979-11-17	1979-12-01	1	3621
77529	5299	1177480	1994-09-10	1994-09-24	1	9032
28777	1947	1728416	1952-12-25	1953-01-08	1	-6202
43931	2969	1125315	1967-11-07	1967-12-12	1	-751
71368	4872	1125315	1968-03-01	1968-03-08	1	-664
35536	2414	1119510	1950-06-10	1950-06-24	1	-7131
33808	2294	1738521	1972-01-22	1972-02-05	1	765
32949	2232	1125315	1999-07-18	1999-08-01	1	10804
32143	2174	1515774	1990-06-16	1991-06-11	1	7831
21724	1478	1551099	1990-11-23	1990-11-23	1	7631
28854	1952	1125315	1965-09-04	1965-09-11	1	-1573
52072	3545	1124300	2011-12-13	2011-12-13	1	15321
5012	341	1137529	2018-09-03	2018-09-03	1	17777
70547	4819	1759842	2013-02-25	2013-03-04	1	15768
13158	902	1102527	1968-01-15	1968-01-15	1	-717
64194	4384	1118084	2005-08-25	2005-08-25	1	13020
27936	1892	1102527	1974-07-13	1974-07-13	1	1654
5542	379	1125315	2016-07-28	2016-08-04	1	17017
76165	5210	1125315	2009-03-04	2009-03-18	1	14321
9217	639	1125315	1965-05-01	1965-05-15	1	-1692
77021	5262	1125315	1990-12-24	1991-03-24	1	7752
35671	2424	967823	1997-06-06	1997-06-06	1	10018
71611	4890	1112807	1927-01-11	1927-02-01	1	-15675
46956	3184	1125315	1966-05-24	1966-06-07	1	-1304
34852	2357	1713332	1985-01-24	1985-01-31	1	5509
26248	1776	782043	1984-10-13	1984-10-13	1	5399
74915	5127	1125315	1989-06-28	1989-07-05	1	7125
20924	1428	1177480	1998-06-05	1998-08-04	1	10442
77530	5299	1503184	1986-06-04	1987-05-30	1	6358
28778	1947	1729720	1956-06-17	1956-06-25	1	-4938
43932	2969	1125315	2000-11-03	2000-11-17	1	11278
71369	4872	1125315	1968-06-01	1968-06-22	1	-558
35537	2414	1119510	1989-07-08	1989-07-22	1	7142
34573	2341	1115008	2014-05-25	2014-06-29	1	16250
32950	2232	1125315	2009-08-29	2009-09-05	1	14492
32144	2174	1549786	1990-06-16	1991-06-11	1	7831
21725	1478	782043	1975-05-03	1975-05-03	1	1948
28855	1952	1177480	2012-08-28	2012-09-18	1	15601
52073	3545	1125315	1998-09-13	1998-09-20	1	10489
5013	341	1717327	1963-03-28	1963-04-11	1	-2457
70548	4819	738818	1982-01-26	1982-02-02	1	4415
13159	902	1112807	1965-03-10	1965-03-31	1	-1737
64195	4384	1551099	1968-09-08	1968-09-08	1	-480
27937	1892	1112807	1974-07-13	1974-09-11	1	1714
5543	379	1515774	1989-03-25	1990-03-20	1	7383
76166	5210	738818	1981-05-20	1981-05-27	1	4164
9218	639	1125315	1998-11-27	1998-12-11	1	10571
77022	5262	1521369	1992-11-21	1993-11-16	1	8720
35672	2424	1112807	1979-08-14	1979-11-12	1	3602
71612	4890	1112807	1942-05-13	1942-06-03	1	-10074
46957	3184	1125315	1973-01-29	1973-02-12	1	1138
34853	2357	1729720	1951-01-14	1951-01-24	1	-6917
26249	1776	1000560	1984-10-13	1984-10-13	2	5399
74916	5127	1759842	1999-06-13	1999-07-04	1	10776
20925	1428	1728416	1950-04-23	1950-05-08	1	-7178
77531	5299	1503184	1988-05-24	1989-05-19	1	7078
28779	1947	1759842	1949-04-21	1949-04-28	1	-7553
43933	2969	1125315	1977-09-18	1977-10-16	1	2845
71370	4872	1125315	2005-12-21	2006-01-04	1	13152
35538	2414	1125315	1944-10-31	1944-11-07	1	-9186
34574	2341	1118084	1986-01-03	1986-01-03	1	5846
32951	2232	1503184	1977-05-06	1978-05-01	1	3042
32145	2174	1713332	2013-03-21	2013-04-04	1	15799
21726	1478	933724	1990-04-10	1990-04-17	1	7411
28856	1952	1728416	1959-09-05	1959-09-19	1	-3757
52074	3545	1177480	1988-10-13	1988-10-27	1	6874
5014	341	1112807	1963-03-28	1963-04-11	1	-2457
70549	4819	1124300	2003-03-30	2003-03-30	1	12141
13160	902	1112807	1990-12-15	1990-12-25	1	7663
64196	4384	1717327	1968-04-24	1968-05-08	1	-603
27938	1892	1149380	2009-05-21	2009-05-21	1	14385
5544	379	1515774	1991-03-15	1992-03-09	1	8103
76167	5210	1125315	1981-05-20	1981-05-27	1	4164
9219	639	1503184	1975-11-14	1976-11-08	1	2503
77023	5262	1549786	1989-12-04	1990-11-29	1	7637
35673	2424	1125315	1997-09-08	1997-09-22	1	10126
71613	4890	1125315	1972-02-17	1972-02-17	1	777
46958	3184	1713332	2004-01-14	2004-01-28	1	12445
34854	2357	1759842	1956-05-06	1956-05-20	1	-4974
26250	1776	1112807	1920-01-28	1920-02-11	1	-18222
76543	5233	1112807	1958-10-08	1958-11-12	1	-4068
20926	1428	1112807	1950-04-23	1950-05-08	1	-7178
77532	5299	1717327	1974-09-09	1974-09-23	1	1726
28780	1947	1119510	1950-02-11	1950-02-25	1	-7250
43934	2969	1125315	1982-04-24	1982-05-01	1	4503
71371	4872	1125315	2007-09-22	2007-09-29	1	13785
35539	2414	1125315	1975-05-24	1975-06-07	1	1983
34575	2341	1125315	1953-09-18	1953-10-02	1	-5935
32952	2232	1503184	1979-04-26	1980-04-20	1	3762
32146	2174	1759842	1978-03-16	1978-04-06	1	3017
21727	1478	1112807	1972-01-23	1972-02-27	1	787
28857	1952	1729720	1996-12-09	1996-12-21	1	9851
52075	3545	1177480	2010-09-02	2010-10-07	1	14889
5015	341	1759842	1969-02-03	1969-02-17	1	-318
70550	4819	1124957	1976-09-22	1976-09-22	1	2456
13161	902	1118084	1991-09-05	1991-09-05	1	7917
64197	4384	1759842	1975-09-04	1975-09-18	1	2086
28473	1928	1102527	2018-02-26	2018-02-26	1	17588
5545	379	1549786	1989-03-25	1990-03-20	1	7383
76168	5210	1177480	1996-09-26	1996-10-17	1	9786
9220	639	1503184	1977-11-03	1978-10-29	1	3223
77024	5262	1549786	1991-11-27	1992-11-21	1	8360
35674	2424	1125315	2005-06-30	2005-07-14	1	12978
71614	4890	1125315	1976-04-09	1976-04-16	1	2297
46959	3184	1713332	2004-04-28	2004-05-19	1	12557
34855	2357	920293	1998-02-05	1998-02-12	1	10269
26251	1776	1112807	1921-09-30	1921-10-14	1	-17611
76544	5233	1177480	2003-02-17	2003-03-03	1	12114
20927	1428	1112807	1958-09-30	1958-11-03	1	-4077
77533	5299	1759842	1978-06-11	1978-07-02	1	3104
28781	1947	1119510	1995-05-16	1995-05-30	1	9280
46092	3129	1125315	2006-12-25	2007-01-08	1	13521
71372	4872	1713332	1927-12-10	1927-12-24	1	-15349
35540	2414	1125315	2000-04-27	2000-04-27	1	11074
34576	2341	1307863	2002-03-28	2002-03-28	1	11774
32953	2232	19127890	1983-04-05	1985-03-25	2	5562
34885	2359	1124300	1965-01-30	1965-01-30	1	-1797
21728	1478	1118084	2001-12-26	2001-12-26	1	11682
28858	1952	738818	2001-12-18	2002-01-01	1	11688
52076	3545	1713332	1975-12-30	1976-01-13	1	2203
5016	341	1125315	1990-06-06	1990-06-13	1	7468
70551	4819	1125315	1976-09-22	1976-11-21	2	2516
13162	902	1125315	1973-12-30	1974-01-06	1	1466
64198	4384	1112807	1968-04-24	1968-05-08	1	-603
28474	1928	1119510	1997-09-23	1997-09-30	1	10134
5546	379	1713332	1982-09-27	1982-10-04	1	4659
76169	5210	1728416	1975-05-20	1975-06-03	1	1979
9221	639	1728416	1955-07-07	1955-07-21	1	-5278
44572	3019	1125315	1991-08-19	1991-09-02	1	7914
35675	2424	1367571	1997-06-06	1997-06-06	1	10018
71615	4890	1326303	2009-12-09	2009-12-09	1	14587
46960	3184	1728416	1966-05-24	1966-06-07	1	-1304
34856	2357	1112807	1960-12-10	1960-12-31	1	-3288
26252	1776	1112807	1931-08-23	1931-09-13	1	-13990
76545	5233	1118084	1998-06-25	1998-06-25	1	10402
20928	1428	1118084	1984-03-30	1984-03-30	1	5202
77805	5317	1118084	2014-05-20	2014-05-20	1	16210
28782	1947	1557272	2009-06-21	2009-06-21	1	14416
46093	3129	1177480	1998-03-27	1998-05-26	1	10372
71373	4872	1713332	1980-06-29	1980-07-06	1	3839
35541	2414	1307863	1994-08-18	1994-08-18	1	8995
34577	2341	1713332	2012-12-25	2013-04-30	1	15825
32954	2232	738818	2009-08-29	2009-09-05	1	14492
34886	2359	1125315	1978-11-29	1978-12-13	1	3268
21729	1478	1174888	1975-05-04	1975-05-04	1	1949
28859	1952	933724	2006-09-03	2006-09-10	1	13401
52077	3545	1759842	2018-05-12	2018-05-26	1	17677
5017	341	1713332	1990-09-14	1990-10-05	1	7582
70552	4819	1125315	1982-01-26	1982-02-02	1	4415
13163	902	1713332	1999-11-04	1999-11-11	1	10906
64199	4384	1125315	1978-10-17	1978-10-24	1	3218
28475	1928	1125315	2018-02-19	2018-03-28	1	17618
5547	379	19127890	1989-03-25	1990-03-20	1	7383
76170	5210	1729720	1982-10-31	1982-11-12	1	4698
10771	741	914335	2000-05-26	2000-05-26	1	11103
44573	3019	1125315	2001-03-01	2001-03-15	1	11396
35676	2424	1713332	1964-05-11	1964-06-01	1	-2040
71616	4890	1713332	1956-11-25	1956-12-16	1	-4764
46961	3184	1768849	1995-11-16	1995-11-30	1	9464
34857	2357	1124957	1952-07-04	1952-07-04	1	-6390
26253	1776	1112807	1992-12-03	1993-01-02	1	8402
76546	5233	1177480	1980-04-20	1980-07-19	1	3852
20929	1428	1713332	1982-11-20	1982-11-27	1	4713
77806	5317	1125315	1974-01-30	1974-02-13	1	1504
28783	1947	1759842	1970-09-21	1970-10-05	1	277
46094	3129	1515774	1989-04-23	1990-04-18	1	7412
71374	4872	1729720	1990-08-17	1990-08-27	1	7543
35542	2414	1361711	1991-08-01	1994-05-26	1	8911
34578	2341	1729720	1961-05-21	1961-06-02	1	-3135
32955	2232	1119510	1981-07-13	1981-07-27	1	4225
34887	2359	1125315	1998-03-23	1998-04-22	2	10338
21730	1478	1177480	2001-09-22	2001-10-06	1	11601
28860	1952	1112807	1964-01-10	1964-02-14	1	-2148
52078	3545	1125315	1985-05-15	1985-05-29	1	5627
10999	755	1115008	2010-12-27	2011-01-10	1	14984
70553	4819	1125315	1988-01-23	1988-02-06	1	6610
13164	902	1729720	2006-04-11	2006-04-19	1	13257
64200	4384	1713332	1975-09-04	1975-09-18	1	2086
28476	1928	1177480	1983-11-29	1984-02-27	1	5170
5548	379	19127890	1991-03-15	1992-03-09	1	8103
76171	5210	1118084	2015-06-14	2015-06-14	1	16600
10772	741	1309944	2000-05-26	2000-05-26	1	11103
44574	3019	1729720	1988-05-08	1988-05-21	1	6715
35677	2424	1741122	1997-06-06	1997-06-06	1	10018
71617	4890	1759842	1956-11-25	1956-12-16	1	-4764
46962	3184	1125315	1978-04-02	1978-04-30	1	3041
34858	2357	1125315	1973-05-02	1973-05-09	1	1224
26254	1776	1125315	2001-01-11	2001-02-15	1	11368
76547	5233	1125315	1956-11-18	1956-12-02	1	-4778
22095	1506	1118084	1985-08-06	1985-08-06	1	5696
77807	5317	1125315	1976-03-08	1976-03-22	1	2272
31110	2103	920293	2009-05-31	2009-06-07	1	14402
46095	3129	1515774	1992-04-07	1993-04-02	1	8492
71375	4872	1759842	1927-12-10	1927-12-24	1	-15349
35543	2414	1361711	1994-08-18	2000-04-27	1	11074
34579	2341	1778162	1994-10-18	1994-11-22	1	9091
32956	2232	1125315	1968-02-13	1968-03-05	1	-667
34888	2359	1125315	2007-12-01	2007-12-22	1	13869
21731	1478	1177480	2016-04-04	2016-04-18	1	16909
28861	1952	1118084	1989-01-10	1989-01-10	1	6949
52079	3545	1125315	1997-02-11	1997-02-18	1	9910
11000	755	1115008	2013-02-28	2013-03-14	1	15778
70554	4819	1125315	2002-08-20	2002-09-03	1	11933
13165	902	738818	1970-05-23	1970-06-06	1	156
64201	4384	1738521	1968-02-11	1968-02-25	1	-676
28477	1928	1759842	1979-03-20	1979-04-10	1	3386
10680	733	1112807	1959-08-29	1959-11-27	1	-3688
76172	5210	1119510	1981-05-20	1981-05-27	1	4164
10773	741	1343916	2000-05-26	2000-05-26	1	11103
44575	3019	1118084	2015-10-12	2015-10-12	1	16720
35678	2424	738818	1975-12-05	1975-12-12	1	2171
71618	4890	975125	1946-11-23	1946-11-23	1	-8440
46963	3184	1125315	1997-06-19	1997-07-10	1	10052
34859	2357	1728416	1952-07-04	1952-07-25	1	-6369
26255	1776	1177480	2018-04-17	2018-05-24	1	17675
76548	5233	1125315	1993-09-09	1993-10-07	1	8680
22096	1506	1125315	1952-08-29	1952-10-05	1	-6297
77808	5317	1729720	1983-12-22	1983-12-29	1	5110
31111	2103	1102527	1991-06-17	1991-06-17	1	7837
46096	3129	1521369	1986-05-09	1987-05-04	1	6332
71376	4872	1759842	1980-06-29	1980-07-06	1	3839
35544	2414	1713332	1927-06-25	1927-07-09	1	-15517
34580	2341	920293	1977-04-17	1977-04-24	1	2670
32957	2232	1125315	2016-10-13	2016-10-20	1	17094
34889	2359	1729720	1962-11-18	1962-11-27	1	-2592
21732	1478	1729720	1961-10-19	1961-10-30	1	-2985
28862	1952	1119510	2001-12-18	2002-01-01	1	11688
52080	3545	1759842	1975-12-30	1976-01-13	1	2203
11001	755	1125315	2018-10-14	2019-01-12	1	17908
70555	4819	1713332	1984-04-23	1984-04-30	1	5233
13166	902	1112807	1968-01-15	1968-02-14	1	-687
64202	4384	1768849	1982-01-12	1982-01-26	1	4408
28478	1928	19127890	1990-07-05	1991-06-30	1	7850
10681	733	1125315	1992-01-08	1992-02-05	1	8070
76173	5210	1729720	1974-01-26	1974-02-02	1	1493
10774	741	1521369	1989-11-20	1990-11-15	1	7623
44576	3019	1759842	1978-03-09	1978-03-30	1	3010
35679	2424	1000560	1997-06-06	1997-06-06	2	10018
71619	4890	1115008	2015-05-07	2015-05-21	1	16576
46964	3184	1125315	2004-01-14	2004-01-28	1	12445
34860	2357	920293	1995-12-19	1995-12-26	1	9490
26256	1776	1307863	2003-10-11	2003-10-11	1	12336
76549	5233	1125315	2012-02-12	2012-02-26	1	15396
22097	1506	1307863	2011-04-30	2011-04-30	1	15094
77809	5317	1125315	1973-11-03	1973-11-17	1	1416
31112	2103	1125315	1978-02-13	1978-02-20	1	2972
46097	3129	1713332	1975-01-02	1975-01-09	1	1834
71377	4872	920293	1953-08-25	1953-09-01	1	-5966
35545	2414	1759842	1984-11-22	1984-12-13	1	5460
34581	2341	933724	1977-04-17	1977-04-24	1	2670
32958	2232	1177480	2001-09-08	2001-09-22	1	11587
34890	2359	1119510	1941-01-31	1941-02-14	1	-10548
21733	1478	1746114	1975-05-03	1975-05-03	1	1948
28863	1952	1125315	1967-12-25	1967-12-25	2	-738
52081	3545	738818	1974-10-03	1974-10-17	1	1750
11002	755	1177480	1981-07-02	1981-08-01	1	4230
70556	4819	1728416	1963-11-30	1963-12-14	1	-2210
13167	902	1125315	1952-05-17	1952-05-31	1	-6424
64203	4384	1125315	1968-03-12	1968-03-26	1	-646
28479	1928	19127890	1992-06-24	1993-06-19	1	8570
10682	733	1759842	1961-04-29	1961-05-06	1	-3162
76174	5210	1125315	2016-12-06	2017-01-03	1	17169
10775	741	1713332	1999-03-02	1999-03-16	1	10666
46854	3179	738818	1996-02-04	1996-02-11	1	9537
35680	2424	1124300	2004-04-19	2004-04-19	1	12527
71620	4890	1118084	1957-07-02	1957-07-02	1	-4566
46965	3184	1728416	1963-03-22	1963-04-05	1	-2463
34861	2357	1112807	1941-03-04	1941-03-18	1	-10516
26257	1776	1326303	2003-10-11	2003-10-11	1	12336
77190	5277	1125315	1963-11-24	1963-12-08	1	-2216
22098	1506	1322184	2012-10-13	2012-10-13	1	15626
77810	5317	1125315	1981-04-23	1981-05-07	1	4144
31113	2103	1125315	1982-11-17	1982-12-01	1	4717
46098	3129	1729720	2009-04-09	2009-04-17	1	14351
71378	4872	933724	1953-08-25	1953-09-01	1	-5966
35546	2414	1759842	1985-06-19	1985-07-03	1	5662
34582	2341	1112807	1967-01-08	1967-01-29	1	-1068
32959	2232	1521369	1977-05-06	1978-05-01	1	3042
34891	2359	1125315	1927-12-03	1927-12-10	1	-15363
21734	1478	753626	1975-05-03	1975-05-03	1	1948
28864	1952	1125315	2001-12-18	2002-01-01	1	11688
52082	3545	1125315	1974-10-03	1974-10-17	1	1750
11003	755	1713332	1998-01-04	1998-01-18	1	10244
70557	4819	1759842	1969-12-17	1969-12-24	1	-8
13168	902	1125315	1970-05-23	1970-06-06	1	156
64204	4384	1125315	2008-11-27	2008-12-11	1	14224
28480	1928	738818	1974-03-22	1974-04-05	1	1555
10683	733	1112807	1948-07-29	1948-08-26	1	-7798
76175	5210	1713332	1980-03-28	1980-04-11	1	3753
10776	741	1738521	1977-04-17	1977-05-01	1	2677
46855	3179	1119510	1970-04-09	1970-04-23	1	112
35681	2424	1124957	1979-08-14	1979-08-14	1	3512
71621	4890	1125315	1971-01-29	1971-02-05	1	400
46966	3184	738818	2017-08-11	2017-08-18	1	17396
34862	2357	1118084	1973-12-26	1973-12-26	1	1455
26258	1776	1557272	2006-10-28	2006-10-28	1	13449
77191	5277	1112807	1955-12-31	1956-02-29	1	-5055
22099	1506	1728416	1949-01-30	1949-02-13	1	-7627
77811	5317	19127890	1989-11-17	1990-11-12	1	7620
31114	2103	1503184	1991-04-14	1992-04-08	1	8133
46099	3129	1118084	2014-12-23	2014-12-23	1	16427
71379	4872	1125315	1944-05-29	1944-06-12	1	-9334
37476	2548	1729720	1967-12-25	1968-01-06	1	-726
34583	2341	1125315	2010-02-23	2010-03-02	1	14670
32960	2232	1521369	1979-04-26	1980-04-20	1	3762
34892	2359	1125315	1998-12-10	1998-12-17	1	10577
21735	1478	967823	1975-05-03	1975-05-04	1	1949
28865	1952	1557272	2015-03-02	2015-03-02	1	16496
52083	3545	1713332	2018-05-12	2018-05-26	1	17677
11004	755	1759842	1998-01-04	1998-01-18	1	10244
70558	4819	1759842	1984-04-23	1984-04-30	1	5233
13169	902	1322184	2011-05-21	2011-05-21	1	15115
64205	4384	1551099	1976-03-31	1976-03-31	1	2281
28481	1928	738818	1997-09-23	1997-09-30	1	10134
10684	733	1125315	1999-05-04	1999-05-11	1	10722
76176	5210	1713332	1984-04-27	1984-05-11	1	5244
10777	741	1759842	1999-03-02	1999-03-16	1	10666
46856	3179	1124957	1932-10-14	1932-10-14	1	-13593
35682	2424	1125315	1975-12-05	1975-12-12	1	2171
71622	4890	1177480	1981-12-26	1982-02-24	1	4437
46967	3184	1119510	1973-01-29	1973-02-12	1	1138
34863	2357	1125315	1952-07-04	1952-07-04	1	-6390
26259	1776	967823	1984-10-13	1984-10-14	1	5400
77192	5277	1112807	1956-07-28	1956-08-11	1	-4891
22100	1506	1729720	1972-09-05	1972-09-15	1	988
77812	5317	1125315	1978-01-10	1978-01-17	1	2938
31115	2103	19127890	1987-05-05	1989-04-24	2	7053
46100	3129	19127890	1989-04-23	1990-04-18	1	7412
71380	4872	1177480	1999-07-10	1999-07-24	1	10796
37477	2548	1125315	1985-04-29	1985-05-13	1	5611
34584	2341	1521369	1976-01-31	1977-01-25	1	2581
32961	2232	1713332	1987-06-11	1987-06-25	1	6384
34893	2359	1347450	2014-10-06	2014-10-06	1	16349
21736	1478	1125315	1997-12-22	1997-12-29	1	10224
28866	1952	19127890	1974-07-02	1975-06-27	1	2003
52084	3545	1717327	1973-01-21	1973-02-04	1	1130
11005	755	1112807	1970-08-08	1970-11-06	1	309
70559	4819	738818	2015-11-03	2015-11-10	1	16749
13170	902	1332418	2011-05-21	2011-05-21	1	15115
64206	4384	1729720	1991-10-03	1991-10-15	1	7957
28482	1928	1115008	2019-04-22	2019-05-22	1	18038
10685	733	1115008	2016-05-03	2016-05-17	1	16938
76177	5210	1729720	1978-02-12	1978-02-20	1	2972
10778	741	933724	1995-12-23	1995-12-30	1	9494
46857	3179	1125315	1996-02-04	1996-02-11	1	9537
35683	2424	1713332	1968-09-16	1968-09-23	1	-465
71623	4890	1307863	2009-12-09	2009-12-09	1	14587
46968	3184	1125315	1989-07-27	1989-08-10	1	7161
34864	2357	1713332	1956-05-06	1956-05-20	1	-4974
26260	1776	1112807	1920-09-07	1920-10-05	1	-17985
77193	5277	1118084	1997-09-06	1997-09-06	1	10110
22101	1506	1112807	1949-01-30	1949-02-13	1	-7627
77813	5317	1125315	2012-08-31	2012-09-14	1	15597
31116	2103	1112807	1972-11-17	1972-12-01	1	1065
46101	3129	19127890	1992-04-07	1993-04-02	1	8492
71381	4872	1713332	1925-06-25	1925-07-16	1	-16240
37478	2548	1125315	2011-01-10	2011-01-17	1	14991
34585	2341	1728416	1953-09-18	1953-10-02	1	-5935
32962	2232	1759842	1987-06-11	1987-06-25	1	6384
34894	2359	1361711	2011-04-25	2011-04-25	1	15089
21737	1478	1125315	2012-08-14	2012-08-21	1	15573
28867	1952	1503184	1974-07-02	1975-06-27	1	2003
52715	3593	1125315	1974-06-17	1974-07-01	1	1642
11006	755	1119510	2004-04-16	2004-04-30	1	12538
70560	4819	1119510	1993-12-03	1993-12-17	1	8751
13171	902	1539403	2011-05-21	2011-05-21	1	15115
64207	4384	1125315	1982-01-12	1982-01-26	1	4408
28483	1928	1124300	2010-07-15	2010-07-15	1	14805
10686	733	1124300	1980-05-07	1980-05-07	1	3779
76178	5210	1759842	1980-03-28	1980-04-11	1	3753
10779	741	1125315	2001-07-22	2001-08-19	1	11553
46858	3179	1119510	1988-12-19	1988-12-26	1	6934
35684	2424	19039298	1997-06-06	1997-06-06	1	10018
71624	4890	1713332	1928-10-29	1928-11-19	1	-15018
46969	3184	1125315	2017-08-11	2017-08-18	1	17396
34865	2357	1729720	1977-07-30	1977-08-10	1	2778
26261	1776	1112807	1922-09-09	1922-12-08	1	-17191
77194	5277	1119510	1990-09-21	1990-10-05	1	7582
22102	1506	1115008	1998-03-22	1998-04-05	1	10321
77814	5317	1549786	1989-11-17	1990-11-12	1	7620
31117	2103	1125315	1982-03-03	1982-03-17	1	4458
46102	3129	1125315	1972-02-13	1972-02-20	1	780
71382	4872	1759842	1921-12-30	1922-01-06	1	-17527
37479	2548	1729720	2018-01-22	2018-02-04	1	17566
34586	2341	1310149	2002-03-28	2002-03-28	1	11774
34392	2333	967823	1978-05-19	1978-05-20	1	3061
34895	2359	738818	1941-01-31	1941-02-14	1	-10548
21738	1478	1154029	1975-05-03	1975-05-03	1	1948
28868	1952	1521369	1974-07-02	1975-06-27	1	2003
52716	3593	1177480	2018-09-02	2018-09-30	1	17804
11007	755	1125315	2004-04-16	2004-04-30	1	12538
70561	4819	1125315	2015-11-03	2015-11-10	1	16749
13172	902	1728416	1952-05-17	1952-05-31	1	-6424
64208	4384	1125315	1982-12-08	1982-12-29	1	4745
28484	1928	1125315	1974-03-22	1974-04-05	1	1555
10687	733	1713332	1961-04-29	1961-05-06	1	-3162
76179	5210	1759842	1984-04-27	1984-05-11	1	5244
10780	741	1503184	1989-11-20	1990-11-15	1	7623
46859	3179	1125315	1987-06-13	1987-06-27	1	6386
35685	2424	1119510	1991-10-31	1991-11-07	1	7980
72750	4972	1125315	2016-09-19	2016-12-18	1	17153
46970	3184	1177480	1995-11-16	1995-11-30	1	9464
34866	2357	933724	1998-02-05	1998-02-12	1	10269
26262	1776	1112807	1945-04-23	1945-05-14	1	-8998
77195	5277	1713332	1963-12-06	1963-12-13	1	-2211
22103	1506	1326303	2011-04-30	2011-04-30	1	15094
77815	5317	1729720	1984-01-29	1984-02-06	1	5149
31118	2103	1503184	1987-05-05	1989-04-24	2	7053
46103	3129	1125315	1998-11-07	1998-11-21	1	10551
73015	4990	738818	1971-03-09	1971-03-23	1	446
37480	2548	1115008	1998-03-14	1998-04-18	1	10334
34587	2341	1503184	1976-01-31	1977-01-25	1	2581
34393	2333	1125315	1978-05-20	1978-05-20	1	3061
34896	2359	1115008	2008-12-16	2009-01-06	1	14250
21739	1478	1551099	1977-11-22	1977-11-22	1	2882
28869	1952	1124957	1967-12-25	1967-12-25	1	-738
52717	3593	1326303	2017-06-14	2017-06-14	1	17331
11008	755	1177480	2016-01-28	2016-03-28	1	16888
70562	4819	1713332	2013-02-25	2013-03-04	1	15768
13173	902	1759842	1999-11-04	1999-11-11	1	10906
64209	4384	1125315	1999-10-01	1999-10-22	1	10886
28485	1928	1125315	1997-09-23	1997-09-30	1	10134
10688	733	1729720	1944-12-31	1945-01-08	1	-9124
77584	5302	1124300	2010-07-15	2010-07-15	1	14805
10781	741	1503184	1991-11-10	1993-10-30	2	8703
46860	3179	1347450	1987-05-23	1987-05-23	1	6351
35686	2424	1713332	1994-03-12	1994-03-26	1	8850
72751	4972	1713332	1980-04-13	1980-11-30	1	3986
46971	3184	1759842	2004-04-28	2004-05-19	1	12557
34867	2357	1112807	1952-07-04	1952-07-25	1	-6369
26263	1776	1124300	1954-06-11	1954-06-11	1	-5683
77196	5277	1713332	1983-07-01	1983-07-22	1	4950
22104	1506	1112807	1964-12-01	1964-12-15	1	-1843
77816	5317	1125315	1983-09-20	1983-09-27	1	5017
31119	2103	1521369	1991-04-14	1992-04-08	1	8133
46104	3129	1125315	2008-08-31	2008-09-30	1	14152
73016	4990	738818	2008-06-06	2008-06-13	1	14043
37481	2548	1118084	1997-11-14	1997-11-14	1	10179
34588	2341	1759842	2012-12-25	2013-04-30	1	15825
34394	2333	1125315	1997-10-03	1997-10-10	1	10144
34897	2359	1119510	1998-12-10	1998-12-17	1	10577
21740	1478	1551099	1981-04-12	1981-04-12	1	4119
28870	1952	1125315	1959-09-05	1959-09-19	1	-3757
52718	3593	1713332	1988-05-26	1988-06-02	1	6727
11009	755	1713332	1965-07-21	1965-08-04	1	-1611
70563	4819	1729720	1960-09-18	1960-09-25	1	-3385
13174	902	1778162	1990-12-11	1990-12-25	1	7663
66462	4538	933724	2012-06-04	2012-06-18	1	15509
28486	1928	1503184	1990-07-05	1991-06-30	1	7850
10689	733	1778162	2016-05-03	2016-05-17	1	16938
77585	5302	1515774	1991-07-30	1992-07-24	1	8240
10782	741	19127890	1991-11-10	1993-10-30	2	8703
46861	3179	1713332	1922-11-22	1922-11-29	1	-17200
35687	2424	1729720	1971-04-02	1971-04-09	1	463
72752	4972	1125315	1957-10-10	1957-10-24	1	-4452
46972	3184	1125315	2004-12-02	2004-12-16	1	12768
34868	2357	1125315	1953-07-31	1953-08-14	1	-5984
26264	1776	1125315	1977-05-08	1977-05-15	1	2691
77197	5277	1713332	2009-08-07	2009-08-21	1	14477
22105	1506	1310149	2011-04-30	2011-04-30	1	15094
77817	5317	1125315	2006-03-01	2006-03-08	1	13215
31120	2103	933724	2009-05-31	2009-06-07	1	14402
46105	3129	1549786	1989-04-23	1990-04-18	1	7412
73017	4990	920293	1981-02-16	1981-02-23	1	4071
37482	2548	1125315	1975-11-12	1975-11-19	1	2148
34589	2341	1102527	1994-10-18	1994-10-18	1	9056
34395	2333	1154029	1978-05-19	1978-05-19	1	3060
34898	2359	1125315	1941-01-31	1941-02-14	1	-10548
21741	1478	1713332	1998-04-14	1998-04-28	1	10344
28871	1952	1125315	1962-01-22	1962-02-19	1	-2873
52719	3593	1713332	2008-08-11	2008-08-18	1	14109
11010	755	1713332	1978-02-24	1978-03-17	1	2997
70564	4819	1729720	1970-02-10	1970-02-17	1	47
13175	902	1119510	1970-05-23	1970-06-06	1	156
66463	4538	1118084	1987-05-22	1987-05-22	1	6350
28487	1928	1503184	1992-06-24	1993-06-19	1	8570
10690	733	1102527	1959-08-29	1959-08-29	1	-3778
77586	5302	1713332	2007-01-12	2007-01-19	1	13532
10783	741	1125315	1977-12-13	1978-01-12	1	2933
46862	3179	1112807	1932-10-14	1933-01-12	1	-13503
35688	2424	1759842	1968-09-16	1968-09-23	1	-465
72753	4972	1125315	1984-07-11	1984-07-25	1	5319
49984	3407	1118084	2005-08-02	2005-08-02	1	12997
34869	2357	1125315	2012-11-26	2013-02-24	1	15760
26265	1776	1310149	2003-10-11	2003-10-11	1	12336
77198	5277	1729720	1968-09-26	1968-10-09	1	-449
22106	1506	1347450	2012-10-13	2012-10-13	1	15626
77818	5317	1515774	1989-11-17	1990-11-12	1	7620
31121	2103	1112807	1973-06-19	1973-07-03	1	1279
46106	3129	1549786	1992-04-07	1993-04-02	1	8492
73018	4990	920293	1983-04-11	1983-04-18	1	4855
38162	2596	1119510	1988-12-07	1988-12-14	1	6922
34590	2341	1115008	2005-09-25	2005-10-09	1	13065
34396	2333	1177480	1991-04-19	1991-05-10	1	7799
34899	2359	1125315	2004-03-21	2004-04-04	1	12512
21742	1478	1717327	1962-04-15	1962-04-29	1	-2804
29664	2006	1112807	1955-09-28	1955-10-12	1	-5195
52720	3593	1118084	1988-02-29	1988-02-29	1	6633
11011	755	1729720	1953-04-08	1953-04-19	1	-6101
73379	5018	1713332	1992-09-25	1992-10-16	1	8324
13176	902	1125315	1960-08-05	1960-08-12	1	-3429
66464	4538	1125315	1986-09-21	1986-09-28	1	6114
28488	1928	19127890	1985-07-31	1986-07-26	1	6050
10691	733	1177480	2003-09-05	2003-11-11	1	12367
77587	5302	1729720	1989-01-15	1989-01-26	1	6965
10784	741	1125315	1982-10-18	1982-11-01	1	4687
46863	3179	1112807	1944-09-11	1944-09-25	1	-9229
35689	2424	1759842	1994-03-12	1994-03-26	1	8850
72754	4972	1125315	1997-08-30	1997-08-30	1	10103
49985	3407	1125315	2006-05-30	2006-06-20	1	13319
34870	2357	1557272	2009-02-24	2009-02-24	1	14299
26266	1776	1367571	1984-10-13	1984-10-13	1	5399
77199	5277	1759842	1972-03-05	1972-03-26	1	815
22107	1506	1557272	2006-04-01	2006-04-01	1	13239
77819	5317	1738521	1974-01-30	1974-02-13	1	1504
31122	2103	1118084	2010-09-21	2010-09-21	1	14873
46107	3129	1713332	2012-04-15	2012-04-29	1	15459
73019	4990	920293	1986-05-26	1986-06-02	1	5996
38163	2596	1125315	1968-03-04	1968-03-18	1	-654
34591	2341	1125315	1953-06-21	1953-07-05	1	-6024
34397	2333	1177480	1998-10-30	1998-11-20	1	10550
34900	2359	1322184	2011-04-25	2014-10-06	1	16349
21743	1478	1729720	1969-11-01	1969-11-14	1	-48
29665	2006	1124300	1986-01-28	1986-01-28	1	5871
52721	3593	1125315	1984-01-01	1984-01-22	1	5134
11012	755	1729720	1975-06-02	1975-06-10	1	1986
73380	5018	1713332	2012-11-14	2012-12-05	1	15679
13177	902	1361711	2011-05-21	2011-05-21	1	15115
66465	4538	1124957	1972-10-09	1972-10-09	1	1012
28489	1928	920293	2016-09-07	2016-09-14	1	17058
10692	733	1729720	1944-09-19	1944-09-30	1	-9224
77588	5302	19127890	1986-08-25	1987-08-20	1	6440
10785	741	1125315	1992-11-25	1992-12-02	1	8371
46864	3179	1125315	1932-10-14	1932-10-14	1	-13593
37180	2530	1112807	1972-12-20	1973-01-19	1	1114
72755	4972	1728416	1956-01-17	1956-01-31	1	-5084
49986	3407	1125315	1964-06-18	1964-07-02	1	-2009
34871	2357	1729720	1981-01-24	1981-02-03	1	4051
26267	1776	1729720	1921-08-06	1921-08-13	1	-17673
77200	5277	1759842	1983-07-01	1983-07-22	1	4950
22108	1506	1728416	1946-09-30	1946-10-14	1	-8480
31123	2103	1177480	1975-02-27	1975-05-28	1	1973
46108	3129	1759842	2012-04-15	2012-04-29	1	15459
73020	4990	933724	1981-02-16	1981-02-23	1	4071
38164	2596	1125315	1977-04-25	1977-05-25	1	2701
34592	2341	1125315	1954-05-16	1954-08-14	1	-5619
34398	2333	1557272	2000-06-13	2000-06-13	1	11121
34901	2359	1713332	1938-07-20	1938-08-31	1	-11446
21744	1478	1729720	2015-07-21	2015-07-29	1	16645
29666	2006	1125315	1950-03-30	1950-04-13	1	-7203
52722	3593	1310149	2017-06-14	2017-06-14	1	17331
11013	755	920293	1995-07-20	1995-07-27	1	9338
73381	5018	1759842	1964-01-16	1964-01-23	1	-2170
15313	1062	1112807	1966-12-16	1966-12-30	1	-1098
66466	4538	1125315	2009-06-08	2009-06-22	1	14417
28490	1928	933724	2016-09-07	2016-09-14	1	17058
11456	782	738818	1950-01-17	1950-01-24	1	-7282
77589	5302	19127890	1988-08-14	1989-08-09	1	7160
10786	741	1125315	2004-05-05	2004-05-19	1	12557
46865	3179	738818	1970-04-09	1970-04-23	1	112
37181	2530	1125315	1980-09-09	1980-12-08	2	3994
72756	4972	1759842	1970-07-10	1970-07-31	1	211
49987	3407	1713332	2002-02-05	2002-02-19	1	11737
34872	2357	1729720	1993-10-02	1993-10-10	1	8683
26268	1776	1759842	2012-11-24	2012-12-15	1	15689
77201	5277	1759842	2009-08-07	2009-08-21	1	14477
22109	1506	1729720	1948-10-22	1948-11-01	1	-7731
31124	2103	1177480	1991-06-17	1991-08-16	1	7897
46109	3129	19127890	1986-05-09	1987-05-04	1	6332
73021	4990	933724	1983-04-11	1983-04-18	1	4855
38165	2596	1125315	1983-09-21	1983-12-20	1	5101
34593	2341	1125315	1955-12-21	1956-01-04	1	-5111
34399	2333	1713332	1938-06-16	1938-06-23	1	-11515
34902	2359	1729720	1945-10-12	1945-10-24	1	-8835
21745	1478	1759842	1998-04-14	1998-04-28	1	10344
29667	2006	1177480	2000-09-13	2000-10-04	1	11234
52723	3593	1728416	1957-12-18	1958-01-01	1	-4383
11014	755	1102527	1970-08-08	1970-08-08	1	219
73382	5018	1759842	1992-09-25	1992-10-16	1	8324
15314	1062	1112807	1971-10-28	1971-11-11	1	679
66467	4538	1713332	1997-03-18	1997-04-08	1	9959
28491	1928	1119510	1974-03-22	1974-04-05	1	1555
11457	782	1112807	1913-07-07	1913-07-28	1	-20611
77590	5302	1112807	1973-05-25	1973-06-08	1	1254
10787	741	1177480	1977-04-17	1977-05-01	1	2677
46866	3179	738818	1988-12-19	1988-12-26	1	6934
37182	2530	1713332	1995-04-05	1995-04-26	1	9246
72757	4972	1759842	1980-04-13	1980-11-30	1	3986
49988	3407	920293	1985-02-22	1985-03-01	1	5538
34873	2357	1759842	1985-01-24	1985-01-31	1	5509
26269	1776	19059528	1984-10-13	1984-10-13	1	5399
77202	5277	1115008	1996-12-14	1996-12-28	1	9858
22110	1506	1112807	1946-09-30	1946-10-14	1	-8480
31125	2103	1717327	1973-06-19	1973-07-03	1	1279
46110	3129	1503184	1986-05-09	1987-05-04	1	6332
73022	4990	933724	1986-05-26	1986-06-02	1	5996
38166	2596	1125315	1985-06-18	1985-06-25	1	5654
34594	2341	1125315	1969-02-17	1969-03-03	1	-304
34400	2333	715997	2001-06-19	2001-06-19	1	11492
34903	2359	1729720	1983-04-13	1983-04-26	1	4863
21746	1478	19003953	1975-05-03	1975-05-03	1	1948
29668	2006	1177480	2006-06-05	2006-07-03	1	13332
52724	3593	1729720	1965-04-06	1965-04-15	1	-1722
11015	755	1118084	1991-08-08	1991-08-08	1	7889
73383	5018	1759842	2012-11-14	2012-12-05	1	15679
15315	1062	1125315	1981-05-11	1981-05-18	1	4155
66468	4538	920293	2012-06-04	2012-06-18	2	15509
28492	1928	1125315	1993-06-10	1993-06-24	1	8575
11458	782	1112807	1914-08-22	1914-09-19	1	-20193
77591	5302	1119510	1996-01-03	1996-01-17	1	9512
10788	741	1177480	1989-12-24	1990-01-21	1	7325
46867	3179	1112807	1925-10-30	1925-11-20	1	-16113
37183	2530	1717327	1964-10-23	1964-11-06	1	-1882
72758	4972	1112807	1956-09-13	1956-10-04	1	-4837
49989	3407	933724	1985-02-22	1985-03-01	1	5538
37048	2521	920293	1989-04-05	1989-04-12	1	7041
26270	1776	708298	1984-10-13	1984-10-13	1	5399
77203	5277	1125315	1961-10-30	1961-12-04	1	-2950
22111	1506	1729720	1975-12-30	1976-01-10	1	2200
31126	2103	1738521	1972-11-17	1972-12-01	1	1065
46111	3129	1759842	1975-01-02	1975-01-09	1	1834
73023	4990	1119510	2008-06-06	2008-06-13	1	14043
38167	2596	1177480	2018-03-28	2018-04-11	1	17632
34595	2341	1125315	1994-10-18	1994-11-22	1	9091
34401	2333	738818	1958-09-19	1958-09-26	1	-4115
34904	2359	1759842	1938-07-20	1938-08-31	1	-11446
22948	1558	782043	1962-06-14	1962-06-14	1	-2758
29669	2006	1759842	1949-07-20	1949-08-10	1	-7449
52725	3593	1112807	1957-12-18	1958-01-01	1	-4383
11016	755	1125315	1950-07-19	1950-08-23	1	-7071
73384	5018	1112807	1942-07-03	1942-07-17	1	-10030
15316	1062	1125315	1983-09-16	1983-09-23	1	5013
66469	4538	1115008	2003-12-26	2004-01-09	1	12426
28493	1928	1125315	1996-02-24	1996-03-16	1	9571
11459	782	1119510	1913-03-27	1913-04-03	1	-20727
77592	5302	1125315	1980-04-19	1980-04-26	1	3768
10789	741	1521369	1991-11-10	1993-10-30	2	8703
46868	3179	1118084	1958-12-06	1958-12-06	1	-4044
37184	2530	1759842	1995-04-05	1995-04-26	1	9246
72759	4972	1115008	1999-08-20	1999-09-19	1	10853
49990	3407	1115008	2010-04-30	2010-05-21	1	14750
37049	2521	933724	1989-04-05	1989-04-12	1	7041
26271	1776	1102527	1984-10-14	1984-10-14	1	5400
77204	5277	1125315	1970-02-17	1970-03-03	1	61
22112	1506	1729720	1980-05-02	1980-05-12	1	3784
31127	2103	19127890	1991-04-14	1992-04-08	1	8133
48340	3285	1112807	1964-05-17	1964-06-14	1	-2027
73024	4990	1125315	1971-03-09	1971-03-23	1	446
38168	2596	1713332	2010-12-23	2011-01-06	1	14980
34596	2341	1125315	2006-05-28	2006-06-04	1	13303
34402	2333	738818	1997-10-03	1997-10-10	1	10144
34905	2359	738818	1998-12-10	1998-12-17	1	10577
22949	1558	1118084	1992-09-01	1992-09-01	1	8279
29670	2006	914335	2014-01-17	2014-01-17	1	16087
52726	3593	1125315	1961-09-29	1961-10-13	1	-3002
11017	755	1125315	1979-12-15	1979-12-22	1	3642
73385	5018	1112807	1955-09-23	1955-10-21	1	-5186
15317	1062	738818	1973-03-16	1973-03-23	1	1177
66470	4538	1177480	2011-10-29	2011-12-28	1	15336
28494	1928	1177480	1974-03-21	1974-04-20	1	1570
11460	782	1125315	1911-12-17	1911-12-31	1	-21186
77593	5302	1125315	1992-07-23	1992-08-06	1	8253
10790	741	920293	1995-12-23	1995-12-30	1	9494
46869	3179	1119510	1996-02-04	1996-02-11	1	9537
37185	2530	738818	2017-04-21	2017-04-28	1	17284
72760	4972	1124300	1988-09-20	1988-09-20	1	6837
49991	3407	1717327	1964-06-18	1964-07-02	1	-2009
37050	2521	1112807	1949-01-13	1949-04-13	3	-7609
26272	1776	1110410	1984-10-13	1984-10-13	1	5399
77205	5277	1125315	1998-08-05	1998-08-12	1	10450
23363	1586	738818	2001-10-15	2001-10-22	1	11617
31128	2103	1125315	1972-07-12	1972-07-26	1	937
48341	3285	1729720	1978-11-13	1978-11-22	1	3247
73025	4990	1125315	1974-01-21	1974-04-21	1	1571
38169	2596	1759842	2010-12-23	2011-01-06	1	14980
34597	2341	1125315	2008-03-26	2008-04-02	1	13971
34403	2333	782043	1978-05-19	1978-05-19	1	3060
34906	2359	1125315	1984-11-14	1984-11-21	1	5438
22950	1558	1125315	2006-04-06	2006-04-13	1	13251
29671	2006	920293	1993-02-12	1993-02-19	1	8450
52727	3593	1307863	2017-06-14	2017-06-14	1	17331
11018	755	1729720	1975-12-08	1975-12-15	1	2174
73386	5018	1125315	1963-05-07	1963-05-21	1	-2417
15318	1062	1102527	1979-05-24	1979-05-24	1	3430
66471	4538	1759842	1997-03-18	1997-04-08	1	9959
28495	1928	1503184	1985-07-31	1986-07-26	1	6050
11461	782	1125315	1954-06-12	1954-08-18	2	-5615
77594	5302	1713332	2004-10-01	2004-10-08	1	12699
10791	741	1118084	2011-07-08	2011-07-08	1	15163
46870	3179	1125315	1970-04-09	1970-04-23	1	112
37186	2530	1125315	1968-10-03	1968-10-17	1	-441
72761	4972	1124957	1997-08-30	1997-08-30	1	10103
49992	3407	1729720	1966-11-09	1966-11-19	1	-1139
37051	2521	1125315	1948-03-20	1948-04-03	1	-7943
26273	1776	1112807	1918-01-21	1918-02-04	1	-18959
77206	5277	1713332	1972-03-05	1972-03-26	1	815
23364	1586	1119510	2001-10-15	2001-10-22	1	11617
31129	2103	1177480	1975-11-08	1975-11-22	1	2151
48342	3285	1125315	1962-06-27	1962-08-04	2	-2724
73026	4990	1125315	2008-06-06	2008-06-13	1	14043
38170	2596	738818	1980-10-21	1980-11-04	1	3960
34598	2341	1326303	2002-03-28	2002-03-28	1	11774
34404	2333	1000560	1978-05-19	1978-05-19	2	3060
34907	2359	1125315	1995-06-07	1995-07-07	1	9318
22951	1558	1367571	1962-06-14	1962-06-14	1	-2758
29672	2006	933724	1993-02-12	1993-02-19	1	8450
52728	3593	1759842	1988-05-26	1988-06-02	1	6727
11019	755	738818	2004-04-16	2004-04-30	1	12538
73387	5018	1713332	1964-01-16	1964-01-23	1	-2170
15319	1062	1125315	1973-03-16	1973-03-23	1	1177
66472	4538	1125315	1972-10-02	1972-11-08	2	1042
28496	1928	1521369	1990-07-05	1991-06-30	1	7850
11462	782	738818	1913-03-27	1913-04-03	1	-20727
77595	5302	1713332	2017-04-21	2017-04-28	1	17284
10792	741	19127890	1989-11-20	1990-11-15	1	7623
46871	3179	1125315	1988-12-19	1988-12-26	1	6934
37187	2530	1112807	1968-03-06	1968-04-10	1	-631
72762	4972	1125315	1956-01-17	1956-01-31	1	-5084
49993	3407	1759842	2002-02-05	2002-02-19	1	11737
37052	2521	1728416	1949-01-13	1949-01-27	1	-7644
26274	1776	1112807	1921-06-27	1921-07-11	1	-17706
77207	5277	1728416	1956-07-28	1956-08-11	1	-4891
23365	1586	1125315	1954-06-21	1954-07-19	1	-5645
31130	2103	1177480	2002-08-18	2002-09-08	1	11938
48343	3285	1125315	1996-02-26	1996-03-11	1	9566
73027	4990	1717327	1966-07-02	1966-07-16	1	-1265
38171	2596	738818	1988-12-07	1988-12-14	1	6922
34599	2341	1728416	1955-12-21	1956-01-04	1	-5111
34405	2333	1112807	1922-12-18	1923-01-01	1	-17167
34908	2359	1174888	1998-03-23	1998-03-23	1	10308
22952	1558	1713332	1974-01-13	1974-02-03	1	1494
29673	2006	1125315	1967-03-29	1967-04-05	1	-1002
52729	3593	1759842	2008-08-11	2008-08-18	1	14109
11020	755	933724	1995-07-20	1995-07-27	1	9338
73388	5018	1112807	1963-07-16	1963-08-06	1	-2340
15320	1062	1713332	2018-01-15	2018-01-22	1	17553
66473	4538	1713332	2012-11-25	2012-12-02	1	15676
28497	1928	1521369	1992-06-24	1993-06-19	1	8570
11463	782	1112807	1949-12-14	1950-01-04	1	-7302
77596	5302	1759842	2004-10-01	2004-10-08	1	12699
11952	822	1729720	1973-11-26	1973-12-03	1	1432
46872	3179	1729720	1928-02-04	1928-02-14	1	-15297
37188	2530	1119510	2017-04-21	2017-04-28	1	17284
72763	4972	1177480	1997-08-30	1997-09-29	1	10133
49994	3407	1125315	1999-07-15	1999-08-05	1	10808
37053	2521	1125315	1986-08-07	1986-09-04	1	6090
26275	1776	1125315	1947-12-17	1947-12-24	1	-8044
77208	5277	1759842	1963-12-06	1963-12-13	1	-2211
23366	1586	1125315	2001-10-15	2001-10-22	1	11617
31131	2103	1521369	1987-05-05	1989-04-24	2	7053
48344	3285	1729720	1963-01-26	1963-02-04	1	-2523
73028	4990	1102527	1979-12-21	1979-12-21	1	3641
38172	2596	1112807	1969-05-31	1969-06-14	1	-201
34600	2341	1729720	1962-06-28	1962-07-06	1	-2736
34406	2333	1112807	1936-01-09	1936-02-06	1	-12383
34909	2359	1322184	2015-05-18	2015-05-18	1	16573
22953	1558	1728416	1957-09-01	1957-09-15	1	-4491
29674	2006	1177480	1986-08-30	1986-09-27	1	6113
52730	3593	1125315	1953-03-14	1953-04-13	1	-6107
11021	755	1125315	1989-02-12	1989-02-26	1	6996
73389	5018	1125315	1942-05-06	1942-05-13	1	-10095
15321	1062	1728416	1966-12-16	1966-12-30	1	-1098
66474	4538	1759842	2012-11-25	2012-12-02	1	15676
28498	1928	1713332	1979-03-20	1979-04-10	1	3386
11464	782	1118084	1944-10-27	1944-10-27	1	-9197
77597	5302	1759842	2017-04-21	2017-04-28	1	17284
11953	822	1125315	1975-09-16	1975-09-30	1	2098
46873	3179	1759842	1922-11-22	1922-11-29	1	-17200
37189	2530	1125315	1978-04-06	1978-04-20	1	3031
72764	4972	1713332	1970-07-10	1970-07-31	1	211
49995	3407	1713332	2013-07-26	2013-08-09	1	15926
37054	2521	1713332	1971-02-18	1971-03-11	1	434
26276	1776	1125315	1997-12-07	1997-12-28	1	10223
77209	5277	738818	1990-09-21	1990-10-05	1	7582
23367	1586	1125315	2008-07-03	2008-09-01	1	14123
31132	2103	1729720	2015-04-01	2015-04-09	1	16534
48345	3285	1124300	1997-11-25	1997-11-25	1	10190
73029	4990	1713332	1988-09-25	1988-10-16	1	6863
38173	2596	1124957	2017-04-02	2017-04-02	1	17258
34601	2341	19127890	1976-01-31	1977-01-25	1	2581
34407	2333	1112807	1940-09-12	1940-09-26	1	-10689
34910	2359	1332418	2011-04-25	2011-04-25	1	15089
22954	1558	1729720	2000-12-04	2000-12-11	1	11302
29675	2006	1177480	2008-06-22	2008-07-13	1	14073
52731	3593	1177480	1987-09-03	1987-09-24	1	6475
11022	755	1125315	2011-04-01	2011-04-15	1	15079
73390	5018	1125315	1959-08-01	1959-09-05	1	-3771
15322	1062	1728416	1971-10-28	1971-11-11	1	679
67937	4636	1713332	1976-07-08	1976-07-22	1	2394
28499	1928	1125315	1980-06-09	1980-06-16	1	3819
11465	782	1125315	1913-03-27	1913-04-03	1	-20727
77598	5302	19127890	1991-07-30	1992-07-24	1	8240
11954	822	1728416	1975-09-16	1975-09-30	1	2098
47207	3207	914335	1994-12-01	1994-12-01	1	9100
37190	2530	1125315	1988-08-04	1988-08-11	1	6797
72765	4972	1729720	1974-05-25	1974-06-02	1	1613
49996	3407	1759842	2013-07-26	2013-08-09	1	15926
37055	2521	1729720	1953-01-10	1953-01-17	1	-6193
26277	1776	1713332	1991-08-16	1991-08-30	1	7911
77210	5277	1125315	1990-09-21	1990-10-05	1	7582
23368	1586	1361711	1966-05-22	1966-05-22	1	-1320
31133	2103	1729720	2015-09-07	2015-09-14	1	16692
48346	3285	1125315	1980-06-04	1980-06-18	1	3821
73030	4990	1759842	1980-08-31	1980-09-14	1	3909
38174	2596	1125315	1980-10-21	1980-11-04	1	3960
35191	2387	1115008	2002-10-27	2002-11-10	1	12001
34408	2333	1119510	1941-12-17	1941-12-31	1	-10228
34911	2359	1539403	2011-04-25	2011-04-25	1	15089
22955	1558	19003953	1962-06-14	1962-06-14	1	-2758
29676	2006	1309944	2014-01-17	2014-01-17	1	16087
52732	3593	1177480	2017-08-17	2017-09-07	1	17416
11023	755	1177480	1979-06-22	1979-07-13	1	3480
73391	5018	1125315	1979-03-13	1979-03-27	1	3372
15323	1062	1759842	2018-01-15	2018-01-22	1	17553
67938	4636	1112807	1948-05-08	1948-05-22	1	-7894
28500	1928	1125315	2004-09-24	2004-10-08	1	12699
11466	782	1125315	1963-11-14	1963-11-28	1	-2226
77599	5302	738818	1996-01-03	1996-01-17	1	9512
11955	822	1124300	2013-09-21	2013-09-21	1	15969
47208	3207	1112807	1963-08-12	1963-08-26	1	-2320
37191	2530	1112807	1964-10-23	1964-11-06	1	-1882
73065	4992	1729720	2014-03-01	2014-03-14	1	16143
52001	3541	1125315	1998-10-25	1998-11-08	1	10538
37056	2521	1759842	1970-09-24	1970-10-15	1	287
26278	1776	1713332	1991-12-07	1991-12-14	1	8017
77211	5277	1177480	2018-07-06	2018-07-20	1	17732
23369	1586	1539403	1991-09-01	1991-09-01	1	7913
31134	2103	1738521	1972-07-12	1972-07-26	1	937
73031	4990	1112807	1967-03-29	1967-06-27	1	-919
38175	2596	1125315	1988-12-07	1988-12-14	1	6922
35192	2387	1713332	2006-09-03	2006-09-10	1	13401
34409	2333	1124957	1978-05-20	1978-05-20	1	3061
34990	2369	1154343	1984-05-09	2001-04-01	1	11413
22956	1558	1729720	1999-08-03	1999-08-11	1	10814
29677	2006	1343916	2014-01-17	2014-01-17	1	16087
54852	3731	1738521	1974-06-20	1974-07-04	1	1645
11024	755	1728416	1950-08-18	1950-08-23	1	-7071
73392	5018	1125315	2009-08-27	2009-09-03	1	14490
15324	1062	1119510	1973-03-16	1973-03-23	1	1177
67939	4636	1759842	1976-07-08	1976-07-22	1	2394
28501	1928	1521369	1985-07-31	1986-07-26	1	6050
11467	782	1759842	1999-01-07	1999-01-28	1	10619
77600	5302	1125315	1996-01-03	1996-01-17	1	9512
11956	822	1125315	1988-02-10	1988-03-09	1	6642
47209	3207	1125315	1961-06-28	1961-07-12	1	-3095
37192	2530	1112807	1965-03-04	1965-03-18	1	-1750
73066	4992	19127890	1999-05-13	2000-05-07	1	11084
52002	3541	1177480	2000-06-26	2000-07-31	1	11169
37057	2521	1322184	2007-10-15	2007-10-15	1	13801
26279	1776	1741122	1984-10-13	1984-10-13	1	5399
77212	5277	1713332	1982-08-09	1982-08-30	1	4624
23370	1586	1112807	1953-04-27	1953-05-11	1	-6079
33376	2267	738818	1983-10-21	1983-10-28	1	5048
73032	4990	1119510	1971-03-09	1971-03-23	1	446
38176	2596	1728416	1969-05-31	1969-06-14	1	-201
35193	2387	1521369	1983-02-19	1984-02-14	1	5157
34410	2333	1125315	1926-02-01	1926-02-08	1	-16033
34991	2369	1129625	1982-01-16	1982-01-16	1	4398
22957	1558	1759842	1974-01-13	1974-02-03	1	1494
29678	2006	1713332	1949-07-20	1949-08-10	1	-7449
54853	3731	1177480	1989-03-31	1989-04-30	1	7059
11025	755	1759842	1965-07-21	1965-08-04	1	-1611
73393	5018	1177480	1976-03-30	1976-06-28	1	2370
15325	1062	1124300	2000-08-29	2000-08-29	1	11198
67940	4636	1124300	1986-10-26	1986-10-26	1	6142
30252	2046	1112807	1966-03-30	1966-04-13	1	-1359
11468	782	1125315	1921-11-16	1921-11-30	1	-17564
77601	5302	1521369	1986-08-25	1987-08-20	1	6440
13742	940	738818	1982-07-13	1982-07-20	1	4583
47210	3207	1177480	1990-07-01	1990-07-29	1	7514
37193	2530	1118084	2000-09-04	2000-09-04	1	11204
73067	4992	1125315	2004-05-07	2004-05-21	1	12559
52003	3541	1713332	1968-04-10	1968-04-24	1	-617
37058	2521	1347450	2006-03-20	2006-03-20	1	13227
26280	1776	1759842	1991-08-16	1991-08-30	1	7911
77213	5277	1759842	1982-08-09	1982-08-30	1	4624
23371	1586	1112807	1961-04-13	1961-04-27	1	-3171
33377	2267	1118084	2009-11-17	2009-11-17	1	14565
73033	4990	1177480	1979-12-21	1980-03-20	1	3731
38177	2596	1738521	1967-03-28	1967-04-11	1	-996
35194	2387	1118084	2006-04-04	2006-04-04	1	13242
34411	2333	1125315	1951-03-31	1951-04-14	1	-6837
34992	2369	1125315	2004-07-03	2004-07-17	1	12616
22958	1558	1000560	1962-06-14	1962-06-14	2	-2758
29679	2006	1729720	1948-02-08	1948-02-19	1	-7987
54854	3731	1729720	1976-09-11	1976-09-22	1	2456
11026	755	1759842	1978-02-24	1978-03-17	1	2997
73394	5018	920293	1980-11-30	1980-12-07	1	3993
15326	1062	1729720	1994-02-18	1994-02-28	1	8824
67941	4636	1125315	1962-02-08	1962-02-22	1	-2870
30253	2046	1119510	1961-04-01	1961-04-08	1	-3190
11469	782	1125315	1950-01-17	1950-01-24	1	-7282
77602	5302	1521369	1988-08-14	1989-08-09	1	7160
13743	940	914335	1993-03-04	1993-03-04	1	8463
47211	3207	1728416	1961-06-28	1961-07-12	1	-3095
37194	2530	1125315	1970-12-26	1971-01-30	1	394
73068	4992	1503184	1999-05-13	2000-05-07	1	11084
52004	3541	1112807	1987-04-08	1987-04-22	1	6320
37059	2521	920293	1986-02-17	1986-03-03	2	5905
26281	1776	1759842	1991-12-07	1991-12-14	1	8017
47146	3200	738818	1961-09-03	1961-09-17	1	-3028
23372	1586	1124300	1974-10-19	1974-10-19	1	1752
33378	2267	1125315	1983-10-21	1983-10-28	1	5048
73034	4990	1713332	2012-12-24	2012-12-31	1	15705
38178	2596	1124300	2004-06-06	2004-06-06	1	12575
35195	2387	1125315	1972-05-08	1972-05-15	1	865
34412	2333	1125315	1958-09-19	1958-09-26	1	-4115
34993	2369	1125315	2006-07-09	2006-07-23	1	13352
22959	1558	1112807	1957-09-01	1957-09-15	1	-4491
29680	2006	1112807	1946-02-17	1946-03-03	1	-8705
54855	3731	1118084	2008-03-03	2008-03-03	1	13941
11659	800	1102527	1980-03-14	1980-03-14	1	3725
73395	5018	933724	1980-11-30	1980-12-07	1	3993
15327	1062	1112807	1969-02-03	1969-04-11	1	-265
67942	4636	1125315	1963-10-18	1963-10-25	1	-2260
30254	2046	1125315	1969-12-30	1970-01-29	2	28
11470	782	1174888	1954-06-19	1954-06-19	1	-5675
77603	5302	1759842	2007-01-12	2007-01-19	1	13532
13744	940	1118084	1982-07-09	1982-07-09	1	4572
47212	3207	1759842	1965-10-03	1965-10-17	1	-1537
37195	2530	1125315	2001-08-05	2001-08-12	1	11546
73069	4992	1503184	2001-05-02	2002-04-27	1	11804
52005	3541	1112807	1991-04-01	1991-04-15	1	7774
37060	2521	933724	1986-02-17	1986-03-03	1	5905
29190	1977	1125315	1922-01-10	1922-01-24	1	-17509
47147	3200	1125315	1961-09-03	1961-09-17	1	-3028
23373	1586	1125315	1954-10-20	1954-11-03	1	-5538
33379	2267	1759842	1980-12-20	1980-12-27	1	4013
73035	4990	1729720	2008-02-04	2008-02-12	1	13921
38179	2596	1125315	1967-03-28	1967-04-11	1	-996
35196	2387	1503184	1983-02-19	1984-02-14	1	5157
34413	2333	1307863	1990-04-17	1990-04-17	1	7411
34994	2369	1149380	1984-05-09	2001-04-01	1	11413
22960	1558	1125315	1996-01-21	1996-01-28	1	9523
29681	2006	1115008	2013-04-18	2013-05-09	1	15834
54856	3731	1125315	1974-06-20	1974-07-04	1	1645
11660	800	1177480	1996-07-30	1996-08-20	1	9728
73396	5018	1102527	1976-03-30	1976-03-30	1	2280
15328	1062	1125315	1972-01-26	1972-03-01	1	790
67943	4636	1728416	1950-11-24	1950-12-08	1	-6964
30255	2046	1125315	1991-11-12	1991-11-19	1	7992
11471	782	1713332	1999-01-07	1999-01-28	1	10619
77604	5302	1503184	1986-08-25	1987-08-20	1	6440
13745	940	1125315	1947-05-05	1947-05-19	1	-8263
47213	3207	1124300	1995-08-19	1995-08-19	1	9361
37196	2530	1125315	2017-04-21	2017-04-28	1	17284
73070	4992	1713332	1987-09-03	1987-09-17	1	6468
52006	3541	1729720	2018-09-27	2018-10-08	1	17812
37061	2521	1112807	1964-04-15	1964-05-13	1	-2059
29191	1977	1125315	1931-01-29	1931-02-12	1	-14203
47148	3200	1125315	2012-03-13	2012-03-27	1	15426
23374	1586	1125315	1964-03-12	1964-05-11	2	-2061
33380	2267	19127890	1983-11-19	1984-11-13	1	5430
73036	4990	1759842	1988-09-25	1988-10-16	1	6863
38180	2596	1125315	1974-04-11	1974-05-11	1	1591
35197	2387	1759842	2006-09-03	2006-09-10	1	13401
34414	2333	1713332	1931-01-01	1931-01-15	1	-14231
34995	2369	1551099	1981-12-29	1981-12-29	1	4380
22961	1558	1728416	1957-02-12	1957-02-26	1	-4692
29682	2006	1125315	1959-11-28	1959-12-05	1	-3680
54857	3731	1125315	1978-10-28	1978-11-04	1	3229
11661	800	1713332	1970-12-08	1970-12-22	1	355
73397	5018	1118084	1980-01-25	1980-01-25	1	3676
15329	1062	1125315	1979-05-24	1979-06-23	1	3460
67944	4636	1112807	1950-11-24	1950-12-08	1	-6964
30256	2046	1177480	1995-01-18	1995-02-08	1	9169
11472	782	836654	1994-05-15	1994-05-15	1	8900
77605	5302	1503184	1988-08-14	1989-08-09	1	7160
13746	940	1125315	1971-08-09	1971-08-23	1	599
47214	3207	1125315	1960-10-01	1960-12-30	1	-3289
37197	2530	1174888	1980-09-09	1980-09-09	1	3904
73071	4992	19127890	2001-05-02	2002-04-27	1	11804
52007	3541	1124300	2010-07-17	2010-07-17	1	14807
37062	2521	1112807	1980-08-17	1980-09-07	1	3902
29192	1977	1177480	2007-12-09	2007-12-23	1	13870
47149	3200	1729720	1980-01-05	1980-01-15	1	3666
23375	1586	1174888	1964-03-12	1964-03-12	1	-2121
33381	2267	19127890	1985-11-08	1986-11-03	1	6150
73037	4990	1759842	2012-12-24	2012-12-31	1	15705
38181	2596	1125315	2018-11-09	2018-11-23	1	17858
35198	2387	1125315	2012-08-30	2012-09-13	1	15596
34415	2333	1713332	1971-09-21	1971-10-12	1	649
34996	2369	1729720	2002-09-07	2002-09-16	1	11946
22962	1558	1746114	1962-06-14	1962-06-14	1	-2758
29683	2006	1125315	1993-10-17	1993-10-31	1	8704
54858	3731	1125315	1988-04-14	1988-05-05	1	6699
11662	800	1124300	1994-07-09	1994-07-09	1	8955
75887	5196	1125315	2006-10-07	2006-10-14	1	13435
15330	1062	1125315	1992-08-22	1992-09-05	1	8283
67945	4636	1125315	1972-07-01	1972-07-08	1	919
30257	2046	1713332	1996-04-19	1996-05-03	1	9619
11473	782	1119510	1950-01-17	1950-01-24	1	-7282
77606	5302	1549786	1991-07-30	1992-07-24	1	8240
13747	940	1125315	1982-07-13	1982-07-30	2	4593
47215	3207	1125315	1962-10-12	1962-10-26	1	-2624
38379	2610	1102527	2000-09-02	2000-09-02	1	11202
73072	4992	705944	1995-05-14	1998-05-31	1	10377
52008	3541	1125315	1978-12-07	1978-12-21	1	3276
37063	2521	1118084	1983-12-31	1983-12-31	1	5112
29193	1977	1307863	2012-05-31	2012-05-31	1	15491
47150	3200	1115008	2013-08-19	2013-11-17	1	16026
23376	1586	1322184	1997-10-05	1997-10-05	1	10139
33382	2267	1125315	1979-07-05	1979-07-12	1	3479
73038	4990	1112807	1966-03-04	1966-07-16	2	-1295
38182	2596	1112807	1969-08-14	1969-09-04	1	-119
35199	2387	19127890	1983-02-19	1984-02-14	1	5157
34416	2333	1759842	1931-01-01	1931-01-15	1	-14231
34997	2369	1124300	2018-07-18	2018-07-18	1	17730
22963	1558	708298	1962-06-14	1962-06-14	1	-2758
29684	2006	1501700	2017-12-31	2017-12-31	1	17531
54859	3731	1112807	1984-07-27	1984-09-02	1	5358
11663	800	1125315	1958-05-09	1958-05-23	1	-4241
75888	5196	1177480	1993-08-20	1993-09-17	1	8660
15331	1062	1125315	2005-09-04	2005-10-04	1	13060
67946	4636	1557272	2006-08-15	2006-08-15	1	13375
30258	2046	1729720	1945-03-03	1945-03-15	1	-9058
11474	782	1125315	1977-11-15	1977-11-29	1	2889
77709	5312	1112807	1939-09-26	1939-10-10	1	-11041
13748	940	1309944	1993-03-04	1993-03-04	1	8463
47216	3207	1309944	1994-12-01	1994-12-01	1	9100
38380	2610	1112807	1973-04-26	1973-06-26	1	1272
73073	4992	1118084	2019-03-24	2019-03-24	1	17979
52009	3541	1125315	2014-08-18	2014-09-01	1	16314
37064	2521	1125315	1981-11-05	1981-11-12	1	4333
29194	1977	1322184	1997-03-06	1997-03-06	1	9926
47151	3200	1119510	1961-09-03	1961-09-17	1	-3028
23377	1586	920293	1966-04-12	1966-04-19	1	-1353
33383	2267	1177480	1980-02-28	1980-04-03	1	3745
73039	4990	1118084	2002-08-02	2002-08-02	1	11901
38183	2596	1119510	1980-10-21	1980-11-04	1	3960
36643	2495	1124300	2015-04-10	2015-04-10	1	16535
34417	2333	708298	1978-05-19	1978-05-19	1	3060
36405	2477	933724	2001-03-23	2001-03-30	1	11411
22964	1558	753626	1962-06-14	1962-06-14	1	-2758
29685	2006	1729720	1961-12-11	1961-12-21	1	-2933
54860	3731	1112807	1990-01-09	1990-01-23	1	7327
11664	800	1125315	1980-03-14	1980-05-13	1	3785
75889	5196	1728416	1956-02-08	1956-02-22	1	-5062
15332	1062	1728416	1972-01-26	1972-03-01	1	790
70980	4848	920293	2003-09-29	2003-10-06	1	12331
30259	2046	1124957	1969-12-30	1969-12-30	1	-2
11475	782	1177480	1978-12-24	1979-01-07	1	3293
77710	5312	1177480	2004-12-16	2005-01-06	1	12789
13749	940	1343916	1993-03-04	1993-03-04	1	8463
47217	3207	1343916	1994-12-01	1994-12-01	1	9100
38381	2610	1125315	2000-09-02	2000-11-30	1	11291
73074	4992	1177480	1987-09-03	1987-09-17	1	6468
52010	3541	1759842	1968-04-10	1968-04-24	1	-617
37065	2521	1125315	1985-08-24	1985-09-07	1	5728
29195	1977	1759842	1966-04-20	1966-05-11	1	-1331
47152	3200	1124957	2014-09-13	2014-09-13	1	16326
23378	1586	933724	1966-04-12	1966-04-19	1	-1353
33384	2267	1503184	1983-11-19	1984-11-13	1	5430
73040	4990	1125315	1975-04-09	1975-04-23	1	1938
38184	2596	1125315	1967-10-25	1967-11-08	1	-785
36644	2495	1125315	2013-12-20	2013-12-27	1	16066
34418	2333	715997	2003-05-10	2003-05-10	1	12182
36406	2477	1125315	1967-10-22	1967-11-12	1	-781
22965	1558	967823	1962-06-14	1962-06-14	1	-2758
29686	2006	1729720	1972-02-28	1972-03-11	1	800
54861	3731	1125315	1999-10-16	1999-10-23	1	10887
11665	800	1125315	1994-06-04	1994-08-10	1	8987
75890	5196	1119510	1958-12-26	1959-01-02	1	-4017
17750	1226	738818	1989-07-19	1989-08-02	1	7153
70981	4848	1112807	1966-10-01	1966-12-30	1	-1098
30260	2046	1125315	1946-11-21	1946-11-28	1	-8435
11476	782	1177480	1990-05-09	1990-07-08	1	7493
77711	5312	1557272	1998-12-14	1998-12-14	1	10574
13750	940	1119510	1982-07-13	1982-07-20	1	4583
47218	3207	1713332	1984-01-31	1984-02-14	1	5157
38382	2610	1521369	1975-06-12	1976-06-06	1	2348
73075	4992	1521369	1999-05-13	2000-05-07	1	11084
52681	3589	1125315	2007-03-16	2007-03-30	1	13602
37066	2521	1322184	2006-03-20	2006-03-20	1	13227
29196	1977	1112807	1911-11-02	1911-11-16	1	-21231
47153	3200	1125315	1958-01-21	1958-02-18	1	-4335
23379	1586	1112807	1967-04-26	1967-05-10	1	-967
33385	2267	1503184	1985-11-08	1986-11-03	1	6150
73041	4990	1125315	2002-07-31	2002-08-07	1	11906
38185	2596	1125315	1978-04-14	1978-04-28	1	3039
36645	2495	1503184	1996-09-16	1997-09-11	1	10115
34419	2333	753626	1978-05-19	1978-05-19	1	3060
36407	2477	1521369	1977-01-12	1978-01-07	1	2928
22966	1558	1110410	1962-06-14	1962-06-14	1	-2758
29687	2006	1729720	1980-07-29	1980-08-11	1	3875
54862	3731	1125315	2011-08-22	2011-09-05	1	15222
11666	800	1728416	1958-05-09	1958-05-23	1	-4241
75891	5196	1125315	2005-09-04	2005-09-11	1	13037
17751	1226	1125315	1989-07-19	1989-08-02	1	7153
70982	4848	1125315	1970-12-09	1971-01-06	1	370
30261	2046	1125315	2014-04-01	2014-04-01	1	16161
11477	782	1729720	1938-09-27	1938-10-10	1	-11406
77712	5312	1713332	1944-07-07	1944-07-14	1	-9302
13751	940	1124957	1956-05-30	1956-05-30	1	-4964
47219	3207	1729720	1971-02-09	1971-02-22	1	417
38383	2610	1118084	1992-06-17	1992-06-17	1	8203
73076	4992	1521369	2001-05-02	2002-04-27	1	11804
52682	3589	1150770	1981-08-09	1981-08-09	1	4238
37067	2521	1347450	2007-10-15	2007-10-15	1	13801
29197	1977	1118084	1952-04-20	1952-04-20	1	-6465
47154	3200	1125315	1981-03-19	1981-04-09	1	4116
23380	1586	1332418	1994-09-18	1994-09-18	1	9026
33386	2267	1713332	2008-10-14	2008-11-04	1	14187
73042	4990	1713332	1980-08-31	1980-09-14	1	3909
38186	2596	1125315	2017-04-02	2017-04-02	1	17258
36646	2495	1515774	1994-09-27	1995-09-22	1	9395
34420	2333	1110410	1978-05-19	1978-05-19	1	3060
36408	2477	1729720	1967-06-10	1967-06-18	1	-928
22967	1558	1112807	1957-02-12	1957-02-26	1	-4692
30436	2060	738818	2008-06-29	2008-07-13	1	14073
54863	3731	1125315	2016-09-15	2016-09-22	1	17066
11667	800	1729720	2013-03-15	2013-03-23	1	15787
75892	5196	1729720	1958-01-11	1958-01-19	1	-4365
17752	1226	1115008	2014-09-05	2014-09-26	1	16339
70983	4848	1125315	2007-08-14	2007-08-28	1	13753
30262	2046	1545958	2014-04-01	2014-04-01	1	16161
14489	994	1125315	1969-10-29	1969-11-05	1	-57
77713	5312	1729720	1950-07-16	1950-07-29	1	-7096
13752	940	1125315	1956-10-06	1956-10-20	1	-4821
47220	3207	1759842	1984-01-31	1984-02-14	1	5157
38384	2610	1503184	1975-06-12	1976-06-06	1	2348
75305	5152	1119510	2002-01-17	2002-01-31	1	11718
52683	3589	1177480	1985-09-24	1985-10-08	1	5759
37068	2521	1713332	1970-09-24	1970-10-15	1	287
29198	1977	1125315	1993-08-19	1993-09-09	1	8652
47155	3200	1125315	2014-09-13	2014-11-12	2	16386
23381	1586	1713332	1947-11-04	1947-11-18	1	-8080
33387	2267	1738521	1969-08-24	1969-09-07	1	-116
75530	5170	705944	1979-12-25	1987-01-02	1	6210
38187	2596	1177480	2017-03-26	2017-06-01	1	17318
36647	2495	1549786	2000-08-26	2001-08-21	1	11555
34421	2333	1112807	1925-11-23	1925-12-07	1	-16096
36409	2477	920293	2003-04-24	2003-05-08	2	12180
22968	1558	1112807	1969-04-10	1969-05-01	1	-245
30437	2060	1112807	1968-06-10	1968-06-24	1	-556
54864	3731	1177480	1991-05-20	1991-08-18	1	7899
11668	800	1759842	1970-12-08	1970-12-22	1	355
75893	5196	738818	1958-12-26	1959-01-02	1	-4017
17753	1226	1119510	1995-09-18	1995-09-25	1	9398
70984	4848	1118084	1996-08-24	1996-08-24	1	9732
30263	2046	1713332	2005-06-18	2005-07-02	1	12966
14490	994	1729720	2007-02-06	2007-02-15	1	13559
77714	5312	738818	1961-05-04	1961-05-11	1	-3157
13753	940	1125315	1979-05-30	1979-06-13	1	3450
47221	3207	1125315	1968-07-22	1968-08-05	1	-514
38385	2610	1729720	1983-09-13	1983-09-20	1	5010
75306	5152	1125315	2002-09-18	2002-10-09	1	11969
37069	2521	1728416	1949-03-30	1949-04-13	1	-7568
29199	1977	1177480	2000-05-05	2000-05-19	1	11096
47156	3200	1729720	1951-02-12	1951-02-21	1	-6889
23382	1586	1759842	1961-09-13	1961-09-27	1	-3018
33388	2267	1759842	2008-10-14	2008-11-04	1	14187
75531	5170	1124957	1981-02-11	1981-02-11	1	4059
40440	2750	701322	2009-06-28	2009-06-28	1	14423
36648	2495	1595799	2000-08-26	2001-08-21	1	11555
34422	2333	1112807	1948-02-17	1948-03-16	1	-7961
36410	2477	933724	2003-04-24	2003-05-08	1	12180
22969	1558	1741122	1962-06-14	1962-06-14	1	-2758
30438	2060	1119510	1998-12-19	1999-01-02	1	10593
54865	3731	1778162	1990-01-09	1990-01-23	1	7327
11669	800	1125315	1970-06-11	1970-06-25	1	175
75894	5196	1112807	1989-01-15	1989-02-12	1	6982
17754	1226	1119510	1989-07-19	1989-08-02	1	7153
70985	4848	1177480	1980-08-16	1980-09-06	1	3901
30264	2046	1118084	1984-11-29	1984-11-29	1	5446
14491	994	1112807	1962-08-05	1962-08-19	1	-2692
77715	5312	1112807	1987-06-21	1987-07-19	1	6408
13754	940	1125315	1987-05-02	1987-05-23	1	6351
47222	3207	1177480	1982-11-05	1982-12-10	1	4726
38386	2610	1112807	1960-06-20	1960-07-04	1	-3468
75307	5152	1729720	1976-08-14	1976-08-23	1	2426
37070	2521	1729720	1961-01-04	1961-01-13	1	-3275
29200	1977	1361711	1963-12-26	1963-12-26	1	-2198
47157	3200	1729720	2001-01-21	2001-02-03	1	11356
23383	1586	920293	1966-06-19	1966-06-26	1	-1285
33389	2267	1112807	1969-08-24	1969-09-07	1	-116
75532	5170	1125315	1980-03-20	1980-04-10	1	3752
40441	2750	1115008	2001-03-29	2001-04-12	1	11424
36649	2495	1515774	2005-07-31	2006-07-26	1	13355
34423	2333	1119510	1997-10-03	1997-10-10	1	10144
36411	2477	1112807	1956-03-23	1956-04-06	1	-5018
22970	1558	19078219	1962-06-14	1962-06-14	1	-2758
30439	2060	1119510	2008-06-29	2008-07-13	1	14073
55979	3813	1119510	1995-08-06	1995-08-13	1	9355
11670	800	1125315	1973-06-21	1973-06-28	1	1274
75895	5196	1124300	1993-04-09	1993-04-09	1	8499
17755	1226	738818	1995-09-18	1995-09-25	1	9398
70986	4848	933724	2003-09-29	2003-10-06	1	12331
30265	2046	1125315	1951-02-15	1951-02-22	1	-6888
14492	994	1118084	1998-10-30	1998-10-30	1	10529
77716	5312	1119510	1998-12-04	1998-12-18	1	10578
13755	940	1125315	2001-11-29	2001-11-29	1	11655
47223	3207	1713332	1965-10-03	1965-10-17	1	-1537
38387	2610	1112807	1969-05-18	1969-07-17	1	-168
75308	5152	738818	2002-01-17	2002-01-31	1	11718
37071	2521	1759842	1971-02-18	1971-03-11	1	434
29201	1977	1539403	1991-01-31	1991-01-31	1	7700
47158	3200	1112807	1948-04-13	1948-04-27	1	-7919
23384	1586	933724	1966-06-19	1966-06-26	1	-1285
33390	2267	1112807	1971-10-08	1971-10-22	1	659
75533	5170	1125315	1990-03-26	1990-04-16	1	7410
40442	2750	1361711	2007-09-26	2007-09-26	1	13782
36650	2495	1521369	1996-09-16	1997-09-11	1	10115
34424	2333	1322184	2007-04-03	2007-04-03	1	13606
36412	2477	1112807	1969-10-02	1969-10-30	1	-63
24151	1632	723013	1962-07-20	1962-11-01	1	-2618
30440	2060	1125315	2008-06-29	2008-07-13	1	14073
55980	3813	1125315	2012-10-01	2012-10-15	1	15628
11671	800	1177480	1984-02-22	1984-03-28	1	5200
75896	5196	1125315	1958-12-26	1959-01-02	1	-4017
17756	1226	1118084	2013-08-21	2013-08-21	1	15938
70987	4848	1119510	1960-01-08	1960-01-15	1	-3639
30266	2046	1125315	2005-06-18	2005-07-02	1	12966
14493	994	1125315	2002-06-16	2002-06-30	1	11868
77717	5312	1125315	1961-05-04	1961-05-11	1	-3157
13756	940	1545958	2001-11-29	2001-11-29	1	11655
47224	3207	1717327	1962-10-12	1962-10-26	1	-2624
38388	2610	1125315	1960-05-21	1960-06-04	1	-3498
75309	5152	1118084	2012-05-13	2012-05-13	1	15473
47557	3229	1115008	2014-11-22	2014-12-13	1	16417
29202	1977	1759842	1973-09-07	1973-09-28	1	1366
47159	3200	1759842	1970-12-23	1971-01-06	1	370
23385	1586	1125315	1966-05-14	1966-05-21	1	-1321
33391	2267	1112807	1990-09-08	1990-10-13	1	7590
75534	5170	1738521	1973-09-02	1973-09-16	1	1354
40443	2750	1759842	1989-01-13	1989-02-03	1	6973
36651	2495	1549786	1994-09-27	1995-09-22	1	9395
34425	2333	1326303	1990-04-17	1990-04-17	1	7411
36413	2477	1125315	1957-06-17	1957-07-01	1	-4567
24152	1632	1112807	1989-11-27	1989-12-18	1	7291
30441	2060	1521369	1981-11-09	1983-10-30	2	5050
55981	3813	1177480	1982-09-11	1982-12-10	1	4726
11672	800	1177480	2010-02-08	2010-03-01	1	14669
75897	5196	1125315	2017-01-10	2017-01-24	1	17190
17757	1226	1125315	1995-09-18	1995-09-25	1	9398
70988	4848	1125315	1975-04-27	1975-05-11	1	1956
30267	2046	1177480	2003-08-13	2003-08-27	1	12291
14494	994	1717327	1962-08-05	1962-08-19	1	-2692
77718	5312	1125315	1961-12-09	1961-12-16	1	-2938
13757	940	1112807	1944-09-16	1944-09-30	1	-9224
47225	3207	1728416	1963-08-12	1963-08-26	1	-2320
38389	2610	1112807	1964-04-13	1964-05-14	1	-2058
75310	5152	1125315	2002-01-17	2002-01-31	1	11718
47558	3229	1125315	2003-12-29	2004-01-19	1	12436
29203	1977	1125315	1926-11-07	1926-11-21	1	-15747
47160	3200	1118084	1985-01-29	1985-01-29	1	5507
23386	1586	1125315	1972-07-10	1972-07-24	1	935
33392	2267	1119510	1983-10-21	1983-10-28	1	5048
75535	5170	1759842	2010-01-13	2010-02-03	1	14643
40444	2750	757627	2008-03-05	2008-03-05	1	13943
36652	2495	1589505	2004-08-05	2005-07-31	1	12995
34426	2333	1741122	1978-05-19	1978-05-19	1	3060
36414	2477	1125315	1982-02-24	1982-03-31	1	4472
24153	1632	1713332	2003-05-22	2003-06-05	1	12208
30442	2060	1713332	1996-05-18	1996-06-01	1	9648
55982	3813	1177480	1994-11-07	1994-11-28	1	9097
11673	800	1717327	1970-06-11	1970-06-25	1	175
75898	5196	1713332	1952-07-07	1952-07-14	1	-6380
18996	1305	1124300	2000-10-18	2000-10-18	1	11248
70989	4848	1177480	1988-10-24	1988-11-07	1	6885
30268	2046	1332418	2004-02-24	2004-02-24	1	12472
15496	1076	1515774	1989-04-27	1990-04-22	1	7416
77719	5312	1759842	1944-07-07	1944-07-14	1	-9302
13758	940	1125315	1965-07-16	1965-07-23	1	-1623
48717	3313	1102527	1997-06-23	1997-06-23	1	10035
38390	2610	1125315	2011-11-20	2011-12-04	1	15312
75311	5152	1125315	2013-06-19	2013-06-26	1	15882
47559	3229	1713332	1984-03-13	1984-03-27	1	5199
29204	1977	1125315	1957-08-07	1957-08-14	1	-4523
47161	3200	1125315	1983-09-04	1983-09-11	1	5001
23387	1586	1125315	1997-02-26	1997-03-05	1	9925
33393	2267	1521369	1983-11-19	1984-11-13	1	5430
75536	5170	1112807	1971-10-13	1971-11-03	1	671
40445	2750	1119510	1956-01-05	1956-01-12	1	-5103
36653	2495	19127890	2001-08-21	2002-08-16	1	11915
34427	2333	1746114	1978-05-19	1978-05-19	1	3060
36415	2477	1125315	1998-04-06	1998-04-13	1	10329
24154	1632	1112807	1955-04-23	1955-05-08	1	-5352
30443	2060	1713332	2008-07-05	2008-07-19	1	14079
55983	3813	19127890	1986-09-30	1987-09-25	1	6476
13922	954	1124300	2015-12-15	2015-12-15	1	16784
75899	5196	1112807	1956-02-08	1956-02-22	1	-5062
18997	1305	1125315	1969-06-14	1969-06-28	1	-187
70990	4848	1713332	2014-11-23	2014-11-30	1	16404
30269	2046	1361711	2004-02-24	2014-04-01	1	16161
15497	1076	1515774	1994-04-01	1996-03-21	2	9576
77720	5312	1112807	1942-09-10	1942-10-01	1	-9954
13759	940	1174888	2001-11-29	2001-11-29	1	11655
48718	3313	1112807	1960-07-23	1960-08-22	1	-3419
38391	2610	1728416	1960-06-20	1960-07-04	1	-3468
75312	5152	1729720	1973-01-22	1973-01-31	1	1126
47560	3229	1729720	1991-04-10	1991-04-23	1	7782
29205	1977	1125315	1963-12-20	1963-12-27	1	-2197
47162	3200	1713332	1970-12-23	1971-01-06	1	370
23388	1586	1557272	1999-10-17	1999-10-17	1	10881
33394	2267	1521369	1985-11-08	1986-11-03	1	6150
75537	5170	1125315	1983-04-02	1983-07-01	1	4929
40446	2750	1125315	1935-03-18	1935-03-25	1	-12701
36654	2495	19127890	2005-07-31	2006-07-26	1	13355
34428	2333	1759842	1938-06-16	1938-06-23	1	-11515
36416	2477	920293	2001-03-23	2001-03-30	1	11411
24155	1632	1118084	1993-01-22	1993-01-22	1	8422
30444	2060	1759842	1996-05-18	1996-06-01	1	9648
55984	3813	1503184	1986-09-30	1987-09-25	1	6476
13923	954	1125315	1978-12-21	1978-12-28	1	3283
75900	5196	1125315	1995-05-16	1995-05-23	1	9273
18998	1305	1729720	1966-03-02	1966-03-09	1	-1394
70991	4848	1729720	1963-11-30	1963-12-10	1	-2214
30270	2046	1713332	1973-06-13	1973-06-27	1	1273
15498	1076	1521369	1988-05-02	1989-04-27	1	7056
77721	5312	1112807	1943-05-22	1943-06-05	1	-9707
13760	940	1322184	1997-12-25	2001-11-29	1	11655
48719	3313	1112807	1976-08-28	1976-09-11	1	2445
38392	2610	19127890	1975-06-12	1976-06-06	1	2348
75313	5152	1125315	2015-07-03	2015-07-24	1	16640
47561	3229	1125315	1984-03-13	1984-03-27	1	5199
29206	1977	1310149	2012-05-31	2012-05-31	1	15491
47163	3200	1728416	1948-04-13	1948-04-27	1	-7919
23389	1586	1713332	1961-09-13	1961-09-27	1	-3018
33395	2267	1713332	1980-12-20	1980-12-27	1	4013
75538	5170	1503184	1985-12-08	1986-12-03	1	6180
40447	2750	1125315	1983-01-21	1983-02-04	1	4782
36655	2495	1119510	1985-05-08	1985-05-22	1	5620
34429	2333	1759842	1971-09-21	1971-10-12	1	649
36417	2477	1125315	1974-01-05	1974-01-12	1	1472
24156	1632	1729720	1962-07-26	1962-08-05	1	-2706
30445	2060	1759842	2008-07-05	2008-07-19	1	14079
55985	3813	738818	1995-08-06	1995-08-13	1	9355
13924	954	1125315	1981-09-21	1981-10-05	1	4295
75901	5196	1125315	2002-09-12	2002-09-19	1	11949
18999	1305	1717327	1964-12-06	1964-12-20	1	-1838
70992	4848	1759842	2014-11-23	2014-11-30	1	16404
30271	2046	1729720	1991-04-27	1991-05-05	1	7794
15499	1076	1713332	2003-01-02	2003-01-23	1	12075
77722	5312	1125315	1998-12-04	1998-12-18	1	10578
13761	940	1332418	1994-12-08	1994-12-08	1	9107
48720	3313	1119510	1971-10-17	1971-10-24	1	661
40997	2782	1112807	1921-08-10	1921-08-24	1	-17662
75314	5152	1125315	1987-12-31	1988-02-04	1	6608
47562	3229	1713332	1994-05-04	1994-05-18	1	8903
29207	1977	1332418	1994-02-17	1994-02-17	1	8813
49400	3365	1115008	2005-08-11	2005-08-25	1	13020
23390	1586	1728416	1953-04-27	1953-05-11	1	-6079
33396	2267	1738521	1971-10-08	1971-10-22	1	659
75539	5170	1521369	1985-12-08	1986-12-03	1	6180
40448	2750	1322184	2007-09-26	2007-09-26	1	13782
36656	2495	1125315	1990-09-28	1990-10-12	1	7589
34430	2333	738818	1941-12-17	1941-12-31	1	-10228
36418	2477	1503184	1977-01-12	1978-01-07	1	2928
24157	1632	1729720	1966-02-18	1966-02-27	1	-1404
30446	2060	1125315	1964-02-04	1964-02-18	1	-2144
55986	3813	1118084	2006-07-12	2006-07-12	1	13341
13925	954	1177480	1979-11-03	1979-11-17	1	3607
75902	5196	1729720	1952-10-27	1952-11-06	1	-6265
19000	1305	1738521	1967-01-07	1967-01-21	1	-1076
70993	4848	738818	1960-01-08	1960-01-15	1	-3639
30272	2046	1759842	1940-07-31	1940-08-07	1	-10739
15500	1076	1759842	2003-01-02	2003-01-23	1	12075
77723	5312	1149380	1977-01-03	1977-01-03	1	2559
13762	940	1539403	1992-11-26	1992-11-26	1	8365
48721	3313	1125315	1978-03-31	1978-04-07	1	3018
40998	2782	1112807	1936-08-21	1936-09-18	1	-12158
76116	5206	1118084	2017-10-26	2017-10-26	1	17465
47563	3229	1118084	2019-04-14	2019-04-14	1	18000
29208	1977	1713332	1973-09-07	1973-09-28	1	1366
49401	3365	1115008	2017-02-14	2017-03-07	1	17232
23391	1586	1759842	1947-11-04	1947-11-18	1	-8080
36052	2450	1112807	1952-07-27	1952-08-10	1	-6353
75540	5170	1521369	1987-11-28	1989-11-17	2	7260
40449	2750	1332418	2007-09-26	2007-09-26	1	13782
36657	2495	1177480	1992-09-27	1992-10-11	1	8319
34431	2333	920293	1962-06-17	1962-07-01	2	-2741
36419	2477	1728416	1956-03-23	1956-04-06	1	-5018
24158	1632	1112807	1976-10-09	1976-11-05	1	2500
30447	2060	1125315	2004-08-10	2004-08-17	1	12647
55987	3813	1125315	1995-08-06	1995-08-13	1	9355
13926	954	1177480	1983-01-25	1983-02-15	1	4793
75903	5196	1759842	1952-07-07	1952-07-14	1	-6380
19001	1305	1112807	1964-12-06	1964-12-20	1	-1838
70994	4848	1125315	1960-01-08	1960-01-15	1	-3639
30273	2046	738818	1961-04-01	1961-04-08	1	-3190
15501	1076	19127890	1997-03-16	2000-02-29	3	11016
77724	5312	1729720	1995-01-14	1995-01-22	1	9152
13763	940	1713332	1982-07-16	1982-07-30	1	4593
48722	3313	1125315	1994-03-15	1994-03-22	1	8846
40999	2782	1125315	1952-02-01	1952-02-08	1	-6537
76117	5206	1125315	1980-07-27	1980-08-10	1	3874
47564	3229	1759842	1994-05-04	1994-05-18	1	8903
29209	1977	1729720	1988-05-20	1988-05-30	1	6724
49402	3365	1125315	2001-05-06	2001-05-13	1	11455
23655	1604	738818	1997-02-27	1997-03-13	1	9933
36053	2450	1125315	1984-05-18	1984-06-01	1	5265
75541	5170	1125315	1991-03-12	1991-04-02	1	7761
40450	2750	1539403	2007-09-26	2007-09-26	1	13782
36658	2495	1521369	2000-08-26	2002-08-16	2	11915
34432	2333	920293	1962-08-24	1962-08-31	1	-2680
36420	2477	1729720	2015-01-30	2015-02-09	1	16475
24159	1632	1119510	1958-05-18	1958-06-01	1	-4232
30448	2060	1503184	1981-11-09	1983-10-30	2	5050
55988	3813	1521369	1986-09-30	1987-09-25	1	6476
13927	954	1177480	2007-04-08	2007-04-29	1	13632
78107	5334	738818	1988-11-06	1988-11-13	1	6891
19002	1305	1112807	1967-01-07	1967-01-21	1	-1076
70995	4848	1125315	2003-10-25	2003-11-01	1	12357
30274	2046	1112807	1942-10-11	1942-10-25	1	-9930
15502	1076	1125315	1976-04-10	1976-04-17	1	2298
77725	5312	738818	1998-12-04	1998-12-18	1	10578
13764	940	1759842	1968-04-20	1968-04-27	1	-614
48723	3313	1713332	1997-06-23	1997-07-14	1	10056
41000	2782	1125315	1956-06-03	1956-06-17	1	-4946
76118	5206	1125315	1986-05-11	1986-06-01	1	5995
48631	3307	1729720	1995-05-03	1995-05-15	1	9265
29210	1977	1112807	1938-03-15	1938-04-19	1	-11580
49403	3365	1125315	1968-03-28	1968-05-02	1	-609
23656	1604	1112807	1957-10-25	1957-11-08	1	-4437
36054	2450	1728416	1952-07-27	1952-08-10	1	-6353
75542	5170	1125315	2015-12-23	2016-01-06	1	16806
40451	2750	1729720	1928-12-03	1928-12-14	1	-14993
36659	2495	1521369	2003-08-11	2004-08-05	1	12635
34433	2333	920293	1967-10-07	1967-10-14	1	-810
36421	2477	1118084	1998-06-06	1998-06-06	1	10383
24160	1632	1125315	2004-01-07	2004-01-21	1	12438
30449	2060	1717327	1968-06-10	1968-06-24	1	-556
57253	3904	738818	2009-06-09	2009-06-16	1	14411
13928	954	1125315	1974-05-14	1974-05-28	1	1608
78108	5334	1713332	1983-09-21	1983-10-05	1	5025
19003	1305	1125315	1967-05-25	1967-06-15	1	-931
70996	4848	1125315	2017-03-10	2017-04-14	1	17270
30275	2046	1112807	1952-09-18	1952-10-09	1	-6293
15503	1076	1177480	1981-12-25	1982-02-23	1	4436
77726	5312	738818	2005-04-24	2005-05-01	1	12904
13765	940	1125315	1950-04-18	1950-05-02	1	-7184
48724	3313	1728416	1956-03-16	1956-03-30	1	-5025
41001	2782	1125315	1987-06-20	1987-07-04	1	6393
76119	5206	1759842	1985-09-03	1985-09-10	1	5731
48632	3307	1759842	1968-01-17	1968-01-24	1	-708
29211	1977	1125315	1984-12-18	1985-01-01	1	5479
49404	3365	1729720	1973-11-01	1973-11-14	1	1413
23657	1604	1112807	1959-09-28	1959-10-26	1	-3720
36055	2450	1125315	1994-05-22	1994-05-29	1	8914
75543	5170	1713332	1988-09-26	1988-10-10	1	6857
40452	2750	1729720	1973-09-25	1973-10-03	1	1371
36660	2495	1729720	2013-04-05	2013-04-14	1	15809
34434	2333	933724	1962-06-17	1962-07-01	1	-2741
36422	2477	1192710	1957-03-19	1957-03-19	1	-4671
24161	1632	1309944	1988-11-13	1988-11-14	1	6892
30450	2060	738818	1998-12-19	1999-01-02	1	10593
57254	3904	1119510	2009-06-09	2009-06-16	1	14411
13929	954	1729720	1978-03-06	1978-03-14	1	2994
78109	5334	1713332	2007-04-05	2007-04-19	1	13622
19004	1305	1125315	1976-05-02	1976-05-16	1	2327
71725	4899	1112807	1922-10-19	1922-11-02	1	-17227
30276	2046	1125315	1961-04-01	1961-04-08	1	-3190
15504	1076	1503184	1988-05-02	1989-04-27	1	7056
77727	5312	1112807	1971-08-30	1971-09-13	1	620
13766	940	1125315	1956-05-30	1956-08-28	2	-4874
48725	3313	1125315	1958-08-05	1958-08-12	1	-4160
41002	2782	1307863	1981-02-18	1981-02-18	1	4066
76120	5206	1125315	1993-06-14	1993-06-28	1	8579
48633	3307	920293	2009-11-03	2009-11-10	1	14558
29212	1977	1125315	1990-11-12	1990-12-03	1	7641
49405	3365	738818	2012-08-14	2012-08-21	1	15573
23658	1604	1119510	1990-06-18	1990-07-02	1	7487
36056	2450	1729720	1985-11-29	1985-12-12	1	5824
75544	5170	1759842	1988-09-26	1988-10-10	1	6857
40453	2750	1729720	2000-09-10	2000-09-19	1	11219
36661	2495	738818	1985-05-08	1985-05-22	1	5620
34435	2333	933724	1962-08-24	1962-08-31	1	-2680
36423	2477	19127890	1977-01-12	1978-01-07	1	2928
24162	1632	1713332	1993-12-07	1993-12-21	1	8755
30451	2060	920293	1996-12-27	1997-01-03	1	9864
57255	3904	1125315	2009-06-09	2009-06-16	1	14411
13930	954	920293	1997-05-13	1997-05-20	1	10001
78110	5334	1759842	1984-06-26	1984-07-03	1	5297
20447	1391	1112807	1928-09-06	1928-10-04	1	-15064
71726	4899	1112807	1945-06-20	1945-07-04	1	-8947
30277	2046	1125315	2001-01-31	2001-02-07	1	11360
15505	1076	1515774	1997-03-16	2000-02-29	3	11016
77728	5312	1118084	1973-06-14	1973-06-14	1	1260
13767	940	1361711	1990-12-20	2001-11-29	1	11655
48726	3313	1728416	1956-12-25	1957-01-08	1	-4741
41003	2782	1347450	2002-03-06	2002-03-06	1	11752
76121	5206	1713332	1980-07-27	1980-08-10	1	3874
48634	3307	1125315	1982-03-17	1982-03-17	1	4458
29213	1977	1125315	2007-04-13	2007-04-27	1	13630
49406	3365	1118084	2006-01-23	2006-01-23	1	13171
23659	1604	1125315	1955-06-21	1955-07-05	1	-5294
36057	2450	1112807	1970-08-22	1970-09-26	1	268
75545	5170	19127890	1985-12-08	1986-12-03	1	6180
40454	2750	738818	1956-01-05	1956-01-12	1	-5103
36662	2495	1125315	1985-05-08	1985-05-22	1	5620
34436	2333	933724	1967-10-07	1967-10-14	1	-810
39489	2685	1125315	1943-02-25	1943-03-04	1	-9800
24163	1632	1713332	1999-07-29	1999-08-05	1	10808
30452	2060	933724	1996-12-27	1997-01-03	1	9864
57256	3904	1549786	1993-02-18	1994-02-13	1	8809
13931	954	1177480	1997-11-28	1997-12-26	1	10221
78111	5334	19127890	1980-02-05	1981-01-30	1	4047
20448	1391	1125315	1961-02-02	1961-02-16	1	-3241
71727	4899	1125315	1976-10-22	1976-10-22	1	2486
30278	2046	1174888	2014-04-01	2014-04-01	1	16161
15506	1076	1515774	2001-02-23	2002-02-18	1	11736
77729	5312	1119510	1961-05-04	1961-05-11	1	-3157
13768	940	1713332	1968-04-20	1968-04-27	1	-614
48727	3313	1728416	1957-07-28	1957-08-11	1	-4526
41004	2782	1557272	2000-03-22	2000-03-22	1	11038
76122	5206	1713332	1985-09-03	1985-09-10	1	5731
48635	3307	1112807	1972-09-15	1972-10-15	1	1018
29214	1977	1326303	2012-05-31	2012-05-31	1	15491
49407	3365	1125315	2012-08-14	2012-08-21	1	15573
23660	1604	1125315	1997-02-27	1997-03-13	1	9933
75546	5170	19127890	1987-11-28	1989-11-17	2	7260
40455	2750	914335	2011-05-25	2011-05-25	1	15119
36663	2495	1177480	1987-06-26	1987-08-25	1	6445
34437	2333	1115008	1999-10-16	1999-10-30	1	10894
39490	2685	1137529	1968-01-04	1968-01-04	1	-728
24164	1632	1728416	1955-04-23	1955-05-08	1	-5352
30453	2060	1125315	1969-07-15	1969-07-22	1	-163
57257	3904	1549786	1995-02-08	1996-02-03	1	9529
13932	954	1717327	1974-05-14	1974-05-28	1	1608
78112	5334	738818	2018-12-07	2018-12-21	1	17886
20449	1391	1713332	1930-09-27	1930-10-04	1	-14334
71728	4899	1729720	1924-11-19	1924-12-01	1	-16467
30279	2046	1322184	2004-02-24	2014-04-01	1	16161
15507	1076	1521369	1992-04-11	1993-04-06	1	8496
77730	5312	1119510	2005-04-24	2005-05-01	1	12904
14379	986	1119510	1968-03-23	1968-04-06	1	-635
48728	3313	1729720	1956-07-17	1956-07-25	1	-4908
41005	2782	1713332	1989-07-25	1989-08-15	1	7166
76123	5206	1729720	1981-12-21	1982-01-02	1	4384
48636	3307	1112807	1982-03-17	1982-04-16	1	4488
29215	1977	1713332	1966-04-20	1966-05-11	1	-1331
49408	3365	1119510	2012-08-14	2012-08-21	1	15573
23661	1604	1713332	1967-09-11	1967-10-02	1	-822
75547	5170	1115008	1997-08-28	1997-10-02	1	10136
40456	2750	1112807	1949-05-01	1949-05-15	1	-7536
36664	2495	1503184	2001-08-21	2002-08-16	1	11915
34438	2333	1118084	1957-04-13	1957-04-13	1	-4646
39491	2685	1713332	2012-05-07	2012-05-14	1	15474
24165	1632	1759842	1965-05-01	1965-05-22	1	-1685
30454	2060	1125315	1998-12-19	1999-01-02	1	10593
57258	3904	1713332	1999-07-16	1999-07-23	1	10795
13933	954	1728416	1976-03-12	1976-03-26	1	2276
78113	5334	1125315	1970-10-25	1970-11-08	1	311
20450	1391	1713332	1940-10-10	1940-11-28	1	-10626
71729	4899	1729720	1994-07-22	1994-08-04	1	8981
30280	2046	1539403	2004-02-24	2004-02-24	1	12472
15508	1076	1549786	1997-03-16	2000-02-29	3	11016
77731	5312	1125315	2005-04-24	2005-05-01	1	12904
14380	986	1119510	1971-09-24	1971-10-01	1	638
48729	3313	1729720	1958-02-18	1958-02-27	1	-4326
41006	2782	1729720	1956-01-04	1956-01-15	1	-5100
76124	5206	1112807	1982-08-16	1982-08-30	1	4624
48637	3307	1124300	2003-07-05	2003-07-05	1	12238
29576	1999	1115008	2013-04-22	2013-05-06	1	15831
51805	3529	1112807	1944-09-23	1944-10-07	1	-9217
23662	1604	1728416	1955-06-21	1955-07-05	1	-5294
75548	5170	1118084	2004-12-08	2004-12-08	1	12760
40457	2750	1125315	1956-01-05	1956-01-12	1	-5103
36665	2495	1549786	2005-07-31	2006-07-26	1	13355
34439	2333	1119510	1958-09-19	1958-09-26	1	-4115
39492	2685	1729720	1989-05-05	1989-05-17	1	7076
24166	1632	1759842	1993-12-07	1993-12-21	1	8755
30455	2060	1729720	1993-09-10	1993-09-20	1	8663
57259	3904	1759842	1999-07-16	1999-07-23	1	10795
13934	954	1768849	1979-11-03	1979-11-17	1	3607
78114	5334	1125315	1978-04-27	1978-05-11	1	3052
20451	1391	1713332	1980-10-09	1980-10-30	1	3955
71730	4899	738818	1947-09-10	1947-09-17	1	-8142
30281	2046	1713332	1940-07-31	1940-08-07	1	-10739
15509	1076	1549786	2001-02-23	2002-02-18	1	11736
77732	5312	1137529	1977-01-03	1977-01-03	1	2559
14381	986	738818	1971-09-24	1971-10-01	1	638
48730	3313	1112807	1956-03-16	1956-03-30	1	-5025
48205	3275	738818	1996-10-21	1996-11-04	1	9804
76125	5206	1125315	1980-11-25	1980-12-09	1	3995
48638	3307	1124957	1982-03-17	1982-03-17	1	4458
29577	1999	1125315	1981-03-08	1981-03-22	1	4098
51806	3529	1112807	1981-02-25	1981-03-25	1	4101
23663	1604	1728416	1958-12-08	1958-12-22	1	-4028
75549	5170	1125315	1973-09-02	1973-09-16	1	1354
40458	2750	1125315	1997-02-03	1997-02-17	1	9909
36666	2495	19127890	1994-09-27	1995-09-22	1	9395
34440	2333	1125315	1941-12-17	1941-12-31	1	-10228
39493	2685	1112807	1943-01-25	1943-02-08	1	-9824
24167	1632	1759842	1999-07-29	1999-08-05	1	10808
30456	2060	1118084	2009-09-08	2009-09-08	1	14495
57260	3904	1768849	1984-12-03	1984-12-17	1	5464
13935	954	1768849	1981-09-21	1981-10-05	1	4295
78115	5334	1125315	1988-02-01	1988-02-08	1	6612
20452	1391	920293	1960-01-30	1960-02-06	1	-3617
71731	4899	1112807	1972-10-10	1972-11-14	1	1048
30282	2046	1729720	1945-08-14	1945-08-27	1	-8893
15510	1076	1713332	2008-04-01	2008-04-15	1	13984
77733	5312	1729720	1961-07-13	1961-07-26	1	-3081
14382	986	1125315	1932-02-09	1932-02-16	1	-13834
48731	3313	1125315	1967-01-29	1967-02-12	1	-1054
48206	3275	738818	2002-06-01	2002-06-15	1	11853
76126	5206	1713332	1986-05-11	1986-06-01	1	5995
48639	3307	1125315	1975-08-31	1975-09-30	1	2098
29578	1999	1125315	1982-10-10	1982-10-24	1	4679
51807	3529	1118084	1976-07-07	1976-07-07	1	2379
23664	1604	1759842	1978-11-10	1978-11-17	1	3242
75550	5170	1125315	1981-02-11	1981-02-11	1	4059
40459	2750	1125315	2003-01-24	2003-01-31	1	12083
36667	2495	19127890	1996-09-16	1997-09-11	1	10115
34441	2333	1125315	1953-09-18	1953-09-25	1	-5942
39494	2685	1112807	1950-07-17	1950-08-07	1	-7087
24168	1632	738818	1958-05-18	1958-06-01	1	-4232
30457	2060	1729720	1964-11-02	1964-11-14	1	-1874
57261	3904	738818	1995-05-05	1995-05-12	1	9262
13936	954	19127890	1990-03-31	1991-03-26	1	7754
78116	5334	1125315	1988-11-06	1988-11-13	1	6891
20453	1391	933724	1960-01-30	1960-02-06	1	-3617
71732	4899	1112807	1976-10-15	1976-12-21	1	2546
30283	2046	1729720	1948-02-17	1948-02-29	1	-7977
15511	1076	1729720	1981-05-31	1981-06-11	1	4179
23	2	1112807	1920-07-01	1920-07-15	1	-18067
14383	986	1125315	1971-09-24	1971-10-01	1	638
48732	3313	1177480	1997-06-23	1997-07-14	1	10056
48207	3275	920293	2003-06-17	2003-06-24	1	12227
76127	5206	1713332	2006-12-27	2007-01-17	1	13530
48640	3307	1125315	1981-01-30	1981-02-20	1	4068
29579	1999	1125315	1991-07-12	1991-08-11	1	7892
51808	3529	1174888	2017-05-15	2017-05-15	1	17301
23665	1604	1102527	1973-04-22	1973-04-22	1	1207
75551	5170	1177480	1981-02-04	1981-03-13	1	4089
40460	2750	1309944	2011-05-25	2011-05-25	1	15119
34442	2333	1125315	1990-03-20	1990-04-24	1	7418
39495	2685	1125315	1982-12-14	1982-12-28	1	4744
24169	1632	914335	1988-11-13	1988-11-14	1	6892
30458	2060	19127890	1981-11-09	1983-10-30	2	5050
57262	3904	1125315	1991-06-21	1991-06-28	1	7848
13937	954	933724	1997-05-13	1997-05-20	1	10001
78117	5334	1125315	2018-12-07	2018-12-21	1	17886
20454	1391	1112807	1927-09-24	1927-10-08	1	-15426
71733	4899	1125315	1947-09-10	1947-09-17	1	-8142
30284	2046	1759842	1973-06-13	1973-06-27	1	1273
15512	1076	1738521	1976-01-26	1976-02-09	1	2230
24	2	1112807	1924-01-12	1924-04-11	1	-16701
14384	986	1125315	1977-07-02	1977-07-09	1	2746
48733	3313	738818	1971-10-17	1971-10-24	1	661
48208	3275	1112807	1985-10-25	1985-11-08	1	5790
76128	5206	1729720	1999-06-23	1999-07-04	1	10776
48641	3307	1713332	1968-01-17	1968-01-24	1	-708
29580	1999	1149196	2011-10-05	2011-10-05	1	15252
51809	3529	1713332	1976-01-06	1976-01-13	1	2203
23666	1604	1112807	1958-12-08	1958-12-22	1	-4028
75552	5170	1503184	1987-11-28	1989-11-17	2	7260
40461	2750	1343916	2011-05-25	2011-05-25	1	15119
34443	2333	1125315	2001-07-21	2001-08-25	1	11559
39496	2685	1177480	1974-09-30	1974-10-14	1	1747
24170	1632	1112807	1954-03-08	1954-03-22	1	-5764
33450	2272	1515774	1993-11-27	1994-11-22	1	9091
57263	3904	1125315	1995-05-05	1995-05-12	1	9262
13938	954	1177480	1976-03-04	1976-03-26	1	2276
78118	5334	1177480	2008-08-24	2008-09-14	1	14136
20455	1391	1112807	1933-05-11	1933-06-01	1	-13363
71734	4899	1125315	1998-03-01	1998-03-15	1	10300
30285	2046	1759842	1996-04-19	1996-05-03	1	9619
15513	1076	19127890	2001-02-23	2002-02-18	1	11736
25	2	1118084	1956-12-04	1956-12-04	1	-4776
14385	986	1729720	1967-05-23	1967-06-04	1	-942
48734	3313	1112807	1956-12-25	1957-01-08	1	-4741
48209	3275	1118084	1992-02-21	1992-02-21	1	8086
76129	5206	1759842	2006-12-27	2007-01-17	1	13530
48642	3307	933724	2009-11-03	2009-11-10	1	14558
29581	1999	1343916	2011-10-05	2011-10-05	1	15252
51810	3529	1112807	1949-02-13	1949-05-14	1	-7537
23667	1604	1119510	1997-02-27	1997-03-13	1	9933
75553	5170	1713332	2010-01-13	2010-02-03	1	14643
40462	2750	1778162	2001-03-29	2001-04-12	1	11424
34444	2333	1310149	1990-04-17	1990-04-17	1	7411
39497	2685	1759842	2012-05-07	2012-05-14	1	15474
24171	1632	1125315	1958-05-18	1958-06-01	1	-4232
33451	2272	1549786	1993-11-27	1994-11-22	1	9091
57264	3904	1713332	1979-05-23	1979-06-06	1	3443
13939	954	1515774	1990-03-31	1991-03-26	1	7754
78119	5334	1717327	1964-10-16	1964-10-30	1	-1889
20456	1391	1115008	1999-04-14	1999-04-28	1	10709
71735	4899	1137529	1969-02-25	1969-02-25	1	-310
30790	2084	738818	2002-02-18	2002-02-25	1	11743
15514	1076	1125315	1974-05-07	1974-05-14	1	1594
26	2	1125315	1931-09-03	1931-09-17	1	-13986
14386	986	1112807	1918-10-18	1918-11-01	1	-18689
48735	3313	1112807	1957-07-28	1957-08-11	1	-4526
48210	3275	1125315	1993-04-02	1993-04-09	1	8499
77631	5306	1115008	2013-01-22	2013-02-19	1	15755
51234	3490	1112807	1951-02-13	1951-04-14	1	-6837
29582	1999	1115008	1996-11-12	1996-12-17	1	9847
51811	3529	1112807	1951-03-05	1951-05-04	1	-6817
23668	1604	1149380	1999-06-17	1999-06-17	1	10759
40463	2750	1112807	1926-10-29	1927-01-27	1	-15680
34445	2333	1347450	2007-04-03	2007-04-03	1	13606
39498	2685	1112807	1966-07-01	1966-07-15	1	-1266
24172	1632	1343916	1988-11-13	1988-11-14	1	6892
33452	2272	1549786	1999-10-27	2000-10-21	1	11251
57265	3904	1759842	2010-05-20	2010-05-27	1	14756
13940	954	1549786	1990-03-31	1991-03-26	1	7754
78120	5334	1717327	1966-10-19	1966-11-02	1	-1156
20457	1391	1125315	1997-12-20	1998-03-20	1	10305
71736	4899	1713332	1931-05-28	1931-06-04	1	-14091
30791	2084	933724	2001-12-16	2001-12-23	1	11679
15515	1076	1125315	1976-01-26	1976-02-09	1	2230
27	2	1137529	1990-10-02	1990-10-02	1	7579
14387	986	1112807	1919-12-12	1920-01-02	1	-18262
48736	3313	1124300	1991-12-28	1991-12-28	1	8031
48211	3275	1125315	1996-10-21	1996-11-04	1	9804
77632	5306	1521369	1986-12-26	1987-12-21	1	6563
51235	3490	1112807	1956-01-23	1956-04-22	1	-5002
29583	1999	1124300	2017-02-05	2017-02-05	1	17202
51812	3529	1125315	2017-05-15	2017-08-13	2	17391
23669	1604	1713332	1978-11-10	1978-11-17	1	3242
40464	2750	1118084	1963-01-23	1963-01-23	1	-2535
34446	2333	1367571	1978-05-19	1978-05-19	1	3060
39499	2685	1118084	1981-01-05	1981-01-05	1	4022
24173	1632	1713332	1965-05-01	1965-05-22	1	-1685
33453	2272	1595799	1999-10-27	2000-10-21	1	11251
57266	3904	19127890	1993-02-18	1994-02-13	1	8809
13941	954	1729720	1994-04-14	1994-04-25	1	8880
78121	5334	1112807	1966-10-19	1966-11-02	1	-1156
20458	1391	1112807	1924-07-29	1924-08-12	1	-16578
71737	4899	1112807	1973-09-10	1973-10-01	1	1369
30792	2084	1125315	2002-02-18	2002-02-25	1	11743
15516	1076	1503184	1992-04-11	1993-04-06	1	8496
28	2	1307863	2007-09-04	2007-09-04	1	13760
14388	986	738818	1968-03-23	1968-04-06	1	-635
48737	3313	1125315	1971-10-17	1971-10-24	1	661
48212	3275	1125315	2002-06-01	2002-06-15	1	11853
77633	5306	1102527	2013-01-22	2013-01-22	1	15727
51236	3490	1119510	1978-05-02	1978-05-09	1	3050
29584	1999	1728416	1978-06-20	1978-07-04	1	3106
51813	3529	1125315	1993-04-11	1993-04-18	1	8508
23670	1604	1759842	1967-09-11	1967-10-02	1	-822
40465	2750	1177480	1980-07-31	1980-08-14	1	3878
34447	2333	19003953	1978-05-19	1978-05-19	1	3060
39500	2685	1125315	1952-10-13	1952-10-27	1	-6275
24174	1632	1728416	1954-03-08	1954-03-22	1	-5764
33454	2272	19127890	1998-11-01	1999-10-27	1	10891
57267	3904	933724	2005-03-29	2005-04-05	1	12878
14213	972	1125315	1967-01-27	1967-02-10	1	-1056
78122	5334	1118084	2001-01-30	2001-01-30	1	11352
20459	1391	1112807	1947-03-20	1947-04-17	1	-8295
71738	4899	1149380	1969-02-25	1969-02-25	1	-310
30793	2084	1728416	1967-02-16	1967-03-02	1	-1036
15517	1076	1549786	1994-04-01	1996-03-21	2	9576
29	2	1326303	2007-09-04	2007-09-04	1	13760
14389	986	1112807	1924-09-07	1924-10-05	1	-16524
48738	3313	1177480	2010-11-03	2010-11-17	1	14930
48213	3275	1503184	1976-03-26	1977-03-21	1	2636
77634	5306	1112807	1969-03-20	1969-04-03	1	-273
51237	3490	1125315	1990-04-23	1990-04-30	1	7424
29585	1999	1738521	1982-10-10	1982-10-24	1	4679
51814	3529	1557272	2004-08-04	2004-08-04	1	12634
23671	1604	1125315	2018-12-27	2019-01-26	1	17922
40466	2750	1713332	1989-01-13	1989-02-03	1	6973
35444	2411	1119510	2014-11-09	2014-11-16	1	16390
39501	2685	1125315	1967-12-17	1967-12-31	1	-732
24175	1632	1759842	2003-05-22	2003-06-05	1	12208
33455	2272	1125315	1982-09-16	1982-12-15	1	4731
57268	3904	1119510	1995-05-05	1995-05-12	1	9262
14214	972	1125315	2008-09-20	2008-10-04	1	14156
78123	5334	1119510	1988-11-06	1988-11-13	1	6891
20460	1391	1118084	1962-09-13	1962-09-13	1	-2667
71739	4899	1174888	1976-10-22	1976-10-22	1	2486
30794	2084	738818	1977-04-25	1977-05-09	1	2685
15518	1076	1118084	2013-08-19	2013-08-19	1	15936
30	2	1713332	1926-09-15	1926-10-06	1	-15793
14390	986	1118084	1951-11-04	1951-11-04	1	-6633
49346	3362	1713332	1971-12-23	1972-01-13	1	742
48214	3275	1503184	1979-03-11	1980-03-05	1	3716
77635	5306	1125315	1971-01-22	1971-02-05	1	400
51238	3490	1125315	1993-06-22	1993-07-06	1	8587
29586	1999	975125	2011-09-23	2011-09-23	1	15240
51815	3529	1112807	1947-04-11	1947-04-25	1	-8287
23672	1604	1137529	1999-06-17	1999-06-17	1	10759
40613	2760	1112807	1971-10-09	1971-11-06	1	674
35445	2411	1125315	1993-01-01	1993-02-05	2	8436
39502	2685	1125315	1992-04-12	1992-05-10	1	8165
24816	1676	1118084	2014-10-21	2014-10-21	1	16364
33456	2272	1125315	1996-09-02	1996-10-07	1	9776
57269	3904	1125315	1979-05-23	1979-06-06	1	3443
14215	972	1322184	2019-01-30	2019-01-30	1	17926
78124	5334	1125315	1967-12-01	1967-12-08	1	-755
20461	1391	1125315	1968-05-30	1968-06-13	1	-567
71740	4899	1729720	1934-10-07	1934-10-16	1	-12861
30795	2084	738818	1986-06-03	1986-06-17	1	6011
15519	1076	1125315	1980-10-01	1980-12-30	1	4016
31	2	1759842	1926-09-15	1926-10-06	1	-15793
14391	986	1125315	1934-05-27	1934-06-03	1	-12996
49347	3362	1759842	1967-04-18	1967-05-09	1	-968
48215	3275	1759842	1960-06-13	1960-07-04	1	-3468
77636	5306	1125315	1990-08-27	1990-09-24	1	7571
51239	3490	1154343	1947-09-21	1947-09-21	1	-8138
29587	1999	1729720	1990-03-22	1990-04-02	1	7396
51816	3529	1129625	1949-05-16	1949-05-16	1	-7535
23673	1604	1729720	1953-11-30	1953-12-09	1	-5867
40614	2760	1125315	1993-07-01	1993-07-08	1	8589
35446	2411	1125315	1967-07-01	1967-07-15	1	-901
39503	2685	1149380	1968-01-04	1968-01-04	1	-728
24817	1676	1125315	1999-06-02	1999-07-02	1	10774
33457	2272	1503184	1998-11-01	1999-10-27	1	10891
57270	3904	1125315	1984-12-03	1984-12-17	1	5464
14216	972	1347450	2019-01-30	2019-01-30	1	17926
78125	5334	1125315	1983-09-21	1983-10-05	1	5025
20462	1391	1125315	1980-11-19	1981-01-18	1	4035
71741	4899	920293	1951-06-18	1951-06-25	1	-6765
30796	2084	920293	2001-12-16	2001-12-23	1	11679
15520	1076	1549786	1989-04-27	1990-04-22	1	7416
32	2	1112807	1921-06-04	1921-06-18	1	-17729
14392	986	1125315	1965-06-18	1965-07-02	1	-1644
49348	3362	1112807	1986-12-11	1986-12-25	1	6202
48216	3275	19127890	1979-03-11	1980-03-05	1	3716
77637	5306	1125315	1997-06-19	1997-07-10	1	10052
51240	3490	1115008	2017-03-17	2017-03-31	1	17256
29588	1999	1177480	1978-06-20	1978-07-04	1	3106
51817	3529	1713332	2012-03-25	2012-04-08	1	15438
23674	1604	738818	1990-06-18	1990-07-02	1	7487
40615	2760	1521369	1978-02-20	1979-02-15	1	3332
35447	2411	1125315	1999-10-02	1999-10-23	1	10887
39779	2705	1112807	1965-09-27	1965-10-25	1	-1529
24818	1676	1759842	1985-04-21	1985-05-05	1	5603
33458	2272	1503184	2001-10-16	2002-10-11	1	11971
57271	3904	1125315	2006-01-01	2006-01-22	1	13170
14217	972	1521369	1983-05-13	1984-05-07	1	5240
78126	5334	1521369	1980-02-05	1981-01-30	1	4047
20463	1391	1713332	1931-12-03	1931-12-10	1	-13902
71742	4899	933724	1951-06-18	1951-06-25	1	-6765
30797	2084	1125315	1967-02-16	1967-03-02	1	-1036
15521	1076	1759842	2008-04-01	2008-04-15	1	13984
33	2	1124957	1934-01-19	1934-01-19	1	-13131
14393	986	1125315	1968-03-23	1968-04-06	1	-635
49349	3362	1124300	1996-05-31	1996-05-31	1	9647
48217	3275	933724	2003-06-17	2003-06-24	1	12227
77638	5306	1125315	2003-08-08	2003-09-12	1	12307
51241	3490	1119510	1980-09-24	1980-10-01	1	3926
30563	2069	1125315	1955-05-03	1955-06-02	1	-5327
51818	3529	1759842	1976-01-06	1976-01-13	1	2203
23675	1604	1112807	1973-04-15	1973-05-22	1	1237
40616	2760	1713332	1967-12-13	1968-01-03	1	-729
35448	2411	738818	2014-11-09	2014-11-16	1	16390
39780	2705	1125315	1966-09-20	1966-10-25	1	-1164
24819	1676	1759842	1999-01-20	1999-04-07	1	10688
33459	2272	1729720	2010-06-20	2010-07-02	1	14792
57272	3904	1515774	1995-02-08	1996-02-03	1	9529
14218	972	1738521	1968-07-03	1968-07-17	1	-533
78127	5334	1713332	1984-06-26	1984-07-03	1	5297
20464	1391	1729720	1936-02-09	1936-02-18	1	-12371
71743	4899	1112807	1924-07-24	1924-08-07	1	-16583
30798	2084	1125315	1976-08-27	1976-09-10	1	2444
15522	1076	19127890	1988-05-02	1990-04-22	2	7416
34	2	1125315	1990-04-14	1990-07-13	1	7498
14394	986	1729720	1926-11-20	1926-11-29	1	-15739
49350	3362	1125315	2004-11-08	2004-11-22	1	12744
48218	3275	1119510	2002-06-01	2002-06-15	1	11853
77639	5306	1503184	1986-12-26	1987-12-21	1	6563
51242	3490	1125315	1961-06-23	1961-07-07	1	-3100
30564	2069	1125315	1963-06-22	1963-07-06	1	-2371
51819	3529	1759842	2012-03-25	2012-04-08	1	15438
23676	1604	1118084	1991-02-07	1991-02-07	1	7707
40617	2760	1713332	1974-01-23	1974-02-13	1	1504
35449	2411	1112807	1965-05-28	1965-06-11	1	-1665
39781	2705	1125315	1980-12-16	1980-12-23	1	4009
24820	1676	1713332	1990-02-17	1990-03-03	1	7366
33460	2272	1729720	2013-11-17	2013-11-27	1	16036
57273	3904	1515774	1997-01-28	1998-01-23	1	10249
14219	972	1112807	1971-04-25	1971-05-09	1	493
78128	5334	1729720	1965-10-12	1965-10-25	1	-1529
20465	1391	1729720	1951-09-14	1951-09-27	1	-6671
71744	4899	1119510	1947-09-10	1947-09-17	1	-8142
30799	2084	1125315	1977-04-25	1977-05-09	1	2685
15523	1076	19127890	1992-04-11	1993-04-06	1	8496
35	2	1177480	1977-04-08	1977-04-22	1	2668
14941	1036	738818	1995-07-26	1995-08-02	1	9344
49351	3362	1713332	1967-04-18	1967-05-09	1	-968
48219	3275	19127890	1976-03-26	1977-03-21	1	2636
77640	5306	1503184	1989-12-10	1990-12-05	1	7643
51243	3490	1125315	1978-05-02	1978-05-09	1	3050
30565	2069	1125315	1997-01-28	1997-02-11	1	9903
52953	3609	1125315	1982-10-18	1982-11-08	1	4694
23677	1604	1125315	1977-04-01	1977-05-06	1	2682
40618	2760	1713332	1985-09-04	1985-09-11	1	5732
35450	2411	1125315	2014-11-09	2014-11-16	1	16390
39782	2705	1307863	2010-12-11	2010-12-11	1	14954
24821	1676	1759842	1990-02-17	1990-03-03	1	7366
33461	2272	19127890	1993-11-27	1994-11-22	1	9091
57274	3904	1549786	1997-01-28	1998-01-23	1	10249
14220	972	1124957	2016-01-11	2016-01-11	1	16811
78129	5334	1729720	1976-10-01	1976-10-11	1	2475
20466	1391	1759842	1931-12-03	1931-12-10	1	-13902
71745	4899	1124300	1964-05-01	1964-05-01	1	-2071
30800	2084	1125315	1979-06-27	1979-07-18	1	3485
15524	1076	19127890	1994-04-01	1996-03-21	2	9576
36	2	715997	2000-07-25	2000-07-25	1	11163
14942	1036	1118084	2011-05-13	2011-05-13	1	15107
49352	3362	1729720	1979-05-23	1979-06-02	1	3439
48220	3275	933724	1997-05-01	1997-05-08	1	9989
77641	5306	1521369	1989-12-10	1990-12-05	1	7643
51244	3490	1759842	1983-03-27	1983-04-03	1	4840
30566	2069	1713332	1955-03-24	1955-04-07	1	-5383
52954	3609	1125315	1990-03-06	1990-03-27	1	7390
23678	1604	1125315	1990-06-18	1990-07-02	1	7487
40619	2760	1759842	1998-10-25	1998-11-15	1	10545
35451	2411	1174888	1993-01-01	1993-01-01	1	8401
39783	2705	1124300	1978-03-13	1978-03-13	1	2993
24822	1676	1125315	1983-01-28	1983-02-11	1	4789
33462	2272	1125315	1994-09-14	1994-09-21	1	9029
57275	3904	1713332	2010-05-20	2010-05-27	1	14756
14221	972	1125315	1974-01-20	1974-04-20	1	1570
78130	5334	1759842	2007-04-05	2007-04-19	1	13622
20467	1391	1759842	1940-10-10	1940-11-28	1	-10626
71746	4899	1759842	1931-05-28	1931-06-04	1	-14091
30801	2084	1125315	1986-06-03	1986-06-17	1	6011
20859	1425	1112807	1939-10-20	1939-11-03	1	-11017
37	2	715997	2002-10-13	2002-10-13	1	11973
14943	1036	1119510	1981-12-03	1981-12-10	1	4361
49353	3362	1759842	1971-12-23	1972-01-13	1	742
48221	3275	1112807	1973-09-28	1973-11-27	1	1426
77642	5306	1717327	1971-01-22	1971-02-05	1	400
51245	3490	1759842	2002-07-28	2002-08-18	1	11917
30567	2069	1729720	1959-02-24	1959-03-09	1	-3951
52955	3609	1177480	1983-09-04	1983-09-25	1	5015
25953	1758	1118084	2002-09-28	2002-09-28	1	11958
40620	2760	1102527	1970-07-16	1970-07-16	1	196
35452	2411	1717327	1967-07-01	1967-07-15	1	-901
39784	2705	1125315	1969-07-09	1969-07-16	1	-169
24823	1676	1713332	1985-04-21	1985-05-05	1	5603
33463	2272	1500211	1994-11-22	1995-11-17	1	9451
57276	3904	1729720	1986-04-17	1986-04-27	1	5960
14222	972	1549786	1989-04-11	1990-04-06	1	7400
78131	5334	1119510	2018-12-07	2018-12-21	1	17886
20468	1391	1125315	1954-01-25	1954-02-01	1	-5813
72423	4949	1515774	1990-08-28	1991-08-23	1	7904
30802	2084	1717327	1967-10-20	1967-11-03	1	-790
20860	1425	1119510	1996-04-17	1996-04-24	1	9610
38	2	1112807	1952-07-13	1952-07-27	1	-6367
14944	1036	1125315	1995-07-26	1995-08-02	1	9344
49354	3362	1125315	1981-09-10	1981-10-08	1	4298
48222	3275	1521369	1976-03-26	1977-03-21	1	2636
77643	5306	1729720	1983-12-03	1983-12-14	1	5095
51246	3490	738818	1978-05-02	1978-05-09	1	3050
30568	2069	1729720	1965-09-18	1965-09-30	1	-1554
52956	3609	1778162	1986-07-11	1986-07-25	1	6049
25954	1758	1125315	2013-01-22	2013-02-05	1	15741
40621	2760	1125315	1972-10-07	1972-10-21	1	1024
35453	2411	1118084	2001-05-14	2001-05-14	1	11456
39785	2705	1713332	1974-03-13	1974-04-03	1	1553
24824	1676	1713332	1999-01-20	1999-04-07	1	10688
33464	2272	1729720	2001-03-14	2001-03-26	1	11407
57277	3904	920293	2005-03-29	2005-04-05	1	12878
14223	972	1713332	2014-09-15	2014-10-06	1	16349
78132	5334	1125315	1964-10-16	1964-10-30	1	-1889
20469	1391	1729720	1937-10-14	1937-10-24	1	-11757
72424	4949	1515774	1992-08-17	1993-08-12	1	8624
30803	2084	920293	1995-11-03	1995-11-10	1	9444
20861	1425	1713332	1995-12-09	1995-12-30	1	9494
39	2	1112807	1974-03-04	1974-03-25	1	1544
14945	1036	1125315	2006-10-12	2006-11-11	1	13463
49355	3362	1125315	2010-12-10	2011-01-07	1	14981
48223	3275	1713332	1960-06-13	1960-07-04	1	-3468
77644	5306	1738521	1969-09-24	1969-10-08	1	-85
51247	3490	1112807	1954-11-24	1954-12-29	1	-5482
30569	2069	1125315	2011-04-30	2011-06-04	1	15129
52957	3609	1125315	2017-06-24	2017-07-15	1	17362
25955	1758	1177480	2000-01-11	2000-02-15	1	11002
40622	2760	1503184	1978-02-20	1979-02-15	1	3332
35454	2411	1778162	1993-01-01	1993-02-05	1	8436
39786	2705	1115008	2012-03-27	2012-04-24	1	15454
26434	1786	1112807	1947-12-03	1947-12-17	1	-8051
33465	2272	19127890	2001-10-16	2002-10-11	1	11971
57278	3904	1118084	2015-01-04	2015-01-04	1	16439
14224	972	1759842	2014-09-15	2014-10-06	1	16349
78133	5334	1125315	1986-06-23	1986-07-21	1	6045
20470	1391	1738521	1968-05-30	1968-06-13	1	-567
72425	4949	1521369	1987-09-13	1989-09-02	2	7184
30804	2084	920293	2002-02-17	2002-02-24	1	11742
20862	1425	1112807	1938-06-13	1938-06-27	1	-11511
40	2	1125315	1980-07-27	1980-08-10	1	3874
14946	1036	1729720	1975-09-07	1975-09-20	1	2088
49356	3362	1729720	1965-06-26	1965-07-04	1	-1642
48224	3275	920293	1997-05-01	1997-05-08	1	9989
77645	5306	1124300	2013-01-23	2013-01-23	1	15728
51248	3490	1115008	2012-06-27	2012-07-11	1	15532
30570	2069	1728416	1952-06-17	1952-07-01	1	-6393
52958	3609	1177480	1992-01-16	1992-02-06	1	8071
25956	1758	1503184	1976-08-05	1977-07-31	1	2768
40623	2760	1729720	1971-10-30	1971-11-07	1	675
35896	2439	1112807	1973-08-24	1973-09-07	1	1345
39787	2705	1125315	2017-08-19	2017-08-26	1	17404
26435	1786	1125315	1970-11-02	1971-01-01	1	365
33466	2272	1118084	2015-12-12	2015-12-12	1	16781
57279	3904	1515774	1993-02-18	1994-02-13	1	8809
14225	972	1125315	2016-01-11	2016-01-11	1	16811
78134	5334	1503184	1980-02-05	1981-01-30	1	4047
20471	1391	1759842	1930-09-27	1930-10-04	1	-14334
72426	4949	19127890	1995-08-02	1996-07-27	1	9704
30805	2084	933724	1995-11-03	1995-11-10	1	9444
20863	1425	1112807	1947-08-09	1947-08-23	1	-8167
41	2	1125315	1994-06-05	1994-06-19	1	8935
14947	1036	19127890	1984-08-27	1985-08-22	1	5712
49357	3362	1115008	1994-04-17	1994-05-08	1	8893
48225	3275	1119510	1996-10-21	1996-11-04	1	9804
77646	5306	1125315	1969-09-24	1969-10-08	1	-85
51249	3490	1125315	1950-03-22	1950-04-19	1	-7197
30571	2069	1112807	1952-06-17	1952-07-01	1	-6393
52959	3609	1125315	1977-02-16	1977-03-02	1	2617
25957	1758	920293	2008-09-04	2008-09-11	1	14133
40624	2760	1759842	1967-12-13	1968-01-03	1	-729
35897	2439	1119510	1978-03-19	1978-03-26	1	3006
39788	2705	1310149	2010-12-11	2010-12-11	1	14954
26436	1786	1713332	1964-08-07	1964-08-21	1	-1959
33467	2272	1125315	1987-11-19	1988-02-17	1	6621
57280	3904	19127890	1995-02-08	1996-02-03	1	9529
14226	972	1729720	1987-08-11	1987-08-21	1	6441
78135	5334	1729720	2008-11-25	2008-12-07	1	14220
20472	1391	1759842	1980-10-09	1980-10-30	1	3955
72427	4949	1112807	1972-12-20	1973-01-03	1	1098
30806	2084	1119510	1986-06-03	1986-06-17	1	6011
20864	1425	1119510	1946-08-01	1946-08-15	1	-8540
42	2	1125315	1996-04-10	1996-04-24	1	9610
14948	1036	1112807	1970-11-29	1970-12-13	1	346
49358	3362	1125315	1960-04-05	1960-05-03	1	-3530
48226	3275	1125315	1973-10-30	1973-11-06	1	1405
77647	5306	1728416	1973-05-17	1973-05-31	1	1246
51250	3490	1149380	1947-09-21	1947-09-21	1	-8138
30572	2069	1118084	1988-09-01	1988-09-01	1	6818
52960	3609	1125315	1986-07-11	1986-07-25	1	6049
25958	1758	933724	2008-09-04	2008-09-11	1	14133
40625	2760	1759842	1974-01-23	1974-02-13	1	1504
35898	2439	1125315	1975-05-02	1975-06-06	1	1982
39789	2705	1759842	1974-03-13	1974-04-03	1	1553
26437	1786	738818	1965-06-02	1965-06-16	1	-1660
33468	2272	1521369	1998-11-01	2000-10-21	2	11251
57281	3904	19127890	1997-01-28	1998-01-23	1	10249
14227	972	1729720	1999-07-04	1999-07-13	1	10785
836	57	1119510	1992-02-19	1992-02-26	1	8091
20722	1411	1112807	1972-04-27	1972-07-26	1	937
72428	4949	1112807	1973-08-28	1973-09-11	1	1349
30807	2084	1119510	2002-02-18	2002-02-25	1	11743
20865	1425	1119510	1961-10-23	1961-11-06	1	-2978
43	2	1125315	1996-10-01	1996-10-08	1	9777
14949	1036	1112807	1972-01-08	1972-01-22	1	751
49359	3362	1125315	1966-09-02	1966-09-09	1	-1210
48227	3275	1521369	1979-03-11	1980-03-05	1	3716
77648	5306	19127890	1986-12-26	1987-12-21	1	6563
51251	3490	1729720	1950-04-22	1950-05-02	1	-7184
30573	2069	1125315	1967-02-28	1967-03-21	1	-1017
52961	3609	1125315	1992-03-01	1992-03-08	1	8102
25959	1758	1125315	1988-06-07	1988-07-12	1	6767
40626	2760	933724	1998-04-18	1998-04-25	1	10341
35899	2439	1125315	1981-02-04	1981-03-11	1	4087
39790	2705	1115008	2013-03-20	2013-04-03	1	15798
26438	1786	1118084	1984-12-08	1984-12-08	1	5455
33469	2272	1521369	2001-10-16	2004-09-30	3	12691
61622	4206	738818	1973-01-29	1973-02-12	1	1138
14228	972	1738521	1967-01-27	1967-02-10	1	-1056
837	57	1125315	2013-02-24	2013-03-10	1	15774
20723	1411	1118084	2002-11-11	2002-11-11	1	12002
72429	4949	1759842	1997-06-15	1997-06-29	1	10041
30808	2084	1125315	1967-10-20	1967-11-03	1	-790
20866	1425	1177480	1987-09-29	1987-10-27	1	6508
44	2	920293	1952-06-24	1952-07-08	2	-6386
14950	1036	1154343	1971-09-12	1971-09-12	1	619
49360	3362	1125315	2013-11-22	2013-12-13	1	16052
49188	3352	1119510	1998-03-31	1998-04-14	1	10330
77649	5306	1125315	1973-05-17	1973-05-31	1	1246
51252	3490	1759842	1978-08-04	1978-08-11	1	3144
30574	2069	1125315	1977-12-26	1978-01-02	1	2923
52962	3609	1118084	2018-08-05	2018-08-05	1	17748
25960	1758	1521369	1976-08-05	1977-07-31	1	2768
40627	2760	1112807	1959-11-13	1959-11-27	1	-3688
35900	2439	1125315	1993-10-04	1993-10-18	1	8691
39791	2705	1125315	2011-11-24	2011-12-08	1	15316
26439	1786	1125315	1959-03-05	1959-06-03	1	-3865
35027	2373	1125315	1959-12-29	1960-02-02	1	-3621
61623	4206	738818	1980-09-16	1980-09-23	1	3918
14229	972	1738521	1971-04-25	1971-05-09	1	493
838	57	705944	1973-06-16	1979-06-25	1	3462
20724	1411	1125315	1966-09-26	1966-10-10	1	-1179
72430	4949	19127890	1990-08-28	1991-08-23	1	7904
30809	2084	1125315	1997-04-29	1997-05-06	1	9987
20867	1425	1713332	2018-04-09	2018-04-23	1	17644
45	2	933724	1952-06-24	1952-07-08	1	-6386
14951	1036	1177480	1978-12-17	1979-01-16	1	3302
49361	3362	1729720	1984-01-17	1984-01-25	1	5137
49189	3352	1125315	1981-02-10	1981-03-12	1	4088
77650	5306	1308738	1989-01-14	1989-01-14	1	6953
51253	3490	738818	1980-09-24	1980-10-01	1	3926
30575	2069	1729720	1959-04-09	1959-04-18	1	-3911
52963	3609	1729720	2008-07-26	2008-08-03	1	14094
25961	1758	1759842	2016-03-18	2016-04-08	1	16899
40628	2760	1112807	1961-01-06	1961-02-03	1	-3254
35901	2439	1125315	2008-05-18	2008-06-01	1	14031
39792	2705	1177480	1998-03-08	1998-03-22	1	10307
26440	1786	1125315	1965-06-02	1965-06-16	1	-1660
35028	2373	1728416	1956-09-15	1956-09-29	1	-4842
61624	4206	1124300	1984-06-12	1984-06-12	1	5276
14230	972	19127890	1989-04-11	1990-04-06	1	7400
839	57	1112807	1982-12-31	1983-01-21	1	4768
20725	1411	1728416	1966-09-26	1966-10-10	1	-1179
72431	4949	19127890	1992-08-17	1993-08-12	1	8624
30810	2084	1125315	2003-10-19	2003-10-26	1	12351
20868	1425	1759842	2018-04-09	2018-04-23	1	17644
46	2	1112807	1934-01-19	1934-03-20	1	-13071
14952	1036	738818	1981-12-03	1981-12-10	1	4361
53023	3614	738818	1992-07-05	1992-07-12	1	8228
49190	3352	1177480	1975-06-28	1975-07-12	1	2018
77651	5306	1713332	2013-01-22	2013-02-19	1	15755
51254	3490	1124300	1987-06-21	1987-06-21	1	6380
30576	2069	1759842	1955-03-24	1955-04-07	1	-5383
52964	3609	1738521	1977-02-16	1977-03-02	1	2617
25962	1758	1125315	1973-02-12	1973-02-26	1	1152
40629	2760	1112807	1961-12-23	1962-01-06	1	-2917
35902	2439	1125315	2018-12-06	2019-01-10	1	17906
39793	2705	1326303	2010-12-11	2010-12-11	1	14954
26441	1786	1125315	1986-07-11	1986-07-11	1	6035
35029	2373	1759842	1979-07-02	1979-07-23	1	3490
61625	4206	1125315	1973-01-29	1973-02-12	1	1138
14231	972	1112807	1968-07-03	1968-07-17	1	-533
840	57	1119510	1982-01-01	1982-01-08	1	4390
20726	1411	19059528	1999-11-23	1999-11-23	1	10918
72432	4949	1115008	1994-10-26	1994-11-16	1	9085
30811	2084	1125315	2015-10-25	2015-11-01	1	16740
20869	1425	738818	1946-08-01	1946-08-15	1	-8540
47	2	1125315	1934-01-19	1934-01-19	1	-13131
14953	1036	1125315	1981-12-03	1981-12-10	1	4361
53024	3614	1112807	1967-12-19	1968-01-23	1	-709
49191	3352	1503184	1982-09-29	1983-09-24	1	5014
77652	5306	1729720	1995-04-29	1995-05-11	1	9261
51255	3490	1125315	1969-10-30	1969-11-13	1	-49
31703	2147	1112807	1955-06-14	1955-07-19	1	-5280
54293	3695	738818	1987-03-31	1987-04-14	1	6312
25963	1758	1125315	2004-02-01	2004-02-08	1	12456
40630	2760	1713332	1966-02-24	1966-03-17	1	-1386
35903	2439	1177480	1989-10-25	1989-11-08	1	7251
39794	2705	1778162	1998-03-08	1998-03-22	1	10307
26442	1786	1728416	1947-12-03	1947-12-17	1	-8051
35030	2373	1759842	2003-10-14	2003-11-04	1	12360
61626	4206	1149380	1985-09-16	1985-09-16	1	5737
14232	972	1118084	2002-06-12	2002-06-12	1	11850
841	57	1125315	1986-07-31	1986-08-14	1	6069
20727	1411	753626	1999-11-23	1999-11-23	1	10918
72433	4949	1118084	2013-02-28	2013-02-28	1	15764
30812	2084	1713332	1981-08-23	1981-09-06	1	4266
20870	1425	738818	1961-10-23	1961-11-06	1	-2978
48	2	1125315	1955-10-22	1955-10-29	1	-5178
14954	1036	1125315	1983-10-22	1983-10-22	1	5042
53025	3614	1125315	1992-07-05	1992-07-12	1	8228
49192	3352	19127890	1979-10-15	1980-10-09	1	3934
77653	5306	1738521	1969-03-20	1969-04-03	1	-273
51256	3490	1125315	1980-09-24	1980-10-01	1	3926
31704	2147	1124300	1989-03-06	1989-03-06	1	7004
54294	3695	1110410	1996-03-20	1996-03-20	1	9575
25964	1758	1713332	2016-03-18	2016-04-08	1	16899
40631	2760	1713332	1998-10-25	1998-11-15	1	10545
35904	2439	1728416	1976-02-11	1976-02-25	1	2246
42314	2868	738818	2009-05-31	2009-06-07	1	14402
26443	1786	1759842	1964-08-07	1964-08-21	1	-1959
35031	2373	1124300	1997-10-25	1997-10-25	1	10159
61627	4206	1119510	1961-03-07	1961-03-21	1	-3208
14233	972	1503184	1983-05-13	1984-05-07	1	5240
842	57	1125315	1992-02-19	1992-02-26	1	8091
20728	1411	1110410	1999-11-23	1999-11-23	1	10918
72434	4949	1549786	1990-08-28	1991-08-23	1	7904
30813	2084	1729720	1992-12-07	1992-12-15	1	8384
20871	1425	1102527	1954-06-24	1954-06-24	1	-5670
49	2	1149380	1990-10-02	1990-10-02	1	7579
14955	1036	1129625	1974-09-25	1974-09-25	1	1728
53026	3614	1125315	2008-03-30	2008-04-13	1	13982
49193	3352	1125315	1976-09-20	1976-10-04	1	2468
77654	5306	19127890	1989-12-10	1990-12-05	1	7643
51257	3490	1557272	2005-11-11	2005-11-11	1	13098
31705	2147	1125315	1984-12-24	1985-01-07	1	5485
54295	3695	1125315	1982-12-07	1982-12-21	1	4737
25965	1758	1728416	1962-11-07	1962-11-21	1	-2598
40632	2760	1729720	1963-05-29	1963-06-11	1	-2396
35905	2439	738818	1993-10-04	1993-10-18	1	8691
42315	2868	1119510	2009-05-31	2009-06-07	1	14402
26444	1786	1759842	1982-04-07	1982-04-21	1	4493
35032	2373	1125315	1973-02-23	1973-03-09	1	1163
61628	4206	1137529	1985-09-16	1985-09-16	1	5737
14234	972	1515774	1989-04-11	1990-04-06	1	7400
843	57	1713332	2005-07-27	2005-08-17	1	13012
20729	1411	1112807	1968-07-30	1968-08-13	1	-506
72435	4949	1549786	1992-08-17	1993-08-12	1	8624
30814	2084	1759842	1971-09-17	1971-10-08	1	645
20872	1425	1125315	1946-08-01	1946-08-15	1	-8540
50	2	1177480	1993-03-29	1993-05-28	1	8548
14956	1036	1174888	1983-10-22	1983-10-22	1	5042
53027	3614	1149380	2004-07-25	2004-07-25	1	12624
49194	3352	1137529	2001-12-21	2001-12-21	1	11677
51258	3490	1713332	1978-08-04	1978-08-11	1	3144
31706	2147	1309944	2005-03-25	2005-03-25	1	12867
54296	3695	1125315	1987-03-31	1987-04-14	1	6312
25966	1758	19127890	1976-08-05	1977-07-31	1	2768
40633	2760	1759842	1963-07-04	1963-07-18	1	-2359
35906	2439	1717327	1973-05-12	1973-05-26	1	1241
42316	2868	1125315	1967-10-20	1967-11-03	1	-790
26445	1786	1119510	1965-06-02	1965-06-16	1	-1660
35033	2373	1713332	1978-08-10	1978-08-31	1	3164
61629	4206	738818	1961-03-07	1961-03-21	1	-3208
14235	972	1729720	2012-03-07	2012-03-20	1	15419
844	57	1729720	1976-10-29	1976-11-08	1	2503
20730	1411	1746114	1999-11-23	1999-11-23	1	10918
72436	4949	1549786	1995-08-02	1996-07-27	1	9704
30815	2084	1759842	1981-08-23	1981-09-06	1	4266
20873	1425	1125315	1954-06-17	1954-08-23	1	-5610
51	2	1310149	2007-09-04	2007-09-04	1	13760
14957	1036	1521369	1984-08-27	1985-08-22	1	5712
53028	3614	1177480	1974-06-25	1974-07-09	1	1650
49195	3352	1521369	1982-09-29	1983-09-24	1	5014
51259	3490	1713332	1983-03-27	1983-04-03	1	4840
31707	2147	1343916	2005-03-25	2005-03-25	1	12867
54297	3695	1125315	1996-03-21	1996-03-21	1	9576
25967	1758	1112807	1962-11-07	1962-11-21	1	-2598
40634	2760	1759842	1978-01-30	1978-02-20	1	2972
35907	2439	738818	1978-03-19	1978-03-26	1	3006
42317	2868	1125315	1970-03-02	1970-03-16	1	74
26446	1786	1124957	1986-07-11	1986-07-11	1	6035
35034	2373	1125315	1961-04-08	1961-04-22	1	-3176
61630	4206	1102527	1993-04-14	1993-04-14	1	8504
14236	972	19127890	1983-05-13	1984-05-07	1	5240
845	57	738818	1992-02-19	1992-02-26	1	8091
20731	1411	19002770	1999-11-23	1999-11-23	1	10918
72437	4949	1713332	1991-10-19	1991-11-09	1	7982
30816	2084	933724	2002-02-17	2002-02-24	1	11742
20874	1425	1125315	1961-10-23	1961-11-06	1	-2978
1746	116	715997	2001-10-29	2001-10-29	1	11624
14958	1036	1738521	1972-01-08	1972-01-22	1	751
53029	3614	1308738	2009-06-11	2009-06-11	1	14406
49196	3352	1729720	1966-11-22	1966-12-04	1	-1124
51260	3490	1713332	2002-07-28	2002-08-18	1	11917
31708	2147	738818	1988-01-23	1988-02-06	1	6610
54298	3695	1192710	1981-06-13	1981-06-13	1	4181
25968	1758	1729720	1974-11-02	1974-11-13	1	1777
40635	2760	1759842	1985-09-04	1985-09-11	1	5732
35908	2439	933724	2006-06-04	2006-06-11	1	13310
42318	2868	1125315	2009-05-31	2009-06-07	1	14402
26447	1786	1125315	2007-11-05	2007-11-19	1	13836
35035	2373	1713332	1979-07-02	1979-07-23	1	3490
61631	4206	1119510	1973-01-29	1973-02-12	1	1138
16389	1132	738818	1972-08-23	1972-08-30	1	972
846	57	1112807	1971-02-27	1971-03-13	1	436
20732	1411	19003953	1999-11-23	1999-11-23	1	10918
72438	4949	1717327	1977-11-08	1977-11-22	1	2882
30817	2084	1112807	1984-03-23	1984-04-06	1	5209
20875	1425	738818	1996-04-17	1996-04-24	1	9610
1747	116	1125315	1980-01-25	1980-02-01	1	3683
14959	1036	1115008	2000-06-24	2000-07-15	1	11153
53030	3614	1713332	1953-02-26	1953-03-12	1	-6139
49197	3352	1729720	1972-09-22	1972-10-04	1	1007
51988	3540	1125315	1976-09-14	1976-11-13	1	2508
31709	2147	914335	2005-03-25	2005-03-25	1	12867
54299	3695	1309944	2007-02-12	2007-02-12	1	13556
28250	1915	738818	1987-06-06	1987-06-13	1	6372
40636	2760	19127890	1978-02-20	1979-02-15	1	3332
35909	2439	1112807	1973-05-12	1973-05-26	1	1241
42319	2868	1125315	2016-02-10	2016-02-10	1	16841
26448	1786	1177480	1986-07-11	1986-10-09	1	6125
35036	2373	1713332	2003-10-14	2003-11-04	1	12360
61632	4206	1125315	1980-09-16	1980-09-23	1	3918
16390	1132	1112807	1968-09-19	1968-11-18	1	-409
847	57	1115008	2007-01-15	2007-01-29	1	13542
20733	1411	708298	1999-11-23	1999-11-23	1	10918
72439	4949	1738521	1973-08-28	1973-09-11	1	1349
30818	2084	1119510	1977-04-25	1977-05-09	1	2685
20876	1425	1112807	1937-01-19	1937-02-02	1	-12021
1748	116	1125315	2002-04-19	2002-05-03	1	11810
14960	1036	1119510	1995-07-26	1995-08-02	1	9344
53031	3614	1729720	1958-06-11	1958-06-20	1	-4213
49198	3352	1778162	1984-10-22	1984-11-12	1	5429
51989	3540	1125315	1984-05-06	1984-05-13	1	5246
31710	2147	1125315	1988-01-23	1988-02-06	1	6610
54300	3695	1343916	2007-02-12	2007-02-12	1	13556
28251	1915	1125315	1987-06-06	1987-06-13	1	6372
40637	2760	920293	1998-04-18	1998-04-25	1	10341
35910	2439	1124300	2014-08-25	2014-08-25	1	16307
42320	2868	1361711	2002-10-16	2016-02-10	1	16841
26449	1786	1177480	2014-04-06	2014-04-20	1	16180
35037	2373	1759842	1978-08-10	1978-08-31	1	3164
61633	4206	1729720	1955-06-08	1955-06-17	1	-5312
16391	1132	1118084	1993-09-11	1993-09-11	1	8654
848	57	1118084	1997-04-01	1997-04-01	1	9952
20734	1411	967823	1999-11-23	1999-11-23	1	10918
72440	4949	1759842	1991-10-19	1991-11-09	1	7982
30819	2084	1124300	1999-08-17	1999-08-17	1	10820
20877	1425	1118084	1977-01-04	1977-01-04	1	2560
1749	116	715997	2000-12-03	2000-12-03	1	11294
14961	1036	1125315	1998-03-20	1998-03-27	1	10312
53032	3614	1125315	1951-05-17	1951-08-15	1	-6714
49199	3352	1124300	2003-07-01	2003-07-01	1	12234
51990	3540	1729720	1982-05-10	1982-05-18	1	4520
31711	2147	1154343	1956-10-03	1956-10-03	1	-4838
54301	3695	1521369	1999-01-05	1999-12-31	1	10956
28252	1915	1713332	1991-12-22	1992-01-12	1	8046
40638	2760	1112807	1970-07-16	1970-10-14	1	286
35911	2439	1125315	1978-03-19	1978-03-26	1	3006
42321	2868	1728416	1967-05-12	1967-05-26	1	-951
26450	1786	1713332	1962-06-21	1962-07-12	1	-2730
35038	2373	1112807	1956-09-15	1956-09-29	1	-4842
61634	4206	1112807	1968-08-23	1968-09-20	1	-468
16392	1132	1125315	1972-08-23	1972-08-30	1	972
849	57	738818	1982-01-01	1982-01-08	1	4390
20735	1411	1367571	1999-11-23	1999-11-23	1	10918
72441	4949	19127890	1987-09-13	1989-09-02	2	7184
30820	2084	1713332	1971-09-17	1971-10-08	1	645
20878	1425	1125315	1996-04-17	1996-04-24	1	9610
1750	116	738818	1952-11-22	1952-12-06	1	-6235
14962	1036	1149380	1971-09-12	1971-09-12	1	619
53033	3614	1125315	1952-03-13	1952-03-20	1	-6496
49200	3352	1125315	1998-03-31	1998-04-14	1	10330
51991	3540	1112807	1974-07-27	1974-08-10	1	1682
31712	2147	1119510	1988-01-23	1988-02-06	1	6610
54302	3695	19016749	1996-03-20	1996-03-20	1	9575
28253	1915	1738521	1977-05-18	1977-06-01	1	2708
40639	2760	1118084	2001-05-31	2001-05-31	1	11473
35912	2439	1717327	1973-08-24	1973-09-07	1	1345
42322	2868	1729720	1968-02-12	1968-02-24	1	-677
26451	1786	1713332	1982-04-07	1982-04-21	1	4493
35039	2373	1112807	1957-10-10	1958-01-08	1	-4376
61635	4206	1119510	1980-09-16	1980-09-23	1	3918
16393	1132	1125315	1983-03-04	1983-03-18	1	4824
850	57	1125315	1982-01-01	1982-01-08	1	4390
20736	1411	1713332	1982-07-04	1982-07-25	1	4588
72442	4949	1125315	1977-11-08	1977-11-22	1	2882
31474	2130	1102527	1976-02-27	1976-02-27	1	2248
20879	1425	1729720	1945-11-04	1945-11-16	1	-8812
1751	116	1102527	1964-06-16	1964-06-16	1	-2025
14963	1036	1177480	1983-10-22	1984-01-20	1	5132
53034	3614	1713332	1993-07-02	1993-07-09	1	8590
49201	3352	1149380	2001-12-21	2001-12-21	1	11677
51992	3540	1115008	2019-06-13	2019-06-13	1	18060
31713	2147	1125315	1958-03-01	1958-03-08	1	-4317
54303	3695	708298	1996-03-20	1996-03-20	1	9575
28254	1915	1118084	2006-08-14	2006-08-14	1	13374
40640	2760	1713332	1963-07-04	1963-07-18	1	-2359
35913	2439	738818	2012-12-24	2013-01-07	1	15712
42323	2868	19127890	1978-09-26	1982-09-05	4	4630
26452	1786	1125315	2001-02-22	2001-03-15	1	11396
35040	2373	1125315	1956-09-16	1956-09-30	1	-4841
61636	4206	1125315	1959-01-15	1959-02-12	1	-3976
16394	1132	1728416	1957-04-13	1957-04-27	1	-4632
851	57	1125315	1982-07-09	1982-07-23	1	4586
20737	1411	1741122	1999-11-23	1999-11-23	1	10918
72443	4949	1503184	1987-09-13	1989-09-02	2	7184
31475	2130	1119510	1982-02-14	1982-02-28	1	4441
20880	1425	1759842	1995-12-09	1995-12-30	1	9494
1752	116	1112807	1929-05-08	1929-05-22	1	-14834
14964	1036	1503184	1984-08-27	1985-08-22	1	5712
53035	3614	1759842	1953-02-26	1953-03-12	1	-6139
49202	3352	1521369	1979-10-15	1980-10-09	1	3934
51993	3540	1118084	2013-07-07	2013-07-07	1	15893
31714	2147	1125315	1973-08-27	1973-09-10	1	1348
54304	3695	914335	2007-02-12	2007-02-12	1	13556
28255	1915	1125315	1984-05-13	1984-05-20	1	5253
40641	2760	1713332	1978-01-30	1978-02-20	1	2972
35914	2439	920293	2006-06-04	2006-06-11	1	13310
42324	2868	19127890	1983-08-31	1984-08-25	1	5350
26453	1786	1729720	1959-12-18	1959-12-26	1	-3659
35041	2373	1125315	1969-08-13	1969-09-12	1	-111
61637	4206	1125315	1961-03-07	1961-03-21	1	-3208
16395	1132	1768849	1983-03-04	1983-03-18	1	4824
852	57	1177480	1976-08-13	1976-09-03	1	2437
20738	1411	1759842	1982-07-04	1982-07-25	1	4588
72444	4949	1515774	1995-08-02	1996-07-27	1	9704
31476	2130	1125315	1968-02-04	1968-02-18	1	-683
22183	1511	933724	2006-05-28	2006-06-04	1	13303
1753	116	1112807	1944-10-08	1944-12-07	1	-9156
16631	1146	920293	1986-02-08	1986-02-15	1	5889
53036	3614	757627	2004-07-25	2004-07-25	1	12624
49203	3352	1738521	1976-09-20	1976-10-04	1	2468
51994	3540	1738521	1976-06-28	1976-07-12	1	2384
31715	2147	1125315	1987-05-02	1987-05-16	1	6344
54305	3695	1000560	1996-03-20	1996-03-20	2	9575
28256	1915	1125315	2005-12-06	2005-12-20	1	13137
40642	2760	1728416	1961-12-23	1962-01-06	1	-2917
35915	2439	1119510	1993-10-04	1993-10-18	1	8691
42325	2868	1112807	1967-05-12	1967-05-26	1	-951
26454	1786	1759842	1962-06-21	1962-07-12	1	-2730
35042	2373	1125315	1992-12-01	1992-12-15	1	8384
61921	4226	738818	1975-04-15	1975-04-22	1	1937
16396	1132	1112807	1957-04-13	1957-04-27	1	-4632
853	57	1759842	2005-07-27	2005-08-17	1	13012
20739	1411	1000560	1999-11-23	1999-11-23	2	10918
72445	4949	1713332	1997-06-15	1997-06-29	1	10041
31477	2130	1125315	2004-07-16	2004-07-23	1	12622
22184	1511	1112807	1968-08-07	1968-08-21	1	-498
1754	116	1124300	1970-02-14	1970-02-14	1	44
16632	1146	933724	1986-02-08	1986-02-15	1	5889
53037	3614	1125315	1952-11-07	1952-11-21	1	-6250
49204	3352	738818	1998-03-31	1998-04-14	1	10330
51995	3540	1125315	1988-02-14	1988-03-06	1	6639
31716	2147	1713332	2001-04-09	2001-04-23	1	11435
54306	3695	1124300	2013-11-17	2013-11-17	1	16026
28257	1915	1177480	2013-04-02	2013-04-16	1	15811
40643	2760	1759842	1966-02-24	1966-03-17	1	-1386
35916	2439	1119510	2012-12-24	2013-01-07	1	15712
42326	2868	1112807	1969-02-05	1969-04-06	1	-270
29074	1971	738818	1983-10-02	1983-10-16	1	5036
35043	2373	1125315	1996-06-12	1996-06-26	1	9673
61922	4226	738818	1995-12-09	1995-12-16	1	9480
16397	1132	1112807	1963-04-12	1963-06-18	1	-2389
1153	79	1177480	2016-08-26	2016-09-23	1	17067
20740	1411	1102527	1996-03-29	1996-03-29	1	9584
73848	5049	1112807	1993-08-16	1993-09-06	1	8649
31478	2130	1713332	1962-08-18	1962-08-25	1	-2686
22185	1511	1125315	1981-08-29	1981-09-19	1	4279
1755	116	1125315	1952-11-22	1952-12-06	1	-6235
16633	1146	1102527	2001-09-11	2001-09-11	1	11576
53038	3614	1125315	1953-12-01	1953-12-15	1	-5861
49205	3352	1124957	1984-10-22	1984-10-22	1	5408
51996	3540	1125315	1994-10-19	1994-11-02	1	9071
31717	2147	1759842	2001-04-09	2001-04-23	1	11435
54307	3695	1125315	2008-11-30	2008-12-14	1	14227
28258	1915	738818	2006-05-20	2006-06-03	1	13302
41942	2843	738818	1998-01-06	1998-01-13	1	10239
35917	2439	1125315	2012-12-24	2013-01-07	1	15712
42327	2868	1322184	2002-10-16	2016-02-10	1	16841
29075	1971	920293	1996-06-01	1996-06-08	1	9655
35044	2373	1125315	2017-07-16	2017-07-30	1	17377
61923	4226	1125315	1975-04-15	1975-04-22	1	1937
16398	1132	1125315	2010-04-24	2010-05-01	1	14730
1154	79	1713332	1981-11-23	1981-11-30	1	4351
20741	1411	1125315	1996-03-22	1996-04-28	1	9614
73849	5049	1118084	1998-12-08	1998-12-08	1	10568
31479	2130	738818	1982-02-14	1982-02-28	1	4441
22186	1511	1125315	2014-07-23	2014-07-30	1	16281
1756	116	1125315	1964-06-16	1964-09-14	1	-1935
16634	1146	1112807	1970-11-25	1971-01-24	1	388
53039	3614	1125315	1959-11-25	1959-12-02	1	-3683
49206	3352	1125315	1984-10-22	1984-11-12	2	5429
51997	3540	1177480	1976-06-28	1976-07-12	1	2384
31718	2147	1149380	1956-10-03	1956-10-03	1	-4838
54308	3695	1177480	2015-11-14	2015-12-05	1	16774
28259	1915	1112807	1977-05-18	1977-06-01	1	2708
41943	2843	1125315	1960-02-29	1960-03-07	1	-3587
35918	2439	1177480	1976-02-11	1976-02-25	1	2246
42328	2868	1332418	2002-10-16	2002-10-16	1	11976
29076	1971	1125315	1983-10-02	1983-10-16	1	5036
39838	2709	738818	2013-10-12	2013-10-26	1	16004
61924	4226	1125315	1983-03-09	1983-03-16	1	4822
16399	1132	1119510	1972-08-23	1972-08-30	1	972
1155	79	1728416	1947-10-17	1947-10-31	1	-8098
22401	1525	1118084	1998-10-11	1998-10-11	1	10510
73850	5049	1125315	1966-05-11	1966-05-25	1	-1317
31480	2130	1119510	1962-02-11	1962-02-25	1	-2867
22187	1511	19127890	1981-04-11	1983-04-01	2	4838
1757	116	1125315	1994-11-27	1994-12-11	1	9110
16635	1146	1112807	1971-11-20	1971-12-18	1	716
53040	3614	1137529	2004-07-25	2004-07-25	1	12624
49207	3352	1503184	1979-10-15	1980-10-09	1	3934
51998	3540	1125315	2005-02-05	2005-02-26	1	12840
31719	2147	1177480	2013-08-27	2013-09-10	1	15958
54309	3695	1367571	1996-03-20	1996-03-20	1	9575
28260	1915	1112807	1985-03-07	1985-03-21	1	5558
41944	2843	1125315	1990-12-31	1991-03-31	2	7759
37424	2545	715997	2000-09-14	2000-09-14	1	11214
42329	2868	1539403	2002-10-16	2002-10-16	1	11976
29077	1971	1125315	1984-04-08	1984-04-22	1	5225
39839	2709	1119510	2013-10-12	2013-10-26	1	16004
61925	4226	1124300	2002-11-28	2002-11-28	1	12019
16400	1132	1713332	1963-07-19	1963-08-09	1	-2337
1156	79	1728416	1949-08-25	1949-09-08	1	-7420
22402	1525	1125315	1966-09-28	1966-10-12	1	-1177
73851	5049	1125315	1996-04-28	1996-05-12	1	9628
31481	2130	1125315	1976-02-27	1976-04-27	1	2308
22188	1511	1125315	1974-11-04	1974-12-04	1	1798
1758	116	1713332	1943-10-30	1943-11-20	1	-9539
16636	1146	1118084	1998-04-25	1998-04-25	1	10341
53041	3614	1177480	1993-04-11	1993-05-16	1	8536
49208	3352	19127890	1982-09-29	1983-09-24	1	5014
51999	3540	1729720	1975-11-23	1975-12-04	1	2163
32346	2191	1759842	1972-09-13	1972-10-04	1	1007
54310	3695	1549786	1999-01-05	1999-12-31	1	10956
28261	1915	1119510	1987-06-06	1987-06-13	1	6372
41945	2843	1125315	2001-05-29	2001-08-03	2	11513
37425	2545	1713332	1984-02-10	1984-02-24	1	5167
42330	2868	19127890	1988-08-04	1989-07-30	1	7150
29078	1971	1551099	1979-11-17	1979-11-17	1	3607
39840	2709	1124957	2017-10-06	2017-10-06	1	17445
61926	4226	1125315	1965-08-04	1965-08-18	1	-1597
16401	1132	1713332	1976-09-05	1976-09-26	1	2460
1157	79	1759842	1958-09-27	1958-10-18	1	-4093
22403	1525	1503184	1985-06-16	1986-06-11	1	6005
73852	5049	1713332	1968-02-08	1968-02-15	1	-686
31482	2130	1125315	1982-02-14	1982-02-28	1	4441
22189	1511	1177480	2012-12-15	2013-02-13	1	15749
1759	116	1713332	1963-08-11	1963-08-18	1	-2328
16637	1146	1125315	1965-06-12	1965-07-03	1	-1643
53042	3614	1728416	1952-11-07	1952-11-21	1	-6250
50492	3438	1118084	1946-12-29	1946-12-29	1	-8404
52000	3540	1738521	1974-07-27	1974-08-10	1	1682
32347	2191	1759842	1979-11-29	1979-12-06	1	3626
54311	3695	1741122	1996-03-20	1996-03-20	1	9575
28262	1915	1125315	1991-07-09	1991-10-07	2	7949
41946	2843	1713332	2015-11-17	2015-12-01	1	16770
37426	2545	1759842	1984-02-10	1984-02-24	1	5167
42331	2868	1503184	1988-08-04	1989-07-30	1	7150
29079	1971	1738521	1972-04-27	1972-05-11	1	861
39841	2709	1125315	1984-03-03	1984-06-01	1	5265
61927	4226	1125315	1996-10-20	1996-11-10	1	9810
16402	1132	920293	1984-06-09	1984-06-16	1	5280
1158	79	1759842	1966-01-05	1966-01-26	1	-1436
22404	1525	19127890	1977-07-28	1979-07-18	2	3485
73853	5049	1713332	1970-09-09	1970-09-23	1	265
31483	2130	1125315	1994-05-13	1994-05-27	1	8912
22190	1511	1503184	1981-04-11	1983-04-01	2	4838
1760	116	1729720	1934-05-10	1934-05-23	1	-13007
16638	1146	1125315	2011-10-08	2011-10-15	1	15262
53043	3614	1728416	1953-12-01	1953-12-15	1	-5861
50493	3438	1119510	1927-01-03	1927-01-10	1	-15697
54358	3698	1119510	1989-05-05	1989-05-12	1	7071
32348	2191	1118084	2011-12-25	2011-12-25	1	15333
54312	3695	1115008	2010-04-09	2010-05-14	1	14743
28263	1915	1125315	2006-05-20	2006-06-03	1	13302
41947	2843	1759842	2015-11-17	2015-12-01	1	16770
37427	2545	1112807	1949-09-24	1949-10-08	1	-7390
42332	2868	1521369	1978-09-26	1982-09-05	4	4630
29080	1971	1738521	1973-01-15	1973-01-29	1	1124
39842	2709	1125315	2013-10-12	2013-10-26	1	16004
61928	4226	1149380	2006-01-01	2006-01-01	1	13149
16403	1132	933724	1984-06-09	1984-06-16	1	5280
1159	79	1759842	1981-11-23	1981-11-30	1	4351
22405	1525	1125315	1993-08-23	1993-11-21	2	8725
73854	5049	914335	1998-02-18	1998-02-18	1	10275
31484	2130	1177480	1980-06-05	1980-06-19	1	3822
22191	1511	1503184	1985-03-21	1986-03-16	1	5918
1761	116	1729720	1937-07-25	1937-08-01	1	-11841
16639	1146	1503184	1974-01-06	1975-01-01	1	1826
53044	3614	1738521	1974-06-25	1974-07-09	1	1650
50494	3438	1125315	1918-03-02	1918-03-16	1	-18919
54359	3698	1125315	2009-06-24	2009-07-08	1	14433
32349	2191	1713332	1979-11-29	1979-12-06	1	3626
54313	3695	1125315	1992-09-28	1992-10-19	1	8327
28264	1915	1177480	1989-06-28	1989-07-19	1	7139
41948	2843	1125315	1998-01-06	1998-01-13	1	10239
37428	2545	1125315	1959-11-12	1959-11-26	1	-3689
42333	2868	1521369	1983-08-31	1984-08-25	1	5350
29081	1971	1759842	2017-12-22	2018-01-12	1	17543
39843	2709	1125315	2019-03-15	2019-03-22	1	17977
61929	4226	1119510	1975-04-15	1975-04-22	1	1937
16404	1132	1125315	1998-03-10	1998-03-17	1	10302
1160	79	1149380	1949-05-02	1949-05-02	1	-7549
22406	1525	1174888	1993-08-23	1993-08-23	1	8635
73855	5049	1125315	1969-11-07	1969-11-21	1	-41
31485	2130	1713332	2001-03-29	2001-06-21	1	11494
22192	1511	1521369	1985-03-21	1986-03-16	1	5918
1762	116	1112807	1927-07-05	1927-07-19	1	-15507
16640	1146	1717327	1961-05-18	1961-06-01	1	-3136
53045	3614	1759842	1993-07-02	1993-07-09	1	8590
50495	3438	1125315	1944-01-03	1944-01-10	1	-9488
54360	3698	1728416	1952-10-26	1952-11-09	1	-6262
32350	2191	1125315	1981-04-23	1981-05-07	1	4144
54314	3695	1125315	2008-03-29	2008-04-19	1	13988
28265	1915	1713332	2005-12-06	2005-12-20	1	13137
41949	2843	1119510	1998-01-06	1998-01-13	1	10239
37429	2545	1112807	1947-09-14	1947-10-05	1	-8124
42334	2868	1717327	1966-06-21	1966-07-05	1	-1276
29082	1971	738818	1993-07-04	1993-07-11	1	8592
39844	2709	1713332	1947-05-07	1947-05-28	1	-8254
61930	4226	1119510	1995-12-09	1995-12-16	1	9480
16405	1132	1125315	2002-01-27	2002-02-03	1	11721
1161	79	1729720	1957-02-13	1957-02-21	1	-4697
22407	1525	1503184	1977-07-28	1979-07-18	2	3485
73856	5049	1177480	1999-07-07	1999-07-28	1	10800
31486	2130	1738521	1974-12-04	1974-12-18	1	1812
22193	1511	1125315	1966-01-22	1966-02-05	1	-1426
1763	116	1112807	1936-02-18	1936-03-24	1	-12336
16641	1146	1759842	1970-03-29	1970-04-12	1	101
53046	3614	701322	2006-04-16	2006-04-16	1	13254
50496	3438	1125315	1977-08-11	1977-08-18	1	2786
54361	3698	1729720	1966-09-03	1966-09-15	1	-1204
32351	2191	1713332	1972-09-13	1972-10-04	1	1007
54315	3695	1713332	1981-10-26	1981-11-09	1	4330
28266	1915	1759842	1991-12-22	1992-01-12	1	8046
41950	2843	1118084	2000-01-09	2000-01-09	1	10965
37430	2545	1112807	1948-06-10	1948-06-24	1	-7861
42335	2868	1738521	1967-10-20	1967-11-03	1	-790
29083	1971	920293	1993-04-08	1993-04-22	2	8512
39845	2709	1713332	2003-04-23	2003-05-07	1	12179
61931	4226	1125315	2017-10-21	2017-11-11	1	17481
16406	1132	1759842	1963-07-19	1963-08-09	1	-2337
1162	79	1112807	1967-07-05	1967-07-19	1	-897
22408	1525	1713332	2013-02-16	2013-03-09	1	15773
73857	5049	1309944	1998-02-18	1998-02-18	1	10275
31487	2130	1759842	1962-08-18	1962-08-25	1	-2686
22194	1511	1125315	2000-09-09	2000-10-14	1	11244
1764	116	1119510	1952-11-22	1952-12-06	1	-6235
16642	1146	1759842	2015-09-20	2015-10-04	1	16712
53047	3614	1119510	1992-07-05	1992-07-12	1	8228
50497	3438	1112807	1934-09-03	1934-10-03	1	-12874
54362	3698	1118084	1992-02-09	1992-02-09	1	8074
32352	2191	1729720	1985-02-07	1985-02-18	1	5527
54316	3695	1746114	1996-03-20	1996-03-20	1	9575
28267	1915	1119510	2006-05-20	2006-06-03	1	13302
41951	2843	1125315	1961-06-11	1961-06-18	1	-3119
37431	2545	1118084	1987-01-02	1987-01-02	1	6210
42336	2868	1124300	2003-10-15	2003-10-15	1	12340
29084	1971	933724	1993-04-08	1993-04-22	1	8512
39846	2709	1729720	2008-03-14	2008-03-21	1	13959
61932	4226	1137529	2006-01-01	2006-01-01	1	13149
16407	1132	1759842	1976-09-05	1976-09-26	1	2460
1163	79	1118084	1988-12-05	1988-12-05	1	6913
22409	1525	1717327	1965-12-18	1966-01-01	1	-1461
73858	5049	1322184	2002-07-31	2002-07-31	1	11899
31488	2130	738818	1962-02-11	1962-02-25	1	-2867
22195	1511	1125315	2007-01-28	2007-02-04	1	13548
1765	116	1125315	1938-03-10	1938-03-24	1	-11606
16643	1146	1521369	1974-01-06	1975-01-01	1	1826
53048	3614	1124300	1989-11-03	1989-11-03	1	7246
50498	3438	1112807	1965-10-20	1965-11-10	1	-1513
54363	3698	1119510	1996-03-16	1996-03-23	1	9578
33834	2297	1738521	1976-10-20	1976-11-03	1	2498
54317	3695	1778162	1985-05-29	1985-06-12	1	5641
28268	1915	1125315	2002-11-29	2002-12-06	1	12027
41952	2843	1125315	1962-07-17	1962-07-31	1	-2711
37432	2545	1125315	1977-06-29	1977-08-03	1	2771
42337	2868	1125315	1966-02-22	1966-03-01	1	-1402
29085	1971	933724	1996-06-01	1996-06-08	1	9655
39847	2709	1115008	2017-10-06	2017-12-05	1	17505
61933	4226	1728416	1967-07-16	1967-07-30	1	-886
19234	1317	1112807	1963-03-16	1963-04-06	1	-2462
1164	79	1125315	1987-07-25	1987-08-29	1	6449
22410	1525	19127890	1985-06-16	1986-06-11	1	6005
73859	5049	1343916	1998-02-18	1998-02-18	1	10275
31489	2130	1125315	1962-02-11	1962-02-25	1	-2867
22196	1511	1174888	2012-12-15	2012-12-15	1	15689
1766	116	1125315	1959-07-22	1959-08-12	1	-3795
16644	1146	1713332	1970-03-29	1970-04-12	1	101
53049	3614	1125315	1952-09-17	1952-10-01	1	-6301
50499	3438	1124957	1924-06-27	1924-06-27	1	-16624
54364	3698	1125315	1952-10-26	1952-11-11	2	-6260
33835	2297	1759842	1987-02-01	1987-02-22	1	6261
54318	3695	753626	1996-03-20	1996-03-20	1	9575
28269	1915	1125315	2018-09-13	2018-09-27	1	17801
41953	2843	1125315	1964-10-04	1964-10-18	1	-1901
37433	2545	1728416	1948-06-10	1948-06-24	1	-7861
42338	2868	1125315	1966-06-21	1966-07-05	1	-1276
29086	1971	1112807	1973-01-15	1973-01-29	1	1124
39848	2709	1119510	1943-12-17	1943-12-24	1	-9505
61934	4226	1112807	1967-07-16	1967-07-30	1	-886
19235	1317	1125315	1957-10-09	1957-10-16	1	-4460
1165	79	1713332	1996-06-05	1996-07-03	1	9680
22411	1525	1115008	2013-02-09	2013-02-23	1	15759
73860	5049	1125315	1970-07-18	1970-10-16	1	288
31490	2130	1125315	1987-04-14	1987-04-28	1	6326
22197	1511	1177480	2003-06-01	2003-07-06	1	12239
1767	116	1177480	2001-03-04	2001-03-25	1	11406
16645	1146	1728416	1959-12-11	1959-12-25	1	-3660
53050	3614	1125315	1990-10-06	1990-10-13	1	7590
50500	3438	1125315	1927-01-03	1927-01-10	1	-15697
54365	3698	1125315	1960-07-04	1960-07-11	1	-3461
33836	2297	19127890	1988-08-28	1989-08-23	1	7174
54319	3695	782043	1996-03-20	1996-03-20	1	9575
28270	1915	1174888	1991-07-09	1991-07-09	1	7859
41954	2843	1174888	1990-12-31	1990-12-31	1	7669
37434	2545	715997	2003-07-01	2003-07-01	1	12234
42339	2868	1174888	2016-02-10	2016-02-10	1	16841
29087	1971	1125315	1981-08-08	1981-08-22	1	4251
39849	2709	1713332	2013-03-20	2013-04-03	1	15798
61935	4226	1125315	1995-12-09	1995-12-16	1	9480
19236	1317	1137529	1997-07-11	1997-07-11	1	10053
1166	79	1759842	1996-06-05	1996-07-03	1	9680
22412	1525	1125315	1965-12-18	1966-01-01	1	-1461
73861	5049	1125315	1981-05-21	1981-06-04	1	4172
31491	2130	1713332	2004-02-23	2004-03-08	1	12485
22198	1511	1521369	1981-04-11	1983-04-01	2	4838
1768	116	1729720	2004-10-03	2004-10-14	1	12705
16646	1146	1729720	1967-04-15	1967-04-27	1	-980
57598	3927	1125315	1979-01-20	1979-02-24	1	3341
50501	3438	1713332	1988-09-14	1988-10-05	1	6852
54366	3698	1729720	1963-12-07	1963-12-17	1	-2207
33837	2297	1125315	1976-10-20	1976-11-03	1	2498
54320	3695	967823	1996-03-20	1996-03-21	1	9576
28271	1915	1177480	2001-12-13	2001-12-27	1	11683
41955	2843	1728416	1962-07-17	1962-07-31	1	-2711
37435	2545	1728416	1949-09-24	1949-10-08	1	-7390
42340	2868	1503184	1978-09-26	1982-09-05	4	4630
29088	1971	1125315	1993-07-04	1993-07-11	1	8592
39850	2709	1729720	1950-12-09	1950-12-17	1	-6955
61936	4226	1129625	1964-12-08	1964-12-08	1	-1850
19237	1317	1713332	1978-07-13	1978-07-27	1	3129
1167	79	1112807	1947-10-17	1947-10-31	1	-8098
22413	1525	1521369	1985-06-16	1986-06-11	1	6005
73862	5049	1347450	2002-07-31	2002-07-31	1	11899
31492	2130	1759842	2001-03-29	2001-06-21	1	11494
22199	1511	920293	2006-05-28	2006-06-04	1	13303
1769	116	1759842	1943-10-30	1943-11-20	1	-9539
16647	1146	1729720	1978-11-15	1978-11-27	1	3252
57599	3927	1177480	1998-09-12	1998-10-03	1	10502
50502	3438	1729720	1957-11-20	1957-11-27	1	-4418
54367	3698	738818	1989-05-05	1989-05-12	1	7071
33838	2297	1125315	1978-06-12	1978-08-11	1	3144
54321	3695	1112807	1985-05-29	1985-06-12	1	5641
28272	1915	1713332	1980-06-21	1980-07-12	1	3845
43219	2925	1112807	1961-02-03	1961-02-17	1	-3240
37436	2545	1729720	1988-05-16	1988-05-29	1	6723
42341	2868	1503184	1983-08-31	1984-08-25	1	5350
29089	1971	1125315	1997-09-06	1997-09-20	1	10124
39851	2709	1759842	1958-03-27	1958-04-10	1	-4284
61937	4226	1717327	1965-08-04	1965-08-18	1	-1597
19238	1317	1728416	1952-12-03	1952-12-08	1	-6233
1168	79	1112807	1949-08-25	1949-09-08	1	-7420
22414	1525	1759842	2013-02-16	2013-03-09	1	15773
73863	5049	1759842	1968-02-08	1968-02-15	1	-686
31493	2130	1118084	1996-05-12	1996-05-12	1	9628
22200	1511	1124300	2010-01-29	2010-01-29	1	14638
1770	116	1759842	1963-08-11	1963-08-18	1	-2328
16648	1146	1112807	1961-05-18	1961-06-01	1	-3136
57600	3927	1713332	1962-07-26	1962-08-16	1	-2695
50503	3438	738818	1927-01-03	1927-01-10	1	-15697
54368	3698	1112807	1963-04-02	1963-04-30	1	-2438
33839	2297	1503184	1988-08-28	1989-08-23	1	7174
54322	3695	1119510	1987-03-31	1987-04-14	1	6312
28273	1915	1713332	2012-07-22	2012-08-05	1	15557
43220	2925	1125315	2007-06-17	2007-07-22	2	13716
38934	2647	920293	2006-01-14	2006-01-28	2	13176
42342	2868	1521369	1988-08-04	1989-07-30	1	7150
29090	1971	1177480	2015-08-27	2015-09-10	1	16688
39852	2709	1759842	1975-04-04	1975-04-25	1	1940
63498	4340	1125315	2002-03-20	2002-03-27	1	11773
19239	1317	1759842	1968-12-21	1969-01-11	1	-355
1169	79	1125315	1979-02-15	1979-03-08	1	3353
22415	1525	1125315	1977-07-20	1977-07-27	1	2764
73864	5049	1759842	1970-09-09	1970-09-23	1	265
31494	2130	1125315	1974-12-04	1974-12-18	1	1812
22201	1511	1125315	2009-04-27	2009-05-11	1	14375
2262	152	753626	1973-12-15	1973-12-15	1	1444
16649	1146	1177480	2001-09-11	2001-10-11	1	11606
57601	3927	1713332	1986-05-09	1986-05-30	1	5993
50504	3438	933724	1938-05-19	1938-06-02	1	-11536
54369	3698	1125315	1989-05-05	1989-05-12	1	7071
33840	2297	1177480	2017-05-18	2017-06-01	1	17318
54323	3695	1124957	1996-03-21	1996-03-21	1	9576
28274	1915	1713332	2013-04-02	2013-04-16	1	15811
38935	2647	1125315	1988-01-31	1988-02-07	1	6611
42343	2868	1545958	2016-02-10	2016-02-10	1	16841
29091	1971	1521369	1987-02-18	1988-02-13	1	6617
39853	2709	1759842	2013-03-20	2013-04-03	1	15798
63499	4340	1112807	1984-02-13	1984-03-05	1	5177
19240	1317	1112807	1971-02-23	1971-03-16	1	439
1170	79	1125315	1990-08-05	1990-08-12	1	7528
22416	1525	1521369	1977-07-28	1979-07-18	2	3485
75188	5145	1125315	1999-02-08	1999-02-22	1	10644
31495	2130	1125315	2004-02-23	2004-03-08	1	12485
22202	1511	1125315	2012-12-15	2012-12-15	1	15689
2263	152	920293	2011-02-02	2011-02-09	1	15014
16650	1146	1713332	1960-03-17	1960-03-31	1	-3563
57602	3927	1112807	1960-04-10	1960-05-15	1	-3518
50505	3438	1713332	1930-04-20	1930-05-04	1	-14487
54370	3698	738818	1996-03-16	1996-03-23	1	9578
33841	2297	1118084	2012-06-13	2012-06-13	1	15504
54324	3695	1177480	1981-10-26	1981-11-09	1	4330
28275	1915	1759842	1980-06-21	1980-07-12	1	3845
38936	2647	19127890	1988-11-18	1990-11-08	2	7616
42535	2882	1149380	1975-05-19	1993-12-24	1	8758
29092	1971	1717327	1973-09-14	1973-09-28	1	1366
39854	2709	757627	2012-01-17	2012-01-17	1	15356
63500	4340	1125315	1977-04-29	1977-05-20	1	2696
19241	1317	1125315	1964-04-14	1964-04-21	1	-2081
1171	79	1154343	1949-05-02	1949-05-02	1	-7549
25469	1727	708298	1982-03-25	1982-03-25	1	4466
75189	5145	1713332	1969-04-07	1969-04-21	1	-255
33053	2238	1125315	2003-10-14	2003-10-28	1	12353
22203	1511	1717327	1968-08-07	1968-08-21	1	-498
2264	152	933724	2010-11-13	2010-11-20	1	14933
16651	1146	1713332	1967-06-01	1967-06-08	1	-938
57603	3927	1125315	1973-06-11	1973-06-18	1	1264
50506	3438	1759842	1930-04-20	1930-05-04	1	-14487
54371	3698	1125315	1996-03-16	1996-03-23	1	9578
33842	2297	1521369	1988-08-28	1989-08-23	1	7174
54325	3695	1595799	1999-01-05	1999-12-31	1	10956
28276	1915	1759842	2012-07-22	2012-08-05	1	15557
38937	2647	1728416	1971-05-12	1971-05-26	1	510
42536	2882	1503184	1987-05-04	1988-04-28	1	6692
29093	1971	1728416	1974-04-23	1974-05-07	1	1587
39855	2709	1112807	1943-12-15	1943-12-29	1	-9500
63501	4340	1115008	2000-10-07	2000-10-28	1	11258
19242	1317	1125315	1992-05-05	1992-05-12	1	8167
1172	79	1713332	1958-09-27	1958-10-18	1	-4093
25470	1727	920293	2002-05-28	2002-06-04	1	11842
75190	5145	1713332	1979-08-26	1979-09-23	1	3552
33054	2238	1118084	2002-07-17	2002-07-17	1	11885
22204	1511	19127890	1985-03-21	1986-03-16	1	5918
2265	152	1110410	1973-12-15	1973-12-15	1	1444
16652	1146	1729720	2001-12-10	2001-12-22	1	11678
57604	3927	1125315	2011-04-02	2011-04-16	1	15080
50507	3438	920293	1938-05-19	1938-06-02	2	-11536
54372	3698	1125315	2000-02-03	2000-02-10	1	10997
33843	2297	1713332	1987-02-01	1987-02-22	1	6261
54326	3695	1713332	1982-12-07	1982-12-21	1	4737
29809	2017	1119510	1985-04-26	1985-05-03	1	5601
38938	2647	1729720	1977-02-23	1977-03-04	1	2619
42537	2882	1192710	1974-06-02	1974-06-02	1	1613
29094	1971	1112807	1973-09-14	1973-09-28	1	1366
39856	2709	1112807	1944-11-07	1944-12-07	1	-9156
63502	4340	1118084	2010-01-31	2010-01-31	1	14640
19243	1317	1322184	2009-12-25	2009-12-25	1	14603
1173	79	1713332	1966-01-05	1966-01-26	1	-1436
25471	1727	967823	1982-03-24	1982-03-25	1	4466
75191	5145	1728416	1958-06-26	1958-07-10	1	-4193
33055	2238	1125315	1978-10-13	1978-10-27	1	3221
25200	1709	738818	1970-04-25	1970-05-02	1	121
2266	152	1115008	1995-03-03	1995-03-24	1	9213
16653	1146	19127890	1974-01-06	1975-01-01	1	1826
57605	3927	1713332	1961-12-29	1962-01-19	1	-2904
50508	3438	1112807	1924-06-27	1924-08-26	1	-16564
54997	3742	1125315	1993-09-14	1993-09-28	1	8671
34692	2346	1112807	1946-12-03	1946-12-17	1	-8416
54327	3695	19003953	1996-03-20	1996-03-20	1	9575
29810	2017	1125315	1974-05-04	1974-05-18	1	1598
38939	2647	933724	2006-01-14	2006-01-28	1	13176
42538	2882	1521369	1987-05-04	1988-04-28	1	6692
29095	1971	1118084	2012-02-17	2012-02-17	1	15387
39857	2709	1125315	2002-11-16	2002-11-30	1	12021
63503	4340	1125315	1976-04-04	1976-04-18	1	2299
19244	1317	1332418	2009-12-25	2009-12-25	1	14603
2472	163	1118084	2010-04-03	2010-04-03	1	14702
25472	1727	1000560	1982-03-24	1982-03-25	2	4465
75192	5145	1729720	1967-10-08	1967-10-18	1	-806
33056	2238	1149380	1971-08-11	1971-08-11	1	587
25201	1709	1112807	1943-11-12	1943-12-10	1	-9519
2267	152	1118084	2000-03-11	2000-03-11	1	11027
16654	1146	1112807	1969-12-09	1969-12-30	1	-2
57606	3927	1717327	1962-02-27	1962-03-13	1	-2851
50509	3438	1125315	1924-06-27	1924-06-27	1	-16624
54998	3742	1112807	1972-07-04	1972-07-18	1	929
34693	2346	1112807	1982-08-10	1982-11-08	1	4694
57467	3920	1115008	2012-11-24	2012-12-29	1	15703
29811	2017	1713332	1974-04-11	1974-04-25	1	1575
38940	2647	1112807	1973-02-12	1973-02-26	1	1152
42539	2882	1118084	2005-09-21	2005-09-21	1	13047
29096	1971	1119510	1993-07-04	1993-07-11	1	8592
39858	2709	1125315	2017-10-06	2017-10-06	1	17445
63504	4340	1728416	1976-04-04	1976-04-18	1	2299
19245	1317	1539403	2009-12-25	2009-12-25	1	14603
2473	163	1177480	1999-08-30	1999-09-13	1	10847
25473	1727	1112807	1952-03-14	1952-04-04	1	-6481
75193	5145	1112807	1979-08-26	1979-09-23	1	3552
33057	2238	1177480	1989-01-16	1989-02-20	1	6990
25202	1709	1112807	1949-11-06	1949-12-06	1	-7331
2268	152	1125315	1992-02-17	1992-03-18	2	8112
16655	1146	1125315	1959-12-11	1959-12-25	1	-3660
57607	3927	1112807	1948-10-19	1948-11-09	1	-7723
50510	3438	1759842	1988-09-14	1988-10-05	1	6852
54999	3742	1118084	2010-09-18	2010-09-18	1	14870
34694	2346	1119510	1952-11-03	1952-11-17	1	-6254
57468	3920	1515774	1993-07-17	1994-07-12	1	8958
29812	2017	738818	1985-04-26	1985-05-03	1	5601
38941	2647	1115008	1996-06-29	1996-09-27	1	9766
42540	2882	1515774	1989-04-23	1991-04-13	2	7772
29097	1971	1125315	1981-05-12	1981-05-19	1	4156
39859	2709	1713332	1958-03-27	1958-04-10	1	-4284
63505	4340	1729720	1978-11-03	1978-11-16	1	3241
19246	1317	1759842	1986-12-21	1987-01-04	1	6212
2474	163	1119510	2006-09-02	2006-09-16	1	13407
25474	1727	1119510	2004-09-10	2004-09-24	1	12685
75194	5145	1118084	1991-04-24	1991-04-24	1	7783
33058	2238	1125315	1986-04-23	1986-05-07	1	5970
25203	1709	1125315	1951-10-27	1951-11-26	1	-6611
2269	152	19003953	1973-12-15	1973-12-15	1	1444
16656	1146	1125315	1990-11-30	1990-12-14	1	7652
57608	3927	1112807	1949-04-17	1949-05-01	1	-7550
50855	3458	738818	1991-06-12	1991-06-26	1	7846
55000	3742	1713332	1989-01-16	1989-02-06	1	6976
34695	2346	1728416	1949-09-01	1949-09-15	1	-7413
57469	3920	1713332	1986-05-03	1986-05-10	1	5973
29813	2017	1125315	1980-07-03	1980-07-17	1	3850
38942	2647	1118084	2014-08-19	2014-08-19	1	16301
42541	2882	1515774	1992-04-07	1994-03-28	2	8852
29098	1971	1729720	1971-04-07	1971-04-17	1	471
39860	2709	1713332	1975-04-04	1975-04-25	1	1940
63506	4340	1729720	1994-10-07	1994-10-20	1	9058
19247	1317	1759842	2010-08-28	2010-09-18	1	14870
2475	163	1125315	1975-04-26	1975-07-26	2	2032
25475	1727	1137529	2000-04-06	2000-04-06	1	11053
75195	5145	1124957	1979-08-26	1979-08-26	1	3524
33059	2238	1125315	2005-08-16	2005-09-06	1	13032
25204	1709	1125315	1970-04-25	1970-05-02	1	121
2270	152	19016749	1973-12-15	1973-12-15	1	1444
16657	1146	1713332	2015-09-20	2015-10-04	1	16712
57609	3927	1728416	1949-04-17	1949-05-01	1	-7550
50856	3458	1125315	1983-06-30	1983-07-21	1	4949
55001	3742	1713332	1996-09-01	1996-09-22	1	9761
34696	2346	1112807	1949-09-01	1949-09-15	1	-7413
57470	3920	1759842	1986-05-03	1986-05-10	1	5973
29814	2017	1125315	1985-04-26	1985-05-03	1	5601
38943	2647	1125315	1974-08-25	1974-09-01	1	1704
42542	2882	1549786	1989-04-23	1991-04-13	2	7772
29099	1971	19127890	1987-02-18	1988-02-13	1	6617
39861	2709	1729720	1953-08-04	1953-08-13	1	-5985
64296	4391	1102527	2016-11-26	2016-11-26	1	17131
19248	1317	1112807	1952-11-03	1952-12-08	1	-6233
2476	163	1125315	2001-04-28	2001-05-12	1	11454
25476	1727	1149380	2000-04-06	2000-04-06	1	11053
75196	5145	1125315	1968-04-04	1968-04-25	1	-616
33060	2238	1154343	1971-08-11	1971-08-11	1	587
25205	1709	1759842	1966-08-15	1966-08-29	1	-1221
2271	152	782043	1973-12-15	1973-12-15	1	1444
16658	1146	1729720	1990-12-26	1991-01-03	1	7672
57610	3927	1759842	1961-12-29	1962-01-19	1	-2904
50857	3458	1125315	1997-09-29	1997-10-06	1	10140
55002	3742	1729720	1984-08-04	1984-08-11	1	5336
34697	2346	1118084	1986-11-13	1986-11-13	1	6160
57471	3920	1118084	2011-01-09	2011-01-09	1	14983
29815	2017	1728416	1974-05-04	1974-05-18	1	1598
38944	2647	1129625	1974-01-02	1974-01-02	1	1462
42543	2882	1549786	1992-04-07	1994-03-28	2	8852
29100	1971	1112807	1972-04-27	1972-05-11	1	861
39862	2709	1759842	2003-04-23	2003-05-07	1	12179
64297	4391	1112807	1952-11-06	1952-11-20	1	-6251
19249	1317	1112807	1982-09-14	1982-10-14	1	4669
2477	163	1125315	2006-09-02	2006-09-16	1	13407
25477	1727	1713332	1973-06-26	1973-07-17	1	1293
75197	5145	1728416	1959-03-14	1959-03-28	1	-3932
33061	2238	1125315	2009-04-18	2009-05-02	1	14366
25206	1709	1112807	1939-03-22	1939-04-05	1	-11229
2272	152	920293	2010-11-13	2010-11-20	1	14933
16659	1146	1759842	1960-03-17	1960-03-31	1	-3563
57611	3927	1759842	1986-05-09	1986-05-30	1	5993
50858	3458	1177480	1992-06-03	1992-06-24	1	8210
55003	3742	1729720	1995-04-02	1995-04-14	1	9234
34698	2346	1125315	1952-11-03	1952-11-17	1	-6254
57472	3920	1125315	1974-12-01	1974-12-15	1	1809
29816	2017	1729720	1971-02-20	1971-02-27	1	422
38945	2647	1515774	1989-11-13	1990-11-08	1	7616
42544	2882	19127890	1987-05-04	1988-04-28	1	6692
29101	1971	1119510	1983-10-02	1983-10-16	1	5036
39863	2709	701322	2013-10-08	2013-10-08	1	15986
64298	4391	1125315	2011-10-10	2011-10-24	1	15271
19250	1317	1115008	1999-01-18	1999-02-01	1	10623
2478	163	1713332	1989-01-29	1989-02-05	1	6975
25478	1727	1741122	1982-03-25	1982-03-25	1	4466
75198	5145	1759842	1990-01-23	1990-02-06	1	7341
33062	2238	1177480	2000-09-20	2000-10-11	1	11241
25207	1709	1112807	1948-10-14	1948-11-11	1	-7721
2273	152	1000560	1973-12-15	1973-12-15	2	1444
16660	1146	1759842	1967-06-01	1967-06-08	1	-938
57612	3927	1112807	1962-02-27	1962-03-13	1	-2851
50859	3458	1177480	2013-05-05	2013-05-26	1	15851
55004	3742	1759842	1989-01-16	1989-02-06	1	6976
34699	2346	1177480	2016-09-10	2016-12-09	1	17144
57473	3920	1729720	1976-07-07	1976-07-16	1	2388
29817	2017	1125315	1972-09-11	1972-09-25	1	998
38946	2647	1521369	1988-11-18	1989-11-13	1	7256
42545	2882	1125315	1990-09-06	1990-09-13	1	7560
29102	1971	1177480	1974-04-23	1974-05-07	1	1587
39864	2709	738818	1943-12-17	1943-12-24	1	-9505
64299	4391	1125315	2012-09-18	2012-10-18	1	15631
19251	1317	1124300	1989-11-19	1989-11-19	1	7262
2479	163	738818	2006-09-02	2006-09-16	1	13407
25479	1727	1759842	1995-10-29	1995-11-04	1	9438
75199	5145	914335	2018-01-13	2018-01-13	1	17544
33063	2238	1729720	1970-12-26	1971-01-05	1	369
25208	1709	1112807	1953-10-16	1953-11-20	1	-5886
2274	152	1729720	2017-01-26	2017-02-05	1	17202
17029	1174	1112807	1941-11-03	1941-11-24	1	-10265
57613	3927	1118084	1981-02-08	1981-02-08	1	4056
50860	3458	1713332	1988-04-04	1988-04-18	1	6682
55005	3742	1759842	1996-09-01	1996-09-22	1	9761
34700	2346	1728416	1946-12-03	1946-12-17	1	-8416
57474	3920	1738521	1975-08-30	1975-09-13	1	2081
29818	2017	1125315	2001-08-08	2001-08-22	1	11556
38947	2647	1112807	1971-05-12	1971-05-26	1	510
42546	2882	1154343	1975-05-19	1993-12-24	1	8758
29103	1971	1503184	1987-02-18	1988-02-13	1	6617
39865	2709	1112807	1942-12-20	1943-01-17	1	-9846
64300	4391	1177480	1987-02-20	1987-03-20	1	6287
19252	1317	1713332	1968-12-21	1969-01-11	1	-355
2480	163	933724	2007-08-19	2007-08-26	1	13751
25480	1727	753626	1982-03-25	1982-03-25	1	4466
75200	5145	920293	1978-10-21	1978-10-28	1	3222
35794	2433	1112807	1958-02-14	1958-02-28	1	-4325
25209	1709	1115008	2004-04-08	2004-05-06	1	12544
2275	152	1746114	1973-12-15	1973-12-15	1	1444
17030	1174	1115008	2003-01-31	2003-02-21	1	12104
57614	3927	1125315	1977-01-16	1977-01-30	1	2586
50861	3458	1125315	1985-05-22	1985-06-05	1	5634
55006	3742	1125315	2003-03-27	2003-04-10	1	12152
34701	2346	738818	1952-11-03	1952-11-17	1	-6254
57475	3920	1759842	1981-09-22	1981-10-06	1	4296
29819	2017	1759842	1974-04-11	1974-04-25	1	1575
38948	2647	1125315	1975-11-13	1975-11-27	1	2156
42547	2882	19127890	1989-04-23	1991-04-13	2	7772
29104	1971	1713332	2015-08-27	2015-09-10	1	16688
39866	2709	1118084	1984-01-14	1984-01-14	1	5126
64301	4391	1713332	1957-08-18	1957-09-08	1	-4498
19253	1317	1713332	1986-12-21	1987-01-04	1	6212
2481	163	1112807	1968-04-18	1968-05-02	1	-609
25481	1727	920293	2000-04-11	2000-04-18	1	11065
75201	5145	933724	1978-10-21	1978-10-28	1	3222
35795	2433	1118084	1992-01-27	1992-01-27	1	8061
25210	1709	1557272	2017-02-04	2017-02-04	1	17201
2276	152	708298	1973-12-15	1973-12-15	1	1444
17031	1174	1125315	1957-09-02	1957-09-23	1	-4483
57615	3927	1177480	2013-12-13	2014-01-17	1	16087
50862	3458	1125315	1988-04-04	1988-04-18	1	6682
55007	3742	1717327	1972-07-04	1972-07-18	1	929
34702	2346	1125315	1953-09-26	1953-10-10	1	-5927
57476	3920	738818	1975-04-14	1975-04-21	1	1936
29820	2017	1124300	2007-10-08	2007-10-08	1	13794
38949	2647	1503184	1988-11-18	1989-11-13	1	7256
42548	2882	19127890	1992-04-07	1994-03-28	2	8852
29105	1971	1713332	2017-12-22	2018-01-12	1	17543
39867	2709	1125315	1943-12-17	1943-12-24	1	-9505
64302	4391	1112807	1945-12-13	1946-03-13	1	-8695
19254	1317	1713332	2010-08-28	2010-09-18	1	14870
2482	163	1112807	1979-06-04	1979-06-25	1	3462
25482	1727	933724	2002-05-28	2002-06-04	1	11842
75202	5145	1112807	1959-03-14	1959-03-28	1	-3932
35796	2433	1125315	1955-01-01	1955-01-22	1	-5458
25211	1709	1713332	1953-07-31	1953-08-14	1	-5984
2277	152	933724	2011-02-02	2011-02-09	1	15014
17032	1174	1125315	1963-03-02	1963-03-02	1	-2497
57616	3927	1759842	1962-07-26	1962-08-16	1	-2695
50863	3458	1713332	1996-09-02	1996-09-16	1	9755
57187	3899	1125315	2003-12-18	2003-12-25	1	12411
34703	2346	1125315	1972-10-10	1972-10-24	1	1027
57477	3920	1102527	2009-11-10	2009-11-10	1	14558
29821	2017	1125315	1983-05-01	1983-06-05	1	4903
38950	2647	1549786	1989-11-13	1990-11-08	1	7616
45476	3086	1125315	1980-05-27	1980-06-03	1	3806
29390	1989	933724	1997-03-13	1997-03-20	1	9940
39868	2709	1125315	1970-09-22	1970-10-13	1	285
64303	4391	1118084	1978-06-18	1978-06-18	1	3090
19255	1317	1728416	1963-03-16	1963-04-06	1	-2462
2483	163	1125315	1973-03-23	1973-04-06	1	1191
25483	1727	1112807	1977-02-22	1977-03-24	1	2639
75203	5145	1112807	1960-11-07	1960-11-21	1	-3328
35797	2433	1125315	1962-12-22	1962-12-29	1	-2560
25212	1709	1759842	1967-03-02	1967-03-09	1	-1029
2278	152	1125315	1969-03-19	1969-04-02	1	-274
17033	1174	1174888	1963-03-02	1963-03-02	1	-2497
59129	4027	914335	2014-06-21	2014-06-21	1	16242
50864	3458	1759842	1996-09-02	1996-09-16	1	9755
57188	3899	1177480	1985-05-31	1985-06-28	1	5657
34704	2346	1713332	1982-08-23	1982-08-30	1	4624
57478	3920	1125315	1974-05-18	1974-06-01	1	1612
29822	2017	1738521	1972-09-11	1972-09-25	1	998
38951	2647	1713332	1998-03-04	1998-03-18	1	10303
45477	3086	1125315	1987-01-30	1987-02-06	1	6245
29391	1989	1112807	1956-12-20	1957-01-17	1	-4732
39869	2709	1729720	1973-01-01	1973-01-14	1	1109
64304	4391	1119510	1947-12-04	1947-12-18	1	-8050
19256	1317	1729720	1995-08-03	1995-08-10	1	9352
2484	163	1768849	1980-02-02	1980-02-16	1	3698
25484	1727	1118084	1991-12-10	1991-12-10	1	8013
75204	5145	1125315	2000-02-18	2000-02-25	1	11012
35798	2433	1125315	1984-05-17	1984-06-07	1	5271
25213	1709	1112807	1937-09-14	1937-09-28	1	-11783
2279	152	1125315	1976-09-10	1976-09-17	1	2451
17034	1174	1713332	2016-05-05	2016-05-12	1	16933
59130	4027	1125315	1976-06-07	1976-06-21	1	2363
50865	3458	1119510	1991-06-12	1991-06-26	1	7846
57189	3899	738818	2016-06-06	2016-06-13	1	16965
34705	2346	1713332	2004-12-03	2004-12-17	1	12769
57479	3920	1125315	1975-04-14	1975-04-21	1	1936
35587	2418	1115008	1996-09-20	1996-10-04	1	9773
38952	2647	1713332	2000-12-07	2000-12-14	1	11305
45478	3086	1728416	1971-11-30	1971-12-14	1	712
29392	1989	1119510	1967-10-25	1967-11-08	1	-785
39870	2709	1759842	1947-05-07	1947-05-28	1	-8254
64305	4391	1729720	1983-09-19	1983-09-30	1	5020
19257	1317	1759842	1978-07-13	1978-07-27	1	3129
2485	163	920293	2001-07-20	2001-07-27	1	11530
25485	1727	1174888	1977-02-22	1977-02-22	1	2609
75205	5145	1309944	2018-01-13	2018-01-13	1	17544
35799	2433	1125315	1994-03-17	1994-04-21	1	8876
25214	1709	1112807	1940-04-22	1940-05-06	1	-10832
2280	152	1125315	2000-10-23	2000-11-22	1	11283
17035	1174	1729720	1946-03-28	1946-04-05	1	-8672
59131	4027	1125315	1994-04-30	1994-05-07	1	8892
50866	3458	1125315	2004-01-04	2004-01-11	1	12428
57190	3899	1125315	1991-10-29	1991-11-12	1	7985
34706	2346	1729720	1958-10-28	1958-11-05	1	-4075
57480	3920	1125315	2004-05-17	2004-05-31	1	12569
35588	2418	1118084	2009-06-17	2009-06-17	1	14412
38953	2647	1729720	1980-10-15	1980-10-25	1	3950
45479	3086	1729720	1982-05-27	1982-06-03	1	4536
29393	1989	1119510	1984-04-14	1984-04-21	1	5224
64306	4391	701322	2016-06-20	2016-06-20	1	16972
19258	1317	1149380	1997-07-11	1997-07-11	1	10053
2486	163	920293	2007-08-19	2007-08-26	1	13751
25486	1727	1177480	1991-06-10	1991-07-01	1	7851
75206	5145	1343916	2018-01-13	2018-01-13	1	17544
35800	2433	1177480	1981-06-04	1981-07-02	1	4200
25215	1709	1118084	1978-02-26	1978-02-26	1	2978
2281	152	1125315	2010-09-23	2010-09-30	1	14882
17036	1174	1759842	1952-06-15	1952-06-29	1	-6395
59132	4027	1503184	1995-11-21	1996-11-15	1	9815
50867	3458	1115008	2014-04-21	2014-05-19	1	16209
57191	3899	1125315	2016-06-06	2016-06-13	1	16965
34707	2346	1729720	1959-10-17	1959-10-24	1	-3722
57481	3920	1177480	2009-11-10	2010-01-09	1	14618
35589	2418	1125315	2018-06-02	2018-06-09	1	17691
38954	2647	1759842	1998-03-04	1998-03-18	1	10303
45480	3086	1112807	1971-11-30	1971-12-14	1	712
29394	1989	1125315	1952-11-11	1952-11-25	1	-6246
64307	4391	715997	2016-06-20	2016-06-20	1	16972
19259	1317	1361711	2009-12-25	2009-12-25	1	14603
2487	163	933724	2001-07-20	2001-07-27	1	11530
25487	1727	1713332	1952-11-15	1952-11-22	1	-6249
75207	5145	920293	1979-01-13	1979-01-20	1	3306
35801	2433	1729720	1961-01-30	1961-02-07	1	-3250
25216	1709	1125315	1989-05-23	1989-06-06	1	7096
2282	152	1174888	1992-02-17	1992-02-17	1	8082
17037	1174	1112807	1944-04-17	1944-05-01	1	-9376
59133	4027	1503184	1997-11-10	1998-11-05	1	10535
50868	3458	1124300	2019-03-28	2019-03-28	1	17983
57192	3899	1177480	2018-08-09	2018-11-07	1	17842
34708	2346	1729720	2019-02-13	2019-02-21	1	17948
57482	3920	1515774	1991-07-28	1992-07-22	1	8238
35590	2418	1521369	1992-08-05	1993-07-31	1	8612
38955	2647	1759842	2000-12-07	2000-12-14	1	11305
45481	3086	1118084	2004-09-06	2004-09-06	1	12667
29395	1989	1728416	1952-11-11	1952-11-25	1	-6246
64308	4391	738818	1947-12-04	1947-12-18	1	-8050
19260	1317	1729720	1964-10-04	1964-10-13	1	-1906
2488	163	1125315	1980-02-02	1980-02-16	1	3698
25488	1727	19003953	1982-03-25	1982-03-25	1	4466
75208	5145	933724	1979-01-13	1979-01-20	1	3306
35802	2433	1125315	1986-02-27	1986-05-28	2	5991
25217	1709	1125315	2002-01-21	2002-02-18	1	11736
2283	152	1741122	1973-12-15	1973-12-15	1	1444
17038	1174	1112807	1963-02-23	1963-05-02	1	-2436
59134	4027	1521369	1997-11-10	1998-11-05	1	10535
50869	3458	1125315	1991-06-12	1991-06-26	1	7846
57193	3899	738818	2010-10-21	2010-10-28	1	14910
34709	2346	1759842	1982-08-23	1982-08-30	1	4624
57483	3920	1549786	1991-07-28	1992-07-22	1	8238
35591	2418	1125315	1979-02-10	1979-02-24	1	3341
40388	2747	705944	1983-06-09	1983-11-10	1	5061
45482	3086	1125315	1971-07-12	1971-07-26	1	571
29396	1989	738818	1984-04-14	1984-04-21	1	5224
64309	4391	1125315	1947-12-04	1947-12-18	1	-8050
26346	1781	738818	1961-01-27	1961-02-03	1	-3254
2489	163	1125315	1984-04-29	1984-05-20	1	5253
25489	1727	933724	2000-04-11	2000-04-18	1	11065
75209	5145	1112807	1958-06-26	1958-07-10	1	-4193
35803	2433	1125315	1996-02-06	1996-02-20	1	9546
25218	1709	1713332	1966-08-15	1966-08-29	1	-1221
2284	152	967823	1973-12-15	1973-12-16	1	1445
17039	1174	1713332	1952-06-15	1952-06-29	1	-6395
59135	4027	1521369	1999-10-31	2000-10-25	1	11255
50870	3458	1729720	2000-07-31	2000-08-07	1	11176
57194	3899	1119510	2010-10-21	2010-10-28	1	14910
34710	2346	1759842	2004-12-03	2004-12-17	1	12769
57484	3920	1549786	1993-07-17	1994-07-12	1	8958
35592	2418	1125315	1981-09-09	1981-12-08	1	4359
40389	2747	1119510	1984-02-20	1984-02-27	1	5170
45483	3086	1125315	2014-10-22	2014-11-05	1	16379
29397	1989	1124300	1986-07-26	1986-07-26	1	6050
64310	4391	1177480	2016-11-26	2017-02-24	1	17221
26347	1781	1112807	1942-02-05	1942-02-19	1	-10178
2490	163	1738521	1968-04-18	1968-05-02	1	-609
25490	1727	1125315	1950-07-24	1950-08-07	1	-7087
75210	5145	1125315	1979-08-26	1979-08-26	1	3524
35804	2433	1361711	2014-03-16	2014-03-16	1	16145
25219	1709	1112807	1959-10-20	1959-11-03	1	-3712
2285	152	1125315	2017-02-26	2017-03-19	1	17244
17040	1174	1112807	1943-07-27	1943-08-10	1	-9641
59136	4027	1521369	2002-10-15	2003-10-10	1	12335
50871	3458	1729720	2006-08-10	2006-08-17	1	13377
57195	3899	1119510	2016-06-06	2016-06-13	1	16965
34711	2346	1125315	1966-04-22	1966-05-06	1	-1336
57485	3920	1713332	1981-09-22	1981-10-06	1	4296
35593	2418	1125315	1989-05-14	1989-05-28	1	7087
40390	2747	1119510	2019-04-30	2019-05-07	1	18023
45484	3086	1177480	1982-11-11	1982-11-25	1	4711
29398	1989	1125315	1984-04-14	1984-04-21	1	5224
64311	4391	1729720	1955-07-06	1955-07-16	1	-5283
26348	1781	1119510	1966-02-09	1966-02-23	1	-1408
2491	163	1759842	1989-01-29	1989-02-05	1	6975
25491	1727	1177480	2012-11-06	2012-11-27	1	15671
75211	5145	1125315	2001-11-26	2002-01-25	1	11712
1598	105	1125315	1985-10-08	1985-10-22	1	5773
25220	1709	1119510	1970-04-25	1970-05-02	1	121
2286	152	1367571	1973-12-15	1973-12-15	1	1444
17041	1174	1118084	1974-01-25	1974-01-25	1	1485
59137	4027	1549786	1996-11-15	1997-11-10	1	10175
52445	3572	1112807	1969-10-02	1969-10-16	1	-77
57196	3899	1125315	2010-10-21	2010-10-28	1	14910
34712	2346	1125315	1983-05-14	1983-05-21	1	4888
57486	3920	1728416	1974-05-18	1974-06-01	1	1612
35594	2418	1177480	1975-12-23	1976-01-06	1	2196
40391	2747	1125315	2008-12-09	2008-12-23	1	14236
45485	3086	1729720	1971-10-14	1971-10-26	1	663
29399	1989	1177480	2010-07-20	2010-08-10	1	14831
64312	4391	1759842	1957-08-18	1957-09-08	1	-4498
26349	1781	1124300	1975-09-15	1975-09-15	1	2083
3219	213	1118084	2003-09-09	2003-09-09	1	12304
25492	1727	1713332	1995-10-29	1995-11-04	1	9438
75212	5145	1713332	1990-01-23	1990-02-06	1	7341
1599	105	1125315	2005-11-11	2005-11-11	1	13098
25221	1709	1177480	2017-10-25	2017-11-22	1	17492
4816	331	738818	1999-12-31	2000-01-14	1	10970
17042	1174	1759842	1976-11-03	1976-12-01	1	2526
59138	4027	1713332	1983-04-06	1983-04-27	1	4864
52446	3572	1125315	1975-01-11	1975-02-01	1	1857
57197	3899	1177480	1998-08-19	1998-09-23	1	10492
34713	2346	1177480	1974-08-22	1974-09-21	1	1724
57487	3920	19127890	1991-07-28	1992-07-22	1	8238
35595	2418	1177480	1976-04-21	1976-05-26	1	2337
40392	2747	1729720	1980-10-28	1980-11-04	1	3960
48521	3298	1112807	1976-01-12	1976-01-26	1	2216
29400	1989	1713332	1992-04-16	1992-05-07	1	8162
64313	4391	757627	2015-06-26	2015-06-26	1	16612
26350	1781	1125315	1961-01-27	1961-02-03	1	-3254
3220	213	1521369	1982-04-22	1984-04-11	2	5214
25493	1727	1728416	1950-07-24	1950-08-07	1	-7087
75213	5145	1713332	1999-02-08	1999-02-22	1	10644
1600	105	1177480	1982-02-12	1982-02-26	1	4439
25222	1709	1713332	1967-03-02	1967-03-09	1	-1029
4817	331	753626	1997-04-18	1997-04-18	1	9969
17043	1174	920293	1967-02-07	1967-02-14	1	-1052
59139	4027	1759842	1983-04-06	1983-04-27	1	4864
52447	3572	1713332	2005-01-11	2005-01-18	1	12801
57198	3899	1118084	2015-07-08	2015-07-08	1	16624
35292	2396	1112807	1920-08-15	1920-08-29	1	-18022
57488	3920	19127890	1993-07-17	1994-07-12	1	8958
35596	2418	1177480	1980-10-16	1980-11-13	1	3969
40393	2747	1729720	1994-09-23	1994-10-04	1	9042
48522	3298	1115008	2018-06-28	2018-07-26	1	17738
29401	1989	1759842	1992-04-16	1992-05-07	1	8162
64314	4391	1112807	1941-11-04	1941-11-18	1	-10271
26351	1781	1713332	1995-06-19	1995-07-03	1	9314
3221	213	1759842	2009-06-23	2009-07-14	1	14439
25494	1727	1729720	1954-02-05	1954-02-13	1	-5801
75214	5145	1759842	1969-04-07	1969-04-21	1	-255
1601	105	1713332	1979-07-28	1979-08-11	1	3509
25223	1709	1759842	1953-07-31	1953-08-14	1	-5984
4818	331	1102527	1997-04-19	1997-04-19	1	9970
17044	1174	933724	1967-02-07	1967-02-14	1	-1052
59140	4027	19127890	1988-01-02	1988-12-27	1	6935
52448	3572	1759842	1972-12-24	1972-12-31	1	1095
57408	3917	1307863	2014-02-27	2014-02-27	1	16128
35293	2396	1112807	1921-11-21	1921-12-05	1	-17559
57489	3920	1112807	1975-08-30	1975-09-13	1	2081
35597	2418	1503184	1992-08-05	1993-07-31	1	8612
40394	2747	738818	1984-02-20	1984-02-27	1	5170
48523	3298	1729720	1984-04-22	1984-04-30	1	5233
29402	1989	738818	1967-10-25	1967-11-08	1	-785
64315	4391	1729720	1953-11-03	1953-11-10	1	-5896
26352	1781	1759842	1950-01-30	1950-02-06	1	-7269
3222	213	1125315	1970-11-11	1970-11-25	1	328
25495	1727	1759842	1952-11-15	1952-11-22	1	-6249
76808	5251	738818	1954-04-13	1954-04-27	1	-5728
1602	105	1174888	2005-11-11	2005-11-11	1	13098
25907	1755	1112807	1969-04-28	1969-05-26	1	-220
4819	331	1110410	1997-04-18	1997-04-18	1	9969
17045	1174	1125315	1951-09-15	1951-09-22	1	-6676
59141	4027	19127890	1989-12-22	1990-12-17	1	7655
52449	3572	1125315	1958-07-22	1958-08-05	1	-4167
57409	3917	1713332	2008-07-09	2008-07-30	1	14090
35294	2396	1112807	1924-05-21	1924-06-04	1	-16647
57490	3920	1119510	1975-04-14	1975-04-21	1	1936
35598	2418	1515774	1991-08-11	1992-08-05	1	8252
40395	2747	1125315	1984-02-20	1984-02-27	1	5170
48524	3298	1124300	2006-10-30	2006-10-30	1	13451
29403	1989	1125315	1967-10-25	1967-11-08	1	-785
64911	4433	1125315	2008-08-02	2008-08-16	1	14107
26353	1781	1759842	1952-03-24	1952-03-31	1	-6485
3223	213	1125315	2004-06-16	2004-06-23	1	12592
25496	1727	19002770	1982-03-25	1982-03-25	1	4466
76809	5251	1112807	1928-11-13	1928-12-11	1	-14996
1603	105	1322184	2000-06-09	2005-11-11	1	13098
25908	1755	1119510	2010-04-21	2010-05-05	1	14734
4820	331	1112807	1956-03-24	1956-04-21	1	-5003
17046	1174	1125315	2016-05-29	2016-06-12	1	16964
59142	4027	738818	1974-10-04	1974-10-11	1	1744
52450	3572	1125315	2004-01-05	2004-02-09	1	12457
57410	3917	1759842	1980-12-26	1981-01-16	1	4033
35295	2396	1125315	1972-10-23	1972-11-06	1	1040
57491	3920	1125315	1989-01-29	1989-02-28	1	6998
35599	2418	1549786	1991-08-11	1992-08-05	1	8252
40396	2747	1125315	1988-12-28	1989-01-11	1	6950
48525	3298	1125315	1972-08-09	1972-08-30	1	972
29404	1989	1125315	1984-01-26	1984-02-16	1	5159
64912	4433	1310149	1993-04-10	1993-04-10	1	8500
26354	1781	1759842	1995-06-19	1995-07-03	1	9314
3224	213	1125315	2016-06-09	2016-06-23	1	16975
25497	1727	738818	2004-09-10	2004-09-24	1	12685
76810	5251	1125315	1947-05-18	1947-06-01	1	-8250
1604	105	1545958	2005-11-11	2005-11-11	1	13098
25909	1755	1124300	2002-02-21	2002-02-21	1	11739
4821	331	1115008	2002-06-19	2002-07-24	1	11892
17047	1174	1713332	1976-11-03	1976-12-01	1	2526
59143	4027	1125315	1974-10-04	1974-10-11	1	1744
52451	3572	1125315	2009-10-11	2009-10-25	1	14542
57411	3917	1112807	1968-08-02	1968-08-30	1	-489
35296	2396	1177480	1997-10-19	1997-12-18	1	10213
57492	3920	1125315	1999-01-16	1999-01-30	1	10621
35600	2418	19127890	1991-08-11	1993-07-31	2	8612
40397	2747	1177480	1990-01-29	1990-02-26	1	7361
48526	3298	1717327	1975-11-22	1975-12-06	1	2165
29405	1989	920293	1997-03-13	1997-03-20	1	9940
64913	4433	1326303	1993-04-10	1993-04-10	1	8500
26355	1781	1119510	2002-10-04	2002-10-11	1	11971
3225	213	1713332	1968-12-30	1969-01-06	1	-360
25498	1727	1110410	1982-03-24	1982-03-25	1	4466
76811	5251	1125315	1954-04-13	1954-04-27	1	-5728
1605	105	1713332	2001-11-17	2001-11-24	1	11650
25910	1755	1125315	1961-10-06	1961-10-20	1	-2995
4822	331	1125315	1999-12-31	2000-01-14	1	10970
17048	1174	1759842	2016-05-05	2016-05-12	1	16933
59144	4027	1177480	1975-05-30	1975-06-13	1	1989
52452	3572	1322184	2014-04-09	2014-04-09	1	16169
57412	3917	1124300	2000-05-21	2000-05-21	1	11098
35297	2396	1322184	1997-03-19	2000-11-08	1	11269
57493	3920	1738521	1974-12-01	1974-12-15	1	1809
35601	2418	920293	1998-09-22	1998-09-29	1	10498
40398	2747	1713332	2001-12-31	2002-01-07	1	11694
48527	3298	1125315	1975-11-22	1975-12-06	1	2165
29406	1989	1125315	1988-10-22	1988-11-28	2	6906
64914	4433	1759842	1941-06-14	1941-06-21	1	-10421
26356	1781	1125315	1957-01-17	1957-01-31	1	-4718
3226	213	1713332	2013-03-27	2013-04-03	1	15798
25499	1727	1125315	1977-02-22	1977-02-22	1	2609
76812	5251	1713332	1961-06-07	1961-06-14	1	-3123
1606	105	1118084	2003-07-17	2003-07-17	1	12250
25911	1755	1125315	1969-09-03	1969-09-10	1	-113
4823	331	1125315	2006-11-20	2006-12-04	1	13486
22847	1551	1125315	1990-04-07	1990-04-28	1	7422
59145	4027	1177480	2006-02-16	2006-03-23	1	13230
52453	3572	1713332	1972-12-24	1972-12-31	1	1095
57413	3917	1305058	2008-08-27	2012-03-09	1	15408
35298	2396	1361711	1989-02-01	2001-02-21	1	11374
61857	4222	1112807	1951-09-21	1951-10-05	1	-6663
35602	2418	933724	1998-09-22	1998-09-29	1	10498
40399	2747	1738521	1976-02-21	1976-03-06	1	2256
48528	3298	1125315	1979-12-06	1979-12-20	1	3640
29407	1989	1174888	1988-10-29	1988-10-29	1	6876
64915	4433	1115008	2014-12-26	2015-01-16	1	16451
26357	1781	1125315	1999-10-11	1999-10-25	1	10889
3227	213	1729720	1967-12-01	1967-12-12	1	-751
25500	1727	1125315	2004-09-10	2004-09-24	1	12685
76813	5251	723013	1922-02-27	1922-05-08	1	-17405
1607	105	1125315	1979-07-28	1979-08-11	1	3509
25912	1755	1125315	1995-12-06	1995-12-27	1	9491
4824	331	1713332	1937-06-27	1937-07-18	1	-11855
22848	1551	1177480	1982-10-02	1982-10-16	1	4671
59146	4027	1192710	1975-02-13	1975-02-13	1	1869
52454	3572	1728416	1958-07-22	1958-08-05	1	-4167
57414	3917	1125315	1970-05-22	1970-06-26	1	176
35299	2396	1759842	1936-04-30	1936-05-21	1	-12278
61858	4222	1119510	1956-03-12	1956-03-19	1	-5036
35603	2418	1729720	1983-04-19	1983-04-26	1	4863
40400	2747	1738521	1978-01-25	1978-02-08	1	2960
48529	3298	1125315	1985-05-04	1985-05-18	1	5616
29408	1989	1177480	1994-05-31	1994-06-14	1	8930
64916	4433	1118084	1982-06-25	1982-06-25	1	4558
26358	1781	1557272	2011-12-06	2011-12-06	1	15314
3228	213	1759842	2013-03-27	2013-04-03	1	15798
25501	1727	1367571	1982-03-24	1982-03-24	1	4465
76814	5251	1118084	1962-03-09	1962-03-09	1	-2855
1608	105	1361711	2000-06-09	2005-11-11	1	13098
25913	1755	1125315	2010-04-21	2010-05-05	1	14734
4825	331	1746114	1997-04-18	1997-04-18	1	9969
22849	1551	1713332	1958-09-15	1958-09-22	1	-4119
59147	4027	1503184	1988-01-02	1988-12-27	1	6935
52455	3572	1118084	1993-08-29	1993-08-29	1	8641
57415	3917	1125315	1974-12-16	1974-12-30	1	1824
35300	2396	1102527	1971-02-08	1971-02-08	1	403
61859	4222	1713332	1998-05-19	1998-05-26	1	10372
35604	2418	1738521	1975-12-23	1976-01-06	1	2196
40401	2747	1759842	2001-12-31	2002-01-07	1	11694
48530	3298	1729720	1972-12-10	1972-12-20	1	1084
29409	1989	1729720	1954-02-05	1954-02-13	1	-5801
64917	4433	1125315	1983-12-27	1984-01-17	1	5129
26359	1781	1759842	2004-07-12	2004-07-19	1	12618
3229	213	1503184	1982-04-22	1984-04-11	2	5214
25502	1727	1746114	1982-03-25	1982-03-25	1	4466
76815	5251	1713332	1970-08-09	1970-08-23	1	234
1609	105	1332418	2000-06-09	2000-06-09	1	11117
25914	1755	1503184	1977-05-23	1978-05-18	1	3059
4826	331	19003953	1997-04-18	1997-04-18	1	9969
22850	1551	1759842	2009-05-30	2009-06-06	1	14401
59148	4027	1503184	1999-10-31	2000-10-25	1	11255
52456	3572	1125315	1980-02-05	1980-03-11	1	3722
57416	3917	1326303	2014-02-27	2014-02-27	1	16128
35301	2396	1112807	1941-04-27	1941-05-11	1	-10462
61860	4222	1728416	1951-03-08	1951-03-22	1	-6860
36209	2462	1124300	2002-02-10	2002-02-10	1	11728
40402	2747	738818	2019-04-30	2019-05-07	1	18023
48531	3298	1729720	1984-06-02	1984-06-13	1	5277
30720	2079	1118084	1991-06-25	1991-06-25	1	7845
64918	4433	1125315	1993-07-04	1993-07-11	1	8592
26360	1781	1759842	2017-04-17	2017-05-01	1	17287
3230	213	1713332	2009-06-23	2009-07-14	1	14439
25503	1727	1759842	1973-06-26	1973-07-17	1	1293
76816	5251	1112807	1935-11-05	1935-11-19	1	-12462
1610	105	1539403	2000-06-09	2000-06-09	1	11117
25915	1755	1503184	1980-05-07	1981-05-02	1	4139
4827	331	19016749	1997-04-18	1997-04-18	1	9969
22851	1551	1124300	1998-08-24	1998-08-24	1	10462
59149	4027	1521369	1995-11-21	1996-11-15	1	9815
52457	3572	1125315	1984-01-20	1984-02-19	2	5162
57417	3917	1713332	1980-12-26	1981-01-16	1	4033
35302	2396	1112807	1954-10-14	1954-11-04	1	-5537
61861	4222	1112807	1951-03-08	1951-03-22	1	-6860
36210	2462	1124957	1997-09-29	1997-09-29	1	10133
40403	2747	1112807	1980-06-29	1980-07-20	1	3853
40705	2765	1149380	2006-10-31	2006-10-31	1	13452
30721	2079	1125315	1967-08-16	1967-08-23	1	-862
64919	4433	1307863	1993-04-10	1993-04-10	1	8500
26361	1781	738818	1966-02-09	1966-02-23	1	-1408
3231	213	1717327	1970-11-11	1970-11-25	1	328
25504	1727	19016749	1982-03-25	1982-03-25	1	4466
76817	5251	1119510	1954-04-13	1954-04-27	1	-5728
1611	105	1759842	2001-11-17	2001-11-24	1	11650
25916	1755	1729720	2000-04-21	2000-04-29	1	11076
4828	331	967823	1997-04-18	1997-04-19	1	9970
22852	1551	1125315	2008-09-20	2008-10-11	1	14163
59150	4027	1713332	1974-05-11	1974-05-18	1	1598
52458	3572	1177480	2010-01-01	2010-01-15	1	14624
57418	3917	1759842	2008-07-09	2008-07-30	1	14090
35303	2396	1125315	1986-03-06	1986-03-20	1	5922
61862	4222	1118084	1987-01-28	1987-01-28	1	6236
36211	2462	1125315	2008-06-11	2008-06-18	1	14048
40404	2747	1115008	2007-02-27	2007-03-13	1	13585
40706	2765	1322184	2005-01-11	2005-01-11	1	12794
30722	2079	1125315	2002-07-03	2002-07-17	1	11885
64920	4433	1713332	1941-06-14	1941-06-21	1	-10421
26362	1781	738818	2002-10-04	2002-10-11	1	11971
3232	213	1759842	1968-12-30	1969-01-06	1	-360
25600	1737	738818	1993-03-21	1993-04-04	1	8494
76818	5251	1759842	1961-06-07	1961-06-14	1	-3123
2004	133	1118084	2019-03-26	2019-03-26	1	17981
25917	1755	1759842	1975-04-19	1975-05-03	1	1948
4829	331	1112807	1936-10-23	1936-11-06	1	-12109
22853	1551	1322184	2018-03-12	2018-03-12	1	17602
59151	4027	1125315	2012-03-21	2012-04-11	1	15441
52459	3572	1713332	2010-01-01	2010-01-15	1	14624
57419	3917	1115008	2008-08-27	2012-03-09	1	15408
35304	2396	1125315	2001-02-21	2001-02-21	1	11374
61863	4222	1728416	1951-09-21	1951-10-05	1	-6663
36212	2462	1177480	1997-09-29	1997-11-03	1	10168
40405	2747	1124300	2009-11-14	2009-11-14	1	14562
40707	2765	1322184	2016-09-20	2016-09-20	1	17064
30723	2079	1728416	1957-03-10	1957-03-24	1	-4666
64921	4433	1713332	1994-07-03	1994-07-24	1	8970
26363	1781	1112807	1944-01-11	1944-01-25	1	-9473
3233	213	19127890	1982-04-22	1984-04-11	2	5214
25601	1737	1118084	1950-07-04	1950-07-04	1	-7121
76819	5251	1112807	1923-03-24	1923-04-14	1	-17064
2005	133	1177480	1988-11-03	1988-11-17	1	6895
25918	1755	19127890	1985-04-19	1985-09-11	1	5732
4830	331	1119510	1999-12-31	2000-01-14	1	10970
22854	1551	1332418	2018-03-12	2018-03-12	1	17602
59152	4027	1515774	1992-12-06	1993-12-01	1	8735
52460	3572	1728416	1956-11-16	1956-11-30	1	-4780
57420	3917	1125315	1972-10-10	1972-10-24	1	1027
35305	2396	1177480	2000-09-03	2000-10-03	1	11233
61864	4222	920293	1970-07-05	1970-07-12	1	192
36213	2462	1713332	2009-08-17	2009-09-07	1	14494
40406	2747	1125315	1974-03-05	1974-03-19	1	1538
40708	2765	1347450	2005-01-11	2005-01-11	1	12794
30724	2079	1125315	1989-05-21	1989-05-28	1	7087
64922	4433	1759842	1994-07-03	1994-07-24	1	8970
26364	1781	1115008	2009-11-24	2009-12-08	1	14586
3234	213	1115008	2015-11-04	2015-11-25	1	16764
25602	1737	1125315	1972-05-02	1972-05-09	1	859
76820	5251	1112807	1931-10-27	1931-12-26	1	-13886
2006	133	1125315	2010-08-11	2010-08-25	1	14846
25919	1755	738818	2010-04-21	2010-05-05	1	14734
4831	331	1125315	1968-01-10	1968-01-24	1	-708
22855	1551	1125315	1958-07-12	1958-07-19	1	-4184
59153	4027	1515774	1996-11-15	1997-11-10	1	10175
52461	3572	1729720	1970-12-04	1970-12-13	1	346
57421	3917	1125315	1980-12-30	1981-01-27	1	4044
35306	2396	920293	1971-12-19	1971-12-26	1	724
61865	4222	933724	1970-07-05	1970-07-12	1	192
36214	2462	1125315	2011-10-24	2011-10-31	1	15278
40407	2747	1125315	2019-04-30	2019-05-07	1	18023
40709	2765	1347450	2016-09-20	2016-09-20	1	17064
30725	2079	1125315	1978-06-18	1978-07-09	1	3111
64923	4433	1112807	1940-02-11	1940-02-25	1	-10903
26365	1781	1119510	1961-01-27	1961-02-03	1	-3254
3235	213	1125315	1988-05-10	1988-05-24	1	6718
25603	1737	1125315	1993-03-21	1993-04-04	1	8494
76821	5251	1112807	1933-11-15	1933-12-15	1	-13166
2007	133	1729720	2002-11-06	2002-11-13	1	12004
25920	1755	1115008	2018-10-16	2018-10-30	1	17834
4832	331	1759842	1969-08-18	1969-09-01	1	-122
22856	1551	1125315	1996-12-05	1996-12-19	1	9849
59154	4027	1521369	1988-01-02	1988-12-27	1	6935
52462	3572	1738521	1969-10-02	1969-10-16	1	-77
57422	3917	1125315	1994-01-20	1994-02-03	1	8799
35307	2396	933724	1971-12-19	1971-12-26	1	724
61866	4222	1759842	1998-05-19	1998-05-26	1	10372
36215	2462	975125	1988-10-12	1988-10-12	1	6859
40408	2747	1177480	1976-02-21	1976-03-06	1	2256
40710	2765	1729720	1956-07-26	1956-08-03	1	-4899
30726	2079	1125315	2005-11-01	2005-11-08	1	13095
64924	4433	1112807	1943-07-25	1943-08-08	1	-9643
26366	1781	1125315	1966-02-09	1966-02-23	1	-1408
3236	213	1125315	1993-06-27	1993-08-01	1	8613
25604	1737	1332418	1994-04-08	1994-04-08	1	8863
76822	5251	1729720	1933-01-04	1933-01-11	1	-13504
2008	133	1778162	1988-11-03	1988-11-17	1	6895
25921	1755	1503184	1975-06-03	1976-05-28	1	2339
4833	331	708298	1997-04-18	1997-04-18	1	9969
22857	1551	1125315	2001-12-07	2001-12-21	1	11677
59155	4027	1713332	2011-06-18	2011-07-09	1	15164
52463	3572	1759842	1958-01-15	1958-01-22	1	-4362
57423	3917	1310149	2014-02-27	2014-02-27	1	16128
35308	2396	1112807	1946-01-15	1946-01-29	1	-8738
61867	4222	738818	1956-03-12	1956-03-19	1	-5036
36216	2462	1112807	1964-09-22	1964-10-06	1	-1913
40409	2747	1177480	1978-01-25	1978-02-08	1	2960
40711	2765	1759842	1935-09-20	1935-10-11	1	-12501
30727	2079	1177480	2008-01-17	2008-02-07	1	13916
64925	4433	1125315	1981-11-16	1981-12-07	1	4358
26367	1781	1125315	2002-10-04	2002-10-11	1	11971
3237	213	1125315	2013-10-01	2013-10-15	1	15993
25605	1737	1125315	2001-02-01	2001-02-15	1	11368
76823	5251	1759842	1970-08-09	1970-08-23	1	234
2009	133	1713332	2001-05-08	2001-05-22	1	11464
25922	1755	1503184	1985-04-19	1985-09-11	1	5732
4834	331	1118084	1974-11-08	1974-11-08	1	1772
22858	1551	1361711	2018-03-12	2018-03-12	1	17602
59156	4027	1728416	1975-05-30	1975-06-13	1	1989
52464	3572	1759842	2005-01-11	2005-01-18	1	12801
57424	3917	1738521	1972-10-10	1972-10-24	1	1027
35309	2396	1124300	1961-08-30	1961-08-30	1	-3046
61868	4222	1125315	1956-03-12	1956-03-19	1	-5036
36217	2462	1717327	1964-09-22	1964-10-06	1	-1913
40410	2747	1729720	1995-09-30	1995-10-10	1	9413
40712	2765	1112807	1946-11-15	1947-02-13	1	-8358
30728	2079	1177480	2016-03-26	2016-04-23	1	16914
64926	4433	1125315	2015-12-12	2016-03-11	1	16871
26368	1781	1713332	1983-02-13	1983-02-20	1	4798
3852	262	705944	1978-07-31	1982-08-09	1	4603
25606	1737	1322184	1997-04-25	2013-10-11	1	15989
46910	3181	1149380	2001-06-22	2001-06-22	1	11495
2010	133	1759842	2001-05-08	2001-05-22	1	11464
25923	1755	19127890	1975-06-03	1976-05-28	1	2339
4835	331	1119510	2004-03-27	2004-04-03	1	12511
22859	1551	1539403	2018-03-12	2018-03-12	1	17602
59157	4027	1759842	1974-05-11	1974-05-18	1	1598
52465	3572	1112807	1956-11-16	1956-11-30	1	-4780
57425	3917	1738521	1974-12-16	1974-12-30	1	1824
35310	2396	1125315	1959-01-25	1959-02-01	1	-3987
61869	4222	1177480	1998-07-29	1998-08-26	1	10464
36218	2462	1729720	1966-10-27	1966-11-06	1	-1152
40692	2765	738818	1989-04-07	1989-04-14	1	7043
40713	2765	1112807	1949-11-29	1949-12-27	1	-7310
30729	2079	1125315	1957-03-10	1957-03-24	1	-4666
64927	4433	1177480	2002-12-08	2002-12-29	1	12050
26369	1781	1729720	1941-08-11	1941-08-19	1	-10362
3853	262	1729720	1974-10-24	1974-11-01	1	1765
25607	1737	1322184	2014-04-25	2014-04-25	1	16185
46911	3181	1713332	1989-12-10	1989-12-31	1	7304
2011	133	1729720	1990-05-31	1990-06-10	1	7465
25924	1755	19127890	1977-05-23	1978-05-18	1	3059
4836	331	1367571	1997-04-18	1997-04-18	1	9969
22860	1551	1713332	2009-05-30	2009-06-06	1	14401
59158	4027	1759842	2011-06-18	2011-07-09	1	15164
52466	3572	1112807	1959-02-23	1959-03-09	1	-3951
59492	4055	738818	2013-12-23	2014-01-06	1	16076
35311	2396	1174888	2001-02-21	2001-02-21	1	11374
63264	4324	1112807	1967-01-30	1967-02-13	1	-1053
36219	2462	1759842	2009-08-17	2009-09-07	1	14494
40693	2765	1112807	1938-04-24	1938-05-08	1	-11561
40714	2765	1119510	1949-06-04	1949-06-18	1	-7502
30730	2079	1125315	1970-05-25	1970-06-01	1	151
71101	4855	920293	2004-10-01	2004-10-08	1	12699
26370	1781	1759842	1983-02-13	1983-02-20	1	4798
3854	262	1115008	2005-05-30	2005-06-13	1	12947
25608	1737	1347450	2013-10-11	2013-10-11	1	15989
46912	3181	738818	1994-12-27	1995-01-10	1	9140
6383	442	701322	2017-11-24	2017-11-24	1	17494
25925	1755	19127890	1980-05-07	1981-05-02	1	4139
4837	331	1741122	1997-04-18	1997-04-18	1	9969
22861	1551	1125315	1979-08-19	1979-11-17	1	3607
59159	4027	19127890	1995-11-21	1998-11-05	3	10535
52467	3572	1124957	1984-01-20	1984-01-20	1	5132
59493	4055	1119510	2013-12-23	2014-01-06	1	16076
35312	2396	1308738	1995-10-31	1995-10-31	1	9434
63265	4324	738818	2016-07-17	2016-07-31	1	17013
36220	2462	1778162	1997-09-29	1997-11-03	1	10168
40694	2765	1118084	1974-06-26	1974-06-26	1	1637
40715	2765	1125315	1952-12-11	1953-01-01	1	-6209
30731	2079	1125315	1975-12-28	1976-01-11	1	2201
71102	4855	933724	2005-11-03	2005-11-10	1	13097
26371	1781	1125315	2009-11-17	2009-12-01	1	14579
3855	262	1118084	1999-12-13	1999-12-13	1	10938
25609	1737	1361711	1970-11-13	1970-11-13	1	316
46913	3181	1112807	1964-11-04	1964-11-25	1	-1863
6384	442	738818	2011-05-28	2011-06-11	1	15136
25926	1755	914335	2015-08-26	2015-08-26	1	16673
4838	331	738818	2004-03-27	2004-04-03	1	12511
22862	1551	1713332	1983-10-17	1983-11-07	1	5058
59160	4027	19127890	1999-10-31	2000-10-25	1	11255
52468	3572	1347450	2014-04-09	2014-04-09	1	16169
59494	4055	1125315	2013-12-23	2014-01-06	1	16076
35313	2396	1322184	2001-02-21	2001-02-21	1	11374
63266	4324	975125	1981-06-15	1981-06-15	1	4183
36221	2462	1115008	2018-08-15	2018-09-12	1	17786
40695	2765	1125315	1978-01-18	1978-02-01	1	2953
40716	2765	1125315	1960-02-24	1960-03-23	1	-3571
31836	2153	1112807	1972-04-17	1972-05-22	1	872
71103	4855	1125315	1982-11-19	1982-12-03	1	4719
26372	1781	1713332	1950-01-30	1950-02-06	1	-7269
3856	262	1713332	1980-10-16	1980-11-06	1	3962
25610	1737	1539403	1991-08-30	1991-08-30	1	7911
46914	3181	1115008	2018-11-15	2019-02-13	1	17940
6385	442	1119510	2011-05-28	2011-06-11	1	15136
25927	1755	1112807	1960-07-11	1960-08-15	1	-3426
4839	331	782043	1997-04-18	1997-04-18	1	9969
22863	1551	1759842	1958-09-15	1958-09-22	1	-4119
59161	4027	1119510	1974-10-04	1974-10-11	1	1744
52469	3572	1713332	1958-01-15	1958-01-22	1	-4362
59495	4055	1112807	1970-07-29	1970-08-12	1	223
35314	2396	1332418	1994-03-02	1994-03-02	1	8826
63267	4324	1112807	1963-08-30	1963-09-13	1	-2302
36222	2462	1125315	1966-01-17	1966-01-24	1	-1438
40696	2765	1125315	1989-04-07	1989-04-14	1	7043
40717	2765	1125315	1984-06-10	1984-06-24	1	5288
31837	2153	1125315	1981-06-30	1981-07-07	1	4205
71104	4855	1515774	1993-08-27	1994-08-22	1	8999
26373	1781	1713332	1952-03-24	1952-03-31	1	-6485
3857	262	1713332	2016-12-16	2016-12-30	1	17165
25611	1737	1729720	1918-08-19	1918-08-27	1	-18755
46915	3181	1125315	1951-10-14	1951-10-28	1	-6640
6386	442	1125315	1964-02-27	1964-03-12	1	-2121
25928	1755	1125315	2001-11-25	2001-12-30	1	11686
4840	331	1000560	1997-04-18	1997-04-18	2	9969
22864	1551	1759842	1983-10-17	1983-11-07	1	5058
59162	4027	1124300	2008-04-16	2008-04-16	1	13985
53878	3666	1125315	1979-12-16	1979-12-30	1	3650
59496	4055	1125315	1970-05-01	1970-05-15	1	134
35315	2396	1545958	2001-02-21	2001-02-21	1	11374
63268	4324	1125315	1981-08-26	1981-09-02	1	4262
36223	2462	1125315	1989-09-19	1989-10-03	1	7215
40697	2765	1137529	2006-10-31	2006-10-31	1	13452
40718	2765	1322184	2018-05-22	2018-05-22	1	17673
31838	2153	1177480	1992-09-18	1992-10-09	1	8317
71105	4855	1728416	1978-06-07	1978-06-21	1	3093
26374	1781	1713332	2004-07-12	2004-07-19	1	12618
3858	262	1759842	1980-10-16	1980-11-06	1	3962
25612	1737	1112807	1923-01-22	1923-02-26	1	-17111
46916	3181	1125315	1994-12-27	1995-01-10	1	9140
6387	442	1125315	1971-07-06	1971-07-20	1	565
25929	1755	1521369	1975-06-03	1976-05-28	1	2339
4841	331	1112807	1942-09-22	1942-10-29	1	-9926
24528	1657	1112807	1946-06-24	1946-07-08	1	-8578
59163	4027	1125315	2002-06-26	2002-07-03	1	11871
53879	3666	1125315	1991-08-22	1991-09-05	1	7917
59497	4055	1115008	1997-06-28	1997-07-12	1	10054
35316	2396	1713332	1936-04-30	1936-05-21	1	-12278
63269	4324	1125315	2010-11-01	2010-11-08	1	14921
36224	2462	1125315	1997-09-29	1997-09-29	1	10133
40698	2765	738818	1949-06-04	1949-06-18	1	-7502
40719	2765	1347450	2018-05-22	2018-05-22	1	17673
31839	2153	1503184	1982-11-01	1983-10-27	1	5047
71106	4855	933724	2004-10-01	2004-10-08	1	12699
26375	1781	1713332	2017-04-17	2017-05-01	1	17287
3859	262	1759842	2016-12-16	2016-12-30	1	17165
25613	1737	1125315	1912-10-17	1912-10-24	1	-20888
46917	3181	1154343	1953-09-20	1953-09-20	1	-5947
6388	442	1125315	2011-05-28	2011-06-11	1	15136
25930	1755	1521369	1977-05-23	1978-05-18	1	3059
4842	331	1112807	1948-08-28	1948-10-02	1	-7761
24529	1657	1112807	1949-09-19	1949-10-03	1	-7395
59164	4027	1309944	2014-06-21	2014-06-21	1	16242
53880	3666	1125315	2013-06-02	2013-06-23	1	15879
59498	4055	1125315	1980-01-08	1980-01-29	1	3680
35317	2396	1729720	1934-03-09	1934-03-16	1	-13075
63270	4324	1150770	1981-06-30	1981-06-30	1	4198
38458	2616	1125315	1974-06-29	1974-07-13	1	1654
40699	2765	757627	2016-12-27	2016-12-27	1	17162
40720	2765	1713332	1935-09-20	1935-10-11	1	-12501
31840	2153	1503184	1986-10-11	1987-10-06	1	6487
71107	4855	1118084	2014-07-23	2014-07-23	1	16274
29234	1980	738818	1975-07-07	1975-07-21	1	2027
3860	262	1125315	1967-03-21	1967-06-19	1	-927
25614	1737	1125315	1941-08-31	1941-09-14	1	-10336
46918	3181	1551099	1959-05-06	1959-05-06	1	-3893
6389	442	1129625	1980-09-11	1980-09-11	1	3906
25931	1755	1521369	1980-05-07	1981-05-02	1	4139
4843	331	1125315	1998-05-31	1998-06-07	1	10384
24530	1657	1115008	2013-01-12	2013-04-12	1	15807
59165	4027	1343916	2014-06-21	2014-06-21	1	16242
53881	3666	1125315	1971-10-30	1971-11-06	1	674
59499	4055	1118084	2007-02-20	2007-02-20	1	13564
35318	2396	1112807	1923-06-20	1923-07-04	1	-16983
63271	4324	1713332	2015-10-10	2015-10-24	1	16732
38459	2616	1125315	1987-04-24	1987-05-08	1	6336
40700	2765	1115008	2016-12-06	2017-01-03	1	17169
40721	2765	701322	2018-05-21	2018-05-21	1	17672
31841	2153	1521369	1986-10-11	1987-10-06	1	6487
71108	4855	1125315	1982-04-30	1982-05-14	1	4516
29235	1980	1102527	1988-07-02	1988-07-02	1	6757
5388	368	1125315	1982-03-12	1982-03-26	1	4467
25615	1737	1125315	1958-10-18	1958-11-22	1	-4058
46919	3181	1728416	1951-10-14	1951-10-28	1	-6640
6390	442	1729720	1955-06-29	1955-07-11	1	-5288
25932	1755	1713332	1975-04-19	1975-05-03	1	1948
4844	331	1125315	2004-03-27	2004-04-03	1	12511
24531	1657	1125315	2008-01-09	2008-03-09	1	13947
59166	4027	1515774	1989-12-22	1990-12-17	1	7655
53882	3666	1729720	1972-05-27	1972-06-06	1	887
59500	4055	1125315	1979-09-29	1979-10-06	1	3565
35319	2396	1125315	1967-09-19	1967-10-03	1	-821
63272	4324	1729720	1961-08-12	1961-08-19	1	-3057
38460	2616	1177480	1996-02-23	1996-03-22	1	9577
40701	2765	1119510	1989-04-07	1989-04-14	1	7043
40722	2765	715997	2018-05-21	2018-05-21	1	17672
31842	2153	1521369	1988-09-30	1989-09-25	1	7207
71109	4855	1177480	1987-02-20	1987-03-22	1	6289
29236	1980	1119510	2006-01-23	2006-02-06	1	13185
5389	368	1729720	2008-04-30	2008-05-07	1	14006
25616	1737	1177480	2000-10-12	2000-11-11	1	11272
46920	3181	1115008	2001-05-27	2001-06-17	1	11490
6391	442	757627	2016-07-02	2016-07-02	1	16984
25933	1755	1112807	1967-05-11	1967-06-08	1	-938
4845	331	1713332	1969-08-18	1969-09-01	1	-122
24532	1657	1309944	1998-04-22	1998-04-22	1	10338
59167	4027	1549786	1989-12-22	1990-12-17	1	7655
53883	3666	1118084	2000-11-05	2000-11-05	1	11266
60397	4117	1118084	1996-05-29	1996-05-29	1	9645
35320	2396	1125315	1971-02-08	1971-05-09	1	493
63273	4324	1118084	1999-07-27	1999-07-27	1	10799
38461	2616	1125315	1953-09-17	1953-10-01	1	-5936
40702	2765	1125315	1949-06-04	1949-06-18	1	-7502
40723	2765	1112807	1937-06-05	1937-06-19	1	-11884
31843	2153	1125315	1975-02-06	1975-02-20	1	1876
71110	4855	1177480	2018-08-06	2018-08-20	1	17763
29237	1980	1124300	2013-06-22	2013-06-22	1	15878
5390	368	1713332	1997-11-16	1997-11-23	1	10188
25617	1737	1729720	1922-12-08	1922-12-20	1	-17179
46921	3181	1125315	1966-12-25	1967-01-01	1	-1096
6392	442	975125	1980-08-24	1980-08-24	1	3888
25934	1755	1125315	1990-08-22	1990-09-05	1	7552
4846	331	1759842	1937-06-27	1937-07-18	1	-11855
24533	1657	914335	1998-04-22	1998-04-22	1	10338
59168	4027	1549786	1992-12-06	1993-12-01	1	8735
53884	3666	1125315	1962-09-16	1962-09-30	1	-2650
60398	4117	1125315	1964-05-07	1964-05-21	1	-2051
35321	2396	1347450	2000-11-08	2000-11-08	1	11269
63274	4324	1119510	2016-07-17	2016-07-31	1	17013
38462	2616	1125315	1954-11-28	1954-12-12	1	-5499
40703	2765	1125315	1993-04-13	1993-04-27	1	8517
40724	2765	1125315	1978-07-18	1978-08-01	1	3134
31844	2153	1503184	1988-09-30	1989-09-25	1	7207
71111	4855	1503184	1992-09-01	1993-08-27	1	8639
29238	1980	1125315	1975-07-07	1975-07-21	1	2027
5391	368	1759842	1997-11-16	1997-11-23	1	10188
25618	1737	1112807	1952-12-20	1953-01-17	1	-6193
46922	3181	1125315	1989-04-09	1989-04-30	1	7059
6393	442	1115008	1997-05-28	1997-07-02	1	10044
25935	1755	1125315	2006-05-27	2006-06-10	1	13309
12065	830	1112807	1961-04-14	1961-04-28	1	-3170
24534	1657	1112807	1944-02-27	1944-03-12	1	-9426
59169	4027	1729720	1976-08-25	1976-09-03	1	2437
53885	3666	1177480	1979-10-08	1979-10-29	1	3588
60399	4117	1177480	1997-05-14	1997-06-18	1	10030
35322	2396	1539403	1991-02-13	1991-02-13	1	7713
63275	4324	1717327	1967-01-30	1967-02-13	1	-1053
38463	2616	1728416	1953-09-17	1953-10-01	1	-5936
40704	2765	1125315	1998-01-31	1998-02-14	1	10271
40725	2765	1125315	1994-08-17	1994-08-31	1	9008
31845	2153	1728416	1966-09-16	1966-09-30	1	-1189
71112	4855	1521369	1992-09-01	1993-08-27	1	8639
29239	1980	1125315	1982-03-22	1982-06-20	1	4553
5392	368	738818	2008-10-22	2008-11-05	1	14188
25619	1737	1119510	1993-03-21	1993-04-04	1	8494
46923	3181	1129625	1956-10-03	1956-10-03	1	-4838
6394	442	1177480	2010-02-24	2010-03-24	1	14692
25936	1755	1125315	2008-07-26	2008-08-09	1	14100
12066	830	1112807	1970-08-30	1970-09-20	1	262
24535	1657	1125315	2014-02-06	2014-02-20	1	16121
59170	4027	19127890	1992-12-06	1993-12-01	1	8735
53886	3666	1125315	1965-08-31	1965-09-21	1	-1563
60400	4117	1729720	1964-05-10	1964-05-19	1	-2053
36444	2480	1112807	1961-03-24	1961-04-07	1	-3191
63276	4324	1759842	2015-10-10	2015-10-24	1	16732
38464	2616	1728416	1954-11-28	1954-12-12	1	-5499
3651	246	1118084	2000-06-03	2000-06-03	1	11111
40726	2765	1729720	2013-07-08	2013-07-15	1	15901
31846	2153	19127890	1982-11-01	1983-10-27	1	5047
71113	4855	1549786	1993-08-27	1994-08-22	1	8999
29240	1980	1177480	1983-04-16	1983-04-30	1	4867
5393	368	1118084	2004-11-16	2004-11-16	1	12738
25620	1737	1713332	1935-07-12	1935-08-02	1	-12571
46924	3181	1759842	1989-12-10	1989-12-31	1	7304
6395	442	715997	2017-11-24	2017-11-24	1	17494
25937	1755	1309944	2015-08-26	2015-08-26	1	16673
12067	830	1125315	1984-12-30	1985-01-06	1	5484
24536	1657	1343916	1998-04-22	1998-04-22	1	10338
59378	4045	1119510	1988-02-25	1988-03-03	1	6636
55598	3784	1112807	1949-08-27	1949-09-17	1	-7411
60401	4117	1713332	1967-09-25	1967-10-09	1	-815
36445	2480	1112807	1964-05-05	1964-05-19	1	-2053
63277	4324	1125315	1980-07-31	1980-08-21	1	3885
38465	2616	1118084	1987-12-08	1987-12-08	1	6550
3652	246	1125315	2011-08-12	2011-08-26	1	15212
41992	2846	1125315	1984-02-07	1984-02-21	1	5164
31847	2153	1124300	2006-03-30	2006-03-30	1	13237
71114	4855	920293	2005-11-03	2005-11-10	1	13097
29241	1980	1177480	2014-05-31	2014-06-14	1	16235
5394	368	1125315	2008-10-22	2008-11-05	1	14188
25621	1737	1759842	1935-07-12	1935-08-02	1	-12571
47164	3201	738818	1958-08-25	1958-09-01	1	-4140
6396	442	1124300	1985-09-02	1985-09-02	1	5723
25938	1755	1343916	2015-08-26	2015-08-26	1	16673
12068	830	1112807	1965-11-19	1965-12-24	1	-1469
24537	1657	1759842	1985-02-23	1985-03-09	1	5546
59379	4045	1125315	1982-03-07	1982-03-21	1	4462
55599	3784	1112807	1972-03-18	1972-04-01	1	821
60402	4117	1125315	1998-11-05	1998-11-12	1	10542
36446	2480	1115008	1988-10-24	1988-10-24	1	6871
63278	4324	1125315	2016-07-17	2016-07-31	1	17013
38466	2616	1125315	1955-08-01	1955-08-15	1	-5253
3653	246	1149380	2000-09-07	2000-09-07	1	11207
41993	2846	1728416	1977-10-11	1977-10-25	1	2854
31848	2153	1125315	1966-09-16	1966-09-30	1	-1189
71115	4855	1177480	1978-06-07	1978-06-21	1	3093
29242	1980	1521369	1986-09-07	1987-09-02	1	6453
5395	368	1729720	1990-09-29	1990-10-06	1	7583
28012	1900	738818	2017-08-26	2017-09-02	1	17411
47165	3201	920293	1968-09-08	1968-09-15	1	-473
6397	442	1125315	1974-12-18	1974-12-25	1	1819
25939	1755	1521369	1985-04-19	1985-09-11	1	5732
12069	830	1125315	1962-06-22	1962-07-06	1	-2736
24538	1657	1102527	2013-01-12	2013-01-12	1	15717
59380	4045	1759842	1984-11-23	1984-12-14	1	5461
55600	3784	1125315	1951-06-10	1951-06-17	1	-6773
60403	4117	1125315	2011-09-03	2011-10-01	1	15248
36447	2480	1118084	1991-06-16	1991-06-16	1	7836
63279	4324	1717327	1963-08-30	1963-09-13	1	-2302
38467	2616	1125315	1975-08-07	1975-09-11	1	2079
3654	246	1177480	1981-06-06	1981-06-27	1	4195
41994	2846	920293	2016-07-26	2016-08-09	2	17022
31849	2153	1125315	1996-08-18	1996-08-25	1	9733
71116	4855	1713332	1982-04-30	1982-05-14	1	4516
29243	1980	1729720	1976-11-19	1976-11-28	1	2523
5396	368	1119510	2008-10-22	2008-11-05	1	14188
28013	1900	1125315	2017-08-26	2017-09-02	1	17411
47166	3201	933724	1968-09-08	1968-09-15	1	-473
6398	442	1728416	1952-02-28	1952-03-13	1	-6503
28309	1918	738818	1985-04-29	1985-05-13	1	5611
12070	830	1728416	1962-06-22	1962-07-06	1	-2736
24539	1657	1125315	1953-04-24	1953-06-23	1	-6036
59381	4045	1768849	1980-01-28	1980-02-11	1	3693
55601	3784	1125315	1979-01-01	1979-01-08	1	3294
60404	4117	1125315	2012-06-30	2012-07-07	1	15528
36448	2480	1551099	1988-10-24	1988-11-14	1	6892
66224	4525	1124300	2007-08-04	2007-08-04	1	13729
38468	2616	1125315	2017-04-01	2017-04-29	1	17285
3655	246	1112807	1961-11-15	1962-01-14	1	-2909
41995	2846	1115008	1996-12-28	1997-02-01	1	9893
31850	2153	19127890	1986-10-11	1987-10-06	1	6487
71117	4855	1713332	2005-11-03	2005-11-24	1	13111
29244	1980	1115008	2005-04-04	2005-04-18	1	12891
6040	412	1118084	1993-09-22	1993-09-22	1	8665
28014	1900	1759842	1979-12-18	1979-12-25	1	3645
47167	3201	1118084	1976-07-25	1976-07-25	1	2397
6399	442	1112807	1952-02-28	1952-03-13	1	-6503
28310	1918	1125315	1985-04-29	1985-05-13	1	5611
12071	830	1125315	1973-07-12	1973-07-19	1	1295
24540	1657	1125315	1994-02-20	1994-02-27	1	8823
59382	4045	1125315	1974-08-15	1974-08-29	1	1701
55602	3784	1137529	1983-07-26	1983-07-26	1	4954
60405	4117	1717327	1964-05-07	1964-05-21	1	-2051
36449	2480	1717327	1964-05-05	1964-05-19	1	-2053
66225	4525	1713332	1985-10-30	1985-11-20	1	5802
38469	2616	1125315	2018-12-10	2018-12-24	1	17889
3656	246	1125315	1980-06-27	1980-07-11	1	3844
41996	2846	1125315	1978-03-26	1978-04-09	1	3020
31851	2153	19127890	1988-09-30	1989-09-25	1	7207
71118	4855	1729720	1984-11-03	1984-11-14	1	5431
29245	1980	1119510	1984-08-31	1984-09-14	1	5370
6041	412	1125315	1963-03-13	1963-06-11	1	-2396
28015	1900	19127890	1978-09-28	1979-09-23	1	3552
47168	3201	1125315	1958-08-25	1958-09-01	1	-4140
6400	442	1125315	1951-06-03	1951-07-01	1	-6759
28311	1918	1729720	1998-01-15	1998-01-28	1	10254
12072	830	1125315	1981-09-22	1981-10-06	1	4296
24541	1657	1713332	1985-02-23	1985-03-09	1	5546
59383	4045	1125315	1980-01-28	1980-02-11	1	3693
55603	3784	1501700	1984-06-24	1984-06-24	1	5288
60406	4117	1759842	1967-09-25	1967-10-09	1	-815
36450	2480	1728416	1957-11-06	1957-11-20	1	-4425
66226	4525	1729720	1984-05-19	1984-05-28	1	5261
38470	2616	1728416	1955-08-01	1955-08-15	1	-5253
3657	246	1125315	2003-05-23	2003-06-06	1	12209
41997	2846	1125315	1979-12-30	1980-03-29	1	3740
31852	2153	1521369	1982-11-01	1983-10-27	1	5047
71119	4855	1759842	2005-11-03	2005-11-24	1	13111
29246	1980	1129625	1975-10-01	1975-10-01	1	2099
6042	412	1125315	1965-06-30	1965-07-21	1	-1625
28016	1900	738818	1971-12-26	1972-01-09	1	738
47169	3201	1759842	1980-07-18	1980-07-25	1	3858
6401	442	1125315	1989-12-08	1989-12-22	1	7295
28312	1918	1115008	2018-08-21	2018-09-11	1	17785
12073	830	1717327	1961-04-14	1961-04-28	1	-3170
24542	1657	1728416	1949-09-19	1949-10-03	1	-7395
59384	4045	1125315	1988-02-25	1988-03-03	1	6636
55604	3784	920293	1948-08-08	1948-08-15	1	-7809
60407	4117	1112807	1965-04-16	1965-04-30	1	-1707
36451	2480	1759842	1968-10-12	1968-11-02	1	-425
66227	4525	1729720	2013-11-06	2013-11-19	1	16028
3658	246	1125315	2018-03-15	2018-04-05	1	17626
41998	2846	1177480	1990-04-20	1990-05-04	1	7428
33734	2291	1124300	1997-05-22	1997-05-22	1	10003
71120	4855	19127890	1992-09-01	1994-08-22	2	8999
29247	1980	1503184	1986-09-07	1987-09-02	1	6453
6043	412	1125315	2004-02-18	2004-03-03	1	12480
28017	1900	1125315	1971-12-26	1972-01-09	1	738
47170	3201	1102527	1953-06-19	1953-06-19	1	-6040
6402	442	1125315	1992-08-08	1992-08-22	1	8269
28313	1918	1119510	1982-01-30	1982-02-13	1	4426
12074	830	1729720	2016-09-21	2016-09-30	1	17074
24543	1657	1112807	1947-09-09	1947-09-23	1	-8136
59385	4045	1728416	1974-08-15	1974-08-29	1	1701
55605	3784	933724	1948-08-08	1948-08-15	1	-7809
60408	4117	1125315	1980-03-16	1980-03-23	1	3734
36452	2480	1125315	1957-11-06	1957-11-20	1	-4425
66228	4525	1738521	1969-10-22	1969-11-05	1	-57
3659	246	1154343	1963-12-02	1963-12-02	1	-2222
41999	2846	1759842	1999-09-19	1999-10-10	1	10874
33735	2291	1125315	1971-02-18	1971-04-26	1	480
71121	4855	1713332	1982-11-19	1982-12-03	1	4719
29248	1980	1521369	1992-08-06	1993-08-01	1	8613
6044	412	1125315	1955-08-20	1955-09-03	1	-5234
28018	1900	1125315	1980-01-04	1980-01-11	1	3662
47171	3201	1112807	1941-03-26	1941-05-23	2	-10466
6403	442	1713332	1992-04-19	1992-05-03	1	8158
28314	1918	1125315	1984-06-01	1984-06-15	1	5279
12075	830	1118084	1995-08-04	1995-08-04	1	9346
24544	1657	1124300	1987-02-01	1987-02-01	1	6240
59386	4045	1729720	2003-03-19	2003-03-27	1	12138
55606	3784	1124300	1965-02-14	1965-02-14	1	-1782
62112	4239	1112807	1951-09-10	1951-10-08	1	-6660
36453	2480	1713332	1968-10-12	1968-11-02	1	-425
66229	4525	1759842	1985-10-30	1985-11-20	1	5802
3660	246	1729720	1964-09-13	1964-09-26	1	-1923
42000	2846	1112807	1973-07-20	1973-08-03	1	1310
33736	2291	1125315	1977-12-20	1978-02-18	1	2970
75264	5150	1125315	1970-11-01	1970-11-15	1	318
29249	1980	1125315	1985-03-22	1985-04-05	1	5573
6045	412	1125315	1961-04-17	1961-05-22	1	-3146
28019	1900	1118084	1995-11-18	1995-11-18	1	9452
47172	3201	1112807	1953-06-19	1953-07-19	1	-6010
6404	442	1759842	1992-04-19	1992-05-03	1	8158
28315	1918	1713332	1982-02-02	1982-02-16	1	4429
12076	830	1713332	1985-08-18	1985-09-01	1	5722
24545	1657	1125315	1966-02-15	1966-03-22	1	-1381
59387	4045	1118084	2015-04-27	2015-04-27	1	16552
55607	3784	1125315	1937-05-04	1937-05-18	1	-11916
62113	4239	1112807	1958-02-03	1958-05-04	1	-4260
36454	2480	1728416	1957-01-25	1957-02-08	1	-4710
66230	4525	1125315	1969-10-22	1969-11-05	1	-57
3661	246	1759842	2001-03-31	2001-04-07	1	11419
42001	2846	1125315	1977-10-11	1977-10-25	1	2854
33737	2291	1125315	2018-12-19	2018-12-26	1	17891
75265	5150	1125315	1973-12-13	1973-12-20	1	1449
29250	1980	1177480	1988-07-02	1988-08-01	1	6787
6046	412	1322184	2004-06-18	2004-06-18	1	12587
28020	1900	1119510	2017-08-26	2017-09-02	1	17411
47173	3201	1112807	1964-09-19	1964-10-03	1	-1916
10923	752	738818	1994-05-03	1994-05-17	1	8902
28316	1918	1729720	1976-05-02	1976-05-09	1	2320
12077	830	1713332	2009-04-21	2009-04-28	1	14362
24546	1657	1125315	1975-08-02	1975-08-30	1	2067
59388	4045	738818	1988-02-25	1988-03-03	1	6636
55608	3784	1149380	1983-07-26	1983-07-26	1	4954
62114	4239	1125315	1993-07-29	1993-10-04	2	8677
36455	2480	738818	1996-10-28	1996-11-11	1	9811
66231	4525	1112807	1973-06-03	1973-06-24	1	1270
3662	246	1112807	1975-02-03	1975-02-24	1	1880
42002	2846	1177480	1981-02-22	1981-05-23	1	4160
33738	2291	1521369	1982-08-29	1983-08-24	1	4983
75266	5150	1125315	1978-06-24	1978-07-08	1	3110
29251	1980	1503184	1992-08-06	1993-08-01	1	8613
6047	412	1759842	1986-12-23	1987-01-06	1	6214
28021	1900	1503184	1978-09-28	1979-09-23	1	3552
47174	3201	1119510	1958-08-25	1958-09-01	1	-4140
10924	752	1125315	1950-02-13	1950-02-27	1	-7248
28317	1918	1119510	1985-04-29	1985-05-13	1	5611
12078	830	1759842	1985-08-18	1985-09-01	1	5722
24547	1657	1125315	1990-11-23	1990-12-07	1	7645
59389	4045	1713332	1984-11-23	1984-12-14	1	5461
55609	3784	1738521	1972-03-18	1972-04-01	1	821
62115	4239	1713332	1968-10-27	1968-11-24	1	-403
36456	2480	1125315	1996-10-28	1996-11-11	1	9811
66232	4525	1125315	2007-05-23	2007-05-30	1	13663
3663	246	1125315	1970-03-05	1970-03-12	1	70
42003	2846	1713332	1999-09-19	1999-10-10	1	10874
33739	2291	1713332	1967-05-31	1967-06-14	1	-932
75267	5150	1125315	1979-10-03	1979-10-17	1	3576
29252	1980	19127890	1986-09-07	1987-09-02	1	6453
6048	412	1125315	1957-10-10	1957-10-24	1	-4452
28022	1900	1713332	1979-11-04	1979-11-11	1	3601
47175	3201	1125315	1981-02-27	1981-03-27	1	4103
10925	752	1125315	1957-01-16	1957-01-30	1	-4719
28318	1918	1125315	1973-09-27	1973-11-01	1	1400
12079	830	1759842	2009-04-21	2009-04-28	1	14362
24548	1657	1728416	1946-06-24	1946-07-08	1	-8578
61810	4217	1713332	2007-03-16	2007-03-30	1	13602
55610	3784	920293	1954-09-23	1954-09-30	1	-5572
62116	4239	1729720	1953-11-01	1953-11-14	1	-5892
36457	2480	1713332	1956-09-03	1956-09-10	1	-4861
66233	4525	1125315	2012-04-30	2012-05-21	1	15481
3664	246	1137529	2000-09-07	2000-09-07	1	11207
42004	2846	1729720	1979-06-21	1979-06-29	1	3466
33740	2291	1713332	2014-12-01	2014-12-08	1	16412
75268	5150	1125315	1998-09-13	1998-09-27	1	10496
29253	1980	738818	1984-08-31	1984-09-14	1	5370
6049	412	1125315	1958-03-20	1958-04-03	1	-4291
28023	1900	1713332	2003-01-21	2003-01-28	1	12080
47176	3201	1112807	1973-04-19	1973-05-10	1	1225
10926	752	1125315	2014-05-07	2014-05-21	1	16211
28319	1918	1125315	1980-04-28	1980-05-12	1	3784
13646	932	1124957	2017-05-25	2017-05-25	1	17311
24549	1657	1729720	1955-11-22	1955-12-03	1	-5143
61811	4217	1729720	1983-04-14	1983-04-23	1	4860
55611	3784	933724	1954-09-23	1954-09-30	1	-5572
62117	4239	1112807	1954-06-17	1954-07-01	1	-5663
36458	2480	1713332	1969-06-09	1969-06-23	1	-192
66234	4525	1729720	1990-02-27	1990-03-10	1	7373
3665	246	1713332	2001-03-31	2001-04-07	1	11419
42005	2846	933724	2016-07-26	2016-08-09	1	17022
33741	2291	1729720	2016-02-21	2016-03-01	1	16861
75269	5150	1177480	2004-05-20	2004-06-03	1	12572
29254	1980	738818	2006-01-23	2006-02-06	1	13185
6050	412	1125315	1960-01-11	1960-01-18	1	-3636
28024	1900	1729720	1966-09-10	1966-09-19	1	-1200
47177	3201	1713332	1980-07-18	1980-07-25	1	3858
10927	752	1125315	2017-12-01	2017-12-15	1	17515
28320	1918	1125315	1987-09-03	1987-12-02	1	6544
13647	932	1118084	2002-07-06	2002-07-06	1	11874
24907	1685	1125315	1983-08-23	1983-09-13	1	5003
61812	4217	1118084	2001-04-19	2001-04-19	1	11431
55612	3784	1112807	1932-08-08	1932-08-22	1	-13646
62118	4239	1119510	1957-01-22	1957-02-05	1	-4713
36459	2480	1717327	1961-03-24	1961-04-07	1	-3191
66235	4525	1125315	1969-01-26	1969-02-09	1	-326
3666	246	1124957	1974-03-12	1974-03-12	1	1531
42006	2846	1124300	2017-08-28	2017-08-28	1	17406
33742	2291	1759842	1978-09-19	1978-09-26	1	3190
75270	5150	1124300	1976-07-19	1976-07-19	1	2391
29255	1980	1119510	1975-07-07	1975-07-21	1	2027
6051	412	1125315	1964-06-27	1964-07-04	1	-2007
28025	1900	1729720	1980-08-27	1980-09-04	1	3899
49374	3364	975125	2000-06-26	2000-06-26	1	11134
10928	752	1713332	1967-07-16	1967-07-23	1	-893
28321	1918	1738521	1969-10-04	1969-10-18	1	-75
13648	932	1125315	1975-08-22	1975-09-05	1	2073
24908	1685	1177480	1989-09-11	1989-09-25	1	7207
61813	4217	1125315	1991-07-05	1991-09-03	1	7915
55613	3784	1112807	1945-07-19	1945-09-17	1	-8872
62119	4239	1149380	1952-10-01	1952-10-01	1	-6301
36460	2480	1119510	1996-10-28	1996-11-11	1	9811
66236	4525	1713332	1986-08-24	1986-08-31	1	6086
3667	246	1125315	1974-03-12	1974-04-09	2	1559
42007	2846	1125315	1982-04-18	1982-05-18	1	4520
33743	2291	1759842	2014-12-01	2014-12-08	1	16412
75271	5150	1125315	1958-12-06	1959-01-03	1	-4016
29256	1980	1125315	1972-10-12	1972-10-19	1	1022
6052	412	1125315	1982-11-09	1982-11-23	1	4709
28026	1900	1759842	1979-11-04	1979-11-11	1	3601
49375	3364	1125315	1994-12-01	1994-12-01	1	9100
10929	752	1759842	1950-04-29	1950-05-20	1	-7166
28322	1918	738818	1982-01-30	1982-02-13	1	4426
13649	932	1125315	2017-05-25	2017-08-23	2	17401
24909	1685	1759842	2001-01-24	2001-02-14	1	11367
61814	4217	1177480	1987-09-10	1987-09-24	1	6475
55614	3784	1125315	1956-07-02	1956-07-16	1	-4917
62120	4239	1728416	1951-03-14	1951-03-28	1	-6854
36461	2480	1125315	1957-01-25	1957-02-08	1	-4710
66237	4525	1729720	1974-02-01	1974-02-09	1	1500
3668	246	1149380	1963-12-02	1963-12-02	1	-2222
42008	2846	1125315	2001-08-24	2001-08-31	1	11565
33744	2291	933724	2010-10-26	2010-11-02	1	14915
75272	5150	1729720	1952-01-02	1952-01-13	1	-6563
29257	1980	1125315	1984-08-31	1984-09-14	1	5370
6053	412	1713332	1986-12-23	1987-01-06	1	6214
28027	1900	1759842	2003-01-21	2003-01-28	1	12080
49376	3364	1595799	1998-05-10	1999-05-05	1	10716
10930	752	1112807	1951-10-15	1952-01-13	1	-6563
28323	1918	1112807	1969-07-06	1969-07-20	1	-165
13650	932	1112807	1971-01-15	1971-02-14	1	409
24910	1685	1118084	2015-10-19	2015-10-19	1	16727
61815	4217	1759842	2007-03-16	2007-03-30	1	13602
55615	3784	1112807	1931-01-04	1931-01-18	1	-14228
62121	4239	757627	2019-01-19	2019-01-19	1	17915
36462	2480	1125315	1975-07-21	1975-08-04	1	2041
66238	4525	1759842	1986-08-24	1986-08-31	1	6086
3669	246	1717327	1974-03-12	1974-04-09	1	1559
42009	2846	1125315	2003-11-21	2003-12-05	1	12391
33745	2291	1119510	2001-03-14	2001-03-21	1	11402
75273	5150	1112807	1944-09-15	1944-09-29	1	-9225
29258	1980	1125315	2006-01-23	2006-02-06	1	13185
6054	412	1728416	1955-03-17	1955-03-31	1	-5390
28028	1900	1119510	1971-12-26	1972-01-09	1	738
49377	3364	1729720	1982-12-05	1982-12-18	1	4734
10931	752	1118084	1991-03-19	1991-03-19	1	7747
28324	1918	1112807	1969-10-04	1969-10-18	1	-75
13651	932	1112807	1986-04-10	1986-05-08	1	5971
24911	1685	1125315	1985-05-14	1985-05-28	1	5626
61816	4217	1102527	1991-07-05	1991-07-05	1	7855
55616	3784	1125315	1952-08-02	1952-08-23	1	-6340
62122	4239	920293	1980-10-22	1980-10-29	1	3954
36463	2480	1125315	2009-06-05	2009-09-03	1	14490
66968	4571	1102527	2001-03-24	2001-03-24	1	11405
4280	293	1125315	1975-01-20	1975-02-03	1	1859
48166	3272	1521369	1988-05-19	1989-05-14	1	7073
33746	2291	1149380	1964-10-19	1980-10-09	1	3934
75274	5150	1112807	1947-08-31	1947-10-05	1	-8124
29259	1980	19127890	1992-08-06	1993-08-01	1	8613
6055	412	1728416	1957-10-10	1957-10-24	1	-4452
28029	1900	1521369	1978-09-28	1979-09-23	1	3552
49378	3364	1768849	1980-08-02	1980-08-16	1	3880
10932	752	1125315	1994-05-03	1994-05-17	1	8902
28325	1918	1118084	2004-11-19	2004-11-19	1	12741
14312	978	933724	2014-09-09	2014-09-16	1	16329
24912	1685	1125315	1985-09-13	1985-09-27	1	5748
61817	4217	1112807	1965-10-05	1965-10-19	1	-1535
55617	3784	1729720	1932-01-01	1932-01-14	1	-13867
62123	4239	933724	1980-10-22	1980-10-29	1	3954
36464	2480	1125315	2010-08-29	2010-09-23	1	14875
66969	4571	1125315	1993-12-29	1994-01-05	1	8770
4281	293	1713332	2014-09-05	2014-09-12	1	16325
48167	3272	1738521	1971-08-03	1971-08-17	1	593
33747	2291	1192710	1963-11-03	1963-11-03	1	-2251
75275	5150	1119510	1998-09-13	1998-09-27	1	10496
30496	2064	1125315	1982-04-06	1982-07-05	1	4568
6056	412	1112807	1955-03-17	1955-03-31	1	-5390
28030	1900	1713332	1979-12-18	1979-12-25	1	3645
49379	3364	19127890	1991-06-16	1995-05-26	4	9276
10933	752	1125315	1997-10-20	1997-11-03	1	10168
28326	1918	1125315	1982-01-30	1982-02-13	1	4426
14313	978	1119510	1985-10-23	1985-10-30	1	5781
24913	1685	1125315	1997-10-29	1997-11-12	1	10177
61818	4217	1125315	1976-06-11	1976-06-25	1	2367
57896	3949	705944	1977-03-15	1979-04-03	1	3379
62124	4239	1118084	1990-06-07	1990-06-07	1	7462
36465	2480	1177480	1977-12-06	1977-12-20	1	2910
66970	4571	1125315	2000-08-03	2000-08-10	1	11179
4282	293	1118084	2006-12-22	2006-12-22	1	13504
48168	3272	1125315	1987-04-11	1987-05-09	1	6337
33748	2291	1521369	1987-08-03	1988-07-28	1	6783
75276	5150	1125315	2011-06-01	2011-06-08	1	15133
30497	2064	1503184	1993-03-23	1994-03-18	1	8842
6057	412	1125315	1953-08-13	1953-08-27	1	-5971
31593	2138	1119510	1994-09-16	1994-09-23	1	9031
49380	3364	920293	2007-07-11	2007-07-18	1	13712
10934	752	1713332	1950-04-29	1950-05-20	1	-7166
28327	1918	1125315	2002-05-25	2002-06-01	1	11839
14314	978	1125315	1995-09-29	1995-12-28	1	9492
24914	1685	1125315	2014-12-13	2015-01-10	1	16445
61819	4217	1192710	1962-09-02	1962-09-02	1	-2678
57897	3949	1759842	1994-12-14	1994-12-21	1	9120
62125	4239	1125315	1952-09-06	1952-09-13	1	-6319
36466	2480	1759842	1956-09-03	1956-09-10	1	-4861
66971	4571	1125315	2001-03-17	2001-05-23	1	11465
4283	293	1125315	1983-08-22	1983-08-29	1	4988
48169	3272	1125315	1988-01-07	1988-01-14	1	6587
33749	2291	1713332	1997-07-05	1997-07-26	1	10068
75277	5150	738818	1998-09-13	1998-09-27	1	10496
30498	2064	1515774	1992-03-28	1993-03-23	1	8482
6058	412	1347450	2004-06-18	2004-06-18	1	12587
31594	2138	1125315	1972-12-05	1972-12-12	1	1076
49381	3364	1115008	1994-12-01	1995-03-01	1	9190
10935	752	1728416	1950-02-13	1950-02-27	1	-7248
28328	1918	1759842	1982-02-02	1982-02-16	1	4429
14315	978	19127890	1990-08-06	1991-08-01	1	7882
24915	1685	1713332	2001-01-24	2001-02-14	1	11367
61820	4217	1713332	1987-09-10	1987-09-24	1	6475
57898	3949	1177480	2009-12-12	2009-12-26	1	14604
62126	4239	1125315	1971-11-20	1971-12-04	1	702
36467	2480	1759842	1969-06-09	1969-06-23	1	-192
66972	4571	1125315	2018-03-11	2018-03-25	1	17615
4284	293	1177480	2018-03-04	2018-03-25	1	17615
48170	3272	1503184	1988-05-19	1989-05-14	1	7073
33750	2291	1717327	1964-01-26	1964-02-09	1	-2153
76824	5252	1729720	1967-03-19	1967-03-31	1	-1007
30499	2064	1549786	1992-03-28	1993-03-23	1	8482
6059	412	1713332	1992-01-15	1992-01-22	1	8056
31595	2138	1125315	1995-03-09	1995-03-23	1	9212
49382	3364	1125315	2012-07-29	2012-08-26	1	15578
10936	752	1729720	1983-11-22	1983-11-30	1	5081
29832	2020	1112807	1976-09-20	1976-10-04	1	2468
14316	978	920293	2014-09-09	2014-09-16	1	16329
24916	1685	1713332	1985-05-14	1985-05-28	1	5626
66179	4522	1125315	1981-03-13	1981-03-27	1	4103
57899	3949	1713332	1994-12-14	1994-12-21	1	9120
62127	4239	1125315	2001-09-22	2001-10-13	1	11608
44170	2988	705944	1976-06-06	1980-06-15	1	3818
66973	4571	1728416	1956-11-29	1956-12-13	1	-4767
4285	293	1125315	1978-04-03	1978-07-02	2	3104
48171	3272	1118084	2004-09-18	2004-09-18	1	12679
33751	2291	738818	2001-03-14	2001-03-21	1	11402
76825	5252	1759842	1978-02-24	1978-03-03	1	2983
30500	2064	1125315	1996-06-30	1996-07-07	1	9684
6060	412	1759842	1992-01-15	1992-01-22	1	8056
31596	2138	1125315	1999-12-27	2000-01-03	1	10959
49383	3364	1177480	1981-10-02	1981-10-16	1	4306
10937	752	1759842	1967-07-16	1967-07-23	1	-893
29833	2020	1115008	2012-07-22	2012-08-19	1	15571
14317	978	1503184	1990-08-06	1991-08-01	1	7882
27216	1840	1713332	1985-11-19	1985-12-10	1	5822
66180	4522	19127890	1990-01-05	1990-12-31	1	7669
57900	3949	1118084	2003-07-27	2003-07-27	1	12260
62128	4239	1728416	1954-06-17	1954-07-01	1	-5663
44171	2988	1112807	1965-10-22	1965-11-05	1	-1518
66974	4571	1112807	1956-01-17	1956-01-31	1	-5084
4286	293	1174888	1978-04-03	1978-04-03	1	3014
48172	3272	1125315	1971-08-03	1971-08-17	1	593
33752	2291	920293	2010-10-26	2010-11-02	1	14915
76826	5252	1112807	1969-10-01	1969-12-30	1	-2
30501	2064	19127890	1992-03-28	1994-03-18	2	8842
8478	588	1125315	2016-03-02	2016-03-16	1	16876
31597	2138	1125315	2002-02-14	2002-02-28	1	11746
49384	3364	1515774	1991-06-16	1995-05-26	4	9276
10938	752	914335	1979-02-04	1979-02-04	1	3321
29834	2020	1500211	1994-09-05	1995-08-31	1	9373
14318	978	1177480	2003-06-19	2003-07-10	1	12243
27217	1840	1759842	1985-05-25	1985-06-15	1	5644
66181	4522	1118084	2017-08-16	2017-08-16	1	17394
57901	3949	1125315	1976-01-11	1976-01-18	1	2208
62129	4239	738818	1957-01-22	1957-02-05	1	-4713
44172	2988	1119510	1972-09-16	1972-09-23	1	996
66975	4571	1124300	1995-04-02	1995-04-02	1	9222
4287	293	1759842	2014-09-05	2014-09-12	1	16325
48173	3272	1713332	1999-04-02	1999-04-16	1	10697
33753	2291	1115008	1998-09-15	1998-10-13	1	10512
76827	5252	1115008	2005-03-31	2005-06-29	1	12963
30502	2064	1124300	2017-06-16	2017-06-16	1	17333
8479	588	738818	1981-11-26	1981-12-10	1	4361
31598	2138	1728416	1957-02-26	1957-03-12	1	-4678
49385	3364	1549786	1998-05-10	1999-05-05	1	10716
10939	752	1125315	1971-07-25	1971-08-01	1	577
29835	2020	1503184	1988-10-06	1990-09-26	2	7573
14319	978	1729720	1979-09-25	1979-10-03	1	3562
27218	1840	1119510	2017-07-20	2017-07-27	1	17374
66182	4522	1515774	1990-01-05	1990-12-31	1	7669
57902	3949	1125315	2003-01-28	2003-02-04	1	12087
62130	4239	1112807	1951-03-14	1951-03-28	1	-6854
44173	2988	1119510	2002-10-22	2002-11-05	1	11996
66976	4571	1713332	2010-07-07	2010-07-28	1	14818
4288	293	1713332	1995-08-08	1995-08-22	1	9364
48174	3272	1759842	1999-04-02	1999-04-16	1	10697
33754	2291	1125315	1989-05-21	1989-06-04	1	7094
76828	5252	1115008	2015-11-04	2015-11-25	1	16764
30503	2064	1125315	2008-11-02	2008-11-20	1	14203
8480	588	1125315	1981-11-26	1981-12-10	1	4361
31599	2138	1112807	1959-08-15	1959-11-13	1	-3702
49386	3364	1713332	2017-03-09	2017-03-16	1	17241
10940	752	1125315	2000-01-22	2000-02-05	1	10992
29836	2020	19127890	1984-10-27	1985-10-22	1	5773
14320	978	1729720	1981-05-29	1981-06-11	1	4179
27219	1840	1125315	1978-02-02	1978-02-16	1	2968
66183	4522	1549786	1990-01-05	1990-12-31	1	7669
57903	3949	1177480	1980-01-19	1980-03-19	1	3730
62131	4239	1115008	2019-04-12	2019-05-19	1	18035
44174	2988	1177480	2008-12-01	2008-12-15	1	14228
66977	4571	1728416	1956-01-17	1956-01-31	1	-5084
4289	293	1759842	1995-08-08	1995-08-22	1	9364
48175	3272	1112807	1972-01-14	1972-01-28	1	757
33755	2291	1125315	2001-03-14	2001-03-21	1	11402
76829	5252	1125315	1961-12-06	1961-12-13	1	-2941
30504	2064	1125315	1989-02-28	1989-03-21	1	7019
8481	588	1713332	1981-02-27	1981-03-13	1	4089
31600	2138	1118084	1990-04-24	1990-04-24	1	7418
49387	3364	1729720	1988-01-24	1988-02-06	1	6610
10941	752	1125315	2008-10-10	2008-10-24	1	14176
29837	2020	1112807	1973-07-17	1973-07-31	1	1307
14321	978	738818	1985-10-23	1985-10-30	1	5781
27220	1840	1125315	2016-02-17	2016-02-24	1	16855
66184	4522	1713332	1981-03-13	1981-03-27	1	4103
59937	4087	1125315	2010-10-13	2010-10-20	1	14902
62132	4239	1125315	1957-01-22	1957-02-05	1	-4713
44175	2988	738818	2002-10-22	2002-11-05	1	11996
66978	4571	920293	2004-07-27	2004-08-03	1	12633
4981	339	1118084	2019-06-21	2019-06-21	1	18068
48176	3272	19127890	1988-05-19	1989-05-14	1	7073
33756	2291	1503184	1987-08-03	1988-07-28	1	6783
76830	5252	1125315	1987-01-08	1987-01-15	1	6223
30505	2064	1125315	1993-10-06	1993-10-13	1	8686
8482	588	1115008	2008-12-02	2008-12-23	1	14236
31601	2138	1125315	1992-10-30	1992-11-06	1	8345
49388	3364	933724	2007-07-11	2007-07-18	1	13712
10942	752	1112807	1949-04-28	1949-05-12	1	-7539
29838	2020	1729720	1983-12-06	1983-12-19	1	5100
14322	978	1102527	1995-09-29	1995-09-29	1	9402
27221	1840	738818	2017-07-20	2017-07-27	1	17374
66185	4522	1729720	2017-02-12	2017-02-25	1	17222
59938	4087	1177480	1990-10-16	1990-10-30	1	7607
62133	4239	1154343	1952-10-01	1952-10-01	1	-6301
44176	2988	1119510	2006-12-22	2007-01-05	1	13518
66979	4571	933724	2004-07-27	2004-08-03	1	12633
4982	339	1125315	1993-05-19	1993-06-02	1	8553
49241	3355	1713332	1974-07-28	1974-08-18	1	1690
33757	2291	1713332	1988-05-12	1988-05-19	1	6713
76831	5252	1137529	1999-04-13	1999-04-13	1	10694
30506	2064	1521369	1993-03-23	1994-03-18	1	8842
8483	588	1118084	2019-06-08	2019-06-08	1	18055
31602	2138	1713332	2002-02-14	2002-02-28	1	11746
49389	3364	1118084	2009-02-01	2009-02-01	1	14276
10943	752	1119510	1994-05-03	1994-05-17	1	8902
29839	2020	1738521	1976-09-20	1976-10-04	1	2468
14323	978	1118084	2012-04-22	2012-04-22	1	15452
27222	1840	1118084	2016-12-29	2016-12-29	1	17164
66186	4522	1125315	1985-04-23	1985-04-30	1	5598
59939	4087	1177480	2008-03-20	2008-04-03	1	13972
62134	4239	1174888	1993-08-05	1993-08-05	1	8617
44177	2988	1125315	2002-10-22	2002-11-05	1	11996
66980	4571	1112807	1956-11-29	1956-12-13	1	-4767
4983	339	1713332	1987-11-09	1987-11-23	1	6535
49242	3355	738818	2002-02-08	2002-02-15	1	11733
33758	2291	1759842	1988-05-12	1988-05-19	1	6713
76832	5252	1347450	2018-11-27	2018-11-27	1	17862
31749	2150	738818	1969-08-06	1969-08-13	1	-141
8484	588	1125315	1981-02-27	1981-03-13	1	4089
31603	2138	738818	1994-09-16	1994-09-23	1	9031
49390	3364	1125315	1983-09-17	1983-10-01	1	5021
10944	752	1125315	1952-12-09	1952-12-23	1	-6218
29840	2020	19127890	1988-10-06	1990-09-26	2	7573
14324	978	1125315	1985-10-23	1985-10-30	1	5781
27223	1840	1125315	1986-08-19	1986-11-17	1	6164
66187	4522	1589505	1993-12-15	1994-12-10	1	9109
59940	4087	1729720	1991-08-22	1991-08-31	1	7912
62135	4239	1759842	1968-10-27	1968-11-24	1	-403
44178	2988	1322184	2012-06-24	2012-06-24	1	15515
66981	4571	1177480	1981-03-18	1981-04-01	1	4108
4984	339	1759842	2000-04-23	2000-05-14	1	11091
49243	3355	1112807	1963-05-03	1963-05-17	1	-2421
33759	2291	19127890	1982-08-29	1983-08-24	1	4983
76833	5252	1713332	1978-02-24	1978-03-03	1	2983
31750	2150	738818	1989-06-30	1989-07-07	1	7127
8485	588	1119510	1981-11-26	1981-12-10	1	4361
31604	2138	1125315	1994-09-16	1994-09-23	1	9031
49391	3364	1174888	1994-12-01	1994-12-01	1	9100
10945	752	1125315	1979-10-18	1979-11-08	1	3598
29841	2020	1124300	2006-05-10	2006-05-10	1	13278
14325	978	1177480	1985-01-24	1985-04-24	1	5592
27224	1840	1125315	2017-07-20	2017-07-27	1	17374
66986	4572	1112807	1977-11-08	1977-12-13	1	2903
59941	4087	1119510	1988-11-20	1988-11-27	1	6905
64352	4394	1174888	2000-08-12	2000-08-12	1	11181
44179	2988	1729720	1972-10-18	1972-10-25	1	1028
66982	4571	1759842	2010-07-07	2010-07-28	1	14818
4985	339	1125315	2008-12-13	2008-12-27	1	14240
49244	3355	1118084	2007-10-09	2007-10-09	1	13795
33760	2291	1125315	1964-01-26	1964-02-09	1	-2153
76834	5252	920293	2015-12-30	2016-01-06	1	16806
31751	2150	1115008	2005-11-07	2006-02-05	1	13184
8486	588	1125315	2010-05-07	2010-05-14	1	14743
31605	2138	1729720	1958-07-24	1958-08-03	1	-4169
49392	3364	1177480	1980-08-02	1980-08-16	1	3880
10946	752	1125315	2014-02-27	2014-03-06	1	16135
29842	2020	1521369	1984-10-27	1985-10-22	1	5773
14326	978	1521369	1990-08-06	1991-08-01	1	7882
27225	1840	1125315	2006-09-04	2006-09-18	1	13409
66987	4572	1125315	1976-11-08	1976-12-13	1	2538
59942	4087	1125315	1983-12-18	1984-01-01	1	5113
64353	4394	19127890	1987-02-11	1988-02-06	1	6610
44180	2988	1112807	1972-09-15	1972-09-29	1	1002
66983	4571	1112807	1958-12-02	1958-12-23	1	-4027
4986	339	1177480	1994-08-09	1994-09-08	1	9016
49245	3355	1119510	2002-02-08	2002-02-15	1	11733
33761	2291	1154343	1964-10-19	1980-10-09	1	3934
76835	5252	1112807	1973-09-10	1973-09-24	1	1362
31752	2150	1124300	1986-02-25	1986-02-25	1	5899
9757	672	738818	1972-11-15	1972-11-29	1	1063
31606	2138	1112807	1957-02-26	1957-03-12	1	-4678
49393	3364	1521369	1998-05-10	1999-05-05	1	10716
10947	752	1309944	1979-02-04	1979-02-04	1	3321
29843	2020	1503184	1984-10-27	1985-10-22	1	5773
14327	978	1729720	2011-11-02	2011-11-13	1	15291
27226	1840	1713332	1985-05-25	1985-06-15	1	5644
66988	4572	1125315	1981-10-01	1981-10-15	1	4305
59943	4087	738818	1988-11-20	1988-11-27	1	6905
64354	4394	738818	2014-05-12	2014-05-26	1	16216
44181	2988	1125315	1972-09-16	1972-09-23	1	996
66984	4571	1177480	1979-02-06	1979-02-27	1	3344
4987	339	1713332	1990-02-03	1990-03-03	1	7366
49246	3355	1125315	2002-02-08	2002-02-15	1	11733
33762	2291	1503184	1982-08-29	1983-08-24	1	4983
76836	5252	1125315	1961-04-17	1961-04-24	1	-3174
31753	2150	1125315	1952-12-22	1953-01-05	1	-6205
9758	672	1124957	2000-02-24	2000-02-24	1	11011
31607	2138	1125315	1966-09-07	1966-11-06	1	-1152
49394	3364	1549786	1991-06-16	1995-05-26	4	9276
10948	752	1343916	1979-02-04	1979-02-04	1	3321
29844	2020	1521369	1988-10-06	1990-09-26	2	7573
16494	1138	1174888	2018-03-17	2018-03-17	1	17607
27227	1840	1759842	1985-11-19	1985-12-10	1	5822
66989	4572	1125315	1987-04-17	1987-05-01	1	6329
59944	4087	1124300	2018-01-27	2018-01-27	1	17558
64355	4394	1125315	2000-08-12	2000-08-12	1	11181
44182	2988	1125315	1975-08-15	1975-09-05	1	2073
66985	4571	1729720	1958-02-09	1958-02-19	1	-4334
4988	339	1778162	1985-09-16	1985-09-30	1	5751
49247	3355	1503184	1976-10-01	1977-09-26	1	2825
33763	2291	1713332	1978-09-19	1978-09-26	1	3190
76837	5252	1322184	2018-11-27	2018-11-27	1	17862
31754	2150	1125315	1966-07-14	1966-07-28	1	-1253
9759	672	1125315	1965-04-19	1965-05-03	1	-1704
31608	2138	1177480	2007-10-16	2007-11-13	1	13830
49395	3364	1713332	1981-10-02	1981-10-16	1	4306
10949	752	1713332	1994-02-14	1994-02-28	1	8824
29845	2020	1738521	1973-07-17	1973-07-31	1	1307
16495	1138	1177480	2007-03-15	2007-04-14	1	13617
28967	1962	1125315	1979-06-03	1979-06-17	1	3454
66990	4572	1713332	1981-10-01	1981-11-05	2	4319
59945	4087	1125315	1988-11-20	1988-11-27	1	6905
64356	4394	1125315	2014-05-12	2014-05-26	1	16216
44183	2988	1125315	1993-01-03	1993-03-11	2	8470
69625	4753	1125315	1965-06-17	1965-07-01	1	-1645
4989	339	1125315	1996-02-28	1996-03-06	1	9561
49248	3355	1713332	2004-03-09	2004-03-30	1	12507
33764	2291	1729720	1966-01-18	1966-01-30	1	-1432
76838	5252	1713332	1979-03-19	1979-04-09	1	3385
31755	2150	1125315	1989-06-30	1989-07-07	1	7127
9760	672	1125315	1983-02-04	1983-02-25	1	4803
31609	2138	1177480	2012-08-18	2012-09-08	1	15591
49396	3364	1125315	1986-06-02	1986-06-16	1	6010
10950	752	1713332	2001-01-20	2001-02-03	1	11356
33264	2258	1124957	1977-11-25	1977-11-25	1	2885
16496	1138	1124300	2016-03-12	2016-03-12	1	16872
28968	1962	1125315	1992-09-20	1992-10-04	1	8312
66991	4572	1729720	1977-01-08	1977-01-21	1	2577
59946	4087	1125315	2013-12-03	2013-12-03	1	16042
64357	4394	1177480	2000-08-12	2000-11-10	1	11271
44184	2988	1125315	2003-01-18	2003-02-01	1	12084
69626	4753	1125315	1970-02-20	1970-03-06	1	64
4990	339	1713332	1994-10-17	1995-02-13	1	9174
49249	3355	1713332	2007-07-22	2007-08-12	1	13737
33765	2291	1759842	1967-05-31	1967-06-14	1	-932
76839	5252	1759842	1979-03-19	1979-04-09	1	3385
31756	2150	1125315	1990-04-02	1990-04-30	1	7424
9761	672	1125315	1985-03-16	1985-04-06	1	5574
32913	2230	1119510	2002-04-16	2002-04-30	1	11807
49397	3364	1129625	1977-10-02	1977-10-02	1	2831
10951	752	1759842	1994-02-14	1994-02-28	1	8824
33265	2258	1713332	1991-05-28	1991-06-18	1	7838
16497	1138	1125315	1984-02-09	1984-03-15	1	5187
28969	1962	1125315	2019-01-22	2019-01-29	1	17925
66992	4572	1759842	1981-10-22	1981-11-05	1	4326
59947	4087	1713332	1982-01-26	1982-02-09	1	4422
64358	4394	1503184	1987-02-11	1988-02-06	1	6610
44185	2988	1347450	2012-06-24	2012-06-24	1	15515
69627	4753	1125315	2013-09-16	2013-09-30	1	15978
4991	339	1759842	1994-10-17	1995-02-13	1	9174
49250	3355	19127890	1976-10-01	1977-09-26	1	2825
33766	2291	1759842	1997-07-05	1997-07-26	1	10068
76840	5252	933724	2015-12-30	2016-01-06	1	16806
31757	2150	1177480	1995-09-14	1995-09-28	1	9401
9762	672	1177480	2000-02-17	2000-04-24	1	11071
32914	2230	1125315	1976-05-01	1976-05-15	1	2326
49398	3364	1729720	2013-10-18	2013-10-30	1	16008
10952	752	1759842	2001-01-20	2001-02-03	1	11356
33266	2258	1728416	1959-11-30	1959-12-14	1	-3671
16498	1138	1150836	1985-02-19	1985-02-19	1	5528
28970	1962	1713332	2015-08-26	2015-09-16	1	16694
66993	4572	1118084	2018-10-24	2018-10-24	1	17828
59948	4087	1115008	1995-07-06	1995-07-27	1	9338
64359	4394	1729720	1978-03-22	1978-04-04	1	3015
44186	2988	1717327	1965-10-22	1965-11-05	1	-1518
69628	4753	1503184	1975-06-04	1976-05-29	1	2340
4992	339	1112807	1990-02-03	1990-03-03	1	7366
49251	3355	1102527	1977-11-15	1977-11-15	1	2875
33767	2291	19127890	1987-08-03	1988-07-28	1	6783
76841	5252	1118084	1995-11-09	1995-11-09	1	9443
31758	2150	1177480	2008-01-26	2008-02-16	1	13925
9763	672	1125315	1956-10-25	1956-11-01	1	-4809
32915	2230	1125315	1976-09-29	1976-10-13	1	2477
49399	3364	1759842	2017-03-09	2017-03-16	1	17241
14279	975	1119510	2003-01-27	2003-02-03	1	12086
33267	2258	1112807	1959-11-30	1959-12-14	1	-3671
16499	1138	1713332	1982-08-18	1982-09-01	1	4626
28971	1962	1759842	2015-08-26	2015-09-16	1	16694
66994	4572	1713332	2008-04-25	2008-06-13	1	14043
59949	4087	1115008	2013-12-03	2014-02-01	1	16102
64360	4394	1112807	1978-02-18	1978-03-11	1	2991
44187	2988	1759842	1968-03-10	1968-03-31	1	-641
69629	4753	1521369	1978-05-19	1979-05-14	1	3420
4993	339	1125315	1985-09-16	1985-09-30	1	5751
49252	3355	1112807	1986-07-31	1986-10-29	1	6145
38050	2588	738818	2010-09-28	2010-10-12	1	14894
76842	5252	1125315	1987-10-11	1987-11-01	1	6513
31759	2150	1713332	1981-09-24	1981-10-01	1	4291
9764	672	1125315	1967-03-26	1967-04-09	1	-998
32916	2230	1125315	2002-04-16	2002-04-30	1	11807
50037	3410	933724	1995-05-22	1995-05-29	1	9279
14280	975	1125315	2003-01-27	2003-02-03	1	12086
33268	2258	1125315	1977-11-25	1978-02-23	2	2975
16500	1138	1713332	1987-09-25	1987-10-09	1	6490
28972	1962	19127890	1980-03-25	1982-03-15	2	4456
66995	4572	1729720	1981-05-17	1981-05-27	1	4164
59950	4087	1125315	1982-01-26	1982-02-09	1	4422
64361	4394	1118084	2013-02-04	2013-02-04	1	15740
44188	2988	738818	1972-09-16	1972-09-23	1	996
69630	4753	1521369	1980-05-08	1981-05-03	1	4140
4994	339	1125315	1987-11-09	1987-11-23	1	6535
49253	3355	1177480	2017-05-10	2017-07-09	1	17356
38051	2588	1124300	2002-04-03	2002-04-03	1	11780
76843	5252	1149380	1999-04-13	1999-04-13	1	10694
31760	2150	1759842	1961-02-17	1961-02-24	1	-3233
9765	672	1759842	1989-07-06	1989-07-27	1	7147
32917	2230	738818	2002-04-16	2002-04-30	1	11807
50038	3410	1125315	1973-03-20	1973-04-03	1	1188
14281	975	1729720	1967-10-03	1967-10-16	1	-808
33269	2258	1125315	1985-03-16	1985-04-06	1	5574
16501	1138	1729720	1981-07-26	1981-08-08	1	4237
28973	1962	1112807	1967-01-23	1967-02-06	1	-1060
66996	4572	1759842	2008-04-25	2008-06-13	1	14043
59951	4087	1125315	1984-05-15	1984-06-19	1	5283
64362	4394	1119510	2014-05-12	2014-05-26	1	16216
44189	2988	738818	2006-12-22	2007-01-05	1	13518
69631	4753	1521369	1982-04-28	1983-04-23	1	4860
4995	339	1177480	1984-10-02	1984-10-16	1	5402
49254	3355	1729720	1964-09-28	1964-10-10	1	-1909
38052	2588	1125315	2010-09-28	2010-10-12	1	14894
76844	5252	1729720	1990-02-15	1990-02-28	1	7363
31761	2150	1112807	1951-07-14	1951-07-28	1	-6732
9766	672	1125315	1972-11-15	1972-11-29	1	1063
32918	2230	1102527	1985-06-13	1985-06-13	1	5642
50039	3410	1125315	2007-02-01	2007-02-08	1	13552
14282	975	1112807	1972-01-08	1972-02-07	1	767
33270	2258	1112807	1961-08-16	1961-08-30	1	-3046
16502	1138	1759842	1987-09-25	1987-10-09	1	6490
28974	1962	1125315	1998-04-06	1998-05-04	1	10350
66997	4572	1125315	1978-05-02	1978-05-16	1	3057
59952	4087	1125315	2002-09-17	2002-09-24	1	11954
64363	4394	1521369	1987-02-11	1988-02-06	1	6610
44190	2988	1118084	2001-07-15	2001-07-15	1	11518
69632	4753	1717327	1962-03-04	1962-03-18	1	-2846
4996	339	1713332	2000-04-23	2000-05-14	1	11091
49255	3355	1729720	1975-07-26	1975-08-06	1	2043
38053	2588	1713332	2008-06-10	2008-06-24	1	14054
31762	2150	1125315	1969-08-06	1969-08-13	1	-141
9767	672	1125315	2004-11-15	2004-11-22	1	12744
32919	2230	1125315	1985-06-13	1985-07-13	1	5672
50040	3410	1503184	1980-04-01	1981-03-27	1	4103
14283	975	738818	2003-01-27	2003-02-03	1	12086
33271	2258	1118084	1995-01-30	1995-01-30	1	9160
16503	1138	1125315	1982-08-18	1982-09-01	1	4626
28975	1962	1125315	2005-03-28	2005-05-27	1	12930
66998	4572	1125315	2002-05-06	2002-05-27	1	11834
59953	4087	1174888	2013-12-03	2013-12-03	1	16042
66643	4550	1118084	2000-11-13	2000-11-13	1	11274
44191	2988	1125315	2006-12-22	2007-01-05	1	13518
69633	4753	1729720	1984-11-03	1984-11-11	1	5428
6618	457	1759842	1971-03-22	1971-04-05	1	459
49256	3355	1125315	1977-11-15	1978-02-13	1	2965
38054	2588	1729720	1994-09-04	1994-09-17	1	9025
31763	2150	1125315	2013-03-28	2013-04-04	1	15799
9768	672	1713332	1989-07-06	1989-07-27	1	7147
32920	2230	1738521	1976-05-01	1976-05-15	1	2326
50041	3410	1503184	1982-03-22	1983-03-17	1	4823
14284	975	1124300	2000-03-26	2000-03-26	1	11042
33272	2258	1125315	1979-07-19	1979-07-26	1	3493
16504	1138	1125315	1993-12-20	1994-01-03	1	8768
28976	1962	1713332	2009-10-29	2009-11-26	1	14574
66999	4572	1177480	2008-04-25	2008-05-30	1	14029
59954	4087	1729720	1985-11-08	1985-11-19	1	5801
66644	4550	1713332	1974-03-14	1974-04-04	1	1554
44192	2988	1174888	1993-01-10	1993-01-10	1	8410
69634	4753	914335	1987-11-18	1987-11-18	1	6530
6619	457	1125315	1954-04-01	1954-04-15	1	-5740
49257	3355	1125315	1995-06-14	1995-07-05	1	9316
38055	2588	19127890	1978-08-27	1979-08-22	1	3520
31764	2150	1174888	2003-10-19	2003-10-19	1	12344
9769	672	1118084	1989-04-13	1989-04-13	1	7042
32921	2230	1118084	2009-01-28	2009-01-28	1	14272
50042	3410	1503184	1984-03-11	1986-03-01	2	5903
14285	975	1125315	1979-12-11	1980-01-17	2	3668
33273	2258	1125315	1981-03-09	1981-04-06	1	4113
16505	1138	1125315	2018-03-17	2018-03-17	1	17607
28977	1962	1729720	1966-10-28	1966-11-04	1	-1154
67000	4572	1729720	2018-07-16	2018-07-23	1	17735
60837	4149	1112807	1970-11-12	1970-11-26	1	329
66645	4550	1759842	1974-10-07	1974-10-21	1	1754
44193	2988	1713332	1968-03-10	1968-03-31	1	-641
69635	4753	1125315	1986-11-28	1986-12-12	1	6189
6620	457	1125315	1958-08-07	1958-10-06	1	-4105
49258	3355	1521369	1976-10-01	1977-09-26	1	2825
38056	2588	1112807	1979-07-02	1979-08-06	1	3504
31765	2150	1177480	2003-10-19	2003-11-18	1	12374
9770	672	1119510	1972-11-15	1972-11-29	1	1063
32922	2230	1125315	2009-10-05	2009-11-02	1	14550
50043	3410	1717327	1964-08-13	1964-08-27	1	-1953
14286	975	1717327	1966-12-05	1966-12-19	1	-1109
33274	2258	1125315	2003-11-11	2003-11-25	1	12381
16506	1138	1177480	1985-06-24	1985-07-08	1	5667
28978	1962	1759842	2003-04-25	2003-05-16	1	12188
69729	4758	914335	1989-08-13	1989-08-13	1	7164
60838	4149	1125315	1999-06-03	1999-06-10	1	10752
66646	4550	1125315	1963-06-06	1963-06-20	1	-2387
45456	3084	1515774	1991-11-20	1993-11-09	2	8713
69636	4753	1125315	2006-02-25	2006-05-26	1	13294
6621	457	1125315	1998-07-04	1998-08-10	1	10448
49259	3355	1729720	1966-12-02	1966-12-10	1	-1118
38057	2588	1115008	2016-07-13	2016-07-27	1	17009
31766	2150	1713332	1961-02-17	1961-02-24	1	-3233
9771	672	1125315	1975-11-17	1975-11-24	1	2153
33089	2240	1713332	1959-10-21	1959-10-28	1	-3718
50044	3410	738818	2018-03-14	2018-03-21	1	17611
14287	975	1124957	1979-12-18	1979-12-18	1	3638
33275	2258	1729720	1968-04-01	1968-04-09	1	-632
16507	1138	1177480	2018-03-17	2018-06-15	1	17697
28979	1962	19127890	1978-04-05	1979-03-31	1	3376
69730	4758	920293	2018-04-04	2018-04-11	1	17632
60839	4149	1177480	2006-04-26	2006-05-10	1	13278
66647	4550	1125315	1971-03-26	1971-04-25	1	479
45457	3084	1515774	1995-10-30	1996-10-24	1	9793
69637	4753	1309944	1987-11-18	1987-11-18	1	6530
6622	457	1125315	2007-03-10	2007-03-17	1	13589
49260	3355	1759842	1974-07-28	1974-08-18	1	1690
38058	2588	1119510	1981-05-01	1981-05-08	1	4145
31767	2150	1729720	1953-07-04	1953-07-12	1	-6017
9772	672	1125315	2000-02-24	2000-02-24	1	11011
33090	2240	1729720	2004-06-01	2004-06-09	1	12578
50045	3410	1118084	2002-06-20	2002-06-20	1	11858
14288	975	1125315	1966-12-05	1966-12-19	1	-1109
33276	2258	1759842	1991-05-28	1991-06-18	1	7838
19627	1339	738818	2018-07-16	2018-07-23	1	17735
28980	1962	1124300	1999-02-19	1999-02-19	1	10641
69731	4758	1112807	1958-05-08	1958-05-22	1	-4242
60840	4149	1717327	1966-03-27	1966-04-10	1	-1362
66648	4550	1713332	1974-10-07	1974-10-21	1	1754
45458	3084	1549786	1995-10-30	1996-10-24	1	9793
69638	4753	1343916	1987-11-18	1987-11-18	1	6530
6623	457	1177480	2009-05-14	2009-07-13	1	14438
49261	3355	1759842	2004-03-09	2004-03-30	1	12507
38059	2588	1119510	2010-09-28	2010-10-12	1	14894
31768	2150	1119510	1969-08-06	1969-08-13	1	-141
10560	726	738818	1988-06-24	1988-07-01	1	6756
33091	2240	1759842	1959-10-21	1959-10-28	1	-3718
50046	3410	1125315	2018-03-14	2018-03-21	1	17611
14289	975	1125315	2009-07-27	2009-08-03	1	14459
35640	2423	920293	1996-11-16	1996-11-23	1	9823
19628	1339	1125315	1970-04-23	1970-05-28	1	147
28981	1962	1521369	1978-04-05	1979-03-31	1	3376
69732	4758	1119510	1985-05-08	1985-05-15	1	5613
60841	4149	1729720	1973-11-16	1973-11-27	1	1426
66649	4550	1729720	1977-09-07	1977-09-20	1	2819
45459	3084	1102527	2006-10-13	2006-10-13	1	13434
69639	4753	1713332	1989-10-24	1989-10-31	1	7243
6624	457	933724	2009-09-10	2009-09-17	1	14504
49262	3355	1759842	2007-07-22	2007-08-12	1	13737
38060	2588	1125315	1978-06-07	1978-09-05	2	3169
31769	2150	1119510	1989-06-30	1989-07-07	1	7127
10561	726	1177480	2004-09-01	2004-09-22	1	12683
33092	2240	1118084	2000-04-04	2000-04-04	1	11051
50047	3410	1521369	1980-04-01	1981-03-27	1	4103
14290	975	1177480	1975-10-19	1975-11-02	1	2131
35641	2423	1112807	1962-05-24	1962-06-14	1	-2758
19629	1339	1125315	2018-07-16	2018-07-23	1	17735
28982	1962	1713332	2003-04-25	2003-05-16	1	12188
69733	4758	1125315	1962-09-22	1962-10-06	1	-2644
60842	4149	1738521	1968-06-22	1968-07-06	1	-544
66650	4550	1759842	1974-03-14	1974-04-04	1	1554
45460	3084	1124300	2017-05-02	2017-05-02	1	17288
69640	4753	1729720	1975-02-28	1975-03-10	1	1894
6625	457	1118084	1986-03-28	1986-03-28	1	5930
50464	3437	920293	1946-05-16	1946-05-23	1	-8624
38061	2588	1112807	1969-06-05	1969-06-19	1	-196
31770	2150	1125315	2003-10-19	2003-10-19	1	12344
10562	726	19127890	1977-07-05	1978-06-30	1	3102
33093	2240	1125315	2004-09-16	2004-09-23	1	12684
50048	3410	1521369	1982-03-22	1983-03-17	1	4823
16438	1135	738818	1992-01-04	1992-01-18	1	8052
35642	2423	1125315	1997-06-29	1997-09-27	1	10131
19630	1339	1125315	1977-08-19	1977-09-09	1	2808
28983	1962	1729720	1972-08-05	1972-08-14	1	956
69734	4758	1177480	1987-06-05	1987-06-26	1	6385
60843	4149	1118084	2002-08-05	2002-08-05	1	11904
66651	4550	1112807	1968-02-23	1968-03-08	1	-664
45461	3084	1125315	1980-08-09	1980-08-30	1	3894
69641	4753	1729720	1985-05-14	1985-05-23	1	5621
6626	457	1125315	2003-03-01	2003-03-15	1	12126
50465	3437	933724	1946-05-16	1946-05-23	1	-8624
38062	2588	1124957	1978-06-07	1978-06-07	1	3079
31771	2150	1713332	2017-02-28	2017-03-28	1	17253
10563	726	1124300	1991-06-12	1991-06-12	1	7832
33094	2240	1112807	1966-10-05	1966-10-19	1	-1170
50049	3410	1521369	1984-03-11	1986-03-01	2	5903
16439	1135	1125315	1981-10-27	1981-11-26	1	4347
35643	2423	1759842	1957-08-26	1957-09-09	1	-4497
19631	1339	1729720	1968-05-04	1968-05-17	1	-594
28984	1962	1759842	2009-10-29	2009-11-26	1	14574
69735	4758	738818	1985-05-08	1985-05-15	1	5613
60844	4149	1729720	2005-06-25	2005-07-03	1	12967
66652	4550	1112807	1980-01-08	1980-02-05	1	3687
45462	3084	1177480	2006-10-13	2006-12-12	1	13494
69642	4753	19127890	1975-06-04	1976-05-29	1	2340
6627	457	1177480	1989-03-27	1989-04-17	1	7046
50466	3437	1125315	1971-05-20	1971-05-27	1	511
38063	2588	1125315	1985-09-16	1985-09-30	1	5751
31772	2150	1759842	1977-03-30	1977-04-13	1	2659
10564	726	1759842	1982-05-25	1982-06-01	1	4534
33095	2240	1125315	1987-07-01	1987-09-29	1	6480
50050	3410	1729720	1970-10-14	1970-10-23	1	295
16440	1135	1125315	1992-01-04	1992-01-18	1	8052
35644	2423	1102527	1998-09-29	1998-09-29	1	10498
19632	1339	1115008	1999-04-17	1999-05-08	1	10719
28985	1962	1125315	1987-02-05	1987-02-19	1	6258
69736	4758	933724	2018-04-04	2018-04-11	1	17632
60845	4149	1112807	1968-06-22	1968-07-06	1	-544
66653	4550	1713332	1985-04-02	1985-04-23	1	5591
45463	3084	1309944	2015-10-21	2015-10-21	1	16729
69643	4753	1118084	2003-12-09	2003-12-09	1	12395
6628	457	1713332	1971-03-22	1971-04-05	1	459
50467	3437	1125315	1980-11-30	1980-12-14	1	4000
38064	2588	1125315	1987-01-26	1987-02-16	1	6255
31773	2150	1759842	1981-09-24	1981-10-01	1	4291
10565	726	1112807	1969-02-07	1969-05-08	1	-238
37670	2559	1112807	1962-10-05	1962-10-19	1	-2631
50051	3410	1759842	1996-05-03	1996-05-17	1	9633
16441	1135	1112807	1959-09-04	1959-09-18	1	-3758
35645	2423	1177480	1998-09-22	1998-11-28	1	10558
19633	1339	1119510	2001-05-12	2001-05-19	1	11461
28986	1962	1503184	1978-04-05	1979-03-31	1	3376
69737	4758	1119510	1967-01-22	1967-01-29	1	-1068
60846	4149	1177480	2007-06-04	2007-06-25	1	13689
66654	4550	1717327	1963-06-06	1963-06-20	1	-2387
45464	3084	1343916	2015-10-21	2015-10-21	1	16729
69644	4753	1125315	1966-03-26	1966-04-09	1	-1363
6629	457	1713332	2003-02-24	2003-03-17	1	12128
50468	3437	1713332	1945-05-09	1945-05-30	1	-8982
38065	2588	1137529	2014-08-31	2014-08-31	1	16313
31774	2150	1768849	1995-09-14	1995-09-28	1	9401
10566	726	1125315	1954-04-27	1954-05-11	1	-5714
37671	2559	1125315	1980-02-19	1980-02-26	1	3708
50052	3410	1759842	1999-04-08	1999-04-22	1	10703
16442	1135	1125315	1996-05-09	1996-05-16	1	9632
35646	2423	1557272	2016-12-19	2016-12-19	1	17154
19634	1339	1125315	2001-05-12	2001-05-19	1	11461
28987	1962	1503184	1980-03-25	1982-03-15	2	4456
69738	4758	1124300	1996-11-14	1996-11-14	1	9814
60847	4149	1125315	1966-03-27	1966-04-10	1	-1362
66655	4550	1759842	1985-04-02	1985-04-23	1	5591
45465	3084	19127890	1991-11-20	1993-11-09	2	8713
69645	4753	1125315	1973-04-24	1973-05-08	1	1223
6630	457	1759842	2003-02-24	2003-03-17	1	12128
50469	3437	1717327	1977-05-16	1977-05-30	1	2706
38066	2588	1149380	2014-08-31	2014-08-31	1	16313
31775	2150	1112807	1961-02-21	1961-03-14	1	-3215
10567	726	1125315	1988-06-24	1988-07-01	1	6756
37672	2559	1125315	1986-03-13	1986-03-20	1	5922
50053	3410	920293	1995-05-22	1995-05-29	1	9279
16443	1135	1119510	1992-01-04	1992-01-18	1	8052
35647	2423	1713332	1959-04-08	1959-04-15	1	-3914
19635	1339	738818	2001-05-12	2001-05-19	1	11461
28988	1962	1521369	1980-03-25	1982-03-15	2	4456
69739	4758	1125315	1985-05-08	1985-05-15	1	5613
60848	4149	1717327	1970-11-12	1970-11-26	1	329
67820	4630	920293	1983-02-24	1983-03-10	2	4816
45466	3084	19127890	1995-10-30	1996-10-24	1	9793
69646	4753	1503184	1978-05-19	1979-05-14	1	3420
6631	457	920293	2009-09-10	2009-09-17	1	14504
50470	3437	1112807	1915-03-13	1915-05-12	1	-19958
38067	2588	1503184	1978-08-27	1979-08-22	1	3520
31776	2150	1112807	1965-12-18	1966-01-08	1	-1454
10568	726	1503184	1977-07-05	1978-06-30	1	3102
37673	2559	1125315	2014-01-11	2014-02-01	1	16102
50054	3410	1112807	1965-05-10	1965-05-31	1	-1676
16444	1135	1728416	1959-09-04	1959-09-18	1	-3758
35648	2423	1124300	1997-09-02	1997-09-02	1	10106
19636	1339	1112807	1973-05-12	1973-08-10	1	1317
28989	1962	1729720	1968-06-13	1968-06-23	1	-557
69740	4758	1125315	1991-05-06	1991-05-27	1	7816
63136	4313	1728416	1950-01-04	1950-01-18	1	-7288
67821	4630	933724	1983-02-24	1983-03-10	1	4816
45467	3084	914335	2015-10-21	2015-10-21	1	16729
69647	4753	1503184	1980-05-08	1981-05-03	1	4140
6632	457	1102527	1998-07-11	1998-07-11	1	10418
50471	3437	1112807	1921-03-09	1921-05-08	1	-17770
38068	2588	738818	1981-05-01	1981-05-08	1	4145
31777	2150	1115008	2017-02-28	2017-03-28	1	17253
10569	726	1713332	1982-05-25	1982-06-01	1	4534
37674	2559	1728416	1958-07-15	1958-07-29	1	-4174
50055	3410	1119510	2018-03-14	2018-03-21	1	17611
16445	1135	1118084	1999-06-05	1999-06-05	1	10747
35649	2423	1125315	1970-01-14	1970-01-28	1	27
19637	1339	1118084	2006-03-20	2006-03-20	1	13227
29736	2012	1112807	1971-05-10	1971-05-24	1	508
69741	4758	1125315	1995-10-21	1995-11-04	1	9438
63137	4313	1759842	1975-12-12	1976-01-02	1	2192
67822	4630	1118084	1993-04-07	1993-04-07	1	8497
45468	3084	1125315	2017-04-18	2017-05-18	1	17304
69648	4753	1503184	1982-04-28	1983-04-23	1	4860
6633	457	1125315	1969-08-09	1969-08-23	1	-131
50472	3437	1125315	1976-12-28	1977-01-04	1	2560
38069	2588	1125315	1966-06-22	1966-06-29	1	-1282
31778	2150	1125315	1954-12-27	1955-01-10	1	-5470
10570	726	1119510	1988-06-24	1988-07-01	1	6756
37675	2559	1728416	1961-07-18	1961-08-01	1	-3075
50056	3410	1713332	1996-05-03	1996-05-17	1	9633
16446	1135	1125315	1959-04-26	1959-05-10	1	-3889
35650	2423	1125315	2005-10-02	2005-10-09	1	13065
19638	1339	1119510	2018-07-16	2018-07-23	1	17735
29737	2012	1713332	1966-05-21	1966-06-11	1	-1300
69742	4758	1125315	1999-11-11	2000-02-09	1	10996
63138	4313	1112807	1949-05-09	1949-05-30	1	-7521
67823	4630	1759842	1970-06-30	1970-07-21	1	201
45469	3084	1125315	1982-03-03	1982-03-17	1	4458
69649	4753	1521369	1975-06-04	1976-05-29	1	2340
6634	457	1177480	1996-09-07	1996-10-12	1	9781
50473	3437	1713332	1951-02-15	1951-03-01	1	-6881
38070	2588	1125315	1967-03-06	1967-03-13	1	-1025
31779	2150	1125315	1958-04-08	1958-06-07	1	-4226
10571	726	1125315	1984-08-18	1984-08-25	1	5350
37676	2559	1125315	1960-12-02	1960-12-09	1	-3310
50057	3410	1713332	1999-04-08	1999-04-22	1	10703
16447	1135	1125315	1981-01-01	1981-01-15	1	4032
35651	2423	1177480	1992-11-01	1992-11-22	1	8361
19639	1339	1125315	1968-12-29	1969-03-29	1	-278
29738	2012	1125315	1957-08-31	1957-09-14	1	-4492
69743	4758	1713332	1979-10-24	1979-10-31	1	3590
63139	4313	1125315	1953-09-06	1953-10-06	1	-5931
67824	4630	1112807	1966-10-10	1966-10-31	1	-1158
45470	3084	1177480	1978-04-22	1978-05-06	1	3047
69650	4753	1729720	1982-12-31	1983-01-12	1	4759
6635	457	1728416	1969-08-09	1969-08-23	1	-131
50474	3437	1713332	1982-05-15	1982-06-05	1	4538
38071	2588	1125315	1972-06-03	1972-07-08	1	919
31780	2150	1125315	1968-02-25	1968-03-03	1	-669
10572	726	1125315	2013-05-23	2013-06-06	1	15862
37677	2559	1713332	1987-11-04	1987-11-18	1	6530
50058	3410	1728416	1966-09-13	1966-09-27	1	-1192
16448	1135	1125315	2014-07-13	2014-07-27	1	16278
35652	2423	1729720	1967-12-08	1967-12-16	1	-747
19922	1357	1118084	2014-11-07	2014-11-07	1	16381
29739	2012	1728416	1959-12-18	1960-01-01	1	-3653
69744	4758	1125315	2013-06-09	2013-06-16	1	15872
63140	4313	1125315	1991-08-28	1991-09-04	1	7916
67825	4630	1119510	1985-08-20	1985-09-03	1	5724
45471	3084	1549786	1991-11-20	1993-11-09	2	8713
69651	4753	1759842	1989-10-24	1989-10-31	1	7243
11049	757	920293	1944-01-14	1944-01-21	1	-9477
50475	3437	1759842	1970-10-26	1970-11-09	1	312
38072	2588	1125315	1981-05-01	1981-05-08	1	4145
31781	2150	1713332	1977-03-30	1977-04-13	1	2659
10573	726	1521369	1977-07-05	1978-06-30	1	3102
37678	2559	1717327	1962-10-05	1962-10-19	1	-2631
50059	3410	1729720	1980-07-03	1980-07-14	1	3847
16449	1135	1728416	1959-04-26	1959-05-10	1	-3889
35653	2423	1759842	1959-04-08	1959-04-15	1	-3914
19923	1357	1125315	1976-10-18	1976-10-25	1	2489
29740	2012	1728416	1971-05-10	1971-05-24	1	508
69745	4758	1309944	1989-08-13	1989-08-13	1	7164
63141	4313	1125315	2006-02-18	2006-02-25	1	13204
67826	4630	1125315	1959-03-09	1959-03-23	1	-3937
47069	3194	738818	1968-01-02	1968-01-09	1	-723
69652	4753	1112807	1962-03-04	1962-03-18	1	-2846
11050	757	1119510	1935-05-24	1935-06-07	1	-12627
50476	3437	1759842	1982-05-15	1982-06-05	1	4538
38073	2588	1177480	2008-06-10	2008-06-24	1	14054
31782	2150	1728416	1951-07-14	1951-07-28	1	-6732
10574	726	1713332	1986-12-12	1986-12-19	1	6196
37679	2559	1759842	1987-11-04	1987-11-18	1	6530
50060	3410	19127890	1980-04-01	1981-03-27	1	4103
16790	1155	1112807	1967-10-14	1967-10-28	1	-796
35654	2423	933724	1996-11-16	1996-11-23	1	9823
19924	1357	1125315	1980-03-18	1980-03-25	1	3736
29741	2012	1759842	1966-05-21	1966-06-11	1	-1300
69746	4758	1343916	1989-08-13	1989-08-13	1	7164
63142	4313	1112807	1950-01-04	1950-01-18	1	-7288
67827	4630	1125315	1973-07-15	1973-07-22	1	1298
47070	3194	1125315	1968-01-02	1968-01-09	1	-723
69653	4753	1112807	1968-04-01	1968-05-01	1	-610
11051	757	1326303	1976-01-11	1976-01-11	1	2201
50477	3437	1112807	1936-03-20	1936-04-03	1	-12326
38074	2588	1521369	1978-08-27	1979-08-22	1	3520
32293	2186	1125315	1974-06-03	1974-06-17	1	1628
10575	726	1759842	1986-12-12	1986-12-19	1	6196
37680	2559	1112807	1958-07-15	1958-07-29	1	-4174
50061	3410	19127890	1982-03-22	1983-03-17	1	4823
16791	1155	1112807	1989-04-08	1989-04-22	1	7051
35655	2423	1125315	1987-11-30	1987-12-28	1	6570
19925	1357	1125315	1976-01-21	1976-02-25	1	2246
29742	2012	1102527	1970-07-23	1970-07-23	1	203
69747	4758	1713332	1969-09-29	1969-10-13	1	-80
63143	4313	1112807	1958-09-10	1958-10-01	1	-4110
67828	4630	1125315	1982-08-08	1982-08-29	1	4623
47071	3194	1125315	1974-08-24	1974-08-31	1	1703
69654	4753	1717327	1966-03-26	1966-04-09	1	-1363
11052	757	1713332	1934-02-03	1934-02-10	1	-13109
50478	3437	1112807	1938-03-24	1938-04-28	1	-11571
39212	2666	738818	1955-07-25	1955-08-01	1	-5267
32294	2186	1125315	1975-12-14	1975-12-28	1	2187
12913	883	933724	2007-08-30	2007-09-06	1	13762
37681	2559	1112807	1961-07-18	1961-08-01	1	-3075
50062	3410	19127890	1984-03-11	1986-03-01	2	5903
16792	1155	1125315	1981-03-04	1981-04-03	1	4110
35656	2423	1713332	1957-08-26	1957-09-09	1	-4497
19926	1357	1125315	2015-04-22	2015-05-06	1	16561
29743	2012	1112807	1976-02-22	1976-03-07	1	2257
69748	4758	1759842	1979-10-24	1979-10-31	1	3590
63144	4313	1713332	1975-12-12	1976-01-02	1	2192
67829	4630	1125315	2012-01-15	2012-01-22	1	15361
47072	3194	1361711	1971-01-11	1971-01-11	1	375
69655	4753	19127890	1978-05-19	1979-05-14	1	3420
11053	757	1729720	1926-05-05	1926-05-15	1	-15937
50479	3437	1118084	1955-03-03	1955-03-03	1	-5418
39213	2666	1112807	1953-01-05	1953-02-02	1	-6177
32295	2186	1125315	2019-01-09	2019-04-09	2	17995
12914	883	1112807	1965-11-21	1965-12-05	1	-1488
37682	2559	1118084	1990-03-29	1990-03-29	1	7392
50063	3410	1112807	1964-08-13	1964-08-27	1	-1953
16793	1155	1125315	1990-01-04	1990-01-11	1	7315
36163	2459	1125315	1993-04-23	1993-05-23	1	8543
19927	1357	1125315	1978-04-19	1978-04-26	1	3037
29744	2012	1119510	2014-02-23	2014-03-02	1	16131
69749	4758	738818	1967-01-22	1967-01-29	1	-1068
63145	4313	1729720	1954-10-12	1954-10-19	1	-5553
67830	4630	1713332	1970-06-30	1970-07-21	1	201
47073	3194	1729720	1957-02-27	1957-03-09	1	-4681
69656	4753	19127890	1980-05-08	1981-05-03	1	4140
11054	757	1759842	1934-02-03	1934-02-10	1	-13109
50480	3437	1119510	1980-05-19	1980-06-02	1	3805
39214	2666	1112807	1954-10-27	1954-11-10	1	-5531
32296	2186	1729720	1974-10-02	1974-10-14	1	1747
12915	883	1119510	1987-01-24	1987-01-31	1	6239
37683	2559	1125315	1970-02-21	1970-03-07	1	65
50064	3410	1112807	1966-09-13	1966-09-27	1	-1192
16794	1155	1713332	1989-04-08	1989-04-22	1	7051
36164	2459	1521369	1993-06-06	1994-06-01	1	8917
19928	1357	1125315	1982-05-24	1982-07-23	1	4586
29745	2012	1125315	1968-03-10	1968-03-17	1	-655
69750	4758	1125315	1967-01-22	1967-01-29	1	-1068
63146	4313	1729720	1958-12-29	1959-01-05	1	-4014
67831	4630	1112807	1965-09-15	1965-11-14	1	-1509
47074	3194	975125	1968-06-19	1968-06-19	1	-561
69657	4753	19127890	1982-04-28	1983-04-23	1	4860
11055	757	1125315	1940-10-09	1940-10-23	1	-10662
50481	3437	1713332	1970-10-26	1970-11-09	1	312
40842	2771	1347450	1991-10-18	1991-10-18	1	7960
32297	2186	1738521	1974-06-03	1974-06-17	1	1628
12916	883	19127890	1978-05-27	1979-05-22	1	3428
37684	2559	1125315	1988-10-05	1988-11-09	1	6887
50065	3410	1125315	1978-02-06	1978-03-06	1	2986
16795	1155	1124300	2007-10-29	2007-10-29	1	13815
36165	2459	1713332	1980-06-30	1980-07-14	1	3847
19929	1357	1125315	2000-05-19	2000-06-09	1	11117
29746	2012	1125315	1983-03-08	1983-06-06	1	4904
69751	4758	1713332	2002-03-10	2002-03-31	1	11777
63147	4313	1118084	1980-01-27	1980-01-27	1	3678
67832	4630	1125315	1995-03-01	1995-03-15	1	9204
47075	3194	1112807	1950-07-03	1950-07-24	1	-7101
71940	4916	738818	1977-08-30	1977-09-06	1	2805
11056	757	1125315	1978-09-22	1978-10-06	1	3200
50482	3437	1729720	1916-05-09	1916-05-16	1	-19588
40843	2771	1746114	1974-09-02	1974-09-02	1	1705
32298	2186	1738521	1975-12-14	1975-12-28	1	2187
12917	883	738818	1968-05-11	1968-05-18	1	-593
37685	2559	1177480	2012-05-07	2012-05-21	1	15481
50066	3410	1713332	1979-04-05	1979-04-26	1	3402
16796	1155	1125315	1990-05-13	1990-05-20	1	7444
36166	2459	1713332	2007-06-07	2007-06-28	1	13692
19930	1357	1177480	1984-06-12	1984-09-10	1	5366
29747	2012	1125315	2009-11-21	2009-12-05	1	14583
69752	4758	1728416	1958-05-08	1958-05-22	1	-4242
63148	4313	1713332	1990-05-26	1990-06-02	1	7457
67833	4630	1125315	2002-11-14	2002-11-21	1	12012
47076	3194	1119510	1968-01-02	1968-01-09	1	-723
71941	4916	1125315	1977-08-30	1977-09-06	1	2805
11057	757	1125315	1988-10-13	1988-11-17	1	6895
50483	3437	1759842	1951-02-15	1951-03-01	1	-6881
43935	2970	1343916	1999-05-06	1999-05-06	1	10717
32299	2186	1118084	2014-10-16	2014-10-16	1	16359
12918	883	920293	2007-08-30	2007-09-06	1	13762
37686	2559	1125315	1960-06-16	1960-06-30	1	-3472
50067	3410	1713332	1985-11-06	1985-11-20	1	5802
16797	1155	1125315	1972-10-19	1972-10-26	1	1029
36167	2459	1729720	1984-06-15	1984-06-25	1	5289
19931	1357	1729720	1980-07-29	1980-08-06	1	3870
29748	2012	1177480	2006-06-05	2006-06-26	1	13325
69753	4758	1759842	1969-09-29	1969-10-13	1	-80
63149	4313	1759842	1990-05-26	1990-06-02	1	7457
67834	4630	1125315	2009-09-17	2009-10-01	1	14518
47077	3194	1125315	1980-11-29	1980-12-06	1	3992
71942	4916	1549786	1994-07-10	1995-07-05	1	9316
11058	757	1125315	1990-05-21	1990-05-28	1	7452
50484	3437	738818	1980-05-19	1980-06-02	1	3805
43936	2970	1124300	2004-11-27	2004-11-27	1	12749
32300	2186	1759842	2002-06-03	2002-06-24	1	11862
12919	883	933724	2006-07-17	2006-07-24	1	13353
37687	2559	1728416	1960-06-16	1960-06-30	1	-3472
50068	3410	1713332	2009-03-06	2009-03-27	1	14330
16798	1155	1125315	1974-02-19	1974-03-05	1	1524
36168	2459	1759842	2007-06-07	2007-06-28	1	13692
21138	1441	914335	1985-11-11	1985-11-11	1	5793
29749	2012	1713332	1973-04-12	1973-04-26	1	1211
69754	4758	1759842	2002-03-10	2002-03-31	1	11777
65510	4476	1125315	1962-04-21	1962-05-05	1	-2798
67835	4630	738818	1985-08-20	1985-09-03	1	5724
47078	3194	914335	1983-03-28	1983-03-28	1	4834
71943	4916	1713332	2003-10-12	2003-10-26	1	12351
11059	757	1310149	1976-01-11	1976-01-11	1	2201
50485	3437	1102527	1972-11-25	1972-11-25	1	1059
43937	2970	1125315	1981-02-23	1981-03-02	1	4078
32301	2186	1124957	2019-01-09	2019-01-09	1	17905
12920	883	1119510	2008-06-28	2008-07-05	1	14065
38958	2649	1125315	1964-02-29	1964-03-07	1	-2126
50069	3410	1759842	1979-04-05	1979-04-26	1	3402
16799	1155	1728416	1967-10-14	1967-10-28	1	-796
36169	2459	1112807	1980-06-30	1980-07-14	1	3847
21139	1441	1115008	1994-01-03	1994-01-17	1	8782
29750	2012	738818	2014-02-23	2014-03-02	1	16131
72205	4933	723013	1980-03-13	1980-07-24	1	3857
65511	4476	1125315	2008-08-03	2008-08-10	1	14101
67836	4630	1125315	1964-11-05	1964-11-19	1	-1869
47079	3194	1118084	1980-08-24	1980-08-24	1	3888
71944	4916	19127890	1994-07-10	1995-07-05	1	9316
11060	757	1729720	1928-05-07	1928-05-14	1	-15207
50486	3437	1112807	1920-03-16	1920-04-13	1	-18160
43938	2970	1177480	2015-01-15	2015-02-14	1	16480
32302	2186	1177480	1987-10-28	1987-11-11	1	6523
12921	883	1125315	1975-09-30	1975-10-14	1	2112
38959	2649	1125315	2005-04-23	2005-05-21	1	12924
50070	3410	1759842	1985-11-06	1985-11-20	1	5802
16800	1155	1125315	2007-10-19	2007-11-02	1	13819
36170	2459	1503184	1993-06-06	1994-06-01	1	8917
21140	1441	1118084	2012-11-26	2012-11-26	1	15670
29751	2012	1112807	1959-12-18	1960-01-01	1	-3653
72206	4933	1102527	1998-11-04	1998-11-04	1	10534
65512	4476	1192710	1964-03-10	1964-03-10	1	-2123
67837	4630	1125315	1985-08-20	1985-09-03	1	5724
47080	3194	1112807	1944-11-01	1944-11-15	1	-9178
71945	4916	19127890	1996-06-29	1997-06-24	1	10036
11061	757	738818	1935-05-24	1935-06-07	1	-12627
50487	3437	1125315	1972-11-25	1972-12-23	1	1087
43939	2970	1729720	1980-01-31	1980-02-11	1	3693
32303	2186	1177480	1996-02-27	1996-03-19	1	9574
12922	883	1125315	1986-03-20	1986-03-27	1	5929
38960	2649	1125315	2017-06-15	2017-06-22	1	17339
50071	3410	1759842	2009-03-06	2009-03-27	1	14330
16801	1155	1125315	2010-10-29	2010-11-05	1	14918
36171	2459	1515774	1992-06-11	1993-06-06	1	8557
21141	1441	1125315	1974-01-20	1974-02-19	1	1510
29752	2012	1112807	1978-02-25	1978-05-03	1	3044
72207	4933	1112807	1986-08-27	1986-10-01	1	6117
65513	4476	1503184	1976-02-15	1977-02-09	1	2596
67838	4630	1125315	1993-11-29	1993-12-13	1	8747
47081	3194	1125315	1954-05-04	1954-05-18	1	-5707
71946	4916	1112807	1978-06-24	1978-07-08	1	3110
11062	757	933724	1941-12-13	1941-12-20	1	-10239
50488	3437	1125315	1977-05-16	1977-05-30	1	2706
43940	2970	738818	2003-10-05	2003-10-12	1	12337
32304	2186	1713332	2002-06-03	2002-06-24	1	11862
12923	883	1112807	1970-01-29	1970-02-28	1	58
38961	2649	1112807	1972-12-23	1973-01-13	1	1108
51653	3518	1125315	2006-11-16	2006-11-23	1	13475
16802	1155	1729720	1976-08-14	1976-08-22	1	2425
36172	2459	1515774	1994-06-01	1995-05-27	1	9277
21142	1441	1125315	1994-10-02	1994-10-02	1	9040
29753	2012	1118084	1994-04-13	1994-04-13	1	8868
72208	4933	1177480	1980-03-03	1980-06-01	1	3804
65514	4476	1503184	1981-01-19	1982-01-14	1	4396
68939	4704	920293	2000-01-04	2000-01-18	2	10974
47082	3194	1309944	1983-03-28	1983-03-28	1	4834
71947	4916	1118084	2013-01-06	2013-01-06	1	15711
11063	757	933724	1944-01-14	1944-01-21	1	-9477
50489	3437	1125315	1980-05-19	1980-06-02	1	3805
43941	2970	1107830	1999-05-06	1999-05-06	1	10717
32305	2186	1125315	1975-05-14	1975-05-28	1	1973
12924	883	1119510	1968-05-11	1968-05-18	1	-593
38962	2649	1125315	1962-05-08	1962-05-22	1	-2781
51654	3518	1125315	2014-06-29	2014-07-06	1	16257
19261	1318	757627	2011-08-30	2011-08-30	1	15216
36173	2459	1549786	1992-06-11	1993-06-06	1	8557
21143	1441	1177480	1974-02-19	1974-03-05	1	1524
29754	2012	1125315	1965-06-02	1965-06-16	1	-1660
72209	4933	1713332	1972-12-26	1973-04-17	1	1202
65515	4476	1759842	1990-01-01	1990-01-15	1	7319
68940	4704	1717327	1968-02-06	1968-02-20	1	-681
47083	3194	1343916	1983-03-28	1983-03-28	1	4834
71948	4916	1119510	1977-08-30	1977-09-06	1	2805
11064	757	1118084	1949-11-14	1949-11-14	1	-7353
50490	3437	1728416	1972-11-25	1972-12-23	1	1087
43942	2970	1125315	1993-01-19	1993-02-09	1	8440
32306	2186	1125315	1986-10-28	1986-12-02	1	6179
12925	883	1125315	1987-01-24	1987-01-31	1	6239
38963	2649	1125315	2002-11-15	2002-11-29	1	12020
51655	3518	1125315	2018-08-24	2018-08-31	1	17774
19262	1318	1112807	1941-05-21	1941-06-04	1	-10438
36174	2459	1549786	1994-06-01	1995-05-27	1	9277
21144	1441	1309944	1985-11-11	1985-11-11	1	5793
29755	2012	1125315	1970-07-23	1970-08-22	1	233
72210	4933	1738521	1971-02-28	1971-03-14	1	437
65516	4476	19127890	1981-01-19	1982-01-14	1	4396
68941	4704	19127890	1982-12-06	1984-11-25	2	5442
47449	3222	738818	2002-11-21	2002-11-28	1	12019
71949	4916	1125315	1989-05-06	1989-05-20	1	7079
11065	757	1125315	1935-05-24	1935-06-07	1	-12627
50491	3437	1759842	1945-05-09	1945-05-30	1	-8982
43943	2970	1125315	2003-10-05	2003-10-12	1	12337
32307	2186	1125315	1987-02-26	1987-03-12	1	6279
12926	883	1177480	2008-03-24	2008-04-07	1	13976
38964	2649	1759842	1983-07-17	1983-08-07	1	4966
51656	3518	1177480	1981-09-29	1981-11-03	1	4324
19263	1318	1112807	1972-07-10	1972-07-31	1	942
36175	2459	1759842	2013-03-25	2013-04-15	1	15810
21145	1441	1343916	1985-11-11	1985-11-11	1	5793
29756	2012	1125315	2014-02-23	2014-03-02	1	16131
72211	4933	1759842	1997-11-04	1997-11-11	1	10176
65517	4476	1119510	2003-03-08	2003-03-22	1	12133
68942	4704	738818	1982-01-03	1982-01-10	1	4392
47450	3222	1112807	1956-04-19	1956-05-03	1	-4991
71950	4916	1549786	1996-06-29	1997-06-24	1	10036
11066	757	920293	1941-12-13	1941-12-20	1	-10239
50836	3457	1112807	1921-02-07	1921-02-21	1	-17846
43944	2970	1713332	2008-11-25	2008-12-02	1	14215
32308	2186	1125315	2003-09-09	2003-09-30	1	12325
12927	883	1728416	1965-11-21	1965-12-05	1	-1488
38965	2649	1118084	1993-01-15	1993-01-15	1	8415
51657	3518	1713332	1968-05-08	1968-05-22	1	-589
19264	1318	1119510	1942-06-16	1942-06-23	1	-10054
36176	2459	1118084	2015-08-31	2015-08-31	1	16678
21146	1441	1521369	1988-05-16	1989-05-11	1	7070
29757	2012	1759842	1973-04-12	1973-04-26	1	1211
72212	4933	723013	1978-03-03	1978-05-12	1	3053
65518	4476	1124300	2000-02-29	2000-02-29	1	11016
68943	4704	1112807	1969-01-01	1969-01-15	1	-351
47451	3222	1119510	2002-11-21	2002-11-28	1	12019
71951	4916	1729720	2010-07-10	2010-07-18	1	14808
11067	757	1112807	1940-10-22	1940-11-19	1	-10635
50837	3457	1759842	1947-07-12	1947-07-26	1	-8195
43945	2970	1759842	2008-11-25	2008-12-02	1	14215
32309	2186	1125315	2013-05-30	2013-06-13	1	15869
12928	883	738818	1987-01-24	1987-01-31	1	6239
38966	2649	1125315	1986-08-03	1986-08-31	1	6086
51658	3518	1112807	1968-08-03	1968-08-17	1	-502
19265	1318	1119510	1944-05-13	1944-05-27	1	-9350
36177	2459	1125315	2006-06-16	2006-06-23	1	13322
21147	1441	1115008	1994-10-02	1994-11-06	1	9075
30378	2054	1503184	1988-06-12	1989-06-07	1	7097
72213	4933	1112807	1970-12-30	1971-03-14	2	407
65519	4476	1521369	1976-02-15	1977-02-09	1	2596
68944	4704	1112807	1970-04-15	1970-04-29	1	118
47452	3222	1125315	2002-11-21	2002-11-28	1	12019
71952	4916	1125315	2005-05-27	2005-06-10	1	12944
11068	757	1125315	1974-02-24	1974-03-17	1	1536
50838	3457	738818	1919-06-19	1919-06-26	1	-18452
43946	2970	975125	1999-04-17	1999-04-17	1	10698
32310	2186	1129625	1975-03-01	1975-03-01	1	1885
12929	883	738818	2008-06-28	2008-07-05	1	14065
38967	2649	1125315	2011-02-19	2011-03-12	1	15045
51659	3518	1125315	1974-11-14	1974-11-28	1	1792
19266	1318	1125315	1998-06-06	1998-06-13	1	10390
36178	2459	1125315	2008-09-06	2008-09-13	1	14135
21148	1441	1125315	1976-10-08	1976-10-22	1	2486
30379	2054	1112807	1974-01-09	1974-01-23	1	1483
72214	4933	1115008	2007-08-19	2007-09-23	1	13779
65520	4476	914335	1975-05-04	1975-05-04	1	1949
68945	4704	1125315	1982-01-03	1982-01-10	1	4392
47453	3222	1713332	1996-06-21	1996-09-27	1	9766
71953	4916	1515774	1994-07-10	1995-07-05	1	9316
11069	757	1307863	1981-02-08	1981-02-08	1	4056
50839	3457	738818	1925-11-06	1925-11-20	1	-16113
43947	2970	1119510	2003-10-05	2003-10-12	1	12337
32311	2186	1728416	1975-05-14	1975-05-28	1	1973
12930	883	920293	2006-07-17	2006-07-24	1	13353
38968	2649	1713332	1983-07-17	1983-08-07	1	4966
51660	3518	1125315	1978-09-08	1978-10-15	1	3209
19267	1318	1307863	2017-08-01	2017-08-01	1	17379
36179	2459	1729720	1984-03-09	1984-03-16	1	5188
21149	1441	1125315	1993-10-10	1993-10-24	1	8697
30380	2054	1192710	1974-07-14	1974-07-14	1	1655
72215	4933	1759842	1972-12-26	1973-04-17	1	1202
65521	4476	920293	1989-03-10	1989-03-17	1	7015
68946	4704	1125315	1998-04-13	1998-04-27	1	10343
47454	3222	738818	1958-08-25	1958-09-01	1	-4140
71954	4916	1515774	1996-06-29	1997-06-24	1	10036
11736	806	1124300	1997-12-05	1997-12-05	1	10200
50840	3457	1112807	1921-04-08	1921-04-22	1	-17786
43948	2970	1125315	2018-09-25	2018-10-02	1	17806
33880	2300	723013	1950-01-26	1950-08-24	1	-7070
12931	883	1124300	2003-02-25	2003-02-25	1	12108
38969	2649	1112807	1971-01-05	1971-02-02	1	397
51661	3518	1759842	1968-05-08	1968-05-22	1	-589
19268	1318	1326303	2017-08-01	2017-08-01	1	17379
36180	2459	19127890	1992-06-11	1995-05-27	3	9277
21150	1441	1125315	2008-10-25	2008-11-01	1	14184
30381	2054	1521369	1988-06-12	1989-06-07	1	7097
72216	4933	1112807	1974-11-09	1974-11-30	1	1794
65522	4476	920293	1992-04-11	1992-04-18	1	8143
68947	4704	1177480	2010-09-21	2010-10-26	1	14908
47455	3222	1119510	2017-05-19	2017-05-26	1	17312
71955	4916	1125315	1990-03-07	1990-04-06	1	7400
11737	806	1125315	1971-02-17	1971-03-03	1	426
50841	3457	1112807	1938-07-06	1938-07-20	1	-11488
43949	2970	1729720	2017-05-23	2017-05-30	1	17316
33881	2300	738818	1974-11-08	1974-11-15	1	1779
12932	883	1125315	1968-05-11	1968-05-18	1	-593
38970	2649	1713332	1999-08-12	1999-09-02	1	10836
51662	3518	1102527	1978-09-15	1978-09-15	1	3179
19269	1318	1713332	1954-09-26	1954-10-17	1	-5555
36181	2459	1125315	2015-03-23	2015-04-06	1	16531
21151	1441	1713332	1994-01-03	1994-01-17	1	8782
30382	2054	1125315	1987-01-11	1987-01-25	1	6233
72217	4933	1118084	2007-06-14	2007-06-14	1	13678
65523	4476	933724	1989-03-10	1989-03-17	1	7015
68948	4704	1713332	1991-11-09	1991-11-16	1	7989
47456	3222	1124300	1993-03-12	1993-03-12	1	8471
71956	4916	1759842	2003-10-12	2003-10-26	1	12351
11738	806	1125315	1983-09-05	1983-09-12	1	5002
50842	3457	1112807	1986-03-31	1986-06-29	1	6023
47598	3232	1125315	1983-11-21	1983-12-05	1	5086
33882	2300	1112807	1993-02-28	1993-03-28	1	8487
12933	883	1125315	2008-06-28	2008-07-05	1	14065
38971	2649	1759842	1999-08-12	1999-09-02	1	10836
51663	3518	1112807	1967-06-12	1967-07-10	1	-906
19270	1318	1713332	1984-10-24	1984-11-07	1	5424
36182	2459	1713332	2013-03-25	2013-04-15	1	15810
21152	1441	975125	1974-03-06	1974-03-27	1	1546
30383	2054	1177480	2014-07-22	2014-10-20	1	16363
72218	4933	1125315	1984-09-08	1984-10-06	1	5392
65524	4476	933724	1992-04-11	1992-04-18	1	8143
68949	4704	1759842	1991-11-09	1991-11-16	1	7989
47457	3222	1125315	1958-08-25	1958-09-01	1	-4140
76662	5240	738818	1942-01-14	1942-01-21	1	-10207
11739	806	738818	2009-01-18	2009-01-25	1	14269
50843	3457	1125315	1925-11-06	1925-11-20	1	-16113
47599	3232	1713332	1967-02-02	1967-02-23	1	-1043
33883	2300	1125315	1957-09-18	1957-10-02	1	-4474
12934	883	1503184	1978-05-27	1979-05-22	1	3428
41775	2832	1115008	2003-04-26	2003-07-25	1	12258
51664	3518	1118084	1994-03-12	1994-03-12	1	8836
19271	1318	1759842	1984-10-24	1984-11-07	1	5424
36183	2459	1729720	1977-07-19	1977-07-29	1	2766
21153	1441	1124957	1994-10-02	1994-10-02	1	9040
30384	2054	19127890	1988-06-12	1989-06-07	1	7097
72219	4933	1177480	1998-10-28	1998-12-04	1	10564
65525	4476	1125315	1992-05-25	1992-06-01	1	8187
68950	4704	19127890	1986-11-15	1987-11-10	1	6522
47458	3222	1125315	2011-01-03	2011-01-10	1	14984
76663	5240	1115008	1997-04-08	1997-06-07	1	10019
11740	806	1112807	1962-01-03	1962-01-17	1	-2906
50844	3457	1713332	1987-09-25	1987-10-09	1	6490
47600	3232	1759842	1967-02-02	1967-02-23	1	-1043
33884	2300	1125315	1991-05-09	1991-05-16	1	7805
12935	883	1521369	1978-05-27	1979-05-22	1	3428
41776	2832	1125315	1988-10-11	1988-10-25	1	6872
51665	3518	1729720	1987-05-16	1987-05-26	1	6354
19272	1318	1118084	1973-02-17	1973-02-17	1	1143
37329	2541	1125315	1987-03-01	1987-03-08	1	6275
21154	1441	1177480	1999-06-13	1999-07-18	1	10790
30385	2054	1118084	2010-08-28	2010-08-28	1	14849
72220	4933	1713332	1997-11-04	1997-11-11	1	10176
65526	4476	1125315	2001-12-25	2002-01-15	1	11702
68951	4704	933724	2000-01-04	2000-01-18	1	10974
47459	3222	1125315	2015-06-10	2015-06-24	1	16610
76664	5240	1124300	1984-05-31	1984-05-31	1	5264
11741	806	1115008	2010-01-03	2010-04-03	1	14702
50845	3457	1112807	1930-12-01	1930-12-15	1	-14262
47601	3232	1118084	2004-06-27	2004-06-27	1	12596
33885	2300	1149380	1974-11-14	1974-11-14	1	1778
12936	883	1729720	1969-04-07	1969-04-15	1	-261
41777	2832	1521369	1981-02-04	1982-01-30	1	4412
51793	3528	740275	1958-11-03	1958-12-29	1	-4021
19273	1318	1125315	1997-10-24	1997-11-07	1	10172
37330	2541	1125315	2003-11-06	2003-12-06	2	12392
21155	1441	1503184	1988-05-16	1989-05-11	1	7070
30386	2054	1125315	1973-04-16	1973-04-23	1	1208
77072	5267	1125315	2008-09-26	2008-10-03	1	14155
65527	4476	1309944	1975-05-04	1975-05-04	1	1949
68952	4704	1118084	2010-07-25	2010-07-25	1	14815
47460	3222	1112807	1952-01-27	1952-02-10	1	-6535
76665	5240	1125315	1942-01-14	1942-01-21	1	-10207
11742	806	1115008	2012-03-23	2012-04-27	1	15457
50846	3457	1119510	1919-06-19	1919-06-26	1	-18452
47602	3232	1125315	1999-07-14	1999-08-11	1	10814
33886	2300	1713332	1987-01-08	1987-01-29	1	6237
12937	883	1729720	1969-09-14	1969-09-23	1	-100
41778	2832	975125	1994-02-17	1994-02-17	1	8813
51794	3528	1118084	1998-03-13	1998-03-13	1	10298
19274	1318	1729720	1949-10-09	1949-10-16	1	-7382
37331	2541	1347450	1998-08-10	1998-08-10	1	10448
21156	1441	975125	1978-02-09	1978-02-23	1	2975
30387	2054	1125315	1985-05-11	1985-05-25	1	5623
77073	5267	1343916	1995-12-23	1995-12-23	1	9487
65528	4476	1343916	1975-05-04	1975-05-04	1	1949
68953	4704	1125315	1972-01-17	1972-01-24	1	753
47461	3222	1119510	1958-08-25	1958-09-01	1	-4140
76666	5240	1125315	1956-12-06	1956-12-13	1	-4767
11743	806	1119510	2009-01-18	2009-01-25	1	14269
50847	3457	1119510	1925-11-06	1925-11-20	1	-16113
47603	3232	1322184	2019-04-29	2019-04-29	1	18015
33887	2300	1112807	1955-12-26	1956-03-25	1	-5030
15842	1097	1124300	2004-05-07	2004-05-07	1	12545
41779	2832	1102527	2003-04-26	2003-04-26	1	12168
51795	3528	1125315	1961-12-19	1962-01-02	1	-2921
19275	1318	1759842	1954-09-26	1954-10-17	1	-5555
37332	2541	1503184	1989-09-25	1990-09-20	1	7567
21157	1441	1115008	2018-11-05	2018-11-26	1	17861
30388	2054	1177480	2019-06-26	2019-06-26	1	18073
77074	5267	1503184	1984-11-09	1985-11-04	1	5786
65529	4476	1551099	1972-12-22	1972-12-22	1	1086
68954	4704	1125315	1982-09-04	1982-11-03	1	4689
47462	3222	1125315	1959-04-20	1959-05-20	2	-3879
76667	5240	1125315	1974-05-22	1974-06-19	1	1630
11744	806	1125315	1967-03-06	1967-03-20	1	-1018
50848	3457	1125315	1919-06-19	1919-06-26	1	-18452
47604	3232	1347450	2019-04-29	2019-04-29	1	18015
33888	2300	1112807	1960-12-29	1961-01-12	1	-3276
15843	1097	1125315	1976-06-18	1976-07-02	1	2374
41780	2832	1124300	2000-06-25	2000-06-25	1	11133
51796	3528	1125315	1993-08-31	1993-09-28	1	8671
19276	1318	1112807	1949-05-07	1949-06-11	1	-7509
37333	2541	1738521	1977-06-20	1977-07-04	1	2741
21158	1441	1177480	2013-11-01	2013-12-31	1	16070
30389	2054	1729720	1979-10-13	1979-10-21	1	3580
77075	5267	1503184	1986-10-30	1987-10-25	1	6506
65530	4476	19127890	1976-02-15	1977-02-09	1	2596
68955	4704	1125315	2009-11-01	2009-11-08	1	14556
47463	3222	1322184	2012-10-30	2012-10-30	1	15643
76668	5240	1125315	2001-12-13	2002-01-03	1	11690
11745	806	1125315	2009-01-18	2009-01-25	1	14269
50849	3457	1125315	1960-04-25	1960-05-16	1	-3517
47605	3232	1729720	1969-06-17	1969-06-24	1	-191
33889	2300	1125315	1974-11-08	1974-11-15	1	1779
15844	1097	1125315	1978-07-10	1978-07-24	1	3126
41781	2832	1503184	1981-02-04	1982-01-30	1	4412
51797	3528	1125315	2011-11-04	2011-11-11	1	15289
19277	1318	1115008	2010-06-12	2010-07-03	1	14793
37334	2541	19127890	1992-09-17	1993-09-12	1	8655
21159	1441	1713332	1994-10-02	1994-11-06	1	9075
31916	2160	1125315	1995-11-14	1995-11-21	1	9455
77076	5267	19127890	1986-10-30	1987-10-25	1	6506
65531	4476	738818	2003-03-08	2003-03-22	1	12133
68956	4704	1503184	1982-12-06	1984-11-25	2	5442
47464	3222	1759842	1996-06-21	1996-09-27	1	9766
76669	5240	1177480	1976-05-23	1976-06-20	1	2362
11746	806	1717327	1962-01-03	1962-01-17	1	-2906
50850	3457	1124300	1952-08-13	1952-08-13	1	-6350
47606	3232	1125315	1964-07-12	1964-08-02	1	-1978
33890	2300	1125315	2010-08-01	2010-08-22	1	14843
15845	1097	1125315	2001-12-28	2002-01-04	1	11691
41782	2832	19127890	1979-02-11	1980-02-06	1	3688
51798	3528	1177480	2015-05-04	2015-06-03	1	16589
19278	1318	701322	2012-08-24	2012-08-24	1	15576
37335	2541	1125315	1977-06-20	1977-07-04	1	2741
21160	1441	19127890	1988-05-16	1989-05-11	1	7070
31917	2160	1125315	2014-05-23	2014-06-13	1	16234
77077	5267	920293	1994-12-25	1995-01-01	1	9131
65532	4476	1112807	1968-08-15	1968-11-13	1	-414
68957	4704	1521369	1986-11-15	1987-11-10	1	6522
47465	3222	738818	2017-05-19	2017-05-26	1	17312
76670	5240	920293	1988-08-26	1988-09-02	1	6819
11747	806	1125315	1962-07-02	1962-07-30	1	-2712
50851	3457	1125315	1987-09-25	1987-10-09	1	6490
50607	3443	920293	2006-04-10	2006-04-17	1	13255
33891	2300	1137529	1974-11-14	1974-11-14	1	1778
15846	1097	1347450	2016-09-15	2016-09-15	1	17059
41783	2832	920293	2008-03-21	2008-03-28	1	13966
51799	3528	723013	1960-10-10	1961-07-31	1	-3076
19279	1318	738818	1942-06-16	1942-06-23	1	-10054
37336	2541	1125315	1994-04-11	1994-04-18	1	8873
22745	1543	1125315	1994-10-23	1994-10-23	1	9061
31918	2160	1713332	1981-07-27	1981-08-03	1	4232
77078	5267	933724	1994-12-25	1995-01-01	1	9131
65533	4476	1112807	1971-06-01	1971-06-15	1	530
68958	4704	1729720	1968-10-05	1968-10-17	1	-441
47466	3222	1115008	2007-08-06	2007-08-27	1	13752
76671	5240	933724	1988-08-26	1988-09-02	1	6819
13946	956	1112807	1950-04-08	1950-06-07	1	-7148
50852	3457	1125315	2011-04-18	2011-04-25	1	15089
50608	3443	1503184	1992-02-28	1993-02-22	1	8453
33892	2300	1713332	2001-01-24	2001-01-31	1	11353
15847	1097	1759842	1978-01-15	1978-02-05	1	2957
41784	2832	1521369	1979-02-11	1980-02-06	1	3688
51800	3528	1125315	1994-05-17	1994-05-24	1	8909
19280	1318	738818	1944-05-13	1944-05-27	1	-9350
37337	2541	1125315	1999-02-23	1999-03-09	1	10659
22746	1543	1539403	1991-09-08	1991-09-08	1	7920
31919	2160	1717327	1962-03-03	1962-03-17	1	-2847
77079	5267	1729720	1971-05-15	1971-05-27	1	511
65534	4476	1125315	2003-03-08	2003-03-22	1	12133
68959	4704	1119510	1982-01-03	1982-01-10	1	4392
47467	3222	1125315	2017-05-19	2017-05-26	1	17312
76672	5240	1102527	1979-04-13	1979-04-13	1	3389
13947	956	1118084	1975-10-13	1975-10-13	1	2111
50853	3457	1713332	1947-07-12	1947-07-26	1	-8195
50609	3443	1515774	1991-03-05	1992-02-28	1	8093
33893	2300	1759842	2001-01-24	2001-01-31	1	11353
15848	1097	1521369	1985-03-13	1986-03-08	1	5910
41785	2832	1713332	1986-11-30	1986-12-21	1	6198
51801	3528	1759842	1965-02-05	1965-02-26	1	-1770
19281	1318	1112807	1943-04-04	1943-04-18	1	-9755
37338	2541	1322184	1998-08-10	1998-08-10	1	10448
22747	1543	738818	1941-06-19	1941-06-26	1	-10416
31920	2160	1728416	1963-07-13	1963-07-27	1	-2350
77080	5267	1729720	1979-03-04	1979-03-16	1	3361
65535	4476	1177480	1990-04-06	1990-04-27	1	7421
68960	4704	1125315	1968-02-06	1968-02-20	1	-681
47468	3222	1347450	2012-10-30	2012-10-30	1	15643
76673	5240	1125315	1982-11-08	1982-11-15	1	4701
13948	956	1125315	1950-04-08	1950-04-08	1	-7208
50854	3457	1729720	1926-10-11	1926-10-20	1	-15779
50610	3443	1549786	1993-02-22	1997-02-01	4	9893
33894	2300	1115008	2017-07-03	2017-07-17	1	17364
15849	1097	1729720	1972-09-22	1972-09-30	1	1003
41786	2832	1713332	1995-04-10	1995-04-17	1	9237
51802	3528	740275	1959-11-16	1960-06-13	1	-3489
19282	1318	1112807	1948-06-13	1948-07-11	1	-7844
37339	2541	1521369	1989-09-25	1990-09-20	1	7567
22748	1543	1125315	1941-06-19	1941-06-26	1	-10416
31921	2160	1759842	1981-07-27	1981-08-03	1	4232
77081	5267	1738521	1968-06-26	1968-07-10	1	-540
65536	4476	1521369	1981-01-19	1982-01-14	1	4396
68961	4704	1503184	1986-11-15	1987-11-10	1	6522
47469	3222	1728416	1952-01-27	1952-02-10	1	-6535
76674	5240	1177480	1979-04-06	1979-06-12	1	3449
13949	956	1125315	2004-01-31	2004-02-14	1	12462
53172	3623	1119510	1951-01-12	1951-01-19	1	-6922
50611	3443	1738521	1978-07-02	1978-07-16	1	3118
33895	2300	1778162	2017-07-03	2017-07-17	1	17364
15850	1097	920293	2008-04-17	2008-05-01	2	14000
41787	2832	1759842	1986-11-30	1986-12-21	1	6198
51803	3528	1115008	1997-07-09	1997-08-06	1	10079
19283	1318	1125315	1942-06-16	1942-06-23	1	-10054
37340	2541	1729720	1984-10-13	1984-10-26	1	5412
22749	1543	1125315	1971-07-21	1971-07-28	1	573
31922	2160	738818	2005-12-23	2005-12-30	1	13147
77082	5267	19127890	1984-11-09	1985-11-04	1	5786
65537	4476	1713332	1990-01-01	1990-01-15	1	7319
68962	4704	1521369	1982-12-06	1984-11-25	2	5442
48491	3296	738818	2004-07-04	2004-07-18	1	12617
76675	5240	1759842	1989-12-02	1989-12-16	1	7289
13950	956	1557272	2006-05-03	2006-05-03	1	13271
53173	3623	1125315	1999-03-14	1999-04-18	1	10699
50612	3443	19127890	1991-03-05	1997-02-01	6	9893
33896	2300	1118084	1990-07-30	1990-07-30	1	7515
15851	1097	1177480	2012-02-24	2012-03-09	1	15408
41788	2832	1759842	1995-04-10	1995-04-17	1	9237
51804	3528	1713332	1965-02-05	1965-02-26	1	-1770
19284	1318	1125315	1944-05-13	1944-05-27	1	-9350
37341	2541	1115008	1997-01-27	1997-02-10	1	9902
22750	1543	1713332	1988-09-12	1988-09-26	1	6843
31923	2160	920293	1993-08-05	1993-08-12	1	8624
77083	5267	1118084	2006-01-08	2006-01-08	1	13156
65802	4496	1125315	1972-03-02	1972-03-09	1	798
68963	4704	1738521	1970-04-15	1970-04-29	1	118
48492	3296	1112807	1949-02-19	1949-03-21	1	-7591
76676	5240	1112807	1969-06-19	1969-07-17	1	-168
13951	956	1713332	2009-01-15	2009-01-29	1	14273
53174	3623	1177480	1990-07-31	1990-08-28	1	7544
50613	3443	933724	2006-04-10	2006-04-17	1	13255
33897	2300	1119510	1974-11-08	1974-11-15	1	1779
15852	1097	1503184	1985-03-13	1986-03-08	1	5910
41789	2832	933724	2008-03-21	2008-03-28	1	13966
54273	3694	1125315	2017-09-14	2017-09-21	1	17430
19285	1318	1125315	2014-06-20	2014-07-04	1	16255
37342	2541	1118084	2017-12-07	2017-12-07	1	17507
22751	1543	1112807	1946-06-21	1946-09-19	1	-8505
31924	2160	920293	1993-10-27	1993-11-10	2	8714
77084	5267	1125315	1976-01-16	1976-02-20	1	2241
65803	4496	1713332	2006-10-11	2006-11-01	1	13453
69566	4748	920293	1996-11-04	1996-11-11	1	9811
48493	3296	1125315	2004-07-04	2004-07-18	1	12617
76677	5240	1119510	1942-01-14	1942-01-21	1	-10207
13952	956	1759842	2009-01-15	2009-01-29	1	14273
53175	3623	1112807	1966-03-18	1966-04-08	1	-1364
50614	3443	1112807	1981-10-28	1981-11-11	1	4332
33898	2300	1125315	1970-12-21	1971-01-25	1	389
15853	1097	1713332	1978-01-15	1978-02-05	1	2957
41790	2832	1107830	1994-03-05	1994-03-05	1	8829
54274	3694	1717327	1961-06-17	1961-07-01	1	-3106
19286	1318	1310149	2017-08-01	2017-08-01	1	17379
37343	2541	1124957	2003-11-06	2003-11-06	1	12362
22752	1543	1119510	1941-06-19	1941-06-26	1	-10416
31925	2160	933724	1993-08-05	1993-08-12	1	8624
77085	5267	1521369	1986-10-30	1987-10-25	1	6506
65804	4496	1728416	1949-01-01	1949-01-15	1	-7656
69567	4748	1112807	1946-08-27	1946-11-25	1	-8438
48494	3296	1125315	2016-02-24	2016-02-24	1	16855
76678	5240	1177480	1975-06-14	1975-06-28	1	2004
13953	956	1112807	1948-01-19	1948-04-18	1	-7928
53176	3623	1118084	1988-07-24	1988-07-24	1	6779
50615	3443	1125315	1978-07-02	1978-07-16	1	3118
33899	2300	1125315	2004-09-26	2004-10-31	1	12722
15854	1097	19127890	1985-03-13	1986-03-08	1	5910
41791	2832	1125315	2000-04-13	2000-04-27	1	11074
54275	3694	705944	1965-04-07	1966-02-09	1	-1422
19974	1360	1118084	2018-06-11	2018-06-11	1	17693
37344	2541	1125315	1991-08-06	1991-08-27	1	7908
22753	1543	1125315	1957-03-25	1957-05-24	1	-4605
31926	2160	1112807	1963-07-13	1963-07-27	1	-2350
77086	5267	1729720	1972-02-23	1972-03-07	1	796
65805	4496	1729720	1953-10-08	1953-10-20	1	-5917
69568	4748	1118084	1983-10-17	1983-10-17	1	5037
48495	3296	1759842	2000-04-24	2000-05-08	1	11085
76679	5240	1713332	1970-08-21	1970-10-09	1	281
13954	956	1112807	1950-08-29	1950-09-12	1	-7051
53177	3623	1125315	1958-02-02	1958-02-23	1	-4330
50616	3443	1515774	1993-02-22	1997-02-01	4	9893
33900	2300	1125315	2018-03-13	2018-04-17	1	17638
15855	1097	933724	2008-04-17	2008-05-01	1	14000
41792	2832	1343916	1994-03-05	1994-03-05	1	8829
54276	3694	723013	1971-08-24	1971-12-07	1	705
19975	1360	1125315	1977-03-28	1977-04-11	1	2657
37345	2541	1125315	2007-09-27	2007-10-11	1	13797
22754	1543	1332418	1994-09-25	1994-09-25	1	9033
31927	2160	1125315	2005-12-23	2005-12-30	1	13147
77087	5267	975125	1995-12-09	1995-12-09	1	9473
65806	4496	1112807	1949-01-01	1949-01-15	1	-7656
69569	4748	738818	1959-03-23	1959-04-06	1	-3923
48496	3296	723013	1966-09-18	1967-06-16	2	-956
76680	5240	1713332	1992-06-27	1992-07-04	1	8220
13955	956	1125315	1955-02-02	1955-02-23	1	-5426
53178	3623	1125315	2005-01-06	2005-01-20	1	12803
50617	3443	1515774	2000-01-17	2001-01-11	1	11333
33901	2300	1759842	1987-01-08	1987-01-29	1	6237
15856	1097	1322184	2016-09-15	2016-09-15	1	17059
41793	2832	1503184	1979-02-11	1980-02-06	1	3688
54277	3694	740275	1969-04-06	1969-09-14	1	-109
19976	1360	1125315	2009-11-12	2009-11-26	1	14574
37346	2541	1125315	2011-08-08	2011-08-15	1	15201
22755	1543	1361711	1986-08-24	1994-10-23	1	9061
31928	2160	933724	1993-10-27	1993-11-10	1	8714
77088	5267	1112807	1968-06-26	1968-07-10	1	-540
65807	4496	1125315	2006-10-11	2006-10-11	1	13432
69570	4748	933724	1996-11-04	1996-11-11	1	9811
48497	3296	1112807	1963-09-04	1963-10-02	1	-2283
76681	5240	1728416	1952-05-27	1952-06-10	1	-6414
13956	956	1174888	1950-04-08	1950-04-08	1	-7208
53179	3623	1713332	1953-12-30	1954-01-13	1	-5832
50618	3443	1521369	1992-02-28	1993-02-22	1	8453
34778	2351	757627	2018-06-02	2018-06-02	1	17684
17230	1189	1118084	2005-05-10	2005-05-10	1	12913
41794	2832	1713332	1988-10-11	1988-10-25	1	6872
54278	3694	1115008	1995-02-13	1995-04-14	1	9234
19977	1360	1125315	2013-06-17	2013-08-16	1	15933
37347	2541	1515774	1992-09-17	1993-09-12	1	8655
22756	1543	1759842	1988-09-12	1988-09-26	1	6843
31929	2160	1102527	2012-07-02	2012-07-02	1	15523
77089	5267	1129625	1995-12-23	1995-12-23	1	9487
65808	4496	1115008	2006-10-11	2006-11-01	1	13453
69571	4748	1125315	1959-03-23	1959-04-06	1	-3923
48498	3296	1124300	1980-06-26	1980-06-26	1	3829
76682	5240	1759842	1992-06-27	1992-07-04	1	8220
13957	956	1728416	1950-08-29	1950-09-12	1	-7051
53180	3623	1728416	1952-04-04	1952-04-18	1	-6467
50619	3443	1549786	1991-03-05	1992-02-28	1	8093
34779	2351	1112807	1949-05-13	1949-06-10	1	-7510
17231	1189	1125315	1968-11-05	1968-11-19	1	-408
41795	2832	19127890	1981-02-04	1982-01-30	1	4412
54279	3694	1124300	1995-11-16	1995-11-16	1	9450
19978	1360	1125315	2015-09-29	2015-10-06	1	16714
37348	2541	19127890	1989-09-25	1990-09-20	1	7567
22757	1543	1124300	1981-03-29	1981-03-29	1	4105
31930	2160	1112807	1962-03-03	1962-03-17	1	-2847
77090	5267	1521369	1984-11-09	1985-11-04	1	5786
65809	4496	1118084	1980-08-21	1980-08-21	1	3885
69572	4748	1125315	1970-08-16	1970-08-30	1	241
48499	3296	1125315	1998-04-22	1998-04-29	1	10345
76683	5240	920293	1985-07-17	1985-07-31	2	5690
13958	956	933724	1980-06-24	1980-07-01	1	3834
53181	3623	1728416	1954-06-10	1954-06-24	1	-5670
50620	3443	1589505	2003-01-01	2003-12-27	1	12413
34780	2351	1112807	1950-12-04	1950-12-18	1	-6954
17232	1189	1177480	1975-07-02	1975-08-01	1	2038
45846	3114	1125315	1950-12-04	1950-12-18	1	-6954
54280	3694	1125315	1961-06-17	1961-07-02	2	-3105
19979	1360	19127890	1990-09-26	1992-09-15	2	8293
37349	2541	1125315	1989-04-28	1989-05-05	1	7064
22758	1543	1174888	1994-10-23	1994-10-23	1	9061
31931	2160	1115008	1997-09-09	1997-09-23	1	10127
77091	5267	1713332	2001-11-25	2001-12-16	1	11672
65810	4496	1124957	2006-10-11	2006-10-11	1	13432
69573	4748	1125315	1982-10-22	1982-11-05	1	4691
48500	3296	1125315	2019-02-08	2019-04-09	1	17995
76684	5240	933724	1985-07-17	1985-07-31	1	5690
13959	956	1112807	1936-06-29	1936-07-13	1	-12225
53182	3623	1729720	1964-05-01	1964-05-11	1	-2061
50621	3443	1713332	1993-06-20	1993-07-04	1	8585
34781	2351	1124957	1993-07-22	1993-07-22	1	8603
17233	1189	1713332	1980-11-09	1980-11-23	1	3979
45847	3114	1713332	1976-10-27	1976-11-10	1	2505
54281	3694	1125315	1993-04-26	1993-05-24	1	8544
19980	1360	1177480	1977-08-30	1977-09-13	1	2812
37350	2541	1549786	1992-09-17	1993-09-12	1	8655
24420	1649	1119510	1969-11-02	1969-11-16	1	-46
31932	2160	1119510	2005-12-23	2005-12-30	1	13147
77092	5267	1759842	2001-11-25	2001-12-16	1	11672
65811	4496	1125315	1950-04-13	1950-04-27	1	-7189
69574	4748	1125315	1995-12-28	1996-01-11	1	9506
48501	3296	1729720	1948-08-21	1948-09-01	1	-7792
76685	5240	1112807	1939-08-26	1939-09-09	1	-11072
13960	956	1112807	1944-12-14	1945-01-04	1	-9128
53183	3623	1759842	1989-07-20	1989-07-27	1	7147
50622	3443	1759842	1993-06-20	1993-07-04	1	8585
34782	2351	1125315	1958-07-26	1958-08-09	1	-4163
17234	1189	1717327	1968-11-05	1968-11-19	1	-408
45848	3114	1728416	1950-12-04	1950-12-18	1	-6954
54282	3694	1177480	1984-02-22	1984-03-14	1	5186
19981	1360	1515774	1990-09-26	1992-09-15	2	8293
38542	2621	1102527	1999-06-17	1999-06-17	1	10759
24421	1649	1119510	1985-01-05	1985-01-12	1	5490
31933	2160	1125315	1982-09-14	1982-09-28	1	4653
65812	4496	1713332	1955-11-02	1955-11-23	1	-5153
69575	4748	1125315	2004-04-04	2004-04-11	1	12519
48502	3296	1124957	2016-02-24	2016-02-24	1	16855
76686	5240	1112807	1952-05-27	1952-06-10	1	-6414
13961	956	1112807	1969-10-12	1969-10-26	1	-67
53184	3623	1125315	1951-01-12	1951-01-19	1	-6922
50623	3443	19127890	2000-01-17	2001-01-11	1	11333
34783	2351	1125315	2009-11-25	2009-12-09	1	14587
17235	1189	1729720	2010-11-17	2010-11-24	1	14937
45849	3114	1112807	1961-02-01	1961-05-02	1	-3166
54283	3694	1177480	2006-07-15	2006-08-05	1	13365
19982	1360	1549786	1990-09-26	1992-09-15	2	8293
38543	2621	1713332	1964-05-14	1964-06-04	1	-2037
24422	1649	1174888	2017-08-23	2017-08-23	1	17401
31934	2160	1125315	1989-01-11	1989-01-18	1	6957
65813	4496	1728416	1950-04-13	1950-04-27	1	-7189
69576	4748	1112807	1984-10-25	1984-12-24	1	5471
48503	3296	1125315	1948-10-02	1948-10-09	1	-7754
76687	5240	1713332	1989-12-02	1989-12-16	1	7289
13962	956	1125315	1945-04-15	1945-04-22	1	-9020
53185	3623	1177480	2012-03-01	2012-04-05	1	15435
50624	3443	1177480	2018-11-28	2018-12-26	1	17891
34784	2351	1713332	1965-10-17	1965-11-07	1	-1516
17236	1189	1759842	2012-11-07	2012-11-28	1	15672
45850	3114	1118084	1983-02-21	1983-02-21	1	4799
54284	3694	1310149	2016-02-23	2016-02-23	1	16854
19983	1360	1729720	1993-12-11	1993-12-20	1	8754
38544	2621	1112807	1964-10-12	1964-10-26	1	-1893
24423	1649	1322184	2007-03-14	2017-08-23	1	17401
31935	2160	1729720	1974-05-16	1974-05-28	1	1608
65814	4496	920293	1985-04-19	1985-04-26	1	5594
69577	4748	1119510	1959-03-23	1959-04-06	1	-3923
48504	3296	1125315	1971-03-24	1971-04-21	1	475
76688	5240	1759842	1970-08-21	1970-10-09	1	281
13963	956	1125315	1949-08-29	1949-09-12	1	-7416
53186	3623	1713332	1989-07-20	1989-07-27	1	7147
50625	3443	1124300	2012-05-19	2012-05-19	1	15479
34785	2351	1112807	1964-03-07	1964-05-06	1	-2066
17237	1189	19127890	1977-11-28	1978-11-23	1	3248
45851	3114	1125315	1953-09-12	1953-09-26	1	-5941
54285	3694	1102527	1995-02-13	1995-02-13	1	9174
19984	1360	1729720	2016-03-28	2016-04-05	1	16896
38545	2621	1112807	1983-07-08	1983-07-29	1	4957
24424	1649	1545958	2017-08-23	2017-08-23	1	17401
31936	2160	1118084	1998-07-22	1998-07-22	1	10429
65815	4496	933724	1985-04-19	1985-04-26	1	5594
69578	4748	1124957	1997-07-26	1997-07-26	1	10068
48505	3296	1177480	2016-02-24	2016-05-24	1	16945
77093	5268	1118084	2004-01-04	2004-01-04	1	12421
13964	956	1729720	1941-11-04	1941-11-14	1	-10275
53187	3623	738818	1951-01-12	1951-01-19	1	-6922
50626	3443	1125315	1981-09-16	1981-09-23	1	4283
34786	2351	1125315	1966-03-27	1966-04-26	1	-1346
17238	1189	1177480	1980-03-07	1980-03-28	1	3739
45852	3114	1125315	1980-07-21	1980-08-11	1	3875
54286	3694	1112807	1971-08-29	1971-11-27	1	695
19985	1360	920293	2014-10-30	2014-11-06	1	16380
38546	2621	1124300	1994-07-02	1994-07-02	1	8948
24425	1649	738818	1969-11-02	1969-11-16	1	-46
31937	2160	1177480	2002-03-31	2002-04-21	1	11798
65816	4496	1112807	1960-12-29	1961-01-19	1	-3269
69579	4748	1759842	1954-12-21	1954-12-28	1	-5483
48506	3296	1713332	2000-04-24	2000-05-08	1	11085
77094	5268	1125315	2008-08-24	2008-08-24	1	14115
13965	956	920293	1980-06-24	1980-07-01	1	3834
53188	3623	1112807	1952-04-04	1952-04-18	1	-6467
50627	3443	1125315	1994-05-20	1994-06-03	1	8919
34787	2351	1125315	1968-03-16	1968-03-30	1	-642
17239	1189	1503184	1977-11-28	1978-11-23	1	3248
45853	3114	1713332	1979-10-04	1979-10-25	1	3584
54287	3694	1125315	2019-01-24	2019-02-07	1	17934
19986	1360	933724	2014-10-30	2014-11-06	1	16380
38547	2621	1125315	2004-01-26	2004-02-09	1	12457
24426	1649	1112807	1960-09-12	1960-12-11	1	-3308
31938	2160	1177480	2009-09-11	2009-10-09	1	14526
65817	4496	1112807	1964-08-01	1964-08-22	1	-1958
69580	4748	1112807	1946-06-28	1946-07-12	1	-8574
48507	3296	1729720	1949-09-29	1949-10-08	1	-7390
77095	5268	1728416	1965-09-25	1965-10-09	1	-1545
13966	956	1112807	1952-05-27	1952-06-17	1	-6407
53189	3623	1112807	1954-06-10	1954-06-24	1	-5670
50628	3443	1549786	2000-01-17	2001-01-11	1	11333
34788	2351	1713332	2000-08-10	2000-08-31	1	11200
17240	1189	1729720	2004-01-29	2004-02-11	1	12459
45854	3114	1729720	1958-04-03	1958-04-15	1	-4279
54288	3694	1307863	2016-02-23	2016-02-23	1	16854
19987	1360	1125315	1981-02-07	1981-02-14	1	4062
38548	2621	1729720	1957-12-04	1957-12-17	1	-4398
24427	1649	1125315	1969-11-02	1969-11-16	1	-46
31939	2160	1177480	2012-06-25	2012-08-31	1	15583
65818	4496	1112807	1970-06-22	1970-09-20	1	262
69581	4748	1112807	1965-05-19	1965-06-23	1	-1653
48508	3296	1759842	1993-11-04	1993-11-18	1	8722
77096	5268	1112807	1965-09-25	1965-10-09	1	-1545
13967	956	1125315	1956-02-18	1956-03-24	1	-5031
53190	3623	1112807	1961-02-07	1961-03-14	1	-3215
52272	3561	1115008	1998-08-22	1998-09-12	1	10481
34789	2351	1729720	1998-02-27	1998-03-11	1	10296
17241	1189	1125315	1964-09-27	1964-11-26	1	-1862
45855	3114	1759842	1976-10-27	1976-11-10	1	2505
54289	3694	1112807	1958-11-30	1958-12-21	1	-4029
19988	1360	1738521	1977-03-28	1977-04-11	1	2657
38549	2621	1112807	1969-09-21	1969-10-19	1	-74
24428	1649	1125315	2017-08-23	2017-08-23	1	17401
32521	2204	1112807	1959-07-30	1959-08-13	1	-3794
65819	4496	1125315	2010-04-21	2010-05-05	1	14734
69582	4748	1125315	1997-07-19	1997-08-25	2	10098
48509	3296	757627	2018-08-17	2018-08-17	1	17760
77097	5268	1125315	1979-05-09	1979-05-16	1	3422
13968	956	1125315	2001-03-24	2001-04-07	1	11419
53191	3623	1125315	2011-04-15	2011-05-06	1	15100
52273	3561	1125315	1949-02-12	1949-02-19	1	-7621
34790	2351	1759842	2000-08-10	2000-08-31	1	11200
17242	1189	1521369	1977-11-28	1978-11-23	1	3248
45856	3114	1759842	1979-10-04	1979-10-25	1	3584
54290	3694	1112807	1972-12-21	1973-01-20	1	1115
19989	1360	1713332	1999-12-11	1999-12-25	1	10950
38550	2621	1115008	1999-06-10	1999-08-16	1	10819
24429	1649	738818	1985-01-05	1985-01-12	1	5490
32522	2204	1118084	1986-11-16	1986-11-16	1	6163
65820	4496	1759842	1955-11-02	1955-11-23	1	-5153
69583	4748	1177480	1976-03-27	1976-06-25	1	2367
48510	3296	1112807	1937-07-22	1937-08-05	1	-11837
77098	5268	1759842	2015-08-06	2015-08-27	1	16674
13969	956	1125315	2014-09-28	2014-10-05	1	16348
53192	3623	1177480	2013-01-30	2013-02-13	1	15749
52274	3561	1125315	2007-08-24	2007-08-31	1	13756
34791	2351	701322	2019-04-28	2019-04-28	1	18014
17243	1189	1713332	2012-11-07	2012-11-28	1	15672
45857	3114	1125315	2013-02-19	2013-05-20	1	15845
54291	3694	1125315	1961-11-05	1961-11-19	1	-2965
19990	1360	1759842	1999-12-11	1999-12-25	1	10950
38551	2621	1125315	1966-09-16	1966-11-10	2	-1175
24430	1649	1124300	1993-05-17	1993-05-17	1	8537
32523	2204	1125315	1952-12-05	1952-12-19	1	-6222
68287	4662	753626	1989-07-27	1989-07-27	1	7147
69584	4748	1713332	1954-12-21	1954-12-28	1	-5483
48511	3296	1112807	1937-11-02	1937-11-16	1	-11734
77099	5268	1124957	2008-08-24	2008-08-24	1	14115
14171	970	738818	1966-12-24	1966-12-31	1	-1097
53193	3623	1729720	1956-06-27	1956-07-10	1	-4923
52275	3561	1307863	1981-08-17	1981-08-17	1	4246
34792	2351	715997	2019-04-28	2019-04-28	1	18014
17244	1189	1759842	1980-11-09	1980-11-23	1	3979
45858	3114	1177480	2016-04-04	2016-05-04	1	16925
54292	3694	1326303	2016-02-23	2016-02-23	1	16854
21559	1468	933724	1998-07-07	1998-07-14	1	10421
38552	2621	1125315	1986-01-29	1986-02-12	1	5886
24431	1649	1125315	1972-10-09	1972-10-30	1	1033
32524	2204	1713332	1964-04-18	1964-05-10	1	-2062
68288	4662	1112807	1966-12-23	1967-01-13	1	-1084
71790	4905	1125315	1982-07-11	1982-07-18	1	4581
48512	3296	1119510	2004-07-04	2004-07-18	1	12617
77100	5268	1125315	1972-03-24	1972-04-07	1	827
14172	970	1125315	1966-12-24	1966-12-31	1	-1097
53194	3623	1759842	1953-12-30	1954-01-13	1	-5832
52276	3561	1713332	1945-02-07	1945-03-28	1	-9045
34793	2351	1112807	1963-02-27	1963-03-13	1	-2486
17909	1235	1713332	1997-07-21	1997-08-04	1	10077
45859	3114	1729720	1960-02-07	1960-02-17	1	-3606
54578	3714	1112807	1956-06-28	1956-07-19	1	-4914
21560	1468	1112807	1958-01-29	1958-02-12	1	-4341
38553	2621	1177480	1989-04-28	1989-06-02	1	7092
24432	1649	1125315	1978-05-02	1978-05-23	1	3064
32525	2204	1728416	1948-10-26	1948-11-09	1	-7723
68289	4662	1125315	1965-01-02	1965-01-02	1	-1825
71791	4905	1115008	2018-09-20	2018-10-04	1	17808
48513	3296	1125315	1944-05-17	1944-05-24	1	-9353
77101	5268	1125315	2004-08-31	2004-09-14	1	12675
14173	970	1125315	1977-03-27	1977-04-10	1	2656
55450	3773	1112807	1961-05-16	1961-05-30	1	-3138
52277	3561	1713332	2007-03-15	2007-03-22	1	13594
34794	2351	1124300	1990-11-24	1990-11-24	1	7632
17910	1235	1729720	2005-02-20	2005-03-04	1	12846
45860	3114	1102527	2013-02-19	2013-02-19	1	15755
54579	3714	1112807	1964-01-09	1964-01-23	1	-2170
21561	1468	1119510	1981-06-16	1981-06-23	1	4191
38554	2621	1729720	1961-01-03	1961-01-11	1	-3277
24433	1649	1125315	1985-01-05	1985-01-12	1	5490
32526	2204	1759842	1946-11-14	1946-11-28	1	-8435
68290	4662	1367571	1989-07-27	1989-07-27	1	7147
71792	4905	1118084	2016-09-04	2016-09-04	1	17048
48514	3296	1713332	1993-11-04	1993-11-18	1	8722
77102	5268	1125315	2005-08-07	2005-08-14	1	13009
14174	970	1177480	2002-12-21	2003-01-18	1	12070
55451	3773	1124300	1996-10-09	1996-10-09	1	9778
52278	3561	1759842	2007-03-15	2007-03-22	1	13594
34795	2351	1125315	1993-07-22	1993-10-20	2	8693
17911	1235	1118084	2010-09-04	2010-09-04	1	14856
45861	3114	1112807	1946-10-18	1946-11-01	1	-8462
54580	3714	1119510	1924-06-07	1924-06-14	1	-16637
21562	1468	1125315	1951-10-05	1951-10-19	1	-6649
38555	2621	1729720	1994-11-17	1994-11-26	1	9095
24434	1649	1125315	1988-03-31	1988-04-21	1	6685
32527	2204	1759842	1972-02-17	1972-02-24	1	784
68291	4662	1759842	1958-08-30	1958-09-20	1	-4121
71793	4905	1125315	1978-07-31	1978-08-30	1	3163
48515	3296	1713332	1994-06-23	1994-07-14	1	8960
77103	5268	1177480	2008-08-24	2008-09-23	1	14145
14175	970	1713332	1952-12-14	1952-12-21	1	-6220
55452	3773	1713332	1969-12-07	1969-12-21	1	-11
52279	3561	1112807	1943-12-04	1944-01-03	1	-9495
34796	2351	1112807	1958-02-23	1958-05-24	1	-4240
17912	1235	19127890	1993-05-01	1994-04-26	1	8881
47850	3248	782043	2016-06-26	2016-06-26	1	16978
54581	3714	1119510	1985-10-03	1985-10-17	1	5768
21563	1468	1125315	1958-09-26	1958-10-10	1	-4101
38556	2621	1125315	1984-07-12	1984-07-26	1	5320
24435	1649	1361711	2007-03-14	2017-08-23	1	17401
32528	2204	1112807	1948-10-26	1948-11-09	1	-7723
68292	4662	782043	1989-07-27	1989-07-27	1	7147
71794	4905	1125315	2018-09-01	2018-09-08	1	17782
48516	3296	1759842	1994-06-23	1994-07-14	1	8960
77104	5268	1713332	2015-08-06	2015-08-27	1	16674
14176	970	1713332	1966-03-18	1966-04-01	1	-1371
55453	3773	1125315	1961-11-14	1961-11-28	1	-2956
52280	3561	1115008	1997-09-12	1997-09-26	1	10130
34797	2351	1115008	2011-09-30	2011-10-14	1	15261
17913	1235	1112807	1981-04-08	1981-04-22	1	4129
47851	3248	1326303	2007-03-30	2007-03-30	1	13602
54582	3714	1125315	1924-06-07	1924-06-14	1	-16637
21564	1468	1177480	1989-06-18	1989-07-23	1	7143
38557	2621	1713332	2009-03-20	2009-04-03	1	14337
24436	1649	1125315	1960-03-18	1960-03-25	1	-3569
32529	2204	1125315	1954-12-10	1954-12-24	1	-5487
68293	4662	791967	1989-07-27	1989-07-27	1	7147
71795	4905	19127890	1989-08-12	1990-08-07	1	7523
49860	3397	1112807	1957-12-06	1958-02-04	1	-4349
38457	2615	1759842	2010-02-16	2010-02-23	1	14663
14177	970	1713332	2000-03-03	2000-03-10	1	11026
55454	3773	1125315	1990-12-31	1991-01-14	1	7683
52281	3561	1118084	1943-11-09	1943-11-09	1	-9550
34798	2351	1125315	1978-09-04	1978-10-09	1	3203
17914	1235	1112807	1992-12-20	1993-01-10	1	8410
47852	3248	1728416	1946-07-08	1946-07-22	1	-8564
54583	3714	1557272	2012-12-19	2012-12-19	1	15693
21565	1468	1539403	1991-07-10	1991-07-10	1	7860
38558	2621	1759842	1964-05-14	1964-06-04	1	-2037
24437	1649	1125315	1994-10-26	1994-11-02	1	9071
32530	2204	1125315	1957-04-03	1957-06-10	1	-4588
68294	4662	967823	1989-07-27	1989-07-28	1	7148
71796	4905	1515774	1989-08-12	1990-08-07	1	7523
49861	3397	1118084	1981-12-25	1981-12-25	1	4376
40948	2779	1115008	2019-05-19	2019-06-02	1	18049
14178	970	1728416	1956-11-14	1956-11-28	1	-4782
55455	3773	1125315	2003-06-09	2003-06-16	1	12219
52282	3561	1125315	1967-04-02	1967-05-02	2	-975
34799	2351	1728416	1949-05-13	1949-06-10	1	-7510
17915	1235	1515774	1993-05-01	1994-04-26	1	8881
47853	3248	723013	2016-06-26	2016-06-26	1	16978
54584	3714	738818	1963-01-21	1963-01-28	1	-2530
21566	1468	1729720	1956-02-13	1956-02-23	1	-5061
38559	2621	1759842	2009-03-20	2009-04-03	1	14337
24438	1649	1332418	2007-03-14	2007-03-14	1	13586
32531	2204	1125315	1965-08-11	1965-08-25	1	-1590
68295	4662	1124300	1994-06-10	1994-06-10	1	8926
71797	4905	1549786	1989-08-12	1990-08-07	1	7523
49862	3397	1125315	1952-04-07	1952-04-21	1	-6464
40949	2779	1118084	2015-04-23	2015-04-23	1	16548
14179	970	1112807	1953-04-04	1953-07-03	1	-6026
55456	3773	1759842	1969-12-07	1969-12-21	1	-11
52283	3561	1125315	1977-07-15	1977-07-22	1	2759
34800	2351	1728416	1950-12-04	1950-12-18	1	-6954
17916	1235	1549786	1993-05-01	1994-04-26	1	8881
47854	3248	1000560	2016-06-26	2016-06-26	2	16978
54585	3714	1112807	1925-12-28	1926-01-11	1	-16061
21567	1468	1759842	1969-10-24	1969-10-31	1	-62
41546	2818	738818	1978-08-04	1978-08-11	1	3144
24439	1649	1539403	2007-03-14	2007-03-14	1	13586
32532	2204	1177480	1986-03-21	1986-04-04	1	5937
68296	4662	1124957	1965-01-02	1965-01-02	1	-1825
71798	4905	1125315	1988-06-08	1988-06-29	1	6754
49863	3397	1125315	1961-09-18	1961-10-02	1	-3013
40950	2779	1125315	1988-12-11	1988-12-18	1	6926
14180	970	1125315	1956-11-14	1956-11-28	1	-4782
55457	3773	1112807	1963-02-05	1963-02-26	1	-2501
52284	3561	1310149	1973-04-16	1973-04-16	1	1201
34801	2351	1729720	1959-07-22	1959-07-30	1	-3808
17917	1235	1759842	1997-07-21	1997-08-04	1	10077
47855	3248	1110410	2016-06-26	2016-06-26	1	16978
54586	3714	1112807	1965-02-16	1965-03-02	1	-1766
21568	1468	738818	1989-07-13	1989-07-20	1	7140
41547	2818	1124300	2009-11-03	2009-11-03	1	14551
24440	1649	1729720	1963-08-29	1963-09-09	1	-2306
32533	2204	1713332	1946-11-14	1946-11-28	1	-8435
68297	4662	1713332	1958-08-30	1958-09-20	1	-4121
71799	4905	1729720	1977-08-18	1977-08-31	1	2799
49864	3397	1729720	1951-01-13	1951-01-25	1	-6916
40951	2779	1129625	1994-12-07	1994-12-07	1	9106
14181	970	1729720	1960-07-25	1960-08-03	1	-3438
55458	3773	1125315	1981-01-22	1981-02-21	1	4069
52285	3561	1326303	1973-04-16	1973-04-16	1	1201
34802	2351	1759842	1965-10-17	1965-11-07	1	-1516
17918	1235	1112807	1980-02-29	1980-03-14	1	3725
47856	3248	1112807	1946-06-08	1946-07-22	2	-8580
54587	3714	1112807	1966-03-27	1966-04-24	1	-1348
21569	1468	920293	1998-07-07	1998-07-14	1	10421
41548	2818	1125315	1978-08-04	1978-08-11	1	3144
27358	1848	920293	1975-10-07	1975-10-14	1	2112
32534	2204	1713332	1972-02-17	1972-02-24	1	784
68298	4662	1759842	1995-10-04	1995-10-25	1	9428
73744	5043	1125315	2013-09-16	2013-09-30	1	15978
49865	3397	1112807	1973-03-17	1973-03-31	1	1185
40952	2779	1177480	2005-03-16	2005-04-13	1	12886
14182	970	1759842	1952-12-14	1952-12-21	1	-6220
55459	3773	1125315	1981-08-22	1981-09-05	1	4265
52286	3561	1729720	1983-03-14	1983-03-26	1	4832
36522	2485	1119510	1924-07-25	1924-08-01	1	-16589
17919	1235	1125315	2004-01-13	2004-02-10	1	12458
47857	3248	1307863	2007-03-30	2007-03-30	1	13602
54588	3714	1124957	2007-02-18	2007-02-18	1	13562
21570	1468	1125315	1964-11-07	1964-11-28	1	-1860
41549	2818	1125315	2014-03-16	2014-03-23	1	16152
27359	1848	920293	1981-11-07	1981-11-14	1	4335
32535	2204	1713332	1989-01-22	1989-02-05	1	6975
68299	4662	1112807	1965-01-02	1965-02-01	1	-1795
73745	5043	1503184	1992-11-14	1993-11-09	1	8713
49866	3397	1115008	1994-09-03	1994-09-17	1	9025
40953	2779	1119510	1988-12-11	1988-12-18	1	6926
14183	970	1759842	1966-03-18	1966-04-01	1	-1371
55460	3773	1125315	1982-06-21	1982-06-28	1	4561
52287	3561	1124957	1967-04-02	1967-04-02	1	-1005
36523	2485	1125315	1920-04-28	1920-05-12	1	-18131
17920	1235	1713332	2011-06-07	2011-06-28	1	15153
47858	3248	1729720	2007-04-03	2007-04-15	1	13618
54589	3714	1125315	1963-01-21	1963-01-28	1	-2530
21571	1468	1125315	1965-08-11	1965-08-18	1	-1597
41550	2818	1177480	1977-09-01	1977-09-22	1	2821
27360	1848	933724	1975-10-07	1975-10-14	1	2112
32536	2204	1729720	1967-06-22	1967-07-02	1	-914
68300	4662	1115008	1998-07-29	1998-08-19	1	10457
73746	5043	1515774	1990-11-25	1992-11-14	2	8353
49867	3397	1119510	1980-07-05	1980-07-12	1	3845
40954	2779	1177480	1976-03-18	1976-04-01	1	2282
14184	970	1118084	1986-12-17	1986-12-17	1	6194
55461	3773	1728416	1961-05-16	1961-05-30	1	-3138
52288	3561	1125315	1930-09-23	1930-09-30	1	-14338
36524	2485	1125315	1990-03-11	1990-06-09	2	7464
17921	1235	1759842	2011-06-07	2011-06-28	1	15153
47859	3248	1746114	2016-06-26	2016-06-26	1	16978
54590	3714	1125315	1973-04-24	1973-05-08	1	1223
21572	1468	1125315	1989-07-13	1989-07-20	1	7140
41551	2818	1177480	1989-04-06	1989-04-27	1	7056
27361	1848	933724	1981-11-07	1981-11-14	1	4335
32537	2204	1759842	1964-04-18	1964-05-10	1	-2062
68301	4662	1125315	2003-12-27	2004-01-03	1	12420
73747	5043	1549786	1990-11-25	1992-11-14	2	8353
49868	3397	1125315	1954-01-06	1954-01-20	1	-5825
40955	2779	1177480	1976-11-13	1977-01-12	1	2568
14185	970	1125315	1967-11-28	1967-12-12	1	-751
55645	3787	738818	1986-02-14	1986-02-28	1	5902
52289	3561	1125315	2002-06-13	2002-06-27	1	11865
36525	2485	1174888	1990-03-11	1990-03-11	1	7374
18601	1280	738818	1955-07-15	1955-07-29	1	-5270
121	7	738818	2001-07-18	2001-08-01	1	11535
54591	3714	1177480	2007-02-18	2007-04-19	1	13622
21573	1468	1310149	2015-06-03	2015-06-03	1	16589
41552	2818	738818	2004-04-30	2004-05-14	1	12552
27362	1848	1119510	1970-12-15	1970-12-29	1	362
32538	2204	1112807	1950-07-19	1950-08-09	1	-7085
68302	4662	1713332	1995-10-04	1995-10-25	1	9428
73748	5043	1549786	1993-11-09	1994-11-04	1	9073
49869	3397	1125315	1976-11-10	1976-12-01	1	2526
40956	2779	1713332	1990-05-12	1990-06-02	1	7457
14186	970	1125315	1998-11-07	1998-12-12	1	10572
55646	3787	1125315	1980-11-01	1980-11-15	1	3971
52290	3561	1112807	1979-04-29	1979-05-20	1	3426
36526	2485	1177480	1983-12-22	1984-01-12	1	5124
18602	1280	933724	2012-08-11	2012-08-18	1	15570
122	7	1118084	2008-10-17	2008-10-17	1	14169
54592	3714	1307863	2005-11-09	2005-11-09	1	13096
21574	1468	1713332	1969-10-24	1969-10-31	1	-62
41553	2818	1119510	1971-07-18	1971-07-25	1	570
27363	1848	1125315	1978-07-07	1978-07-21	1	3123
32539	2204	1125315	1950-02-11	1950-02-25	1	-7250
68303	4662	1729720	1953-08-23	1953-09-05	1	-5962
73749	5043	19127890	1990-11-25	1998-10-14	8	10513
49870	3397	738818	1980-07-05	1980-07-12	1	3845
40957	2779	975125	1994-11-21	1994-11-21	1	9090
14187	970	1125315	2003-08-16	2003-08-23	1	12287
55647	3787	1125315	1986-02-14	1986-02-28	1	5902
52291	3561	1125315	1925-02-12	1925-02-19	1	-16387
36527	2485	1713332	2002-11-08	2003-01-31	1	12083
18603	1280	1115008	1994-06-23	1998-12-29	1	10589
123	7	1119510	2001-07-18	2001-08-01	1	11535
54593	3714	1322184	2005-09-21	2005-09-21	1	13047
21575	1468	1728416	1958-01-29	1958-02-12	1	-4341
41554	2818	1119510	1978-08-04	1978-08-11	1	3144
27364	1848	1125315	1985-04-03	1985-05-03	1	5601
32540	2204	1125315	1986-09-18	1986-09-25	1	6111
68304	4662	1741122	1989-07-27	1989-07-27	1	7147
73750	5043	1118084	2008-03-25	2008-03-25	1	13963
49871	3397	1112807	1956-01-16	1956-02-15	1	-5069
40958	2779	1125315	2006-02-07	2006-05-08	1	13276
14188	970	1713332	2008-07-25	2008-08-01	1	14092
55648	3787	1174888	2016-08-27	2016-08-27	1	17040
52292	3561	1125315	2010-06-11	2010-07-11	1	14801
36528	2485	738818	1924-07-25	1924-08-01	1	-16589
18604	1280	1119510	1964-03-16	1964-03-23	1	-2110
124	7	1125315	1972-07-09	1972-07-23	1	934
54594	3714	1322184	2009-07-01	2009-07-01	1	14426
21576	1468	1119510	1989-07-13	1989-07-20	1	7140
41555	2818	1119510	2004-04-30	2004-05-14	1	12552
27365	1848	1307863	2011-02-17	2011-02-17	1	15022
32541	2204	1759842	1989-01-22	1989-02-05	1	6975
68305	4662	1759842	1958-12-26	1959-01-09	1	-4010
73751	5043	1125315	1994-09-02	1994-09-02	1	9010
49872	3397	1125315	1980-07-05	1980-07-12	1	3845
40959	2779	1738521	1976-03-18	1976-04-01	1	2282
14189	970	1729720	1960-05-11	1960-05-23	1	-3510
55649	3787	1332418	2013-04-13	2013-04-13	1	15808
52293	3561	1759842	1945-02-07	1945-03-28	1	-9045
36529	2485	1118084	1953-03-09	1953-03-09	1	-6142
18605	1280	1124300	1988-03-11	1988-03-11	1	6644
125	7	1125315	2001-07-18	2001-08-01	1	11535
54595	3714	1326303	2005-11-09	2005-11-09	1	13096
21577	1468	1307863	2015-06-03	2015-06-03	1	16589
41556	2818	1125315	1969-11-23	1969-12-28	1	-4
27366	1848	1112807	1957-03-10	1957-03-31	1	-4659
32542	2204	1125315	1980-04-07	1980-04-21	1	3763
68306	4662	19003953	1989-07-27	1989-07-27	1	7147
73752	5043	1503184	1987-12-11	1988-12-05	1	6913
49873	3397	1125315	1981-09-06	1981-10-11	1	4301
40960	2779	738818	1988-12-11	1988-12-18	1	6926
14190	970	1729720	1965-01-11	1965-01-20	1	-1807
55650	3787	1539403	2013-04-13	2013-04-13	1	15808
53481	3641	1112807	1924-08-30	1924-09-20	1	-16539
36530	2485	1125315	1924-07-25	1924-08-01	1	-16589
18606	1280	1125315	1955-07-15	1955-07-29	1	-5270
126	7	1503184	1986-10-13	1987-10-08	1	6489
54596	3714	738818	1924-06-07	1924-06-14	1	-16637
21578	1468	1361711	1977-02-02	1977-02-02	1	2589
41557	2818	1125315	1971-07-18	1971-08-18	2	584
27367	1848	1310149	2011-02-17	2011-02-17	1	15022
32543	2204	1125315	2000-06-20	2000-07-04	1	11142
68307	4662	1000560	1989-07-27	1989-07-27	2	7147
73753	5043	1515774	1993-11-09	1994-11-04	1	9073
49874	3397	1125315	2010-01-08	2010-01-22	1	14631
40961	2779	1343916	1994-12-07	1994-12-07	1	9106
14191	970	1759842	2008-07-25	2008-08-01	1	14092
55651	3787	1125315	2016-08-27	2016-08-27	1	17040
53482	3641	1119510	2002-01-03	2002-01-10	1	11697
36531	2485	1125315	1999-10-14	1999-10-28	1	10892
18607	1280	1125315	1976-03-04	1976-04-03	1	2284
127	7	1112807	1969-10-02	1969-10-23	1	-70
54597	3714	738818	1985-10-03	1985-10-17	1	5768
21579	1468	1713332	1983-09-12	1983-09-26	1	5016
41558	2818	1125315	1971-11-18	1971-12-02	1	700
27368	1848	1717327	1962-04-13	1962-04-27	1	-2806
32544	2204	1729720	1950-07-03	1950-07-15	1	-7110
68308	4662	1110410	1989-07-27	1989-07-27	1	7147
73754	5043	1515774	1995-10-30	1996-10-24	1	9793
49875	3397	1729720	2008-10-18	2008-10-27	1	14179
40962	2779	1713332	2019-05-19	2019-06-02	1	18049
14192	970	1115008	1996-07-29	1996-08-19	1	9727
55652	3787	1361711	2013-04-13	2016-08-27	1	17040
53483	3641	1125315	1979-04-01	1979-04-15	1	3391
36532	2485	1177480	2004-08-24	2004-09-21	1	12682
18608	1280	1177480	1978-03-28	1978-04-11	1	3022
128	7	1125315	1974-08-12	1974-09-11	1	1714
54598	3714	1112807	1928-07-15	1928-08-05	1	-15124
21580	1468	1759842	1983-09-12	1983-09-26	1	5016
41559	2818	1125315	1975-03-07	1975-03-14	1	1898
27369	1848	1118084	1982-09-25	1982-09-25	1	4650
32545	2204	1729720	1955-04-20	1955-05-01	1	-5359
68309	4662	1112807	1953-04-21	1953-05-05	1	-6085
73755	5043	1515774	1997-10-19	1998-10-14	1	10513
52804	3599	1115008	2015-03-23	2015-05-22	1	16577
40963	2779	1759842	1990-05-12	1990-06-02	1	7457
14193	970	1119510	1966-12-24	1966-12-31	1	-1097
55653	3787	1119510	1986-02-14	1986-02-28	1	5902
53484	3641	1177480	1987-01-03	1987-01-31	1	6239
36533	2485	1713332	1976-10-18	1976-11-08	1	2503
18609	1280	1177480	2017-04-28	2017-05-12	1	17298
129	7	1738521	1968-12-06	1968-12-20	1	-377
54599	3714	1112807	1940-03-05	1940-03-26	1	-10873
21581	1468	738818	1981-06-16	1981-06-23	1	4191
41560	2818	1125315	2004-04-30	2004-05-14	1	12552
27370	1848	1125315	1962-04-13	1962-04-27	1	-2806
32546	2204	1729720	1987-11-19	1987-12-01	1	6543
68310	4662	1713332	1958-12-26	1959-01-09	1	-4010
73756	5043	1521369	1987-12-11	1988-12-05	1	6913
52805	3599	1119510	2012-11-19	2012-11-26	1	15670
43488	2942	975125	1964-09-03	1964-09-24	1	-1925
14194	970	1125315	1956-02-18	1956-03-17	1	-5038
55654	3787	1124300	1998-07-20	1998-07-20	1	10427
53485	3641	1713332	1984-07-31	1984-08-21	1	5346
36534	2485	1112807	1914-11-02	1914-11-16	1	-20135
18610	1280	1713332	1971-04-26	1971-05-03	1	487
130	7	19127890	1986-10-13	1987-10-08	1	6489
54600	3714	1112807	1949-07-07	1949-08-04	1	-7455
21582	1468	1118084	1992-03-26	1992-03-26	1	8120
41561	2818	1738521	1971-08-04	1971-08-18	1	594
27371	1848	1125315	2010-01-24	2010-02-07	1	14647
39319	2675	738818	1993-02-19	1993-02-26	1	8457
68311	4662	1729720	1958-01-16	1958-01-29	1	-4355
73757	5043	1125315	2004-08-04	2004-08-18	1	12648
52806	3599	1112807	1973-03-30	1973-04-27	1	1212
43489	2942	1112807	1965-07-26	1965-08-23	1	-1592
14195	970	1729720	1997-03-10	1997-03-21	1	9941
55655	3787	1125315	1966-06-18	1966-08-17	1	-1233
53486	3641	1713332	1993-08-12	1993-08-19	1	8631
36535	2485	1177480	2015-12-23	2016-01-13	1	16813
18611	1280	1729720	2016-12-14	2016-12-23	1	17158
131	7	1112807	1968-12-06	1968-12-20	1	-377
54601	3714	1118084	1958-07-28	1958-07-28	1	-4175
21583	1468	1125315	1981-06-16	1981-06-23	1	4191
41562	2818	1112807	1970-02-21	1970-03-07	1	65
27372	1848	1713332	1947-04-10	1947-04-17	1	-8295
39320	2675	738818	2013-12-13	2013-12-20	1	16059
68312	4662	1746114	1989-07-27	1989-07-27	1	7147
73758	5043	1174888	1994-09-02	1994-09-02	1	9010
52807	3599	1118084	2006-06-10	2006-06-10	1	13309
43490	2942	1124300	1998-10-01	1998-10-01	1	10500
14196	970	1759842	2000-03-03	2000-03-10	1	11026
55656	3787	1125315	1979-09-28	1979-10-12	1	3571
53487	3641	1729720	1943-11-18	1943-11-27	1	-9532
36536	2485	1557272	2003-11-12	2003-11-12	1	12368
18612	1280	1759842	1977-10-07	1977-10-28	1	2857
132	7	1125315	1985-05-16	1985-06-13	1	5642
54602	3714	1125315	1950-03-10	1950-03-24	1	-7223
21584	1468	1177480	1974-02-09	1974-03-09	1	1528
41563	2818	1125315	1997-10-01	1997-10-15	1	10149
27373	1848	738818	1970-12-15	1970-12-29	1	362
39321	2675	1118084	2002-01-04	2002-01-04	1	11691
68313	4662	19059528	1989-07-27	1989-07-27	1	7147
73759	5043	1503184	1994-11-04	1995-10-30	1	9433
52808	3599	1125315	1974-12-22	1975-01-05	1	1830
43491	2942	1307863	2016-09-28	2016-09-28	1	17072
16820	1158	1177480	1980-11-27	1980-12-11	1	3997
55657	3787	1125315	2010-10-04	2010-10-11	1	14893
53488	3641	1759842	1923-08-27	1923-09-03	1	-16922
36537	2485	1112807	1913-08-31	1913-09-14	1	-20563
18613	1280	1125315	1975-03-05	1975-04-02	1	1917
133	7	1521369	1986-10-13	1987-10-08	1	6489
54603	3714	1125315	1963-03-31	1963-04-14	1	-2454
21585	1468	1322184	1997-02-26	1997-02-26	1	9918
41564	2818	738818	1971-07-18	1971-07-25	1	570
27374	1848	1125315	1960-08-23	1960-09-06	1	-3404
39322	2675	1125315	1963-02-18	1963-03-04	1	-2495
70641	4826	1112807	1967-11-26	1967-12-26	1	-737
73760	5043	1503184	1996-10-24	1997-10-19	1	10153
52809	3599	1125315	2018-08-29	2018-09-05	1	17779
43492	2942	975125	1959-05-10	1959-05-31	1	-3868
16821	1158	1515774	1994-07-27	1995-07-22	1	9333
55658	3787	1322184	2013-04-13	2016-08-27	1	17040
53489	3641	1759842	2007-03-05	2007-03-19	1	13591
36538	2485	1713332	1999-10-14	1999-10-28	1	10892
18614	1280	1125315	1975-12-23	1976-01-06	1	2196
134	7	1713332	1986-08-06	1986-08-13	1	6068
54604	3714	1125315	1985-10-03	1985-10-17	1	5768
21586	1468	1326303	2015-06-03	2015-06-03	1	16589
41565	2818	1125315	1985-07-12	1985-07-26	1	5685
27375	1848	1125315	1970-12-15	1970-12-29	1	362
39323	2675	1125315	1993-02-19	1993-02-26	1	8457
70642	4826	1112807	1969-01-19	1969-03-20	1	-287
73761	5043	1549786	1995-10-30	1996-10-24	1	9793
52810	3599	1112807	1971-06-09	1971-06-23	1	538
43493	2942	1154343	1956-08-04	1956-08-04	1	-4898
16822	1158	920293	1999-09-11	1999-09-18	1	10852
55659	3787	1125315	1978-07-16	1978-07-23	1	3125
53490	3641	1112807	1946-06-27	1946-08-01	1	-8554
36539	2485	1759842	1976-10-18	1976-11-08	1	2503
18615	1280	1713332	1977-10-07	1977-10-28	1	2857
135	7	1759842	1986-08-06	1986-08-13	1	6068
54605	3714	1125315	2007-02-18	2007-02-18	1	13562
21587	1468	1332418	1995-07-19	1995-07-19	1	9330
41566	2818	1713332	1987-12-10	1987-12-31	1	6573
27376	1848	1326303	2011-02-17	2011-02-17	1	15022
39324	2675	1125315	2013-12-13	2013-12-20	1	16059
70643	4826	1125315	1960-04-22	1960-05-06	1	-3527
73762	5043	1549786	1997-10-19	1998-10-14	1	10513
52811	3599	1125315	1976-11-07	1976-12-05	1	2530
43494	2942	1326303	2016-09-28	2016-09-28	1	17072
16823	1158	933724	1999-09-11	1999-09-18	1	10852
55660	3787	1545958	2016-08-27	2016-08-27	1	17040
53491	3641	1125315	2000-06-24	2000-07-08	1	11146
36540	2485	1759842	2002-11-08	2003-01-31	1	12083
18616	1280	1713332	1993-04-26	1993-05-03	1	8523
3503	235	738818	2008-06-02	2008-06-16	1	14046
54606	3714	1347450	2009-07-01	2009-07-01	1	14426
21777	1482	1125315	1975-01-17	1975-01-31	1	1856
41567	2818	1759842	1987-12-10	1987-12-31	1	6573
27377	1848	1729720	1954-11-24	1954-12-06	1	-5505
39325	2675	1322184	2012-08-19	2012-08-19	1	15571
70644	4826	1125315	1991-11-07	1991-11-21	1	7994
73763	5043	19127890	1987-12-11	1988-12-05	1	6913
52812	3599	1125315	2015-03-23	2015-03-23	1	16517
43495	2942	1713332	1979-01-20	1979-02-03	1	3320
16824	1158	1115008	2017-02-14	2017-03-14	1	17239
56693	3864	1112807	1969-03-20	1969-04-03	1	-273
53492	3641	1759842	1959-05-30	1959-06-20	1	-3848
37925	2579	738818	1961-05-05	1961-05-12	1	-3156
18617	1280	1759842	1971-04-26	1971-05-03	1	487
3504	235	1125315	2000-05-02	2000-05-09	1	11086
54607	3714	1112807	1937-01-20	1937-03-21	1	-11974
21778	1482	1125315	1987-12-10	1987-12-31	1	6573
46070	3128	975125	1974-06-29	1974-07-20	1	1661
27378	1848	1759842	1947-04-10	1947-04-17	1	-8295
39326	2675	1347450	2012-08-19	2012-08-19	1	15571
70645	4826	1125315	2019-05-18	2019-05-18	1	18034
73764	5043	1177480	1994-08-26	1994-11-01	1	9070
52813	3599	1728416	1971-06-09	1971-06-23	1	538
43496	2942	1729720	2003-01-13	2003-01-24	1	12076
16825	1158	1118084	2016-12-13	2016-12-13	1	17148
56694	3864	1118084	2007-12-16	2007-12-16	1	13863
53493	3641	1759842	1976-05-29	1976-06-05	1	2347
37926	2579	920293	1981-05-07	1981-05-14	1	4151
18618	1280	738818	1964-03-16	1964-03-23	1	-2110
3505	235	1125315	2008-06-02	2008-06-16	1	14046
54608	3714	1119510	1963-01-21	1963-01-28	1	-2530
21779	1482	1149380	2008-11-22	2008-11-22	1	14205
46071	3128	975125	1977-09-08	1977-09-22	1	2821
27676	1870	1125315	1943-01-16	1943-01-30	1	-9833
39327	2675	1759842	1963-12-24	1963-12-31	1	-2193
70646	4826	1713332	1996-02-23	1996-03-15	1	9570
73765	5043	1521369	1992-11-14	1993-11-09	1	8713
52814	3599	1729720	1979-10-10	1979-10-22	1	3581
43497	2942	1112807	1957-09-20	1957-10-04	1	-4472
16826	1158	1125315	1992-10-27	1992-11-10	1	8349
56695	3864	1125315	1966-11-03	1966-11-17	1	-1141
53494	3641	1112807	1947-06-27	1947-07-18	1	-8203
37927	2579	1125315	1961-05-05	1961-05-12	1	-3156
18619	1280	1112807	1964-08-24	1964-09-28	1	-1921
3506	235	1713332	1984-07-24	1984-08-07	1	5332
54609	3714	1310149	2005-11-09	2005-11-09	1	13096
21780	1482	1768849	1993-01-01	1993-01-15	1	8415
46072	3128	1125315	2009-05-28	2009-06-25	1	14420
27677	1870	920293	1957-05-08	1957-05-15	1	-4614
39328	2675	1759842	1979-08-08	1979-08-22	1	3520
70647	4826	1713332	2019-05-18	2019-06-22	1	18069
73766	5043	1521369	1994-11-04	1995-10-30	1	9433
52815	3599	738818	2012-11-19	2012-11-26	1	15670
43498	2942	1112807	1979-01-20	1979-02-03	1	3320
16827	1158	1713332	2005-02-14	2005-02-28	1	12842
56696	3864	1125315	1974-08-08	1974-08-15	1	1687
53495	3641	1118084	1957-12-10	1957-12-10	1	-4405
37928	2579	1125315	1996-10-06	1996-10-13	1	9782
18620	1280	1119510	1955-07-15	1955-07-29	1	-5270
3507	235	1729720	1988-12-02	1988-12-14	1	6922
54610	3714	1347450	2005-09-21	2005-09-21	1	13047
21781	1482	1125315	1986-09-17	1986-09-24	1	6110
46073	3128	1129625	1978-08-13	1978-08-13	1	3146
27678	1870	933724	1957-05-08	1957-05-15	1	-4614
39329	2675	1759842	1999-10-12	1999-10-19	1	10883
70648	4826	1125315	2002-11-22	2002-12-13	1	12034
73767	5043	1521369	1996-10-24	1997-10-19	1	10153
52816	3599	1125315	2012-11-19	2012-11-26	1	15670
43499	2942	1125315	2007-12-09	2007-12-16	1	13863
16828	1158	1112807	1983-01-31	1983-02-14	1	4792
56697	3864	1125315	2003-05-25	2003-06-01	1	12204
53496	3641	1713332	1923-08-27	1923-09-03	1	-16922
37929	2579	1729720	1956-05-01	1956-05-14	1	-4980
18621	1280	1125315	1964-03-16	1964-03-23	1	-2110
3508	235	1729720	1991-04-04	1991-04-16	1	7775
56911	3879	933724	1967-01-09	1967-01-16	1	-1081
21782	1482	1125315	1993-01-01	1993-01-15	1	8415
46074	3128	1154343	1976-07-30	1976-07-30	1	2402
27679	1870	1118084	1957-05-29	1957-05-29	1	-4600
39330	2675	1115008	1996-10-20	1996-11-10	1	9810
70649	4826	1177480	2019-05-18	2019-06-22	1	18069
76913	5257	1112807	1980-01-04	1980-02-01	1	3683
52817	3599	1174888	2015-03-23	2015-03-23	1	16517
43500	2942	1551099	1966-03-23	1966-03-23	1	-1380
16829	1158	1115008	1999-07-05	1999-07-19	1	10791
56698	3864	1177480	1978-08-30	1978-10-04	1	3198
53497	3641	1713332	1959-05-30	1959-06-20	1	-3848
37930	2579	933724	1981-05-07	1981-05-14	1	4151
18622	1280	1125315	1970-06-04	1970-06-18	1	168
3509	235	1112807	1984-06-24	1984-07-29	1	5323
56912	3879	1112807	1944-09-16	1944-09-30	1	-9224
21783	1482	1129625	1975-07-28	1975-07-28	1	2034
46075	3128	1177480	2007-03-19	2007-04-09	1	13612
27680	1870	1125315	1927-04-13	1927-04-20	1	-15597
39331	2675	1119510	1976-05-31	1976-06-07	1	2349
70650	4826	1713332	1994-12-16	1994-12-23	1	9122
76914	5257	1125315	1986-07-03	1986-07-17	1	6041
52818	3599	1713332	1982-07-10	1982-07-24	1	4587
43501	2942	1728416	1954-07-24	1954-08-07	1	-5626
16830	1158	1125315	2004-06-14	2004-06-28	1	12597
56699	3864	1728416	1969-03-20	1969-04-03	1	-273
53498	3641	1713332	1976-05-29	1976-06-05	1	2347
37931	2579	1118084	1992-04-30	1992-04-30	1	8155
18623	1280	1305058	1994-06-23	1998-12-29	1	10589
3510	235	1119510	2008-06-02	2008-06-16	1	14046
56913	3879	1112807	1946-08-21	1946-09-25	1	-8499
21784	1482	1551099	1981-12-11	1981-12-11	1	4362
46076	3128	1551099	1974-02-19	1974-02-19	1	1510
27681	1870	1125315	1947-10-21	1947-11-04	1	-8094
39332	2675	1119510	1993-02-19	1993-02-26	1	8457
70651	4826	1759842	1994-12-16	1994-12-23	1	9122
76915	5257	1515774	2007-12-22	2008-12-16	1	14229
52819	3599	1759842	1982-07-10	1982-07-24	1	4587
43502	2942	1728416	1957-09-20	1957-10-04	1	-4472
16831	1158	1177480	1984-03-11	1984-03-25	1	5197
56700	3864	1713332	1967-09-02	1967-09-23	1	-831
53499	3641	1713332	2007-03-05	2007-03-19	1	13591
37932	2579	1125315	2000-03-31	2000-04-14	1	11061
18624	1280	1713332	1987-05-03	1987-05-24	1	6352
3511	235	1713332	1998-04-23	1998-05-14	1	10360
56914	3879	1118084	1981-03-23	1981-03-23	1	4099
21785	1482	1124300	2017-08-24	2017-08-24	1	17402
46077	3128	1713332	1990-05-11	1990-06-01	1	7456
27682	1870	1112807	1953-01-25	1953-02-08	1	-6171
39333	2675	1119510	2013-12-13	2013-12-20	1	16059
70652	4826	1118084	1986-04-16	1986-04-16	1	5949
76916	5257	1549786	2007-12-22	2008-12-16	1	14229
54875	3733	738818	1984-04-28	1984-05-12	1	5245
43503	2942	1112807	1954-05-25	1954-08-07	2	-5656
16832	1158	1713332	2007-08-17	2007-08-31	1	13756
56701	3864	1759842	1967-09-02	1967-09-23	1	-831
53500	3641	1729720	1978-02-07	1978-02-14	1	2966
37933	2579	1728416	1953-11-11	1953-11-25	1	-5881
18625	1280	1759842	1987-05-03	1987-05-24	1	6352
3512	235	1729720	1991-10-15	1991-10-27	1	7969
56915	3879	1125315	1969-06-10	1969-06-17	1	-198
21786	1482	1125315	1976-10-19	1976-11-02	1	2497
46078	3128	975125	1986-09-10	1986-09-24	1	6110
27683	1870	1125315	1932-07-24	1932-07-31	1	-13668
39334	2675	1124957	1978-02-13	1978-02-13	1	2965
70653	4826	1125315	1996-05-10	1996-05-17	1	9633
76917	5257	1589505	2006-12-23	2007-12-22	1	13869
54876	3733	1119510	2003-04-10	2003-04-24	1	12166
43504	2942	1112807	1968-04-09	1968-06-08	1	-572
16833	1158	1759842	2007-08-17	2007-08-31	1	13756
57904	3950	1112807	1972-10-20	1972-11-10	1	1044
53501	3641	1759842	1984-07-31	1984-08-21	1	5346
37934	2579	1729720	1962-11-13	1962-11-25	1	-2594
18626	1280	920293	2012-08-11	2012-08-18	1	15570
3513	235	1759842	1998-04-23	1998-05-14	1	10360
56916	3879	920293	1967-01-09	1967-01-16	1	-1081
21787	1482	1713332	1983-07-09	1983-10-01	1	5021
46079	3128	1124957	1985-08-11	1985-08-11	1	5701
27684	1870	1729720	1939-09-30	1939-10-12	1	-11039
39335	2675	1125315	1966-01-22	1966-02-05	1	-1426
70654	4826	1174888	2019-05-18	2019-05-18	1	18034
76918	5257	1713332	1994-10-12	1994-10-26	1	9064
54877	3733	1124300	2011-03-22	2011-03-22	1	15055
43505	2942	1125315	1983-05-24	1983-05-31	1	4898
16834	1158	1778162	1983-01-31	1983-02-14	1	4792
57905	3950	1118084	2014-12-04	2014-12-04	1	16408
53502	3641	1759842	1993-08-12	1993-08-19	1	8631
37935	2579	1759842	1967-12-07	1967-12-21	1	-742
18627	1280	1102527	1976-03-04	1976-03-04	1	2254
3514	235	1118084	2016-05-17	2016-05-17	1	16938
56917	3879	975125	1965-12-16	1965-12-16	1	-1477
21788	1482	1713332	1985-09-26	1985-10-03	1	5754
46080	3128	1515774	1994-06-14	1995-06-09	1	9290
27685	1870	1713332	1932-10-09	1932-10-16	1	-13591
39336	2675	1177480	1992-01-01	1992-01-15	1	8049
70655	4826	1713332	2005-10-16	2005-10-30	1	13086
76919	5257	1118084	2014-03-21	2014-03-21	1	16150
54878	3733	1125315	1984-04-28	1984-05-12	1	5245
43506	2942	1125315	1992-04-27	1992-05-04	1	8159
16835	1158	1125315	2005-02-14	2005-02-28	1	12842
57906	3950	1119510	1976-08-01	1976-08-15	1	2418
53503	3641	738818	2002-01-03	2002-01-10	1	11697
37936	2579	1112807	1953-11-11	1953-11-25	1	-5881
18628	1280	1112807	1956-07-07	1956-07-21	1	-4912
3515	235	1125315	1985-05-13	1985-05-27	1	5625
56918	3879	1112807	1941-02-06	1941-02-20	1	-10542
21789	1482	1759842	1983-07-09	1983-10-01	1	5021
46081	3128	1118084	2010-11-02	2010-11-02	1	14915
27686	1870	1759842	1932-10-09	1932-10-16	1	-13591
39337	2675	1713332	1992-08-06	1992-08-13	1	8260
70656	4826	1729720	1992-04-17	1992-04-28	1	8153
76920	5257	1713332	2000-08-25	2000-09-08	1	11208
54879	3733	1768849	1981-04-08	1981-04-22	1	4129
43507	2942	1125315	2012-10-25	2012-11-01	1	15645
16836	1158	1549786	1994-07-27	1995-07-22	1	9333
57907	3950	1125315	1979-09-14	1979-09-28	1	3557
53504	3641	1102527	1992-11-30	1992-11-30	1	8369
37937	2579	1119510	1961-05-05	1961-05-12	1	-3156
18629	1280	1125315	2011-12-13	2011-12-20	1	15328
3516	235	1177480	2000-10-03	2000-11-02	1	11263
56919	3879	1119510	1996-10-13	1996-10-20	1	9789
21790	1482	1759842	1985-09-26	1985-10-03	1	5754
46082	3128	1125315	1984-09-08	1984-10-15	1	5401
28889	1954	1112807	1960-05-07	1960-06-13	1	-3489
39338	2675	1759842	1992-08-06	1992-08-13	1	8260
70657	4826	1759842	1954-03-03	1954-03-17	1	-5769
76921	5257	1759842	2000-08-25	2000-09-08	1	11208
54880	3733	19127890	1994-10-12	1995-10-07	1	9410
43508	2942	1149380	1956-08-04	1956-08-04	1	-4898
16837	1158	19127890	1994-07-27	1995-07-22	1	9333
57908	3950	1713332	2011-08-31	2011-09-21	1	15238
53505	3641	1112807	1915-08-18	1915-09-17	1	-19830
37938	2579	920293	1987-06-17	1987-06-24	1	6383
18630	1280	1729720	1952-03-03	1952-03-10	1	-6506
3517	235	1729720	1986-04-19	1986-04-30	1	5963
56920	3879	1557272	2010-04-08	2010-04-08	1	14707
21791	1482	1125315	2006-06-13	2006-06-20	1	13319
46083	3128	1177480	1982-09-05	1982-09-19	1	4644
28890	1954	1125315	1952-12-01	1952-12-15	1	-6226
39339	2675	738818	1976-05-31	1976-06-07	1	2349
70658	4826	1759842	2005-10-16	2005-10-30	1	13086
76922	5257	19127890	1995-02-24	1996-02-19	1	9545
54881	3733	1125315	1980-07-17	1980-08-21	1	3885
43509	2942	1310149	2016-09-28	2016-09-28	1	17072
18361	1264	1125315	1974-04-13	1974-04-27	1	1577
57909	3950	1759842	2011-08-31	2011-09-21	1	15238
53506	3641	1125315	1992-11-30	1993-02-28	1	8459
37939	2579	933724	1987-06-17	1987-06-24	1	6383
18631	1280	1759842	1993-04-26	1993-05-03	1	8523
3518	235	740275	1992-09-25	1993-02-26	1	8457
56921	3879	1713332	1987-02-19	1987-03-05	1	6272
21792	1482	1137529	2008-11-22	2008-11-22	1	14205
46084	3128	1500211	1995-06-09	1996-06-03	1	9650
28891	1954	1125315	1964-05-04	1964-05-11	1	-2061
39340	2675	1125315	1969-06-18	1969-07-02	1	-183
70659	4826	1112807	1951-09-07	1951-09-21	1	-6677
76923	5257	19127890	1997-02-13	1998-02-08	1	10265
54882	3733	1500211	1992-10-22	1993-10-17	1	8690
44847	3044	1125315	1974-08-23	1974-09-13	1	1716
18362	1264	1125315	1993-03-31	1993-04-14	1	8504
57910	3950	1112807	1971-09-26	1971-12-25	1	723
53507	3641	1125315	2002-01-03	2002-01-10	1	11697
37940	2579	1112807	1961-08-31	1961-09-30	1	-3015
22266	1516	757627	2007-04-23	2007-04-23	1	13626
3519	235	1125315	1984-07-24	1984-08-07	1	5332
56922	3879	1759842	2014-04-26	2014-05-17	1	16207
21793	1482	1728416	1976-10-19	1976-11-02	1	2497
46085	3128	1549786	1994-06-14	1995-06-09	1	9290
28892	1954	1729720	1997-11-05	1997-11-13	1	10178
39341	2675	1125315	1976-05-31	1976-06-07	1	2349
70660	4826	1713332	1954-03-03	1954-03-17	1	-5769
76924	5257	19127890	2007-12-22	2008-12-16	1	14229
54883	3733	1713332	1979-05-07	1979-05-21	1	3427
44848	3044	1125315	2012-10-07	2012-10-07	1	15620
18363	1264	1149380	1988-01-08	1988-01-08	1	6581
57911	3950	1119510	2001-12-11	2001-12-25	1	11681
58592	3996	738818	1979-12-16	1979-12-30	1	3650
37941	2579	1125315	2006-01-14	2006-01-28	1	13176
22267	1516	1112807	1966-12-23	1967-01-06	1	-1091
4535	312	1125315	1972-05-24	1972-05-31	1	881
56923	3879	1102527	2003-06-03	2003-06-03	1	12206
26376	1782	1000560	1956-01-11	1956-01-11	2	-5104
46086	3128	1729720	2011-01-10	2011-01-21	1	14995
28893	1954	715997	1999-11-19	1999-11-19	1	10914
39342	2675	1177480	1978-02-13	1978-04-14	1	3025
70661	4826	1729720	1990-04-20	1990-04-27	1	7421
76925	5257	1102527	2014-04-10	2014-04-10	1	16170
54884	3733	738818	2003-04-10	2003-04-24	1	12166
44849	3044	1713332	2012-10-07	2012-11-04	1	15648
18364	1264	1729720	1953-05-16	1953-05-27	1	-6063
57912	3950	1125315	1979-06-07	1979-06-28	1	3465
58593	3996	1125315	1989-05-08	1989-06-14	2	7104
37942	2579	1713332	1967-12-07	1967-12-21	1	-742
22268	1516	1125315	1967-12-02	1967-12-23	1	-740
4536	312	1125315	2006-12-03	2006-12-10	1	13492
56924	3879	1125315	1951-02-01	1951-03-08	1	-6874
26377	1782	1118084	1988-01-01	1988-01-01	1	6574
46087	3128	1759842	1990-05-11	1990-06-01	1	7456
28894	1954	1112807	1949-12-17	1950-02-15	1	-7260
39343	2675	1177480	2006-06-21	2006-07-05	1	13334
70662	4826	1759842	1996-02-23	1996-03-15	1	9570
76926	5257	1125315	1989-02-13	1989-05-14	1	7073
54885	3733	1125315	1979-05-07	1979-05-21	1	3427
44850	3044	1728416	1969-07-20	1969-08-03	1	-151
18365	1264	1729720	1953-08-28	1953-09-10	1	-5957
57913	3950	1125315	1981-06-17	1981-07-22	1	4220
58594	3996	1125315	2003-04-05	2003-04-12	1	12154
39140	2661	1125315	1989-10-31	1989-11-07	1	7250
22269	1516	1759842	1948-10-05	1948-10-26	1	-7737
4537	312	1125315	2009-05-30	2009-06-06	1	14401
56925	3879	1125315	2003-06-03	2003-08-02	1	12266
26378	1782	1367571	1956-01-11	1956-01-11	1	-5104
46088	3128	19127890	1994-06-14	1995-06-09	1	9290
28895	1954	1112807	1936-12-25	1937-01-08	1	-12046
39344	2675	1713332	1979-08-08	1979-08-22	1	3520
71383	4873	1118084	2018-10-24	2018-10-24	1	17828
76927	5257	1177480	2014-04-03	2014-06-09	1	16230
54886	3733	1125315	2003-04-10	2003-04-24	1	12166
44851	3044	1112807	1969-07-20	1969-08-03	1	-151
18366	1264	1729720	1997-06-20	1997-06-29	1	10041
57914	3950	738818	1976-08-01	1976-08-15	1	2418
58595	3996	1125315	2016-10-05	2016-10-12	1	17086
39141	2661	1177480	2006-12-21	2007-01-04	1	13517
22270	1516	1112807	1968-10-18	1968-11-08	1	-419
4538	312	1778162	1985-01-15	1985-01-29	1	5507
56926	3879	738818	1996-10-13	1996-10-20	1	9789
26379	1782	1728416	1954-08-01	1954-08-15	1	-5618
46089	3128	975125	1989-12-13	1990-01-03	1	7307
28896	1954	1125315	1949-12-17	1949-12-17	1	-7320
363	23	1125315	1986-04-28	1986-05-19	1	5982
71384	4873	1503184	1993-06-27	1994-06-22	1	8938
76928	5257	1515774	2003-01-13	2004-01-08	1	12425
54887	3733	1503184	1994-10-12	1995-10-07	1	9410
44852	3044	1177480	2012-10-07	2012-11-04	1	15648
18367	1264	1124300	1987-12-14	1987-12-14	1	6556
57915	3950	738818	2001-12-11	2001-12-25	1	11681
58596	3996	1112807	1976-09-01	1976-09-22	1	2456
39142	2661	1521369	1979-09-03	1980-08-28	1	3892
22271	1516	1118084	1979-07-12	1979-07-12	1	3479
4539	312	1125315	1977-04-27	1977-07-26	1	2763
56927	3879	920293	1971-02-26	1971-03-05	1	428
26380	1782	1759842	1997-10-22	1997-10-29	1	10163
46090	3128	1125315	1985-08-11	1985-11-09	2	5791
28897	1954	1125315	1972-11-07	1972-12-12	1	1076
364	23	1125315	1991-10-01	1991-10-08	1	7950
71385	4873	1515774	1991-07-08	1992-07-02	1	8218
76929	5257	1521369	1999-02-03	2001-01-23	2	11345
54888	3733	1717327	1976-09-06	1976-09-20	1	2454
44853	3044	1112807	1971-01-23	1971-02-06	1	401
18368	1264	1137529	1988-01-08	1988-01-08	1	6581
57916	3950	1125315	1976-08-01	1976-08-15	1	2418
58597	3996	1115008	2016-06-22	2016-07-13	1	16995
39143	2661	1521369	1981-08-23	1982-08-18	1	4612
22272	1516	1125315	1960-08-05	1960-10-11	1	-3369
4540	312	1759842	2012-04-26	2012-05-03	1	15463
56928	3879	933724	1971-02-26	1971-03-05	1	428
26381	1782	708298	1956-01-11	1956-01-11	1	-5104
46091	3128	1149380	1976-07-30	1976-07-30	1	2402
28898	1954	1125315	1981-05-29	1981-06-12	1	4180
365	23	1713332	1991-08-08	1991-08-22	1	7903
71386	4873	1729720	1980-11-25	1980-12-04	1	3990
76930	5257	1549786	1995-02-24	1996-02-19	1	9545
54889	3733	1119510	1984-04-28	1984-05-12	1	5245
44854	3044	1115008	1998-02-09	1998-02-23	1	10280
18369	1264	1713332	1982-05-21	1982-06-04	1	4537
57917	3950	1125315	2001-12-11	2001-12-25	1	11681
58598	3996	1118084	2003-02-27	2003-02-27	1	12110
39144	2661	1551099	1976-06-11	1976-06-11	1	2353
22273	1516	1125315	1979-05-07	1979-05-14	1	3420
4541	312	1102527	1991-05-14	1991-05-14	1	7803
56929	3879	1112807	1941-11-03	1941-12-01	1	-10258
26382	1782	738818	1955-08-13	1955-08-27	1	-5241
46385	3150	738818	1955-12-24	1956-01-07	1	-5108
28899	1954	1713332	2003-10-27	2003-11-03	1	12359
366	23	1118084	2012-05-11	2012-05-11	1	15471
71387	4873	1125315	1978-10-16	1978-10-30	1	3224
76931	5257	1549786	1997-02-13	1998-02-08	1	10265
54890	3733	1125315	1976-09-06	1976-09-20	1	2454
44855	3044	1115008	2013-09-30	2013-11-04	1	16013
18370	1264	1713332	1982-12-09	1982-12-30	1	4746
57918	3950	1125315	2016-05-12	2016-05-26	1	16947
58599	3996	1124957	1989-05-15	1989-05-15	1	7074
39145	2661	1125315	2015-11-02	2015-11-09	1	16748
22274	1516	1125315	1988-11-02	1988-11-09	1	6887
4542	312	1118084	2017-03-28	2017-03-28	1	17253
56930	3879	1125315	1984-10-05	1984-10-12	1	5398
26383	1782	967823	1956-01-11	1956-01-11	1	-5104
46386	3150	738818	1945-07-25	1945-08-08	1	-8912
28900	1954	1759842	2003-10-27	2003-11-03	1	12359
367	23	1125315	1997-02-04	1997-03-04	1	9924
71388	4873	1125315	1979-06-20	1979-07-04	1	3471
76932	5257	1589505	2004-01-08	2005-12-28	2	13145
54891	3733	1177480	1981-04-08	1981-04-22	1	4129
44856	3044	1118084	2007-09-29	2007-09-29	1	13785
18371	1264	1729720	2004-09-24	2004-10-05	1	12696
57919	3950	1713332	1979-09-14	1979-09-28	1	3557
58600	3996	1125315	1979-12-16	1979-12-30	1	3650
39146	2661	1149380	1967-09-18	1967-09-18	1	-836
22275	1516	1713332	1948-10-05	1948-10-26	1	-7737
4543	312	1177480	1985-01-15	1985-01-29	1	5507
56931	3879	1125315	1987-02-19	1987-03-05	1	6272
26384	1782	1110410	1956-01-11	1956-01-11	1	-5104
46387	3150	1112807	1957-01-22	1957-02-21	1	-4697
28901	1954	715997	1998-12-24	1998-12-24	1	10584
368	23	1713332	2016-01-21	2016-02-04	1	16835
71389	4873	1521369	1993-06-27	1994-06-22	1	8938
76933	5257	1713332	1987-02-02	1987-02-16	1	6255
54892	3733	1521369	1994-10-12	1995-10-07	1	9410
44857	3044	1174888	2012-10-07	2012-10-07	1	15620
18372	1264	1759842	2002-06-07	2002-06-28	1	11866
59876	4084	1119510	1987-01-26	1987-02-09	1	6248
58601	3996	1361711	2003-02-25	2003-02-25	1	12108
39147	2661	1713332	1967-12-04	1967-12-25	1	-738
22276	1516	1729720	1944-02-15	1944-02-22	1	-9445
4544	312	1713332	1974-12-18	1975-01-01	1	1826
56932	3879	1125315	1996-10-13	1996-10-20	1	9789
26385	1782	1112807	1954-08-01	1954-08-15	1	-5618
46388	3150	1125315	1945-07-25	1945-08-08	1	-8912
28902	1954	1118084	1970-08-14	1970-08-14	1	225
369	23	1125315	1988-05-08	1988-05-22	1	6716
71390	4873	1549786	1991-07-08	1992-07-02	1	8218
76934	5257	1759842	1987-02-02	1987-02-16	1	6255
55952	3811	738818	1929-06-13	1929-06-27	1	-14798
44858	3044	1729720	1977-10-21	1977-11-03	1	2863
18373	1264	1125315	2001-02-02	2001-02-09	1	11362
59877	4084	1125315	1971-08-29	1971-09-12	1	619
58602	3996	1119510	1979-12-16	1979-12-30	1	3650
39148	2661	1713332	1981-01-17	1981-03-21	1	4097
22277	1516	701322	2009-04-12	2009-04-12	1	14346
4545	312	1713332	2012-04-26	2012-05-03	1	15463
56933	3879	1713332	2014-04-26	2014-05-17	1	16207
26386	1782	1125315	1968-12-01	1969-03-01	1	-306
46389	3150	1125315	1955-12-24	1956-01-07	1	-5108
28903	1954	1174888	1949-12-17	1949-12-17	1	-7320
370	23	1125315	2011-11-24	2011-12-01	1	15309
71391	4873	1738521	1978-10-16	1978-10-30	1	3224
76935	5257	19127890	2003-01-13	2004-01-08	1	12425
55953	3811	1112807	1945-04-17	1945-05-08	1	-9004
44859	3044	1729720	2017-01-30	2017-02-09	1	17206
18374	1264	1125315	2014-05-03	2014-05-17	1	16207
59878	4084	914335	2010-10-03	2010-10-03	1	14885
58603	3996	1177480	1983-05-19	1983-06-09	1	4907
39149	2661	1759842	1981-01-17	1981-03-21	1	4097
22278	1516	1102527	1960-08-12	1960-08-12	1	-3429
4546	312	1115008	2012-03-24	2012-04-07	1	15437
57494	3921	1125315	1999-07-10	1999-07-10	1	10782
26387	1782	1741122	1956-01-11	1956-01-11	1	-5104
46390	3150	1174888	1957-01-22	1957-01-22	1	-4727
28904	1954	1728416	1972-11-07	1972-12-12	1	1076
371	23	1125315	2016-01-21	2016-02-04	1	16835
71392	4873	933724	1996-08-04	1996-08-11	1	9719
76936	5257	1125315	1979-06-08	1979-06-22	1	3459
55954	3811	1124300	1955-12-13	1955-12-13	1	-5133
44860	3044	1738521	1971-01-23	1971-02-06	1	401
18375	1264	1713332	2002-06-07	2002-06-28	1	11866
59879	4084	1112807	1962-12-13	1962-12-27	1	-2562
58604	3996	1177480	2010-08-23	2010-09-22	1	14874
39150	2661	1118084	2005-01-19	2005-01-19	1	12802
22279	1516	1112807	1961-08-07	1961-08-21	1	-3055
4547	312	1125315	1991-05-14	1991-06-13	1	7833
57495	3921	1549786	2001-10-07	2004-09-21	3	12682
26388	1782	19016749	1956-01-11	1956-01-11	1	-5104
46391	3150	1729720	1947-01-01	1947-01-11	1	-8391
29627	2004	738818	1984-05-25	1984-06-01	1	5265
372	23	1759842	1991-08-08	1991-08-22	1	7903
71393	4873	1125315	1977-02-11	1977-02-25	1	2612
76937	5257	1503184	1999-02-03	2001-01-23	2	11345
55955	3811	1125315	1929-06-13	1929-06-27	1	-14798
47726	3240	738818	2006-07-10	2006-07-24	1	13353
18376	1264	1759842	1982-05-21	1982-06-04	1	4537
59880	4084	1124300	1996-11-29	1996-11-29	1	9829
58605	3996	1322184	2003-02-25	2003-02-25	1	12108
39151	2661	1759842	1967-12-04	1967-12-25	1	-738
22280	1516	1125315	1982-09-26	1982-10-26	1	4681
4548	312	1759842	1974-12-18	1975-01-01	1	1826
57496	3921	1768849	1994-02-23	1994-03-09	1	8833
26389	1782	738818	1960-02-01	1960-02-08	1	-3615
46392	3150	1118084	1975-06-07	1975-06-07	1	1983
29628	2004	1125315	1984-05-25	1984-06-01	1	5265
1449	97	757627	2015-08-10	2015-08-10	1	16657
71394	4873	1713332	2005-03-17	2005-03-31	1	12873
76938	5257	1515774	1995-02-24	1996-02-19	1	9545
55956	3811	1713332	1942-07-09	1942-07-16	1	-10031
47727	3240	1112807	1947-09-15	1947-09-29	1	-8130
18377	1264	1759842	1982-12-09	1982-12-30	1	4746
59881	4084	1177480	1994-08-18	1994-09-17	1	9025
58606	3996	1332418	2003-02-25	2003-02-25	1	12108
39152	2661	19127890	1979-09-03	1980-08-28	1	3892
22281	1516	1713332	1972-12-14	1972-12-21	1	1085
4889	334	701322	2012-06-03	2012-06-03	1	15494
57497	3921	19127890	1995-11-08	1996-11-02	1	9802
26390	1782	753626	1956-01-11	1956-01-11	1	-5104
46393	3150	1119510	1955-12-24	1956-01-07	1	-5108
29629	2004	1125315	1987-01-08	1987-02-12	1	6251
1450	97	920293	1966-08-09	1966-08-16	1	-1234
71395	4873	1729720	2009-09-07	2009-09-17	1	14504
76939	5257	1515774	1997-02-13	1998-02-08	1	10265
55957	3811	1729720	2008-04-13	2008-04-22	1	13991
47728	3240	1112807	1969-05-06	1969-05-20	1	-226
19192	1315	1125315	1964-05-25	1964-06-08	1	-2033
59882	4084	1309944	2010-10-03	2010-10-03	1	14885
58607	3996	1539403	2003-02-25	2003-02-25	1	12108
39153	2661	19127890	1981-08-23	1982-08-18	1	4612
22282	1516	1729720	1959-04-21	1959-04-29	1	-3900
4890	334	738818	1970-04-21	1970-05-05	1	124
57498	3921	19127890	1997-10-28	1998-10-23	1	10522
26391	1782	920293	1979-12-14	1979-12-21	1	3641
46394	3150	1112807	1939-11-23	1939-12-07	1	-10983
29630	2004	1125315	2002-01-06	2002-01-13	1	11700
1451	97	933724	1966-08-09	1966-08-16	1	-1234
71396	4873	1738521	1977-02-11	1977-02-25	1	2612
76940	5257	1549786	2003-01-13	2004-01-08	1	12425
55958	3811	1759842	1966-11-15	1966-11-22	1	-1136
47729	3240	1115008	2015-07-07	2015-07-21	1	16637
19193	1315	1729720	1965-10-08	1965-10-16	1	-1538
59883	4084	1343916	2010-10-03	2010-10-03	1	14885
58608	3996	1729720	1979-07-03	1979-07-11	1	3478
39154	2661	1112807	1969-06-17	1969-07-08	1	-177
22283	1516	1125315	1952-10-17	1952-10-24	1	-6278
4891	334	1112807	1983-08-17	1983-08-31	1	4990
57499	3921	1115008	1999-07-10	1999-09-08	1	10842
26392	1782	933724	1979-12-14	1979-12-21	1	3641
46395	3150	1119510	1945-07-25	1945-08-08	1	-8912
29631	2004	1521369	1985-05-28	1986-05-23	1	5986
1452	97	1115008	1995-08-25	1995-09-22	1	9395
71397	4873	1759842	2005-03-17	2005-03-31	1	12873
76941	5257	1589505	1998-02-08	1999-02-03	1	10625
55959	3811	1125315	1985-10-05	1985-11-09	1	5791
47730	3240	1119510	1990-12-30	1991-01-06	1	7675
19194	1315	1112807	1960-05-04	1960-06-08	1	-3494
59884	4084	1713332	1980-09-29	1980-10-06	1	3931
61372	4190	1118084	2013-08-09	2013-08-09	1	15926
39155	2661	1129625	1968-10-01	1968-10-01	1	-457
22284	1516	1125315	1984-04-18	1984-05-02	1	5235
4892	334	1125315	1963-11-22	1963-12-06	1	-2218
57500	3921	1125315	1983-08-14	1983-08-28	1	4987
26393	1782	1102527	1968-12-01	1968-12-01	1	-396
46396	3150	1125315	1955-01-20	1955-01-27	1	-5453
29632	2004	1713332	2014-02-28	2014-03-14	1	16143
1453	97	1125315	1966-04-21	1966-04-28	1	-1344
71398	4873	1768849	1979-06-20	1979-07-04	1	3471
76942	5257	1759842	1994-10-12	1994-10-26	1	9064
55960	3811	1729720	1994-03-31	1994-04-09	1	8864
47731	3240	1119510	2006-07-10	2006-07-24	1	13353
19195	1315	1118084	1996-03-21	1996-03-21	1	9576
59885	4084	1759842	1980-09-29	1980-10-06	1	3931
61373	4190	1192710	1976-08-19	1976-08-19	1	2422
39156	2661	1154343	1967-09-18	1967-09-18	1	-836
22285	1516	1177480	2000-04-24	2000-05-08	1	11085
4893	334	1125315	1970-04-21	1970-05-05	1	124
57501	3921	1125315	1986-08-17	1986-09-16	1	6102
26394	1782	1112807	1954-04-19	1954-05-03	1	-5722
46397	3150	1125315	1957-01-22	1957-01-22	1	-4727
29633	2004	1118084	2005-12-09	2005-12-09	1	13126
1454	97	1125315	1992-09-04	1992-10-09	1	8317
71399	4873	19127890	1991-07-08	1992-07-02	1	8218
76943	5257	1768849	1979-06-08	1979-06-22	1	3459
55961	3811	701322	2007-02-14	2007-02-14	1	13558
47732	3240	1125315	2006-07-10	2006-07-24	1	13353
19196	1315	1125315	1962-05-29	1962-08-04	1	-2707
59886	4084	738818	1987-01-26	1987-02-09	1	6248
61374	4190	1759842	1995-10-18	1995-11-01	1	9435
39157	2661	1503184	1979-09-03	1980-08-28	1	3892
22286	1516	1557272	1998-03-02	1998-03-02	1	10287
4894	334	1125315	1992-03-25	1992-04-08	1	8133
57502	3921	1512674	2003-09-27	2004-09-21	1	12682
26395	1782	1125315	1955-08-13	1955-08-27	1	-5241
39170	2662	1768849	1979-04-22	1979-05-07	1	3413
29634	2004	1125315	1989-12-28	1990-01-11	1	7315
1455	97	1125315	2001-05-15	2001-05-29	1	11471
71400	4873	19127890	1993-06-27	1994-06-22	1	8938
76944	5257	19127890	1999-02-03	2001-01-23	2	11345
55962	3811	757627	2005-09-22	2005-09-22	1	13048
47733	3240	1322184	2008-10-08	2008-10-08	1	14160
19197	1315	1728416	1962-09-10	1962-09-24	1	-2656
59887	4084	1125315	1987-01-26	1987-02-09	1	6248
61375	4190	1125315	2000-08-23	2000-09-13	1	11213
39158	2661	1503184	1981-08-23	1982-08-18	1	4612
22287	1516	1759842	1972-12-14	1972-12-21	1	1085
4895	334	1125315	2006-08-29	2006-08-29	1	13389
57503	3921	1521369	2001-10-07	2003-09-27	2	12322
26396	1782	1125315	1960-02-01	1960-02-08	1	-3615
39672	2698	738818	2017-05-08	2017-05-15	1	17301
29635	2004	1125315	2005-11-13	2005-11-27	1	13114
1456	97	1137529	1983-07-25	1983-07-25	1	4953
71401	4873	920293	1996-08-04	1996-08-11	1	9719
55963	3811	1112807	1925-05-04	1925-06-01	1	-16285
47734	3240	1713332	1979-08-24	1979-09-07	1	3536
19198	1315	1759842	1989-10-06	1989-10-20	1	7232
59888	4084	1177480	1978-06-22	1978-07-13	1	3115
61376	4190	1177480	1987-01-13	1987-02-03	1	6242
39651	2697	1112807	1941-02-07	1941-02-28	1	-10534
25111	1702	1119510	2003-09-27	2003-10-04	1	12329
4896	334	1557272	2005-06-15	2005-06-15	1	12949
57504	3921	1713332	1982-02-09	1982-02-23	1	4436
26397	1782	1125315	1973-01-09	1973-01-30	1	1125
39673	2698	1118084	2019-04-17	2019-04-17	1	18003
29636	2004	1177480	2014-02-28	2014-03-14	1	16143
1457	97	1177480	2002-07-08	2002-07-29	1	11897
71402	4873	1125315	2004-09-18	2004-10-02	1	12693
55964	3811	1112807	1927-05-22	1927-08-20	1	-15475
47735	3240	1728416	1948-06-28	1948-07-12	1	-7843
19199	1315	1115008	2010-02-21	2010-03-07	1	14675
59889	4084	1112807	1976-08-01	1976-08-31	1	2434
61377	4190	1713332	1995-10-18	1995-11-01	1	9435
39652	2697	1125315	1994-11-17	1994-12-22	1	9121
25112	1702	1125315	1979-07-08	1979-10-06	1	3565
4897	334	1729720	1940-02-13	1940-02-25	1	-10903
57505	3921	1115008	2007-07-19	2007-08-23	1	13748
26398	1782	1125315	2009-11-17	2009-12-01	1	14579
39674	2698	1125315	2017-05-08	2017-05-15	1	17301
29637	2004	1503184	1985-05-28	1986-05-23	1	5986
1458	97	1759842	1952-12-28	1953-01-11	1	-6199
73043	4991	920293	2007-08-14	2007-08-21	1	13746
55965	3811	1125315	1963-10-02	1963-10-16	1	-2269
47736	3240	1759842	1979-08-24	1979-09-07	1	3536
19200	1315	1125315	1974-10-14	1974-10-28	1	1761
59890	4084	1125315	1973-03-20	1973-06-18	1	1264
62583	4274	738818	1947-05-09	1947-05-23	1	-8259
39653	2697	1125315	2001-06-15	2001-06-22	1	11495
25113	1702	1112807	1965-11-26	1965-12-10	1	-1483
4898	334	738818	1982-08-26	1982-09-02	1	4627
57506	3921	1118084	2014-06-26	2014-06-26	1	16247
26399	1782	1713332	1997-10-22	1997-10-29	1	10163
39675	2698	1177480	1989-08-02	1989-08-16	1	7167
29638	2004	1738521	1972-02-26	1972-03-11	1	800
1459	97	1759842	1992-08-27	1992-09-03	1	8281
73044	4991	975125	1997-07-13	1997-07-13	1	10055
55966	3811	1125315	1991-11-23	1991-12-07	1	8010
47737	3240	1112807	1948-06-28	1948-07-12	1	-7843
19201	1315	1713332	1989-10-06	1989-10-20	1	7232
59891	4084	1717327	1962-12-13	1962-12-27	1	-2562
62584	4274	1124300	1958-05-31	1958-05-31	1	-4233
39654	2697	1361711	1981-05-14	1981-05-14	1	4151
25114	1702	1125315	1976-09-30	1976-10-21	1	2485
4899	334	1112807	1982-02-08	1982-03-08	1	4449
57507	3921	1125315	1982-02-09	1982-02-23	1	4436
26400	1782	1746114	1956-01-11	1956-01-11	1	-5104
39676	2698	1119510	2017-05-08	2017-05-15	1	17301
29639	2004	1759842	1990-02-25	1990-03-04	1	7367
1460	97	920293	1966-12-15	1966-12-22	1	-1106
73045	4991	1107830	1997-08-01	1997-08-01	1	10074
55967	3811	1125315	1998-08-03	1998-08-17	1	10455
47738	3240	1112807	1963-02-23	1963-03-09	1	-2490
19202	1315	1717327	1961-05-29	1961-06-12	1	-3125
60999	4160	738818	1964-03-28	1964-04-11	1	-2091
62585	4274	1125315	1947-05-09	1947-05-23	1	-8259
39655	2697	1539403	1991-06-06	1991-06-06	1	7826
25115	1702	738818	2003-09-27	2003-10-04	1	12329
4900	334	1115008	2005-09-03	2005-11-02	1	13089
57508	3921	1125315	1994-02-23	1994-03-09	1	8833
26401	1782	782043	1956-01-11	1956-01-11	1	-5104
39677	2698	1125315	2001-01-15	2001-01-29	1	11351
29640	2004	1112807	1972-02-26	1972-03-11	1	800
1461	97	920293	1973-01-28	1973-02-04	1	1130
73046	4991	1125315	1985-04-23	1985-05-07	1	5605
55968	3811	1713332	1966-11-15	1966-11-22	1	-1136
47739	3240	1125315	1951-01-18	1951-02-01	1	-6909
19203	1315	1112807	1961-05-29	1961-06-12	1	-3125
61000	4160	738818	2004-05-13	2004-05-27	1	12565
62586	4274	1125315	1999-07-31	1999-08-14	1	10817
39656	2697	1713332	1960-03-14	1960-03-21	1	-3573
25116	1702	1102527	1979-07-08	1979-07-08	1	3475
4901	334	1119510	1970-04-21	1970-05-05	1	124
57509	3921	1515774	1995-11-08	1996-11-02	1	9802
26402	1782	1119510	1955-08-13	1955-08-27	1	-5241
41451	2812	1118084	1970-12-15	1970-12-15	1	348
29641	2004	1125315	1988-08-05	1988-08-12	1	6798
1462	97	933724	1966-12-15	1966-12-22	1	-1106
73047	4991	1503184	1986-07-01	1988-06-20	2	6745
55969	3811	1759842	1942-07-09	1942-07-16	1	-10031
47740	3240	1177480	1976-08-11	1976-09-08	1	2442
19204	1315	1112807	1962-09-10	1962-09-24	1	-2656
61001	4160	1102527	1978-05-17	1978-05-17	1	3058
62587	4274	920293	1949-12-31	1950-01-07	1	-7299
39657	2697	1729720	1947-12-21	1947-12-30	1	-8038
25117	1702	1118084	2008-10-07	2008-10-07	1	14159
4902	334	1124957	2006-08-29	2006-08-29	1	13389
57510	3921	1515774	1997-10-28	1998-10-23	1	10522
26403	1782	1119510	1960-02-01	1960-02-08	1	-3615
41452	2812	1125315	1999-07-20	1999-08-03	1	10806
29642	2004	1713332	1990-02-25	1990-03-04	1	7367
1463	97	933724	1973-01-28	1973-02-04	1	1130
73048	4991	1521369	1992-05-30	1993-05-25	1	8545
55970	3811	1119510	1929-06-13	1929-06-27	1	-14798
47741	3240	1728416	1947-09-15	1947-09-29	1	-8130
19205	1315	1125315	1962-02-24	1962-03-10	1	-2854
61002	4160	1112807	1969-02-28	1969-04-04	1	-272
62588	4274	920293	1954-01-30	1954-02-06	1	-5808
39658	2697	1729720	1978-03-07	1978-03-16	1	2996
25118	1702	1125315	1967-09-20	1967-10-04	1	-820
4903	334	1125315	1962-11-12	1962-11-26	1	-2593
57511	3921	1549786	1997-10-28	1998-10-23	1	10522
26404	1782	1125315	1961-09-09	1961-12-08	1	-2946
41453	2812	1713332	1981-08-26	1981-09-02	1	4262
29643	2004	1119510	1984-05-25	1984-06-01	1	5265
1464	97	1125315	1959-09-23	1959-11-22	1	-3693
73049	4991	933724	2007-08-14	2007-08-21	1	13746
55971	3811	1125315	1932-05-17	1932-05-24	1	-13736
47742	3240	1728416	1951-01-18	1951-02-01	1	-6909
19206	1315	1125315	1973-02-09	1973-02-23	1	1149
61003	4160	1112807	1989-02-18	1989-03-18	1	7016
62589	4274	933724	1954-01-30	1954-02-06	1	-5808
39659	2697	738818	2004-03-20	2004-04-03	1	12511
25119	1702	1125315	2003-09-27	2003-10-04	1	12329
4904	334	1125315	1982-08-26	1982-09-02	1	4627
57512	3921	1595799	2001-10-07	2003-09-27	2	12322
26405	1782	1125315	2018-12-02	2018-12-16	1	17881
41454	2812	1112807	1940-04-26	1940-05-10	1	-10828
29644	2004	19127890	1985-05-28	1986-05-23	1	5986
1465	97	1177480	1986-11-30	1987-01-04	1	6212
73050	4991	1118084	2006-04-12	2006-04-12	1	13250
55972	3811	1125315	1932-08-24	1932-09-07	1	-13630
47743	3240	738818	1990-12-30	1991-01-06	1	7675
19207	1315	1729720	1971-03-21	1971-04-02	1	456
61004	4160	1125315	1964-03-28	1964-04-11	1	-2091
62590	4274	1115008	2002-07-03	2002-10-01	1	11961
39660	2697	914335	2005-09-08	2005-09-08	1	13034
25120	1702	1125315	2016-08-22	2016-09-05	1	17049
4905	334	1125315	2012-11-25	2012-12-02	1	15676
57513	3921	1713332	1983-08-14	1983-08-28	1	4987
26406	1782	1728416	1954-04-19	1954-05-03	1	-5722
41455	2812	1115008	2000-04-23	2000-06-22	1	11130
30469	2062	1118084	1984-03-25	1984-03-25	1	5197
1466	97	1177480	1996-09-16	1996-10-07	1	9776
73051	4991	1125315	1983-01-18	1983-02-01	1	4779
55973	3811	1557272	2000-08-24	2000-08-24	1	11193
47744	3240	1124300	1981-08-07	1981-08-07	1	4236
20014	1365	933724	1993-09-14	1993-09-28	1	8671
61005	4160	1125315	1991-05-14	1991-05-21	1	7810
62591	4274	1119510	1978-11-10	1978-11-17	1	3242
39661	2697	1112807	1936-07-14	1936-07-28	1	-12210
25121	1702	1717327	1965-11-26	1965-12-10	1	-1483
4906	334	1177480	2009-09-12	2009-10-12	1	14529
57514	3921	1124957	1999-07-10	1999-07-10	1	10782
26407	1782	19003953	1956-01-11	1956-01-11	1	-5104
41456	2812	1112807	1947-06-19	1947-08-18	1	-8172
30470	2062	1125315	1951-04-23	1951-05-28	1	-6793
1467	97	1118084	1986-03-25	1986-03-25	1	5927
73052	4991	1503184	1992-05-30	1993-05-25	1	8545
55974	3811	1729720	1944-12-24	1945-01-04	1	-9128
47745	3240	1125315	2010-09-09	2010-09-16	1	14868
20015	1365	1112807	1967-05-03	1967-07-02	1	-914
61006	4160	1125315	2004-05-13	2004-05-27	1	12565
62592	4274	1124957	1995-08-25	1995-08-25	1	9367
39662	2697	1119510	2004-03-20	2004-04-03	1	12511
25122	1702	1729720	1970-08-05	1970-08-15	1	226
4907	334	1112807	1937-03-26	1937-04-09	1	-11955
57515	3921	1125315	2008-02-25	2008-03-10	1	13948
27073	1829	1125315	1985-04-02	1985-04-16	1	5584
41457	2812	1125315	2012-11-24	2012-12-08	1	15682
30471	2062	1125315	1951-12-03	1951-12-10	1	-6597
1468	97	1119510	1999-07-06	1999-07-20	1	10792
73053	4991	1759842	1972-11-09	1972-11-16	1	1050
58806	4010	738818	2006-01-13	2006-01-20	1	13168
47746	3240	1759842	1975-04-21	1975-05-12	1	1957
20016	1365	1125315	1963-10-21	1963-11-04	1	-2250
61007	4160	1125315	2015-07-09	2015-07-23	1	16639
62593	4274	1125315	1943-04-22	1943-04-29	1	-9744
39663	2697	1124300	1975-12-26	1975-12-26	1	2185
25709	1744	1125315	1981-09-27	1981-10-27	1	4317
4908	334	1112807	1937-07-24	1937-08-28	1	-11814
57516	3921	1177480	2004-08-12	2004-09-02	1	12663
27074	1829	1125315	2003-07-17	2003-07-24	1	12257
41458	2812	1713332	1977-08-11	1977-08-18	1	2786
30472	2062	1177480	1988-02-02	1988-03-08	1	6641
1469	97	1125315	1999-07-06	1999-07-20	1	10792
73054	4991	19127890	1986-07-01	1988-06-20	2	6745
58807	4010	740275	1977-08-11	1978-05-18	1	3059
47747	3240	1112807	1951-05-27	1951-08-25	1	-6704
20017	1365	1125315	1978-06-05	1978-06-12	1	3084
61008	4160	1503184	1983-05-26	1984-05-20	1	5253
62594	4274	1177480	1995-08-25	1995-11-23	1	9457
39664	2697	1125315	2004-03-20	2004-04-03	1	12511
25710	1744	1177480	2007-07-04	2007-07-18	1	13712
4909	334	1118084	1972-10-18	1972-10-18	1	1021
57517	3921	1549786	1995-11-08	1996-11-02	1	9802
27075	1829	19127890	1989-05-19	1990-05-14	1	7438
41459	2812	1759842	1981-08-26	1981-09-02	1	4262
30473	2062	1326303	2014-11-29	2014-11-29	1	16403
1470	97	1125315	2015-03-23	2015-04-06	1	16531
73055	4991	1112807	1973-03-31	1973-04-21	1	1206
58808	4010	1115008	2019-05-25	2019-06-15	1	18062
47748	3240	1125315	1990-12-30	1991-01-06	1	7675
20018	1365	1521369	1980-08-02	1981-07-28	1	4226
61009	4160	1521369	1976-07-01	1977-06-26	1	2733
62595	4274	1713332	1986-03-02	1986-03-16	1	5918
39665	2697	1309944	2005-09-08	2005-09-08	1	13034
25711	1744	738818	1999-08-10	1999-08-24	1	10827
4910	334	1119510	1982-08-26	1982-09-02	1	4627
57518	3921	19127890	2003-09-27	2004-09-21	1	12682
27076	1829	920293	2005-08-04	2005-08-11	1	13006
41460	2812	1125315	1962-08-29	1962-09-12	1	-2668
30474	2062	1759842	1950-12-29	1951-01-05	1	-6936
1471	97	1149380	1983-07-25	1983-07-25	1	4953
73056	4991	1125315	1976-04-16	1976-04-23	1	2304
58809	4010	1119510	2006-01-13	2006-01-20	1	13168
47749	3240	1125315	1992-10-28	1992-11-11	1	8350
20019	1365	920293	1993-09-14	1993-09-28	2	8671
61010	4160	1521369	1979-06-16	1980-06-10	1	3813
62596	4274	738818	1978-11-10	1978-11-17	1	3242
39666	2697	1332418	1994-06-23	1994-06-23	1	8939
25712	1744	1102527	2010-06-02	2010-06-02	1	14762
4911	334	1177480	2006-08-29	2006-09-28	1	13419
60209	4105	1112807	1960-09-24	1960-10-15	1	-3365
27077	1829	933724	2005-08-04	2005-08-11	1	13006
41461	2812	1125315	1971-10-13	1971-10-27	1	664
30475	2062	1112807	1948-04-08	1948-04-22	1	-7924
1472	97	1713332	1952-12-28	1953-01-11	1	-6199
73057	4991	1713332	1972-11-09	1972-11-16	1	1050
58810	4010	1125315	2006-01-13	2006-01-20	1	13168
47750	3240	1125315	2000-02-05	2000-02-26	1	11013
20020	1365	933724	1993-11-13	1993-11-27	1	8731
61011	4160	914335	1965-11-25	1965-11-25	1	-1498
62597	4274	920293	1958-03-16	1958-03-23	1	-4302
39667	2697	1343916	2005-09-08	2005-09-08	1	13034
25713	1744	1119510	1980-05-06	1980-05-13	1	3785
4912	334	1729720	1974-09-05	1974-09-15	1	1718
60210	4105	1125315	1947-12-03	1947-12-17	1	-8051
27078	1829	1177480	1975-07-22	1975-08-05	1	2042
41462	2812	1125315	1991-07-12	1991-08-09	1	7890
30476	2062	1174888	1989-03-03	1989-03-03	1	7001
1473	97	701322	2016-07-05	2016-07-05	1	16987
73058	4991	1729720	1973-06-01	1973-06-11	1	1257
58811	4010	1515774	1996-04-05	1999-03-21	3	10671
47751	3240	1347450	2008-10-08	2008-10-08	1	14160
20021	1365	1118084	2002-06-28	2002-06-28	1	11866
61012	4160	920293	1993-09-11	1993-09-18	1	8661
62598	4274	933724	1958-03-16	1958-03-23	1	-4302
39668	2697	1112807	1933-07-19	1933-08-02	1	-13301
25714	1744	1125315	1999-08-10	1999-08-24	1	10827
4913	334	757627	2010-07-14	2010-07-14	1	14804
60211	4105	1125315	2009-02-16	2009-02-23	1	14298
27079	1829	1521369	1983-06-20	1984-06-14	1	5278
41463	2812	1759842	1977-08-11	1977-08-18	1	2786
30477	2062	1307863	2014-11-29	2014-11-29	1	16403
1474	97	715997	2016-07-05	2016-07-05	1	16987
73059	4991	19127890	1992-05-30	1993-05-25	1	8545
58812	4010	1515774	2000-03-15	2001-03-10	1	11391
47752	3240	1713332	1975-04-21	1975-05-12	1	1957
20022	1365	1125315	1993-10-19	1993-11-02	1	8706
61013	4160	933724	1993-09-11	1993-09-18	1	8661
62599	4274	1112807	1926-01-29	1926-02-12	1	-16029
39669	2697	1322184	1997-07-10	1997-07-10	1	10052
25715	1744	1713332	2011-05-13	2011-06-03	1	15128
4914	334	920293	1964-07-13	1964-07-20	1	-1991
60212	4105	1759842	2004-12-19	2005-01-02	1	12785
27080	1829	1503184	1989-05-19	1990-05-14	1	7438
42246	2863	1118084	2006-04-21	2006-04-21	1	13259
30478	2062	1713332	1950-12-29	1951-01-05	1	-6936
1475	97	738818	1999-07-06	1999-07-20	1	10792
73060	4991	1125315	1971-09-08	1971-09-22	1	629
58813	4010	19127890	1996-04-05	2001-03-10	5	11391
47753	3240	1729720	1970-12-16	1970-12-25	1	358
20023	1365	1177480	1975-10-26	1975-11-09	1	2138
61014	4160	1124300	2004-08-08	2004-08-08	1	12638
62600	4274	1125315	1938-04-27	1938-05-11	1	-11558
39670	2697	1759842	1960-03-14	1960-03-21	1	-3573
25716	1744	1115008	2010-06-02	2010-08-01	1	14822
4915	334	933724	1964-07-13	1964-07-20	1	-1991
60213	4105	1112807	1951-10-12	1951-10-26	1	-6642
27081	1829	19127890	1983-06-20	1984-06-14	1	5278
42247	2863	1717327	1963-10-04	1963-10-18	1	-2267
30479	2062	1728416	1948-04-08	1948-04-22	1	-7924
1476	97	920293	1966-10-04	1966-10-11	1	-1178
73061	4991	1125315	1992-09-08	1992-10-13	1	8321
58814	4010	1124300	2012-12-17	2012-12-17	1	15691
48459	3294	1124300	1985-11-23	1985-11-23	1	5805
20024	1365	1177480	1996-05-30	1996-07-29	1	9706
61015	4160	1125315	1978-05-17	1978-07-16	1	3118
62601	4274	1125315	1973-10-29	1973-11-05	1	1404
39671	2697	1125315	1941-10-07	1941-10-21	1	-10299
25717	1744	1125315	1999-01-09	1999-01-23	1	10614
4916	334	1112807	1939-04-02	1939-04-16	1	-11218
60214	4105	1124300	1983-04-12	1983-04-12	1	4849
27082	1829	1112807	1989-07-22	1989-08-12	1	7163
42248	2863	1729720	2015-05-07	2015-05-16	1	16571
30480	2062	1125315	1962-01-30	1962-02-20	1	-2872
1477	97	933724	1966-10-04	1966-10-11	1	-1178
73062	4991	1177480	1994-08-04	1994-08-25	1	9002
58815	4010	1125315	1994-01-27	1994-02-10	1	8806
48460	3294	1125315	2017-08-20	2017-08-20	1	17398
20025	1365	1521369	1982-07-23	1983-07-18	1	4946
61016	4160	1503184	1976-07-01	1977-06-26	1	2733
62602	4274	1125315	1978-11-10	1978-11-17	1	3242
41501	2815	933724	1998-10-05	1998-10-12	1	10511
25718	1744	1729720	1994-05-24	1994-06-05	1	8921
4917	334	1125315	1944-09-16	1944-09-23	1	-9231
60215	4105	1322184	2019-02-16	2019-02-16	1	17943
27083	1829	1124300	2002-08-09	2002-08-09	1	11908
42249	2863	1112807	1963-10-04	1963-10-18	1	-2267
30481	2062	1125315	1989-03-03	1989-03-17	2	7015
1478	97	1501700	2008-07-02	2008-07-02	1	14062
73063	4991	1343916	1997-08-01	1997-08-01	1	10074
58816	4010	1125315	1999-11-24	1999-12-01	1	10926
48461	3294	1177480	2010-06-30	2010-07-28	1	14818
20026	1365	1713332	2009-02-25	2009-03-11	1	14314
61017	4160	1503184	1979-06-16	1980-06-10	1	3813
62603	4274	1125315	1986-03-02	1986-03-16	1	5918
41502	2815	1125315	1964-08-04	1964-08-18	1	-1962
25719	1744	1759842	2011-05-13	2011-06-03	1	15128
4918	334	1125315	1979-02-19	1979-03-26	1	3371
60216	4105	1713332	1977-04-26	1977-05-10	1	2686
27084	1829	1503184	1983-06-20	1984-06-14	1	5278
42250	2863	1192710	1966-10-04	1966-10-04	1	-1185
30482	2062	1125315	2006-02-16	2006-05-17	1	13285
1479	97	1713332	1992-08-27	1992-09-03	1	8281
73064	4991	1521369	1986-07-01	1988-06-20	2	6745
58817	4010	1521369	1999-03-21	2000-03-15	1	11031
48462	3294	1729720	1993-09-29	1993-10-09	1	8682
20027	1365	920293	1995-01-08	1995-01-15	1	9145
61018	4160	1521369	1983-05-26	1984-05-20	1	5253
62604	4274	1177480	1997-11-12	1997-11-26	1	10191
41503	2815	1125315	1993-06-12	1993-06-26	1	8577
25720	1744	738818	1980-05-06	1980-05-13	1	3785
6082	418	738818	2016-04-03	2016-04-17	1	16908
60217	4105	1125315	1957-05-14	1957-05-28	1	-4601
27085	1829	1521369	1989-05-19	1990-05-14	1	7438
42251	2863	1759842	1968-10-14	1968-10-28	1	-430
30483	2062	1310149	2014-11-29	2014-11-29	1	16403
2097	141	1125315	1987-03-16	1987-03-30	1	6297
75766	5189	1124300	1998-10-28	1998-10-28	1	10527
58818	4010	1713332	1982-12-05	1982-12-19	1	4735
48463	3294	1125315	2015-08-13	2015-08-27	1	16674
20028	1365	1112807	1974-02-25	1974-05-26	1	1606
61019	4160	1713332	1985-09-13	1985-09-27	1	5748
62605	4274	1713332	1967-08-02	1967-08-16	1	-869
41504	2815	1125315	1996-01-17	1996-01-17	1	9512
25721	1744	1118084	2010-08-06	2010-08-06	1	14827
6083	418	1112807	1964-01-20	1964-02-03	1	-2159
60218	4105	1125315	1995-09-13	1995-09-27	1	9400
31733	2149	1125315	1959-08-17	1959-08-31	1	-3776
42252	2863	1112807	1988-05-16	1988-08-14	1	6800
30484	2062	1768849	1989-03-03	1989-03-17	1	7015
2098	141	1729720	1993-09-22	1993-10-04	1	8677
75767	5189	738818	1970-04-05	1970-04-19	1	108
58819	4010	1713332	2016-05-21	2016-06-11	1	16963
48464	3294	1174888	2017-08-20	2017-08-20	1	17398
20029	1365	1125315	1986-02-20	1986-02-27	1	5901
61020	4160	1717327	1964-01-26	1964-02-09	1	-2153
62606	4274	1729720	1930-03-10	1930-03-23	1	-14529
41505	2815	1125315	2002-03-23	2002-04-06	1	11783
25722	1744	1119510	1999-08-10	1999-08-24	1	10827
6084	418	1125315	1961-05-17	1961-08-15	1	-3061
60219	4105	1713332	2004-12-19	2005-01-02	1	12785
31734	2149	1125315	1960-02-12	1960-03-04	1	-3590
42253	2863	1125315	1990-03-18	1990-04-01	1	7395
30485	2062	1112807	1964-04-10	1964-04-24	1	-2078
2099	141	1778162	1987-01-13	1987-01-27	1	6235
75768	5189	738818	1972-01-15	1972-01-22	1	751
58820	4010	723013	1978-07-13	1978-07-13	1	3115
48465	3294	1759842	1952-03-15	1952-03-22	1	-6494
20030	1365	1503184	1980-08-02	1981-07-28	1	4226
61021	4160	1759842	1985-09-13	1985-09-27	1	5748
62607	4274	933724	1949-12-31	1950-01-07	1	-7299
41506	2815	1177480	1996-01-17	1996-04-16	1	9602
25723	1744	1125315	1980-05-06	1980-05-13	1	3785
6085	418	1125315	2016-04-03	2016-04-17	1	16908
60220	4105	1759842	1977-04-26	1977-05-10	1	2686
31735	2149	1125315	2004-09-26	2004-10-03	1	12694
42254	2863	1713332	1968-10-14	1968-10-28	1	-430
30486	2062	1125315	1947-08-13	1947-08-27	1	-8163
2100	141	1125315	1987-01-13	1987-01-27	1	6235
75769	5189	1125315	1970-04-05	1970-04-19	1	108
58821	4010	1125315	1982-12-05	1982-12-19	1	4735
48466	3294	1115008	2017-08-20	2017-09-19	1	17428
20031	1365	19127890	1982-07-23	1983-07-18	1	4946
61022	4160	933724	1989-08-01	1989-08-08	1	7159
62608	4274	1112807	1943-01-30	1943-03-01	1	-9803
41507	2815	1728416	1964-08-04	1964-08-18	1	-1962
25724	1744	1125315	1993-02-15	1993-03-01	1	8460
6086	418	1759842	1962-05-09	1962-05-23	1	-2780
60221	4105	1125315	1950-08-04	1950-08-18	1	-7076
31736	2149	1125315	2010-01-12	2010-01-19	1	14628
42255	2863	1729720	1961-11-14	1961-11-21	1	-2963
30487	2062	1125315	1985-04-04	1985-04-18	1	5586
2101	141	1177480	2013-09-23	2013-10-21	1	15999
75770	5189	1125315	1972-01-15	1972-01-22	1	751
58822	4010	1125315	1985-01-24	1985-02-07	1	5516
48467	3294	1125315	2008-09-09	2008-09-16	1	14138
20032	1365	920293	1993-11-13	1993-11-27	2	8731
61023	4160	1119510	1964-03-28	1964-04-11	1	-2091
62609	4274	1115008	2018-04-10	2018-06-09	1	17691
41508	2815	920293	1998-10-05	1998-10-12	1	10511
25725	1744	1125315	2014-10-20	2014-11-03	1	16377
6087	418	1759842	1973-04-22	1973-04-29	1	1214
60222	4105	1125315	1993-06-20	1993-07-04	1	8585
31737	2149	1322184	2005-11-12	2005-11-12	1	13099
42256	2863	1102527	1988-05-16	1988-05-16	1	6710
32041	2168	1112807	1962-06-14	1962-06-28	1	-2744
2102	141	1500211	2000-02-14	2001-02-08	1	11361
75771	5189	1713332	1980-09-28	1980-10-05	1	3930
58823	4010	1515774	1994-04-16	1995-04-11	1	9231
48468	3294	1713332	1952-03-15	1952-03-22	1	-6494
20033	1365	933724	1995-01-08	1995-01-15	1	9145
61024	4160	1125315	2017-01-27	2017-02-03	1	17200
62610	4274	1119510	1947-05-09	1947-05-23	1	-8259
41509	2815	1759842	1973-03-06	1973-03-27	1	1181
25726	1744	1177480	1990-07-12	1990-08-02	1	7518
6088	418	1112807	1967-09-13	1967-12-12	1	-751
60223	4105	1177480	2000-11-14	2000-12-05	1	11296
31738	2149	1118084	1995-11-25	1995-11-25	1	9459
42257	2863	1112807	1972-02-19	1972-03-11	1	800
32042	2168	1112807	1963-12-02	1963-12-16	1	-2208
2103	141	1503184	1999-02-19	2000-02-14	1	11001
75772	5189	1759842	1957-01-16	1957-02-06	1	-4712
58824	4010	1549786	1994-04-16	1995-04-11	1	9231
52160	3553	1112807	1944-08-26	1944-09-09	1	-9245
20034	1365	1115008	2009-02-25	2009-03-11	1	14314
61025	4160	1177480	2016-07-08	2016-08-12	1	17025
62611	4274	1125315	1995-08-25	1995-08-25	1	9367
41510	2815	1112807	1973-02-18	1973-03-18	1	1172
28718	1945	1112807	1983-09-09	1983-09-23	1	5013
6089	418	1118084	1996-02-01	1996-02-01	1	9527
60224	4105	1347450	2019-02-16	2019-02-16	1	17943
31739	2149	1347450	2005-11-12	2005-11-12	1	13099
42907	2905	738818	1987-10-07	1987-10-14	1	6495
32043	2168	1125315	1962-10-17	1962-11-07	1	-2612
2104	141	1521369	1999-02-19	2000-02-14	1	11001
75773	5189	1119510	1972-01-15	1972-01-22	1	751
58825	4010	1549786	1996-04-05	1999-03-21	3	10671
52161	3553	1729720	1984-08-13	1984-08-25	1	5350
20035	1365	1503184	1982-07-23	1983-07-18	1	4946
61026	4160	1177480	2017-06-08	2017-06-29	1	17346
62612	4274	1729720	1986-01-06	1986-01-16	1	5859
41511	2815	1125315	1992-04-10	1992-04-17	1	8142
28719	1945	1125315	1972-11-17	1973-01-16	1	1111
6090	418	1125315	1990-10-01	1990-10-08	1	7585
60225	4105	1728416	1951-10-12	1951-10-26	1	-6642
31740	2149	1713332	1984-10-06	1984-10-20	1	5406
42908	2905	920293	2007-01-01	2007-01-08	1	13521
32044	2168	1125315	1967-01-20	1967-02-03	1	-1063
2105	141	1778162	1987-10-31	1987-11-14	1	6526
75774	5189	1347450	2007-09-09	2007-09-09	1	13765
58826	4010	1729720	1981-03-18	1981-03-30	1	4106
52162	3553	701322	2007-04-20	2007-04-20	1	13623
20036	1365	1729720	2007-11-22	2007-11-30	1	13847
61027	4160	1309944	1965-11-25	1965-11-25	1	-1498
62613	4274	1759842	1967-08-02	1967-08-16	1	-869
41512	2815	1125315	2006-01-24	2006-02-07	1	13186
28720	1945	1713332	1983-09-09	1983-09-23	1	5013
6091	418	1125315	1999-09-07	1999-09-21	1	10855
60226	4105	1729720	1950-05-24	1950-06-06	1	-7149
31741	2149	1729720	1961-10-08	1961-10-15	1	-3000
42909	2905	1125315	1981-02-14	1981-02-21	1	4069
32045	2168	1125315	1995-09-12	1995-09-26	1	9399
2106	141	1118084	2015-11-12	2015-11-12	1	16751
75775	5189	1759842	1980-09-28	1980-10-05	1	3930
58827	4010	1729720	2015-10-21	2015-10-31	1	16739
52163	3553	738818	1942-09-08	1942-09-15	1	-9970
20037	1365	1738521	1975-10-26	1975-11-09	1	2138
61028	4160	1343916	1965-11-25	1965-11-25	1	-1498
64024	4375	1119510	1946-05-27	1946-06-03	1	-8613
41513	2815	1174888	1996-01-17	1996-01-17	1	9512
28721	1945	1729720	2007-10-22	2007-11-01	1	13818
6092	418	1713332	1962-05-09	1962-05-23	1	-2780
61870	4223	1112807	1959-02-01	1959-02-15	1	-3973
31742	2149	1112807	1982-03-14	1982-04-04	1	4476
42910	2905	1125315	1987-10-07	1987-10-14	1	6495
32046	2168	1129625	1958-10-04	1958-10-04	1	-4107
2107	141	1125315	1987-10-31	1987-11-14	1	6526
75776	5189	1119510	1970-04-05	1970-04-19	1	108
58828	4010	1759842	2016-05-21	2016-06-11	1	16963
52164	3553	1125315	1948-05-01	1948-05-15	1	-7901
20038	1365	19127890	1980-08-02	1981-07-28	1	4226
61029	4160	19127890	1976-07-01	1977-06-26	1	2733
64025	4375	1125315	1933-06-09	1933-06-16	1	-13348
41514	2815	1713332	1973-03-06	1973-03-27	1	1181
28722	1945	1118084	2007-06-08	2007-06-08	1	13672
6093	418	1713332	1973-04-22	1973-04-29	1	1214
61871	4223	1112807	1961-11-25	1961-12-09	1	-2945
31743	2149	1125315	1996-10-12	1996-10-19	1	9788
42911	2905	1125315	1995-08-29	1995-09-12	1	9385
32047	2168	1112807	1960-08-23	1960-09-27	1	-3383
2108	141	19127890	1999-02-19	2000-02-14	1	11001
75777	5189	1125315	1978-08-19	1978-09-23	1	3187
58829	4010	1125315	2018-04-30	2018-05-30	1	17681
52165	3553	1125315	1973-09-24	1973-10-01	1	1369
23073	1567	1125315	1989-07-07	1989-07-14	1	7134
61030	4160	19127890	1979-06-16	1980-06-10	1	3813
64026	4375	1125315	1952-06-13	1952-06-20	1	-6404
41515	2815	1713332	2006-09-14	2006-09-28	1	13419
28723	1945	1125315	1985-01-13	1985-02-03	1	5512
6094	418	1112807	1971-08-23	1971-09-13	1	620
61872	4223	1118084	1989-08-05	1989-08-05	1	7156
31744	2149	1192710	1962-05-08	1962-05-08	1	-2795
42912	2905	1125315	2007-08-25	2007-09-08	1	13764
32048	2168	1149380	1960-09-19	1960-09-19	1	-3391
2109	141	1125315	1995-07-30	1995-09-28	1	9401
75778	5189	1177480	2018-07-25	2018-08-15	1	17758
58830	4010	1503184	1999-03-21	2000-03-15	1	11031
52166	3553	1125315	1977-05-13	1977-05-20	1	2696
23074	1567	1125315	2014-09-15	2014-09-29	1	16342
61031	4160	920293	1989-08-01	1989-08-08	1	7159
64027	4375	1310149	2006-06-25	2006-06-25	1	13324
41516	2815	1759842	2006-09-14	2006-09-28	1	13419
28724	1945	1738521	1971-05-28	1971-06-11	1	526
6095	418	1125315	1958-07-20	1958-08-03	1	-4169
61873	4223	1125315	1962-11-01	1962-11-15	1	-2604
31745	2149	1125315	1972-10-27	1972-12-01	1	1065
42913	2905	1177480	1974-06-06	1974-06-20	1	1631
32049	2168	1729720	1980-08-19	1980-08-28	1	3892
5117	350	708298	1995-09-11	1995-09-11	1	9384
75779	5189	1322184	2007-09-09	2007-09-09	1	13765
58831	4010	1549786	2000-03-15	2001-03-10	1	11391
52167	3553	1125315	1990-03-05	1990-03-19	1	7382
23075	1567	1192710	1975-10-07	1975-10-07	1	2105
61032	4160	1119510	2004-05-13	2004-05-27	1	12565
64028	4375	1713332	1959-08-03	1959-08-24	1	-3783
41517	2815	1118084	1998-12-24	1998-12-24	1	10584
28725	1945	1112807	1971-05-28	1971-06-11	1	526
6096	418	1125315	1959-08-28	1959-09-25	1	-3751
61874	4223	1125315	1976-11-19	1976-11-26	1	2521
31746	2149	1177480	1990-09-19	1990-10-10	1	7587
42914	2905	1521369	1980-11-24	1981-11-19	1	4340
32050	2168	1759842	1991-08-11	1991-08-18	1	7899
5118	350	1000560	1995-09-11	1995-09-11	2	9384
75780	5189	1713332	1957-01-16	1957-02-06	1	-4712
58832	4010	1589505	1991-05-02	1992-04-26	1	8151
52168	3553	757627	2006-06-24	2006-06-24	1	13323
23076	1567	1551099	2002-09-06	2002-09-06	1	11936
61033	4160	1125315	1964-01-26	1964-02-09	1	-2153
64029	4375	738818	1976-10-27	1976-11-10	1	2505
41518	2815	1177480	2000-02-25	2000-03-31	1	11047
28726	1945	1713332	1995-02-19	1995-03-12	1	9201
6097	418	1717327	1964-01-20	1964-02-03	1	-2159
61875	4223	1125315	1997-05-16	1997-05-30	1	10011
31747	2149	1551099	1959-10-15	1959-10-15	1	-3731
42915	2905	1521369	1982-11-14	1983-11-09	1	5060
32051	2168	1112807	1964-11-10	1964-12-15	1	-1843
5119	350	1125315	2003-01-03	2003-01-24	1	12076
75781	5189	1729720	1966-07-06	1966-07-19	1	-1262
58833	4010	1713332	2009-10-10	2009-10-24	1	14541
52169	3553	1125315	1942-09-08	1942-09-15	1	-9970
23077	1567	1125315	1981-11-21	1981-12-05	1	4356
61034	4160	1125315	2011-11-18	2011-12-02	1	15310
64030	4375	920293	1980-07-21	1980-07-28	1	3861
42182	2860	920293	1996-11-12	1996-11-26	2	9826
28727	1945	1728416	1972-08-02	1972-08-16	1	958
6098	418	1729720	1996-01-06	1996-01-17	1	9512
61876	4223	1112807	1960-07-27	1960-08-10	1	-3431
31748	2149	1759842	1984-10-06	1984-10-20	1	5406
42916	2905	1738521	1971-08-04	1971-08-18	1	594
32052	2168	1125315	1988-10-10	1988-10-31	1	6878
5120	350	1125315	2008-11-01	2008-11-08	1	14191
78231	5343	1119510	1998-01-04	1998-01-11	1	10237
58834	4010	1759842	2009-10-10	2009-10-24	1	14541
52170	3553	1729720	1937-11-21	1937-11-30	1	-11720
23078	1567	1125315	1990-07-05	1990-07-26	1	7511
61035	4160	1713332	1989-02-18	1989-03-18	1	7016
64031	4375	1119510	1966-07-08	1966-07-22	1	-1259
42183	2860	920293	2001-12-24	2001-12-31	1	11687
28728	1945	1759842	1995-02-19	1995-03-12	1	9201
6099	418	1115008	2004-06-26	2004-08-25	1	12655
61877	4223	1125315	1966-07-08	1966-07-15	1	-1266
32269	2185	920293	1990-04-03	1990-04-10	1	7404
42917	2905	1759842	1997-02-13	1997-02-20	1	9912
32053	2168	1713332	1976-03-31	1976-04-21	1	2302
5121	350	1729720	1972-07-07	1972-07-19	1	930
78232	5343	1150770	1984-05-11	1984-05-11	1	5244
58835	4010	19127890	1994-04-16	1995-04-11	1	9231
52171	3553	1112807	1934-07-20	1934-08-24	1	-12914
23079	1567	1125315	2018-05-12	2018-05-26	1	17677
61036	4160	19127890	1983-05-26	1984-05-20	1	5253
64032	4375	1125315	1946-05-27	1946-06-03	1	-8613
42184	2860	1118084	1982-05-25	1982-05-25	1	4527
28729	1945	1125315	1972-08-02	1972-08-16	1	958
6100	418	1119510	2016-04-03	2016-04-17	1	16908
61878	4223	1125315	1971-09-18	1971-10-02	1	639
32270	2185	933724	1990-04-03	1990-04-10	1	7404
42918	2905	933724	2007-01-01	2007-01-08	1	13521
32054	2168	1717327	1962-06-14	1962-06-28	1	-2744
5122	350	1741122	1995-09-11	1995-09-11	1	9384
78233	5343	1500211	1996-12-29	1997-12-24	1	10219
61516	4200	1119510	1974-09-18	1974-10-02	1	1735
52172	3553	1118084	1966-09-20	1966-09-20	1	-1199
23080	1567	1713332	2016-04-10	2016-04-17	1	16908
62489	4268	738818	1968-07-16	1968-07-30	1	-520
64033	4375	1125315	1976-10-27	1976-11-10	1	2505
42185	2860	1125315	2004-09-01	2004-09-08	1	12669
31249	2115	738818	1972-10-20	1972-11-03	1	1037
6101	418	1125315	1981-10-20	1981-11-10	1	4331
61879	4223	1125315	1973-02-27	1973-03-06	1	1160
32271	2185	1102527	1992-09-03	1992-09-03	1	8281
42919	2905	19127890	1985-10-29	1986-10-24	1	6140
32055	2168	1112807	1959-07-30	1959-09-28	1	-3748
5123	350	782043	1995-09-11	1995-09-11	1	9384
78234	5343	1713332	1988-05-28	1988-06-11	1	6736
61517	4200	1119510	1991-05-07	1991-05-14	1	7803
52173	3553	1119510	1942-09-08	1942-09-15	1	-9970
23081	1567	1759842	2016-04-10	2016-04-17	1	16908
62490	4268	1125315	1959-01-24	1959-02-07	1	-3981
64034	4375	1307863	2006-06-25	2006-06-25	1	13324
42186	2860	1305058	2006-10-01	2010-04-13	1	14712
31250	2115	1119510	2016-09-21	2016-10-05	1	17079
6102	418	1125315	1999-04-26	1999-05-10	1	10721
61880	4223	1125315	2019-04-26	2019-05-17	1	18033
32272	2185	1112807	1972-04-19	1972-05-04	1	854
42920	2905	1112807	1972-01-07	1972-01-21	1	750
32056	2168	1118084	1989-10-25	1989-10-25	1	7237
5124	350	920293	1982-10-21	1982-11-04	2	4690
78235	5343	1759842	2001-03-16	2001-03-30	1	11411
61518	4200	1713332	1976-08-03	1976-08-17	1	2420
52174	3553	1125315	1952-11-12	1952-11-26	1	-6245
23082	1567	1118084	2008-05-06	2008-05-06	1	14005
62491	4268	1125315	1963-02-04	1963-02-11	1	-2516
64035	4375	1326303	2006-06-25	2006-06-25	1	13324
42187	2860	1112807	1946-01-24	1946-02-07	1	-8729
31251	2115	1125315	1975-09-12	1975-09-26	1	2094
9713	670	1118084	2017-05-11	2017-05-11	1	17297
61881	4223	1177480	2004-05-23	2004-06-13	1	12582
32273	2185	1115008	2015-06-05	2015-07-05	1	16621
42921	2905	1118084	1999-10-06	1999-10-06	1	10870
32057	2168	1125315	1987-03-19	1987-03-26	1	6293
5125	350	933724	1982-10-21	1982-11-04	1	4690
78236	5343	19127890	1997-12-24	1998-12-19	1	10579
61519	4200	738818	2016-12-24	2016-12-31	1	17166
53349	3633	1713332	2001-01-13	2001-01-20	1	11342
23083	1567	1551099	1991-09-29	1991-09-29	1	7941
62492	4268	1125315	1971-01-30	1971-02-13	1	408
64036	4375	1361711	2015-08-16	2015-08-16	1	16663
42188	2860	1125315	1952-02-24	1952-03-02	1	-6514
31252	2115	1717327	1975-09-12	1975-09-26	1	2094
9714	670	1125315	1978-05-11	1978-08-09	1	3142
61882	4223	1112807	1972-04-06	1972-07-05	1	916
32274	2185	1125315	2018-11-23	2018-11-30	1	17865
42922	2905	1119510	2012-12-03	2012-12-10	1	15684
32058	2168	1125315	2016-07-06	2016-07-27	1	17009
5126	350	967823	1995-09-11	1995-09-12	1	9385
78237	5343	1551099	1984-04-26	1984-04-26	1	5229
61520	4200	1125315	1973-06-14	1973-06-28	1	1274
53350	3633	1759842	2001-01-13	2001-01-20	1	11342
23084	1567	1729720	1980-07-29	1980-08-08	1	3872
62493	4268	1125315	1993-05-26	1993-06-09	1	8560
64037	4375	1729720	1957-12-04	1957-12-12	1	-4403
42189	2860	1125315	2001-11-01	2001-11-01	1	11627
31253	2115	920293	1986-10-22	1986-10-29	1	6145
9715	670	1549786	1989-10-24	1990-10-19	1	7596
61883	4223	1112807	1975-04-21	1975-05-12	1	1957
32275	2185	920293	1987-02-28	1987-03-07	1	6274
42923	2905	1125315	2012-12-03	2012-12-10	1	15684
32059	2168	1154343	1960-09-19	1960-09-19	1	-3391
5127	350	1112807	1970-11-03	1971-02-01	1	396
78238	5343	1713332	1986-02-15	1986-03-01	1	5903
61521	4200	1125315	1991-05-07	1991-05-14	1	7803
53351	3633	1125315	1975-02-12	1975-02-26	1	1882
24321	1641	1112807	1956-09-11	1956-10-16	1	-4825
62494	4268	1125315	1994-12-21	1995-01-18	1	9148
64038	4375	738818	1966-07-08	1966-07-22	1	-1259
42190	2860	1729720	1949-10-21	1949-11-02	1	-7365
31254	2115	933724	1986-10-22	1986-10-29	1	6145
9716	670	738818	1995-12-11	1995-12-25	1	9489
61884	4223	1125315	1979-05-16	1979-05-23	1	3429
32276	2185	933724	1987-02-28	1987-03-07	1	6274
42924	2905	1125315	2015-05-31	2015-06-14	1	16600
32060	2168	1713332	1991-08-11	1991-08-18	1	7899
5128	350	1174888	1995-09-12	1995-09-12	1	9385
78239	5343	1729720	1994-08-30	1994-09-11	1	9019
61522	4200	1125315	2009-04-15	2009-05-13	1	14377
53352	3633	1713332	1984-06-24	1984-07-15	1	5309
24322	1641	1112807	1964-06-13	1964-07-04	1	-2007
62495	4268	1521369	1974-08-13	1976-08-02	2	2405
64039	4375	1112807	1933-03-27	1933-04-10	1	-13415
42191	2860	1112807	1945-05-29	1945-08-27	1	-8893
31255	2115	738818	2016-09-21	2016-10-05	1	17079
9717	670	1729720	1984-08-06	1984-08-18	1	5343
61885	4223	1717327	1961-11-25	1961-12-09	1	-2945
32277	2185	1112807	1942-12-24	1943-02-22	1	-9810
42925	2905	1125315	2019-06-17	2019-07-01	1	18078
32061	2168	1759842	1976-03-31	1976-04-21	1	2302
5129	350	1729720	1994-03-03	1994-03-11	1	8835
78240	5343	1729720	2008-08-11	2008-08-24	1	14115
61523	4200	1125315	2016-12-24	2016-12-31	1	17166
53353	3633	1125315	1973-09-20	1973-10-04	1	1372
24323	1641	1125315	1963-12-05	1963-12-12	1	-2212
62496	4268	1728416	1959-01-24	1959-02-07	1	-3981
64040	4375	1119510	1976-10-27	1976-11-10	1	2505
42192	2860	1115008	2006-10-01	2006-10-01	1	13422
31256	2115	1112807	1968-02-21	1968-03-27	1	-645
9718	670	1738521	1976-04-03	1976-04-17	1	2298
61886	4223	1717327	1962-11-01	1962-11-15	1	-2604
32278	2185	1125315	1959-05-13	1959-06-10	1	-3858
42926	2905	1177480	2014-05-04	2014-05-18	1	16208
33476	2274	1125315	1954-01-26	1954-02-09	1	-5805
5130	350	19003953	1995-09-11	1995-09-11	1	9384
78241	5343	1118084	2019-02-12	2019-02-12	1	17939
61524	4200	1129625	1972-07-09	1972-07-09	1	920
53354	3633	1124300	2017-05-02	2017-05-02	1	17288
24324	1641	1125315	1967-02-07	1967-02-21	1	-1045
62497	4268	738818	2011-12-12	2011-12-19	1	15327
64041	4375	1125315	1966-07-08	1966-07-22	1	-1259
42193	2860	1174888	2001-11-01	2001-11-01	1	11627
31257	2115	1118084	2004-06-01	2004-06-01	1	12570
9719	670	1759842	1994-11-03	1994-11-24	1	9093
61887	4223	1729720	1968-07-14	1968-07-21	1	-529
32279	2185	1713332	1988-08-14	1988-09-04	1	6821
42927	2905	1503184	1980-11-24	1981-11-19	1	4340
33477	2274	1177480	1976-02-02	1976-02-16	1	2237
5131	350	753626	1995-09-11	1995-09-11	1	9384
78242	5343	1125315	1988-05-28	1988-06-11	1	6736
61525	4200	1759842	1976-08-03	1976-08-17	1	2420
53355	3633	1177480	1979-10-03	1980-01-01	1	3652
24325	1641	1728416	1967-02-07	1967-02-21	1	-1045
62498	4268	1125315	1961-06-12	1961-07-12	1	-3095
64042	4375	1539403	2015-08-16	2015-08-16	1	16663
42194	2860	1177480	2001-11-01	2001-12-01	1	11657
31258	2115	1119510	1972-10-20	1972-11-03	1	1037
9720	670	19127890	1989-10-24	1990-10-19	1	7596
61888	4223	1729720	1971-06-22	1971-07-03	1	548
32280	2185	1759842	1986-07-11	1986-07-18	1	6042
42928	2905	1503184	1982-11-14	1983-11-09	1	5060
33478	2274	1118084	1987-06-11	1987-06-11	1	6370
5132	350	1110410	1995-09-11	1995-09-11	1	9384
78243	5343	1125315	1998-01-04	1998-01-11	1	10237
61526	4200	738818	1974-09-18	1974-10-02	1	1735
53356	3633	1729720	1982-06-08	1982-06-15	1	4548
24326	1641	1112807	1957-07-08	1957-07-22	1	-4546
62499	4268	1125315	1970-04-26	1970-07-02	2	182
64043	4375	1557272	2018-03-04	2018-03-04	1	17594
42195	2860	933724	1996-11-12	1996-11-26	1	9826
31259	2115	1125315	2004-08-29	2004-10-05	2	12696
9721	670	1119510	1995-12-11	1995-12-25	1	9489
61889	4223	1112807	1973-05-01	1973-05-31	1	1246
32281	2185	1125315	1962-04-24	1962-05-30	1	-2773
42929	2905	1503184	1985-10-29	1986-10-24	1	6140
33479	2274	1125315	2003-11-05	2003-11-19	1	12375
5133	350	1112807	1965-05-19	1965-06-02	1	-1674
78244	5343	1125315	1998-09-10	1998-11-09	1	10539
61527	4200	738818	1991-05-07	1991-05-14	1	7803
53357	3633	1759842	1984-06-24	1984-07-15	1	5309
24327	1641	1112807	1962-06-17	1962-07-24	1	-2718
62500	4268	1125315	1971-05-28	1971-06-11	1	526
64044	4375	1759842	1959-08-03	1959-08-24	1	-3783
42196	2860	933724	2001-12-24	2001-12-31	1	11687
31260	2115	1125315	2016-09-21	2016-10-05	1	17079
9722	670	1125315	1977-09-15	1977-09-22	1	2821
61890	4223	1125315	1958-08-18	1958-09-01	1	-4140
32282	2185	1125315	1982-10-26	1982-11-08	1	4694
42930	2905	1521369	1985-10-29	1986-10-24	1	6140
33480	2274	1177480	1997-11-22	1997-12-13	1	10208
5134	350	1115008	1999-05-10	1999-05-24	1	10735
78245	5343	1521369	1997-12-24	1998-12-19	1	10579
61528	4200	1112807	1971-01-05	1971-01-19	1	383
53727	3655	1361711	2006-08-31	2010-12-16	1	14959
24328	1641	1125315	1981-05-23	1981-05-30	1	4167
62501	4268	1125315	1996-04-25	1996-05-02	1	9618
64045	4375	738818	1946-05-27	1946-06-03	1	-8613
42197	2860	1125315	1955-09-25	1955-10-09	1	-5198
31261	2115	1112807	1989-12-16	1990-03-16	1	7379
9723	670	1125315	1984-10-02	1984-10-09	1	5395
61891	4223	1125315	1973-05-01	1973-05-01	1	1216
32283	2185	1125315	1983-11-12	1983-11-19	1	5070
42931	2905	1717327	1974-06-06	1974-06-20	1	1631
33481	2274	1729720	1954-10-25	1954-11-06	1	-5535
5135	350	1118084	2004-08-22	2004-08-22	1	12652
78246	5343	1713332	2001-03-16	2001-03-30	1	11411
61529	4200	1118084	2006-09-23	2006-09-23	1	13414
53728	3655	1713332	1951-01-13	1951-01-27	1	-6914
24329	1641	1713332	1958-10-09	1958-10-16	1	-4095
62502	4268	1125315	2011-12-12	2011-12-19	1	15327
64046	4375	933724	1980-07-21	1980-07-28	1	3861
42198	2860	1125315	1976-06-29	1976-07-13	1	2385
31262	2115	1124957	2004-09-05	2004-09-05	1	12666
9724	670	1125315	1998-08-24	1998-09-14	1	10483
61892	4223	1174888	1973-05-01	1973-05-01	1	1216
32284	2185	1557272	2000-09-28	2000-09-28	1	11228
42932	2905	738818	2012-12-03	2012-12-10	1	15684
33482	2274	1729720	1983-12-14	1983-12-26	1	5107
5136	350	1361711	1991-11-08	1991-11-08	1	7981
78247	5343	1729720	1991-03-04	1991-03-16	1	7744
61530	4200	1738521	1973-06-14	1973-06-28	1	1274
53729	3655	1759842	1972-01-20	1972-01-27	1	756
24330	1641	1713332	1995-07-05	1995-07-26	1	9337
62503	4268	1503184	1974-08-13	1976-08-02	2	2405
64047	4375	1112807	1929-01-30	1929-02-13	1	-14932
42199	2860	1713332	2014-01-20	2014-01-27	1	16097
31263	2115	1125315	1970-12-12	1970-12-26	1	359
9725	670	1713332	1994-11-03	1994-11-24	1	9093
61893	4223	1728416	1958-08-18	1958-09-01	1	-4140
32285	2185	1713332	1986-07-11	1986-07-18	1	6042
42933	2905	1119510	1987-10-07	1987-10-14	1	6495
33483	2274	738818	1967-09-19	1967-10-03	1	-821
5137	350	1746114	1995-09-11	1995-09-11	1	9384
78248	5343	738818	1998-01-04	1998-01-11	1	10237
61531	4200	1759842	1970-10-15	1970-10-29	1	301
53730	3655	738818	1940-10-04	1940-10-18	1	-10667
24331	1641	1759842	1988-05-23	1988-06-06	1	6731
62504	4268	1759842	1985-07-10	1985-07-31	1	5690
64048	4375	1124300	1969-07-19	1969-07-19	1	-166
42200	2860	1728416	1946-01-24	1946-02-07	1	-8729
31264	2115	1125315	1971-09-05	1971-09-19	1	626
9726	670	1125315	1974-07-01	1974-07-15	1	1656
61894	4223	1728416	1959-02-01	1959-02-15	1	-3973
32286	2185	1759842	1988-08-14	1988-09-04	1	6821
42934	2905	1125315	1971-08-04	1971-08-18	1	594
33484	2274	1115008	2008-07-18	2008-08-01	1	14092
5138	350	19016749	1995-09-11	1995-09-11	1	9384
78249	5343	1125315	1985-01-23	1985-01-30	1	5508
61532	4200	1119510	2016-12-24	2016-12-31	1	17166
53731	3655	1125315	1940-10-04	1940-10-18	1	-10667
24332	1641	1125315	1967-04-20	1967-05-11	1	-966
62505	4268	19127890	1979-07-18	1980-07-12	1	3845
64049	4375	1125315	1936-03-12	1936-03-19	1	-12341
42201	2860	1728416	1955-09-25	1955-10-09	1	-5198
31265	2115	1125315	1972-10-20	1972-11-03	1	1037
9727	670	1125315	1995-12-11	1995-12-25	1	9489
61895	4223	1729720	1969-11-15	1969-11-26	1	-36
32287	2185	1112807	1954-09-22	1954-10-05	1	-5567
42935	2905	1125315	2007-06-24	2007-07-01	1	13695
33485	2274	1125315	1960-08-21	1960-09-25	1	-3385
5139	350	1125315	1961-12-06	1961-12-20	1	-2934
78250	5343	1125315	2016-11-04	2016-11-18	1	17123
61533	4200	1125315	1974-09-18	1974-10-02	1	1735
53732	3655	1125315	2002-02-02	2002-02-16	1	11734
24333	1641	1713332	1988-05-23	1988-06-06	1	6731
62506	4268	19127890	1982-07-02	1983-06-27	1	4925
64050	4375	1322184	2015-08-16	2015-08-16	1	16663
42202	2860	1729720	1953-11-14	1953-11-21	1	-5885
31266	2115	1125315	2011-04-02	2011-06-01	1	15126
9728	670	1177480	1976-04-03	1976-04-17	1	2298
62201	4243	1759842	1983-10-22	1983-11-12	1	5063
32288	2185	1118084	1981-03-18	1981-03-18	1	4094
42936	2905	1713332	1997-02-13	1997-02-20	1	9912
33486	2274	1125315	1967-09-19	1967-10-03	1	-821
5140	350	1125315	1995-09-12	1995-09-12	1	9385
78251	5343	1177480	1986-02-15	1986-03-01	1	5903
61534	4200	1713332	1970-10-15	1970-10-29	1	301
53733	3655	1174888	2010-12-16	2010-12-16	1	14959
24334	1641	1759842	1995-07-05	1995-07-26	1	9337
62507	4268	1115008	2016-12-07	2016-12-28	1	17163
64051	4375	1332418	2015-08-16	2015-08-16	1	16663
42203	2860	1759842	2014-01-20	2014-01-27	1	16097
33351	2265	1125315	1975-09-26	1975-10-10	1	2108
9729	670	1515774	1989-10-24	1990-10-19	1	7596
62202	4243	1125315	1987-02-08	1987-02-22	1	6261
32289	2185	1125315	1970-02-16	1970-03-02	1	60
42937	2905	1738521	1972-01-07	1972-01-21	1	750
33487	2274	1125315	1975-03-25	1975-04-08	1	1923
5141	350	1177480	1984-02-23	1984-03-29	1	5201
78252	5343	1503184	1997-12-24	1998-12-19	1	10579
61535	4200	1729720	1979-06-26	1979-07-04	1	3471
53734	3655	1118084	1975-12-08	1975-12-08	1	2167
24335	1641	1118084	1997-10-31	1997-10-31	1	10165
62508	4268	1118084	1997-06-23	1997-06-23	1	10035
64052	4375	1501700	1982-06-26	1982-06-26	1	4559
42940	2906	933724	1979-05-14	1979-05-21	1	3427
33352	2265	1125315	1986-05-23	1986-05-30	1	5993
9730	670	1728416	1974-07-01	1974-07-15	1	1656
62203	4243	1728416	1969-12-23	1970-01-06	1	5
32290	2185	1125315	1992-09-03	1992-10-03	1	8311
42938	2905	19127890	1980-11-24	1981-11-19	1	4340
33488	2274	1728416	1949-07-20	1949-08-03	1	-7456
5142	350	1322184	1997-11-14	1997-11-14	1	10179
78253	5343	1551099	1999-05-11	1999-05-11	1	10722
61536	4200	1738521	1971-01-05	1971-01-19	1	383
53735	3655	1347450	2001-12-13	2001-12-13	1	11669
24336	1641	1728416	1957-07-08	1957-07-22	1	-4546
62509	4268	1125315	1968-07-16	1968-07-30	1	-520
65784	4493	1759842	2012-08-01	2012-08-15	1	15567
42941	2906	1112807	1936-08-14	1936-08-28	1	-12179
33353	2265	1125315	1996-06-07	1996-06-14	1	9661
10846	744	1112807	1954-09-01	1954-09-15	1	-5587
62204	4243	1112807	1969-02-12	1969-02-26	1	-309
32291	2185	1729720	1948-06-09	1948-06-22	1	-7863
42939	2905	19127890	1982-11-14	1983-11-09	1	5060
33489	2274	1112807	1949-07-20	1949-08-03	1	-7456
5143	350	1332418	1994-11-11	1994-11-11	1	9080
63487	4338	1124300	1998-01-18	1998-01-18	1	10244
53736	3655	1545958	2010-12-16	2010-12-16	1	14959
24337	1641	1759842	1958-10-09	1958-10-16	1	-4095
62510	4268	1521369	1979-07-18	1980-07-12	1	3845
65785	4493	738818	1995-06-05	1995-06-12	1	9293
42942	2906	1125315	1958-11-13	1958-12-18	1	-4032
33354	2265	1129625	1967-03-09	1967-03-09	1	-1029
10847	744	1125315	1977-12-03	1978-01-07	1	2928
62205	4243	1125315	1989-12-26	1990-01-09	1	7313
32292	2185	1738521	1972-04-19	1972-05-04	1	854
44283	2997	1102527	2004-12-23	2004-12-23	1	12775
33490	2274	1119510	1967-09-19	1967-10-03	1	-821
5144	350	1367571	1995-09-11	1995-09-11	1	9384
63488	4338	1125315	2011-12-06	2011-12-20	1	15328
53737	3655	1729720	1948-11-02	1948-11-11	1	-7721
24731	1669	1112807	1959-12-29	1960-01-19	1	-3635
62511	4268	1521369	1982-07-02	1983-06-27	1	4925
65786	4493	1118084	2017-01-29	2017-01-29	1	17195
42943	2906	1125315	1977-01-15	1977-01-22	1	2578
33355	2265	1713332	1997-03-26	1997-08-13	1	10086
10848	744	1112807	1972-04-12	1972-05-03	1	853
62206	4243	1125315	1993-11-06	1993-11-20	1	8724
35267	2394	1112807	1912-02-25	1912-03-10	1	-21116
44284	2997	1177480	1994-01-29	1994-02-12	1	8808
33491	2274	1125315	1958-06-29	1958-07-06	1	-4197
5145	350	1539403	1991-11-08	1991-11-08	1	7981
63489	4338	1125315	1966-06-05	1966-07-05	1	-1276
53738	3655	1112807	1936-05-26	1936-06-09	1	-12259
24732	1669	1125315	2012-05-15	2012-06-12	1	15503
62512	4268	1713332	1985-07-10	1985-07-31	1	5690
65787	4493	1125315	1988-01-22	1988-02-12	1	6616
42944	2906	1713332	1951-07-27	1951-08-10	1	-6719
33356	2265	1118084	2002-05-28	2002-05-28	1	11835
10849	744	1125315	1983-12-07	1983-12-28	1	5109
62207	4243	1125315	2015-05-11	2015-05-18	1	16573
35268	2394	1125315	1987-05-27	1987-06-10	1	6369
44285	2997	1549786	1995-10-01	1996-09-25	1	9764
33492	2274	1125315	1966-07-26	1966-08-09	1	-1241
5146	350	1713332	2006-06-06	2006-06-27	1	13326
63490	4338	1177480	1993-01-28	1993-02-25	1	8456
53739	3655	1119510	1940-10-04	1940-10-18	1	-10667
24733	1669	1322184	1998-02-09	1998-02-09	1	10266
62513	4268	1729720	1967-08-11	1967-08-22	1	-863
65788	4493	1119510	1995-06-05	1995-06-12	1	9293
42945	2906	1759842	1985-05-31	1985-06-14	1	5643
33357	2265	1125315	1964-06-12	1964-06-26	1	-2015
10850	744	1728416	1954-09-01	1954-09-15	1	-5587
62208	4243	1713332	1999-05-31	1999-06-14	1	10756
35269	2394	1125315	1988-01-06	1988-03-06	2	6639
44286	2997	920293	2001-11-11	2001-11-18	1	11644
37095	2525	1125315	1996-05-09	1996-05-23	1	9639
5147	350	1759842	2006-06-06	2006-06-27	1	13326
63491	4338	1713332	2011-12-06	2011-12-20	1	15328
53740	3655	1125315	1972-01-15	1972-01-22	1	751
24734	1669	1717327	1964-02-06	1964-02-20	1	-2142
62514	4268	1119510	1968-07-16	1968-07-30	1	-520
65789	4493	1125315	1989-11-13	1989-11-27	1	7270
42946	2906	738818	1977-03-24	1977-04-07	1	2653
33358	2265	1125315	1978-10-26	1978-11-09	1	3234
10851	744	1729720	2009-11-03	2009-11-10	1	14558
62209	4243	1738521	1972-06-15	1972-06-29	1	910
35270	2394	1729720	1919-01-23	1919-02-02	1	-18596
44287	2997	1118084	2016-11-09	2016-11-09	1	17114
37096	2525	1125315	2009-12-26	2010-01-09	1	14618
6527	452	1112807	1973-09-14	1973-10-05	1	1373
63492	4338	1125315	1973-02-28	1973-03-14	1	1168
53741	3655	1125315	1997-08-04	1997-08-25	1	10098
24735	1669	1759842	1960-02-05	1960-02-19	1	-3604
62515	4268	1119510	2011-12-12	2011-12-19	1	15327
65790	4493	1125315	1995-06-05	1995-06-12	1	9293
42947	2906	920293	1979-05-14	1979-05-21	1	3427
33359	2265	1759842	1997-03-26	1997-08-13	1	10086
10852	744	1759842	2015-04-08	2015-04-15	1	16540
62210	4243	1759842	1999-05-31	1999-06-14	1	10756
35271	2394	1112807	1916-11-14	1916-11-28	1	-19392
44288	2997	1125315	1993-12-01	1993-12-15	1	8749
37097	2525	1177480	1976-01-24	1976-02-14	1	2235
6528	452	1118084	2002-04-15	2002-04-15	1	11792
63493	4338	1125315	2014-04-26	2014-05-10	1	16200
53742	3655	1125315	2010-12-16	2010-12-16	1	14959
24736	1669	1118084	1998-10-15	1998-10-15	1	10514
62516	4268	1124957	1970-05-03	1970-05-03	1	122
65791	4493	1713332	2012-08-01	2012-08-15	1	15567
42948	2906	1112807	1924-11-08	1924-11-22	1	-16476
34077	2314	1125315	1956-06-25	1956-07-09	1	-4924
10853	744	1118084	1994-07-01	1994-07-01	1	8947
62211	4243	1112807	1969-12-23	1970-01-06	1	5
35272	2394	1112807	1955-06-23	1955-07-28	1	-5271
44289	2997	1177480	2004-12-16	2005-01-22	1	12805
37098	2525	1503184	1988-01-01	1988-12-26	1	6934
6529	452	1125315	1976-03-28	1976-04-04	1	2285
63494	4338	1729720	1967-12-01	1967-12-14	1	-749
53743	3655	1322184	2001-12-13	2001-12-13	1	11669
24737	1669	1539403	1996-11-18	1996-11-18	1	9818
62517	4268	1125315	1969-09-28	1969-10-05	1	-88
67412	4603	738818	1962-05-10	1962-05-24	1	-2779
42949	2906	1112807	1929-12-26	1930-01-09	1	-14602
34078	2314	1125315	1962-12-13	1962-12-27	1	-2562
10854	744	1125315	1953-10-19	1953-11-02	1	-5904
62212	4243	1118084	2007-09-26	2007-09-26	1	13782
35273	2394	1124300	1953-02-04	1953-02-04	1	-6175
44290	2997	1500211	1996-09-25	1997-09-20	1	10124
37099	2525	1549786	1989-12-21	1990-12-16	1	7654
6530	452	1177480	2009-08-18	2009-09-01	1	14488
64992	4439	738818	1989-07-08	1989-07-22	1	7142
53744	3655	1322184	2006-08-31	2010-12-16	1	14959
24738	1669	1115008	1998-03-30	1998-05-29	1	10375
62518	4268	1125315	1980-01-25	1980-02-08	1	3690
67413	4603	1112807	1959-12-13	1959-12-27	1	-3658
42950	2906	1115008	2014-02-25	2014-03-18	1	16147
34079	2314	1125315	1986-05-21	1986-06-04	1	5998
10855	744	1125315	2017-08-29	2017-09-19	1	17428
62213	4243	1125315	1972-06-15	1972-06-29	1	910
35274	2394	1174888	1988-01-06	1988-01-06	1	6579
44291	2997	19127890	1995-10-01	1996-09-25	1	9764
37100	2525	1124300	2017-12-09	2017-12-09	1	17509
6531	452	1713332	2009-08-18	2009-09-01	1	14488
64993	4439	1118084	1995-04-12	1995-04-12	1	9232
53745	3655	1332418	2006-08-31	2006-08-31	1	13391
24739	1669	1125315	1998-03-30	1998-03-30	1	10315
62519	4268	1177480	2012-05-18	2012-06-01	1	15492
67414	4603	1125315	1962-05-10	1962-05-24	1	-2779
42951	2906	1125315	1970-03-14	1970-03-21	1	79
34080	2314	1125315	1989-12-01	1989-12-15	1	7288
10856	744	1177480	2012-01-14	2012-01-28	1	15367
62214	4243	1713332	1983-10-22	1983-11-12	1	5063
35275	2394	1112807	1912-09-22	1912-10-06	1	-20906
44292	2997	933724	2001-11-11	2001-11-18	1	11644
37101	2525	1125315	1982-04-22	1982-05-06	1	4508
6532	452	738818	2017-10-27	2017-11-10	1	17480
64994	4439	1125315	1989-07-08	1989-07-22	1	7142
53746	3655	1539403	2006-08-31	2006-08-31	1	13391
24740	1669	1137529	2000-02-21	2000-02-21	1	11008
62520	4268	1503184	1979-07-18	1980-07-12	1	3845
67415	4603	1125315	2000-11-22	2000-12-27	1	11318
42952	2906	1125315	1982-04-30	1982-05-14	1	4516
34081	2314	1729720	2016-03-25	2016-04-02	1	16893
10857	744	1713332	2015-04-08	2015-04-15	1	16540
62215	4243	1738521	1969-02-12	1969-02-26	1	-309
35276	2394	1125315	1914-08-14	1914-08-28	1	-20215
44293	2997	1515774	1995-10-01	1996-09-25	1	9764
37102	2525	1515774	1989-12-21	1990-12-16	1	7654
6533	452	1125315	1965-12-31	1966-01-14	1	-1448
64995	4439	1125315	2002-03-01	2002-03-22	1	11768
53747	3655	1713332	1972-01-20	1972-01-27	1	756
24741	1669	1149380	2000-02-21	2000-02-21	1	11008
62521	4268	1503184	1982-07-02	1983-06-27	1	4925
67416	4603	1177480	1982-04-17	1982-05-01	1	4503
42953	2906	1125315	2009-09-30	2009-10-14	1	14531
34082	2314	1112807	1958-03-02	1958-05-31	1	-4233
10858	744	1728416	1953-10-19	1953-11-02	1	-5904
63280	4325	1118084	2002-05-03	2002-05-03	1	11810
35277	2394	1125315	1956-04-19	1956-04-26	1	-4998
44472	3011	1115008	2003-03-14	2003-04-04	1	12146
37103	2525	1713332	1986-08-09	1986-08-23	1	6078
6534	452	1125315	2017-10-27	2017-11-10	1	17480
64996	4439	1713332	2005-08-17	2005-09-07	1	13033
53748	3655	1729720	1949-05-12	1949-05-19	1	-7532
24742	1669	1174888	1998-03-30	1998-03-30	1	10315
62522	4268	1557272	2016-01-11	2016-01-11	1	16811
67417	4603	1729720	1970-05-17	1970-05-30	1	149
42954	2906	1713332	1925-12-08	1925-12-22	1	-16081
34083	2314	1118084	1987-08-17	1987-08-17	1	6437
10859	744	1728416	1957-11-18	1957-12-02	1	-4413
63281	4325	1119510	1986-05-21	1986-06-04	1	5998
35278	2394	1125315	1979-10-20	1979-12-19	1	3639
44473	3011	1125315	1983-04-07	1983-04-28	1	4865
37104	2525	1759842	1996-08-06	1996-08-13	1	9721
6535	452	1717327	1963-01-05	1963-01-19	1	-2539
64997	4439	1728416	1955-03-08	1955-03-22	1	-5399
53749	3655	1759842	1951-01-13	1951-01-27	1	-6914
24743	1669	1713332	1960-02-05	1960-02-19	1	-3604
62523	4268	1713332	1993-12-17	1993-12-31	1	8765
67418	4603	1125315	1972-04-14	1972-04-28	1	848
42955	2906	1759842	1925-12-08	1925-12-22	1	-16081
34084	2314	1119510	1964-01-02	1964-01-16	1	-2177
10860	744	1112807	1957-11-18	1957-12-02	1	-4413
63282	4325	1713332	1980-12-18	1981-01-08	1	4025
35279	2394	1729720	1978-11-29	1978-12-09	1	3264
44474	3011	1177480	1978-01-19	1978-02-02	1	2954
37105	2525	1759842	2006-05-29	2006-06-05	1	13304
6536	452	1729720	1973-03-17	1973-03-24	1	1178
64998	4439	1759842	2005-08-17	2005-09-07	1	13033
58052	3960	1713332	1970-09-07	1970-09-21	1	263
24744	1669	1112807	1964-02-06	1964-02-20	1	-2142
62524	4268	1759842	1993-12-17	1993-12-31	1	8765
67419	4603	1102527	2004-09-07	2004-09-07	1	12668
34085	2314	1125315	1961-01-15	1961-02-21	1	-3236
10861	744	1125315	1996-07-22	1996-08-05	1	9713
63283	4325	1729720	1969-12-10	1969-12-17	1	-15
36541	2486	1115008	1996-12-21	1997-02-19	1	9911
44475	3011	1729720	2003-04-02	2003-04-09	1	12151
37106	2525	19127890	1988-01-01	1988-12-26	1	6934
6537	452	1738521	1967-08-05	1967-08-19	1	-866
64999	4439	1119510	1989-07-08	1989-07-22	1	7142
58053	3960	738818	1970-11-28	1970-12-12	1	345
24745	1669	1112807	1965-01-22	1965-04-22	1	-1715
62525	4268	19127890	1974-08-13	1976-08-02	2	2405
67420	4603	1112807	1940-09-23	1940-10-28	1	-10657
34086	2314	1728416	1952-10-29	1952-11-12	1	-6259
13577	929	738818	1942-06-13	1942-06-20	1	-10057
63284	4325	1759842	1970-11-18	1970-12-09	1	342
36542	2486	1119510	1978-09-29	1978-10-06	1	3200
44476	3011	1125315	2014-05-12	2014-05-19	1	16209
37107	2525	1521369	1988-01-01	1988-12-26	1	6934
6538	452	1115008	2013-06-07	2013-08-06	1	15923
65000	4439	1759842	2012-06-07	2012-06-14	1	15505
58054	3960	1118084	1997-05-21	1997-05-21	1	10002
24746	1669	1332418	1996-11-18	1996-11-18	1	9818
68278	4661	1125315	2016-08-29	2016-09-12	1	17056
67421	4603	1112807	1969-10-24	1969-11-21	1	-41
34087	2314	738818	1964-01-02	1964-01-16	1	-2177
13578	929	1119510	1934-08-16	1934-08-23	1	-12915
63285	4325	1759842	1974-03-05	1974-03-12	1	1531
36543	2486	1125315	1974-07-20	1974-08-03	1	1675
44477	3011	1549786	1989-06-30	1990-06-25	1	7480
37108	2525	1713332	1982-04-22	1982-05-06	1	4508
6539	452	1119510	2017-10-27	2017-11-10	1	17480
65001	4439	1112807	1955-03-08	1955-03-22	1	-5399
58055	3960	1125315	1966-09-30	1966-10-14	1	-1175
24747	1669	1361711	1996-11-18	1996-11-18	1	9818
68279	4661	1713332	2012-12-02	2012-12-09	1	15683
67422	4603	1115008	2014-03-19	2014-04-09	1	16169
34088	2314	1112807	1952-10-29	1952-11-12	1	-6259
13579	929	1125315	1942-06-13	1942-06-20	1	-10057
63286	4325	1759842	1980-12-18	1981-01-08	1	4025
36544	2486	1125315	1996-12-21	1996-12-21	1	9851
44478	3011	1515774	1989-06-30	1990-06-25	1	7480
37109	2525	1713332	1996-08-06	1996-08-13	1	9721
6540	452	1125315	1963-01-05	1963-01-19	1	-2539
65002	4439	1125315	1955-07-17	1955-07-31	1	-5268
58056	3960	1125315	1970-11-28	1970-12-12	1	345
26297	1779	1125315	1953-02-01	1953-05-02	1	-6088
68280	4661	1759842	2012-12-02	2012-12-09	1	15683
67423	4603	1119510	1962-05-10	1962-05-24	1	-2779
34089	2314	1125315	1964-01-02	1964-01-16	1	-2177
13580	929	1125315	1997-07-09	1997-07-23	1	10065
63287	4325	738818	1972-09-14	1972-09-21	1	994
36545	2486	1125315	2007-02-07	2007-02-21	1	13565
44479	3011	1729720	1980-01-10	1980-01-20	1	3671
37110	2525	1713332	2006-05-29	2006-06-05	1	13304
6541	452	1112807	1964-10-26	1964-11-30	1	-1858
65003	4439	1125315	1999-02-18	1999-03-04	1	10654
58057	3960	1713332	2018-11-26	2018-12-03	1	17868
26298	1779	1125315	1988-02-12	1988-03-04	1	6637
68281	4661	1713332	1979-03-09	1979-03-23	1	3368
67424	4603	1125315	2018-01-18	2018-03-19	1	17609
34090	2314	1125315	1979-08-14	1979-09-04	1	3533
13581	929	1154343	1922-08-10	1939-07-10	1	-11133
63288	4325	1125315	1972-09-14	1972-09-21	1	994
36546	2486	1174888	1996-12-21	1996-12-21	1	9851
44480	3011	1118084	2009-02-15	2009-02-15	1	14290
37111	2525	1759842	1986-08-09	1986-08-23	1	6078
6542	452	1125315	1967-08-05	1967-08-19	1	-866
65004	4439	1713332	2012-06-07	2012-06-14	1	15505
58058	3960	1729720	1980-04-23	1980-05-06	1	3778
26299	1779	1343916	1949-09-15	1949-09-15	1	-7413
68282	4661	1118084	2018-02-21	2018-02-21	1	17583
67425	4603	1713332	1990-08-18	1990-08-25	1	7541
34091	2314	1125315	1991-12-04	1991-12-18	1	8021
13582	929	1174888	2005-10-10	2005-10-10	1	13066
63289	4325	1125315	1996-08-30	1996-09-06	1	9745
36547	2486	1521369	1994-02-15	1995-02-10	1	9171
44481	3011	1125315	1980-01-09	1980-01-23	1	3674
37112	2525	1713332	2011-12-11	2011-12-18	1	15326
6543	452	1125315	2008-12-14	2008-12-21	1	14234
65005	4439	1728416	1955-07-17	1955-07-31	1	-5268
58059	3960	1759842	1970-09-07	1970-09-21	1	263
26300	1779	1501700	2009-11-09	2009-11-09	1	14557
68283	4661	1125315	1979-11-28	1979-12-12	1	3632
67426	4603	1728416	1959-12-13	1959-12-27	1	-3658
34092	2314	1125315	1972-04-08	1972-04-22	1	842
13583	929	1177480	1977-05-20	1977-06-03	1	2710
63290	4325	1125315	2014-08-19	2014-09-02	1	16315
36548	2486	1503184	1988-03-18	1989-03-13	1	7011
44482	3011	1768849	1980-01-09	1980-01-23	1	3674
37113	2525	1759842	2011-12-11	2011-12-18	1	15326
6544	452	1125315	2017-02-21	2017-02-28	1	17225
65006	4439	1729720	1961-12-19	1961-12-26	1	-2928
58060	3960	1759842	2018-11-26	2018-12-03	1	17868
26301	1779	738818	1950-01-13	1950-01-27	1	-7279
68284	4661	1759842	1979-03-09	1979-03-23	1	3368
67427	4603	1729720	1931-05-18	1931-05-26	1	-14100
34093	2314	1125315	1984-04-10	1984-05-08	1	5241
13584	929	1322184	1998-01-12	2005-10-10	1	13066
63291	4325	1177480	1982-11-03	1982-11-17	1	4703
36549	2486	1521369	1988-03-18	1989-03-13	1	7011
44483	3011	19127890	1989-06-30	1990-06-25	1	7480
37114	2525	19127890	1989-12-21	1990-12-16	1	7654
6545	452	1729720	2003-08-28	2003-09-06	1	12301
66724	4557	738818	1988-12-26	1989-01-02	1	6941
58061	3960	1125315	1961-07-31	1961-08-14	1	-3062
26302	1779	914335	1949-09-15	1949-09-15	1	-7413
68285	4661	1177480	1983-06-10	1983-06-24	1	4922
67428	4603	1759842	1990-08-18	1990-08-25	1	7541
35728	2428	1713332	1987-06-06	1987-06-13	1	6372
13585	929	1539403	1991-12-09	1991-12-09	1	8012
63292	4325	1729720	1969-01-03	1969-01-11	1	-355
36550	2486	1118084	2011-03-03	2011-03-03	1	15036
45570	3093	920293	1998-07-29	1998-08-05	1	10443
39899	2711	701322	2016-03-18	2016-03-18	1	16878
8838	610	920293	2013-09-15	2013-09-22	1	15970
66725	4557	914335	1978-12-31	1978-12-31	1	3286
58062	3960	1125315	1983-04-08	1983-04-15	1	4852
26303	1779	1125315	1945-12-11	1945-12-25	1	-8773
68286	4661	1768849	1979-11-28	1979-12-12	1	3632
67429	4603	1118084	1970-01-24	1970-01-24	1	23
35729	2428	1713332	2007-08-29	2007-09-19	1	13775
13586	929	1729720	1925-02-07	1925-02-20	1	-16386
63293	4325	1759842	1972-08-09	1972-08-23	1	965
36551	2486	1503184	1994-02-15	1995-02-10	1	9171
45571	3093	933724	1998-07-29	1998-08-05	1	10443
39900	2711	715997	2016-03-18	2016-03-18	1	16878
8839	610	1102527	2008-12-04	2008-12-04	1	14217
66726	4557	933724	1952-05-20	1952-05-27	1	-6428
58063	3960	1728416	1958-04-16	1958-04-30	1	-4264
26304	1779	1125315	1950-01-13	1950-01-27	1	-7279
68494	4675	738818	1930-05-20	1930-06-03	1	-14457
67430	4603	1125315	1931-02-14	1931-02-21	1	-14194
35730	2428	1759842	1987-06-06	1987-06-13	1	6372
13587	929	1759842	1930-12-27	1931-01-03	1	-14243
63294	4325	1759842	1989-07-01	1989-07-08	1	7128
36552	2486	1728416	1974-07-20	1974-08-03	1	1675
45572	3093	1118084	2009-11-03	2009-11-03	1	14551
39901	2711	738818	1966-11-08	1966-11-22	1	-1136
8840	610	1112807	1976-10-11	1976-12-10	1	2535
66727	4557	1102527	1969-11-12	1969-11-12	1	-50
58064	3960	920293	1981-03-10	1981-03-17	1	4093
26305	1779	1125315	1956-03-31	1956-04-07	1	-5017
68495	4675	1112807	1916-05-01	1916-05-15	1	-19589
67431	4603	1125315	1959-07-21	1959-08-18	1	-3789
35731	2428	1759842	2007-08-29	2007-09-19	1	13775
13588	929	1759842	2003-08-04	2003-08-18	1	12282
63295	4325	1112807	1971-10-18	1971-11-01	1	669
36553	2486	19127890	1988-03-18	1991-03-03	3	7731
45573	3093	1125315	1981-02-24	1981-03-10	1	4086
39902	2711	975125	2019-06-11	2019-06-25	1	18072
8841	610	1119510	1998-01-28	1998-02-11	1	10268
66728	4557	1112807	1924-05-27	1924-06-17	1	-16634
58065	3960	933724	1981-03-10	1981-03-17	1	4093
26306	1779	1125315	1976-07-14	1976-10-12	2	2476
68496	4675	1119510	1959-07-08	1959-07-15	1	-3823
67432	4603	1125315	2004-09-07	2004-10-07	1	12698
35732	2428	19127890	1988-06-21	1990-06-11	2	7466
13589	929	1112807	1947-05-23	1947-06-27	1	-8224
63296	4325	1119510	1972-09-14	1972-09-21	1	994
36554	2486	738818	1978-09-29	1978-10-06	1	3200
45574	3093	1119510	2016-07-30	2016-08-06	1	17019
39903	2711	1119510	1996-04-09	1996-04-23	1	9609
8842	610	1125315	2010-08-22	2010-09-05	1	14857
66729	4557	1115008	2017-06-24	2017-09-22	1	17431
58066	3960	1112807	1958-04-16	1958-04-30	1	-4264
26307	1779	1125315	1978-07-13	1978-07-27	1	3129
68497	4675	1124300	1948-01-09	1948-01-09	1	-8028
67433	4603	1557272	2010-10-28	2010-10-28	1	14910
35733	2428	1124300	2015-10-08	2015-10-08	1	16716
13590	929	1125315	1963-08-24	1963-09-07	1	-2308
63297	4325	1125315	2012-02-04	2012-02-18	1	15388
36555	2486	1125315	1978-09-29	1978-10-06	1	3200
45575	3093	1125315	1984-11-19	1984-12-10	1	5457
39904	2711	1125315	1952-12-14	1952-12-28	1	-6213
8843	610	1503184	1982-07-26	1983-07-21	1	4949
66730	4557	1125315	1969-11-12	1970-01-11	1	10
58067	3960	1112807	1966-10-01	1966-10-29	1	-1160
26308	1779	1125315	2009-10-25	2009-11-01	1	14549
68498	4675	1125315	1923-01-01	1923-01-15	1	-17153
68884	4701	1125315	1990-07-04	1990-07-25	1	7510
35734	2428	1125315	2008-02-28	2008-03-06	1	13944
13591	929	1125315	2005-10-10	2005-10-10	1	13066
63298	4325	1713332	1970-11-18	1970-12-09	1	342
36556	2486	1515774	1989-03-13	1991-03-03	2	7731
45576	3093	1125315	2011-02-28	2011-03-14	1	15047
39905	2711	1125315	1966-11-08	1966-11-22	1	-1136
8844	610	738818	1998-01-28	1998-02-11	1	10268
66731	4557	1125315	1988-12-26	1989-01-02	1	6941
58068	3960	1112807	1972-12-26	1973-01-23	1	1118
26309	1779	1177480	2003-12-16	2004-01-13	1	12430
68499	4675	1125315	1930-05-20	1930-06-03	1	-14457
68885	4701	1125315	2008-11-02	2008-11-16	1	14199
35735	2428	1503184	1988-06-21	1990-06-11	2	7466
13592	929	1545958	2005-10-10	2005-10-10	1	13066
63299	4325	1713332	1974-03-05	1974-03-12	1	1531
36557	2486	1549786	1989-03-13	1991-03-03	2	7731
45577	3093	1521369	1988-06-06	1989-06-01	1	7091
39906	2711	1125315	1968-05-27	1968-06-03	1	-577
8845	610	933724	2015-10-25	2015-11-01	1	16740
66732	4557	1125315	2001-11-15	2002-02-13	1	11731
58069	3960	1119510	1970-11-28	1970-12-12	1	345
26310	1779	1115008	2002-12-07	2002-12-21	1	12042
68500	4675	1125315	1946-09-08	1946-09-08	1	-8516
68886	4701	1717327	1971-02-25	1971-03-11	1	434
35736	2428	1759842	1987-03-08	1987-03-29	1	6296
13593	929	1112807	1919-09-03	1919-09-17	1	-18369
63300	4325	1713332	1989-07-01	1989-07-08	1	7128
36558	2486	19127890	1994-02-15	1995-02-10	1	9171
45578	3093	1729720	1983-01-27	1983-02-05	1	4783
39907	2711	1125315	1972-05-18	1972-05-25	1	875
8846	610	1125315	1965-06-29	1965-07-13	1	-1633
66733	4557	1309944	1978-12-31	1978-12-31	1	3286
58070	3960	1125315	1963-01-08	1963-01-15	1	-2543
26311	1779	1119510	1950-01-13	1950-01-27	1	-7279
68501	4675	1125315	1953-09-11	1953-09-25	1	-5942
68887	4701	1717327	1973-12-22	1974-01-05	1	1465
35737	2428	1759842	2010-09-11	2010-09-18	1	14870
13594	929	1118084	1961-08-13	1961-08-13	1	-3063
63301	4325	738818	1986-05-21	1986-06-04	1	5998
37869	2576	1115008	2015-04-24	2015-05-15	1	16570
45579	3093	738818	2016-07-30	2016-08-06	1	17019
39908	2711	1149380	1953-07-02	1953-07-02	1	-6027
8847	610	1125315	1973-11-28	1973-12-26	1	1455
66734	4557	1343916	1978-12-31	1978-12-31	1	3286
62704	4282	1112807	1966-10-03	1966-10-17	1	-1172
26312	1779	1125315	2011-01-30	2011-02-06	1	15011
68502	4675	1125315	1988-09-22	1988-10-06	1	6853
68888	4701	1119510	1975-06-06	1975-06-20	1	1996
35738	2428	920293	2002-08-03	2002-08-10	1	11909
13595	929	1361711	1990-12-03	2005-10-10	1	13066
63302	4325	1125315	1986-05-21	1986-06-04	1	5998
37870	2576	1118084	2019-04-12	2019-04-12	1	17998
45580	3093	1112807	1973-05-16	1973-06-06	1	1252
39909	2711	1713332	1999-10-09	1999-10-30	1	10894
8848	610	1125315	1977-10-10	1977-10-24	1	2853
66735	4557	1729720	1934-10-05	1934-10-16	1	-12861
62705	4282	1118084	2004-10-13	2004-10-13	1	12704
26313	1779	1551099	1946-12-07	1946-12-07	1	-8426
68503	4675	1125315	2006-11-11	2006-12-11	1	13493
68889	4701	1125315	1978-08-17	1978-08-31	1	3164
35739	2428	1112807	1977-04-10	1977-04-24	1	2670
13596	929	1713332	1993-02-12	1993-02-19	1	8450
63303	4325	1713332	1972-08-09	1972-08-23	1	965
37871	2576	1125315	2017-04-04	2017-04-18	1	17274
45581	3093	1125315	2016-07-30	2016-08-06	1	17019
39910	2711	1729720	1957-05-10	1957-05-23	1	-4606
8849	610	1521369	1982-07-26	1983-07-21	1	4949
66736	4557	738818	1942-12-20	1943-01-03	1	-9860
62706	4282	1347450	2007-10-10	2007-10-10	1	13796
26314	1779	1551099	1969-04-15	1969-04-15	1	-261
68504	4675	1713332	1926-11-10	1926-12-01	1	-15737
68890	4701	1713332	1974-07-14	1974-07-28	1	1669
35740	2428	1521369	1988-06-21	1990-06-11	2	7466
13597	929	1759842	1993-02-12	1993-02-19	1	8450
64518	4406	920293	1976-12-25	1977-01-08	2	2564
37872	2576	1503184	1998-10-09	1999-10-04	1	10868
45582	3093	19127890	1988-06-06	1989-06-01	1	7091
39911	2711	738818	1972-05-18	1972-05-25	1	875
8850	610	1729720	1966-09-09	1966-09-18	1	-1201
66737	4557	920293	1952-05-20	1952-05-27	1	-6428
62707	4282	1717327	1966-10-03	1966-10-17	1	-1172
26315	1779	1112807	1944-10-16	1944-10-30	1	-9194
68505	4675	1713332	1964-03-03	1964-03-10	1	-2123
68891	4701	1713332	1989-06-15	1989-12-21	1	7294
35741	2428	1728416	1975-02-20	1975-03-06	1	1890
13598	929	738818	1934-08-16	1934-08-23	1	-12915
64519	4406	933724	1976-12-25	1977-01-08	1	2564
37873	2576	1549786	2000-09-28	2002-09-18	2	11948
45583	3093	1125315	2019-03-26	2019-04-02	1	17988
39912	2711	975125	1964-09-24	1964-10-08	1	-1911
8851	610	933724	2013-09-15	2013-09-22	1	15970
66738	4557	1112807	1925-08-20	1925-09-03	1	-16191
62708	4282	1759842	1989-11-22	1989-12-06	1	7279
26316	1779	1112807	1955-03-23	1955-04-06	1	-5384
68506	4675	1713332	1980-06-19	1980-07-10	1	3843
68892	4701	1759842	1989-06-15	1989-12-21	1	7294
35742	2428	933724	2002-08-03	2002-08-10	1	11909
13599	929	1112807	1924-08-15	1924-08-29	1	-16561
64520	4406	1112807	1942-04-21	1942-05-05	1	-10103
37874	2576	1713332	1980-10-03	1980-10-17	1	3942
45584	3093	1503184	1988-06-06	1989-06-01	1	7091
39913	2711	975125	1974-02-24	1974-03-17	1	1536
8852	610	1118084	2004-12-07	2004-12-07	1	12759
66739	4557	1112807	1932-10-03	1932-10-31	1	-13576
62709	4282	1112807	1970-02-14	1970-03-16	1	74
26317	1779	1115008	1994-02-01	1994-02-22	1	8818
68507	4675	1759842	1926-11-10	1926-12-01	1	-15737
68893	4701	19127890	1988-11-06	1989-11-01	1	7244
35743	2428	1125315	1984-01-18	1984-02-17	1	5160
13600	929	1112807	1932-07-26	1932-08-09	1	-13659
64521	4406	1778162	2004-07-06	2004-07-20	1	12619
37875	2576	19127890	1993-11-04	1995-10-25	2	9428
45585	3093	1729720	1979-02-01	1979-02-13	1	3330
39914	2711	1125315	1979-05-25	1979-06-24	1	3461
8853	610	19127890	1982-07-26	1983-07-21	1	4949
66740	4557	1112807	1971-03-09	1971-03-23	1	446
62710	4282	1119510	2014-10-30	2014-11-06	1	16380
26318	1779	1118084	1976-11-07	1976-11-07	1	2502
68508	4675	1759842	1947-09-25	1947-10-16	1	-8113
68894	4701	738818	1975-06-06	1975-06-20	1	1996
35744	2428	1177480	1975-02-20	1975-03-06	1	1890
13601	929	1119510	1942-06-13	1942-06-20	1	-10057
64522	4406	1125315	2004-07-06	2004-07-20	1	12619
37876	2576	1125315	1981-12-11	1981-12-25	1	4376
47340	3215	738818	1982-01-31	1982-02-07	1	4420
39915	2711	1713332	1982-02-26	1982-03-05	1	4446
8854	610	920293	2015-10-25	2015-11-01	1	16740
66741	4557	1118084	1966-04-22	1966-04-22	1	-1350
62711	4282	1125315	1977-09-06	1977-09-13	1	2812
26319	1779	1124957	1976-07-14	1976-07-14	1	2386
68509	4675	1759842	1980-06-19	1980-07-10	1	3843
68895	4701	933724	2001-12-20	2001-12-27	1	11683
35745	2428	1177480	1996-04-14	1996-05-19	1	9635
13602	929	1125315	1934-08-16	1934-08-23	1	-12915
64523	4406	920293	1978-02-08	1978-02-15	1	2967
37877	2576	1125315	1993-10-25	1993-11-15	1	8719
47341	3215	1119510	2000-03-21	2000-03-28	1	11044
39916	2711	1728416	1955-09-28	1955-10-12	1	-5195
8855	610	1115008	1995-08-24	1995-09-14	1	9387
66742	4557	1119510	1988-12-26	1989-01-02	1	6941
62712	4282	1125315	1983-12-24	1984-01-07	1	5119
26320	1779	1551099	1945-02-13	1945-02-13	1	-9088
68510	4675	1112807	1946-09-08	1946-09-29	1	-8495
68896	4701	1112807	1973-12-22	1974-01-05	1	1465
35746	2428	1713332	1987-03-08	1987-03-29	1	6296
13603	929	1125315	1947-05-23	1947-05-23	1	-8259
64524	4406	933724	1978-02-08	1978-02-15	1	2967
37878	2576	1125315	2002-12-09	2002-12-16	1	12037
47342	3215	1125315	1980-06-02	1980-06-16	1	3819
39917	2711	1759842	1975-06-21	1975-06-28	1	2004
8856	610	1125315	1963-08-25	1963-09-08	1	-2307
66743	4557	1125315	1942-12-20	1943-01-03	1	-9860
62713	4282	1125315	2014-10-30	2014-11-06	1	16380
27764	1878	1177480	1975-06-14	1975-06-28	1	2004
68511	4675	1125315	1969-03-23	1969-04-06	1	-270
68897	4701	1124300	2011-07-10	2011-07-10	1	15165
35747	2428	1713332	2010-09-11	2010-09-18	1	14870
13604	929	1125315	1967-11-16	1967-11-30	1	-763
64525	4406	1124300	1981-08-29	1981-08-29	1	4258
37879	2576	1125315	2018-09-05	2018-09-12	1	17786
47343	3215	1125315	1981-09-24	1981-10-01	1	4291
39918	2711	1759842	1982-02-26	1982-03-05	1	4446
8857	610	1125315	1989-12-02	1989-12-23	1	7296
66744	4557	1125315	1973-08-23	1973-09-13	1	1351
62714	4282	1713332	2013-10-31	2013-11-14	1	16023
27765	1878	1759842	2007-02-04	2007-02-18	1	13562
68512	4675	1125315	1971-11-28	1971-12-05	1	703
68898	4701	1125315	1971-02-25	1971-03-11	1	434
36020	2448	738818	1981-08-24	1981-08-31	1	4260
13605	929	1149380	1922-08-10	1939-07-10	1	-11133
64526	4406	1125315	1969-11-27	1969-12-04	1	-28
37880	2576	1503184	1993-11-04	1995-10-25	2	9428
47344	3215	1125315	1982-01-31	1982-02-07	1	4420
39919	2711	19010482	2019-06-11	2019-06-25	1	18072
8858	610	1125315	1993-05-21	1993-06-04	1	8555
66745	4557	1713332	1996-06-25	1996-07-09	1	9686
62715	4282	1738521	1969-02-01	1969-02-15	1	-320
27766	1878	1125315	1980-05-01	1980-05-15	1	3787
68513	4675	1307863	1998-11-29	1998-11-29	1	10559
68899	4701	1125315	1975-06-06	1975-06-20	1	1996
36021	2448	933724	1998-08-14	1998-08-21	1	10459
13606	929	1174888	1947-05-23	1947-05-23	1	-8259
64527	4406	1125315	1975-04-28	1975-05-19	1	1964
37881	2576	1595799	2000-09-28	2001-09-23	1	11588
47345	3215	1125315	1995-01-02	1995-02-01	2	9162
39920	2711	738818	1996-04-09	1996-04-23	1	9609
8859	610	1125315	1998-01-28	1998-02-11	1	10268
66746	4557	1759842	2010-01-16	2010-01-30	1	14639
62716	4282	1759842	2013-10-31	2013-11-14	1	16023
27767	1878	1125315	1990-03-27	1990-04-04	1	7398
68514	4675	1713332	2007-08-29	2007-09-12	1	13768
68900	4701	1125315	1977-12-27	1978-01-10	1	2931
36022	2448	1503184	1983-06-16	1984-06-10	1	5274
13607	929	1177480	1992-09-12	1992-09-26	1	8304
66942	4570	1112807	1942-10-24	1942-12-23	1	-9871
37882	2576	19127890	1998-10-09	1999-10-04	1	10868
47346	3215	1125315	1997-10-24	1997-10-31	1	10165
39921	2711	757627	2010-11-15	2010-11-15	1	14928
8860	610	1125315	2008-12-04	2009-02-02	1	14277
66747	4557	1112807	1968-01-31	1968-02-21	1	-680
62717	4282	920293	2008-04-26	2008-05-03	1	14002
27768	1878	1177480	1976-02-08	1976-02-29	1	2250
68515	4675	1759842	1930-03-22	1930-03-29	1	-14523
68901	4701	1125315	1991-02-01	1991-02-15	1	7715
36023	2448	1713332	1988-04-02	1988-04-23	1	6687
13608	929	1332418	1994-12-26	1994-12-26	1	9125
66943	4570	1119510	1991-12-21	1991-12-28	1	8031
37883	2576	1515774	2001-09-23	2002-09-18	1	11948
47347	3215	1125315	2000-03-21	2000-03-28	1	11044
39922	2711	1112807	1955-09-28	1955-10-12	1	-5195
8861	610	1192710	1967-09-19	1967-09-19	1	-835
66748	4557	1119510	1942-12-20	1943-01-03	1	-9860
62718	4282	933724	2008-04-26	2008-05-03	1	14002
27769	1878	1177480	1980-12-04	1980-12-25	1	4011
68516	4675	1759842	2000-06-16	2000-06-30	1	11138
68902	4701	1521369	1988-11-06	1989-11-01	1	7244
36024	2448	1713332	2011-10-04	2011-10-11	1	15258
13609	929	1713332	1930-12-27	1931-01-03	1	-14243
66944	4570	1124300	1972-08-02	1972-08-02	1	944
37884	2576	1521369	1993-11-04	1995-10-25	2	9428
47348	3215	1174888	1995-01-02	1995-01-02	1	9132
39923	2711	1118084	1989-09-04	1989-09-04	1	7186
8862	610	1729720	1973-08-27	1973-09-03	1	1341
66749	4557	1738521	1971-03-09	1971-03-23	1	446
62719	4282	1112807	1969-02-01	1969-02-15	1	-320
27770	1878	1738521	1975-06-14	1975-06-28	1	2004
68517	4675	738818	1959-07-08	1959-07-15	1	-3823
68903	4701	920293	2001-12-20	2001-12-27	1	11683
36025	2448	1759842	1970-11-16	1970-11-30	1	333
13610	929	1713332	1997-07-09	1997-07-23	1	10065
66945	4570	1125315	1957-12-05	1957-12-19	1	-4396
37885	2576	1729720	1982-01-28	1982-02-08	1	4421
47349	3215	1738521	1978-06-30	1978-07-14	1	3116
39924	2711	1119510	1966-11-08	1966-11-22	1	-1136
8863	610	1738521	1977-10-10	1977-10-24	1	2853
66750	4557	1112807	1951-12-21	1952-01-25	1	-6551
62720	4282	1322184	2007-10-10	2007-10-10	1	13796
27771	1878	1124300	2010-07-25	2010-07-25	1	14815
68518	4675	738818	1960-06-02	1960-06-16	1	-3486
68904	4701	1115008	2015-11-11	2015-12-02	1	16771
36026	2448	920293	1998-08-14	1998-08-21	1	10459
13611	929	1713332	2003-08-04	2003-08-18	1	12282
66946	4570	1728416	1957-12-05	1957-12-19	1	-4396
37886	2576	19127890	2001-09-23	2002-09-18	1	11948
47350	3215	738818	2000-03-21	2000-03-28	1	11044
39925	2711	1125315	1988-05-07	1988-05-28	1	6722
9476	654	1119510	2010-03-03	2010-03-10	1	14678
66751	4557	1125315	1988-07-21	1988-07-28	1	6783
62721	4282	1713332	1983-12-24	1984-01-07	1	5119
27772	1878	1177480	1975-12-21	1976-01-04	1	2194
68519	4675	1112807	1915-05-12	1915-05-26	1	-19944
68905	4701	1125315	1978-12-26	1979-01-09	1	3295
36027	2448	1118084	2000-05-22	2000-05-22	1	11099
13612	929	1728416	1947-05-23	1947-06-27	1	-8224
66947	4570	1729720	1944-05-03	1944-05-14	1	-9363
37887	2576	1177480	1980-10-03	1980-10-17	1	3942
47351	3215	975125	2002-10-08	2002-10-08	1	11968
39926	2711	1125315	2015-11-03	2016-01-02	1	16802
9477	654	1125315	2018-08-26	2018-09-02	1	17776
66752	4557	1125315	1998-06-22	1998-06-29	1	10406
62722	4282	1713332	1998-07-26	1998-08-02	1	10440
27773	1878	1729720	1987-09-13	1987-09-24	1	6475
68520	4675	1112807	1949-04-16	1949-05-16	1	-7535
68906	4701	1125315	1989-05-05	1989-06-09	1	7099
36028	2448	1125315	1979-12-26	1980-01-02	1	3653
13613	929	1729720	1965-10-04	1965-10-17	1	-1537
66948	4570	1729720	1976-12-16	1976-12-27	1	2552
37888	2576	1521369	1998-10-09	1999-10-04	1	10868
47352	3215	1125315	2016-07-21	2016-08-04	1	17017
39927	2711	1129625	1953-07-16	1953-07-16	1	-6013
9478	654	738818	2010-03-03	2010-03-10	1	14678
66753	4557	1713332	2010-01-16	2010-01-30	1	14639
62723	4282	1759842	1998-07-26	1998-08-02	1	10440
27774	1878	1729720	2013-07-12	2013-07-20	1	15906
68521	4675	1119510	1930-05-20	1930-06-03	1	-14457
68907	4701	1322184	2015-04-03	2015-04-03	1	16528
36029	2448	1125315	1981-08-24	1981-08-31	1	4260
14831	1025	1112807	1968-03-30	1968-04-27	1	-614
66949	4570	1125315	1997-05-31	1997-06-07	1	10019
37889	2576	1521369	2000-09-28	2001-09-23	1	11588
47353	3215	1153428	2002-10-26	2002-10-26	1	11986
39928	2711	1713332	1975-06-21	1975-06-28	1	2004
9479	654	1125315	2007-05-22	2007-06-05	1	13669
66754	4557	1759842	1996-06-25	1996-07-09	1	9686
62724	4282	738818	2014-10-30	2014-11-06	1	16380
27775	1878	1713332	2007-02-04	2007-02-18	1	13562
68522	4675	1124957	1946-09-08	1946-09-08	1	-8516
68908	4701	1347450	2015-04-03	2015-04-03	1	16528
36030	2448	1308738	1991-07-09	1991-07-09	1	7859
14832	1025	1119510	1987-10-21	1987-10-28	1	6509
66950	4570	1112807	1937-09-20	1937-10-04	1	-11777
37890	2576	1713332	1981-12-11	1981-12-25	1	4376
47354	3215	1177480	2003-10-17	2003-10-31	1	12356
39929	2711	1759842	1999-10-09	1999-10-30	1	10894
9480	654	1125315	2010-03-03	2010-03-10	1	14678
67947	4637	1115008	2003-05-13	2003-05-27	1	12199
62725	4282	1713332	1989-11-22	1989-12-06	1	7279
27776	1878	1728416	1975-12-21	1976-01-04	1	2194
68523	4675	1125315	1959-07-08	1959-07-15	1	-3823
68909	4701	1503184	1988-11-06	1989-11-01	1	7244
36031	2448	1521369	1983-06-16	1984-06-10	1	5274
14833	1025	1125315	1956-09-28	1956-10-05	1	-4836
66951	4570	1112807	1939-11-22	1939-12-06	1	-10984
37891	2576	1729720	1993-09-27	1993-10-06	1	8679
47355	3215	1343916	2002-10-26	2002-10-26	1	11986
39930	2711	975125	1981-09-08	1981-09-22	1	4282
9481	654	1713332	1981-03-16	1981-03-23	1	4099
67948	4637	1125315	1989-08-10	1989-08-24	1	7175
64169	4383	1124957	2008-01-22	2008-01-22	1	13900
27777	1878	1768849	1980-05-01	1980-05-15	1	3787
68524	4675	1125315	1960-06-02	1960-06-16	1	-3486
68910	4701	1759842	1974-07-14	1974-07-28	1	1669
36032	2448	1713332	1970-11-16	1970-11-30	1	333
14834	1025	1125315	1958-03-10	1958-03-17	1	-4308
66952	4570	1125315	1954-11-20	1954-12-04	1	-5507
39159	2662	1125315	1979-04-22	1979-05-07	1	3413
47356	3215	1361711	2009-04-06	2009-04-06	1	14340
39931	2711	1119510	1972-05-18	1972-05-25	1	875
9482	654	1728416	1964-02-06	1964-02-20	1	-2142
67949	4637	1115008	2011-12-25	2012-01-15	1	15354
64170	4383	1713332	1970-10-13	1970-10-27	1	299
30577	2070	738818	2001-05-10	2001-05-24	1	11466
68525	4675	1125315	2014-07-02	2014-07-23	1	16274
70358	4807	738818	1981-01-03	1981-01-17	1	4034
36033	2448	1729720	1978-05-31	1978-06-07	1	3079
14835	1025	1759842	2004-03-07	2004-03-28	1	12505
66953	4570	1125315	1985-05-15	1985-05-29	1	5627
39160	2662	1125315	1995-10-28	1995-11-10	1	9444
47357	3215	1768849	1980-06-02	1980-06-16	1	3819
39932	2711	1125315	1980-02-05	1980-02-12	1	3694
9483	654	1729720	1971-07-31	1971-08-07	1	583
67950	4637	1118084	2013-04-01	2013-04-01	1	15796
64171	4383	1713332	2002-09-23	2002-10-07	1	11967
30578	2070	1119510	2001-05-10	2001-05-24	1	11466
68526	4675	1177480	2012-07-12	2012-09-10	1	15593
70359	4807	933724	2002-04-21	2002-04-28	1	11805
36034	2448	19127890	1983-06-16	1984-06-10	1	5274
14836	1025	1112807	1945-02-24	1945-03-31	1	-9042
66954	4570	1347450	1991-09-21	1991-09-21	1	7933
39161	2662	1118084	2016-07-02	2016-07-02	1	16984
47358	3215	1112807	1978-06-30	1978-07-14	1	3116
39933	2711	1125315	1996-04-09	1996-04-23	1	9609
9484	654	1759842	1981-03-16	1981-03-23	1	4099
67951	4637	1125315	1988-05-09	1988-05-16	1	6710
64172	4383	1119510	1976-03-30	1976-04-06	1	2287
30579	2070	1125315	2001-05-10	2001-05-24	1	11466
68527	4675	1326303	1998-11-29	1998-11-29	1	10559
70360	4807	1112807	1971-05-17	1971-06-14	1	529
36035	2448	1119510	1981-08-24	1981-08-31	1	4260
14837	1025	1125315	1987-10-21	1987-10-28	1	6509
66955	4570	1557272	1997-01-25	1997-01-25	1	9886
39162	2662	1125315	1980-05-31	1980-06-14	1	3817
47359	3215	1118084	2018-01-11	2018-01-11	1	17542
39934	2711	1154343	1953-07-02	1953-07-02	1	-6027
9485	654	1125315	1964-02-06	1964-02-20	1	-2142
67952	4637	1174888	2008-04-30	2008-04-30	1	13999
64173	4383	1125315	1975-06-04	1975-09-02	1	2070
30580	2070	1717327	1968-02-08	1968-02-22	1	-679
68528	4675	1728416	1946-09-08	1946-09-29	1	-8495
70361	4807	1125315	1954-03-03	1954-03-17	1	-5769
36036	2448	1759842	1988-04-02	1988-04-23	1	6687
14838	1025	1125315	2018-03-20	2018-04-03	1	17624
66956	4570	1759842	1958-10-04	1958-10-18	1	-4093
39163	2662	1125315	2000-09-29	2000-10-13	1	11243
47360	3215	1119510	1982-01-31	1982-02-07	1	4420
39935	2711	1729720	2018-06-09	2018-06-19	1	17701
9486	654	1118084	2001-07-26	2001-07-26	1	11529
67953	4637	1177480	1975-12-12	1976-01-16	1	2206
64174	4383	1125315	2008-01-22	2008-01-22	1	13900
30581	2070	19127890	1978-10-23	1979-10-18	1	3577
68529	4675	1112807	1917-01-01	1917-01-15	1	-19344
70362	4807	1125315	1974-03-15	1974-03-22	1	1541
36037	2448	1759842	2011-10-04	2011-10-11	1	15258
14839	1025	1713332	2004-03-07	2004-03-28	1	12505
66957	4570	1759842	1973-03-24	1973-04-14	1	1199
39164	2662	1177480	2002-07-05	2002-08-11	1	11910
47361	3215	1125315	1979-02-27	1979-03-06	1	3351
42292	2866	1521369	1984-07-13	1985-07-08	1	5667
11108	760	1125315	1977-06-20	1977-07-20	1	2757
67954	4637	1713332	2008-04-30	2008-05-14	1	14013
64175	4383	1177480	2008-01-22	2008-02-26	1	13935
30582	2070	1112807	1993-10-08	1993-10-29	1	8702
68530	4675	1112807	1941-01-09	1941-02-06	1	-10556
70363	4807	1125315	1981-01-03	1981-01-17	1	4034
37231	2534	1118084	2011-04-02	2011-04-02	1	15066
14840	1025	1728416	1945-02-24	1945-03-31	1	-9042
66958	4570	738818	1991-12-21	1991-12-28	1	8031
39165	2662	1177480	2018-02-17	2018-03-20	1	17610
47362	3215	1322184	2009-04-06	2009-04-06	1	14340
42293	2866	1713332	2010-04-27	2010-05-04	1	14733
11109	760	1125315	1992-09-13	1992-10-04	1	8312
67955	4637	1125315	2008-04-30	2008-05-14	2	14013
64176	4383	1729720	1975-05-18	1975-05-26	1	1971
30583	2070	1177480	2001-07-19	2001-08-02	1	11536
68531	4675	1119510	1960-06-02	1960-06-16	1	-3486
70364	4807	1557272	2006-03-09	2006-03-09	1	13216
37232	2534	1125315	2001-05-24	2001-06-21	1	11494
14841	1025	738818	1987-10-21	1987-10-28	1	6509
66959	4570	1112807	1941-03-21	1941-04-04	1	-10499
39166	2662	1759842	1993-07-05	1993-07-12	1	8593
47363	3215	1332418	2009-04-06	2009-04-06	1	14340
42294	2866	1759842	1984-08-25	1984-09-01	1	5357
11110	760	1177480	1979-05-11	1979-05-25	1	3431
67956	4637	1125315	2009-05-28	2009-06-04	1	14399
64177	4383	738818	1976-03-30	1976-04-06	1	2287
30584	2070	1177480	2017-07-09	2017-08-13	1	17391
68532	4675	1125315	1945-10-14	1945-10-21	1	-8838
70365	4807	1729720	1961-04-05	1961-04-13	1	-3185
37233	2534	1125315	2017-07-30	2017-08-06	1	17384
14842	1025	1112807	1941-04-18	1941-05-16	1	-10457
66960	4570	1112807	1961-11-27	1961-12-18	1	-2936
39167	2662	1102527	2002-07-12	2002-07-12	1	11880
47364	3215	1539403	2009-04-06	2009-04-06	1	14340
42295	2866	1118084	2005-10-21	2005-10-21	1	13077
11111	760	1125315	1966-11-16	1966-11-23	1	-1135
67957	4637	1125315	1980-12-20	1981-01-24	1	4041
64178	4383	1125315	1990-10-13	1990-10-27	1	7604
30585	2070	1102527	1988-02-07	1988-02-07	1	6611
68533	4675	1125315	1961-04-13	1961-05-11	1	-3157
70366	4807	1729720	1967-07-12	1967-07-25	1	-891
37234	2534	1503184	1986-07-22	1988-07-11	2	6766
14843	1025	1118084	1974-04-05	1974-04-05	1	1555
66961	4570	1125315	1964-08-30	1964-09-13	1	-1936
39168	2662	1713332	1980-05-31	1980-06-14	1	3817
47365	3215	1713332	1988-12-10	1988-12-31	1	6939
42296	2866	1149380	2001-04-29	2001-04-29	1	11441
11112	760	1759842	1990-08-02	1990-08-16	1	7532
67958	4637	1729720	1980-04-20	1980-04-30	1	3772
64179	4383	1125315	1990-12-20	1991-01-03	1	7672
30586	2070	1125315	1978-05-16	1978-05-30	1	3071
68534	4675	1125315	1972-06-16	1972-06-30	1	911
70367	4807	738818	2012-04-08	2012-04-22	1	15452
37235	2534	1738521	1974-10-13	1974-10-27	1	1760
16551	1143	1119510	1983-06-12	1983-06-19	1	4917
66962	4570	1125315	1991-12-21	1991-12-28	1	8031
39169	2662	1713332	1993-07-05	1993-07-12	1	8593
47366	3215	1759842	1988-12-10	1988-12-31	1	6939
42297	2866	1503184	1984-07-13	1985-07-08	1	5667
11113	760	1119510	2007-06-21	2007-06-28	1	13692
69066	4715	1115008	2008-09-03	2008-09-17	1	14139
64180	4383	1125315	1992-07-18	1992-08-22	1	8269
30587	2070	1125315	1980-09-04	1980-09-18	1	3913
68535	4675	1125315	1984-08-28	1984-09-11	1	5367
70368	4807	1112807	1946-03-24	1946-04-14	1	-8663
37236	2534	1125315	1984-10-09	1984-10-23	1	5409
16552	1143	1124957	1983-11-26	1983-11-26	1	5077
66963	4570	1125315	2003-08-10	2003-09-09	1	12304
48819	3321	738818	2013-02-16	2013-02-23	1	15759
42298	2866	1717327	1967-09-01	1967-09-15	1	-839
11114	760	1713332	1990-08-02	1990-08-16	1	7532
69067	4715	1729720	2017-09-05	2017-09-13	1	17422
64181	4383	1125315	2000-03-12	2000-03-19	1	11035
30588	2070	1129625	1969-11-15	1969-11-15	1	-47
68536	4675	1125315	1994-07-17	1994-08-16	1	8993
70369	4807	1118084	1981-03-10	1981-03-10	1	4086
37237	2534	1515774	1989-07-06	1990-07-01	1	7486
16553	1143	1125315	1976-01-02	1976-03-02	1	2252
66964	4570	1713332	1958-10-04	1958-10-18	1	-4093
48820	3321	1125315	1980-01-09	1980-01-30	1	3681
42299	2866	1112807	1967-09-01	1967-09-15	1	-839
11115	760	738818	2007-06-21	2007-06-28	1	13692
69068	4715	1118084	1995-01-14	1995-01-14	1	9144
64182	4383	1738521	1969-09-12	1969-09-26	1	-97
30589	2070	1521369	1978-10-23	1979-10-18	1	3577
68537	4675	1125315	2007-12-06	2008-01-05	1	13883
70370	4807	1119510	2012-04-08	2012-04-22	1	15452
37238	2534	1521369	1986-07-22	1988-07-11	2	6766
16554	1143	1125315	2012-12-02	2012-12-16	1	15690
66965	4570	1713332	1973-03-24	1973-04-14	1	1199
48821	3321	1125315	2013-02-16	2013-02-23	1	15759
42300	2866	1137529	2001-04-29	2001-04-29	1	11441
11116	760	1118084	1998-01-01	1998-01-01	1	10227
69069	4715	1125315	1970-01-26	1970-02-02	1	32
64183	4383	1759842	1970-10-13	1970-10-27	1	299
30590	2070	1112807	1968-02-08	1968-02-22	1	-679
68538	4675	1310149	1998-11-29	1998-11-29	1	10559
70371	4807	1125315	1972-05-09	1972-06-13	1	894
37239	2534	1729720	2008-08-16	2008-08-23	1	14114
16555	1143	1713332	2007-05-31	2007-06-07	1	13671
66966	4570	1729720	1947-07-29	1947-08-11	1	-8179
48822	3321	1177480	1982-11-15	1982-11-29	1	4715
42301	2866	1713332	1984-08-25	1984-09-01	1	5357
11117	760	1125315	1992-12-08	1992-12-22	1	8391
69070	4715	1125315	1996-07-14	1996-07-28	1	9705
64184	4383	1112807	1970-09-07	1970-09-28	1	270
30591	2070	1118084	2008-07-02	2008-07-02	1	14062
68539	4675	1713332	1930-03-22	1930-03-29	1	-14523
70372	4807	1125315	2012-04-08	2012-04-22	1	15452
37240	2534	1177480	1974-10-13	1974-10-27	1	1760
16556	1143	1112807	1973-09-14	1973-09-28	1	1366
66967	4570	1729720	2002-11-09	2002-11-22	1	12013
48823	3321	1713332	2014-01-31	2014-02-07	1	16108
42302	2866	1759842	2010-04-27	2010-05-04	1	14733
11118	760	1125315	2007-06-21	2007-06-28	1	13692
69071	4715	1125315	1985-01-07	1985-01-14	1	5492
64185	4383	1118084	2008-06-24	2008-06-24	1	14054
30592	2070	1125315	1988-02-07	1988-04-07	1	6671
68540	4675	1713332	1947-09-25	1947-10-16	1	-8113
70373	4807	1729720	1987-03-29	1987-04-11	1	6309
37241	2534	1549786	1989-07-06	1990-07-01	1	7486
16557	1143	1125315	1983-11-26	1983-12-26	2	5107
69352	4732	1115008	1997-11-24	1997-12-08	1	10203
48824	3321	1759842	2014-01-31	2014-02-07	1	16108
42303	2866	19127890	1984-07-13	1985-07-08	1	5667
14112	967	1125315	1956-10-26	1956-11-09	1	-4801
69072	4715	1125315	2004-09-27	2004-10-04	1	12695
64186	4383	1125315	1969-09-12	1969-09-26	1	-97
30593	2070	1125315	2005-09-02	2005-09-09	1	13035
68541	4675	1713332	2000-06-16	2000-06-30	1	11138
70374	4807	1759842	1976-03-26	1976-04-09	1	2290
37242	2534	1768849	1984-10-09	1984-10-23	1	5409
16558	1143	1125315	1979-08-16	1979-08-30	1	3528
69353	4732	1124300	1992-09-27	1992-09-27	1	8305
48825	3321	1125315	2013-05-11	2013-07-10	2	15896
42304	2866	1125315	1969-08-05	1969-08-19	1	-135
14113	967	1125315	1984-08-01	1984-08-08	1	5333
69073	4715	1713332	2016-03-30	2016-04-06	1	16897
64187	4383	1125315	1971-02-06	1971-02-13	1	408
30594	2070	1503184	1978-10-23	1979-10-18	1	3577
68542	4675	1759842	1964-03-03	1964-03-10	1	-2123
70375	4807	920293	2002-07-06	2002-07-13	1	11881
37243	2534	19127890	1989-07-06	1990-07-01	1	7486
16559	1143	1125315	1980-11-20	1980-12-11	1	3997
69354	4732	738818	1995-02-28	1995-03-07	1	9196
48826	3321	1174888	2013-05-11	2013-05-11	1	15836
42305	2866	1125315	2018-10-03	2018-10-31	1	17835
14114	967	1125315	2003-03-12	2003-06-10	2	12213
69074	4715	1729720	1983-12-26	1984-01-08	1	5120
64188	4383	1125315	1976-03-30	1976-04-06	1	2287
33844	2298	738818	1982-03-11	1982-03-18	1	4459
68543	4675	1759842	2007-08-29	2007-09-12	1	13768
70376	4807	1125315	1988-07-27	1988-08-10	1	6796
37244	2534	1125315	1974-06-15	1974-08-14	1	1686
16560	1143	1125315	1990-04-24	1990-05-08	1	7432
69355	4732	1125315	1964-07-06	1964-07-20	1	-1991
48827	3321	1713332	2014-04-10	2014-04-24	1	16184
42306	2866	1729720	1970-01-29	1970-02-09	1	39
14115	967	1125315	2014-06-01	2014-06-15	1	16236
69075	4715	1759842	2016-03-30	2016-04-06	1	16897
64189	4383	1125315	2004-05-21	2004-06-11	1	12580
33845	2298	1125315	1978-02-21	1978-03-07	1	2987
71403	4874	1118084	2004-02-11	2004-02-11	1	12459
70377	4807	1125315	2005-02-22	2005-03-08	1	12850
37245	2534	19127890	1986-07-22	1988-07-11	2	6766
16561	1143	1717327	1973-09-14	1973-09-28	1	1366
69356	4732	1125315	1995-02-28	1995-03-07	1	9196
48828	3321	1119510	2013-02-16	2013-02-23	1	15759
14116	967	1125315	2019-02-07	2019-02-28	1	17955
69076	4715	1125315	1955-11-10	1955-11-24	1	-5152
64190	4383	1713332	2008-01-22	2008-02-26	1	13935
33846	2298	1125315	1982-03-11	1982-03-18	1	4459
71404	4874	1124957	2006-11-28	2006-11-28	1	13480
70378	4807	1713332	1976-03-26	1976-04-09	1	2290
38581	2624	920293	1991-02-05	1991-02-12	1	7712
16562	1143	1729720	1975-06-21	1975-07-03	1	2009
69357	4732	1729720	1957-04-16	1957-04-25	1	-4634
48829	3321	1125315	1991-03-17	1991-03-31	1	7759
14117	967	1713332	1947-05-29	1947-07-03	1	-8218
69077	4715	1728416	1955-11-10	1955-11-24	1	-5152
64191	4383	1729720	1981-07-27	1981-08-03	1	4232
33847	2298	1717327	1973-10-28	1973-11-11	1	1410
71405	4874	1125315	1972-09-20	1972-10-04	1	1007
70379	4807	920293	2002-04-21	2002-04-28	1	11805
38582	2624	1112807	1973-08-05	1973-08-26	1	1333
16563	1143	738818	1983-06-12	1983-06-19	1	4917
69358	4732	1112807	1976-06-03	1976-06-17	1	2359
48830	3321	1729720	1977-06-26	1977-07-03	1	2740
14118	967	738818	2018-03-08	2018-03-22	1	17612
71708	4898	1125315	1954-03-14	1954-03-28	1	-5758
64192	4383	1759842	2002-09-23	2002-10-07	1	11967
33848	2298	1729720	1972-02-23	1972-03-01	1	790
71406	4874	1521369	1983-07-26	1984-07-20	1	5314
70380	4807	933724	2002-07-06	2002-07-13	1	11881
38583	2624	1118084	2006-06-18	2006-06-18	1	13317
16564	1143	738818	1999-07-18	1999-08-01	1	10804
69359	4732	1119510	1995-02-28	1995-03-07	1	9196
48831	3321	1115008	2014-04-10	2014-04-24	1	16184
14119	967	1125315	1939-01-14	1939-01-28	1	-11296
71709	4898	1125315	1962-10-27	1962-11-26	1	-2593
65247	4457	1174888	1999-09-27	1999-09-27	1	10861
33849	2298	1125315	1973-10-28	1973-11-11	1	1410
71407	4874	1521369	1995-05-24	1996-05-18	1	9634
70381	4807	1119510	1981-01-03	1981-01-17	1	4034
38584	2624	1125315	2015-09-15	2015-10-13	1	16721
16565	1143	1118084	2015-04-07	2015-04-07	1	16532
69360	4732	1125315	1982-08-03	1982-08-17	1	4611
48832	3321	1118084	2011-06-30	2011-06-30	1	15155
14120	967	1125315	1994-02-18	1994-03-04	1	8828
71710	4898	1125315	1971-04-13	1971-05-11	1	495
65248	4457	1177480	2006-07-22	2006-08-21	1	13381
33850	2298	1112807	1973-04-16	1973-04-30	1	1215
71408	4874	1713332	2016-07-19	2016-08-02	1	17015
70382	4807	1125315	1957-10-24	1957-11-07	1	-4438
38585	2624	1521369	1984-12-15	1985-12-10	1	5822
16566	1143	1119510	1999-07-18	1999-08-01	1	10804
69361	4732	1717327	1964-07-06	1964-07-20	1	-1991
48833	3321	1713332	2018-04-26	2018-05-17	1	17668
14121	967	1125315	2018-03-08	2018-03-22	1	17612
71711	4898	1125315	1983-03-29	1983-04-12	1	4849
65249	4457	1713332	1985-01-06	1985-01-27	1	5505
33851	2298	1118084	2006-01-03	2006-01-03	1	13151
71409	4874	1759842	1975-03-09	1975-03-23	1	1907
71516	4884	1717327	1973-03-20	1973-04-03	1	1188
38586	2624	1713332	1993-01-28	1993-02-18	1	8449
16567	1143	1125315	1979-11-12	1979-11-26	1	3616
69362	4732	1112807	1961-11-19	1962-01-18	1	-2905
48834	3321	1759842	2018-04-26	2018-05-17	1	17668
14122	967	1174888	2003-03-12	2003-03-12	1	12123
71712	4898	1125315	1991-08-24	1991-09-07	2	7919
65250	4457	1759842	1985-01-06	1985-01-27	1	5505
33852	2298	1177480	2008-06-30	2008-07-14	1	14074
71410	4874	738818	1972-06-14	1972-06-21	1	902
71517	4884	1738521	1977-05-15	1977-05-29	1	2705
38587	2624	705944	1975-01-02	1977-06-09	1	2716
16568	1143	1125315	1983-06-12	1983-06-19	1	4917
71957	4917	1115008	1994-12-16	1994-12-30	1	9129
49442	3370	738818	2019-04-20	2019-05-04	1	18020
14123	967	1177480	2002-02-15	2002-04-16	1	11793
71713	4898	1759842	2005-12-09	2005-12-23	1	13140
65251	4457	1125315	1999-09-27	1999-09-27	1	10861
33853	2298	1738521	1972-02-21	1972-03-06	1	795
71411	4874	1125315	1972-06-14	1972-06-21	1	902
71518	4884	1112807	1973-03-20	1973-04-03	1	1188
38588	2624	933724	1991-02-05	1991-02-12	1	7712
16569	1143	1125315	1992-02-05	1992-02-12	1	8077
71958	4917	1125315	1993-08-23	1993-11-21	1	8725
49443	3370	1125315	2005-05-04	2005-05-18	1	12921
14124	967	1322184	2011-07-16	2011-07-16	1	15171
71714	4898	1119510	1991-08-26	1991-09-02	1	7914
65252	4457	1177480	1999-09-27	1999-11-26	1	10921
33854	2298	1112807	1972-02-21	1972-03-06	1	795
71412	4874	1125315	1992-12-25	1993-01-08	1	8408
71519	4884	1154343	1975-10-28	1975-10-28	1	2126
38589	2624	1112807	1972-08-10	1972-08-24	1	966
16570	1143	1125315	1999-07-18	1999-08-01	1	10804
71959	4917	1713332	1985-01-07	1985-01-14	1	5492
49444	3370	1125315	2019-04-20	2019-05-04	1	18020
14125	967	1332418	2011-07-16	2011-07-16	1	15171
71715	4898	1125315	1966-09-20	1966-10-04	1	-1185
65253	4457	1713332	1987-07-18	1987-08-01	1	6421
33855	2298	1119510	1982-03-11	1982-03-18	1	4459
71413	4874	1521369	1988-06-29	1990-06-19	2	7474
71520	4884	1174888	1989-07-08	1989-07-08	1	7128
38590	2624	1119510	2007-03-11	2007-03-18	1	13590
16571	1143	1177480	2008-04-18	2008-05-23	1	14022
71960	4917	1729720	1989-02-16	1989-02-28	1	6998
49445	3370	1503184	1986-09-21	1987-09-16	1	6467
14126	967	1539403	2011-07-16	2011-07-16	1	15171
71716	4898	1125315	1990-07-30	1990-08-29	1	7545
65254	4457	1759842	2009-07-09	2009-07-23	1	14448
33856	2298	1125315	1982-11-09	1982-12-14	1	4730
71414	4874	1713332	1975-03-09	1975-03-23	1	1907
71521	4884	1177480	1980-12-22	1981-01-21	1	4038
38591	2624	19127890	1984-12-15	1985-12-10	1	5822
16572	1143	1759842	2007-05-31	2007-06-07	1	13671
71961	4917	1759842	1985-01-07	1985-01-14	1	5492
49446	3370	1759842	1998-08-08	1998-08-22	1	10460
14127	967	1713332	1955-10-17	1955-11-07	1	-5169
71717	4898	1125315	2008-01-05	2008-01-19	1	13897
65255	4457	1125315	1987-07-18	1987-08-01	1	6421
33857	2298	1125315	2018-02-08	2018-02-22	1	17584
71415	4874	1503184	1995-05-24	1996-05-18	1	9634
71522	4884	1177480	2006-12-06	2006-12-27	1	13509
38592	2624	738818	2007-03-11	2007-03-18	1	13590
18341	1261	738818	1989-03-29	1989-04-12	1	7041
71962	4917	1118084	2016-06-28	2016-06-28	1	16980
49447	3370	1125315	1984-06-21	1984-07-12	1	5306
14128	967	1713332	2016-04-13	2016-04-20	1	16911
71718	4898	738818	1991-08-26	1991-09-02	1	7914
65256	4457	1713332	2009-07-09	2009-07-23	1	14448
36498	2483	1112807	1945-03-29	1945-04-12	1	-9030
71416	4874	19127890	1988-06-29	1990-06-19	2	7474
71523	4884	1729720	1975-11-09	1975-11-16	1	2145
38593	2624	1115008	2018-12-26	2019-01-09	1	17905
18342	1261	1125315	1989-03-29	1989-04-12	1	7041
71963	4917	1729720	1996-04-04	1996-04-16	1	9602
49448	3370	1177480	1977-06-14	1977-06-28	1	2735
14129	967	1759842	2016-04-13	2016-04-20	1	16911
71719	4898	1118084	1997-11-22	1997-11-22	1	10187
65257	4457	1729720	1994-06-10	1994-06-20	1	8936
36499	2483	1112807	1945-12-24	1946-01-07	1	-8760
71417	4874	19127890	1992-06-08	1993-06-03	1	8554
71524	4884	1738521	1974-05-26	1974-06-09	1	1620
38594	2624	1125315	1993-08-26	1993-09-09	1	8652
18343	1261	1149380	2005-07-09	2005-07-09	1	12973
71964	4917	1177480	1997-12-14	1998-01-18	1	10244
49449	3370	1521369	1986-09-21	1987-09-16	1	6467
14130	967	1115008	2007-05-20	2007-06-10	1	13674
71720	4898	1713332	2005-12-09	2005-12-23	1	13140
65258	4457	1729720	2003-11-02	2003-11-09	1	12365
36500	2483	1125315	1946-07-24	1946-07-31	1	-8555
71418	4874	1119510	1972-06-14	1972-06-21	1	902
71525	4884	1125315	1989-07-08	1989-10-06	2	7218
38595	2624	1125315	2007-03-11	2007-03-18	1	13590
18344	1261	920293	2012-05-30	2012-06-06	1	15497
73692	5039	1728416	1974-10-21	1974-11-04	1	1768
49450	3370	1551099	1977-01-31	1977-01-31	1	2587
14131	967	1118084	1973-10-25	1973-10-25	1	1393
71721	4898	1729720	1954-02-12	1954-02-20	1	-5794
65259	4457	1118084	2016-08-19	2016-08-19	1	17032
36501	2483	1149380	1968-05-11	1968-05-11	1	-600
71419	4874	1125315	1976-12-12	1976-12-26	1	2551
71526	4884	1149380	1975-10-28	1975-10-28	1	2126
38596	2624	1503184	1984-12-15	1985-12-10	1	5822
18345	1261	1125315	1990-06-08	1990-06-22	1	7477
73693	5039	1759842	1981-08-22	1981-08-29	1	4258
49451	3370	1112807	1974-06-16	1974-06-30	1	1641
14132	967	1177480	1977-04-06	1977-04-27	1	2673
71722	4898	1125315	1999-06-23	1999-07-07	1	10779
65260	4457	1125315	1994-02-11	1994-02-25	1	8821
36502	2483	1728416	1945-03-29	1945-04-12	1	-9030
71420	4874	1125315	2006-11-28	2006-11-28	1	13480
71527	4884	1713332	1976-10-08	1976-10-22	1	2486
38597	2624	1759842	1993-01-28	1993-02-18	1	8449
18346	1261	1125315	2006-05-01	2006-05-08	1	13276
73694	5039	1118084	2010-10-02	2010-10-02	1	14884
49452	3370	1124300	2011-10-30	2011-10-30	1	15277
14133	967	1729720	1937-10-31	1937-11-10	1	-11740
71723	4898	1125315	2003-09-16	2003-09-23	1	12318
65660	4485	1759842	2012-12-06	2012-12-20	1	15694
36503	2483	1118084	1984-08-11	1984-08-11	1	5336
71421	4874	1503184	1983-07-26	1984-07-20	1	5314
71528	4884	1124300	2016-02-28	2016-02-28	1	16859
38598	2624	1713332	2006-02-16	2006-02-23	1	13202
18347	1261	1125315	2006-11-06	2006-11-20	1	13472
73695	5039	1125315	1976-05-13	1976-06-03	1	2345
49453	3370	1125315	1977-05-01	1977-05-15	1	2691
14134	967	1759842	1947-05-29	1947-07-03	1	-8218
71724	4898	1125315	2012-03-28	2012-04-11	1	15441
65661	4485	1112807	1951-07-09	1951-07-23	1	-6737
36504	2483	1125315	1962-12-15	1962-12-29	1	-2560
71422	4874	1503184	1988-06-29	1990-06-19	2	7474
71529	4884	1125315	1974-05-26	1974-06-09	1	1620
38599	2624	1759842	2006-02-16	2006-02-23	1	13202
18348	1261	1125315	2016-04-12	2016-04-19	1	16910
73696	5039	1125315	1984-02-22	1984-03-14	1	5186
49454	3370	1125315	2003-05-17	2003-05-31	1	12203
14135	967	1119510	2018-03-08	2018-03-22	1	17612
73822	5048	1115008	2016-05-23	2016-08-21	1	17034
65662	4485	1118084	1994-10-16	1994-10-16	1	9054
36505	2483	1137529	1968-05-11	1968-05-11	1	-600
71423	4874	1515774	1992-06-08	1993-06-03	1	8554
71530	4884	1177480	1977-05-15	1977-05-29	1	2705
40187	2732	1112807	1987-07-23	1987-08-06	1	6426
18349	1261	1137529	2005-07-09	2005-07-09	1	12973
73697	5039	1125315	2014-04-13	2014-04-27	1	16187
49455	3370	1125315	2015-01-14	2015-01-28	1	16463
14136	967	1125315	1973-01-13	1973-01-27	1	1122
73823	5048	1125315	1978-01-22	1978-01-29	1	2950
65663	4485	1125315	1963-02-08	1963-02-22	1	-2505
36506	2483	1729720	1981-04-06	1981-04-16	1	4123
71424	4874	1549786	1992-06-08	1993-06-03	1	8554
71531	4884	1177480	1978-02-22	1978-03-08	1	2988
40188	2732	1118084	2004-03-21	2004-03-21	1	12498
18350	1261	1738521	1973-09-27	1973-10-11	1	1379
73698	5039	1322184	2008-12-30	2008-12-30	1	14243
49456	3370	1713332	1998-08-08	1998-08-22	1	10460
14137	967	1125315	1987-06-16	1987-06-23	1	6382
73824	5048	1125315	1995-02-26	1995-03-12	1	9201
65664	4485	1125315	2002-08-22	2002-08-29	1	11928
36507	2483	1112807	1961-02-17	1961-03-10	1	-3219
71425	4874	1759842	2016-07-19	2016-08-02	1	17015
71532	4884	1759842	1976-10-08	1976-10-22	1	2486
40189	2732	1759842	1978-06-26	1978-07-17	1	3119
18351	1261	933724	2012-05-30	2012-06-06	1	15497
73699	5039	1332418	2008-12-30	2008-12-30	1	14243
49457	3370	1728416	1977-05-01	1977-05-15	1	2691
14138	967	1125315	2011-07-09	2011-07-16	1	15171
73825	5048	1125315	2002-05-15	2002-05-22	1	11829
65665	4485	1125315	2008-10-21	2008-11-04	1	14187
36752	2501	1112807	1962-05-26	1962-06-09	1	-2763
71426	4874	19127890	1983-07-26	1984-07-20	1	5314
75466	5166	1119510	2015-05-14	2015-05-28	1	16583
40190	2732	19127890	1983-08-04	1984-07-29	1	5323
18352	1261	975125	1989-05-20	1989-05-20	1	7079
73700	5039	1539403	2008-12-30	2008-12-30	1	14243
49458	3370	1759842	1975-02-18	1975-02-25	1	1881
14139	967	1361711	2011-07-16	2011-07-16	1	15171
73826	5048	1177480	1999-06-24	1999-07-08	1	10780
65666	4485	1759842	1972-04-14	1972-04-28	1	848
36753	2501	1112807	1966-08-28	1966-09-11	1	-1208
71427	4874	19127890	1995-05-24	1996-05-18	1	9634
75467	5166	1177480	2008-12-15	2009-01-12	1	14256
40191	2732	1125315	1972-07-23	1972-07-30	1	941
18353	1261	1119510	1989-03-29	1989-04-12	1	7041
73701	5039	1112807	1974-10-21	1974-11-04	1	1768
49459	3370	1119510	2019-04-20	2019-05-04	1	18020
14140	967	1501700	1993-09-30	1993-09-30	1	8673
73827	5048	1177480	2007-12-23	2008-01-06	1	13884
65667	4485	1177480	2003-05-07	2003-05-21	1	12193
36754	2501	1125315	1974-04-07	1974-05-05	1	1585
72989	4988	1119510	1988-03-28	1988-04-11	1	6675
75468	5166	1713332	1969-06-27	1969-07-04	1	-181
40192	2732	1713332	1978-06-26	1978-07-17	1	3119
18354	1261	1125315	1972-03-06	1972-03-20	1	809
73702	5039	1115008	1994-12-17	1995-03-17	1	9206
49460	3370	1177480	1990-10-09	1990-10-30	1	7607
14141	967	1759842	1955-10-17	1955-11-07	1	-5169
73828	5048	1713332	1965-05-11	1965-06-01	1	-1675
65668	4485	1125315	1994-07-20	1994-08-03	1	8980
36755	2501	1125315	1981-11-14	1981-11-21	1	4342
72990	4988	1125315	1979-01-05	1979-01-19	1	3305
75469	5166	1729720	2011-04-23	2011-05-04	1	15098
40193	2732	1729720	2014-01-30	2014-02-10	1	16111
18355	1261	1125315	1973-01-01	1973-02-04	2	1124
73703	5039	1125315	2019-02-11	2019-02-25	1	17952
49461	3370	1713332	1975-02-18	1975-02-25	1	1881
20070	1368	1112807	1985-01-30	1985-02-20	1	5529
73829	5048	920293	1983-01-06	1983-01-13	1	4760
65669	4485	1713332	1972-04-14	1972-04-28	1	848
36756	2501	1112807	1962-09-05	1962-09-19	1	-2661
72991	4988	1713332	2000-02-26	2000-03-04	1	11020
75470	5166	738818	2015-05-14	2015-05-28	1	16583
40194	2732	19127890	1987-07-14	1988-07-08	1	6763
18356	1261	1729720	1973-06-01	1973-06-10	1	1256
73704	5039	1125315	1977-01-19	1977-02-02	1	2589
49462	3370	19127890	1986-09-21	1987-09-16	1	6467
20071	1368	1125315	1958-04-10	1958-04-24	1	-4270
73830	5048	933724	1983-01-06	1983-01-13	1	4760
65670	4485	1713332	2012-12-06	2012-12-20	1	15694
36757	2501	1112807	1962-10-23	1962-11-06	1	-2613
72992	4988	1125315	1956-02-05	1956-04-05	1	-5019
75471	5166	1112807	1955-02-22	1955-05-23	1	-5337
40195	2732	920293	1992-08-25	1992-09-01	1	8279
18357	1261	1112807	1973-09-27	1973-10-11	1	1379
73705	5039	1125315	1979-12-25	1980-01-01	1	3652
50207	3420	1125315	1969-09-03	1969-10-03	1	-90
20072	1368	1125315	1970-09-18	1970-09-18	1	260
73831	5048	1125315	1992-08-24	1992-08-31	1	8278
65671	4485	1728416	1951-07-09	1951-07-23	1	-6737
36758	2501	1125315	1965-06-22	1965-07-06	1	-1640
72993	4988	1125315	1977-04-17	1977-04-24	1	2670
75472	5166	1112807	1966-05-25	1966-08-23	1	-1227
40196	2732	933724	1992-08-25	1992-09-01	1	8279
18358	1261	1115008	1995-01-10	1995-01-31	1	9161
73706	5039	1125315	1994-12-17	1994-12-17	1	9116
50208	3420	1125315	1982-12-15	1983-01-12	1	4759
20073	1368	1125315	1971-07-03	1971-07-17	1	562
73832	5048	1129625	1962-11-13	1962-11-13	1	-2606
67311	4595	1717327	1965-03-28	1965-04-11	1	-1726
36759	2501	1125315	1997-06-15	1997-06-29	1	10041
72994	4988	1125315	2007-09-13	2007-09-27	1	13783
75473	5166	1125315	1989-05-24	1989-06-28	1	7118
40197	2732	1503184	1983-08-04	1984-07-29	1	5323
18359	1261	1118084	2005-10-24	2005-10-24	1	13080
73707	5039	1174888	1994-12-17	1994-12-17	1	9116
50209	3420	1729720	1980-01-22	1980-02-04	1	3686
20074	1368	1728416	1956-04-20	1956-05-04	1	-4990
73833	5048	1729720	1970-06-27	1970-07-08	1	188
67312	4595	1112807	1965-03-28	1965-04-11	1	-1726
36760	2501	1112807	1979-05-09	1979-05-30	1	3436
72995	4988	1713332	1979-01-05	1979-01-19	1	3305
75474	5166	1125315	2015-05-14	2015-05-28	1	16583
40198	2732	1521369	1987-07-14	1988-07-08	1	6763
19805	1352	967823	1976-07-29	1976-07-30	1	2402
73708	5039	1361711	2008-12-30	2008-12-30	1	14243
50210	3420	1759842	1970-02-05	1970-02-12	1	42
20075	1368	1729720	1976-09-02	1976-09-09	1	2443
73834	5048	1759842	1965-05-11	1965-06-01	1	-1675
67313	4595	1174888	1996-02-21	1996-02-21	1	9547
36761	2501	1115008	2019-06-04	2019-06-18	1	18065
72996	4988	1729720	2006-12-10	2006-12-17	1	13499
75475	5166	1759842	1969-06-27	1969-07-04	1	-181
40199	2732	1713332	1975-03-14	1975-04-04	1	1919
19806	1352	1000560	1976-07-29	1976-07-29	2	2401
73709	5039	1713332	1981-08-22	1981-08-29	1	4258
50211	3420	1119510	1973-06-15	1973-06-29	1	1275
20076	1368	1112807	1956-04-20	1956-05-04	1	-4990
73835	5048	920293	1976-11-14	1976-11-21	1	2516
67314	4595	1713332	1967-06-23	1967-07-14	1	-902
36762	2501	1118084	1995-11-09	1995-11-09	1	9443
72997	4988	738818	1988-03-28	1988-04-11	1	6675
75476	5166	1102527	1966-05-25	1966-05-25	1	-1317
40200	2732	1125315	1978-12-18	1979-01-08	1	3294
19807	1352	1125315	1959-08-12	1959-08-19	1	-3788
73710	5039	1717327	1977-01-19	1977-02-02	1	2589
50212	3420	1125315	1993-04-22	1993-04-29	1	8519
20077	1368	1125315	1959-05-19	1959-06-18	1	-3850
73836	5048	933724	1976-11-14	1976-11-21	1	2516
67315	4595	1729720	1970-07-13	1970-07-22	1	202
36763	2501	1125315	1996-05-27	1996-06-10	1	9657
72998	4988	1125315	1960-09-11	1960-09-25	1	-3385
75477	5166	1112807	1992-03-14	1992-06-12	1	8198
40201	2732	1125315	1980-02-02	1980-03-01	1	3712
19808	1352	1367571	1976-07-29	1976-07-29	1	2401
74310	5081	1112807	1927-12-28	1928-01-18	1	-15324
50213	3420	1713332	1970-02-05	1970-02-12	1	42
20078	1368	1713332	1994-01-11	1994-01-25	1	8790
73837	5048	1125315	1966-08-13	1966-09-10	1	-1209
67316	4595	1124300	2001-11-14	2001-11-14	1	11640
36764	2501	1728416	1966-08-28	1966-09-11	1	-1208
72999	4988	1125315	1967-05-22	1967-06-19	1	-927
75478	5166	1125315	1969-10-31	1969-11-07	1	-55
40202	2732	1125315	1981-12-02	1981-12-16	1	4367
19809	1352	1713332	1999-03-13	1999-04-03	1	10684
74311	5081	1119510	1997-06-20	1997-06-27	1	10039
50214	3420	19127890	1984-08-25	1985-08-20	1	5710
20079	1368	1112807	1970-09-18	1970-10-16	1	288
73838	5048	1125315	1975-11-22	1975-12-06	1	2165
67317	4595	1125315	1974-08-09	1974-11-06	1	1770
36765	2501	1125315	1992-07-17	1992-07-31	1	8247
73000	4988	1125315	1977-12-23	1978-01-27	1	2948
75479	5166	1125315	1998-06-03	1998-06-17	1	10394
40203	2732	1192710	1973-08-27	1973-08-27	1	1334
19810	1352	1729720	1947-04-05	1947-04-14	1	-8298
74312	5081	1125315	1975-01-30	1975-02-20	1	1876
50215	3420	1118084	1998-11-10	1998-11-10	1	10540
20080	1368	1118084	1992-05-26	1992-05-26	1	8181
73839	5048	1125315	1993-08-03	1993-08-24	1	8636
67318	4595	1125315	1986-04-01	1986-04-08	1	5941
36766	2501	1177480	1995-09-03	1995-09-24	1	9397
73001	4988	1125315	1988-03-28	1988-04-11	1	6675
75480	5166	1125315	2003-01-18	2003-01-25	1	12077
40204	2732	1503184	1987-07-14	1988-07-08	1	6763
19811	1352	1759842	1976-10-03	1976-10-24	1	2488
74313	5081	1125315	1985-07-27	1985-08-10	1	5700
50216	3420	1125315	2002-07-29	2002-08-05	1	11904
20081	1368	1322184	2019-06-26	2019-06-26	1	18073
73840	5048	1713332	2012-12-13	2012-12-20	1	15694
67319	4595	1125315	1991-04-09	1991-04-23	1	7782
36767	2501	1717327	1962-05-26	1962-06-09	1	-2763
73002	4988	1713332	1996-07-25	1996-08-08	1	9716
75481	5166	1713332	2010-05-29	2010-06-05	1	14765
40205	2732	1521369	1983-08-04	1984-07-29	1	5323
19812	1352	1759842	1999-08-10	1999-08-31	1	10834
74314	5081	1125315	1986-09-04	1986-09-25	1	6111
50217	3420	1125315	2005-10-20	2005-10-27	1	13083
20082	1368	1347450	2019-06-26	2019-06-26	1	18073
73841	5048	1759842	2012-12-13	2012-12-20	1	15694
67320	4595	1759842	1967-06-23	1967-07-14	1	-902
36768	2501	1729720	1974-05-27	1974-06-05	1	1616
73003	4988	1713332	2002-08-27	2002-09-03	1	11933
75482	5166	1729720	1953-04-06	1953-04-15	1	-6105
40206	2732	1759842	1975-03-14	1975-04-04	1	1919
19813	1352	708298	1976-07-29	1976-07-29	1	2401
74315	5081	1125315	2004-11-19	2004-12-19	1	12771
50218	3420	1177480	1975-09-02	1975-09-23	1	2091
20083	1368	1713332	1974-12-20	1975-01-03	1	1828
73842	5048	1118084	1991-10-06	1991-10-06	1	7948
67321	4595	1115008	2017-01-31	2017-02-14	1	17211
39112	2659	1125315	1976-09-13	1976-09-27	1	2461
73004	4988	1759842	1996-07-25	1996-08-08	1	9716
75483	5166	1759842	2010-05-29	2010-06-05	1	14765
40207	2732	1768849	1981-12-02	1981-12-16	1	4367
19814	1352	1102527	1976-07-30	1976-07-30	1	2402
74316	5081	1729720	1974-04-27	1974-05-08	1	1588
50219	3420	738818	1973-06-15	1973-06-29	1	1275
20084	1368	1759842	1994-01-11	1994-01-25	1	8790
73843	5048	1125315	1959-10-20	1959-10-27	1	-3719
67322	4595	1125315	1976-03-02	1976-03-16	1	2266
39113	2659	1125315	1988-03-15	1988-03-22	1	6655
73005	4988	1759842	2002-08-27	2002-09-03	1	11933
75484	5166	1118084	1985-08-23	1985-08-23	1	5713
40939	2778	738818	1978-07-17	1978-07-24	1	3126
19815	1352	1110410	1976-07-29	1976-07-29	1	2401
74317	5081	715997	2000-09-09	2000-09-09	1	11209
50220	3420	1125315	1973-06-15	1973-06-29	1	1275
20085	1368	1124957	1970-09-18	1970-09-18	1	260
73844	5048	1125315	1961-07-10	1961-07-24	1	-3083
67323	4595	1125315	1996-02-14	1996-03-22	2	9577
39114	2659	1125315	2006-07-18	2006-08-01	1	13361
73006	4988	920293	1983-05-27	1983-06-03	1	4901
75485	5166	1125315	1958-09-06	1958-09-20	1	-4121
40940	2778	1125315	1978-07-17	1978-07-24	1	3126
19816	1352	1125315	1959-12-07	1959-12-14	1	-3671
74318	5081	738818	1964-11-04	1964-11-18	1	-1870
50221	3420	1177480	2003-01-27	2003-02-26	1	12109
20086	1368	1125315	1956-10-25	1956-11-08	1	-4802
73845	5048	1125315	1964-09-06	1964-09-20	1	-1929
68027	4643	1112807	1914-02-04	1914-02-18	1	-20406
39115	2659	1177480	1977-09-08	1977-10-06	1	2835
73007	4988	933724	1983-05-27	1983-06-03	1	4901
77534	5300	708298	1945-02-13	1945-02-13	1	-9088
40941	2778	1125315	2011-04-12	2011-04-19	1	15083
19817	1352	1149380	1995-08-20	1995-08-20	1	9362
74319	5081	738818	1997-06-20	1997-06-27	1	10039
50222	3420	1503184	1984-08-25	1985-08-20	1	5710
20087	1368	1177480	1982-05-16	1982-05-30	1	4532
73846	5048	1728416	1961-07-10	1961-07-24	1	-3083
68028	4643	1125315	1956-02-06	1956-02-13	1	-5071
39116	2659	1174888	2017-02-20	2017-02-20	1	17217
73008	4988	1118084	1991-04-27	1991-04-27	1	7786
77535	5300	1000560	1945-02-13	1945-02-13	2	-9088
40942	2778	1729720	2017-09-07	2017-09-15	1	17424
19818	1352	1713332	1976-10-03	1976-10-24	1	2488
74320	5081	1102527	2004-11-19	2004-11-19	1	12741
50223	3420	1521369	1984-08-25	1985-08-20	1	5710
20088	1368	1713332	2007-01-01	2007-01-08	1	13521
73847	5048	1728416	1964-09-06	1964-09-20	1	-1929
68029	4643	1125315	1963-01-12	1963-01-19	1	-2539
39117	2659	1177480	1979-06-19	1979-09-17	1	3546
73009	4988	1177480	1983-07-30	1983-08-20	1	4979
77536	5300	1125315	1959-05-24	1959-06-07	1	-3861
40943	2778	1119510	1978-07-17	1978-07-24	1	3126
19819	1352	1713332	1993-02-28	1993-03-14	1	8473
74321	5081	1112807	1946-10-14	1946-10-28	1	-8466
50224	3420	1729720	1970-01-02	1970-01-14	1	13
20089	1368	1728416	1956-10-25	1956-11-08	1	-4802
75168	5144	757627	2014-09-27	2014-09-27	1	16340
68030	4643	1125315	1978-12-07	1979-02-05	1	3322
39118	2659	1177480	2015-03-12	2015-04-02	1	16527
73010	4988	1759842	2000-02-26	2000-03-04	1	11020
77537	5300	1125315	1965-04-09	1965-04-23	1	-1714
40944	2778	1125315	1986-10-01	1986-10-22	1	6138
19820	1352	1741122	1976-07-29	1976-07-29	1	2401
74322	5081	1125315	1947-09-19	1947-10-03	1	-8126
51405	3504	1177480	1993-12-01	1993-12-29	1	8763
20090	1368	1738521	1970-09-18	1970-10-16	1	288
75169	5144	1112807	1968-07-01	1968-07-22	1	-528
68031	4643	1125315	1985-02-03	1985-03-05	1	5542
39119	2659	1738521	1976-09-13	1976-09-27	1	2461
74457	5094	1112807	1991-09-25	1991-11-24	1	7997
77538	5300	1367571	1945-02-13	1945-02-13	1	-9088
40945	2778	1729720	1977-07-23	1977-08-01	1	2769
19821	1352	19078219	1976-07-29	1976-07-29	1	2401
74323	5081	1125315	1964-11-04	1964-11-18	1	-1870
51406	3504	715997	2002-11-23	2002-11-23	1	12014
20091	1368	1759842	1974-12-20	1975-01-03	1	1828
75170	5144	1118084	1971-09-03	1971-09-03	1	610
68032	4643	1759842	1941-11-20	1941-12-11	1	-10248
39120	2659	1759842	1974-12-29	1975-08-17	1	2054
74458	5094	1118084	2017-12-07	2017-12-07	1	17507
77539	5300	1713332	1978-01-19	1978-01-26	1	2947
40946	2778	1118084	2011-07-27	2011-07-27	1	15182
19822	1352	914335	1984-11-25	1984-11-25	1	5442
74324	5081	1728416	1946-10-14	1946-10-28	1	-8466
51407	3504	1112807	1924-05-07	1924-05-21	1	-16661
20092	1368	1759842	2007-01-01	2007-01-08	1	13521
75171	5144	1125315	1942-02-28	1942-03-07	1	-10162
68033	4643	1112807	1912-12-27	1913-01-10	1	-20810
39121	2659	1124300	2006-07-08	2006-07-08	1	13337
74459	5094	1125315	1981-11-11	1981-12-16	1	4367
77540	5300	1741122	1945-02-13	1945-02-13	1	-9088
40947	2778	1150770	1978-02-02	1978-02-02	1	2954
19823	1352	1137529	1995-08-20	1995-08-20	1	9362
74325	5081	914335	1935-05-17	1935-05-17	1	-12648
51408	3504	1112807	1937-12-25	1938-01-24	1	-11665
21453	1460	1115008	2017-10-21	2017-11-11	1	17481
75172	5144	1125315	2017-06-03	2017-06-17	1	17334
68034	4643	1119510	1913-05-27	1913-06-03	1	-20666
39122	2659	1713332	1974-12-29	1975-08-17	1	2054
74460	5094	1125315	1991-09-25	1991-09-25	1	7937
77541	5300	1759842	1984-06-29	1984-07-06	1	5300
41658	2825	1112807	1991-03-02	1991-05-31	1	7820
19824	1352	1551099	1971-07-29	1971-08-19	1	595
74326	5081	1112807	1939-03-21	1939-04-04	1	-11230
51409	3504	1112807	1939-11-15	1940-01-14	1	-10945
21454	1460	1125315	2016-11-20	2016-12-25	1	17160
75173	5144	738818	1957-05-25	1957-06-08	1	-4590
68035	4643	1124957	1940-08-30	1940-08-30	1	-10716
39123	2659	1729720	1979-01-03	1979-01-16	1	3302
74461	5094	1153428	1999-05-19	1999-05-19	1	10730
77542	5300	1110410	1945-02-13	1945-02-13	1	-9088
41659	2825	1124300	1964-03-06	1964-03-06	1	-2127
19825	1352	1713332	1999-08-10	1999-08-31	1	10834
74327	5081	1112807	1951-05-01	1951-05-15	1	-6806
51410	3504	1125315	1967-06-22	1967-07-06	1	-910
21455	1460	1177480	1984-03-15	1984-03-29	1	5201
75174	5144	1119510	1951-04-19	1951-05-03	1	-6818
68036	4643	1125315	1916-04-19	1916-04-26	1	-19608
39124	2659	1125315	2017-02-20	2017-04-21	2	17277
74462	5094	1549786	1995-04-12	1996-04-06	1	9592
77543	5300	1112807	1942-11-17	1943-02-15	1	-9817
41660	2825	1125315	1970-04-30	1970-05-07	1	126
19826	1352	1729720	1972-07-13	1972-07-21	1	932
74328	5081	1124300	1955-02-14	1955-02-14	1	-5435
51411	3504	1713332	1939-11-24	1939-12-15	1	-10975
21456	1460	1521369	1995-05-27	1996-05-21	1	9637
75175	5144	1125315	1957-05-25	1957-06-08	1	-4590
68037	4643	1713332	1958-08-11	1958-08-25	1	-4147
39125	2659	1177480	1978-08-02	1978-08-23	1	3156
74463	5094	1729720	2006-10-18	2006-10-30	1	13451
77544	5300	1125315	2007-06-15	2007-06-29	1	13693
41661	2825	1125315	2007-12-24	2008-01-23	1	13901
19827	1352	1746114	1976-07-29	1976-07-29	1	2401
74329	5081	1125315	1915-12-28	1916-01-04	1	-19721
51412	3504	1759842	1939-11-24	1939-12-15	1	-10975
21457	1460	1549786	1999-05-06	2000-04-30	1	11077
75176	5144	1125315	1982-04-15	1982-04-22	1	4494
68038	4643	1729720	1994-06-20	1994-07-02	1	8948
39753	2703	723013	1976-08-08	1977-01-16	1	2572
74464	5094	975125	1999-05-04	1999-05-04	1	10715
77545	5300	1759842	1978-01-19	1978-01-26	1	2947
41662	2825	1713332	1968-11-27	1968-12-11	1	-386
19828	1352	1759842	1999-03-13	1999-04-03	1	10684
74330	5081	1125315	1970-07-07	1970-07-21	1	201
51413	3504	1713332	1988-12-17	1989-01-07	1	6946
21458	1460	1118084	2017-09-03	2017-09-03	1	17412
75177	5144	701322	2016-03-20	2016-03-20	1	16880
68039	4643	1112807	1940-08-30	1940-11-28	1	-10626
39754	2703	1118084	2014-04-12	2014-04-12	1	16172
74465	5094	1343916	1999-05-19	1999-05-19	1	10730
77546	5300	19078219	1945-02-13	1945-02-13	1	-9088
41663	2825	1713332	1972-10-26	1972-11-16	1	1050
19829	1352	19002770	1976-07-29	1976-07-29	1	2401
74331	5081	1177480	1989-08-10	1989-09-09	1	7191
51414	3504	1759842	1988-12-17	1989-01-07	1	6946
21459	1460	1515774	1996-05-21	1997-05-16	1	9997
75178	5144	1112807	1938-04-19	1938-05-03	1	-11566
68040	4643	1125315	1937-10-04	1937-10-11	1	-11770
39755	2703	1125315	1986-02-17	1986-03-03	1	5905
74466	5094	19127890	1995-04-12	1996-04-06	1	9592
77547	5300	753626	1945-02-13	1945-02-13	1	-9088
41664	2825	1112807	1927-03-16	1927-04-13	1	-15604
19830	1352	19003953	1976-07-29	1976-07-29	1	2401
74332	5081	1343916	1935-05-17	1935-05-17	1	-12648
51415	3504	715997	2001-12-28	2001-12-28	1	11684
21460	1460	1595799	1999-05-06	2000-04-30	1	11077
75179	5144	1119510	1957-05-25	1957-06-08	1	-4590
68041	4643	1125315	1940-08-30	1940-08-30	1	-10716
39756	2703	1713332	1984-11-26	1984-12-03	1	5450
74467	5094	1174888	1991-09-25	1991-09-25	1	7937
77548	5300	1102527	2018-03-18	2018-03-18	1	17608
41665	2825	1112807	1946-03-09	1946-04-13	1	-8664
19831	1352	753626	1976-07-29	1976-07-29	1	2401
74333	5081	715997	1999-10-15	1999-10-15	1	10879
51416	3504	1118084	1956-04-29	1956-04-29	1	-4995
21461	1460	1768849	1982-07-24	1982-08-07	1	4601
75180	5144	1177480	2009-11-14	2009-12-05	1	14583
68042	4643	1713332	1941-11-20	1941-12-11	1	-10248
39757	2703	1729720	1979-09-20	1979-09-28	1	3557
74468	5094	1515774	1995-04-12	1996-04-06	1	9592
77549	5300	1125315	1998-11-10	1998-11-17	1	10547
41666	2825	1125315	1993-06-19	1993-07-10	1	8591
19832	1352	1112807	1970-07-29	1970-08-26	1	237
74334	5081	1112807	1919-11-05	1919-12-10	1	-18285
51417	3504	1729720	1931-04-04	1931-04-13	1	-14143
21462	1460	1125315	1989-07-19	1989-08-02	1	7153
75181	5144	715997	2016-03-20	2016-03-20	1	16880
68043	4643	738818	1913-05-27	1913-06-03	1	-20666
39758	2703	1738521	1977-07-15	1977-07-29	1	2766
74469	5094	1125315	2000-12-06	2001-01-03	1	11325
77550	5300	1125315	2002-12-25	2003-01-08	1	12060
41667	2825	1125315	2017-02-20	2017-03-06	1	17231
19833	1352	1115008	1971-07-29	1971-07-29	1	574
74335	5081	1112807	1969-05-10	1969-05-31	1	-215
51745	3526	1112807	1951-05-21	1951-06-04	1	-6786
21463	1460	1503184	1995-05-27	1996-05-21	1	9637
75182	5144	738818	1951-04-19	1951-05-03	1	-6818
68044	4643	1112807	1946-05-01	1946-05-31	1	-8616
39759	2703	1759842	1984-11-26	1984-12-03	1	5450
74470	5094	1125315	2006-06-05	2006-06-12	1	13311
77551	5300	1125315	2015-04-19	2015-05-03	1	16558
41668	2825	1112807	1927-09-12	1927-09-26	1	-15438
19834	1352	1118084	1989-09-07	1989-09-07	1	7189
74336	5081	1119510	1964-11-04	1964-11-18	1	-1870
51746	3526	1119510	2015-01-05	2015-01-19	1	16454
21464	1460	1521369	1999-05-06	2000-04-30	1	11077
75183	5144	1125315	1951-04-19	1951-05-03	1	-6818
68045	4643	1124300	1944-06-22	1944-06-22	1	-9324
39760	2703	1115008	2014-10-07	2014-10-28	1	16371
75508	5168	1119510	1973-05-17	1973-05-24	1	1239
77552	5300	1125315	2018-03-18	2018-04-17	1	17638
41669	2825	1125315	1975-09-08	1975-09-22	1	2090
19835	1352	1125315	1946-09-05	1946-09-19	1	-8505
74337	5081	1125315	1989-08-12	1989-08-19	1	7170
51747	3526	1124300	1986-06-06	1986-06-06	1	6000
21465	1460	1549786	1996-05-21	1997-05-16	1	9997
75184	5144	1125315	1951-08-09	1951-08-30	1	-6699
68046	4643	1125315	1913-05-27	1913-06-03	1	-20666
39761	2703	1125315	2004-10-03	2004-10-24	1	12715
75509	5168	1729720	2000-04-20	2000-05-01	1	11078
77553	5300	1713332	1984-06-29	1984-07-06	1	5300
41670	2825	1759842	1968-11-27	1968-12-11	1	-386
19836	1352	1125315	1993-02-28	1993-03-14	1	8473
74338	5081	1125315	1997-06-20	1997-06-27	1	10039
51748	3526	1125315	1972-08-17	1972-08-17	1	959
21466	1460	1112807	1982-07-24	1982-08-07	1	4601
75185	5144	1125315	1961-06-17	1961-06-24	1	-3113
68047	4643	1125315	1958-02-27	1958-03-27	1	-4298
39762	2703	1177480	2015-08-24	2015-09-07	1	16685
75510	5168	1759842	2015-11-21	2015-12-05	1	16774
77554	5300	1746114	1945-02-13	1945-02-13	1	-9088
41671	2825	1759842	1972-10-26	1972-11-16	1	1050
19837	1352	1309944	1984-11-25	1984-11-25	1	5442
76689	5241	1177480	1976-01-13	1976-02-10	1	2231
51749	3526	1713332	1957-03-11	1957-03-18	1	-4672
21467	1460	1125315	1991-01-30	1991-02-06	1	7706
75186	5144	1125315	1962-06-21	1962-06-28	1	-2744
68048	4643	1729720	1909-09-15	1909-09-27	1	-22011
39763	2703	723013	1974-11-10	1976-06-27	1	2369
75511	5168	1124300	2010-01-07	2010-01-07	1	14616
77555	5300	1759842	1975-12-16	1975-12-23	1	2182
41672	2825	1112807	1931-01-22	1931-02-26	1	-14189
19838	1352	1343916	1984-11-25	1984-11-25	1	5442
76690	5241	1177480	1987-03-14	1987-04-11	1	6309
51750	3526	1728416	1953-08-22	1953-09-05	1	-5962
21468	1460	1177480	1999-10-07	1999-10-21	1	10885
75187	5144	1125315	2013-05-08	2013-05-15	1	15840
68049	4643	1759842	1958-08-11	1958-08-25	1	-4147
39764	2703	1125315	1983-11-04	1983-11-11	1	5062
75512	5168	1717327	1971-05-27	1971-06-10	1	525
77556	5300	782043	1945-02-13	1945-02-13	1	-9088
41673	2825	1125315	1991-10-16	1991-10-30	1	7972
19839	1352	1713332	1983-09-26	1983-10-10	1	5030
76691	5241	1503184	1983-02-15	1985-02-04	2	5513
51751	3526	1729720	1955-01-13	1955-01-20	1	-5460
21469	1460	1729720	1988-10-05	1988-10-13	1	6860
76503	5230	1112807	1961-09-06	1961-11-05	1	-2979
70486	4815	1118084	2008-09-06	2008-09-06	1	14128
39765	2703	1125315	1987-05-24	1987-06-14	1	6373
75513	5168	738818	1973-05-17	1973-05-24	1	1239
77557	5300	967823	1945-02-13	1945-02-14	1	-9087
43510	2943	738818	1977-08-02	1977-08-16	1	2784
19840	1352	1713332	2005-12-05	2005-12-26	1	13143
76692	5241	1503184	1986-01-30	1987-01-25	1	6233
51752	3526	1759842	1961-10-31	1961-12-26	1	-2928
21470	1460	19127890	1995-05-27	1997-05-16	2	9997
76504	5230	1125315	2013-04-06	2013-04-20	1	15815
70487	4815	1125315	1985-09-26	1985-10-10	1	5761
39766	2703	1729720	1977-07-16	1977-07-28	1	2765
75514	5168	1125315	1973-05-17	1973-05-24	1	1239
77558	5300	1118084	1981-09-03	1981-09-03	1	4263
43511	2943	1125315	1970-05-02	1970-05-30	1	149
19841	1352	1729720	1951-09-21	1951-10-01	1	-6667
76693	5241	1729720	1972-01-06	1972-01-14	1	743
51753	3526	1759842	1977-03-18	1977-04-08	1	2654
24251	1636	1112807	1960-03-15	1960-03-29	1	-3565
76505	5230	1177480	2002-03-05	2002-04-04	1	11781
70488	4815	1728416	1971-08-27	1971-09-10	1	617
39767	2703	723013	1974-03-03	1974-09-29	1	1732
75515	5168	1125315	1979-08-03	1979-08-10	1	3508
77559	5300	1177480	1994-01-18	1994-02-08	1	8804
43512	2943	1125315	1971-01-28	1971-02-04	1	399
19842	1352	1759842	1983-09-26	1983-10-10	1	5030
76694	5241	1729720	2005-10-14	2005-10-24	1	13080
51754	3526	738818	1994-03-07	1994-03-14	1	8838
24252	1636	1112807	1963-04-10	1963-04-24	1	-2444
76506	5230	1713332	1949-02-18	1949-03-11	1	-7601
70489	4815	1112807	1971-08-27	1971-09-10	1	617
39768	2703	1112807	1977-07-15	1977-07-29	1	2766
75516	5168	1125315	2009-08-04	2009-08-11	1	14467
77560	5300	1713332	1975-12-16	1975-12-23	1	2182
43513	2943	738818	2003-03-23	2003-04-06	1	12148
19843	1352	1759842	2005-12-05	2005-12-26	1	13143
76695	5241	1125315	1962-04-26	1962-05-10	1	-2793
51755	3526	1112807	1961-12-24	1962-01-07	1	-2916
24253	1636	1118084	2000-06-13	2000-06-13	1	11121
76507	5230	1729720	1953-03-25	1953-04-05	1	-6115
70490	4815	1119510	2012-06-02	2012-06-09	1	15500
39769	2703	1115008	1999-08-10	1999-08-31	1	10834
75517	5168	1125315	2011-05-27	2011-06-17	1	15142
77561	5300	19003953	1945-02-13	1945-02-13	1	-9088
43514	2943	1112807	1917-03-17	1917-03-31	1	-19269
21878	1490	1118084	1974-02-18	1974-02-18	1	1509
76696	5241	1125315	2001-04-02	2001-04-09	1	11421
51756	3526	1125315	1994-03-07	1994-03-14	1	8838
24254	1636	1125315	1959-08-31	1959-09-14	1	-3762
76508	5230	1124300	1981-02-13	1981-02-13	1	4061
70491	4815	1125315	1988-08-25	1988-10-24	2	6871
39770	2703	1125315	1976-10-19	1976-11-02	1	2497
75518	5168	1112807	1973-04-27	1973-05-11	1	1226
77752	5314	920293	1979-12-21	1979-12-28	1	3648
43515	2943	1112807	1929-09-22	1929-10-22	1	-14681
21879	1490	1177480	2011-01-20	2011-02-10	1	15015
76697	5241	1125315	2017-03-18	2017-03-25	1	17250
51757	3526	1125315	2012-05-10	2012-06-14	1	15505
24255	1636	1125315	2019-02-16	2019-03-02	1	17957
76509	5230	1759842	1949-02-18	1949-03-11	1	-7601
70492	4815	1125315	2003-01-13	2003-01-20	1	12072
39771	2703	1125315	2006-08-15	2006-08-29	1	13389
75519	5168	1125315	1971-05-27	1971-06-10	1	525
77753	5314	933724	1979-12-21	1979-12-28	1	3648
43516	2943	1112807	1931-08-13	1931-10-12	1	-13961
21880	1490	1713332	1960-02-03	1960-02-24	1	-3599
76698	5241	1177480	2012-10-26	2012-11-09	1	15653
51758	3526	1713332	1961-10-31	1961-12-26	1	-2928
24256	1636	1728416	1959-08-31	1959-09-14	1	-3762
76510	5230	1102527	2002-03-05	2002-03-05	1	11751
70493	4815	1125315	2012-06-02	2012-06-09	1	15500
39772	2703	1125315	2008-09-17	2008-10-08	1	14160
75520	5168	1713332	2015-11-21	2015-12-05	1	16774
77754	5314	1125315	1951-09-20	1951-10-04	1	-6664
43517	2943	1118084	1952-11-08	1952-11-08	1	-6263
21881	1490	738818	1992-10-18	1992-11-01	1	8340
76699	5241	1729720	1996-01-20	1996-02-01	1	9527
51759	3526	1713332	1977-03-18	1977-04-08	1	2654
24257	1636	1729720	1969-05-09	1969-05-19	1	-227
76511	5230	1125315	1983-12-12	1983-12-19	1	5100
70494	4815	1174888	1988-08-25	1988-08-25	1	6811
42125	2858	1125315	1979-07-01	1979-07-15	1	3482
75782	5190	1125315	1993-04-20	1993-05-04	1	8524
77755	5314	738818	1959-05-12	1959-05-19	1	-3880
43518	2943	1119510	2003-03-23	2003-04-06	1	12148
21882	1490	1112807	1941-01-22	1941-02-05	1	-10557
76700	5241	19127890	1983-02-15	1985-02-04	2	5513
51760	3526	1759842	1957-03-11	1957-03-18	1	-4672
24258	1636	1119510	1963-08-03	1963-08-10	1	-2336
76512	5230	1557272	2005-11-09	2005-11-09	1	13096
70495	4815	738818	2012-06-02	2012-06-09	1	15500
42126	2858	1125315	1982-02-23	1982-03-02	1	4443
75783	5190	1125315	1998-07-21	1998-08-04	1	10442
77756	5314	1118084	1992-10-04	1992-10-04	1	8312
43519	2943	1125315	1977-08-02	1977-08-16	1	2784
21883	1490	1759842	1960-02-03	1960-02-24	1	-3599
76701	5241	19127890	1986-01-30	1987-01-25	1	6233
51761	3526	1119510	1994-03-07	1994-03-14	1	8838
24259	1636	1125315	1983-02-04	1983-02-18	1	4796
76513	5230	1713332	1949-08-15	1949-09-05	1	-7423
70496	4815	1125315	2010-11-28	2011-01-02	1	14976
42127	2858	1125315	2004-11-29	2004-12-20	1	12772
75784	5190	1125315	2015-02-11	2015-03-11	1	16505
77757	5314	1125315	1959-05-12	1959-05-19	1	-3880
43520	2943	1125315	2003-03-23	2003-04-06	1	12148
21884	1490	1759842	1985-01-08	1985-01-29	1	5507
76702	5241	920293	2019-04-11	2019-04-18	1	18004
51762	3526	1174888	1972-08-17	1972-08-17	1	959
24260	1636	738818	1963-08-03	1963-08-10	1	-2336
76514	5230	1713332	1952-11-26	1952-12-17	1	-6224
70497	4815	1177480	1982-10-28	1982-11-11	1	4697
42128	2858	1713332	1950-03-20	1950-04-10	1	-7206
75785	5190	1713332	1962-02-23	1962-03-09	1	-2855
77758	5314	1125315	1962-08-03	1962-08-10	1	-2701
43521	2943	1713332	1938-01-09	1938-01-16	1	-11673
21885	1490	1759842	2017-02-20	2017-02-27	1	17224
76703	5241	1124300	2001-04-01	2001-04-01	1	11413
51763	3526	1177480	2000-11-09	2000-12-09	1	11300
24261	1636	1125315	1956-04-10	1956-04-24	1	-5000
76515	5230	1729720	1994-01-05	1994-01-16	1	8781
70498	4815	1729720	1970-12-31	1971-01-08	1	372
42129	2858	1713332	1978-08-09	1978-08-23	1	3156
75786	5190	1729720	1974-10-21	1974-10-31	1	1764
77759	5314	1125315	1976-10-04	1976-10-18	1	2482
43522	2943	1713332	1984-11-22	1984-11-29	1	5446
21886	1490	1112807	1940-11-23	1940-12-14	1	-10610
76704	5241	1521369	1986-01-30	1987-01-25	1	6233
51764	3526	1728416	1951-05-21	1951-06-04	1	-6786
24262	1636	1125315	1963-08-03	1963-08-10	1	-2336
76516	5230	1125315	1996-06-12	1996-06-26	1	9673
72701	4970	1112807	1934-10-17	1934-11-21	1	-12825
42130	2858	1112807	1911-06-15	1911-06-29	1	-21371
75787	5190	1759842	1965-01-27	1965-02-10	1	-1786
77760	5314	1125315	1997-05-05	1997-05-26	1	10007
43523	2943	1713332	2002-05-11	2002-06-01	1	11839
21887	1490	1112807	1942-09-07	1942-09-21	1	-9964
76705	5241	1713332	1981-10-21	1981-11-04	1	4325
51765	3526	1759842	1950-05-05	1950-05-12	1	-7174
24263	1636	1125315	1994-06-13	1994-06-20	1	8936
76517	5230	1177480	2014-02-14	2014-05-15	1	16205
72702	4970	1119510	1934-04-13	1934-04-20	1	-13040
42131	2858	1112807	1912-03-11	1912-04-10	1	-21085
75788	5190	738818	1998-07-21	1998-08-04	1	10442
77761	5314	1112807	1951-11-19	1951-12-03	1	-6604
43524	2943	1112807	1915-07-26	1915-08-09	1	-19869
21888	1490	1115008	1998-11-10	1998-11-24	1	10554
76706	5241	933724	2019-04-11	2019-04-18	1	18004
51766	3526	738818	2015-01-05	2015-01-19	1	16454
24264	1636	1125315	2002-04-07	2002-05-07	1	11814
76518	5230	1713332	2004-10-29	2004-11-05	1	12727
72703	4970	1124300	1958-11-25	1958-11-25	1	-4055
42132	2858	1112807	1936-02-04	1936-03-05	1	-12355
75789	5190	1112807	1965-03-09	1965-03-23	1	-1745
77762	5314	1119510	1959-05-12	1959-05-19	1	-3880
43525	2943	1112807	1920-02-14	1920-03-13	1	-18191
21889	1490	1119510	1992-10-18	1992-11-01	1	8340
76707	5241	1112807	1981-10-21	1981-11-04	1	4325
51767	3526	1112807	1964-09-23	1964-10-23	1	-1896
24265	1636	1125315	2012-01-15	2012-02-14	1	15384
76519	5230	1759842	1949-08-15	1949-09-05	1	-7423
72704	4970	1125315	1927-02-27	1927-03-13	1	-15635
42133	2858	1112807	1944-09-20	1944-10-18	1	-9206
75790	5190	1119510	1998-07-21	1998-08-04	1	10442
77763	5314	1125315	1986-11-12	1986-11-19	1	6166
43526	2943	1112807	1936-08-16	1936-09-06	1	-12170
21890	1490	1125315	1968-09-29	1968-10-13	1	-445
76708	5241	1125315	1969-04-19	1969-05-19	1	-227
51768	3526	1112807	1966-10-13	1966-11-17	1	-1141
24266	1636	1125315	2016-04-23	2016-06-22	1	16974
76520	5230	1759842	1952-11-26	1952-12-17	1	-6224
72705	4970	1125315	1962-08-31	1962-09-14	1	-2666
42134	2858	1115008	1998-01-05	1998-02-04	1	10261
75791	5190	1125315	1962-06-02	1962-06-23	1	-2749
77764	5314	1713332	1971-11-24	1971-12-08	1	706
43527	2943	1125315	2008-02-08	2008-05-08	2	14007
21891	1490	1125315	1982-05-08	1982-08-06	2	4600
76709	5241	1125315	2017-05-17	2017-08-15	1	17393
51769	3526	1112807	1972-08-17	1972-09-16	1	989
24267	1636	1717327	1963-04-10	1963-04-24	1	-2444
76521	5230	1759842	2004-10-29	2004-11-05	1	12727
72706	4970	1713332	1926-05-27	1926-06-03	1	-15918
42135	2858	1124300	1953-05-26	1953-05-26	1	-6064
75792	5190	1125315	1971-05-21	1971-06-04	1	519
77765	5314	1713332	1989-02-12	1989-03-05	1	7003
43528	2943	1759842	1938-01-09	1938-01-16	1	-11673
21892	1490	1125315	2018-10-01	2018-10-31	1	17835
76710	5241	1521369	1983-02-15	1985-02-04	2	5513
51770	3526	1125315	1953-08-22	1953-09-05	1	-5962
24268	1636	1729720	1966-12-07	1966-12-20	1	-1108
240	16	723013	1983-10-10	1984-01-16	1	5128
72707	4970	715997	1997-04-22	1997-04-22	1	9973
42136	2858	1124957	1925-09-29	1925-09-29	1	-16165
75793	5190	1125315	1990-10-05	1990-10-19	1	7596
77766	5314	1728416	1951-09-20	1951-10-04	1	-6664
43529	2943	1759842	1984-11-22	1984-11-29	1	5446
21893	1490	1174888	1982-05-08	1982-05-08	1	4510
76711	5241	1717327	1962-04-26	1962-05-10	1	-2793
51771	3526	1125315	2015-01-05	2015-01-19	1	16454
24269	1636	1125315	1967-05-13	1967-06-10	1	-936
241	16	1112807	1975-05-25	1975-06-08	1	1984
72708	4970	836654	1995-11-29	1995-11-29	1	9463
42137	2858	1125315	1950-07-19	1950-08-02	1	-7092
75794	5190	1713332	1965-01-27	1965-02-10	1	-1786
77767	5314	1728416	1954-11-16	1954-11-30	1	-5511
43530	2943	1759842	2002-05-11	2002-06-01	1	11839
21894	1490	1713332	1985-01-08	1985-01-29	1	5507
51772	3526	1177480	1974-05-09	1974-05-30	1	1610
24270	1636	1125315	1975-07-20	1975-07-27	1	2033
242	16	1112807	1989-06-24	1989-07-08	1	7128
72709	4970	975125	1946-04-20	1946-04-20	1	-8657
42138	2858	1125315	1977-03-02	1977-03-16	1	2631
75795	5190	1759842	1962-02-23	1962-03-09	1	-2855
77768	5314	1759842	1977-11-15	1977-12-06	1	2896
43531	2943	1112807	1946-10-14	1946-11-04	1	-8459
21895	1490	1713332	2017-02-20	2017-02-27	1	17224
51773	3526	1713332	1950-05-05	1950-05-12	1	-7174
24271	1636	1728416	1956-04-10	1956-04-24	1	-5000
243	16	1115008	2014-06-27	2014-07-25	1	16276
72710	4970	1112807	1928-10-18	1928-11-01	1	-15036
42139	2858	1125315	1986-02-07	1986-04-08	1	5941
75796	5190	1759842	1991-10-22	1991-11-05	1	7978
77769	5314	1759842	1989-02-12	1989-03-05	1	7003
43532	2943	1119510	1977-08-02	1977-08-16	1	2784
21896	1490	1125315	1970-09-08	1970-12-07	1	340
54103	3680	19010482	2011-05-27	2011-06-10	1	15135
24765	1672	920293	1979-05-30	1979-06-06	1	3443
244	16	1125315	1974-06-11	1974-06-25	1	1636
72711	4970	1112807	1987-01-17	1987-02-21	1	6260
42140	2858	1125315	2010-05-30	2010-06-13	1	14773
75797	5190	1177480	1986-03-17	1986-03-31	1	5933
77770	5314	1112807	1954-11-16	1954-11-30	1	-5511
43533	2943	1125315	1917-09-15	1917-09-29	1	-19087
21897	1490	1125315	1992-10-18	1992-11-01	1	8340
54104	3680	975125	1998-08-29	1998-09-12	1	10481
24766	1672	933724	1979-05-30	1979-06-06	1	3443
245	16	1713332	1986-09-29	1986-10-20	1	6136
72712	4970	1119510	1983-01-21	1983-01-28	1	4775
42141	2858	1539403	2014-07-09	2014-07-09	1	16260
75798	5190	1713332	1991-10-22	1991-11-05	1	7978
77771	5314	1713332	1977-11-15	1977-12-06	1	2896
43534	2943	1125315	1994-05-30	1994-06-06	1	8922
21898	1490	1125315	1993-01-10	1993-02-09	1	8440
54105	3680	975125	2004-08-15	2004-08-29	1	12659
24767	1672	1118084	1989-04-10	1989-04-10	1	7039
246	16	1125315	1994-01-01	1994-01-08	1	8773
72713	4970	1125315	1964-06-21	1964-06-28	1	-2013
42142	2858	1713332	1982-05-09	1982-05-23	1	4525
75799	5190	1112807	1969-04-01	1969-05-31	1	-215
77772	5314	1759842	1971-11-24	1971-12-08	1	706
43535	2943	1125315	1995-12-15	1996-01-12	1	9507
22653	1538	738818	2010-04-28	2010-05-05	1	14734
54106	3680	1119510	1984-09-04	1984-09-18	1	5374
24768	1672	1125315	1973-10-07	1973-10-28	1	1396
247	16	1503184	1986-10-04	1988-09-23	2	6840
72714	4970	738818	1934-04-13	1934-04-20	1	-13040
42143	2858	1713332	1999-02-19	1999-03-12	1	10662
75800	5190	1124300	1991-11-12	1991-11-12	1	7985
613	38	1118084	2006-05-20	2006-05-20	1	13288
43536	2943	1174888	2008-02-08	2008-02-08	1	13917
22654	1538	1112807	1931-02-27	1931-03-13	1	-14174
54107	3680	1125315	2000-10-25	2000-11-08	1	11269
24769	1672	1125315	2002-10-31	2002-11-07	1	11998
248	16	1521369	1986-10-04	1988-09-23	2	6840
72715	4970	1125315	1934-04-13	1934-04-20	1	-13040
42144	2858	1713332	2005-01-25	2005-02-01	1	12815
75801	5190	1125315	2009-03-20	2009-04-03	1	14337
614	38	1125315	1981-09-29	1981-10-13	1	4303
43537	2943	1177480	1997-02-05	1997-03-07	1	9927
22655	1538	1119510	2010-04-28	2010-05-05	1	14734
54108	3680	1177480	2018-06-19	2018-07-24	1	17736
24770	1672	1713332	2000-01-15	2000-01-29	1	10985
249	16	1713332	1985-08-05	1985-08-26	1	5716
72716	4970	1759842	1926-05-27	1926-06-03	1	-15918
42145	2858	1729720	1918-05-20	1918-05-30	1	-18844
75802	5190	1177480	1988-01-20	1988-02-03	1	6607
615	38	1125315	1999-12-24	2000-01-07	1	10963
45995	3123	1125315	1989-10-03	1989-10-17	1	7229
22656	1538	1125315	1999-07-05	1999-07-26	1	10798
54109	3680	1551099	1979-11-29	1979-11-29	1	3619
24771	1672	1125315	1955-08-17	1955-08-31	1	-5237
250	16	1738521	1972-04-10	1972-04-24	1	844
72717	4970	738818	1983-01-21	1983-01-28	1	4775
42146	2858	1759842	1950-03-20	1950-04-10	1	-7206
75803	5190	1713332	1987-05-30	1987-06-06	1	6365
616	38	1125315	1966-08-05	1966-08-19	1	-1231
45996	3123	1515774	1997-06-01	1998-05-27	1	10373
22657	1538	1125315	2006-04-04	2006-04-18	1	13256
54110	3680	1729720	1999-11-17	1999-11-29	1	10924
24772	1672	1125315	2000-01-15	2000-01-15	1	10971
251	16	1759842	1985-08-05	1985-08-26	1	5716
72718	4970	1125315	1962-06-27	1962-07-27	1	-2715
42147	2858	1759842	1982-05-09	1982-05-23	1	4525
75804	5190	1713332	1993-04-20	1993-05-04	1	8524
617	38	1125315	1966-10-02	1966-10-16	1	-1173
45997	3123	1521369	1991-07-03	1992-06-27	1	8213
22658	1538	1125315	2010-04-28	2010-05-05	1	14734
54111	3680	1778162	1985-01-01	1985-01-15	1	5493
24773	1672	1125315	2001-08-17	2001-08-31	1	11565
252	16	1112807	1972-04-10	1972-04-24	1	844
72719	4970	1125315	1983-01-21	1983-01-28	1	4775
42148	2858	1759842	1999-02-19	1999-03-12	1	10662
75805	5190	1759842	1987-05-30	1987-06-06	1	6365
618	38	1125315	2016-01-01	2016-01-08	1	16808
45998	3123	1713332	1981-02-22	1981-03-01	1	4077
22659	1538	1347450	2016-09-19	2016-09-19	1	17063
54112	3680	975125	1987-05-02	1987-05-23	1	6351
24774	1672	1728416	1955-08-17	1955-08-31	1	-5237
253	16	1124300	2013-03-21	2013-03-21	1	15785
72720	4970	1713332	1980-04-18	1980-04-25	1	3767
42149	2858	1759842	2005-01-25	2005-02-01	1	12815
77371	5290	1125315	1957-06-19	1957-06-26	1	-4572
619	38	1728416	1966-10-02	1966-10-16	1	-1173
45999	3123	1713332	2017-06-14	2017-06-28	1	17345
22660	1538	1713332	1942-01-17	1942-01-31	1	-10197
54113	3680	1112807	1985-01-01	1985-01-15	1	5493
24775	1672	1115008	2000-01-15	2000-01-29	1	10985
254	16	1125315	1985-03-05	1985-03-12	1	5549
72721	4970	1713332	1995-12-09	1995-12-16	1	9480
42150	2858	1112807	1925-09-29	1925-10-29	1	-16135
77372	5290	1125315	1979-05-29	1979-08-27	1	3525
620	38	920293	2004-02-24	2004-03-02	1	12479
46000	3123	1124300	2018-04-12	2018-04-12	1	17633
22661	1538	1713332	1985-04-16	1985-04-30	1	5598
54114	3680	1115008	1994-03-15	1994-04-05	1	8860
24776	1672	1125315	1962-08-01	1962-09-05	1	-2675
255	16	1177480	2004-01-21	2004-03-21	1	12498
72722	4970	1759842	1980-04-18	1980-04-25	1	3767
42151	2858	1115008	1988-03-02	1988-03-02	1	6635
77373	5290	1112807	1954-11-01	1954-12-01	1	-5510
621	38	1125315	1967-10-27	1967-11-17	1	-776
46001	3123	1125315	2016-10-06	2016-10-13	1	17087
22662	1538	1713332	2001-06-23	2001-07-14	1	11517
54115	3680	1115008	1995-04-30	1995-05-21	1	9271
24777	1672	1125315	1992-01-22	1992-02-26	1	8091
256	16	1713332	1987-04-25	1987-05-16	1	6344
72723	4970	1759842	1995-12-09	1995-12-16	1	9480
42152	2858	1125315	1925-09-29	1925-09-29	1	-16165
77374	5290	1124957	1971-09-03	1971-09-03	1	610
622	38	1759842	1973-09-30	1973-10-14	1	1382
46002	3123	1150770	1978-02-19	1978-02-19	1	2971
22663	1538	1759842	1985-04-16	1985-04-30	1	5598
54116	3680	1124300	2018-05-13	2018-05-13	1	17664
24778	1672	1728416	1955-11-04	1955-11-18	1	-5158
257	16	1759842	1987-04-25	1987-05-16	1	6344
73111	4998	975125	1987-08-24	1987-09-07	1	6458
42153	2858	1125315	1991-02-19	1991-03-05	1	7733
77375	5290	1713332	1992-11-14	1992-11-21	1	8360
623	38	933724	2004-02-24	2004-03-02	1	12479
46003	3123	1177480	2005-11-02	2005-12-02	1	13119
22664	1538	1759842	2001-06-23	2001-07-14	1	11517
54117	3680	19010482	1998-08-29	1998-09-12	1	10481
24779	1672	1125315	1955-11-04	1955-11-18	1	-5158
258	16	19127890	1986-10-04	1988-09-23	2	6840
73112	4998	1129625	1968-10-29	1968-10-29	1	-429
42154	2858	1551099	1988-03-02	1988-03-16	1	6649
77376	5290	1759842	1992-11-14	1992-11-21	1	8360
624	38	1713332	1973-09-30	1973-10-14	1	1382
46004	3123	1500211	2004-04-25	2005-04-20	1	12893
22665	1538	1112807	1931-07-10	1931-07-24	1	-14041
54118	3680	19010482	2004-08-15	2004-08-29	1	12659
24780	1672	1125315	1957-03-09	1957-03-30	1	-4660
259	16	1759842	1986-09-29	1986-10-20	1	6136
73113	4998	1154343	1968-10-15	1984-06-01	1	5265
42155	2858	1759842	1978-08-09	1978-08-23	1	3156
77377	5290	1112807	1971-09-03	1971-10-08	1	645
1174	80	738818	1953-02-24	1953-03-10	1	-6141
46005	3123	1503184	1991-07-03	1992-06-27	1	8213
22666	1538	1112807	1960-08-23	1960-09-13	1	-3397
54119	3680	738818	1984-09-04	1984-09-18	1	5374
24781	1672	1174888	2000-01-15	2000-01-15	1	10971
1560	102	1503184	1988-06-11	1989-06-06	1	7096
73114	4998	1713332	2015-03-25	2015-04-01	1	16526
42156	2858	1125315	2018-04-12	2018-04-26	1	17647
77378	5290	1118084	1995-05-15	1995-05-15	1	9265
1175	80	1125315	1937-07-09	1937-07-16	1	-11857
46006	3123	1521369	2002-05-06	2003-05-01	1	12173
22667	1538	1119510	1960-05-18	1960-05-25	1	-3508
54120	3680	738818	2006-07-29	2006-08-12	1	13372
24782	1672	1177480	2007-09-19	2007-10-10	1	13796
1561	102	1521369	1992-05-21	1994-05-11	2	8896
73115	4998	1759842	2015-03-25	2015-04-01	1	16526
42157	2858	1322184	2014-07-09	2014-07-09	1	16260
77379	5290	1177480	2000-05-08	2000-05-29	1	11106
1176	80	1125315	1953-02-24	1953-03-10	1	-6141
46007	3123	1549786	1994-06-17	1995-06-12	1	9293
22668	1538	1125315	1938-02-21	1938-02-28	1	-11630
54121	3680	975125	1983-04-29	1983-05-20	1	4887
24783	1672	1729720	2006-02-03	2006-02-11	1	13190
1562	102	1521369	1996-04-30	1997-04-25	1	9976
73116	4998	975125	1996-12-22	1997-01-05	1	9866
42158	2858	1332418	2014-07-09	2014-07-09	1	16260
77380	5290	1361711	2017-08-11	2017-08-11	1	17389
1177	80	1125315	2013-12-29	2014-01-12	1	16082
46008	3123	1549786	1997-06-01	1998-05-27	1	10373
22669	1538	1177480	1993-12-19	1994-01-02	1	8767
54122	3680	975125	1989-05-18	1989-06-01	1	7091
27177	1837	1118084	2000-07-22	2000-07-22	1	11160
1563	102	1549786	1990-06-01	1992-05-21	2	8176
73117	4998	1124300	2003-08-16	2003-08-16	1	12280
42159	2858	1361711	2014-07-09	2014-07-09	1	16260
77381	5290	1539403	2017-08-11	2017-08-11	1	17389
1178	80	1125315	2018-04-03	2018-04-10	1	17631
46009	3123	1713332	1979-07-26	1979-08-09	1	3507
22670	1538	1310149	2008-05-05	2008-05-05	1	14004
54123	3680	975125	1992-10-14	1992-10-28	1	8336
27178	1837	1119510	1971-06-07	1971-06-21	1	536
1564	102	1778162	1994-06-10	1994-07-15	1	8961
73118	4998	1125315	1966-03-03	1966-03-17	1	-1386
44223	2992	738818	2000-10-07	2000-10-14	1	11244
77382	5290	1551099	1955-01-30	1955-01-30	1	-5450
1179	80	1713332	1950-03-24	1950-04-07	1	-7209
46010	3123	1125315	2005-01-28	2005-02-04	1	12818
22671	1538	1759842	1942-01-17	1942-01-31	1	-10197
54124	3680	975125	2011-05-27	2011-06-10	1	15135
27179	1837	1125315	1964-01-04	1964-01-18	1	-2175
1565	102	1112807	1991-08-20	1991-09-24	1	7936
73119	4998	1125315	1992-05-02	1992-05-16	1	8171
44224	2992	738818	2016-06-30	2016-07-14	1	16996
77383	5290	1717327	1971-09-03	1971-10-08	1	645
1180	80	1759842	1955-04-18	1955-05-09	1	-5351
46011	3123	1177480	1979-07-26	1979-08-09	1	3507
22672	1538	738818	1960-05-18	1960-05-25	1	-3508
54125	3680	1119510	2006-07-29	2006-08-12	1	13372
27180	1837	1125315	1980-01-15	1980-01-29	1	3680
1566	102	1124957	1994-06-10	1994-06-10	1	8926
73120	4998	1729720	1993-02-08	1993-02-17	1	8448
44225	2992	1124957	2012-05-17	2012-05-17	1	15477
77384	5290	1125315	1956-09-21	1956-10-05	1	-4836
1181	80	1759842	1959-05-23	1959-05-30	1	-3869
46012	3123	1515774	1994-06-17	1995-06-12	1	9293
22673	1538	1112807	1932-04-06	1932-04-20	1	-13770
54126	3680	1125315	1984-09-04	1984-09-18	1	5374
27181	1837	1503184	1975-05-05	1976-04-29	1	2310
1567	102	1125315	1983-06-28	1983-08-02	1	4961
73121	4998	1729720	2008-04-13	2008-04-25	1	13994
44226	2992	1125315	1958-03-12	1958-03-26	1	-4299
77385	5290	1125315	1971-09-03	1971-09-03	1	610
1182	80	1112807	1938-08-01	1938-08-22	1	-11455
46013	3123	1551099	1978-02-02	1978-02-02	1	2954
22674	1538	1118084	1964-02-14	1964-02-14	1	-2148
54127	3680	1125315	2006-07-29	2006-08-12	1	13372
27182	1837	1503184	1978-04-19	1979-04-14	1	3390
1568	102	1177480	1994-06-10	1994-07-15	1	8961
73122	4998	1759842	2013-09-11	2013-09-25	1	15973
44227	2992	1125315	1971-10-30	1971-11-20	1	688
77386	5290	1129625	1955-11-27	1955-11-27	1	-5149
1183	80	1119510	1953-02-24	1953-03-10	1	-6141
46014	3123	19127890	1997-06-01	1998-05-27	1	10373
22675	1538	1307863	2008-05-05	2008-05-05	1	14004
54128	3680	1192710	1979-12-15	1979-12-15	1	3635
27183	1837	1551099	1964-01-23	1964-01-23	1	-2170
1569	102	1521369	1988-06-11	1989-06-06	1	7096
73123	4998	975125	2007-11-15	2007-12-06	1	13853
44228	2992	1125315	1983-01-10	1983-02-07	1	4785
77387	5290	1322184	2017-08-11	2017-08-11	1	17389
1184	80	1125315	1975-10-16	1975-10-23	1	2121
46015	3123	1112807	1993-07-03	1993-08-07	1	8619
22676	1538	1729720	1994-05-19	1994-05-31	1	8916
56265	3834	1112807	1959-11-12	1959-11-26	1	-3689
27184	1837	1729720	1962-09-04	1962-09-11	1	-2669
1570	102	1738521	1974-01-16	1974-01-30	1	1490
73124	4998	1119510	1967-02-27	1967-03-13	1	-1025
44229	2992	1125315	2000-10-07	2000-10-14	1	11244
77388	5290	1332418	2017-08-11	2017-08-11	1	17389
1185	80	1125315	1988-09-12	1988-10-17	1	6864
46016	3123	1177480	1982-12-26	1983-01-09	1	4756
22677	1538	1125315	1960-05-18	1960-05-25	1	-3508
56266	3834	1125315	1957-10-04	1957-10-18	1	-4458
27185	1837	1759842	2001-11-25	2001-12-16	1	11672
1571	102	1125315	1994-06-10	1994-06-10	1	8926
73125	4998	1149380	1968-10-15	1984-06-01	1	5265
44230	2992	1177480	1979-05-12	1979-06-09	1	3446
77389	5290	1728416	1956-09-21	1956-10-05	1	-4836
1186	80	1125315	2008-06-03	2008-06-17	1	14047
46017	3123	1177480	1988-09-06	1988-09-27	1	6844
22678	1538	1125315	1992-11-18	1992-12-02	1	8371
56267	3834	1125315	1966-08-24	1966-09-07	1	-1212
27186	1837	19127890	1978-04-19	1979-04-14	1	3390
1572	102	1503184	1992-05-21	1994-05-11	2	8896
73126	4998	1177480	2007-03-28	2007-04-18	1	13621
44231	2992	1717327	1962-12-03	1962-12-17	1	-2572
943	64	1118084	2009-03-03	2009-03-03	1	14306
1187	80	1713332	1955-04-18	1955-05-09	1	-5351
46018	3123	1519936	2008-04-04	2010-03-25	2	14693
22679	1538	1322184	2016-09-19	2016-09-19	1	17063
56268	3834	1125315	1967-06-15	1967-06-29	1	-917
27187	1837	738818	1961-01-10	1961-01-17	1	-3271
1573	102	1503184	1996-04-30	1997-04-25	1	9976
73127	4998	1759842	1973-12-25	1974-01-08	1	1468
44232	2992	1728416	1958-03-12	1958-03-26	1	-4299
944	64	1177480	1976-06-14	1976-06-28	1	2370
1188	80	1713332	1959-05-23	1959-05-30	1	-3869
46019	3123	1521369	2005-04-20	2006-04-15	1	13253
22680	1538	1326303	2008-05-05	2008-05-05	1	14004
56269	3834	1125315	2012-04-18	2012-05-02	1	15462
27188	1837	920293	1992-06-17	1992-06-24	1	8210
1574	102	1515774	1990-06-01	1992-05-21	2	8176
73128	4998	1759842	1975-04-12	1975-04-19	1	1934
44233	2992	1759842	2008-08-15	2008-08-29	1	14120
945	64	1521369	1994-09-18	1995-09-13	1	9386
1189	80	1759842	1950-03-24	1950-04-07	1	-7209
46020	3123	1521369	2007-04-10	2008-04-04	1	13973
22681	1538	1713332	2008-09-11	2008-09-25	1	14147
56270	3834	1361711	2003-08-10	2003-08-10	1	12274
27189	1837	933724	1992-06-17	1992-06-24	1	8210
1575	102	19127890	1988-06-11	1989-06-06	1	7096
73129	4998	19010482	1996-12-22	1997-01-05	1	9866
44234	2992	1118084	1991-12-29	1991-12-29	1	8032
946	64	1759842	1993-07-05	1993-07-26	1	8607
1190	80	1115008	2018-03-14	2018-04-11	1	17632
46021	3123	1713332	1982-12-26	1983-01-09	1	4756
22682	1538	1759842	2008-09-11	2008-09-25	1	14147
56271	3834	1112807	1963-10-03	1964-01-01	1	-2192
27190	1837	1119510	2015-07-02	2015-07-16	1	16632
1576	102	1124300	2008-12-03	2008-12-03	1	14216
73130	4998	738818	1967-02-27	1967-03-13	1	-1025
44235	2992	1125315	1966-08-29	1966-09-12	1	-1207
947	64	738818	1985-02-28	1985-03-14	1	5551
1191	80	1729720	1950-03-20	1950-03-29	1	-7218
46022	3123	1759842	1981-02-22	1981-03-01	1	4077
27632	1867	1119510	1983-04-28	1983-05-05	1	4872
56272	3834	1125315	2009-04-27	2009-05-04	1	14368
27191	1837	1125315	1961-01-10	1961-01-17	1	-3271
1577	102	1125315	1974-01-16	1974-01-30	1	1490
73131	4998	1125315	1967-02-27	1967-03-13	1	-1025
44236	2992	1729720	1968-09-27	1968-10-04	1	-454
948	64	1115008	2012-04-11	2012-05-09	1	15469
1192	80	1112807	1953-12-31	1954-01-14	1	-5831
46023	3123	1759842	2017-06-14	2017-06-28	1	17345
27633	1867	1125315	2018-06-21	2018-07-26	1	17738
56273	3834	1322184	2003-08-10	2003-08-10	1	12274
27192	1837	1125315	1961-08-06	1961-08-20	1	-3056
1578	102	1125315	2010-03-10	2010-03-24	1	14692
73132	4998	1713332	1973-12-25	1974-01-08	1	1468
44237	2992	1729720	1998-07-19	1998-07-28	1	10435
949	64	1125315	1985-02-28	1985-03-14	1	5551
1193	80	1118084	1974-09-16	1974-09-16	1	1719
42956	2906	1759842	1951-07-27	1951-08-10	1	-6719
27634	1867	1713332	1981-07-30	1981-08-13	1	4242
56274	3834	1332418	2003-08-10	2003-08-10	1	12274
27193	1837	1125315	1966-05-11	1966-05-18	1	-1324
1579	102	1713332	1989-07-03	1989-10-02	1	7214
73133	4998	1713332	1975-04-12	1975-04-19	1	1934
44238	2992	1112807	1962-12-03	1962-12-17	1	-2572
950	64	1717327	1976-06-14	1976-06-28	1	2370
1194	80	1729720	1951-03-25	1951-04-06	1	-6845
42957	2906	701322	2010-05-09	2010-05-09	1	14738
27635	1867	1717327	1977-01-13	1977-01-27	1	2583
56275	3834	1539403	2003-08-10	2003-08-10	1	12274
27194	1837	1125315	1976-05-17	1976-06-16	1	2358
1580	102	1759842	1989-07-03	1989-10-02	1	7214
73134	4998	1713332	2013-09-11	2013-09-25	1	15973
44239	2992	1119510	2000-10-07	2000-10-14	1	11244
951	64	1119510	1985-02-28	1985-03-14	1	5551
1195	80	1729720	1986-08-29	1986-09-09	1	6095
42958	2906	757627	2009-06-13	2009-06-13	1	14408
27636	1867	1728416	1978-05-06	1978-05-20	1	3061
56276	3834	1728416	1959-11-12	1959-11-26	1	-3689
27195	1837	1729720	2016-11-21	2016-11-28	1	17133
1581	102	19127890	1990-06-01	1994-05-11	4	8896
73135	4998	19010482	1987-08-24	1987-09-07	1	6458
44240	2992	1125315	1983-11-09	1983-11-16	1	5067
952	64	1125315	2003-10-05	2003-10-26	1	12351
2832	188	1115008	2011-10-30	2011-11-20	1	15298
42959	2906	1112807	1929-01-23	1929-03-24	1	-14893
27637	1867	1177480	1974-07-23	1974-08-06	1	1678
56277	3834	1729720	1989-12-21	1989-12-31	1	7304
27196	1837	19127890	1975-05-05	1976-04-29	1	2310
1582	102	19127890	1996-04-30	1997-04-25	1	9976
73136	4998	19010482	2007-11-15	2007-12-06	1	13853
44241	2992	1125315	1995-03-19	1995-03-26	1	9215
953	64	1503184	1994-09-18	1995-09-13	1	9386
2833	188	1125315	1988-10-22	1988-10-29	1	6876
42960	2906	1112807	1934-08-25	1934-10-24	1	-12853
27638	1867	1729720	1972-11-20	1972-12-03	1	1067
56278	3834	1729720	2005-03-09	2005-03-18	1	12860
27197	1837	738818	1971-06-07	1971-06-21	1	536
6295	437	738818	2002-09-23	2002-10-07	1	11967
74618	5104	1118084	2017-06-15	2017-06-15	1	17332
44242	2992	1125315	2016-06-30	2016-07-14	1	16996
954	64	19127890	1989-10-14	1990-10-09	1	7586
2834	188	1729720	2018-04-17	2018-04-28	1	17649
42961	2906	1112807	1941-05-25	1941-06-15	1	-10427
27639	1867	1759842	1973-07-24	1973-07-31	1	1307
56279	3834	1713332	1957-07-11	1957-07-18	1	-4550
27198	1837	1112807	1965-02-16	1965-05-17	1	-1690
6296	437	920293	1978-03-01	1978-03-15	2	2995
74619	5104	1177480	1987-04-08	1987-07-07	1	6396
44243	2992	1177480	2007-07-01	2007-07-22	1	13716
955	64	19127890	1992-09-28	1993-09-23	1	8666
2835	188	1759842	1997-04-13	1997-04-27	1	9978
42962	2906	1112807	1956-11-23	1957-01-22	1	-4727
27640	1867	738818	1983-04-28	1983-05-05	1	4872
56280	3834	1759842	1971-10-13	1972-02-02	1	762
27199	1837	1125315	1971-06-07	1971-06-21	1	536
6297	437	933724	1978-03-01	1978-03-15	1	2995
74620	5104	1177480	1988-07-31	1988-08-21	1	6807
44244	2992	1177480	2012-05-17	2012-08-15	1	15567
956	64	1177480	2000-08-07	2000-08-21	1	11190
2836	188	738818	1981-09-10	1981-09-17	1	4277
42963	2906	1112807	1971-03-15	1971-03-29	1	452
27641	1867	1118084	2006-07-04	2006-07-04	1	13333
56281	3834	1124300	1994-06-27	1994-06-27	1	8943
27200	1837	1521369	1978-04-19	1979-04-14	1	3390
6298	437	1115008	2017-11-06	2018-01-05	1	17536
74621	5104	1759842	1991-09-09	1991-09-23	1	7935
44245	2992	1119510	2016-06-30	2016-07-14	1	16996
957	64	1515774	1989-10-14	1990-10-09	1	7586
2837	188	1125315	1981-09-10	1981-09-17	1	4277
42964	2906	1119510	1977-03-24	1977-04-07	1	2653
27642	1867	1125315	1977-07-29	1977-08-12	1	2780
56282	3834	1713332	1971-10-13	1972-02-02	1	762
27201	1837	1713332	2001-11-25	2001-12-16	1	11672
6299	437	1118084	1987-07-22	1987-07-22	1	6411
74622	5104	1768849	1980-06-29	1980-07-13	1	3846
44246	2992	1125315	1981-01-29	1981-02-19	1	4067
958	64	1515774	1992-09-28	1993-09-23	1	8666
2838	188	1125315	1986-10-27	1986-11-10	1	6157
42965	2906	1124300	1965-06-11	1965-06-11	1	-1665
27643	1867	1125315	1981-07-30	1981-08-13	1	4242
56283	3834	1717327	1966-08-24	1966-09-07	1	-1212
27202	1837	738818	2015-07-02	2015-07-16	1	16632
6300	437	1119510	2002-09-23	2002-10-07	1	11967
74623	5104	1177480	1980-09-09	1980-09-23	1	3918
44247	2992	1125315	2006-01-02	2006-01-09	1	13157
959	64	1549786	1989-10-14	1990-10-09	1	7586
2839	188	1125315	2012-04-08	2012-04-22	1	15452
42966	2906	1557272	2014-07-12	2014-07-12	1	16263
27644	1867	1125315	1983-04-28	1983-05-05	1	4872
56284	3834	1728416	1957-10-04	1957-10-18	1	-4458
27203	1837	1119510	1961-01-10	1961-01-17	1	-3271
6301	437	1124957	2017-11-06	2017-11-06	1	17476
74624	5104	1125315	1980-06-29	1980-07-13	1	3846
44248	2992	1125315	2012-05-17	2012-05-17	1	15477
960	64	1549786	1992-09-28	1993-09-23	1	8666
2840	188	1729720	1967-10-25	1967-11-07	1	-786
42967	2906	1713332	1971-09-15	1971-09-22	1	629
27645	1867	1125315	1990-08-17	1990-10-16	1	7593
56285	3834	1729720	1965-07-27	1965-08-04	1	-1611
27204	1837	1125315	1974-04-30	1974-05-28	1	1608
6302	437	1125315	1950-01-23	1950-02-06	1	-7269
74625	5104	1713332	1980-09-09	1980-09-23	1	3918
44249	2992	1177480	2009-04-12	2009-05-03	1	14367
961	64	1713332	1993-07-05	1993-07-26	1	8607
2841	188	1125315	1986-03-28	1986-04-04	1	5937
42968	2906	1713332	2009-09-30	2009-10-14	1	14531
27646	1867	1177480	1977-01-13	1977-01-27	1	2583
56286	3834	1759842	1957-07-11	1957-07-18	1	-4550
27205	1837	1125315	1990-04-23	1990-04-30	1	7424
6303	437	1125315	2002-09-23	2002-10-07	1	11967
74626	5104	1713332	2011-11-29	2011-12-20	1	15328
44250	2992	1322184	2011-08-19	2011-08-19	1	15205
962	64	19127890	1994-09-18	1995-09-13	1	9386
2842	188	1177480	1975-09-11	1975-09-25	1	2093
42969	2906	1729720	1962-10-04	1962-10-16	1	-2634
27647	1867	1713332	1973-07-24	1973-07-31	1	1307
56950	3881	1112807	1960-06-30	1960-07-14	1	-3458
27206	1837	1125315	2015-07-02	2015-07-16	1	16632
6304	437	1125315	2007-07-06	2007-08-03	1	13728
74627	5104	1759842	2011-11-29	2011-12-20	1	15328
44251	2992	1347450	2011-08-19	2011-08-19	1	15205
5851	403	1112807	1924-02-29	1924-03-14	1	-16729
2843	188	1118084	1999-11-24	1999-11-24	1	10919
42970	2906	1729720	2004-06-10	2004-06-18	1	12587
27648	1867	1713332	1982-07-17	1982-07-31	1	4594
56951	3881	1112807	1960-11-27	1961-01-26	1	-3262
27207	1837	1521369	1975-05-05	1976-04-29	1	2310
6305	437	1713332	1976-01-04	1976-01-25	1	2215
74628	5104	1177480	1986-05-29	1986-06-12	1	6006
44252	2992	1713332	2008-08-15	2008-08-29	1	14120
5852	403	1112807	1968-08-29	1968-11-27	1	-400
2844	188	1119510	1981-09-10	1981-09-17	1	4277
42971	2906	920293	1982-06-13	1982-06-20	1	4553
27649	1867	1717327	1974-07-23	1974-08-06	1	1678
56952	3881	1125315	1981-12-05	1981-12-26	1	4377
27208	1837	1717327	1961-08-06	1961-08-20	1	-3056
6306	437	1713332	1985-10-16	1985-10-30	1	5781
74629	5104	1713332	1991-09-09	1991-09-23	1	7935
44514	3014	1118084	2012-11-06	2012-11-06	1	15650
5853	403	1112807	1991-08-29	1991-10-28	1	7970
2845	188	1125315	1968-08-18	1968-09-01	1	-487
42972	2906	933724	1982-06-13	1982-06-20	1	4553
27650	1867	1728416	1977-07-29	1977-08-12	1	2780
56953	3881	1125315	2013-01-03	2013-01-10	1	15715
27209	1837	1729720	1974-03-27	1974-04-04	1	1554
6307	437	1759842	1959-11-10	1959-11-17	1	-3698
74630	5104	1778162	1988-07-31	1988-08-21	1	6807
44515	3014	1125315	1974-04-26	1974-05-10	1	1590
5854	403	1118084	1962-01-03	1962-01-03	1	-2920
2846	188	1713332	1997-04-13	1997-04-27	1	9978
42973	2906	1112807	1925-05-19	1925-06-02	1	-16284
27651	1867	1738521	1973-03-19	1973-04-02	1	1187
56954	3881	1125315	2017-04-10	2017-04-24	1	17280
29155	1975	723013	1973-01-29	1973-01-29	1	1124
6308	437	1759842	1985-10-16	1985-10-30	1	5781
75990	5200	738818	1966-02-08	1966-02-15	1	-1416
2017	135	738818	2017-11-14	2017-11-21	1	17491
5855	403	1125315	1951-12-18	1952-01-01	1	-6575
2847	188	1728416	1968-08-18	1968-09-01	1	-487
42974	2906	1112807	1940-05-09	1940-05-30	1	-10808
27652	1867	1759842	1982-07-17	1982-07-31	1	4594
56955	3881	1177480	1978-12-23	1979-01-20	1	3306
29156	1975	1112807	1923-01-07	1923-02-06	1	-17131
6309	437	1112807	1960-11-25	1960-12-09	1	-3310
75991	5200	975125	1982-08-21	1982-08-21	1	4615
2018	135	1125315	2005-11-09	2005-12-07	1	13124
5856	403	1177480	1988-08-14	1988-09-13	1	6830
3051	202	757627	2016-01-02	2016-01-02	1	16802
42975	2906	1125315	1977-03-24	1977-04-07	1	2653
27653	1867	1125315	1973-03-19	1973-04-02	1	1187
56956	3881	1361711	1986-11-07	1986-11-07	1	6154
29157	1975	1112807	1928-08-22	1928-11-07	1	-15030
6310	437	1125315	2017-11-06	2017-11-06	1	17476
75992	5200	1125315	1966-02-08	1966-02-15	1	-1416
2019	135	1125315	2017-11-14	2017-11-21	1	17491
5857	403	1177480	1996-08-02	1996-08-23	1	9731
3052	202	1118084	1982-02-16	1982-02-16	1	4429
42976	2906	1713332	1985-05-31	1985-06-14	1	5643
27654	1867	1177480	1978-05-06	1978-05-20	1	3061
56957	3881	1713332	2013-02-03	2013-02-17	1	15753
29158	1975	1713332	1931-12-28	1932-01-18	1	-13863
6311	437	1112807	1947-06-07	1947-06-21	1	-8230
75993	5200	1125315	1982-03-31	1982-04-21	1	4493
2020	135	1515774	1990-05-16	1991-05-11	1	7800
5858	403	1177480	2018-01-30	2018-02-13	1	17575
3053	202	1125315	1948-12-18	1949-01-01	1	-7670
42977	2906	1729720	1947-07-11	1947-07-24	1	-8197
32102	2173	738818	1997-02-27	1997-03-06	1	9926
56958	3881	1759842	2013-02-03	2013-02-17	1	15753
29159	1975	1713332	1948-02-19	1948-03-04	1	-7973
6312	437	1115008	2010-05-19	2010-06-16	1	14776
75994	5200	1118084	1989-01-25	1989-01-25	1	6964
2021	135	1713332	1997-06-28	1997-07-19	1	10061
5859	403	1713332	2008-12-14	2008-12-28	1	14241
3054	202	1125315	1971-07-29	1971-08-12	1	588
42978	2906	1759842	1971-09-15	1971-09-22	1	629
32103	2173	1112807	1940-10-13	1940-11-12	1	-10642
56959	3881	914335	1997-01-03	1997-01-03	1	9864
29160	1975	1759842	1938-05-23	1938-06-06	1	-11532
6313	437	1125315	1951-08-30	1951-09-13	1	-6685
75995	5200	1119510	1961-04-18	1961-05-02	1	-3166
2022	135	1759842	1997-06-28	1997-07-19	1	10061
5860	403	1729720	1926-03-10	1926-03-22	1	-15991
3055	202	1125315	2015-10-18	2015-11-15	1	16754
46619	3168	1115008	2007-10-22	2007-11-19	1	13836
32104	2173	1112807	1942-08-04	1942-10-23	1	-9932
56960	3881	1118084	1992-08-31	1992-08-31	1	8278
29161	1975	1118084	1957-04-23	1957-04-23	1	-4636
6314	437	1713332	1959-11-10	1959-11-17	1	-3698
75996	5200	1119510	1968-05-24	1968-06-07	1	-573
2023	135	1118084	2009-11-27	2009-11-27	1	14575
5861	403	1759842	2008-12-14	2008-12-28	1	14241
3056	202	1347450	1997-10-25	1997-10-25	1	10159
46620	3168	1125315	1981-12-09	1982-01-08	1	4390
32105	2173	1118084	1975-02-17	1975-02-17	1	1873
56961	3881	1125315	1998-01-13	1998-01-20	1	10246
29162	1975	1729720	1952-11-21	1952-12-04	1	-6237
6315	437	1728416	1951-08-30	1951-09-13	1	-6685
75997	5200	1125315	1960-06-21	1960-07-05	1	-3467
2024	135	1125315	1980-01-29	1980-02-26	1	3708
5862	403	1112807	1922-07-27	1922-08-10	1	-17311
3057	202	701322	2016-11-27	2016-11-27	1	17132
46621	3168	1125315	2012-06-09	2012-06-16	1	15507
32106	2173	1124957	1942-08-04	1942-08-04	1	-10012
56962	3881	1125315	2015-11-28	2015-12-12	1	16781
29163	1975	1112807	1924-10-28	1924-11-11	1	-16487
6316	437	1759842	1976-01-04	1976-01-25	1	2215
75998	5200	1728416	1960-06-21	1960-07-05	1	-3467
2025	135	1125315	1988-12-10	1989-03-10	1	7008
5863	403	1112807	1925-05-01	1925-05-15	1	-16302
3058	202	1112807	1940-05-02	1940-05-23	1	-10815
46622	3168	1118084	2015-09-27	2015-09-27	1	16705
32107	2173	1125315	1959-08-07	1959-08-14	1	-3793
56963	3881	1309944	1997-01-03	1997-01-03	1	9864
29164	1975	1112807	1927-04-16	1927-04-30	1	-15587
8885	613	933724	1989-01-29	1989-02-05	1	6975
75999	5200	1112807	1960-08-20	1960-09-03	1	-3407
2026	135	1125315	2001-01-06	2001-02-03	1	11356
5864	403	1112807	1946-03-28	1946-05-27	1	-8620
3059	202	1125315	2013-06-10	2013-06-17	1	15873
46623	3168	1125315	2003-10-17	2003-10-24	1	12349
32108	2173	1125315	1960-03-02	1960-03-23	1	-3571
56964	3881	1343916	1997-01-03	1997-01-03	1	9864
29165	1975	1713332	1938-05-23	1938-06-06	1	-11532
8886	613	1119510	1951-07-25	1951-08-01	1	-6728
76000	5200	1125315	1995-01-27	1995-02-03	1	9164
2027	135	1125315	2010-10-21	2010-10-28	1	14910
5865	403	1119510	1935-01-04	1935-01-11	1	-12774
3060	202	1713332	2010-03-04	2010-03-25	1	14693
46624	3168	1759842	2015-10-30	2015-11-13	1	16752
32109	2173	1125315	1997-02-27	1997-03-06	1	9926
56965	3881	1729720	1958-07-14	1958-07-25	1	-4178
29166	1975	1729720	1961-09-21	1961-09-30	1	-3015
8887	613	1119510	2015-05-15	2015-05-29	1	16584
76001	5200	1150770	1982-09-04	1982-09-04	1	4629
2028	135	19127890	1990-05-16	1991-05-11	1	7800
5866	403	1125315	1992-11-09	1992-11-23	1	8362
3061	202	1759842	2010-03-04	2010-03-25	1	14693
46625	3168	1115008	2003-02-17	2003-03-17	1	12128
32110	2173	1125315	2010-06-27	2010-09-02	1	14854
56966	3881	1759842	1975-03-15	1975-03-29	1	1913
29167	1975	1759842	1931-12-28	1932-01-18	1	-13863
8888	613	1124957	2007-03-07	2007-03-07	1	13579
76002	5200	1177480	1974-05-21	1974-06-11	1	1622
2029	135	1119510	2017-11-14	2017-11-21	1	17491
5867	403	1307863	1992-12-28	1992-12-28	1	8397
3062	202	1112807	1942-04-13	1942-05-18	1	-10090
46626	3168	1125315	2010-12-03	2011-03-03	1	15036
32111	2173	1125315	2012-08-27	2012-09-10	1	15593
56967	3881	1322184	1998-01-23	1998-01-23	1	10249
29168	1975	1729720	1932-07-22	1932-07-29	1	-13670
8889	613	738818	1951-07-25	1951-08-01	1	-6728
76003	5200	738818	1961-04-18	1961-05-02	1	-3166
2030	135	1125315	2000-11-10	2000-11-24	1	11285
5868	403	1729720	1934-03-27	1934-04-03	1	-13057
3063	202	1112807	1951-09-28	1951-10-12	1	-6656
46627	3168	1729720	1988-09-07	1988-09-18	1	6835
32112	2173	1713332	1996-12-12	1997-01-02	1	9863
56968	3881	1713332	1975-03-15	1975-03-29	1	1913
29169	1975	1759842	1948-02-19	1948-03-04	1	-7973
8890	613	920293	1995-03-20	1995-03-27	1	9216
76004	5200	738818	1968-05-24	1968-06-07	1	-573
2031	135	1125315	2016-05-15	2016-05-22	1	16943
5869	403	1759842	1950-11-06	1950-11-13	1	-6989
3064	202	1125315	1964-03-11	1964-03-18	1	-2115
46628	3168	1102527	2008-10-14	2008-10-14	1	14166
32113	2173	1713332	2009-04-07	2009-04-21	1	14355
56969	3881	1728416	1960-06-30	1960-07-14	1	-3458
30644	2075	738818	2000-09-14	2000-09-21	1	11221
8891	613	933724	1995-03-20	1995-03-27	1	9216
76005	5200	1119510	1966-02-08	1966-02-15	1	-1416
2032	135	1549786	1990-05-16	1991-05-11	1	7800
5870	403	738818	1935-01-04	1935-01-11	1	-12774
3065	202	1322184	1997-10-25	1997-10-25	1	10159
46629	3168	1115008	2008-10-14	2009-01-12	1	14256
32114	2173	1729720	1998-09-09	1998-09-20	1	10489
56970	3881	1729720	2011-07-11	2011-07-20	1	15175
30645	2075	1119510	2019-04-03	2019-04-10	1	17996
8892	613	1125315	1951-07-25	1951-08-01	1	-6728
76006	5200	1125315	1961-04-18	1961-05-02	1	-3166
2033	135	1102527	1988-12-10	1988-12-10	1	6918
5871	403	1112807	1929-07-20	1929-08-03	1	-14761
3066	202	1729720	1989-07-02	1989-07-13	1	7133
46630	3168	1125315	1987-03-13	1987-06-11	1	6370
32115	2173	1729720	1938-07-21	1938-08-01	1	-11476
56971	3881	1115008	1998-05-31	1998-06-21	1	10398
30646	2075	1125315	1993-05-08	1993-05-22	1	8542
8893	613	1125315	2007-03-07	2007-03-07	1	13579
76007	5200	1125315	1968-05-24	1968-06-07	1	-573
4997	340	1115008	2001-05-03	2001-06-02	1	11475
5872	403	1125315	1929-02-11	1929-02-18	1	-14927
3067	202	1759842	1953-12-24	1954-01-14	1	-5831
46631	3168	1713332	2015-10-30	2015-11-13	1	16752
32116	2173	1759842	1949-07-07	1949-07-28	1	-7462
56972	3881	1332418	1994-01-21	1994-01-21	1	8786
30647	2075	1125315	2000-09-14	2000-09-21	1	11221
8894	613	1125315	2007-08-07	2007-08-21	1	13746
76008	5200	1125315	1972-07-02	1972-07-30	1	941
4998	340	1118084	1995-06-24	1995-06-24	1	9305
5873	403	1125315	1935-01-04	1935-01-11	1	-12774
3068	202	715997	2016-11-27	2016-11-27	1	17132
47275	3212	920293	2016-09-02	2016-09-09	1	17053
32117	2173	1759842	1974-11-21	1974-12-05	1	1799
56973	3881	1539403	1992-11-13	1992-11-13	1	8352
30648	2075	1125315	2019-04-03	2019-04-15	2	17996
8895	613	1557272	2016-05-27	2016-05-27	1	16948
76009	5200	1177480	2005-07-31	2005-08-14	1	13009
4999	340	1174888	2001-05-03	2001-05-03	1	11445
5874	403	1125315	2019-01-09	2019-01-23	1	17919
3069	202	1115008	2008-09-26	2008-10-24	1	14176
47276	3212	933724	2016-09-02	2016-09-09	1	17053
32118	2173	1112807	1934-11-14	1934-11-28	1	-12818
57698	3935	1112807	1958-05-25	1958-06-15	1	-4218
30649	2075	1129625	1968-12-20	1968-12-20	1	-377
8896	613	1759842	1978-06-13	1978-07-04	1	3106
76010	5200	1713332	2019-04-20	2019-05-04	1	18020
5000	340	1177480	2007-10-29	2007-11-26	1	13843
5875	403	1310149	1992-12-28	1992-12-28	1	8397
3070	202	1125315	1998-01-30	1998-02-06	1	10263
47277	3212	1110410	2018-07-21	2018-07-21	1	17733
32119	2173	1713332	1991-03-10	1991-03-17	1	7745
57699	3935	1112807	1961-05-30	1961-07-04	1	-3103
30650	2075	1717327	1966-07-28	1966-08-11	1	-1239
8897	613	920293	1989-01-29	1989-02-05	1	6975
76011	5200	1759842	2019-04-20	2019-05-04	1	18020
5001	340	1713332	2014-01-11	2014-01-25	1	16095
5876	403	1729720	1932-12-16	1932-12-28	1	-13518
3071	202	1125315	2014-11-18	2014-12-02	1	16406
47278	3212	1125315	1987-05-30	1987-06-13	1	6372
32120	2173	1759842	1991-03-10	1991-03-17	1	7745
57700	3935	1125315	1958-01-15	1958-01-22	1	-4362
30651	2075	1112807	1966-07-28	1966-08-11	1	-1239
8898	613	1124300	1977-01-23	1977-01-23	1	2579
77864	5322	738818	1964-02-24	1964-03-09	1	-2124
5002	340	1759842	2014-01-11	2014-01-25	1	16095
5877	403	1729720	1936-08-22	1936-09-04	1	-12172
3072	202	1713332	1953-12-24	1954-01-14	1	-5831
47279	3212	1125315	1988-07-09	1988-07-16	1	6771
32121	2173	1119510	1997-02-27	1997-03-06	1	9926
57701	3935	1125315	1987-05-16	1987-05-30	1	6358
30652	2075	1119510	2000-09-14	2000-09-21	1	11221
8899	613	1713332	2002-02-12	2002-03-05	1	11751
77865	5322	1112807	1949-08-28	1949-09-11	1	-7417
5003	340	1112807	1963-11-14	1963-12-19	1	-2205
5878	403	1102527	1946-03-28	1946-03-28	1	-8680
5641	387	1115008	2011-03-27	2011-05-01	1	15095
47280	3212	1125315	1991-09-30	1991-10-14	1	7956
32122	2173	1125315	1942-08-04	1942-08-04	1	-10012
57702	3935	1713332	1958-03-16	1958-03-30	1	-4295
30653	2075	1125315	1980-06-14	1980-07-19	1	3852
8900	613	1759842	2002-02-12	2002-03-05	1	11751
77866	5322	1125315	1964-02-24	1964-03-09	1	-2124
5004	340	1125315	1996-02-26	1996-03-11	1	9566
5879	403	1112807	1939-10-10	1939-10-31	1	-11020
5642	387	1119510	1980-04-16	1980-04-23	1	3765
47281	3212	1125315	1992-11-08	1992-11-22	1	8361
32123	2173	1177480	1987-07-30	1987-08-27	1	6447
57703	3935	1729720	1987-10-23	1987-11-01	1	6513
30654	2075	1125315	2017-05-04	2017-05-25	1	17311
8901	613	738818	2015-05-15	2015-05-29	1	16584
77867	5322	1154343	1951-01-28	1951-01-28	1	-6913
5005	340	1125315	2001-05-03	2001-05-03	1	11445
5880	403	1125315	1926-02-07	1926-02-21	1	-16020
5643	387	1125315	1974-08-26	1974-10-25	1	1758
47282	3212	1125315	1996-05-15	1996-06-19	1	9666
32124	2173	1713332	1949-07-07	1949-07-28	1	-7462
57704	3935	1759842	1986-06-06	1986-06-20	1	6014
30655	2075	1729720	1982-06-07	1982-06-20	1	4553
8902	613	920293	1987-12-19	1987-12-26	1	6568
77868	5322	1713332	2014-06-28	2014-07-12	1	16263
6353	440	1125315	1975-11-28	1975-12-26	1	2185
5881	403	1326303	1992-12-28	1992-12-28	1	8397
5644	387	1125315	1975-08-22	1975-09-05	1	2073
47283	3212	1125315	2018-07-21	2018-07-21	1	17733
32125	2173	1713332	1974-11-21	1974-12-05	1	1799
57705	3935	1347450	1990-10-24	1990-10-24	1	7601
30656	2075	1759842	1973-10-14	1973-10-21	1	1389
8903	613	933724	1987-12-19	1987-12-26	1	6568
77869	5322	1728416	1947-06-21	1947-07-05	1	-8216
6354	440	1515774	1990-11-19	1991-11-14	1	7987
5882	403	1713332	1935-08-08	1935-08-22	1	-12551
5645	387	1177480	1987-07-19	1987-08-16	1	6436
47284	3212	1515774	1999-07-04	2000-06-28	1	11136
32126	2173	1729720	1934-05-29	1934-06-09	1	-12990
57706	3935	1759842	1958-03-16	1958-03-30	1	-4295
30657	2075	738818	2019-04-03	2019-04-10	1	17996
8904	613	1112807	1937-10-05	1937-10-19	1	-11762
77870	5322	1759842	1967-03-14	1967-03-21	1	-1017
6355	440	1713332	2016-08-11	2016-08-25	1	17038
5883	403	1713332	1950-11-06	1950-11-13	1	-6989
5646	387	1112807	1977-12-22	1978-01-05	1	2926
47285	3212	19016749	2018-07-21	2018-07-21	1	17733
32127	2173	1759842	1996-12-12	1997-01-02	1	9863
57707	3935	1118084	1982-10-16	1982-10-16	1	4671
30658	2075	1118084	2006-03-10	2006-03-10	1	13217
8905	613	1115008	2002-04-18	2002-05-02	1	11809
77871	5322	1759842	2014-06-28	2014-07-12	1	16263
6356	440	1729720	1997-03-23	1997-04-01	1	9952
5884	403	1713332	1984-04-14	1984-04-21	1	5224
5647	387	1125315	1976-01-18	1976-02-01	1	2222
47286	3212	705944	1992-07-25	1999-08-03	1	10806
32128	2173	1759842	2009-04-07	2009-04-21	1	14355
57708	3935	1125315	1952-02-28	1952-03-13	1	-6503
30659	2075	1177480	2019-04-15	2019-04-15	1	18001
8906	613	1125315	1992-08-17	1992-09-07	1	8285
77872	5322	975125	1957-02-13	1957-03-06	1	-4684
6357	440	1759842	2016-08-11	2016-08-25	1	17038
5885	403	1729720	1983-01-31	1983-02-08	1	4786
5648	387	1125315	1991-08-25	1991-09-08	1	7920
47287	3212	1119510	1991-09-30	1991-10-14	1	7956
34837	2356	705944	1988-10-30	1990-06-17	1	7472
57709	3935	1125315	1964-06-20	1964-06-27	1	-2014
30660	2075	1713332	1973-10-14	1973-10-21	1	1389
8907	613	1125315	2015-05-15	2015-05-29	1	16584
77873	5322	1112807	1947-06-21	1947-07-05	1	-8216
6358	440	1125315	1983-09-18	1983-09-25	1	5015
5886	403	1759842	1935-08-08	1935-08-22	1	-12551
5649	387	1521369	1988-08-22	1989-08-17	1	7168
47288	3212	1119510	1995-09-18	1995-10-02	1	9405
34838	2356	1118084	2017-02-10	2017-02-10	1	17207
57710	3935	1125315	1968-05-28	1968-06-25	1	-555
30661	2075	1124957	2019-04-15	2019-04-15	1	18001
8908	613	1177480	2007-03-07	2007-05-06	1	13639
77874	5322	1125315	2014-03-18	2014-05-17	1	16207
6359	440	1521369	1987-12-05	1989-11-24	2	7267
5887	403	1759842	1984-04-14	1984-04-21	1	5224
5650	387	1717327	1977-12-22	1978-01-05	1	2926
47289	3212	1125315	1986-08-31	1986-10-05	1	6121
34839	2356	1115008	2017-05-25	2017-06-15	1	17332
57711	3935	1177480	1983-02-07	1983-02-21	1	4799
30662	2075	1125315	1970-06-20	1970-07-04	1	184
8909	613	1713332	1978-06-13	1978-07-04	1	3106
77875	5322	1129625	1950-02-11	1950-02-11	1	-7264
6360	440	1713332	1983-03-14	1983-03-21	1	4827
8115	565	1124300	1994-09-28	1994-09-28	1	9036
5651	387	1729720	1979-05-18	1979-05-31	1	3437
47290	3212	1746114	2018-07-21	2018-07-21	1	17733
34840	2356	1125315	1984-06-28	1984-07-12	1	5306
57712	3935	1713332	1986-06-06	1986-06-20	1	6014
30663	2075	1177480	2012-06-01	2012-06-29	1	15520
8910	613	1729720	1949-08-07	1949-08-18	1	-7441
77876	5322	1149380	1951-01-28	1951-01-28	1	-6913
6361	440	1115008	2006-01-06	2006-01-20	1	13168
8116	565	1125315	1962-06-13	1962-06-27	1	-2745
5652	387	19127890	1991-08-07	1992-08-01	1	8248
47291	3212	708298	2018-07-21	2018-07-21	1	17733
34841	2356	1115008	1998-12-26	1999-01-30	1	10621
58986	4019	738818	1974-01-29	1974-02-12	1	1503
30664	2075	1551099	1967-04-24	1967-04-24	1	-983
8911	613	1729720	1970-01-03	1970-01-11	1	10
77877	5322	1177480	2000-09-29	2000-10-27	1	11257
6362	440	1118084	2009-02-17	2009-02-17	1	14292
8117	565	1125315	1962-10-07	1962-10-21	1	-2629
5653	387	738818	1980-04-16	1980-04-23	1	3765
47292	3212	738818	1991-09-30	1991-10-14	1	7956
34842	2356	1125315	2015-12-14	2015-12-28	1	16797
58987	4019	738818	1992-07-22	1992-08-05	1	8252
30665	2075	1738521	1970-06-20	1970-07-04	1	184
9404	649	1177480	1978-04-26	1978-06-25	1	3097
77878	5322	1713332	1967-03-14	1967-03-21	1	-1017
6363	440	1500211	1994-10-29	1995-10-24	1	9427
8118	565	1729720	1974-01-13	1974-01-25	1	1485
5654	387	1118084	2016-07-06	2016-07-06	1	16988
47293	3212	738818	1995-09-18	1995-10-02	1	9405
34843	2356	1713332	2007-10-15	2007-10-22	1	13808
58988	4019	1119510	2012-03-06	2012-03-20	1	15419
32189	2177	1125315	1971-04-16	1971-04-23	1	477
9405	649	1119510	1973-08-16	1973-08-23	1	1330
77879	5322	1728416	1949-08-28	1949-09-11	1	-7417
6364	440	1503184	1987-12-05	1989-11-24	2	7267
8119	565	1759842	1982-08-31	1982-09-14	1	4639
5655	387	1125315	1980-04-16	1980-04-23	1	3765
47294	3212	967823	2018-07-21	2018-07-21	1	17733
34844	2356	1759842	2007-10-15	2007-10-22	1	13808
58989	4019	1124300	2005-04-30	2005-04-30	1	12903
32190	2177	1713332	1993-02-04	1993-02-11	1	8442
9406	649	1125315	2010-03-23	2010-04-06	1	14705
77880	5322	1759842	1993-01-27	1993-02-10	1	8441
6365	440	1549786	1990-11-19	1991-11-14	1	7987
8120	565	1112807	1958-07-19	1958-08-02	1	-4170
5656	387	1125315	1998-04-04	1998-07-03	2	10410
47295	3212	1000560	2018-07-21	2018-07-21	2	17733
34845	2356	1177480	1985-02-23	1985-03-09	1	5546
58990	4019	1125315	1974-01-29	1974-02-12	1	1503
32191	2177	1713332	2012-01-11	2012-01-18	1	15357
9407	649	1729720	1975-09-19	1975-10-02	1	2100
77881	5322	1112807	1949-01-23	1949-02-06	1	-7634
6366	440	1713332	1982-02-01	1982-02-08	1	4421
8121	565	1125315	1967-12-12	1967-12-19	1	-744
5657	387	1503184	1988-08-22	1989-08-17	1	7168
47296	3212	1118084	2018-05-10	2018-05-10	1	17661
39504	2686	738818	2005-07-09	2005-07-23	1	12987
58991	4019	1125315	1988-04-05	1988-04-12	1	6676
32192	2177	1177480	2002-09-17	2002-10-15	1	11975
9408	649	1738521	1970-07-02	1970-07-16	1	196
77882	5322	1112807	1962-02-02	1962-03-02	1	-2862
6367	440	1713332	2005-09-08	2005-09-29	1	13055
8122	565	1125315	1980-07-14	1980-07-28	1	3861
5658	387	1503184	1991-08-07	1992-08-01	1	8248
47297	3212	1125315	1995-09-18	1995-10-02	1	9405
39505	2686	1112807	1972-10-20	1972-11-10	1	1044
58992	4019	1125315	1992-07-22	1992-08-05	1	8252
32193	2177	1728416	1971-05-17	1971-05-31	1	515
9409	649	738818	1973-08-16	1973-08-23	1	1330
77883	5322	1112807	1985-11-26	1985-12-17	1	5829
6368	440	1738521	1974-06-06	1974-06-20	1	1631
8123	565	1728416	1958-10-31	1958-11-14	1	-4066
5659	387	1124957	1998-04-04	1998-04-04	1	10320
47298	3212	1125315	2009-04-30	2009-05-14	1	14378
39506	2686	1119510	2005-07-09	2005-07-23	1	12987
58993	4019	1112807	1987-10-31	1987-11-21	1	6533
32194	2177	1112807	1971-05-17	1971-05-31	1	515
9410	649	1112807	1970-07-02	1970-07-16	1	196
77884	5322	1119510	1964-02-24	1964-03-09	1	-2124
6369	440	1759842	1982-02-01	1982-02-08	1	4421
8124	565	1728416	1962-06-13	1962-06-27	1	-2745
5660	387	1521369	1991-08-07	1992-08-01	1	8248
47299	3212	1367571	2018-07-21	2018-07-21	1	17733
39507	2686	1125315	1969-09-07	1969-09-14	1	-109
58994	4019	1125315	1991-05-04	1991-08-02	2	7883
32195	2177	1124300	2005-06-03	2005-06-03	1	12937
9411	649	1124300	2007-05-29	2007-05-29	1	13662
77885	5322	1124300	1982-06-02	1982-06-02	1	4535
6370	440	1759842	2005-09-08	2005-09-29	1	13055
8125	565	1729720	1963-02-24	1963-03-08	1	-2491
5661	387	1738521	1976-01-18	1976-02-01	1	2222
47300	3212	1549786	1999-07-04	2000-06-28	1	11136
39508	2686	1125315	1996-10-24	1996-11-07	1	9807
58995	4019	1717327	1966-11-06	1966-11-20	1	-1138
32196	2177	1125315	1990-09-12	1990-09-19	1	7566
9412	649	1125315	1973-08-16	1973-08-23	1	1330
77886	5322	1551099	1963-06-27	1963-06-27	1	-2380
6371	440	1112807	1974-06-06	1974-06-20	1	1631
8126	565	1112807	1958-10-31	1958-11-14	1	-4066
5662	387	19127890	1988-08-22	1989-08-17	1	7168
47301	3212	1741122	2018-07-21	2018-07-21	1	17733
39509	2686	1125315	2005-07-09	2005-07-23	1	12987
58996	4019	1729720	1968-01-04	1968-01-11	1	-721
32197	2177	1177480	1982-10-02	1982-10-31	1	4686
9413	649	1125315	1974-03-13	1974-04-17	1	1567
77887	5322	1713332	1985-08-29	1985-12-26	1	5838
6372	440	1125315	1994-03-07	1994-03-21	1	8845
8127	565	1125315	1960-12-07	1960-12-14	1	-3305
7892	549	920293	1986-08-31	1986-09-14	2	6100
47302	3212	19127890	1999-07-04	2000-06-28	1	11136
39510	2686	1177480	2009-12-10	2010-01-14	1	14623
58997	4019	1119510	1974-01-29	1974-02-12	1	1503
32198	2177	1717327	1969-03-13	1969-03-27	1	-280
9414	649	1729720	1979-09-12	1979-09-22	1	3551
77888	5322	1759842	1970-06-25	1970-07-16	1	196
6373	440	1759842	1983-03-14	1983-03-21	1	4827
8128	565	1125315	1963-05-15	1963-05-29	1	-2409
7893	549	933724	1986-08-31	1986-09-14	1	6100
47303	3212	753626	2018-07-21	2018-07-21	1	17733
39511	2686	1729720	2011-03-25	2011-04-04	1	15068
58998	4019	1119510	1992-07-22	1992-08-05	1	8252
32199	2177	1125315	1969-03-13	1969-03-27	1	-280
9415	649	1729720	1985-05-25	1985-06-04	1	5633
77889	5322	1759842	1985-08-29	1985-12-26	1	5838
6374	440	19127890	1987-12-05	1989-11-24	2	7267
8129	565	1713332	1982-08-31	1982-09-14	1	4639
7894	549	738818	1989-05-19	1989-06-02	1	7092
47304	3212	782043	2018-07-21	2018-07-21	1	17733
39512	2686	1118084	1995-02-28	1995-02-28	1	9189
58999	4019	738818	2012-03-06	2012-03-20	1	15419
32200	2177	1125315	1969-07-13	1969-07-27	1	-158
9416	649	914335	2011-01-25	2011-01-25	1	14999
77890	5322	975125	1958-04-03	1958-04-17	1	-4277
6375	440	19127890	1990-11-19	1991-11-14	1	7987
8130	565	1728416	1963-05-15	1963-05-29	1	-2409
7895	549	1125315	1989-05-19	1989-06-02	1	7092
47305	3212	1124957	2018-07-21	2018-07-21	1	17733
39513	2686	1125315	1994-03-20	1994-06-18	1	8934
59000	4019	1124957	1991-05-04	1991-05-04	1	7793
32201	2177	1759842	1993-02-04	1993-02-11	1	8442
9417	649	1112807	1972-11-18	1973-02-16	1	1142
77891	5322	1125315	1989-04-21	1989-04-28	1	7057
6697	462	19127890	1993-08-28	1994-08-23	1	9000
8131	565	1125315	1965-06-12	1965-07-17	1	-1629
7896	549	920293	1989-10-19	1989-10-26	1	7238
47306	3212	1125315	2000-12-10	2000-12-24	1	11315
39514	2686	1713332	1994-09-03	1994-09-17	1	9025
59001	4019	1125315	1966-11-06	1966-11-20	1	-1138
32202	2177	1759842	2012-01-11	2012-01-18	1	15357
9418	649	1309944	2011-01-25	2011-01-25	1	14999
77892	5322	1557272	2007-05-09	2007-05-09	1	13642
6698	462	738818	1981-06-23	1981-07-07	1	4205
8132	565	1728416	1958-07-19	1958-08-02	1	-4170
7897	549	933724	1989-10-19	1989-10-26	1	7238
47307	3212	1177480	2006-10-25	2006-11-22	1	13474
39515	2686	1112807	1967-12-02	1967-12-16	1	-747
59002	4019	1125315	2012-03-06	2012-03-20	1	15419
33809	2295	1119510	2001-03-12	2001-03-19	1	11400
9419	649	1343916	2011-01-25	2011-01-25	1	14999
77893	5322	1713332	1970-06-25	1970-07-16	1	196
6699	462	933724	1999-10-14	1999-10-21	1	10885
8342	579	1125315	1963-11-07	1963-11-21	1	-2233
7898	549	1119510	1989-05-19	1989-06-02	1	7092
47308	3212	19003953	2018-07-21	2018-07-21	1	17733
39516	2686	1125315	1956-11-01	1956-11-08	1	-4802
59003	4019	1177480	1979-12-28	1980-01-11	1	3662
33810	2295	1124300	2005-10-21	2005-10-21	1	13077
9420	649	1729720	1972-05-26	1972-06-02	1	883
77894	5322	1713332	1993-01-27	1993-02-10	1	8441
6700	462	1125315	1981-06-23	1981-07-07	1	4205
8343	579	1177480	2005-10-28	2005-12-02	1	13119
7899	549	1125315	1977-03-12	1977-04-16	1	2662
50255	3423	1125315	1986-10-28	1986-11-18	1	6165
39517	2686	1125315	1962-01-10	1962-01-24	1	-2899
62318	4253	1589505	2002-11-07	2003-11-02	1	12358
33811	2295	1177480	1980-07-29	1980-08-19	1	3883
11803	812	1124957	1979-09-01	1979-09-01	1	3530
77895	5322	1728416	1949-01-23	1949-02-06	1	-7634
6701	462	1125315	2009-12-01	2009-12-08	1	14586
8344	579	1729720	1973-09-23	1973-10-05	1	1373
7900	549	1125315	2014-08-31	2014-09-14	1	16327
50256	3423	1713332	1984-06-15	1984-06-22	1	5286
39518	2686	1125315	2001-04-17	2001-05-01	1	11443
62319	4253	1115008	2010-08-16	2010-08-30	1	14851
33812	2295	1713332	2006-04-25	2006-05-02	1	13270
11804	812	1125315	1970-01-07	1970-01-21	1	20
77896	5322	1729720	1994-02-18	1994-03-02	1	8826
6702	462	1549786	1993-08-28	1994-08-23	1	9000
8345	579	1729720	1996-09-21	1996-10-01	1	9770
7901	549	1177480	2011-04-18	2011-05-09	1	15103
50257	3423	1759842	1984-06-15	1984-06-22	1	5286
39519	2686	1713332	1997-08-09	1997-08-23	1	10096
62320	4253	1515774	1995-12-14	1997-12-03	2	10198
33813	2295	1713332	2007-08-30	2007-09-06	1	13762
11805	812	1125315	1979-09-01	1979-10-31	2	3590
77897	5322	1729720	2009-07-14	2009-07-24	1	14449
6703	462	1713332	1979-10-01	1979-10-15	1	3574
8346	579	738818	1994-03-30	1994-04-06	1	8861
7902	549	1112807	1953-05-26	1953-06-09	1	-6050
50258	3423	1119510	1992-04-16	1992-04-30	1	8155
39520	2686	1759842	1997-08-09	1997-08-23	1	10096
62321	4253	1549786	1995-12-14	1997-12-03	2	10198
33814	2295	1759842	2006-04-25	2006-05-02	1	13270
11806	812	1118084	2004-12-14	2004-12-14	1	12766
6704	462	738818	2002-02-03	2002-02-10	1	11728
8347	579	1125315	1993-08-31	1993-09-28	1	8671
7903	549	1118084	1987-12-04	1987-12-04	1	6546
50259	3423	1177480	1989-12-02	1989-12-16	1	7289
39521	2686	1125315	1966-07-12	1966-07-26	1	-1255
62322	4253	1595799	2001-11-12	2002-11-07	1	11998
33815	2295	1759842	2007-08-30	2007-09-06	1	13762
11807	812	1125315	1983-08-11	1983-08-25	1	4984
6705	462	1125315	1979-10-01	1979-10-15	1	3574
8348	579	1125315	1994-03-30	1994-04-06	1	8861
7904	549	1125315	1962-07-08	1962-07-29	1	-2713
50260	3423	1713332	1981-12-09	1981-12-23	1	4374
39522	2686	1177480	1998-06-27	1998-07-11	1	10418
62323	4253	1713332	2010-08-06	2010-11-11	1	14924
33816	2295	1125315	1976-06-07	1976-06-21	1	2363
11808	812	1125315	1988-09-30	1988-10-07	1	6854
6706	462	1125315	1986-09-16	1986-09-23	1	6109
8349	579	1713332	1986-02-08	1986-03-01	1	5903
7905	549	1729720	1958-09-01	1958-09-12	1	-4129
50261	3423	738818	2010-10-25	2010-11-01	1	14914
39523	2686	1759842	1994-09-03	1994-09-17	1	9025
62324	4253	1115008	1995-03-09	1995-04-07	1	9227
33817	2295	1125315	1994-09-16	1994-09-30	1	9038
11809	812	1125315	1996-09-26	1996-10-10	1	9779
6707	462	1125315	1992-06-17	1992-07-01	1	8217
8350	579	1713332	1988-07-11	1988-08-01	1	6787
10214	703	1125315	1995-12-24	1996-01-07	1	9502
50262	3423	1119510	2010-10-25	2010-11-01	1	14914
39795	2706	1118084	2006-11-19	2006-11-19	1	13471
62325	4253	1118084	2018-08-01	2018-08-01	1	17744
33818	2295	1125315	1996-12-23	1997-01-06	1	9867
11810	812	1125315	2006-07-06	2006-07-13	1	13342
6708	462	1125315	2002-02-03	2002-02-10	1	11728
8351	579	1759842	1986-02-08	1986-03-01	1	5903
10215	703	1125315	2007-09-08	2007-09-22	1	13778
50263	3423	1125315	2010-10-25	2010-11-01	1	14914
39796	2706	1177480	2001-08-22	2001-09-05	1	11570
62326	4253	1549786	2001-11-12	2002-11-07	1	11998
33819	2295	1125315	2015-07-01	2015-07-01	1	16617
11811	812	1759842	1978-08-26	1978-09-02	1	3166
6709	462	1515774	1993-08-28	1994-08-23	1	9000
8352	579	1759842	1988-07-11	1988-08-01	1	6787
10216	703	1125315	2009-05-04	2009-05-18	1	14382
50264	3423	1729720	1993-08-03	1993-08-15	1	8627
39797	2706	1361711	2006-06-20	2006-06-20	1	13319
62327	4253	1589505	2005-10-23	2006-10-18	1	13439
33820	2295	1177480	2015-07-01	2015-08-30	1	16677
11812	812	1713332	1978-08-26	1978-09-02	1	3166
6710	462	920293	1999-10-14	1999-10-21	1	10885
8353	579	1118084	1999-08-30	1999-08-30	1	10833
10217	703	1326303	2006-01-27	2006-01-27	1	13175
50265	3423	1759842	1981-12-09	1981-12-23	1	4374
39798	2706	1322184	2006-06-20	2006-06-20	1	13319
62328	4253	1729720	1996-06-30	1996-07-08	1	9685
33821	2295	1738521	1974-11-28	1974-12-12	1	1806
11813	812	1729720	1973-10-30	1973-11-08	1	1407
6711	462	1118084	2014-08-28	2014-08-28	1	16310
8354	579	1125315	1994-07-25	1994-08-29	1	9006
10218	703	1728416	1954-05-31	1954-06-14	1	-5680
50266	3423	738818	1992-04-16	1992-04-30	1	8155
39799	2706	1332418	2006-06-20	2006-06-20	1	13319
62329	4253	19127890	1995-12-14	1997-12-03	2	10198
33822	2295	738818	2001-03-12	2001-03-19	1	11400
12477	858	1729720	1975-02-10	1975-02-17	1	1873
6712	462	1119510	1981-06-23	1981-07-07	1	4205
8355	579	1125315	2008-08-22	2008-09-05	1	14127
10219	703	738818	2013-12-25	2014-01-08	1	16078
50267	3423	1118084	2012-01-31	2012-01-31	1	15370
39800	2706	1539403	2006-06-20	2006-06-20	1	13319
62330	4253	1125315	1987-06-22	1987-06-29	1	6388
33823	2295	1125315	1974-11-28	1974-12-12	1	1806
12478	858	1118084	2009-09-28	2009-09-28	1	14515
6713	462	1119510	2002-02-03	2002-02-10	1	11728
8356	579	1729720	1970-06-02	1970-06-10	1	160
10220	703	1119510	2013-12-25	2014-01-08	1	16078
50268	3423	1125315	1979-12-20	1980-01-03	1	3654
39801	2706	1717327	1964-07-02	1964-07-16	1	-1995
62331	4253	1125315	2017-06-12	2017-06-26	1	17343
33824	2295	1125315	2001-03-12	2001-03-19	1	11400
12479	858	1713332	2008-04-23	2008-07-02	1	14062
6714	462	1768849	1992-06-17	1992-07-01	1	8217
8357	579	1119510	1994-03-30	1994-04-06	1	8861
10221	703	1125315	1992-06-19	1992-07-03	1	8219
50269	3423	1125315	1992-04-16	1992-04-30	1	8155
39802	2706	1759842	1990-05-23	1990-06-13	1	7468
62332	4253	1521369	2001-11-12	2002-11-07	1	11998
33825	2295	1174888	2015-07-01	2015-07-01	1	16617
12480	858	1759842	2008-04-23	2008-07-02	1	14062
8960	616	1112807	1961-06-21	1961-07-05	1	-3102
8358	579	1125315	2014-09-12	2014-09-26	1	16339
10222	703	1125315	2013-12-25	2014-01-08	1	16078
50270	3423	1125315	2004-12-27	2005-01-24	1	12807
39803	2706	1759842	2011-08-27	2011-09-17	1	15234
62333	4253	1549786	2005-10-23	2006-10-18	1	13439
34562	2340	1118084	1999-05-14	1999-05-14	1	10725
12481	858	1125315	1979-11-15	1980-01-14	1	3665
8961	616	1119510	2003-07-12	2003-07-26	1	12259
8359	579	1177480	1998-12-06	1999-01-03	1	10594
10223	703	1310149	2006-01-27	2006-01-27	1	13175
50271	3423	1713332	1994-03-22	1994-04-05	1	8860
39804	2706	1112807	1975-10-03	1975-10-17	1	2115
62334	4253	1759842	2010-08-06	2010-11-11	1	14924
34563	2340	1112807	1966-07-26	1966-10-24	1	-1165
13867	950	1713332	2013-09-19	2013-10-10	1	15988
8962	616	1125315	1983-03-03	1983-03-24	1	4830
9992	687	738818	1981-03-18	1981-03-25	1	4101
10224	703	1713332	1980-01-21	1980-01-28	1	3679
50272	3423	1729720	1988-12-04	1988-12-14	1	6922
39805	2706	1729720	1973-02-14	1973-02-23	1	1149
63410	4331	1125315	1989-10-27	1989-11-10	1	7253
34564	2340	1119510	1963-02-12	1963-02-26	1	-2501
13868	950	1717327	1974-02-21	1974-03-07	1	1526
8963	616	1729720	1977-08-11	1977-08-23	1	2791
9993	687	1102527	1981-07-06	1981-07-06	1	4204
10225	703	1713332	2004-05-26	2004-06-09	1	12578
50273	3423	1759842	1994-03-22	1994-04-05	1	8860
39806	2706	1115008	2000-08-06	2000-08-27	1	11196
63411	4331	1177480	1981-12-08	1981-12-22	1	4373
34565	2340	1125315	1962-11-02	1962-11-16	1	-2603
13869	950	705944	1981-05-21	1982-04-08	1	4480
8964	616	738818	2003-07-12	2003-07-26	1	12259
9994	687	1125315	1981-03-18	1981-03-25	1	4101
10226	703	1729720	1981-12-06	1981-12-18	1	4369
56241	3833	1177480	2011-04-06	2011-04-20	1	15084
39807	2706	1115008	2010-02-20	2010-03-27	1	14695
63412	4331	1713332	1981-12-08	1981-12-22	1	4373
34566	2340	738818	1963-02-12	1963-02-26	1	-2501
13870	950	1112807	1985-05-26	1985-06-16	1	5645
8965	616	1125315	2003-07-12	2003-07-26	1	12259
9995	687	1125315	1981-07-06	1981-10-04	1	4294
10227	703	1125315	1966-07-27	1966-10-25	1	-1164
56242	3833	1738521	1970-10-15	1970-10-29	1	301
39808	2706	1125315	1964-07-02	1964-07-16	1	-1995
63413	4331	1118084	2017-03-24	2017-03-24	1	17249
34567	2340	1112807	1961-01-22	1961-02-05	1	-3252
13871	950	1125315	1974-02-21	1974-03-07	1	1526
8966	616	1125315	2012-11-14	2012-11-21	1	15665
9996	687	1125315	1983-12-21	1984-01-04	1	5116
10228	703	1125315	1976-04-06	1976-04-13	1	2294
56243	3833	1759842	1968-07-21	1968-08-11	1	-508
39809	2706	1125315	1973-01-16	1973-02-15	1	1141
64552	4408	1115008	2011-07-14	2011-09-12	1	15229
34568	2340	1112807	1961-06-06	1961-06-20	1	-3117
13872	950	1125315	1983-04-16	1983-06-15	1	4913
8967	616	1728416	1961-06-21	1961-07-05	1	-3102
9997	687	1738521	1968-01-16	1968-01-30	1	-702
10229	703	1125315	1992-09-13	1992-09-27	1	8305
56244	3833	1115008	2005-10-27	2005-11-10	1	13097
39810	2706	1713332	1990-05-23	1990-06-13	1	7468
64553	4408	1177480	2014-05-29	2014-06-19	1	16240
34569	2340	1125315	1963-02-12	1963-02-26	1	-2501
13873	950	1125315	1984-07-09	1984-07-30	1	5324
8968	616	1112807	1959-11-29	1960-02-27	1	-3596
9998	687	1125315	1968-01-16	1968-01-30	1	-702
10230	703	1112807	1954-05-31	1954-06-14	1	-5680
56245	3833	1118084	2001-12-07	2001-12-07	1	11663
39811	2706	1713332	2011-08-27	2011-09-17	1	15234
64554	4408	1503184	1999-12-24	2000-12-18	1	11309
34570	2340	1125315	1999-06-11	1999-06-18	1	10760
13874	950	1177480	1988-03-02	1988-05-31	1	6725
8969	616	1118084	2000-12-08	2000-12-08	1	11299
9999	687	1125315	1974-12-12	1974-12-26	1	1820
10231	703	1112807	1974-04-16	1974-05-21	1	1601
56246	3833	1119510	1966-09-24	1966-10-01	1	-1188
41083	2788	1124300	2018-06-27	2018-06-27	1	17709
64555	4408	1515774	1996-01-14	1997-01-08	1	9869
34571	2340	1717327	1961-06-06	1961-06-20	1	-3117
13875	950	1713332	1984-12-20	1984-12-27	1	5474
8970	616	1125315	1969-07-09	1969-08-13	1	-141
10000	687	1551099	1969-06-09	1969-06-09	1	-206
10232	703	1118084	1989-02-01	1989-02-01	1	6971
56247	3833	1125315	1970-10-15	1970-10-29	1	301
41084	2788	1125315	1983-03-23	1983-04-06	1	4843
64556	4408	1515774	2000-12-18	2001-12-13	1	11669
34572	2340	1717327	1962-11-02	1962-11-16	1	-2603
13876	950	1738521	1972-09-10	1972-09-24	1	997
8971	616	1125315	2004-07-01	2004-07-22	1	12621
10001	687	19127890	1988-12-06	1989-12-01	1	7274
10233	703	1125315	1952-02-11	1952-04-11	1	-6474
56248	3833	1125315	1976-04-02	1976-05-02	1	2313
41085	2788	1102527	2017-12-01	2017-12-01	1	17501
64557	4408	1549786	2000-12-18	2001-12-13	1	11669
36799	2504	1125315	1966-09-18	1966-10-02	1	-1187
13877	950	1759842	1984-12-20	1984-12-27	1	5474
9284	644	738818	1984-09-22	1984-09-29	1	5385
10002	687	1112807	1968-06-28	1968-07-12	1	-538
10234	703	1307863	2006-01-27	2006-01-27	1	13175
56249	3833	1125315	1985-09-23	1985-09-30	1	5751
41086	2788	1125315	1980-01-08	1980-02-12	1	3694
64558	4408	1713332	2007-10-18	2007-10-25	1	13811
36800	2504	1125315	1970-12-28	1971-01-04	1	368
13878	950	1112807	1972-09-10	1972-09-24	1	997
9285	644	933724	1997-11-16	1997-11-23	1	10188
10003	687	1112807	1984-07-20	1984-09-18	1	5374
10235	703	1759842	1980-01-21	1980-01-28	1	3679
56250	3833	1125315	2018-08-18	2018-09-01	1	17775
41087	2788	1125315	2017-11-24	2018-01-30	1	17561
64559	4408	1768849	1984-07-20	1984-08-03	1	5328
36801	2504	1728416	1966-09-18	1966-10-02	1	-1187
13879	950	1118084	2010-02-28	2010-02-28	1	14668
9286	644	1124300	2013-05-30	2013-05-30	1	15855
10004	687	1119510	1981-03-18	1981-03-25	1	4101
10236	703	1759842	2004-05-26	2004-06-09	1	12578
56251	3833	1713332	2001-10-18	2001-11-08	1	11634
41088	2788	1713332	1983-03-23	1983-04-06	1	4843
64560	4408	19127890	1999-12-24	2001-12-13	2	11669
36802	2504	1118084	1989-12-31	1989-12-31	1	7304
13880	950	1125315	1985-06-05	1985-06-12	1	5641
9287	644	1125315	1975-12-21	1976-01-04	1	2194
10005	687	1149380	1970-01-27	1970-01-27	1	26
16055	1110	1115008	2019-01-14	2019-01-28	1	17924
56252	3833	1728416	1967-03-21	1967-04-04	1	-1003
42377	2871	1124300	1996-07-12	1996-07-12	1	9689
64561	4408	1124957	2011-07-14	2011-07-14	1	15169
36803	2504	1125315	1968-01-11	1968-02-08	1	-693
13881	950	1729720	1981-03-29	1981-04-08	1	4115
9288	644	1125315	1984-09-22	1984-09-29	1	5385
10006	687	1177480	2013-09-02	2013-09-30	1	15978
16056	1110	1129625	1983-04-24	1983-04-24	1	4861
56253	3833	1759842	1973-03-10	1973-03-31	1	1185
42378	2871	1125315	2017-03-15	2017-03-15	1	17240
64562	4408	1125315	1982-05-17	1982-05-31	1	4533
36804	2504	19127890	1979-08-21	1980-08-15	1	3879
13882	950	1759842	2013-09-19	2013-10-10	1	15988
9289	644	1125315	2015-10-11	2015-10-25	1	16733
10007	687	1503184	1988-12-06	1989-12-01	1	7274
16057	1110	1713332	1988-10-08	1988-10-22	1	6869
56254	3833	1112807	1967-03-21	1967-04-04	1	-1003
42379	2871	1713332	1960-08-22	1960-09-05	1	-3405
64563	4408	1125315	1989-10-09	1989-10-23	1	7235
36805	2504	1125315	2006-04-02	2006-04-16	1	13254
15069	1046	738818	1980-09-19	1980-09-26	1	3921
9290	644	1521369	1990-10-13	1991-10-08	1	7950
10008	687	1551099	1977-05-03	1977-05-03	1	2679
16058	1110	1125315	1988-10-11	1988-10-18	1	6865
56255	3833	1125315	1971-04-29	1971-06-28	1	543
42380	2871	1713332	1976-06-23	1976-06-30	1	2372
64564	4408	19127890	1996-01-14	1997-01-08	1	9869
36806	2504	1521369	1979-08-21	1980-08-15	1	3879
15070	1046	920293	2010-07-20	2010-07-27	1	14817
9291	644	738818	1980-09-26	1980-10-10	1	3935
10009	687	1713332	2014-03-01	2014-03-15	1	16144
16059	1110	1515774	1997-03-06	1998-03-01	1	10286
56256	3833	1713332	1973-03-10	1973-03-31	1	1185
42381	2871	1729720	1955-09-19	1955-10-01	1	-5206
64565	4408	1177480	2019-02-23	2019-03-09	1	17964
36807	2504	1125315	1963-08-05	1963-10-04	1	-2281
15071	1046	1118084	2012-10-15	2012-10-15	1	15628
9292	644	1125315	1980-09-26	1980-10-10	1	3935
10010	687	1759842	2014-03-01	2014-03-15	1	16144
16060	1110	1551099	1983-04-09	1983-04-09	1	4846
56257	3833	1713332	2008-10-29	2008-11-05	1	14188
42382	2871	1759842	1956-02-07	1956-02-14	1	-5070
64566	4408	1759842	2007-10-18	2007-10-25	1	13811
36808	2504	1125315	1968-12-04	1968-12-18	1	-379
15072	1046	1125315	1975-03-19	1975-06-17	1	1993
9293	644	1125315	1981-05-12	1981-05-26	1	4163
10011	687	1112807	1971-11-13	1971-11-27	1	695
16061	1110	1125315	2002-08-27	2002-09-10	1	11940
56258	3833	1713332	2011-04-06	2011-04-20	1	15084
42383	2871	1759842	1963-12-26	1964-01-02	1	-2191
64567	4408	1118084	2017-09-05	2017-09-05	1	17414
36809	2504	1503184	1979-08-21	1980-08-15	1	3879
15073	1046	1125315	1980-09-19	1980-09-26	1	3921
9294	644	1125315	2003-11-04	2003-11-11	1	12367
10012	687	1118084	2001-04-07	2001-04-07	1	11419
16062	1110	1759842	1988-10-08	1988-10-22	1	6869
56259	3833	1759842	2008-10-29	2008-11-05	1	14188
42384	2871	1112807	1951-06-09	1951-06-23	1	-6767
64568	4408	1125315	1984-07-20	1984-08-03	1	5328
39550	2690	1118084	1983-12-16	1983-12-16	1	5097
15074	1046	1125315	2000-03-17	2000-03-31	1	11047
9295	644	1717327	1975-12-21	1976-01-04	1	2194
10013	687	1154343	1970-01-27	1970-01-27	1	26
16063	1110	19127890	1997-03-06	1998-03-01	1	10286
56260	3833	738818	1966-09-24	1966-10-01	1	-1188
42385	2871	1112807	1960-11-18	1961-01-17	1	-3271
64569	4408	1125315	2011-07-14	2011-07-14	1	15169
39551	2690	1125315	1951-07-30	1951-08-13	1	-6716
15075	1046	1713332	1989-09-29	1989-10-20	1	7232
9296	644	920293	1997-11-16	1997-11-23	1	10188
10014	687	1177480	1993-04-04	1993-04-18	1	8508
16064	1110	1118084	2014-11-27	2014-11-27	1	16401
56261	3833	1125315	1966-09-24	1966-10-01	1	-1188
42386	2871	1112807	1967-07-15	1967-08-05	1	-880
64570	4408	1521369	1999-12-24	2000-12-18	1	11309
39552	2690	1125315	1972-08-17	1972-08-31	1	973
15076	1046	1759842	1989-09-29	1989-10-20	1	7232
9297	644	1112807	1977-12-18	1978-01-01	1	2922
10015	687	1192710	1969-02-10	1969-02-10	1	-325
16065	1110	1125315	1992-10-18	1992-12-17	1	8386
56262	3833	1125315	1999-02-14	1999-02-28	1	10650
42387	2871	1125315	1959-07-29	1959-08-12	1	-3795
64571	4408	1549786	1996-01-14	1997-01-08	1	9869
39553	2690	1177480	1997-04-30	1997-05-21	1	10002
15077	1046	920293	2009-06-11	2009-06-18	1	14413
9298	644	1119510	1980-09-26	1980-10-10	1	3935
10016	687	1521369	1988-12-06	1989-12-01	1	7274
16066	1110	1125315	2009-08-20	2009-09-03	1	14490
56263	3833	1713332	1968-07-21	1968-08-11	1	-508
260	17	920293	2000-02-13	2000-02-27	2	11014
64572	4408	1729720	1995-06-10	1995-06-22	1	9303
39554	2690	1713332	1970-06-17	1970-07-08	1	188
15078	1046	933724	2010-07-20	2010-07-27	1	14817
9299	644	1125315	1982-09-29	1982-11-28	1	4714
10623	729	1125315	1962-07-26	1962-10-24	1	-2626
16067	1110	1125315	2010-09-10	2010-09-24	1	14876
56264	3833	1759842	2001-10-18	2001-11-08	1	11634
261	17	1112807	1951-04-10	1951-04-24	1	-6827
66056	4514	1119510	1999-05-19	1999-06-02	1	10744
39555	2690	1728416	1951-07-30	1951-08-13	1	-6716
15079	1046	1125315	1983-04-06	1983-05-11	1	4878
9300	644	1503184	1990-10-13	1991-10-08	1	7950
10624	729	1125315	2000-01-22	2000-02-26	1	11013
16068	1110	1549786	1997-03-06	1998-03-01	1	10286
57666	3932	1125315	1976-09-09	1976-09-23	1	2457
262	17	1125315	1966-10-19	1966-10-26	1	-1163
66057	4514	1125315	1978-09-04	1978-09-18	1	3182
39556	2690	1174888	2001-08-02	2001-08-02	1	11536
15080	1046	1713332	1984-10-19	1984-11-02	1	5419
9301	644	1515774	1991-10-08	1992-10-02	1	8310
10625	729	1119510	1974-01-25	1974-02-08	1	1499
17791	1228	920293	2014-08-02	2014-08-09	1	16291
57667	3932	1125315	2018-05-06	2018-05-13	1	17664
263	17	1125315	1994-11-21	1994-12-19	1	9118
66058	4514	1713332	1981-10-23	1981-11-06	1	4327
39557	2690	1322184	1998-10-01	2001-08-02	1	11536
15081	1046	19127890	1987-04-25	1988-04-19	1	6683
9302	644	1515774	1993-09-27	1994-09-22	1	9030
10626	729	1125315	2001-11-17	2002-01-16	2	11703
17792	1228	920293	2016-09-01	2016-09-08	1	17052
57668	3932	1717327	1976-09-09	1976-09-23	1	2457
264	17	1713332	2015-10-25	2015-11-15	1	16754
66059	4514	1759842	1981-10-23	1981-11-06	1	4327
39558	2690	1332418	1994-10-20	1994-10-20	1	9058
15082	1046	1112807	1992-02-28	1992-03-20	1	8114
9303	644	1549786	1991-10-08	1992-10-02	1	8310
10627	729	1125315	2019-03-20	2019-03-27	1	17982
17793	1228	933724	2016-09-01	2016-09-08	1	17052
57669	3932	1118084	2010-11-10	2010-11-10	1	14923
265	17	933724	2000-02-13	2000-02-27	1	11014
66060	4514	1129625	1976-06-28	1976-06-28	1	2370
39559	2690	1545958	2001-08-02	2001-08-02	1	11536
15083	1046	1521369	1987-04-25	1988-04-19	1	6683
9304	644	1549786	1993-09-27	1994-09-22	1	9030
10628	729	1174888	2001-11-17	2001-11-17	1	11643
17794	1228	1115008	2001-09-19	2001-10-10	1	11605
57670	3932	1125315	1982-05-12	1982-05-26	1	4528
266	17	1759842	1973-03-13	1973-03-20	1	1174
66061	4514	1521369	1989-05-19	1990-05-14	1	7438
39560	2690	1759842	1970-06-17	1970-07-08	1	188
15084	1046	1759842	1984-10-19	1984-11-02	1	5419
9305	644	1713332	1981-05-12	1981-05-26	1	4163
10629	729	738818	1974-01-25	1974-02-08	1	1499
17795	1228	1713332	1999-08-31	1999-09-21	1	10855
57671	3932	1125315	1989-01-04	1989-04-04	1	7033
267	17	723013	1965-01-11	1965-07-05	1	-1641
66062	4514	1521369	1991-05-09	1993-04-28	2	8518
39561	2690	1125315	2001-08-02	2001-08-02	1	11536
15085	1046	933724	2009-06-11	2009-06-18	1	14413
9306	644	1729720	1987-06-04	1987-06-14	1	6373
10630	729	1125315	1974-01-25	1974-02-08	1	1499
17796	1228	1759842	1999-08-31	1999-09-21	1	10855
57672	3932	1125315	2006-09-27	2006-10-04	1	13425
268	17	933724	1995-01-02	1995-01-09	1	9139
66063	4514	1118084	2015-03-29	2015-03-29	1	16523
39562	2690	1539403	1992-10-15	1992-10-15	1	8323
15086	1046	1115008	1996-03-29	1996-04-26	1	9612
9307	644	1119510	1984-09-22	1984-09-29	1	5385
10631	729	1729720	1966-03-09	1966-03-17	1	-1386
17797	1228	19127890	1993-06-08	1994-06-03	1	8919
57673	3932	1177480	1975-06-17	1975-09-15	1	2083
269	17	1102527	1971-10-27	1971-10-27	1	664
66064	4514	1125315	1977-02-11	1977-02-25	1	2612
39563	2690	1728416	1949-06-27	1949-07-11	1	-7479
15087	1046	1119510	1980-09-19	1980-09-26	1	3921
9308	644	1125315	1989-06-02	1989-06-09	1	7099
10632	729	1112807	1972-02-04	1972-02-18	1	778
17798	1228	19127890	1995-05-29	1996-05-23	1	9639
57674	3932	1177480	1994-01-08	1994-01-22	1	8787
270	17	1118084	1989-11-21	1989-11-21	1	7264
66065	4514	1125315	2014-06-29	2014-07-06	1	16257
39564	2690	1729720	1961-11-06	1961-11-14	1	-2970
15088	1046	1125315	1972-08-01	1972-08-15	1	957
9309	644	1177480	1976-10-16	1976-10-30	1	2494
10633	729	1124300	2000-04-07	2000-04-07	1	11054
17799	1228	933724	2014-08-02	2014-08-09	1	16291
57675	3932	1729720	1975-09-17	1975-09-24	1	2092
271	17	1177480	2012-01-19	2012-02-02	1	15372
66066	4514	1177480	1979-04-16	1979-07-15	1	3482
39565	2690	1759842	1971-11-08	1971-11-29	1	697
15089	1046	1125315	1988-06-13	1988-07-18	1	6773
9310	644	1713332	1996-02-22	1996-03-07	1	9562
11386	778	1118084	2011-05-06	2011-05-06	1	15100
17800	1228	1102527	2003-09-30	2003-09-30	1	12325
57676	3932	1729720	1995-12-08	1995-12-20	1	9484
272	17	1728416	1951-04-10	1951-04-24	1	-6827
66067	4514	1503184	1989-05-19	1990-05-14	1	7438
39566	2690	1112807	1949-06-27	1949-07-11	1	-7479
15090	1046	1503184	1987-04-25	1988-04-19	1	6683
9311	644	1728416	1977-12-18	1978-01-01	1	2922
11387	778	1125315	1980-12-04	1981-01-01	1	4018
17801	1228	1177480	1980-01-06	1980-03-13	1	3724
60127	4100	1118084	1979-12-21	1979-12-21	1	3641
273	17	1729720	1960-02-08	1960-02-20	1	-3603
66068	4514	1503184	1991-05-09	1993-04-28	2	8518
39567	2690	1125315	1956-11-19	1956-11-26	1	-4784
15091	1046	1729720	1984-08-25	1984-09-04	1	5360
9312	644	1759842	1996-02-22	1996-03-07	1	9562
11388	778	1125315	1985-01-10	1985-01-31	1	5509
17802	1228	1515774	1993-06-08	1994-06-03	1	8919
60128	4100	1125315	1947-10-11	1947-10-25	1	-8104
274	17	1738521	1971-10-27	1971-12-01	1	699
66069	4514	738818	1999-05-19	1999-06-02	1	10744
39568	2690	1177480	1996-03-22	1996-04-05	1	9591
15092	1046	1738521	1972-08-01	1972-08-15	1	957
9313	644	19127890	1990-10-13	1992-10-02	2	8310
11389	778	1515774	1997-12-15	1998-12-10	1	10570
17803	1228	1515774	1995-05-29	1996-05-23	1	9639
60129	4100	1125315	1957-08-23	1957-09-20	1	-4486
275	17	723013	1962-12-08	1963-03-23	1	-2476
66070	4514	1125315	1999-05-19	1999-06-02	1	10744
39569	2690	1361711	1971-06-03	2001-08-02	1	11536
16209	1120	1503184	1978-11-02	1979-10-28	1	3587
9314	644	19127890	1993-09-27	1994-09-22	1	9030
11390	778	1521369	1996-12-20	1997-12-15	1	10210
17804	1228	1549786	1993-06-08	1994-06-03	1	8919
60130	4100	1713332	1966-09-20	1966-10-11	1	-1178
276	17	740275	1966-10-31	1967-05-01	1	-976
66071	4514	1738521	1978-09-04	1978-09-18	1	3182
39570	2690	1713332	1971-11-08	1971-11-29	1	697
16210	1120	1521369	1975-11-08	1976-11-02	1	2497
10981	754	933724	1989-09-16	1989-09-30	1	7212
11391	778	1738521	1978-07-18	1978-08-01	1	3134
17805	1228	1549786	1995-05-29	1996-05-23	1	9639
60131	4100	1759842	2007-08-27	2007-09-10	1	13766
277	17	740275	1967-11-06	1968-05-27	1	-584
66072	4514	19127890	1989-05-19	1990-05-14	1	7438
39571	2690	1729720	1992-01-24	1992-02-06	1	8071
16211	1120	1713332	1994-01-26	1994-02-16	1	8812
10982	754	1112807	1939-11-24	1939-12-08	1	-10982
11392	778	1759842	2001-09-08	2001-09-22	1	11587
17806	1228	1713332	2019-01-05	2019-01-26	1	17922
60132	4100	738818	1979-06-13	1979-06-27	1	3464
278	17	920293	1995-01-02	1995-01-09	1	9139
66073	4514	19127890	1991-05-09	1993-04-28	2	8518
41325	2804	1112807	1954-04-27	1954-05-11	1	-5714
16212	1120	1713332	1994-09-22	1994-09-29	1	9037
10983	754	1112807	1943-02-06	1943-02-20	1	-9812
11393	778	1119510	1990-03-18	1990-03-25	1	7388
17807	1228	1759842	2000-03-26	2000-04-16	1	11063
60133	4100	1125315	1979-06-13	1979-06-27	1	3464
279	17	1112807	1958-11-29	1959-01-28	1	-3991
69193	4722	1112807	1918-04-19	1918-05-19	1	-18855
41326	2804	1125315	1961-06-07	1961-06-21	1	-3116
16213	1120	1728416	1958-10-28	1958-11-11	1	-4069
10984	754	920293	1989-09-16	1989-09-30	2	7212
11394	778	1515774	1992-01-16	1993-01-10	1	8410
17808	1228	1125315	1984-10-13	1984-10-20	1	5406
60134	4100	1347450	2008-08-27	2008-08-27	1	14118
280	17	1112807	1969-02-04	1969-03-11	1	-296
69194	4722	1112807	1924-02-17	1924-03-25	1	-16718
41327	2804	1125315	1983-08-09	1983-08-16	1	4975
16214	1120	1112807	1958-10-28	1958-11-11	1	-4069
10985	754	1112807	1938-02-20	1938-03-06	1	-11624
11395	778	1515774	1994-01-05	1994-12-31	1	9130
17809	1228	1129625	1979-07-26	1979-07-26	1	3493
60135	4100	1759842	1966-09-20	1966-10-11	1	-1178
281	17	1125315	1971-10-27	1971-12-01	1	699
69195	4722	1115008	1996-06-19	1996-07-10	1	9687
41328	2804	1174888	1983-04-16	1983-04-16	1	4853
16215	1120	1503184	1975-11-08	1976-11-02	1	2497
10986	754	1112807	1945-01-14	1945-02-18	1	-9083
11396	778	19127890	1996-12-20	1998-12-10	2	10570
17810	1228	1713332	2016-03-27	2016-04-10	1	16901
60136	4100	1119510	1979-06-13	1979-06-27	1	3464
282	17	1125315	1989-09-27	1989-10-18	1	7230
69196	4722	1115008	2009-07-29	2009-08-12	1	14468
41329	2804	1177480	1996-02-26	1996-03-11	1	9566
16216	1120	1521369	1978-11-02	1979-10-28	1	3587
10987	754	1112807	1972-09-15	1972-11-14	1	1048
11397	778	1112807	1978-07-18	1978-08-01	1	3134
17811	1228	1115008	2003-09-30	2003-11-29	1	12385
60137	4100	1713332	1978-05-11	1978-05-25	1	3066
283	17	1125315	2012-11-25	2012-12-09	1	15683
69197	4722	1118084	1945-07-25	1945-07-25	1	-8926
41330	2804	1713332	1998-05-25	1998-06-15	1	10392
16217	1120	1729720	1972-07-30	1972-08-06	1	948
10988	754	1118084	1973-08-05	1973-08-05	1	1312
11398	778	1125315	2008-01-22	2008-02-05	1	13914
17812	1228	1118084	2009-01-13	2009-01-13	1	14257
60138	4100	1125315	1952-03-17	1952-04-21	1	-6464
284	17	1713332	1973-03-13	1973-03-20	1	1174
69198	4722	1177480	2012-10-14	2013-01-12	1	15717
41331	2804	1112807	1952-08-05	1952-11-03	1	-6268
16218	1120	933724	2016-02-17	2016-02-24	1	16855
10989	754	1125315	1950-08-12	1950-09-20	2	-7068
11399	778	1177480	2001-12-03	2001-12-17	1	11673
17813	1228	1125315	1989-03-06	1989-03-20	1	7018
60139	4100	1322184	2008-08-27	2008-08-27	1	14118
285	17	1759842	2015-10-25	2015-11-15	1	16754
69199	4722	1713332	2008-05-15	2008-05-22	1	14021
41332	2804	1119510	1961-06-07	1961-06-21	1	-3116
16219	1120	1112807	1971-12-19	1972-01-18	1	747
10990	754	1713332	2009-05-31	2010-02-28	1	14668
11400	778	1500211	1994-12-31	1995-12-26	1	9490
17814	1228	1177480	2016-03-27	2016-04-10	1	16901
60140	4100	1713332	2007-08-27	2007-09-10	1	13766
1583	103	738818	1974-07-22	1974-07-29	1	1670
69200	4722	1713332	2011-07-11	2011-08-01	1	15187
41333	2804	1125315	1956-09-14	1956-09-21	1	-4850
16220	1120	1124300	1997-03-07	1997-03-07	1	9927
10991	754	1729720	1952-01-11	1952-01-19	1	-6557
11401	778	1549786	1992-01-16	1993-01-10	1	8410
17815	1228	1713332	2000-03-26	2000-04-16	1	11063
60141	4100	1729720	1949-09-01	1949-09-14	1	-7414
1584	103	933724	2000-06-14	2000-06-21	1	11129
69201	4722	1759842	1956-04-15	1956-05-06	1	-4988
41334	2804	1125315	1963-02-16	1963-02-23	1	-2504
16221	1120	1125315	1987-10-26	1988-01-24	1	6597
10992	754	1112807	1970-01-08	1970-01-29	1	28
11402	778	1713332	2001-09-08	2001-09-22	1	11587
17816	1228	1759842	2019-01-05	2019-01-26	1	17922
60142	4100	1759842	1978-05-11	1978-05-25	1	3066
1585	103	1125315	1972-03-02	1972-03-23	1	812
69202	4722	1759842	1991-03-11	1991-07-22	1	7872
41335	2804	1125315	1983-04-09	1983-05-16	2	4883
16222	1120	1717327	1961-08-27	1961-09-10	1	-3035
10993	754	1125315	1947-08-03	1947-08-17	1	-8173
11403	778	19127890	1992-01-16	1993-01-10	1	8410
20325	1385	1521369	1974-05-10	1975-05-05	1	1950
61680	4210	1112807	1986-01-07	1986-01-21	1	5864
1586	103	1125315	1974-07-22	1974-07-29	1	1670
69203	4722	1112807	1914-02-18	1914-03-11	1	-20385
41336	2804	1125315	2017-08-18	2017-09-01	1	17410
16223	1120	1729720	1966-03-23	1966-04-01	1	-1371
10994	754	1759842	2009-05-31	2010-02-28	1	14668
11404	778	19127890	1994-01-05	1994-12-31	1	9130
20326	1385	1713332	1997-11-09	1997-11-30	1	10195
61681	4210	1125315	1991-04-13	1991-04-27	1	7786
1587	103	1308738	2002-05-19	2002-05-19	1	11826
69204	4722	1125315	1924-02-24	1924-02-24	1	-16748
41337	2804	1728416	1954-04-27	1954-05-11	1	-5714
16224	1120	1759842	1994-01-26	1994-02-16	1	8812
10995	754	1112807	1950-09-20	1950-10-20	1	-7013
11405	778	738818	1990-03-18	1990-03-25	1	7388
20327	1385	1713332	2016-03-23	2016-04-13	1	16904
61682	4210	1759842	2001-12-04	2002-01-29	1	11716
1588	103	920293	2000-06-14	2000-06-21	1	11129
69205	4722	1125315	1938-12-11	1938-12-18	1	-11337
41338	2804	738818	1961-06-07	1961-06-21	1	-3116
16225	1120	1759842	1994-09-22	1994-09-29	1	9037
10996	754	1115008	2008-04-09	2008-05-09	1	14008
11406	778	1125315	1988-03-16	1988-06-14	1	6739
20328	1385	1728416	1962-07-02	1962-07-16	1	-2726
61683	4210	1119510	2014-02-24	2014-03-03	1	16132
1589	103	1125315	1990-08-16	1990-08-30	1	7546
69206	4722	1713332	1933-03-29	1933-04-05	1	-13420
41339	2804	1118084	1990-06-17	1990-06-17	1	7472
16226	1120	19127890	1975-11-08	1976-11-02	1	2497
10997	754	1124957	1950-09-20	1950-09-20	1	-7043
11407	778	1125315	1990-03-18	1990-03-25	1	7388
20329	1385	1729720	1970-07-21	1970-07-31	1	211
61684	4210	1125315	1979-01-28	1979-02-18	1	3335
1590	103	1125315	2002-04-30	2002-05-07	1	11814
69207	4722	1713332	1956-04-15	1956-05-06	1	-4988
41340	2804	1713332	1964-01-10	1964-01-17	1	-2176
16227	1120	920293	2015-01-01	2015-01-08	1	16443
10998	754	1125315	1952-07-11	1952-08-10	1	-6353
11408	778	1503184	1996-12-20	1997-12-15	1	10210
20330	1385	1125315	2012-01-26	2012-02-02	1	15372
61685	4210	1125315	2014-02-24	2014-03-03	1	16132
1591	103	1125315	2018-12-21	2019-01-04	1	17900
69208	4722	1759842	1933-03-29	1933-04-05	1	-13420
41341	2804	1759842	1973-11-02	1973-11-23	1	1422
16228	1120	920293	2016-02-17	2016-02-24	1	16855
12426	855	1119510	1980-10-08	1980-10-22	1	3947
11409	778	1549786	1994-01-05	1994-12-31	1	9130
20331	1385	1521369	1979-04-14	1981-04-03	2	4110
61686	4210	1177480	1984-12-18	1985-03-18	1	5555
1592	103	1729720	2009-08-26	2009-09-05	1	14492
69209	4722	1125315	1946-04-17	1946-04-24	1	-8653
41342	2804	1112807	1965-02-28	1965-03-14	1	-1754
16229	1120	933724	2015-01-01	2015-01-08	1	16443
12427	855	920293	1993-12-26	1994-01-02	1	8767
11410	778	1549786	1997-12-15	1998-12-10	1	10570
20332	1385	1521369	1984-03-18	1985-03-13	1	5550
61687	4210	738818	2007-02-02	2007-02-16	1	13560
1593	103	1118084	2008-06-01	2008-06-01	1	14031
69210	4722	1125315	1967-02-05	1967-02-12	1	-1054
41343	2804	1177480	1988-03-20	1988-04-10	1	6674
16230	1120	1125315	1961-08-27	1961-09-10	1	-3035
12428	855	933724	1993-12-26	1994-01-02	1	8767
15415	1072	1112807	1972-02-14	1972-03-06	1	795
20333	1385	1759842	2008-07-20	2008-09-07	1	14129
61688	4210	1118084	2016-12-10	2016-12-10	1	17145
1594	103	1119510	1974-07-22	1974-07-29	1	1670
69211	4722	1125315	1994-07-16	1994-07-30	1	8976
41344	2804	1177480	1993-02-13	1993-03-13	1	8472
16231	1120	19127890	1978-11-02	1979-10-28	1	3587
12429	855	1728416	1958-03-18	1958-04-01	1	-4293
15416	1072	1125315	1961-08-12	1961-08-26	1	-3050
20334	1385	1768849	2003-06-02	2003-06-30	1	12233
61689	4210	1119510	2007-02-02	2007-02-16	1	13560
1595	103	1125315	1996-09-03	1996-09-10	1	9749
69212	4722	1177480	2015-09-29	2015-10-29	1	16737
41345	2804	1177480	2015-06-30	2015-07-21	1	16637
19321	1321	1112807	1961-07-12	1961-08-09	1	-3067
12430	855	1728416	1959-04-27	1959-05-11	1	-3888
15417	1072	1125315	1979-01-12	1979-01-26	1	3312
20335	1385	1112807	1963-12-24	1964-01-07	1	-2186
61690	4210	1125315	2007-02-02	2007-02-16	1	13560
6511	450	1118084	2005-03-10	2005-03-10	1	12852
69213	4722	1713332	1991-03-11	1991-07-22	1	7872
41346	2804	1713332	1973-11-02	1973-11-23	1	1422
19322	1321	1119510	1965-02-01	1965-02-08	1	-1788
12431	855	738818	1980-10-08	1980-10-22	1	3947
15418	1072	1125315	1996-12-03	1996-12-17	1	9847
20336	1385	1118084	1999-12-20	1999-12-20	1	10945
61691	4210	1177480	1990-02-20	1990-03-06	1	7369
6512	450	1125315	1967-10-09	1967-10-16	1	-808
69214	4722	1759842	2008-05-15	2008-05-22	1	14021
41347	2804	1759842	1964-01-10	1964-01-17	1	-2176
19323	1321	1177480	2000-11-10	2000-12-15	1	11306
12432	855	1112807	1958-03-18	1958-04-01	1	-4293
15419	1072	1125315	2009-04-14	2009-04-21	1	14355
20337	1385	1125315	1965-08-17	1965-08-31	1	-1584
61692	4210	1177480	1995-10-06	1995-11-10	1	9444
6513	450	1125315	1983-08-14	1983-09-11	1	5001
69215	4722	1759842	2011-07-11	2011-08-01	1	15187
41348	2804	1759842	1998-05-25	1998-06-15	1	10392
19324	1321	1713332	2017-07-24	2017-07-31	1	17378
12433	855	1112807	1959-04-27	1959-05-11	1	-3888
15420	1072	1177480	2019-04-20	2019-05-04	1	18020
20338	1385	1125315	1997-11-09	1997-11-30	2	10195
61693	4210	1177480	2017-07-17	2017-07-31	1	17378
6514	450	1125315	2008-10-15	2008-10-22	1	14174
69216	4722	1124957	1924-02-24	1924-02-24	1	-16748
42771	2897	1112807	1965-11-24	1965-12-08	1	-1485
19325	1321	1728416	1962-10-14	1962-10-28	1	-2622
12434	855	1124300	1999-03-08	1999-03-08	1	10658
15421	1072	1124300	2000-07-28	2000-07-28	1	11166
20339	1385	1174888	1997-11-09	1997-11-09	1	10174
61694	4210	738818	2014-02-24	2014-03-03	1	16132
6515	450	1125315	1970-06-23	1970-07-07	1	187
69217	4722	1125315	1941-02-23	1941-03-02	1	-10532
42772	2897	1125315	1983-07-28	1983-08-25	1	4984
19326	1321	1759842	2017-07-24	2017-07-31	1	17378
12435	855	1125315	1967-07-29	1967-08-12	1	-873
15422	1072	1713332	1980-11-06	1980-11-27	1	3983
20340	1385	1177480	2016-03-23	2016-04-13	1	16904
61695	4210	1125315	1976-04-29	1976-05-13	1	2324
6516	450	1177480	2015-03-27	2015-04-10	1	16535
69218	4722	1125315	1984-04-09	1984-05-09	1	5242
42773	2897	1125315	2017-11-15	2017-11-15	1	17485
19327	1321	1119510	1968-01-26	1968-02-09	1	-692
12436	855	1713332	1991-02-19	1991-03-05	1	7733
15423	1072	1713332	1994-12-02	1994-12-09	1	9108
20341	1385	1503184	1979-04-14	1981-04-03	2	4110
61696	4210	1713332	2001-12-04	2002-01-29	1	11716
6517	450	1759842	1989-05-13	1989-05-27	1	7086
72035	4923	1118084	2000-05-23	2000-05-23	1	11100
42774	2897	1124300	2003-11-06	2003-11-06	1	12362
19328	1321	1119510	1978-05-22	1978-06-05	1	3077
12437	855	1717327	1962-03-18	1962-04-01	1	-2832
15424	1072	1729720	1987-07-22	1987-07-29	1	6418
20342	1385	1503184	1984-03-18	1985-03-13	1	5550
61697	4210	1768849	1986-01-07	1986-01-21	1	5864
6518	450	1102527	1981-07-25	1981-07-25	1	4223
72036	4923	1125315	1977-01-24	1977-04-29	2	2654
42775	2897	1125315	1974-06-22	1974-06-29	1	1640
19329	1321	1125315	1962-10-14	1962-10-28	1	-2622
12438	855	1759842	1991-02-19	1991-03-05	1	7733
15425	1072	1759842	1980-11-06	1980-11-27	1	3983
20343	1385	1729720	1972-05-22	1972-05-31	1	881
63332	4328	738818	1993-12-31	1994-01-14	1	8779
6519	450	1112807	1981-07-25	1981-09-23	1	4283
72037	4923	1125315	1978-03-12	1978-03-26	1	3006
42776	2897	1174888	2017-11-15	2017-11-15	1	17485
19330	1321	1125315	2015-12-11	2015-12-18	1	16787
12439	855	1112807	1962-03-18	1962-04-01	1	-2832
15426	1072	1759842	1994-12-02	1994-12-09	1	9108
20344	1385	1729720	1972-11-29	1972-12-07	1	1071
63333	4328	1125315	1993-12-31	1994-01-14	1	8779
6520	450	1713332	1989-05-13	1989-05-27	1	7086
72038	4923	1125315	2014-09-05	2014-09-19	1	16332
42777	2897	1112807	1970-11-23	1970-12-28	1	361
19331	1321	1177480	2007-11-09	2007-12-14	1	13861
12440	855	1125315	1968-12-22	1968-12-29	1	-368
15427	1072	1112807	1966-02-01	1966-02-15	1	-1416
20345	1385	19127890	1974-05-10	1975-05-05	1	1950
63334	4328	933724	1998-07-12	1998-07-19	1	10426
6521	450	1759842	1974-02-08	1974-02-15	1	1506
72039	4923	1322184	2018-06-19	2018-06-19	1	17701
42778	2897	1125315	1985-12-30	1986-01-13	1	5856
19332	1321	1713332	1987-09-20	1987-10-11	1	6492
12441	855	1125315	1980-10-08	1980-10-22	1	3947
15428	1072	1125315	1968-03-08	1968-04-05	1	-636
20346	1385	1112807	1962-07-02	1962-07-16	1	-2726
63335	4328	1118084	2009-07-13	2009-07-13	1	14438
6522	450	1713332	1974-02-08	1974-02-15	1	1506
72040	4923	1347450	2018-06-19	2018-06-19	1	17701
42779	2897	1713332	1984-07-26	1984-08-09	1	5334
19333	1321	1759842	1965-02-21	1965-03-14	1	-1754
14237	973	738818	1990-04-27	1990-05-11	1	7435
15429	1072	1125315	1990-10-20	1990-11-18	1	7626
20347	1385	1125315	1997-05-17	1997-05-24	1	10005
63336	4328	1125315	2016-03-07	2016-03-21	1	16881
6523	450	1738521	1970-06-23	1970-07-07	1	187
72041	4923	1125315	1984-07-16	1984-08-13	1	5338
42780	2897	1713332	2013-06-23	2013-06-30	1	15886
19334	1321	738818	1965-02-01	1965-02-08	1	-1788
14238	973	1125315	1916-09-06	1916-09-20	1	-19461
15430	1072	1177480	1979-05-29	1979-06-28	1	3465
20348	1385	1125315	2007-05-14	2007-05-28	1	13661
63337	4328	920293	1998-07-12	1998-07-19	1	10426
9373	648	738818	1966-07-29	1966-08-12	1	-1238
72042	4923	1521369	1985-09-26	1987-09-16	2	6467
42781	2897	1729720	1983-12-13	1983-12-21	1	5102
19335	1321	738818	1968-01-26	1968-02-09	1	-692
14239	973	1125315	1944-07-27	1944-08-03	1	-9282
15431	1072	1717327	1966-02-01	1966-02-15	1	-1416
20349	1385	1177480	2003-06-02	2003-06-30	1	12233
63338	4328	1119510	1993-12-31	1994-01-14	1	8779
9374	648	1112807	1933-06-14	1933-06-28	1	-13336
72043	4923	1713332	1997-09-19	1997-10-03	1	10137
42782	2897	1759842	1984-07-26	1984-08-09	1	5334
19336	1321	738818	1978-05-22	1978-06-05	1	3077
14240	973	1125315	1990-04-27	1990-05-11	1	7435
17297	1194	1125315	1995-07-09	1995-10-07	2	9410
20350	1385	1396131	2007-05-02	2007-05-02	1	13635
63339	4328	1125315	1976-02-02	1976-02-16	1	2237
9375	648	1125315	1936-10-27	1936-11-10	1	-12105
72044	4923	1738521	1978-03-12	1978-03-26	1	3006
42783	2897	1759842	2013-06-23	2013-06-30	1	15886
19337	1321	1125315	1965-02-01	1965-02-08	1	-1788
14241	973	1759842	1932-01-10	1932-01-31	1	-13850
17298	1194	1125315	2003-06-30	2003-07-14	1	12247
20351	1385	1503184	1974-05-10	1975-05-05	1	1950
63340	4328	1125315	2015-02-02	2015-02-09	1	16475
9376	648	1125315	1937-02-19	1937-03-05	1	-11990
72045	4923	1759842	1997-09-19	1997-10-03	1	10137
42784	2897	1112807	1962-09-22	1962-10-06	1	-2644
19338	1321	1125315	1968-01-26	1968-02-09	1	-692
14242	973	1759842	1970-12-07	1970-12-28	1	361
17299	1194	1174888	1995-07-09	1995-07-09	1	9320
20352	1385	1713332	2008-07-20	2008-09-07	1	14129
63341	4328	1177480	2007-08-18	2007-09-22	1	13778
9377	648	1125315	1966-07-29	1966-08-12	1	-1238
72046	4923	1102527	1997-03-08	1997-03-08	1	9928
42785	2897	1115008	2017-11-15	2017-12-15	1	17515
19339	1321	1125315	1978-05-22	1978-06-05	1	3077
14243	973	738818	1944-07-27	1944-08-03	1	-9282
17300	1194	1729720	1963-11-15	1963-11-25	1	-2229
20353	1385	19127890	1979-04-14	1981-04-03	2	4110
63342	4328	1125315	2003-08-06	2003-08-20	1	12284
9378	648	1125315	2014-09-30	2014-10-07	1	16350
72047	4923	1125315	1979-05-08	1979-05-22	1	3428
42786	2897	1125315	1968-12-19	1969-01-02	1	-364
19340	1321	1125315	1999-11-02	1999-11-16	1	10911
14244	973	1112807	1918-11-24	1918-12-08	1	-18652
17301	1194	1125315	1999-03-30	1999-04-13	1	10694
20354	1385	19127890	1984-03-18	1985-03-13	1	5550
63343	4328	1177480	1995-06-22	1995-09-20	1	9393
9379	648	1115008	2000-02-03	2000-03-04	1	11020
72048	4923	1713332	1984-12-18	1985-01-01	1	5479
42787	2897	1125315	1977-02-21	1977-02-28	1	2615
19341	1321	1759842	1987-09-20	1987-10-11	1	6492
14245	973	1112807	1920-03-23	1920-04-06	1	-18167
17302	1194	1717327	1962-08-10	1962-08-24	1	-2687
22375	1523	1119510	1959-06-25	1959-07-09	1	-3829
63344	4328	1713332	2016-07-21	2016-07-28	1	17010
9380	648	1125315	1938-08-25	1938-09-08	1	-11438
72049	4923	1759842	1984-12-18	1985-01-01	1	5479
42788	2897	1125315	1979-03-16	1979-04-20	1	3396
19342	1321	738818	2000-10-15	2000-10-29	1	11259
14246	973	1115008	1997-04-08	1997-04-22	1	9973
17303	1194	1717327	1963-10-18	1963-11-01	1	-2253
22376	1523	1124300	1996-01-21	1996-01-21	1	9516
63345	4328	1759842	2016-07-21	2016-07-28	1	17010
9381	648	1125315	1951-12-20	1952-01-03	1	-6573
72050	4923	19127890	1985-09-26	1987-09-16	2	6467
42789	2897	1177480	2001-03-23	2001-04-13	1	11425
19343	1321	1112807	1987-04-25	1987-05-09	1	6337
14247	973	1713332	1982-05-07	1982-05-21	1	4523
17304	1194	1112807	1962-08-10	1962-08-24	1	-2687
22377	1523	1759842	1971-05-30	1971-06-06	1	521
64609	4411	933724	1996-07-06	1996-07-13	1	9690
9382	648	1125315	1961-11-25	1961-12-09	1	-2945
72051	4923	1112807	1970-01-01	1970-01-15	1	14
42790	2897	1717327	1962-09-22	1962-10-06	1	-2644
19344	1321	1118084	2002-02-06	2002-02-06	1	11724
14248	973	1759842	1982-05-07	1982-05-21	1	4523
17305	1194	1118084	2001-05-27	2001-05-27	1	11469
22378	1523	1112807	1957-02-04	1957-02-18	1	-4700
64610	4411	1125315	2003-03-13	2003-03-27	1	12138
9383	648	1125315	1963-07-07	1963-08-11	1	-2335
72052	4923	1115008	1997-03-08	1997-04-07	1	9958
42791	2897	1728416	1965-11-24	1965-12-08	1	-1485
19345	1321	1119510	2000-10-15	2000-10-29	1	11259
14249	973	1112807	1965-03-22	1965-04-26	1	-1711
17306	1194	1729720	1972-05-25	1972-06-03	1	884
22379	1523	1119510	2014-08-14	2014-08-28	1	16310
64611	4411	1125315	2014-11-24	2014-12-24	1	16428
9384	648	1125315	1984-05-21	1984-05-28	1	5261
72053	4923	1125315	1974-03-13	1974-03-27	1	1546
42792	2897	1729720	1967-07-29	1967-08-05	1	-880
19346	1321	1125315	1960-05-27	1960-06-17	1	-3485
14250	973	1118084	1953-12-25	1953-12-25	1	-5851
17307	1194	1112807	1963-10-18	1963-11-01	1	-2253
22380	1523	1125315	1974-07-29	1974-08-12	1	1684
64612	4411	1759842	1979-02-16	1979-02-23	1	3340
9385	648	1322184	2018-01-19	2018-01-19	1	17550
72054	4923	1125315	1980-11-18	1980-11-25	1	3981
44566	3019	1125315	1995-03-01	1995-03-29	1	9218
19347	1321	1125315	2000-10-15	2000-10-29	1	11259
14251	973	1119510	1944-07-27	1944-08-03	1	-9282
17308	1194	1177480	1978-09-15	1978-10-06	1	3200
22381	1523	1177480	2001-08-25	2001-09-08	1	11573
64613	4411	920293	1990-05-20	1990-05-27	1	7451
9386	648	1347450	2018-01-19	2018-01-19	1	17550
72055	4923	1503184	1985-09-26	1987-09-16	2	6467
44567	3019	1768849	1991-08-19	1991-09-02	1	7914
19348	1321	1177480	2016-12-26	2017-01-09	1	17175
14252	973	1119510	1993-12-03	1993-12-10	1	8744
20563	1401	1112807	1978-01-02	1978-01-16	1	2937
22382	1523	738818	1959-06-25	1959-07-09	1	-3829
64614	4411	920293	1996-07-06	1996-07-13	1	9690
9387	648	1729720	2018-05-02	2018-05-15	1	17666
72056	4923	1729720	1969-01-10	1969-01-20	1	-346
44568	3019	1125315	1992-04-15	1992-04-15	2	8170
19349	1321	1713332	1965-02-21	1965-03-14	1	-1754
14253	973	1125315	1962-12-29	1963-01-12	1	-2546
20564	1401	1174888	1987-03-14	1987-03-14	1	6281
22383	1523	738818	2014-08-14	2014-08-28	1	16310
64615	4411	933724	1990-05-20	1990-05-27	1	7451
9388	648	1102527	1954-10-22	1954-10-22	1	-5550
74290	5079	1112807	1969-07-28	1969-09-10	1	-113
44569	3019	1174888	1992-04-15	1992-04-15	1	8140
19350	1321	1728416	1961-07-12	1961-08-09	1	-3067
14254	973	1125315	2006-10-11	2006-10-18	1	13439
20565	1401	1503184	1991-01-04	1991-12-30	1	8033
22384	1523	1112807	1973-08-09	1973-08-23	1	1330
64616	4411	1119510	1993-08-16	1993-08-23	1	8635
9389	648	1112807	1939-02-13	1939-05-14	1	-11190
74291	5079	1119510	1970-12-22	1970-12-29	1	362
44570	3019	1713332	1978-03-09	1978-03-30	1	3010
19351	1321	1729720	2007-06-22	2007-06-29	1	13693
14255	973	1149380	1917-08-23	1917-08-23	1	-19124
20566	1401	1713332	2001-08-09	2001-08-23	1	11557
22385	1523	1125315	1959-06-25	1959-07-09	1	-3829
64617	4411	1119510	2002-07-08	2002-07-15	1	11883
9390	648	1112807	1954-10-22	1954-11-21	1	-5520
74292	5079	1125315	1999-11-08	1999-11-22	1	10917
44571	3019	1115008	2000-10-28	2000-12-02	1	11293
21440	1459	1115008	2006-10-26	2006-11-16	1	13468
14256	973	1713332	1970-12-07	1970-12-28	1	361
20567	1401	1713332	2005-04-25	2005-05-16	1	12919
22386	1523	1125315	1988-11-02	1989-01-31	1	6970
64618	4411	1125315	1946-03-13	1946-03-20	1	-8688
9391	648	1115008	2001-02-27	2001-03-29	1	11410
74293	5079	1125315	1981-08-24	1981-09-14	1	4274
21441	1459	1118084	1976-03-21	1976-03-21	1	2271
14257	973	738818	1993-12-03	1993-12-10	1	8744
20568	1401	1759842	1977-10-13	1977-10-27	1	2856
22387	1523	1125315	2014-08-14	2014-08-28	1	16310
64619	4411	1125315	1953-10-31	1953-11-30	1	-5876
9392	648	1125315	1980-04-13	1980-04-27	1	3769
74294	5079	738818	1970-12-22	1970-12-29	1	362
21442	1459	1729720	1949-01-23	1949-02-04	1	-7636
14258	973	1119510	1990-04-27	1990-05-11	1	7435
20569	1401	1759842	2002-01-27	2002-02-17	1	11735
22388	1523	1713332	2001-08-25	2001-09-08	1	11573
64620	4411	1713332	1980-09-22	1980-10-13	1	3938
9393	648	1125315	1991-12-20	1992-01-03	1	8037
74295	5079	1118084	2008-05-19	2008-05-19	1	14018
21443	1459	1759842	1972-03-26	1972-04-16	1	836
14259	973	1125315	1953-09-02	1953-09-16	1	-5951
20570	1401	19127890	1993-12-19	1994-12-14	1	9113
22389	1523	1713332	2011-09-27	2011-10-18	1	15265
64621	4411	738818	1993-08-16	1993-08-23	1	8635
9394	648	1125315	2005-08-27	2005-09-10	1	13036
74296	5079	1125315	1970-12-11	1970-12-29	2	362
21444	1459	1759842	2002-12-06	2003-02-07	1	12090
14260	973	1125315	1993-12-03	1993-12-10	1	8744
20571	1401	19127890	1995-12-09	1996-12-03	1	9833
22390	1523	1728416	1957-02-04	1957-02-18	1	-4700
64622	4411	738818	2002-07-08	2002-07-15	1	11883
9395	648	1322184	2015-09-25	2015-09-25	1	16703
74297	5079	1717327	1969-08-27	1969-09-10	1	-113
21445	1459	1112807	1943-02-08	1943-02-22	1	-9810
14261	973	1154343	1917-08-23	1917-08-23	1	-19124
20572	1401	1112807	1989-11-28	1989-12-12	1	7285
22391	1523	1759842	2011-09-27	2011-10-18	1	15265
64623	4411	1112807	1950-01-20	1950-03-21	1	-7226
9396	648	1347450	2015-09-25	2015-09-25	1	16703
74298	5079	1729720	1985-01-20	1985-01-29	1	5507
21446	1459	1125315	1990-06-02	1990-06-16	1	7471
14262	973	1177480	1998-02-16	1998-03-09	1	10294
20573	1401	1125315	1987-03-14	1987-05-13	2	6341
22392	1523	1713332	1971-05-30	1971-06-06	1	521
64624	4411	1118084	1984-01-22	1984-01-22	1	5134
9397	648	1118084	1971-07-25	1971-07-25	1	570
74299	5079	1728416	1970-12-11	1970-12-25	1	358
21447	1459	1713332	1972-01-12	1972-01-19	1	748
14263	973	1177480	2016-06-02	2016-06-16	1	16968
20574	1401	1503184	1987-01-25	1988-01-20	1	6593
23153	1571	1118084	1998-08-05	1998-08-05	1	10443
64625	4411	1125315	1951-04-24	1951-05-01	1	-6820
9398	648	1119510	1966-07-29	1966-08-12	1	-1238
74822	5121	1125315	2013-06-30	2013-07-14	1	15900
21448	1459	1112807	1944-11-29	1944-12-20	1	-9143
14264	973	1713332	1932-01-10	1932-01-31	1	-13850
20575	1401	1521369	1987-01-25	1988-01-20	1	6593
23154	1571	1125315	1995-01-25	1995-02-08	1	9169
64626	4411	1125315	1962-01-16	1962-01-23	1	-2900
9399	648	1125315	1944-03-16	1944-03-30	1	-9408
74823	5121	1125315	1988-10-12	1988-10-26	1	6873
21449	1459	1125315	1997-07-15	1997-09-13	1	10117
15131	1051	1112807	1970-01-14	1970-01-28	1	27
20576	1401	1521369	1991-01-04	1991-12-30	1	8033
23155	1571	1713332	1994-05-18	1994-06-01	1	8917
64627	4411	1125315	1993-08-16	1993-08-23	1	8635
9400	648	1125315	1993-05-05	1993-06-09	1	8560
74824	5121	1125315	2019-01-19	2019-01-26	1	17922
21450	1459	1713332	1972-03-26	1972-04-16	1	836
15132	1051	1125315	1982-02-12	1982-02-19	1	4432
20577	1401	1125315	1986-03-21	1986-04-18	1	5951
23156	1571	1713332	2011-06-25	2011-07-02	1	15157
64628	4411	1125315	2002-07-08	2002-07-15	1	11883
9401	648	1125315	1994-11-05	1994-11-12	1	9081
74825	5121	1118084	2000-02-01	2000-02-01	1	10988
21451	1459	1713332	2002-12-06	2003-02-07	1	12090
15133	1051	1154343	1969-02-15	1969-02-15	1	-320
20578	1401	1503184	1993-12-19	1994-12-14	1	9113
23157	1571	1729720	1967-04-28	1967-05-11	1	-966
64629	4411	1125315	1977-07-15	1977-07-22	1	2759
9402	648	1177480	2007-07-26	2007-10-24	1	13810
74826	5121	1125315	1964-11-16	1964-11-30	1	-1858
21452	1459	1759842	1972-01-12	1972-01-19	1	748
15134	1051	1177480	1988-08-07	1988-08-21	1	6807
20579	1401	1503184	1995-12-09	1996-12-03	1	9833
23158	1571	1119510	1959-07-08	1959-07-22	1	-3816
64630	4411	1713332	1979-02-16	1979-02-23	1	3340
9403	648	1729720	2016-05-28	2016-06-08	1	16960
74827	5121	1125315	1998-10-19	1998-11-16	1	10546
24230	1635	738818	1981-08-03	1981-08-17	1	4246
15135	1051	1759842	1975-09-20	1975-10-04	1	2102
20580	1401	1713332	1977-10-13	1977-10-27	1	2856
23159	1571	1125315	1980-03-06	1980-03-13	1	3724
64631	4411	1729720	2017-06-15	2017-06-26	1	17343
12482	859	738818	2003-06-17	2003-06-24	1	12227
74828	5121	1728416	1964-11-16	1964-11-30	1	-1858
24231	1635	1112807	1975-05-06	1975-05-20	1	1965
15136	1051	1759842	2005-08-16	2005-08-30	1	13025
20581	1401	19127890	1987-01-25	1988-01-20	1	6593
23160	1571	1177480	2001-03-27	2001-04-10	1	11422
64632	4411	1759842	1980-09-22	1980-10-13	1	3938
12483	859	1118084	1993-06-18	1993-06-18	1	8569
76644	5239	1125315	1968-10-11	1968-10-18	1	-440
24232	1635	1713332	1993-05-29	1993-06-26	1	8577
15137	1051	738818	2010-03-11	2010-03-25	1	14693
20582	1401	19127890	1991-01-04	1991-12-30	1	8033
23161	1571	1551099	1966-01-06	1966-01-06	1	-1456
66038	4513	738818	1966-03-01	1966-03-15	1	-1388
12484	859	1125315	1970-05-26	1970-06-09	1	159
76645	5239	1738521	1970-10-12	1970-10-26	1	298
24233	1635	1759842	1990-11-21	1990-12-05	1	7643
15138	1051	920293	2000-03-14	2000-03-28	2	11044
20583	1401	1124300	2007-08-03	2007-08-03	1	13728
23162	1571	738818	1959-07-08	1959-07-22	1	-3816
66039	4513	1112807	1967-05-23	1967-06-06	1	-940
12485	859	1125315	2003-06-17	2003-06-24	1	12227
76646	5239	1759842	2006-08-21	2006-08-28	1	13388
24234	1635	914335	2013-03-27	2013-03-27	1	15791
15139	1051	1118084	2001-03-17	2001-03-17	1	11398
20584	1401	1521369	1993-12-19	1994-12-14	1	9113
23163	1571	1112807	1971-02-03	1971-03-05	1	428
66040	4513	1125315	1966-03-01	1966-03-15	1	-1388
12486	859	1125315	2007-08-10	2007-09-07	1	13763
76647	5239	1112807	1966-07-22	1966-08-05	1	-1245
24235	1635	1343916	2013-03-27	2013-03-27	1	15791
15140	1051	1125315	1991-08-06	1991-08-20	1	7901
20585	1401	1521369	1995-12-09	1996-12-03	1	9833
23164	1571	1125315	1959-07-08	1959-07-22	1	-3816
66041	4513	1125315	1978-01-16	1978-04-16	1	3027
12487	859	1125315	2018-03-13	2018-04-10	1	17631
76648	5239	1112807	1970-10-12	1970-10-26	1	298
24236	1635	1729720	1983-03-29	1983-04-06	1	4843
15141	1051	1125315	2010-03-11	2010-03-25	1	14693
20586	1401	1713332	2002-01-27	2002-02-17	1	11735
23165	1571	1551099	1958-04-12	1958-04-12	1	-4282
66042	4513	1125315	1986-12-14	1986-12-28	1	6205
12488	859	1154343	1961-03-10	1961-03-10	1	-3219
76649	5239	1112807	1971-07-02	1971-07-16	1	561
24237	1635	1112807	1988-01-19	1988-02-16	1	6620
15142	1051	1521369	1985-12-31	1986-12-26	1	6203
20587	1401	1738521	1978-01-02	1978-01-16	1	2937
23166	1571	1729720	1979-02-15	1979-02-24	1	3341
66043	4513	1729720	1982-02-07	1982-02-16	1	4429
12489	859	1125315	1971-07-09	1971-07-23	1	568
76650	5239	1177480	1997-03-11	1997-06-09	1	10021
24238	1635	1118084	2012-02-21	2012-02-21	1	15391
15143	1051	1713332	2017-09-10	2017-09-24	1	17433
20588	1401	1759842	2001-08-09	2001-08-23	1	11557
23167	1571	1759842	1994-05-18	1994-06-01	1	8917
66044	4513	1729720	2014-07-07	2014-07-20	1	16271
12490	859	1129625	1959-03-25	1959-03-25	1	-3935
76651	5239	738818	2004-09-23	2004-10-07	1	12698
24239	1635	1119510	2014-07-30	2014-08-06	1	16288
15144	1051	1759842	2017-09-10	2017-09-24	1	17433
20589	1401	1759842	2005-04-25	2005-05-16	1	12919
23168	1571	1759842	2011-06-25	2011-07-02	1	15157
66045	4513	1125315	1969-02-03	1969-02-10	1	-325
12491	859	1177480	1979-10-31	1979-12-05	1	3625
76652	5239	1118084	2011-08-30	2011-08-30	1	15216
24240	1635	1125315	1981-08-03	1981-08-17	1	4246
15145	1051	933724	2000-03-14	2000-03-28	1	11044
23679	1605	1112807	1937-11-03	1937-11-17	1	-11733
25694	1743	1112807	1967-11-20	1967-12-11	1	-752
66046	4513	1125315	1978-12-05	1978-12-19	1	3274
12492	859	1713332	2018-12-17	2018-12-31	1	17896
76653	5239	1125315	1972-08-19	1972-10-18	1	1021
24241	1635	1728416	1975-05-06	1975-05-20	1	1965
15146	1051	1119510	2010-03-11	2010-03-25	1	14693
23680	1605	1112807	1948-12-13	1948-12-27	1	-7675
25695	1743	1125315	2006-07-03	2006-07-24	1	13353
66047	4513	1112807	1966-09-25	1966-10-16	1	-1173
12493	859	1112807	1969-01-28	1969-02-13	1	-322
76654	5239	1125315	1979-02-14	1979-05-15	2	3331
24242	1635	738818	2014-07-30	2014-08-06	1	16288
15147	1051	1129625	1970-03-01	1970-03-01	1	59
23681	1605	1124300	1971-08-09	1971-08-09	1	585
25696	1743	1713332	1985-05-25	1985-06-15	1	5644
66048	4513	1125315	1976-03-27	1976-03-27	1	2277
12494	859	1125315	1992-11-11	1992-11-18	1	8357
76655	5239	1125315	2004-09-23	2004-10-07	1	12698
24243	1635	1112807	1973-08-14	1973-11-12	1	1411
15148	1051	1149380	1969-02-15	1969-02-15	1	-320
23682	1605	1125315	2016-05-05	2016-05-26	1	16947
25697	1743	1713332	1986-08-16	1986-08-23	1	6078
66049	4513	1174888	1976-03-27	1976-03-27	1	2277
12495	859	1149380	1961-03-10	1961-03-10	1	-3219
76656	5239	1174888	1979-02-14	1979-02-14	1	3331
24244	1635	1119510	1981-08-03	1981-08-17	1	4246
15149	1051	1503184	1985-12-31	1986-12-26	1	6203
23683	1605	1309944	2019-05-12	2019-05-12	1	18028
25698	1743	1759842	1985-05-25	1985-06-15	1	5644
66050	4513	1177480	1976-03-27	1976-04-26	1	2307
12496	859	1177480	1996-05-09	1996-06-08	1	9655
76657	5239	1713332	2006-08-21	2006-08-28	1	13388
24245	1635	1125315	1976-07-29	1976-08-19	1	2422
15150	1051	1551099	1966-03-06	1966-03-06	1	-1397
23684	1605	1347450	2006-09-17	2006-09-17	1	13408
25699	1743	1759842	1986-08-16	1986-08-23	1	6078
66051	4513	1115008	2003-09-02	2003-10-07	1	12332
12497	859	1729720	1982-07-09	1982-07-20	1	4583
76658	5239	1119510	2004-09-23	2004-10-07	1	12698
24246	1635	1125315	2005-07-19	2005-08-02	1	12997
15151	1051	1713332	2005-08-16	2005-08-30	1	13025
23685	1605	1361711	2017-10-22	2017-10-22	1	17461
25700	1743	1125315	1968-03-20	1968-04-03	1	-638
66052	4513	1115008	2004-08-02	2004-10-01	1	12692
12498	859	1112807	1961-02-11	1961-03-11	1	-3218
76659	5239	1728416	1966-07-22	1966-08-05	1	-1245
24247	1635	1125315	2014-07-30	2014-08-06	1	16288
15152	1051	1125315	1975-06-17	1975-07-17	1	2023
23686	1605	1539403	2017-10-22	2017-10-22	1	17461
25701	1743	1112807	1965-12-30	1966-01-29	1	-1433
66053	4513	1118084	1995-12-27	1995-12-27	1	9491
12499	859	1119510	2003-06-17	2003-06-24	1	12227
76660	5239	1729720	2001-01-20	2001-01-29	1	11351
24248	1635	1309944	2013-03-27	2013-03-27	1	15791
15153	1051	1713332	1975-09-20	1975-10-04	1	2102
23687	1605	1713332	2003-09-10	2003-10-01	1	12326
25702	1743	1124300	2002-01-15	2002-01-15	1	11702
66054	4513	1119510	1966-03-01	1966-03-15	1	-1388
12500	859	1125315	1976-11-02	1976-11-09	1	2504
76661	5239	1738521	1971-07-02	1971-07-16	1	561
24249	1635	1713332	1990-11-21	1990-12-05	1	7643
15154	1051	19127890	1985-12-31	1986-12-26	1	6203
23688	1605	1759842	1989-08-23	1989-09-06	1	7188
25703	1743	1125315	2012-06-21	2012-07-05	1	15526
66055	4513	1738521	1967-05-23	1967-06-06	1	-940
12501	859	1738521	1969-01-30	1969-02-13	1	-322
24250	1635	1759842	1993-05-29	1993-06-26	1	8577
16408	1133	920293	2012-08-06	2012-08-13	1	15565
23689	1605	1759842	2018-08-03	2018-08-24	1	17767
25704	1743	1177480	1999-09-08	1999-10-08	1	10872
67604	4615	738818	1973-06-04	1973-06-18	1	1264
12502	859	1759842	2018-12-17	2018-12-31	1	17896
24836	1679	1102527	1989-07-01	1989-07-01	1	7121
16409	1133	1118084	2000-07-20	2000-07-20	1	11158
23690	1605	1112807	1937-02-23	1937-03-09	1	-11986
25705	1743	1738521	1969-01-13	1969-01-27	1	-339
67605	4615	1125315	2002-08-11	2002-08-25	1	11924
13883	951	1125315	1966-12-14	1967-01-04	1	-1093
24837	1679	1125315	1973-09-09	1973-09-23	1	1361
16410	1133	1119510	1973-03-30	1973-04-06	1	1191
23691	1605	1112807	1938-04-04	1938-04-18	1	-11581
25706	1743	1112807	1974-10-05	1974-10-19	1	1752
67606	4615	1177480	1984-01-09	1984-01-23	1	5135
13884	951	1125315	1990-12-09	1990-12-23	1	7661
24838	1679	1125315	1989-07-01	1989-09-29	1	7211
16411	1133	1119510	2005-10-16	2005-10-30	1	13086
23692	1605	1112807	1948-01-27	1948-02-17	1	-7989
25707	1743	1125315	1969-01-13	1969-01-27	1	-339
67607	4615	1503184	1974-03-21	1975-03-16	1	1900
13885	951	1177480	2008-02-24	2008-03-09	1	13947
24839	1679	1125315	2013-03-27	2013-04-17	1	15812
16412	1133	1729720	1968-05-12	1968-05-24	1	-587
23693	1605	1125315	1964-10-31	1964-11-14	1	-1874
25708	1743	1177480	2012-03-24	2012-04-14	1	15444
67608	4615	1728416	1957-04-09	1957-04-23	1	-4636
13886	951	1713332	2002-05-31	2002-06-21	1	11859
24840	1679	1729720	2012-06-30	2012-07-13	1	15534
16413	1133	19127890	1982-06-20	1983-06-15	1	4913
23694	1605	1125315	2011-05-22	2011-08-30	1	15216
26919	1820	920293	2008-03-11	2008-03-18	1	13956
67609	4615	738818	1963-08-08	1963-08-15	1	-2331
13887	951	1713332	2008-02-24	2008-03-09	1	13947
24841	1679	1759842	1985-10-17	1985-11-07	1	5789
16414	1133	738818	2005-10-16	2005-10-30	1	13086
23695	1605	1177480	1984-03-23	1984-04-27	1	5230
26920	1820	1119510	2010-11-20	2010-12-04	1	14947
67610	4615	1125315	1963-08-08	1963-08-15	1	-2331
13888	951	1713332	2013-12-27	2014-01-17	1	16087
24842	1679	1118084	2009-06-12	2009-06-12	1	14407
16415	1133	1125315	2005-10-16	2005-10-30	1	13086
23696	1605	1177480	1999-12-03	1999-12-31	1	10956
26921	1820	1125315	1989-08-25	1989-09-08	1	7190
67611	4615	1125315	1973-06-04	1973-06-18	1	1264
13889	951	1728416	1957-11-22	1957-12-06	1	-4409
24843	1679	1177480	1974-01-02	1974-01-16	1	1476
16416	1133	1125315	2011-03-10	2011-03-10	1	15043
23697	1605	1322184	2006-09-17	2006-09-17	1	13408
26922	1820	1521369	2001-12-16	2002-12-11	1	12032
67612	4615	1125315	2000-09-15	2000-09-29	1	11229
13890	951	1729720	2004-11-02	2004-11-13	1	12735
24844	1679	1729720	1974-08-06	1974-08-17	1	1689
16417	1133	1503184	1982-06-20	1983-06-15	1	4913
23698	1605	1125315	1992-01-16	1992-02-13	1	8078
26923	1820	1759842	1995-05-17	1995-05-24	1	9274
67613	4615	1125315	2004-12-25	2005-01-08	1	12791
13891	951	738818	1971-11-20	1971-12-04	1	702
24845	1679	1738521	1973-06-30	1973-07-14	1	1290
16418	1133	1759842	2002-08-26	2002-09-09	1	11939
23699	1605	1125315	1992-08-20	1992-08-27	1	8274
26924	1820	1759842	2015-07-14	2015-08-04	1	16651
67614	4615	1177480	2011-04-24	2011-05-22	1	15116
13892	951	738818	1984-01-20	1984-02-03	1	5146
24846	1679	1125315	1971-10-20	1971-11-03	1	671
16419	1133	738818	1973-03-30	1973-04-06	1	1191
23700	1605	1174888	1999-12-03	1999-12-03	1	10928
26925	1820	738818	2010-11-20	2010-12-04	1	14947
67615	4615	1713332	1955-08-26	1955-09-16	1	-5221
13893	951	1125315	1967-12-30	1968-01-20	1	-712
24847	1679	1125315	2019-02-17	2019-02-24	1	17951
16420	1133	1124957	2011-03-10	2011-03-10	1	15043
23701	1605	1713332	1989-08-23	1989-09-06	1	7188
26926	1820	1124300	2014-08-17	2014-08-17	1	16299
67616	4615	1768849	2000-09-15	2000-09-29	1	11229
13894	951	1125315	1971-11-20	1971-12-04	1	702
24848	1679	1729720	2001-11-09	2001-11-22	1	11648
16421	1133	1125315	1973-03-30	1973-04-06	1	1191
23702	1605	1713332	2018-08-03	2018-08-24	1	17767
26927	1820	1125315	1984-01-09	1984-01-23	1	5135
67617	4615	19127890	1974-03-21	1975-03-16	1	1900
13895	951	1125315	1984-01-20	1984-02-03	1	5146
24849	1679	1112807	1973-06-30	1973-07-14	1	1290
16422	1133	1177480	2011-03-10	2011-05-09	1	15103
23703	1605	1759842	2003-09-10	2003-10-01	1	12326
26928	1820	1125315	2006-12-02	2006-12-09	1	13491
67618	4615	1112807	1969-12-02	1969-12-30	1	-2
13896	951	1125315	1995-09-25	1995-11-24	1	9458
24850	1679	1125315	2009-04-04	2009-04-11	1	14345
16423	1133	1521369	1982-06-20	1983-06-15	1	4913
23704	1605	914335	2019-05-12	2019-05-12	1	18028
26929	1820	1125315	2010-11-20	2010-12-04	1	14947
67619	4615	1118084	1995-05-30	1995-05-30	1	9280
13897	951	1177480	2019-01-22	2019-02-26	1	17953
24851	1679	1713332	1985-10-17	1985-11-07	1	5789
16424	1133	933724	2012-08-06	2012-08-13	1	15565
23705	1605	1125315	1958-06-08	1958-07-08	1	-4195
26930	1820	1177480	1992-07-23	1992-08-13	1	8260
67620	4615	1119510	1973-06-04	1973-06-18	1	1264
13898	951	1112807	1957-11-22	1957-12-06	1	-4409
24852	1679	1717327	1974-01-02	1974-01-16	1	1476
16425	1133	1112807	1973-10-25	1973-12-24	1	1453
23706	1605	1125315	1999-12-03	1999-12-03	1	10928
26931	1820	1347450	2004-09-14	2004-09-14	1	12675
67621	4615	1713332	1984-01-09	1984-01-23	1	5135
13899	951	1118084	1985-10-15	1985-10-15	1	5766
26423	1785	1125315	1958-05-07	1958-06-11	1	-4222
16426	1133	1713332	2002-08-26	2002-09-09	1	11939
23707	1605	1322184	2017-10-22	2017-10-22	1	17461
26932	1820	1515774	1999-12-27	2000-12-21	1	11312
67622	4615	1759842	1955-08-26	1955-09-16	1	-5221
13900	951	1119510	1971-11-20	1971-12-04	1	702
26424	1785	1177480	2001-10-28	2001-11-18	1	11644
18477	1271	738818	1968-09-01	1968-09-15	1	-473
23708	1605	1332418	2017-10-22	2017-10-22	1	17461
26933	1820	1521369	1997-01-08	1998-01-03	1	10229
67623	4615	920293	1988-05-15	1988-05-22	1	6716
13901	951	1119510	1984-01-20	1984-02-03	1	5146
26425	1785	1713332	2016-01-12	2016-01-26	1	16826
18478	1271	1125315	1968-09-01	1968-09-15	1	-473
23709	1605	1343916	2019-05-12	2019-05-12	1	18028
26934	1820	19127890	1999-12-27	2000-12-21	1	11312
67624	4615	933724	1988-05-15	1988-05-22	1	6716
13902	951	1125315	1954-11-17	1954-12-01	1	-5510
26426	1785	1125315	2013-09-25	2013-10-09	1	15987
18479	1271	1125315	1978-12-20	1979-01-10	1	3296
23710	1605	1768849	1999-12-03	1999-12-31	1	10956
26935	1820	1177480	1995-04-30	1995-05-14	1	9264
67625	4615	1112807	1957-04-09	1957-04-23	1	-4636
13903	951	1728416	1954-11-17	1954-12-01	1	-5510
26427	1785	1125315	2016-01-12	2016-01-26	1	16826
18480	1271	1118084	2010-10-14	2010-10-14	1	14896
25969	1759	1119510	2005-06-25	2005-07-02	1	12966
26936	1820	1322184	2004-09-14	2004-09-14	1	12675
67626	4615	1112807	1957-10-25	1957-11-08	1	-4437
13904	951	1759842	2002-05-31	2002-06-21	1	11859
26428	1785	1759842	1957-04-26	1957-05-03	1	-4626
18481	1271	1119510	1968-09-01	1968-09-15	1	-473
25970	1759	1125315	2005-06-25	2005-07-02	1	12966
26937	1820	1503184	1997-01-08	1998-01-03	1	10229
67627	4615	1119510	1963-08-08	1963-08-15	1	-2331
13905	951	1759842	2013-12-27	2014-01-17	1	16087
26429	1785	1112807	1956-08-24	1956-09-14	1	-4857
18482	1271	1521369	1981-12-30	1982-12-25	1	4741
25971	1759	1549786	2007-11-11	2009-02-23	2	14298
26938	1820	1515774	1995-01-19	1996-01-14	1	9509
67628	4615	1521369	1974-03-21	1975-03-16	1	1900
19292	1320	1125315	1971-10-06	1971-10-13	1	650
26430	1785	1112807	1962-06-20	1962-07-25	1	-2717
18483	1271	1125315	1986-02-10	1986-02-17	1	5891
25972	1759	1595799	2003-12-02	2004-11-26	1	12748
26939	1820	1549786	1995-01-19	1996-01-14	1	9509
67629	4615	1728416	1957-10-25	1957-11-08	1	-4437
19293	1320	1125315	1985-10-11	1985-10-18	1	5769
26431	1785	1124300	1990-12-14	1990-12-14	1	7652
18484	1271	1125315	1991-07-23	1991-07-30	1	7880
25973	1759	738818	2005-06-25	2005-07-02	1	12966
26940	1820	1549786	1999-12-27	2000-12-21	1	11312
70884	4843	1118084	1997-11-28	1997-11-28	1	10193
19294	1320	1174888	1998-09-12	1998-09-12	1	10481
26432	1785	1125315	1961-05-26	1961-06-25	1	-3112
18485	1271	1503184	1981-12-30	1982-12-25	1	4741
25974	1759	1118084	2019-03-08	2019-03-08	1	17963
26941	1820	1595799	2001-12-16	2002-12-11	1	12032
70885	4843	1177480	1980-05-16	1980-06-13	1	3816
19295	1320	1177480	2019-05-25	2019-06-15	1	18062
26433	1785	1713332	1957-04-26	1957-05-03	1	-4626
18486	1271	1729720	1979-04-06	1979-04-19	1	3395
25975	1759	1125315	1990-02-26	1990-03-12	1	7375
26942	1820	1713332	1995-05-17	1995-05-24	1	9274
70886	4843	1125315	1963-03-18	1963-03-25	1	-2474
19296	1320	1713332	1953-12-01	1953-12-22	1	-5854
27120	1834	738818	1988-12-08	1988-12-22	1	6930
18487	1271	1112807	1969-10-24	1969-11-07	1	-55
25976	1759	1125315	1993-12-16	1993-12-23	1	8757
26943	1820	1713332	2015-07-14	2015-08-04	1	16651
70887	4843	1125315	1984-06-22	1984-09-20	1	5376
19297	1320	701322	2017-09-08	2017-09-08	1	17417
27121	1834	1125315	1981-04-05	1981-05-10	1	4147
18488	1271	19127890	1981-12-30	1982-12-25	1	4741
25977	1759	1125315	2001-09-25	2001-10-02	1	11597
26944	1820	933724	2008-03-11	2008-03-18	1	13956
70888	4843	1125315	1988-08-13	1988-08-20	1	6806
19298	1320	715997	2017-09-08	2017-09-08	1	17417
27122	1834	1125315	1988-12-08	1988-12-22	1	6930
19208	1316	1112807	1949-10-21	1949-11-04	1	-7363
25978	1759	1125315	2006-01-29	2006-02-05	1	13184
26945	1820	1549786	2001-12-16	2002-12-11	1	12032
70889	4843	1102527	1974-06-17	1974-06-17	1	1628
19299	1320	738818	1992-01-20	1992-01-27	1	8061
27123	1834	1361711	2014-07-20	2014-07-20	1	16271
19209	1316	1112807	1959-12-28	1960-01-18	1	-3636
25979	1759	1595799	1998-12-28	1999-12-23	1	10948
26946	1820	1713332	1984-03-13	1984-03-20	1	5192
70890	4843	1112807	1974-06-17	1974-08-16	1	1688
19300	1320	1125315	1990-05-06	1990-05-20	1	7444
27124	1834	1759842	1969-04-07	1969-05-05	1	-241
19210	1316	1112807	1968-05-05	1968-06-09	1	-571
25980	1759	1595799	2000-12-17	2001-12-12	1	11668
26947	1820	1729720	1982-03-19	1982-03-31	1	4472
70891	4843	1119510	2009-06-13	2009-06-20	1	14415
19301	1320	1125315	1993-08-09	1993-10-08	1	8681
27125	1834	1112807	1946-10-31	1946-11-14	1	-8449
19211	1316	1118084	1994-05-03	1994-05-03	1	8888
25981	1759	1713332	1987-11-30	1987-12-14	1	6556
26948	1820	1759842	1984-03-13	1984-03-20	1	5192
70892	4843	1125315	1964-02-10	1964-02-24	1	-2138
19302	1320	1177480	2006-03-04	2006-04-03	1	13241
27126	1834	1112807	1960-04-25	1960-06-24	1	-3478
19212	1316	1125315	1985-06-02	1985-06-09	1	5638
25982	1759	920293	2017-01-30	2017-02-13	2	17210
26949	1820	19127890	1995-01-19	1996-01-14	1	9509
70893	4843	1125315	1984-05-05	1984-05-19	1	5252
19303	1320	1759842	1953-12-01	1953-12-22	1	-5854
27127	1834	1118084	1986-07-13	1986-07-13	1	6037
19213	1316	1125315	2013-03-13	2013-03-27	1	15791
25983	1759	1125315	1987-11-30	1987-12-14	1	6556
26950	1820	19127890	1997-01-08	1998-01-03	1	10229
70894	4843	1125315	2009-06-13	2009-06-20	1	14415
19304	1320	1759842	2000-04-03	2000-04-24	1	11071
27128	1834	1119510	1971-06-11	1971-06-25	1	540
19214	1316	1125315	2013-04-30	2013-05-14	1	15839
25984	1759	1125315	1993-02-17	1993-03-10	1	8469
27979	1898	1118084	2011-08-14	2011-08-14	1	15200
70895	4843	1713332	1980-02-21	1980-03-13	1	3724
19305	1320	1759842	2018-03-29	2018-04-05	1	17626
27129	1834	1119510	1993-12-09	1993-12-23	1	8757
19215	1316	1729720	2004-08-16	2004-08-26	1	12656
25985	1759	1125315	2012-09-15	2012-09-22	1	15605
27980	1898	1119510	1986-10-24	1986-10-31	1	6147
70896	4843	1728416	1964-02-10	1964-02-24	1	-2138
19306	1320	757627	2016-10-13	2016-10-13	1	17087
27130	1834	1124957	1960-04-25	1960-04-25	1	-3538
19216	1316	1125315	1998-03-22	1998-03-29	1	10314
25986	1759	1177480	1986-01-25	1986-02-08	1	5882
27981	1898	1759842	2007-12-16	2008-01-06	1	13884
70897	4843	1759842	1980-02-21	1980-03-13	1	3724
19307	1320	1112807	1937-02-15	1937-03-01	1	-11994
27131	1834	1125315	1954-12-18	1955-01-22	1	-5458
19217	1316	1125315	2004-07-26	2004-08-09	1	12639
25987	1759	1515774	2007-11-11	2008-11-05	1	14188
27982	1898	1174888	1996-05-15	1996-05-15	1	9631
70898	4843	738818	2009-06-13	2009-06-20	1	14415
19308	1320	1112807	1947-09-21	1947-10-12	1	-8117
27132	1834	1322184	2014-07-20	2014-07-20	1	16271
19218	1316	1125315	2006-08-19	2006-09-16	1	13407
25988	1759	1521369	1998-12-28	1999-12-23	1	10948
27983	1898	1177480	1994-06-04	1994-06-25	1	8941
70899	4843	1729720	1965-09-04	1965-09-13	1	-1571
19309	1320	1119510	1992-01-20	1992-01-27	1	8061
27133	1834	1332418	2014-07-20	2014-07-20	1	16271
19219	1316	1713332	1997-11-20	1997-12-11	1	10206
25989	1759	1521369	2000-12-17	2001-12-12	1	11668
27984	1898	1177480	1996-05-15	1996-06-14	1	9661
70900	4843	1729720	1981-12-22	1981-12-29	1	4380
19310	1320	1125315	1946-05-31	1946-06-07	1	-8609
27134	1834	1713332	1969-04-07	1969-05-05	1	-241
19220	1316	1728416	1949-10-21	1949-11-04	1	-7363
25990	1759	1713332	1990-02-26	1990-03-12	1	7375
27985	1898	1177480	2011-08-25	2011-09-15	1	15232
70901	4843	1729720	2001-02-18	2001-02-27	1	11380
19311	1320	1557272	1995-06-15	1995-06-15	1	9296
27135	1834	1728416	1946-10-31	1946-11-14	1	-8449
19221	1316	738818	1949-12-22	1950-01-05	1	-7301
25991	1759	19127890	2007-11-11	2008-11-05	1	14188
27986	1898	738818	2013-05-25	2013-06-01	1	15857
72318	4942	1310149	2004-04-29	2004-04-29	1	12537
19312	1320	1713332	2000-04-03	2000-04-24	1	11071
27136	1834	1729720	1987-05-14	1987-05-23	1	6351
19222	1316	1115008	2018-09-27	2018-12-26	1	17891
25992	1759	933724	2017-01-30	2017-02-13	1	17210
27987	1898	1119510	2013-05-25	2013-06-01	1	15857
72319	4942	1539403	1992-12-31	1992-12-31	1	8400
19313	1320	1713332	2018-03-29	2018-04-05	1	17626
27137	1834	1115008	2009-01-13	2009-02-17	1	14292
19223	1316	1125315	1949-12-22	1950-01-05	1	-7301
25993	1759	1500211	2005-11-21	2006-11-16	1	13468
27988	1898	1125315	1996-05-15	1996-05-15	1	9631
72320	4942	1729720	1960-03-29	1960-04-10	1	-3553
19314	1320	1112807	1939-02-26	1939-03-12	1	-11253
27138	1834	1119510	1988-12-08	1988-12-22	1	6930
19224	1316	1125315	1976-09-26	1976-10-03	1	2467
25994	1759	1521369	2002-12-07	2004-11-26	2	12748
27989	1898	1125315	2007-09-12	2007-09-19	1	13775
72321	4942	1112807	1955-02-23	1955-04-24	1	-5366
19315	1320	1112807	1939-10-09	1939-10-23	1	-11028
27139	1834	1125315	1971-06-11	1971-06-25	1	540
19225	1316	1728416	1950-08-24	1950-09-07	1	-7056
25995	1759	1521369	2006-11-16	2007-11-11	1	13828
27990	1898	1125315	2013-05-25	2013-06-01	1	15857
72322	4942	1112807	1985-09-09	1985-09-30	1	5751
19316	1320	1112807	1959-10-09	1959-11-06	1	-3709
27140	1834	1539403	2014-07-20	2014-07-20	1	16271
19226	1316	1759842	1958-07-14	1958-08-04	1	-4168
25996	1759	1549786	1998-12-28	1999-12-23	1	10948
27991	1898	738818	1986-10-24	1986-10-31	1	6147
72323	4942	1118084	1986-12-07	1986-12-07	1	6184
19317	1320	1118084	1973-08-15	1973-08-15	1	1322
27141	1834	1713332	1976-01-06	1976-01-20	1	2210
19227	1316	1759842	1997-11-20	1997-12-11	1	10206
25997	1759	1549786	2000-12-17	2001-12-12	1	11668
27992	1898	1112807	1973-11-21	1973-12-05	1	1434
72324	4942	1125315	1957-03-14	1957-03-28	1	-4662
19318	1320	1125315	1992-01-20	1992-01-27	1	8061
27142	1834	1729720	1970-12-13	1970-12-25	1	358
19228	1316	1119510	1949-12-22	1950-01-05	1	-7301
25998	1759	1549786	2003-12-02	2004-11-26	1	12748
27993	1898	1125315	1979-10-23	1979-10-30	1	3589
72325	4942	1125315	1981-12-08	1981-12-29	1	4380
19319	1320	1125315	1998-09-12	1998-09-12	1	10481
27143	1834	1729720	1985-01-13	1985-01-21	1	5499
19229	1316	1125315	1950-08-24	1950-09-07	1	-7056
25999	1759	1589505	2008-11-05	2009-02-23	1	14298
27994	1898	1125315	1986-10-24	1986-10-31	1	6147
72326	4942	1125315	1986-12-08	1986-12-15	1	6192
19320	1320	1177480	1998-09-12	1998-11-11	1	10541
27144	1834	1729720	2016-05-17	2016-05-30	1	16951
19230	1316	1125315	1952-03-18	1952-04-01	1	-6484
26000	1759	1713332	1986-01-25	1986-02-08	1	5882
27995	1898	1713332	2007-12-16	2008-01-06	1	13884
72327	4942	1332418	1995-01-05	1995-01-05	1	9135
21681	1476	1112807	1955-02-19	1955-03-12	1	-5409
27145	1834	1759842	1978-06-14	1978-06-21	1	3093
19231	1316	1125315	1953-03-23	1953-03-30	1	-6121
26698	1804	920293	1976-11-11	1976-11-18	1	2513
27996	1898	1717327	1973-11-21	1973-12-05	1	1434
72328	4942	1347450	2006-08-03	2006-08-03	1	13363
21682	1476	1112807	1978-08-22	1978-10-21	1	3215
27146	1834	738818	1971-06-11	1971-06-25	1	540
19232	1316	1713332	1958-07-14	1958-08-04	1	-4168
26699	1804	933724	1976-11-11	1976-11-18	1	2513
27997	1898	1729720	1991-04-03	1991-04-16	1	7775
72329	4942	933724	2003-05-20	2003-06-03	1	12206
21683	1476	1125315	1956-11-01	1956-11-01	1	-4809
27147	1834	738818	1993-12-09	1993-12-23	1	8757
19233	1316	1729720	1963-09-29	1963-10-08	1	-2277
26700	1804	1112807	1937-11-14	1937-11-28	1	-11722
28435	1926	1118084	2006-06-16	2006-06-16	1	13315
72330	4942	1112807	1954-11-25	1954-12-09	1	-5502
21684	1476	1322184	2011-05-26	2011-05-26	1	15120
27148	1834	1112807	1955-11-18	1955-12-18	1	-5128
21753	1480	1112807	1974-09-06	1974-09-20	1	1723
26701	1804	1118084	1972-05-22	1972-05-22	1	872
28436	1926	1125315	2016-01-11	2016-01-18	1	16818
72331	4942	1322184	1997-01-09	2006-08-03	1	13363
21685	1476	1326303	2003-11-27	2003-11-27	1	12383
27149	1834	1125315	1955-05-18	1955-06-01	1	-5328
21754	1480	1125315	1971-10-24	1971-11-07	1	675
26702	1804	1112807	1955-10-29	1955-11-12	1	-5164
28437	1926	1177480	1974-09-12	1974-09-26	1	1729
72332	4942	1361711	1982-10-14	1982-10-14	1	4669
21686	1476	1347450	2011-05-26	2011-05-26	1	15120
27150	1834	1125315	1960-04-25	1960-04-25	1	-3538
21755	1480	1125315	1973-07-13	1973-10-11	1	1379
26703	1804	1119510	1981-09-14	1981-09-21	1	4281
28438	1926	1177480	1988-09-20	1988-10-04	1	6851
72333	4942	1759842	1961-07-23	1961-07-30	1	-3077
21687	1476	1713332	1967-09-02	1967-09-09	1	-845
27151	1834	1125315	1969-10-02	1969-10-09	1	-84
21756	1480	1177480	1980-03-22	1980-04-12	1	3754
26704	1804	1125315	1986-06-02	1986-06-23	1	6017
28439	1926	1177480	2017-12-21	2018-01-18	1	17549
72334	4942	920293	2003-05-20	2003-06-03	2	12206
21688	1476	1729720	2002-11-07	2002-11-20	1	12011
27152	1834	1125315	1993-12-09	1993-12-23	1	8757
21757	1480	1177480	2000-10-24	2000-11-07	1	11268
26705	1804	1125315	1989-07-12	1989-07-19	1	7139
28440	1926	1503184	1988-03-17	1989-03-12	1	7010
72335	4942	1115008	1998-04-16	1998-05-21	1	10367
21689	1476	1759842	1948-11-11	1948-11-18	1	-7714
27153	1834	1713332	1978-06-14	1978-06-21	1	3093
21758	1480	1361711	2006-08-04	2006-08-04	1	13364
26706	1804	1347450	1999-06-14	1999-06-14	1	10756
28441	1926	1713332	1995-07-25	1995-08-01	1	9343
72336	4942	1125315	1972-11-04	1972-11-25	1	1059
21690	1476	1759842	1958-12-14	1958-12-28	1	-4022
27154	1834	1759842	1976-01-06	1976-01-20	1	2210
21759	1480	1713332	1969-06-10	1969-07-01	1	-184
26707	1804	1112807	1936-03-12	1936-03-26	1	-12334
28442	1926	1717327	1974-09-12	1974-09-26	1	1729
72337	4942	1125315	1989-12-16	1989-12-23	1	7296
21691	1476	1149380	1946-09-21	1946-09-21	1	-8503
29410	1990	1125315	1970-05-07	1970-05-14	1	133
21760	1480	705944	1975-01-19	1975-02-16	1	1872
26708	1804	1112807	1940-03-10	1940-03-24	1	-10875
28443	1926	1738521	1973-03-26	1973-04-09	1	1194
72338	4942	1177480	1994-10-13	1994-11-03	1	9072
21692	1476	1307863	2003-11-27	2003-11-27	1	12383
29411	1990	1125315	2001-03-15	2001-04-14	1	11426
21761	1480	1119510	1989-05-06	1989-05-13	1	7072
26709	1804	1125315	1981-09-14	1981-09-21	1	4281
28444	1926	1112807	1975-10-18	1975-11-01	1	2130
72339	4942	1307863	2004-04-29	2004-04-29	1	12537
21693	1476	1713332	1948-11-11	1948-11-18	1	-7714
29412	1990	19127890	1983-05-08	1985-04-27	2	5595
21762	1480	1125315	1968-02-10	1968-02-24	1	-677
26710	1804	1322184	1999-06-14	1999-06-14	1	10756
28445	1926	1112807	1984-06-26	1984-08-25	1	5350
72340	4942	1326303	2004-04-29	2004-04-29	1	12537
21694	1476	1713332	1958-12-14	1958-12-28	1	-4022
29413	1990	738818	1980-11-18	1980-12-02	1	3988
21763	1480	1125315	2006-08-04	2006-08-04	1	13364
26711	1804	738818	1981-09-14	1981-09-21	1	4281
28446	1926	1125315	1973-11-14	1973-11-28	1	1427
72341	4942	1713332	1961-07-23	1961-07-30	1	-3077
21695	1476	1759842	1967-09-02	1967-09-09	1	-845
29414	1990	1118084	2005-05-07	2005-05-07	1	12910
21764	1480	1759842	1969-06-10	1969-07-01	1	-184
26712	1804	1729720	1945-02-08	1945-02-19	1	-9082
28447	1926	1125315	2000-01-06	2000-01-20	1	10976
72342	4942	1728416	1954-11-25	1954-12-09	1	-5502
21696	1476	1112807	1956-11-01	1956-12-31	1	-4749
29415	1990	1125315	1975-04-10	1975-07-09	1	2015
21765	1480	1125315	2001-12-26	2002-01-02	1	11689
29793	2016	1115008	2003-05-07	2003-05-21	1	12193
28448	1926	1521369	1988-03-17	1989-03-12	1	7010
74233	5076	1118084	1976-04-17	1976-04-17	1	2298
21697	1476	1125315	1961-08-21	1961-10-20	1	-2995
29416	1990	1125315	1980-11-18	1980-12-02	1	3988
21766	1480	1174888	2006-08-04	2006-08-04	1	13364
29794	2016	1503184	1996-11-25	1997-11-20	1	10185
28449	1926	1112807	1973-03-26	1973-04-09	1	1194
74234	5076	1125315	1942-02-16	1942-02-23	1	-10174
21698	1476	1557272	2004-12-02	2004-12-02	1	12754
29417	1990	1125315	2011-06-28	2011-07-12	1	15167
21767	1480	1322184	2006-08-04	2006-08-04	1	13364
29795	2016	1595799	1999-11-10	2000-11-04	1	11265
28450	1926	1125315	1984-06-26	1984-06-26	1	5290
74235	5076	1125315	1988-03-13	1988-03-27	1	6660
21699	1476	1759842	1949-08-23	1949-09-27	1	-7401
29418	1990	1729720	1996-05-21	1996-06-01	1	9648
21768	1480	1545958	2006-08-04	2006-08-04	1	13364
29796	2016	19127890	1996-11-25	1997-11-20	1	10185
28451	1926	1174888	1984-06-26	1984-06-26	1	5290
74236	5076	1177480	1983-04-05	1983-04-26	1	4863
21700	1476	1112807	1957-10-27	1957-11-10	1	-4435
29419	1990	1124957	1978-06-23	1978-06-23	1	3095
21769	1480	738818	1989-05-06	1989-05-13	1	7072
29797	2016	1112807	1989-05-26	1989-06-16	1	7106
28452	1926	1729720	1978-07-02	1978-07-10	1	3112
74237	5076	1713332	2004-10-02	2004-11-06	1	12728
21701	1476	1124300	1980-06-27	1980-06-27	1	3830
29420	1990	1125315	1978-06-23	1978-07-14	2	3116
21770	1480	1118084	2001-07-01	2001-07-01	1	11504
29798	2016	1125315	1981-03-09	1981-03-23	1	4099
28453	1926	1759842	1995-07-25	1995-08-01	1	9343
74238	5076	1112807	1952-08-02	1952-08-16	1	-6347
21702	1476	1124957	1956-11-01	1956-11-01	1	-4809
29421	1990	1521369	1983-05-08	1985-04-27	2	5595
21771	1480	1125315	1982-02-23	1982-03-09	1	4450
29799	2016	1125315	1998-05-11	1998-05-25	1	10371
28454	1926	1778162	1988-09-20	1988-10-04	1	6851
74239	5076	1177480	2005-09-02	2005-11-01	1	13088
21703	1476	1125315	1978-08-18	1978-09-01	1	3165
29422	1990	1717327	1970-04-25	1970-05-09	1	128
21772	1480	1125315	1989-05-06	1989-05-13	1	7072
29800	2016	1549786	1999-11-10	2000-11-04	1	11265
28455	1926	1115008	2005-07-27	2005-08-26	1	13021
74240	5076	1738521	1975-11-15	1975-12-13	1	2172
21704	1476	1154343	1946-09-21	1946-09-21	1	-8503
29423	1990	1112807	1970-04-25	1970-05-09	1	128
21773	1480	1125315	2006-04-11	2006-04-18	1	13256
29801	2016	1115008	2002-06-13	2002-07-11	1	11879
28456	1926	1125315	1986-05-17	1986-06-07	1	6001
74241	5076	1112807	1938-06-06	1938-06-20	1	-11518
21705	1476	1310149	2003-11-27	2003-11-27	1	12383
29424	1990	1119510	1980-11-18	1980-12-02	1	3988
22983	1560	1112807	1941-09-28	1941-10-12	1	-10308
29802	2016	1115008	2011-09-06	2011-10-06	1	15253
28457	1926	19127890	1988-03-17	1989-03-12	1	7010
74242	5076	1115008	2004-10-02	2004-11-06	1	12728
21706	1476	1713332	1949-08-23	1949-09-27	1	-7401
29425	1990	1125315	1968-06-15	1968-06-29	1	-551
22984	1560	1118084	1974-12-20	1974-12-20	1	1814
29803	2016	1125315	1983-09-06	1983-09-20	1	5010
30939	2090	738818	1969-11-14	1969-11-21	1	-41
74243	5076	1119510	2003-01-09	2003-01-23	1	12075
22923	1556	1125315	1989-01-04	1989-01-25	1	6964
29426	1990	1125315	1998-04-10	1998-04-24	1	10340
22985	1560	1125315	1946-07-16	1946-07-23	1	-8563
29804	2016	1115008	1998-05-30	1998-07-04	1	10411
30940	2090	914335	1974-03-20	1974-03-20	1	1539
74244	5076	1125315	1975-11-15	1975-12-13	1	2172
22924	1556	1177480	1990-02-19	1990-03-05	1	7368
29427	1990	1125315	2014-07-06	2014-07-20	1	16271
22986	1560	1125315	1997-12-12	1997-12-26	1	10221
29805	2016	1118084	2017-03-20	2017-03-20	1	17245
30941	2090	920293	1994-07-01	1994-07-08	1	8954
74245	5076	738818	2003-01-09	2003-01-23	1	12075
22925	1556	1177480	2004-04-20	2004-07-19	1	12618
29428	1990	1503184	1983-05-08	1985-04-27	2	5595
22987	1560	1307863	2018-02-05	2018-02-05	1	17567
29806	2016	1521369	1996-11-25	1997-11-20	1	10185
30942	2090	1125315	1976-06-08	1976-07-06	1	2378
74246	5076	1102527	1975-11-15	1975-11-15	1	2144
22926	1556	1503184	1988-03-20	1989-03-15	1	7013
29429	1990	1717327	1978-06-23	1978-07-14	1	3116
22988	1560	1326303	2018-02-05	2018-02-05	1	17567
29807	2016	1521369	1999-11-10	2000-11-04	1	11265
30943	2090	1125315	1999-05-05	1999-05-12	1	10723
74247	5076	1112807	1946-09-22	1946-10-27	1	-8467
22927	1556	1521369	1988-03-20	1989-03-15	1	7013
29430	1990	1729720	2002-11-28	2002-12-07	1	12028
22989	1560	1112807	1940-06-16	1940-07-07	1	-10770
29808	2016	1738521	1981-03-09	1981-03-23	1	4099
30944	2090	1503184	1985-05-02	1986-04-27	1	5960
74248	5076	1112807	1947-11-21	1947-12-12	1	-8056
22928	1556	1521369	1990-03-10	1991-03-05	1	7733
30666	2076	1713332	2016-07-25	2016-11-07	1	17112
22990	1560	1119510	1963-04-07	1963-04-14	1	-2454
34025	2309	738818	1990-08-29	1990-09-05	1	7552
30945	2090	1521369	1989-04-11	1990-04-06	1	7400
74249	5076	1125315	1951-09-04	1951-09-18	1	-6680
22929	1556	1551099	1973-09-25	1973-09-25	1	1363
30667	2076	1729720	1982-12-07	1982-12-18	1	4734
22991	1560	1125315	2009-02-05	2009-03-12	1	14315
34026	2309	1102527	1986-02-04	1986-02-04	1	5878
30946	2090	1124300	2002-06-12	2002-06-12	1	11850
74250	5076	1125315	2003-01-09	2003-01-23	1	12075
22930	1556	1713332	1985-02-19	1985-03-05	1	5542
30668	2076	1759842	2016-07-25	2016-11-07	1	17112
22992	1560	1112807	1937-05-14	1937-05-28	1	-11906
34027	2309	1125315	1980-04-06	1980-06-05	1	3808
30947	2090	1125315	1969-11-14	1969-11-21	1	-41
74251	5076	1125315	2009-04-02	2009-04-09	1	14343
22931	1556	1729720	1981-12-02	1981-12-14	1	4365
30669	2076	1124300	1999-11-11	1999-11-11	1	10906
22993	1560	1177480	2017-01-29	2017-04-29	1	17285
34028	2309	1177480	1986-02-04	1986-04-05	1	5938
30948	2090	1309944	1974-03-20	1974-03-20	1	1539
76598	5236	1124300	2009-05-19	2009-05-19	1	14383
22932	1556	1759842	1985-02-19	1985-03-05	1	5542
30670	2076	1125315	1976-11-27	1977-02-25	1	2612
22994	1560	1310149	2018-02-05	2018-02-05	1	17567
34029	2309	1177480	2005-07-22	2005-08-12	1	13007
30949	2090	1343916	1974-03-20	1974-03-20	1	1539
76599	5236	1125315	2004-11-28	2004-12-05	1	12757
22933	1556	1125315	2011-08-12	2011-08-26	1	15212
30671	2076	1125315	1987-12-09	1987-12-16	1	6558
22995	1560	1713332	1968-09-22	1968-09-29	1	-459
34030	2309	1125315	2018-01-06	2018-03-14	1	17604
30950	2090	1521369	1985-05-02	1986-04-27	1	5960
76600	5236	1125315	2005-09-28	2005-10-19	1	13075
22934	1556	1150770	1977-04-18	1977-04-18	1	2664
30672	2076	1125315	1988-03-17	1988-03-31	1	6664
22996	1560	738818	1963-04-07	1963-04-14	1	-2454
34031	2309	1759842	1986-10-25	1986-11-01	1	6148
30951	2090	933724	1994-07-01	1994-07-08	1	8954
76601	5236	1125315	2008-08-18	2008-09-01	1	14123
22935	1556	1713332	1982-02-09	1982-03-30	1	4471
30673	2076	1125315	1997-12-23	1998-01-06	1	10232
22997	1560	1112807	1935-04-14	1935-04-28	1	-12667
34032	2309	1759842	2000-10-31	2000-11-14	1	11275
30952	2090	1125315	2004-09-07	2004-12-06	1	12758
76602	5236	1125315	2017-10-12	2017-10-19	1	17458
22936	1556	1125315	1996-10-26	1996-11-09	1	9809
30674	2076	1125315	2005-07-10	2005-07-24	1	12988
22998	1560	1125315	1963-04-07	1963-04-14	1	-2454
34033	2309	1112807	1977-01-08	1977-01-22	1	2578
30953	2090	1125315	2011-06-10	2011-06-24	1	15149
76603	5236	1177480	1982-10-08	1982-10-29	1	4684
22937	1556	19127890	1988-03-20	1989-03-15	1	7013
30675	2076	1112807	1973-01-17	1973-02-16	1	1142
22999	1560	1759842	1968-09-22	1968-09-29	1	-459
34034	2309	1118084	2016-10-10	2016-10-10	1	17084
30954	2090	1503184	1989-04-11	1990-04-06	1	7400
76604	5236	1177480	2015-01-30	2015-03-06	1	16500
22938	1556	19127890	1990-03-10	1991-03-05	1	7733
30676	2076	1115008	2006-10-21	2006-11-25	1	13477
24377	1646	1112807	1943-09-16	1943-10-07	1	-9583
34035	2309	1125315	1990-08-29	1990-09-05	1	7552
30955	2090	1729720	2008-07-02	2008-07-14	1	14074
76605	5236	1713332	1993-02-26	1993-03-05	1	8464
22939	1556	1118084	2016-05-07	2016-05-07	1	16928
30677	2076	1125315	2017-12-27	2018-01-24	1	17555
24378	1646	1112807	1973-03-03	1973-03-17	1	1171
34036	2309	1713332	1986-10-25	1986-11-01	1	6148
30956	2090	19127890	1985-05-02	1986-04-27	1	5960
76606	5236	19127890	1988-02-19	1989-02-13	1	6983
22940	1556	1503184	1990-03-10	1991-03-05	1	7733
30678	2076	1759842	1969-10-19	1969-10-26	1	-67
24379	1646	1118084	1982-03-05	1982-03-05	1	4446
34037	2309	1713332	2000-10-31	2000-11-14	1	11275
30957	2090	1102527	2004-09-07	2004-09-07	1	12668
76607	5236	1125315	1986-07-10	1986-07-10	1	6034
22941	1556	1589505	1991-03-05	1992-02-28	1	8093
30679	2076	1125315	1970-11-08	1970-11-29	1	332
24380	1646	1125315	2010-12-12	2010-12-19	1	14962
34038	2309	1729720	1983-05-19	1983-05-27	1	4894
30958	2090	1112807	1971-03-07	1971-06-05	1	520
76608	5236	1174888	1986-07-10	1986-07-10	1	6034
22942	1556	1759842	1982-02-09	1982-03-30	1	4471
30680	2076	1125315	1972-07-02	1972-07-09	1	920
24381	1646	1125315	2014-02-10	2014-02-24	1	16125
34039	2309	1115008	2013-11-28	2013-12-28	1	16067
30959	2090	1119510	1969-11-14	1969-11-21	1	-41
76609	5236	1521369	1988-02-19	1989-02-13	1	6983
24195	1634	1112807	1939-03-08	1939-03-22	1	-11243
30681	2076	1125315	1984-04-16	1984-04-23	1	5226
24382	1646	1177480	2012-03-22	2012-05-21	1	15481
34040	2309	1119510	1990-08-29	1990-09-05	1	7552
30960	2090	1177480	2016-04-07	2016-04-21	1	16912
76610	5236	1717327	1976-10-09	1976-10-23	1	2487
24196	1634	1125315	1950-11-07	1950-11-21	1	-6981
30682	2076	1713332	1969-10-19	1969-10-26	1	-67
24383	1646	738818	1941-05-30	1941-06-13	1	-10429
34041	2309	1125315	1987-03-31	1987-04-28	1	6326
30961	2090	19127890	1989-04-11	1990-04-06	1	7400
76611	5236	1759842	1993-02-26	1993-03-05	1	8464
24197	1634	1125315	2017-09-10	2017-09-24	1	17433
34552	2339	1125315	2013-11-16	2013-11-23	1	16032
24384	1646	1119510	2018-03-23	2018-04-06	1	17627
34042	2309	1125315	1999-03-15	1999-03-29	1	10679
31616	2140	738818	1963-06-21	1963-07-05	1	-2372
76612	5236	1125315	1986-03-22	1986-04-05	1	5938
24198	1634	1713332	2002-03-07	2002-03-28	1	11774
34553	2339	1759842	1988-02-24	1988-03-09	1	6642
24385	1646	1125315	1941-05-30	1941-06-13	1	-10429
34043	2309	1713332	1998-10-20	1998-11-03	1	10533
31617	2140	1125315	1960-01-20	1960-03-20	1	-3574
76613	5236	1177480	1976-10-09	1976-10-23	1	2487
24199	1634	1729720	1948-08-05	1948-08-18	1	-7806
34554	2339	1118084	2006-04-01	2006-04-01	1	13239
24386	1646	1125315	1946-01-14	1946-01-28	1	-8739
34044	2309	1729720	1977-09-07	1977-09-16	1	2815
31618	2140	1125315	1963-06-21	1963-07-05	1	-2372
76614	5236	1177480	1986-07-10	1986-10-08	1	6124
24200	1634	738818	1975-03-23	1975-03-30	1	1914
34555	2339	1125315	1984-12-17	1985-01-16	1	5494
24387	1646	1125315	1948-02-18	1948-03-03	1	-7974
34045	2309	1759842	1998-10-20	1998-11-03	1	10533
31619	2140	1125315	1964-12-25	1965-01-01	1	-1826
76615	5236	1503184	1988-02-19	1989-02-13	1	6983
24201	1634	1119510	1956-08-11	1956-08-25	1	-4877
34556	2339	1115008	2016-08-22	2016-09-05	1	17049
24388	1646	738818	2018-03-23	2018-04-06	1	17627
35605	2419	1112807	1955-11-22	1955-12-27	1	-5119
31620	2140	1119510	1962-10-08	1962-10-22	1	-2628
76616	5236	1713332	1992-06-15	1992-06-22	1	8208
24202	1634	1124300	1978-12-18	1978-12-18	1	3273
34557	2339	1192710	1977-09-11	1977-09-11	1	2810
24389	1646	1112807	1946-01-03	1946-01-17	1	-8750
35606	2419	1112807	1989-12-12	1990-02-10	1	7345
31621	2140	1713332	1999-02-08	1999-02-22	1	10644
76617	5236	1759842	1992-06-15	1992-06-22	1	8208
24203	1634	1125315	1975-03-23	1975-03-30	1	1914
34558	2339	1713332	1988-02-24	1988-03-09	1	6642
24390	1646	1119510	1941-05-30	1941-06-13	1	-10429
35607	2419	1125315	1972-11-19	1972-12-03	1	1067
31622	2140	738818	1962-10-08	1962-10-22	1	-2628
77119	5272	1119510	2016-11-13	2016-11-20	1	17125
24204	1634	1125315	1992-01-13	1992-01-20	1	8054
34559	2339	1102527	1984-12-17	1984-12-17	1	5464
24391	1646	1125315	1956-12-06	1956-12-20	1	-4760
35608	2419	1729720	1970-08-01	1970-08-09	1	220
31623	2140	1118084	1989-10-14	1989-10-14	1	7226
77120	5272	1125315	2013-02-17	2013-03-03	1	15767
24205	1634	1310149	2014-08-29	2014-08-29	1	16311
34560	2339	1125315	1995-01-24	1995-02-14	1	9175
24392	1646	1125315	2018-03-23	2018-04-06	1	17627
35609	2419	1759842	1951-01-26	1951-02-16	1	-6894
31624	2140	1119510	1963-06-21	1963-07-05	1	-2372
77121	5272	1729720	1921-01-12	1921-01-20	1	-17878
24206	1634	1322184	2016-03-11	2016-03-11	1	16871
34561	2339	1551099	1983-05-27	1983-05-27	1	4894
24393	1646	1177480	2017-12-31	2018-01-14	1	17545
35610	2419	1759842	1953-05-12	1953-05-19	1	-6071
31625	2140	1125315	1962-10-08	1962-10-22	1	-2628
77122	5272	1729720	1957-05-24	1957-05-31	1	-4598
24207	1634	701322	2015-01-15	2015-01-15	1	16450
35208	2389	1125315	1975-12-17	1976-01-16	1	2206
24394	1646	1728416	1956-12-06	1956-12-20	1	-4760
35611	2419	1124300	1979-10-02	1979-10-02	1	3561
31626	2140	1125315	1998-03-20	1998-04-03	1	10319
77123	5272	1729720	1966-12-25	1967-01-01	1	-1096
24208	1634	715997	2015-01-15	2015-01-15	1	16450
35209	2389	738818	1990-11-08	1990-11-22	1	7630
24395	1646	920293	1977-12-24	1977-12-31	1	2921
35612	2419	1125315	1948-07-03	1948-07-10	1	-7845
31627	2140	1729720	1989-11-22	1989-12-04	1	7277
77124	5272	738818	1949-04-29	1949-05-13	1	-7538
24209	1634	738818	1956-08-11	1956-08-25	1	-4877
35210	2389	1125315	1990-11-08	1990-11-22	1	7630
24396	1646	933724	1977-12-24	1977-12-31	1	2921
35613	2419	1713332	1977-10-29	1977-11-19	1	2879
31628	2140	1759842	1959-04-28	1959-05-05	1	-3894
77125	5272	738818	2016-11-13	2016-11-20	1	17125
24210	1634	1112807	1941-01-08	1941-01-22	1	-10571
35211	2389	1177480	1974-01-05	1974-01-26	1	1486
24397	1646	1713332	2017-12-31	2018-01-14	1	17545
35614	2419	1728416	1949-07-26	1949-08-09	1	-7450
31629	2140	1759842	1999-02-08	1999-02-22	1	10644
77126	5272	1125315	1949-04-29	1949-05-13	1	-7538
24211	1634	1115008	2008-01-17	2008-01-31	1	13909
35212	2389	1177480	1992-02-21	1992-03-06	1	8100
24678	1666	1112807	1940-02-07	1940-02-28	1	-10900
35615	2419	1112807	1949-07-26	1949-08-09	1	-7450
31630	2140	1125315	1952-09-28	1952-10-12	1	-6290
77127	5272	1125315	2016-11-13	2016-11-20	1	17125
24212	1634	1119510	1975-03-23	1975-03-30	1	1914
35213	2389	1177480	1992-12-31	1993-01-28	1	8428
24679	1666	1119510	2018-05-04	2018-05-18	1	17669
35616	2419	1119510	2000-01-30	2000-02-06	1	10993
31631	2140	1177480	1984-02-13	1984-03-05	1	5177
77128	5272	1118084	1952-05-31	1952-05-31	1	-6424
24213	1634	1125315	1956-08-11	1956-08-25	1	-4877
35214	2389	1729720	1979-06-10	1979-06-22	1	3459
24680	1666	1125315	1951-05-20	1951-05-27	1	-6794
35617	2419	1125315	2000-01-30	2000-02-06	1	10993
31632	2140	1713332	1959-04-28	1959-05-05	1	-3894
77129	5272	1119510	1949-04-29	1949-05-13	1	-7538
24214	1634	1125315	1971-02-18	1971-03-11	1	434
35215	2389	1118084	2008-08-09	2008-08-09	1	14100
24681	1666	1125315	1977-01-28	1977-02-18	1	2605
35618	2419	1759842	1977-10-29	1977-11-19	1	2879
31633	2140	1728416	1952-09-28	1952-10-12	1	-6290
77130	5272	1125315	1969-04-10	1969-04-17	1	-259
24215	1634	1125315	1981-07-16	1981-08-06	1	4235
35216	2389	1119510	1990-11-08	1990-11-22	1	7630
24682	1666	738818	1951-05-20	1951-05-27	1	-6794
35619	2419	738818	2000-01-30	2000-02-06	1	10993
34232	2325	1125315	1983-07-04	1983-07-11	1	4939
77131	5272	1125315	1972-01-04	1972-01-18	1	747
24216	1634	1125315	2006-07-07	2006-07-21	1	13350
35217	2389	1125315	1996-06-11	1996-06-18	1	9665
24683	1666	1119510	1948-08-25	1948-09-01	1	-7792
35620	2419	1112807	1959-05-10	1959-05-24	1	-3875
34233	2325	1125315	2007-10-06	2007-10-06	1	13792
77132	5272	1125315	2001-03-22	2001-04-05	1	11417
24217	1634	1307863	2014-08-29	2014-08-29	1	16311
38098	2591	1112807	1947-09-12	1947-12-11	1	-8057
24684	1666	1125315	1971-02-10	1971-02-24	1	419
35621	2419	1125315	1985-06-09	1985-06-16	1	5645
34234	2325	1177480	1996-05-15	1996-06-05	1	9652
77133	5272	1125315	2009-01-04	2009-01-11	1	14255
24218	1634	1347450	2016-03-11	2016-03-11	1	16871
38099	2591	1125315	1981-11-02	1981-11-16	1	4337
24685	1666	1125315	1991-09-03	1991-09-24	1	7936
35622	2419	1713332	1951-01-26	1951-02-16	1	-6894
34235	2325	1503184	1988-10-04	1989-09-29	1	7211
77134	5272	1125315	2015-07-29	2015-08-05	1	16652
24219	1634	1759842	1959-03-28	1959-04-04	1	-3925
38100	2591	1177480	2004-02-15	2004-05-15	1	12553
24686	1666	1177480	2015-08-19	2015-09-09	1	16687
35623	2419	1713332	1953-05-12	1953-05-19	1	-6071
34236	2325	1503184	1990-09-24	1991-09-19	1	7931
24220	1634	757627	2013-08-23	2013-08-23	1	15940
38101	2591	1713332	2017-02-19	2017-03-05	1	17230
24687	1666	1177480	2018-08-24	2018-09-28	1	17802
36225	2463	1112807	1972-03-14	1972-03-28	1	817
34237	2325	1549786	1991-09-19	1992-09-13	1	8291
24221	1634	920293	1974-10-08	1974-10-15	1	1748
38102	2591	1728416	1963-11-26	1963-12-10	1	-2214
24688	1666	1729720	1994-06-07	1994-06-17	1	8933
36226	2463	1503184	1987-03-17	1988-03-11	1	6644
34238	2325	1759842	1994-10-11	1994-10-18	1	9056
24222	1634	933724	1974-10-08	1974-10-15	1	1748
38103	2591	1759842	1954-12-07	1954-12-14	1	-5497
24689	1666	1759842	1994-05-17	1994-05-31	1	8916
36227	2463	1729720	2004-05-30	2004-06-10	1	12579
34239	2325	19127890	1990-09-24	1992-09-13	2	8291
24223	1634	1112807	1966-12-11	1967-02-09	1	-1057
38104	2591	1118084	1974-08-20	1974-08-20	1	1692
24690	1666	738818	2018-05-04	2018-05-18	1	17669
36228	2463	1738521	1971-06-29	1971-07-13	1	558
34240	2325	19127890	1993-09-08	1994-09-03	1	9011
24224	1634	1125315	1985-02-03	1985-02-17	1	5526
38105	2591	1125315	2017-02-19	2017-03-05	1	17230
24691	1666	1112807	1941-11-19	1941-12-19	1	-10240
36229	2463	1112807	1970-03-06	1970-06-04	1	154
34241	2325	920293	2014-11-15	2014-11-29	2	16403
24225	1634	1322184	2009-07-03	2009-07-03	1	14428
38106	2591	1713332	1996-01-17	1996-03-20	1	9575
24692	1666	1112807	1953-01-20	1953-02-03	1	-6176
36230	2463	1112807	1975-04-02	1975-04-16	1	1931
34242	2325	1112807	1972-05-21	1972-06-04	1	885
24226	1634	1326303	2014-08-29	2014-08-29	1	16311
38107	2591	1112807	1943-06-14	1943-07-05	1	-9677
24693	1666	1125315	2018-05-04	2018-05-18	1	17669
36231	2463	1177480	2009-12-25	2010-01-29	1	14638
34243	2325	1125315	1999-09-17	1999-10-01	1	10865
24227	1634	1347450	2009-07-03	2009-07-03	1	14428
38108	2591	1125315	1951-04-29	1951-05-13	1	-6808
24694	1666	1729720	1949-02-18	1949-03-01	1	-7611
36232	2463	19127890	1987-03-17	1988-03-11	1	6644
34244	2325	1125315	2009-08-29	2009-09-12	1	14499
24228	1634	1713332	1959-03-28	1959-04-04	1	-3925
38109	2591	1125315	1987-12-17	1987-12-24	1	6566
24695	1666	1759842	1967-08-31	1967-09-14	1	-840
36233	2463	1112807	1971-06-29	1971-07-13	1	558
34245	2325	1125315	2019-06-19	2019-06-19	1	18066
24229	1634	1759842	2002-03-07	2002-03-28	1	11774
38110	2591	1125315	2017-11-22	2017-11-29	1	17499
24696	1666	738818	1948-08-25	1948-09-01	1	-7792
36234	2463	1118084	2006-07-20	2006-07-20	1	13349
34246	2325	1174888	2007-10-06	2007-10-06	1	13792
27852	1885	1124300	2009-11-05	2009-11-05	1	14553
38111	2591	1557272	2012-03-14	2012-03-14	1	15413
24697	1666	1112807	1935-06-03	1935-06-17	1	-12617
36235	2463	1125315	1978-08-21	1978-09-18	1	3182
34247	2325	1515774	1991-09-19	1992-09-13	1	8291
27853	1885	1125315	1977-08-28	1977-09-11	1	2810
38112	2591	1102527	1947-09-12	1947-09-12	1	-8147
24698	1666	1112807	1982-06-22	1982-08-21	1	4615
36236	2463	1125315	1979-10-13	1979-11-03	1	3593
34248	2325	1515774	1993-09-08	1994-09-03	1	9011
27854	1885	1515774	1990-02-08	1991-02-03	1	7703
38113	2591	1112807	1963-11-26	1963-12-10	1	-2214
24699	1666	1119510	1951-05-20	1951-05-27	1	-6794
36237	2463	1125315	1999-01-04	1999-01-18	1	10609
34249	2325	1521369	1988-10-04	1989-09-29	1	7211
27855	1885	1713332	1973-12-01	1974-04-06	1	1556
38114	2591	1125315	1947-04-26	1947-05-10	1	-8272
24700	1666	1124300	1976-11-14	1976-11-14	1	2509
36238	2463	1125315	2001-02-19	2001-03-05	1	11386
34250	2325	1589505	1996-08-23	1997-08-18	1	10091
27856	1885	1713332	1987-09-12	1987-10-03	1	6484
38115	2591	1125315	1997-12-12	1997-12-26	1	10221
24701	1666	1125315	1948-08-25	1948-09-01	1	-7792
36239	2463	1521369	1987-03-17	1988-03-11	1	6644
34251	2325	1713332	2015-06-13	2015-06-27	1	16613
27857	1885	1759842	1987-09-12	1987-10-03	1	6484
38116	2591	1713332	1954-12-07	1954-12-14	1	-5497
24702	1666	1713332	1967-08-31	1967-09-14	1	-840
37269	2537	1112807	1948-08-11	1948-08-25	1	-7799
34252	2325	1729720	2018-10-30	2018-11-08	1	17843
27858	1885	1119510	2006-11-03	2006-11-17	1	13469
38117	2591	1759842	1996-01-17	1996-03-20	1	9575
24703	1666	1713332	1994-05-17	1994-05-31	1	8916
37270	2537	1112807	1949-04-22	1949-05-06	1	-7545
34253	2325	1759842	2015-06-13	2015-06-27	1	16613
27859	1885	1125315	2019-04-01	2019-04-08	1	17994
39592	2693	920293	1984-01-24	1984-01-31	1	5143
24704	1666	1729720	1944-11-01	1944-11-10	1	-9183
37271	2537	1125315	1950-11-16	1950-11-30	1	-6972
34254	2325	738818	1981-01-06	1981-01-13	1	4030
27860	1885	1177480	1978-11-04	1978-11-18	1	3243
39593	2693	933724	1984-01-24	1984-01-31	1	5143
26321	1780	1119510	1974-08-28	1974-09-04	1	1707
37272	2537	1125315	2006-10-08	2006-10-22	1	13443
34255	2325	920293	2018-01-10	2018-01-17	1	17548
27861	1885	1521369	1988-02-19	1989-02-13	1	6983
39594	2693	1119510	2014-01-03	2014-01-17	1	16087
26322	1780	1119510	1988-11-30	1988-12-14	1	6922
37273	2537	1149380	1950-08-23	1950-08-23	1	-7071
34256	2325	933724	2018-01-10	2018-01-17	1	17548
27862	1885	1713332	2013-03-30	2013-04-13	1	15808
39595	2693	1125315	1963-06-20	1963-07-04	1	-2373
26323	1780	1124300	2006-02-20	2006-02-20	1	13199
37274	2537	1322184	1998-09-06	1998-09-06	1	10475
34257	2325	1115008	2007-10-06	2007-12-05	1	13852
27863	1885	1738521	1977-08-28	1977-09-11	1	2810
39596	2693	1125315	1967-09-22	1967-10-06	1	-818
26324	1780	1125315	1989-02-09	1989-04-10	1	7039
37275	2537	1728416	1950-11-16	1950-11-30	1	-6972
34258	2325	1118084	2013-04-06	2013-04-06	1	15801
27864	1885	19127890	1990-02-08	1991-02-03	1	7703
39597	2693	1759842	1975-08-29	1975-09-19	1	2087
26325	1780	1125315	1993-05-19	1993-06-09	1	8560
37276	2537	1729720	1957-01-09	1957-01-17	1	-4732
34259	2325	1125315	1981-01-06	1981-01-13	1	4030
27865	1885	1125315	1976-02-12	1976-02-26	1	2247
39598	2693	19127890	1978-09-09	1979-09-04	1	3533
26326	1780	1713332	1986-12-11	1987-04-23	1	6321
37277	2537	1118084	1990-01-23	1990-01-23	1	7327
34260	2325	1549786	1993-09-08	1994-09-03	1	9011
27866	1885	1759842	1973-12-01	1974-04-06	1	1556
39599	2693	920293	1983-11-04	1983-11-11	1	5062
26327	1780	1713332	1997-02-01	1997-02-22	1	9914
37278	2537	1177480	1991-03-11	1991-04-01	1	7760
34261	2325	1713332	1980-12-26	1981-01-02	1	4019
27867	1885	1759842	2013-03-30	2013-04-13	1	15808
39600	2693	933724	1983-11-04	1983-11-11	1	5062
26328	1780	1759842	2003-01-19	2003-02-02	1	12085
37279	2537	1192710	1951-09-06	1951-09-06	1	-6692
34262	2325	1738521	1972-05-21	1972-06-04	1	885
27868	1885	19127890	1988-02-19	1989-02-13	1	6983
39601	2693	1112807	1972-10-30	1972-11-20	1	1054
26329	1780	1778162	2019-02-20	2019-03-06	1	17961
37280	2537	1347450	1998-09-06	1998-09-06	1	10475
34263	2325	1759842	1980-12-26	1981-01-02	1	4019
27869	1885	738818	2006-11-03	2006-11-17	1	13469
39602	2693	1118084	1997-05-27	1997-05-27	1	10008
26330	1780	1729720	1978-05-06	1978-05-15	1	3056
37281	2537	723013	1961-06-25	1961-10-22	1	-2993
34264	2325	19127890	1988-10-04	1989-09-29	1	7211
27870	1885	1125315	2006-11-03	2006-11-17	1	13469
39603	2693	1125315	1995-10-15	1995-10-22	1	9425
26331	1780	738818	1974-08-28	1974-09-04	1	1707
37282	2537	1728416	1949-04-22	1949-05-06	1	-7545
34265	2325	933724	2014-11-15	2014-11-29	1	16403
27871	1885	1503184	1988-02-19	1989-02-13	1	6983
39604	2693	1503184	1978-09-09	1979-09-04	1	3533
26332	1780	738818	1988-11-30	1988-12-14	1	6922
37283	2537	1112807	1957-11-13	1957-12-04	1	-4411
34266	2325	1119510	1981-01-06	1981-01-13	1	4030
27872	1885	1549786	1990-02-08	1991-02-03	1	7703
39605	2693	1521369	1978-09-09	1979-09-04	1	3533
26333	1780	1125315	1983-02-06	1983-02-13	1	4791
37284	2537	1125315	1952-05-22	1952-06-12	1	-6412
34267	2325	1125315	1976-07-29	1976-08-28	1	2431
27873	1885	1738521	1976-02-12	1976-02-26	1	2247
39606	2693	1521369	1981-08-24	1982-08-19	1	4613
26334	1780	1125315	1988-11-30	1988-12-14	1	6922
37285	2537	1154343	1950-08-23	1950-08-23	1	-7071
34268	2325	1125315	2012-11-25	2012-12-09	1	15683
27874	1885	1738521	1978-11-04	1978-11-18	1	3243
39607	2693	1759842	1976-09-22	1976-10-06	1	2470
26335	1780	1149380	1967-06-22	1985-03-12	1	5549
38473	2617	738818	2001-01-23	2001-02-06	1	11359
34269	2325	1521369	1990-09-24	1991-09-19	1	7931
29431	1991	738818	1971-07-01	1971-07-08	1	553
39608	2693	738818	2014-01-03	2014-01-17	1	16087
26336	1780	1177480	2019-02-20	2019-03-06	1	17961
38474	2617	1112807	1953-12-30	1954-01-13	1	-5832
34270	2325	1713332	1994-10-11	1994-10-18	1	9056
29432	1991	1112807	1946-11-24	1946-12-15	1	-8418
39609	2693	1125315	2014-01-03	2014-01-17	1	16087
26337	1780	1713332	2003-01-19	2003-02-02	1	12085
38475	2617	1112807	1955-11-20	1955-12-18	1	-5128
36010	2447	1119510	1985-06-27	1985-07-04	1	5663
29433	1991	1125315	1971-07-01	1971-07-08	1	553
39610	2693	1713332	1975-08-29	1975-09-19	1	2087
26338	1780	1728416	1966-11-07	1966-11-21	1	-1137
38476	2617	1115008	2016-06-05	2016-06-26	1	16978
36011	2447	1137529	2017-10-11	2017-10-11	1	17450
29434	1991	1125315	1988-08-19	1988-08-26	1	6812
39611	2693	19127890	1981-08-24	1982-08-19	1	4613
26339	1780	1759842	1986-12-11	1987-04-23	1	6321
38477	2617	1125315	1956-09-16	1956-09-23	1	-4848
36012	2447	738818	1985-06-27	1985-07-04	1	5663
29435	1991	1125315	1992-12-02	1992-12-16	1	8385
39612	2693	1125315	1962-01-27	1962-02-10	1	-2882
26340	1780	1759842	1997-02-01	1997-02-22	1	9914
38478	2617	1713332	1997-04-14	1997-04-28	1	9979
36013	2447	738818	1995-07-24	1995-08-07	1	9349
29436	1991	1174888	2011-02-21	2011-02-21	1	15026
39613	2693	1125315	1977-08-27	1977-09-03	1	2802
26341	1780	1112807	1966-11-07	1966-11-21	1	-1137
38479	2617	1759842	1997-04-14	1997-04-28	1	9979
36014	2447	1125315	1985-06-27	1985-07-04	1	5663
29437	1991	1322184	1997-11-03	2011-02-21	1	15026
39614	2693	1125315	2006-03-27	2006-04-17	1	13255
26342	1780	1125315	1974-08-28	1974-09-04	1	1707
38480	2617	1118084	1987-07-15	1987-07-15	1	6404
36015	2447	1149380	2017-10-11	2017-10-11	1	17450
29438	1991	1713332	1988-01-14	1988-01-28	1	6601
39615	2693	1503184	1981-08-24	1982-08-19	1	4613
26343	1780	1125315	1981-02-01	1981-02-15	1	4063
38481	2617	1177480	2001-03-21	2001-04-25	1	11437
36016	2447	1119510	1995-07-24	1995-08-07	1	9349
29439	1991	1729720	1987-07-02	1987-07-09	1	6398
39616	2693	1713332	1976-09-22	1976-10-06	1	2470
26344	1780	1125315	1982-04-01	1982-04-15	1	4487
38482	2617	1361711	2014-09-06	2014-09-06	1	16319
36017	2447	1115008	2011-02-09	2011-03-09	1	15042
29440	1991	1119510	1954-09-14	1954-09-28	1	-5574
39617	2693	1717327	1963-06-20	1963-07-04	1	-2373
26345	1780	1154343	1967-06-22	1985-03-12	1	5549
38483	2617	1539403	2014-09-06	2014-09-06	1	16319
36018	2447	1124300	2017-02-27	2017-02-27	1	17224
29441	1991	1119510	1965-12-03	1965-12-10	1	-1483
39618	2693	1729720	1961-04-17	1961-04-24	1	-3174
31783	2151	1322184	1997-09-03	1999-12-08	1	10933
38484	2617	1119510	2001-01-23	2001-02-06	1	11359
36019	2447	1125315	1995-07-24	1995-08-07	1	9349
29442	1991	1125315	2011-02-21	2011-02-21	1	15026
42856	2902	1125315	1953-02-04	1953-02-18	1	-6161
31784	2151	1347450	1992-12-09	1992-12-09	1	8378
38485	2617	1125315	1969-08-28	1969-09-04	1	-119
40264	2739	757627	2009-04-22	2009-04-22	1	14356
29443	1991	1539403	1993-10-11	1993-10-11	1	8684
42857	2902	1728416	1947-11-27	1947-12-11	1	-8057
31785	2151	1713332	1930-01-01	1930-01-08	1	-14603
38486	2617	1125315	2001-01-23	2001-02-06	1	11359
40265	2739	1112807	1957-03-20	1957-04-03	1	-4656
29444	1991	1545958	2011-02-21	2011-02-21	1	15026
42858	2902	1728416	1953-02-04	1953-02-18	1	-6161
31786	2151	1713332	1940-11-18	1940-12-02	1	-10622
38487	2617	1728416	1953-12-30	1954-01-13	1	-5832
40266	2739	1125315	1956-05-31	1956-06-14	1	-4949
29445	1991	738818	1965-12-03	1965-12-10	1	-1483
42859	2902	1112807	1947-11-27	1947-12-11	1	-8057
31787	2151	1759842	1930-01-01	1930-01-08	1	-14603
38488	2617	1322184	2014-09-06	2014-09-06	1	16319
40267	2739	1125315	1988-06-26	1988-08-25	1	6811
29446	1991	1102527	1988-01-14	1988-01-14	1	6587
42860	2902	1112807	1952-06-03	1952-07-08	1	-6386
31788	2151	1112807	1919-11-04	1919-11-18	1	-18307
38489	2617	1332418	2014-09-06	2014-09-06	1	16319
40268	2739	1728416	1956-05-31	1956-06-14	1	-4949
29447	1991	1112807	1946-04-28	1946-05-12	1	-8635
42861	2902	1119510	2017-09-03	2017-09-10	1	17419
31789	2151	1119510	1954-09-02	1954-09-16	1	-5586
41606	2822	1118084	2011-11-30	2011-11-30	1	15308
40269	2739	701322	2010-02-16	2010-02-16	1	14656
29448	1991	1112807	1958-07-15	1958-10-13	1	-4098
42862	2902	1125315	2000-09-21	2000-10-05	1	11235
31790	2151	1119510	1967-06-08	1967-06-22	1	-924
41607	2822	1125315	1996-09-30	1996-10-14	1	9783
40270	2739	1124300	1992-03-28	1992-03-28	1	8122
29449	1991	1119510	1971-07-01	1971-07-08	1	553
42863	2902	1129625	1950-07-25	1950-07-25	1	-7100
31791	2151	1310149	1975-04-30	1975-04-30	1	1945
41608	2822	1713332	1977-03-26	1977-04-02	1	2648
40271	2739	1125315	1969-07-24	1969-07-31	1	-154
29450	1991	1124300	1977-07-24	1977-07-24	1	2761
42864	2902	1347450	2011-02-11	2011-02-11	1	15016
31792	2151	1326303	1975-04-30	1975-04-30	1	1945
41609	2822	1759842	1977-03-26	1977-04-02	1	2648
40272	2739	1729720	1960-03-25	1960-04-07	1	-3556
29451	1991	1125315	1965-12-03	1965-12-10	1	-1483
42865	2902	738818	2017-09-03	2017-09-10	1	17419
31793	2151	1545958	1999-12-08	1999-12-08	1	10933
41610	2822	738818	2001-09-04	2001-09-11	1	11576
40273	2739	1125315	1986-07-23	1986-08-06	1	6061
29452	1991	738818	1954-09-14	1954-09-28	1	-5574
42866	2902	1115008	1998-08-06	1998-08-27	1	10465
31794	2151	1125315	1958-02-09	1958-02-16	1	-4337
41611	2822	1119510	2001-09-04	2001-09-11	1	11576
40572	2757	1125315	1978-03-06	1978-06-04	1	3076
29453	1991	1125315	1954-09-14	1954-09-28	1	-5574
42867	2902	1125315	2005-02-18	2005-03-04	1	12846
31795	2151	1125315	1963-02-14	1963-02-28	1	-2499
41612	2822	1125315	1980-06-01	1980-06-08	1	3811
40573	2757	1177480	1974-02-27	1974-03-27	1	1546
29454	1991	1125315	1977-01-06	1977-02-10	1	2597
42868	2902	1322184	2011-02-11	2011-02-11	1	15016
31796	2151	1125315	1969-03-17	1969-03-31	1	-276
41613	2822	1125315	2001-09-04	2001-09-11	1	11576
40574	2757	1713332	2014-09-27	2014-10-18	1	16361
29455	1991	1125315	1988-01-14	1988-01-28	1	6601
42869	2902	1729720	1986-03-17	1986-03-28	1	5930
31797	2151	1174888	1999-12-08	1999-12-08	1	10933
41614	2822	1125315	2016-02-27	2016-03-05	1	16865
40575	2757	1759842	2014-09-27	2014-10-18	1	16361
29456	1991	1332418	1994-10-17	1994-10-17	1	9055
42870	2902	1118084	1991-04-10	1991-04-10	1	7769
31798	2151	1332418	1994-08-17	1994-08-17	1	8994
41615	2822	1112807	1983-07-06	1983-07-27	1	4955
40576	2757	1759842	1982-05-29	1982-06-19	1	4552
29457	1991	1361711	1993-10-11	2011-02-21	1	15026
42871	2902	1125315	1950-05-29	1950-06-12	1	-7143
31799	2151	738818	1954-09-02	1954-09-16	1	-5586
41616	2822	1125315	1976-12-18	1977-01-01	1	2557
40577	2757	1112807	1976-02-15	1976-04-15	1	2296
30683	2077	757627	2004-07-25	2004-07-25	1	12624
42872	2902	1125315	2017-09-03	2017-09-10	1	17419
31800	2151	738818	1967-06-08	1967-06-22	1	-924
41617	2822	1125315	1977-11-13	1977-12-04	1	2894
40578	2757	1118084	2007-07-14	2007-07-14	1	13708
30684	2077	1125315	1977-08-16	1977-08-30	1	2798
42873	2902	1728416	1950-05-29	1950-06-12	1	-7143
31801	2151	1112807	1926-05-31	1926-06-28	1	-15893
41618	2822	1125315	1990-09-16	1990-09-30	1	7577
40579	2757	1322184	2017-01-20	2017-01-20	1	17186
30685	2077	1125315	2001-06-11	2001-09-09	1	11574
44361	3002	1124300	2012-11-05	2012-11-05	1	15649
31802	2151	1118084	1958-07-22	1958-07-22	1	-4181
41619	2822	1728416	1976-12-18	1977-01-01	1	2557
40580	2757	1347450	2017-01-20	2017-01-20	1	17186
30686	2077	1729720	1951-07-09	1951-07-22	1	-6738
44362	3002	1125315	1981-12-09	1982-01-13	1	4395
31803	2151	1125315	1954-09-02	1954-09-16	1	-5586
46121	3132	1118084	2007-04-17	2007-04-17	1	13620
40581	2757	1713332	1982-05-29	1982-06-19	1	4552
30687	2077	701322	2005-05-21	2005-05-21	1	12924
44363	3002	1177480	1975-03-25	1975-04-15	1	1930
31804	2151	1125315	1967-06-08	1967-06-22	1	-924
46122	3132	1713332	1991-07-17	1991-08-07	1	7888
30688	2077	1124300	1972-06-04	1972-06-04	1	885
44364	3002	738818	2014-11-27	2014-12-11	1	16415
31805	2151	1125315	1999-12-08	1999-12-08	1	10933
46123	3132	1759842	1991-07-17	1991-08-07	1	7888
30689	2077	1125315	1942-06-08	1942-06-22	1	-10055
44365	3002	1119510	2014-11-27	2014-12-11	1	16415
31806	2151	1307863	1981-06-03	1981-06-03	1	4171
46124	3132	1112807	1965-11-23	1965-12-07	1	-1486
30690	2077	1125315	1952-02-26	1952-03-11	1	-6505
44366	3002	1125315	1974-03-30	1974-04-13	1	1563
31807	2151	1361711	1988-07-13	1999-12-08	1	10933
46125	3132	1717327	1965-11-23	1965-12-07	1	-1486
30691	2077	914335	2005-08-21	2005-08-21	1	13016
44367	3002	1125315	1977-03-01	1977-03-15	1	2630
31808	2151	1539403	1991-07-31	1991-07-31	1	7881
46126	3132	1112807	1981-03-18	1981-04-15	1	4122
30692	2077	975125	1958-03-29	1958-03-29	1	-4296
44368	3002	1125315	2014-11-27	2014-12-11	1	16415
31809	2151	1729720	1925-07-06	1925-07-16	1	-16240
46127	3132	1125315	1967-07-18	1967-08-01	1	-884
30693	2077	1125315	1946-11-09	1946-11-23	1	-8440
44369	3002	1728416	1977-03-01	1977-03-15	1	2630
31810	2151	1759842	1940-11-18	1940-12-02	1	-10622
46128	3132	1125315	1999-08-09	1999-09-13	1	10847
30694	2077	1177480	1996-10-21	1996-11-04	1	9804
44370	3002	1759842	2011-12-27	2012-01-10	1	15349
35237	2392	738818	1960-01-22	1960-01-29	1	-3625
46129	3132	1729720	1974-08-22	1974-09-04	1	1707
30695	2077	1309944	2005-08-21	2005-08-21	1	13016
44371	3002	1717327	1974-03-30	1974-04-13	1	1563
35238	2392	1112807	1916-11-30	1916-12-30	1	-19360
46130	3132	1112807	1968-12-07	1968-12-21	1	-376
30696	2077	1343916	2005-08-21	2005-08-21	1	13016
44372	3002	1713332	2011-12-27	2012-01-10	1	15349
35239	2392	1112807	1926-05-12	1926-06-02	1	-15919
46131	3132	1125315	1995-07-01	1995-09-29	1	9402
30697	2077	1102527	1988-05-06	1988-05-06	1	6700
44373	3002	1738521	1975-04-07	1975-04-15	1	1930
35240	2392	1119510	1958-07-23	1958-07-30	1	-4173
47708	3238	1119510	1974-06-21	1974-06-28	1	1639
30698	2077	1125315	1962-08-21	1962-09-04	1	-2676
44577	3020	1112807	1959-01-04	1959-01-18	1	-4001
35241	2392	1125315	1942-12-31	1943-01-14	1	-9849
47709	3238	1713332	1987-01-17	1987-02-07	1	6246
30699	2077	1713332	1939-10-25	1939-11-08	1	-11012
44578	3020	1125315	1959-02-23	1959-03-02	1	-3958
35242	2392	1125315	1955-05-18	1955-05-25	1	-5335
47710	3238	1112807	1968-03-23	1968-04-06	1	-635
30700	2077	1713332	1997-02-08	1997-02-22	1	9914
44579	3020	1137529	2003-01-22	2003-01-22	1	12074
35243	2392	1125315	1960-01-22	1960-01-29	1	-3625
44516	3014	1125315	1998-01-21	1998-01-28	1	10254
30701	2077	1759842	1939-10-25	1939-11-08	1	-11012
44580	3020	1361711	1961-12-13	1961-12-13	1	-2941
35244	2392	1125315	2013-09-25	2013-10-09	1	15987
44517	3014	1125315	2013-06-05	2013-08-11	2	15928
30702	2077	1759842	1997-02-08	1997-02-22	1	9914
44581	3020	1125315	1969-03-20	1969-03-27	1	-280
35245	2392	1137529	1954-10-15	1954-10-15	1	-5557
44518	3014	1521369	1990-06-11	1991-06-06	1	7826
31856	2155	1118084	1970-07-16	1970-07-16	1	196
44582	3020	1322184	1997-01-08	1997-01-08	1	9869
35246	2392	1713332	1932-08-18	1932-09-08	1	-13629
44519	3014	1713332	2013-10-25	2013-11-01	1	16010
31857	2155	1119510	1993-07-19	1993-08-02	1	8614
44583	3020	1539403	1991-03-20	1991-03-20	1	7748
35247	2392	1759842	1932-08-18	1932-09-08	1	-13629
44520	3014	1125315	1978-07-17	1978-07-31	1	3133
31858	2155	1125315	1986-12-24	1987-01-28	1	6236
44584	3020	1112807	1963-01-01	1963-01-15	1	-2543
35248	2392	1125315	1984-02-24	1984-03-09	1	5181
44521	3014	1125315	1984-04-02	1984-05-08	1	5241
31859	2155	1322184	2006-02-08	2006-02-08	1	13187
44585	3020	1125315	1981-10-29	1981-11-05	1	4326
35249	2392	1310149	1997-05-16	1997-05-16	1	9997
44522	3014	1174888	2013-06-12	2013-06-12	1	15868
31860	2155	1322184	2009-04-29	2009-04-29	1	14363
44586	3020	1125315	1991-12-19	1991-12-26	1	8029
35250	2392	738818	1958-07-23	1958-07-30	1	-4173
44523	3014	1515774	1993-05-26	1994-05-21	1	8906
31861	2155	1347450	2009-04-29	2009-04-29	1	14363
44587	3020	1149380	2003-01-22	2003-01-22	1	12074
35251	2392	1112807	1919-09-16	1919-09-30	1	-18356
44524	3014	1503184	1990-06-11	1991-06-06	1	7826
31862	2155	1759842	1932-12-30	1933-01-06	1	-13509
44588	3020	1118084	1996-04-12	1996-04-12	1	9598
35252	2392	1112807	1937-09-02	1937-09-16	1	-11795
44525	3014	1549786	1993-05-26	1994-05-21	1	8906
31863	2155	1119510	1985-10-10	1985-10-17	1	5768
44589	3020	1125315	1957-06-01	1957-06-15	1	-4583
35253	2392	1112807	1940-07-02	1940-07-23	1	-10754
44526	3014	738818	2000-03-19	2000-03-26	1	11042
31864	2155	1125315	1935-05-28	1935-06-04	1	-12630
44590	3020	1332418	1994-12-28	1994-12-28	1	9127
35254	2392	1119510	1960-01-22	1960-01-29	1	-3625
44527	3014	1119510	2000-03-19	2000-03-26	1	11042
31865	2155	1125315	2003-05-23	2003-06-17	1	12220
44591	3020	1728416	1957-06-01	1957-06-15	1	-4583
35255	2392	1125315	1942-09-17	1942-10-01	1	-9954
44528	3014	1125315	2000-03-19	2000-03-26	1	11042
31866	2155	1347450	2006-02-08	2006-02-08	1	13187
44592	3020	1728416	1959-01-04	1959-01-18	1	-4001
35256	2392	1125315	1958-07-23	1958-07-30	1	-4173
44529	3014	1738521	1974-04-26	1974-05-10	1	1590
31867	2155	1713332	1928-07-10	1928-07-17	1	-15143
45628	3098	738818	1973-12-04	1973-12-18	1	1447
35257	2392	1125315	2019-02-17	2019-03-03	1	17958
44530	3014	1738521	1978-07-17	1978-07-31	1	3133
31868	2155	1759842	1928-07-10	1928-07-17	1	-15143
45629	3098	738818	2012-02-09	2012-02-23	1	15393
35258	2392	1149380	1954-10-15	1954-10-15	1	-5557
44531	3014	1759842	2013-10-25	2013-11-01	1	16010
31869	2155	738818	2005-04-06	2005-04-20	1	12893
45630	3098	1125315	1973-12-04	1973-12-18	1	1447
35259	2392	1326303	1997-05-16	1997-05-16	1	9997
44532	3014	19127890	1990-06-11	1991-06-06	1	7826
31870	2155	1125315	1979-07-25	1979-08-08	1	3506
45631	3098	1125315	2012-02-09	2012-02-23	1	15393
35260	2392	1118084	1948-05-16	1948-05-16	1	-7900
44533	3014	19127890	1993-05-26	1994-05-21	1	8906
31871	2155	1125315	1985-10-10	1985-10-17	1	5768
45632	3098	1125315	2016-06-11	2016-06-18	1	16970
35261	2392	1125315	1954-10-08	1954-10-29	1	-5543
45508	3088	1125315	1963-06-07	1963-06-21	1	-2386
31872	2155	1713332	1932-12-30	1933-01-06	1	-13509
45633	3098	1177480	2009-01-02	2009-01-16	1	14260
35262	2392	1125315	1957-02-13	1957-02-27	1	-4691
45509	3088	1112807	1978-10-21	1978-11-18	1	3243
31873	2155	738818	1985-10-10	1985-10-17	1	5768
45634	3098	1759842	1984-06-08	1984-06-22	1	5286
35263	2392	1125315	1974-06-16	1974-07-07	1	1648
45510	3088	1125315	1947-12-30	1948-01-06	1	-8031
31874	2155	738818	1993-07-19	1993-08-02	1	8614
45635	3098	1118084	1995-12-02	1995-12-02	1	9466
35264	2392	1125315	2011-03-24	2011-03-31	1	15064
45511	3088	1125315	1964-08-11	1964-08-25	1	-1955
31875	2155	1119510	2005-04-06	2005-04-20	1	12893
45636	3098	19127890	1974-09-08	1975-09-03	1	2071
35265	2392	1307863	1997-05-16	1997-05-16	1	9997
45512	3088	1125315	1970-03-16	1970-04-06	1	95
31876	2155	1125315	1993-07-19	1993-08-02	1	8614
45637	3098	1102527	2019-06-23	2019-06-23	1	18070
36713	2498	1102527	2018-08-26	2018-08-26	1	17769
45513	3088	1729720	1950-08-02	1950-08-15	1	-7079
31877	2155	1125315	1996-01-11	1996-02-10	1	9536
45638	3098	1119510	1973-12-04	1973-12-18	1	1447
36714	2498	1125315	1997-10-15	1997-11-14	1	10179
45514	3088	701322	2017-12-07	2017-12-07	1	17507
31878	2155	1125315	1999-02-02	1999-02-16	1	10638
45639	3098	1503184	1974-09-08	1975-09-03	1	2071
36715	2498	1738521	1973-03-31	1973-04-14	1	1199
45515	3088	715997	2017-12-07	2017-12-07	1	17507
31879	2155	1125315	2000-04-17	2000-05-01	1	11078
45640	3098	1713332	1984-06-08	1984-06-22	1	5286
36716	2498	1124300	2007-11-18	2007-11-18	1	13835
45516	3088	757627	2017-02-10	2017-02-10	1	17207
31880	2155	1125315	2005-04-06	2005-04-20	1	12893
45641	3098	1115008	1994-07-15	1994-08-19	1	8996
36717	2498	1125315	1995-08-29	1995-09-26	1	9399
45517	3088	1124300	1980-08-21	1980-08-21	1	3885
31881	2155	1557272	2007-04-25	2007-04-25	1	13628
45642	3098	1119510	2012-02-09	2012-02-23	1	15393
36718	2498	1738521	1976-05-31	1976-06-14	1	2356
45518	3088	1729720	1960-09-08	1960-09-15	1	-3395
31882	2155	1729720	1979-09-19	1979-10-02	1	3561
45643	3098	1125315	1991-07-21	1991-08-04	1	7885
36719	2498	1112807	1973-03-31	1973-04-14	1	1199
45519	3088	1125315	1993-03-04	1993-03-25	1	8484
33691	2289	1124300	1985-10-08	1985-10-08	1	5759
45644	3098	1177480	2019-06-23	2019-06-23	1	18070
36720	2498	1112807	1976-05-31	1976-06-14	1	2356
45520	3088	1308738	1999-03-30	1999-03-30	1	10680
33692	2289	1177480	1996-05-29	1996-06-19	1	9666
45645	3098	1521369	1974-09-08	1975-09-03	1	2071
36721	2498	1112807	1982-12-23	1983-01-06	1	4753
45521	3088	1729720	1940-05-12	1940-05-23	1	-10815
33693	2289	1557272	2009-12-29	2009-12-29	1	14607
1142	78	1125315	1968-03-13	1968-03-27	1	-645
36722	2498	1125315	1986-10-17	1986-11-14	1	6161
46720	3174	738818	1989-08-29	1989-09-12	1	7194
33694	2289	1125315	1953-06-13	1953-06-27	1	-6032
1143	78	1177480	1978-09-25	1978-11-24	1	3249
36723	2498	1322184	2006-04-08	2006-04-08	1	13246
46721	3174	1125315	1989-08-29	1989-09-12	1	7194
33695	2289	1125315	1961-11-19	1961-12-10	1	-2944
1144	78	1729720	1985-05-13	1985-05-23	1	5621
36724	2498	1332418	2006-04-08	2006-04-08	1	13246
46722	3174	1515774	1996-11-28	1997-11-23	1	10188
33696	2289	1125315	1977-04-29	1977-05-06	1	2682
1145	78	1112807	1967-11-13	1967-11-27	1	-766
36725	2498	1539403	2006-04-08	2006-04-08	1	13246
46723	3174	1713332	2005-01-22	2005-01-29	1	12812
33697	2289	1125315	1991-04-03	1991-04-17	1	7776
1146	78	1125315	1968-11-25	1968-12-16	1	-381
36726	2498	1729720	1975-12-19	1975-12-31	1	2190
46724	3174	1759842	2005-01-22	2005-01-29	1	12812
33698	2289	1125315	2018-07-15	2018-08-19	1	17762
1147	78	1728416	1967-07-04	1967-07-18	1	-898
36727	2498	1112807	1972-08-03	1972-08-17	1	959
46725	3174	1118084	2014-12-19	2014-12-19	1	16423
33699	2289	1177480	1975-08-13	1975-09-17	1	2085
1148	78	1728416	1967-11-13	1967-11-27	1	-766
36728	2498	1115008	2018-08-26	2018-09-25	1	17799
46726	3174	1119510	1989-08-29	1989-09-12	1	7194
33700	2289	1717327	1963-01-19	1963-02-02	1	-2525
1149	78	1112807	1967-07-04	1967-07-18	1	-898
36729	2498	1125315	1992-01-22	1992-02-05	1	8070
46727	3174	1500211	1997-11-23	1998-11-18	1	10548
33701	2289	1728416	1953-06-13	1953-06-27	1	-6032
1150	78	1118084	2003-02-15	2003-02-15	1	12098
36730	2498	1361711	2006-04-08	2006-04-08	1	13246
46728	3174	19127890	1996-11-28	1997-11-23	1	10188
33702	2289	1729720	1950-04-04	1950-04-12	1	-7204
1151	78	1125315	1991-10-28	1991-11-04	1	7977
37913	2578	738818	1972-12-31	1973-01-07	1	1102
46729	3174	1115008	2000-01-02	2000-02-06	1	10993
33703	2289	1729720	1953-02-28	1953-03-10	1	-6141
1152	78	1125315	2009-04-14	2009-04-21	1	14355
37914	2578	1119510	2008-03-06	2008-03-20	1	13958
46730	3174	1125315	1994-12-23	1995-01-06	1	9136
33704	2289	1759842	1968-06-19	1968-06-26	1	-554
2448	162	1119510	1984-06-15	1984-06-22	1	5286
37915	2578	1125315	1971-12-21	1971-12-28	1	726
46731	3174	1549786	1996-11-28	1997-11-23	1	10188
33705	2289	1112807	1957-04-23	1957-05-14	1	-4615
2449	162	1124300	1972-04-07	1972-04-07	1	827
37916	2578	1125315	1972-12-31	1973-01-07	1	1102
46732	3174	1729720	1991-12-18	1991-12-26	1	8029
33706	2289	1112807	1964-11-24	1965-01-23	1	-1804
2450	162	1125315	2001-06-25	2001-07-02	1	11505
37917	2578	1125315	2008-03-06	2008-03-20	1	13958
49521	3375	1125315	1956-11-19	1956-12-03	1	-4777
33707	2289	1125315	1955-11-01	1955-11-15	1	-5161
2451	162	1112807	1940-07-14	1940-07-28	1	-10749
37918	2578	1778162	2003-04-06	2003-04-20	1	12162
49522	3375	1728416	1958-02-03	1958-02-17	1	-4336
33708	2289	1125315	1971-11-18	1971-12-02	1	700
2452	162	1115008	2005-10-31	2005-11-14	1	13101
37919	2578	738818	2008-03-06	2008-03-20	1	13958
49523	3375	1729720	1993-03-14	1993-03-26	1	8485
33709	2289	1125315	2019-06-02	2019-06-16	1	18063
2453	162	1125315	1964-11-06	1964-11-20	1	-1868
37920	2578	1124300	2008-04-04	2008-04-04	1	13973
49524	3375	19127890	1974-01-29	1975-01-24	1	1849
33710	2289	1177480	2000-07-28	2000-08-18	1	11187
2454	162	1125315	2013-12-31	2014-01-07	1	16077
37921	2578	1125315	1990-12-10	1990-12-24	1	7662
49525	3375	738818	1983-06-03	1983-06-17	1	4915
33711	2289	1713332	1968-06-19	1968-06-26	1	-554
2455	162	1557272	2009-10-20	2009-10-20	1	14537
37922	2578	1115008	2015-06-16	2015-07-14	1	16630
49526	3375	1118084	1995-09-11	1995-09-11	1	9384
33712	2289	723013	1958-10-30	1958-10-30	1	-4081
2456	162	738818	1984-06-15	1984-06-22	1	5286
37923	2578	1119510	1972-12-31	1973-01-07	1	1102
49527	3375	1125315	1983-06-03	1983-06-17	1	4915
33713	2289	740275	1959-03-19	1959-09-03	1	-3773
2457	162	920293	1976-12-13	1976-12-20	1	2545
37924	2578	1177480	2003-04-06	2003-04-20	1	12162
49528	3375	1125315	2007-02-24	2007-03-03	1	13575
33714	2289	1125315	1963-01-19	1963-02-02	1	-2525
2458	162	933724	1976-12-13	1976-12-20	1	2545
42204	2861	1125315	1977-04-25	1977-04-25	1	2671
49529	3375	1503184	1974-01-29	1975-01-24	1	1849
38084	2590	1112807	1967-06-20	1967-08-19	1	-866
2459	162	1115008	2007-09-05	2007-09-26	1	13782
42205	2861	1729720	1970-04-28	1970-05-11	1	130
49530	3375	1713332	2007-10-12	2007-10-26	1	13812
38085	2590	1713332	2011-01-11	2011-01-25	1	14999
2460	162	1177480	1978-03-14	1978-03-28	1	3008
42206	2861	1125315	1987-12-20	1988-01-19	1	6592
49531	3375	1112807	1958-02-03	1958-02-17	1	-4336
38086	2590	1717327	1963-04-14	1963-04-28	1	-2440
2461	162	1713332	1945-11-09	1945-11-16	1	-8812
42207	2861	1125315	1989-04-24	1989-05-08	1	7067
49532	3375	1125315	2014-11-23	2014-12-07	1	16411
38087	2590	1112807	1966-06-27	1966-07-25	1	-1256
2462	162	1713332	1957-10-20	1957-11-10	1	-4435
42208	2861	1728416	1966-11-05	1966-11-19	1	-1139
49533	3375	1728416	1956-11-19	1956-12-03	1	-4777
38088	2590	1125315	2000-12-06	2000-12-13	1	11304
2463	162	1717327	1978-03-14	1978-03-28	1	3008
42209	2861	1729720	1999-01-16	1999-01-29	1	10620
49534	3375	1759842	2007-10-12	2007-10-26	1	13812
38089	2590	1177480	1979-01-18	1979-02-22	1	3339
2464	162	1759842	1964-08-13	1964-08-20	1	-1960
42210	2861	1759842	1998-03-02	1998-03-16	1	10301
49535	3375	1119510	1983-06-03	1983-06-17	1	4915
38090	2590	1125315	1963-04-14	1963-04-28	1	-2440
2465	162	1125315	1979-07-29	1979-08-05	1	3503
42211	2861	738818	2010-11-25	2010-12-09	1	14952
49536	3375	1521369	1974-01-29	1975-01-24	1	1849
38091	2590	1125315	1968-06-28	1968-07-12	1	-538
2466	162	1125315	1984-06-15	1984-06-22	1	5286
42212	2861	1112807	1966-11-05	1966-11-19	1	-1139
49537	3375	1729720	1988-07-22	1988-08-04	1	6790
38092	2590	1125315	1980-02-17	1980-03-09	1	3720
2467	162	1713332	1964-08-13	1964-08-20	1	-1960
42213	2861	1115008	2005-03-20	2005-04-03	1	12876
50150	3417	920293	1950-05-07	1950-05-14	1	-7172
38093	2590	1125315	1990-10-04	1990-11-01	1	7609
2468	162	1713332	1998-08-13	1998-08-20	1	10458
42214	2861	1118084	2006-10-10	2006-10-10	1	13431
50151	3417	1112807	1948-04-13	1948-05-04	1	-7912
38094	2590	1759842	2011-01-11	2011-01-25	1	14999
2469	162	1759842	1945-11-09	1945-11-16	1	-8812
42215	2861	1119510	2010-11-25	2010-12-09	1	14952
50152	3417	1119510	1957-07-22	1957-08-05	1	-4532
38095	2590	1118084	2002-09-21	2002-09-21	1	11951
2470	162	1759842	1957-10-20	1957-11-10	1	-4435
42216	2861	1125315	1999-06-29	1999-07-13	1	10785
50153	3417	1124300	1948-12-28	1948-12-28	1	-7674
38096	2590	1125315	1994-01-03	1994-01-10	1	8775
2471	162	1759842	1998-08-13	1998-08-20	1	10458
42217	2861	1125315	2010-11-25	2010-12-09	1	14952
50154	3417	1124957	1980-06-15	1980-06-15	1	3818
38097	2590	1177480	1981-01-03	1981-01-24	1	4041
3194	212	920293	2015-04-22	2015-04-29	1	16554
42218	2861	1125315	2019-06-19	2019-06-19	1	18066
50155	3417	1713332	2016-03-25	2016-04-15	1	16906
39576	2692	1177480	1996-02-17	1996-03-09	1	9564
3195	212	1125315	1996-06-13	1996-06-20	1	9667
42219	2861	1174888	1977-04-25	1977-04-25	1	2671
50156	3417	1729720	1947-04-17	1947-04-26	1	-8286
39577	2692	1332418	1995-12-11	1995-12-11	1	9475
3196	212	1125315	2012-07-28	2012-08-11	1	15563
42220	2861	1713332	2002-11-26	2002-12-03	1	12024
50157	3417	1759842	2016-03-25	2016-04-15	1	16906
39578	2692	1539403	1995-12-11	1995-12-11	1	9475
3197	212	1177480	1996-04-15	1996-04-29	1	9615
42221	2861	1728416	1965-05-28	1965-06-11	1	-1665
50158	3417	1125315	1914-09-20	1914-09-27	1	-20185
39579	2692	1125315	1950-07-04	1950-07-18	1	-7107
3198	212	1521369	1989-02-19	1990-02-14	1	7349
42222	2861	1759842	2002-11-26	2002-12-03	1	12024
50159	3417	1759842	1928-07-01	1928-07-08	1	-15152
39580	2692	1125315	1959-07-17	1959-07-31	1	-3807
3199	212	723013	2014-08-16	2015-05-02	1	16557
42223	2861	1125315	1965-05-28	1965-06-11	1	-1665
50160	3417	1759842	1943-07-28	1943-08-18	1	-9633
39581	2692	1361711	1995-12-11	1998-06-29	1	10406
3200	212	933724	2015-04-22	2015-04-29	1	16554
42224	2861	1125315	1982-03-30	1982-04-20	1	4492
50161	3417	1759842	1945-09-11	1945-09-18	1	-8871
39582	2692	1759842	1967-06-15	1967-07-06	1	-910
3201	212	1118084	2012-12-30	2012-12-30	1	15704
42225	2861	1177480	1977-04-25	1977-07-24	1	2761
50162	3417	738818	1957-07-22	1957-08-05	1	-4532
39583	2692	1124300	1986-01-21	1986-01-21	1	5864
3202	212	1119510	1996-06-13	1996-06-20	1	9667
42226	2861	1713332	1998-03-02	1998-03-16	1	10301
50163	3417	1112807	1937-04-20	1937-05-11	1	-11923
39584	2692	1125315	1982-10-16	1982-10-30	1	4685
3203	212	1521369	1991-02-09	1992-02-04	1	8069
42227	2861	1729720	1964-07-05	1964-07-13	1	-1998
50164	3417	1125315	2018-03-28	2018-06-26	1	17708
39585	2692	1125315	1998-06-29	1998-06-29	1	10406
3204	212	1713332	1996-04-15	1996-04-29	1	9615
50165	3417	1557272	1999-09-04	1999-09-04	1	10838
39586	2692	1174888	1998-06-29	1998-06-29	1	10406
3205	212	1729720	1993-12-15	1993-12-22	1	8756
50166	3417	1713332	1918-11-05	1918-11-12	1	-18678
39587	2692	1322184	1997-11-17	1998-06-29	1	10406
3206	212	1768849	1980-04-14	1980-04-28	1	3770
50167	3417	1713332	1943-07-28	1943-08-18	1	-9633
39588	2692	1545958	1998-06-29	1998-06-29	1	10406
3207	212	1115008	2011-01-20	2011-02-03	1	15008
50168	3417	1713332	1945-09-11	1945-09-18	1	-8871
39589	2692	1713332	1967-06-15	1967-07-06	1	-910
3208	212	1125315	1975-02-23	1975-03-09	1	1893
50169	3417	1759842	1918-11-05	1918-11-12	1	-18678
39590	2692	1728416	1950-07-04	1950-07-18	1	-7107
3209	212	1125315	1978-11-04	1978-11-18	1	3243
50170	3417	933724	1950-05-07	1950-05-14	1	-7172
39591	2692	1729720	1958-04-26	1958-05-04	1	-4260
3210	212	1125315	1980-08-27	1980-09-03	1	3898
50171	3417	1125315	1957-07-22	1957-08-05	1	-4532
41285	2802	1112807	1965-01-01	1965-04-01	1	-1736
3211	212	1503184	1991-02-09	1992-02-04	1	8069
50172	3417	1125315	1980-01-29	1980-02-12	1	3694
41286	2802	1112807	1973-06-18	1973-07-02	1	1278
3212	212	1729720	1972-09-07	1972-09-18	1	991
50173	3417	1125315	1980-06-15	1980-07-15	2	3848
41287	2802	1125315	1981-11-17	1981-12-01	1	4352
3213	212	19127890	1989-02-19	1990-02-14	1	7349
50174	3417	1125315	1989-03-28	1989-04-04	1	7033
41288	2802	1125315	1997-12-13	1997-12-13	1	10208
3214	212	738818	1996-06-13	1996-06-20	1	9667
50175	3417	1125315	1995-08-02	1995-08-09	1	9351
41289	2802	1174888	1997-12-13	1997-12-13	1	10208
3215	212	1125315	2007-04-20	2007-05-11	1	13644
50176	3417	1125315	2004-02-25	2004-03-03	1	12480
41290	2802	1322184	1997-11-01	1997-12-13	1	10208
3216	212	1177480	1980-04-14	1980-04-28	1	3770
50177	3417	1125315	2014-06-17	2014-07-17	1	16268
41291	2802	1545958	1997-12-13	1997-12-13	1	10208
3217	212	1503184	1989-02-19	1990-02-14	1	7349
50178	3417	1713332	1928-07-01	1928-07-08	1	-15152
41292	2802	1713332	1949-10-01	1949-10-08	1	-7390
3218	212	19127890	1991-02-09	1992-02-04	1	8069
50179	3417	1729720	1917-04-18	1917-04-29	1	-19240
41293	2802	1125315	1971-05-16	1971-05-23	1	507
3861	263	1118084	1991-03-28	1991-03-28	1	7756
51474	3509	1112807	1949-12-26	1950-01-23	1	-7283
41294	2802	1361711	1987-06-27	1997-12-13	1	10208
3862	263	1119510	1955-02-16	1955-03-02	1	-5419
51475	3509	1112807	1962-04-18	1962-05-09	1	-2794
41295	2802	1729720	1940-10-02	1940-10-11	1	-10674
3863	263	1125315	1988-09-04	1988-09-11	1	6828
51476	3509	1119510	1961-09-20	1961-09-27	1	-3018
41296	2802	1759842	1949-10-01	1949-10-08	1	-7390
3864	263	1177480	2013-08-21	2013-09-11	1	15959
51477	3509	1125315	1953-11-03	1953-11-17	1	-5889
41297	2802	1112807	1944-03-12	1944-04-09	1	-9398
3865	263	1326303	2016-08-28	2016-08-28	1	17041
51478	3509	1125315	1984-04-27	1984-05-18	1	5251
41298	2802	1112807	1949-12-09	1949-12-30	1	-7307
3866	263	1759842	1963-04-25	1963-05-02	1	-2436
51479	3509	1125315	1954-12-12	1954-12-26	1	-5485
41299	2802	1118084	1983-01-17	1983-01-17	1	4764
3867	263	1759842	2002-01-21	2002-02-11	1	11729
51480	3509	1125315	1961-03-08	1961-03-22	1	-3207
41300	2802	1119510	1961-03-24	1961-04-07	1	-3191
3868	263	1125315	2010-11-05	2011-01-04	1	14978
51481	3509	1177480	1989-12-18	1990-01-15	1	7319
41301	2802	1125315	1993-01-02	1993-01-16	1	8416
3869	263	1310149	2016-08-28	2016-08-28	1	17041
51482	3509	1177480	2011-03-26	2011-06-24	1	15149
41302	2802	1539403	1991-09-28	1991-09-28	1	7940
3870	263	738818	1955-02-16	1955-03-02	1	-5419
51483	3509	1713332	2011-06-18	2011-07-09	1	15164
41303	2802	738818	1961-03-24	1961-04-07	1	-3191
3871	263	1112807	1957-06-04	1957-06-18	1	-4580
51484	3509	1728416	1946-02-08	1946-02-22	1	-8714
41304	2802	1112807	1943-02-16	1943-03-02	1	-9802
3872	263	1112807	1960-02-12	1960-02-26	1	-3597
51485	3509	1729720	1976-09-21	1976-10-04	1	2468
41305	2802	1112807	1951-11-20	1951-12-11	1	-6596
3873	263	1125315	1955-02-16	1955-03-02	1	-5419
51486	3509	1759842	2011-06-18	2011-07-09	1	15164
41306	2802	1125315	1947-01-28	1947-02-04	1	-8367
3874	263	1307863	2016-08-28	2016-08-28	1	17041
51487	3509	738818	1965-05-11	1965-05-18	1	-1689
41307	2802	1125315	1952-08-06	1952-08-20	1	-6343
3875	263	1713332	2002-01-21	2002-02-11	1	11729
51488	3509	1112807	1942-12-12	1943-02-01	2	-9847
41308	2802	1125315	1961-03-24	1961-04-07	1	-3191
3876	263	1728416	1960-02-12	1960-02-26	1	-3597
51489	3509	1112807	1946-02-08	1946-02-22	1	-8714
41309	2802	1332418	1994-10-15	1994-10-15	1	9053
3877	263	1112807	1958-03-31	1958-04-14	1	-4280
51490	3509	1112807	1973-06-10	1973-06-24	1	1270
41310	2802	1728416	1949-12-09	1949-12-30	1	-7307
3878	263	1125315	1979-02-23	1979-03-23	1	3368
51491	3509	1115008	2015-12-30	2016-03-29	1	16889
41311	2802	1728416	1952-08-06	1952-08-20	1	-6343
3879	263	1713332	1963-04-25	1963-05-02	1	-2436
51492	3509	1125315	1965-05-11	1965-05-18	1	-1689
41312	2802	1729720	1953-09-01	1953-09-14	1	-5953
5397	369	1112807	1982-03-22	1982-04-05	1	4477
51493	3509	1729720	1956-06-27	1956-07-06	1	-4927
42031	2849	1102527	1987-09-25	1987-09-25	1	6476
5398	369	1125315	1997-02-15	1997-03-01	1	9921
51494	3509	738818	1961-09-20	1961-09-27	1	-3018
42032	2849	1112807	1933-11-18	1933-12-02	1	-13179
5399	369	1125315	2009-03-22	2009-03-29	1	14332
51495	3509	920293	1972-02-10	1972-02-17	1	777
42033	2849	1115008	2004-04-28	2004-06-27	1	12596
5400	369	1503184	1994-12-24	1995-12-19	1	9483
51496	3509	933724	1972-02-10	1972-02-17	1	777
42034	2849	1125315	1972-12-13	1972-12-20	1	1084
5401	369	1595799	1998-12-03	2000-11-22	2	11283
51497	3509	1118084	1987-05-25	1987-05-25	1	6353
42035	2849	1125315	2003-05-04	2003-07-03	1	12236
5402	369	1595799	2001-11-17	2002-11-12	1	12003
51498	3509	1119510	1965-05-11	1965-05-18	1	-1689
42036	2849	1112807	1937-08-13	1937-09-03	1	-11808
5403	369	1118084	2016-10-14	2016-10-14	1	17088
51499	3509	1125315	1961-09-20	1961-09-27	1	-3018
42037	2849	1112807	1964-05-14	1964-06-13	1	-2028
5404	369	1521369	1994-12-24	1995-12-19	1	9483
52862	3603	1713332	1997-03-10	1997-03-24	1	9944
42038	2849	1125315	1921-07-26	1921-08-09	1	-17677
5405	369	1713332	1982-03-22	1982-04-05	1	4477
52863	3603	1759842	1969-08-30	1969-09-13	1	-110
42039	2849	1125315	1984-10-26	1984-11-09	1	5426
5406	369	1713332	2012-05-05	2012-05-12	1	15472
52864	3603	1759842	1997-03-10	1997-03-24	1	9944
42040	2849	1729720	1927-04-08	1927-04-17	1	-15600
5407	369	1759842	2012-05-05	2012-05-12	1	15472
52865	3603	1112807	1971-09-08	1971-09-22	1	629
42041	2849	1112807	1921-09-22	1921-10-06	1	-17619
5408	369	1125315	1990-05-11	1990-05-25	1	7449
52866	3603	1119510	2006-06-21	2006-06-28	1	13327
42042	2849	1125315	1933-01-13	1933-01-20	1	-13495
5409	369	1521369	2001-11-17	2002-11-12	1	12003
52867	3603	1154343	1969-02-12	1986-07-13	1	6037
42043	2849	1177480	1987-09-25	1987-12-24	1	6566
5410	369	1549786	1998-12-03	2000-11-22	2	11283
52868	3603	738818	2006-06-21	2006-06-28	1	13327
42044	2849	1115008	2017-10-17	2018-01-15	1	17546
5411	369	1549786	2001-11-17	2002-11-12	1	12003
52869	3603	1118084	2004-03-23	2004-03-23	1	12500
42045	2849	1118084	1959-04-16	1959-04-16	1	-3913
5412	369	19127890	1994-12-24	1995-12-19	1	9483
52870	3603	1125315	1969-12-18	1969-12-25	1	-7
42046	2849	1125315	1928-09-27	1928-10-04	1	-15064
5413	369	1125315	1993-11-19	1993-12-03	1	8737
52871	3603	1125315	1974-06-14	1974-06-21	1	1632
42874	2903	1112807	1965-12-03	1965-12-17	1	-1476
5414	369	1125315	2013-03-07	2013-03-28	1	15792
52872	3603	1125315	2001-06-02	2001-06-16	1	11489
42875	2903	1125315	1973-08-23	1973-09-13	1	1351
5415	369	1125315	2014-09-18	2014-10-02	1	16345
52873	3603	1125315	2006-06-21	2006-06-28	1	13327
42876	2903	920293	1998-10-08	1998-10-15	1	10514
5416	369	1177480	1982-01-21	1982-03-22	1	4463
52874	3603	1125315	2009-07-26	2009-08-02	1	14458
42877	2903	920293	2004-11-09	2004-11-16	1	12738
5417	369	1521369	1998-12-03	2000-11-22	2	11283
52875	3603	1129625	1970-02-26	1970-02-26	1	56
42878	2903	920293	2009-12-23	2009-12-30	1	14608
8214	571	1112807	1968-02-09	1968-05-09	1	-602
52876	3603	1728416	1971-09-08	1971-09-22	1	629
42879	2903	933724	1998-10-08	1998-10-15	1	10514
8215	571	1118084	1992-01-03	1992-01-03	1	8037
52877	3603	1125315	1973-12-13	1973-12-27	1	1456
42880	2903	1115008	2013-12-12	2014-01-02	1	16072
8216	571	1125315	1980-05-17	1980-05-31	1	3803
52878	3603	1125315	2017-06-08	2017-06-22	1	17339
42881	2903	1125315	1973-04-10	1973-04-24	1	1209
8217	571	1713332	1980-02-08	1980-02-29	1	3711
52879	3603	1149380	1969-02-12	1986-07-13	1	6037
42882	2903	1125315	1974-09-06	1974-09-20	1	1723
8218	571	1102527	1968-02-09	1968-02-09	1	-692
52880	3603	1713332	1969-08-30	1969-09-13	1	-110
42883	2903	1521369	1979-09-01	1980-08-26	1	3890
8219	571	1713332	2009-09-06	2009-09-13	1	14500
52881	3603	1729720	1973-10-01	1973-10-11	1	1379
42884	2903	1717327	1965-12-03	1965-12-17	1	-1476
8220	571	1713332	2013-04-06	2013-04-13	1	15808
54709	3721	933724	1994-12-14	1994-12-21	1	9120
42885	2903	1124300	2000-05-23	2000-05-23	1	11100
8221	571	1759842	2009-09-06	2009-09-13	1	14500
54710	3721	1112807	1968-02-03	1968-02-17	1	-684
42886	2903	1125315	2011-03-11	2011-03-25	1	15058
8222	571	1759842	2013-04-06	2013-04-13	1	15808
54711	3721	1125315	1964-03-14	1964-03-28	1	-2105
42887	2903	1177480	1980-03-01	1980-03-15	1	3726
8223	571	1112807	1958-06-10	1958-07-01	1	-4202
54712	3721	1503184	1978-11-06	1979-11-01	1	3591
42888	2903	1713332	1979-12-26	1980-01-09	1	3660
8224	571	1125315	2014-05-27	2014-06-03	1	16224
54713	3721	1503184	1981-10-21	1982-10-16	1	4671
42889	2903	1759842	1979-12-26	1980-01-09	1	3660
8225	571	1759842	1980-02-08	1980-02-29	1	3711
54714	3721	1713332	1975-09-19	1975-09-26	1	2094
42890	2903	19127890	1979-09-01	1980-08-26	1	3890
8226	571	738818	2005-08-03	2005-08-10	1	13005
54715	3721	1713332	2001-10-03	2001-10-17	1	11612
42891	2903	933724	2004-11-09	2004-11-16	1	12738
8227	571	1119510	2005-08-03	2005-08-10	1	13005
54716	3721	1728416	1968-02-03	1968-02-17	1	-684
42892	2903	933724	2009-12-23	2009-12-30	1	14608
8228	571	1125315	2005-08-03	2005-08-10	1	13005
54717	3721	1729720	2015-02-13	2015-02-23	1	16489
42893	2903	1125315	1966-06-02	1966-06-16	1	-1295
9773	673	1125315	1966-06-12	1966-06-26	1	-1285
54718	3721	1759842	1978-12-17	1979-01-07	1	3293
42894	2903	1125315	1979-01-26	1979-02-02	1	3319
9774	673	1521369	1975-09-19	1976-09-13	1	2447
54719	3721	1759842	1996-09-04	1996-09-11	1	9750
42895	2903	1503184	1979-09-01	1980-08-26	1	3890
9775	673	1713332	1983-03-20	1983-04-10	1	4847
54720	3721	1125315	1981-05-19	1981-06-02	1	4170
46903	3181	1118084	1987-11-19	1987-11-19	1	6531
9776	673	1102527	1983-03-20	1983-03-20	1	4826
54721	3721	1728416	1964-03-14	1964-03-28	1	-2105
46904	3181	1119510	1994-12-27	1995-01-10	1	9140
9777	673	1112807	1962-09-17	1962-10-01	1	-2649
54722	3721	19127890	1978-11-06	1979-11-01	1	3591
46905	3181	1125315	1982-04-25	1982-05-16	1	4518
9778	673	1118084	1995-12-03	1995-12-03	1	9467
54723	3721	19127890	1981-10-21	1982-10-16	1	4671
46906	3181	1137529	2001-06-22	2001-06-22	1	11495
9779	673	1125315	1967-05-24	1967-06-28	1	-918
54724	3721	738818	1968-11-28	1968-12-12	1	-385
46907	3181	1149380	1953-09-20	1953-09-20	1	-5947
9780	673	1125315	1983-03-20	1983-04-10	1	4847
54725	3721	920293	1994-12-14	1994-12-21	1	9120
46908	3181	1729720	1984-07-23	1984-08-03	1	5328
9781	673	1125315	1984-12-30	1985-01-27	1	5505
54726	3721	1118084	2002-08-27	2002-08-27	1	11926
46909	3181	1125315	1977-11-06	1977-11-20	1	2880
9782	673	1149380	1964-09-28	1964-09-28	1	-1921
54727	3721	1125315	1968-11-28	1968-12-12	1	-385
1636	110	920293	1998-03-13	1998-03-20	1	10305
9783	673	1177480	2012-05-26	2012-06-16	1	15507
54728	3721	1125315	1972-06-12	1972-06-26	1	907
1637	110	1125315	2001-04-06	2001-04-13	1	11425
9784	673	1521369	1979-08-29	1980-08-23	1	3887
54729	3721	1125315	1978-08-28	1978-09-11	1	3175
1638	110	1125315	2015-02-10	2015-02-17	1	16483
9785	673	1521369	1981-08-18	1982-08-13	1	4607
54730	3721	1521369	1978-11-06	1979-11-01	1	3591
1639	110	1549786	1993-02-03	1994-01-29	1	8794
9786	673	1521369	1983-08-08	1984-08-02	1	5327
54731	3721	1521369	1981-10-21	1982-10-16	1	4671
1640	110	19127890	1993-02-03	1994-01-29	1	8794
9787	673	1115008	2014-08-05	2014-09-04	1	16317
54732	3721	1713332	1978-12-17	1979-01-07	1	3293
1641	110	1115008	2009-08-18	2009-09-22	1	14509
9788	673	1125315	1973-11-20	1973-11-27	1	1426
54733	3721	1759842	1975-09-19	1975-09-26	1	2094
1642	110	1118084	2018-08-23	2018-08-23	1	17766
9789	673	1125315	1978-09-28	1978-10-12	1	3206
54734	3721	1119510	1968-11-28	1968-12-12	1	-385
1643	110	1125315	1979-08-28	1979-09-11	1	3540
9790	673	1154343	1964-09-28	1964-09-28	1	-1921
54735	3721	1125315	1965-10-06	1965-10-13	1	-1541
1644	110	1125315	2013-09-01	2013-10-06	1	15984
9791	673	1503184	1975-09-19	1976-09-13	1	2447
54736	3721	1713332	1996-09-04	1996-09-11	1	9750
1645	110	1521369	1990-02-11	1991-02-06	1	7706
9792	673	19127890	1979-08-29	1980-08-23	1	3887
54737	3721	1729720	1971-09-16	1971-09-25	1	632
1646	110	1503184	1990-02-11	1991-02-06	1	7706
9793	673	19127890	1981-08-18	1982-08-13	1	4607
54738	3721	1759842	2001-10-03	2001-10-17	1	11612
1647	110	933724	1998-03-13	1998-03-20	1	10305
9794	673	19127890	1983-08-08	1984-08-02	1	5327
56341	3839	920293	1987-11-11	1987-11-18	1	6530
1648	110	1177480	2003-07-23	2003-08-20	1	12284
9795	673	1125315	2005-11-22	2005-12-29	1	13146
56342	3839	933724	1987-11-11	1987-11-18	1	6530
1649	110	1515774	1993-02-03	1994-01-29	1	8794
9796	673	1177480	1998-03-20	1998-04-03	1	10319
56343	3839	1119510	1994-07-23	1994-08-06	1	8983
1650	110	1729720	1984-04-06	1984-04-17	1	5220
9797	673	1503184	1979-08-29	1980-08-23	1	3887
56344	3839	1125315	1951-10-18	1951-12-17	1	-6590
1651	110	19127890	1990-02-11	1991-02-06	1	7706
9798	673	1503184	1981-08-18	1982-08-13	1	4607
56345	3839	1177480	2017-04-30	2017-05-30	1	17316
3611	244	738818	1946-01-29	1946-02-05	1	-8731
9799	673	1503184	1983-08-08	1984-08-02	1	5327
56346	3839	1759842	1961-10-31	1961-11-14	1	-2970
3612	244	1125315	1946-01-29	1946-02-05	1	-8731
9800	673	1729720	1987-05-10	1987-05-21	1	6349
56347	3839	1112807	1959-05-09	1959-06-08	1	-3860
3613	244	1125315	1974-10-16	1974-10-30	1	1763
9801	673	19127890	1975-09-19	1976-09-13	1	2447
56348	3839	1112807	1972-08-03	1972-10-02	1	1005
3614	244	1729720	1949-10-27	1949-11-09	1	-7358
10576	727	738818	1926-11-26	1926-12-03	1	-15735
56349	3839	1118084	1994-06-24	1994-06-24	1	8940
3615	244	1112807	1926-05-07	1926-05-21	1	-15931
10577	727	738818	1927-04-03	1927-04-17	1	-15600
56350	3839	1125315	1957-09-17	1957-10-01	1	-4475
3616	244	1112807	1938-02-09	1938-02-23	1	-11635
10578	727	1115008	1998-01-16	1998-04-16	1	10332
56351	3839	1125315	1970-08-09	1970-09-13	1	255
3617	244	1118084	1966-06-06	1966-06-06	1	-1305
10579	727	1115008	2013-10-24	2013-11-07	1	16016
56352	3839	1125315	2012-05-26	2012-08-24	1	15576
3618	244	1125315	1926-12-20	1926-12-27	1	-15711
10580	727	1118084	1947-05-12	1947-05-12	1	-8270
56353	3839	1713332	1952-02-08	1952-02-29	1	-6516
3619	244	1713332	1932-12-08	1932-12-29	1	-13517
10581	727	757627	2008-02-01	2008-02-01	1	13910
56354	3839	1713332	1957-04-12	1957-04-26	1	-4633
3620	244	1125315	1993-07-02	1993-07-09	1	8590
10582	727	1112807	1914-08-23	1914-09-06	1	-20206
56355	3839	1713332	1958-06-26	1958-07-10	1	-4193
3621	244	1759842	1932-12-08	1932-12-29	1	-13517
10583	727	1112807	1944-05-17	1944-06-07	1	-9339
56356	3839	1759842	1984-09-20	1984-10-04	1	5390
3622	244	1119510	1946-01-29	1946-02-05	1	-8731
10584	727	1112807	1969-08-25	1969-09-15	1	-108
56357	3839	1713332	1961-10-31	1961-11-14	1	-2970
3623	244	1125315	1923-06-23	1923-06-30	1	-16987
10585	727	1125315	1926-11-26	1926-12-03	1	-15735
56358	3839	1713332	1984-09-20	1984-10-04	1	5390
3624	244	1125315	1954-03-09	1954-03-16	1	-5770
10586	727	1125315	1927-04-03	1927-04-17	1	-15600
56359	3839	1729720	1952-12-12	1952-12-21	1	-6220
3625	244	1729720	1972-11-04	1972-11-12	1	1046
10587	727	1125315	1951-08-04	1951-08-11	1	-6718
56360	3839	738818	1994-07-23	1994-08-06	1	8983
4294	295	738818	1973-12-07	1973-12-21	1	1450
10588	727	1125315	1974-03-23	1974-04-22	1	1572
56361	3839	1125315	1994-07-23	1994-08-06	1	8983
4295	295	1115008	2015-11-24	2016-02-22	1	16853
10589	727	1125315	1988-08-06	1988-09-05	2	6822
56362	3839	1177480	2007-11-28	2007-12-19	1	13866
4296	295	1125315	1973-12-07	1973-12-21	1	1450
10590	727	1125315	1991-04-23	1991-06-22	1	7842
56363	3839	1759842	1952-02-08	1952-02-29	1	-6516
4297	295	1125315	2017-02-16	2017-02-16	1	17213
10591	727	1713332	1960-01-25	1960-02-08	1	-3615
56364	3839	1759842	1957-04-12	1957-04-26	1	-4633
4298	295	1177480	2017-02-16	2017-05-17	1	17303
10592	727	701322	2009-05-26	2009-05-26	1	14390
56365	3839	1759842	1958-06-26	1958-07-10	1	-4193
4299	295	1729720	1975-08-06	1975-08-18	1	2055
10593	727	1112807	1915-04-07	1915-04-21	1	-19979
56984	3884	738818	2001-08-27	2001-09-03	1	11568
4300	295	1125315	1951-04-06	1951-06-05	1	-6785
10594	727	1125315	1917-04-10	1917-04-24	1	-19245
56985	3884	1119510	2001-08-27	2001-09-03	1	11568
4301	295	1125315	1990-04-02	1990-04-09	1	7403
10595	727	1125315	1949-09-20	1949-09-27	1	-7401
56986	3884	1125315	1975-10-10	1975-10-24	1	2122
4302	295	1174888	2017-02-16	2017-02-16	1	17213
10596	727	1119510	1926-11-26	1926-12-03	1	-15735
56987	3884	1125315	2001-08-27	2001-09-03	1	11568
4303	295	1713332	1987-04-14	1987-05-05	1	6333
10597	727	1119510	1927-04-03	1927-04-17	1	-15600
56988	3884	1738521	1974-07-15	1974-07-29	1	1670
4304	295	1729720	1951-12-03	1951-12-13	1	-6594
10598	727	1124957	1988-08-06	1988-08-06	1	6792
56989	3884	705944	1984-03-24	1990-04-14	1	7408
4305	295	1729720	1964-03-21	1964-04-03	1	-2099
10599	727	1729720	1920-02-06	1920-02-17	1	-18216
56990	3884	1177480	1983-02-26	1983-03-12	1	4818
4306	295	1759842	1987-04-14	1987-05-05	1	6333
10600	727	1759842	1960-01-25	1960-02-08	1	-3615
56991	3884	1729720	2005-05-22	2005-06-02	1	12936
4307	295	1118084	1993-06-19	1993-06-19	1	8570
12888	882	1119510	2018-09-03	2018-09-17	1	17791
56992	3884	1112807	1973-03-22	1973-04-19	1	1204
4308	295	1119510	1973-12-07	1973-12-21	1	1450
12889	882	1174888	2013-06-27	2013-06-27	1	15883
56993	3884	1118084	2011-04-07	2011-04-07	1	15071
4309	295	1125315	1953-05-25	1953-06-08	1	-6051
12890	882	1713332	1987-05-23	1987-06-13	1	6372
56994	3884	1125315	1976-08-22	1976-09-05	1	2439
4310	295	1125315	1980-07-18	1980-07-25	1	3858
12891	882	1728416	1946-10-25	1946-11-08	1	-8455
56995	3884	1125315	1997-01-12	1997-01-19	1	9880
4311	295	1125315	1984-04-12	1984-05-10	1	5243
12892	882	1759842	1987-05-23	1987-06-13	1	6372
56996	3884	1125315	1974-07-15	1974-07-29	1	1670
4312	295	1125315	1984-10-04	1984-10-18	1	5404
12893	882	1112807	1946-10-25	1946-11-08	1	-8455
56997	3884	1129625	1975-04-17	1975-04-17	1	1932
4313	295	1728416	1953-05-25	1953-06-08	1	-6051
12894	882	1322184	2016-12-10	2016-12-10	1	17145
56998	3884	1729720	1980-01-18	1980-01-31	1	3682
4314	295	1729720	1959-09-04	1959-09-13	1	-3763
12895	882	1347450	2016-12-10	2016-12-10	1	17145
57638	3930	1112807	1914-09-28	1914-10-12	1	-20170
4946	337	1112807	1960-01-21	1960-02-04	1	-3619
12896	882	1729720	1971-01-24	1971-02-05	1	400
57639	3930	1112807	1916-01-29	1916-02-12	1	-19682
4947	337	1115008	2013-10-23	2013-11-27	1	16036
12897	882	738818	1975-03-17	1975-03-24	1	1908
57640	3930	1124300	1957-11-06	1957-11-06	1	-4439
4948	337	1729720	1980-11-02	1980-11-11	1	3967
12898	882	1112807	1945-04-22	1945-05-06	1	-9006
57641	3930	1125315	1935-02-28	1935-03-14	1	-12712
4949	337	1759842	1985-02-22	1985-03-01	1	5538
12899	882	1125315	1975-03-17	1975-03-24	1	1908
57642	3930	1729720	1927-10-05	1927-10-18	1	-15416
4950	337	1112807	1965-09-21	1965-10-05	1	-1549
12900	882	1125315	1987-10-18	1987-10-25	1	6506
57643	3930	1759842	1956-10-30	1956-11-20	1	-4790
4951	337	1118084	1997-07-30	1997-07-30	1	10072
12901	882	1125315	1993-11-06	1993-11-27	1	8731
57644	3930	1112807	1945-07-13	1945-07-27	1	-8924
4952	337	1125315	1962-06-09	1962-09-07	1	-2673
12902	882	1729720	1957-06-07	1957-06-16	1	-4582
57645	3930	1125315	1917-09-14	1917-09-28	1	-19088
4953	337	1713332	1978-12-05	1978-12-19	1	3274
12903	882	1759842	1970-12-31	1971-01-21	1	385
57646	3930	1149380	1964-11-28	1964-11-28	1	-1860
4954	337	1125315	1986-02-04	1986-02-18	1	5892
12904	882	738818	2018-09-03	2018-09-17	1	17791
57647	3930	1713332	1956-10-30	1956-11-20	1	-4790
4955	337	1125315	1991-08-06	1991-08-13	1	7894
12905	882	1115008	2015-05-18	2015-07-24	1	16640
57648	3930	1112807	1917-05-20	1917-06-10	1	-19198
4956	337	1177480	2018-11-01	2018-11-22	1	17857
12906	882	1119510	1975-03-17	1975-03-24	1	1908
57649	3930	1137529	1964-11-28	1964-11-28	1	-1860
4957	337	705944	1973-09-19	1977-09-28	1	2827
12907	882	1124300	1987-12-03	1987-12-03	1	6545
57650	3930	1112807	1916-06-19	1916-07-24	1	-19519
4958	337	1112807	1963-04-16	1963-04-30	1	-2438
12908	882	1125315	2002-02-13	2002-03-20	1	11766
57651	3930	1112807	1917-02-01	1917-02-15	1	-19313
4959	337	1713332	1985-02-22	1985-03-01	1	5538
12909	882	1125315	2013-06-20	2013-08-26	2	15943
57652	3930	1361711	1972-07-22	1979-12-29	1	3649
4960	337	1759842	1978-12-05	1978-12-19	1	3274
12910	882	1125315	2018-09-03	2018-09-17	1	17791
57653	3930	1729720	1923-04-18	1923-04-27	1	-17051
6432	445	738818	1931-03-13	1931-03-27	1	-14160
12911	882	1713332	1970-12-31	1971-01-21	1	385
57654	3930	1729720	1971-07-11	1971-07-21	1	566
6433	445	1112807	1917-06-22	1917-07-06	1	-19172
12912	882	1728416	1945-04-22	1945-05-06	1	-9006
59052	4022	1118084	1999-07-28	1999-07-28	1	10800
6434	445	1125315	1931-03-13	1931-03-27	1	-14160
14547	1000	1112807	1964-11-03	1965-01-16	2	-1841
59053	4022	19127890	1974-07-09	1975-07-04	1	2010
6435	445	1125315	1947-09-13	1947-09-27	1	-8132
14548	1000	1115008	2011-06-12	2011-06-26	1	15151
59054	4022	19127890	1977-06-23	1978-06-18	1	3090
6436	445	1112807	1915-09-01	1915-09-15	1	-19832
14549	1000	1118084	2008-01-22	2008-01-22	1	13900
59055	4022	920293	1977-08-13	1977-08-20	1	2788
6437	445	1112807	1951-08-05	1951-08-19	1	-6710
14550	1000	1125315	1966-10-24	1967-01-22	1	-1075
59056	4022	933724	1977-08-13	1977-08-20	1	2788
6438	445	1119510	1931-03-13	1931-03-27	1	-14160
14551	1000	1177480	1995-02-08	1995-03-08	1	9197
59057	4022	1125315	1993-03-26	1993-04-09	1	8499
6439	445	1125315	1950-12-23	1950-12-30	1	-6942
14552	1000	740275	2017-01-29	2017-07-30	1	17377
59058	4022	1177480	2010-06-09	2010-07-14	1	14804
6440	445	1112807	1935-06-02	1935-06-30	1	-12604
14553	1000	1102527	1976-02-18	1976-02-18	1	2239
59059	4022	1713332	2012-06-26	2012-07-03	1	15524
6441	445	1118084	1953-11-30	1953-11-30	1	-5876
14554	1000	1125315	1972-08-23	1972-11-21	1	1055
59060	4022	1713332	2015-12-24	2015-12-31	1	16800
6442	445	740275	1925-09-18	1927-07-01	1	-15525
14555	1000	920293	2016-02-25	2016-03-03	1	16863
59061	4022	1112807	1968-02-01	1968-03-07	1	-665
6443	445	1125315	1968-03-15	1968-03-22	1	-650
14556	1000	1125315	1973-12-16	1973-12-30	1	1459
59062	4022	1521369	1974-07-09	1975-07-04	1	2010
6444	445	1713332	1922-12-18	1923-01-08	1	-17160
14557	1000	1125315	1976-02-18	1976-03-19	1	2269
59063	4022	1521369	1977-06-23	1978-06-18	1	3090
6445	445	1759842	1922-12-18	1923-01-08	1	-17160
14558	1000	1717327	1965-01-02	1965-01-16	1	-1811
59064	4022	1759842	1963-12-30	1964-01-20	1	-2173
6655	459	1118084	2008-07-12	2008-07-12	1	14072
14559	1000	740275	2018-03-13	2018-08-28	1	17771
59065	4022	1503184	1974-07-09	1975-07-04	1	2010
6656	459	1759842	2012-10-25	2012-11-01	1	15645
14560	1000	933724	2016-02-25	2016-03-03	1	16863
59066	4022	1503184	1977-06-23	1978-06-18	1	3090
6657	459	1125315	1975-01-07	1975-01-21	1	1846
14561	1000	1125315	1970-09-04	1970-09-18	1	260
59067	4022	1713332	1963-12-30	1964-01-20	1	-2173
6658	459	1125315	1985-02-15	1985-02-22	1	5531
14562	1000	1125315	1972-04-20	1972-05-04	1	854
59068	4022	1729720	1968-11-28	1968-12-06	1	-391
6659	459	1177480	1987-12-05	1988-01-02	1	6575
14563	1000	1729720	1995-12-16	1995-12-29	1	9493
59069	4022	1759842	2012-06-26	2012-07-03	1	15524
6660	459	1177480	2013-12-16	2014-02-14	1	16115
15676	1086	1115008	2013-03-20	2013-04-03	1	15798
59070	4022	1759842	2015-12-24	2015-12-31	1	16800
6661	459	1177480	1984-12-20	1985-01-19	1	5497
15677	1086	1119510	1990-02-24	1990-03-03	1	7366
59207	4032	1125315	1961-01-18	1961-04-18	1	-3180
6662	459	1112807	1975-05-07	1975-06-11	1	1987
15678	1086	1125315	1988-11-23	1988-11-30	1	6908
59208	4032	1125315	1979-01-31	1979-02-07	1	3324
6663	459	1713332	2012-10-25	2012-11-01	1	15645
15679	1086	1125315	1993-12-01	1993-12-15	1	8749
59209	4032	1177480	2014-01-27	2014-02-17	1	16118
7757	539	1102527	1956-01-02	1956-01-02	1	-5113
15680	1086	1177480	2012-03-20	2012-04-24	1	15454
59210	4032	1310149	2010-07-20	2010-07-20	1	14810
7758	539	1112807	1970-05-18	1970-06-08	1	158
15681	1086	1177480	2015-04-23	2015-06-22	1	16608
59211	4032	1713332	1996-07-27	1996-08-03	1	9711
7759	539	1119510	1981-06-10	1981-06-17	1	4185
15682	1086	1759842	1969-11-13	1969-12-04	1	-28
59212	4032	1729720	2007-06-22	2007-07-04	1	13698
7760	539	1125315	1972-12-15	1972-12-22	1	1086
15683	1086	1118084	2004-07-21	2004-07-21	1	12620
59213	4032	1115008	2001-10-20	2001-11-10	1	11636
7761	539	1174888	1999-07-25	1999-07-25	1	10797
15684	1086	1125315	1973-04-02	1973-04-16	1	1201
59214	4032	1125315	1953-04-16	1953-04-30	1	-6090
7762	539	1322184	1997-03-09	1999-07-25	1	10797
15685	1086	1713332	1969-11-13	1969-12-04	1	-28
59215	4032	1125315	1985-08-21	1985-09-04	1	5725
7763	539	1539403	1991-02-03	1991-02-03	1	7703
15686	1086	1738521	1967-06-01	1967-06-15	1	-931
59216	4032	1125315	2010-12-23	2011-01-13	1	14987
7764	539	1759842	1990-12-19	1991-01-02	1	7671
15687	1086	738818	1990-02-24	1990-03-03	1	7366
59217	4032	1102527	1960-02-23	1960-02-23	1	-3600
7765	539	1112807	1955-12-26	1956-03-02	1	-5053
15688	1086	1112807	1967-06-01	1967-06-15	1	-931
59218	4032	1125315	1960-02-23	1960-03-24	1	-3570
7766	539	1118084	1968-12-02	1968-12-02	1	-395
15689	1086	1125315	1990-02-24	1990-03-03	1	7366
59219	4032	1125315	1987-02-19	1987-03-05	1	6272
7767	539	1125315	1950-11-24	1950-12-08	1	-6964
15690	1086	1713332	1989-08-19	1989-09-09	1	7191
59220	4032	1125315	1989-08-19	1989-09-23	1	7205
7768	539	1125315	1989-01-16	1989-01-23	1	6962
15691	1086	1759842	1970-05-08	1970-05-22	1	141
59221	4032	1125315	2001-05-22	2001-06-05	1	11478
7769	539	1125315	1999-07-25	1999-07-25	1	10797
15692	1086	1759842	1989-08-19	1989-09-09	1	7191
59222	4032	1307863	2010-07-20	2010-07-20	1	14810
7770	539	1545958	1999-07-25	1999-07-25	1	10797
15693	1086	1125315	1975-09-17	1975-10-01	1	2099
59223	4032	1759842	1996-07-27	1996-08-03	1	9711
7771	539	1713332	1976-11-12	1976-11-19	1	2514
15694	1086	1125315	1980-03-19	1980-04-02	1	3744
59224	4032	1118084	1991-01-22	1991-01-22	1	7691
7772	539	1759842	1969-08-09	1969-08-16	1	-138
15695	1086	1713332	1970-05-08	1970-05-22	1	141
59225	4032	1125315	2002-11-03	2002-11-10	1	12001
7773	539	738818	1981-06-10	1981-06-17	1	4185
15696	1086	1729720	1970-02-17	1970-03-01	1	59
59226	4032	1326303	2010-07-20	2010-07-20	1	14810
7774	539	740275	1933-03-26	1933-07-09	1	-13325
17226	1188	1125315	2015-12-28	2016-01-18	1	16818
61715	4212	1112807	1982-02-25	1982-03-25	1	4466
7775	539	920293	1984-04-23	1984-04-30	1	5233
17227	1188	1118084	2013-03-13	2013-03-13	1	15777
61716	4212	1125315	1981-01-31	1981-04-01	1	4108
7776	539	933724	1984-04-23	1984-04-30	1	5233
17228	1188	1177480	1983-09-17	1983-11-16	1	5067
61717	4212	1125315	1983-10-20	1983-10-27	1	5047
7777	539	933724	1990-06-09	1990-06-16	1	7471
17229	1188	1729720	1987-09-29	1987-10-06	1	6487
61718	4212	1119510	1995-01-28	1995-02-11	1	9172
7778	539	1125315	1981-06-10	1981-06-17	1	4185
18632	1281	914335	2012-07-21	2012-07-21	1	15542
61719	4212	1125315	1984-01-14	1984-03-14	1	5186
7779	539	1309944	1972-01-02	1972-01-02	1	731
18633	1281	1112807	1972-02-22	1972-03-07	1	796
61720	4212	1713332	2013-02-11	2013-03-04	1	15768
7780	539	1332418	1994-02-20	1994-02-20	1	8816
18634	1281	1112807	1973-12-02	1973-12-16	1	1445
61721	4212	1738521	1970-07-28	1970-08-11	1	222
7781	539	1343916	1972-01-02	1972-01-02	1	731
18635	1281	1115008	2008-10-31	2008-11-28	1	14211
61722	4212	1759842	2013-02-11	2013-03-04	1	15768
7782	539	1713332	1969-08-09	1969-08-16	1	-138
18636	1281	1125315	1984-06-18	1984-08-17	1	5342
61723	4212	1102527	1984-01-14	1984-01-14	1	5126
7783	539	1713332	1990-12-19	1991-01-02	1	7671
18637	1281	1125315	1997-11-30	1997-12-07	1	10202
61724	4212	1112807	1970-07-28	1970-08-11	1	222
7784	539	1759842	1976-11-12	1976-11-19	1	2514
18638	1281	1309944	2012-07-21	2012-07-21	1	15542
61725	4212	1125315	2014-12-18	2015-01-01	1	16436
7785	539	914335	1972-01-02	1972-01-02	1	731
18639	1281	1343916	2012-07-21	2012-07-21	1	15542
61726	4212	738818	1995-01-28	1995-02-11	1	9172
7786	539	920293	1990-06-09	1990-06-16	1	7471
18640	1281	1717327	1972-02-22	1972-03-07	1	796
61727	4212	1124300	2010-02-03	2010-02-03	1	14643
7787	539	1112807	1933-07-24	1933-08-07	1	-13296
18641	1281	705944	1981-12-31	1988-01-09	1	6582
61728	4212	1125315	1995-01-28	1995-02-11	1	9172
7788	539	1112807	1934-06-30	1934-07-14	1	-12955
18642	1281	1125315	1978-06-22	1978-07-06	1	3108
61729	4212	1729720	1977-01-23	1977-02-01	1	2588
7789	539	1112807	1935-08-28	1935-09-11	1	-12531
18643	1281	1713332	2018-01-29	2018-02-19	1	17581
64650	4413	1119510	1976-08-04	1976-08-18	1	2421
7790	539	1112807	1971-04-04	1971-04-18	1	472
18644	1281	1759842	2018-01-29	2018-02-19	1	17581
64651	4413	1125315	2013-06-21	2013-07-05	1	15891
7791	539	1125315	1957-03-08	1957-03-15	1	-4675
18645	1281	1124300	2005-11-10	2005-11-10	1	13097
64652	4413	1503184	1975-11-30	1976-11-24	1	2519
7792	539	1125315	1986-08-11	1986-08-25	1	6080
18646	1281	1125315	1975-06-12	1975-06-26	1	2002
64653	4413	1717327	1962-07-01	1962-07-15	1	-2727
7793	539	1361711	1982-11-28	1999-07-25	1	10797
18647	1281	1717327	1975-06-12	1975-06-26	1	2002
64654	4413	1729720	1962-07-13	1962-07-21	1	-2721
9016	621	1112807	1915-11-04	1915-11-18	1	-19768
18648	1281	1115008	2002-10-12	2002-11-02	1	11993
64655	4413	1112807	1962-07-01	1962-07-15	1	-2727
9017	621	1112807	1919-04-17	1919-05-17	1	-18492
18649	1281	1713332	1991-09-07	1992-01-25	1	8059
64656	4413	1125315	1965-09-15	1965-09-29	1	-1555
9018	621	1347450	1995-11-29	1995-11-29	1	9463
18650	1281	1728416	1973-12-02	1973-12-16	1	1445
64657	4413	1177480	1975-08-22	1975-09-12	1	2080
9019	621	1713332	1979-08-15	1979-09-05	1	3534
18651	1281	1759842	1991-09-07	1992-01-25	1	8059
64658	4413	1729720	1961-10-08	1961-10-15	1	-3000
9020	621	1729720	1926-02-09	1926-02-17	1	-16024
20551	1399	1125315	1988-04-01	1988-04-08	1	6672
64659	4413	1729720	1966-06-04	1966-06-17	1	-1294
9021	621	1310149	2015-03-18	2015-03-18	1	16512
20552	1399	1125315	1992-07-18	1992-07-25	1	8241
64660	4413	19127890	1975-11-30	1976-11-24	1	2519
9022	621	1713332	1951-01-31	1951-02-21	1	-6889
20553	1399	1119510	1967-05-25	1967-06-01	1	-945
64661	4413	723013	1996-11-29	1997-05-09	1	9990
9023	621	1713332	1966-02-23	1966-03-02	1	-1401
20554	1399	1125315	2008-04-21	2008-05-26	1	14025
64662	4413	738818	1976-08-04	1976-08-18	1	2421
9024	621	1112807	1922-12-27	1923-01-24	1	-17144
20555	1399	1129625	1962-07-20	1962-07-20	1	-2722
64663	4413	1125315	1964-02-03	1964-02-17	1	-2145
9025	621	1124300	1953-11-29	1953-11-29	1	-5877
20556	1399	705944	1972-06-26	1978-07-05	1	3107
64664	4413	1125315	1976-08-04	1976-09-06	3	2440
9026	621	1177480	1982-12-10	1982-12-31	1	4747
20557	1399	1115008	2000-09-25	2000-10-30	1	11260
64665	4413	1115008	2006-10-29	2006-12-03	1	13485
9027	621	1557272	2003-01-08	2003-01-08	1	12060
20558	1399	1124300	1992-10-09	1992-10-09	1	8317
64666	4413	1124300	1997-11-14	1997-11-14	1	10179
9028	621	1759842	1951-01-31	1951-02-21	1	-6889
20559	1399	738818	1967-05-25	1967-06-01	1	-945
64667	4413	1124957	1976-08-07	1976-08-07	1	2410
9029	621	1759842	1966-02-23	1966-03-02	1	-1401
20560	1399	1112807	1960-11-26	1960-12-10	1	-3309
64668	4413	1125315	2012-04-18	2012-04-25	1	15455
9030	621	1759842	1979-08-15	1979-09-05	1	3534
20561	1399	1125315	1967-05-25	1967-06-01	1	-945
64669	4413	1521369	1975-11-30	1976-11-24	1	2519
9031	621	1125315	2017-05-01	2017-05-15	1	17301
20562	1399	1125315	1994-12-28	1995-01-19	1	9149
66808	4561	1125315	1954-01-22	1954-02-05	1	-5809
9032	621	1307863	2015-03-18	2015-03-18	1	16512
21024	1435	1177480	2014-03-12	2014-03-26	1	16155
66809	4561	1125315	1984-08-06	1984-08-13	1	5338
9033	621	1326303	2015-03-18	2015-03-18	1	16512
21025	1435	1713332	1996-10-08	1996-10-29	1	9798
66810	4561	1125315	1988-08-20	1988-11-18	2	6896
9034	621	1729720	1926-04-21	1926-04-29	1	-15953
21026	1435	1759842	1996-10-08	1996-10-29	1	9798
66811	4561	1125315	2004-12-24	2005-01-07	1	12790
11085	759	738818	1982-12-30	1983-01-13	1	4760
21027	1435	1778162	2014-03-12	2014-03-26	1	16155
66812	4561	1713332	1958-07-19	1958-07-26	1	-4177
11086	759	1125315	1948-12-14	1948-12-21	1	-7681
21028	1435	738818	1980-10-27	1980-11-10	1	3966
66813	4561	1729720	1959-04-12	1959-04-20	1	-3909
11087	759	1125315	1957-10-07	1957-10-21	1	-4455
21029	1435	1112807	1984-05-18	1984-06-01	1	5265
66814	4561	1759842	1996-11-30	1996-12-14	1	9844
11088	759	1125315	1962-10-03	1962-10-17	1	-2633
21030	1435	1125315	1980-10-27	1980-11-10	1	3966
66815	4561	1125315	1961-12-29	1962-01-12	1	-2911
11089	759	1125315	1982-12-30	1983-01-13	1	4760
21031	1435	1125315	2002-05-26	2002-06-30	1	11868
66816	4561	1759842	1958-04-05	1958-04-12	1	-4282
11090	759	1125315	1992-09-19	1992-10-03	1	8311
21032	1435	1125315	2008-11-20	2008-11-27	1	14210
66817	4561	1118084	1984-06-22	1984-06-22	1	5286
11091	759	1729720	1980-08-22	1980-09-02	1	3897
21033	1435	1125315	2009-01-24	2009-04-24	1	14358
66818	4561	1124957	1988-08-20	1988-08-20	1	6806
11092	759	1759842	1970-07-24	1970-08-07	1	218
21034	1435	1125315	2010-03-23	2010-04-06	1	14705
66819	4561	1713332	1958-04-05	1958-04-12	1	-4282
11093	759	1102527	2016-11-17	2016-11-17	1	17122
21035	1435	1759842	1996-05-14	1996-06-04	1	9651
66820	4561	1713332	1996-11-30	1996-12-14	1	9844
11094	759	1119510	1982-12-30	1983-01-13	1	4760
21036	1435	1759842	2010-09-03	2010-09-24	1	14876
66821	4561	1717327	1961-12-29	1962-01-12	1	-2911
11095	759	1310149	2003-02-19	2003-02-19	1	12102
21037	1435	1102527	2009-01-24	2009-01-24	1	14268
66822	4561	1125315	1952-06-30	1952-07-14	1	-6380
11096	759	1326303	2003-02-19	2003-02-19	1	12102
21038	1435	1112807	1968-07-11	1968-10-09	1	-449
66823	4561	1125315	2015-06-23	2015-06-30	1	16616
11097	759	1115008	2016-11-17	2017-01-16	1	17182
21039	1435	1115008	1996-02-13	1996-02-27	1	9553
66824	4561	1728416	1952-06-30	1952-07-14	1	-6380
11098	759	1118084	1980-06-13	1980-06-13	1	3816
21040	1435	1729720	1976-08-21	1976-09-01	1	2435
66825	4561	1729720	1980-04-12	1980-04-20	1	3762
11099	759	1125315	1973-12-23	1974-01-06	1	1466
21041	1435	920293	1987-03-30	1987-04-06	1	6304
66826	4561	1759842	1958-07-19	1958-07-26	1	-4177
11100	759	1125315	1977-01-20	1977-02-10	1	2597
21042	1435	933724	1987-03-30	1987-04-06	1	6304
69834	4763	1112807	1966-08-19	1966-09-18	1	-1201
11101	759	1125315	2017-09-07	2017-09-21	1	17430
21043	1435	1119510	1980-10-27	1980-11-10	1	3966
69835	4763	1118084	1990-04-24	1990-04-24	1	7418
11102	759	1307863	2003-02-19	2003-02-19	1	12102
21044	1435	1124300	2002-09-26	2002-09-26	1	11956
69836	4763	1125315	1989-11-21	1990-01-20	1	7324
11103	759	1713332	1970-07-24	1970-08-07	1	218
21045	1435	1125315	1967-12-16	1967-12-30	1	-733
69837	4763	1177480	1983-06-21	1983-07-21	1	4949
11104	759	1112807	1946-07-27	1946-08-10	1	-8545
21046	1435	1125315	2016-09-11	2016-09-18	1	17062
69838	4763	1729720	1962-03-13	1962-03-22	1	-2842
11105	759	1112807	1969-03-28	1969-04-18	1	-258
21047	1435	1177480	1994-02-09	1994-02-23	1	8819
69839	4763	1759842	1960-07-03	1960-07-17	1	-3455
11106	759	1125315	2005-07-25	2005-08-01	1	12996
21048	1435	1713332	1996-05-14	1996-06-04	1	9651
69840	4763	1112807	1951-06-18	1951-07-09	1	-6751
11107	759	1125315	2015-11-02	2015-11-23	1	16762
21049	1435	1713332	2010-09-03	2010-09-24	1	14876
69841	4763	1112807	1987-03-02	1987-04-06	1	6304
12369	850	1125315	1978-04-06	1978-04-20	1	3031
21050	1435	1729720	1969-09-08	1969-09-17	1	-106
69842	4763	1729720	1962-12-18	1962-12-31	1	-2558
12370	850	1728416	1964-09-05	1964-09-19	1	-1930
21051	1435	1729720	1975-11-17	1975-11-24	1	2153
69843	4763	1112807	1955-09-09	1955-09-23	1	-5214
12371	850	1759842	1968-12-15	1968-12-22	1	-375
22288	1517	1112807	1945-02-22	1945-03-08	1	-9065
69844	4763	1125315	1953-01-08	1953-01-22	1	-6188
12372	850	1112807	1949-03-09	1949-03-23	1	-7589
22289	1517	1119510	1984-11-25	1984-12-02	1	5449
69845	4763	1713332	1960-07-03	1960-07-17	1	-3455
12373	850	1112807	1964-09-05	1964-09-19	1	-1930
22290	1517	1177480	1998-04-29	1998-05-29	1	10375
69846	4763	1728416	1953-01-08	1953-01-22	1	-6188
12374	850	1713332	1968-12-15	1968-12-22	1	-375
22291	1517	1729720	1996-04-27	1996-05-05	1	9621
69847	4763	1728416	1955-09-09	1955-09-23	1	-5214
12375	850	1125315	1971-03-15	1971-03-29	1	452
22292	1517	723013	1951-12-03	1952-07-07	1	-6387
69848	4763	1125315	2003-08-15	2003-08-22	1	12286
12376	850	1125315	1991-07-11	1991-08-08	1	7889
22293	1517	723013	1949-10-29	1950-01-28	1	-7278
69849	4763	1125315	2009-04-23	2009-05-07	1	14371
12377	850	1118084	1990-01-23	1990-01-23	1	7327
22294	1517	738818	1984-11-25	1984-12-02	1	5449
76550	5234	920293	1971-10-01	1971-10-08	1	645
13975	958	1118084	1993-08-15	1993-08-15	1	8627
22295	1517	1125315	1984-11-25	1984-12-02	1	5449
76551	5234	1125315	1989-07-20	1989-09-18	1	7200
13976	958	1125315	2002-12-12	2002-12-26	1	12047
22296	1517	1310149	2017-04-17	2017-04-17	1	17273
76552	5234	1713332	1990-07-29	1990-08-19	1	7535
13977	958	1713332	1994-02-14	1994-02-21	1	8817
22297	1517	1118084	1981-04-09	1981-04-09	1	4116
76553	5234	1759842	1990-07-29	1990-08-19	1	7535
13978	958	1759842	1994-02-14	1994-02-21	1	8817
22298	1517	1177480	2013-02-09	2013-03-11	1	15775
76554	5234	920293	1977-11-17	1977-11-24	1	2884
13979	958	1124957	1979-12-07	1979-12-07	1	3627
22299	1517	1307863	2017-04-17	2017-04-17	1	17273
76555	5234	933724	1971-10-01	1971-10-08	1	645
13980	958	1177480	1979-12-07	1980-01-11	1	3662
22300	1517	1326303	2017-04-17	2017-04-17	1	17273
76556	5234	933724	1977-11-17	1977-11-24	1	2884
13981	958	1713332	1979-12-07	1980-01-11	1	3662
23532	1597	1112807	1947-06-14	1947-06-28	1	-8223
76557	5234	1112807	1937-09-27	1937-10-11	1	-11770
13982	958	1729720	2012-12-07	2012-12-16	1	15690
23533	1597	1118084	1981-04-06	1981-04-06	1	4113
76558	5234	1112807	1962-09-30	1962-10-21	1	-2629
13983	958	1759842	2017-11-23	2017-12-14	1	17514
23534	1597	1125315	1960-06-10	1960-06-24	1	-3478
76559	5234	1112807	1977-09-07	1977-09-21	1	2820
13984	958	1125315	1990-01-15	1990-01-22	1	7326
23535	1597	1729720	1959-02-26	1959-03-10	1	-3950
76560	5234	1125315	1949-02-28	1949-03-14	1	-7598
13985	958	1125315	2013-12-06	2013-12-13	1	16052
23536	1597	738818	1993-01-15	1993-01-29	1	8429
76561	5234	1125315	1956-06-25	1956-07-09	1	-4924
13986	958	1125315	1979-12-07	1979-12-07	1	3627
23537	1597	1125315	1993-01-15	1993-01-29	1	8429
76562	5234	1125315	1972-04-15	1972-05-06	1	856
13987	958	1177480	2012-10-04	2012-10-18	1	15631
23538	1597	1551099	1948-11-08	1948-11-08	1	-7724
76563	5234	1137529	1998-04-29	1998-04-29	1	10345
13988	958	1713332	2017-11-23	2017-12-14	1	17514
23539	1597	1729720	1953-08-15	1953-08-23	1	-5975
76564	5234	1149380	1998-04-29	1998-04-29	1	10345
15187	1054	757627	2007-09-14	2007-09-14	1	13770
23540	1597	1729720	1960-10-01	1960-10-11	1	-3369
76565	5234	1729720	1936-12-02	1936-12-15	1	-12070
15188	1054	1112807	1984-02-15	1984-03-07	1	5179
23541	1597	1729720	2006-03-11	2006-03-20	1	13227
76566	5234	1112807	1960-09-26	1960-10-10	1	-3370
15189	1054	1125315	1997-07-08	1997-07-15	1	10057
23542	1597	1112807	1949-05-04	1949-05-18	1	-7533
76567	5234	1118084	1979-07-14	1979-07-14	1	3481
15190	1054	1125315	1999-11-12	1999-11-26	1	10921
23543	1597	1125315	1969-12-04	1969-12-25	1	-7
76568	5234	1125315	1993-08-28	1993-09-11	1	8654
15191	1054	1713332	1986-02-12	1986-02-19	1	5893
23544	1597	1125315	1985-09-02	1985-11-01	1	5783
76569	5234	1125315	1995-04-02	1995-04-16	1	9236
15192	1054	701322	2008-09-08	2008-09-08	1	14130
23545	1597	1551099	1945-04-25	1945-04-25	1	-9017
76570	5234	757627	2006-07-19	2006-07-19	1	13348
15193	1054	1112807	1956-02-14	1956-02-28	1	-5056
23546	1597	1728416	1947-06-14	1947-06-28	1	-8223
76571	5234	1112807	1953-02-05	1953-03-07	1	-6144
15194	1054	1174888	2000-02-03	2000-02-03	1	10990
23547	1597	1729720	2003-04-12	2003-04-23	1	12165
76572	5234	1112807	1965-09-05	1965-09-19	1	-1565
15195	1054	1713332	1934-03-20	1934-04-10	1	-13050
23548	1597	1102527	1965-02-28	1965-02-28	1	-1768
76573	5234	1713332	2000-07-25	2000-08-15	1	11184
15196	1054	1713332	1988-06-13	1988-06-20	1	6745
23549	1597	1112807	1956-04-11	1956-05-02	1	-4992
76574	5234	1759842	2000-07-25	2000-08-15	1	11184
15197	1054	1759842	1934-03-20	1934-04-10	1	-13050
23550	1597	1112807	1965-02-28	1965-04-29	1	-1708
77214	5278	1125315	1981-06-07	1981-06-14	1	4182
15198	1054	1759842	1988-06-13	1988-06-20	1	6745
23551	1597	1115008	1994-07-18	1994-08-01	1	8978
77215	5278	1149380	1973-05-15	1973-05-15	1	1230
15199	1054	1125315	1957-05-05	1957-05-19	1	-4610
23552	1597	1119510	1993-01-15	1993-01-29	1	8429
77216	5278	1759842	1970-11-08	1970-11-22	1	325
15200	1054	1125315	2012-03-01	2012-03-15	1	15414
23553	1597	1125315	1954-07-08	1954-07-22	1	-5642
77217	5278	1124300	2013-10-15	2013-10-15	1	15993
15201	1054	1713332	1987-03-22	1987-04-12	1	6310
23815	1611	738818	2011-10-12	2011-10-19	1	15266
77218	5278	1125315	1987-05-05	1987-05-19	1	6347
15202	1054	1713332	1999-11-12	1999-11-26	1	10921
23816	1611	1124300	1997-10-10	1997-10-10	1	10144
77219	5278	1713332	1970-11-08	1970-11-22	1	325
15203	1054	1759842	1987-03-22	1987-04-12	1	6310
23817	1611	1125315	1968-12-13	1968-12-27	1	-370
77220	5278	1112807	1984-12-16	1985-02-14	1	5523
15204	1054	1112807	1934-06-09	1934-06-23	1	-12976
23818	1611	1125315	1990-09-07	1990-09-21	1	7568
77221	5278	1125315	1971-06-28	1971-09-26	1	633
15205	1054	1112807	1985-11-27	1985-12-18	1	5830
23819	1611	1125315	2011-10-12	2011-10-19	1	15266
77222	5278	1125315	1984-12-16	1984-12-16	1	5463
15206	1054	1118084	1973-01-25	1973-01-25	1	1120
23820	1611	1322184	2017-04-09	2017-04-09	1	17265
77223	5278	1154343	1973-05-15	1973-05-15	1	1230
15207	1054	1125315	1939-08-13	1939-08-27	1	-11085
23821	1611	1347450	2017-04-09	2017-04-09	1	17265
77224	5278	1713332	1990-04-29	1990-05-13	1	7437
15208	1054	1125315	1973-04-29	1973-05-13	1	1228
23822	1611	1713332	2002-10-06	2002-10-27	1	11987
77225	5278	1759842	1990-04-29	1990-05-13	1	7437
15209	1054	1125315	1996-10-26	1996-11-02	1	9802
23823	1611	1119510	2011-10-12	2011-10-19	1	15266
77226	5278	1124957	1984-12-16	1984-12-16	1	5463
15210	1054	1125315	2000-02-03	2000-05-03	2	11080
23824	1611	1124957	1991-07-28	1991-07-28	1	7878
77227	5278	1729720	2006-01-24	2006-02-06	1	13185
15211	1054	1759842	1986-02-12	1986-02-19	1	5893
23825	1611	1125315	1955-07-23	1955-08-06	1	-5262
50229	3422	738818	1980-05-10	1980-05-17	1	3789
16332	1128	1125315	1975-02-21	1975-02-28	1	1884
23826	1611	1759842	1972-05-25	1972-06-15	1	896
50230	3422	740275	1980-01-14	1980-01-14	1	3665
16333	1128	1729720	1987-01-21	1987-02-03	1	6242
23827	1611	1112807	1972-11-20	1972-12-04	1	1068
50231	3422	1125315	1980-05-10	1980-05-17	1	3789
16334	1128	1125315	1979-04-29	1979-05-13	1	3419
23828	1611	1125315	1977-06-21	1977-07-05	1	2742
50232	3422	1125315	2006-08-18	2006-09-01	1	13392
16335	1128	1112807	1970-05-17	1970-05-31	1	150
23829	1611	1125315	1991-07-28	1991-10-26	2	7968
50233	3422	1343916	1994-01-09	1994-01-09	1	8774
16336	1128	1125315	2017-01-23	2017-01-30	1	17196
23830	1611	1713332	1972-05-25	1972-06-15	1	896
50234	3422	1729720	1975-03-08	1975-03-19	1	1903
16337	1128	1713332	1991-08-23	1991-09-06	1	7918
23831	1611	1728416	1955-07-23	1955-08-06	1	-5262
50235	3422	975125	1993-12-24	1993-12-24	1	8758
16338	1128	1759842	1991-08-23	1991-09-06	1	7918
23832	1611	1729720	1952-08-09	1952-08-22	1	-6341
50236	3422	1107830	1994-01-09	1994-01-09	1	8774
16339	1128	1115008	2016-03-16	2016-04-13	1	16904
23833	1611	1759842	2002-10-06	2002-10-27	1	11987
50237	3422	1125315	1990-01-22	1990-02-05	1	7340
16340	1128	1118084	2006-04-08	2006-04-08	1	13246
23834	1611	1177480	2013-11-29	2013-12-20	1	16059
50238	3422	1713332	1988-09-24	1988-10-08	1	6855
16341	1128	1125315	1971-07-28	1971-08-11	1	587
23835	1611	1729720	1981-04-10	1981-04-23	1	4130
50239	3422	740275	1978-12-16	1979-06-30	1	3467
16342	1128	1728416	1970-05-17	1970-05-31	1	150
25123	1703	1112807	1954-11-10	1955-02-08	1	-5441
50240	3422	1125315	1981-03-21	1981-04-04	1	4111
18399	1266	1125315	1984-06-08	1984-07-13	1	5307
25124	1703	1119510	1983-09-05	1983-09-12	1	5002
50241	3422	723013	1980-09-15	1981-03-16	1	4092
18400	1266	1125315	1994-11-16	1994-11-23	1	9092
25125	1703	1125315	1949-08-10	1949-08-17	1	-7442
50242	3422	914335	1973-11-12	1973-11-12	1	1411
18401	1266	1125315	2000-06-26	2000-07-03	1	11141
25126	1703	1125315	1956-01-04	1956-01-25	1	-5090
50243	3422	1118084	2001-08-27	2001-08-27	1	11561
18402	1266	1125315	2004-12-11	2004-12-18	1	12770
25127	1703	1125315	1965-03-19	1965-04-02	1	-1735
50244	3422	1119510	1980-05-10	1980-05-17	1	3789
18403	1266	1177480	1991-02-07	1991-03-14	1	7742
25128	1703	1759842	1952-04-21	1952-04-28	1	-6457
50245	3422	1125315	1977-11-21	1977-12-26	1	2916
18404	1266	738818	1992-07-21	1992-08-04	1	8251
25129	1703	1112807	1963-11-05	1963-11-19	1	-2235
50246	3422	1125315	1995-09-20	1995-10-04	1	9407
18405	1266	1125315	1972-03-15	1972-03-22	1	811
25130	1703	1115008	2019-05-11	2019-05-11	1	18027
50247	3422	1177480	1988-09-24	1988-10-08	1	6855
18406	1266	1125315	1992-07-21	1992-08-04	1	8251
25131	1703	1125315	1954-05-28	1954-06-04	1	-5690
50248	3422	1309944	1973-11-12	1973-11-12	1	1411
18407	1266	1112807	1971-03-19	1971-04-18	1	472
25132	1703	1125315	2019-05-18	2019-05-18	1	18034
50249	3422	1343916	1973-11-12	1973-11-12	1	1411
18408	1266	1125315	1974-09-09	1974-09-23	1	1726
25133	1703	1713332	1953-03-03	1953-03-10	1	-6141
50250	3422	1713332	1980-10-04	1980-10-18	1	3943
18409	1266	1729720	1980-07-31	1980-08-09	1	3873
25134	1703	1713332	1971-12-24	1972-01-07	1	736
50251	3422	1713332	1995-06-04	1995-06-18	1	9299
18410	1266	1119510	1992-07-21	1992-08-04	1	8251
25135	1703	738818	1983-09-05	1983-09-12	1	5002
50252	3422	1729720	2012-09-19	2012-09-29	1	15612
18411	1266	1124300	2004-12-20	2004-12-20	1	12772
25136	1703	1112807	1962-10-20	1962-11-10	1	-2609
50253	3422	1759842	1980-10-04	1980-10-18	1	3943
18412	1266	1125315	2017-12-11	2017-12-25	1	17525
25137	1703	1118084	1992-10-16	1992-10-16	1	8324
50254	3422	1759842	1995-06-04	1995-06-18	1	9299
19159	1313	1125315	1993-12-22	1993-12-29	1	8763
25138	1703	1125315	1950-06-04	1950-06-18	1	-7137
52882	3604	1125315	2000-05-06	2000-05-20	1	11097
19160	1313	1759842	2004-04-03	2004-04-17	1	12525
25139	1703	1125315	1983-09-05	1983-09-12	1	5002
52883	3604	1713332	1990-03-12	1990-03-19	1	7382
19161	1313	1713332	2004-04-03	2004-04-17	1	12525
25140	1703	1713332	1952-04-21	1952-04-28	1	-6457
52884	3604	1729720	1984-08-05	1984-08-18	1	5343
19162	1313	1118084	2011-08-03	2011-08-03	1	15189
25141	1703	1728416	1950-06-04	1950-06-18	1	-7137
52885	3604	1125315	1990-01-03	1990-01-31	1	7335
20050	1367	920293	2002-06-04	2002-06-11	1	11849
25142	1703	1124957	2019-05-18	2019-05-18	1	18034
52886	3604	1713332	1984-10-31	1984-11-14	1	5431
20051	1367	1124300	2005-02-04	2005-02-04	1	12818
25143	1703	1125315	1995-09-02	1995-09-30	1	9403
52887	3604	1125315	1987-08-08	1987-08-22	1	6442
20052	1367	1125315	1967-11-29	1967-12-13	1	-750
25144	1703	1125315	1997-08-20	1997-09-03	1	10107
52888	3604	1125315	1993-02-17	1993-03-03	1	8462
20053	1367	1729720	2000-05-17	2000-05-24	1	11101
25145	1703	1759842	1953-03-03	1953-03-10	1	-6141
52889	3604	1125315	1996-03-24	1996-03-31	1	9586
20054	1367	1125315	1980-03-08	1980-03-22	1	3733
25146	1703	1759842	1971-12-24	1972-01-07	1	736
52890	3604	1177480	1987-03-02	1987-03-16	1	6283
20055	1367	1177480	1981-08-25	1981-09-08	1	4268
25727	1745	1112807	1986-06-05	1986-08-04	1	6059
52891	3604	1192710	1984-12-12	1984-12-12	1	5459
20056	1367	1521369	1982-04-11	1984-03-31	2	5203
25728	1745	1119510	2007-06-19	2007-06-26	1	13690
52892	3604	1713332	1987-03-02	1987-03-16	1	6283
20057	1367	1713332	1981-08-25	1981-09-08	1	4268
25729	1745	1125315	1980-02-09	1980-02-23	1	3705
52893	3604	1729720	1992-04-24	1992-05-02	1	8157
20058	1367	933724	2002-06-04	2002-06-11	1	11849
25730	1745	1125315	1984-08-16	1984-09-13	1	5369
52894	3604	1759842	1990-03-12	1990-03-19	1	7382
20059	1367	1112807	1966-04-25	1966-05-30	1	-1312
25731	1745	1125315	2007-06-19	2007-06-26	1	13690
52895	3604	1124300	2019-05-16	2019-05-16	1	18032
20060	1367	1112807	1978-03-28	1978-04-18	1	3029
25732	1745	1519936	2006-10-30	2007-10-25	1	13811
52896	3604	1125315	1984-10-31	1984-11-14	1	5431
20061	1367	1112807	1992-05-18	1992-06-01	1	8187
25733	1745	1549786	2001-11-25	2003-11-15	2	12371
52897	3604	1778162	1987-08-08	1987-08-22	1	6442
20062	1367	1717327	1965-12-26	1966-01-09	1	-1453
25734	1745	1595799	1998-12-11	1999-12-06	1	10931
56226	3832	1115008	2001-01-26	2001-02-09	1	11362
20063	1367	19127890	1982-04-11	1984-03-31	2	5203
25735	1745	19127890	1997-12-16	1998-12-11	1	10571
56227	3832	1125315	2012-06-16	2012-07-21	1	15542
20064	1367	1112807	1965-12-26	1966-01-09	1	-1453
25736	1745	738818	2007-06-19	2007-06-26	1	13690
56228	3832	1759842	2016-03-19	2016-03-26	1	16886
20065	1367	1125315	1969-03-15	1969-06-13	1	-202
25737	1745	1521369	2003-11-15	2005-11-04	2	13091
56229	3832	1119510	1993-08-23	1993-08-30	1	8642
20066	1367	1125315	2006-06-25	2006-07-02	1	13331
25738	1745	1713332	1993-10-31	1993-11-14	1	8718
56230	3832	1713332	1999-03-18	1999-04-08	1	10689
20067	1367	1503184	1982-04-11	1984-03-31	2	5203
25739	1745	1118084	2017-05-25	2017-05-25	1	17311
56231	3832	1759842	1999-03-18	1999-04-08	1	10689
20068	1367	1713332	1990-11-24	1990-12-08	1	7646
25740	1745	1515774	1997-12-16	1998-12-11	1	10571
56232	3832	1118084	2016-06-27	2016-06-27	1	16979
20069	1367	1759842	1990-11-24	1990-12-08	1	7646
25741	1745	1549786	1997-12-16	2000-11-30	3	11291
56233	3832	1125315	1985-11-02	1985-11-16	1	5798
21541	1467	933724	1955-04-27	1955-05-04	1	-5356
25742	1745	1589505	2008-10-23	2009-10-22	1	14539
56234	3832	1125315	1991-12-31	1992-01-14	1	8048
21542	1467	1118084	1967-10-09	1967-10-09	1	-815
25743	1745	1713332	1980-02-09	1980-02-23	1	3705
56235	3832	1713332	2016-03-19	2016-03-26	1	16886
21543	1467	1119510	1988-07-19	1988-08-02	1	6788
25744	1745	1729720	1979-08-16	1979-08-27	1	3525
56236	3832	738818	1993-08-23	1993-08-30	1	8642
21544	1467	1125315	1944-02-29	1944-03-07	1	-9431
25745	1745	1759842	1993-10-31	1993-11-14	1	8718
56237	3832	1125315	1993-08-23	1993-08-30	1	8642
21545	1467	1713332	1997-04-21	1997-04-28	1	9979
25746	1745	1125315	2018-03-18	2018-03-25	1	17615
56238	3832	1125315	2006-10-11	2006-11-15	1	13467
21546	1467	738818	1988-07-19	1988-08-02	1	6788
25747	1745	1515774	1999-12-06	2000-11-30	1	11291
56239	3832	1150770	1984-11-17	1984-11-17	1	5434
21547	1467	1125315	1988-07-19	1988-08-02	1	6788
25748	1745	1515774	2001-11-25	2003-11-15	2	12371
56240	3832	1551099	2010-12-21	2010-12-21	1	14964
21548	1467	1713332	1983-10-11	1983-10-25	1	5045
25749	1745	1521369	1998-12-11	1999-12-06	1	10931
58942	4017	1112807	1948-11-06	1948-11-27	1	-7705
21549	1467	1759842	1942-11-01	1942-11-15	1	-9909
25750	1745	19127890	1999-12-06	2000-11-30	1	11291
58943	4017	1326303	1998-04-09	1998-04-09	1	10325
21550	1467	1759842	1983-10-11	1983-10-25	1	5045
25751	1745	19127890	2001-11-25	2003-11-15	2	12371
58944	4017	1332418	2000-04-20	2000-04-20	1	11067
21551	1467	920293	1955-04-27	1955-05-04	1	-5356
26593	1794	1125315	1960-11-28	1960-12-12	1	-3307
58945	4017	1539403	2000-04-20	2000-04-20	1	11067
21552	1467	1102527	2011-07-19	2011-07-19	1	15174
26594	1794	1125315	1961-02-13	1961-02-27	1	-3230
58946	4017	1759842	2005-09-12	2005-10-03	1	13059
21553	1467	1112807	1935-06-14	1935-06-28	1	-12606
26595	1794	1125315	1990-04-25	1990-05-09	1	7433
58947	4017	701322	2011-05-15	2011-05-15	1	15109
21554	1467	1112807	1966-08-30	1966-09-13	1	-1206
26596	1794	1125315	2014-11-15	2014-11-29	1	16403
58948	4017	1112807	1934-01-17	1934-03-25	1	-13066
21555	1467	1125315	1998-04-16	1998-04-30	1	10346
26597	1794	1177480	2005-03-21	2005-04-04	1	12877
58949	4017	1112807	1937-04-08	1937-05-08	1	-11926
21556	1467	1177480	1994-03-20	1994-04-17	1	8872
26598	1794	1728416	1960-11-28	1960-12-12	1	-3307
58950	4017	1124957	1934-01-24	1934-01-24	1	-13126
21557	1467	1713332	1942-11-01	1942-11-15	1	-9909
26599	1794	1112807	1961-09-13	1961-09-27	1	-3018
58951	4017	1310149	1998-04-09	1998-04-09	1	10325
21558	1467	1759842	1997-04-21	1997-04-28	1	9979
26600	1794	1112807	1963-06-07	1963-06-21	1	-2386
58952	4017	1322184	2000-04-20	2014-08-07	1	16289
23050	1565	1125315	1974-07-24	1974-08-07	1	1679
26601	1794	1717327	1961-02-13	1961-02-27	1	-3230
58953	4017	1125315	1930-02-08	1930-02-22	1	-14558
23051	1565	1759842	1965-08-18	1965-09-08	1	-1576
26602	1794	1717327	1961-09-13	1961-09-27	1	-3018
58954	4017	1125315	1936-05-08	1936-05-22	1	-12277
23052	1565	1112807	1968-05-25	1968-06-08	1	-572
26603	1794	1728416	1963-06-07	1963-06-21	1	-2386
58955	4017	1125315	1984-03-04	1984-03-18	1	5190
23053	1565	1125315	1998-11-25	1998-12-09	1	10569
26604	1794	1118084	1996-01-19	1996-01-19	1	9514
58956	4017	1125315	1989-02-09	1989-02-23	1	6993
23054	1565	1125315	2017-08-18	2017-09-01	1	17410
26605	1794	1125315	1978-07-29	1978-08-05	1	3138
58957	4017	1307863	1998-04-09	1998-04-09	1	10325
23055	1565	1728416	1968-05-25	1968-06-08	1	-572
28138	1908	738818	2014-06-15	2014-06-29	1	16250
58958	4017	1713332	2005-09-12	2005-10-03	1	13059
23056	1565	1118084	1999-11-24	1999-11-24	1	10919
28139	1908	1125315	2014-06-15	2014-06-29	1	16250
58959	4017	757627	2010-05-20	2010-05-20	1	14749
23057	1565	1125315	1998-03-14	1998-03-28	1	10313
28140	1908	1177480	1975-08-16	1975-08-30	1	2067
58960	4017	1124300	1963-08-13	1963-08-13	1	-2333
23058	1565	1713332	1965-08-18	1965-09-08	1	-1576
28141	1908	1177480	1998-02-24	1998-05-25	1	10371
58961	4017	1125315	1934-01-24	1934-01-24	1	-13126
27011	1826	1118084	1978-05-17	1978-05-17	1	3058
28142	1908	1713332	1980-01-03	1980-01-17	1	3668
58962	4017	1125315	1986-10-14	1986-10-21	1	6137
27012	1826	1119510	1999-04-13	1999-04-20	1	10701
28143	1908	1713332	2005-04-20	2005-05-04	1	12907
58963	4017	1347450	2014-08-07	2014-08-07	1	16289
27013	1826	1125315	2004-02-27	2004-03-05	1	12482
28144	1908	1125315	1987-04-09	1987-04-23	1	6321
58964	4017	1361711	2000-04-20	2000-04-20	1	11067
27014	1826	1174888	1956-10-29	1956-10-29	1	-4812
28145	1908	1125315	1989-10-27	1989-11-03	1	7246
58965	4017	1713332	2012-11-01	2012-11-22	1	15666
27015	1826	1713332	1963-02-16	1963-03-09	1	-2490
28146	1908	1125315	2007-01-14	2007-01-21	1	13534
58966	4017	1759842	2012-11-01	2012-11-22	1	15666
27016	1826	1713332	2016-12-11	2016-12-18	1	17153
28147	1908	1717327	1975-08-16	1975-08-30	1	2067
60143	4101	723013	1960-02-27	1960-05-07	1	-3526
27017	1826	1759842	1995-08-19	1995-09-09	1	9382
28148	1908	1738521	1974-09-26	1974-10-10	1	1743
60144	4101	1125315	1973-08-17	1973-09-14	1	1352
27018	1826	738818	1999-04-13	1999-04-20	1	10701
28149	1908	1125315	1980-01-03	1980-01-17	1	3668
60145	4101	1125315	2014-08-08	2014-08-15	1	16297
27019	1826	1125315	1964-05-04	1964-06-03	1	-2038
28150	1908	1717327	1971-01-03	1971-01-17	1	381
60146	4101	1503184	1977-02-07	1978-02-02	1	2954
27020	1826	1125315	1999-04-13	1999-04-20	1	10701
28151	1908	1759842	2005-04-20	2005-05-04	1	12907
60147	4101	920293	1983-03-21	1983-04-04	2	4841
27021	1826	1759842	1963-02-16	1963-03-09	1	-2490
28152	1908	1112807	1971-01-03	1971-01-17	1	381
60148	4101	933724	1983-03-21	1983-04-04	1	4841
27022	1826	1112807	1957-11-23	1957-12-07	1	-4408
28153	1908	1112807	1974-09-26	1974-10-10	1	1743
60149	4101	1125315	1980-06-08	1980-06-22	1	3825
27023	1826	1119510	2017-02-27	2017-03-13	1	17238
28154	1908	1118084	2002-12-16	2002-12-16	1	12037
60150	4101	1713332	1992-07-09	1992-07-16	1	8232
27024	1826	1713332	1995-08-19	1995-09-09	1	9382
28155	1908	1119510	2014-06-15	2014-06-29	1	16250
60151	4101	1759842	1992-07-09	1992-07-16	1	8232
27025	1826	1729720	1945-08-02	1945-08-13	1	-8907
28156	1908	1125315	1993-09-15	1993-09-22	1	8665
60152	4101	19127890	1977-02-07	1978-02-02	1	2954
27026	1826	1729720	1985-06-18	1985-06-30	1	5659
28157	1908	1125315	2018-03-11	2018-05-10	1	17661
60153	4101	1112807	1987-12-30	1988-01-20	1	6593
27027	1826	1759842	1978-09-21	1978-10-12	1	3206
30011	2030	1119510	1990-06-22	1990-06-29	1	7484
60154	4101	1118084	1999-06-07	1999-06-07	1	10749
27028	1826	1759842	2016-12-11	2016-12-18	1	17153
30012	2030	1119510	1995-07-13	1995-07-27	1	9338
60155	4101	1125315	1965-09-28	1965-10-12	1	-1542
27029	1826	738818	2017-02-27	2017-03-13	1	17238
30013	2030	1125315	2014-03-27	2014-04-10	1	16170
60156	4101	1125315	1978-05-24	1978-05-31	1	3072
27030	1826	1112807	1940-01-27	1940-02-10	1	-10918
30014	2030	1521369	1978-04-08	1979-04-03	1	3379
60157	4101	1521369	1977-02-07	1978-02-02	1	2954
27031	1826	1125315	1956-10-29	1956-12-28	2	-4812
30015	2030	1347450	2005-07-24	2005-07-24	1	12988
60158	4101	1728416	1965-09-28	1965-10-12	1	-1542
27032	1826	1125315	1965-04-17	1965-05-01	1	-1706
30016	2030	1503184	1978-04-08	1979-04-03	1	3379
60159	4101	1729720	1963-09-20	1963-10-01	1	-2284
27033	1826	1125315	1997-12-25	1998-01-08	1	10234
30017	2030	1713332	2018-06-04	2018-06-25	1	17707
60160	4101	1729720	2008-08-16	2008-08-28	1	14119
27034	1826	1125315	2017-02-27	2017-03-13	1	17238
30018	2030	1729720	1968-11-20	1968-12-01	1	-396
60161	4101	1729720	1971-06-08	1971-06-20	1	535
27035	1826	1713332	1978-09-21	1978-10-12	1	3206
30019	2030	1759842	2018-06-04	2018-06-25	1	17707
62336	4255	1115008	2019-06-29	2019-06-29	1	18076
29170	1976	1112807	1984-05-13	1984-05-27	1	5260
30020	2030	738818	1990-06-22	1990-06-29	1	7484
62337	4255	1118084	2010-02-03	2010-02-03	1	14643
29171	1976	1125315	1993-05-26	1993-06-25	1	8576
30021	2030	738818	1995-07-13	1995-07-27	1	9338
62338	4255	1125315	1988-04-11	1988-04-25	1	6689
29172	1976	1125315	2008-06-07	2008-06-21	1	14051
30022	2030	1125315	1970-12-06	1971-01-14	2	378
62339	4255	1713332	1994-03-25	1994-04-01	1	8856
29173	1976	1177480	1986-12-20	1987-01-03	1	6211
30023	2030	1125315	1974-04-29	1974-05-13	1	1593
62340	4255	1713332	1997-08-06	1997-08-20	1	10093
29174	1976	1177480	1988-01-29	1988-02-12	1	6616
30024	2030	1125315	1990-06-22	1990-06-29	1	7484
62341	4255	1759842	1994-03-25	1994-04-01	1	8856
29175	1976	1177480	2010-07-01	2010-07-22	1	14812
30025	2030	1125315	1995-01-05	1995-01-12	1	9142
62342	4255	1759842	1997-08-06	1997-08-20	1	10093
29176	1976	1500211	1996-12-16	1997-12-11	1	10206
30026	2030	1125315	1995-07-13	1995-07-27	1	9338
62343	4255	1112807	1986-08-30	1986-09-20	1	6106
29177	1976	1521369	1999-12-05	2000-11-29	1	11290
30027	2030	1322184	2005-07-24	2005-07-24	1	12988
62344	4255	1177480	1979-04-14	1979-04-28	1	3404
29178	1976	1768849	1985-09-19	1985-10-03	1	5754
30028	2030	19127890	1978-04-08	1979-04-03	1	3379
62345	4255	1713332	1979-04-14	1979-04-28	1	3404
29179	1976	1124300	2017-11-01	2017-11-01	1	17471
30029	2030	1124300	1997-11-04	1997-11-04	1	10169
62346	4255	1713332	1979-07-27	1979-08-03	1	3501
29180	1976	1125315	1985-09-19	1985-10-03	1	5754
30030	2030	1125315	1967-01-26	1967-02-25	1	-1041
62347	4255	1713332	1997-05-17	1997-05-31	1	10012
29181	1976	1177480	1995-07-15	1995-08-19	1	9361
30031	2030	1713332	2002-12-16	2002-12-23	1	12044
62348	4255	1717327	1974-11-19	1974-12-03	1	1797
29182	1976	1595799	1999-12-05	2000-11-29	1	11290
30032	2030	1759842	2002-12-16	2002-12-23	1	12044
62349	4255	1125315	1989-12-26	1990-01-09	1	7313
29183	1976	1713332	1984-05-13	1984-05-27	1	5260
31067	2100	1112807	1947-07-02	1947-07-16	1	-8205
62350	4255	1125315	1999-12-11	2000-01-10	1	10966
29184	1976	1713332	2003-08-10	2003-08-17	1	12281
31068	2100	1112807	1959-08-13	1959-08-27	1	-3780
62351	4255	1729720	1984-08-14	1984-08-21	1	5346
29185	1976	1759842	2003-08-10	2003-08-17	1	12281
31069	2100	1124300	1976-01-16	1976-01-16	1	2206
62352	4255	1759842	1979-07-27	1979-08-03	1	3501
29186	1976	1125315	2003-12-02	2003-12-09	1	12395
31070	2100	1125315	2015-04-01	2015-04-15	1	16540
62353	4255	1759842	1997-05-17	1997-05-31	1	10012
29187	1976	1192710	1986-01-09	1986-01-09	1	5852
62354	4255	1125315	1974-11-19	1974-12-03	1	1797
29188	1976	1549786	1999-12-05	2000-11-29	1	11290
62355	4255	1125315	1990-09-07	1990-09-14	1	7561
29189	1976	1713332	1986-12-20	1987-01-03	1	6211
62356	4255	1177480	1975-01-18	1975-02-08	1	1864
29563	1998	738818	2012-01-12	2012-01-19	1	15358
62357	4255	1177480	1977-11-24	1977-12-15	1	2905
29564	1998	1118084	2015-10-01	2015-10-01	1	16709
62358	4255	1713332	2006-10-11	2006-10-25	1	13446
29565	1998	1713332	1989-10-26	1989-11-16	1	7259
62359	4255	1729720	2008-12-16	2008-12-26	1	14239
29566	1998	1713332	1998-08-07	1998-08-28	1	10466
62360	4255	1759842	2006-10-11	2006-10-25	1	13446
29567	1998	1759842	1989-10-26	1989-11-16	1	7259
63346	4329	933724	2008-05-10	2008-05-24	1	14023
29568	1998	1759842	1998-08-07	1998-08-28	1	10466
63347	4329	1125315	1982-05-25	1982-06-08	1	4541
29569	1998	1119510	2012-01-12	2012-01-19	1	15358
63348	4329	1125315	2018-03-15	2018-03-22	1	17612
29570	1998	1125315	2012-01-12	2012-01-19	1	15358
63349	4329	1595799	2000-02-25	2001-02-19	1	11372
29571	1998	1125315	2017-09-21	2017-10-05	1	17444
63350	4329	19127890	1995-03-14	1996-03-08	1	9563
29572	1998	1713332	2016-07-10	2016-07-17	1	16999
63351	4329	920293	2008-05-10	2008-05-24	2	14023
29573	1998	1125315	2019-02-22	2019-03-01	1	17956
63352	4329	1125315	1981-03-17	1981-04-14	1	4121
29574	1998	1759842	2016-07-10	2016-07-17	1	16999
63353	4329	1125315	2013-12-19	2013-12-26	1	16065
29575	1998	1115008	2017-05-13	2017-05-27	1	17313
63354	4329	1125315	2014-10-19	2014-12-24	2	16428
32328	2190	1729720	2017-06-05	2017-06-12	1	17329
63355	4329	1177480	1991-09-20	1991-12-18	1	8021
32329	2190	1778162	1985-11-09	1985-11-23	1	5805
63356	4329	1713332	1990-10-17	1990-10-24	1	7601
32330	2190	1125315	1952-06-28	1952-07-05	1	-6389
63357	4329	1759842	2011-08-27	2011-09-17	1	15234
32331	2190	1125315	1985-11-09	1985-11-23	1	5805
63358	4329	19127890	1992-03-29	1993-03-24	1	8483
32332	2190	1125315	1988-01-08	1988-01-22	1	6595
63359	4329	1174888	2014-10-26	2014-10-26	1	16369
32333	2190	1115008	2014-09-23	2014-12-22	1	16426
63360	4329	1177480	1978-11-28	1978-12-12	1	3267
32334	2190	1118084	1983-09-22	1983-09-22	1	5012
63361	4329	1500211	1994-03-19	1995-03-14	1	9203
32335	2190	1125315	1957-10-28	1957-11-18	1	-4427
63362	4329	1503184	1992-03-29	1993-03-24	1	8483
32336	2190	1125315	1982-02-10	1982-03-10	1	4451
63363	4329	1521369	1995-03-14	1996-03-08	1	9563
32337	2190	1177480	2008-05-06	2008-05-27	1	14026
63364	4329	1521369	2000-02-25	2001-02-19	1	11372
32338	2190	1713332	1972-12-30	1973-01-20	1	1115
63365	4329	1549786	2000-02-25	2001-02-19	1	11372
32339	2190	1713332	2009-04-17	2009-05-01	1	14365
63366	4329	1713332	1982-05-25	1982-06-08	1	4541
32340	2190	1728416	1955-12-08	1955-12-22	1	-5124
63367	4329	1124300	2010-11-10	2010-11-10	1	14923
32341	2190	1759842	2009-04-17	2009-05-01	1	14365
63368	4329	1125315	1981-10-16	1981-10-29	1	4319
32342	2190	1102527	2014-09-23	2014-09-23	1	16336
63369	4329	1503184	1995-03-14	1996-03-08	1	9563
32343	2190	1112807	1955-12-08	1955-12-22	1	-5124
63370	4329	1521369	1992-03-29	1993-03-24	1	8483
32344	2190	1729720	1953-10-23	1953-11-01	1	-5905
63371	4329	1713332	2011-08-27	2011-09-17	1	15234
32345	2190	1759842	1972-12-30	1973-01-20	1	1115
63372	4329	1738521	1978-11-28	1978-12-12	1	3267
34714	2347	920293	2016-01-02	2016-01-09	1	16809
63373	4329	1759842	1990-10-17	1990-10-24	1	7601
34715	2347	1115008	2001-11-23	2001-12-14	1	11670
64852	4428	933724	2005-12-09	2005-12-16	1	13133
34716	2347	1119510	1982-03-25	1982-04-08	1	4480
64853	4428	1119510	1983-08-31	1983-09-07	1	4997
34717	2347	1125315	2008-01-31	2008-02-07	1	13916
64854	4428	1713332	1994-01-02	1994-01-16	1	8781
34718	2347	1521369	1986-11-13	1987-11-08	1	6520
64855	4428	1713332	2011-10-17	2011-10-31	1	15278
34719	2347	933724	2016-01-02	2016-01-09	1	16809
64856	4428	1728416	1952-05-13	1952-05-27	1	-6428
34720	2347	1118084	2012-09-07	2012-09-07	1	15590
64857	4428	1729720	1961-11-05	1961-11-17	1	-2967
34721	2347	1361711	2002-02-25	2002-02-25	1	11743
64858	4428	1759842	1994-01-02	1994-01-16	1	8781
34722	2347	738818	1982-03-25	1982-04-08	1	4480
64859	4428	1759842	2011-10-17	2011-10-31	1	15278
34723	2347	1125315	1974-03-06	1974-05-05	1	1585
64860	4428	738818	1983-08-31	1983-09-07	1	4997
34724	2347	1125315	1982-03-25	1982-04-08	1	4480
64861	4428	1112807	1952-05-13	1952-05-27	1	-6428
34725	2347	1125315	2006-08-01	2006-08-08	1	13368
64862	4428	1125315	1983-08-31	1983-09-07	1	4997
34726	2347	1177480	1980-03-04	1980-03-18	1	3729
64863	4428	1125315	1985-05-31	1985-06-14	1	5643
34727	2347	1322184	2002-02-25	2002-02-25	1	11743
64864	4428	1118084	1991-05-04	1991-05-04	1	7793
34728	2347	1332418	2002-02-25	2002-02-25	1	11743
64865	4428	1125315	1972-10-25	1972-11-07	1	1041
34729	2347	1539403	2002-02-25	2002-02-25	1	11743
64866	4428	920293	2005-12-09	2005-12-16	1	13133
34730	2347	19127890	1986-11-13	1987-11-08	1	6520
64867	4428	1729720	1954-05-05	1954-05-15	1	-5710
34731	2347	1503184	1986-11-13	1987-11-08	1	6520
69147	4720	738818	2009-11-07	2009-11-14	1	14562
34732	2347	1713332	1989-04-21	1989-05-05	1	7064
69148	4720	920293	2016-07-16	2016-07-23	1	17005
34733	2347	1759842	1989-04-21	1989-05-05	1	7064
69149	4720	1118084	2014-01-27	2014-01-27	1	16097
36468	2481	1124300	2004-09-24	2004-09-24	1	12685
69150	4720	1119510	1989-08-30	1989-09-13	1	7195
36469	2481	1713332	1990-02-07	1990-02-28	1	7363
69151	4720	1119510	1993-03-12	1993-03-26	1	8485
36470	2481	1713332	2007-12-21	2008-01-11	1	13889
69152	4720	1125315	2009-11-07	2009-11-14	1	14562
36471	2481	1713332	2012-07-25	2012-08-08	1	15560
69153	4720	1503184	1990-06-12	1991-06-07	1	7827
36472	2481	1738521	1972-05-05	1972-05-19	1	869
69154	4720	1515774	1995-05-26	1996-05-20	1	9636
36473	2481	1125315	1978-10-03	1978-10-17	1	3211
69155	4720	1549786	1992-06-01	1993-05-27	1	8547
36474	2481	1125315	1997-07-21	1997-08-11	1	10084
69156	4720	1549786	1995-05-26	1996-05-20	1	9636
36475	2481	1177480	1984-06-01	1984-06-29	1	5293
69157	4720	19127890	1992-06-01	1993-05-27	1	8547
36476	2481	1713332	1984-10-10	1984-10-31	1	5417
69158	4720	1125315	1976-08-15	1976-08-29	1	2432
36477	2481	1759842	1984-10-10	1984-10-31	1	5417
69159	4720	1125315	2012-12-29	2013-01-19	1	15724
36478	2481	1115008	2012-07-25	2012-10-21	2	15620
69160	4720	19127890	1990-06-12	1991-06-07	1	7827
36479	2481	1112807	1972-05-05	1972-05-19	1	869
69161	4720	19127890	1995-05-26	1996-05-20	1	9636
36480	2481	1759842	1990-02-07	1990-02-28	1	7363
69162	4720	738818	1989-08-30	1989-09-13	1	7195
36481	2481	1759842	2007-12-21	2008-01-11	1	13889
69163	4720	738818	1993-03-12	1993-03-26	1	8485
36782	2503	1118084	2017-02-24	2017-02-24	1	17221
69164	4720	1125315	1977-11-22	1977-11-29	1	2889
36783	2503	1125315	1986-10-10	1986-11-07	1	6154
69165	4720	1125315	1989-08-30	1989-09-13	1	7195
36784	2503	1192710	1978-03-12	1978-03-12	1	2992
69166	4720	1125315	1993-03-12	1993-03-26	1	8485
36785	2503	1515774	1991-02-01	1992-01-27	1	8061
69167	4720	1177480	1987-04-19	1987-05-10	1	6338
36786	2503	1515774	1993-01-21	1994-01-16	1	8781
69168	4720	1729720	1979-12-28	1980-01-04	1	3655
36787	2503	19127890	1989-02-06	1990-02-01	1	7336
69169	4720	933724	2016-07-16	2016-07-23	1	17005
36788	2503	1125315	1975-03-12	1975-03-26	1	1910
69170	4720	1115008	1999-04-07	1999-05-12	1	10723
36789	2503	1125315	2013-05-26	2013-06-09	1	15865
69171	4720	1119510	2009-11-07	2009-11-14	1	14562
36790	2503	1717327	1975-03-12	1975-03-26	1	1910
69172	4720	1125315	1982-02-14	1982-04-15	1	4487
36791	2503	1729720	1985-09-17	1985-09-29	1	5750
69173	4720	1515774	1992-06-01	1993-05-27	1	8547
36792	2503	19127890	1991-02-01	1992-01-27	1	8061
69174	4720	1521369	1990-06-12	1991-06-07	1	7827
36793	2503	19127890	1993-01-21	1994-01-16	1	8781
69850	4764	1713332	2018-05-12	2018-05-19	1	17670
36794	2503	1515774	1989-02-06	1990-02-01	1	7336
69851	4764	1759842	2018-05-12	2018-05-19	1	17670
36795	2503	1549786	1989-02-06	1990-02-01	1	7336
69852	4764	1118084	2007-01-29	2007-01-29	1	13542
36796	2503	1125315	1999-01-07	1999-01-21	1	10612
69853	4764	1125315	1981-11-11	1981-11-25	1	4346
36797	2503	1549786	1991-02-01	1992-01-27	1	8061
69854	4764	1759842	1999-06-17	1999-07-08	1	10780
36798	2503	1549786	1993-01-21	1994-01-16	1	8781
69855	4764	1125315	1998-07-17	1998-07-31	1	10438
38004	2583	1124300	2006-11-23	2006-11-23	1	13475
69856	4764	1713332	1999-06-17	1999-07-08	1	10780
38005	2583	1177480	1989-07-05	1989-07-19	1	7139
69857	4764	1728416	1971-01-08	1971-01-22	1	386
38006	2583	1177480	1993-06-28	1993-07-28	1	8609
69858	4764	1112807	1971-01-08	1971-01-22	1	386
38007	2583	1728416	1973-07-20	1973-08-03	1	1310
72343	4943	1177480	1979-11-15	1979-12-22	1	3642
38008	2583	1759842	1995-04-04	1995-04-18	1	9238
72344	4943	1177480	1995-09-29	1995-10-13	1	9416
38009	2583	19127890	1989-05-16	1990-05-11	1	7435
72345	4943	1521369	1975-01-29	1976-01-24	1	2214
38010	2583	1125315	1985-10-26	1985-11-09	1	5791
72346	4943	1729720	1999-05-29	1999-06-09	1	10751
38011	2583	1125315	1986-08-20	1986-10-19	1	6135
72347	4943	1124957	1974-02-14	1974-02-14	1	1505
38012	2583	1125315	2018-10-25	2018-11-08	1	17843
72348	4943	1125315	1969-10-18	1969-10-25	1	-68
38013	2583	1515774	1989-05-16	1990-05-11	1	7435
72349	4943	1118084	1996-03-09	1996-03-09	1	9564
38014	2583	1717327	1973-01-30	1973-02-13	1	1139
72350	4943	1125315	1974-02-14	1974-04-15	2	1565
38015	2583	1112807	1973-01-30	1973-02-13	1	1139
72351	4943	1713332	2000-07-15	2000-08-05	1	11174
38016	2583	1112807	1973-07-20	1973-08-03	1	1310
72352	4943	1759842	2000-07-15	2000-08-05	1	11174
38017	2583	1125315	1971-07-10	1971-10-08	1	645
72353	4943	19127890	1975-01-29	1976-01-24	1	2214
38018	2583	1549786	1989-05-16	1990-05-11	1	7435
72354	4943	723013	1962-02-01	1962-08-16	1	-2695
38019	2583	920293	2000-07-13	2000-07-20	1	11158
72355	4943	1112807	1970-07-05	1970-10-03	1	275
38020	2583	933724	2000-07-13	2000-07-20	1	11158
72356	4943	1125315	1964-10-13	1964-11-03	1	-1885
38021	2583	1102527	1986-08-20	1986-08-20	1	6075
72357	4943	1125315	2014-09-30	2014-10-14	1	16357
38022	2583	1713332	1995-04-04	1995-04-18	1	9238
72358	4943	1503184	1975-01-29	1976-01-24	1	2214
38023	2583	1729720	1973-02-01	1973-02-09	1	1135
72359	4943	1729720	1971-12-05	1971-12-14	1	712
39091	2657	1115008	2011-07-11	2011-07-25	1	15180
74252	5077	723013	2017-03-04	2017-09-09	1	17418
39092	2657	1118084	2000-05-19	2000-05-19	1	11096
74253	5077	1125315	1973-10-31	1973-12-14	2	1427
39093	2657	1713332	2011-07-11	2011-07-25	1	15180
74254	5077	1125315	2006-02-10	2006-02-17	1	13196
39094	2657	1102527	2016-01-23	2016-01-23	1	16823
74255	5077	738818	1971-02-16	1971-03-02	1	425
39095	2657	914335	1970-09-05	1970-09-05	1	247
74256	5077	1125315	1971-02-16	1971-03-02	1	425
39096	2657	1115008	2016-01-16	2016-02-22	1	16853
74257	5077	1713332	1977-08-20	1977-09-03	1	2802
39097	2657	1309944	1970-09-05	1970-09-05	1	247
74258	5077	740275	2018-06-20	2019-01-16	1	17912
39098	2657	1343916	1970-09-05	1970-09-05	1	247
74259	5077	1125315	1998-12-12	1998-12-19	1	10579
39099	2657	1729720	1989-08-15	1989-08-23	1	7174
74260	5077	1717327	1973-11-30	1973-12-14	1	1443
45524	3090	738818	1978-04-11	1978-04-25	1	3036
74261	5077	1119510	1971-02-16	1971-03-02	1	425
45525	3090	1119510	1961-09-21	1961-10-05	1	-3010
74262	5077	1124300	2002-10-29	2002-10-29	1	11989
45526	3090	1125315	1978-04-11	1978-04-25	1	3036
74263	5077	1125315	2014-05-18	2014-05-25	1	16215
45527	3090	1125315	1980-09-10	1980-10-01	1	3926
74264	5077	1759842	1977-08-20	1977-09-03	1	2802
45528	3090	1125315	1994-11-17	1994-12-08	1	9107
74847	5123	738818	1985-03-28	1985-04-04	1	5572
45529	3090	1729720	2002-07-31	2002-08-07	1	11906
74848	5123	1112807	1984-01-02	1984-02-06	1	5149
45530	3090	1124300	2001-02-02	2001-02-02	1	11355
74849	5123	1125315	1985-03-28	1985-04-04	1	5572
45531	3090	1125315	2005-03-06	2005-03-13	1	12855
74850	5123	1503184	1995-05-14	1996-05-08	1	9624
45532	3090	1125315	2006-02-07	2006-02-21	1	13200
74851	5123	1549786	1998-04-28	1999-04-23	1	10704
45533	3090	738818	1961-09-21	1961-10-05	1	-3010
74852	5123	1125315	2004-04-21	2004-05-21	2	12559
45534	3090	1115008	2003-05-25	2003-06-15	1	12218
74853	5123	1174888	2004-04-21	2004-04-21	1	12529
45535	3090	1119510	1978-04-11	1978-04-25	1	3036
74854	5123	1503184	1993-05-24	1994-05-19	1	8904
45536	3090	1125315	1961-09-21	1961-10-05	1	-3010
74855	5123	1521369	1993-05-24	1994-05-19	1	8904
45537	3090	1125315	1989-10-28	1989-11-11	1	7254
74856	5123	1521369	1995-05-14	1996-05-08	1	9624
46683	3172	1119510	2005-01-23	2005-01-30	1	12813
74857	5123	1521369	1998-04-28	1999-04-23	1	10704
46684	3172	1124300	2012-10-28	2012-10-28	1	15641
74858	5123	1713332	1993-05-21	1993-05-28	1	8548
46685	3172	1521369	1998-12-06	2000-11-25	2	11286
74859	5123	1759842	1993-05-21	1993-05-28	1	8548
46686	3172	1549786	1994-12-27	1995-12-22	1	9486
74860	5123	1115008	1994-09-11	1994-12-10	1	9109
46687	3172	1549786	1996-12-16	1998-12-06	2	10566
74861	5123	1177480	1983-11-03	1983-11-17	1	5068
46688	3172	1549786	1999-12-01	2000-11-25	1	11286
74862	5123	1595799	1998-04-28	1999-04-23	1	10704
46689	3172	1713332	1993-07-31	1993-08-07	1	8619
74863	5123	1729720	1990-03-14	1990-03-26	1	7389
46690	3172	1759842	1993-07-31	1993-08-07	1	8619
74864	5123	19127890	1993-05-24	1994-05-19	1	8904
46691	3172	1115008	2004-09-16	2004-11-15	1	12737
74865	5123	19127890	1995-05-14	1996-05-08	1	9624
46692	3172	1125315	1980-02-06	1980-02-13	1	3695
74866	5123	1119510	1985-03-28	1985-04-04	1	5572
46693	3172	1125315	1986-11-21	1986-11-28	1	6175
74867	5123	1124300	2016-08-06	2016-08-06	1	17019
46694	3172	1729720	1977-07-23	1977-07-30	1	2767
1040	70	1124300	1983-06-27	1983-06-27	1	4925
46695	3172	1759842	2018-09-27	2018-10-04	1	17808
1041	70	738818	1962-07-17	1962-07-31	1	-2711
46696	3172	1768849	1983-04-19	1983-05-03	1	4870
1042	70	1125315	1960-01-10	1960-01-24	1	-3630
46697	3172	19127890	1994-12-27	1995-12-22	1	9486
1043	70	1125315	1962-07-17	1962-07-31	1	-2711
46698	3172	738818	2005-01-23	2005-01-30	1	12813
1044	70	1125315	1981-06-02	1981-06-16	1	4184
46699	3172	1124957	1999-01-16	1999-01-16	1	10607
1045	70	738818	2007-12-03	2007-12-10	1	13857
46700	3172	1125315	1982-12-20	1983-01-03	1	4750
1046	70	1112807	1982-08-17	1982-08-31	1	4625
46701	3172	1125315	1999-01-09	1999-02-15	2	10637
1047	70	1119510	1962-07-17	1962-07-31	1	-2711
46702	3172	1125315	2005-01-23	2005-01-30	1	12813
1048	70	1125315	1952-05-20	1952-06-03	1	-6421
46703	3172	1503184	1998-12-06	1999-12-01	1	10926
1049	70	1728416	1952-05-20	1952-06-03	1	-6421
46704	3172	1515774	1996-12-16	1998-12-06	2	10566
1050	70	1729720	1993-04-29	1993-05-07	1	8527
46705	3172	1713332	2018-09-27	2018-10-04	1	17808
1051	70	1729720	2019-04-24	2019-05-03	1	18019
46706	3172	1125315	1983-04-19	1983-05-03	1	4870
1052	70	1119510	2007-12-03	2007-12-10	1	13857
46707	3172	1125315	2015-12-20	2016-01-03	1	16803
1053	70	1125315	2007-12-03	2007-12-10	1	13857
46708	3172	1515774	1994-12-27	1995-12-22	1	9486
1054	70	1768849	1982-08-17	1982-08-31	1	4625
46709	3172	1595799	1999-12-01	2000-11-25	1	11286
2558	170	933724	1996-03-11	1996-03-18	1	9573
46710	3172	19127890	1996-12-16	1999-12-01	3	10926
2559	170	1125315	1994-06-03	1994-06-24	1	8940
47226	3208	1125315	1992-09-07	1992-09-21	1	8299
2560	170	1125315	2014-01-21	2014-02-04	1	16105
47227	3208	1521369	1984-12-23	1986-12-13	2	6190
2561	170	1503184	1985-01-31	1986-01-26	1	5869
47228	3208	1713332	2016-02-09	2016-02-23	1	16854
2562	170	1503184	1988-01-16	1989-01-10	1	6949
47229	3208	1125315	1990-03-17	1990-03-31	1	7394
2563	170	920293	1996-03-11	1996-03-18	1	9573
47230	3208	1177480	1975-10-02	1975-11-01	1	2130
2564	170	1115008	2004-01-31	2004-03-06	1	12483
47231	3208	1503184	1984-12-23	1986-12-13	2	6190
2565	170	1118084	2009-04-15	2009-04-15	1	14349
47232	3208	1521369	1988-12-02	1989-11-27	1	7270
2566	170	1125315	1971-12-31	1972-01-14	1	743
47233	3208	1115008	2001-03-08	2001-03-29	1	11410
2567	170	1521369	1985-01-31	1986-01-26	1	5869
47234	3208	1118084	2011-04-21	2011-04-21	1	15085
2568	170	1521369	1988-01-16	1989-01-10	1	6949
47235	3208	1125315	1986-04-07	1986-05-12	1	5975
2569	170	1713332	1979-03-29	1979-04-19	1	3395
47236	3208	1174888	2016-02-09	2016-02-09	1	16840
2570	170	1759842	1979-03-29	1979-04-19	1	3395
47237	3208	1361711	2008-01-18	2008-01-18	1	13896
2571	170	1115008	1998-04-04	1998-05-02	1	10348
47238	3208	1503184	1988-12-02	1989-11-27	1	7270
2572	170	1729720	2003-12-21	2004-01-02	1	12419
47239	3208	19127890	1984-12-23	1986-12-13	2	6190
2573	170	19127890	1985-01-31	1986-01-26	1	5869
47240	3208	1125315	1997-01-11	1997-01-25	1	9886
2574	170	19127890	1988-01-16	1989-01-10	1	6949
47241	3208	1125315	2016-02-09	2016-02-23	2	16854
3297	220	1119510	2019-01-11	2019-01-25	1	17921
47242	3208	1322184	2008-01-18	2008-01-18	1	13896
3298	220	1125315	1984-11-21	1984-11-28	1	5445
47243	3208	1332418	2008-01-18	2008-01-18	1	13896
3299	220	1177480	1982-10-31	1982-11-14	1	4700
47244	3208	1539403	2008-01-18	2008-01-18	1	13896
3300	220	1521369	2000-08-07	2001-08-02	1	11536
47245	3208	1713332	1990-03-17	1990-03-31	1	7394
3301	220	1729720	1997-07-08	1997-07-16	1	10058
47246	3208	19127890	1988-12-02	1989-11-27	1	7270
3302	220	1778162	1986-12-17	1986-12-31	1	6208
46024	3123	19127890	1991-07-03	1992-06-27	1	8213
3303	220	1125315	1993-02-11	1993-02-25	1	8456
46025	3123	19127890	1994-06-17	1995-06-12	1	9293
3304	220	1125315	2019-01-11	2019-01-25	1	17921
46253	3141	1125315	1985-08-20	1985-09-03	1	5724
3305	220	1177480	1985-03-19	1985-04-09	1	5577
46254	3141	738818	1979-08-25	1979-09-08	1	3537
3306	220	1500211	1998-08-18	1999-08-13	1	10816
46255	3141	1112807	1981-11-11	1981-12-09	1	4360
3307	220	1521369	1997-08-23	1998-08-18	1	10456
46256	3141	1124300	2010-09-15	2010-09-15	1	14867
3308	220	1713332	1988-02-09	1988-02-16	1	6620
46257	3141	1125315	1979-08-25	1979-09-08	1	3537
3309	220	1759842	1988-02-09	1988-02-16	1	6620
46258	3141	1759842	1976-11-16	1976-11-23	1	2518
3310	220	738818	1993-07-20	1993-08-03	1	8615
46259	3141	1125315	1984-08-02	1984-08-09	1	5334
3311	220	1125315	1990-01-12	1990-01-26	1	7330
46260	3141	1713332	1976-11-16	1976-11-23	1	2518
3312	220	1125315	1993-07-20	1993-08-03	1	8615
46261	3141	1119510	1979-08-25	1979-09-08	1	3537
3313	220	1595799	2000-08-07	2001-08-02	1	11536
46262	3141	1125315	1987-09-11	1987-09-18	1	6469
3314	220	1713332	1982-10-31	1982-11-14	1	4700
46263	3141	1177480	1998-05-28	1998-06-11	1	10388
3315	220	1713332	1993-02-11	1993-02-25	1	8456
47754	3241	1102527	1987-03-19	1987-03-19	1	6286
3316	220	19127890	1997-08-23	1998-08-18	1	10456
47755	3241	1125315	1965-03-09	1965-06-07	1	-1669
3317	220	738818	2019-01-11	2019-01-25	1	17921
47756	3241	1713332	1976-05-31	1976-06-21	1	2363
3318	220	1118084	2019-05-15	2019-05-15	1	18031
47757	3241	1713332	2019-06-10	2019-06-10	1	18057
3319	220	1119510	1993-07-20	1993-08-03	1	8615
47758	3241	1729720	1980-09-29	1980-10-11	1	3936
3320	220	1125315	1986-12-17	1986-12-31	1	6208
47759	3241	1125315	1976-09-07	1976-10-12	1	2476
3321	220	1125315	1991-12-04	1991-12-25	1	8028
47760	3241	1347450	1990-08-16	1990-08-16	1	7532
3322	220	1125315	1998-06-15	1998-06-29	1	10406
47761	3241	1713332	1973-05-02	1973-05-16	1	1231
3323	220	1503184	1997-08-23	1998-08-18	1	10456
47762	3241	1713332	1973-08-23	1973-09-06	1	1344
3324	220	1549786	2000-08-07	2001-08-02	1	11536
47763	3241	1713332	1977-11-22	1977-11-29	1	2889
3325	220	1729720	1985-08-17	1985-08-24	1	5714
47764	3241	1713332	2002-08-02	2002-08-09	1	11908
5500	377	1119510	1979-01-02	1979-01-16	1	3302
47765	3241	1759842	2002-08-02	2002-08-09	1	11908
5501	377	1521369	1985-01-08	1988-12-18	4	6926
47766	3241	1112807	1970-02-11	1970-04-12	1	101
5502	377	1759842	2015-11-15	2015-11-29	1	16768
47767	3241	1118084	1998-08-08	1998-08-08	1	10446
5503	377	914335	1996-11-07	1996-11-07	1	9807
47768	3241	1125315	1966-02-04	1966-02-18	1	-1413
5504	377	1124300	2003-02-13	2003-02-13	1	12096
47769	3241	1125315	1992-09-10	1992-09-24	1	8302
5505	377	1125315	1995-07-13	1995-08-17	1	9359
47770	3241	1125315	2013-08-02	2013-08-09	1	15926
5506	377	1125315	1998-06-06	1998-06-20	1	10397
47771	3241	1759842	1973-05-02	1973-05-16	1	1231
5507	377	1713332	1994-09-30	1994-10-21	1	9059
47772	3241	1759842	1973-08-23	1973-09-06	1	1344
5508	377	1738521	1974-08-29	1974-09-19	1	1722
47773	3241	1759842	1977-11-22	1977-11-29	1	2889
5509	377	1759842	1994-09-30	1994-10-21	1	9059
47774	3241	1759842	2019-06-10	2019-06-10	1	18057
5510	377	1125315	1977-08-04	1977-08-25	1	2793
47775	3241	1112807	1987-03-19	1987-04-18	1	6316
5511	377	1125315	2010-07-19	2010-07-26	1	14816
47776	3241	1125315	2003-10-11	2003-10-25	1	12350
5512	377	1503184	1985-01-08	1988-12-18	4	6926
47777	3241	1759842	1976-05-31	1976-06-21	1	2363
5513	377	1713332	2000-12-20	2001-01-10	1	11332
48469	3295	1112807	1957-12-18	1958-01-01	1	-4383
5514	377	1729720	1970-09-18	1970-09-30	1	272
48470	3295	1118084	1983-03-22	1983-03-22	1	4828
5515	377	1759842	2000-12-20	2001-01-10	1	11332
48471	3295	1125315	1960-05-24	1960-06-07	1	-3495
5516	377	738818	1979-01-02	1979-01-16	1	3302
48472	3295	1125315	1997-11-01	1997-11-15	1	10180
5517	377	1112807	1971-10-09	1971-11-13	1	681
48473	3295	1713332	1971-04-14	1971-04-28	1	482
5518	377	1112807	1974-08-29	1974-09-19	1	1722
48474	3295	1759842	1947-03-13	1947-03-20	1	-8323
5519	377	1125315	1979-01-02	1979-01-16	1	3302
48475	3295	1112807	1952-01-19	1952-02-18	1	-6527
5520	377	1125315	1987-02-04	1987-02-25	1	6264
48476	3295	1112807	1964-11-25	1964-12-16	1	-1842
5521	377	1309944	1996-11-07	1996-11-07	1	9807
48477	3295	1177480	2009-02-23	2009-03-25	1	14328
5522	377	1343916	1996-11-07	1996-11-07	1	9807
48478	3295	1307863	1990-10-08	1990-10-08	1	7585
5523	377	1713332	2015-11-15	2015-11-29	1	16768
48479	3295	1713332	1999-05-02	1999-05-16	1	10727
5524	377	19127890	1985-01-08	1988-12-18	4	6926
48480	3295	1759842	1965-12-18	1966-01-01	1	-1461
8075	563	1347450	2005-03-13	2005-03-13	1	12855
48481	3295	1112807	1944-03-31	1944-04-14	1	-9393
8076	563	1112807	1986-02-19	1986-03-12	1	5914
48482	3295	1125315	1956-04-07	1956-04-14	1	-5010
8077	563	1124300	2003-01-18	2003-01-18	1	12070
48483	3295	1713332	1965-12-18	1966-01-01	1	-1461
8078	563	1125315	1969-04-16	1969-05-07	1	-239
48484	3295	1125315	1944-06-01	1944-06-08	1	-9338
8079	563	1322184	2005-03-13	2005-03-13	1	12855
48485	3295	1310149	1990-10-08	1990-10-08	1	7585
8080	563	1713332	1980-05-16	1980-05-30	1	3802
48486	3295	1326303	1990-10-08	1990-10-08	1	7585
8081	563	1729720	1969-08-15	1969-08-22	1	-132
48487	3295	1713332	1947-03-13	1947-03-20	1	-8323
8082	563	1759842	1964-08-16	1964-08-30	1	-1950
48488	3295	1729720	1978-11-10	1978-11-18	1	3243
8083	563	1759842	1980-05-16	1980-05-30	1	3802
48489	3295	1759842	1971-04-14	1971-04-28	1	482
8084	563	975125	1985-04-19	1985-04-19	1	5587
48490	3295	1759842	1999-05-02	1999-05-16	1	10727
8085	563	1112807	1964-06-11	1964-06-25	1	-2016
52136	3552	1125315	1978-03-21	1978-03-28	1	3008
8086	563	1129625	1985-05-03	1985-05-03	1	5601
52137	3552	1125315	2016-08-30	2016-09-06	1	17050
8087	563	1713332	1964-08-16	1964-08-30	1	-1950
52138	3552	1125315	2017-05-04	2017-05-18	1	17304
8088	563	1112807	1970-04-02	1970-04-23	1	112
52139	3552	1125315	2018-01-13	2018-01-20	1	17551
8089	563	1177480	1978-01-11	1978-02-01	1	2953
52140	3552	1713332	1999-11-02	1999-11-23	1	10918
8090	563	1713332	1985-11-05	1985-11-26	1	5808
52141	3552	1112807	1979-06-25	1979-07-23	1	3490
8091	563	1729720	1974-10-28	1974-11-05	1	1769
52142	3552	1118084	1992-05-25	1992-05-25	1	8180
8092	563	1759842	1985-11-05	1985-11-26	1	5808
52143	3552	1125315	1979-06-25	1979-06-25	1	3462
13040	890	1124300	1997-09-06	1997-09-06	1	10110
52144	3552	1125315	2002-10-31	2002-11-07	1	11998
13041	890	1125315	1992-10-30	1992-11-20	1	8359
52145	3552	1759842	1999-11-02	1999-11-23	1	10918
13042	890	1125315	2012-09-04	2012-09-18	1	15601
52146	3552	738818	1961-04-24	1961-05-08	1	-3160
13043	890	1729720	1964-10-15	1964-10-23	1	-1896
52147	3552	1112807	1957-07-13	1957-07-27	1	-4541
13044	890	738818	1992-03-05	1992-03-19	1	8113
52148	3552	1112807	1958-10-19	1958-11-02	1	-4078
13045	890	1112807	1961-06-17	1961-08-16	1	-3060
52149	3552	1125315	1961-04-24	1961-05-08	1	-3160
13046	890	1125315	1966-03-25	1966-04-01	1	-1371
52150	3552	1125315	1964-02-14	1964-02-21	1	-2141
13047	890	1125315	1992-03-05	1992-03-19	1	8113
52151	3552	1125315	2014-01-23	2014-02-06	1	16107
13048	890	1729720	2015-05-25	2015-06-04	1	16590
52152	3552	1728416	1957-07-13	1957-07-27	1	-4541
13049	890	1759842	1986-08-21	1986-09-04	1	6090
52153	3552	1112807	1965-07-08	1965-08-07	1	-1608
13050	890	1174888	1982-06-25	1982-06-25	1	4558
52154	3552	1119510	1961-04-24	1961-05-08	1	-3160
13051	890	1177480	1975-03-06	1975-04-03	1	1918
52155	3552	1174888	1979-06-25	1979-06-25	1	3462
13052	890	1729720	1963-09-08	1963-09-19	1	-2296
52156	3552	1713332	1993-06-15	1993-06-29	1	8580
13053	890	1119510	1992-03-05	1992-03-19	1	8113
52157	3552	1728416	1958-10-19	1958-11-02	1	-4078
13054	890	1125315	1982-06-25	1982-07-25	2	4588
52158	3552	1759842	1993-06-15	1993-06-29	1	8580
13055	890	1713332	1986-08-21	1986-09-04	1	6090
52159	3552	1768849	1979-06-25	1979-07-23	1	3490
13393	918	738818	1941-10-11	1941-10-25	1	-10295
53715	3654	738818	1975-01-14	1975-01-21	1	1846
13394	918	738818	1991-11-14	1991-11-28	1	8001
53716	3654	1112807	1973-05-23	1973-06-06	1	1252
13395	918	914335	2016-05-20	2016-05-20	1	16941
53717	3654	1125315	1975-01-14	1975-01-21	1	1846
13396	918	1112807	1913-10-07	1913-10-21	1	-20526
53718	3654	1125315	1977-11-23	1977-12-07	1	2897
13397	918	1118084	1954-12-21	1954-12-21	1	-5490
53719	3654	1125315	1994-02-07	1994-02-21	1	8817
13398	918	1119510	2002-12-07	2002-12-14	1	12035
53720	3654	1729720	1983-02-13	1983-02-25	1	4803
13399	918	1125315	1941-10-11	1941-10-25	1	-10295
53721	3654	1177480	2016-10-18	2016-11-21	1	17126
13400	918	1125315	1966-02-22	1966-03-08	1	-1395
53722	3654	1717327	1973-11-18	1973-12-02	1	1431
13401	918	1177480	1989-03-07	1989-04-04	1	7033
53723	3654	1112807	1973-11-18	1973-12-02	1	1431
13402	918	1322184	1997-12-26	1997-12-26	1	10221
53724	3654	1119510	1975-01-14	1975-01-21	1	1846
13403	918	1343916	2016-05-20	2016-05-20	1	16941
53725	3654	1124300	2004-10-17	2004-10-17	1	12708
13404	918	1361711	1991-01-11	1991-01-11	1	7680
53726	3654	1125315	1985-04-06	1985-04-20	1	5588
13405	918	1728416	1949-01-10	1949-01-24	1	-7647
55174	3754	1713332	2011-01-18	2011-02-01	1	15006
13406	918	1112807	1928-01-22	1928-04-21	1	-15230
55175	3754	1728416	1961-04-25	1961-05-09	1	-3159
13407	918	1115008	1998-10-05	1998-11-09	1	10539
55176	3754	1729720	1990-03-03	1990-03-14	1	7377
13408	918	1124957	1928-01-22	1928-01-22	1	-15320
55177	3754	1759842	1963-06-20	1963-06-27	1	-2380
13409	918	1125315	1978-08-01	1978-08-15	1	3148
55178	3754	1759842	2011-01-18	2011-02-01	1	15006
13410	918	1125315	1985-04-27	1985-05-27	1	5625
55179	3754	19127890	1976-12-12	1977-12-07	1	2897
13411	918	1125315	1991-11-14	1991-11-28	1	8001
55180	3754	19127890	1978-12-02	1979-11-27	1	3617
13412	918	1177480	1995-03-04	1995-03-25	1	9214
55181	3754	19127890	1981-11-16	1982-11-11	1	4697
13413	918	1309944	2016-05-20	2016-05-20	1	16941
55182	3754	738818	1995-11-25	1995-12-02	1	9466
13414	918	1539403	1991-01-11	1991-01-11	1	7680
55183	3754	1112807	1961-04-25	1961-05-09	1	-3159
13415	918	1729720	1935-06-25	1935-07-02	1	-12602
55184	3754	1125315	1964-12-24	1965-01-07	1	-1820
13416	918	738818	2015-12-19	2016-01-02	1	16802
55185	3754	1125315	1995-11-25	1995-12-02	1	9466
13417	918	1112807	1921-05-06	1921-05-20	1	-17758
55186	3754	1125315	2017-05-18	2017-06-24	2	17341
13418	918	1112807	1949-01-10	1949-01-24	1	-7647
55187	3754	1713332	1963-06-20	1963-06-27	1	-2380
13419	918	1112807	1964-01-13	1964-02-03	1	-2159
55188	3754	1713332	1995-12-31	1996-01-14	1	9509
13420	918	1119510	1941-10-11	1941-10-25	1	-10295
55189	3754	1729720	1965-05-25	1965-06-01	1	-1675
13421	918	1119510	1991-11-14	1991-11-28	1	8001
55190	3754	1112807	1961-09-22	1961-10-27	1	-2988
13422	918	1125315	2015-12-19	2016-01-02	1	16802
55191	3754	1115008	2019-05-15	2019-05-29	1	18045
13423	918	1717327	1978-08-01	1978-08-15	1	3148
55192	3754	1177480	1986-07-16	1986-07-30	1	6054
13424	918	738818	2002-12-07	2002-12-14	1	12035
55193	3754	1521369	1976-12-12	1977-12-07	1	2897
13425	918	1115008	2008-05-20	2008-06-03	1	14033
55194	3754	1521369	1978-12-02	1979-11-27	1	3617
13426	918	1119510	2015-12-19	2016-01-02	1	16802
55195	3754	1521369	1981-11-16	1982-11-11	1	4697
13427	918	1125315	1928-01-22	1928-01-22	1	-15320
55196	3754	1713332	1964-05-01	1964-05-22	1	-2050
13428	918	1125315	1969-01-21	1969-03-22	1	-285
55197	3754	1713332	1971-03-19	1971-04-02	1	456
13429	918	1125315	2002-12-07	2002-12-14	1	12035
55198	3754	1729720	1966-06-28	1966-07-10	1	-1271
13430	918	1332418	1994-12-09	1994-12-09	1	9108
55199	3754	1729720	1970-11-18	1970-11-26	1	329
14456	992	738818	1956-09-07	1956-09-21	1	-4850
55200	3754	1759842	1966-01-18	1966-01-25	1	-1437
14457	992	1125315	1956-07-25	1956-09-21	2	-4880
55201	3754	1118084	2005-03-10	2005-03-10	1	12852
14458	992	1125315	1960-07-03	1960-07-10	1	-3462
55202	3754	1119510	1995-11-25	1995-12-02	1	9466
14459	992	1125315	1971-09-14	1971-09-21	1	628
55203	3754	1125315	1968-03-24	1968-04-21	1	-620
14460	992	1125315	1997-02-01	1997-04-02	1	9953
55204	3754	1174888	2017-05-25	2017-05-25	1	17311
14461	992	1125315	2015-03-29	2015-05-03	1	16558
55205	3754	1503184	1976-12-12	1977-12-07	1	2897
14462	992	1177480	1993-03-26	1993-04-23	1	8513
55206	3754	1503184	1978-12-02	1979-11-27	1	3617
14463	992	1112807	1955-05-15	1955-05-29	1	-5331
55207	3754	1503184	1981-11-16	1982-11-11	1	4697
14464	992	1119510	1956-09-07	1956-09-21	1	-4850
55208	3754	1713332	1966-01-18	1966-01-25	1	-1437
14465	992	1124300	1987-07-31	1987-07-31	1	6420
55209	3754	1729720	1963-02-18	1963-03-03	1	-2496
14466	992	1125315	1962-12-08	1962-12-15	1	-2574
55210	3754	1759842	1964-05-01	1964-05-22	1	-2050
14467	992	1125315	1987-07-01	1987-07-15	1	6404
55211	3754	1759842	1971-03-19	1971-04-02	1	456
14468	992	1125315	2009-12-25	2010-03-25	1	14693
55212	3754	1759842	1995-12-31	1996-01-14	1	9509
14469	992	920293	2005-09-16	2005-09-30	2	13056
55887	3804	1118084	2003-04-16	2003-04-16	1	12158
14470	992	933724	2005-09-16	2005-09-30	1	13056
55888	3804	1174888	2000-01-28	2000-01-28	1	10984
14471	992	1102527	2009-12-25	2009-12-25	1	14603
55889	3804	1112807	1978-11-14	1978-12-19	1	3274
14472	992	1728416	1955-05-15	1955-05-29	1	-5331
55890	3804	1177480	2018-04-23	2018-05-28	1	17679
14473	992	1728416	1956-07-25	1956-08-08	1	-4894
55891	3804	1713332	1999-08-11	1999-08-18	1	10821
15700	1088	1102527	1995-12-14	1995-12-14	1	9478
55892	3804	1717327	1964-05-10	1964-05-24	1	-2048
15701	1088	1119510	1987-10-20	1987-10-27	1	6508
55893	3804	1759842	1999-08-11	1999-08-18	1	10821
15702	1088	1125315	1996-10-10	1996-10-24	1	9793
55894	3804	1112807	1964-05-10	1964-05-24	1	-2048
15703	1088	1125315	2001-01-18	2001-01-25	1	11347
55895	3804	1125315	2000-01-28	2000-01-28	1	10984
15704	1088	1515774	1991-07-01	1992-06-25	1	8211
55896	3804	1112807	1962-09-18	1962-10-18	1	-2632
15705	1088	1729720	1975-08-18	1975-08-26	1	2063
55897	3804	1115008	2000-01-28	2000-02-27	1	11014
15706	1088	1729720	1984-09-10	1984-09-23	1	5379
55898	3804	1125315	1971-08-02	1971-08-23	1	599
15707	1088	920293	2006-09-01	2006-09-08	1	13399
55899	3804	1125315	1991-06-19	1991-07-03	1	7853
15708	1088	933724	2006-09-01	2006-09-08	1	13399
58071	3961	738818	1973-03-09	1973-03-16	1	1170
15709	1088	1125315	1976-04-10	1976-05-01	1	2312
58072	3961	1125315	1973-03-09	1973-03-16	1	1170
15710	1088	1521369	1990-07-06	1991-07-01	1	7851
58073	3961	1125315	1975-02-26	1975-03-12	1	1896
15711	1088	1521369	1992-06-25	1993-06-20	1	8571
58074	3961	1125315	1984-03-29	1984-04-12	1	5215
15712	1088	1738521	1973-10-23	1973-11-06	1	1405
58075	3961	1125315	1990-06-05	1990-07-10	2	7495
15713	1088	1112807	1973-10-23	1973-11-06	1	1405
58076	3961	1174888	1990-06-05	1990-06-05	1	7460
15714	1088	1118084	2011-07-11	2011-07-11	1	15166
58077	3961	1713332	1983-02-10	1983-02-24	1	4802
15715	1088	19127890	1990-07-06	1993-06-20	3	8571
58078	3961	1729720	1977-05-19	1977-05-31	1	2707
15716	1088	738818	1987-10-20	1987-10-27	1	6508
58079	3961	1124300	2011-09-15	2011-09-15	1	15232
15717	1088	1115008	1995-12-14	1996-01-13	1	9508
58080	3961	1125315	2018-12-10	2018-12-31	1	17896
15718	1088	1125315	1985-06-23	1985-06-30	1	5659
58081	3961	1738521	1975-02-26	1975-03-12	1	1896
15719	1088	1125315	1987-10-20	1987-10-27	1	6508
58082	3961	1778162	1990-06-05	1990-07-10	1	7495
15720	1088	1125315	1988-01-29	1988-02-19	1	6623
58083	3961	1125315	1983-02-10	1983-02-24	1	4802
15721	1088	1125315	1989-03-15	1989-04-12	1	7041
58084	3961	1177480	1975-10-31	1975-11-21	1	2150
15722	1088	1503184	1990-07-06	1991-07-01	1	7851
58085	3961	1112807	1974-10-29	1974-12-05	1	1799
15723	1088	1503184	1992-06-25	1993-06-20	1	8571
58086	3961	1119510	1973-03-09	1973-03-16	1	1170
15724	1088	1549786	1991-07-01	1992-06-25	1	8211
58087	3961	1322184	2014-10-28	2014-10-28	1	16371
18007	1242	1112807	1960-03-05	1960-03-19	1	-3575
58088	3961	1347450	2014-10-28	2014-10-28	1	16371
18008	1242	1125315	1975-10-14	1975-10-21	1	2119
58089	3961	1713332	1984-03-29	1984-04-12	1	5215
18009	1242	1125315	1985-05-07	1985-05-14	1	5612
58505	3989	920293	1954-11-01	1954-11-08	1	-5533
18010	1242	1119510	1979-02-14	1979-02-21	1	3338
58506	3989	933724	1954-11-01	1954-11-08	1	-5533
18011	1242	1125315	2007-05-20	2007-06-03	1	13667
58507	3989	1112807	1928-10-27	1928-11-10	1	-15027
18012	1242	1118084	2000-10-21	2000-10-21	1	11251
58508	3989	1125315	1975-03-25	1975-04-22	1	1937
18013	1242	1125315	1989-12-26	1990-01-09	1	7313
58509	3989	1759842	1994-04-20	1994-05-04	1	8889
18014	1242	1177480	2014-07-02	2014-07-23	1	16274
58510	3989	1125315	1959-01-20	1959-02-03	1	-3985
18015	1242	1713332	1977-12-06	1977-12-27	1	2917
58511	3989	1125315	1971-01-14	1971-01-21	1	385
18016	1242	1713332	1996-02-28	1996-03-06	1	9561
58512	3989	1125315	1994-02-13	1994-02-20	1	8816
18017	1242	1759842	1996-02-28	1996-03-06	1	9561
58513	3989	1729720	1996-11-05	1996-11-16	1	9816
18018	1242	738818	1979-02-14	1979-02-21	1	3338
58514	3989	701322	2018-10-15	2018-10-15	1	17819
18019	1242	1112807	1969-10-14	1969-11-11	1	-51
58515	3989	715997	2018-10-15	2018-10-15	1	17819
18020	1242	1125315	1964-02-27	1964-03-12	1	-2121
58516	3989	1115008	2003-11-21	2004-02-19	1	12467
18021	1242	1125315	1979-02-14	1979-02-21	1	3338
58517	3989	1125315	1974-12-02	1974-12-16	1	1810
18022	1242	1728416	1964-02-27	1964-03-12	1	-2121
58518	3989	1125315	1978-04-09	1978-04-23	1	3034
18023	1242	1759842	1977-12-06	1977-12-27	1	2917
58519	3989	757627	2017-01-23	2017-01-23	1	17189
18758	1289	1112807	1963-06-19	1963-07-03	1	-2374
58520	3989	1118084	1965-01-11	1965-01-11	1	-1816
18759	1289	1118084	2000-11-23	2000-11-23	1	11284
58521	3989	1125315	1981-01-13	1981-01-20	1	4037
18760	1289	1119510	1996-03-07	1996-03-14	1	9569
58522	3989	1125315	1999-01-26	1999-02-09	1	10631
18761	1289	1125315	1965-03-18	1965-05-01	2	-1715
58523	3989	1557272	2018-01-29	2018-01-29	1	17560
18762	1289	1125315	1989-04-16	1989-05-07	1	7066
58524	3989	1713332	1994-04-20	1994-05-04	1	8889
18763	1289	1713332	2004-07-11	2004-08-01	1	12631
59628	4067	1124300	2007-07-01	2007-07-01	1	13695
18764	1289	1115008	2002-12-25	2003-01-15	1	12067
59629	4067	1125315	2012-08-19	2012-09-02	1	15585
18765	1289	1119510	1976-12-26	1977-01-09	1	2565
59630	4067	1729720	1987-01-04	1987-01-15	1	6223
18766	1289	1125315	1962-11-08	1962-11-22	1	-2597
59631	4067	1112807	1977-06-23	1977-07-14	1	2751
18767	1289	1125315	2015-09-30	2015-10-28	1	16736
59632	4067	1125315	1983-01-14	1983-04-14	1	4851
18768	1289	1717327	1963-06-19	1963-07-03	1	-2374
59633	4067	1713332	2002-08-29	2002-09-12	1	11942
18769	1289	1717327	1965-04-17	1965-05-01	1	-1706
59634	4067	1729720	1972-05-24	1972-06-03	1	884
18770	1289	1729720	1973-12-14	1973-12-23	1	1452
59635	4067	723013	1971-12-04	1972-06-03	1	884
18771	1289	738818	1996-03-07	1996-03-14	1	9569
59636	4067	740275	1972-06-03	1972-10-28	1	1031
18772	1289	1125315	1964-08-14	1964-08-28	1	-1952
59637	4067	1759842	2002-08-29	2002-09-12	1	11942
18773	1289	1125315	1996-03-07	1996-03-14	1	9569
59638	4067	723013	1971-03-27	1971-10-02	1	639
18774	1289	1728416	1964-08-14	1964-08-28	1	-1952
60532	4129	1125315	1992-04-05	1992-04-26	1	8151
18775	1289	1759842	2004-07-11	2004-08-01	1	12631
60533	4129	1729720	1950-11-14	1950-11-23	1	-6979
18776	1289	738818	1976-12-26	1977-01-09	1	2565
60534	4129	1124300	1983-10-05	1983-10-05	1	5025
18777	1289	1112807	1963-02-06	1963-02-27	1	-2500
60535	4129	1713332	2013-06-07	2013-06-14	1	15870
18778	1289	1112807	1972-09-28	1972-10-12	1	1015
60536	4129	1759842	2013-06-07	2013-06-14	1	15870
18779	1289	1115008	2011-10-30	2011-11-20	1	15298
60537	4129	1112807	1988-08-24	1988-10-23	1	6870
18780	1289	1125315	1976-12-26	1977-01-09	1	2565
60538	4129	1729720	1955-03-05	1955-03-15	1	-5406
18781	1289	1177480	1997-05-25	1997-08-23	1	10096
62726	4283	1118084	1990-12-15	1990-12-15	1	7653
18782	1289	1713332	1995-06-06	1995-06-20	1	9301
62727	4283	1125315	1955-11-26	1956-01-25	1	-5090
18783	1289	1717327	1962-11-08	1962-11-22	1	-2597
62728	4283	1125315	1967-03-09	1967-03-16	1	-1022
18784	1289	1729720	1975-03-19	1975-03-26	1	1910
62729	4283	1729720	1970-09-15	1970-09-25	1	267
18785	1289	1759842	1995-06-06	1995-06-20	1	9301
62730	4283	1112807	1959-02-08	1959-05-09	1	-3890
20636	1407	1125315	1971-08-18	1971-09-17	1	624
62731	4283	1112807	1973-10-22	1973-11-19	1	1418
20637	1407	1125315	1999-09-26	1999-10-03	1	10867
62732	4283	1125315	1953-10-30	1954-01-28	1	-5817
20638	1407	19127890	1981-11-07	1982-11-02	1	4688
62733	4283	1125315	1964-11-03	1964-11-17	1	-1871
20639	1407	19127890	1987-10-07	1988-10-01	1	6848
62734	4283	1125315	1981-12-29	1982-01-12	1	4394
20640	1407	1125315	1970-10-01	1970-10-22	1	294
62735	4283	1729720	1990-09-11	1990-09-24	1	7571
20641	1407	1503184	1987-10-07	1988-10-01	1	6848
62736	4283	1112807	1956-12-20	1957-03-20	1	-4670
20642	1407	1717327	1973-11-09	1973-11-23	1	1422
62737	4283	1125315	1961-06-27	1961-07-27	1	-3080
20643	1407	1112807	1973-11-09	1973-11-23	1	1422
64140	4382	738818	2010-08-13	2010-08-20	1	14841
20644	1407	1118084	2002-11-17	2002-11-17	1	12008
64141	4382	1149380	1955-01-05	1955-01-05	1	-5475
20645	1407	1125315	1975-04-29	1975-05-27	1	1972
64142	4382	1177480	1975-12-20	1976-01-10	1	2200
20646	1407	1125315	1986-06-28	1986-07-19	1	6043
64143	4382	19127890	1974-11-14	1975-11-09	1	2138
20647	1407	1125315	1989-03-05	1989-04-04	1	7033
64144	4382	19127890	1976-11-03	1977-10-29	1	2858
20648	1407	1503184	1981-11-07	1982-11-02	1	4688
64145	4382	738818	1967-01-22	1967-01-29	1	-1068
20649	1407	1521369	1981-11-07	1982-11-02	1	4688
64146	4382	1115008	2000-06-16	2000-06-30	1	11138
20650	1407	1521369	1987-10-07	1988-10-01	1	6848
64147	4382	1118084	1994-05-03	1994-05-03	1	8888
20651	1407	1713332	1979-09-15	1979-09-22	1	3551
64148	4382	1125315	1964-10-27	1964-11-17	1	-1871
20652	1407	1713332	1989-08-07	1989-08-21	1	7172
64149	4382	1125315	1965-06-16	1965-06-30	1	-1646
20653	1407	1759842	1979-09-15	1979-09-22	1	3551
64150	4382	1125315	1967-01-22	1967-01-29	1	-1068
20654	1407	1759842	1989-08-07	1989-08-21	1	7172
64151	4382	1125315	1968-06-13	1968-06-20	1	-560
20655	1407	1112807	1968-10-06	1968-11-10	1	-417
64152	4382	1125315	1985-12-18	1986-01-01	1	5844
20656	1407	1125315	1992-12-14	1992-12-28	1	8397
64153	4382	1729720	1974-10-07	1974-10-15	1	1748
20657	1407	1729720	2012-10-02	2012-10-15	1	15628
64154	4382	19127890	1978-10-24	1979-10-19	1	3578
20897	1427	920293	1986-12-17	1986-12-24	1	6201
64155	4382	1119510	2010-08-13	2010-08-20	1	14841
20898	1427	933724	1986-12-17	1986-12-24	1	6201
64156	4382	1125315	1955-08-17	1955-08-31	1	-5237
20899	1427	1115008	2008-08-26	2008-09-09	1	14131
64157	4382	1125315	2010-08-13	2010-08-20	1	14841
20900	1427	1118084	1995-09-15	1995-09-15	1	9388
64158	4382	1503184	1974-11-14	1975-11-09	1	2138
20901	1427	1125315	1968-06-03	1968-07-03	1	-547
64159	4382	1503184	1976-11-03	1977-10-29	1	2858
20902	1427	1125315	1982-03-13	1982-04-03	1	4475
64160	4382	1521369	1978-10-24	1979-10-19	1	3578
20903	1427	1125315	2011-07-20	2011-07-27	1	15182
64161	4382	1729720	1984-12-22	1985-01-02	1	5480
20904	1427	1177480	2000-10-16	2000-11-06	1	11267
64162	4382	1729720	2016-04-07	2016-04-18	1	16909
20905	1427	1713332	2011-03-15	2011-04-05	1	15069
64163	4382	1115008	2017-03-03	2017-03-17	1	17242
20906	1427	1778162	2008-08-26	2008-09-09	1	14131
64164	4382	1119510	1967-01-22	1967-01-29	1	-1068
20907	1427	1102527	2008-08-26	2008-08-26	1	14117
64165	4382	1154343	1955-01-05	1955-01-05	1	-5475
20908	1427	1125315	1959-05-15	1959-05-29	1	-3870
64166	4382	1503184	1978-10-24	1979-10-19	1	3578
20909	1427	1125315	1973-06-07	1973-06-28	1	1274
64167	4382	1521369	1974-11-14	1975-11-09	1	2138
20910	1427	1125315	1979-07-07	1979-07-21	1	3488
64168	4382	1521369	1976-11-03	1977-10-29	1	2858
20911	1427	1728416	1959-05-15	1959-05-29	1	-3870
65228	4456	738818	1967-02-09	1967-02-23	1	-1043
20912	1427	1112807	1958-09-24	1958-12-07	2	-4043
65229	4456	738818	2010-03-31	2010-04-14	1	14713
20913	1427	1713332	1994-12-17	1994-12-31	1	9130
65230	4456	920293	2008-06-25	2008-07-02	1	14062
20914	1427	1759842	1994-12-17	1994-12-31	1	9130
65231	4456	1124300	1998-03-07	1998-03-07	1	10292
20915	1427	1177480	1983-01-28	1983-02-18	1	4796
65232	4456	1125315	1999-12-09	1999-12-16	1	10941
20916	1427	1759842	2011-03-15	2011-04-05	1	15069
65233	4456	1125315	2010-03-31	2010-04-14	1	14713
25887	1753	1112807	1968-05-16	1968-05-30	1	-581
65234	4456	19127890	1980-05-10	1981-05-05	1	4142
25888	1753	1149380	1967-05-14	1986-05-29	1	5992
65235	4456	933724	2008-06-25	2008-07-02	1	14062
25889	1753	19127890	1983-04-16	1984-04-10	1	5213
65236	4456	1119510	2010-03-31	2010-04-14	1	14713
25890	1753	19127890	1985-04-05	1987-03-26	2	6293
65237	4456	1125315	1971-06-11	1971-06-18	1	533
25891	1753	1118084	2002-06-17	2002-06-17	1	11855
65238	4456	1112807	1965-06-18	1965-08-17	1	-1598
25892	1753	1125315	1972-05-09	1972-05-23	1	873
65239	4456	1125315	1967-02-09	1967-02-23	1	-1043
25893	1753	1125315	1988-06-02	1988-06-09	1	6734
65240	4456	1125315	1976-01-24	1976-02-07	1	2228
25894	1753	1154343	1967-05-14	1986-05-29	1	5992
65241	4456	1729720	1999-11-03	1999-11-11	1	10906
25895	1753	1503184	1983-04-16	1984-04-10	1	5213
65242	4456	1119510	1967-02-09	1967-02-23	1	-1043
25896	1753	1503184	1985-04-05	1987-03-26	2	6293
65243	4456	1125315	1969-05-13	1969-05-20	1	-226
25897	1753	1729720	1998-04-18	1998-04-29	1	10345
65244	4456	1125315	2003-04-30	2003-05-14	1	12186
25898	1753	1112807	1965-04-02	1965-04-16	1	-1721
65245	4456	1503184	1980-05-10	1981-05-05	1	4142
25899	1753	1125315	1968-07-26	1968-08-09	1	-510
65246	4456	1521369	1980-05-10	1981-05-05	1	4142
25900	1753	1717327	1968-07-26	1968-08-09	1	-510
65634	4484	738818	1951-11-14	1951-11-21	1	-6616
25901	1753	1728416	1965-04-02	1965-04-16	1	-1721
65635	4484	1102527	2003-02-17	2003-02-17	1	12100
25902	1753	1729720	1965-04-03	1965-04-16	1	-1721
65636	4484	1112807	1966-09-24	1966-10-29	1	-1160
25903	1753	1521369	1983-04-16	1984-04-10	1	5213
65637	4484	1115008	2003-02-17	2003-03-03	1	12114
25904	1753	1521369	1985-04-05	1987-03-26	2	6293
65638	4484	1119510	1986-03-23	1986-04-06	1	5939
25905	1753	1713332	1999-09-07	1999-09-28	1	10862
65639	4484	1125315	1960-12-24	1961-01-07	1	-3281
25906	1753	1759842	1999-09-07	1999-09-28	1	10862
65640	4484	1177480	2019-05-11	2019-05-25	1	18041
28277	1916	1112807	1973-09-23	1973-10-07	1	1375
65641	4484	1728416	1960-12-24	1961-01-07	1	-3281
28278	1916	1115008	2004-10-31	2004-11-21	1	12743
65642	4484	1768849	2003-02-17	2003-03-03	1	12114
28279	1916	1125315	1972-01-04	1972-01-11	1	740
65643	4484	1125315	1951-11-14	1951-11-21	1	-6616
28280	1916	1149380	1974-10-10	1974-10-10	1	1743
65644	4484	1125315	2011-09-09	2011-09-16	1	15233
28281	1916	738818	1987-07-24	1987-07-31	1	6420
65645	4484	1310149	2017-06-08	2017-06-08	1	17325
28282	1916	1118084	2007-05-13	2007-05-13	1	13646
65646	4484	1713332	2007-04-05	2007-04-19	1	13622
28283	1916	1125315	1977-06-04	1977-06-18	1	2725
65647	4484	1759842	2007-04-05	2007-04-19	1	13622
28284	1916	1125315	1987-07-24	1987-07-31	1	6420
65648	4484	1112807	1954-06-29	1954-07-13	1	-5651
28285	1916	1125315	1982-05-23	1982-06-29	1	4562
65649	4484	1118084	1986-07-26	1986-07-26	1	6050
28286	1916	1125315	1984-02-12	1984-02-26	1	5169
65650	4484	1125315	1958-01-02	1958-01-16	1	-4368
28287	1916	1125315	2001-09-09	2001-09-23	1	11588
65651	4484	1307863	2017-06-08	2017-06-08	1	17325
28288	1916	1125315	2015-09-12	2015-09-19	1	16697
65652	4484	1728416	1958-01-02	1958-01-16	1	-4368
28289	1916	1154343	1974-10-10	1974-10-10	1	1743
65653	4484	738818	1986-03-23	1986-04-06	1	5939
28290	1916	1713332	1995-10-10	1995-10-31	1	9434
65654	4484	1119510	1951-11-14	1951-11-21	1	-6616
28291	1916	1759842	1995-10-10	1995-10-31	1	9434
65655	4484	1125315	1976-09-11	1976-09-25	1	2459
28292	1916	1112807	1977-07-18	1977-08-17	1	2785
65656	4484	1125315	1986-03-23	1986-04-06	1	5939
28293	1916	1119510	1987-07-24	1987-07-31	1	6420
65657	4484	1326303	2017-06-08	2017-06-08	1	17325
28294	1916	1738521	1977-06-04	1977-06-18	1	2725
65658	4484	1728416	1954-06-29	1954-07-13	1	-5651
28594	1936	1112807	1955-08-04	1955-08-25	1	-5243
65659	4484	1729720	2001-01-15	2001-01-24	1	11346
28595	1936	1115008	2009-07-31	2009-08-30	1	14486
68017	4642	1124300	1991-11-06	1991-11-06	1	7979
28596	1936	1125315	1979-07-11	1979-07-18	1	3485
68018	4642	1125315	1956-12-04	1956-12-18	1	-4762
28597	1936	1713332	2012-04-24	2012-05-08	1	15468
68019	4642	1728416	1956-12-04	1956-12-18	1	-4762
28598	1936	1759842	2012-04-24	2012-05-08	1	15468
68020	4642	1125315	1965-10-05	1965-10-12	1	-1542
28599	1936	738818	2013-08-15	2013-08-22	1	15939
68021	4642	1125315	1984-09-09	1984-09-23	1	5379
28600	1936	1118084	1984-11-03	1984-11-03	1	5420
68022	4642	1551099	1957-06-06	1957-06-06	1	-4592
28601	1936	1125315	1951-09-26	1951-10-24	1	-6644
68023	4642	1112807	1958-10-01	1958-10-15	1	-4096
28602	1936	1125315	2013-08-15	2013-08-22	1	15939
68024	4642	1125315	1962-05-08	1962-05-22	1	-2781
28603	1936	1729720	1949-07-12	1949-07-24	1	-7466
68025	4642	1551099	1953-08-23	1953-08-23	1	-5975
28604	1936	920293	1983-03-13	1983-03-20	1	4826
68026	4642	1125315	1979-02-07	1979-03-14	1	3359
28605	1936	933724	1983-03-13	1983-03-20	1	4826
28606	1936	1125315	1965-02-03	1965-03-10	1	-1758
28607	1936	1728416	1950-05-06	1950-05-20	1	-7166
28608	1936	1102527	2009-07-31	2009-07-31	1	14456
28609	1936	1112807	1949-10-08	1949-11-05	1	-7362
28610	1936	1112807	1950-05-06	1950-05-20	1	-7166
28611	1936	1119510	2013-08-15	2013-08-22	1	15939
28612	1936	1125315	1962-12-31	1963-01-07	1	-2551
28613	1936	1125315	1987-02-07	1987-02-14	1	6253
28614	1936	1177480	1980-06-19	1980-07-03	1	3836
28615	1936	1177480	2010-08-25	2010-09-15	1	14867
31157	2108	1112807	1961-07-19	1961-10-17	1	-2998
31158	2108	1118084	1975-11-13	1975-11-13	1	2142
31159	2108	1125315	1947-12-06	1947-12-20	1	-8048
31160	2108	1125315	1957-04-12	1957-04-26	1	-4633
31161	2108	1177480	1993-05-02	1993-05-30	1	8550
31162	2108	1713332	2004-12-05	2004-12-19	1	12771
31163	2108	1759842	2004-12-05	2004-12-19	1	12771
31164	2108	1125315	1951-09-26	1951-10-10	1	-6658
31165	2108	1125315	1974-03-09	1974-03-23	1	1542
31166	2108	1125315	1987-06-03	1987-09-01	1	6452
31167	2108	1310149	2018-12-28	2018-12-28	1	17893
31168	2108	1326303	2018-12-28	2018-12-28	1	17893
31169	2108	1713332	2010-03-01	2010-03-22	1	14690
31170	2108	1112807	1949-11-14	1949-12-19	1	-7318
31171	2108	1112807	1986-05-09	1986-08-07	1	6062
31172	2108	1115008	2017-07-23	2017-09-21	1	17430
31173	2108	1125315	1946-10-03	1946-10-10	1	-8484
31174	2108	1125315	2006-10-14	2006-10-28	1	13449
31175	2108	1713332	1945-12-23	1946-01-06	1	-8761
31176	2108	1713332	1955-10-12	1955-10-19	1	-5188
31177	2108	1102527	1987-06-03	1987-06-03	1	6362
31178	2108	1112807	1945-03-10	1945-04-09	1	-9033
31179	2108	1307863	2018-12-28	2018-12-28	1	17893
31180	2108	1759842	1945-12-23	1946-01-06	1	-8761
31181	2108	1759842	1955-10-12	1955-10-19	1	-5188
31182	2108	1759842	2010-03-01	2010-03-22	1	14690
31355	2122	738818	2011-07-15	2011-07-29	1	15184
31356	2122	1118084	2013-08-01	2013-08-01	1	15918
31357	2122	1125315	1982-03-09	1982-03-16	1	4457
31358	2122	1125315	1998-04-15	1998-04-29	1	10345
31359	2122	1177480	1975-09-24	1975-10-08	1	2106
31360	2122	1119510	1991-05-02	1991-05-16	1	7805
31361	2122	1125315	1974-10-15	1974-10-29	1	1762
31362	2122	1177480	1978-08-25	1978-09-08	1	3172
31363	2122	1177480	1992-03-12	1992-03-26	1	8120
31364	2122	1119510	2011-07-15	2011-07-29	1	15184
31365	2122	1125315	2011-07-15	2011-07-29	1	15184
31366	2122	1125315	2017-09-07	2017-09-21	1	17430
31367	2122	1738521	1978-08-25	1978-09-08	1	3172
31368	2122	738818	1991-05-02	1991-05-16	1	7805
31369	2122	1115008	1995-03-11	1995-04-01	1	9221
31370	2122	1125315	1991-05-02	1991-05-16	1	7805
31371	2122	1125315	2001-06-29	2001-07-06	1	11509
33222	2256	1125315	1992-09-05	1992-09-19	1	8297
33223	2256	1512674	2003-06-09	2004-06-03	1	12572
33224	2256	1521369	1998-07-05	2003-06-09	5	12212
33225	2256	1713332	1994-09-06	1994-09-13	1	9021
33226	2256	1729720	1989-05-17	1989-05-29	1	7088
33227	2256	738818	1989-11-11	1989-11-25	1	7268
33228	2256	1124300	2012-03-23	2012-03-23	1	15422
33229	2256	1125315	1989-11-11	1989-11-25	1	7268
33230	2256	1521369	1995-07-21	1997-07-10	2	10052
33231	2256	1589505	2004-06-03	2005-05-29	1	12932
33232	2256	19127890	2001-06-19	2002-06-14	1	11852
33233	2256	19127890	2003-06-09	2004-06-03	1	12572
33234	2256	1119510	1989-11-11	1989-11-25	1	7268
33235	2256	1503184	1999-06-30	2000-06-24	1	11132
33236	2256	1503184	2001-06-19	2002-06-14	1	11852
33237	2256	1549786	2000-06-24	2001-06-19	1	11492
33238	2256	1549786	2002-06-14	2004-06-03	2	12572
33239	2256	1713332	2005-08-23	2005-09-06	1	13032
33240	2256	1759842	2005-08-23	2005-09-06	1	13032
33241	2256	19127890	1994-07-26	1997-07-10	3	10052
33242	2256	1125315	1985-05-04	1985-07-03	1	5662
33243	2256	1125315	1990-06-07	1990-07-07	1	7492
33244	2256	1125315	1992-02-23	1992-03-08	1	8102
33245	2256	1125315	2004-12-20	2005-01-03	1	12786
33246	2256	1503184	1995-07-21	1997-07-10	2	10052
33247	2256	1515774	1994-07-26	1995-07-21	1	9332
33248	2256	1549786	1994-07-26	1995-07-21	1	9332
33249	2256	1549786	1998-07-05	1999-06-30	1	10772
33250	2256	1595799	1998-07-05	1999-06-30	1	10772
33251	2256	1595799	2000-06-24	2001-06-19	1	11492
33252	2256	1595799	2002-06-14	2003-06-09	1	12212
33253	2256	1759842	1994-09-06	1994-09-13	1	9021
33254	2256	19127890	1999-06-30	2000-06-24	1	11132
33989	2307	1112807	1966-08-25	1966-09-08	1	-1211
33990	2307	1112807	1967-05-06	1967-05-20	1	-957
33991	2307	1125315	1999-09-28	1999-10-19	1	10883
33992	2307	1503184	1982-09-10	1983-09-05	1	4995
33993	2307	1521369	1986-08-20	1987-08-15	1	6435
33994	2307	1713332	1989-12-09	1989-12-23	1	7296
33995	2307	1759842	1989-12-09	1989-12-23	1	7296
33996	2307	19127890	1978-09-21	1980-09-10	2	3905
33997	2307	1125315	1972-03-09	1972-03-23	1	812
33998	2307	1125315	2013-02-07	2013-03-09	1	15773
33999	2307	1503184	1978-09-21	1980-09-10	2	3905
34000	2307	19127890	1982-09-10	1983-09-05	1	4995
34001	2307	1124300	2003-11-12	2003-11-12	1	12368
34002	2307	1125315	1963-06-25	1963-07-09	1	-2368
34003	2307	1177480	1985-07-16	1985-07-30	1	5689
34004	2307	1503184	1986-08-20	1987-08-15	1	6435
34005	2307	1521369	1982-09-10	1983-09-05	1	4995
34006	2307	1713332	1985-07-16	1985-07-30	1	5689
34007	2307	1728416	1966-08-25	1966-09-08	1	-1211
34008	2307	1125315	1993-01-20	1993-02-03	1	8434
34009	2307	1521369	1978-09-21	1980-09-10	2	3905
34010	2307	1729720	1973-11-01	1973-11-09	1	1408
34011	2307	19127890	1986-08-20	1987-08-15	1	6435
37379	2543	1125315	1978-05-22	1978-06-12	1	3084
37380	2543	1717327	1967-08-04	1967-08-18	1	-867
37381	2543	738818	2015-10-23	2015-10-30	1	16738
37382	2543	1112807	1965-11-12	1965-11-26	1	-1497
37383	2543	1112807	1967-08-04	1967-08-18	1	-867
37384	2543	1125315	2015-02-19	2015-03-19	1	16513
37385	2543	1125315	2015-10-23	2015-10-30	1	16738
37386	2543	1759842	1971-02-06	1971-02-13	1	408
37387	2543	1119510	2015-10-23	2015-10-30	1	16738
37388	2543	1729720	1979-09-04	1979-09-14	1	3543
37389	2543	1118084	2001-03-28	2001-03-28	1	11409
37390	2543	1177480	2011-10-17	2011-11-07	1	15285
37391	2543	1713332	1971-02-06	1971-02-13	1	408
37392	2543	1713332	1998-01-13	1998-01-20	1	10246
37393	2543	1759842	1998-01-13	1998-01-20	1	10246
38735	2633	1112807	1951-01-19	1951-02-02	1	-6908
38736	2633	1112807	1951-11-17	1951-12-01	1	-6606
38737	2633	1118084	1981-08-28	1981-08-28	1	4257
38738	2633	1125315	1991-11-24	1991-12-08	1	8011
38739	2633	1729720	1957-08-28	1957-09-09	1	-4497
38740	2633	1112807	1948-05-13	1948-05-27	1	-7889
38741	2633	1125315	1950-03-16	1950-03-30	1	-7217
38742	2633	1125315	2018-02-19	2018-05-20	1	17671
38743	2633	1728416	1950-03-16	1950-03-30	1	-7217
38744	2633	1728416	1951-01-19	1951-02-02	1	-6908
38745	2633	1728416	1951-11-17	1951-12-01	1	-6606
40809	2771	708298	1974-09-02	1974-09-02	1	1705
40810	2771	753626	1974-09-02	1974-09-02	1	1705
40811	2771	914335	1955-11-11	1955-11-11	1	-5165
40812	2771	967823	1974-09-02	1974-09-02	1	1705
40813	2771	1110410	1974-09-02	1974-09-02	1	1705
40814	2771	1112807	1915-01-19	1915-02-02	1	-20057
40815	2771	1125315	1913-07-30	1913-08-06	1	-20602
40816	2771	1125315	1990-09-08	1990-09-29	1	7576
40817	2771	1741122	1974-09-02	1974-09-02	1	1705
40818	2771	19003953	1974-09-02	1974-09-02	1	1705
40819	2771	740275	1972-09-01	1972-12-08	1	1072
40820	2771	1112807	1940-03-08	1940-03-29	1	-10870
40821	2771	1112807	1946-11-23	1946-12-14	1	-8419
40822	2771	1119510	1973-12-22	1973-12-29	1	1458
40823	2771	1326303	1978-01-20	1978-01-20	1	2941
40824	2771	1343916	1955-11-11	1955-11-11	1	-5165
40825	2771	1347450	1993-02-19	1993-02-19	1	8450
40826	2771	1367571	1974-09-02	1974-09-02	1	1705
40827	2771	1713332	2015-02-05	2015-02-19	1	16485
40828	2771	1759842	2015-02-05	2015-02-19	1	16485
40829	2771	738818	1973-12-22	1973-12-29	1	1458
40830	2771	1118084	1946-09-23	1946-09-23	1	-8501
40831	2771	1125315	1920-09-15	1920-09-29	1	-17991
40832	2771	1125315	1973-12-22	1973-12-29	1	1458
40833	2771	1154029	1974-09-02	1974-09-02	1	1705
40834	2771	782043	1974-09-02	1974-09-02	1	1705
40835	2771	1000560	1974-09-02	1974-09-02	2	1705
40836	2771	1102527	1974-09-02	1974-09-02	1	1705
40837	2771	1112807	1914-07-23	1914-10-21	1	-20161
40838	2771	1112807	1961-08-27	1961-09-10	1	-3035
40839	2771	1115008	2013-09-28	2013-10-28	1	16006
40840	2771	1307863	1981-02-06	1981-02-06	1	4054
40841	2771	1310149	1978-01-20	1978-01-20	1	2941
\.


--
-- TOC entry 3898 (class 0 OID 3185526)
-- Dependencies: 220
-- Data for Name: drug_exposure; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".drug_exposure (drug_exposure_id, person_id, drug_concept_id, drug_exposure_start_date, drug_exposure_start_datetime, drug_exposure_end_date, drug_exposure_end_datetime, verbatim_end_date, drug_type_concept_id, stop_reason, refills, quantity, days_supply, sig, route_concept_id, lot_number, provider_id, visit_occurrence_id, visit_detail_id, drug_source_value, drug_source_concept_id, route_source_value, dose_unit_source_value) FROM stdin;
26318	573	40213160	1960-04-09	1960-04-09 00:00:00	1960-04-09	1960-04-09 00:00:00	1960-04-09	581452		0	0	0		0	0	0	38004	0	10	40213160		
60926	1332	40213198	2010-10-06	2010-10-06 00:00:00	2010-10-06	2010-10-06 00:00:00	2010-10-06	581452		0	0	0		0	0	0	88400	0	133	40213198		
26418	576	40213260	2017-10-25	2017-10-25 00:00:00	2017-10-25	2017-10-25 00:00:00	2017-10-25	581452		0	0	0		0	0	0	38145	0	121	40213260		
54785	4550	1118084	2000-11-13	2000-11-13 00:00:00	2000-11-13	2000-11-13 00:00:00	\N	38000177		0	0	0		0	0	0	303185	0	00025152531	44923712		
47027	3895	40162522	1982-03-30	1982-03-30 00:00:00	1982-03-30	1982-03-30 00:00:00	\N	38000177		0	0	0		0	0	0	259023	0	857005	40162522		
38712	3199	19059056	1975-08-19	1975-08-19 00:00:00	1975-09-02	1975-09-02 00:00:00	1975-09-02	38000177		0	0	14		0	0	0	212733	0	243670	19059056		
21897	476	40213296	2008-05-31	2008-05-31 00:00:00	2008-05-31	2008-05-31 00:00:00	2008-05-31	581452		0	0	0		0	0	0	31764	0	52	40213296		
52764	1154	40213160	1971-05-16	1971-05-16 00:00:00	1971-05-16	1971-05-16 00:00:00	1971-05-16	581452		0	0	0		0	0	0	76224	0	10	40213160		
8667	186	40213160	1976-05-31	1976-05-31 00:00:00	1976-05-31	1976-05-31 00:00:00	1976-05-31	581452		0	0	0		0	0	0	12657	0	10	40213160		
10459	871	1127078	1967-11-09	1967-11-09 00:00:00	1968-01-08	1968-01-08 00:00:00	1968-01-08	38000177		0	0	60		0	0	0	57955	0	282464	1127078		
10524	877	1127433	1992-05-28	1992-05-28 00:00:00	1992-06-11	1992-06-11 00:00:00	1992-06-11	38000177		0	0	14		0	0	0	58440	0	313782	1127433		
9646	806	1127078	1962-07-02	1962-07-02 00:00:00	1962-07-30	1962-07-30 00:00:00	1962-07-30	38000177		0	0	28		0	0	0	53468	0	282464	1127078		
9653	806	40229134	2009-01-18	2009-01-18 00:00:00	2009-01-25	2009-01-25 00:00:00	2009-01-25	38000177		0	0	7		0	0	0	53505	0	1043400	40229134		
86272	1892	40213306	1984-04-12	1984-04-12 00:00:00	1984-04-12	1984-04-12 00:00:00	1984-04-12	581452		0	0	0		0	0	0	126008	0	43	40213306		
9745	817	1713671	1998-09-01	1998-09-01 00:00:00	1998-09-15	1998-09-15 00:00:00	1998-09-15	38000177		0	0	14		0	0	0	54092	0	562251	1713671		
9791	820	19133905	1992-06-30	1992-06-30 00:00:00	1992-07-11	1992-07-11 00:00:00	1992-07-11	38000177		0	0	11		0	0	0	54306	0	834102	19133905		
21217	1746	40236824	2011-05-17	2011-05-17 00:00:00	2011-05-24	2011-05-24 00:00:00	2011-05-24	38000177		0	0	7		0	0	0	116726	0	1094107	40236824		
27036	2230	40165015	1985-06-13	1985-06-13 00:00:00	1985-06-13	1985-06-13 00:00:00	\N	38000177		0	0	0		0	0	0	148400	0	861467	40165015		
87122	1911	40213227	2007-10-29	2007-10-29 00:00:00	2007-10-29	2007-10-29 00:00:00	2007-10-29	581452		0	0	0		0	0	0	127122	0	113	40213227		
31813	2636	1127433	2017-08-22	2017-08-22 00:00:00	2017-09-05	2017-09-05 00:00:00	2017-09-05	38000177		0	0	14		0	0	0	174469	0	313782	1127433		
7089	597	1118084	1987-01-17	1987-01-17 00:00:00	1987-01-17	1987-01-17 00:00:00	\N	38000177		0	0	0		0	0	0	39396	0	00025152531	44923712		
6213	520	40173590	2011-01-06	2011-01-06 00:00:00	2011-01-06	2011-01-06 00:00:00	\N	38000177		0	0	0		0	0	0	34741	0	904419	40173590		
6266	525	1713671	1988-06-04	1988-06-04 00:00:00	1988-09-03	1988-09-03 00:00:00	1988-09-03	38000177		0	0	91		0	0	0	34966	0	562251	1713671		
52955	4401	19059056	1971-11-20	1971-11-20 00:00:00	1971-12-11	1971-12-11 00:00:00	1971-12-11	38000177		0	0	21		0	0	0	292562	0	243670	19059056		
126	9	1118084	2014-08-05	2014-08-05 00:00:00	2014-08-05	2014-08-05 00:00:00	\N	38000177		0	0	0		0	0	0	771	0	00025152531	44923712		
17899	1482	1551192	1981-12-11	1981-12-11 00:00:00	1981-12-11	1981-12-11 00:00:00	1981-12-11	38000177		0	0	0		0	0	0	98905	0	312617	1551192		
28401	2342	19128065	1989-01-13	1989-01-13 00:00:00	1990-01-08	1990-01-08 00:00:00	1990-01-08	38000177		0	0	360		0	0	0	155872	0	749882	19128065		
28460	2346	1713671	1982-08-23	1982-08-23 00:00:00	1982-08-30	1982-08-30 00:00:00	1982-08-30	38000177		0	0	7		0	0	0	156128	0	562251	1713671		
28508	2349	1713671	1992-08-28	1992-08-28 00:00:00	1992-10-16	1992-10-16 00:00:00	1992-10-16	38000177		0	0	49		0	0	0	156351	0	562251	1713671		
52272	4349	40229134	2008-05-20	2008-05-20 00:00:00	2008-05-27	2008-05-27 00:00:00	2008-05-27	38000177		0	0	7		0	0	0	288423	0	1043400	40229134		
53955	4484	19006318	1960-12-24	1960-12-24 00:00:00	1961-01-07	1961-01-07 00:00:00	1961-01-07	38000177		0	0	14		0	0	0	298448	0	105078	19006318		
38050	3147	19133873	1948-07-05	1948-07-05 00:00:00	1948-07-12	1948-07-12 00:00:00	1948-07-12	38000177		0	0	7		0	0	0	209413	0	834061	19133873		
59146	4916	19128022	1994-07-10	1994-07-10 00:00:00	1995-07-05	1995-07-05 00:00:00	1995-07-05	38000177		0	0	360		0	0	0	326675	0	749785	19128022		
38170	3158	19059056	1967-04-07	1967-04-07 00:00:00	1967-05-12	1967-05-12 00:00:00	1967-05-12	38000177		0	0	35		0	0	0	209946	0	243670	19059056		
34903	2882	40169216	1975-05-19	1975-05-19 00:00:00	1993-12-24	1993-12-24 00:00:00	1993-12-24	38000177		0	0	6794		0	0	0	191707	0	895994	40169216		
1807	40	40213160	1955-05-11	1955-05-11 00:00:00	1955-05-11	1955-05-11 00:00:00	1955-05-11	581452		0	0	0		0	0	0	2807	0	10	40213160		
13050	1097	40220960	2016-09-15	2016-09-15 00:00:00	2016-09-15	2016-09-15 00:00:00	2016-09-15	38000177		0	0	0		0	0	0	71970	0	1804799	40220960		
59277	4927	1713671	2006-04-03	2006-04-03 00:00:00	2006-04-10	2006-04-10 00:00:00	2006-04-10	38000177		0	0	7		0	0	0	327491	0	562251	1713671		
13111	1101	40229134	1989-07-01	1989-07-01 00:00:00	1989-07-08	1989-07-08 00:00:00	1989-07-08	38000177		0	0	7		0	0	0	72344	0	1043400	40229134		
40967	3397	1115171	1994-09-03	1994-09-03 00:00:00	1994-09-17	1994-09-17 00:00:00	1994-09-17	38000177		0	0	14		0	0	0	225352	0	849574	1115171		
997	81	1713671	1986-05-21	1986-05-21 00:00:00	1986-06-11	1986-06-11 00:00:00	1986-06-11	38000177		0	0	21		0	0	0	5519	0	562251	1713671		
114186	2509	40213160	1969-09-14	1969-09-14 00:00:00	1969-09-14	1969-09-14 00:00:00	1969-09-14	581452		0	0	0		0	0	0	166051	0	10	40213160		
13969	1169	1127433	1937-12-03	1937-12-03 00:00:00	1937-12-17	1937-12-17 00:00:00	1937-12-17	38000177		0	0	14		0	0	0	77028	0	313782	1127433		
60871	5063	1127433	2010-05-21	2010-05-21 00:00:00	2010-06-04	2010-06-04 00:00:00	2010-06-04	38000177		0	0	14		0	0	0	336572	0	313782	1127433		
14061	1175	40231925	2018-11-11	2018-11-11 00:00:00	2018-11-11	2018-11-11 00:00:00	\N	38000177		0	0	0		0	0	0	77481	0	1049221	40231925		
22987	499	40213160	1959-10-02	1959-10-02 00:00:00	1959-10-02	1959-10-02 00:00:00	1959-10-02	581452		0	0	0		0	0	0	33403	0	10	40213160		
24611	2025	1713671	1969-04-18	1969-04-18 00:00:00	1969-04-25	1969-04-25 00:00:00	1969-04-25	38000177		0	0	7		0	0	0	134694	0	562251	1713671		
44910	3717	40232448	1977-02-15	1977-02-15 00:00:00	1977-02-15	1977-02-15 00:00:00	\N	38000177		0	0	0		0	0	0	247065	0	1049630	40232448		
5411	117	40213227	2000-10-14	2000-10-14 00:00:00	2000-10-14	2000-10-14 00:00:00	2000-10-14	581452		0	0	0		0	0	0	7772	0	113	40213227		
13089	283	40213227	2003-07-21	2003-07-21 00:00:00	2003-07-21	2003-07-21 00:00:00	2003-07-21	581452		0	0	0		0	0	0	18858	0	113	40213227		
16193	1345	19078461	1993-07-21	1993-07-21 00:00:00	1993-10-19	1993-10-19 00:00:00	1993-10-19	38000177		0	0	90		0	0	0	89172	0	310965	19078461		
16231	1348	1713671	1971-04-20	1971-04-20 00:00:00	1971-05-11	1971-05-11 00:00:00	1971-05-11	38000177		0	0	21		0	0	0	89293	0	562251	1713671		
26732	2202	19059056	1987-06-30	1987-06-30 00:00:00	1987-07-14	1987-07-14 00:00:00	1987-07-14	38000177		0	0	14		0	0	0	146808	0	243670	19059056		
26776	2206	19078461	1986-01-18	1986-01-18 00:00:00	1986-02-17	1986-02-17 00:00:00	1986-02-17	38000177		0	0	30		0	0	0	147010	0	310965	19078461		
122935	2702	40213227	1992-10-25	1992-10-25 00:00:00	1992-10-25	1992-10-25 00:00:00	1992-10-25	581452		0	0	0		0	0	0	178999	0	113	40213227		
81631	1783	40213306	1982-10-11	1982-10-11 00:00:00	1982-10-11	1982-10-11 00:00:00	1982-10-11	581452		0	0	0		0	0	0	\N	0	43	40213306		
60753	5051	1127433	2016-02-22	2016-02-22 00:00:00	2016-03-28	2016-03-28 00:00:00	2016-03-28	38000177		0	0	35		0	0	0	335907	0	313782	1127433		
52055	4329	1713671	1990-10-17	1990-10-17 00:00:00	1990-10-24	1990-10-24 00:00:00	1990-10-24	38000177		0	0	7		0	0	0	287119	0	562251	1713671		
6834	576	19059056	1971-06-06	1971-06-06 00:00:00	1971-06-20	1971-06-20 00:00:00	1971-06-20	38000177		0	0	14		0	0	0	38105	0	243670	19059056		
6877	578	1127433	2009-07-22	2009-07-22 00:00:00	2009-07-29	2009-07-29 00:00:00	2009-07-29	38000177		0	0	7		0	0	0	38275	0	313782	1127433		
6923	582	1127433	1996-10-02	1996-10-02 00:00:00	1996-10-09	1996-10-09 00:00:00	1996-10-09	38000177		0	0	7		0	0	0	38579	0	313782	1127433		
49510	1084	40213296	2019-03-01	2019-03-01 00:00:00	2019-03-01	2019-03-01 00:00:00	2019-03-01	581452		0	0	0		0	0	0	\N	0	52	40213296		
54259	4509	1127078	1978-02-02	1978-02-02 00:00:00	1978-04-03	1978-04-03 00:00:00	1978-04-03	38000177		0	0	60		0	0	0	300363	0	282464	1127078		
17528	1450	19078461	1994-11-21	1994-11-21 00:00:00	1994-12-12	1994-12-12 00:00:00	1994-12-12	38000177		0	0	21		0	0	0	96696	0	310965	19078461		
26323	573	40213160	1960-07-09	1960-07-09 00:00:00	1960-07-09	1960-07-09 00:00:00	1960-07-09	581452		0	0	0		0	0	0	37988	0	10	40213160		
60968	1332	40213201	2009-09-30	2009-09-30 00:00:00	2009-09-30	2009-09-30 00:00:00	2009-09-30	581452		0	0	0		0	0	0	88331	0	33	40213201		
26420	576	40213227	2017-10-25	2017-10-25 00:00:00	2017-10-25	2017-10-25 00:00:00	2017-10-25	581452		0	0	0		0	0	0	38145	0	113	40213227		
54786	4550	19059056	1980-01-08	1980-01-08 00:00:00	1980-02-05	1980-02-05 00:00:00	1980-02-05	38000177		0	0	28		0	0	0	303201	0	243670	19059056		
47028	3896	1127433	1990-12-29	1990-12-29 00:00:00	1991-01-12	1991-01-12 00:00:00	1991-01-12	38000177		0	0	14		0	0	0	259140	0	313782	1127433		
38713	3199	46233988	1975-08-19	1975-08-19 00:00:00	1975-09-02	1975-09-02 00:00:00	1975-09-02	38000177		0	0	14		0	0	0	212733	0	1652673	46233988		
21900	476	40213306	1990-08-11	1990-08-11 00:00:00	1990-08-11	1990-08-11 00:00:00	1990-08-11	581452		0	0	0		0	0	0	31754	0	43	40213306		
52773	1154	40213160	1975-08-17	1975-08-17 00:00:00	1975-08-17	1975-08-17 00:00:00	1975-08-17	581452		0	0	0		0	0	0	76292	0	10	40213160		
8675	186	40213296	2012-12-09	2012-12-09 00:00:00	2012-12-09	2012-12-09 00:00:00	2012-12-09	581452		0	0	0		0	0	0	12617	0	52	40213296		
10460	871	19078461	2002-10-20	2002-10-20 00:00:00	2002-11-03	2002-11-03 00:00:00	2002-11-03	38000177		0	0	14		0	0	0	57959	0	310965	19078461		
10525	877	1127433	2009-07-15	2009-07-15 00:00:00	2009-07-29	2009-07-29 00:00:00	2009-07-29	38000177		0	0	14		0	0	0	58367	0	313782	1127433		
9647	806	1127433	1983-09-05	1983-09-05 00:00:00	1983-09-12	1983-09-12 00:00:00	1983-09-12	38000177		0	0	7		0	0	0	53502	0	313782	1127433		
9654	806	19059056	1962-01-03	1962-01-03 00:00:00	1962-01-17	1962-01-17 00:00:00	1962-01-17	38000177		0	0	14		0	0	0	53512	0	243670	19059056		
34046	2815	1127433	1992-04-10	1992-04-10 00:00:00	1992-04-17	1992-04-17 00:00:00	1992-04-17	38000177		0	0	7		0	0	0	186517	0	313782	1127433		
9746	817	19128065	1974-04-27	1974-04-27 00:00:00	1975-04-22	1975-04-22 00:00:00	1975-04-22	38000177		0	0	360		0	0	0	54141	0	749882	19128065		
9792	820	1127433	2009-10-14	2009-10-14 00:00:00	2009-10-21	2009-10-21 00:00:00	2009-10-21	38000177		0	0	7		0	0	0	54329	0	313782	1127433		
21218	1746	40229134	1997-05-30	1997-05-30 00:00:00	1997-06-13	1997-06-13 00:00:00	1997-06-13	38000177		0	0	14		0	0	0	116781	0	1043400	40229134		
27037	2230	1127433	1985-06-13	1985-06-13 00:00:00	1985-07-13	1985-07-13 00:00:00	1985-07-13	38000177		0	0	30		0	0	0	148400	0	313782	1127433		
37531	3103	1713671	2018-10-07	2018-10-07 00:00:00	2018-10-28	2018-10-28 00:00:00	2018-10-28	38000177		0	0	21		0	0	0	206440	0	562251	1713671		
31814	2636	1127433	1989-12-25	1989-12-25 00:00:00	1990-01-01	1990-01-01 00:00:00	1990-01-01	38000177		0	0	7		0	0	0	174466	0	313782	1127433		
7090	597	19133905	2003-06-21	2003-06-21 00:00:00	2003-06-29	2003-06-29 00:00:00	2003-06-29	38000177		0	0	8		0	0	0	39447	0	834102	19133905		
6214	520	1127433	1993-09-23	1993-09-23 00:00:00	1993-10-07	1993-10-07 00:00:00	1993-10-07	38000177		0	0	14		0	0	0	34671	0	313782	1127433		
6267	525	1127433	2002-02-19	2002-02-19 00:00:00	2002-02-26	2002-02-26 00:00:00	2002-02-26	38000177		0	0	7		0	0	0	34969	0	313782	1127433		
52956	4401	19128065	1983-12-27	1983-12-27 00:00:00	1984-12-21	1984-12-21 00:00:00	1984-12-21	38000177		0	0	360		0	0	0	292569	0	749882	19128065		
127	9	19128022	1996-06-25	1996-06-25 00:00:00	1997-06-20	1997-06-20 00:00:00	1997-06-20	38000177		0	0	360		0	0	0	850	0	749785	19128022		
17900	1482	1127433	1987-12-10	1987-12-10 00:00:00	1987-12-31	1987-12-31 00:00:00	1987-12-31	38000177		0	0	21		0	0	0	98828	0	313782	1127433		
28402	2342	1127078	1978-09-13	1978-09-13 00:00:00	1978-09-27	1978-09-27 00:00:00	1978-09-27	38000177		0	0	14		0	0	0	155899	0	282464	1127078		
28461	2346	19078461	2016-09-10	2016-09-10 00:00:00	2016-12-09	2016-12-09 00:00:00	2016-12-09	38000177		0	0	90		0	0	0	156220	0	310965	19078461		
28509	2349	1127433	2016-12-21	2016-12-21 00:00:00	2016-12-28	2016-12-28 00:00:00	2016-12-28	38000177		0	0	7		0	0	0	156356	0	313782	1127433		
52273	4349	19073183	1983-05-01	1983-05-01 00:00:00	1983-05-15	1983-05-15 00:00:00	1983-05-15	38000177		0	0	14		0	0	0	288389	0	308182	19073183		
53956	4484	19059056	1954-06-29	1954-06-29 00:00:00	1954-07-13	1954-07-13 00:00:00	1954-07-13	38000177		0	0	14		0	0	0	298485	0	243670	19059056		
38051	3147	1127433	1992-02-24	1992-02-24 00:00:00	1992-03-02	1992-03-02 00:00:00	1992-03-02	38000177		0	0	7		0	0	0	209431	0	313782	1127433		
59147	4916	1127433	2005-05-27	2005-05-27 00:00:00	2005-06-10	2005-06-10 00:00:00	2005-06-10	38000177		0	0	14		0	0	0	326663	0	313782	1127433		
38171	3158	1124300	1990-02-06	1990-02-06 00:00:00	1990-02-06	1990-02-06 00:00:00	\N	38000177		0	0	0		0	0	0	209982	0	00781178901	45011828		
34904	2882	1154615	1975-05-19	1975-05-19 00:00:00	1993-12-24	1993-12-24 00:00:00	1993-12-24	38000177		0	0	6794		0	0	0	191707	0	745679	1154615		
1809	40	40213227	1993-12-15	1993-12-15 00:00:00	1993-12-15	1993-12-15 00:00:00	1993-12-15	581452		0	0	0		0	0	0	2846	0	113	40213227		
13051	1097	19075601	2016-09-15	2016-09-15 00:00:00	2016-09-15	2016-09-15 00:00:00	2016-09-15	38000177		0	0	0		0	0	0	71970	0	309362	19075601		
59278	4927	1713671	2005-06-10	2005-06-10 00:00:00	2005-07-01	2005-07-01 00:00:00	2005-07-01	38000177		0	0	21		0	0	0	327487	0	562251	1713671		
13112	1101	1713671	2012-02-17	2012-02-17 00:00:00	2012-03-09	2012-03-09 00:00:00	2012-03-09	38000177		0	0	21		0	0	0	72360	0	562251	1713671		
40968	3397	1127433	1954-01-06	1954-01-06 00:00:00	1954-01-20	1954-01-20 00:00:00	1954-01-20	38000177		0	0	14		0	0	0	225323	0	313782	1127433		
998	81	1118084	1997-04-30	1997-04-30 00:00:00	1997-04-30	1997-04-30 00:00:00	\N	38000177		0	0	0		0	0	0	5477	0	00025152531	44923712		
114194	2509	40213160	1970-02-15	1970-02-15 00:00:00	1970-02-15	1970-02-15 00:00:00	1970-02-15	581452		0	0	0		0	0	0	166052	0	10	40213160		
13970	1169	1127433	1961-10-16	1961-10-16 00:00:00	1961-11-06	1961-11-06 00:00:00	1961-11-06	38000177		0	0	21		0	0	0	76985	0	313782	1127433		
60872	5063	19059056	1947-03-04	1947-03-04 00:00:00	1947-03-18	1947-03-18 00:00:00	1947-03-18	38000177		0	0	14		0	0	0	336618	0	243670	19059056		
14062	1175	1713671	2017-02-15	2017-02-15 00:00:00	2017-03-08	2017-03-08 00:00:00	2017-03-08	38000177		0	0	21		0	0	0	77530	0	562251	1713671		
22989	499	40213296	2000-06-02	2000-06-02 00:00:00	2000-06-02	2000-06-02 00:00:00	2000-06-02	581452		0	0	0		0	0	0	33475	0	52	40213296		
24612	2025	1127433	1954-09-11	1954-09-11 00:00:00	1954-10-16	1954-10-16 00:00:00	1954-10-16	38000177		0	0	35		0	0	0	134737	0	313782	1127433		
44911	3717	1127078	1981-03-13	1981-03-13 00:00:00	1981-03-27	1981-03-27 00:00:00	1981-03-27	38000177		0	0	14		0	0	0	247051	0	282464	1127078		
5417	117	40213160	1973-09-15	1973-09-15 00:00:00	1973-09-15	1973-09-15 00:00:00	1973-09-15	581452		0	0	0		0	0	0	7791	0	10	40213160		
13090	283	40213306	2003-07-21	2003-07-21 00:00:00	2003-07-21	2003-07-21 00:00:00	2003-07-21	581452		0	0	0		0	0	0	18858	0	43	40213306		
16194	1345	19059056	1968-06-19	1968-06-19 00:00:00	1968-07-03	1968-07-03 00:00:00	1968-07-03	38000177		0	0	14		0	0	0	89155	0	243670	19059056		
16232	1348	19133905	1979-07-22	1979-07-22 00:00:00	1979-08-01	1979-08-01 00:00:00	1979-08-01	38000177		0	0	10		0	0	0	89339	0	834102	19133905		
26733	2202	40229134	1997-12-24	1997-12-24 00:00:00	1997-12-31	1997-12-31 00:00:00	1997-12-31	38000177		0	0	7		0	0	0	146774	0	1043400	40229134		
26777	2206	19059056	1976-03-30	1976-03-30 00:00:00	1976-04-13	1976-04-13 00:00:00	1976-04-13	38000177		0	0	14		0	0	0	147053	0	243670	19059056		
122950	2702	40213227	2002-03-10	2002-03-10 00:00:00	2002-03-10	2002-03-10 00:00:00	2002-03-10	581452		0	0	0		0	0	0	178989	0	113	40213227		
81634	1783	40213306	1981-03-23	1981-03-23 00:00:00	1981-03-23	1981-03-23 00:00:00	1981-03-23	581452		0	0	0		0	0	0	\N	0	43	40213306		
60754	5051	1713671	1979-04-23	1979-04-23 00:00:00	1979-05-07	1979-05-07 00:00:00	1979-05-07	38000177		0	0	14		0	0	0	335871	0	562251	1713671		
52056	4329	920334	2008-05-17	2008-05-17 00:00:00	2008-05-24	2008-05-24 00:00:00	2008-05-24	38000177		0	0	7		0	0	0	287072	0	311995	920334		
6835	576	46233988	1971-06-06	1971-06-06 00:00:00	1971-06-20	1971-06-20 00:00:00	1971-06-20	38000177		0	0	14		0	0	0	38105	0	1652673	46233988		
6878	578	19133905	1996-12-18	1996-12-18 00:00:00	1996-12-28	1996-12-28 00:00:00	1996-12-28	38000177		0	0	10		0	0	0	38269	0	834102	19133905		
6924	582	19059056	1961-01-22	1961-01-22 00:00:00	1961-04-22	1961-04-22 00:00:00	1961-04-22	38000177		0	0	90		0	0	0	38553	0	243670	19059056		
61443	5113	19078461	2014-04-03	2014-04-03 00:00:00	2014-04-24	2014-04-24 00:00:00	2014-04-24	38000177		0	0	21		0	0	0	339729	0	310965	19078461		
54260	4509	1713671	2003-11-04	2003-11-04 00:00:00	2003-11-18	2003-11-18 00:00:00	2003-11-18	38000177		0	0	14		0	0	0	300387	0	562251	1713671		
17529	1450	40229134	2015-11-24	2015-11-24 00:00:00	2015-12-08	2015-12-08 00:00:00	2015-12-08	38000177		0	0	14		0	0	0	96724	0	1043400	40229134		
26330	573	40213227	2010-11-06	2010-11-06 00:00:00	2010-11-06	2010-11-06 00:00:00	2010-11-06	581452		0	0	0		0	0	0	37948	0	113	40213227		
60971	1332	40213227	2004-09-01	2004-09-01 00:00:00	2004-09-01	2004-09-01 00:00:00	2004-09-01	581452		0	0	0		0	0	0	88343	0	113	40213227		
26426	576	40213296	2010-08-25	2010-08-25 00:00:00	2010-08-25	2010-08-25 00:00:00	2010-08-25	581452		0	0	0		0	0	0	38144	0	52	40213296		
54787	4550	19133873	1977-09-07	1977-09-07 00:00:00	1977-09-20	1977-09-20 00:00:00	1977-09-20	38000177		0	0	13		0	0	0	303204	0	834061	19133873		
47029	3896	19059056	1985-01-28	1985-01-28 00:00:00	1985-02-18	1985-02-18 00:00:00	1985-02-18	38000177		0	0	21		0	0	0	259185	0	243670	19059056		
38714	3199	1127433	1989-05-08	1989-05-08 00:00:00	1989-05-15	1989-05-15 00:00:00	1989-05-15	38000177		0	0	7		0	0	0	212734	0	313782	1127433		
21913	476	40213227	1999-08-21	1999-08-21 00:00:00	1999-08-21	1999-08-21 00:00:00	1999-08-21	581452		0	0	0		0	0	0	31719	0	113	40213227		
52779	1154	40213296	2012-09-16	2012-09-16 00:00:00	2012-09-16	2012-09-16 00:00:00	2012-09-16	581452		0	0	0		0	0	0	76264	0	52	40213296		
8679	186	40213306	1995-07-03	1995-07-03 00:00:00	1995-07-03	1995-07-03 00:00:00	1995-07-03	581452		0	0	0		0	0	0	\N	0	43	40213306		
10461	871	1118084	2003-12-30	2003-12-30 00:00:00	2003-12-30	2003-12-30 00:00:00	\N	38000177		0	0	0		0	0	0	57959	0	00025152531	44923712		
10526	877	40229134	1998-03-16	1998-03-16 00:00:00	1998-03-30	1998-03-30 00:00:00	1998-03-30	38000177		0	0	14		0	0	0	58461	0	1043400	40229134		
9648	806	1127078	1967-03-06	1967-03-06 00:00:00	1967-03-20	1967-03-20 00:00:00	1967-03-20	38000177		0	0	14		0	0	0	53469	0	282464	1127078		
9655	806	19129655	1962-01-03	1962-01-03 00:00:00	1962-01-17	1962-01-17 00:00:00	1962-01-17	38000177		0	0	14		0	0	0	53512	0	789980	19129655		
34047	2815	1127433	1993-06-12	1993-06-12 00:00:00	1993-06-26	1993-06-26 00:00:00	1993-06-26	38000177		0	0	14		0	0	0	186550	0	313782	1127433		
9747	817	19059056	1972-11-21	1972-11-21 00:00:00	1972-12-26	1972-12-26 00:00:00	1972-12-26	38000177		0	0	35		0	0	0	54109	0	243670	19059056		
9793	820	1713671	1995-02-10	1995-02-10 00:00:00	1995-03-03	1995-03-03 00:00:00	1995-03-03	38000177		0	0	21		0	0	0	54307	0	562251	1713671		
21219	1746	1127078	1963-11-14	1963-11-14 00:00:00	1963-12-05	1963-12-05 00:00:00	1963-12-05	38000177		0	0	21		0	0	0	116763	0	282464	1127078		
27038	2230	1127433	2009-10-05	2009-10-05 00:00:00	2009-11-02	2009-11-02 00:00:00	2009-11-02	38000177		0	0	28		0	0	0	148401	0	313782	1127433		
37532	3103	1124300	2019-01-20	2019-01-20 00:00:00	2019-01-20	2019-01-20 00:00:00	\N	38000177		0	0	0		0	0	0	206440	0	00781178901	45011828		
31815	2636	1127433	1995-12-13	1995-12-13 00:00:00	1995-12-27	1995-12-27 00:00:00	1995-12-27	38000177		0	0	14		0	0	0	174419	0	313782	1127433		
7091	597	1115171	2005-10-11	2005-10-11 00:00:00	2005-11-01	2005-11-01 00:00:00	2005-11-01	38000177		0	0	21		0	0	0	39460	0	849574	1115171		
6215	520	920334	1974-12-17	1974-12-17 00:00:00	1974-12-24	1974-12-24 00:00:00	1974-12-24	38000177		0	0	7		0	0	0	34664	0	311995	920334		
6268	525	19059056	1955-01-03	1955-01-03 00:00:00	1955-01-17	1955-01-17 00:00:00	1955-01-17	38000177		0	0	14		0	0	0	34959	0	243670	19059056		
52957	4401	1713671	1997-02-06	1997-02-06 00:00:00	1997-02-20	1997-02-20 00:00:00	1997-02-20	38000177		0	0	14		0	0	0	292538	0	562251	1713671		
128	9	1115171	2012-12-21	2012-12-21 00:00:00	2013-01-11	2013-01-11 00:00:00	2013-01-11	38000177		0	0	21		0	0	0	866	0	849574	1115171		
17901	1482	1713671	1983-07-09	1983-07-09 00:00:00	1983-10-01	1983-10-01 00:00:00	1983-10-01	38000177		0	0	84		0	0	0	98886	0	562251	1713671		
28403	2342	46233988	1978-09-13	1978-09-13 00:00:00	1978-09-27	1978-09-27 00:00:00	1978-09-27	38000177		0	0	14		0	0	0	155899	0	1652673	46233988		
28462	2346	1127433	1966-04-22	1966-04-22 00:00:00	1966-05-06	1966-05-06 00:00:00	1966-05-06	38000177		0	0	14		0	0	0	156216	0	313782	1127433		
28510	2349	19059056	1973-04-16	1973-04-16 00:00:00	1973-04-30	1973-04-30 00:00:00	1973-04-30	38000177		0	0	14		0	0	0	156357	0	243670	19059056		
52274	4349	19059056	1983-05-01	1983-05-01 00:00:00	1983-05-15	1983-05-15 00:00:00	1983-05-15	38000177		0	0	14		0	0	0	288389	0	243670	19059056		
53957	4484	19006318	1954-06-29	1954-06-29 00:00:00	1954-07-13	1954-07-13 00:00:00	1954-07-13	38000177		0	0	14		0	0	0	298485	0	105078	19006318		
38052	3147	1127433	2014-07-28	2014-07-28 00:00:00	2014-08-18	2014-08-18 00:00:00	2014-08-18	38000177		0	0	21		0	0	0	209429	0	313782	1127433		
59148	4916	1127433	1989-05-06	1989-05-06 00:00:00	1989-05-20	1989-05-20 00:00:00	1989-05-20	38000177		0	0	14		0	0	0	326715	0	313782	1127433		
38172	3158	40236446	1963-08-22	1963-08-22 00:00:00	1967-03-30	1967-03-30 00:00:00	1967-03-30	38000177		0	0	1316		0	0	0	210010	0	1091392	40236446		
34905	2882	19112599	1974-06-02	1974-06-02 00:00:00	1974-06-02	1974-06-02 00:00:00	\N	38000177		0	0	0		0	0	0	191725	0	477045	19112599		
1812	40	40213198	2017-06-21	2017-06-21 00:00:00	2017-06-21	2017-06-21 00:00:00	2017-06-21	581452		0	0	0		0	0	0	2838	0	133	40213198		
13052	1097	19078461	2012-02-24	2012-02-24 00:00:00	2012-03-09	2012-03-09 00:00:00	2012-03-09	38000177		0	0	14		0	0	0	72013	0	310965	19078461		
59279	4927	1127433	2016-12-09	2016-12-09 00:00:00	2016-12-16	2016-12-16 00:00:00	2016-12-16	38000177		0	0	7		0	0	0	327496	0	313782	1127433		
13113	1101	19059056	1979-01-24	1979-01-24 00:00:00	1979-02-07	1979-02-07 00:00:00	1979-02-07	38000177		0	0	14		0	0	0	72361	0	243670	19059056		
40969	3397	19059056	1957-12-06	1957-12-06 00:00:00	1958-02-04	1958-02-04 00:00:00	1958-02-04	38000177		0	0	60		0	0	0	225348	0	243670	19059056		
999	81	19133905	2005-08-09	2005-08-09 00:00:00	2005-08-17	2005-08-17 00:00:00	2005-08-17	38000177		0	0	8		0	0	0	5489	0	834102	19133905		
114195	2509	40213306	1991-06-30	1991-06-30 00:00:00	1991-06-30	1991-06-30 00:00:00	1991-06-30	581452		0	0	0		0	0	0	166078	0	43	40213306		
13971	1169	1127433	1982-01-30	1982-01-30 00:00:00	1982-02-13	1982-02-13 00:00:00	1982-02-13	38000177		0	0	14		0	0	0	76988	0	313782	1127433		
60873	5063	19006318	1947-03-04	1947-03-04 00:00:00	1947-03-18	1947-03-18 00:00:00	1947-03-18	38000177		0	0	14		0	0	0	336618	0	105078	19006318		
14063	1176	19059056	1967-08-24	1967-08-24 00:00:00	1967-09-28	1967-09-28 00:00:00	1967-09-28	38000177		0	0	35		0	0	0	77643	0	243670	19059056		
12680	1068	40236446	1985-09-11	1985-09-11 00:00:00	1991-09-20	1991-09-20 00:00:00	1991-09-20	38000177		0	0	2200		0	0	0	69977	0	1091392	40236446		
24613	2025	19059056	1969-04-05	1969-04-05 00:00:00	1969-04-26	1969-04-26 00:00:00	1969-04-26	38000177		0	0	21		0	0	0	134741	0	243670	19059056		
44912	3717	19074843	1981-03-13	1981-03-13 00:00:00	1981-03-27	1981-03-27 00:00:00	1981-03-27	38000177		0	0	14		0	0	0	247051	0	309045	19074843		
12779	1076	46233988	1976-01-26	1976-01-26 00:00:00	1976-02-09	1976-02-09 00:00:00	1976-02-09	38000177		0	0	14		0	0	0	70568	0	1652673	46233988		
13092	283	40213251	1984-02-06	1984-02-06 00:00:00	1984-02-06	1984-02-06 00:00:00	1984-02-06	581452		0	0	0		0	0	0	18891	0	21	40213251		
16195	1345	19006318	1968-06-19	1968-06-19 00:00:00	1968-07-03	1968-07-03 00:00:00	1968-07-03	38000177		0	0	14		0	0	0	89155	0	105078	19006318		
16233	1348	19059056	1932-12-06	1932-12-06 00:00:00	1932-12-27	1932-12-27 00:00:00	1932-12-27	38000177		0	0	21		0	0	0	89371	0	243670	19059056		
26734	2202	1118084	2011-04-20	2011-04-20 00:00:00	2011-04-20	2011-04-20 00:00:00	\N	38000177		0	0	0		0	0	0	146798	0	00025152531	44923712		
26778	2206	46233988	1976-03-30	1976-03-30 00:00:00	1976-04-13	1976-04-13 00:00:00	1976-04-13	38000177		0	0	14		0	0	0	147053	0	1652673	46233988		
122956	2703	40213314	1978-02-05	1978-02-05 00:00:00	1978-02-05	1978-02-05 00:00:00	1978-02-05	581452		0	0	0		0	0	0	179056	0	49	40213314		
28291	615	40213227	1992-07-25	1992-07-25 00:00:00	1992-07-25	1992-07-25 00:00:00	1992-07-25	581452		0	0	0		0	0	0	40948	0	113	40213227		
60755	5051	19074843	1980-05-12	1980-05-12 00:00:00	1980-05-26	1980-05-26 00:00:00	1980-05-26	38000177		0	0	14		0	0	0	335891	0	309045	19074843		
52057	4329	42902245	2000-02-25	2000-02-25 00:00:00	2001-02-19	2001-02-19 00:00:00	2001-02-19	38000177		0	0	360		0	0	0	287164	0	1359133	42902245		
6836	576	1127433	2013-09-24	2013-09-24 00:00:00	2013-10-08	2013-10-08 00:00:00	2013-10-08	38000177		0	0	14		0	0	0	38131	0	313782	1127433		
6879	578	1551192	1967-12-27	1967-12-27 00:00:00	1967-12-27	1967-12-27 00:00:00	1967-12-27	38000177		0	0	0		0	0	0	38192	0	312617	1551192		
6925	582	1118084	2005-02-05	2005-02-05 00:00:00	2005-02-05	2005-02-05 00:00:00	\N	38000177		0	0	0		0	0	0	38572	0	00025152531	44923712		
61444	5113	19074679	1976-03-06	1976-03-06 00:00:00	1976-07-17	1976-07-17 00:00:00	1976-07-17	38000177		0	0	133		0	0	0	339705	0	308971	19074679		
54261	4509	1127078	1977-01-08	1977-01-08 00:00:00	1977-01-22	1977-01-22 00:00:00	1977-01-22	38000177		0	0	14		0	0	0	300364	0	282464	1127078		
17530	1450	19059056	1966-02-12	1966-02-12 00:00:00	1966-02-26	1966-02-26 00:00:00	1966-02-26	38000177		0	0	14		0	0	0	96743	0	243670	19059056		
26331	573	40213260	2010-11-06	2010-11-06 00:00:00	2010-11-06	2010-11-06 00:00:00	2010-11-06	581452		0	0	0		0	0	0	37948	0	121	40213260		
9131	759	1127433	2015-11-02	2015-11-02 00:00:00	2015-11-23	2015-11-23 00:00:00	2015-11-23	38000177		0	0	21		0	0	0	50363	0	313782	1127433		
26429	576	40213306	1988-11-02	1988-11-02 00:00:00	1988-11-02	1988-11-02 00:00:00	1988-11-02	581452		0	0	0		0	0	0	38141	0	43	40213306		
54788	4550	1713671	1985-04-02	1985-04-02 00:00:00	1985-04-23	1985-04-23 00:00:00	1985-04-23	38000177		0	0	21		0	0	0	303179	0	562251	1713671		
47030	3896	1127078	1978-08-03	1978-08-03 00:00:00	1978-08-17	1978-08-17 00:00:00	1978-08-17	38000177		0	0	14		0	0	0	259170	0	282464	1127078		
38715	3200	40229134	1961-09-03	1961-09-03 00:00:00	1961-09-17	1961-09-17 00:00:00	1961-09-17	38000177		0	0	14		0	0	0	212831	0	1043400	40229134		
21914	476	40213160	1967-12-23	1967-12-23 00:00:00	1967-12-23	1967-12-23 00:00:00	1967-12-23	581452		0	0	0		0	0	0	31756	0	10	40213160		
52781	1154	40213227	2012-09-16	2012-09-16 00:00:00	2012-09-16	2012-09-16 00:00:00	2012-09-16	581452		0	0	0		0	0	0	76264	0	113	40213227		
8680	186	40213160	1972-02-27	1972-02-27 00:00:00	1972-02-27	1972-02-27 00:00:00	1972-02-27	581452		0	0	0		0	0	0	12601	0	10	40213160		
10462	871	19006318	1968-12-03	1968-12-03 00:00:00	1968-12-17	1968-12-17 00:00:00	1968-12-17	38000177		0	0	14		0	0	0	57935	0	105078	19006318		
10527	877	1127433	2017-09-03	2017-09-03 00:00:00	2017-09-24	2017-09-24 00:00:00	2017-09-24	38000177		0	0	21		0	0	0	58443	0	313782	1127433		
9649	806	1115171	2010-01-03	2010-01-03 00:00:00	2010-04-03	2010-04-03 00:00:00	2010-04-03	38000177		0	0	90		0	0	0	53470	0	849574	1115171		
9656	807	19078461	2014-10-15	2014-10-15 00:00:00	2014-11-19	2014-11-19 00:00:00	2014-11-19	38000177		0	0	35		0	0	0	53547	0	310965	19078461		
34048	2815	40162522	1996-01-17	1996-01-17 00:00:00	1996-01-17	1996-01-17 00:00:00	\N	38000177		0	0	0		0	0	0	186532	0	857005	40162522		
9748	817	1713671	1998-12-21	1998-12-21 00:00:00	1999-01-11	1999-01-11 00:00:00	1999-01-11	38000177		0	0	21		0	0	0	54147	0	562251	1713671		
9794	820	1713671	2017-09-21	2017-09-21 00:00:00	2017-09-28	2017-09-28 00:00:00	2017-09-28	38000177		0	0	7		0	0	0	54361	0	562251	1713671		
21220	1746	1127433	2014-07-10	2014-07-10 00:00:00	2014-08-07	2014-08-07 00:00:00	2014-08-07	38000177		0	0	28		0	0	0	116765	0	313782	1127433		
27039	2230	1118084	2009-01-28	2009-01-28 00:00:00	2009-01-28	2009-01-28 00:00:00	\N	38000177		0	0	0		0	0	0	148416	0	00025152531	44923712		
37533	3103	1127433	2015-06-19	2015-06-19 00:00:00	2015-06-26	2015-06-26 00:00:00	2015-06-26	38000177		0	0	7		0	0	0	206452	0	313782	1127433		
31816	2636	19129655	1964-03-25	1964-03-25 00:00:00	1964-04-08	1964-04-08 00:00:00	1964-04-08	38000177		0	0	14		0	0	0	174425	0	789980	19129655		
7092	597	1115171	2001-11-26	2001-11-26 00:00:00	2001-12-31	2001-12-31 00:00:00	2001-12-31	38000177		0	0	35		0	0	0	39459	0	849574	1115171		
6216	520	19133905	1971-07-08	1971-07-08 00:00:00	1971-07-17	1971-07-17 00:00:00	1971-07-17	38000177		0	0	9		0	0	0	34668	0	834102	19133905		
6269	525	19133905	1997-04-03	1997-04-03 00:00:00	1997-04-13	1997-04-13 00:00:00	1997-04-13	38000177		0	0	10		0	0	0	34968	0	834102	19133905		
52958	4401	920300	2005-01-23	2005-01-23 00:00:00	2005-01-30	2005-01-30 00:00:00	2005-01-30	38000177		0	0	7		0	0	0	292592	0	311989	920300		
129	9	1115171	2008-06-10	2008-06-10 00:00:00	2008-06-24	2008-06-24 00:00:00	2008-06-24	38000177		0	0	14		0	0	0	864	0	849574	1115171		
17902	1482	19074841	1993-01-01	1993-01-01 00:00:00	1993-01-15	1993-01-15 00:00:00	1993-01-15	38000177		0	0	14		0	0	0	98846	0	309043	19074841		
28404	2343	19006318	1959-05-28	1959-05-28 00:00:00	1959-06-11	1959-06-11 00:00:00	1959-06-11	38000177		0	0	14		0	0	0	155984	0	105078	19006318		
28463	2346	19059056	1982-08-10	1982-08-10 00:00:00	1982-11-08	1982-11-08 00:00:00	1982-11-08	38000177		0	0	90		0	0	0	156218	0	243670	19059056		
28511	2349	19006318	1973-04-16	1973-04-16 00:00:00	1973-04-30	1973-04-30 00:00:00	1973-04-30	38000177		0	0	14		0	0	0	156357	0	105078	19006318		
52275	4349	19019979	1987-01-10	1987-01-10 00:00:00	1987-01-31	1987-01-31 00:00:00	1987-01-31	38000177		0	0	21		0	0	0	288400	0	198405	19019979		
53958	4484	1127078	1958-01-02	1958-01-02 00:00:00	1958-01-16	1958-01-16 00:00:00	1958-01-16	38000177		0	0	14		0	0	0	298507	0	282464	1127078		
38053	3147	19133873	1953-06-20	1953-06-20 00:00:00	1953-06-28	1953-06-28 00:00:00	1953-06-28	38000177		0	0	8		0	0	0	209357	0	834061	19133873		
59149	4916	1118084	2013-01-06	2013-01-06 00:00:00	2013-01-06	2013-01-06 00:00:00	\N	38000177		0	0	0		0	0	0	326665	0	00025152531	44923712		
38173	3158	1127433	1985-10-20	1985-10-20 00:00:00	1985-11-03	1985-11-03 00:00:00	1985-11-03	38000177		0	0	14		0	0	0	209965	0	313782	1127433		
34906	2882	19128022	1993-04-02	1993-04-02 00:00:00	1994-03-28	1994-03-28 00:00:00	1994-03-28	38000177		0	0	360		0	0	0	191742	0	749785	19128022		
1820	40	40213160	1955-11-09	1955-11-09 00:00:00	1955-11-09	1955-11-09 00:00:00	1955-11-09	581452		0	0	0		0	0	0	2883	0	10	40213160		
13053	1097	1127433	1978-07-10	1978-07-10 00:00:00	1978-07-24	1978-07-24 00:00:00	1978-07-24	38000177		0	0	14		0	0	0	72015	0	313782	1127433		
59280	4927	1118084	2017-06-27	2017-06-27 00:00:00	2017-06-27	2017-06-27 00:00:00	\N	38000177		0	0	0		0	0	0	327496	0	00025152531	44923712		
13114	1101	19073183	1979-01-24	1979-01-24 00:00:00	1979-02-07	1979-02-07 00:00:00	1979-02-07	38000177		0	0	14		0	0	0	72361	0	308182	19073183		
40970	3397	1127433	1961-09-18	1961-09-18 00:00:00	1961-10-02	1961-10-02 00:00:00	1961-10-02	38000177		0	0	14		0	0	0	225335	0	313782	1127433		
1000	82	1127433	2006-03-11	2006-03-11 00:00:00	2006-03-18	2006-03-18 00:00:00	2006-03-18	38000177		0	0	7		0	0	0	5569	0	313782	1127433		
114202	2509	40213296	2011-06-19	2011-06-19 00:00:00	2011-06-19	2011-06-19 00:00:00	2011-06-19	581452		0	0	0		0	0	0	166082	0	52	40213296		
13972	1169	1713671	1956-09-15	1956-09-15 00:00:00	1956-10-06	1956-10-06 00:00:00	1956-10-06	38000177		0	0	21		0	0	0	76960	0	562251	1713671		
60874	5063	40236824	1964-05-07	1964-05-07 00:00:00	1964-05-14	1964-05-14 00:00:00	1964-05-14	38000177		0	0	7		0	0	0	336553	0	1094107	40236824		
14064	1176	40229134	1971-02-06	1971-02-06 00:00:00	1971-02-20	1971-02-20 00:00:00	1971-02-20	38000177		0	0	14		0	0	0	77651	0	1043400	40229134		
12681	1068	40229134	1987-05-05	1987-05-05 00:00:00	1987-05-12	1987-05-12 00:00:00	1987-05-12	38000177		0	0	7		0	0	0	69978	0	1043400	40229134		
24614	2025	40229134	2014-05-16	2014-05-16 00:00:00	2014-05-30	2014-05-30 00:00:00	2014-05-30	38000177		0	0	14		0	0	0	134727	0	1043400	40229134		
44913	3717	1127433	1989-04-10	1989-04-10 00:00:00	1989-04-17	1989-04-17 00:00:00	1989-04-17	38000177		0	0	7		0	0	0	247066	0	313782	1127433		
12780	1076	1127078	1976-01-26	1976-01-26 00:00:00	1976-02-09	1976-02-09 00:00:00	1976-02-09	38000177		0	0	14		0	0	0	70568	0	282464	1127078		
23283	1918	1118084	2004-11-19	2004-11-19 00:00:00	2004-11-19	2004-11-19 00:00:00	\N	38000177		0	0	0		0	0	0	127657	0	00025152531	44923712		
16196	1345	1127433	2015-03-15	2015-03-15 00:00:00	2015-03-29	2015-03-29 00:00:00	2015-03-29	38000177		0	0	14		0	0	0	89168	0	313782	1127433		
16234	1348	19059056	1913-01-20	1913-01-20 00:00:00	1913-02-03	1913-02-03 00:00:00	1913-02-03	38000177		0	0	14		0	0	0	89283	0	243670	19059056		
26735	2202	1127078	1974-01-09	1974-01-09 00:00:00	1974-01-23	1974-01-23 00:00:00	1974-01-23	38000177		0	0	14		0	0	0	146756	0	282464	1127078		
26779	2206	19128065	1994-10-13	1994-10-13 00:00:00	1995-10-08	1995-10-08 00:00:00	1995-10-08	38000177		0	0	360		0	0	0	147001	0	749882	19128065		
122959	2703	40213227	1996-04-07	1996-04-07 00:00:00	1996-04-07	1996-04-07 00:00:00	1996-04-07	581452		0	0	0		0	0	0	179094	0	113	40213227		
28306	615	40213227	2001-09-15	2001-09-15 00:00:00	2001-09-15	2001-09-15 00:00:00	2001-09-15	581452		0	0	0		0	0	0	40992	0	113	40213227		
60756	5051	1127078	1980-05-12	1980-05-12 00:00:00	1980-05-26	1980-05-26 00:00:00	1980-05-26	38000177		0	0	14		0	0	0	335891	0	282464	1127078		
52058	4329	19128065	1992-03-29	1992-03-29 00:00:00	1993-03-24	1993-03-24 00:00:00	1993-03-24	38000177		0	0	360		0	0	0	287080	0	749882	19128065		
6837	576	1115171	1997-04-18	1997-04-18 00:00:00	1997-05-09	1997-05-09 00:00:00	1997-05-09	38000177		0	0	21		0	0	0	38065	0	849574	1115171		
6880	579	1127078	1963-11-07	1963-11-07 00:00:00	1963-11-21	1963-11-21 00:00:00	1963-11-21	38000177		0	0	14		0	0	0	38303	0	282464	1127078		
6926	582	1115171	2016-09-10	2016-09-10 00:00:00	2016-10-10	2016-10-10 00:00:00	2016-10-10	38000177		0	0	30		0	0	0	38557	0	849574	1115171		
61445	5113	1127078	1974-02-15	1974-02-15 00:00:00	1974-03-24	1974-03-24 00:00:00	1974-03-24	38000177		0	0	37		0	0	0	339722	0	282464	1127078		
54262	4509	46233988	1977-01-08	1977-01-08 00:00:00	1977-01-22	1977-01-22 00:00:00	1977-01-22	38000177		0	0	14		0	0	0	300364	0	1652673	46233988		
17531	1450	19006318	1966-02-12	1966-02-12 00:00:00	1966-02-26	1966-02-26 00:00:00	1966-02-26	38000177		0	0	14		0	0	0	96743	0	105078	19006318		
26333	573	40213306	1982-01-02	1982-01-02 00:00:00	1982-01-02	1982-01-02 00:00:00	1982-01-02	581452		0	0	0		0	0	0	37960	0	43	40213306		
9132	759	1127433	1977-01-20	1977-01-20 00:00:00	1977-02-10	1977-02-10 00:00:00	1977-02-10	38000177		0	0	21		0	0	0	50360	0	313782	1127433		
26430	576	40213160	1967-02-08	1967-02-08 00:00:00	1967-02-08	1967-02-08 00:00:00	1967-02-08	581452		0	0	0		0	0	0	38121	0	10	40213160		
54789	4551	1713671	1989-02-04	1989-02-04 00:00:00	1989-02-11	1989-02-11 00:00:00	1989-02-11	38000177		0	0	7		0	0	0	303303	0	562251	1713671		
47031	3896	46233988	1978-08-03	1978-08-03 00:00:00	1978-08-17	1978-08-17 00:00:00	1978-08-17	38000177		0	0	14		0	0	0	259170	0	1652673	46233988		
38717	3200	19133905	1980-01-05	1980-01-05 00:00:00	1980-01-15	1980-01-15 00:00:00	1980-01-15	38000177		0	0	10		0	0	0	212791	0	834102	19133905		
21918	476	40213160	1968-05-25	1968-05-25 00:00:00	1968-05-25	1968-05-25 00:00:00	1968-05-25	581452		0	0	0		0	0	0	31757	0	10	40213160		
52786	1154	40213160	1971-02-14	1971-02-14 00:00:00	1971-02-14	1971-02-14 00:00:00	1971-02-14	581452		0	0	0		0	0	0	76290	0	10	40213160		
8682	186	40213160	1972-07-31	1972-07-31 00:00:00	1972-07-31	1972-07-31 00:00:00	1972-07-31	581452		0	0	0		0	0	0	12639	0	10	40213160		
10463	871	19059056	1968-12-03	1968-12-03 00:00:00	1968-12-17	1968-12-17 00:00:00	1968-12-17	38000177		0	0	14		0	0	0	57935	0	243670	19059056		
10528	877	19128022	1994-04-14	1994-04-14 00:00:00	1995-04-09	1995-04-09 00:00:00	1995-04-09	38000177		0	0	360		0	0	0	58385	0	749785	19128022		
9650	806	1127433	1971-02-17	1971-02-17 00:00:00	1971-03-03	1971-03-03 00:00:00	1971-03-03	38000177		0	0	14		0	0	0	53507	0	313782	1127433		
9657	807	40229134	1973-11-17	1973-11-17 00:00:00	1973-11-24	1973-11-24 00:00:00	1973-11-24	38000177		0	0	7		0	0	0	53624	0	1043400	40229134		
34049	2815	19078461	1996-01-17	1996-01-17 00:00:00	1996-04-16	1996-04-16 00:00:00	1996-04-16	38000177		0	0	90		0	0	0	186532	0	310965	19078461		
9750	817	19006318	1958-09-21	1958-09-21 00:00:00	1958-10-05	1958-10-05 00:00:00	1958-10-05	38000177		0	0	14		0	0	0	54139	0	105078	19006318		
20253	1661	1115171	2018-11-16	2018-11-16 00:00:00	2019-02-14	2019-02-14 00:00:00	2019-02-14	38000177		0	0	90		0	0	0	111657	0	849574	1115171		
21221	1746	1127433	1954-04-08	1954-04-08 00:00:00	1954-04-22	1954-04-22 00:00:00	1954-04-22	38000177		0	0	14		0	0	0	116718	0	313782	1127433		
27040	2230	1127433	1976-09-29	1976-09-29 00:00:00	1976-10-13	1976-10-13 00:00:00	1976-10-13	38000177		0	0	14		0	0	0	148361	0	313782	1127433		
37534	3103	1127078	1982-05-04	1982-05-04 00:00:00	1982-05-18	1982-05-18 00:00:00	1982-05-18	38000177		0	0	14		0	0	0	206453	0	282464	1127078		
31817	2636	19059056	1964-03-25	1964-03-25 00:00:00	1964-04-08	1964-04-08 00:00:00	1964-04-08	38000177		0	0	14		0	0	0	174425	0	243670	19059056		
7093	597	40229134	1993-09-05	1993-09-05 00:00:00	1993-09-19	1993-09-19 00:00:00	1993-09-19	38000177		0	0	14		0	0	0	39424	0	1043400	40229134		
6217	520	19074841	1983-02-19	1983-02-19 00:00:00	1983-03-05	1983-03-05 00:00:00	1983-03-05	38000177		0	0	14		0	0	0	34673	0	309043	19074841		
6270	525	19059056	1965-03-25	1965-03-25 00:00:00	1965-06-23	1965-06-23 00:00:00	1965-06-23	38000177		0	0	90		0	0	0	34960	0	243670	19059056		
75	5	40165015	1990-04-07	1990-04-07 00:00:00	1990-04-07	1990-04-07 00:00:00	\N	38000177		0	0	0		0	0	0	468	0	861467	40165015		
130	9	19133873	1987-08-13	1987-08-13 00:00:00	1987-08-24	1987-08-24 00:00:00	1987-08-24	38000177		0	0	11		0	0	0	813	0	834061	19133873		
17903	1482	1127433	1993-01-01	1993-01-01 00:00:00	1993-01-15	1993-01-15 00:00:00	1993-01-15	38000177		0	0	14		0	0	0	98846	0	313782	1127433		
28405	2343	1127078	1959-05-28	1959-05-28 00:00:00	1959-06-11	1959-06-11 00:00:00	1959-06-11	38000177		0	0	14		0	0	0	155984	0	282464	1127078		
28464	2346	19133873	1958-10-28	1958-10-28 00:00:00	1958-11-05	1958-11-05 00:00:00	1958-11-05	38000177		0	0	8		0	0	0	156126	0	834061	19133873		
28512	2349	19133873	1973-05-07	1973-05-07 00:00:00	1973-05-20	1973-05-20 00:00:00	1973-05-20	38000177		0	0	13		0	0	0	156365	0	834061	19133873		
52276	4349	1118084	2019-05-12	2019-05-12 00:00:00	2019-05-12	2019-05-12 00:00:00	\N	38000177		0	0	0		0	0	0	288430	0	00025152531	44923712		
53959	4484	19006318	1958-01-02	1958-01-02 00:00:00	1958-01-16	1958-01-16 00:00:00	1958-01-16	38000177		0	0	14		0	0	0	298507	0	105078	19006318		
38054	3147	1713671	1947-12-12	1947-12-12 00:00:00	1947-12-19	1947-12-19 00:00:00	1947-12-19	38000177		0	0	7		0	0	0	209339	0	562251	1713671		
59150	4916	19059056	1978-06-24	1978-06-24 00:00:00	1978-07-08	1978-07-08 00:00:00	1978-07-08	38000177		0	0	14		0	0	0	326697	0	243670	19059056		
38174	3158	19059056	1971-09-18	1971-09-18 00:00:00	1971-10-16	1971-10-16 00:00:00	1971-10-16	38000177		0	0	28		0	0	0	209947	0	243670	19059056		
34907	2882	19128022	1990-04-18	1990-04-18 00:00:00	1991-04-13	1991-04-13 00:00:00	1991-04-13	38000177		0	0	360		0	0	0	191740	0	749785	19128022		
52550	4370	1127433	1993-05-17	1993-05-17 00:00:00	1993-05-24	1993-05-24 00:00:00	1993-05-24	38000177		0	0	7		0	0	0	290129	0	313782	1127433		
13055	1097	19133873	1972-09-22	1972-09-22 00:00:00	1972-09-30	1972-09-30 00:00:00	1972-09-30	38000177		0	0	8		0	0	0	72004	0	834061	19133873		
59281	4927	1127078	1983-06-02	1983-06-02 00:00:00	1983-06-16	1983-06-16 00:00:00	1983-06-16	38000177		0	0	14		0	0	0	327439	0	282464	1127078		
23585	1941	1713671	1997-12-27	1997-12-27 00:00:00	1998-01-10	1998-01-10 00:00:00	1998-01-10	38000177		0	0	14		0	0	0	129103	0	562251	1713671		
40971	3397	19133905	2008-10-18	2008-10-18 00:00:00	2008-10-27	2008-10-27 00:00:00	2008-10-27	38000177		0	0	9		0	0	0	225327	0	834102	19133905		
1001	82	1127433	1973-09-14	1973-09-14 00:00:00	1973-11-13	1973-11-13 00:00:00	1973-11-13	38000177		0	0	60		0	0	0	5568	0	313782	1127433		
125485	2760	40213227	2008-08-14	2008-08-14 00:00:00	2008-08-14	2008-08-14 00:00:00	2008-08-14	581452		0	0	0		0	0	0	182578	0	113	40213227		
13973	1169	920334	1989-11-11	1989-11-11 00:00:00	1989-11-18	1989-11-18 00:00:00	1989-11-18	38000177		0	0	7		0	0	0	76963	0	311995	920334		
60875	5063	920300	1964-05-07	1964-05-07 00:00:00	1964-05-14	1964-05-14 00:00:00	1964-05-14	38000177		0	0	7		0	0	0	336553	0	311989	920300		
14065	1176	1551192	1981-09-13	1981-09-13 00:00:00	1981-09-13	1981-09-13 00:00:00	1981-09-13	38000177		0	0	0		0	0	0	77645	0	312617	1551192		
12682	1068	1118084	2014-11-23	2014-11-23 00:00:00	2014-11-23	2014-11-23 00:00:00	\N	38000177		0	0	0		0	0	0	69972	0	00025152531	44923712		
24615	2025	19059056	1965-01-12	1965-01-12 00:00:00	1965-01-26	1965-01-26 00:00:00	1965-01-26	38000177		0	0	14		0	0	0	134739	0	243670	19059056		
44914	3717	1124300	2014-01-19	2014-01-19 00:00:00	2014-01-19	2014-01-19 00:00:00	\N	38000177		0	0	0		0	0	0	247073	0	00781178901	45011828		
12781	1076	19128065	1992-04-11	1992-04-11 00:00:00	1993-04-06	1993-04-06 00:00:00	1993-04-06	38000177		0	0	360		0	0	0	70569	0	749882	19128065		
23284	1918	19133905	1998-01-15	1998-01-15 00:00:00	1998-01-28	1998-01-28 00:00:00	1998-01-28	38000177		0	0	13		0	0	0	127619	0	834102	19133905		
16197	1345	40229134	2001-02-10	2001-02-10 00:00:00	2001-02-17	2001-02-17 00:00:00	2001-02-17	38000177		0	0	7		0	0	0	89161	0	1043400	40229134		
16235	1348	1713671	2001-08-09	2001-08-09 00:00:00	2001-08-30	2001-08-30 00:00:00	2001-08-30	38000177		0	0	21		0	0	0	89307	0	562251	1713671		
26736	2202	40229134	1982-08-26	1982-08-26 00:00:00	1982-09-09	1982-09-09 00:00:00	1982-09-09	38000177		0	0	14		0	0	0	146789	0	1043400	40229134		
26780	2206	19128022	1996-10-02	1996-10-02 00:00:00	1997-09-27	1997-09-27 00:00:00	1997-09-27	38000177		0	0	360		0	0	0	147003	0	749785	19128022		
122960	2703	40213306	1996-04-07	1996-04-07 00:00:00	1996-04-07	1996-04-07 00:00:00	1996-04-07	581452		0	0	0		0	0	0	179094	0	43	40213306		
28326	616	40213227	1993-09-11	1993-09-11 00:00:00	1993-09-11	1993-09-11 00:00:00	1993-09-11	581452		0	0	0		0	0	0	41134	0	113	40213227		
3404	74	40213296	2014-07-16	2014-07-16 00:00:00	2014-07-16	2014-07-16 00:00:00	2014-07-16	581452		0	0	0		0	0	0	4987	0	52	40213296		
52059	4329	1127433	2014-10-19	2014-10-19 00:00:00	2014-12-24	2014-12-24 00:00:00	2014-12-24	38000177		0	0	66		0	0	0	287106	0	313782	1127433		
6838	576	1551192	2000-10-31	2000-10-31 00:00:00	2000-10-31	2000-10-31 00:00:00	2000-10-31	38000177		0	0	0		0	0	0	38088	0	312617	1551192		
6881	579	1127433	1993-08-31	1993-08-31 00:00:00	1993-09-28	1993-09-28 00:00:00	1993-09-28	38000177		0	0	28		0	0	0	38336	0	313782	1127433		
6927	582	19006318	1959-07-02	1959-07-02 00:00:00	1959-07-16	1959-07-16 00:00:00	1959-07-16	38000177		0	0	14		0	0	0	38592	0	105078	19006318		
61447	5113	19133905	2011-07-31	2011-07-31 00:00:00	2011-08-10	2011-08-10 00:00:00	2011-08-10	38000177		0	0	10		0	0	0	339708	0	834102	19133905		
54263	4509	40169281	1993-04-13	1993-04-13 00:00:00	1993-04-13	1993-04-13 00:00:00	\N	38000177		0	0	0		0	0	0	300360	0	896209	40169281		
17532	1450	1124300	1996-03-19	1996-03-19 00:00:00	1996-03-19	1996-03-19 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00781178901	45011828		
26339	573	40213260	2009-10-31	2009-10-31 00:00:00	2009-10-31	2009-10-31 00:00:00	2009-10-31	581452		0	0	0		0	0	0	37963	0	121	40213260		
9133	759	1127433	1992-09-19	1992-09-19 00:00:00	1992-10-03	1992-10-03 00:00:00	1992-10-03	38000177		0	0	14		0	0	0	50361	0	313782	1127433		
26437	576	40213160	1971-08-11	1971-08-11 00:00:00	1971-08-11	1971-08-11 00:00:00	1971-08-11	581452		0	0	0		0	0	0	38123	0	10	40213160		
54790	4551	1118084	2015-10-09	2015-10-09 00:00:00	2015-10-09	2015-10-09 00:00:00	\N	38000177		0	0	0		0	0	0	303324	0	00025152531	44923712		
47032	3896	19133873	1987-02-21	1987-02-21 00:00:00	1987-03-02	1987-03-02 00:00:00	1987-03-02	38000177		0	0	9		0	0	0	259187	0	834061	19133873		
38718	3200	1127433	2012-03-13	2012-03-13 00:00:00	2012-03-27	2012-03-27 00:00:00	2012-03-27	38000177		0	0	14		0	0	0	212824	0	313782	1127433		
21924	476	40213227	2018-09-22	2018-09-22 00:00:00	2018-09-22	2018-09-22 00:00:00	2018-09-22	581452		0	0	0		0	0	0	31734	0	113	40213227		
52793	1154	40213227	2002-05-19	2002-05-19 00:00:00	2002-05-19	2002-05-19 00:00:00	2002-05-19	581452		0	0	0		0	0	0	76261	0	113	40213227		
8683	186	40213227	2004-12-05	2004-12-05 00:00:00	2004-12-05	2004-12-05 00:00:00	2004-12-05	581452		0	0	0		0	0	0	12664	0	113	40213227		
10464	871	1713671	2014-09-28	2014-09-28 00:00:00	2014-10-19	2014-10-19 00:00:00	2014-10-19	38000177		0	0	21		0	0	0	57943	0	562251	1713671		
32311	2679	1127078	1976-12-05	1976-12-05 00:00:00	1977-01-04	1977-01-04 00:00:00	1977-01-04	38000177		0	0	30		0	0	0	177460	0	282464	1127078		
9651	806	1124300	1997-12-05	1997-12-05 00:00:00	1997-12-05	1997-12-05 00:00:00	\N	38000177		0	0	0		0	0	0	53497	0	00781178901	45011828		
9658	807	1127433	1965-10-27	1965-10-27 00:00:00	1965-11-10	1965-11-10 00:00:00	1965-11-10	38000177		0	0	14		0	0	0	53634	0	313782	1127433		
34050	2815	1713671	2006-09-14	2006-09-14 00:00:00	2006-09-28	2006-09-28 00:00:00	2006-09-28	38000177		0	0	14		0	0	0	186557	0	562251	1713671		
9751	817	19059056	1958-09-21	1958-09-21 00:00:00	1958-10-05	1958-10-05 00:00:00	1958-10-05	38000177		0	0	14		0	0	0	54139	0	243670	19059056		
20254	1661	19059056	1993-06-02	1993-06-02 00:00:00	1993-06-16	1993-06-16 00:00:00	1993-06-16	38000177		0	0	14		0	0	0	111655	0	243670	19059056		
21232	1748	1127433	1964-10-08	1964-10-08 00:00:00	1964-10-22	1964-10-22 00:00:00	1964-10-22	38000177		0	0	14		0	0	0	116921	0	313782	1127433		
27041	2230	40229134	2002-04-16	2002-04-16 00:00:00	2002-04-30	2002-04-30 00:00:00	2002-04-30	38000177		0	0	14		0	0	0	148404	0	1043400	40229134		
37535	3103	19073183	1982-05-04	1982-05-04 00:00:00	1982-05-18	1982-05-18 00:00:00	1982-05-18	38000177		0	0	14		0	0	0	206453	0	308182	19073183		
64125	5325	19059056	1952-01-05	1952-01-05 00:00:00	1952-01-26	1952-01-26 00:00:00	1952-01-26	38000177		0	0	21		0	0	0	354436	0	243670	19059056		
7094	597	19073188	2012-07-27	2012-07-27 00:00:00	2012-08-17	2012-08-17 00:00:00	2012-08-17	38000177		0	0	21		0	0	0	39461	0	308192	19073188		
6218	520	19059056	1983-02-19	1983-02-19 00:00:00	1983-03-05	1983-03-05 00:00:00	1983-03-05	38000177		0	0	14		0	0	0	34673	0	243670	19059056		
6272	525	19133873	1952-12-18	1952-12-18 00:00:00	1952-12-31	1952-12-31 00:00:00	1952-12-31	38000177		0	0	13		0	0	0	34965	0	834061	19133873		
76	5	40229134	2012-02-10	2012-02-10 00:00:00	2012-02-17	2012-02-17 00:00:00	2012-02-17	38000177		0	0	7		0	0	0	508	0	1043400	40229134		
131	9	40232448	1979-01-30	1979-01-30 00:00:00	1979-01-30	1979-01-30 00:00:00	\N	38000177		0	0	0		0	0	0	707	0	1049630	40232448		
17904	1482	19006318	1976-10-19	1976-10-19 00:00:00	1976-11-02	1976-11-02 00:00:00	1976-11-02	38000177		0	0	14		0	0	0	98845	0	105078	19006318		
28406	2343	1127078	1958-09-30	1958-09-30 00:00:00	1958-11-04	1958-11-04 00:00:00	1958-11-04	38000177		0	0	35		0	0	0	155980	0	282464	1127078		
28465	2346	1127433	1953-09-26	1953-09-26 00:00:00	1953-10-10	1953-10-10 00:00:00	1953-10-10	38000177		0	0	14		0	0	0	156149	0	313782	1127433		
28513	2349	1127078	1972-10-06	1972-10-06 00:00:00	1972-10-20	1972-10-20 00:00:00	1972-10-20	38000177		0	0	14		0	0	0	156453	0	282464	1127078		
52277	4349	19019979	1991-02-09	1991-02-09 00:00:00	1991-03-09	1991-03-09 00:00:00	1991-03-09	38000177		0	0	28		0	0	0	288402	0	198405	19019979		
53960	4484	1127433	1976-09-11	1976-09-11 00:00:00	1976-09-25	1976-09-25 00:00:00	1976-09-25	38000177		0	0	14		0	0	0	298460	0	313782	1127433		
38055	3147	1713671	1998-02-20	1998-02-20 00:00:00	1998-02-27	1998-02-27 00:00:00	1998-02-27	38000177		0	0	7		0	0	0	209432	0	562251	1713671		
59151	4916	40229134	1977-08-30	1977-08-30 00:00:00	1977-09-06	1977-09-06 00:00:00	1977-09-06	38000177		0	0	7		0	0	0	326687	0	1043400	40229134		
38175	3158	19133905	1986-02-25	1986-02-25 00:00:00	1986-03-09	1986-03-09 00:00:00	1986-03-09	38000177		0	0	12		0	0	0	209917	0	834102	19133905		
34908	2882	19128022	1992-04-07	1992-04-07 00:00:00	1993-04-02	1993-04-02 00:00:00	1993-04-02	38000177		0	0	360		0	0	0	191741	0	749785	19128022		
52551	4370	19059056	1966-10-06	1966-10-06 00:00:00	1966-10-27	1966-10-27 00:00:00	1966-10-27	38000177		0	0	21		0	0	0	290119	0	243670	19059056		
13056	1097	1127433	2001-12-28	2001-12-28 00:00:00	2002-01-04	2002-01-04 00:00:00	2002-01-04	38000177		0	0	7		0	0	0	71969	0	313782	1127433		
59282	4927	19075001	1983-06-02	1983-06-02 00:00:00	1983-06-16	1983-06-16 00:00:00	1983-06-16	38000177		0	0	14		0	0	0	327439	0	309097	19075001		
23586	1941	40229134	1995-03-13	1995-03-13 00:00:00	1995-03-27	1995-03-27 00:00:00	1995-03-27	38000177		0	0	14		0	0	0	129037	0	1043400	40229134		
40972	3397	40229134	1980-07-05	1980-07-05 00:00:00	1980-07-12	1980-07-12 00:00:00	1980-07-12	38000177		0	0	7		0	0	0	225325	0	1043400	40229134		
1002	82	1127433	2004-04-05	2004-04-05 00:00:00	2004-04-19	2004-04-19 00:00:00	2004-04-19	38000177		0	0	14		0	0	0	5539	0	313782	1127433		
125486	2760	40213260	2008-08-14	2008-08-14 00:00:00	2008-08-14	2008-08-14 00:00:00	2008-08-14	581452		0	0	0		0	0	0	182578	0	121	40213260		
13974	1169	46233710	1971-05-18	1971-05-18 00:00:00	1971-06-22	1971-06-22 00:00:00	1971-06-22	38000177		0	0	35		0	0	0	76986	0	1650142	46233710		
60877	5063	1127433	1985-08-11	1985-08-11 00:00:00	1985-08-18	1985-08-18 00:00:00	1985-08-18	38000177		0	0	7		0	0	0	336634	0	313782	1127433		
14066	1176	1551192	1963-10-14	1963-10-14 00:00:00	1963-10-14	1963-10-14 00:00:00	1963-10-14	38000177		0	0	0		0	0	0	77642	0	312617	1551192		
12683	1068	19073188	2011-12-24	2011-12-24 00:00:00	2012-01-07	2012-01-07 00:00:00	2012-01-07	38000177		0	0	14		0	0	0	69990	0	308192	19073188		
24616	2025	19133873	1921-03-29	1921-03-29 00:00:00	1921-04-06	1921-04-06 00:00:00	1921-04-06	38000177		0	0	8		0	0	0	134770	0	834061	19133873		
44915	3717	1127433	1989-11-14	1989-11-14 00:00:00	1989-11-21	1989-11-21 00:00:00	1989-11-21	38000177		0	0	7		0	0	0	247078	0	313782	1127433		
12782	1076	19128022	2001-02-23	2001-02-23 00:00:00	2002-02-18	2002-02-18 00:00:00	2002-02-18	38000177		0	0	360		0	0	0	70532	0	749785	19128022		
23285	1918	19133873	1976-05-02	1976-05-02 00:00:00	1976-05-09	1976-05-09 00:00:00	1976-05-09	38000177		0	0	7		0	0	0	127575	0	834061	19133873		
16198	1345	19059056	1977-09-13	1977-09-13 00:00:00	1977-10-13	1977-10-13 00:00:00	1977-10-13	38000177		0	0	30		0	0	0	89171	0	243670	19059056		
16236	1348	1124300	1954-03-06	1954-03-06 00:00:00	1954-03-06	1954-03-06 00:00:00	\N	38000177		0	0	0		0	0	0	89348	0	00781178901	45011828		
26747	2204	1713671	1972-02-17	1972-02-17 00:00:00	1972-02-24	1972-02-24 00:00:00	1972-02-24	38000177		0	0	7		0	0	0	146876	0	562251	1713671		
26781	2206	1118084	2008-03-13	2008-03-13 00:00:00	2008-03-13	2008-03-13 00:00:00	\N	38000177		0	0	0		0	0	0	146998	0	00025152531	44923712		
122962	2703	40213160	1978-08-20	1978-08-20 00:00:00	1978-08-20	1978-08-20 00:00:00	1978-08-20	581452		0	0	0		0	0	0	179057	0	10	40213160		
28328	616	40213260	2009-01-03	2009-01-03 00:00:00	2009-01-03	2009-01-03 00:00:00	2009-01-03	581452		0	0	0		0	0	0	41107	0	121	40213260		
3406	74	40213227	2014-07-16	2014-07-16 00:00:00	2014-07-16	2014-07-16 00:00:00	2014-07-16	581452		0	0	0		0	0	0	4987	0	113	40213227		
52060	4329	46233988	1978-11-28	1978-11-28 00:00:00	1978-12-12	1978-12-12 00:00:00	1978-12-12	38000177		0	0	14		0	0	0	287127	0	1652673	46233988		
6839	576	1115171	1999-06-28	1999-06-28 00:00:00	1999-07-12	1999-07-12 00:00:00	1999-07-12	38000177		0	0	14		0	0	0	38087	0	849574	1115171		
6882	579	19133873	1970-06-02	1970-06-02 00:00:00	1970-06-10	1970-06-10 00:00:00	1970-06-10	38000177		0	0	8		0	0	0	38356	0	834061	19133873		
6928	582	19059056	1959-07-02	1959-07-02 00:00:00	1959-07-16	1959-07-16 00:00:00	1959-07-16	38000177		0	0	14		0	0	0	38592	0	243670	19059056		
61449	5113	1127433	1986-01-02	1986-01-02 00:00:00	1986-02-01	1986-02-01 00:00:00	1986-02-01	38000177		0	0	30		0	0	0	339727	0	313782	1127433		
54264	4509	1713671	1978-02-07	1978-02-07 00:00:00	1978-02-21	1978-02-21 00:00:00	1978-02-21	38000177		0	0	14		0	0	0	300374	0	562251	1713671		
17533	1450	1127078	1963-10-09	1963-10-09 00:00:00	1963-10-23	1963-10-23 00:00:00	1963-10-23	38000177		0	0	14		0	0	0	96726	0	282464	1127078		
222087	4874	40213160	1969-04-12	1969-04-12 00:00:00	1969-04-12	1969-04-12 00:00:00	1969-04-12	581452		0	0	0		0	0	0	324210	0	10	40213160		
9134	759	1127433	2017-09-07	2017-09-07 00:00:00	2017-09-21	2017-09-21 00:00:00	2017-09-21	38000177		0	0	14		0	0	0	50395	0	313782	1127433		
26444	576	40213227	2000-08-09	2000-08-09 00:00:00	2000-08-09	2000-08-09 00:00:00	2000-08-09	581452		0	0	0		0	0	0	38128	0	113	40213227		
54791	4551	1127433	2016-07-20	2016-07-20 00:00:00	2016-07-27	2016-07-27 00:00:00	2016-07-27	38000177		0	0	7		0	0	0	303289	0	313782	1127433		
47033	3896	19133873	1988-03-28	1988-03-28 00:00:00	1988-04-05	1988-04-05 00:00:00	1988-04-05	38000177		0	0	8		0	0	0	259139	0	834061	19133873		
38721	3200	19133873	1951-02-12	1951-02-12 00:00:00	1951-02-21	1951-02-21 00:00:00	1951-02-21	38000177		0	0	9		0	0	0	212830	0	834061	19133873		
21925	476	40213260	2018-09-22	2018-09-22 00:00:00	2018-09-22	2018-09-22 00:00:00	2018-09-22	581452		0	0	0		0	0	0	31734	0	121	40213260		
19853	1632	19059056	1976-10-09	1976-10-09 00:00:00	1976-11-05	1976-11-05 00:00:00	1976-11-05	38000177		0	0	27		0	0	0	109550	0	243670	19059056		
8687	186	40213227	2012-12-02	2012-12-02 00:00:00	2012-12-02	2012-12-02 00:00:00	2012-12-02	581452		0	0	0		0	0	0	12653	0	113	40213227		
10465	871	1127078	1975-10-28	1975-10-28 00:00:00	1975-11-11	1975-11-11 00:00:00	1975-11-11	38000177		0	0	14		0	0	0	57956	0	282464	1127078		
32312	2680	1127433	1978-12-18	1978-12-18 00:00:00	1979-01-01	1979-01-01 00:00:00	1979-01-01	38000177		0	0	14		0	0	0	177560	0	313782	1127433		
9652	806	1115171	2012-03-23	2012-03-23 00:00:00	2012-04-27	2012-04-27 00:00:00	2012-04-27	38000177		0	0	35		0	0	0	53471	0	849574	1115171		
9659	807	19133905	1981-10-25	1981-10-25 00:00:00	1981-11-05	1981-11-05 00:00:00	1981-11-05	38000177		0	0	11		0	0	0	53567	0	834102	19133905		
34051	2815	1127433	2002-03-23	2002-03-23 00:00:00	2002-04-06	2002-04-06 00:00:00	2002-04-06	38000177		0	0	14		0	0	0	186556	0	313782	1127433		
9752	817	1124300	1999-07-20	1999-07-20 00:00:00	1999-07-20	1999-07-20 00:00:00	\N	38000177		0	0	0		0	0	0	54177	0	00781178901	45011828		
20255	1661	19078461	2018-01-06	2018-01-06 00:00:00	2018-01-20	2018-01-20 00:00:00	2018-01-20	38000177		0	0	14		0	0	0	111656	0	310965	19078461		
21233	1748	1127433	1989-07-03	1989-07-03 00:00:00	1989-08-09	1989-08-09 00:00:00	1989-08-09	38000177		0	0	37		0	0	0	116870	0	313782	1127433		
27042	2230	46233988	1976-05-01	1976-05-01 00:00:00	1976-05-15	1976-05-15 00:00:00	1976-05-15	38000177		0	0	14		0	0	0	148406	0	1652673	46233988		
37536	3103	40229134	1984-10-08	1984-10-08 00:00:00	1984-10-22	1984-10-22 00:00:00	1984-10-22	38000177		0	0	14		0	0	0	206446	0	1043400	40229134		
64126	5325	19078461	2008-11-18	2008-11-18 00:00:00	2008-12-02	2008-12-02 00:00:00	2008-12-02	38000177		0	0	14		0	0	0	354462	0	310965	19078461		
7095	597	19078461	2012-07-27	2012-07-27 00:00:00	2012-08-17	2012-08-17 00:00:00	2012-08-17	38000177		0	0	21		0	0	0	39461	0	310965	19078461		
6219	520	1127433	1958-03-04	1958-03-04 00:00:00	1958-03-11	1958-03-11 00:00:00	1958-03-11	38000177		0	0	7		0	0	0	34666	0	313782	1127433		
6273	525	1127078	1950-03-30	1950-03-30 00:00:00	1950-04-13	1950-04-13 00:00:00	1950-04-13	38000177		0	0	14		0	0	0	34975	0	282464	1127078		
77	5	40229134	2003-09-10	2003-09-10 00:00:00	2003-09-17	2003-09-17 00:00:00	2003-09-17	38000177		0	0	7		0	0	0	506	0	1043400	40229134		
132	9	19078461	2011-01-10	2011-01-10 00:00:00	2011-01-31	2011-01-31 00:00:00	2011-01-31	38000177		0	0	21		0	0	0	865	0	310965	19078461		
17905	1482	1127078	1976-10-19	1976-10-19 00:00:00	1976-11-02	1976-11-02 00:00:00	1976-11-02	38000177		0	0	14		0	0	0	98845	0	282464	1127078		
28407	2343	1127433	1970-06-30	1970-06-30 00:00:00	1970-07-14	1970-07-14 00:00:00	1970-07-14	38000177		0	0	14		0	0	0	155949	0	313782	1127433		
28466	2346	19059056	1949-09-01	1949-09-01 00:00:00	1949-09-15	1949-09-15 00:00:00	1949-09-15	38000177		0	0	14		0	0	0	156156	0	243670	19059056		
28514	2349	19006318	1972-10-06	1972-10-06 00:00:00	1972-10-20	1972-10-20 00:00:00	1972-10-20	38000177		0	0	14		0	0	0	156453	0	105078	19006318		
62749	5215	40243436	1960-07-11	1960-07-11 00:00:00	1960-07-11	1960-07-11 00:00:00	1960-07-11	38000177		0	0	0		0	0	0	346837	0	1190795	40243436		
53961	4484	19059056	1966-09-24	1966-09-24 00:00:00	1966-10-29	1966-10-29 00:00:00	1966-10-29	38000177		0	0	35		0	0	0	298467	0	243670	19059056		
38056	3147	1713671	1973-02-02	1973-02-02 00:00:00	1973-02-23	1973-02-23 00:00:00	1973-02-23	38000177		0	0	21		0	0	0	209430	0	562251	1713671		
59152	4916	1127433	1990-03-07	1990-03-07 00:00:00	1990-04-06	1990-04-06 00:00:00	1990-04-06	38000177		0	0	30		0	0	0	326698	0	313782	1127433		
38176	3158	1127433	1977-04-01	1977-04-01 00:00:00	1977-06-30	1977-06-30 00:00:00	1977-06-30	38000177		0	0	90		0	0	0	209949	0	313782	1127433		
34909	2882	19128022	1989-04-23	1989-04-23 00:00:00	1990-04-18	1990-04-18 00:00:00	1990-04-18	38000177		0	0	360		0	0	0	191702	0	749785	19128022		
52552	4370	1127078	1964-09-18	1964-09-18 00:00:00	1964-10-16	1964-10-16 00:00:00	1964-10-16	38000177		0	0	28		0	0	0	290118	0	282464	1127078		
13057	1097	1127078	1976-06-18	1976-06-18 00:00:00	1976-07-02	1976-07-02 00:00:00	1976-07-02	38000177		0	0	14		0	0	0	72012	0	282464	1127078		
59283	4927	42902245	2002-05-22	2002-05-22 00:00:00	2003-05-17	2003-05-17 00:00:00	2003-05-17	38000177		0	0	360		0	0	0	327535	0	1359133	42902245		
23587	1941	1127078	1975-05-14	1975-05-14 00:00:00	1975-05-28	1975-05-28 00:00:00	1975-05-28	38000177		0	0	14		0	0	0	129105	0	282464	1127078		
40973	3397	1127433	2010-01-08	2010-01-08 00:00:00	2010-01-22	2010-01-22 00:00:00	2010-01-22	38000177		0	0	14		0	0	0	225313	0	313782	1127433		
27527	600	40213227	2005-05-25	2005-05-25 00:00:00	2005-05-25	2005-05-25 00:00:00	2005-05-25	581452		0	0	0		0	0	0	39598	0	113	40213227		
125487	2760	40213160	1957-12-05	1957-12-05 00:00:00	1957-12-05	1957-12-05 00:00:00	1957-12-05	581452		0	0	0		0	0	0	182602	0	10	40213160		
13975	1169	19059056	1971-05-18	1971-05-18 00:00:00	1971-06-22	1971-06-22 00:00:00	1971-06-22	38000177		0	0	35		0	0	0	76986	0	243670	19059056		
60878	5063	1127433	2000-05-19	2000-05-19 00:00:00	2000-06-02	2000-06-02 00:00:00	2000-06-02	38000177		0	0	14		0	0	0	336636	0	313782	1127433		
14067	1176	1127433	1976-05-13	1976-05-13 00:00:00	1976-06-17	1976-06-17 00:00:00	1976-06-17	38000177		0	0	35		0	0	0	77644	0	313782	1127433		
12684	1068	1115171	2011-12-24	2011-12-24 00:00:00	2012-01-07	2012-01-07 00:00:00	2012-01-07	38000177		0	0	14		0	0	0	69990	0	849574	1115171		
24617	2025	1127433	1965-10-30	1965-10-30 00:00:00	1965-11-13	1965-11-13 00:00:00	1965-11-13	38000177		0	0	14		0	0	0	134692	0	313782	1127433		
44916	3717	1127433	2008-10-31	2008-10-31 00:00:00	2008-11-28	2008-11-28 00:00:00	2008-11-28	38000177		0	0	28		0	0	0	246970	0	313782	1127433		
23241	1915	19078461	2001-12-13	2001-12-13 00:00:00	2001-12-27	2001-12-27 00:00:00	2001-12-27	38000177		0	0	14		0	0	0	127405	0	310965	19078461		
23286	1918	1127078	1980-04-28	1980-04-28 00:00:00	1980-05-12	1980-05-12 00:00:00	1980-05-12	38000177		0	0	14		0	0	0	127583	0	282464	1127078		
16199	1345	19019273	2005-03-05	2005-03-05 00:00:00	2009-06-12	2009-06-12 00:00:00	2009-06-12	38000177		0	0	1560		0	0	0	89106	0	198014	19019273		
16237	1348	19059056	1919-09-16	1919-09-16 00:00:00	1919-11-15	1919-11-15 00:00:00	1919-11-15	38000177		0	0	60		0	0	0	89301	0	243670	19059056		
26748	2204	19133873	1950-07-03	1950-07-03 00:00:00	1950-07-15	1950-07-15 00:00:00	1950-07-15	38000177		0	0	12		0	0	0	146902	0	834061	19133873		
26782	2206	19128022	1999-09-17	1999-09-17 00:00:00	2000-09-11	2000-09-11 00:00:00	2000-09-11	38000177		0	0	360		0	0	0	147006	0	749785	19128022		
122964	2703	40213314	1977-08-07	1977-08-07 00:00:00	1977-08-07	1977-08-07 00:00:00	1977-08-07	581452		0	0	0		0	0	0	179073	0	49	40213314		
60705	5048	1127433	1993-08-03	1993-08-03 00:00:00	1993-08-24	1993-08-24 00:00:00	1993-08-24	38000177		0	0	21		0	0	0	335503	0	313782	1127433		
3408	74	40213160	1976-10-13	1976-10-13 00:00:00	1976-10-13	1976-10-13 00:00:00	1976-10-13	581452		0	0	0		0	0	0	4977	0	10	40213160		
52061	4329	19019979	1978-11-28	1978-11-28 00:00:00	1978-12-12	1978-12-12 00:00:00	1978-12-12	38000177		0	0	14		0	0	0	287127	0	198405	19019979		
6840	576	1713671	1991-12-27	1991-12-27 00:00:00	1992-01-03	1992-01-03 00:00:00	1992-01-03	38000177		0	0	7		0	0	0	38100	0	562251	1713671		
6883	579	19078461	2005-10-28	2005-10-28 00:00:00	2005-12-02	2005-12-02 00:00:00	2005-12-02	38000177		0	0	35		0	0	0	38339	0	310965	19078461		
6929	582	1127433	2008-03-23	2008-03-23 00:00:00	2008-03-30	2008-03-30 00:00:00	2008-03-30	38000177		0	0	7		0	0	0	38582	0	313782	1127433		
61450	5113	19078461	1999-11-20	1999-11-20 00:00:00	1999-12-18	1999-12-18 00:00:00	1999-12-18	38000177		0	0	28		0	0	0	339728	0	310965	19078461		
54265	4509	1127433	1970-04-16	1970-04-16 00:00:00	1970-04-23	1970-04-23 00:00:00	1970-04-23	38000177		0	0	7		0	0	0	300383	0	313782	1127433		
17534	1450	19129655	1963-10-09	1963-10-09 00:00:00	1963-10-23	1963-10-23 00:00:00	1963-10-23	38000177		0	0	14		0	0	0	96726	0	789980	19129655		
222092	4874	40213160	1968-11-09	1968-11-09 00:00:00	1968-11-09	1968-11-09 00:00:00	1968-11-09	581452		0	0	0		0	0	0	324209	0	10	40213160		
9135	759	1118084	1980-06-13	1980-06-13 00:00:00	1980-06-13	1980-06-13 00:00:00	\N	38000177		0	0	0		0	0	0	50453	0	00025152531	44923712		
26449	576	40213160	1967-05-10	1967-05-10 00:00:00	1967-05-10	1967-05-10 00:00:00	1967-05-10	581452		0	0	0		0	0	0	38116	0	10	40213160		
54792	4551	1127078	1980-09-15	1980-09-15 00:00:00	1980-09-29	1980-09-29 00:00:00	1980-09-29	38000177		0	0	14		0	0	0	303291	0	282464	1127078		
47034	3896	1124300	2018-11-11	2018-11-11 00:00:00	2018-11-11	2018-11-11 00:00:00	\N	38000177		0	0	0		0	0	0	259193	0	00781178901	45011828		
38723	3200	1118084	1985-01-29	1985-01-29 00:00:00	1985-01-29	1985-01-29 00:00:00	\N	38000177		0	0	0		0	0	0	212803	0	00025152531	44923712		
21928	476	40213260	2017-09-16	2017-09-16 00:00:00	2017-09-16	2017-09-16 00:00:00	2017-09-16	581452		0	0	0		0	0	0	31728	0	121	40213260		
19855	1632	1310034	1988-11-13	1988-11-13 00:00:00	1988-11-14	1988-11-14 00:00:00	1988-11-14	38000177		0	0	1		0	0	0	109551	0	834357	1310034		
8688	186	40213296	2012-12-02	2012-12-02 00:00:00	2012-12-02	2012-12-02 00:00:00	2012-12-02	581452		0	0	0		0	0	0	12653	0	52	40213296		
10466	871	19078461	2001-10-25	2001-10-25 00:00:00	2001-11-24	2001-11-24 00:00:00	2001-11-24	38000177		0	0	30		0	0	0	57958	0	310965	19078461		
32313	2680	40165015	1986-02-15	1986-02-15 00:00:00	1986-02-15	1986-02-15 00:00:00	\N	38000177		0	0	0		0	0	0	177515	0	861467	40165015		
30485	2528	19075001	1991-10-16	1991-10-16 00:00:00	1991-10-30	1991-10-30 00:00:00	1991-10-30	38000177		0	0	14		0	0	0	167141	0	309097	19075001		
9660	807	1127433	1991-10-25	1991-10-25 00:00:00	1991-12-24	1991-12-24 00:00:00	1991-12-24	38000177		0	0	60		0	0	0	53545	0	313782	1127433		
34053	2815	1118084	1998-12-24	1998-12-24 00:00:00	1998-12-24	1998-12-24 00:00:00	\N	38000177		0	0	0		0	0	0	186519	0	00025152531	44923712		
9753	817	19006318	1958-02-10	1958-02-10 00:00:00	1958-02-24	1958-02-24 00:00:00	1958-02-24	38000177		0	0	14		0	0	0	54152	0	105078	19006318		
20256	1661	1127433	2017-03-31	2017-03-31 00:00:00	2017-04-14	2017-04-14 00:00:00	2017-04-14	38000177		0	0	14		0	0	0	111694	0	313782	1127433		
21234	1748	1127433	2006-02-21	2006-02-21 00:00:00	2006-02-28	2006-02-28 00:00:00	2006-02-28	38000177		0	0	7		0	0	0	116927	0	313782	1127433		
27043	2230	1127078	1976-05-01	1976-05-01 00:00:00	1976-05-15	1976-05-15 00:00:00	1976-05-15	38000177		0	0	14		0	0	0	148406	0	282464	1127078		
37537	3103	19075601	2018-05-16	2018-05-16 00:00:00	2018-05-16	2018-05-16 00:00:00	2018-05-16	38000177		0	0	0		0	0	0	206438	0	309362	19075601		
64127	5325	1127433	1991-11-22	1991-11-22 00:00:00	1991-11-29	1991-11-29 00:00:00	1991-11-29	38000177		0	0	7		0	0	0	354447	0	313782	1127433		
7096	597	40162522	2012-07-27	2012-07-27 00:00:00	2012-07-27	2012-07-27 00:00:00	\N	38000177		0	0	0		0	0	0	39461	0	857005	40162522		
6220	520	19078461	2001-12-15	2001-12-15 00:00:00	2001-12-29	2001-12-29 00:00:00	2001-12-29	38000177		0	0	14		0	0	0	34747	0	310965	19078461		
6274	525	19006318	1950-03-30	1950-03-30 00:00:00	1950-04-13	1950-04-13 00:00:00	1950-04-13	38000177		0	0	14		0	0	0	34975	0	105078	19006318		
78	5	19059056	1990-03-31	1990-03-31 00:00:00	1990-06-06	1990-06-06 00:00:00	1990-06-06	38000177		0	0	67		0	0	0	492	0	243670	19059056		
133	9	19128022	1994-07-06	1994-07-06 00:00:00	1995-07-01	1995-07-01 00:00:00	1995-07-01	38000177		0	0	360		0	0	0	828	0	749785	19128022		
17906	1482	1127433	1986-09-17	1986-09-17 00:00:00	1986-09-24	1986-09-24 00:00:00	1986-09-24	38000177		0	0	7		0	0	0	98896	0	313782	1127433		
28408	2343	1713671	2006-08-05	2006-08-05 00:00:00	2006-08-26	2006-08-26 00:00:00	2006-08-26	38000177		0	0	21		0	0	0	155973	0	562251	1713671		
28467	2346	19006318	1949-09-01	1949-09-01 00:00:00	1949-09-15	1949-09-15 00:00:00	1949-09-15	38000177		0	0	14		0	0	0	156156	0	105078	19006318		
28515	2349	1115171	1994-05-03	1994-05-03 00:00:00	1994-05-17	1994-05-17 00:00:00	1994-05-17	38000177		0	0	14		0	0	0	156413	0	849574	1115171		
31315	2596	1127433	1978-04-14	1978-04-14 00:00:00	1978-04-28	1978-04-28 00:00:00	1978-04-28	38000177		0	0	14		0	0	0	171768	0	313782	1127433		
53962	4484	1118084	1986-07-26	1986-07-26 00:00:00	1986-07-26	1986-07-26 00:00:00	\N	38000177		0	0	0		0	0	0	298514	0	00025152531	44923712		
38057	3147	1127433	2008-06-18	2008-06-18 00:00:00	2008-07-02	2008-07-02 00:00:00	2008-07-02	38000177		0	0	14		0	0	0	209396	0	313782	1127433		
59153	4916	19133905	2010-07-10	2010-07-10 00:00:00	2010-07-18	2010-07-18 00:00:00	2010-07-18	38000177		0	0	8		0	0	0	326664	0	834102	19133905		
38177	3158	40229134	1950-11-20	1950-11-20 00:00:00	1950-11-27	1950-11-27 00:00:00	1950-11-27	38000177		0	0	7		0	0	0	209994	0	1043400	40229134		
34910	2882	1127433	1990-09-06	1990-09-06 00:00:00	1990-09-13	1990-09-13 00:00:00	1990-09-13	38000177		0	0	7		0	0	0	191711	0	313782	1127433		
32385	2684	40243436	1967-05-21	1967-05-21 00:00:00	1967-05-21	1967-05-21 00:00:00	1967-05-21	38000177		0	0	0		0	0	0	177845	0	1190795	40243436		
13058	1097	1124300	2004-05-07	2004-05-07 00:00:00	2004-05-07	2004-05-07 00:00:00	\N	38000177		0	0	0		0	0	0	71972	0	00781178901	45011828		
59284	4927	42902245	1999-06-07	1999-06-07 00:00:00	2000-06-01	2000-06-01 00:00:00	2000-06-01	38000177		0	0	360		0	0	0	327452	0	1359133	42902245		
23588	1941	19019979	1981-11-21	1981-11-21 00:00:00	1981-12-21	1981-12-21 00:00:00	1981-12-21	38000177		0	0	30		0	0	0	129099	0	198405	19019979		
40974	3397	1127433	1981-09-06	1981-09-06 00:00:00	1981-10-11	1981-10-11 00:00:00	1981-10-11	38000177		0	0	35		0	0	0	225351	0	313782	1127433		
27529	600	40213296	1997-04-30	1997-04-30 00:00:00	1997-04-30	1997-04-30 00:00:00	1997-04-30	581452		0	0	0		0	0	0	39586	0	52	40213296		
125501	2761	40213160	1981-01-26	1981-01-26 00:00:00	1981-01-26	1981-01-26 00:00:00	1981-01-26	581452		0	0	0		0	0	0	182630	0	10	40213160		
13976	1169	40231925	1971-05-18	1971-05-18 00:00:00	1971-05-18	1971-05-18 00:00:00	\N	38000177		0	0	0		0	0	0	76986	0	1049221	40231925		
60879	5063	19059056	1968-02-12	1968-02-12 00:00:00	1968-03-04	1968-03-04 00:00:00	1968-03-04	38000177		0	0	21		0	0	0	336599	0	243670	19059056		
14068	1176	19059056	1964-10-08	1964-10-08 00:00:00	1964-10-22	1964-10-22 00:00:00	1964-10-22	38000177		0	0	14		0	0	0	77705	0	243670	19059056		
12685	1068	19078461	2006-10-05	2006-10-05 00:00:00	2006-11-02	2006-11-02 00:00:00	2006-11-02	38000177		0	0	28		0	0	0	69962	0	310965	19078461		
24618	2025	1127433	2012-10-26	2012-10-26 00:00:00	2012-11-02	2012-11-02 00:00:00	2012-11-02	38000177		0	0	7		0	0	0	134634	0	313782	1127433		
44917	3717	1127433	1992-10-11	1992-10-11 00:00:00	1992-10-25	1992-10-25 00:00:00	1992-10-25	38000177		0	0	14		0	0	0	246969	0	313782	1127433		
23242	1915	19078461	2013-04-02	2013-04-02 00:00:00	2013-04-16	2013-04-16 00:00:00	2013-04-16	38000177		0	0	14		0	0	0	127343	0	310965	19078461		
23287	1918	40229134	1982-01-30	1982-01-30 00:00:00	1982-02-13	1982-02-13 00:00:00	1982-02-13	38000177		0	0	14		0	0	0	127592	0	1043400	40229134		
16200	1345	1118084	2005-04-19	2005-04-19 00:00:00	2005-04-19	2005-04-19 00:00:00	\N	38000177		0	0	0		0	0	0	89106	0	00025152531	44923712		
16238	1348	1127433	1947-07-10	1947-07-10 00:00:00	1947-07-24	1947-07-24 00:00:00	1947-07-24	38000177		0	0	14		0	0	0	89291	0	313782	1127433		
26749	2204	1713671	1989-01-22	1989-01-22 00:00:00	1989-02-05	1989-02-05 00:00:00	1989-02-05	38000177		0	0	14		0	0	0	146919	0	562251	1713671		
26783	2206	19128065	1985-11-29	1985-11-29 00:00:00	1986-11-24	1986-11-24 00:00:00	1986-11-24	38000177		0	0	360		0	0	0	147054	0	749882	19128065		
122966	2703	40213160	1974-06-09	1974-06-09 00:00:00	1974-06-09	1974-06-09 00:00:00	1974-06-09	581452		0	0	0		0	0	0	179067	0	10	40213160		
60706	5048	1127433	1978-01-22	1978-01-22 00:00:00	1978-01-29	1978-01-29 00:00:00	1978-01-29	38000177		0	0	7		0	0	0	335471	0	313782	1127433		
3410	74	40213160	1972-06-14	1972-06-14 00:00:00	1972-06-14	1972-06-14 00:00:00	1972-06-14	581452		0	0	0		0	0	0	5002	0	10	40213160		
52062	4329	1713671	2011-08-27	2011-08-27 00:00:00	2011-09-17	2011-09-17 00:00:00	2011-09-17	38000177		0	0	21		0	0	0	287148	0	562251	1713671		
6841	576	1713671	2015-12-17	2015-12-17 00:00:00	2015-12-31	2015-12-31 00:00:00	2015-12-31	38000177		0	0	14		0	0	0	38104	0	562251	1713671		
6884	579	40229134	1994-03-30	1994-03-30 00:00:00	1994-04-06	1994-04-06 00:00:00	1994-04-06	38000177		0	0	7		0	0	0	38293	0	1043400	40229134		
6930	582	19059056	1965-11-27	1965-11-27 00:00:00	1966-01-01	1966-01-01 00:00:00	1966-01-01	38000177		0	0	35		0	0	0	38554	0	243670	19059056		
61451	5113	19006318	1978-11-23	1978-11-23 00:00:00	1978-12-07	1978-12-07 00:00:00	1978-12-07	38000177		0	0	14		0	0	0	339680	0	105078	19006318		
54266	4509	19059056	1968-09-22	1968-09-22 00:00:00	1968-11-21	1968-11-21 00:00:00	1968-11-21	38000177		0	0	60		0	0	0	300362	0	243670	19059056		
17535	1450	19059056	1965-11-27	1965-11-27 00:00:00	1966-01-01	1966-01-01 00:00:00	1966-01-01	38000177		0	0	35		0	0	0	96698	0	243670	19059056		
222094	4874	40213160	1969-01-11	1969-01-11 00:00:00	1969-01-11	1969-01-11 00:00:00	1969-01-11	581452		0	0	0		0	0	0	324166	0	10	40213160		
9136	759	19059056	1946-07-27	1946-07-27 00:00:00	1946-08-10	1946-08-10 00:00:00	1946-08-10	38000177		0	0	14		0	0	0	50430	0	243670	19059056		
60977	1333	40213296	1996-01-21	1996-01-21 00:00:00	1996-01-21	1996-01-21 00:00:00	1996-01-21	581452		0	0	0		0	0	0	88437	0	52	40213296		
54793	4551	1115171	2001-04-20	2001-04-20 00:00:00	2001-07-19	2001-07-19 00:00:00	2001-07-19	38000177		0	0	90		0	0	0	303327	0	849574	1115171		
47035	3896	1127078	1987-09-06	1987-09-06 00:00:00	1987-10-11	1987-10-11 00:00:00	1987-10-11	38000177		0	0	35		0	0	0	259186	0	282464	1127078		
38724	3200	40231925	2014-09-13	2014-09-13 00:00:00	2014-09-13	2014-09-13 00:00:00	\N	38000177		0	0	0		0	0	0	212829	0	1049221	40231925		
37127	3069	19078461	1977-05-29	1977-05-29 00:00:00	1977-06-19	1977-06-19 00:00:00	1977-06-19	38000177		0	0	21		0	0	0	204311	0	310965	19078461		
19856	1632	40243436	1988-11-13	1988-11-13 00:00:00	1988-11-14	1988-11-14 00:00:00	1988-11-14	38000177		0	0	1		0	0	0	109551	0	1190795	40243436		
8701	187	40213227	1996-11-24	1996-11-24 00:00:00	1996-11-24	1996-11-24 00:00:00	1996-11-24	581452		0	0	0		0	0	0	12767	0	113	40213227		
10467	871	19128065	1980-01-15	1980-01-15 00:00:00	1981-01-09	1981-01-09 00:00:00	1981-01-09	38000177		0	0	360		0	0	0	57919	0	749882	19128065		
32314	2680	19128065	1988-02-24	1988-02-24 00:00:00	1989-02-18	1989-02-18 00:00:00	1989-02-18	38000177		0	0	360		0	0	0	177583	0	749882	19128065		
30486	2528	1115171	2018-11-23	2018-11-23 00:00:00	2018-12-07	2018-12-07 00:00:00	2018-12-07	38000177		0	0	14		0	0	0	167134	0	849574	1115171		
9661	807	40165015	1991-10-25	1991-10-25 00:00:00	1991-10-25	1991-10-25 00:00:00	\N	38000177		0	0	0		0	0	0	53545	0	861467	40165015		
34054	2815	40236824	1998-10-05	1998-10-05 00:00:00	1998-10-12	1998-10-12 00:00:00	1998-10-12	38000177		0	0	7		0	0	0	186519	0	1094107	40236824		
9754	817	19059056	1958-02-10	1958-02-10 00:00:00	1958-02-24	1958-02-24 00:00:00	1958-02-24	38000177		0	0	14		0	0	0	54152	0	243670	19059056		
20257	1661	1118084	1995-02-05	1995-02-05 00:00:00	1995-02-05	1995-02-05 00:00:00	\N	38000177		0	0	0		0	0	0	111692	0	00025152531	44923712		
21235	1748	1118084	1987-05-08	1987-05-08 00:00:00	1987-05-08	1987-05-08 00:00:00	\N	38000177		0	0	0		0	0	0	116855	0	00025152531	44923712		
27044	2231	19078461	2010-09-20	2010-09-20 00:00:00	2010-10-11	2010-10-11 00:00:00	2010-10-11	38000177		0	0	21		0	0	0	148430	0	310965	19078461		
37538	3103	40220960	2018-05-16	2018-05-16 00:00:00	2018-05-16	2018-05-16 00:00:00	2018-05-16	38000177		0	0	0		0	0	0	206438	0	1804799	40220960		
64128	5325	19133905	2009-02-28	2009-02-28 00:00:00	2009-03-08	2009-03-08 00:00:00	2009-03-08	38000177		0	0	8		0	0	0	354494	0	834102	19133905		
7097	597	1127433	1984-06-30	1984-06-30 00:00:00	1984-07-14	1984-07-14 00:00:00	1984-07-14	38000177		0	0	14		0	0	0	39457	0	313782	1127433		
6221	520	1713671	1983-12-02	1983-12-02 00:00:00	1983-12-09	1983-12-09 00:00:00	1983-12-09	38000177		0	0	7		0	0	0	34700	0	562251	1713671		
6275	525	1127433	1994-09-07	1994-09-07 00:00:00	1994-09-14	1994-09-14 00:00:00	1994-09-14	38000177		0	0	7		0	0	0	34967	0	313782	1127433		
79	5	1118084	2009-05-30	2009-05-30 00:00:00	2009-05-30	2009-05-30 00:00:00	\N	38000177		0	0	0		0	0	0	466	0	00025152531	44923712		
134	9	19133873	1996-02-09	1996-02-09 00:00:00	1996-02-17	1996-02-17 00:00:00	1996-02-17	38000177		0	0	8		0	0	0	846	0	834061	19133873		
17907	1482	40232448	1975-07-28	1975-07-28 00:00:00	1975-07-28	1975-07-28 00:00:00	\N	38000177		0	0	0		0	0	0	98904	0	1049630	40232448		
28409	2343	1127433	2010-04-03	2010-04-03 00:00:00	2010-04-24	2010-04-24 00:00:00	2010-04-24	38000177		0	0	21		0	0	0	155982	0	313782	1127433		
28468	2346	1118084	1986-11-13	1986-11-13 00:00:00	1986-11-13	1986-11-13 00:00:00	\N	38000177		0	0	0		0	0	0	156154	0	00025152531	44923712		
28516	2349	1118084	2004-12-22	2004-12-22 00:00:00	2004-12-22	2004-12-22 00:00:00	\N	38000177		0	0	0		0	0	0	156407	0	00025152531	44923712		
31316	2596	19078461	2018-03-28	2018-03-28 00:00:00	2018-04-11	2018-04-11 00:00:00	2018-04-11	38000177		0	0	14		0	0	0	171766	0	310965	19078461		
53963	4484	19078461	2019-05-11	2019-05-11 00:00:00	2019-05-25	2019-05-25 00:00:00	2019-05-25	38000177		0	0	14		0	0	0	298497	0	310965	19078461		
38058	3147	19059056	1962-09-03	1962-09-03 00:00:00	1962-09-17	1962-09-17 00:00:00	1962-09-17	38000177		0	0	14		0	0	0	209397	0	243670	19059056		
59154	4916	1713671	2003-10-12	2003-10-12 00:00:00	2003-10-26	2003-10-26 00:00:00	2003-10-26	38000177		0	0	14		0	0	0	326674	0	562251	1713671		
38178	3159	1115171	2015-06-01	2015-06-01 00:00:00	2015-06-29	2015-06-29 00:00:00	2015-06-29	38000177		0	0	28		0	0	0	210082	0	849574	1115171		
34911	2882	1118084	2005-09-21	2005-09-21 00:00:00	2005-09-21	2005-09-21 00:00:00	\N	38000177		0	0	0		0	0	0	191688	0	00025152531	44923712		
32386	2684	19128065	1975-02-09	1975-02-09 00:00:00	1976-02-04	1976-02-04 00:00:00	1976-02-04	38000177		0	0	360		0	0	0	177880	0	749882	19128065		
13059	1097	1713671	1978-01-15	1978-01-15 00:00:00	1978-02-05	1978-02-05 00:00:00	1978-02-05	38000177		0	0	21		0	0	0	72005	0	562251	1713671		
10197	855	19059056	1959-04-27	1959-04-27 00:00:00	1959-05-11	1959-05-11 00:00:00	1959-05-11	38000177		0	0	14		0	0	0	56504	0	243670	19059056		
23589	1941	1713671	1982-05-16	1982-05-16 00:00:00	1982-05-23	1982-05-23 00:00:00	1982-05-23	38000177		0	0	7		0	0	0	129063	0	562251	1713671		
40975	3397	1118084	1981-12-25	1981-12-25 00:00:00	1981-12-25	1981-12-25 00:00:00	\N	38000177		0	0	0		0	0	0	225351	0	00025152531	44923712		
27541	600	40213260	2007-06-06	2007-06-06 00:00:00	2007-06-06	2007-06-06 00:00:00	2007-06-06	581452		0	0	0		0	0	0	39635	0	121	40213260		
125503	2761	40213251	1985-04-29	1985-04-29 00:00:00	1985-04-29	1985-04-29 00:00:00	1985-04-29	581452		0	0	0		0	0	0	182643	0	21	40213251		
13977	1169	1310034	2012-02-20	2012-02-20 00:00:00	2012-02-20	2012-02-20 00:00:00	2012-02-20	38000177		0	0	0		0	0	0	76990	0	834357	1310034		
60880	5063	40229134	1957-08-20	1957-08-20 00:00:00	1957-08-27	1957-08-27 00:00:00	1957-08-27	38000177		0	0	7		0	0	0	336552	0	1043400	40229134		
14069	1176	19129655	1964-10-08	1964-10-08 00:00:00	1964-10-22	1964-10-22 00:00:00	1964-10-22	38000177		0	0	14		0	0	0	77705	0	789980	19129655		
12686	1068	19133873	1984-10-05	1984-10-05 00:00:00	1984-10-15	1984-10-15 00:00:00	1984-10-15	38000177		0	0	10		0	0	0	69976	0	834061	19133873		
24619	2025	40229134	1926-06-22	1926-06-22 00:00:00	1926-06-29	1926-06-29 00:00:00	1926-06-29	38000177		0	0	7		0	0	0	134748	0	1043400	40229134		
44918	3717	1127433	1977-07-04	1977-07-04 00:00:00	1977-07-11	1977-07-11 00:00:00	1977-07-11	38000177		0	0	7		0	0	0	247075	0	313782	1127433		
23243	1915	19073188	2013-04-02	2013-04-02 00:00:00	2013-04-16	2013-04-16 00:00:00	2013-04-16	38000177		0	0	14		0	0	0	127343	0	308192	19073188		
23288	1918	19059056	1969-07-06	1969-07-06 00:00:00	1969-07-20	1969-07-20 00:00:00	1969-07-20	38000177		0	0	14		0	0	0	127603	0	243670	19059056		
16201	1345	19007333	2005-03-05	2005-03-05 00:00:00	2009-06-12	2009-06-12 00:00:00	2009-06-12	38000177		0	0	1560		0	0	0	89106	0	105586	19007333		
16239	1348	1713671	1959-10-20	1959-10-20 00:00:00	1959-10-27	1959-10-27 00:00:00	1959-10-27	38000177		0	0	7		0	0	0	89363	0	562251	1713671		
26750	2204	19133873	1955-04-20	1955-04-20 00:00:00	1955-05-01	1955-05-01 00:00:00	1955-05-01	38000177		0	0	11		0	0	0	146931	0	834061	19133873		
26784	2206	40229134	2001-04-08	2001-04-08 00:00:00	2001-04-22	2001-04-22 00:00:00	2001-04-22	38000177		0	0	14		0	0	0	146990	0	1043400	40229134		
122971	2703	40213160	1974-11-10	1974-11-10 00:00:00	1974-11-10	1974-11-10 00:00:00	1974-11-10	581452		0	0	0		0	0	0	179068	0	10	40213160		
60707	5048	1713671	2012-12-13	2012-12-13 00:00:00	2012-12-20	2012-12-20 00:00:00	2012-12-20	38000177		0	0	7		0	0	0	335478	0	562251	1713671		
3414	74	40213227	2004-09-29	2004-09-29 00:00:00	2004-09-29	2004-09-29 00:00:00	2004-09-29	581452		0	0	0		0	0	0	5032	0	113	40213227		
52063	4329	1127078	1981-03-17	1981-03-17 00:00:00	1981-04-14	1981-04-14 00:00:00	1981-04-14	38000177		0	0	28		0	0	0	287104	0	282464	1127078		
6842	576	19133873	1969-03-22	1969-03-22 00:00:00	1969-04-03	1969-04-03 00:00:00	1969-04-03	38000177		0	0	12		0	0	0	38095	0	834061	19133873		
6885	579	1127433	2014-09-12	2014-09-12 00:00:00	2014-09-26	2014-09-26 00:00:00	2014-09-26	38000177		0	0	14		0	0	0	38326	0	313782	1127433		
6931	582	19078461	1986-03-17	1986-03-17 00:00:00	1986-04-21	1986-04-21 00:00:00	1986-04-21	38000177		0	0	35		0	0	0	38555	0	310965	19078461		
61452	5113	1127078	1978-11-23	1978-11-23 00:00:00	1978-12-07	1978-12-07 00:00:00	1978-12-07	38000177		0	0	14		0	0	0	339680	0	282464	1127078		
1169	95	19129655	1962-04-05	1962-04-05 00:00:00	1962-04-19	1962-04-19 00:00:00	1962-04-19	38000177		0	0	14		0	0	0	6400	0	789980	19129655		
17536	1450	1127433	1979-04-29	1979-04-29 00:00:00	1979-05-06	1979-05-06 00:00:00	1979-05-06	38000177		0	0	7		0	0	0	96739	0	313782	1127433		
19299	1593	19059056	1953-06-01	1953-06-01 00:00:00	1953-06-15	1953-06-15 00:00:00	1953-06-15	38000177		0	0	14		0	0	0	106842	0	243670	19059056		
9137	759	1127433	2005-07-25	2005-07-25 00:00:00	2005-08-01	2005-08-01 00:00:00	2005-08-01	38000177		0	0	7		0	0	0	50393	0	313782	1127433		
60979	1333	40213227	1996-01-21	1996-01-21 00:00:00	1996-01-21	1996-01-21 00:00:00	1996-01-21	581452		0	0	0		0	0	0	88437	0	113	40213227		
54794	4551	1713671	2017-08-30	2017-08-30 00:00:00	2017-09-13	2017-09-13 00:00:00	2017-09-13	38000177		0	0	14		0	0	0	303332	0	562251	1713671		
47036	3896	19075601	2010-06-18	2010-06-18 00:00:00	2010-06-18	2010-06-18 00:00:00	2010-06-18	38000177		0	0	0		0	0	0	259191	0	309362	19075601		
38725	3200	1127433	2014-09-13	2014-09-13 00:00:00	2014-11-12	2014-11-12 00:00:00	2014-11-12	38000177		0	0	60		0	0	0	212829	0	313782	1127433		
37128	3069	19128065	1975-08-13	1975-08-13 00:00:00	1976-08-07	1976-08-07 00:00:00	1976-08-07	38000177		0	0	360		0	0	0	204251	0	749882	19128065		
19857	1632	46275916	1988-11-13	1988-11-13 00:00:00	1988-11-14	1988-11-14 00:00:00	1988-11-14	38000177		0	0	1		0	0	0	109551	0	1660014	46275916		
12899	1084	19128065	1997-12-02	1997-12-02 00:00:00	1998-11-27	1998-11-27 00:00:00	1998-11-27	38000177		0	0	360		0	0	0	71183	0	749882	19128065		
10468	871	1127433	1971-09-20	1971-09-20 00:00:00	1971-10-04	1971-10-04 00:00:00	1971-10-04	38000177		0	0	14		0	0	0	57915	0	313782	1127433		
32315	2680	1127078	1976-09-14	1976-09-14 00:00:00	1976-09-28	1976-09-28 00:00:00	1976-09-28	38000177		0	0	14		0	0	0	177554	0	282464	1127078		
30487	2528	19059056	1974-09-15	1974-09-15 00:00:00	1974-10-15	1974-10-15 00:00:00	1974-10-15	38000177		0	0	30		0	0	0	167130	0	243670	19059056		
9662	807	19078461	1998-04-21	1998-04-21 00:00:00	1998-05-12	1998-05-12 00:00:00	1998-05-12	38000177		0	0	21		0	0	0	53546	0	310965	19078461		
34055	2815	920300	1998-10-05	1998-10-05 00:00:00	1998-10-12	1998-10-12 00:00:00	1998-10-12	38000177		0	0	7		0	0	0	186519	0	311989	920300		
9755	817	19073188	1989-08-11	1989-08-11 00:00:00	1989-08-25	1989-08-25 00:00:00	1989-08-25	38000177		0	0	14		0	0	0	54122	0	308192	19073188		
20258	1661	1127433	1981-06-09	1981-06-09 00:00:00	1981-07-14	1981-07-14 00:00:00	1981-07-14	38000177		0	0	35		0	0	0	111652	0	313782	1127433		
21236	1748	1127433	1949-04-23	1949-04-23 00:00:00	1949-04-30	1949-04-30 00:00:00	1949-04-30	38000177		0	0	7		0	0	0	116837	0	313782	1127433		
27045	2231	19078461	2006-12-26	2006-12-26 00:00:00	2007-01-09	2007-01-09 00:00:00	2007-01-09	38000177		0	0	14		0	0	0	148429	0	310965	19078461		
37539	3103	19073188	2011-01-23	2011-01-23 00:00:00	2011-02-06	2011-02-06 00:00:00	2011-02-06	38000177		0	0	14		0	0	0	206454	0	308192	19073188		
64129	5325	19077572	2018-03-11	2018-03-11 00:00:00	2018-03-11	2018-03-11 00:00:00	\N	38000177		0	0	0		0	0	0	354446	0	310436	19077572		
7099	597	920300	2006-06-01	2006-06-01 00:00:00	2006-06-08	2006-06-08 00:00:00	2006-06-08	38000177		0	0	7		0	0	0	39441	0	311989	920300		
6222	520	19059056	1978-01-17	1978-01-17 00:00:00	1978-02-14	1978-02-14 00:00:00	1978-02-14	38000177		0	0	28		0	0	0	34744	0	243670	19059056		
6276	525	1127433	2000-09-17	2000-09-17 00:00:00	2000-10-08	2000-10-08 00:00:00	2000-10-08	38000177		0	0	21		0	0	0	34962	0	313782	1127433		
80	5	1127433	1974-05-11	1974-05-11 00:00:00	1974-05-18	1974-05-18 00:00:00	1974-05-18	38000177		0	0	7		0	0	0	477	0	313782	1127433		
135	9	1127078	1982-04-30	1982-04-30 00:00:00	1982-05-14	1982-05-14 00:00:00	1982-05-14	38000177		0	0	14		0	0	0	711	0	282464	1127078		
17908	1482	40169281	2008-11-22	2008-11-22 00:00:00	2008-11-22	2008-11-22 00:00:00	\N	38000177		0	0	0		0	0	0	98824	0	896209	40169281		
28410	2343	1127433	2002-11-05	2002-11-05 00:00:00	2002-11-12	2002-11-12 00:00:00	2002-11-12	38000177		0	0	7		0	0	0	155953	0	313782	1127433		
28469	2346	40229134	1952-11-03	1952-11-03 00:00:00	1952-11-17	1952-11-17 00:00:00	1952-11-17	38000177		0	0	14		0	0	0	156125	0	1043400	40229134		
28517	2349	1127078	1974-02-03	1974-02-03 00:00:00	1974-02-17	1974-02-17 00:00:00	1974-02-17	38000177		0	0	14		0	0	0	156411	0	282464	1127078		
31317	2596	1127433	1967-10-25	1967-10-25 00:00:00	1967-11-08	1967-11-08 00:00:00	1967-11-08	38000177		0	0	14		0	0	0	171767	0	313782	1127433		
53964	4484	40163554	2017-06-08	2017-06-08 00:00:00	2017-06-08	2017-06-08 00:00:00	\N	38000177		0	0	0		0	0	0	298520	0	855332	40163554		
38059	3147	19129655	1962-09-03	1962-09-03 00:00:00	1962-09-17	1962-09-17 00:00:00	1962-09-17	38000177		0	0	14		0	0	0	209397	0	789980	19129655		
59155	4916	19128022	1996-06-29	1996-06-29 00:00:00	1997-06-24	1997-06-24 00:00:00	1997-06-24	38000177		0	0	360		0	0	0	326676	0	749785	19128022		
38179	3159	19128065	1979-05-21	1979-05-21 00:00:00	1980-05-15	1980-05-15 00:00:00	1980-05-15	38000177		0	0	360		0	0	0	210079	0	749882	19128065		
34912	2882	19128065	1987-05-04	1987-05-04 00:00:00	1988-04-28	1988-04-28 00:00:00	1988-04-28	38000177		0	0	360		0	0	0	191701	0	749882	19128065		
32387	2684	1127433	1991-04-25	1991-04-25 00:00:00	1991-05-09	1991-05-09 00:00:00	1991-05-09	38000177		0	0	14		0	0	0	177859	0	313782	1127433		
13060	1097	920334	2008-04-24	2008-04-24 00:00:00	2008-05-01	2008-05-01 00:00:00	2008-05-01	38000177		0	0	7		0	0	0	72016	0	311995	920334		
10198	855	19006318	1959-04-27	1959-04-27 00:00:00	1959-05-11	1959-05-11 00:00:00	1959-05-11	38000177		0	0	14		0	0	0	56504	0	105078	19006318		
23590	1941	1124300	2009-11-23	2009-11-23 00:00:00	2009-11-23	2009-11-23 00:00:00	\N	38000177		0	0	0		0	0	0	129102	0	00781178901	45011828		
40976	3397	19059056	1956-01-16	1956-01-16 00:00:00	1956-02-15	1956-02-15 00:00:00	1956-02-15	38000177		0	0	30		0	0	0	225347	0	243670	19059056		
27546	600	40213160	1955-03-16	1955-03-16 00:00:00	1955-03-16	1955-03-16 00:00:00	1955-03-16	581452		0	0	0		0	0	0	39577	0	10	40213160		
125505	2761	40213160	1985-04-29	1985-04-29 00:00:00	1985-04-29	1985-04-29 00:00:00	1985-04-29	581452		0	0	0		0	0	0	182643	0	10	40213160		
13978	1169	46275916	2012-02-20	2012-02-20 00:00:00	2012-02-20	2012-02-20 00:00:00	2012-02-20	38000177		0	0	0		0	0	0	76990	0	1660014	46275916		
60892	5065	1127433	2002-01-06	2002-01-06 00:00:00	2002-01-13	2002-01-13 00:00:00	2002-01-13	38000177		0	0	7		0	0	0	336704	0	313782	1127433		
14070	1176	1551192	1999-11-13	1999-11-13 00:00:00	1999-11-13	1999-11-13 00:00:00	1999-11-13	38000177		0	0	0		0	0	0	77647	0	312617	1551192		
33221	726	40213227	2004-09-05	2004-09-05 00:00:00	2004-09-05	2004-09-05 00:00:00	2004-09-05	581452		0	0	0		0	0	0	48082	0	113	40213227		
24620	2025	1713671	1946-08-09	1946-08-09 00:00:00	1946-08-23	1946-08-23 00:00:00	1946-08-23	38000177		0	0	14		0	0	0	134631	0	562251	1713671		
44919	3717	1713671	2006-06-12	2006-06-12 00:00:00	2006-06-26	2006-06-26 00:00:00	2006-06-26	38000177		0	0	14		0	0	0	246980	0	562251	1713671		
23244	1915	1127433	1991-07-09	1991-07-09 00:00:00	1991-10-07	1991-10-07 00:00:00	1991-10-07	38000177		0	0	90		0	0	0	127404	0	313782	1127433		
23289	1918	1713671	1982-02-02	1982-02-02 00:00:00	1982-02-16	1982-02-16 00:00:00	1982-02-16	38000177		0	0	14		0	0	0	127635	0	562251	1713671		
16202	1345	1115171	1996-06-05	1996-06-05 00:00:00	1996-06-26	1996-06-26 00:00:00	1996-06-26	38000177		0	0	21		0	0	0	89173	0	849574	1115171		
16240	1348	1127433	1988-10-04	1988-10-04 00:00:00	1988-10-18	1988-10-18 00:00:00	1988-10-18	38000177		0	0	14		0	0	0	89305	0	313782	1127433		
26751	2204	1713671	1946-11-14	1946-11-14 00:00:00	1946-11-28	1946-11-28 00:00:00	1946-11-28	38000177		0	0	14		0	0	0	146905	0	562251	1713671		
26785	2206	19128065	1995-10-08	1995-10-08 00:00:00	1996-10-02	1996-10-02 00:00:00	1996-10-02	38000177		0	0	360		0	0	0	147002	0	749882	19128065		
60659	5045	19128065	1979-03-04	1979-03-04 00:00:00	1980-02-27	1980-02-27 00:00:00	1980-02-27	38000177		0	0	360		0	0	0	335292	0	749882	19128065		
60708	5048	1713671	1965-05-11	1965-05-11 00:00:00	1965-06-01	1965-06-01 00:00:00	1965-06-01	38000177		0	0	21		0	0	0	335402	0	562251	1713671		
35705	2943	19059056	1917-03-17	1917-03-17 00:00:00	1917-03-31	1917-03-31 00:00:00	1917-03-31	38000177		0	0	14		0	0	0	196243	0	243670	19059056		
52064	4329	19073183	1982-05-25	1982-05-25 00:00:00	1982-06-08	1982-06-08 00:00:00	1982-06-08	38000177		0	0	14		0	0	0	287107	0	308182	19073183		
6843	576	1127433	1982-06-22	1982-06-22 00:00:00	1982-07-06	1982-07-06 00:00:00	1982-07-06	38000177		0	0	14		0	0	0	38064	0	313782	1127433		
6886	579	1127433	1994-07-25	1994-07-25 00:00:00	1994-08-29	1994-08-29 00:00:00	1994-08-29	38000177		0	0	35		0	0	0	38337	0	313782	1127433		
6966	587	19128065	2000-02-05	2000-02-05 00:00:00	2001-01-30	2001-01-30 00:00:00	2001-01-30	38000177		0	0	360		0	0	0	38893	0	749882	19128065		
61453	5113	19074679	1977-03-12	1977-03-12 00:00:00	1977-03-12	1977-03-12 00:00:00	\N	38000177		0	0	0		0	0	0	339672	0	308971	19074679		
1170	95	19059056	1962-04-05	1962-04-05 00:00:00	1962-04-19	1962-04-19 00:00:00	1962-04-19	38000177		0	0	14		0	0	0	6400	0	243670	19059056		
17537	1450	1127433	1970-03-08	1970-03-08 00:00:00	1970-03-15	1970-03-15 00:00:00	1970-03-15	38000177		0	0	7		0	0	0	96738	0	313782	1127433		
19300	1593	19059056	1970-09-03	1970-09-03 00:00:00	1970-09-17	1970-09-17 00:00:00	1970-09-17	38000177		0	0	14		0	0	0	106847	0	243670	19059056		
9138	759	40163554	2003-02-19	2003-02-19 00:00:00	2003-02-19	2003-02-19 00:00:00	\N	38000177		0	0	0		0	0	0	50367	0	855332	40163554		
60983	1333	40213227	2006-02-19	2006-02-19 00:00:00	2006-02-19	2006-02-19 00:00:00	2006-02-19	581452		0	0	0		0	0	0	88424	0	113	40213227		
54795	4551	1127433	1981-09-03	1981-09-03 00:00:00	1981-09-17	1981-09-17 00:00:00	1981-09-17	38000177		0	0	14		0	0	0	303340	0	313782	1127433		
47037	3896	40220960	2010-06-18	2010-06-18 00:00:00	2010-06-18	2010-06-18 00:00:00	2010-06-18	38000177		0	0	0		0	0	0	259191	0	1804799	40220960		
38728	3200	1127433	1983-09-04	1983-09-04 00:00:00	1983-09-11	1983-09-11 00:00:00	1983-09-11	38000177		0	0	7		0	0	0	212832	0	313782	1127433		
37129	3069	19059056	1986-08-01	1986-08-01 00:00:00	1986-10-07	1986-10-07 00:00:00	1986-10-07	38000177		0	0	67		0	0	0	204312	0	243670	19059056		
19858	1632	1713671	1965-05-01	1965-05-01 00:00:00	1965-05-22	1965-05-22 00:00:00	1965-05-22	38000177		0	0	21		0	0	0	109567	0	562251	1713671		
12900	1084	42902245	1998-11-27	1998-11-27 00:00:00	1999-11-22	1999-11-22 00:00:00	1999-11-22	38000177		0	0	360		0	0	0	71184	0	1359133	42902245		
74947	1636	40213160	1956-05-18	1956-05-18 00:00:00	1956-05-18	1956-05-18 00:00:00	1956-05-18	581452		0	0	0		0	0	0	109922	0	10	40213160		
32316	2680	1127433	2009-06-14	2009-06-14 00:00:00	2009-07-12	2009-07-12 00:00:00	2009-07-12	38000177		0	0	28		0	0	0	177557	0	313782	1127433		
30488	2528	19133873	1969-11-12	1969-11-12 00:00:00	1969-11-25	1969-11-25 00:00:00	1969-11-25	38000177		0	0	13		0	0	0	167103	0	834061	19133873		
9663	807	19059056	1964-09-04	1964-09-04 00:00:00	1964-10-02	1964-10-02 00:00:00	1964-10-02	38000177		0	0	28		0	0	0	53633	0	243670	19059056		
34056	2815	19059056	1973-02-18	1973-02-18 00:00:00	1973-03-18	1973-03-18 00:00:00	1973-03-18	38000177		0	0	28		0	0	0	186531	0	243670	19059056		
9756	817	1127433	1989-08-11	1989-08-11 00:00:00	1989-08-25	1989-08-25 00:00:00	1989-08-25	38000177		0	0	14		0	0	0	54122	0	313782	1127433		
20259	1661	19133905	1977-01-07	1977-01-07 00:00:00	1977-01-18	1977-01-18 00:00:00	1977-01-18	38000177		0	0	11		0	0	0	111665	0	834102	19133905		
21237	1748	1127433	1955-05-01	1955-05-01 00:00:00	1955-05-08	1955-05-08 00:00:00	1955-05-08	38000177		0	0	7		0	0	0	116916	0	313782	1127433		
27046	2231	1713671	1979-11-26	1979-11-26 00:00:00	1979-12-03	1979-12-03 00:00:00	1979-12-03	38000177		0	0	7		0	0	0	148418	0	562251	1713671		
37540	3103	1127433	2011-01-23	2011-01-23 00:00:00	2011-02-06	2011-02-06 00:00:00	2011-02-06	38000177		0	0	14		0	0	0	206454	0	313782	1127433		
64130	5325	1118084	1985-08-14	1985-08-14 00:00:00	1985-08-14	1985-08-14 00:00:00	\N	38000177		0	0	0		0	0	0	354507	0	00025152531	44923712		
7100	597	40236824	2006-06-01	2006-06-01 00:00:00	2006-06-08	2006-06-08 00:00:00	2006-06-08	38000177		0	0	7		0	0	0	39441	0	1094107	40236824		
6223	520	1127433	1980-12-30	1980-12-30 00:00:00	1981-01-20	1981-01-20 00:00:00	1981-01-20	38000177		0	0	21		0	0	0	34745	0	313782	1127433		
6277	525	1713671	2003-02-10	2003-02-10 00:00:00	2003-03-03	2003-03-03 00:00:00	2003-03-03	38000177		0	0	21		0	0	0	35044	0	562251	1713671		
81	5	19078461	2012-10-08	2012-10-08 00:00:00	2012-12-07	2012-12-07 00:00:00	2012-12-07	38000177		0	0	60		0	0	0	493	0	310965	19078461		
136	9	19073183	1982-04-30	1982-04-30 00:00:00	1982-05-14	1982-05-14 00:00:00	1982-05-14	38000177		0	0	14		0	0	0	711	0	308182	19073183		
17909	1482	1127078	1975-01-17	1975-01-17 00:00:00	1975-01-31	1975-01-31 00:00:00	1975-01-31	38000177		0	0	14		0	0	0	98843	0	282464	1127078		
28411	2343	19059056	1986-03-12	1986-03-12 00:00:00	1986-04-09	1986-04-09 00:00:00	1986-04-09	38000177		0	0	28		0	0	0	155981	0	243670	19059056		
28470	2346	19133873	1959-10-17	1959-10-17 00:00:00	1959-10-24	1959-10-24 00:00:00	1959-10-24	38000177		0	0	7		0	0	0	156168	0	834061	19133873		
28518	2349	1127433	2010-03-23	2010-03-23 00:00:00	2010-03-30	2010-03-30 00:00:00	2010-03-30	38000177		0	0	7		0	0	0	156451	0	313782	1127433		
31318	2596	40229134	1980-10-21	1980-10-21 00:00:00	1980-11-04	1980-11-04 00:00:00	1980-11-04	38000177		0	0	14		0	0	0	171812	0	1043400	40229134		
53965	4484	19018935	2017-06-08	2017-06-08 00:00:00	2017-06-08	2017-06-08 00:00:00	\N	38000177		0	0	0		0	0	0	298520	0	197604	19018935		
38060	3147	1127433	1980-01-01	1980-01-01 00:00:00	1980-01-15	1980-01-15 00:00:00	1980-01-15	38000177		0	0	14		0	0	0	209360	0	313782	1127433		
59156	4917	1118084	2016-06-28	2016-06-28 00:00:00	2016-06-28	2016-06-28 00:00:00	\N	38000177		0	0	0		0	0	0	326730	0	00025152531	44923712		
38180	3159	1713671	1961-08-19	1961-08-19 00:00:00	1961-09-09	1961-09-09 00:00:00	1961-09-09	38000177		0	0	21		0	0	0	210020	0	562251	1713671		
34914	2883	1127433	1970-01-27	1970-01-27 00:00:00	1970-02-03	1970-02-03 00:00:00	1970-02-03	38000177		0	0	7		0	0	0	191780	0	313782	1127433		
32388	2685	19059056	1966-07-01	1966-07-01 00:00:00	1966-07-15	1966-07-15 00:00:00	1966-07-15	38000177		0	0	14		0	0	0	177967	0	243670	19059056		
13062	1097	19128065	1985-03-13	1985-03-13 00:00:00	1986-03-08	1986-03-08 00:00:00	1986-03-08	38000177		0	0	360		0	0	0	72007	0	749882	19128065		
10199	855	1127078	1967-07-29	1967-07-29 00:00:00	1967-08-12	1967-08-12 00:00:00	1967-08-12	38000177		0	0	14		0	0	0	56514	0	282464	1127078		
23591	1941	1115171	2009-04-28	2009-04-28 00:00:00	2009-05-19	2009-05-19 00:00:00	2009-05-19	38000177		0	0	21		0	0	0	129102	0	849574	1115171		
40977	3397	19133873	1951-01-13	1951-01-13 00:00:00	1951-01-25	1951-01-25 00:00:00	1951-01-25	38000177		0	0	12		0	0	0	225333	0	834061	19133873		
27548	600	40213160	1958-12-17	1958-12-17 00:00:00	1958-12-17	1958-12-17 00:00:00	1958-12-17	581452		0	0	0		0	0	0	39589	0	10	40213160		
44180	962	40213227	2012-01-13	2012-01-13 00:00:00	2012-01-13	2012-01-13 00:00:00	2012-01-13	581452		0	0	0		0	0	0	64067	0	113	40213227		
13979	1169	40243436	2012-02-20	2012-02-20 00:00:00	2012-02-20	2012-02-20 00:00:00	2012-02-20	38000177		0	0	0		0	0	0	76990	0	1190795	40243436		
60893	5065	19133905	2000-07-31	2000-07-31 00:00:00	2000-08-10	2000-08-10 00:00:00	2000-08-10	38000177		0	0	10		0	0	0	336703	0	834102	19133905		
14071	1176	1713671	1995-02-05	1995-02-05 00:00:00	1995-02-19	1995-02-19 00:00:00	1995-02-19	38000177		0	0	14		0	0	0	77696	0	562251	1713671		
33232	726	40213160	1955-02-06	1955-02-06 00:00:00	1955-02-06	1955-02-06 00:00:00	1955-02-06	581452		0	0	0		0	0	0	48096	0	10	40213160		
24621	2025	1124300	1946-12-28	1946-12-28 00:00:00	1946-12-28	1946-12-28 00:00:00	\N	38000177		0	0	0		0	0	0	134631	0	00781178901	45011828		
44920	3717	40236446	1983-05-07	1983-05-07 00:00:00	1983-08-06	1983-08-06 00:00:00	1983-08-06	38000177		0	0	91		0	0	0	247077	0	1091392	40236446		
23245	1915	40162522	1991-07-09	1991-07-09 00:00:00	1991-07-09	1991-07-09 00:00:00	\N	38000177		0	0	0		0	0	0	127404	0	857005	40162522		
23290	1918	40229134	1985-04-29	1985-04-29 00:00:00	1985-05-13	1985-05-13 00:00:00	1985-05-13	38000177		0	0	14		0	0	0	127593	0	1043400	40229134		
16203	1345	19075601	2008-03-25	2008-03-25 00:00:00	2008-03-25	2008-03-25 00:00:00	\N	38000177		0	0	0		0	0	0	89151	0	309362	19075601		
16241	1348	1127433	1931-07-07	1931-07-07 00:00:00	1931-07-14	1931-07-14 00:00:00	1931-07-14	38000177		0	0	7		0	0	0	89341	0	313782	1127433		
26752	2204	19059056	1950-07-19	1950-07-19 00:00:00	1950-08-09	1950-08-09 00:00:00	1950-08-09	38000177		0	0	21		0	0	0	146925	0	243670	19059056		
26786	2206	19059056	1990-11-23	1990-11-23 00:00:00	1990-12-14	1990-12-14 00:00:00	1990-12-14	38000177		0	0	21		0	0	0	147011	0	243670	19059056		
60660	5045	19133873	1963-08-19	1963-08-19 00:00:00	1963-09-01	1963-09-01 00:00:00	1963-09-01	38000177		0	0	13		0	0	0	335261	0	834061	19133873		
60709	5048	1127433	1992-08-24	1992-08-24 00:00:00	1992-08-31	1992-08-31 00:00:00	1992-08-31	38000177		0	0	7		0	0	0	335496	0	313782	1127433		
35706	2943	1127433	2008-02-08	2008-02-08 00:00:00	2008-05-08	2008-05-08 00:00:00	2008-05-08	38000177		0	0	90		0	0	0	196326	0	313782	1127433		
52065	4329	1127078	1982-05-25	1982-05-25 00:00:00	1982-06-08	1982-06-08 00:00:00	1982-06-08	38000177		0	0	14		0	0	0	287107	0	282464	1127078		
6844	576	1118084	2001-12-10	2001-12-10 00:00:00	2001-12-10	2001-12-10 00:00:00	\N	38000177		0	0	0		0	0	0	38101	0	00025152531	44923712		
6887	579	1127433	2008-08-22	2008-08-22 00:00:00	2008-09-05	2008-09-05 00:00:00	2008-09-05	38000177		0	0	14		0	0	0	38350	0	313782	1127433		
6967	587	1713671	1986-06-17	1986-06-17 00:00:00	1986-07-08	1986-07-08 00:00:00	1986-07-08	38000177		0	0	21		0	0	0	38889	0	562251	1713671		
61454	5113	1127078	1978-12-28	1978-12-28 00:00:00	1979-01-18	1979-01-18 00:00:00	1979-01-18	38000177		0	0	21		0	0	0	339725	0	282464	1127078		
1171	95	1713671	2002-03-18	2002-03-18 00:00:00	2002-04-08	2002-04-08 00:00:00	2002-04-08	38000177		0	0	21		0	0	0	6458	0	562251	1713671		
17538	1450	1713671	2009-01-29	2009-01-29 00:00:00	2009-02-05	2009-02-05 00:00:00	2009-02-05	38000177		0	0	7		0	0	0	96721	0	562251	1713671		
19301	1593	19059056	1941-08-05	1941-08-05 00:00:00	1941-10-04	1941-10-04 00:00:00	1941-10-04	38000177		0	0	60		0	0	0	106919	0	243670	19059056		
9139	759	19018935	2003-02-19	2003-02-19 00:00:00	2003-02-19	2003-02-19 00:00:00	\N	38000177		0	0	0		0	0	0	50367	0	197604	19018935		
60984	1333	40213260	2006-02-19	2006-02-19 00:00:00	2006-02-19	2006-02-19 00:00:00	2006-02-19	581452		0	0	0		0	0	0	88424	0	121	40213260		
54796	4551	46233988	1977-02-25	1977-02-25 00:00:00	1977-03-11	1977-03-11 00:00:00	1977-03-11	38000177		0	0	14		0	0	0	303290	0	1652673	46233988		
47038	3896	40229134	2000-10-31	2000-10-31 00:00:00	2000-11-07	2000-11-07 00:00:00	2000-11-07	38000177		0	0	7		0	0	0	259181	0	1043400	40229134		
38729	3200	1127078	1958-01-21	1958-01-21 00:00:00	1958-02-18	1958-02-18 00:00:00	1958-02-18	38000177		0	0	28		0	0	0	212826	0	282464	1127078		
37130	3069	1127433	1991-02-12	1991-02-12 00:00:00	1991-02-26	1991-02-26 00:00:00	1991-02-26	38000177		0	0	14		0	0	0	204247	0	313782	1127433		
19859	1632	19059056	1989-11-27	1989-11-27 00:00:00	1989-12-18	1989-12-18 00:00:00	1989-12-18	38000177		0	0	21		0	0	0	109552	0	243670	19059056		
12901	1084	1127078	1982-12-11	1982-12-11 00:00:00	1983-02-09	1983-02-09 00:00:00	1983-02-09	38000177		0	0	60		0	0	0	71208	0	282464	1127078		
74966	1636	40213227	2007-02-16	2007-02-16 00:00:00	2007-02-16	2007-02-16 00:00:00	2007-02-16	581452		0	0	0		0	0	0	109931	0	113	40213227		
32317	2680	19128022	1990-02-13	1990-02-13 00:00:00	1991-02-08	1991-02-08 00:00:00	1991-02-08	38000177		0	0	360		0	0	0	177546	0	749785	19128022		
30489	2528	1713671	1979-05-06	1979-05-06 00:00:00	1979-05-27	1979-05-27 00:00:00	1979-05-27	38000177		0	0	21		0	0	0	167109	0	562251	1713671		
9664	807	1118084	1994-09-22	1994-09-22 00:00:00	1994-09-22	1994-09-22 00:00:00	\N	38000177		0	0	0		0	0	0	53550	0	00025152531	44923712		
34057	2815	1127433	2006-01-24	2006-01-24 00:00:00	2006-02-07	2006-02-07 00:00:00	2006-02-07	38000177		0	0	14		0	0	0	186495	0	313782	1127433		
9757	817	1127078	1961-12-21	1961-12-21 00:00:00	1962-01-18	1962-01-18 00:00:00	1962-01-18	38000177		0	0	28		0	0	0	54107	0	282464	1127078		
20260	1661	1127078	1962-03-14	1962-03-14 00:00:00	1962-03-28	1962-03-28 00:00:00	1962-03-28	38000177		0	0	14		0	0	0	111688	0	282464	1127078		
21238	1748	40231925	1989-07-10	1989-07-10 00:00:00	1989-07-10	1989-07-10 00:00:00	\N	38000177		0	0	0		0	0	0	116868	0	1049221	40231925		
27047	2231	40229134	1990-08-28	1990-08-28 00:00:00	1990-09-04	1990-09-04 00:00:00	1990-09-04	38000177		0	0	7		0	0	0	148453	0	1043400	40229134		
37541	3103	19059056	1978-11-06	1978-11-06 00:00:00	1978-11-20	1978-11-20 00:00:00	1978-11-20	38000177		0	0	14		0	0	0	206408	0	243670	19059056		
64131	5325	19133873	1952-10-03	1952-10-03 00:00:00	1952-10-14	1952-10-14 00:00:00	1952-10-14	38000177		0	0	11		0	0	0	354455	0	834061	19133873		
7101	597	1127433	1985-08-08	1985-08-08 00:00:00	1985-08-22	1985-08-22 00:00:00	1985-08-22	38000177		0	0	14		0	0	0	39458	0	313782	1127433		
6224	520	19059056	1953-12-07	1953-12-07 00:00:00	1953-12-28	1953-12-28 00:00:00	1953-12-28	38000177		0	0	21		0	0	0	34749	0	243670	19059056		
6278	525	1115171	2013-03-04	2013-03-04 00:00:00	2013-03-18	2013-03-18 00:00:00	2013-03-18	38000177		0	0	14		0	0	0	34963	0	849574	1115171		
82	5	1127433	1971-03-12	1971-03-12 00:00:00	1971-03-26	1971-03-26 00:00:00	1971-03-26	38000177		0	0	14		0	0	0	401	0	313782	1127433		
137	9	1127433	2003-02-23	2003-02-23 00:00:00	2003-03-09	2003-03-09 00:00:00	2003-03-09	38000177		0	0	14		0	0	0	863	0	313782	1127433		
17910	1482	1127433	2006-06-13	2006-06-13 00:00:00	2006-06-20	2006-06-20 00:00:00	2006-06-20	38000177		0	0	7		0	0	0	98901	0	313782	1127433		
28412	2343	19075601	2016-05-21	2016-05-21 00:00:00	2016-05-21	2016-05-21 00:00:00	2016-05-21	38000177		0	0	0		0	0	0	156005	0	309362	19075601		
28471	2346	19078461	1974-08-22	1974-08-22 00:00:00	1974-09-21	1974-09-21 00:00:00	1974-09-21	38000177		0	0	30		0	0	0	156217	0	310965	19078461		
28519	2349	19059056	1973-03-05	1973-03-05 00:00:00	1973-04-09	1973-04-09 00:00:00	1973-04-09	38000177		0	0	35		0	0	0	156410	0	243670	19059056		
31319	2596	19059056	1969-08-14	1969-08-14 00:00:00	1969-09-04	1969-09-04 00:00:00	1969-09-04	38000177		0	0	21		0	0	0	171816	0	243670	19059056		
53966	4484	40171902	2017-06-08	2017-06-08 00:00:00	2017-06-08	2017-06-08 00:00:00	\N	38000177		0	0	0		0	0	0	298520	0	897718	40171902		
38061	3147	1127078	1955-01-29	1955-01-29 00:00:00	1955-04-29	1955-04-29 00:00:00	1955-04-29	38000177		0	0	90		0	0	0	209351	0	282464	1127078		
59157	4917	19078461	1997-12-14	1997-12-14 00:00:00	1998-01-18	1998-01-18 00:00:00	1998-01-18	38000177		0	0	35		0	0	0	326749	0	310965	19078461		
48639	4027	1713671	2011-06-18	2011-06-18 00:00:00	2011-07-09	2011-07-09 00:00:00	2011-07-09	38000177		0	0	21		0	0	0	267855	0	562251	1713671		
34916	2883	1713671	1985-11-22	1985-11-22 00:00:00	1985-12-13	1985-12-13 00:00:00	1985-12-13	38000177		0	0	21		0	0	0	191782	0	562251	1713671		
32389	2685	1127433	1967-12-17	1967-12-17 00:00:00	1967-12-31	1967-12-31 00:00:00	1967-12-31	38000177		0	0	14		0	0	0	177955	0	313782	1127433		
13063	1097	920300	2008-04-17	2008-04-17 00:00:00	2008-04-24	2008-04-24 00:00:00	2008-04-24	38000177		0	0	7		0	0	0	71973	0	311989	920300		
10200	855	1713671	1991-02-19	1991-02-19 00:00:00	1991-03-05	1991-03-05 00:00:00	1991-03-05	38000177		0	0	14		0	0	0	56461	0	562251	1713671		
23592	1941	19129655	1976-04-19	1976-04-19 00:00:00	1976-05-03	1976-05-03 00:00:00	1976-05-03	38000177		0	0	14		0	0	0	129041	0	789980	19129655		
40978	3397	1127433	1976-11-10	1976-11-10 00:00:00	1976-12-01	1976-12-01 00:00:00	1976-12-01	38000177		0	0	21		0	0	0	225350	0	313782	1127433		
13294	287	40213314	1977-07-18	1977-07-18 00:00:00	1977-07-18	1977-07-18 00:00:00	1977-07-18	581452		0	0	0		0	0	0	19212	0	49	40213314		
44185	962	40213227	2001-11-16	2001-11-16 00:00:00	2001-11-16	2001-11-16 00:00:00	2001-11-16	581452		0	0	0		0	0	0	64074	0	113	40213227		
13980	1169	1713671	1980-11-23	1980-11-23 00:00:00	1980-11-30	1980-11-30 00:00:00	1980-11-30	38000177		0	0	7		0	0	0	77031	0	562251	1713671		
60894	5065	40229134	1989-02-04	1989-02-04 00:00:00	1989-02-11	1989-02-11 00:00:00	1989-02-11	38000177		0	0	7		0	0	0	336734	0	1043400	40229134		
14072	1176	40232448	1966-11-08	1966-11-08 00:00:00	1966-11-08	1966-11-08 00:00:00	\N	38000177		0	0	0		0	0	0	77649	0	1049630	40232448		
36583	3019	1713671	1978-03-09	1978-03-09 00:00:00	1978-03-30	1978-03-30 00:00:00	1978-03-30	38000177		0	0	21		0	0	0	201332	0	562251	1713671		
24622	2025	1127433	1938-07-18	1938-07-18 00:00:00	1938-08-01	1938-08-01 00:00:00	1938-08-01	38000177		0	0	14		0	0	0	134771	0	313782	1127433		
44921	3717	19133905	1999-06-22	1999-06-22 00:00:00	1999-07-02	1999-07-02 00:00:00	1999-07-02	38000177		0	0	10		0	0	0	246978	0	834102	19133905		
23246	1915	40229134	1987-06-06	1987-06-06 00:00:00	1987-06-13	1987-06-13 00:00:00	1987-06-13	38000177		0	0	7		0	0	0	127378	0	1043400	40229134		
23297	1921	40229134	1991-07-06	1991-07-06 00:00:00	1991-07-13	1991-07-13 00:00:00	1991-07-13	38000177		0	0	7		0	0	0	127738	0	1043400	40229134		
16204	1345	19126352	2008-03-25	2008-03-25 00:00:00	2008-03-25	2008-03-25 00:00:00	\N	38000177		0	0	0		0	0	0	89151	0	705129	19126352		
16242	1348	1713671	1919-07-15	1919-07-15 00:00:00	1919-08-05	1919-08-05 00:00:00	1919-08-05	38000177		0	0	21		0	0	0	89359	0	562251	1713671		
26753	2204	1713671	1964-04-18	1964-04-18 00:00:00	1964-05-10	1964-05-10 00:00:00	1964-05-10	38000177		0	0	22		0	0	0	146914	0	562251	1713671		
26787	2206	19128065	1998-09-22	1998-09-22 00:00:00	1999-09-17	1999-09-17 00:00:00	1999-09-17	38000177		0	0	360		0	0	0	147005	0	749882	19128065		
60661	5045	19128065	1976-03-19	1976-03-19 00:00:00	1977-03-14	1977-03-14 00:00:00	1977-03-14	38000177		0	0	360		0	0	0	335290	0	749882	19128065		
60710	5049	1127433	1996-04-28	1996-04-28 00:00:00	1996-05-12	1996-05-12 00:00:00	1996-05-12	38000177		0	0	14		0	0	0	335578	0	313782	1127433		
35707	2943	40162522	2008-02-08	2008-02-08 00:00:00	2008-02-08	2008-02-08 00:00:00	\N	38000177		0	0	0		0	0	0	196326	0	857005	40162522		
52066	4330	40229134	1964-03-31	1964-03-31 00:00:00	1964-04-07	1964-04-07 00:00:00	1964-04-07	38000177		0	0	7		0	0	0	287186	0	1043400	40229134		
6845	576	40232448	1971-09-20	1971-09-20 00:00:00	1971-09-20	1971-09-20 00:00:00	\N	38000177		0	0	0		0	0	0	38096	0	1049630	40232448		
6888	579	1713671	1988-07-11	1988-07-11 00:00:00	1988-08-01	1988-08-01 00:00:00	1988-08-01	38000177		0	0	21		0	0	0	38292	0	562251	1713671		
6968	587	1127433	1994-08-12	1994-08-12 00:00:00	1994-08-26	1994-08-26 00:00:00	1994-08-26	38000177		0	0	14		0	0	0	38872	0	313782	1127433		
61455	5113	19059056	1970-02-08	1970-02-08 00:00:00	1970-03-08	1970-03-08 00:00:00	1970-03-08	38000177		0	0	28		0	0	0	339721	0	243670	19059056		
1172	95	1127433	1990-09-19	1990-09-19 00:00:00	1990-10-03	1990-10-03 00:00:00	1990-10-03	38000177		0	0	14		0	0	0	6465	0	313782	1127433		
17539	1450	19078461	1976-01-09	1976-01-09 00:00:00	1976-01-30	1976-01-30 00:00:00	1976-01-30	38000177		0	0	21		0	0	0	96699	0	310965	19078461		
19302	1593	19059056	1940-01-06	1940-01-06 00:00:00	1940-01-20	1940-01-20 00:00:00	1940-01-20	38000177		0	0	14		0	0	0	106868	0	243670	19059056		
9140	759	40171902	2003-02-19	2003-02-19 00:00:00	2003-02-19	2003-02-19 00:00:00	\N	38000177		0	0	0		0	0	0	50367	0	897718	40171902		
60989	1333	40213160	1955-01-09	1955-01-09 00:00:00	1955-01-09	1955-01-09 00:00:00	1955-01-09	581452		0	0	0		0	0	0	88422	0	10	40213160		
54797	4551	19019979	1977-02-25	1977-02-25 00:00:00	1977-03-11	1977-03-11 00:00:00	1977-03-11	38000177		0	0	14		0	0	0	303290	0	198405	19019979		
47051	3899	19078461	2018-08-09	2018-08-09 00:00:00	2018-11-07	2018-11-07 00:00:00	2018-11-07	38000177		0	0	90		0	0	0	259249	0	310965	19078461		
38730	3200	1115171	2013-08-19	2013-08-19 00:00:00	2013-11-17	2013-11-17 00:00:00	2013-11-17	38000177		0	0	90		0	0	0	212828	0	849574	1115171		
37131	3069	1127078	1969-01-27	1969-01-27 00:00:00	1969-03-28	1969-03-28 00:00:00	1969-03-28	38000177		0	0	60		0	0	0	204309	0	282464	1127078		
19860	1632	19059056	1955-04-23	1955-04-23 00:00:00	1955-05-08	1955-05-08 00:00:00	1955-05-08	38000177		0	0	15		0	0	0	109626	0	243670	19059056		
12902	1084	19128022	1992-01-03	1992-01-03 00:00:00	1992-12-28	1992-12-28 00:00:00	1992-12-28	38000177		0	0	360		0	0	0	71207	0	749785	19128022		
74967	1636	40213260	2007-02-16	2007-02-16 00:00:00	2007-02-16	2007-02-16 00:00:00	2007-02-16	581452		0	0	0		0	0	0	109931	0	121	40213260		
32318	2680	1127433	1986-02-08	1986-02-08 00:00:00	1986-04-16	1986-04-16 00:00:00	1986-04-16	38000177		0	0	67		0	0	0	177555	0	313782	1127433		
30490	2528	1127433	1977-05-03	1977-05-03 00:00:00	1977-05-17	1977-05-17 00:00:00	1977-05-17	38000177		0	0	14		0	0	0	167129	0	313782	1127433		
6637	559	1127433	1973-05-12	1973-05-12 00:00:00	1973-05-19	1973-05-19 00:00:00	1973-05-19	38000177		0	0	7		0	0	0	37073	0	313782	1127433		
34059	2815	19006318	1964-08-04	1964-08-04 00:00:00	1964-08-18	1964-08-18 00:00:00	1964-08-18	38000177		0	0	14		0	0	0	186551	0	105078	19006318		
9758	817	1713671	2004-08-01	2004-08-01 00:00:00	2004-08-15	2004-08-15 00:00:00	2004-08-15	38000177		0	0	14		0	0	0	54148	0	562251	1713671		
20261	1661	19129655	1962-03-14	1962-03-14 00:00:00	1962-03-28	1962-03-28 00:00:00	1962-03-28	38000177		0	0	14		0	0	0	111688	0	789980	19129655		
21239	1748	1713671	2005-09-21	2005-09-21 00:00:00	2005-09-28	2005-09-28 00:00:00	2005-09-28	38000177		0	0	7		0	0	0	116858	0	562251	1713671		
27048	2231	19133905	2012-12-02	2012-12-02 00:00:00	2012-12-15	2012-12-15 00:00:00	2012-12-15	38000177		0	0	13		0	0	0	148454	0	834102	19133905		
37542	3103	46233988	1978-11-06	1978-11-06 00:00:00	1978-11-20	1978-11-20 00:00:00	1978-11-20	38000177		0	0	14		0	0	0	206408	0	1652673	46233988		
64132	5325	1713671	1963-02-04	1963-02-04 00:00:00	1963-02-25	1963-02-25 00:00:00	1963-02-25	38000177		0	0	21		0	0	0	354458	0	562251	1713671		
7102	597	1127433	1977-07-02	1977-07-02 00:00:00	1977-07-16	1977-07-16 00:00:00	1977-07-16	38000177		0	0	14		0	0	0	39418	0	313782	1127433		
6225	520	1127433	1983-06-21	1983-06-21 00:00:00	1983-06-28	1983-06-28 00:00:00	1983-06-28	38000177		0	0	7		0	0	0	34697	0	313782	1127433		
6279	525	19078924	1952-05-22	1952-05-22 00:00:00	1952-05-22	1952-05-22 00:00:00	1952-05-22	38000177		0	0	0		0	0	0	34958	0	311700	19078924		
83	5	19112599	1973-08-13	1973-08-13 00:00:00	1973-08-13	1973-08-13 00:00:00	\N	38000177		0	0	0		0	0	0	402	0	477045	19112599		
138	9	1127433	1990-09-15	1990-09-15 00:00:00	1990-09-29	1990-09-29 00:00:00	1990-09-29	38000177		0	0	14		0	0	0	761	0	313782	1127433		
17911	1482	1713671	1985-09-26	1985-09-26 00:00:00	1985-10-03	1985-10-03 00:00:00	1985-10-03	38000177		0	0	7		0	0	0	98887	0	562251	1713671		
28413	2343	40220960	2016-05-21	2016-05-21 00:00:00	2016-05-21	2016-05-21 00:00:00	2016-05-21	38000177		0	0	0		0	0	0	156005	0	1804799	40220960		
28472	2346	1127433	1972-10-10	1972-10-10 00:00:00	1972-10-24	1972-10-24 00:00:00	1972-10-24	38000177		0	0	14		0	0	0	156169	0	313782	1127433		
28520	2349	19078461	1987-02-09	1987-02-09 00:00:00	1987-05-10	1987-05-10 00:00:00	1987-05-10	38000177		0	0	90		0	0	0	156412	0	310965	19078461		
31320	2596	1127433	2018-11-09	2018-11-09 00:00:00	2018-11-23	2018-11-23 00:00:00	2018-11-23	38000177		0	0	14		0	0	0	171747	0	313782	1127433		
53967	4484	40229134	1951-11-14	1951-11-14 00:00:00	1951-11-21	1951-11-21 00:00:00	1951-11-21	38000177		0	0	7		0	0	0	298458	0	1043400	40229134		
38062	3147	1127433	1988-11-29	1988-11-29 00:00:00	1988-12-27	1988-12-27 00:00:00	1988-12-27	38000177		0	0	28		0	0	0	209355	0	313782	1127433		
59158	4917	1127078	1993-08-23	1993-08-23 00:00:00	1993-11-21	1993-11-21 00:00:00	1993-11-21	38000177		0	0	90		0	0	0	326747	0	282464	1127078		
20619	449	40213296	1999-11-11	1999-11-11 00:00:00	1999-11-11	1999-11-11 00:00:00	1999-11-11	581452		0	0	0		0	0	0	29888	0	52	40213296		
34917	2883	1713671	1965-05-27	1965-05-27 00:00:00	1965-06-03	1965-06-03 00:00:00	1965-06-03	38000177		0	0	7		0	0	0	191779	0	562251	1713671		
32390	2685	1713671	2012-05-07	2012-05-07 00:00:00	2012-05-14	2012-05-14 00:00:00	2012-05-14	38000177		0	0	7		0	0	0	177966	0	562251	1713671		
13064	1097	40236824	2008-04-17	2008-04-17 00:00:00	2008-05-01	2008-05-01 00:00:00	2008-05-01	38000177		0	0	14		0	0	0	71973	0	1094107	40236824		
10201	855	920300	1993-12-26	1993-12-26 00:00:00	1994-01-02	1994-01-02 00:00:00	1994-01-02	38000177		0	0	7		0	0	0	56462	0	311989	920300		
23593	1941	19019979	1976-04-19	1976-04-19 00:00:00	1976-05-03	1976-05-03 00:00:00	1976-05-03	38000177		0	0	14		0	0	0	129041	0	198405	19019979		
40979	3397	19059056	1973-03-17	1973-03-17 00:00:00	1973-03-31	1973-03-31 00:00:00	1973-03-31	38000177		0	0	14		0	0	0	225349	0	243670	19059056		
13300	287	40213314	1977-04-17	1977-04-17 00:00:00	1977-04-17	1977-04-17 00:00:00	1977-04-17	581452		0	0	0		0	0	0	19200	0	49	40213314		
44196	962	40213227	1993-10-01	1993-10-01 00:00:00	1993-10-01	1993-10-01 00:00:00	1993-10-01	581452		0	0	0		0	0	0	64054	0	113	40213227		
13981	1169	1127433	1980-02-05	1980-02-05 00:00:00	1980-03-11	1980-03-11 00:00:00	1980-03-11	38000177		0	0	35		0	0	0	76987	0	313782	1127433		
60895	5065	19126352	2004-03-02	2004-03-02 00:00:00	2005-03-15	2005-03-15 00:00:00	2005-03-15	38000177		0	0	378		0	0	0	336744	0	705129	19126352		
14073	1176	1713671	1993-09-15	1993-09-15 00:00:00	1993-10-06	1993-10-06 00:00:00	1993-10-06	38000177		0	0	21		0	0	0	77695	0	562251	1713671		
36584	3019	1115171	2000-10-28	2000-10-28 00:00:00	2000-12-02	2000-12-02 00:00:00	2000-12-02	38000177		0	0	35		0	0	0	201348	0	849574	1115171		
24623	2025	40163554	1973-11-10	1973-11-10 00:00:00	1973-11-10	1973-11-10 00:00:00	\N	38000177		0	0	0		0	0	0	134672	0	855332	40163554		
44922	3718	19128065	1988-09-04	1988-09-04 00:00:00	1989-08-30	1989-08-30 00:00:00	1989-08-30	38000177		0	0	360		0	0	0	247085	0	749882	19128065		
23247	1915	19078461	1989-06-28	1989-06-28 00:00:00	1989-07-19	1989-07-19 00:00:00	1989-07-19	38000177		0	0	21		0	0	0	127403	0	310965	19078461		
23298	1921	40236824	1992-12-31	1992-12-31 00:00:00	1993-01-07	1993-01-07 00:00:00	1993-01-07	38000177		0	0	7		0	0	0	127764	0	1094107	40236824		
16205	1345	1332419	2008-03-25	2008-03-25 00:00:00	2008-03-25	2008-03-25 00:00:00	\N	38000177		0	0	0		0	0	0	89151	0	197361	1332419		
16243	1348	19078461	1977-12-01	1977-12-01 00:00:00	1977-12-22	1977-12-22 00:00:00	1977-12-22	38000177		0	0	21		0	0	0	89373	0	310965	19078461		
26754	2204	19133905	1967-06-22	1967-06-22 00:00:00	1967-07-02	1967-07-02 00:00:00	1967-07-02	38000177		0	0	10		0	0	0	146904	0	834102	19133905		
26788	2206	1127078	1974-02-20	1974-02-20 00:00:00	1974-03-06	1974-03-06 00:00:00	1974-03-06	38000177		0	0	14		0	0	0	147013	0	282464	1127078		
60662	5046	1127433	1992-08-18	1992-08-18 00:00:00	1992-09-15	1992-09-15 00:00:00	1992-09-15	38000177		0	0	28		0	0	0	335340	0	313782	1127433		
60711	5049	1127433	1981-05-21	1981-05-21 00:00:00	1981-06-04	1981-06-04 00:00:00	1981-06-04	38000177		0	0	14		0	0	0	335576	0	313782	1127433		
35708	2943	40229134	2003-03-23	2003-03-23 00:00:00	2003-04-06	2003-04-06 00:00:00	2003-04-06	38000177		0	0	14		0	0	0	196295	0	1043400	40229134		
52067	4330	40173590	2006-02-18	2006-02-18 00:00:00	2006-02-18	2006-02-18 00:00:00	\N	38000177		0	0	0		0	0	0	287247	0	904419	40173590		
6846	576	1127433	2001-07-01	2001-07-01 00:00:00	2001-09-29	2001-09-29 00:00:00	2001-09-29	38000177		0	0	90		0	0	0	38066	0	313782	1127433		
6889	579	19133905	1996-09-21	1996-09-21 00:00:00	1996-10-01	1996-10-01 00:00:00	1996-10-01	38000177		0	0	10		0	0	0	38301	0	834102	19133905		
29729	648	40213227	2004-01-02	2004-01-02 00:00:00	2004-01-02	2004-01-02 00:00:00	2004-01-02	581452		0	0	0		0	0	0	42859	0	113	40213227		
61456	5113	19115351	1977-05-21	1977-05-21 00:00:00	1977-11-05	1977-11-05 00:00:00	1977-11-05	38000177		0	0	168		0	0	0	339724	0	563026	19115351		
1173	95	40162522	1969-12-08	1969-12-08 00:00:00	1969-12-08	1969-12-08 00:00:00	\N	38000177		0	0	0		0	0	0	6464	0	857005	40162522		
17540	1450	1127433	1991-12-31	1991-12-31 00:00:00	1992-01-14	1992-01-14 00:00:00	1992-01-14	38000177		0	0	14		0	0	0	96714	0	313782	1127433		
19303	1593	19059056	1968-10-22	1968-10-22 00:00:00	1968-11-12	1968-11-12 00:00:00	1968-11-12	38000177		0	0	21		0	0	0	106846	0	243670	19059056		
9141	759	40229134	1982-12-30	1982-12-30 00:00:00	1983-01-13	1983-01-13 00:00:00	1983-01-13	38000177		0	0	14		0	0	0	50392	0	1043400	40229134		
60997	1333	40213296	1998-01-25	1998-01-25 00:00:00	1998-01-25	1998-01-25 00:00:00	1998-01-25	581452		0	0	0		0	0	0	88410	0	52	40213296		
54798	4551	19133873	1990-04-30	1990-04-30 00:00:00	1990-05-07	1990-05-07 00:00:00	1990-05-07	38000177		0	0	7		0	0	0	303304	0	834061	19133873		
47052	3899	19019979	1985-05-31	1985-05-31 00:00:00	1985-06-28	1985-06-28 00:00:00	1985-06-28	38000177		0	0	28		0	0	0	259247	0	198405	19019979		
38731	3200	19133905	2001-01-21	2001-01-21 00:00:00	2001-02-03	2001-02-03 00:00:00	2001-02-03	38000177		0	0	13		0	0	0	212834	0	834102	19133905		
37132	3069	40165015	1986-08-08	1986-08-08 00:00:00	1986-08-08	1986-08-08 00:00:00	\N	38000177		0	0	0		0	0	0	204284	0	861467	40165015		
19861	1632	19006318	1955-04-23	1955-04-23 00:00:00	1955-05-08	1955-05-08 00:00:00	1955-05-08	38000177		0	0	15		0	0	0	109626	0	105078	19006318		
12903	1084	1127433	2010-12-04	2010-12-04 00:00:00	2010-12-18	2010-12-18 00:00:00	2010-12-18	38000177		0	0	14		0	0	0	71191	0	313782	1127433		
74971	1636	40213260	2006-02-10	2006-02-10 00:00:00	2006-02-10	2006-02-10 00:00:00	2006-02-10	581452		0	0	0		0	0	0	109893	0	121	40213260		
32319	2680	19073188	1996-05-16	1996-05-16 00:00:00	1996-05-30	1996-05-30 00:00:00	1996-05-30	38000177		0	0	14		0	0	0	177579	0	308192	19073188		
30491	2528	1127433	2010-07-30	2010-07-30 00:00:00	2010-08-13	2010-08-13 00:00:00	2010-08-13	38000177		0	0	14		0	0	0	167120	0	313782	1127433		
6638	559	1127433	1992-04-09	1992-04-09 00:00:00	1992-05-09	1992-05-09 00:00:00	1992-05-09	38000177		0	0	30		0	0	0	37098	0	313782	1127433		
34060	2815	1127078	1964-08-04	1964-08-04 00:00:00	1964-08-18	1964-08-18 00:00:00	1964-08-18	38000177		0	0	14		0	0	0	186551	0	282464	1127078		
9759	817	1127433	2006-09-07	2006-09-07 00:00:00	2006-09-14	2006-09-14 00:00:00	2006-09-14	38000177		0	0	7		0	0	0	54165	0	313782	1127433		
20262	1661	40229134	2016-08-03	2016-08-03 00:00:00	2016-08-17	2016-08-17 00:00:00	2016-08-17	38000177		0	0	14		0	0	0	111640	0	1043400	40229134		
21240	1748	40229134	2012-03-06	2012-03-06 00:00:00	2012-03-20	2012-03-20 00:00:00	2012-03-20	38000177		0	0	14		0	0	0	116860	0	1043400	40229134		
27049	2231	40236446	1977-05-07	1977-05-07 00:00:00	1988-05-14	1988-05-14 00:00:00	1988-05-14	38000177		0	0	4025		0	0	0	148424	0	1091392	40236446		
37543	3103	19128022	1992-06-06	1992-06-06 00:00:00	1993-06-01	1993-06-01 00:00:00	1993-06-01	38000177		0	0	360		0	0	0	206404	0	749785	19128022		
64133	5325	1127433	1970-12-17	1970-12-17 00:00:00	1970-12-31	1970-12-31 00:00:00	1970-12-31	38000177		0	0	14		0	0	0	354438	0	313782	1127433		
7104	597	19133873	1963-03-26	1963-03-26 00:00:00	1963-04-04	1963-04-04 00:00:00	1963-04-04	38000177		0	0	9		0	0	0	39472	0	834061	19133873		
6227	520	1118084	1988-05-18	1988-05-18 00:00:00	1988-05-18	1988-05-18 00:00:00	\N	38000177		0	0	0		0	0	0	34728	0	00025152531	44923712		
6280	525	19079524	1952-05-22	1952-05-22 00:00:00	1952-05-23	1952-05-23 00:00:00	1952-05-23	38000177		0	0	1		0	0	0	34958	0	313002	19079524		
84	5	1127433	2012-10-16	2012-10-16 00:00:00	2012-10-23	2012-10-23 00:00:00	2012-10-23	38000177		0	0	7		0	0	0	525	0	313782	1127433		
139	9	40169216	1982-07-26	1982-07-26 00:00:00	1982-07-26	1982-07-26 00:00:00	\N	38000177		0	0	0		0	0	0	708	0	895994	40169216		
17912	1482	1124300	2017-08-24	2017-08-24 00:00:00	2017-08-24	2017-08-24 00:00:00	\N	38000177		0	0	0		0	0	0	98827	0	00781178901	45011828		
28414	2343	1115171	2012-11-09	2012-11-09 00:00:00	2012-11-23	2012-11-23 00:00:00	2012-11-23	38000177		0	0	14		0	0	0	155983	0	849574	1115171		
28473	2346	1127433	1983-05-14	1983-05-14 00:00:00	1983-05-21	1983-05-21 00:00:00	1983-05-21	38000177		0	0	7		0	0	0	156211	0	313782	1127433		
28527	2351	1127433	1968-03-16	1968-03-16 00:00:00	1968-03-30	1968-03-30 00:00:00	1968-03-30	38000177		0	0	14		0	0	0	156507	0	313782	1127433		
31321	2596	1127433	1985-06-18	1985-06-18 00:00:00	1985-06-25	1985-06-25 00:00:00	1985-06-25	38000177		0	0	7		0	0	0	171770	0	313782	1127433		
53968	4484	40229134	1986-03-23	1986-03-23 00:00:00	1986-04-06	1986-04-06 00:00:00	1986-04-06	38000177		0	0	14		0	0	0	298461	0	1043400	40229134		
38063	3147	1118084	1983-09-19	1983-09-19 00:00:00	1983-09-19	1983-09-19 00:00:00	\N	38000177		0	0	0		0	0	0	209419	0	00025152531	44923712		
59159	4917	19133873	1989-02-16	1989-02-16 00:00:00	1989-02-28	1989-02-28 00:00:00	1989-02-28	38000177		0	0	12		0	0	0	326737	0	834061	19133873		
21269	462	40213314	1977-11-24	1977-11-24 00:00:00	1977-11-24	1977-11-24 00:00:00	1977-11-24	581452		0	0	0		0	0	0	30871	0	49	40213314		
34918	2883	40229134	1981-05-08	1981-05-08 00:00:00	1981-05-15	1981-05-15 00:00:00	1981-05-15	38000177		0	0	7		0	0	0	191785	0	1043400	40229134		
32391	2685	1118084	1981-01-05	1981-01-05 00:00:00	1981-01-05	1981-01-05 00:00:00	\N	38000177		0	0	0		0	0	0	177959	0	00025152531	44923712		
34973	2889	1127433	1961-06-15	1961-06-15 00:00:00	1961-06-22	1961-06-22 00:00:00	1961-06-22	38000177		0	0	7		0	0	0	192121	0	313782	1127433		
10202	855	40236824	1993-12-26	1993-12-26 00:00:00	1994-01-02	1994-01-02 00:00:00	1994-01-02	38000177		0	0	7		0	0	0	56462	0	1094107	40236824		
23594	1941	1713671	1979-12-16	1979-12-16 00:00:00	1979-12-23	1979-12-23 00:00:00	1979-12-23	38000177		0	0	7		0	0	0	129071	0	562251	1713671		
40980	3397	1127433	1952-04-07	1952-04-07 00:00:00	1952-04-21	1952-04-21 00:00:00	1952-04-21	38000177		0	0	14		0	0	0	225334	0	313782	1127433		
13303	287	40213227	2018-09-17	2018-09-17 00:00:00	2018-09-17	2018-09-17 00:00:00	2018-09-17	581452		0	0	0		0	0	0	19196	0	113	40213227		
44207	962	40213198	2016-02-05	2016-02-05 00:00:00	2016-02-05	2016-02-05 00:00:00	2016-02-05	581452		0	0	0		0	0	0	64098	0	133	40213198		
13982	1169	1127433	1952-02-08	1952-02-08 00:00:00	1952-03-07	1952-03-07 00:00:00	1952-03-07	38000177		0	0	28		0	0	0	76984	0	313782	1127433		
60896	5065	1332419	2004-03-02	2004-03-02 00:00:00	2004-03-02	2004-03-02 00:00:00	\N	38000177		0	0	0		0	0	0	336744	0	197361	1332419		
14074	1176	40165015	1991-03-01	1991-03-01 00:00:00	1991-03-01	1991-03-01 00:00:00	\N	38000177		0	0	0		0	0	0	77646	0	861467	40165015		
36585	3019	1127433	1991-08-19	1991-08-19 00:00:00	1991-09-02	1991-09-02 00:00:00	1991-09-02	38000177		0	0	14		0	0	0	201316	0	313782	1127433		
24624	2025	19018935	1973-11-10	1973-11-10 00:00:00	1973-11-10	1973-11-10 00:00:00	\N	38000177		0	0	0		0	0	0	134672	0	197604	19018935		
44923	3718	1127078	1972-09-18	1972-09-18 00:00:00	1972-10-16	1972-10-16 00:00:00	1972-10-16	38000177		0	0	28		0	0	0	247143	0	282464	1127078		
23248	1915	40229134	2006-05-20	2006-05-20 00:00:00	2006-06-03	2006-06-03 00:00:00	2006-06-03	38000177		0	0	14		0	0	0	127355	0	1043400	40229134		
23299	1921	920300	1992-12-31	1992-12-31 00:00:00	1993-01-07	1993-01-07 00:00:00	1993-01-07	38000177		0	0	7		0	0	0	127764	0	311989	920300		
16206	1345	1539411	2008-03-25	2008-03-25 00:00:00	2008-03-25	2008-03-25 00:00:00	\N	38000177		0	0	0		0	0	0	89151	0	312961	1539411		
16244	1348	1127433	1942-09-03	1942-09-03 00:00:00	1942-09-17	1942-09-17 00:00:00	1942-09-17	38000177		0	0	14		0	0	0	89361	0	313782	1127433		
26755	2204	1118084	1986-11-16	1986-11-16 00:00:00	1986-11-16	1986-11-16 00:00:00	\N	38000177		0	0	0		0	0	0	146917	0	00025152531	44923712		
26789	2206	1713671	2018-03-06	2018-03-06 00:00:00	2018-03-13	2018-03-13 00:00:00	2018-03-13	38000177		0	0	7		0	0	0	147039	0	562251	1713671		
60663	5046	1115171	2012-11-12	2012-11-12 00:00:00	2012-12-03	2012-12-03 00:00:00	2012-12-03	38000177		0	0	21		0	0	0	335342	0	849574	1115171		
60712	5049	1127433	1969-11-07	1969-11-07 00:00:00	1969-11-21	1969-11-21 00:00:00	1969-11-21	38000177		0	0	14		0	0	0	335589	0	313782	1127433		
35709	2943	1127433	1917-09-15	1917-09-15 00:00:00	1917-09-29	1917-09-29 00:00:00	1917-09-29	38000177		0	0	14		0	0	0	196349	0	313782	1127433		
52068	4330	19059056	1948-06-28	1948-06-28 00:00:00	1948-07-12	1948-07-12 00:00:00	1948-07-12	38000177		0	0	14		0	0	0	287243	0	243670	19059056		
6847	576	40165015	2001-07-01	2001-07-01 00:00:00	2001-07-01	2001-07-01 00:00:00	\N	38000177		0	0	0		0	0	0	38066	0	861467	40165015		
6890	579	19133873	1973-09-23	1973-09-23 00:00:00	1973-10-05	1973-10-05 00:00:00	1973-10-05	38000177		0	0	12		0	0	0	38290	0	834061	19133873		
33216	2752	40174880	2004-03-04	2004-03-04 00:00:00	2004-03-04	2004-03-04 00:00:00	\N	38000177		0	0	0		0	0	0	182104	0	966222	40174880		
61457	5113	1713671	2017-04-22	2017-04-22 00:00:00	2017-05-13	2017-05-13 00:00:00	2017-05-13	38000177		0	0	21		0	0	0	339709	0	562251	1713671		
1174	95	1127433	1969-12-08	1969-12-08 00:00:00	1970-03-08	1970-03-08 00:00:00	1970-03-08	38000177		0	0	90		0	0	0	6464	0	313782	1127433		
17541	1450	1127078	1965-01-13	1965-01-13 00:00:00	1965-01-27	1965-01-27 00:00:00	1965-01-27	38000177		0	0	14		0	0	0	96716	0	282464	1127078		
19334	1597	19133873	1959-02-26	1959-02-26 00:00:00	1959-03-10	1959-03-10 00:00:00	1959-03-10	38000177		0	0	12		0	0	0	107099	0	834061	19133873		
9142	759	1713671	1970-07-24	1970-07-24 00:00:00	1970-08-07	1970-08-07 00:00:00	1970-08-07	38000177		0	0	14		0	0	0	50374	0	562251	1713671		
61013	1333	40213160	1959-07-05	1959-07-05 00:00:00	1959-07-05	1959-07-05 00:00:00	1959-07-05	581452		0	0	0		0	0	0	88457	0	10	40213160		
10493	224	40213227	1994-02-01	1994-02-01 00:00:00	1994-02-01	1994-02-01 00:00:00	1994-02-01	581452		0	0	0		0	0	0	15077	0	113	40213227		
47053	3899	1127433	1991-10-29	1991-10-29 00:00:00	1991-11-12	1991-11-12 00:00:00	1991-11-12	38000177		0	0	14		0	0	0	259278	0	313782	1127433		
38732	3200	1127433	1981-03-19	1981-03-19 00:00:00	1981-04-09	1981-04-09 00:00:00	1981-04-09	38000177		0	0	21		0	0	0	212827	0	313782	1127433		
37133	3069	1713671	1995-08-23	1995-08-23 00:00:00	1995-09-13	1995-09-13 00:00:00	1995-09-13	38000177		0	0	21		0	0	0	204289	0	562251	1713671		
19862	1632	1713671	1999-07-29	1999-07-29 00:00:00	1999-08-05	1999-08-05 00:00:00	1999-08-05	38000177		0	0	7		0	0	0	109624	0	562251	1713671		
12904	1084	19074843	1979-09-28	1979-09-28 00:00:00	1979-10-12	1979-10-12 00:00:00	1979-10-12	38000177		0	0	14		0	0	0	71212	0	309045	19074843		
74974	1636	40213296	1998-02-20	1998-02-20 00:00:00	1998-02-20	1998-02-20 00:00:00	1998-02-20	581452		0	0	0		0	0	0	109908	0	52	40213296		
32320	2680	1115171	1996-05-16	1996-05-16 00:00:00	1996-05-30	1996-05-30 00:00:00	1996-05-30	38000177		0	0	14		0	0	0	177579	0	849574	1115171		
30492	2528	1713671	1992-06-06	1992-06-06 00:00:00	1992-06-13	1992-06-13 00:00:00	1992-06-13	38000177		0	0	7		0	0	0	167088	0	562251	1713671		
6639	559	1118084	2011-06-03	2011-06-03 00:00:00	2011-06-03	2011-06-03 00:00:00	\N	38000177		0	0	0		0	0	0	37058	0	00025152531	44923712		
34061	2815	19078461	2000-02-25	2000-02-25 00:00:00	2000-03-31	2000-03-31 00:00:00	2000-03-31	38000177		0	0	35		0	0	0	186533	0	310965	19078461		
9760	817	1713671	1983-02-27	1983-02-27 00:00:00	1983-03-20	1983-03-20 00:00:00	1983-03-20	38000177		0	0	21		0	0	0	54145	0	562251	1713671		
20263	1661	40229134	1979-01-05	1979-01-05 00:00:00	1979-01-12	1979-01-12 00:00:00	1979-01-12	38000177		0	0	7		0	0	0	111691	0	1043400	40229134		
21241	1748	40229134	1975-02-28	1975-02-28 00:00:00	1975-03-07	1975-03-07 00:00:00	1975-03-07	38000177		0	0	7		0	0	0	116922	0	1043400	40229134		
27050	2231	19078461	1982-09-03	1982-09-03 00:00:00	1982-11-02	1982-11-02 00:00:00	1982-11-02	38000177		0	0	60		0	0	0	148428	0	310965	19078461		
37544	3103	19128065	1995-05-22	1995-05-22 00:00:00	1996-05-16	1996-05-16 00:00:00	1996-05-16	38000177		0	0	360		0	0	0	206405	0	749882	19128065		
64134	5325	1127433	1973-03-16	1973-03-16 00:00:00	1973-03-30	1973-03-30 00:00:00	1973-03-30	38000177		0	0	14		0	0	0	354492	0	313782	1127433		
7105	597	1127433	1966-10-06	1966-10-06 00:00:00	1966-10-13	1966-10-13 00:00:00	1966-10-13	38000177		0	0	7		0	0	0	39423	0	313782	1127433		
6228	520	19078461	1997-02-25	1997-02-25 00:00:00	1997-03-11	1997-03-11 00:00:00	1997-03-11	38000177		0	0	14		0	0	0	34746	0	310965	19078461		
6281	525	1367571	1952-05-22	1952-05-22 00:00:00	1952-05-22	1952-05-22 00:00:00	1952-05-22	38000177		0	0	0		0	0	0	34958	0	314659	19080464		
85	5	40229134	2015-08-10	2015-08-10 00:00:00	2015-08-17	2015-08-17 00:00:00	2015-08-17	38000177		0	0	7		0	0	0	527	0	1043400	40229134		
140	9	1154615	1982-07-26	1982-07-26 00:00:00	1982-07-26	1982-07-26 00:00:00	\N	38000177		0	0	0		0	0	0	708	0	745679	1154615		
28387	2341	1127433	1953-06-21	1953-06-21 00:00:00	1953-07-05	1953-07-05 00:00:00	1953-07-05	38000177		0	0	14		0	0	0	155850	0	313782	1127433		
28415	2343	1118084	1995-12-25	1995-12-25 00:00:00	1995-12-25	1995-12-25 00:00:00	\N	38000177		0	0	0		0	0	0	155968	0	00025152531	44923712		
28474	2346	19059056	1946-12-03	1946-12-03 00:00:00	1946-12-17	1946-12-17 00:00:00	1946-12-17	38000177		0	0	14		0	0	0	156200	0	243670	19059056		
28528	2351	1127433	1958-07-26	1958-07-26 00:00:00	1958-08-09	1958-08-09 00:00:00	1958-08-09	38000177		0	0	14		0	0	0	156569	0	313782	1127433		
31322	2596	1127078	1977-04-25	1977-04-25 00:00:00	1977-05-25	1977-05-25 00:00:00	1977-05-25	38000177		0	0	30		0	0	0	171761	0	282464	1127078		
53969	4484	1713671	2007-04-05	2007-04-05 00:00:00	2007-04-19	2007-04-19 00:00:00	2007-04-19	38000177		0	0	14		0	0	0	298484	0	562251	1713671		
38064	3147	1127433	1947-11-09	1947-11-09 00:00:00	1947-11-23	1947-11-23 00:00:00	1947-11-23	38000177		0	0	14		0	0	0	209356	0	313782	1127433		
59160	4917	1713671	1985-01-07	1985-01-07 00:00:00	1985-01-14	1985-01-14 00:00:00	1985-01-14	38000177		0	0	7		0	0	0	326750	0	562251	1713671		
21272	462	40213296	2017-12-21	2017-12-21 00:00:00	2017-12-21	2017-12-21 00:00:00	2017-12-21	581452		0	0	0		0	0	0	30900	0	52	40213296		
34919	2883	1127078	1966-01-16	1966-01-16 00:00:00	1966-01-30	1966-01-30 00:00:00	1966-01-30	38000177		0	0	14		0	0	0	191767	0	282464	1127078		
32392	2685	19078461	1974-09-30	1974-09-30 00:00:00	1974-10-14	1974-10-14 00:00:00	1974-10-14	38000177		0	0	14		0	0	0	177898	0	310965	19078461		
34974	2889	1115171	2007-06-12	2007-06-12 00:00:00	2007-07-17	2007-07-17 00:00:00	2007-07-17	38000177		0	0	35		0	0	0	192147	0	849574	1115171		
10203	856	1127433	2011-09-06	2011-09-06 00:00:00	2011-10-06	2011-10-06 00:00:00	2011-10-06	38000177		0	0	30		0	0	0	56576	0	313782	1127433		
23595	1941	1127433	1997-03-18	1997-03-18 00:00:00	1997-04-01	1997-04-01 00:00:00	1997-04-01	38000177		0	0	14		0	0	0	129038	0	313782	1127433		
40990	3399	40229134	1987-01-18	1987-01-18 00:00:00	1987-01-25	1987-01-25 00:00:00	1987-01-25	38000177		0	0	7		0	0	0	225510	0	1043400	40229134		
13304	287	40213296	2018-09-17	2018-09-17 00:00:00	2018-09-17	2018-09-17 00:00:00	2018-09-17	581452		0	0	0		0	0	0	19196	0	52	40213296		
44209	962	40213201	2017-06-02	2017-06-02 00:00:00	2017-06-02	2017-06-02 00:00:00	2017-06-02	581452		0	0	0		0	0	0	64068	0	33	40213201		
13983	1169	1115171	2009-02-21	2009-02-21 00:00:00	2009-03-07	2009-03-07 00:00:00	2009-03-07	38000177		0	0	14		0	0	0	76989	0	849574	1115171		
60897	5065	1539411	2004-03-02	2004-03-02 00:00:00	2004-03-02	2004-03-02 00:00:00	\N	38000177		0	0	0		0	0	0	336744	0	312961	1539411		
14075	1176	1127433	1991-03-01	1991-03-01 00:00:00	1991-04-30	1991-04-30 00:00:00	1991-04-30	38000177		0	0	60		0	0	0	77646	0	313782	1127433		
36586	3019	19074841	1991-08-19	1991-08-19 00:00:00	1991-09-02	1991-09-02 00:00:00	1991-09-02	38000177		0	0	14		0	0	0	201316	0	309043	19074841		
24625	2025	1713671	1915-11-22	1915-11-22 00:00:00	1915-11-29	1915-11-29 00:00:00	1915-11-29	38000177		0	0	7		0	0	0	134769	0	562251	1713671		
44924	3718	1127433	2003-12-03	2003-12-03 00:00:00	2003-12-17	2003-12-17 00:00:00	2003-12-17	38000177		0	0	14		0	0	0	247145	0	313782	1127433		
23249	1916	40229134	1987-07-24	1987-07-24 00:00:00	1987-07-31	1987-07-31 00:00:00	1987-07-31	38000177		0	0	7		0	0	0	127476	0	1043400	40229134		
23300	1921	19059056	1964-08-16	1964-08-16 00:00:00	1964-08-30	1964-08-30 00:00:00	1964-08-30	38000177		0	0	14		0	0	0	127789	0	243670	19059056		
16207	1345	1713671	2011-03-20	2011-03-20 00:00:00	2011-04-03	2011-04-03 00:00:00	2011-04-03	38000177		0	0	14		0	0	0	89128	0	562251	1713671		
16245	1348	40229134	1920-03-15	1920-03-15 00:00:00	1920-03-22	1920-03-22 00:00:00	1920-03-22	38000177		0	0	7		0	0	0	89360	0	1043400	40229134		
26756	2204	1127433	1986-09-18	1986-09-18 00:00:00	1986-09-25	1986-09-25 00:00:00	1986-09-25	38000177		0	0	7		0	0	0	146917	0	313782	1127433		
26790	2206	1127433	2006-08-25	2006-08-25 00:00:00	2006-09-08	2006-09-08 00:00:00	2006-09-08	38000177		0	0	14		0	0	0	147024	0	313782	1127433		
60664	5046	40229134	2009-05-18	2009-05-18 00:00:00	2009-06-01	2009-06-01 00:00:00	2009-06-01	38000177		0	0	14		0	0	0	335365	0	1043400	40229134		
60713	5049	19075601	2002-07-31	2002-07-31 00:00:00	2002-07-31	2002-07-31 00:00:00	2002-07-31	38000177		0	0	0		0	0	0	335546	0	309362	19075601		
35710	2943	1713671	1984-11-22	1984-11-22 00:00:00	1984-11-29	1984-11-29 00:00:00	1984-11-29	38000177		0	0	7		0	0	0	196361	0	562251	1713671		
52069	4330	19006318	1948-06-28	1948-06-28 00:00:00	1948-07-12	1948-07-12 00:00:00	1948-07-12	38000177		0	0	14		0	0	0	287243	0	105078	19006318		
6848	576	19059056	1969-04-17	1969-04-17 00:00:00	1969-05-01	1969-05-01 00:00:00	1969-05-01	38000177		0	0	14		0	0	0	38063	0	243670	19059056		
6891	579	1713671	1986-02-08	1986-02-08 00:00:00	1986-03-01	1986-03-01 00:00:00	1986-03-01	38000177		0	0	21		0	0	0	38291	0	562251	1713671		
33217	2752	1124300	1992-03-27	1992-03-27 00:00:00	1992-03-27	1992-03-27 00:00:00	\N	38000177		0	0	0		0	0	0	182045	0	00781178901	45011828		
61458	5113	1115171	2016-03-14	2016-03-14 00:00:00	2016-04-18	2016-04-18 00:00:00	2016-04-18	38000177		0	0	35		0	0	0	339732	0	849574	1115171		
1175	95	19078461	2013-06-02	2013-06-02 00:00:00	2013-06-23	2013-06-23 00:00:00	2013-06-23	38000177		0	0	21		0	0	0	6468	0	310965	19078461		
17542	1450	19006318	1965-01-13	1965-01-13 00:00:00	1965-01-27	1965-01-27 00:00:00	1965-01-27	38000177		0	0	14		0	0	0	96716	0	105078	19006318		
19335	1597	1127433	1954-07-08	1954-07-08 00:00:00	1954-07-22	1954-07-22 00:00:00	1954-07-22	38000177		0	0	14		0	0	0	107169	0	313782	1127433		
9143	759	1127433	1973-12-23	1973-12-23 00:00:00	1974-01-06	1974-01-06 00:00:00	1974-01-06	38000177		0	0	14		0	0	0	50359	0	313782	1127433		
19391	1599	1127433	1980-05-23	1980-05-23 00:00:00	1980-06-06	1980-06-06 00:00:00	1980-06-06	38000177		0	0	14		0	0	0	107301	0	313782	1127433		
10498	224	40213198	2010-05-04	2010-05-04 00:00:00	2010-05-04	2010-05-04 00:00:00	2010-05-04	581452		0	0	0		0	0	0	15105	0	133	40213198		
47054	3899	19078461	1998-08-19	1998-08-19 00:00:00	1998-09-23	1998-09-23 00:00:00	1998-09-23	38000177		0	0	35		0	0	0	259248	0	310965	19078461		
38733	3200	1713671	1970-12-23	1970-12-23 00:00:00	1971-01-06	1971-01-06 00:00:00	1971-01-06	38000177		0	0	14		0	0	0	212790	0	562251	1713671		
37134	3069	19078461	1991-06-13	1991-06-13 00:00:00	1991-06-27	1991-06-27 00:00:00	1991-06-27	38000177		0	0	14		0	0	0	204313	0	310965	19078461		
19863	1632	1127433	2004-01-07	2004-01-07 00:00:00	2004-01-21	2004-01-21 00:00:00	2004-01-21	38000177		0	0	14		0	0	0	109560	0	313782	1127433		
12905	1084	1127078	1979-09-28	1979-09-28 00:00:00	1979-10-12	1979-10-12 00:00:00	1979-10-12	38000177		0	0	14		0	0	0	71212	0	282464	1127078		
74976	1636	40213227	1998-02-20	1998-02-20 00:00:00	1998-02-20	1998-02-20 00:00:00	1998-02-20	581452		0	0	0		0	0	0	109908	0	113	40213227		
32321	2680	1127433	1975-06-23	1975-06-23 00:00:00	1975-07-07	1975-07-07 00:00:00	1975-07-07	38000177		0	0	14		0	0	0	177539	0	313782	1127433		
30493	2528	19133873	1977-05-30	1977-05-30 00:00:00	1977-06-08	1977-06-08 00:00:00	1977-06-08	38000177		0	0	9		0	0	0	167119	0	834061	19133873		
6640	559	19133905	2005-05-11	2005-05-11 00:00:00	2005-05-18	2005-05-18 00:00:00	2005-05-18	38000177		0	0	7		0	0	0	37111	0	834102	19133905		
34062	2815	1713671	1973-03-06	1973-03-06 00:00:00	1973-03-27	1973-03-27 00:00:00	1973-03-27	38000177		0	0	21		0	0	0	186548	0	562251	1713671		
9761	817	19128065	1976-04-16	1976-04-16 00:00:00	1977-04-11	1977-04-11 00:00:00	1977-04-11	38000177		0	0	360		0	0	0	54142	0	749882	19128065		
20264	1661	40165015	1991-06-13	1991-06-13 00:00:00	1991-06-13	1991-06-13 00:00:00	\N	38000177		0	0	0		0	0	0	111654	0	861467	40165015		
21242	1748	19006318	1948-03-28	1948-03-28 00:00:00	1948-04-11	1948-04-11 00:00:00	1948-04-11	38000177		0	0	14		0	0	0	116928	0	105078	19006318		
27051	2231	40231925	1982-09-03	1982-09-03 00:00:00	1982-09-03	1982-09-03 00:00:00	\N	38000177		0	0	0		0	0	0	148428	0	1049221	40231925		
37548	3105	40229134	2016-07-02	2016-07-02 00:00:00	2016-07-16	2016-07-16 00:00:00	2016-07-16	38000177		0	0	14		0	0	0	206492	0	1043400	40229134		
64135	5325	19006318	1946-06-05	1946-06-05 00:00:00	1946-06-19	1946-06-19 00:00:00	1946-06-19	38000177		0	0	14		0	0	0	354450	0	105078	19006318		
7106	597	19133905	1970-06-30	1970-06-30 00:00:00	1970-07-13	1970-07-13 00:00:00	1970-07-13	38000177		0	0	13		0	0	0	39446	0	834102	19133905		
38425	3177	40163554	2012-05-09	2012-05-09 00:00:00	2012-05-09	2012-05-09 00:00:00	\N	38000177		0	0	0		0	0	0	211369	0	855332	40163554		
6282	525	35605482	1952-05-22	1952-05-22 00:00:00	1952-05-22	1952-05-22 00:00:00	1952-05-22	38000177		0	0	0		0	0	0	34958	0	1740467	35605482		
86	5	19133873	1980-08-05	1980-08-05 00:00:00	1980-08-18	1980-08-18 00:00:00	1980-08-18	38000177		0	0	13		0	0	0	478	0	834061	19133873		
141	9	1127433	1985-06-15	1985-06-15 00:00:00	1985-06-29	1985-06-29 00:00:00	1985-06-29	38000177		0	0	14		0	0	0	723	0	313782	1127433		
28388	2341	1127078	1954-05-16	1954-05-16 00:00:00	1954-08-14	1954-08-14 00:00:00	1954-08-14	38000177		0	0	90		0	0	0	155800	0	282464	1127078		
28416	2343	40229134	1990-07-11	1990-07-11 00:00:00	1990-07-25	1990-07-25 00:00:00	1990-07-25	38000177		0	0	14		0	0	0	155935	0	1043400	40229134		
28475	2346	19006318	1946-12-03	1946-12-03 00:00:00	1946-12-17	1946-12-17 00:00:00	1946-12-17	38000177		0	0	14		0	0	0	156200	0	105078	19006318		
28529	2351	1115171	2011-09-30	2011-09-30 00:00:00	2011-10-14	2011-10-14 00:00:00	2011-10-14	38000177		0	0	14		0	0	0	156511	0	849574	1115171		
31323	2597	1127433	1990-06-26	1990-06-26 00:00:00	1990-07-24	1990-07-24 00:00:00	1990-07-24	38000177		0	0	28		0	0	0	171857	0	313782	1127433		
53970	4484	1127433	2011-09-09	2011-09-09 00:00:00	2011-09-16	2011-09-16 00:00:00	2011-09-16	38000177		0	0	7		0	0	0	298465	0	313782	1127433		
38065	3147	19059056	1964-08-09	1964-08-09 00:00:00	1964-09-06	1964-09-06 00:00:00	1964-09-06	38000177		0	0	28		0	0	0	209352	0	243670	19059056		
59161	4917	19133873	1996-04-04	1996-04-04 00:00:00	1996-04-16	1996-04-16 00:00:00	1996-04-16	38000177		0	0	12		0	0	0	326758	0	834061	19133873		
21274	462	40213227	2008-02-21	2008-02-21 00:00:00	2008-02-21	2008-02-21 00:00:00	2008-02-21	581452		0	0	0		0	0	0	30916	0	113	40213227		
34920	2883	40229134	1994-03-14	1994-03-14 00:00:00	1994-03-28	1994-03-28 00:00:00	1994-03-28	38000177		0	0	14		0	0	0	191770	0	1043400	40229134		
32393	2685	40169281	1968-01-04	1968-01-04 00:00:00	1968-01-04	1968-01-04 00:00:00	\N	38000177		0	0	0		0	0	0	177921	0	896209	40169281		
34975	2889	1118084	2002-02-23	2002-02-23 00:00:00	2002-02-23	2002-02-23 00:00:00	\N	38000177		0	0	0		0	0	0	192151	0	00025152531	44923712		
10204	856	46233988	1971-10-16	1971-10-16 00:00:00	1971-10-30	1971-10-30 00:00:00	1971-10-30	38000177		0	0	14		0	0	0	56541	0	1652673	46233988		
23596	1941	19059056	1974-01-11	1974-01-11 00:00:00	1974-02-01	1974-02-01 00:00:00	1974-02-01	38000177		0	0	21		0	0	0	129098	0	243670	19059056		
40991	3399	1115171	2019-01-29	2019-01-29 00:00:00	2019-02-19	2019-02-19 00:00:00	2019-02-19	38000177		0	0	21		0	0	0	225521	0	849574	1115171		
13307	287	40213160	1976-08-23	1976-08-23 00:00:00	1976-08-23	1976-08-23 00:00:00	1976-08-23	581452		0	0	0		0	0	0	19199	0	10	40213160		
27562	600	40213227	1995-04-26	1995-04-26 00:00:00	1995-04-26	1995-04-26 00:00:00	1995-04-26	581452		0	0	0		0	0	0	39634	0	113	40213227		
14009	1173	19078461	1982-09-22	1982-09-22 00:00:00	1982-10-06	1982-10-06 00:00:00	1982-10-06	38000177		0	0	14		0	0	0	77275	0	310965	19078461		
60898	5065	19075601	2004-03-02	2004-03-02 00:00:00	2005-03-15	2005-03-15 00:00:00	2005-03-15	38000177		0	0	378		0	0	0	336744	0	309362	19075601		
14076	1176	40229134	1981-07-29	1981-07-29 00:00:00	1981-08-12	1981-08-12 00:00:00	1981-08-12	38000177		0	0	14		0	0	0	77652	0	1043400	40229134		
36587	3019	19133873	1988-05-08	1988-05-08 00:00:00	1988-05-21	1988-05-21 00:00:00	1988-05-21	38000177		0	0	13		0	0	0	201353	0	834061	19133873		
24626	2025	19133905	2012-01-28	2012-01-28 00:00:00	2012-02-05	2012-02-05 00:00:00	2012-02-05	38000177		0	0	8		0	0	0	134724	0	834102	19133905		
44926	3718	19077572	2016-10-31	2016-10-31 00:00:00	2016-10-31	2016-10-31 00:00:00	\N	38000177		0	0	0		0	0	0	247148	0	310436	19077572		
23250	1916	1127433	1984-02-12	1984-02-12 00:00:00	1984-02-26	1984-02-26 00:00:00	1984-02-26	38000177		0	0	14		0	0	0	127424	0	313782	1127433		
23301	1921	40229134	1955-02-06	1955-02-06 00:00:00	1955-02-13	1955-02-13 00:00:00	1955-02-13	38000177		0	0	7		0	0	0	127729	0	1043400	40229134		
16208	1345	1127433	2013-10-13	2013-10-13 00:00:00	2013-10-20	2013-10-20 00:00:00	2013-10-20	38000177		0	0	7		0	0	0	89129	0	313782	1127433		
26198	2155	1127433	1986-12-24	1986-12-24 00:00:00	1987-01-28	1987-01-28 00:00:00	1987-01-28	38000177		0	0	35		0	0	0	143616	0	313782	1127433		
26757	2204	1127433	1980-04-07	1980-04-07 00:00:00	1980-04-21	1980-04-21 00:00:00	1980-04-21	38000177		0	0	14		0	0	0	146879	0	313782	1127433		
26791	2206	42902245	2001-09-06	2001-09-06 00:00:00	2002-09-01	2002-09-01 00:00:00	2002-09-01	38000177		0	0	360		0	0	0	147014	0	1359133	42902245		
60665	5046	1115171	2000-05-06	2000-05-06 00:00:00	2000-05-20	2000-05-20 00:00:00	2000-05-20	38000177		0	0	14		0	0	0	335341	0	849574	1115171		
60714	5049	40220960	2002-07-31	2002-07-31 00:00:00	2002-07-31	2002-07-31 00:00:00	2002-07-31	38000177		0	0	0		0	0	0	335546	0	1804799	40220960		
35711	2943	19059056	1946-10-14	1946-10-14 00:00:00	1946-11-04	1946-11-04 00:00:00	1946-11-04	38000177		0	0	21		0	0	0	196248	0	243670	19059056		
52070	4330	1127078	1953-07-13	1953-07-13 00:00:00	1953-07-27	1953-07-27 00:00:00	1953-07-27	38000177		0	0	14		0	0	0	287257	0	282464	1127078		
6849	576	1127433	2015-06-01	2015-06-01 00:00:00	2015-06-08	2015-06-08 00:00:00	2015-06-08	38000177		0	0	7		0	0	0	38103	0	313782	1127433		
6892	579	19078461	1998-12-06	1998-12-06 00:00:00	1999-01-03	1999-01-03 00:00:00	1999-01-03	38000177		0	0	28		0	0	0	38338	0	310965	19078461		
33218	2752	19006318	1960-01-15	1960-01-15 00:00:00	1960-01-28	1960-01-28 00:00:00	1960-01-28	38000177		0	0	13		0	0	0	182024	0	105078	19006318		
61459	5113	19133905	2013-05-02	2013-05-02 00:00:00	2013-05-11	2013-05-11 00:00:00	2013-05-11	38000177		0	0	9		0	0	0	339669	0	834102	19133905		
1176	95	19133873	1965-11-18	1965-11-18 00:00:00	1965-11-25	1965-11-25 00:00:00	1965-11-25	38000177		0	0	7		0	0	0	6453	0	834061	19133873		
17543	1450	40229134	1999-11-03	1999-11-03 00:00:00	1999-11-17	1999-11-17 00:00:00	1999-11-17	38000177		0	0	14		0	0	0	96740	0	1043400	40229134		
19336	1597	19059056	1956-04-11	1956-04-11 00:00:00	1956-05-02	1956-05-02 00:00:00	1956-05-02	38000177		0	0	21		0	0	0	107116	0	243670	19059056		
9144	760	1127433	1966-11-16	1966-11-16 00:00:00	1966-11-23	1966-11-23 00:00:00	1966-11-23	38000177		0	0	7		0	0	0	50495	0	313782	1127433		
19392	1599	1127433	1972-11-19	1972-11-19 00:00:00	1972-12-03	1972-12-03 00:00:00	1972-12-03	38000177		0	0	14		0	0	0	107291	0	313782	1127433		
10501	224	40213201	2009-04-28	2009-04-28 00:00:00	2009-04-28	2009-04-28 00:00:00	2009-04-28	581452		0	0	0		0	0	0	15069	0	33	40213201		
47055	3899	1127433	2003-12-18	2003-12-18 00:00:00	2003-12-25	2003-12-25 00:00:00	2003-12-25	38000177		0	0	7		0	0	0	259267	0	313782	1127433		
38734	3200	19006318	1948-04-13	1948-04-13 00:00:00	1948-04-27	1948-04-27 00:00:00	1948-04-27	38000177		0	0	14		0	0	0	212835	0	105078	19006318		
37135	3069	1127433	1997-04-26	1997-04-26 00:00:00	1997-05-10	1997-05-10 00:00:00	1997-05-10	38000177		0	0	14		0	0	0	204314	0	313782	1127433		
19864	1632	19133873	1966-02-18	1966-02-18 00:00:00	1966-02-27	1966-02-27 00:00:00	1966-02-27	38000177		0	0	9		0	0	0	109588	0	834061	19133873		
12906	1084	19128065	2002-11-06	2002-11-06 00:00:00	2003-11-01	2003-11-01 00:00:00	2003-11-01	38000177		0	0	360		0	0	0	71213	0	749882	19128065		
57703	4795	19128065	1981-10-20	1981-10-20 00:00:00	1982-10-15	1982-10-15 00:00:00	1982-10-15	38000177		0	0	360		0	0	0	319025	0	749882	19128065		
32322	2680	1127433	1987-05-11	1987-05-11 00:00:00	1987-08-09	1987-08-09 00:00:00	1987-08-09	38000177		0	0	90		0	0	0	177556	0	313782	1127433		
30494	2528	40229134	2011-03-28	2011-03-28 00:00:00	2011-04-11	2011-04-11 00:00:00	2011-04-11	38000177		0	0	14		0	0	0	167121	0	1043400	40229134		
17099	1415	1127433	2004-06-05	2004-06-05 00:00:00	2004-07-05	2004-07-05 00:00:00	2004-07-05	38000177		0	0	30		0	0	0	94213	0	313782	1127433		
34085	2818	19019979	1977-09-01	1977-09-01 00:00:00	1977-09-22	1977-09-22 00:00:00	1977-09-22	38000177		0	0	21		0	0	0	186728	0	198405	19019979		
9762	817	19133873	1970-01-22	1970-01-22 00:00:00	1970-01-29	1970-01-29 00:00:00	1970-01-29	38000177		0	0	7		0	0	0	54131	0	834061	19133873		
20265	1661	19059056	1991-06-13	1991-06-13 00:00:00	1991-08-12	1991-08-12 00:00:00	1991-08-12	38000177		0	0	60		0	0	0	111654	0	243670	19059056		
21243	1748	19059056	1948-03-28	1948-03-28 00:00:00	1948-04-11	1948-04-11 00:00:00	1948-04-11	38000177		0	0	14		0	0	0	116928	0	243670	19059056		
27052	2231	1118084	2008-07-18	2008-07-18 00:00:00	2008-07-18	2008-07-18 00:00:00	\N	38000177		0	0	0		0	0	0	148452	0	00025152531	44923712		
37549	3105	19059056	1970-11-22	1970-11-22 00:00:00	1970-12-20	1970-12-20 00:00:00	1970-12-20	38000177		0	0	28		0	0	0	206480	0	243670	19059056		
64136	5325	19059056	1946-06-05	1946-06-05 00:00:00	1946-06-19	1946-06-19 00:00:00	1946-06-19	38000177		0	0	14		0	0	0	354450	0	243670	19059056		
7107	597	19059056	1967-09-14	1967-09-14 00:00:00	1967-09-28	1967-09-28 00:00:00	1967-09-28	38000177		0	0	14		0	0	0	39456	0	243670	19059056		
38426	3177	19018935	2012-05-09	2012-05-09 00:00:00	2012-05-09	2012-05-09 00:00:00	\N	38000177		0	0	0		0	0	0	211369	0	197604	19018935		
6283	525	35605482	1952-05-22	1952-05-22 00:00:00	1952-05-22	1952-05-22 00:00:00	1952-05-22	38000177		0	0	0		0	0	0	34958	0	1740467	35605482		
87	6	1115171	2004-05-09	2004-05-09 00:00:00	2004-05-23	2004-05-23 00:00:00	2004-05-23	38000177		0	0	14		0	0	0	561	0	849574	1115171		
149	11	1127433	1966-10-25	1966-10-25 00:00:00	1966-11-08	1966-11-08 00:00:00	1966-11-08	38000177		0	0	14		0	0	0	943	0	313782	1127433		
28389	2342	1127433	1985-06-27	1985-06-27 00:00:00	1985-07-11	1985-07-11 00:00:00	1985-07-11	38000177		0	0	14		0	0	0	155910	0	313782	1127433		
28417	2343	19133873	1965-03-30	1965-03-30 00:00:00	1965-04-10	1965-04-10 00:00:00	1965-04-10	38000177		0	0	11		0	0	0	156000	0	834061	19133873		
28476	2346	19133905	2019-02-13	2019-02-13 00:00:00	2019-02-21	2019-02-21 00:00:00	2019-02-21	38000177		0	0	8		0	0	0	156172	0	834102	19133905		
28530	2351	19059056	1964-03-07	1964-03-07 00:00:00	1964-05-06	1964-05-06 00:00:00	1964-05-06	38000177		0	0	60		0	0	0	156505	0	243670	19059056		
31324	2597	1127433	1996-06-04	1996-06-04 00:00:00	1996-06-18	1996-06-18 00:00:00	1996-06-18	38000177		0	0	14		0	0	0	171832	0	313782	1127433		
53971	4484	1115171	2003-02-17	2003-02-17 00:00:00	2003-03-03	2003-03-03 00:00:00	2003-03-03	38000177		0	0	14		0	0	0	298469	0	849574	1115171		
38066	3147	40169281	1973-02-12	1973-02-12 00:00:00	1973-02-12	1973-02-12 00:00:00	\N	38000177		0	0	0		0	0	0	209439	0	896209	40169281		
59162	4917	1115171	1994-12-16	1994-12-16 00:00:00	1994-12-30	1994-12-30 00:00:00	1994-12-30	38000177		0	0	14		0	0	0	326748	0	849574	1115171		
21278	462	40213227	2017-12-21	2017-12-21 00:00:00	2017-12-21	2017-12-21 00:00:00	2017-12-21	581452		0	0	0		0	0	0	30900	0	113	40213227		
2469	196	19006318	1956-04-08	1956-04-08 00:00:00	1956-04-22	1956-04-22 00:00:00	1956-04-22	38000177		0	0	14		0	0	0	13521	0	105078	19006318		
32394	2685	1127433	1952-10-13	1952-10-13 00:00:00	1952-10-27	1952-10-27 00:00:00	1952-10-27	38000177		0	0	14		0	0	0	177944	0	313782	1127433		
34976	2889	19133873	1969-09-29	1969-09-29 00:00:00	1969-10-12	1969-10-12 00:00:00	1969-10-12	38000177		0	0	13		0	0	0	192123	0	834061	19133873		
10205	856	19059056	1971-10-16	1971-10-16 00:00:00	1971-10-30	1971-10-30 00:00:00	1971-10-30	38000177		0	0	14		0	0	0	56541	0	243670	19059056		
23597	1941	19059056	1973-03-17	1973-03-17 00:00:00	1973-03-31	1973-03-31 00:00:00	1973-03-31	38000177		0	0	14		0	0	0	129092	0	243670	19059056		
40992	3399	1118084	2016-08-13	2016-08-13 00:00:00	2016-08-13	2016-08-13 00:00:00	\N	38000177		0	0	0		0	0	0	225446	0	00025152531	44923712		
4815	403	19078461	2018-01-30	2018-01-30 00:00:00	2018-02-13	2018-02-13 00:00:00	2018-02-13	38000177		0	0	14		0	0	0	26467	0	310965	19078461		
27564	600	40213227	2015-07-22	2015-07-22 00:00:00	2015-07-22	2015-07-22 00:00:00	2015-07-22	581452		0	0	0		0	0	0	39601	0	113	40213227		
14010	1173	1713671	2009-01-23	2009-01-23 00:00:00	2009-02-13	2009-02-13 00:00:00	2009-02-13	38000177		0	0	21		0	0	0	77271	0	562251	1713671		
60899	5065	1127433	1984-06-23	1984-06-23 00:00:00	1984-07-07	1984-07-07 00:00:00	1984-07-07	38000177		0	0	14		0	0	0	336702	0	313782	1127433		
14077	1176	40229134	2002-02-24	2002-02-24 00:00:00	2002-03-03	2002-03-03 00:00:00	2002-03-03	38000177		0	0	7		0	0	0	77636	0	1043400	40229134		
36588	3019	1127433	2001-03-01	2001-03-01 00:00:00	2001-03-15	2001-03-15 00:00:00	2001-03-15	38000177		0	0	14		0	0	0	201333	0	313782	1127433		
24627	2025	1127433	1953-08-25	1953-08-25 00:00:00	1953-09-01	1953-09-01 00:00:00	1953-09-01	38000177		0	0	7		0	0	0	134666	0	313782	1127433		
44927	3718	19129655	1966-03-24	1966-03-24 00:00:00	1966-04-07	1966-04-07 00:00:00	1966-04-07	38000177		0	0	14		0	0	0	247083	0	789980	19129655		
23251	1916	1118084	2007-05-13	2007-05-13 00:00:00	2007-05-13	2007-05-13 00:00:00	\N	38000177		0	0	0		0	0	0	127498	0	00025152531	44923712		
23302	1921	1127433	2016-01-19	2016-01-19 00:00:00	2016-02-09	2016-02-09 00:00:00	2016-02-09	38000177		0	0	21		0	0	0	127793	0	313782	1127433		
16209	1345	46233988	1967-11-05	1967-11-05 00:00:00	1967-11-19	1967-11-19 00:00:00	1967-11-19	38000177		0	0	14		0	0	0	89169	0	1652673	46233988		
26199	2155	19133905	1979-09-19	1979-09-19 00:00:00	1979-10-02	1979-10-02 00:00:00	1979-10-02	38000177		0	0	13		0	0	0	143655	0	834102	19133905		
26758	2204	19059056	1959-07-30	1959-07-30 00:00:00	1959-08-13	1959-08-13 00:00:00	1959-08-13	38000177		0	0	14		0	0	0	146927	0	243670	19059056		
26792	2206	19128065	1997-09-27	1997-09-27 00:00:00	1998-09-22	1998-09-22 00:00:00	1998-09-22	38000177		0	0	360		0	0	0	147004	0	749882	19128065		
60666	5046	19006318	1961-12-10	1961-12-10 00:00:00	1961-12-24	1961-12-24 00:00:00	1961-12-24	38000177		0	0	14		0	0	0	335347	0	105078	19006318		
60715	5049	19078461	1999-07-07	1999-07-07 00:00:00	1999-07-28	1999-07-28 00:00:00	1999-07-28	38000177		0	0	21		0	0	0	335587	0	310965	19078461		
35712	2943	1118084	1952-11-08	1952-11-08 00:00:00	1952-11-08	1952-11-08 00:00:00	\N	38000177		0	0	0		0	0	0	196292	0	00025152531	44923712		
52071	4330	1713671	2006-06-03	2006-06-03 00:00:00	2006-06-24	2006-06-24 00:00:00	2006-06-24	38000177		0	0	21		0	0	0	287197	0	562251	1713671		
6850	576	19133905	1997-07-31	1997-07-31 00:00:00	1997-08-13	1997-08-13 00:00:00	1997-08-13	38000177		0	0	13		0	0	0	38073	0	834102	19133905		
6893	579	1118084	1999-08-30	1999-08-30 00:00:00	1999-08-30	1999-08-30 00:00:00	\N	38000177		0	0	0		0	0	0	38338	0	00025152531	44923712		
33219	2752	1127433	1989-12-07	1989-12-07 00:00:00	1989-12-14	1989-12-14 00:00:00	1989-12-14	38000177		0	0	7		0	0	0	182031	0	313782	1127433		
61460	5113	1127078	1981-02-06	1981-02-06 00:00:00	1981-02-27	1981-02-27 00:00:00	1981-02-27	38000177		0	0	21		0	0	0	339726	0	282464	1127078		
1177	95	1118084	1993-06-06	1993-06-06 00:00:00	1993-06-06	1993-06-06 00:00:00	\N	38000177		0	0	0		0	0	0	6425	0	00025152531	44923712		
17544	1450	1127433	1995-02-09	1995-02-09 00:00:00	1995-02-16	1995-02-16 00:00:00	1995-02-16	38000177		0	0	7		0	0	0	96694	0	313782	1127433		
19337	1597	1127433	1969-12-04	1969-12-04 00:00:00	1969-12-25	1969-12-25 00:00:00	1969-12-25	38000177		0	0	21		0	0	0	107120	0	313782	1127433		
9145	760	1118084	1998-01-01	1998-01-01 00:00:00	1998-01-01	1998-01-01 00:00:00	\N	38000177		0	0	0		0	0	0	50480	0	00025152531	44923712		
19393	1599	19133873	1962-11-26	1962-11-26 00:00:00	1962-12-03	1962-12-03 00:00:00	1962-12-03	38000177		0	0	7		0	0	0	107285	0	834061	19133873		
10514	224	40213227	2014-05-27	2014-05-27 00:00:00	2014-05-27	2014-05-27 00:00:00	2014-05-27	581452		0	0	0		0	0	0	15107	0	113	40213227		
47056	3899	1118084	2015-07-08	2015-07-08 00:00:00	2015-07-08	2015-07-08 00:00:00	\N	38000177		0	0	0		0	0	0	259276	0	00025152531	44923712		
38735	3200	19059056	1948-04-13	1948-04-13 00:00:00	1948-04-27	1948-04-27 00:00:00	1948-04-27	38000177		0	0	14		0	0	0	212835	0	243670	19059056		
37136	3069	19133873	1967-07-30	1967-07-30 00:00:00	1967-08-08	1967-08-08 00:00:00	1967-08-08	38000177		0	0	9		0	0	0	204285	0	834061	19133873		
19865	1632	19133873	1962-07-26	1962-07-26 00:00:00	1962-08-05	1962-08-05 00:00:00	1962-08-05	38000177		0	0	10		0	0	0	109587	0	834061	19133873		
12907	1084	19127904	2004-10-26	2004-10-26 00:00:00	2005-10-21	2005-10-21 00:00:00	2005-10-21	38000177		0	0	360		0	0	0	71214	0	748856	19127904		
57704	4795	40229134	1977-11-22	1977-11-22 00:00:00	1977-12-06	1977-12-06 00:00:00	1977-12-06	38000177		0	0	14		0	0	0	319021	0	1043400	40229134		
32323	2680	1713671	2008-12-26	2008-12-26 00:00:00	2009-01-02	2009-01-02 00:00:00	2009-01-02	38000177		0	0	7		0	0	0	177521	0	562251	1713671		
30495	2528	19133873	1978-09-04	1978-09-04 00:00:00	1978-09-12	1978-09-12 00:00:00	1978-09-12	38000177		0	0	8		0	0	0	167087	0	834061	19133873		
17100	1415	1127433	1988-09-15	1988-09-15 00:00:00	1988-09-22	1988-09-22 00:00:00	1988-09-22	38000177		0	0	7		0	0	0	94196	0	313782	1127433		
34086	2818	19078461	1989-04-06	1989-04-06 00:00:00	1989-04-27	1989-04-27 00:00:00	1989-04-27	38000177		0	0	21		0	0	0	186730	0	310965	19078461		
9764	817	19078461	2012-12-26	2012-12-26 00:00:00	2013-02-01	2013-02-01 00:00:00	2013-02-01	38000177		0	0	37		0	0	0	54111	0	310965	19078461		
20266	1661	1127433	1980-05-24	1980-05-24 00:00:00	1980-06-14	1980-06-14 00:00:00	1980-06-14	38000177		0	0	21		0	0	0	111651	0	313782	1127433		
21244	1748	19133873	1949-05-23	1949-05-23 00:00:00	1949-06-01	1949-06-01 00:00:00	1949-06-01	38000177		0	0	9		0	0	0	116915	0	834061	19133873		
27053	2231	19078461	2017-07-06	2017-07-06 00:00:00	2017-07-27	2017-07-27 00:00:00	2017-07-27	38000177		0	0	21		0	0	0	148472	0	310965	19078461		
37550	3105	19059056	1972-02-29	1972-02-29 00:00:00	1972-03-14	1972-03-14 00:00:00	1972-03-14	38000177		0	0	14		0	0	0	206494	0	243670	19059056		
64137	5325	19059056	1948-11-21	1948-11-21 00:00:00	1948-12-21	1948-12-21 00:00:00	1948-12-21	38000177		0	0	30		0	0	0	354435	0	243670	19059056		
7108	597	1127433	2015-07-27	2015-07-27 00:00:00	2015-08-03	2015-08-03 00:00:00	2015-08-03	38000177		0	0	7		0	0	0	39426	0	313782	1127433		
38427	3177	19075601	2012-05-30	2012-05-30 00:00:00	2012-05-30	2012-05-30 00:00:00	2012-05-30	38000177		0	0	0		0	0	0	211369	0	309362	19075601		
6284	525	782047	1952-05-22	1952-05-22 00:00:00	1952-05-22	1952-05-22 00:00:00	1952-05-22	38000177		0	0	0		0	0	0	34958	0	542347	782047		
88	6	1115171	2005-06-17	2005-06-17 00:00:00	2005-07-22	2005-07-22 00:00:00	2005-07-22	38000177		0	0	35		0	0	0	562	0	849574	1115171		
150	11	19133873	1966-04-08	1966-04-08 00:00:00	1966-04-19	1966-04-19 00:00:00	1966-04-19	38000177		0	0	11		0	0	0	953	0	834061	19133873		
28390	2342	1127078	1976-05-11	1976-05-11 00:00:00	1976-05-25	1976-05-25 00:00:00	1976-05-25	38000177		0	0	14		0	0	0	155898	0	282464	1127078		
28418	2344	19006318	1967-07-07	1967-07-07 00:00:00	1967-07-21	1967-07-21 00:00:00	1967-07-21	38000177		0	0	14		0	0	0	156077	0	105078	19006318		
28477	2346	1713671	2004-12-03	2004-12-03 00:00:00	2004-12-17	2004-12-17 00:00:00	2004-12-17	38000177		0	0	14		0	0	0	156152	0	562251	1713671		
28531	2351	1127433	1993-07-22	1993-07-22 00:00:00	1993-10-20	1993-10-20 00:00:00	1993-10-20	38000177		0	0	90		0	0	0	156509	0	313782	1127433		
31325	2597	1713671	1990-12-15	1990-12-15 00:00:00	1990-12-22	1990-12-22 00:00:00	1990-12-22	38000177		0	0	7		0	0	0	171846	0	562251	1713671		
53972	4484	19074841	2003-02-17	2003-02-17 00:00:00	2003-03-03	2003-03-03 00:00:00	2003-03-03	38000177		0	0	14		0	0	0	298469	0	309043	19074841		
38067	3147	19059056	1949-10-27	1949-10-27 00:00:00	1949-11-10	1949-11-10 00:00:00	1949-11-10	38000177		0	0	14		0	0	0	209341	0	243670	19059056		
9252	197	40213227	2001-09-23	2001-09-23 00:00:00	2001-09-23	2001-09-23 00:00:00	2001-09-23	581452		0	0	0		0	0	0	13544	0	113	40213227		
21284	462	40213160	1977-02-24	1977-02-24 00:00:00	1977-02-24	1977-02-24 00:00:00	1977-02-24	581452		0	0	0		0	0	0	30870	0	10	40213160		
2470	196	40229134	2008-08-31	2008-08-31 00:00:00	2008-09-14	2008-09-14 00:00:00	2008-09-14	38000177		0	0	14		0	0	0	13520	0	1043400	40229134		
32395	2685	1127433	1943-02-25	1943-02-25 00:00:00	1943-03-04	1943-03-04 00:00:00	1943-03-04	38000177		0	0	7		0	0	0	177923	0	313782	1127433		
34977	2890	1127433	1991-07-13	1991-07-13 00:00:00	1991-07-27	1991-07-27 00:00:00	1991-07-27	38000177		0	0	14		0	0	0	192222	0	313782	1127433		
10206	856	19133873	1982-04-24	1982-04-24 00:00:00	1982-05-05	1982-05-05 00:00:00	1982-05-05	38000177		0	0	11		0	0	0	56526	0	834061	19133873		
23598	1941	19006318	1973-03-17	1973-03-17 00:00:00	1973-03-31	1973-03-31 00:00:00	1973-03-31	38000177		0	0	14		0	0	0	129092	0	105078	19006318		
40993	3399	1115171	2000-04-09	2000-04-09 00:00:00	2000-06-08	2000-06-08 00:00:00	2000-06-08	38000177		0	0	60		0	0	0	225520	0	849574	1115171		
4816	403	1127433	1951-12-18	1951-12-18 00:00:00	1952-01-01	1952-01-01 00:00:00	1952-01-01	38000177		0	0	14		0	0	0	26512	0	313782	1127433		
27566	600	40213160	1955-06-15	1955-06-15 00:00:00	1955-06-15	1955-06-15 00:00:00	1955-06-15	581452		0	0	0		0	0	0	39623	0	10	40213160		
14011	1173	19133873	1951-03-11	1951-03-11 00:00:00	1951-03-22	1951-03-22 00:00:00	1951-03-22	38000177		0	0	11		0	0	0	77206	0	834061	19133873		
60900	5065	1713671	1969-10-09	1969-10-09 00:00:00	1969-10-16	1969-10-16 00:00:00	1969-10-16	38000177		0	0	7		0	0	0	336709	0	562251	1713671		
14078	1176	19059056	1966-12-16	1966-12-16 00:00:00	1966-12-30	1966-12-30 00:00:00	1966-12-30	38000177		0	0	14		0	0	0	77713	0	243670	19059056		
36589	3019	1127433	1992-04-15	1992-04-15 00:00:00	1992-05-15	1992-05-15 00:00:00	1992-05-15	38000177		0	0	30		0	0	0	201346	0	313782	1127433		
24628	2026	1127433	2009-02-11	2009-02-11 00:00:00	2009-02-25	2009-02-25 00:00:00	2009-02-25	38000177		0	0	14		0	0	0	134858	0	313782	1127433		
44928	3718	1127078	1966-03-24	1966-03-24 00:00:00	1966-04-07	1966-04-07 00:00:00	1966-04-07	38000177		0	0	14		0	0	0	247083	0	282464	1127078		
23252	1916	1713671	1995-10-10	1995-10-10 00:00:00	1995-10-31	1995-10-31 00:00:00	1995-10-31	38000177		0	0	21		0	0	0	127464	0	562251	1713671		
23303	1921	1127433	2003-03-13	2003-03-13 00:00:00	2003-03-20	2003-03-20 00:00:00	2003-03-20	38000177		0	0	7		0	0	0	127747	0	313782	1127433		
16210	1345	1127078	1967-11-05	1967-11-05 00:00:00	1967-11-19	1967-11-19 00:00:00	1967-11-19	38000177		0	0	14		0	0	0	89169	0	282464	1127078		
26200	2155	40220960	2006-02-08	2006-02-08 00:00:00	2006-02-08	2006-02-08 00:00:00	2006-02-08	38000177		0	0	0		0	0	0	143621	0	1804799	40220960		
26759	2204	1127433	1965-08-11	1965-08-11 00:00:00	1965-08-25	1965-08-25 00:00:00	1965-08-25	38000177		0	0	14		0	0	0	146878	0	313782	1127433		
26793	2206	19128022	1993-10-18	1993-10-18 00:00:00	1994-10-13	1994-10-13 00:00:00	1994-10-13	38000177		0	0	360		0	0	0	147000	0	749785	19128022		
60667	5046	19059056	1961-12-10	1961-12-10 00:00:00	1961-12-24	1961-12-24 00:00:00	1961-12-24	38000177		0	0	14		0	0	0	335347	0	243670	19059056		
60716	5049	1118084	1998-12-08	1998-12-08 00:00:00	1998-12-08	1998-12-08 00:00:00	\N	38000177		0	0	0		0	0	0	335562	0	00025152531	44923712		
35713	2943	19059056	1920-02-14	1920-02-14 00:00:00	1920-03-13	1920-03-13 00:00:00	1920-03-13	38000177		0	0	28		0	0	0	196244	0	243670	19059056		
52072	4330	1127433	1977-08-29	1977-08-29 00:00:00	1977-09-12	1977-09-12 00:00:00	1977-09-12	38000177		0	0	14		0	0	0	287183	0	313782	1127433		
6858	578	46233988	1968-11-21	1968-11-21 00:00:00	1968-12-05	1968-12-05 00:00:00	1968-12-05	38000177		0	0	14		0	0	0	38281	0	1652673	46233988		
6894	580	19059056	1946-02-07	1946-02-07 00:00:00	1946-02-28	1946-02-28 00:00:00	1946-02-28	38000177		0	0	21		0	0	0	38401	0	243670	19059056		
33220	2752	40229134	1964-12-08	1964-12-08 00:00:00	1964-12-15	1964-12-15 00:00:00	1964-12-15	38000177		0	0	7		0	0	0	182060	0	1043400	40229134		
61461	5113	1118084	2004-03-26	2004-03-26 00:00:00	2004-03-26	2004-03-26 00:00:00	\N	38000177		0	0	0		0	0	0	339695	0	00025152531	44923712		
1178	95	1127433	2002-08-01	2002-08-01 00:00:00	2002-08-29	2002-08-29 00:00:00	2002-08-29	38000177		0	0	28		0	0	0	6466	0	313782	1127433		
17545	1450	1127078	1968-09-03	1968-09-03 00:00:00	1968-09-17	1968-09-17 00:00:00	1968-09-17	38000177		0	0	14		0	0	0	96682	0	282464	1127078		
19338	1597	19133873	1960-10-01	1960-10-01 00:00:00	1960-10-11	1960-10-11 00:00:00	1960-10-11	38000177		0	0	10		0	0	0	107107	0	834061	19133873		
9146	760	1127433	1992-09-13	1992-09-13 00:00:00	1992-10-04	1992-10-04 00:00:00	1992-10-04	38000177		0	0	21		0	0	0	50510	0	313782	1127433		
19395	1599	40229134	1962-09-28	1962-09-28 00:00:00	1962-10-12	1962-10-12 00:00:00	1962-10-12	38000177		0	0	14		0	0	0	107321	0	1043400	40229134		
44081	3650	19078461	1984-12-13	1984-12-13 00:00:00	1985-01-19	1985-01-19 00:00:00	1985-01-19	38000177		0	0	37		0	0	0	242936	0	310965	19078461		
10523	224	40213227	2004-03-30	2004-03-30 00:00:00	2004-03-30	2004-03-30 00:00:00	2004-03-30	581452		0	0	0		0	0	0	15071	0	113	40213227		
38737	3201	40236824	1968-09-08	1968-09-08 00:00:00	1968-09-15	1968-09-15 00:00:00	1968-09-15	38000177		0	0	7		0	0	0	212894	0	1094107	40236824		
37137	3069	1127433	1971-04-28	1971-04-28 00:00:00	1971-05-05	1971-05-05 00:00:00	1971-05-05	38000177		0	0	7		0	0	0	204245	0	313782	1127433		
19866	1632	1118084	1993-01-22	1993-01-22 00:00:00	1993-01-22	1993-01-22 00:00:00	\N	38000177		0	0	0		0	0	0	109613	0	00025152531	44923712		
12908	1084	1713671	2008-04-23	2008-04-23 00:00:00	2008-05-07	2008-05-07 00:00:00	2008-05-07	38000177		0	0	14		0	0	0	71206	0	562251	1713671		
57705	4795	920334	1995-12-16	1995-12-16 00:00:00	1995-12-23	1995-12-23 00:00:00	1995-12-23	38000177		0	0	7		0	0	0	319022	0	311995	920334		
32324	2680	19059056	1974-01-28	1974-01-28 00:00:00	1974-02-11	1974-02-11 00:00:00	1974-02-11	38000177		0	0	14		0	0	0	177545	0	243670	19059056		
30496	2528	1118084	2007-08-03	2007-08-03 00:00:00	2007-08-03	2007-08-03 00:00:00	\N	38000177		0	0	0		0	0	0	167154	0	00025152531	44923712		
17101	1415	1713671	1974-05-07	1974-05-07 00:00:00	1974-05-21	1974-05-21 00:00:00	1974-05-21	38000177		0	0	14		0	0	0	94188	0	562251	1713671		
34087	2818	19059056	1970-02-21	1970-02-21 00:00:00	1970-03-07	1970-03-07 00:00:00	1970-03-07	38000177		0	0	14		0	0	0	186723	0	243670	19059056		
9765	817	40162522	2007-01-27	2007-01-27 00:00:00	2007-01-27	2007-01-27 00:00:00	\N	38000177		0	0	0		0	0	0	54110	0	857005	40162522		
20267	1661	40171902	2007-07-12	2007-07-12 00:00:00	2007-07-12	2007-07-12 00:00:00	\N	38000177		0	0	0		0	0	0	111679	0	897718	40171902		
21245	1748	19133873	1959-02-12	1959-02-12 00:00:00	1959-02-21	1959-02-21 00:00:00	1959-02-21	38000177		0	0	9		0	0	0	116838	0	834061	19133873		
27054	2231	1127433	1981-07-11	1981-07-11 00:00:00	1981-07-25	1981-07-25 00:00:00	1981-07-25	38000177		0	0	14		0	0	0	148426	0	313782	1127433		
37551	3105	19129655	1972-02-29	1972-02-29 00:00:00	1972-03-14	1972-03-14 00:00:00	1972-03-14	38000177		0	0	14		0	0	0	206494	0	789980	19129655		
64138	5325	1115171	2009-04-24	2009-04-24 00:00:00	2009-05-22	2009-05-22 00:00:00	2009-05-22	38000177		0	0	28		0	0	0	354440	0	849574	1115171		
7109	597	19133873	1962-06-14	1962-06-14 00:00:00	1962-06-26	1962-06-26 00:00:00	1962-06-26	38000177		0	0	12		0	0	0	39422	0	834061	19133873		
38428	3177	40171902	2012-05-09	2012-05-09 00:00:00	2012-05-09	2012-05-09 00:00:00	\N	38000177		0	0	0		0	0	0	211369	0	897718	40171902		
6285	525	40220386	1952-05-22	1952-05-22 00:00:00	1952-05-22	1952-05-22 00:00:00	1952-05-22	38000177		0	0	0		0	0	0	34958	0	1808217	40220386		
89	6	1118084	2005-07-13	2005-07-13 00:00:00	2005-07-13	2005-07-13 00:00:00	\N	38000177		0	0	0		0	0	0	562	0	00025152531	44923712		
151	11	19078461	1998-04-02	1998-04-02 00:00:00	1998-07-01	1998-07-01 00:00:00	1998-07-01	38000177		0	0	90		0	0	0	993	0	310965	19078461		
28391	2342	1127433	1990-01-28	1990-01-28 00:00:00	1990-02-18	1990-02-18 00:00:00	1990-02-18	38000177		0	0	21		0	0	0	155888	0	313782	1127433		
28419	2344	1127078	1967-07-07	1967-07-07 00:00:00	1967-07-21	1967-07-21 00:00:00	1967-07-21	38000177		0	0	14		0	0	0	156077	0	282464	1127078		
28478	2347	1115171	2001-11-23	2001-11-23 00:00:00	2001-12-14	2001-12-14 00:00:00	2001-12-14	38000177		0	0	21		0	0	0	156224	0	849574	1115171		
28532	2351	40231925	1993-07-22	1993-07-22 00:00:00	1993-07-22	1993-07-22 00:00:00	\N	38000177		0	0	0		0	0	0	156509	0	1049221	40231925		
31326	2597	40229134	2001-06-05	2001-06-05 00:00:00	2001-06-12	2001-06-12 00:00:00	2001-06-12	38000177		0	0	7		0	0	0	171839	0	1043400	40229134		
53973	4484	40165015	2003-02-17	2003-02-17 00:00:00	2003-02-17	2003-02-17 00:00:00	\N	38000177		0	0	0		0	0	0	298469	0	861467	40165015		
38068	3147	1127433	1993-12-31	1993-12-31 00:00:00	1994-01-14	1994-01-14 00:00:00	1994-01-14	38000177		0	0	14		0	0	0	209428	0	313782	1127433		
9253	197	40213296	2001-09-23	2001-09-23 00:00:00	2001-09-23	2001-09-23 00:00:00	2001-09-23	581452		0	0	0		0	0	0	13544	0	52	40213296		
21285	462	40213314	1977-02-24	1977-02-24 00:00:00	1977-02-24	1977-02-24 00:00:00	1977-02-24	581452		0	0	0		0	0	0	30870	0	49	40213314		
2471	196	1127433	1959-10-22	1959-10-22 00:00:00	1959-10-29	1959-10-29 00:00:00	1959-10-29	38000177		0	0	7		0	0	0	13440	0	313782	1127433		
32396	2685	19059056	1943-01-25	1943-01-25 00:00:00	1943-02-08	1943-02-08 00:00:00	1943-02-08	38000177		0	0	14		0	0	0	177911	0	243670	19059056		
34978	2890	19128065	1980-11-08	1980-11-08 00:00:00	1981-11-03	1981-11-03 00:00:00	1981-11-03	38000177		0	0	360		0	0	0	192193	0	749882	19128065		
10207	856	1127433	1982-01-25	1982-01-25 00:00:00	1982-02-08	1982-02-08 00:00:00	1982-02-08	38000177		0	0	14		0	0	0	56567	0	313782	1127433		
23599	1941	40236446	1986-02-12	1986-02-12 00:00:00	1987-01-28	1987-01-28 00:00:00	1987-01-28	38000177		0	0	350		0	0	0	129064	0	1091392	40236446		
40994	3399	1713671	2005-02-08	2005-02-08 00:00:00	2005-02-15	2005-02-15 00:00:00	2005-02-15	38000177		0	0	7		0	0	0	225439	0	562251	1713671		
4817	403	1127433	2019-01-09	2019-01-09 00:00:00	2019-01-23	2019-01-23 00:00:00	2019-01-23	38000177		0	0	14		0	0	0	26468	0	313782	1127433		
38850	847	40213160	1971-03-19	1971-03-19 00:00:00	1971-03-19	1971-03-19 00:00:00	1971-03-19	581452		0	0	0		0	0	0	56114	0	10	40213160		
14012	1173	1127433	1957-08-06	1957-08-06 00:00:00	1957-08-20	1957-08-20 00:00:00	1957-08-20	38000177		0	0	14		0	0	0	77221	0	313782	1127433		
60901	5065	19133905	1993-01-26	1993-01-26 00:00:00	1993-02-04	1993-02-04 00:00:00	1993-02-04	38000177		0	0	9		0	0	0	336721	0	834102	19133905		
14079	1176	19129655	1966-12-16	1966-12-16 00:00:00	1966-12-30	1966-12-30 00:00:00	1966-12-30	38000177		0	0	14		0	0	0	77713	0	789980	19129655		
36590	3019	40162522	1992-04-15	1992-04-15 00:00:00	1992-04-15	1992-04-15 00:00:00	\N	38000177		0	0	0		0	0	0	201346	0	857005	40162522		
24631	2026	19133873	1960-03-23	1960-03-23 00:00:00	1960-04-03	1960-04-03 00:00:00	1960-04-03	38000177		0	0	11		0	0	0	134798	0	834061	19133873		
44929	3718	1127433	1989-08-01	1989-08-01 00:00:00	1989-08-08	1989-08-08 00:00:00	1989-08-08	38000177		0	0	7		0	0	0	247138	0	313782	1127433		
23253	1916	1127078	1982-05-23	1982-05-23 00:00:00	1982-06-29	1982-06-29 00:00:00	1982-06-29	38000177		0	0	37		0	0	0	127442	0	282464	1127078		
23304	1921	19059056	1968-07-10	1968-07-10 00:00:00	1968-10-08	1968-10-08 00:00:00	1968-10-08	38000177		0	0	90		0	0	0	127790	0	243670	19059056		
50044	4153	19129655	1973-05-14	1973-05-14 00:00:00	1973-05-28	1973-05-28 00:00:00	1973-05-28	38000177		0	0	14		0	0	0	276067	0	789980	19129655		
26201	2155	19075601	2006-02-08	2006-02-08 00:00:00	2006-02-08	2006-02-08 00:00:00	2006-02-08	38000177		0	0	0		0	0	0	143621	0	309362	19075601		
26760	2204	19059056	1948-10-26	1948-10-26 00:00:00	1948-11-09	1948-11-09 00:00:00	1948-11-09	38000177		0	0	14		0	0	0	146941	0	243670	19059056		
26794	2206	1127433	2017-09-09	2017-09-09 00:00:00	2017-09-23	2017-09-23 00:00:00	2017-09-23	38000177		0	0	14		0	0	0	146992	0	313782	1127433		
60668	5046	19133873	1968-12-20	1968-12-20 00:00:00	1968-12-29	1968-12-29 00:00:00	1968-12-29	38000177		0	0	9		0	0	0	335324	0	834061	19133873		
60717	5049	1127078	1970-07-18	1970-07-18 00:00:00	1970-10-16	1970-10-16 00:00:00	1970-10-16	38000177		0	0	90		0	0	0	335584	0	282464	1127078		
35714	2943	19078461	1997-02-05	1997-02-05 00:00:00	1997-03-07	1997-03-07 00:00:00	1997-03-07	38000177		0	0	30		0	0	0	196325	0	310965	19078461		
52073	4330	1118084	1987-02-25	1987-02-25 00:00:00	1987-02-25	1987-02-25 00:00:00	\N	38000177		0	0	0		0	0	0	287185	0	00025152531	44923712		
6859	578	1127078	1968-11-21	1968-11-21 00:00:00	1968-12-05	1968-12-05 00:00:00	1968-12-05	38000177		0	0	14		0	0	0	38281	0	282464	1127078		
6895	580	40173590	1997-10-05	1997-10-05 00:00:00	1997-10-05	1997-10-05 00:00:00	\N	38000177		0	0	0		0	0	0	38467	0	904419	40173590		
33221	2752	19133905	2008-06-09	2008-06-09 00:00:00	2008-06-20	2008-06-20 00:00:00	2008-06-20	38000177		0	0	11		0	0	0	182063	0	834102	19133905		
61480	5116	19112599	1967-06-19	1967-06-19 00:00:00	1967-06-19	1967-06-19 00:00:00	\N	38000177		0	0	0		0	0	0	339992	0	477045	19112599		
1179	95	1713671	1978-04-18	1978-04-18 00:00:00	1978-04-25	1978-04-25 00:00:00	1978-04-25	38000177		0	0	7		0	0	0	6418	0	562251	1713671		
17546	1450	19006318	1968-09-03	1968-09-03 00:00:00	1968-09-17	1968-09-17 00:00:00	1968-09-17	38000177		0	0	14		0	0	0	96682	0	105078	19006318		
19340	1597	1127433	1985-09-02	1985-09-02 00:00:00	1985-11-01	1985-11-01 00:00:00	1985-11-01	38000177		0	0	60		0	0	0	107121	0	313782	1127433		
9147	760	1713671	1990-08-02	1990-08-02 00:00:00	1990-08-16	1990-08-16 00:00:00	1990-08-16	38000177		0	0	14		0	0	0	50461	0	562251	1713671		
19396	1600	1713671	1981-10-12	1981-10-12 00:00:00	1981-11-09	1981-11-09 00:00:00	1981-11-09	38000177		0	0	28		0	0	0	107436	0	562251	1713671		
44082	3650	1127433	2017-03-07	2017-03-07 00:00:00	2017-03-21	2017-03-21 00:00:00	2017-03-21	38000177		0	0	14		0	0	0	242996	0	313782	1127433		
10545	225	40213160	1969-12-15	1969-12-15 00:00:00	1969-12-15	1969-12-15 00:00:00	1969-12-15	581452		0	0	0		0	0	0	15125	0	10	40213160		
38738	3201	920300	1968-09-08	1968-09-08 00:00:00	1968-09-15	1968-09-15 00:00:00	1968-09-15	38000177		0	0	7		0	0	0	212894	0	311989	920300		
37138	3069	1127078	1963-04-08	1963-04-08 00:00:00	1963-04-22	1963-04-22 00:00:00	1963-04-22	38000177		0	0	14		0	0	0	204301	0	282464	1127078		
19867	1632	1713671	2003-05-22	2003-05-22 00:00:00	2003-06-05	2003-06-05 00:00:00	2003-06-05	38000177		0	0	14		0	0	0	109590	0	562251	1713671		
12909	1085	1127433	1977-02-05	1977-02-05 00:00:00	1977-03-05	1977-03-05 00:00:00	1977-03-05	38000177		0	0	28		0	0	0	71266	0	313782	1127433		
57707	4795	1124300	2005-10-09	2005-10-09 00:00:00	2005-10-09	2005-10-09 00:00:00	\N	38000177		0	0	0		0	0	0	319000	0	00781178901	45011828		
32325	2680	19073188	2014-12-13	2014-12-13 00:00:00	2015-01-03	2015-01-03 00:00:00	2015-01-03	38000177		0	0	21		0	0	0	177558	0	308192	19073188		
30497	2528	1713671	1977-04-01	1977-04-01 00:00:00	1977-04-08	1977-04-08 00:00:00	1977-04-08	38000177		0	0	7		0	0	0	167128	0	562251	1713671		
17102	1415	1713671	1987-06-05	1987-06-05 00:00:00	1987-06-19	1987-06-19 00:00:00	1987-06-19	38000177		0	0	14		0	0	0	94218	0	562251	1713671		
34088	2818	1713671	1987-12-10	1987-12-10 00:00:00	1987-12-31	1987-12-31 00:00:00	1987-12-31	38000177		0	0	21		0	0	0	186719	0	562251	1713671		
9766	817	19078461	2007-01-27	2007-01-27 00:00:00	2007-04-27	2007-04-27 00:00:00	2007-04-27	38000177		0	0	90		0	0	0	54110	0	310965	19078461		
20268	1661	40163554	2007-07-12	2007-07-12 00:00:00	2007-07-12	2007-07-12 00:00:00	\N	38000177		0	0	0		0	0	0	111679	0	855332	40163554		
21246	1748	1713671	1997-05-06	1997-05-06 00:00:00	1997-05-20	1997-05-20 00:00:00	1997-05-20	38000177		0	0	14		0	0	0	116925	0	562251	1713671		
27055	2232	40229134	1981-07-13	1981-07-13 00:00:00	1981-07-27	1981-07-27 00:00:00	1981-07-27	38000177		0	0	14		0	0	0	148537	0	1043400	40229134		
37552	3105	1115171	2004-07-15	2004-07-15 00:00:00	2004-08-05	2004-08-05 00:00:00	2004-08-05	38000177		0	0	21		0	0	0	206482	0	849574	1115171		
64139	5325	1127078	1955-01-10	1955-01-10 00:00:00	1955-02-09	1955-02-09 00:00:00	1955-02-09	38000177		0	0	30		0	0	0	354437	0	282464	1127078		
7110	597	1127433	2003-09-08	2003-09-08 00:00:00	2003-09-22	2003-09-22 00:00:00	2003-09-22	38000177		0	0	14		0	0	0	39473	0	313782	1127433		
38429	3177	40220960	2012-05-30	2012-05-30 00:00:00	2012-05-30	2012-05-30 00:00:00	2012-05-30	38000177		0	0	0		0	0	0	211369	0	1804799	40220960		
6286	525	19016749	1952-05-22	1952-05-22 00:00:00	1952-05-22	1952-05-22 00:00:00	1952-05-22	38000177		0	0	0		0	0	0	34958	0	73032	19016749		
90	6	19059056	1967-12-10	1967-12-10 00:00:00	1967-12-31	1967-12-31 00:00:00	1967-12-31	38000177		0	0	21		0	0	0	554	0	243670	19059056		
152	11	1713671	1994-07-31	1994-07-31 00:00:00	1994-08-14	1994-08-14 00:00:00	1994-08-14	38000177		0	0	14		0	0	0	964	0	562251	1713671		
28392	2342	1713671	2010-03-19	2010-03-19 00:00:00	2010-04-09	2010-04-09 00:00:00	2010-04-09	38000177		0	0	21		0	0	0	155896	0	562251	1713671		
28420	2344	1118084	1999-11-21	1999-11-21 00:00:00	1999-11-21	1999-11-21 00:00:00	\N	38000177		0	0	0		0	0	0	156018	0	00025152531	44923712		
28479	2347	1127078	1974-03-06	1974-03-06 00:00:00	1974-05-05	1974-05-05 00:00:00	1974-05-05	38000177		0	0	60		0	0	0	156221	0	282464	1127078		
28533	2351	1127433	1978-09-04	1978-09-04 00:00:00	1978-10-09	1978-10-09 00:00:00	1978-10-09	38000177		0	0	35		0	0	0	156508	0	313782	1127433		
31327	2597	1127433	1981-08-30	1981-08-30 00:00:00	1981-09-13	1981-09-13 00:00:00	1981-09-13	38000177		0	0	14		0	0	0	171825	0	313782	1127433		
53974	4485	1713671	2012-12-06	2012-12-06 00:00:00	2012-12-20	2012-12-20 00:00:00	2012-12-20	38000177		0	0	14		0	0	0	298586	0	562251	1713671		
38079	3149	19059056	1958-02-11	1958-02-11 00:00:00	1958-03-04	1958-03-04 00:00:00	1958-03-04	38000177		0	0	21		0	0	0	209563	0	243670	19059056		
9254	197	40213160	1961-02-26	1961-02-26 00:00:00	1961-02-26	1961-02-26 00:00:00	1961-02-26	581452		0	0	0		0	0	0	13587	0	10	40213160		
21286	462	40213306	1998-11-19	1998-11-19 00:00:00	1998-11-19	1998-11-19 00:00:00	1998-11-19	581452		0	0	0		0	0	0	30878	0	43	40213306		
2472	197	19059056	1973-01-11	1973-01-11 00:00:00	1973-02-08	1973-02-08 00:00:00	1973-02-08	38000177		0	0	28		0	0	0	13529	0	243670	19059056		
32397	2685	19133905	1989-05-05	1989-05-05 00:00:00	1989-05-17	1989-05-17 00:00:00	1989-05-17	38000177		0	0	12		0	0	0	177908	0	834102	19133905		
34980	2890	1127433	1985-01-08	1985-01-08 00:00:00	1985-01-15	1985-01-15 00:00:00	1985-01-15	38000177		0	0	7		0	0	0	192201	0	313782	1127433		
10208	856	19074841	1982-01-25	1982-01-25 00:00:00	1982-02-08	1982-02-08 00:00:00	1982-02-08	38000177		0	0	14		0	0	0	56567	0	309043	19074841		
23600	1941	1127433	1988-11-25	1988-11-25 00:00:00	1989-01-13	1989-01-13 00:00:00	1989-01-13	38000177		0	0	49		0	0	0	129056	0	313782	1127433		
40995	3399	43012433	2003-01-03	2003-01-03 00:00:00	2003-12-29	2003-12-29 00:00:00	2003-12-29	38000177		0	0	360		0	0	0	225524	0	1367439	43012433		
4818	403	19059056	1968-08-29	1968-08-29 00:00:00	1968-11-27	1968-11-27 00:00:00	1968-11-27	38000177		0	0	90		0	0	0	26463	0	243670	19059056		
194887	4282	40213160	1966-09-14	1966-09-14 00:00:00	1966-09-14	1966-09-14 00:00:00	1966-09-14	581452		0	0	0		0	0	0	284201	0	10	40213160		
14013	1173	1713671	1994-10-19	1994-10-19 00:00:00	1994-11-02	1994-11-02 00:00:00	1994-11-02	38000177		0	0	14		0	0	0	77208	0	562251	1713671		
60902	5065	19133768	2005-03-15	2005-03-15 00:00:00	2005-03-15	2005-03-15 00:00:00	2005-03-15	38000177		0	0	0		0	0	0	336708	0	833036	19133768		
14080	1176	1118084	1999-04-28	1999-04-28 00:00:00	1999-04-28	1999-04-28 00:00:00	\N	38000177		0	0	0		0	0	0	77697	0	00025152531	44923712		
36591	3019	1127433	1995-03-01	1995-03-01 00:00:00	1995-03-29	1995-03-29 00:00:00	1995-03-29	38000177		0	0	28		0	0	0	201347	0	313782	1127433		
24632	2026	40236824	1974-02-18	1974-02-18 00:00:00	1974-03-04	1974-03-04 00:00:00	1974-03-04	38000177		0	0	14		0	0	0	134854	0	1094107	40236824		
44930	3718	19128022	1989-08-30	1989-08-30 00:00:00	1990-08-25	1990-08-25 00:00:00	1990-08-25	38000177		0	0	360		0	0	0	247086	0	749785	19128022		
23254	1916	1115171	2004-10-31	2004-10-31 00:00:00	2004-11-21	2004-11-21 00:00:00	2004-11-21	38000177		0	0	21		0	0	0	127446	0	849574	1115171		
23305	1921	1118084	1995-03-02	1995-03-02 00:00:00	1995-03-02	1995-03-02 00:00:00	\N	38000177		0	0	0		0	0	0	127773	0	00025152531	44923712		
50045	4153	1127078	1973-05-14	1973-05-14 00:00:00	1973-05-28	1973-05-28 00:00:00	1973-05-28	38000177		0	0	14		0	0	0	276067	0	282464	1127078		
26202	2155	40229134	1993-07-19	1993-07-19 00:00:00	1993-08-02	1993-08-02 00:00:00	1993-08-02	38000177		0	0	14		0	0	0	143587	0	1043400	40229134		
26761	2204	19006318	1948-10-26	1948-10-26 00:00:00	1948-11-09	1948-11-09 00:00:00	1948-11-09	38000177		0	0	14		0	0	0	146941	0	105078	19006318		
26795	2206	1127433	1987-11-10	1987-11-10 00:00:00	1987-11-17	1987-11-17 00:00:00	1987-11-17	38000177		0	0	7		0	0	0	147051	0	313782	1127433		
60669	5046	1118084	1995-09-22	1995-09-22 00:00:00	1995-09-22	1995-09-22 00:00:00	\N	38000177		0	0	0		0	0	0	335311	0	00025152531	44923712		
60718	5049	46275916	1998-02-18	1998-02-18 00:00:00	1998-02-18	1998-02-18 00:00:00	1998-02-18	38000177		0	0	0		0	0	0	335586	0	1660014	46275916		
35715	2943	19059056	1931-08-13	1931-08-13 00:00:00	1931-10-12	1931-10-12 00:00:00	1931-10-12	38000177		0	0	60		0	0	0	196246	0	243670	19059056		
52074	4330	1127433	2012-03-20	2012-03-20 00:00:00	2012-06-18	2012-06-18 00:00:00	2012-06-18	38000177		0	0	90		0	0	0	287221	0	313782	1127433		
6860	578	19078461	2001-12-19	2001-12-19 00:00:00	2002-01-16	2002-01-16 00:00:00	2002-01-16	38000177		0	0	28		0	0	0	38259	0	310965	19078461		
6896	580	1127433	1964-05-17	1964-05-17 00:00:00	1964-05-31	1964-05-31 00:00:00	1964-05-31	38000177		0	0	14		0	0	0	38458	0	313782	1127433		
33223	2752	19133873	1962-01-05	1962-01-05 00:00:00	1962-01-12	1962-01-12 00:00:00	1962-01-12	38000177		0	0	7		0	0	0	182102	0	834061	19133873		
61481	5116	19133905	2016-08-23	2016-08-23 00:00:00	2016-09-04	2016-09-04 00:00:00	2016-09-04	38000177		0	0	12		0	0	0	339950	0	834102	19133905		
1180	95	1127433	1973-11-04	1973-11-04 00:00:00	1973-11-11	1973-11-11 00:00:00	1973-11-11	38000177		0	0	7		0	0	0	6456	0	313782	1127433		
56943	4724	1127433	1994-01-17	1994-01-17 00:00:00	1994-01-24	1994-01-24 00:00:00	1994-01-24	38000177		0	0	7		0	0	0	314835	0	313782	1127433		
19341	1597	19059056	1965-02-28	1965-02-28 00:00:00	1965-04-29	1965-04-29 00:00:00	1965-04-29	38000177		0	0	60		0	0	0	107119	0	243670	19059056		
9148	760	1127433	1977-06-20	1977-06-20 00:00:00	1977-07-20	1977-07-20 00:00:00	1977-07-20	38000177		0	0	30		0	0	0	50508	0	313782	1127433		
19398	1600	1124300	1978-01-12	1978-01-12 00:00:00	1978-01-12	1978-01-12 00:00:00	\N	38000177		0	0	0		0	0	0	107394	0	00781178901	45011828		
44083	3650	1124300	1964-08-09	1964-08-09 00:00:00	1964-08-09	1964-08-09 00:00:00	\N	38000177		0	0	0		0	0	0	242991	0	00781178901	45011828		
10548	225	40213160	1965-09-13	1965-09-13 00:00:00	1965-09-13	1965-09-13 00:00:00	1965-09-13	581452		0	0	0		0	0	0	15154	0	10	40213160		
38739	3201	1127433	1981-02-27	1981-02-27 00:00:00	1981-03-27	1981-03-27 00:00:00	1981-03-27	38000177		0	0	28		0	0	0	212919	0	313782	1127433		
37139	3069	1118084	2001-10-25	2001-10-25 00:00:00	2001-10-25	2001-10-25 00:00:00	\N	38000177		0	0	0		0	0	0	204249	0	00025152531	44923712		
19868	1632	40229134	1958-05-18	1958-05-18 00:00:00	1958-06-01	1958-06-01 00:00:00	1958-06-01	38000177		0	0	14		0	0	0	109586	0	1043400	40229134		
12910	1085	40162522	2000-07-02	2000-07-02 00:00:00	2000-07-02	2000-07-02 00:00:00	\N	38000177		0	0	0		0	0	0	71267	0	857005	40162522		
57708	4795	40229134	1991-06-28	1991-06-28 00:00:00	1991-07-12	1991-07-12 00:00:00	1991-07-12	38000177		0	0	14		0	0	0	318999	0	1043400	40229134		
32326	2680	1127433	2014-12-13	2014-12-13 00:00:00	2015-01-03	2015-01-03 00:00:00	2015-01-03	38000177		0	0	21		0	0	0	177558	0	313782	1127433		
30498	2528	19133873	1970-10-24	1970-10-24 00:00:00	1970-11-02	1970-11-02 00:00:00	1970-11-02	38000177		0	0	9		0	0	0	167086	0	834061	19133873		
17103	1415	19133873	1984-05-12	1984-05-12 00:00:00	1984-05-19	1984-05-19 00:00:00	1984-05-19	38000177		0	0	7		0	0	0	94195	0	834061	19133873		
34089	2818	40229134	1971-07-18	1971-07-18 00:00:00	1971-07-25	1971-07-25 00:00:00	1971-07-25	38000177		0	0	7		0	0	0	186718	0	1043400	40229134		
9767	817	1127433	2008-12-03	2008-12-03 00:00:00	2008-12-10	2008-12-10 00:00:00	2008-12-10	38000177		0	0	7		0	0	0	54094	0	313782	1127433		
20269	1661	19018935	2007-07-12	2007-07-12 00:00:00	2007-07-12	2007-07-12 00:00:00	\N	38000177		0	0	0		0	0	0	111679	0	197604	19018935		
21247	1748	1127433	1987-09-01	1987-09-01 00:00:00	1987-09-15	1987-09-15 00:00:00	1987-09-15	38000177		0	0	14		0	0	0	116912	0	313782	1127433		
27056	2232	40229134	2009-08-29	2009-08-29 00:00:00	2009-09-05	2009-09-05 00:00:00	2009-09-05	38000177		0	0	7		0	0	0	148522	0	1043400	40229134		
37553	3105	46233988	1971-12-17	1971-12-17 00:00:00	1971-12-31	1971-12-31 00:00:00	1971-12-31	38000177		0	0	14		0	0	0	206493	0	1652673	46233988		
64140	5325	19073188	1989-10-22	1989-10-22 00:00:00	1989-11-05	1989-11-05 00:00:00	1989-11-05	38000177		0	0	14		0	0	0	354439	0	308192	19073188		
7111	597	1127433	1964-11-29	1964-11-29 00:00:00	1964-12-06	1964-12-06 00:00:00	1964-12-06	38000177		0	0	7		0	0	0	39417	0	313782	1127433		
38430	3177	1127433	1993-10-04	1993-10-04 00:00:00	1993-11-03	1993-11-03 00:00:00	1993-11-03	38000177		0	0	30		0	0	0	211234	0	313782	1127433		
6287	525	42707627	1952-05-22	1952-05-22 00:00:00	1952-05-22	1952-05-22 00:00:00	1952-05-22	38000177		0	0	0		0	0	0	34958	0	1234995	42707627		
91	6	19129655	1965-06-23	1965-06-23 00:00:00	1965-07-07	1965-07-07 00:00:00	1965-07-07	38000177		0	0	14		0	0	0	544	0	789980	19129655		
153	11	19059056	1989-09-22	1989-09-22 00:00:00	1989-10-13	1989-10-13 00:00:00	1989-10-13	38000177		0	0	21		0	0	0	990	0	243670	19059056		
28393	2342	920300	2010-02-08	2010-02-08 00:00:00	2010-02-15	2010-02-15 00:00:00	2010-02-15	38000177		0	0	7		0	0	0	155902	0	311989	920300		
28421	2344	1713671	1988-10-18	1988-10-18 00:00:00	1988-11-08	1988-11-08 00:00:00	1988-11-08	38000177		0	0	21		0	0	0	156017	0	562251	1713671		
28480	2347	1127433	2006-08-01	2006-08-01 00:00:00	2006-08-08	2006-08-08 00:00:00	2006-08-08	38000177		0	0	7		0	0	0	156235	0	313782	1127433		
28534	2351	1713671	2000-08-10	2000-08-10 00:00:00	2000-08-31	2000-08-31 00:00:00	2000-08-31	38000177		0	0	21		0	0	0	156560	0	562251	1713671		
31328	2597	1713671	1997-06-24	1997-06-24 00:00:00	1997-07-08	1997-07-08 00:00:00	1997-07-08	38000177		0	0	14		0	0	0	171882	0	562251	1713671		
53975	4485	1713671	1972-04-14	1972-04-14 00:00:00	1972-04-28	1972-04-28 00:00:00	1972-04-28	38000177		0	0	14		0	0	0	298598	0	562251	1713671		
38080	3149	40162522	1965-10-30	1965-10-30 00:00:00	1965-10-30	1965-10-30 00:00:00	\N	38000177		0	0	0		0	0	0	209503	0	857005	40162522		
9259	197	40213160	1960-12-25	1960-12-25 00:00:00	1960-12-25	1960-12-25 00:00:00	1960-12-25	581452		0	0	0		0	0	0	13549	0	10	40213160		
59203	4922	19128022	1990-07-31	1990-07-31 00:00:00	1991-07-26	1991-07-26 00:00:00	1991-07-26	38000177		0	0	360		0	0	0	327060	0	749785	19128022		
2473	197	1127433	1984-08-24	1984-08-24 00:00:00	1984-09-07	1984-09-07 00:00:00	1984-09-07	38000177		0	0	14		0	0	0	13536	0	313782	1127433		
32398	2685	1127433	1982-12-14	1982-12-14 00:00:00	1982-12-28	1982-12-28 00:00:00	1982-12-28	38000177		0	0	14		0	0	0	177936	0	313782	1127433		
34981	2890	40236824	2010-01-08	2010-01-08 00:00:00	2010-01-15	2010-01-15 00:00:00	2010-01-15	38000177		0	0	7		0	0	0	192199	0	1094107	40236824		
10209	856	19078461	1984-12-28	1984-12-28 00:00:00	1985-01-25	1985-01-25 00:00:00	1985-01-25	38000177		0	0	28		0	0	0	56518	0	310965	19078461		
45522	3767	19074843	1988-08-15	1988-08-15 00:00:00	1988-08-29	1988-08-29 00:00:00	1988-08-29	38000177		0	0	14		0	0	0	250382	0	309045	19074843		
40996	3399	1150771	1983-12-17	1983-12-17 00:00:00	1983-12-17	1983-12-17 00:00:00	\N	38000177		0	0	0		0	0	0	225486	0	197378	1150771		
4819	403	19133873	1926-03-10	1926-03-10 00:00:00	1926-03-22	1926-03-22 00:00:00	1926-03-22	38000177		0	0	12		0	0	0	26489	0	834061	19133873		
194890	4282	40213260	2017-04-12	2017-04-12 00:00:00	2017-04-12	2017-04-12 00:00:00	2017-04-12	581452		0	0	0		0	0	0	284218	0	121	40213260		
14014	1173	19059056	1947-06-15	1947-06-15 00:00:00	1947-06-29	1947-06-29 00:00:00	1947-06-29	38000177		0	0	14		0	0	0	77248	0	243670	19059056		
60903	5065	1545959	2005-03-15	2005-03-15 00:00:00	2005-03-15	2005-03-15 00:00:00	2005-03-15	38000177		0	0	0		0	0	0	336708	0	259255	1545959		
14081	1176	1713671	2009-06-23	2009-06-23 00:00:00	2009-07-07	2009-07-07 00:00:00	2009-07-07	38000177		0	0	14		0	0	0	77711	0	562251	1713671		
36592	3019	1118084	2015-10-12	2015-10-12 00:00:00	2015-10-12	2015-10-12 00:00:00	\N	38000177		0	0	0		0	0	0	201361	0	00025152531	44923712		
24633	2026	920300	1974-02-18	1974-02-18 00:00:00	1974-02-25	1974-02-25 00:00:00	1974-02-25	38000177		0	0	7		0	0	0	134854	0	311989	920300		
44931	3718	40229134	1994-02-02	1994-02-02 00:00:00	1994-02-09	1994-02-09 00:00:00	1994-02-09	38000177		0	0	7		0	0	0	247129	0	1043400	40229134		
23255	1916	40169216	1974-10-10	1974-10-10 00:00:00	1974-10-10	1974-10-10 00:00:00	\N	38000177		0	0	0		0	0	0	127450	0	895994	40169216		
23306	1921	1127433	1987-03-06	1987-03-06 00:00:00	1987-03-20	1987-03-20 00:00:00	1987-03-20	38000177		0	0	14		0	0	0	127721	0	313782	1127433		
50046	4153	46233988	1967-01-02	1967-01-02 00:00:00	1967-01-16	1967-01-16 00:00:00	1967-01-16	38000177		0	0	14		0	0	0	276041	0	1652673	46233988		
26203	2155	1127433	2003-05-23	2003-05-23 00:00:00	2003-06-17	2003-06-17 00:00:00	2003-06-17	38000177		0	0	25		0	0	0	143602	0	313782	1127433		
26762	2204	19078461	1986-03-21	1986-03-21 00:00:00	1986-04-04	1986-04-04 00:00:00	1986-04-04	38000177		0	0	14		0	0	0	146880	0	310965	19078461		
26796	2206	19128022	1991-10-29	1991-10-29 00:00:00	1992-10-23	1992-10-23 00:00:00	1992-10-23	38000177		0	0	360		0	0	0	146993	0	749785	19128022		
60670	5046	19059056	1971-09-03	1971-09-03 00:00:00	1971-10-08	1971-10-08 00:00:00	1971-10-08	38000177		0	0	35		0	0	0	335339	0	243670	19059056		
60719	5049	40243436	1998-02-18	1998-02-18 00:00:00	1998-02-18	1998-02-18 00:00:00	1998-02-18	38000177		0	0	0		0	0	0	335586	0	1190795	40243436		
35716	2943	19059056	1929-09-22	1929-09-22 00:00:00	1929-10-22	1929-10-22 00:00:00	1929-10-22	38000177		0	0	30		0	0	0	196245	0	243670	19059056		
52075	4330	1713671	1967-03-26	1967-03-26 00:00:00	1967-04-09	1967-04-09 00:00:00	1967-04-09	38000177		0	0	14		0	0	0	287264	0	562251	1713671		
6861	578	40229134	1969-02-21	1969-02-21 00:00:00	1969-02-28	1969-02-28 00:00:00	1969-02-28	38000177		0	0	7		0	0	0	38265	0	1043400	40229134		
6897	580	1127433	1942-08-16	1942-08-16 00:00:00	1942-08-23	1942-08-23 00:00:00	1942-08-23	38000177		0	0	7		0	0	0	38404	0	313782	1127433		
33225	2752	1127433	1954-04-03	1954-04-03 00:00:00	1954-04-10	1954-04-10 00:00:00	1954-04-10	38000177		0	0	7		0	0	0	182101	0	313782	1127433		
61482	5116	1118084	2010-05-03	2010-05-03 00:00:00	2010-05-03	2010-05-03 00:00:00	\N	38000177		0	0	0		0	0	0	339937	0	00025152531	44923712		
1181	95	1127433	1979-02-24	1979-02-24 00:00:00	1979-03-03	1979-03-03 00:00:00	1979-03-03	38000177		0	0	7		0	0	0	6419	0	313782	1127433		
56944	4724	19008572	1971-04-17	1971-04-17 00:00:00	1971-05-01	1971-05-01 00:00:00	1971-05-01	38000177		0	0	14		0	0	0	314721	0	106258	19008572		
19342	1597	40165015	1965-02-28	1965-02-28 00:00:00	1965-02-28	1965-02-28 00:00:00	\N	38000177		0	0	0		0	0	0	107119	0	861467	40165015		
9149	760	1127433	1992-12-08	1992-12-08 00:00:00	1992-12-22	1992-12-22 00:00:00	1992-12-22	38000177		0	0	14		0	0	0	50496	0	313782	1127433		
19399	1600	1115171	2002-07-21	2002-07-21 00:00:00	2002-08-04	2002-08-04 00:00:00	2002-08-04	38000177		0	0	14		0	0	0	107364	0	849574	1115171		
44084	3650	1127433	2013-12-17	2013-12-17 00:00:00	2013-12-31	2013-12-31 00:00:00	2013-12-31	38000177		0	0	14		0	0	0	242995	0	313782	1127433		
10550	225	40213160	1965-04-12	1965-04-12 00:00:00	1965-04-12	1965-04-12 00:00:00	1965-04-12	581452		0	0	0		0	0	0	15153	0	10	40213160		
38740	3201	19059056	1964-09-19	1964-09-19 00:00:00	1964-10-03	1964-10-03 00:00:00	1964-10-03	38000177		0	0	14		0	0	0	212917	0	243670	19059056		
37140	3069	19059056	1968-02-11	1968-02-11 00:00:00	1968-03-03	1968-03-03 00:00:00	1968-03-03	38000177		0	0	21		0	0	0	204308	0	243670	19059056		
19869	1632	19115351	1962-07-20	1962-07-20 00:00:00	1962-11-01	1962-11-01 00:00:00	1962-11-01	38000177		0	0	104		0	0	0	109549	0	563026	19115351		
12911	1085	1127433	2000-07-02	2000-07-02 00:00:00	2000-08-01	2000-08-01 00:00:00	2000-08-01	38000177		0	0	30		0	0	0	71267	0	313782	1127433		
57709	4795	1115171	2011-10-09	2011-10-09 00:00:00	2011-10-23	2011-10-23 00:00:00	2011-10-23	38000177		0	0	14		0	0	0	319030	0	849574	1115171		
32327	2680	1127433	2017-09-19	2017-09-19 00:00:00	2017-10-03	2017-10-03 00:00:00	2017-10-03	38000177		0	0	14		0	0	0	177559	0	313782	1127433		
30499	2528	1713671	1994-04-10	1994-04-10 00:00:00	1994-04-17	1994-04-17 00:00:00	1994-04-17	38000177		0	0	7		0	0	0	167139	0	562251	1713671		
17104	1415	1127433	1995-01-27	1995-01-27 00:00:00	1995-02-03	1995-02-03 00:00:00	1995-02-03	38000177		0	0	7		0	0	0	94190	0	313782	1127433		
34090	2818	1127433	1975-03-07	1975-03-07 00:00:00	1975-03-14	1975-03-14 00:00:00	1975-03-14	38000177		0	0	7		0	0	0	186731	0	313782	1127433		
9785	820	19133873	1964-10-22	1964-10-22 00:00:00	1964-10-29	1964-10-29 00:00:00	1964-10-29	38000177		0	0	7		0	0	0	54304	0	834061	19133873		
20270	1662	1127078	1964-07-11	1964-07-11 00:00:00	1964-07-25	1964-07-25 00:00:00	1964-07-25	38000177		0	0	14		0	0	0	111736	0	282464	1127078		
21248	1748	19059056	1980-08-05	1980-08-05 00:00:00	1980-08-19	1980-08-19 00:00:00	1980-08-19	38000177		0	0	14		0	0	0	116869	0	243670	19059056		
27057	2232	19128065	1979-04-26	1979-04-26 00:00:00	1980-04-20	1980-04-20 00:00:00	1980-04-20	38000177		0	0	360		0	0	0	148482	0	749882	19128065		
37554	3105	19059056	1971-12-17	1971-12-17 00:00:00	1971-12-31	1971-12-31 00:00:00	1971-12-31	38000177		0	0	14		0	0	0	206493	0	243670	19059056		
64141	5325	40231925	1989-10-22	1989-10-22 00:00:00	1989-10-22	1989-10-22 00:00:00	\N	38000177		0	0	0		0	0	0	354439	0	1049221	40231925		
7112	598	1124300	2009-10-26	2009-10-26 00:00:00	2009-10-26	2009-10-26 00:00:00	\N	38000177		0	0	0		0	0	0	39500	0	00781178901	45011828		
38431	3177	19059056	1924-12-04	1924-12-04 00:00:00	1924-12-18	1924-12-18 00:00:00	1924-12-18	38000177		0	0	14		0	0	0	211226	0	243670	19059056		
6288	525	46275444	1952-05-22	1952-05-22 00:00:00	1952-05-22	1952-05-22 00:00:00	1952-05-22	38000177		0	0	0		0	0	0	34958	0	1659149	46275444		
92	6	19059056	1965-06-23	1965-06-23 00:00:00	1965-07-07	1965-07-07 00:00:00	1965-07-07	38000177		0	0	14		0	0	0	544	0	243670	19059056		
154	11	1127433	2008-02-20	2008-02-20 00:00:00	2008-03-05	2008-03-05 00:00:00	2008-03-05	38000177		0	0	14		0	0	0	906	0	313782	1127433		
28394	2342	40236824	2010-02-08	2010-02-08 00:00:00	2010-02-15	2010-02-15 00:00:00	2010-02-15	38000177		0	0	7		0	0	0	155902	0	1094107	40236824		
28422	2344	1127078	1969-05-27	1969-05-27 00:00:00	1969-06-17	1969-06-17 00:00:00	1969-06-17	38000177		0	0	21		0	0	0	156034	0	282464	1127078		
28481	2347	19019979	1980-03-04	1980-03-04 00:00:00	1980-03-18	1980-03-18 00:00:00	1980-03-18	38000177		0	0	14		0	0	0	156222	0	198405	19019979		
28535	2351	19059056	1949-05-13	1949-05-13 00:00:00	1949-06-10	1949-06-10 00:00:00	1949-06-10	38000177		0	0	28		0	0	0	156556	0	243670	19059056		
31329	2597	1118084	2010-08-31	2010-08-31 00:00:00	2010-08-31	2010-08-31 00:00:00	\N	38000177		0	0	0		0	0	0	171863	0	00025152531	44923712		
53976	4485	1127433	2002-08-22	2002-08-22 00:00:00	2002-08-29	2002-08-29 00:00:00	2002-08-29	38000177		0	0	7		0	0	0	298599	0	313782	1127433		
38081	3149	1118084	1989-10-31	1989-10-31 00:00:00	1989-10-31	1989-10-31 00:00:00	\N	38000177		0	0	0		0	0	0	209534	0	00025152531	44923712		
9264	197	40213160	1965-08-29	1965-08-29 00:00:00	1965-08-29	1965-08-29 00:00:00	1965-08-29	581452		0	0	0		0	0	0	13589	0	10	40213160		
59204	4922	1127078	1977-12-26	1977-12-26 00:00:00	1978-01-09	1978-01-09 00:00:00	1978-01-09	38000177		0	0	14		0	0	0	327020	0	282464	1127078		
2474	197	40229134	1968-09-08	1968-09-08 00:00:00	1968-09-15	1968-09-15 00:00:00	1968-09-15	38000177		0	0	7		0	0	0	13534	0	1043400	40229134		
32399	2685	1127433	1992-04-12	1992-04-12 00:00:00	1992-05-10	1992-05-10 00:00:00	1992-05-10	38000177		0	0	28		0	0	0	177899	0	313782	1127433		
34982	2890	920300	2010-01-08	2010-01-08 00:00:00	2010-01-15	2010-01-15 00:00:00	2010-01-15	38000177		0	0	7		0	0	0	192199	0	311989	920300		
10210	856	1115171	2015-05-18	2015-05-18 00:00:00	2015-07-17	2015-07-17 00:00:00	2015-07-17	38000177		0	0	60		0	0	0	56577	0	849574	1115171		
45523	3767	19019979	1988-08-15	1988-08-15 00:00:00	1988-08-29	1988-08-29 00:00:00	1988-08-29	38000177		0	0	14		0	0	0	250382	0	198405	19019979		
40997	3399	19128065	2000-01-19	2000-01-19 00:00:00	2001-01-13	2001-01-13 00:00:00	2001-01-13	38000177		0	0	360		0	0	0	225539	0	749882	19128065		
4820	403	1127433	1926-02-07	1926-02-07 00:00:00	1926-02-21	1926-02-21 00:00:00	1926-02-21	38000177		0	0	14		0	0	0	26529	0	313782	1127433		
194892	4282	40213227	2017-04-12	2017-04-12 00:00:00	2017-04-12	2017-04-12 00:00:00	2017-04-12	581452		0	0	0		0	0	0	284218	0	113	40213227		
28733	2372	1127433	1965-05-02	1965-05-02 00:00:00	1965-05-16	1965-05-16 00:00:00	1965-05-16	38000177		0	0	14		0	0	0	157822	0	313782	1127433		
60904	5065	1118084	2002-02-23	2002-02-23 00:00:00	2002-02-23	2002-02-23 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00025152531	44923712		
14083	1177	19133873	1978-04-23	1978-04-23 00:00:00	1978-05-02	1978-05-02 00:00:00	1978-05-02	38000177		0	0	9		0	0	0	77737	0	834061	19133873		
36593	3020	1127433	1969-03-20	1969-03-20 00:00:00	1969-03-27	1969-03-27 00:00:00	1969-03-27	38000177		0	0	7		0	0	0	201392	0	313782	1127433		
24634	2026	1115171	2016-05-04	2016-05-04 00:00:00	2016-06-03	2016-06-03 00:00:00	2016-06-03	38000177		0	0	30		0	0	0	134796	0	849574	1115171		
44932	3718	19128065	1984-09-25	1984-09-25 00:00:00	1985-09-20	1985-09-20 00:00:00	1985-09-20	38000177		0	0	360		0	0	0	247141	0	749882	19128065		
23256	1916	1154615	1974-10-10	1974-10-10 00:00:00	1974-10-10	1974-10-10 00:00:00	\N	38000177		0	0	0		0	0	0	127450	0	745679	1154615		
23307	1921	19059056	1951-12-23	1951-12-23 00:00:00	1952-01-06	1952-01-06 00:00:00	1952-01-06	38000177		0	0	14		0	0	0	127740	0	243670	19059056		
50047	4153	1127078	1967-01-02	1967-01-02 00:00:00	1967-01-16	1967-01-16 00:00:00	1967-01-16	38000177		0	0	14		0	0	0	276041	0	282464	1127078		
26204	2155	1127433	1979-07-25	1979-07-25 00:00:00	1979-08-08	1979-08-08 00:00:00	1979-08-08	38000177		0	0	14		0	0	0	143575	0	313782	1127433		
26763	2204	19133905	1987-11-19	1987-11-19 00:00:00	1987-12-01	1987-12-01 00:00:00	1987-12-01	38000177		0	0	12		0	0	0	146936	0	834102	19133905		
26797	2207	1127078	1981-02-18	1981-02-18 00:00:00	1981-03-04	1981-03-04 00:00:00	1981-03-04	38000177		0	0	14		0	0	0	147098	0	282464	1127078		
60671	5046	1127078	1959-08-07	1959-08-07 00:00:00	1959-08-21	1959-08-21 00:00:00	1959-08-21	38000177		0	0	14		0	0	0	335366	0	282464	1127078		
60720	5049	1310034	1998-02-18	1998-02-18 00:00:00	1998-02-18	1998-02-18 00:00:00	1998-02-18	38000177		0	0	0		0	0	0	335586	0	834357	1310034		
35717	2943	1127433	1995-12-15	1995-12-15 00:00:00	1996-01-12	1996-01-12 00:00:00	1996-01-12	38000177		0	0	28		0	0	0	196324	0	313782	1127433		
52076	4330	19059056	1948-04-18	1948-04-18 00:00:00	1948-05-02	1948-05-02 00:00:00	1948-05-02	38000177		0	0	14		0	0	0	287242	0	243670	19059056		
6862	578	1127078	1970-01-15	1970-01-15 00:00:00	1970-04-15	1970-04-15 00:00:00	1970-04-15	38000177		0	0	90		0	0	0	38193	0	282464	1127078		
6898	580	19059056	1929-06-24	1929-06-24 00:00:00	1929-07-08	1929-07-08 00:00:00	1929-07-08	38000177		0	0	14		0	0	0	38399	0	243670	19059056		
33226	2752	40229134	1956-07-14	1956-07-14 00:00:00	1956-07-21	1956-07-21 00:00:00	1956-07-21	38000177		0	0	7		0	0	0	182059	0	1043400	40229134		
61483	5116	19133905	1992-06-04	1992-06-04 00:00:00	1992-06-16	1992-06-16 00:00:00	1992-06-16	38000177		0	0	12		0	0	0	340001	0	834102	19133905		
1182	95	1127078	1968-12-29	1968-12-29 00:00:00	1969-01-12	1969-01-12 00:00:00	1969-01-12	38000177		0	0	14		0	0	0	6463	0	282464	1127078		
56945	4724	19008572	1945-07-30	1945-07-30 00:00:00	1945-08-20	1945-08-20 00:00:00	1945-08-20	38000177		0	0	21		0	0	0	314732	0	106258	19008572		
19344	1597	1115171	1994-07-18	1994-07-18 00:00:00	1994-08-01	1994-08-01 00:00:00	1994-08-01	38000177		0	0	14		0	0	0	107196	0	849574	1115171		
9150	760	40229134	2007-06-21	2007-06-21 00:00:00	2007-06-28	2007-06-28 00:00:00	2007-06-28	38000177		0	0	7		0	0	0	50497	0	1043400	40229134		
19400	1600	1127078	1952-02-23	1952-02-23 00:00:00	1952-03-15	1952-03-15 00:00:00	1952-03-15	38000177		0	0	21		0	0	0	107368	0	282464	1127078		
44085	3650	19133905	2015-07-03	2015-07-03 00:00:00	2015-07-14	2015-07-14 00:00:00	2015-07-14	38000177		0	0	11		0	0	0	242949	0	834102	19133905		
10553	225	40213306	1987-10-05	1987-10-05 00:00:00	1987-10-05	1987-10-05 00:00:00	1987-10-05	581452		0	0	0		0	0	0	15131	0	43	40213306		
38741	3201	19059056	1941-04-25	1941-04-25 00:00:00	1941-05-23	1941-05-23 00:00:00	1941-05-23	38000177		0	0	28		0	0	0	212915	0	243670	19059056		
37141	3069	1127078	1971-12-13	1971-12-13 00:00:00	1971-12-27	1971-12-27 00:00:00	1971-12-27	38000177		0	0	14		0	0	0	204310	0	282464	1127078		
19870	1632	19059056	1954-03-08	1954-03-08 00:00:00	1954-03-22	1954-03-22 00:00:00	1954-03-22	38000177		0	0	14		0	0	0	109625	0	243670	19059056		
12912	1085	1118084	2004-11-08	2004-11-08 00:00:00	2004-11-08	2004-11-08 00:00:00	\N	38000177		0	0	0		0	0	0	71290	0	00025152531	44923712		
57710	4795	19128065	1986-09-24	1986-09-24 00:00:00	1987-09-19	1987-09-19 00:00:00	1987-09-19	38000177		0	0	360		0	0	0	319029	0	749882	19128065		
32328	2680	1127433	1981-04-09	1981-04-09 00:00:00	1981-04-23	1981-04-23 00:00:00	1981-04-23	38000177		0	0	14		0	0	0	177516	0	313782	1127433		
30513	2530	1127433	1978-04-06	1978-04-06 00:00:00	1978-04-20	1978-04-20 00:00:00	1978-04-20	38000177		0	0	14		0	0	0	167212	0	313782	1127433		
17118	1418	1127078	1973-09-22	1973-09-22 00:00:00	1973-10-13	1973-10-13 00:00:00	1973-10-13	38000177		0	0	21		0	0	0	94420	0	282464	1127078		
23947	1971	19128065	1987-02-18	1987-02-18 00:00:00	1988-02-13	1988-02-13 00:00:00	1988-02-13	38000177		0	0	360		0	0	0	131106	0	749882	19128065		
9786	820	1118084	2004-12-27	2004-12-27 00:00:00	2004-12-27	2004-12-27 00:00:00	\N	38000177		0	0	0		0	0	0	54354	0	00025152531	44923712		
20271	1662	19129655	1964-07-11	1964-07-11 00:00:00	1964-07-25	1964-07-25 00:00:00	1964-07-25	38000177		0	0	14		0	0	0	111736	0	789980	19129655		
40463	3353	19059056	1954-03-16	1954-03-16 00:00:00	1954-04-20	1954-04-20 00:00:00	1954-04-20	38000177		0	0	35		0	0	0	222427	0	243670	19059056		
27058	2232	1127433	2016-10-13	2016-10-13 00:00:00	2016-10-20	2016-10-20 00:00:00	2016-10-20	38000177		0	0	7		0	0	0	148523	0	313782	1127433		
37555	3105	1713671	1981-05-03	1981-05-03 00:00:00	1981-05-10	1981-05-10 00:00:00	1981-05-10	38000177		0	0	7		0	0	0	206505	0	562251	1713671		
64142	5325	19059056	1989-10-22	1989-10-22 00:00:00	1989-11-05	1989-11-05 00:00:00	1989-11-05	38000177		0	0	14		0	0	0	354439	0	243670	19059056		
7113	598	1127078	1977-01-07	1977-01-07 00:00:00	1977-01-21	1977-01-21 00:00:00	1977-01-21	38000177		0	0	14		0	0	0	39504	0	282464	1127078		
38432	3177	19059056	1959-04-24	1959-04-24 00:00:00	1959-05-15	1959-05-15 00:00:00	1959-05-15	38000177		0	0	21		0	0	0	211229	0	243670	19059056		
6289	525	35605858	1952-05-22	1952-05-22 00:00:00	1952-05-22	1952-05-22 00:00:00	1952-05-22	38000177		0	0	0		0	0	0	34958	0	1732136	35605858		
94	6	19115351	2003-12-21	2003-12-21 00:00:00	2003-12-21	2003-12-21 00:00:00	\N	38000177		0	0	0		0	0	0	559	0	563026	19115351		
155	11	19059056	1966-08-24	1966-08-24 00:00:00	1966-09-23	1966-09-23 00:00:00	1966-09-23	38000177		0	0	30		0	0	0	988	0	243670	19059056		
28395	2342	1713671	2008-05-01	2008-05-01 00:00:00	2008-05-22	2008-05-22 00:00:00	2008-05-22	38000177		0	0	21		0	0	0	155895	0	562251	1713671		
28424	2344	1127433	1970-11-19	1970-11-19 00:00:00	1970-11-26	1970-11-26 00:00:00	1970-11-26	38000177		0	0	7		0	0	0	156024	0	313782	1127433		
28482	2347	1118084	2012-09-07	2012-09-07 00:00:00	2012-09-07	2012-09-07 00:00:00	\N	38000177		0	0	0		0	0	0	156248	0	00025152531	44923712		
28536	2351	19006318	1949-05-13	1949-05-13 00:00:00	1949-06-10	1949-06-10 00:00:00	1949-06-10	38000177		0	0	28		0	0	0	156556	0	105078	19006318		
31330	2597	19078461	1999-06-07	1999-06-07 00:00:00	1999-06-28	1999-06-28 00:00:00	1999-06-28	38000177		0	0	21		0	0	0	171859	0	310965	19078461		
53977	4485	1118084	1994-10-16	1994-10-16 00:00:00	1994-10-16	1994-10-16 00:00:00	\N	38000177		0	0	0		0	0	0	298605	0	00025152531	44923712		
38082	3149	40229134	1982-08-05	1982-08-05 00:00:00	1982-08-12	1982-08-12 00:00:00	1982-08-12	38000177		0	0	7		0	0	0	209487	0	1043400	40229134		
9266	197	40213260	2010-10-17	2010-10-17 00:00:00	2010-10-17	2010-10-17 00:00:00	2010-10-17	581452		0	0	0		0	0	0	13581	0	121	40213260		
59205	4922	46233988	1977-12-26	1977-12-26 00:00:00	1978-01-09	1978-01-09 00:00:00	1978-01-09	38000177		0	0	14		0	0	0	327020	0	1652673	46233988		
2475	197	19059056	1975-10-26	1975-10-26 00:00:00	1975-11-16	1975-11-16 00:00:00	1975-11-16	38000177		0	0	21		0	0	0	13530	0	243670	19059056		
32400	2685	19059056	1950-07-17	1950-07-17 00:00:00	1950-08-07	1950-08-07 00:00:00	1950-08-07	38000177		0	0	21		0	0	0	177897	0	243670	19059056		
34983	2890	19059056	1970-08-23	1970-08-23 00:00:00	1970-10-22	1970-10-22 00:00:00	1970-10-22	38000177		0	0	60		0	0	0	192211	0	243670	19059056		
10211	856	40162522	2015-05-18	2015-05-18 00:00:00	2015-05-18	2015-05-18 00:00:00	\N	38000177		0	0	0		0	0	0	56577	0	857005	40162522		
45524	3767	1118084	2018-10-20	2018-10-20 00:00:00	2018-10-20	2018-10-20 00:00:00	\N	38000177		0	0	0		0	0	0	250352	0	00025152531	44923712		
2875	232	40231925	1959-02-12	1959-02-12 00:00:00	1959-02-12	1959-02-12 00:00:00	\N	38000177		0	0	0		0	0	0	15596	0	1049221	40231925		
21687	471	40213314	1985-10-11	1985-10-11 00:00:00	1985-10-11	1985-10-11 00:00:00	1985-10-11	581452		0	0	0		0	0	0	31482	0	49	40213314		
194897	4282	40213296	2006-04-12	2006-04-12 00:00:00	2006-04-12	2006-04-12 00:00:00	2006-04-12	581452		0	0	0		0	0	0	284176	0	52	40213296		
28734	2372	19133905	1977-11-13	1977-11-13 00:00:00	1977-11-20	1977-11-20 00:00:00	1977-11-20	38000177		0	0	7		0	0	0	157842	0	834102	19133905		
60905	5065	46233988	1971-06-01	1971-06-01 00:00:00	1971-06-15	1971-06-15 00:00:00	1971-06-15	38000177		0	0	14		0	0	0	336741	0	1652673	46233988		
14084	1177	1127433	1989-05-13	1989-05-13 00:00:00	1989-05-27	1989-05-27 00:00:00	1989-05-27	38000177		0	0	14		0	0	0	77761	0	313782	1127433		
36594	3020	1127433	1981-10-29	1981-10-29 00:00:00	1981-11-05	1981-11-05 00:00:00	1981-11-05	38000177		0	0	7		0	0	0	201391	0	313782	1127433		
24635	2026	40165015	2016-05-04	2016-05-04 00:00:00	2016-05-04	2016-05-04 00:00:00	\N	38000177		0	0	0		0	0	0	134796	0	861467	40165015		
44934	3718	19128065	1980-10-16	1980-10-16 00:00:00	1981-10-11	1981-10-11 00:00:00	1981-10-11	38000177		0	0	360		0	0	0	247139	0	749882	19128065		
23257	1916	1127433	2001-09-09	2001-09-09 00:00:00	2001-09-23	2001-09-23 00:00:00	2001-09-23	38000177		0	0	14		0	0	0	127434	0	313782	1127433		
23308	1921	19006318	1951-12-23	1951-12-23 00:00:00	1952-01-06	1952-01-06 00:00:00	1952-01-06	38000177		0	0	14		0	0	0	127740	0	105078	19006318		
50048	4153	1115171	2005-05-10	2005-05-10 00:00:00	2005-07-09	2005-07-09 00:00:00	2005-07-09	38000177		0	0	60		0	0	0	276008	0	849574	1115171		
26205	2155	1118084	1970-07-16	1970-07-16 00:00:00	1970-07-16	1970-07-16 00:00:00	\N	38000177		0	0	0		0	0	0	143590	0	00025152531	44923712		
26764	2204	1127433	1952-12-05	1952-12-05 00:00:00	1952-12-19	1952-12-19 00:00:00	1952-12-19	38000177		0	0	14		0	0	0	146903	0	313782	1127433		
26798	2207	40236824	2002-05-27	2002-05-27 00:00:00	2002-06-03	2002-06-03 00:00:00	2002-06-03	38000177		0	0	7		0	0	0	147101	0	1094107	40236824		
60685	5048	40236824	1983-01-06	1983-01-06 00:00:00	1983-01-13	1983-01-13 00:00:00	1983-01-13	38000177		0	0	7		0	0	0	335462	0	1094107	40236824		
60721	5049	19059056	1993-08-16	1993-08-16 00:00:00	1993-09-06	1993-09-06 00:00:00	1993-09-06	38000177		0	0	21		0	0	0	335585	0	243670	19059056		
35718	2943	19059056	1936-08-16	1936-08-16 00:00:00	1936-09-06	1936-09-06 00:00:00	1936-09-06	38000177		0	0	21		0	0	0	196247	0	243670	19059056		
52077	4330	19006318	1948-04-18	1948-04-18 00:00:00	1948-05-02	1948-05-02 00:00:00	1948-05-02	38000177		0	0	14		0	0	0	287242	0	105078	19006318		
6863	578	19128065	1989-04-15	1989-04-15 00:00:00	1990-04-10	1990-04-10 00:00:00	1990-04-10	38000177		0	0	360		0	0	0	38234	0	749882	19128065		
6899	580	19059056	1958-04-26	1958-04-26 00:00:00	1958-05-10	1958-05-10 00:00:00	1958-05-10	38000177		0	0	14		0	0	0	38402	0	243670	19059056		
33547	2776	1127078	1984-11-21	1984-11-21 00:00:00	1984-12-05	1984-12-05 00:00:00	1984-12-05	38000177		0	0	14		0	0	0	183816	0	282464	1127078		
61484	5116	1127433	1970-05-07	1970-05-07 00:00:00	1970-05-21	1970-05-21 00:00:00	1970-05-21	38000177		0	0	14		0	0	0	339993	0	313782	1127433		
1183	95	1127078	1962-10-08	1962-10-08 00:00:00	1962-10-22	1962-10-22 00:00:00	1962-10-22	38000177		0	0	14		0	0	0	6404	0	282464	1127078		
56946	4724	40229134	1996-10-20	1996-10-20 00:00:00	1996-10-27	1996-10-27 00:00:00	1996-10-27	38000177		0	0	7		0	0	0	314798	0	1043400	40229134		
60917	1332	40213227	2014-10-29	2014-10-29 00:00:00	2014-10-29	2014-10-29 00:00:00	2014-10-29	581452		0	0	0		0	0	0	88402	0	113	40213227		
9151	760	19078461	1979-05-11	1979-05-11 00:00:00	1979-05-25	1979-05-25 00:00:00	1979-05-25	38000177		0	0	14		0	0	0	50509	0	310965	19078461		
19401	1600	19078461	2013-09-01	2013-09-01 00:00:00	2013-10-31	2013-10-31 00:00:00	2013-10-31	38000177		0	0	60		0	0	0	107367	0	310965	19078461		
44086	3650	19059056	1931-06-04	1931-06-04 00:00:00	1931-06-18	1931-06-18 00:00:00	1931-06-18	38000177		0	0	14		0	0	0	242946	0	243670	19059056		
10556	225	40213227	1996-10-14	1996-10-14 00:00:00	1996-10-14	1996-10-14 00:00:00	1996-10-14	581452		0	0	0		0	0	0	15134	0	113	40213227		
38742	3201	40229134	1958-08-25	1958-08-25 00:00:00	1958-09-01	1958-09-01 00:00:00	1958-09-01	38000177		0	0	7		0	0	0	212921	0	1043400	40229134		
37142	3069	1713671	2011-07-13	2011-07-13 00:00:00	2011-07-20	2011-07-20 00:00:00	2011-07-20	38000177		0	0	7		0	0	0	204250	0	562251	1713671		
19871	1632	19006318	1954-03-08	1954-03-08 00:00:00	1954-03-22	1954-03-22 00:00:00	1954-03-22	38000177		0	0	14		0	0	0	109625	0	105078	19006318		
12913	1085	1713671	1998-07-24	1998-07-24 00:00:00	1998-08-14	1998-08-14 00:00:00	1998-08-14	38000177		0	0	21		0	0	0	71248	0	562251	1713671		
57712	4795	1127433	1974-02-20	1974-02-20 00:00:00	1974-03-06	1974-03-06 00:00:00	1974-03-06	38000177		0	0	14		0	0	0	318993	0	313782	1127433		
32329	2680	1118084	2007-10-17	2007-10-17 00:00:00	2007-10-17	2007-10-17 00:00:00	\N	38000177		0	0	0		0	0	0	177593	0	00025152531	44923712		
30514	2530	1118084	2000-09-04	2000-09-04 00:00:00	2000-09-04	2000-09-04 00:00:00	\N	38000177		0	0	0		0	0	0	167267	0	00025152531	44923712		
17119	1418	1713671	2004-06-04	2004-06-04 00:00:00	2004-06-11	2004-06-11 00:00:00	2004-06-11	38000177		0	0	7		0	0	0	94411	0	562251	1713671		
23948	1971	46233988	1973-01-15	1973-01-15 00:00:00	1973-01-29	1973-01-29 00:00:00	1973-01-29	38000177		0	0	14		0	0	0	131115	0	1652673	46233988		
9787	820	1713671	1989-12-27	1989-12-27 00:00:00	1990-01-10	1990-01-10 00:00:00	1990-01-10	38000177		0	0	14		0	0	0	54349	0	562251	1713671		
20272	1662	1124300	1999-05-24	1999-05-24 00:00:00	1999-05-24	1999-05-24 00:00:00	\N	38000177		0	0	0		0	0	0	111734	0	00781178901	45011828		
40464	3355	40229134	2002-02-08	2002-02-08 00:00:00	2002-02-15	2002-02-15 00:00:00	2002-02-15	38000177		0	0	7		0	0	0	222464	0	1043400	40229134		
37529	3103	19059056	1987-12-10	1987-12-10 00:00:00	1988-01-09	1988-01-09 00:00:00	1988-01-09	38000177		0	0	30		0	0	0	206456	0	243670	19059056		
37556	3105	19078461	2000-10-13	2000-10-13 00:00:00	2000-11-03	2000-11-03 00:00:00	2000-11-03	38000177		0	0	21		0	0	0	206481	0	310965	19078461		
53937	4482	1127433	1994-04-12	1994-04-12 00:00:00	1994-04-26	1994-04-26 00:00:00	1994-04-26	38000177		0	0	14		0	0	0	298394	0	313782	1127433		
7114	598	19006318	1977-01-07	1977-01-07 00:00:00	1977-01-21	1977-01-21 00:00:00	1977-01-21	38000177		0	0	14		0	0	0	39504	0	105078	19006318		
38433	3177	40236824	1948-10-18	1948-10-18 00:00:00	1948-10-25	1948-10-25 00:00:00	1948-10-25	38000177		0	0	7		0	0	0	211250	0	1094107	40236824		
6290	525	1713671	1964-04-22	1964-04-22 00:00:00	1964-06-03	1964-06-03 00:00:00	1964-06-03	38000177		0	0	42		0	0	0	35010	0	562251	1713671		
96	6	19059056	1971-08-12	1971-08-12 00:00:00	1971-08-26	1971-08-26 00:00:00	1971-08-26	38000177		0	0	14		0	0	0	555	0	243670	19059056		
156	11	19075601	2002-05-28	2002-05-28 00:00:00	2002-05-28	2002-05-28 00:00:00	2002-05-28	38000177		0	0	0		0	0	0	973	0	309362	19075601		
28396	2342	1127433	2012-04-20	2012-04-20 00:00:00	2012-04-27	2012-04-27 00:00:00	2012-04-27	38000177		0	0	7		0	0	0	155926	0	313782	1127433		
28425	2344	40236824	2008-03-31	2008-03-31 00:00:00	2008-04-07	2008-04-07 00:00:00	2008-04-07	38000177		0	0	7		0	0	0	156076	0	1094107	40236824		
28483	2347	920300	2016-01-02	2016-01-02 00:00:00	2016-01-09	2016-01-09 00:00:00	2016-01-09	38000177		0	0	7		0	0	0	156236	0	311989	920300		
28537	2351	19059056	1950-12-04	1950-12-04 00:00:00	1950-12-18	1950-12-18 00:00:00	1950-12-18	38000177		0	0	14		0	0	0	156570	0	243670	19059056		
31331	2597	19059056	1973-01-12	1973-01-12 00:00:00	1973-01-26	1973-01-26 00:00:00	1973-01-26	38000177		0	0	14		0	0	0	171855	0	243670	19059056		
53978	4485	19078461	2003-05-07	2003-05-07 00:00:00	2003-05-21	2003-05-21 00:00:00	2003-05-21	38000177		0	0	14		0	0	0	298619	0	310965	19078461		
38083	3149	19133873	1968-10-17	1968-10-17 00:00:00	1968-10-30	1968-10-30 00:00:00	1968-10-30	38000177		0	0	13		0	0	0	209524	0	834061	19133873		
9273	197	40213160	1961-05-28	1961-05-28 00:00:00	1961-05-28	1961-05-28 00:00:00	1961-05-28	581452		0	0	0		0	0	0	13550	0	10	40213160		
59206	4922	1127078	1983-05-29	1983-05-29 00:00:00	1983-08-04	1983-08-04 00:00:00	1983-08-04	38000177		0	0	67		0	0	0	327002	0	282464	1127078		
2476	197	1118084	1996-07-31	1996-07-31 00:00:00	1996-07-31	1996-07-31 00:00:00	\N	38000177		0	0	0		0	0	0	13564	0	00025152531	44923712		
32401	2686	1127433	2001-04-17	2001-04-17 00:00:00	2001-05-01	2001-05-01 00:00:00	2001-05-01	38000177		0	0	14		0	0	0	178029	0	313782	1127433		
34984	2890	1713671	1979-10-20	1979-10-20 00:00:00	1979-10-27	1979-10-27 00:00:00	1979-10-27	38000177		0	0	7		0	0	0	192228	0	562251	1713671		
10212	856	1127078	1970-10-06	1970-10-06 00:00:00	1970-10-20	1970-10-20 00:00:00	1970-10-20	38000177		0	0	14		0	0	0	56566	0	282464	1127078		
45525	3767	19133905	2017-09-20	2017-09-20 00:00:00	2017-10-02	2017-10-02 00:00:00	2017-10-02	38000177		0	0	12		0	0	0	250352	0	834102	19133905		
2876	232	19059056	1953-08-30	1953-08-30 00:00:00	1953-09-20	1953-09-20 00:00:00	1953-09-20	38000177		0	0	21		0	0	0	15645	0	243670	19059056		
21688	471	40213160	1990-04-13	1990-04-13 00:00:00	1990-04-13	1990-04-13 00:00:00	1990-04-13	581452		0	0	0		0	0	0	31488	0	10	40213160		
194902	4282	40213260	2016-04-06	2016-04-06 00:00:00	2016-04-06	2016-04-06 00:00:00	2016-04-06	581452		0	0	0		0	0	0	284178	0	121	40213260		
28735	2372	1124300	1997-12-09	1997-12-09 00:00:00	1997-12-09	1997-12-09 00:00:00	\N	38000177		0	0	0		0	0	0	157834	0	00781178901	45011828		
60906	5065	19059056	1971-06-01	1971-06-01 00:00:00	1971-06-15	1971-06-15 00:00:00	1971-06-15	38000177		0	0	14		0	0	0	336741	0	243670	19059056		
14085	1177	19128065	1981-04-12	1981-04-12 00:00:00	1982-04-07	1982-04-07 00:00:00	1982-04-07	38000177		0	0	360		0	0	0	77803	0	749882	19128065		
36595	3020	1539411	1991-03-20	1991-03-20 00:00:00	1991-03-20	1991-03-20 00:00:00	\N	38000177		0	0	0		0	0	0	201399	0	312961	1539411		
24636	2026	1713671	2016-03-07	2016-03-07 00:00:00	2016-03-28	2016-03-28 00:00:00	2016-03-28	38000177		0	0	21		0	0	0	134793	0	562251	1713671		
44935	3718	46233988	1970-10-11	1970-10-11 00:00:00	1970-10-25	1970-10-25 00:00:00	1970-10-25	38000177		0	0	14		0	0	0	247097	0	1652673	46233988		
23258	1916	19059056	1977-07-18	1977-07-18 00:00:00	1977-08-17	1977-08-17 00:00:00	1977-08-17	38000177		0	0	30		0	0	0	127440	0	243670	19059056		
23309	1921	40229134	1965-08-20	1965-08-20 00:00:00	1965-08-27	1965-08-27 00:00:00	1965-08-27	38000177		0	0	7		0	0	0	127720	0	1043400	40229134		
50049	4153	1127433	2018-01-21	2018-01-21 00:00:00	2018-01-28	2018-01-28 00:00:00	2018-01-28	38000177		0	0	7		0	0	0	276040	0	313782	1127433		
26206	2155	1127433	2000-04-17	2000-04-17 00:00:00	2000-05-01	2000-05-01 00:00:00	2000-05-01	38000177		0	0	14		0	0	0	143579	0	313782	1127433		
26765	2204	1127078	1950-02-11	1950-02-11 00:00:00	1950-02-25	1950-02-25 00:00:00	1950-02-25	38000177		0	0	14		0	0	0	146887	0	282464	1127078		
26799	2207	920300	2002-05-27	2002-05-27 00:00:00	2002-06-03	2002-06-03 00:00:00	2002-06-03	38000177		0	0	7		0	0	0	147101	0	311989	920300		
60686	5048	920300	1983-01-06	1983-01-06 00:00:00	1983-01-13	1983-01-13 00:00:00	1983-01-13	38000177		0	0	7		0	0	0	335462	0	311989	920300		
60722	5049	1127433	1966-05-11	1966-05-11 00:00:00	1966-05-25	1966-05-25 00:00:00	1966-05-25	38000177		0	0	14		0	0	0	335588	0	313782	1127433		
35719	2943	1713671	2002-05-11	2002-05-11 00:00:00	2002-06-01	2002-06-01 00:00:00	2002-06-01	38000177		0	0	21		0	0	0	196272	0	562251	1713671		
52078	4330	19073188	1987-11-24	1987-11-24 00:00:00	1987-12-08	1987-12-08 00:00:00	1987-12-08	38000177		0	0	14		0	0	0	287261	0	308192	19073188		
6864	578	19128065	1987-04-26	1987-04-26 00:00:00	1988-04-20	1988-04-20 00:00:00	1988-04-20	38000177		0	0	360		0	0	0	38258	0	749882	19128065		
6900	580	19059056	1930-06-03	1930-06-03 00:00:00	1930-07-01	1930-07-01 00:00:00	1930-07-01	38000177		0	0	28		0	0	0	38400	0	243670	19059056		
33548	2776	40229134	1980-09-16	1980-09-16 00:00:00	1980-09-30	1980-09-30 00:00:00	1980-09-30	38000177		0	0	14		0	0	0	183860	0	1043400	40229134		
61485	5116	1127433	2011-04-24	2011-04-24 00:00:00	2011-05-01	2011-05-01 00:00:00	2011-05-01	38000177		0	0	7		0	0	0	339943	0	313782	1127433		
1184	95	19006318	1962-10-08	1962-10-08 00:00:00	1962-10-22	1962-10-22 00:00:00	1962-10-22	38000177		0	0	14		0	0	0	6404	0	105078	19006318		
56947	4724	40229134	1977-12-26	1977-12-26 00:00:00	1978-01-02	1978-01-02 00:00:00	1978-01-02	38000177		0	0	7		0	0	0	314771	0	1043400	40229134		
60923	1332	40213227	1994-07-06	1994-07-06 00:00:00	1994-07-06	1994-07-06 00:00:00	1994-07-06	581452		0	0	0		0	0	0	88364	0	113	40213227		
9152	761	1127433	1991-04-19	1991-04-19 00:00:00	1991-05-03	1991-05-03 00:00:00	1991-05-03	38000177		0	0	14		0	0	0	50546	0	313782	1127433		
19402	1600	1713671	1958-11-06	1958-11-06 00:00:00	1958-11-13	1958-11-13 00:00:00	1958-11-13	38000177		0	0	7		0	0	0	107439	0	562251	1713671		
44087	3650	1127433	1977-01-29	1977-01-29 00:00:00	1977-02-12	1977-02-12 00:00:00	1977-02-12	38000177		0	0	14		0	0	0	242989	0	313782	1127433		
10558	225	40213296	2007-01-15	2007-01-15 00:00:00	2007-01-15	2007-01-15 00:00:00	2007-01-15	581452		0	0	0		0	0	0	15132	0	52	40213296		
38743	3201	19059056	1941-03-26	1941-03-26 00:00:00	1941-04-09	1941-04-09 00:00:00	1941-04-09	38000177		0	0	14		0	0	0	212904	0	243670	19059056		
37143	3070	19059056	1967-08-28	1967-08-28 00:00:00	1967-10-27	1967-10-27 00:00:00	1967-10-27	38000177		0	0	60		0	0	0	204358	0	243670	19059056		
19872	1632	1713671	1993-12-07	1993-12-07 00:00:00	1993-12-21	1993-12-21 00:00:00	1993-12-21	38000177		0	0	14		0	0	0	109571	0	562251	1713671		
12914	1085	1127078	1968-11-12	1968-11-12 00:00:00	1969-01-18	1969-01-18 00:00:00	1969-01-18	38000177		0	0	67		0	0	0	71265	0	282464	1127078		
57713	4795	46233988	1969-12-12	1969-12-12 00:00:00	1969-12-26	1969-12-26 00:00:00	1969-12-26	38000177		0	0	14		0	0	0	319024	0	1652673	46233988		
32344	2682	40231925	2017-02-04	2017-02-04 00:00:00	2017-02-04	2017-02-04 00:00:00	\N	38000177		0	0	0		0	0	0	177726	0	1049221	40231925		
30515	2530	1127433	1988-08-04	1988-08-04 00:00:00	1988-08-11	1988-08-11 00:00:00	1988-08-11	38000177		0	0	7		0	0	0	167252	0	313782	1127433		
17120	1418	1127433	1988-03-09	1988-03-09 00:00:00	1988-03-16	1988-03-16 00:00:00	1988-03-16	38000177		0	0	7		0	0	0	94446	0	313782	1127433		
23949	1971	19059056	1973-01-15	1973-01-15 00:00:00	1973-01-29	1973-01-29 00:00:00	1973-01-29	38000177		0	0	14		0	0	0	131115	0	243670	19059056		
9788	820	19133873	1969-05-09	1969-05-09 00:00:00	1969-05-22	1969-05-22 00:00:00	1969-05-22	38000177		0	0	13		0	0	0	54292	0	834061	19133873		
20273	1662	1713671	1988-11-14	1988-11-14 00:00:00	1988-11-28	1988-11-28 00:00:00	1988-11-28	38000177		0	0	14		0	0	0	111712	0	562251	1713671		
40465	3355	1713671	2007-07-22	2007-07-22 00:00:00	2007-08-12	2007-08-12 00:00:00	2007-08-12	38000177		0	0	21		0	0	0	222513	0	562251	1713671		
37530	3103	19019979	1983-03-15	1983-03-15 00:00:00	1983-04-05	1983-04-05 00:00:00	1983-04-05	38000177		0	0	21		0	0	0	206455	0	198405	19019979		
37557	3105	1127433	2007-09-10	2007-09-10 00:00:00	2007-09-17	2007-09-17 00:00:00	2007-09-17	38000177		0	0	7		0	0	0	206508	0	313782	1127433		
53938	4482	40229134	2019-01-19	2019-01-19 00:00:00	2019-01-26	2019-01-26 00:00:00	2019-01-26	38000177		0	0	7		0	0	0	298379	0	1043400	40229134		
7115	598	1127433	2014-01-07	2014-01-07 00:00:00	2014-02-04	2014-02-04 00:00:00	2014-02-04	38000177		0	0	28		0	0	0	39478	0	313782	1127433		
38434	3177	920300	1948-10-18	1948-10-18 00:00:00	1948-10-25	1948-10-25 00:00:00	1948-10-25	38000177		0	0	7		0	0	0	211250	0	311989	920300		
6291	525	1118084	1990-03-15	1990-03-15 00:00:00	1990-03-15	1990-03-15 00:00:00	\N	38000177		0	0	0		0	0	0	34988	0	00025152531	44923712		
97	6	40231925	1976-05-01	1976-05-01 00:00:00	1976-05-01	1976-05-01 00:00:00	\N	38000177		0	0	0		0	0	0	556	0	1049221	40231925		
157	11	40220960	2002-05-28	2002-05-28 00:00:00	2002-05-28	2002-05-28 00:00:00	2002-05-28	38000177		0	0	0		0	0	0	973	0	1804799	40220960		
28397	2342	1115171	2018-11-18	2018-11-18 00:00:00	2018-12-23	2018-12-23 00:00:00	2018-12-23	38000177		0	0	35		0	0	0	155889	0	849574	1115171		
28426	2344	920300	2008-03-31	2008-03-31 00:00:00	2008-04-07	2008-04-07 00:00:00	2008-04-07	38000177		0	0	7		0	0	0	156076	0	311989	920300		
28484	2347	40236824	2016-01-02	2016-01-02 00:00:00	2016-01-09	2016-01-09 00:00:00	2016-01-09	38000177		0	0	7		0	0	0	156236	0	1094107	40236824		
28538	2351	19006318	1950-12-04	1950-12-04 00:00:00	1950-12-18	1950-12-18 00:00:00	1950-12-18	38000177		0	0	14		0	0	0	156570	0	105078	19006318		
31332	2597	1127433	1983-12-30	1983-12-30 00:00:00	1984-01-29	1984-01-29 00:00:00	1984-01-29	38000177		0	0	30		0	0	0	171856	0	313782	1127433		
53979	4485	1127433	1994-07-20	1994-07-20 00:00:00	1994-08-03	1994-08-03 00:00:00	1994-08-03	38000177		0	0	14		0	0	0	298581	0	313782	1127433		
38084	3149	1127433	1992-05-22	1992-05-22 00:00:00	1992-06-05	1992-06-05 00:00:00	1992-06-05	38000177		0	0	14		0	0	0	209488	0	313782	1127433		
9275	197	40213306	1982-11-21	1982-11-21 00:00:00	1982-11-21	1982-11-21 00:00:00	1982-11-21	581452		0	0	0		0	0	0	13557	0	43	40213306		
59207	4922	19133873	1981-08-11	1981-08-11 00:00:00	1981-08-20	1981-08-20 00:00:00	1981-08-20	38000177		0	0	9		0	0	0	326967	0	834061	19133873		
2477	197	1713671	1972-08-24	1972-08-24 00:00:00	1972-09-14	1972-09-14 00:00:00	1972-09-14	38000177		0	0	21		0	0	0	13535	0	562251	1713671		
32402	2686	1127433	1956-11-01	1956-11-01 00:00:00	1956-11-08	1956-11-08 00:00:00	1956-11-08	38000177		0	0	7		0	0	0	178047	0	313782	1127433		
34985	2890	1118084	2001-12-13	2001-12-13 00:00:00	2001-12-13	2001-12-13 00:00:00	\N	38000177		0	0	0		0	0	0	192220	0	00025152531	44923712		
10213	856	19129655	1970-10-06	1970-10-06 00:00:00	1970-10-20	1970-10-20 00:00:00	1970-10-20	38000177		0	0	14		0	0	0	56566	0	789980	19129655		
45526	3767	19073183	1986-10-08	1986-10-08 00:00:00	1986-10-22	1986-10-22 00:00:00	1986-10-22	38000177		0	0	14		0	0	0	250341	0	308182	19073183		
2877	232	19006318	1953-08-30	1953-08-30 00:00:00	1953-09-20	1953-09-20 00:00:00	1953-09-20	38000177		0	0	21		0	0	0	15645	0	105078	19006318		
21690	471	40213251	1990-04-13	1990-04-13 00:00:00	1990-04-13	1990-04-13 00:00:00	1990-04-13	581452		0	0	0		0	0	0	31488	0	21	40213251		
183086	4022	40213260	2009-10-31	2009-10-31 00:00:00	2009-10-31	2009-10-31 00:00:00	2009-10-31	581452		0	0	0		0	0	0	267409	0	121	40213260		
28736	2372	19129655	1966-07-08	1966-07-08 00:00:00	1966-07-22	1966-07-22 00:00:00	1966-07-22	38000177		0	0	14		0	0	0	157845	0	789980	19129655		
60907	5066	1115171	1997-08-17	1997-08-17 00:00:00	1997-08-31	1997-08-31 00:00:00	1997-08-31	38000177		0	0	14		0	0	0	336813	0	849574	1115171		
14086	1177	19059056	1966-04-13	1966-04-13 00:00:00	1966-05-04	1966-05-04 00:00:00	1966-05-04	38000177		0	0	21		0	0	0	77755	0	243670	19059056		
36596	3020	19006318	1957-06-01	1957-06-01 00:00:00	1957-06-15	1957-06-15 00:00:00	1957-06-15	38000177		0	0	14		0	0	0	201395	0	105078	19006318		
24637	2026	40236824	1975-04-05	1975-04-05 00:00:00	1975-04-12	1975-04-12 00:00:00	1975-04-12	38000177		0	0	7		0	0	0	134800	0	1094107	40236824		
44936	3718	19059056	1970-10-11	1970-10-11 00:00:00	1970-10-25	1970-10-25 00:00:00	1970-10-25	38000177		0	0	14		0	0	0	247097	0	243670	19059056		
23259	1916	19059056	1973-09-23	1973-09-23 00:00:00	1973-10-07	1973-10-07 00:00:00	1973-10-07	38000177		0	0	14		0	0	0	127439	0	243670	19059056		
23310	1921	1127433	2012-12-17	2012-12-17 00:00:00	2012-12-24	2012-12-24 00:00:00	2012-12-24	38000177		0	0	7		0	0	0	127748	0	313782	1127433		
50050	4153	1127433	1975-12-26	1975-12-26 00:00:00	1976-01-09	1976-01-09 00:00:00	1976-01-09	38000177		0	0	14		0	0	0	276063	0	313782	1127433		
26207	2155	1127433	1996-01-11	1996-01-11 00:00:00	1996-02-10	1996-02-10 00:00:00	1996-02-10	38000177		0	0	30		0	0	0	143617	0	313782	1127433		
26766	2204	1127433	1954-12-10	1954-12-10 00:00:00	1954-12-24	1954-12-24 00:00:00	1954-12-24	38000177		0	0	14		0	0	0	146873	0	313782	1127433		
26800	2207	19128022	1996-04-14	1996-04-14 00:00:00	1997-04-09	1997-04-09 00:00:00	1997-04-09	38000177		0	0	360		0	0	0	147103	0	749785	19128022		
60687	5048	19006318	1964-09-06	1964-09-06 00:00:00	1964-09-20	1964-09-20 00:00:00	1964-09-20	38000177		0	0	14		0	0	0	335446	0	105078	19006318		
60723	5049	1713671	1968-02-08	1968-02-08 00:00:00	1968-02-15	1968-02-15 00:00:00	1968-02-15	38000177		0	0	7		0	0	0	335632	0	562251	1713671		
35720	2943	40229134	1977-08-02	1977-08-02 00:00:00	1977-08-16	1977-08-16 00:00:00	1977-08-16	38000177		0	0	14		0	0	0	196321	0	1043400	40229134		
52079	4330	1127433	1987-11-24	1987-11-24 00:00:00	1987-12-08	1987-12-08 00:00:00	1987-12-08	38000177		0	0	14		0	0	0	287261	0	313782	1127433		
6865	578	19078461	1979-10-25	1979-10-25 00:00:00	1979-11-15	1979-11-15 00:00:00	1979-11-15	38000177		0	0	21		0	0	0	38195	0	310965	19078461		
6901	580	1118084	1962-07-16	1962-07-16 00:00:00	1962-07-16	1962-07-16 00:00:00	\N	38000177		0	0	0		0	0	0	38419	0	00025152531	44923712		
33549	2777	1127433	1975-06-04	1975-06-04 00:00:00	1975-06-11	1975-06-11 00:00:00	1975-06-11	38000177		0	0	7		0	0	0	183948	0	313782	1127433		
61486	5116	1127433	1979-07-24	1979-07-24 00:00:00	1979-08-14	1979-08-14 00:00:00	1979-08-14	38000177		0	0	21		0	0	0	339887	0	313782	1127433		
1185	96	1124300	1963-04-02	1963-04-02 00:00:00	1963-04-02	1963-04-02 00:00:00	\N	38000177		0	0	0		0	0	0	6469	0	00781178901	45011828		
56948	4724	1713671	2014-10-30	2014-10-30 00:00:00	2014-11-06	2014-11-06 00:00:00	2014-11-06	38000177		0	0	7		0	0	0	314799	0	562251	1713671		
44190	3658	1127078	1962-07-27	1962-07-27 00:00:00	1962-08-10	1962-08-10 00:00:00	1962-08-10	38000177		0	0	14		0	0	0	243483	0	282464	1127078		
9153	761	1127433	2008-01-16	2008-01-16 00:00:00	2008-01-23	2008-01-23 00:00:00	2008-01-23	38000177		0	0	7		0	0	0	50614	0	313782	1127433		
19403	1600	1127433	1965-04-17	1965-04-17 00:00:00	1965-04-24	1965-04-24 00:00:00	1965-04-24	38000177		0	0	7		0	0	0	107432	0	313782	1127433		
44088	3650	1127433	2000-03-21	2000-03-21 00:00:00	2000-03-28	2000-03-28 00:00:00	2000-03-28	38000177		0	0	7		0	0	0	242994	0	313782	1127433		
10560	225	40213227	2007-01-15	2007-01-15 00:00:00	2007-01-15	2007-01-15 00:00:00	2007-01-15	581452		0	0	0		0	0	0	15132	0	113	40213227		
38744	3201	19059056	1973-04-19	1973-04-19 00:00:00	1973-05-10	1973-05-10 00:00:00	1973-05-10	38000177		0	0	21		0	0	0	212918	0	243670	19059056		
37145	3070	46233988	1967-12-19	1967-12-19 00:00:00	1968-01-02	1968-01-02 00:00:00	1968-01-02	38000177		0	0	14		0	0	0	204364	0	1652673	46233988		
19885	1634	1127433	1971-02-18	1971-02-18 00:00:00	1971-03-11	1971-03-11 00:00:00	1971-03-11	38000177		0	0	21		0	0	0	109688	0	313782	1127433		
12915	1085	1713671	1968-03-23	1968-03-23 00:00:00	1968-03-30	1968-03-30 00:00:00	1968-03-30	38000177		0	0	7		0	0	0	71269	0	562251	1713671		
57714	4795	1127078	1969-12-12	1969-12-12 00:00:00	1969-12-26	1969-12-26 00:00:00	1969-12-26	38000177		0	0	14		0	0	0	319024	0	282464	1127078		
32345	2682	19078461	2017-02-04	2017-02-04 00:00:00	2017-05-05	2017-05-05 00:00:00	2017-05-05	38000177		0	0	90		0	0	0	177726	0	310965	19078461		
30516	2530	1127433	2001-08-05	2001-08-05 00:00:00	2001-08-12	2001-08-12 00:00:00	2001-08-12	38000177		0	0	7		0	0	0	167217	0	313782	1127433		
17121	1418	1127433	2016-12-21	2016-12-21 00:00:00	2017-01-04	2017-01-04 00:00:00	2017-01-04	38000177		0	0	14		0	0	0	94458	0	313782	1127433		
23950	1971	40229134	1993-07-04	1993-07-04 00:00:00	1993-07-11	1993-07-11 00:00:00	1993-07-11	38000177		0	0	7		0	0	0	131000	0	1043400	40229134		
9789	820	1713671	2018-05-04	2018-05-04 00:00:00	2018-05-25	2018-05-25 00:00:00	2018-05-25	38000177		0	0	21		0	0	0	54362	0	562251	1713671		
20274	1662	1127433	1969-11-14	1969-11-14 00:00:00	1969-11-28	1969-11-28 00:00:00	1969-11-28	38000177		0	0	14		0	0	0	111710	0	313782	1127433		
40466	3355	1118084	2007-10-09	2007-10-09 00:00:00	2007-10-09	2007-10-09 00:00:00	\N	38000177		0	0	0		0	0	0	222513	0	00025152531	44923712		
3308	273	40162522	2001-09-27	2001-09-27 00:00:00	2001-09-27	2001-09-27 00:00:00	\N	38000177		0	0	0		0	0	0	18287	0	857005	40162522		
37558	3105	1127433	1981-12-26	1981-12-26 00:00:00	1982-01-02	1982-01-02 00:00:00	1982-01-02	38000177		0	0	7		0	0	0	206509	0	313782	1127433		
53939	4482	19059056	1966-12-23	1966-12-23 00:00:00	1967-01-22	1967-01-22 00:00:00	1967-01-22	38000177		0	0	30		0	0	0	298356	0	243670	19059056		
7116	598	19059056	1987-02-14	1987-02-14 00:00:00	1987-02-28	1987-02-28 00:00:00	1987-02-28	38000177		0	0	14		0	0	0	39477	0	243670	19059056		
38435	3177	19059056	1917-03-16	1917-03-16 00:00:00	1917-03-30	1917-03-30 00:00:00	1917-03-30	38000177		0	0	14		0	0	0	211333	0	243670	19059056		
6292	526	920300	2004-05-28	2004-05-28 00:00:00	2004-06-04	2004-06-04 00:00:00	2004-06-04	38000177		0	0	7		0	0	0	35097	0	311989	920300		
98	6	19078461	1976-05-01	1976-05-01 00:00:00	1976-06-30	1976-06-30 00:00:00	1976-06-30	38000177		0	0	60		0	0	0	556	0	310965	19078461		
158	11	1127433	1994-05-20	1994-05-20 00:00:00	1994-06-24	1994-06-24 00:00:00	1994-06-24	38000177		0	0	35		0	0	0	991	0	313782	1127433		
28398	2342	1118084	2018-06-25	2018-06-25 00:00:00	2018-06-25	2018-06-25 00:00:00	\N	38000177		0	0	0		0	0	0	155909	0	00025152531	44923712		
28428	2344	19133873	1968-07-02	1968-07-02 00:00:00	1968-07-13	1968-07-13 00:00:00	1968-07-13	38000177		0	0	11		0	0	0	156074	0	834061	19133873		
28485	2347	1127433	2008-01-31	2008-01-31 00:00:00	2008-02-07	2008-02-07 00:00:00	2008-02-07	38000177		0	0	7		0	0	0	156226	0	313782	1127433		
14725	1232	1127433	1991-10-04	1991-10-04 00:00:00	1991-10-11	1991-10-11 00:00:00	1991-10-11	38000177		0	0	7		0	0	0	81220	0	313782	1127433		
31333	2597	1127433	2008-10-05	2008-10-05 00:00:00	2008-10-12	2008-10-12 00:00:00	2008-10-12	38000177		0	0	7		0	0	0	171848	0	313782	1127433		
53980	4485	19059056	1951-07-09	1951-07-09 00:00:00	1951-07-23	1951-07-23 00:00:00	1951-07-23	38000177		0	0	14		0	0	0	298543	0	243670	19059056		
38085	3149	1127433	2001-01-31	2001-01-31 00:00:00	2001-02-14	2001-02-14 00:00:00	2001-02-14	38000177		0	0	14		0	0	0	209526	0	313782	1127433		
9282	197	40213227	1993-09-12	1993-09-12 00:00:00	1993-09-12	1993-09-12 00:00:00	1993-09-12	581452		0	0	0		0	0	0	13564	0	113	40213227		
59208	4922	1713671	2003-01-12	2003-01-12 00:00:00	2003-02-02	2003-02-02 00:00:00	2003-02-02	38000177		0	0	21		0	0	0	327019	0	562251	1713671		
2478	197	19133905	2015-02-26	2015-02-26 00:00:00	2015-03-07	2015-03-07 00:00:00	2015-03-07	38000177		0	0	9		0	0	0	13548	0	834102	19133905		
32403	2686	1118084	1995-02-28	1995-02-28 00:00:00	1995-02-28	1995-02-28 00:00:00	\N	38000177		0	0	0		0	0	0	177988	0	00025152531	44923712		
34986	2890	1127433	2013-08-12	2013-08-12 00:00:00	2013-08-19	2013-08-19 00:00:00	2013-08-19	38000177		0	0	7		0	0	0	192202	0	313782	1127433		
10214	856	1127078	1971-11-30	1971-11-30 00:00:00	1972-01-06	1972-01-06 00:00:00	1972-01-06	38000177		0	0	37		0	0	0	56517	0	282464	1127078		
45527	3767	19019979	1986-10-08	1986-10-08 00:00:00	1986-10-22	1986-10-22 00:00:00	1986-10-22	38000177		0	0	14		0	0	0	250341	0	198405	19019979		
2896	235	19059056	1984-06-24	1984-06-24 00:00:00	1984-07-29	1984-07-29 00:00:00	1984-07-29	38000177		0	0	35		0	0	0	15756	0	243670	19059056		
21693	471	40213160	1985-10-11	1985-10-11 00:00:00	1985-10-11	1985-10-11 00:00:00	1985-10-11	581452		0	0	0		0	0	0	31482	0	10	40213160		
183099	4022	40213227	2010-11-06	2010-11-06 00:00:00	2010-11-06	2010-11-06 00:00:00	2010-11-06	581452		0	0	0		0	0	0	267421	0	113	40213227		
28737	2372	1127078	1966-07-08	1966-07-08 00:00:00	1966-07-22	1966-07-22 00:00:00	1966-07-22	38000177		0	0	14		0	0	0	157845	0	282464	1127078		
60908	5066	1127078	1971-08-15	1971-08-15 00:00:00	1971-08-29	1971-08-29 00:00:00	1971-08-29	38000177		0	0	14		0	0	0	336788	0	282464	1127078		
14087	1177	1115171	2000-07-04	2000-07-04 00:00:00	2000-07-25	2000-07-25 00:00:00	2000-07-25	38000177		0	0	21		0	0	0	77756	0	849574	1115171		
36597	3020	1127078	1957-06-01	1957-06-01 00:00:00	1957-06-15	1957-06-15 00:00:00	1957-06-15	38000177		0	0	14		0	0	0	201395	0	282464	1127078		
24638	2026	920300	1975-04-05	1975-04-05 00:00:00	1975-04-12	1975-04-12 00:00:00	1975-04-12	38000177		0	0	7		0	0	0	134800	0	311989	920300		
44937	3718	1127078	1974-08-07	1974-08-07 00:00:00	1974-10-06	1974-10-06 00:00:00	1974-10-06	38000177		0	0	60		0	0	0	247144	0	282464	1127078		
23260	1916	1127433	2015-09-12	2015-09-12 00:00:00	2015-09-19	2015-09-19 00:00:00	2015-09-19	38000177		0	0	7		0	0	0	127421	0	313782	1127433		
23311	1921	1127433	1988-07-25	1988-07-25 00:00:00	1988-08-15	1988-08-15 00:00:00	1988-08-15	38000177		0	0	21		0	0	0	127791	0	313782	1127433		
50051	4153	1713671	2005-01-14	2005-01-14 00:00:00	2005-01-28	2005-01-28 00:00:00	2005-01-28	38000177		0	0	14		0	0	0	276018	0	562251	1713671		
26208	2155	1713671	1932-12-30	1932-12-30 00:00:00	1933-01-06	1933-01-06 00:00:00	1933-01-06	38000177		0	0	7		0	0	0	143586	0	562251	1713671		
26767	2204	1127433	2000-06-20	2000-06-20 00:00:00	2000-07-04	2000-07-04 00:00:00	2000-07-04	38000177		0	0	14		0	0	0	146881	0	313782	1127433		
26801	2207	19059056	1982-01-14	1982-01-14 00:00:00	1982-01-28	1982-01-28 00:00:00	1982-01-28	38000177		0	0	14		0	0	0	147081	0	243670	19059056		
60688	5048	1127078	1964-09-06	1964-09-06 00:00:00	1964-09-20	1964-09-20 00:00:00	1964-09-20	38000177		0	0	14		0	0	0	335446	0	282464	1127078		
60724	5049	1713671	1970-09-09	1970-09-09 00:00:00	1970-09-23	1970-09-23 00:00:00	1970-09-23	38000177		0	0	14		0	0	0	335619	0	562251	1713671		
35721	2943	1713671	1938-01-09	1938-01-09 00:00:00	1938-01-16	1938-01-16 00:00:00	1938-01-16	38000177		0	0	7		0	0	0	196336	0	562251	1713671		
52080	4330	19059056	1955-08-16	1955-08-16 00:00:00	1955-09-13	1955-09-13 00:00:00	1955-09-13	38000177		0	0	28		0	0	0	287258	0	243670	19059056		
6866	578	19128022	1991-04-05	1991-04-05 00:00:00	1992-03-30	1992-03-30 00:00:00	1992-03-30	38000177		0	0	360		0	0	0	38245	0	749785	19128022		
6902	580	1127433	2017-04-29	2017-04-29 00:00:00	2017-05-13	2017-05-13 00:00:00	2017-05-13	38000177		0	0	14		0	0	0	38390	0	313782	1127433		
33550	2777	1127433	1985-11-06	1985-11-06 00:00:00	1985-12-13	1985-12-13 00:00:00	1985-12-13	38000177		0	0	37		0	0	0	183933	0	313782	1127433		
61487	5116	1127433	1969-01-03	1969-01-03 00:00:00	1969-01-10	1969-01-10 00:00:00	1969-01-10	38000177		0	0	7		0	0	0	339910	0	313782	1127433		
1186	96	19059056	1942-02-26	1942-02-26 00:00:00	1942-04-27	1942-04-27 00:00:00	1942-04-27	38000177		0	0	60		0	0	0	6504	0	243670	19059056		
56949	4724	19059056	1943-06-09	1943-06-09 00:00:00	1943-06-23	1943-06-23 00:00:00	1943-06-23	38000177		0	0	14		0	0	0	314720	0	243670	19059056		
44191	3658	19129655	1962-07-27	1962-07-27 00:00:00	1962-08-10	1962-08-10 00:00:00	1962-08-10	38000177		0	0	14		0	0	0	243483	0	789980	19129655		
9154	761	1127433	1988-07-26	1988-07-26 00:00:00	1988-08-02	1988-08-02 00:00:00	1988-08-02	38000177		0	0	7		0	0	0	50592	0	313782	1127433		
19405	1600	1115171	2008-03-10	2008-03-10 00:00:00	2008-03-31	2008-03-31 00:00:00	2008-03-31	38000177		0	0	21		0	0	0	107366	0	849574	1115171		
44089	3650	1127433	1968-09-18	1968-09-18 00:00:00	1968-10-02	1968-10-02 00:00:00	1968-10-02	38000177		0	0	14		0	0	0	242942	0	313782	1127433		
37051	3064	40229134	1993-12-29	1993-12-29 00:00:00	1994-01-12	1994-01-12 00:00:00	1994-01-12	38000177		0	0	14		0	0	0	203940	0	1043400	40229134		
38745	3201	19059056	1953-06-19	1953-06-19 00:00:00	1953-07-19	1953-07-19 00:00:00	1953-07-19	38000177		0	0	30		0	0	0	212916	0	243670	19059056		
37146	3070	1127078	1967-12-19	1967-12-19 00:00:00	1968-01-02	1968-01-02 00:00:00	1968-01-02	38000177		0	0	14		0	0	0	204364	0	282464	1127078		
19886	1634	1127433	2017-09-10	2017-09-10 00:00:00	2017-09-24	2017-09-24 00:00:00	2017-09-24	38000177		0	0	14		0	0	0	109692	0	313782	1127433		
12916	1085	1713671	1976-01-28	1976-01-28 00:00:00	1976-02-11	1976-02-11 00:00:00	1976-02-11	38000177		0	0	14		0	0	0	71250	0	562251	1713671		
57715	4795	1115171	2001-02-27	2001-02-27 00:00:00	2001-04-03	2001-04-03 00:00:00	2001-04-03	38000177		0	0	35		0	0	0	319045	0	849574	1115171		
32346	2682	1118084	2016-05-25	2016-05-25 00:00:00	2016-05-25	2016-05-25 00:00:00	\N	38000177		0	0	0		0	0	0	177723	0	00025152531	44923712		
30517	2530	19059056	1972-12-20	1972-12-20 00:00:00	1973-01-19	1973-01-19 00:00:00	1973-01-19	38000177		0	0	30		0	0	0	167222	0	243670	19059056		
17122	1418	19128065	1992-07-29	1992-07-29 00:00:00	1993-03-08	1993-03-08 00:00:00	1993-03-08	38000177		0	0	222		0	0	0	94436	0	749882	19128065		
23951	1971	40229134	1983-10-02	1983-10-02 00:00:00	1983-10-16	1983-10-16 00:00:00	1983-10-16	38000177		0	0	14		0	0	0	131085	0	1043400	40229134		
9790	820	1713671	2002-08-05	2002-08-05 00:00:00	2003-02-03	2003-02-03 00:00:00	2003-02-03	38000177		0	0	182		0	0	0	54353	0	562251	1713671		
20289	1666	40229134	2018-05-04	2018-05-04 00:00:00	2018-05-18	2018-05-18 00:00:00	2018-05-18	38000177		0	0	14		0	0	0	111887	0	1043400	40229134		
40467	3355	19133873	1966-12-02	1966-12-02 00:00:00	1966-12-10	1966-12-10 00:00:00	1966-12-10	38000177		0	0	8		0	0	0	222481	0	834061	19133873		
3309	273	1115171	2001-09-27	2001-09-27 00:00:00	2001-11-26	2001-11-26 00:00:00	2001-11-26	38000177		0	0	60		0	0	0	18287	0	849574	1115171		
37559	3105	46233988	1972-12-30	1972-12-30 00:00:00	1973-01-13	1973-01-13 00:00:00	1973-01-13	38000177		0	0	14		0	0	0	206495	0	1652673	46233988		
53940	4482	1127433	1976-10-01	1976-10-01 00:00:00	1976-10-22	1976-10-22 00:00:00	1976-10-22	38000177		0	0	21		0	0	0	298357	0	313782	1127433		
7117	598	1127433	2014-10-21	2014-10-21 00:00:00	2014-10-28	2014-10-28 00:00:00	2014-10-28	38000177		0	0	7		0	0	0	39480	0	313782	1127433		
38436	3177	1127433	1946-07-10	1946-07-10 00:00:00	1946-07-17	1946-07-17 00:00:00	1946-07-17	38000177		0	0	7		0	0	0	211249	0	313782	1127433		
6293	526	40236824	2004-05-28	2004-05-28 00:00:00	2004-06-04	2004-06-04 00:00:00	2004-06-04	38000177		0	0	7		0	0	0	35097	0	1094107	40236824		
99	6	19129655	1966-10-03	1966-10-03 00:00:00	1966-10-17	1966-10-17 00:00:00	1966-10-17	38000177		0	0	14		0	0	0	583	0	789980	19129655		
159	11	19059056	1960-06-26	1960-06-26 00:00:00	1960-07-10	1960-07-10 00:00:00	1960-07-10	38000177		0	0	14		0	0	0	924	0	243670	19059056		
28399	2342	1127433	1976-09-10	1976-09-10 00:00:00	1976-09-17	1976-09-17 00:00:00	1976-09-17	38000177		0	0	7		0	0	0	155900	0	313782	1127433		
28429	2344	19128065	1988-01-28	1988-01-28 00:00:00	1989-01-22	1989-01-22 00:00:00	1989-01-22	38000177		0	0	360		0	0	0	156020	0	749882	19128065		
28486	2347	1332419	2002-02-25	2002-02-25 00:00:00	2002-02-25	2002-02-25 00:00:00	\N	38000177		0	0	0		0	0	0	156246	0	197361	1332419		
14726	1232	1713671	1980-05-14	1980-05-14 00:00:00	1980-05-21	1980-05-21 00:00:00	1980-05-21	38000177		0	0	7		0	0	0	81202	0	562251	1713671		
31334	2598	1118084	2008-07-18	2008-07-18 00:00:00	2008-07-18	2008-07-18 00:00:00	\N	38000177		0	0	0		0	0	0	171929	0	00025152531	44923712		
53981	4485	19006318	1951-07-09	1951-07-09 00:00:00	1951-07-23	1951-07-23 00:00:00	1951-07-23	38000177		0	0	14		0	0	0	298543	0	105078	19006318		
38086	3149	1713671	1951-10-24	1951-10-24 00:00:00	1951-11-07	1951-11-07 00:00:00	1951-11-07	38000177		0	0	14		0	0	0	209486	0	562251	1713671		
21208	461	40213227	2009-10-27	2009-10-27 00:00:00	2009-10-27	2009-10-27 00:00:00	2009-10-27	581452		0	0	0		0	0	0	30845	0	113	40213227		
59209	4922	920300	2000-09-07	2000-09-07 00:00:00	2000-09-14	2000-09-14 00:00:00	2000-09-14	38000177		0	0	7		0	0	0	327037	0	311989	920300		
2479	197	1127433	1985-09-15	1985-09-15 00:00:00	1985-09-29	1985-09-29 00:00:00	1985-09-29	38000177		0	0	14		0	0	0	13532	0	313782	1127433		
32404	2686	1127433	1969-09-07	1969-09-07 00:00:00	1969-09-14	1969-09-14 00:00:00	1969-09-14	38000177		0	0	7		0	0	0	178005	0	313782	1127433		
34987	2890	19059056	1964-02-26	1964-02-26 00:00:00	1964-03-11	1964-03-11 00:00:00	1964-03-11	38000177		0	0	14		0	0	0	192203	0	243670	19059056		
10215	856	19133873	1981-03-15	1981-03-15 00:00:00	1981-03-26	1981-03-26 00:00:00	1981-03-26	38000177		0	0	11		0	0	0	56525	0	834061	19133873		
45528	3767	40229134	2000-11-29	2000-11-29 00:00:00	2000-12-06	2000-12-06 00:00:00	2000-12-06	38000177		0	0	7		0	0	0	250339	0	1043400	40229134		
2897	235	19133873	1986-04-19	1986-04-19 00:00:00	1986-04-30	1986-04-30 00:00:00	1986-04-30	38000177		0	0	11		0	0	0	15778	0	834061	19133873		
21698	471	40213314	1986-07-11	1986-07-11 00:00:00	1986-07-11	1986-07-11 00:00:00	1986-07-11	581452		0	0	0		0	0	0	31483	0	49	40213314		
183100	4022	40213260	2010-11-06	2010-11-06 00:00:00	2010-11-06	2010-11-06 00:00:00	2010-11-06	581452		0	0	0		0	0	0	267421	0	121	40213260		
28738	2372	1127433	1974-04-14	1974-04-14 00:00:00	1974-05-05	1974-05-05 00:00:00	1974-05-05	38000177		0	0	21		0	0	0	157840	0	313782	1127433		
60909	5066	46233988	1971-08-15	1971-08-15 00:00:00	1971-08-29	1971-08-29 00:00:00	1971-08-29	38000177		0	0	14		0	0	0	336788	0	1652673	46233988		
14088	1177	1118084	2004-01-04	2004-01-04 00:00:00	2004-01-04	2004-01-04 00:00:00	\N	38000177		0	0	0		0	0	0	77741	0	00025152531	44923712		
36598	3020	1127433	1959-02-23	1959-02-23 00:00:00	1959-03-02	1959-03-02 00:00:00	1959-03-02	38000177		0	0	7		0	0	0	201363	0	313782	1127433		
24639	2026	1118084	1995-07-14	1995-07-14 00:00:00	1995-07-14	1995-07-14 00:00:00	\N	38000177		0	0	0		0	0	0	134819	0	00025152531	44923712		
44938	3718	45892894	2017-09-26	2017-09-26 00:00:00	2017-09-26	2017-09-26 00:00:00	\N	38000177		0	0	0		0	0	0	247130	0	1599803	45892894		
23261	1916	1127433	1972-01-04	1972-01-04 00:00:00	1972-01-11	1972-01-11 00:00:00	1972-01-11	38000177		0	0	7		0	0	0	127461	0	313782	1127433		
23312	1921	40236824	1992-10-16	1992-10-16 00:00:00	1992-10-23	1992-10-23 00:00:00	1992-10-23	38000177		0	0	7		0	0	0	127745	0	1094107	40236824		
50052	4153	40229134	2015-03-20	2015-03-20 00:00:00	2015-04-03	2015-04-03 00:00:00	2015-04-03	38000177		0	0	14		0	0	0	276039	0	1043400	40229134		
26209	2155	1127433	1935-05-28	1935-05-28 00:00:00	1935-06-04	1935-06-04 00:00:00	1935-06-04	38000177		0	0	7		0	0	0	143653	0	313782	1127433		
26768	2204	1127078	1957-04-03	1957-04-03 00:00:00	1957-06-10	1957-06-10 00:00:00	1957-06-10	38000177		0	0	68		0	0	0	146926	0	282464	1127078		
26802	2207	19073183	1982-01-14	1982-01-14 00:00:00	1982-01-28	1982-01-28 00:00:00	1982-01-28	38000177		0	0	14		0	0	0	147081	0	308182	19073183		
60689	5048	19078461	2007-12-23	2007-12-23 00:00:00	2008-01-06	2008-01-06 00:00:00	2008-01-06	38000177		0	0	14		0	0	0	335505	0	310965	19078461		
4581	380	1713671	2016-06-28	2016-06-28 00:00:00	2016-07-05	2016-07-05 00:00:00	2016-07-05	38000177		0	0	7		0	0	0	25144	0	562251	1713671		
35722	2943	19059056	1915-07-26	1915-07-26 00:00:00	1915-08-09	1915-08-09 00:00:00	1915-08-09	38000177		0	0	14		0	0	0	196282	0	243670	19059056		
52082	4330	1127433	1968-09-04	1968-09-04 00:00:00	1968-11-03	1968-11-03 00:00:00	1968-11-03	38000177		0	0	60		0	0	0	287260	0	313782	1127433		
6867	578	1713671	2010-11-06	2010-11-06 00:00:00	2010-11-20	2010-11-20 00:00:00	2010-11-20	38000177		0	0	14		0	0	0	38254	0	562251	1713671		
6903	580	1115171	2005-10-14	2005-10-14 00:00:00	2005-11-04	2005-11-04 00:00:00	2005-11-04	38000177		0	0	21		0	0	0	38454	0	849574	1115171		
33551	2777	1127433	1988-12-27	1988-12-27 00:00:00	1989-01-24	1989-01-24 00:00:00	1989-01-24	38000177		0	0	28		0	0	0	183934	0	313782	1127433		
61488	5116	19059056	1969-12-28	1969-12-28 00:00:00	1970-01-11	1970-01-11 00:00:00	1970-01-11	38000177		0	0	14		0	0	0	339886	0	243670	19059056		
1187	96	40231925	1942-02-26	1942-02-26 00:00:00	1942-02-26	1942-02-26 00:00:00	\N	38000177		0	0	0		0	0	0	6504	0	1049221	40231925		
56951	4724	1127433	2003-09-14	2003-09-14 00:00:00	2003-12-13	2003-12-13 00:00:00	2003-12-13	38000177		0	0	90		0	0	0	314690	0	313782	1127433		
44192	3658	40229134	1983-02-08	1983-02-08 00:00:00	1983-02-15	1983-02-15 00:00:00	1983-02-15	38000177		0	0	7		0	0	0	243479	0	1043400	40229134		
222138	4876	40213306	1994-12-31	1994-12-31 00:00:00	1994-12-31	1994-12-31 00:00:00	1994-12-31	581452		0	0	0		0	0	0	324277	0	43	40213306		
19406	1600	40165015	1978-08-26	1978-08-26 00:00:00	1978-08-26	1978-08-26 00:00:00	\N	38000177		0	0	0		0	0	0	107370	0	861467	40165015		
44090	3650	40229134	1992-02-28	1992-02-28 00:00:00	1992-03-13	1992-03-13 00:00:00	1992-03-13	38000177		0	0	14		0	0	0	242944	0	1043400	40229134		
37052	3064	19059056	1947-01-08	1947-01-08 00:00:00	1947-01-29	1947-01-29 00:00:00	1947-01-29	38000177		0	0	21		0	0	0	203995	0	243670	19059056		
38746	3201	40165015	1953-06-19	1953-06-19 00:00:00	1953-06-19	1953-06-19 00:00:00	\N	38000177		0	0	0		0	0	0	212916	0	861467	40165015		
37147	3070	19128065	1985-08-26	1985-08-26 00:00:00	1986-08-21	1986-08-21 00:00:00	1986-08-21	38000177		0	0	360		0	0	0	204322	0	749882	19128065		
19887	1634	19133873	1948-08-05	1948-08-05 00:00:00	1948-08-18	1948-08-18 00:00:00	1948-08-18	38000177		0	0	13		0	0	0	109724	0	834061	19133873		
12917	1085	19129655	1965-10-29	1965-10-29 00:00:00	1965-11-12	1965-11-12 00:00:00	1965-11-12	38000177		0	0	14		0	0	0	71261	0	789980	19129655		
57716	4795	920300	1999-02-07	1999-02-07 00:00:00	1999-02-14	1999-02-14 00:00:00	1999-02-14	38000177		0	0	7		0	0	0	319023	0	311989	920300		
32347	2682	1127433	1974-08-10	1974-08-10 00:00:00	1974-08-24	1974-08-24 00:00:00	1974-08-24	38000177		0	0	14		0	0	0	177708	0	313782	1127433		
30518	2530	1127433	1980-09-09	1980-09-09 00:00:00	1980-12-08	1980-12-08 00:00:00	1980-12-08	38000177		0	0	90		0	0	0	167223	0	313782	1127433		
17123	1418	1127433	2016-01-18	2016-01-18 00:00:00	2016-01-25	2016-01-25 00:00:00	2016-01-25	38000177		0	0	7		0	0	0	94415	0	313782	1127433		
23952	1971	19073188	2015-08-27	2015-08-27 00:00:00	2015-09-10	2015-09-10 00:00:00	2015-09-10	38000177		0	0	14		0	0	0	131107	0	308192	19073188		
51396	1125	40213198	2016-04-29	2016-04-29 00:00:00	2016-04-29	2016-04-29 00:00:00	2016-04-29	581452		0	0	0		0	0	0	74177	0	133	40213198		
20290	1666	19133873	1949-02-18	1949-02-18 00:00:00	1949-03-01	1949-03-01 00:00:00	1949-03-01	38000177		0	0	11		0	0	0	111884	0	834061	19133873		
40468	3355	19133873	1975-07-26	1975-07-26 00:00:00	1975-08-06	1975-08-06 00:00:00	1975-08-06	38000177		0	0	11		0	0	0	222480	0	834061	19133873		
3310	273	1713671	1975-10-21	1975-10-21 00:00:00	1975-11-04	1975-11-04 00:00:00	1975-11-04	38000177		0	0	14		0	0	0	18222	0	562251	1713671		
37560	3105	19059056	1972-12-30	1972-12-30 00:00:00	1973-01-13	1973-01-13 00:00:00	1973-01-13	38000177		0	0	14		0	0	0	206495	0	243670	19059056		
53941	4482	19006318	1952-02-12	1952-02-12 00:00:00	1952-02-26	1952-02-26 00:00:00	1952-02-26	38000177		0	0	14		0	0	0	298380	0	105078	19006318		
7124	600	19006318	1954-03-07	1954-03-07 00:00:00	1954-03-21	1954-03-21 00:00:00	1954-03-21	38000177		0	0	14		0	0	0	39642	0	105078	19006318		
38437	3177	1127433	1964-02-18	1964-02-18 00:00:00	1964-03-19	1964-03-19 00:00:00	1964-03-19	38000177		0	0	30		0	0	0	211230	0	313782	1127433		
6294	526	1713671	2008-10-16	2008-10-16 00:00:00	2008-10-23	2008-10-23 00:00:00	2008-10-23	38000177		0	0	7		0	0	0	35098	0	562251	1713671		
100	6	19059056	1966-10-03	1966-10-03 00:00:00	1966-10-17	1966-10-17 00:00:00	1966-10-17	38000177		0	0	14		0	0	0	583	0	243670	19059056		
160	11	1713671	1974-01-21	1974-01-21 00:00:00	1974-01-28	1974-01-28 00:00:00	1974-01-28	38000177		0	0	7		0	0	0	962	0	562251	1713671		
28400	2342	1127433	1980-06-29	1980-06-29 00:00:00	1980-07-13	1980-07-13 00:00:00	1980-07-13	38000177		0	0	14		0	0	0	155923	0	313782	1127433		
28430	2344	19128065	1984-02-18	1984-02-18 00:00:00	1985-02-12	1985-02-12 00:00:00	1985-02-12	38000177		0	0	360		0	0	0	156078	0	749882	19128065		
28487	2347	19075601	2002-02-25	2002-02-25 00:00:00	2002-02-25	2002-02-25 00:00:00	\N	38000177		0	0	0		0	0	0	156246	0	309362	19075601		
14727	1232	1127433	1969-08-21	1969-08-21 00:00:00	1969-09-04	1969-09-04 00:00:00	1969-09-04	38000177		0	0	14		0	0	0	81179	0	313782	1127433		
31335	2598	1127433	2007-04-25	2007-04-25 00:00:00	2007-05-02	2007-05-02 00:00:00	2007-05-02	38000177		0	0	7		0	0	0	171929	0	313782	1127433		
53982	4485	1127433	2008-10-21	2008-10-21 00:00:00	2008-11-04	2008-11-04 00:00:00	2008-11-04	38000177		0	0	14		0	0	0	298620	0	313782	1127433		
38087	3149	1127433	1965-10-23	1965-10-23 00:00:00	1965-12-29	1965-12-29 00:00:00	1965-12-29	38000177		0	0	67		0	0	0	209566	0	313782	1127433		
21211	461	40213227	1999-08-31	1999-08-31 00:00:00	1999-08-31	1999-08-31 00:00:00	1999-08-31	581452		0	0	0		0	0	0	30786	0	113	40213227		
59210	4922	40236824	2000-09-07	2000-09-07 00:00:00	2000-09-14	2000-09-14 00:00:00	2000-09-14	38000177		0	0	7		0	0	0	327037	0	1094107	40236824		
2480	197	1127078	1969-02-03	1969-02-03 00:00:00	1969-03-03	1969-03-03 00:00:00	1969-03-03	38000177		0	0	28		0	0	0	13528	0	282464	1127078		
32405	2686	1713671	1997-08-09	1997-08-09 00:00:00	1997-08-23	1997-08-23 00:00:00	1997-08-23	38000177		0	0	14		0	0	0	178051	0	562251	1713671		
34988	2890	19006318	1964-02-26	1964-02-26 00:00:00	1964-03-11	1964-03-11 00:00:00	1964-03-11	38000177		0	0	14		0	0	0	192203	0	105078	19006318		
10216	856	19073188	1989-01-03	1989-01-03 00:00:00	1989-01-17	1989-01-17 00:00:00	1989-01-17	38000177		0	0	14		0	0	0	56568	0	308192	19073188		
45529	3767	1127078	1989-07-19	1989-07-19 00:00:00	1989-08-02	1989-08-02 00:00:00	1989-08-02	38000177		0	0	14		0	0	0	250383	0	282464	1127078		
2898	235	1713671	1998-04-23	1998-04-23 00:00:00	1998-05-14	1998-05-14 00:00:00	1998-05-14	38000177		0	0	21		0	0	0	15745	0	562251	1713671		
21699	471	40213251	1986-07-11	1986-07-11 00:00:00	1986-07-11	1986-07-11 00:00:00	1986-07-11	581452		0	0	0		0	0	0	31483	0	21	40213251		
183105	4022	40213296	2002-10-12	2002-10-12 00:00:00	2002-10-12	2002-10-12 00:00:00	2002-10-12	581452		0	0	0		0	0	0	267435	0	52	40213296		
28739	2372	1713671	2017-02-17	2017-02-17 00:00:00	2017-02-24	2017-02-24 00:00:00	2017-02-24	38000177		0	0	7		0	0	0	157828	0	562251	1713671		
60911	5066	1127433	2011-06-18	2011-06-18 00:00:00	2011-07-02	2011-07-02 00:00:00	2011-07-02	38000177		0	0	14		0	0	0	336763	0	313782	1127433		
14089	1177	1127433	1998-06-24	1998-06-24 00:00:00	1998-07-08	1998-07-08 00:00:00	1998-07-08	38000177		0	0	14		0	0	0	77799	0	313782	1127433		
36599	3020	40169281	2003-01-22	2003-01-22 00:00:00	2003-01-22	2003-01-22 00:00:00	\N	38000177		0	0	0		0	0	0	201430	0	896209	40169281		
24641	2026	920334	1974-02-25	1974-02-25 00:00:00	1974-03-04	1974-03-04 00:00:00	1974-03-04	38000177		0	0	7		0	0	0	134855	0	311995	920334		
44939	3718	1124300	2002-03-10	2002-03-10 00:00:00	2002-03-10	2002-03-10 00:00:00	\N	38000177		0	0	0		0	0	0	247124	0	00781178901	45011828		
23262	1916	1127078	1977-06-04	1977-06-04 00:00:00	1977-06-18	1977-06-18 00:00:00	1977-06-18	38000177		0	0	14		0	0	0	127467	0	282464	1127078		
23313	1921	920300	1992-10-16	1992-10-16 00:00:00	1992-10-23	1992-10-23 00:00:00	1992-10-23	38000177		0	0	7		0	0	0	127745	0	311989	920300		
50053	4153	19078461	1999-11-01	1999-11-01 00:00:00	1999-12-08	1999-12-08 00:00:00	1999-12-08	38000177		0	0	37		0	0	0	276007	0	310965	19078461		
26210	2155	1713671	1928-07-10	1928-07-10 00:00:00	1928-07-17	1928-07-17 00:00:00	1928-07-17	38000177		0	0	7		0	0	0	143638	0	562251	1713671		
36708	3030	1127433	1995-12-31	1995-12-31 00:00:00	1996-01-14	1996-01-14 00:00:00	1996-01-14	38000177		0	0	14		0	0	0	202023	0	313782	1127433		
26803	2207	1713671	1992-02-14	1992-02-14 00:00:00	1992-03-06	1992-03-06 00:00:00	1992-03-06	38000177		0	0	21		0	0	0	147080	0	562251	1713671		
60690	5048	19133873	1970-06-27	1970-06-27 00:00:00	1970-07-08	1970-07-08 00:00:00	1970-07-08	38000177		0	0	11		0	0	0	335403	0	834061	19133873		
4582	380	40165015	1986-08-25	1986-08-25 00:00:00	1986-08-25	1986-08-25 00:00:00	\N	38000177		0	0	0		0	0	0	25137	0	861467	40165015		
35723	2943	1127433	1994-05-30	1994-05-30 00:00:00	1994-06-06	1994-06-06 00:00:00	1994-06-06	38000177		0	0	7		0	0	0	196323	0	313782	1127433		
52083	4330	40162522	1963-09-01	1963-09-01 00:00:00	1963-09-01	1963-09-01 00:00:00	\N	38000177		0	0	0		0	0	0	287259	0	857005	40162522		
6868	578	1118084	2001-12-08	2001-12-08 00:00:00	2001-12-08	2001-12-08 00:00:00	\N	38000177		0	0	0		0	0	0	38209	0	00025152531	44923712		
6904	580	1127433	1991-08-25	1991-08-25 00:00:00	1991-09-08	1991-09-08 00:00:00	1991-09-08	38000177		0	0	14		0	0	0	38389	0	313782	1127433		
33552	2777	1127433	1968-05-21	1968-05-21 00:00:00	1968-05-28	1968-05-28 00:00:00	1968-05-28	38000177		0	0	7		0	0	0	183964	0	313782	1127433		
239506	5257	40213160	1983-02-23	1983-02-23 00:00:00	1983-02-23	1983-02-23 00:00:00	1983-02-23	581452		0	0	0		0	0	0	349803	0	10	40213160		
1188	96	1713671	1971-09-23	1971-09-23 00:00:00	1971-10-07	1971-10-07 00:00:00	1971-10-07	38000177		0	0	14		0	0	0	6531	0	562251	1713671		
56953	4724	40229134	1993-05-14	1993-05-14 00:00:00	1993-05-21	1993-05-21 00:00:00	1993-05-21	38000177		0	0	7		0	0	0	314756	0	1043400	40229134		
44193	3658	19078461	1980-05-14	1980-05-14 00:00:00	1980-05-28	1980-05-28 00:00:00	1980-05-28	38000177		0	0	14		0	0	0	243507	0	310965	19078461		
233419	5128	40213201	1992-11-11	1992-11-11 00:00:00	1992-11-11	1992-11-11 00:00:00	1992-11-11	581452		0	0	0		0	0	0	341022	0	33	40213201		
19407	1600	1127433	1978-08-26	1978-08-26 00:00:00	1978-10-25	1978-10-25 00:00:00	1978-10-25	38000177		0	0	60		0	0	0	107370	0	313782	1127433		
44091	3650	40220960	2014-07-04	2014-07-04 00:00:00	2014-07-04	2014-07-04 00:00:00	2014-07-04	38000177		0	0	0		0	0	0	242920	0	1804799	40220960		
37053	3064	19059056	1949-02-17	1949-02-17 00:00:00	1949-03-03	1949-03-03 00:00:00	1949-03-03	38000177		0	0	14		0	0	0	203996	0	243670	19059056		
38747	3201	1118084	1976-07-25	1976-07-25 00:00:00	1976-07-25	1976-07-25 00:00:00	\N	38000177		0	0	0		0	0	0	212913	0	00025152531	44923712		
37150	3070	1118084	1999-12-31	1999-12-31 00:00:00	1999-12-31	1999-12-31 00:00:00	\N	38000177		0	0	0		0	0	0	204342	0	00025152531	44923712		
19888	1634	1713671	2002-03-07	2002-03-07 00:00:00	2002-03-28	2002-03-28 00:00:00	2002-03-28	38000177		0	0	21		0	0	0	109796	0	562251	1713671		
12918	1085	19059056	1965-10-29	1965-10-29 00:00:00	1965-11-12	1965-11-12 00:00:00	1965-11-12	38000177		0	0	14		0	0	0	71261	0	243670	19059056		
57717	4795	40236824	1999-02-07	1999-02-07 00:00:00	1999-02-14	1999-02-14 00:00:00	1999-02-14	38000177		0	0	7		0	0	0	319023	0	1094107	40236824		
32348	2682	1127433	2017-12-04	2017-12-04 00:00:00	2017-12-11	2017-12-11 00:00:00	2017-12-11	38000177		0	0	7		0	0	0	177754	0	313782	1127433		
30519	2530	40162522	1980-09-09	1980-09-09 00:00:00	1980-09-09	1980-09-09 00:00:00	\N	38000177		0	0	0		0	0	0	167223	0	857005	40162522		
17124	1418	19133873	1978-01-02	1978-01-02 00:00:00	1978-01-15	1978-01-15 00:00:00	1978-01-15	38000177		0	0	13		0	0	0	94422	0	834061	19133873		
23953	1971	19078461	2015-08-27	2015-08-27 00:00:00	2015-09-10	2015-09-10 00:00:00	2015-09-10	38000177		0	0	14		0	0	0	131107	0	310965	19078461		
51401	1125	40213201	2017-05-05	2017-05-05 00:00:00	2017-05-05	2017-05-05 00:00:00	2017-05-05	581452		0	0	0		0	0	0	74133	0	33	40213201		
20291	1666	19059056	1953-01-20	1953-01-20 00:00:00	1953-02-03	1953-02-03 00:00:00	1953-02-03	38000177		0	0	14		0	0	0	111877	0	243670	19059056		
40469	3355	1127433	1995-06-14	1995-06-14 00:00:00	1995-07-05	1995-07-05 00:00:00	1995-07-05	38000177		0	0	21		0	0	0	222508	0	313782	1127433		
3311	273	19133873	1976-02-14	1976-02-14 00:00:00	1976-02-27	1976-02-27 00:00:00	1976-02-27	38000177		0	0	13		0	0	0	18223	0	834061	19133873		
37561	3105	40229134	1990-06-04	1990-06-04 00:00:00	1990-06-18	1990-06-18 00:00:00	1990-06-18	38000177		0	0	14		0	0	0	206507	0	1043400	40229134		
53942	4482	19059056	1952-02-12	1952-02-12 00:00:00	1952-02-26	1952-02-26 00:00:00	1952-02-26	38000177		0	0	14		0	0	0	298380	0	243670	19059056		
7125	600	19059056	1954-03-07	1954-03-07 00:00:00	1954-03-21	1954-03-21 00:00:00	1954-03-21	38000177		0	0	14		0	0	0	39642	0	243670	19059056		
38438	3177	19059056	1918-03-24	1918-03-24 00:00:00	1918-04-07	1918-04-07 00:00:00	1918-04-07	38000177		0	0	14		0	0	0	211334	0	243670	19059056		
6295	526	1127433	2018-04-14	2018-04-14 00:00:00	2018-04-21	2018-04-21 00:00:00	2018-04-21	38000177		0	0	7		0	0	0	35099	0	313782	1127433		
101	6	19129655	1969-12-20	1969-12-20 00:00:00	1970-01-03	1970-01-03 00:00:00	1970-01-03	38000177		0	0	14		0	0	0	573	0	789980	19129655		
161	11	1127433	1987-10-03	1987-10-03 00:00:00	1987-11-02	1987-11-02 00:00:00	1987-11-02	38000177		0	0	30		0	0	0	989	0	313782	1127433		
37881	3132	19129655	1965-11-23	1965-11-23 00:00:00	1965-12-07	1965-12-07 00:00:00	1965-12-07	38000177		0	0	14		0	0	0	208393	0	789980	19129655		
28431	2344	1713671	1990-02-06	1990-02-06 00:00:00	1990-02-20	1990-02-20 00:00:00	1990-02-20	38000177		0	0	14		0	0	0	156075	0	562251	1713671		
28488	2347	1539411	2002-02-25	2002-02-25 00:00:00	2002-02-25	2002-02-25 00:00:00	\N	38000177		0	0	0		0	0	0	156246	0	312961	1539411		
14728	1232	1713671	2014-01-15	2014-01-15 00:00:00	2014-04-09	2014-04-09 00:00:00	2014-04-09	38000177		0	0	84		0	0	0	81223	0	562251	1713671		
31336	2598	1713671	1995-12-22	1995-12-22 00:00:00	1995-12-29	1995-12-29 00:00:00	1995-12-29	38000177		0	0	7		0	0	0	171928	0	562251	1713671		
53983	4485	1127433	1963-02-08	1963-02-08 00:00:00	1963-02-22	1963-02-22 00:00:00	1963-02-22	38000177		0	0	14		0	0	0	298541	0	313782	1127433		
38088	3149	1713671	1993-02-27	1993-02-27 00:00:00	1993-03-06	1993-03-06 00:00:00	1993-03-06	38000177		0	0	7		0	0	0	209525	0	562251	1713671		
21222	461	40213227	1993-02-16	1993-02-16 00:00:00	1993-02-16	1993-02-16 00:00:00	1993-02-16	581452		0	0	0		0	0	0	\N	0	113	40213227		
41957	3477	1127433	2010-08-18	2010-08-18 00:00:00	2010-09-01	2010-09-01 00:00:00	2010-09-01	38000177		0	0	14		0	0	0	230610	0	313782	1127433		
2481	197	1127433	1982-07-12	1982-07-12 00:00:00	1982-08-02	1982-08-02 00:00:00	1982-08-02	38000177		0	0	21		0	0	0	13531	0	313782	1127433		
32406	2686	19059056	1972-10-20	1972-10-20 00:00:00	1972-11-10	1972-11-10 00:00:00	1972-11-10	38000177		0	0	21		0	0	0	178071	0	243670	19059056		
34991	2891	1127433	2000-09-21	2000-09-21 00:00:00	2000-10-05	2000-10-05 00:00:00	2000-10-05	38000177		0	0	14		0	0	0	192326	0	313782	1127433		
10217	856	19078461	1989-01-03	1989-01-03 00:00:00	1989-01-17	1989-01-17 00:00:00	1989-01-17	38000177		0	0	14		0	0	0	56568	0	310965	19078461		
45530	3767	19075001	1989-07-19	1989-07-19 00:00:00	1989-08-02	1989-08-02 00:00:00	1989-08-02	38000177		0	0	14		0	0	0	250383	0	309097	19075001		
2899	235	19133873	1991-10-15	1991-10-15 00:00:00	1991-10-27	1991-10-27 00:00:00	1991-10-27	38000177		0	0	12		0	0	0	15771	0	834061	19133873		
21707	471	40213180	2007-12-21	2007-12-21 00:00:00	2007-12-21	2007-12-21 00:00:00	2007-12-21	581452		0	0	0		0	0	0	31476	0	114	40213180		
138009	3030	40213314	1982-01-26	1982-01-26 00:00:00	1982-01-26	1982-01-26 00:00:00	1982-01-26	581452		0	0	0		0	0	0	202006	0	49	40213314		
28740	2372	1115171	2007-07-11	2007-07-11 00:00:00	2007-07-25	2007-07-25 00:00:00	2007-07-25	38000177		0	0	14		0	0	0	157841	0	849574	1115171		
60912	5066	19128065	1981-04-04	1981-04-04 00:00:00	1982-03-30	1982-03-30 00:00:00	1982-03-30	38000177		0	0	360		0	0	0	336775	0	749882	19128065		
14090	1177	1127433	2016-01-03	2016-01-03 00:00:00	2016-01-24	2016-01-24 00:00:00	2016-01-24	38000177		0	0	21		0	0	0	77757	0	313782	1127433		
36600	3020	1118084	1996-04-12	1996-04-12 00:00:00	1996-04-12	1996-04-12 00:00:00	\N	38000177		0	0	0		0	0	0	201429	0	00025152531	44923712		
24642	2027	1118084	2002-03-27	2002-03-27 00:00:00	2002-03-27	2002-03-27 00:00:00	\N	38000177		0	0	0		0	0	0	134871	0	00025152531	44923712		
44940	3718	1127433	1973-10-15	1973-10-15 00:00:00	1973-10-22	1973-10-22 00:00:00	1973-10-22	38000177		0	0	7		0	0	0	247106	0	313782	1127433		
23263	1916	46233988	1977-06-04	1977-06-04 00:00:00	1977-06-18	1977-06-18 00:00:00	1977-06-18	38000177		0	0	14		0	0	0	127467	0	1652673	46233988		
23314	1921	19078461	2015-01-26	2015-01-26 00:00:00	2015-02-23	2015-02-23 00:00:00	2015-02-23	38000177		0	0	28		0	0	0	127792	0	310965	19078461		
50054	4153	1127433	1975-09-19	1975-09-19 00:00:00	1975-09-26	1975-09-26 00:00:00	1975-09-26	38000177		0	0	7		0	0	0	276060	0	313782	1127433		
26211	2155	40173590	2007-04-25	2007-04-25 00:00:00	2007-04-25	2007-04-25 00:00:00	\N	38000177		0	0	0		0	0	0	143622	0	904419	40173590		
36709	3030	40229134	1984-09-03	1984-09-03 00:00:00	1984-09-17	1984-09-17 00:00:00	1984-09-17	38000177		0	0	14		0	0	0	202011	0	1043400	40229134		
26804	2207	1115171	2011-10-23	2011-10-23 00:00:00	2011-11-20	2011-11-20 00:00:00	2011-11-20	38000177		0	0	28		0	0	0	147099	0	849574	1115171		
60691	5048	40232448	1962-11-13	1962-11-13 00:00:00	1962-11-13	1962-11-13 00:00:00	\N	38000177		0	0	0		0	0	0	335460	0	1049630	40232448		
4583	380	1127433	1986-08-25	1986-08-25 00:00:00	1986-10-24	1986-10-24 00:00:00	1986-10-24	38000177		0	0	60		0	0	0	25137	0	313782	1127433		
35724	2943	1127433	1970-05-02	1970-05-02 00:00:00	1970-05-30	1970-05-30 00:00:00	1970-05-30	38000177		0	0	28		0	0	0	196249	0	313782	1127433		
52084	4330	19059056	1963-09-01	1963-09-01 00:00:00	1963-11-30	1963-11-30 00:00:00	1963-11-30	38000177		0	0	90		0	0	0	287259	0	243670	19059056		
6869	578	1127433	1996-10-06	1996-10-06 00:00:00	1996-10-20	1996-10-20 00:00:00	1996-10-20	38000177		0	0	14		0	0	0	38268	0	313782	1127433		
6905	580	19059056	1928-01-01	1928-01-01 00:00:00	1928-01-15	1928-01-15 00:00:00	1928-01-15	38000177		0	0	14		0	0	0	38470	0	243670	19059056		
33553	2777	40165015	1985-11-13	1985-11-13 00:00:00	1985-11-13	1985-11-13 00:00:00	\N	38000177		0	0	0		0	0	0	183940	0	861467	40165015		
239515	5257	40213227	2009-09-09	2009-09-09 00:00:00	2009-09-09	2009-09-09 00:00:00	2009-09-09	581452		0	0	0		0	0	0	349783	0	113	40213227		
1189	96	1713671	1970-04-05	1970-04-05 00:00:00	1970-04-26	1970-04-26 00:00:00	1970-04-26	38000177		0	0	21		0	0	0	6545	0	562251	1713671		
56954	4724	19008572	1953-10-09	1953-10-09 00:00:00	1953-10-23	1953-10-23 00:00:00	1953-10-23	38000177		0	0	14		0	0	0	314741	0	106258	19008572		
44194	3658	1127433	1998-01-10	1998-01-10 00:00:00	1998-01-24	1998-01-24 00:00:00	1998-01-24	38000177		0	0	14		0	0	0	243440	0	313782	1127433		
19345	1597	40229134	1993-01-15	1993-01-15 00:00:00	1993-01-29	1993-01-29 00:00:00	1993-01-29	38000177		0	0	14		0	0	0	107131	0	1043400	40229134		
19408	1600	19078461	2005-04-20	2005-04-20 00:00:00	2005-05-25	2005-05-25 00:00:00	2005-05-25	38000177		0	0	35		0	0	0	107365	0	310965	19078461		
44092	3650	19075601	2014-07-04	2014-07-04 00:00:00	2014-07-04	2014-07-04 00:00:00	2014-07-04	38000177		0	0	0		0	0	0	242920	0	309362	19075601		
37054	3064	19059056	1962-05-24	1962-05-24 00:00:00	1962-06-07	1962-06-07 00:00:00	1962-06-07	38000177		0	0	14		0	0	0	203997	0	243670	19059056		
38748	3201	1713671	1980-07-18	1980-07-18 00:00:00	1980-07-25	1980-07-25 00:00:00	1980-07-25	38000177		0	0	7		0	0	0	212898	0	562251	1713671		
37151	3070	19128065	1984-08-31	1984-08-31 00:00:00	1985-08-26	1985-08-26 00:00:00	1985-08-26	38000177		0	0	360		0	0	0	204371	0	749882	19128065		
21715	1782	40229134	1955-08-13	1955-08-13 00:00:00	1955-08-27	1955-08-27 00:00:00	1955-08-27	38000177		0	0	14		0	0	0	119359	0	1043400	40229134		
12919	1085	1127433	1965-12-30	1965-12-30 00:00:00	1966-01-13	1966-01-13 00:00:00	1966-01-13	38000177		0	0	14		0	0	0	71255	0	313782	1127433		
57718	4795	19078461	2003-03-24	2003-03-24 00:00:00	2003-04-14	2003-04-14 00:00:00	2003-04-14	38000177		0	0	21		0	0	0	319046	0	310965	19078461		
32349	2682	1127078	1978-05-20	1978-05-20 00:00:00	1978-06-24	1978-06-24 00:00:00	1978-06-24	38000177		0	0	35		0	0	0	177724	0	282464	1127078		
30520	2530	1713671	1995-04-05	1995-04-05 00:00:00	1995-04-26	1995-04-26 00:00:00	1995-04-26	38000177		0	0	21		0	0	0	167253	0	562251	1713671		
17125	1418	1118084	2014-08-08	2014-08-08 00:00:00	2014-08-08	2014-08-08 00:00:00	\N	38000177		0	0	0		0	0	0	94414	0	00025152531	44923712		
23960	1973	1127078	1974-06-21	1974-06-21 00:00:00	1974-07-05	1974-07-05 00:00:00	1974-07-05	38000177		0	0	14		0	0	0	131199	0	282464	1127078		
51404	1125	40213227	2001-09-28	2001-09-28 00:00:00	2001-09-28	2001-09-28 00:00:00	2001-09-28	581452		0	0	0		0	0	0	74159	0	113	40213227		
20292	1666	1127433	1991-09-03	1991-09-03 00:00:00	1991-09-24	1991-09-24 00:00:00	1991-09-24	38000177		0	0	21		0	0	0	111880	0	313782	1127433		
40470	3355	19078461	2017-05-10	2017-05-10 00:00:00	2017-07-09	2017-07-09 00:00:00	2017-07-09	38000177		0	0	60		0	0	0	222509	0	310965	19078461		
3312	273	1127078	1981-05-15	1981-05-15 00:00:00	1981-05-29	1981-05-29 00:00:00	1981-05-29	38000177		0	0	14		0	0	0	18297	0	282464	1127078		
37562	3105	46233988	1975-04-23	1975-04-23 00:00:00	1975-05-07	1975-05-07 00:00:00	1975-05-07	38000177		0	0	14		0	0	0	206531	0	1652673	46233988		
53943	4482	1713671	1991-02-22	1991-02-22 00:00:00	1991-03-15	1991-03-15 00:00:00	1991-03-15	38000177		0	0	21		0	0	0	298386	0	562251	1713671		
7126	600	1127433	1973-06-25	1973-06-25 00:00:00	1973-07-09	1973-07-09 00:00:00	1973-07-09	38000177		0	0	14		0	0	0	39646	0	313782	1127433		
38439	3177	19059056	1934-10-27	1934-10-27 00:00:00	1934-11-17	1934-11-17 00:00:00	1934-11-17	38000177		0	0	21		0	0	0	211227	0	243670	19059056		
6296	526	19059056	1977-01-23	1977-01-23 00:00:00	1977-02-06	1977-02-06 00:00:00	1977-02-06	38000177		0	0	14		0	0	0	35100	0	243670	19059056		
102	6	1127078	1969-12-20	1969-12-20 00:00:00	1970-01-03	1970-01-03 00:00:00	1970-01-03	38000177		0	0	14		0	0	0	573	0	282464	1127078		
162	11	1115171	1996-04-14	1996-04-14 00:00:00	1996-05-12	1996-05-12 00:00:00	1996-05-12	38000177		0	0	28		0	0	0	992	0	849574	1115171		
37882	3132	1127433	1967-07-18	1967-07-18 00:00:00	1967-08-01	1967-08-01 00:00:00	1967-08-01	38000177		0	0	14		0	0	0	208404	0	313782	1127433		
28432	2344	19059056	1983-09-02	1983-09-02 00:00:00	1983-09-16	1983-09-16 00:00:00	1983-09-16	38000177		0	0	14		0	0	0	156035	0	243670	19059056		
28489	2347	19126352	2002-02-25	2002-02-25 00:00:00	2002-02-25	2002-02-25 00:00:00	\N	38000177		0	0	0		0	0	0	156246	0	705129	19126352		
14729	1232	19059056	1966-03-09	1966-03-09 00:00:00	1966-03-23	1966-03-23 00:00:00	1966-03-23	38000177		0	0	14		0	0	0	81181	0	243670	19059056		
31337	2598	1713671	1985-04-17	1985-04-17 00:00:00	1985-05-08	1985-05-08 00:00:00	1985-05-08	38000177		0	0	21		0	0	0	171887	0	562251	1713671		
53992	4487	1127433	1960-05-10	1960-05-10 00:00:00	1960-05-17	1960-05-17 00:00:00	1960-05-17	38000177		0	0	7		0	0	0	298698	0	313782	1127433		
38089	3149	1127433	2012-11-22	2012-11-22 00:00:00	2012-12-22	2012-12-22 00:00:00	2012-12-22	38000177		0	0	30		0	0	0	209567	0	313782	1127433		
21224	461	40213160	1955-05-03	1955-05-03 00:00:00	1955-05-03	1955-05-03 00:00:00	1955-05-03	581452		0	0	0		0	0	0	\N	0	10	40213160		
41958	3477	1118084	1997-01-08	1997-01-08 00:00:00	1997-01-08	1997-01-08 00:00:00	\N	38000177		0	0	0		0	0	0	230736	0	00025152531	44923712		
12949	1088	19059056	1973-10-23	1973-10-23 00:00:00	1973-11-06	1973-11-06 00:00:00	1973-11-06	38000177		0	0	14		0	0	0	71416	0	243670	19059056		
32407	2686	1127433	1996-10-24	1996-10-24 00:00:00	1996-11-07	1996-11-07 00:00:00	1996-11-07	38000177		0	0	14		0	0	0	178028	0	313782	1127433		
34992	2891	19128065	1987-11-19	1987-11-19 00:00:00	1988-11-13	1988-11-13 00:00:00	1988-11-13	38000177		0	0	360		0	0	0	192383	0	749882	19128065		
10218	856	1124300	2006-02-24	2006-02-24 00:00:00	2006-02-24	2006-02-24 00:00:00	\N	38000177		0	0	0		0	0	0	56539	0	00781178901	45011828		
45531	3767	19133873	1986-05-13	1986-05-13 00:00:00	1986-05-23	1986-05-23 00:00:00	1986-05-23	38000177		0	0	10		0	0	0	250349	0	834061	19133873		
2900	235	1118084	2016-05-17	2016-05-17 00:00:00	2016-05-17	2016-05-17 00:00:00	\N	38000177		0	0	0		0	0	0	15766	0	00025152531	44923712		
21708	471	40213306	2007-12-21	2007-12-21 00:00:00	2007-12-21	2007-12-21 00:00:00	2007-12-21	581452		0	0	0		0	0	0	31476	0	43	40213306		
149304	3285	40213227	2010-04-03	2010-04-03 00:00:00	2010-04-03	2010-04-03 00:00:00	2010-04-03	581452		0	0	0		0	0	0	218241	0	113	40213227		
28741	2372	19059056	1965-04-01	1965-04-01 00:00:00	1965-04-15	1965-04-15 00:00:00	1965-04-15	38000177		0	0	14		0	0	0	157844	0	243670	19059056		
60913	5066	1127433	1982-08-15	1982-08-15 00:00:00	1982-09-05	1982-09-05 00:00:00	1982-09-05	38000177		0	0	21		0	0	0	336804	0	313782	1127433		
14091	1177	1713671	1989-09-02	1989-09-02 00:00:00	1989-09-16	1989-09-16 00:00:00	1989-09-16	38000177		0	0	14		0	0	0	77762	0	562251	1713671		
36601	3020	1332419	1994-12-28	1994-12-28 00:00:00	1994-12-28	1994-12-28 00:00:00	\N	38000177		0	0	0		0	0	0	201429	0	197361	1332419		
24643	2027	19059056	1968-02-09	1968-02-09 00:00:00	1968-03-15	1968-03-15 00:00:00	1968-03-15	38000177		0	0	35		0	0	0	134932	0	243670	19059056		
44941	3719	19078461	1999-06-03	1999-06-03 00:00:00	1999-07-01	1999-07-01 00:00:00	1999-07-01	38000177		0	0	28		0	0	0	247168	0	310965	19078461		
23264	1917	19059056	1983-01-06	1983-01-06 00:00:00	1983-02-10	1983-02-10 00:00:00	1983-02-10	38000177		0	0	35		0	0	0	127554	0	243670	19059056		
23315	1921	19059056	1957-02-05	1957-02-05 00:00:00	1957-02-19	1957-02-19 00:00:00	1957-02-19	38000177		0	0	14		0	0	0	127723	0	243670	19059056		
50055	4153	40231925	1999-11-08	1999-11-08 00:00:00	1999-11-08	1999-11-08 00:00:00	\N	38000177		0	0	0		0	0	0	276038	0	1049221	40231925		
26212	2155	40229134	1985-10-10	1985-10-10 00:00:00	1985-10-17	1985-10-17 00:00:00	1985-10-17	38000177		0	0	7		0	0	0	143576	0	1043400	40229134		
36710	3030	42902245	1998-07-30	1998-07-30 00:00:00	1999-07-25	1999-07-25 00:00:00	1999-07-25	38000177		0	0	360		0	0	0	202003	0	1359133	42902245		
26805	2207	40229134	2010-02-08	2010-02-08 00:00:00	2010-02-15	2010-02-15 00:00:00	2010-02-15	38000177		0	0	7		0	0	0	147057	0	1043400	40229134		
60693	5048	1115171	2016-05-23	2016-05-23 00:00:00	2016-08-21	2016-08-21 00:00:00	2016-08-21	38000177		0	0	90		0	0	0	335506	0	849574	1115171		
4584	380	1713671	1985-08-06	1985-08-06 00:00:00	1985-08-20	1985-08-20 00:00:00	1985-08-20	38000177		0	0	14		0	0	0	25128	0	562251	1713671		
35725	2943	1127433	1971-01-28	1971-01-28 00:00:00	1971-02-04	1971-02-04 00:00:00	1971-02-04	38000177		0	0	7		0	0	0	196320	0	313782	1127433		
52085	4330	1127433	1988-12-02	1988-12-02 00:00:00	1989-01-06	1989-01-06 00:00:00	1989-01-06	38000177		0	0	35		0	0	0	287262	0	313782	1127433		
6870	578	1127433	2005-10-27	2005-10-27 00:00:00	2005-11-10	2005-11-10 00:00:00	2005-11-10	38000177		0	0	14		0	0	0	38260	0	313782	1127433		
6906	580	1127433	2011-08-05	2011-08-05 00:00:00	2011-08-19	2011-08-19 00:00:00	2011-08-19	38000177		0	0	14		0	0	0	38455	0	313782	1127433		
33554	2777	1713671	2014-12-10	2014-12-10 00:00:00	2014-12-31	2014-12-31 00:00:00	2014-12-31	38000177		0	0	21		0	0	0	183953	0	562251	1713671		
239518	5257	40213306	2000-08-30	2000-08-30 00:00:00	2000-08-30	2000-08-30 00:00:00	2000-08-30	581452		0	0	0		0	0	0	349812	0	43	40213306		
1190	96	1127433	1940-05-16	1940-05-16 00:00:00	1940-05-30	1940-05-30 00:00:00	1940-05-30	38000177		0	0	14		0	0	0	6510	0	313782	1127433		
56955	4724	1127078	1952-12-05	1952-12-05 00:00:00	1953-01-09	1953-01-09 00:00:00	1953-01-09	38000177		0	0	35		0	0	0	314685	0	282464	1127078		
44195	3658	19059056	1972-09-02	1972-09-02 00:00:00	1972-10-02	1972-10-02 00:00:00	1972-10-02	38000177		0	0	30		0	0	0	243505	0	243670	19059056		
19348	1597	19059056	1949-05-04	1949-05-04 00:00:00	1949-05-18	1949-05-18 00:00:00	1949-05-18	38000177		0	0	14		0	0	0	107115	0	243670	19059056		
19410	1600	19059056	1945-12-26	1945-12-26 00:00:00	1946-01-09	1946-01-09 00:00:00	1946-01-09	38000177		0	0	14		0	0	0	107427	0	243670	19059056		
44093	3650	1127433	1935-04-03	1935-04-03 00:00:00	1935-04-17	1935-04-17 00:00:00	1935-04-17	38000177		0	0	14		0	0	0	242940	0	313782	1127433		
37055	3064	19059056	1941-04-25	1941-04-25 00:00:00	1941-05-09	1941-05-09 00:00:00	1941-05-09	38000177		0	0	14		0	0	0	203964	0	243670	19059056		
21839	474	40213160	1970-05-24	1970-05-24 00:00:00	1970-05-24	1970-05-24 00:00:00	1970-05-24	581452		0	0	0		0	0	0	31630	0	10	40213160		
37152	3070	1713671	1973-01-18	1973-01-18 00:00:00	1973-01-25	1973-01-25 00:00:00	1973-01-25	38000177		0	0	7		0	0	0	204319	0	562251	1713671		
21716	1782	1127433	2018-12-02	2018-12-02 00:00:00	2018-12-16	2018-12-16 00:00:00	2018-12-16	38000177		0	0	14		0	0	0	119374	0	313782	1127433		
12920	1085	19133873	1971-06-03	1971-06-03 00:00:00	1971-06-10	1971-06-10 00:00:00	1971-06-10	38000177		0	0	7		0	0	0	71242	0	834061	19133873		
57720	4795	920300	1995-12-09	1995-12-09 00:00:00	1995-12-16	1995-12-16 00:00:00	1995-12-16	38000177		0	0	7		0	0	0	318994	0	311989	920300		
32350	2682	1127433	1977-03-06	1977-03-06 00:00:00	1977-03-13	1977-03-13 00:00:00	1977-03-13	38000177		0	0	7		0	0	0	177737	0	313782	1127433		
30521	2530	40229134	2017-04-21	2017-04-21 00:00:00	2017-04-28	2017-04-28 00:00:00	2017-04-28	38000177		0	0	7		0	0	0	167254	0	1043400	40229134		
17126	1418	1713671	1979-05-31	1979-05-31 00:00:00	1979-06-07	1979-06-07 00:00:00	1979-06-07	38000177		0	0	7		0	0	0	94423	0	562251	1713671		
23961	1973	19128065	1989-05-13	1989-05-13 00:00:00	1990-05-08	1990-05-08 00:00:00	1990-05-08	38000177		0	0	360		0	0	0	131153	0	749882	19128065		
17187	1426	1127078	1954-12-26	1954-12-26 00:00:00	1955-01-23	1955-01-23 00:00:00	1955-01-23	38000177		0	0	28		0	0	0	94872	0	282464	1127078		
20293	1666	40229134	1951-05-20	1951-05-20 00:00:00	1951-05-27	1951-05-27 00:00:00	1951-05-27	38000177		0	0	7		0	0	0	111852	0	1043400	40229134		
40471	3355	19128065	1976-10-01	1976-10-01 00:00:00	1977-09-26	1977-09-26 00:00:00	1977-09-26	38000177		0	0	360		0	0	0	222466	0	749882	19128065		
3313	273	40229134	1980-11-17	1980-11-17 00:00:00	1980-11-24	1980-11-24 00:00:00	1980-11-24	38000177		0	0	7		0	0	0	18194	0	1043400	40229134		
37563	3105	1127078	1975-04-23	1975-04-23 00:00:00	1975-05-07	1975-05-07 00:00:00	1975-05-07	38000177		0	0	14		0	0	0	206531	0	282464	1127078		
53944	4482	19006318	1952-11-15	1952-11-15 00:00:00	1952-11-29	1952-11-29 00:00:00	1952-11-29	38000177		0	0	14		0	0	0	298360	0	105078	19006318		
7127	600	1115171	2002-01-20	2002-01-20 00:00:00	2002-04-20	2002-04-20 00:00:00	2002-04-20	38000177		0	0	90		0	0	0	39650	0	849574	1115171		
38440	3177	1127433	1975-05-21	1975-05-21 00:00:00	1975-06-11	1975-06-11 00:00:00	1975-06-11	38000177		0	0	21		0	0	0	211232	0	313782	1127433		
6297	526	1115171	1998-11-29	1998-11-29 00:00:00	1998-12-27	1998-12-27 00:00:00	1998-12-27	38000177		0	0	28		0	0	0	35105	0	849574	1115171		
103	6	1127433	1980-01-11	1980-01-11 00:00:00	1980-02-15	1980-02-15 00:00:00	1980-02-15	38000177		0	0	35		0	0	0	557	0	313782	1127433		
17851	1478	19059056	1972-01-23	1972-01-23 00:00:00	1972-02-27	1972-02-27 00:00:00	1972-02-27	38000177		0	0	35		0	0	0	98638	0	243670	19059056		
37883	3132	19059056	1968-12-07	1968-12-07 00:00:00	1968-12-21	1968-12-21 00:00:00	1968-12-21	38000177		0	0	14		0	0	0	208402	0	243670	19059056		
28433	2344	19006318	1970-10-04	1970-10-04 00:00:00	1970-10-18	1970-10-18 00:00:00	1970-10-18	38000177		0	0	14		0	0	0	156027	0	105078	19006318		
28490	2347	1713671	1989-04-21	1989-04-21 00:00:00	1989-05-05	1989-05-05 00:00:00	1989-05-05	38000177		0	0	14		0	0	0	156275	0	562251	1713671		
14730	1232	19129655	1966-03-09	1966-03-09 00:00:00	1966-03-23	1966-03-23 00:00:00	1966-03-23	38000177		0	0	14		0	0	0	81181	0	789980	19129655		
31338	2598	40229134	1994-02-24	1994-02-24 00:00:00	1994-03-03	1994-03-03 00:00:00	1994-03-03	38000177		0	0	7		0	0	0	171894	0	1043400	40229134		
53993	4487	19059056	1953-09-12	1953-09-12 00:00:00	1953-12-11	1953-12-11 00:00:00	1953-12-11	38000177		0	0	90		0	0	0	298681	0	243670	19059056		
38090	3149	19059056	1961-12-13	1961-12-13 00:00:00	1962-01-12	1962-01-12 00:00:00	1962-01-12	38000177		0	0	30		0	0	0	209565	0	243670	19059056		
21231	461	40213201	2014-11-25	2014-11-25 00:00:00	2014-11-25	2014-11-25 00:00:00	2014-11-25	581452		0	0	0		0	0	0	30827	0	33	40213201		
41959	3477	40236446	1972-03-25	1972-03-25 00:00:00	1972-07-01	1972-07-01 00:00:00	1972-07-01	38000177		0	0	98		0	0	0	230648	0	1091392	40236446		
12950	1088	46233988	1973-10-23	1973-10-23 00:00:00	1973-11-06	1973-11-06 00:00:00	1973-11-06	38000177		0	0	14		0	0	0	71416	0	1652673	46233988		
32408	2686	1127433	1966-07-12	1966-07-12 00:00:00	1966-07-26	1966-07-26 00:00:00	1966-07-26	38000177		0	0	14		0	0	0	177984	0	313782	1127433		
34993	2891	1124300	2014-05-01	2014-05-01 00:00:00	2014-05-01	2014-05-01 00:00:00	\N	38000177		0	0	0		0	0	0	192299	0	00781178901	45011828		
10219	857	19006318	1955-02-04	1955-02-04 00:00:00	1955-02-18	1955-02-18 00:00:00	1955-02-18	38000177		0	0	14		0	0	0	56593	0	105078	19006318		
45532	3767	40229134	2016-03-13	2016-03-13 00:00:00	2016-03-20	2016-03-20 00:00:00	2016-03-20	38000177		0	0	7		0	0	0	250351	0	1043400	40229134		
2901	235	1127433	2000-05-02	2000-05-02 00:00:00	2000-05-09	2000-05-09 00:00:00	2000-05-09	38000177		0	0	7		0	0	0	15783	0	313782	1127433		
21710	471	40213227	2007-12-21	2007-12-21 00:00:00	2007-12-21	2007-12-21 00:00:00	2007-12-21	581452		0	0	0		0	0	0	31476	0	113	40213227		
149305	3285	40213260	2010-04-03	2010-04-03 00:00:00	2010-04-03	2010-04-03 00:00:00	2010-04-03	581452		0	0	0		0	0	0	218241	0	121	40213260		
28742	2372	19133905	1984-08-17	1984-08-17 00:00:00	1984-08-24	1984-08-24 00:00:00	1984-08-24	38000177		0	0	7		0	0	0	157825	0	834102	19133905		
60914	5066	19059056	1983-08-31	1983-08-31 00:00:00	1983-10-30	1983-10-30 00:00:00	1983-10-30	38000177		0	0	60		0	0	0	336805	0	243670	19059056		
14092	1177	19133873	1978-01-11	1978-01-11 00:00:00	1978-01-20	1978-01-20 00:00:00	1978-01-20	38000177		0	0	9		0	0	0	77775	0	834061	19133873		
36602	3020	19126352	1961-12-13	1961-12-13 00:00:00	1961-12-13	1961-12-13 00:00:00	\N	38000177		0	0	0		0	0	0	201425	0	705129	19126352		
24644	2027	19006318	1968-02-09	1968-02-09 00:00:00	1968-03-15	1968-03-15 00:00:00	1968-03-15	38000177		0	0	35		0	0	0	134932	0	105078	19006318		
44942	3719	40162522	1985-10-09	1985-10-09 00:00:00	1985-10-09	1985-10-09 00:00:00	\N	38000177		0	0	0		0	0	0	247166	0	857005	40162522		
23265	1917	40220960	2006-06-04	2006-06-04 00:00:00	2006-06-04	2006-06-04 00:00:00	2006-06-04	38000177		0	0	0		0	0	0	127552	0	1804799	40220960		
23316	1921	19006318	1957-02-05	1957-02-05 00:00:00	1957-02-19	1957-02-19 00:00:00	1957-02-19	38000177		0	0	14		0	0	0	127723	0	105078	19006318		
50056	4153	1118084	2001-09-20	2001-09-20 00:00:00	2001-09-20	2001-09-20 00:00:00	\N	38000177		0	0	0		0	0	0	276038	0	00025152531	44923712		
26213	2155	40220960	2009-04-29	2009-04-29 00:00:00	2009-04-29	2009-04-29 00:00:00	2009-04-29	38000177		0	0	0		0	0	0	143619	0	1804799	40220960		
36711	3030	1127078	1989-04-08	1989-04-08 00:00:00	1989-05-06	1989-05-06 00:00:00	1989-05-06	38000177		0	0	28		0	0	0	202022	0	282464	1127078		
26806	2207	1124300	2013-05-06	2013-05-06 00:00:00	2013-05-06	2013-05-06 00:00:00	\N	38000177		0	0	0		0	0	0	147077	0	00781178901	45011828		
60694	5048	19078461	1999-06-24	1999-06-24 00:00:00	1999-07-08	1999-07-08 00:00:00	1999-07-08	38000177		0	0	14		0	0	0	335504	0	310965	19078461		
4585	380	1118084	2012-06-14	2012-06-14 00:00:00	2012-06-14	2012-06-14 00:00:00	\N	38000177		0	0	0		0	0	0	25134	0	00025152531	44923712		
35726	2944	40229134	1981-09-02	1981-09-02 00:00:00	1981-09-16	1981-09-16 00:00:00	1981-09-16	38000177		0	0	14		0	0	0	196404	0	1043400	40229134		
52086	4330	1115171	1995-12-31	1995-12-31 00:00:00	1996-01-14	1996-01-14 00:00:00	1996-01-14	38000177		0	0	14		0	0	0	287263	0	849574	1115171		
6871	578	46233988	1970-05-22	1970-05-22 00:00:00	1970-06-05	1970-06-05 00:00:00	1970-06-05	38000177		0	0	14		0	0	0	38222	0	1652673	46233988		
6907	580	40229134	1980-12-01	1980-12-01 00:00:00	1980-12-15	1980-12-15 00:00:00	1980-12-15	38000177		0	0	14		0	0	0	38406	0	1043400	40229134		
33555	2777	19059056	1969-07-13	1969-07-13 00:00:00	1969-08-03	1969-08-03 00:00:00	1969-08-03	38000177		0	0	21		0	0	0	183931	0	243670	19059056		
239520	5257	40213227	2000-08-30	2000-08-30 00:00:00	2000-08-30	2000-08-30 00:00:00	2000-08-30	581452		0	0	0		0	0	0	349812	0	113	40213227		
1191	96	1713671	1933-11-16	1933-11-16 00:00:00	1933-12-07	1933-12-07 00:00:00	1933-12-07	38000177		0	0	21		0	0	0	6549	0	562251	1713671		
56956	4724	19134077	2018-04-21	2018-04-21 00:00:00	2018-05-05	2018-05-05 00:00:00	2018-05-05	38000177		0	0	14		0	0	0	314816	0	835900	19134077		
44196	3658	40229134	2017-01-17	2017-01-17 00:00:00	2017-01-31	2017-01-31 00:00:00	2017-01-31	38000177		0	0	14		0	0	0	243459	0	1043400	40229134		
19349	1597	19059056	1947-06-14	1947-06-14 00:00:00	1947-06-28	1947-06-28 00:00:00	1947-06-28	38000177		0	0	14		0	0	0	107105	0	243670	19059056		
19411	1600	19006318	1945-12-26	1945-12-26 00:00:00	1946-01-09	1946-01-09 00:00:00	1946-01-09	38000177		0	0	14		0	0	0	107427	0	105078	19006318		
44094	3650	40229134	1931-03-08	1931-03-08 00:00:00	1931-03-15	1931-03-15 00:00:00	1931-03-15	38000177		0	0	7		0	0	0	242964	0	1043400	40229134		
37056	3064	1713671	1972-08-11	1972-08-11 00:00:00	1972-09-01	1972-09-01 00:00:00	1972-09-01	38000177		0	0	21		0	0	0	203937	0	562251	1713671		
21843	474	40213160	1974-11-24	1974-11-24 00:00:00	1974-11-24	1974-11-24 00:00:00	1974-11-24	581452		0	0	0		0	0	0	31633	0	10	40213160		
37153	3070	1127433	2011-10-07	2011-10-07 00:00:00	2011-10-14	2011-10-14 00:00:00	2011-10-14	38000177		0	0	7		0	0	0	204389	0	313782	1127433		
21717	1782	19006318	1954-08-01	1954-08-01 00:00:00	1954-08-15	1954-08-15 00:00:00	1954-08-15	38000177		0	0	14		0	0	0	119349	0	105078	19006318		
12921	1086	1118084	2004-07-21	2004-07-21 00:00:00	2004-07-21	2004-07-21 00:00:00	\N	38000177		0	0	0		0	0	0	71339	0	00025152531	44923712		
57721	4795	40236824	1995-12-09	1995-12-09 00:00:00	1995-12-23	1995-12-23 00:00:00	1995-12-23	38000177		0	0	14		0	0	0	318994	0	1094107	40236824		
32351	2682	46233988	1978-01-20	1978-01-20 00:00:00	1978-02-03	1978-02-03 00:00:00	1978-02-03	38000177		0	0	14		0	0	0	177740	0	1652673	46233988		
30522	2530	19059056	1964-10-23	1964-10-23 00:00:00	1964-11-06	1964-11-06 00:00:00	1964-11-06	38000177		0	0	14		0	0	0	167256	0	243670	19059056		
17127	1418	1713671	2005-07-12	2005-07-12 00:00:00	2005-07-26	2005-07-26 00:00:00	2005-07-26	38000177		0	0	14		0	0	0	94450	0	562251	1713671		
23962	1973	1127433	1995-09-22	1995-09-22 00:00:00	1995-10-06	1995-10-06 00:00:00	1995-10-06	38000177		0	0	14		0	0	0	131162	0	313782	1127433		
17188	1426	1127433	1983-11-23	1983-11-23 00:00:00	1983-11-30	1983-11-30 00:00:00	1983-11-30	38000177		0	0	7		0	0	0	94830	0	313782	1127433		
20294	1666	1713671	1967-08-31	1967-08-31 00:00:00	1967-09-14	1967-09-14 00:00:00	1967-09-14	38000177		0	0	14		0	0	0	111854	0	562251	1713671		
40472	3355	19059056	1986-07-31	1986-07-31 00:00:00	1986-10-29	1986-10-29 00:00:00	1986-10-29	38000177		0	0	90		0	0	0	222507	0	243670	19059056		
3314	273	40229134	2003-01-08	2003-01-08 00:00:00	2003-01-22	2003-01-22 00:00:00	2003-01-22	38000177		0	0	14		0	0	0	18296	0	1043400	40229134		
37564	3105	1124300	2008-07-05	2008-07-05 00:00:00	2008-07-05	2008-07-05 00:00:00	\N	38000177		0	0	0		0	0	0	206518	0	00781178901	45011828		
53945	4482	19059056	1952-11-15	1952-11-15 00:00:00	1952-11-29	1952-11-29 00:00:00	1952-11-29	38000177		0	0	14		0	0	0	298360	0	243670	19059056		
7128	600	1127433	1978-03-30	1978-03-30 00:00:00	1978-04-13	1978-04-13 00:00:00	1978-04-13	38000177		0	0	14		0	0	0	39571	0	313782	1127433		
38441	3177	920334	1946-08-29	1946-08-29 00:00:00	1946-09-05	1946-09-05 00:00:00	1946-09-05	38000177		0	0	7		0	0	0	211315	0	311995	920334		
6298	526	1127433	1988-04-06	1988-04-06 00:00:00	1988-04-13	1988-04-13 00:00:00	1988-04-13	38000177		0	0	7		0	0	0	35048	0	313782	1127433		
104	6	19128065	1977-12-27	1977-12-27 00:00:00	1978-12-22	1978-12-22 00:00:00	1978-12-22	38000177		0	0	360		0	0	0	542	0	749882	19128065		
17853	1478	35605482	1975-05-03	1975-05-03 00:00:00	1975-05-03	1975-05-03 00:00:00	1975-05-03	38000177		0	0	0		0	0	0	98639	0	1740467	35605482		
37884	3132	19059056	1981-03-18	1981-03-18 00:00:00	1981-04-15	1981-04-15 00:00:00	1981-04-15	38000177		0	0	28		0	0	0	208385	0	243670	19059056		
28434	2344	19059056	1970-10-04	1970-10-04 00:00:00	1970-10-18	1970-10-18 00:00:00	1970-10-18	38000177		0	0	14		0	0	0	156027	0	243670	19059056		
28491	2347	40229134	1982-03-25	1982-03-25 00:00:00	1982-04-08	1982-04-08 00:00:00	1982-04-08	38000177		0	0	14		0	0	0	156250	0	1043400	40229134		
14731	1232	19078461	1993-12-12	1993-12-12 00:00:00	1993-12-26	1993-12-26 00:00:00	1993-12-26	38000177		0	0	14		0	0	0	81185	0	310965	19078461		
31339	2598	1127433	2011-11-16	2011-11-16 00:00:00	2011-12-07	2011-12-07 00:00:00	2011-12-07	38000177		0	0	21		0	0	0	171937	0	313782	1127433		
53994	4487	40229134	1990-10-03	1990-10-03 00:00:00	1990-10-10	1990-10-10 00:00:00	1990-10-10	38000177		0	0	7		0	0	0	298716	0	1043400	40229134		
38091	3150	19059056	1939-11-23	1939-11-23 00:00:00	1939-12-07	1939-12-07 00:00:00	1939-12-07	38000177		0	0	14		0	0	0	209585	0	243670	19059056		
21241	461	40213198	2013-11-19	2013-11-19 00:00:00	2013-11-19	2013-11-19 00:00:00	2013-11-19	581452		0	0	0		0	0	0	30865	0	133	40213198		
41960	3477	19008572	1986-04-02	1986-04-02 00:00:00	1986-04-02	1986-04-02 00:00:00	\N	38000177		0	0	0		0	0	0	230714	0	106258	19008572		
12951	1088	40236824	2006-09-01	2006-09-01 00:00:00	2006-09-08	2006-09-08 00:00:00	2006-09-08	38000177		0	0	7		0	0	0	71409	0	1094107	40236824		
32409	2686	1713671	1994-09-03	1994-09-03 00:00:00	1994-09-17	1994-09-17 00:00:00	1994-09-17	38000177		0	0	14		0	0	0	177995	0	562251	1713671		
34994	2891	1127433	1996-05-05	1996-05-05 00:00:00	1996-05-12	1996-05-12 00:00:00	1996-05-12	38000177		0	0	7		0	0	0	192324	0	313782	1127433		
10220	857	19059056	1955-02-04	1955-02-04 00:00:00	1955-02-18	1955-02-18 00:00:00	1955-02-18	38000177		0	0	14		0	0	0	56593	0	243670	19059056		
45533	3767	1127433	1997-03-15	1997-03-15 00:00:00	1997-03-29	1997-03-29 00:00:00	1997-03-29	38000177		0	0	14		0	0	0	250381	0	313782	1127433		
2903	235	19133873	1991-04-04	1991-04-04 00:00:00	1991-04-16	1991-04-16 00:00:00	1991-04-16	38000177		0	0	12		0	0	0	15782	0	834061	19133873		
21719	472	40213227	2018-10-28	2018-10-28 00:00:00	2018-10-28	2018-10-28 00:00:00	2018-10-28	581452		0	0	0		0	0	0	31545	0	113	40213227		
149311	3285	40213296	2002-03-09	2002-03-09 00:00:00	2002-03-09	2002-03-09 00:00:00	2002-03-09	581452		0	0	0		0	0	0	218198	0	52	40213296		
28743	2373	1127433	1996-06-12	1996-06-12 00:00:00	1996-06-26	1996-06-26 00:00:00	1996-06-26	38000177		0	0	14		0	0	0	157940	0	313782	1127433		
60915	5066	1127433	2015-02-28	2015-02-28 00:00:00	2015-03-30	2015-03-30 00:00:00	2015-03-30	38000177		0	0	30		0	0	0	336814	0	313782	1127433		
14093	1177	1713671	1983-05-18	1983-05-18 00:00:00	1983-06-08	1983-06-08 00:00:00	1983-06-08	38000177		0	0	21		0	0	0	77776	0	562251	1713671		
36603	3020	19059056	1963-01-01	1963-01-01 00:00:00	1963-01-15	1963-01-15 00:00:00	1963-01-15	38000177		0	0	14		0	0	0	201371	0	243670	19059056		
24645	2027	1127433	1961-08-15	1961-08-15 00:00:00	1961-08-22	1961-08-22 00:00:00	1961-08-22	38000177		0	0	7		0	0	0	134876	0	313782	1127433		
44943	3719	19078461	1985-10-09	1985-10-09 00:00:00	1985-12-08	1985-12-08 00:00:00	1985-12-08	38000177		0	0	60		0	0	0	247166	0	310965	19078461		
23266	1917	19075601	2006-06-04	2006-06-04 00:00:00	2006-06-04	2006-06-04 00:00:00	2006-06-04	38000177		0	0	0		0	0	0	127552	0	309362	19075601		
23327	1923	1127433	1962-06-13	1962-06-13 00:00:00	1962-06-27	1962-06-27 00:00:00	1962-06-27	38000177		0	0	14		0	0	0	127953	0	313782	1127433		
50057	4153	19059056	1981-01-18	1981-01-18 00:00:00	1981-02-08	1981-02-08 00:00:00	1981-02-08	38000177		0	0	21		0	0	0	276006	0	243670	19059056		
26214	2155	19075601	2009-04-29	2009-04-29 00:00:00	2009-04-29	2009-04-29 00:00:00	2009-04-29	38000177		0	0	0		0	0	0	143619	0	309362	19075601		
36712	3030	1713671	2014-01-24	2014-01-24 00:00:00	2014-02-14	2014-02-14 00:00:00	2014-02-14	38000177		0	0	21		0	0	0	201985	0	562251	1713671		
26807	2207	40229134	1989-01-08	1989-01-08 00:00:00	1989-01-22	1989-01-22 00:00:00	1989-01-22	38000177		0	0	14		0	0	0	147078	0	1043400	40229134		
60695	5048	1118084	1991-10-06	1991-10-06 00:00:00	1991-10-06	1991-10-06 00:00:00	\N	38000177		0	0	0		0	0	0	335507	0	00025152531	44923712		
4614	384	40236824	2018-08-09	2018-08-09 00:00:00	2018-08-16	2018-08-16 00:00:00	2018-08-16	38000177		0	0	7		0	0	0	25340	0	1094107	40236824		
35727	2944	19059056	1960-03-31	1960-03-31 00:00:00	1960-04-14	1960-04-14 00:00:00	1960-04-14	38000177		0	0	14		0	0	0	196429	0	243670	19059056		
52087	4330	19059056	1951-06-15	1951-06-15 00:00:00	1951-06-29	1951-06-29 00:00:00	1951-06-29	38000177		0	0	14		0	0	0	287192	0	243670	19059056		
6872	578	1127078	1970-05-22	1970-05-22 00:00:00	1970-06-05	1970-06-05 00:00:00	1970-06-05	38000177		0	0	14		0	0	0	38222	0	282464	1127078		
6908	580	19078461	1994-07-30	1994-07-30 00:00:00	1994-08-13	1994-08-13 00:00:00	1994-08-13	38000177		0	0	14		0	0	0	38453	0	310965	19078461		
33556	2777	40236824	2013-04-25	2013-04-25 00:00:00	2013-05-02	2013-05-02 00:00:00	2013-05-02	38000177		0	0	7		0	0	0	183895	0	1094107	40236824		
239521	5257	40213160	1978-11-22	1978-11-22 00:00:00	1978-11-22	1978-11-22 00:00:00	1978-11-22	581452		0	0	0		0	0	0	349793	0	10	40213160		
1192	96	40220960	1989-09-16	1989-09-16 00:00:00	1989-09-16	1989-09-16 00:00:00	1989-09-16	38000177		0	0	0		0	0	0	6493	0	1804799	40220960		
56957	4724	19008572	2018-04-21	2018-04-21 00:00:00	2018-05-05	2018-05-05 00:00:00	2018-05-05	38000177		0	0	14		0	0	0	314816	0	106258	19008572		
44197	3658	1713671	1998-07-28	1998-07-28 00:00:00	1998-08-18	1998-08-18 00:00:00	1998-08-18	38000177		0	0	21		0	0	0	243441	0	562251	1713671		
19350	1597	19006318	1947-06-14	1947-06-14 00:00:00	1947-06-28	1947-06-28 00:00:00	1947-06-28	38000177		0	0	14		0	0	0	107105	0	105078	19006318		
19412	1600	1713671	1965-05-13	1965-05-13 00:00:00	1965-05-20	1965-05-20 00:00:00	1965-05-20	38000177		0	0	7		0	0	0	107408	0	562251	1713671		
44095	3650	19059056	1928-05-20	1928-05-20 00:00:00	1928-06-10	1928-06-10 00:00:00	1928-06-10	38000177		0	0	21		0	0	0	242934	0	243670	19059056		
37057	3064	19078461	1980-05-03	1980-05-03 00:00:00	1980-05-24	1980-05-24 00:00:00	1980-05-24	38000177		0	0	21		0	0	0	203999	0	310965	19078461		
21847	474	40213160	1970-03-22	1970-03-22 00:00:00	1970-03-22	1970-03-22 00:00:00	1970-03-22	581452		0	0	0		0	0	0	31656	0	10	40213160		
37154	3070	1713671	1969-08-16	1969-08-16 00:00:00	1969-08-30	1969-08-30 00:00:00	1969-08-30	38000177		0	0	14		0	0	0	204367	0	562251	1713671		
21718	1782	19059056	1954-08-01	1954-08-01 00:00:00	1954-08-15	1954-08-15 00:00:00	1954-08-15	38000177		0	0	14		0	0	0	119349	0	243670	19059056		
12922	1086	1127078	1975-09-17	1975-09-17 00:00:00	1975-10-01	1975-10-01 00:00:00	1975-10-01	38000177		0	0	14		0	0	0	71349	0	282464	1127078		
32265	2675	40229134	1976-05-31	1976-05-31 00:00:00	1976-06-07	1976-06-07 00:00:00	1976-06-07	38000177		0	0	7		0	0	0	177289	0	1043400	40229134		
32352	2682	19019979	1978-01-20	1978-01-20 00:00:00	1978-02-03	1978-02-03 00:00:00	1978-02-03	38000177		0	0	14		0	0	0	177740	0	198405	19019979		
30523	2530	19129655	1964-10-23	1964-10-23 00:00:00	1964-11-06	1964-11-06 00:00:00	1964-11-06	38000177		0	0	14		0	0	0	167256	0	789980	19129655		
59968	4986	1127433	1965-03-05	1965-03-05 00:00:00	1965-03-26	1965-03-26 00:00:00	1965-03-26	38000177		0	0	21		0	0	0	331615	0	313782	1127433		
23963	1973	1118084	2011-07-17	2011-07-17 00:00:00	2011-07-17	2011-07-17 00:00:00	\N	38000177		0	0	0		0	0	0	131163	0	00025152531	44923712		
17189	1426	1713671	1975-07-27	1975-07-27 00:00:00	1975-08-17	1975-08-17 00:00:00	1975-08-17	38000177		0	0	21		0	0	0	94879	0	562251	1713671		
17236	1430	1713671	1954-04-04	1954-04-04 00:00:00	1954-04-18	1954-04-18 00:00:00	1954-04-18	38000177		0	0	14		0	0	0	95121	0	562251	1713671		
40473	3355	1713671	2004-03-09	2004-03-09 00:00:00	2004-03-30	2004-03-30 00:00:00	2004-03-30	38000177		0	0	21		0	0	0	222496	0	562251	1713671		
3315	273	1124300	2011-09-25	2011-09-25 00:00:00	2011-09-25	2011-09-25 00:00:00	\N	38000177		0	0	0		0	0	0	18233	0	00781178901	45011828		
37565	3106	1713671	1968-04-28	1968-04-28 00:00:00	1968-05-12	1968-05-12 00:00:00	1968-05-12	38000177		0	0	14		0	0	0	206547	0	562251	1713671		
53946	4482	1118084	1987-08-27	1987-08-27 00:00:00	1987-08-27	1987-08-27 00:00:00	\N	38000177		0	0	0		0	0	0	298329	0	00025152531	44923712		
7129	600	19133905	1983-08-17	1983-08-17 00:00:00	1983-08-29	1983-08-29 00:00:00	1983-08-29	38000177		0	0	12		0	0	0	39640	0	834102	19133905		
38442	3177	920300	1946-08-22	1946-08-22 00:00:00	1946-08-29	1946-08-29 00:00:00	1946-08-29	38000177		0	0	7		0	0	0	211314	0	311989	920300		
6299	526	920300	2004-03-21	2004-03-21 00:00:00	2004-03-28	2004-03-28 00:00:00	2004-03-28	38000177		0	0	7		0	0	0	35068	0	311989	920300		
106	7	1127078	1972-07-09	1972-07-09 00:00:00	1972-07-23	1972-07-23 00:00:00	1972-07-23	38000177		0	0	14		0	0	0	630	0	282464	1127078		
17854	1478	35605482	1975-05-03	1975-05-03 00:00:00	1975-05-03	1975-05-03 00:00:00	1975-05-03	38000177		0	0	0		0	0	0	98639	0	1740467	35605482		
37885	3132	19133873	1974-08-22	1974-08-22 00:00:00	1974-09-04	1974-09-04 00:00:00	1974-09-04	38000177		0	0	13		0	0	0	208389	0	834061	19133873		
37927	3135	40229134	1978-12-24	1978-12-24 00:00:00	1979-01-07	1979-01-07 00:00:00	1979-01-07	38000177		0	0	14		0	0	0	208666	0	1043400	40229134		
28492	2347	19128065	1986-11-13	1986-11-13 00:00:00	1987-11-08	1987-11-08 00:00:00	1987-11-08	38000177		0	0	360		0	0	0	156237	0	749882	19128065		
14732	1232	19133873	1965-09-14	1965-09-14 00:00:00	1965-09-27	1965-09-27 00:00:00	1965-09-27	38000177		0	0	13		0	0	0	81198	0	834061	19133873		
31340	2598	19133873	1985-09-09	1985-09-09 00:00:00	1985-09-22	1985-09-22 00:00:00	1985-09-22	38000177		0	0	13		0	0	0	171888	0	834061	19133873		
53995	4487	1127433	1997-09-04	1997-09-04 00:00:00	1997-09-11	1997-09-11 00:00:00	1997-09-11	38000177		0	0	7		0	0	0	298693	0	313782	1127433		
38092	3150	1118084	1975-06-07	1975-06-07 00:00:00	1975-06-07	1975-06-07 00:00:00	\N	38000177		0	0	0		0	0	0	209622	0	00025152531	44923712		
21789	1789	40232448	1976-03-06	1976-03-06 00:00:00	1976-03-06	1976-03-06 00:00:00	\N	38000177		0	0	0		0	0	0	119926	0	1049630	40232448		
41961	3477	19133873	1968-02-22	1968-02-22 00:00:00	1968-03-04	1968-03-04 00:00:00	1968-03-04	38000177		0	0	11		0	0	0	230687	0	834061	19133873		
12952	1088	920300	2006-09-01	2006-09-01 00:00:00	2006-09-08	2006-09-08 00:00:00	2006-09-08	38000177		0	0	7		0	0	0	71409	0	311989	920300		
32410	2686	1127433	1962-01-10	1962-01-10 00:00:00	1962-01-24	1962-01-24 00:00:00	1962-01-24	38000177		0	0	14		0	0	0	178048	0	313782	1127433		
34995	2891	40236824	1996-01-02	1996-01-02 00:00:00	1996-01-09	1996-01-09 00:00:00	1996-01-09	38000177		0	0	7		0	0	0	192323	0	1094107	40236824		
10221	857	1118084	1985-10-15	1985-10-15 00:00:00	1985-10-15	1985-10-15 00:00:00	\N	38000177		0	0	0		0	0	0	56591	0	00025152531	44923712		
45545	3769	1115171	2003-11-06	2003-11-06 00:00:00	2003-11-20	2003-11-20 00:00:00	2003-11-20	38000177		0	0	14		0	0	0	250506	0	849574	1115171		
2904	235	19078461	2000-10-03	2000-10-03 00:00:00	2000-11-02	2000-11-02 00:00:00	2000-11-02	38000177		0	0	30		0	0	0	15759	0	310965	19078461		
21720	472	40213296	2018-10-28	2018-10-28 00:00:00	2018-10-28	2018-10-28 00:00:00	2018-10-28	581452		0	0	0		0	0	0	31545	0	52	40213296		
149315	3285	40213160	1959-02-21	1959-02-21 00:00:00	1959-02-21	1959-02-21 00:00:00	1959-02-21	581452		0	0	0		0	0	0	218202	0	10	40213160		
28744	2373	1713671	1979-07-02	1979-07-02 00:00:00	1979-07-23	1979-07-23 00:00:00	1979-07-23	38000177		0	0	21		0	0	0	157898	0	562251	1713671		
60916	5066	1118084	2011-07-16	2011-07-16 00:00:00	2011-07-16	2011-07-16 00:00:00	\N	38000177		0	0	0		0	0	0	336811	0	00025152531	44923712		
14094	1177	19059056	1968-10-12	1968-10-12 00:00:00	1968-10-26	1968-10-26 00:00:00	1968-10-26	38000177		0	0	14		0	0	0	77734	0	243670	19059056		
36605	3020	1127433	1991-12-19	1991-12-19 00:00:00	1991-12-26	1991-12-26 00:00:00	1991-12-26	38000177		0	0	7		0	0	0	201393	0	313782	1127433		
24646	2027	19059056	1965-09-06	1965-09-06 00:00:00	1965-09-20	1965-09-20 00:00:00	1965-09-20	38000177		0	0	14		0	0	0	134875	0	243670	19059056		
44944	3719	40229134	1986-11-19	1986-11-19 00:00:00	1986-12-03	1986-12-03 00:00:00	1986-12-03	38000177		0	0	14		0	0	0	247194	0	1043400	40229134		
23267	1917	19133905	1984-03-01	1984-03-01 00:00:00	1984-03-10	1984-03-10 00:00:00	1984-03-10	38000177		0	0	9		0	0	0	127522	0	834102	19133905		
23328	1923	19059056	1937-06-23	1937-06-23 00:00:00	1937-07-07	1937-07-07 00:00:00	1937-07-07	38000177		0	0	14		0	0	0	127856	0	243670	19059056		
50058	4153	1713671	1968-07-01	1968-07-01 00:00:00	1968-07-22	1968-07-22 00:00:00	1968-07-22	38000177		0	0	21		0	0	0	276028	0	562251	1713671		
26215	2155	1127433	1999-02-02	1999-02-02 00:00:00	1999-02-16	1999-02-16 00:00:00	1999-02-16	38000177		0	0	14		0	0	0	143578	0	313782	1127433		
36713	3030	19019979	1986-05-24	1986-05-24 00:00:00	1986-08-22	1986-08-22 00:00:00	1986-08-22	38000177		0	0	90		0	0	0	202021	0	198405	19019979		
26808	2207	1127433	2018-10-03	2018-10-03 00:00:00	2018-10-17	2018-10-17 00:00:00	2018-10-17	38000177		0	0	14		0	0	0	147083	0	313782	1127433		
60696	5048	1127433	1959-10-20	1959-10-20 00:00:00	1959-10-27	1959-10-27 00:00:00	1959-10-27	38000177		0	0	7		0	0	0	335517	0	313782	1127433		
4615	384	920300	2018-08-09	2018-08-09 00:00:00	2018-08-16	2018-08-16 00:00:00	2018-08-16	38000177		0	0	7		0	0	0	25340	0	311989	920300		
35728	2944	19006318	1960-03-31	1960-03-31 00:00:00	1960-04-14	1960-04-14 00:00:00	1960-04-14	38000177		0	0	14		0	0	0	196429	0	105078	19006318		
52088	4330	19006318	1951-06-15	1951-06-15 00:00:00	1951-06-29	1951-06-29 00:00:00	1951-06-29	38000177		0	0	14		0	0	0	287192	0	105078	19006318		
6873	578	19128065	1981-05-27	1981-05-27 00:00:00	1982-05-22	1982-05-22 00:00:00	1982-05-22	38000177		0	0	360		0	0	0	38244	0	749882	19128065		
6909	580	19059056	1930-03-05	1930-03-05 00:00:00	1930-03-19	1930-03-19 00:00:00	1930-03-19	38000177		0	0	14		0	0	0	38471	0	243670	19059056		
33557	2777	920300	2013-04-25	2013-04-25 00:00:00	2013-05-02	2013-05-02 00:00:00	2013-05-02	38000177		0	0	7		0	0	0	183895	0	311989	920300		
239524	5257	40213296	2018-03-21	2018-03-21 00:00:00	2018-03-21	2018-03-21 00:00:00	2018-03-21	581452		0	0	0		0	0	0	349832	0	52	40213296		
1193	96	1127433	1944-09-01	1944-09-01 00:00:00	1944-09-15	1944-09-15 00:00:00	1944-09-15	38000177		0	0	14		0	0	0	6544	0	313782	1127433		
56958	4724	19077572	2018-02-28	2018-02-28 00:00:00	2018-02-28	2018-02-28 00:00:00	\N	38000177		0	0	0		0	0	0	314815	0	310436	19077572		
44198	3658	1124300	1999-06-13	1999-06-13 00:00:00	1999-06-13	1999-06-13 00:00:00	\N	38000177		0	0	0		0	0	0	243441	0	00781178901	45011828		
19353	1597	19133905	2006-03-11	2006-03-11 00:00:00	2006-03-20	2006-03-20 00:00:00	2006-03-20	38000177		0	0	9		0	0	0	107161	0	834102	19133905		
19413	1600	1713671	1972-02-18	1972-02-18 00:00:00	1972-02-25	1972-02-25 00:00:00	1972-02-25	38000177		0	0	7		0	0	0	107433	0	562251	1713671		
44096	3650	19133873	1938-05-31	1938-05-31 00:00:00	1938-06-10	1938-06-10 00:00:00	1938-06-10	38000177		0	0	10		0	0	0	242965	0	834061	19133873		
37058	3064	19059056	1971-10-18	1971-10-18 00:00:00	1971-12-17	1971-12-17 00:00:00	1971-12-17	38000177		0	0	60		0	0	0	203998	0	243670	19059056		
17151	370	40213227	1994-07-14	1994-07-14 00:00:00	1994-07-14	1994-07-14 00:00:00	1994-07-14	581452		0	0	0		0	0	0	24649	0	113	40213227		
37155	3070	1115171	2018-12-28	2018-12-28 00:00:00	2019-01-25	2019-01-25 00:00:00	2019-01-25	38000177		0	0	28		0	0	0	204327	0	849574	1115171		
21719	1782	1127433	2009-11-17	2009-11-17 00:00:00	2009-12-01	2009-12-01 00:00:00	2009-12-01	38000177		0	0	14		0	0	0	119344	0	313782	1127433		
12923	1086	1127433	1973-04-02	1973-04-02 00:00:00	1973-04-16	1973-04-16 00:00:00	1973-04-16	38000177		0	0	14		0	0	0	71319	0	313782	1127433		
32266	2675	40229134	1993-02-19	1993-02-19 00:00:00	1993-02-26	1993-02-26 00:00:00	1993-02-26	38000177		0	0	7		0	0	0	177290	0	1043400	40229134		
32353	2682	1713671	2014-11-01	2014-11-01 00:00:00	2014-11-15	2014-11-15 00:00:00	2014-11-15	38000177		0	0	14		0	0	0	177713	0	562251	1713671		
30524	2530	1127433	1968-10-03	1968-10-03 00:00:00	1968-10-17	1968-10-17 00:00:00	1968-10-17	38000177		0	0	14		0	0	0	167233	0	313782	1127433		
59969	4986	1127433	1955-12-25	1955-12-25 00:00:00	1956-01-01	1956-01-01 00:00:00	1956-01-01	38000177		0	0	7		0	0	0	331688	0	313782	1127433		
23964	1973	1713671	1972-01-12	1972-01-12 00:00:00	1972-01-19	1972-01-19 00:00:00	1972-01-19	38000177		0	0	7		0	0	0	131154	0	562251	1713671		
17190	1426	1115171	2005-10-18	2005-10-18 00:00:00	2005-11-17	2005-11-17 00:00:00	2005-11-17	38000177		0	0	30		0	0	0	94875	0	849574	1115171		
17237	1430	1124300	1986-03-02	1986-03-02 00:00:00	1986-03-02	1986-03-02 00:00:00	\N	38000177		0	0	0		0	0	0	95104	0	00781178901	45011828		
40474	3355	1127433	1977-11-15	1977-11-15 00:00:00	1978-02-13	1978-02-13 00:00:00	1978-02-13	38000177		0	0	90		0	0	0	222506	0	313782	1127433		
3316	273	19078461	2002-11-21	2002-11-21 00:00:00	2002-12-21	2002-12-21 00:00:00	2002-12-21	38000177		0	0	30		0	0	0	18289	0	310965	19078461		
37566	3106	1127433	2008-05-15	2008-05-15 00:00:00	2008-05-22	2008-05-22 00:00:00	2008-05-22	38000177		0	0	7		0	0	0	206570	0	313782	1127433		
53947	4482	19133873	1955-06-07	1955-06-07 00:00:00	1955-06-16	1955-06-16 00:00:00	1955-06-16	38000177		0	0	9		0	0	0	298407	0	834061	19133873		
7130	600	1127078	1956-02-25	1956-02-25 00:00:00	1956-03-26	1956-03-26 00:00:00	1956-03-26	38000177		0	0	30		0	0	0	39644	0	282464	1127078		
38443	3177	40236824	1946-08-22	1946-08-22 00:00:00	1946-09-05	1946-09-05 00:00:00	1946-09-05	38000177		0	0	14		0	0	0	211314	0	1094107	40236824		
6300	526	40236824	2004-03-21	2004-03-21 00:00:00	2004-03-28	2004-03-28 00:00:00	2004-03-28	38000177		0	0	7		0	0	0	35068	0	1094107	40236824		
107	7	1118084	2008-10-17	2008-10-17 00:00:00	2008-10-17	2008-10-17 00:00:00	\N	38000177		0	0	0		0	0	0	624	0	00025152531	44923712		
17855	1478	1367571	1975-05-03	1975-05-03 00:00:00	1975-05-03	1975-05-03 00:00:00	1975-05-03	38000177		0	0	0		0	0	0	98639	0	314659	19080464		
37886	3132	1713671	1991-07-17	1991-07-17 00:00:00	1991-08-07	1991-08-07 00:00:00	1991-08-07	38000177		0	0	21		0	0	0	208428	0	562251	1713671		
37928	3135	40229134	1979-12-27	1979-12-27 00:00:00	1980-01-03	1980-01-03 00:00:00	1980-01-03	38000177		0	0	7		0	0	0	208685	0	1043400	40229134		
14679	1228	1713671	1999-08-31	1999-08-31 00:00:00	1999-09-21	1999-09-21 00:00:00	1999-09-21	38000177		0	0	21		0	0	0	80876	0	562251	1713671		
14733	1232	1127433	1989-06-30	1989-06-30 00:00:00	1989-07-14	1989-07-14 00:00:00	1989-07-14	38000177		0	0	14		0	0	0	81171	0	313782	1127433		
31341	2598	40162522	1986-09-02	1986-09-02 00:00:00	1986-09-02	1986-09-02 00:00:00	\N	38000177		0	0	0		0	0	0	171921	0	857005	40162522		
53996	4487	19059056	1950-08-29	1950-08-29 00:00:00	1950-09-12	1950-09-12 00:00:00	1950-09-12	38000177		0	0	14		0	0	0	298759	0	243670	19059056		
2371	53	40213306	1985-03-13	1985-03-13 00:00:00	1985-03-13	1985-03-13 00:00:00	1985-03-13	581452		0	0	0		0	0	0	3652	0	43	40213306		
21790	1789	19133905	2014-09-10	2014-09-10 00:00:00	2014-09-21	2014-09-21 00:00:00	2014-09-21	38000177		0	0	11		0	0	0	119877	0	834102	19133905		
41962	3477	1713671	2008-12-03	2008-12-03 00:00:00	2008-12-24	2008-12-24 00:00:00	2008-12-24	38000177		0	0	21		0	0	0	230609	0	562251	1713671		
12953	1088	19128022	1991-07-01	1991-07-01 00:00:00	1992-06-25	1992-06-25 00:00:00	1992-06-25	38000177		0	0	360		0	0	0	71448	0	749785	19128022		
32411	2686	1127433	1994-03-20	1994-03-20 00:00:00	1994-06-18	1994-06-18 00:00:00	1994-06-18	38000177		0	0	90		0	0	0	178072	0	313782	1127433		
34996	2891	920300	1996-01-02	1996-01-02 00:00:00	1996-01-09	1996-01-09 00:00:00	1996-01-09	38000177		0	0	7		0	0	0	192323	0	311989	920300		
10222	857	46275916	1983-09-18	1983-09-18 00:00:00	1983-09-18	1983-09-18 00:00:00	1983-09-18	38000177		0	0	0		0	0	0	56579	0	1660014	46275916		
45546	3769	19059056	1970-05-05	1970-05-05 00:00:00	1970-06-02	1970-06-02 00:00:00	1970-06-02	38000177		0	0	28		0	0	0	250505	0	243670	19059056		
2905	235	40229134	2008-06-02	2008-06-02 00:00:00	2008-06-16	2008-06-16 00:00:00	2008-06-16	38000177		0	0	14		0	0	0	15740	0	1043400	40229134		
21723	472	40213160	1976-10-03	1976-10-03 00:00:00	1976-10-03	1976-10-03 00:00:00	1976-10-03	581452		0	0	0		0	0	0	31538	0	10	40213160		
149317	3285	40213227	2000-03-04	2000-03-04 00:00:00	2000-03-04	2000-03-04 00:00:00	2000-03-04	581452		0	0	0		0	0	0	218239	0	113	40213227		
28745	2373	1127078	1959-12-29	1959-12-29 00:00:00	1960-02-02	1960-02-02 00:00:00	1960-02-02	38000177		0	0	35		0	0	0	157945	0	282464	1127078		
43989	958	40213227	2018-01-14	2018-01-14 00:00:00	2018-01-14	2018-01-14 00:00:00	2018-01-14	581452		0	0	0		0	0	0	63661	0	113	40213227		
14095	1177	46233988	1968-10-12	1968-10-12 00:00:00	1968-10-26	1968-10-26 00:00:00	1968-10-26	38000177		0	0	14		0	0	0	77734	0	1652673	46233988		
36607	3020	19075601	1997-01-08	1997-01-08 00:00:00	1997-01-08	1997-01-08 00:00:00	\N	38000177		0	0	0		0	0	0	201401	0	309362	19075601		
24647	2027	1127078	1962-03-12	1962-03-12 00:00:00	1962-03-26	1962-03-26 00:00:00	1962-03-26	38000177		0	0	14		0	0	0	134922	0	282464	1127078		
10168	217	40213227	2018-03-13	2018-03-13 00:00:00	2018-03-13	2018-03-13 00:00:00	2018-03-13	581452		0	0	0		0	0	0	14696	0	113	40213227		
23268	1917	1118084	1987-03-11	1987-03-11 00:00:00	1987-03-11	1987-03-11 00:00:00	\N	38000177		0	0	0		0	0	0	127541	0	00025152531	44923712		
22303	1834	40231925	1960-04-25	1960-04-25 00:00:00	1960-04-25	1960-04-25 00:00:00	\N	38000177		0	0	0		0	0	0	122541	0	1049221	40231925		
36309	793	40213314	1977-05-12	1977-05-12 00:00:00	1977-05-12	1977-05-12 00:00:00	1977-05-12	581452		0	0	0		0	0	0	52607	0	49	40213314		
26216	2155	40229134	2005-04-06	2005-04-06 00:00:00	2005-04-20	2005-04-20 00:00:00	2005-04-20	38000177		0	0	14		0	0	0	143603	0	1043400	40229134		
36714	3030	1127078	1984-02-12	1984-02-12 00:00:00	1984-02-26	1984-02-26 00:00:00	1984-02-26	38000177		0	0	14		0	0	0	201987	0	282464	1127078		
36747	3035	19133905	2007-11-08	2007-11-08 00:00:00	2007-11-15	2007-11-15 00:00:00	2007-11-15	38000177		0	0	7		0	0	0	202183	0	834102	19133905		
60697	5048	1127433	2002-05-15	2002-05-15 00:00:00	2002-05-22	2002-05-22 00:00:00	2002-05-22	38000177		0	0	7		0	0	0	335442	0	313782	1127433		
4616	384	1127078	1961-08-23	1961-08-23 00:00:00	1961-09-06	1961-09-06 00:00:00	1961-09-06	38000177		0	0	14		0	0	0	25294	0	282464	1127078		
35729	2944	19059056	1991-07-02	1991-07-02 00:00:00	1991-08-06	1991-08-06 00:00:00	1991-08-06	38000177		0	0	35		0	0	0	196396	0	243670	19059056		
52090	4330	1713671	2015-09-30	2015-09-30 00:00:00	2015-10-21	2015-10-21 00:00:00	2015-10-21	38000177		0	0	21		0	0	0	287198	0	562251	1713671		
6874	578	40232448	1971-06-20	1971-06-20 00:00:00	1971-06-20	1971-06-20 00:00:00	\N	38000177		0	0	0		0	0	0	38266	0	1049630	40232448		
6910	580	1713671	1958-03-24	1958-03-24 00:00:00	1958-03-31	1958-03-31 00:00:00	1958-03-31	38000177		0	0	7		0	0	0	38457	0	562251	1713671		
33558	2777	1127433	2015-10-20	2015-10-20 00:00:00	2015-11-09	2015-11-09 00:00:00	2015-11-09	38000177		0	0	20		0	0	0	183938	0	313782	1127433		
239528	5257	40213314	1978-06-21	1978-06-21 00:00:00	1978-06-21	1978-06-21 00:00:00	1978-06-21	581452		0	0	0		0	0	0	349792	0	49	40213314		
1194	96	19059056	1942-12-23	1942-12-23 00:00:00	1943-01-06	1943-01-06 00:00:00	1943-01-06	38000177		0	0	14		0	0	0	6532	0	243670	19059056		
56959	4725	40232448	1976-10-13	1976-10-13 00:00:00	1976-10-13	1976-10-13 00:00:00	\N	38000177		0	0	0		0	0	0	314889	0	1049630	40232448		
44199	3658	1127433	2005-05-17	2005-05-17 00:00:00	2005-05-31	2005-05-31 00:00:00	2005-05-31	38000177		0	0	14		0	0	0	243508	0	313782	1127433		
19354	1597	1118084	1981-04-06	1981-04-06 00:00:00	1981-04-06	1981-04-06 00:00:00	\N	38000177		0	0	0		0	0	0	107177	0	00025152531	44923712		
19414	1600	1127433	1971-10-02	1971-10-02 00:00:00	1971-12-31	1971-12-31 00:00:00	1971-12-31	38000177		0	0	90		0	0	0	107369	0	313782	1127433		
44097	3650	19078461	1992-05-26	1992-05-26 00:00:00	1992-06-16	1992-06-16 00:00:00	1992-06-16	38000177		0	0	21		0	0	0	242938	0	310965	19078461		
37059	3064	1127433	1995-01-03	1995-01-03 00:00:00	1995-01-10	1995-01-10 00:00:00	1995-01-10	38000177		0	0	7		0	0	0	203941	0	313782	1127433		
17153	370	40213160	1968-04-11	1968-04-11 00:00:00	1968-04-11	1968-04-11 00:00:00	1968-04-11	581452		0	0	0		0	0	0	24626	0	10	40213160		
37156	3070	1127433	2001-09-04	2001-09-04 00:00:00	2001-09-18	2001-09-18 00:00:00	2001-09-18	38000177		0	0	14		0	0	0	204387	0	313782	1127433		
21720	1782	1713671	1997-10-22	1997-10-22 00:00:00	1997-10-29	1997-10-29 00:00:00	1997-10-29	38000177		0	0	7		0	0	0	119347	0	562251	1713671		
12924	1086	19133873	1970-02-17	1970-02-17 00:00:00	1970-03-01	1970-03-01 00:00:00	1970-03-01	38000177		0	0	12		0	0	0	71311	0	834061	19133873		
32267	2675	1713671	1999-10-12	1999-10-12 00:00:00	1999-10-19	1999-10-19 00:00:00	1999-10-19	38000177		0	0	7		0	0	0	177291	0	562251	1713671		
32354	2682	1127433	2009-12-01	2009-12-01 00:00:00	2009-12-08	2009-12-08 00:00:00	2009-12-08	38000177		0	0	7		0	0	0	177712	0	313782	1127433		
30525	2530	19059056	1968-03-06	1968-03-06 00:00:00	1968-04-10	1968-04-10 00:00:00	1968-04-10	38000177		0	0	35		0	0	0	167220	0	243670	19059056		
59970	4986	1713671	2005-02-07	2005-02-07 00:00:00	2005-02-21	2005-02-21 00:00:00	2005-02-21	38000177		0	0	14		0	0	0	331695	0	562251	1713671		
23966	1973	1713671	1983-03-01	1983-03-01 00:00:00	1983-03-08	1983-03-08 00:00:00	1983-03-08	38000177		0	0	7		0	0	0	131189	0	562251	1713671		
17191	1427	19059056	1958-09-24	1958-09-24 00:00:00	1958-11-23	1958-11-23 00:00:00	1958-11-23	38000177		0	0	60		0	0	0	94957	0	243670	19059056		
17238	1430	1127433	2017-11-18	2017-11-18 00:00:00	2017-12-02	2017-12-02 00:00:00	2017-12-02	38000177		0	0	14		0	0	0	95133	0	313782	1127433		
40475	3355	40165015	1977-11-15	1977-11-15 00:00:00	1977-11-15	1977-11-15 00:00:00	\N	38000177		0	0	0		0	0	0	222506	0	861467	40165015		
3317	273	19078461	2019-02-25	2019-02-25 00:00:00	2019-04-01	2019-04-01 00:00:00	2019-04-01	38000177		0	0	35		0	0	0	18325	0	310965	19078461		
37567	3106	19006318	1952-01-01	1952-01-01 00:00:00	1952-01-15	1952-01-15 00:00:00	1952-01-15	38000177		0	0	14		0	0	0	206603	0	105078	19006318		
53948	4482	1127433	1952-04-13	1952-04-13 00:00:00	1952-04-27	1952-04-27 00:00:00	1952-04-27	38000177		0	0	14		0	0	0	298406	0	313782	1127433		
7131	600	1127433	1987-04-09	1987-04-09 00:00:00	1987-04-16	1987-04-16 00:00:00	1987-04-16	38000177		0	0	7		0	0	0	39573	0	313782	1127433		
38444	3177	1127433	2006-04-08	2006-04-08 00:00:00	2006-04-15	2006-04-15 00:00:00	2006-04-15	38000177		0	0	7		0	0	0	211272	0	313782	1127433		
6301	526	19128065	1988-02-05	1988-02-05 00:00:00	1989-01-30	1989-01-30 00:00:00	1989-01-30	38000177		0	0	360		0	0	0	35067	0	749882	19128065		
108	7	19059056	1969-10-02	1969-10-02 00:00:00	1969-10-23	1969-10-23 00:00:00	1969-10-23	38000177		0	0	21		0	0	0	635	0	243670	19059056		
17856	1478	1154029	1975-05-03	1975-05-03 00:00:00	1975-05-03	1975-05-03 00:00:00	1975-05-03	38000177		0	0	0		0	0	0	98639	0	4337	1154029		
37887	3132	1127433	1999-08-09	1999-08-09 00:00:00	1999-09-13	1999-09-13 00:00:00	1999-09-13	38000177		0	0	35		0	0	0	208387	0	313782	1127433		
37929	3135	1127433	1963-09-05	1963-09-05 00:00:00	1963-09-12	1963-09-12 00:00:00	1963-09-12	38000177		0	0	7		0	0	0	208680	0	313782	1127433		
14680	1229	1127433	2001-08-24	2001-08-24 00:00:00	2001-09-07	2001-09-07 00:00:00	2001-09-07	38000177		0	0	14		0	0	0	81008	0	313782	1127433		
14734	1232	19133905	2001-09-28	2001-09-28 00:00:00	2001-10-10	2001-10-10 00:00:00	2001-10-10	38000177		0	0	12		0	0	0	81222	0	834102	19133905		
31342	2598	1127433	1986-09-02	1986-09-02 00:00:00	1986-10-02	1986-10-02 00:00:00	1986-10-02	38000177		0	0	30		0	0	0	171921	0	313782	1127433		
53997	4487	1127433	1980-09-01	1980-09-01 00:00:00	1980-09-08	1980-09-08 00:00:00	1980-09-08	38000177		0	0	7		0	0	0	298700	0	313782	1127433		
2378	53	40213260	2014-03-12	2014-03-12 00:00:00	2014-03-12	2014-03-12 00:00:00	2014-03-12	581452		0	0	0		0	0	0	3665	0	121	40213260		
21791	1789	40169216	1979-03-05	1979-03-05 00:00:00	1979-03-05	1979-03-05 00:00:00	\N	38000177		0	0	0		0	0	0	119860	0	895994	40169216		
41963	3477	1127433	1969-03-18	1969-03-18 00:00:00	1969-03-25	1969-03-25 00:00:00	1969-03-25	38000177		0	0	7		0	0	0	230600	0	313782	1127433		
12954	1088	1127433	1989-03-15	1989-03-15 00:00:00	1989-04-12	1989-04-12 00:00:00	1989-04-12	38000177		0	0	28		0	0	0	71424	0	313782	1127433		
32412	2686	19133905	2011-03-25	2011-03-25 00:00:00	2011-04-04	2011-04-04 00:00:00	2011-04-04	38000177		0	0	10		0	0	0	177998	0	834102	19133905		
34997	2891	1127433	1993-10-29	1993-10-29 00:00:00	1993-11-19	1993-11-19 00:00:00	1993-11-19	38000177		0	0	21		0	0	0	192315	0	313782	1127433		
10223	857	1310034	1983-09-18	1983-09-18 00:00:00	1983-09-18	1983-09-18 00:00:00	1983-09-18	38000177		0	0	0		0	0	0	56579	0	834357	1310034		
45547	3769	1127433	2019-03-20	2019-03-20 00:00:00	2019-04-03	2019-04-03 00:00:00	2019-04-03	38000177		0	0	14		0	0	0	250580	0	313782	1127433		
2906	235	19133873	1988-12-02	1988-12-02 00:00:00	1988-12-14	1988-12-14 00:00:00	1988-12-14	38000177		0	0	12		0	0	0	15781	0	834061	19133873		
21724	472	40213251	1984-01-22	1984-01-22 00:00:00	1984-01-22	1984-01-22 00:00:00	1984-01-22	581452		0	0	0		0	0	0	31541	0	21	40213251		
149318	3285	40213296	2000-03-04	2000-03-04 00:00:00	2000-03-04	2000-03-04 00:00:00	2000-03-04	581452		0	0	0		0	0	0	218239	0	52	40213296		
28746	2373	1713671	1978-08-10	1978-08-10 00:00:00	1978-08-31	1978-08-31 00:00:00	1978-08-31	38000177		0	0	21		0	0	0	157950	0	562251	1713671		
43993	958	40213160	1957-04-14	1957-04-14 00:00:00	1957-04-14	1957-04-14 00:00:00	1957-04-14	581452		0	0	0		0	0	0	63603	0	10	40213160		
14096	1177	19059056	1964-01-24	1964-01-24 00:00:00	1964-02-07	1964-02-07 00:00:00	1964-02-07	38000177		0	0	14		0	0	0	77801	0	243670	19059056		
36608	3020	19006318	1959-01-04	1959-01-04 00:00:00	1959-01-18	1959-01-18 00:00:00	1959-01-18	38000177		0	0	14		0	0	0	201396	0	105078	19006318		
24648	2027	1127433	2002-11-03	2002-11-03 00:00:00	2002-11-10	2002-11-10 00:00:00	2002-11-10	38000177		0	0	7		0	0	0	134879	0	313782	1127433		
10169	217	40213296	2018-03-13	2018-03-13 00:00:00	2018-03-13	2018-03-13 00:00:00	2018-03-13	581452		0	0	0		0	0	0	14696	0	52	40213296		
23269	1917	1127433	1982-08-08	1982-08-08 00:00:00	1982-08-22	1982-08-22 00:00:00	1982-08-22	38000177		0	0	14		0	0	0	127513	0	313782	1127433		
22304	1834	19059056	1960-04-25	1960-04-25 00:00:00	1960-06-24	1960-06-24 00:00:00	1960-06-24	38000177		0	0	60		0	0	0	122541	0	243670	19059056		
36315	793	40213227	1996-08-22	1996-08-22 00:00:00	1996-08-22	1996-08-22 00:00:00	1996-08-22	581452		0	0	0		0	0	0	52657	0	113	40213227		
26217	2156	40165015	1988-04-18	1988-04-18 00:00:00	1988-04-18	1988-04-18 00:00:00	\N	38000177		0	0	0		0	0	0	143732	0	861467	40165015		
36715	3030	19074843	1984-02-12	1984-02-12 00:00:00	1984-02-26	1984-02-26 00:00:00	1984-02-26	38000177		0	0	14		0	0	0	201987	0	309045	19074843		
36748	3035	1118084	2004-09-30	2004-09-30 00:00:00	2004-09-30	2004-09-30 00:00:00	\N	38000177		0	0	0		0	0	0	202208	0	00025152531	44923712		
60698	5048	1127433	1975-11-22	1975-11-22 00:00:00	1975-12-06	1975-12-06 00:00:00	1975-12-06	38000177		0	0	14		0	0	0	335502	0	313782	1127433		
4617	384	19129655	1961-08-23	1961-08-23 00:00:00	1961-09-06	1961-09-06 00:00:00	1961-09-06	38000177		0	0	14		0	0	0	25294	0	789980	19129655		
35730	2944	1118084	1997-09-13	1997-09-13 00:00:00	1997-09-13	1997-09-13 00:00:00	\N	38000177		0	0	0		0	0	0	196398	0	00025152531	44923712		
52091	4330	1127433	2000-01-04	2000-01-04 00:00:00	2000-01-11	2000-01-11 00:00:00	2000-01-11	38000177		0	0	7		0	0	0	287213	0	313782	1127433		
6875	578	19128065	1984-05-11	1984-05-11 00:00:00	1985-05-06	1985-05-06 00:00:00	1985-05-06	38000177		0	0	360		0	0	0	38257	0	749882	19128065		
6919	582	19078461	1977-06-08	1977-06-08 00:00:00	1977-06-22	1977-06-22 00:00:00	1977-06-22	38000177		0	0	14		0	0	0	38533	0	310965	19078461		
33559	2777	1115171	2007-02-03	2007-02-03 00:00:00	2007-03-05	2007-03-05 00:00:00	2007-03-05	38000177		0	0	30		0	0	0	183937	0	849574	1115171		
239529	5257	40213160	1978-06-21	1978-06-21 00:00:00	1978-06-21	1978-06-21 00:00:00	1978-06-21	581452		0	0	0		0	0	0	349792	0	10	40213160		
1195	96	1127433	1962-05-22	1962-05-22 00:00:00	1962-05-29	1962-05-29 00:00:00	1962-05-29	38000177		0	0	7		0	0	0	6551	0	313782	1127433		
56960	4725	19059056	1988-09-07	1988-09-07 00:00:00	1988-09-28	1988-09-28 00:00:00	1988-09-28	38000177		0	0	21		0	0	0	314865	0	243670	19059056		
44200	3658	1127433	1992-12-10	1992-12-10 00:00:00	1992-12-17	1992-12-17 00:00:00	1992-12-17	38000177		0	0	7		0	0	0	243439	0	313782	1127433		
19355	1597	1551192	1945-04-25	1945-04-25 00:00:00	1945-04-25	1945-04-25 00:00:00	1945-04-25	38000177		0	0	0		0	0	0	107113	0	312617	1551192		
19415	1600	40236824	1984-12-20	1984-12-20 00:00:00	1984-12-27	1984-12-27 00:00:00	1984-12-27	38000177		0	0	7		0	0	0	107437	0	1094107	40236824		
44098	3650	1127433	1955-09-30	1955-09-30 00:00:00	1955-10-14	1955-10-14 00:00:00	1955-10-14	38000177		0	0	14		0	0	0	242987	0	313782	1127433		
37060	3064	1127433	1993-03-01	1993-03-01 00:00:00	1993-03-22	1993-03-22 00:00:00	1993-03-22	38000177		0	0	21		0	0	0	204002	0	313782	1127433		
17162	370	40213260	2013-05-02	2013-05-02 00:00:00	2013-05-02	2013-05-02 00:00:00	2013-05-02	581452		0	0	0		0	0	0	24617	0	121	40213260		
37157	3070	1127433	1986-12-11	1986-12-11 00:00:00	1986-12-18	1986-12-18 00:00:00	1986-12-18	38000177		0	0	7		0	0	0	204362	0	313782	1127433		
21721	1782	1127078	1961-09-09	1961-09-09 00:00:00	1961-12-08	1961-12-08 00:00:00	1961-12-08	38000177		0	0	90		0	0	0	119340	0	282464	1127078		
12925	1086	19078461	2012-03-20	2012-03-20 00:00:00	2012-04-24	2012-04-24 00:00:00	2012-04-24	38000177		0	0	35		0	0	0	71350	0	310965	19078461		
32268	2675	1713671	1963-12-24	1963-12-24 00:00:00	1963-12-31	1963-12-31 00:00:00	1963-12-31	38000177		0	0	7		0	0	0	177265	0	562251	1713671		
32355	2682	1127433	1989-09-24	1989-09-24 00:00:00	1989-10-29	1989-10-29 00:00:00	1989-10-29	38000177		0	0	35		0	0	0	177725	0	313782	1127433		
30526	2530	1127078	1970-12-26	1970-12-26 00:00:00	1971-01-30	1971-01-30 00:00:00	1971-01-30	38000177		0	0	35		0	0	0	167221	0	282464	1127078		
59972	4986	1713671	2015-08-04	2015-08-04 00:00:00	2015-08-18	2015-08-18 00:00:00	2015-08-18	38000177		0	0	14		0	0	0	331696	0	562251	1713671		
23967	1973	1127433	1985-08-24	1985-08-24 00:00:00	1985-09-07	1985-09-07 00:00:00	1985-09-07	38000177		0	0	14		0	0	0	131151	0	313782	1127433		
17192	1427	1713671	2011-03-15	2011-03-15 00:00:00	2011-04-05	2011-04-05 00:00:00	2011-04-05	38000177		0	0	21		0	0	0	94922	0	562251	1713671		
17239	1430	1127433	2000-09-02	2000-09-02 00:00:00	2000-09-16	2000-09-16 00:00:00	2000-09-16	38000177		0	0	14		0	0	0	95158	0	313782	1127433		
40476	3355	19133873	1964-09-28	1964-09-28 00:00:00	1964-10-10	1964-10-10 00:00:00	1964-10-10	38000177		0	0	12		0	0	0	222492	0	834061	19133873		
3318	273	19133905	2002-07-25	2002-07-25 00:00:00	2002-08-02	2002-08-02 00:00:00	2002-08-02	38000177		0	0	8		0	0	0	18295	0	834102	19133905		
37568	3106	19059056	1952-01-01	1952-01-01 00:00:00	1952-01-15	1952-01-15 00:00:00	1952-01-15	38000177		0	0	14		0	0	0	206603	0	243670	19059056		
53949	4482	19059056	1962-01-20	1962-01-20 00:00:00	1962-02-17	1962-02-17 00:00:00	1962-02-17	38000177		0	0	28		0	0	0	298391	0	243670	19059056		
7132	600	1127433	2012-08-25	2012-08-25 00:00:00	2012-09-15	2012-09-15 00:00:00	2012-09-15	38000177		0	0	21		0	0	0	39651	0	313782	1127433		
38445	3177	19133873	1931-11-14	1931-11-14 00:00:00	1931-11-25	1931-11-25 00:00:00	1931-11-25	38000177		0	0	11		0	0	0	211264	0	834061	19133873		
6302	526	1115171	2008-09-05	2008-09-05 00:00:00	2008-09-19	2008-09-19 00:00:00	2008-09-19	38000177		0	0	14		0	0	0	35104	0	849574	1115171		
109	7	1713671	1986-08-06	1986-08-06 00:00:00	1986-08-13	1986-08-13 00:00:00	1986-08-13	38000177		0	0	7		0	0	0	612	0	562251	1713671		
17857	1478	40220386	1975-05-03	1975-05-03 00:00:00	1975-05-03	1975-05-03 00:00:00	1975-05-03	38000177		0	0	0		0	0	0	98639	0	1808217	40220386		
37888	3133	19073188	2011-01-24	2011-01-24 00:00:00	2011-02-07	2011-02-07 00:00:00	2011-02-07	38000177		0	0	14		0	0	0	208479	0	308192	19073188		
37930	3135	1127433	2003-08-03	2003-08-03 00:00:00	2003-08-10	2003-08-10 00:00:00	2003-08-10	38000177		0	0	7		0	0	0	208687	0	313782	1127433		
14681	1229	1713671	2011-05-10	2011-05-10 00:00:00	2011-05-31	2011-05-31 00:00:00	2011-05-31	38000177		0	0	21		0	0	0	80959	0	562251	1713671		
14735	1232	19059056	1971-10-09	1971-10-09 00:00:00	1971-11-08	1971-11-08 00:00:00	1971-11-08	38000177		0	0	30		0	0	0	81184	0	243670	19059056		
31343	2598	1127433	2003-07-19	2003-07-19 00:00:00	2003-07-26	2003-07-26 00:00:00	2003-07-26	38000177		0	0	7		0	0	0	171895	0	313782	1127433		
53998	4487	1127433	1977-08-10	1977-08-10 00:00:00	1977-08-24	1977-08-24 00:00:00	1977-08-24	38000177		0	0	14		0	0	0	298685	0	313782	1127433		
2379	53	40213227	2014-03-12	2014-03-12 00:00:00	2014-03-12	2014-03-12 00:00:00	2014-03-12	581452		0	0	0		0	0	0	3665	0	113	40213227		
21792	1789	1154615	1979-03-05	1979-03-05 00:00:00	1979-03-05	1979-03-05 00:00:00	\N	38000177		0	0	0		0	0	0	119860	0	745679	1154615		
41964	3477	19078461	1995-11-25	1995-11-25 00:00:00	1995-12-23	1995-12-23 00:00:00	1995-12-23	38000177		0	0	28		0	0	0	230721	0	310965	19078461		
12955	1088	1127433	1985-06-23	1985-06-23 00:00:00	1985-06-30	1985-06-30 00:00:00	1985-06-30	38000177		0	0	7		0	0	0	71461	0	313782	1127433		
32413	2686	40229134	2005-07-09	2005-07-09 00:00:00	2005-07-23	2005-07-23 00:00:00	2005-07-23	38000177		0	0	14		0	0	0	177997	0	1043400	40229134		
34998	2891	19112599	1975-04-27	1975-04-27 00:00:00	1975-04-27	1975-04-27 00:00:00	\N	38000177		0	0	0		0	0	0	192353	0	477045	19112599		
10224	857	40243436	1983-09-18	1983-09-18 00:00:00	1983-09-18	1983-09-18 00:00:00	1983-09-18	38000177		0	0	0		0	0	0	56579	0	1190795	40243436		
45548	3769	1118084	1990-09-04	1990-09-04 00:00:00	1990-09-04	1990-09-04 00:00:00	\N	38000177		0	0	0		0	0	0	250511	0	00025152531	44923712		
2907	235	1127078	1984-07-24	1984-07-24 00:00:00	1984-08-07	1984-08-07 00:00:00	1984-08-07	38000177		0	0	14		0	0	0	15785	0	282464	1127078		
21731	472	40213314	1977-04-03	1977-04-03 00:00:00	1977-04-03	1977-04-03 00:00:00	1977-04-03	581452		0	0	0		0	0	0	31519	0	49	40213314		
149327	3285	40213306	1981-01-17	1981-01-17 00:00:00	1981-01-17	1981-01-17 00:00:00	1981-01-17	581452		0	0	0		0	0	0	218210	0	43	40213306		
28747	2373	1713671	2003-10-14	2003-10-14 00:00:00	2003-11-04	2003-11-04 00:00:00	2003-11-04	38000177		0	0	21		0	0	0	157941	0	562251	1713671		
44002	958	40213296	1998-02-01	1998-02-01 00:00:00	1998-02-01	1998-02-01 00:00:00	1998-02-01	581452		0	0	0		0	0	0	63627	0	52	40213296		
14097	1177	19129655	1964-01-24	1964-01-24 00:00:00	1964-02-07	1964-02-07 00:00:00	1964-02-07	38000177		0	0	14		0	0	0	77801	0	789980	19129655		
36609	3020	19059056	1959-01-04	1959-01-04 00:00:00	1959-01-18	1959-01-18 00:00:00	1959-01-18	38000177		0	0	14		0	0	0	201396	0	243670	19059056		
24649	2027	40229134	2019-01-04	2019-01-04 00:00:00	2019-01-18	2019-01-18 00:00:00	2019-01-18	38000177		0	0	14		0	0	0	134880	0	1043400	40229134		
10177	217	40213306	1997-09-16	1997-09-16 00:00:00	1997-09-16	1997-09-16 00:00:00	1997-09-16	581452		0	0	0		0	0	0	14641	0	43	40213306		
23270	1917	1713671	1955-04-10	1955-04-10 00:00:00	1955-04-17	1955-04-17 00:00:00	1955-04-17	38000177		0	0	7		0	0	0	127560	0	562251	1713671		
22305	1834	19059056	1955-11-18	1955-11-18 00:00:00	1955-12-18	1955-12-18 00:00:00	1955-12-18	38000177		0	0	30		0	0	0	122540	0	243670	19059056		
36316	793	40213306	1996-08-22	1996-08-22 00:00:00	1996-08-22	1996-08-22 00:00:00	1996-08-22	581452		0	0	0		0	0	0	52657	0	43	40213306		
26218	2156	19078461	1988-04-18	1988-04-18 00:00:00	1988-06-17	1988-06-17 00:00:00	1988-06-17	38000177		0	0	60		0	0	0	143732	0	310965	19078461		
36716	3030	1124300	2018-07-25	2018-07-25 00:00:00	2018-07-25	2018-07-25 00:00:00	\N	38000177		0	0	0		0	0	0	202000	0	00781178901	45011828		
36749	3035	1127433	2017-02-26	2017-02-26 00:00:00	2017-03-05	2017-03-05 00:00:00	2017-03-05	38000177		0	0	7		0	0	0	202213	0	313782	1127433		
60699	5048	1127078	1966-08-13	1966-08-13 00:00:00	1966-09-10	1966-09-10 00:00:00	1966-09-10	38000177		0	0	28		0	0	0	335501	0	282464	1127078		
4618	384	1127078	1967-12-25	1967-12-25 00:00:00	1968-01-08	1968-01-08 00:00:00	1968-01-08	38000177		0	0	14		0	0	0	25353	0	282464	1127078		
35731	2944	19128065	1977-01-11	1977-01-11 00:00:00	1978-01-06	1978-01-06 00:00:00	1978-01-06	38000177		0	0	360		0	0	0	196408	0	749882	19128065		
52092	4330	19059056	1946-01-21	1946-01-21 00:00:00	1946-02-04	1946-02-04 00:00:00	1946-02-04	38000177		0	0	14		0	0	0	287216	0	243670	19059056		
6876	578	19133873	1979-05-31	1979-05-31 00:00:00	1979-06-08	1979-06-08 00:00:00	1979-06-08	38000177		0	0	8		0	0	0	38278	0	834061	19133873		
6920	582	19006318	1977-06-08	1977-06-08 00:00:00	1977-06-22	1977-06-22 00:00:00	1977-06-22	38000177		0	0	14		0	0	0	38533	0	105078	19006318		
33560	2777	40229134	2000-08-30	2000-08-30 00:00:00	2000-09-13	2000-09-13 00:00:00	2000-09-13	38000177		0	0	14		0	0	0	183968	0	1043400	40229134		
239532	5258	40213306	1981-04-01	1981-04-01 00:00:00	1981-04-01	1981-04-01 00:00:00	1981-04-01	581452		0	0	0		0	0	0	349919	0	43	40213306		
1196	96	40169281	1954-05-29	1954-05-29 00:00:00	1954-05-29	1954-05-29 00:00:00	\N	38000177		0	0	0		0	0	0	6488	0	896209	40169281		
56961	4725	1127078	1979-07-29	1979-07-29 00:00:00	1979-08-26	1979-08-26 00:00:00	1979-08-26	38000177		0	0	28		0	0	0	314864	0	282464	1127078		
44201	3658	19078461	1977-05-09	1977-05-09 00:00:00	1977-05-30	1977-05-30 00:00:00	1977-05-30	38000177		0	0	21		0	0	0	243506	0	310965	19078461		
19356	1597	19133905	2003-04-12	2003-04-12 00:00:00	2003-04-23	2003-04-23 00:00:00	2003-04-23	38000177		0	0	11		0	0	0	107160	0	834102	19133905		
19416	1600	920300	1984-12-20	1984-12-20 00:00:00	1984-12-27	1984-12-27 00:00:00	1984-12-27	38000177		0	0	7		0	0	0	107437	0	311989	920300		
44099	3650	40173590	1997-05-30	1997-05-30 00:00:00	1997-05-30	1997-05-30 00:00:00	\N	38000177		0	0	0		0	0	0	242923	0	904419	40173590		
37061	3064	19078461	1990-07-01	1990-07-01 00:00:00	1990-07-15	1990-07-15 00:00:00	1990-07-15	38000177		0	0	14		0	0	0	204001	0	310965	19078461		
17165	370	40213296	2003-05-08	2003-05-08 00:00:00	2003-05-08	2003-05-08 00:00:00	2003-05-08	581452		0	0	0		0	0	0	24652	0	52	40213296		
37158	3070	1127433	2008-04-24	2008-04-24 00:00:00	2008-05-24	2008-05-24 00:00:00	2008-05-24	38000177		0	0	30		0	0	0	204326	0	313782	1127433		
21722	1783	40232448	1961-08-16	1961-08-16 00:00:00	1961-08-16	1961-08-16 00:00:00	\N	38000177		0	0	0		0	0	0	119420	0	1049630	40232448		
12926	1086	19059056	1967-06-01	1967-06-01 00:00:00	1967-06-15	1967-06-15 00:00:00	1967-06-15	38000177		0	0	14		0	0	0	71340	0	243670	19059056		
32269	2675	19078461	1992-01-01	1992-01-01 00:00:00	1992-01-15	1992-01-15 00:00:00	1992-01-15	38000177		0	0	14		0	0	0	177233	0	310965	19078461		
32356	2682	1127433	2014-07-16	2014-07-16 00:00:00	2014-07-30	2014-07-30 00:00:00	2014-07-30	38000177		0	0	14		0	0	0	177753	0	313782	1127433		
30527	2530	19059056	1965-03-04	1965-03-04 00:00:00	1965-03-18	1965-03-18 00:00:00	1965-03-18	38000177		0	0	14		0	0	0	167235	0	243670	19059056		
59973	4986	1127433	1959-07-23	1959-07-23 00:00:00	1959-08-06	1959-08-06 00:00:00	1959-08-06	38000177		0	0	14		0	0	0	331656	0	313782	1127433		
23968	1973	46233988	1974-03-23	1974-03-23 00:00:00	1974-04-06	1974-04-06 00:00:00	1974-04-06	38000177		0	0	14		0	0	0	131191	0	1652673	46233988		
17194	1427	1127433	1979-07-07	1979-07-07 00:00:00	1979-07-21	1979-07-21 00:00:00	1979-07-21	38000177		0	0	14		0	0	0	94920	0	313782	1127433		
17240	1430	40173590	2004-10-12	2004-10-12 00:00:00	2004-10-12	2004-10-12 00:00:00	\N	38000177		0	0	0		0	0	0	95168	0	904419	40173590		
40477	3355	1713671	1974-07-28	1974-07-28 00:00:00	1974-08-18	1974-08-18 00:00:00	1974-08-18	38000177		0	0	21		0	0	0	222479	0	562251	1713671		
3319	273	1713671	1996-07-06	1996-07-06 00:00:00	1996-07-27	1996-07-27 00:00:00	1996-07-27	38000177		0	0	21		0	0	0	18279	0	562251	1713671		
37569	3106	1127078	1951-07-05	1951-07-05 00:00:00	1951-08-02	1951-08-02 00:00:00	1951-08-02	38000177		0	0	28		0	0	0	206615	0	282464	1127078		
53950	4482	1127433	2003-10-08	2003-10-08 00:00:00	2003-10-22	2003-10-22 00:00:00	2003-10-22	38000177		0	0	14		0	0	0	298359	0	313782	1127433		
7133	600	40231925	2018-07-23	2018-07-23 00:00:00	2018-07-23	2018-07-23 00:00:00	\N	38000177		0	0	0		0	0	0	39643	0	1049221	40231925		
38446	3177	1127433	1936-05-16	1936-05-16 00:00:00	1936-05-30	1936-05-30 00:00:00	1936-05-30	38000177		0	0	14		0	0	0	211266	0	313782	1127433		
6303	526	1713671	2000-10-29	2000-10-29 00:00:00	2000-11-12	2000-11-12 00:00:00	2000-11-12	38000177		0	0	14		0	0	0	35052	0	562251	1713671		
110	7	46233988	1968-12-06	1968-12-06 00:00:00	1968-12-20	1968-12-20 00:00:00	1968-12-20	38000177		0	0	14		0	0	0	606	0	1652673	46233988		
17858	1478	19079524	1975-05-03	1975-05-03 00:00:00	1975-05-04	1975-05-04 00:00:00	1975-05-04	38000177		0	0	1		0	0	0	98639	0	313002	19079524		
37889	3133	1127433	2011-01-24	2011-01-24 00:00:00	2011-02-07	2011-02-07 00:00:00	2011-02-07	38000177		0	0	14		0	0	0	208479	0	313782	1127433		
37931	3135	1127433	2011-08-19	2011-08-19 00:00:00	2011-08-26	2011-08-26 00:00:00	2011-08-26	38000177		0	0	7		0	0	0	208707	0	313782	1127433		
14682	1229	40236824	1977-06-11	1977-06-11 00:00:00	1977-06-18	1977-06-18 00:00:00	1977-06-18	38000177		0	0	7		0	0	0	81011	0	1094107	40236824		
14736	1232	1127078	1968-12-08	1968-12-08 00:00:00	1968-12-22	1968-12-22 00:00:00	1968-12-22	38000177		0	0	14		0	0	0	81204	0	282464	1127078		
31344	2598	1127078	1976-02-27	1976-02-27 00:00:00	1976-03-12	1976-03-12 00:00:00	1976-03-12	38000177		0	0	14		0	0	0	171939	0	282464	1127078		
53999	4487	19059056	1962-07-27	1962-07-27 00:00:00	1962-08-17	1962-08-17 00:00:00	1962-08-17	38000177		0	0	21		0	0	0	298682	0	243670	19059056		
2385	53	40213296	2005-12-07	2005-12-07 00:00:00	2005-12-07	2005-12-07 00:00:00	2005-12-07	581452		0	0	0		0	0	0	3693	0	52	40213296		
21793	1789	19019979	1977-09-14	1977-09-14 00:00:00	1977-09-28	1977-09-28 00:00:00	1977-09-28	38000177		0	0	14		0	0	0	119879	0	198405	19019979		
41965	3477	40232448	1986-04-20	1986-04-20 00:00:00	1986-04-20	1986-04-20 00:00:00	\N	38000177		0	0	0		0	0	0	230612	0	1049630	40232448		
12956	1088	19128065	1992-06-25	1992-06-25 00:00:00	1993-06-20	1993-06-20 00:00:00	1993-06-20	38000177		0	0	360		0	0	0	71449	0	749882	19128065		
32414	2686	19059056	1967-12-02	1967-12-02 00:00:00	1967-12-16	1967-12-16 00:00:00	1967-12-16	38000177		0	0	14		0	0	0	178070	0	243670	19059056		
34999	2891	1713671	2002-07-15	2002-07-15 00:00:00	2002-08-05	2002-08-05 00:00:00	2002-08-05	38000177		0	0	21		0	0	0	192327	0	562251	1713671		
10226	857	19133873	1954-07-22	1954-07-22 00:00:00	1954-07-30	1954-07-30 00:00:00	1954-07-30	38000177		0	0	8		0	0	0	56628	0	834061	19133873		
45549	3769	1127433	1957-04-25	1957-04-25 00:00:00	1957-05-09	1957-05-09 00:00:00	1957-05-09	38000177		0	0	14		0	0	0	250537	0	313782	1127433		
2908	235	19073183	1984-07-24	1984-07-24 00:00:00	1984-08-07	1984-08-07 00:00:00	1984-08-07	38000177		0	0	14		0	0	0	15785	0	308182	19073183		
57109	4738	40229134	1917-11-05	1917-11-05 00:00:00	1917-11-12	1917-11-12 00:00:00	1917-11-12	38000177		0	0	7		0	0	0	315640	0	1043400	40229134		
1003	82	19128065	1976-03-12	1976-03-12 00:00:00	1977-03-07	1977-03-07 00:00:00	1977-03-07	38000177		0	0	360		0	0	0	5579	0	749882	19128065		
28748	2373	1124300	1997-10-25	1997-10-25 00:00:00	1997-10-25	1997-10-25 00:00:00	\N	38000177		0	0	0		0	0	0	157892	0	00781178901	45011828		
44004	958	40213227	1998-02-01	1998-02-01 00:00:00	1998-02-01	1998-02-01 00:00:00	1998-02-01	581452		0	0	0		0	0	0	63627	0	113	40213227		
14098	1177	1713671	2008-01-30	2008-01-30 00:00:00	2008-02-20	2008-02-20 00:00:00	2008-02-20	38000177		0	0	21		0	0	0	77764	0	562251	1713671		
36610	3022	1127433	2011-11-08	2011-11-08 00:00:00	2011-11-22	2011-11-22 00:00:00	2011-11-22	38000177		0	0	14		0	0	0	201470	0	313782	1127433		
24650	2027	19133873	1969-01-15	1969-01-15 00:00:00	1969-01-25	1969-01-25 00:00:00	1969-01-25	38000177		0	0	10		0	0	0	134869	0	834061	19133873		
10179	217	40213160	1975-07-15	1975-07-15 00:00:00	1975-07-15	1975-07-15 00:00:00	1975-07-15	581452		0	0	0		0	0	0	14653	0	10	40213160		
23271	1917	1713671	1999-09-17	1999-09-17 00:00:00	1999-10-01	1999-10-01 00:00:00	1999-10-01	38000177		0	0	14		0	0	0	127528	0	562251	1713671		
22306	1834	19133905	2016-05-17	2016-05-17 00:00:00	2016-05-30	2016-05-30 00:00:00	2016-05-30	38000177		0	0	13		0	0	0	122517	0	834102	19133905		
36320	793	40213306	1993-08-19	1993-08-19 00:00:00	1993-08-19	1993-08-19 00:00:00	1993-08-19	581452		0	0	0		0	0	0	52656	0	43	40213306		
26219	2156	920300	2008-08-17	2008-08-17 00:00:00	2008-08-24	2008-08-24 00:00:00	2008-08-24	38000177		0	0	7		0	0	0	143715	0	311989	920300		
36717	3030	19019979	1981-10-17	1981-10-17 00:00:00	1981-10-31	1981-10-31 00:00:00	1981-10-31	38000177		0	0	14		0	0	0	202002	0	198405	19019979		
36750	3035	19059056	1990-04-08	1990-04-08 00:00:00	1990-04-22	1990-04-22 00:00:00	1990-04-22	38000177		0	0	14		0	0	0	202187	0	243670	19059056		
60700	5048	19006318	1961-07-10	1961-07-10 00:00:00	1961-07-24	1961-07-24 00:00:00	1961-07-24	38000177		0	0	14		0	0	0	335445	0	105078	19006318		
4619	384	1118084	1996-05-11	1996-05-11 00:00:00	1996-05-11	1996-05-11 00:00:00	\N	38000177		0	0	0		0	0	0	25285	0	00025152531	44923712		
35732	2944	1127433	2010-10-07	2010-10-07 00:00:00	2010-10-21	2010-10-21 00:00:00	2010-10-21	38000177		0	0	14		0	0	0	196412	0	313782	1127433		
52093	4330	1713671	2013-08-15	2013-08-15 00:00:00	2013-09-05	2013-09-05 00:00:00	2013-09-05	38000177		0	0	21		0	0	0	287241	0	562251	1713671		
18346	399	40213160	1955-09-11	1955-09-11 00:00:00	1955-09-11	1955-09-11 00:00:00	1955-09-11	581452		0	0	0		0	0	0	26158	0	10	40213160		
6921	582	19133905	2014-04-02	2014-04-02 00:00:00	2014-04-14	2014-04-14 00:00:00	2014-04-14	38000177		0	0	12		0	0	0	38583	0	834102	19133905		
33561	2777	19078461	1999-05-03	1999-05-03 00:00:00	1999-05-17	1999-05-17 00:00:00	1999-05-17	38000177		0	0	14		0	0	0	183936	0	310965	19078461		
239535	5258	40213160	1959-01-07	1959-01-07 00:00:00	1959-01-07	1959-01-07 00:00:00	1959-01-07	581452		0	0	0		0	0	0	349924	0	10	40213160		
1197	96	19059056	1931-07-24	1931-07-24 00:00:00	1931-08-23	1931-08-23 00:00:00	1931-08-23	38000177		0	0	30		0	0	0	6502	0	243670	19059056		
56962	4725	1124300	2009-07-31	2009-07-31 00:00:00	2009-07-31	2009-07-31 00:00:00	\N	38000177		0	0	0		0	0	0	314929	0	00781178901	45011828		
44212	3660	1115171	1999-12-22	1999-12-22 00:00:00	2000-01-12	2000-01-12 00:00:00	2000-01-12	38000177		0	0	21		0	0	0	243607	0	849574	1115171		
19357	1597	1551192	1948-11-08	1948-11-08 00:00:00	1948-11-08	1948-11-08 00:00:00	1948-11-08	38000177		0	0	0		0	0	0	107114	0	312617	1551192		
19417	1600	19133873	1959-11-30	1959-11-30 00:00:00	1959-12-13	1959-12-13 00:00:00	1959-12-13	38000177		0	0	13		0	0	0	107440	0	834061	19133873		
44100	3650	19059056	1940-11-04	1940-11-04 00:00:00	1940-12-04	1940-12-04 00:00:00	1940-12-04	38000177		0	0	30		0	0	0	242935	0	243670	19059056		
37062	3064	19059056	1936-08-28	1936-08-28 00:00:00	1936-10-02	1936-10-02 00:00:00	1936-10-02	38000177		0	0	35		0	0	0	203993	0	243670	19059056		
17166	370	40213160	1963-08-08	1963-08-08 00:00:00	1963-08-08	1963-08-08 00:00:00	1963-08-08	581452		0	0	0		0	0	0	24591	0	10	40213160		
37164	3072	1115171	1995-11-27	1995-11-27 00:00:00	1995-12-27	1995-12-27 00:00:00	1995-12-27	38000177		0	0	30		0	0	0	204461	0	849574	1115171		
21723	1783	40169216	1961-08-02	1961-08-02 00:00:00	1961-08-02	1961-08-02 00:00:00	\N	38000177		0	0	0		0	0	0	119420	0	895994	40169216		
12927	1086	46233988	1967-06-01	1967-06-01 00:00:00	1967-06-15	1967-06-15 00:00:00	1967-06-15	38000177		0	0	14		0	0	0	71340	0	1652673	46233988		
32270	2675	1118084	2002-01-04	2002-01-04 00:00:00	2002-01-04	2002-01-04 00:00:00	\N	38000177		0	0	0		0	0	0	177241	0	00025152531	44923712		
32597	2702	1127433	2000-02-20	2000-02-20 00:00:00	2000-02-27	2000-02-27 00:00:00	2000-02-27	38000177		0	0	7		0	0	0	178936	0	313782	1127433		
39976	871	40213160	1966-09-27	1966-09-27 00:00:00	1966-09-27	1966-09-27 00:00:00	1966-09-27	581452		0	0	0		0	0	0	57945	0	10	40213160		
59975	4986	40236446	1960-04-20	1960-04-20 00:00:00	1968-04-28	1968-04-28 00:00:00	1968-04-28	38000177		0	0	2930		0	0	0	331651	0	1091392	40236446		
23969	1973	19059056	1974-03-23	1974-03-23 00:00:00	1974-04-06	1974-04-06 00:00:00	1974-04-06	38000177		0	0	14		0	0	0	131191	0	243670	19059056		
17195	1427	1127433	2011-07-20	2011-07-20 00:00:00	2011-07-27	2011-07-27 00:00:00	2011-07-27	38000177		0	0	7		0	0	0	94932	0	313782	1127433		
17241	1430	1713671	1958-02-23	1958-02-23 00:00:00	1958-03-16	1958-03-16 00:00:00	1958-03-16	38000177		0	0	21		0	0	0	95129	0	562251	1713671		
40478	3355	19059056	1963-05-03	1963-05-03 00:00:00	1963-05-17	1963-05-17 00:00:00	1963-05-17	38000177		0	0	14		0	0	0	222465	0	243670	19059056		
3320	273	40229134	2014-03-27	2014-03-27 00:00:00	2014-04-10	2014-04-10 00:00:00	2014-04-10	38000177		0	0	14		0	0	0	18224	0	1043400	40229134		
37570	3106	1127078	1957-03-03	1957-03-03 00:00:00	1957-03-31	1957-03-31 00:00:00	1957-03-31	38000177		0	0	28		0	0	0	206616	0	282464	1127078		
87146	1911	40213227	1997-09-01	1997-09-01 00:00:00	1997-09-01	1997-09-01 00:00:00	1997-09-01	581452		0	0	0		0	0	0	127138	0	113	40213227		
7134	600	1127433	1994-11-07	1994-11-07 00:00:00	1994-11-28	1994-11-28 00:00:00	1994-11-28	38000177		0	0	21		0	0	0	39648	0	313782	1127433		
38447	3177	1124300	1950-04-27	1950-04-27 00:00:00	1950-04-27	1950-04-27 00:00:00	\N	38000177		0	0	0		0	0	0	211297	0	00781178901	45011828		
6304	526	1118084	2002-04-12	2002-04-12 00:00:00	2002-04-12	2002-04-12 00:00:00	\N	38000177		0	0	0		0	0	0	35052	0	00025152531	44923712		
111	7	19059056	1968-12-06	1968-12-06 00:00:00	1968-12-20	1968-12-20 00:00:00	1968-12-20	38000177		0	0	14		0	0	0	606	0	243670	19059056		
17859	1478	42707627	1975-05-03	1975-05-03 00:00:00	1975-05-03	1975-05-03 00:00:00	1975-05-03	38000177		0	0	0		0	0	0	98639	0	1234995	42707627		
37890	3133	19133873	1960-07-03	1960-07-03 00:00:00	1960-07-16	1960-07-16 00:00:00	1960-07-16	38000177		0	0	13		0	0	0	208442	0	834061	19133873		
37932	3135	19078461	2001-07-16	2001-07-16 00:00:00	2001-07-30	2001-07-30 00:00:00	2001-07-30	38000177		0	0	14		0	0	0	208695	0	310965	19078461		
14683	1229	920300	1977-06-11	1977-06-11 00:00:00	1977-06-18	1977-06-18 00:00:00	1977-06-18	38000177		0	0	7		0	0	0	81011	0	311989	920300		
14737	1232	1124300	2003-01-19	2003-01-19 00:00:00	2003-01-19	2003-01-19 00:00:00	\N	38000177		0	0	0		0	0	0	81213	0	00781178901	45011828		
31345	2598	46233988	1976-02-27	1976-02-27 00:00:00	1976-03-12	1976-03-12 00:00:00	1976-03-12	38000177		0	0	14		0	0	0	171939	0	1652673	46233988		
54000	4487	1118084	1988-01-22	1988-01-22 00:00:00	1988-01-22	1988-01-22 00:00:00	\N	38000177		0	0	0		0	0	0	298752	0	00025152531	44923712		
2391	53	40213227	2003-12-03	2003-12-03 00:00:00	2003-12-03	2003-12-03 00:00:00	2003-12-03	581452		0	0	0		0	0	0	3679	0	113	40213227		
21794	1789	19129655	1977-09-14	1977-09-14 00:00:00	1977-09-28	1977-09-28 00:00:00	1977-09-28	38000177		0	0	14		0	0	0	119879	0	789980	19129655		
41966	3477	1713671	1993-06-28	1993-06-28 00:00:00	1993-07-05	1993-07-05 00:00:00	1993-07-05	38000177		0	0	7		0	0	0	230710	0	562251	1713671		
12957	1088	1118084	2011-07-11	2011-07-11 00:00:00	2011-07-11	2011-07-11 00:00:00	\N	38000177		0	0	0		0	0	0	71411	0	00025152531	44923712		
32415	2686	19078461	1998-06-27	1998-06-27 00:00:00	1998-07-11	1998-07-11 00:00:00	1998-07-11	38000177		0	0	14		0	0	0	178073	0	310965	19078461		
35000	2891	1127433	2017-02-07	2017-02-07 00:00:00	2017-02-28	2017-02-28 00:00:00	2017-02-28	38000177		0	0	21		0	0	0	192316	0	313782	1127433		
10227	857	1713671	1981-02-23	1981-02-23 00:00:00	1981-06-15	1981-06-15 00:00:00	1981-06-15	38000177		0	0	112		0	0	0	56661	0	562251	1713671		
45550	3769	40229134	1981-07-29	1981-07-29 00:00:00	1981-08-05	1981-08-05 00:00:00	1981-08-05	38000177		0	0	7		0	0	0	250522	0	1043400	40229134		
2909	235	1127078	1985-05-13	1985-05-13 00:00:00	1985-05-27	1985-05-27 00:00:00	1985-05-27	38000177		0	0	14		0	0	0	15746	0	282464	1127078		
57110	4739	40229134	1938-11-26	1938-11-26 00:00:00	1938-12-10	1938-12-10 00:00:00	1938-12-10	38000177		0	0	14		0	0	0	315683	0	1043400	40229134		
1004	82	40236824	2006-04-24	2006-04-24 00:00:00	2006-05-01	2006-05-01 00:00:00	2006-05-01	38000177		0	0	7		0	0	0	5551	0	1094107	40236824		
28749	2373	1127433	1969-08-13	1969-08-13 00:00:00	1969-09-12	1969-09-12 00:00:00	1969-09-12	38000177		0	0	30		0	0	0	157946	0	313782	1127433		
44009	959	40213160	1958-07-02	1958-07-02 00:00:00	1958-07-02	1958-07-02 00:00:00	1958-07-02	581452		0	0	0		0	0	0	63728	0	10	40213160		
14099	1177	19128065	1980-04-17	1980-04-17 00:00:00	1981-04-12	1981-04-12 00:00:00	1981-04-12	38000177		0	0	360		0	0	0	77802	0	749882	19128065		
36611	3022	19019979	1975-04-20	1975-04-20 00:00:00	1975-05-25	1975-05-25 00:00:00	1975-05-25	38000177		0	0	35		0	0	0	201466	0	198405	19019979		
24651	2027	1127433	1963-04-16	1963-04-16 00:00:00	1963-04-30	1963-04-30 00:00:00	1963-04-30	38000177		0	0	14		0	0	0	134867	0	313782	1127433		
10183	217	40213160	1975-09-16	1975-09-16 00:00:00	1975-09-16	1975-09-16 00:00:00	1975-09-16	581452		0	0	0		0	0	0	14656	0	10	40213160		
23272	1917	1127433	1955-11-30	1955-11-30 00:00:00	1955-12-07	1955-12-07 00:00:00	1955-12-07	38000177		0	0	7		0	0	0	127527	0	313782	1127433		
22307	1834	19133905	1985-01-13	1985-01-13 00:00:00	1985-01-21	1985-01-21 00:00:00	1985-01-21	38000177		0	0	8		0	0	0	122483	0	834102	19133905		
36321	793	40213227	2006-03-09	2006-03-09 00:00:00	2006-03-09	2006-03-09 00:00:00	2006-03-09	581452		0	0	0		0	0	0	52659	0	113	40213227		
26220	2156	40236824	2008-08-17	2008-08-17 00:00:00	2008-08-24	2008-08-24 00:00:00	2008-08-24	38000177		0	0	7		0	0	0	143715	0	1094107	40236824		
36718	3030	19074843	1981-10-17	1981-10-17 00:00:00	1981-10-31	1981-10-31 00:00:00	1981-10-31	38000177		0	0	14		0	0	0	202002	0	309045	19074843		
36751	3035	19073188	1990-04-08	1990-04-08 00:00:00	1990-04-22	1990-04-22 00:00:00	1990-04-22	38000177		0	0	14		0	0	0	202187	0	308192	19073188		
60701	5048	1127078	1961-07-10	1961-07-10 00:00:00	1961-07-24	1961-07-24 00:00:00	1961-07-24	38000177		0	0	14		0	0	0	335445	0	282464	1127078		
4620	384	1115171	2003-07-03	2003-07-03 00:00:00	2003-07-17	2003-07-17 00:00:00	2003-07-17	38000177		0	0	14		0	0	0	25354	0	849574	1115171		
35733	2944	1127433	1998-03-08	1998-03-08 00:00:00	1998-03-15	1998-03-15 00:00:00	1998-03-15	38000177		0	0	7		0	0	0	196405	0	313782	1127433		
52095	4330	40229134	1959-06-13	1959-06-13 00:00:00	1959-06-27	1959-06-27 00:00:00	1959-06-27	38000177		0	0	14		0	0	0	287267	0	1043400	40229134		
18352	399	40213227	2006-09-24	2006-09-24 00:00:00	2006-09-24	2006-09-24 00:00:00	2006-09-24	581452		0	0	0		0	0	0	26194	0	113	40213227		
6922	582	1127433	1973-09-17	1973-09-17 00:00:00	1973-10-01	1973-10-01 00:00:00	1973-10-01	38000177		0	0	14		0	0	0	38571	0	313782	1127433		
33562	2777	1124300	1999-11-07	1999-11-07 00:00:00	1999-11-07	1999-11-07 00:00:00	\N	38000177		0	0	0		0	0	0	183936	0	00781178901	45011828		
8703	726	1124300	1991-06-12	1991-06-12 00:00:00	1991-06-12	1991-06-12 00:00:00	\N	38000177		0	0	0		0	0	0	48124	0	00781178901	45011828		
1198	96	19126352	1984-02-18	1984-02-18 00:00:00	1997-01-25	1997-01-25 00:00:00	1997-01-25	38000177		0	0	4725		0	0	0	6514	0	705129	19126352		
56963	4725	19078461	1996-02-19	1996-02-19 00:00:00	1996-03-18	1996-03-18 00:00:00	1996-03-18	38000177		0	0	28		0	0	0	314866	0	310965	19078461		
44213	3660	40236824	1997-08-09	1997-08-09 00:00:00	1997-08-16	1997-08-16 00:00:00	1997-08-16	38000177		0	0	7		0	0	0	243585	0	1094107	40236824		
19359	1597	1127433	1960-06-10	1960-06-10 00:00:00	1960-06-24	1960-06-24 00:00:00	1960-06-24	38000177		0	0	14		0	0	0	107118	0	313782	1127433		
19418	1600	1127433	2008-08-06	2008-08-06 00:00:00	2008-08-13	2008-08-13 00:00:00	2008-08-13	38000177		0	0	7		0	0	0	107371	0	313782	1127433		
44101	3650	40231925	1940-11-04	1940-11-04 00:00:00	1940-11-04	1940-11-04 00:00:00	\N	38000177		0	0	0		0	0	0	242935	0	1049221	40231925		
37063	3064	1118084	1975-05-16	1975-05-16 00:00:00	1975-05-16	1975-05-16 00:00:00	\N	38000177		0	0	0		0	0	0	203933	0	00025152531	44923712		
17172	370	40213306	1985-07-04	1985-07-04 00:00:00	1985-07-04	1985-07-04 00:00:00	1985-07-04	581452		0	0	0		0	0	0	24638	0	43	40213306		
37165	3072	1713671	2013-08-22	2013-08-22 00:00:00	2013-09-05	2013-09-05 00:00:00	2013-09-05	38000177		0	0	14		0	0	0	204481	0	562251	1713671		
21724	1783	1154615	1961-08-02	1961-08-02 00:00:00	1961-08-02	1961-08-02 00:00:00	\N	38000177		0	0	0		0	0	0	119420	0	745679	1154615		
12928	1086	1115171	2013-03-20	2013-03-20 00:00:00	2013-04-03	2013-04-03 00:00:00	2013-04-03	38000177		0	0	14		0	0	0	71351	0	849574	1115171		
32271	2675	19078461	2006-06-21	2006-06-21 00:00:00	2006-07-05	2006-07-05 00:00:00	2006-07-05	38000177		0	0	14		0	0	0	177236	0	310965	19078461		
32598	2702	19133905	2014-08-17	2014-08-17 00:00:00	2014-08-30	2014-08-30 00:00:00	2014-08-30	38000177		0	0	13		0	0	0	178939	0	834102	19133905		
39978	871	40213227	1997-12-30	1997-12-30 00:00:00	1997-12-30	1997-12-30 00:00:00	1997-12-30	581452		0	0	0		0	0	0	57972	0	113	40213227		
59976	4986	1713671	1956-12-25	1956-12-25 00:00:00	1957-01-01	1957-01-01 00:00:00	1957-01-01	38000177		0	0	7		0	0	0	331678	0	562251	1713671		
23970	1973	1127433	2004-11-04	2004-11-04 00:00:00	2004-11-18	2004-11-18 00:00:00	2004-11-18	38000177		0	0	14		0	0	0	131190	0	313782	1127433		
17196	1427	40236824	1986-12-17	1986-12-17 00:00:00	1986-12-24	1986-12-24 00:00:00	1986-12-24	38000177		0	0	7		0	0	0	94954	0	1094107	40236824		
17242	1430	40236824	1997-12-25	1997-12-25 00:00:00	1998-01-01	1998-01-01 00:00:00	1998-01-01	38000177		0	0	7		0	0	0	95151	0	1094107	40236824		
50963	4235	1127078	1987-10-15	1987-10-15 00:00:00	1987-11-19	1987-11-19 00:00:00	1987-11-19	38000177		0	0	35		0	0	0	281188	0	282464	1127078		
13779	1151	1115171	2009-04-14	2009-04-14 00:00:00	2009-05-12	2009-05-12 00:00:00	2009-05-12	38000177		0	0	28		0	0	0	76100	0	849574	1115171		
37571	3106	40229134	1973-12-23	1973-12-23 00:00:00	1973-12-30	1973-12-30 00:00:00	1973-12-30	38000177		0	0	7		0	0	0	206556	0	1043400	40229134		
75140	1641	40213227	2005-09-28	2005-09-28 00:00:00	2005-09-28	2005-09-28 00:00:00	2005-09-28	581452		0	0	0		0	0	0	110140	0	113	40213227		
38808	847	40213227	1997-06-20	1997-06-20 00:00:00	1997-06-20	1997-06-20 00:00:00	1997-06-20	581452		0	0	0		0	0	0	56130	0	113	40213227		
38448	3177	40231925	1942-03-10	1942-03-10 00:00:00	1942-03-10	1942-03-10 00:00:00	\N	38000177		0	0	0		0	0	0	211228	0	1049221	40231925		
38471	3178	40162522	2014-03-14	2014-03-14 00:00:00	2014-03-14	2014-03-14 00:00:00	\N	38000177		0	0	0		0	0	0	211388	0	857005	40162522		
112	7	40229134	2001-07-18	2001-07-18 00:00:00	2001-08-01	2001-08-01 00:00:00	2001-08-01	38000177		0	0	14		0	0	0	625	0	1043400	40229134		
17860	1478	35605858	1975-05-03	1975-05-03 00:00:00	1975-05-03	1975-05-03 00:00:00	1975-05-03	38000177		0	0	0		0	0	0	98639	0	1732136	35605858		
37891	3133	19059056	1956-09-19	1956-09-19 00:00:00	1956-10-03	1956-10-03 00:00:00	1956-10-03	38000177		0	0	14		0	0	0	208472	0	243670	19059056		
37933	3135	1127433	1990-09-08	1990-09-08 00:00:00	1990-09-22	1990-09-22 00:00:00	1990-09-22	38000177		0	0	14		0	0	0	208668	0	313782	1127433		
14684	1229	1127433	2001-04-17	2001-04-17 00:00:00	2001-04-24	2001-04-24 00:00:00	2001-04-24	38000177		0	0	7		0	0	0	80982	0	313782	1127433		
14738	1232	40229134	1996-07-30	1996-07-30 00:00:00	1996-08-13	1996-08-13 00:00:00	1996-08-13	38000177		0	0	14		0	0	0	81221	0	1043400	40229134		
31346	2598	1127433	1988-08-22	1988-08-22 00:00:00	1988-09-26	1988-09-26 00:00:00	1988-09-26	38000177		0	0	35		0	0	0	171922	0	313782	1127433		
25275	2080	40162522	1993-03-23	1993-03-23 00:00:00	1993-03-23	1993-03-23 00:00:00	\N	38000177		0	0	0		0	0	0	138522	0	857005	40162522		
2392	53	40213296	2003-12-03	2003-12-03 00:00:00	2003-12-03	2003-12-03 00:00:00	2003-12-03	581452		0	0	0		0	0	0	3679	0	52	40213296		
21795	1789	40165015	1991-11-21	1991-11-21 00:00:00	1991-11-21	1991-11-21 00:00:00	\N	38000177		0	0	0		0	0	0	119906	0	861467	40165015		
41993	3481	1127078	1987-02-03	1987-02-03 00:00:00	1987-02-17	1987-02-17 00:00:00	1987-02-17	38000177		0	0	14		0	0	0	230874	0	282464	1127078		
12958	1088	1127433	1996-10-10	1996-10-10 00:00:00	1996-10-24	1996-10-24 00:00:00	1996-10-24	38000177		0	0	14		0	0	0	71462	0	313782	1127433		
32416	2686	19078461	2009-12-10	2009-12-10 00:00:00	2010-01-14	2010-01-14 00:00:00	2010-01-14	38000177		0	0	35		0	0	0	178074	0	310965	19078461		
35001	2891	1127433	1974-10-20	1974-10-20 00:00:00	1974-10-27	1974-10-27 00:00:00	1974-10-27	38000177		0	0	7		0	0	0	192343	0	313782	1127433		
10229	857	920334	1981-04-06	1981-04-06 00:00:00	1981-04-13	1981-04-13 00:00:00	1981-04-13	38000177		0	0	7		0	0	0	56662	0	311995	920334		
45551	3769	19059056	1951-03-18	1951-03-18 00:00:00	1951-04-15	1951-04-15 00:00:00	1951-04-15	38000177		0	0	28		0	0	0	250504	0	243670	19059056		
2910	235	19074679	1992-09-25	1992-09-25 00:00:00	1993-02-26	1993-02-26 00:00:00	1993-02-26	38000177		0	0	154		0	0	0	15758	0	308971	19074679		
57111	4739	19133905	1948-02-18	1948-02-18 00:00:00	1948-02-28	1948-02-28 00:00:00	1948-02-28	38000177		0	0	10		0	0	0	315684	0	834102	19133905		
1005	82	920300	2006-04-24	2006-04-24 00:00:00	2006-05-01	2006-05-01 00:00:00	2006-05-01	38000177		0	0	7		0	0	0	5551	0	311989	920300		
28750	2373	1127433	1961-04-08	1961-04-08 00:00:00	1961-04-22	1961-04-22 00:00:00	1961-04-22	38000177		0	0	14		0	0	0	157883	0	313782	1127433		
44013	959	40213160	1963-03-06	1963-03-06 00:00:00	1963-03-06	1963-03-06 00:00:00	1963-03-06	581452		0	0	0		0	0	0	63799	0	10	40213160		
14100	1177	1713671	1992-11-07	1992-11-07 00:00:00	1992-11-14	1992-11-14 00:00:00	1992-11-14	38000177		0	0	7		0	0	0	77763	0	562251	1713671		
36612	3022	1127078	1978-11-12	1978-11-12 00:00:00	1979-01-11	1979-01-11 00:00:00	1979-01-11	38000177		0	0	60		0	0	0	201476	0	282464	1127078		
24652	2028	1127433	2003-09-16	2003-09-16 00:00:00	2003-10-07	2003-10-07 00:00:00	2003-10-07	38000177		0	0	21		0	0	0	135030	0	313782	1127433		
24657	2028	19074679	1977-11-27	1977-11-27 00:00:00	1977-11-27	1977-11-27 00:00:00	\N	38000177		0	0	0		0	0	0	134950	0	308971	19074679		
23273	1917	19133873	1959-06-27	1959-06-27 00:00:00	1959-07-07	1959-07-07 00:00:00	1959-07-07	38000177		0	0	10		0	0	0	127561	0	834061	19133873		
22308	1834	1127078	1954-12-18	1954-12-18 00:00:00	1955-01-22	1955-01-22 00:00:00	1955-01-22	38000177		0	0	35		0	0	0	122539	0	282464	1127078		
36324	793	40213296	2014-03-20	2014-03-20 00:00:00	2014-03-20	2014-03-20 00:00:00	2014-03-20	581452		0	0	0		0	0	0	52660	0	52	40213296		
26221	2156	1127433	1978-10-10	1978-10-10 00:00:00	1978-10-17	1978-10-17 00:00:00	1978-10-17	38000177		0	0	7		0	0	0	143696	0	313782	1127433		
36719	3030	19078461	2013-08-26	2013-08-26 00:00:00	2013-09-09	2013-09-09 00:00:00	2013-09-09	38000177		0	0	14		0	0	0	202027	0	310965	19078461		
36752	3035	1127433	1999-09-21	1999-09-21 00:00:00	1999-09-28	1999-09-28 00:00:00	1999-09-28	38000177		0	0	7		0	0	0	202212	0	313782	1127433		
60702	5048	1127433	1995-02-26	1995-02-26 00:00:00	1995-03-12	1995-03-12 00:00:00	1995-03-12	38000177		0	0	14		0	0	0	335500	0	313782	1127433		
4621	384	40229134	2008-02-10	2008-02-10 00:00:00	2008-02-17	2008-02-17 00:00:00	2008-02-17	38000177		0	0	7		0	0	0	25348	0	1043400	40229134		
35735	2944	40229134	1965-12-01	1965-12-01 00:00:00	1965-12-15	1965-12-15 00:00:00	1965-12-15	38000177		0	0	14		0	0	0	196426	0	1043400	40229134		
52096	4331	1118084	2017-03-24	2017-03-24 00:00:00	2017-03-24	2017-03-24 00:00:00	\N	38000177		0	0	0		0	0	0	287297	0	00025152531	44923712		
18353	399	40213260	2006-09-24	2006-09-24 00:00:00	2006-09-24	2006-09-24 00:00:00	2006-09-24	581452		0	0	0		0	0	0	26194	0	121	40213260		
60494	5034	1127433	1930-12-22	1930-12-22 00:00:00	1930-12-29	1930-12-29 00:00:00	1930-12-29	38000177		0	0	7		0	0	0	334526	0	313782	1127433		
33563	2777	1713671	1975-04-27	1975-04-27 00:00:00	1975-05-11	1975-05-11 00:00:00	1975-05-11	38000177		0	0	14		0	0	0	183966	0	562251	1713671		
8706	726	1127433	1984-08-18	1984-08-18 00:00:00	1984-08-25	1984-08-25 00:00:00	1984-08-25	38000177		0	0	7		0	0	0	48112	0	313782	1127433		
1199	96	1332419	1994-04-16	1994-04-16 00:00:00	1994-04-16	1994-04-16 00:00:00	\N	38000177		0	0	0		0	0	0	6516	0	197361	1332419		
56964	4725	1127078	1977-03-11	1977-03-11 00:00:00	1977-03-25	1977-03-25 00:00:00	1977-03-25	38000177		0	0	14		0	0	0	314896	0	282464	1127078		
44214	3660	920300	1997-08-09	1997-08-09 00:00:00	1997-08-16	1997-08-16 00:00:00	1997-08-16	38000177		0	0	7		0	0	0	243585	0	311989	920300		
19361	1597	19133873	1953-08-15	1953-08-15 00:00:00	1953-08-23	1953-08-23 00:00:00	1953-08-23	38000177		0	0	8		0	0	0	107098	0	834061	19133873		
29881	2476	1713671	1985-05-29	1985-05-29 00:00:00	1985-06-12	1985-06-12 00:00:00	1985-06-12	38000177		0	0	14		0	0	0	164106	0	562251	1713671		
44102	3650	19078461	1986-12-10	1986-12-10 00:00:00	1986-12-24	1986-12-24 00:00:00	1986-12-24	38000177		0	0	14		0	0	0	242937	0	310965	19078461		
37064	3064	19059056	1938-08-18	1938-08-18 00:00:00	1938-09-01	1938-09-01 00:00:00	1938-09-01	38000177		0	0	14		0	0	0	203982	0	243670	19059056		
17175	370	40213160	1964-01-09	1964-01-09 00:00:00	1964-01-09	1964-01-09 00:00:00	1964-01-09	581452		0	0	0		0	0	0	24592	0	10	40213160		
37166	3072	1127433	1975-10-22	1975-10-22 00:00:00	1975-11-12	1975-11-12 00:00:00	1975-11-12	38000177		0	0	21		0	0	0	204460	0	313782	1127433		
21725	1783	1127433	1981-03-15	1981-03-15 00:00:00	1981-03-22	1981-03-22 00:00:00	1981-03-22	38000177		0	0	7		0	0	0	119381	0	313782	1127433		
12929	1086	1127433	1988-11-23	1988-11-23 00:00:00	1988-11-30	1988-11-30 00:00:00	1988-11-30	38000177		0	0	7		0	0	0	71355	0	313782	1127433		
32272	2675	19078461	1978-02-13	1978-02-13 00:00:00	1978-04-14	1978-04-14 00:00:00	1978-04-14	38000177		0	0	60		0	0	0	177232	0	310965	19078461		
32599	2702	19006318	1946-10-18	1946-10-18 00:00:00	1946-11-01	1946-11-01 00:00:00	1946-11-01	38000177		0	0	14		0	0	0	178974	0	105078	19006318		
39983	871	40213260	2017-01-24	2017-01-24 00:00:00	2017-01-24	2017-01-24 00:00:00	2017-01-24	581452		0	0	0		0	0	0	57961	0	121	40213260		
59977	4986	19059056	1952-10-24	1952-10-24 00:00:00	1952-11-07	1952-11-07 00:00:00	1952-11-07	38000177		0	0	14		0	0	0	331654	0	243670	19059056		
23971	1973	19059056	1978-04-15	1978-04-15 00:00:00	1978-04-29	1978-04-29 00:00:00	1978-04-29	38000177		0	0	14		0	0	0	131200	0	243670	19059056		
17197	1427	920300	1986-12-17	1986-12-17 00:00:00	1986-12-24	1986-12-24 00:00:00	1986-12-24	38000177		0	0	7		0	0	0	94954	0	311989	920300		
17243	1430	920300	1997-12-25	1997-12-25 00:00:00	1998-01-01	1998-01-01 00:00:00	1998-01-01	38000177		0	0	7		0	0	0	95151	0	311989	920300		
50964	4235	19074843	1987-10-15	1987-10-15 00:00:00	1987-11-19	1987-11-19 00:00:00	1987-11-19	38000177		0	0	35		0	0	0	281188	0	309045	19074843		
13780	1151	1127433	2019-04-01	2019-04-01 00:00:00	2019-04-08	2019-04-08 00:00:00	2019-04-08	38000177		0	0	7		0	0	0	76089	0	313782	1127433		
37572	3106	1124300	1990-03-22	1990-03-22 00:00:00	1990-03-22	1990-03-22 00:00:00	\N	38000177		0	0	0		0	0	0	206581	0	00781178901	45011828		
75143	1641	40213227	2015-11-25	2015-11-25 00:00:00	2015-11-25	2015-11-25 00:00:00	2015-11-25	581452		0	0	0		0	0	0	110151	0	113	40213227		
38810	847	40213160	1966-07-15	1966-07-15 00:00:00	1966-07-15	1966-07-15 00:00:00	1966-07-15	581452		0	0	0		0	0	0	56147	0	10	40213160		
38449	3177	19059056	1942-03-10	1942-03-10 00:00:00	1942-03-24	1942-03-24 00:00:00	1942-03-24	38000177		0	0	14		0	0	0	211228	0	243670	19059056		
38472	3178	35605482	2014-03-13	2014-03-13 00:00:00	2014-03-13	2014-03-13 00:00:00	2014-03-13	38000177		0	0	0		0	0	0	211388	0	1740467	35605482		
114	7	1127078	1974-08-12	1974-08-12 00:00:00	1974-09-11	1974-09-11 00:00:00	1974-09-11	38000177		0	0	30		0	0	0	631	0	282464	1127078		
17861	1478	46275444	1975-05-03	1975-05-03 00:00:00	1975-05-03	1975-05-03 00:00:00	1975-05-03	38000177		0	0	0		0	0	0	98639	0	1659149	46275444		
37892	3133	19006318	1956-09-19	1956-09-19 00:00:00	1956-10-03	1956-10-03 00:00:00	1956-10-03	38000177		0	0	14		0	0	0	208472	0	105078	19006318		
37946	3137	19133905	1928-06-23	1928-06-23 00:00:00	1928-07-03	1928-07-03 00:00:00	1928-07-03	38000177		0	0	10		0	0	0	208851	0	834102	19133905		
14685	1229	1127433	2005-07-29	2005-07-29 00:00:00	2005-08-12	2005-08-12 00:00:00	2005-08-12	38000177		0	0	14		0	0	0	80958	0	313782	1127433		
14753	1235	19128022	1993-05-01	1993-05-01 00:00:00	1994-04-26	1994-04-26 00:00:00	1994-04-26	38000177		0	0	360		0	0	0	81350	0	749785	19128022		
31347	2598	19078461	1992-07-07	1992-07-07 00:00:00	1992-07-28	1992-07-28 00:00:00	1992-07-28	38000177		0	0	21		0	0	0	171923	0	310965	19078461		
25276	2080	1713671	2000-07-05	2000-07-05 00:00:00	2000-09-20	2000-09-20 00:00:00	2000-09-20	38000177		0	0	77		0	0	0	138539	0	562251	1713671		
2404	53	40213260	2013-03-06	2013-03-06 00:00:00	2013-03-06	2013-03-06 00:00:00	2013-03-06	581452		0	0	0		0	0	0	3673	0	121	40213260		
21796	1789	19059056	1991-11-21	1991-11-21 00:00:00	1992-01-20	1992-01-20 00:00:00	1992-01-20	38000177		0	0	60		0	0	0	119906	0	243670	19059056		
41994	3481	19126352	1995-06-24	1995-06-24 00:00:00	2015-04-04	2015-04-04 00:00:00	2015-04-04	38000177		0	0	7224		0	0	0	230870	0	705129	19126352		
49685	4121	40236824	1971-08-30	1971-08-30 00:00:00	1971-09-13	1971-09-13 00:00:00	1971-09-13	38000177		0	0	14		0	0	0	273943	0	1094107	40236824		
32420	2688	1713671	1987-07-06	1987-07-06 00:00:00	1987-07-13	1987-07-13 00:00:00	1987-07-13	38000177		0	0	7		0	0	0	178146	0	562251	1713671		
35002	2891	1127078	1978-12-26	1978-12-26 00:00:00	1979-01-09	1979-01-09 00:00:00	1979-01-09	38000177		0	0	14		0	0	0	192329	0	282464	1127078		
10231	857	920300	1981-03-30	1981-03-30 00:00:00	1981-04-06	1981-04-06 00:00:00	1981-04-06	38000177		0	0	7		0	0	0	56629	0	311989	920300		
45552	3769	1127433	1964-02-10	1964-02-10 00:00:00	1964-02-24	1964-02-24 00:00:00	1964-02-24	38000177		0	0	14		0	0	0	250535	0	313782	1127433		
2912	236	1127433	1983-12-29	1983-12-29 00:00:00	1984-03-28	1984-03-28 00:00:00	1984-03-28	38000177		0	0	90		0	0	0	15915	0	313782	1127433		
57112	4739	19059056	1954-09-03	1954-09-03 00:00:00	1954-09-17	1954-09-17 00:00:00	1954-09-17	38000177		0	0	14		0	0	0	315730	0	243670	19059056		
1006	82	19128065	1980-02-20	1980-02-20 00:00:00	1981-02-14	1981-02-14 00:00:00	1981-02-14	38000177		0	0	360		0	0	0	5581	0	749882	19128065		
28751	2373	1127433	1992-12-01	1992-12-01 00:00:00	1992-12-15	1992-12-15 00:00:00	1992-12-15	38000177		0	0	14		0	0	0	157900	0	313782	1127433		
44020	959	40213160	1958-12-03	1958-12-03 00:00:00	1958-12-03	1958-12-03 00:00:00	1958-12-03	581452		0	0	0		0	0	0	63729	0	10	40213160		
62439	5196	1124300	1993-04-09	1993-04-09 00:00:00	1993-04-09	1993-04-09 00:00:00	\N	38000177		0	0	0		0	0	0	345503	0	00781178901	45011828		
36613	3022	19133873	1975-04-24	1975-04-24 00:00:00	1975-05-07	1975-05-07 00:00:00	1975-05-07	38000177		0	0	13		0	0	0	201491	0	834061	19133873		
24653	2028	40174880	2018-11-17	2018-11-17 00:00:00	2018-11-17	2018-11-17 00:00:00	\N	38000177		0	0	0		0	0	0	135011	0	966222	40174880		
24658	2028	1127433	1997-11-16	1997-11-16 00:00:00	1998-01-15	1998-01-15 00:00:00	1998-01-15	38000177		0	0	60		0	0	0	134954	0	313782	1127433		
23274	1917	19059056	1952-05-18	1952-05-18 00:00:00	1952-06-01	1952-06-01 00:00:00	1952-06-01	38000177		0	0	14		0	0	0	127543	0	243670	19059056		
22309	1834	1118084	1986-07-13	1986-07-13 00:00:00	1986-07-13	1986-07-13 00:00:00	\N	38000177		0	0	0		0	0	0	122506	0	00025152531	44923712		
36330	793	40213227	2016-03-24	2016-03-24 00:00:00	2016-03-24	2016-03-24 00:00:00	2016-03-24	581452		0	0	0		0	0	0	52610	0	113	40213227		
26222	2156	19059056	1968-08-01	1968-08-01 00:00:00	1968-08-15	1968-08-15 00:00:00	1968-08-15	38000177		0	0	14		0	0	0	143723	0	243670	19059056		
36720	3030	19078461	2001-01-17	2001-01-17 00:00:00	2001-01-31	2001-01-31 00:00:00	2001-01-31	38000177		0	0	14		0	0	0	202025	0	310965	19078461		
36753	3035	19059056	1968-05-27	1968-05-27 00:00:00	1968-07-26	1968-07-26 00:00:00	1968-07-26	38000177		0	0	60		0	0	0	202209	0	243670	19059056		
60703	5048	40236824	1976-11-14	1976-11-14 00:00:00	1976-11-21	1976-11-21 00:00:00	1976-11-21	38000177		0	0	7		0	0	0	335470	0	1094107	40236824		
4622	384	40229134	2014-04-18	2014-04-18 00:00:00	2014-05-02	2014-05-02 00:00:00	2014-05-02	38000177		0	0	14		0	0	0	25349	0	1043400	40229134		
35736	2944	19078461	1976-03-01	1976-03-01 00:00:00	1976-03-22	1976-03-22 00:00:00	1976-03-22	38000177		0	0	21		0	0	0	196395	0	310965	19078461		
52097	4331	19019979	1981-12-08	1981-12-08 00:00:00	1981-12-22	1981-12-22 00:00:00	1981-12-22	38000177		0	0	14		0	0	0	287301	0	198405	19019979		
18354	399	40213160	1955-07-10	1955-07-10 00:00:00	1955-07-10	1955-07-10 00:00:00	1955-07-10	581452		0	0	0		0	0	0	26142	0	10	40213160		
60495	5034	19133905	1973-06-24	1973-06-24 00:00:00	1973-07-05	1973-07-05 00:00:00	1973-07-05	38000177		0	0	11		0	0	0	334486	0	834102	19133905		
33564	2777	19078461	1993-10-01	1993-10-01 00:00:00	1993-10-31	1993-10-31 00:00:00	1993-10-31	38000177		0	0	30		0	0	0	183935	0	310965	19078461		
8707	726	19078461	2004-09-01	2004-09-01 00:00:00	2004-09-22	2004-09-22 00:00:00	2004-09-22	38000177		0	0	21		0	0	0	48093	0	310965	19078461		
1200	96	1539411	1991-03-30	1991-03-30 00:00:00	1991-03-30	1991-03-30 00:00:00	\N	38000177		0	0	0		0	0	0	6483	0	312961	1539411		
56965	4725	19129655	1977-03-11	1977-03-11 00:00:00	1977-03-25	1977-03-25 00:00:00	1977-03-25	38000177		0	0	14		0	0	0	314896	0	789980	19129655		
44215	3660	19078461	1987-11-29	1987-11-29 00:00:00	1987-12-20	1987-12-20 00:00:00	1987-12-20	38000177		0	0	21		0	0	0	243603	0	310965	19078461		
19362	1598	40173590	2018-08-06	2018-08-06 00:00:00	2018-08-06	2018-08-06 00:00:00	\N	38000177		0	0	0		0	0	0	107269	0	904419	40173590		
29882	2477	19112599	1957-03-19	1957-03-19 00:00:00	1957-03-19	1957-03-19 00:00:00	\N	38000177		0	0	0		0	0	0	164175	0	477045	19112599		
44103	3650	19133905	1961-09-18	1961-09-18 00:00:00	1961-09-25	1961-09-25 00:00:00	1961-09-25	38000177		0	0	7		0	0	0	242901	0	834102	19133905		
37065	3064	19078461	1997-01-30	1997-01-30 00:00:00	1997-03-06	1997-03-06 00:00:00	1997-03-06	38000177		0	0	35		0	0	0	203945	0	310965	19078461		
17180	371	40213160	1968-10-10	1968-10-10 00:00:00	1968-10-10	1968-10-10 00:00:00	1968-10-10	581452		0	0	0		0	0	0	24696	0	10	40213160		
37167	3072	1127433	2008-01-23	2008-01-23 00:00:00	2008-02-13	2008-02-13 00:00:00	2008-02-13	38000177		0	0	21		0	0	0	204462	0	313782	1127433		
21726	1783	1551192	1962-03-13	1962-03-13 00:00:00	1962-03-13	1962-03-13 00:00:00	1962-03-13	38000177		0	0	0		0	0	0	119436	0	312617	1551192		
12930	1086	1713671	1989-08-19	1989-08-19 00:00:00	1989-09-09	1989-09-09 00:00:00	1989-09-09	38000177		0	0	21		0	0	0	71313	0	562251	1713671		
32273	2675	40231925	1978-02-13	1978-02-13 00:00:00	1978-02-13	1978-02-13 00:00:00	\N	38000177		0	0	0		0	0	0	177232	0	1049221	40231925		
32600	2702	19059056	1946-10-18	1946-10-18 00:00:00	1946-11-01	1946-11-01 00:00:00	1946-11-01	38000177		0	0	14		0	0	0	178974	0	243670	19059056		
39985	871	40213227	2017-01-24	2017-01-24 00:00:00	2017-01-24	2017-01-24 00:00:00	2017-01-24	581452		0	0	0		0	0	0	57961	0	113	40213227		
59978	4986	1118084	1981-12-06	1981-12-06 00:00:00	1981-12-06	1981-12-06 00:00:00	\N	38000177		0	0	0		0	0	0	331633	0	00025152531	44923712		
23972	1973	1115171	1996-12-20	1996-12-20 00:00:00	1997-01-19	1997-01-19 00:00:00	1997-01-19	38000177		0	0	30		0	0	0	131202	0	849574	1115171		
17198	1427	19059056	1958-11-23	1958-11-23 00:00:00	1958-12-07	1958-12-07 00:00:00	1958-12-07	38000177		0	0	14		0	0	0	94918	0	243670	19059056		
17244	1430	1127433	1993-12-28	1993-12-28 00:00:00	1994-01-25	1994-01-25 00:00:00	1994-01-25	38000177		0	0	28		0	0	0	95183	0	313782	1127433		
50965	4235	1713671	2008-02-09	2008-02-09 00:00:00	2008-03-01	2008-03-01 00:00:00	2008-03-01	38000177		0	0	21		0	0	0	281215	0	562251	1713671		
13781	1151	1127078	1990-04-17	1990-04-17 00:00:00	1990-05-01	1990-05-01 00:00:00	1990-05-01	38000177		0	0	14		0	0	0	76091	0	282464	1127078		
37573	3106	40229134	2012-12-28	2012-12-28 00:00:00	2013-01-11	2013-01-11 00:00:00	2013-01-11	38000177		0	0	14		0	0	0	206602	0	1043400	40229134		
75145	1641	40213260	2007-10-10	2007-10-10 00:00:00	2007-10-10	2007-10-10 00:00:00	2007-10-10	581452		0	0	0		0	0	0	110112	0	121	40213260		
38812	847	40213296	2007-12-07	2007-12-07 00:00:00	2007-12-07	2007-12-07 00:00:00	2007-12-07	581452		0	0	0		0	0	0	56156	0	52	40213296		
38450	3177	1127433	2008-02-18	2008-02-18 00:00:00	2008-03-19	2008-03-19 00:00:00	2008-03-19	38000177		0	0	30		0	0	0	211351	0	313782	1127433		
38473	3178	35605482	2014-03-14	2014-03-14 00:00:00	2014-03-14	2014-03-14 00:00:00	2014-03-14	38000177		0	0	0		0	0	0	211388	0	1740467	35605482		
115	7	19128065	1986-10-13	1986-10-13 00:00:00	1987-10-08	1987-10-08 00:00:00	1987-10-08	38000177		0	0	360		0	0	0	608	0	749882	19128065		
17862	1478	40162522	1975-05-04	1975-05-04 00:00:00	1975-05-04	1975-05-04 00:00:00	\N	38000177		0	0	0		0	0	0	98639	0	857005	40162522		
37893	3133	19059056	1964-03-28	1964-03-28 00:00:00	1964-04-11	1964-04-11 00:00:00	1964-04-11	38000177		0	0	14		0	0	0	208526	0	243670	19059056		
37947	3137	19133873	1927-03-18	1927-03-18 00:00:00	1927-03-27	1927-03-27 00:00:00	1927-03-27	38000177		0	0	9		0	0	0	208776	0	834061	19133873		
14686	1229	40236446	1966-05-12	1966-05-12 00:00:00	1972-05-20	1972-05-20 00:00:00	1972-05-20	38000177		0	0	2200		0	0	0	80977	0	1091392	40236446		
14754	1235	19059056	1981-04-08	1981-04-08 00:00:00	1981-04-22	1981-04-22 00:00:00	1981-04-22	38000177		0	0	14		0	0	0	81338	0	243670	19059056		
31348	2598	40229134	2017-04-29	2017-04-29 00:00:00	2017-05-13	2017-05-13 00:00:00	2017-05-13	38000177		0	0	14		0	0	0	171938	0	1043400	40229134		
25277	2080	19078461	2009-08-24	2009-08-24 00:00:00	2009-09-07	2009-09-07 00:00:00	2009-09-07	38000177		0	0	14		0	0	0	138544	0	310965	19078461		
2405	53	40213227	1995-11-22	1995-11-22 00:00:00	1995-11-22	1995-11-22 00:00:00	1995-11-22	581452		0	0	0		0	0	0	3669	0	113	40213227		
21797	1789	1118084	2017-01-07	2017-01-07 00:00:00	2017-01-07	2017-01-07 00:00:00	\N	38000177		0	0	0		0	0	0	119932	0	00025152531	44923712		
41995	3481	1332419	1995-06-24	1995-06-24 00:00:00	1995-06-24	1995-06-24 00:00:00	\N	38000177		0	0	0		0	0	0	230870	0	197361	1332419		
49686	4121	920300	1971-08-30	1971-08-30 00:00:00	1971-09-06	1971-09-06 00:00:00	1971-09-06	38000177		0	0	7		0	0	0	273943	0	311989	920300		
32421	2688	1127433	1975-09-09	1975-09-09 00:00:00	1975-10-14	1975-10-14 00:00:00	1975-10-14	38000177		0	0	35		0	0	0	178163	0	313782	1127433		
35003	2891	46233988	1978-12-26	1978-12-26 00:00:00	1979-01-09	1979-01-09 00:00:00	1979-01-09	38000177		0	0	14		0	0	0	192329	0	1652673	46233988		
10232	857	40236824	1981-03-30	1981-03-30 00:00:00	1981-04-13	1981-04-13 00:00:00	1981-04-13	38000177		0	0	14		0	0	0	56629	0	1094107	40236824		
45553	3769	40229134	1954-04-02	1954-04-02 00:00:00	1954-04-09	1954-04-09 00:00:00	1954-04-09	38000177		0	0	7		0	0	0	250518	0	1043400	40229134		
2916	236	19128065	1984-12-14	1984-12-14 00:00:00	1985-12-09	1985-12-09 00:00:00	1985-12-09	38000177		0	0	360		0	0	0	15815	0	749882	19128065		
57113	4739	1127433	1919-09-15	1919-09-15 00:00:00	1919-09-29	1919-09-29 00:00:00	1919-09-29	38000177		0	0	14		0	0	0	315732	0	313782	1127433		
1007	82	19128065	1978-03-02	1978-03-02 00:00:00	1979-02-25	1979-02-25 00:00:00	1979-02-25	38000177		0	0	360		0	0	0	5580	0	749882	19128065		
28752	2373	1127433	2017-07-16	2017-07-16 00:00:00	2017-07-30	2017-07-30 00:00:00	2017-07-30	38000177		0	0	14		0	0	0	157960	0	313782	1127433		
44022	959	40213260	2008-03-26	2008-03-26 00:00:00	2008-03-26	2008-03-26 00:00:00	2008-03-26	581452		0	0	0		0	0	0	63736	0	121	40213260		
62440	5196	19006318	1956-02-08	1956-02-08 00:00:00	1956-02-22	1956-02-22 00:00:00	1956-02-22	38000177		0	0	14		0	0	0	345553	0	105078	19006318		
36614	3022	1127433	1991-07-18	1991-07-18 00:00:00	1991-07-25	1991-07-25 00:00:00	1991-07-25	38000177		0	0	7		0	0	0	201446	0	313782	1127433		
24655	2028	1118084	1987-02-08	1987-02-08 00:00:00	1987-02-08	1987-02-08 00:00:00	\N	38000177		0	0	0		0	0	0	135024	0	00025152531	44923712		
24659	2028	40165015	1997-11-16	1997-11-16 00:00:00	1997-11-16	1997-11-16 00:00:00	\N	38000177		0	0	0		0	0	0	134954	0	861467	40165015		
23275	1917	19006318	1952-05-18	1952-05-18 00:00:00	1952-06-01	1952-06-01 00:00:00	1952-06-01	38000177		0	0	14		0	0	0	127543	0	105078	19006318		
22310	1834	1713671	1978-06-14	1978-06-14 00:00:00	1978-06-21	1978-06-21 00:00:00	1978-06-21	38000177		0	0	7		0	0	0	122538	0	562251	1713671		
36331	793	40213296	2016-03-24	2016-03-24 00:00:00	2016-03-24	2016-03-24 00:00:00	2016-03-24	581452		0	0	0		0	0	0	52610	0	52	40213296		
26223	2156	40229134	2014-02-12	2014-02-12 00:00:00	2014-02-26	2014-02-26 00:00:00	2014-02-26	38000177		0	0	14		0	0	0	143704	0	1043400	40229134		
104198	2286	40213296	1997-09-08	1997-09-08 00:00:00	1997-09-08	1997-09-08 00:00:00	1997-09-08	581452		0	0	0		0	0	0	152042	0	52	40213296		
36754	3035	1127433	1995-04-07	1995-04-07 00:00:00	1995-04-14	1995-04-14 00:00:00	1995-04-14	38000177		0	0	7		0	0	0	202182	0	313782	1127433		
60704	5048	920300	1976-11-14	1976-11-14 00:00:00	1976-11-21	1976-11-21 00:00:00	1976-11-21	38000177		0	0	7		0	0	0	335470	0	311989	920300		
4623	384	1713671	1962-09-23	1962-09-23 00:00:00	1962-10-07	1962-10-07 00:00:00	1962-10-07	38000177		0	0	14		0	0	0	25351	0	562251	1713671		
35737	2944	19059056	1969-10-10	1969-10-10 00:00:00	1969-11-14	1969-11-14 00:00:00	1969-11-14	38000177		0	0	35		0	0	0	196392	0	243670	19059056		
52098	4331	19073183	1981-12-08	1981-12-08 00:00:00	1981-12-22	1981-12-22 00:00:00	1981-12-22	38000177		0	0	14		0	0	0	287301	0	308182	19073183		
22665	1860	1127078	1963-03-24	1963-03-24 00:00:00	1963-04-07	1963-04-07 00:00:00	1963-04-07	38000177		0	0	14		0	0	0	124377	0	282464	1127078		
60496	5034	1127433	1980-09-25	1980-09-25 00:00:00	1980-10-09	1980-10-09 00:00:00	1980-10-09	38000177		0	0	14		0	0	0	334442	0	313782	1127433		
33565	2777	1713671	2016-07-31	2016-07-31 00:00:00	2016-08-07	2016-08-07 00:00:00	2016-08-07	38000177		0	0	7		0	0	0	183954	0	562251	1713671		
8708	726	1127078	1954-04-27	1954-04-27 00:00:00	1954-05-11	1954-05-11 00:00:00	1954-05-11	38000177		0	0	14		0	0	0	48077	0	282464	1127078		
1201	96	920300	1986-02-05	1986-02-05 00:00:00	1986-02-12	1986-02-12 00:00:00	1986-02-12	38000177		0	0	7		0	0	0	6471	0	311989	920300		
56966	4725	19019979	1975-08-19	1975-08-19 00:00:00	1975-11-17	1975-11-17 00:00:00	1975-11-17	38000177		0	0	90		0	0	0	314863	0	198405	19019979		
44216	3660	40236824	1998-09-23	1998-09-23 00:00:00	1998-09-30	1998-09-30 00:00:00	1998-09-30	38000177		0	0	7		0	0	0	243595	0	1094107	40236824		
19363	1598	1127433	1969-06-23	1969-06-23 00:00:00	1969-06-30	1969-06-30 00:00:00	1969-06-30	38000177		0	0	7		0	0	0	107248	0	313782	1127433		
29883	2477	920300	2003-04-24	2003-04-24 00:00:00	2003-05-01	2003-05-01 00:00:00	2003-05-01	38000177		0	0	7		0	0	0	164210	0	311989	920300		
44104	3650	40229134	2002-06-08	2002-06-08 00:00:00	2002-06-22	2002-06-22 00:00:00	2002-06-22	38000177		0	0	14		0	0	0	242945	0	1043400	40229134		
37066	3065	40229134	1995-04-27	1995-04-27 00:00:00	1995-05-04	1995-05-04 00:00:00	1995-05-04	38000177		0	0	7		0	0	0	204073	0	1043400	40229134		
17181	371	40213160	1968-07-11	1968-07-11 00:00:00	1968-07-11	1968-07-11 00:00:00	1968-07-11	581452		0	0	0		0	0	0	24653	0	10	40213160		
37168	3072	1127433	1983-03-15	1983-03-15 00:00:00	1983-03-22	1983-03-22 00:00:00	1983-03-22	38000177		0	0	7		0	0	0	204478	0	313782	1127433		
21727	1783	1115171	1994-03-09	1994-03-09 00:00:00	1994-03-30	1994-03-30 00:00:00	1994-03-30	38000177		0	0	21		0	0	0	119444	0	849574	1115171		
12931	1086	40229134	1990-02-24	1990-02-24 00:00:00	1990-03-03	1990-03-03 00:00:00	1990-03-03	38000177		0	0	7		0	0	0	71328	0	1043400	40229134		
32274	2675	1713671	1979-08-08	1979-08-08 00:00:00	1979-08-22	1979-08-22 00:00:00	1979-08-22	38000177		0	0	14		0	0	0	177267	0	562251	1713671		
32601	2702	1127433	1978-01-28	1978-01-28 00:00:00	1978-02-04	1978-02-04 00:00:00	1978-02-04	38000177		0	0	7		0	0	0	178965	0	313782	1127433		
39987	871	40213296	2006-01-24	2006-01-24 00:00:00	2006-01-24	2006-01-24 00:00:00	2006-01-24	581452		0	0	0		0	0	0	57939	0	52	40213296		
59979	4986	19018935	2001-04-29	2001-04-29 00:00:00	2001-04-29	2001-04-29 00:00:00	\N	38000177		0	0	0		0	0	0	331638	0	197604	19018935		
23973	1973	40231925	1996-12-20	1996-12-20 00:00:00	1996-12-20	1996-12-20 00:00:00	\N	38000177		0	0	0		0	0	0	131202	0	1049221	40231925		
17200	1427	19078461	2000-10-16	2000-10-16 00:00:00	2000-11-06	2000-11-06 00:00:00	2000-11-06	38000177		0	0	21		0	0	0	94962	0	310965	19078461		
17245	1430	40165015	1993-12-28	1993-12-28 00:00:00	1993-12-28	1993-12-28 00:00:00	\N	38000177		0	0	0		0	0	0	95183	0	861467	40165015		
50966	4235	1124300	2014-02-05	2014-02-05 00:00:00	2014-02-05	2014-02-05 00:00:00	\N	38000177		0	0	0		0	0	0	281213	0	00781178901	45011828		
13782	1151	19074843	1990-04-17	1990-04-17 00:00:00	1990-05-01	1990-05-01 00:00:00	1990-05-01	38000177		0	0	14		0	0	0	76091	0	309045	19074843		
37574	3106	1127433	1973-05-11	1973-05-11 00:00:00	1973-05-25	1973-05-25 00:00:00	1973-05-25	38000177		0	0	14		0	0	0	206610	0	313782	1127433		
75148	1641	40213160	1955-08-31	1955-08-31 00:00:00	1955-08-31	1955-08-31 00:00:00	1955-08-31	581452		0	0	0		0	0	0	110179	0	10	40213160		
38814	847	40213227	2007-12-07	2007-12-07 00:00:00	2007-12-07	2007-12-07 00:00:00	2007-12-07	581452		0	0	0		0	0	0	56156	0	113	40213227		
38451	3177	1127433	1920-02-01	1920-02-01 00:00:00	1920-02-08	1920-02-08 00:00:00	1920-02-08	38000177		0	0	7		0	0	0	211246	0	313782	1127433		
38474	3178	19079524	2014-03-13	2014-03-13 00:00:00	2014-03-14	2014-03-14 00:00:00	2014-03-14	38000177		0	0	1		0	0	0	211388	0	313002	19079524		
116	7	1127433	1985-05-16	1985-05-16 00:00:00	1985-06-13	1985-06-13 00:00:00	1985-06-13	38000177		0	0	28		0	0	0	632	0	313782	1127433		
17863	1478	782047	1975-05-03	1975-05-03 00:00:00	1975-05-03	1975-05-03 00:00:00	1975-05-03	38000177		0	0	0		0	0	0	98639	0	542347	782047		
37894	3133	19129655	1964-03-28	1964-03-28 00:00:00	1964-04-11	1964-04-11 00:00:00	1964-04-11	38000177		0	0	14		0	0	0	208526	0	789980	19129655		
37948	3137	1127433	1975-04-13	1975-04-13 00:00:00	1975-05-13	1975-05-13 00:00:00	1975-05-13	38000177		0	0	30		0	0	0	208834	0	313782	1127433		
14687	1229	1713671	1983-06-02	1983-06-02 00:00:00	1983-06-23	1983-06-23 00:00:00	1983-06-23	38000177		0	0	21		0	0	0	80956	0	562251	1713671		
14755	1235	1713671	1997-07-21	1997-07-21 00:00:00	1997-08-04	1997-08-04 00:00:00	1997-08-04	38000177		0	0	14		0	0	0	81321	0	562251	1713671		
31349	2598	1713671	2004-02-05	2004-02-05 00:00:00	2004-02-19	2004-02-19 00:00:00	2004-02-19	38000177		0	0	14		0	0	0	171911	0	562251	1713671		
25278	2080	1154615	1982-10-18	1982-10-18 00:00:00	1982-10-18	1982-10-18 00:00:00	\N	38000177		0	0	0		0	0	0	138532	0	745679	1154615		
39089	3231	1127433	2001-05-30	2001-05-30 00:00:00	2001-06-13	2001-06-13 00:00:00	2001-06-13	38000177		0	0	14		0	0	0	214801	0	313782	1127433		
21809	1791	40236824	2011-12-12	2011-12-12 00:00:00	2011-12-19	2011-12-19 00:00:00	2011-12-19	38000177		0	0	7		0	0	0	120104	0	1094107	40236824		
41996	3481	1539411	1995-06-24	1995-06-24 00:00:00	1995-06-24	1995-06-24 00:00:00	\N	38000177		0	0	0		0	0	0	230870	0	312961	1539411		
49687	4121	19059056	1948-05-17	1948-05-17 00:00:00	1948-06-14	1948-06-14 00:00:00	1948-06-14	38000177		0	0	28		0	0	0	273930	0	243670	19059056		
32422	2688	19006318	1964-08-17	1964-08-17 00:00:00	1964-08-31	1964-08-31 00:00:00	1964-08-31	38000177		0	0	14		0	0	0	178096	0	105078	19006318		
35004	2891	1115171	2012-08-11	2012-08-11 00:00:00	2012-09-01	2012-09-01 00:00:00	2012-09-01	38000177		0	0	21		0	0	0	192282	0	849574	1115171		
10234	857	1127433	1979-02-09	1979-02-09 00:00:00	1979-02-23	1979-02-23 00:00:00	1979-02-23	38000177		0	0	14		0	0	0	56578	0	313782	1127433		
45554	3769	19075601	2016-04-17	2016-04-17 00:00:00	2016-04-17	2016-04-17 00:00:00	2016-04-17	38000177		0	0	0		0	0	0	250560	0	309362	19075601		
2917	236	1118084	1990-10-28	1990-10-28 00:00:00	1990-10-28	1990-10-28 00:00:00	\N	38000177		0	0	0		0	0	0	15956	0	00025152531	44923712		
57114	4739	1551192	1915-03-31	1915-03-31 00:00:00	1915-03-31	1915-03-31 00:00:00	1915-03-31	38000177		0	0	0		0	0	0	315724	0	312617	1551192		
1008	82	19115351	1973-03-18	1973-03-18 00:00:00	1973-11-18	1973-11-18 00:00:00	1973-11-18	38000177		0	0	245		0	0	0	5570	0	563026	19115351		
28753	2373	19059056	1956-09-15	1956-09-15 00:00:00	1956-09-29	1956-09-29 00:00:00	1956-09-29	38000177		0	0	14		0	0	0	157961	0	243670	19059056		
28746	624	40213227	2002-03-09	2002-03-09 00:00:00	2002-03-09	2002-03-09 00:00:00	2002-03-09	581452		0	0	0		0	0	0	41627	0	113	40213227		
62441	5196	19059056	1956-02-08	1956-02-08 00:00:00	1956-02-22	1956-02-22 00:00:00	1956-02-22	38000177		0	0	14		0	0	0	345553	0	243670	19059056		
36615	3022	1713671	1990-09-03	1990-09-03 00:00:00	1990-09-17	1990-09-17 00:00:00	1990-09-17	38000177		0	0	14		0	0	0	201445	0	562251	1713671		
44868	3714	1127433	1950-03-10	1950-03-10 00:00:00	1950-03-24	1950-03-24 00:00:00	1950-03-24	38000177		0	0	14		0	0	0	246795	0	313782	1127433		
24660	2028	1127433	2015-12-03	2015-12-03 00:00:00	2015-12-31	2015-12-31 00:00:00	2015-12-31	38000177		0	0	28		0	0	0	134977	0	313782	1127433		
23276	1918	1127433	1987-09-03	1987-09-03 00:00:00	1987-12-02	1987-12-02 00:00:00	1987-12-02	38000177		0	0	90		0	0	0	127586	0	313782	1127433		
22311	1834	1127433	1981-04-05	1981-04-05 00:00:00	1981-05-10	1981-05-10 00:00:00	1981-05-10	38000177		0	0	35		0	0	0	122542	0	313782	1127433		
36336	793	40213160	1978-05-18	1978-05-18 00:00:00	1978-05-18	1978-05-18 00:00:00	1978-05-18	581452		0	0	0		0	0	0	52633	0	10	40213160		
26224	2156	1127078	1967-06-08	1967-06-08 00:00:00	1967-08-07	1967-08-07 00:00:00	1967-08-07	38000177		0	0	60		0	0	0	143731	0	282464	1127078		
13187	285	40213296	2012-06-04	2012-06-04 00:00:00	2012-06-04	2012-06-04 00:00:00	2012-06-04	581452		0	0	0		0	0	0	19033	0	52	40213296		
36755	3035	1713671	2015-07-11	2015-07-11 00:00:00	2015-08-01	2015-08-01 00:00:00	2015-08-01	38000177		0	0	21		0	0	0	202184	0	562251	1713671		
26594	579	40213227	2012-07-04	2012-07-04 00:00:00	2012-07-04	2012-07-04 00:00:00	2012-07-04	581452		0	0	0		0	0	0	38323	0	113	40213227		
4624	384	40236824	2013-06-27	2013-06-27 00:00:00	2013-07-04	2013-07-04 00:00:00	2013-07-04	38000177		0	0	7		0	0	0	25293	0	1094107	40236824		
35738	2944	19059056	1972-09-20	1972-09-20 00:00:00	1972-10-18	1972-10-18 00:00:00	1972-10-18	38000177		0	0	28		0	0	0	196394	0	243670	19059056		
52099	4331	1127433	1989-10-27	1989-10-27 00:00:00	1989-11-10	1989-11-10 00:00:00	1989-11-10	38000177		0	0	14		0	0	0	287326	0	313782	1127433		
22666	1860	19129655	1963-03-24	1963-03-24 00:00:00	1963-04-07	1963-04-07 00:00:00	1963-04-07	38000177		0	0	14		0	0	0	124377	0	789980	19129655		
60497	5034	1127433	1989-05-02	1989-05-02 00:00:00	1989-05-16	1989-05-16 00:00:00	1989-05-16	38000177		0	0	14		0	0	0	334520	0	313782	1127433		
33566	2777	1127433	2004-05-02	2004-05-02 00:00:00	2004-05-09	2004-05-09 00:00:00	2004-05-09	38000177		0	0	7		0	0	0	183951	0	313782	1127433		
8709	727	1127433	1988-08-06	1988-08-06 00:00:00	1988-09-05	1988-09-05 00:00:00	1988-09-05	38000177		0	0	30		0	0	0	48208	0	313782	1127433		
1202	96	40236824	1986-02-05	1986-02-05 00:00:00	1986-02-12	1986-02-12 00:00:00	1986-02-12	38000177		0	0	7		0	0	0	6471	0	1094107	40236824		
56967	4725	19128022	1991-09-04	1991-09-04 00:00:00	1992-08-29	1992-08-29 00:00:00	1992-08-29	38000177		0	0	360		0	0	0	314978	0	749785	19128022		
44217	3660	920300	1998-09-23	1998-09-23 00:00:00	1998-09-30	1998-09-30 00:00:00	1998-09-30	38000177		0	0	7		0	0	0	243595	0	311989	920300		
19364	1598	19059056	1970-02-16	1970-02-16 00:00:00	1970-03-02	1970-03-02 00:00:00	1970-03-02	38000177		0	0	14		0	0	0	107217	0	243670	19059056		
29884	2477	40236824	2003-04-24	2003-04-24 00:00:00	2003-05-08	2003-05-08 00:00:00	2003-05-08	38000177		0	0	14		0	0	0	164210	0	1094107	40236824		
44105	3650	1713671	1978-04-12	1978-04-12 00:00:00	1978-07-12	1978-07-12 00:00:00	1978-07-12	38000177		0	0	91		0	0	0	242902	0	562251	1713671		
37067	3065	1713671	2004-09-22	2004-09-22 00:00:00	2004-11-17	2004-11-17 00:00:00	2004-11-17	38000177		0	0	56		0	0	0	204038	0	562251	1713671		
17182	371	40213306	1990-04-05	1990-04-05 00:00:00	1990-04-05	1990-04-05 00:00:00	1990-04-05	581452		0	0	0		0	0	0	24708	0	43	40213306		
37169	3072	46275916	1964-02-01	1964-02-01 00:00:00	1964-02-01	1964-02-01 00:00:00	1964-02-01	38000177		0	0	0		0	0	0	204459	0	1660014	46275916		
21728	1783	19133905	2008-12-19	2008-12-19 00:00:00	2008-12-26	2008-12-26 00:00:00	2008-12-26	38000177		0	0	7		0	0	0	119508	0	834102	19133905		
12932	1086	19078461	2015-04-23	2015-04-23 00:00:00	2015-06-22	2015-06-22 00:00:00	2015-06-22	38000177		0	0	60		0	0	0	71352	0	310965	19078461		
32275	2675	1127433	1969-06-18	1969-06-18 00:00:00	1969-07-02	1969-07-02 00:00:00	1969-07-02	38000177		0	0	14		0	0	0	177276	0	313782	1127433		
32602	2703	19133873	1977-07-16	1977-07-16 00:00:00	1977-07-28	1977-07-28 00:00:00	1977-07-28	38000177		0	0	12		0	0	0	179084	0	834061	19133873		
39990	871	40213260	2016-01-19	2016-01-19 00:00:00	2016-01-19	2016-01-19 00:00:00	2016-01-19	581452		0	0	0		0	0	0	57941	0	121	40213260		
59980	4986	40163554	2001-04-29	2001-04-29 00:00:00	2001-04-29	2001-04-29 00:00:00	\N	38000177		0	0	0		0	0	0	331638	0	855332	40163554		
33958	742	40213227	1996-05-13	1996-05-13 00:00:00	1996-05-13	1996-05-13 00:00:00	1996-05-13	581452		0	0	0		0	0	0	49180	0	113	40213227		
17201	1427	19078461	1983-01-28	1983-01-28 00:00:00	1983-02-18	1983-02-18 00:00:00	1983-02-18	38000177		0	0	21		0	0	0	94961	0	310965	19078461		
17246	1430	19073188	1993-12-28	1993-12-28 00:00:00	1994-01-25	1994-01-25 00:00:00	1994-01-25	38000177		0	0	28		0	0	0	95183	0	308192	19073188		
27737	2295	46233988	1974-11-28	1974-11-28 00:00:00	1974-12-12	1974-12-12 00:00:00	1974-12-12	38000177		0	0	14		0	0	0	152784	0	1652673	46233988		
13783	1151	1713671	1997-04-24	1997-04-24 00:00:00	1997-05-15	1997-05-15 00:00:00	1997-05-15	38000177		0	0	21		0	0	0	76118	0	562251	1713671		
13808	1154	920334	1995-10-12	1995-10-12 00:00:00	1995-10-19	1995-10-19 00:00:00	1995-10-19	38000177		0	0	7		0	0	0	76284	0	311995	920334		
75158	1641	40213160	1959-09-02	1959-09-02 00:00:00	1959-09-02	1959-09-02 00:00:00	1959-09-02	581452		0	0	0		0	0	0	110142	0	10	40213160		
38817	847	40213306	1988-06-10	1988-06-10 00:00:00	1988-06-10	1988-06-10 00:00:00	1988-06-10	581452		0	0	0		0	0	0	56154	0	43	40213306		
38452	3177	1127433	1986-09-08	1986-09-08 00:00:00	1986-09-15	1986-09-15 00:00:00	1986-09-15	38000177		0	0	7		0	0	0	211318	0	313782	1127433		
38475	3178	46275444	2014-03-14	2014-03-14 00:00:00	2014-03-14	2014-03-14 00:00:00	2014-03-14	38000177		0	0	0		0	0	0	211388	0	1659149	46275444		
317	23	1127433	2016-01-21	2016-01-21 00:00:00	2016-02-04	2016-02-04 00:00:00	2016-02-04	38000177		0	0	14		0	0	0	1805	0	313782	1127433		
17864	1478	19078924	1975-05-03	1975-05-03 00:00:00	1975-05-03	1975-05-03 00:00:00	1975-05-03	38000177		0	0	0		0	0	0	98639	0	311700	19078924		
37895	3133	1127433	1962-09-20	1962-09-20 00:00:00	1962-10-04	1962-10-04 00:00:00	1962-10-04	38000177		0	0	14		0	0	0	208519	0	313782	1127433		
37949	3137	1127433	1944-01-16	1944-01-16 00:00:00	1944-01-23	1944-01-23 00:00:00	1944-01-23	38000177		0	0	7		0	0	0	208825	0	313782	1127433		
14688	1229	1115171	2012-06-09	2012-06-09 00:00:00	2012-06-23	2012-06-23 00:00:00	2012-06-23	38000177		0	0	14		0	0	0	80981	0	849574	1115171		
14756	1235	1713671	2011-06-07	2011-06-07 00:00:00	2011-06-28	2011-06-28 00:00:00	2011-06-28	38000177		0	0	21		0	0	0	81349	0	562251	1713671		
31350	2599	1127078	1984-10-28	1984-10-28 00:00:00	1984-11-27	1984-11-27 00:00:00	1984-11-27	38000177		0	0	30		0	0	0	171958	0	282464	1127078		
25279	2080	40169216	1982-10-18	1982-10-18 00:00:00	1982-10-18	1982-10-18 00:00:00	\N	38000177		0	0	0		0	0	0	138532	0	895994	40169216		
39090	3231	1118084	1980-01-01	1980-01-01 00:00:00	1980-01-01	1980-01-01 00:00:00	\N	38000177		0	0	0		0	0	0	214808	0	00025152531	44923712		
21810	1791	920300	2011-12-12	2011-12-12 00:00:00	2011-12-19	2011-12-19 00:00:00	2011-12-19	38000177		0	0	7		0	0	0	120104	0	311989	920300		
41997	3481	46275916	2001-05-12	2001-05-12 00:00:00	2001-05-12	2001-05-12 00:00:00	2001-05-12	38000177		0	0	0		0	0	0	230885	0	1660014	46275916		
49688	4121	40165015	1948-05-17	1948-05-17 00:00:00	1948-05-17	1948-05-17 00:00:00	\N	38000177		0	0	0		0	0	0	273930	0	861467	40165015		
32423	2688	1127078	1964-08-17	1964-08-17 00:00:00	1964-08-31	1964-08-31 00:00:00	1964-08-31	38000177		0	0	14		0	0	0	178096	0	282464	1127078		
35005	2891	1713671	1979-11-27	1979-11-27 00:00:00	1980-02-26	1980-02-26 00:00:00	1980-02-26	38000177		0	0	91		0	0	0	192345	0	562251	1713671		
10235	857	40169281	1992-03-15	1992-03-15 00:00:00	1992-03-15	1992-03-15 00:00:00	\N	38000177		0	0	0		0	0	0	56639	0	896209	40169281		
45555	3769	40220960	2016-04-17	2016-04-17 00:00:00	2016-04-17	2016-04-17 00:00:00	2016-04-17	38000177		0	0	0		0	0	0	250560	0	1804799	40220960		
2918	236	1127433	1985-05-02	1985-05-02 00:00:00	1985-05-09	1985-05-09 00:00:00	1985-05-09	38000177		0	0	7		0	0	0	15881	0	313782	1127433		
57115	4739	19126352	1982-11-13	1982-11-13 00:00:00	1993-06-26	1993-06-26 00:00:00	1993-06-26	38000177		0	0	3878		0	0	0	315721	0	705129	19126352		
1009	82	1118084	1995-12-03	1995-12-03 00:00:00	1995-12-03	1995-12-03 00:00:00	\N	38000177		0	0	0		0	0	0	5597	0	00025152531	44923712		
28754	2373	19006318	1956-09-15	1956-09-15 00:00:00	1956-09-29	1956-09-29 00:00:00	1956-09-29	38000177		0	0	14		0	0	0	157961	0	105078	19006318		
28749	624	40213201	2007-04-07	2007-04-07 00:00:00	2007-04-07	2007-04-07 00:00:00	2007-04-07	581452		0	0	0		0	0	0	41707	0	33	40213201		
62442	5196	19078461	1993-08-20	1993-08-20 00:00:00	1993-09-17	1993-09-17 00:00:00	1993-09-17	38000177		0	0	28		0	0	0	345569	0	310965	19078461		
36616	3022	1127433	1976-03-16	1976-03-16 00:00:00	1976-03-30	1976-03-30 00:00:00	1976-03-30	38000177		0	0	14		0	0	0	201477	0	313782	1127433		
44869	3714	19059056	1949-07-07	1949-07-07 00:00:00	1949-08-04	1949-08-04 00:00:00	1949-08-04	38000177		0	0	28		0	0	0	246846	0	243670	19059056		
24661	2028	19133873	1956-11-09	1956-11-09 00:00:00	1956-11-18	1956-11-18 00:00:00	1956-11-18	38000177		0	0	9		0	0	0	134969	0	834061	19133873		
23277	1918	1127433	2002-05-25	2002-05-25 00:00:00	2002-06-01	2002-06-01 00:00:00	2002-06-01	38000177		0	0	7		0	0	0	127651	0	313782	1127433		
22312	1834	40229134	1971-06-11	1971-06-11 00:00:00	1971-06-25	1971-06-25 00:00:00	1971-06-25	38000177		0	0	14		0	0	0	122559	0	1043400	40229134		
47618	1039	40213260	2010-03-20	2010-03-20 00:00:00	2010-03-20	2010-03-20 00:00:00	2010-03-20	581452		0	0	0		0	0	0	68352	0	121	40213260		
26225	2156	1115171	2017-02-15	2017-02-15 00:00:00	2017-03-22	2017-03-22 00:00:00	2017-03-22	38000177		0	0	35		0	0	0	143687	0	849574	1115171		
13194	285	40213160	1975-03-03	1975-03-03 00:00:00	1975-03-03	1975-03-03 00:00:00	1975-03-03	581452		0	0	0		0	0	0	18960	0	10	40213160		
36756	3035	1127078	1972-04-06	1972-04-06 00:00:00	1972-04-27	1972-04-27 00:00:00	1972-04-27	38000177		0	0	21		0	0	0	202210	0	282464	1127078		
26595	579	40213260	2012-07-04	2012-07-04 00:00:00	2012-07-04	2012-07-04 00:00:00	2012-07-04	581452		0	0	0		0	0	0	38323	0	121	40213260		
4625	384	920300	2013-06-27	2013-06-27 00:00:00	2013-07-04	2013-07-04 00:00:00	2013-07-04	38000177		0	0	7		0	0	0	25293	0	311989	920300		
35739	2944	40231925	2006-10-23	2006-10-23 00:00:00	2006-10-23	2006-10-23 00:00:00	\N	38000177		0	0	0		0	0	0	196434	0	1049221	40231925		
49943	4143	19129655	1963-04-22	1963-04-22 00:00:00	1963-05-06	1963-05-06 00:00:00	1963-05-06	38000177		0	0	14		0	0	0	275381	0	789980	19129655		
22667	1861	1127078	1982-03-28	1982-03-28 00:00:00	1982-04-11	1982-04-11 00:00:00	1982-04-11	38000177		0	0	14		0	0	0	124426	0	282464	1127078		
60498	5034	40229134	1965-01-30	1965-01-30 00:00:00	1965-02-06	1965-02-06 00:00:00	1965-02-06	38000177		0	0	7		0	0	0	334517	0	1043400	40229134		
33567	2777	1713671	1988-06-28	1988-06-28 00:00:00	1988-07-12	1988-07-12 00:00:00	1988-07-12	38000177		0	0	14		0	0	0	183925	0	562251	1713671		
8710	727	40231925	1988-08-06	1988-08-06 00:00:00	1988-08-06	1988-08-06 00:00:00	\N	38000177		0	0	0		0	0	0	48208	0	1049221	40231925		
1203	96	1127433	1935-03-06	1935-03-06 00:00:00	1935-03-13	1935-03-13 00:00:00	1935-03-13	38000177		0	0	7		0	0	0	6542	0	313782	1127433		
56968	4725	920300	2000-10-20	2000-10-20 00:00:00	2000-10-27	2000-10-27 00:00:00	2000-10-27	38000177		0	0	7		0	0	0	314881	0	311989	920300		
44218	3660	1713671	2016-02-15	2016-02-15 00:00:00	2016-02-29	2016-02-29 00:00:00	2016-02-29	38000177		0	0	14		0	0	0	243569	0	562251	1713671		
19365	1598	19128065	1979-12-06	1979-12-06 00:00:00	1980-11-30	1980-11-30 00:00:00	1980-11-30	38000177		0	0	360		0	0	0	107272	0	749882	19128065		
29885	2477	920300	2001-03-23	2001-03-23 00:00:00	2001-03-30	2001-03-30 00:00:00	2001-03-30	38000177		0	0	7		0	0	0	164157	0	311989	920300		
44106	3650	1127433	2007-01-31	2007-01-31 00:00:00	2007-02-14	2007-02-14 00:00:00	2007-02-14	38000177		0	0	14		0	0	0	242992	0	313782	1127433		
37068	3065	1713671	1990-04-09	1990-04-09 00:00:00	1990-04-30	1990-04-30 00:00:00	1990-04-30	38000177		0	0	21		0	0	0	204022	0	562251	1713671		
142145	3123	40213314	1978-09-13	1978-09-13 00:00:00	1978-09-13	1978-09-13 00:00:00	1978-09-13	581452		0	0	0		0	0	0	207827	0	49	40213314		
37170	3072	40243436	1964-02-01	1964-02-01 00:00:00	1964-02-01	1964-02-01 00:00:00	1964-02-01	38000177		0	0	0		0	0	0	204459	0	1190795	40243436		
21729	1783	1551192	1974-06-14	1974-06-14 00:00:00	1974-06-14	1974-06-14 00:00:00	1974-06-14	38000177		0	0	0		0	0	0	119439	0	312617	1551192		
12933	1086	1127433	1993-12-01	1993-12-01 00:00:00	1993-12-15	1993-12-15 00:00:00	1993-12-15	38000177		0	0	14		0	0	0	71356	0	313782	1127433		
32276	2675	1713671	1992-08-06	1992-08-06 00:00:00	1992-08-13	1992-08-13 00:00:00	1992-08-13	38000177		0	0	7		0	0	0	177281	0	562251	1713671		
32603	2703	1127433	1986-02-17	1986-02-17 00:00:00	1986-03-03	1986-03-03 00:00:00	1986-03-03	38000177		0	0	14		0	0	0	179087	0	313782	1127433		
39996	871	40213160	1970-12-29	1970-12-29 00:00:00	1970-12-29	1970-12-29 00:00:00	1970-12-29	581452		0	0	0		0	0	0	57975	0	10	40213160		
59981	4986	40171902	2001-04-29	2001-04-29 00:00:00	2001-04-29	2001-04-29 00:00:00	\N	38000177		0	0	0		0	0	0	331638	0	897718	40171902		
33975	742	40213201	1991-04-15	1991-04-15 00:00:00	1991-04-15	1991-04-15 00:00:00	1991-04-15	581452		0	0	0		0	0	0	49209	0	33	40213201		
17202	1427	1127433	1968-06-03	1968-06-03 00:00:00	1968-07-03	1968-07-03 00:00:00	1968-07-03	38000177		0	0	30		0	0	0	94958	0	313782	1127433		
17247	1430	1127433	1946-02-11	1946-02-11 00:00:00	1946-02-25	1946-02-25 00:00:00	1946-02-25	38000177		0	0	14		0	0	0	95119	0	313782	1127433		
27738	2295	1127433	1996-12-23	1996-12-23 00:00:00	1997-01-06	1997-01-06 00:00:00	1997-01-06	38000177		0	0	14		0	0	0	152754	0	313782	1127433		
13784	1151	1713671	2016-12-01	2016-12-01 00:00:00	2016-12-15	2016-12-15 00:00:00	2016-12-15	38000177		0	0	14		0	0	0	76119	0	562251	1713671		
13809	1154	19128065	1985-08-28	1985-08-28 00:00:00	1986-08-23	1986-08-23 00:00:00	1986-08-23	38000177		0	0	360		0	0	0	76256	0	749882	19128065		
75159	1641	40213160	1955-06-01	1955-06-01 00:00:00	1955-06-01	1955-06-01 00:00:00	1955-06-01	581452		0	0	0		0	0	0	110120	0	10	40213160		
38822	847	40213160	1966-09-16	1966-09-16 00:00:00	1966-09-16	1966-09-16 00:00:00	1966-09-16	581452		0	0	0		0	0	0	56095	0	10	40213160		
38453	3177	40243436	2003-01-08	2003-01-08 00:00:00	2003-01-08	2003-01-08 00:00:00	2003-01-08	38000177		0	0	0		0	0	0	211350	0	1190795	40243436		
38476	3178	19059056	1984-08-07	1984-08-07 00:00:00	1984-08-21	1984-08-21 00:00:00	1984-08-21	38000177		0	0	14		0	0	0	211394	0	243670	19059056		
318	23	19073188	2016-01-21	2016-01-21 00:00:00	2016-02-04	2016-02-04 00:00:00	2016-02-04	38000177		0	0	14		0	0	0	1805	0	308192	19073188		
17865	1478	40236824	1990-04-10	1990-04-10 00:00:00	1990-04-17	1990-04-17 00:00:00	1990-04-17	38000177		0	0	7		0	0	0	98653	0	1094107	40236824		
37896	3133	19059056	1961-09-14	1961-09-14 00:00:00	1961-09-28	1961-09-28 00:00:00	1961-09-28	38000177		0	0	14		0	0	0	208460	0	243670	19059056		
37950	3137	1118084	1945-04-23	1945-04-23 00:00:00	1945-04-23	1945-04-23 00:00:00	\N	38000177		0	0	0		0	0	0	208825	0	00025152531	44923712		
14689	1229	1127433	1957-07-29	1957-07-29 00:00:00	1957-08-05	1957-08-05 00:00:00	1957-08-05	38000177		0	0	7		0	0	0	81006	0	313782	1127433		
14757	1235	19059056	1992-12-20	1992-12-20 00:00:00	1993-01-10	1993-01-10 00:00:00	1993-01-10	38000177		0	0	21		0	0	0	81339	0	243670	19059056		
31351	2599	19019979	1979-12-19	1979-12-19 00:00:00	1980-01-02	1980-01-02 00:00:00	1980-01-02	38000177		0	0	14		0	0	0	171955	0	198405	19019979		
25280	2080	40229134	2009-04-09	2009-04-09 00:00:00	2009-04-23	2009-04-23 00:00:00	2009-04-23	38000177		0	0	14		0	0	0	138541	0	1043400	40229134		
39091	3231	1127433	1960-04-27	1960-04-27 00:00:00	1960-05-11	1960-05-11 00:00:00	1960-05-11	38000177		0	0	14		0	0	0	214774	0	313782	1127433		
21811	1791	19133873	1966-02-19	1966-02-19 00:00:00	1966-03-03	1966-03-03 00:00:00	1966-03-03	38000177		0	0	12		0	0	0	120085	0	834061	19133873		
41998	3481	40243436	2001-05-12	2001-05-12 00:00:00	2001-05-12	2001-05-12 00:00:00	2001-05-12	38000177		0	0	0		0	0	0	230885	0	1190795	40243436		
49689	4121	19006318	1948-05-17	1948-05-17 00:00:00	1948-06-14	1948-06-14 00:00:00	1948-06-14	38000177		0	0	28		0	0	0	273930	0	105078	19006318		
32424	2688	1127433	2008-12-27	2008-12-27 00:00:00	2009-01-10	2009-01-10 00:00:00	2009-01-10	38000177		0	0	14		0	0	0	178152	0	313782	1127433		
35006	2891	1127078	1982-08-07	1982-08-07 00:00:00	1982-08-28	1982-08-28 00:00:00	1982-08-28	38000177		0	0	21		0	0	0	192314	0	282464	1127078		
10236	857	1127433	2000-02-27	2000-02-27 00:00:00	2000-03-05	2000-03-05 00:00:00	2000-03-05	38000177		0	0	7		0	0	0	56609	0	313782	1127433		
45556	3771	19059056	1966-11-13	1966-11-13 00:00:00	1966-12-11	1966-12-11 00:00:00	1966-12-11	38000177		0	0	28		0	0	0	250620	0	243670	19059056		
2920	236	19006318	1956-06-10	1956-06-10 00:00:00	1956-06-24	1956-06-24 00:00:00	1956-06-24	38000177		0	0	14		0	0	0	15911	0	105078	19006318		
57116	4739	19133768	1993-06-26	1993-06-26 00:00:00	1993-06-26	1993-06-26 00:00:00	1993-06-26	38000177		0	0	0		0	0	0	315731	0	833036	19133768		
1015	84	1150771	1979-04-03	1979-04-03 00:00:00	1979-04-03	1979-04-03 00:00:00	\N	38000177		0	0	0		0	0	0	5664	0	197378	1150771		
28755	2373	19059056	1957-10-10	1957-10-10 00:00:00	1958-01-08	1958-01-08 00:00:00	1958-01-08	38000177		0	0	90		0	0	0	157944	0	243670	19059056		
28753	625	40213160	1973-08-14	1973-08-14 00:00:00	1973-08-14	1973-08-14 00:00:00	1973-08-14	581452		0	0	0		0	0	0	41746	0	10	40213160		
62443	5197	19006318	1954-02-15	1954-02-15 00:00:00	1954-03-01	1954-03-01 00:00:00	1954-03-01	38000177		0	0	14		0	0	0	345631	0	105078	19006318		
36617	3022	19078461	2003-03-27	2003-03-27 00:00:00	2003-04-24	2003-04-24 00:00:00	2003-04-24	38000177		0	0	28		0	0	0	201469	0	310965	19078461		
44870	3714	40173590	2012-12-19	2012-12-19 00:00:00	2012-12-19	2012-12-19 00:00:00	\N	38000177		0	0	0		0	0	0	246855	0	904419	40173590		
24662	2028	40229134	2007-01-12	2007-01-12 00:00:00	2007-01-19	2007-01-19 00:00:00	2007-01-19	38000177		0	0	7		0	0	0	134975	0	1043400	40229134		
23278	1918	19059056	1969-10-04	1969-10-04 00:00:00	1969-10-18	1969-10-18 00:00:00	1969-10-18	38000177		0	0	14		0	0	0	127620	0	243670	19059056		
22313	1834	19006318	1946-10-31	1946-10-31 00:00:00	1946-11-14	1946-11-14 00:00:00	1946-11-14	38000177		0	0	14		0	0	0	122491	0	105078	19006318		
47620	1039	40213227	1994-10-15	1994-10-15 00:00:00	1994-10-15	1994-10-15 00:00:00	1994-10-15	581452		0	0	0		0	0	0	68368	0	113	40213227		
26226	2156	1118084	2009-03-04	2009-03-04 00:00:00	2009-03-04	2009-03-04 00:00:00	\N	38000177		0	0	0		0	0	0	143702	0	00025152531	44923712		
13198	285	40213160	1971-02-01	1971-02-01 00:00:00	1971-02-01	1971-02-01 00:00:00	1971-02-01	581452		0	0	0		0	0	0	18957	0	10	40213160		
36757	3035	1713671	1968-02-04	1968-02-04 00:00:00	1968-02-11	1968-02-11 00:00:00	1968-02-11	38000177		0	0	7		0	0	0	202185	0	562251	1713671		
26600	579	40213160	1961-11-29	1961-11-29 00:00:00	1961-11-29	1961-11-29 00:00:00	1961-11-29	581452		0	0	0		0	0	0	38352	0	10	40213160		
4626	384	1127078	1962-04-20	1962-04-20 00:00:00	1962-05-25	1962-05-25 00:00:00	1962-05-25	38000177		0	0	35		0	0	0	25352	0	282464	1127078		
35740	2944	1127433	2016-05-30	2016-05-30 00:00:00	2016-06-13	2016-06-13 00:00:00	2016-06-13	38000177		0	0	14		0	0	0	196424	0	313782	1127433		
49954	4145	1127433	1992-04-03	1992-04-03 00:00:00	1992-06-02	1992-06-02 00:00:00	1992-06-02	38000177		0	0	60		0	0	0	275464	0	313782	1127433		
22668	1861	19073183	1982-03-28	1982-03-28 00:00:00	1982-04-11	1982-04-11 00:00:00	1982-04-11	38000177		0	0	14		0	0	0	124426	0	308182	19073183		
60499	5034	1127433	1956-12-14	1956-12-14 00:00:00	1956-12-28	1956-12-28 00:00:00	1956-12-28	38000177		0	0	14		0	0	0	334516	0	313782	1127433		
33568	2778	1127078	1986-10-01	1986-10-01 00:00:00	1986-10-22	1986-10-22 00:00:00	1986-10-22	38000177		0	0	21		0	0	0	184025	0	282464	1127078		
8711	727	1115171	2013-10-24	2013-10-24 00:00:00	2013-11-07	2013-11-07 00:00:00	2013-11-07	38000177		0	0	14		0	0	0	48221	0	849574	1115171		
1204	96	19074841	1979-07-12	1979-07-12 00:00:00	1979-08-02	1979-08-02 00:00:00	1979-08-02	38000177		0	0	21		0	0	0	6507	0	309043	19074841		
56969	4725	40236824	2000-10-20	2000-10-20 00:00:00	2000-10-27	2000-10-27 00:00:00	2000-10-27	38000177		0	0	7		0	0	0	314881	0	1094107	40236824		
44219	3660	1124300	2009-09-26	2009-09-26 00:00:00	2009-09-26	2009-09-26 00:00:00	\N	38000177		0	0	0		0	0	0	243600	0	00781178901	45011828		
19366	1598	1127433	2009-09-12	2009-09-12 00:00:00	2009-09-26	2009-09-26 00:00:00	2009-09-26	38000177		0	0	14		0	0	0	107238	0	313782	1127433		
29886	2477	40236824	2001-03-23	2001-03-23 00:00:00	2001-03-30	2001-03-30 00:00:00	2001-03-30	38000177		0	0	7		0	0	0	164157	0	1094107	40236824		
44107	3651	1713671	1998-07-27	1998-07-27 00:00:00	1998-09-21	1998-09-21 00:00:00	1998-09-21	38000177		0	0	56		0	0	0	243048	0	562251	1713671		
37069	3065	1127433	1992-09-29	1992-09-29 00:00:00	1992-10-13	1992-10-13 00:00:00	1992-10-13	38000177		0	0	14		0	0	0	204037	0	313782	1127433		
142147	3123	40213251	1984-03-14	1984-03-14 00:00:00	1984-03-14	1984-03-14 00:00:00	1984-03-14	581452		0	0	0		0	0	0	207858	0	21	40213251		
26700	2199	1713671	2005-04-03	2005-04-03 00:00:00	2005-04-17	2005-04-17 00:00:00	2005-04-17	38000177		0	0	14		0	0	0	146546	0	562251	1713671		
21730	1783	1118084	2002-03-03	2002-03-03 00:00:00	2002-03-03	2002-03-03 00:00:00	\N	38000177		0	0	0		0	0	0	119432	0	00025152531	44923712		
12934	1086	1713671	1969-11-13	1969-11-13 00:00:00	1969-12-04	1969-12-04 00:00:00	1969-12-04	38000177		0	0	21		0	0	0	71310	0	562251	1713671		
32283	2677	19075001	2015-01-29	2015-01-29 00:00:00	2015-02-12	2015-02-12 00:00:00	2015-02-12	38000177		0	0	14		0	0	0	177420	0	309097	19075001		
32604	2703	1127433	1987-05-24	1987-05-24 00:00:00	1987-06-14	1987-06-14 00:00:00	1987-06-14	38000177		0	0	21		0	0	0	179105	0	313782	1127433		
40007	871	40213160	1966-04-26	1966-04-26 00:00:00	1966-04-26	1966-04-26 00:00:00	1966-04-26	581452		0	0	0		0	0	0	57944	0	10	40213160		
59982	4986	1127433	1983-06-09	1983-06-09 00:00:00	1983-06-16	1983-06-16 00:00:00	1983-06-16	38000177		0	0	7		0	0	0	331680	0	313782	1127433		
33985	742	40213227	2006-07-10	2006-07-10 00:00:00	2006-07-10	2006-07-10 00:00:00	2006-07-10	581452		0	0	0		0	0	0	49213	0	113	40213227		
17203	1427	1127433	1973-06-07	1973-06-07 00:00:00	1973-06-28	1973-06-28 00:00:00	1973-06-28	38000177		0	0	21		0	0	0	94959	0	313782	1127433		
17248	1430	1115171	2010-01-01	2010-01-01 00:00:00	2010-01-22	2010-01-22 00:00:00	2010-01-22	38000177		0	0	21		0	0	0	95184	0	849574	1115171		
27739	2295	40162522	2015-07-01	2015-07-01 00:00:00	2015-07-01	2015-07-01 00:00:00	\N	38000177		0	0	0		0	0	0	152755	0	857005	40162522		
13785	1151	1127433	2000-01-15	2000-01-15 00:00:00	2000-01-22	2000-01-22 00:00:00	2000-01-22	38000177		0	0	7		0	0	0	76088	0	313782	1127433		
13810	1154	1551192	1971-03-05	1971-03-05 00:00:00	1971-03-05	1971-03-05 00:00:00	1971-03-05	38000177		0	0	0		0	0	0	76271	0	312617	1551192		
75163	1641	40213160	1955-03-02	1955-03-02 00:00:00	1955-03-02	1955-03-02 00:00:00	1955-03-02	581452		0	0	0		0	0	0	110169	0	10	40213160		
38827	847	40213296	2006-04-14	2006-04-14 00:00:00	2006-04-14	2006-04-14 00:00:00	2006-04-14	581452		0	0	0		0	0	0	56133	0	52	40213296		
38454	3177	46275916	2003-01-08	2003-01-08 00:00:00	2003-01-08	2003-01-08 00:00:00	2003-01-08	38000177		0	0	0		0	0	0	211350	0	1660014	46275916		
38477	3178	19074841	1984-08-07	1984-08-07 00:00:00	1984-08-21	1984-08-21 00:00:00	1984-08-21	38000177		0	0	14		0	0	0	211394	0	309043	19074841		
319	23	1713671	1991-08-08	1991-08-08 00:00:00	1991-08-22	1991-08-22 00:00:00	1991-08-22	38000177		0	0	14		0	0	0	1803	0	562251	1713671		
17866	1478	920300	1990-04-10	1990-04-10 00:00:00	1990-04-17	1990-04-17 00:00:00	1990-04-17	38000177		0	0	7		0	0	0	98653	0	311989	920300		
37897	3133	19006318	1961-09-14	1961-09-14 00:00:00	1961-09-28	1961-09-28 00:00:00	1961-09-28	38000177		0	0	14		0	0	0	208460	0	105078	19006318		
37951	3137	40220960	1987-11-14	1987-11-14 00:00:00	1987-11-14	1987-11-14 00:00:00	1987-11-14	38000177		0	0	0		0	0	0	208867	0	1804799	40220960		
14690	1229	1118084	1990-09-18	1990-09-18 00:00:00	1990-09-18	1990-09-18 00:00:00	\N	38000177		0	0	0		0	0	0	80946	0	00025152531	44923712		
14758	1235	19059056	1980-02-29	1980-02-29 00:00:00	1980-03-14	1980-03-14 00:00:00	1980-03-14	38000177		0	0	14		0	0	0	81337	0	243670	19059056		
31352	2599	1127078	1980-09-14	1980-09-14 00:00:00	1980-09-28	1980-09-28 00:00:00	1980-09-28	38000177		0	0	14		0	0	0	171991	0	282464	1127078		
25281	2080	1127433	1992-02-06	1992-02-06 00:00:00	1992-02-27	1992-02-27 00:00:00	1992-02-27	38000177		0	0	21		0	0	0	138521	0	313782	1127433		
39092	3231	1127433	2005-01-29	2005-01-29 00:00:00	2005-02-12	2005-02-12 00:00:00	2005-02-12	38000177		0	0	14		0	0	0	214759	0	313782	1127433		
21812	1791	40229134	2005-07-07	2005-07-07 00:00:00	2005-07-14	2005-07-14 00:00:00	2005-07-14	38000177		0	0	7		0	0	0	120068	0	1043400	40229134		
52457	4364	19133873	1961-03-26	1961-03-26 00:00:00	1961-04-04	1961-04-04 00:00:00	1961-04-04	38000177		0	0	9		0	0	0	289449	0	834061	19133873		
49690	4121	920334	1971-09-06	1971-09-06 00:00:00	1971-09-13	1971-09-13 00:00:00	1971-09-13	38000177		0	0	7		0	0	0	273944	0	311995	920334		
32425	2688	19059056	1963-01-17	1963-01-17 00:00:00	1963-01-31	1963-01-31 00:00:00	1963-01-31	38000177		0	0	14		0	0	0	178126	0	243670	19059056		
35007	2891	1127433	2011-03-13	2011-03-13 00:00:00	2011-03-27	2011-03-27 00:00:00	2011-03-27	38000177		0	0	14		0	0	0	192372	0	313782	1127433		
10239	857	1127433	1967-04-14	1967-04-14 00:00:00	1967-04-21	1967-04-21 00:00:00	1967-04-21	38000177		0	0	7		0	0	0	56635	0	313782	1127433		
45557	3771	1713671	1983-01-21	1983-01-21 00:00:00	1983-02-04	1983-02-04 00:00:00	1983-02-04	38000177		0	0	14		0	0	0	250588	0	562251	1713671		
176841	3887	40213227	2007-10-29	2007-10-29 00:00:00	2007-10-29	2007-10-29 00:00:00	2007-10-29	581452		0	0	0		0	0	0	258374	0	113	40213227		
57117	4739	40229134	1930-08-05	1930-08-05 00:00:00	1930-08-12	1930-08-12 00:00:00	1930-08-12	38000177		0	0	7		0	0	0	315682	0	1043400	40229134		
1016	84	19133873	1974-05-16	1974-05-16 00:00:00	1974-05-26	1974-05-26 00:00:00	1974-05-26	38000177		0	0	10		0	0	0	5679	0	834061	19133873		
28756	2373	1127433	1956-09-16	1956-09-16 00:00:00	1956-09-30	1956-09-30 00:00:00	1956-09-30	38000177		0	0	14		0	0	0	157956	0	313782	1127433		
28756	625	40213160	1973-03-13	1973-03-13 00:00:00	1973-03-13	1973-03-13 00:00:00	1973-03-13	581452		0	0	0		0	0	0	41745	0	10	40213160		
62444	5197	19059056	1954-02-15	1954-02-15 00:00:00	1954-03-01	1954-03-01 00:00:00	1954-03-01	38000177		0	0	14		0	0	0	345631	0	243670	19059056		
36618	3022	1127433	2003-02-08	2003-02-08 00:00:00	2003-02-15	2003-02-15 00:00:00	2003-02-15	38000177		0	0	7		0	0	0	201454	0	313782	1127433		
44871	3714	19059056	1940-03-05	1940-03-05 00:00:00	1940-03-26	1940-03-26 00:00:00	1940-03-26	38000177		0	0	21		0	0	0	246845	0	243670	19059056		
24663	2028	1713671	1946-07-12	1946-07-12 00:00:00	1946-07-19	1946-07-19 00:00:00	1946-07-19	38000177		0	0	7		0	0	0	135004	0	562251	1713671		
23279	1918	46233988	1969-10-04	1969-10-04 00:00:00	1969-10-18	1969-10-18 00:00:00	1969-10-18	38000177		0	0	14		0	0	0	127620	0	1652673	46233988		
22314	1834	19059056	1946-10-31	1946-10-31 00:00:00	1946-11-14	1946-11-14 00:00:00	1946-11-14	38000177		0	0	14		0	0	0	122491	0	243670	19059056		
26151	2151	19059056	1926-05-31	1926-05-31 00:00:00	1926-06-28	1926-06-28 00:00:00	1926-06-28	38000177		0	0	28		0	0	0	143280	0	243670	19059056		
26227	2156	19128065	1980-07-09	1980-07-09 00:00:00	1981-07-04	1981-07-04 00:00:00	1981-07-04	38000177		0	0	360		0	0	0	143700	0	749882	19128065		
13210	286	40213227	1992-05-23	1992-05-23 00:00:00	1992-05-23	1992-05-23 00:00:00	1992-05-23	581452		0	0	0		0	0	0	19123	0	113	40213227		
36758	3035	19059056	1968-01-28	1968-01-28 00:00:00	1968-02-11	1968-02-11 00:00:00	1968-02-11	38000177		0	0	14		0	0	0	202203	0	243670	19059056		
26602	579	40213296	2004-04-21	2004-04-21 00:00:00	2004-04-21	2004-04-21 00:00:00	2004-04-21	581452		0	0	0		0	0	0	38363	0	52	40213296		
26643	580	40213227	1998-10-11	1998-10-11 00:00:00	1998-10-11	1998-10-11 00:00:00	1998-10-11	581452		0	0	0		0	0	0	38437	0	113	40213227		
35741	2944	19128065	1975-01-22	1975-01-22 00:00:00	1976-01-17	1976-01-17 00:00:00	1976-01-17	38000177		0	0	360		0	0	0	196425	0	749882	19128065		
49955	4145	19008572	2006-07-12	2006-07-12 00:00:00	2006-07-12	2006-07-12 00:00:00	\N	38000177		0	0	0		0	0	0	275513	0	106258	19008572		
22669	1861	1713671	1993-08-30	1993-08-30 00:00:00	1993-09-20	1993-09-20 00:00:00	1993-09-20	38000177		0	0	21		0	0	0	124453	0	562251	1713671		
60500	5034	19059056	1922-11-08	1922-11-08 00:00:00	1922-11-22	1922-11-22 00:00:00	1922-11-22	38000177		0	0	14		0	0	0	334521	0	243670	19059056		
33569	2778	1118084	2011-07-27	2011-07-27 00:00:00	2011-07-27	2011-07-27 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00025152531	44923712		
8712	727	40229134	1926-11-26	1926-11-26 00:00:00	1926-12-03	1926-12-03 00:00:00	1926-12-03	38000177		0	0	7		0	0	0	48142	0	1043400	40229134		
1205	96	19078461	1979-07-12	1979-07-12 00:00:00	1979-08-02	1979-08-02 00:00:00	1979-08-02	38000177		0	0	21		0	0	0	6507	0	310965	19078461		
56987	4729	1118084	2000-03-08	2000-03-08 00:00:00	2000-03-08	2000-03-08 00:00:00	\N	38000177		0	0	0		0	0	0	315079	0	00025152531	44923712		
44220	3660	1127433	2006-06-30	2006-06-30 00:00:00	2006-07-14	2006-07-14 00:00:00	2006-07-14	38000177		0	0	14		0	0	0	243586	0	313782	1127433		
19367	1598	1118084	2003-09-26	2003-09-26 00:00:00	2003-09-26	2003-09-26 00:00:00	\N	38000177		0	0	0		0	0	0	107227	0	00025152531	44923712		
29887	2477	1127433	1998-04-06	1998-04-06 00:00:00	1998-04-13	1998-04-13 00:00:00	1998-04-13	38000177		0	0	7		0	0	0	164163	0	313782	1127433		
44108	3651	1127433	2009-10-03	2009-10-03 00:00:00	2009-10-10	2009-10-10 00:00:00	2009-10-10	38000177		0	0	7		0	0	0	243069	0	313782	1127433		
37070	3065	19128022	1994-04-03	1994-04-03 00:00:00	1995-03-29	1995-03-29 00:00:00	1995-03-29	38000177		0	0	360		0	0	0	204008	0	749785	19128022		
142152	3123	40213160	1978-03-15	1978-03-15 00:00:00	1978-03-15	1978-03-15 00:00:00	1978-03-15	581452		0	0	0		0	0	0	207854	0	10	40213160		
26701	2199	1127433	1981-05-13	1981-05-13 00:00:00	1981-05-27	1981-05-27 00:00:00	1981-05-27	38000177		0	0	14		0	0	0	146544	0	313782	1127433		
21731	1783	40236824	2017-09-11	2017-09-11 00:00:00	2017-09-18	2017-09-18 00:00:00	2017-09-18	38000177		0	0	7		0	0	0	119460	0	1094107	40236824		
12935	1086	1713671	1970-05-08	1970-05-08 00:00:00	1970-05-22	1970-05-22 00:00:00	1970-05-22	38000177		0	0	14		0	0	0	71312	0	562251	1713671		
32284	2677	1127433	2015-01-29	2015-01-29 00:00:00	2015-02-12	2015-02-12 00:00:00	2015-02-12	38000177		0	0	14		0	0	0	177420	0	313782	1127433		
32605	2703	1127433	1976-10-19	1976-10-19 00:00:00	1976-11-02	1976-11-02 00:00:00	1976-11-02	38000177		0	0	14		0	0	0	179083	0	313782	1127433		
6618	558	1127433	1985-04-26	1985-04-26 00:00:00	1985-05-24	1985-05-24 00:00:00	1985-05-24	38000177		0	0	28		0	0	0	37008	0	313782	1127433		
59983	4986	1127433	1989-03-20	1989-03-20 00:00:00	1989-04-03	1989-04-03 00:00:00	1989-04-03	38000177		0	0	14		0	0	0	331681	0	313782	1127433		
26268	572	40213227	2014-11-07	2014-11-07 00:00:00	2014-11-07	2014-11-07 00:00:00	2014-11-07	581452		0	0	0		0	0	0	37884	0	113	40213227		
17204	1427	1115171	2008-08-26	2008-08-26 00:00:00	2008-09-09	2008-09-09 00:00:00	2008-09-09	38000177		0	0	14		0	0	0	94963	0	849574	1115171		
17249	1430	1127433	1971-12-16	1971-12-16 00:00:00	1971-12-23	1971-12-23 00:00:00	1971-12-23	38000177		0	0	7		0	0	0	95123	0	313782	1127433		
27740	2295	19078461	2015-07-01	2015-07-01 00:00:00	2015-08-30	2015-08-30 00:00:00	2015-08-30	38000177		0	0	60		0	0	0	152755	0	310965	19078461		
13786	1151	1127433	1994-12-30	1994-12-30 00:00:00	1995-01-06	1995-01-06 00:00:00	1995-01-06	38000177		0	0	7		0	0	0	76086	0	313782	1127433		
13811	1154	19059056	1971-10-31	1971-10-31 00:00:00	1971-11-14	1971-11-14 00:00:00	1971-11-14	38000177		0	0	14		0	0	0	76289	0	243670	19059056		
87629	1923	40213227	1994-02-18	1994-02-18 00:00:00	1994-02-18	1994-02-18 00:00:00	1994-02-18	581452		0	0	0		0	0	0	127912	0	113	40213227		
38831	847	40213160	1966-12-16	1966-12-16 00:00:00	1966-12-16	1966-12-16 00:00:00	1966-12-16	581452		0	0	0		0	0	0	56148	0	10	40213160		
38455	3177	1310034	2003-01-08	2003-01-08 00:00:00	2003-01-08	2003-01-08 00:00:00	2003-01-08	38000177		0	0	0		0	0	0	211350	0	834357	1310034		
38478	3178	1127433	1972-04-22	1972-04-22 00:00:00	1972-05-06	1972-05-06 00:00:00	1972-05-06	38000177		0	0	14		0	0	0	211370	0	313782	1127433		
320	23	1127433	2011-11-24	2011-11-24 00:00:00	2011-12-01	2011-12-01 00:00:00	2011-12-01	38000177		0	0	7		0	0	0	1804	0	313782	1127433		
17867	1478	1127433	2009-12-13	2009-12-13 00:00:00	2009-12-27	2009-12-27 00:00:00	2009-12-27	38000177		0	0	14		0	0	0	98657	0	313782	1127433		
37898	3133	1127433	2010-04-08	2010-04-08 00:00:00	2010-04-22	2010-04-22 00:00:00	2010-04-22	38000177		0	0	14		0	0	0	208459	0	313782	1127433		
37952	3137	40231925	1933-06-10	1933-06-10 00:00:00	1933-06-10	1933-06-10 00:00:00	\N	38000177		0	0	0		0	0	0	208837	0	1049221	40231925		
14703	1231	920334	1965-02-20	1965-02-20 00:00:00	1965-02-27	1965-02-27 00:00:00	1965-02-27	38000177		0	0	7		0	0	0	81082	0	311995	920334		
14759	1235	1127433	2004-01-13	2004-01-13 00:00:00	2004-02-10	2004-02-10 00:00:00	2004-02-10	38000177		0	0	28		0	0	0	81340	0	313782	1127433		
31353	2599	19074843	1980-09-14	1980-09-14 00:00:00	1980-09-28	1980-09-28 00:00:00	1980-09-28	38000177		0	0	14		0	0	0	171991	0	309045	19074843		
25282	2080	1118084	2019-05-20	2019-05-20 00:00:00	2019-05-20	2019-05-20 00:00:00	\N	38000177		0	0	0		0	0	0	138531	0	00025152531	44923712		
39093	3231	1127433	1996-07-01	1996-07-01 00:00:00	1996-07-08	1996-07-08 00:00:00	1996-07-08	38000177		0	0	7		0	0	0	214777	0	313782	1127433		
21813	1791	1115171	1996-08-01	1996-08-01 00:00:00	1996-09-05	1996-09-05 00:00:00	1996-09-05	38000177		0	0	35		0	0	0	120058	0	849574	1115171		
52458	4364	19133873	1961-09-05	1961-09-05 00:00:00	1961-09-18	1961-09-18 00:00:00	1961-09-18	38000177		0	0	13		0	0	0	289454	0	834061	19133873		
49691	4121	19059056	1952-05-24	1952-05-24 00:00:00	1952-07-23	1952-07-23 00:00:00	1952-07-23	38000177		0	0	60		0	0	0	273931	0	243670	19059056		
32426	2688	19129655	1963-01-17	1963-01-17 00:00:00	1963-01-31	1963-01-31 00:00:00	1963-01-31	38000177		0	0	14		0	0	0	178126	0	789980	19129655		
35008	2892	1127433	1997-07-18	1997-07-18 00:00:00	1997-08-01	1997-08-01 00:00:00	1997-08-01	38000177		0	0	14		0	0	0	192397	0	313782	1127433		
10242	857	19006318	1954-02-20	1954-02-20 00:00:00	1954-03-06	1954-03-06 00:00:00	1954-03-06	38000177		0	0	14		0	0	0	56610	0	105078	19006318		
45558	3771	1118084	1996-09-11	1996-09-11 00:00:00	1996-09-11	1996-09-11 00:00:00	\N	38000177		0	0	0		0	0	0	250641	0	00025152531	44923712		
176842	3887	40213260	2007-10-29	2007-10-29 00:00:00	2007-10-29	2007-10-29 00:00:00	2007-10-29	581452		0	0	0		0	0	0	258374	0	121	40213260		
57118	4739	19059056	1913-09-07	1913-09-07 00:00:00	1913-09-21	1913-09-21 00:00:00	1913-09-21	38000177		0	0	14		0	0	0	315723	0	243670	19059056		
1017	84	19129655	1975-04-08	1975-04-08 00:00:00	1975-04-22	1975-04-22 00:00:00	1975-04-22	38000177		0	0	14		0	0	0	5675	0	789980	19129655		
28757	2373	1127433	1973-02-23	1973-02-23 00:00:00	1973-03-09	1973-03-09 00:00:00	1973-03-09	38000177		0	0	14		0	0	0	157947	0	313782	1127433		
28759	625	40213160	1973-05-15	1973-05-15 00:00:00	1973-05-15	1973-05-15 00:00:00	1973-05-15	581452		0	0	0		0	0	0	41779	0	10	40213160		
62445	5197	1713671	2005-08-12	2005-08-12 00:00:00	2005-08-19	2005-08-19 00:00:00	2005-08-19	38000177		0	0	7		0	0	0	345585	0	562251	1713671		
36619	3022	46233988	1972-12-01	1972-12-01 00:00:00	1972-12-15	1972-12-15 00:00:00	1972-12-15	38000177		0	0	14		0	0	0	201448	0	1652673	46233988		
44872	3714	40163554	2005-11-09	2005-11-09 00:00:00	2005-11-09	2005-11-09 00:00:00	\N	38000177		0	0	0		0	0	0	246875	0	855332	40163554		
24664	2028	40229134	2016-09-24	2016-09-24 00:00:00	2016-10-01	2016-10-01 00:00:00	2016-10-01	38000177		0	0	7		0	0	0	135010	0	1043400	40229134		
23280	1918	1127433	1984-06-01	1984-06-01 00:00:00	1984-06-15	1984-06-15 00:00:00	1984-06-15	38000177		0	0	14		0	0	0	127595	0	313782	1127433		
22315	1834	19133905	1970-12-13	1970-12-13 00:00:00	1970-12-25	1970-12-25 00:00:00	1970-12-25	38000177		0	0	12		0	0	0	122558	0	834102	19133905		
26152	2151	19126352	1988-07-13	1988-07-13 00:00:00	1999-12-08	1999-12-08 00:00:00	1999-12-08	38000177		0	0	4165		0	0	0	143277	0	705129	19126352		
26228	2156	1713671	1988-12-31	1988-12-31 00:00:00	1989-01-07	1989-01-07 00:00:00	1989-01-07	38000177		0	0	7		0	0	0	143745	0	562251	1713671		
13219	286	40213227	2019-05-18	2019-05-18 00:00:00	2019-05-18	2019-05-18 00:00:00	2019-05-18	581452		0	0	0		0	0	0	19155	0	113	40213227		
36759	3035	19129655	1968-01-28	1968-01-28 00:00:00	1968-02-11	1968-02-11 00:00:00	1968-02-11	38000177		0	0	14		0	0	0	202203	0	789980	19129655		
26606	579	40213227	1992-10-14	1992-10-14 00:00:00	1992-10-14	1992-10-14 00:00:00	1992-10-14	581452		0	0	0		0	0	0	38370	0	113	40213227		
26653	580	40213227	2007-12-02	2007-12-02 00:00:00	2007-12-02	2007-12-02 00:00:00	2007-12-02	581452		0	0	0		0	0	0	38478	0	113	40213227		
35742	2944	19128065	1976-01-17	1976-01-17 00:00:00	1977-01-11	1977-01-11 00:00:00	1977-01-11	38000177		0	0	360		0	0	0	196407	0	749882	19128065		
49956	4145	1115171	2012-09-15	2012-09-15 00:00:00	2012-09-29	2012-09-29 00:00:00	2012-09-29	38000177		0	0	14		0	0	0	275465	0	849574	1115171		
22670	1861	1115171	1995-02-28	1995-02-28 00:00:00	1995-04-29	1995-04-29 00:00:00	1995-04-29	38000177		0	0	60		0	0	0	124414	0	849574	1115171		
60501	5034	1127433	1927-11-28	1927-11-28 00:00:00	1927-12-05	1927-12-05 00:00:00	1927-12-05	38000177		0	0	7		0	0	0	334440	0	313782	1127433		
33570	2778	1150771	1978-02-02	1978-02-02 00:00:00	1978-02-02	1978-02-02 00:00:00	\N	38000177		0	0	0		0	0	0	183994	0	197378	1150771		
8713	727	19059056	1915-04-07	1915-04-07 00:00:00	1915-04-21	1915-04-21 00:00:00	1915-04-21	38000177		0	0	14		0	0	0	48169	0	243670	19059056		
1206	96	1545959	1997-01-25	1997-01-25 00:00:00	1997-01-25	1997-01-25 00:00:00	1997-01-25	38000177		0	0	0		0	0	0	6509	0	259255	1545959		
56988	4729	19078461	2000-09-05	2000-09-05 00:00:00	2000-10-03	2000-10-03 00:00:00	2000-10-03	38000177		0	0	28		0	0	0	315107	0	310965	19078461		
44221	3660	1127433	2017-10-09	2017-10-09 00:00:00	2017-11-13	2017-11-13 00:00:00	2017-11-13	38000177		0	0	35		0	0	0	243608	0	313782	1127433		
19368	1598	40229134	2011-06-19	2011-06-19 00:00:00	2011-07-03	2011-07-03 00:00:00	2011-07-03	38000177		0	0	14		0	0	0	107247	0	1043400	40229134		
29888	2477	1127433	1982-02-24	1982-02-24 00:00:00	1982-03-31	1982-03-31 00:00:00	1982-03-31	38000177		0	0	35		0	0	0	164183	0	313782	1127433		
44109	3651	19078461	1975-07-04	1975-07-04 00:00:00	1975-07-25	1975-07-25 00:00:00	1975-07-25	38000177		0	0	21		0	0	0	243044	0	310965	19078461		
37071	3065	1127433	1976-10-19	1976-10-19 00:00:00	1976-11-02	1976-11-02 00:00:00	1976-11-02	38000177		0	0	14		0	0	0	204057	0	313782	1127433		
142158	3123	40213227	2011-02-16	2011-02-16 00:00:00	2011-02-16	2011-02-16 00:00:00	2011-02-16	581452		0	0	0		0	0	0	207808	0	113	40213227		
26702	2199	40229134	2016-02-27	2016-02-27 00:00:00	2016-03-12	2016-03-12 00:00:00	2016-03-12	38000177		0	0	14		0	0	0	146591	0	1043400	40229134		
21732	1783	920300	2017-09-11	2017-09-11 00:00:00	2017-09-18	2017-09-18 00:00:00	2017-09-18	38000177		0	0	7		0	0	0	119460	0	311989	920300		
12936	1086	1127433	1980-03-19	1980-03-19 00:00:00	1980-04-02	1980-04-02 00:00:00	1980-04-02	38000177		0	0	14		0	0	0	71354	0	313782	1127433		
32285	2677	1713671	1986-06-27	1986-06-27 00:00:00	1986-07-04	1986-07-04 00:00:00	1986-07-04	38000177		0	0	7		0	0	0	177366	0	562251	1713671		
32606	2703	19078461	2015-08-24	2015-08-24 00:00:00	2015-09-07	2015-09-07 00:00:00	2015-09-07	38000177		0	0	14		0	0	0	179111	0	310965	19078461		
6619	558	19078461	2002-12-12	2002-12-12 00:00:00	2003-01-09	2003-01-09 00:00:00	2003-01-09	38000177		0	0	28		0	0	0	36977	0	310965	19078461		
59984	4986	1713671	1970-06-13	1970-06-13 00:00:00	1970-07-04	1970-07-04 00:00:00	1970-07-04	38000177		0	0	21		0	0	0	331691	0	562251	1713671		
26271	572	40213260	2006-11-10	2006-11-10 00:00:00	2006-11-10	2006-11-10 00:00:00	2006-11-10	581452		0	0	0		0	0	0	37857	0	121	40213260		
17205	1427	40165015	2008-08-26	2008-08-26 00:00:00	2008-08-26	2008-08-26 00:00:00	\N	38000177		0	0	0		0	0	0	94963	0	861467	40165015		
17250	1430	1127433	1986-04-25	1986-04-25 00:00:00	1986-05-09	1986-05-09 00:00:00	1986-05-09	38000177		0	0	14		0	0	0	95182	0	313782	1127433		
27741	2295	19019979	1980-07-29	1980-07-29 00:00:00	1980-08-19	1980-08-19 00:00:00	1980-08-19	38000177		0	0	21		0	0	0	152753	0	198405	19019979		
13787	1151	19133873	1986-11-14	1986-11-14 00:00:00	1986-11-25	1986-11-25 00:00:00	1986-11-25	38000177		0	0	11		0	0	0	76123	0	834061	19133873		
13812	1154	19128065	1988-08-12	1988-08-12 00:00:00	1989-08-07	1989-08-07 00:00:00	1989-08-07	38000177		0	0	360		0	0	0	76269	0	749882	19128065		
168050	3694	40213160	1957-07-16	1957-07-16 00:00:00	1957-07-16	1957-07-16 00:00:00	1957-07-16	581452		0	0	0		0	0	0	245518	0	10	40213160		
38836	847	40213260	2016-12-30	2016-12-30 00:00:00	2016-12-30	2016-12-30 00:00:00	2016-12-30	581452		0	0	0		0	0	0	56119	0	121	40213260		
38456	3177	1127433	2008-06-05	2008-06-05 00:00:00	2008-06-19	2008-06-19 00:00:00	2008-06-19	38000177		0	0	14		0	0	0	211321	0	313782	1127433		
38479	3178	1127433	2018-09-04	2018-09-04 00:00:00	2018-09-18	2018-09-18 00:00:00	2018-09-18	38000177		0	0	14		0	0	0	211377	0	313782	1127433		
321	23	1118084	2012-05-11	2012-05-11 00:00:00	2012-05-11	2012-05-11 00:00:00	\N	38000177		0	0	0		0	0	0	1804	0	00025152531	44923712		
17868	1478	19133905	2015-07-21	2015-07-21 00:00:00	2015-07-29	2015-07-29 00:00:00	2015-07-29	38000177		0	0	8		0	0	0	98633	0	834102	19133905		
37899	3133	19059056	1958-10-21	1958-10-21 00:00:00	1958-11-04	1958-11-04 00:00:00	1958-11-04	38000177		0	0	14		0	0	0	208473	0	243670	19059056		
37953	3137	19059056	1933-06-10	1933-06-10 00:00:00	1933-07-08	1933-07-08 00:00:00	1933-07-08	38000177		0	0	28		0	0	0	208837	0	243670	19059056		
14704	1231	1127433	1992-07-26	1992-07-26 00:00:00	1992-08-16	1992-08-16 00:00:00	1992-08-16	38000177		0	0	21		0	0	0	81118	0	313782	1127433		
14760	1235	1118084	2010-09-04	2010-09-04 00:00:00	2010-09-04	2010-09-04 00:00:00	\N	38000177		0	0	0		0	0	0	81345	0	00025152531	44923712		
31354	2599	42902245	1998-12-27	1998-12-27 00:00:00	1999-12-22	1999-12-22 00:00:00	1999-12-22	38000177		0	0	360		0	0	0	171986	0	1359133	42902245		
25291	2082	19059056	1945-01-20	1945-01-20 00:00:00	1945-02-24	1945-02-24 00:00:00	1945-02-24	38000177		0	0	35		0	0	0	138659	0	243670	19059056		
39094	3231	1127433	1954-07-12	1954-07-12 00:00:00	1954-07-26	1954-07-26 00:00:00	1954-07-26	38000177		0	0	14		0	0	0	214769	0	313782	1127433		
21814	1791	19073188	1996-08-01	1996-08-01 00:00:00	1996-09-05	1996-09-05 00:00:00	1996-09-05	38000177		0	0	35		0	0	0	120058	0	308192	19073188		
52459	4365	1127078	1963-06-11	1963-06-11 00:00:00	1963-06-25	1963-06-25 00:00:00	1963-06-25	38000177		0	0	14		0	0	0	289564	0	282464	1127078		
49692	4121	1713671	1925-09-28	1925-09-28 00:00:00	1925-10-19	1925-10-19 00:00:00	1925-10-19	38000177		0	0	21		0	0	0	273956	0	562251	1713671		
32427	2688	1127433	1970-01-27	1970-01-27 00:00:00	1970-02-10	1970-02-10 00:00:00	1970-02-10	38000177		0	0	14		0	0	0	178144	0	313782	1127433		
35009	2892	1713671	1985-04-21	1985-04-21 00:00:00	1985-05-05	1985-05-05 00:00:00	1985-05-05	38000177		0	0	14		0	0	0	192396	0	562251	1713671		
42548	3528	1127433	1994-05-17	1994-05-17 00:00:00	1994-05-24	1994-05-24 00:00:00	1994-05-24	38000177		0	0	7		0	0	0	234192	0	313782	1127433		
45559	3771	1127433	1989-06-18	1989-06-18 00:00:00	1989-07-23	1989-07-23 00:00:00	1989-07-23	38000177		0	0	35		0	0	0	250622	0	313782	1127433		
176851	3887	40213260	2006-10-23	2006-10-23 00:00:00	2006-10-23	2006-10-23 00:00:00	2006-10-23	581452		0	0	0		0	0	0	258382	0	121	40213260		
57119	4739	1127433	1943-12-27	1943-12-27 00:00:00	1944-01-10	1944-01-10 00:00:00	1944-01-10	38000177		0	0	14		0	0	0	315701	0	313782	1127433		
1018	84	19019979	1975-04-08	1975-04-08 00:00:00	1975-04-22	1975-04-22 00:00:00	1975-04-22	38000177		0	0	14		0	0	0	5675	0	198405	19019979		
60825	5058	1127433	2014-07-17	2014-07-17 00:00:00	2014-09-22	2014-09-22 00:00:00	2014-09-22	38000177		0	0	67		0	0	0	336348	0	313782	1127433		
28765	625	40213314	1977-11-15	1977-11-15 00:00:00	1977-11-15	1977-11-15 00:00:00	1977-11-15	581452		0	0	0		0	0	0	41781	0	49	40213314		
62446	5197	19059056	1959-03-21	1959-03-21 00:00:00	1959-04-25	1959-04-25 00:00:00	1959-04-25	38000177		0	0	35		0	0	0	345570	0	243670	19059056		
36620	3022	1127078	1972-12-01	1972-12-01 00:00:00	1972-12-15	1972-12-15 00:00:00	1972-12-15	38000177		0	0	14		0	0	0	201448	0	282464	1127078		
44873	3714	40171902	2005-11-09	2005-11-09 00:00:00	2005-11-09	2005-11-09 00:00:00	\N	38000177		0	0	0		0	0	0	246875	0	897718	40171902		
24666	2028	1127433	1967-04-02	1967-04-02 00:00:00	1967-04-16	1967-04-16 00:00:00	1967-04-16	38000177		0	0	14		0	0	0	134990	0	313782	1127433		
23281	1918	1127078	1973-09-27	1973-09-27 00:00:00	1973-11-01	1973-11-01 00:00:00	1973-11-01	38000177		0	0	35		0	0	0	127604	0	282464	1127078		
22316	1834	1713671	1976-01-06	1976-01-06 00:00:00	1976-01-20	1976-01-20 00:00:00	1976-01-20	38000177		0	0	14		0	0	0	122537	0	562251	1713671		
26153	2151	1127433	1969-03-17	1969-03-17 00:00:00	1969-03-31	1969-03-31 00:00:00	1969-03-31	38000177		0	0	14		0	0	0	143257	0	313782	1127433		
36692	3028	1127433	2010-05-27	2010-05-27 00:00:00	2010-06-03	2010-06-03 00:00:00	2010-06-03	38000177		0	0	7		0	0	0	201897	0	313782	1127433		
13220	286	40213227	2010-03-27	2010-03-27 00:00:00	2010-03-27	2010-03-27 00:00:00	2010-03-27	581452		0	0	0		0	0	0	19154	0	113	40213227		
36760	3035	1127433	1986-10-30	1986-10-30 00:00:00	1986-11-06	1986-11-06 00:00:00	1986-11-06	38000177		0	0	7		0	0	0	202168	0	313782	1127433		
26613	579	40213160	1965-12-01	1965-12-01 00:00:00	1965-12-01	1965-12-01 00:00:00	1965-12-01	581452		0	0	0		0	0	0	38330	0	10	40213160		
40251	3332	1127078	1969-07-22	1969-07-22 00:00:00	1969-10-20	1969-10-20 00:00:00	1969-10-20	38000177		0	0	90		0	0	0	221130	0	282464	1127078		
35743	2944	1115171	2006-10-16	2006-10-16 00:00:00	2006-12-22	2006-12-22 00:00:00	2006-12-22	38000177		0	0	67		0	0	0	196397	0	849574	1115171		
49957	4145	1594382	2006-07-29	2006-07-29 00:00:00	2006-07-29	2006-07-29 00:00:00	\N	38000177		0	0	0		0	0	0	275533	0	1870230	1594382		
22671	1861	40162522	1995-02-28	1995-02-28 00:00:00	1995-02-28	1995-02-28 00:00:00	\N	38000177		0	0	0		0	0	0	124414	0	857005	40162522		
60502	5034	1127433	1967-04-07	1967-04-07 00:00:00	1967-04-28	1967-04-28 00:00:00	1967-04-28	38000177		0	0	21		0	0	0	334460	0	313782	1127433		
33571	2778	1127433	2011-04-12	2011-04-12 00:00:00	2011-04-19	2011-04-19 00:00:00	2011-04-19	38000177		0	0	7		0	0	0	184081	0	313782	1127433		
8714	727	1127433	1949-09-20	1949-09-20 00:00:00	1949-09-27	1949-09-27 00:00:00	1949-09-27	38000177		0	0	7		0	0	0	48242	0	313782	1127433		
1207	96	19133768	1997-01-25	1997-01-25 00:00:00	1997-01-25	1997-01-25 00:00:00	1997-01-25	38000177		0	0	0		0	0	0	6509	0	833036	19133768		
25865	2127	1713671	1976-08-21	1976-08-21 00:00:00	1976-09-04	1976-09-04 00:00:00	1976-09-04	38000177		0	0	14		0	0	0	141488	0	562251	1713671		
44222	3660	1127433	2005-04-28	2005-04-28 00:00:00	2005-05-05	2005-05-05 00:00:00	2005-05-05	38000177		0	0	7		0	0	0	243565	0	313782	1127433		
19369	1598	19078461	1989-03-22	1989-03-22 00:00:00	1989-04-05	1989-04-05 00:00:00	1989-04-05	38000177		0	0	14		0	0	0	107218	0	310965	19078461		
29889	2477	19059056	1969-10-02	1969-10-02 00:00:00	1969-10-30	1969-10-30 00:00:00	1969-10-30	38000177		0	0	28		0	0	0	164119	0	243670	19059056		
44110	3651	40229134	1992-01-07	1992-01-07 00:00:00	1992-01-21	1992-01-21 00:00:00	1992-01-21	38000177		0	0	14		0	0	0	243051	0	1043400	40229134		
37072	3065	46233988	1974-10-28	1974-10-28 00:00:00	1974-11-11	1974-11-11 00:00:00	1974-11-11	38000177		0	0	14		0	0	0	204045	0	1652673	46233988		
142159	3123	40213314	1977-10-12	1977-10-12 00:00:00	1977-10-12	1977-10-12 00:00:00	1977-10-12	581452		0	0	0		0	0	0	207789	0	49	40213314		
26703	2199	19133873	1996-01-02	1996-01-02 00:00:00	1996-01-10	1996-01-10 00:00:00	1996-01-10	38000177		0	0	8		0	0	0	146588	0	834061	19133873		
21733	1783	1127433	1968-04-11	1968-04-11 00:00:00	1968-04-18	1968-04-18 00:00:00	1968-04-18	38000177		0	0	7		0	0	0	119414	0	313782	1127433		
12940	1088	19128065	1990-07-06	1990-07-06 00:00:00	1991-07-01	1991-07-01 00:00:00	1991-07-01	38000177		0	0	360		0	0	0	71419	0	749882	19128065		
32286	2677	19059056	1974-11-30	1974-11-30 00:00:00	1974-12-30	1974-12-30 00:00:00	1974-12-30	38000177		0	0	30		0	0	0	177357	0	243670	19059056		
32607	2703	19115351	1974-03-03	1974-03-03 00:00:00	1974-09-29	1974-09-29 00:00:00	1974-09-29	38000177		0	0	210		0	0	0	179053	0	563026	19115351		
6620	558	1118084	2002-03-13	2002-03-13 00:00:00	2002-03-13	2002-03-13 00:00:00	\N	38000177		0	0	0		0	0	0	37039	0	00025152531	44923712		
59985	4986	1127433	1979-03-13	1979-03-13 00:00:00	1979-04-10	1979-04-10 00:00:00	1979-04-10	38000177		0	0	28		0	0	0	331616	0	313782	1127433		
26272	572	40213160	1956-03-30	1956-03-30 00:00:00	1956-03-30	1956-03-30 00:00:00	1956-03-30	581452		0	0	0		0	0	0	37900	0	10	40213160		
17206	1427	19075001	2008-08-26	2008-08-26 00:00:00	2008-09-09	2008-09-09 00:00:00	2008-09-09	38000177		0	0	14		0	0	0	94963	0	309097	19075001		
17251	1430	19059056	1972-02-24	1972-02-24 00:00:00	1972-03-09	1972-03-09 00:00:00	1972-03-09	38000177		0	0	14		0	0	0	95181	0	243670	19059056		
27742	2295	1124300	2005-10-21	2005-10-21 00:00:00	2005-10-21	2005-10-21 00:00:00	\N	38000177		0	0	0		0	0	0	152782	0	00781178901	45011828		
13788	1151	1127433	2014-01-26	2014-01-26 00:00:00	2014-02-09	2014-02-09 00:00:00	2014-02-09	38000177		0	0	14		0	0	0	76129	0	313782	1127433		
13814	1154	1124300	2006-07-14	2006-07-14 00:00:00	2006-07-14	2006-07-14 00:00:00	\N	38000177		0	0	0		0	0	0	76262	0	00781178901	45011828		
168052	3694	40213227	2008-04-15	2008-04-15 00:00:00	2008-04-15	2008-04-15 00:00:00	2008-04-15	581452		0	0	0		0	0	0	245525	0	113	40213227		
38841	847	40213227	2018-01-05	2018-01-05 00:00:00	2018-01-05	2018-01-05 00:00:00	2018-01-05	581452		0	0	0		0	0	0	56157	0	113	40213227		
38457	3177	1127433	1984-03-27	1984-03-27 00:00:00	1984-04-10	1984-04-10 00:00:00	1984-04-10	38000177		0	0	14		0	0	0	211252	0	313782	1127433		
38480	3178	1127078	1962-09-11	1962-09-11 00:00:00	1962-10-09	1962-10-09 00:00:00	1962-10-09	38000177		0	0	28		0	0	0	211387	0	282464	1127078		
322	23	1127078	1986-04-28	1986-04-28 00:00:00	1986-05-19	1986-05-19 00:00:00	1986-05-19	38000177		0	0	21		0	0	0	1774	0	282464	1127078		
17869	1478	19133873	1961-10-19	1961-10-19 00:00:00	1961-10-30	1961-10-30 00:00:00	1961-10-30	38000177		0	0	11		0	0	0	98621	0	834061	19133873		
37900	3133	1124300	1989-06-03	1989-06-03 00:00:00	1989-06-03	1989-06-03 00:00:00	\N	38000177		0	0	0		0	0	0	208470	0	00781178901	45011828		
37954	3137	40236824	1943-06-21	1943-06-21 00:00:00	1943-06-28	1943-06-28 00:00:00	1943-06-28	38000177		0	0	7		0	0	0	208824	0	1094107	40236824		
14705	1231	19133905	1958-06-21	1958-06-21 00:00:00	1958-07-02	1958-07-02 00:00:00	1958-07-02	38000177		0	0	11		0	0	0	81152	0	834102	19133905		
14761	1235	19133905	2005-02-20	2005-02-20 00:00:00	2005-03-04	2005-03-04 00:00:00	2005-03-04	38000177		0	0	12		0	0	0	81348	0	834102	19133905		
31355	2599	1127078	1988-08-24	1988-08-24 00:00:00	1988-09-07	1988-09-07 00:00:00	1988-09-07	38000177		0	0	14		0	0	0	172006	0	282464	1127078		
25292	2082	1127433	2017-02-20	2017-02-20 00:00:00	2017-04-21	2017-04-21 00:00:00	2017-04-21	38000177		0	0	60		0	0	0	138721	0	313782	1127433		
39095	3231	19133873	1962-09-01	1962-09-01 00:00:00	1962-09-11	1962-09-11 00:00:00	1962-09-11	38000177		0	0	10		0	0	0	214798	0	834061	19133873		
21815	1791	19059056	1965-05-01	1965-05-01 00:00:00	1965-06-05	1965-06-05 00:00:00	1965-06-05	38000177		0	0	35		0	0	0	120076	0	243670	19059056		
52460	4365	19006318	1963-06-11	1963-06-11 00:00:00	1963-06-25	1963-06-25 00:00:00	1963-06-25	38000177		0	0	14		0	0	0	289564	0	105078	19006318		
49693	4121	40236824	1971-06-15	1971-06-15 00:00:00	1971-06-22	1971-06-22 00:00:00	1971-06-22	38000177		0	0	7		0	0	0	273989	0	1094107	40236824		
32428	2688	19059056	1973-06-23	1973-06-23 00:00:00	1973-07-21	1973-07-21 00:00:00	1973-07-21	38000177		0	0	28		0	0	0	178162	0	243670	19059056		
35010	2892	1127078	1974-01-22	1974-01-22 00:00:00	1974-02-05	1974-02-05 00:00:00	1974-02-05	38000177		0	0	14		0	0	0	192399	0	282464	1127078		
42549	3528	19074679	1958-11-03	1958-11-03 00:00:00	1958-12-29	1958-12-29 00:00:00	1958-12-29	38000177		0	0	56		0	0	0	234247	0	308971	19074679		
45560	3771	19059056	1970-12-20	1970-12-20 00:00:00	1971-01-24	1971-01-24 00:00:00	1971-01-24	38000177		0	0	35		0	0	0	250621	0	243670	19059056		
188133	4131	40213160	1981-05-22	1981-05-22 00:00:00	1981-05-22	1981-05-22 00:00:00	1981-05-22	581452		0	0	0		0	0	0	274698	0	10	40213160		
57120	4739	1118084	1952-01-31	1952-01-31 00:00:00	1952-01-31	1952-01-31 00:00:00	\N	38000177		0	0	0		0	0	0	315740	0	00025152531	44923712		
1019	84	1127433	1996-11-08	1996-11-08 00:00:00	1996-11-22	1996-11-22 00:00:00	1996-11-22	38000177		0	0	14		0	0	0	5652	0	313782	1127433		
60826	5058	1127433	1991-04-19	1991-04-19 00:00:00	1991-05-03	1991-05-03 00:00:00	1991-05-03	38000177		0	0	14		0	0	0	336306	0	313782	1127433		
28766	625	40213160	1977-11-15	1977-11-15 00:00:00	1977-11-15	1977-11-15 00:00:00	1977-11-15	581452		0	0	0		0	0	0	41781	0	10	40213160		
62447	5197	40229134	1986-10-21	1986-10-21 00:00:00	1986-11-04	1986-11-04 00:00:00	1986-11-04	38000177		0	0	14		0	0	0	345594	0	1043400	40229134		
36621	3022	1118084	2012-04-15	2012-04-15 00:00:00	2012-04-15	2012-04-15 00:00:00	\N	38000177		0	0	0		0	0	0	201475	0	00025152531	44923712		
44874	3714	19018935	2005-11-09	2005-11-09 00:00:00	2005-11-09	2005-11-09 00:00:00	\N	38000177		0	0	0		0	0	0	246875	0	197604	19018935		
24667	2028	1127433	1959-03-29	1959-03-29 00:00:00	1959-04-12	1959-04-12 00:00:00	1959-04-12	38000177		0	0	14		0	0	0	135006	0	313782	1127433		
23282	1918	1115171	2018-08-21	2018-08-21 00:00:00	2018-09-11	2018-09-11 00:00:00	2018-09-11	38000177		0	0	21		0	0	0	127587	0	849574	1115171		
22317	1834	1127433	1955-05-18	1955-05-18 00:00:00	1955-06-01	1955-06-01 00:00:00	1955-06-01	38000177		0	0	14		0	0	0	122534	0	313782	1127433		
26154	2151	1713671	1930-01-01	1930-01-01 00:00:00	1930-01-08	1930-01-08 00:00:00	1930-01-08	38000177		0	0	7		0	0	0	143269	0	562251	1713671		
36693	3028	40171902	2007-05-17	2007-05-17 00:00:00	2007-05-17	2007-05-17 00:00:00	\N	38000177		0	0	0		0	0	0	201875	0	897718	40171902		
13229	286	40213201	1994-06-04	1994-06-04 00:00:00	1994-06-04	1994-06-04 00:00:00	1994-06-04	581452		0	0	0		0	0	0	19124	0	33	40213201		
36761	3035	40229134	1974-08-25	1974-08-25 00:00:00	1974-09-01	1974-09-01 00:00:00	1974-09-01	38000177		0	0	7		0	0	0	202180	0	1043400	40229134		
26614	579	40213160	1961-08-30	1961-08-30 00:00:00	1961-08-30	1961-08-30 00:00:00	1961-08-30	581452		0	0	0		0	0	0	38306	0	10	40213160		
40252	3334	19133873	1959-12-13	1959-12-13 00:00:00	1959-12-22	1959-12-22 00:00:00	1959-12-22	38000177		0	0	9		0	0	0	221145	0	834061	19133873		
35744	2944	19059056	1970-11-09	1970-11-09 00:00:00	1970-11-30	1970-11-30 00:00:00	1970-11-30	38000177		0	0	21		0	0	0	196393	0	243670	19059056		
49958	4145	40223834	2006-07-29	2006-07-29 00:00:00	2006-07-29	2006-07-29 00:00:00	\N	38000177		0	0	0		0	0	0	275533	0	997501	40223834		
22672	1861	1127433	1993-12-30	1993-12-30 00:00:00	1994-02-03	1994-02-03 00:00:00	1994-02-03	38000177		0	0	35		0	0	0	124413	0	313782	1127433		
60503	5034	19133768	1994-02-26	1994-02-26 00:00:00	1994-02-26	1994-02-26 00:00:00	1994-02-26	38000177		0	0	0		0	0	0	334463	0	833036	19133768		
33572	2778	40229134	1978-07-17	1978-07-17 00:00:00	1978-07-24	1978-07-24 00:00:00	1978-07-24	38000177		0	0	7		0	0	0	184005	0	1043400	40229134		
8715	727	19133873	1920-02-06	1920-02-06 00:00:00	1920-02-17	1920-02-17 00:00:00	1920-02-17	38000177		0	0	11		0	0	0	48175	0	834061	19133873		
1208	96	19075601	1997-01-25	1997-01-25 00:00:00	1997-01-25	1997-01-25 00:00:00	1997-01-25	38000177		0	0	0		0	0	0	6509	0	309362	19075601		
25867	2127	19128065	1975-08-26	1975-08-26 00:00:00	1976-08-20	1976-08-20 00:00:00	1976-08-20	38000177		0	0	360		0	0	0	141492	0	749882	19128065		
44223	3660	1127433	1988-12-14	1988-12-14 00:00:00	1989-01-04	1989-01-04 00:00:00	1989-01-04	38000177		0	0	21		0	0	0	243604	0	313782	1127433		
19370	1598	19133873	1965-08-13	1965-08-13 00:00:00	1965-08-25	1965-08-25 00:00:00	1965-08-25	38000177		0	0	12		0	0	0	107220	0	834061	19133873		
29890	2477	1127433	1974-01-05	1974-01-05 00:00:00	1974-01-12	1974-01-12 00:00:00	1974-01-12	38000177		0	0	7		0	0	0	164178	0	313782	1127433		
44111	3651	1124300	1995-10-07	1995-10-07 00:00:00	1995-10-07	1995-10-07 00:00:00	\N	38000177		0	0	0		0	0	0	243029	0	00781178901	45011828		
37073	3065	1127078	1974-10-28	1974-10-28 00:00:00	1974-11-11	1974-11-11 00:00:00	1974-11-11	38000177		0	0	14		0	0	0	204045	0	282464	1127078		
142160	3123	40213160	1977-10-12	1977-10-12 00:00:00	1977-10-12	1977-10-12 00:00:00	1977-10-12	581452		0	0	0		0	0	0	207789	0	10	40213160		
26704	2199	1713671	1982-07-11	1982-07-11 00:00:00	1982-08-01	1982-08-01 00:00:00	1982-08-01	38000177		0	0	21		0	0	0	146555	0	562251	1713671		
21734	1783	1127433	1986-08-04	1986-08-04 00:00:00	1986-08-18	1986-08-18 00:00:00	1986-08-18	38000177		0	0	14		0	0	0	119441	0	313782	1127433		
12941	1088	19133873	1984-09-10	1984-09-10 00:00:00	1984-09-23	1984-09-23 00:00:00	1984-09-23	38000177		0	0	13		0	0	0	71460	0	834061	19133873		
32287	2677	1713671	2000-09-01	2000-09-01 00:00:00	2000-09-22	2000-09-22 00:00:00	2000-09-22	38000177		0	0	21		0	0	0	177430	0	562251	1713671		
32608	2703	1127433	2004-10-03	2004-10-03 00:00:00	2004-10-24	2004-10-24 00:00:00	2004-10-24	38000177		0	0	21		0	0	0	179107	0	313782	1127433		
6621	558	1115171	2000-11-01	2000-11-01 00:00:00	2000-11-22	2000-11-22 00:00:00	2000-11-22	38000177		0	0	21		0	0	0	36976	0	849574	1115171		
59986	4986	19133873	1959-04-20	1959-04-20 00:00:00	1959-04-30	1959-04-30 00:00:00	1959-04-30	38000177		0	0	10		0	0	0	331650	0	834061	19133873		
26276	572	40213160	1955-04-01	1955-04-01 00:00:00	1955-04-01	1955-04-01 00:00:00	1955-04-01	581452		0	0	0		0	0	0	37910	0	10	40213160		
17207	1427	1127433	1982-03-13	1982-03-13 00:00:00	1982-04-03	1982-04-03 00:00:00	1982-04-03	38000177		0	0	21		0	0	0	94960	0	313782	1127433		
17252	1430	1127078	1955-05-24	1955-05-24 00:00:00	1955-08-22	1955-08-22 00:00:00	1955-08-22	38000177		0	0	90		0	0	0	95179	0	282464	1127078		
27743	2295	1127078	1976-06-07	1976-06-07 00:00:00	1976-06-21	1976-06-21 00:00:00	1976-06-21	38000177		0	0	14		0	0	0	152756	0	282464	1127078		
13789	1151	1127078	1987-12-19	1987-12-19 00:00:00	1988-01-02	1988-01-02 00:00:00	1988-01-02	38000177		0	0	14		0	0	0	76125	0	282464	1127078		
13815	1154	1127433	2005-05-05	2005-05-05 00:00:00	2005-05-26	2005-05-26 00:00:00	2005-05-26	38000177		0	0	21		0	0	0	76274	0	313782	1127433		
168053	3694	40213260	2008-04-15	2008-04-15 00:00:00	2008-04-15	2008-04-15 00:00:00	2008-04-15	581452		0	0	0		0	0	0	245525	0	121	40213260		
38842	847	40213260	2018-01-05	2018-01-05 00:00:00	2018-01-05	2018-01-05 00:00:00	2018-01-05	581452		0	0	0		0	0	0	56157	0	121	40213260		
38458	3177	1127433	1980-02-21	1980-02-21 00:00:00	1980-02-28	1980-02-28 00:00:00	1980-02-28	38000177		0	0	7		0	0	0	211311	0	313782	1127433		
38481	3178	19006318	1956-12-11	1956-12-11 00:00:00	1956-12-25	1956-12-25 00:00:00	1956-12-25	38000177		0	0	14		0	0	0	211378	0	105078	19006318		
323	23	1127078	1988-05-08	1988-05-08 00:00:00	1988-05-22	1988-05-22 00:00:00	1988-05-22	38000177		0	0	14		0	0	0	1775	0	282464	1127078		
17870	1478	19059056	1962-04-15	1962-04-15 00:00:00	1962-04-29	1962-04-29 00:00:00	1962-04-29	38000177		0	0	14		0	0	0	98562	0	243670	19059056		
37901	3133	1713671	1973-06-22	1973-06-22 00:00:00	1973-07-13	1973-07-13 00:00:00	1973-07-13	38000177		0	0	21		0	0	0	208501	0	562251	1713671		
37955	3137	920300	1943-06-21	1943-06-21 00:00:00	1943-06-28	1943-06-28 00:00:00	1943-06-28	38000177		0	0	7		0	0	0	208824	0	311989	920300		
14706	1231	1713671	1968-08-05	1968-08-05 00:00:00	1968-08-19	1968-08-19 00:00:00	1968-08-19	38000177		0	0	14		0	0	0	81070	0	562251	1713671		
14762	1236	1127433	2005-12-08	2005-12-08 00:00:00	2006-01-07	2006-01-07 00:00:00	2006-01-07	38000177		0	0	30		0	0	0	81489	0	313782	1127433		
31356	2599	19075001	1988-08-24	1988-08-24 00:00:00	1988-09-07	1988-09-07 00:00:00	1988-09-07	38000177		0	0	14		0	0	0	172006	0	309097	19075001		
25293	2082	40165015	2007-12-10	2007-12-10 00:00:00	2007-12-10	2007-12-10 00:00:00	\N	38000177		0	0	0		0	0	0	138719	0	861467	40165015		
39096	3231	19059056	1957-11-22	1957-11-22 00:00:00	1957-12-13	1957-12-13 00:00:00	1957-12-13	38000177		0	0	21		0	0	0	214727	0	243670	19059056		
21816	1791	19059056	1968-03-21	1968-03-21 00:00:00	1968-04-25	1968-04-25 00:00:00	1968-04-25	38000177		0	0	35		0	0	0	120054	0	243670	19059056		
21835	1791	1127433	2017-02-12	2017-02-12 00:00:00	2017-02-19	2017-02-19 00:00:00	2017-02-19	38000177		0	0	7		0	0	0	120071	0	313782	1127433		
49694	4121	920300	1971-06-15	1971-06-15 00:00:00	1971-06-22	1971-06-22 00:00:00	1971-06-22	38000177		0	0	7		0	0	0	273989	0	311989	920300		
32429	2688	1124300	2001-08-25	2001-08-25 00:00:00	2001-08-25	2001-08-25 00:00:00	\N	38000177		0	0	0		0	0	0	178139	0	00781178901	45011828		
35011	2892	46233988	1974-01-22	1974-01-22 00:00:00	1974-02-05	1974-02-05 00:00:00	1974-02-05	38000177		0	0	14		0	0	0	192399	0	1652673	46233988		
42550	3528	19078461	2015-05-04	2015-05-04 00:00:00	2015-06-03	2015-06-03 00:00:00	2015-06-03	38000177		0	0	30		0	0	0	234284	0	310965	19078461		
45561	3771	19133873	1972-05-19	1972-05-19 00:00:00	1972-05-26	1972-05-26 00:00:00	1972-05-26	38000177		0	0	7		0	0	0	250611	0	834061	19133873		
188134	4131	40213160	1976-09-17	1976-09-17 00:00:00	1976-09-17	1976-09-17 00:00:00	1976-09-17	581452		0	0	0		0	0	0	274689	0	10	40213160		
57121	4739	19133873	1916-10-22	1916-10-22 00:00:00	1916-11-01	1916-11-01 00:00:00	1916-11-01	38000177		0	0	10		0	0	0	315749	0	834061	19133873		
1020	84	40229134	1976-07-02	1976-07-02 00:00:00	1976-07-16	1976-07-16 00:00:00	1976-07-16	38000177		0	0	14		0	0	0	5669	0	1043400	40229134		
60827	5058	40173590	2017-03-05	2017-03-05 00:00:00	2017-03-05	2017-03-05 00:00:00	\N	38000177		0	0	0		0	0	0	336327	0	904419	40173590		
28773	625	40213227	2014-12-16	2014-12-16 00:00:00	2014-12-16	2014-12-16 00:00:00	2014-12-16	581452		0	0	0		0	0	0	41732	0	113	40213227		
62448	5197	19073188	2009-04-07	2009-04-07 00:00:00	2009-05-05	2009-05-05 00:00:00	2009-05-05	38000177		0	0	28		0	0	0	345577	0	308192	19073188		
36622	3022	1127433	1991-12-04	1991-12-04 00:00:00	1991-12-25	1991-12-25 00:00:00	1991-12-25	38000177		0	0	21		0	0	0	201468	0	313782	1127433		
44875	3714	40229134	1924-06-07	1924-06-07 00:00:00	1924-06-14	1924-06-14 00:00:00	1924-06-14	38000177		0	0	7		0	0	0	246852	0	1043400	40229134		
24668	2028	1127433	1980-01-18	1980-01-18 00:00:00	1980-02-01	1980-02-01 00:00:00	1980-02-01	38000177		0	0	14		0	0	0	134993	0	313782	1127433		
22263	1829	19128065	1983-06-20	1983-06-20 00:00:00	1984-06-14	1984-06-14 00:00:00	1984-06-14	38000177		0	0	360		0	0	0	122319	0	749882	19128065		
22318	1834	40229134	1988-12-08	1988-12-08 00:00:00	1988-12-22	1988-12-22 00:00:00	1988-12-22	38000177		0	0	14		0	0	0	122560	0	1043400	40229134		
26155	2151	19018935	1975-04-30	1975-04-30 00:00:00	1975-04-30	1975-04-30 00:00:00	\N	38000177		0	0	0		0	0	0	143273	0	197604	19018935		
36694	3028	19018935	2007-05-17	2007-05-17 00:00:00	2007-05-17	2007-05-17 00:00:00	\N	38000177		0	0	0		0	0	0	201875	0	197604	19018935		
70176	1535	40213160	1978-09-11	1978-09-11 00:00:00	1978-09-11	1978-09-11 00:00:00	1978-09-11	581452		0	0	0		0	0	0	102765	0	10	40213160		
36762	3035	1713671	1991-01-21	1991-01-21 00:00:00	1991-02-11	1991-02-11 00:00:00	1991-02-11	38000177		0	0	21		0	0	0	202211	0	562251	1713671		
26618	580	40213201	1993-09-12	1993-09-12 00:00:00	1993-09-12	1993-09-12 00:00:00	1993-09-12	581452		0	0	0		0	0	0	38465	0	33	40213201		
40253	3334	19059056	1951-01-27	1951-01-27 00:00:00	1951-02-10	1951-02-10 00:00:00	1951-02-10	38000177		0	0	14		0	0	0	221148	0	243670	19059056		
35745	2945	1127433	1984-10-10	1984-10-10 00:00:00	1984-10-24	1984-10-24 00:00:00	1984-10-24	38000177		0	0	14		0	0	0	196544	0	313782	1127433		
49959	4145	1127078	1975-05-03	1975-05-03 00:00:00	1975-05-17	1975-05-17 00:00:00	1975-05-17	38000177		0	0	14		0	0	0	275549	0	282464	1127078		
22673	1861	1127078	1983-10-19	1983-10-19 00:00:00	1983-11-09	1983-11-09 00:00:00	1983-11-09	38000177		0	0	21		0	0	0	124409	0	282464	1127078		
60504	5034	1127433	1923-01-08	1923-01-08 00:00:00	1923-01-22	1923-01-22 00:00:00	1923-01-22	38000177		0	0	14		0	0	0	334432	0	313782	1127433		
33573	2778	19133905	2017-09-07	2017-09-07 00:00:00	2017-09-15	2017-09-15 00:00:00	2017-09-15	38000177		0	0	8		0	0	0	183997	0	834102	19133905		
8716	727	1127433	1991-04-23	1991-04-23 00:00:00	1991-06-22	1991-06-22 00:00:00	1991-06-22	38000177		0	0	60		0	0	0	48209	0	313782	1127433		
1209	96	1115171	1996-10-01	1996-10-01 00:00:00	1996-10-15	1996-10-15 00:00:00	1996-10-15	38000177		0	0	14		0	0	0	6508	0	849574	1115171		
25888	2130	1127433	1974-12-04	1974-12-04 00:00:00	1974-12-18	1974-12-18 00:00:00	1974-12-18	38000177		0	0	14		0	0	0	141735	0	313782	1127433		
44224	3660	1127078	1979-03-18	1979-03-18 00:00:00	1979-04-15	1979-04-15 00:00:00	1979-04-15	38000177		0	0	28		0	0	0	243602	0	282464	1127078		
19371	1598	40229134	1995-08-15	1995-08-15 00:00:00	1995-08-22	1995-08-22 00:00:00	1995-08-22	38000177		0	0	7		0	0	0	107245	0	1043400	40229134		
29891	2477	1118084	1998-06-06	1998-06-06 00:00:00	1998-06-06	1998-06-06 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00025152531	44923712		
44112	3651	1127433	1973-02-14	1973-02-14 00:00:00	1973-05-15	1973-05-15 00:00:00	1973-05-15	38000177		0	0	90		0	0	0	243043	0	313782	1127433		
37074	3065	40229134	1989-09-23	1989-09-23 00:00:00	1989-09-30	1989-09-30 00:00:00	1989-09-30	38000177		0	0	7		0	0	0	204036	0	1043400	40229134		
37079	3065	19133873	1977-11-13	1977-11-13 00:00:00	1977-11-26	1977-11-26 00:00:00	1977-11-26	38000177		0	0	13		0	0	0	204035	0	834061	19133873		
26705	2199	1713671	1998-12-14	1998-12-14 00:00:00	1998-12-28	1998-12-28 00:00:00	1998-12-28	38000177		0	0	14		0	0	0	146557	0	562251	1713671		
21737	1785	19078461	2001-10-28	2001-10-28 00:00:00	2001-11-18	2001-11-18 00:00:00	2001-11-18	38000177		0	0	21		0	0	0	119609	0	310965	19078461		
12942	1088	1127433	2001-01-18	2001-01-18 00:00:00	2001-01-25	2001-01-25 00:00:00	2001-01-25	38000177		0	0	7		0	0	0	71463	0	313782	1127433		
32288	2677	1127433	2016-05-04	2016-05-04 00:00:00	2016-05-11	2016-05-11 00:00:00	2016-05-11	38000177		0	0	7		0	0	0	177348	0	313782	1127433		
32609	2703	1118084	2014-04-12	2014-04-12 00:00:00	2014-04-12	2014-04-12 00:00:00	\N	38000177		0	0	0		0	0	0	179096	0	00025152531	44923712		
6622	558	40220960	2003-09-04	2003-09-04 00:00:00	2003-09-04	2003-09-04 00:00:00	2003-09-04	38000177		0	0	0		0	0	0	36972	0	1804799	40220960		
59987	4986	920300	2000-05-22	2000-05-22 00:00:00	2000-05-29	2000-05-29 00:00:00	2000-05-29	38000177		0	0	7		0	0	0	331705	0	311989	920300		
26279	572	40213227	1995-11-03	1995-11-03 00:00:00	1995-11-03	1995-11-03 00:00:00	1995-11-03	581452		0	0	0		0	0	0	37880	0	113	40213227		
17208	1427	1118084	1995-09-15	1995-09-15 00:00:00	1995-09-15	1995-09-15 00:00:00	\N	38000177		0	0	0		0	0	0	94921	0	00025152531	44923712		
17253	1431	19078461	1994-09-26	1994-09-26 00:00:00	1994-10-17	1994-10-17 00:00:00	1994-10-17	38000177		0	0	21		0	0	0	95251	0	310965	19078461		
27744	2295	1713671	2006-04-25	2006-04-25 00:00:00	2006-05-02	2006-05-02 00:00:00	2006-05-02	38000177		0	0	7		0	0	0	152778	0	562251	1713671		
13790	1151	19074843	1987-12-19	1987-12-19 00:00:00	1988-01-02	1988-01-02 00:00:00	1988-01-02	38000177		0	0	14		0	0	0	76125	0	309045	19074843		
13816	1154	1127433	2014-07-19	2014-07-19 00:00:00	2014-08-02	2014-08-02 00:00:00	2014-08-02	38000177		0	0	14		0	0	0	76255	0	313782	1127433		
168060	3695	40213160	1985-01-14	1985-01-14 00:00:00	1985-01-14	1985-01-14 00:00:00	1985-01-14	581452		0	0	0		0	0	0	245600	0	10	40213160		
50121	1098	40213260	2007-12-22	2007-12-22 00:00:00	2007-12-22	2007-12-22 00:00:00	2007-12-22	581452		0	0	0		0	0	0	72103	0	121	40213260		
38459	3177	19078461	2002-07-19	2002-07-19 00:00:00	2002-08-18	2002-08-18 00:00:00	2002-08-18	38000177		0	0	30		0	0	0	211349	0	310965	19078461		
38482	3178	1127078	1956-12-11	1956-12-11 00:00:00	1956-12-25	1956-12-25 00:00:00	1956-12-25	38000177		0	0	14		0	0	0	211378	0	282464	1127078		
324	23	1127433	1991-10-01	1991-10-01 00:00:00	1991-10-08	1991-10-08 00:00:00	1991-10-08	38000177		0	0	7		0	0	0	1791	0	313782	1127433		
17871	1478	19129655	1962-04-15	1962-04-15 00:00:00	1962-04-29	1962-04-29 00:00:00	1962-04-29	38000177		0	0	14		0	0	0	98562	0	789980	19129655		
37902	3133	19059056	1961-01-26	1961-01-26 00:00:00	1961-03-27	1961-03-27 00:00:00	1961-03-27	38000177		0	0	60		0	0	0	208507	0	243670	19059056		
37956	3137	1713671	1957-12-08	1957-12-08 00:00:00	1957-12-29	1957-12-29 00:00:00	1957-12-29	38000177		0	0	21		0	0	0	208781	0	562251	1713671		
14707	1231	19133873	1955-04-11	1955-04-11 00:00:00	1955-04-20	1955-04-20 00:00:00	1955-04-20	38000177		0	0	9		0	0	0	81151	0	834061	19133873		
14763	1236	1713671	1957-05-11	1957-05-11 00:00:00	1957-05-25	1957-05-25 00:00:00	1957-05-25	38000177		0	0	14		0	0	0	81463	0	562251	1713671		
31357	2599	1127433	1981-09-10	1981-09-10 00:00:00	1981-09-24	1981-09-24 00:00:00	1981-09-24	38000177		0	0	14		0	0	0	171946	0	313782	1127433		
25294	2082	1115171	2007-12-10	2007-12-10 00:00:00	2008-03-09	2008-03-09 00:00:00	2008-03-09	38000177		0	0	90		0	0	0	138719	0	849574	1115171		
39097	3231	1127433	1966-04-16	1966-04-16 00:00:00	1966-04-30	1966-04-30 00:00:00	1966-04-30	38000177		0	0	14		0	0	0	214770	0	313782	1127433		
21818	1791	1115171	1997-08-31	1997-08-31 00:00:00	1997-09-28	1997-09-28 00:00:00	1997-09-28	38000177		0	0	28		0	0	0	120059	0	849574	1115171		
21836	1791	1127433	1975-04-25	1975-04-25 00:00:00	1975-05-02	1975-05-02 00:00:00	1975-05-02	38000177		0	0	7		0	0	0	120101	0	313782	1127433		
49695	4121	19078461	1979-10-30	1979-10-30 00:00:00	1979-12-04	1979-12-04 00:00:00	1979-12-04	38000177		0	0	35		0	0	0	273964	0	310965	19078461		
32430	2688	1127433	1964-06-12	1964-06-12 00:00:00	1964-06-26	1964-06-26 00:00:00	1964-06-26	38000177		0	0	14		0	0	0	178091	0	313782	1127433		
35012	2892	19133873	1981-05-24	1981-05-24 00:00:00	1981-06-02	1981-06-02 00:00:00	1981-06-02	38000177		0	0	9		0	0	0	192423	0	834061	19133873		
42552	3529	40232448	1949-05-16	1949-05-16 00:00:00	1949-05-16	1949-05-16 00:00:00	\N	38000177		0	0	0		0	0	0	234434	0	1049630	40232448		
45562	3771	1127433	2000-03-20	2000-03-20 00:00:00	2000-03-27	2000-03-27 00:00:00	2000-03-27	38000177		0	0	7		0	0	0	250612	0	313782	1127433		
188139	4131	40213227	2018-10-12	2018-10-12 00:00:00	2018-10-12	2018-10-12 00:00:00	2018-10-12	581452		0	0	0		0	0	0	274701	0	113	40213227		
57122	4739	40229134	1919-06-09	1919-06-09 00:00:00	1919-06-16	1919-06-16 00:00:00	1919-06-16	38000177		0	0	7		0	0	0	315680	0	1043400	40229134		
1021	84	1127078	1979-09-25	1979-09-25 00:00:00	1979-10-09	1979-10-09 00:00:00	1979-10-09	38000177		0	0	14		0	0	0	5660	0	282464	1127078		
60828	5058	1127433	1975-06-23	1975-06-23 00:00:00	1975-07-14	1975-07-14 00:00:00	1975-07-14	38000177		0	0	21		0	0	0	336344	0	313782	1127433		
28774	625	40213296	2014-12-16	2014-12-16 00:00:00	2014-12-16	2014-12-16 00:00:00	2014-12-16	581452		0	0	0		0	0	0	41732	0	52	40213296		
62449	5197	19078461	2009-04-07	2009-04-07 00:00:00	2009-05-05	2009-05-05 00:00:00	2009-05-05	38000177		0	0	28		0	0	0	345577	0	310965	19078461		
36623	3022	46233988	1976-08-24	1976-08-24 00:00:00	1976-09-07	1976-09-07 00:00:00	1976-09-07	38000177		0	0	14		0	0	0	201449	0	1652673	46233988		
44876	3714	19059056	1966-03-27	1966-03-27 00:00:00	1966-04-24	1966-04-24 00:00:00	1966-04-24	38000177		0	0	28		0	0	0	246850	0	243670	19059056		
24669	2028	19115351	1983-02-09	1983-02-09 00:00:00	1983-09-21	1983-09-21 00:00:00	1983-09-21	38000177		0	0	224		0	0	0	135003	0	563026	19115351		
22264	1829	1127433	1985-04-02	1985-04-02 00:00:00	1985-04-16	1985-04-16 00:00:00	1985-04-16	38000177		0	0	14		0	0	0	122303	0	313782	1127433		
22319	1834	1713671	1969-04-07	1969-04-07 00:00:00	1969-05-05	1969-05-05 00:00:00	1969-05-05	38000177		0	0	28		0	0	0	122512	0	562251	1713671		
26156	2151	40163554	1975-04-30	1975-04-30 00:00:00	1975-04-30	1975-04-30 00:00:00	\N	38000177		0	0	0		0	0	0	143273	0	855332	40163554		
36695	3028	40163554	2007-05-17	2007-05-17 00:00:00	2007-05-17	2007-05-17 00:00:00	\N	38000177		0	0	0		0	0	0	201875	0	855332	40163554		
70177	1535	40213314	1978-09-11	1978-09-11 00:00:00	1978-09-11	1978-09-11 00:00:00	1978-09-11	581452		0	0	0		0	0	0	102765	0	49	40213314		
36763	3035	40220960	2014-09-12	2014-09-12 00:00:00	2014-09-12	2014-09-12 00:00:00	2014-09-12	38000177		0	0	0		0	0	0	202232	0	1804799	40220960		
26626	580	40213227	2018-05-13	2018-05-13 00:00:00	2018-05-13	2018-05-13 00:00:00	2018-05-13	581452		0	0	0		0	0	0	38448	0	113	40213227		
40254	3334	19006318	1951-01-27	1951-01-27 00:00:00	1951-02-10	1951-02-10 00:00:00	1951-02-10	38000177		0	0	14		0	0	0	221148	0	105078	19006318		
35746	2945	1713671	1972-07-18	1972-07-18 00:00:00	1972-08-01	1972-08-01 00:00:00	1972-08-01	38000177		0	0	14		0	0	0	196514	0	562251	1713671		
49960	4145	40229134	1993-11-25	1993-11-25 00:00:00	1993-12-09	1993-12-09 00:00:00	1993-12-09	38000177		0	0	14		0	0	0	275495	0	1043400	40229134		
22674	1861	1115171	2000-02-02	2000-02-02 00:00:00	2000-02-23	2000-02-23 00:00:00	2000-02-23	38000177		0	0	21		0	0	0	124415	0	849574	1115171		
60505	5034	1124300	1959-07-27	1959-07-27 00:00:00	1959-07-27	1959-07-27 00:00:00	\N	38000177		0	0	0		0	0	0	334498	0	00781178901	45011828		
33574	2778	19133873	1977-07-23	1977-07-23 00:00:00	1977-08-01	1977-08-01 00:00:00	1977-08-01	38000177		0	0	9		0	0	0	184027	0	834061	19133873		
8717	727	19059056	1914-08-23	1914-08-23 00:00:00	1914-09-06	1914-09-06 00:00:00	1914-09-06	38000177		0	0	14		0	0	0	48180	0	243670	19059056		
1210	97	40236824	1966-10-04	1966-10-04 00:00:00	1966-10-11	1966-10-11 00:00:00	1966-10-11	38000177		0	0	7		0	0	0	6586	0	1094107	40236824		
25889	2130	46233710	1974-12-04	1974-12-04 00:00:00	1974-12-18	1974-12-18 00:00:00	1974-12-18	38000177		0	0	14		0	0	0	141735	0	1650142	46233710		
44225	3660	19078461	1997-03-23	1997-03-23 00:00:00	1997-04-06	1997-04-06 00:00:00	1997-04-06	38000177		0	0	14		0	0	0	243606	0	310965	19078461		
19372	1598	1713671	1964-01-22	1964-01-22 00:00:00	1964-02-12	1964-02-12 00:00:00	1964-02-12	38000177		0	0	21		0	0	0	107219	0	562251	1713671		
29894	2477	19006318	1956-03-23	1956-03-23 00:00:00	1956-04-06	1956-04-06 00:00:00	1956-04-06	38000177		0	0	14		0	0	0	164167	0	105078	19006318		
44113	3651	19133905	1985-02-23	1985-02-23 00:00:00	1985-03-06	1985-03-06 00:00:00	1985-03-06	38000177		0	0	11		0	0	0	243045	0	834102	19133905		
37075	3065	1127433	1987-10-01	1987-10-01 00:00:00	1987-10-08	1987-10-08 00:00:00	1987-10-08	38000177		0	0	7		0	0	0	204021	0	313782	1127433		
37080	3065	19073188	2018-05-18	2018-05-18 00:00:00	2018-06-01	2018-06-01 00:00:00	2018-06-01	38000177		0	0	14		0	0	0	204026	0	308192	19073188		
26706	2199	1127078	1984-04-26	1984-04-26 00:00:00	1984-07-25	1984-07-25 00:00:00	1984-07-25	38000177		0	0	90		0	0	0	146577	0	282464	1127078		
21738	1785	1127433	2013-09-25	2013-09-25 00:00:00	2013-10-09	2013-10-09 00:00:00	2013-10-09	38000177		0	0	14		0	0	0	119598	0	313782	1127433		
12943	1088	1115171	1995-12-14	1995-12-14 00:00:00	1996-01-13	1996-01-13 00:00:00	1996-01-13	38000177		0	0	30		0	0	0	71435	0	849574	1115171		
32289	2677	19133873	1981-12-08	1981-12-08 00:00:00	1981-12-17	1981-12-17 00:00:00	1981-12-17	38000177		0	0	9		0	0	0	177343	0	834061	19133873		
32610	2703	1127433	2006-08-15	2006-08-15 00:00:00	2006-08-29	2006-08-29 00:00:00	2006-08-29	38000177		0	0	14		0	0	0	179108	0	313782	1127433		
6623	558	19075601	2003-09-04	2003-09-04 00:00:00	2003-09-04	2003-09-04 00:00:00	2003-09-04	38000177		0	0	0		0	0	0	36972	0	309362	19075601		
59988	4986	40236824	2000-05-22	2000-05-22 00:00:00	2000-05-29	2000-05-29 00:00:00	2000-05-29	38000177		0	0	7		0	0	0	331705	0	1094107	40236824		
26282	572	40213160	1958-10-03	1958-10-03 00:00:00	1958-10-03	1958-10-03 00:00:00	1958-10-03	581452		0	0	0		0	0	0	37852	0	10	40213160		
17209	1427	1713671	1994-12-17	1994-12-17 00:00:00	1994-12-31	1994-12-31 00:00:00	1994-12-31	38000177		0	0	14		0	0	0	94921	0	562251	1713671		
17254	1431	19059056	1952-05-18	1952-05-18 00:00:00	1952-06-01	1952-06-01 00:00:00	1952-06-01	38000177		0	0	14		0	0	0	95256	0	243670	19059056		
27745	2295	1713671	2007-08-30	2007-08-30 00:00:00	2007-09-06	2007-09-06 00:00:00	2007-09-06	38000177		0	0	7		0	0	0	152779	0	562251	1713671		
13791	1151	1118084	2019-06-06	2019-06-06 00:00:00	2019-06-06	2019-06-06 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00025152531	44923712		
13817	1154	1713671	1976-02-16	1976-02-16 00:00:00	1976-03-01	1976-03-01 00:00:00	1976-03-01	38000177		0	0	14		0	0	0	76278	0	562251	1713671		
168062	3695	40213251	1985-01-14	1985-01-14 00:00:00	1985-01-14	1985-01-14 00:00:00	1985-01-14	581452		0	0	0		0	0	0	245600	0	21	40213251		
31152	679	40213160	1972-12-15	1972-12-15 00:00:00	1972-12-15	1972-12-15 00:00:00	1972-12-15	581452		0	0	0		0	0	0	44941	0	10	40213160		
38460	3177	1127433	1985-12-15	1985-12-15 00:00:00	1986-03-15	1986-03-15 00:00:00	1986-03-15	38000177		0	0	90		0	0	0	211233	0	313782	1127433		
38483	3178	40163554	2006-09-23	2006-09-23 00:00:00	2006-09-23	2006-09-23 00:00:00	\N	38000177		0	0	0		0	0	0	211447	0	855332	40163554		
325	23	1127433	1997-02-04	1997-02-04 00:00:00	1997-03-04	1997-03-04 00:00:00	1997-03-04	38000177		0	0	28		0	0	0	1776	0	313782	1127433		
17873	1478	19078461	2016-04-04	2016-04-04 00:00:00	2016-04-18	2016-04-18 00:00:00	2016-04-18	38000177		0	0	14		0	0	0	98645	0	310965	19078461		
37903	3133	19059056	1972-09-25	1972-09-25 00:00:00	1972-12-24	1972-12-24 00:00:00	1972-12-24	38000177		0	0	90		0	0	0	208509	0	243670	19059056		
37957	3137	1127433	1961-02-11	1961-02-11 00:00:00	1961-02-25	1961-02-25 00:00:00	1961-02-25	38000177		0	0	14		0	0	0	208838	0	313782	1127433		
14708	1231	19133905	1970-09-15	1970-09-15 00:00:00	1970-09-22	1970-09-22 00:00:00	1970-09-22	38000177		0	0	7		0	0	0	81071	0	834102	19133905		
14764	1236	40231925	1939-10-23	1939-10-23 00:00:00	1939-10-23	1939-10-23 00:00:00	\N	38000177		0	0	0		0	0	0	81442	0	1049221	40231925		
31358	2599	1118084	2011-05-05	2011-05-05 00:00:00	2011-05-05	2011-05-05 00:00:00	\N	38000177		0	0	0		0	0	0	172005	0	00025152531	44923712		
25295	2082	19059056	1969-02-18	1969-02-18 00:00:00	1969-03-04	1969-03-04 00:00:00	1969-03-04	38000177		0	0	14		0	0	0	138661	0	243670	19059056		
39098	3231	19073188	2010-03-19	2010-03-19 00:00:00	2010-04-02	2010-04-02 00:00:00	2010-04-02	38000177		0	0	14		0	0	0	214761	0	308192	19073188		
21819	1791	19073188	1980-12-27	1980-12-27 00:00:00	1981-01-10	1981-01-10 00:00:00	1981-01-10	38000177		0	0	14		0	0	0	120029	0	308192	19073188		
21837	1791	1127433	1963-05-14	1963-05-14 00:00:00	1963-05-21	1963-05-21 00:00:00	1963-05-21	38000177		0	0	7		0	0	0	120084	0	313782	1127433		
49696	4121	19059056	1933-06-30	1933-06-30 00:00:00	1933-08-04	1933-08-04 00:00:00	1933-08-04	38000177		0	0	35		0	0	0	273929	0	243670	19059056		
1827	145	1127078	1953-04-01	1953-04-01 00:00:00	1953-04-15	1953-04-15 00:00:00	1953-04-15	38000177		0	0	14		0	0	0	9776	0	282464	1127078		
49777	4130	40163554	2014-05-08	2014-05-08 00:00:00	2014-05-08	2014-05-08 00:00:00	\N	38000177		0	0	0		0	0	0	274604	0	855332	40163554		
42553	3529	19059056	1951-03-05	1951-03-05 00:00:00	1951-05-04	1951-05-04 00:00:00	1951-05-04	38000177		0	0	60		0	0	0	234287	0	243670	19059056		
3331	276	19132304	2005-04-06	2005-04-06 00:00:00	2006-04-09	2006-04-09 00:00:00	2006-04-09	38000177		0	0	368		0	0	0	18434	0	807283	19132304		
188140	4131	40213296	2018-10-12	2018-10-12 00:00:00	2018-10-12	2018-10-12 00:00:00	2018-10-12	581452		0	0	0		0	0	0	274701	0	52	40213296		
57123	4739	19059056	1927-09-11	1927-09-11 00:00:00	1927-09-25	1927-09-25 00:00:00	1927-09-25	38000177		0	0	14		0	0	0	315691	0	243670	19059056		
1022	84	19073183	1979-09-25	1979-09-25 00:00:00	1979-10-09	1979-10-09 00:00:00	1979-10-09	38000177		0	0	14		0	0	0	5660	0	308182	19073183		
60838	5060	1713671	2018-06-22	2018-06-22 00:00:00	2018-06-29	2018-06-29 00:00:00	2018-06-29	38000177		0	0	7		0	0	0	336446	0	562251	1713671		
1095	90	1124300	1997-06-02	1997-06-02 00:00:00	1997-06-02	1997-06-02 00:00:00	\N	38000177		0	0	0		0	0	0	6044	0	00781178901	45011828		
62450	5197	19006318	1956-06-17	1956-06-17 00:00:00	1956-07-01	1956-07-01 00:00:00	1956-07-01	38000177		0	0	14		0	0	0	345637	0	105078	19006318		
36624	3022	19019979	1976-08-24	1976-08-24 00:00:00	1976-09-07	1976-09-07 00:00:00	1976-09-07	38000177		0	0	14		0	0	0	201449	0	198405	19019979		
44877	3714	1127433	1963-03-31	1963-03-31 00:00:00	1963-04-14	1963-04-14 00:00:00	1963-04-14	38000177		0	0	14		0	0	0	246757	0	313782	1127433		
24670	2028	19115351	1980-02-06	1980-02-06 00:00:00	1980-07-23	1980-07-23 00:00:00	1980-07-23	38000177		0	0	168		0	0	0	135002	0	563026	19115351		
22265	1829	920300	2005-08-04	2005-08-04 00:00:00	2005-08-11	2005-08-11 00:00:00	2005-08-11	38000177		0	0	7		0	0	0	122274	0	311989	920300		
22320	1834	19133905	1987-05-14	1987-05-14 00:00:00	1987-05-23	1987-05-23 00:00:00	1987-05-23	38000177		0	0	9		0	0	0	122484	0	834102	19133905		
26157	2151	40229134	1967-06-08	1967-06-08 00:00:00	1967-06-22	1967-06-22 00:00:00	1967-06-22	38000177		0	0	14		0	0	0	143286	0	1043400	40229134		
36696	3028	1713671	1981-01-02	1981-01-02 00:00:00	1981-01-23	1981-01-23 00:00:00	1981-01-23	38000177		0	0	21		0	0	0	201879	0	562251	1713671		
70181	1535	40213160	1983-04-04	1983-04-04 00:00:00	1983-04-04	1983-04-04 00:00:00	1983-04-04	581452		0	0	0		0	0	0	102713	0	10	40213160		
36764	3035	19075601	2014-09-12	2014-09-12 00:00:00	2014-09-12	2014-09-12 00:00:00	2014-09-12	38000177		0	0	0		0	0	0	202232	0	309362	19075601		
169399	3725	40213227	2019-03-14	2019-03-14 00:00:00	2019-03-14	2019-03-14 00:00:00	2019-03-14	581452		0	0	0		0	0	0	247575	0	113	40213227		
40255	3334	1115171	2001-10-31	2001-10-31 00:00:00	2001-12-05	2001-12-05 00:00:00	2001-12-05	38000177		0	0	35		0	0	0	221159	0	849574	1115171		
35747	2945	1124300	1981-11-25	1981-11-25 00:00:00	1981-11-25	1981-11-25 00:00:00	\N	38000177		0	0	0		0	0	0	196474	0	00781178901	45011828		
49961	4145	40229134	2017-07-22	2017-07-22 00:00:00	2017-08-05	2017-08-05 00:00:00	2017-08-05	38000177		0	0	14		0	0	0	275545	0	1043400	40229134		
22675	1861	1118084	2019-02-02	2019-02-02 00:00:00	2019-02-02	2019-02-02 00:00:00	\N	38000177		0	0	0		0	0	0	124440	0	00025152531	44923712		
60506	5034	19126352	1994-01-29	1994-01-29 00:00:00	1994-02-26	1994-02-26 00:00:00	1994-02-26	38000177		0	0	28		0	0	0	334515	0	705129	19126352		
33575	2779	19008572	1994-11-21	1994-11-21 00:00:00	1994-11-21	1994-11-21 00:00:00	\N	38000177		0	0	0		0	0	0	184123	0	106258	19008572		
8718	727	1713671	1960-01-25	1960-01-25 00:00:00	1960-02-08	1960-02-08 00:00:00	1960-02-08	38000177		0	0	14		0	0	0	48243	0	562251	1713671		
1211	97	920300	1966-10-04	1966-10-04 00:00:00	1966-10-11	1966-10-11 00:00:00	1966-10-11	38000177		0	0	7		0	0	0	6586	0	311989	920300		
25890	2130	1713671	2001-03-29	2001-03-29 00:00:00	2001-06-21	2001-06-21 00:00:00	2001-06-21	38000177		0	0	84		0	0	0	141731	0	562251	1713671		
44226	3660	19078461	1992-06-17	1992-06-17 00:00:00	1992-09-15	1992-09-15 00:00:00	1992-09-15	38000177		0	0	90		0	0	0	243605	0	310965	19078461		
19373	1598	1713671	2008-09-21	2008-09-21 00:00:00	2008-10-05	2008-10-05 00:00:00	2008-10-05	38000177		0	0	14		0	0	0	107271	0	562251	1713671		
9155	761	19019979	1981-09-30	1981-09-30 00:00:00	1981-10-14	1981-10-14 00:00:00	1981-10-14	38000177		0	0	14		0	0	0	50615	0	198405	19019979		
44114	3652	40236824	2011-10-13	2011-10-13 00:00:00	2011-10-20	2011-10-20 00:00:00	2011-10-20	38000177		0	0	7		0	0	0	243123	0	1094107	40236824		
37076	3065	1127433	1999-02-25	1999-02-25 00:00:00	1999-03-11	1999-03-11 00:00:00	1999-03-11	38000177		0	0	14		0	0	0	204004	0	313782	1127433		
37081	3065	1115171	2018-05-18	2018-05-18 00:00:00	2018-06-01	2018-06-01 00:00:00	2018-06-01	38000177		0	0	14		0	0	0	204026	0	849574	1115171		
26707	2199	19059056	1980-05-17	1980-05-17 00:00:00	1980-05-31	1980-05-31 00:00:00	1980-05-31	38000177		0	0	14		0	0	0	146562	0	243670	19059056		
21739	1785	19059056	1962-06-20	1962-06-20 00:00:00	1962-07-25	1962-07-25 00:00:00	1962-07-25	38000177		0	0	35		0	0	0	119608	0	243670	19059056		
12944	1088	40165015	1995-12-14	1995-12-14 00:00:00	1995-12-14	1995-12-14 00:00:00	\N	38000177		0	0	0		0	0	0	71435	0	861467	40165015		
32290	2677	19059056	1980-09-21	1980-09-21 00:00:00	1980-10-21	1980-10-21 00:00:00	1980-10-21	38000177		0	0	30		0	0	0	177359	0	243670	19059056		
32611	2703	1127433	1983-11-04	1983-11-04 00:00:00	1983-11-11	1983-11-11 00:00:00	1983-11-11	38000177		0	0	7		0	0	0	179066	0	313782	1127433		
6624	558	19078461	1977-11-04	1977-11-04 00:00:00	1978-02-02	1978-02-02 00:00:00	1978-02-02	38000177		0	0	90		0	0	0	37007	0	310965	19078461		
59989	4986	19059056	1951-08-16	1951-08-16 00:00:00	1951-08-30	1951-08-30 00:00:00	1951-08-30	38000177		0	0	14		0	0	0	331625	0	243670	19059056		
26289	573	40213160	1964-03-21	1964-03-21 00:00:00	1964-03-21	1964-03-21 00:00:00	1964-03-21	581452		0	0	0		0	0	0	\N	0	10	40213160		
17210	1427	1127078	1959-05-15	1959-05-15 00:00:00	1959-05-29	1959-05-29 00:00:00	1959-05-29	38000177		0	0	14		0	0	0	94924	0	282464	1127078		
17256	1431	1713671	2012-08-28	2012-08-28 00:00:00	2012-09-04	2012-09-04 00:00:00	2012-09-04	38000177		0	0	7		0	0	0	95255	0	562251	1713671		
27746	2295	40229134	2001-03-12	2001-03-12 00:00:00	2001-03-19	2001-03-19 00:00:00	2001-03-19	38000177		0	0	7		0	0	0	152777	0	1043400	40229134		
13792	1151	42902245	1998-11-17	1998-11-17 00:00:00	1999-11-12	1999-11-12 00:00:00	1999-11-12	38000177		0	0	360		0	0	0	76126	0	1359133	42902245		
13818	1154	19128022	1989-08-07	1989-08-07 00:00:00	1990-08-02	1990-08-02 00:00:00	1990-08-02	38000177		0	0	360		0	0	0	76244	0	749785	19128022		
168065	3695	40213314	1981-04-13	1981-04-13 00:00:00	1981-04-13	1981-04-13 00:00:00	1981-04-13	581452		0	0	0		0	0	0	245597	0	49	40213314		
31154	679	40213296	2013-06-21	2013-06-21 00:00:00	2013-06-21	2013-06-21 00:00:00	2013-06-21	581452		0	0	0		0	0	0	44936	0	52	40213296		
38461	3177	1127433	1985-09-03	1985-09-03 00:00:00	1985-09-10	1985-09-10 00:00:00	1985-09-10	38000177		0	0	7		0	0	0	211344	0	313782	1127433		
38484	3178	19018935	2006-09-23	2006-09-23 00:00:00	2006-09-23	2006-09-23 00:00:00	\N	38000177		0	0	0		0	0	0	211447	0	197604	19018935		
10805	902	1127433	1960-08-05	1960-08-05 00:00:00	1960-08-12	1960-08-12 00:00:00	1960-08-12	38000177		0	0	7		0	0	0	60047	0	313782	1127433		
17880	1480	40229134	1989-05-06	1989-05-06 00:00:00	1989-05-13	1989-05-13 00:00:00	1989-05-13	38000177		0	0	7		0	0	0	98705	0	1043400	40229134		
37904	3134	19078461	1988-12-07	1988-12-07 00:00:00	1989-03-07	1989-03-07 00:00:00	1989-03-07	38000177		0	0	90		0	0	0	208557	0	310965	19078461		
37958	3137	40236824	1939-05-11	1939-05-11 00:00:00	1939-05-18	1939-05-18 00:00:00	1939-05-18	38000177		0	0	7		0	0	0	208852	0	1094107	40236824		
14709	1231	920300	1965-02-13	1965-02-13 00:00:00	1965-02-20	1965-02-20 00:00:00	1965-02-20	38000177		0	0	7		0	0	0	81069	0	311989	920300		
14765	1236	1127433	2017-07-22	2017-07-22 00:00:00	2017-08-05	2017-08-05 00:00:00	2017-08-05	38000177		0	0	14		0	0	0	81419	0	313782	1127433		
31359	2599	1127433	2001-03-01	2001-03-01 00:00:00	2001-03-22	2001-03-22 00:00:00	2001-03-22	38000177		0	0	21		0	0	0	171970	0	313782	1127433		
25297	2082	1713671	1943-12-25	1943-12-25 00:00:00	1944-01-01	1944-01-01 00:00:00	1944-01-01	38000177		0	0	7		0	0	0	138712	0	562251	1713671		
39099	3231	1127433	2010-03-19	2010-03-19 00:00:00	2010-04-02	2010-04-02 00:00:00	2010-04-02	38000177		0	0	14		0	0	0	214761	0	313782	1127433		
21820	1791	1127433	1980-12-27	1980-12-27 00:00:00	1981-01-10	1981-01-10 00:00:00	1981-01-10	38000177		0	0	14		0	0	0	120029	0	313782	1127433		
21838	1791	19133873	1955-08-24	1955-08-24 00:00:00	1955-08-31	1955-08-31 00:00:00	1955-08-31	38000177		0	0	7		0	0	0	120062	0	834061	19133873		
49697	4121	19133873	1923-12-22	1923-12-22 00:00:00	1924-01-02	1924-01-02 00:00:00	1924-01-02	38000177		0	0	11		0	0	0	273955	0	834061	19133873		
1828	145	19006318	1953-04-01	1953-04-01 00:00:00	1953-04-15	1953-04-15 00:00:00	1953-04-15	38000177		0	0	14		0	0	0	9776	0	105078	19006318		
49778	4130	19018935	2014-05-08	2014-05-08 00:00:00	2014-05-08	2014-05-08 00:00:00	\N	38000177		0	0	0		0	0	0	274604	0	197604	19018935		
42554	3529	1713671	2012-03-25	2012-03-25 00:00:00	2012-04-08	2012-04-08 00:00:00	2012-04-08	38000177		0	0	14		0	0	0	234308	0	562251	1713671		
3332	276	19128263	2009-03-24	2009-03-24 00:00:00	2009-07-16	2009-07-16 00:00:00	2009-07-16	38000177		0	0	114		0	0	0	18450	0	751905	19128263		
188141	4131	40213160	1976-11-19	1976-11-19 00:00:00	1976-11-19	1976-11-19 00:00:00	1976-11-19	581452		0	0	0		0	0	0	274723	0	10	40213160		
57124	4739	19059056	1934-10-01	1934-10-01 00:00:00	1934-10-22	1934-10-22 00:00:00	1934-10-22	38000177		0	0	21		0	0	0	315726	0	243670	19059056		
1023	84	19133873	1974-11-10	1974-11-10 00:00:00	1974-11-21	1974-11-21 00:00:00	1974-11-21	38000177		0	0	11		0	0	0	5650	0	834061	19133873		
60839	5060	1127433	1988-06-01	1988-06-01 00:00:00	1988-07-01	1988-07-01 00:00:00	1988-07-01	38000177		0	0	30		0	0	0	336406	0	313782	1127433		
1097	90	1127433	1980-09-19	1980-09-19 00:00:00	1980-10-10	1980-10-10 00:00:00	1980-10-10	38000177		0	0	21		0	0	0	5999	0	313782	1127433		
62451	5197	19059056	1956-06-17	1956-06-17 00:00:00	1956-07-01	1956-07-01 00:00:00	1956-07-01	38000177		0	0	14		0	0	0	345637	0	243670	19059056		
36625	3022	1127433	1985-04-09	1985-04-09 00:00:00	1985-06-08	1985-06-08 00:00:00	1985-06-08	38000177		0	0	60		0	0	0	201467	0	313782	1127433		
44878	3714	40229134	1963-01-21	1963-01-21 00:00:00	1963-01-28	1963-01-28 00:00:00	1963-01-28	38000177		0	0	7		0	0	0	246766	0	1043400	40229134		
24671	2028	1713671	2004-08-03	2004-08-03 00:00:00	2004-08-24	2004-08-24 00:00:00	2004-08-24	38000177		0	0	21		0	0	0	134981	0	562251	1713671		
22266	1829	40236824	2005-08-04	2005-08-04 00:00:00	2005-08-11	2005-08-11 00:00:00	2005-08-11	38000177		0	0	7		0	0	0	122274	0	1094107	40236824		
22321	1834	19126352	2014-07-20	2014-07-20 00:00:00	2014-07-20	2014-07-20 00:00:00	\N	38000177		0	0	0		0	0	0	122469	0	705129	19126352		
26158	2151	1127433	1958-02-09	1958-02-09 00:00:00	1958-02-16	1958-02-16 00:00:00	1958-02-16	38000177		0	0	7		0	0	0	143285	0	313782	1127433		
36697	3028	1118084	2000-07-01	2000-07-01 00:00:00	2000-07-01	2000-07-01 00:00:00	\N	38000177		0	0	0		0	0	0	201864	0	00025152531	44923712		
70198	1535	40213306	2001-04-09	2001-04-09 00:00:00	2001-04-09	2001-04-09 00:00:00	2001-04-09	581452		0	0	0		0	0	0	102730	0	43	40213306		
36765	3035	1127433	1978-02-25	1978-02-25 00:00:00	1978-03-18	1978-03-18 00:00:00	1978-03-18	38000177		0	0	21		0	0	0	202172	0	313782	1127433		
169400	3725	40213260	2019-03-14	2019-03-14 00:00:00	2019-03-14	2019-03-14 00:00:00	2019-03-14	581452		0	0	0		0	0	0	247575	0	121	40213260		
40256	3334	19133905	2019-04-27	2019-04-27 00:00:00	2019-05-07	2019-05-07 00:00:00	2019-05-07	38000177		0	0	10		0	0	0	221179	0	834102	19133905		
35748	2945	40229134	1964-11-05	1964-11-05 00:00:00	1964-11-12	1964-11-12 00:00:00	1964-11-12	38000177		0	0	7		0	0	0	196539	0	1043400	40229134		
49962	4145	1713671	1995-06-29	1995-06-29 00:00:00	1995-07-13	1995-07-13 00:00:00	1995-07-13	38000177		0	0	14		0	0	0	275496	0	562251	1713671		
22676	1861	1127078	1986-10-24	1986-10-24 00:00:00	1986-11-07	1986-11-07 00:00:00	1986-11-07	38000177		0	0	14		0	0	0	124410	0	282464	1127078		
60507	5034	1332419	1994-01-29	1994-01-29 00:00:00	1994-01-29	1994-01-29 00:00:00	\N	38000177		0	0	0		0	0	0	334515	0	197361	1332419		
33576	2779	1713671	1990-05-12	1990-05-12 00:00:00	1990-06-02	1990-06-02 00:00:00	1990-06-02	38000177		0	0	21		0	0	0	184170	0	562251	1713671		
8719	727	1127433	1974-03-23	1974-03-23 00:00:00	1974-04-22	1974-04-22 00:00:00	1974-04-22	38000177		0	0	30		0	0	0	48207	0	313782	1127433		
1212	97	19078461	1986-11-30	1986-11-30 00:00:00	1987-01-04	1987-01-04 00:00:00	1987-01-04	38000177		0	0	35		0	0	0	6643	0	310965	19078461		
25891	2130	19078461	1980-06-05	1980-06-05 00:00:00	1980-06-19	1980-06-19 00:00:00	1980-06-19	38000177		0	0	14		0	0	0	141692	0	310965	19078461		
44227	3660	1127433	2003-03-14	2003-03-14 00:00:00	2003-03-21	2003-03-21 00:00:00	2003-03-21	38000177		0	0	7		0	0	0	243596	0	313782	1127433		
19374	1598	1127433	1997-05-28	1997-05-28 00:00:00	1997-06-04	1997-06-04 00:00:00	1997-06-04	38000177		0	0	7		0	0	0	107246	0	313782	1127433		
9156	761	19073183	1981-09-30	1981-09-30 00:00:00	1981-10-14	1981-10-14 00:00:00	1981-10-14	38000177		0	0	14		0	0	0	50615	0	308182	19073183		
17056	368	40213296	2011-10-12	2011-10-12 00:00:00	2011-10-12	2011-10-12 00:00:00	2011-10-12	581452		0	0	0		0	0	0	24513	0	52	40213296		
37077	3065	1118084	2014-05-26	2014-05-26 00:00:00	2014-05-26	2014-05-26 00:00:00	\N	38000177		0	0	0		0	0	0	204055	0	00025152531	44923712		
37082	3065	19128065	1992-04-13	1992-04-13 00:00:00	1993-04-08	1993-04-08 00:00:00	1993-04-08	38000177		0	0	360		0	0	0	204076	0	749882	19128065		
26708	2199	19073183	1980-05-17	1980-05-17 00:00:00	1980-05-31	1980-05-31 00:00:00	1980-05-31	38000177		0	0	14		0	0	0	146562	0	308182	19073183		
21740	1785	1127078	1958-05-07	1958-05-07 00:00:00	1958-06-11	1958-06-11 00:00:00	1958-06-11	38000177		0	0	35		0	0	0	119606	0	282464	1127078		
37245	3079	19133873	1934-06-18	1934-06-18 00:00:00	1934-06-30	1934-06-30 00:00:00	1934-06-30	38000177		0	0	12		0	0	0	204937	0	834061	19133873		
32291	2677	19059056	1975-10-26	1975-10-26 00:00:00	1975-11-16	1975-11-16 00:00:00	1975-11-16	38000177		0	0	21		0	0	0	177358	0	243670	19059056		
32612	2703	19115351	1976-08-08	1976-08-08 00:00:00	1977-01-16	1977-01-16 00:00:00	1977-01-16	38000177		0	0	161		0	0	0	179055	0	563026	19115351		
6625	558	40162522	1977-11-04	1977-11-04 00:00:00	1977-11-04	1977-11-04 00:00:00	\N	38000177		0	0	0		0	0	0	37007	0	857005	40162522		
59991	4987	1127433	2013-07-05	2013-07-05 00:00:00	2013-07-12	2013-07-12 00:00:00	2013-07-12	38000177		0	0	7		0	0	0	331736	0	313782	1127433		
26293	573	40213160	1960-02-06	1960-02-06 00:00:00	1960-02-06	1960-02-06 00:00:00	1960-02-06	581452		0	0	0		0	0	0	37977	0	10	40213160		
17211	1427	19006318	1959-05-15	1959-05-15 00:00:00	1959-05-29	1959-05-29 00:00:00	1959-05-29	38000177		0	0	14		0	0	0	94924	0	105078	19006318		
17257	1431	1127433	1963-06-22	1963-06-22 00:00:00	1963-07-06	1963-07-06 00:00:00	1963-07-06	38000177		0	0	14		0	0	0	95296	0	313782	1127433		
27747	2295	1127433	1994-09-16	1994-09-16 00:00:00	1994-09-30	1994-09-30 00:00:00	1994-09-30	38000177		0	0	14		0	0	0	152774	0	313782	1127433		
13793	1151	1127078	1985-11-15	1985-11-15 00:00:00	1985-11-29	1985-11-29 00:00:00	1985-11-29	38000177		0	0	14		0	0	0	76090	0	282464	1127078		
13819	1154	1713671	1971-04-10	1971-04-10 00:00:00	1971-05-01	1971-05-01 00:00:00	1971-05-01	38000177		0	0	21		0	0	0	76277	0	562251	1713671		
168071	3695	40213227	2011-12-12	2011-12-12 00:00:00	2011-12-12	2011-12-12 00:00:00	2011-12-12	581452		0	0	0		0	0	0	245661	0	113	40213227		
31156	679	40213227	2013-06-21	2013-06-21 00:00:00	2013-06-21	2013-06-21 00:00:00	2013-06-21	581452		0	0	0		0	0	0	44936	0	113	40213227		
38462	3178	1118084	1994-07-30	1994-07-30 00:00:00	1994-07-30	1994-07-30 00:00:00	\N	38000177		0	0	0		0	0	0	211374	0	00025152531	44923712		
38485	3178	40171902	2006-09-23	2006-09-23 00:00:00	2006-09-23	2006-09-23 00:00:00	\N	38000177		0	0	0		0	0	0	211447	0	897718	40171902		
10806	902	1127078	1952-05-17	1952-05-17 00:00:00	1952-05-31	1952-05-31 00:00:00	1952-05-31	38000177		0	0	14		0	0	0	60015	0	282464	1127078		
17881	1480	1127433	1982-02-23	1982-02-23 00:00:00	1982-03-09	1982-03-09 00:00:00	1982-03-09	38000177		0	0	14		0	0	0	98741	0	313782	1127433		
37905	3134	40165015	1988-12-07	1988-12-07 00:00:00	1988-12-07	1988-12-07 00:00:00	\N	38000177		0	0	0		0	0	0	208557	0	861467	40165015		
37959	3137	920300	1939-05-11	1939-05-11 00:00:00	1939-05-18	1939-05-18 00:00:00	1939-05-18	38000177		0	0	7		0	0	0	208852	0	311989	920300		
14710	1231	40236824	1965-02-13	1965-02-13 00:00:00	1965-02-27	1965-02-27 00:00:00	1965-02-27	38000177		0	0	14		0	0	0	81069	0	1094107	40236824		
14766	1236	19059056	1939-10-16	1939-10-16 00:00:00	1939-11-22	1939-11-22 00:00:00	1939-11-22	38000177		0	0	37		0	0	0	81482	0	243670	19059056		
31360	2599	19128022	1993-01-19	1993-01-19 00:00:00	1994-01-14	1994-01-14 00:00:00	1994-01-14	38000177		0	0	360		0	0	0	171992	0	749785	19128022		
25298	2082	1127433	1997-04-06	1997-04-06 00:00:00	1997-05-06	1997-05-06 00:00:00	1997-05-06	38000177		0	0	30		0	0	0	138717	0	313782	1127433		
39100	3232	1118084	2004-06-27	2004-06-27 00:00:00	2004-06-27	2004-06-27 00:00:00	\N	38000177		0	0	0		0	0	0	214844	0	00025152531	44923712		
21823	1791	19128065	1974-10-21	1974-10-21 00:00:00	1975-10-16	1975-10-16 00:00:00	1975-10-16	38000177		0	0	360		0	0	0	120074	0	749882	19128065		
21849	1793	40220960	2006-08-30	2006-08-30 00:00:00	2006-08-30	2006-08-30 00:00:00	2006-08-30	38000177		0	0	0		0	0	0	120247	0	1804799	40220960		
49698	4121	19133873	1930-12-30	1930-12-30 00:00:00	1931-01-12	1931-01-12 00:00:00	1931-01-12	38000177		0	0	13		0	0	0	273988	0	834061	19133873		
1829	145	40236824	1983-04-03	1983-04-03 00:00:00	1983-04-10	1983-04-10 00:00:00	1983-04-10	38000177		0	0	7		0	0	0	9808	0	1094107	40236824		
49779	4130	40171902	2014-05-08	2014-05-08 00:00:00	2014-05-08	2014-05-08 00:00:00	\N	38000177		0	0	0		0	0	0	274604	0	897718	40171902		
42556	3529	1127433	1993-04-11	1993-04-11 00:00:00	1993-04-18	1993-04-18 00:00:00	1993-04-18	38000177		0	0	7		0	0	0	234407	0	313782	1127433		
3333	276	1127433	1983-08-18	1983-08-18 00:00:00	1983-08-25	1983-08-25 00:00:00	1983-08-25	38000177		0	0	7		0	0	0	18406	0	313782	1127433		
188142	4131	40213306	1998-07-31	1998-07-31 00:00:00	1998-07-31	1998-07-31 00:00:00	1998-07-31	581452		0	0	0		0	0	0	274706	0	43	40213306		
57125	4739	19059056	1944-05-02	1944-05-02 00:00:00	1944-06-06	1944-06-06 00:00:00	1944-06-06	38000177		0	0	35		0	0	0	315727	0	243670	19059056		
1024	84	1118084	2014-03-29	2014-03-29 00:00:00	2014-03-29	2014-03-29 00:00:00	\N	38000177		0	0	0		0	0	0	5705	0	00025152531	44923712		
60840	5060	46233988	1976-12-31	1976-12-31 00:00:00	1977-01-14	1977-01-14 00:00:00	1977-01-14	38000177		0	0	14		0	0	0	336440	0	1652673	46233988		
1098	90	19059056	1975-11-10	1975-11-10 00:00:00	1975-12-10	1975-12-10 00:00:00	1975-12-10	38000177		0	0	30		0	0	0	5997	0	243670	19059056		
62452	5197	1127433	1972-09-13	1972-09-13 00:00:00	1972-11-12	1972-11-12 00:00:00	1972-11-12	38000177		0	0	60		0	0	0	345572	0	313782	1127433		
36626	3023	19059056	1993-04-24	1993-04-24 00:00:00	1993-05-29	1993-05-29 00:00:00	1993-05-29	38000177		0	0	35		0	0	0	201508	0	243670	19059056		
44879	3714	19059056	1925-12-28	1925-12-28 00:00:00	1926-01-11	1926-01-11 00:00:00	1926-01-11	38000177		0	0	14		0	0	0	246799	0	243670	19059056		
24672	2028	19059056	1984-07-13	1984-07-13 00:00:00	1984-07-27	1984-07-27 00:00:00	1984-07-27	38000177		0	0	14		0	0	0	134952	0	243670	19059056		
22267	1829	19019979	1975-07-22	1975-07-22 00:00:00	1975-08-05	1975-08-05 00:00:00	1975-08-05	38000177		0	0	14		0	0	0	122270	0	198405	19019979		
22322	1834	1332419	2014-07-20	2014-07-20 00:00:00	2014-07-20	2014-07-20 00:00:00	\N	38000177		0	0	0		0	0	0	122469	0	197361	1332419		
26159	2151	1118084	1958-07-22	1958-07-22 00:00:00	1958-07-22	1958-07-22 00:00:00	\N	38000177		0	0	0		0	0	0	143285	0	00025152531	44923712		
36698	3028	1713671	1974-12-07	1974-12-07 00:00:00	1974-12-28	1974-12-28 00:00:00	1974-12-28	38000177		0	0	21		0	0	0	201863	0	562251	1713671		
70200	1535	40213227	2001-04-09	2001-04-09 00:00:00	2001-04-09	2001-04-09 00:00:00	2001-04-09	581452		0	0	0		0	0	0	102730	0	113	40213227		
24525	533	40213160	1963-01-09	1963-01-09 00:00:00	1963-01-09	1963-01-09 00:00:00	1963-01-09	581452		0	0	0		0	0	0	35490	0	10	40213160		
169405	3725	40213260	2018-03-08	2018-03-08 00:00:00	2018-03-08	2018-03-08 00:00:00	2018-03-08	581452		0	0	0		0	0	0	247554	0	121	40213260		
40257	3334	1127433	1954-04-13	1954-04-13 00:00:00	1954-04-27	1954-04-27 00:00:00	1954-04-27	38000177		0	0	14		0	0	0	221144	0	313782	1127433		
35749	2945	1115171	2010-12-06	2010-12-06 00:00:00	2011-01-10	2011-01-10 00:00:00	2011-01-10	38000177		0	0	35		0	0	0	196486	0	849574	1115171		
49963	4145	1124300	2009-07-18	2009-07-18 00:00:00	2009-07-18	2009-07-18 00:00:00	\N	38000177		0	0	0		0	0	0	275511	0	00781178901	45011828		
22677	1861	19133873	1990-07-01	1990-07-01 00:00:00	1990-07-10	1990-07-10 00:00:00	1990-07-10	38000177		0	0	9		0	0	0	124418	0	834061	19133873		
60508	5034	1713671	1922-06-20	1922-06-20 00:00:00	1922-07-04	1922-07-04 00:00:00	1922-07-04	38000177		0	0	14		0	0	0	334433	0	562251	1713671		
33577	2779	1594382	1994-12-07	1994-12-07 00:00:00	1994-12-07	1994-12-07 00:00:00	\N	38000177		0	0	0		0	0	0	184124	0	1870230	1594382		
8720	727	19059056	1969-08-25	1969-08-25 00:00:00	1969-09-15	1969-09-15 00:00:00	1969-09-15	38000177		0	0	21		0	0	0	48206	0	243670	19059056		
1213	97	40169281	1983-07-25	1983-07-25 00:00:00	1983-07-25	1983-07-25 00:00:00	\N	38000177		0	0	0		0	0	0	6607	0	896209	40169281		
25892	2130	40229134	1962-02-11	1962-02-11 00:00:00	1962-02-25	1962-02-25 00:00:00	1962-02-25	38000177		0	0	14		0	0	0	141726	0	1043400	40229134		
44228	3661	19128022	1992-02-09	1992-02-09 00:00:00	1993-02-03	1993-02-03 00:00:00	1993-02-03	38000177		0	0	360		0	0	0	243659	0	749785	19128022		
19375	1598	40236824	1977-02-27	1977-02-27 00:00:00	1977-03-06	1977-03-06 00:00:00	1977-03-06	38000177		0	0	7		0	0	0	107222	0	1094107	40236824		
9157	761	40229134	2015-03-29	2015-03-29 00:00:00	2015-04-12	2015-04-12 00:00:00	2015-04-12	38000177		0	0	14		0	0	0	50532	0	1043400	40229134		
17060	368	40213160	1972-03-15	1972-03-15 00:00:00	1972-03-15	1972-03-15 00:00:00	1972-03-15	581452		0	0	0		0	0	0	24479	0	10	40213160		
37078	3065	1127433	1983-12-03	1983-12-03 00:00:00	1983-12-10	1983-12-10 00:00:00	1983-12-10	38000177		0	0	7		0	0	0	204020	0	313782	1127433		
37083	3065	19019979	1981-02-23	1981-02-23 00:00:00	1981-04-24	1981-04-24 00:00:00	1981-04-24	38000177		0	0	60		0	0	0	204042	0	198405	19019979		
26709	2199	1127078	1985-06-03	1985-06-03 00:00:00	1985-06-17	1985-06-17 00:00:00	1985-06-17	38000177		0	0	14		0	0	0	146550	0	282464	1127078		
21741	1785	1713671	1957-04-26	1957-04-26 00:00:00	1957-05-03	1957-05-03 00:00:00	1957-05-03	38000177		0	0	7		0	0	0	119610	0	562251	1713671		
37246	3079	1127433	1965-11-28	1965-11-28 00:00:00	1965-12-12	1965-12-12 00:00:00	1965-12-12	38000177		0	0	14		0	0	0	204919	0	313782	1127433		
32292	2677	1118084	2006-11-27	2006-11-27 00:00:00	2006-11-27	2006-11-27 00:00:00	\N	38000177		0	0	0		0	0	0	177387	0	00025152531	44923712		
32613	2703	46233988	1977-07-15	1977-07-15 00:00:00	1977-07-29	1977-07-29 00:00:00	1977-07-29	38000177		0	0	14		0	0	0	179085	0	1652673	46233988		
6626	558	1127433	1974-09-22	1974-09-22 00:00:00	1974-10-06	1974-10-06 00:00:00	1974-10-06	38000177		0	0	14		0	0	0	36995	0	313782	1127433		
59992	4987	1713671	2018-10-17	2018-10-17 00:00:00	2018-11-07	2018-11-07 00:00:00	2018-11-07	38000177		0	0	21		0	0	0	331761	0	562251	1713671		
26299	573	40213296	2001-12-01	2001-12-01 00:00:00	2001-12-01	2001-12-01 00:00:00	2001-12-01	581452		0	0	0		0	0	0	37962	0	52	40213296		
17212	1428	1118084	1984-03-30	1984-03-30 00:00:00	1984-03-30	1984-03-30 00:00:00	\N	38000177		0	0	0		0	0	0	95027	0	00025152531	44923712		
17258	1431	1127078	1956-01-28	1956-01-28 00:00:00	1956-02-18	1956-02-18 00:00:00	1956-02-18	38000177		0	0	21		0	0	0	95249	0	282464	1127078		
27754	2297	1713671	1987-02-01	1987-02-01 00:00:00	1987-02-22	1987-02-22 00:00:00	1987-02-22	38000177		0	0	21		0	0	0	152962	0	562251	1713671		
13794	1151	19073183	1985-11-15	1985-11-15 00:00:00	1985-11-29	1985-11-29 00:00:00	1985-11-29	38000177		0	0	14		0	0	0	76090	0	308182	19073183		
13820	1154	40236824	1995-10-05	1995-10-05 00:00:00	1995-10-19	1995-10-19 00:00:00	1995-10-19	38000177		0	0	14		0	0	0	76217	0	1094107	40236824		
168072	3695	40213251	1984-01-09	1984-01-09 00:00:00	1984-01-09	1984-01-09 00:00:00	1984-01-09	581452		0	0	0		0	0	0	245680	0	21	40213251		
31162	679	40213160	1972-07-14	1972-07-14 00:00:00	1972-07-14	1972-07-14 00:00:00	1972-07-14	581452		0	0	0		0	0	0	44957	0	10	40213160		
38463	3178	40229134	1999-08-19	1999-08-19 00:00:00	1999-09-02	1999-09-02 00:00:00	1999-09-02	38000177		0	0	14		0	0	0	211375	0	1043400	40229134		
38486	3179	1713671	1922-11-22	1922-11-22 00:00:00	1922-11-29	1922-11-29 00:00:00	1922-11-29	38000177		0	0	7		0	0	0	211500	0	562251	1713671		
7205	156	40213314	1979-04-01	1979-04-01 00:00:00	1979-04-01	1979-04-01 00:00:00	1979-04-01	581452		0	0	0		0	0	0	10655	0	49	40213314		
17882	1480	1545959	2006-08-04	2006-08-04 00:00:00	2006-08-04	2006-08-04 00:00:00	2006-08-04	38000177		0	0	0		0	0	0	98765	0	259255	1545959		
37906	3134	19059056	1949-06-04	1949-06-04 00:00:00	1949-07-09	1949-07-09 00:00:00	1949-07-09	38000177		0	0	35		0	0	0	208554	0	243670	19059056		
37960	3137	40229134	1920-07-27	1920-07-27 00:00:00	1920-08-03	1920-08-03 00:00:00	1920-08-03	38000177		0	0	7		0	0	0	208850	0	1043400	40229134		
14711	1231	19133905	1989-06-27	1989-06-27 00:00:00	1989-07-04	1989-07-04 00:00:00	1989-07-04	38000177		0	0	7		0	0	0	81096	0	834102	19133905		
14767	1236	19059056	1921-07-24	1921-07-24 00:00:00	1921-08-07	1921-08-07 00:00:00	1921-08-07	38000177		0	0	14		0	0	0	81468	0	243670	19059056		
45683	3783	920300	1999-05-04	1999-05-04 00:00:00	1999-05-11	1999-05-11 00:00:00	1999-05-11	38000177		0	0	7		0	0	0	251331	0	311989	920300		
25299	2082	19133905	1978-08-11	1978-08-11 00:00:00	1978-08-20	1978-08-20 00:00:00	1978-08-20	38000177		0	0	9		0	0	0	138677	0	834102	19133905		
39101	3232	1127433	1983-11-21	1983-11-21 00:00:00	1983-12-05	1983-12-05 00:00:00	1983-12-05	38000177		0	0	14		0	0	0	214858	0	313782	1127433		
21824	1791	1127433	1988-06-07	1988-06-07 00:00:00	1988-06-21	1988-06-21 00:00:00	1988-06-21	38000177		0	0	14		0	0	0	120023	0	313782	1127433		
21850	1793	19133905	2005-12-28	2005-12-28 00:00:00	2006-01-07	2006-01-07 00:00:00	2006-01-07	38000177		0	0	10		0	0	0	120247	0	834102	19133905		
49699	4121	40236824	1966-05-14	1966-05-14 00:00:00	1966-05-21	1966-05-21 00:00:00	1966-05-21	38000177		0	0	7		0	0	0	273937	0	1094107	40236824		
1830	145	920300	1983-04-03	1983-04-03 00:00:00	1983-04-10	1983-04-10 00:00:00	1983-04-10	38000177		0	0	7		0	0	0	9808	0	311989	920300		
49780	4130	46233988	1967-07-24	1967-07-24 00:00:00	1967-08-07	1967-08-07 00:00:00	1967-08-07	38000177		0	0	14		0	0	0	274661	0	1652673	46233988		
42557	3529	40173590	2004-08-04	2004-08-04 00:00:00	2004-08-04	2004-08-04 00:00:00	\N	38000177		0	0	0		0	0	0	234354	0	904419	40173590		
3334	276	1127433	2011-08-10	2011-08-10 00:00:00	2011-08-24	2011-08-24 00:00:00	2011-08-24	38000177		0	0	14		0	0	0	18391	0	313782	1127433		
188144	4131	40213227	1998-07-31	1998-07-31 00:00:00	1998-07-31	1998-07-31 00:00:00	1998-07-31	581452		0	0	0		0	0	0	274706	0	113	40213227		
57126	4739	1127433	1950-10-03	1950-10-03 00:00:00	1950-10-24	1950-10-24 00:00:00	1950-10-24	38000177		0	0	21		0	0	0	315728	0	313782	1127433		
1025	84	1127433	1995-08-01	1995-08-01 00:00:00	1995-08-15	1995-08-15 00:00:00	1995-08-15	38000177		0	0	14		0	0	0	5671	0	313782	1127433		
60841	5060	1127078	1976-12-31	1976-12-31 00:00:00	1977-01-14	1977-01-14 00:00:00	1977-01-14	38000177		0	0	14		0	0	0	336440	0	282464	1127078		
1100	90	1713671	1970-06-28	1970-06-28 00:00:00	1970-08-09	1970-08-09 00:00:00	1970-08-09	38000177		0	0	42		0	0	0	5988	0	562251	1713671		
62453	5197	40231925	1972-09-13	1972-09-13 00:00:00	1972-09-13	1972-09-13 00:00:00	\N	38000177		0	0	0		0	0	0	345572	0	1049221	40231925		
50300	1102	40213296	2007-07-17	2007-07-17 00:00:00	2007-07-17	2007-07-17 00:00:00	2007-07-17	581452		0	0	0		0	0	0	72463	0	52	40213296		
44880	3714	40231925	2007-02-18	2007-02-18 00:00:00	2007-02-18	2007-02-18 00:00:00	\N	38000177		0	0	0		0	0	0	246787	0	1049221	40231925		
24684	2030	1127433	1995-01-05	1995-01-05 00:00:00	1995-01-12	1995-01-12 00:00:00	1995-01-12	38000177		0	0	7		0	0	0	135159	0	313782	1127433		
22268	1829	19128065	1989-05-19	1989-05-19 00:00:00	1990-05-14	1990-05-14 00:00:00	1990-05-14	38000177		0	0	360		0	0	0	122276	0	749882	19128065		
22323	1834	19075601	2014-07-20	2014-07-20 00:00:00	2014-07-20	2014-07-20 00:00:00	\N	38000177		0	0	0		0	0	0	122469	0	309362	19075601		
26160	2151	19075601	1997-09-03	1997-09-03 00:00:00	1999-12-08	1999-12-08 00:00:00	1999-12-08	38000177		0	0	826		0	0	0	143266	0	309362	19075601		
36699	3028	19129655	1964-08-24	1964-08-24 00:00:00	1964-09-07	1964-09-07 00:00:00	1964-09-07	38000177		0	0	14		0	0	0	201915	0	789980	19129655		
70201	1535	40213306	1998-04-06	1998-04-06 00:00:00	1998-04-06	1998-04-06 00:00:00	1998-04-06	581452		0	0	0		0	0	0	102729	0	43	40213306		
24530	533	40213227	2013-08-07	2013-08-07 00:00:00	2013-08-07	2013-08-07 00:00:00	2013-08-07	581452		0	0	0		0	0	0	35388	0	113	40213227		
169407	3725	40213296	2008-11-06	2008-11-06 00:00:00	2008-11-06	2008-11-06 00:00:00	2008-11-06	581452		0	0	0		0	0	0	247552	0	52	40213296		
40258	3334	1118084	1981-08-07	1981-08-07 00:00:00	1981-08-07	1981-08-07 00:00:00	\N	38000177		0	0	0		0	0	0	221146	0	00025152531	44923712		
35750	2945	19133905	1992-03-25	1992-03-25 00:00:00	1992-04-04	1992-04-04 00:00:00	1992-04-04	38000177		0	0	10		0	0	0	196542	0	834102	19133905		
48942	1072	40213160	1961-01-25	1961-01-25 00:00:00	1961-01-25	1961-01-25 00:00:00	1961-01-25	581452		0	0	0		0	0	0	70254	0	10	40213160		
22678	1861	1127433	2015-05-05	2015-05-05 00:00:00	2015-05-19	2015-05-19 00:00:00	2015-05-19	38000177		0	0	14		0	0	0	124439	0	313782	1127433		
60509	5034	1127433	1971-03-08	1971-03-08 00:00:00	1971-04-14	1971-04-14 00:00:00	1971-04-14	38000177		0	0	37		0	0	0	334461	0	313782	1127433		
33578	2779	40232448	1994-12-07	1994-12-07 00:00:00	1994-12-07	1994-12-07 00:00:00	\N	38000177		0	0	0		0	0	0	184124	0	1049630	40232448		
8721	727	1115171	1998-01-16	1998-01-16 00:00:00	1998-04-16	1998-04-16 00:00:00	1998-04-16	38000177		0	0	90		0	0	0	48220	0	849574	1115171		
1214	97	1713671	1952-12-28	1952-12-28 00:00:00	1953-01-11	1953-01-11 00:00:00	1953-01-11	38000177		0	0	14		0	0	0	6583	0	562251	1713671		
25893	2130	1127433	1968-02-04	1968-02-04 00:00:00	1968-02-18	1968-02-18 00:00:00	1968-02-18	38000177		0	0	14		0	0	0	141741	0	313782	1127433		
44229	3661	920300	2011-05-03	2011-05-03 00:00:00	2011-05-10	2011-05-10 00:00:00	2011-05-10	38000177		0	0	7		0	0	0	243623	0	311989	920300		
19376	1598	920300	1977-02-27	1977-02-27 00:00:00	1977-03-06	1977-03-06 00:00:00	1977-03-06	38000177		0	0	7		0	0	0	107222	0	311989	920300		
9158	761	40229134	2007-11-08	2007-11-08 00:00:00	2007-11-15	2007-11-15 00:00:00	2007-11-15	38000177		0	0	7		0	0	0	50627	0	1043400	40229134		
17062	368	40213160	1976-09-15	1976-09-15 00:00:00	1976-09-15	1976-09-15 00:00:00	1976-09-15	581452		0	0	0		0	0	0	24499	0	10	40213160		
26603	2190	1127433	1985-11-09	1985-11-09 00:00:00	1985-11-23	1985-11-23 00:00:00	1985-11-23	38000177		0	0	14		0	0	0	146031	0	313782	1127433		
37084	3065	1127078	1982-05-19	1982-05-19 00:00:00	1982-06-25	1982-06-25 00:00:00	1982-06-25	38000177		0	0	37		0	0	0	204043	0	282464	1127078		
26710	2199	19074843	1985-06-03	1985-06-03 00:00:00	1985-06-17	1985-06-17 00:00:00	1985-06-17	38000177		0	0	14		0	0	0	146550	0	309045	19074843		
21742	1785	1127433	2016-01-12	2016-01-12 00:00:00	2016-01-26	2016-01-26 00:00:00	2016-01-26	38000177		0	0	14		0	0	0	119641	0	313782	1127433		
37247	3079	1713671	1937-04-05	1937-04-05 00:00:00	1937-04-26	1937-04-26 00:00:00	1937-04-26	38000177		0	0	21		0	0	0	204938	0	562251	1713671		
32293	2677	1713671	1975-12-25	1975-12-25 00:00:00	1976-01-01	1976-01-01 00:00:00	1976-01-01	38000177		0	0	7		0	0	0	177362	0	562251	1713671		
32614	2703	19059056	1977-07-15	1977-07-15 00:00:00	1977-07-29	1977-07-29 00:00:00	1977-07-29	38000177		0	0	14		0	0	0	179085	0	243670	19059056		
6627	558	40236446	1968-11-01	1968-11-01 00:00:00	1970-09-25	1970-09-25 00:00:00	1970-09-25	38000177		0	0	693		0	0	0	37009	0	1091392	40236446		
59993	4987	19133873	1960-12-31	1960-12-31 00:00:00	1961-01-07	1961-01-07 00:00:00	1961-01-07	38000177		0	0	7		0	0	0	331708	0	834061	19133873		
26301	573	40213227	2001-12-01	2001-12-01 00:00:00	2001-12-01	2001-12-01 00:00:00	2001-12-01	581452		0	0	0		0	0	0	37962	0	113	40213227		
17213	1428	1127433	1954-02-03	1954-02-03 00:00:00	1954-02-17	1954-02-17 00:00:00	1954-02-17	38000177		0	0	14		0	0	0	95009	0	313782	1127433		
17259	1431	1713671	1966-02-26	1966-02-26 00:00:00	1966-03-05	1966-03-05 00:00:00	1966-03-05	38000177		0	0	7		0	0	0	95298	0	562251	1713671		
27755	2297	1118084	2012-06-13	2012-06-13 00:00:00	2012-06-13	2012-06-13 00:00:00	\N	38000177		0	0	0		0	0	0	152953	0	00025152531	44923712		
20341	1669	19059056	1959-12-29	1959-12-29 00:00:00	1960-01-19	1960-01-19 00:00:00	1960-01-19	38000177		0	0	21		0	0	0	112068	0	243670	19059056		
13821	1154	920300	1995-10-05	1995-10-05 00:00:00	1995-10-12	1995-10-12 00:00:00	1995-10-12	38000177		0	0	7		0	0	0	76217	0	311989	920300		
168075	3695	40213314	1980-05-12	1980-05-12 00:00:00	1980-05-12	1980-05-12 00:00:00	1980-05-12	581452		0	0	0		0	0	0	245677	0	49	40213314		
31167	679	40213296	2015-06-26	2015-06-26 00:00:00	2015-06-26	2015-06-26 00:00:00	2015-06-26	581452		0	0	0		0	0	0	44944	0	52	40213296		
38464	3178	19059528	2014-03-14	2014-03-14 00:00:00	2014-03-14	2014-03-14 00:00:00	2014-03-14	38000177		0	0	0		0	0	0	211388	0	480	19059528		
38487	3179	40229134	1996-02-04	1996-02-04 00:00:00	1996-02-11	1996-02-11 00:00:00	1996-02-11	38000177		0	0	7		0	0	0	211515	0	1043400	40229134		
7206	156	40213160	1979-04-01	1979-04-01 00:00:00	1979-04-01	1979-04-01 00:00:00	1979-04-01	581452		0	0	0		0	0	0	10655	0	10	40213160		
17883	1480	19126352	2006-08-04	2006-08-04 00:00:00	2006-08-04	2006-08-04 00:00:00	2006-08-04	38000177		0	0	0		0	0	0	98765	0	705129	19126352		
37907	3134	1713671	2001-08-18	2001-08-18 00:00:00	2001-09-01	2001-09-01 00:00:00	2001-09-01	38000177		0	0	14		0	0	0	208563	0	562251	1713671		
37961	3137	19133905	1981-04-13	1981-04-13 00:00:00	1981-04-21	1981-04-21 00:00:00	1981-04-21	38000177		0	0	8		0	0	0	208794	0	834102	19133905		
14712	1231	1127433	1957-07-07	1957-07-07 00:00:00	1957-07-21	1957-07-21 00:00:00	1957-07-21	38000177		0	0	14		0	0	0	81105	0	313782	1127433		
14768	1236	19059056	1961-04-30	1961-04-30 00:00:00	1961-05-28	1961-05-28 00:00:00	1961-05-28	38000177		0	0	28		0	0	0	81483	0	243670	19059056		
45684	3783	40236824	1999-05-04	1999-05-04 00:00:00	1999-05-11	1999-05-11 00:00:00	1999-05-11	38000177		0	0	7		0	0	0	251331	0	1094107	40236824		
25301	2082	1713671	1990-08-15	1990-08-15 00:00:00	1990-08-22	1990-08-22 00:00:00	1990-08-22	38000177		0	0	7		0	0	0	138708	0	562251	1713671		
39102	3232	40220960	2019-04-29	2019-04-29 00:00:00	2019-04-29	2019-04-29 00:00:00	2019-04-29	38000177		0	0	0		0	0	0	214846	0	1804799	40220960		
21825	1791	1124300	1992-01-05	1992-01-05 00:00:00	1992-01-05	1992-01-05 00:00:00	\N	38000177		0	0	0		0	0	0	120103	0	00781178901	45011828		
21851	1793	1127433	1955-01-06	1955-01-06 00:00:00	1955-01-20	1955-01-20 00:00:00	1955-01-20	38000177		0	0	14		0	0	0	120179	0	313782	1127433		
49700	4121	920300	1966-05-14	1966-05-14 00:00:00	1966-05-21	1966-05-21 00:00:00	1966-05-21	38000177		0	0	7		0	0	0	273937	0	311989	920300		
21070	457	40213227	2013-04-23	2013-04-23 00:00:00	2013-04-23	2013-04-23 00:00:00	2013-04-23	581452		0	0	0		0	0	0	30551	0	113	40213227		
49781	4130	19059056	1967-07-24	1967-07-24 00:00:00	1967-08-07	1967-08-07 00:00:00	1967-08-07	38000177		0	0	14		0	0	0	274661	0	243670	19059056		
42558	3529	19059056	1949-02-13	1949-02-13 00:00:00	1949-05-14	1949-05-14 00:00:00	1949-05-14	38000177		0	0	90		0	0	0	234286	0	243670	19059056		
3335	276	1124300	2013-01-16	2013-01-16 00:00:00	2013-01-16	2013-01-16 00:00:00	\N	38000177		0	0	0		0	0	0	18391	0	00781178901	45011828		
188153	4131	40213296	2016-10-07	2016-10-07 00:00:00	2016-10-07	2016-10-07 00:00:00	2016-10-07	581452		0	0	0		0	0	0	274676	0	52	40213296		
57127	4739	1127433	1930-10-13	1930-10-13 00:00:00	1930-10-27	1930-10-27 00:00:00	1930-10-27	38000177		0	0	14		0	0	0	315739	0	313782	1127433		
1026	84	19133873	1982-07-13	1982-07-13 00:00:00	1982-07-26	1982-07-26 00:00:00	1982-07-26	38000177		0	0	13		0	0	0	5666	0	834061	19133873		
60842	5060	1127433	2004-09-07	2004-09-07 00:00:00	2004-09-21	2004-09-21 00:00:00	2004-09-21	38000177		0	0	14		0	0	0	336421	0	313782	1127433		
1101	90	1713671	2017-04-18	2017-04-18 00:00:00	2017-05-09	2017-05-09 00:00:00	2017-05-09	38000177		0	0	21		0	0	0	6021	0	562251	1713671		
62454	5197	1127433	1987-07-27	1987-07-27 00:00:00	1987-08-10	1987-08-10 00:00:00	1987-08-10	38000177		0	0	14		0	0	0	345573	0	313782	1127433		
50302	1102	40213160	1967-07-04	1967-07-04 00:00:00	1967-07-04	1967-07-04 00:00:00	1967-07-04	581452		0	0	0		0	0	0	72374	0	10	40213160		
44881	3714	19078461	2007-02-18	2007-02-18 00:00:00	2007-04-19	2007-04-19 00:00:00	2007-04-19	38000177		0	0	60		0	0	0	246787	0	310965	19078461		
24685	2030	1127433	1974-04-29	1974-04-29 00:00:00	1974-05-13	1974-05-13 00:00:00	1974-05-13	38000177		0	0	14		0	0	0	135118	0	313782	1127433		
22269	1829	1124300	2002-08-09	2002-08-09 00:00:00	2002-08-09	2002-08-09 00:00:00	\N	38000177		0	0	0		0	0	0	122280	0	00781178901	45011828		
22324	1834	1539411	2014-07-20	2014-07-20 00:00:00	2014-07-20	2014-07-20 00:00:00	\N	38000177		0	0	0		0	0	0	122469	0	312961	1539411		
26161	2151	1127433	1963-02-14	1963-02-14 00:00:00	1963-02-28	1963-02-28 00:00:00	1963-02-28	38000177		0	0	14		0	0	0	143281	0	313782	1127433		
36700	3028	19059056	1964-08-24	1964-08-24 00:00:00	1964-09-07	1964-09-07 00:00:00	1964-09-07	38000177		0	0	14		0	0	0	201915	0	243670	19059056		
70205	1535	40213314	1978-07-10	1978-07-10 00:00:00	1978-07-10	1978-07-10 00:00:00	1978-07-10	581452		0	0	0		0	0	0	102758	0	49	40213314		
24531	533	40213260	2013-08-07	2013-08-07 00:00:00	2013-08-07	2013-08-07 00:00:00	2013-08-07	581452		0	0	0		0	0	0	35388	0	121	40213260		
169409	3725	40213160	1973-02-15	1973-02-15 00:00:00	1973-02-15	1973-02-15 00:00:00	1973-02-15	581452		0	0	0		0	0	0	247543	0	10	40213160		
40259	3334	1115171	2017-09-12	2017-09-12 00:00:00	2017-10-03	2017-10-03 00:00:00	2017-10-03	38000177		0	0	21		0	0	0	221160	0	849574	1115171		
5147	430	1713671	1964-03-05	1964-03-05 00:00:00	1964-03-19	1964-03-19 00:00:00	1964-03-19	38000177		0	0	14		0	0	0	28438	0	562251	1713671		
48943	1072	40213227	2001-12-26	2001-12-26 00:00:00	2001-12-26	2001-12-26 00:00:00	2001-12-26	581452		0	0	0		0	0	0	70218	0	113	40213227		
22679	1861	1127433	2004-02-02	2004-02-02 00:00:00	2004-02-16	2004-02-16 00:00:00	2004-02-16	38000177		0	0	14		0	0	0	124416	0	313782	1127433		
60510	5034	40229134	1973-12-22	1973-12-22 00:00:00	1973-12-29	1973-12-29 00:00:00	1973-12-29	38000177		0	0	7		0	0	0	334531	0	1043400	40229134		
33579	2779	1118084	2015-04-23	2015-04-23 00:00:00	2015-04-23	2015-04-23 00:00:00	\N	38000177		0	0	0		0	0	0	184196	0	00025152531	44923712		
8722	727	1127433	1951-08-04	1951-08-04 00:00:00	1951-08-11	1951-08-11 00:00:00	1951-08-11	38000177		0	0	7		0	0	0	48251	0	313782	1127433		
33307	2760	1127433	1993-07-01	1993-07-01 00:00:00	1993-07-08	1993-07-08 00:00:00	1993-07-08	38000177		0	0	7		0	0	0	182539	0	313782	1127433		
25894	2130	1127433	1976-02-27	1976-02-27 00:00:00	1976-04-27	1976-04-27 00:00:00	1976-04-27	38000177		0	0	60		0	0	0	141691	0	313782	1127433		
44230	3661	40236824	2011-05-03	2011-05-03 00:00:00	2011-05-10	2011-05-10 00:00:00	2011-05-10	38000177		0	0	7		0	0	0	243623	0	1094107	40236824		
19377	1598	1127433	2002-08-21	2002-08-21 00:00:00	2002-09-04	2002-09-04 00:00:00	2002-09-04	38000177		0	0	14		0	0	0	107210	0	313782	1127433		
9159	761	1713671	2010-09-23	2010-09-23 00:00:00	2010-10-07	2010-10-07 00:00:00	2010-10-07	38000177		0	0	14		0	0	0	50531	0	562251	1713671		
17065	368	40213296	2013-10-16	2013-10-16 00:00:00	2013-10-16	2013-10-16 00:00:00	2013-10-16	581452		0	0	0		0	0	0	24514	0	52	40213296		
26604	2190	19075001	1985-11-09	1985-11-09 00:00:00	1985-11-23	1985-11-23 00:00:00	1985-11-23	38000177		0	0	14		0	0	0	146031	0	309097	19075001		
37088	3067	1127433	1968-11-28	1968-11-28 00:00:00	1968-12-26	1968-12-26 00:00:00	1968-12-26	38000177		0	0	28		0	0	0	204184	0	313782	1127433		
26711	2199	1118084	2016-10-30	2016-10-30 00:00:00	2016-10-30	2016-10-30 00:00:00	\N	38000177		0	0	0		0	0	0	146587	0	00025152531	44923712		
21743	1785	19073188	2016-01-12	2016-01-12 00:00:00	2016-01-26	2016-01-26 00:00:00	2016-01-26	38000177		0	0	14		0	0	0	119641	0	308192	19073188		
37248	3079	19078461	1979-05-24	1979-05-24 00:00:00	1979-06-23	1979-06-23 00:00:00	1979-06-23	38000177		0	0	30		0	0	0	204964	0	310965	19078461		
32294	2677	1127433	2009-07-02	2009-07-02 00:00:00	2009-07-09	2009-07-09 00:00:00	2009-07-09	38000177		0	0	7		0	0	0	177339	0	313782	1127433		
32615	2703	1713671	1984-11-26	1984-11-26 00:00:00	1984-12-03	1984-12-03 00:00:00	1984-12-03	38000177		0	0	7		0	0	0	179097	0	562251	1713671		
6628	558	19078461	2003-11-05	2003-11-05 00:00:00	2003-11-26	2003-11-26 00:00:00	2003-11-26	38000177		0	0	21		0	0	0	36978	0	310965	19078461		
59994	4987	19059056	1962-10-06	1962-10-06 00:00:00	1962-10-20	1962-10-20 00:00:00	1962-10-20	38000177		0	0	14		0	0	0	331762	0	243670	19059056		
26304	573	40213227	1992-07-18	1992-07-18 00:00:00	1992-07-18	1992-07-18 00:00:00	1992-07-18	581452		0	0	0		0	0	0	\N	0	113	40213227		
17214	1428	1115171	1995-08-22	1995-08-22 00:00:00	1995-09-19	1995-09-19 00:00:00	1995-09-19	38000177		0	0	28		0	0	0	94967	0	849574	1115171		
17260	1431	1127433	2018-07-09	2018-07-09 00:00:00	2018-07-16	2018-07-16 00:00:00	2018-07-16	38000177		0	0	7		0	0	0	95353	0	313782	1127433		
27756	2297	46233988	1976-10-20	1976-10-20 00:00:00	1976-11-03	1976-11-03 00:00:00	1976-11-03	38000177		0	0	14		0	0	0	152934	0	1652673	46233988		
20342	1670	40169216	1968-01-11	1968-01-11 00:00:00	1983-11-27	1983-11-27 00:00:00	1983-11-27	38000177		0	0	5799		0	0	0	112131	0	895994	40169216		
13822	1154	1127433	2009-11-01	2009-11-01 00:00:00	2009-11-22	2009-11-22 00:00:00	2009-11-22	38000177		0	0	21		0	0	0	76275	0	313782	1127433		
168076	3695	40213160	1980-05-12	1980-05-12 00:00:00	1980-05-12	1980-05-12 00:00:00	1980-05-12	581452		0	0	0		0	0	0	245677	0	10	40213160		
31174	679	40213314	1977-03-18	1977-03-18 00:00:00	1977-03-18	1977-03-18 00:00:00	1977-03-18	581452		0	0	0		0	0	0	44924	0	49	40213314		
38465	3178	42707627	2014-03-14	2014-03-14 00:00:00	2014-03-14	2014-03-14 00:00:00	2014-03-14	38000177		0	0	0		0	0	0	211388	0	1234995	42707627		
38488	3179	40220960	1987-05-23	1987-05-23 00:00:00	1987-05-23	1987-05-23 00:00:00	1987-05-23	38000177		0	0	0		0	0	0	211539	0	1804799	40220960		
7208	156	40213160	1983-07-17	1983-07-17 00:00:00	1983-07-17	1983-07-17 00:00:00	1983-07-17	581452		0	0	0		0	0	0	10657	0	10	40213160		
17884	1480	19133768	2006-08-04	2006-08-04 00:00:00	2006-08-04	2006-08-04 00:00:00	2006-08-04	38000177		0	0	0		0	0	0	98765	0	833036	19133768		
37908	3134	1713671	2003-09-26	2003-09-26 00:00:00	2003-10-10	2003-10-10 00:00:00	2003-10-10	38000177		0	0	14		0	0	0	208579	0	562251	1713671		
37962	3137	1127433	1919-01-12	1919-01-12 00:00:00	1919-01-19	1919-01-19 00:00:00	1919-01-19	38000177		0	0	7		0	0	0	208821	0	313782	1127433		
14713	1231	1127433	1968-04-21	1968-04-21 00:00:00	1968-05-06	1968-05-06 00:00:00	1968-05-06	38000177		0	0	15		0	0	0	81107	0	313782	1127433		
14769	1236	19059056	1925-08-21	1925-08-21 00:00:00	1925-09-04	1925-09-04 00:00:00	1925-09-04	38000177		0	0	14		0	0	0	81410	0	243670	19059056		
45685	3783	19133873	1953-05-15	1953-05-15 00:00:00	1953-05-28	1953-05-28 00:00:00	1953-05-28	38000177		0	0	13		0	0	0	251282	0	834061	19133873		
25302	2082	1118084	1975-09-15	1975-09-15 00:00:00	1975-09-15	1975-09-15 00:00:00	\N	38000177		0	0	0		0	0	0	138668	0	00025152531	44923712		
39103	3232	19075601	2019-04-29	2019-04-29 00:00:00	2019-04-29	2019-04-29 00:00:00	2019-04-29	38000177		0	0	0		0	0	0	214846	0	309362	19075601		
21826	1791	1127433	2017-03-22	2017-03-22 00:00:00	2017-04-05	2017-04-05 00:00:00	2017-04-05	38000177		0	0	14		0	0	0	120026	0	313782	1127433		
21852	1793	1127433	1947-02-16	1947-02-16 00:00:00	1947-03-02	1947-03-02 00:00:00	1947-03-02	38000177		0	0	14		0	0	0	120239	0	313782	1127433		
49701	4121	1124300	1964-10-19	1964-10-19 00:00:00	1964-10-19	1964-10-19 00:00:00	\N	38000177		0	0	0		0	0	0	274004	0	00781178901	45011828		
21086	458	40213160	1973-01-21	1973-01-21 00:00:00	1973-01-21	1973-01-21 00:00:00	1973-01-21	581452		0	0	0		0	0	0	30633	0	10	40213160		
49782	4130	1115171	1999-12-19	1999-12-19 00:00:00	2000-01-02	2000-01-02 00:00:00	2000-01-02	38000177		0	0	14		0	0	0	274666	0	849574	1115171		
42561	3529	1127433	2017-05-15	2017-05-15 00:00:00	2017-08-13	2017-08-13 00:00:00	2017-08-13	38000177		0	0	90		0	0	0	234452	0	313782	1127433		
3336	276	1713671	2008-01-26	2008-01-26 00:00:00	2008-02-16	2008-02-16 00:00:00	2008-02-16	38000177		0	0	21		0	0	0	18444	0	562251	1713671		
188154	4131	40213251	1984-06-08	1984-06-08 00:00:00	1984-06-08	1984-06-08 00:00:00	1984-06-08	581452		0	0	0		0	0	0	274681	0	21	40213251		
57128	4739	19059056	1910-11-22	1910-11-22 00:00:00	1910-12-06	1910-12-06 00:00:00	1910-12-06	38000177		0	0	14		0	0	0	315690	0	243670	19059056		
1027	84	19019979	1977-02-10	1977-02-10 00:00:00	1977-02-24	1977-02-24 00:00:00	1977-02-24	38000177		0	0	14		0	0	0	5659	0	198405	19019979		
60843	5060	1118084	2009-10-09	2009-10-09 00:00:00	2009-10-09	2009-10-09 00:00:00	\N	38000177		0	0	0		0	0	0	336435	0	00025152531	44923712		
1102	90	19133873	1963-02-13	1963-02-13 00:00:00	1963-02-20	1963-02-20 00:00:00	1963-02-20	38000177		0	0	7		0	0	0	6016	0	834061	19133873		
62455	5197	19075601	2012-05-08	2012-05-08 00:00:00	2012-05-08	2012-05-08 00:00:00	2012-05-08	38000177		0	0	0		0	0	0	345612	0	309362	19075601		
50307	1102	40213227	1998-08-04	1998-08-04 00:00:00	1998-08-04	1998-08-04 00:00:00	1998-08-04	581452		0	0	0		0	0	0	\N	0	113	40213227		
44882	3714	19059056	1928-07-15	1928-07-15 00:00:00	1928-08-05	1928-08-05 00:00:00	1928-08-05	38000177		0	0	21		0	0	0	246843	0	243670	19059056		
24686	2030	1127078	1967-01-26	1967-01-26 00:00:00	1967-02-25	1967-02-25 00:00:00	1967-02-25	38000177		0	0	30		0	0	0	135103	0	282464	1127078		
22270	1829	19059056	1989-07-22	1989-07-22 00:00:00	1989-08-12	1989-08-12 00:00:00	1989-08-12	38000177		0	0	21		0	0	0	122271	0	243670	19059056		
22325	1834	1127433	1969-10-02	1969-10-02 00:00:00	1969-10-09	1969-10-09 00:00:00	1969-10-09	38000177		0	0	7		0	0	0	122557	0	313782	1127433		
26162	2152	1539411	1991-03-16	1991-03-16 00:00:00	1991-03-16	1991-03-16 00:00:00	\N	38000177		0	0	0		0	0	0	143457	0	312961	1539411		
92835	2037	40213227	2002-04-26	2002-04-26 00:00:00	2002-04-26	2002-04-26 00:00:00	2002-04-26	581452		0	0	0		0	0	0	135654	0	113	40213227		
70206	1535	40213160	1978-07-10	1978-07-10 00:00:00	1978-07-10	1978-07-10 00:00:00	1978-07-10	581452		0	0	0		0	0	0	102758	0	10	40213160		
24535	533	40213260	2012-08-01	2012-08-01 00:00:00	2012-08-01	2012-08-01 00:00:00	2012-08-01	581452		0	0	0		0	0	0	35470	0	121	40213260		
169414	3725	40213160	1968-06-13	1968-06-13 00:00:00	1968-06-13	1968-06-13 00:00:00	1968-06-13	581452		0	0	0		0	0	0	247578	0	10	40213160		
40260	3334	1713671	1955-04-12	1955-04-12 00:00:00	1955-05-03	1955-05-03 00:00:00	1955-05-03	38000177		0	0	21		0	0	0	221175	0	562251	1713671		
5148	430	40222846	2006-12-08	2006-12-08 00:00:00	2006-12-08	2006-12-08 00:00:00	\N	38000177		0	0	0		0	0	0	28442	0	996740	40222846		
48944	1072	40213296	2001-12-26	2001-12-26 00:00:00	2001-12-26	2001-12-26 00:00:00	2001-12-26	581452		0	0	0		0	0	0	70218	0	52	40213296		
22688	1864	1127433	1979-11-04	1979-11-04 00:00:00	1979-11-11	1979-11-11 00:00:00	1979-11-11	38000177		0	0	7		0	0	0	124553	0	313782	1127433		
60511	5034	19126352	1993-01-23	1993-01-23 00:00:00	1993-11-13	1993-11-13 00:00:00	1993-11-13	38000177		0	0	294		0	0	0	334481	0	705129	19126352		
33580	2779	46233988	1976-03-18	1976-03-18 00:00:00	1976-04-01	1976-04-01 00:00:00	1976-04-01	38000177		0	0	14		0	0	0	184203	0	1652673	46233988		
8723	727	40229134	1927-04-03	1927-04-03 00:00:00	1927-04-17	1927-04-17 00:00:00	1927-04-17	38000177		0	0	14		0	0	0	48239	0	1043400	40229134		
33308	2760	19133873	1963-05-29	1963-05-29 00:00:00	1963-06-11	1963-06-11 00:00:00	1963-06-11	38000177		0	0	13		0	0	0	182548	0	834061	19133873		
25895	2130	40165015	1976-02-27	1976-02-27 00:00:00	1976-02-27	1976-02-27 00:00:00	\N	38000177		0	0	0		0	0	0	141691	0	861467	40165015		
44231	3661	40169216	1982-02-18	1982-02-18 00:00:00	1982-02-18	1982-02-18 00:00:00	\N	38000177		0	0	0		0	0	0	243669	0	895994	40169216		
19378	1598	19006318	1958-05-20	1958-05-20 00:00:00	1958-06-03	1958-06-03 00:00:00	1958-06-03	38000177		0	0	14		0	0	0	107211	0	105078	19006318		
9160	761	19078461	1994-04-25	1994-04-25 00:00:00	1994-05-16	1994-05-16 00:00:00	1994-05-16	38000177		0	0	21		0	0	0	50523	0	310965	19078461		
17067	368	40213227	2013-10-16	2013-10-16 00:00:00	2013-10-16	2013-10-16 00:00:00	2013-10-16	581452		0	0	0		0	0	0	24514	0	113	40213227		
26605	2190	1127078	1957-10-28	1957-10-28 00:00:00	1957-11-18	1957-11-18 00:00:00	1957-11-18	38000177		0	0	21		0	0	0	146079	0	282464	1127078		
37089	3067	1127433	1967-03-09	1967-03-09 00:00:00	1967-04-08	1967-04-08 00:00:00	1967-04-08	38000177		0	0	30		0	0	0	204177	0	313782	1127433		
26712	2199	1713671	2018-05-08	2018-05-08 00:00:00	2018-05-22	2018-05-22 00:00:00	2018-05-22	38000177		0	0	14		0	0	0	146561	0	562251	1713671		
21744	1785	1124300	1990-12-14	1990-12-14 00:00:00	1990-12-14	1990-12-14 00:00:00	\N	38000177		0	0	0		0	0	0	119612	0	00781178901	45011828		
37249	3079	1127433	1957-05-16	1957-05-16 00:00:00	1957-05-30	1957-05-30 00:00:00	1957-05-30	38000177		0	0	14		0	0	0	204869	0	313782	1127433		
32295	2677	1713671	1988-01-29	1988-01-29 00:00:00	1988-02-05	1988-02-05 00:00:00	1988-02-05	38000177		0	0	7		0	0	0	177418	0	562251	1713671		
32616	2703	19133873	1979-09-20	1979-09-20 00:00:00	1979-09-28	1979-09-28 00:00:00	1979-09-28	38000177		0	0	8		0	0	0	179052	0	834061	19133873		
6629	559	19019979	1974-02-22	1974-02-22 00:00:00	1974-03-15	1974-03-15 00:00:00	1974-03-15	38000177		0	0	21		0	0	0	37096	0	198405	19019979		
47915	3972	19078461	2016-03-22	2016-03-22 00:00:00	2016-04-19	2016-04-19 00:00:00	2016-04-19	38000177		0	0	28		0	0	0	264118	0	310965	19078461		
26307	573	40213306	1982-11-06	1982-11-06 00:00:00	1982-11-06	1982-11-06 00:00:00	1982-11-06	581452		0	0	0		0	0	0	37995	0	43	40213306		
17215	1428	1127433	1962-12-07	1962-12-07 00:00:00	1962-12-14	1962-12-14 00:00:00	1962-12-14	38000177		0	0	7		0	0	0	95010	0	313782	1127433		
17261	1431	19059056	1965-05-31	1965-05-31 00:00:00	1965-06-30	1965-06-30 00:00:00	1965-06-30	38000177		0	0	30		0	0	0	95250	0	243670	19059056		
27757	2297	1127078	1976-10-20	1976-10-20 00:00:00	1976-11-03	1976-11-03 00:00:00	1976-11-03	38000177		0	0	14		0	0	0	152934	0	282464	1127078		
20343	1670	1154615	1968-01-11	1968-01-11 00:00:00	1983-11-27	1983-11-27 00:00:00	1983-11-27	38000177		0	0	5799		0	0	0	112131	0	745679	1154615		
13823	1154	1115171	2016-08-17	2016-08-17 00:00:00	2016-11-15	2016-11-15 00:00:00	2016-11-15	38000177		0	0	90		0	0	0	76276	0	849574	1115171		
168077	3695	40213227	2002-06-24	2002-06-24 00:00:00	2002-06-24	2002-06-24 00:00:00	2002-06-24	581452		0	0	0		0	0	0	245576	0	113	40213227		
31177	679	40213160	1977-03-18	1977-03-18 00:00:00	1977-03-18	1977-03-18 00:00:00	1977-03-18	581452		0	0	0		0	0	0	44924	0	10	40213160		
38466	3178	1367571	2014-03-13	2014-03-13 00:00:00	2014-03-13	2014-03-13 00:00:00	2014-03-13	38000177		0	0	0		0	0	0	211388	0	314659	19080464		
38489	3179	1127433	1987-06-13	1987-06-13 00:00:00	1987-06-27	1987-06-27 00:00:00	1987-06-27	38000177		0	0	14		0	0	0	211514	0	313782	1127433		
7213	156	40213306	2001-10-14	2001-10-14 00:00:00	2001-10-14	2001-10-14 00:00:00	2001-10-14	581452		0	0	0		0	0	0	10666	0	43	40213306		
17885	1480	19075601	2006-08-04	2006-08-04 00:00:00	2006-08-04	2006-08-04 00:00:00	2006-08-04	38000177		0	0	0		0	0	0	98765	0	309362	19075601		
37909	3134	1127433	2001-08-01	2001-08-01 00:00:00	2001-08-22	2001-08-22 00:00:00	2001-08-22	38000177		0	0	21		0	0	0	208558	0	313782	1127433		
37963	3137	1127433	1982-05-06	1982-05-06 00:00:00	1982-06-03	1982-06-03 00:00:00	1982-06-03	38000177		0	0	28		0	0	0	208835	0	313782	1127433		
14714	1231	1127433	2000-11-01	2000-11-01 00:00:00	2001-01-30	2001-01-30 00:00:00	2001-01-30	38000177		0	0	90		0	0	0	81119	0	313782	1127433		
14770	1236	19133873	1933-12-04	1933-12-04 00:00:00	1933-12-16	1933-12-16 00:00:00	1933-12-16	38000177		0	0	12		0	0	0	81363	0	834061	19133873		
45686	3783	1713671	1999-02-28	1999-02-28 00:00:00	1999-03-14	1999-03-14 00:00:00	1999-03-14	38000177		0	0	14		0	0	0	251366	0	562251	1713671		
25320	2084	1127433	2003-10-19	2003-10-19 00:00:00	2003-10-26	2003-10-26 00:00:00	2003-10-26	38000177		0	0	7		0	0	0	138863	0	313782	1127433		
39104	3232	1713671	1967-02-02	1967-02-02 00:00:00	1967-02-23	1967-02-23 00:00:00	1967-02-23	38000177		0	0	21		0	0	0	214835	0	562251	1713671		
21827	1791	1127433	1969-12-30	1969-12-30 00:00:00	1970-01-13	1970-01-13 00:00:00	1970-01-13	38000177		0	0	14		0	0	0	120089	0	313782	1127433		
21853	1793	19075601	1997-07-16	1997-07-16 00:00:00	2006-08-30	2006-08-30 00:00:00	2006-08-30	38000177		0	0	3332		0	0	0	120172	0	309362	19075601		
49702	4122	19078461	1995-11-25	1995-11-25 00:00:00	1996-02-23	1996-02-23 00:00:00	1996-02-23	38000177		0	0	90		0	0	0	274067	0	310965	19078461		
21088	458	40213227	1995-03-19	1995-03-19 00:00:00	1995-03-19	1995-03-19 00:00:00	1995-03-19	581452		0	0	0		0	0	0	30667	0	113	40213227		
49783	4130	1118084	2004-04-28	2004-04-28 00:00:00	2004-04-28	2004-04-28 00:00:00	\N	38000177		0	0	0		0	0	0	274549	0	00025152531	44923712		
42562	3529	40162522	2017-05-15	2017-05-15 00:00:00	2017-05-15	2017-05-15 00:00:00	\N	38000177		0	0	0		0	0	0	234452	0	857005	40162522		
3337	276	19128022	1994-05-21	1994-05-21 00:00:00	1995-05-16	1995-05-16 00:00:00	1995-05-16	38000177		0	0	360		0	0	0	18410	0	749785	19128022		
188156	4131	40213314	1977-05-20	1977-05-20 00:00:00	1977-05-20	1977-05-20 00:00:00	1977-05-20	581452		0	0	0		0	0	0	274669	0	49	40213314		
57129	4739	19059056	1911-09-02	1911-09-02 00:00:00	1911-09-16	1911-09-16 00:00:00	1911-09-16	38000177		0	0	14		0	0	0	315766	0	243670	19059056		
1028	84	46233988	1977-02-10	1977-02-10 00:00:00	1977-02-24	1977-02-24 00:00:00	1977-02-24	38000177		0	0	14		0	0	0	5659	0	1652673	46233988		
60844	5060	1127433	2012-10-23	2012-10-23 00:00:00	2012-12-22	2012-12-22 00:00:00	2012-12-22	38000177		0	0	60		0	0	0	336407	0	313782	1127433		
1103	90	1127078	1965-10-28	1965-10-28 00:00:00	1965-12-02	1965-12-02 00:00:00	1965-12-02	38000177		0	0	35		0	0	0	5996	0	282464	1127078		
62456	5197	40220960	2012-05-08	2012-05-08 00:00:00	2012-05-08	2012-05-08 00:00:00	2012-05-08	38000177		0	0	0		0	0	0	345612	0	1804799	40220960		
50313	1102	40213160	1971-10-26	1971-10-26 00:00:00	1971-10-26	1971-10-26 00:00:00	1971-10-26	581452		0	0	0		0	0	0	72437	0	10	40213160		
44883	3714	19059056	1965-02-16	1965-02-16 00:00:00	1965-03-02	1965-03-02 00:00:00	1965-03-02	38000177		0	0	14		0	0	0	246849	0	243670	19059056		
24687	2030	1127078	1970-12-06	1970-12-06 00:00:00	1971-01-10	1971-01-10 00:00:00	1971-01-10	38000177		0	0	35		0	0	0	135104	0	282464	1127078		
22271	1829	1127433	2003-07-17	2003-07-17 00:00:00	2003-07-24	2003-07-24 00:00:00	2003-07-24	38000177		0	0	7		0	0	0	122305	0	313782	1127433		
22326	1834	1115171	2009-01-13	2009-01-13 00:00:00	2009-02-17	2009-02-17 00:00:00	2009-02-17	38000177		0	0	35		0	0	0	122544	0	849574	1115171		
26163	2152	40229134	2005-01-26	2005-01-26 00:00:00	2005-02-09	2005-02-09 00:00:00	2005-02-09	38000177		0	0	14		0	0	0	143427	0	1043400	40229134		
92836	2037	40213296	2002-04-26	2002-04-26 00:00:00	2002-04-26	2002-04-26 00:00:00	2002-04-26	581452		0	0	0		0	0	0	135654	0	52	40213296		
70207	1535	40213251	1984-04-09	1984-04-09 00:00:00	1984-04-09	1984-04-09 00:00:00	1984-04-09	581452		0	0	0		0	0	0	102768	0	21	40213251		
24538	534	40213227	2010-01-11	2010-01-11 00:00:00	2010-01-11	2010-01-11 00:00:00	2010-01-11	581452		0	0	0		0	0	0	35603	0	113	40213227		
169418	3725	40213227	2010-11-11	2010-11-11 00:00:00	2010-11-11	2010-11-11 00:00:00	2010-11-11	581452		0	0	0		0	0	0	247559	0	113	40213227		
40261	3334	19059056	1946-10-20	1946-10-20 00:00:00	1947-01-18	1947-01-18 00:00:00	1947-01-18	38000177		0	0	90		0	0	0	221157	0	243670	19059056		
5149	430	1127433	2006-02-15	2006-02-15 00:00:00	2006-02-22	2006-02-22 00:00:00	2006-02-22	38000177		0	0	7		0	0	0	28441	0	313782	1127433		
48947	1072	40213296	2003-12-31	2003-12-31 00:00:00	2003-12-31	2003-12-31 00:00:00	2003-12-31	581452		0	0	0		0	0	0	70225	0	52	40213296		
22689	1864	1713671	1966-07-10	1966-07-10 00:00:00	1966-07-31	1966-07-31 00:00:00	1966-07-31	38000177		0	0	21		0	0	0	124535	0	562251	1713671		
60512	5034	1539411	1993-01-23	1993-01-23 00:00:00	1993-01-23	1993-01-23 00:00:00	\N	38000177		0	0	0		0	0	0	334481	0	312961	1539411		
33581	2779	19019979	1976-03-18	1976-03-18 00:00:00	1976-04-01	1976-04-01 00:00:00	1976-04-01	38000177		0	0	14		0	0	0	184203	0	198405	19019979		
8724	727	1118084	1947-05-12	1947-05-12 00:00:00	1947-05-12	1947-05-12 00:00:00	\N	38000177		0	0	0		0	0	0	48139	0	00025152531	44923712		
33309	2760	1713671	1967-12-13	1967-12-13 00:00:00	1968-01-03	1968-01-03 00:00:00	1968-01-03	38000177		0	0	21		0	0	0	182531	0	562251	1713671		
25896	2130	1713671	1962-08-18	1962-08-18 00:00:00	1962-08-25	1962-08-25 00:00:00	1962-08-25	38000177		0	0	7		0	0	0	141694	0	562251	1713671		
44232	3661	1154615	1982-02-18	1982-02-18 00:00:00	1982-02-18	1982-02-18 00:00:00	\N	38000177		0	0	0		0	0	0	243669	0	745679	1154615		
19379	1598	19059056	1958-05-20	1958-05-20 00:00:00	1958-06-03	1958-06-03 00:00:00	1958-06-03	38000177		0	0	14		0	0	0	107211	0	243670	19059056		
9161	761	1150771	1979-09-26	1979-09-26 00:00:00	1979-09-26	1979-09-26 00:00:00	\N	38000177		0	0	0		0	0	0	50589	0	197378	1150771		
17076	368	40213227	1993-10-13	1993-10-13 00:00:00	1993-10-13	1993-10-13 00:00:00	1993-10-13	581452		0	0	0		0	0	0	24504	0	113	40213227		
26606	2190	19133905	2017-06-05	2017-06-05 00:00:00	2017-06-12	2017-06-12 00:00:00	2017-06-12	38000177		0	0	7		0	0	0	146013	0	834102	19133905		
37090	3067	1127433	1979-08-01	1979-08-01 00:00:00	1979-08-15	1979-08-15 00:00:00	1979-08-15	38000177		0	0	14		0	0	0	204185	0	313782	1127433		
26713	2200	1127433	1991-05-12	1991-05-12 00:00:00	1991-08-10	1991-08-10 00:00:00	1991-08-10	38000177		0	0	90		0	0	0	146684	0	313782	1127433		
21745	1785	19059056	1956-08-24	1956-08-24 00:00:00	1956-09-14	1956-09-14 00:00:00	1956-09-14	38000177		0	0	21		0	0	0	119605	0	243670	19059056		
37250	3079	1115171	2003-07-17	2003-07-17 00:00:00	2003-07-31	2003-07-31 00:00:00	2003-07-31	38000177		0	0	14		0	0	0	204965	0	849574	1115171		
32296	2677	1115171	2014-02-24	2014-02-24 00:00:00	2014-03-18	2014-03-18 00:00:00	2014-03-18	38000177		0	0	22		0	0	0	177361	0	849574	1115171		
32617	2703	1115171	2014-10-07	2014-10-07 00:00:00	2014-10-28	2014-10-28 00:00:00	2014-10-28	38000177		0	0	21		0	0	0	179110	0	849574	1115171		
6630	559	40229134	1989-01-26	1989-01-26 00:00:00	1989-02-09	1989-02-09 00:00:00	1989-02-09	38000177		0	0	14		0	0	0	37100	0	1043400	40229134		
47916	3972	19059056	1972-12-03	1972-12-03 00:00:00	1973-01-07	1973-01-07 00:00:00	1973-01-07	38000177		0	0	35		0	0	0	264136	0	243670	19059056		
106233	2330	40213227	2017-07-31	2017-07-31 00:00:00	2017-07-31	2017-07-31 00:00:00	2017-07-31	581452		0	0	0		0	0	0	155003	0	113	40213227		
17216	1428	1127078	1952-09-10	1952-09-10 00:00:00	1952-09-30	1952-09-30 00:00:00	1952-09-30	38000177		0	0	20		0	0	0	94965	0	282464	1127078		
17262	1431	19078461	2018-11-08	2018-11-08 00:00:00	2018-12-08	2018-12-08 00:00:00	2018-12-08	38000177		0	0	30		0	0	0	95254	0	310965	19078461		
27758	2297	19078461	2017-05-18	2017-05-18 00:00:00	2017-06-01	2017-06-01 00:00:00	2017-06-01	38000177		0	0	14		0	0	0	152930	0	310965	19078461		
20344	1670	1127433	2014-10-13	2014-10-13 00:00:00	2014-10-20	2014-10-20 00:00:00	2014-10-20	38000177		0	0	7		0	0	0	112139	0	313782	1127433		
13824	1154	1127433	2002-05-21	2002-05-21 00:00:00	2002-08-19	2002-08-19 00:00:00	2002-08-19	38000177		0	0	90		0	0	0	76272	0	313782	1127433		
168078	3695	40213306	2002-06-24	2002-06-24 00:00:00	2002-06-24	2002-06-24 00:00:00	2002-06-24	581452		0	0	0		0	0	0	245576	0	43	40213306		
31179	679	40213306	1994-12-16	1994-12-16 00:00:00	1994-12-16	1994-12-16 00:00:00	1994-12-16	581452		0	0	0		0	0	0	44949	0	43	40213306		
38467	3178	782047	2014-03-14	2014-03-14 00:00:00	2014-03-14	2014-03-14 00:00:00	2014-03-14	38000177		0	0	0		0	0	0	211388	0	542347	782047		
38490	3179	19133873	1928-02-04	1928-02-04 00:00:00	1928-02-14	1928-02-14 00:00:00	1928-02-14	38000177		0	0	10		0	0	0	211511	0	834061	19133873		
7215	156	40213227	2001-10-14	2001-10-14 00:00:00	2001-10-14	2001-10-14 00:00:00	2001-10-14	581452		0	0	0		0	0	0	10666	0	113	40213227		
17886	1480	19059056	1974-09-06	1974-09-06 00:00:00	1974-09-20	1974-09-20 00:00:00	1974-09-20	38000177		0	0	14		0	0	0	98760	0	243670	19059056		
37910	3134	19059056	1966-11-07	1966-11-07 00:00:00	1966-12-12	1966-12-12 00:00:00	1966-12-12	38000177		0	0	35		0	0	0	208555	0	243670	19059056		
37964	3137	19059056	1912-03-02	1912-03-02 00:00:00	1912-03-16	1912-03-16 00:00:00	1912-03-16	38000177		0	0	14		0	0	0	208868	0	243670	19059056		
14715	1231	1127433	1975-03-09	1975-03-09 00:00:00	1975-04-06	1975-04-06 00:00:00	1975-04-06	38000177		0	0	28		0	0	0	81115	0	313782	1127433		
43405	3598	1539411	1996-04-07	1996-04-07 00:00:00	1996-04-07	1996-04-07 00:00:00	\N	38000177		0	0	0		0	0	0	239010	0	312961	1539411		
45687	3783	40229134	1985-07-21	1985-07-21 00:00:00	1985-07-28	1985-07-28 00:00:00	1985-07-28	38000177		0	0	7		0	0	0	251369	0	1043400	40229134		
54168	1185	40213227	2018-05-06	2018-05-06 00:00:00	2018-05-06	2018-05-06 00:00:00	2018-05-06	581452		0	0	0		0	0	0	78177	0	113	40213227		
39105	3232	19133873	1969-06-17	1969-06-17 00:00:00	1969-06-24	1969-06-24 00:00:00	1969-06-24	38000177		0	0	7		0	0	0	214816	0	834061	19133873		
21828	1791	19078461	2006-06-13	2006-06-13 00:00:00	2006-07-04	2006-07-04 00:00:00	2006-07-04	38000177		0	0	21		0	0	0	120060	0	310965	19078461		
21854	1793	1127433	1953-11-10	1953-11-10 00:00:00	1953-12-08	1953-12-08 00:00:00	1953-12-08	38000177		0	0	28		0	0	0	120222	0	313782	1127433		
49703	4122	19133905	2013-06-23	2013-06-23 00:00:00	2013-07-05	2013-07-05 00:00:00	2013-07-05	38000177		0	0	12		0	0	0	274042	0	834102	19133905		
21089	458	40213306	1995-03-19	1995-03-19 00:00:00	1995-03-19	1995-03-19 00:00:00	1995-03-19	581452		0	0	0		0	0	0	30667	0	43	40213306		
49784	4130	1115171	1998-11-19	1998-11-19 00:00:00	1998-12-24	1998-12-24 00:00:00	1998-12-24	38000177		0	0	35		0	0	0	274665	0	849574	1115171		
42564	3529	19059056	1947-04-11	1947-04-11 00:00:00	1947-04-25	1947-04-25 00:00:00	1947-04-25	38000177		0	0	14		0	0	0	234285	0	243670	19059056		
3338	276	1127078	1978-06-04	1978-06-04 00:00:00	1978-07-04	1978-07-04 00:00:00	1978-07-04	38000177		0	0	30		0	0	0	18389	0	282464	1127078		
10289	862	19078461	2017-08-22	2017-08-22 00:00:00	2017-11-20	2017-11-20 00:00:00	2017-11-20	38000177		0	0	90		0	0	0	57054	0	310965	19078461		
57130	4739	1539411	1992-01-04	1992-01-04 00:00:00	1992-01-04	1992-01-04 00:00:00	\N	38000177		0	0	0		0	0	0	315777	0	312961	1539411		
63076	5240	1713671	1989-12-02	1989-12-02 00:00:00	1989-12-16	1989-12-16 00:00:00	1989-12-16	38000177		0	0	14		0	0	0	348715	0	562251	1713671		
60845	5060	40165015	2012-10-23	2012-10-23 00:00:00	2012-10-23	2012-10-23 00:00:00	\N	38000177		0	0	0		0	0	0	336407	0	861467	40165015		
1104	90	19133905	1991-12-05	1991-12-05 00:00:00	1991-12-12	1991-12-12 00:00:00	1991-12-12	38000177		0	0	7		0	0	0	6006	0	834102	19133905		
62457	5197	1127433	1954-06-17	1954-06-17 00:00:00	1954-06-24	1954-06-24 00:00:00	1954-06-24	38000177		0	0	7		0	0	0	345578	0	313782	1127433		
50318	1102	40213306	1990-01-23	1990-01-23 00:00:00	1990-01-23	1990-01-23 00:00:00	1990-01-23	581452		0	0	0		0	0	0	72445	0	43	40213306		
44884	3714	19075601	2005-09-21	2005-09-21 00:00:00	2005-09-21	2005-09-21 00:00:00	2005-09-21	38000177		0	0	0		0	0	0	246840	0	309362	19075601		
24688	2030	40229134	1995-07-13	1995-07-13 00:00:00	1995-07-27	1995-07-27 00:00:00	1995-07-27	38000177		0	0	14		0	0	0	135120	0	1043400	40229134		
58717	1285	40213227	1996-04-01	1996-04-01 00:00:00	1996-04-01	1996-04-01 00:00:00	1996-04-01	581452		0	0	0		0	0	0	85032	0	113	40213227		
22327	1834	40229134	1993-12-09	1993-12-09 00:00:00	1993-12-23	1993-12-23 00:00:00	1993-12-23	38000177		0	0	14		0	0	0	122562	0	1043400	40229134		
26164	2152	19075601	1997-04-19	1997-04-19 00:00:00	2007-09-08	2007-09-08 00:00:00	2007-09-08	38000177		0	0	3794		0	0	0	143388	0	309362	19075601		
92846	2037	40213160	1960-12-23	1960-12-23 00:00:00	1960-12-23	1960-12-23 00:00:00	1960-12-23	581452		0	0	0		0	0	0	135628	0	10	40213160		
32883	2724	40173590	2015-04-19	2015-04-19 00:00:00	2015-04-19	2015-04-19 00:00:00	\N	38000177		0	0	0		0	0	0	180462	0	904419	40173590		
24541	534	40213251	1984-06-05	1984-06-05 00:00:00	1984-06-05	1984-06-05 00:00:00	1984-06-05	581452		0	0	0		0	0	0	35537	0	21	40213251		
169419	3725	40213296	2010-11-11	2010-11-11 00:00:00	2010-11-11	2010-11-11 00:00:00	2010-11-11	581452		0	0	0		0	0	0	247559	0	52	40213296		
40262	3335	19078461	2005-03-31	2005-03-31 00:00:00	2005-04-28	2005-04-28 00:00:00	2005-04-28	38000177		0	0	28		0	0	0	221302	0	310965	19078461		
5150	430	19077572	2005-07-16	2005-07-16 00:00:00	2005-07-16	2005-07-16 00:00:00	\N	38000177		0	0	0		0	0	0	28450	0	310436	19077572		
48949	1072	40213227	1994-11-02	1994-11-02 00:00:00	1994-11-02	1994-11-02 00:00:00	1994-11-02	581452		0	0	0		0	0	0	70270	0	113	40213227		
22690	1864	920300	2012-12-19	2012-12-19 00:00:00	2012-12-26	2012-12-26 00:00:00	2012-12-26	38000177		0	0	7		0	0	0	124565	0	311989	920300		
60513	5034	19059056	1945-02-10	1945-02-10 00:00:00	1945-03-03	1945-03-03 00:00:00	1945-03-03	38000177		0	0	21		0	0	0	334458	0	243670	19059056		
33582	2779	40229134	1988-12-11	1988-12-11 00:00:00	1988-12-18	1988-12-18 00:00:00	1988-12-18	38000177		0	0	7		0	0	0	184094	0	1043400	40229134		
8725	727	19059056	1944-05-17	1944-05-17 00:00:00	1944-06-07	1944-06-07 00:00:00	1944-06-07	38000177		0	0	21		0	0	0	48205	0	243670	19059056		
33310	2760	40236824	1998-04-18	1998-04-18 00:00:00	1998-04-25	1998-04-25 00:00:00	1998-04-25	38000177		0	0	7		0	0	0	182555	0	1094107	40236824		
36355	2997	1127433	1993-12-01	1993-12-01 00:00:00	1993-12-15	1993-12-15 00:00:00	1993-12-15	38000177		0	0	14		0	0	0	199970	0	313782	1127433		
44233	3661	19133873	1986-07-04	1986-07-04 00:00:00	1986-07-11	1986-07-11 00:00:00	1986-07-11	38000177		0	0	7		0	0	0	243673	0	834061	19133873		
19380	1599	19059056	1966-11-09	1966-11-09 00:00:00	1966-12-09	1966-12-09 00:00:00	1966-12-09	38000177		0	0	30		0	0	0	107360	0	243670	19059056		
9162	761	40169216	1980-12-21	1980-12-21 00:00:00	1998-06-05	1998-06-05 00:00:00	1998-06-05	38000177		0	0	6375		0	0	0	50564	0	895994	40169216		
17077	368	40213306	1993-10-13	1993-10-13 00:00:00	1993-10-13	1993-10-13 00:00:00	1993-10-13	581452		0	0	0		0	0	0	24504	0	43	40213306		
26607	2190	40165015	2014-09-23	2014-09-23 00:00:00	2014-09-23	2014-09-23 00:00:00	\N	38000177		0	0	0		0	0	0	146083	0	861467	40165015		
37091	3067	1118084	1976-07-27	1976-07-27 00:00:00	1976-07-27	1976-07-27 00:00:00	\N	38000177		0	0	0		0	0	0	204145	0	00025152531	44923712		
26714	2200	1118084	2014-04-16	2014-04-16 00:00:00	2014-04-16	2014-04-16 00:00:00	\N	38000177		0	0	0		0	0	0	146659	0	00025152531	44923712		
21746	1785	1127078	1961-05-26	1961-05-26 00:00:00	1961-06-25	1961-06-25 00:00:00	1961-06-25	38000177		0	0	30		0	0	0	119607	0	282464	1127078		
37251	3079	1127433	1995-08-30	1995-08-30 00:00:00	1995-09-13	1995-09-13 00:00:00	1995-09-13	38000177		0	0	14		0	0	0	204872	0	313782	1127433		
32302	2679	19133873	1978-09-29	1978-09-29 00:00:00	1978-10-07	1978-10-07 00:00:00	1978-10-07	38000177		0	0	8		0	0	0	177500	0	834061	19133873		
32619	2703	19115351	1974-11-10	1974-11-10 00:00:00	1976-06-27	1976-06-27 00:00:00	1976-06-27	38000177		0	0	595		0	0	0	179068	0	563026	19115351		
6631	559	40229134	1969-06-19	1969-06-19 00:00:00	1969-07-03	1969-07-03 00:00:00	1969-07-03	38000177		0	0	14		0	0	0	37050	0	1043400	40229134		
47917	3972	19133873	1962-04-29	1962-04-29 00:00:00	1962-05-10	1962-05-10 00:00:00	1962-05-10	38000177		0	0	11		0	0	0	264157	0	834061	19133873		
106234	2330	40213296	2017-07-31	2017-07-31 00:00:00	2017-07-31	2017-07-31 00:00:00	2017-07-31	581452		0	0	0		0	0	0	155003	0	52	40213296		
17217	1428	19078461	1998-06-05	1998-06-05 00:00:00	1998-08-04	1998-08-04 00:00:00	1998-08-04	38000177		0	0	60		0	0	0	95043	0	310965	19078461		
17263	1431	1713671	1985-05-25	1985-05-25 00:00:00	1985-06-15	1985-06-15 00:00:00	1985-06-15	38000177		0	0	21		0	0	0	95316	0	562251	1713671		
27759	2297	19128065	1988-08-28	1988-08-28 00:00:00	1989-08-23	1989-08-23 00:00:00	1989-08-23	38000177		0	0	360		0	0	0	152963	0	749882	19128065		
20345	1670	1127433	2015-10-01	2015-10-01 00:00:00	2015-10-08	2015-10-08 00:00:00	2015-10-08	38000177		0	0	7		0	0	0	112152	0	313782	1127433		
13825	1155	1127433	1981-03-04	1981-03-04 00:00:00	1981-04-03	1981-04-03 00:00:00	1981-04-03	38000177		0	0	30		0	0	0	76312	0	313782	1127433		
179363	3943	40213160	1957-01-24	1957-01-24 00:00:00	1957-01-24	1957-01-24 00:00:00	1957-01-24	581452		0	0	0		0	0	0	262158	0	10	40213160		
31181	679	40213227	1994-12-16	1994-12-16 00:00:00	1994-12-16	1994-12-16 00:00:00	1994-12-16	581452		0	0	0		0	0	0	44949	0	113	40213227		
38468	3178	19078924	2014-03-14	2014-03-14 00:00:00	2014-03-14	2014-03-14 00:00:00	2014-03-14	38000177		0	0	0		0	0	0	211388	0	311700	19078924		
38491	3179	19059056	1925-10-30	1925-10-30 00:00:00	1925-11-20	1925-11-20 00:00:00	1925-11-20	38000177		0	0	21		0	0	0	211526	0	243670	19059056		
7217	156	40213296	2018-11-04	2018-11-04 00:00:00	2018-11-04	2018-11-04 00:00:00	2018-11-04	581452		0	0	0		0	0	0	10692	0	52	40213296		
17887	1480	1127078	1968-02-10	1968-02-10 00:00:00	1968-02-24	1968-02-24 00:00:00	1968-02-24	38000177		0	0	14		0	0	0	98721	0	282464	1127078		
37911	3134	19059056	1924-08-09	1924-08-09 00:00:00	1924-09-13	1924-09-13 00:00:00	1924-09-13	38000177		0	0	35		0	0	0	208553	0	243670	19059056		
37965	3137	40236824	1947-08-07	1947-08-07 00:00:00	1947-08-14	1947-08-14 00:00:00	1947-08-14	38000177		0	0	7		0	0	0	208780	0	1094107	40236824		
14716	1231	1118084	1978-01-21	1978-01-21 00:00:00	1978-01-21	1978-01-21 00:00:00	\N	38000177		0	0	0		0	0	0	81084	0	00025152531	44923712		
43407	3599	19059056	1971-06-09	1971-06-09 00:00:00	1971-06-23	1971-06-23 00:00:00	1971-06-23	38000177		0	0	14		0	0	0	239052	0	243670	19059056		
45688	3783	19059056	1943-06-19	1943-06-19 00:00:00	1943-07-03	1943-07-03 00:00:00	1943-07-03	38000177		0	0	14		0	0	0	251409	0	243670	19059056		
54174	1185	40213227	1998-01-11	1998-01-11 00:00:00	1998-01-11	1998-01-11 00:00:00	1998-01-11	581452		0	0	0		0	0	0	78116	0	113	40213227		
39106	3232	1127433	1999-07-14	1999-07-14 00:00:00	1999-08-11	1999-08-11 00:00:00	1999-08-11	38000177		0	0	28		0	0	0	214859	0	313782	1127433		
21829	1791	1127433	1963-11-19	1963-11-19 00:00:00	1963-11-26	1963-11-26 00:00:00	1963-11-26	38000177		0	0	7		0	0	0	120088	0	313782	1127433		
21855	1793	1127433	2002-06-16	2002-06-16 00:00:00	2002-06-30	2002-06-30 00:00:00	2002-06-30	38000177		0	0	14		0	0	0	120269	0	313782	1127433		
49704	4122	1118084	2013-08-22	2013-08-22 00:00:00	2013-08-22	2013-08-22 00:00:00	\N	38000177		0	0	0		0	0	0	274042	0	00025152531	44923712		
21092	458	40213160	1972-11-19	1972-11-19 00:00:00	1972-11-19	1972-11-19 00:00:00	1972-11-19	581452		0	0	0		0	0	0	30618	0	10	40213160		
49785	4130	19059056	1968-03-24	1968-03-24 00:00:00	1968-04-07	1968-04-07 00:00:00	1968-04-07	38000177		0	0	14		0	0	0	274662	0	243670	19059056		
42565	3529	19059056	1944-09-23	1944-09-23 00:00:00	1944-10-07	1944-10-07 00:00:00	1944-10-07	38000177		0	0	14		0	0	0	234310	0	243670	19059056		
3339	276	19128065	1997-05-11	1997-05-11 00:00:00	1998-05-06	1998-05-06 00:00:00	1998-05-06	38000177		0	0	360		0	0	0	18397	0	749882	19128065		
10290	862	1127433	1987-02-21	1987-02-21 00:00:00	1987-03-07	1987-03-07 00:00:00	1987-03-07	38000177		0	0	14		0	0	0	57044	0	313782	1127433		
57131	4739	1713671	1944-02-27	1944-02-27 00:00:00	1944-03-05	1944-03-05 00:00:00	1944-03-05	38000177		0	0	7		0	0	0	315753	0	562251	1713671		
63077	5240	1127433	1974-05-22	1974-05-22 00:00:00	1974-06-19	1974-06-19 00:00:00	1974-06-19	38000177		0	0	28		0	0	0	348608	0	313782	1127433		
60860	5063	1118084	1981-09-11	1981-09-11 00:00:00	1981-09-11	1981-09-11 00:00:00	\N	38000177		0	0	0		0	0	0	336661	0	00025152531	44923712		
1105	90	1713671	1968-06-08	1968-06-08 00:00:00	1968-06-29	1968-06-29 00:00:00	1968-06-29	38000177		0	0	21		0	0	0	5982	0	562251	1713671		
62458	5197	1124300	1995-09-28	1995-09-28 00:00:00	1995-09-28	1995-09-28 00:00:00	\N	38000177		0	0	0		0	0	0	345576	0	00781178901	45011828		
50324	1102	40213160	1967-10-03	1967-10-03 00:00:00	1967-10-03	1967-10-03 00:00:00	1967-10-03	581452		0	0	0		0	0	0	72487	0	10	40213160		
44885	3714	40220960	2005-09-21	2005-09-21 00:00:00	2005-09-21	2005-09-21 00:00:00	2005-09-21	38000177		0	0	0		0	0	0	246840	0	1804799	40220960		
24689	2030	1127433	1971-01-07	1971-01-07 00:00:00	1971-01-14	1971-01-14 00:00:00	1971-01-14	38000177		0	0	7		0	0	0	135117	0	313782	1127433		
58718	1285	40213296	1996-04-01	1996-04-01 00:00:00	1996-04-01	1996-04-01 00:00:00	1996-04-01	581452		0	0	0		0	0	0	85032	0	52	40213296		
58764	1285	40213160	1955-02-28	1955-02-28 00:00:00	1955-02-28	1955-02-28 00:00:00	1955-02-28	581452		0	0	0		0	0	0	84997	0	10	40213160		
26165	2152	1127433	1972-11-25	1972-11-25 00:00:00	1972-12-09	1972-12-09 00:00:00	1972-12-09	38000177		0	0	14		0	0	0	143424	0	313782	1127433		
92848	2037	40213160	1960-09-23	1960-09-23 00:00:00	1960-09-23	1960-09-23 00:00:00	1960-09-23	581452		0	0	0		0	0	0	135683	0	10	40213160		
32884	2724	19133873	1969-04-19	1969-04-19 00:00:00	1969-04-29	1969-04-29 00:00:00	1969-04-29	38000177		0	0	10		0	0	0	180482	0	834061	19133873		
24545	534	40213296	2018-06-26	2018-06-26 00:00:00	2018-06-26	2018-06-26 00:00:00	2018-06-26	581452		0	0	0		0	0	0	35530	0	52	40213296		
169422	3725	40213160	1968-08-15	1968-08-15 00:00:00	1968-08-15	1968-08-15 00:00:00	1968-08-15	581452		0	0	0		0	0	0	247540	0	10	40213160		
40263	3335	1127433	2014-05-27	2014-05-27 00:00:00	2014-06-03	2014-06-03 00:00:00	2014-06-03	38000177		0	0	7		0	0	0	221244	0	313782	1127433		
5151	430	1127433	1940-11-30	1940-11-30 00:00:00	1940-12-14	1940-12-14 00:00:00	1940-12-14	38000177		0	0	14		0	0	0	28515	0	313782	1127433		
48960	1072	40213160	1960-11-23	1960-11-23 00:00:00	1960-11-23	1960-11-23 00:00:00	1960-11-23	581452		0	0	0		0	0	0	70290	0	10	40213160		
22691	1864	40236824	2012-12-19	2012-12-19 00:00:00	2012-12-26	2012-12-26 00:00:00	2012-12-26	38000177		0	0	7		0	0	0	124565	0	1094107	40236824		
60514	5034	1713671	1975-02-20	1975-02-20 00:00:00	1975-03-13	1975-03-13 00:00:00	1975-03-13	38000177		0	0	21		0	0	0	334518	0	562251	1713671		
33583	2779	1115171	2019-05-19	2019-05-19 00:00:00	2019-06-02	2019-06-02 00:00:00	2019-06-02	38000177		0	0	14		0	0	0	184133	0	849574	1115171		
8726	727	19077572	2008-02-01	2008-02-01 00:00:00	2008-02-01	2008-02-01 00:00:00	\N	38000177		0	0	0		0	0	0	48191	0	310436	19077572		
33311	2760	920300	1998-04-18	1998-04-18 00:00:00	1998-04-25	1998-04-25 00:00:00	1998-04-25	38000177		0	0	7		0	0	0	182555	0	311989	920300		
36356	2997	19128022	1995-10-01	1995-10-01 00:00:00	1996-09-25	1996-09-25 00:00:00	1996-09-25	38000177		0	0	360		0	0	0	199957	0	749785	19128022		
44234	3661	1713671	1982-09-18	1982-09-18 00:00:00	1982-10-02	1982-10-02 00:00:00	1982-10-02	38000177		0	0	14		0	0	0	243670	0	562251	1713671		
19381	1599	19006318	1964-12-26	1964-12-26 00:00:00	1965-01-09	1965-01-09 00:00:00	1965-01-09	38000177		0	0	14		0	0	0	107352	0	105078	19006318		
9163	761	1154615	1980-12-21	1980-12-21 00:00:00	1998-06-05	1998-06-05 00:00:00	1998-06-05	38000177		0	0	6375		0	0	0	50564	0	745679	1154615		
17085	368	40213227	2002-10-23	2002-10-23 00:00:00	2002-10-23	2002-10-23 00:00:00	2002-10-23	581452		0	0	0		0	0	0	24493	0	113	40213227		
26608	2190	1115171	2014-09-23	2014-09-23 00:00:00	2014-12-22	2014-12-22 00:00:00	2014-12-22	38000177		0	0	90		0	0	0	146083	0	849574	1115171		
37092	3067	40229134	1971-07-21	1971-07-21 00:00:00	1971-08-04	1971-08-04 00:00:00	1971-08-04	38000177		0	0	14		0	0	0	204153	0	1043400	40229134		
26715	2200	1713671	1978-08-19	1978-08-19 00:00:00	1978-09-02	1978-09-02 00:00:00	1978-09-02	38000177		0	0	14		0	0	0	146598	0	562251	1713671		
32212	2672	1127433	1958-08-17	1958-08-17 00:00:00	1958-08-31	1958-08-31 00:00:00	1958-08-31	38000177		0	0	14		0	0	0	176962	0	313782	1127433		
37252	3079	19059056	1934-07-14	1934-07-14 00:00:00	1934-07-28	1934-07-28 00:00:00	1934-07-28	38000177		0	0	14		0	0	0	204940	0	243670	19059056		
32303	2679	19059056	1989-08-02	1989-08-02 00:00:00	1989-08-30	1989-08-30 00:00:00	1989-08-30	38000177		0	0	28		0	0	0	177463	0	243670	19059056		
32620	2703	1115171	1999-08-10	1999-08-10 00:00:00	1999-08-31	1999-08-31 00:00:00	1999-08-31	38000177		0	0	21		0	0	0	179106	0	849574	1115171		
6632	559	19133905	2009-06-30	2009-06-30 00:00:00	2009-07-12	2009-07-12 00:00:00	2009-07-12	38000177		0	0	12		0	0	0	37057	0	834102	19133905		
47918	3972	1118084	1999-07-25	1999-07-25 00:00:00	1999-07-25	1999-07-25 00:00:00	\N	38000177		0	0	0		0	0	0	264153	0	00025152531	44923712		
106237	2330	40213314	1977-06-27	1977-06-27 00:00:00	1977-06-27	1977-06-27 00:00:00	1977-06-27	581452		0	0	0		0	0	0	154999	0	49	40213314		
17218	1428	1713671	1982-11-20	1982-11-20 00:00:00	1982-11-27	1982-11-27 00:00:00	1982-11-27	38000177		0	0	7		0	0	0	95046	0	562251	1713671		
17264	1431	1551192	1950-05-30	1950-05-30 00:00:00	1950-05-30	1950-05-30 00:00:00	1950-05-30	38000177		0	0	0		0	0	0	95248	0	312617	1551192		
27760	2297	1127078	1978-06-12	1978-06-12 00:00:00	1978-08-11	1978-08-11 00:00:00	1978-08-11	38000177		0	0	60		0	0	0	152928	0	282464	1127078		
20346	1670	1127433	2017-01-01	2017-01-01 00:00:00	2017-01-22	2017-01-22 00:00:00	2017-01-22	38000177		0	0	21		0	0	0	112173	0	313782	1127433		
13826	1155	1127433	2007-10-19	2007-10-19 00:00:00	2007-11-02	2007-11-02 00:00:00	2007-11-02	38000177		0	0	14		0	0	0	76331	0	313782	1127433		
179364	3943	40213160	1955-07-21	1955-07-21 00:00:00	1955-07-21	1955-07-21 00:00:00	1955-07-21	581452		0	0	0		0	0	0	262182	0	10	40213160		
31184	679	40213160	1972-09-15	1972-09-15 00:00:00	1972-09-15	1972-09-15 00:00:00	1972-09-15	581452		0	0	0		0	0	0	44921	0	10	40213160		
38469	3178	40220386	2014-03-14	2014-03-14 00:00:00	2014-03-14	2014-03-14 00:00:00	2014-03-14	38000177		0	0	0		0	0	0	211388	0	1808217	40220386		
38492	3179	40229134	1988-12-19	1988-12-19 00:00:00	1988-12-26	1988-12-26 00:00:00	1988-12-26	38000177		0	0	7		0	0	0	211488	0	1043400	40229134		
7223	156	40213160	1979-07-01	1979-07-01 00:00:00	1979-07-01	1979-07-01 00:00:00	1979-07-01	581452		0	0	0		0	0	0	10686	0	10	40213160		
17888	1480	40236446	1975-01-19	1975-01-19 00:00:00	1975-02-16	1975-02-16 00:00:00	1975-02-16	38000177		0	0	28		0	0	0	98753	0	1091392	40236446		
37912	3134	1713671	1973-03-11	1973-03-11 00:00:00	1973-04-01	1973-04-01 00:00:00	1973-04-01	38000177		0	0	21		0	0	0	208552	0	562251	1713671		
37966	3137	920300	1947-08-07	1947-08-07 00:00:00	1947-08-14	1947-08-14 00:00:00	1947-08-14	38000177		0	0	7		0	0	0	208780	0	311989	920300		
14717	1231	40229134	1982-01-07	1982-01-07 00:00:00	1982-01-14	1982-01-14 00:00:00	1982-01-14	38000177		0	0	7		0	0	0	81095	0	1043400	40229134		
43408	3599	19006318	1971-06-09	1971-06-09 00:00:00	1971-06-23	1971-06-23 00:00:00	1971-06-23	38000177		0	0	14		0	0	0	239052	0	105078	19006318		
45689	3783	1551192	1948-09-25	1948-09-25 00:00:00	1948-09-25	1948-09-25 00:00:00	1948-09-25	38000177		0	0	0		0	0	0	251450	0	312617	1551192		
54186	1185	40213201	2003-02-09	2003-02-09 00:00:00	2003-02-09	2003-02-09 00:00:00	2003-02-09	581452		0	0	0		0	0	0	78123	0	33	40213201		
39107	3232	1127078	1964-07-12	1964-07-12 00:00:00	1964-08-02	1964-08-02 00:00:00	1964-08-02	38000177		0	0	21		0	0	0	214857	0	282464	1127078		
21830	1791	19059056	1957-01-13	1957-01-13 00:00:00	1957-01-27	1957-01-27 00:00:00	1957-01-27	38000177		0	0	14		0	0	0	120027	0	243670	19059056		
21856	1793	1127433	1975-12-27	1975-12-27 00:00:00	1976-01-24	1976-01-24 00:00:00	1976-01-24	38000177		0	0	28		0	0	0	120225	0	313782	1127433		
49705	4122	1127433	2004-06-12	2004-06-12 00:00:00	2004-06-19	2004-06-19 00:00:00	2004-06-19	38000177		0	0	7		0	0	0	274034	0	313782	1127433		
21095	458	40213160	1973-04-22	1973-04-22 00:00:00	1973-04-22	1973-04-22 00:00:00	1973-04-22	581452		0	0	0		0	0	0	30641	0	10	40213160		
49786	4130	1127433	1997-03-02	1997-03-02 00:00:00	1997-03-16	1997-03-16 00:00:00	1997-03-16	38000177		0	0	14		0	0	0	274535	0	313782	1127433		
42566	3529	19059056	1981-02-25	1981-02-25 00:00:00	1981-03-25	1981-03-25 00:00:00	1981-03-25	38000177		0	0	28		0	0	0	234289	0	243670	19059056		
3340	276	19128022	1998-05-06	1998-05-06 00:00:00	1999-05-01	1999-05-01 00:00:00	1999-05-01	38000177		0	0	360		0	0	0	18398	0	749785	19128022		
10291	862	19019979	1977-09-23	1977-09-23 00:00:00	1977-10-21	1977-10-21 00:00:00	1977-10-21	38000177		0	0	28		0	0	0	57050	0	198405	19019979		
57132	4739	40229134	1962-08-08	1962-08-08 00:00:00	1962-08-15	1962-08-15 00:00:00	1962-08-15	38000177		0	0	7		0	0	0	315702	0	1043400	40229134		
63078	5240	1713671	1992-06-27	1992-06-27 00:00:00	1992-07-04	1992-07-04 00:00:00	1992-07-04	38000177		0	0	7		0	0	0	348629	0	562251	1713671		
60861	5063	1127433	1970-03-03	1970-03-03 00:00:00	1970-03-17	1970-03-17 00:00:00	1970-03-17	38000177		0	0	14		0	0	0	336568	0	313782	1127433		
1106	90	1127078	1963-05-12	1963-05-12 00:00:00	1963-05-26	1963-05-26 00:00:00	1963-05-26	38000177		0	0	14		0	0	0	5985	0	282464	1127078		
62459	5197	1127433	1995-08-28	1995-08-28 00:00:00	1995-09-18	1995-09-18 00:00:00	1995-09-18	38000177		0	0	21		0	0	0	345576	0	313782	1127433		
50326	1102	40213260	2017-01-24	2017-01-24 00:00:00	2017-01-24	2017-01-24 00:00:00	2017-01-24	581452		0	0	0		0	0	0	72494	0	121	40213260		
44886	3714	40229134	1985-10-03	1985-10-03 00:00:00	1985-10-17	1985-10-17 00:00:00	1985-10-17	38000177		0	0	14		0	0	0	246792	0	1043400	40229134		
24690	2030	1127433	2014-03-27	2014-03-27 00:00:00	2014-04-10	2014-04-10 00:00:00	2014-04-10	38000177		0	0	14		0	0	0	135163	0	313782	1127433		
58721	1285	40213160	1959-03-02	1959-03-02 00:00:00	1959-03-02	1959-03-02 00:00:00	1959-03-02	581452		0	0	0		0	0	0	85027	0	10	40213160		
5464	119	40213227	2007-01-02	2007-01-02 00:00:00	2007-01-02	2007-01-02 00:00:00	2007-01-02	581452		0	0	0		0	0	0	7920	0	113	40213227		
26166	2152	19126352	1980-01-12	1980-01-12 00:00:00	1980-01-12	1980-01-12 00:00:00	\N	38000177		0	0	0		0	0	0	143400	0	705129	19126352		
92849	2037	40213306	1982-06-18	1982-06-18 00:00:00	1982-06-18	1982-06-18 00:00:00	1982-06-18	581452		0	0	0		0	0	0	135648	0	43	40213306		
32886	2724	19133905	1994-12-30	1994-12-30 00:00:00	1995-01-07	1995-01-07 00:00:00	1995-01-07	38000177		0	0	8		0	0	0	180443	0	834102	19133905		
24552	534	40213314	1978-11-27	1978-11-27 00:00:00	1978-11-27	1978-11-27 00:00:00	1978-11-27	581452		0	0	0		0	0	0	35575	0	49	40213314		
8039	672	1713671	1989-07-06	1989-07-06 00:00:00	1989-07-27	1989-07-27 00:00:00	1989-07-27	38000177		0	0	21		0	0	0	44404	0	562251	1713671		
40264	3335	40165015	2013-02-15	2013-02-15 00:00:00	2013-02-15	2013-02-15 00:00:00	\N	38000177		0	0	0		0	0	0	221226	0	861467	40165015		
5152	430	19059056	1931-09-18	1931-09-18 00:00:00	1931-10-02	1931-10-02 00:00:00	1931-10-02	38000177		0	0	14		0	0	0	28464	0	243670	19059056		
48963	1072	40213227	2012-01-25	2012-01-25 00:00:00	2012-01-25	2012-01-25 00:00:00	2012-01-25	581452		0	0	0		0	0	0	70220	0	113	40213227		
22692	1864	19078461	1996-08-22	1996-08-22 00:00:00	1996-09-05	1996-09-05 00:00:00	1996-09-05	38000177		0	0	14		0	0	0	124521	0	310965	19078461		
60515	5034	40162522	1971-03-15	1971-03-15 00:00:00	1971-03-15	1971-03-15 00:00:00	\N	38000177		0	0	0		0	0	0	334457	0	857005	40162522		
33584	2779	19073188	2019-05-19	2019-05-19 00:00:00	2019-06-02	2019-06-02 00:00:00	2019-06-02	38000177		0	0	14		0	0	0	184133	0	308192	19073188		
8727	727	40222846	2009-05-26	2009-05-26 00:00:00	2009-05-26	2009-05-26 00:00:00	\N	38000177		0	0	0		0	0	0	48248	0	996740	40222846		
33312	2760	1713671	1974-01-23	1974-01-23 00:00:00	1974-02-13	1974-02-13 00:00:00	1974-02-13	38000177		0	0	21		0	0	0	182534	0	562251	1713671		
4296	357	19059056	1968-04-16	1968-04-16 00:00:00	1968-05-16	1968-05-16 00:00:00	1968-05-16	38000177		0	0	30		0	0	0	23636	0	243670	19059056		
56989	4729	1115171	2006-12-31	2006-12-31 00:00:00	2007-01-28	2007-01-28 00:00:00	2007-01-28	38000177		0	0	28		0	0	0	315108	0	849574	1115171		
19382	1599	1127078	1962-06-28	1962-06-28 00:00:00	1962-07-12	1962-07-12 00:00:00	1962-07-12	38000177		0	0	14		0	0	0	107300	0	282464	1127078		
9164	761	19133873	1987-01-04	1987-01-04 00:00:00	1987-01-13	1987-01-13 00:00:00	1987-01-13	38000177		0	0	9		0	0	0	50568	0	834061	19133873		
17086	368	40213160	1972-01-12	1972-01-12 00:00:00	1972-01-12	1972-01-12 00:00:00	1972-01-12	581452		0	0	0		0	0	0	24520	0	10	40213160		
26609	2190	1127433	1952-06-28	1952-06-28 00:00:00	1952-07-05	1952-07-05 00:00:00	1952-07-05	38000177		0	0	7		0	0	0	146025	0	313782	1127433		
37093	3067	1127433	2015-11-09	2015-11-09 00:00:00	2015-12-09	2015-12-09 00:00:00	2015-12-09	38000177		0	0	30		0	0	0	204189	0	313782	1127433		
26716	2200	1127433	1997-05-10	1997-05-10 00:00:00	1997-06-14	1997-06-14 00:00:00	1997-06-14	38000177		0	0	35		0	0	0	146685	0	313782	1127433		
32213	2672	19078461	1999-11-14	1999-11-14 00:00:00	1999-12-12	1999-12-12 00:00:00	1999-12-12	38000177		0	0	28		0	0	0	176983	0	310965	19078461		
37253	3080	19078461	2015-09-27	2015-09-27 00:00:00	2015-10-25	2015-10-25 00:00:00	2015-10-25	38000177		0	0	28		0	0	0	205011	0	310965	19078461		
32304	2679	1127078	1982-11-09	1982-11-09 00:00:00	1982-12-07	1982-12-07 00:00:00	1982-12-07	38000177		0	0	28		0	0	0	177462	0	282464	1127078		
32621	2703	1127433	2008-09-17	2008-09-17 00:00:00	2008-10-08	2008-10-08 00:00:00	2008-10-08	38000177		0	0	21		0	0	0	179109	0	313782	1127433		
6633	559	19133873	1973-06-16	1973-06-16 00:00:00	1973-06-24	1973-06-24 00:00:00	1973-06-24	38000177		0	0	8		0	0	0	37074	0	834061	19133873		
47919	3972	1127433	1960-04-06	1960-04-06 00:00:00	1960-04-13	1960-04-13 00:00:00	1960-04-13	38000177		0	0	7		0	0	0	264093	0	313782	1127433		
106241	2330	40213227	2006-10-02	2006-10-02 00:00:00	2006-10-02	2006-10-02 00:00:00	2006-10-02	581452		0	0	0		0	0	0	154973	0	113	40213227		
17219	1428	19059056	1958-09-30	1958-09-30 00:00:00	1958-11-03	1958-11-03 00:00:00	1958-11-03	38000177		0	0	34		0	0	0	94966	0	243670	19059056		
27723	2294	40165015	1978-06-29	1978-06-29 00:00:00	1978-06-29	1978-06-29 00:00:00	\N	38000177		0	0	0		0	0	0	152750	0	861467	40165015		
27761	2298	19059056	1973-04-16	1973-04-16 00:00:00	1973-04-30	1973-04-30 00:00:00	1973-04-30	38000177		0	0	14		0	0	0	153015	0	243670	19059056		
20347	1670	19133873	1964-06-07	1964-06-07 00:00:00	1964-06-18	1964-06-18 00:00:00	1964-06-18	38000177		0	0	11		0	0	0	112136	0	834061	19133873		
13827	1155	19073188	1989-04-08	1989-04-08 00:00:00	1989-04-22	1989-04-22 00:00:00	1989-04-22	38000177		0	0	14		0	0	0	76369	0	308192	19073188		
179147	3939	40213160	1978-12-31	1978-12-31 00:00:00	1978-12-31	1978-12-31 00:00:00	1978-12-31	581452		0	0	0		0	0	0	261837	0	10	40213160		
31188	679	40213227	2005-08-19	2005-08-19 00:00:00	2005-08-19	2005-08-19 00:00:00	2005-08-19	581452		0	0	0		0	0	0	44935	0	113	40213227		
38470	3178	35605858	2014-03-13	2014-03-13 00:00:00	2014-03-14	2014-03-14 00:00:00	2014-03-14	38000177		0	0	1		0	0	0	211388	0	1732136	35605858		
38493	3179	1118084	1958-12-06	1958-12-06 00:00:00	1958-12-06	1958-12-06 00:00:00	\N	38000177		0	0	0		0	0	0	211490	0	00025152531	44923712		
7227	156	40213314	1979-12-30	1979-12-30 00:00:00	1979-12-30	1979-12-30 00:00:00	1979-12-30	581452		0	0	0		0	0	0	10656	0	49	40213314		
17889	1480	1127433	2006-04-11	2006-04-11 00:00:00	2006-04-18	2006-04-18 00:00:00	2006-04-18	38000177		0	0	7		0	0	0	98720	0	313782	1127433		
37913	3134	1713671	1969-01-15	1969-01-15 00:00:00	1969-01-22	1969-01-22 00:00:00	1969-01-22	38000177		0	0	7		0	0	0	208551	0	562251	1713671		
37967	3137	19133873	1919-02-27	1919-02-27 00:00:00	1919-03-10	1919-03-10 00:00:00	1919-03-10	38000177		0	0	11		0	0	0	208831	0	834061	19133873		
14718	1231	19133905	2002-05-13	2002-05-13 00:00:00	2002-05-23	2002-05-23 00:00:00	2002-05-23	38000177		0	0	10		0	0	0	81109	0	834102	19133905		
43409	3599	1118084	2006-06-10	2006-06-10 00:00:00	2006-06-10	2006-06-10 00:00:00	\N	38000177		0	0	0		0	0	0	239044	0	00025152531	44923712		
45690	3783	1127433	1982-08-16	1982-08-16 00:00:00	1982-08-23	1982-08-23 00:00:00	1982-08-23	38000177		0	0	7		0	0	0	251368	0	313782	1127433		
46852	3881	19133905	2011-07-11	2011-07-11 00:00:00	2011-07-20	2011-07-20 00:00:00	2011-07-20	38000177		0	0	9		0	0	0	257916	0	834102	19133905		
39122	3234	19126352	1955-05-03	1955-05-03 00:00:00	2010-01-19	2010-01-19 00:00:00	2010-01-19	38000177		0	0	19985		0	0	0	214953	0	705129	19126352		
21831	1791	19006318	1957-01-13	1957-01-13 00:00:00	1957-01-27	1957-01-27 00:00:00	1957-01-27	38000177		0	0	14		0	0	0	120027	0	105078	19006318		
21857	1793	1713671	1986-05-09	1986-05-09 00:00:00	1986-05-23	1986-05-23 00:00:00	1986-05-23	38000177		0	0	14		0	0	0	120242	0	562251	1713671		
49706	4122	1127433	2010-09-17	2010-09-17 00:00:00	2010-10-01	2010-10-01 00:00:00	2010-10-01	38000177		0	0	14		0	0	0	274071	0	313782	1127433		
21105	458	40213227	2015-07-19	2015-07-19 00:00:00	2015-07-19	2015-07-19 00:00:00	2015-07-19	581452		0	0	0		0	0	0	30647	0	113	40213227		
49787	4130	19006318	1966-05-25	1966-05-25 00:00:00	1966-06-08	1966-06-08 00:00:00	1966-06-08	38000177		0	0	14		0	0	0	274538	0	105078	19006318		
42567	3529	1118084	1976-07-07	1976-07-07 00:00:00	1976-07-07	1976-07-07 00:00:00	\N	38000177		0	0	0		0	0	0	234320	0	00025152531	44923712		
3341	276	1127433	1983-04-11	1983-04-11 00:00:00	1983-04-18	1983-04-18 00:00:00	1983-04-18	38000177		0	0	7		0	0	0	18442	0	313782	1127433		
10292	862	1713671	2006-07-28	2006-07-28 00:00:00	2006-08-18	2006-08-18 00:00:00	2006-08-18	38000177		0	0	21		0	0	0	57090	0	562251	1713671		
57133	4739	1551192	1922-02-25	1922-02-25 00:00:00	1922-02-25	1922-02-25 00:00:00	1922-02-25	38000177		0	0	0		0	0	0	315725	0	312617	1551192		
63079	5240	1127433	1956-12-06	1956-12-06 00:00:00	1956-12-13	1956-12-13 00:00:00	1956-12-13	38000177		0	0	7		0	0	0	348713	0	313782	1127433		
60862	5063	1127433	1979-05-06	1979-05-06 00:00:00	1979-06-03	1979-06-03 00:00:00	1979-06-03	38000177		0	0	28		0	0	0	336600	0	313782	1127433		
1107	90	19129655	1963-05-12	1963-05-12 00:00:00	1963-05-26	1963-05-26 00:00:00	1963-05-26	38000177		0	0	14		0	0	0	5985	0	789980	19129655		
62460	5197	1127433	1960-11-20	1960-11-20 00:00:00	1960-12-04	1960-12-04 00:00:00	1960-12-04	38000177		0	0	14		0	0	0	345592	0	313782	1127433		
50328	1102	40213227	2018-01-30	2018-01-30 00:00:00	2018-01-30	2018-01-30 00:00:00	2018-01-30	581452		0	0	0		0	0	0	72484	0	113	40213227		
44887	3714	1118084	1958-07-28	1958-07-28 00:00:00	1958-07-28	1958-07-28 00:00:00	\N	38000177		0	0	0		0	0	0	246832	0	00025152531	44923712		
24691	2030	19075601	2005-07-24	2005-07-24 00:00:00	2005-07-24	2005-07-24 00:00:00	2005-07-24	38000177		0	0	0		0	0	0	135101	0	309362	19075601		
58725	1285	40213227	2015-05-25	2015-05-25 00:00:00	2015-05-25	2015-05-25 00:00:00	2015-05-25	581452		0	0	0		0	0	0	84972	0	113	40213227		
5465	119	40213260	2007-01-02	2007-01-02 00:00:00	2007-01-02	2007-01-02 00:00:00	2007-01-02	581452		0	0	0		0	0	0	7920	0	121	40213260		
26167	2152	40220960	1988-01-23	1988-01-23 00:00:00	1988-01-23	1988-01-23 00:00:00	1988-01-23	38000177		0	0	0		0	0	0	143347	0	1804799	40220960		
92859	2037	40213227	2011-04-22	2011-04-22 00:00:00	2011-04-22	2011-04-22 00:00:00	2011-04-22	581452		0	0	0		0	0	0	135673	0	113	40213227		
32887	2724	920334	1989-07-06	1989-07-06 00:00:00	1989-07-13	1989-07-13 00:00:00	1989-07-13	38000177		0	0	7		0	0	0	180442	0	311995	920334		
24553	534	40213160	1978-11-27	1978-11-27 00:00:00	1978-11-27	1978-11-27 00:00:00	1978-11-27	581452		0	0	0		0	0	0	35575	0	10	40213160		
8041	672	40231925	2000-02-24	2000-02-24 00:00:00	2000-02-24	2000-02-24 00:00:00	\N	38000177		0	0	0		0	0	0	44415	0	1049221	40231925		
40265	3335	19073188	2013-02-15	2013-02-15 00:00:00	2013-03-01	2013-03-01 00:00:00	2013-03-01	38000177		0	0	14		0	0	0	221226	0	308192	19073188		
18259	395	40213227	2011-02-22	2011-02-22 00:00:00	2011-02-22	2011-02-22 00:00:00	2011-02-22	581452		0	0	0		0	0	0	25998	0	113	40213227		
48964	1072	40213260	2012-01-25	2012-01-25 00:00:00	2012-01-25	2012-01-25 00:00:00	2012-01-25	581452		0	0	0		0	0	0	70220	0	121	40213260		
22693	1864	1127433	2008-04-22	2008-04-22 00:00:00	2008-04-29	2008-04-29 00:00:00	2008-04-29	38000177		0	0	7		0	0	0	124564	0	313782	1127433		
60516	5034	19133768	1993-11-13	1993-11-13 00:00:00	1993-11-13	1993-11-13 00:00:00	1993-11-13	38000177		0	0	0		0	0	0	334462	0	833036	19133768		
33585	2779	19019979	1976-11-13	1976-11-13 00:00:00	1977-01-12	1977-01-12 00:00:00	1977-01-12	38000177		0	0	60		0	0	0	184098	0	198405	19019979		
8728	727	1127433	1917-04-10	1917-04-10 00:00:00	1917-04-24	1917-04-24 00:00:00	1917-04-24	38000177		0	0	14		0	0	0	48174	0	313782	1127433		
33313	2760	40165015	1970-07-16	1970-07-16 00:00:00	1970-07-16	1970-07-16 00:00:00	\N	38000177		0	0	0		0	0	0	182593	0	861467	40165015		
4298	357	19133905	1992-07-11	1992-07-11 00:00:00	1992-07-24	1992-07-24 00:00:00	1992-07-24	38000177		0	0	13		0	0	0	23725	0	834102	19133905		
56990	4729	19059056	1967-11-07	1967-11-07 00:00:00	1968-01-06	1968-01-06 00:00:00	1968-01-06	38000177		0	0	60		0	0	0	315104	0	243670	19059056		
19383	1599	19059056	1964-12-14	1964-12-14 00:00:00	1965-01-09	1965-01-09 00:00:00	1965-01-09	38000177		0	0	26		0	0	0	107359	0	243670	19059056		
9165	761	1118084	2015-05-30	2015-05-30 00:00:00	2015-05-30	2015-05-30 00:00:00	\N	38000177		0	0	0		0	0	0	50562	0	00025152531	44923712		
17094	369	40213306	2003-07-19	2003-07-19 00:00:00	2003-07-19	2003-07-19 00:00:00	2003-07-19	581452		0	0	0		0	0	0	24573	0	43	40213306		
26610	2190	1127433	1988-01-08	1988-01-08 00:00:00	1988-01-22	1988-01-22 00:00:00	1988-01-22	38000177		0	0	14		0	0	0	146081	0	313782	1127433		
37094	3067	19006318	1945-09-02	1945-09-02 00:00:00	1945-09-16	1945-09-16 00:00:00	1945-09-16	38000177		0	0	14		0	0	0	204198	0	105078	19006318		
26717	2200	19133873	1978-05-16	1978-05-16 00:00:00	1978-05-28	1978-05-28 00:00:00	1978-05-28	38000177		0	0	12		0	0	0	146628	0	834061	19133873		
32214	2672	1713671	1991-02-09	1991-02-09 00:00:00	1991-03-02	1991-03-02 00:00:00	1991-03-02	38000177		0	0	21		0	0	0	177043	0	562251	1713671		
37254	3080	920334	1969-01-15	1969-01-15 00:00:00	1969-01-22	1969-01-22 00:00:00	1969-01-22	38000177		0	0	7		0	0	0	204987	0	311995	920334		
32305	2679	1127078	1981-11-09	1981-11-09 00:00:00	1981-12-14	1981-12-14 00:00:00	1981-12-14	38000177		0	0	35		0	0	0	177461	0	282464	1127078		
32622	2704	920300	2004-09-14	2004-09-14 00:00:00	2004-09-21	2004-09-21 00:00:00	2004-09-21	38000177		0	0	7		0	0	0	179117	0	311989	920300		
6634	559	1713671	1986-04-25	1986-04-25 00:00:00	1986-05-02	1986-05-02 00:00:00	1986-05-02	38000177		0	0	7		0	0	0	37048	0	562251	1713671		
47920	3972	19059056	1971-10-05	1971-10-05 00:00:00	1971-11-09	1971-11-09 00:00:00	1971-11-09	38000177		0	0	35		0	0	0	264135	0	243670	19059056		
106245	2330	40213160	1980-06-30	1980-06-30 00:00:00	1980-06-30	1980-06-30 00:00:00	1980-06-30	581452		0	0	0		0	0	0	155001	0	10	40213160		
17220	1428	1127433	1998-09-18	1998-09-18 00:00:00	1998-10-02	1998-10-02 00:00:00	1998-10-02	38000177		0	0	14		0	0	0	94995	0	313782	1127433		
27724	2294	1713671	2009-06-09	2009-06-09 00:00:00	2009-06-23	2009-06-23 00:00:00	2009-06-23	38000177		0	0	14		0	0	0	152719	0	562251	1713671		
27762	2298	19078461	2008-06-30	2008-06-30 00:00:00	2008-07-14	2008-07-14 00:00:00	2008-07-14	38000177		0	0	14		0	0	0	153017	0	310965	19078461		
20348	1670	1127433	2002-12-24	2002-12-24 00:00:00	2002-12-31	2002-12-31 00:00:00	2002-12-31	38000177		0	0	7		0	0	0	112138	0	313782	1127433		
13828	1155	19059056	1989-04-08	1989-04-08 00:00:00	1989-04-22	1989-04-22 00:00:00	1989-04-22	38000177		0	0	14		0	0	0	76369	0	243670	19059056		
179154	3939	40213227	2007-03-11	2007-03-11 00:00:00	2007-03-11	2007-03-11 00:00:00	2007-03-11	581452		0	0	0		0	0	0	261848	0	113	40213227		
8827	736	1713671	2003-04-29	2003-04-29 00:00:00	2003-05-20	2003-05-20 00:00:00	2003-05-20	38000177		0	0	21		0	0	0	48843	0	562251	1713671		
42363	3513	19133873	1985-12-04	1985-12-04 00:00:00	1985-12-12	1985-12-12 00:00:00	1985-12-12	38000177		0	0	8		0	0	0	233129	0	834061	19133873		
38494	3179	19059056	1944-09-11	1944-09-11 00:00:00	1944-09-25	1944-09-25 00:00:00	1944-09-25	38000177		0	0	14		0	0	0	211529	0	243670	19059056		
7234	156	40213227	2010-10-24	2010-10-24 00:00:00	2010-10-24	2010-10-24 00:00:00	2010-10-24	581452		0	0	0		0	0	0	10669	0	113	40213227		
17890	1480	19078461	2000-10-24	2000-10-24 00:00:00	2000-11-07	2000-11-07 00:00:00	2000-11-07	38000177		0	0	14		0	0	0	98764	0	310965	19078461		
37914	3134	1127433	1981-10-24	1981-10-24 00:00:00	1981-11-14	1981-11-14 00:00:00	1981-11-14	38000177		0	0	21		0	0	0	208556	0	313782	1127433		
37968	3137	40229134	1910-06-13	1910-06-13 00:00:00	1910-06-27	1910-06-27 00:00:00	1910-06-27	38000177		0	0	14		0	0	0	208830	0	1043400	40229134		
14719	1231	1127433	1986-10-05	1986-10-05 00:00:00	1986-10-26	1986-10-26 00:00:00	1986-10-26	38000177		0	0	21		0	0	0	81117	0	313782	1127433		
43410	3599	1127433	2018-08-29	2018-08-29 00:00:00	2018-09-05	2018-09-05 00:00:00	2018-09-05	38000177		0	0	7		0	0	0	239033	0	313782	1127433		
45691	3783	1127433	1946-03-06	1946-03-06 00:00:00	1946-03-20	1946-03-20 00:00:00	1946-03-20	38000177		0	0	14		0	0	0	251426	0	313782	1127433		
46853	3881	1539411	1992-11-13	1992-11-13 00:00:00	1992-11-13	1992-11-13 00:00:00	\N	38000177		0	0	0		0	0	0	257931	0	312961	1539411		
39123	3234	1124300	1990-02-03	1990-02-03 00:00:00	1990-02-03	1990-02-03 00:00:00	\N	38000177		0	0	0		0	0	0	214938	0	00781178901	45011828		
21832	1791	40162522	1995-07-08	1995-07-08 00:00:00	1995-07-08	1995-07-08 00:00:00	\N	38000177		0	0	0		0	0	0	120057	0	857005	40162522		
21858	1793	1127433	1982-04-20	1982-04-20 00:00:00	1982-05-04	1982-05-04 00:00:00	1982-05-04	38000177		0	0	14		0	0	0	120214	0	313782	1127433		
49707	4122	19128065	1985-12-27	1985-12-27 00:00:00	1986-12-22	1986-12-22 00:00:00	1986-12-22	38000177		0	0	360		0	0	0	274057	0	749882	19128065		
21107	458	40213296	2015-07-19	2015-07-19 00:00:00	2015-07-19	2015-07-19 00:00:00	2015-07-19	581452		0	0	0		0	0	0	30647	0	52	40213296		
49788	4130	19059056	1966-05-25	1966-05-25 00:00:00	1966-06-08	1966-06-08 00:00:00	1966-06-08	38000177		0	0	14		0	0	0	274538	0	243670	19059056		
42568	3529	1713671	1976-01-06	1976-01-06 00:00:00	1976-01-13	1976-01-13 00:00:00	1976-01-13	38000177		0	0	7		0	0	0	234320	0	562251	1713671		
3342	276	19128022	2001-04-20	2001-04-20 00:00:00	2002-04-15	2002-04-15 00:00:00	2002-04-15	38000177		0	0	360		0	0	0	18446	0	749785	19128022		
20766	1713	1713671	1988-11-05	1988-11-05 00:00:00	1988-11-19	1988-11-19 00:00:00	1988-11-19	38000177		0	0	14		0	0	0	114434	0	562251	1713671		
57151	4745	40236446	1985-03-30	1985-03-30 00:00:00	1993-04-07	1993-04-07 00:00:00	1993-04-07	38000177		0	0	2930		0	0	0	315963	0	1091392	40236446		
63080	5240	19059056	1952-05-27	1952-05-27 00:00:00	1952-06-10	1952-06-10 00:00:00	1952-06-10	38000177		0	0	14		0	0	0	348655	0	243670	19059056		
60863	5063	40229134	1944-05-20	1944-05-20 00:00:00	1944-05-27	1944-05-27 00:00:00	1944-05-27	38000177		0	0	7		0	0	0	336532	0	1043400	40229134		
8327	695	1127433	2011-10-31	2011-10-31 00:00:00	2011-11-07	2011-11-07 00:00:00	2011-11-07	38000177		0	0	7		0	0	0	45992	0	313782	1127433		
62461	5197	1127433	1966-09-28	1966-09-28 00:00:00	1966-10-05	1966-10-05 00:00:00	1966-10-05	38000177		0	0	7		0	0	0	345580	0	313782	1127433		
50329	1102	40213260	2018-01-30	2018-01-30 00:00:00	2018-01-30	2018-01-30 00:00:00	2018-01-30	581452		0	0	0		0	0	0	72484	0	121	40213260		
44888	3714	19059056	1964-01-09	1964-01-09 00:00:00	1964-01-23	1964-01-23 00:00:00	1964-01-23	38000177		0	0	14		0	0	0	246848	0	243670	19059056		
24692	2030	40220960	2005-07-24	2005-07-24 00:00:00	2005-07-24	2005-07-24 00:00:00	2005-07-24	38000177		0	0	0		0	0	0	135101	0	1804799	40220960		
58737	1285	40213227	2005-03-28	2005-03-28 00:00:00	2005-03-28	2005-03-28 00:00:00	2005-03-28	581452		0	0	0		0	0	0	84969	0	113	40213227		
5466	119	40213160	1956-09-04	1956-09-04 00:00:00	1956-09-04	1956-09-04 00:00:00	1956-09-04	581452		0	0	0		0	0	0	7901	0	10	40213160		
26168	2152	19133873	1924-06-18	1924-06-18 00:00:00	1924-06-27	1924-06-27 00:00:00	1924-06-27	38000177		0	0	9		0	0	0	143341	0	834061	19133873		
92860	2037	40213260	2011-04-22	2011-04-22 00:00:00	2011-04-22	2011-04-22 00:00:00	2011-04-22	581452		0	0	0		0	0	0	135673	0	121	40213260		
32888	2724	19059056	1959-11-23	1959-11-23 00:00:00	1959-12-28	1959-12-28 00:00:00	1959-12-28	38000177		0	0	35		0	0	0	180433	0	243670	19059056		
104211	2286	40213160	1958-05-12	1958-05-12 00:00:00	1958-05-12	1958-05-12 00:00:00	1958-05-12	581452		0	0	0		0	0	0	152047	0	10	40213160		
8043	672	1127433	1956-10-25	1956-10-25 00:00:00	1956-11-01	1956-11-01 00:00:00	1956-11-01	38000177		0	0	7		0	0	0	44334	0	313782	1127433		
40266	3335	1115171	2013-02-15	2013-02-15 00:00:00	2013-03-01	2013-03-01 00:00:00	2013-03-01	38000177		0	0	14		0	0	0	221226	0	849574	1115171		
18260	395	40213260	2011-02-22	2011-02-22 00:00:00	2011-02-22	2011-02-22 00:00:00	2011-02-22	581452		0	0	0		0	0	0	25998	0	121	40213260		
48966	1072	40213260	2011-01-19	2011-01-19 00:00:00	2011-01-19	2011-01-19 00:00:00	2011-01-19	581452		0	0	0		0	0	0	70272	0	121	40213260		
22694	1864	1118084	2004-09-14	2004-09-14 00:00:00	2004-09-14	2004-09-14 00:00:00	\N	38000177		0	0	0		0	0	0	124528	0	00025152531	44923712		
60517	5034	1713671	1936-06-28	1936-06-28 00:00:00	1936-07-05	1936-07-05 00:00:00	1936-07-05	38000177		0	0	7		0	0	0	334437	0	562251	1713671		
33586	2779	1127433	2006-02-07	2006-02-07 00:00:00	2006-05-08	2006-05-08 00:00:00	2006-05-08	38000177		0	0	90		0	0	0	184100	0	313782	1127433		
8729	728	19133905	1997-04-20	1997-04-20 00:00:00	1997-04-27	1997-04-27 00:00:00	1997-04-27	38000177		0	0	7		0	0	0	48332	0	834102	19133905		
33314	2760	19059056	1970-07-16	1970-07-16 00:00:00	1970-10-14	1970-10-14 00:00:00	1970-10-14	38000177		0	0	90		0	0	0	182593	0	243670	19059056		
4299	357	1115171	2016-08-23	2016-08-23 00:00:00	2016-09-13	2016-09-13 00:00:00	2016-09-13	38000177		0	0	21		0	0	0	23640	0	849574	1115171		
56991	4729	19128065	1981-01-15	1981-01-15 00:00:00	1982-01-10	1982-01-10 00:00:00	1982-01-10	38000177		0	0	360		0	0	0	315092	0	749882	19128065		
19385	1599	1118084	1997-12-21	1997-12-21 00:00:00	1997-12-21	1997-12-21 00:00:00	\N	38000177		0	0	0		0	0	0	107307	0	00025152531	44923712		
9166	761	1127433	2004-01-31	2004-01-31 00:00:00	2004-02-14	2004-02-14 00:00:00	2004-02-14	38000177		0	0	14		0	0	0	50613	0	313782	1127433		
26529	2184	1124300	2002-12-23	2002-12-23 00:00:00	2002-12-23	2002-12-23 00:00:00	\N	38000177		0	0	0		0	0	0	145529	0	00781178901	45011828		
26611	2190	1713671	1972-12-30	1972-12-30 00:00:00	1973-01-20	1973-01-20 00:00:00	1973-01-20	38000177		0	0	21		0	0	0	146027	0	562251	1713671		
37095	3067	19059056	1945-09-02	1945-09-02 00:00:00	1945-09-16	1945-09-16 00:00:00	1945-09-16	38000177		0	0	14		0	0	0	204198	0	243670	19059056		
26718	2200	1127433	1981-09-27	1981-09-27 00:00:00	1981-10-11	1981-10-11 00:00:00	1981-10-11	38000177		0	0	14		0	0	0	146647	0	313782	1127433		
32216	2672	40236824	1977-12-22	1977-12-22 00:00:00	1977-12-29	1977-12-29 00:00:00	1977-12-29	38000177		0	0	7		0	0	0	177015	0	1094107	40236824		
37255	3080	40236824	1969-01-08	1969-01-08 00:00:00	1969-01-22	1969-01-22 00:00:00	1969-01-22	38000177		0	0	14		0	0	0	204988	0	1094107	40236824		
32306	2679	1127433	2016-09-07	2016-09-07 00:00:00	2016-09-21	2016-09-21 00:00:00	2016-09-21	38000177		0	0	14		0	0	0	177469	0	313782	1127433		
32623	2704	40236824	2004-09-14	2004-09-14 00:00:00	2004-09-21	2004-09-21 00:00:00	2004-09-21	38000177		0	0	7		0	0	0	179117	0	1094107	40236824		
6635	559	1127433	1981-01-07	1981-01-07 00:00:00	1981-03-08	1981-03-08 00:00:00	1981-03-08	38000177		0	0	60		0	0	0	37097	0	313782	1127433		
47921	3972	19059056	1967-10-26	1967-10-26 00:00:00	1967-12-25	1967-12-25 00:00:00	1967-12-25	38000177		0	0	60		0	0	0	264134	0	243670	19059056		
106255	2330	40213227	1997-09-22	1997-09-22 00:00:00	1997-09-22	1997-09-22 00:00:00	1997-09-22	581452		0	0	0		0	0	0	154970	0	113	40213227		
17221	1428	19006318	1950-04-23	1950-04-23 00:00:00	1950-05-08	1950-05-08 00:00:00	1950-05-08	38000177		0	0	15		0	0	0	95049	0	105078	19006318		
27725	2294	19129655	1964-09-05	1964-09-05 00:00:00	1964-09-19	1964-09-19 00:00:00	1964-09-19	38000177		0	0	14		0	0	0	152708	0	789980	19129655		
27763	2298	19133873	1972-02-23	1972-02-23 00:00:00	1972-03-01	1972-03-01 00:00:00	1972-03-01	38000177		0	0	7		0	0	0	153003	0	834061	19133873		
20349	1670	1118084	2004-06-13	2004-06-13 00:00:00	2004-06-13	2004-06-13 00:00:00	\N	38000177		0	0	0		0	0	0	112151	0	00025152531	44923712		
13829	1155	19059056	1967-10-14	1967-10-14 00:00:00	1967-10-28	1967-10-28 00:00:00	1967-10-28	38000177		0	0	14		0	0	0	76319	0	243670	19059056		
179158	3939	40213160	1974-06-30	1974-06-30 00:00:00	1974-06-30	1974-06-30 00:00:00	1974-06-30	581452		0	0	0		0	0	0	261833	0	10	40213160		
8828	736	1127433	1976-08-14	1976-08-14 00:00:00	1976-08-28	1976-08-28 00:00:00	1976-08-28	38000177		0	0	14		0	0	0	48792	0	313782	1127433		
42365	3513	19078461	1992-12-13	1992-12-13 00:00:00	1992-12-27	1992-12-27 00:00:00	1992-12-27	38000177		0	0	14		0	0	0	233118	0	310965	19078461		
38495	3179	40229134	1970-04-09	1970-04-09 00:00:00	1970-04-23	1970-04-23 00:00:00	1970-04-23	38000177		0	0	14		0	0	0	211461	0	1043400	40229134		
7239	156	40213251	1984-07-22	1984-07-22 00:00:00	1984-07-22	1984-07-22 00:00:00	1984-07-22	581452		0	0	0		0	0	0	10680	0	21	40213251		
17891	1480	1118084	2001-07-01	2001-07-01 00:00:00	2001-07-01	2001-07-01 00:00:00	\N	38000177		0	0	0		0	0	0	98764	0	00025152531	44923712		
37915	3134	1127433	1965-05-06	1965-05-06 00:00:00	1965-05-20	1965-05-20 00:00:00	1965-05-20	38000177		0	0	14		0	0	0	208566	0	313782	1127433		
37969	3137	1713671	1914-04-28	1914-04-28 00:00:00	1914-05-05	1914-05-05 00:00:00	1914-05-05	38000177		0	0	7		0	0	0	208849	0	562251	1713671		
14720	1231	1127433	1977-02-04	1977-02-04 00:00:00	1977-02-18	1977-02-18 00:00:00	1977-02-18	38000177		0	0	14		0	0	0	81083	0	313782	1127433		
43411	3599	1127078	1976-11-07	1976-11-07 00:00:00	1976-12-05	1976-12-05 00:00:00	1976-12-05	38000177		0	0	28		0	0	0	239083	0	282464	1127078		
45692	3783	19078461	2005-09-21	2005-09-21 00:00:00	2005-10-19	2005-10-19 00:00:00	2005-10-19	38000177		0	0	28		0	0	0	251452	0	310965	19078461		
46854	3881	19059056	1960-11-27	1960-11-27 00:00:00	1961-01-26	1961-01-26 00:00:00	1961-01-26	38000177		0	0	60		0	0	0	257918	0	243670	19059056		
39124	3234	1539411	1992-07-28	1992-07-28 00:00:00	1992-07-28	1992-07-28 00:00:00	\N	38000177		0	0	0		0	0	0	214941	0	312961	1539411		
21833	1791	1115171	1995-07-08	1995-07-08 00:00:00	1995-09-06	1995-09-06 00:00:00	1995-09-06	38000177		0	0	60		0	0	0	120057	0	849574	1115171		
21859	1793	1115171	1996-12-04	1996-12-04 00:00:00	1996-12-18	1996-12-18 00:00:00	1996-12-18	38000177		0	0	14		0	0	0	120227	0	849574	1115171		
49708	4123	1127433	1984-10-24	1984-10-24 00:00:00	1984-11-07	1984-11-07 00:00:00	1984-11-07	38000177		0	0	14		0	0	0	274084	0	313782	1127433		
52341	4353	1713671	2004-09-26	2004-09-26 00:00:00	2004-10-17	2004-10-17 00:00:00	2004-10-17	38000177		0	0	21		0	0	0	288833	0	562251	1713671		
49789	4130	1127433	1986-07-28	1986-07-28 00:00:00	1986-08-11	1986-08-11 00:00:00	1986-08-11	38000177		0	0	14		0	0	0	274527	0	313782	1127433		
42569	3530	1539411	1993-07-16	1993-07-16 00:00:00	1993-07-16	1993-07-16 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	312961	1539411		
3343	277	1127433	1987-09-26	1987-09-26 00:00:00	1987-10-17	1987-10-17 00:00:00	1987-10-17	38000177		0	0	21		0	0	0	18498	0	313782	1127433		
20767	1713	1713671	1982-11-08	1982-11-08 00:00:00	1983-02-07	1983-02-07 00:00:00	1983-02-07	38000177		0	0	91		0	0	0	114463	0	562251	1713671		
57152	4745	40229134	2011-09-28	2011-09-28 00:00:00	2011-10-12	2011-10-12 00:00:00	2011-10-12	38000177		0	0	14		0	0	0	315986	0	1043400	40229134		
69824	1526	40213227	2003-03-13	2003-03-13 00:00:00	2003-03-13	2003-03-13 00:00:00	2003-03-13	581452		0	0	0		0	0	0	102046	0	113	40213227		
60864	5063	1127433	1957-10-07	1957-10-07 00:00:00	1958-01-05	1958-01-05 00:00:00	1958-01-05	38000177		0	0	90		0	0	0	336598	0	313782	1127433		
8328	695	1127433	1996-10-15	1996-10-15 00:00:00	1996-10-29	1996-10-29 00:00:00	1996-10-29	38000177		0	0	14		0	0	0	46008	0	313782	1127433		
62462	5197	40220386	1962-06-06	1962-06-06 00:00:00	1962-06-06	1962-06-06 00:00:00	1962-06-06	38000177		0	0	0		0	0	0	345571	0	1808217	40220386		
18022	1493	19059056	1972-07-03	1972-07-03 00:00:00	1972-09-01	1972-09-01 00:00:00	1972-09-01	38000177		0	0	60		0	0	0	99575	0	243670	19059056		
44889	3714	1127433	1973-04-24	1973-04-24 00:00:00	1973-05-08	1973-05-08 00:00:00	1973-05-08	38000177		0	0	14		0	0	0	246797	0	313782	1127433		
24693	2030	1713671	2018-06-04	2018-06-04 00:00:00	2018-06-25	2018-06-25 00:00:00	2018-06-25	38000177		0	0	21		0	0	0	135165	0	562251	1713671		
58744	1285	40213160	1955-05-30	1955-05-30 00:00:00	1955-05-30	1955-05-30 00:00:00	1955-05-30	581452		0	0	0		0	0	0	84980	0	10	40213160		
5468	119	40213296	1996-04-16	1996-04-16 00:00:00	1996-04-16	1996-04-16 00:00:00	1996-04-16	581452		0	0	0		0	0	0	7950	0	52	40213296		
26169	2152	40229134	2016-10-17	2016-10-17 00:00:00	2016-10-31	2016-10-31 00:00:00	2016-10-31	38000177		0	0	14		0	0	0	143370	0	1043400	40229134		
92863	2037	40213227	1994-07-01	1994-07-01 00:00:00	1994-07-01	1994-07-01 00:00:00	1994-07-01	581452		0	0	0		0	0	0	135652	0	113	40213227		
32927	2731	1127433	1986-03-21	1986-03-21 00:00:00	1986-04-11	1986-04-11 00:00:00	1986-04-11	38000177		0	0	21		0	0	0	180790	0	313782	1127433		
104213	2286	40213160	1958-02-10	1958-02-10 00:00:00	1958-02-10	1958-02-10 00:00:00	1958-02-10	581452		0	0	0		0	0	0	152073	0	10	40213160		
8044	672	1127433	1975-11-17	1975-11-17 00:00:00	1975-11-24	1975-11-24 00:00:00	1975-11-24	38000177		0	0	7		0	0	0	44350	0	313782	1127433		
40267	3335	1127433	1987-07-04	1987-07-04 00:00:00	1987-08-03	1987-08-03 00:00:00	1987-08-03	38000177		0	0	30		0	0	0	221300	0	313782	1127433		
22909	1885	1124300	2009-11-05	2009-11-05 00:00:00	2009-11-05	2009-11-05 00:00:00	\N	38000177		0	0	0		0	0	0	125675	0	00781178901	45011828		
48972	1073	40213227	2008-02-14	2008-02-14 00:00:00	2008-02-14	2008-02-14 00:00:00	2008-02-14	581452		0	0	0		0	0	0	70319	0	113	40213227		
22695	1864	19128065	1982-11-14	1982-11-14 00:00:00	1983-11-09	1983-11-09 00:00:00	1983-11-09	38000177		0	0	360		0	0	0	124515	0	749882	19128065		
60518	5035	19133873	1940-07-23	1940-07-23 00:00:00	1940-08-01	1940-08-01 00:00:00	1940-08-01	38000177		0	0	9		0	0	0	334621	0	834061	19133873		
33587	2779	19078461	2005-03-16	2005-03-16 00:00:00	2005-04-13	2005-04-13 00:00:00	2005-04-13	38000177		0	0	28		0	0	0	184099	0	310965	19078461		
8730	728	1127078	1959-12-27	1959-12-27 00:00:00	1960-01-10	1960-01-10 00:00:00	1960-01-10	38000177		0	0	14		0	0	0	48359	0	282464	1127078		
33315	2760	19059056	1961-01-06	1961-01-06 00:00:00	1961-02-03	1961-02-03 00:00:00	1961-02-03	38000177		0	0	28		0	0	0	182592	0	243670	19059056		
4302	357	1127433	2000-02-24	2000-02-24 00:00:00	2000-03-02	2000-03-02 00:00:00	2000-03-02	38000177		0	0	7		0	0	0	23699	0	313782	1127433		
56992	4729	1127433	1980-05-03	1980-05-03 00:00:00	1980-05-10	1980-05-10 00:00:00	1980-05-10	38000177		0	0	7		0	0	0	315085	0	313782	1127433		
19386	1599	920300	2002-06-06	2002-06-06 00:00:00	2002-06-13	2002-06-13 00:00:00	2002-06-13	38000177		0	0	7		0	0	0	107327	0	311989	920300		
9167	761	1713671	1983-06-25	1983-06-25 00:00:00	1983-07-09	1983-07-09 00:00:00	1983-07-09	38000177		0	0	14		0	0	0	50567	0	562251	1713671		
26530	2184	1127078	1967-08-14	1967-08-14 00:00:00	1967-08-28	1967-08-28 00:00:00	1967-08-28	38000177		0	0	14		0	0	0	145584	0	282464	1127078		
26612	2190	19078461	2008-05-06	2008-05-06 00:00:00	2008-05-27	2008-05-27 00:00:00	2008-05-27	38000177		0	0	21		0	0	0	146082	0	310965	19078461		
37096	3067	19059056	1941-01-12	1941-01-12 00:00:00	1941-01-26	1941-01-26 00:00:00	1941-01-26	38000177		0	0	14		0	0	0	204157	0	243670	19059056		
26719	2200	1127078	1982-07-07	1982-07-07 00:00:00	1982-07-28	1982-07-28 00:00:00	1982-07-28	38000177		0	0	21		0	0	0	146622	0	282464	1127078		
32217	2672	920300	1977-12-22	1977-12-22 00:00:00	1977-12-29	1977-12-29 00:00:00	1977-12-29	38000177		0	0	7		0	0	0	177015	0	311989	920300		
37256	3080	920300	1969-01-08	1969-01-08 00:00:00	1969-01-15	1969-01-15 00:00:00	1969-01-15	38000177		0	0	7		0	0	0	204988	0	311989	920300		
32307	2679	1124300	2013-01-05	2013-01-05 00:00:00	2013-01-05	2013-01-05 00:00:00	\N	38000177		0	0	0		0	0	0	177513	0	00781178901	45011828		
32624	2704	19078461	1994-12-11	1994-12-11 00:00:00	1994-12-25	1994-12-25 00:00:00	1994-12-25	38000177		0	0	14		0	0	0	179113	0	310965	19078461		
6636	559	40162522	1981-01-07	1981-01-07 00:00:00	1981-01-07	1981-01-07 00:00:00	\N	38000177		0	0	0		0	0	0	37097	0	857005	40162522		
47922	3972	1127433	2014-01-09	2014-01-09 00:00:00	2014-01-16	2014-01-16 00:00:00	2014-01-16	38000177		0	0	7		0	0	0	264164	0	313782	1127433		
106256	2330	40213306	1997-09-22	1997-09-22 00:00:00	1997-09-22	1997-09-22 00:00:00	1997-09-22	581452		0	0	0		0	0	0	154970	0	43	40213306		
17222	1428	19059056	1950-04-23	1950-04-23 00:00:00	1950-05-08	1950-05-08 00:00:00	1950-05-08	38000177		0	0	15		0	0	0	95049	0	243670	19059056		
27726	2294	19059056	1964-09-05	1964-09-05 00:00:00	1964-09-19	1964-09-19 00:00:00	1964-09-19	38000177		0	0	14		0	0	0	152708	0	243670	19059056		
27764	2298	1127078	1973-10-28	1973-10-28 00:00:00	1973-11-11	1973-11-11 00:00:00	1973-11-11	38000177		0	0	14		0	0	0	152989	0	282464	1127078		
20350	1670	1127433	2002-10-26	2002-10-26 00:00:00	2002-11-16	2002-11-16 00:00:00	2002-11-16	38000177		0	0	21		0	0	0	112172	0	313782	1127433		
13830	1155	19006318	1967-10-14	1967-10-14 00:00:00	1967-10-28	1967-10-28 00:00:00	1967-10-28	38000177		0	0	14		0	0	0	76319	0	105078	19006318		
37594	3109	1127433	1964-06-29	1964-06-29 00:00:00	1964-07-06	1964-07-06 00:00:00	1964-07-06	38000177		0	0	7		0	0	0	206757	0	313782	1127433		
8829	736	19078461	2010-07-15	2010-07-15 00:00:00	2010-08-05	2010-08-05 00:00:00	2010-08-05	38000177		0	0	21		0	0	0	48814	0	310965	19078461		
42366	3513	19128065	1988-03-05	1988-03-05 00:00:00	1989-02-28	1989-02-28 00:00:00	1989-02-28	38000177		0	0	360		0	0	0	233162	0	749882	19128065		
38496	3179	40231925	1932-10-14	1932-10-14 00:00:00	1932-10-14	1932-10-14 00:00:00	\N	38000177		0	0	0		0	0	0	211527	0	1049221	40231925		
7243	156	40213314	1979-01-28	1979-01-28 00:00:00	1979-01-28	1979-01-28 00:00:00	1979-01-28	581452		0	0	0		0	0	0	10685	0	49	40213314		
17892	1480	1127433	1971-10-24	1971-10-24 00:00:00	1971-11-07	1971-11-07 00:00:00	1971-11-07	38000177		0	0	14		0	0	0	98704	0	313782	1127433		
37916	3134	1713671	1978-04-11	1978-04-11 00:00:00	1978-05-02	1978-05-02 00:00:00	1978-05-02	38000177		0	0	21		0	0	0	208629	0	562251	1713671		
3142	260	19059056	1971-06-02	1971-06-02 00:00:00	1971-06-16	1971-06-16 00:00:00	1971-06-16	38000177		0	0	14		0	0	0	17264	0	243670	19059056		
14721	1231	19059056	1972-03-18	1972-03-18 00:00:00	1972-04-22	1972-04-22 00:00:00	1972-04-22	38000177		0	0	35		0	0	0	81114	0	243670	19059056		
43412	3599	1713671	1982-07-10	1982-07-10 00:00:00	1982-07-24	1982-07-24 00:00:00	1982-07-24	38000177		0	0	14		0	0	0	239050	0	562251	1713671		
45693	3783	19074679	1953-05-01	1953-05-01 00:00:00	1953-11-06	1953-11-06 00:00:00	1953-11-06	38000177		0	0	189		0	0	0	251295	0	308971	19074679		
46855	3881	19075601	1998-01-23	1998-01-23 00:00:00	1998-01-23	1998-01-23 00:00:00	\N	38000177		0	0	0		0	0	0	257908	0	309362	19075601		
39125	3234	1127433	2005-10-27	2005-10-27 00:00:00	2005-11-02	2005-11-02 00:00:00	2005-11-02	38000177		0	0	6		0	0	0	214973	0	313782	1127433		
21834	1791	19059056	1970-04-15	1970-04-15 00:00:00	1970-05-20	1970-05-20 00:00:00	1970-05-20	38000177		0	0	35		0	0	0	120055	0	243670	19059056		
21860	1793	19133905	1967-06-13	1967-06-13 00:00:00	1967-06-21	1967-06-21 00:00:00	1967-06-21	38000177		0	0	8		0	0	0	120240	0	834102	19133905		
49709	4123	19078461	2013-02-09	2013-02-09 00:00:00	2013-03-11	2013-03-11 00:00:00	2013-03-11	38000177		0	0	30		0	0	0	274118	0	310965	19078461		
52342	4353	1127078	1972-11-03	1972-11-03 00:00:00	1972-12-10	1972-12-10 00:00:00	1972-12-10	38000177		0	0	37		0	0	0	288786	0	282464	1127078		
49790	4130	19078461	1995-12-07	1995-12-07 00:00:00	1996-01-04	1996-01-04 00:00:00	1996-01-04	38000177		0	0	28		0	0	0	274664	0	310965	19078461		
42570	3530	1332419	1996-08-09	1996-08-09 00:00:00	1996-08-09	1996-08-09 00:00:00	\N	38000177		0	0	0		0	0	0	234471	0	197361	1332419		
3344	277	19133873	1964-03-02	1964-03-02 00:00:00	1964-03-10	1964-03-10 00:00:00	1964-03-10	38000177		0	0	8		0	0	0	18490	0	834061	19133873		
20768	1713	19078461	1990-10-26	1990-10-26 00:00:00	1990-11-16	1990-11-16 00:00:00	1990-11-16	38000177		0	0	21		0	0	0	114454	0	310965	19078461		
57153	4745	1713671	1983-03-30	1983-03-30 00:00:00	1983-04-06	1983-04-06 00:00:00	1983-04-06	38000177		0	0	7		0	0	0	315892	0	562251	1713671		
69829	1526	40213160	1976-12-09	1976-12-09 00:00:00	1976-12-09	1976-12-09 00:00:00	1976-12-09	581452		0	0	0		0	0	0	102069	0	10	40213160		
60865	5063	40162522	1957-10-07	1957-10-07 00:00:00	1957-10-07	1957-10-07 00:00:00	\N	38000177		0	0	0		0	0	0	336598	0	857005	40162522		
8329	695	1127433	1990-08-18	1990-08-18 00:00:00	1990-09-01	1990-09-01 00:00:00	1990-09-01	38000177		0	0	14		0	0	0	46014	0	313782	1127433		
62463	5197	782047	1962-06-06	1962-06-06 00:00:00	1962-06-06	1962-06-06 00:00:00	1962-06-06	38000177		0	0	0		0	0	0	345571	0	542347	782047		
18023	1493	1713671	1964-09-03	1964-09-03 00:00:00	1964-09-17	1964-09-17 00:00:00	1964-09-17	38000177		0	0	14		0	0	0	99562	0	562251	1713671		
44890	3714	19059056	1956-06-28	1956-06-28 00:00:00	1956-07-19	1956-07-19 00:00:00	1956-07-19	38000177		0	0	21		0	0	0	246847	0	243670	19059056		
24694	2030	19128065	1978-04-08	1978-04-08 00:00:00	1979-04-03	1979-04-03 00:00:00	1979-04-03	38000177		0	0	360		0	0	0	135106	0	749882	19128065		
58745	1285	40213160	1955-08-29	1955-08-29 00:00:00	1955-08-29	1955-08-29 00:00:00	1955-08-29	581452		0	0	0		0	0	0	85005	0	10	40213160		
5481	119	40213160	1956-06-05	1956-06-05 00:00:00	1956-06-05	1956-06-05 00:00:00	1956-06-05	581452		0	0	0		0	0	0	7930	0	10	40213160		
26170	2152	19075601	2008-02-23	2008-02-23 00:00:00	2008-02-23	2008-02-23 00:00:00	\N	38000177		0	0	0		0	0	0	143390	0	309362	19075601		
92865	2037	40213296	2000-04-21	2000-04-21 00:00:00	2000-04-21	2000-04-21 00:00:00	2000-04-21	581452		0	0	0		0	0	0	135634	0	52	40213296		
32928	2731	1713671	2014-07-24	2014-07-24 00:00:00	2014-07-31	2014-07-31 00:00:00	2014-07-31	38000177		0	0	7		0	0	0	180770	0	562251	1713671		
104219	2286	40213227	2018-11-05	2018-11-05 00:00:00	2018-11-05	2018-11-05 00:00:00	2018-11-05	581452		0	0	0		0	0	0	152046	0	113	40213227		
8045	672	1127433	1985-03-16	1985-03-16 00:00:00	1985-04-06	1985-04-06 00:00:00	1985-04-06	38000177		0	0	21		0	0	0	44413	0	313782	1127433		
40268	3335	1127433	1975-05-12	1975-05-12 00:00:00	1975-05-26	1975-05-26 00:00:00	1975-05-26	38000177		0	0	14		0	0	0	221283	0	313782	1127433		
22910	1885	1127433	2019-04-01	2019-04-01 00:00:00	2019-04-08	2019-04-08 00:00:00	2019-04-08	38000177		0	0	7		0	0	0	125691	0	313782	1127433		
12279	1032	1713671	1980-08-04	1980-08-04 00:00:00	1980-08-11	1980-08-11 00:00:00	1980-08-11	38000177		0	0	7		0	0	0	67884	0	562251	1713671		
22696	1864	1127433	1971-04-08	1971-04-08 00:00:00	1971-04-22	1971-04-22 00:00:00	1971-04-22	38000177		0	0	14		0	0	0	124552	0	313782	1127433		
60519	5035	1310034	2003-03-03	2003-03-03 00:00:00	2003-03-03	2003-03-03 00:00:00	2003-03-03	38000177		0	0	0		0	0	0	334577	0	834357	1310034		
33588	2780	19133873	1958-06-10	1958-06-10 00:00:00	1958-06-18	1958-06-18 00:00:00	1958-06-18	38000177		0	0	8		0	0	0	184233	0	834061	19133873		
8731	728	40229134	1983-12-11	1983-12-11 00:00:00	1983-12-18	1983-12-18 00:00:00	1983-12-18	38000177		0	0	7		0	0	0	48355	0	1043400	40229134		
33317	2760	1127433	1972-10-07	1972-10-07 00:00:00	1972-10-21	1972-10-21 00:00:00	1972-10-21	38000177		0	0	14		0	0	0	182551	0	313782	1127433		
4303	357	19078461	1983-04-28	1983-04-28 00:00:00	1983-05-19	1983-05-19 00:00:00	1983-05-19	38000177		0	0	21		0	0	0	23638	0	310965	19078461		
56993	4729	19078461	1993-11-20	1993-11-20 00:00:00	1993-12-11	1993-12-11 00:00:00	1993-12-11	38000177		0	0	21		0	0	0	315106	0	310965	19078461		
19387	1599	40236824	2002-06-06	2002-06-06 00:00:00	2002-06-13	2002-06-13 00:00:00	2002-06-13	38000177		0	0	7		0	0	0	107327	0	1094107	40236824		
9168	761	1713671	1982-08-05	1982-08-05 00:00:00	1982-08-12	1982-08-12 00:00:00	1982-08-12	38000177		0	0	7		0	0	0	50565	0	562251	1713671		
26531	2184	1127433	2012-05-19	2012-05-19 00:00:00	2012-06-02	2012-06-02 00:00:00	2012-06-02	38000177		0	0	14		0	0	0	145583	0	313782	1127433		
26613	2190	1713671	2009-04-17	2009-04-17 00:00:00	2009-05-01	2009-05-01 00:00:00	2009-05-01	38000177		0	0	14		0	0	0	146029	0	562251	1713671		
37097	3067	40229134	1991-09-10	1991-09-10 00:00:00	1991-09-17	1991-09-17 00:00:00	1991-09-17	38000177		0	0	7		0	0	0	204103	0	1043400	40229134		
26720	2200	19059056	1978-10-12	1978-10-12 00:00:00	1978-10-26	1978-10-26 00:00:00	1978-10-26	38000177		0	0	14		0	0	0	146621	0	243670	19059056		
32218	2672	19059056	1962-01-27	1962-01-27 00:00:00	1962-02-10	1962-02-10 00:00:00	1962-02-10	38000177		0	0	14		0	0	0	176980	0	243670	19059056		
37257	3080	1127078	1950-06-23	1950-06-23 00:00:00	1950-07-07	1950-07-07 00:00:00	1950-07-07	38000177		0	0	14		0	0	0	204967	0	282464	1127078		
32308	2679	19133873	1985-10-04	1985-10-04 00:00:00	1985-10-13	1985-10-13 00:00:00	1985-10-13	38000177		0	0	9		0	0	0	177479	0	834061	19133873		
32626	2704	1127433	2014-05-02	2014-05-02 00:00:00	2014-05-09	2014-05-09 00:00:00	2014-05-09	38000177		0	0	7		0	0	0	179118	0	313782	1127433		
85593	1874	40213160	1978-10-21	1978-10-21 00:00:00	1978-10-21	1978-10-21 00:00:00	1978-10-21	581452		0	0	0		0	0	0	125126	0	10	40213160		
47923	3972	40229134	2018-05-27	2018-05-27 00:00:00	2018-06-10	2018-06-10 00:00:00	2018-06-10	38000177		0	0	14		0	0	0	264098	0	1043400	40229134		
106261	2330	40213160	1976-03-29	1976-03-29 00:00:00	1976-03-29	1976-03-29 00:00:00	1976-03-29	581452		0	0	0		0	0	0	154961	0	10	40213160		
17223	1428	1127433	1979-11-17	1979-11-17 00:00:00	1979-12-01	1979-12-01 00:00:00	1979-12-01	38000177		0	0	14		0	0	0	95044	0	313782	1127433		
27727	2294	1127433	1984-12-20	1984-12-20 00:00:00	1985-01-03	1985-01-03 00:00:00	1985-01-03	38000177		0	0	14		0	0	0	152680	0	313782	1127433		
27765	2298	19129655	1973-10-28	1973-10-28 00:00:00	1973-11-11	1973-11-11 00:00:00	1973-11-11	38000177		0	0	14		0	0	0	152989	0	789980	19129655		
20351	1670	19133873	1967-09-02	1967-09-02 00:00:00	1967-09-11	1967-09-11 00:00:00	1967-09-11	38000177		0	0	9		0	0	0	112154	0	834061	19133873		
13831	1155	1124300	2007-10-29	2007-10-29 00:00:00	2007-10-29	2007-10-29 00:00:00	\N	38000177		0	0	0		0	0	0	76385	0	00781178901	45011828		
37595	3109	19078461	1987-09-04	1987-09-04 00:00:00	1987-09-25	1987-09-25 00:00:00	1987-09-25	38000177		0	0	21		0	0	0	206708	0	310965	19078461		
8830	736	1127433	2000-10-22	2000-10-22 00:00:00	2000-10-29	2000-10-29 00:00:00	2000-10-29	38000177		0	0	7		0	0	0	48841	0	313782	1127433		
42367	3513	920300	2008-04-16	2008-04-16 00:00:00	2008-04-23	2008-04-23 00:00:00	2008-04-23	38000177		0	0	7		0	0	0	233131	0	311989	920300		
38497	3179	19059056	1932-10-14	1932-10-14 00:00:00	1933-01-12	1933-01-12 00:00:00	1933-01-12	38000177		0	0	90		0	0	0	211527	0	243670	19059056		
7244	156	40213160	1979-01-28	1979-01-28 00:00:00	1979-01-28	1979-01-28 00:00:00	1979-01-28	581452		0	0	0		0	0	0	10685	0	10	40213160		
17893	1480	1127078	1973-07-13	1973-07-13 00:00:00	1973-10-11	1973-10-11 00:00:00	1973-10-11	38000177		0	0	90		0	0	0	98759	0	282464	1127078		
37917	3134	1127433	1977-08-22	1977-08-22 00:00:00	1977-08-29	1977-08-29 00:00:00	1977-08-29	38000177		0	0	7		0	0	0	208628	0	313782	1127433		
3143	260	1118084	2010-03-19	2010-03-19 00:00:00	2010-03-19	2010-03-19 00:00:00	\N	38000177		0	0	0		0	0	0	17209	0	00025152531	44923712		
14722	1231	40229134	1960-07-15	1960-07-15 00:00:00	1960-07-29	1960-07-29 00:00:00	1960-07-29	38000177		0	0	14		0	0	0	81153	0	1043400	40229134		
43413	3599	1115171	2015-03-23	2015-03-23 00:00:00	2015-05-22	2015-05-22 00:00:00	2015-05-22	38000177		0	0	60		0	0	0	239071	0	849574	1115171		
45694	3783	1713671	1959-02-17	1959-02-17 00:00:00	1959-03-03	1959-03-03 00:00:00	1959-03-03	38000177		0	0	14		0	0	0	251388	0	562251	1713671		
46856	3881	1713671	1975-03-15	1975-03-15 00:00:00	1975-03-29	1975-03-29 00:00:00	1975-03-29	38000177		0	0	14		0	0	0	257882	0	562251	1713671		
39126	3234	1713671	1953-11-30	1953-11-30 00:00:00	1953-12-14	1953-12-14 00:00:00	1953-12-14	38000177		0	0	14		0	0	0	214922	0	562251	1713671		
224437	4927	40213314	1977-10-28	1977-10-28 00:00:00	1977-10-28	1977-10-28 00:00:00	1977-10-28	581452		0	0	0		0	0	0	327518	0	49	40213314		
21861	1793	1127433	1962-05-25	1962-05-25 00:00:00	1962-07-24	1962-07-24 00:00:00	1962-07-24	38000177		0	0	60		0	0	0	120223	0	313782	1127433		
49710	4123	40165015	2013-02-09	2013-02-09 00:00:00	2013-02-09	2013-02-09 00:00:00	\N	38000177		0	0	0		0	0	0	274118	0	861467	40165015		
52352	4355	1118084	2019-04-24	2019-04-24 00:00:00	2019-04-24	2019-04-24 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00025152531	44923712		
49791	4130	1127433	2019-05-17	2019-05-17 00:00:00	2019-05-31	2019-05-31 00:00:00	2019-05-31	38000177		0	0	14		0	0	0	274647	0	313782	1127433		
42571	3530	1127433	1978-11-12	1978-11-12 00:00:00	1978-11-26	1978-11-26 00:00:00	1978-11-26	38000177		0	0	14		0	0	0	234499	0	313782	1127433		
3345	277	1127433	1976-01-29	1976-01-29 00:00:00	1976-02-05	1976-02-05 00:00:00	1976-02-05	38000177		0	0	7		0	0	0	18491	0	313782	1127433		
20769	1713	19133905	2013-05-19	2013-05-19 00:00:00	2013-05-27	2013-05-27 00:00:00	2013-05-27	38000177		0	0	8		0	0	0	114497	0	834102	19133905		
57154	4745	40229134	1981-11-27	1981-11-27 00:00:00	1981-12-04	1981-12-04 00:00:00	1981-12-04	38000177		0	0	7		0	0	0	315940	0	1043400	40229134		
69830	1526	40213160	1972-04-06	1972-04-06 00:00:00	1972-04-06	1972-04-06 00:00:00	1972-04-06	581452		0	0	0		0	0	0	102042	0	10	40213160		
60866	5063	1127433	2019-02-08	2019-02-08 00:00:00	2019-03-10	2019-03-10 00:00:00	2019-03-10	38000177		0	0	30		0	0	0	336541	0	313782	1127433		
8330	695	19133873	1976-06-12	1976-06-12 00:00:00	1976-06-20	1976-06-20 00:00:00	1976-06-20	38000177		0	0	8		0	0	0	46006	0	834061	19133873		
62464	5197	19078924	1962-06-06	1962-06-06 00:00:00	1962-06-06	1962-06-06 00:00:00	1962-06-06	38000177		0	0	0		0	0	0	345571	0	311700	19078924		
18024	1493	1127433	2006-08-09	2006-08-09 00:00:00	2006-08-16	2006-08-16 00:00:00	2006-08-16	38000177		0	0	7		0	0	0	99570	0	313782	1127433		
44891	3714	19075601	2009-07-01	2009-07-01 00:00:00	2009-07-01	2009-07-01 00:00:00	2009-07-01	38000177		0	0	0		0	0	0	246788	0	309362	19075601		
24695	2030	1713671	2002-12-16	2002-12-16 00:00:00	2002-12-23	2002-12-23 00:00:00	2002-12-23	38000177		0	0	7		0	0	0	135160	0	562251	1713671		
58746	1285	40213260	2007-04-09	2007-04-09 00:00:00	2007-04-09	2007-04-09 00:00:00	2007-04-09	581452		0	0	0		0	0	0	84970	0	121	40213260		
5489	119	40213160	1960-12-06	1960-12-06 00:00:00	1960-12-06	1960-12-06 00:00:00	1960-12-06	581452		0	0	0		0	0	0	7933	0	10	40213160		
26171	2152	40163554	2008-02-23	2008-02-23 00:00:00	2008-02-23	2008-02-23 00:00:00	\N	38000177		0	0	0		0	0	0	143390	0	855332	40163554		
92872	2037	40213260	2010-04-16	2010-04-16 00:00:00	2010-04-16	2010-04-16 00:00:00	2010-04-16	581452		0	0	0		0	0	0	135636	0	121	40213260		
1473	116	1127433	1980-01-25	1980-01-25 00:00:00	1980-02-01	1980-02-01 00:00:00	1980-02-01	38000177		0	0	7		0	0	0	7678	0	313782	1127433		
104225	2286	40213160	1957-12-09	1957-12-09 00:00:00	1957-12-09	1957-12-09 00:00:00	1957-12-09	581452		0	0	0		0	0	0	152026	0	10	40213160		
8046	672	40229134	1972-11-15	1972-11-15 00:00:00	1972-11-29	1972-11-29 00:00:00	1972-11-29	38000177		0	0	14		0	0	0	44369	0	1043400	40229134		
40269	3335	1127433	1986-04-10	1986-04-10 00:00:00	1986-06-09	1986-06-09 00:00:00	1986-06-09	38000177		0	0	60		0	0	0	221299	0	313782	1127433		
22911	1885	1713671	1973-12-01	1973-12-01 00:00:00	1974-04-06	1974-04-06 00:00:00	1974-04-06	38000177		0	0	126		0	0	0	125685	0	562251	1713671		
12280	1032	1713671	1975-08-19	1975-08-19 00:00:00	1975-08-26	1975-08-26 00:00:00	1975-08-26	38000177		0	0	7		0	0	0	67957	0	562251	1713671		
22697	1864	19128065	1979-11-30	1979-11-30 00:00:00	1980-11-24	1980-11-24 00:00:00	1980-11-24	38000177		0	0	360		0	0	0	124514	0	749882	19128065		
60520	5035	40243436	2003-03-03	2003-03-03 00:00:00	2003-03-03	2003-03-03 00:00:00	2003-03-03	38000177		0	0	0		0	0	0	334577	0	1190795	40243436		
33589	2780	1127433	1968-04-16	1968-04-16 00:00:00	1968-04-30	1968-04-30 00:00:00	1968-04-30	38000177		0	0	14		0	0	0	184227	0	313782	1127433		
8732	728	1127433	1973-08-16	1973-08-16 00:00:00	1973-08-30	1973-08-30 00:00:00	1973-08-30	38000177		0	0	14		0	0	0	48351	0	313782	1127433		
33318	2760	19128065	1978-02-20	1978-02-20 00:00:00	1979-02-15	1979-02-15 00:00:00	1979-02-15	38000177		0	0	360		0	0	0	182560	0	749882	19128065		
4304	357	19006318	1956-03-06	1956-03-06 00:00:00	1956-03-20	1956-03-20 00:00:00	1956-03-20	38000177		0	0	14		0	0	0	23623	0	105078	19006318		
56994	4729	1127433	1984-12-27	1984-12-27 00:00:00	1985-01-03	1985-01-03 00:00:00	1985-01-03	38000177		0	0	7		0	0	0	315098	0	313782	1127433		
19388	1599	1127433	1979-12-31	1979-12-31 00:00:00	1980-02-29	1980-02-29 00:00:00	1980-02-29	38000177		0	0	60		0	0	0	107361	0	313782	1127433		
9169	762	40229134	1980-04-20	1980-04-20 00:00:00	1980-04-27	1980-04-27 00:00:00	1980-04-27	38000177		0	0	7		0	0	0	50673	0	1043400	40229134		
26532	2184	40169216	1970-02-21	1970-02-21 00:00:00	1970-02-21	1970-02-21 00:00:00	\N	38000177		0	0	0		0	0	0	145531	0	895994	40169216		
26614	2191	1127433	1981-04-23	1981-04-23 00:00:00	1981-05-07	1981-05-07 00:00:00	1981-05-07	38000177		0	0	14		0	0	0	146088	0	313782	1127433		
37098	3067	1127433	1958-05-11	1958-05-11 00:00:00	1958-05-25	1958-05-25 00:00:00	1958-05-25	38000177		0	0	14		0	0	0	204174	0	313782	1127433		
26721	2200	46233988	1978-01-15	1978-01-15 00:00:00	1978-01-29	1978-01-29 00:00:00	1978-01-29	38000177		0	0	14		0	0	0	146601	0	1652673	46233988		
22007	1808	1127433	1993-12-11	1993-12-11 00:00:00	1994-01-08	1994-01-08 00:00:00	1994-01-08	38000177		0	0	28		0	0	0	121085	0	313782	1127433		
37258	3080	19059056	1966-07-13	1966-07-13 00:00:00	1966-08-03	1966-08-03 00:00:00	1966-08-03	38000177		0	0	21		0	0	0	204968	0	243670	19059056		
32309	2679	19078461	2012-02-22	2012-02-22 00:00:00	2012-03-21	2012-03-21 00:00:00	2012-03-21	38000177		0	0	28		0	0	0	177492	0	310965	19078461		
32627	2704	1118084	2011-05-26	2011-05-26 00:00:00	2011-05-26	2011-05-26 00:00:00	\N	38000177		0	0	0		0	0	0	179146	0	00025152531	44923712		
85599	1874	40213227	1996-08-03	1996-08-03 00:00:00	1996-08-03	1996-08-03 00:00:00	1996-08-03	581452		0	0	0		0	0	0	125107	0	113	40213227		
47924	3972	19133905	1979-07-09	1979-07-09 00:00:00	1979-07-19	1979-07-19 00:00:00	1979-07-19	38000177		0	0	10		0	0	0	264141	0	834102	19133905		
106264	2330	40213314	1977-12-26	1977-12-26 00:00:00	1977-12-26	1977-12-26 00:00:00	1977-12-26	581452		0	0	0		0	0	0	154981	0	49	40213314		
85730	1878	40213296	2015-04-26	2015-04-26 00:00:00	2015-04-26	2015-04-26 00:00:00	2015-04-26	581452		0	0	0		0	0	0	125344	0	52	40213296		
27728	2294	1713671	2006-02-04	2006-02-04 00:00:00	2006-02-18	2006-02-18 00:00:00	2006-02-18	38000177		0	0	14		0	0	0	152718	0	562251	1713671		
27766	2298	1127433	1978-02-21	1978-02-21 00:00:00	1978-03-07	1978-03-07 00:00:00	1978-03-07	38000177		0	0	14		0	0	0	152984	0	313782	1127433		
20352	1670	1713671	1964-12-07	1964-12-07 00:00:00	1964-12-21	1964-12-21 00:00:00	1964-12-21	38000177		0	0	14		0	0	0	112153	0	562251	1713671		
13832	1155	1127433	1990-05-13	1990-05-13 00:00:00	1990-05-20	1990-05-20 00:00:00	1990-05-20	38000177		0	0	7		0	0	0	76387	0	313782	1127433		
37596	3109	19059056	1923-05-10	1923-05-10 00:00:00	1923-05-24	1923-05-24 00:00:00	1923-05-24	38000177		0	0	14		0	0	0	206755	0	243670	19059056		
8831	736	40229134	2002-08-21	2002-08-21 00:00:00	2002-09-04	2002-09-04 00:00:00	2002-09-04	38000177		0	0	14		0	0	0	48842	0	1043400	40229134		
42368	3513	40236824	2008-04-16	2008-04-16 00:00:00	2008-04-23	2008-04-23 00:00:00	2008-04-23	38000177		0	0	7		0	0	0	233131	0	1094107	40236824		
48971	4064	19134077	1985-12-08	1985-12-08 00:00:00	1985-12-22	1985-12-22 00:00:00	1985-12-22	38000177		0	0	14		0	0	0	269987	0	835900	19134077		
499	36	40162522	2001-03-30	2001-03-30 00:00:00	2001-03-30	2001-03-30 00:00:00	\N	38000177		0	0	0		0	0	0	2615	0	857005	40162522		
17894	1480	19078461	1980-03-22	1980-03-22 00:00:00	1980-04-12	1980-04-12 00:00:00	1980-04-12	38000177		0	0	21		0	0	0	98761	0	310965	19078461		
37918	3134	19075601	2015-04-16	2015-04-16 00:00:00	2015-04-16	2015-04-16 00:00:00	2015-04-16	38000177		0	0	0		0	0	0	208605	0	309362	19075601		
3144	260	19112599	1972-08-01	1972-08-01 00:00:00	1972-08-01	1972-08-01 00:00:00	\N	38000177		0	0	0		0	0	0	17154	0	477045	19112599		
14723	1231	19133873	1946-12-01	1946-12-01 00:00:00	1946-12-09	1946-12-09 00:00:00	1946-12-09	38000177		0	0	8		0	0	0	81150	0	834061	19133873		
43414	3599	40162522	2015-03-23	2015-03-23 00:00:00	2015-03-23	2015-03-23 00:00:00	\N	38000177		0	0	0		0	0	0	239071	0	857005	40162522		
45695	3784	1127433	1937-05-04	1937-05-04 00:00:00	1937-05-18	1937-05-18 00:00:00	1937-05-18	38000177		0	0	14		0	0	0	251491	0	313782	1127433		
46857	3881	1127433	2015-11-28	2015-11-28 00:00:00	2015-12-12	2015-12-12 00:00:00	2015-12-12	38000177		0	0	14		0	0	0	257890	0	313782	1127433		
39127	3234	19059056	1949-06-19	1949-06-19 00:00:00	1949-07-03	1949-07-03 00:00:00	1949-07-03	38000177		0	0	14		0	0	0	214945	0	243670	19059056		
224438	4927	40213160	1977-10-28	1977-10-28 00:00:00	1977-10-28	1977-10-28 00:00:00	1977-10-28	581452		0	0	0		0	0	0	327518	0	10	40213160		
21862	1793	1118084	1963-03-18	1963-03-18 00:00:00	1963-03-18	1963-03-18 00:00:00	\N	38000177		0	0	0		0	0	0	120223	0	00025152531	44923712		
49711	4123	1127433	1977-11-10	1977-11-10 00:00:00	1978-01-09	1978-01-09 00:00:00	1978-01-09	38000177		0	0	60		0	0	0	274116	0	313782	1127433		
52353	4355	40229134	2019-04-12	2019-04-12 00:00:00	2019-04-19	2019-04-19 00:00:00	2019-04-19	38000177		0	0	7		0	0	0	288947	0	1043400	40229134		
49792	4130	1127078	1965-06-17	1965-06-17 00:00:00	1965-07-01	1965-07-01 00:00:00	1965-07-01	38000177		0	0	14		0	0	0	274594	0	282464	1127078		
42572	3530	19059056	1981-06-18	1981-06-18 00:00:00	1981-07-23	1981-07-23 00:00:00	1981-07-23	38000177		0	0	35		0	0	0	234455	0	243670	19059056		
3346	277	19129655	1966-09-16	1966-09-16 00:00:00	1966-09-30	1966-09-30 00:00:00	1966-09-30	38000177		0	0	14		0	0	0	18500	0	789980	19129655		
20771	1713	19078461	2011-07-13	2011-07-13 00:00:00	2011-08-17	2011-08-17 00:00:00	2011-08-17	38000177		0	0	35		0	0	0	114456	0	310965	19078461		
168	3	40213227	1997-06-30	1997-06-30 00:00:00	1997-06-30	1997-06-30 00:00:00	1997-06-30	581452		0	0	0		0	0	0	328	0	113	40213227		
69832	1526	40213296	2012-01-05	2012-01-05 00:00:00	2012-01-05	2012-01-05 00:00:00	2012-01-05	581452		0	0	0		0	0	0	102054	0	52	40213296		
60867	5063	1127433	2010-10-18	2010-10-18 00:00:00	2010-11-22	2010-11-22 00:00:00	2010-11-22	38000177		0	0	35		0	0	0	336601	0	313782	1127433		
8331	695	1713671	2014-10-25	2014-10-25 00:00:00	2014-11-08	2014-11-08 00:00:00	2014-11-08	38000177		0	0	14		0	0	0	46009	0	562251	1713671		
62465	5197	35605482	1962-06-06	1962-06-06 00:00:00	1962-06-06	1962-06-06 00:00:00	1962-06-06	38000177		0	0	0		0	0	0	345571	0	1740467	35605482		
18025	1493	1713671	1982-10-03	1982-10-03 00:00:00	1982-10-24	1982-10-24 00:00:00	1982-10-24	38000177		0	0	21		0	0	0	99582	0	562251	1713671		
44892	3714	40220960	2009-07-01	2009-07-01 00:00:00	2009-07-01	2009-07-01 00:00:00	2009-07-01	38000177		0	0	0		0	0	0	246788	0	1804799	40220960		
24696	2030	19133873	1968-11-20	1968-11-20 00:00:00	1968-12-01	1968-12-01 00:00:00	1968-12-01	38000177		0	0	11		0	0	0	135116	0	834061	19133873		
58750	1285	40213260	2006-04-03	2006-04-03 00:00:00	2006-04-03	2006-04-03 00:00:00	2006-04-03	581452		0	0	0		0	0	0	84963	0	121	40213260		
5495	119	40213227	1998-04-21	1998-04-21 00:00:00	1998-04-21	1998-04-21 00:00:00	1998-04-21	581452		0	0	0		0	0	0	7918	0	113	40213227		
26172	2152	19018935	2008-02-23	2008-02-23 00:00:00	2008-02-23	2008-02-23 00:00:00	\N	38000177		0	0	0		0	0	0	143390	0	197604	19018935		
92876	2037	40213160	1965-03-26	1965-03-26 00:00:00	1965-03-26	1965-03-26 00:00:00	1965-03-26	581452		0	0	0		0	0	0	135686	0	10	40213160		
1474	116	19133873	1934-05-10	1934-05-10 00:00:00	1934-05-23	1934-05-23 00:00:00	1934-05-23	38000177		0	0	13		0	0	0	7649	0	834061	19133873		
104231	2286	40213227	1999-09-13	1999-09-13 00:00:00	1999-09-13	1999-09-13 00:00:00	1999-09-13	581452		0	0	0		0	0	0	152055	0	113	40213227		
8047	672	1127433	1967-03-26	1967-03-26 00:00:00	1967-04-09	1967-04-09 00:00:00	1967-04-09	38000177		0	0	14		0	0	0	44349	0	313782	1127433		
40270	3335	19019979	1984-01-23	1984-01-23 00:00:00	1984-02-20	1984-02-20 00:00:00	1984-02-20	38000177		0	0	28		0	0	0	221298	0	198405	19019979		
22912	1885	1713671	1987-09-12	1987-09-12 00:00:00	1987-10-03	1987-10-03 00:00:00	1987-10-03	38000177		0	0	21		0	0	0	125695	0	562251	1713671		
71235	1558	40213160	1955-04-07	1955-04-07 00:00:00	1955-04-07	1955-04-07 00:00:00	1955-04-07	581452		0	0	0		0	0	0	104387	0	10	40213160		
22698	1864	1713671	1984-08-23	1984-08-23 00:00:00	1984-08-30	1984-08-30 00:00:00	1984-08-30	38000177		0	0	7		0	0	0	124554	0	562251	1713671		
60521	5035	46275916	2003-03-03	2003-03-03 00:00:00	2003-03-03	2003-03-03 00:00:00	2003-03-03	38000177		0	0	0		0	0	0	334577	0	1660014	46275916		
33590	2780	1127433	1979-05-05	1979-05-05 00:00:00	1979-05-12	1979-05-12 00:00:00	1979-05-12	38000177		0	0	7		0	0	0	184235	0	313782	1127433		
8733	728	1127433	1973-02-17	1973-02-17 00:00:00	1973-03-03	1973-03-03 00:00:00	1973-03-03	38000177		0	0	14		0	0	0	48350	0	313782	1127433		
33319	2760	19006318	1961-12-23	1961-12-23 00:00:00	1962-01-06	1962-01-06 00:00:00	1962-01-06	38000177		0	0	14		0	0	0	182563	0	105078	19006318		
4305	357	19059056	1956-03-06	1956-03-06 00:00:00	1956-03-20	1956-03-20 00:00:00	1956-03-20	38000177		0	0	14		0	0	0	23623	0	243670	19059056		
56995	4729	40229134	2018-07-02	2018-07-02 00:00:00	2018-07-09	2018-07-09 00:00:00	2018-07-09	38000177		0	0	7		0	0	0	315088	0	1043400	40229134		
19389	1599	40229134	1971-10-24	1971-10-24 00:00:00	1971-10-31	1971-10-31 00:00:00	1971-10-31	38000177		0	0	7		0	0	0	107290	0	1043400	40229134		
9170	762	1127433	1959-01-20	1959-01-20 00:00:00	1959-02-03	1959-02-03 00:00:00	1959-02-03	38000177		0	0	14		0	0	0	50654	0	313782	1127433		
26533	2184	1154615	1970-02-21	1970-02-21 00:00:00	1970-02-21	1970-02-21 00:00:00	\N	38000177		0	0	0		0	0	0	145531	0	745679	1154615		
26615	2191	1713671	1972-09-13	1972-09-13 00:00:00	1972-10-04	1972-10-04 00:00:00	1972-10-04	38000177		0	0	21		0	0	0	146094	0	562251	1713671		
37099	3067	1127433	1984-11-14	1984-11-14 00:00:00	1984-11-21	1984-11-21 00:00:00	1984-11-21	38000177		0	0	7		0	0	0	204129	0	313782	1127433		
26722	2200	19059056	1978-01-15	1978-01-15 00:00:00	1978-01-29	1978-01-29 00:00:00	1978-01-29	38000177		0	0	14		0	0	0	146601	0	243670	19059056		
22008	1808	1127078	1969-12-26	1969-12-26 00:00:00	1970-01-16	1970-01-16 00:00:00	1970-01-16	38000177		0	0	21		0	0	0	121084	0	282464	1127078		
37259	3080	1115171	2018-10-09	2018-10-09 00:00:00	2018-10-30	2018-10-30 00:00:00	2018-10-30	38000177		0	0	21		0	0	0	205012	0	849574	1115171		
32310	2679	19078461	2009-12-13	2009-12-13 00:00:00	2010-01-03	2010-01-03 00:00:00	2010-01-03	38000177		0	0	21		0	0	0	177491	0	310965	19078461		
32628	2704	1115171	2018-12-19	2018-12-19 00:00:00	2019-01-16	2019-01-16 00:00:00	2019-01-16	38000177		0	0	28		0	0	0	179114	0	849574	1115171		
85600	1874	40213306	1996-08-03	1996-08-03 00:00:00	1996-08-03	1996-08-03 00:00:00	1996-08-03	581452		0	0	0		0	0	0	125107	0	43	40213306		
47925	3973	1713671	2008-09-08	2008-09-08 00:00:00	2008-09-29	2008-09-29 00:00:00	2008-09-29	38000177		0	0	21		0	0	0	264181	0	562251	1713671		
131800	2896	40213260	2019-03-24	2019-03-24 00:00:00	2019-03-24	2019-03-24 00:00:00	2019-03-24	581452		0	0	0		0	0	0	192832	0	121	40213260		
85735	1878	40213227	2007-04-15	2007-04-15 00:00:00	2007-04-15	2007-04-15 00:00:00	2007-04-15	581452		0	0	0		0	0	0	125355	0	113	40213227		
27729	2294	1118084	1997-09-02	1997-09-02 00:00:00	1997-09-02	1997-09-02 00:00:00	\N	38000177		0	0	0		0	0	0	152671	0	00025152531	44923712		
27767	2298	46233988	1972-02-21	1972-02-21 00:00:00	1972-03-06	1972-03-06 00:00:00	1972-03-06	38000177		0	0	14		0	0	0	153020	0	1652673	46233988		
20353	1670	1127433	1991-04-13	1991-04-13 00:00:00	1991-04-27	1991-04-27 00:00:00	1991-04-27	38000177		0	0	14		0	0	0	112193	0	313782	1127433		
13833	1155	1127433	1972-10-19	1972-10-19 00:00:00	1972-10-26	1972-10-26 00:00:00	1972-10-26	38000177		0	0	7		0	0	0	76324	0	313782	1127433		
37597	3109	19059056	1920-03-03	1920-03-03 00:00:00	1920-03-17	1920-03-17 00:00:00	1920-03-17	38000177		0	0	14		0	0	0	206754	0	243670	19059056		
8832	736	1713671	1983-12-02	1983-12-02 00:00:00	1983-12-23	1983-12-23 00:00:00	1983-12-23	38000177		0	0	21		0	0	0	48778	0	562251	1713671		
42369	3514	1127433	1989-09-09	1989-09-09 00:00:00	1989-09-16	1989-09-16 00:00:00	1989-09-16	38000177		0	0	7		0	0	0	233187	0	313782	1127433		
48972	4064	19008572	1985-12-08	1985-12-08 00:00:00	1985-12-22	1985-12-22 00:00:00	1985-12-22	38000177		0	0	14		0	0	0	269987	0	106258	19008572		
501	36	1713671	1991-10-16	1991-10-16 00:00:00	1991-10-30	1991-10-30 00:00:00	1991-10-30	38000177		0	0	14		0	0	0	2646	0	562251	1713671		
17895	1480	1713671	1969-06-10	1969-06-10 00:00:00	1969-07-01	1969-07-01 00:00:00	1969-07-01	38000177		0	0	21		0	0	0	98706	0	562251	1713671		
37919	3134	40220960	2015-04-16	2015-04-16 00:00:00	2015-04-16	2015-04-16 00:00:00	2015-04-16	38000177		0	0	0		0	0	0	208605	0	1804799	40220960		
3145	260	1127433	1979-02-22	1979-02-22 00:00:00	1979-03-08	1979-03-08 00:00:00	1979-03-08	38000177		0	0	14		0	0	0	17155	0	313782	1127433		
14724	1231	19059056	1949-11-14	1949-11-14 00:00:00	1950-01-13	1950-01-13 00:00:00	1950-01-13	38000177		0	0	60		0	0	0	81113	0	243670	19059056		
43415	3599	1127433	1974-12-22	1974-12-22 00:00:00	1975-01-05	1975-01-05 00:00:00	1975-01-05	38000177		0	0	14		0	0	0	239048	0	313782	1127433		
45696	3784	19133873	1932-01-01	1932-01-01 00:00:00	1932-01-14	1932-01-14 00:00:00	1932-01-14	38000177		0	0	13		0	0	0	251490	0	834061	19133873		
46858	3881	1127433	1981-12-05	1981-12-05 00:00:00	1981-12-26	1981-12-26 00:00:00	1981-12-26	38000177		0	0	21		0	0	0	257920	0	313782	1127433		
39128	3234	19006318	1949-06-19	1949-06-19 00:00:00	1949-07-03	1949-07-03 00:00:00	1949-07-03	38000177		0	0	14		0	0	0	214945	0	105078	19006318		
224440	4927	40213160	1978-03-31	1978-03-31 00:00:00	1978-03-31	1978-03-31 00:00:00	1978-03-31	581452		0	0	0		0	0	0	327469	0	10	40213160		
21863	1793	1127433	1977-01-13	1977-01-13 00:00:00	1977-01-20	1977-01-20 00:00:00	1977-01-20	38000177		0	0	7		0	0	0	120181	0	313782	1127433		
49712	4123	1127433	1997-12-25	1997-12-25 00:00:00	1998-01-29	1998-01-29 00:00:00	1998-01-29	38000177		0	0	35		0	0	0	274117	0	313782	1127433		
52354	4355	40229134	2018-07-08	2018-07-08 00:00:00	2018-07-15	2018-07-15 00:00:00	2018-07-15	38000177		0	0	7		0	0	0	288967	0	1043400	40229134		
49793	4130	19129655	1965-06-17	1965-06-17 00:00:00	1965-07-01	1965-07-01 00:00:00	1965-07-01	38000177		0	0	14		0	0	0	274594	0	789980	19129655		
42573	3530	19075601	1999-04-30	1999-04-30 00:00:00	1999-04-30	1999-04-30 00:00:00	\N	38000177		0	0	0		0	0	0	234477	0	309362	19075601		
3347	277	1127078	1966-09-16	1966-09-16 00:00:00	1966-09-30	1966-09-30 00:00:00	1966-09-30	38000177		0	0	14		0	0	0	18500	0	282464	1127078		
20772	1713	19073188	2011-07-13	2011-07-13 00:00:00	2011-08-17	2011-08-17 00:00:00	2011-08-17	38000177		0	0	35		0	0	0	114456	0	308192	19073188		
11457	246	40213227	2001-04-05	2001-04-05 00:00:00	2001-04-05	2001-04-05 00:00:00	2001-04-05	581452		0	0	0		0	0	0	16566	0	113	40213227		
1999	159	19059056	1963-05-23	1963-05-23 00:00:00	1963-06-27	1963-06-27 00:00:00	1963-06-27	38000177		0	0	35		0	0	0	10919	0	243670	19059056		
60868	5063	1127433	1967-05-09	1967-05-09 00:00:00	1967-05-16	1967-05-16 00:00:00	1967-05-16	38000177		0	0	7		0	0	0	336590	0	313782	1127433		
8332	695	19059056	1984-12-17	1984-12-17 00:00:00	1985-01-14	1985-01-14 00:00:00	1985-01-14	38000177		0	0	28		0	0	0	46049	0	243670	19059056		
62466	5197	35605482	1962-06-05	1962-06-05 00:00:00	1962-06-05	1962-06-05 00:00:00	1962-06-05	38000177		0	0	0		0	0	0	345571	0	1740467	35605482		
18026	1493	1713671	1967-06-07	1967-06-07 00:00:00	1967-06-28	1967-06-28 00:00:00	1967-06-28	38000177		0	0	21		0	0	0	99579	0	562251	1713671		
44893	3714	19059056	1937-01-20	1937-01-20 00:00:00	1937-03-21	1937-03-21 00:00:00	1937-03-21	38000177		0	0	60		0	0	0	246844	0	243670	19059056		
24698	2030	1124300	1997-11-04	1997-11-04 00:00:00	1997-11-04	1997-11-04 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00781178901	45011828		
92652	2033	40213227	2012-12-11	2012-12-11 00:00:00	2012-12-11	2012-12-11 00:00:00	2012-12-11	581452		0	0	0		0	0	0	135359	0	113	40213227		
5496	119	40213296	1998-04-21	1998-04-21 00:00:00	1998-04-21	1998-04-21 00:00:00	1998-04-21	581452		0	0	0		0	0	0	7918	0	52	40213296		
26173	2152	40171902	2008-02-23	2008-02-23 00:00:00	2008-02-23	2008-02-23 00:00:00	\N	38000177		0	0	0		0	0	0	143390	0	897718	40171902		
50070	4156	19059056	1960-03-06	1960-03-06 00:00:00	1960-03-27	1960-03-27 00:00:00	1960-03-27	38000177		0	0	21		0	0	0	276156	0	243670	19059056		
1475	116	40223774	2001-10-29	2001-10-29 00:00:00	2001-10-29	2001-10-29 00:00:00	\N	38000177		0	0	0		0	0	0	7681	0	998582	40223774		
104232	2286	40213296	1999-09-13	1999-09-13 00:00:00	1999-09-13	1999-09-13 00:00:00	1999-09-13	581452		0	0	0		0	0	0	152055	0	52	40213296		
8048	672	1127433	2004-11-15	2004-11-15 00:00:00	2004-11-22	2004-11-22 00:00:00	2004-11-22	38000177		0	0	7		0	0	0	44405	0	313782	1127433		
40271	3335	1118084	2011-01-01	2011-01-01 00:00:00	2011-01-01	2011-01-01 00:00:00	\N	38000177		0	0	0		0	0	0	221235	0	00025152531	44923712		
22913	1885	19019979	1978-11-04	1978-11-04 00:00:00	1978-11-18	1978-11-18 00:00:00	1978-11-18	38000177		0	0	14		0	0	0	125724	0	198405	19019979		
13531	292	40213227	2007-04-14	2007-04-14 00:00:00	2007-04-14	2007-04-14 00:00:00	2007-04-14	581452		0	0	0		0	0	0	19430	0	113	40213227		
22699	1864	19059056	1971-02-05	1971-02-05 00:00:00	1971-02-19	1971-02-19 00:00:00	1971-02-19	38000177		0	0	14		0	0	0	124539	0	243670	19059056		
60522	5035	1713671	1997-02-06	1997-02-06 00:00:00	1997-02-13	1997-02-13 00:00:00	1997-02-13	38000177		0	0	7		0	0	0	334649	0	562251	1713671		
33591	2780	40229134	2018-08-21	2018-08-21 00:00:00	2018-08-28	2018-08-28 00:00:00	2018-08-28	38000177		0	0	7		0	0	0	184211	0	1043400	40229134		
8734	728	19133873	1966-04-10	1966-04-10 00:00:00	1966-04-20	1966-04-20 00:00:00	1966-04-20	38000177		0	0	10		0	0	0	48331	0	834061	19133873		
33320	2760	19059056	1961-12-23	1961-12-23 00:00:00	1962-01-06	1962-01-06 00:00:00	1962-01-06	38000177		0	0	14		0	0	0	182563	0	243670	19059056		
4306	357	1127433	1992-03-28	1992-03-28 00:00:00	1992-04-04	1992-04-04 00:00:00	1992-04-04	38000177		0	0	7		0	0	0	23764	0	313782	1127433		
56996	4729	1127078	1965-09-18	1965-09-18 00:00:00	1965-10-18	1965-10-18 00:00:00	1965-10-18	38000177		0	0	30		0	0	0	315097	0	282464	1127078		
19390	1599	19073188	1980-05-23	1980-05-23 00:00:00	1980-06-06	1980-06-06 00:00:00	1980-06-06	38000177		0	0	14		0	0	0	107301	0	308192	19073188		
9171	762	1713671	1962-06-06	1962-06-06 00:00:00	1962-06-27	1962-06-27 00:00:00	1962-06-27	38000177		0	0	21		0	0	0	50675	0	562251	1713671		
26534	2184	19059056	1973-01-14	1973-01-14 00:00:00	1973-02-11	1973-02-11 00:00:00	1973-02-11	38000177		0	0	28		0	0	0	145587	0	243670	19059056		
26616	2191	1118084	2011-12-25	2011-12-25 00:00:00	2011-12-25	2011-12-25 00:00:00	\N	38000177		0	0	0		0	0	0	146126	0	00025152531	44923712		
37100	3067	1127433	1994-10-18	1994-10-18 00:00:00	1994-11-01	1994-11-01 00:00:00	1994-11-01	38000177		0	0	14		0	0	0	204178	0	313782	1127433		
37185	3074	1127433	2018-07-15	2018-07-15 00:00:00	2018-07-29	2018-07-29 00:00:00	2018-07-29	38000177		0	0	14		0	0	0	204575	0	313782	1127433		
22009	1808	920334	2001-03-21	2001-03-21 00:00:00	2001-03-28	2001-03-28 00:00:00	2001-03-28	38000177		0	0	7		0	0	0	121031	0	311995	920334		
37260	3080	1713671	1959-01-27	1959-01-27 00:00:00	1959-02-03	1959-02-03 00:00:00	1959-02-03	38000177		0	0	7		0	0	0	205014	0	562251	1713671		
32551	2699	19078461	1989-07-20	1989-07-20 00:00:00	1989-08-10	1989-08-10 00:00:00	1989-08-10	38000177		0	0	21		0	0	0	178712	0	310965	19078461		
32629	2705	40171902	2010-12-11	2010-12-11 00:00:00	2010-12-11	2010-12-11 00:00:00	\N	38000177		0	0	0		0	0	0	179219	0	897718	40171902		
85601	1874	40213314	1977-04-16	1977-04-16 00:00:00	1977-04-16	1977-04-16 00:00:00	1977-04-16	581452		0	0	0		0	0	0	125157	0	49	40213314		
47926	3973	1713671	1980-07-12	1980-07-12 00:00:00	1980-07-19	1980-07-19 00:00:00	1980-07-19	38000177		0	0	7		0	0	0	264204	0	562251	1713671		
131802	2896	40213227	2001-02-25	2001-02-25 00:00:00	2001-02-25	2001-02-25 00:00:00	2001-02-25	581452		0	0	0		0	0	0	192768	0	113	40213227		
85738	1878	40213160	1975-11-22	1975-11-22 00:00:00	1975-11-22	1975-11-22 00:00:00	1975-11-22	581452		0	0	0		0	0	0	125306	0	10	40213160		
27730	2294	1115171	1999-06-09	1999-06-09 00:00:00	1999-06-23	1999-06-23 00:00:00	1999-06-23	38000177		0	0	14		0	0	0	152751	0	849574	1115171		
27768	2298	19059056	1972-02-21	1972-02-21 00:00:00	1972-03-06	1972-03-06 00:00:00	1972-03-06	38000177		0	0	14		0	0	0	153020	0	243670	19059056		
20354	1670	1127433	1981-11-03	1981-11-03 00:00:00	1981-11-10	1981-11-10 00:00:00	1981-11-10	38000177		0	0	7		0	0	0	112156	0	313782	1127433		
13834	1155	1127433	1990-01-04	1990-01-04 00:00:00	1990-01-11	1990-01-11 00:00:00	1990-01-11	38000177		0	0	7		0	0	0	76329	0	313782	1127433		
37598	3109	19133873	1930-08-22	1930-08-22 00:00:00	1930-08-31	1930-08-31 00:00:00	1930-08-31	38000177		0	0	9		0	0	0	206768	0	834061	19133873		
8833	736	40229134	1982-10-06	1982-10-06 00:00:00	1982-10-20	1982-10-20 00:00:00	1982-10-20	38000177		0	0	14		0	0	0	48785	0	1043400	40229134		
42370	3514	1127433	1987-03-03	1987-03-03 00:00:00	1987-03-17	1987-03-17 00:00:00	1987-03-17	38000177		0	0	14		0	0	0	233213	0	313782	1127433		
48973	4064	19128065	1977-04-20	1977-04-20 00:00:00	1978-04-15	1978-04-15 00:00:00	1978-04-15	38000177		0	0	360		0	0	0	270049	0	749882	19128065		
502	36	19008572	1965-10-27	1965-10-27 00:00:00	1965-11-17	1965-11-17 00:00:00	1965-11-17	38000177		0	0	21		0	0	0	2504	0	106258	19008572		
17896	1480	1127433	2001-12-26	2001-12-26 00:00:00	2002-01-02	2002-01-02 00:00:00	2002-01-02	38000177		0	0	7		0	0	0	98719	0	313782	1127433		
37920	3134	40229134	1974-03-22	1974-03-22 00:00:00	1974-04-05	1974-04-05 00:00:00	1974-04-05	38000177		0	0	14		0	0	0	208559	0	1043400	40229134		
3146	260	1127433	1990-08-10	1990-08-10 00:00:00	1990-09-16	1990-09-16 00:00:00	1990-09-16	38000177		0	0	37		0	0	0	17267	0	313782	1127433		
36249	2987	19133905	1992-10-01	1992-10-01 00:00:00	1992-10-13	1992-10-13 00:00:00	1992-10-13	38000177		0	0	12		0	0	0	199413	0	834102	19133905		
43416	3599	40229134	2012-11-19	2012-11-19 00:00:00	2012-11-26	2012-11-26 00:00:00	2012-11-26	38000177		0	0	7		0	0	0	239051	0	1043400	40229134		
45697	3784	1127433	1951-06-10	1951-06-10 00:00:00	1951-06-17	1951-06-17 00:00:00	1951-06-17	38000177		0	0	7		0	0	0	251507	0	313782	1127433		
46859	3881	1118084	1992-08-31	1992-08-31 00:00:00	1992-08-31	1992-08-31 00:00:00	\N	38000177		0	0	0		0	0	0	257930	0	00025152531	44923712		
39129	3234	1545959	2010-01-18	2010-01-18 00:00:00	2010-01-19	2010-01-19 00:00:00	2010-01-19	38000177		0	0	1		0	0	0	214997	0	259255	1545959		
224443	4927	40213160	1982-07-02	1982-07-02 00:00:00	1982-07-02	1982-07-02 00:00:00	1982-07-02	581452		0	0	0		0	0	0	327508	0	10	40213160		
21864	1793	19059056	1921-02-26	1921-02-26 00:00:00	1921-03-12	1921-03-12 00:00:00	1921-03-12	38000177		0	0	14		0	0	0	120201	0	243670	19059056		
49713	4123	1118084	1999-01-07	1999-01-07 00:00:00	1999-01-07	1999-01-07 00:00:00	\N	38000177		0	0	0		0	0	0	274117	0	00025152531	44923712		
52355	4355	1127078	1981-11-14	1981-11-14 00:00:00	1981-11-28	1981-11-28 00:00:00	1981-11-28	38000177		0	0	14		0	0	0	288968	0	282464	1127078		
49794	4131	19128022	1996-05-07	1996-05-07 00:00:00	1997-05-02	1997-05-02 00:00:00	1997-05-02	38000177		0	0	360		0	0	0	274685	0	749785	19128022		
42574	3530	1124300	1995-04-30	1995-04-30 00:00:00	1995-04-30	1995-04-30 00:00:00	\N	38000177		0	0	0		0	0	0	234500	0	00781178901	45011828		
3348	277	1127433	2010-12-09	2010-12-09 00:00:00	2010-12-16	2010-12-16 00:00:00	2010-12-16	38000177		0	0	7		0	0	0	18505	0	313782	1127433		
20773	1713	40231925	2011-07-13	2011-07-13 00:00:00	2011-07-13	2011-07-13 00:00:00	\N	38000177		0	0	0		0	0	0	114456	0	1049221	40231925		
11458	246	40213296	2001-04-05	2001-04-05 00:00:00	2001-04-05	2001-04-05 00:00:00	2001-04-05	581452		0	0	0		0	0	0	16566	0	52	40213296		
2000	159	19059056	1955-08-12	1955-08-12 00:00:00	1955-08-26	1955-08-26 00:00:00	1955-08-26	38000177		0	0	14		0	0	0	10860	0	243670	19059056		
60869	5063	1127433	1999-06-08	1999-06-08 00:00:00	1999-06-22	1999-06-22 00:00:00	1999-06-22	38000177		0	0	14		0	0	0	336570	0	313782	1127433		
8333	695	1127433	1974-10-21	1974-10-21 00:00:00	1974-11-04	1974-11-04 00:00:00	1974-11-04	38000177		0	0	14		0	0	0	45989	0	313782	1127433		
62467	5197	42707627	1962-06-06	1962-06-06 00:00:00	1962-06-06	1962-06-06 00:00:00	1962-06-06	38000177		0	0	0		0	0	0	345571	0	1234995	42707627		
18027	1493	19059056	1962-10-24	1962-10-24 00:00:00	1962-11-23	1962-11-23 00:00:00	1962-11-23	38000177		0	0	30		0	0	0	99574	0	243670	19059056		
16336	352	40213160	1982-06-28	1982-06-28 00:00:00	1982-06-28	1982-06-28 00:00:00	1982-06-28	581452		0	0	0		0	0	0	23458	0	10	40213160		
24699	2030	40229134	1990-06-22	1990-06-22 00:00:00	1990-06-29	1990-06-29 00:00:00	1990-06-29	38000177		0	0	7		0	0	0	135142	0	1043400	40229134		
92664	2033	40213227	1992-12-22	1992-12-22 00:00:00	1992-12-22	1992-12-22 00:00:00	1992-12-22	581452		0	0	0		0	0	0	135312	0	113	40213227		
5498	119	40213160	1956-04-03	1956-04-03 00:00:00	1956-04-03	1956-04-03 00:00:00	1956-04-03	581452		0	0	0		0	0	0	7942	0	10	40213160		
26174	2152	19133905	1949-07-14	1949-07-14 00:00:00	1949-07-25	1949-07-25 00:00:00	1949-07-25	38000177		0	0	11		0	0	0	143449	0	834102	19133905		
50071	4156	19059056	1966-09-22	1966-09-22 00:00:00	1966-10-06	1966-10-06 00:00:00	1966-10-06	38000177		0	0	14		0	0	0	276158	0	243670	19059056		
1476	116	19133873	1937-07-25	1937-07-25 00:00:00	1937-08-01	1937-08-01 00:00:00	1937-08-01	38000177		0	0	7		0	0	0	7702	0	834061	19133873		
104235	2286	40213160	1962-08-13	1962-08-13 00:00:00	1962-08-13	1962-08-13 00:00:00	1962-08-13	581452		0	0	0		0	0	0	152039	0	10	40213160		
8049	672	1127433	1983-02-04	1983-02-04 00:00:00	1983-02-25	1983-02-25 00:00:00	1983-02-25	38000177		0	0	21		0	0	0	44412	0	313782	1127433		
40272	3335	1713671	1990-01-11	1990-01-11 00:00:00	1990-02-22	1990-02-22 00:00:00	1990-02-22	38000177		0	0	42		0	0	0	221246	0	562251	1713671		
22914	1885	46233988	1978-11-04	1978-11-04 00:00:00	1978-11-18	1978-11-18 00:00:00	1978-11-18	38000177		0	0	14		0	0	0	125724	0	1652673	46233988		
13546	293	40213160	1965-06-22	1965-06-22 00:00:00	1965-06-22	1965-06-22 00:00:00	1965-06-22	581452		0	0	0		0	0	0	19528	0	10	40213160		
22700	1864	40169281	2011-12-23	2011-12-23 00:00:00	2011-12-23	2011-12-23 00:00:00	\N	38000177		0	0	0		0	0	0	124551	0	896209	40169281		
60523	5035	1127433	1996-12-10	1996-12-10 00:00:00	1996-12-24	1996-12-24 00:00:00	1996-12-24	38000177		0	0	14		0	0	0	334648	0	313782	1127433		
33592	2780	19006318	1956-02-17	1956-02-17 00:00:00	1956-03-02	1956-03-02 00:00:00	1956-03-02	38000177		0	0	14		0	0	0	184228	0	105078	19006318		
8735	728	1713671	2014-09-22	2014-09-22 00:00:00	2014-10-13	2014-10-13 00:00:00	2014-10-13	38000177		0	0	21		0	0	0	48357	0	562251	1713671		
33321	2760	1713671	1966-02-24	1966-02-24 00:00:00	1966-03-17	1966-03-17 00:00:00	1966-03-17	38000177		0	0	21		0	0	0	182553	0	562251	1713671		
4307	357	1118084	1996-04-20	1996-04-20 00:00:00	1996-04-20	1996-04-20 00:00:00	\N	38000177		0	0	0		0	0	0	23772	0	00025152531	44923712		
57007	4731	40236446	1981-10-30	1981-10-30 00:00:00	1983-11-11	1983-11-11 00:00:00	1983-11-11	38000177		0	0	742		0	0	0	315193	0	1091392	40236446		
28085	2325	40229134	1981-01-06	1981-01-06 00:00:00	1981-01-13	1981-01-13 00:00:00	1981-01-13	38000177		0	0	7		0	0	0	154617	0	1043400	40229134		
9172	762	1124300	1996-05-19	1996-05-19 00:00:00	1996-05-19	1996-05-19 00:00:00	\N	38000177		0	0	0		0	0	0	50657	0	00781178901	45011828		
26535	2184	19078461	2004-03-21	2004-03-21 00:00:00	2004-04-18	2004-04-18 00:00:00	2004-04-18	38000177		0	0	28		0	0	0	145590	0	310965	19078461		
26617	2191	1713671	1979-11-29	1979-11-29 00:00:00	1979-12-06	1979-12-06 00:00:00	1979-12-06	38000177		0	0	7		0	0	0	146087	0	562251	1713671		
37101	3067	1127433	2003-10-21	2003-10-21 00:00:00	2003-10-28	2003-10-28 00:00:00	2003-10-28	38000177		0	0	7		0	0	0	204180	0	313782	1127433		
37186	3074	1115171	1998-11-15	1998-11-15 00:00:00	1998-12-06	1998-12-06 00:00:00	1998-12-06	38000177		0	0	21		0	0	0	204573	0	849574	1115171		
22010	1808	40229134	1963-03-05	1963-03-05 00:00:00	1963-03-12	1963-03-12 00:00:00	1963-03-12	38000177		0	0	7		0	0	0	121018	0	1043400	40229134		
37261	3080	1115171	2014-10-02	2014-10-02 00:00:00	2014-12-01	2014-12-01 00:00:00	2014-12-01	38000177		0	0	60		0	0	0	205010	0	849574	1115171		
32552	2699	1713671	1992-04-29	1992-04-29 00:00:00	1992-05-20	1992-05-20 00:00:00	1992-05-20	38000177		0	0	21		0	0	0	178701	0	562251	1713671		
32630	2705	40163554	2010-12-11	2010-12-11 00:00:00	2010-12-11	2010-12-11 00:00:00	\N	38000177		0	0	0		0	0	0	179219	0	855332	40163554		
49445	4102	40165015	1981-08-14	1981-08-14 00:00:00	1981-08-14	1981-08-14 00:00:00	\N	38000177		0	0	0		0	0	0	272580	0	861467	40165015		
47927	3973	1713671	1992-11-17	1992-11-17 00:00:00	1992-12-08	1992-12-08 00:00:00	1992-12-08	38000177		0	0	21		0	0	0	264168	0	562251	1713671		
131805	2896	40213160	1969-08-31	1969-08-31 00:00:00	1969-08-31	1969-08-31 00:00:00	1969-08-31	581452		0	0	0		0	0	0	192820	0	10	40213160		
85740	1878	40213306	1998-03-21	1998-03-21 00:00:00	1998-03-21	1998-03-21 00:00:00	1998-03-21	581452		0	0	0		0	0	0	125303	0	43	40213306		
27731	2294	19078461	2018-11-10	2018-11-10 00:00:00	2018-12-01	2018-12-01 00:00:00	2018-12-01	38000177		0	0	21		0	0	0	152752	0	310965	19078461		
27769	2298	1127433	1982-11-09	1982-11-09 00:00:00	1982-12-14	1982-12-14 00:00:00	1982-12-14	38000177		0	0	35		0	0	0	153016	0	313782	1127433		
20355	1670	1127433	1989-01-03	1989-01-03 00:00:00	1989-01-17	1989-01-17 00:00:00	1989-01-17	38000177		0	0	14		0	0	0	112198	0	313782	1127433		
13835	1155	1127433	2010-10-29	2010-10-29 00:00:00	2010-11-05	2010-11-05 00:00:00	2010-11-05	38000177		0	0	7		0	0	0	76366	0	313782	1127433		
37599	3109	1127433	1968-07-22	1968-07-22 00:00:00	1968-08-05	1968-08-05 00:00:00	1968-08-05	38000177		0	0	14		0	0	0	206772	0	313782	1127433		
8834	736	1118084	2009-10-13	2009-10-13 00:00:00	2009-10-13	2009-10-13 00:00:00	\N	38000177		0	0	0		0	0	0	48844	0	00025152531	44923712		
42371	3514	1127433	1994-02-23	1994-02-23 00:00:00	1994-03-09	1994-03-09 00:00:00	1994-03-09	38000177		0	0	14		0	0	0	233185	0	313782	1127433		
48974	4064	19078461	1999-06-28	1999-06-28 00:00:00	1999-07-19	1999-07-19 00:00:00	1999-07-19	38000177		0	0	21		0	0	0	270123	0	310965	19078461		
503	36	19128065	1975-10-02	1975-10-02 00:00:00	1976-09-26	1976-09-26 00:00:00	1976-09-26	38000177		0	0	360		0	0	0	2573	0	749882	19128065		
4083	337	1115171	2013-10-23	2013-10-23 00:00:00	2013-11-27	2013-11-27 00:00:00	2013-11-27	38000177		0	0	35		0	0	0	22415	0	849574	1115171		
37921	3134	1124300	1963-09-04	1963-09-04 00:00:00	1963-09-04	1963-09-04 00:00:00	\N	38000177		0	0	0		0	0	0	208529	0	00781178901	45011828		
3147	260	1713671	1974-12-20	1974-12-20 00:00:00	1975-01-10	1975-01-10 00:00:00	1975-01-10	38000177		0	0	21		0	0	0	17197	0	562251	1713671		
36250	2987	1127433	1989-05-30	1989-05-30 00:00:00	1989-06-13	1989-06-13 00:00:00	1989-06-13	38000177		0	0	14		0	0	0	199371	0	313782	1127433		
43417	3599	19133873	1979-10-10	1979-10-10 00:00:00	1979-10-22	1979-10-22 00:00:00	1979-10-22	38000177		0	0	12		0	0	0	239065	0	834061	19133873		
45698	3784	46233710	1972-03-18	1972-03-18 00:00:00	1972-04-01	1972-04-01 00:00:00	1972-04-01	38000177		0	0	14		0	0	0	251496	0	1650142	46233710		
46860	3881	19126352	1986-11-07	1986-11-07 00:00:00	1986-11-07	1986-11-07 00:00:00	\N	38000177		0	0	0		0	0	0	257907	0	705129	19126352		
39130	3234	19133768	2010-01-18	2010-01-18 00:00:00	2010-01-19	2010-01-19 00:00:00	2010-01-19	38000177		0	0	1		0	0	0	214997	0	833036	19133768		
224446	4927	40213227	1999-09-24	1999-09-24 00:00:00	1999-09-24	1999-09-24 00:00:00	1999-09-24	581452		0	0	0		0	0	0	327464	0	113	40213227		
21865	1793	40229134	1934-04-14	1934-04-14 00:00:00	1934-04-28	1934-04-28 00:00:00	1934-04-28	38000177		0	0	14		0	0	0	120212	0	1043400	40229134		
49714	4123	19059056	1963-08-14	1963-08-14 00:00:00	1963-08-28	1963-08-28 00:00:00	1963-08-28	38000177		0	0	14		0	0	0	274142	0	243670	19059056		
52356	4355	19073183	1981-11-14	1981-11-14 00:00:00	1981-11-28	1981-11-28 00:00:00	1981-11-28	38000177		0	0	14		0	0	0	288968	0	308182	19073183		
49795	4131	42902245	1998-04-27	1998-04-27 00:00:00	1999-04-22	1999-04-22 00:00:00	1999-04-22	38000177		0	0	360		0	0	0	274687	0	1359133	42902245		
42575	3530	1713671	1994-04-12	1994-04-12 00:00:00	1994-05-03	1994-05-03 00:00:00	1994-05-03	38000177		0	0	21		0	0	0	234500	0	562251	1713671		
3349	277	40220960	2005-11-29	2005-11-29 00:00:00	2005-11-29	2005-11-29 00:00:00	2005-11-29	38000177		0	0	0		0	0	0	18469	0	1804799	40220960		
20774	1713	19128065	1988-09-16	1988-09-16 00:00:00	1989-09-11	1989-09-11 00:00:00	1989-09-11	38000177		0	0	360		0	0	0	114472	0	749882	19128065		
11462	246	40213160	1960-05-05	1960-05-05 00:00:00	1960-05-05	1960-05-05 00:00:00	1960-05-05	581452		0	0	0		0	0	0	16528	0	10	40213160		
2001	159	40229134	1971-12-17	1971-12-17 00:00:00	1971-12-31	1971-12-31 00:00:00	1971-12-31	38000177		0	0	14		0	0	0	10856	0	1043400	40229134		
60870	5063	1713671	1972-06-28	1972-06-28 00:00:00	1972-07-12	1972-07-12 00:00:00	1972-07-12	38000177		0	0	14		0	0	0	336593	0	562251	1713671		
8334	695	1127078	1969-11-15	1969-11-15 00:00:00	1969-12-06	1969-12-06 00:00:00	1969-12-06	38000177		0	0	21		0	0	0	46005	0	282464	1127078		
62468	5197	1367571	1962-06-05	1962-06-05 00:00:00	1962-06-05	1962-06-05 00:00:00	1962-06-05	38000177		0	0	0		0	0	0	345571	0	314659	19080464		
18028	1493	1127433	2007-04-18	2007-04-18 00:00:00	2007-04-25	2007-04-25 00:00:00	2007-04-25	38000177		0	0	7		0	0	0	99555	0	313782	1127433		
16346	352	40213251	1984-07-09	1984-07-09 00:00:00	1984-07-09	1984-07-09 00:00:00	1984-07-09	581452		0	0	0		0	0	0	23459	0	21	40213251		
3919	326	19078461	1995-06-20	1995-06-20 00:00:00	1995-07-11	1995-07-11 00:00:00	1995-07-11	38000177		0	0	21		0	0	0	21529	0	310965	19078461		
92669	2033	40213201	2018-05-01	2018-05-01 00:00:00	2018-05-01	2018-05-01 00:00:00	2018-05-01	581452		0	0	0		0	0	0	135348	0	33	40213201		
92720	2034	40213227	2004-11-10	2004-11-10 00:00:00	2004-11-10	2004-11-10 00:00:00	2004-11-10	581452		0	0	0		0	0	0	135499	0	113	40213227		
26175	2152	1124300	1963-05-17	1963-05-17 00:00:00	1963-05-17	1963-05-17 00:00:00	\N	38000177		0	0	0		0	0	0	143420	0	00781178901	45011828		
50072	4156	19126352	2006-06-26	2006-06-26 00:00:00	2007-12-24	2007-12-24 00:00:00	2007-12-24	38000177		0	0	546		0	0	0	276210	0	705129	19126352		
1477	116	1127433	2002-04-19	2002-04-19 00:00:00	2002-05-03	2002-05-03 00:00:00	2002-05-03	38000177		0	0	14		0	0	0	7692	0	313782	1127433		
104242	2286	40213227	1992-03-02	1992-03-02 00:00:00	1992-03-02	1992-03-02 00:00:00	1992-03-02	581452		0	0	0		0	0	0	152030	0	113	40213227		
8050	673	1127078	1967-05-24	1967-05-24 00:00:00	1967-06-28	1967-06-28 00:00:00	1967-06-28	38000177		0	0	35		0	0	0	44430	0	282464	1127078		
40273	3335	1713671	1985-08-20	1985-08-20 00:00:00	1985-08-27	1985-08-27 00:00:00	1985-08-27	38000177		0	0	7		0	0	0	221273	0	562251	1713671		
22915	1885	40229134	2006-11-03	2006-11-03 00:00:00	2006-11-17	2006-11-17 00:00:00	2006-11-17	38000177		0	0	14		0	0	0	125674	0	1043400	40229134		
13555	293	40213227	1998-08-18	1998-08-18 00:00:00	1998-08-18	1998-08-18 00:00:00	1998-08-18	581452		0	0	0		0	0	0	19480	0	113	40213227		
22701	1864	1115171	2014-02-03	2014-02-03 00:00:00	2014-02-17	2014-02-17 00:00:00	2014-02-17	38000177		0	0	14		0	0	0	124522	0	849574	1115171		
60524	5035	40165015	1996-06-20	1996-06-20 00:00:00	1996-06-20	1996-06-20 00:00:00	\N	38000177		0	0	0		0	0	0	334620	0	861467	40165015		
46347	3839	19133873	1952-12-12	1952-12-12 00:00:00	1952-12-21	1952-12-21 00:00:00	1952-12-21	38000177		0	0	9		0	0	0	254836	0	834061	19133873		
8736	728	19078461	1993-06-29	1993-06-29 00:00:00	1993-07-20	1993-07-20 00:00:00	1993-07-20	38000177		0	0	21		0	0	0	48313	0	310965	19078461		
33322	2760	1713671	1998-10-25	1998-10-25 00:00:00	1998-11-15	1998-11-15 00:00:00	1998-11-15	38000177		0	0	21		0	0	0	182558	0	562251	1713671		
4308	357	1551192	1955-09-08	1955-09-08 00:00:00	1955-09-08	1955-09-08 00:00:00	1955-09-08	38000177		0	0	0		0	0	0	23633	0	312617	1551192		
57008	4731	46233988	1975-05-08	1975-05-08 00:00:00	1975-05-22	1975-05-22 00:00:00	1975-05-22	38000177		0	0	14		0	0	0	315240	0	1652673	46233988		
28086	2325	1115171	2007-10-06	2007-10-06 00:00:00	2007-12-05	2007-12-05 00:00:00	2007-12-05	38000177		0	0	60		0	0	0	154601	0	849574	1115171		
9173	762	40173590	2014-09-10	2014-09-10 00:00:00	2014-09-10	2014-09-10 00:00:00	\N	38000177		0	0	0		0	0	0	50729	0	904419	40173590		
26536	2184	40165015	2004-03-21	2004-03-21 00:00:00	2004-03-21	2004-03-21 00:00:00	\N	38000177		0	0	0		0	0	0	145590	0	861467	40165015		
26618	2191	19133873	1985-02-07	1985-02-07 00:00:00	1985-02-18	1985-02-18 00:00:00	1985-02-18	38000177		0	0	11		0	0	0	146118	0	834061	19133873		
37102	3067	40229134	1970-10-09	1970-10-09 00:00:00	1970-10-23	1970-10-23 00:00:00	1970-10-23	38000177		0	0	14		0	0	0	204128	0	1043400	40229134		
37187	3074	1127433	2005-09-30	2005-09-30 00:00:00	2005-10-21	2005-10-21 00:00:00	2005-10-21	38000177		0	0	21		0	0	0	204574	0	313782	1127433		
22011	1808	1127433	2014-04-27	2014-04-27 00:00:00	2014-05-04	2014-05-04 00:00:00	2014-05-04	38000177		0	0	7		0	0	0	121050	0	313782	1127433		
37262	3080	19059056	1946-06-09	1946-06-09 00:00:00	1946-06-23	1946-06-23 00:00:00	1946-06-23	38000177		0	0	14		0	0	0	205021	0	243670	19059056		
32553	2699	920300	2008-12-07	2008-12-07 00:00:00	2008-12-14	2008-12-14 00:00:00	2008-12-14	38000177		0	0	7		0	0	0	178721	0	311989	920300		
32631	2705	19018935	2010-12-11	2010-12-11 00:00:00	2010-12-11	2010-12-11 00:00:00	\N	38000177		0	0	0		0	0	0	179219	0	197604	19018935		
49446	4102	19059056	1981-08-14	1981-08-14 00:00:00	1981-11-12	1981-11-12 00:00:00	1981-11-12	38000177		0	0	90		0	0	0	272580	0	243670	19059056		
47928	3973	1127433	1996-11-15	1996-11-15 00:00:00	1996-11-29	1996-11-29 00:00:00	1996-11-29	38000177		0	0	14		0	0	0	264171	0	313782	1127433		
131808	2896	40213296	2011-04-03	2011-04-03 00:00:00	2011-04-03	2011-04-03 00:00:00	2011-04-03	581452		0	0	0		0	0	0	192771	0	52	40213296		
97021	2127	40213160	1960-12-10	1960-12-10 00:00:00	1960-12-10	1960-12-10 00:00:00	1960-12-10	581452		0	0	0		0	0	0	141458	0	10	40213160		
27732	2294	19133905	1990-10-08	1990-10-08 00:00:00	1990-10-17	1990-10-17 00:00:00	1990-10-17	38000177		0	0	9		0	0	0	152704	0	834102	19133905		
27770	2298	1127433	2018-02-08	2018-02-08 00:00:00	2018-02-22	2018-02-22 00:00:00	2018-02-22	38000177		0	0	14		0	0	0	153019	0	313782	1127433		
20358	1672	19078461	2007-09-19	2007-09-19 00:00:00	2007-10-10	2007-10-10 00:00:00	2007-10-10	38000177		0	0	21		0	0	0	112283	0	310965	19078461		
13836	1155	19133873	1976-08-14	1976-08-14 00:00:00	1976-08-22	1976-08-22 00:00:00	1976-08-22	38000177		0	0	8		0	0	0	76302	0	834061	19133873		
37600	3109	19059056	1956-12-03	1956-12-03 00:00:00	1956-12-24	1956-12-24 00:00:00	1956-12-24	38000177		0	0	21		0	0	0	206706	0	243670	19059056		
8835	736	1713671	1979-03-05	1979-03-05 00:00:00	1979-03-19	1979-03-19 00:00:00	1979-03-19	38000177		0	0	14		0	0	0	48783	0	562251	1713671		
42372	3514	19059056	1975-09-13	1975-09-13 00:00:00	1975-10-04	1975-10-04 00:00:00	1975-10-04	38000177		0	0	21		0	0	0	233211	0	243670	19059056		
7301	610	40236824	2015-10-25	2015-10-25 00:00:00	2015-11-01	2015-11-01 00:00:00	2015-11-01	38000177		0	0	7		0	0	0	40615	0	1094107	40236824		
504	36	19008572	1982-10-06	1982-10-06 00:00:00	1982-10-20	1982-10-20 00:00:00	1982-10-20	38000177		0	0	14		0	0	0	2515	0	106258	19008572		
4085	338	19128065	1983-04-05	1983-04-05 00:00:00	1984-03-30	1984-03-30 00:00:00	1984-03-30	38000177		0	0	360		0	0	0	22587	0	749882	19128065		
37922	3134	40171902	2007-02-15	2007-02-15 00:00:00	2007-02-15	2007-02-15 00:00:00	\N	38000177		0	0	0		0	0	0	208597	0	897718	40171902		
3148	260	1127078	1971-03-15	1971-03-15 00:00:00	1971-03-29	1971-03-29 00:00:00	1971-03-29	38000177		0	0	14		0	0	0	17183	0	282464	1127078		
36251	2987	1127433	2003-09-12	2003-09-12 00:00:00	2003-10-17	2003-10-17 00:00:00	2003-10-17	38000177		0	0	35		0	0	0	199424	0	313782	1127433		
43418	3599	19059056	1973-03-30	1973-03-30 00:00:00	1973-04-27	1973-04-27 00:00:00	1973-04-27	38000177		0	0	28		0	0	0	239082	0	243670	19059056		
45699	3784	19059056	1972-03-18	1972-03-18 00:00:00	1972-04-01	1972-04-01 00:00:00	1972-04-01	38000177		0	0	14		0	0	0	251496	0	243670	19059056		
46861	3881	19006318	1960-06-30	1960-06-30 00:00:00	1960-07-14	1960-07-14 00:00:00	1960-07-14	38000177		0	0	14		0	0	0	257917	0	105078	19006318		
39131	3234	19078461	1980-04-06	1980-04-06 00:00:00	1980-04-28	1980-04-28 00:00:00	1980-04-28	38000177		0	0	22		0	0	0	214996	0	310965	19078461		
224447	4927	40213306	1999-09-24	1999-09-24 00:00:00	1999-09-24	1999-09-24 00:00:00	1999-09-24	581452		0	0	0		0	0	0	327464	0	43	40213306		
21866	1793	1332419	1994-06-29	1994-06-29 00:00:00	1994-06-29	1994-06-29 00:00:00	\N	38000177		0	0	0		0	0	0	120256	0	197361	1332419		
49715	4123	1713671	1994-12-31	1994-12-31 00:00:00	1995-01-07	1995-01-07 00:00:00	1995-01-07	38000177		0	0	7		0	0	0	274147	0	562251	1713671		
52357	4355	1127433	2010-10-13	2010-10-13 00:00:00	2010-10-27	2010-10-27 00:00:00	2010-10-27	38000177		0	0	14		0	0	0	288962	0	313782	1127433		
49796	4131	19128065	1997-05-02	1997-05-02 00:00:00	1998-04-27	1998-04-27 00:00:00	1998-04-27	38000177		0	0	360		0	0	0	274686	0	749882	19128065		
42576	3530	1127433	2001-12-05	2001-12-05 00:00:00	2001-12-26	2001-12-26 00:00:00	2001-12-26	38000177		0	0	21		0	0	0	234456	0	313782	1127433		
3350	277	19075601	2005-11-29	2005-11-29 00:00:00	2005-11-29	2005-11-29 00:00:00	2005-11-29	38000177		0	0	0		0	0	0	18469	0	309362	19075601		
20775	1713	40236824	2004-10-26	2004-10-26 00:00:00	2004-11-02	2004-11-02 00:00:00	2004-11-02	38000177		0	0	7		0	0	0	114465	0	1094107	40236824		
11465	246	40213160	1960-03-03	1960-03-03 00:00:00	1960-03-03	1960-03-03 00:00:00	1960-03-03	581452		0	0	0		0	0	0	16508	0	10	40213160		
2002	159	19133873	1957-12-02	1957-12-02 00:00:00	1957-12-12	1957-12-12 00:00:00	1957-12-12	38000177		0	0	10		0	0	0	10925	0	834061	19133873		
51889	4313	1127078	1953-09-06	1953-09-06 00:00:00	1953-10-06	1953-10-06 00:00:00	1953-10-06	38000177		0	0	30		0	0	0	286307	0	282464	1127078		
8335	695	1118084	2006-03-01	2006-03-01 00:00:00	2006-03-01	2006-03-01 00:00:00	\N	38000177		0	0	0		0	0	0	46029	0	00025152531	44923712		
62469	5197	1154029	1962-06-06	1962-06-06 00:00:00	1962-06-06	1962-06-06 00:00:00	1962-06-06	38000177		0	0	0		0	0	0	345571	0	4337	1154029		
18029	1493	1127433	2003-12-28	2003-12-28 00:00:00	2004-01-11	2004-01-11 00:00:00	2004-01-11	38000177		0	0	14		0	0	0	99537	0	313782	1127433		
16352	352	40213227	2008-10-27	2008-10-27 00:00:00	2008-10-27	2008-10-27 00:00:00	2008-10-27	581452		0	0	0		0	0	0	23464	0	113	40213227		
3920	326	1127433	1973-05-18	1973-05-18 00:00:00	1973-06-01	1973-06-01 00:00:00	1973-06-01	38000177		0	0	14		0	0	0	21530	0	313782	1127433		
92678	2033	40213198	2017-04-25	2017-04-25 00:00:00	2017-04-25	2017-04-25 00:00:00	2017-04-25	581452		0	0	0		0	0	0	135327	0	133	40213198		
33805	2798	1124300	1994-02-18	1994-02-18 00:00:00	1994-02-18	1994-02-18 00:00:00	\N	38000177		0	0	0		0	0	0	185397	0	00781178901	45011828		
26176	2152	40220960	2007-09-08	2007-09-08 00:00:00	2007-09-08	2007-09-08 00:00:00	2007-09-08	38000177		0	0	0		0	0	0	143419	0	1804799	40220960		
50073	4156	19075601	2006-06-26	2006-06-26 00:00:00	2007-12-24	2007-12-24 00:00:00	2007-12-24	38000177		0	0	546		0	0	0	276210	0	309362	19075601		
1478	116	1713671	1963-08-11	1963-08-11 00:00:00	1963-08-18	1963-08-18 00:00:00	1963-08-18	38000177		0	0	7		0	0	0	7676	0	562251	1713671		
104244	2286	40213260	2008-09-08	2008-09-08 00:00:00	2008-09-08	2008-09-08 00:00:00	2008-09-08	581452		0	0	0		0	0	0	152087	0	121	40213260		
8051	673	19128065	1981-08-18	1981-08-18 00:00:00	1982-08-13	1982-08-13 00:00:00	1982-08-13	38000177		0	0	360		0	0	0	44494	0	749882	19128065		
40274	3335	1713671	1997-11-18	1997-11-18 00:00:00	1997-12-09	1997-12-09 00:00:00	1997-12-09	38000177		0	0	21		0	0	0	221276	0	562251	1713671		
22916	1885	19128065	1988-02-19	1988-02-19 00:00:00	1989-02-13	1989-02-13 00:00:00	1989-02-13	38000177		0	0	360		0	0	0	125702	0	749882	19128065		
13557	293	40213296	2008-09-02	2008-09-02 00:00:00	2008-09-02	2008-09-02 00:00:00	2008-09-02	581452		0	0	0		0	0	0	19490	0	52	40213296		
23014	1898	19133905	1991-04-03	1991-04-03 00:00:00	1991-04-16	1991-04-16 00:00:00	1991-04-16	38000177		0	0	13		0	0	0	126342	0	834102	19133905		
60525	5035	1115171	1996-06-20	1996-06-20 00:00:00	1996-09-18	1996-09-18 00:00:00	1996-09-18	38000177		0	0	90		0	0	0	334620	0	849574	1115171		
46348	3839	1713671	1958-06-26	1958-06-26 00:00:00	1958-07-10	1958-07-10 00:00:00	1958-07-10	38000177		0	0	14		0	0	0	254911	0	562251	1713671		
8737	728	19059056	1970-10-14	1970-10-14 00:00:00	1970-10-28	1970-10-28 00:00:00	1970-10-28	38000177		0	0	14		0	0	0	48312	0	243670	19059056		
33323	2761	19133873	1985-07-24	1985-07-24 00:00:00	1985-07-31	1985-07-31 00:00:00	1985-07-31	38000177		0	0	7		0	0	0	182648	0	834061	19133873		
4309	357	1127078	1959-12-16	1959-12-16 00:00:00	1960-01-15	1960-01-15 00:00:00	1960-01-15	38000177		0	0	30		0	0	0	23634	0	282464	1127078		
57009	4731	19019979	1975-05-08	1975-05-08 00:00:00	1975-05-22	1975-05-22 00:00:00	1975-05-22	38000177		0	0	14		0	0	0	315240	0	198405	19019979		
28087	2325	40162522	2007-10-06	2007-10-06 00:00:00	2007-10-06	2007-10-06 00:00:00	\N	38000177		0	0	0		0	0	0	154601	0	857005	40162522		
9174	762	1115171	2007-04-28	2007-04-28 00:00:00	2007-05-12	2007-05-12 00:00:00	2007-05-12	38000177		0	0	14		0	0	0	50731	0	849574	1115171		
26537	2184	19073188	2004-03-21	2004-03-21 00:00:00	2004-04-18	2004-04-18 00:00:00	2004-04-18	38000177		0	0	28		0	0	0	145590	0	308192	19073188		
26619	2192	1127433	1972-04-23	1972-04-23 00:00:00	1972-04-30	1972-04-30 00:00:00	1972-04-30	38000177		0	0	7		0	0	0	146207	0	313782	1127433		
37103	3067	46275916	1960-12-20	1960-12-20 00:00:00	1960-12-20	1960-12-20 00:00:00	1960-12-20	38000177		0	0	0		0	0	0	204175	0	1660014	46275916		
37188	3074	40220960	1993-11-10	1993-11-10 00:00:00	1993-11-10	1993-11-10 00:00:00	1993-11-10	38000177		0	0	0		0	0	0	204591	0	1804799	40220960		
22012	1808	1124300	2003-12-18	2003-12-18 00:00:00	2003-12-18	2003-12-18 00:00:00	\N	38000177		0	0	0		0	0	0	121056	0	00781178901	45011828		
37263	3080	19006318	1946-06-09	1946-06-09 00:00:00	1946-06-23	1946-06-23 00:00:00	1946-06-23	38000177		0	0	14		0	0	0	205021	0	105078	19006318		
32554	2699	40236824	2008-12-07	2008-12-07 00:00:00	2008-12-14	2008-12-14 00:00:00	2008-12-14	38000177		0	0	7		0	0	0	178721	0	1094107	40236824		
32632	2705	19059056	1965-09-27	1965-09-27 00:00:00	1965-10-25	1965-10-25 00:00:00	1965-10-25	38000177		0	0	28		0	0	0	179242	0	243670	19059056		
49447	4102	19128065	1984-02-21	1984-02-21 00:00:00	1985-02-15	1985-02-15 00:00:00	1985-02-15	38000177		0	0	360		0	0	0	272595	0	749882	19128065		
47929	3973	19018935	2018-08-30	2018-08-30 00:00:00	2018-08-30	2018-08-30 00:00:00	\N	38000177		0	0	0		0	0	0	264215	0	197604	19018935		
131810	2896	40213227	2011-04-03	2011-04-03 00:00:00	2011-04-03	2011-04-03 00:00:00	2011-04-03	581452		0	0	0		0	0	0	192771	0	113	40213227		
97024	2127	40213296	2003-03-08	2003-03-08 00:00:00	2003-03-08	2003-03-08 00:00:00	2003-03-08	581452		0	0	0		0	0	0	141475	0	52	40213296		
27733	2294	19059056	1961-11-20	1961-11-20 00:00:00	1961-12-11	1961-12-11 00:00:00	1961-12-11	38000177		0	0	21		0	0	0	152747	0	243670	19059056		
27771	2298	40229134	1982-03-11	1982-03-11 00:00:00	1982-03-18	1982-03-18 00:00:00	1982-03-18	38000177		0	0	7		0	0	0	153004	0	1043400	40229134		
20359	1672	1127433	2001-08-17	2001-08-17 00:00:00	2001-08-31	2001-08-31 00:00:00	2001-08-31	38000177		0	0	14		0	0	0	112243	0	313782	1127433		
13837	1155	1127433	1974-02-19	1974-02-19 00:00:00	1974-03-05	1974-03-05 00:00:00	1974-03-05	38000177		0	0	14		0	0	0	76325	0	313782	1127433		
37601	3109	19059056	1921-06-13	1921-06-13 00:00:00	1921-06-27	1921-06-27 00:00:00	1921-06-27	38000177		0	0	14		0	0	0	206760	0	243670	19059056		
8836	738	1127433	1978-08-04	1978-08-04 00:00:00	1978-08-18	1978-08-18 00:00:00	1978-08-18	38000177		0	0	14		0	0	0	48864	0	313782	1127433		
42373	3514	19128022	1993-07-20	1993-07-20 00:00:00	1994-07-15	1994-07-15 00:00:00	1994-07-15	38000177		0	0	360		0	0	0	233198	0	749785	19128022		
7302	610	920300	2015-10-25	2015-10-25 00:00:00	2015-11-01	2015-11-01 00:00:00	2015-11-01	38000177		0	0	7		0	0	0	40615	0	311989	920300		
236709	5197	40213227	1994-11-08	1994-11-08 00:00:00	1994-11-08	1994-11-08 00:00:00	1994-11-08	581452		0	0	0		0	0	0	345591	0	113	40213227		
4086	338	1713671	2014-02-18	2014-02-18 00:00:00	2014-02-25	2014-02-25 00:00:00	2014-02-25	38000177		0	0	7		0	0	0	22584	0	562251	1713671		
37923	3134	19018935	2007-02-15	2007-02-15 00:00:00	2007-02-15	2007-02-15 00:00:00	\N	38000177		0	0	0		0	0	0	208597	0	197604	19018935		
3149	260	46233988	1971-03-15	1971-03-15 00:00:00	1971-03-29	1971-03-29 00:00:00	1971-03-29	38000177		0	0	14		0	0	0	17183	0	1652673	46233988		
36252	2987	40165015	1989-01-28	1989-01-28 00:00:00	1989-01-28	1989-01-28 00:00:00	\N	38000177		0	0	0		0	0	0	199423	0	861467	40165015		
43422	3601	1127433	1971-05-18	1971-05-18 00:00:00	1971-05-25	1971-05-25 00:00:00	1971-05-25	38000177		0	0	7		0	0	0	239149	0	313782	1127433		
45700	3784	40236824	1948-08-08	1948-08-08 00:00:00	1948-08-15	1948-08-15 00:00:00	1948-08-15	38000177		0	0	7		0	0	0	251453	0	1094107	40236824		
46862	3881	19059056	1960-06-30	1960-06-30 00:00:00	1960-07-14	1960-07-14 00:00:00	1960-07-14	38000177		0	0	14		0	0	0	257917	0	243670	19059056		
39132	3234	1332419	1994-08-02	1994-08-02 00:00:00	1994-08-02	1994-08-02 00:00:00	\N	38000177		0	0	0		0	0	0	214965	0	197361	1332419		
224458	4927	40213251	1984-07-13	1984-07-13 00:00:00	1984-07-13	1984-07-13 00:00:00	1984-07-13	581452		0	0	0		0	0	0	327509	0	21	40213251		
21867	1793	19059056	1942-01-28	1942-01-28 00:00:00	1942-02-11	1942-02-11 00:00:00	1942-02-11	38000177		0	0	14		0	0	0	120216	0	243670	19059056		
49716	4123	19059056	1965-07-04	1965-07-04 00:00:00	1965-07-25	1965-07-25 00:00:00	1965-07-25	38000177		0	0	21		0	0	0	274113	0	243670	19059056		
52358	4355	19078461	2013-05-14	2013-05-14 00:00:00	2013-05-28	2013-05-28 00:00:00	2013-05-28	38000177		0	0	14		0	0	0	288963	0	310965	19078461		
49797	4131	19133873	1985-04-26	1985-04-26 00:00:00	1985-05-05	1985-05-05 00:00:00	1985-05-05	38000177		0	0	9		0	0	0	274712	0	834061	19133873		
42577	3530	1713671	1982-05-01	1982-05-01 00:00:00	1982-05-08	1982-05-08 00:00:00	1982-05-08	38000177		0	0	7		0	0	0	234488	0	562251	1713671		
3351	277	40229134	1986-11-20	1986-11-20 00:00:00	1986-11-27	1986-11-27 00:00:00	1986-11-27	38000177		0	0	7		0	0	0	18458	0	1043400	40229134		
20776	1713	920300	2004-10-26	2004-10-26 00:00:00	2004-11-02	2004-11-02 00:00:00	2004-11-02	38000177		0	0	7		0	0	0	114465	0	311989	920300		
11478	246	40213260	2010-04-29	2010-04-29 00:00:00	2010-04-29	2010-04-29 00:00:00	2010-04-29	581452		0	0	0		0	0	0	16514	0	121	40213260		
2003	159	1127433	1984-04-05	1984-04-05 00:00:00	1984-06-04	1984-06-04 00:00:00	1984-06-04	38000177		0	0	60		0	0	0	10921	0	313782	1127433		
51890	4313	1713671	1990-05-26	1990-05-26 00:00:00	1990-06-02	1990-06-02 00:00:00	1990-06-02	38000177		0	0	7		0	0	0	286314	0	562251	1713671		
8336	695	1713671	2016-11-03	2016-11-03 00:00:00	2016-11-10	2016-11-10 00:00:00	2016-11-10	38000177		0	0	7		0	0	0	46032	0	562251	1713671		
62470	5197	46275444	1962-06-06	1962-06-06 00:00:00	1962-06-06	1962-06-06 00:00:00	1962-06-06	38000177		0	0	0		0	0	0	345571	0	1659149	46275444		
18030	1493	19075601	2016-03-08	2016-03-08 00:00:00	2016-03-08	2016-03-08 00:00:00	2016-03-08	38000177		0	0	0		0	0	0	99518	0	309362	19075601		
16354	352	40213296	2017-07-24	2017-07-24 00:00:00	2017-07-24	2017-07-24 00:00:00	2017-07-24	581452		0	0	0		0	0	0	23470	0	52	40213296		
3921	326	19133873	1979-09-23	1979-09-23 00:00:00	1979-10-06	1979-10-06 00:00:00	1979-10-06	38000177		0	0	13		0	0	0	21553	0	834061	19133873		
92693	2034	40213201	1989-08-09	1989-08-09 00:00:00	1989-08-09	1989-08-09 00:00:00	1989-08-09	581452		0	0	0		0	0	0	135513	0	33	40213201		
33806	2798	19128065	1979-08-06	1979-08-06 00:00:00	1980-07-31	1980-07-31 00:00:00	1980-07-31	38000177		0	0	360		0	0	0	185414	0	749882	19128065		
26177	2152	1332419	1994-04-02	1994-04-02 00:00:00	1994-04-02	1994-04-02 00:00:00	\N	38000177		0	0	0		0	0	0	143446	0	197361	1332419		
50074	4156	1713671	1966-04-09	1966-04-09 00:00:00	1966-04-30	1966-04-30 00:00:00	1966-04-30	38000177		0	0	21		0	0	0	276161	0	562251	1713671		
1479	116	40229134	1952-11-22	1952-11-22 00:00:00	1952-12-06	1952-12-06 00:00:00	1952-12-06	38000177		0	0	14		0	0	0	7656	0	1043400	40229134		
11977	1000	19129655	1965-01-02	1965-01-02 00:00:00	1965-01-16	1965-01-16 00:00:00	1965-01-16	38000177		0	0	14		0	0	0	66144	0	789980	19129655		
8052	673	1118084	1995-12-03	1995-12-03 00:00:00	1995-12-03	1995-12-03 00:00:00	\N	38000177		0	0	0		0	0	0	44486	0	00025152531	44923712		
40283	3337	1713671	1981-02-13	1981-02-13 00:00:00	1981-03-06	1981-03-06 00:00:00	1981-03-06	38000177		0	0	21		0	0	0	221388	0	562251	1713671		
22917	1885	1713671	2013-03-30	2013-03-30 00:00:00	2013-04-13	2013-04-13 00:00:00	2013-04-13	38000177		0	0	14		0	0	0	125721	0	562251	1713671		
13558	293	40213160	1965-01-19	1965-01-19 00:00:00	1965-01-19	1965-01-19 00:00:00	1965-01-19	581452		0	0	0		0	0	0	19527	0	10	40213160		
23015	1898	1127433	2007-09-12	2007-09-12 00:00:00	2007-09-19	2007-09-19 00:00:00	2007-09-19	38000177		0	0	7		0	0	0	126344	0	313782	1127433		
60526	5035	1713671	1976-06-28	1976-06-28 00:00:00	1976-07-05	1976-07-05 00:00:00	1976-07-05	38000177		0	0	7		0	0	0	334640	0	562251	1713671		
46350	3839	19078461	2007-11-28	2007-11-28 00:00:00	2007-12-19	2007-12-19 00:00:00	2007-12-19	38000177		0	0	21		0	0	0	254862	0	310965	19078461		
8738	728	1127078	1960-11-21	1960-11-21 00:00:00	1960-12-05	1960-12-05 00:00:00	1960-12-05	38000177		0	0	14		0	0	0	48311	0	282464	1127078		
33324	2761	1118084	2017-07-04	2017-07-04 00:00:00	2017-07-04	2017-07-04 00:00:00	\N	38000177		0	0	0		0	0	0	182667	0	00025152531	44923712		
4310	357	19133873	1967-06-11	1967-06-11 00:00:00	1967-06-21	1967-06-21 00:00:00	1967-06-21	38000177		0	0	10		0	0	0	23735	0	834061	19133873		
57010	4731	1124300	2008-09-08	2008-09-08 00:00:00	2008-09-08	2008-09-08 00:00:00	\N	38000177		0	0	0		0	0	0	315224	0	00781178901	45011828		
28088	2325	40236824	2014-11-15	2014-11-15 00:00:00	2014-11-29	2014-11-29 00:00:00	2014-11-29	38000177		0	0	14		0	0	0	154605	0	1094107	40236824		
9175	762	19059056	1955-08-08	1955-08-08 00:00:00	1955-08-29	1955-08-29 00:00:00	1955-08-29	38000177		0	0	21		0	0	0	50730	0	243670	19059056		
26538	2184	1127433	1987-01-02	1987-01-02 00:00:00	1987-01-09	1987-01-09 00:00:00	1987-01-09	38000177		0	0	7		0	0	0	145525	0	313782	1127433		
26621	2192	19128065	1983-10-05	1983-10-05 00:00:00	1984-09-29	1984-09-29 00:00:00	1984-09-29	38000177		0	0	360		0	0	0	146184	0	749882	19128065		
37104	3067	40243436	1960-12-20	1960-12-20 00:00:00	1960-12-20	1960-12-20 00:00:00	1960-12-20	38000177		0	0	0		0	0	0	204175	0	1190795	40243436		
37189	3074	19059056	1953-12-20	1953-12-20 00:00:00	1954-01-03	1954-01-03 00:00:00	1954-01-03	38000177		0	0	14		0	0	0	204541	0	243670	19059056		
22013	1808	19073188	1979-04-18	1979-04-18 00:00:00	1979-05-02	1979-05-02 00:00:00	1979-05-02	38000177		0	0	14		0	0	0	121021	0	308192	19073188		
37264	3080	1127433	1959-11-05	1959-11-05 00:00:00	1959-11-19	1959-11-19 00:00:00	1959-11-19	38000177		0	0	14		0	0	0	205058	0	313782	1127433		
32555	2699	40229134	1980-11-18	1980-11-18 00:00:00	1980-11-25	1980-11-25 00:00:00	1980-11-25	38000177		0	0	7		0	0	0	178717	0	1043400	40229134		
32633	2705	1124300	1978-03-13	1978-03-13 00:00:00	1978-03-13	1978-03-13 00:00:00	\N	38000177		0	0	0		0	0	0	179210	0	00781178901	45011828		
49449	4102	19128065	1988-01-31	1988-01-31 00:00:00	1989-01-25	1989-01-25 00:00:00	1989-01-25	38000177		0	0	360		0	0	0	272599	0	749882	19128065		
47930	3973	40163554	2018-08-30	2018-08-30 00:00:00	2018-08-30	2018-08-30 00:00:00	\N	38000177		0	0	0		0	0	0	264215	0	855332	40163554		
131825	2896	40213160	1969-06-29	1969-06-29 00:00:00	1969-06-29	1969-06-29 00:00:00	1969-06-29	581452		0	0	0		0	0	0	192806	0	10	40213160		
97026	2127	40213227	2003-03-08	2003-03-08 00:00:00	2003-03-08	2003-03-08 00:00:00	2003-03-08	581452		0	0	0		0	0	0	141475	0	113	40213227		
27734	2294	1127078	1972-01-22	1972-01-22 00:00:00	1972-02-05	1972-02-05 00:00:00	1972-02-05	38000177		0	0	14		0	0	0	152722	0	282464	1127078		
27772	2298	1118084	2006-01-03	2006-01-03 00:00:00	2006-01-03	2006-01-03 00:00:00	\N	38000177		0	0	0		0	0	0	152981	0	00025152531	44923712		
20360	1672	19006318	1955-11-04	1955-11-04 00:00:00	1955-11-18	1955-11-18 00:00:00	1955-11-18	38000177		0	0	14		0	0	0	112259	0	105078	19006318		
98631	2160	40213260	2012-01-23	2012-01-23 00:00:00	2012-01-23	2012-01-23 00:00:00	2012-01-23	581452		0	0	0		0	0	0	143926	0	121	40213260		
37602	3109	1713671	1985-03-24	1985-03-24 00:00:00	1985-07-14	1985-07-14 00:00:00	1985-07-14	38000177		0	0	112		0	0	0	206751	0	562251	1713671		
8837	738	19019979	1981-08-17	1981-08-17 00:00:00	1981-08-31	1981-08-31 00:00:00	1981-08-31	38000177		0	0	14		0	0	0	48902	0	198405	19019979		
42374	3514	19128022	1991-07-31	1991-07-31 00:00:00	1992-07-25	1992-07-25 00:00:00	1992-07-25	38000177		0	0	360		0	0	0	233197	0	749785	19128022		
7303	610	1127078	1963-08-25	1963-08-25 00:00:00	1963-09-08	1963-09-08 00:00:00	1963-09-08	38000177		0	0	14		0	0	0	40587	0	282464	1127078		
236715	5197	40213260	2006-12-19	2006-12-19 00:00:00	2006-12-19	2006-12-19 00:00:00	2006-12-19	581452		0	0	0		0	0	0	345601	0	121	40213260		
4087	338	40229134	2003-10-21	2003-10-21 00:00:00	2003-11-04	2003-11-04 00:00:00	2003-11-04	38000177		0	0	14		0	0	0	22541	0	1043400	40229134		
37924	3134	40163554	2007-02-15	2007-02-15 00:00:00	2007-02-15	2007-02-15 00:00:00	\N	38000177		0	0	0		0	0	0	208597	0	855332	40163554		
3150	260	40165015	1990-08-17	1990-08-17 00:00:00	1990-08-17	1990-08-17 00:00:00	\N	38000177		0	0	0		0	0	0	17174	0	861467	40165015		
36253	2987	1127433	1989-01-28	1989-01-28 00:00:00	1989-02-27	1989-02-27 00:00:00	1989-02-27	38000177		0	0	30		0	0	0	199423	0	313782	1127433		
43423	3601	1127433	2011-08-26	2011-08-26 00:00:00	2011-09-09	2011-09-09 00:00:00	2011-09-09	38000177		0	0	14		0	0	0	239251	0	313782	1127433		
45701	3784	920300	1948-08-08	1948-08-08 00:00:00	1948-08-15	1948-08-15 00:00:00	1948-08-15	38000177		0	0	7		0	0	0	251453	0	311989	920300		
46863	3881	1127433	1998-01-13	1998-01-13 00:00:00	1998-01-20	1998-01-20 00:00:00	1998-01-20	38000177		0	0	7		0	0	0	257947	0	313782	1127433		
39133	3234	19059056	1952-12-16	1952-12-16 00:00:00	1952-12-30	1952-12-30 00:00:00	1952-12-30	38000177		0	0	14		0	0	0	214933	0	243670	19059056		
224463	4927	40213296	2018-06-15	2018-06-15 00:00:00	2018-06-15	2018-06-15 00:00:00	2018-06-15	581452		0	0	0		0	0	0	327513	0	52	40213296		
21868	1793	1127433	2002-10-14	2002-10-14 00:00:00	2002-10-28	2002-10-28 00:00:00	2002-10-28	38000177		0	0	14		0	0	0	120251	0	313782	1127433		
49717	4123	19059056	1976-12-24	1976-12-24 00:00:00	1977-01-14	1977-01-14 00:00:00	1977-01-14	38000177		0	0	21		0	0	0	274115	0	243670	19059056		
52359	4355	19059056	1983-12-16	1983-12-16 00:00:00	1983-12-30	1983-12-30 00:00:00	1983-12-30	38000177		0	0	14		0	0	0	288969	0	243670	19059056		
49798	4131	1127433	1989-09-22	1989-09-22 00:00:00	1989-09-29	1989-09-29 00:00:00	1989-09-29	38000177		0	0	7		0	0	0	274713	0	313782	1127433		
42578	3530	46275916	2003-01-03	2003-01-03 00:00:00	2003-01-03	2003-01-03 00:00:00	2003-01-03	38000177		0	0	0		0	0	0	234457	0	1660014	46275916		
3352	277	1124300	2001-01-05	2001-01-05 00:00:00	2001-01-05	2001-01-05 00:00:00	\N	38000177		0	0	0		0	0	0	18462	0	00781178901	45011828		
20778	1713	19133905	2010-10-20	2010-10-20 00:00:00	2010-10-29	2010-10-29 00:00:00	2010-10-29	38000177		0	0	9		0	0	0	114496	0	834102	19133905		
11480	246	40213227	2011-05-05	2011-05-05 00:00:00	2011-05-05	2011-05-05 00:00:00	2011-05-05	581452		0	0	0		0	0	0	16568	0	113	40213227		
2004	159	1127078	1959-07-09	1959-07-09 00:00:00	1959-07-23	1959-07-23 00:00:00	1959-07-23	38000177		0	0	14		0	0	0	10865	0	282464	1127078		
51891	4313	19059056	1958-09-10	1958-09-10 00:00:00	1958-10-01	1958-10-01 00:00:00	1958-10-01	38000177		0	0	21		0	0	0	286271	0	243670	19059056		
8351	697	1127433	1995-12-10	1995-12-10 00:00:00	1995-12-17	1995-12-17 00:00:00	1995-12-17	38000177		0	0	7		0	0	0	46126	0	313782	1127433		
62471	5197	35605858	1962-06-05	1962-06-05 00:00:00	1962-06-06	1962-06-06 00:00:00	1962-06-06	38000177		0	0	1		0	0	0	345571	0	1732136	35605858		
18031	1493	40220960	2016-03-08	2016-03-08 00:00:00	2016-03-08	2016-03-08 00:00:00	2016-03-08	38000177		0	0	0		0	0	0	99518	0	1804799	40220960		
62531	5201	42902245	2000-02-19	2000-02-19 00:00:00	2001-02-13	2001-02-13 00:00:00	2001-02-13	38000177		0	0	360		0	0	0	345957	0	1359133	42902245		
3922	326	19133873	1972-02-22	1972-02-22 00:00:00	1972-02-29	1972-02-29 00:00:00	1972-02-29	38000177		0	0	7		0	0	0	21542	0	834061	19133873		
33799	2798	1127433	2005-09-27	2005-09-27 00:00:00	2005-10-04	2005-10-04 00:00:00	2005-10-04	38000177		0	0	7		0	0	0	185446	0	313782	1127433		
33807	2798	920334	1999-12-19	1999-12-19 00:00:00	1999-12-26	1999-12-26 00:00:00	1999-12-26	38000177		0	0	7		0	0	0	185404	0	311995	920334		
26178	2152	19133873	1936-06-28	1936-06-28 00:00:00	1936-07-05	1936-07-05 00:00:00	1936-07-05	38000177		0	0	7		0	0	0	143421	0	834061	19133873		
50075	4156	40229134	1992-04-19	1992-04-19 00:00:00	1992-04-26	1992-04-26 00:00:00	1992-04-26	38000177		0	0	7		0	0	0	276171	0	1043400	40229134		
1480	117	1713671	1970-04-06	1970-04-06 00:00:00	1970-04-20	1970-04-20 00:00:00	1970-04-20	38000177		0	0	14		0	0	0	7801	0	562251	1713671		
11978	1000	19078461	1995-02-08	1995-02-08 00:00:00	1995-03-08	1995-03-08 00:00:00	1995-03-08	38000177		0	0	28		0	0	0	66140	0	310965	19078461		
8053	673	1154615	1964-09-28	1964-09-28 00:00:00	1964-09-28	1964-09-28 00:00:00	\N	38000177		0	0	0		0	0	0	44480	0	745679	1154615		
40284	3337	1127078	1977-08-26	1977-08-26 00:00:00	1977-09-25	1977-09-25 00:00:00	1977-09-25	38000177		0	0	30		0	0	0	221350	0	282464	1127078		
22918	1885	19128022	1990-02-08	1990-02-08 00:00:00	1991-02-03	1991-02-03 00:00:00	1991-02-03	38000177		0	0	360		0	0	0	125725	0	749785	19128022		
13562	293	40213306	1987-09-08	1987-09-08 00:00:00	1987-09-08	1987-09-08 00:00:00	1987-09-08	581452		0	0	0		0	0	0	19477	0	43	40213306		
23016	1898	1118084	2011-08-14	2011-08-14 00:00:00	2011-08-14	2011-08-14 00:00:00	\N	38000177		0	0	0		0	0	0	126372	0	00025152531	44923712		
60527	5035	1127433	1976-07-21	1976-07-21 00:00:00	1976-08-04	1976-08-04 00:00:00	1976-08-04	38000177		0	0	14		0	0	0	334619	0	313782	1127433		
46351	3839	19059056	1972-08-03	1972-08-03 00:00:00	1972-10-02	1972-10-02 00:00:00	1972-10-02	38000177		0	0	60		0	0	0	254861	0	243670	19059056		
8739	728	1124300	1990-03-04	1990-03-04 00:00:00	1990-03-04	1990-03-04 00:00:00	\N	38000177		0	0	0		0	0	0	48281	0	00781178901	45011828		
33325	2761	40229134	1982-09-08	1982-09-08 00:00:00	1982-09-15	1982-09-15 00:00:00	1982-09-15	38000177		0	0	7		0	0	0	182646	0	1043400	40229134		
4311	357	1713671	1983-10-09	1983-10-09 00:00:00	1984-01-08	1984-01-08 00:00:00	1984-01-08	38000177		0	0	91		0	0	0	23665	0	562251	1713671		
57011	4731	19019979	1975-01-15	1975-01-15 00:00:00	1975-01-29	1975-01-29 00:00:00	1975-01-29	38000177		0	0	14		0	0	0	315239	0	198405	19019979		
28089	2325	920300	2014-11-15	2014-11-15 00:00:00	2014-11-22	2014-11-22 00:00:00	2014-11-22	38000177		0	0	7		0	0	0	154605	0	311989	920300		
9176	762	40229134	1996-12-31	1996-12-31 00:00:00	1997-01-07	1997-01-07 00:00:00	1997-01-07	38000177		0	0	7		0	0	0	50658	0	1043400	40229134		
26539	2184	19078461	2019-05-30	2019-05-30 00:00:00	2019-05-30	2019-05-30 00:00:00	\N	38000177		0	0	0		0	0	0	145593	0	310965	19078461		
26622	2192	1127433	2000-05-01	2000-05-01 00:00:00	2000-05-08	2000-05-08 00:00:00	2000-05-08	38000177		0	0	7		0	0	0	146229	0	313782	1127433		
37105	3067	40229134	2018-07-13	2018-07-13 00:00:00	2018-07-20	2018-07-20 00:00:00	2018-07-20	38000177		0	0	7		0	0	0	204104	0	1043400	40229134		
37190	3074	1127433	1996-03-24	1996-03-24 00:00:00	1996-04-07	1996-04-07 00:00:00	1996-04-07	38000177		0	0	14		0	0	0	204542	0	313782	1127433		
22014	1808	1127433	1979-04-18	1979-04-18 00:00:00	1979-05-02	1979-05-02 00:00:00	1979-05-02	38000177		0	0	14		0	0	0	121021	0	313782	1127433		
37265	3080	1115171	2002-07-16	2002-07-16 00:00:00	2002-08-06	2002-08-06 00:00:00	2002-08-06	38000177		0	0	21		0	0	0	205009	0	849574	1115171		
32556	2699	19019979	1976-07-02	1976-07-02 00:00:00	1976-07-23	1976-07-23 00:00:00	1976-07-23	38000177		0	0	21		0	0	0	178710	0	198405	19019979		
32634	2705	1127433	2011-11-24	2011-11-24 00:00:00	2011-12-08	2011-12-08 00:00:00	2011-12-08	38000177		0	0	14		0	0	0	179224	0	313782	1127433		
49450	4102	19019273	1997-03-14	1997-03-14 00:00:00	2001-12-18	2001-12-18 00:00:00	2001-12-18	38000177		0	0	1740		0	0	0	272558	0	198014	19019273		
47931	3973	40171902	2018-08-30	2018-08-30 00:00:00	2018-08-30	2018-08-30 00:00:00	\N	38000177		0	0	0		0	0	0	264215	0	897718	40171902		
131826	2896	40213227	1992-02-16	1992-02-16 00:00:00	1992-02-16	1992-02-16 00:00:00	1992-02-16	581452		0	0	0		0	0	0	192849	0	113	40213227		
108023	2367	40213296	2017-10-24	2017-10-24 00:00:00	2017-10-24	2017-10-24 00:00:00	2017-10-24	581452		0	0	0		0	0	0	157563	0	52	40213296		
27735	2294	46233988	1972-01-22	1972-01-22 00:00:00	1972-02-05	1972-02-05 00:00:00	1972-02-05	38000177		0	0	14		0	0	0	152722	0	1652673	46233988		
58529	4859	35605858	1971-06-05	1971-06-05 00:00:00	1971-06-05	1971-06-05 00:00:00	1971-06-05	38000177		0	0	0		0	0	0	323226	0	1732136	35605858		
20361	1672	1127078	1955-11-04	1955-11-04 00:00:00	1955-11-18	1955-11-18 00:00:00	1955-11-18	38000177		0	0	14		0	0	0	112259	0	282464	1127078		
98633	2160	40213227	2012-01-23	2012-01-23 00:00:00	2012-01-23	2012-01-23 00:00:00	2012-01-23	581452		0	0	0		0	0	0	143926	0	113	40213227		
37603	3109	1713671	1979-02-13	1979-02-13 00:00:00	1979-02-20	1979-02-20 00:00:00	1979-02-20	38000177		0	0	7		0	0	0	206830	0	562251	1713671		
8838	738	19074843	1981-08-17	1981-08-17 00:00:00	1981-08-31	1981-08-31 00:00:00	1981-08-31	38000177		0	0	14		0	0	0	48902	0	309045	19074843		
42375	3514	1713671	2015-12-07	2015-12-07 00:00:00	2015-12-14	2015-12-14 00:00:00	2015-12-14	38000177		0	0	7		0	0	0	233167	0	562251	1713671		
17793	1475	1127433	1993-04-29	1993-04-29 00:00:00	1993-05-13	1993-05-13 00:00:00	1993-05-13	38000177		0	0	14		0	0	0	98260	0	313782	1127433		
236717	5197	40213160	1955-09-20	1955-09-20 00:00:00	1955-09-20	1955-09-20 00:00:00	1955-09-20	581452		0	0	0		0	0	0	345616	0	10	40213160		
4088	338	19059056	1969-02-07	1969-02-07 00:00:00	1969-03-07	1969-03-07 00:00:00	1969-03-07	38000177		0	0	28		0	0	0	22597	0	243670	19059056		
37925	3135	1127433	2005-05-02	2005-05-02 00:00:00	2005-05-09	2005-05-09 00:00:00	2005-05-09	38000177		0	0	7		0	0	0	208697	0	313782	1127433		
3151	260	1115171	2015-04-08	2015-04-08 00:00:00	2015-07-07	2015-07-07 00:00:00	2015-07-07	38000177		0	0	90		0	0	0	17175	0	849574	1115171		
36254	2987	19133873	1983-02-24	1983-02-24 00:00:00	1983-03-05	1983-03-05 00:00:00	1983-03-05	38000177		0	0	9		0	0	0	199411	0	834061	19133873		
43424	3601	19059056	1974-03-02	1974-03-02 00:00:00	1974-04-06	1974-04-06 00:00:00	1974-04-06	38000177		0	0	35		0	0	0	239218	0	243670	19059056		
45702	3784	1127433	1956-07-02	1956-07-02 00:00:00	1956-07-16	1956-07-16 00:00:00	1956-07-16	38000177		0	0	14		0	0	0	251455	0	313782	1127433		
46864	3881	1127433	2013-01-03	2013-01-03 00:00:00	2013-01-10	2013-01-10 00:00:00	2013-01-10	38000177		0	0	7		0	0	0	257885	0	313782	1127433		
39134	3234	19006318	1952-12-16	1952-12-16 00:00:00	1952-12-30	1952-12-30 00:00:00	1952-12-30	38000177		0	0	14		0	0	0	214933	0	105078	19006318		
224465	4927	40213314	1978-09-29	1978-09-29 00:00:00	1978-09-29	1978-09-29 00:00:00	1978-09-29	581452		0	0	0		0	0	0	327505	0	49	40213314		
21869	1793	19078461	1991-01-05	1991-01-05 00:00:00	1991-03-06	1991-03-06 00:00:00	1991-03-06	38000177		0	0	60		0	0	0	120226	0	310965	19078461		
49718	4124	19133905	2002-06-11	2002-06-11 00:00:00	2002-06-19	2002-06-19 00:00:00	2002-06-19	38000177		0	0	8		0	0	0	274177	0	834102	19133905		
52360	4355	19074843	1983-12-16	1983-12-16 00:00:00	1983-12-30	1983-12-30 00:00:00	1983-12-30	38000177		0	0	14		0	0	0	288969	0	309045	19074843		
49799	4131	1127433	2014-09-23	2014-09-23 00:00:00	2014-09-30	2014-09-30 00:00:00	2014-09-30	38000177		0	0	7		0	0	0	274715	0	313782	1127433		
42579	3530	40243436	2003-01-03	2003-01-03 00:00:00	2003-01-03	2003-01-03 00:00:00	2003-01-03	38000177		0	0	0		0	0	0	234457	0	1190795	40243436		
3360	279	19006318	1952-08-26	1952-08-26 00:00:00	1952-09-09	1952-09-09 00:00:00	1952-09-09	38000177		0	0	14		0	0	0	18625	0	105078	19006318		
20779	1713	1127078	1972-04-03	1972-04-03 00:00:00	1972-04-17	1972-04-17 00:00:00	1972-04-17	38000177		0	0	14		0	0	0	114480	0	282464	1127078		
11481	246	40213260	2011-05-05	2011-05-05 00:00:00	2011-05-05	2011-05-05 00:00:00	2011-05-05	581452		0	0	0		0	0	0	16568	0	121	40213260		
2005	159	19006318	1959-07-09	1959-07-09 00:00:00	1959-07-23	1959-07-23 00:00:00	1959-07-23	38000177		0	0	14		0	0	0	10865	0	105078	19006318		
51892	4313	19059056	1950-01-04	1950-01-04 00:00:00	1950-01-18	1950-01-18 00:00:00	1950-01-18	38000177		0	0	14		0	0	0	286365	0	243670	19059056		
8352	697	1127433	2012-04-22	2012-04-22 00:00:00	2012-04-29	2012-04-29 00:00:00	2012-04-29	38000177		0	0	7		0	0	0	46111	0	313782	1127433		
62472	5197	19079524	1962-06-05	1962-06-05 00:00:00	1962-06-06	1962-06-06 00:00:00	1962-06-06	38000177		0	0	1		0	0	0	345571	0	313002	19079524		
18032	1493	1127433	1960-09-05	1960-09-05 00:00:00	1960-09-12	1960-09-12 00:00:00	1960-09-12	38000177		0	0	7		0	0	0	99561	0	313782	1127433		
62532	5201	19128022	1993-03-27	1993-03-27 00:00:00	1994-03-22	1994-03-22 00:00:00	1994-03-22	38000177		0	0	360		0	0	0	345976	0	749785	19128022		
3923	326	19059056	1973-03-17	1973-03-17 00:00:00	1973-03-31	1973-03-31 00:00:00	1973-03-31	38000177		0	0	14		0	0	0	21555	0	243670	19059056		
33800	2798	19059056	1958-04-18	1958-04-18 00:00:00	1958-06-17	1958-06-17 00:00:00	1958-06-17	38000177		0	0	60		0	0	0	185428	0	243670	19059056		
33809	2798	19059056	1967-11-27	1967-11-27 00:00:00	1967-12-25	1967-12-25 00:00:00	1967-12-25	38000177		0	0	28		0	0	0	185429	0	243670	19059056		
26179	2152	1127433	1922-08-12	1922-08-12 00:00:00	1922-08-19	1922-08-19 00:00:00	1922-08-19	38000177		0	0	7		0	0	0	143378	0	313782	1127433		
50076	4156	19133873	1958-10-29	1958-10-29 00:00:00	1958-11-07	1958-11-07 00:00:00	1958-11-07	38000177		0	0	9		0	0	0	276136	0	834061	19133873		
1481	117	1127433	2015-01-21	2015-01-21 00:00:00	2015-01-28	2015-01-28 00:00:00	2015-01-28	38000177		0	0	7		0	0	0	7778	0	313782	1127433		
11979	1000	19074679	2018-03-13	2018-03-13 00:00:00	2018-08-28	2018-08-28 00:00:00	2018-08-28	38000177		0	0	168		0	0	0	66165	0	308971	19074679		
8054	673	40169216	1964-09-28	1964-09-28 00:00:00	1964-09-28	1964-09-28 00:00:00	\N	38000177		0	0	0		0	0	0	44480	0	895994	40169216		
40285	3337	1127433	2019-06-10	2019-06-10 00:00:00	2019-06-17	2019-06-17 00:00:00	2019-06-17	38000177		0	0	7		0	0	0	221358	0	313782	1127433		
22948	1889	1115171	2009-04-14	2009-04-14 00:00:00	2009-05-05	2009-05-05 00:00:00	2009-05-05	38000177		0	0	21		0	0	0	125916	0	849574	1115171		
13564	293	40213227	2006-08-29	2006-08-29 00:00:00	2006-08-29	2006-08-29 00:00:00	2006-08-29	581452		0	0	0		0	0	0	19524	0	113	40213227		
23017	1898	40162522	1996-05-15	1996-05-15 00:00:00	1996-05-15	1996-05-15 00:00:00	\N	38000177		0	0	0		0	0	0	126339	0	857005	40162522		
60528	5035	1127433	1990-04-07	1990-04-07 00:00:00	1990-04-14	1990-04-14 00:00:00	1990-04-14	38000177		0	0	7		0	0	0	334591	0	313782	1127433		
46352	3839	1118084	1994-06-24	1994-06-24 00:00:00	1994-06-24	1994-06-24 00:00:00	\N	38000177		0	0	0		0	0	0	254888	0	00025152531	44923712		
8740	728	1713671	1986-06-11	1986-06-11 00:00:00	1986-06-18	1986-06-18 00:00:00	1986-06-18	38000177		0	0	7		0	0	0	48298	0	562251	1713671		
33326	2761	1713671	2007-08-14	2007-08-14 00:00:00	2007-08-21	2007-08-21 00:00:00	2007-08-21	38000177		0	0	7		0	0	0	182623	0	562251	1713671		
4312	357	19006318	1977-06-28	1977-06-28 00:00:00	1977-07-12	1977-07-12 00:00:00	1977-07-12	38000177		0	0	14		0	0	0	23675	0	105078	19006318		
57012	4731	19006318	1975-01-15	1975-01-15 00:00:00	1975-01-29	1975-01-29 00:00:00	1975-01-29	38000177		0	0	14		0	0	0	315239	0	105078	19006318		
28090	2325	1713671	1980-12-26	1980-12-26 00:00:00	1981-01-02	1981-01-02 00:00:00	1981-01-02	38000177		0	0	7		0	0	0	154585	0	562251	1713671		
9177	762	1127433	2017-01-23	2017-01-23 00:00:00	2017-01-30	2017-01-30 00:00:00	2017-01-30	38000177		0	0	7		0	0	0	50678	0	313782	1127433		
26540	2185	1127433	2018-11-23	2018-11-23 00:00:00	2018-11-30	2018-11-30 00:00:00	2018-11-30	38000177		0	0	7		0	0	0	145658	0	313782	1127433		
26623	2192	1713671	1979-06-07	1979-06-07 00:00:00	1979-09-06	1979-09-06 00:00:00	1979-09-06	38000177		0	0	91		0	0	0	146227	0	562251	1713671		
37106	3067	46275916	1965-11-23	1965-11-23 00:00:00	1965-11-23	1965-11-23 00:00:00	1965-11-23	38000177		0	0	0		0	0	0	204176	0	1660014	46275916		
37193	3076	40243436	1952-11-26	1952-11-26 00:00:00	1952-11-26	1952-11-26 00:00:00	1952-11-26	38000177		0	0	0		0	0	0	204704	0	1190795	40243436		
22015	1808	40229134	1971-08-03	1971-08-03 00:00:00	1971-08-10	1971-08-10 00:00:00	1971-08-10	38000177		0	0	7		0	0	0	121028	0	1043400	40229134		
37266	3080	19059056	1944-08-23	1944-08-23 00:00:00	1944-09-06	1944-09-06 00:00:00	1944-09-06	38000177		0	0	14		0	0	0	205020	0	243670	19059056		
32557	2699	1127433	1971-10-15	1971-10-15 00:00:00	1971-10-29	1971-10-29 00:00:00	1971-10-29	38000177		0	0	14		0	0	0	178715	0	313782	1127433		
32635	2705	1713671	1974-03-13	1974-03-13 00:00:00	1974-04-03	1974-04-03 00:00:00	1974-04-03	38000177		0	0	21		0	0	0	179195	0	562251	1713671		
49451	4102	19007333	1997-03-14	1997-03-14 00:00:00	2001-12-18	2001-12-18 00:00:00	2001-12-18	38000177		0	0	1740		0	0	0	272558	0	105586	19007333		
47932	3973	1127078	1970-05-16	1970-05-16 00:00:00	1970-05-30	1970-05-30 00:00:00	1970-05-30	38000177		0	0	14		0	0	0	264216	0	282464	1127078		
131827	2896	40213306	1992-02-16	1992-02-16 00:00:00	1992-02-16	1992-02-16 00:00:00	1992-02-16	581452		0	0	0		0	0	0	192849	0	43	40213306		
108024	2367	40213227	1996-09-10	1996-09-10 00:00:00	1996-09-10	1996-09-10 00:00:00	1996-09-10	581452		0	0	0		0	0	0	157568	0	113	40213227		
27736	2295	1127078	1974-11-28	1974-11-28 00:00:00	1974-12-12	1974-12-12 00:00:00	1974-12-12	38000177		0	0	14		0	0	0	152784	0	282464	1127078		
58530	4859	46275444	1971-06-05	1971-06-05 00:00:00	1971-06-05	1971-06-05 00:00:00	1971-06-05	38000177		0	0	0		0	0	0	323226	0	1659149	46275444		
20362	1672	1127078	1962-08-01	1962-08-01 00:00:00	1962-09-05	1962-09-05 00:00:00	1962-09-05	38000177		0	0	35		0	0	0	112279	0	282464	1127078		
98642	2160	40213160	1965-06-21	1965-06-21 00:00:00	1965-06-21	1965-06-21 00:00:00	1965-06-21	581452		0	0	0		0	0	0	143976	0	10	40213160		
37604	3109	1118084	1953-10-16	1953-10-16 00:00:00	1953-10-16	1953-10-16 00:00:00	\N	38000177		0	0	0		0	0	0	206843	0	00025152531	44923712		
8839	738	1118084	2014-01-11	2014-01-11 00:00:00	2014-01-11	2014-01-11 00:00:00	\N	38000177		0	0	0		0	0	0	48880	0	00025152531	44923712		
42376	3514	1127433	1981-06-14	1981-06-14 00:00:00	1981-06-21	1981-06-21 00:00:00	1981-06-21	38000177		0	0	7		0	0	0	233184	0	313782	1127433		
17794	1475	1713671	1997-12-12	1997-12-12 00:00:00	1997-12-19	1997-12-19 00:00:00	1997-12-19	38000177		0	0	7		0	0	0	98222	0	562251	1713671		
236723	5197	40213227	2004-12-07	2004-12-07 00:00:00	2004-12-07	2004-12-07 00:00:00	2004-12-07	581452		0	0	0		0	0	0	345624	0	113	40213227		
4089	338	40229134	2008-11-01	2008-11-01 00:00:00	2008-11-15	2008-11-15 00:00:00	2008-11-15	38000177		0	0	14		0	0	0	22543	0	1043400	40229134		
37926	3135	1118084	2005-10-13	2005-10-13 00:00:00	2005-10-13	2005-10-13 00:00:00	\N	38000177		0	0	0		0	0	0	208719	0	00025152531	44923712		
3152	260	1127078	1974-03-05	1974-03-05 00:00:00	1974-03-19	1974-03-19 00:00:00	1974-03-19	38000177		0	0	14		0	0	0	17184	0	282464	1127078		
36255	2987	40229134	1995-07-16	1995-07-16 00:00:00	1995-07-30	1995-07-30 00:00:00	1995-07-30	38000177		0	0	14		0	0	0	199394	0	1043400	40229134		
43425	3601	19128065	1976-05-30	1976-05-30 00:00:00	1977-05-25	1977-05-25 00:00:00	1977-05-25	38000177		0	0	360		0	0	0	239254	0	749882	19128065		
45703	3784	19059056	1931-01-04	1931-01-04 00:00:00	1931-01-18	1931-01-18 00:00:00	1931-01-18	38000177		0	0	14		0	0	0	251512	0	243670	19059056		
46865	3881	19133873	1958-07-14	1958-07-14 00:00:00	1958-07-25	1958-07-25 00:00:00	1958-07-25	38000177		0	0	11		0	0	0	257943	0	834061	19133873		
35529	775	40213227	1992-10-21	1992-10-21 00:00:00	1992-10-21	1992-10-21 00:00:00	1992-10-21	581452		0	0	0		0	0	0	51481	0	113	40213227		
41911	3470	40229134	2008-12-20	2008-12-20 00:00:00	2008-12-27	2008-12-27 00:00:00	2008-12-27	38000177		0	0	7		0	0	0	230351	0	1043400	40229134		
21870	1793	1713671	1991-01-05	1991-01-05 00:00:00	1991-01-12	1991-01-12 00:00:00	1991-01-12	38000177		0	0	7		0	0	0	120266	0	562251	1713671		
49719	4124	1124300	2014-03-01	2014-03-01 00:00:00	2014-03-01	2014-03-01 00:00:00	\N	38000177		0	0	0		0	0	0	274203	0	00781178901	45011828		
52361	4355	1127433	2017-05-07	2017-05-07 00:00:00	2017-05-28	2017-05-28 00:00:00	2017-05-28	38000177		0	0	21		0	0	0	288964	0	313782	1127433		
49800	4131	1127433	1988-06-09	1988-06-09 00:00:00	1988-06-23	1988-06-23 00:00:00	1988-06-23	38000177		0	0	14		0	0	0	274683	0	313782	1127433		
42580	3530	1310034	2003-01-03	2003-01-03 00:00:00	2003-01-03	2003-01-03 00:00:00	2003-01-03	38000177		0	0	0		0	0	0	234457	0	834357	1310034		
3361	279	19059056	1952-08-26	1952-08-26 00:00:00	1952-09-09	1952-09-09 00:00:00	1952-09-09	38000177		0	0	14		0	0	0	18625	0	243670	19059056		
20780	1713	19078461	2009-06-09	2009-06-09 00:00:00	2009-06-23	2009-06-23 00:00:00	2009-06-23	38000177		0	0	14		0	0	0	114455	0	310965	19078461		
11483	246	40213227	1992-08-27	1992-08-27 00:00:00	1992-08-27	1992-08-27 00:00:00	1992-08-27	581452		0	0	0		0	0	0	16563	0	113	40213227		
2006	159	19059056	1962-04-07	1962-04-07 00:00:00	1962-04-28	1962-04-28 00:00:00	1962-04-28	38000177		0	0	21		0	0	0	10918	0	243670	19059056		
51893	4313	19006318	1950-01-04	1950-01-04 00:00:00	1950-01-18	1950-01-18 00:00:00	1950-01-18	38000177		0	0	14		0	0	0	286365	0	105078	19006318		
8353	697	1127433	2016-06-24	2016-06-24 00:00:00	2016-07-08	2016-07-08 00:00:00	2016-07-08	38000177		0	0	14		0	0	0	46124	0	313782	1127433		
62474	5197	1127433	1964-08-24	1964-08-24 00:00:00	1964-09-07	1964-09-07 00:00:00	1964-09-07	38000177		0	0	14		0	0	0	345579	0	313782	1127433		
18033	1493	1115171	1994-04-09	1994-04-09 00:00:00	1994-04-23	1994-04-23 00:00:00	1994-04-23	38000177		0	0	14		0	0	0	99576	0	849574	1115171		
62533	5201	19128022	1996-03-11	1996-03-11 00:00:00	1997-03-06	1997-03-06 00:00:00	1997-03-06	38000177		0	0	360		0	0	0	345956	0	749785	19128022		
3924	326	19129655	1973-03-17	1973-03-17 00:00:00	1973-03-31	1973-03-31 00:00:00	1973-03-31	38000177		0	0	14		0	0	0	21555	0	789980	19129655		
33801	2798	1127433	1963-06-23	1963-06-23 00:00:00	1963-07-07	1963-07-07 00:00:00	1963-07-07	38000177		0	0	14		0	0	0	185444	0	313782	1127433		
33811	2798	19128065	1978-08-11	1978-08-11 00:00:00	1979-08-06	1979-08-06 00:00:00	1979-08-06	38000177		0	0	360		0	0	0	185460	0	749882	19128065		
26180	2152	19059056	1949-08-02	1949-08-02 00:00:00	1949-08-16	1949-08-16 00:00:00	1949-08-16	38000177		0	0	14		0	0	0	143416	0	243670	19059056		
50077	4156	1545959	2006-02-27	2006-02-27 00:00:00	2006-02-27	2006-02-27 00:00:00	2006-02-27	38000177		0	0	0		0	0	0	276159	0	259255	1545959		
1482	117	1127433	2002-03-21	2002-03-21 00:00:00	2002-03-28	2002-03-28 00:00:00	2002-03-28	38000177		0	0	7		0	0	0	7806	0	313782	1127433		
11980	1000	1115171	2011-06-12	2011-06-12 00:00:00	2011-06-26	2011-06-26 00:00:00	2011-06-26	38000177		0	0	14		0	0	0	66141	0	849574	1115171		
8055	673	1127078	1966-06-12	1966-06-12 00:00:00	1966-06-26	1966-06-26 00:00:00	1966-06-26	38000177		0	0	14		0	0	0	44491	0	282464	1127078		
40286	3337	1127433	1982-07-03	1982-07-03 00:00:00	1982-07-17	1982-07-17 00:00:00	1982-07-17	38000177		0	0	14		0	0	0	221415	0	313782	1127433		
22949	1889	1124300	2018-04-28	2018-04-28 00:00:00	2018-04-28	2018-04-28 00:00:00	\N	38000177		0	0	0		0	0	0	125912	0	00781178901	45011828		
13565	293	40213296	2006-08-29	2006-08-29 00:00:00	2006-08-29	2006-08-29 00:00:00	2006-08-29	581452		0	0	0		0	0	0	19524	0	52	40213296		
23018	1898	19078461	1996-05-15	1996-05-15 00:00:00	1996-06-14	1996-06-14 00:00:00	1996-06-14	38000177		0	0	30		0	0	0	126339	0	310965	19078461		
60529	5035	1713671	1995-01-21	1995-01-21 00:00:00	1995-02-11	1995-02-11 00:00:00	1995-02-11	38000177		0	0	21		0	0	0	334565	0	562251	1713671		
46353	3839	1127433	1957-09-17	1957-09-17 00:00:00	1957-10-01	1957-10-01 00:00:00	1957-10-01	38000177		0	0	14		0	0	0	254870	0	313782	1127433		
8741	728	1713671	1990-08-02	1990-08-02 00:00:00	1990-08-23	1990-08-23 00:00:00	1990-08-23	38000177		0	0	21		0	0	0	48356	0	562251	1713671		
33327	2761	1713671	1989-04-20	1989-04-20 00:00:00	1989-04-27	1989-04-27 00:00:00	1989-04-27	38000177		0	0	7		0	0	0	182637	0	562251	1713671		
4313	357	19078461	1977-06-28	1977-06-28 00:00:00	1977-07-12	1977-07-12 00:00:00	1977-07-12	38000177		0	0	14		0	0	0	23675	0	310965	19078461		
57013	4731	1127433	2005-08-07	2005-08-07 00:00:00	2005-08-14	2005-08-14 00:00:00	2005-08-14	38000177		0	0	7		0	0	0	315196	0	313782	1127433		
28091	2325	1127433	2009-08-29	2009-08-29 00:00:00	2009-09-12	2009-09-12 00:00:00	2009-09-12	38000177		0	0	14		0	0	0	154621	0	313782	1127433		
9178	763	19059056	1987-06-21	1987-06-21 00:00:00	1987-07-05	1987-07-05 00:00:00	1987-07-05	38000177		0	0	14		0	0	0	50733	0	243670	19059056		
26541	2185	1127433	1982-10-26	1982-10-26 00:00:00	1982-11-08	1982-11-08 00:00:00	1982-11-08	38000177		0	0	13		0	0	0	145682	0	313782	1127433		
26624	2192	1127433	1986-07-11	1986-07-11 00:00:00	1986-07-25	1986-07-25 00:00:00	1986-07-25	38000177		0	0	14		0	0	0	146171	0	313782	1127433		
37107	3067	1310034	1965-11-23	1965-11-23 00:00:00	1965-11-23	1965-11-23 00:00:00	1965-11-23	38000177		0	0	0		0	0	0	204176	0	834357	1310034		
37194	3076	46275916	1952-11-26	1952-11-26 00:00:00	1952-11-26	1952-11-26 00:00:00	1952-11-26	38000177		0	0	0		0	0	0	204704	0	1660014	46275916		
22016	1808	1115171	1997-11-18	1997-11-18 00:00:00	1997-12-16	1997-12-16 00:00:00	1997-12-16	38000177		0	0	28		0	0	0	121086	0	849574	1115171		
37267	3080	1713671	2009-03-01	2009-03-01 00:00:00	2009-03-08	2009-03-08 00:00:00	2009-03-08	38000177		0	0	7		0	0	0	205024	0	562251	1713671		
32558	2699	1124300	2012-02-20	2012-02-20 00:00:00	2012-02-20	2012-02-20 00:00:00	\N	38000177		0	0	0		0	0	0	178702	0	00781178901	45011828		
32636	2705	1127433	2017-08-19	2017-08-19 00:00:00	2017-08-26	2017-08-26 00:00:00	2017-08-26	38000177		0	0	7		0	0	0	179225	0	313782	1127433		
49452	4102	1127433	1977-11-12	1977-11-12 00:00:00	1977-12-03	1977-12-03 00:00:00	1977-12-03	38000177		0	0	21		0	0	0	272579	0	313782	1127433		
107946	2366	40213296	2005-09-19	2005-09-19 00:00:00	2005-09-19	2005-09-19 00:00:00	2005-09-19	581452		0	0	0		0	0	0	157506	0	52	40213296		
131834	2896	40213296	2009-03-29	2009-03-29 00:00:00	2009-03-29	2009-03-29 00:00:00	2009-03-29	581452		0	0	0		0	0	0	192830	0	52	40213296		
108025	2367	40213306	1996-09-10	1996-09-10 00:00:00	1996-09-10	1996-09-10 00:00:00	1996-09-10	581452		0	0	0		0	0	0	157568	0	43	40213306		
108069	2369	40213306	2004-07-11	2004-07-11 00:00:00	2004-07-11	2004-07-11 00:00:00	2004-07-11	581452		0	0	0		0	0	0	\N	0	43	40213306		
58531	4859	19078461	2013-07-28	2013-07-28 00:00:00	2013-08-18	2013-08-18 00:00:00	2013-08-18	38000177		0	0	21		0	0	0	323228	0	310965	19078461		
20363	1672	1127433	1973-10-07	1973-10-07 00:00:00	1973-10-28	1973-10-28 00:00:00	1973-10-28	38000177		0	0	21		0	0	0	112280	0	313782	1127433		
98643	2160	40213160	1960-10-17	1960-10-17 00:00:00	1960-10-17	1960-10-17 00:00:00	1960-10-17	581452		0	0	0		0	0	0	143957	0	10	40213160		
37605	3109	40220960	1990-02-21	1990-02-21 00:00:00	1990-02-21	1990-02-21 00:00:00	1990-02-21	38000177		0	0	0		0	0	0	206724	0	1804799	40220960		
8840	738	19133873	1989-08-21	1989-08-21 00:00:00	1989-08-28	1989-08-28 00:00:00	1989-08-28	38000177		0	0	7		0	0	0	48891	0	834061	19133873		
42377	3514	19128022	1998-06-24	1998-06-24 00:00:00	1999-06-19	1999-06-19 00:00:00	1999-06-19	38000177		0	0	360		0	0	0	233169	0	749785	19128022		
17795	1475	1127433	2017-12-29	2017-12-29 00:00:00	2018-01-05	2018-01-05 00:00:00	2018-01-05	38000177		0	0	7		0	0	0	98278	0	313782	1127433		
236728	5197	40213160	1956-03-20	1956-03-20 00:00:00	1956-03-20	1956-03-20 00:00:00	1956-03-20	581452		0	0	0		0	0	0	345597	0	10	40213160		
4090	338	1127433	1974-06-13	1974-06-13 00:00:00	1974-06-20	1974-06-20 00:00:00	1974-06-20	38000177		0	0	7		0	0	0	22602	0	313782	1127433		
4134	343	19112599	1972-02-21	1972-02-21 00:00:00	1972-02-21	1972-02-21 00:00:00	\N	38000177		0	0	0		0	0	0	22852	0	477045	19112599		
3153	260	46233988	1974-03-05	1974-03-05 00:00:00	1974-03-19	1974-03-19 00:00:00	1974-03-19	38000177		0	0	14		0	0	0	17184	0	1652673	46233988		
36256	2988	1127433	2003-01-18	2003-01-18 00:00:00	2003-02-01	2003-02-01 00:00:00	2003-02-01	38000177		0	0	14		0	0	0	199428	0	313782	1127433		
43426	3601	19007333	2000-06-08	2000-06-08 00:00:00	2005-01-13	2005-01-13 00:00:00	2005-01-13	38000177		0	0	1680		0	0	0	239183	0	105586	19007333		
45704	3784	1127433	1952-08-02	1952-08-02 00:00:00	1952-08-23	1952-08-23 00:00:00	1952-08-23	38000177		0	0	21		0	0	0	251489	0	313782	1127433		
46866	3881	1115171	1998-05-31	1998-05-31 00:00:00	1998-06-21	1998-06-21 00:00:00	1998-06-21	38000177		0	0	21		0	0	0	257922	0	849574	1115171		
35542	776	40213160	1958-11-06	1958-11-06 00:00:00	1958-11-06	1958-11-06 00:00:00	1958-11-06	581452		0	0	0		0	0	0	51541	0	10	40213160		
41912	3470	40229134	1980-10-18	1980-10-18 00:00:00	1980-11-01	1980-11-01 00:00:00	1980-11-01	38000177		0	0	14		0	0	0	230322	0	1043400	40229134		
21871	1793	1713671	1936-10-11	1936-10-11 00:00:00	1936-10-25	1936-10-25 00:00:00	1936-10-25	38000177		0	0	14		0	0	0	120178	0	562251	1713671		
49720	4124	1127433	2013-03-22	2013-03-22 00:00:00	2013-03-29	2013-03-29 00:00:00	2013-03-29	38000177		0	0	7		0	0	0	274194	0	313782	1127433		
52362	4355	1713671	1999-05-29	1999-05-29 00:00:00	1999-06-12	1999-06-12 00:00:00	1999-06-12	38000177		0	0	14		0	0	0	288991	0	562251	1713671		
60274	5013	1115171	2003-04-11	2003-04-11 00:00:00	2003-04-25	2003-04-25 00:00:00	2003-04-25	38000177		0	0	14		0	0	0	333200	0	849574	1115171		
42581	3530	19059056	1968-12-02	1968-12-02 00:00:00	1968-12-23	1968-12-23 00:00:00	1968-12-23	38000177		0	0	21		0	0	0	234453	0	243670	19059056		
3362	279	1127433	1992-02-12	1992-02-12 00:00:00	1992-02-26	1992-02-26 00:00:00	1992-02-26	38000177		0	0	14		0	0	0	18639	0	313782	1127433		
20781	1713	1118084	2010-05-14	2010-05-14 00:00:00	2010-05-14	2010-05-14 00:00:00	\N	38000177		0	0	0		0	0	0	114450	0	00025152531	44923712		
25897	2130	1127433	2004-07-16	2004-07-16 00:00:00	2004-07-23	2004-07-23 00:00:00	2004-07-23	38000177		0	0	7		0	0	0	141732	0	313782	1127433		
2007	160	920300	1992-12-01	1992-12-01 00:00:00	1992-12-08	1992-12-08 00:00:00	1992-12-08	38000177		0	0	7		0	0	0	10948	0	311989	920300		
51894	4313	1713671	1975-12-12	1975-12-12 00:00:00	1976-01-02	1976-01-02 00:00:00	1976-01-02	38000177		0	0	21		0	0	0	286311	0	562251	1713671		
8354	697	19133873	1979-11-29	1979-11-29 00:00:00	1979-12-07	1979-12-07 00:00:00	1979-12-07	38000177		0	0	8		0	0	0	46120	0	834061	19133873		
20087	1649	19133873	1963-08-29	1963-08-29 00:00:00	1963-09-09	1963-09-09 00:00:00	1963-09-09	38000177		0	0	11		0	0	0	110657	0	834061	19133873		
18034	1493	19129655	1961-11-28	1961-11-28 00:00:00	1961-12-12	1961-12-12 00:00:00	1961-12-12	38000177		0	0	14		0	0	0	99568	0	789980	19129655		
62534	5201	1118084	2015-02-10	2015-02-10 00:00:00	2015-02-10	2015-02-10 00:00:00	\N	38000177		0	0	0		0	0	0	345948	0	00025152531	44923712		
3925	326	1118084	2004-03-09	2004-03-09 00:00:00	2004-03-09	2004-03-09 00:00:00	\N	38000177		0	0	0		0	0	0	21557	0	00025152531	44923712		
33802	2798	1127433	2015-05-19	2015-05-19 00:00:00	2015-06-02	2015-06-02 00:00:00	2015-06-02	38000177		0	0	14		0	0	0	185450	0	313782	1127433		
33812	2798	1127433	1977-05-25	1977-05-25 00:00:00	1977-06-08	1977-06-08 00:00:00	1977-06-08	38000177		0	0	14		0	0	0	185432	0	313782	1127433		
26181	2152	1127433	1992-07-01	1992-07-01 00:00:00	1992-07-15	1992-07-15 00:00:00	1992-07-15	38000177		0	0	14		0	0	0	143418	0	313782	1127433		
50078	4156	19133768	2006-02-27	2006-02-27 00:00:00	2006-02-27	2006-02-27 00:00:00	2006-02-27	38000177		0	0	0		0	0	0	276159	0	833036	19133768		
1483	117	1127078	1979-09-08	1979-09-08 00:00:00	1979-09-22	1979-09-22 00:00:00	1979-09-22	38000177		0	0	14		0	0	0	7781	0	282464	1127078		
11982	1000	19133905	1995-12-16	1995-12-16 00:00:00	1995-12-29	1995-12-29 00:00:00	1995-12-29	38000177		0	0	13		0	0	0	66158	0	834102	19133905		
8057	673	19128065	1983-08-08	1983-08-08 00:00:00	1984-08-02	1984-08-02 00:00:00	1984-08-02	38000177		0	0	360		0	0	0	44496	0	749882	19128065		
40287	3337	1310034	1983-12-05	1983-12-05 00:00:00	1983-12-05	1983-12-05 00:00:00	1983-12-05	38000177		0	0	0		0	0	0	221351	0	834357	1310034		
22950	1889	19078461	2015-10-31	2015-10-31 00:00:00	2015-11-21	2015-11-21 00:00:00	2015-11-21	38000177		0	0	21		0	0	0	125917	0	310965	19078461		
13571	293	40213260	2015-09-22	2015-09-22 00:00:00	2015-09-22	2015-09-22 00:00:00	2015-09-22	581452		0	0	0		0	0	0	19484	0	121	40213260		
23019	1898	19129655	1973-11-21	1973-11-21 00:00:00	1973-12-05	1973-12-05 00:00:00	1973-12-05	38000177		0	0	14		0	0	0	126400	0	789980	19129655		
60530	5035	40220960	1995-06-19	1995-06-19 00:00:00	1995-06-19	1995-06-19 00:00:00	1995-06-19	38000177		0	0	0		0	0	0	334597	0	1804799	40220960		
46354	3839	1127078	1951-10-18	1951-10-18 00:00:00	1951-12-17	1951-12-17 00:00:00	1951-12-17	38000177		0	0	60		0	0	0	254857	0	282464	1127078		
8742	728	40229134	1982-07-21	1982-07-21 00:00:00	1982-07-28	1982-07-28 00:00:00	1982-07-28	38000177		0	0	7		0	0	0	48352	0	1043400	40229134		
33328	2761	19075001	1984-09-25	1984-09-25 00:00:00	1984-10-09	1984-10-09 00:00:00	1984-10-09	38000177		0	0	14		0	0	0	182639	0	309097	19075001		
4315	357	1127078	1961-11-05	1961-11-05 00:00:00	1961-11-19	1961-11-19 00:00:00	1961-11-19	38000177		0	0	14		0	0	0	23635	0	282464	1127078		
57014	4731	1713671	1992-03-19	1992-03-19 00:00:00	1992-03-26	1992-03-26 00:00:00	1992-03-26	38000177		0	0	7		0	0	0	315212	0	562251	1713671		
28092	2325	19059056	1972-05-21	1972-05-21 00:00:00	1972-06-04	1972-06-04 00:00:00	1972-06-04	38000177		0	0	14		0	0	0	154592	0	243670	19059056		
9179	763	1127433	2000-11-17	2000-11-17 00:00:00	2000-12-01	2000-12-01 00:00:00	2000-12-01	38000177		0	0	14		0	0	0	50745	0	313782	1127433		
26542	2185	1127433	1992-09-03	1992-09-03 00:00:00	1992-10-03	1992-10-03 00:00:00	1992-10-03	38000177		0	0	30		0	0	0	145626	0	313782	1127433		
26625	2192	40229134	1997-11-15	1997-11-15 00:00:00	1997-11-29	1997-11-29 00:00:00	1997-11-29	38000177		0	0	14		0	0	0	146175	0	1043400	40229134		
37108	3067	40243436	1965-11-23	1965-11-23 00:00:00	1965-11-23	1965-11-23 00:00:00	1965-11-23	38000177		0	0	0		0	0	0	204176	0	1190795	40243436		
37195	3076	1127078	1952-05-16	1952-05-16 00:00:00	1952-05-30	1952-05-30 00:00:00	1952-05-30	38000177		0	0	14		0	0	0	204664	0	282464	1127078		
22017	1808	920300	2001-03-14	2001-03-14 00:00:00	2001-03-21	2001-03-21 00:00:00	2001-03-21	38000177		0	0	7		0	0	0	121020	0	311989	920300		
37268	3080	1127433	1980-11-29	1980-11-29 00:00:00	1980-12-06	1980-12-06 00:00:00	1980-12-06	38000177		0	0	7		0	0	0	205059	0	313782	1127433		
32559	2699	19128065	1986-11-03	1986-11-03 00:00:00	1987-10-29	1987-10-29 00:00:00	1987-10-29	38000177		0	0	360		0	0	0	178703	0	749882	19128065		
32637	2705	1127433	1980-12-16	1980-12-16 00:00:00	1980-12-23	1980-12-23 00:00:00	1980-12-23	38000177		0	0	7		0	0	0	179179	0	313782	1127433		
49453	4102	1115171	1997-09-19	1997-09-19 00:00:00	1997-10-26	1997-10-26 00:00:00	1997-10-26	38000177		0	0	37		0	0	0	272581	0	849574	1115171		
107949	2366	40213227	2016-09-19	2016-09-19 00:00:00	2016-09-19	2016-09-19 00:00:00	2016-09-19	581452		0	0	0		0	0	0	157539	0	113	40213227		
131839	2897	40213260	2010-08-14	2010-08-14 00:00:00	2010-08-14	2010-08-14 00:00:00	2010-08-14	581452		0	0	0		0	0	0	192961	0	121	40213260		
108028	2367	40213227	2006-04-11	2006-04-11 00:00:00	2006-04-11	2006-04-11 00:00:00	2006-04-11	581452		0	0	0		0	0	0	157608	0	113	40213227		
108076	2369	40213314	1981-10-11	1981-10-11 00:00:00	1981-10-11	1981-10-11 00:00:00	1981-10-11	581452		0	0	0		0	0	0	157658	0	49	40213314		
58532	4859	1127078	1958-11-30	1958-11-30 00:00:00	1958-12-14	1958-12-14 00:00:00	1958-12-14	38000177		0	0	14		0	0	0	323287	0	282464	1127078		
20364	1672	19006318	1955-08-17	1955-08-17 00:00:00	1955-08-31	1955-08-31 00:00:00	1955-08-31	38000177		0	0	14		0	0	0	112231	0	105078	19006318		
98645	2160	40213160	1961-03-20	1961-03-20 00:00:00	1961-03-20	1961-03-20 00:00:00	1961-03-20	581452		0	0	0		0	0	0	143958	0	10	40213160		
37606	3109	19133873	1928-11-18	1928-11-18 00:00:00	1928-11-27	1928-11-27 00:00:00	1928-11-27	38000177		0	0	9		0	0	0	206792	0	834061	19133873		
8841	738	1127433	1988-04-22	1988-04-22 00:00:00	1988-05-06	1988-05-06 00:00:00	1988-05-06	38000177		0	0	14		0	0	0	48887	0	313782	1127433		
42378	3514	19128022	1996-07-04	1996-07-04 00:00:00	1997-06-29	1997-06-29 00:00:00	1997-06-29	38000177		0	0	360		0	0	0	233168	0	749785	19128022		
17796	1475	1118084	1981-03-24	1981-03-24 00:00:00	1981-03-24	1981-03-24 00:00:00	\N	38000177		0	0	0		0	0	0	98233	0	00025152531	44923712		
236732	5197	40213296	1996-11-12	1996-11-12 00:00:00	1996-11-12	1996-11-12 00:00:00	1996-11-12	581452		0	0	0		0	0	0	345600	0	52	40213296		
4091	338	1118084	2001-08-03	2001-08-03 00:00:00	2001-08-03	2001-08-03 00:00:00	\N	38000177		0	0	0		0	0	0	22478	0	00025152531	44923712		
4135	343	1551192	1971-02-25	1971-02-25 00:00:00	1971-02-25	1971-02-25 00:00:00	1971-02-25	38000177		0	0	0		0	0	0	22848	0	312617	1551192		
3154	260	19078461	1986-04-28	1986-04-28 00:00:00	1986-06-02	1986-06-02 00:00:00	1986-06-02	38000177		0	0	35		0	0	0	17266	0	310965	19078461		
36257	2988	19075601	2012-06-24	2012-06-24 00:00:00	2012-06-24	2012-06-24 00:00:00	2012-06-24	38000177		0	0	0		0	0	0	199457	0	309362	19075601		
43427	3601	19019273	2000-06-08	2000-06-08 00:00:00	2005-01-13	2005-01-13 00:00:00	2005-01-13	38000177		0	0	1680		0	0	0	239183	0	198014	19019273		
45705	3784	40236824	1954-09-23	1954-09-23 00:00:00	1954-09-30	1954-09-30 00:00:00	1954-09-30	38000177		0	0	7		0	0	0	251492	0	1094107	40236824		
46867	3881	1127433	2017-04-10	2017-04-10 00:00:00	2017-04-24	2017-04-24 00:00:00	2017-04-24	38000177		0	0	14		0	0	0	257950	0	313782	1127433		
35550	776	40213160	1963-03-28	1963-03-28 00:00:00	1963-03-28	1963-03-28 00:00:00	1963-03-28	581452		0	0	0		0	0	0	51530	0	10	40213160		
41913	3470	1713671	1975-11-05	1975-11-05 00:00:00	1976-02-11	1976-02-11 00:00:00	1976-02-11	38000177		0	0	98		0	0	0	230321	0	562251	1713671		
21872	1793	1127433	1978-07-01	1978-07-01 00:00:00	1978-07-08	1978-07-08 00:00:00	1978-07-08	38000177		0	0	7		0	0	0	120241	0	313782	1127433		
49721	4124	1713671	2000-04-13	2000-04-13 00:00:00	2000-05-04	2000-05-04 00:00:00	2000-05-04	38000177		0	0	21		0	0	0	274208	0	562251	1713671		
52363	4355	40229134	1994-03-13	1994-03-13 00:00:00	1994-03-20	1994-03-20 00:00:00	1994-03-20	38000177		0	0	7		0	0	0	288988	0	1043400	40229134		
60275	5013	1127433	1990-07-26	1990-07-26 00:00:00	1990-08-09	1990-08-09 00:00:00	1990-08-09	38000177		0	0	14		0	0	0	333205	0	313782	1127433		
42582	3530	19133873	1972-09-24	1972-09-24 00:00:00	1972-10-02	1972-10-02 00:00:00	1972-10-02	38000177		0	0	8		0	0	0	234467	0	834061	19133873		
3363	279	40229134	1998-04-05	1998-04-05 00:00:00	1998-04-19	1998-04-19 00:00:00	1998-04-19	38000177		0	0	14		0	0	0	18594	0	1043400	40229134		
20782	1713	19133905	1999-07-09	1999-07-09 00:00:00	1999-07-17	1999-07-17 00:00:00	1999-07-17	38000177		0	0	8		0	0	0	114479	0	834102	19133905		
25898	2130	1127433	1987-04-14	1987-04-14 00:00:00	1987-04-28	1987-04-28 00:00:00	1987-04-28	38000177		0	0	14		0	0	0	141693	0	313782	1127433		
2008	160	40236824	1992-12-01	1992-12-01 00:00:00	1992-12-08	1992-12-08 00:00:00	1992-12-08	38000177		0	0	7		0	0	0	10948	0	1094107	40236824		
51895	4313	19133873	1954-10-12	1954-10-12 00:00:00	1954-10-19	1954-10-19 00:00:00	1954-10-19	38000177		0	0	7		0	0	0	286308	0	834061	19133873		
8355	697	40229134	1973-08-01	1973-08-01 00:00:00	1973-08-15	1973-08-15 00:00:00	1973-08-15	38000177		0	0	14		0	0	0	46125	0	1043400	40229134		
20088	1649	19126352	2007-03-14	2007-03-14 00:00:00	2017-08-23	2017-08-23 00:00:00	2017-08-23	38000177		0	0	3815		0	0	0	110625	0	705129	19126352		
18035	1493	1127078	1961-11-28	1961-11-28 00:00:00	1961-12-12	1961-12-12 00:00:00	1961-12-12	38000177		0	0	14		0	0	0	99568	0	282464	1127078		
62535	5201	19074843	1980-04-04	1980-04-04 00:00:00	1980-04-18	1980-04-18 00:00:00	1980-04-18	38000177		0	0	14		0	0	0	345955	0	309045	19074843		
3926	326	1127078	1980-01-10	1980-01-10 00:00:00	1980-04-09	1980-04-09 00:00:00	1980-04-09	38000177		0	0	90		0	0	0	21528	0	282464	1127078		
33803	2798	19075001	2015-05-19	2015-05-19 00:00:00	2015-06-02	2015-06-02 00:00:00	2015-06-02	38000177		0	0	14		0	0	0	185450	0	309097	19075001		
33813	2798	1127433	1976-07-08	1976-07-08 00:00:00	1976-07-29	1976-07-29 00:00:00	1976-07-29	38000177		0	0	21		0	0	0	185431	0	313782	1127433		
26182	2152	19059056	1933-07-13	1933-07-13 00:00:00	1933-07-27	1933-07-27 00:00:00	1933-07-27	38000177		0	0	14		0	0	0	143415	0	243670	19059056		
50079	4156	1545959	2007-12-24	2007-12-24 00:00:00	2007-12-24	2007-12-24 00:00:00	2007-12-24	38000177		0	0	0		0	0	0	276160	0	259255	1545959		
1484	117	1127433	1984-11-29	1984-11-29 00:00:00	1984-12-06	1984-12-06 00:00:00	1984-12-06	38000177		0	0	7		0	0	0	7779	0	313782	1127433		
11983	1000	1127078	1972-08-23	1972-08-23 00:00:00	1972-11-21	1972-11-21 00:00:00	1972-11-21	38000177		0	0	90		0	0	0	66137	0	282464	1127078		
8059	673	19078461	2012-05-26	2012-05-26 00:00:00	2012-06-16	2012-06-16 00:00:00	2012-06-16	38000177		0	0	21		0	0	0	44440	0	310965	19078461		
40288	3337	40243436	1983-12-05	1983-12-05 00:00:00	1983-12-05	1983-12-05 00:00:00	1983-12-05	38000177		0	0	0		0	0	0	221351	0	1190795	40243436		
40303	3339	1115171	1999-04-05	1999-04-05 00:00:00	1999-07-04	1999-07-04 00:00:00	1999-07-04	38000177		0	0	90		0	0	0	221541	0	849574	1115171		
44567	3691	1127078	1959-07-02	1959-07-02 00:00:00	1959-07-16	1959-07-16 00:00:00	1959-07-16	38000177		0	0	14		0	0	0	245350	0	282464	1127078		
23020	1898	19059056	1973-11-21	1973-11-21 00:00:00	1973-12-05	1973-12-05 00:00:00	1973-12-05	38000177		0	0	14		0	0	0	126400	0	243670	19059056		
60531	5035	40229134	1982-03-02	1982-03-02 00:00:00	1982-03-16	1982-03-16 00:00:00	1982-03-16	38000177		0	0	14		0	0	0	334590	0	1043400	40229134		
46356	3839	40229134	1994-07-23	1994-07-23 00:00:00	1994-08-06	1994-08-06 00:00:00	1994-08-06	38000177		0	0	14		0	0	0	254889	0	1043400	40229134		
8743	728	19133873	1963-11-09	1963-11-09 00:00:00	1963-11-21	1963-11-21 00:00:00	1963-11-21	38000177		0	0	12		0	0	0	48335	0	834061	19133873		
33329	2761	19019979	1984-09-25	1984-09-25 00:00:00	1984-10-09	1984-10-09 00:00:00	1984-10-09	38000177		0	0	14		0	0	0	182639	0	198405	19019979		
4316	357	40173590	2014-12-10	2014-12-10 00:00:00	2014-12-10	2014-12-10 00:00:00	\N	38000177		0	0	0		0	0	0	23753	0	904419	40173590		
57015	4731	19059056	1972-10-27	1972-10-27 00:00:00	1973-01-25	1973-01-25 00:00:00	1973-01-25	38000177		0	0	90		0	0	0	315215	0	243670	19059056		
28093	2325	46233988	1972-05-21	1972-05-21 00:00:00	1972-06-04	1972-06-04 00:00:00	1972-06-04	38000177		0	0	14		0	0	0	154592	0	1652673	46233988		
9180	763	40236824	2018-04-06	2018-04-06 00:00:00	2018-04-13	2018-04-13 00:00:00	2018-04-13	38000177		0	0	7		0	0	0	50762	0	1094107	40236824		
26543	2185	40165015	1992-09-03	1992-09-03 00:00:00	1992-09-03	1992-09-03 00:00:00	\N	38000177		0	0	0		0	0	0	145626	0	861467	40165015		
26626	2192	19133873	1963-04-12	1963-04-12 00:00:00	1963-04-20	1963-04-20 00:00:00	1963-04-20	38000177		0	0	8		0	0	0	146195	0	834061	19133873		
37109	3067	1127433	1974-08-31	1974-08-31 00:00:00	1974-09-07	1974-09-07 00:00:00	1974-09-07	38000177		0	0	7		0	0	0	204154	0	313782	1127433		
37196	3076	19006318	1952-05-16	1952-05-16 00:00:00	1952-05-30	1952-05-30 00:00:00	1952-05-30	38000177		0	0	14		0	0	0	204664	0	105078	19006318		
22018	1808	40236824	2001-03-14	2001-03-14 00:00:00	2001-03-28	2001-03-28 00:00:00	2001-03-28	38000177		0	0	14		0	0	0	121020	0	1094107	40236824		
37269	3080	1713671	2007-05-12	2007-05-12 00:00:00	2007-06-02	2007-06-02 00:00:00	2007-06-02	38000177		0	0	21		0	0	0	204992	0	562251	1713671		
32560	2699	19059056	1973-08-03	1973-08-03 00:00:00	1973-08-17	1973-08-17 00:00:00	1973-08-17	38000177		0	0	14		0	0	0	178714	0	243670	19059056		
32638	2705	1127433	1966-09-20	1966-09-20 00:00:00	1966-10-25	1966-10-25 00:00:00	1966-10-25	38000177		0	0	35		0	0	0	179243	0	313782	1127433		
96610	2119	40213227	2012-06-18	2012-06-18 00:00:00	2012-06-18	2012-06-18 00:00:00	2012-06-18	581452		0	0	0		0	0	0	141088	0	113	40213227		
107950	2366	40213260	2016-09-19	2016-09-19 00:00:00	2016-09-19	2016-09-19 00:00:00	2016-09-19	581452		0	0	0		0	0	0	157539	0	121	40213260		
139834	3072	40213260	2010-07-24	2010-07-24 00:00:00	2010-07-24	2010-07-24 00:00:00	2010-07-24	581452		0	0	0		0	0	0	204455	0	121	40213260		
108056	2369	40213251	1984-04-08	1984-04-08 00:00:00	1984-04-08	1984-04-08 00:00:00	1984-04-08	581452		0	0	0		0	0	0	157624	0	21	40213251		
108077	2369	40213160	1981-10-11	1981-10-11 00:00:00	1981-10-11	1981-10-11 00:00:00	1981-10-11	581452		0	0	0		0	0	0	157658	0	10	40213160		
58533	4859	1127433	1962-02-03	1962-02-03 00:00:00	1962-02-17	1962-02-17 00:00:00	1962-02-17	38000177		0	0	14		0	0	0	323232	0	313782	1127433		
20365	1672	1127078	1955-08-17	1955-08-17 00:00:00	1955-08-31	1955-08-31 00:00:00	1955-08-31	38000177		0	0	14		0	0	0	112231	0	282464	1127078		
98646	2160	40213296	2000-07-17	2000-07-17 00:00:00	2000-07-17	2000-07-17 00:00:00	2000-07-17	581452		0	0	0		0	0	0	143939	0	52	40213296		
37607	3109	1127433	1971-02-09	1971-02-09 00:00:00	1971-03-02	1971-03-02 00:00:00	1971-03-02	38000177		0	0	21		0	0	0	206707	0	313782	1127433		
8842	738	1713671	2016-03-09	2016-03-09 00:00:00	2016-03-23	2016-03-23 00:00:00	2016-03-23	38000177		0	0	14		0	0	0	48904	0	562251	1713671		
42379	3514	1118084	2014-03-02	2014-03-02 00:00:00	2014-03-02	2014-03-02 00:00:00	\N	38000177		0	0	0		0	0	0	233209	0	00025152531	44923712		
17797	1475	19059056	1935-01-20	1935-01-20 00:00:00	1935-02-03	1935-02-03 00:00:00	1935-02-03	38000177		0	0	14		0	0	0	98279	0	243670	19059056		
6305	526	1127433	1973-07-15	1973-07-15 00:00:00	1973-07-22	1973-07-22 00:00:00	1973-07-22	38000177		0	0	7		0	0	0	35046	0	313782	1127433		
4092	338	19112599	1971-05-09	1971-05-09 00:00:00	1971-05-09	1971-05-09 00:00:00	\N	38000177		0	0	0		0	0	0	22593	0	477045	19112599		
4136	343	1127433	1988-11-25	1988-11-25 00:00:00	1988-12-09	1988-12-09 00:00:00	1988-12-09	38000177		0	0	14		0	0	0	22920	0	313782	1127433		
14633	1227	19059056	1946-04-10	1946-04-10 00:00:00	1946-07-09	1946-07-09 00:00:00	1946-07-09	38000177		0	0	90		0	0	0	80816	0	243670	19059056		
36258	2988	40220960	2012-06-24	2012-06-24 00:00:00	2012-06-24	2012-06-24 00:00:00	2012-06-24	38000177		0	0	0		0	0	0	199457	0	1804799	40220960		
43428	3601	40229134	1984-10-01	1984-10-01 00:00:00	1984-10-15	1984-10-15 00:00:00	1984-10-15	38000177		0	0	14		0	0	0	239180	0	1043400	40229134		
45706	3784	920300	1954-09-23	1954-09-23 00:00:00	1954-09-30	1954-09-30 00:00:00	1954-09-30	38000177		0	0	7		0	0	0	251492	0	311989	920300		
46868	3881	1332419	1994-01-21	1994-01-21 00:00:00	1994-01-21	1994-01-21 00:00:00	\N	38000177		0	0	0		0	0	0	257932	0	197361	1332419		
35552	776	40213227	2009-08-06	2009-08-06 00:00:00	2009-08-06	2009-08-06 00:00:00	2009-08-06	581452		0	0	0		0	0	0	51506	0	113	40213227		
41914	3470	19133873	1967-05-06	1967-05-06 00:00:00	1967-05-19	1967-05-19 00:00:00	1967-05-19	38000177		0	0	13		0	0	0	230298	0	834061	19133873		
21873	1793	46233710	1971-06-20	1971-06-20 00:00:00	1971-07-04	1971-07-04 00:00:00	1971-07-04	38000177		0	0	14		0	0	0	120217	0	1650142	46233710		
49722	4124	1127433	1985-08-29	1985-08-29 00:00:00	1985-09-12	1985-09-12 00:00:00	1985-09-12	38000177		0	0	14		0	0	0	274210	0	313782	1127433		
52364	4355	1713671	2001-05-08	2001-05-08 00:00:00	2001-05-22	2001-05-22 00:00:00	2001-05-22	38000177		0	0	14		0	0	0	288992	0	562251	1713671		
60276	5013	40229134	1966-10-12	1966-10-12 00:00:00	1966-10-19	1966-10-19 00:00:00	1966-10-19	38000177		0	0	7		0	0	0	333203	0	1043400	40229134		
42583	3530	19126352	1970-05-01	1970-05-01 00:00:00	1970-05-01	1970-05-01 00:00:00	\N	38000177		0	0	0		0	0	0	234504	0	705129	19126352		
3364	279	1127433	1971-02-06	1971-02-06 00:00:00	1971-02-13	1971-02-13 00:00:00	1971-02-13	38000177		0	0	7		0	0	0	18637	0	313782	1127433		
20783	1713	1127433	2000-04-10	2000-04-10 00:00:00	2000-04-24	2000-04-24 00:00:00	2000-04-24	38000177		0	0	14		0	0	0	114469	0	313782	1127433		
25899	2130	1127433	1994-05-13	1994-05-13 00:00:00	1994-05-27	1994-05-27 00:00:00	1994-05-27	38000177		0	0	14		0	0	0	141729	0	313782	1127433		
2009	160	19129655	1964-03-13	1964-03-13 00:00:00	1964-03-27	1964-03-27 00:00:00	1964-03-27	38000177		0	0	14		0	0	0	10967	0	789980	19129655		
51909	4317	1713671	2002-10-16	2002-10-16 00:00:00	2002-10-23	2002-10-23 00:00:00	2002-10-23	38000177		0	0	7		0	0	0	286509	0	562251	1713671		
8356	697	40229134	1986-04-16	1986-04-16 00:00:00	1986-04-23	1986-04-23 00:00:00	1986-04-23	38000177		0	0	7		0	0	0	46121	0	1043400	40229134		
20089	1649	1539411	2007-03-14	2007-03-14 00:00:00	2007-03-14	2007-03-14 00:00:00	\N	38000177		0	0	0		0	0	0	110625	0	312961	1539411		
18036	1493	1713671	2006-08-20	2006-08-20 00:00:00	2006-09-03	2006-09-03 00:00:00	2006-09-03	38000177		0	0	14		0	0	0	99554	0	562251	1713671		
62536	5201	1127078	1980-04-04	1980-04-04 00:00:00	1980-04-18	1980-04-18 00:00:00	1980-04-18	38000177		0	0	14		0	0	0	345955	0	282464	1127078		
3927	327	1127078	1976-01-20	1976-01-20 00:00:00	1976-02-03	1976-02-03 00:00:00	1976-02-03	38000177		0	0	14		0	0	0	21622	0	282464	1127078		
33804	2798	1127433	1977-12-27	1977-12-27 00:00:00	1978-01-03	1978-01-03 00:00:00	1978-01-03	38000177		0	0	7		0	0	0	185452	0	313782	1127433		
33814	2798	1127433	1986-08-20	1986-08-20 00:00:00	1986-09-03	1986-09-03 00:00:00	1986-09-03	38000177		0	0	14		0	0	0	185433	0	313782	1127433		
26183	2153	1127433	1981-06-30	1981-06-30 00:00:00	1981-07-07	1981-07-07 00:00:00	1981-07-07	38000177		0	0	7		0	0	0	143505	0	313782	1127433		
50080	4156	19133768	2007-12-24	2007-12-24 00:00:00	2007-12-24	2007-12-24 00:00:00	2007-12-24	38000177		0	0	0		0	0	0	276160	0	833036	19133768		
1485	117	1713671	1981-09-24	1981-09-24 00:00:00	1981-10-08	1981-10-08 00:00:00	1981-10-08	38000177		0	0	14		0	0	0	7758	0	562251	1713671		
11984	1000	1127433	1970-09-04	1970-09-04 00:00:00	1970-09-18	1970-09-18 00:00:00	1970-09-18	38000177		0	0	14		0	0	0	66197	0	313782	1127433		
8060	673	19128065	1975-09-19	1975-09-19 00:00:00	1976-09-13	1976-09-13 00:00:00	1976-09-13	38000177		0	0	360		0	0	0	44524	0	749882	19128065		
40289	3337	46275916	1983-12-05	1983-12-05 00:00:00	1983-12-05	1983-12-05 00:00:00	1983-12-05	38000177		0	0	0		0	0	0	221351	0	1660014	46275916		
40304	3339	1127433	1987-06-23	1987-06-23 00:00:00	1987-07-07	1987-07-07 00:00:00	1987-07-07	38000177		0	0	14		0	0	0	221540	0	313782	1127433		
44568	3691	1127433	1969-07-26	1969-07-26 00:00:00	1969-08-02	1969-08-02 00:00:00	1969-08-02	38000177		0	0	7		0	0	0	245352	0	313782	1127433		
23021	1898	40229134	2013-05-25	2013-05-25 00:00:00	2013-06-01	2013-06-01 00:00:00	2013-06-01	38000177		0	0	7		0	0	0	126345	0	1043400	40229134		
60532	5035	19077572	2009-08-03	2009-08-03 00:00:00	2009-08-03	2009-08-03 00:00:00	\N	38000177		0	0	0		0	0	0	334645	0	310436	19077572		
46357	3839	1713671	1952-02-08	1952-02-08 00:00:00	1952-02-29	1952-02-29 00:00:00	1952-02-29	38000177		0	0	21		0	0	0	254905	0	562251	1713671		
8744	729	1127433	2019-03-20	2019-03-20 00:00:00	2019-03-27	2019-03-27 00:00:00	2019-03-27	38000177		0	0	7		0	0	0	48429	0	313782	1127433		
33330	2761	19133873	1992-12-23	1992-12-23 00:00:00	1992-12-31	1992-12-31 00:00:00	1992-12-31	38000177		0	0	8		0	0	0	182621	0	834061	19133873		
14775	1236	1713671	2017-02-06	2017-02-06 00:00:00	2017-02-20	2017-02-20 00:00:00	2017-02-20	38000177		0	0	14		0	0	0	81472	0	562251	1713671		
57016	4731	1127433	2014-06-14	2014-06-14 00:00:00	2014-06-21	2014-06-21 00:00:00	2014-06-21	38000177		0	0	7		0	0	0	315197	0	313782	1127433		
28094	2325	40236824	2018-01-10	2018-01-10 00:00:00	2018-01-17	2018-01-17 00:00:00	2018-01-17	38000177		0	0	7		0	0	0	154591	0	1094107	40236824		
9181	763	920300	2018-04-06	2018-04-06 00:00:00	2018-04-13	2018-04-13 00:00:00	2018-04-13	38000177		0	0	7		0	0	0	50762	0	311989	920300		
26544	2185	46233710	1972-04-19	1972-04-19 00:00:00	1972-05-04	1972-05-04 00:00:00	1972-05-04	38000177		0	0	15		0	0	0	145644	0	1650142	46233710		
26628	2192	19059056	1962-08-13	1962-08-13 00:00:00	1962-10-12	1962-10-12 00:00:00	1962-10-12	38000177		0	0	60		0	0	0	146243	0	243670	19059056		
37110	3067	1115171	2009-12-26	2009-12-26 00:00:00	2010-01-09	2010-01-09 00:00:00	2010-01-09	38000177		0	0	14		0	0	0	204187	0	849574	1115171		
37197	3076	1127433	1983-06-05	1983-06-05 00:00:00	1983-06-12	1983-06-12 00:00:00	1983-06-12	38000177		0	0	7		0	0	0	204659	0	313782	1127433		
22019	1808	46233988	1967-01-11	1967-01-11 00:00:00	1967-01-25	1967-01-25 00:00:00	1967-01-25	38000177		0	0	14		0	0	0	121074	0	1652673	46233988		
37270	3080	1115171	2007-04-12	2007-04-12 00:00:00	2007-04-26	2007-04-26 00:00:00	2007-04-26	38000177		0	0	14		0	0	0	204995	0	849574	1115171		
32561	2699	19128022	1994-09-22	1994-09-22 00:00:00	1995-09-17	1995-09-17 00:00:00	1995-09-17	38000177		0	0	360		0	0	0	178745	0	749785	19128022		
32639	2705	1127433	1969-07-09	1969-07-09 00:00:00	1969-07-16	1969-07-16 00:00:00	1969-07-16	38000177		0	0	7		0	0	0	179221	0	313782	1127433		
96611	2119	40213260	2012-06-18	2012-06-18 00:00:00	2012-06-18	2012-06-18 00:00:00	2012-06-18	581452		0	0	0		0	0	0	141088	0	121	40213260		
107958	2366	40213306	1987-11-16	1987-11-16 00:00:00	1987-11-16	1987-11-16 00:00:00	1987-11-16	581452		0	0	0		0	0	0	157494	0	43	40213306		
139836	3072	40213227	2010-07-24	2010-07-24 00:00:00	2010-07-24	2010-07-24 00:00:00	2010-07-24	581452		0	0	0		0	0	0	204455	0	113	40213227		
108060	2369	40213160	1982-01-10	1982-01-10 00:00:00	1982-01-10	1982-01-10 00:00:00	1982-01-10	581452		0	0	0		0	0	0	157622	0	10	40213160		
108080	2369	40213314	1982-07-11	1982-07-11 00:00:00	1982-07-11	1982-07-11 00:00:00	1982-07-11	581452		0	0	0		0	0	0	157707	0	49	40213314		
58534	4859	1713671	1967-10-19	1967-10-19 00:00:00	1967-11-09	1967-11-09 00:00:00	1967-11-09	38000177		0	0	21		0	0	0	323267	0	562251	1713671		
20366	1672	1127433	2002-10-31	2002-10-31 00:00:00	2002-11-07	2002-11-07 00:00:00	2002-11-07	38000177		0	0	7		0	0	0	112244	0	313782	1127433		
98648	2160	40213160	1960-12-19	1960-12-19 00:00:00	1960-12-19	1960-12-19 00:00:00	1960-12-19	581452		0	0	0		0	0	0	143987	0	10	40213160		
37608	3109	19059056	1925-02-05	1925-02-05 00:00:00	1925-02-19	1925-02-19 00:00:00	1925-02-19	38000177		0	0	14		0	0	0	206703	0	243670	19059056		
8843	738	1127433	1990-07-04	1990-07-04 00:00:00	1990-07-18	1990-07-18 00:00:00	1990-07-18	38000177		0	0	14		0	0	0	48867	0	313782	1127433		
42380	3514	43012754	1994-07-15	1994-07-15 00:00:00	1995-07-10	1995-07-10 00:00:00	1995-07-10	38000177		0	0	360		0	0	0	233199	0	1366343	43012754		
17798	1475	40229134	1944-03-05	1944-03-05 00:00:00	1944-03-12	1944-03-12 00:00:00	1944-03-12	38000177		0	0	7		0	0	0	98219	0	1043400	40229134		
16767	1387	40236824	2013-04-21	2013-04-21 00:00:00	2013-05-05	2013-05-05 00:00:00	2013-05-05	38000177		0	0	14		0	0	0	92046	0	1094107	40236824		
4093	338	1551192	1975-09-04	1975-09-04 00:00:00	1975-09-04	1975-09-04 00:00:00	1975-09-04	38000177		0	0	0		0	0	0	22598	0	312617	1551192		
4137	343	1713671	2010-10-14	2010-10-14 00:00:00	2010-10-21	2010-10-21 00:00:00	2010-10-21	38000177		0	0	7		0	0	0	22863	0	562251	1713671		
14634	1227	19059056	1954-01-12	1954-01-12 00:00:00	1954-02-16	1954-02-16 00:00:00	1954-02-16	38000177		0	0	35		0	0	0	80819	0	243670	19059056		
36259	2988	1127433	1975-08-15	1975-08-15 00:00:00	1975-09-05	1975-09-05 00:00:00	1975-09-05	38000177		0	0	21		0	0	0	199426	0	313782	1127433		
43429	3601	19008572	1967-08-22	1967-08-22 00:00:00	1967-09-12	1967-09-12 00:00:00	1967-09-12	38000177		0	0	21		0	0	0	239171	0	106258	19008572		
45707	3784	19059056	1949-08-27	1949-08-27 00:00:00	1949-09-17	1949-09-17 00:00:00	1949-09-17	38000177		0	0	21		0	0	0	251488	0	243670	19059056		
46869	3881	19078461	1978-12-23	1978-12-23 00:00:00	1979-01-20	1979-01-20 00:00:00	1979-01-20	38000177		0	0	28		0	0	0	257919	0	310965	19078461		
35553	776	40213260	2009-08-06	2009-08-06 00:00:00	2009-08-06	2009-08-06 00:00:00	2009-08-06	581452		0	0	0		0	0	0	51506	0	121	40213260		
41916	3470	1127433	1969-04-12	1969-04-12 00:00:00	1969-04-19	1969-04-19 00:00:00	1969-04-19	38000177		0	0	7		0	0	0	230299	0	313782	1127433		
21874	1793	19059056	1971-06-20	1971-06-20 00:00:00	1971-07-04	1971-07-04 00:00:00	1971-07-04	38000177		0	0	14		0	0	0	120217	0	243670	19059056		
49723	4124	1127078	1977-02-28	1977-02-28 00:00:00	1977-03-14	1977-03-14 00:00:00	1977-03-14	38000177		0	0	14		0	0	0	274209	0	282464	1127078		
170416	3746	40213227	2015-10-08	2015-10-08 00:00:00	2015-10-08	2015-10-08 00:00:00	2015-10-08	581452		0	0	0		0	0	0	249070	0	113	40213227		
60277	5013	19059056	1969-06-17	1969-06-17 00:00:00	1969-07-08	1969-07-08 00:00:00	1969-07-08	38000177		0	0	21		0	0	0	333199	0	243670	19059056		
42584	3530	19133905	1980-10-05	1980-10-05 00:00:00	1980-10-18	1980-10-18 00:00:00	1980-10-18	38000177		0	0	13		0	0	0	234462	0	834102	19133905		
3365	279	1127433	2014-10-24	2014-10-24 00:00:00	2014-10-31	2014-10-31 00:00:00	2014-10-31	38000177		0	0	7		0	0	0	18644	0	313782	1127433		
20784	1713	1127433	1999-01-14	1999-01-14 00:00:00	1999-01-28	1999-01-28 00:00:00	1999-01-28	38000177		0	0	14		0	0	0	114435	0	313782	1127433		
25900	2130	1118084	1996-05-12	1996-05-12 00:00:00	1996-05-12	1996-05-12 00:00:00	\N	38000177		0	0	0		0	0	0	141729	0	00025152531	44923712		
2010	160	19059056	1964-03-13	1964-03-13 00:00:00	1964-03-27	1964-03-27 00:00:00	1964-03-27	38000177		0	0	14		0	0	0	10967	0	243670	19059056		
51910	4317	1118084	1988-08-14	1988-08-14 00:00:00	1988-08-14	1988-08-14 00:00:00	\N	38000177		0	0	0		0	0	0	286524	0	00025152531	44923712		
8357	697	40162522	2001-08-17	2001-08-17 00:00:00	2001-08-17	2001-08-17 00:00:00	\N	38000177		0	0	0		0	0	0	46162	0	857005	40162522		
20090	1649	19075601	2007-03-14	2007-03-14 00:00:00	2017-08-23	2017-08-23 00:00:00	2017-08-23	38000177		0	0	3815		0	0	0	110625	0	309362	19075601		
18037	1493	1124300	1989-11-06	1989-11-06 00:00:00	1989-11-06	1989-11-06 00:00:00	\N	38000177		0	0	0		0	0	0	99507	0	00781178901	45011828		
62537	5201	1127433	1979-05-02	1979-05-02 00:00:00	1979-05-16	1979-05-16 00:00:00	1979-05-16	38000177		0	0	14		0	0	0	345989	0	313782	1127433		
3928	327	46233988	1976-01-20	1976-01-20 00:00:00	1976-02-03	1976-02-03 00:00:00	1976-02-03	38000177		0	0	14		0	0	0	21622	0	1652673	46233988		
127394	2802	40213227	1992-10-03	1992-10-03 00:00:00	1992-10-03	1992-10-03 00:00:00	1992-10-03	581452		0	0	0		0	0	0	185734	0	113	40213227		
33815	2798	1713671	2017-10-13	2017-10-13 00:00:00	2017-10-20	2017-10-20 00:00:00	2017-10-20	38000177		0	0	7		0	0	0	185449	0	562251	1713671		
26184	2153	1127433	1996-08-18	1996-08-18 00:00:00	1996-08-25	1996-08-25 00:00:00	1996-08-25	38000177		0	0	7		0	0	0	143507	0	313782	1127433		
50081	4156	1332419	2004-11-15	2004-11-15 00:00:00	2004-11-15	2004-11-15 00:00:00	\N	38000177		0	0	0		0	0	0	276209	0	197361	1332419		
1486	117	1118084	2009-01-13	2009-01-13 00:00:00	2009-01-13	2009-01-13 00:00:00	\N	38000177		0	0	0		0	0	0	7814	0	00025152531	44923712		
11985	1000	1118084	2008-01-22	2008-01-22 00:00:00	2008-01-22	2008-01-22 00:00:00	\N	38000177		0	0	0		0	0	0	66213	0	00025152531	44923712		
8061	673	1127433	2005-11-22	2005-11-22 00:00:00	2005-12-29	2005-12-29 00:00:00	2005-12-29	38000177		0	0	37		0	0	0	44439	0	313782	1127433		
40290	3337	1118084	2007-02-15	2007-02-15 00:00:00	2007-02-15	2007-02-15 00:00:00	\N	38000177		0	0	0		0	0	0	221400	0	00025152531	44923712		
40305	3339	19059056	1967-08-07	1967-08-07 00:00:00	1967-11-05	1967-11-05 00:00:00	1967-11-05	38000177		0	0	90		0	0	0	221539	0	243670	19059056		
44569	3691	19133905	1999-01-04	1999-01-04 00:00:00	1999-01-16	1999-01-16 00:00:00	1999-01-16	38000177		0	0	12		0	0	0	245318	0	834102	19133905		
23022	1898	40229134	1986-10-24	1986-10-24 00:00:00	1986-10-31	1986-10-31 00:00:00	1986-10-31	38000177		0	0	7		0	0	0	126341	0	1043400	40229134		
60533	5035	19018935	2011-08-15	2011-08-15 00:00:00	2011-08-15	2011-08-15 00:00:00	\N	38000177		0	0	0		0	0	0	334646	0	197604	19018935		
46358	3839	19059056	1959-05-09	1959-05-09 00:00:00	1959-06-08	1959-06-08 00:00:00	1959-06-08	38000177		0	0	30		0	0	0	254858	0	243670	19059056		
8745	729	1127078	1962-07-26	1962-07-26 00:00:00	1962-10-24	1962-10-24 00:00:00	1962-10-24	38000177		0	0	90		0	0	0	48403	0	282464	1127078		
33331	2761	1127433	2006-11-20	2006-11-20 00:00:00	2006-11-27	2006-11-27 00:00:00	2006-11-27	38000177		0	0	7		0	0	0	182622	0	313782	1127433		
14776	1236	1115171	2012-12-31	2012-12-31 00:00:00	2013-01-14	2013-01-14 00:00:00	2013-01-14	38000177		0	0	14		0	0	0	81418	0	849574	1115171		
57017	4732	19133873	1957-04-16	1957-04-16 00:00:00	1957-04-25	1957-04-25 00:00:00	1957-04-25	38000177		0	0	9		0	0	0	315278	0	834061	19133873		
28095	2325	920300	2018-01-10	2018-01-10 00:00:00	2018-01-17	2018-01-17 00:00:00	2018-01-17	38000177		0	0	7		0	0	0	154591	0	311989	920300		
9182	763	19078461	1981-08-21	1981-08-21 00:00:00	1981-11-19	1981-11-19 00:00:00	1981-11-19	38000177		0	0	90		0	0	0	50732	0	310965	19078461		
26545	2185	19059056	1972-04-19	1972-04-19 00:00:00	1972-05-04	1972-05-04 00:00:00	1972-05-04	38000177		0	0	15		0	0	0	145644	0	243670	19059056		
26629	2192	1127433	1975-06-30	1975-06-30 00:00:00	1975-07-07	1975-07-07 00:00:00	1975-07-07	38000177		0	0	7		0	0	0	146170	0	313782	1127433		
37111	3067	40236824	1983-01-20	1983-01-20 00:00:00	1983-01-27	1983-01-27 00:00:00	1983-01-27	38000177		0	0	7		0	0	0	204155	0	1094107	40236824		
37198	3076	40165015	2017-10-20	2017-10-20 00:00:00	2017-10-20	2017-10-20 00:00:00	\N	38000177		0	0	0		0	0	0	204649	0	861467	40165015		
22020	1808	19059056	1967-01-11	1967-01-11 00:00:00	1967-01-25	1967-01-25 00:00:00	1967-01-25	38000177		0	0	14		0	0	0	121074	0	243670	19059056		
37271	3080	19073188	2007-04-12	2007-04-12 00:00:00	2007-04-26	2007-04-26 00:00:00	2007-04-26	38000177		0	0	14		0	0	0	204995	0	308192	19073188		
32562	2699	1713671	1989-09-09	1989-09-09 00:00:00	1989-09-23	1989-09-23 00:00:00	1989-09-23	38000177		0	0	14		0	0	0	178719	0	562251	1713671		
32640	2705	1115171	2013-03-20	2013-03-20 00:00:00	2013-04-03	2013-04-03 00:00:00	2013-04-03	38000177		0	0	14		0	0	0	179246	0	849574	1115171		
96625	2119	40213160	1961-09-18	1961-09-18 00:00:00	1961-09-18	1961-09-18 00:00:00	1961-09-18	581452		0	0	0		0	0	0	140982	0	10	40213160		
107961	2366	40213160	1965-12-20	1965-12-20 00:00:00	1965-12-20	1965-12-20 00:00:00	1965-12-20	581452		0	0	0		0	0	0	157495	0	10	40213160		
139847	3072	40213227	1992-04-04	1992-04-04 00:00:00	1992-04-04	1992-04-04 00:00:00	1992-04-04	581452		0	0	0		0	0	0	204471	0	113	40213227		
108067	2369	40213306	2004-07-18	2004-07-18 00:00:00	2004-07-18	2004-07-18 00:00:00	2004-07-18	581452		0	0	0		0	0	0	157727	0	43	40213306		
108085	2369	40213251	1986-04-13	1986-04-13 00:00:00	1986-04-13	1986-04-13 00:00:00	1986-04-13	581452		0	0	0		0	0	0	157709	0	21	40213251		
58535	4859	1127433	1980-03-14	1980-03-14 00:00:00	1980-03-21	1980-03-21 00:00:00	1980-03-21	38000177		0	0	7		0	0	0	323248	0	313782	1127433		
20367	1672	19133905	2006-02-03	2006-02-03 00:00:00	2006-02-11	2006-02-11 00:00:00	2006-02-11	38000177		0	0	8		0	0	0	112250	0	834102	19133905		
98653	2160	40213227	2002-07-22	2002-07-22 00:00:00	2002-07-22	2002-07-22 00:00:00	2002-07-22	581452		0	0	0		0	0	0	143946	0	113	40213227		
37609	3109	1127433	1931-02-05	1931-02-05 00:00:00	1931-02-19	1931-02-19 00:00:00	1931-02-19	38000177		0	0	14		0	0	0	206769	0	313782	1127433		
8844	738	1127433	2000-08-29	2000-08-29 00:00:00	2000-09-05	2000-09-05 00:00:00	2000-09-05	38000177		0	0	7		0	0	0	48892	0	313782	1127433		
42381	3514	19019979	1982-05-30	1982-05-30 00:00:00	1982-06-27	1982-06-27 00:00:00	1982-06-27	38000177		0	0	28		0	0	0	233212	0	198405	19019979		
17799	1475	19133873	1934-11-23	1934-11-23 00:00:00	1934-12-01	1934-12-01 00:00:00	1934-12-01	38000177		0	0	8		0	0	0	98215	0	834061	19133873		
16768	1387	920300	2013-04-21	2013-04-21 00:00:00	2013-04-28	2013-04-28 00:00:00	2013-04-28	38000177		0	0	7		0	0	0	92046	0	311989	920300		
4094	338	1127433	1995-06-01	1995-06-01 00:00:00	1995-06-15	1995-06-15 00:00:00	1995-06-15	38000177		0	0	14		0	0	0	22526	0	313782	1127433		
4138	343	1127433	1994-04-13	1994-04-13 00:00:00	1994-04-27	1994-04-27 00:00:00	1994-04-27	38000177		0	0	14		0	0	0	22871	0	313782	1127433		
14635	1227	1127433	2000-06-03	2000-06-03 00:00:00	2000-06-10	2000-06-10 00:00:00	2000-06-10	38000177		0	0	7		0	0	0	80735	0	313782	1127433		
36260	2988	1118084	2001-07-15	2001-07-15 00:00:00	2001-07-15	2001-07-15 00:00:00	\N	38000177		0	0	0		0	0	0	199431	0	00025152531	44923712		
43430	3601	1713671	1998-07-24	1998-07-24 00:00:00	1998-07-31	1998-07-31 00:00:00	1998-07-31	38000177		0	0	7		0	0	0	239246	0	562251	1713671		
45708	3784	19059056	1932-08-08	1932-08-08 00:00:00	1932-08-22	1932-08-22 00:00:00	1932-08-22	38000177		0	0	14		0	0	0	251466	0	243670	19059056		
46870	3881	40243436	1997-01-03	1997-01-03 00:00:00	1997-01-03	1997-01-03 00:00:00	1997-01-03	38000177		0	0	0		0	0	0	257921	0	1190795	40243436		
35567	776	40213260	2008-07-31	2008-07-31 00:00:00	2008-07-31	2008-07-31 00:00:00	2008-07-31	581452		0	0	0		0	0	0	51582	0	121	40213260		
35572	776	40213306	1982-08-12	1982-08-12 00:00:00	1982-08-12	1982-08-12 00:00:00	1982-08-12	581452		0	0	0		0	0	0	51578	0	43	40213306		
21875	1793	1127433	1972-03-03	1972-03-03 00:00:00	1972-03-17	1972-03-17 00:00:00	1972-03-17	38000177		0	0	14		0	0	0	120224	0	313782	1127433		
49724	4125	1127433	1987-11-17	1987-11-17 00:00:00	1987-12-08	1987-12-08 00:00:00	1987-12-08	38000177		0	0	21		0	0	0	274213	0	313782	1127433		
48689	4033	1127433	2010-09-06	2010-09-06 00:00:00	2010-09-20	2010-09-20 00:00:00	2010-09-20	38000177		0	0	14		0	0	0	268364	0	313782	1127433		
60278	5013	1545959	2013-05-31	2013-05-31 00:00:00	2013-05-31	2013-05-31 00:00:00	2013-05-31	38000177		0	0	0		0	0	0	333201	0	259255	1545959		
42585	3530	19059056	1960-10-15	1960-10-15 00:00:00	1960-10-29	1960-10-29 00:00:00	1960-10-29	38000177		0	0	14		0	0	0	234480	0	243670	19059056		
3366	279	19006318	1954-03-02	1954-03-02 00:00:00	1954-03-16	1954-03-16 00:00:00	1954-03-16	38000177		0	0	14		0	0	0	18626	0	105078	19006318		
20785	1713	1713671	2004-12-22	2004-12-22 00:00:00	2004-12-29	2004-12-29 00:00:00	2004-12-29	38000177		0	0	7		0	0	0	114436	0	562251	1713671		
25901	2130	1127433	2004-02-23	2004-02-23 00:00:00	2004-03-08	2004-03-08 00:00:00	2004-03-08	38000177		0	0	14		0	0	0	141707	0	313782	1127433		
2011	160	920300	1992-09-02	1992-09-02 00:00:00	1992-09-09	1992-09-09 00:00:00	1992-09-09	38000177		0	0	7		0	0	0	10941	0	311989	920300		
51911	4317	19059056	1961-11-19	1961-11-19 00:00:00	1961-12-19	1961-12-19 00:00:00	1961-12-19	38000177		0	0	30		0	0	0	286477	0	243670	19059056		
8358	697	1115171	2001-08-17	2001-08-17 00:00:00	2001-10-16	2001-10-16 00:00:00	2001-10-16	38000177		0	0	60		0	0	0	46162	0	849574	1115171		
20091	1649	1332419	2007-03-14	2007-03-14 00:00:00	2007-03-14	2007-03-14 00:00:00	\N	38000177		0	0	0		0	0	0	110625	0	197361	1332419		
18053	1496	19133905	1948-08-17	1948-08-17 00:00:00	1948-08-24	1948-08-24 00:00:00	1948-08-24	38000177		0	0	7		0	0	0	99726	0	834102	19133905		
62538	5201	42902245	2001-02-13	2001-02-13 00:00:00	2002-02-08	2002-02-08 00:00:00	2002-02-08	38000177		0	0	360		0	0	0	345958	0	1359133	42902245		
3929	327	1127433	1985-11-05	1985-11-05 00:00:00	1985-12-10	1985-12-10 00:00:00	1985-12-10	38000177		0	0	35		0	0	0	21619	0	313782	1127433		
16427	354	40213227	2007-01-11	2007-01-11 00:00:00	2007-01-11	2007-01-11 00:00:00	2007-01-11	581452		0	0	0		0	0	0	23576	0	113	40213227		
33817	2798	40236824	1999-12-12	1999-12-12 00:00:00	1999-12-26	1999-12-26 00:00:00	1999-12-26	38000177		0	0	14		0	0	0	185464	0	1094107	40236824		
26185	2153	19128065	1986-10-11	1986-10-11 00:00:00	1987-10-06	1987-10-06 00:00:00	1987-10-06	38000177		0	0	360		0	0	0	143483	0	749882	19128065		
50082	4156	19126352	2004-11-15	2004-11-15 00:00:00	2006-02-27	2006-02-27 00:00:00	2006-02-27	38000177		0	0	469		0	0	0	276209	0	705129	19126352		
1487	117	1127433	1982-09-22	1982-09-22 00:00:00	1982-10-22	1982-10-22 00:00:00	1982-10-22	38000177		0	0	30		0	0	0	7803	0	313782	1127433		
11986	1000	1127433	1976-02-18	1976-02-18 00:00:00	1976-03-19	1976-03-19 00:00:00	1976-03-19	38000177		0	0	30		0	0	0	66139	0	313782	1127433		
8062	673	19078461	1998-03-20	1998-03-20 00:00:00	1998-04-03	1998-04-03 00:00:00	1998-04-03	38000177		0	0	14		0	0	0	44438	0	310965	19078461		
40291	3337	1127433	1991-08-29	1991-08-29 00:00:00	1991-09-12	1991-09-12 00:00:00	1991-09-12	38000177		0	0	14		0	0	0	221359	0	313782	1127433		
40306	3339	1713671	1978-09-30	1978-09-30 00:00:00	1978-10-14	1978-10-14 00:00:00	1978-10-14	38000177		0	0	14		0	0	0	221477	0	562251	1713671		
44570	3691	1115171	2012-07-17	2012-07-17 00:00:00	2012-08-07	2012-08-07 00:00:00	2012-08-07	38000177		0	0	21		0	0	0	245332	0	849574	1115171		
23023	1898	1127433	1979-10-23	1979-10-23 00:00:00	1979-10-30	1979-10-30 00:00:00	1979-10-30	38000177		0	0	7		0	0	0	126392	0	313782	1127433		
60534	5035	40171902	2011-08-15	2011-08-15 00:00:00	2011-08-15	2011-08-15 00:00:00	\N	38000177		0	0	0		0	0	0	334646	0	897718	40171902		
46359	3839	1713671	1961-10-31	1961-10-31 00:00:00	1961-11-14	1961-11-14 00:00:00	1961-11-14	38000177		0	0	14		0	0	0	254837	0	562251	1713671		
8746	729	1124300	2000-04-07	2000-04-07 00:00:00	2000-04-07	2000-04-07 00:00:00	\N	38000177		0	0	0		0	0	0	48365	0	00781178901	45011828		
33332	2761	1127433	2011-07-06	2011-07-06 00:00:00	2011-07-13	2011-07-13 00:00:00	2011-07-13	38000177		0	0	7		0	0	0	182638	0	313782	1127433		
14777	1236	40173590	2010-07-29	2010-07-29 00:00:00	2010-07-29	2010-07-29 00:00:00	\N	38000177		0	0	0		0	0	0	81448	0	904419	40173590		
57018	4732	19059056	1961-11-19	1961-11-19 00:00:00	1962-01-18	1962-01-18 00:00:00	1962-01-18	38000177		0	0	60		0	0	0	315273	0	243670	19059056		
28096	2325	1713671	1994-10-11	1994-10-11 00:00:00	1994-10-18	1994-10-18 00:00:00	1994-10-18	38000177		0	0	7		0	0	0	154559	0	562251	1713671		
9183	763	1713671	1994-08-09	1994-08-09 00:00:00	1994-08-16	1994-08-16 00:00:00	1994-08-16	38000177		0	0	7		0	0	0	50754	0	562251	1713671		
26546	2185	1127433	1962-04-24	1962-04-24 00:00:00	1962-05-30	1962-05-30 00:00:00	1962-05-30	38000177		0	0	36		0	0	0	145624	0	313782	1127433		
26631	2192	19006318	1957-06-22	1957-06-22 00:00:00	1957-07-06	1957-07-06 00:00:00	1957-07-06	38000177		0	0	14		0	0	0	146182	0	105078	19006318		
37112	3067	920300	1983-01-20	1983-01-20 00:00:00	1983-01-27	1983-01-27 00:00:00	1983-01-27	38000177		0	0	7		0	0	0	204155	0	311989	920300		
1417	32	40213227	1995-07-26	1995-07-26 00:00:00	1995-07-26	1995-07-26 00:00:00	1995-07-26	581452		0	0	0		0	0	0	2233	0	113	40213227		
22021	1808	19078461	2018-07-29	2018-07-29 00:00:00	2018-08-19	2018-08-19 00:00:00	2018-08-19	38000177		0	0	21		0	0	0	121087	0	310965	19078461		
37272	3080	1127433	1991-12-20	1991-12-20 00:00:00	1992-01-10	1992-01-10 00:00:00	1992-01-10	38000177		0	0	21		0	0	0	204969	0	313782	1127433		
32563	2699	19128065	1991-10-08	1991-10-08 00:00:00	1992-10-02	1992-10-02 00:00:00	1992-10-02	38000177		0	0	360		0	0	0	178744	0	749882	19128065		
32641	2705	1115171	2012-03-27	2012-03-27 00:00:00	2012-04-24	2012-04-24 00:00:00	2012-04-24	38000177		0	0	28		0	0	0	179245	0	849574	1115171		
96629	2119	40213227	1992-08-24	1992-08-24 00:00:00	1992-08-24	1992-08-24 00:00:00	1992-08-24	581452		0	0	0		0	0	0	141069	0	113	40213227		
107962	2366	40213160	1966-02-21	1966-02-21 00:00:00	1966-02-21	1966-02-21 00:00:00	1966-02-21	581452		0	0	0		0	0	0	157514	0	10	40213160		
139850	3072	40213160	1959-10-24	1959-10-24 00:00:00	1959-10-24	1959-10-24 00:00:00	1959-10-24	581452		0	0	0		0	0	0	204482	0	10	40213160		
41081	3408	1127078	1974-08-29	1974-08-29 00:00:00	1974-09-12	1974-09-12 00:00:00	1974-09-12	38000177		0	0	14		0	0	0	226050	0	282464	1127078		
108088	2369	40213160	1986-04-13	1986-04-13 00:00:00	1986-04-13	1986-04-13 00:00:00	1986-04-13	581452		0	0	0		0	0	0	157709	0	10	40213160		
58536	4859	40229134	1985-09-22	1985-09-22 00:00:00	1985-10-06	1985-10-06 00:00:00	1985-10-06	38000177		0	0	14		0	0	0	323252	0	1043400	40229134		
20368	1672	920300	1979-05-30	1979-05-30 00:00:00	1979-06-06	1979-06-06 00:00:00	1979-06-06	38000177		0	0	7		0	0	0	112256	0	311989	920300		
98654	2160	40213296	2002-07-22	2002-07-22 00:00:00	2002-07-22	2002-07-22 00:00:00	2002-07-22	581452		0	0	0		0	0	0	143946	0	52	40213296		
16697	1384	19128065	1997-03-07	1997-03-07 00:00:00	1998-03-02	1998-03-02 00:00:00	1998-03-02	38000177		0	0	360		0	0	0	91751	0	749882	19128065		
8845	738	1127078	1983-03-10	1983-03-10 00:00:00	1983-03-31	1983-03-31 00:00:00	1983-03-31	38000177		0	0	21		0	0	0	48889	0	282464	1127078		
42400	3516	19078461	2017-03-08	2017-03-08 00:00:00	2017-05-14	2017-05-14 00:00:00	2017-05-14	38000177		0	0	67		0	0	0	233369	0	310965	19078461		
17800	1475	1115171	2003-02-04	2003-02-04 00:00:00	2003-03-11	2003-03-11 00:00:00	2003-03-11	38000177		0	0	35		0	0	0	98252	0	849574	1115171		
16769	1387	1713671	1983-05-06	1983-05-06 00:00:00	1983-05-20	1983-05-20 00:00:00	1983-05-20	38000177		0	0	14		0	0	0	92002	0	562251	1713671		
4095	338	1713671	1998-11-28	1998-11-28 00:00:00	1998-12-05	1998-12-05 00:00:00	1998-12-05	38000177		0	0	7		0	0	0	22527	0	562251	1713671		
4139	343	1127433	1981-10-01	1981-10-01 00:00:00	1981-10-08	1981-10-08 00:00:00	1981-10-08	38000177		0	0	7		0	0	0	22917	0	313782	1127433		
14636	1227	1124300	1980-05-31	1980-05-31 00:00:00	1980-05-31	1980-05-31 00:00:00	\N	38000177		0	0	0		0	0	0	80727	0	00781178901	45011828		
36261	2988	40229134	2002-10-22	2002-10-22 00:00:00	2002-11-05	2002-11-05 00:00:00	2002-11-05	38000177		0	0	14		0	0	0	199471	0	1043400	40229134		
43431	3601	40169216	1962-06-25	1962-06-25 00:00:00	1962-06-25	1962-06-25 00:00:00	\N	38000177		0	0	0		0	0	0	239234	0	895994	40169216		
45709	3784	1124300	1965-02-14	1965-02-14 00:00:00	1965-02-14	1965-02-14 00:00:00	\N	38000177		0	0	0		0	0	0	251485	0	00781178901	45011828		
46871	3881	1310034	1997-01-03	1997-01-03 00:00:00	1997-01-03	1997-01-03 00:00:00	1997-01-03	38000177		0	0	0		0	0	0	257921	0	834357	1310034		
41879	3469	1127433	2001-07-18	2001-07-18 00:00:00	2001-08-01	2001-08-01 00:00:00	2001-08-01	38000177		0	0	14		0	0	0	230257	0	313782	1127433		
35576	776	40213296	1999-09-02	1999-09-02 00:00:00	1999-09-02	1999-09-02 00:00:00	1999-09-02	581452		0	0	0		0	0	0	51580	0	52	40213296		
21876	1793	1127433	1990-05-28	1990-05-28 00:00:00	1990-06-11	1990-06-11 00:00:00	1990-06-11	38000177		0	0	14		0	0	0	120243	0	313782	1127433		
49725	4125	1127078	1971-06-30	1971-06-30 00:00:00	1971-07-14	1971-07-14 00:00:00	1971-07-14	38000177		0	0	14		0	0	0	274248	0	282464	1127078		
48690	4033	1127433	2016-04-11	2016-04-11 00:00:00	2016-04-18	2016-04-18 00:00:00	2016-04-18	38000177		0	0	7		0	0	0	268372	0	313782	1127433		
60279	5013	19133768	2013-05-31	2013-05-31 00:00:00	2013-05-31	2013-05-31 00:00:00	2013-05-31	38000177		0	0	0		0	0	0	333201	0	833036	19133768		
42586	3530	19006318	1960-10-15	1960-10-15 00:00:00	1960-10-29	1960-10-29 00:00:00	1960-10-29	38000177		0	0	14		0	0	0	234480	0	105078	19006318		
3367	279	19059056	1954-03-02	1954-03-02 00:00:00	1954-03-16	1954-03-16 00:00:00	1954-03-16	38000177		0	0	14		0	0	0	18626	0	243670	19059056		
20788	1715	19078461	1996-02-08	1996-02-08 00:00:00	1996-03-14	1996-03-14 00:00:00	1996-03-14	38000177		0	0	35		0	0	0	114555	0	310965	19078461		
25902	2130	19073188	2004-02-23	2004-02-23 00:00:00	2004-03-08	2004-03-08 00:00:00	2004-03-08	38000177		0	0	14		0	0	0	141707	0	308192	19073188		
2012	160	40236824	1992-09-02	1992-09-02 00:00:00	1992-09-16	1992-09-16 00:00:00	1992-09-16	38000177		0	0	14		0	0	0	10941	0	1094107	40236824		
51912	4317	40162522	1961-11-19	1961-11-19 00:00:00	1961-11-19	1961-11-19 00:00:00	\N	38000177		0	0	0		0	0	0	286477	0	857005	40162522		
8359	697	19059056	1973-08-30	1973-08-30 00:00:00	1973-09-13	1973-09-13 00:00:00	1973-09-13	38000177		0	0	14		0	0	0	46161	0	243670	19059056		
20092	1649	19059056	1960-09-12	1960-09-12 00:00:00	1960-12-11	1960-12-11 00:00:00	1960-12-11	38000177		0	0	90		0	0	0	110676	0	243670	19059056		
18054	1496	19133905	1952-08-04	1952-08-04 00:00:00	1952-08-17	1952-08-17 00:00:00	1952-08-17	38000177		0	0	13		0	0	0	99721	0	834102	19133905		
62539	5201	19074843	1979-06-29	1979-06-29 00:00:00	1979-07-13	1979-07-13 00:00:00	1979-07-13	38000177		0	0	14		0	0	0	345963	0	309045	19074843		
3930	327	1127433	1976-04-07	1976-04-07 00:00:00	1976-04-21	1976-04-21 00:00:00	1976-04-21	38000177		0	0	14		0	0	0	21570	0	313782	1127433		
16428	354	40213260	2007-01-11	2007-01-11 00:00:00	2007-01-11	2007-01-11 00:00:00	2007-01-11	581452		0	0	0		0	0	0	23576	0	121	40213260		
33818	2798	920300	1999-12-12	1999-12-12 00:00:00	1999-12-19	1999-12-19 00:00:00	1999-12-19	38000177		0	0	7		0	0	0	185464	0	311989	920300		
26186	2153	1124300	2006-03-30	2006-03-30 00:00:00	2006-03-30	2006-03-30 00:00:00	\N	38000177		0	0	0		0	0	0	143467	0	00781178901	45011828		
50083	4156	19075601	2004-11-15	2004-11-15 00:00:00	2006-02-27	2006-02-27 00:00:00	2006-02-27	38000177		0	0	469		0	0	0	276209	0	309362	19075601		
1488	117	40231925	1982-09-22	1982-09-22 00:00:00	1982-09-22	1982-09-22 00:00:00	\N	38000177		0	0	0		0	0	0	7803	0	1049221	40231925		
11987	1000	40165015	1976-02-18	1976-02-18 00:00:00	1976-02-18	1976-02-18 00:00:00	\N	38000177		0	0	0		0	0	0	66139	0	861467	40165015		
8063	673	40165015	1983-03-20	1983-03-20 00:00:00	1983-03-20	1983-03-20 00:00:00	\N	38000177		0	0	0		0	0	0	44434	0	861467	40165015		
40292	3337	1713671	2007-11-17	2007-11-17 00:00:00	2007-12-01	2007-12-01 00:00:00	2007-12-01	38000177		0	0	14		0	0	0	221370	0	562251	1713671		
40307	3339	1124300	1995-11-23	1995-11-23 00:00:00	1995-11-23	1995-11-23 00:00:00	\N	38000177		0	0	0		0	0	0	221511	0	00781178901	45011828		
44572	3691	1127433	1984-01-05	1984-01-05 00:00:00	1984-01-19	1984-01-19 00:00:00	1984-01-19	38000177		0	0	14		0	0	0	245353	0	313782	1127433		
23024	1898	19078461	2011-08-25	2011-08-25 00:00:00	2011-09-15	2011-09-15 00:00:00	2011-09-15	38000177		0	0	21		0	0	0	126340	0	310965	19078461		
60535	5035	40163554	2011-08-15	2011-08-15 00:00:00	2011-08-15	2011-08-15 00:00:00	\N	38000177		0	0	0		0	0	0	334646	0	855332	40163554		
46360	3839	19078461	2017-04-30	2017-04-30 00:00:00	2017-05-30	2017-05-30 00:00:00	2017-05-30	38000177		0	0	30		0	0	0	254864	0	310965	19078461		
8747	729	1127433	2000-01-22	2000-01-22 00:00:00	2000-02-26	2000-02-26 00:00:00	2000-02-26	38000177		0	0	35		0	0	0	48365	0	313782	1127433		
33347	2764	1118084	2009-10-09	2009-10-09 00:00:00	2009-10-09	2009-10-09 00:00:00	\N	38000177		0	0	0		0	0	0	182790	0	00025152531	44923712		
14778	1236	19059056	1922-08-02	1922-08-02 00:00:00	1922-08-16	1922-08-16 00:00:00	1922-08-16	38000177		0	0	14		0	0	0	81409	0	243670	19059056		
57019	4732	1115171	1997-11-24	1997-11-24 00:00:00	1997-12-08	1997-12-08 00:00:00	1997-12-08	38000177		0	0	14		0	0	0	315277	0	849574	1115171		
28097	2325	1127433	2012-11-25	2012-11-25 00:00:00	2012-12-09	2012-12-09 00:00:00	2012-12-09	38000177		0	0	14		0	0	0	154564	0	313782	1127433		
9184	763	19133873	1970-01-10	1970-01-10 00:00:00	1970-01-23	1970-01-23 00:00:00	1970-01-23	38000177		0	0	13		0	0	0	50747	0	834061	19133873		
26547	2185	1115171	2015-06-05	2015-06-05 00:00:00	2015-07-05	2015-07-05 00:00:00	2015-07-05	38000177		0	0	30		0	0	0	145627	0	849574	1115171		
26632	2192	1127078	1957-06-22	1957-06-22 00:00:00	1957-07-06	1957-07-06 00:00:00	1957-07-06	38000177		0	0	14		0	0	0	146182	0	282464	1127078		
37113	3067	19059056	1943-02-01	1943-02-01 00:00:00	1943-03-01	1943-03-01 00:00:00	1943-03-01	38000177		0	0	28		0	0	0	204173	0	243670	19059056		
22382	486	40213260	2010-12-30	2010-12-30 00:00:00	2010-12-30	2010-12-30 00:00:00	2010-12-30	581452		0	0	0		0	0	0	32520	0	121	40213260		
22023	1809	1127433	1996-10-05	1996-10-05 00:00:00	1996-10-19	1996-10-19 00:00:00	1996-10-19	38000177		0	0	14		0	0	0	121120	0	313782	1127433		
37273	3080	1713671	1988-11-02	1988-11-02 00:00:00	1988-12-28	1988-12-28 00:00:00	1988-12-28	38000177		0	0	56		0	0	0	204989	0	562251	1713671		
32564	2699	19133905	2007-01-08	2007-01-08 00:00:00	2007-01-15	2007-01-15 00:00:00	2007-01-15	38000177		0	0	7		0	0	0	178720	0	834102	19133905		
32642	2705	19075001	1998-03-08	1998-03-08 00:00:00	1998-03-22	1998-03-22 00:00:00	1998-03-22	38000177		0	0	14		0	0	0	179196	0	309097	19075001		
96632	2119	40213160	1961-11-20	1961-11-20 00:00:00	1961-11-20	1961-11-20 00:00:00	1961-11-20	581452		0	0	0		0	0	0	141013	0	10	40213160		
107965	2366	40213227	1996-11-25	1996-11-25 00:00:00	1996-11-25	1996-11-25 00:00:00	1996-11-25	581452		0	0	0		0	0	0	157503	0	113	40213227		
883	72	1713671	1990-11-15	1990-11-15 00:00:00	1990-11-29	1990-11-29 00:00:00	1990-11-29	38000177		0	0	14		0	0	0	4861	0	562251	1713671		
41082	3408	19078461	1999-06-12	1999-06-12 00:00:00	1999-07-03	1999-07-03 00:00:00	1999-07-03	38000177		0	0	21		0	0	0	226022	0	310965	19078461		
108091	2369	40213314	1981-08-09	1981-08-09 00:00:00	1981-08-09	1981-08-09 00:00:00	1981-08-09	581452		0	0	0		0	0	0	157648	0	49	40213314		
58537	4859	19059056	1969-03-24	1969-03-24 00:00:00	1969-04-07	1969-04-07 00:00:00	1969-04-07	38000177		0	0	14		0	0	0	323255	0	243670	19059056		
20369	1672	40236824	1979-05-30	1979-05-30 00:00:00	1979-06-06	1979-06-06 00:00:00	1979-06-06	38000177		0	0	7		0	0	0	112256	0	1094107	40236824		
98656	2160	40213227	1992-01-27	1992-01-27 00:00:00	1992-01-27	1992-01-27 00:00:00	1992-01-27	581452		0	0	0		0	0	0	143952	0	113	40213227		
16698	1384	19133873	1997-08-30	1997-08-30 00:00:00	1997-09-10	1997-09-10 00:00:00	1997-09-10	38000177		0	0	11		0	0	0	91729	0	834061	19133873		
8846	738	1127433	1990-08-21	1990-08-21 00:00:00	1990-09-04	1990-09-04 00:00:00	1990-09-04	38000177		0	0	14		0	0	0	48890	0	313782	1127433		
42401	3516	19077572	2010-09-09	2010-09-09 00:00:00	2010-09-09	2010-09-09 00:00:00	\N	38000177		0	0	0		0	0	0	233362	0	310436	19077572		
17801	1475	1127433	1961-01-03	1961-01-03 00:00:00	1961-01-17	1961-01-17 00:00:00	1961-01-17	38000177		0	0	14		0	0	0	98249	0	313782	1127433		
16770	1387	40229134	1989-03-19	1989-03-19 00:00:00	1989-03-26	1989-03-26 00:00:00	1989-03-26	38000177		0	0	7		0	0	0	92044	0	1043400	40229134		
4096	338	19133873	1979-03-05	1979-03-05 00:00:00	1979-03-13	1979-03-13 00:00:00	1979-03-13	38000177		0	0	8		0	0	0	22566	0	834061	19133873		
4140	343	1713671	2007-08-11	2007-08-11 00:00:00	2007-08-25	2007-08-25 00:00:00	2007-08-25	38000177		0	0	14		0	0	0	22862	0	562251	1713671		
14637	1227	19133905	1967-01-21	1967-01-21 00:00:00	1967-02-02	1967-02-02 00:00:00	1967-02-02	38000177		0	0	12		0	0	0	80780	0	834102	19133905		
36262	2988	19129655	1965-10-22	1965-10-22 00:00:00	1965-11-05	1965-11-05 00:00:00	1965-11-05	38000177		0	0	14		0	0	0	199473	0	789980	19129655		
43432	3601	1154615	1962-06-25	1962-06-25 00:00:00	1962-06-25	1962-06-25 00:00:00	\N	38000177		0	0	0		0	0	0	239234	0	745679	1154615		
45710	3784	19059056	1945-07-19	1945-07-19 00:00:00	1945-09-17	1945-09-17 00:00:00	1945-09-17	38000177		0	0	60		0	0	0	251487	0	243670	19059056		
46872	3881	46275916	1997-01-03	1997-01-03 00:00:00	1997-01-03	1997-01-03 00:00:00	1997-01-03	38000177		0	0	0		0	0	0	257921	0	1660014	46275916		
41880	3469	19078461	1991-06-17	1991-06-17 00:00:00	1991-07-01	1991-07-01 00:00:00	1991-07-01	38000177		0	0	14		0	0	0	230253	0	310965	19078461		
35577	776	40213227	1999-09-02	1999-09-02 00:00:00	1999-09-02	1999-09-02 00:00:00	1999-09-02	581452		0	0	0		0	0	0	51580	0	113	40213227		
21877	1793	40229134	1932-07-29	1932-07-29 00:00:00	1932-08-12	1932-08-12 00:00:00	1932-08-12	38000177		0	0	14		0	0	0	120238	0	1043400	40229134		
49726	4125	46233988	1971-06-30	1971-06-30 00:00:00	1971-07-14	1971-07-14 00:00:00	1971-07-14	38000177		0	0	14		0	0	0	274248	0	1652673	46233988		
48691	4033	19073188	2017-02-03	2017-02-03 00:00:00	2017-02-17	2017-02-17 00:00:00	2017-02-17	38000177		0	0	14		0	0	0	268386	0	308192	19073188		
60280	5013	19126352	2010-09-10	2010-09-10 00:00:00	2013-05-31	2013-05-31 00:00:00	2013-05-31	38000177		0	0	994		0	0	0	333181	0	705129	19126352		
42587	3531	1124300	2001-07-08	2001-07-08 00:00:00	2001-07-08	2001-07-08 00:00:00	\N	38000177		0	0	0		0	0	0	234537	0	00781178901	45011828		
3368	279	1127433	1965-12-05	1965-12-05 00:00:00	1965-12-12	1965-12-12 00:00:00	1965-12-12	38000177		0	0	7		0	0	0	18633	0	313782	1127433		
20789	1715	1127433	1964-01-15	1964-01-15 00:00:00	1964-01-22	1964-01-22 00:00:00	1964-01-22	38000177		0	0	7		0	0	0	114561	0	313782	1127433		
25903	2130	40229134	1982-02-14	1982-02-14 00:00:00	1982-02-28	1982-02-28 00:00:00	1982-02-28	38000177		0	0	14		0	0	0	141744	0	1043400	40229134		
2013	160	40229134	1980-01-14	1980-01-14 00:00:00	1980-01-28	1980-01-28 00:00:00	1980-01-28	38000177		0	0	14		0	0	0	10945	0	1043400	40229134		
51913	4317	19075601	2018-11-01	2018-11-01 00:00:00	2018-11-01	2018-11-01 00:00:00	\N	38000177		0	0	0		0	0	0	286529	0	309362	19075601		
8360	697	1127433	1989-03-28	1989-03-28 00:00:00	1989-04-04	1989-04-04 00:00:00	1989-04-04	38000177		0	0	7		0	0	0	46109	0	313782	1127433		
20127	1655	1115171	2002-09-18	2002-09-18 00:00:00	2002-10-02	2002-10-02 00:00:00	2002-10-02	38000177		0	0	14		0	0	0	110988	0	849574	1115171		
18055	1496	1127433	1977-03-31	1977-03-31 00:00:00	1977-04-14	1977-04-14 00:00:00	1977-04-14	38000177		0	0	14		0	0	0	99698	0	313782	1127433		
62540	5201	19019979	1979-06-29	1979-06-29 00:00:00	1979-07-13	1979-07-13 00:00:00	1979-07-13	38000177		0	0	14		0	0	0	345963	0	198405	19019979		
3931	327	1127433	1983-10-26	1983-10-26 00:00:00	1983-11-16	1983-11-16 00:00:00	1983-11-16	38000177		0	0	21		0	0	0	21618	0	313782	1127433		
16440	354	40213227	1998-01-15	1998-01-15 00:00:00	1998-01-15	1998-01-15 00:00:00	1998-01-15	581452		0	0	0		0	0	0	23566	0	113	40213227		
33819	2798	1127433	1973-03-21	1973-03-21 00:00:00	1973-04-04	1973-04-04 00:00:00	1973-04-04	38000177		0	0	14		0	0	0	185459	0	313782	1127433		
26187	2153	19128065	1988-09-30	1988-09-30 00:00:00	1989-09-25	1989-09-25 00:00:00	1989-09-25	38000177		0	0	360		0	0	0	143510	0	749882	19128065		
50084	4156	1539411	2004-11-15	2004-11-15 00:00:00	2004-11-15	2004-11-15 00:00:00	\N	38000177		0	0	0		0	0	0	276209	0	312961	1539411		
1489	117	1127433	1974-07-08	1974-07-08 00:00:00	1974-07-15	1974-07-15 00:00:00	1974-07-15	38000177		0	0	7		0	0	0	7757	0	313782	1127433		
11988	1000	19074679	2017-01-29	2017-01-29 00:00:00	2017-07-30	2017-07-30 00:00:00	2017-07-30	38000177		0	0	182		0	0	0	66142	0	308971	19074679		
8064	673	19073188	1983-03-20	1983-03-20 00:00:00	1983-04-10	1983-04-10 00:00:00	1983-04-10	38000177		0	0	21		0	0	0	44434	0	308192	19073188		
40293	3337	40229134	2010-07-24	2010-07-24 00:00:00	2010-07-31	2010-07-31 00:00:00	2010-07-31	38000177		0	0	7		0	0	0	221371	0	1043400	40229134		
40308	3339	19059056	1970-02-10	1970-02-10 00:00:00	1970-02-24	1970-02-24 00:00:00	1970-02-24	38000177		0	0	14		0	0	0	221530	0	243670	19059056		
44575	3691	19078461	1989-12-24	1989-12-24 00:00:00	1990-01-14	1990-01-14 00:00:00	1990-01-14	38000177		0	0	21		0	0	0	245330	0	310965	19078461		
23025	1898	1713671	2007-12-16	2007-12-16 00:00:00	2008-01-06	2008-01-06 00:00:00	2008-01-06	38000177		0	0	21		0	0	0	126399	0	562251	1713671		
60536	5035	40222846	2010-07-29	2010-07-29 00:00:00	2010-07-29	2010-07-29 00:00:00	\N	38000177		0	0	0		0	0	0	334568	0	996740	40222846		
46361	3839	920300	1987-11-11	1987-11-11 00:00:00	1987-11-18	1987-11-18 00:00:00	1987-11-18	38000177		0	0	7		0	0	0	254841	0	311989	920300		
8748	729	40229134	1974-01-25	1974-01-25 00:00:00	1974-02-08	1974-02-08 00:00:00	1974-02-08	38000177		0	0	14		0	0	0	48368	0	1043400	40229134		
33348	2764	19128065	1987-08-21	1987-08-21 00:00:00	1988-08-15	1988-08-15 00:00:00	1988-08-15	38000177		0	0	360		0	0	0	182792	0	749882	19128065		
14779	1236	19059056	1966-12-28	1966-12-28 00:00:00	1967-03-05	1967-03-05 00:00:00	1967-03-05	38000177		0	0	67		0	0	0	81484	0	243670	19059056		
57020	4732	40229134	1995-02-28	1995-02-28 00:00:00	1995-03-07	1995-03-07 00:00:00	1995-03-07	38000177		0	0	7		0	0	0	315282	0	1043400	40229134		
28098	2325	1118084	2013-04-06	2013-04-06 00:00:00	2013-04-06	2013-04-06 00:00:00	\N	38000177		0	0	0		0	0	0	154598	0	00025152531	44923712		
9185	763	19128065	1981-03-04	1981-03-04 00:00:00	1982-02-27	1982-02-27 00:00:00	1982-02-27	38000177		0	0	360		0	0	0	50761	0	749882	19128065		
26548	2185	1118084	1981-03-18	1981-03-18 00:00:00	1981-03-18	1981-03-18 00:00:00	\N	38000177		0	0	0		0	0	0	145679	0	00025152531	44923712		
26633	2192	1127433	1959-08-10	1959-08-10 00:00:00	1959-08-17	1959-08-17 00:00:00	1959-08-17	38000177		0	0	7		0	0	0	146221	0	313782	1127433		
37114	3067	1127433	1998-03-08	1998-03-08 00:00:00	1998-03-29	1998-03-29 00:00:00	1998-03-29	38000177		0	0	21		0	0	0	204186	0	313782	1127433		
22388	486	40213160	1961-02-09	1961-02-09 00:00:00	1961-02-09	1961-02-09 00:00:00	1961-02-09	581452		0	0	0		0	0	0	32473	0	10	40213160		
22024	1809	19133873	1964-07-05	1964-07-05 00:00:00	1964-07-13	1964-07-13 00:00:00	1964-07-13	38000177		0	0	8		0	0	0	121091	0	834061	19133873		
37274	3080	1118084	1981-09-18	1981-09-18 00:00:00	1981-09-18	1981-09-18 00:00:00	\N	38000177		0	0	0		0	0	0	205038	0	00025152531	44923712		
32584	2702	19059056	1943-05-31	1943-05-31 00:00:00	1943-06-14	1943-06-14 00:00:00	1943-06-14	38000177		0	0	14		0	0	0	178941	0	243670	19059056		
14855	321	40213160	1962-02-18	1962-02-18 00:00:00	1962-02-18	1962-02-18 00:00:00	1962-02-18	581452		0	0	0		0	0	0	21279	0	10	40213160		
96638	2119	40213306	1983-08-15	1983-08-15 00:00:00	1983-08-15	1983-08-15 00:00:00	1983-08-15	581452		0	0	0		0	0	0	141044	0	43	40213306		
107968	2366	40213260	2015-09-14	2015-09-14 00:00:00	2015-09-14	2015-09-14 00:00:00	2015-09-14	581452		0	0	0		0	0	0	157508	0	121	40213260		
884	72	1127433	1979-07-10	1979-07-10 00:00:00	1979-08-07	1979-08-07 00:00:00	1979-08-07	38000177		0	0	28		0	0	0	4857	0	313782	1127433		
41083	3409	19078461	1984-06-04	1984-06-04 00:00:00	1984-06-18	1984-06-18 00:00:00	1984-06-18	38000177		0	0	14		0	0	0	226121	0	310965	19078461		
108092	2369	40213160	1981-08-09	1981-08-09 00:00:00	1981-08-09	1981-08-09 00:00:00	1981-08-09	581452		0	0	0		0	0	0	157648	0	10	40213160		
58538	4859	19006318	1969-03-24	1969-03-24 00:00:00	1969-04-07	1969-04-07 00:00:00	1969-04-07	38000177		0	0	14		0	0	0	323255	0	105078	19006318		
20370	1672	1127078	1957-03-09	1957-03-09 00:00:00	1957-03-30	1957-03-30 00:00:00	1957-03-30	38000177		0	0	21		0	0	0	112278	0	282464	1127078		
98671	2160	40213260	2011-01-17	2011-01-17 00:00:00	2011-01-17	2011-01-17 00:00:00	2011-01-17	581452		0	0	0		0	0	0	143941	0	121	40213260		
16699	1384	1127078	1986-12-09	1986-12-09 00:00:00	1986-12-23	1986-12-23 00:00:00	1986-12-23	38000177		0	0	14		0	0	0	91750	0	282464	1127078		
8847	739	40229134	1937-06-17	1937-06-17 00:00:00	1937-07-01	1937-07-01 00:00:00	1937-07-01	38000177		0	0	14		0	0	0	48977	0	1043400	40229134		
42402	3516	40222846	2012-01-02	2012-01-02 00:00:00	2012-01-02	2012-01-02 00:00:00	\N	38000177		0	0	0		0	0	0	233394	0	996740	40222846		
17802	1475	19078461	1984-12-26	1984-12-26 00:00:00	1985-01-09	1985-01-09 00:00:00	1985-01-09	38000177		0	0	14		0	0	0	98251	0	310965	19078461		
16771	1387	920334	2013-04-28	2013-04-28 00:00:00	2013-05-05	2013-05-05 00:00:00	2013-05-05	38000177		0	0	7		0	0	0	92090	0	311995	920334		
4097	339	1118084	2019-06-21	2019-06-21 00:00:00	2019-06-21	2019-06-21 00:00:00	\N	38000177		0	0	0		0	0	0	22635	0	00025152531	44923712		
4141	343	920300	1999-03-05	1999-03-05 00:00:00	1999-03-12	1999-03-12 00:00:00	1999-03-12	38000177		0	0	7		0	0	0	22887	0	311989	920300		
14638	1227	1127433	1965-03-07	1965-03-07 00:00:00	1965-03-14	1965-03-14 00:00:00	1965-03-14	38000177		0	0	7		0	0	0	80749	0	313782	1127433		
36263	2988	19059056	1965-10-22	1965-10-22 00:00:00	1965-11-05	1965-11-05 00:00:00	1965-11-05	38000177		0	0	14		0	0	0	199473	0	243670	19059056		
43433	3601	40232448	1964-07-08	1964-07-08 00:00:00	1964-07-08	1964-07-08 00:00:00	\N	38000177		0	0	0		0	0	0	239133	0	1049630	40232448		
45711	3784	40174880	1984-06-24	1984-06-24 00:00:00	1984-06-24	1984-06-24 00:00:00	\N	38000177		0	0	0		0	0	0	251500	0	966222	40174880		
46873	3881	1713671	2013-02-03	2013-02-03 00:00:00	2013-02-17	2013-02-17 00:00:00	2013-02-17	38000177		0	0	14		0	0	0	257889	0	562251	1713671		
41881	3469	19059056	1958-06-08	1958-06-08 00:00:00	1958-06-22	1958-06-22 00:00:00	1958-06-22	38000177		0	0	14		0	0	0	230214	0	243670	19059056		
35591	776	40213160	1959-01-08	1959-01-08 00:00:00	1959-01-08	1959-01-08 00:00:00	1959-01-08	581452		0	0	0		0	0	0	51565	0	10	40213160		
21878	1793	1539411	1991-06-12	1991-06-12 00:00:00	1991-06-12	1991-06-12 00:00:00	\N	38000177		0	0	0		0	0	0	120187	0	312961	1539411		
49727	4125	40229134	2015-05-20	2015-05-20 00:00:00	2015-05-27	2015-05-27 00:00:00	2015-05-27	38000177		0	0	7		0	0	0	274264	0	1043400	40229134		
48692	4033	1127433	2017-02-03	2017-02-03 00:00:00	2017-02-17	2017-02-17 00:00:00	2017-02-17	38000177		0	0	14		0	0	0	268386	0	313782	1127433		
10236	219	40213160	1973-02-10	1973-02-10 00:00:00	1973-02-10	1973-02-10 00:00:00	1973-02-10	581452		0	0	0		0	0	0	\N	0	10	40213160		
42588	3531	46233988	1971-04-15	1971-04-15 00:00:00	1971-04-29	1971-04-29 00:00:00	1971-04-29	38000177		0	0	14		0	0	0	234564	0	1652673	46233988		
3369	279	1713671	2002-12-29	2002-12-29 00:00:00	2003-01-19	2003-01-19 00:00:00	2003-01-19	38000177		0	0	21		0	0	0	18595	0	562251	1713671		
20790	1715	1127433	1970-06-20	1970-06-20 00:00:00	1970-06-27	1970-06-27 00:00:00	1970-06-27	38000177		0	0	7		0	0	0	114562	0	313782	1127433		
25904	2131	1127433	1955-12-03	1955-12-03 00:00:00	1955-12-10	1955-12-10 00:00:00	1955-12-10	38000177		0	0	7		0	0	0	141762	0	313782	1127433		
2015	160	40229134	1990-01-13	1990-01-13 00:00:00	1990-01-27	1990-01-27 00:00:00	1990-01-27	38000177		0	0	14		0	0	0	10947	0	1043400	40229134		
51914	4317	1332419	2018-11-01	2018-11-01 00:00:00	2018-11-01	2018-11-01 00:00:00	\N	38000177		0	0	0		0	0	0	286529	0	197361	1332419		
8361	697	1713671	1988-07-01	1988-07-01 00:00:00	1988-07-15	1988-07-15 00:00:00	1988-07-15	38000177		0	0	14		0	0	0	46103	0	562251	1713671		
20128	1655	19133873	1986-04-10	1986-04-10 00:00:00	1986-04-18	1986-04-18 00:00:00	1986-04-18	38000177		0	0	8		0	0	0	110983	0	834061	19133873		
18056	1496	19133905	1980-06-12	1980-06-12 00:00:00	1980-06-24	1980-06-24 00:00:00	1980-06-24	38000177		0	0	12		0	0	0	99733	0	834102	19133905		
62541	5201	40236824	2015-05-12	2015-05-12 00:00:00	2015-05-19	2015-05-19 00:00:00	2015-05-19	38000177		0	0	7		0	0	0	345962	0	1094107	40236824		
3932	327	40229134	2000-07-17	2000-07-17 00:00:00	2000-07-31	2000-07-31 00:00:00	2000-07-31	38000177		0	0	14		0	0	0	21574	0	1043400	40229134		
16441	354	40213296	1998-01-15	1998-01-15 00:00:00	1998-01-15	1998-01-15 00:00:00	1998-01-15	581452		0	0	0		0	0	0	23566	0	52	40213296		
33820	2798	19059056	1973-05-27	1973-05-27 00:00:00	1973-06-24	1973-06-24 00:00:00	1973-06-24	38000177		0	0	28		0	0	0	185430	0	243670	19059056		
26188	2153	19128065	1982-11-01	1982-11-01 00:00:00	1983-10-27	1983-10-27 00:00:00	1983-10-27	38000177		0	0	360		0	0	0	143481	0	749882	19128065		
50085	4156	1127433	2017-12-24	2017-12-24 00:00:00	2017-12-31	2017-12-31 00:00:00	2017-12-31	38000177		0	0	7		0	0	0	276181	0	313782	1127433		
11967	1000	19059056	1964-11-03	1964-11-03 00:00:00	1964-12-03	1964-12-03 00:00:00	1964-12-03	38000177		0	0	30		0	0	0	66135	0	243670	19059056		
12015	1004	40229134	1986-12-13	1986-12-13 00:00:00	1986-12-20	1986-12-20 00:00:00	1986-12-20	38000177		0	0	7		0	0	0	66383	0	1043400	40229134		
8065	673	1127433	1983-03-20	1983-03-20 00:00:00	1983-04-10	1983-04-10 00:00:00	1983-04-10	38000177		0	0	21		0	0	0	44434	0	313782	1127433		
8086	675	1154615	1952-02-23	1952-02-23 00:00:00	1952-02-23	1952-02-23 00:00:00	\N	38000177		0	0	0		0	0	0	44712	0	745679	1154615		
40309	3339	19129655	1970-02-10	1970-02-10 00:00:00	1970-02-24	1970-02-24 00:00:00	1970-02-24	38000177		0	0	14		0	0	0	221530	0	789980	19129655		
44576	3691	19059056	1955-09-07	1955-09-07 00:00:00	1955-09-21	1955-09-21 00:00:00	1955-09-21	38000177		0	0	14		0	0	0	245349	0	243670	19059056		
23026	1898	19078461	1994-06-04	1994-06-04 00:00:00	1994-06-25	1994-06-25 00:00:00	1994-06-25	38000177		0	0	21		0	0	0	126338	0	310965	19078461		
60537	5035	19078461	1997-08-14	1997-08-14 00:00:00	1997-10-13	1997-10-13 00:00:00	1997-10-13	38000177		0	0	60		0	0	0	334576	0	310965	19078461		
46362	3839	40236824	1987-11-11	1987-11-11 00:00:00	1987-11-18	1987-11-18 00:00:00	1987-11-18	38000177		0	0	7		0	0	0	254841	0	1094107	40236824		
60259	1318	40213201	2004-07-20	2004-07-20 00:00:00	2004-07-20	2004-07-20 00:00:00	2004-07-20	581452		0	0	0		0	0	0	87386	0	33	40213201		
33349	2764	1713671	1988-12-10	1988-12-10 00:00:00	1988-12-17	1988-12-17 00:00:00	1988-12-17	38000177		0	0	7		0	0	0	182781	0	562251	1713671		
14780	1236	1118084	1963-09-07	1963-09-07 00:00:00	1963-09-07	1963-09-07 00:00:00	\N	38000177		0	0	0		0	0	0	81358	0	00025152531	44923712		
57021	4732	19059056	1976-06-03	1976-06-03 00:00:00	1976-06-17	1976-06-17 00:00:00	1976-06-17	38000177		0	0	14		0	0	0	315276	0	243670	19059056		
28099	2325	43012754	1996-08-23	1996-08-23 00:00:00	1997-08-18	1997-08-18 00:00:00	1997-08-18	38000177		0	0	360		0	0	0	154569	0	1366343	43012754		
9186	763	1127078	1966-07-11	1966-07-11 00:00:00	1966-07-25	1966-07-25 00:00:00	1966-07-25	38000177		0	0	14		0	0	0	50763	0	282464	1127078		
26549	2185	1713671	1986-07-11	1986-07-11 00:00:00	1986-07-18	1986-07-18 00:00:00	1986-07-18	38000177		0	0	7		0	0	0	145656	0	562251	1713671		
26634	2192	1127433	1997-01-11	1997-01-11 00:00:00	1997-01-18	1997-01-18 00:00:00	1997-01-18	38000177		0	0	7		0	0	0	146174	0	313782	1127433		
37115	3067	1713671	1968-04-02	1968-04-02 00:00:00	1968-04-30	1968-04-30 00:00:00	1968-04-30	38000177		0	0	28		0	0	0	204132	0	562251	1713671		
22390	486	40213160	1961-04-13	1961-04-13 00:00:00	1961-04-13	1961-04-13 00:00:00	1961-04-13	581452		0	0	0		0	0	0	32511	0	10	40213160		
22025	1809	1124300	1995-01-23	1995-01-23 00:00:00	1995-01-23	1995-01-23 00:00:00	\N	38000177		0	0	0		0	0	0	121106	0	00781178901	45011828		
37275	3081	1127433	1984-05-14	1984-05-14 00:00:00	1984-05-21	1984-05-21 00:00:00	1984-05-21	38000177		0	0	7		0	0	0	205099	0	313782	1127433		
32585	2702	19059056	1947-04-10	1947-04-10 00:00:00	1947-04-24	1947-04-24 00:00:00	1947-04-24	38000177		0	0	14		0	0	0	179039	0	243670	19059056		
94819	2080	40213227	2003-09-12	2003-09-12 00:00:00	2003-09-12	2003-09-12 00:00:00	2003-09-12	581452		0	0	0		0	0	0	138593	0	113	40213227		
96647	2119	40213160	1966-05-23	1966-05-23 00:00:00	1966-05-23	1966-05-23 00:00:00	1966-05-23	581452		0	0	0		0	0	0	141015	0	10	40213160		
107970	2366	40213227	2007-09-24	2007-09-24 00:00:00	2007-09-24	2007-09-24 00:00:00	2007-09-24	581452		0	0	0		0	0	0	157538	0	113	40213227		
885	72	1713671	2005-06-20	2005-06-20 00:00:00	2005-07-11	2005-07-11 00:00:00	2005-07-11	38000177		0	0	21		0	0	0	4862	0	562251	1713671		
41084	3409	1124300	1999-08-19	1999-08-19 00:00:00	1999-08-19	1999-08-19 00:00:00	\N	38000177		0	0	0		0	0	0	226105	0	00781178901	45011828		
108097	2369	40213227	2013-07-28	2013-07-28 00:00:00	2013-07-28	2013-07-28 00:00:00	2013-07-28	581452		0	0	0		0	0	0	157730	0	113	40213227		
58540	4859	1118084	1993-11-01	1993-11-01 00:00:00	1993-11-01	1993-11-01 00:00:00	\N	38000177		0	0	0		0	0	0	323200	0	00025152531	44923712		
20371	1672	19073188	2000-01-15	2000-01-15 00:00:00	2000-01-29	2000-01-29 00:00:00	2000-01-29	38000177		0	0	14		0	0	0	112282	0	308192	19073188		
20387	1674	1127433	2008-09-09	2008-09-09 00:00:00	2008-09-16	2008-09-16 00:00:00	2008-09-16	38000177		0	0	7		0	0	0	112392	0	313782	1127433		
16700	1384	19073183	1986-12-09	1986-12-09 00:00:00	1986-12-23	1986-12-23 00:00:00	1986-12-23	38000177		0	0	14		0	0	0	91750	0	308182	19073183		
8848	739	1127433	1987-10-16	1987-10-16 00:00:00	1987-11-20	1987-11-20 00:00:00	1987-11-20	38000177		0	0	35		0	0	0	48932	0	313782	1127433		
42403	3516	1115171	1996-09-24	1996-09-24 00:00:00	1996-11-23	1996-11-23 00:00:00	1996-11-23	38000177		0	0	60		0	0	0	233368	0	849574	1115171		
17803	1475	1127433	1963-12-30	1963-12-30 00:00:00	1964-01-13	1964-01-13 00:00:00	1964-01-13	38000177		0	0	14		0	0	0	98220	0	313782	1127433		
16772	1387	40229134	2000-08-26	2000-08-26 00:00:00	2000-09-02	2000-09-02 00:00:00	2000-09-02	38000177		0	0	7		0	0	0	92015	0	1043400	40229134		
4098	339	1713671	1994-10-17	1994-10-17 00:00:00	1995-02-13	1995-02-13 00:00:00	1995-02-13	38000177		0	0	119		0	0	0	22620	0	562251	1713671		
4142	343	40236824	1999-03-05	1999-03-05 00:00:00	1999-03-12	1999-03-12 00:00:00	1999-03-12	38000177		0	0	7		0	0	0	22887	0	1094107	40236824		
14639	1227	19133905	1984-12-27	1984-12-27 00:00:00	1985-01-04	1985-01-04 00:00:00	1985-01-04	38000177		0	0	8		0	0	0	80755	0	834102	19133905		
36264	2988	1127433	1993-01-03	1993-01-03 00:00:00	1993-03-11	1993-03-11 00:00:00	1993-03-11	38000177		0	0	67		0	0	0	199427	0	313782	1127433		
43434	3601	1127433	2011-12-28	2011-12-28 00:00:00	2012-02-01	2012-02-01 00:00:00	2012-02-01	38000177		0	0	35		0	0	0	239212	0	313782	1127433		
45712	3784	40169281	1983-07-26	1983-07-26 00:00:00	1983-07-26	1983-07-26 00:00:00	\N	38000177		0	0	0		0	0	0	251459	0	896209	40169281		
46883	3884	1127078	1976-08-22	1976-08-22 00:00:00	1976-09-05	1976-09-05 00:00:00	1976-09-05	38000177		0	0	14		0	0	0	258192	0	282464	1127078		
41882	3469	19006318	1958-06-08	1958-06-08 00:00:00	1958-06-22	1958-06-22 00:00:00	1958-06-22	38000177		0	0	14		0	0	0	230214	0	105078	19006318		
35593	776	40213296	2001-09-06	2001-09-06 00:00:00	2001-09-06	2001-09-06 00:00:00	2001-09-06	581452		0	0	0		0	0	0	51555	0	52	40213296		
21879	1793	19059056	1919-07-07	1919-07-07 00:00:00	1919-09-05	1919-09-05 00:00:00	1919-09-05	38000177		0	0	60		0	0	0	120220	0	243670	19059056		
49728	4125	1127433	2017-11-03	2017-11-03 00:00:00	2017-11-10	2017-11-10 00:00:00	2017-11-10	38000177		0	0	7		0	0	0	274219	0	313782	1127433		
48693	4033	1118084	2014-07-25	2014-07-25 00:00:00	2014-07-25	2014-07-25 00:00:00	\N	38000177		0	0	0		0	0	0	268323	0	00025152531	44923712		
10241	219	40213227	2000-06-24	2000-06-24 00:00:00	2000-06-24	2000-06-24 00:00:00	2000-06-24	581452		0	0	0		0	0	0	14746	0	113	40213227		
42589	3531	19059056	1971-04-15	1971-04-15 00:00:00	1971-04-29	1971-04-29 00:00:00	1971-04-29	38000177		0	0	14		0	0	0	234564	0	243670	19059056		
3370	279	19078461	2012-02-27	2012-02-27 00:00:00	2012-03-19	2012-03-19 00:00:00	2012-03-19	38000177		0	0	21		0	0	0	18613	0	310965	19078461		
20791	1715	1124300	1999-05-29	1999-05-29 00:00:00	1999-05-29	1999-05-29 00:00:00	\N	38000177		0	0	0		0	0	0	114564	0	00781178901	45011828		
25905	2131	1127078	1962-06-19	1962-06-19 00:00:00	1962-07-10	1962-07-10 00:00:00	1962-07-10	38000177		0	0	21		0	0	0	141825	0	282464	1127078		
2016	160	19133905	1998-05-31	1998-05-31 00:00:00	1998-06-11	1998-06-11 00:00:00	1998-06-11	38000177		0	0	11		0	0	0	10980	0	834102	19133905		
51915	4317	1539411	2018-11-01	2018-11-01 00:00:00	2018-11-01	2018-11-01 00:00:00	\N	38000177		0	0	0		0	0	0	286529	0	312961	1539411		
8362	697	1118084	2000-03-21	2000-03-21 00:00:00	2000-03-21	2000-03-21 00:00:00	\N	38000177		0	0	0		0	0	0	46146	0	00025152531	44923712		
56252	4668	1118084	1997-05-20	1997-05-20 00:00:00	1997-05-20	1997-05-20 00:00:00	\N	38000177		0	0	0		0	0	0	311048	0	00025152531	44923712		
18057	1496	19059056	1949-07-11	1949-07-11 00:00:00	1949-08-15	1949-08-15 00:00:00	1949-08-15	38000177		0	0	35		0	0	0	99739	0	243670	19059056		
62542	5201	920300	2015-05-12	2015-05-12 00:00:00	2015-05-19	2015-05-19 00:00:00	2015-05-19	38000177		0	0	7		0	0	0	345962	0	311989	920300		
3933	327	1124300	2010-12-03	2010-12-03 00:00:00	2010-12-03	2010-12-03 00:00:00	\N	38000177		0	0	0		0	0	0	21621	0	00781178901	45011828		
22582	489	40213227	2007-03-25	2007-03-25 00:00:00	2007-03-25	2007-03-25 00:00:00	2007-03-25	581452		0	0	0		0	0	0	32778	0	113	40213227		
33821	2798	1713671	2013-08-06	2013-08-06 00:00:00	2013-08-27	2013-08-27 00:00:00	2013-08-27	38000177		0	0	21		0	0	0	185465	0	562251	1713671		
26189	2153	19078461	1992-09-18	1992-09-18 00:00:00	1992-10-09	1992-10-09 00:00:00	1992-10-09	38000177		0	0	21		0	0	0	143470	0	310965	19078461		
50086	4156	1118084	1997-03-02	1997-03-02 00:00:00	1997-03-02	1997-03-02 00:00:00	\N	38000177		0	0	0		0	0	0	276208	0	00025152531	44923712		
11970	1000	1127433	1972-04-20	1972-04-20 00:00:00	1972-05-04	1972-05-04 00:00:00	1972-05-04	38000177		0	0	14		0	0	0	66133	0	313782	1127433		
12017	1004	1127433	2003-10-29	2003-10-29 00:00:00	2003-11-05	2003-11-05 00:00:00	2003-11-05	38000177		0	0	7		0	0	0	66378	0	313782	1127433		
8066	673	1115171	2014-08-05	2014-08-05 00:00:00	2014-09-04	2014-09-04 00:00:00	2014-09-04	38000177		0	0	30		0	0	0	44441	0	849574	1115171		
8087	675	40169216	1952-02-23	1952-02-23 00:00:00	1952-02-23	1952-02-23 00:00:00	\N	38000177		0	0	0		0	0	0	44712	0	895994	40169216		
40310	3339	19133873	1969-02-14	1969-02-14 00:00:00	1969-02-21	1969-02-21 00:00:00	1969-02-21	38000177		0	0	7		0	0	0	221475	0	834061	19133873		
44577	3691	1127433	1988-03-20	1988-03-20 00:00:00	1988-04-03	1988-04-03 00:00:00	1988-04-03	38000177		0	0	14		0	0	0	245329	0	313782	1127433		
23037	1900	40229134	2017-08-26	2017-08-26 00:00:00	2017-09-02	2017-09-02 00:00:00	2017-09-02	38000177		0	0	7		0	0	0	126456	0	1043400	40229134		
60538	5035	19059056	1932-09-19	1932-09-19 00:00:00	1932-10-03	1932-10-03 00:00:00	1932-10-03	38000177		0	0	14		0	0	0	334570	0	243670	19059056		
46368	3841	19128065	1993-08-14	1993-08-14 00:00:00	1994-08-09	1994-08-09 00:00:00	1994-08-09	38000177		0	0	360		0	0	0	254991	0	749882	19128065		
60269	1318	40213227	2009-08-18	2009-08-18 00:00:00	2009-08-18	2009-08-18 00:00:00	2009-08-18	581452		0	0	0		0	0	0	87415	0	113	40213227		
33350	2764	19128022	1995-07-20	1995-07-20 00:00:00	1996-07-14	1996-07-14 00:00:00	1996-07-14	38000177		0	0	360		0	0	0	182809	0	749785	19128022		
14781	1236	1127433	1978-11-02	1978-11-02 00:00:00	1978-11-16	1978-11-16 00:00:00	1978-11-16	38000177		0	0	14		0	0	0	81485	0	313782	1127433		
57022	4732	1127433	1982-08-03	1982-08-03 00:00:00	1982-08-17	1982-08-17 00:00:00	1982-08-17	38000177		0	0	14		0	0	0	315280	0	313782	1127433		
28100	2325	920334	2014-11-22	2014-11-22 00:00:00	2014-11-29	2014-11-29 00:00:00	2014-11-29	38000177		0	0	7		0	0	0	154606	0	311995	920334		
9187	763	19129655	1966-07-11	1966-07-11 00:00:00	1966-07-25	1966-07-25 00:00:00	1966-07-25	38000177		0	0	14		0	0	0	50763	0	789980	19129655		
26550	2185	920300	1990-04-03	1990-04-03 00:00:00	1990-04-10	1990-04-10 00:00:00	1990-04-10	38000177		0	0	7		0	0	0	145696	0	311989	920300		
26637	2192	40236824	2002-01-26	2002-01-26 00:00:00	2002-02-02	2002-02-02 00:00:00	2002-02-02	38000177		0	0	7		0	0	0	146148	0	1094107	40236824		
37116	3067	40162522	2010-12-05	2010-12-05 00:00:00	2010-12-05	2010-12-05 00:00:00	\N	38000177		0	0	0		0	0	0	204188	0	857005	40162522		
22393	486	40213306	1983-01-06	1983-01-06 00:00:00	1983-01-06	1983-01-06 00:00:00	1983-01-06	581452		0	0	0		0	0	0	32500	0	43	40213306		
22026	1809	1127433	1978-08-20	1978-08-20 00:00:00	1978-10-19	1978-10-19 00:00:00	1978-10-19	38000177		0	0	60		0	0	0	121088	0	313782	1127433		
37276	3081	19078461	1976-07-14	1976-07-14 00:00:00	1976-08-11	1976-08-11 00:00:00	1976-08-11	38000177		0	0	28		0	0	0	205134	0	310965	19078461		
32586	2702	40236824	1980-11-17	1980-11-17 00:00:00	1980-11-24	1980-11-24 00:00:00	1980-11-24	38000177		0	0	7		0	0	0	178997	0	1094107	40236824		
94822	2080	40213306	2000-07-14	2000-07-14 00:00:00	2000-07-14	2000-07-14 00:00:00	2000-07-14	581452		0	0	0		0	0	0	138555	0	43	40213306		
96650	2119	40213160	1962-02-19	1962-02-19 00:00:00	1962-02-19	1962-02-19 00:00:00	1962-02-19	581452		0	0	0		0	0	0	140983	0	10	40213160		
107971	2366	40213296	2007-09-24	2007-09-24 00:00:00	2007-09-24	2007-09-24 00:00:00	2007-09-24	581452		0	0	0		0	0	0	157538	0	52	40213296		
886	72	19078461	2008-06-19	2008-06-19 00:00:00	2008-07-17	2008-07-17 00:00:00	2008-07-17	38000177		0	0	28		0	0	0	4859	0	310965	19078461		
41086	3409	920300	2002-07-01	2002-07-01 00:00:00	2002-07-08	2002-07-08 00:00:00	2002-07-08	38000177		0	0	7		0	0	0	226095	0	311989	920300		
108100	2369	40213227	2004-04-04	2004-04-04 00:00:00	2004-04-04	2004-04-04 00:00:00	2004-04-04	581452		0	0	0		0	0	0	157701	0	113	40213227		
58541	4859	1713671	1983-06-25	1983-06-25 00:00:00	1983-07-02	1983-07-02 00:00:00	1983-07-02	38000177		0	0	7		0	0	0	323279	0	562251	1713671		
20372	1672	1115171	2000-01-15	2000-01-15 00:00:00	2000-01-29	2000-01-29 00:00:00	2000-01-29	38000177		0	0	14		0	0	0	112282	0	849574	1115171		
20388	1674	19078461	2008-09-07	2008-09-07 00:00:00	2008-12-06	2008-12-06 00:00:00	2008-12-06	38000177		0	0	90		0	0	0	112387	0	310965	19078461		
16701	1384	1118084	2016-11-27	2016-11-27 00:00:00	2016-11-27	2016-11-27 00:00:00	\N	38000177		0	0	0		0	0	0	91784	0	00025152531	44923712		
8849	739	1127433	1988-10-15	1988-10-15 00:00:00	1988-10-29	1988-10-29 00:00:00	1988-10-29	38000177		0	0	14		0	0	0	48933	0	313782	1127433		
42404	3516	1127433	1954-04-20	1954-04-20 00:00:00	1954-05-04	1954-05-04 00:00:00	1954-05-04	38000177		0	0	14		0	0	0	233331	0	313782	1127433		
17804	1475	1127433	1980-09-11	1980-09-11 00:00:00	1980-09-25	1980-09-25 00:00:00	1980-09-25	38000177		0	0	14		0	0	0	98272	0	313782	1127433		
16773	1387	40236446	1981-03-29	1981-03-29 00:00:00	1987-01-25	1987-01-25 00:00:00	1987-01-25	38000177		0	0	2128		0	0	0	91996	0	1091392	40236446		
4099	339	1127078	1985-09-16	1985-09-16 00:00:00	1985-09-30	1985-09-30 00:00:00	1985-09-30	38000177		0	0	14		0	0	0	22627	0	282464	1127078		
4143	343	1118084	2005-09-09	2005-09-09 00:00:00	2005-09-09	2005-09-09 00:00:00	\N	38000177		0	0	0		0	0	0	22955	0	00025152531	44923712		
14640	1227	1127433	1950-04-03	1950-04-03 00:00:00	1950-05-03	1950-05-03 00:00:00	1950-05-03	38000177		0	0	30		0	0	0	80818	0	313782	1127433		
36265	2988	1713671	1968-03-10	1968-03-10 00:00:00	1968-03-31	1968-03-31 00:00:00	1968-03-31	38000177		0	0	21		0	0	0	199489	0	562251	1713671		
43435	3601	40236824	1980-07-21	1980-07-21 00:00:00	1980-07-28	1980-07-28 00:00:00	1980-07-28	38000177		0	0	7		0	0	0	239176	0	1094107	40236824		
45713	3784	1127433	1979-01-01	1979-01-01 00:00:00	1979-01-08	1979-01-08 00:00:00	1979-01-08	38000177		0	0	7		0	0	0	251511	0	313782	1127433		
46884	3884	40232448	1975-04-17	1975-04-17 00:00:00	1975-04-17	1975-04-17 00:00:00	\N	38000177		0	0	0		0	0	0	258144	0	1049630	40232448		
41883	3469	1127078	1953-08-27	1953-08-27 00:00:00	1953-09-10	1953-09-10 00:00:00	1953-09-10	38000177		0	0	14		0	0	0	230293	0	282464	1127078		
35594	776	40213160	1959-04-09	1959-04-09 00:00:00	1959-04-09	1959-04-09 00:00:00	1959-04-09	581452		0	0	0		0	0	0	51542	0	10	40213160		
21880	1793	19126352	1980-07-23	1980-07-23 00:00:00	1980-07-23	1980-07-23 00:00:00	\N	38000177		0	0	0		0	0	0	120185	0	705129	19126352		
49729	4125	1127078	1978-01-08	1978-01-08 00:00:00	1978-04-08	1978-04-08 00:00:00	1978-04-08	38000177		0	0	90		0	0	0	274212	0	282464	1127078		
48711	4035	1118084	2007-04-02	2007-04-02 00:00:00	2007-04-02	2007-04-02 00:00:00	\N	38000177		0	0	0		0	0	0	268468	0	00025152531	44923712		
10246	219	40213296	2008-07-05	2008-07-05 00:00:00	2008-07-05	2008-07-05 00:00:00	2008-07-05	581452		0	0	0		0	0	0	14747	0	52	40213296		
42590	3531	19128065	1986-02-27	1986-02-27 00:00:00	1987-02-22	1987-02-22 00:00:00	1987-02-22	38000177		0	0	360		0	0	0	234552	0	749882	19128065		
3371	279	1713671	1996-10-19	1996-10-19 00:00:00	1996-11-02	1996-11-02 00:00:00	1996-11-02	38000177		0	0	14		0	0	0	18592	0	562251	1713671		
20792	1715	1127433	1998-09-04	1998-09-04 00:00:00	1998-09-18	1998-09-18 00:00:00	1998-09-18	38000177		0	0	14		0	0	0	114564	0	313782	1127433		
25906	2131	1115171	2003-06-10	2003-06-10 00:00:00	2003-07-01	2003-07-01 00:00:00	2003-07-01	38000177		0	0	21		0	0	0	141828	0	849574	1115171		
2017	160	1127433	2019-04-02	2019-04-02 00:00:00	2019-04-16	2019-04-16 00:00:00	2019-04-16	38000177		0	0	14		0	0	0	10966	0	313782	1127433		
51916	4317	19126352	2018-11-01	2018-11-01 00:00:00	2018-11-01	2018-11-01 00:00:00	\N	38000177		0	0	0		0	0	0	286529	0	705129	19126352		
8363	697	1127433	2015-10-13	2015-10-13 00:00:00	2015-10-27	2015-10-27 00:00:00	2015-10-27	38000177		0	0	14		0	0	0	46137	0	313782	1127433		
56253	4668	19059056	1957-03-31	1957-03-31 00:00:00	1957-04-14	1957-04-14 00:00:00	1957-04-14	38000177		0	0	14		0	0	0	311092	0	243670	19059056		
18058	1496	19059056	1925-11-07	1925-11-07 00:00:00	1925-11-21	1925-11-21 00:00:00	1925-11-21	38000177		0	0	14		0	0	0	99702	0	243670	19059056		
62543	5201	40229134	1982-01-26	1982-01-26 00:00:00	1982-02-02	1982-02-02 00:00:00	1982-02-02	38000177		0	0	7		0	0	0	345964	0	1043400	40229134		
3934	327	19078461	2010-09-30	2010-09-30 00:00:00	2010-10-21	2010-10-21 00:00:00	2010-10-21	38000177		0	0	21		0	0	0	21621	0	310965	19078461		
10185	217	40213227	2008-02-26	2008-02-26 00:00:00	2008-02-26	2008-02-26 00:00:00	2008-02-26	581452		0	0	0		0	0	0	14668	0	113	40213227		
33822	2798	40229134	1988-04-21	1988-04-21 00:00:00	1988-04-28	1988-04-28 00:00:00	1988-04-28	38000177		0	0	7		0	0	0	185461	0	1043400	40229134		
26191	2153	1127078	1975-02-06	1975-02-06 00:00:00	1975-02-20	1975-02-20 00:00:00	1975-02-20	38000177		0	0	14		0	0	0	143472	0	282464	1127078		
50087	4156	1127078	1962-12-12	1962-12-12 00:00:00	1963-02-10	1963-02-10 00:00:00	1963-02-10	38000177		0	0	60		0	0	0	276157	0	282464	1127078		
11972	1000	1127078	1973-12-16	1973-12-16 00:00:00	1973-12-30	1973-12-30 00:00:00	1973-12-30	38000177		0	0	14		0	0	0	66138	0	282464	1127078		
12018	1004	1127433	1974-02-02	1974-02-02 00:00:00	1974-02-16	1974-02-16 00:00:00	1974-02-16	38000177		0	0	14		0	0	0	66380	0	313782	1127433		
8067	673	19133905	1987-05-10	1987-05-10 00:00:00	1987-05-21	1987-05-21 00:00:00	1987-05-21	38000177		0	0	11		0	0	0	44522	0	834102	19133905		
8088	675	19059056	1949-10-09	1949-10-09 00:00:00	1949-10-23	1949-10-23 00:00:00	1949-10-23	38000177		0	0	14		0	0	0	44612	0	243670	19059056		
40311	3339	1127433	2012-09-13	2012-09-13 00:00:00	2012-09-27	2012-09-27 00:00:00	2012-09-27	38000177		0	0	14		0	0	0	221478	0	313782	1127433		
44578	3691	19006318	1957-05-29	1957-05-29 00:00:00	1957-06-12	1957-06-12 00:00:00	1957-06-12	38000177		0	0	14		0	0	0	245359	0	105078	19006318		
23038	1900	1118084	1995-11-18	1995-11-18 00:00:00	1995-11-18	1995-11-18 00:00:00	\N	38000177		0	0	0		0	0	0	126490	0	00025152531	44923712		
49142	4078	19059056	1968-03-09	1968-03-09 00:00:00	1968-03-23	1968-03-23 00:00:00	1968-03-23	38000177		0	0	14		0	0	0	271096	0	243670	19059056		
46369	3841	19128022	1992-08-19	1992-08-19 00:00:00	1993-08-14	1993-08-14 00:00:00	1993-08-14	38000177		0	0	360		0	0	0	254990	0	749785	19128022		
128858	2833	40213201	2002-01-14	2002-01-14 00:00:00	2002-01-14	2002-01-14 00:00:00	2002-01-14	581452		0	0	0		0	0	0	188041	0	33	40213201		
33351	2764	19128022	1990-08-05	1990-08-05 00:00:00	1991-07-31	1991-07-31 00:00:00	1991-07-31	38000177		0	0	360		0	0	0	182785	0	749785	19128022		
14782	1236	1127433	1979-01-23	1979-01-23 00:00:00	1979-01-30	1979-01-30 00:00:00	1979-01-30	38000177		0	0	7		0	0	0	81464	0	313782	1127433		
57023	4732	1127078	1964-07-06	1964-07-06 00:00:00	1964-07-20	1964-07-20 00:00:00	1964-07-20	38000177		0	0	14		0	0	0	315289	0	282464	1127078		
28101	2325	19128065	1990-09-24	1990-09-24 00:00:00	1991-09-19	1991-09-19 00:00:00	1991-09-19	38000177		0	0	360		0	0	0	154567	0	749882	19128065		
9188	763	1713671	1982-06-23	1982-06-23 00:00:00	1982-07-14	1982-07-14 00:00:00	1982-07-14	38000177		0	0	21		0	0	0	50749	0	562251	1713671		
26551	2185	40236824	1990-04-03	1990-04-03 00:00:00	1990-04-10	1990-04-10 00:00:00	1990-04-10	38000177		0	0	7		0	0	0	145696	0	1094107	40236824		
26638	2192	920300	2002-01-26	2002-01-26 00:00:00	2002-02-02	2002-02-02 00:00:00	2002-02-02	38000177		0	0	7		0	0	0	146148	0	311989	920300		
37117	3067	19078461	2010-12-05	2010-12-05 00:00:00	2011-01-04	2011-01-04 00:00:00	2011-01-04	38000177		0	0	30		0	0	0	204188	0	310965	19078461		
22397	486	40213227	2012-01-05	2012-01-05 00:00:00	2012-01-05	2012-01-05 00:00:00	2012-01-05	581452		0	0	0		0	0	0	32493	0	113	40213227		
22027	1809	1127433	1971-03-02	1971-03-02 00:00:00	1971-03-09	1971-03-09 00:00:00	1971-03-09	38000177		0	0	7		0	0	0	121099	0	313782	1127433		
37277	3081	1127433	1985-09-21	1985-09-21 00:00:00	1985-11-20	1985-11-20 00:00:00	1985-11-20	38000177		0	0	60		0	0	0	205136	0	313782	1127433		
32587	2702	40229134	1986-03-30	1986-03-30 00:00:00	1986-04-06	1986-04-06 00:00:00	1986-04-06	38000177		0	0	7		0	0	0	178972	0	1043400	40229134		
94832	2080	40213227	2012-04-27	2012-04-27 00:00:00	2012-04-27	2012-04-27 00:00:00	2012-04-27	581452		0	0	0		0	0	0	138529	0	113	40213227		
96652	2119	40213260	2011-06-13	2011-06-13 00:00:00	2011-06-13	2011-06-13 00:00:00	2011-06-13	581452		0	0	0		0	0	0	141097	0	121	40213260		
107973	2366	40213160	1966-05-23	1966-05-23 00:00:00	1966-05-23	1966-05-23 00:00:00	1966-05-23	581452		0	0	0		0	0	0	157496	0	10	40213160		
888	72	1127433	1969-09-30	1969-09-30 00:00:00	1969-10-30	1969-10-30 00:00:00	1969-10-30	38000177		0	0	30		0	0	0	4856	0	313782	1127433		
41087	3409	40236824	2002-07-01	2002-07-01 00:00:00	2002-07-15	2002-07-15 00:00:00	2002-07-15	38000177		0	0	14		0	0	0	226095	0	1094107	40236824		
108101	2369	40213306	2004-04-04	2004-04-04 00:00:00	2004-04-04	2004-04-04 00:00:00	2004-04-04	581452		0	0	0		0	0	0	157701	0	43	40213306		
58543	4859	920300	2002-05-25	2002-05-25 00:00:00	2002-06-01	2002-06-01 00:00:00	2002-06-01	38000177		0	0	7		0	0	0	323202	0	311989	920300		
20373	1672	40162522	2000-01-15	2000-01-15 00:00:00	2000-01-15	2000-01-15 00:00:00	\N	38000177		0	0	0		0	0	0	112282	0	857005	40162522		
20389	1674	40162522	2008-09-07	2008-09-07 00:00:00	2008-09-07	2008-09-07 00:00:00	\N	38000177		0	0	0		0	0	0	112387	0	857005	40162522		
16702	1384	1713671	2003-09-20	2003-09-20 00:00:00	2003-10-11	2003-10-11 00:00:00	2003-10-11	38000177		0	0	21		0	0	0	91777	0	562251	1713671		
8850	739	1118084	1947-12-15	1947-12-15 00:00:00	1947-12-15	1947-12-15 00:00:00	\N	38000177		0	0	0		0	0	0	48924	0	00025152531	44923712		
42405	3516	1127433	1956-11-01	1956-11-01 00:00:00	1956-11-08	1956-11-08 00:00:00	1956-11-08	38000177		0	0	7		0	0	0	233293	0	313782	1127433		
7637	642	19078461	1989-12-23	1989-12-23 00:00:00	1990-01-20	1990-01-20 00:00:00	1990-01-20	38000177		0	0	28		0	0	0	42464	0	310965	19078461		
16774	1387	1124300	2008-10-13	2008-10-13 00:00:00	2008-10-13	2008-10-13 00:00:00	\N	38000177		0	0	0		0	0	0	92079	0	00781178901	45011828		
4100	339	19075001	1985-09-16	1985-09-16 00:00:00	1985-09-30	1985-09-30 00:00:00	1985-09-30	38000177		0	0	14		0	0	0	22627	0	309097	19075001		
4144	343	1127433	1987-06-01	1987-06-01 00:00:00	1987-08-30	1987-08-30 00:00:00	1987-08-30	38000177		0	0	90		0	0	0	22850	0	313782	1127433		
14641	1227	40231925	1950-04-03	1950-04-03 00:00:00	1950-04-03	1950-04-03 00:00:00	\N	38000177		0	0	0		0	0	0	80818	0	1049221	40231925		
36266	2988	19059056	1972-09-15	1972-09-15 00:00:00	1972-09-29	1972-09-29 00:00:00	1972-09-29	38000177		0	0	14		0	0	0	199425	0	243670	19059056		
43436	3601	920300	1980-07-21	1980-07-21 00:00:00	1980-07-28	1980-07-28 00:00:00	1980-07-28	38000177		0	0	7		0	0	0	239176	0	311989	920300		
45722	3786	1115171	1998-06-10	1998-06-10 00:00:00	1998-07-15	1998-07-15 00:00:00	1998-07-15	38000177		0	0	35		0	0	0	251664	0	849574	1115171		
46885	3884	40229134	2001-08-27	2001-08-27 00:00:00	2001-09-03	2001-09-03 00:00:00	2001-09-03	38000177		0	0	7		0	0	0	258115	0	1043400	40229134		
41884	3469	19075001	2001-11-30	2001-11-30 00:00:00	2001-12-14	2001-12-14 00:00:00	2001-12-14	38000177		0	0	14		0	0	0	230243	0	309097	19075001		
20947	455	40213227	1992-09-01	1992-09-01 00:00:00	1992-09-01	1992-09-01 00:00:00	1992-09-01	581452		0	0	0		0	0	0	30423	0	113	40213227		
20981	455	40213227	2011-04-05	2011-04-05 00:00:00	2011-04-05	2011-04-05 00:00:00	2011-04-05	581452		0	0	0		0	0	0	30413	0	113	40213227		
49730	4125	1127433	1972-08-25	1972-08-25 00:00:00	1972-09-01	1972-09-01 00:00:00	1972-09-01	38000177		0	0	7		0	0	0	274245	0	313782	1127433		
48712	4035	1127433	1975-07-06	1975-07-06 00:00:00	1975-07-20	1975-07-20 00:00:00	1975-07-20	38000177		0	0	14		0	0	0	268491	0	313782	1127433		
10248	219	40213306	1991-01-19	1991-01-19 00:00:00	1991-01-19	1991-01-19 00:00:00	1991-01-19	581452		0	0	0		0	0	0	14790	0	43	40213306		
42591	3531	19128065	1988-02-17	1988-02-17 00:00:00	1989-02-11	1989-02-11 00:00:00	1989-02-11	38000177		0	0	360		0	0	0	234544	0	749882	19128065		
3372	279	1127433	1997-03-03	1997-03-03 00:00:00	1997-03-10	1997-03-10 00:00:00	1997-03-10	38000177		0	0	7		0	0	0	18593	0	313782	1127433		
96110	2108	40213227	2011-01-07	2011-01-07 00:00:00	2011-01-07	2011-01-07 00:00:00	2011-01-07	581452		0	0	0		0	0	0	140329	0	113	40213227		
25907	2131	1118084	1986-12-04	1986-12-04 00:00:00	1986-12-04	1986-12-04 00:00:00	\N	38000177		0	0	0		0	0	0	141803	0	00025152531	44923712		
2018	160	40229134	2003-06-06	2003-06-06 00:00:00	2003-06-13	2003-06-13 00:00:00	2003-06-13	38000177		0	0	7		0	0	0	11004	0	1043400	40229134		
51917	4317	40229134	1980-05-20	1980-05-20 00:00:00	1980-06-03	1980-06-03 00:00:00	1980-06-03	38000177		0	0	14		0	0	0	286499	0	1043400	40229134		
193332	4247	40213160	1988-02-27	1988-02-27 00:00:00	1988-02-27	1988-02-27 00:00:00	1988-02-27	581452		0	0	0		0	0	0	282093	0	10	40213160		
56254	4668	19006318	1957-03-31	1957-03-31 00:00:00	1957-04-14	1957-04-14 00:00:00	1957-04-14	38000177		0	0	14		0	0	0	311092	0	105078	19006318		
18059	1496	40231925	1970-11-23	1970-11-23 00:00:00	1970-11-23	1970-11-23 00:00:00	\N	38000177		0	0	0		0	0	0	99740	0	1049221	40231925		
62544	5201	19128065	1995-03-17	1995-03-17 00:00:00	1996-03-11	1996-03-11 00:00:00	1996-03-11	38000177		0	0	360		0	0	0	345977	0	749882	19128065		
3935	327	19059056	1972-12-22	1972-12-22 00:00:00	1973-01-05	1973-01-05 00:00:00	1973-01-05	38000177		0	0	14		0	0	0	21595	0	243670	19059056		
10190	217	40213306	1997-08-05	1997-08-05 00:00:00	1997-08-05	1997-08-05 00:00:00	1997-08-05	581452		0	0	0		0	0	0	14694	0	43	40213306		
33823	2798	40236824	1998-11-02	1998-11-02 00:00:00	1998-11-09	1998-11-09 00:00:00	1998-11-09	38000177		0	0	7		0	0	0	185445	0	1094107	40236824		
26192	2153	19059056	1972-04-17	1972-04-17 00:00:00	1972-05-22	1972-05-22 00:00:00	1972-05-22	38000177		0	0	35		0	0	0	143471	0	243670	19059056		
50088	4156	19126352	2008-07-07	2008-07-07 00:00:00	2008-07-07	2008-07-07 00:00:00	\N	38000177		0	0	0		0	0	0	276194	0	705129	19126352		
11973	1000	1127078	1966-10-24	1966-10-24 00:00:00	1967-01-22	1967-01-22 00:00:00	1967-01-22	38000177		0	0	90		0	0	0	66136	0	282464	1127078		
12019	1004	40236824	2011-10-25	2011-10-25 00:00:00	2011-11-01	2011-11-01 00:00:00	2011-11-01	38000177		0	0	7		0	0	0	66379	0	1094107	40236824		
8069	673	19128065	1979-08-29	1979-08-29 00:00:00	1980-08-23	1980-08-23 00:00:00	1980-08-23	38000177		0	0	360		0	0	0	44492	0	749882	19128065		
8089	675	19006318	1949-10-09	1949-10-09 00:00:00	1949-10-23	1949-10-23 00:00:00	1949-10-23	38000177		0	0	14		0	0	0	44612	0	105078	19006318		
40312	3339	19133873	1960-10-08	1960-10-08 00:00:00	1960-10-18	1960-10-18 00:00:00	1960-10-18	38000177		0	0	10		0	0	0	221501	0	834061	19133873		
44579	3691	19059056	1957-05-29	1957-05-29 00:00:00	1957-06-12	1957-06-12 00:00:00	1957-06-12	38000177		0	0	14		0	0	0	245359	0	243670	19059056		
23039	1900	19128065	1978-09-28	1978-09-28 00:00:00	1979-09-23	1979-09-23 00:00:00	1979-09-23	38000177		0	0	360		0	0	0	126479	0	749882	19128065		
49143	4078	19008572	1961-01-31	1961-01-31 00:00:00	1961-02-21	1961-02-21 00:00:00	1961-02-21	38000177		0	0	21		0	0	0	271055	0	106258	19008572		
46370	3841	1127078	1974-04-16	1974-04-16 00:00:00	1974-04-30	1974-04-30 00:00:00	1974-04-30	38000177		0	0	14		0	0	0	255005	0	282464	1127078		
57050	1249	40213160	1973-01-04	1973-01-04 00:00:00	1973-01-04	1973-01-04 00:00:00	1973-01-04	581452		0	0	0		0	0	0	82270	0	10	40213160		
33352	2764	19128022	1997-07-09	1997-07-09 00:00:00	1998-03-20	1998-03-20 00:00:00	1998-03-20	38000177		0	0	254		0	0	0	182810	0	749785	19128022		
14783	1236	1115171	2001-03-04	2001-03-04 00:00:00	2001-04-03	2001-04-03 00:00:00	2001-04-03	38000177		0	0	30		0	0	0	81488	0	849574	1115171		
57024	4732	19129655	1964-07-06	1964-07-06 00:00:00	1964-07-20	1964-07-20 00:00:00	1964-07-20	38000177		0	0	14		0	0	0	315289	0	789980	19129655		
28102	2325	19128022	1993-09-08	1993-09-08 00:00:00	1994-09-03	1994-09-03 00:00:00	1994-09-03	38000177		0	0	360		0	0	0	154594	0	749785	19128022		
9190	763	40229134	1972-06-10	1972-06-10 00:00:00	1972-06-17	1972-06-17 00:00:00	1972-06-17	38000177		0	0	7		0	0	0	50750	0	1043400	40229134		
26552	2185	920300	1987-02-28	1987-02-28 00:00:00	1987-03-07	1987-03-07 00:00:00	1987-03-07	38000177		0	0	7		0	0	0	145674	0	311989	920300		
26639	2192	1118084	1996-04-01	1996-04-01 00:00:00	1996-04-01	1996-04-01 00:00:00	\N	38000177		0	0	0		0	0	0	146158	0	00025152531	44923712		
37118	3067	19133873	1951-06-22	1951-06-22 00:00:00	1951-07-02	1951-07-02 00:00:00	1951-07-02	38000177		0	0	10		0	0	0	204098	0	834061	19133873		
22398	486	40213260	2012-01-05	2012-01-05 00:00:00	2012-01-05	2012-01-05 00:00:00	2012-01-05	581452		0	0	0		0	0	0	32493	0	121	40213260		
22028	1809	1127433	2004-12-01	2004-12-01 00:00:00	2004-12-15	2004-12-15 00:00:00	2004-12-15	38000177		0	0	14		0	0	0	121089	0	313782	1127433		
37278	3081	19133873	1957-06-27	1957-06-27 00:00:00	1957-07-08	1957-07-08 00:00:00	1957-07-08	38000177		0	0	11		0	0	0	205140	0	834061	19133873		
32588	2702	920300	1980-11-17	1980-11-17 00:00:00	1980-11-24	1980-11-24 00:00:00	1980-11-24	38000177		0	0	7		0	0	0	178997	0	311989	920300		
94836	2080	40213314	1980-01-18	1980-01-18 00:00:00	1980-01-18	1980-01-18 00:00:00	1980-01-18	581452		0	0	0		0	0	0	138601	0	49	40213314		
86317	1892	40213260	2010-07-15	2010-07-15 00:00:00	2010-07-15	2010-07-15 00:00:00	2010-07-15	581452		0	0	0		0	0	0	125987	0	121	40213260		
16339	1354	1127433	1994-09-14	1994-09-14 00:00:00	1994-09-28	1994-09-28 00:00:00	1994-09-28	38000177		0	0	14		0	0	0	89726	0	313782	1127433		
889	72	19059056	1964-11-11	1964-11-11 00:00:00	1964-11-25	1964-11-25 00:00:00	1964-11-25	38000177		0	0	14		0	0	0	4855	0	243670	19059056		
41088	3409	920300	2004-08-25	2004-08-25 00:00:00	2004-09-01	2004-09-01 00:00:00	2004-09-01	38000177		0	0	7		0	0	0	226096	0	311989	920300		
41127	3410	19006318	1966-09-13	1966-09-13 00:00:00	1966-09-27	1966-09-27 00:00:00	1966-09-27	38000177		0	0	14		0	0	0	226211	0	105078	19006318		
58544	4859	40236824	2002-05-25	2002-05-25 00:00:00	2002-06-01	2002-06-01 00:00:00	2002-06-01	38000177		0	0	7		0	0	0	323202	0	1094107	40236824		
20374	1672	1127433	1992-01-22	1992-01-22 00:00:00	1992-02-26	1992-02-26 00:00:00	1992-02-26	38000177		0	0	35		0	0	0	112281	0	313782	1127433		
20390	1674	1127433	2004-12-22	2004-12-22 00:00:00	2005-01-05	2005-01-05 00:00:00	2005-01-05	38000177		0	0	14		0	0	0	112354	0	313782	1127433		
16703	1384	1713671	2012-08-16	2012-08-16 00:00:00	2012-08-23	2012-08-23 00:00:00	2012-08-23	38000177		0	0	7		0	0	0	91789	0	562251	1713671		
8851	739	1127433	1991-08-15	1991-08-15 00:00:00	1991-10-14	1991-10-14 00:00:00	1991-10-14	38000177		0	0	60		0	0	0	48934	0	313782	1127433		
42406	3516	1713671	1967-03-14	1967-03-14 00:00:00	1967-05-23	1967-05-23 00:00:00	1967-05-23	38000177		0	0	70		0	0	0	233322	0	562251	1713671		
7638	642	19059056	1936-06-06	1936-06-06 00:00:00	1936-06-20	1936-06-20 00:00:00	1936-06-20	38000177		0	0	14		0	0	0	42466	0	243670	19059056		
16775	1387	40165015	2001-12-09	2001-12-09 00:00:00	2001-12-09	2001-12-09 00:00:00	\N	38000177		0	0	0		0	0	0	92093	0	861467	40165015		
4101	339	19019979	1984-10-02	1984-10-02 00:00:00	1984-10-16	1984-10-16 00:00:00	1984-10-16	38000177		0	0	14		0	0	0	22611	0	198405	19019979		
4145	343	46233988	1971-11-22	1971-11-22 00:00:00	1971-12-06	1971-12-06 00:00:00	1971-12-06	38000177		0	0	14		0	0	0	22873	0	1652673	46233988		
14642	1227	19075601	2013-03-20	2013-03-20 00:00:00	2013-03-20	2013-03-20 00:00:00	\N	38000177		0	0	0		0	0	0	80769	0	309362	19075601		
36267	2988	19133873	1972-10-18	1972-10-18 00:00:00	1972-10-25	1972-10-25 00:00:00	1972-10-25	38000177		0	0	7		0	0	0	199465	0	834061	19133873		
43437	3601	1118084	1992-03-27	1992-03-27 00:00:00	1992-03-27	1992-03-27 00:00:00	\N	38000177		0	0	0		0	0	0	239155	0	00025152531	44923712		
45724	3786	19078461	1978-02-27	1978-02-27 00:00:00	1978-03-13	1978-03-13 00:00:00	1978-03-13	38000177		0	0	14		0	0	0	251689	0	310965	19078461		
46886	3884	19059056	1973-03-22	1973-03-22 00:00:00	1973-04-19	1973-04-19 00:00:00	1973-04-19	38000177		0	0	28		0	0	0	258013	0	243670	19059056		
41885	3469	1127433	2001-11-30	2001-11-30 00:00:00	2001-12-14	2001-12-14 00:00:00	2001-12-14	38000177		0	0	14		0	0	0	230243	0	313782	1127433		
20964	455	40213198	2015-04-28	2015-04-28 00:00:00	2015-04-28	2015-04-28 00:00:00	2015-04-28	581452		0	0	0		0	0	0	30396	0	133	40213198		
41811	3462	19133873	1975-01-27	1975-01-27 00:00:00	1975-02-07	1975-02-07 00:00:00	1975-02-07	38000177		0	0	11		0	0	0	229682	0	834061	19133873		
31951	2649	1713671	1999-08-12	1999-08-12 00:00:00	1999-09-02	1999-09-02 00:00:00	1999-09-02	38000177		0	0	21		0	0	0	175281	0	562251	1713671		
48713	4035	19128065	1987-03-13	1987-03-13 00:00:00	1988-03-07	1988-03-07 00:00:00	1988-03-07	38000177		0	0	360		0	0	0	268482	0	749882	19128065		
10250	219	40213306	1991-12-14	1991-12-14 00:00:00	1991-12-14	1991-12-14 00:00:00	1991-12-14	581452		0	0	0		0	0	0	14776	0	43	40213306		
42592	3531	19128065	1982-03-20	1982-03-20 00:00:00	1983-03-15	1983-03-15 00:00:00	1983-03-15	38000177		0	0	360		0	0	0	234550	0	749882	19128065		
10319	220	40213160	1983-05-11	1983-05-11 00:00:00	1983-05-11	1983-05-11 00:00:00	1983-05-11	581452		0	0	0		0	0	0	14848	0	10	40213160		
42651	3536	920300	2016-02-29	2016-02-29 00:00:00	2016-03-07	2016-03-07 00:00:00	2016-03-07	38000177		0	0	7		0	0	0	234857	0	311989	920300		
25908	2131	1551192	1962-03-30	1962-03-30 00:00:00	1962-03-30	1962-03-30 00:00:00	1962-03-30	38000177		0	0	0		0	0	0	141824	0	312617	1551192		
2019	160	19128065	1976-07-18	1976-07-18 00:00:00	1977-07-13	1977-07-13 00:00:00	1977-07-13	38000177		0	0	360		0	0	0	10981	0	749882	19128065		
51918	4317	19059056	1947-09-04	1947-09-04 00:00:00	1947-09-18	1947-09-18 00:00:00	1947-09-18	38000177		0	0	14		0	0	0	286503	0	243670	19059056		
193336	4247	40213160	1983-06-25	1983-06-25 00:00:00	1983-06-25	1983-06-25 00:00:00	1983-06-25	581452		0	0	0		0	0	0	282082	0	10	40213160		
56255	4668	1127433	2014-12-09	2014-12-09 00:00:00	2014-12-23	2014-12-23 00:00:00	2014-12-23	38000177		0	0	14		0	0	0	311090	0	313782	1127433		
18060	1496	19059056	1970-11-23	1970-11-23 00:00:00	1970-12-14	1970-12-14 00:00:00	1970-12-14	38000177		0	0	21		0	0	0	99740	0	243670	19059056		
62545	5201	1127433	2001-10-21	2001-10-21 00:00:00	2001-10-28	2001-10-28 00:00:00	2001-10-28	38000177		0	0	7		0	0	0	345975	0	313782	1127433		
3936	327	46233988	1972-12-22	1972-12-22 00:00:00	1973-01-05	1973-01-05 00:00:00	1973-01-05	38000177		0	0	14		0	0	0	21595	0	1652673	46233988		
10192	217	40213227	1997-08-05	1997-08-05 00:00:00	1997-08-05	1997-08-05 00:00:00	1997-08-05	581452		0	0	0		0	0	0	14694	0	113	40213227		
33824	2798	920300	1998-11-02	1998-11-02 00:00:00	1998-11-09	1998-11-09 00:00:00	1998-11-09	38000177		0	0	7		0	0	0	185445	0	311989	920300		
26193	2153	1127078	1966-09-16	1966-09-16 00:00:00	1966-09-30	1966-09-30 00:00:00	1966-09-30	38000177		0	0	14		0	0	0	143521	0	282464	1127078		
50089	4156	19075601	2008-07-07	2008-07-07 00:00:00	2008-07-07	2008-07-07 00:00:00	\N	38000177		0	0	0		0	0	0	276194	0	309362	19075601		
11974	1000	40236824	2016-02-25	2016-02-25 00:00:00	2016-03-03	2016-03-03 00:00:00	2016-03-03	38000177		0	0	7		0	0	0	66157	0	1094107	40236824		
12020	1004	920300	2011-10-25	2011-10-25 00:00:00	2011-11-01	2011-11-01 00:00:00	2011-11-01	38000177		0	0	7		0	0	0	66379	0	311989	920300		
8070	673	19059056	1962-09-17	1962-09-17 00:00:00	1962-10-01	1962-10-01 00:00:00	1962-10-01	38000177		0	0	14		0	0	0	44469	0	243670	19059056		
8090	675	1115171	2019-06-07	2019-06-07 00:00:00	2019-06-07	2019-06-07 00:00:00	\N	38000177		0	0	0		0	0	0	44647	0	849574	1115171		
40313	3339	1713671	2011-08-07	2011-08-07 00:00:00	2011-08-28	2011-08-28 00:00:00	2011-08-28	38000177		0	0	21		0	0	0	221528	0	562251	1713671		
44580	3691	19059056	1964-03-21	1964-03-21 00:00:00	1964-04-25	1964-04-25 00:00:00	1964-04-25	38000177		0	0	35		0	0	0	245327	0	243670	19059056		
23040	1900	40229134	1971-12-26	1971-12-26 00:00:00	1972-01-09	1972-01-09 00:00:00	1972-01-09	38000177		0	0	14		0	0	0	126507	0	1043400	40229134		
49144	4078	40229134	1975-03-23	1975-03-23 00:00:00	1975-03-30	1975-03-30 00:00:00	1975-03-30	38000177		0	0	7		0	0	0	271057	0	1043400	40229134		
46371	3841	19059056	1988-10-29	1988-10-29 00:00:00	1988-11-19	1988-11-19 00:00:00	1988-11-19	38000177		0	0	21		0	0	0	255054	0	243670	19059056		
57056	1249	40213160	1968-07-04	1968-07-04 00:00:00	1968-07-04	1968-07-04 00:00:00	1968-07-04	581452		0	0	0		0	0	0	82266	0	10	40213160		
33381	2765	1118084	1974-06-26	1974-06-26 00:00:00	1974-06-26	1974-06-26 00:00:00	\N	38000177		0	0	0		0	0	0	182940	0	00025152531	44923712		
14784	1236	19078461	2012-01-06	2012-01-06 00:00:00	2012-03-06	2012-03-06 00:00:00	2012-03-06	38000177		0	0	60		0	0	0	81490	0	310965	19078461		
57025	4732	1124300	1992-09-27	1992-09-27 00:00:00	1992-09-27	1992-09-27 00:00:00	\N	38000177		0	0	0		0	0	0	315267	0	00781178901	45011828		
28103	2325	1713671	2015-06-13	2015-06-13 00:00:00	2015-06-27	2015-06-27 00:00:00	2015-06-27	38000177		0	0	14		0	0	0	154590	0	562251	1713671		
9191	763	19133905	1991-12-12	1991-12-12 00:00:00	1991-12-21	1991-12-21 00:00:00	1991-12-21	38000177		0	0	9		0	0	0	50751	0	834102	19133905		
26553	2185	40236824	1987-02-28	1987-02-28 00:00:00	1987-03-07	1987-03-07 00:00:00	1987-03-07	38000177		0	0	7		0	0	0	145674	0	1094107	40236824		
26640	2192	19128065	1976-11-07	1976-11-07 00:00:00	1977-11-02	1977-11-02 00:00:00	1977-11-02	38000177		0	0	360		0	0	0	146232	0	749882	19128065		
26649	2192	19059056	1957-01-11	1957-01-11 00:00:00	1957-01-25	1957-01-25 00:00:00	1957-01-25	38000177		0	0	14		0	0	0	146151	0	243670	19059056		
5648	474	1118084	2005-08-17	2005-08-17 00:00:00	2005-08-17	2005-08-17 00:00:00	\N	38000177		0	0	0		0	0	0	31662	0	00025152531	44923712		
22029	1809	19006318	1978-12-18	1978-12-18 00:00:00	1979-01-01	1979-01-01 00:00:00	1979-01-01	38000177		0	0	14		0	0	0	121094	0	105078	19006318		
37279	3081	40220960	2011-09-07	2011-09-07 00:00:00	2011-09-07	2011-09-07 00:00:00	2011-09-07	38000177		0	0	0		0	0	0	205094	0	1804799	40220960		
32589	2702	40220960	1998-08-09	1998-08-09 00:00:00	1998-08-09	1998-08-09 00:00:00	1998-08-09	38000177		0	0	0		0	0	0	179001	0	1804799	40220960		
94837	2080	40213160	1980-01-18	1980-01-18 00:00:00	1980-01-18	1980-01-18 00:00:00	1980-01-18	581452		0	0	0		0	0	0	138601	0	10	40213160		
86324	1892	40213296	2001-05-03	2001-05-03 00:00:00	2001-05-03	2001-05-03 00:00:00	2001-05-03	581452		0	0	0		0	0	0	126012	0	52	40213296		
16340	1354	1713671	2007-12-04	2007-12-04 00:00:00	2007-12-25	2007-12-25 00:00:00	2007-12-25	38000177		0	0	21		0	0	0	89727	0	562251	1713671		
890	72	1713671	1952-04-20	1952-04-20 00:00:00	1952-05-11	1952-05-11 00:00:00	1952-05-11	38000177		0	0	21		0	0	0	4882	0	562251	1713671		
41089	3409	40236824	2004-08-25	2004-08-25 00:00:00	2004-09-01	2004-09-01 00:00:00	2004-09-01	38000177		0	0	7		0	0	0	226096	0	1094107	40236824		
41128	3410	1713671	2009-03-06	2009-03-06 00:00:00	2009-03-27	2009-03-27 00:00:00	2009-03-27	38000177		0	0	21		0	0	0	226166	0	562251	1713671		
58545	4860	19078461	2016-06-02	2016-06-02 00:00:00	2016-07-07	2016-07-07 00:00:00	2016-07-07	38000177		0	0	35		0	0	0	323342	0	310965	19078461		
20375	1672	1118084	1989-04-10	1989-04-10 00:00:00	1989-04-10	1989-04-10 00:00:00	\N	38000177		0	0	0		0	0	0	112241	0	00025152531	44923712		
20391	1674	1127433	1993-12-29	1993-12-29 00:00:00	1994-01-12	1994-01-12 00:00:00	1994-01-12	38000177		0	0	14		0	0	0	112369	0	313782	1127433		
16704	1384	1127078	1994-01-12	1994-01-12 00:00:00	1994-02-18	1994-02-18 00:00:00	1994-02-18	38000177		0	0	37		0	0	0	91725	0	282464	1127078		
8852	739	19059056	1935-06-21	1935-06-21 00:00:00	1935-09-19	1935-09-19 00:00:00	1935-09-19	38000177		0	0	90		0	0	0	48969	0	243670	19059056		
42407	3516	1127433	1984-06-10	1984-06-10 00:00:00	1984-06-24	1984-06-24 00:00:00	1984-06-24	38000177		0	0	14		0	0	0	233325	0	313782	1127433		
7639	642	40229134	1995-12-03	1995-12-03 00:00:00	1995-12-10	1995-12-10 00:00:00	1995-12-10	38000177		0	0	7		0	0	0	42540	0	1043400	40229134		
16776	1387	1127433	2001-12-09	2001-12-09 00:00:00	2002-01-06	2002-01-06 00:00:00	2002-01-06	38000177		0	0	28		0	0	0	92093	0	313782	1127433		
4102	339	1127433	1996-02-28	1996-02-28 00:00:00	1996-03-06	1996-03-06 00:00:00	1996-03-06	38000177		0	0	7		0	0	0	22638	0	313782	1127433		
4146	343	19059056	1971-11-22	1971-11-22 00:00:00	1971-12-06	1971-12-06 00:00:00	1971-12-06	38000177		0	0	14		0	0	0	22873	0	243670	19059056		
14643	1227	19126352	2013-03-20	2013-03-20 00:00:00	2013-03-20	2013-03-20 00:00:00	\N	38000177		0	0	0		0	0	0	80769	0	705129	19126352		
36268	2988	40162522	1993-01-10	1993-01-10 00:00:00	1993-01-10	1993-01-10 00:00:00	\N	38000177		0	0	0		0	0	0	199488	0	857005	40162522		
43438	3601	1127433	1971-09-24	1971-09-24 00:00:00	1971-10-08	1971-10-08 00:00:00	1971-10-08	38000177		0	0	14		0	0	0	239150	0	313782	1127433		
45725	3786	1127433	2002-07-25	2002-07-25 00:00:00	2002-08-08	2002-08-08 00:00:00	2002-08-08	38000177		0	0	14		0	0	0	251716	0	313782	1127433		
46887	3884	1127433	1997-01-12	1997-01-12 00:00:00	1997-01-19	1997-01-19 00:00:00	1997-01-19	38000177		0	0	7		0	0	0	258055	0	313782	1127433		
41886	3469	1118084	1991-04-15	1991-04-15 00:00:00	1991-04-15	1991-04-15 00:00:00	\N	38000177		0	0	0		0	0	0	230252	0	00025152531	44923712		
20967	455	40213160	1955-01-18	1955-01-18 00:00:00	1955-01-18	1955-01-18 00:00:00	1955-01-18	581452		0	0	0		0	0	0	30445	0	10	40213160		
41812	3462	1127433	1985-06-21	1985-06-21 00:00:00	1985-08-20	1985-08-20 00:00:00	1985-08-20	38000177		0	0	60		0	0	0	229697	0	313782	1127433		
31952	2649	1127433	2011-02-19	2011-02-19 00:00:00	2011-03-12	2011-03-12 00:00:00	2011-03-12	38000177		0	0	21		0	0	0	175270	0	313782	1127433		
102173	2240	40213260	2007-03-27	2007-03-27 00:00:00	2007-03-27	2007-03-27 00:00:00	2007-03-27	581452		0	0	0		0	0	0	149154	0	121	40213260		
10253	219	40213160	1968-07-06	1968-07-06 00:00:00	1968-07-06	1968-07-06 00:00:00	1968-07-06	581452		0	0	0		0	0	0	14715	0	10	40213160		
42779	3545	1713671	2018-05-12	2018-05-12 00:00:00	2018-05-26	2018-05-26 00:00:00	2018-05-26	38000177		0	0	14		0	0	0	235451	0	562251	1713671		
10322	220	40213314	1983-02-09	1983-02-09 00:00:00	1983-02-09	1983-02-09 00:00:00	1983-02-09	581452		0	0	0		0	0	0	14830	0	49	40213314		
42652	3536	40236824	2016-02-29	2016-02-29 00:00:00	2016-03-07	2016-03-07 00:00:00	2016-03-07	38000177		0	0	7		0	0	0	234857	0	1094107	40236824		
25909	2131	1127433	1978-10-14	1978-10-14 00:00:00	1978-10-28	1978-10-28 00:00:00	1978-10-28	38000177		0	0	14		0	0	0	141826	0	313782	1127433		
2020	160	1127433	2004-10-01	2004-10-01 00:00:00	2004-10-08	2004-10-08 00:00:00	2004-10-08	38000177		0	0	7		0	0	0	10951	0	313782	1127433		
51919	4317	19006318	1947-09-04	1947-09-04 00:00:00	1947-09-18	1947-09-18 00:00:00	1947-09-18	38000177		0	0	14		0	0	0	286503	0	105078	19006318		
193337	4247	40213314	1983-06-25	1983-06-25 00:00:00	1983-06-25	1983-06-25 00:00:00	1983-06-25	581452		0	0	0		0	0	0	282082	0	49	40213314		
56257	4668	19059056	1963-01-24	1963-01-24 00:00:00	1963-02-07	1963-02-07 00:00:00	1963-02-07	38000177		0	0	14		0	0	0	311073	0	243670	19059056		
18061	1496	46233710	1970-11-23	1970-11-23 00:00:00	1970-12-14	1970-12-14 00:00:00	1970-12-14	38000177		0	0	21		0	0	0	99740	0	1650142	46233710		
62560	5203	1127433	1961-09-15	1961-09-15 00:00:00	1961-09-22	1961-09-22 00:00:00	1961-09-22	38000177		0	0	7		0	0	0	346121	0	313782	1127433		
3937	327	19059056	1974-10-13	1974-10-13 00:00:00	1975-01-11	1975-01-11 00:00:00	1975-01-11	38000177		0	0	90		0	0	0	21617	0	243670	19059056		
10193	217	40213314	1978-03-14	1978-03-14 00:00:00	1978-03-14	1978-03-14 00:00:00	1978-03-14	581452		0	0	0		0	0	0	14661	0	49	40213314		
33825	2799	19019979	1985-04-06	1985-04-06 00:00:00	1985-04-20	1985-04-20 00:00:00	1985-04-20	38000177		0	0	14		0	0	0	185507	0	198405	19019979		
26194	2153	19006318	1966-09-16	1966-09-16 00:00:00	1966-09-30	1966-09-30 00:00:00	1966-09-30	38000177		0	0	14		0	0	0	143521	0	105078	19006318		
13159	285	40213160	1970-11-02	1970-11-02 00:00:00	1970-11-02	1970-11-02 00:00:00	1970-11-02	581452		0	0	0		0	0	0	18928	0	10	40213160		
11975	1000	920300	2016-02-25	2016-02-25 00:00:00	2016-03-03	2016-03-03 00:00:00	2016-03-03	38000177		0	0	7		0	0	0	66157	0	311989	920300		
12021	1004	19133873	1977-09-10	1977-09-10 00:00:00	1977-09-20	1977-09-20 00:00:00	1977-09-20	38000177		0	0	10		0	0	0	66376	0	834061	19133873		
8071	673	1127433	1973-11-20	1973-11-20 00:00:00	1973-11-27	1973-11-27 00:00:00	1973-11-27	38000177		0	0	7		0	0	0	44462	0	313782	1127433		
8091	675	19133873	1956-12-03	1956-12-03 00:00:00	1956-12-14	1956-12-14 00:00:00	1956-12-14	38000177		0	0	11		0	0	0	44715	0	834061	19133873		
40314	3339	1713671	1971-01-19	1971-01-19 00:00:00	1971-02-02	1971-02-02 00:00:00	1971-02-02	38000177		0	0	14		0	0	0	221476	0	562251	1713671		
44581	3691	40229134	2005-08-28	2005-08-28 00:00:00	2005-09-04	2005-09-04 00:00:00	2005-09-04	38000177		0	0	7		0	0	0	245348	0	1043400	40229134		
23041	1900	1713671	1979-11-04	1979-11-04 00:00:00	1979-11-11	1979-11-11 00:00:00	1979-11-11	38000177		0	0	7		0	0	0	126464	0	562251	1713671		
49145	4078	19008572	1966-01-28	1966-01-28 00:00:00	1966-02-18	1966-02-18 00:00:00	1966-02-18	38000177		0	0	21		0	0	0	270977	0	106258	19008572		
46372	3841	19128022	1991-08-25	1991-08-25 00:00:00	1992-08-19	1992-08-19 00:00:00	1992-08-19	38000177		0	0	360		0	0	0	254989	0	749785	19128022		
54213	4504	46233988	1972-11-17	1972-11-17 00:00:00	1972-12-01	1972-12-01 00:00:00	1972-12-01	38000177		0	0	14		0	0	0	299949	0	1652673	46233988		
33382	2765	1127433	1993-04-13	1993-04-13 00:00:00	1993-04-27	1993-04-27 00:00:00	1993-04-27	38000177		0	0	14		0	0	0	182892	0	313782	1127433		
14785	1236	19059056	1938-11-06	1938-11-06 00:00:00	1938-11-20	1938-11-20 00:00:00	1938-11-20	38000177		0	0	14		0	0	0	81481	0	243670	19059056		
17587	1454	19133873	1984-04-06	1984-04-06 00:00:00	1984-04-15	1984-04-15 00:00:00	1984-04-15	38000177		0	0	9		0	0	0	96977	0	834061	19133873		
28104	2325	19128022	1991-09-19	1991-09-19 00:00:00	1992-09-13	1992-09-13 00:00:00	1992-09-13	38000177		0	0	360		0	0	0	154568	0	749785	19128022		
9192	763	1713671	1995-05-19	1995-05-19 00:00:00	1995-06-09	1995-06-09 00:00:00	1995-06-09	38000177		0	0	21		0	0	0	50755	0	562251	1713671		
26554	2185	1127433	1970-02-16	1970-02-16 00:00:00	1970-03-02	1970-03-02 00:00:00	1970-03-02	38000177		0	0	14		0	0	0	145625	0	313782	1127433		
26641	2192	19133873	1955-10-20	1955-10-20 00:00:00	1955-10-30	1955-10-30 00:00:00	1955-10-30	38000177		0	0	10		0	0	0	146194	0	834061	19133873		
26650	2192	19128065	1974-11-18	1974-11-18 00:00:00	1975-11-13	1975-11-13 00:00:00	1975-11-13	38000177		0	0	360		0	0	0	146231	0	749882	19128065		
5649	474	19133873	1982-12-04	1982-12-04 00:00:00	1982-12-16	1982-12-16 00:00:00	1982-12-16	38000177		0	0	12		0	0	0	31646	0	834061	19133873		
22030	1809	19078461	1978-12-18	1978-12-18 00:00:00	1979-01-01	1979-01-01 00:00:00	1979-01-01	38000177		0	0	14		0	0	0	121094	0	310965	19078461		
37280	3081	19075601	2011-09-07	2011-09-07 00:00:00	2011-09-07	2011-09-07 00:00:00	2011-09-07	38000177		0	0	0		0	0	0	205094	0	309362	19075601		
32590	2702	19075601	1998-08-09	1998-08-09 00:00:00	1998-08-09	1998-08-09 00:00:00	1998-08-09	38000177		0	0	0		0	0	0	179001	0	309362	19075601		
94839	2080	40213160	1980-06-20	1980-06-20 00:00:00	1980-06-20	1980-06-20 00:00:00	1980-06-20	581452		0	0	0		0	0	0	138580	0	10	40213160		
20085	437	40213227	2017-06-13	2017-06-13 00:00:00	2017-06-13	2017-06-13 00:00:00	2017-06-13	581452		0	0	0		0	0	0	29044	0	113	40213227		
16341	1355	19129655	1966-11-22	1966-11-22 00:00:00	1966-12-06	1966-12-06 00:00:00	1966-12-06	38000177		0	0	14		0	0	0	89809	0	789980	19129655		
905	74	920300	2004-01-30	2004-01-30 00:00:00	2004-02-06	2004-02-06 00:00:00	2004-02-06	38000177		0	0	7		0	0	0	4999	0	311989	920300		
41090	3409	1127433	2011-04-26	2011-04-26 00:00:00	2011-07-25	2011-07-25 00:00:00	2011-07-25	38000177		0	0	90		0	0	0	226124	0	313782	1127433		
41129	3410	1713671	1985-11-06	1985-11-06 00:00:00	1985-11-20	1985-11-20 00:00:00	1985-11-20	38000177		0	0	14		0	0	0	226165	0	562251	1713671		
58546	4860	1127433	2006-09-28	2006-09-28 00:00:00	2006-10-05	2006-10-05 00:00:00	2006-10-05	38000177		0	0	7		0	0	0	323297	0	313782	1127433		
87308	1915	40213296	2014-03-11	2014-03-11 00:00:00	2014-03-11	2014-03-11 00:00:00	2014-03-11	581452		0	0	0		0	0	0	127387	0	52	40213296		
20392	1674	1127433	1990-06-09	1990-06-09 00:00:00	1990-06-16	1990-06-16 00:00:00	1990-06-16	38000177		0	0	7		0	0	0	112377	0	313782	1127433		
16705	1384	19019979	1991-03-29	1991-03-29 00:00:00	1991-04-28	1991-04-28 00:00:00	1991-04-28	38000177		0	0	30		0	0	0	91724	0	198405	19019979		
8853	739	1127433	1927-10-11	1927-10-11 00:00:00	1927-10-25	1927-10-25 00:00:00	1927-10-25	38000177		0	0	14		0	0	0	48972	0	313782	1127433		
42408	3516	19133873	1947-05-04	1947-05-04 00:00:00	1947-05-17	1947-05-17 00:00:00	1947-05-17	38000177		0	0	13		0	0	0	233311	0	834061	19133873		
7640	642	19073188	1992-04-16	1992-04-16 00:00:00	1992-04-30	1992-04-30 00:00:00	1992-04-30	38000177		0	0	14		0	0	0	42497	0	308192	19073188		
16777	1387	19073188	2001-12-09	2001-12-09 00:00:00	2002-01-06	2002-01-06 00:00:00	2002-01-06	38000177		0	0	28		0	0	0	92093	0	308192	19073188		
4103	339	1127433	2008-12-13	2008-12-13 00:00:00	2008-12-27	2008-12-27 00:00:00	2008-12-27	38000177		0	0	14		0	0	0	22640	0	313782	1127433		
4147	343	1551192	1972-10-19	1972-10-19 00:00:00	1972-10-19	1972-10-19 00:00:00	1972-10-19	38000177		0	0	0		0	0	0	22849	0	312617	1551192		
14644	1227	1539411	2013-03-20	2013-03-20 00:00:00	2013-03-20	2013-03-20 00:00:00	\N	38000177		0	0	0		0	0	0	80769	0	312961	1539411		
36269	2988	40229134	2006-12-22	2006-12-22 00:00:00	2007-01-05	2007-01-05 00:00:00	2007-01-05	38000177		0	0	14		0	0	0	199494	0	1043400	40229134		
43439	3601	1127433	1976-11-21	1976-11-21 00:00:00	1976-12-26	1976-12-26 00:00:00	1976-12-26	38000177		0	0	35		0	0	0	239220	0	313782	1127433		
45726	3786	1127433	2017-10-08	2017-10-08 00:00:00	2017-11-12	2017-11-12 00:00:00	2017-11-12	38000177		0	0	35		0	0	0	251666	0	313782	1127433		
46888	3884	19019979	1983-02-26	1983-02-26 00:00:00	1983-03-12	1983-03-12 00:00:00	1983-03-12	38000177		0	0	14		0	0	0	258015	0	198405	19019979		
41887	3469	1127433	1989-06-22	1989-06-22 00:00:00	1989-07-27	1989-07-27 00:00:00	1989-07-27	38000177		0	0	35		0	0	0	230252	0	313782	1127433		
41745	3456	19126352	1989-12-21	1989-12-21 00:00:00	1989-12-21	1989-12-21 00:00:00	\N	38000177		0	0	0		0	0	0	229286	0	705129	19126352		
41813	3462	40165015	1985-06-21	1985-06-21 00:00:00	1985-06-21	1985-06-21 00:00:00	\N	38000177		0	0	0		0	0	0	229697	0	861467	40165015		
31953	2649	1127433	2005-04-23	2005-04-23 00:00:00	2005-05-21	2005-05-21 00:00:00	2005-05-21	38000177		0	0	28		0	0	0	175269	0	313782	1127433		
102175	2240	40213227	2019-03-05	2019-03-05 00:00:00	2019-03-05	2019-03-05 00:00:00	2019-03-05	581452		0	0	0		0	0	0	149173	0	113	40213227		
10260	219	40213227	2010-07-10	2010-07-10 00:00:00	2010-07-10	2010-07-10 00:00:00	2010-07-10	581452		0	0	0		0	0	0	14763	0	113	40213227		
42780	3545	19073188	1988-10-13	1988-10-13 00:00:00	1988-10-27	1988-10-27 00:00:00	1988-10-27	38000177		0	0	14		0	0	0	235452	0	308192	19073188		
10323	220	40213160	1983-02-09	1983-02-09 00:00:00	1983-02-09	1983-02-09 00:00:00	1983-02-09	581452		0	0	0		0	0	0	14830	0	10	40213160		
42654	3536	40229134	2005-12-09	2005-12-09 00:00:00	2005-12-16	2005-12-16 00:00:00	2005-12-16	38000177		0	0	7		0	0	0	234828	0	1043400	40229134		
25910	2131	1127433	1988-06-07	1988-06-07 00:00:00	1988-06-28	1988-06-28 00:00:00	1988-06-28	38000177		0	0	21		0	0	0	141827	0	313782	1127433		
2021	160	19133905	2016-09-06	2016-09-06 00:00:00	2016-09-19	2016-09-19 00:00:00	2016-09-19	38000177		0	0	13		0	0	0	10965	0	834102	19133905		
51920	4317	1127433	1998-11-05	1998-11-05 00:00:00	1999-02-03	1999-02-03 00:00:00	1999-02-03	38000177		0	0	90		0	0	0	286479	0	313782	1127433		
193348	4247	40213180	2005-12-31	2005-12-31 00:00:00	2005-12-31	2005-12-31 00:00:00	2005-12-31	581452		0	0	0		0	0	0	282031	0	114	40213180		
56258	4668	19129655	1963-01-24	1963-01-24 00:00:00	1963-02-07	1963-02-07 00:00:00	1963-02-07	38000177		0	0	14		0	0	0	311073	0	789980	19129655		
18062	1496	1127433	1924-06-28	1924-06-28 00:00:00	1924-07-05	1924-07-05 00:00:00	1924-07-05	38000177		0	0	7		0	0	0	99672	0	313782	1127433		
62561	5203	19133873	1947-01-24	1947-01-24 00:00:00	1947-02-05	1947-02-05 00:00:00	1947-02-05	38000177		0	0	12		0	0	0	346113	0	834061	19133873		
3938	327	1713671	2004-04-08	2004-04-08 00:00:00	2004-04-15	2004-04-15 00:00:00	2004-04-15	38000177		0	0	7		0	0	0	21606	0	562251	1713671		
10196	217	40213314	1977-03-15	1977-03-15 00:00:00	1977-03-15	1977-03-15 00:00:00	1977-03-15	581452		0	0	0		0	0	0	14689	0	49	40213314		
33826	2799	19073183	1985-04-06	1985-04-06 00:00:00	1985-04-20	1985-04-20 00:00:00	1985-04-20	38000177		0	0	14		0	0	0	185507	0	308182	19073183		
15129	327	40213296	2011-11-21	2011-11-21 00:00:00	2011-11-21	2011-11-21 00:00:00	2011-11-21	581452		0	0	0		0	0	0	21586	0	52	40213296		
13160	285	40213227	2001-12-31	2001-12-31 00:00:00	2001-12-31	2001-12-31 00:00:00	2001-12-31	581452		0	0	0		0	0	0	19020	0	113	40213227		
11976	1000	19059056	1965-01-02	1965-01-02 00:00:00	1965-01-16	1965-01-16 00:00:00	1965-01-16	38000177		0	0	14		0	0	0	66144	0	243670	19059056		
12022	1004	1713671	1971-12-29	1971-12-29 00:00:00	1972-01-05	1972-01-05 00:00:00	1972-01-05	38000177		0	0	7		0	0	0	66375	0	562251	1713671		
8072	673	1127433	1984-12-30	1984-12-30 00:00:00	1985-01-27	1985-01-27 00:00:00	1985-01-27	38000177		0	0	28		0	0	0	44436	0	313782	1127433		
8092	675	40229134	1985-03-25	1985-03-25 00:00:00	1985-04-08	1985-04-08 00:00:00	1985-04-08	38000177		0	0	14		0	0	0	44588	0	1043400	40229134		
40315	3339	40229134	1993-06-17	1993-06-17 00:00:00	1993-06-24	1993-06-24 00:00:00	1993-06-24	38000177		0	0	7		0	0	0	221504	0	1043400	40229134		
44599	3694	1127078	1961-11-05	1961-11-05 00:00:00	1961-11-19	1961-11-19 00:00:00	1961-11-19	38000177		0	0	14		0	0	0	245558	0	282464	1127078		
23042	1900	1713671	1979-12-18	1979-12-18 00:00:00	1979-12-25	1979-12-25 00:00:00	1979-12-25	38000177		0	0	7		0	0	0	126458	0	562251	1713671		
49146	4078	19078461	1986-09-15	1986-09-15 00:00:00	1986-10-13	1986-10-13 00:00:00	1986-10-13	38000177		0	0	28		0	0	0	271097	0	310965	19078461		
46373	3841	19128022	1994-08-09	1994-08-09 00:00:00	1995-08-04	1995-08-04 00:00:00	1995-08-04	38000177		0	0	360		0	0	0	254995	0	749785	19128022		
54214	4505	1127433	1992-12-12	1992-12-12 00:00:00	1992-12-26	1992-12-26 00:00:00	1992-12-26	38000177		0	0	14		0	0	0	300116	0	313782	1127433		
33383	2765	19075601	2005-01-11	2005-01-11 00:00:00	2005-01-11	2005-01-11 00:00:00	2005-01-11	38000177		0	0	0		0	0	0	182832	0	309362	19075601		
14786	1236	1115171	1994-08-24	1994-08-24 00:00:00	1994-09-23	1994-09-23 00:00:00	1994-09-23	38000177		0	0	30		0	0	0	81486	0	849574	1115171		
17588	1454	19128065	1989-08-16	1989-08-16 00:00:00	1990-08-11	1990-08-11 00:00:00	1990-08-11	38000177		0	0	360		0	0	0	96991	0	749882	19128065		
28105	2325	1127433	1999-09-17	1999-09-17 00:00:00	1999-10-01	1999-10-01 00:00:00	1999-10-01	38000177		0	0	14		0	0	0	154619	0	313782	1127433		
9193	763	40229134	1990-12-21	1990-12-21 00:00:00	1991-01-04	1991-01-04 00:00:00	1991-01-04	38000177		0	0	14		0	0	0	50753	0	1043400	40229134		
26555	2185	19059056	1942-12-24	1942-12-24 00:00:00	1943-02-22	1943-02-22 00:00:00	1943-02-22	38000177		0	0	60		0	0	0	145621	0	243670	19059056		
26642	2192	1310034	2001-12-06	2001-12-06 00:00:00	2001-12-06	2001-12-06 00:00:00	2001-12-06	38000177		0	0	0		0	0	0	146244	0	834357	1310034		
1411	32	40213227	2004-11-17	2004-11-17 00:00:00	2004-11-17	2004-11-17 00:00:00	2004-11-17	581452		0	0	0		0	0	0	2218	0	113	40213227		
5650	474	1713671	2008-11-20	2008-11-20 00:00:00	2008-12-04	2008-12-04 00:00:00	2008-12-04	38000177		0	0	14		0	0	0	31603	0	562251	1713671		
22043	1812	1127433	2005-09-28	2005-09-28 00:00:00	2005-11-27	2005-11-27 00:00:00	2005-11-27	38000177		0	0	60		0	0	0	121298	0	313782	1127433		
37281	3081	40229134	1975-05-31	1975-05-31 00:00:00	1975-06-14	1975-06-14 00:00:00	1975-06-14	38000177		0	0	14		0	0	0	205159	0	1043400	40229134		
32591	2702	19133905	2007-10-10	2007-10-10 00:00:00	2007-10-20	2007-10-20 00:00:00	2007-10-20	38000177		0	0	10		0	0	0	178938	0	834102	19133905		
94846	2080	40213314	1980-03-21	1980-03-21 00:00:00	1980-03-21	1980-03-21 00:00:00	1980-03-21	581452		0	0	0		0	0	0	138566	0	49	40213314		
20090	437	40213227	2007-04-17	2007-04-17 00:00:00	2007-04-17	2007-04-17 00:00:00	2007-04-17	581452		0	0	0		0	0	0	28970	0	113	40213227		
16342	1355	1127078	1966-11-22	1966-11-22 00:00:00	1966-12-06	1966-12-06 00:00:00	1966-12-06	38000177		0	0	14		0	0	0	89809	0	282464	1127078		
906	74	40236824	2004-01-30	2004-01-30 00:00:00	2004-02-06	2004-02-06 00:00:00	2004-02-06	38000177		0	0	7		0	0	0	4999	0	1094107	40236824		
41091	3409	40165015	2011-04-26	2011-04-26 00:00:00	2011-04-26	2011-04-26 00:00:00	\N	38000177		0	0	0		0	0	0	226124	0	861467	40165015		
41130	3410	1127433	2007-02-01	2007-02-01 00:00:00	2007-02-08	2007-02-08 00:00:00	2007-02-08	38000177		0	0	7		0	0	0	226209	0	313782	1127433		
58547	4860	19019979	1979-10-24	1979-10-24 00:00:00	1979-11-07	1979-11-07 00:00:00	1979-11-07	38000177		0	0	14		0	0	0	323298	0	198405	19019979		
87310	1915	40213160	1974-08-13	1974-08-13 00:00:00	1974-08-13	1974-08-13 00:00:00	1974-08-13	581452		0	0	0		0	0	0	127395	0	10	40213160		
20393	1674	1127433	2013-11-01	2013-11-01 00:00:00	2013-11-15	2013-11-15 00:00:00	2013-11-15	38000177		0	0	14		0	0	0	112393	0	313782	1127433		
16706	1384	1713671	1985-04-25	1985-04-25 00:00:00	1985-05-09	1985-05-09 00:00:00	1985-05-09	38000177		0	0	14		0	0	0	91774	0	562251	1713671		
8854	739	19078461	1975-08-20	1975-08-20 00:00:00	1975-09-19	1975-09-19 00:00:00	1975-09-19	38000177		0	0	30		0	0	0	48930	0	310965	19078461		
1	1	1127078	1958-03-11	1958-03-11 00:00:00	1958-06-09	1958-06-09 00:00:00	1958-06-09	38000177		0	0	90		0	0	0	79	0	282464	1127078		
7641	642	1127433	1992-04-16	1992-04-16 00:00:00	1992-04-30	1992-04-30 00:00:00	1992-04-30	38000177		0	0	14		0	0	0	42497	0	313782	1127433		
16778	1387	40236824	2013-07-18	2013-07-18 00:00:00	2013-07-25	2013-07-25 00:00:00	2013-07-25	38000177		0	0	7		0	0	0	92091	0	1094107	40236824		
4104	339	1127078	1987-11-09	1987-11-09 00:00:00	1987-11-23	1987-11-23 00:00:00	1987-11-23	38000177		0	0	14		0	0	0	22628	0	282464	1127078		
4148	343	1713671	1989-05-08	1989-05-08 00:00:00	1989-05-22	1989-05-22 00:00:00	1989-05-22	38000177		0	0	14		0	0	0	22921	0	562251	1713671		
14645	1227	1332419	2013-03-20	2013-03-20 00:00:00	2013-03-20	2013-03-20 00:00:00	\N	38000177		0	0	0		0	0	0	80769	0	197361	1332419		
36270	2988	19078461	2008-12-01	2008-12-01 00:00:00	2008-12-15	2008-12-15 00:00:00	2008-12-15	38000177		0	0	14		0	0	0	199429	0	310965	19078461		
43440	3601	1127433	1979-01-15	1979-01-15 00:00:00	1979-02-05	1979-02-05 00:00:00	1979-02-05	38000177		0	0	21		0	0	0	239221	0	313782	1127433		
45727	3786	1124300	1995-04-19	1995-04-19 00:00:00	1995-04-19	1995-04-19 00:00:00	\N	38000177		0	0	0		0	0	0	251675	0	00781178901	45011828		
46889	3884	1127078	1974-07-15	1974-07-15 00:00:00	1974-07-29	1974-07-29 00:00:00	1974-07-29	38000177		0	0	14		0	0	0	258156	0	282464	1127078		
41888	3469	1127433	2006-11-11	2006-11-11 00:00:00	2006-11-25	2006-11-25 00:00:00	2006-11-25	38000177		0	0	14		0	0	0	230242	0	313782	1127433		
41746	3456	1127433	1978-11-11	1978-11-11 00:00:00	1978-11-25	1978-11-25 00:00:00	1978-11-25	38000177		0	0	14		0	0	0	229308	0	313782	1127433		
41814	3462	19133873	1961-11-18	1961-11-18 00:00:00	1961-11-25	1961-11-25 00:00:00	1961-11-25	38000177		0	0	7		0	0	0	229710	0	834061	19133873		
31954	2649	1127433	2002-11-15	2002-11-15 00:00:00	2002-11-29	2002-11-29 00:00:00	2002-11-29	38000177		0	0	14		0	0	0	175258	0	313782	1127433		
102181	2240	40213296	1997-04-01	1997-04-01 00:00:00	1997-04-01	1997-04-01 00:00:00	1997-04-01	581452		0	0	0		0	0	0	149152	0	52	40213296		
10261	219	40213296	2010-07-10	2010-07-10 00:00:00	2010-07-10	2010-07-10 00:00:00	2010-07-10	581452		0	0	0		0	0	0	14763	0	52	40213296		
42781	3545	19078461	1988-10-13	1988-10-13 00:00:00	1988-10-27	1988-10-27 00:00:00	1988-10-27	38000177		0	0	14		0	0	0	235452	0	310965	19078461		
60327	5017	1127433	1996-09-16	1996-09-16 00:00:00	1996-09-23	1996-09-23 00:00:00	1996-09-23	38000177		0	0	7		0	0	0	333438	0	313782	1127433		
42655	3536	19128065	1979-10-24	1979-10-24 00:00:00	1980-10-18	1980-10-18 00:00:00	1980-10-18	38000177		0	0	360		0	0	0	234819	0	749882	19128065		
25911	2131	1127433	2014-09-07	2014-09-07 00:00:00	2014-09-14	2014-09-14 00:00:00	2014-09-14	38000177		0	0	7		0	0	0	141845	0	313782	1127433		
2022	160	1127433	1973-02-10	1973-02-10 00:00:00	1973-02-17	1973-02-17 00:00:00	1973-02-17	38000177		0	0	7		0	0	0	10944	0	313782	1127433		
51921	4317	1713671	1967-09-25	1967-09-25 00:00:00	1967-10-09	1967-10-09 00:00:00	1967-10-09	38000177		0	0	14		0	0	0	286498	0	562251	1713671		
193350	4247	40213227	2005-12-31	2005-12-31 00:00:00	2005-12-31	2005-12-31 00:00:00	2005-12-31	581452		0	0	0		0	0	0	282031	0	113	40213227		
56259	4668	1115171	2011-10-05	2011-10-05 00:00:00	2011-10-26	2011-10-26 00:00:00	2011-10-26	38000177		0	0	21		0	0	0	311089	0	849574	1115171		
35585	2933	1713671	1987-09-20	1987-09-20 00:00:00	1987-10-04	1987-10-04 00:00:00	1987-10-04	38000177		0	0	14		0	0	0	195631	0	562251	1713671		
62562	5203	19059056	1942-01-09	1942-01-09 00:00:00	1942-02-13	1942-02-13 00:00:00	1942-02-13	38000177		0	0	35		0	0	0	346053	0	243670	19059056		
3939	327	1713671	2000-11-03	2000-11-03 00:00:00	2000-11-17	2000-11-17 00:00:00	2000-11-17	38000177		0	0	14		0	0	0	21575	0	562251	1713671		
10199	217	40213314	1977-09-13	1977-09-13 00:00:00	1977-09-13	1977-09-13 00:00:00	1977-09-13	581452		0	0	0		0	0	0	14672	0	49	40213314		
33827	2799	1127433	1995-05-14	1995-05-14 00:00:00	1995-06-13	1995-06-13 00:00:00	1995-06-13	38000177		0	0	30		0	0	0	185476	0	313782	1127433		
15132	327	40213227	1993-04-12	1993-04-12 00:00:00	1993-04-12	1993-04-12 00:00:00	1993-04-12	581452		0	0	0		0	0	0	21601	0	113	40213227		
13163	285	40213296	2010-05-31	2010-05-31 00:00:00	2010-05-31	2010-05-31 00:00:00	2010-05-31	581452		0	0	0		0	0	0	19029	0	52	40213296		
1553	123	19133873	1960-10-20	1960-10-20 00:00:00	1960-11-01	1960-11-01 00:00:00	1960-11-01	38000177		0	0	12		0	0	0	8120	0	834061	19133873		
1593	124	19075001	1989-09-12	1989-09-12 00:00:00	1989-09-26	1989-09-26 00:00:00	1989-09-26	38000177		0	0	14		0	0	0	8259	0	309097	19075001		
8073	673	1127433	1978-09-28	1978-09-28 00:00:00	1978-10-12	1978-10-12 00:00:00	1978-10-12	38000177		0	0	14		0	0	0	44433	0	313782	1127433		
8093	675	40236824	1986-03-21	1986-03-21 00:00:00	1986-03-28	1986-03-28 00:00:00	1986-03-28	38000177		0	0	7		0	0	0	44709	0	1094107	40236824		
40316	3339	1127078	1961-08-03	1961-08-03 00:00:00	1961-09-07	1961-09-07 00:00:00	1961-09-07	38000177		0	0	35		0	0	0	221538	0	282464	1127078		
44600	3694	1127433	1993-04-26	1993-04-26 00:00:00	1993-05-24	1993-05-24 00:00:00	1993-05-24	38000177		0	0	28		0	0	0	245564	0	313782	1127433		
35807	2949	19078461	2006-08-05	2006-08-05 00:00:00	2006-08-19	2006-08-19 00:00:00	2006-08-19	38000177		0	0	14		0	0	0	196881	0	310965	19078461		
49167	4080	19078461	2014-05-06	2014-05-06 00:00:00	2014-05-20	2014-05-20 00:00:00	2014-05-20	38000177		0	0	14		0	0	0	271177	0	310965	19078461		
46374	3841	19129655	1975-04-02	1975-04-02 00:00:00	1975-04-16	1975-04-16 00:00:00	1975-04-16	38000177		0	0	14		0	0	0	255041	0	789980	19129655		
54215	4505	40229134	1999-07-25	1999-07-25 00:00:00	1999-08-08	1999-08-08 00:00:00	1999-08-08	38000177		0	0	14		0	0	0	300069	0	1043400	40229134		
33384	2765	40220960	2005-01-11	2005-01-11 00:00:00	2005-01-11	2005-01-11 00:00:00	2005-01-11	38000177		0	0	0		0	0	0	182832	0	1804799	40220960		
14787	1236	1713671	1922-03-26	1922-03-26 00:00:00	1922-04-02	1922-04-02 00:00:00	1922-04-02	38000177		0	0	7		0	0	0	81461	0	562251	1713671		
17589	1454	40229134	1989-12-23	1989-12-23 00:00:00	1989-12-30	1989-12-30 00:00:00	1989-12-30	38000177		0	0	7		0	0	0	96987	0	1043400	40229134		
28106	2325	1127078	1976-07-29	1976-07-29 00:00:00	1976-08-28	1976-08-28 00:00:00	1976-08-28	38000177		0	0	30		0	0	0	154599	0	282464	1127078		
9195	763	1118084	2002-11-29	2002-11-29 00:00:00	2002-11-29	2002-11-29 00:00:00	\N	38000177		0	0	0		0	0	0	50803	0	00025152531	44923712		
26556	2185	1713671	1988-08-14	1988-08-14 00:00:00	1988-09-04	1988-09-04 00:00:00	1988-09-04	38000177		0	0	21		0	0	0	145657	0	562251	1713671		
26643	2192	40243436	2001-12-06	2001-12-06 00:00:00	2001-12-06	2001-12-06 00:00:00	2001-12-06	38000177		0	0	0		0	0	0	146244	0	1190795	40243436		
52658	1151	40213227	2007-01-23	2007-01-23 00:00:00	2007-01-23	2007-01-23 00:00:00	2007-01-23	581452		0	0	0		0	0	0	76108	0	113	40213227		
21669	1780	1154615	1967-06-22	1967-06-22 00:00:00	1985-03-12	1985-03-12 00:00:00	1985-03-12	38000177		0	0	6473		0	0	0	119105	0	745679	1154615		
22044	1812	40231925	2005-09-28	2005-09-28 00:00:00	2005-09-28	2005-09-28 00:00:00	\N	38000177		0	0	0		0	0	0	121298	0	1049221	40231925		
37282	3081	1118084	1984-05-08	1984-05-08 00:00:00	1984-05-08	1984-05-08 00:00:00	\N	38000177		0	0	0		0	0	0	205171	0	00025152531	44923712		
32592	2702	1127433	1992-11-09	1992-11-09 00:00:00	1992-11-23	1992-11-23 00:00:00	1992-11-23	38000177		0	0	14		0	0	0	178973	0	313782	1127433		
94847	2080	40213160	1980-03-21	1980-03-21 00:00:00	1980-03-21	1980-03-21 00:00:00	1980-03-21	581452		0	0	0		0	0	0	138566	0	10	40213160		
86182	1889	40213160	1987-10-29	1987-10-29 00:00:00	1987-10-29	1987-10-29 00:00:00	1987-10-29	581452		0	0	0		0	0	0	125943	0	10	40213160		
16343	1355	40229134	1971-12-24	1971-12-24 00:00:00	1972-01-07	1972-01-07 00:00:00	1972-01-07	38000177		0	0	14		0	0	0	89839	0	1043400	40229134		
907	74	1127433	1998-12-02	1998-12-02 00:00:00	1998-12-16	1998-12-16 00:00:00	1998-12-16	38000177		0	0	14		0	0	0	4988	0	313782	1127433		
41092	3409	1127433	1982-05-27	1982-05-27 00:00:00	1982-06-03	1982-06-03 00:00:00	1982-06-03	38000177		0	0	7		0	0	0	226090	0	313782	1127433		
41131	3410	19128065	1980-04-01	1980-04-01 00:00:00	1981-03-27	1981-03-27 00:00:00	1981-03-27	38000177		0	0	360		0	0	0	226167	0	749882	19128065		
58548	4860	46233988	1979-10-24	1979-10-24 00:00:00	1979-11-07	1979-11-07 00:00:00	1979-11-07	38000177		0	0	14		0	0	0	323298	0	1652673	46233988		
87311	1915	40213160	1974-11-12	1974-11-12 00:00:00	1974-11-12	1974-11-12 00:00:00	1974-11-12	581452		0	0	0		0	0	0	127363	0	10	40213160		
20394	1674	1713671	2008-09-06	2008-09-06 00:00:00	2008-09-20	2008-09-20 00:00:00	2008-09-20	38000177		0	0	14		0	0	0	112380	0	562251	1713671		
16707	1384	19078461	1996-04-15	1996-04-15 00:00:00	1996-06-14	1996-06-14 00:00:00	1996-06-14	38000177		0	0	60		0	0	0	91728	0	310965	19078461		
8855	739	40165015	1975-08-20	1975-08-20 00:00:00	1975-08-20	1975-08-20 00:00:00	\N	38000177		0	0	0		0	0	0	48930	0	861467	40165015		
2	1	19059056	1970-12-03	1970-12-03 00:00:00	1970-12-31	1970-12-31 00:00:00	1970-12-31	38000177		0	0	28		0	0	0	80	0	243670	19059056		
7642	642	19018935	2007-09-09	2007-09-09 00:00:00	2007-09-09	2007-09-09 00:00:00	\N	38000177		0	0	0		0	0	0	42481	0	197604	19018935		
16779	1387	920300	2013-07-18	2013-07-18 00:00:00	2013-07-25	2013-07-25 00:00:00	2013-07-25	38000177		0	0	7		0	0	0	92091	0	311989	920300		
4105	339	19073183	1987-11-09	1987-11-09 00:00:00	1987-11-23	1987-11-23 00:00:00	1987-11-23	38000177		0	0	14		0	0	0	22628	0	308182	19073183		
14626	1226	40229134	1995-09-18	1995-09-18 00:00:00	1995-09-25	1995-09-25 00:00:00	1995-09-25	38000177		0	0	7		0	0	0	80698	0	1043400	40229134		
14646	1227	19059056	1940-10-08	1940-10-08 00:00:00	1940-10-22	1940-10-22 00:00:00	1940-10-22	38000177		0	0	14		0	0	0	80857	0	243670	19059056		
36271	2988	40229134	1972-09-16	1972-09-16 00:00:00	1972-09-23	1972-09-23 00:00:00	1972-09-23	38000177		0	0	7		0	0	0	199464	0	1043400	40229134		
43441	3601	1551192	1965-01-18	1965-01-18 00:00:00	1965-01-18	1965-01-18 00:00:00	1965-01-18	38000177		0	0	0		0	0	0	239217	0	312617	1551192		
45728	3786	1127433	1981-04-12	1981-04-12 00:00:00	1981-04-19	1981-04-19 00:00:00	1981-04-19	38000177		0	0	7		0	0	0	251670	0	313782	1127433		
46890	3884	46233988	1974-07-15	1974-07-15 00:00:00	1974-07-29	1974-07-29 00:00:00	1974-07-29	38000177		0	0	14		0	0	0	258156	0	1652673	46233988		
41889	3469	1115171	1998-08-30	1998-08-30 00:00:00	1998-10-04	1998-10-04 00:00:00	1998-10-04	38000177		0	0	35		0	0	0	230255	0	849574	1115171		
41747	3456	40229134	1959-01-17	1959-01-17 00:00:00	1959-01-24	1959-01-24 00:00:00	1959-01-24	38000177		0	0	7		0	0	0	229297	0	1043400	40229134		
41815	3462	1124300	1995-03-09	1995-03-09 00:00:00	1995-03-09	1995-03-09 00:00:00	\N	38000177		0	0	0		0	0	0	229702	0	00781178901	45011828		
31955	2649	19059056	1971-01-05	1971-01-05 00:00:00	1971-02-02	1971-02-02 00:00:00	1971-02-02	38000177		0	0	28		0	0	0	175266	0	243670	19059056		
46988	1025	40213201	2007-02-10	2007-02-10 00:00:00	2007-02-10	2007-02-10 00:00:00	2007-02-10	581452		0	0	0		0	0	0	67577	0	33	40213201		
10266	219	40213227	2019-06-22	2019-06-22 00:00:00	2019-06-22	2019-06-22 00:00:00	2019-06-22	581452		0	0	0		0	0	0	14794	0	113	40213227		
42782	3545	1127433	1985-05-15	1985-05-15 00:00:00	1985-05-29	1985-05-29 00:00:00	1985-05-29	38000177		0	0	14		0	0	0	235482	0	313782	1127433		
60328	5017	1118084	2015-06-27	2015-06-27 00:00:00	2015-06-27	2015-06-27 00:00:00	\N	38000177		0	0	0		0	0	0	333460	0	00025152531	44923712		
42656	3536	40229134	1990-11-16	1990-11-16 00:00:00	1990-11-30	1990-11-30 00:00:00	1990-11-30	38000177		0	0	14		0	0	0	234842	0	1043400	40229134		
25912	2131	40229134	1958-07-17	1958-07-17 00:00:00	1958-07-24	1958-07-24 00:00:00	1958-07-24	38000177		0	0	7		0	0	0	141791	0	1043400	40229134		
2023	160	1127433	2016-08-05	2016-08-05 00:00:00	2016-09-04	2016-09-04 00:00:00	2016-09-04	38000177		0	0	30		0	0	0	10976	0	313782	1127433		
51922	4317	1127433	2007-11-25	2007-11-25 00:00:00	2007-12-09	2007-12-09 00:00:00	2007-12-09	38000177		0	0	14		0	0	0	286557	0	313782	1127433		
193351	4247	40213306	2005-12-31	2005-12-31 00:00:00	2005-12-31	2005-12-31 00:00:00	2005-12-31	581452		0	0	0		0	0	0	282031	0	43	40213306		
56260	4668	1713671	1981-09-09	1981-09-09 00:00:00	1981-09-30	1981-09-30 00:00:00	1981-09-30	38000177		0	0	21		0	0	0	311071	0	562251	1713671		
35586	2933	19133873	1957-10-31	1957-10-31 00:00:00	1957-11-08	1957-11-08 00:00:00	1957-11-08	38000177		0	0	8		0	0	0	195615	0	834061	19133873		
62563	5203	1545959	2003-03-19	2003-03-19 00:00:00	2003-03-19	2003-03-19 00:00:00	2003-03-19	38000177		0	0	0		0	0	0	346137	0	259255	1545959		
3940	328	40236824	2005-12-08	2005-12-08 00:00:00	2005-12-15	2005-12-15 00:00:00	2005-12-15	38000177		0	0	7		0	0	0	21643	0	1094107	40236824		
10201	217	40213296	2016-03-08	2016-03-08 00:00:00	2016-03-08	2016-03-08 00:00:00	2016-03-08	581452		0	0	0		0	0	0	14695	0	52	40213296		
33828	2799	40165015	1995-05-14	1995-05-14 00:00:00	1995-05-14	1995-05-14 00:00:00	\N	38000177		0	0	0		0	0	0	185476	0	861467	40165015		
15133	327	40213306	1993-04-12	1993-04-12 00:00:00	1993-04-12	1993-04-12 00:00:00	1993-04-12	581452		0	0	0		0	0	0	21601	0	43	40213306		
13172	285	40213160	1970-08-31	1970-08-31 00:00:00	1970-08-31	1970-08-31 00:00:00	1970-08-31	581452		0	0	0		0	0	0	18956	0	10	40213160		
1554	123	1713671	1986-01-05	1986-01-05 00:00:00	1986-01-26	1986-01-26 00:00:00	1986-01-26	38000177		0	0	21		0	0	0	8143	0	562251	1713671		
1594	124	19059056	1993-11-13	1993-11-13 00:00:00	1994-01-12	1994-01-12 00:00:00	1994-01-12	38000177		0	0	60		0	0	0	8288	0	243670	19059056		
40205	3330	19128065	1987-10-04	1987-10-04 00:00:00	1988-09-28	1988-09-28 00:00:00	1988-09-28	38000177		0	0	360		0	0	0	220957	0	749882	19128065		
8094	675	920300	1986-03-21	1986-03-21 00:00:00	1986-03-28	1986-03-28 00:00:00	1986-03-28	38000177		0	0	7		0	0	0	44709	0	311989	920300		
40317	3339	19006318	1963-01-25	1963-01-25 00:00:00	1963-02-08	1963-02-08 00:00:00	1963-02-08	38000177		0	0	14		0	0	0	221479	0	105078	19006318		
44602	3694	1127433	1961-06-18	1961-06-18 00:00:00	1961-07-02	1961-07-02 00:00:00	1961-07-02	38000177		0	0	14		0	0	0	245475	0	313782	1127433		
35808	2949	1127433	1978-12-11	1978-12-11 00:00:00	1978-12-25	1978-12-25 00:00:00	1978-12-25	38000177		0	0	14		0	0	0	196857	0	313782	1127433		
49168	4080	19059056	1970-10-03	1970-10-03 00:00:00	1970-10-24	1970-10-24 00:00:00	1970-10-24	38000177		0	0	21		0	0	0	271172	0	243670	19059056		
46375	3841	1127078	1975-04-02	1975-04-02 00:00:00	1975-04-16	1975-04-16 00:00:00	1975-04-16	38000177		0	0	14		0	0	0	255041	0	282464	1127078		
54216	4505	1713671	1957-03-30	1957-03-30 00:00:00	1957-04-13	1957-04-13 00:00:00	1957-04-13	38000177		0	0	14		0	0	0	299965	0	562251	1713671		
33385	2765	1115171	2016-12-06	2016-12-06 00:00:00	2017-01-03	2017-01-03 00:00:00	2017-01-03	38000177		0	0	28		0	0	0	182885	0	849574	1115171		
14788	1236	1115171	1999-03-31	1999-03-31 00:00:00	1999-04-14	1999-04-14 00:00:00	1999-04-14	38000177		0	0	14		0	0	0	81487	0	849574	1115171		
17590	1454	1127433	1985-05-09	1985-05-09 00:00:00	1985-05-16	1985-05-16 00:00:00	1985-05-16	38000177		0	0	7		0	0	0	96989	0	313782	1127433		
28107	2325	1127433	2019-06-19	2019-06-19 00:00:00	2019-06-19	2019-06-19 00:00:00	\N	38000177		0	0	0		0	0	0	154565	0	313782	1127433		
9196	763	40229134	1990-05-17	1990-05-17 00:00:00	1990-05-24	1990-05-24 00:00:00	1990-05-24	38000177		0	0	7		0	0	0	50743	0	1043400	40229134		
26557	2185	1127433	1983-11-12	1983-11-12 00:00:00	1983-11-19	1983-11-19 00:00:00	1983-11-19	38000177		0	0	7		0	0	0	145683	0	313782	1127433		
26644	2192	46275916	2001-12-06	2001-12-06 00:00:00	2001-12-06	2001-12-06 00:00:00	2001-12-06	38000177		0	0	0		0	0	0	146244	0	1660014	46275916		
52659	1151	40213306	2007-01-23	2007-01-23 00:00:00	2007-01-23	2007-01-23 00:00:00	2007-01-23	581452		0	0	0		0	0	0	76108	0	43	40213306		
21670	1780	40169216	1967-06-22	1967-06-22 00:00:00	1985-03-12	1985-03-12 00:00:00	1985-03-12	38000177		0	0	6473		0	0	0	119105	0	895994	40169216		
22045	1812	19133873	1971-03-04	1971-03-04 00:00:00	1971-03-13	1971-03-13 00:00:00	1971-03-13	38000177		0	0	9		0	0	0	121254	0	834061	19133873		
37283	3081	19078461	2016-07-10	2016-07-10 00:00:00	2016-07-31	2016-07-31 00:00:00	2016-07-31	38000177		0	0	21		0	0	0	205113	0	310965	19078461		
32593	2702	1118084	1983-04-21	1983-04-21 00:00:00	1983-04-21	1983-04-21 00:00:00	\N	38000177		0	0	0		0	0	0	178960	0	00025152531	44923712		
94848	2080	40213251	1984-02-03	1984-02-03 00:00:00	1984-02-03	1984-02-03 00:00:00	1984-02-03	581452		0	0	0		0	0	0	138569	0	21	40213251		
86183	1889	40213251	1987-10-29	1987-10-29 00:00:00	1987-10-29	1987-10-29 00:00:00	1987-10-29	581452		0	0	0		0	0	0	125943	0	21	40213251		
16344	1355	1127433	2007-01-16	2007-01-16 00:00:00	2007-01-30	2007-01-30 00:00:00	2007-01-30	38000177		0	0	14		0	0	0	89860	0	313782	1127433		
908	74	1124300	2015-08-12	2015-08-12 00:00:00	2015-08-12	2015-08-12 00:00:00	\N	38000177		0	0	0		0	0	0	4987	0	00781178901	45011828		
41093	3409	19128065	1974-05-17	1974-05-17 00:00:00	1975-05-12	1975-05-12 00:00:00	1975-05-12	38000177		0	0	360		0	0	0	226081	0	749882	19128065		
41132	3410	19133873	1970-10-14	1970-10-14 00:00:00	1970-10-23	1970-10-23 00:00:00	1970-10-23	38000177		0	0	9		0	0	0	226206	0	834061	19133873		
58549	4860	19128022	1992-09-25	1992-09-25 00:00:00	1993-09-20	1993-09-20 00:00:00	1993-09-20	38000177		0	0	360		0	0	0	323299	0	749785	19128022		
87317	1915	40213314	1977-08-09	1977-08-09 00:00:00	1977-08-09	1977-08-09 00:00:00	1977-08-09	581452		0	0	0		0	0	0	127408	0	49	40213314		
20395	1674	1118084	2012-04-20	2012-04-20 00:00:00	2012-04-20	2012-04-20 00:00:00	\N	38000177		0	0	0		0	0	0	112355	0	00025152531	44923712		
16708	1384	40165015	1996-04-15	1996-04-15 00:00:00	1996-04-15	1996-04-15 00:00:00	\N	38000177		0	0	0		0	0	0	91728	0	861467	40165015		
8856	739	19059056	1914-04-27	1914-04-27 00:00:00	1914-05-11	1914-05-11 00:00:00	1914-05-11	38000177		0	0	14		0	0	0	48943	0	243670	19059056		
3	1	19133873	1953-02-06	1953-02-06 00:00:00	1953-02-16	1953-02-16 00:00:00	1953-02-16	38000177		0	0	10		0	0	0	41	0	834061	19133873		
7643	642	40171902	2007-09-09	2007-09-09 00:00:00	2007-09-09	2007-09-09 00:00:00	\N	38000177		0	0	0		0	0	0	42481	0	897718	40171902		
16780	1387	19128065	1986-03-20	1986-03-20 00:00:00	1987-03-15	1987-03-15 00:00:00	1987-03-15	38000177		0	0	360		0	0	0	91963	0	749882	19128065		
4106	339	1127433	1993-05-19	1993-05-19 00:00:00	1993-06-02	1993-06-02 00:00:00	1993-06-02	38000177		0	0	14		0	0	0	22637	0	313782	1127433		
14627	1226	1118084	2013-08-21	2013-08-21 00:00:00	2013-08-21	2013-08-21 00:00:00	\N	38000177		0	0	0		0	0	0	80684	0	00025152531	44923712		
14647	1227	19059056	1943-03-27	1943-03-27 00:00:00	1943-05-26	1943-05-26 00:00:00	1943-05-26	38000177		0	0	60		0	0	0	80815	0	243670	19059056		
36272	2988	40236446	1976-06-06	1976-06-06 00:00:00	1980-06-15	1980-06-15 00:00:00	1980-06-15	38000177		0	0	1470		0	0	0	199466	0	1091392	40236446		
43442	3601	1713671	1967-05-13	1967-05-13 00:00:00	1967-06-03	1967-06-03 00:00:00	1967-06-03	38000177		0	0	21		0	0	0	239139	0	562251	1713671		
31054	677	40213160	1961-09-08	1961-09-08 00:00:00	1961-09-08	1961-09-08 00:00:00	1961-09-08	581452		0	0	0		0	0	0	44786	0	10	40213160		
65787	1439	40213296	2017-08-19	2017-08-19 00:00:00	2017-08-19	2017-08-19 00:00:00	2017-08-19	581452		0	0	0		0	0	0	95886	0	52	40213296		
41890	3469	19059056	1969-04-19	1969-04-19 00:00:00	1969-05-10	1969-05-10 00:00:00	1969-05-10	38000177		0	0	21		0	0	0	230294	0	243670	19059056		
41748	3456	1713671	1956-11-04	1956-11-04 00:00:00	1956-11-25	1956-11-25 00:00:00	1956-11-25	38000177		0	0	21		0	0	0	229306	0	562251	1713671		
41816	3462	1127078	1969-12-05	1969-12-05 00:00:00	1969-12-19	1969-12-19 00:00:00	1969-12-19	38000177		0	0	14		0	0	0	229716	0	282464	1127078		
31956	2649	1127433	1964-02-29	1964-02-29 00:00:00	1964-03-07	1964-03-07 00:00:00	1964-03-07	38000177		0	0	7		0	0	0	175298	0	313782	1127433		
154402	3399	40213306	2005-09-27	2005-09-27 00:00:00	2005-09-27	2005-09-27 00:00:00	2005-09-27	581452		0	0	0		0	0	0	225443	0	43	40213306		
10267	219	40213260	2019-06-22	2019-06-22 00:00:00	2019-06-22	2019-06-22 00:00:00	2019-06-22	581452		0	0	0		0	0	0	14794	0	121	40213260		
42783	3545	19078461	2010-09-02	2010-09-02 00:00:00	2010-10-07	2010-10-07 00:00:00	2010-10-07	38000177		0	0	35		0	0	0	235440	0	310965	19078461		
60329	5017	1127078	1983-10-23	1983-10-23 00:00:00	1983-11-13	1983-11-13 00:00:00	1983-11-13	38000177		0	0	21		0	0	0	333453	0	282464	1127078		
42657	3536	920300	2010-01-13	2010-01-13 00:00:00	2010-01-20	2010-01-20 00:00:00	2010-01-20	38000177		0	0	7		0	0	0	234856	0	311989	920300		
25913	2131	1127433	1956-06-09	1956-06-09 00:00:00	1956-06-23	1956-06-23 00:00:00	1956-06-23	38000177		0	0	14		0	0	0	141843	0	313782	1127433		
2024	160	40162522	2016-08-05	2016-08-05 00:00:00	2016-08-05	2016-08-05 00:00:00	\N	38000177		0	0	0		0	0	0	10976	0	857005	40162522		
51923	4317	19059056	1964-10-04	1964-10-04 00:00:00	1964-11-03	1964-11-03 00:00:00	1964-11-03	38000177		0	0	30		0	0	0	286478	0	243670	19059056		
193353	4247	40213314	1983-08-27	1983-08-27 00:00:00	1983-08-27	1983-08-27 00:00:00	1983-08-27	581452		0	0	0		0	0	0	282090	0	49	40213314		
56261	4668	1127433	1987-06-22	1987-06-22 00:00:00	1987-08-28	1987-08-28 00:00:00	1987-08-28	38000177		0	0	67		0	0	0	311086	0	313782	1127433		
35587	2933	19059056	1978-06-13	1978-06-13 00:00:00	1978-06-27	1978-06-27 00:00:00	1978-06-27	38000177		0	0	14		0	0	0	195604	0	243670	19059056		
62564	5203	19133768	2003-03-19	2003-03-19 00:00:00	2003-03-19	2003-03-19 00:00:00	2003-03-19	38000177		0	0	0		0	0	0	346137	0	833036	19133768		
3941	328	920300	2005-12-08	2005-12-08 00:00:00	2005-12-15	2005-12-15 00:00:00	2005-12-15	38000177		0	0	7		0	0	0	21643	0	311989	920300		
42077	3488	40165015	1991-06-29	1991-06-29 00:00:00	1991-06-29	1991-06-29 00:00:00	\N	38000177		0	0	0		0	0	0	231358	0	861467	40165015		
33829	2799	1118084	2018-01-13	2018-01-13 00:00:00	2018-01-13	2018-01-13 00:00:00	\N	38000177		0	0	0		0	0	0	185514	0	00025152531	44923712		
15136	327	40213227	2013-11-25	2013-11-25 00:00:00	2013-11-25	2013-11-25 00:00:00	2013-11-25	581452		0	0	0		0	0	0	21604	0	113	40213227		
13181	285	40213227	1992-12-21	1992-12-21 00:00:00	1992-12-21	1992-12-21 00:00:00	1992-12-21	581452		0	0	0		0	0	0	19017	0	113	40213227		
1555	123	1118084	1986-03-24	1986-03-24 00:00:00	1986-03-24	1986-03-24 00:00:00	\N	38000177		0	0	0		0	0	0	8143	0	00025152531	44923712		
1595	124	19008572	1995-09-14	1995-09-14 00:00:00	1995-10-05	1995-10-05 00:00:00	1995-10-05	38000177		0	0	21		0	0	0	8318	0	106258	19008572		
40206	3330	1118084	2018-01-14	2018-01-14 00:00:00	2018-01-14	2018-01-14 00:00:00	\N	38000177		0	0	0		0	0	0	221005	0	00025152531	44923712		
8095	675	1118084	1984-04-03	1984-04-03 00:00:00	1984-04-03	1984-04-03 00:00:00	\N	38000177		0	0	0		0	0	0	44681	0	00025152531	44923712		
40318	3339	19059056	1963-01-25	1963-01-25 00:00:00	1963-02-08	1963-02-08 00:00:00	1963-02-08	38000177		0	0	14		0	0	0	221479	0	243670	19059056		
44603	3694	19078461	2006-07-15	2006-07-15 00:00:00	2006-08-05	2006-08-05 00:00:00	2006-08-05	38000177		0	0	21		0	0	0	245526	0	310965	19078461		
35809	2949	1127078	1956-05-24	1956-05-24 00:00:00	1956-06-23	1956-06-23 00:00:00	1956-06-23	38000177		0	0	30		0	0	0	196877	0	282464	1127078		
49170	4080	40229134	1985-01-19	1985-01-19 00:00:00	1985-02-02	1985-02-02 00:00:00	1985-02-02	38000177		0	0	14		0	0	0	271178	0	1043400	40229134		
46376	3841	1713671	2018-03-10	2018-03-10 00:00:00	2018-03-31	2018-03-31 00:00:00	2018-03-31	38000177		0	0	21		0	0	0	255034	0	562251	1713671		
54217	4505	1127433	2016-04-02	2016-04-02 00:00:00	2016-04-23	2016-04-23 00:00:00	2016-04-23	38000177		0	0	21		0	0	0	300011	0	313782	1127433		
33387	2767	19077572	2019-04-10	2019-04-10 00:00:00	2019-04-10	2019-04-10 00:00:00	\N	38000177		0	0	0		0	0	0	183027	0	310436	19077572		
14789	1237	40169281	1991-04-28	1991-04-28 00:00:00	1991-04-28	1991-04-28 00:00:00	\N	38000177		0	0	0		0	0	0	81496	0	896209	40169281		
17591	1454	46233988	1973-09-29	1973-09-29 00:00:00	1973-10-13	1973-10-13 00:00:00	1973-10-13	38000177		0	0	14		0	0	0	97029	0	1652673	46233988		
28108	2325	1127433	1983-07-04	1983-07-04 00:00:00	1983-07-11	1983-07-11 00:00:00	1983-07-11	38000177		0	0	7		0	0	0	154557	0	313782	1127433		
9197	763	19059056	1970-06-05	1970-06-05 00:00:00	1970-06-19	1970-06-19 00:00:00	1970-06-19	38000177		0	0	14		0	0	0	50737	0	243670	19059056		
26558	2185	1127433	1959-05-13	1959-05-13 00:00:00	1959-06-10	1959-06-10 00:00:00	1959-06-10	38000177		0	0	28		0	0	0	145623	0	313782	1127433		
26645	2192	19133905	2013-10-15	2013-10-15 00:00:00	2013-10-28	2013-10-28 00:00:00	2013-10-28	38000177		0	0	13		0	0	0	146176	0	834102	19133905		
52660	1151	40213180	2007-01-23	2007-01-23 00:00:00	2007-01-23	2007-01-23 00:00:00	2007-01-23	581452		0	0	0		0	0	0	76108	0	114	40213180		
21671	1780	40229134	1974-08-28	1974-08-28 00:00:00	1974-09-04	1974-09-04 00:00:00	1974-09-04	38000177		0	0	7		0	0	0	119168	0	1043400	40229134		
22046	1812	1713671	2012-01-19	2012-01-19 00:00:00	2012-02-09	2012-02-09 00:00:00	2012-02-09	38000177		0	0	21		0	0	0	121295	0	562251	1713671		
37284	3081	1127078	1955-04-06	1955-04-06 00:00:00	1955-06-05	1955-06-05 00:00:00	1955-06-05	38000177		0	0	60		0	0	0	205132	0	282464	1127078		
32594	2702	19078461	1999-09-18	1999-09-18 00:00:00	1999-10-09	1999-10-09 00:00:00	1999-10-09	38000177		0	0	21		0	0	0	179042	0	310965	19078461		
94851	2080	40213306	2000-07-07	2000-07-07 00:00:00	2000-07-07	2000-07-07 00:00:00	2000-07-07	581452		0	0	0		0	0	0	\N	0	43	40213306		
86186	1889	40213227	2014-01-30	2014-01-30 00:00:00	2014-01-30	2014-01-30 00:00:00	2014-01-30	581452		0	0	0		0	0	0	125934	0	113	40213227		
16345	1355	1713671	2009-04-22	2009-04-22 00:00:00	2009-04-29	2009-04-29 00:00:00	2009-04-29	38000177		0	0	7		0	0	0	89841	0	562251	1713671		
909	74	19133873	1978-03-07	1978-03-07 00:00:00	1978-03-18	1978-03-18 00:00:00	1978-03-18	38000177		0	0	11		0	0	0	5008	0	834061	19133873		
41094	3409	19078461	2005-01-27	2005-01-27 00:00:00	2005-02-26	2005-02-26 00:00:00	2005-02-26	38000177		0	0	30		0	0	0	226123	0	310965	19078461		
41134	3410	1713671	1996-05-03	1996-05-03 00:00:00	1996-05-17	1996-05-17 00:00:00	1996-05-17	38000177		0	0	14		0	0	0	226207	0	562251	1713671		
58550	4860	1127433	1995-08-01	1995-08-01 00:00:00	1995-08-31	1995-08-31 00:00:00	1995-08-31	38000177		0	0	30		0	0	0	323340	0	313782	1127433		
87324	1916	40213306	1995-10-16	1995-10-16 00:00:00	1995-10-16	1995-10-16 00:00:00	1995-10-16	581452		0	0	0		0	0	0	127481	0	43	40213306		
20396	1674	1127433	1997-05-07	1997-05-07 00:00:00	1997-05-21	1997-05-21 00:00:00	1997-05-21	38000177		0	0	14		0	0	0	112344	0	313782	1127433		
16709	1384	40224805	2001-02-14	2001-02-14 00:00:00	2002-02-09	2002-02-09 00:00:00	2002-02-09	38000177		0	0	360		0	0	0	91753	0	1000126	40224805		
8857	739	1127433	1923-06-26	1923-06-26 00:00:00	1923-07-03	1923-07-03 00:00:00	1923-07-03	38000177		0	0	7		0	0	0	48971	0	313782	1127433		
4	1	1713671	1967-05-30	1967-05-30 00:00:00	1967-06-20	1967-06-20 00:00:00	1967-06-20	38000177		0	0	21		0	0	0	74	0	562251	1713671		
7644	642	40163554	2007-09-09	2007-09-09 00:00:00	2007-09-09	2007-09-09 00:00:00	\N	38000177		0	0	0		0	0	0	42481	0	855332	40163554		
16781	1387	19019979	1980-08-31	1980-08-31 00:00:00	1980-11-29	1980-11-29 00:00:00	1980-11-29	38000177		0	0	90		0	0	0	92092	0	198405	19019979		
4107	339	19019979	1994-08-09	1994-08-09 00:00:00	1994-09-08	1994-09-08 00:00:00	1994-09-08	38000177		0	0	30		0	0	0	22663	0	198405	19019979		
14628	1226	1115171	2014-09-05	2014-09-05 00:00:00	2014-09-26	2014-09-26 00:00:00	2014-09-26	38000177		0	0	21		0	0	0	80696	0	849574	1115171		
14648	1227	1127433	1960-07-14	1960-07-14 00:00:00	1960-08-04	1960-08-04 00:00:00	1960-08-04	38000177		0	0	21		0	0	0	80820	0	313782	1127433		
36273	2989	19133873	1958-10-02	1958-10-02 00:00:00	1958-10-13	1958-10-13 00:00:00	1958-10-13	38000177		0	0	11		0	0	0	199542	0	834061	19133873		
43443	3601	1551192	1976-03-25	1976-03-25 00:00:00	1976-03-25	1976-03-25 00:00:00	1976-03-25	38000177		0	0	0		0	0	0	239219	0	312617	1551192		
31057	677	40213260	2011-06-03	2011-06-03 00:00:00	2011-06-03	2011-06-03 00:00:00	2011-06-03	581452		0	0	0		0	0	0	44846	0	121	40213260		
65789	1439	40213160	1978-03-18	1978-03-18 00:00:00	1978-03-18	1978-03-18 00:00:00	1978-03-18	581452		0	0	0		0	0	0	\N	0	10	40213160		
41891	3469	1127433	2015-09-18	2015-09-18 00:00:00	2015-10-02	2015-10-02 00:00:00	2015-10-02	38000177		0	0	14		0	0	0	230213	0	313782	1127433		
41749	3456	1127433	1977-08-22	1977-08-22 00:00:00	1977-09-12	1977-09-12 00:00:00	1977-09-12	38000177		0	0	21		0	0	0	229294	0	313782	1127433		
41817	3462	1127433	1994-09-26	1994-09-26 00:00:00	1994-10-03	1994-10-03 00:00:00	1994-10-03	38000177		0	0	7		0	0	0	229733	0	313782	1127433		
31957	2649	1127433	2017-06-15	2017-06-15 00:00:00	2017-06-22	2017-06-22 00:00:00	2017-06-22	38000177		0	0	7		0	0	0	175275	0	313782	1127433		
154403	3399	40213180	2005-09-27	2005-09-27 00:00:00	2005-09-27	2005-09-27 00:00:00	2005-09-27	581452		0	0	0		0	0	0	225443	0	114	40213180		
10269	219	40213260	2018-03-31	2018-03-31 00:00:00	2018-03-31	2018-03-31 00:00:00	2018-03-31	581452		0	0	0		0	0	0	14764	0	121	40213260		
42784	3545	1127433	1983-05-29	1983-05-29 00:00:00	1983-08-27	1983-08-27 00:00:00	1983-08-27	38000177		0	0	90		0	0	0	235438	0	313782	1127433		
60330	5018	1713671	1964-01-16	1964-01-16 00:00:00	1964-01-23	1964-01-23 00:00:00	1964-01-23	38000177		0	0	7		0	0	0	333463	0	562251	1713671		
42658	3536	40236824	2010-01-13	2010-01-13 00:00:00	2010-01-20	2010-01-20 00:00:00	2010-01-20	38000177		0	0	7		0	0	0	234856	0	1094107	40236824		
25914	2131	40229134	1959-06-20	1959-06-20 00:00:00	1959-06-27	1959-06-27 00:00:00	1959-06-27	38000177		0	0	7		0	0	0	141792	0	1043400	40229134		
2025	160	1127433	1966-01-03	1966-01-03 00:00:00	1966-01-17	1966-01-17 00:00:00	1966-01-17	38000177		0	0	14		0	0	0	10960	0	313782	1127433		
51924	4317	19059056	1954-01-30	1954-01-30 00:00:00	1954-04-30	1954-04-30 00:00:00	1954-04-30	38000177		0	0	90		0	0	0	286476	0	243670	19059056		
193354	4247	40213160	1983-08-27	1983-08-27 00:00:00	1983-08-27	1983-08-27 00:00:00	1983-08-27	581452		0	0	0		0	0	0	282090	0	10	40213160		
56262	4668	1127433	1976-05-22	1976-05-22 00:00:00	1976-05-29	1976-05-29 00:00:00	1976-05-29	38000177		0	0	7		0	0	0	311033	0	313782	1127433		
35588	2933	19133873	1954-07-25	1954-07-25 00:00:00	1954-08-04	1954-08-04 00:00:00	1954-08-04	38000177		0	0	10		0	0	0	195594	0	834061	19133873		
62565	5203	1713671	1997-01-29	1997-01-29 00:00:00	1997-02-19	1997-02-19 00:00:00	1997-02-19	38000177		0	0	21		0	0	0	346057	0	562251	1713671		
3942	328	1127433	1985-04-27	1985-04-27 00:00:00	1985-05-11	1985-05-11 00:00:00	1985-05-11	38000177		0	0	14		0	0	0	21641	0	313782	1127433		
42078	3488	19078461	1991-06-29	1991-06-29 00:00:00	1991-07-29	1991-07-29 00:00:00	1991-07-29	38000177		0	0	30		0	0	0	231358	0	310965	19078461		
33830	2799	19019979	1986-08-29	1986-08-29 00:00:00	1986-11-27	1986-11-27 00:00:00	1986-11-27	38000177		0	0	90		0	0	0	185475	0	198405	19019979		
15137	327	40213296	2013-11-25	2013-11-25 00:00:00	2013-11-25	2013-11-25 00:00:00	2013-11-25	581452		0	0	0		0	0	0	21604	0	52	40213296		
13182	285	40213306	1992-12-21	1992-12-21 00:00:00	1992-12-21	1992-12-21 00:00:00	1992-12-21	581452		0	0	0		0	0	0	19017	0	43	40213306		
1556	123	40243436	2013-07-10	2013-07-10 00:00:00	2013-07-10	2013-07-10 00:00:00	2013-07-10	38000177		0	0	0		0	0	0	8146	0	1190795	40243436		
1607	126	1713671	1989-05-26	1989-05-26 00:00:00	1989-06-09	1989-06-09 00:00:00	1989-06-09	38000177		0	0	14		0	0	0	8418	0	562251	1713671		
40207	3330	19128022	1996-08-17	1996-08-17 00:00:00	1997-08-12	1997-08-12 00:00:00	1997-08-12	38000177		0	0	360		0	0	0	220960	0	749785	19128022		
8096	675	40229134	1975-12-16	1975-12-16 00:00:00	1975-12-30	1975-12-30 00:00:00	1975-12-30	38000177		0	0	14		0	0	0	44577	0	1043400	40229134		
40319	3339	19133873	1968-08-09	1968-08-09 00:00:00	1968-08-16	1968-08-16 00:00:00	1968-08-16	38000177		0	0	7		0	0	0	221532	0	834061	19133873		
44604	3694	19115351	1971-08-24	1971-08-24 00:00:00	1971-12-07	1971-12-07 00:00:00	1971-12-07	38000177		0	0	105		0	0	0	245487	0	563026	19115351		
35810	2949	1127078	1960-03-04	1960-03-04 00:00:00	1960-05-03	1960-05-03 00:00:00	1960-05-03	38000177		0	0	60		0	0	0	196878	0	282464	1127078		
49171	4080	1127078	1971-11-18	1971-11-18 00:00:00	1972-01-17	1972-01-17 00:00:00	1972-01-17	38000177		0	0	60		0	0	0	271173	0	282464	1127078		
46377	3841	40229134	1975-04-13	1975-04-13 00:00:00	1975-04-20	1975-04-20 00:00:00	1975-04-20	38000177		0	0	7		0	0	0	255021	0	1043400	40229134		
54218	4505	1124300	1981-10-23	1981-10-23 00:00:00	1981-10-23	1981-10-23 00:00:00	\N	38000177		0	0	0		0	0	0	300120	0	00781178901	45011828		
33388	2767	1127433	1942-08-06	1942-08-06 00:00:00	1942-08-20	1942-08-20 00:00:00	1942-08-20	38000177		0	0	14		0	0	0	183074	0	313782	1127433		
14790	1237	1127433	1971-01-11	1971-01-11 00:00:00	1971-01-18	1971-01-18 00:00:00	1971-01-18	38000177		0	0	7		0	0	0	81545	0	313782	1127433		
17592	1454	1127078	1973-09-29	1973-09-29 00:00:00	1973-10-13	1973-10-13 00:00:00	1973-10-13	38000177		0	0	14		0	0	0	97029	0	282464	1127078		
28109	2325	19133905	2018-10-30	2018-10-30 00:00:00	2018-11-08	2018-11-08 00:00:00	2018-11-08	38000177		0	0	9		0	0	0	154562	0	834102	19133905		
9199	763	1115171	1995-04-24	1995-04-24 00:00:00	1995-05-15	1995-05-15 00:00:00	1995-05-15	38000177		0	0	21		0	0	0	50734	0	849574	1115171		
26559	2185	19059056	1954-09-22	1954-09-22 00:00:00	1954-10-05	1954-10-05 00:00:00	1954-10-05	38000177		0	0	13		0	0	0	145622	0	243670	19059056		
26646	2192	1127433	1956-05-18	1956-05-18 00:00:00	1956-05-25	1956-05-25 00:00:00	1956-05-25	38000177		0	0	7		0	0	0	146219	0	313782	1127433		
21623	1776	19133873	1921-08-06	1921-08-06 00:00:00	1921-08-13	1921-08-13 00:00:00	1921-08-13	38000177		0	0	7		0	0	0	118770	0	834061	19133873		
21672	1780	19006318	1966-11-07	1966-11-07 00:00:00	1966-11-21	1966-11-21 00:00:00	1966-11-21	38000177		0	0	14		0	0	0	119179	0	105078	19006318		
22406	486	40213160	1961-07-13	1961-07-13 00:00:00	1961-07-13	1961-07-13 00:00:00	1961-07-13	581452		0	0	0		0	0	0	32482	0	10	40213160		
37285	3081	19078461	1978-06-02	1978-06-02 00:00:00	1978-06-30	1978-06-30 00:00:00	1978-06-30	38000177		0	0	28		0	0	0	205135	0	310965	19078461		
32595	2702	19059056	1944-02-16	1944-02-16 00:00:00	1944-03-01	1944-03-01 00:00:00	1944-03-01	38000177		0	0	14		0	0	0	179009	0	243670	19059056		
94853	2080	40213160	1984-01-27	1984-01-27 00:00:00	1984-01-27	1984-01-27 00:00:00	1984-01-27	581452		0	0	0		0	0	0	\N	0	10	40213160		
23495	1934	19006318	1961-05-24	1961-05-24 00:00:00	1961-06-07	1961-06-07 00:00:00	1961-06-07	38000177		0	0	14		0	0	0	128650	0	105078	19006318		
16346	1355	19129655	1975-11-20	1975-11-20 00:00:00	1975-12-04	1975-12-04 00:00:00	1975-12-04	38000177		0	0	14		0	0	0	89802	0	789980	19129655		
910	74	1127078	1977-07-07	1977-07-07 00:00:00	1977-07-21	1977-07-21 00:00:00	1977-07-21	38000177		0	0	14		0	0	0	5016	0	282464	1127078		
41095	3409	1127433	1985-10-25	1985-10-25 00:00:00	1985-11-01	1985-11-01 00:00:00	1985-11-01	38000177		0	0	7		0	0	0	226091	0	313782	1127433		
41157	3413	1713671	1980-05-14	1980-05-14 00:00:00	1980-06-25	1980-06-25 00:00:00	1980-06-25	38000177		0	0	42		0	0	0	226420	0	562251	1713671		
58551	4860	40162522	1995-08-01	1995-08-01 00:00:00	1995-08-01	1995-08-01 00:00:00	\N	38000177		0	0	0		0	0	0	323340	0	857005	40162522		
87326	1916	40213160	1972-01-10	1972-01-10 00:00:00	1972-01-10	1972-01-10 00:00:00	1972-01-10	581452		0	0	0		0	0	0	127500	0	10	40213160		
20397	1674	19133873	1980-06-23	1980-06-23 00:00:00	1980-07-06	1980-07-06 00:00:00	1980-07-06	38000177		0	0	13		0	0	0	112368	0	834061	19133873		
16710	1384	19128065	1998-03-02	1998-03-02 00:00:00	1999-02-25	1999-02-25 00:00:00	1999-02-25	38000177		0	0	360		0	0	0	91752	0	749882	19128065		
8858	739	19078461	1978-05-06	1978-05-06 00:00:00	1978-07-05	1978-07-05 00:00:00	1978-07-05	38000177		0	0	60		0	0	0	48931	0	310965	19078461		
5	1	1713671	2012-02-14	2012-02-14 00:00:00	2012-02-28	2012-02-28 00:00:00	2012-02-28	38000177		0	0	14		0	0	0	25	0	562251	1713671		
7645	642	19059056	1949-12-11	1949-12-11 00:00:00	1950-01-01	1950-01-01 00:00:00	1950-01-01	38000177		0	0	21		0	0	0	42462	0	243670	19059056		
16792	1389	19059056	1955-07-03	1955-07-03 00:00:00	1955-07-17	1955-07-17 00:00:00	1955-07-17	38000177		0	0	14		0	0	0	92223	0	243670	19059056		
4108	339	1713671	2000-04-23	2000-04-23 00:00:00	2000-05-14	2000-05-14 00:00:00	2000-05-14	38000177		0	0	21		0	0	0	22623	0	562251	1713671		
14629	1226	40229134	1989-07-19	1989-07-19 00:00:00	1989-08-02	1989-08-02 00:00:00	1989-08-02	38000177		0	0	14		0	0	0	80692	0	1043400	40229134		
14649	1227	1127433	1956-01-08	1956-01-08 00:00:00	1956-01-22	1956-01-22 00:00:00	1956-01-22	38000177		0	0	14		0	0	0	80845	0	313782	1127433		
36274	2989	19059056	1956-04-13	1956-04-13 00:00:00	1956-05-18	1956-05-18 00:00:00	1956-05-18	38000177		0	0	35		0	0	0	199584	0	243670	19059056		
43444	3601	1127433	1992-06-26	1992-06-26 00:00:00	1992-07-10	1992-07-10 00:00:00	1992-07-10	38000177		0	0	14		0	0	0	239224	0	313782	1127433		
31069	677	40213296	2002-02-01	2002-02-01 00:00:00	2002-02-01	2002-02-01 00:00:00	2002-02-01	581452		0	0	0		0	0	0	44844	0	52	40213296		
65794	1439	40213314	1978-01-21	1978-01-21 00:00:00	1978-01-21	1978-01-21 00:00:00	1978-01-21	581452		0	0	0		0	0	0	95867	0	49	40213314		
41892	3469	40231925	1983-02-26	1983-02-26 00:00:00	1983-02-26	1983-02-26 00:00:00	\N	38000177		0	0	0		0	0	0	230250	0	1049221	40231925		
41750	3456	19006318	1946-10-11	1946-10-11 00:00:00	1946-10-25	1946-10-25 00:00:00	1946-10-25	38000177		0	0	14		0	0	0	229289	0	105078	19006318		
41818	3462	1115171	2018-04-29	2018-04-29 00:00:00	2018-05-13	2018-05-13 00:00:00	2018-05-13	38000177		0	0	14		0	0	0	229770	0	849574	1115171		
31958	2649	1127433	1986-08-03	1986-08-03 00:00:00	1986-08-31	1986-08-31 00:00:00	1986-08-31	38000177		0	0	28		0	0	0	175268	0	313782	1127433		
30358	2518	1127078	1961-01-11	1961-01-11 00:00:00	1961-02-10	1961-02-10 00:00:00	1961-02-10	38000177		0	0	30		0	0	0	166538	0	282464	1127078		
10270	219	40213306	1991-12-07	1991-12-07 00:00:00	1991-12-07	1991-12-07 00:00:00	1991-12-07	581452		0	0	0		0	0	0	\N	0	43	40213306		
42785	3545	40229134	1974-10-03	1974-10-03 00:00:00	1974-10-17	1974-10-17 00:00:00	1974-10-17	38000177		0	0	14		0	0	0	235445	0	1043400	40229134		
60331	5018	1713671	2012-11-14	2012-11-14 00:00:00	2012-12-05	2012-12-05 00:00:00	2012-12-05	38000177		0	0	21		0	0	0	333490	0	562251	1713671		
42659	3536	920334	2006-12-05	2006-12-05 00:00:00	2006-12-12	2006-12-12 00:00:00	2006-12-12	38000177		0	0	7		0	0	0	234853	0	311995	920334		
25915	2131	19059056	1956-06-29	1956-06-29 00:00:00	1956-07-20	1956-07-20 00:00:00	1956-07-20	38000177		0	0	21		0	0	0	141823	0	243670	19059056		
2026	160	1118084	2006-02-01	2006-02-01 00:00:00	2006-02-01	2006-02-01 00:00:00	\N	38000177		0	0	0		0	0	0	10999	0	00025152531	44923712		
51925	4317	1127433	1977-11-23	1977-11-23 00:00:00	1977-11-30	1977-11-30 00:00:00	1977-11-30	38000177		0	0	7		0	0	0	286508	0	313782	1127433		
193355	4247	40213314	1984-05-26	1984-05-26 00:00:00	1984-05-26	1984-05-26 00:00:00	1984-05-26	581452		0	0	0		0	0	0	282091	0	49	40213314		
56268	4670	1127078	1958-02-08	1958-02-08 00:00:00	1958-02-22	1958-02-22 00:00:00	1958-02-22	38000177		0	0	14		0	0	0	311154	0	282464	1127078		
35600	2935	1127078	1981-01-11	1981-01-11 00:00:00	1981-03-12	1981-03-12 00:00:00	1981-03-12	38000177		0	0	60		0	0	0	195677	0	282464	1127078		
62566	5203	1127433	1996-10-10	1996-10-10 00:00:00	1996-10-17	1996-10-17 00:00:00	1996-10-17	38000177		0	0	7		0	0	0	346114	0	313782	1127433		
3943	328	40229134	2014-03-31	2014-03-31 00:00:00	2014-04-07	2014-04-07 00:00:00	2014-04-07	38000177		0	0	7		0	0	0	21666	0	1043400	40229134		
42079	3488	1127078	1955-05-23	1955-05-23 00:00:00	1955-06-06	1955-06-06 00:00:00	1955-06-06	38000177		0	0	14		0	0	0	231346	0	282464	1127078		
33831	2799	1115171	2000-05-17	2000-05-17 00:00:00	2000-05-31	2000-05-31 00:00:00	2000-05-31	38000177		0	0	14		0	0	0	185477	0	849574	1115171		
15140	327	40213227	2003-11-10	2003-11-10 00:00:00	2003-11-10	2003-11-10 00:00:00	2003-11-10	581452		0	0	0		0	0	0	21589	0	113	40213227		
13186	285	40213227	2012-06-04	2012-06-04 00:00:00	2012-06-04	2012-06-04 00:00:00	2012-06-04	581452		0	0	0		0	0	0	19033	0	113	40213227		
1557	123	46275916	2013-07-10	2013-07-10 00:00:00	2013-07-10	2013-07-10 00:00:00	2013-07-10	38000177		0	0	0		0	0	0	8146	0	1660014	46275916		
1608	126	1118084	1989-09-03	1989-09-03 00:00:00	1989-09-03	1989-09-03 00:00:00	\N	38000177		0	0	0		0	0	0	8478	0	00025152531	44923712		
40208	3330	1127433	2009-06-02	2009-06-02 00:00:00	2009-06-09	2009-06-09 00:00:00	2009-06-09	38000177		0	0	7		0	0	0	220956	0	313782	1127433		
8097	675	19133873	1959-04-06	1959-04-06 00:00:00	1959-04-17	1959-04-17 00:00:00	1959-04-17	38000177		0	0	11		0	0	0	44575	0	834061	19133873		
40320	3342	1713671	1938-12-10	1938-12-10 00:00:00	1938-12-24	1938-12-24 00:00:00	1938-12-24	38000177		0	0	14		0	0	0	221549	0	562251	1713671		
44605	3694	1127433	2019-01-24	2019-01-24 00:00:00	2019-02-07	2019-02-07 00:00:00	2019-02-07	38000177		0	0	14		0	0	0	245481	0	313782	1127433		
35811	2949	1127433	1964-05-13	1964-05-13 00:00:00	1964-05-20	1964-05-20 00:00:00	1964-05-20	38000177		0	0	7		0	0	0	196863	0	313782	1127433		
49172	4080	1127433	1993-09-05	1993-09-05 00:00:00	1993-09-19	1993-09-19 00:00:00	1993-09-19	38000177		0	0	14		0	0	0	271157	0	313782	1127433		
46378	3841	19128065	1989-09-04	1989-09-04 00:00:00	1990-08-30	1990-08-30 00:00:00	1990-08-30	38000177		0	0	360		0	0	0	255042	0	749882	19128065		
54219	4505	19133905	1981-05-21	1981-05-21 00:00:00	1981-06-03	1981-06-03 00:00:00	1981-06-03	38000177		0	0	13		0	0	0	300042	0	834102	19133905		
33389	2767	1127433	1973-02-23	1973-02-23 00:00:00	1973-03-23	1973-03-23 00:00:00	1973-03-23	38000177		0	0	28		0	0	0	183065	0	313782	1127433		
14791	1237	19133873	1949-06-25	1949-06-25 00:00:00	1949-07-08	1949-07-08 00:00:00	1949-07-08	38000177		0	0	13		0	0	0	81512	0	834061	19133873		
17593	1454	19128065	1987-08-27	1987-08-27 00:00:00	1988-08-21	1988-08-21 00:00:00	1988-08-21	38000177		0	0	360		0	0	0	97030	0	749882	19128065		
28110	2325	19128065	1988-10-04	1988-10-04 00:00:00	1989-09-29	1989-09-29 00:00:00	1989-09-29	38000177		0	0	360		0	0	0	154566	0	749882	19128065		
9200	764	1127433	2012-05-30	2012-05-30 00:00:00	2012-06-29	2012-06-29 00:00:00	2012-06-29	38000177		0	0	30		0	0	0	50859	0	313782	1127433		
26560	2185	19133873	1948-06-09	1948-06-09 00:00:00	1948-06-22	1948-06-22 00:00:00	1948-06-22	38000177		0	0	13		0	0	0	145676	0	834061	19133873		
26648	2192	19006318	1957-01-11	1957-01-11 00:00:00	1957-01-25	1957-01-25 00:00:00	1957-01-25	38000177		0	0	14		0	0	0	146151	0	105078	19006318		
21629	1778	1115171	2015-01-14	2015-01-14 00:00:00	2015-02-04	2015-02-04 00:00:00	2015-02-04	38000177		0	0	21		0	0	0	118932	0	849574	1115171		
21673	1780	19059056	1966-11-07	1966-11-07 00:00:00	1966-11-21	1966-11-21 00:00:00	1966-11-21	38000177		0	0	14		0	0	0	119179	0	243670	19059056		
22410	486	40213227	1992-01-16	1992-01-16 00:00:00	1992-01-16	1992-01-16 00:00:00	1992-01-16	581452		0	0	0		0	0	0	32491	0	113	40213227		
37286	3081	1127433	2015-09-03	2015-09-03 00:00:00	2015-09-17	2015-09-17 00:00:00	2015-09-17	38000177		0	0	14		0	0	0	205163	0	313782	1127433		
32596	2702	19059056	1944-09-15	1944-09-15 00:00:00	1944-09-29	1944-09-29 00:00:00	1944-09-29	38000177		0	0	14		0	0	0	179010	0	243670	19059056		
94854	2080	40213251	1984-01-27	1984-01-27 00:00:00	1984-01-27	1984-01-27 00:00:00	1984-01-27	581452		0	0	0		0	0	0	\N	0	21	40213251		
23496	1934	1127078	1961-05-24	1961-05-24 00:00:00	1961-06-07	1961-06-07 00:00:00	1961-06-07	38000177		0	0	14		0	0	0	128650	0	282464	1127078		
16347	1355	1127433	1975-11-20	1975-11-20 00:00:00	1975-12-04	1975-12-04 00:00:00	1975-12-04	38000177		0	0	14		0	0	0	89802	0	313782	1127433		
911	74	19128065	1986-12-27	1986-12-27 00:00:00	1987-12-22	1987-12-22 00:00:00	1987-12-22	38000177		0	0	360		0	0	0	4992	0	749882	19128065		
41096	3409	1127078	1957-05-06	1957-05-06 00:00:00	1957-08-04	1957-08-04 00:00:00	1957-08-04	38000177		0	0	90		0	0	0	226136	0	282464	1127078		
41158	3413	1127433	1982-08-23	1982-08-23 00:00:00	1982-08-30	1982-08-30 00:00:00	1982-08-30	38000177		0	0	7		0	0	0	226378	0	313782	1127433		
58552	4860	1127433	1980-06-21	1980-06-21 00:00:00	1980-07-05	1980-07-05 00:00:00	1980-07-05	38000177		0	0	14		0	0	0	323343	0	313782	1127433		
87335	1916	40213160	1972-06-12	1972-06-12 00:00:00	1972-06-12	1972-06-12 00:00:00	1972-06-12	581452		0	0	0		0	0	0	127501	0	10	40213160		
20398	1674	19078461	1995-12-01	1995-12-01 00:00:00	1995-12-15	1995-12-15 00:00:00	1995-12-15	38000177		0	0	14		0	0	0	112386	0	310965	19078461		
16711	1384	1127078	1989-03-09	1989-03-09 00:00:00	1989-04-08	1989-04-08 00:00:00	1989-04-08	38000177		0	0	30		0	0	0	91723	0	282464	1127078		
8859	739	19059056	1910-09-30	1910-09-30 00:00:00	1910-10-14	1910-10-14 00:00:00	1910-10-14	38000177		0	0	14		0	0	0	48929	0	243670	19059056		
6	1	1118084	1982-08-12	1982-08-12 00:00:00	1982-08-12	1982-08-12 00:00:00	\N	38000177		0	0	0		0	0	0	85	0	00025152531	44923712		
7646	642	40229134	1950-06-06	1950-06-06 00:00:00	1950-06-13	1950-06-13 00:00:00	1950-06-13	38000177		0	0	7		0	0	0	42518	0	1043400	40229134		
16793	1389	19006318	1955-07-03	1955-07-03 00:00:00	1955-07-17	1955-07-17 00:00:00	1955-07-17	38000177		0	0	14		0	0	0	92223	0	105078	19006318		
4109	339	19059056	1990-02-03	1990-02-03 00:00:00	1990-03-03	1990-03-03 00:00:00	1990-03-03	38000177		0	0	28		0	0	0	22608	0	243670	19059056		
14630	1227	19059056	1961-08-29	1961-08-29 00:00:00	1961-11-04	1961-11-04 00:00:00	1961-11-04	38000177		0	0	67		0	0	0	80821	0	243670	19059056		
14650	1227	45892894	2018-12-22	2018-12-22 00:00:00	2018-12-22	2018-12-22 00:00:00	\N	38000177		0	0	0		0	0	0	80856	0	1599803	45892894		
36275	2989	1713671	1976-06-02	1976-06-02 00:00:00	1976-06-09	1976-06-09 00:00:00	1976-06-09	38000177		0	0	7		0	0	0	199553	0	562251	1713671		
43445	3601	19128065	1979-05-15	1979-05-15 00:00:00	1980-05-09	1980-05-09 00:00:00	1980-05-09	38000177		0	0	360		0	0	0	239206	0	749882	19128065		
31076	677	40213160	1961-11-10	1961-11-10 00:00:00	1961-11-10	1961-11-10 00:00:00	1961-11-10	581452		0	0	0		0	0	0	44823	0	10	40213160		
65795	1439	40213160	1978-01-21	1978-01-21 00:00:00	1978-01-21	1978-01-21 00:00:00	1978-01-21	581452		0	0	0		0	0	0	95867	0	10	40213160		
41893	3469	1127433	1983-02-26	1983-02-26 00:00:00	1983-03-26	1983-03-26 00:00:00	1983-03-26	38000177		0	0	28		0	0	0	230250	0	313782	1127433		
41751	3456	19059056	1946-10-11	1946-10-11 00:00:00	1946-10-25	1946-10-25 00:00:00	1946-10-25	38000177		0	0	14		0	0	0	229289	0	243670	19059056		
46903	1024	40213201	2008-05-18	2008-05-18 00:00:00	2008-05-18	2008-05-18 00:00:00	2008-05-18	581452		0	0	0		0	0	0	67464	0	33	40213201		
31959	2649	1127078	1962-05-08	1962-05-08 00:00:00	1962-05-22	1962-05-22 00:00:00	1962-05-22	38000177		0	0	14		0	0	0	175265	0	282464	1127078		
30359	2518	1127433	1983-08-05	1983-08-05 00:00:00	1983-08-26	1983-08-26 00:00:00	1983-08-26	38000177		0	0	21		0	0	0	166541	0	313782	1127433		
51412	4274	1127433	1943-04-22	1943-04-22 00:00:00	1943-04-29	1943-04-29 00:00:00	1943-04-29	38000177		0	0	7		0	0	0	283663	0	313782	1127433		
42786	3545	1127078	1973-01-21	1973-01-21 00:00:00	1973-02-04	1973-02-04 00:00:00	1973-02-04	38000177		0	0	14		0	0	0	235498	0	282464	1127078		
60332	5018	40236824	1980-11-30	1980-11-30 00:00:00	1980-12-07	1980-12-07 00:00:00	1980-12-07	38000177		0	0	7		0	0	0	333530	0	1094107	40236824		
42661	3536	19133873	1974-06-24	1974-06-24 00:00:00	1974-07-04	1974-07-04 00:00:00	1974-07-04	38000177		0	0	10		0	0	0	234840	0	834061	19133873		
25924	2133	1713671	1966-01-10	1966-01-10 00:00:00	1966-01-31	1966-01-31 00:00:00	1966-01-31	38000177		0	0	21		0	0	0	141895	0	562251	1713671		
2027	160	19133873	1961-10-28	1961-10-28 00:00:00	1961-11-08	1961-11-08 00:00:00	1961-11-08	38000177		0	0	11		0	0	0	10977	0	834061	19133873		
51926	4317	1127433	1970-12-03	1970-12-03 00:00:00	1970-12-17	1970-12-17 00:00:00	1970-12-17	38000177		0	0	14		0	0	0	286552	0	313782	1127433		
193356	4247	40213251	1984-05-26	1984-05-26 00:00:00	1984-05-26	1984-05-26 00:00:00	1984-05-26	581452		0	0	0		0	0	0	282091	0	21	40213251		
56269	4670	920334	1990-05-15	1990-05-15 00:00:00	1990-05-22	1990-05-22 00:00:00	1990-05-22	38000177		0	0	7		0	0	0	311195	0	311995	920334		
35601	2935	19128065	1993-03-19	1993-03-19 00:00:00	1994-03-14	1994-03-14 00:00:00	1994-03-14	38000177		0	0	360		0	0	0	195696	0	749882	19128065		
62567	5203	1127433	1980-03-25	1980-03-25 00:00:00	1980-04-22	1980-04-22 00:00:00	1980-04-22	38000177		0	0	28		0	0	0	346135	0	313782	1127433		
3944	328	1118084	2014-04-13	2014-04-13 00:00:00	2014-04-13	2014-04-13 00:00:00	\N	38000177		0	0	0		0	0	0	21666	0	00025152531	44923712		
42080	3488	19006318	1955-05-23	1955-05-23 00:00:00	1955-06-06	1955-06-06 00:00:00	1955-06-06	38000177		0	0	14		0	0	0	231346	0	105078	19006318		
33846	2801	19059056	1925-02-01	1925-02-01 00:00:00	1925-03-08	1925-03-08 00:00:00	1925-03-08	38000177		0	0	35		0	0	0	185602	0	243670	19059056		
15142	327	40213160	1971-10-11	1971-10-11 00:00:00	1971-10-11	1971-10-11 00:00:00	1971-10-11	581452		0	0	0		0	0	0	21608	0	10	40213160		
14570	1222	19059056	1958-10-29	1958-10-29 00:00:00	1958-11-12	1958-11-12 00:00:00	1958-11-12	38000177		0	0	14		0	0	0	80437	0	243670	19059056		
1558	123	1310034	2013-07-10	2013-07-10 00:00:00	2013-07-10	2013-07-10 00:00:00	2013-07-10	38000177		0	0	0		0	0	0	8146	0	834357	1310034		
1609	126	1127433	1978-11-07	1978-11-07 00:00:00	1978-11-14	1978-11-14 00:00:00	1978-11-14	38000177		0	0	7		0	0	0	8460	0	313782	1127433		
40209	3330	1713671	2005-03-30	2005-03-30 00:00:00	2005-04-06	2005-04-06 00:00:00	2005-04-06	38000177		0	0	7		0	0	0	220977	0	562251	1713671		
8098	675	1127078	1959-10-15	1959-10-15 00:00:00	1959-10-29	1959-10-29 00:00:00	1959-10-29	38000177		0	0	14		0	0	0	44596	0	282464	1127078		
40321	3342	19078461	1979-07-01	1979-07-01 00:00:00	1979-07-31	1979-07-31 00:00:00	1979-07-31	38000177		0	0	30		0	0	0	221567	0	310965	19078461		
44606	3694	40165015	1995-02-13	1995-02-13 00:00:00	1995-02-13	1995-02-13 00:00:00	\N	38000177		0	0	0		0	0	0	245565	0	861467	40165015		
35812	2949	40165015	1974-10-24	1974-10-24 00:00:00	1974-10-24	1974-10-24 00:00:00	\N	38000177		0	0	0		0	0	0	196837	0	861467	40165015		
49173	4080	19128065	1982-05-13	1982-05-13 00:00:00	1983-05-08	1983-05-08 00:00:00	1983-05-08	38000177		0	0	360		0	0	0	271197	0	749882	19128065		
46379	3841	1127433	1982-09-27	1982-09-27 00:00:00	1982-10-11	1982-10-11 00:00:00	1982-10-11	38000177		0	0	14		0	0	0	255022	0	313782	1127433		
54220	4505	1127433	1945-05-07	1945-05-07 00:00:00	1945-05-21	1945-05-21 00:00:00	1945-05-21	38000177		0	0	14		0	0	0	300046	0	313782	1127433		
33390	2767	1127433	1984-03-28	1984-03-28 00:00:00	1984-04-04	1984-04-04 00:00:00	1984-04-04	38000177		0	0	7		0	0	0	183071	0	313782	1127433		
14792	1237	19059056	1950-02-20	1950-02-20 00:00:00	1950-04-21	1950-04-21 00:00:00	1950-04-21	38000177		0	0	60		0	0	0	81518	0	243670	19059056		
17594	1454	1127433	1999-11-19	1999-11-19 00:00:00	1999-11-26	1999-11-26 00:00:00	1999-11-26	38000177		0	0	7		0	0	0	97027	0	313782	1127433		
28111	2325	19078461	1996-05-15	1996-05-15 00:00:00	1996-06-05	1996-06-05 00:00:00	1996-06-05	38000177		0	0	21		0	0	0	154600	0	310965	19078461		
57098	4738	920334	1937-11-18	1937-11-18 00:00:00	1937-11-25	1937-11-25 00:00:00	1937-11-25	38000177		0	0	7		0	0	0	315622	0	311995	920334		
16099	1335	19073183	1984-02-06	1984-02-06 00:00:00	1984-02-20	1984-02-20 00:00:00	1984-02-20	38000177		0	0	14		0	0	0	88566	0	308182	19073183		
1323	30	40213227	2011-10-22	2011-10-22 00:00:00	2011-10-22	2011-10-22 00:00:00	2011-10-22	581452		0	0	0		0	0	0	2093	0	113	40213227		
21630	1778	1127433	1993-07-08	1993-07-08 00:00:00	1993-09-06	1993-09-06 00:00:00	1993-09-06	38000177		0	0	60		0	0	0	118931	0	313782	1127433		
21674	1780	19133873	1978-05-06	1978-05-06 00:00:00	1978-05-15	1978-05-15 00:00:00	1978-05-15	38000177		0	0	9		0	0	0	119112	0	834061	19133873		
22411	486	40213160	1965-10-14	1965-10-14 00:00:00	1965-10-14	1965-10-14 00:00:00	1965-10-14	581452		0	0	0		0	0	0	32515	0	10	40213160		
37287	3081	1127433	1969-09-20	1969-09-20 00:00:00	1969-09-27	1969-09-27 00:00:00	1969-09-27	38000177		0	0	7		0	0	0	205157	0	313782	1127433		
47721	3957	19074841	1980-07-12	1980-07-12 00:00:00	1980-07-26	1980-07-26 00:00:00	1980-07-26	38000177		0	0	14		0	0	0	263122	0	309043	19074841		
94857	2080	40213314	1980-12-19	1980-12-19 00:00:00	1980-12-19	1980-12-19 00:00:00	1980-12-19	581452		0	0	0		0	0	0	138567	0	49	40213314		
23497	1934	19006318	1964-07-02	1964-07-02 00:00:00	1964-07-16	1964-07-16 00:00:00	1964-07-16	38000177		0	0	14		0	0	0	128638	0	105078	19006318		
16350	1355	1127078	1965-07-29	1965-07-29 00:00:00	1965-09-02	1965-09-02 00:00:00	1965-09-02	38000177		0	0	35		0	0	0	89792	0	282464	1127078		
912	74	19128065	1986-01-01	1986-01-01 00:00:00	1986-12-27	1986-12-27 00:00:00	1986-12-27	38000177		0	0	360		0	0	0	4991	0	749882	19128065		
41097	3409	19133873	1955-11-17	1955-11-17 00:00:00	1955-11-25	1955-11-25 00:00:00	1955-11-25	38000177		0	0	8		0	0	0	226063	0	834061	19133873		
41159	3413	1713671	2014-09-15	2014-09-15 00:00:00	2014-10-06	2014-10-06 00:00:00	2014-10-06	38000177		0	0	21		0	0	0	226423	0	562251	1713671		
58553	4860	1127433	1988-05-27	1988-05-27 00:00:00	1988-06-03	1988-06-03 00:00:00	1988-06-03	38000177		0	0	7		0	0	0	323289	0	313782	1127433		
87337	1916	40213227	2004-09-27	2004-09-27 00:00:00	2004-09-27	2004-09-27 00:00:00	2004-09-27	581452		0	0	0		0	0	0	127510	0	113	40213227		
20399	1674	1127433	1985-01-28	1985-01-28 00:00:00	1985-02-04	1985-02-04 00:00:00	1985-02-04	38000177		0	0	7		0	0	0	112342	0	313782	1127433		
16712	1384	19059056	1984-06-03	1984-06-03 00:00:00	1984-06-17	1984-06-17 00:00:00	1984-06-17	38000177		0	0	14		0	0	0	91749	0	243670	19059056		
8860	739	920300	1964-07-26	1964-07-26 00:00:00	1964-08-02	1964-08-02 00:00:00	1964-08-02	38000177		0	0	7		0	0	0	48978	0	311989	920300		
7	1	1127433	1971-01-04	1971-01-04 00:00:00	1971-01-18	1971-01-18 00:00:00	1971-01-18	38000177		0	0	14		0	0	0	23	0	313782	1127433		
7647	642	19077572	2016-01-17	2016-01-17 00:00:00	2016-01-17	2016-01-17 00:00:00	\N	38000177		0	0	0		0	0	0	42516	0	310436	19077572		
16794	1389	19077344	1962-03-03	1962-03-03 00:00:00	1962-03-03	1962-03-03 00:00:00	\N	38000177		0	0	0		0	0	0	92180	0	310325	19077344		
4110	339	19073183	1990-02-03	1990-02-03 00:00:00	1990-03-03	1990-03-03 00:00:00	1990-03-03	38000177		0	0	28		0	0	0	22608	0	308182	19073183		
14631	1227	1127433	2012-03-06	2012-03-06 00:00:00	2012-03-20	2012-03-20 00:00:00	2012-03-20	38000177		0	0	14		0	0	0	80805	0	313782	1127433		
14651	1227	1127433	1981-02-22	1981-02-22 00:00:00	1981-04-23	1981-04-23 00:00:00	1981-04-23	38000177		0	0	60		0	0	0	80822	0	313782	1127433		
36277	2989	1127433	1966-08-20	1966-08-20 00:00:00	1966-09-03	1966-09-03 00:00:00	1966-09-03	38000177		0	0	14		0	0	0	199543	0	313782	1127433		
36295	2991	19078461	2018-10-01	2018-10-01 00:00:00	2018-10-15	2018-10-15 00:00:00	2018-10-15	38000177		0	0	14		0	0	0	199630	0	310965	19078461		
31082	677	40213227	2004-02-06	2004-02-06 00:00:00	2004-02-06	2004-02-06 00:00:00	2004-02-06	581452		0	0	0		0	0	0	44817	0	113	40213227		
65799	1439	40213251	1984-07-07	1984-07-07 00:00:00	1984-07-07	1984-07-07 00:00:00	1984-07-07	581452		0	0	0		0	0	0	95889	0	21	40213251		
41894	3469	19073188	1983-02-26	1983-02-26 00:00:00	1983-03-26	1983-03-26 00:00:00	1983-03-26	38000177		0	0	28		0	0	0	230250	0	308192	19073188		
41752	3456	1118084	1982-07-13	1982-07-13 00:00:00	1982-07-13	1982-07-13 00:00:00	\N	38000177		0	0	0		0	0	0	229288	0	00025152531	44923712		
46908	1024	40213227	1992-07-05	1992-07-05 00:00:00	1992-07-05	1992-07-05 00:00:00	1992-07-05	581452		0	0	0		0	0	0	67459	0	113	40213227		
31960	2649	1118084	1993-01-15	1993-01-15 00:00:00	1993-01-15	1993-01-15 00:00:00	\N	38000177		0	0	0		0	0	0	175263	0	00025152531	44923712		
30361	2518	19133905	2004-08-06	2004-08-06 00:00:00	2004-08-19	2004-08-19 00:00:00	2004-08-19	38000177		0	0	13		0	0	0	166520	0	834102	19133905		
51413	4274	1713671	1967-08-02	1967-08-02 00:00:00	1967-08-16	1967-08-16 00:00:00	1967-08-16	38000177		0	0	14		0	0	0	283553	0	562251	1713671		
42787	3545	19129655	1973-01-21	1973-01-21 00:00:00	1973-02-04	1973-02-04 00:00:00	1973-02-04	38000177		0	0	14		0	0	0	235498	0	789980	19129655		
60333	5018	920300	1980-11-30	1980-11-30 00:00:00	1980-12-07	1980-12-07 00:00:00	1980-12-07	38000177		0	0	7		0	0	0	333530	0	311989	920300		
42662	3536	19078461	2006-08-07	2006-08-07 00:00:00	2006-08-28	2006-08-28 00:00:00	2006-08-28	38000177		0	0	21		0	0	0	234808	0	310965	19078461		
25925	2133	19078461	1996-11-21	1996-11-21 00:00:00	1996-12-28	1996-12-28 00:00:00	1996-12-28	38000177		0	0	37		0	0	0	141933	0	310965	19078461		
2028	160	19128065	1975-07-24	1975-07-24 00:00:00	1976-07-18	1976-07-18 00:00:00	1976-07-18	38000177		0	0	360		0	0	0	11006	0	749882	19128065		
51927	4317	1127433	2012-03-19	2012-03-19 00:00:00	2012-04-02	2012-04-02 00:00:00	2012-04-02	38000177		0	0	14		0	0	0	286502	0	313782	1127433		
193359	4247	40213160	1983-11-26	1983-11-26 00:00:00	1983-11-26	1983-11-26 00:00:00	1983-11-26	581452		0	0	0		0	0	0	282083	0	10	40213160		
56270	4670	1127433	1982-03-24	1982-03-24 00:00:00	1982-03-31	1982-03-31 00:00:00	1982-03-31	38000177		0	0	7		0	0	0	311229	0	313782	1127433		
35602	2935	1127078	1984-12-21	1984-12-21 00:00:00	1985-01-20	1985-01-20 00:00:00	1985-01-20	38000177		0	0	30		0	0	0	195678	0	282464	1127078		
62568	5203	19126352	1988-08-31	1988-08-31 00:00:00	1999-02-17	1999-02-17 00:00:00	1999-02-17	38000177		0	0	3822		0	0	0	346106	0	705129	19126352		
3945	328	1127078	1981-12-12	1981-12-12 00:00:00	1981-12-26	1981-12-26 00:00:00	1981-12-26	38000177		0	0	14		0	0	0	21644	0	282464	1127078		
42081	3488	19133905	1993-03-19	1993-03-19 00:00:00	1993-03-30	1993-03-30 00:00:00	1993-03-30	38000177		0	0	11		0	0	0	231383	0	834102	19133905		
33847	2801	19133873	1926-04-30	1926-04-30 00:00:00	1926-05-08	1926-05-08 00:00:00	1926-05-08	38000177		0	0	8		0	0	0	185639	0	834061	19133873		
15145	327	40213160	1976-01-12	1976-01-12 00:00:00	1976-01-12	1976-01-12 00:00:00	1976-01-12	581452		0	0	0		0	0	0	21628	0	10	40213160		
14571	1222	19006318	1958-10-29	1958-10-29 00:00:00	1958-11-12	1958-11-12 00:00:00	1958-11-12	38000177		0	0	14		0	0	0	80437	0	105078	19006318		
1559	123	19133905	1998-11-18	1998-11-18 00:00:00	1998-11-25	1998-11-25 00:00:00	1998-11-25	38000177		0	0	7		0	0	0	8109	0	834102	19133905		
1610	126	19059056	1950-11-23	1950-11-23 00:00:00	1950-12-07	1950-12-07 00:00:00	1950-12-07	38000177		0	0	14		0	0	0	8420	0	243670	19059056		
40210	3330	19128022	1993-09-02	1993-09-02 00:00:00	1994-08-28	1994-08-28 00:00:00	1994-08-28	38000177		0	0	360		0	0	0	220995	0	749785	19128022		
8099	675	19059056	1972-04-23	1972-04-23 00:00:00	1972-05-14	1972-05-14 00:00:00	1972-05-14	38000177		0	0	21		0	0	0	44600	0	243670	19059056		
40322	3342	19059056	1926-10-18	1926-10-18 00:00:00	1926-11-22	1926-11-22 00:00:00	1926-11-22	38000177		0	0	35		0	0	0	221630	0	243670	19059056		
44607	3694	1115171	1995-02-13	1995-02-13 00:00:00	1995-04-14	1995-04-14 00:00:00	1995-04-14	38000177		0	0	60		0	0	0	245565	0	849574	1115171		
35813	2949	1127433	1974-10-17	1974-10-17 00:00:00	1974-11-23	1974-11-23 00:00:00	1974-11-23	38000177		0	0	37		0	0	0	196879	0	313782	1127433		
49175	4080	1118084	2002-10-10	2002-10-10 00:00:00	2002-10-10	2002-10-10 00:00:00	\N	38000177		0	0	0		0	0	0	271191	0	00025152531	44923712		
46380	3841	1124300	2017-03-01	2017-03-01 00:00:00	2017-03-01	2017-03-01 00:00:00	\N	38000177		0	0	0		0	0	0	255017	0	00781178901	45011828		
54221	4505	1127433	1985-04-26	1985-04-26 00:00:00	1985-05-10	1985-05-10 00:00:00	1985-05-10	38000177		0	0	14		0	0	0	300079	0	313782	1127433		
33391	2767	40173590	1996-06-05	1996-06-05 00:00:00	1996-06-05	1996-06-05 00:00:00	\N	38000177		0	0	0		0	0	0	183042	0	904419	40173590		
14793	1237	40229134	1979-07-15	1979-07-15 00:00:00	1979-07-29	1979-07-29 00:00:00	1979-07-29	38000177		0	0	14		0	0	0	81523	0	1043400	40229134		
17595	1454	1713671	1992-05-18	1992-05-18 00:00:00	1992-06-08	1992-06-08 00:00:00	1992-06-08	38000177		0	0	21		0	0	0	96988	0	562251	1713671		
28114	2326	19078461	2000-07-21	2000-07-21 00:00:00	2000-08-04	2000-08-04 00:00:00	2000-08-04	38000177		0	0	14		0	0	0	154722	0	310965	19078461		
57099	4738	19059056	1924-03-02	1924-03-02 00:00:00	1924-03-30	1924-03-30 00:00:00	1924-03-30	38000177		0	0	28		0	0	0	315652	0	243670	19059056		
16100	1335	1127078	1984-02-06	1984-02-06 00:00:00	1984-02-20	1984-02-20 00:00:00	1984-02-20	38000177		0	0	14		0	0	0	88566	0	282464	1127078		
1324	30	40213296	2011-10-22	2011-10-22 00:00:00	2011-10-22	2011-10-22 00:00:00	2011-10-22	581452		0	0	0		0	0	0	2093	0	52	40213296		
21631	1778	40162522	1993-07-08	1993-07-08 00:00:00	1993-07-08	1993-07-08 00:00:00	\N	38000177		0	0	0		0	0	0	118931	0	857005	40162522		
21675	1780	1127433	1989-02-09	1989-02-09 00:00:00	1989-04-10	1989-04-10 00:00:00	1989-04-10	38000177		0	0	60		0	0	0	119144	0	313782	1127433		
22419	486	40213296	2003-12-11	2003-12-11 00:00:00	2003-12-11	2003-12-11 00:00:00	2003-12-11	581452		0	0	0		0	0	0	32492	0	52	40213296		
37288	3081	40229134	2005-10-30	2005-10-30 00:00:00	2005-11-06	2005-11-06 00:00:00	2005-11-06	38000177		0	0	7		0	0	0	205122	0	1043400	40229134		
47722	3957	1127433	1980-07-12	1980-07-12 00:00:00	1980-07-26	1980-07-26 00:00:00	1980-07-26	38000177		0	0	14		0	0	0	263122	0	313782	1127433		
94859	2080	40213306	2000-08-04	2000-08-04 00:00:00	2000-08-04	2000-08-04 00:00:00	2000-08-04	581452		0	0	0		0	0	0	138562	0	43	40213306		
23498	1934	19059056	1964-07-02	1964-07-02 00:00:00	1964-07-16	1964-07-16 00:00:00	1964-07-16	38000177		0	0	14		0	0	0	128638	0	243670	19059056		
16351	1355	1127433	1965-11-28	1965-11-28 00:00:00	1965-12-12	1965-12-12 00:00:00	1965-12-12	38000177		0	0	14		0	0	0	89851	0	313782	1127433		
913	74	19133905	1995-09-11	1995-09-11 00:00:00	1995-09-19	1995-09-19 00:00:00	1995-09-19	38000177		0	0	8		0	0	0	4998	0	834102	19133905		
41099	3409	1127433	2002-11-11	2002-11-11 00:00:00	2002-12-09	2002-12-09 00:00:00	2002-12-09	38000177		0	0	28		0	0	0	226122	0	313782	1127433		
41160	3413	19133873	1983-02-09	1983-02-09 00:00:00	1983-02-21	1983-02-21 00:00:00	1983-02-21	38000177		0	0	12		0	0	0	226379	0	834061	19133873		
58554	4860	19128065	1997-08-30	1997-08-30 00:00:00	1998-08-25	1998-08-25 00:00:00	1998-08-25	38000177		0	0	360		0	0	0	323332	0	749882	19128065		
87339	1916	40213227	1993-10-11	1993-10-11 00:00:00	1993-10-11	1993-10-11 00:00:00	1993-10-11	581452		0	0	0		0	0	0	127508	0	113	40213227		
20404	1676	1118084	2014-10-21	2014-10-21 00:00:00	2014-10-21	2014-10-21 00:00:00	\N	38000177		0	0	0		0	0	0	112468	0	00025152531	44923712		
16713	1384	19073183	1984-06-03	1984-06-03 00:00:00	1984-06-17	1984-06-17 00:00:00	1984-06-17	38000177		0	0	14		0	0	0	91749	0	308182	19073183		
8861	739	40236824	1964-07-26	1964-07-26 00:00:00	1964-08-02	1964-08-02 00:00:00	1964-08-02	38000177		0	0	7		0	0	0	48978	0	1094107	40236824		
8	1	1127433	1982-09-11	1982-09-11 00:00:00	1982-10-02	1982-10-02 00:00:00	1982-10-02	38000177		0	0	21		0	0	0	83	0	313782	1127433		
7648	642	19133905	1972-01-28	1972-01-28 00:00:00	1972-02-07	1972-02-07 00:00:00	1972-02-07	38000177		0	0	10		0	0	0	42537	0	834102	19133905		
16795	1389	1127433	2007-08-29	2007-08-29 00:00:00	2007-09-19	2007-09-19 00:00:00	2007-09-19	38000177		0	0	21		0	0	0	92206	0	313782	1127433		
4111	340	1127433	1996-02-26	1996-02-26 00:00:00	1996-03-11	1996-03-11 00:00:00	1996-03-11	38000177		0	0	14		0	0	0	22712	0	313782	1127433		
14632	1227	1713671	2019-04-27	2019-04-27 00:00:00	2019-05-04	2019-05-04 00:00:00	2019-05-04	38000177		0	0	7		0	0	0	80736	0	562251	1713671		
14652	1227	1115171	2017-09-11	2017-09-11 00:00:00	2017-10-11	2017-10-11 00:00:00	2017-10-11	38000177		0	0	30		0	0	0	80824	0	849574	1115171		
36278	2989	1127433	1993-11-10	1993-11-10 00:00:00	1993-11-24	1993-11-24 00:00:00	1993-11-24	38000177		0	0	14		0	0	0	199576	0	313782	1127433		
36296	2991	1127433	1990-12-14	1990-12-14 00:00:00	1990-12-28	1990-12-28 00:00:00	1990-12-28	38000177		0	0	14		0	0	0	199644	0	313782	1127433		
31083	677	40213296	2004-02-06	2004-02-06 00:00:00	2004-02-06	2004-02-06 00:00:00	2004-02-06	581452		0	0	0		0	0	0	44817	0	52	40213296		
76722	1676	40213314	1980-05-23	1980-05-23 00:00:00	1980-05-23	1980-05-23 00:00:00	1980-05-23	581452		0	0	0		0	0	0	112441	0	49	40213314		
41895	3469	19059056	1956-11-09	1956-11-09 00:00:00	1956-11-23	1956-11-23 00:00:00	1956-11-23	38000177		0	0	14		0	0	0	230276	0	243670	19059056		
41753	3456	19006318	1945-10-07	1945-10-07 00:00:00	1945-10-21	1945-10-21 00:00:00	1945-10-21	38000177		0	0	14		0	0	0	229311	0	105078	19006318		
46927	1024	40213198	2010-05-30	2010-05-30 00:00:00	2010-05-30	2010-05-30 00:00:00	2010-05-30	581452		0	0	0		0	0	0	67429	0	133	40213198		
31972	2651	1115171	2006-07-11	2006-07-11 00:00:00	2006-07-25	2006-07-25 00:00:00	2006-07-25	38000177		0	0	14		0	0	0	175423	0	849574	1115171		
30362	2518	1127433	1973-06-07	1973-06-07 00:00:00	1973-06-28	1973-06-28 00:00:00	1973-06-28	38000177		0	0	21		0	0	0	166539	0	313782	1127433		
51414	4274	40229134	1947-05-09	1947-05-09 00:00:00	1947-05-23	1947-05-23 00:00:00	1947-05-23	38000177		0	0	14		0	0	0	283664	0	1043400	40229134		
42788	3545	1127433	1997-02-11	1997-02-11 00:00:00	1997-02-18	1997-02-18 00:00:00	1997-02-18	38000177		0	0	7		0	0	0	235497	0	313782	1127433		
60334	5018	1713671	1992-09-25	1992-09-25 00:00:00	1992-10-16	1992-10-16 00:00:00	1992-10-16	38000177		0	0	21		0	0	0	333488	0	562251	1713671		
53121	4413	1115171	2006-10-29	2006-10-29 00:00:00	2006-12-03	2006-12-03 00:00:00	2006-12-03	38000177		0	0	35		0	0	0	293420	0	849574	1115171		
25926	2133	1127433	2009-10-16	2009-10-16 00:00:00	2009-10-23	2009-10-23 00:00:00	2009-10-23	38000177		0	0	7		0	0	0	141936	0	313782	1127433		
2029	160	920300	1998-01-10	1998-01-10 00:00:00	1998-01-17	1998-01-17 00:00:00	1998-01-17	38000177		0	0	7		0	0	0	10950	0	311989	920300		
51928	4317	1713671	1949-12-01	1949-12-01 00:00:00	1949-12-08	1949-12-08 00:00:00	1949-12-08	38000177		0	0	7		0	0	0	286496	0	562251	1713671		
193368	4247	40213227	2015-01-10	2015-01-10 00:00:00	2015-01-10	2015-01-10 00:00:00	2015-01-10	581452		0	0	0		0	0	0	282008	0	113	40213227		
56271	4670	1127433	1978-09-12	1978-09-12 00:00:00	1978-09-26	1978-09-26 00:00:00	1978-09-26	38000177		0	0	14		0	0	0	311228	0	313782	1127433		
35603	2935	1127078	1980-10-02	1980-10-02 00:00:00	1980-10-16	1980-10-16 00:00:00	1980-10-16	38000177		0	0	14		0	0	0	195729	0	282464	1127078		
62569	5203	19133905	1967-01-14	1967-01-14 00:00:00	1967-01-24	1967-01-24 00:00:00	1967-01-24	38000177		0	0	10		0	0	0	346122	0	834102	19133905		
3946	328	19074843	1981-12-12	1981-12-12 00:00:00	1981-12-26	1981-12-26 00:00:00	1981-12-26	38000177		0	0	14		0	0	0	21644	0	309045	19074843		
42082	3489	19129655	1977-12-22	1977-12-22 00:00:00	1978-01-05	1978-01-05 00:00:00	1978-01-05	38000177		0	0	14		0	0	0	231448	0	789980	19129655		
33848	2801	40229134	1930-08-06	1930-08-06 00:00:00	1930-08-13	1930-08-13 00:00:00	1930-08-13	38000177		0	0	7		0	0	0	185591	0	1043400	40229134		
15147	327	40213160	1971-07-12	1971-07-12 00:00:00	1971-07-12	1971-07-12 00:00:00	1971-07-12	581452		0	0	0		0	0	0	21624	0	10	40213160		
14572	1222	1713671	1986-02-15	1986-02-15 00:00:00	1986-03-08	1986-03-08 00:00:00	1986-03-08	38000177		0	0	21		0	0	0	80428	0	562251	1713671		
1560	123	1127078	1956-01-11	1956-01-11 00:00:00	1956-01-25	1956-01-25 00:00:00	1956-01-25	38000177		0	0	14		0	0	0	8125	0	282464	1127078		
1611	126	19006318	1950-11-23	1950-11-23 00:00:00	1950-12-07	1950-12-07 00:00:00	1950-12-07	38000177		0	0	14		0	0	0	8420	0	105078	19006318		
40211	3330	19078461	2013-03-16	2013-03-16 00:00:00	2013-04-20	2013-04-20 00:00:00	2013-04-20	38000177		0	0	35		0	0	0	221008	0	310965	19078461		
8100	675	19059056	1958-08-21	1958-08-21 00:00:00	1958-10-20	1958-10-20 00:00:00	1958-10-20	38000177		0	0	60		0	0	0	44594	0	243670	19059056		
40323	3342	40229134	1938-11-26	1938-11-26 00:00:00	1938-12-10	1938-12-10 00:00:00	1938-12-10	38000177		0	0	14		0	0	0	221561	0	1043400	40229134		
44608	3694	19059056	1958-11-30	1958-11-30 00:00:00	1958-12-21	1958-12-21 00:00:00	1958-12-21	38000177		0	0	21		0	0	0	245557	0	243670	19059056		
35814	2949	19006318	1950-10-23	1950-10-23 00:00:00	1950-11-06	1950-11-06 00:00:00	1950-11-06	38000177		0	0	14		0	0	0	196870	0	105078	19006318		
49176	4080	19128065	1979-05-29	1979-05-29 00:00:00	1980-05-23	1980-05-23 00:00:00	1980-05-23	38000177		0	0	360		0	0	0	271170	0	749882	19128065		
46381	3841	19128022	1990-08-30	1990-08-30 00:00:00	1991-08-25	1991-08-25 00:00:00	1991-08-25	38000177		0	0	360		0	0	0	254988	0	749785	19128022		
54222	4505	1127433	1993-03-29	1993-03-29 00:00:00	1993-05-03	1993-05-03 00:00:00	1993-05-03	38000177		0	0	35		0	0	0	300080	0	313782	1127433		
33392	2767	19059056	1975-01-12	1975-01-12 00:00:00	1975-02-18	1975-02-18 00:00:00	1975-02-18	38000177		0	0	37		0	0	0	183066	0	243670	19059056		
14794	1237	1118084	1983-10-06	1983-10-06 00:00:00	1983-10-06	1983-10-06 00:00:00	\N	38000177		0	0	0		0	0	0	81508	0	00025152531	44923712		
17596	1454	40229134	1979-01-02	1979-01-02 00:00:00	1979-01-09	1979-01-09 00:00:00	1979-01-09	38000177		0	0	7		0	0	0	96976	0	1043400	40229134		
57045	4735	19133873	1974-08-30	1974-08-30 00:00:00	1974-09-09	1974-09-09 00:00:00	1974-09-09	38000177		0	0	10		0	0	0	315455	0	834061	19133873		
57100	4738	19059056	1911-03-11	1911-03-11 00:00:00	1911-03-25	1911-03-25 00:00:00	1911-03-25	38000177		0	0	14		0	0	0	315665	0	243670	19059056		
16101	1335	19128022	1993-11-11	1993-11-11 00:00:00	1994-11-06	1994-11-06 00:00:00	1994-11-06	38000177		0	0	360		0	0	0	88595	0	749785	19128022		
1338	30	40213160	1975-07-26	1975-07-26 00:00:00	1975-07-26	1975-07-26 00:00:00	1975-07-26	581452		0	0	0		0	0	0	2052	0	10	40213160		
21632	1778	40229134	2017-10-01	2017-10-01 00:00:00	2017-10-15	2017-10-15 00:00:00	2017-10-15	38000177		0	0	14		0	0	0	118958	0	1043400	40229134		
21676	1781	1713671	1983-02-13	1983-02-13 00:00:00	1983-02-20	1983-02-20 00:00:00	1983-02-20	38000177		0	0	7		0	0	0	119205	0	562251	1713671		
22426	486	40213227	2001-12-06	2001-12-06 00:00:00	2001-12-06	2001-12-06 00:00:00	2001-12-06	581452		0	0	0		0	0	0	32503	0	113	40213227		
37289	3082	46233988	1967-12-22	1967-12-22 00:00:00	1968-01-05	1968-01-05 00:00:00	1968-01-05	38000177		0	0	14		0	0	0	205239	0	1652673	46233988		
47723	3957	1127433	2001-12-10	2001-12-10 00:00:00	2001-12-24	2001-12-24 00:00:00	2001-12-24	38000177		0	0	14		0	0	0	263064	0	313782	1127433		
120380	2646	40213314	1977-06-17	1977-06-17 00:00:00	1977-06-17	1977-06-17 00:00:00	1977-06-17	581452		0	0	0		0	0	0	175047	0	49	40213314		
23499	1934	19129655	1963-04-29	1963-04-29 00:00:00	1963-05-13	1963-05-13 00:00:00	1963-05-13	38000177		0	0	14		0	0	0	128636	0	789980	19129655		
16352	1355	19078461	2000-01-02	2000-01-02 00:00:00	2000-01-23	2000-01-23 00:00:00	2000-01-23	38000177		0	0	21		0	0	0	89793	0	310965	19078461		
914	74	19128065	1988-12-16	1988-12-16 00:00:00	1989-12-11	1989-12-11 00:00:00	1989-12-11	38000177		0	0	360		0	0	0	5018	0	749882	19128065		
41100	3409	1127078	1960-08-18	1960-08-18 00:00:00	1960-09-01	1960-09-01 00:00:00	1960-09-01	38000177		0	0	14		0	0	0	226062	0	282464	1127078		
41161	3413	1127078	1975-08-08	1975-08-08 00:00:00	1975-09-07	1975-09-07 00:00:00	1975-09-07	38000177		0	0	30		0	0	0	226402	0	282464	1127078		
58555	4860	19078461	1999-07-11	1999-07-11 00:00:00	1999-08-01	1999-08-01 00:00:00	1999-08-01	38000177		0	0	21		0	0	0	323341	0	310965	19078461		
87340	1916	40213306	1993-10-11	1993-10-11 00:00:00	1993-10-11	1993-10-11 00:00:00	1993-10-11	581452		0	0	0		0	0	0	127508	0	43	40213306		
20405	1676	1127433	1983-01-28	1983-01-28 00:00:00	1983-02-11	1983-02-11 00:00:00	1983-02-11	38000177		0	0	14		0	0	0	112450	0	313782	1127433		
16714	1384	1713671	2000-01-19	2000-01-19 00:00:00	2000-02-02	2000-02-02 00:00:00	2000-02-02	38000177		0	0	14		0	0	0	91776	0	562251	1713671		
8862	741	1118084	2011-07-08	2011-07-08 00:00:00	2011-07-08	2011-07-08 00:00:00	\N	38000177		0	0	0		0	0	0	49098	0	00025152531	44923712		
9	1	19078461	1978-06-22	1978-06-22 00:00:00	1978-07-27	1978-07-27 00:00:00	1978-07-27	38000177		0	0	35		0	0	0	81	0	310965	19078461		
7649	642	19133905	2013-12-31	2013-12-31 00:00:00	2014-01-10	2014-01-10 00:00:00	2014-01-10	38000177		0	0	10		0	0	0	42541	0	834102	19133905		
16796	1389	40165015	2007-08-29	2007-08-29 00:00:00	2007-08-29	2007-08-29 00:00:00	\N	38000177		0	0	0		0	0	0	92206	0	861467	40165015		
4112	340	1118084	1995-06-24	1995-06-24 00:00:00	1995-06-24	1995-06-24 00:00:00	\N	38000177		0	0	0		0	0	0	22688	0	00025152531	44923712		
163	11	1713671	1970-07-28	1970-07-28 00:00:00	1970-08-04	1970-08-04 00:00:00	1970-08-04	38000177		0	0	7		0	0	0	944	0	562251	1713671		
14653	1227	19077572	2016-04-06	2016-04-06 00:00:00	2016-04-06	2016-04-06 00:00:00	\N	38000177		0	0	0		0	0	0	80766	0	310436	19077572		
36279	2989	1127078	1960-01-28	1960-01-28 00:00:00	1960-03-05	1960-03-05 00:00:00	1960-03-05	38000177		0	0	37		0	0	0	199586	0	282464	1127078		
36297	2991	1127433	1989-09-12	1989-09-12 00:00:00	1989-10-03	1989-10-03 00:00:00	1989-10-03	38000177		0	0	21		0	0	0	199629	0	313782	1127433		
31086	677	40213227	2012-06-08	2012-06-08 00:00:00	2012-06-08	2012-06-08 00:00:00	2012-06-08	581452		0	0	0		0	0	0	44819	0	113	40213227		
76723	1676	40213160	1980-05-23	1980-05-23 00:00:00	1980-05-23	1980-05-23 00:00:00	1980-05-23	581452		0	0	0		0	0	0	112441	0	10	40213160		
41896	3469	19006318	1956-11-09	1956-11-09 00:00:00	1956-11-23	1956-11-23 00:00:00	1956-11-23	38000177		0	0	14		0	0	0	230276	0	105078	19006318		
41754	3456	19059056	1945-10-07	1945-10-07 00:00:00	1945-10-21	1945-10-21 00:00:00	1945-10-21	38000177		0	0	14		0	0	0	229311	0	243670	19059056		
46931	1024	40213227	2003-04-20	2003-04-20 00:00:00	2003-04-20	2003-04-20 00:00:00	2003-04-20	581452		0	0	0		0	0	0	67417	0	113	40213227		
31973	2651	19078461	2000-11-18	2000-11-18 00:00:00	2000-12-09	2000-12-09 00:00:00	2000-12-09	38000177		0	0	21		0	0	0	175422	0	310965	19078461		
30364	2518	1118084	1988-05-29	1988-05-29 00:00:00	1988-05-29	1988-05-29 00:00:00	\N	38000177		0	0	0		0	0	0	166517	0	00025152531	44923712		
51415	4274	40236824	1958-03-16	1958-03-16 00:00:00	1958-03-23	1958-03-23 00:00:00	1958-03-23	38000177		0	0	7		0	0	0	283617	0	1094107	40236824		
42789	3545	1127433	1973-03-24	1973-03-24 00:00:00	1973-03-31	1973-03-31 00:00:00	1973-03-31	38000177		0	0	7		0	0	0	235495	0	313782	1127433		
60335	5018	1127433	1942-05-06	1942-05-06 00:00:00	1942-05-13	1942-05-13 00:00:00	1942-05-13	38000177		0	0	7		0	0	0	333531	0	313782	1127433		
53122	4413	1127433	1965-09-15	1965-09-15 00:00:00	1965-09-29	1965-09-29 00:00:00	1965-09-29	38000177		0	0	14		0	0	0	293426	0	313782	1127433		
25927	2133	1118084	2003-08-17	2003-08-17 00:00:00	2003-08-17	2003-08-17 00:00:00	\N	38000177		0	0	0		0	0	0	141934	0	00025152531	44923712		
2030	160	40236824	1998-01-10	1998-01-10 00:00:00	1998-01-17	1998-01-17 00:00:00	1998-01-17	38000177		0	0	7		0	0	0	10950	0	1094107	40236824		
51930	4319	19019979	1982-09-12	1982-09-12 00:00:00	1982-10-03	1982-10-03 00:00:00	1982-10-03	38000177		0	0	21		0	0	0	286581	0	198405	19019979		
159756	3516	40213201	2011-09-15	2011-09-15 00:00:00	2011-09-15	2011-09-15 00:00:00	2011-09-15	581452		0	0	0		0	0	0	233387	0	33	40213201		
56273	4670	1127433	2018-07-10	2018-07-10 00:00:00	2018-07-31	2018-07-31 00:00:00	2018-07-31	38000177		0	0	21		0	0	0	311159	0	313782	1127433		
35604	2935	19128065	1991-03-30	1991-03-30 00:00:00	1992-03-24	1992-03-24 00:00:00	1992-03-24	38000177		0	0	360		0	0	0	195694	0	749882	19128065		
62570	5203	1713671	1996-12-14	1996-12-14 00:00:00	1996-12-21	1996-12-21 00:00:00	1996-12-21	38000177		0	0	7		0	0	0	346082	0	562251	1713671		
3947	328	40236824	2012-01-15	2012-01-15 00:00:00	2012-01-22	2012-01-22 00:00:00	2012-01-22	38000177		0	0	7		0	0	0	21678	0	1094107	40236824		
42083	3489	1127078	1977-12-22	1977-12-22 00:00:00	1978-01-05	1978-01-05 00:00:00	1978-01-05	38000177		0	0	14		0	0	0	231448	0	282464	1127078		
33849	2801	19133873	1928-12-24	1928-12-24 00:00:00	1929-01-02	1929-01-02 00:00:00	1929-01-02	38000177		0	0	9		0	0	0	185569	0	834061	19133873		
15150	327	40213160	1971-05-10	1971-05-10 00:00:00	1971-05-10	1971-05-10 00:00:00	1971-05-10	581452		0	0	0		0	0	0	21607	0	10	40213160		
14573	1222	19059056	1960-05-21	1960-05-21 00:00:00	1960-06-11	1960-06-11 00:00:00	1960-06-11	38000177		0	0	21		0	0	0	80423	0	243670	19059056		
1561	123	19006318	1956-01-11	1956-01-11 00:00:00	1956-01-25	1956-01-25 00:00:00	1956-01-25	38000177		0	0	14		0	0	0	8125	0	105078	19006318		
1612	126	19059056	1950-04-06	1950-04-06 00:00:00	1950-04-20	1950-04-20 00:00:00	1950-04-20	38000177		0	0	14		0	0	0	8415	0	243670	19059056		
40212	3330	19128022	1997-08-12	1997-08-12 00:00:00	1998-08-07	1998-08-07 00:00:00	1998-08-07	38000177		0	0	360		0	0	0	220961	0	749785	19128022		
8101	675	1127433	2001-01-17	2001-01-17 00:00:00	2001-01-24	2001-01-24 00:00:00	2001-01-24	38000177		0	0	7		0	0	0	44606	0	313782	1127433		
40324	3342	1118084	1950-04-18	1950-04-18 00:00:00	1950-04-18	1950-04-18 00:00:00	\N	38000177		0	0	0		0	0	0	221685	0	00025152531	44923712		
44609	3694	19078461	1984-02-22	1984-02-22 00:00:00	1984-03-14	1984-03-14 00:00:00	1984-03-14	38000177		0	0	21		0	0	0	245562	0	310965	19078461		
35815	2949	19059056	1950-10-23	1950-10-23 00:00:00	1950-11-06	1950-11-06 00:00:00	1950-11-06	38000177		0	0	14		0	0	0	196870	0	243670	19059056		
49177	4080	1115171	1998-01-30	1998-01-30 00:00:00	1998-03-01	1998-03-01 00:00:00	1998-03-01	38000177		0	0	30		0	0	0	271175	0	849574	1115171		
46382	3841	1127433	2009-10-30	2009-10-30 00:00:00	2009-12-04	2009-12-04 00:00:00	2009-12-04	38000177		0	0	35		0	0	0	255055	0	313782	1127433		
54223	4505	19075001	1993-03-29	1993-03-29 00:00:00	1993-05-03	1993-05-03 00:00:00	1993-05-03	38000177		0	0	35		0	0	0	300080	0	309097	19075001		
33393	2767	1118084	1970-10-17	1970-10-17 00:00:00	1970-10-17	1970-10-17 00:00:00	\N	38000177		0	0	0		0	0	0	183109	0	00025152531	44923712		
14795	1237	19078461	1981-09-05	1981-09-05 00:00:00	1981-09-19	1981-09-19 00:00:00	1981-09-19	38000177		0	0	14		0	0	0	81520	0	310965	19078461		
36378	3000	1127433	2003-03-24	2003-03-24 00:00:00	2003-03-31	2003-03-31 00:00:00	2003-03-31	38000177		0	0	7		0	0	0	200197	0	313782	1127433		
57046	4735	46275916	1983-06-16	1983-06-16 00:00:00	1983-06-16	1983-06-16 00:00:00	1983-06-16	38000177		0	0	0		0	0	0	315452	0	1660014	46275916		
57101	4738	19133873	1915-12-17	1915-12-17 00:00:00	1915-12-27	1915-12-27 00:00:00	1915-12-27	38000177		0	0	10		0	0	0	315662	0	834061	19133873		
16102	1335	1713671	2003-10-14	2003-10-14 00:00:00	2003-10-21	2003-10-21 00:00:00	2003-10-21	38000177		0	0	7		0	0	0	88557	0	562251	1713671		
1340	30	40213306	1993-09-25	1993-09-25 00:00:00	1993-09-25	1993-09-25 00:00:00	1993-09-25	581452		0	0	0		0	0	0	2084	0	43	40213306		
21633	1778	1118084	2017-09-25	2017-09-25 00:00:00	2017-09-25	2017-09-25 00:00:00	\N	38000177		0	0	0		0	0	0	118936	0	00025152531	44923712		
21677	1781	19059056	1942-02-05	1942-02-05 00:00:00	1942-02-19	1942-02-19 00:00:00	1942-02-19	38000177		0	0	14		0	0	0	119262	0	243670	19059056		
22427	486	40213296	2001-12-06	2001-12-06 00:00:00	2001-12-06	2001-12-06 00:00:00	2001-12-06	581452		0	0	0		0	0	0	32503	0	52	40213296		
37290	3082	1127078	1967-12-22	1967-12-22 00:00:00	1968-01-05	1968-01-05 00:00:00	1968-01-05	38000177		0	0	14		0	0	0	205239	0	282464	1127078		
47724	3957	19078461	1988-04-01	1988-04-01 00:00:00	1988-04-22	1988-04-22 00:00:00	1988-04-22	38000177		0	0	21		0	0	0	263063	0	310965	19078461		
120382	2646	40213314	1978-06-16	1978-06-16 00:00:00	1978-06-16	1978-06-16 00:00:00	1978-06-16	581452		0	0	0		0	0	0	175097	0	49	40213314		
23500	1934	1127078	1963-04-29	1963-04-29 00:00:00	1963-05-13	1963-05-13 00:00:00	1963-05-13	38000177		0	0	14		0	0	0	128636	0	282464	1127078		
16353	1355	1127433	1995-11-07	1995-11-07 00:00:00	1995-11-14	1995-11-14 00:00:00	1995-11-14	38000177		0	0	7		0	0	0	89856	0	313782	1127433		
915	74	1127433	1973-09-28	1973-09-28 00:00:00	1973-10-12	1973-10-12 00:00:00	1973-10-12	38000177		0	0	14		0	0	0	5003	0	313782	1127433		
41101	3409	19006318	1960-08-18	1960-08-18 00:00:00	1960-09-01	1960-09-01 00:00:00	1960-09-01	38000177		0	0	14		0	0	0	226062	0	105078	19006318		
41162	3413	1127433	2017-02-28	2017-02-28 00:00:00	2017-03-14	2017-03-14 00:00:00	2017-03-14	38000177		0	0	14		0	0	0	226404	0	313782	1127433		
58556	4860	1713671	1986-08-26	1986-08-26 00:00:00	1986-09-16	1986-09-16 00:00:00	1986-09-16	38000177		0	0	21		0	0	0	323295	0	562251	1713671		
87343	1916	40213160	1972-03-13	1972-03-13 00:00:00	1972-03-13	1972-03-13 00:00:00	1972-03-13	581452		0	0	0		0	0	0	127457	0	10	40213160		
20406	1676	1713671	1985-04-21	1985-04-21 00:00:00	1985-05-05	1985-05-05 00:00:00	1985-05-05	38000177		0	0	14		0	0	0	112470	0	562251	1713671		
16715	1385	19128065	1974-05-10	1974-05-10 00:00:00	1975-05-05	1975-05-05 00:00:00	1975-05-05	38000177		0	0	360		0	0	0	91844	0	749882	19128065		
8863	741	1127433	1992-11-25	1992-11-25 00:00:00	1992-12-02	1992-12-02 00:00:00	1992-12-02	38000177		0	0	7		0	0	0	49067	0	313782	1127433		
10	1	40231925	1978-06-22	1978-06-22 00:00:00	1978-06-22	1978-06-22 00:00:00	\N	38000177		0	0	0		0	0	0	81	0	1049221	40231925		
7650	642	19078461	2006-01-10	2006-01-10 00:00:00	2006-02-14	2006-02-14 00:00:00	2006-02-14	38000177		0	0	35		0	0	0	42573	0	310965	19078461		
16797	1389	19075001	2007-08-29	2007-08-29 00:00:00	2007-09-19	2007-09-19 00:00:00	2007-09-19	38000177		0	0	21		0	0	0	92206	0	309097	19075001		
4113	340	19059056	1963-11-14	1963-11-14 00:00:00	1963-12-19	1963-12-19 00:00:00	1963-12-19	38000177		0	0	35		0	0	0	22668	0	243670	19059056		
164	11	1124300	1987-06-15	1987-06-15 00:00:00	1987-06-15	1987-06-15 00:00:00	\N	38000177		0	0	0		0	0	0	933	0	00781178901	45011828		
14654	1227	19018935	2016-04-06	2016-04-06 00:00:00	2016-04-06	2016-04-06 00:00:00	\N	38000177		0	0	0		0	0	0	80766	0	197604	19018935		
36280	2989	1713671	1974-10-26	1974-10-26 00:00:00	1974-11-02	1974-11-02 00:00:00	1974-11-02	38000177		0	0	7		0	0	0	199552	0	562251	1713671		
36298	2991	40229134	1968-02-22	1968-02-22 00:00:00	1968-03-07	1968-03-07 00:00:00	1968-03-07	38000177		0	0	14		0	0	0	199631	0	1043400	40229134		
31087	677	40213260	2012-06-08	2012-06-08 00:00:00	2012-06-08	2012-06-08 00:00:00	2012-06-08	581452		0	0	0		0	0	0	44819	0	121	40213260		
76727	1676	40213160	1980-03-21	1980-03-21 00:00:00	1980-03-21	1980-03-21 00:00:00	1980-03-21	581452		0	0	0		0	0	0	112434	0	10	40213160		
41897	3469	19078461	1986-02-08	1986-02-08 00:00:00	1986-05-09	1986-05-09 00:00:00	1986-05-09	38000177		0	0	90		0	0	0	230251	0	310965	19078461		
41755	3456	19133873	1952-06-07	1952-06-07 00:00:00	1952-06-20	1952-06-20 00:00:00	1952-06-20	38000177		0	0	13		0	0	0	229287	0	834061	19133873		
46935	1025	40213227	2002-01-12	2002-01-12 00:00:00	2002-01-12	2002-01-12 00:00:00	2002-01-12	581452		0	0	0		0	0	0	67501	0	113	40213227		
31974	2651	1127433	1952-12-26	1952-12-26 00:00:00	1953-01-02	1953-01-02 00:00:00	1953-01-02	38000177		0	0	7		0	0	0	175484	0	313782	1127433		
193594	4253	40213251	1985-12-02	1985-12-02 00:00:00	1985-12-02	1985-12-02 00:00:00	1985-12-02	581452		0	0	0		0	0	0	282454	0	21	40213251		
51416	4274	920300	1958-03-16	1958-03-16 00:00:00	1958-03-23	1958-03-23 00:00:00	1958-03-23	38000177		0	0	7		0	0	0	283617	0	311989	920300		
42790	3545	1127433	1998-09-13	1998-09-13 00:00:00	1998-09-20	1998-09-20 00:00:00	1998-09-20	38000177		0	0	7		0	0	0	235448	0	313782	1127433		
60336	5018	1118084	1980-01-25	1980-01-25 00:00:00	1980-01-25	1980-01-25 00:00:00	\N	38000177		0	0	0		0	0	0	333505	0	00025152531	44923712		
53123	4413	19133873	1961-10-08	1961-10-08 00:00:00	1961-10-15	1961-10-15 00:00:00	1961-10-15	38000177		0	0	7		0	0	0	293489	0	834061	19133873		
25928	2133	19059056	1970-09-09	1970-09-09 00:00:00	1970-09-23	1970-09-23 00:00:00	1970-09-23	38000177		0	0	14		0	0	0	141917	0	243670	19059056		
2031	160	920334	1992-09-09	1992-09-09 00:00:00	1992-09-16	1992-09-16 00:00:00	1992-09-16	38000177		0	0	7		0	0	0	10949	0	311995	920334		
51931	4319	1127433	1998-09-19	1998-09-19 00:00:00	1998-09-26	1998-09-26 00:00:00	1998-09-26	38000177		0	0	7		0	0	0	286611	0	313782	1127433		
159770	3516	40213227	1996-08-01	1996-08-01 00:00:00	1996-08-01	1996-08-01 00:00:00	1996-08-01	581452		0	0	0		0	0	0	233307	0	113	40213227		
56274	4670	1713671	1965-08-17	1965-08-17 00:00:00	1965-08-24	1965-08-24 00:00:00	1965-08-24	38000177		0	0	7		0	0	0	311204	0	562251	1713671		
35605	2935	1127433	1994-03-18	1994-03-18 00:00:00	1994-04-01	1994-04-01 00:00:00	1994-04-01	38000177		0	0	14		0	0	0	195680	0	313782	1127433		
62571	5203	1118084	1973-02-25	1973-02-25 00:00:00	1973-02-25	1973-02-25 00:00:00	\N	38000177		0	0	0		0	0	0	346066	0	00025152531	44923712		
3948	328	920300	2012-01-15	2012-01-15 00:00:00	2012-01-22	2012-01-22 00:00:00	2012-01-22	38000177		0	0	7		0	0	0	21678	0	311989	920300		
42084	3489	1713671	2005-02-07	2005-02-07 00:00:00	2005-02-14	2005-02-14 00:00:00	2005-02-14	38000177		0	0	7		0	0	0	231475	0	562251	1713671		
33850	2801	19059056	1984-03-01	1984-03-01 00:00:00	1984-05-30	1984-05-30 00:00:00	1984-05-30	38000177		0	0	90		0	0	0	185615	0	243670	19059056		
15171	328	40213227	2010-08-29	2010-08-29 00:00:00	2010-08-29	2010-08-29 00:00:00	2010-08-29	581452		0	0	0		0	0	0	21660	0	113	40213227		
14574	1222	19078461	2017-12-09	2017-12-09 00:00:00	2017-12-30	2017-12-30 00:00:00	2017-12-30	38000177		0	0	21		0	0	0	80444	0	310965	19078461		
1562	123	1127433	1954-01-10	1954-01-10 00:00:00	1954-01-24	1954-01-24 00:00:00	1954-01-24	38000177		0	0	14		0	0	0	8149	0	313782	1127433		
1613	126	19006318	1950-04-06	1950-04-06 00:00:00	1950-04-20	1950-04-20 00:00:00	1950-04-20	38000177		0	0	14		0	0	0	8415	0	105078	19006318		
40213	3330	19128065	1990-09-18	1990-09-18 00:00:00	1991-09-13	1991-09-13 00:00:00	1991-09-13	38000177		0	0	360		0	0	0	220993	0	749882	19128065		
8102	675	40165015	2013-11-05	2013-11-05 00:00:00	2013-11-05	2013-11-05 00:00:00	\N	38000177		0	0	0		0	0	0	44646	0	861467	40165015		
40325	3342	40236824	1932-07-30	1932-07-30 00:00:00	1932-08-06	1932-08-06 00:00:00	1932-08-06	38000177		0	0	7		0	0	0	221589	0	1094107	40236824		
44610	3694	19018935	2016-02-23	2016-02-23 00:00:00	2016-02-23	2016-02-23 00:00:00	\N	38000177		0	0	0		0	0	0	245555	0	197604	19018935		
35816	2949	1124300	1986-04-02	1986-04-02 00:00:00	1986-04-02	1986-04-02 00:00:00	\N	38000177		0	0	0		0	0	0	196836	0	00781178901	45011828		
49178	4080	40165015	1998-01-30	1998-01-30 00:00:00	1998-01-30	1998-01-30 00:00:00	\N	38000177		0	0	0		0	0	0	271175	0	861467	40165015		
46383	3841	40229134	2002-08-29	2002-08-29 00:00:00	2002-09-05	2002-09-05 00:00:00	2002-09-05	38000177		0	0	7		0	0	0	255033	0	1043400	40229134		
54224	4505	40165015	1993-03-29	1993-03-29 00:00:00	1993-03-29	1993-03-29 00:00:00	\N	38000177		0	0	0		0	0	0	300080	0	861467	40165015		
33394	2767	1127433	2002-12-27	2002-12-27 00:00:00	2003-01-10	2003-01-10 00:00:00	2003-01-10	38000177		0	0	14		0	0	0	183076	0	313782	1127433		
14796	1237	1127433	1971-02-18	1971-02-18 00:00:00	1971-02-25	1971-02-25 00:00:00	1971-02-25	38000177		0	0	7		0	0	0	81522	0	313782	1127433		
36379	3000	19059056	1965-12-13	1965-12-13 00:00:00	1966-01-03	1966-01-03 00:00:00	1966-01-03	38000177		0	0	21		0	0	0	200177	0	243670	19059056		
57047	4735	40243436	1983-06-16	1983-06-16 00:00:00	1983-06-16	1983-06-16 00:00:00	1983-06-16	38000177		0	0	0		0	0	0	315452	0	1190795	40243436		
57102	4738	40236824	1935-10-09	1935-10-09 00:00:00	1935-10-16	1935-10-16 00:00:00	1935-10-16	38000177		0	0	7		0	0	0	315644	0	1094107	40236824		
26561	2185	40173590	2000-09-28	2000-09-28 00:00:00	2000-09-28	2000-09-28 00:00:00	\N	38000177		0	0	0		0	0	0	145629	0	904419	40173590		
1342	30	40213227	1993-09-25	1993-09-25 00:00:00	1993-09-25	1993-09-25 00:00:00	1993-09-25	581452		0	0	0		0	0	0	2084	0	113	40213227		
21634	1778	19019979	1983-04-02	1983-04-02 00:00:00	1983-04-16	1983-04-16 00:00:00	1983-04-16	38000177		0	0	14		0	0	0	118972	0	198405	19019979		
21678	1781	1713671	1952-03-24	1952-03-24 00:00:00	1952-03-31	1952-03-31 00:00:00	1952-03-31	38000177		0	0	7		0	0	0	119197	0	562251	1713671		
22433	487	40213296	2007-06-06	2007-06-06 00:00:00	2007-06-06	2007-06-06 00:00:00	2007-06-06	581452		0	0	0		0	0	0	\N	0	52	40213296		
6475	545	1551192	1974-06-25	1974-06-25 00:00:00	1974-06-25	1974-06-25 00:00:00	1974-06-25	38000177		0	0	0		0	0	0	36142	0	312617	1551192		
47725	3957	1127433	1994-01-22	1994-01-22 00:00:00	1994-01-29	1994-01-29 00:00:00	1994-01-29	38000177		0	0	7		0	0	0	263087	0	313782	1127433		
120384	2646	40213314	1977-12-16	1977-12-16 00:00:00	1977-12-16	1977-12-16 00:00:00	1977-12-16	581452		0	0	0		0	0	0	175057	0	49	40213314		
23501	1935	1127078	1965-09-26	1965-09-26 00:00:00	1965-10-10	1965-10-10 00:00:00	1965-10-10	38000177		0	0	14		0	0	0	128745	0	282464	1127078		
16354	1355	19128065	1980-07-20	1980-07-20 00:00:00	1981-07-15	1981-07-15 00:00:00	1981-07-15	38000177		0	0	360		0	0	0	89782	0	749882	19128065		
916	74	19128065	1987-12-22	1987-12-22 00:00:00	1988-12-16	1988-12-16 00:00:00	1988-12-16	38000177		0	0	360		0	0	0	5017	0	749882	19128065		
41102	3409	19133905	2011-06-01	2011-06-01 00:00:00	2011-06-09	2011-06-09 00:00:00	2011-06-09	38000177		0	0	8		0	0	0	226097	0	834102	19133905		
41163	3413	19128065	1980-04-23	1980-04-23 00:00:00	1981-04-18	1981-04-18 00:00:00	1981-04-18	38000177		0	0	360		0	0	0	226387	0	749882	19128065		
58557	4860	1124300	2011-10-11	2011-10-11 00:00:00	2011-10-11	2011-10-11 00:00:00	\N	38000177		0	0	0		0	0	0	323311	0	00781178901	45011828		
87345	1916	40213296	2014-10-13	2014-10-13 00:00:00	2014-10-13	2014-10-13 00:00:00	2014-10-13	581452		0	0	0		0	0	0	127483	0	52	40213296		
20407	1676	1127433	1999-06-02	1999-06-02 00:00:00	1999-07-02	1999-07-02 00:00:00	1999-07-02	38000177		0	0	30		0	0	0	112469	0	313782	1127433		
16716	1385	19059056	1963-12-24	1963-12-24 00:00:00	1964-01-07	1964-01-07 00:00:00	1964-01-07	38000177		0	0	14		0	0	0	91872	0	243670	19059056		
8864	741	19128065	1989-11-20	1989-11-20 00:00:00	1990-11-15	1990-11-15 00:00:00	1990-11-15	38000177		0	0	360		0	0	0	49099	0	749882	19128065		
11	1	19129655	1978-06-22	1978-06-22 00:00:00	1978-07-27	1978-07-27 00:00:00	1978-07-27	38000177		0	0	35		0	0	0	81	0	789980	19129655		
7651	642	1127433	1993-10-01	1993-10-01 00:00:00	1993-10-15	1993-10-15 00:00:00	1993-10-15	38000177		0	0	14		0	0	0	42572	0	313782	1127433		
16798	1389	1127078	1962-04-27	1962-04-27 00:00:00	1962-06-26	1962-06-26 00:00:00	1962-06-26	38000177		0	0	60		0	0	0	92203	0	282464	1127078		
4114	340	40162522	2001-05-03	2001-05-03 00:00:00	2001-05-03	2001-05-03 00:00:00	\N	38000177		0	0	0		0	0	0	22669	0	857005	40162522		
165	12	19059056	1970-09-20	1970-09-20 00:00:00	1970-10-20	1970-10-20 00:00:00	1970-10-20	38000177		0	0	30		0	0	0	995	0	243670	19059056		
14655	1227	40171902	2016-04-06	2016-04-06 00:00:00	2016-04-06	2016-04-06 00:00:00	\N	38000177		0	0	0		0	0	0	80766	0	897718	40171902		
36281	2989	1115171	2010-07-16	2010-07-16 00:00:00	2010-08-06	2010-08-06 00:00:00	2010-08-06	38000177		0	0	21		0	0	0	199591	0	849574	1115171		
36299	2992	1127433	2006-01-02	2006-01-02 00:00:00	2006-01-09	2006-01-09 00:00:00	2006-01-09	38000177		0	0	7		0	0	0	199698	0	313782	1127433		
31090	677	40213160	1962-02-09	1962-02-09 00:00:00	1962-02-09	1962-02-09 00:00:00	1962-02-09	581452		0	0	0		0	0	0	44787	0	10	40213160		
76729	1676	40213314	1980-03-21	1980-03-21 00:00:00	1980-03-21	1980-03-21 00:00:00	1980-03-21	581452		0	0	0		0	0	0	112434	0	49	40213314		
41898	3469	1713671	1961-06-14	1961-06-14 00:00:00	1961-06-28	1961-06-28 00:00:00	1961-06-28	38000177		0	0	14		0	0	0	230256	0	562251	1713671		
41756	3456	19059056	1949-10-04	1949-10-04 00:00:00	1949-10-18	1949-10-18 00:00:00	1949-10-18	38000177		0	0	14		0	0	0	229293	0	243670	19059056		
159051	3501	40213227	2019-04-05	2019-04-05 00:00:00	2019-04-05	2019-04-05 00:00:00	2019-04-05	581452		0	0	0		0	0	0	232133	0	113	40213227		
31975	2651	1127433	2008-09-23	2008-09-23 00:00:00	2008-10-07	2008-10-07 00:00:00	2008-10-07	38000177		0	0	14		0	0	0	175384	0	313782	1127433		
193597	4253	40213160	1985-12-02	1985-12-02 00:00:00	1985-12-02	1985-12-02 00:00:00	1985-12-02	581452		0	0	0		0	0	0	282454	0	10	40213160		
51417	4274	19073188	1986-03-02	1986-03-02 00:00:00	1986-03-16	1986-03-16 00:00:00	1986-03-16	38000177		0	0	14		0	0	0	283624	0	308192	19073188		
42791	3545	1115171	1994-07-30	1994-07-30 00:00:00	1994-08-27	1994-08-27 00:00:00	1994-08-27	38000177		0	0	28		0	0	0	235439	0	849574	1115171		
60337	5018	19059056	1963-07-16	1963-07-16 00:00:00	1963-08-06	1963-08-06 00:00:00	1963-08-06	38000177		0	0	21		0	0	0	333481	0	243670	19059056		
53124	4413	1127433	2013-06-21	2013-06-21 00:00:00	2013-07-05	2013-07-05 00:00:00	2013-07-05	38000177		0	0	14		0	0	0	293492	0	313782	1127433		
25929	2133	19129655	1970-09-09	1970-09-09 00:00:00	1970-09-23	1970-09-23 00:00:00	1970-09-23	38000177		0	0	14		0	0	0	141917	0	789980	19129655		
2032	160	1127433	1976-02-09	1976-02-09 00:00:00	1976-03-08	1976-03-08 00:00:00	1976-03-08	38000177		0	0	28		0	0	0	10974	0	313782	1127433		
51932	4319	1127433	2009-04-04	2009-04-04 00:00:00	2009-04-11	2009-04-11 00:00:00	2009-04-11	38000177		0	0	7		0	0	0	286612	0	313782	1127433		
159773	3516	40213227	2016-12-08	2016-12-08 00:00:00	2016-12-08	2016-12-08 00:00:00	2016-12-08	581452		0	0	0		0	0	0	233348	0	113	40213227		
10025	213	40213227	2018-07-02	2018-07-02 00:00:00	2018-07-02	2018-07-02 00:00:00	2018-07-02	581452		0	0	0		0	0	0	14523	0	113	40213227		
35606	2935	1124300	2013-08-16	2013-08-16 00:00:00	2013-08-16	2013-08-16 00:00:00	\N	38000177		0	0	0		0	0	0	195714	0	00781178901	45011828		
62572	5203	19059056	1938-03-31	1938-03-31 00:00:00	1938-04-14	1938-04-14 00:00:00	1938-04-14	38000177		0	0	14		0	0	0	346116	0	243670	19059056		
3949	328	1713671	1984-08-05	1984-08-05 00:00:00	1984-08-19	1984-08-19 00:00:00	1984-08-19	38000177		0	0	14		0	0	0	21670	0	562251	1713671		
42085	3489	1127433	2009-09-07	2009-09-07 00:00:00	2009-09-21	2009-09-21 00:00:00	2009-09-21	38000177		0	0	14		0	0	0	231462	0	313782	1127433		
138729	3048	40213296	2014-05-21	2014-05-21 00:00:00	2014-05-21	2014-05-21 00:00:00	2014-05-21	581452		0	0	0		0	0	0	202794	0	52	40213296		
1381	111	19073183	1985-12-26	1985-12-26 00:00:00	1986-01-09	1986-01-09 00:00:00	1986-01-09	38000177		0	0	14		0	0	0	7365	0	308182	19073183		
14575	1222	40229134	1988-12-27	1988-12-27 00:00:00	1989-01-03	1989-01-03 00:00:00	1989-01-03	38000177		0	0	7		0	0	0	80370	0	1043400	40229134		
1563	123	1332419	2006-08-23	2006-08-23 00:00:00	2006-08-23	2006-08-23 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	197361	1332419		
1614	126	1115171	2010-05-26	2010-05-26 00:00:00	2010-06-16	2010-06-16 00:00:00	2010-06-16	38000177		0	0	21		0	0	0	8449	0	849574	1115171		
40214	3330	19078461	2007-08-24	2007-08-24 00:00:00	2007-09-14	2007-09-14 00:00:00	2007-09-14	38000177		0	0	21		0	0	0	221007	0	310965	19078461		
8103	675	19078461	2013-11-05	2013-11-05 00:00:00	2014-02-03	2014-02-03 00:00:00	2014-02-03	38000177		0	0	90		0	0	0	44646	0	310965	19078461		
40326	3342	920300	1932-07-30	1932-07-30 00:00:00	1932-08-06	1932-08-06 00:00:00	1932-08-06	38000177		0	0	7		0	0	0	221589	0	311989	920300		
44611	3694	40163554	2016-02-23	2016-02-23 00:00:00	2016-02-23	2016-02-23 00:00:00	\N	38000177		0	0	0		0	0	0	245555	0	855332	40163554		
35817	2949	19006318	1951-03-03	1951-03-03 00:00:00	1951-03-17	1951-03-17 00:00:00	1951-03-17	38000177		0	0	14		0	0	0	196859	0	105078	19006318		
49179	4080	1713671	1988-09-03	1988-09-03 00:00:00	1988-09-10	1988-09-10 00:00:00	1988-09-10	38000177		0	0	7		0	0	0	271156	0	562251	1713671		
46384	3843	46233988	1974-02-03	1974-02-03 00:00:00	1974-02-17	1974-02-17 00:00:00	1974-02-17	38000177		0	0	14		0	0	0	255113	0	1652673	46233988		
54225	4505	19059056	1942-02-20	1942-02-20 00:00:00	1942-03-13	1942-03-13 00:00:00	1942-03-13	38000177		0	0	21		0	0	0	300078	0	243670	19059056		
33395	2767	1127433	1947-03-31	1947-03-31 00:00:00	1947-04-07	1947-04-07 00:00:00	1947-04-07	38000177		0	0	7		0	0	0	183048	0	313782	1127433		
14797	1237	1127433	1951-08-01	1951-08-01 00:00:00	1951-08-15	1951-08-15 00:00:00	1951-08-15	38000177		0	0	14		0	0	0	81497	0	313782	1127433		
36380	3000	1713671	1976-04-15	1976-04-15 00:00:00	1976-05-06	1976-05-06 00:00:00	1976-05-06	38000177		0	0	21		0	0	0	200141	0	562251	1713671		
57048	4735	1310034	1983-06-16	1983-06-16 00:00:00	1983-06-16	1983-06-16 00:00:00	1983-06-16	38000177		0	0	0		0	0	0	315452	0	834357	1310034		
57103	4738	920300	1935-10-09	1935-10-09 00:00:00	1935-10-16	1935-10-16 00:00:00	1935-10-16	38000177		0	0	7		0	0	0	315644	0	311989	920300		
26562	2186	19078461	1996-02-27	1996-02-27 00:00:00	1996-03-19	1996-03-19 00:00:00	1996-03-19	38000177		0	0	21		0	0	0	145829	0	310965	19078461		
1345	30	40213160	1971-01-23	1971-01-23 00:00:00	1971-01-23	1971-01-23 00:00:00	1971-01-23	581452		0	0	0		0	0	0	2050	0	10	40213160		
21635	1778	19073183	1983-04-02	1983-04-02 00:00:00	1983-04-16	1983-04-16 00:00:00	1983-04-16	38000177		0	0	14		0	0	0	118972	0	308182	19073183		
21679	1781	40173590	2011-12-06	2011-12-06 00:00:00	2011-12-06	2011-12-06 00:00:00	\N	38000177		0	0	0		0	0	0	119201	0	904419	40173590		
22438	487	40213160	1970-04-29	1970-04-29 00:00:00	1970-04-29	1970-04-29 00:00:00	1970-04-29	581452		0	0	0		0	0	0	32563	0	10	40213160		
6476	545	19128065	1986-09-30	1986-09-30 00:00:00	1987-09-25	1987-09-25 00:00:00	1987-09-25	38000177		0	0	360		0	0	0	36067	0	749882	19128065		
47726	3957	1713671	2010-05-11	2010-05-11 00:00:00	2010-05-25	2010-05-25 00:00:00	2010-05-25	38000177		0	0	14		0	0	0	263120	0	562251	1713671		
120387	2646	40213227	2016-07-22	2016-07-22 00:00:00	2016-07-22	2016-07-22 00:00:00	2016-07-22	581452		0	0	0		0	0	0	175082	0	113	40213227		
23502	1935	1124300	2009-03-09	2009-03-09 00:00:00	2009-03-09	2009-03-09 00:00:00	\N	38000177		0	0	0		0	0	0	128694	0	00781178901	45011828		
16355	1355	1118084	1996-05-22	1996-05-22 00:00:00	1996-05-22	1996-05-22 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00025152531	44923712		
917	74	19133873	1986-02-04	1986-02-04 00:00:00	1986-02-11	1986-02-11 00:00:00	1986-02-11	38000177		0	0	7		0	0	0	5013	0	834061	19133873		
41103	3409	1713671	2016-02-06	2016-02-06 00:00:00	2016-02-20	2016-02-20 00:00:00	2016-02-20	38000177		0	0	14		0	0	0	226078	0	562251	1713671		
41164	3413	1118084	2001-07-07	2001-07-07 00:00:00	2001-07-07	2001-07-07 00:00:00	\N	38000177		0	0	0		0	0	0	226405	0	00025152531	44923712		
58558	4860	1127433	2015-11-14	2015-11-14 00:00:00	2015-11-21	2015-11-21 00:00:00	2015-11-21	38000177		0	0	7		0	0	0	323291	0	313782	1127433		
87347	1916	40213160	1976-01-19	1976-01-19 00:00:00	1976-01-19	1976-01-19 00:00:00	1976-01-19	581452		0	0	0		0	0	0	\N	0	10	40213160		
20408	1676	1713671	1990-02-17	1990-02-17 00:00:00	1990-03-03	1990-03-03 00:00:00	1990-03-03	38000177		0	0	14		0	0	0	112453	0	562251	1713671		
16717	1385	19133873	1972-05-22	1972-05-22 00:00:00	1972-05-31	1972-05-31 00:00:00	1972-05-31	38000177		0	0	9		0	0	0	91818	0	834061	19133873		
8865	741	19128065	1992-11-04	1992-11-04 00:00:00	1993-10-30	1993-10-30 00:00:00	1993-10-30	38000177		0	0	360		0	0	0	49101	0	749882	19128065		
12	1	19059056	1981-08-10	1981-08-10 00:00:00	1981-09-16	1981-09-16 00:00:00	1981-09-16	38000177		0	0	37		0	0	0	82	0	243670	19059056		
7652	642	19059056	1967-07-31	1967-07-31 00:00:00	1967-08-21	1967-08-21 00:00:00	1967-08-21	38000177		0	0	21		0	0	0	42463	0	243670	19059056		
16799	1389	1127433	2008-09-10	2008-09-10 00:00:00	2008-09-24	2008-09-24 00:00:00	2008-09-24	38000177		0	0	14		0	0	0	92167	0	313782	1127433		
4115	340	1115171	2001-05-03	2001-05-03 00:00:00	2001-06-02	2001-06-02 00:00:00	2001-06-02	38000177		0	0	30		0	0	0	22669	0	849574	1115171		
166	12	1127433	1980-01-31	1980-01-31 00:00:00	1980-02-21	1980-02-21 00:00:00	1980-02-21	38000177		0	0	21		0	0	0	996	0	313782	1127433		
14656	1227	40163554	2016-04-06	2016-04-06 00:00:00	2016-04-06	2016-04-06 00:00:00	\N	38000177		0	0	0		0	0	0	80766	0	855332	40163554		
36282	2989	1127433	1986-11-16	1986-11-16 00:00:00	1986-11-30	1986-11-30 00:00:00	1986-11-30	38000177		0	0	14		0	0	0	199545	0	313782	1127433		
36300	2992	40231925	2012-05-17	2012-05-17 00:00:00	2012-05-17	2012-05-17 00:00:00	\N	38000177		0	0	0		0	0	0	199768	0	1049221	40231925		
111902	2458	40213160	1975-05-11	1975-05-11 00:00:00	1975-05-11	1975-05-11 00:00:00	1975-05-11	581452		0	0	0		0	0	0	163003	0	10	40213160		
76732	1676	40213160	1980-08-22	1980-08-22 00:00:00	1980-08-22	1980-08-22 00:00:00	1980-08-22	581452		0	0	0		0	0	0	112454	0	10	40213160		
41899	3469	1127433	1993-03-22	1993-03-22 00:00:00	1993-04-28	1993-04-28 00:00:00	1993-04-28	38000177		0	0	37		0	0	0	230254	0	313782	1127433		
41757	3456	1127433	1978-10-07	1978-10-07 00:00:00	1978-10-28	1978-10-28 00:00:00	1978-10-28	38000177		0	0	21		0	0	0	229295	0	313782	1127433		
159066	3501	40213198	2013-02-28	2013-02-28 00:00:00	2013-02-28	2013-02-28 00:00:00	2013-02-28	581452		0	0	0		0	0	0	232141	0	133	40213198		
31976	2651	19133905	1973-11-08	1973-11-08 00:00:00	1973-11-17	1973-11-17 00:00:00	1973-11-17	38000177		0	0	9		0	0	0	175488	0	834102	19133905		
193598	4253	40213251	1984-05-29	1984-05-29 00:00:00	1984-05-29	1984-05-29 00:00:00	1984-05-29	581452		0	0	0		0	0	0	282430	0	21	40213251		
51418	4274	1127433	1986-03-02	1986-03-02 00:00:00	1986-03-16	1986-03-16 00:00:00	1986-03-16	38000177		0	0	14		0	0	0	283624	0	313782	1127433		
42792	3545	1713671	1975-12-30	1975-12-30 00:00:00	1976-01-13	1976-01-13 00:00:00	1976-01-13	38000177		0	0	14		0	0	0	235446	0	562251	1713671		
60338	5018	19059056	1955-09-23	1955-09-23 00:00:00	1955-10-21	1955-10-21 00:00:00	1955-10-21	38000177		0	0	28		0	0	0	333479	0	243670	19059056		
53125	4413	1127433	2012-04-18	2012-04-18 00:00:00	2012-04-25	2012-04-25 00:00:00	2012-04-25	38000177		0	0	7		0	0	0	293480	0	313782	1127433		
25930	2133	40162522	1996-11-28	1996-11-28 00:00:00	1996-11-28	1996-11-28 00:00:00	\N	38000177		0	0	0		0	0	0	141894	0	857005	40162522		
2033	161	1127433	2013-07-31	2013-07-31 00:00:00	2013-08-28	2013-08-28 00:00:00	2013-08-28	38000177		0	0	28		0	0	0	11059	0	313782	1127433		
51933	4319	1127433	1995-10-30	1995-10-30 00:00:00	1996-01-28	1996-01-28 00:00:00	1996-01-28	38000177		0	0	90		0	0	0	286583	0	313782	1127433		
159784	3516	40213227	2007-06-14	2007-06-14 00:00:00	2007-06-14	2007-06-14 00:00:00	2007-06-14	581452		0	0	0		0	0	0	233361	0	113	40213227		
10030	213	40213306	1989-07-03	1989-07-03 00:00:00	1989-07-03	1989-07-03 00:00:00	1989-07-03	581452		0	0	0		0	0	0	14487	0	43	40213306		
35607	2935	19128022	1992-03-24	1992-03-24 00:00:00	1993-03-19	1993-03-19 00:00:00	1993-03-19	38000177		0	0	360		0	0	0	195695	0	749785	19128022		
62573	5203	19126352	1999-11-10	1999-11-10 00:00:00	2003-03-19	2003-03-19 00:00:00	2003-03-19	38000177		0	0	1225		0	0	0	346099	0	705129	19126352		
3950	328	1127433	2004-08-12	2004-08-12 00:00:00	2004-08-19	2004-08-19 00:00:00	2004-08-19	38000177		0	0	7		0	0	0	21665	0	313782	1127433		
42086	3489	1118084	2012-08-09	2012-08-09 00:00:00	2012-08-09	2012-08-09 00:00:00	\N	38000177		0	0	0		0	0	0	231458	0	00025152531	44923712		
138730	3048	40213160	1974-10-23	1974-10-23 00:00:00	1974-10-23	1974-10-23 00:00:00	1974-10-23	581452		0	0	0		0	0	0	202815	0	10	40213160		
1382	111	19128065	1999-03-12	1999-03-12 00:00:00	2000-03-06	2000-03-06 00:00:00	2000-03-06	38000177		0	0	360		0	0	0	7355	0	749882	19128065		
14576	1222	1127433	1969-06-04	1969-06-04 00:00:00	1969-06-11	1969-06-11 00:00:00	1969-06-11	38000177		0	0	7		0	0	0	80432	0	313782	1127433		
1564	123	1539411	2006-08-23	2006-08-23 00:00:00	2006-08-23	2006-08-23 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	312961	1539411		
1615	126	19059056	1985-08-30	1985-08-30 00:00:00	1985-10-04	1985-10-04 00:00:00	1985-10-04	38000177		0	0	35		0	0	0	8447	0	243670	19059056		
40215	3330	19128065	1988-09-28	1988-09-28 00:00:00	1989-09-23	1989-09-23 00:00:00	1989-09-23	38000177		0	0	360		0	0	0	220958	0	749882	19128065		
8104	675	1127078	1950-12-03	1950-12-03 00:00:00	1950-12-31	1950-12-31 00:00:00	1950-12-31	38000177		0	0	28		0	0	0	44593	0	282464	1127078		
40327	3342	19059056	1910-02-02	1910-02-02 00:00:00	1910-02-16	1910-02-16 00:00:00	1910-02-16	38000177		0	0	14		0	0	0	221648	0	243670	19059056		
44612	3694	40171902	2016-02-23	2016-02-23 00:00:00	2016-02-23	2016-02-23 00:00:00	\N	38000177		0	0	0		0	0	0	245555	0	897718	40171902		
35818	2949	19059056	1951-03-03	1951-03-03 00:00:00	1951-03-17	1951-03-17 00:00:00	1951-03-17	38000177		0	0	14		0	0	0	196859	0	243670	19059056		
49180	4080	19128065	1986-04-22	1986-04-22 00:00:00	1987-04-17	1987-04-17 00:00:00	1987-04-17	38000177		0	0	360		0	0	0	271199	0	749882	19128065		
46385	3843	1127078	1974-02-03	1974-02-03 00:00:00	1974-02-17	1974-02-17 00:00:00	1974-02-17	38000177		0	0	14		0	0	0	255113	0	282464	1127078		
54226	4505	1713671	2007-09-26	2007-09-26 00:00:00	2007-10-10	2007-10-10 00:00:00	2007-10-10	38000177		0	0	14		0	0	0	300070	0	562251	1713671		
33396	2767	1367571	1939-05-23	1939-05-23 00:00:00	1939-05-23	1939-05-23 00:00:00	1939-05-23	38000177		0	0	0		0	0	0	183063	0	314659	19080464		
14798	1237	19006318	1947-04-23	1947-04-23 00:00:00	1947-05-07	1947-05-07 00:00:00	1947-05-07	38000177		0	0	14		0	0	0	81513	0	105078	19006318		
36381	3000	1127433	1951-07-01	1951-07-01 00:00:00	1951-07-15	1951-07-15 00:00:00	1951-07-15	38000177		0	0	14		0	0	0	200184	0	313782	1127433		
57049	4735	46233988	1973-11-30	1973-11-30 00:00:00	1973-12-14	1973-12-14 00:00:00	1973-12-14	38000177		0	0	14		0	0	0	315445	0	1652673	46233988		
57104	4738	1713671	1926-07-11	1926-07-11 00:00:00	1926-08-01	1926-08-01 00:00:00	1926-08-01	38000177		0	0	21		0	0	0	315663	0	562251	1713671		
26563	2186	1127433	2013-05-30	2013-05-30 00:00:00	2013-06-13	2013-06-13 00:00:00	2013-06-13	38000177		0	0	14		0	0	0	145769	0	313782	1127433		
1346	30	40213160	1971-04-24	1971-04-24 00:00:00	1971-04-24	1971-04-24 00:00:00	1971-04-24	581452		0	0	0		0	0	0	2109	0	10	40213160		
21636	1779	1118084	1976-11-07	1976-11-07 00:00:00	1976-11-07	1976-11-07 00:00:00	\N	38000177		0	0	0		0	0	0	118987	0	00025152531	44923712		
21680	1781	19059056	1944-01-11	1944-01-11 00:00:00	1944-01-25	1944-01-25 00:00:00	1944-01-25	38000177		0	0	14		0	0	0	119253	0	243670	19059056		
22442	487	40213160	1965-08-25	1965-08-25 00:00:00	1965-08-25	1965-08-25 00:00:00	1965-08-25	581452		0	0	0		0	0	0	32537	0	10	40213160		
6477	546	1127433	1950-12-28	1950-12-28 00:00:00	1951-01-04	1951-01-04 00:00:00	1951-01-04	38000177		0	0	7		0	0	0	36197	0	313782	1127433		
47727	3957	1124300	1998-08-02	1998-08-02 00:00:00	1998-08-02	1998-08-02 00:00:00	\N	38000177		0	0	0		0	0	0	263119	0	00781178901	45011828		
120388	2646	40213296	2016-07-22	2016-07-22 00:00:00	2016-07-22	2016-07-22 00:00:00	2016-07-22	581452		0	0	0		0	0	0	175082	0	52	40213296		
23503	1935	1713671	1973-10-20	1973-10-20 00:00:00	1973-11-03	1973-11-03 00:00:00	1973-11-03	38000177		0	0	14		0	0	0	128710	0	562251	1713671		
16356	1355	19133873	1966-09-07	1966-09-07 00:00:00	1966-09-17	1966-09-17 00:00:00	1966-09-17	38000177		0	0	10		0	0	0	89796	0	834061	19133873		
918	74	19133873	1979-04-16	1979-04-16 00:00:00	1979-04-27	1979-04-27 00:00:00	1979-04-27	38000177		0	0	11		0	0	0	5009	0	834061	19133873		
41104	3409	19059056	1966-11-15	1966-11-15 00:00:00	1966-12-06	1966-12-06 00:00:00	1966-12-06	38000177		0	0	21		0	0	0	226120	0	243670	19059056		
41165	3413	1713671	2006-10-27	2006-10-27 00:00:00	2006-11-17	2006-11-17 00:00:00	2006-11-17	38000177		0	0	21		0	0	0	226413	0	562251	1713671		
58559	4860	19128022	1996-09-04	1996-09-04 00:00:00	1997-08-30	1997-08-30 00:00:00	1997-08-30	38000177		0	0	360		0	0	0	323331	0	749785	19128022		
87350	1916	40213227	2012-10-08	2012-10-08 00:00:00	2012-10-08	2012-10-08 00:00:00	2012-10-08	581452		0	0	0		0	0	0	127512	0	113	40213227		
20409	1676	1713671	1999-01-20	1999-01-20 00:00:00	1999-04-07	1999-04-07 00:00:00	1999-04-07	38000177		0	0	77		0	0	0	112451	0	562251	1713671		
16718	1385	19128065	1984-03-18	1984-03-18 00:00:00	1985-03-13	1985-03-13 00:00:00	1985-03-13	38000177		0	0	360		0	0	0	91822	0	749882	19128065		
8866	741	920300	1995-12-23	1995-12-23 00:00:00	1995-12-30	1995-12-30 00:00:00	1995-12-30	38000177		0	0	7		0	0	0	49094	0	311989	920300		
13	1	19075601	2006-03-09	2006-03-09 00:00:00	2006-03-09	2006-03-09 00:00:00	\N	38000177		0	0	0		0	0	0	59	0	309362	19075601		
7658	644	19128022	1991-10-08	1991-10-08 00:00:00	1992-10-02	1992-10-02 00:00:00	1992-10-02	38000177		0	0	360		0	0	0	42617	0	749785	19128022		
16800	1389	19059056	1965-03-12	1965-03-12 00:00:00	1965-06-10	1965-06-10 00:00:00	1965-06-10	38000177		0	0	90		0	0	0	92204	0	243670	19059056		
4116	340	1713671	2014-01-11	2014-01-11 00:00:00	2014-01-25	2014-01-25 00:00:00	2014-01-25	38000177		0	0	14		0	0	0	22713	0	562251	1713671		
10625	884	1127433	1985-08-21	1985-08-21 00:00:00	1985-08-28	1985-08-28 00:00:00	1985-08-28	38000177		0	0	7		0	0	0	58839	0	313782	1127433		
14657	1227	1127433	1949-12-22	1949-12-22 00:00:00	1950-01-05	1950-01-05 00:00:00	1950-01-05	38000177		0	0	14		0	0	0	80802	0	313782	1127433		
36283	2989	19078461	1998-10-12	1998-10-12 00:00:00	1998-11-11	1998-11-11 00:00:00	1998-11-11	38000177		0	0	30		0	0	0	199589	0	310965	19078461		
36301	2992	19078461	2012-05-17	2012-05-17 00:00:00	2012-08-15	2012-08-15 00:00:00	2012-08-15	38000177		0	0	90		0	0	0	199768	0	310965	19078461		
111914	2459	40213227	2007-09-10	2007-09-10 00:00:00	2007-09-10	2007-09-10 00:00:00	2007-09-10	581452		0	0	0		0	0	0	163023	0	113	40213227		
76738	1676	40213314	1981-02-20	1981-02-20 00:00:00	1981-02-20	1981-02-20 00:00:00	1981-02-20	581452		0	0	0		0	0	0	112442	0	49	40213314		
41900	3470	1115171	2013-01-23	2013-01-23 00:00:00	2013-02-06	2013-02-06 00:00:00	2013-02-06	38000177		0	0	14		0	0	0	230297	0	849574	1115171		
41758	3457	1713671	1947-07-12	1947-07-12 00:00:00	1947-07-26	1947-07-26 00:00:00	1947-07-26	38000177		0	0	14		0	0	0	229405	0	562251	1713671		
102070	2237	40213227	2000-10-29	2000-10-29 00:00:00	2000-10-29	2000-10-29 00:00:00	2000-10-29	581452		0	0	0		0	0	0	148842	0	113	40213227		
31978	2651	19059056	1956-04-03	1956-04-03 00:00:00	1956-07-02	1956-07-02 00:00:00	1956-07-02	38000177		0	0	90		0	0	0	175417	0	243670	19059056		
193600	4253	40213160	1981-03-30	1981-03-30 00:00:00	1981-03-30	1981-03-30 00:00:00	1981-03-30	581452		0	0	0		0	0	0	282452	0	10	40213160		
51419	4274	1127433	1973-10-29	1973-10-29 00:00:00	1973-11-05	1973-11-05 00:00:00	1973-11-05	38000177		0	0	7		0	0	0	283619	0	313782	1127433		
42802	3547	1124300	2014-05-23	2014-05-23 00:00:00	2014-05-23	2014-05-23 00:00:00	\N	38000177		0	0	0		0	0	0	235579	0	00781178901	45011828		
60339	5018	40165015	1976-03-30	1976-03-30 00:00:00	1976-03-30	1976-03-30 00:00:00	\N	38000177		0	0	0		0	0	0	333482	0	861467	40165015		
53126	4413	19059056	1962-07-01	1962-07-01 00:00:00	1962-07-15	1962-07-15 00:00:00	1962-07-15	38000177		0	0	14		0	0	0	293466	0	243670	19059056		
25931	2134	19075601	2017-04-02	2017-04-02 00:00:00	2017-04-02	2017-04-02 00:00:00	2017-04-02	38000177		0	0	0		0	0	0	141957	0	309362	19075601		
2034	161	19078461	2016-07-13	2016-07-13 00:00:00	2016-09-11	2016-09-11 00:00:00	2016-09-11	38000177		0	0	60		0	0	0	11060	0	310965	19078461		
51934	4319	40165015	2014-05-28	2014-05-28 00:00:00	2014-05-28	2014-05-28 00:00:00	\N	38000177		0	0	0		0	0	0	286586	0	861467	40165015		
57622	1261	40213160	1971-01-23	1971-01-23 00:00:00	1971-01-23	1971-01-23 00:00:00	1971-01-23	581452		0	0	0		0	0	0	83221	0	10	40213160		
10037	213	40213227	2009-05-11	2009-05-11 00:00:00	2009-05-11	2009-05-11 00:00:00	2009-05-11	581452		0	0	0		0	0	0	14543	0	113	40213227		
35608	2935	19133905	2001-01-27	2001-01-27 00:00:00	2001-02-09	2001-02-09 00:00:00	2001-02-09	38000177		0	0	13		0	0	0	195686	0	834102	19133905		
62574	5203	19075601	1999-11-10	1999-11-10 00:00:00	2003-03-19	2003-03-19 00:00:00	2003-03-19	38000177		0	0	1225		0	0	0	346099	0	309362	19075601		
22556	489	40213314	1977-05-08	1977-05-08 00:00:00	1977-05-08	1977-05-08 00:00:00	1977-05-08	581452		0	0	0		0	0	0	32768	0	49	40213314		
42087	3489	920300	1990-11-25	1990-11-25 00:00:00	1990-12-02	1990-12-02 00:00:00	1990-12-02	38000177		0	0	7		0	0	0	231469	0	311989	920300		
138732	3048	40213227	2016-05-25	2016-05-25 00:00:00	2016-05-25	2016-05-25 00:00:00	2016-05-25	581452		0	0	0		0	0	0	202820	0	113	40213227		
1383	111	19128022	1995-04-02	1995-04-02 00:00:00	1996-03-27	1996-03-27 00:00:00	1996-03-27	38000177		0	0	360		0	0	0	7378	0	749785	19128022		
14577	1222	1713671	1954-11-09	1954-11-09 00:00:00	1954-11-16	1954-11-16 00:00:00	1954-11-16	38000177		0	0	7		0	0	0	80431	0	562251	1713671		
1565	123	19126352	2006-08-23	2006-08-23 00:00:00	2006-08-23	2006-08-23 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	705129	19126352		
1616	126	1127078	1951-04-24	1951-04-24 00:00:00	1951-05-08	1951-05-08 00:00:00	1951-05-08	38000177		0	0	14		0	0	0	8416	0	282464	1127078		
40216	3330	19019979	1975-06-29	1975-06-29 00:00:00	1975-07-13	1975-07-13 00:00:00	1975-07-13	38000177		0	0	14		0	0	0	221006	0	198405	19019979		
8105	675	19059056	1951-04-19	1951-04-19 00:00:00	1951-05-03	1951-05-03 00:00:00	1951-05-03	38000177		0	0	14		0	0	0	44632	0	243670	19059056		
40328	3342	1127433	1927-06-04	1927-06-04 00:00:00	1927-06-18	1927-06-18 00:00:00	1927-06-18	38000177		0	0	14		0	0	0	221588	0	313782	1127433		
38608	3189	40165015	1985-09-27	1985-09-27 00:00:00	1985-09-27	1985-09-27 00:00:00	\N	38000177		0	0	0		0	0	0	212225	0	861467	40165015		
35819	2949	1127433	2010-05-30	2010-05-30 00:00:00	2010-07-04	2010-07-04 00:00:00	2010-07-04	38000177		0	0	35		0	0	0	196815	0	313782	1127433		
49181	4080	1127433	2007-01-25	2007-01-25 00:00:00	2007-02-01	2007-02-01 00:00:00	2007-02-01	38000177		0	0	7		0	0	0	271180	0	313782	1127433		
46386	3843	40229134	2004-05-08	2004-05-08 00:00:00	2004-05-15	2004-05-15 00:00:00	2004-05-15	38000177		0	0	7		0	0	0	255074	0	1043400	40229134		
54227	4505	19059056	1938-04-12	1938-04-12 00:00:00	1938-06-11	1938-06-11 00:00:00	1938-06-11	38000177		0	0	60		0	0	0	300077	0	243670	19059056		
33397	2767	35605482	1939-05-23	1939-05-23 00:00:00	1939-05-23	1939-05-23 00:00:00	1939-05-23	38000177		0	0	0		0	0	0	183063	0	1740467	35605482		
33353	2764	1127433	1977-04-07	1977-04-07 00:00:00	1977-04-21	1977-04-21 00:00:00	1977-04-21	38000177		0	0	14		0	0	0	182748	0	313782	1127433		
36383	3000	1124300	1983-09-20	1983-09-20 00:00:00	1983-09-20	1983-09-20 00:00:00	\N	38000177		0	0	0		0	0	0	200223	0	00781178901	45011828		
57050	4735	19059056	1973-11-30	1973-11-30 00:00:00	1973-12-14	1973-12-14 00:00:00	1973-12-14	38000177		0	0	14		0	0	0	315445	0	243670	19059056		
28115	2326	1124300	1994-01-13	1994-01-13 00:00:00	1994-01-13	1994-01-13 00:00:00	\N	38000177		0	0	0		0	0	0	154697	0	00781178901	45011828		
26564	2186	19133873	1974-10-02	1974-10-02 00:00:00	1974-10-14	1974-10-14 00:00:00	1974-10-14	38000177		0	0	12		0	0	0	145816	0	834061	19133873		
1352	30	40213160	1970-11-21	1970-11-21 00:00:00	1970-11-21	1970-11-21 00:00:00	1970-11-21	581452		0	0	0		0	0	0	2108	0	10	40213160		
21637	1779	1127433	1945-12-11	1945-12-11 00:00:00	1945-12-25	1945-12-25 00:00:00	1945-12-25	38000177		0	0	14		0	0	0	119070	0	313782	1127433		
21681	1781	1115171	2009-11-24	2009-11-24 00:00:00	2009-12-08	2009-12-08 00:00:00	2009-12-08	38000177		0	0	14		0	0	0	119227	0	849574	1115171		
22444	487	40213160	1965-10-27	1965-10-27 00:00:00	1965-10-27	1965-10-27 00:00:00	1965-10-27	581452		0	0	0		0	0	0	32605	0	10	40213160		
6478	546	1127433	1946-02-03	1946-02-03 00:00:00	1946-02-10	1946-02-10 00:00:00	1946-02-10	38000177		0	0	7		0	0	0	36207	0	313782	1127433		
47728	3957	40169281	1998-12-24	1998-12-24 00:00:00	1998-12-24	1998-12-24 00:00:00	\N	38000177		0	0	0		0	0	0	263116	0	896209	40169281		
120389	2646	40213160	1974-10-18	1974-10-18 00:00:00	1974-10-18	1974-10-18 00:00:00	1974-10-18	581452		0	0	0		0	0	0	175094	0	10	40213160		
23504	1935	40229134	1980-01-12	1980-01-12 00:00:00	1980-01-26	1980-01-26 00:00:00	1980-01-26	38000177		0	0	14		0	0	0	128684	0	1043400	40229134		
16357	1355	1127078	1966-08-23	1966-08-23 00:00:00	1966-09-06	1966-09-06 00:00:00	1966-09-06	38000177		0	0	14		0	0	0	89842	0	282464	1127078		
919	74	1127433	2013-08-27	2013-08-27 00:00:00	2013-09-10	2013-09-10 00:00:00	2013-09-10	38000177		0	0	14		0	0	0	4981	0	313782	1127433		
41105	3409	920334	2002-07-08	2002-07-08 00:00:00	2002-07-15	2002-07-15 00:00:00	2002-07-15	38000177		0	0	7		0	0	0	226075	0	311995	920334		
41166	3413	19128065	1986-03-23	1986-03-23 00:00:00	1987-03-18	1987-03-18 00:00:00	1987-03-18	38000177		0	0	360		0	0	0	226424	0	749882	19128065		
58560	4861	1127433	1958-08-31	1958-08-31 00:00:00	1958-09-14	1958-09-14 00:00:00	1958-09-14	38000177		0	0	14		0	0	0	323382	0	313782	1127433		
87351	1916	40213296	2012-10-08	2012-10-08 00:00:00	2012-10-08	2012-10-08 00:00:00	2012-10-08	581452		0	0	0		0	0	0	127512	0	52	40213296		
20410	1677	19006318	1971-03-17	1971-03-17 00:00:00	1971-03-31	1971-03-31 00:00:00	1971-03-31	38000177		0	0	14		0	0	0	112515	0	105078	19006318		
16719	1385	1127433	2007-05-14	2007-05-14 00:00:00	2007-05-28	2007-05-28 00:00:00	2007-05-28	38000177		0	0	14		0	0	0	91828	0	313782	1127433		
8867	741	40236824	1995-12-23	1995-12-23 00:00:00	1995-12-30	1995-12-30 00:00:00	1995-12-30	38000177		0	0	7		0	0	0	49094	0	1094107	40236824		
14	1	19126352	2006-03-09	2006-03-09 00:00:00	2006-03-09	2006-03-09 00:00:00	\N	38000177		0	0	0		0	0	0	59	0	705129	19126352		
7659	644	1127078	1981-05-12	1981-05-12 00:00:00	1981-05-26	1981-05-26 00:00:00	1981-05-26	38000177		0	0	14		0	0	0	42659	0	282464	1127078		
16802	1389	1118084	1997-07-12	1997-07-12 00:00:00	1997-07-12	1997-07-12 00:00:00	\N	38000177		0	0	0		0	0	0	92165	0	00025152531	44923712		
4117	340	19078461	2007-10-29	2007-10-29 00:00:00	2007-11-26	2007-11-26 00:00:00	2007-11-26	38000177		0	0	28		0	0	0	22741	0	310965	19078461		
10626	884	1115171	2011-12-29	2011-12-29 00:00:00	2012-02-04	2012-02-04 00:00:00	2012-02-04	38000177		0	0	37		0	0	0	58955	0	849574	1115171		
14658	1227	1127433	1974-12-25	1974-12-25 00:00:00	1975-01-08	1975-01-08 00:00:00	1975-01-08	38000177		0	0	14		0	0	0	80781	0	313782	1127433		
36284	2989	1115171	2002-05-24	2002-05-24 00:00:00	2002-06-28	2002-06-28 00:00:00	2002-06-28	38000177		0	0	35		0	0	0	199590	0	849574	1115171		
36302	2992	1127433	1995-03-19	1995-03-19 00:00:00	1995-03-26	1995-03-26 00:00:00	1995-03-26	38000177		0	0	7		0	0	0	199687	0	313782	1127433		
111918	2459	40213306	1998-08-31	1998-08-31 00:00:00	1998-08-31	1998-08-31 00:00:00	1998-08-31	581452		0	0	0		0	0	0	163027	0	43	40213306		
76739	1676	40213251	1984-08-10	1984-08-10 00:00:00	1984-08-10	1984-08-10 00:00:00	1984-08-10	581452		0	0	0		0	0	0	112473	0	21	40213251		
41901	3470	19059056	1971-10-28	1971-10-28 00:00:00	1971-11-11	1971-11-11 00:00:00	1971-11-11	38000177		0	0	14		0	0	0	230326	0	243670	19059056		
41759	3457	19059056	1930-12-01	1930-12-01 00:00:00	1930-12-15	1930-12-15 00:00:00	1930-12-15	38000177		0	0	14		0	0	0	229382	0	243670	19059056		
102073	2237	40213227	2009-12-27	2009-12-27 00:00:00	2009-12-27	2009-12-27 00:00:00	2009-12-27	581452		0	0	0		0	0	0	148785	0	113	40213227		
31979	2651	1127433	1956-04-11	1956-04-11 00:00:00	1956-04-25	1956-04-25 00:00:00	1956-04-25	38000177		0	0	14		0	0	0	175485	0	313782	1127433		
193601	4253	40213314	1981-03-30	1981-03-30 00:00:00	1981-03-30	1981-03-30 00:00:00	1981-03-30	581452		0	0	0		0	0	0	282452	0	49	40213314		
51420	4274	19133905	1986-01-06	1986-01-06 00:00:00	1986-01-16	1986-01-16 00:00:00	1986-01-16	38000177		0	0	10		0	0	0	283554	0	834102	19133905		
42803	3547	1127433	1987-02-16	1987-02-16 00:00:00	1987-02-23	1987-02-23 00:00:00	1987-02-23	38000177		0	0	7		0	0	0	235569	0	313782	1127433		
60340	5018	19078461	1976-03-30	1976-03-30 00:00:00	1976-06-28	1976-06-28 00:00:00	1976-06-28	38000177		0	0	90		0	0	0	333482	0	310965	19078461		
53127	4413	19129655	1962-07-01	1962-07-01 00:00:00	1962-07-15	1962-07-15 00:00:00	1962-07-15	38000177		0	0	14		0	0	0	293466	0	789980	19129655		
25932	2134	40220960	2017-04-02	2017-04-02 00:00:00	2017-04-02	2017-04-02 00:00:00	2017-04-02	38000177		0	0	0		0	0	0	141957	0	1804799	40220960		
2035	161	1713671	2000-02-28	2000-02-28 00:00:00	2000-03-06	2000-03-06 00:00:00	2000-03-06	38000177		0	0	7		0	0	0	11032	0	562251	1713671		
9533	795	40236824	1973-09-12	1973-09-12 00:00:00	1973-09-19	1973-09-19 00:00:00	1973-09-19	38000177		0	0	7		0	0	0	52707	0	1094107	40236824		
57627	1261	40213160	1970-10-24	1970-10-24 00:00:00	1970-10-24	1970-10-24 00:00:00	1970-10-24	581452		0	0	0		0	0	0	83146	0	10	40213160		
10038	213	40213296	2009-05-11	2009-05-11 00:00:00	2009-05-11	2009-05-11 00:00:00	2009-05-11	581452		0	0	0		0	0	0	14543	0	52	40213296		
35609	2935	19128065	1998-02-21	1998-02-21 00:00:00	1999-02-16	1999-02-16 00:00:00	1999-02-16	38000177		0	0	360		0	0	0	195718	0	749882	19128065		
62575	5203	19075601	1997-10-29	1997-10-29 00:00:00	1999-02-17	1999-02-17 00:00:00	1999-02-17	38000177		0	0	476		0	0	0	346098	0	309362	19075601		
22559	489	40213227	1998-03-15	1998-03-15 00:00:00	1998-03-15	1998-03-15 00:00:00	1998-03-15	581452		0	0	0		0	0	0	32775	0	113	40213227		
42088	3489	40236824	1990-11-25	1990-11-25 00:00:00	1990-12-02	1990-12-02 00:00:00	1990-12-02	38000177		0	0	7		0	0	0	231469	0	1094107	40236824		
138733	3048	40213296	2016-05-25	2016-05-25 00:00:00	2016-05-25	2016-05-25 00:00:00	2016-05-25	581452		0	0	0		0	0	0	202820	0	52	40213296		
1384	111	19129655	1978-01-05	1978-01-05 00:00:00	1978-01-19	1978-01-19 00:00:00	1978-01-19	38000177		0	0	14		0	0	0	7376	0	789980	19129655		
14578	1222	19133905	2017-08-10	2017-08-10 00:00:00	2017-08-22	2017-08-22 00:00:00	2017-08-22	38000177		0	0	12		0	0	0	80405	0	834102	19133905		
1566	123	19075601	2006-08-23	2006-08-23 00:00:00	2006-08-23	2006-08-23 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	309362	19075601		
1617	126	19006318	1951-04-24	1951-04-24 00:00:00	1951-05-08	1951-05-08 00:00:00	1951-05-08	38000177		0	0	14		0	0	0	8416	0	105078	19006318		
40217	3330	46233988	1975-04-30	1975-04-30 00:00:00	1975-05-14	1975-05-14 00:00:00	1975-05-14	38000177		0	0	14		0	0	0	220992	0	1652673	46233988		
8106	675	19006318	1951-04-19	1951-04-19 00:00:00	1951-05-03	1951-05-03 00:00:00	1951-05-03	38000177		0	0	14		0	0	0	44632	0	105078	19006318		
40329	3342	1127433	1995-09-17	1995-09-17 00:00:00	1995-10-01	1995-10-01 00:00:00	1995-10-01	38000177		0	0	14		0	0	0	221611	0	313782	1127433		
38609	3189	19078461	2015-10-11	2015-10-11 00:00:00	2015-12-10	2015-12-10 00:00:00	2015-12-10	38000177		0	0	60		0	0	0	212275	0	310965	19078461		
35820	2949	1713671	1962-03-31	1962-03-31 00:00:00	1962-04-21	1962-04-21 00:00:00	1962-04-21	38000177		0	0	21		0	0	0	196862	0	562251	1713671		
49182	4080	1713671	1981-02-14	1981-02-14 00:00:00	1981-03-07	1981-03-07 00:00:00	1981-03-07	38000177		0	0	21		0	0	0	271168	0	562251	1713671		
46387	3843	1127433	1978-02-21	1978-02-21 00:00:00	1978-03-07	1978-03-07 00:00:00	1978-03-07	38000177		0	0	14		0	0	0	255062	0	313782	1127433		
54228	4506	1127433	1964-09-20	1964-09-20 00:00:00	1964-10-04	1964-10-04 00:00:00	1964-10-04	38000177		0	0	14		0	0	0	300204	0	313782	1127433		
33398	2767	35605482	1939-05-24	1939-05-24 00:00:00	1939-05-24	1939-05-24 00:00:00	1939-05-24	38000177		0	0	0		0	0	0	183063	0	1740467	35605482		
33354	2764	19059056	1977-12-01	1977-12-01 00:00:00	1977-12-15	1977-12-15 00:00:00	1977-12-15	38000177		0	0	14		0	0	0	182784	0	243670	19059056		
36384	3000	19059056	1948-09-13	1948-09-13 00:00:00	1948-09-27	1948-09-27 00:00:00	1948-09-27	38000177		0	0	14		0	0	0	200154	0	243670	19059056		
57052	4735	1115171	1998-06-22	1998-06-22 00:00:00	1998-07-22	1998-07-22 00:00:00	1998-07-22	38000177		0	0	30		0	0	0	315453	0	849574	1115171		
28116	2326	1127433	1991-10-02	1991-10-02 00:00:00	1991-11-06	1991-11-06 00:00:00	1991-11-06	38000177		0	0	35		0	0	0	154721	0	313782	1127433		
26565	2186	1127078	1975-12-14	1975-12-14 00:00:00	1975-12-28	1975-12-28 00:00:00	1975-12-28	38000177		0	0	14		0	0	0	145840	0	282464	1127078		
52629	1151	40213314	1985-05-01	1985-05-01 00:00:00	1985-05-01	1985-05-01 00:00:00	1985-05-01	581452		0	0	0		0	0	0	76121	0	49	40213314		
21638	1779	1551192	1946-12-07	1946-12-07 00:00:00	1946-12-07	1946-12-07 00:00:00	1946-12-07	38000177		0	0	0		0	0	0	119063	0	312617	1551192		
21682	1781	1127433	2009-11-17	2009-11-17 00:00:00	2009-12-01	2009-12-01 00:00:00	2009-12-01	38000177		0	0	14		0	0	0	119208	0	313782	1127433		
64294	1407	40213160	1968-04-20	1968-04-20 00:00:00	1968-04-20	1968-04-20 00:00:00	1968-04-20	581452		0	0	0		0	0	0	93490	0	10	40213160		
6479	546	1118084	1981-05-28	1981-05-28 00:00:00	1981-05-28	1981-05-28 00:00:00	\N	38000177		0	0	0		0	0	0	36230	0	00025152531	44923712		
47729	3957	1127433	1978-08-31	1978-08-31 00:00:00	1978-09-07	1978-09-07 00:00:00	1978-09-07	38000177		0	0	7		0	0	0	263086	0	313782	1127433		
120399	2647	40213160	1971-03-21	1971-03-21 00:00:00	1971-03-21	1971-03-21 00:00:00	1971-03-21	581452		0	0	0		0	0	0	175169	0	10	40213160		
23505	1935	1127433	1978-03-22	1978-03-22 00:00:00	1978-04-21	1978-04-21 00:00:00	1978-04-21	38000177		0	0	30		0	0	0	128739	0	313782	1127433		
16358	1355	46233988	1967-07-22	1967-07-22 00:00:00	1967-08-05	1967-08-05 00:00:00	1967-08-05	38000177		0	0	14		0	0	0	89801	0	1652673	46233988		
920	74	19128022	1990-12-06	1990-12-06 00:00:00	1991-12-01	1991-12-01 00:00:00	1991-12-01	38000177		0	0	360		0	0	0	4971	0	749785	19128022		
41106	3409	1127433	2001-12-27	2001-12-27 00:00:00	2002-01-10	2002-01-10 00:00:00	2002-01-10	38000177		0	0	14		0	0	0	226074	0	313782	1127433		
41167	3413	1127433	1974-09-13	1974-09-13 00:00:00	1974-09-20	1974-09-20 00:00:00	1974-09-20	38000177		0	0	7		0	0	0	226418	0	313782	1127433		
58561	4861	1127433	2003-04-12	2003-04-12 00:00:00	2003-04-26	2003-04-26 00:00:00	2003-04-26	38000177		0	0	14		0	0	0	323384	0	313782	1127433		
31633	689	40213306	2005-09-11	2005-09-11 00:00:00	2005-09-11	2005-09-11 00:00:00	2005-09-11	581452		0	0	0		0	0	0	\N	0	43	40213306		
20411	1677	19059056	1971-03-17	1971-03-17 00:00:00	1971-03-31	1971-03-31 00:00:00	1971-03-31	38000177		0	0	14		0	0	0	112515	0	243670	19059056		
16720	1385	1118084	1999-12-20	1999-12-20 00:00:00	1999-12-20	1999-12-20 00:00:00	\N	38000177		0	0	0		0	0	0	91837	0	00025152531	44923712		
8868	741	1127078	1977-12-13	1977-12-13 00:00:00	1978-01-12	1978-01-12 00:00:00	1978-01-12	38000177		0	0	30		0	0	0	49040	0	282464	1127078		
15	1	1332419	2006-03-09	2006-03-09 00:00:00	2006-03-09	2006-03-09 00:00:00	\N	38000177		0	0	0		0	0	0	59	0	197361	1332419		
7660	644	19073183	1981-05-12	1981-05-12 00:00:00	1981-05-26	1981-05-26 00:00:00	1981-05-26	38000177		0	0	14		0	0	0	42659	0	308182	19073183		
16803	1389	1127433	1956-10-27	1956-10-27 00:00:00	1956-11-10	1956-11-10 00:00:00	1956-11-10	38000177		0	0	14		0	0	0	92148	0	313782	1127433		
4118	341	1127433	1990-06-06	1990-06-06 00:00:00	1990-06-13	1990-06-13 00:00:00	1990-06-13	38000177		0	0	7		0	0	0	22763	0	313782	1127433		
10627	884	1127433	1981-04-19	1981-04-19 00:00:00	1981-04-26	1981-04-26 00:00:00	1981-04-26	38000177		0	0	7		0	0	0	58939	0	313782	1127433		
14659	1227	19059056	1949-05-24	1949-05-24 00:00:00	1949-06-07	1949-06-07 00:00:00	1949-06-07	38000177		0	0	14		0	0	0	80817	0	243670	19059056		
36285	2989	1127433	1972-03-14	1972-03-14 00:00:00	1972-03-28	1972-03-28 00:00:00	1972-03-28	38000177		0	0	14		0	0	0	199575	0	313782	1127433		
36303	2992	19078461	2009-04-12	2009-04-12 00:00:00	2009-05-03	2009-05-03 00:00:00	2009-05-03	38000177		0	0	21		0	0	0	199767	0	310965	19078461		
111919	2459	40213227	1998-08-31	1998-08-31 00:00:00	1998-08-31	1998-08-31 00:00:00	1998-08-31	581452		0	0	0		0	0	0	163027	0	113	40213227		
76742	1676	40213160	1984-08-10	1984-08-10 00:00:00	1984-08-10	1984-08-10 00:00:00	1984-08-10	581452		0	0	0		0	0	0	112473	0	10	40213160		
41902	3470	1118084	1999-02-08	1999-02-08 00:00:00	1999-02-08	1999-02-08 00:00:00	\N	38000177		0	0	0		0	0	0	230342	0	00025152531	44923712		
41760	3457	19059056	1986-03-31	1986-03-31 00:00:00	1986-06-29	1986-06-29 00:00:00	1986-06-29	38000177		0	0	90		0	0	0	229385	0	243670	19059056		
102079	2238	40213306	1991-05-19	1991-05-19 00:00:00	1991-05-19	1991-05-19 00:00:00	1991-05-19	581452		0	0	0		0	0	0	148985	0	43	40213306		
31980	2651	19133905	2014-07-28	2014-07-28 00:00:00	2014-08-06	2014-08-06 00:00:00	2014-08-06	38000177		0	0	9		0	0	0	175432	0	834102	19133905		
165374	3636	40213296	2014-07-25	2014-07-25 00:00:00	2014-07-25	2014-07-25 00:00:00	2014-07-25	581452		0	0	0		0	0	0	241795	0	52	40213296		
51421	4274	40231925	1995-08-25	1995-08-25 00:00:00	1995-08-25	1995-08-25 00:00:00	\N	38000177		0	0	0		0	0	0	283560	0	1049221	40231925		
42804	3547	1115171	2018-01-23	2018-01-23 00:00:00	2018-02-13	2018-02-13 00:00:00	2018-02-13	38000177		0	0	21		0	0	0	235543	0	849574	1115171		
60341	5018	1127433	2009-08-27	2009-08-27 00:00:00	2009-09-03	2009-09-03 00:00:00	2009-09-03	38000177		0	0	7		0	0	0	333511	0	313782	1127433		
53128	4413	1127433	1976-08-07	1976-08-07 00:00:00	1976-09-06	1976-09-06 00:00:00	1976-09-06	38000177		0	0	30		0	0	0	293417	0	313782	1127433		
25933	2134	1713671	1959-08-26	1959-08-26 00:00:00	1959-09-16	1959-09-16 00:00:00	1959-09-16	38000177		0	0	21		0	0	0	141974	0	562251	1713671		
2036	161	19078461	2011-07-21	2011-07-21 00:00:00	2011-08-11	2011-08-11 00:00:00	2011-08-11	38000177		0	0	21		0	0	0	11058	0	310965	19078461		
9534	795	920300	1973-09-12	1973-09-12 00:00:00	1973-09-19	1973-09-19 00:00:00	1973-09-19	38000177		0	0	7		0	0	0	52707	0	311989	920300		
57637	1261	40213296	2013-11-23	2013-11-23 00:00:00	2013-11-23	2013-11-23 00:00:00	2013-11-23	581452		0	0	0		0	0	0	83135	0	52	40213296		
10040	213	40213227	1998-07-13	1998-07-13 00:00:00	1998-07-13	1998-07-13 00:00:00	1998-07-13	581452		0	0	0		0	0	0	14509	0	113	40213227		
35610	2935	1127078	1987-01-10	1987-01-10 00:00:00	1987-01-24	1987-01-24 00:00:00	1987-01-24	38000177		0	0	14		0	0	0	195679	0	282464	1127078		
62576	5203	1713671	1998-06-23	1998-06-23 00:00:00	1998-07-07	1998-07-07 00:00:00	1998-07-07	38000177		0	0	14		0	0	0	346083	0	562251	1713671		
22560	489	40213306	1998-03-15	1998-03-15 00:00:00	1998-03-15	1998-03-15 00:00:00	1998-03-15	581452		0	0	0		0	0	0	32775	0	43	40213306		
42089	3489	1127433	2012-10-28	2012-10-28 00:00:00	2012-11-11	2012-11-11 00:00:00	2012-11-11	38000177		0	0	14		0	0	0	231481	0	313782	1127433		
138735	3048	40213314	1977-10-19	1977-10-19 00:00:00	1977-10-19	1977-10-19 00:00:00	1977-10-19	581452		0	0	0		0	0	0	202802	0	49	40213314		
1385	111	1127078	1978-01-05	1978-01-05 00:00:00	1978-01-19	1978-01-19 00:00:00	1978-01-19	38000177		0	0	14		0	0	0	7376	0	282464	1127078		
14579	1222	1127433	1990-01-29	1990-01-29 00:00:00	1990-02-05	1990-02-05 00:00:00	1990-02-05	38000177		0	0	7		0	0	0	80371	0	313782	1127433		
1567	123	19059056	1962-07-08	1962-07-08 00:00:00	1962-09-13	1962-09-13 00:00:00	1962-09-13	38000177		0	0	67		0	0	0	8165	0	243670	19059056		
1618	126	19133873	1952-08-16	1952-08-16 00:00:00	1952-08-25	1952-08-25 00:00:00	1952-08-25	38000177		0	0	9		0	0	0	8408	0	834061	19133873		
40218	3330	1127078	1975-04-30	1975-04-30 00:00:00	1975-05-14	1975-05-14 00:00:00	1975-05-14	38000177		0	0	14		0	0	0	220992	0	282464	1127078		
8107	675	1127433	1950-08-06	1950-08-06 00:00:00	1950-08-20	1950-08-20 00:00:00	1950-08-20	38000177		0	0	14		0	0	0	44574	0	313782	1127433		
40330	3342	1713671	1936-12-22	1936-12-22 00:00:00	1937-01-12	1937-01-12 00:00:00	1937-01-12	38000177		0	0	21		0	0	0	221605	0	562251	1713671		
38610	3189	19128065	1981-06-02	1981-06-02 00:00:00	1982-05-28	1982-05-28 00:00:00	1982-05-28	38000177		0	0	360		0	0	0	212227	0	749882	19128065		
35821	2949	1115171	1995-12-03	1995-12-03 00:00:00	1995-12-31	1995-12-31 00:00:00	1995-12-31	38000177		0	0	28		0	0	0	196880	0	849574	1115171		
49183	4081	19059056	1965-03-20	1965-03-20 00:00:00	1965-04-19	1965-04-19 00:00:00	1965-04-19	38000177		0	0	30		0	0	0	271237	0	243670	19059056		
46388	3843	46233988	1972-02-21	1972-02-21 00:00:00	1972-03-06	1972-03-06 00:00:00	1972-03-06	38000177		0	0	14		0	0	0	255066	0	1652673	46233988		
54229	4506	1127433	1960-02-22	1960-02-22 00:00:00	1960-03-07	1960-03-07 00:00:00	1960-03-07	38000177		0	0	14		0	0	0	300169	0	313782	1127433		
33399	2767	35605858	1939-05-23	1939-05-23 00:00:00	1939-05-24	1939-05-24 00:00:00	1939-05-24	38000177		0	0	1		0	0	0	183063	0	1732136	35605858		
33355	2764	19129655	1977-12-01	1977-12-01 00:00:00	1977-12-15	1977-12-15 00:00:00	1977-12-15	38000177		0	0	14		0	0	0	182784	0	789980	19129655		
36385	3000	1127433	1976-10-28	1976-10-28 00:00:00	1976-12-02	1976-12-02 00:00:00	1976-12-02	38000177		0	0	35		0	0	0	200180	0	313782	1127433		
57053	4735	40165015	1998-06-22	1998-06-22 00:00:00	1998-06-22	1998-06-22 00:00:00	\N	38000177		0	0	0		0	0	0	315453	0	861467	40165015		
28117	2326	1127078	1952-10-30	1952-10-30 00:00:00	1952-11-13	1952-11-13 00:00:00	1952-11-13	38000177		0	0	14		0	0	0	154664	0	282464	1127078		
26566	2186	46233988	1975-12-14	1975-12-14 00:00:00	1975-12-28	1975-12-28 00:00:00	1975-12-28	38000177		0	0	14		0	0	0	145840	0	1652673	46233988		
52630	1151	40213160	1985-05-01	1985-05-01 00:00:00	1985-05-01	1985-05-01 00:00:00	1985-05-01	581452		0	0	0		0	0	0	76121	0	10	40213160		
21639	1779	1127433	1956-03-31	1956-03-31 00:00:00	1956-04-07	1956-04-07 00:00:00	1956-04-07	38000177		0	0	7		0	0	0	119043	0	313782	1127433		
21683	1781	1713671	1950-01-30	1950-01-30 00:00:00	1950-02-06	1950-02-06 00:00:00	1950-02-06	38000177		0	0	7		0	0	0	119195	0	562251	1713671		
64300	1407	40213160	1972-10-21	1972-10-21 00:00:00	1972-10-21	1972-10-21 00:00:00	1972-10-21	581452		0	0	0		0	0	0	93493	0	10	40213160		
6480	546	920300	1982-11-30	1982-11-30 00:00:00	1982-12-07	1982-12-07 00:00:00	1982-12-07	38000177		0	0	7		0	0	0	36196	0	311989	920300		
47730	3957	1713671	1966-10-01	1966-10-01 00:00:00	1966-10-08	1966-10-08 00:00:00	1966-10-08	38000177		0	0	7		0	0	0	263136	0	562251	1713671		
120402	2647	40213227	1993-02-21	1993-02-21 00:00:00	1993-02-21	1993-02-21 00:00:00	1993-02-21	581452		0	0	0		0	0	0	175178	0	113	40213227		
23507	1935	1127433	1993-01-23	1993-01-23 00:00:00	1993-01-30	1993-01-30 00:00:00	1993-01-30	38000177		0	0	7		0	0	0	128712	0	313782	1127433		
16359	1355	1127078	1967-07-22	1967-07-22 00:00:00	1967-08-05	1967-08-05 00:00:00	1967-08-05	38000177		0	0	14		0	0	0	89801	0	282464	1127078		
921	74	1127433	2012-07-01	2012-07-01 00:00:00	2012-07-15	2012-07-15 00:00:00	2012-07-15	38000177		0	0	14		0	0	0	4990	0	313782	1127433		
41107	3409	1127433	1968-05-06	1968-05-06 00:00:00	1968-05-20	1968-05-20 00:00:00	1968-05-20	38000177		0	0	14		0	0	0	226126	0	313782	1127433		
41168	3413	1115171	2007-04-22	2007-04-22 00:00:00	2007-05-22	2007-05-22 00:00:00	2007-05-22	38000177		0	0	30		0	0	0	226403	0	849574	1115171		
58562	4861	19133905	1985-04-21	1985-04-21 00:00:00	1985-04-29	1985-04-29 00:00:00	1985-04-29	38000177		0	0	8		0	0	0	323423	0	834102	19133905		
31637	689	40213227	2013-04-14	2013-04-14 00:00:00	2013-04-14	2013-04-14 00:00:00	2013-04-14	581452		0	0	0		0	0	0	45689	0	113	40213227		
20412	1677	1127078	1974-01-17	1974-01-17 00:00:00	1974-01-31	1974-01-31 00:00:00	1974-01-31	38000177		0	0	14		0	0	0	112489	0	282464	1127078		
16721	1385	19059056	1962-07-02	1962-07-02 00:00:00	1962-07-16	1962-07-16 00:00:00	1962-07-16	38000177		0	0	14		0	0	0	91821	0	243670	19059056		
51105	4246	1127433	2005-08-14	2005-08-14 00:00:00	2005-08-28	2005-08-28 00:00:00	2005-08-28	38000177		0	0	14		0	0	0	281922	0	313782	1127433		
16	1	1539411	2006-03-09	2006-03-09 00:00:00	2006-03-09	2006-03-09 00:00:00	\N	38000177		0	0	0		0	0	0	59	0	312961	1539411		
42409	3516	1127433	1966-03-08	1966-03-08 00:00:00	1966-04-05	1966-04-05 00:00:00	1966-04-05	38000177		0	0	28		0	0	0	233366	0	313782	1127433		
16804	1389	19133905	2012-03-28	2012-03-28 00:00:00	2012-04-04	2012-04-04 00:00:00	2012-04-04	38000177		0	0	7		0	0	0	92222	0	834102	19133905		
4119	341	1127433	1989-04-10	1989-04-10 00:00:00	1989-05-01	1989-05-01 00:00:00	1989-05-01	38000177		0	0	21		0	0	0	22742	0	313782	1127433		
10628	884	1127433	2007-02-25	2007-02-25 00:00:00	2007-05-26	2007-05-26 00:00:00	2007-05-26	38000177		0	0	90		0	0	0	58953	0	313782	1127433		
14660	1227	1115171	2004-05-22	2004-05-22 00:00:00	2004-07-21	2004-07-21 00:00:00	2004-07-21	38000177		0	0	60		0	0	0	80823	0	849574	1115171		
36286	2989	1124300	1998-02-27	1998-02-27 00:00:00	1998-02-27	1998-02-27 00:00:00	\N	38000177		0	0	0		0	0	0	199524	0	00781178901	45011828		
36304	2992	40220960	2011-08-19	2011-08-19 00:00:00	2011-08-19	2011-08-19 00:00:00	2011-08-19	38000177		0	0	0		0	0	0	199719	0	1804799	40220960		
111926	2459	40213296	2017-10-16	2017-10-16 00:00:00	2017-10-16	2017-10-16 00:00:00	2017-10-16	581452		0	0	0		0	0	0	163014	0	52	40213296		
76754	1676	40213227	2002-11-08	2002-11-08 00:00:00	2002-11-08	2002-11-08 00:00:00	2002-11-08	581452		0	0	0		0	0	0	112465	0	113	40213227		
41903	3470	1127433	1991-10-18	1991-10-18 00:00:00	1991-11-08	1991-11-08 00:00:00	1991-11-08	38000177		0	0	21		0	0	0	230328	0	313782	1127433		
41761	3457	1127433	1987-09-25	1987-09-25 00:00:00	1987-10-09	1987-10-09 00:00:00	1987-10-09	38000177		0	0	14		0	0	0	229334	0	313782	1127433		
102083	2238	40213296	2008-08-10	2008-08-10 00:00:00	2008-08-10	2008-08-10 00:00:00	2008-08-10	581452		0	0	0		0	0	0	148915	0	52	40213296		
31981	2651	19059056	1957-06-27	1957-06-27 00:00:00	1957-07-25	1957-07-25 00:00:00	1957-07-25	38000177		0	0	28		0	0	0	175418	0	243670	19059056		
165375	3636	40213306	1993-12-03	1993-12-03 00:00:00	1993-12-03	1993-12-03 00:00:00	1993-12-03	581452		0	0	0		0	0	0	241824	0	43	40213306		
51422	4274	19078461	1995-08-25	1995-08-25 00:00:00	1995-11-23	1995-11-23 00:00:00	1995-11-23	38000177		0	0	90		0	0	0	283560	0	310965	19078461		
42805	3547	1127433	2004-07-04	2004-07-04 00:00:00	2004-07-18	2004-07-18 00:00:00	2004-07-18	38000177		0	0	14		0	0	0	235570	0	313782	1127433		
60342	5018	1127433	1979-03-13	1979-03-13 00:00:00	1979-03-27	1979-03-27 00:00:00	1979-03-27	38000177		0	0	14		0	0	0	333543	0	313782	1127433		
53129	4413	40231925	1976-08-07	1976-08-07 00:00:00	1976-08-07	1976-08-07 00:00:00	\N	38000177		0	0	0		0	0	0	293417	0	1049221	40231925		
25934	2134	1127433	1978-08-21	1978-08-21 00:00:00	1978-09-04	1978-09-04 00:00:00	1978-09-04	38000177		0	0	14		0	0	0	142002	0	313782	1127433		
2037	161	1713671	2018-06-18	2018-06-18 00:00:00	2018-07-09	2018-07-09 00:00:00	2018-07-09	38000177		0	0	21		0	0	0	11062	0	562251	1713671		
9535	795	1127433	1980-06-21	1980-06-21 00:00:00	1980-06-28	1980-06-28 00:00:00	1980-06-28	38000177		0	0	7		0	0	0	52752	0	313782	1127433		
68922	1508	40213227	1995-02-07	1995-02-07 00:00:00	1995-02-07	1995-02-07 00:00:00	1995-02-07	581452		0	0	0		0	0	0	100526	0	113	40213227		
10046	213	40213296	2007-05-07	2007-05-07 00:00:00	2007-05-07	2007-05-07 00:00:00	2007-05-07	581452		0	0	0		0	0	0	14521	0	52	40213296		
35611	2935	19078461	2018-06-08	2018-06-08 00:00:00	2018-06-22	2018-06-22 00:00:00	2018-06-22	38000177		0	0	14		0	0	0	195682	0	310965	19078461		
20175	1657	19059056	1949-09-19	1949-09-19 00:00:00	1949-10-03	1949-10-03 00:00:00	1949-10-03	38000177		0	0	14		0	0	0	111250	0	243670	19059056		
22565	489	40213160	1976-02-08	1976-02-08 00:00:00	1976-02-08	1976-02-08 00:00:00	1976-02-08	581452		0	0	0		0	0	0	32711	0	10	40213160		
42090	3489	1127433	1985-01-25	1985-01-25 00:00:00	1985-02-08	1985-02-08 00:00:00	1985-02-08	38000177		0	0	14		0	0	0	231447	0	313782	1127433		
138738	3048	40213314	1977-04-20	1977-04-20 00:00:00	1977-04-20	1977-04-20 00:00:00	1977-04-20	581452		0	0	0		0	0	0	202816	0	49	40213314		
1386	111	1115171	2018-08-28	2018-08-28 00:00:00	2018-09-18	2018-09-18 00:00:00	2018-09-18	38000177		0	0	21		0	0	0	7418	0	849574	1115171		
14580	1222	1118084	1995-10-30	1995-10-30 00:00:00	1995-10-30	1995-10-30 00:00:00	\N	38000177		0	0	0		0	0	0	80383	0	00025152531	44923712		
1568	123	40162522	1962-07-15	1962-07-15 00:00:00	1962-07-15	1962-07-15 00:00:00	\N	38000177		0	0	0		0	0	0	8166	0	857005	40162522		
1619	126	1713671	1976-04-29	1976-04-29 00:00:00	1976-05-06	1976-05-06 00:00:00	1976-05-06	38000177		0	0	7		0	0	0	8411	0	562251	1713671		
40219	3330	19128022	1994-08-28	1994-08-28 00:00:00	1995-08-23	1995-08-23 00:00:00	1995-08-23	38000177		0	0	360		0	0	0	220959	0	749785	19128022		
8108	675	1127433	1968-04-19	1968-04-19 00:00:00	1968-04-26	1968-04-26 00:00:00	1968-04-26	38000177		0	0	7		0	0	0	44724	0	313782	1127433		
40331	3342	19059056	1968-07-14	1968-07-14 00:00:00	1968-07-28	1968-07-28 00:00:00	1968-07-28	38000177		0	0	14		0	0	0	221566	0	243670	19059056		
38611	3189	19128065	1986-05-07	1986-05-07 00:00:00	1987-05-02	1987-05-02 00:00:00	1987-05-02	38000177		0	0	360		0	0	0	212230	0	749882	19128065		
35822	2950	1127433	1999-04-05	1999-04-05 00:00:00	1999-04-26	1999-04-26 00:00:00	1999-04-26	38000177		0	0	21		0	0	0	196940	0	313782	1127433		
49184	4081	1127433	2007-08-07	2007-08-07 00:00:00	2007-09-11	2007-09-11 00:00:00	2007-09-11	38000177		0	0	35		0	0	0	271238	0	313782	1127433		
46389	3843	1127078	1972-02-21	1972-02-21 00:00:00	1972-03-06	1972-03-06 00:00:00	1972-03-06	38000177		0	0	14		0	0	0	255066	0	282464	1127078		
54230	4506	1127078	1959-01-27	1959-01-27 00:00:00	1959-02-10	1959-02-10 00:00:00	1959-02-10	38000177		0	0	14		0	0	0	300211	0	282464	1127078		
33400	2767	42707627	1939-05-24	1939-05-24 00:00:00	1939-05-24	1939-05-24 00:00:00	1939-05-24	38000177		0	0	0		0	0	0	183063	0	1234995	42707627		
33356	2764	40224805	1992-07-25	1992-07-25 00:00:00	1993-07-20	1993-07-20 00:00:00	1993-07-20	38000177		0	0	360		0	0	0	182786	0	1000126	40224805		
36386	3000	1713671	1977-12-03	1977-12-03 00:00:00	1977-12-17	1977-12-17 00:00:00	1977-12-17	38000177		0	0	14		0	0	0	200231	0	562251	1713671		
57054	4735	19078461	2014-05-29	2014-05-29 00:00:00	2014-06-12	2014-06-12 00:00:00	2014-06-12	38000177		0	0	14		0	0	0	315430	0	310965	19078461		
28118	2326	19006318	1952-10-30	1952-10-30 00:00:00	1952-11-13	1952-11-13 00:00:00	1952-11-13	38000177		0	0	14		0	0	0	154664	0	105078	19006318		
26567	2186	1127078	1974-06-03	1974-06-03 00:00:00	1974-06-17	1974-06-17 00:00:00	1974-06-17	38000177		0	0	14		0	0	0	145839	0	282464	1127078		
52634	1151	40213160	1985-07-31	1985-07-31 00:00:00	1985-07-31	1985-07-31 00:00:00	1985-07-31	581452		0	0	0		0	0	0	76093	0	10	40213160		
21640	1779	1127078	1953-02-01	1953-02-01 00:00:00	1953-05-02	1953-05-02 00:00:00	1953-05-02	38000177		0	0	90		0	0	0	119065	0	282464	1127078		
21684	1781	40229134	1966-02-09	1966-02-09 00:00:00	1966-02-23	1966-02-23 00:00:00	1966-02-23	38000177		0	0	14		0	0	0	119257	0	1043400	40229134		
64303	1407	40213306	1990-01-13	1990-01-13 00:00:00	1990-01-13	1990-01-13 00:00:00	1990-01-13	581452		0	0	0		0	0	0	93503	0	43	40213306		
6481	546	40236824	1982-11-30	1982-11-30 00:00:00	1982-12-07	1982-12-07 00:00:00	1982-12-07	38000177		0	0	7		0	0	0	36196	0	1094107	40236824		
47732	3957	19059056	1964-05-07	1964-05-07 00:00:00	1964-08-05	1964-08-05 00:00:00	1964-08-05	38000177		0	0	90		0	0	0	263144	0	243670	19059056		
120403	2647	40213306	1993-02-21	1993-02-21 00:00:00	1993-02-21	1993-02-21 00:00:00	1993-02-21	581452		0	0	0		0	0	0	175178	0	43	40213306		
23508	1935	40229134	2004-05-04	2004-05-04 00:00:00	2004-05-18	2004-05-18 00:00:00	2004-05-18	38000177		0	0	14		0	0	0	128713	0	1043400	40229134		
16360	1355	1127433	1968-02-25	1968-02-25 00:00:00	1968-03-03	1968-03-03 00:00:00	1968-03-03	38000177		0	0	7		0	0	0	89838	0	313782	1127433		
922	74	19075001	2017-08-20	2017-08-20 00:00:00	2017-09-03	2017-09-03 00:00:00	2017-09-03	38000177		0	0	14		0	0	0	4993	0	309097	19075001		
41108	3409	46233710	1968-05-06	1968-05-06 00:00:00	1968-05-20	1968-05-20 00:00:00	1968-05-20	38000177		0	0	14		0	0	0	226126	0	1650142	46233710		
51628	4289	19133905	2001-06-24	2001-06-24 00:00:00	2001-07-05	2001-07-05 00:00:00	2001-07-05	38000177		0	0	11		0	0	0	284747	0	834102	19133905		
58563	4861	40173590	2007-05-22	2007-05-22 00:00:00	2007-05-22	2007-05-22 00:00:00	\N	38000177		0	0	0		0	0	0	323399	0	904419	40173590		
31642	689	40213160	1982-08-01	1982-08-01 00:00:00	1982-08-01	1982-08-01 00:00:00	1982-08-01	581452		0	0	0		0	0	0	45656	0	10	40213160		
20413	1677	19133873	1985-06-02	1985-06-02 00:00:00	1985-06-10	1985-06-10 00:00:00	1985-06-10	38000177		0	0	8		0	0	0	112526	0	834061	19133873		
16722	1385	19006318	1962-07-02	1962-07-02 00:00:00	1962-07-16	1962-07-16 00:00:00	1962-07-16	38000177		0	0	14		0	0	0	91821	0	105078	19006318		
51106	4246	19059056	1972-04-30	1972-04-30 00:00:00	1972-05-14	1972-05-14 00:00:00	1972-05-14	38000177		0	0	14		0	0	0	281923	0	243670	19059056		
17	1	1127433	1976-10-20	1976-10-20 00:00:00	1976-11-03	1976-11-03 00:00:00	1976-11-03	38000177		0	0	14		0	0	0	1	0	313782	1127433		
42410	3516	40229134	1949-01-07	1949-01-07 00:00:00	1949-01-21	1949-01-21 00:00:00	1949-01-21	38000177		0	0	14		0	0	0	233312	0	1043400	40229134		
16805	1389	1127433	1972-08-15	1972-08-15 00:00:00	1972-08-22	1972-08-22 00:00:00	1972-08-22	38000177		0	0	7		0	0	0	92151	0	313782	1127433		
4120	341	1713671	1969-02-03	1969-02-03 00:00:00	1969-02-17	1969-02-17 00:00:00	1969-02-17	38000177		0	0	14		0	0	0	22753	0	562251	1713671		
10629	884	40231925	2007-02-25	2007-02-25 00:00:00	2007-02-25	2007-02-25 00:00:00	\N	38000177		0	0	0		0	0	0	58953	0	1049221	40231925		
14661	1228	1713671	2000-03-26	2000-03-26 00:00:00	2000-04-16	2000-04-16 00:00:00	2000-04-16	38000177		0	0	21		0	0	0	80925	0	562251	1713671		
36292	2991	1127433	1996-04-14	1996-04-14 00:00:00	1996-04-21	1996-04-21 00:00:00	1996-04-21	38000177		0	0	7		0	0	0	199632	0	313782	1127433		
36305	2992	19075601	2011-08-19	2011-08-19 00:00:00	2011-08-19	2011-08-19 00:00:00	2011-08-19	38000177		0	0	0		0	0	0	199719	0	309362	19075601		
111928	2459	40213227	2017-10-16	2017-10-16 00:00:00	2017-10-16	2017-10-16 00:00:00	2017-10-16	581452		0	0	0		0	0	0	163014	0	113	40213227		
76755	1676	40213306	2002-11-08	2002-11-08 00:00:00	2002-11-08	2002-11-08 00:00:00	2002-11-08	581452		0	0	0		0	0	0	112465	0	43	40213306		
41904	3470	1127433	2009-03-29	2009-03-29 00:00:00	2009-04-05	2009-04-05 00:00:00	2009-04-05	38000177		0	0	7		0	0	0	230345	0	313782	1127433		
41762	3457	19073188	1987-09-25	1987-09-25 00:00:00	1987-10-09	1987-10-09 00:00:00	1987-10-09	38000177		0	0	14		0	0	0	229334	0	308192	19073188		
102087	2238	40213160	1969-01-12	1969-01-12 00:00:00	1969-01-12	1969-01-12 00:00:00	1969-01-12	581452		0	0	0		0	0	0	148971	0	10	40213160		
31982	2651	1127433	1972-11-03	1972-11-03 00:00:00	1972-11-17	1972-11-17 00:00:00	1972-11-17	38000177		0	0	14		0	0	0	175420	0	313782	1127433		
165377	3636	40213227	2005-08-05	2005-08-05 00:00:00	2005-08-05	2005-08-05 00:00:00	2005-08-05	581452		0	0	0		0	0	0	241821	0	113	40213227		
51423	4274	19133873	1930-03-10	1930-03-10 00:00:00	1930-03-23	1930-03-23 00:00:00	1930-03-23	38000177		0	0	13		0	0	0	283661	0	834061	19133873		
42806	3547	46233988	1972-10-30	1972-10-30 00:00:00	1972-11-13	1972-11-13 00:00:00	1972-11-13	38000177		0	0	14		0	0	0	235586	0	1652673	46233988		
60343	5018	1127433	1959-08-01	1959-08-01 00:00:00	1959-09-05	1959-09-05 00:00:00	1959-09-05	38000177		0	0	35		0	0	0	333480	0	313782	1127433		
53130	4413	19133873	1966-06-04	1966-06-04 00:00:00	1966-06-17	1966-06-17 00:00:00	1966-06-17	38000177		0	0	13		0	0	0	293454	0	834061	19133873		
25935	2134	1127433	1997-02-08	1997-02-08 00:00:00	1997-02-22	1997-02-22 00:00:00	1997-02-22	38000177		0	0	14		0	0	0	142003	0	313782	1127433		
2038	161	1127433	2018-07-03	2018-07-03 00:00:00	2018-07-17	2018-07-17 00:00:00	2018-07-17	38000177		0	0	14		0	0	0	11061	0	313782	1127433		
9536	795	19059056	1946-07-28	1946-07-28 00:00:00	1946-08-18	1946-08-18 00:00:00	1946-08-18	38000177		0	0	21		0	0	0	52731	0	243670	19059056		
68938	1508	40213227	2005-02-22	2005-02-22 00:00:00	2005-02-22	2005-02-22 00:00:00	2005-02-22	581452		0	0	0		0	0	0	100552	0	113	40213227		
28849	2384	1115171	1998-08-06	1998-08-06 00:00:00	1998-08-20	1998-08-20 00:00:00	1998-08-20	38000177		0	0	14		0	0	0	158496	0	849574	1115171		
35612	2935	1127078	1978-06-26	1978-06-26 00:00:00	1978-07-10	1978-07-10 00:00:00	1978-07-10	38000177		0	0	14		0	0	0	195728	0	282464	1127078		
20176	1657	19006318	1949-09-19	1949-09-19 00:00:00	1949-10-03	1949-10-03 00:00:00	1949-10-03	38000177		0	0	14		0	0	0	111250	0	105078	19006318		
22568	489	40213296	2017-07-16	2017-07-16 00:00:00	2017-07-16	2017-07-16 00:00:00	2017-07-16	581452		0	0	0		0	0	0	32780	0	52	40213296		
42091	3489	1713671	1998-05-30	1998-05-30 00:00:00	1998-06-20	1998-06-20 00:00:00	1998-06-20	38000177		0	0	21		0	0	0	231473	0	562251	1713671		
138743	3048	40213314	1978-04-19	1978-04-19 00:00:00	1978-04-19	1978-04-19 00:00:00	1978-04-19	581452		0	0	0		0	0	0	202824	0	49	40213314		
1387	111	1127078	1981-01-30	1981-01-30 00:00:00	1981-02-13	1981-02-13 00:00:00	1981-02-13	38000177		0	0	14		0	0	0	7417	0	282464	1127078		
14581	1222	1713671	1957-04-21	1957-04-21 00:00:00	1957-05-12	1957-05-12 00:00:00	1957-05-12	38000177		0	0	21		0	0	0	80360	0	562251	1713671		
1569	123	1127433	1972-02-13	1972-02-13 00:00:00	1972-02-20	1972-02-20 00:00:00	1972-02-20	38000177		0	0	7		0	0	0	8122	0	313782	1127433		
12318	1036	19128065	1984-08-27	1984-08-27 00:00:00	1985-08-22	1985-08-22 00:00:00	1985-08-22	38000177		0	0	360		0	0	0	68232	0	749882	19128065		
40220	3330	19128065	1991-09-13	1991-09-13 00:00:00	1992-09-07	1992-09-07 00:00:00	1992-09-07	38000177		0	0	360		0	0	0	220994	0	749882	19128065		
8121	677	19078461	1982-01-23	1982-01-23 00:00:00	1982-02-13	1982-02-13 00:00:00	1982-02-13	38000177		0	0	21		0	0	0	44812	0	310965	19078461		
40332	3342	1127433	1981-07-20	1981-07-20 00:00:00	1981-09-18	1981-09-18 00:00:00	1981-09-18	38000177		0	0	60		0	0	0	221568	0	313782	1127433		
38613	3189	19059056	1973-01-05	1973-01-05 00:00:00	1973-01-26	1973-01-26 00:00:00	1973-01-26	38000177		0	0	21		0	0	0	212270	0	243670	19059056		
35823	2950	19077572	2011-10-03	2011-10-03 00:00:00	2011-10-03	2011-10-03 00:00:00	\N	38000177		0	0	0		0	0	0	196910	0	310436	19077572		
49185	4081	1713671	2013-11-18	2013-11-18 00:00:00	2013-12-09	2013-12-09 00:00:00	2013-12-09	38000177		0	0	21		0	0	0	271249	0	562251	1713671		
46390	3843	1127078	1979-06-14	1979-06-14 00:00:00	1979-07-19	1979-07-19 00:00:00	1979-07-19	38000177		0	0	35		0	0	0	255095	0	282464	1127078		
54231	4506	19006318	1959-01-27	1959-01-27 00:00:00	1959-02-10	1959-02-10 00:00:00	1959-02-10	38000177		0	0	14		0	0	0	300211	0	105078	19006318		
33401	2767	46275444	1939-05-24	1939-05-24 00:00:00	1939-05-24	1939-05-24 00:00:00	1939-05-24	38000177		0	0	0		0	0	0	183063	0	1659149	46275444		
33357	2764	19128065	1994-07-25	1994-07-25 00:00:00	1995-07-20	1995-07-20 00:00:00	1995-07-20	38000177		0	0	360		0	0	0	182807	0	749882	19128065		
36387	3000	19078461	1996-11-08	1996-11-08 00:00:00	1996-11-29	1996-11-29 00:00:00	1996-11-29	38000177		0	0	21		0	0	0	200182	0	310965	19078461		
57055	4735	19133873	1985-08-01	1985-08-01 00:00:00	1985-08-09	1985-08-09 00:00:00	1985-08-09	38000177		0	0	8		0	0	0	315414	0	834061	19133873		
28119	2326	1115171	2000-12-04	2000-12-04 00:00:00	2000-12-18	2000-12-18 00:00:00	2000-12-18	38000177		0	0	14		0	0	0	154649	0	849574	1115171		
26568	2186	46233988	1974-06-03	1974-06-03 00:00:00	1974-06-17	1974-06-17 00:00:00	1974-06-17	38000177		0	0	14		0	0	0	145839	0	1652673	46233988		
52637	1151	40213251	1989-10-31	1989-10-31 00:00:00	1989-10-31	1989-10-31 00:00:00	1989-10-31	581452		0	0	0		0	0	0	76134	0	21	40213251		
21641	1779	1127433	1988-02-12	1988-02-12 00:00:00	1988-03-04	1988-03-04 00:00:00	1988-03-04	38000177		0	0	21		0	0	0	119007	0	313782	1127433		
21685	1781	40229134	1961-01-27	1961-01-27 00:00:00	1961-02-03	1961-02-03 00:00:00	1961-02-03	38000177		0	0	7		0	0	0	119204	0	1043400	40229134		
64308	1407	40213227	1999-01-23	1999-01-23 00:00:00	1999-01-23	1999-01-23 00:00:00	1999-01-23	581452		0	0	0		0	0	0	93516	0	113	40213227		
6482	546	40229134	2004-01-21	2004-01-21 00:00:00	2004-01-28	2004-01-28 00:00:00	2004-01-28	38000177		0	0	7		0	0	0	36245	0	1043400	40229134		
47733	3957	1127433	2006-08-22	2006-08-22 00:00:00	2006-09-05	2006-09-05 00:00:00	2006-09-05	38000177		0	0	14		0	0	0	263088	0	313782	1127433		
120407	2647	40213160	1971-05-23	1971-05-23 00:00:00	1971-05-23	1971-05-23 00:00:00	1971-05-23	581452		0	0	0		0	0	0	175205	0	10	40213160		
23509	1935	19128065	1981-01-15	1981-01-15 00:00:00	1982-01-10	1982-01-10 00:00:00	1982-01-10	38000177		0	0	360		0	0	0	128687	0	749882	19128065		
16361	1355	19133905	1987-07-02	1987-07-02 00:00:00	1987-07-09	1987-07-09 00:00:00	1987-07-09	38000177		0	0	7		0	0	0	89778	0	834102	19133905		
923	74	1127433	2017-08-20	2017-08-20 00:00:00	2017-09-03	2017-09-03 00:00:00	2017-09-03	38000177		0	0	14		0	0	0	4993	0	313782	1127433		
41109	3409	19133873	1955-12-27	1955-12-27 00:00:00	1956-01-06	1956-01-06 00:00:00	1956-01-06	38000177		0	0	10		0	0	0	226125	0	834061	19133873		
51629	4289	19133905	2016-09-24	2016-09-24 00:00:00	2016-10-07	2016-10-07 00:00:00	2016-10-07	38000177		0	0	13		0	0	0	284798	0	834102	19133905		
58564	4861	1713671	1955-07-24	1955-07-24 00:00:00	1955-09-11	1955-09-11 00:00:00	1955-09-11	38000177		0	0	49		0	0	0	323381	0	562251	1713671		
31643	689	40213314	1982-08-01	1982-08-01 00:00:00	1982-08-01	1982-08-01 00:00:00	1982-08-01	581452		0	0	0		0	0	0	45656	0	49	40213314		
20414	1677	1115171	2018-08-08	2018-08-08 00:00:00	2018-08-22	2018-08-22 00:00:00	2018-08-22	38000177		0	0	14		0	0	0	112490	0	849574	1115171		
16723	1385	1127433	1997-05-17	1997-05-17 00:00:00	1997-05-24	1997-05-24 00:00:00	1997-05-24	38000177		0	0	7		0	0	0	91811	0	313782	1127433		
51107	4246	46233988	1972-04-30	1972-04-30 00:00:00	1972-05-14	1972-05-14 00:00:00	1972-05-14	38000177		0	0	14		0	0	0	281923	0	1652673	46233988		
18	1	1127433	1980-03-15	1980-03-15 00:00:00	1980-03-29	1980-03-29 00:00:00	1980-03-29	38000177		0	0	14		0	0	0	3	0	313782	1127433		
42411	3516	40231925	1981-12-12	1981-12-12 00:00:00	1981-12-12	1981-12-12 00:00:00	\N	38000177		0	0	0		0	0	0	233367	0	1049221	40231925		
16806	1389	19133873	1967-06-01	1967-06-01 00:00:00	1967-06-10	1967-06-10 00:00:00	1967-06-10	38000177		0	0	9		0	0	0	92150	0	834061	19133873		
4121	341	19059056	1963-03-28	1963-03-28 00:00:00	1963-04-11	1963-04-11 00:00:00	1963-04-11	38000177		0	0	14		0	0	0	22787	0	243670	19059056		
10630	884	19112599	1978-11-13	1978-11-13 00:00:00	1978-11-13	1978-11-13 00:00:00	\N	38000177		0	0	0		0	0	0	58857	0	477045	19112599		
14662	1228	40236824	2016-09-01	2016-09-01 00:00:00	2016-09-08	2016-09-08 00:00:00	2016-09-08	38000177		0	0	7		0	0	0	80919	0	1094107	40236824		
36293	2991	19078461	1984-04-27	1984-04-27 00:00:00	1984-05-11	1984-05-11 00:00:00	1984-05-11	38000177		0	0	14		0	0	0	199628	0	310965	19078461		
36306	2992	1713671	2008-08-15	2008-08-15 00:00:00	2008-08-29	2008-08-29 00:00:00	2008-08-29	38000177		0	0	14		0	0	0	199744	0	562251	1713671		
111929	2459	40213160	1981-06-01	1981-06-01 00:00:00	1981-06-01	1981-06-01 00:00:00	1981-06-01	581452		0	0	0		0	0	0	163012	0	10	40213160		
76759	1676	40213227	2011-11-18	2011-11-18 00:00:00	2011-11-18	2011-11-18 00:00:00	2011-11-18	581452		0	0	0		0	0	0	112468	0	113	40213227		
41905	3470	19133873	1962-06-19	1962-06-19 00:00:00	1962-06-28	1962-06-28 00:00:00	1962-06-28	38000177		0	0	9		0	0	0	230301	0	834061	19133873		
41763	3457	19059056	1921-04-08	1921-04-08 00:00:00	1921-04-22	1921-04-22 00:00:00	1921-04-22	38000177		0	0	14		0	0	0	229423	0	243670	19059056		
102093	2238	40213160	1969-04-13	1969-04-13 00:00:00	1969-04-13	1969-04-13 00:00:00	1969-04-13	581452		0	0	0		0	0	0	148908	0	10	40213160		
31983	2651	40229134	1963-09-17	1963-09-17 00:00:00	1963-09-24	1963-09-24 00:00:00	1963-09-24	38000177		0	0	7		0	0	0	175486	0	1043400	40229134		
165380	3636	40213296	2012-07-20	2012-07-20 00:00:00	2012-07-20	2012-07-20 00:00:00	2012-07-20	581452		0	0	0		0	0	0	241830	0	52	40213296		
51424	4274	1127433	1938-04-27	1938-04-27 00:00:00	1938-05-11	1938-05-11 00:00:00	1938-05-11	38000177		0	0	14		0	0	0	283633	0	313782	1127433		
42807	3547	19059056	1972-10-30	1972-10-30 00:00:00	1972-11-13	1972-11-13 00:00:00	1972-11-13	38000177		0	0	14		0	0	0	235586	0	243670	19059056		
60344	5018	1127433	1963-05-07	1963-05-07 00:00:00	1963-05-21	1963-05-21 00:00:00	1963-05-21	38000177		0	0	14		0	0	0	333462	0	313782	1127433		
53131	4413	40229134	1976-08-04	1976-08-04 00:00:00	1976-08-18	1976-08-18 00:00:00	1976-08-18	38000177		0	0	14		0	0	0	293490	0	1043400	40229134		
25936	2134	1127078	1951-07-03	1951-07-03 00:00:00	1951-07-17	1951-07-17 00:00:00	1951-07-17	38000177		0	0	14		0	0	0	141992	0	282464	1127078		
2039	161	1127433	1978-02-24	1978-02-24 00:00:00	1978-03-10	1978-03-10 00:00:00	1978-03-10	38000177		0	0	14		0	0	0	11045	0	313782	1127433		
9537	795	19133873	1950-05-25	1950-05-25 00:00:00	1950-06-05	1950-06-05 00:00:00	1950-06-05	38000177		0	0	11		0	0	0	52773	0	834061	19133873		
38940	850	40213227	2008-04-22	2008-04-22 00:00:00	2008-04-22	2008-04-22 00:00:00	2008-04-22	581452		0	0	0		0	0	0	56203	0	113	40213227		
28850	2384	19078461	1997-05-13	1997-05-13 00:00:00	1997-08-11	1997-08-11 00:00:00	1997-08-11	38000177		0	0	90		0	0	0	158495	0	310965	19078461		
35613	2935	19073183	1980-10-02	1980-10-02 00:00:00	1980-10-16	1980-10-16 00:00:00	1980-10-16	38000177		0	0	14		0	0	0	195729	0	308182	19073183		
20177	1657	1127433	1966-02-15	1966-02-15 00:00:00	1966-03-22	1966-03-22 00:00:00	1966-03-22	38000177		0	0	35		0	0	0	111184	0	313782	1127433		
22570	489	40213227	2017-07-16	2017-07-16 00:00:00	2017-07-16	2017-07-16 00:00:00	2017-07-16	581452		0	0	0		0	0	0	32780	0	113	40213227		
42092	3489	1713671	1987-12-15	1987-12-15 00:00:00	1987-12-29	1987-12-29 00:00:00	1987-12-29	38000177		0	0	14		0	0	0	231460	0	562251	1713671		
138755	3048	40213160	1975-01-22	1975-01-22 00:00:00	1975-01-22	1975-01-22 00:00:00	1975-01-22	581452		0	0	0		0	0	0	202830	0	10	40213160		
1388	111	43012754	2004-02-14	2004-02-14 00:00:00	2005-02-08	2005-02-08 00:00:00	2005-02-08	38000177		0	0	360		0	0	0	7385	0	1366343	43012754		
14582	1222	40162522	1971-08-13	1971-08-13 00:00:00	1971-08-13	1971-08-13 00:00:00	\N	38000177		0	0	0		0	0	0	80424	0	857005	40162522		
1570	123	1127433	2006-08-17	2006-08-17 00:00:00	2006-08-24	2006-08-24 00:00:00	2006-08-24	38000177		0	0	7		0	0	0	8144	0	313782	1127433		
12319	1036	19133873	1975-09-07	1975-09-07 00:00:00	1975-09-20	1975-09-20 00:00:00	1975-09-20	38000177		0	0	13		0	0	0	68095	0	834061	19133873		
40228	3332	19078461	1983-01-01	1983-01-01 00:00:00	1983-01-22	1983-01-22 00:00:00	1983-01-22	38000177		0	0	21		0	0	0	221132	0	310965	19078461		
8122	677	19059056	1965-03-13	1965-03-13 00:00:00	1965-03-27	1965-03-27 00:00:00	1965-03-27	38000177		0	0	14		0	0	0	44825	0	243670	19059056		
40333	3342	1713671	1921-11-30	1921-11-30 00:00:00	1921-12-14	1921-12-14 00:00:00	1921-12-14	38000177		0	0	14		0	0	0	221573	0	562251	1713671		
38614	3189	40236446	1973-06-14	1973-06-14 00:00:00	1975-01-02	1975-01-02 00:00:00	1975-01-02	38000177		0	0	567		0	0	0	212219	0	1091392	40236446		
35824	2950	1127433	1983-06-09	1983-06-09 00:00:00	1983-06-23	1983-06-23 00:00:00	1983-06-23	38000177		0	0	14		0	0	0	196938	0	313782	1127433		
49186	4081	1127433	1988-10-25	1988-10-25 00:00:00	1988-11-01	1988-11-01 00:00:00	1988-11-01	38000177		0	0	7		0	0	0	271235	0	313782	1127433		
46392	3843	1124300	2008-06-21	2008-06-21 00:00:00	2008-06-21	2008-06-21 00:00:00	\N	38000177		0	0	0		0	0	0	255096	0	00781178901	45011828		
54232	4506	1713671	2009-07-26	2009-07-26 00:00:00	2009-08-09	2009-08-09 00:00:00	2009-08-09	38000177		0	0	14		0	0	0	300239	0	562251	1713671		
33402	2767	19079524	1939-05-23	1939-05-23 00:00:00	1939-05-24	1939-05-24 00:00:00	1939-05-24	38000177		0	0	1		0	0	0	183063	0	313002	19079524		
33358	2765	19059056	1938-04-24	1938-04-24 00:00:00	1938-05-08	1938-05-08 00:00:00	1938-05-08	38000177		0	0	14		0	0	0	182950	0	243670	19059056		
36388	3000	19078461	2010-04-20	2010-04-20 00:00:00	2010-05-25	2010-05-25 00:00:00	2010-05-25	38000177		0	0	35		0	0	0	200183	0	310965	19078461		
57056	4735	1127433	1993-06-20	1993-06-20 00:00:00	1993-06-27	1993-06-27 00:00:00	1993-06-27	38000177		0	0	7		0	0	0	315443	0	313782	1127433		
28120	2326	19073188	2000-12-04	2000-12-04 00:00:00	2000-12-18	2000-12-18 00:00:00	2000-12-18	38000177		0	0	14		0	0	0	154649	0	308192	19073188		
26569	2186	1118084	2014-10-16	2014-10-16 00:00:00	2014-10-16	2014-10-16 00:00:00	\N	38000177		0	0	0		0	0	0	145783	0	00025152531	44923712		
52639	1151	40213160	1989-10-31	1989-10-31 00:00:00	1989-10-31	1989-10-31 00:00:00	1989-10-31	581452		0	0	0		0	0	0	76134	0	10	40213160		
21642	1779	1127433	2009-10-25	2009-10-25 00:00:00	2009-11-01	2009-11-01 00:00:00	2009-11-01	38000177		0	0	7		0	0	0	119000	0	313782	1127433		
21686	1781	1713671	2004-07-12	2004-07-12 00:00:00	2004-07-19	2004-07-19 00:00:00	2004-07-19	38000177		0	0	7		0	0	0	119207	0	562251	1713671		
64312	1408	40213227	2005-01-24	2005-01-24 00:00:00	2005-01-24	2005-01-24 00:00:00	2005-01-24	581452		0	0	0		0	0	0	93648	0	113	40213227		
6483	546	1713671	1995-02-17	1995-02-17 00:00:00	1995-03-03	1995-03-03 00:00:00	1995-03-03	38000177		0	0	14		0	0	0	36202	0	562251	1713671		
47734	3957	1127433	1978-10-09	1978-10-09 00:00:00	1978-10-23	1978-10-23 00:00:00	1978-10-23	38000177		0	0	14		0	0	0	263100	0	313782	1127433		
120414	2647	40213227	2012-12-23	2012-12-23 00:00:00	2012-12-23	2012-12-23 00:00:00	2012-12-23	581452		0	0	0		0	0	0	175146	0	113	40213227		
23510	1935	1127433	1989-12-13	1989-12-13 00:00:00	1989-12-27	1989-12-27 00:00:00	1989-12-27	38000177		0	0	14		0	0	0	128742	0	313782	1127433		
16362	1356	19008572	1995-02-07	1995-02-07 00:00:00	1995-02-07	1995-02-07 00:00:00	\N	38000177		0	0	0		0	0	0	89887	0	106258	19008572		
924	74	19128022	1992-11-25	1992-11-25 00:00:00	1993-11-20	1993-11-20 00:00:00	1993-11-20	38000177		0	0	360		0	0	0	5001	0	749785	19128022		
41110	3410	1127433	1978-02-06	1978-02-06 00:00:00	1978-03-06	1978-03-06 00:00:00	1978-03-06	38000177		0	0	28		0	0	0	226175	0	313782	1127433		
51630	4289	40165015	2017-05-10	2017-05-10 00:00:00	2017-05-10	2017-05-10 00:00:00	\N	38000177		0	0	0		0	0	0	284744	0	861467	40165015		
58565	4861	40169216	1982-06-02	1982-06-02 00:00:00	1982-06-02	1982-06-02 00:00:00	\N	38000177		0	0	0		0	0	0	323415	0	895994	40169216		
31647	689	40213251	1984-01-29	1984-01-29 00:00:00	1984-01-29	1984-01-29 00:00:00	1984-01-29	581452		0	0	0		0	0	0	45658	0	21	40213251		
20415	1677	1118084	2003-04-20	2003-04-20 00:00:00	2003-04-20	2003-04-20 00:00:00	\N	38000177		0	0	0		0	0	0	112481	0	00025152531	44923712		
16724	1385	40162522	1997-11-09	1997-11-09 00:00:00	1997-11-09	1997-11-09 00:00:00	\N	38000177		0	0	0		0	0	0	91874	0	857005	40162522		
51108	4246	1127433	1969-10-14	1969-10-14 00:00:00	1969-10-28	1969-10-28 00:00:00	1969-10-28	38000177		0	0	14		0	0	0	281985	0	313782	1127433		
19	1	19074841	1980-03-15	1980-03-15 00:00:00	1980-03-29	1980-03-29 00:00:00	1980-03-29	38000177		0	0	14		0	0	0	3	0	309043	19074841		
42412	3516	1127433	1981-12-12	1981-12-12 00:00:00	1982-02-10	1982-02-10 00:00:00	1982-02-10	38000177		0	0	60		0	0	0	233367	0	313782	1127433		
16807	1390	1118084	2006-10-11	2006-10-11 00:00:00	2006-10-11	2006-10-11 00:00:00	\N	38000177		0	0	0		0	0	0	92292	0	00025152531	44923712		
4122	341	19129655	1963-03-28	1963-03-28 00:00:00	1963-04-11	1963-04-11 00:00:00	1963-04-11	38000177		0	0	14		0	0	0	22787	0	789980	19129655		
10631	884	19019979	1989-06-08	1989-06-08 00:00:00	1989-09-06	1989-09-06 00:00:00	1989-09-06	38000177		0	0	90		0	0	0	58950	0	198405	19019979		
14663	1228	920300	2016-09-01	2016-09-01 00:00:00	2016-09-08	2016-09-08 00:00:00	2016-09-08	38000177		0	0	7		0	0	0	80919	0	311989	920300		
36294	2991	1118084	1998-10-16	1998-10-16 00:00:00	1998-10-16	1998-10-16 00:00:00	\N	38000177		0	0	0		0	0	0	199661	0	00025152531	44923712		
36307	2992	1127433	1966-08-29	1966-08-29 00:00:00	1966-09-12	1966-09-12 00:00:00	1966-09-12	38000177		0	0	14		0	0	0	199693	0	313782	1127433		
111934	2459	40213160	1976-11-29	1976-11-29 00:00:00	1976-11-29	1976-11-29 00:00:00	1976-11-29	581452		0	0	0		0	0	0	163038	0	10	40213160		
2325	186	1713671	1976-05-28	1976-05-28 00:00:00	1976-06-04	1976-06-04 00:00:00	1976-06-04	38000177		0	0	7		0	0	0	12623	0	562251	1713671		
41906	3470	40162522	1998-08-10	1998-08-10 00:00:00	1998-08-10	1998-08-10 00:00:00	\N	38000177		0	0	0		0	0	0	230380	0	857005	40162522		
41764	3457	19059056	1921-02-07	1921-02-07 00:00:00	1921-02-21	1921-02-21 00:00:00	1921-02-21	38000177		0	0	14		0	0	0	229381	0	243670	19059056		
102097	2238	40213160	1973-07-15	1973-07-15 00:00:00	1973-07-15	1973-07-15 00:00:00	1973-07-15	581452		0	0	0		0	0	0	148893	0	10	40213160		
31984	2651	1127433	1969-11-20	1969-11-20 00:00:00	1969-12-04	1969-12-04 00:00:00	1969-12-04	38000177		0	0	14		0	0	0	175487	0	313782	1127433		
165387	3636	40213160	1972-10-20	1972-10-20 00:00:00	1972-10-20	1972-10-20 00:00:00	1972-10-20	581452		0	0	0		0	0	0	241787	0	10	40213160		
51425	4274	1124300	1958-05-31	1958-05-31 00:00:00	1958-05-31	1958-05-31 00:00:00	\N	38000177		0	0	0		0	0	0	283602	0	00781178901	45011828		
42808	3547	19059056	1973-12-13	1973-12-13 00:00:00	1973-12-27	1973-12-27 00:00:00	1973-12-27	38000177		0	0	14		0	0	0	235581	0	243670	19059056		
60345	5018	19059056	1942-07-03	1942-07-03 00:00:00	1942-07-17	1942-07-17 00:00:00	1942-07-17	38000177		0	0	14		0	0	0	333545	0	243670	19059056		
53132	4413	19078461	1975-08-22	1975-08-22 00:00:00	1975-09-12	1975-09-12 00:00:00	1975-09-12	38000177		0	0	21		0	0	0	293416	0	310965	19078461		
25937	2134	1118084	1988-02-19	1988-02-19 00:00:00	1988-02-19	1988-02-19 00:00:00	\N	38000177		0	0	0		0	0	0	142035	0	00025152531	44923712		
2040	161	19078461	1990-07-20	1990-07-20 00:00:00	1990-10-18	1990-10-18 00:00:00	1990-10-18	38000177		0	0	90		0	0	0	11056	0	310965	19078461		
9538	795	40173590	2006-11-01	2006-11-01 00:00:00	2006-11-01	2006-11-01 00:00:00	\N	38000177		0	0	0		0	0	0	52769	0	904419	40173590		
38946	850	40213227	1998-02-24	1998-02-24 00:00:00	1998-02-24	1998-02-24 00:00:00	1998-02-24	581452		0	0	0		0	0	0	56266	0	113	40213227		
28851	2384	920300	2013-03-25	2013-03-25 00:00:00	2013-04-01	2013-04-01 00:00:00	2013-04-01	38000177		0	0	7		0	0	0	158501	0	311989	920300		
35614	2935	1127433	2002-04-22	2002-04-22 00:00:00	2002-04-29	2002-04-29 00:00:00	2002-04-29	38000177		0	0	7		0	0	0	195687	0	313782	1127433		
20178	1657	1713671	1985-02-23	1985-02-23 00:00:00	1985-03-09	1985-03-09 00:00:00	1985-03-09	38000177		0	0	14		0	0	0	111176	0	562251	1713671		
22572	489	40213160	1975-09-07	1975-09-07 00:00:00	1975-09-07	1975-09-07 00:00:00	1975-09-07	581452		0	0	0		0	0	0	32710	0	10	40213160		
42093	3489	19128022	1990-10-04	1990-10-04 00:00:00	1991-09-29	1991-09-29 00:00:00	1991-09-29	38000177		0	0	360		0	0	0	231464	0	749785	19128022		
138757	3048	40213227	2005-07-27	2005-07-27 00:00:00	2005-07-27	2005-07-27 00:00:00	2005-07-27	581452		0	0	0		0	0	0	202791	0	113	40213227		
1389	111	1127078	1977-05-21	1977-05-21 00:00:00	1977-06-04	1977-06-04 00:00:00	1977-06-04	38000177		0	0	14		0	0	0	7352	0	282464	1127078		
14583	1222	1127433	1971-08-13	1971-08-13 00:00:00	1971-11-11	1971-11-11 00:00:00	1971-11-11	38000177		0	0	90		0	0	0	80424	0	313782	1127433		
1571	123	1127433	1952-02-03	1952-02-03 00:00:00	1952-02-10	1952-02-10 00:00:00	1952-02-10	38000177		0	0	7		0	0	0	8148	0	313782	1127433		
12320	1036	40232448	1974-09-25	1974-09-25 00:00:00	1974-09-25	1974-09-25 00:00:00	\N	38000177		0	0	0		0	0	0	68163	0	1049630	40232448		
40229	3332	19133905	1998-06-19	1998-06-19 00:00:00	1998-06-28	1998-06-28 00:00:00	1998-06-28	38000177		0	0	9		0	0	0	221126	0	834102	19133905		
8123	677	19006318	1965-03-13	1965-03-13 00:00:00	1965-03-27	1965-03-27 00:00:00	1965-03-27	38000177		0	0	14		0	0	0	44825	0	105078	19006318		
40334	3342	19018935	2005-03-30	2005-03-30 00:00:00	2005-03-30	2005-03-30 00:00:00	\N	38000177		0	0	0		0	0	0	221627	0	197604	19018935		
38615	3189	19128065	1984-05-17	1984-05-17 00:00:00	1985-05-12	1985-05-12 00:00:00	1985-05-12	38000177		0	0	360		0	0	0	212228	0	749882	19128065		
35825	2950	19059056	1936-08-09	1936-08-09 00:00:00	1936-08-23	1936-08-23 00:00:00	1936-08-23	38000177		0	0	14		0	0	0	196985	0	243670	19059056		
35843	2950	1713671	2006-11-28	2006-11-28 00:00:00	2006-12-12	2006-12-12 00:00:00	2006-12-12	38000177		0	0	14		0	0	0	196983	0	562251	1713671		
15269	1276	19078461	2010-08-11	2010-08-11 00:00:00	2010-09-10	2010-09-10 00:00:00	2010-09-10	38000177		0	0	30		0	0	0	84135	0	310965	19078461		
54233	4506	1118084	1992-02-28	1992-02-28 00:00:00	1992-02-28	1992-02-28 00:00:00	\N	38000177		0	0	0		0	0	0	300229	0	00025152531	44923712		
33403	2767	19023423	1939-05-24	1939-05-24 00:00:00	1939-05-24	1939-05-24 00:00:00	1939-05-24	38000177		0	0	0		0	0	0	183063	0	200252	19023423		
33359	2765	19059056	1946-11-15	1946-11-15 00:00:00	1947-02-13	1947-02-13 00:00:00	1947-02-13	38000177		0	0	90		0	0	0	182884	0	243670	19059056		
36390	3000	1713671	2007-11-21	2007-11-21 00:00:00	2007-11-28	2007-11-28 00:00:00	2007-11-28	38000177		0	0	7		0	0	0	200198	0	562251	1713671		
57058	4735	1127078	1982-04-17	1982-04-17 00:00:00	1982-07-16	1982-07-16 00:00:00	1982-07-16	38000177		0	0	90		0	0	0	315451	0	282464	1127078		
28121	2326	1127433	1986-01-14	1986-01-14 00:00:00	1986-01-28	1986-01-28 00:00:00	1986-01-28	38000177		0	0	14		0	0	0	154636	0	313782	1127433		
26570	2186	1127078	1975-05-14	1975-05-14 00:00:00	1975-05-28	1975-05-28 00:00:00	1975-05-28	38000177		0	0	14		0	0	0	145771	0	282464	1127078		
52641	1151	40213314	1986-01-28	1986-01-28 00:00:00	1986-01-28	1986-01-28 00:00:00	1986-01-28	581452		0	0	0		0	0	0	76122	0	49	40213314		
21643	1779	40174880	2009-11-09	2009-11-09 00:00:00	2009-11-09	2009-11-09 00:00:00	\N	38000177		0	0	0		0	0	0	119050	0	966222	40174880		
21687	1781	1124300	1975-09-15	1975-09-15 00:00:00	1975-09-15	1975-09-15 00:00:00	\N	38000177		0	0	0		0	0	0	119267	0	00781178901	45011828		
64337	1408	40213227	2015-03-23	2015-03-23 00:00:00	2015-03-23	2015-03-23 00:00:00	2015-03-23	581452		0	0	0		0	0	0	93607	0	113	40213227		
6484	546	1127433	1990-04-22	1990-04-22 00:00:00	1990-04-29	1990-04-29 00:00:00	1990-04-29	38000177		0	0	7		0	0	0	36243	0	313782	1127433		
47735	3957	1127433	1971-03-04	1971-03-04 00:00:00	1971-03-11	1971-03-11 00:00:00	1971-03-11	38000177		0	0	7		0	0	0	263099	0	313782	1127433		
120415	2647	40213296	2012-12-23	2012-12-23 00:00:00	2012-12-23	2012-12-23 00:00:00	2012-12-23	581452		0	0	0		0	0	0	175146	0	52	40213296		
23511	1935	19133873	1981-05-01	1981-05-01 00:00:00	1981-05-13	1981-05-13 00:00:00	1981-05-13	38000177		0	0	12		0	0	0	128711	0	834061	19133873		
16363	1356	1594382	1995-02-23	1995-02-23 00:00:00	1995-02-23	1995-02-23 00:00:00	\N	38000177		0	0	0		0	0	0	89888	0	1870230	1594382		
925	74	1713671	1998-04-14	1998-04-14 00:00:00	1998-05-05	1998-05-05 00:00:00	1998-05-05	38000177		0	0	21		0	0	0	5004	0	562251	1713671		
41111	3410	1127078	1973-03-20	1973-03-20 00:00:00	1973-04-03	1973-04-03 00:00:00	1973-04-03	38000177		0	0	14		0	0	0	226177	0	282464	1127078		
58512	4859	1127433	1955-08-19	1955-08-19 00:00:00	1955-08-26	1955-08-26 00:00:00	1955-08-26	38000177		0	0	7		0	0	0	323247	0	313782	1127433		
58566	4861	1154615	1982-06-02	1982-06-02 00:00:00	1982-06-02	1982-06-02 00:00:00	\N	38000177		0	0	0		0	0	0	323415	0	745679	1154615		
87538	1921	40213198	2017-01-16	2017-01-16 00:00:00	2017-01-16	2017-01-16 00:00:00	2017-01-16	581452		0	0	0		0	0	0	127760	0	133	40213198		
20416	1677	19059056	1970-05-08	1970-05-08 00:00:00	1970-05-22	1970-05-22 00:00:00	1970-05-22	38000177		0	0	14		0	0	0	112497	0	243670	19059056		
16725	1385	1127433	1997-11-09	1997-11-09 00:00:00	1997-11-30	1997-11-30 00:00:00	1997-11-30	38000177		0	0	21		0	0	0	91874	0	313782	1127433		
51109	4246	19133873	1974-01-16	1974-01-16 00:00:00	1974-01-28	1974-01-28 00:00:00	1974-01-28	38000177		0	0	12		0	0	0	281986	0	834061	19133873		
20	2	1127433	1931-09-03	1931-09-03 00:00:00	1931-09-17	1931-09-17 00:00:00	1931-09-17	38000177		0	0	14		0	0	0	123	0	313782	1127433		
42413	3516	1118084	1978-04-09	1978-04-09 00:00:00	1978-04-09	1978-04-09 00:00:00	\N	38000177		0	0	0		0	0	0	233379	0	00025152531	44923712		
16808	1390	1713671	2017-05-07	2017-05-07 00:00:00	2017-05-28	2017-05-28 00:00:00	2017-05-28	38000177		0	0	21		0	0	0	92272	0	562251	1713671		
4123	341	1713671	1990-09-14	1990-09-14 00:00:00	1990-10-05	1990-10-05 00:00:00	1990-10-05	38000177		0	0	21		0	0	0	22784	0	562251	1713671		
10632	884	1127433	2013-11-26	2013-11-26 00:00:00	2013-12-03	2013-12-03 00:00:00	2013-12-03	38000177		0	0	7		0	0	0	58932	0	313782	1127433		
14664	1228	40165015	2003-09-30	2003-09-30 00:00:00	2003-09-30	2003-09-30 00:00:00	\N	38000177		0	0	0		0	0	0	80896	0	861467	40165015		
43359	3595	1127433	1989-08-08	1989-08-08 00:00:00	1989-09-12	1989-09-12 00:00:00	1989-09-12	38000177		0	0	35		0	0	0	238833	0	313782	1127433		
36308	2992	1127433	1971-10-30	1971-10-30 00:00:00	1971-11-20	1971-11-20 00:00:00	1971-11-20	38000177		0	0	21		0	0	0	199762	0	313782	1127433		
111935	2459	40213314	1977-05-30	1977-05-30 00:00:00	1977-05-30	1977-05-30 00:00:00	1977-05-30	581452		0	0	0		0	0	0	163017	0	49	40213314		
2326	187	1127433	1999-04-21	1999-04-21 00:00:00	1999-05-26	1999-05-26 00:00:00	1999-05-26	38000177		0	0	35		0	0	0	12737	0	313782	1127433		
41909	3470	1115171	1998-08-03	1998-08-03 00:00:00	1998-10-09	1998-10-09 00:00:00	1998-10-09	38000177		0	0	67		0	0	0	230329	0	849574	1115171		
41765	3457	40229134	1925-11-06	1925-11-06 00:00:00	1925-11-20	1925-11-20 00:00:00	1925-11-20	38000177		0	0	14		0	0	0	229321	0	1043400	40229134		
102102	2238	40213306	1990-01-07	1990-01-07 00:00:00	1990-01-07	1990-01-07 00:00:00	1990-01-07	581452		0	0	0		0	0	0	\N	0	43	40213306		
31985	2651	1127433	1951-04-27	1951-04-27 00:00:00	1951-05-04	1951-05-04 00:00:00	1951-05-04	38000177		0	0	7		0	0	0	175414	0	313782	1127433		
165392	3636	40213160	1972-12-22	1972-12-22 00:00:00	1972-12-22	1972-12-22 00:00:00	1972-12-22	581452		0	0	0		0	0	0	241844	0	10	40213160		
51426	4274	19059056	1926-01-29	1926-01-29 00:00:00	1926-02-12	1926-02-12 00:00:00	1926-02-12	38000177		0	0	14		0	0	0	283574	0	243670	19059056		
42809	3547	1127433	2009-10-05	2009-10-05 00:00:00	2009-10-12	2009-10-12 00:00:00	2009-10-12	38000177		0	0	7		0	0	0	235596	0	313782	1127433		
60358	5022	1713671	1998-01-01	1998-01-01 00:00:00	1998-01-08	1998-01-08 00:00:00	1998-01-08	38000177		0	0	7		0	0	0	333643	0	562251	1713671		
53133	4413	19115351	1996-11-29	1996-11-29 00:00:00	1997-05-09	1997-05-09 00:00:00	1997-05-09	38000177		0	0	161		0	0	0	293419	0	563026	19115351		
25938	2134	40229134	2013-11-14	2013-11-14 00:00:00	2013-11-21	2013-11-21 00:00:00	2013-11-21	38000177		0	0	7		0	0	0	141981	0	1043400	40229134		
2041	161	1127433	2016-01-19	2016-01-19 00:00:00	2016-01-26	2016-01-26 00:00:00	2016-01-26	38000177		0	0	7		0	0	0	11048	0	313782	1127433		
9539	795	40229134	1965-06-20	1965-06-20 00:00:00	1965-06-27	1965-06-27 00:00:00	1965-06-27	38000177		0	0	7		0	0	0	52736	0	1043400	40229134		
38955	850	40213227	2018-06-19	2018-06-19 00:00:00	2018-06-19	2018-06-19 00:00:00	2018-06-19	581452		0	0	0		0	0	0	56228	0	113	40213227		
28852	2384	40236824	2013-03-25	2013-03-25 00:00:00	2013-04-01	2013-04-01 00:00:00	2013-04-01	38000177		0	0	7		0	0	0	158501	0	1094107	40236824		
35615	2935	1713671	2012-10-07	2012-10-07 00:00:00	2012-10-21	2012-10-21 00:00:00	2012-10-21	38000177		0	0	14		0	0	0	195727	0	562251	1713671		
20179	1657	1127433	1994-02-20	1994-02-20 00:00:00	1994-02-27	1994-02-27 00:00:00	1994-02-27	38000177		0	0	7		0	0	0	111245	0	313782	1127433		
22576	489	40213314	1978-05-07	1978-05-07 00:00:00	1978-05-07	1978-05-07 00:00:00	1978-05-07	581452		0	0	0		0	0	0	32713	0	49	40213314		
42094	3489	46233988	1975-05-16	1975-05-16 00:00:00	1975-05-30	1975-05-30 00:00:00	1975-05-30	38000177		0	0	14		0	0	0	231463	0	1652673	46233988		
138759	3048	40213160	1974-08-21	1974-08-21 00:00:00	1974-08-21	1974-08-21 00:00:00	1974-08-21	581452		0	0	0		0	0	0	202829	0	10	40213160		
1390	111	46233988	1977-05-21	1977-05-21 00:00:00	1977-06-04	1977-06-04 00:00:00	1977-06-04	38000177		0	0	14		0	0	0	7352	0	1652673	46233988		
14584	1222	1127433	1975-06-12	1975-06-12 00:00:00	1975-06-19	1975-06-19 00:00:00	1975-06-19	38000177		0	0	7		0	0	0	80427	0	313782	1127433		
1572	124	19008572	1994-11-30	1994-11-30 00:00:00	1994-12-14	1994-12-14 00:00:00	1994-12-14	38000177		0	0	14		0	0	0	8243	0	106258	19008572		
12321	1036	19059056	1972-01-08	1972-01-08 00:00:00	1972-01-22	1972-01-22 00:00:00	1972-01-22	38000177		0	0	14		0	0	0	68190	0	243670	19059056		
40230	3332	1127433	1974-11-24	1974-11-24 00:00:00	1974-12-01	1974-12-01 00:00:00	1974-12-01	38000177		0	0	7		0	0	0	221125	0	313782	1127433		
8124	677	19059056	1977-09-11	1977-09-11 00:00:00	1977-10-16	1977-10-16 00:00:00	1977-10-16	38000177		0	0	35		0	0	0	44811	0	243670	19059056		
40335	3342	40163554	2005-03-30	2005-03-30 00:00:00	2005-03-30	2005-03-30 00:00:00	\N	38000177		0	0	0		0	0	0	221627	0	855332	40163554		
38616	3189	19059056	1965-09-14	1965-09-14 00:00:00	1965-09-28	1965-09-28 00:00:00	1965-09-28	38000177		0	0	14		0	0	0	212238	0	243670	19059056		
35826	2950	1118084	1978-04-26	1978-04-26 00:00:00	1978-04-26	1978-04-26 00:00:00	\N	38000177		0	0	0		0	0	0	196980	0	00025152531	44923712		
35844	2950	19133905	1993-01-13	1993-01-13 00:00:00	1993-01-20	1993-01-20 00:00:00	1993-01-20	38000177		0	0	7		0	0	0	196989	0	834102	19133905		
15270	1276	1551192	1958-05-02	1958-05-02 00:00:00	1958-05-02	1958-05-02 00:00:00	1958-05-02	38000177		0	0	0		0	0	0	84131	0	312617	1551192		
54234	4506	1127433	1980-03-20	1980-03-20 00:00:00	1980-04-03	1980-04-03 00:00:00	1980-04-03	38000177		0	0	14		0	0	0	300222	0	313782	1127433		
33404	2767	40220386	1939-05-24	1939-05-24 00:00:00	1939-05-24	1939-05-24 00:00:00	1939-05-24	38000177		0	0	0		0	0	0	183063	0	1808217	40220386		
33360	2765	19059056	1949-11-29	1949-11-29 00:00:00	1949-12-27	1949-12-27 00:00:00	1949-12-27	38000177		0	0	28		0	0	0	182887	0	243670	19059056		
36392	3000	1127433	1975-08-28	1975-08-28 00:00:00	1975-11-03	1975-11-03 00:00:00	1975-11-03	38000177		0	0	67		0	0	0	200179	0	313782	1127433		
57059	4735	1118084	2012-04-14	2012-04-14 00:00:00	2012-04-14	2012-04-14 00:00:00	\N	38000177		0	0	0		0	0	0	315411	0	00025152531	44923712		
28122	2326	1127433	2008-06-03	2008-06-03 00:00:00	2008-06-17	2008-06-17 00:00:00	2008-06-17	38000177		0	0	14		0	0	0	154648	0	313782	1127433		
26571	2186	19006318	1975-05-14	1975-05-14 00:00:00	1975-05-28	1975-05-28 00:00:00	1975-05-28	38000177		0	0	14		0	0	0	145771	0	105078	19006318		
52642	1151	40213251	1986-01-28	1986-01-28 00:00:00	1986-01-28	1986-01-28 00:00:00	1986-01-28	581452		0	0	0		0	0	0	76122	0	21	40213251		
21644	1779	19059056	1944-10-16	1944-10-16 00:00:00	1944-10-30	1944-10-30 00:00:00	1944-10-30	38000177		0	0	14		0	0	0	119002	0	243670	19059056		
21688	1781	1713671	2017-04-17	2017-04-17 00:00:00	2017-05-01	2017-05-01 00:00:00	2017-05-01	38000177		0	0	14		0	0	0	119261	0	562251	1713671		
74131	1618	40213227	2005-03-09	2005-03-09 00:00:00	2005-03-09	2005-03-09 00:00:00	2005-03-09	581452		0	0	0		0	0	0	108807	0	113	40213227		
6485	546	19059056	1944-12-08	1944-12-08 00:00:00	1945-02-06	1945-02-06 00:00:00	1945-02-06	38000177		0	0	60		0	0	0	36148	0	243670	19059056		
47736	3957	1127433	1989-11-26	1989-11-26 00:00:00	1989-12-10	1989-12-10 00:00:00	1989-12-10	38000177		0	0	14		0	0	0	263139	0	313782	1127433		
120417	2647	40213227	2002-03-03	2002-03-03 00:00:00	2002-03-03	2002-03-03 00:00:00	2002-03-03	581452		0	0	0		0	0	0	175181	0	113	40213227		
23512	1935	19133873	1972-12-21	1972-12-21 00:00:00	1972-12-29	1972-12-29 00:00:00	1972-12-29	38000177		0	0	8		0	0	0	128740	0	834061	19133873		
16364	1356	1107882	1995-02-23	1995-02-23 00:00:00	1995-02-23	1995-02-23 00:00:00	\N	38000177		0	0	0		0	0	0	89888	0	311372	1107882		
10621	884	46233988	1979-04-29	1979-04-29 00:00:00	1979-05-13	1979-05-13 00:00:00	1979-05-13	38000177		0	0	14		0	0	0	58920	0	1652673	46233988		
41112	3410	1713671	1999-04-08	1999-04-08 00:00:00	1999-04-22	1999-04-22 00:00:00	1999-04-22	38000177		0	0	14		0	0	0	226208	0	562251	1713671		
58513	4859	1127433	1956-08-29	1956-08-29 00:00:00	1956-09-12	1956-09-12 00:00:00	1956-09-12	38000177		0	0	14		0	0	0	323199	0	313782	1127433		
58567	4861	1127433	2017-09-10	2017-09-10 00:00:00	2017-09-17	2017-09-17 00:00:00	2017-09-17	38000177		0	0	7		0	0	0	323446	0	313782	1127433		
1038	23	40213314	1979-02-15	1979-02-15 00:00:00	1979-02-15	1979-02-15 00:00:00	1979-02-15	581452		0	0	0		0	0	0	1768	0	49	40213314		
30877	2556	1127433	1970-06-13	1970-06-13 00:00:00	1970-06-27	1970-06-27 00:00:00	1970-06-27	38000177		0	0	14		0	0	0	169417	0	313782	1127433		
16726	1385	19073188	1997-11-09	1997-11-09 00:00:00	1997-11-30	1997-11-30 00:00:00	1997-11-30	38000177		0	0	21		0	0	0	91874	0	308192	19073188		
51110	4246	1127433	1989-05-02	1989-05-02 00:00:00	1989-05-09	1989-05-09 00:00:00	1989-05-09	38000177		0	0	7		0	0	0	281951	0	313782	1127433		
21	2	19059056	1974-03-04	1974-03-04 00:00:00	1974-03-25	1974-03-25 00:00:00	1974-03-25	38000177		0	0	21		0	0	0	114	0	243670	19059056		
42414	3516	40229134	2002-05-05	2002-05-05 00:00:00	2002-05-19	2002-05-19 00:00:00	2002-05-19	38000177		0	0	14		0	0	0	233299	0	1043400	40229134		
48975	4064	19134077	1988-08-09	1988-08-09 00:00:00	1988-08-30	1988-08-30 00:00:00	1988-08-30	38000177		0	0	21		0	0	0	270075	0	835900	19134077		
4124	341	1127433	2000-05-10	2000-05-10 00:00:00	2000-05-17	2000-05-17 00:00:00	2000-05-17	38000177		0	0	7		0	0	0	22806	0	313782	1127433		
10633	884	19134077	2012-01-15	2012-01-15 00:00:00	2012-02-05	2012-02-05 00:00:00	2012-02-05	38000177		0	0	21		0	0	0	58930	0	835900	19134077		
14665	1228	1115171	2003-09-30	2003-09-30 00:00:00	2003-11-29	2003-11-29 00:00:00	2003-11-29	38000177		0	0	60		0	0	0	80896	0	849574	1115171		
43360	3595	40229134	1980-04-19	1980-04-19 00:00:00	1980-05-03	1980-05-03 00:00:00	1980-05-03	38000177		0	0	14		0	0	0	238847	0	1043400	40229134		
36309	2992	1127433	1981-01-29	1981-01-29 00:00:00	1981-02-19	1981-02-19 00:00:00	1981-02-19	38000177		0	0	21		0	0	0	199764	0	313782	1127433		
111940	2459	40213160	1976-09-27	1976-09-27 00:00:00	1976-09-27	1976-09-27 00:00:00	1976-09-27	581452		0	0	0		0	0	0	163064	0	10	40213160		
2327	187	1127433	2001-04-15	2001-04-15 00:00:00	2001-05-13	2001-05-13 00:00:00	2001-05-13	38000177		0	0	28		0	0	0	12738	0	313782	1127433		
41910	3470	19059056	1988-09-12	1988-09-12 00:00:00	1988-10-03	1988-10-03 00:00:00	1988-10-03	38000177		0	0	21		0	0	0	230327	0	243670	19059056		
41766	3457	1127433	1960-04-25	1960-04-25 00:00:00	1960-05-16	1960-05-16 00:00:00	1960-05-16	38000177		0	0	21		0	0	0	229384	0	313782	1127433		
102107	2238	40213227	2010-08-15	2010-08-15 00:00:00	2010-08-15	2010-08-15 00:00:00	2010-08-15	581452		0	0	0		0	0	0	148881	0	113	40213227		
31986	2651	19006318	1963-03-18	1963-03-18 00:00:00	1963-04-01	1963-04-01 00:00:00	1963-04-01	38000177		0	0	14		0	0	0	175448	0	105078	19006318		
176675	3884	40213314	1977-03-07	1977-03-07 00:00:00	1977-03-07	1977-03-07 00:00:00	1977-03-07	581452		0	0	0		0	0	0	258198	0	49	40213314		
51427	4274	1115171	2018-04-10	2018-04-10 00:00:00	2018-06-09	2018-06-09 00:00:00	2018-06-09	38000177		0	0	60		0	0	0	283563	0	849574	1115171		
42810	3547	1127078	1977-12-03	1977-12-03 00:00:00	1978-01-02	1978-01-02 00:00:00	1978-01-02	38000177		0	0	30		0	0	0	235540	0	282464	1127078		
60359	5022	1127433	2010-01-23	2010-01-23 00:00:00	2010-02-27	2010-02-27 00:00:00	2010-02-27	38000177		0	0	35		0	0	0	333663	0	313782	1127433		
53134	4413	1124300	1997-11-14	1997-11-14 00:00:00	1997-11-14	1997-11-14 00:00:00	\N	38000177		0	0	0		0	0	0	293419	0	00781178901	45011828		
24901	2046	19133768	2014-04-01	2014-04-01 00:00:00	2014-04-01	2014-04-01 00:00:00	2014-04-01	38000177		0	0	0		0	0	0	136154	0	833036	19133768		
2042	161	1124300	2011-01-01	2011-01-01 00:00:00	2011-01-01	2011-01-01 00:00:00	\N	38000177		0	0	0		0	0	0	11057	0	00781178901	45011828		
9540	795	19133905	2018-09-09	2018-09-09 00:00:00	2018-09-16	2018-09-16 00:00:00	2018-09-16	38000177		0	0	7		0	0	0	52777	0	834102	19133905		
38962	850	40213201	2013-05-21	2013-05-21 00:00:00	2013-05-21	2013-05-21 00:00:00	2013-05-21	581452		0	0	0		0	0	0	56267	0	33	40213201		
28853	2384	1118084	2017-03-04	2017-03-04 00:00:00	2017-03-04	2017-03-04 00:00:00	\N	38000177		0	0	0		0	0	0	158521	0	00025152531	44923712		
35616	2935	19128065	1990-04-04	1990-04-04 00:00:00	1991-03-30	1991-03-30 00:00:00	1991-03-30	38000177		0	0	360		0	0	0	195693	0	749882	19128065		
20180	1658	19133873	1926-06-21	1926-06-21 00:00:00	1926-06-29	1926-06-29 00:00:00	1926-06-29	38000177		0	0	8		0	0	0	111342	0	834061	19133873		
22578	489	40213314	1977-11-06	1977-11-06 00:00:00	1977-11-06	1977-11-06 00:00:00	1977-11-06	581452		0	0	0		0	0	0	32782	0	49	40213314		
42095	3489	1127078	1975-05-16	1975-05-16 00:00:00	1975-05-30	1975-05-30 00:00:00	1975-05-30	38000177		0	0	14		0	0	0	231463	0	282464	1127078		
27779	605	40213160	1961-03-31	1961-03-31 00:00:00	1961-03-31	1961-03-31 00:00:00	1961-03-31	581452		0	0	0		0	0	0	\N	0	10	40213160		
1391	111	1118084	2012-02-07	2012-02-07 00:00:00	2012-02-07	2012-02-07 00:00:00	\N	38000177		0	0	0		0	0	0	7371	0	00025152531	44923712		
14585	1222	1713671	2013-09-06	2013-09-06 00:00:00	2013-09-20	2013-09-20 00:00:00	2013-09-20	38000177		0	0	14		0	0	0	80372	0	562251	1713671		
1573	124	19008572	1992-02-29	1992-02-29 00:00:00	1992-03-14	1992-03-14 00:00:00	1992-03-14	38000177		0	0	14		0	0	0	8317	0	106258	19008572		
12322	1036	46233988	1972-01-08	1972-01-08 00:00:00	1972-01-22	1972-01-22 00:00:00	1972-01-22	38000177		0	0	14		0	0	0	68190	0	1652673	46233988		
40231	3332	1127433	1976-07-31	1976-07-31 00:00:00	1976-08-07	1976-08-07 00:00:00	1976-08-07	38000177		0	0	7		0	0	0	221069	0	313782	1127433		
8125	677	1127433	2016-11-11	2016-11-11 00:00:00	2016-11-25	2016-11-25 00:00:00	2016-11-25	38000177		0	0	14		0	0	0	44813	0	313782	1127433		
40336	3342	40171902	2005-03-30	2005-03-30 00:00:00	2005-03-30	2005-03-30 00:00:00	\N	38000177		0	0	0		0	0	0	221627	0	897718	40171902		
38617	3189	19006318	1965-09-14	1965-09-14 00:00:00	1965-09-28	1965-09-28 00:00:00	1965-09-28	38000177		0	0	14		0	0	0	212238	0	105078	19006318		
35827	2950	19059056	1982-04-15	1982-04-15 00:00:00	1982-06-14	1982-06-14 00:00:00	1982-06-14	38000177		0	0	60		0	0	0	196937	0	243670	19059056		
35845	2951	40229134	1968-10-24	1968-10-24 00:00:00	1968-10-31	1968-10-31 00:00:00	1968-10-31	38000177		0	0	7		0	0	0	197031	0	1043400	40229134		
15271	1276	19115351	1968-03-05	1968-03-05 00:00:00	1968-08-27	1968-08-27 00:00:00	1968-08-27	38000177		0	0	175		0	0	0	84132	0	563026	19115351		
54235	4506	1127433	1978-11-21	1978-11-21 00:00:00	1978-11-28	1978-11-28 00:00:00	1978-11-28	38000177		0	0	7		0	0	0	300221	0	313782	1127433		
33405	2767	19078924	1939-05-24	1939-05-24 00:00:00	1939-05-24	1939-05-24 00:00:00	1939-05-24	38000177		0	0	0		0	0	0	183063	0	311700	19078924		
33361	2765	45892894	2018-05-21	2018-05-21 00:00:00	2018-05-21	2018-05-21 00:00:00	\N	38000177		0	0	0		0	0	0	182847	0	1599803	45892894		
36393	3000	1115171	1994-09-29	1994-09-29 00:00:00	1994-10-20	1994-10-20 00:00:00	1994-10-20	38000177		0	0	21		0	0	0	200181	0	849574	1115171		
57060	4735	1115171	2011-01-15	2011-01-15 00:00:00	2011-04-15	2011-04-15 00:00:00	2011-04-15	38000177		0	0	90		0	0	0	315454	0	849574	1115171		
28123	2326	1127433	2010-02-20	2010-02-20 00:00:00	2010-03-06	2010-03-06 00:00:00	2010-03-06	38000177		0	0	14		0	0	0	154663	0	313782	1127433		
26572	2186	1127433	1986-10-28	1986-10-28 00:00:00	1986-12-02	1986-12-02 00:00:00	1986-12-02	38000177		0	0	35		0	0	0	145826	0	313782	1127433		
52646	1151	40213227	2017-02-07	2017-02-07 00:00:00	2017-02-07	2017-02-07 00:00:00	2017-02-07	581452		0	0	0		0	0	0	76117	0	113	40213227		
21645	1779	1127433	2011-01-30	2011-01-30 00:00:00	2011-02-06	2011-02-06 00:00:00	2011-02-06	38000177		0	0	7		0	0	0	118990	0	313782	1127433		
21689	1781	1127433	1999-10-11	1999-10-11 00:00:00	1999-10-25	1999-10-25 00:00:00	1999-10-25	38000177		0	0	14		0	0	0	119184	0	313782	1127433		
74139	1618	40213306	1996-02-28	1996-02-28 00:00:00	1996-02-28	1996-02-28 00:00:00	1996-02-28	581452		0	0	0		0	0	0	108804	0	43	40213306		
6486	546	1127433	2010-05-17	2010-05-17 00:00:00	2010-06-16	2010-06-16 00:00:00	2010-06-16	38000177		0	0	30		0	0	0	36154	0	313782	1127433		
47737	3957	40236824	2002-10-18	2002-10-18 00:00:00	2002-10-25	2002-10-25 00:00:00	2002-10-25	38000177		0	0	7		0	0	0	263049	0	1094107	40236824		
120418	2647	40213296	2010-12-19	2010-12-19 00:00:00	2010-12-19	2010-12-19 00:00:00	2010-12-19	581452		0	0	0		0	0	0	175184	0	52	40213296		
23513	1936	19078461	2010-08-25	2010-08-25 00:00:00	2010-09-15	2010-09-15 00:00:00	2010-09-15	38000177		0	0	21		0	0	0	128760	0	310965	19078461		
16365	1356	1127433	1983-08-01	1983-08-01 00:00:00	1983-08-29	1983-08-29 00:00:00	1983-08-29	38000177		0	0	28		0	0	0	89861	0	313782	1127433		
10622	884	1310034	2005-05-24	2005-05-24 00:00:00	2005-05-24	2005-05-24 00:00:00	2005-05-24	38000177		0	0	0		0	0	0	58952	0	834357	1310034		
41113	3410	19128065	1982-03-22	1982-03-22 00:00:00	1983-03-17	1983-03-17 00:00:00	1983-03-17	38000177		0	0	360		0	0	0	226168	0	749882	19128065		
58514	4859	19059056	1955-10-17	1955-10-17 00:00:00	1955-10-31	1955-10-31 00:00:00	1955-10-31	38000177		0	0	14		0	0	0	323238	0	243670	19059056		
58568	4861	19133873	1952-04-19	1952-04-19 00:00:00	1952-05-03	1952-05-03 00:00:00	1952-05-03	38000177		0	0	14		0	0	0	323393	0	834061	19133873		
1039	23	40213160	1979-02-15	1979-02-15 00:00:00	1979-02-15	1979-02-15 00:00:00	1979-02-15	581452		0	0	0		0	0	0	1768	0	10	40213160		
30878	2556	1713671	2006-04-24	2006-04-24 00:00:00	2006-05-15	2006-05-15 00:00:00	2006-05-15	38000177		0	0	21		0	0	0	169421	0	562251	1713671		
16727	1385	19128065	1979-04-14	1979-04-14 00:00:00	1980-04-08	1980-04-08 00:00:00	1980-04-08	38000177		0	0	360		0	0	0	91815	0	749882	19128065		
51111	4246	19133873	1973-05-10	1973-05-10 00:00:00	1973-05-18	1973-05-18 00:00:00	1973-05-18	38000177		0	0	8		0	0	0	281955	0	834061	19133873		
22	2	40223768	2000-07-25	2000-07-25 00:00:00	2000-07-25	2000-07-25 00:00:00	\N	38000177		0	0	0		0	0	0	186	0	997223	40223768		
42415	3516	19133873	1957-09-25	1957-09-25 00:00:00	1957-10-04	1957-10-04 00:00:00	1957-10-04	38000177		0	0	9		0	0	0	233321	0	834061	19133873		
48976	4064	19008572	1988-08-09	1988-08-09 00:00:00	1988-08-30	1988-08-30 00:00:00	1988-08-30	38000177		0	0	21		0	0	0	270075	0	106258	19008572		
4125	341	40169281	2018-09-03	2018-09-03 00:00:00	2018-09-03	2018-09-03 00:00:00	\N	38000177		0	0	0		0	0	0	22813	0	896209	40169281		
10634	884	19008572	2012-01-15	2012-01-15 00:00:00	2012-02-05	2012-02-05 00:00:00	2012-02-05	38000177		0	0	21		0	0	0	58930	0	106258	19008572		
14666	1228	1713671	2019-01-05	2019-01-05 00:00:00	2019-01-26	2019-01-26 00:00:00	2019-01-26	38000177		0	0	21		0	0	0	80904	0	562251	1713671		
43361	3595	19059056	1951-05-04	1951-05-04 00:00:00	1951-06-08	1951-06-08 00:00:00	1951-06-08	38000177		0	0	35		0	0	0	238829	0	243670	19059056		
36310	2992	19133905	1998-07-19	1998-07-19 00:00:00	1998-07-28	1998-07-28 00:00:00	1998-07-28	38000177		0	0	9		0	0	0	199688	0	834102	19133905		
111942	2459	40213160	1977-02-28	1977-02-28 00:00:00	1977-02-28	1977-02-28 00:00:00	1977-02-28	581452		0	0	0		0	0	0	163065	0	10	40213160		
2328	187	1127433	1980-01-09	1980-01-09 00:00:00	1980-01-30	1980-01-30 00:00:00	1980-01-30	38000177		0	0	21		0	0	0	12736	0	313782	1127433		
3526	292	1118084	2017-01-16	2017-01-16 00:00:00	2017-01-16	2017-01-16 00:00:00	\N	38000177		0	0	0		0	0	0	19461	0	00025152531	44923712		
41767	3457	1127433	2011-04-18	2011-04-18 00:00:00	2011-04-25	2011-04-25 00:00:00	2011-04-25	38000177		0	0	7		0	0	0	229332	0	313782	1127433		
102108	2238	40213296	2010-08-15	2010-08-15 00:00:00	2010-08-15	2010-08-15 00:00:00	2010-08-15	581452		0	0	0		0	0	0	148881	0	52	40213296		
31987	2651	1127433	1963-03-18	1963-03-18 00:00:00	1963-04-01	1963-04-01 00:00:00	1963-04-01	38000177		0	0	14		0	0	0	175448	0	313782	1127433		
176677	3884	40213160	1977-03-07	1977-03-07 00:00:00	1977-03-07	1977-03-07 00:00:00	1977-03-07	581452		0	0	0		0	0	0	258198	0	10	40213160		
51428	4274	1115171	2002-07-03	2002-07-03 00:00:00	2002-10-01	2002-10-01 00:00:00	2002-10-01	38000177		0	0	90		0	0	0	283562	0	849574	1115171		
42811	3547	46233988	1976-02-07	1976-02-07 00:00:00	1976-02-21	1976-02-21 00:00:00	1976-02-21	38000177		0	0	14		0	0	0	235571	0	1652673	46233988		
60360	5022	19059056	1992-01-07	1992-01-07 00:00:00	1992-01-28	1992-01-28 00:00:00	1992-01-28	38000177		0	0	21		0	0	0	333661	0	243670	19059056		
53135	4413	19133873	1962-07-13	1962-07-13 00:00:00	1962-07-21	1962-07-21 00:00:00	1962-07-21	38000177		0	0	8		0	0	0	293456	0	834061	19133873		
24902	2046	40229134	1961-04-01	1961-04-01 00:00:00	1961-04-08	1961-04-08 00:00:00	1961-04-08	38000177		0	0	7		0	0	0	136087	0	1043400	40229134		
2043	161	1115171	2009-06-10	2009-06-10 00:00:00	2009-07-01	2009-07-01 00:00:00	2009-07-01	38000177		0	0	21		0	0	0	11057	0	849574	1115171		
9541	795	40229134	1978-02-20	1978-02-20 00:00:00	1978-02-27	1978-02-27 00:00:00	1978-02-27	38000177		0	0	7		0	0	0	52751	0	1043400	40229134		
38964	851	40213251	1984-05-07	1984-05-07 00:00:00	1984-05-07	1984-05-07 00:00:00	1984-05-07	581452		0	0	0		0	0	0	56274	0	21	40213251		
28854	2384	19078461	2008-09-10	2008-09-10 00:00:00	2008-09-24	2008-09-24 00:00:00	2008-09-24	38000177		0	0	14		0	0	0	158498	0	310965	19078461		
35617	2935	19078461	2004-02-08	2004-02-08 00:00:00	2004-02-22	2004-02-22 00:00:00	2004-02-22	38000177		0	0	14		0	0	0	195681	0	310965	19078461		
20181	1658	1713671	1952-03-09	1952-03-09 00:00:00	1952-03-30	1952-03-30 00:00:00	1952-03-30	38000177		0	0	21		0	0	0	111414	0	562251	1713671		
22580	489	40213296	2015-07-12	2015-07-12 00:00:00	2015-07-12	2015-07-12 00:00:00	2015-07-12	581452		0	0	0		0	0	0	32770	0	52	40213296		
42096	3489	19128065	1986-10-25	1986-10-25 00:00:00	1987-10-20	1987-10-20 00:00:00	1987-10-20	38000177		0	0	360		0	0	0	231449	0	749882	19128065		
27784	605	40213160	1957-02-22	1957-02-22 00:00:00	1957-02-22	1957-02-22 00:00:00	1957-02-22	581452		0	0	0		0	0	0	40167	0	10	40213160		
1392	111	19128022	1996-03-27	1996-03-27 00:00:00	1997-03-22	1997-03-22 00:00:00	1997-03-22	38000177		0	0	360		0	0	0	7379	0	749785	19128022		
14586	1223	1127433	2015-01-24	2015-01-24 00:00:00	2015-02-07	2015-02-07 00:00:00	2015-02-07	38000177		0	0	14		0	0	0	80526	0	313782	1127433		
1574	124	19078461	2001-05-06	2001-05-06 00:00:00	2001-06-03	2001-06-03 00:00:00	2001-06-03	38000177		0	0	28		0	0	0	8291	0	310965	19078461		
12323	1036	19059056	1970-11-29	1970-11-29 00:00:00	1970-12-13	1970-12-13 00:00:00	1970-12-13	38000177		0	0	14		0	0	0	68189	0	243670	19059056		
40232	3332	40229134	1982-03-25	1982-03-25 00:00:00	1982-04-01	1982-04-01 00:00:00	1982-04-01	38000177		0	0	7		0	0	0	221072	0	1043400	40229134		
8126	677	19133873	1972-03-22	1972-03-22 00:00:00	1972-03-31	1972-03-31 00:00:00	1972-03-31	38000177		0	0	9		0	0	0	44806	0	834061	19133873		
40337	3342	1713671	1913-03-19	1913-03-19 00:00:00	1913-04-09	1913-04-09 00:00:00	1913-04-09	38000177		0	0	21		0	0	0	221571	0	562251	1713671		
38619	3189	1118084	2000-03-29	2000-03-29 00:00:00	2000-03-29	2000-03-29 00:00:00	\N	38000177		0	0	0		0	0	0	212300	0	00025152531	44923712		
35828	2950	1713671	2001-04-29	2001-04-29 00:00:00	2001-05-20	2001-05-20 00:00:00	2001-05-20	38000177		0	0	21		0	0	0	196973	0	562251	1713671		
35846	2951	40229134	1965-03-06	1965-03-06 00:00:00	1965-03-13	1965-03-13 00:00:00	1965-03-13	38000177		0	0	7		0	0	0	197058	0	1043400	40229134		
15272	1276	1713671	1998-02-07	1998-02-07 00:00:00	1998-02-28	1998-02-28 00:00:00	1998-02-28	38000177		0	0	21		0	0	0	84194	0	562251	1713671		
54236	4506	1115171	2001-10-13	2001-10-13 00:00:00	2001-12-12	2001-12-12 00:00:00	2001-12-12	38000177		0	0	60		0	0	0	300228	0	849574	1115171		
33406	2767	19059528	1939-05-24	1939-05-24 00:00:00	1939-05-24	1939-05-24 00:00:00	1939-05-24	38000177		0	0	0		0	0	0	183063	0	480	19059528		
33362	2765	40229134	1949-06-04	1949-06-04 00:00:00	1949-06-18	1949-06-18 00:00:00	1949-06-18	38000177		0	0	14		0	0	0	182938	0	1043400	40229134		
36394	3000	19059056	1961-04-08	1961-04-08 00:00:00	1961-07-07	1961-07-07 00:00:00	1961-07-07	38000177		0	0	90		0	0	0	200176	0	243670	19059056		
57061	4736	1127433	1994-09-30	1994-09-30 00:00:00	1994-10-14	1994-10-14 00:00:00	1994-10-14	38000177		0	0	14		0	0	0	315478	0	313782	1127433		
28124	2326	19078461	2015-10-15	2015-10-15 00:00:00	2015-11-12	2015-11-12 00:00:00	2015-11-12	38000177		0	0	28		0	0	0	154724	0	310965	19078461		
26573	2186	1127433	1987-02-26	1987-02-26 00:00:00	1987-03-12	1987-03-12 00:00:00	1987-03-12	38000177		0	0	14		0	0	0	145817	0	313782	1127433		
52654	1151	40213160	1985-02-26	1985-02-26 00:00:00	1985-02-26	1985-02-26 00:00:00	1985-02-26	581452		0	0	0		0	0	0	76092	0	10	40213160		
21646	1779	40231925	1976-07-14	1976-07-14 00:00:00	1976-07-14	1976-07-14 00:00:00	\N	38000177		0	0	0		0	0	0	119068	0	1049221	40231925		
21690	1781	40229134	2002-10-04	2002-10-04 00:00:00	2002-10-11	2002-10-11 00:00:00	2002-10-11	38000177		0	0	7		0	0	0	119185	0	1043400	40229134		
74141	1618	40213227	1996-02-28	1996-02-28 00:00:00	1996-02-28	1996-02-28 00:00:00	1996-02-28	581452		0	0	0		0	0	0	108804	0	113	40213227		
6487	546	40231925	2010-05-17	2010-05-17 00:00:00	2010-05-17	2010-05-17 00:00:00	\N	38000177		0	0	0		0	0	0	36154	0	1049221	40231925		
47738	3957	920300	2002-10-18	2002-10-18 00:00:00	2002-10-25	2002-10-25 00:00:00	2002-10-25	38000177		0	0	7		0	0	0	263049	0	311989	920300		
128419	2825	40213227	2016-03-08	2016-03-08 00:00:00	2016-03-08	2016-03-08 00:00:00	2016-03-08	581452		0	0	0		0	0	0	187242	0	113	40213227		
23514	1936	40229134	2013-08-15	2013-08-15 00:00:00	2013-08-22	2013-08-22 00:00:00	2013-08-22	38000177		0	0	7		0	0	0	128773	0	1043400	40229134		
16366	1356	1118084	2016-09-11	2016-09-11 00:00:00	2016-09-11	2016-09-11 00:00:00	\N	38000177		0	0	0		0	0	0	89906	0	00025152531	44923712		
10623	884	46275916	2005-05-24	2005-05-24 00:00:00	2005-05-24	2005-05-24 00:00:00	2005-05-24	38000177		0	0	0		0	0	0	58952	0	1660014	46275916		
41114	3410	19128065	1984-03-11	1984-03-11 00:00:00	1985-03-06	1985-03-06 00:00:00	1985-03-06	38000177		0	0	360		0	0	0	226169	0	749882	19128065		
58515	4859	19006318	1955-10-17	1955-10-17 00:00:00	1955-10-31	1955-10-31 00:00:00	1955-10-31	38000177		0	0	14		0	0	0	323238	0	105078	19006318		
58569	4861	19006318	1948-04-23	1948-04-23 00:00:00	1948-05-08	1948-05-08 00:00:00	1948-05-08	38000177		0	0	15		0	0	0	323411	0	105078	19006318		
1041	23	40213160	1979-05-17	1979-05-17 00:00:00	1979-05-17	1979-05-17 00:00:00	1979-05-17	581452		0	0	0		0	0	0	1807	0	10	40213160		
30879	2556	1127433	1978-05-14	1978-05-14 00:00:00	1978-05-21	1978-05-21 00:00:00	1978-05-21	38000177		0	0	7		0	0	0	169419	0	313782	1127433		
16728	1385	1713671	2008-07-20	2008-07-20 00:00:00	2008-09-07	2008-09-07 00:00:00	2008-09-07	38000177		0	0	49		0	0	0	91840	0	562251	1713671		
51112	4246	1118084	2005-01-12	2005-01-12 00:00:00	2005-01-12	2005-01-12 00:00:00	\N	38000177		0	0	0		0	0	0	281967	0	00025152531	44923712		
23	2	1127433	1990-04-14	1990-04-14 00:00:00	1990-07-13	1990-07-13 00:00:00	1990-07-13	38000177		0	0	90		0	0	0	116	0	313782	1127433		
42433	3518	40165015	1978-09-15	1978-09-15 00:00:00	1978-09-15	1978-09-15 00:00:00	\N	38000177		0	0	0		0	0	0	233585	0	861467	40165015		
48977	4064	19008572	1978-11-15	1978-11-15 00:00:00	1978-11-29	1978-11-29 00:00:00	1978-11-29	38000177		0	0	14		0	0	0	269985	0	106258	19008572		
4126	341	1124300	1995-08-27	1995-08-27 00:00:00	1995-08-27	1995-08-27 00:00:00	\N	38000177		0	0	0		0	0	0	22800	0	00781178901	45011828		
10635	884	19019979	1984-09-11	1984-09-11 00:00:00	1984-10-02	1984-10-02 00:00:00	1984-10-02	38000177		0	0	21		0	0	0	58949	0	198405	19019979		
14667	1228	1118084	2009-01-13	2009-01-13 00:00:00	2009-01-13	2009-01-13 00:00:00	\N	38000177		0	0	0		0	0	0	80902	0	00025152531	44923712		
43362	3595	1127433	1985-06-09	1985-06-09 00:00:00	1985-09-07	1985-09-07 00:00:00	1985-09-07	38000177		0	0	90		0	0	0	238831	0	313782	1127433		
36311	2992	1118084	1991-12-29	1991-12-29 00:00:00	1991-12-29	1991-12-29 00:00:00	\N	38000177		0	0	0		0	0	0	199721	0	00025152531	44923712		
28539	2351	19133905	1998-02-27	1998-02-27 00:00:00	1998-03-11	1998-03-11 00:00:00	1998-03-11	38000177		0	0	12		0	0	0	156518	0	834102	19133905		
2329	187	19059056	1977-03-20	1977-03-20 00:00:00	1977-04-25	1977-04-25 00:00:00	1977-04-25	38000177		0	0	36		0	0	0	12735	0	243670	19059056		
3527	292	1127433	1985-01-26	1985-01-26 00:00:00	1985-02-09	1985-02-09 00:00:00	1985-02-09	38000177		0	0	14		0	0	0	19469	0	313782	1127433		
41768	3457	19133873	1926-10-11	1926-10-11 00:00:00	1926-10-20	1926-10-20 00:00:00	1926-10-20	38000177		0	0	9		0	0	0	229404	0	834061	19133873		
102111	2238	40213227	2000-05-28	2000-05-28 00:00:00	2000-05-28	2000-05-28 00:00:00	2000-05-28	581452		0	0	0		0	0	0	148991	0	113	40213227		
31988	2651	19059056	1951-05-25	1951-05-25 00:00:00	1951-06-08	1951-06-08 00:00:00	1951-06-08	38000177		0	0	14		0	0	0	175447	0	243670	19059056		
176684	3884	40213160	1972-07-03	1972-07-03 00:00:00	1972-07-03	1972-07-03 00:00:00	1972-07-03	581452		0	0	0		0	0	0	258033	0	10	40213160		
51429	4274	40229134	1978-11-10	1978-11-10 00:00:00	1978-11-17	1978-11-17 00:00:00	1978-11-17	38000177		0	0	7		0	0	0	283620	0	1043400	40229134		
42812	3547	19059056	1976-02-07	1976-02-07 00:00:00	1976-02-21	1976-02-21 00:00:00	1976-02-21	38000177		0	0	14		0	0	0	235571	0	243670	19059056		
60361	5022	19078461	1986-01-24	1986-01-24 00:00:00	1986-02-07	1986-02-07 00:00:00	1986-02-07	38000177		0	0	14		0	0	0	333660	0	310965	19078461		
53136	4413	1127078	1964-02-03	1964-02-03 00:00:00	1964-02-17	1964-02-17 00:00:00	1964-02-17	38000177		0	0	14		0	0	0	293467	0	282464	1127078		
24903	2046	1713671	1973-06-13	1973-06-13 00:00:00	1973-06-27	1973-06-27 00:00:00	1973-06-27	38000177		0	0	14		0	0	0	136179	0	562251	1713671		
2044	161	1713671	2012-02-11	2012-02-11 00:00:00	2012-02-25	2012-02-25 00:00:00	2012-02-25	38000177		0	0	14		0	0	0	11029	0	562251	1713671		
9542	795	19078461	2000-11-02	2000-11-02 00:00:00	2000-11-16	2000-11-16 00:00:00	2000-11-16	38000177		0	0	14		0	0	0	52734	0	310965	19078461		
23075	1903	1127433	2014-08-21	2014-08-21 00:00:00	2014-08-28	2014-08-28 00:00:00	2014-08-28	38000177		0	0	7		0	0	0	126725	0	313782	1127433		
28855	2384	1127433	2003-10-11	2003-10-11 00:00:00	2003-10-18	2003-10-18 00:00:00	2003-10-18	38000177		0	0	7		0	0	0	158483	0	313782	1127433		
35618	2936	1127433	2008-02-26	2008-02-26 00:00:00	2008-03-11	2008-03-11 00:00:00	2008-03-11	38000177		0	0	14		0	0	0	195783	0	313782	1127433		
20182	1658	19075601	1997-02-24	1997-02-24 00:00:00	1997-02-24	1997-02-24 00:00:00	\N	38000177		0	0	0		0	0	0	111365	0	309362	19075601		
23040	500	40213160	1962-05-29	1962-05-29 00:00:00	1962-05-29	1962-05-29 00:00:00	1962-05-29	581452		0	0	0		0	0	0	33529	0	10	40213160		
42097	3490	1713671	1983-03-27	1983-03-27 00:00:00	1983-04-03	1983-04-03 00:00:00	1983-04-03	38000177		0	0	7		0	0	0	231584	0	562251	1713671		
27786	605	40213260	2008-01-04	2008-01-04 00:00:00	2008-01-04	2008-01-04 00:00:00	2008-01-04	581452		0	0	0		0	0	0	40137	0	121	40213260		
1393	111	40236824	1994-05-25	1994-05-25 00:00:00	1994-06-01	1994-06-01 00:00:00	1994-06-01	38000177		0	0	7		0	0	0	7373	0	1094107	40236824		
14587	1223	1713671	2003-12-19	2003-12-19 00:00:00	2004-01-02	2004-01-02 00:00:00	2004-01-02	38000177		0	0	14		0	0	0	80517	0	562251	1713671		
1575	124	1127078	1988-03-29	1988-03-29 00:00:00	1988-04-13	1988-04-13 00:00:00	1988-04-13	38000177		0	0	15		0	0	0	8209	0	282464	1127078		
12324	1036	19078461	1983-10-22	1983-10-22 00:00:00	1984-01-20	1984-01-20 00:00:00	1984-01-20	38000177		0	0	90		0	0	0	68136	0	310965	19078461		
40233	3332	19128065	1976-11-22	1976-11-22 00:00:00	1977-11-17	1977-11-17 00:00:00	1977-11-17	38000177		0	0	360		0	0	0	221078	0	749882	19128065		
8127	677	1127078	1967-03-03	1967-03-03 00:00:00	1967-04-07	1967-04-07 00:00:00	1967-04-07	38000177		0	0	35		0	0	0	44810	0	282464	1127078		
40338	3342	19133873	1914-03-17	1914-03-17 00:00:00	1914-03-30	1914-03-30 00:00:00	1914-03-30	38000177		0	0	13		0	0	0	221572	0	834061	19133873		
38620	3189	19059056	1987-10-17	1987-10-17 00:00:00	1987-11-07	1987-11-07 00:00:00	1987-11-07	38000177		0	0	21		0	0	0	212272	0	243670	19059056		
35829	2950	1713671	1943-03-15	1943-03-15 00:00:00	1943-04-05	1943-04-05 00:00:00	1943-04-05	38000177		0	0	21		0	0	0	196954	0	562251	1713671		
35847	2951	19129655	1964-01-03	1964-01-03 00:00:00	1964-01-19	1964-01-19 00:00:00	1964-01-19	38000177		0	0	16		0	0	0	197036	0	789980	19129655		
25731	2116	1127433	1979-03-26	1979-03-26 00:00:00	1979-04-09	1979-04-09 00:00:00	1979-04-09	38000177		0	0	14		0	0	0	140793	0	313782	1127433		
54237	4506	40165015	2001-10-13	2001-10-13 00:00:00	2001-10-13	2001-10-13 00:00:00	\N	38000177		0	0	0		0	0	0	300228	0	861467	40165015		
33407	2767	1127433	1961-08-01	1961-08-01 00:00:00	1961-08-15	1961-08-15 00:00:00	1961-08-15	38000177		0	0	14		0	0	0	183022	0	313782	1127433		
33363	2765	1127433	1952-12-11	1952-12-11 00:00:00	1953-01-01	1953-01-01 00:00:00	1953-01-01	38000177		0	0	21		0	0	0	182888	0	313782	1127433		
36395	3000	1127433	1970-11-08	1970-11-08 00:00:00	1970-11-22	1970-11-22 00:00:00	1970-11-22	38000177		0	0	14		0	0	0	200178	0	313782	1127433		
57062	4736	1713671	2001-07-29	2001-07-29 00:00:00	2001-08-12	2001-08-12 00:00:00	2001-08-12	38000177		0	0	14		0	0	0	315487	0	562251	1713671		
28126	2326	40229134	1999-04-05	1999-04-05 00:00:00	1999-04-19	1999-04-19 00:00:00	1999-04-19	38000177		0	0	14		0	0	0	154676	0	1043400	40229134		
26574	2186	1127433	2003-09-09	2003-09-09 00:00:00	2003-09-30	2003-09-30 00:00:00	2003-09-30	38000177		0	0	21		0	0	0	145830	0	313782	1127433		
52655	1151	40213314	1985-02-26	1985-02-26 00:00:00	1985-02-26	1985-02-26 00:00:00	1985-02-26	581452		0	0	0		0	0	0	76092	0	49	40213314		
21647	1779	1127433	1976-07-14	1976-07-14 00:00:00	1976-10-12	1976-10-12 00:00:00	1976-10-12	38000177		0	0	90		0	0	0	119068	0	313782	1127433		
21691	1781	1713671	1995-06-19	1995-06-19 00:00:00	1995-07-03	1995-07-03 00:00:00	1995-07-03	38000177		0	0	14		0	0	0	119251	0	562251	1713671		
74142	1618	40213296	2015-05-27	2015-05-27 00:00:00	2015-05-27	2015-05-27 00:00:00	2015-05-27	581452		0	0	0		0	0	0	108783	0	52	40213296		
6488	546	1127078	1953-10-22	1953-10-22 00:00:00	1954-01-20	1954-01-20 00:00:00	1954-01-20	38000177		0	0	90		0	0	0	36150	0	282464	1127078		
47739	3958	1127433	2017-06-26	2017-06-26 00:00:00	2017-07-10	2017-07-10 00:00:00	2017-07-10	38000177		0	0	14		0	0	0	263150	0	313782	1127433		
47768	3960	19059056	1972-12-26	1972-12-26 00:00:00	1973-01-23	1973-01-23 00:00:00	1973-01-23	38000177		0	0	28		0	0	0	263312	0	243670	19059056		
23516	1936	1127433	1962-12-31	1962-12-31 00:00:00	1963-01-07	1963-01-07 00:00:00	1963-01-07	38000177		0	0	7		0	0	0	128827	0	313782	1127433		
16367	1356	19078461	2016-08-07	2016-08-07 00:00:00	2016-08-21	2016-08-21 00:00:00	2016-08-21	38000177		0	0	14		0	0	0	89906	0	310965	19078461		
10624	884	19008572	1987-05-30	1987-05-30 00:00:00	1987-06-20	1987-06-20 00:00:00	1987-06-20	38000177		0	0	21		0	0	0	58858	0	106258	19008572		
41116	3410	19059056	1964-08-13	1964-08-13 00:00:00	1964-08-27	1964-08-27 00:00:00	1964-08-27	38000177		0	0	14		0	0	0	226210	0	243670	19059056		
58517	4859	40229134	1963-10-17	1963-10-17 00:00:00	1963-10-31	1963-10-31 00:00:00	1963-10-31	38000177		0	0	14		0	0	0	323277	0	1043400	40229134		
58570	4861	19059056	1948-04-23	1948-04-23 00:00:00	1948-05-08	1948-05-08 00:00:00	1948-05-08	38000177		0	0	15		0	0	0	323411	0	243670	19059056		
1043	23	40213227	2000-11-16	2000-11-16 00:00:00	2000-11-16	2000-11-16 00:00:00	2000-11-16	581452		0	0	0		0	0	0	1798	0	113	40213227		
30880	2556	1127433	2007-12-14	2007-12-14 00:00:00	2008-01-18	2008-01-18 00:00:00	2008-01-18	38000177		0	0	35		0	0	0	169428	0	313782	1127433		
16729	1385	1127433	2012-01-26	2012-01-26 00:00:00	2012-02-02	2012-02-02 00:00:00	2012-02-02	38000177		0	0	7		0	0	0	91841	0	313782	1127433		
51113	4247	1127433	1994-01-21	1994-01-21 00:00:00	1994-01-28	1994-01-28 00:00:00	1994-01-28	38000177		0	0	7		0	0	0	282045	0	313782	1127433		
24	2	19059056	1952-07-13	1952-07-13 00:00:00	1952-07-27	1952-07-27 00:00:00	1952-07-27	38000177		0	0	14		0	0	0	113	0	243670	19059056		
42434	3518	19078461	1981-09-29	1981-09-29 00:00:00	1981-11-03	1981-11-03 00:00:00	1981-11-03	38000177		0	0	35		0	0	0	233583	0	310965	19078461		
48978	4064	1551192	1966-02-08	1966-02-08 00:00:00	1966-02-08	1966-02-08 00:00:00	1966-02-08	38000177		0	0	0		0	0	0	269996	0	312617	1551192		
7728	648	40220960	2015-09-25	2015-09-25 00:00:00	2015-09-25	2015-09-25 00:00:00	2015-09-25	38000177		0	0	0		0	0	0	42861	0	1804799	40220960		
10636	884	19128022	1993-08-23	1993-08-23 00:00:00	1994-08-18	1994-08-18 00:00:00	1994-08-18	38000177		0	0	360		0	0	0	58870	0	749785	19128022		
14668	1228	19019979	1980-01-06	1980-01-06 00:00:00	1980-03-13	1980-03-13 00:00:00	1980-03-13	38000177		0	0	67		0	0	0	80894	0	198405	19019979		
43363	3595	1118084	1993-10-20	1993-10-20 00:00:00	1993-10-20	1993-10-20 00:00:00	\N	38000177		0	0	0		0	0	0	238807	0	00025152531	44923712		
36312	2992	19133873	1968-09-27	1968-09-27 00:00:00	1968-10-04	1968-10-04 00:00:00	1968-10-04	38000177		0	0	7		0	0	0	199685	0	834061	19133873		
28540	2351	1127433	2009-11-25	2009-11-25 00:00:00	2009-12-09	2009-12-09 00:00:00	2009-12-09	38000177		0	0	14		0	0	0	156510	0	313782	1127433		
2330	187	1118084	1984-11-29	1984-11-29 00:00:00	1984-11-29	1984-11-29 00:00:00	\N	38000177		0	0	0		0	0	0	12684	0	00025152531	44923712		
3528	292	1127433	1988-07-07	1988-07-07 00:00:00	1988-08-04	1988-08-04 00:00:00	1988-08-04	38000177		0	0	28		0	0	0	19452	0	313782	1127433		
41769	3457	19059056	1938-07-06	1938-07-06 00:00:00	1938-07-20	1938-07-20 00:00:00	1938-07-20	38000177		0	0	14		0	0	0	229383	0	243670	19059056		
108673	2384	40213314	1985-04-30	1985-04-30 00:00:00	1985-04-30	1985-04-30 00:00:00	1985-04-30	581452		0	0	0		0	0	0	158479	0	49	40213314		
31989	2651	19006318	1951-05-25	1951-05-25 00:00:00	1951-06-08	1951-06-08 00:00:00	1951-06-08	38000177		0	0	14		0	0	0	175447	0	105078	19006318		
176687	3884	40213160	1972-12-04	1972-12-04 00:00:00	1972-12-04	1972-12-04 00:00:00	1972-12-04	581452		0	0	0		0	0	0	258056	0	10	40213160		
51430	4274	40236824	1949-12-31	1949-12-31 00:00:00	1950-01-07	1950-01-07 00:00:00	1950-01-07	38000177		0	0	7		0	0	0	283665	0	1094107	40236824		
42813	3547	19078461	2001-03-02	2001-03-02 00:00:00	2001-03-23	2001-03-23 00:00:00	2001-03-23	38000177		0	0	21		0	0	0	235542	0	310965	19078461		
60362	5022	920300	1993-01-21	1993-01-21 00:00:00	1993-01-28	1993-01-28 00:00:00	1993-01-28	38000177		0	0	7		0	0	0	333695	0	311989	920300		
53137	4413	19128065	1975-11-30	1975-11-30 00:00:00	1976-11-24	1976-11-24 00:00:00	1976-11-24	38000177		0	0	360		0	0	0	293469	0	749882	19128065		
24929	2051	19019979	1974-05-10	1974-05-10 00:00:00	1974-05-31	1974-05-31 00:00:00	1974-05-31	38000177		0	0	21		0	0	0	136397	0	198405	19019979		
12521	1054	19059056	1956-02-14	1956-02-14 00:00:00	1956-02-28	1956-02-28 00:00:00	1956-02-28	38000177		0	0	14		0	0	0	69131	0	243670	19059056		
9543	795	19133905	2018-12-17	2018-12-17 00:00:00	2018-12-26	2018-12-26 00:00:00	2018-12-26	38000177		0	0	9		0	0	0	52745	0	834102	19133905		
23077	1903	1127433	2009-05-04	2009-05-04 00:00:00	2009-05-25	2009-05-25 00:00:00	2009-05-25	38000177		0	0	21		0	0	0	126667	0	313782	1127433		
28856	2384	19133873	1985-02-19	1985-02-19 00:00:00	1985-03-04	1985-03-04 00:00:00	1985-03-04	38000177		0	0	13		0	0	0	158471	0	834061	19133873		
35619	2936	1127433	1971-03-03	1971-03-03 00:00:00	1971-03-10	1971-03-10 00:00:00	1971-03-10	38000177		0	0	7		0	0	0	195766	0	313782	1127433		
20183	1658	19059056	1912-09-22	1912-09-22 00:00:00	1912-10-06	1912-10-06 00:00:00	1912-10-06	38000177		0	0	14		0	0	0	111298	0	243670	19059056		
23046	500	40213160	1961-12-26	1961-12-26 00:00:00	1961-12-26	1961-12-26 00:00:00	1961-12-26	581452		0	0	0		0	0	0	33528	0	10	40213160		
42098	3490	1124300	1987-06-21	1987-06-21 00:00:00	1987-06-21	1987-06-21 00:00:00	\N	38000177		0	0	0		0	0	0	231511	0	00781178901	45011828		
27788	605	40213227	2008-01-04	2008-01-04 00:00:00	2008-01-04	2008-01-04 00:00:00	2008-01-04	581452		0	0	0		0	0	0	40137	0	113	40213227		
1394	111	920300	1994-05-25	1994-05-25 00:00:00	1994-06-01	1994-06-01 00:00:00	1994-06-01	38000177		0	0	7		0	0	0	7373	0	311989	920300		
14588	1223	19133873	1959-12-23	1959-12-23 00:00:00	1959-12-30	1959-12-30 00:00:00	1959-12-30	38000177		0	0	7		0	0	0	80449	0	834061	19133873		
1576	124	19073183	1988-03-29	1988-03-29 00:00:00	1988-04-13	1988-04-13 00:00:00	1988-04-13	38000177		0	0	15		0	0	0	8209	0	308182	19073183		
12325	1036	40162522	1983-10-22	1983-10-22 00:00:00	1983-10-22	1983-10-22 00:00:00	\N	38000177		0	0	0		0	0	0	68136	0	857005	40162522		
40234	3332	19059056	1964-04-03	1964-04-03 00:00:00	1964-04-17	1964-04-17 00:00:00	1964-04-17	38000177		0	0	14		0	0	0	221052	0	243670	19059056		
8128	677	1118084	1997-01-09	1997-01-09 00:00:00	1997-01-09	1997-01-09 00:00:00	\N	38000177		0	0	0		0	0	0	44801	0	00025152531	44923712		
50797	4220	1127433	1973-03-18	1973-03-18 00:00:00	1973-04-01	1973-04-01 00:00:00	1973-04-01	38000177		0	0	14		0	0	0	280197	0	313782	1127433		
38621	3189	40229134	2002-12-01	2002-12-01 00:00:00	2002-12-15	2002-12-15 00:00:00	2002-12-15	38000177		0	0	14		0	0	0	212234	0	1043400	40229134		
35830	2950	1713671	2014-06-13	2014-06-13 00:00:00	2014-07-04	2014-07-04 00:00:00	2014-07-04	38000177		0	0	21		0	0	0	196984	0	562251	1713671		
35848	2951	1127433	1983-09-21	1983-09-21 00:00:00	1983-09-28	1983-09-28 00:00:00	1983-09-28	38000177		0	0	7		0	0	0	197047	0	313782	1127433		
25732	2116	1713671	2019-06-11	2019-06-11 00:00:00	2019-06-18	2019-06-18 00:00:00	2019-06-18	38000177		0	0	7		0	0	0	140851	0	562251	1713671		
54238	4506	1127078	1955-11-14	1955-11-14 00:00:00	1956-01-13	1956-01-13 00:00:00	1956-01-13	38000177		0	0	60		0	0	0	300227	0	282464	1127078		
33408	2767	1127433	1957-11-11	1957-11-11 00:00:00	1957-11-18	1957-11-18 00:00:00	1957-11-18	38000177		0	0	7		0	0	0	183049	0	313782	1127433		
33364	2765	19133905	1956-07-26	1956-07-26 00:00:00	1956-08-03	1956-08-03 00:00:00	1956-08-03	38000177		0	0	8		0	0	0	182875	0	834102	19133905		
36396	3000	19129655	1970-11-08	1970-11-08 00:00:00	1970-11-22	1970-11-22 00:00:00	1970-11-22	38000177		0	0	14		0	0	0	200178	0	789980	19129655		
57063	4736	1713671	1974-10-10	1974-10-10 00:00:00	1974-10-31	1974-10-31 00:00:00	1974-10-31	38000177		0	0	21		0	0	0	315482	0	562251	1713671		
28127	2326	19078461	1985-02-23	1985-02-23 00:00:00	1985-03-16	1985-03-16 00:00:00	1985-03-16	38000177		0	0	21		0	0	0	154671	0	310965	19078461		
26575	2186	19078461	1987-10-28	1987-10-28 00:00:00	1987-11-11	1987-11-11 00:00:00	1987-11-11	38000177		0	0	14		0	0	0	145827	0	310965	19078461		
21587	1776	19059056	1931-08-23	1931-08-23 00:00:00	1931-09-13	1931-09-13 00:00:00	1931-09-13	38000177		0	0	21		0	0	0	118801	0	243670	19059056		
21648	1779	19059056	1955-03-23	1955-03-23 00:00:00	1955-04-06	1955-04-06 00:00:00	1955-04-06	38000177		0	0	14		0	0	0	119066	0	243670	19059056		
21692	1781	19133873	1941-08-11	1941-08-11 00:00:00	1941-08-19	1941-08-19 00:00:00	1941-08-19	38000177		0	0	8		0	0	0	119194	0	834061	19133873		
74143	1618	40213227	2015-05-27	2015-05-27 00:00:00	2015-05-27	2015-05-27 00:00:00	2015-05-27	581452		0	0	0		0	0	0	108783	0	113	40213227		
6489	546	1127433	1961-10-10	1961-10-10 00:00:00	1962-01-08	1962-01-08 00:00:00	1962-01-08	38000177		0	0	90		0	0	0	36151	0	313782	1127433		
47740	3958	1127078	1968-10-31	1968-10-31 00:00:00	1968-11-14	1968-11-14 00:00:00	1968-11-14	38000177		0	0	14		0	0	0	263186	0	282464	1127078		
47769	3960	1713671	1970-09-07	1970-09-07 00:00:00	1970-09-21	1970-09-21 00:00:00	1970-09-21	38000177		0	0	14		0	0	0	263251	0	562251	1713671		
23517	1936	1127433	1965-02-03	1965-02-03 00:00:00	1965-03-10	1965-03-10 00:00:00	1965-03-10	38000177		0	0	35		0	0	0	128757	0	313782	1127433		
16368	1356	1713671	1981-06-19	1981-06-19 00:00:00	1981-07-03	1981-07-03 00:00:00	1981-07-03	38000177		0	0	14		0	0	0	89940	0	562251	1713671		
21083	1738	19078461	2014-12-19	2014-12-19 00:00:00	2015-01-02	2015-01-02 00:00:00	2015-01-02	38000177		0	0	14		0	0	0	116168	0	310965	19078461		
41117	3410	19129655	1964-08-13	1964-08-13 00:00:00	1964-08-27	1964-08-27 00:00:00	1964-08-27	38000177		0	0	14		0	0	0	226210	0	789980	19129655		
58518	4859	1127433	1982-07-11	1982-07-11 00:00:00	1982-09-09	1982-09-09 00:00:00	1982-09-09	38000177		0	0	60		0	0	0	323227	0	313782	1127433		
58571	4861	1713671	1956-07-16	1956-07-16 00:00:00	1956-07-30	1956-07-30 00:00:00	1956-07-30	38000177		0	0	14		0	0	0	323421	0	562251	1713671		
1044	23	40213306	2000-11-16	2000-11-16 00:00:00	2000-11-16	2000-11-16 00:00:00	2000-11-16	581452		0	0	0		0	0	0	1798	0	43	40213306		
30881	2556	19073188	2007-12-14	2007-12-14 00:00:00	2008-01-18	2008-01-18 00:00:00	2008-01-18	38000177		0	0	35		0	0	0	169428	0	308192	19073188		
16730	1385	19133873	1972-11-29	1972-11-29 00:00:00	1972-12-07	1972-12-07 00:00:00	1972-12-07	38000177		0	0	8		0	0	0	91834	0	834061	19133873		
51114	4247	40165015	2013-08-20	2013-08-20 00:00:00	2013-08-20	2013-08-20 00:00:00	\N	38000177		0	0	0		0	0	0	282013	0	861467	40165015		
211	16	1115171	2014-06-27	2014-06-27 00:00:00	2014-07-25	2014-07-25 00:00:00	2014-07-25	38000177		0	0	28		0	0	0	1166	0	849574	1115171		
42435	3518	1713671	1968-05-08	1968-05-08 00:00:00	1968-05-22	1968-05-22 00:00:00	1968-05-22	38000177		0	0	14		0	0	0	233552	0	562251	1713671		
48979	4064	1551192	1961-10-01	1961-10-01 00:00:00	1961-10-01	1961-10-01 00:00:00	1961-10-01	38000177		0	0	0		0	0	0	269995	0	312617	1551192		
7729	648	19075601	2015-09-25	2015-09-25 00:00:00	2015-09-25	2015-09-25 00:00:00	2015-09-25	38000177		0	0	0		0	0	0	42861	0	309362	19075601		
10637	884	19134077	2013-10-28	2013-10-28 00:00:00	2013-11-11	2013-11-11 00:00:00	2013-11-11	38000177		0	0	14		0	0	0	58931	0	835900	19134077		
14669	1228	1127433	1989-03-06	1989-03-06 00:00:00	1989-03-20	1989-03-20 00:00:00	1989-03-20	38000177		0	0	14		0	0	0	80918	0	313782	1127433		
43364	3595	19059056	1951-08-02	1951-08-02 00:00:00	1951-08-16	1951-08-16 00:00:00	1951-08-16	38000177		0	0	14		0	0	0	238784	0	243670	19059056		
36313	2992	1127433	1983-11-09	1983-11-09 00:00:00	1983-11-16	1983-11-16 00:00:00	1983-11-16	38000177		0	0	7		0	0	0	199712	0	313782	1127433		
28541	2351	19059056	1958-02-23	1958-02-23 00:00:00	1958-05-24	1958-05-24 00:00:00	1958-05-24	38000177		0	0	90		0	0	0	156557	0	243670	19059056		
100619	2204	40213227	2007-05-24	2007-05-24 00:00:00	2007-05-24	2007-05-24 00:00:00	2007-05-24	581452		0	0	0		0	0	0	146955	0	113	40213227		
3529	292	1127433	1996-07-17	1996-07-17 00:00:00	1996-07-31	1996-07-31 00:00:00	1996-07-31	38000177		0	0	14		0	0	0	19470	0	313782	1127433		
41770	3457	1124300	1952-08-13	1952-08-13 00:00:00	1952-08-13	1952-08-13 00:00:00	\N	38000177		0	0	0		0	0	0	229406	0	00781178901	45011828		
108674	2384	40213251	1985-04-30	1985-04-30 00:00:00	1985-04-30	1985-04-30 00:00:00	1985-04-30	581452		0	0	0		0	0	0	158479	0	21	40213251		
31990	2651	19059056	1952-05-24	1952-05-24 00:00:00	1952-06-23	1952-06-23 00:00:00	1952-06-23	38000177		0	0	30		0	0	0	175416	0	243670	19059056		
176688	3884	40213160	1972-09-04	1972-09-04 00:00:00	1972-09-04	1972-09-04 00:00:00	1972-09-04	581452		0	0	0		0	0	0	258194	0	10	40213160		
51431	4274	920300	1949-12-31	1949-12-31 00:00:00	1950-01-07	1950-01-07 00:00:00	1950-01-07	38000177		0	0	7		0	0	0	283665	0	311989	920300		
42816	3549	19133905	1997-01-13	1997-01-13 00:00:00	1997-01-23	1997-01-23 00:00:00	1997-01-23	38000177		0	0	10		0	0	0	235642	0	834102	19133905		
60363	5022	40236824	1993-01-21	1993-01-21 00:00:00	1993-01-28	1993-01-28 00:00:00	1993-01-28	38000177		0	0	7		0	0	0	333695	0	1094107	40236824		
53329	4432	19006318	1959-05-16	1959-05-16 00:00:00	1959-06-13	1959-06-13 00:00:00	1959-06-13	38000177		0	0	28		0	0	0	294583	0	105078	19006318		
24930	2051	19059056	1967-03-27	1967-03-27 00:00:00	1967-04-10	1967-04-10 00:00:00	1967-04-10	38000177		0	0	14		0	0	0	136336	0	243670	19059056		
12522	1054	1118084	1973-01-25	1973-01-25 00:00:00	1973-01-25	1973-01-25 00:00:00	\N	38000177		0	0	0		0	0	0	69151	0	00025152531	44923712		
9544	795	40236824	1979-11-01	1979-11-01 00:00:00	1979-11-08	1979-11-08 00:00:00	1979-11-08	38000177		0	0	7		0	0	0	52708	0	1094107	40236824		
23078	1903	1713671	2001-05-14	2001-05-14 00:00:00	2001-05-21	2001-05-21 00:00:00	2001-05-21	38000177		0	0	7		0	0	0	126707	0	562251	1713671		
28857	2384	19078461	2018-01-05	2018-01-05 00:00:00	2018-02-02	2018-02-02 00:00:00	2018-02-02	38000177		0	0	28		0	0	0	158499	0	310965	19078461		
35620	2936	1118084	1999-10-16	1999-10-16 00:00:00	1999-10-16	1999-10-16 00:00:00	\N	38000177		0	0	0		0	0	0	195741	0	00025152531	44923712		
20184	1658	1127433	1982-05-03	1982-05-03 00:00:00	1982-06-07	1982-06-07 00:00:00	1982-06-07	38000177		0	0	35		0	0	0	111378	0	313782	1127433		
23048	500	40213296	2004-12-21	2004-12-21 00:00:00	2004-12-21	2004-12-21 00:00:00	2004-12-21	581452		0	0	0		0	0	0	33513	0	52	40213296		
42099	3490	1127078	1950-03-22	1950-03-22 00:00:00	1950-04-19	1950-04-19 00:00:00	1950-04-19	38000177		0	0	28		0	0	0	231512	0	282464	1127078		
27790	605	40213296	1999-12-10	1999-12-10 00:00:00	1999-12-10	1999-12-10 00:00:00	1999-12-10	581452		0	0	0		0	0	0	40136	0	52	40213296		
1395	111	19133873	1979-01-13	1979-01-13 00:00:00	1979-01-25	1979-01-25 00:00:00	1979-01-25	38000177		0	0	12		0	0	0	7413	0	834061	19133873		
14589	1223	40229134	1982-08-20	1982-08-20 00:00:00	1982-08-27	1982-08-27 00:00:00	1982-08-27	38000177		0	0	7		0	0	0	80454	0	1043400	40229134		
1577	124	40229134	1998-03-11	1998-03-11 00:00:00	1998-03-25	1998-03-25 00:00:00	1998-03-25	38000177		0	0	14		0	0	0	8306	0	1043400	40229134		
12326	1036	1127433	1998-03-20	1998-03-20 00:00:00	1998-03-27	1998-03-27 00:00:00	1998-03-27	38000177		0	0	7		0	0	0	68118	0	313782	1127433		
40235	3332	19006318	1964-04-03	1964-04-03 00:00:00	1964-04-17	1964-04-17 00:00:00	1964-04-17	38000177		0	0	14		0	0	0	221052	0	105078	19006318		
207978	4562	40213306	1982-09-04	1982-09-04 00:00:00	1982-09-04	1982-09-04 00:00:00	1982-09-04	581452		0	0	0		0	0	0	\N	0	43	40213306		
4627	384	1127433	1966-04-30	1966-04-30 00:00:00	1966-05-14	1966-05-14 00:00:00	1966-05-14	38000177		0	0	14		0	0	0	25336	0	313782	1127433		
38622	3189	1127433	1985-09-20	1985-09-20 00:00:00	1985-11-26	1985-11-26 00:00:00	1985-11-26	38000177		0	0	67		0	0	0	212271	0	313782	1127433		
35831	2950	1127433	2014-02-11	2014-02-11 00:00:00	2014-04-12	2014-04-12 00:00:00	2014-04-12	38000177		0	0	60		0	0	0	196943	0	313782	1127433		
35849	2951	19059056	1959-11-11	1959-11-11 00:00:00	1959-11-25	1959-11-25 00:00:00	1959-11-25	38000177		0	0	14		0	0	0	197059	0	243670	19059056		
25733	2116	1713671	1987-03-09	1987-03-09 00:00:00	1987-03-23	1987-03-23 00:00:00	1987-03-23	38000177		0	0	14		0	0	0	140785	0	562251	1713671		
54239	4506	1713671	1983-12-21	1983-12-21 00:00:00	1984-01-04	1984-01-04 00:00:00	1984-01-04	38000177		0	0	14		0	0	0	300161	0	562251	1713671		
33409	2767	40165015	1971-04-05	1971-04-05 00:00:00	1971-04-05	1971-04-05 00:00:00	\N	38000177		0	0	0		0	0	0	183064	0	861467	40165015		
33365	2765	19133905	2013-07-08	2013-07-08 00:00:00	2013-07-15	2013-07-15 00:00:00	2013-07-15	38000177		0	0	7		0	0	0	182988	0	834102	19133905		
36397	3000	40231925	1970-11-08	1970-11-08 00:00:00	1970-11-08	1970-11-08 00:00:00	\N	38000177		0	0	0		0	0	0	200178	0	1049221	40231925		
57064	4736	1118084	2013-08-21	2013-08-21 00:00:00	2013-08-21	2013-08-21 00:00:00	\N	38000177		0	0	0		0	0	0	315496	0	00025152531	44923712		
28130	2326	19078461	1990-09-16	1990-09-16 00:00:00	1990-10-07	1990-10-07 00:00:00	1990-10-07	38000177		0	0	21		0	0	0	154672	0	310965	19078461		
26576	2186	40232448	1975-03-01	1975-03-01 00:00:00	1975-03-01	1975-03-01 00:00:00	\N	38000177		0	0	0		0	0	0	145729	0	1049630	40232448		
21588	1776	1713671	1991-08-16	1991-08-16 00:00:00	1991-08-30	1991-08-30 00:00:00	1991-08-30	38000177		0	0	14		0	0	0	118786	0	562251	1713671		
21649	1779	1115171	2002-12-07	2002-12-07 00:00:00	2002-12-21	2002-12-21 00:00:00	2002-12-21	38000177		0	0	14		0	0	0	119009	0	849574	1115171		
21693	1781	1127433	1957-01-17	1957-01-17 00:00:00	1957-01-31	1957-01-31 00:00:00	1957-01-31	38000177		0	0	14		0	0	0	119225	0	313782	1127433		
74147	1618	40213160	1978-04-26	1978-04-26 00:00:00	1978-04-26	1978-04-26 00:00:00	1978-04-26	581452		0	0	0		0	0	0	108819	0	10	40213160		
6490	546	1127433	2001-01-03	2001-01-03 00:00:00	2001-01-17	2001-01-17 00:00:00	2001-01-17	38000177		0	0	14		0	0	0	36179	0	313782	1127433		
47741	3958	46233988	1968-10-31	1968-10-31 00:00:00	1968-11-14	1968-11-14 00:00:00	1968-11-14	38000177		0	0	14		0	0	0	263186	0	1652673	46233988		
47770	3960	1127433	1963-01-08	1963-01-08 00:00:00	1963-01-15	1963-01-15 00:00:00	1963-01-15	38000177		0	0	7		0	0	0	263250	0	313782	1127433		
23518	1936	1118084	1984-11-03	1984-11-03 00:00:00	1984-11-03	1984-11-03 00:00:00	\N	38000177		0	0	0		0	0	0	128752	0	00025152531	44923712		
16369	1356	40162522	2007-09-29	2007-09-29 00:00:00	2007-09-29	2007-09-29 00:00:00	\N	38000177		0	0	0		0	0	0	89863	0	857005	40162522		
21084	1738	40165015	2014-12-19	2014-12-19 00:00:00	2014-12-19	2014-12-19 00:00:00	\N	38000177		0	0	0		0	0	0	116168	0	861467	40165015		
41118	3410	19133873	1980-07-03	1980-07-03 00:00:00	1980-07-14	1980-07-14 00:00:00	1980-07-14	38000177		0	0	11		0	0	0	226189	0	834061	19133873		
58519	4859	40165015	1971-06-10	1971-06-10 00:00:00	1971-06-10	1971-06-10 00:00:00	\N	38000177		0	0	0		0	0	0	323226	0	861467	40165015		
58572	4861	1124300	1989-05-14	1989-05-14 00:00:00	1989-05-14	1989-05-14 00:00:00	\N	38000177		0	0	0		0	0	0	323431	0	00781178901	45011828		
1048	23	40213314	1978-12-14	1978-12-14 00:00:00	1978-12-14	1978-12-14 00:00:00	1978-12-14	581452		0	0	0		0	0	0	1806	0	49	40213314		
30882	2556	40162522	2007-12-14	2007-12-14 00:00:00	2007-12-14	2007-12-14 00:00:00	\N	38000177		0	0	0		0	0	0	169428	0	857005	40162522		
16731	1385	19078461	2003-06-02	2003-06-02 00:00:00	2003-06-30	2003-06-30 00:00:00	2003-06-30	38000177		0	0	28		0	0	0	91875	0	310965	19078461		
51115	4247	1115171	2013-08-20	2013-08-20 00:00:00	2013-09-10	2013-09-10 00:00:00	2013-09-10	38000177		0	0	21		0	0	0	282013	0	849574	1115171		
212	16	19115351	1983-10-10	1983-10-10 00:00:00	1984-01-16	1984-01-16 00:00:00	1984-01-16	38000177		0	0	98		0	0	0	1163	0	563026	19115351		
42436	3518	19059056	1968-08-03	1968-08-03 00:00:00	1968-08-17	1968-08-17 00:00:00	1968-08-17	38000177		0	0	14		0	0	0	233580	0	243670	19059056		
48980	4064	1127433	1990-01-02	1990-01-02 00:00:00	1990-01-16	1990-01-16 00:00:00	1990-01-16	38000177		0	0	14		0	0	0	269998	0	313782	1127433		
7730	648	1127433	1961-11-25	1961-11-25 00:00:00	1961-12-09	1961-12-09 00:00:00	1961-12-09	38000177		0	0	14		0	0	0	42847	0	313782	1127433		
10638	884	19008572	2013-10-28	2013-10-28 00:00:00	2013-11-11	2013-11-11 00:00:00	2013-11-11	38000177		0	0	14		0	0	0	58931	0	106258	19008572		
14670	1228	1115171	2001-09-19	2001-09-19 00:00:00	2001-10-10	2001-10-10 00:00:00	2001-10-10	38000177		0	0	21		0	0	0	80895	0	849574	1115171		
43365	3595	19006318	1951-08-02	1951-08-02 00:00:00	1951-08-16	1951-08-16 00:00:00	1951-08-16	38000177		0	0	14		0	0	0	238784	0	105078	19006318		
36314	2992	19006318	1958-03-12	1958-03-12 00:00:00	1958-03-26	1958-03-26 00:00:00	1958-03-26	38000177		0	0	14		0	0	0	199754	0	105078	19006318		
28542	2351	1713671	1965-10-17	1965-10-17 00:00:00	1965-11-07	1965-11-07 00:00:00	1965-11-07	38000177		0	0	21		0	0	0	156585	0	562251	1713671		
13775	1150	1127433	2010-09-04	2010-09-04 00:00:00	2010-10-09	2010-10-09 00:00:00	2010-10-09	38000177		0	0	35		0	0	0	76065	0	313782	1127433		
3530	292	19019979	1978-07-30	1978-07-30 00:00:00	1978-08-13	1978-08-13 00:00:00	1978-08-13	38000177		0	0	14		0	0	0	19463	0	198405	19019979		
41771	3457	40229134	1919-06-19	1919-06-19 00:00:00	1919-06-26	1919-06-26 00:00:00	1919-06-26	38000177		0	0	7		0	0	0	229396	0	1043400	40229134		
108682	2384	40213160	1984-05-29	1984-05-29 00:00:00	1984-05-29	1984-05-29 00:00:00	1984-05-29	581452		0	0	0		0	0	0	158514	0	10	40213160		
31991	2651	1127433	1977-07-24	1977-07-24 00:00:00	1977-08-21	1977-08-21 00:00:00	1977-08-21	38000177		0	0	28		0	0	0	175421	0	313782	1127433		
176693	3884	40213296	2016-02-15	2016-02-15 00:00:00	2016-02-15	2016-02-15 00:00:00	2016-02-15	581452		0	0	0		0	0	0	258022	0	52	40213296		
51432	4274	19078461	1997-11-12	1997-11-12 00:00:00	1997-11-26	1997-11-26 00:00:00	1997-11-26	38000177		0	0	14		0	0	0	283561	0	310965	19078461		
42817	3549	1713671	1963-09-27	1963-09-27 00:00:00	1963-10-18	1963-10-18 00:00:00	1963-10-18	38000177		0	0	21		0	0	0	235676	0	562251	1713671		
60364	5022	1118084	2005-06-05	2005-06-05 00:00:00	2005-06-05	2005-06-05 00:00:00	\N	38000177		0	0	0		0	0	0	333684	0	00025152531	44923712		
53330	4432	1127078	1959-05-16	1959-05-16 00:00:00	1959-06-13	1959-06-13 00:00:00	1959-06-13	38000177		0	0	28		0	0	0	294583	0	282464	1127078		
24931	2051	46233988	1967-03-27	1967-03-27 00:00:00	1967-04-10	1967-04-10 00:00:00	1967-04-10	38000177		0	0	14		0	0	0	136336	0	1652673	46233988		
12523	1054	1127433	1957-05-05	1957-05-05 00:00:00	1957-05-19	1957-05-19 00:00:00	1957-05-19	38000177		0	0	14		0	0	0	69121	0	313782	1127433		
9545	795	920300	1979-11-01	1979-11-01 00:00:00	1979-11-08	1979-11-08 00:00:00	1979-11-08	38000177		0	0	7		0	0	0	52708	0	311989	920300		
23079	1903	19133873	1969-05-16	1969-05-16 00:00:00	1969-05-29	1969-05-29 00:00:00	1969-05-29	38000177		0	0	13		0	0	0	126669	0	834061	19133873		
28858	2384	1115171	2005-10-12	2005-10-12 00:00:00	2005-10-26	2005-10-26 00:00:00	2005-10-26	38000177		0	0	14		0	0	0	158497	0	849574	1115171		
35621	2936	1127433	1976-08-17	1976-08-17 00:00:00	1976-09-07	1976-09-07 00:00:00	1976-09-07	38000177		0	0	21		0	0	0	195767	0	313782	1127433		
20185	1658	40231925	1989-05-01	1989-05-01 00:00:00	1989-05-01	1989-05-01 00:00:00	\N	38000177		0	0	0		0	0	0	111379	0	1049221	40231925		
23053	500	40213260	2012-01-10	2012-01-10 00:00:00	2012-01-10	2012-01-10 00:00:00	2012-01-10	581452		0	0	0		0	0	0	33536	0	121	40213260		
42100	3490	1115171	2017-03-17	2017-03-17 00:00:00	2017-03-31	2017-03-31 00:00:00	2017-03-31	38000177		0	0	14		0	0	0	231524	0	849574	1115171		
196459	4317	40213198	2012-03-29	2012-03-29 00:00:00	2012-03-29	2012-03-29 00:00:00	2012-03-29	581452		0	0	0		0	0	0	\N	0	133	40213198		
1396	111	19129144	2003-02-19	2003-02-19 00:00:00	2004-02-14	2004-02-14 00:00:00	2004-02-14	38000177		0	0	360		0	0	0	7384	0	757594	19129144		
14590	1223	40163554	2012-05-11	2012-05-11 00:00:00	2012-05-11	2012-05-11 00:00:00	\N	38000177		0	0	0		0	0	0	80504	0	855332	40163554		
1578	124	40169281	2014-03-25	2014-03-25 00:00:00	2014-03-25	2014-03-25 00:00:00	\N	38000177		0	0	0		0	0	0	8273	0	896209	40169281		
12327	1036	1115171	2000-06-24	2000-06-24 00:00:00	2000-07-15	2000-07-15 00:00:00	2000-07-15	38000177		0	0	21		0	0	0	68137	0	849574	1115171		
40236	3332	40236824	1979-12-31	1979-12-31 00:00:00	1980-01-07	1980-01-07 00:00:00	1980-01-07	38000177		0	0	7		0	0	0	221100	0	1094107	40236824		
207980	4562	40213160	1961-10-07	1961-10-07 00:00:00	1961-10-07	1961-10-07 00:00:00	1961-10-07	581452		0	0	0		0	0	0	303994	0	10	40213160		
4646	387	19078461	1987-07-19	1987-07-19 00:00:00	1987-08-16	1987-08-16 00:00:00	1987-08-16	38000177		0	0	28		0	0	0	25456	0	310965	19078461		
38624	3191	1124300	1998-08-02	1998-08-02 00:00:00	1998-08-02	1998-08-02 00:00:00	\N	38000177		0	0	0		0	0	0	212369	0	00781178901	45011828		
35832	2950	40162522	2014-02-11	2014-02-11 00:00:00	2014-02-11	2014-02-11 00:00:00	\N	38000177		0	0	0		0	0	0	196943	0	857005	40162522		
35850	2951	19006318	1959-11-11	1959-11-11 00:00:00	1959-11-25	1959-11-25 00:00:00	1959-11-25	38000177		0	0	14		0	0	0	197059	0	105078	19006318		
25759	2119	1713671	1991-04-22	1991-04-22 00:00:00	1991-05-06	1991-05-06 00:00:00	1991-05-06	38000177		0	0	14		0	0	0	141074	0	562251	1713671		
54256	4509	1118084	2006-11-07	2006-11-07 00:00:00	2006-11-07	2006-11-07 00:00:00	\N	38000177		0	0	0		0	0	0	300398	0	00025152531	44923712		
33410	2767	1127433	1971-04-05	1971-04-05 00:00:00	1971-05-05	1971-05-05 00:00:00	1971-05-05	38000177		0	0	30		0	0	0	183064	0	313782	1127433		
33366	2765	1127433	1978-01-18	1978-01-18 00:00:00	1978-02-01	1978-02-01 00:00:00	1978-02-01	38000177		0	0	14		0	0	0	182891	0	313782	1127433		
36398	3001	1124300	1981-12-26	1981-12-26 00:00:00	1981-12-26	1981-12-26 00:00:00	\N	38000177		0	0	0		0	0	0	200329	0	00781178901	45011828		
57065	4736	19078461	2009-01-25	2009-01-25 00:00:00	2009-03-26	2009-03-26 00:00:00	2009-03-26	38000177		0	0	60		0	0	0	315515	0	310965	19078461		
28131	2326	1127433	1963-01-07	1963-01-07 00:00:00	1963-01-14	1963-01-14 00:00:00	1963-01-14	38000177		0	0	7		0	0	0	154673	0	313782	1127433		
26577	2186	1713671	2002-06-03	2002-06-03 00:00:00	2002-06-24	2002-06-24 00:00:00	2002-06-24	38000177		0	0	21		0	0	0	145811	0	562251	1713671		
21589	1776	1127433	1947-12-17	1947-12-17 00:00:00	1947-12-24	1947-12-24 00:00:00	1947-12-24	38000177		0	0	7		0	0	0	118778	0	313782	1127433		
21650	1779	40229134	1950-01-13	1950-01-13 00:00:00	1950-01-27	1950-01-27 00:00:00	1950-01-27	38000177		0	0	14		0	0	0	119041	0	1043400	40229134		
21694	1782	1127433	1973-01-09	1973-01-09 00:00:00	1973-01-30	1973-01-30 00:00:00	1973-01-30	38000177		0	0	21		0	0	0	119342	0	313782	1127433		
74150	1618	40213160	1973-08-22	1973-08-22 00:00:00	1973-08-22	1973-08-22 00:00:00	1973-08-22	581452		0	0	0		0	0	0	108777	0	10	40213160		
6491	546	1713671	1947-06-03	1947-06-03 00:00:00	1947-09-16	1947-09-16 00:00:00	1947-09-16	38000177		0	0	105		0	0	0	36209	0	562251	1713671		
47742	3958	1127078	1965-04-20	1965-04-20 00:00:00	1965-05-11	1965-05-11 00:00:00	1965-05-11	38000177		0	0	21		0	0	0	263172	0	282464	1127078		
47771	3960	1713671	2018-11-26	2018-11-26 00:00:00	2018-12-03	2018-12-03 00:00:00	2018-12-03	38000177		0	0	7		0	0	0	263302	0	562251	1713671		
23519	1936	920300	1983-03-13	1983-03-13 00:00:00	1983-03-20	1983-03-20 00:00:00	1983-03-20	38000177		0	0	7		0	0	0	128752	0	311989	920300		
16370	1356	1127433	2007-09-22	2007-09-22 00:00:00	2007-10-29	2007-10-29 00:00:00	2007-10-29	38000177		0	0	37		0	0	0	89862	0	313782	1127433		
21086	1738	1127078	1971-10-31	1971-10-31 00:00:00	1971-11-14	1971-11-14 00:00:00	1971-11-14	38000177		0	0	14		0	0	0	116138	0	282464	1127078		
41119	3410	40229134	2018-03-14	2018-03-14 00:00:00	2018-03-21	2018-03-21 00:00:00	2018-03-21	38000177		0	0	7		0	0	0	226179	0	1043400	40229134		
58520	4859	19079524	1971-06-05	1971-06-05 00:00:00	1971-06-10	1971-06-10 00:00:00	1971-06-10	38000177		0	0	5		0	0	0	323226	0	313002	19079524		
58573	4861	1127433	1994-01-22	1994-01-22 00:00:00	1994-02-21	1994-02-21 00:00:00	1994-02-21	38000177		0	0	30		0	0	0	323378	0	313782	1127433		
1049	23	40213160	1978-12-14	1978-12-14 00:00:00	1978-12-14	1978-12-14 00:00:00	1978-12-14	581452		0	0	0		0	0	0	1806	0	10	40213160		
30883	2556	1118084	2004-06-03	2004-06-03 00:00:00	2004-06-03	2004-06-03 00:00:00	\N	38000177		0	0	0		0	0	0	169385	0	00025152531	44923712		
16732	1385	19074841	2003-06-02	2003-06-02 00:00:00	2003-06-30	2003-06-30 00:00:00	2003-06-30	38000177		0	0	28		0	0	0	91875	0	309043	19074841		
51116	4247	19073188	2013-08-20	2013-08-20 00:00:00	2013-09-10	2013-09-10 00:00:00	2013-09-10	38000177		0	0	21		0	0	0	282013	0	308192	19073188		
213	16	1127078	1974-06-11	1974-06-11 00:00:00	1974-06-25	1974-06-25 00:00:00	1974-06-25	38000177		0	0	14		0	0	0	1174	0	282464	1127078		
42437	3518	19059056	1967-06-12	1967-06-12 00:00:00	1967-07-10	1967-07-10 00:00:00	1967-07-10	38000177		0	0	28		0	0	0	233579	0	243670	19059056		
48981	4064	19059056	1969-11-18	1969-11-18 00:00:00	1970-02-16	1970-02-16 00:00:00	1970-02-16	38000177		0	0	90		0	0	0	269997	0	243670	19059056		
7731	648	19133905	2018-05-02	2018-05-02 00:00:00	2018-05-15	2018-05-15 00:00:00	2018-05-15	38000177		0	0	13		0	0	0	42955	0	834102	19133905		
10639	884	19128065	1991-09-03	1991-09-03 00:00:00	1992-08-28	1992-08-28 00:00:00	1992-08-28	38000177		0	0	360		0	0	0	58933	0	749882	19128065		
14671	1228	40236824	2014-08-02	2014-08-02 00:00:00	2014-08-09	2014-08-09 00:00:00	2014-08-09	38000177		0	0	7		0	0	0	80873	0	1094107	40236824		
43366	3595	1127433	1973-03-31	1973-03-31 00:00:00	1973-04-14	1973-04-14 00:00:00	1973-04-14	38000177		0	0	14		0	0	0	238779	0	313782	1127433		
36315	2992	1127078	1958-03-12	1958-03-12 00:00:00	1958-03-26	1958-03-26 00:00:00	1958-03-26	38000177		0	0	14		0	0	0	199754	0	282464	1127078		
28543	2351	1124300	1990-11-24	1990-11-24 00:00:00	1990-11-24	1990-11-24 00:00:00	\N	38000177		0	0	0		0	0	0	156496	0	00781178901	45011828		
13776	1150	1127433	1983-03-20	1983-03-20 00:00:00	1983-04-03	1983-04-03 00:00:00	1983-04-03	38000177		0	0	14		0	0	0	76041	0	313782	1127433		
3531	292	46233988	1978-07-30	1978-07-30 00:00:00	1978-08-13	1978-08-13 00:00:00	1978-08-13	38000177		0	0	14		0	0	0	19463	0	1652673	46233988		
41772	3458	1127078	1988-04-04	1988-04-04 00:00:00	1988-04-18	1988-04-18 00:00:00	1988-04-18	38000177		0	0	14		0	0	0	229462	0	282464	1127078		
108683	2384	40213314	1984-05-29	1984-05-29 00:00:00	1984-05-29	1984-05-29 00:00:00	1984-05-29	581452		0	0	0		0	0	0	158514	0	49	40213314		
31992	2651	40169216	1948-09-24	1948-09-24 00:00:00	1966-03-02	1966-03-02 00:00:00	1966-03-02	38000177		0	0	6368		0	0	0	175435	0	895994	40169216		
84604	1850	40213227	2018-02-09	2018-02-09 00:00:00	2018-02-09	2018-02-09 00:00:00	2018-02-09	581452		0	0	0		0	0	0	123727	0	113	40213227		
51433	4274	40236824	1954-01-30	1954-01-30 00:00:00	1954-02-06	1954-02-06 00:00:00	1954-02-06	38000177		0	0	7		0	0	0	283635	0	1094107	40236824		
42818	3549	1115171	2012-02-16	2012-02-16 00:00:00	2012-03-17	2012-03-17 00:00:00	2012-03-17	38000177		0	0	30		0	0	0	235631	0	849574	1115171		
60365	5022	19128065	1983-12-18	1983-12-18 00:00:00	1984-12-12	1984-12-12 00:00:00	1984-12-12	38000177		0	0	360		0	0	0	333647	0	749882	19128065		
53331	4432	1127433	2004-08-13	2004-08-13 00:00:00	2004-09-17	2004-09-17 00:00:00	2004-09-17	38000177		0	0	35		0	0	0	294585	0	313782	1127433		
24932	2051	1127433	1984-04-14	1984-04-14 00:00:00	1984-04-21	1984-04-21 00:00:00	1984-04-21	38000177		0	0	7		0	0	0	136355	0	313782	1127433		
12524	1054	19077572	2007-09-14	2007-09-14 00:00:00	2007-09-14	2007-09-14 00:00:00	\N	38000177		0	0	0		0	0	0	69158	0	310436	19077572		
9546	795	19059056	1937-04-16	1937-04-16 00:00:00	1937-04-30	1937-04-30 00:00:00	1937-04-30	38000177		0	0	14		0	0	0	52754	0	243670	19059056		
23080	1903	19115351	1975-06-16	1975-06-16 00:00:00	1976-01-05	1976-01-05 00:00:00	1976-01-05	38000177		0	0	203		0	0	0	126664	0	563026	19115351		
28859	2384	19133873	1989-03-02	1989-03-02 00:00:00	1989-03-12	1989-03-12 00:00:00	1989-03-12	38000177		0	0	10		0	0	0	158476	0	834061	19133873		
35622	2936	40229134	1963-11-26	1963-11-26 00:00:00	1963-12-10	1963-12-10 00:00:00	1963-12-10	38000177		0	0	14		0	0	0	195763	0	1043400	40229134		
20186	1658	1127433	1989-05-01	1989-05-01 00:00:00	1989-05-31	1989-05-31 00:00:00	1989-05-31	38000177		0	0	30		0	0	0	111379	0	313782	1127433		
23055	500	40213160	1962-02-27	1962-02-27 00:00:00	1962-02-27	1962-02-27 00:00:00	1962-02-27	581452		0	0	0		0	0	0	33490	0	10	40213160		
42101	3490	19133873	1950-04-22	1950-04-22 00:00:00	1950-05-02	1950-05-02 00:00:00	1950-05-02	38000177		0	0	10		0	0	0	231493	0	834061	19133873		
42136	3494	1127433	1981-04-01	1981-04-01 00:00:00	1981-04-15	1981-04-15 00:00:00	1981-04-15	38000177		0	0	14		0	0	0	231721	0	313782	1127433		
1397	111	19128065	1994-04-07	1994-04-07 00:00:00	1995-04-02	1995-04-02 00:00:00	1995-04-02	38000177		0	0	360		0	0	0	7377	0	749882	19128065		
14591	1223	19018935	2012-05-11	2012-05-11 00:00:00	2012-05-11	2012-05-11 00:00:00	\N	38000177		0	0	0		0	0	0	80504	0	197604	19018935		
1579	124	1594382	1987-04-02	1987-04-02 00:00:00	1987-04-02	1987-04-02 00:00:00	\N	38000177		0	0	0		0	0	0	8296	0	1870230	1594382		
12328	1036	40169216	1971-09-12	1971-09-12 00:00:00	1971-09-12	1971-09-12 00:00:00	\N	38000177		0	0	0		0	0	0	68092	0	895994	40169216		
40237	3332	920300	1979-12-31	1979-12-31 00:00:00	1980-01-07	1980-01-07 00:00:00	1980-01-07	38000177		0	0	7		0	0	0	221100	0	311989	920300		
207996	4562	40213260	2011-01-29	2011-01-29 00:00:00	2011-01-29	2011-01-29 00:00:00	2011-01-29	581452		0	0	0		0	0	0	303975	0	121	40213260		
4647	387	1118084	2016-07-06	2016-07-06 00:00:00	2016-07-06	2016-07-06 00:00:00	\N	38000177		0	0	0		0	0	0	25471	0	00025152531	44923712		
38625	3191	1127433	1993-05-07	1993-05-07 00:00:00	1993-05-14	1993-05-14 00:00:00	1993-05-14	38000177		0	0	7		0	0	0	212350	0	313782	1127433		
35833	2950	19133905	1983-08-12	1983-08-12 00:00:00	1983-08-19	1983-08-19 00:00:00	1983-08-19	38000177		0	0	7		0	0	0	196982	0	834102	19133905		
35851	2951	19128065	1976-10-22	1976-10-22 00:00:00	1977-10-17	1977-10-17 00:00:00	1977-10-17	38000177		0	0	360		0	0	0	196999	0	749882	19128065		
25760	2119	40232448	1983-06-29	1983-06-29 00:00:00	1983-06-29	1983-06-29 00:00:00	\N	38000177		0	0	0		0	0	0	141050	0	1049630	40232448		
54257	4509	1127433	1991-11-21	1991-11-21 00:00:00	1991-12-05	1991-12-05 00:00:00	1991-12-05	38000177		0	0	14		0	0	0	300401	0	313782	1127433		
33411	2767	1127433	2004-01-17	2004-01-17 00:00:00	2004-01-31	2004-01-31 00:00:00	2004-01-31	38000177		0	0	14		0	0	0	183067	0	313782	1127433		
43825	3629	40229134	1994-11-18	1994-11-18 00:00:00	1994-12-02	1994-12-02 00:00:00	1994-12-02	38000177		0	0	14		0	0	0	241497	0	1043400	40229134		
36399	3001	19078461	1980-12-15	1980-12-15 00:00:00	1981-01-05	1981-01-05 00:00:00	1981-01-05	38000177		0	0	21		0	0	0	200329	0	310965	19078461		
57066	4736	1127078	1981-04-01	1981-04-01 00:00:00	1981-04-15	1981-04-15 00:00:00	1981-04-15	38000177		0	0	14		0	0	0	315513	0	282464	1127078		
28133	2326	19133905	1985-01-10	1985-01-10 00:00:00	1985-01-17	1985-01-17 00:00:00	1985-01-17	38000177		0	0	7		0	0	0	154675	0	834102	19133905		
26578	2186	1127433	2019-01-09	2019-01-09 00:00:00	2019-04-09	2019-04-09 00:00:00	2019-04-09	38000177		0	0	90		0	0	0	145831	0	313782	1127433		
21590	1776	19078461	2018-04-17	2018-04-17 00:00:00	2018-05-24	2018-05-24 00:00:00	2018-05-24	38000177		0	0	37		0	0	0	118776	0	310965	19078461		
21651	1779	1551192	1945-02-13	1945-02-13 00:00:00	1945-02-13	1945-02-13 00:00:00	1945-02-13	38000177		0	0	0		0	0	0	119062	0	312617	1551192		
21696	1782	40229134	1960-02-01	1960-02-01 00:00:00	1960-02-08	1960-02-08 00:00:00	1960-02-08	38000177		0	0	7		0	0	0	119372	0	1043400	40229134		
74153	1618	40213160	1974-01-23	1974-01-23 00:00:00	1974-01-23	1974-01-23 00:00:00	1974-01-23	581452		0	0	0		0	0	0	108789	0	10	40213160		
6492	546	1713671	1948-03-21	1948-03-21 00:00:00	1948-04-11	1948-04-11 00:00:00	1948-04-11	38000177		0	0	21		0	0	0	36191	0	562251	1713671		
47743	3958	19129655	1965-04-20	1965-04-20 00:00:00	1965-05-11	1965-05-11 00:00:00	1965-05-11	38000177		0	0	21		0	0	0	263172	0	789980	19129655		
47772	3961	19133873	1977-05-19	1977-05-19 00:00:00	1977-05-31	1977-05-31 00:00:00	1977-05-31	38000177		0	0	12		0	0	0	263339	0	834061	19133873		
23520	1936	40236824	1983-03-13	1983-03-13 00:00:00	1983-03-20	1983-03-20 00:00:00	1983-03-20	38000177		0	0	7		0	0	0	128752	0	1094107	40236824		
16371	1356	19133873	1981-02-14	1981-02-14 00:00:00	1981-02-26	1981-02-26 00:00:00	1981-02-26	38000177		0	0	12		0	0	0	89939	0	834061	19133873		
21087	1738	19129655	1971-10-31	1971-10-31 00:00:00	1971-11-14	1971-11-14 00:00:00	1971-11-14	38000177		0	0	14		0	0	0	116138	0	789980	19129655		
41120	3410	1713671	1979-04-05	1979-04-05 00:00:00	1979-04-26	1979-04-26 00:00:00	1979-04-26	38000177		0	0	21		0	0	0	226178	0	562251	1713671		
58521	4859	35605482	1971-06-05	1971-06-05 00:00:00	1971-06-05	1971-06-05 00:00:00	1971-06-05	38000177		0	0	0		0	0	0	323226	0	1740467	35605482		
58574	4861	1713671	2012-07-05	2012-07-05 00:00:00	2012-07-26	2012-07-26 00:00:00	2012-07-26	38000177		0	0	21		0	0	0	323436	0	562251	1713671		
1053	23	40213227	2009-11-26	2009-11-26 00:00:00	2009-11-26	2009-11-26 00:00:00	2009-11-26	581452		0	0	0		0	0	0	1801	0	113	40213227		
30884	2556	1127433	1975-09-07	1975-09-07 00:00:00	1975-09-21	1975-09-21 00:00:00	1975-09-21	38000177		0	0	14		0	0	0	169418	0	313782	1127433		
16734	1385	19128065	1980-04-08	1980-04-08 00:00:00	1981-04-03	1981-04-03 00:00:00	1981-04-03	38000177		0	0	360		0	0	0	91816	0	749882	19128065		
51117	4247	1127078	1991-08-04	1991-08-04 00:00:00	1991-08-25	1991-08-25 00:00:00	1991-08-25	38000177		0	0	21		0	0	0	282010	0	282464	1127078		
214	16	19059056	1989-06-24	1989-06-24 00:00:00	1989-07-08	1989-07-08 00:00:00	1989-07-08	38000177		0	0	14		0	0	0	1164	0	243670	19059056		
42438	3518	19133905	1987-05-16	1987-05-16 00:00:00	1987-05-26	1987-05-26 00:00:00	1987-05-26	38000177		0	0	10		0	0	0	233556	0	834102	19133905		
48982	4064	40232448	1963-05-30	1963-05-30 00:00:00	1963-05-30	1963-05-30 00:00:00	\N	38000177		0	0	0		0	0	0	270048	0	1049630	40232448		
7732	648	1118084	1971-07-25	1971-07-25 00:00:00	1971-07-25	1971-07-25 00:00:00	\N	38000177		0	0	0		0	0	0	42865	0	00025152531	44923712		
10640	884	1127433	2017-06-16	2017-06-16 00:00:00	2017-06-23	2017-06-23 00:00:00	2017-06-23	38000177		0	0	7		0	0	0	58913	0	313782	1127433		
14672	1228	920300	2014-08-02	2014-08-02 00:00:00	2014-08-09	2014-08-09 00:00:00	2014-08-09	38000177		0	0	7		0	0	0	80873	0	311989	920300		
43367	3595	1127078	1952-07-16	1952-07-16 00:00:00	1952-07-30	1952-07-30 00:00:00	1952-07-30	38000177		0	0	14		0	0	0	238839	0	282464	1127078		
36316	2992	19078461	2007-07-01	2007-07-01 00:00:00	2007-07-22	2007-07-22 00:00:00	2007-07-22	38000177		0	0	21		0	0	0	199766	0	310965	19078461		
28544	2351	19133873	1959-07-22	1959-07-22 00:00:00	1959-07-30	1959-07-30 00:00:00	1959-07-30	38000177		0	0	8		0	0	0	156514	0	834061	19133873		
13777	1150	19073188	1983-03-20	1983-03-20 00:00:00	1983-04-03	1983-04-03 00:00:00	1983-04-03	38000177		0	0	14		0	0	0	76041	0	308192	19073188		
3532	293	1127433	1978-04-03	1978-04-03 00:00:00	1978-07-02	1978-07-02 00:00:00	1978-07-02	38000177		0	0	90		0	0	0	19513	0	313782	1127433		
41773	3458	19073183	1988-04-04	1988-04-04 00:00:00	1988-04-18	1988-04-18 00:00:00	1988-04-18	38000177		0	0	14		0	0	0	229462	0	308182	19073183		
108684	2384	40213314	1984-07-31	1984-07-31 00:00:00	1984-07-31	1984-07-31 00:00:00	1984-07-31	581452		0	0	0		0	0	0	158478	0	49	40213314		
31993	2651	1154615	1948-09-24	1948-09-24 00:00:00	1966-03-02	1966-03-02 00:00:00	1966-03-02	38000177		0	0	6368		0	0	0	175435	0	745679	1154615		
84606	1850	40213260	2008-12-19	2008-12-19 00:00:00	2008-12-19	2008-12-19 00:00:00	2008-12-19	581452		0	0	0		0	0	0	123805	0	121	40213260		
51434	4274	920300	1954-01-30	1954-01-30 00:00:00	1954-02-06	1954-02-06 00:00:00	1954-02-06	38000177		0	0	7		0	0	0	283635	0	311989	920300		
42819	3549	40162522	2012-02-16	2012-02-16 00:00:00	2012-02-16	2012-02-16 00:00:00	\N	38000177		0	0	0		0	0	0	235631	0	857005	40162522		
60366	5022	1127433	1984-05-04	1984-05-04 00:00:00	1984-06-03	1984-06-03 00:00:00	1984-06-03	38000177		0	0	30		0	0	0	333659	0	313782	1127433		
53332	4432	1127433	1978-09-03	1978-09-03 00:00:00	1978-09-17	1978-09-17 00:00:00	1978-09-17	38000177		0	0	14		0	0	0	294589	0	313782	1127433		
24933	2051	19059056	1963-11-13	1963-11-13 00:00:00	1963-12-04	1963-12-04 00:00:00	1963-12-04	38000177		0	0	21		0	0	0	136353	0	243670	19059056		
12525	1054	19059056	1984-02-15	1984-02-15 00:00:00	1984-03-07	1984-03-07 00:00:00	1984-03-07	38000177		0	0	21		0	0	0	69133	0	243670	19059056		
9547	795	19133873	1940-03-02	1940-03-02 00:00:00	1940-03-14	1940-03-14 00:00:00	1940-03-14	38000177		0	0	12		0	0	0	52704	0	834061	19133873		
23081	1903	19059056	1964-06-08	1964-06-08 00:00:00	1964-06-22	1964-06-22 00:00:00	1964-06-22	38000177		0	0	14		0	0	0	126681	0	243670	19059056		
60917	5066	40236824	2000-05-08	2000-05-08 00:00:00	2000-05-15	2000-05-15 00:00:00	2000-05-15	38000177		0	0	7		0	0	0	336799	0	1094107	40236824		
35623	2936	19078461	1975-07-24	1975-07-24 00:00:00	1975-09-22	1975-09-22 00:00:00	1975-09-22	38000177		0	0	60		0	0	0	195818	0	310965	19078461		
20187	1658	1127433	1971-04-02	1971-04-02 00:00:00	1971-04-09	1971-04-09 00:00:00	1971-04-09	38000177		0	0	7		0	0	0	111315	0	313782	1127433		
23057	500	40213306	1984-08-28	1984-08-28 00:00:00	1984-08-28	1984-08-28 00:00:00	1984-08-28	581452		0	0	0		0	0	0	33511	0	43	40213306		
42102	3490	1713671	2002-07-28	2002-07-28 00:00:00	2002-08-18	2002-08-18 00:00:00	2002-08-18	38000177		0	0	21		0	0	0	231598	0	562251	1713671		
42137	3494	1118084	1999-01-18	1999-01-18 00:00:00	1999-01-18	1999-01-18 00:00:00	\N	38000177		0	0	0		0	0	0	231722	0	00025152531	44923712		
1398	111	19133873	1979-07-28	1979-07-28 00:00:00	1979-08-10	1979-08-10 00:00:00	1979-08-10	38000177		0	0	13		0	0	0	7414	0	834061	19133873		
14592	1223	40171902	2012-05-11	2012-05-11 00:00:00	2012-05-11	2012-05-11 00:00:00	\N	38000177		0	0	0		0	0	0	80504	0	897718	40171902		
1580	124	1713671	1984-09-07	1984-09-07 00:00:00	1984-09-14	1984-09-14 00:00:00	1984-09-14	38000177		0	0	7		0	0	0	8224	0	562251	1713671		
12329	1036	1154615	1971-09-12	1971-09-12 00:00:00	1971-09-12	1971-09-12 00:00:00	\N	38000177		0	0	0		0	0	0	68092	0	745679	1154615		
40238	3332	1127433	1981-03-21	1981-03-21 00:00:00	1981-04-11	1981-04-11 00:00:00	1981-04-11	38000177		0	0	21		0	0	0	221131	0	313782	1127433		
207998	4562	40213296	2002-03-30	2002-03-30 00:00:00	2002-03-30	2002-03-30 00:00:00	2002-03-30	581452		0	0	0		0	0	0	304062	0	52	40213296		
4648	387	1127078	1974-08-26	1974-08-26 00:00:00	1974-10-25	1974-10-25 00:00:00	1974-10-25	38000177		0	0	60		0	0	0	25455	0	282464	1127078		
38626	3191	1127433	2000-10-05	2000-10-05 00:00:00	2000-10-12	2000-10-12 00:00:00	2000-10-12	38000177		0	0	7		0	0	0	212361	0	313782	1127433		
35834	2950	19059056	1949-11-29	1949-11-29 00:00:00	1949-12-13	1949-12-13 00:00:00	1949-12-13	38000177		0	0	14		0	0	0	196935	0	243670	19059056		
35852	2951	1124300	1999-12-26	1999-12-26 00:00:00	1999-12-26	1999-12-26 00:00:00	\N	38000177		0	0	0		0	0	0	197068	0	00781178901	45011828		
25761	2119	19059056	1962-05-08	1962-05-08 00:00:00	1962-06-07	1962-06-07 00:00:00	1962-06-07	38000177		0	0	30		0	0	0	140972	0	243670	19059056		
54258	4509	1127433	2005-02-19	2005-02-19 00:00:00	2005-03-05	2005-03-05 00:00:00	2005-03-05	38000177		0	0	14		0	0	0	300404	0	313782	1127433		
33412	2767	1127433	1967-03-01	1967-03-01 00:00:00	1967-03-15	1967-03-15 00:00:00	1967-03-15	38000177		0	0	14		0	0	0	183051	0	313782	1127433		
43826	3629	1127433	1988-09-30	1988-09-30 00:00:00	1988-10-07	1988-10-07 00:00:00	1988-10-07	38000177		0	0	7		0	0	0	241458	0	313782	1127433		
36400	3001	19059056	1958-10-09	1958-10-09 00:00:00	1958-11-13	1958-11-13 00:00:00	1958-11-13	38000177		0	0	35		0	0	0	200327	0	243670	19059056		
57067	4736	19059056	1976-11-06	1976-11-06 00:00:00	1976-11-20	1976-11-20 00:00:00	1976-11-20	38000177		0	0	14		0	0	0	315504	0	243670	19059056		
28134	2326	1127433	1988-10-14	1988-10-14 00:00:00	1988-10-28	1988-10-28 00:00:00	1988-10-28	38000177		0	0	14		0	0	0	154661	0	313782	1127433		
26579	2186	40231925	2019-01-09	2019-01-09 00:00:00	2019-01-09	2019-01-09 00:00:00	\N	38000177		0	0	0		0	0	0	145831	0	1049221	40231925		
21591	1776	40173590	2006-10-28	2006-10-28 00:00:00	2006-10-28	2006-10-28 00:00:00	\N	38000177		0	0	0		0	0	0	118881	0	904419	40173590		
21652	1779	19078461	2003-12-16	2003-12-16 00:00:00	2004-01-13	2004-01-13 00:00:00	2004-01-13	38000177		0	0	28		0	0	0	119010	0	310965	19078461		
21697	1782	19079524	1956-01-11	1956-01-11 00:00:00	1956-01-11	1956-01-11 00:00:00	1956-01-11	38000177		0	0	0		0	0	0	119339	0	313002	19079524		
14721	318	40213227	2014-09-08	2014-09-08 00:00:00	2014-09-08	2014-09-08 00:00:00	2014-09-08	581452		0	0	0		0	0	0	21124	0	113	40213227		
6493	546	1127433	2004-11-23	2004-11-23 00:00:00	2004-12-14	2004-12-14 00:00:00	2004-12-14	38000177		0	0	21		0	0	0	36153	0	313782	1127433		
47744	3958	1127433	1980-06-21	1980-06-21 00:00:00	1980-07-05	1980-07-05 00:00:00	1980-07-05	38000177		0	0	14		0	0	0	263173	0	313782	1127433		
47773	3961	1127433	2018-12-10	2018-12-10 00:00:00	2018-12-31	2018-12-31 00:00:00	2018-12-31	38000177		0	0	21		0	0	0	263353	0	313782	1127433		
23521	1936	19059056	1955-08-04	1955-08-04 00:00:00	1955-08-25	1955-08-25 00:00:00	1955-08-25	38000177		0	0	21		0	0	0	128763	0	243670	19059056		
16372	1356	40229134	1988-11-04	1988-11-04 00:00:00	1988-11-11	1988-11-11 00:00:00	1988-11-11	38000177		0	0	7		0	0	0	89875	0	1043400	40229134		
21088	1738	1127433	2006-03-19	2006-03-19 00:00:00	2006-04-02	2006-04-02 00:00:00	2006-04-02	38000177		0	0	14		0	0	0	116107	0	313782	1127433		
41121	3410	19059056	1965-05-10	1965-05-10 00:00:00	1965-05-31	1965-05-31 00:00:00	1965-05-31	38000177		0	0	21		0	0	0	226176	0	243670	19059056		
58522	4859	782047	1971-06-05	1971-06-05 00:00:00	1971-06-05	1971-06-05 00:00:00	1971-06-05	38000177		0	0	0		0	0	0	323226	0	542347	782047		
4369	363	1713671	1973-10-06	1973-10-06 00:00:00	1974-03-16	1974-03-16 00:00:00	1974-03-16	38000177		0	0	161		0	0	0	24082	0	562251	1713671		
11551	962	1127433	2016-05-20	2016-05-20 00:00:00	2016-05-27	2016-05-27 00:00:00	2016-05-27	38000177		0	0	7		0	0	0	64100	0	313782	1127433		
75088	1640	40213201	2002-06-12	2002-06-12 00:00:00	2002-06-12	2002-06-12 00:00:00	2002-06-12	581452		0	0	0		0	0	0	110052	0	33	40213201		
12408	268	40213260	2017-02-21	2017-02-21 00:00:00	2017-02-21	2017-02-21 00:00:00	2017-02-21	581452		0	0	0		0	0	0	17793	0	121	40213260		
51118	4247	40229134	2006-12-08	2006-12-08 00:00:00	2006-12-22	2006-12-22 00:00:00	2006-12-22	38000177		0	0	14		0	0	0	282023	0	1043400	40229134		
215	16	19078461	2004-01-21	2004-01-21 00:00:00	2004-03-21	2004-03-21 00:00:00	2004-03-21	38000177		0	0	60		0	0	0	1165	0	310965	19078461		
42439	3518	1127433	2014-06-29	2014-06-29 00:00:00	2014-07-06	2014-07-06 00:00:00	2014-07-06	38000177		0	0	7		0	0	0	233536	0	313782	1127433		
48983	4064	40229134	1984-11-01	1984-11-01 00:00:00	1984-11-08	1984-11-08 00:00:00	1984-11-08	38000177		0	0	7		0	0	0	270011	0	1043400	40229134		
7733	648	19133905	2016-05-28	2016-05-28 00:00:00	2016-06-08	2016-06-08 00:00:00	2016-06-08	38000177		0	0	11		0	0	0	42915	0	834102	19133905		
10641	884	19078461	1991-08-27	1991-08-27 00:00:00	1991-09-17	1991-09-17 00:00:00	1991-09-17	38000177		0	0	21		0	0	0	58951	0	310965	19078461		
14673	1228	19128022	1993-06-08	1993-06-08 00:00:00	1994-06-03	1994-06-03 00:00:00	1994-06-03	38000177		0	0	360		0	0	0	80921	0	749785	19128022		
43368	3595	19006318	1952-07-16	1952-07-16 00:00:00	1952-07-30	1952-07-30 00:00:00	1952-07-30	38000177		0	0	14		0	0	0	238839	0	105078	19006318		
36317	2992	19059056	1962-12-03	1962-12-03 00:00:00	1962-12-17	1962-12-17 00:00:00	1962-12-17	38000177		0	0	14		0	0	0	199729	0	243670	19059056		
28545	2351	1127433	1966-03-27	1966-03-27 00:00:00	1966-04-26	1966-04-26 00:00:00	1966-04-26	38000177		0	0	30		0	0	0	156506	0	313782	1127433		
13778	1150	1127433	1985-11-17	1985-11-17 00:00:00	1985-11-24	1985-11-24 00:00:00	1985-11-24	38000177		0	0	7		0	0	0	76003	0	313782	1127433		
3533	293	40162522	1978-04-03	1978-04-03 00:00:00	1978-04-03	1978-04-03 00:00:00	\N	38000177		0	0	0		0	0	0	19513	0	857005	40162522		
41774	3458	1115171	2014-04-21	2014-04-21 00:00:00	2014-05-19	2014-05-19 00:00:00	2014-05-19	38000177		0	0	28		0	0	0	229449	0	849574	1115171		
108685	2384	40213160	1984-07-31	1984-07-31 00:00:00	1984-07-31	1984-07-31 00:00:00	1984-07-31	581452		0	0	0		0	0	0	158478	0	10	40213160		
31994	2651	1118084	1989-07-24	1989-07-24 00:00:00	1989-07-24	1989-07-24 00:00:00	\N	38000177		0	0	0		0	0	0	175471	0	00025152531	44923712		
84614	1850	40213160	1957-05-24	1957-05-24 00:00:00	1957-05-24	1957-05-24 00:00:00	1957-05-24	581452		0	0	0		0	0	0	123781	0	10	40213160		
51435	4274	1127433	1999-07-31	1999-07-31 00:00:00	1999-08-14	1999-08-14 00:00:00	1999-08-14	38000177		0	0	14		0	0	0	283623	0	313782	1127433		
42820	3549	1115171	2015-05-31	2015-05-31 00:00:00	2015-06-21	2015-06-21 00:00:00	2015-06-21	38000177		0	0	21		0	0	0	235632	0	849574	1115171		
60367	5022	40231925	1984-05-04	1984-05-04 00:00:00	1984-05-04	1984-05-04 00:00:00	\N	38000177		0	0	0		0	0	0	333659	0	1049221	40231925		
53333	4432	1127433	1994-08-09	1994-08-09 00:00:00	1994-08-16	1994-08-16 00:00:00	1994-08-16	38000177		0	0	7		0	0	0	294616	0	313782	1127433		
24934	2051	1118084	2005-06-25	2005-06-25 00:00:00	2005-06-25	2005-06-25 00:00:00	\N	38000177		0	0	0		0	0	0	136361	0	00025152531	44923712		
12526	1054	1127433	1996-10-26	1996-10-26 00:00:00	1996-11-02	1996-11-02 00:00:00	1996-11-02	38000177		0	0	7		0	0	0	69164	0	313782	1127433		
9548	795	19133905	1968-03-16	1968-03-16 00:00:00	1968-03-23	1968-03-23 00:00:00	1968-03-23	38000177		0	0	7		0	0	0	52706	0	834102	19133905		
23082	1903	19115351	1978-05-02	1978-05-02 00:00:00	1978-07-18	1978-07-18 00:00:00	1978-07-18	38000177		0	0	77		0	0	0	126713	0	563026	19115351		
60918	5066	920300	2000-05-08	2000-05-08 00:00:00	2000-05-15	2000-05-15 00:00:00	2000-05-15	38000177		0	0	7		0	0	0	336799	0	311989	920300		
35624	2936	1713671	1993-12-15	1993-12-15 00:00:00	1994-01-05	1994-01-05 00:00:00	1994-01-05	38000177		0	0	21		0	0	0	195756	0	562251	1713671		
20188	1658	19133873	1925-03-16	1925-03-16 00:00:00	1925-03-24	1925-03-24 00:00:00	1925-03-24	38000177		0	0	8		0	0	0	111384	0	834061	19133873		
23060	500	40213260	2013-01-15	2013-01-15 00:00:00	2013-01-15	2013-01-15 00:00:00	2013-01-15	581452		0	0	0		0	0	0	33485	0	121	40213260		
42103	3490	40229134	1978-05-02	1978-05-02 00:00:00	1978-05-09	1978-05-09 00:00:00	1978-05-09	38000177		0	0	7		0	0	0	231610	0	1043400	40229134		
42138	3494	1127433	2003-07-03	2003-07-03 00:00:00	2003-07-17	2003-07-17 00:00:00	2003-07-17	38000177		0	0	14		0	0	0	231782	0	313782	1127433		
1399	111	19128065	1997-03-22	1997-03-22 00:00:00	1998-03-17	1998-03-17 00:00:00	1998-03-17	38000177		0	0	360		0	0	0	7380	0	749882	19128065		
14593	1223	1127433	1989-05-23	1989-05-23 00:00:00	1989-05-30	1989-05-30 00:00:00	1989-05-30	38000177		0	0	7		0	0	0	80455	0	313782	1127433		
1581	124	19008572	2006-01-11	2006-01-11 00:00:00	2006-02-01	2006-02-01 00:00:00	2006-02-01	38000177		0	0	21		0	0	0	8200	0	106258	19008572		
12330	1036	1127433	2006-10-12	2006-10-12 00:00:00	2006-11-11	2006-11-11 00:00:00	2006-11-11	38000177		0	0	30		0	0	0	68138	0	313782	1127433		
40239	3332	1127078	1962-04-30	1962-04-30 00:00:00	1962-05-14	1962-05-14 00:00:00	1962-05-14	38000177		0	0	14		0	0	0	221089	0	282464	1127078		
219277	4812	40213227	1996-02-28	1996-02-28 00:00:00	1996-02-28	1996-02-28 00:00:00	1996-02-28	581452		0	0	0		0	0	0	320122	0	113	40213227		
15107	1261	920300	2012-05-30	2012-05-30 00:00:00	2012-06-06	2012-06-06 00:00:00	2012-06-06	38000177		0	0	7		0	0	0	83237	0	311989	920300		
38627	3191	1127433	2013-10-08	2013-10-08 00:00:00	2013-10-15	2013-10-15 00:00:00	2013-10-15	38000177		0	0	7		0	0	0	212337	0	313782	1127433		
35835	2950	1127433	1955-04-16	1955-04-16 00:00:00	1955-05-07	1955-05-07 00:00:00	1955-05-07	38000177		0	0	21		0	0	0	196936	0	313782	1127433		
35853	2951	19133873	1962-03-31	1962-03-31 00:00:00	1962-04-09	1962-04-09 00:00:00	1962-04-09	38000177		0	0	9		0	0	0	197064	0	834061	19133873		
25762	2119	1713671	2014-05-29	2014-05-29 00:00:00	2014-06-19	2014-06-19 00:00:00	2014-06-19	38000177		0	0	21		0	0	0	141012	0	562251	1713671		
55224	4586	19128065	1974-10-04	1974-10-04 00:00:00	1975-09-29	1975-09-29 00:00:00	1975-09-29	38000177		0	0	360		0	0	0	305469	0	749882	19128065		
33413	2768	19133905	2009-10-30	2009-10-30 00:00:00	2009-11-11	2009-11-11 00:00:00	2009-11-11	38000177		0	0	12		0	0	0	183124	0	834102	19133905		
43827	3629	19059056	1959-07-20	1959-07-20 00:00:00	1959-08-03	1959-08-03 00:00:00	1959-08-03	38000177		0	0	14		0	0	0	241489	0	243670	19059056		
36401	3001	1713671	1952-11-06	1952-11-06 00:00:00	1952-11-13	1952-11-13 00:00:00	1952-11-13	38000177		0	0	7		0	0	0	200236	0	562251	1713671		
57068	4736	40162522	2002-08-30	2002-08-30 00:00:00	2002-08-30	2002-08-30 00:00:00	\N	38000177		0	0	0		0	0	0	315516	0	857005	40162522		
28135	2326	19059056	1966-11-16	1966-11-16 00:00:00	1966-11-30	1966-11-30 00:00:00	1966-11-30	38000177		0	0	14		0	0	0	154670	0	243670	19059056		
26588	2189	1127433	1981-03-31	1981-03-31 00:00:00	1981-04-07	1981-04-07 00:00:00	1981-04-07	38000177		0	0	7		0	0	0	145942	0	313782	1127433		
21592	1776	1713671	2012-11-24	2012-11-24 00:00:00	2012-12-15	2012-12-15 00:00:00	2012-12-15	38000177		0	0	21		0	0	0	118794	0	562251	1713671		
21653	1779	46275916	1949-09-15	1949-09-15 00:00:00	1949-09-15	1949-09-15 00:00:00	1949-09-15	38000177		0	0	0		0	0	0	119064	0	1660014	46275916		
21698	1782	782047	1956-01-11	1956-01-11 00:00:00	1956-01-11	1956-01-11 00:00:00	1956-01-11	38000177		0	0	0		0	0	0	119339	0	542347	782047		
14724	318	40213227	1995-05-15	1995-05-15 00:00:00	1995-05-15	1995-05-15 00:00:00	1995-05-15	581452		0	0	0		0	0	0	21121	0	113	40213227		
6494	546	19133905	1986-03-11	1986-03-11 00:00:00	1986-03-24	1986-03-24 00:00:00	1986-03-24	38000177		0	0	13		0	0	0	36178	0	834102	19133905		
47745	3958	1713671	1969-07-07	1969-07-07 00:00:00	1969-07-14	1969-07-14 00:00:00	1969-07-14	38000177		0	0	7		0	0	0	263156	0	562251	1713671		
47774	3961	19059056	1974-10-29	1974-10-29 00:00:00	1974-12-05	1974-12-05 00:00:00	1974-12-05	38000177		0	0	37		0	0	0	263350	0	243670	19059056		
23522	1936	1127433	1987-02-07	1987-02-07 00:00:00	1987-02-14	1987-02-14 00:00:00	1987-02-14	38000177		0	0	7		0	0	0	128828	0	313782	1127433		
16373	1357	1127078	1982-05-24	1982-05-24 00:00:00	1982-07-23	1982-07-23 00:00:00	1982-07-23	38000177		0	0	60		0	0	0	90033	0	282464	1127078		
21089	1738	1127433	1980-11-12	1980-11-12 00:00:00	1980-12-17	1980-12-17 00:00:00	1980-12-17	38000177		0	0	35		0	0	0	116167	0	313782	1127433		
41122	3410	40236824	1995-05-22	1995-05-22 00:00:00	1995-05-29	1995-05-29 00:00:00	1995-05-29	38000177		0	0	7		0	0	0	226197	0	1094107	40236824		
58523	4859	40220386	1971-06-05	1971-06-05 00:00:00	1971-06-05	1971-06-05 00:00:00	1971-06-05	38000177		0	0	0		0	0	0	323226	0	1808217	40220386		
4370	363	1713671	1965-06-09	1965-06-09 00:00:00	1965-06-16	1965-06-16 00:00:00	1965-06-16	38000177		0	0	7		0	0	0	24073	0	562251	1713671		
11552	962	1118084	1995-04-18	1995-04-18 00:00:00	1995-04-18	1995-04-18 00:00:00	\N	38000177		0	0	0		0	0	0	64089	0	00025152531	44923712		
75096	1640	40213227	2007-07-18	2007-07-18 00:00:00	2007-07-18	2007-07-18 00:00:00	2007-07-18	581452		0	0	0		0	0	0	110066	0	113	40213227		
12412	268	40213160	1967-08-01	1967-08-01 00:00:00	1967-08-01	1967-08-01 00:00:00	1967-08-01	581452		0	0	0		0	0	0	17803	0	10	40213160		
51119	4247	1154615	1986-03-25	1986-03-25 00:00:00	2002-12-28	2002-12-28 00:00:00	2002-12-28	38000177		0	0	6122		0	0	0	282057	0	745679	1154615		
216	16	1124300	2013-03-21	2013-03-21 00:00:00	2013-03-21	2013-03-21 00:00:00	\N	38000177		0	0	0		0	0	0	1264	0	00781178901	45011828		
42440	3518	1118084	1994-03-12	1994-03-12 00:00:00	1994-03-12	1994-03-12 00:00:00	\N	38000177		0	0	0		0	0	0	233561	0	00025152531	44923712		
48984	4064	19133873	1972-11-30	1972-11-30 00:00:00	1972-12-11	1972-12-11 00:00:00	1972-12-11	38000177		0	0	11		0	0	0	270110	0	834061	19133873		
7734	648	1127433	1938-08-25	1938-08-25 00:00:00	1938-09-08	1938-09-08 00:00:00	1938-09-08	38000177		0	0	14		0	0	0	42840	0	313782	1127433		
10642	884	1127433	2008-03-21	2008-03-21 00:00:00	2008-04-18	2008-04-18 00:00:00	2008-04-18	38000177		0	0	28		0	0	0	58954	0	313782	1127433		
14674	1228	19128022	1995-05-29	1995-05-29 00:00:00	1996-05-23	1996-05-23 00:00:00	1996-05-23	38000177		0	0	360		0	0	0	80922	0	749785	19128022		
43383	3598	1127433	1985-02-19	1985-02-19 00:00:00	1985-04-20	1985-04-20 00:00:00	1985-04-20	38000177		0	0	60		0	0	0	238944	0	313782	1127433		
36318	2992	19129655	1962-12-03	1962-12-03 00:00:00	1962-12-17	1962-12-17 00:00:00	1962-12-17	38000177		0	0	14		0	0	0	199729	0	789980	19129655		
28546	2351	19077572	2018-06-02	2018-06-02 00:00:00	2018-06-02	2018-06-02 00:00:00	\N	38000177		0	0	0		0	0	0	156493	0	310436	19077572		
24237	1991	19059056	1946-11-24	1946-11-24 00:00:00	1946-12-15	1946-12-15 00:00:00	1946-12-15	38000177		0	0	21		0	0	0	132606	0	243670	19059056		
3534	293	1118084	2006-12-22	2006-12-22 00:00:00	2006-12-22	2006-12-22 00:00:00	\N	38000177		0	0	0		0	0	0	19524	0	00025152531	44923712		
41775	3458	1127078	1983-06-30	1983-06-30 00:00:00	1983-07-21	1983-07-21 00:00:00	1983-07-21	38000177		0	0	21		0	0	0	229483	0	282464	1127078		
108688	2384	40213227	2015-11-03	2015-11-03 00:00:00	2015-11-03	2015-11-03 00:00:00	2015-11-03	581452		0	0	0		0	0	0	158521	0	113	40213227		
31996	2651	1127078	1951-06-24	1951-06-24 00:00:00	1951-07-29	1951-07-29 00:00:00	1951-07-29	38000177		0	0	35		0	0	0	175415	0	282464	1127078		
84625	1851	40213227	2009-04-30	2009-04-30 00:00:00	2009-04-30	2009-04-30 00:00:00	2009-04-30	581452		0	0	0		0	0	0	\N	0	113	40213227		
51436	4274	19059056	1943-01-30	1943-01-30 00:00:00	1943-03-01	1943-03-01 00:00:00	1943-03-01	38000177		0	0	30		0	0	0	283559	0	243670	19059056		
42821	3549	1127433	1986-08-03	1986-08-03 00:00:00	1986-08-17	1986-08-17 00:00:00	1986-08-17	38000177		0	0	14		0	0	0	235667	0	313782	1127433		
60369	5022	19019979	1974-04-29	1974-04-29 00:00:00	1974-05-27	1974-05-27 00:00:00	1974-05-27	38000177		0	0	28		0	0	0	333657	0	198405	19019979		
53334	4432	1127433	2014-06-27	2014-06-27 00:00:00	2014-07-25	2014-07-25 00:00:00	2014-07-25	38000177		0	0	28		0	0	0	294586	0	313782	1127433		
24935	2051	1127433	1981-08-22	1981-08-22 00:00:00	1981-09-12	1981-09-12 00:00:00	1981-09-12	38000177		0	0	21		0	0	0	136398	0	313782	1127433		
12527	1054	19059056	1934-06-09	1934-06-09 00:00:00	1934-06-23	1934-06-23 00:00:00	1934-06-23	38000177		0	0	14		0	0	0	69084	0	243670	19059056		
9549	795	1127433	1984-02-16	1984-02-16 00:00:00	1984-03-01	1984-03-01 00:00:00	1984-03-01	38000177		0	0	14		0	0	0	52743	0	313782	1127433		
23083	1903	1127433	2016-07-20	2016-07-20 00:00:00	2016-07-27	2016-07-27 00:00:00	2016-07-27	38000177		0	0	7		0	0	0	126679	0	313782	1127433		
60919	5066	19059056	1973-01-06	1973-01-06 00:00:00	1973-02-03	1973-02-03 00:00:00	1973-02-03	38000177		0	0	28		0	0	0	336803	0	243670	19059056		
35625	2936	40229134	1997-06-22	1997-06-22 00:00:00	1997-06-29	1997-06-29 00:00:00	1997-06-29	38000177		0	0	7		0	0	0	195757	0	1043400	40229134		
20189	1658	1127433	1990-03-27	1990-03-27 00:00:00	1990-04-10	1990-04-10 00:00:00	1990-04-10	38000177		0	0	14		0	0	0	111380	0	313782	1127433		
23062	500	40213227	2013-01-15	2013-01-15 00:00:00	2013-01-15	2013-01-15 00:00:00	2013-01-15	581452		0	0	0		0	0	0	33485	0	113	40213227		
42104	3490	40229134	1980-09-24	1980-09-24 00:00:00	1980-10-01	1980-10-01 00:00:00	1980-10-01	38000177		0	0	7		0	0	0	231625	0	1043400	40229134		
42139	3494	1127433	1968-03-22	1968-03-22 00:00:00	1968-03-29	1968-03-29 00:00:00	1968-03-29	38000177		0	0	7		0	0	0	231740	0	313782	1127433		
1400	111	19127922	2002-02-24	2002-02-24 00:00:00	2003-02-19	2003-02-19 00:00:00	2003-02-19	38000177		0	0	360		0	0	0	7383	0	748962	19127922		
14594	1223	1118084	1989-10-20	1989-10-20 00:00:00	1989-10-20	1989-10-20 00:00:00	\N	38000177		0	0	0		0	0	0	80490	0	00025152531	44923712		
1582	124	19134077	2006-01-11	2006-01-11 00:00:00	2006-02-01	2006-02-01 00:00:00	2006-02-01	38000177		0	0	21		0	0	0	8200	0	835900	19134077		
12331	1036	40229134	1995-07-26	1995-07-26 00:00:00	1995-08-02	1995-08-02 00:00:00	1995-08-02	38000177		0	0	7		0	0	0	68147	0	1043400	40229134		
40240	3332	19129655	1962-04-30	1962-04-30 00:00:00	1962-05-14	1962-05-14 00:00:00	1962-05-14	38000177		0	0	14		0	0	0	221089	0	789980	19129655		
219278	4812	40213296	1996-02-28	1996-02-28 00:00:00	1996-02-28	1996-02-28 00:00:00	1996-02-28	581452		0	0	0		0	0	0	320122	0	52	40213296		
15108	1261	40236824	2012-05-30	2012-05-30 00:00:00	2012-06-06	2012-06-06 00:00:00	2012-06-06	38000177		0	0	7		0	0	0	83237	0	1094107	40236824		
38628	3191	1127433	1969-11-06	1969-11-06 00:00:00	1970-01-05	1970-01-05 00:00:00	1970-01-05	38000177		0	0	60		0	0	0	212387	0	313782	1127433		
35836	2950	40236824	1964-11-17	1964-11-17 00:00:00	1964-12-01	1964-12-01 00:00:00	1964-12-01	38000177		0	0	14		0	0	0	196971	0	1094107	40236824		
35854	2951	1127433	1963-08-23	1963-08-23 00:00:00	1963-09-06	1963-09-06 00:00:00	1963-09-06	38000177		0	0	14		0	0	0	197021	0	313782	1127433		
25763	2119	1127433	1976-04-25	1976-04-25 00:00:00	1976-05-02	1976-05-02 00:00:00	1976-05-02	38000177		0	0	7		0	0	0	141001	0	313782	1127433		
55225	4586	19078461	2003-08-14	2003-08-14 00:00:00	2003-09-04	2003-09-04 00:00:00	2003-09-04	38000177		0	0	21		0	0	0	305485	0	310965	19078461		
33414	2768	1118084	2010-07-15	2010-07-15 00:00:00	2010-07-15	2010-07-15 00:00:00	\N	38000177		0	0	0		0	0	0	183124	0	00025152531	44923712		
43828	3629	19006318	1959-07-20	1959-07-20 00:00:00	1959-08-03	1959-08-03 00:00:00	1959-08-03	38000177		0	0	14		0	0	0	241489	0	105078	19006318		
36402	3001	19006318	1951-06-27	1951-06-27 00:00:00	1951-07-11	1951-07-11 00:00:00	1951-07-11	38000177		0	0	14		0	0	0	200242	0	105078	19006318		
57069	4736	1127433	1987-10-29	1987-10-29 00:00:00	1987-11-05	1987-11-05 00:00:00	1987-11-05	38000177		0	0	7		0	0	0	315484	0	313782	1127433		
28136	2326	1713671	1983-06-25	1983-06-25 00:00:00	1983-07-02	1983-07-02 00:00:00	1983-07-02	38000177		0	0	7		0	0	0	154674	0	562251	1713671		
26589	2189	1127433	2004-04-08	2004-04-08 00:00:00	2004-04-22	2004-04-22 00:00:00	2004-04-22	38000177		0	0	14		0	0	0	145906	0	313782	1127433		
21593	1776	19059056	1918-08-04	1918-08-04 00:00:00	1918-08-18	1918-08-18 00:00:00	1918-08-18	38000177		0	0	14		0	0	0	118781	0	243670	19059056		
21654	1779	40243436	1949-09-15	1949-09-15 00:00:00	1949-09-15	1949-09-15 00:00:00	1949-09-15	38000177		0	0	0		0	0	0	119064	0	1190795	40243436		
21699	1782	40220386	1956-01-11	1956-01-11 00:00:00	1956-01-11	1956-01-11 00:00:00	1956-01-11	38000177		0	0	0		0	0	0	119339	0	1808217	40220386		
14728	318	40213198	2018-10-01	2018-10-01 00:00:00	2018-10-01	2018-10-01 00:00:00	2018-10-01	581452		0	0	0		0	0	0	21101	0	133	40213198		
6495	546	19059056	1946-11-28	1946-11-28 00:00:00	1946-12-28	1946-12-28 00:00:00	1946-12-28	38000177		0	0	30		0	0	0	36149	0	243670	19059056		
47746	3958	1713671	1973-08-29	1973-08-29 00:00:00	1973-09-19	1973-09-19 00:00:00	1973-09-19	38000177		0	0	21		0	0	0	263178	0	562251	1713671		
47775	3961	19019979	1975-10-31	1975-10-31 00:00:00	1975-11-21	1975-11-21 00:00:00	1975-11-21	38000177		0	0	21		0	0	0	263351	0	198405	19019979		
23523	1936	1127433	1979-07-11	1979-07-11 00:00:00	1979-07-18	1979-07-18 00:00:00	1979-07-18	38000177		0	0	7		0	0	0	128771	0	313782	1127433		
16374	1357	1127433	1980-03-18	1980-03-18 00:00:00	1980-03-25	1980-03-25 00:00:00	1980-03-25	38000177		0	0	7		0	0	0	90022	0	313782	1127433		
21091	1738	1127433	1971-11-02	1971-11-02 00:00:00	1971-11-16	1971-11-16 00:00:00	1971-11-16	38000177		0	0	14		0	0	0	116103	0	313782	1127433		
41123	3410	920300	1995-05-22	1995-05-22 00:00:00	1995-05-29	1995-05-29 00:00:00	1995-05-29	38000177		0	0	7		0	0	0	226197	0	311989	920300		
58524	4859	19078924	1971-06-05	1971-06-05 00:00:00	1971-06-05	1971-06-05 00:00:00	1971-06-05	38000177		0	0	0		0	0	0	323226	0	311700	19078924		
4371	363	40229134	1977-05-01	1977-05-01 00:00:00	1977-05-15	1977-05-15 00:00:00	1977-05-15	38000177		0	0	14		0	0	0	24097	0	1043400	40229134		
11553	962	19059056	1957-06-06	1957-06-06 00:00:00	1957-06-27	1957-06-27 00:00:00	1957-06-27	38000177		0	0	21		0	0	0	64024	0	243670	19059056		
75102	1640	40213227	1997-05-14	1997-05-14 00:00:00	1997-05-14	1997-05-14 00:00:00	1997-05-14	581452		0	0	0		0	0	0	110061	0	113	40213227		
12414	268	40213306	1990-04-03	1990-04-03 00:00:00	1990-04-03	1990-04-03 00:00:00	1990-04-03	581452		0	0	0		0	0	0	17822	0	43	40213306		
51120	4247	40169216	1986-03-25	1986-03-25 00:00:00	2002-12-28	2002-12-28 00:00:00	2002-12-28	38000177		0	0	6122		0	0	0	282057	0	895994	40169216		
217	16	1127433	1985-03-05	1985-03-05 00:00:00	1985-03-12	1985-03-12 00:00:00	1985-03-12	38000177		0	0	7		0	0	0	1276	0	313782	1127433		
42441	3518	1127433	1974-11-14	1974-11-14 00:00:00	1974-11-28	1974-11-28 00:00:00	1974-11-28	38000177		0	0	14		0	0	0	233581	0	313782	1127433		
48985	4064	19078461	2004-02-23	2004-02-23 00:00:00	2004-05-23	2004-05-23 00:00:00	2004-05-23	38000177		0	0	90		0	0	0	270124	0	310965	19078461		
7735	648	1127433	1991-12-20	1991-12-20 00:00:00	1992-01-03	1992-01-03 00:00:00	1992-01-03	38000177		0	0	14		0	0	0	42951	0	313782	1127433		
10643	884	1127078	1981-08-16	1981-08-16 00:00:00	1981-10-22	1981-10-22 00:00:00	1981-10-22	38000177		0	0	67		0	0	0	58927	0	282464	1127078		
14675	1228	40232448	1979-07-26	1979-07-26 00:00:00	1979-07-26	1979-07-26 00:00:00	\N	38000177		0	0	0		0	0	0	80916	0	1049630	40232448		
43384	3598	1127433	2006-01-30	2006-01-30 00:00:00	2006-03-06	2006-03-06 00:00:00	2006-03-06	38000177		0	0	35		0	0	0	238945	0	313782	1127433		
36319	2992	19078461	1979-05-12	1979-05-12 00:00:00	1979-06-09	1979-06-09 00:00:00	1979-06-09	38000177		0	0	28		0	0	0	199763	0	310965	19078461		
28547	2351	19059056	1963-02-27	1963-02-27 00:00:00	1963-03-13	1963-03-13 00:00:00	1963-03-13	38000177		0	0	14		0	0	0	156558	0	243670	19059056		
24238	1991	19133905	1987-07-02	1987-07-02 00:00:00	1987-07-09	1987-07-09 00:00:00	1987-07-09	38000177		0	0	7		0	0	0	132559	0	834102	19133905		
3535	293	1127433	1983-08-22	1983-08-22 00:00:00	1983-08-29	1983-08-29 00:00:00	1983-08-29	38000177		0	0	7		0	0	0	19534	0	313782	1127433		
41776	3458	1124300	2019-03-28	2019-03-28 00:00:00	2019-03-28	2019-03-28 00:00:00	\N	38000177		0	0	0		0	0	0	229453	0	00781178901	45011828		
142994	3141	40213227	1993-10-10	1993-10-10 00:00:00	1993-10-10	1993-10-10 00:00:00	1993-10-10	581452		0	0	0		0	0	0	208997	0	113	40213227		
32195	2669	1118084	2019-01-12	2019-01-12 00:00:00	2019-01-12	2019-01-12 00:00:00	\N	38000177		0	0	0		0	0	0	176798	0	00025152531	44923712		
84629	1851	40213306	2000-11-16	2000-11-16 00:00:00	2000-11-16	2000-11-16 00:00:00	2000-11-16	581452		0	0	0		0	0	0	123856	0	43	40213306		
30702	2545	19059056	1948-06-10	1948-06-10 00:00:00	1948-06-24	1948-06-24 00:00:00	1948-06-24	38000177		0	0	14		0	0	0	168394	0	243670	19059056		
42822	3549	1118084	1995-06-15	1995-06-15 00:00:00	1995-06-15	1995-06-15 00:00:00	\N	38000177		0	0	0		0	0	0	235702	0	00025152531	44923712		
60370	5022	1713671	1991-02-22	1991-02-22 00:00:00	1991-03-15	1991-03-15 00:00:00	1991-03-15	38000177		0	0	21		0	0	0	333642	0	562251	1713671		
53335	4433	40163554	1993-04-10	1993-04-10 00:00:00	1993-04-10	1993-04-10 00:00:00	\N	38000177		0	0	0		0	0	0	294693	0	855332	40163554		
24936	2051	40236824	2013-12-16	2013-12-16 00:00:00	2013-12-23	2013-12-23 00:00:00	2013-12-23	38000177		0	0	7		0	0	0	136362	0	1094107	40236824		
12528	1054	40222846	2008-09-08	2008-09-08 00:00:00	2008-09-08	2008-09-08 00:00:00	\N	38000177		0	0	0		0	0	0	69074	0	996740	40222846		
9550	795	40229134	1987-07-23	1987-07-23 00:00:00	1987-07-30	1987-07-30 00:00:00	1987-07-30	38000177		0	0	7		0	0	0	52709	0	1043400	40229134		
23084	1903	1127433	1981-12-30	1981-12-30 00:00:00	1982-01-06	1982-01-06 00:00:00	1982-01-06	38000177		0	0	7		0	0	0	126673	0	313782	1127433		
60920	5067	19059056	1978-04-03	1978-04-03 00:00:00	1978-05-03	1978-05-03 00:00:00	1978-05-03	38000177		0	0	30		0	0	0	336816	0	243670	19059056		
35626	2936	40165015	1975-07-24	1975-07-24 00:00:00	1975-07-24	1975-07-24 00:00:00	\N	38000177		0	0	0		0	0	0	195818	0	861467	40165015		
20190	1658	1115171	1995-04-14	1995-04-14 00:00:00	1995-06-13	1995-06-13 00:00:00	1995-06-13	38000177		0	0	60		0	0	0	111381	0	849574	1115171		
23069	500	40213227	1994-12-06	1994-12-06 00:00:00	1994-12-06	1994-12-06 00:00:00	1994-12-06	581452		0	0	0		0	0	0	33497	0	113	40213227		
42105	3490	1127433	1969-10-30	1969-10-30 00:00:00	1969-11-13	1969-11-13 00:00:00	1969-11-13	38000177		0	0	14		0	0	0	231490	0	313782	1127433		
42140	3494	19133873	1964-10-23	1964-10-23 00:00:00	1964-11-01	1964-11-01 00:00:00	1964-11-01	38000177		0	0	9		0	0	0	231771	0	834061	19133873		
1420	114	40236824	1999-04-04	1999-04-04 00:00:00	1999-04-11	1999-04-11 00:00:00	1999-04-11	38000177		0	0	7		0	0	0	7531	0	1094107	40236824		
14595	1223	19059056	1954-04-22	1954-04-22 00:00:00	1954-05-20	1954-05-20 00:00:00	1954-05-20	38000177		0	0	28		0	0	0	80445	0	243670	19059056		
1583	124	19133873	1994-10-14	1994-10-14 00:00:00	1994-10-27	1994-10-27 00:00:00	1994-10-27	38000177		0	0	13		0	0	0	8242	0	834061	19133873		
12332	1036	1118084	2011-05-13	2011-05-13 00:00:00	2011-05-13	2011-05-13 00:00:00	\N	38000177		0	0	0		0	0	0	68188	0	00025152531	44923712		
40241	3332	40236824	1980-02-25	1980-02-25 00:00:00	1980-03-10	1980-03-10 00:00:00	1980-03-10	38000177		0	0	14		0	0	0	221085	0	1094107	40236824		
219282	4812	40213260	2006-06-28	2006-06-28 00:00:00	2006-06-28	2006-06-28 00:00:00	2006-06-28	581452		0	0	0		0	0	0	320104	0	121	40213260		
15109	1261	1127433	1973-01-01	1973-01-01 00:00:00	1973-01-08	1973-01-08 00:00:00	1973-01-08	38000177		0	0	7		0	0	0	83245	0	313782	1127433		
38629	3191	19075601	2015-09-24	2015-09-24 00:00:00	2015-09-24	2015-09-24 00:00:00	2015-09-24	38000177		0	0	0		0	0	0	212402	0	309362	19075601		
35837	2950	920300	1964-11-17	1964-11-17 00:00:00	1964-11-24	1964-11-24 00:00:00	1964-11-24	38000177		0	0	7		0	0	0	196971	0	311989	920300		
35855	2951	1127433	2017-09-10	2017-09-10 00:00:00	2017-09-17	2017-09-17 00:00:00	2017-09-17	38000177		0	0	7		0	0	0	197049	0	313782	1127433		
25764	2119	1127433	1994-03-10	1994-03-10 00:00:00	1994-03-24	1994-03-24 00:00:00	1994-03-24	38000177		0	0	14		0	0	0	140975	0	313782	1127433		
55226	4586	1118084	1992-06-01	1992-06-01 00:00:00	1992-06-01	1992-06-01 00:00:00	\N	38000177		0	0	0		0	0	0	305521	0	00025152531	44923712		
33415	2768	19059056	1973-12-16	1973-12-16 00:00:00	1973-12-30	1973-12-30 00:00:00	1973-12-30	38000177		0	0	14		0	0	0	183125	0	243670	19059056		
43829	3629	19133873	1961-02-24	1961-02-24 00:00:00	1961-03-09	1961-03-09 00:00:00	1961-03-09	38000177		0	0	13		0	0	0	241490	0	834061	19133873		
36403	3001	19059056	1951-06-27	1951-06-27 00:00:00	1951-07-11	1951-07-11 00:00:00	1951-07-11	38000177		0	0	14		0	0	0	200242	0	243670	19059056		
57070	4736	1127433	1974-11-05	1974-11-05 00:00:00	1974-11-19	1974-11-19 00:00:00	1974-11-19	38000177		0	0	14		0	0	0	315474	0	313782	1127433		
28137	2327	40236824	2012-11-04	2012-11-04 00:00:00	2012-11-11	2012-11-11 00:00:00	2012-11-11	38000177		0	0	7		0	0	0	154755	0	1094107	40236824		
26590	2189	40228214	2010-02-17	2010-02-17 00:00:00	2010-02-17	2010-02-17 00:00:00	\N	38000177		0	0	0		0	0	0	145893	0	1014678	40228214		
21594	1776	1124300	1954-06-11	1954-06-11 00:00:00	1954-06-11	1954-06-11 00:00:00	\N	38000177		0	0	0		0	0	0	118854	0	00781178901	45011828		
21655	1779	1551192	1969-04-15	1969-04-15 00:00:00	1969-04-15	1969-04-15 00:00:00	1969-04-15	38000177		0	0	0		0	0	0	119067	0	312617	1551192		
21700	1782	1367571	1956-01-11	1956-01-11 00:00:00	1956-01-11	1956-01-11 00:00:00	1956-01-11	38000177		0	0	0		0	0	0	119339	0	314659	19080464		
14729	318	40213160	1955-10-10	1955-10-10 00:00:00	1955-10-10	1955-10-10 00:00:00	1955-10-10	581452		0	0	0		0	0	0	21045	0	10	40213160		
5700	479	1127433	1949-02-17	1949-02-17 00:00:00	1949-03-03	1949-03-03 00:00:00	1949-03-03	38000177		0	0	14		0	0	0	31875	0	313782	1127433		
47747	3958	1118084	2001-11-22	2001-11-22 00:00:00	2001-11-22	2001-11-22 00:00:00	\N	38000177		0	0	0		0	0	0	263194	0	00025152531	44923712		
47776	3961	40229134	1973-03-09	1973-03-09 00:00:00	1973-03-16	1973-03-16 00:00:00	1973-03-16	38000177		0	0	7		0	0	0	263368	0	1043400	40229134		
23524	1936	1115171	2009-07-31	2009-07-31 00:00:00	2009-08-30	2009-08-30 00:00:00	2009-08-30	38000177		0	0	30		0	0	0	128759	0	849574	1115171		
16375	1357	1118084	2014-11-07	2014-11-07 00:00:00	2014-11-07	2014-11-07 00:00:00	\N	38000177		0	0	0		0	0	0	90016	0	00025152531	44923712		
21092	1738	1713671	2004-02-16	2004-02-16 00:00:00	2004-03-08	2004-03-08 00:00:00	2004-03-08	38000177		0	0	21		0	0	0	116106	0	562251	1713671		
41124	3410	1118084	2002-06-20	2002-06-20 00:00:00	2002-06-20	2002-06-20 00:00:00	\N	38000177		0	0	0		0	0	0	226161	0	00025152531	44923712		
58525	4859	1154029	1971-06-05	1971-06-05 00:00:00	1971-06-05	1971-06-05 00:00:00	1971-06-05	38000177		0	0	0		0	0	0	323226	0	4337	1154029		
4372	363	1127433	1995-10-16	1995-10-16 00:00:00	1995-10-23	1995-10-23 00:00:00	1995-10-23	38000177		0	0	7		0	0	0	24075	0	313782	1127433		
11554	962	19133905	1994-03-02	1994-03-02 00:00:00	1994-03-10	1994-03-10 00:00:00	1994-03-10	38000177		0	0	8		0	0	0	64028	0	834102	19133905		
75104	1640	40213227	2016-09-07	2016-09-07 00:00:00	2016-09-07	2016-09-07 00:00:00	2016-09-07	581452		0	0	0		0	0	0	110100	0	113	40213227		
12415	268	40213306	1990-01-23	1990-01-23 00:00:00	1990-01-23	1990-01-23 00:00:00	1990-01-23	581452		0	0	0		0	0	0	17827	0	43	40213306		
51121	4247	1127078	1993-07-15	1993-07-15 00:00:00	1993-08-05	1993-08-05 00:00:00	1993-08-05	38000177		0	0	21		0	0	0	282011	0	282464	1127078		
218	16	19128065	1986-10-04	1986-10-04 00:00:00	1987-09-29	1987-09-29 00:00:00	1987-09-29	38000177		0	0	360		0	0	0	1176	0	749882	19128065		
42442	3518	1127433	2018-08-24	2018-08-24 00:00:00	2018-08-31	2018-08-31 00:00:00	2018-08-31	38000177		0	0	7		0	0	0	233597	0	313782	1127433		
48986	4064	40231925	2004-02-23	2004-02-23 00:00:00	2004-02-23	2004-02-23 00:00:00	\N	38000177		0	0	0		0	0	0	270124	0	1049221	40231925		
7736	648	1127433	1993-05-05	1993-05-05 00:00:00	1993-06-09	1993-06-09 00:00:00	1993-06-09	38000177		0	0	35		0	0	0	42964	0	313782	1127433		
10644	884	19128065	1992-08-28	1992-08-28 00:00:00	1993-08-23	1993-08-23 00:00:00	1993-08-23	38000177		0	0	360		0	0	0	58934	0	749882	19128065		
14676	1228	19078461	2016-03-27	2016-03-27 00:00:00	2016-04-10	2016-04-10 00:00:00	2016-04-10	38000177		0	0	14		0	0	0	80932	0	310965	19078461		
43385	3598	40236824	1978-04-20	1978-04-20 00:00:00	1978-05-04	1978-05-04 00:00:00	1978-05-04	38000177		0	0	14		0	0	0	238965	0	1094107	40236824		
36320	2992	1127433	1983-01-10	1983-01-10 00:00:00	1983-02-07	1983-02-07 00:00:00	1983-02-07	38000177		0	0	28		0	0	0	199765	0	313782	1127433		
28548	2351	45892894	2019-04-28	2019-04-28 00:00:00	2019-04-28	2019-04-28 00:00:00	\N	38000177		0	0	0		0	0	0	156519	0	1599803	45892894		
24239	1991	19059056	1946-04-28	1946-04-28 00:00:00	1946-05-12	1946-05-12 00:00:00	1946-05-12	38000177		0	0	14		0	0	0	132615	0	243670	19059056		
3536	293	1713671	1995-08-08	1995-08-08 00:00:00	1995-08-22	1995-08-22 00:00:00	1995-08-22	38000177		0	0	14		0	0	0	19486	0	562251	1713671		
41777	3458	19133905	2000-07-31	2000-07-31 00:00:00	2000-08-07	2000-08-07 00:00:00	2000-08-07	38000177		0	0	7		0	0	0	229471	0	834102	19133905		
142995	3141	40213306	1993-10-10	1993-10-10 00:00:00	1993-10-10	1993-10-10 00:00:00	1993-10-10	581452		0	0	0		0	0	0	208997	0	43	40213306		
32196	2669	1127433	2018-03-08	2018-03-08 00:00:00	2018-04-12	2018-04-12 00:00:00	2018-04-12	38000177		0	0	35		0	0	0	176763	0	313782	1127433		
84631	1851	40213160	1978-08-17	1978-08-17 00:00:00	1978-08-17	1978-08-17 00:00:00	1978-08-17	581452		0	0	0		0	0	0	123862	0	10	40213160		
30703	2545	19006318	1948-06-10	1948-06-10 00:00:00	1948-06-24	1948-06-24 00:00:00	1948-06-24	38000177		0	0	14		0	0	0	168394	0	105078	19006318		
42823	3550	1115171	2005-08-12	2005-08-12 00:00:00	2005-09-09	2005-09-09 00:00:00	2005-09-09	38000177		0	0	28		0	0	0	235757	0	849574	1115171		
60371	5022	40229134	1987-08-29	1987-08-29 00:00:00	1987-09-12	1987-09-12 00:00:00	1987-09-12	38000177		0	0	14		0	0	0	333694	0	1043400	40229134		
53336	4433	19018935	1993-04-10	1993-04-10 00:00:00	1993-04-10	1993-04-10 00:00:00	\N	38000177		0	0	0		0	0	0	294693	0	197604	19018935		
24937	2051	920300	2013-12-16	2013-12-16 00:00:00	2013-12-23	2013-12-23 00:00:00	2013-12-23	38000177		0	0	7		0	0	0	136362	0	311989	920300		
12529	1054	1127433	1973-04-29	1973-04-29 00:00:00	1973-05-13	1973-05-13 00:00:00	1973-05-13	38000177		0	0	14		0	0	0	69132	0	313782	1127433		
9551	795	40229134	1988-06-08	1988-06-08 00:00:00	1988-06-15	1988-06-15 00:00:00	1988-06-15	38000177		0	0	7		0	0	0	52710	0	1043400	40229134		
23094	1905	1127433	1973-06-12	1973-06-12 00:00:00	1973-06-26	1973-06-26 00:00:00	1973-06-26	38000177		0	0	14		0	0	0	126812	0	313782	1127433		
60921	5067	19128065	1988-05-29	1988-05-29 00:00:00	1989-05-24	1989-05-24 00:00:00	1989-05-24	38000177		0	0	360		0	0	0	336841	0	749882	19128065		
35627	2936	1713671	1988-01-23	1988-01-23 00:00:00	1988-02-06	1988-02-06 00:00:00	1988-02-06	38000177		0	0	14		0	0	0	195739	0	562251	1713671		
20191	1658	40236824	1946-05-19	1946-05-19 00:00:00	1946-05-26	1946-05-26 00:00:00	1946-05-26	38000177		0	0	7		0	0	0	111321	0	1094107	40236824		
23071	500	40213160	1966-07-05	1966-07-05 00:00:00	1966-07-05	1966-07-05 00:00:00	1966-07-05	581452		0	0	0		0	0	0	33505	0	10	40213160		
42106	3490	19059056	1956-01-23	1956-01-23 00:00:00	1956-04-22	1956-04-22 00:00:00	1956-04-22	38000177		0	0	90		0	0	0	231516	0	243670	19059056		
42141	3494	19078461	1991-02-03	1991-02-03 00:00:00	1991-02-24	1991-02-24 00:00:00	1991-02-24	38000177		0	0	21		0	0	0	231768	0	310965	19078461		
1421	114	920300	1999-04-04	1999-04-04 00:00:00	1999-04-11	1999-04-11 00:00:00	1999-04-11	38000177		0	0	7		0	0	0	7531	0	311989	920300		
14596	1223	1127433	1966-01-21	1966-01-21 00:00:00	1966-01-28	1966-01-28 00:00:00	1966-01-28	38000177		0	0	7		0	0	0	80513	0	313782	1127433		
1584	124	1127433	1990-02-03	1990-02-03 00:00:00	1990-02-10	1990-02-10 00:00:00	1990-02-10	38000177		0	0	7		0	0	0	8226	0	313782	1127433		
12333	1036	40229134	1981-12-03	1981-12-03 00:00:00	1981-12-10	1981-12-10 00:00:00	1981-12-10	38000177		0	0	7		0	0	0	68150	0	1043400	40229134		
40242	3332	920300	1980-02-25	1980-02-25 00:00:00	1980-03-03	1980-03-03 00:00:00	1980-03-03	38000177		0	0	7		0	0	0	221085	0	311989	920300		
219286	4812	40213160	1955-01-19	1955-01-19 00:00:00	1955-01-19	1955-01-19 00:00:00	1955-01-19	581452		0	0	0		0	0	0	320114	0	10	40213160		
15110	1261	1127433	1990-06-08	1990-06-08 00:00:00	1990-06-22	1990-06-22 00:00:00	1990-06-22	38000177		0	0	14		0	0	0	83243	0	313782	1127433		
38630	3191	40220960	2015-09-24	2015-09-24 00:00:00	2015-09-24	2015-09-24 00:00:00	2015-09-24	38000177		0	0	0		0	0	0	212402	0	1804799	40220960		
35838	2950	19078461	2005-06-23	2005-06-23 00:00:00	2005-07-28	2005-07-28 00:00:00	2005-07-28	38000177		0	0	35		0	0	0	196942	0	310965	19078461		
46315	3836	1127078	1981-01-27	1981-01-27 00:00:00	1981-02-10	1981-02-10 00:00:00	1981-02-10	38000177		0	0	14		0	0	0	254740	0	282464	1127078		
25765	2119	1127433	1992-05-05	1992-05-05 00:00:00	1992-05-19	1992-05-19 00:00:00	1992-05-19	38000177		0	0	14		0	0	0	140974	0	313782	1127433		
55227	4586	920300	1989-11-24	1989-11-24 00:00:00	1989-12-01	1989-12-01 00:00:00	1989-12-01	38000177		0	0	7		0	0	0	305507	0	311989	920300		
33416	2768	46233988	1973-12-16	1973-12-16 00:00:00	1973-12-30	1973-12-30 00:00:00	1973-12-30	38000177		0	0	14		0	0	0	183125	0	1652673	46233988		
43830	3629	1713671	2018-09-26	2018-09-26 00:00:00	2018-10-03	2018-10-03 00:00:00	2018-10-03	38000177		0	0	7		0	0	0	241462	0	562251	1713671		
36404	3001	19059056	1970-07-13	1970-07-13 00:00:00	1970-08-10	1970-08-10 00:00:00	1970-08-10	38000177		0	0	28		0	0	0	200328	0	243670	19059056		
57071	4736	40229134	1979-11-23	1979-11-23 00:00:00	1979-11-30	1979-11-30 00:00:00	1979-11-30	38000177		0	0	7		0	0	0	315483	0	1043400	40229134		
28138	2327	920300	2012-11-04	2012-11-04 00:00:00	2012-11-11	2012-11-11 00:00:00	2012-11-11	38000177		0	0	7		0	0	0	154755	0	311989	920300		
26591	2189	1594382	2010-02-17	2010-02-17 00:00:00	2010-02-17	2010-02-17 00:00:00	\N	38000177		0	0	0		0	0	0	145893	0	1870230	1594382		
21595	1776	1713671	1991-12-07	1991-12-07 00:00:00	1991-12-14	1991-12-14 00:00:00	1991-12-14	38000177		0	0	7		0	0	0	118787	0	562251	1713671		
21656	1779	1127433	1978-07-13	1978-07-13 00:00:00	1978-07-27	1978-07-27 00:00:00	1978-07-27	38000177		0	0	14		0	0	0	118998	0	313782	1127433		
21701	1782	42707627	1956-01-11	1956-01-11 00:00:00	1956-01-11	1956-01-11 00:00:00	1956-01-11	38000177		0	0	0		0	0	0	119339	0	1234995	42707627		
14735	318	40213260	2006-07-24	2006-07-24 00:00:00	2006-07-24	2006-07-24 00:00:00	2006-07-24	581452		0	0	0		0	0	0	21105	0	121	40213260		
5701	479	19059056	1955-12-27	1955-12-27 00:00:00	1956-01-17	1956-01-17 00:00:00	1956-01-17	38000177		0	0	21		0	0	0	31853	0	243670	19059056		
47748	3958	1127433	1993-10-25	1993-10-25 00:00:00	1993-11-22	1993-11-22 00:00:00	1993-11-22	38000177		0	0	28		0	0	0	263174	0	313782	1127433		
47777	3961	40220960	2014-10-28	2014-10-28 00:00:00	2014-10-28	2014-10-28 00:00:00	2014-10-28	38000177		0	0	0		0	0	0	263347	0	1804799	40220960		
23525	1936	40165015	2009-07-31	2009-07-31 00:00:00	2009-07-31	2009-07-31 00:00:00	\N	38000177		0	0	0		0	0	0	128759	0	861467	40165015		
16376	1357	1127433	2000-05-19	2000-05-19 00:00:00	2000-06-09	2000-06-09 00:00:00	2000-06-09	38000177		0	0	21		0	0	0	90036	0	313782	1127433		
21093	1738	1127433	1986-07-15	1986-07-15 00:00:00	1986-07-29	1986-07-29 00:00:00	1986-07-29	38000177		0	0	14		0	0	0	116149	0	313782	1127433		
41125	3410	19128065	1985-03-06	1985-03-06 00:00:00	1986-03-01	1986-03-01 00:00:00	1986-03-01	38000177		0	0	360		0	0	0	226170	0	749882	19128065		
58526	4859	35605482	1971-06-05	1971-06-05 00:00:00	1971-06-05	1971-06-05 00:00:00	1971-06-05	38000177		0	0	0		0	0	0	323226	0	1740467	35605482		
4373	363	1127433	1990-08-25	1990-08-25 00:00:00	1990-09-22	1990-09-22 00:00:00	1990-09-22	38000177		0	0	28		0	0	0	24069	0	313782	1127433		
11555	962	40229134	1982-09-25	1982-09-25 00:00:00	1982-10-09	1982-10-09 00:00:00	1982-10-09	38000177		0	0	14		0	0	0	64088	0	1043400	40229134		
42982	938	40213227	2017-01-05	2017-01-05 00:00:00	2017-01-05	2017-01-05 00:00:00	2017-01-05	581452		0	0	0		0	0	0	62391	0	113	40213227		
12422	268	40213227	1999-04-13	1999-04-13 00:00:00	1999-04-13	1999-04-13 00:00:00	1999-04-13	581452		0	0	0		0	0	0	17828	0	113	40213227		
51122	4247	1127078	1985-10-12	1985-10-12 00:00:00	1985-10-26	1985-10-26 00:00:00	1985-10-26	38000177		0	0	14		0	0	0	282089	0	282464	1127078		
219	16	19128065	1987-09-29	1987-09-29 00:00:00	1988-09-23	1988-09-23 00:00:00	1988-09-23	38000177		0	0	360		0	0	0	1189	0	749882	19128065		
42443	3518	1127433	2006-11-16	2006-11-16 00:00:00	2006-11-23	2006-11-23 00:00:00	2006-11-23	38000177		0	0	7		0	0	0	233596	0	313782	1127433		
48987	4064	19134077	1999-12-07	1999-12-07 00:00:00	1999-12-28	1999-12-28 00:00:00	1999-12-28	38000177		0	0	21		0	0	0	270047	0	835900	19134077		
7737	648	19059056	1939-02-13	1939-02-13 00:00:00	1939-05-14	1939-05-14 00:00:00	1939-05-14	38000177		0	0	90		0	0	0	42960	0	243670	19059056		
10645	884	40243436	2005-05-24	2005-05-24 00:00:00	2005-05-24	2005-05-24 00:00:00	2005-05-24	38000177		0	0	0		0	0	0	58952	0	1190795	40243436		
14677	1228	19073188	2016-03-27	2016-03-27 00:00:00	2016-04-10	2016-04-10 00:00:00	2016-04-10	38000177		0	0	14		0	0	0	80932	0	308192	19073188		
43386	3598	920300	1978-04-20	1978-04-20 00:00:00	1978-04-27	1978-04-27 00:00:00	1978-04-27	38000177		0	0	7		0	0	0	238965	0	311989	920300		
36321	2992	40229134	2016-06-30	2016-06-30 00:00:00	2016-07-14	2016-07-14 00:00:00	2016-07-14	38000177		0	0	14		0	0	0	199745	0	1043400	40229134		
28549	2352	1713671	2001-02-22	2001-02-22 00:00:00	2001-03-08	2001-03-08 00:00:00	2001-03-08	38000177		0	0	14		0	0	0	156620	0	562251	1713671		
24240	1992	19128022	1995-02-16	1995-02-16 00:00:00	1996-02-11	1996-02-11 00:00:00	1996-02-11	38000177		0	0	360		0	0	0	132646	0	749785	19128022		
3537	293	19078461	2018-03-04	2018-03-04 00:00:00	2018-03-25	2018-03-25 00:00:00	2018-03-25	38000177		0	0	21		0	0	0	19516	0	310965	19078461		
41778	3458	19078461	1992-06-03	1992-06-03 00:00:00	1992-06-24	1992-06-24 00:00:00	1992-06-24	38000177		0	0	21		0	0	0	229446	0	310965	19078461		
154306	3397	40213227	2016-02-20	2016-02-20 00:00:00	2016-02-20	2016-02-20 00:00:00	2016-02-20	581452		0	0	0		0	0	0	225369	0	113	40213227		
32197	2669	19019979	1979-10-24	1979-10-24 00:00:00	1979-11-28	1979-11-28 00:00:00	1979-11-28	38000177		0	0	35		0	0	0	176762	0	198405	19019979		
84639	1851	40213314	1978-05-18	1978-05-18 00:00:00	1978-05-18	1978-05-18 00:00:00	1978-05-18	581452		0	0	0		0	0	0	123843	0	49	40213314		
30706	2545	1127433	1959-11-12	1959-11-12 00:00:00	1959-11-26	1959-11-26 00:00:00	1959-11-26	38000177		0	0	14		0	0	0	168438	0	313782	1127433		
42824	3550	40162522	2005-08-12	2005-08-12 00:00:00	2005-08-12	2005-08-12 00:00:00	\N	38000177		0	0	0		0	0	0	235757	0	857005	40162522		
60372	5022	46233988	1972-09-06	1972-09-06 00:00:00	1972-09-20	1972-09-20 00:00:00	1972-09-20	38000177		0	0	14		0	0	0	333697	0	1652673	46233988		
53337	4433	40171902	1993-04-10	1993-04-10 00:00:00	1993-04-10	1993-04-10 00:00:00	\N	38000177		0	0	0		0	0	0	294693	0	897718	40171902		
24938	2051	1127433	1980-03-17	1980-03-17 00:00:00	1980-03-31	1980-03-31 00:00:00	1980-03-31	38000177		0	0	14		0	0	0	136369	0	313782	1127433		
12530	1054	1127433	2012-03-01	2012-03-01 00:00:00	2012-03-15	2012-03-15 00:00:00	2012-03-15	38000177		0	0	14		0	0	0	69137	0	313782	1127433		
8307	693	40162522	1999-09-11	1999-09-11 00:00:00	1999-09-11	1999-09-11 00:00:00	\N	38000177		0	0	0		0	0	0	45884	0	857005	40162522		
23095	1905	19133905	1990-01-27	1990-01-27 00:00:00	1990-02-04	1990-02-04 00:00:00	1990-02-04	38000177		0	0	8		0	0	0	126821	0	834102	19133905		
60922	5067	19128022	1993-05-03	1993-05-03 00:00:00	1994-04-28	1994-04-28 00:00:00	1994-04-28	38000177		0	0	360		0	0	0	336880	0	749785	19128022		
35628	2936	1713671	1972-12-24	1972-12-24 00:00:00	1973-01-14	1973-01-14 00:00:00	1973-01-14	38000177		0	0	21		0	0	0	195737	0	562251	1713671		
20192	1658	920300	1946-05-19	1946-05-19 00:00:00	1946-05-26	1946-05-26 00:00:00	1946-05-26	38000177		0	0	7		0	0	0	111321	0	311989	920300		
23077	500	40213227	2002-12-17	2002-12-17 00:00:00	2002-12-17	2002-12-17 00:00:00	2002-12-17	581452		0	0	0		0	0	0	33483	0	113	40213227		
42107	3490	1713671	1978-08-04	1978-08-04 00:00:00	1978-08-11	1978-08-11 00:00:00	1978-08-11	38000177		0	0	7		0	0	0	231573	0	562251	1713671		
42142	3494	40169281	2001-05-03	2001-05-03 00:00:00	2001-05-03	2001-05-03 00:00:00	\N	38000177		0	0	0		0	0	0	231734	0	896209	40169281		
1422	114	1127078	1973-04-07	1973-04-07 00:00:00	1973-05-05	1973-05-05 00:00:00	1973-05-05	38000177		0	0	28		0	0	0	7504	0	282464	1127078		
14597	1223	1127433	1983-07-17	1983-07-17 00:00:00	1983-09-15	1983-09-15 00:00:00	1983-09-15	38000177		0	0	60		0	0	0	80446	0	313782	1127433		
1585	124	1127078	1985-05-30	1985-05-30 00:00:00	1985-06-13	1985-06-13 00:00:00	1985-06-13	38000177		0	0	14		0	0	0	8208	0	282464	1127078		
12334	1036	19019979	1978-12-17	1978-12-17 00:00:00	1979-01-16	1979-01-16 00:00:00	1979-01-16	38000177		0	0	30		0	0	0	68135	0	198405	19019979		
40243	3332	1127433	1987-12-15	1987-12-15 00:00:00	1987-12-29	1987-12-29 00:00:00	1987-12-29	38000177		0	0	14		0	0	0	221088	0	313782	1127433		
73323	1602	40213160	1967-11-01	1967-11-01 00:00:00	1967-11-01	1967-11-01 00:00:00	1967-11-01	581452		0	0	0		0	0	0	107562	0	10	40213160		
15111	1261	1127433	2016-04-12	2016-04-12 00:00:00	2016-04-19	2016-04-19 00:00:00	2016-04-19	38000177		0	0	7		0	0	0	83155	0	313782	1127433		
38631	3191	40229134	1992-05-26	1992-05-26 00:00:00	1992-06-09	1992-06-09 00:00:00	1992-06-09	38000177		0	0	14		0	0	0	212345	0	1043400	40229134		
35839	2950	920334	1964-11-24	1964-11-24 00:00:00	1964-12-01	1964-12-01 00:00:00	1964-12-01	38000177		0	0	7		0	0	0	196896	0	311995	920334		
46316	3836	19074843	1981-01-27	1981-01-27 00:00:00	1981-02-10	1981-02-10 00:00:00	1981-02-10	38000177		0	0	14		0	0	0	254740	0	309045	19074843		
25766	2119	1118084	2001-05-23	2001-05-23 00:00:00	2001-05-23	2001-05-23 00:00:00	\N	38000177		0	0	0		0	0	0	141094	0	00025152531	44923712		
55228	4586	40236824	1989-11-24	1989-11-24 00:00:00	1989-12-01	1989-12-01 00:00:00	1989-12-01	38000177		0	0	7		0	0	0	305507	0	1094107	40236824		
33418	2768	1127433	2002-08-26	2002-08-26 00:00:00	2002-09-09	2002-09-09 00:00:00	2002-09-09	38000177		0	0	14		0	0	0	183123	0	313782	1127433		
43831	3629	1127433	1973-05-20	1973-05-20 00:00:00	1973-07-26	1973-07-26 00:00:00	1973-07-26	38000177		0	0	67		0	0	0	241471	0	313782	1127433		
36405	3001	19059056	1952-06-27	1952-06-27 00:00:00	1952-07-11	1952-07-11 00:00:00	1952-07-11	38000177		0	0	14		0	0	0	200243	0	243670	19059056		
57072	4736	1127078	1974-11-04	1974-11-04 00:00:00	1974-11-18	1974-11-18 00:00:00	1974-11-18	38000177		0	0	14		0	0	0	315503	0	282464	1127078		
28139	2327	19133873	1965-12-17	1965-12-17 00:00:00	1965-12-30	1965-12-30 00:00:00	1965-12-30	38000177		0	0	13		0	0	0	154731	0	834061	19133873		
26592	2189	19008572	2010-02-03	2010-02-03 00:00:00	2010-02-03	2010-02-03 00:00:00	\N	38000177		0	0	0		0	0	0	145956	0	106258	19008572		
21596	1776	1127433	2001-01-11	2001-01-11 00:00:00	2001-02-15	2001-02-15 00:00:00	2001-02-15	38000177		0	0	35		0	0	0	118885	0	313782	1127433		
21657	1779	1115171	1994-02-01	1994-02-01 00:00:00	1994-02-22	1994-02-22 00:00:00	1994-02-22	38000177		0	0	21		0	0	0	119008	0	849574	1115171		
21702	1782	35605482	1956-01-11	1956-01-11 00:00:00	1956-01-11	1956-01-11 00:00:00	1956-01-11	38000177		0	0	0		0	0	0	119339	0	1740467	35605482		
14738	318	40213160	1958-04-14	1958-04-14 00:00:00	1958-04-14	1958-04-14 00:00:00	1958-04-14	581452		0	0	0		0	0	0	21087	0	10	40213160		
5702	479	1127433	2004-11-03	2004-11-03 00:00:00	2004-11-10	2004-11-10 00:00:00	2004-11-10	38000177		0	0	7		0	0	0	31882	0	313782	1127433		
47749	3958	19075001	1993-10-25	1993-10-25 00:00:00	1993-11-22	1993-11-22 00:00:00	1993-11-22	38000177		0	0	28		0	0	0	263174	0	309097	19075001		
47778	3961	19075601	2014-10-28	2014-10-28 00:00:00	2014-10-28	2014-10-28 00:00:00	2014-10-28	38000177		0	0	0		0	0	0	263347	0	309362	19075601		
23527	1936	19078461	1980-06-19	1980-06-19 00:00:00	1980-07-03	1980-07-03 00:00:00	1980-07-03	38000177		0	0	14		0	0	0	128758	0	310965	19078461		
16377	1357	19133873	1980-07-29	1980-07-29 00:00:00	1980-08-06	1980-08-06 00:00:00	1980-08-06	38000177		0	0	8		0	0	0	89997	0	834061	19133873		
21094	1738	1713671	1976-09-09	1976-09-09 00:00:00	1976-09-16	1976-09-16 00:00:00	1976-09-16	38000177		0	0	7		0	0	0	116147	0	562251	1713671		
41126	3410	19059056	1966-09-13	1966-09-13 00:00:00	1966-09-27	1966-09-27 00:00:00	1966-09-27	38000177		0	0	14		0	0	0	226211	0	243670	19059056		
58527	4859	1367571	1971-06-05	1971-06-05 00:00:00	1971-06-05	1971-06-05 00:00:00	1971-06-05	38000177		0	0	0		0	0	0	323226	0	314659	19080464		
4374	363	19078461	2016-10-08	2016-10-08 00:00:00	2016-10-22	2016-10-22 00:00:00	2016-10-22	38000177		0	0	14		0	0	0	24127	0	310965	19078461		
11556	962	19059056	1962-02-01	1962-02-01 00:00:00	1962-03-08	1962-03-08 00:00:00	1962-03-08	38000177		0	0	35		0	0	0	64025	0	243670	19059056		
87540	1921	40213201	2018-01-22	2018-01-22 00:00:00	2018-01-22	2018-01-22 00:00:00	2018-01-22	581452		0	0	0		0	0	0	127780	0	33	40213201		
12424	268	40213160	1967-10-31	1967-10-31 00:00:00	1967-10-31	1967-10-31 00:00:00	1967-10-31	581452		0	0	0		0	0	0	17816	0	10	40213160		
51123	4247	19073183	1985-10-12	1985-10-12 00:00:00	1985-10-26	1985-10-26 00:00:00	1985-10-26	38000177		0	0	14		0	0	0	282089	0	308182	19073183		
220	17	19115351	1965-01-11	1965-01-11 00:00:00	1965-07-05	1965-07-05 00:00:00	1965-07-05	38000177		0	0	175		0	0	0	1335	0	563026	19115351		
42444	3518	1127433	1978-09-08	1978-09-08 00:00:00	1978-10-15	1978-10-15 00:00:00	1978-10-15	38000177		0	0	37		0	0	0	233582	0	313782	1127433		
48988	4064	19008572	1999-12-07	1999-12-07 00:00:00	1999-12-28	1999-12-28 00:00:00	1999-12-28	38000177		0	0	21		0	0	0	270047	0	106258	19008572		
7738	648	1127433	1951-12-20	1951-12-20 00:00:00	1952-01-03	1952-01-03 00:00:00	1952-01-03	38000177		0	0	14		0	0	0	42844	0	313782	1127433		
10646	884	1118084	2017-09-16	2017-09-16 00:00:00	2017-09-16	2017-09-16 00:00:00	\N	38000177		0	0	0		0	0	0	58968	0	00025152531	44923712		
14678	1228	1127433	1984-10-13	1984-10-13 00:00:00	1984-10-20	1984-10-20 00:00:00	1984-10-20	38000177		0	0	7		0	0	0	80874	0	313782	1127433		
43387	3598	19059056	1947-10-07	1947-10-07 00:00:00	1947-10-21	1947-10-21 00:00:00	1947-10-21	38000177		0	0	14		0	0	0	238933	0	243670	19059056		
36322	2992	40229134	2000-10-07	2000-10-07 00:00:00	2000-10-14	2000-10-14 00:00:00	2000-10-14	38000177		0	0	7		0	0	0	199743	0	1043400	40229134		
28550	2352	40169216	1972-11-01	1972-11-01 00:00:00	1972-11-01	1972-11-01 00:00:00	\N	38000177		0	0	0		0	0	0	156644	0	895994	40169216		
24241	1992	1150771	1978-04-12	1978-04-12 00:00:00	1978-04-12	1978-04-12 00:00:00	\N	38000177		0	0	0		0	0	0	132730	0	197378	1150771		
3538	293	1713671	2014-09-05	2014-09-05 00:00:00	2014-09-12	2014-09-12 00:00:00	2014-09-12	38000177		0	0	7		0	0	0	19526	0	562251	1713671		
41779	3458	1127433	1997-09-29	1997-09-29 00:00:00	1997-10-06	1997-10-06 00:00:00	1997-10-06	38000177		0	0	7		0	0	0	229452	0	313782	1127433		
154310	3397	40213227	2005-10-15	2005-10-15 00:00:00	2005-10-15	2005-10-15 00:00:00	2005-10-15	581452		0	0	0		0	0	0	225378	0	113	40213227		
32198	2669	1713671	1987-11-10	1987-11-10 00:00:00	1987-12-01	1987-12-01 00:00:00	1987-12-01	38000177		0	0	21		0	0	0	176787	0	562251	1713671		
84640	1851	40213160	1978-05-18	1978-05-18 00:00:00	1978-05-18	1978-05-18 00:00:00	1978-05-18	581452		0	0	0		0	0	0	123843	0	10	40213160		
30707	2545	19059056	1947-09-14	1947-09-14 00:00:00	1947-10-05	1947-10-05 00:00:00	1947-10-05	38000177		0	0	21		0	0	0	168453	0	243670	19059056		
1886	152	19133905	2017-01-26	2017-01-26 00:00:00	2017-02-05	2017-02-05 00:00:00	2017-02-05	38000177		0	0	10		0	0	0	10270	0	834102	19133905		
61941	5151	19078461	1987-04-13	1987-04-13 00:00:00	1987-04-27	1987-04-27 00:00:00	1987-04-27	38000177		0	0	14		0	0	0	342588	0	310965	19078461		
53338	4433	1127433	2008-08-02	2008-08-02 00:00:00	2008-08-16	2008-08-16 00:00:00	2008-08-16	38000177		0	0	14		0	0	0	294657	0	313782	1127433		
24939	2051	19128065	1977-11-09	1977-11-09 00:00:00	1978-11-04	1978-11-04 00:00:00	1978-11-04	38000177		0	0	360		0	0	0	136387	0	749882	19128065		
12531	1054	1713671	1934-03-20	1934-03-20 00:00:00	1934-04-10	1934-04-10 00:00:00	1934-04-10	38000177		0	0	21		0	0	0	69143	0	562251	1713671		
8308	693	19133905	2005-05-31	2005-05-31 00:00:00	2005-06-13	2005-06-13 00:00:00	2005-06-13	38000177		0	0	13		0	0	0	45901	0	834102	19133905		
23097	1905	1127433	2000-10-31	2000-10-31 00:00:00	2000-11-21	2000-11-21 00:00:00	2000-11-21	38000177		0	0	21		0	0	0	126841	0	313782	1127433		
3582	78	40213296	2009-04-23	2009-04-23 00:00:00	2009-04-23	2009-04-23 00:00:00	2009-04-23	581452		0	0	0		0	0	0	\N	0	52	40213296		
35629	2936	19059056	1989-03-03	1989-03-03 00:00:00	1989-05-09	1989-05-09 00:00:00	1989-05-09	38000177		0	0	67		0	0	0	195769	0	243670	19059056		
20193	1658	1127433	1928-07-31	1928-07-31 00:00:00	1928-08-14	1928-08-14 00:00:00	1928-08-14	38000177		0	0	14		0	0	0	111320	0	313782	1127433		
23078	500	40213296	2002-12-17	2002-12-17 00:00:00	2002-12-17	2002-12-17 00:00:00	2002-12-17	581452		0	0	0		0	0	0	33483	0	52	40213296		
42108	3490	1127433	1990-04-23	1990-04-23 00:00:00	1990-04-30	1990-04-30 00:00:00	1990-04-30	38000177		0	0	7		0	0	0	231626	0	313782	1127433		
42143	3494	19059056	1984-01-27	1984-01-27 00:00:00	1984-02-10	1984-02-10 00:00:00	1984-02-10	38000177		0	0	14		0	0	0	231766	0	243670	19059056		
1423	114	19078461	1988-08-14	1988-08-14 00:00:00	1988-08-28	1988-08-28 00:00:00	1988-08-28	38000177		0	0	14		0	0	0	7505	0	310965	19078461		
14598	1223	40165015	1983-07-17	1983-07-17 00:00:00	1983-07-17	1983-07-17 00:00:00	\N	38000177		0	0	0		0	0	0	80446	0	861467	40165015		
1586	124	19074843	1985-05-30	1985-05-30 00:00:00	1985-06-13	1985-06-13 00:00:00	1985-06-13	38000177		0	0	14		0	0	0	8208	0	309045	19074843		
25129	2069	1118084	1988-09-01	1988-09-01 00:00:00	1988-09-01	1988-09-01 00:00:00	\N	38000177		0	0	0		0	0	0	137568	0	00025152531	44923712		
40244	3332	1713671	2006-11-23	2006-11-23 00:00:00	2006-12-07	2006-12-07 00:00:00	2006-12-07	38000177		0	0	14		0	0	0	221102	0	562251	1713671		
73328	1602	40213227	2014-04-23	2014-04-23 00:00:00	2014-04-23	2014-04-23 00:00:00	2014-04-23	581452		0	0	0		0	0	0	107555	0	113	40213227		
15112	1261	1115171	1995-01-10	1995-01-10 00:00:00	1995-01-31	1995-01-31 00:00:00	1995-01-31	38000177		0	0	21		0	0	0	83217	0	849574	1115171		
38632	3191	1127433	1999-03-30	1999-03-30 00:00:00	1999-05-04	1999-05-04 00:00:00	1999-05-04	38000177		0	0	35		0	0	0	212390	0	313782	1127433		
35840	2950	19059056	1986-09-05	1986-09-05 00:00:00	1986-10-10	1986-10-10 00:00:00	1986-10-10	38000177		0	0	35		0	0	0	196939	0	243670	19059056		
46317	3836	1127078	1977-08-01	1977-08-01 00:00:00	1977-08-15	1977-08-15 00:00:00	1977-08-15	38000177		0	0	14		0	0	0	254726	0	282464	1127078		
25767	2119	19074841	1980-04-03	1980-04-03 00:00:00	1980-05-08	1980-05-08 00:00:00	1980-05-08	38000177		0	0	35		0	0	0	140973	0	309043	19074841		
55229	4586	1127433	1968-05-29	1968-05-29 00:00:00	1968-06-05	1968-06-05 00:00:00	1968-06-05	38000177		0	0	7		0	0	0	305464	0	313782	1127433		
33419	2768	19133873	1974-11-13	1974-11-13 00:00:00	1974-11-22	1974-11-22 00:00:00	1974-11-22	38000177		0	0	9		0	0	0	183169	0	834061	19133873		
43832	3629	19059056	1957-06-13	1957-06-13 00:00:00	1957-06-27	1957-06-27 00:00:00	1957-06-27	38000177		0	0	14		0	0	0	241463	0	243670	19059056		
36406	3001	19006318	1952-06-27	1952-06-27 00:00:00	1952-07-11	1952-07-11 00:00:00	1952-07-11	38000177		0	0	14		0	0	0	200243	0	105078	19006318		
57073	4736	46233988	1974-11-04	1974-11-04 00:00:00	1974-11-18	1974-11-18 00:00:00	1974-11-18	38000177		0	0	14		0	0	0	315503	0	1652673	46233988		
28140	2327	19078461	1996-04-27	1996-04-27 00:00:00	1996-05-11	1996-05-11 00:00:00	1996-05-11	38000177		0	0	14		0	0	0	154729	0	310965	19078461		
26593	2189	1127078	1988-09-18	1988-09-18 00:00:00	1988-10-02	1988-10-02 00:00:00	1988-10-02	38000177		0	0	14		0	0	0	145890	0	282464	1127078		
21597	1776	19059056	1920-01-28	1920-01-28 00:00:00	1920-02-11	1920-02-11 00:00:00	1920-02-11	38000177		0	0	14		0	0	0	118796	0	243670	19059056		
21658	1780	1124300	2006-02-20	2006-02-20 00:00:00	2006-02-20	2006-02-20 00:00:00	\N	38000177		0	0	0		0	0	0	119120	0	00781178901	45011828		
21703	1782	35605482	1956-01-11	1956-01-11 00:00:00	1956-01-11	1956-01-11 00:00:00	1956-01-11	38000177		0	0	0		0	0	0	119339	0	1740467	35605482		
14746	318	40213160	1955-04-11	1955-04-11 00:00:00	1955-04-11	1955-04-11 00:00:00	1955-04-11	581452		0	0	0		0	0	0	21085	0	10	40213160		
5703	479	1115171	2016-09-03	2016-09-03 00:00:00	2016-10-03	2016-10-03 00:00:00	2016-10-03	38000177		0	0	30		0	0	0	31963	0	849574	1115171		
47750	3958	40162522	1993-10-25	1993-10-25 00:00:00	1993-10-25	1993-10-25 00:00:00	\N	38000177		0	0	0		0	0	0	263174	0	857005	40162522		
47779	3961	19073183	1984-03-29	1984-03-29 00:00:00	1984-04-12	1984-04-12 00:00:00	1984-04-12	38000177		0	0	14		0	0	0	263372	0	308182	19073183		
23528	1936	19059056	1949-10-08	1949-10-08 00:00:00	1949-11-05	1949-11-05 00:00:00	1949-11-05	38000177		0	0	28		0	0	0	128761	0	243670	19059056		
16378	1357	19019979	1984-06-12	1984-06-12 00:00:00	1984-09-10	1984-09-10 00:00:00	1984-09-10	38000177		0	0	90		0	0	0	90034	0	198405	19019979		
21095	1738	40236824	2009-06-07	2009-06-07 00:00:00	2009-06-14	2009-06-14 00:00:00	2009-06-14	38000177		0	0	7		0	0	0	116137	0	1094107	40236824		
20214	440	40213296	2016-04-13	2016-04-13 00:00:00	2016-04-13	2016-04-13 00:00:00	2016-04-13	581452		0	0	0		0	0	0	29214	0	52	40213296		
58528	4859	42707627	1971-06-05	1971-06-05 00:00:00	1971-06-05	1971-06-05 00:00:00	1971-06-05	38000177		0	0	0		0	0	0	323226	0	1234995	42707627		
4375	363	1713671	2003-09-12	2003-09-12 00:00:00	2003-10-03	2003-10-03 00:00:00	2003-10-03	38000177		0	0	21		0	0	0	24098	0	562251	1713671		
11557	962	19006318	1962-02-01	1962-02-01 00:00:00	1962-03-08	1962-03-08 00:00:00	1962-03-08	38000177		0	0	35		0	0	0	64025	0	105078	19006318		
87550	1921	40213227	1992-09-28	1992-09-28 00:00:00	1992-09-28	1992-09-28 00:00:00	1992-09-28	581452		0	0	0		0	0	0	127745	0	113	40213227		
6143	515	1539411	1996-11-23	1996-11-23 00:00:00	1996-11-23	1996-11-23 00:00:00	\N	38000177		0	0	0		0	0	0	34396	0	312961	1539411		
51124	4247	19133873	1995-07-16	1995-07-16 00:00:00	1995-07-27	1995-07-27 00:00:00	1995-07-27	38000177		0	0	11		0	0	0	282100	0	834061	19133873		
221	17	19133873	1960-02-08	1960-02-08 00:00:00	1960-02-20	1960-02-20 00:00:00	1960-02-20	38000177		0	0	12		0	0	0	1321	0	834061	19133873		
25	2	19078461	1977-04-08	1977-04-08 00:00:00	1977-04-22	1977-04-22 00:00:00	1977-04-22	38000177		0	0	14		0	0	0	115	0	310965	19078461		
48989	4064	1127433	1991-01-06	1991-01-06 00:00:00	1991-01-13	1991-01-13 00:00:00	1991-01-13	38000177		0	0	7		0	0	0	270019	0	313782	1127433		
7739	648	1127433	2005-08-27	2005-08-27 00:00:00	2005-09-10	2005-09-10 00:00:00	2005-09-10	38000177		0	0	14		0	0	0	42905	0	313782	1127433		
10647	885	1127078	1979-12-03	1979-12-03 00:00:00	1979-12-17	1979-12-17 00:00:00	1979-12-17	38000177		0	0	14		0	0	0	59019	0	282464	1127078		
36203	2985	46275916	1967-06-17	1967-06-17 00:00:00	1967-06-17	1967-06-17 00:00:00	1967-06-17	38000177		0	0	0		0	0	0	199186	0	1660014	46275916		
43388	3598	19006318	1947-10-07	1947-10-07 00:00:00	1947-10-21	1947-10-21 00:00:00	1947-10-21	38000177		0	0	14		0	0	0	238933	0	105078	19006318		
36325	2993	19128065	1991-05-04	1991-05-04 00:00:00	1992-04-28	1992-04-28 00:00:00	1992-04-28	38000177		0	0	360		0	0	0	199804	0	749882	19128065		
28551	2352	1154615	1972-11-01	1972-11-01 00:00:00	1972-11-01	1972-11-01 00:00:00	\N	38000177		0	0	0		0	0	0	156644	0	745679	1154615		
24242	1992	40236824	2011-04-22	2011-04-22 00:00:00	2011-04-29	2011-04-29 00:00:00	2011-04-29	38000177		0	0	7		0	0	0	132661	0	1094107	40236824		
16597	1376	19059056	1979-12-31	1979-12-31 00:00:00	1980-01-14	1980-01-14 00:00:00	1980-01-14	38000177		0	0	14		0	0	0	91206	0	243670	19059056		
41780	3458	1713671	1996-09-02	1996-09-02 00:00:00	1996-09-16	1996-09-16 00:00:00	1996-09-16	38000177		0	0	14		0	0	0	229451	0	562251	1713671		
30231	2507	19128065	1983-04-18	1983-04-18 00:00:00	1984-04-12	1984-04-12 00:00:00	1984-04-12	38000177		0	0	360		0	0	0	165980	0	749882	19128065		
32199	2669	1713671	1996-11-21	1996-11-21 00:00:00	1996-11-28	1996-11-28 00:00:00	1996-11-28	38000177		0	0	7		0	0	0	176764	0	562251	1713671		
84642	1851	40213314	1978-03-16	1978-03-16 00:00:00	1978-03-16	1978-03-16 00:00:00	1978-03-16	581452		0	0	0		0	0	0	123861	0	49	40213314		
30709	2545	40223774	2003-07-01	2003-07-01 00:00:00	2003-07-01	2003-07-01 00:00:00	\N	38000177		0	0	0		0	0	0	168367	0	998582	40223774		
1887	152	1115171	1995-03-03	1995-03-03 00:00:00	1995-03-24	1995-03-24 00:00:00	1995-03-24	38000177		0	0	21		0	0	0	10293	0	849574	1115171		
61942	5151	1127078	1959-01-05	1959-01-05 00:00:00	1959-01-19	1959-01-19 00:00:00	1959-01-19	38000177		0	0	14		0	0	0	342581	0	282464	1127078		
53339	4433	19059056	1940-02-11	1940-02-11 00:00:00	1940-02-25	1940-02-25 00:00:00	1940-02-25	38000177		0	0	14		0	0	0	294725	0	243670	19059056		
24940	2051	40236824	2018-01-15	2018-01-15 00:00:00	2018-01-22	2018-01-22 00:00:00	2018-01-22	38000177		0	0	7		0	0	0	136373	0	1094107	40236824		
12532	1054	1127433	1939-08-13	1939-08-13 00:00:00	1939-08-27	1939-08-27 00:00:00	1939-08-27	38000177		0	0	14		0	0	0	69139	0	313782	1127433		
8309	693	1124300	1995-08-14	1995-08-14 00:00:00	1995-08-14	1995-08-14 00:00:00	\N	38000177		0	0	0		0	0	0	45931	0	00781178901	45011828		
23098	1905	46233988	1972-01-30	1972-01-30 00:00:00	1972-02-13	1972-02-13 00:00:00	1972-02-13	38000177		0	0	14		0	0	0	126791	0	1652673	46233988		
3586	78	40213160	1967-09-14	1967-09-14 00:00:00	1967-09-14	1967-09-14 00:00:00	1967-09-14	581452		0	0	0		0	0	0	5207	0	10	40213160		
35630	2936	19133873	1967-03-09	1967-03-09 00:00:00	1967-03-17	1967-03-17 00:00:00	1967-03-17	38000177		0	0	8		0	0	0	195764	0	834061	19133873		
20194	1658	1127433	1978-08-24	1978-08-24 00:00:00	1978-09-21	1978-09-21 00:00:00	1978-09-21	38000177		0	0	28		0	0	0	111377	0	313782	1127433		
16395	354	40213160	1960-12-15	1960-12-15 00:00:00	1960-12-15	1960-12-15 00:00:00	1960-12-15	581452		0	0	0		0	0	0	23563	0	10	40213160		
42109	3490	40169216	1947-09-21	1947-09-21 00:00:00	1947-09-21	1947-09-21 00:00:00	\N	38000177		0	0	0		0	0	0	231487	0	895994	40169216		
42144	3494	40236446	1970-08-03	1970-08-03 00:00:00	1977-08-11	1977-08-11 00:00:00	1977-08-11	38000177		0	0	2565		0	0	0	231741	0	1091392	40236446		
1424	114	1127433	2018-08-24	2018-08-24 00:00:00	2018-09-07	2018-09-07 00:00:00	2018-09-07	38000177		0	0	14		0	0	0	7519	0	313782	1127433		
14599	1223	1127433	1989-07-31	1989-07-31 00:00:00	1989-08-07	1989-08-07 00:00:00	1989-08-07	38000177		0	0	7		0	0	0	80476	0	313782	1127433		
1587	124	19008572	1989-03-23	1989-03-23 00:00:00	1989-04-14	1989-04-14 00:00:00	1989-04-14	38000177		0	0	22		0	0	0	8315	0	106258	19008572		
25130	2069	1127433	1963-06-22	1963-06-22 00:00:00	1963-07-06	1963-07-06 00:00:00	1963-07-06	38000177		0	0	14		0	0	0	137614	0	313782	1127433		
40245	3332	19128065	1975-11-28	1975-11-28 00:00:00	1976-11-22	1976-11-22 00:00:00	1976-11-22	38000177		0	0	360		0	0	0	221077	0	749882	19128065		
73329	1602	40213260	2014-04-23	2014-04-23 00:00:00	2014-04-23	2014-04-23 00:00:00	2014-04-23	581452		0	0	0		0	0	0	107555	0	121	40213260		
15113	1261	19059056	1973-09-27	1973-09-27 00:00:00	1973-10-11	1973-10-11 00:00:00	1973-10-11	38000177		0	0	14		0	0	0	83200	0	243670	19059056		
38633	3191	19078461	1995-04-15	1995-04-15 00:00:00	1995-05-20	1995-05-20 00:00:00	1995-05-20	38000177		0	0	35		0	0	0	212389	0	310965	19078461		
35841	2950	1713671	2010-05-19	2010-05-19 00:00:00	2010-05-26	2010-05-26 00:00:00	2010-05-26	38000177		0	0	7		0	0	0	196974	0	562251	1713671		
46318	3836	46233988	1977-08-01	1977-08-01 00:00:00	1977-08-15	1977-08-15 00:00:00	1977-08-15	38000177		0	0	14		0	0	0	254726	0	1652673	46233988		
25768	2119	1127433	1980-04-03	1980-04-03 00:00:00	1980-05-08	1980-05-08 00:00:00	1980-05-08	38000177		0	0	35		0	0	0	140973	0	313782	1127433		
55230	4586	1713671	1983-02-19	1983-02-19 00:00:00	1983-02-26	1983-02-26 00:00:00	1983-02-26	38000177		0	0	7		0	0	0	305456	0	562251	1713671		
33420	2768	19133905	2006-04-04	2006-04-04 00:00:00	2006-04-16	2006-04-16 00:00:00	2006-04-16	38000177		0	0	12		0	0	0	183142	0	834102	19133905		
43833	3629	19006318	1957-06-13	1957-06-13 00:00:00	1957-06-27	1957-06-27 00:00:00	1957-06-27	38000177		0	0	14		0	0	0	241463	0	105078	19006318		
36407	3001	1127433	1998-12-27	1998-12-27 00:00:00	1999-01-10	1999-01-10 00:00:00	1999-01-10	38000177		0	0	14		0	0	0	200273	0	313782	1127433		
57074	4736	1127433	1982-08-17	1982-08-17 00:00:00	1982-08-24	1982-08-24 00:00:00	1982-08-24	38000177		0	0	7		0	0	0	315477	0	313782	1127433		
28141	2327	19078461	1995-04-19	1995-04-19 00:00:00	1995-05-03	1995-05-03 00:00:00	1995-05-03	38000177		0	0	14		0	0	0	154728	0	310965	19078461		
26594	2189	1118084	2012-11-16	2012-11-16 00:00:00	2012-11-16	2012-11-16 00:00:00	\N	38000177		0	0	0		0	0	0	145984	0	00025152531	44923712		
21598	1776	19059056	1921-09-30	1921-09-30 00:00:00	1921-10-14	1921-10-14 00:00:00	1921-10-14	38000177		0	0	14		0	0	0	118799	0	243670	19059056		
21659	1780	1127433	1993-05-19	1993-05-19 00:00:00	1993-06-09	1993-06-09 00:00:00	1993-06-09	38000177		0	0	21		0	0	0	119145	0	313782	1127433		
21704	1782	19078924	1956-01-11	1956-01-11 00:00:00	1956-01-11	1956-01-11 00:00:00	1956-01-11	38000177		0	0	0		0	0	0	119339	0	311700	19078924		
36037	2966	19059056	1963-10-02	1963-10-02 00:00:00	1963-10-16	1963-10-16 00:00:00	1963-10-16	38000177		0	0	14		0	0	0	198044	0	243670	19059056		
5704	479	1127433	1989-05-11	1989-05-11 00:00:00	1989-05-25	1989-05-25 00:00:00	1989-05-25	38000177		0	0	14		0	0	0	31880	0	313782	1127433		
47751	3958	1115171	1996-10-07	1996-10-07 00:00:00	1996-10-28	1996-10-28 00:00:00	1996-10-28	38000177		0	0	21		0	0	0	263175	0	849574	1115171		
47780	3961	1127078	1984-03-29	1984-03-29 00:00:00	1984-04-12	1984-04-12 00:00:00	1984-04-12	38000177		0	0	14		0	0	0	263372	0	282464	1127078		
23529	1936	19059056	1950-05-06	1950-05-06 00:00:00	1950-05-20	1950-05-20 00:00:00	1950-05-20	38000177		0	0	14		0	0	0	128774	0	243670	19059056		
16379	1357	1127433	2015-04-22	2015-04-22 00:00:00	2015-05-06	2015-05-06 00:00:00	2015-05-06	38000177		0	0	14		0	0	0	90017	0	313782	1127433		
21096	1738	920300	2009-06-07	2009-06-07 00:00:00	2009-06-14	2009-06-14 00:00:00	2009-06-14	38000177		0	0	7		0	0	0	116137	0	311989	920300		
20221	440	40213227	2006-03-29	2006-03-29 00:00:00	2006-03-29	2006-03-29 00:00:00	2006-03-29	581452		0	0	0		0	0	0	29179	0	113	40213227		
3207	264	40229134	1958-05-23	1958-05-23 00:00:00	1958-05-30	1958-05-30 00:00:00	1958-05-30	38000177		0	0	7		0	0	0	17508	0	1043400	40229134		
4376	363	19059056	1968-08-15	1968-08-15 00:00:00	1968-08-29	1968-08-29 00:00:00	1968-08-29	38000177		0	0	14		0	0	0	24101	0	243670	19059056		
11558	962	19059056	1964-03-27	1964-03-27 00:00:00	1964-04-26	1964-04-26 00:00:00	1964-04-26	38000177		0	0	30		0	0	0	64026	0	243670	19059056		
87553	1921	40213160	1955-08-15	1955-08-15 00:00:00	1955-08-15	1955-08-15 00:00:00	1955-08-15	581452		0	0	0		0	0	0	127751	0	10	40213160		
6144	515	19126352	1996-11-23	1996-11-23 00:00:00	1996-11-23	1996-11-23 00:00:00	\N	38000177		0	0	0		0	0	0	34396	0	705129	19126352		
51125	4247	1124300	2018-03-30	2018-03-30 00:00:00	2018-03-30	2018-03-30 00:00:00	\N	38000177		0	0	0		0	0	0	282009	0	00781178901	45011828		
222	17	1118084	1989-11-21	1989-11-21 00:00:00	1989-11-21	1989-11-21 00:00:00	\N	38000177		0	0	0		0	0	0	1374	0	00025152531	44923712		
26	2	920334	1952-07-01	1952-07-01 00:00:00	1952-07-08	1952-07-08 00:00:00	1952-07-08	38000177		0	0	7		0	0	0	102	0	311995	920334		
49004	4067	19074679	1972-06-03	1972-06-03 00:00:00	1972-10-28	1972-10-28 00:00:00	1972-10-28	38000177		0	0	147		0	0	0	270226	0	308971	19074679		
7740	648	19059056	1933-06-14	1933-06-14 00:00:00	1933-06-28	1933-06-28 00:00:00	1933-06-28	38000177		0	0	14		0	0	0	42917	0	243670	19059056		
10648	885	19074843	1979-12-03	1979-12-03 00:00:00	1979-12-17	1979-12-17 00:00:00	1979-12-17	38000177		0	0	14		0	0	0	59019	0	309045	19074843		
36204	2985	19059056	1989-01-26	1989-01-26 00:00:00	1989-02-16	1989-02-16 00:00:00	1989-02-16	38000177		0	0	21		0	0	0	199188	0	243670	19059056		
43389	3598	1118084	1980-07-05	1980-07-05 00:00:00	1980-07-05	1980-07-05 00:00:00	\N	38000177		0	0	0		0	0	0	238966	0	00025152531	44923712		
36326	2993	1713671	1994-11-29	1994-11-29 00:00:00	1994-12-20	1994-12-20 00:00:00	1994-12-20	38000177		0	0	21		0	0	0	199800	0	562251	1713671		
28552	2352	40232448	1974-11-15	1974-11-15 00:00:00	1974-11-15	1974-11-15 00:00:00	\N	38000177		0	0	0		0	0	0	156645	0	1049630	40232448		
24243	1992	920300	2011-04-22	2011-04-22 00:00:00	2011-04-29	2011-04-29 00:00:00	2011-04-29	38000177		0	0	7		0	0	0	132661	0	311989	920300		
16598	1376	1115171	1999-12-16	1999-12-16 00:00:00	2000-01-13	2000-01-13 00:00:00	2000-01-13	38000177		0	0	28		0	0	0	91178	0	849574	1115171		
41781	3458	19078461	2013-05-05	2013-05-05 00:00:00	2013-05-26	2013-05-26 00:00:00	2013-05-26	38000177		0	0	21		0	0	0	229448	0	310965	19078461		
30232	2507	1115171	1996-11-16	1996-11-16 00:00:00	1997-01-15	1997-01-15 00:00:00	1997-01-15	38000177		0	0	60		0	0	0	165954	0	849574	1115171		
32200	2669	1127433	2010-03-19	2010-03-19 00:00:00	2010-03-26	2010-03-26 00:00:00	2010-03-26	38000177		0	0	7		0	0	0	176803	0	313782	1127433		
84643	1851	40213160	1978-03-16	1978-03-16 00:00:00	1978-03-16	1978-03-16 00:00:00	1978-03-16	581452		0	0	0		0	0	0	123861	0	10	40213160		
30710	2545	1127433	1977-06-29	1977-06-29 00:00:00	1977-08-03	1977-08-03 00:00:00	1977-08-03	38000177		0	0	35		0	0	0	168456	0	313782	1127433		
1888	152	1127433	1992-02-17	1992-02-17 00:00:00	1992-03-18	1992-03-18 00:00:00	1992-03-18	38000177		0	0	30		0	0	0	10292	0	313782	1127433		
61943	5151	19006318	1959-01-05	1959-01-05 00:00:00	1959-01-19	1959-01-19 00:00:00	1959-01-19	38000177		0	0	14		0	0	0	342581	0	105078	19006318		
53340	4433	1713671	1941-06-14	1941-06-14 00:00:00	1941-06-21	1941-06-21 00:00:00	1941-06-21	38000177		0	0	7		0	0	0	294700	0	562251	1713671		
24941	2051	920300	2018-01-15	2018-01-15 00:00:00	2018-01-22	2018-01-22 00:00:00	2018-01-22	38000177		0	0	7		0	0	0	136373	0	311989	920300		
12533	1054	1127433	1997-07-08	1997-07-08 00:00:00	1997-07-15	1997-07-15 00:00:00	1997-07-15	38000177		0	0	7		0	0	0	69124	0	313782	1127433		
8310	693	19059056	1966-09-13	1966-09-13 00:00:00	1966-09-27	1966-09-27 00:00:00	1966-09-27	38000177		0	0	14		0	0	0	45890	0	243670	19059056		
23099	1905	1127078	1972-01-30	1972-01-30 00:00:00	1972-02-13	1972-02-13 00:00:00	1972-02-13	38000177		0	0	14		0	0	0	126791	0	282464	1127078		
3596	79	40213227	2007-09-07	2007-09-07 00:00:00	2007-09-07	2007-09-07 00:00:00	2007-09-07	581452		0	0	0		0	0	0	5220	0	113	40213227		
14590	316	40213201	1993-11-02	1993-11-02 00:00:00	1993-11-02	1993-11-02 00:00:00	1993-11-02	581452		0	0	0		0	0	0	20938	0	33	40213201		
20195	1658	19059056	1928-01-07	1928-01-07 00:00:00	1928-01-21	1928-01-21 00:00:00	1928-01-21	38000177		0	0	14		0	0	0	111375	0	243670	19059056		
16397	354	40213296	1996-01-11	1996-01-11 00:00:00	1996-01-11	1996-01-11 00:00:00	1996-01-11	581452		0	0	0		0	0	0	23586	0	52	40213296		
42110	3490	1154615	1947-09-21	1947-09-21 00:00:00	1947-09-21	1947-09-21 00:00:00	\N	38000177		0	0	0		0	0	0	231487	0	745679	1154615		
42145	3495	1127433	1985-03-08	1985-03-08 00:00:00	1985-04-05	1985-04-05 00:00:00	1985-04-05	38000177		0	0	28		0	0	0	231814	0	313782	1127433		
1425	114	1118084	2017-04-16	2017-04-16 00:00:00	2017-04-16	2017-04-16 00:00:00	\N	38000177		0	0	0		0	0	0	7563	0	00025152531	44923712		
14600	1223	19133873	1955-06-03	1955-06-03 00:00:00	1955-06-16	1955-06-16 00:00:00	1955-06-16	38000177		0	0	13		0	0	0	80510	0	834061	19133873		
1588	124	1154615	1986-03-12	1986-03-12 00:00:00	1986-03-12	1986-03-12 00:00:00	\N	38000177		0	0	0		0	0	0	8294	0	745679	1154615		
25131	2069	1127433	1967-02-28	1967-02-28 00:00:00	1967-03-21	1967-03-21 00:00:00	1967-03-21	38000177		0	0	21		0	0	0	137585	0	313782	1127433		
40246	3332	1124300	1999-04-16	1999-04-16 00:00:00	1999-04-16	1999-04-16 00:00:00	\N	38000177		0	0	0		0	0	0	221127	0	00781178901	45011828		
73334	1602	40213227	2005-04-27	2005-04-27 00:00:00	2005-04-27	2005-04-27 00:00:00	2005-04-27	581452		0	0	0		0	0	0	107537	0	113	40213227		
15114	1261	46233988	1973-09-27	1973-09-27 00:00:00	1973-10-11	1973-10-11 00:00:00	1973-10-11	38000177		0	0	14		0	0	0	83200	0	1652673	46233988		
38634	3191	19006318	1960-04-13	1960-04-13 00:00:00	1960-04-27	1960-04-27 00:00:00	1960-04-27	38000177		0	0	14		0	0	0	212377	0	105078	19006318		
35842	2950	40222846	2013-02-24	2013-02-24 00:00:00	2013-02-24	2013-02-24 00:00:00	\N	38000177		0	0	0		0	0	0	196975	0	996740	40222846		
46319	3836	1118084	2018-12-14	2018-12-14 00:00:00	2018-12-14	2018-12-14 00:00:00	\N	38000177		0	0	0		0	0	0	254735	0	00025152531	44923712		
25769	2119	40165015	1980-04-03	1980-04-03 00:00:00	1980-04-03	1980-04-03 00:00:00	\N	38000177		0	0	0		0	0	0	140973	0	861467	40165015		
55231	4586	1127433	1989-04-08	1989-04-08 00:00:00	1989-04-29	1989-04-29 00:00:00	1989-04-29	38000177		0	0	21		0	0	0	305484	0	313782	1127433		
33421	2768	1127433	2010-09-08	2010-09-08 00:00:00	2010-09-29	2010-09-29 00:00:00	2010-09-29	38000177		0	0	21		0	0	0	183164	0	313782	1127433		
43834	3629	19078461	1992-03-02	1992-03-02 00:00:00	1992-03-23	1992-03-23 00:00:00	1992-03-23	38000177		0	0	21		0	0	0	241473	0	310965	19078461		
36408	3001	19059056	1956-11-27	1956-11-27 00:00:00	1956-12-18	1956-12-18 00:00:00	1956-12-18	38000177		0	0	21		0	0	0	200326	0	243670	19059056		
57075	4736	19078461	2002-08-23	2002-08-23 00:00:00	2002-10-29	2002-10-29 00:00:00	2002-10-29	38000177		0	0	67		0	0	0	315514	0	310965	19078461		
28142	2327	19059056	1958-10-11	1958-10-11 00:00:00	1959-01-09	1959-01-09 00:00:00	1959-01-09	38000177		0	0	90		0	0	0	154725	0	243670	19059056		
26595	2189	19133905	1998-04-02	1998-04-02 00:00:00	1998-04-11	1998-04-11 00:00:00	1998-04-11	38000177		0	0	9		0	0	0	145920	0	834102	19133905		
21599	1776	19059056	1940-11-24	1940-11-24 00:00:00	1940-12-15	1940-12-15 00:00:00	1940-12-15	38000177		0	0	21		0	0	0	118802	0	243670	19059056		
21660	1780	1127433	1982-04-01	1982-04-01 00:00:00	1982-04-15	1982-04-15 00:00:00	1982-04-15	38000177		0	0	14		0	0	0	119097	0	313782	1127433		
21705	1782	46275444	1956-01-11	1956-01-11 00:00:00	1956-01-11	1956-01-11 00:00:00	1956-01-11	38000177		0	0	0		0	0	0	119339	0	1659149	46275444		
36044	2969	1115171	2007-01-24	2007-01-24 00:00:00	2007-02-28	2007-02-28 00:00:00	2007-02-28	38000177		0	0	35		0	0	0	198213	0	849574	1115171		
5705	479	1713671	2003-12-19	2003-12-19 00:00:00	2003-12-26	2003-12-26 00:00:00	2003-12-26	38000177		0	0	7		0	0	0	31870	0	562251	1713671		
47752	3958	1713671	1983-02-07	1983-02-07 00:00:00	1983-02-21	1983-02-21 00:00:00	1983-02-21	38000177		0	0	14		0	0	0	263185	0	562251	1713671		
47781	3961	19073183	1983-02-10	1983-02-10 00:00:00	1983-02-24	1983-02-24 00:00:00	1983-02-24	38000177		0	0	14		0	0	0	263367	0	308182	19073183		
23530	1936	19006318	1950-05-06	1950-05-06 00:00:00	1950-05-20	1950-05-20 00:00:00	1950-05-20	38000177		0	0	14		0	0	0	128774	0	105078	19006318		
16380	1357	1127433	1976-10-18	1976-10-18 00:00:00	1976-10-25	1976-10-25 00:00:00	1976-10-25	38000177		0	0	7		0	0	0	89995	0	313782	1127433		
21097	1738	19128065	1986-04-25	1986-04-25 00:00:00	1987-04-20	1987-04-20 00:00:00	1987-04-20	38000177		0	0	360		0	0	0	116133	0	749882	19128065		
20223	440	40213227	1994-03-16	1994-03-16 00:00:00	1994-03-16	1994-03-16 00:00:00	1994-03-16	581452		0	0	0		0	0	0	29224	0	113	40213227		
3208	264	19059056	1969-10-18	1969-10-18 00:00:00	1969-11-24	1969-11-24 00:00:00	1969-11-24	38000177		0	0	37		0	0	0	17534	0	243670	19059056		
4377	363	1115171	2005-07-01	2005-07-01 00:00:00	2005-07-31	2005-07-31 00:00:00	2005-07-31	38000177		0	0	30		0	0	0	24072	0	849574	1115171		
11559	962	40165015	1964-03-27	1964-03-27 00:00:00	1964-03-27	1964-03-27 00:00:00	\N	38000177		0	0	0		0	0	0	64026	0	861467	40165015		
87561	1921	40213160	1955-02-14	1955-02-14 00:00:00	1955-02-14	1955-02-14 00:00:00	1955-02-14	581452		0	0	0		0	0	0	127726	0	10	40213160		
6145	515	1713671	1998-11-16	1998-11-16 00:00:00	1998-11-30	1998-11-30 00:00:00	1998-11-30	38000177		0	0	14		0	0	0	34328	0	562251	1713671		
51126	4247	1127078	1987-05-18	1987-05-18 00:00:00	1987-06-01	1987-06-01 00:00:00	1987-06-01	38000177		0	0	14		0	0	0	282078	0	282464	1127078		
223	17	1127433	1989-09-27	1989-09-27 00:00:00	1989-10-18	1989-10-18 00:00:00	1989-10-18	38000177		0	0	21		0	0	0	1374	0	313782	1127433		
27	2	1127433	1996-10-01	1996-10-01 00:00:00	1996-10-08	1996-10-08 00:00:00	1996-10-08	38000177		0	0	7		0	0	0	209	0	313782	1127433		
49005	4067	19133873	1972-05-24	1972-05-24 00:00:00	1972-06-03	1972-06-03 00:00:00	1972-06-03	38000177		0	0	10		0	0	0	270227	0	834061	19133873		
7741	648	1115171	2001-02-27	2001-02-27 00:00:00	2001-03-29	2001-03-29 00:00:00	2001-03-29	38000177		0	0	30		0	0	0	42966	0	849574	1115171		
10649	885	19129655	1976-07-06	1976-07-06 00:00:00	1976-07-20	1976-07-20 00:00:00	1976-07-20	38000177		0	0	14		0	0	0	58990	0	789980	19129655		
36205	2985	1127433	2006-05-01	2006-05-01 00:00:00	2006-05-08	2006-05-08 00:00:00	2006-05-08	38000177		0	0	7		0	0	0	199209	0	313782	1127433		
43390	3598	19059056	1945-01-20	1945-01-20 00:00:00	1945-03-21	1945-03-21 00:00:00	1945-03-21	38000177		0	0	60		0	0	0	238941	0	243670	19059056		
36327	2993	1118084	2012-09-15	2012-09-15 00:00:00	2012-09-15	2012-09-15 00:00:00	\N	38000177		0	0	0		0	0	0	199792	0	00025152531	44923712		
39011	3224	920334	2000-02-06	2000-02-06 00:00:00	2000-02-13	2000-02-13 00:00:00	2000-02-13	38000177		0	0	7		0	0	0	214380	0	311995	920334		
24244	1992	1118084	2019-01-26	2019-01-26 00:00:00	2019-01-26	2019-01-26 00:00:00	\N	38000177		0	0	0		0	0	0	132764	0	00025152531	44923712		
16599	1376	1127433	1986-11-25	1986-11-25 00:00:00	1986-12-09	1986-12-09 00:00:00	1986-12-09	38000177		0	0	14		0	0	0	91200	0	313782	1127433		
41782	3458	19133905	2006-08-10	2006-08-10 00:00:00	2006-08-17	2006-08-17 00:00:00	2006-08-17	38000177		0	0	7		0	0	0	229472	0	834102	19133905		
30233	2507	40162522	1996-11-16	1996-11-16 00:00:00	1996-11-16	1996-11-16 00:00:00	\N	38000177		0	0	0		0	0	0	165954	0	857005	40162522		
32201	2669	1127433	1980-05-22	1980-05-22 00:00:00	1980-05-29	1980-05-29 00:00:00	1980-05-29	38000177		0	0	7		0	0	0	176784	0	313782	1127433		
84646	1851	40213160	1982-11-18	1982-11-18 00:00:00	1982-11-18	1982-11-18 00:00:00	1982-11-18	581452		0	0	0		0	0	0	123821	0	10	40213160		
41169	3413	40165015	2007-04-22	2007-04-22 00:00:00	2007-04-22	2007-04-22 00:00:00	\N	38000177		0	0	0		0	0	0	226403	0	861467	40165015		
1889	152	40162522	1992-02-17	1992-02-17 00:00:00	1992-02-17	1992-02-17 00:00:00	\N	38000177		0	0	0		0	0	0	10292	0	857005	40162522		
61944	5151	19133873	1964-12-13	1964-12-13 00:00:00	1964-12-21	1964-12-21 00:00:00	1964-12-21	38000177		0	0	8		0	0	0	342508	0	834061	19133873		
53341	4433	1127433	1993-07-04	1993-07-04 00:00:00	1993-07-11	1993-07-11 00:00:00	1993-07-11	38000177		0	0	7		0	0	0	294645	0	313782	1127433		
32175	701	40213227	2019-03-02	2019-03-02 00:00:00	2019-03-02	2019-03-02 00:00:00	2019-03-02	581452		0	0	0		0	0	0	46292	0	113	40213227		
12534	1054	19059056	1985-11-27	1985-11-27 00:00:00	1985-12-18	1985-12-18 00:00:00	1985-12-18	38000177		0	0	21		0	0	0	69134	0	243670	19059056		
8311	693	1127078	1955-01-11	1955-01-11 00:00:00	1955-02-15	1955-02-15 00:00:00	1955-02-15	38000177		0	0	35		0	0	0	45887	0	282464	1127078		
23100	1905	19133905	2010-04-04	2010-04-04 00:00:00	2010-04-16	2010-04-16 00:00:00	2010-04-16	38000177		0	0	12		0	0	0	126818	0	834102	19133905		
3609	79	40213227	2017-11-03	2017-11-03 00:00:00	2017-11-03	2017-11-03 00:00:00	2017-11-03	581452		0	0	0		0	0	0	5262	0	113	40213227		
11645	970	1713671	1966-03-18	1966-03-18 00:00:00	1966-04-01	1966-04-01 00:00:00	1966-04-01	38000177		0	0	14		0	0	0	64480	0	562251	1713671		
20196	1658	40229134	2008-03-13	2008-03-13 00:00:00	2008-03-27	2008-03-27 00:00:00	2008-03-27	38000177		0	0	14		0	0	0	111329	0	1043400	40229134		
16401	354	40213160	1956-06-14	1956-06-14 00:00:00	1956-06-14	1956-06-14 00:00:00	1956-06-14	581452		0	0	0		0	0	0	23529	0	10	40213160		
42111	3490	40173590	2005-11-11	2005-11-11 00:00:00	2005-11-11	2005-11-11 00:00:00	\N	38000177		0	0	0		0	0	0	231570	0	904419	40173590		
42146	3495	19059056	1968-01-19	1968-01-19 00:00:00	1968-02-02	1968-02-02 00:00:00	1968-02-02	38000177		0	0	14		0	0	0	231847	0	243670	19059056		
1426	114	19133873	1974-12-31	1974-12-31 00:00:00	1975-01-08	1975-01-08 00:00:00	1975-01-08	38000177		0	0	8		0	0	0	7529	0	834061	19133873		
14601	1223	19133905	1975-12-07	1975-12-07 00:00:00	1975-12-14	1975-12-14 00:00:00	1975-12-14	38000177		0	0	7		0	0	0	80452	0	834102	19133905		
1589	124	40169216	1986-03-12	1986-03-12 00:00:00	1986-03-12	1986-03-12 00:00:00	\N	38000177		0	0	0		0	0	0	8294	0	895994	40169216		
25132	2069	1713671	1955-03-24	1955-03-24 00:00:00	1955-04-07	1955-04-07 00:00:00	1955-04-07	38000177		0	0	14		0	0	0	137612	0	562251	1713671		
40247	3332	1115171	2014-06-08	2014-06-08 00:00:00	2014-08-14	2014-08-14 00:00:00	2014-08-14	38000177		0	0	67		0	0	0	221133	0	849574	1115171		
73335	1602	40213296	2005-04-27	2005-04-27 00:00:00	2005-04-27	2005-04-27 00:00:00	2005-04-27	581452		0	0	0		0	0	0	107537	0	52	40213296		
15115	1261	1127078	1973-01-14	1973-01-14 00:00:00	1973-02-04	1973-02-04 00:00:00	1973-02-04	38000177		0	0	21		0	0	0	83216	0	282464	1127078		
38635	3191	19059056	1960-04-13	1960-04-13 00:00:00	1960-04-27	1960-04-27 00:00:00	1960-04-27	38000177		0	0	14		0	0	0	212377	0	243670	19059056		
15177	1267	1124300	1990-05-14	1990-05-14 00:00:00	1990-05-14	1990-05-14 00:00:00	\N	38000177		0	0	0		0	0	0	83601	0	00781178901	45011828		
46320	3836	1127078	1984-10-23	1984-10-23 00:00:00	1984-11-13	1984-11-13 00:00:00	1984-11-13	38000177		0	0	21		0	0	0	254748	0	282464	1127078		
25770	2119	19008572	1983-06-18	1983-06-18 00:00:00	1983-06-18	1983-06-18 00:00:00	\N	38000177		0	0	0		0	0	0	140964	0	106258	19008572		
55232	4587	19075601	2018-02-17	2018-02-17 00:00:00	2018-02-17	2018-02-17 00:00:00	\N	38000177		0	0	0		0	0	0	305545	0	309362	19075601		
33422	2768	1713671	1975-08-06	1975-08-06 00:00:00	1975-08-13	1975-08-13 00:00:00	1975-08-13	38000177		0	0	7		0	0	0	183134	0	562251	1713671		
43835	3629	1127433	2014-03-24	2014-03-24 00:00:00	2014-03-31	2014-03-31 00:00:00	2014-03-31	38000177		0	0	7		0	0	0	241459	0	313782	1127433		
36409	3001	1713671	2001-09-25	2001-09-25 00:00:00	2001-10-02	2001-10-02 00:00:00	2001-10-02	38000177		0	0	7		0	0	0	200274	0	562251	1713671		
2163	173	19059056	1977-11-02	1977-11-02 00:00:00	1978-01-01	1978-01-01 00:00:00	1978-01-01	38000177		0	0	60		0	0	0	11763	0	243670	19059056		
28143	2327	1124300	1999-11-25	1999-11-25 00:00:00	1999-11-25	1999-11-25 00:00:00	\N	38000177		0	0	0		0	0	0	154770	0	00781178901	45011828		
26597	2190	19133873	1953-10-23	1953-10-23 00:00:00	1953-11-01	1953-11-01 00:00:00	1953-11-01	38000177		0	0	9		0	0	0	146026	0	834061	19133873		
21600	1776	40171902	2003-10-11	2003-10-11 00:00:00	2003-10-11	2003-10-11 00:00:00	\N	38000177		0	0	0		0	0	0	118838	0	897718	40171902		
21661	1780	1713671	1997-02-01	1997-02-01 00:00:00	1997-02-22	1997-02-22 00:00:00	1997-02-22	38000177		0	0	21		0	0	0	119155	0	562251	1713671		
21706	1782	35605858	1956-01-11	1956-01-11 00:00:00	1956-01-11	1956-01-11 00:00:00	1956-01-11	38000177		0	0	0		0	0	0	119339	0	1732136	35605858		
36045	2969	19078461	1986-03-03	1986-03-03 00:00:00	1986-03-24	1986-03-24 00:00:00	1986-03-24	38000177		0	0	21		0	0	0	198246	0	310965	19078461		
5706	479	19078461	2011-11-15	2011-11-15 00:00:00	2011-11-29	2011-11-29 00:00:00	2011-11-29	38000177		0	0	14		0	0	0	31962	0	310965	19078461		
47753	3958	1127433	1974-02-03	1974-02-03 00:00:00	1974-02-10	1974-02-10 00:00:00	1974-02-10	38000177		0	0	7		0	0	0	263179	0	313782	1127433		
47782	3961	1127078	1983-02-10	1983-02-10 00:00:00	1983-02-24	1983-02-24 00:00:00	1983-02-24	38000177		0	0	14		0	0	0	263367	0	282464	1127078		
23531	1936	19133873	1949-07-12	1949-07-12 00:00:00	1949-07-24	1949-07-24 00:00:00	1949-07-24	38000177		0	0	12		0	0	0	128810	0	834061	19133873		
16381	1357	1127078	1976-01-21	1976-01-21 00:00:00	1976-02-25	1976-02-25 00:00:00	1976-02-25	38000177		0	0	35		0	0	0	90032	0	282464	1127078		
21098	1738	19133873	1976-07-13	1976-07-13 00:00:00	1976-07-21	1976-07-21 00:00:00	1976-07-21	38000177		0	0	8		0	0	0	116104	0	834061	19133873		
20224	440	40213306	1994-03-16	1994-03-16 00:00:00	1994-03-16	1994-03-16 00:00:00	1994-03-16	581452		0	0	0		0	0	0	29224	0	43	40213306		
3209	264	19078461	2007-06-16	2007-06-16 00:00:00	2007-07-07	2007-07-07 00:00:00	2007-07-07	38000177		0	0	21		0	0	0	17588	0	310965	19078461		
4378	363	40162522	2005-07-01	2005-07-01 00:00:00	2005-07-01	2005-07-01 00:00:00	\N	38000177		0	0	0		0	0	0	24072	0	857005	40162522		
11560	962	1127433	1989-09-15	1989-09-15 00:00:00	1989-09-29	1989-09-29 00:00:00	1989-09-29	38000177		0	0	14		0	0	0	64084	0	313782	1127433		
87571	1921	40213227	2012-12-24	2012-12-24 00:00:00	2012-12-24	2012-12-24 00:00:00	2012-12-24	581452		0	0	0		0	0	0	127788	0	113	40213227		
6146	515	19075601	2015-01-31	2015-01-31 00:00:00	2015-01-31	2015-01-31 00:00:00	\N	38000177		0	0	0		0	0	0	34332	0	309362	19075601		
51127	4247	19073183	1987-05-18	1987-05-18 00:00:00	1987-06-01	1987-06-01 00:00:00	1987-06-01	38000177		0	0	14		0	0	0	282078	0	308182	19073183		
225	17	1713671	2015-10-25	2015-10-25 00:00:00	2015-11-15	2015-11-15 00:00:00	2015-11-15	38000177		0	0	21		0	0	0	1300	0	562251	1713671		
28	2	19059056	1924-01-12	1924-01-12 00:00:00	1924-04-11	1924-04-11 00:00:00	1924-04-11	38000177		0	0	90		0	0	0	111	0	243670	19059056		
49006	4067	1713671	2002-08-29	2002-08-29 00:00:00	2002-09-12	2002-09-12 00:00:00	2002-09-12	38000177		0	0	14		0	0	0	270204	0	562251	1713671		
7742	648	40220960	2018-01-19	2018-01-19 00:00:00	2018-01-19	2018-01-19 00:00:00	2018-01-19	38000177		0	0	0		0	0	0	42968	0	1804799	40220960		
10650	885	19059056	1976-07-06	1976-07-06 00:00:00	1976-07-20	1976-07-20 00:00:00	1976-07-20	38000177		0	0	14		0	0	0	58990	0	243670	19059056		
36206	2985	46233988	1968-07-19	1968-07-19 00:00:00	1968-08-02	1968-08-02 00:00:00	1968-08-02	38000177		0	0	14		0	0	0	199212	0	1652673	46233988		
43391	3598	19075601	1997-04-13	1997-04-13 00:00:00	2014-12-14	2014-12-14 00:00:00	2014-12-14	38000177		0	0	6454		0	0	0	238990	0	309362	19075601		
36329	2993	19078461	2017-01-19	2017-01-19 00:00:00	2017-02-09	2017-02-09 00:00:00	2017-02-09	38000177		0	0	21		0	0	0	199831	0	310965	19078461		
39013	3224	1127433	1981-02-18	1981-02-18 00:00:00	1981-02-25	1981-02-25 00:00:00	1981-02-25	38000177		0	0	7		0	0	0	214397	0	313782	1127433		
24245	1992	19128065	1993-02-26	1993-02-26 00:00:00	1994-02-21	1994-02-21 00:00:00	1994-02-21	38000177		0	0	360		0	0	0	132746	0	749882	19128065		
16600	1376	1127433	2004-09-06	2004-09-06 00:00:00	2004-09-13	2004-09-13 00:00:00	2004-09-13	38000177		0	0	7		0	0	0	91204	0	313782	1127433		
41783	3458	40229134	1991-06-12	1991-06-12 00:00:00	1991-06-26	1991-06-26 00:00:00	1991-06-26	38000177		0	0	14		0	0	0	229450	0	1043400	40229134		
30234	2507	19078461	2010-12-03	2010-12-03 00:00:00	2010-12-24	2010-12-24 00:00:00	2010-12-24	38000177		0	0	21		0	0	0	165955	0	310965	19078461		
32202	2669	1127433	1982-09-17	1982-09-17 00:00:00	1982-10-01	1982-10-01 00:00:00	1982-10-01	38000177		0	0	14		0	0	0	176786	0	313782	1127433		
155085	3413	40213260	2017-05-03	2017-05-03 00:00:00	2017-05-03	2017-05-03 00:00:00	2017-05-03	581452		0	0	0		0	0	0	226365	0	121	40213260		
41170	3413	40229134	2009-03-12	2009-03-12 00:00:00	2009-03-19	2009-03-19 00:00:00	2009-03-19	38000177		0	0	7		0	0	0	226400	0	1043400	40229134		
1890	152	40236824	2010-11-13	2010-11-13 00:00:00	2010-11-20	2010-11-20 00:00:00	2010-11-20	38000177		0	0	7		0	0	0	10253	0	1094107	40236824		
61945	5151	1713671	1986-02-01	1986-02-01 00:00:00	1986-02-08	1986-02-08 00:00:00	1986-02-08	38000177		0	0	7		0	0	0	342502	0	562251	1713671		
53342	4433	1118084	1982-06-25	1982-06-25 00:00:00	1982-06-25	1982-06-25 00:00:00	\N	38000177		0	0	0		0	0	0	294644	0	00025152531	44923712		
32176	701	40213160	1957-12-07	1957-12-07 00:00:00	1957-12-07	1957-12-07 00:00:00	1957-12-07	581452		0	0	0		0	0	0	46314	0	10	40213160		
12559	1057	1127433	2011-04-29	2011-04-29 00:00:00	2011-05-06	2011-05-06 00:00:00	2011-05-06	38000177		0	0	7		0	0	0	69310	0	313782	1127433		
8312	693	40229134	2018-01-11	2018-01-11 00:00:00	2018-01-25	2018-01-25 00:00:00	2018-01-25	38000177		0	0	14		0	0	0	45948	0	1043400	40229134		
23102	1905	19128065	1984-01-30	1984-01-30 00:00:00	1985-01-24	1985-01-24 00:00:00	1985-01-24	38000177		0	0	360		0	0	0	126842	0	749882	19128065		
5479	457	1713671	1971-03-22	1971-03-22 00:00:00	1971-04-05	1971-04-05 00:00:00	1971-04-05	38000177		0	0	14		0	0	0	30557	0	562251	1713671		
11646	970	1713671	2008-07-25	2008-07-25 00:00:00	2008-08-01	2008-08-01 00:00:00	2008-08-01	38000177		0	0	7		0	0	0	64527	0	562251	1713671		
20197	1658	1127433	1952-01-16	1952-01-16 00:00:00	1952-01-30	1952-01-30 00:00:00	1952-01-30	38000177		0	0	14		0	0	0	111323	0	313782	1127433		
16406	354	40213260	2006-01-05	2006-01-05 00:00:00	2006-01-05	2006-01-05 00:00:00	2006-01-05	581452		0	0	0		0	0	0	23588	0	121	40213260		
42112	3490	19059056	1954-11-24	1954-11-24 00:00:00	1954-12-29	1954-12-29 00:00:00	1954-12-29	38000177		0	0	35		0	0	0	231515	0	243670	19059056		
42147	3495	46233988	1968-01-19	1968-01-19 00:00:00	1968-02-02	1968-02-02 00:00:00	1968-02-02	38000177		0	0	14		0	0	0	231847	0	1652673	46233988		
1497	119	1713671	2018-03-12	2018-03-12 00:00:00	2018-04-09	2018-04-09 00:00:00	2018-04-09	38000177		0	0	28		0	0	0	7900	0	562251	1713671		
14602	1223	1115171	1995-01-15	1995-01-15 00:00:00	1995-02-05	1995-02-05 00:00:00	1995-02-05	38000177		0	0	21		0	0	0	80447	0	849574	1115171		
1590	124	1124300	2016-12-17	2016-12-17 00:00:00	2016-12-17	2016-12-17 00:00:00	\N	38000177		0	0	0		0	0	0	8230	0	00781178901	45011828		
25133	2069	1127433	1997-01-28	1997-01-28 00:00:00	1997-02-11	1997-02-11 00:00:00	1997-02-11	38000177		0	0	14		0	0	0	137579	0	313782	1127433		
40248	3332	1713671	1973-04-12	1973-04-12 00:00:00	1973-04-26	1973-04-26 00:00:00	1973-04-26	38000177		0	0	14		0	0	0	221051	0	562251	1713671		
73337	1602	40213306	1986-01-29	1986-01-29 00:00:00	1986-01-29	1986-01-29 00:00:00	1986-01-29	581452		0	0	0		0	0	0	107515	0	43	40213306		
15116	1261	1127433	2006-05-01	2006-05-01 00:00:00	2006-05-08	2006-05-08 00:00:00	2006-05-08	38000177		0	0	7		0	0	0	83188	0	313782	1127433		
38636	3191	19059056	1968-09-28	1968-09-28 00:00:00	1968-10-12	1968-10-12 00:00:00	1968-10-12	38000177		0	0	14		0	0	0	212386	0	243670	19059056		
15178	1267	1127433	1959-05-13	1959-05-13 00:00:00	1959-05-20	1959-05-20 00:00:00	1959-05-20	38000177		0	0	7		0	0	0	83595	0	313782	1127433		
46321	3836	1127433	2008-09-24	2008-09-24 00:00:00	2008-10-01	2008-10-01 00:00:00	2008-10-01	38000177		0	0	7		0	0	0	254725	0	313782	1127433		
25771	2119	1713671	1987-05-20	1987-05-20 00:00:00	1987-06-03	1987-06-03 00:00:00	1987-06-03	38000177		0	0	14		0	0	0	141002	0	562251	1713671		
55233	4587	19059056	1940-01-17	1940-01-17 00:00:00	1940-04-16	1940-04-16 00:00:00	1940-04-16	38000177		0	0	90		0	0	0	305566	0	243670	19059056		
33423	2768	1127433	1988-02-15	1988-02-15 00:00:00	1988-03-07	1988-03-07 00:00:00	1988-03-07	38000177		0	0	21		0	0	0	183163	0	313782	1127433		
43837	3630	19059056	1979-05-07	1979-05-07 00:00:00	1979-08-05	1979-08-05 00:00:00	1979-08-05	38000177		0	0	90		0	0	0	241555	0	243670	19059056		
36410	3001	19133873	1959-07-03	1959-07-03 00:00:00	1959-07-12	1959-07-12 00:00:00	1959-07-12	38000177		0	0	9		0	0	0	200269	0	834061	19133873		
2164	173	1127433	1985-07-03	1985-07-03 00:00:00	1985-07-17	1985-07-17 00:00:00	1985-07-17	38000177		0	0	14		0	0	0	11740	0	313782	1127433		
28144	2327	19133873	1960-06-06	1960-06-06 00:00:00	1960-06-13	1960-06-13 00:00:00	1960-06-13	38000177		0	0	7		0	0	0	154744	0	834061	19133873		
26598	2190	1127433	1982-02-10	1982-02-10 00:00:00	1982-03-10	1982-03-10 00:00:00	1982-03-10	38000177		0	0	28		0	0	0	146080	0	313782	1127433		
21601	1776	19018935	2003-10-11	2003-10-11 00:00:00	2003-10-11	2003-10-11 00:00:00	\N	38000177		0	0	0		0	0	0	118838	0	197604	19018935		
21662	1780	1713671	2003-01-19	2003-01-19 00:00:00	2003-02-02	2003-02-02 00:00:00	2003-02-02	38000177		0	0	14		0	0	0	119178	0	562251	1713671		
21707	1782	19016749	1956-01-11	1956-01-11 00:00:00	1956-01-11	1956-01-11 00:00:00	1956-01-11	38000177		0	0	0		0	0	0	119339	0	73032	19016749		
36046	2969	1127433	1977-09-18	1977-09-18 00:00:00	1977-10-16	1977-10-16 00:00:00	1977-10-16	38000177		0	0	28		0	0	0	198245	0	313782	1127433		
5707	479	19059056	1943-01-04	1943-01-04 00:00:00	1943-01-18	1943-01-18 00:00:00	1943-01-18	38000177		0	0	14		0	0	0	31872	0	243670	19059056		
47754	3958	1115171	2000-08-08	2000-08-08 00:00:00	2000-08-29	2000-08-29 00:00:00	2000-08-29	38000177		0	0	21		0	0	0	263176	0	849574	1115171		
47783	3961	40162522	1990-06-05	1990-06-05 00:00:00	1990-06-05	1990-06-05 00:00:00	\N	38000177		0	0	0		0	0	0	263352	0	857005	40162522		
23535	1936	1713671	2012-04-24	2012-04-24 00:00:00	2012-05-08	2012-05-08 00:00:00	2012-05-08	38000177		0	0	14		0	0	0	128805	0	562251	1713671		
16382	1357	1127433	1978-04-19	1978-04-19 00:00:00	1978-04-26	1978-04-26 00:00:00	1978-04-26	38000177		0	0	7		0	0	0	89996	0	313782	1127433		
21099	1739	19006318	1972-04-20	1972-04-20 00:00:00	1972-05-04	1972-05-04 00:00:00	1972-05-04	38000177		0	0	14		0	0	0	116173	0	105078	19006318		
20225	440	40213160	1973-08-22	1973-08-22 00:00:00	1973-08-22	1973-08-22 00:00:00	1973-08-22	581452		0	0	0		0	0	0	29215	0	10	40213160		
3210	264	1127433	1975-10-15	1975-10-15 00:00:00	1975-11-05	1975-11-05 00:00:00	1975-11-05	38000177		0	0	21		0	0	0	17536	0	313782	1127433		
4379	363	1115171	1996-01-24	1996-01-24 00:00:00	1996-02-28	1996-02-28 00:00:00	1996-02-28	38000177		0	0	35		0	0	0	24070	0	849574	1115171		
11567	964	19059056	1981-04-17	1981-04-17 00:00:00	1981-05-01	1981-05-01 00:00:00	1981-05-01	38000177		0	0	14		0	0	0	64187	0	243670	19059056		
11571	964	40229134	1981-04-02	1981-04-02 00:00:00	1981-04-16	1981-04-16 00:00:00	1981-04-16	38000177		0	0	14		0	0	0	64201	0	1043400	40229134		
6147	515	40174880	2009-03-05	2009-03-05 00:00:00	2009-03-05	2009-03-05 00:00:00	\N	38000177		0	0	0		0	0	0	34416	0	966222	40174880		
51128	4247	1127433	2002-04-30	2002-04-30 00:00:00	2002-05-07	2002-05-07 00:00:00	2002-05-07	38000177		0	0	7		0	0	0	282076	0	313782	1127433		
226	17	1127433	1966-10-19	1966-10-19 00:00:00	1966-10-26	1966-10-26 00:00:00	1966-10-26	38000177		0	0	7		0	0	0	1323	0	313782	1127433		
29	2	19059056	1920-07-01	1920-07-01 00:00:00	1920-07-15	1920-07-15 00:00:00	1920-07-15	38000177		0	0	14		0	0	0	161	0	243670	19059056		
49007	4067	19133873	1987-01-04	1987-01-04 00:00:00	1987-01-15	1987-01-15 00:00:00	1987-01-15	38000177		0	0	11		0	0	0	270203	0	834061	19133873		
7743	648	19075601	2018-01-19	2018-01-19 00:00:00	2018-01-19	2018-01-19 00:00:00	2018-01-19	38000177		0	0	0		0	0	0	42968	0	309362	19075601		
10651	885	40236446	1987-04-10	1987-04-10 00:00:00	1989-02-17	1989-02-17 00:00:00	1989-02-17	38000177		0	0	679		0	0	0	58972	0	1091392	40236446		
36207	2985	19059056	1968-07-19	1968-07-19 00:00:00	1968-08-02	1968-08-02 00:00:00	1968-08-02	38000177		0	0	14		0	0	0	199212	0	243670	19059056		
43392	3598	920334	1978-04-27	1978-04-27 00:00:00	1978-05-04	1978-05-04 00:00:00	1978-05-04	38000177		0	0	7		0	0	0	238930	0	311995	920334		
36330	2993	19073188	2007-12-17	2007-12-17 00:00:00	2008-01-07	2008-01-07 00:00:00	2008-01-07	38000177		0	0	21		0	0	0	199830	0	308192	19073188		
39014	3224	1118084	2001-12-20	2001-12-20 00:00:00	2001-12-20	2001-12-20 00:00:00	\N	38000177		0	0	0		0	0	0	214334	0	00025152531	44923712		
24246	1992	1115171	2016-09-18	2016-09-18 00:00:00	2016-10-23	2016-10-23 00:00:00	2016-10-23	38000177		0	0	35		0	0	0	132690	0	849574	1115171		
27059	2232	19128065	1984-03-30	1984-03-30 00:00:00	1985-03-25	1985-03-25 00:00:00	1985-03-25	38000177		0	0	360		0	0	0	148495	0	749882	19128065		
41784	3458	1127433	2004-01-04	2004-01-04 00:00:00	2004-01-11	2004-01-11 00:00:00	2004-01-11	38000177		0	0	7		0	0	0	229460	0	313782	1127433		
30235	2507	1713671	1982-01-21	1982-01-21 00:00:00	1982-02-11	1982-02-11 00:00:00	1982-02-11	38000177		0	0	21		0	0	0	165932	0	562251	1713671		
42663	3536	1118084	2000-01-17	2000-01-17 00:00:00	2000-01-17	2000-01-17 00:00:00	\N	38000177		0	0	0		0	0	0	234816	0	00025152531	44923712		
155087	3413	40213227	2017-05-03	2017-05-03 00:00:00	2017-05-03	2017-05-03 00:00:00	2017-05-03	581452		0	0	0		0	0	0	226365	0	113	40213227		
41171	3414	1127078	1974-11-18	1974-11-18 00:00:00	1974-12-09	1974-12-09 00:00:00	1974-12-09	38000177		0	0	21		0	0	0	226451	0	282464	1127078		
1891	152	920300	2010-11-13	2010-11-13 00:00:00	2010-11-20	2010-11-20 00:00:00	2010-11-20	38000177		0	0	7		0	0	0	10253	0	311989	920300		
61946	5151	1127433	2015-11-26	2015-11-26 00:00:00	2015-12-03	2015-12-03 00:00:00	2015-12-03	38000177		0	0	7		0	0	0	342513	0	313782	1127433		
53343	4433	1127433	1983-12-27	1983-12-27 00:00:00	1984-01-17	1984-01-17 00:00:00	1984-01-17	38000177		0	0	21		0	0	0	294728	0	313782	1127433		
32191	701	40213160	1958-05-10	1958-05-10 00:00:00	1958-05-10	1958-05-10 00:00:00	1958-05-10	581452		0	0	0		0	0	0	46315	0	10	40213160		
12560	1057	40229134	1963-02-11	1963-02-11 00:00:00	1963-02-25	1963-02-25 00:00:00	1963-02-25	38000177		0	0	14		0	0	0	69289	0	1043400	40229134		
8313	693	1713671	2018-05-29	2018-05-29 00:00:00	2018-06-05	2018-06-05 00:00:00	2018-06-05	38000177		0	0	7		0	0	0	45949	0	562251	1713671		
23103	1905	19133873	1980-01-09	1980-01-09 00:00:00	1980-01-17	1980-01-17 00:00:00	1980-01-17	38000177		0	0	8		0	0	0	126814	0	834061	19133873		
5480	457	1127433	1954-04-01	1954-04-01 00:00:00	1954-04-15	1954-04-15 00:00:00	1954-04-15	38000177		0	0	14		0	0	0	30528	0	313782	1127433		
11647	970	19059056	1953-04-04	1953-04-04 00:00:00	1953-07-03	1953-07-03 00:00:00	1953-07-03	38000177		0	0	90		0	0	0	64473	0	243670	19059056		
20198	1658	19059056	1918-02-23	1918-02-23 00:00:00	1918-03-30	1918-03-30 00:00:00	1918-03-30	38000177		0	0	35		0	0	0	111374	0	243670	19059056		
16408	354	40213160	1956-04-12	1956-04-12 00:00:00	1956-04-12	1956-04-12 00:00:00	1956-04-12	581452		0	0	0		0	0	0	23536	0	10	40213160		
42113	3490	1115171	2012-06-27	2012-06-27 00:00:00	2012-07-11	2012-07-11 00:00:00	2012-07-11	38000177		0	0	14		0	0	0	231523	0	849574	1115171		
42148	3495	920300	2017-07-08	2017-07-08 00:00:00	2017-07-15	2017-07-15 00:00:00	2017-07-15	38000177		0	0	7		0	0	0	231855	0	311989	920300		
1498	119	19128065	1976-11-25	1976-11-25 00:00:00	1977-11-20	1977-11-20 00:00:00	1977-11-20	38000177		0	0	360		0	0	0	7939	0	749882	19128065		
14603	1223	1713671	2012-09-18	2012-09-18 00:00:00	2012-10-09	2012-10-09 00:00:00	2012-10-09	38000177		0	0	21		0	0	0	80525	0	562251	1713671		
1591	124	19112599	1987-03-26	1987-03-26 00:00:00	1987-03-26	1987-03-26 00:00:00	\N	38000177		0	0	0		0	0	0	8314	0	477045	19112599		
25134	2069	1127433	1977-12-26	1977-12-26 00:00:00	1978-01-02	1978-01-02 00:00:00	1978-01-02	38000177		0	0	7		0	0	0	137616	0	313782	1127433		
40249	3332	40162522	2014-06-15	2014-06-15 00:00:00	2014-06-15	2014-06-15 00:00:00	\N	38000177		0	0	0		0	0	0	221134	0	857005	40162522		
73339	1602	40213296	2003-04-23	2003-04-23 00:00:00	2003-04-23	2003-04-23 00:00:00	2003-04-23	581452		0	0	0		0	0	0	107517	0	52	40213296		
15117	1261	40229134	1989-03-29	1989-03-29 00:00:00	1989-04-12	1989-04-12 00:00:00	1989-04-12	38000177		0	0	14		0	0	0	83252	0	1043400	40229134		
43571	3612	1127433	1991-12-02	1991-12-02 00:00:00	1992-03-01	1992-03-01 00:00:00	1992-03-01	38000177		0	0	90		0	0	0	240000	0	313782	1127433		
15179	1267	19059056	1955-02-06	1955-02-06 00:00:00	1955-03-08	1955-03-08 00:00:00	1955-03-08	38000177		0	0	30		0	0	0	83565	0	243670	19059056		
46322	3836	1127433	1997-11-09	1997-11-09 00:00:00	1997-11-23	1997-11-23 00:00:00	1997-11-23	38000177		0	0	14		0	0	0	254708	0	313782	1127433		
25772	2119	1127433	2018-12-13	2018-12-13 00:00:00	2019-01-03	2019-01-03 00:00:00	2019-01-03	38000177		0	0	21		0	0	0	140977	0	313782	1127433		
55234	4587	1713671	1991-01-16	1991-01-16 00:00:00	1991-02-06	1991-02-06 00:00:00	1991-02-06	38000177		0	0	21		0	0	0	305588	0	562251	1713671		
33424	2768	19128065	1984-06-01	1984-06-01 00:00:00	1985-05-27	1985-05-27 00:00:00	1985-05-27	38000177		0	0	360		0	0	0	183153	0	749882	19128065		
43838	3630	40231925	1979-05-07	1979-05-07 00:00:00	1979-05-07	1979-05-07 00:00:00	\N	38000177		0	0	0		0	0	0	241555	0	1049221	40231925		
36411	3001	1713671	2016-11-25	2016-11-25 00:00:00	2016-12-09	2016-12-09 00:00:00	2016-12-09	38000177		0	0	14		0	0	0	200317	0	562251	1713671		
36415	3001	1127433	2013-02-02	2013-02-02 00:00:00	2013-02-16	2013-02-16 00:00:00	2013-02-16	38000177		0	0	14		0	0	0	200275	0	313782	1127433		
28145	2327	19078461	1985-10-10	1985-10-10 00:00:00	1985-11-07	1985-11-07 00:00:00	1985-11-07	38000177		0	0	28		0	0	0	154727	0	310965	19078461		
26599	2190	1118084	1983-09-22	1983-09-22 00:00:00	1983-09-22	1983-09-22 00:00:00	\N	38000177		0	0	0		0	0	0	146080	0	00025152531	44923712		
21602	1776	40163554	2003-10-11	2003-10-11 00:00:00	2003-10-11	2003-10-11 00:00:00	\N	38000177		0	0	0		0	0	0	118838	0	855332	40163554		
21663	1780	1127433	1981-02-01	1981-02-01 00:00:00	1981-02-15	1981-02-15 00:00:00	1981-02-15	38000177		0	0	14		0	0	0	119171	0	313782	1127433		
21708	1782	40236824	1979-12-14	1979-12-14 00:00:00	1979-12-21	1979-12-21 00:00:00	1979-12-21	38000177		0	0	7		0	0	0	119308	0	1094107	40236824		
36047	2969	1118084	2009-05-25	2009-05-25 00:00:00	2009-05-25	2009-05-25 00:00:00	\N	38000177		0	0	0		0	0	0	198222	0	00025152531	44923712		
5708	479	40229134	2009-06-18	2009-06-18 00:00:00	2009-07-02	2009-07-02 00:00:00	2009-07-02	38000177		0	0	14		0	0	0	31937	0	1043400	40229134		
47756	3960	19059056	1966-10-01	1966-10-01 00:00:00	1966-10-29	1966-10-29 00:00:00	1966-10-29	38000177		0	0	28		0	0	0	263311	0	243670	19059056		
47784	3961	19075001	1990-06-05	1990-06-05 00:00:00	1990-07-10	1990-07-10 00:00:00	1990-07-10	38000177		0	0	35		0	0	0	263352	0	309097	19075001		
23536	1936	1127078	1951-09-26	1951-09-26 00:00:00	1951-10-24	1951-10-24 00:00:00	1951-10-24	38000177		0	0	28		0	0	0	128762	0	282464	1127078		
16383	1358	19133873	1968-09-15	1968-09-15 00:00:00	1968-09-24	1968-09-24 00:00:00	1968-09-24	38000177		0	0	9		0	0	0	90069	0	834061	19133873		
21100	1739	19059056	1972-04-20	1972-04-20 00:00:00	1972-05-04	1972-05-04 00:00:00	1972-05-04	38000177		0	0	14		0	0	0	116173	0	243670	19059056		
31511	686	40213201	2012-08-25	2012-08-25 00:00:00	2012-08-25	2012-08-25 00:00:00	2012-08-25	581452		0	0	0		0	0	0	45376	0	33	40213201		
3211	264	1713671	1965-06-01	1965-06-01 00:00:00	1965-06-08	1965-06-08 00:00:00	1965-06-08	38000177		0	0	7		0	0	0	17511	0	562251	1713671		
4380	363	19059056	1965-08-01	1965-08-01 00:00:00	1965-09-05	1965-09-05 00:00:00	1965-09-05	38000177		0	0	35		0	0	0	24068	0	243670	19059056		
11568	964	19074843	1981-04-17	1981-04-17 00:00:00	1981-05-01	1981-05-01 00:00:00	1981-05-01	38000177		0	0	14		0	0	0	64187	0	309045	19074843		
11572	964	40229134	1985-12-04	1985-12-04 00:00:00	1985-12-18	1985-12-18 00:00:00	1985-12-18	38000177		0	0	14		0	0	0	64166	0	1043400	40229134		
6148	515	1713671	1958-06-26	1958-06-26 00:00:00	1958-09-11	1958-09-11 00:00:00	1958-09-11	38000177		0	0	77		0	0	0	34349	0	562251	1713671		
61608	5127	1127433	1994-10-26	1994-10-26 00:00:00	1994-11-09	1994-11-09 00:00:00	1994-11-09	38000177		0	0	14		0	0	0	340855	0	313782	1127433		
227	17	19115351	1962-12-08	1962-12-08 00:00:00	1963-03-23	1963-03-23 00:00:00	1963-03-23	38000177		0	0	105		0	0	0	1378	0	563026	19115351		
30	2	1127433	1994-06-05	1994-06-05 00:00:00	1994-06-19	1994-06-19 00:00:00	1994-06-19	38000177		0	0	14		0	0	0	106	0	313782	1127433		
49008	4067	19115351	1971-03-27	1971-03-27 00:00:00	1971-10-02	1971-10-02 00:00:00	1971-10-02	38000177		0	0	189		0	0	0	270199	0	563026	19115351		
7744	648	40229134	1966-07-29	1966-07-29 00:00:00	1966-08-12	1966-08-12 00:00:00	1966-08-12	38000177		0	0	14		0	0	0	42950	0	1043400	40229134		
10652	885	1713671	1988-12-18	1988-12-18 00:00:00	1989-01-01	1989-01-01 00:00:00	1989-01-01	38000177		0	0	14		0	0	0	58984	0	562251	1713671		
36208	2985	1127433	1981-04-16	1981-04-16 00:00:00	1981-04-30	1981-04-30 00:00:00	1981-04-30	38000177		0	0	14		0	0	0	199207	0	313782	1127433		
43393	3598	1127433	1950-05-25	1950-05-25 00:00:00	1950-06-01	1950-06-01 00:00:00	1950-06-01	38000177		0	0	7		0	0	0	238922	0	313782	1127433		
36331	2993	1127433	2007-12-17	2007-12-17 00:00:00	2008-01-07	2008-01-07 00:00:00	2008-01-07	38000177		0	0	21		0	0	0	199830	0	313782	1127433		
39015	3224	19133873	1960-03-19	1960-03-19 00:00:00	1960-04-01	1960-04-01 00:00:00	1960-04-01	38000177		0	0	13		0	0	0	214395	0	834061	19133873		
24247	1992	1127433	2015-10-24	2015-10-24 00:00:00	2015-11-23	2015-11-23 00:00:00	2015-11-23	38000177		0	0	30		0	0	0	132689	0	313782	1127433		
27060	2232	19133905	2019-06-18	2019-06-18 00:00:00	2019-06-25	2019-06-25 00:00:00	2019-06-25	38000177		0	0	7		0	0	0	148514	0	834102	19133905		
41785	3458	1127433	1985-05-22	1985-05-22 00:00:00	1985-06-05	1985-06-05 00:00:00	1985-06-05	38000177		0	0	14		0	0	0	229468	0	313782	1127433		
30236	2507	1127433	2009-03-11	2009-03-11 00:00:00	2009-03-25	2009-03-25 00:00:00	2009-03-25	38000177		0	0	14		0	0	0	165966	0	313782	1127433		
42664	3536	920300	2016-05-03	2016-05-03 00:00:00	2016-05-10	2016-05-10 00:00:00	2016-05-10	38000177		0	0	7		0	0	0	234892	0	311989	920300		
155094	3413	40213260	2016-04-27	2016-04-27 00:00:00	2016-04-27	2016-04-27 00:00:00	2016-04-27	581452		0	0	0		0	0	0	226409	0	121	40213260		
41172	3414	1127433	1981-05-01	1981-05-01 00:00:00	1981-05-08	1981-05-08 00:00:00	1981-05-08	38000177		0	0	7		0	0	0	226468	0	313782	1127433		
1892	152	1127078	1969-03-19	1969-03-19 00:00:00	1969-04-02	1969-04-02 00:00:00	1969-04-02	38000177		0	0	14		0	0	0	10232	0	282464	1127078		
61947	5151	19133873	1961-11-18	1961-11-18 00:00:00	1961-11-28	1961-11-28 00:00:00	1961-11-28	38000177		0	0	10		0	0	0	342576	0	834061	19133873		
53344	4433	1115171	2014-12-26	2014-12-26 00:00:00	2015-01-16	2015-01-16 00:00:00	2015-01-16	38000177		0	0	21		0	0	0	294730	0	849574	1115171		
32215	703	40213198	2015-01-09	2015-01-09 00:00:00	2015-01-09	2015-01-09 00:00:00	2015-01-09	581452		0	0	0		0	0	0	46470	0	133	40213198		
12561	1057	1127433	1985-09-01	1985-09-01 00:00:00	1985-09-15	1985-09-15 00:00:00	1985-09-15	38000177		0	0	14		0	0	0	69275	0	313782	1127433		
8314	693	1127433	1984-05-25	1984-05-25 00:00:00	1984-06-24	1984-06-24 00:00:00	1984-06-24	38000177		0	0	30		0	0	0	45892	0	313782	1127433		
23104	1905	19126352	1983-08-05	1983-08-05 00:00:00	1983-08-05	1983-08-05 00:00:00	\N	38000177		0	0	0		0	0	0	126851	0	705129	19126352		
5481	457	1127433	2007-03-10	2007-03-10 00:00:00	2007-03-17	2007-03-17 00:00:00	2007-03-17	38000177		0	0	7		0	0	0	30604	0	313782	1127433		
11648	970	1127433	1967-11-28	1967-11-28 00:00:00	1967-12-12	1967-12-12 00:00:00	1967-12-12	38000177		0	0	14		0	0	0	64519	0	313782	1127433		
20199	1658	1127433	2000-06-14	2000-06-14 00:00:00	2000-06-21	2000-06-21 00:00:00	2000-06-21	38000177		0	0	7		0	0	0	111417	0	313782	1127433		
16418	354	40213227	2017-03-09	2017-03-09 00:00:00	2017-03-09	2017-03-09 00:00:00	2017-03-09	581452		0	0	0		0	0	0	23594	0	113	40213227		
42114	3490	19059056	1951-02-13	1951-02-13 00:00:00	1951-04-14	1951-04-14 00:00:00	1951-04-14	38000177		0	0	60		0	0	0	231513	0	243670	19059056		
42149	3495	40236824	2017-07-08	2017-07-08 00:00:00	2017-07-15	2017-07-15 00:00:00	2017-07-15	38000177		0	0	7		0	0	0	231855	0	1094107	40236824		
1499	119	40236824	2009-01-24	2009-01-24 00:00:00	2009-02-07	2009-02-07 00:00:00	2009-02-07	38000177		0	0	14		0	0	0	7927	0	1094107	40236824		
14604	1223	1127433	2010-11-24	2010-11-24 00:00:00	2010-12-08	2010-12-08 00:00:00	2010-12-08	38000177		0	0	14		0	0	0	80456	0	313782	1127433		
1592	124	1127078	1989-09-12	1989-09-12 00:00:00	1989-09-26	1989-09-26 00:00:00	1989-09-26	38000177		0	0	14		0	0	0	8259	0	282464	1127078		
25135	2069	19133873	1959-02-24	1959-02-24 00:00:00	1959-03-09	1959-03-09 00:00:00	1959-03-09	38000177		0	0	13		0	0	0	137613	0	834061	19133873		
40250	3332	920334	1980-03-03	1980-03-03 00:00:00	1980-03-10	1980-03-10 00:00:00	1980-03-10	38000177		0	0	7		0	0	0	221071	0	311995	920334		
73342	1602	40213260	2013-04-17	2013-04-17 00:00:00	2013-04-17	2013-04-17 00:00:00	2013-04-17	581452		0	0	0		0	0	0	107567	0	121	40213260		
15119	1264	19133905	1997-06-20	1997-06-20 00:00:00	1997-06-29	1997-06-29 00:00:00	1997-06-29	38000177		0	0	9		0	0	0	83316	0	834102	19133905		
43572	3612	1713671	2018-01-08	2018-01-08 00:00:00	2018-01-29	2018-01-29 00:00:00	2018-01-29	38000177		0	0	21		0	0	0	239988	0	562251	1713671		
15180	1267	1115171	2009-05-14	2009-05-14 00:00:00	2009-05-28	2009-05-28 00:00:00	2009-05-28	38000177		0	0	14		0	0	0	83535	0	849574	1115171		
46323	3836	1115171	2015-02-04	2015-02-04 00:00:00	2015-02-18	2015-02-18 00:00:00	2015-02-18	38000177		0	0	14		0	0	0	254750	0	849574	1115171		
3580	78	40213260	2017-12-07	2017-12-07 00:00:00	2017-12-07	2017-12-07 00:00:00	2017-12-07	581452		0	0	0		0	0	0	5161	0	121	40213260		
55235	4587	19077572	2015-01-31	2015-01-31 00:00:00	2015-01-31	2015-01-31 00:00:00	\N	38000177		0	0	0		0	0	0	305564	0	310436	19077572		
33425	2768	19128065	1985-05-27	1985-05-27 00:00:00	1986-05-22	1986-05-22 00:00:00	1986-05-22	38000177		0	0	360		0	0	0	183154	0	749882	19128065		
43839	3630	1124300	1992-05-23	1992-05-23 00:00:00	1992-05-23	1992-05-23 00:00:00	\N	38000177		0	0	0		0	0	0	241525	0	00781178901	45011828		
36412	3001	19133905	1995-01-04	1995-01-04 00:00:00	1995-01-15	1995-01-15 00:00:00	1995-01-15	38000177		0	0	11		0	0	0	200271	0	834102	19133905		
36416	3001	1127433	1986-09-06	1986-09-06 00:00:00	1986-09-27	1986-09-27 00:00:00	1986-09-27	38000177		0	0	21		0	0	0	200330	0	313782	1127433		
28146	2327	1127433	2001-05-15	2001-05-15 00:00:00	2001-06-05	2001-06-05 00:00:00	2001-06-05	38000177		0	0	21		0	0	0	154730	0	313782	1127433		
26601	2190	19059056	1955-12-08	1955-12-08 00:00:00	1955-12-22	1955-12-22 00:00:00	1955-12-22	38000177		0	0	14		0	0	0	146008	0	243670	19059056		
21603	1776	1367571	1984-10-13	1984-10-13 00:00:00	1984-10-13	1984-10-13 00:00:00	1984-10-13	38000177		0	0	0		0	0	0	118804	0	314659	19080464		
21664	1780	1127433	1983-02-06	1983-02-06 00:00:00	1983-02-13	1983-02-13 00:00:00	1983-02-13	38000177		0	0	7		0	0	0	119152	0	313782	1127433		
21709	1782	920300	1979-12-14	1979-12-14 00:00:00	1979-12-21	1979-12-21 00:00:00	1979-12-21	38000177		0	0	7		0	0	0	119308	0	311989	920300		
36048	2969	1127433	2002-02-28	2002-02-28 00:00:00	2002-03-21	2002-03-21 00:00:00	2002-03-21	38000177		0	0	21		0	0	0	198247	0	313782	1127433		
5709	479	1118084	1979-12-01	1979-12-01 00:00:00	1979-12-01	1979-12-01 00:00:00	\N	38000177		0	0	0		0	0	0	31868	0	00025152531	44923712		
47757	3960	1127433	1961-07-31	1961-07-31 00:00:00	1961-08-14	1961-08-14 00:00:00	1961-08-14	38000177		0	0	14		0	0	0	263249	0	313782	1127433		
47785	3961	1127433	1990-06-05	1990-06-05 00:00:00	1990-07-10	1990-07-10 00:00:00	1990-07-10	38000177		0	0	35		0	0	0	263352	0	313782	1127433		
23537	1937	1713671	1990-07-29	1990-07-29 00:00:00	1990-08-05	1990-08-05 00:00:00	1990-08-05	38000177		0	0	7		0	0	0	128875	0	562251	1713671		
16384	1358	1127433	1965-03-06	1965-03-06 00:00:00	1965-03-20	1965-03-20 00:00:00	1965-03-20	38000177		0	0	14		0	0	0	90044	0	313782	1127433		
21101	1739	1127078	1976-05-20	1976-05-20 00:00:00	1976-06-03	1976-06-03 00:00:00	1976-06-03	38000177		0	0	14		0	0	0	116170	0	282464	1127078		
31519	687	40213260	2017-01-21	2017-01-21 00:00:00	2017-01-21	2017-01-21 00:00:00	2017-01-21	581452		0	0	0		0	0	0	45468	0	121	40213260		
3212	264	19059056	1955-11-26	1955-11-26 00:00:00	1955-12-10	1955-12-10 00:00:00	1955-12-10	38000177		0	0	14		0	0	0	17568	0	243670	19059056		
4381	364	1127433	1988-05-05	1988-05-05 00:00:00	1988-05-12	1988-05-12 00:00:00	1988-05-12	38000177		0	0	7		0	0	0	24201	0	313782	1127433		
11569	964	19128022	1992-10-09	1992-10-09 00:00:00	1993-10-04	1993-10-04 00:00:00	1993-10-04	38000177		0	0	360		0	0	0	64176	0	749785	19128022		
11573	964	1713671	2009-12-30	2009-12-30 00:00:00	2010-01-06	2010-01-06 00:00:00	2010-01-06	38000177		0	0	7		0	0	0	64193	0	562251	1713671		
6149	515	19059056	1942-08-14	1942-08-14 00:00:00	1942-08-28	1942-08-28 00:00:00	1942-08-28	38000177		0	0	14		0	0	0	34335	0	243670	19059056		
31501	686	40213198	2011-08-20	2011-08-20 00:00:00	2011-08-20	2011-08-20 00:00:00	2011-08-20	581452		0	0	0		0	0	0	45371	0	133	40213198		
228	17	1127433	1994-11-21	1994-11-21 00:00:00	1994-12-19	1994-12-19 00:00:00	1994-12-19	38000177		0	0	28		0	0	0	1375	0	313782	1127433		
31	2	19059056	1934-01-19	1934-01-19 00:00:00	1934-03-20	1934-03-20 00:00:00	1934-03-20	38000177		0	0	60		0	0	0	112	0	243670	19059056		
49009	4067	1127078	1983-01-14	1983-01-14 00:00:00	1983-04-14	1983-04-14 00:00:00	1983-04-14	38000177		0	0	90		0	0	0	270197	0	282464	1127078		
7745	648	1127433	1984-05-21	1984-05-21 00:00:00	1984-05-28	1984-05-28 00:00:00	1984-05-28	38000177		0	0	7		0	0	0	42889	0	313782	1127433		
10653	885	19078461	2002-07-11	2002-07-11 00:00:00	2002-07-25	2002-07-25 00:00:00	2002-07-25	38000177		0	0	14		0	0	0	58982	0	310965	19078461		
36209	2985	19129655	1966-06-19	1966-06-19 00:00:00	1966-07-03	1966-07-03 00:00:00	1966-07-03	38000177		0	0	14		0	0	0	199211	0	789980	19129655		
43394	3598	1713671	1964-01-07	1964-01-07 00:00:00	1964-01-28	1964-01-28 00:00:00	1964-01-28	38000177		0	0	21		0	0	0	238949	0	562251	1713671		
36332	2993	40162522	2007-12-17	2007-12-17 00:00:00	2007-12-17	2007-12-17 00:00:00	\N	38000177		0	0	0		0	0	0	199830	0	857005	40162522		
39016	3224	1713671	1975-07-27	1975-07-27 00:00:00	1975-08-10	1975-08-10 00:00:00	1975-08-10	38000177		0	0	14		0	0	0	214370	0	562251	1713671		
24248	1992	40231925	2015-10-24	2015-10-24 00:00:00	2015-10-24	2015-10-24 00:00:00	\N	38000177		0	0	0		0	0	0	132689	0	1049221	40231925		
27061	2232	19078461	2001-09-08	2001-09-08 00:00:00	2001-09-22	2001-09-22 00:00:00	2001-09-22	38000177		0	0	14		0	0	0	148474	0	310965	19078461		
159009	3501	40213201	2014-03-06	2014-03-06 00:00:00	2014-03-06	2014-03-06 00:00:00	2014-03-06	581452		0	0	0		0	0	0	232076	0	33	40213201		
30237	2507	19059056	1973-01-19	1973-01-19 00:00:00	1973-02-02	1973-02-02 00:00:00	1973-02-02	38000177		0	0	14		0	0	0	165996	0	243670	19059056		
42665	3536	40236824	2016-05-03	2016-05-03 00:00:00	2016-05-17	2016-05-17 00:00:00	2016-05-17	38000177		0	0	14		0	0	0	234892	0	1094107	40236824		
155100	3413	40213227	2008-05-07	2008-05-07 00:00:00	2008-05-07	2008-05-07 00:00:00	2008-05-07	581452		0	0	0		0	0	0	226356	0	113	40213227		
41173	3414	19129655	1971-08-06	1971-08-06 00:00:00	1971-08-20	1971-08-20 00:00:00	1971-08-20	38000177		0	0	14		0	0	0	226426	0	789980	19129655		
1893	152	1127433	1976-09-10	1976-09-10 00:00:00	1976-09-17	1976-09-17 00:00:00	1976-09-17	38000177		0	0	7		0	0	0	10278	0	313782	1127433		
61948	5152	1127433	2015-07-03	2015-07-03 00:00:00	2015-07-24	2015-07-24 00:00:00	2015-07-24	38000177		0	0	21		0	0	0	342649	0	313782	1127433		
53345	4433	1127433	1981-11-16	1981-11-16 00:00:00	1981-12-07	1981-12-07 00:00:00	1981-12-07	38000177		0	0	21		0	0	0	294727	0	313782	1127433		
63195	5251	1713671	1961-06-07	1961-06-07 00:00:00	1961-06-14	1961-06-14 00:00:00	1961-06-14	38000177		0	0	7		0	0	0	349365	0	562251	1713671		
12562	1057	1127433	1991-10-25	1991-10-25 00:00:00	1991-11-15	1991-11-15 00:00:00	1991-11-15	38000177		0	0	21		0	0	0	69303	0	313782	1127433		
8315	693	19078461	1999-09-04	1999-09-04 00:00:00	1999-10-11	1999-10-11 00:00:00	1999-10-11	38000177		0	0	37		0	0	0	45894	0	310965	19078461		
23105	1905	1127433	1997-12-02	1997-12-02 00:00:00	1997-12-16	1997-12-16 00:00:00	1997-12-16	38000177		0	0	14		0	0	0	126840	0	313782	1127433		
5482	458	19128065	1989-07-25	1989-07-25 00:00:00	1990-07-20	1990-07-20 00:00:00	1990-07-20	38000177		0	0	360		0	0	0	30654	0	749882	19128065		
11649	970	1115171	1996-07-29	1996-07-29 00:00:00	1996-08-19	1996-08-19 00:00:00	1996-08-19	38000177		0	0	21		0	0	0	64476	0	849574	1115171		
20200	1658	19059056	1914-11-25	1914-11-25 00:00:00	1914-12-09	1914-12-09 00:00:00	1914-12-09	38000177		0	0	14		0	0	0	111299	0	243670	19059056		
16422	354	40213160	1956-09-13	1956-09-13 00:00:00	1956-09-13	1956-09-13 00:00:00	1956-09-13	581452		0	0	0		0	0	0	23537	0	10	40213160		
42115	3490	1127433	1961-06-23	1961-06-23 00:00:00	1961-07-07	1961-07-07 00:00:00	1961-07-07	38000177		0	0	14		0	0	0	231564	0	313782	1127433		
42150	3495	1127433	1979-05-06	1979-05-06 00:00:00	1979-05-20	1979-05-20 00:00:00	1979-05-20	38000177		0	0	14		0	0	0	231807	0	313782	1127433		
1500	119	920300	2009-01-24	2009-01-24 00:00:00	2009-01-31	2009-01-31 00:00:00	2009-01-31	38000177		0	0	7		0	0	0	7927	0	311989	920300		
15178	328	40213296	2019-04-14	2019-04-14 00:00:00	2019-04-14	2019-04-14 00:00:00	2019-04-14	581452		0	0	0		0	0	0	21651	0	52	40213296		
1805	145	19059056	1952-02-27	1952-02-27 00:00:00	1952-03-12	1952-03-12 00:00:00	1952-03-12	38000177		0	0	14		0	0	0	9793	0	243670	19059056		
25136	2069	1127433	2011-04-30	2011-04-30 00:00:00	2011-06-04	2011-06-04 00:00:00	2011-06-04	38000177		0	0	35		0	0	0	137586	0	313782	1127433		
33031	722	40213227	2001-11-27	2001-11-27 00:00:00	2001-11-27	2001-11-27 00:00:00	2001-11-27	581452		0	0	0		0	0	0	47799	0	113	40213227		
161021	3543	40213160	1958-12-23	1958-12-23 00:00:00	1958-12-23	1958-12-23 00:00:00	1958-12-23	581452		0	0	0		0	0	0	235396	0	10	40213160		
15120	1264	1713671	1982-12-09	1982-12-09 00:00:00	1982-12-30	1982-12-30 00:00:00	1982-12-30	38000177		0	0	21		0	0	0	83314	0	562251	1713671		
43573	3612	19133905	1996-01-11	1996-01-11 00:00:00	1996-01-20	1996-01-20 00:00:00	1996-01-20	38000177		0	0	9		0	0	0	239936	0	834102	19133905		
15181	1267	1127433	1960-12-17	1960-12-17 00:00:00	1960-12-31	1960-12-31 00:00:00	1960-12-31	38000177		0	0	14		0	0	0	83560	0	313782	1127433		
46324	3836	19019979	1986-10-04	1986-10-04 00:00:00	1986-11-03	1986-11-03 00:00:00	1986-11-03	38000177		0	0	30		0	0	0	254749	0	198405	19019979		
14861	321	40213160	1962-07-22	1962-07-22 00:00:00	1962-07-22	1962-07-22 00:00:00	1962-07-22	581452		0	0	0		0	0	0	21280	0	10	40213160		
55236	4587	19078461	2004-04-17	2004-04-17 00:00:00	2004-05-08	2004-05-08 00:00:00	2004-05-08	38000177		0	0	21		0	0	0	305568	0	310965	19078461		
33426	2768	1127078	1972-07-24	1972-07-24 00:00:00	1972-08-07	1972-08-07 00:00:00	1972-08-07	38000177		0	0	14		0	0	0	183162	0	282464	1127078		
43840	3630	19059056	1959-04-06	1959-04-06 00:00:00	1959-04-20	1959-04-20 00:00:00	1959-04-20	38000177		0	0	14		0	0	0	241562	0	243670	19059056		
36413	3001	1127433	1961-12-03	1961-12-03 00:00:00	1961-12-10	1961-12-10 00:00:00	1961-12-10	38000177		0	0	7		0	0	0	200270	0	313782	1127433		
36417	3002	19019979	1975-03-25	1975-03-25 00:00:00	1975-04-15	1975-04-15 00:00:00	1975-04-15	38000177		0	0	21		0	0	0	200333	0	198405	19019979		
28147	2327	1127078	1967-12-23	1967-12-23 00:00:00	1968-01-13	1968-01-13 00:00:00	1968-01-13	38000177		0	0	21		0	0	0	154726	0	282464	1127078		
26602	2190	19006318	1955-12-08	1955-12-08 00:00:00	1955-12-22	1955-12-22 00:00:00	1955-12-22	38000177		0	0	14		0	0	0	146008	0	105078	19006318		
21604	1776	40220386	1984-10-13	1984-10-13 00:00:00	1984-10-13	1984-10-13 00:00:00	1984-10-13	38000177		0	0	0		0	0	0	118804	0	1808217	40220386		
21665	1780	1713671	1986-12-11	1986-12-11 00:00:00	1987-04-23	1987-04-23 00:00:00	1987-04-23	38000177		0	0	133		0	0	0	119153	0	562251	1713671		
21710	1782	40165015	1968-12-01	1968-12-01 00:00:00	1968-12-01	1968-12-01 00:00:00	\N	38000177		0	0	0		0	0	0	119341	0	861467	40165015		
36049	2969	19133873	1970-06-28	1970-06-28 00:00:00	1970-07-07	1970-07-07 00:00:00	1970-07-07	38000177		0	0	9		0	0	0	198201	0	834061	19133873		
5710	479	19059056	1959-11-11	1959-11-11 00:00:00	1959-11-25	1959-11-25 00:00:00	1959-11-25	38000177		0	0	14		0	0	0	31884	0	243670	19059056		
47758	3960	40236824	1981-03-10	1981-03-10 00:00:00	1981-03-17	1981-03-17 00:00:00	1981-03-17	38000177		0	0	7		0	0	0	263252	0	1094107	40236824		
47786	3961	1127078	1975-02-26	1975-02-26 00:00:00	1975-03-12	1975-03-12 00:00:00	1975-03-12	38000177		0	0	14		0	0	0	263371	0	282464	1127078		
23538	1937	40162522	1977-07-20	1977-07-20 00:00:00	1977-07-20	1977-07-20 00:00:00	\N	38000177		0	0	0		0	0	0	128902	0	857005	40162522		
30544	2534	1127078	1974-06-15	1974-06-15 00:00:00	1974-08-14	1974-08-14 00:00:00	1974-08-14	38000177		0	0	60		0	0	0	167431	0	282464	1127078		
21102	1739	964261	1986-04-07	1986-04-07 00:00:00	1986-04-07	1986-04-07 00:00:00	\N	38000177		0	0	0		0	0	0	116216	0	2001499	964261		
31525	687	40213160	1967-04-29	1967-04-29 00:00:00	1967-04-29	1967-04-29 00:00:00	1967-04-29	581452		0	0	0		0	0	0	45536	0	10	40213160		
3213	264	19006318	1955-11-26	1955-11-26 00:00:00	1955-12-10	1955-12-10 00:00:00	1955-12-10	38000177		0	0	14		0	0	0	17568	0	105078	19006318		
4382	364	19059056	1961-03-10	1961-03-10 00:00:00	1961-03-31	1961-03-31 00:00:00	1961-03-31	38000177		0	0	21		0	0	0	24210	0	243670	19059056		
11570	964	1127433	1995-02-16	1995-02-16 00:00:00	1995-03-02	1995-03-02 00:00:00	1995-03-02	38000177		0	0	14		0	0	0	64149	0	313782	1127433		
11574	964	1713671	2015-06-28	2015-06-28 00:00:00	2015-07-05	2015-07-05 00:00:00	2015-07-05	38000177		0	0	7		0	0	0	64174	0	562251	1713671		
6150	515	1127433	2001-01-11	2001-01-11 00:00:00	2001-02-01	2001-02-01 00:00:00	2001-02-01	38000177		0	0	21		0	0	0	34391	0	313782	1127433		
42784	933	40213227	2014-10-07	2014-10-07 00:00:00	2014-10-07	2014-10-07 00:00:00	2014-10-07	581452		0	0	0		0	0	0	62090	0	113	40213227		
229	17	40236824	2000-02-13	2000-02-13 00:00:00	2000-02-27	2000-02-27 00:00:00	2000-02-27	38000177		0	0	14		0	0	0	1310	0	1094107	40236824		
32	2	40231925	1934-01-19	1934-01-19 00:00:00	1934-01-19	1934-01-19 00:00:00	\N	38000177		0	0	0		0	0	0	112	0	1049221	40231925		
49010	4067	1124300	2007-07-01	2007-07-01 00:00:00	2007-07-01	2007-07-01 00:00:00	\N	38000177		0	0	0		0	0	0	270205	0	00781178901	45011828		
7746	648	19059056	1954-10-22	1954-10-22 00:00:00	1954-11-21	1954-11-21 00:00:00	1954-11-21	38000177		0	0	30		0	0	0	42961	0	243670	19059056		
10654	885	1127078	1983-03-02	1983-03-02 00:00:00	1983-03-23	1983-03-23 00:00:00	1983-03-23	38000177		0	0	21		0	0	0	58980	0	282464	1127078		
36210	2985	19059056	1966-06-19	1966-06-19 00:00:00	1966-07-03	1966-07-03 00:00:00	1966-07-03	38000177		0	0	14		0	0	0	199211	0	243670	19059056		
43395	3598	19126352	2015-05-31	2015-05-31 00:00:00	2015-05-31	2015-05-31 00:00:00	\N	38000177		0	0	0		0	0	0	238994	0	705129	19126352		
36333	2993	19128065	1988-05-19	1988-05-19 00:00:00	1989-05-14	1989-05-14 00:00:00	1989-05-14	38000177		0	0	360		0	0	0	199784	0	749882	19128065		
39017	3224	19128065	1975-01-06	1975-01-06 00:00:00	1976-01-01	1976-01-01 00:00:00	1976-01-01	38000177		0	0	360		0	0	0	214382	0	749882	19128065		
24249	1992	19128022	1992-03-03	1992-03-03 00:00:00	1993-02-26	1993-02-26 00:00:00	1993-02-26	38000177		0	0	360		0	0	0	132745	0	749785	19128022		
27062	2232	1118084	2005-09-16	2005-09-16 00:00:00	2005-09-16	2005-09-16 00:00:00	\N	38000177		0	0	0		0	0	0	148491	0	00025152531	44923712		
159016	3501	40213227	2009-02-05	2009-02-05 00:00:00	2009-02-05	2009-02-05 00:00:00	2009-02-05	581452		0	0	0		0	0	0	232122	0	113	40213227		
30238	2507	46233988	1973-01-19	1973-01-19 00:00:00	1973-02-02	1973-02-02 00:00:00	1973-02-02	38000177		0	0	14		0	0	0	165996	0	1652673	46233988		
42666	3536	19078461	1994-11-24	1994-11-24 00:00:00	1994-12-08	1994-12-08 00:00:00	1994-12-08	38000177		0	0	14		0	0	0	234807	0	310965	19078461		
155101	3413	40213296	2008-05-07	2008-05-07 00:00:00	2008-05-07	2008-05-07 00:00:00	2008-05-07	581452		0	0	0		0	0	0	226356	0	52	40213296		
41174	3414	19059056	1971-08-06	1971-08-06 00:00:00	1971-08-20	1971-08-20 00:00:00	1971-08-20	38000177		0	0	14		0	0	0	226426	0	243670	19059056		
1894	152	1127433	2000-10-23	2000-10-23 00:00:00	2000-11-22	2000-11-22 00:00:00	2000-11-22	38000177		0	0	30		0	0	0	10294	0	313782	1127433		
61949	5152	19133873	1973-01-22	1973-01-22 00:00:00	1973-01-31	1973-01-31 00:00:00	1973-01-31	38000177		0	0	9		0	0	0	342601	0	834061	19133873		
53346	4433	19078461	2002-12-08	2002-12-08 00:00:00	2002-12-29	2002-12-29 00:00:00	2002-12-29	38000177		0	0	21		0	0	0	294729	0	310965	19078461		
63196	5251	19059056	1933-11-15	1933-11-15 00:00:00	1933-12-15	1933-12-15 00:00:00	1933-12-15	38000177		0	0	30		0	0	0	349383	0	243670	19059056		
12563	1057	40229134	2007-03-13	2007-03-13 00:00:00	2007-03-20	2007-03-20 00:00:00	2007-03-20	38000177		0	0	7		0	0	0	69324	0	1043400	40229134		
8316	693	40229134	1975-10-16	1975-10-16 00:00:00	1975-10-23	1975-10-23 00:00:00	1975-10-23	38000177		0	0	7		0	0	0	45965	0	1043400	40229134		
23106	1905	1127433	1986-02-19	1986-02-19 00:00:00	1986-02-26	1986-02-26 00:00:00	1986-02-26	38000177		0	0	7		0	0	0	126815	0	313782	1127433		
5483	458	1127433	1991-12-12	1991-12-12 00:00:00	1991-12-19	1991-12-19 00:00:00	1991-12-19	38000177		0	0	7		0	0	0	30648	0	313782	1127433		
11650	970	40229134	1966-12-24	1966-12-24 00:00:00	1966-12-31	1966-12-31 00:00:00	1966-12-31	38000177		0	0	7		0	0	0	64488	0	1043400	40229134		
20201	1658	1127433	1984-09-17	1984-09-17 00:00:00	1984-10-01	1984-10-01 00:00:00	1984-10-01	38000177		0	0	14		0	0	0	111327	0	313782	1127433		
44580	971	40213227	1995-05-19	1995-05-19 00:00:00	1995-05-19	1995-05-19 00:00:00	1995-05-19	581452		0	0	0		0	0	0	64638	0	113	40213227		
42116	3490	1127433	1993-06-22	1993-06-22 00:00:00	1993-07-06	1993-07-06 00:00:00	1993-07-06	38000177		0	0	14		0	0	0	231597	0	313782	1127433		
42151	3495	40229134	1980-07-14	1980-07-14 00:00:00	1980-07-28	1980-07-28 00:00:00	1980-07-28	38000177		0	0	14		0	0	0	231795	0	1043400	40229134		
14513	1216	19078461	2006-05-21	2006-05-21 00:00:00	2006-06-04	2006-06-04 00:00:00	2006-06-04	38000177		0	0	14		0	0	0	80071	0	310965	19078461		
15179	328	40213251	1984-10-14	1984-10-14 00:00:00	1984-10-14	1984-10-14 00:00:00	1984-10-14	581452		0	0	0		0	0	0	21656	0	21	40213251		
1806	145	19006318	1952-02-27	1952-02-27 00:00:00	1952-03-12	1952-03-12 00:00:00	1952-03-12	38000177		0	0	14		0	0	0	9793	0	105078	19006318		
25137	2069	19006318	1952-06-17	1952-06-17 00:00:00	1952-07-01	1952-07-01 00:00:00	1952-07-01	38000177		0	0	14		0	0	0	137628	0	105078	19006318		
33041	722	40213160	1974-01-22	1974-01-22 00:00:00	1974-01-22	1974-01-22 00:00:00	1974-01-22	581452		0	0	0		0	0	0	47779	0	10	40213160		
161026	3543	40213227	1992-09-29	1992-09-29 00:00:00	1992-09-29	1992-09-29 00:00:00	1992-09-29	581452		0	0	0		0	0	0	235385	0	113	40213227		
15121	1264	19133873	1953-05-16	1953-05-16 00:00:00	1953-05-27	1953-05-27 00:00:00	1953-05-27	38000177		0	0	11		0	0	0	83321	0	834061	19133873		
43574	3612	920300	2004-03-15	2004-03-15 00:00:00	2004-03-22	2004-03-22 00:00:00	2004-03-22	38000177		0	0	7		0	0	0	239956	0	311989	920300		
15216	1271	1127433	1991-07-23	1991-07-23 00:00:00	1991-07-30	1991-07-30 00:00:00	1991-07-30	38000177		0	0	7		0	0	0	83801	0	313782	1127433		
46325	3836	40236446	1989-03-01	1989-03-01 00:00:00	1995-03-10	1995-03-10 00:00:00	1995-03-10	38000177		0	0	2200		0	0	0	254721	0	1091392	40236446		
14865	321	40213227	1995-01-08	1995-01-08 00:00:00	1995-01-08	1995-01-08 00:00:00	1995-01-08	581452		0	0	0		0	0	0	21296	0	113	40213227		
55237	4587	40165015	1960-04-08	1960-04-08 00:00:00	1960-04-08	1960-04-08 00:00:00	\N	38000177		0	0	0		0	0	0	305634	0	861467	40165015		
33656	2786	19073188	2004-02-10	2004-02-10 00:00:00	2004-02-24	2004-02-24 00:00:00	2004-02-24	38000177		0	0	14		0	0	0	184622	0	308192	19073188		
43841	3630	19006318	1959-04-06	1959-04-06 00:00:00	1959-04-20	1959-04-20 00:00:00	1959-04-20	38000177		0	0	14		0	0	0	241562	0	105078	19006318		
36414	3001	1713671	1980-01-08	1980-01-08 00:00:00	1980-01-15	1980-01-15 00:00:00	1980-01-15	38000177		0	0	7		0	0	0	200315	0	562251	1713671		
36418	3002	1127078	1974-03-30	1974-03-30 00:00:00	1974-04-13	1974-04-13 00:00:00	1974-04-13	38000177		0	0	14		0	0	0	200381	0	282464	1127078		
28148	2327	1127433	1970-11-08	1970-11-08 00:00:00	1970-11-15	1970-11-15 00:00:00	1970-11-15	38000177		0	0	7		0	0	0	154732	0	313782	1127433		
1311	30	40213227	2001-12-01	2001-12-01 00:00:00	2001-12-01	2001-12-01 00:00:00	2001-12-01	581452		0	0	0		0	0	0	2057	0	113	40213227		
21605	1776	46275444	1984-10-13	1984-10-13 00:00:00	1984-10-13	1984-10-13 00:00:00	1984-10-13	38000177		0	0	0		0	0	0	118804	0	1659149	46275444		
21666	1780	40229134	1988-11-30	1988-11-30 00:00:00	1988-12-14	1988-12-14 00:00:00	1988-12-14	38000177		0	0	14		0	0	0	119154	0	1043400	40229134		
21711	1782	1127433	1968-12-01	1968-12-01 00:00:00	1969-03-01	1969-03-01 00:00:00	1969-03-01	38000177		0	0	90		0	0	0	119341	0	313782	1127433		
36050	2969	1127433	1982-04-24	1982-04-24 00:00:00	1982-05-01	1982-05-01 00:00:00	1982-05-01	38000177		0	0	7		0	0	0	198202	0	313782	1127433		
5711	479	19006318	1959-11-11	1959-11-11 00:00:00	1959-11-25	1959-11-25 00:00:00	1959-11-25	38000177		0	0	14		0	0	0	31884	0	105078	19006318		
47759	3960	920300	1981-03-10	1981-03-10 00:00:00	1981-03-17	1981-03-17 00:00:00	1981-03-17	38000177		0	0	7		0	0	0	263252	0	311989	920300		
47787	3961	46233988	1975-02-26	1975-02-26 00:00:00	1975-03-12	1975-03-12 00:00:00	1975-03-12	38000177		0	0	14		0	0	0	263371	0	1652673	46233988		
23540	1937	920300	2004-06-09	2004-06-09 00:00:00	2004-06-16	2004-06-16 00:00:00	2004-06-16	38000177		0	0	7		0	0	0	128888	0	311989	920300		
41003	3401	1127433	1960-07-13	1960-07-13 00:00:00	1960-07-27	1960-07-27 00:00:00	1960-07-27	38000177		0	0	14		0	0	0	225600	0	313782	1127433		
21103	1739	1713671	2017-01-19	2017-01-19 00:00:00	2017-02-02	2017-02-02 00:00:00	2017-02-02	38000177		0	0	14		0	0	0	116214	0	562251	1713671		
31530	687	40213306	1989-11-11	1989-11-11 00:00:00	1989-11-11	1989-11-11 00:00:00	1989-11-11	581452		0	0	0		0	0	0	45547	0	43	40213306		
3214	264	1127433	1995-04-03	1995-04-03 00:00:00	1995-04-10	1995-04-10 00:00:00	1995-04-10	38000177		0	0	7		0	0	0	17594	0	313782	1127433		
4383	364	1127433	2014-09-05	2014-09-05 00:00:00	2014-09-12	2014-09-12 00:00:00	2014-09-12	38000177		0	0	7		0	0	0	24134	0	313782	1127433		
179035	3936	40213260	2008-03-10	2008-03-10 00:00:00	2008-03-10	2008-03-10 00:00:00	2008-03-10	581452		0	0	0		0	0	0	261581	0	121	40213260		
11575	964	19128065	1991-10-15	1991-10-15 00:00:00	1992-10-09	1992-10-09 00:00:00	1992-10-09	38000177		0	0	360		0	0	0	64175	0	749882	19128065		
6151	515	19078461	2012-08-02	2012-08-02 00:00:00	2012-10-31	2012-10-31 00:00:00	2012-10-31	38000177		0	0	90		0	0	0	34392	0	310965	19078461		
42785	933	40213296	2014-10-07	2014-10-07 00:00:00	2014-10-07	2014-10-07 00:00:00	2014-10-07	581452		0	0	0		0	0	0	62090	0	52	40213296		
230	17	920300	2000-02-13	2000-02-13 00:00:00	2000-02-20	2000-02-20 00:00:00	2000-02-20	38000177		0	0	7		0	0	0	1310	0	311989	920300		
33	2	19059056	1921-06-04	1921-06-04 00:00:00	1921-06-18	1921-06-18 00:00:00	1921-06-18	38000177		0	0	14		0	0	0	145	0	243670	19059056		
49011	4067	1127433	2012-08-19	2012-08-19 00:00:00	2012-09-02	2012-09-02 00:00:00	2012-09-02	38000177		0	0	14		0	0	0	270251	0	313782	1127433		
7747	648	40165015	1954-10-22	1954-10-22 00:00:00	1954-10-22	1954-10-22 00:00:00	\N	38000177		0	0	0		0	0	0	42961	0	861467	40165015		
10655	885	19133873	1984-03-22	1984-03-22 00:00:00	1984-04-04	1984-04-04 00:00:00	1984-04-04	38000177		0	0	13		0	0	0	59001	0	834061	19133873		
36212	2985	1127433	1976-10-16	1976-10-16 00:00:00	1976-10-30	1976-10-30 00:00:00	1976-10-30	38000177		0	0	14		0	0	0	199213	0	313782	1127433		
43396	3598	19075601	2015-05-31	2015-05-31 00:00:00	2015-05-31	2015-05-31 00:00:00	\N	38000177		0	0	0		0	0	0	238994	0	309362	19075601		
36334	2993	19059056	1989-02-03	1989-02-03 00:00:00	1989-02-24	1989-02-24 00:00:00	1989-02-24	38000177		0	0	21		0	0	0	199828	0	243670	19059056		
39018	3224	40236824	2000-01-30	2000-01-30 00:00:00	2000-02-13	2000-02-13 00:00:00	2000-02-13	38000177		0	0	14		0	0	0	214379	0	1094107	40236824		
24250	1992	1127433	1984-03-06	1984-03-06 00:00:00	1984-03-13	1984-03-13 00:00:00	1984-03-13	38000177		0	0	7		0	0	0	132732	0	313782	1127433		
27063	2232	1127078	1968-02-13	1968-02-13 00:00:00	1968-03-05	1968-03-05 00:00:00	1968-03-05	38000177		0	0	21		0	0	0	148473	0	282464	1127078		
159028	3501	40213227	1998-12-10	1998-12-10 00:00:00	1998-12-10	1998-12-10 00:00:00	1998-12-10	581452		0	0	0		0	0	0	232071	0	113	40213227		
30239	2507	1127433	1992-05-22	1992-05-22 00:00:00	1992-06-05	1992-06-05 00:00:00	1992-06-05	38000177		0	0	14		0	0	0	165948	0	313782	1127433		
42667	3536	19112599	1967-11-27	1967-11-27 00:00:00	1967-11-27	1967-11-27 00:00:00	\N	38000177		0	0	0		0	0	0	234874	0	477045	19112599		
155104	3414	40213227	2018-04-05	2018-04-05 00:00:00	2018-04-05	2018-04-05 00:00:00	2018-04-05	581452		0	0	0		0	0	0	226467	0	113	40213227		
41175	3414	1118084	2004-04-04	2004-04-04 00:00:00	2004-04-04	2004-04-04 00:00:00	\N	38000177		0	0	0		0	0	0	226489	0	00025152531	44923712		
1895	152	40236824	2011-02-02	2011-02-02 00:00:00	2011-02-09	2011-02-09 00:00:00	2011-02-09	38000177		0	0	7		0	0	0	10246	0	1094107	40236824		
61950	5152	1127433	2013-06-19	2013-06-19 00:00:00	2013-06-26	2013-06-26 00:00:00	2013-06-26	38000177		0	0	7		0	0	0	342605	0	313782	1127433		
53347	4433	1127433	2015-12-12	2015-12-12 00:00:00	2016-03-11	2016-03-11 00:00:00	2016-03-11	38000177		0	0	90		0	0	0	294731	0	313782	1127433		
63197	5251	19059056	1931-10-27	1931-10-27 00:00:00	1931-12-26	1931-12-26 00:00:00	1931-12-26	38000177		0	0	60		0	0	0	349382	0	243670	19059056		
12564	1057	1127078	1963-03-12	1963-03-12 00:00:00	1963-03-26	1963-03-26 00:00:00	1963-03-26	38000177		0	0	14		0	0	0	69301	0	282464	1127078		
8317	693	19059056	1959-05-25	1959-05-25 00:00:00	1959-06-08	1959-06-08 00:00:00	1959-06-08	38000177		0	0	14		0	0	0	45888	0	243670	19059056		
23107	1905	19006318	1966-07-18	1966-07-18 00:00:00	1966-08-01	1966-08-01 00:00:00	1966-08-01	38000177		0	0	14		0	0	0	126819	0	105078	19006318		
5484	458	19133873	1978-03-31	1978-03-31 00:00:00	1978-04-07	1978-04-07 00:00:00	1978-04-07	38000177		0	0	7		0	0	0	30629	0	834061	19133873		
11651	970	1713671	1952-12-14	1952-12-14 00:00:00	1952-12-21	1952-12-21 00:00:00	1952-12-21	38000177		0	0	7		0	0	0	64479	0	562251	1713671		
20202	1658	1713671	1999-12-17	1999-12-17 00:00:00	2000-01-07	2000-01-07 00:00:00	2000-01-07	38000177		0	0	21		0	0	0	111416	0	562251	1713671		
44594	971	40213227	2016-03-11	2016-03-11 00:00:00	2016-03-11	2016-03-11 00:00:00	2016-03-11	581452		0	0	0		0	0	0	64569	0	113	40213227		
34383	752	40213198	2011-11-13	2011-11-13 00:00:00	2011-11-13	2011-11-13 00:00:00	2011-11-13	581452		0	0	0		0	0	0	49728	0	133	40213198		
42152	3495	19019979	1975-05-25	1975-05-25 00:00:00	1975-06-15	1975-06-15 00:00:00	1975-06-15	38000177		0	0	21		0	0	0	231812	0	198405	19019979		
14515	1216	920300	1988-08-27	1988-08-27 00:00:00	1988-09-03	1988-09-03 00:00:00	1988-09-03	38000177		0	0	7		0	0	0	80089	0	311989	920300		
15184	328	40213314	1979-04-08	1979-04-08 00:00:00	1979-04-08	1979-04-08 00:00:00	1979-04-08	581452		0	0	0		0	0	0	21645	0	49	40213314		
1807	145	40236824	1974-01-08	1974-01-08 00:00:00	1974-01-15	1974-01-15 00:00:00	1974-01-15	38000177		0	0	7		0	0	0	9718	0	1094107	40236824		
25138	2069	19059056	1952-06-17	1952-06-17 00:00:00	1952-07-01	1952-07-01 00:00:00	1952-07-01	38000177		0	0	14		0	0	0	137628	0	243670	19059056		
33047	722	40213227	1993-06-01	1993-06-01 00:00:00	1993-06-01	1993-06-01 00:00:00	1993-06-01	581452		0	0	0		0	0	0	47787	0	113	40213227		
161027	3543	40213160	1958-10-21	1958-10-21 00:00:00	1958-10-21	1958-10-21 00:00:00	1958-10-21	581452		0	0	0		0	0	0	235379	0	10	40213160		
15122	1264	19133905	2004-09-24	2004-09-24 00:00:00	2004-10-05	2004-10-05 00:00:00	2004-10-05	38000177		0	0	11		0	0	0	83340	0	834102	19133905		
43575	3612	1118084	2004-09-24	2004-09-24 00:00:00	2004-09-24	2004-09-24 00:00:00	\N	38000177		0	0	0		0	0	0	239956	0	00025152531	44923712		
15217	1271	1127078	1978-12-20	1978-12-20 00:00:00	1979-01-10	1979-01-10 00:00:00	1979-01-10	38000177		0	0	21		0	0	0	83820	0	282464	1127078		
46342	3839	1127433	1970-08-09	1970-08-09 00:00:00	1970-09-13	1970-09-13 00:00:00	1970-09-13	38000177		0	0	35		0	0	0	254860	0	313782	1127433		
14868	321	40213227	2013-02-17	2013-02-17 00:00:00	2013-02-17	2013-02-17 00:00:00	2013-02-17	581452		0	0	0		0	0	0	21287	0	113	40213227		
55238	4587	19075601	2003-07-12	2003-07-12 00:00:00	2017-11-18	2017-11-18 00:00:00	2017-11-18	38000177		0	0	5243		0	0	0	305555	0	309362	19075601		
33657	2786	40223774	2003-09-07	2003-09-07 00:00:00	2003-09-07	2003-09-07 00:00:00	\N	38000177		0	0	0		0	0	0	184619	0	998582	40223774		
43842	3630	1127433	2015-09-15	2015-09-15 00:00:00	2015-09-22	2015-09-22 00:00:00	2015-09-22	38000177		0	0	7		0	0	0	241517	0	313782	1127433		
239639	5259	40213227	2001-09-24	2001-09-24 00:00:00	2001-09-24	2001-09-24 00:00:00	2001-09-24	581452		0	0	0		0	0	0	349952	0	113	40213227		
36419	3002	19129655	1974-03-30	1974-03-30 00:00:00	1974-04-13	1974-04-13 00:00:00	1974-04-13	38000177		0	0	14		0	0	0	200381	0	789980	19129655		
28149	2328	1127433	1975-09-06	1975-09-06 00:00:00	1975-09-20	1975-09-20 00:00:00	1975-09-20	38000177		0	0	14		0	0	0	154864	0	313782	1127433		
1313	30	40213296	2012-01-14	2012-01-14 00:00:00	2012-01-14	2012-01-14 00:00:00	2012-01-14	581452		0	0	0		0	0	0	2074	0	52	40213296		
21606	1776	19078924	1984-10-13	1984-10-13 00:00:00	1984-10-13	1984-10-13 00:00:00	1984-10-13	38000177		0	0	0		0	0	0	118804	0	311700	19078924		
21667	1780	19078461	2019-02-20	2019-02-20 00:00:00	2019-03-06	2019-03-06 00:00:00	2019-03-06	38000177		0	0	14		0	0	0	119157	0	310965	19078461		
21712	1782	19006318	1954-04-19	1954-04-19 00:00:00	1954-05-03	1954-05-03 00:00:00	1954-05-03	38000177		0	0	14		0	0	0	119328	0	105078	19006318		
36051	2969	19059056	1969-12-31	1969-12-31 00:00:00	1970-01-28	1970-01-28 00:00:00	1970-01-28	38000177		0	0	28		0	0	0	198244	0	243670	19059056		
5712	479	1127433	1967-12-15	1967-12-15 00:00:00	1968-01-05	1968-01-05 00:00:00	1968-01-05	38000177		0	0	21		0	0	0	31854	0	313782	1127433		
47760	3960	1127433	1983-04-08	1983-04-08 00:00:00	1983-04-15	1983-04-15 00:00:00	1983-04-15	38000177		0	0	7		0	0	0	263259	0	313782	1127433		
47788	3961	1124300	2011-09-15	2011-09-15 00:00:00	2011-09-15	2011-09-15 00:00:00	\N	38000177		0	0	0		0	0	0	263386	0	00781178901	45011828		
13397	1123	40229134	1977-03-26	1977-03-26 00:00:00	1977-04-09	1977-04-09 00:00:00	1977-04-09	38000177		0	0	14		0	0	0	73999	0	1043400	40229134		
41004	3401	19133905	2007-05-13	2007-05-13 00:00:00	2007-05-21	2007-05-21 00:00:00	2007-05-21	38000177		0	0	8		0	0	0	225597	0	834102	19133905		
21104	1739	19078461	2016-08-23	2016-08-23 00:00:00	2016-09-27	2016-09-27 00:00:00	2016-09-27	38000177		0	0	35		0	0	0	116193	0	310965	19078461		
31533	687	40213160	1972-01-01	1972-01-01 00:00:00	1972-01-01	1972-01-01 00:00:00	1972-01-01	581452		0	0	0		0	0	0	45503	0	10	40213160		
3215	264	1127433	1978-06-15	1978-06-15 00:00:00	1978-06-29	1978-06-29 00:00:00	1978-06-29	38000177		0	0	14		0	0	0	17514	0	313782	1127433		
4384	364	1713671	1961-05-18	1961-05-18 00:00:00	1961-06-01	1961-06-01 00:00:00	1961-06-01	38000177		0	0	14		0	0	0	24150	0	562251	1713671		
179042	3936	40213296	1998-08-31	1998-08-31 00:00:00	1998-08-31	1998-08-31 00:00:00	1998-08-31	581452		0	0	0		0	0	0	261594	0	52	40213296		
11576	964	19133873	1980-11-04	1980-11-04 00:00:00	1980-11-14	1980-11-14 00:00:00	1980-11-14	38000177		0	0	10		0	0	0	64183	0	834061	19133873		
6152	515	40229134	1971-09-12	1971-09-12 00:00:00	1971-09-26	1971-09-26 00:00:00	1971-09-26	38000177		0	0	14		0	0	0	34325	0	1043400	40229134		
42790	933	40213227	2003-12-09	2003-12-09 00:00:00	2003-12-09	2003-12-09 00:00:00	2003-12-09	581452		0	0	0		0	0	0	62091	0	113	40213227		
231	17	1127433	1971-10-27	1971-10-27 00:00:00	1971-12-01	1971-12-01 00:00:00	1971-12-01	38000177		0	0	35		0	0	0	1373	0	313782	1127433		
34	2	1118084	1956-12-04	1956-12-04 00:00:00	1956-12-04	1956-12-04 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00025152531	44923712		
49012	4067	19059056	1977-06-23	1977-06-23 00:00:00	1977-07-14	1977-07-14 00:00:00	1977-07-14	38000177		0	0	21		0	0	0	270200	0	243670	19059056		
7748	648	19078461	2007-07-26	2007-07-26 00:00:00	2007-10-24	2007-10-24 00:00:00	2007-10-24	38000177		0	0	90		0	0	0	42967	0	310965	19078461		
10656	885	19078461	1992-12-30	1992-12-30 00:00:00	1993-02-28	1993-02-28 00:00:00	1993-02-28	38000177		0	0	60		0	0	0	58981	0	310965	19078461		
36213	2985	46233710	1976-10-16	1976-10-16 00:00:00	1976-10-30	1976-10-30 00:00:00	1976-10-30	38000177		0	0	14		0	0	0	199213	0	1650142	46233710		
43397	3598	19059056	1948-07-28	1948-07-28 00:00:00	1948-08-11	1948-08-11 00:00:00	1948-08-11	38000177		0	0	14		0	0	0	239014	0	243670	19059056		
36335	2993	40169281	2007-09-01	2007-09-01 00:00:00	2007-09-01	2007-09-01 00:00:00	\N	38000177		0	0	0		0	0	0	199775	0	896209	40169281		
39019	3224	920300	2000-01-30	2000-01-30 00:00:00	2000-02-06	2000-02-06 00:00:00	2000-02-06	38000177		0	0	7		0	0	0	214379	0	311989	920300		
24251	1992	19128022	1994-02-21	1994-02-21 00:00:00	1995-02-16	1995-02-16 00:00:00	1995-02-16	38000177		0	0	360		0	0	0	132747	0	749785	19128022		
27066	2232	1713671	1987-06-11	1987-06-11 00:00:00	1987-06-25	1987-06-25 00:00:00	1987-06-25	38000177		0	0	14		0	0	0	148538	0	562251	1713671		
159032	3501	40213160	1955-12-01	1955-12-01 00:00:00	1955-12-01	1955-12-01 00:00:00	1955-12-01	581452		0	0	0		0	0	0	232112	0	10	40213160		
30241	2507	1115171	2017-07-20	2017-07-20 00:00:00	2017-08-03	2017-08-03 00:00:00	2017-08-03	38000177		0	0	14		0	0	0	165956	0	849574	1115171		
42668	3536	920334	2016-05-10	2016-05-10 00:00:00	2016-05-17	2016-05-17 00:00:00	2016-05-17	38000177		0	0	7		0	0	0	234859	0	311995	920334		
155105	3414	40213260	2018-04-05	2018-04-05 00:00:00	2018-04-05	2018-04-05 00:00:00	2018-04-05	581452		0	0	0		0	0	0	226467	0	121	40213260		
41176	3414	40229134	1982-04-05	1982-04-05 00:00:00	1982-04-19	1982-04-19 00:00:00	1982-04-19	38000177		0	0	14		0	0	0	226449	0	1043400	40229134		
1896	152	920300	2011-02-02	2011-02-02 00:00:00	2011-02-09	2011-02-09 00:00:00	2011-02-09	38000177		0	0	7		0	0	0	10246	0	311989	920300		
61951	5152	40229134	2002-01-17	2002-01-17 00:00:00	2002-01-31	2002-01-31 00:00:00	2002-01-31	38000177		0	0	14		0	0	0	342603	0	1043400	40229134		
53348	4433	1713671	1994-07-03	1994-07-03 00:00:00	1994-07-24	1994-07-24 00:00:00	1994-07-24	38000177		0	0	21		0	0	0	294667	0	562251	1713671		
63198	5251	19059056	1923-03-24	1923-03-24 00:00:00	1923-04-14	1923-04-14 00:00:00	1923-04-14	38000177		0	0	21		0	0	0	349387	0	243670	19059056		
12565	1057	1118084	2003-11-27	2003-11-27 00:00:00	2003-11-27	2003-11-27 00:00:00	\N	38000177		0	0	0		0	0	0	69306	0	00025152531	44923712		
8318	693	19059056	1962-02-22	1962-02-22 00:00:00	1962-03-08	1962-03-08 00:00:00	1962-03-08	38000177		0	0	14		0	0	0	45889	0	243670	19059056		
23108	1905	19059056	1966-07-18	1966-07-18 00:00:00	1966-08-01	1966-08-01 00:00:00	1966-08-01	38000177		0	0	14		0	0	0	126819	0	243670	19059056		
8378	700	19128022	1995-05-26	1995-05-26 00:00:00	1996-05-20	1996-05-20 00:00:00	1996-05-20	38000177		0	0	360		0	0	0	46270	0	749785	19128022		
11652	970	1127433	1998-11-07	1998-11-07 00:00:00	1998-12-12	1998-12-12 00:00:00	1998-12-12	38000177		0	0	35		0	0	0	64477	0	313782	1127433		
20203	1658	19059056	1939-03-24	1939-03-24 00:00:00	1939-04-21	1939-04-21 00:00:00	1939-04-21	38000177		0	0	28		0	0	0	111376	0	243670	19059056		
44606	971	40213201	2011-02-11	2011-02-11 00:00:00	2011-02-11	2011-02-11 00:00:00	2011-02-11	581452		0	0	0		0	0	0	64655	0	33	40213201		
34384	752	40213227	1998-11-01	1998-11-01 00:00:00	1998-11-01	1998-11-01 00:00:00	1998-11-01	581452		0	0	0		0	0	0	49691	0	113	40213227		
42153	3495	1115171	2014-08-22	2014-08-22 00:00:00	2014-09-26	2014-09-26 00:00:00	2014-09-26	38000177		0	0	35		0	0	0	231816	0	849574	1115171		
14516	1216	40236824	1988-08-27	1988-08-27 00:00:00	1988-09-10	1988-09-10 00:00:00	1988-09-10	38000177		0	0	14		0	0	0	80089	0	1094107	40236824		
15185	328	40213160	1979-04-08	1979-04-08 00:00:00	1979-04-08	1979-04-08 00:00:00	1979-04-08	581452		0	0	0		0	0	0	21645	0	10	40213160		
1808	145	920300	1974-01-08	1974-01-08 00:00:00	1974-01-15	1974-01-15 00:00:00	1974-01-15	38000177		0	0	7		0	0	0	9718	0	311989	920300		
25139	2069	19133873	1959-04-09	1959-04-09 00:00:00	1959-04-18	1959-04-18 00:00:00	1959-04-18	38000177		0	0	9		0	0	0	137598	0	834061	19133873		
33048	722	40213160	1969-07-22	1969-07-22 00:00:00	1969-07-22	1969-07-22 00:00:00	1969-07-22	581452		0	0	0		0	0	0	47776	0	10	40213160		
161033	3543	40213227	2010-01-05	2010-01-05 00:00:00	2010-01-05	2010-01-05 00:00:00	2010-01-05	581452		0	0	0		0	0	0	235365	0	113	40213227		
15123	1264	1713671	2002-06-07	2002-06-07 00:00:00	2002-06-28	2002-06-28 00:00:00	2002-06-28	38000177		0	0	21		0	0	0	83277	0	562251	1713671		
43576	3612	40236824	2004-03-15	2004-03-15 00:00:00	2004-03-22	2004-03-22 00:00:00	2004-03-22	38000177		0	0	7		0	0	0	239956	0	1094107	40236824		
15219	1271	19133873	1979-04-06	1979-04-06 00:00:00	1979-04-19	1979-04-19 00:00:00	1979-04-19	38000177		0	0	13		0	0	0	83823	0	834061	19133873		
46343	3839	1713671	1984-09-20	1984-09-20 00:00:00	1984-10-04	1984-10-04 00:00:00	1984-10-04	38000177		0	0	14		0	0	0	254922	0	562251	1713671		
14869	321	40213260	2013-02-17	2013-02-17 00:00:00	2013-02-17	2013-02-17 00:00:00	2013-02-17	581452		0	0	0		0	0	0	21287	0	121	40213260		
55239	4587	1539411	2003-07-12	2003-07-12 00:00:00	2003-07-12	2003-07-12 00:00:00	\N	38000177		0	0	0		0	0	0	305555	0	312961	1539411		
33658	2786	19059056	1926-03-13	1926-03-13 00:00:00	1926-05-12	1926-05-12 00:00:00	1926-05-12	38000177		0	0	60		0	0	0	184606	0	243670	19059056		
43843	3630	1713671	1996-01-09	1996-01-09 00:00:00	1996-01-23	1996-01-23 00:00:00	1996-01-23	38000177		0	0	14		0	0	0	241561	0	562251	1713671		
239640	5259	40213296	2001-09-24	2001-09-24 00:00:00	2001-09-24	2001-09-24 00:00:00	2001-09-24	581452		0	0	0		0	0	0	349952	0	52	40213296		
36420	3002	1124300	2012-11-05	2012-11-05 00:00:00	2012-11-05	2012-11-05 00:00:00	\N	38000177		0	0	0		0	0	0	200380	0	00781178901	45011828		
28150	2328	1118084	1999-05-04	1999-05-04 00:00:00	1999-05-04	1999-05-04 00:00:00	\N	38000177		0	0	0		0	0	0	154884	0	00025152531	44923712		
1317	30	40213306	1990-09-22	1990-09-22 00:00:00	1990-09-22	1990-09-22 00:00:00	1990-09-22	581452		0	0	0		0	0	0	2083	0	43	40213306		
21607	1776	19059528	1984-10-13	1984-10-13 00:00:00	1984-10-13	1984-10-13 00:00:00	1984-10-13	38000177		0	0	0		0	0	0	118804	0	480	19059528		
21668	1780	19075001	2019-02-20	2019-02-20 00:00:00	2019-03-06	2019-03-06 00:00:00	2019-03-06	38000177		0	0	14		0	0	0	119157	0	309097	19075001		
21713	1782	19059056	1954-04-19	1954-04-19 00:00:00	1954-05-03	1954-05-03 00:00:00	1954-05-03	38000177		0	0	14		0	0	0	119328	0	243670	19059056		
36052	2969	1127433	2000-11-03	2000-11-03 00:00:00	2000-11-17	2000-11-17 00:00:00	2000-11-17	38000177		0	0	14		0	0	0	198250	0	313782	1127433		
5713	479	1127433	1957-04-13	1957-04-13 00:00:00	1957-04-27	1957-04-27 00:00:00	1957-04-27	38000177		0	0	14		0	0	0	31883	0	313782	1127433		
47761	3960	1127433	1966-09-30	1966-09-30 00:00:00	1966-10-14	1966-10-14 00:00:00	1966-10-14	38000177		0	0	14		0	0	0	263289	0	313782	1127433		
47790	3962	19078461	2015-09-03	2015-09-03 00:00:00	2015-09-24	2015-09-24 00:00:00	2015-09-24	38000177		0	0	21		0	0	0	263467	0	310965	19078461		
13398	1123	19059056	1968-12-30	1968-12-30 00:00:00	1969-01-13	1969-01-13 00:00:00	1969-01-13	38000177		0	0	14		0	0	0	74015	0	243670	19059056		
41005	3401	1127433	2002-02-21	2002-02-21 00:00:00	2002-03-21	2002-03-21 00:00:00	2002-03-21	38000177		0	0	28		0	0	0	225626	0	313782	1127433		
21105	1739	40229134	1985-06-13	1985-06-13 00:00:00	1985-06-27	1985-06-27 00:00:00	1985-06-27	38000177		0	0	14		0	0	0	116210	0	1043400	40229134		
3179	262	1713671	2016-12-16	2016-12-16 00:00:00	2016-12-30	2016-12-30 00:00:00	2016-12-30	38000177		0	0	14		0	0	0	17364	0	562251	1713671		
3216	264	1124300	1984-04-04	1984-04-04 00:00:00	1984-04-04	1984-04-04 00:00:00	\N	38000177		0	0	0		0	0	0	17547	0	00781178901	45011828		
4385	364	1124300	1983-08-07	1983-08-07 00:00:00	1983-08-07	1983-08-07 00:00:00	\N	38000177		0	0	0		0	0	0	24157	0	00781178901	45011828		
19742	430	40213227	2002-06-22	2002-06-22 00:00:00	2002-06-22	2002-06-22 00:00:00	2002-06-22	581452		0	0	0		0	0	0	\N	0	113	40213227		
11577	964	19128022	1995-09-24	1995-09-24 00:00:00	1996-09-18	1996-09-18 00:00:00	1996-09-18	38000177		0	0	360		0	0	0	64188	0	749785	19128022		
6153	515	19059056	1943-04-25	1943-04-25 00:00:00	1943-05-09	1943-05-09 00:00:00	1943-05-09	38000177		0	0	14		0	0	0	34336	0	243670	19059056		
42792	933	40213160	1973-01-02	1973-01-02 00:00:00	1973-01-02	1973-01-02 00:00:00	1973-01-02	581452		0	0	0		0	0	0	62065	0	10	40213160		
232	17	46233710	1971-10-27	1971-10-27 00:00:00	1971-12-01	1971-12-01 00:00:00	1971-12-01	38000177		0	0	35		0	0	0	1373	0	1650142	46233710		
35	2	1127433	1996-04-10	1996-04-10 00:00:00	1996-04-24	1996-04-24 00:00:00	1996-04-24	38000177		0	0	14		0	0	0	107	0	313782	1127433		
49013	4067	19115351	1971-12-04	1971-12-04 00:00:00	1972-06-03	1972-06-03 00:00:00	1972-06-03	38000177		0	0	182		0	0	0	270253	0	563026	19115351		
7749	648	1127433	2014-09-30	2014-09-30 00:00:00	2014-10-07	2014-10-07 00:00:00	2014-10-07	38000177		0	0	7		0	0	0	42891	0	313782	1127433		
10657	885	40165015	1992-12-30	1992-12-30 00:00:00	1992-12-30	1992-12-30 00:00:00	\N	38000177		0	0	0		0	0	0	58981	0	861467	40165015		
36214	2985	1127433	1994-12-03	1994-12-03 00:00:00	1994-12-17	1994-12-17 00:00:00	1994-12-17	38000177		0	0	14		0	0	0	199208	0	313782	1127433		
43398	3598	1127433	2004-03-21	2004-03-21 00:00:00	2004-04-04	2004-04-04 00:00:00	2004-04-04	38000177		0	0	14		0	0	0	239012	0	313782	1127433		
59663	4960	19059056	1943-09-30	1943-09-30 00:00:00	1943-10-28	1943-10-28 00:00:00	1943-10-28	38000177		0	0	28		0	0	0	329706	0	243670	19059056		
39020	3224	1127433	1971-01-18	1971-01-18 00:00:00	1971-02-01	1971-02-01 00:00:00	1971-02-01	38000177		0	0	14		0	0	0	214369	0	313782	1127433		
24252	1992	19059056	1992-10-19	1992-10-19 00:00:00	1992-11-23	1992-11-23 00:00:00	1992-11-23	38000177		0	0	35		0	0	0	132688	0	243670	19059056		
27067	2232	1115171	2011-12-29	2011-12-29 00:00:00	2012-01-12	2012-01-12 00:00:00	2012-01-12	38000177		0	0	14		0	0	0	148475	0	849574	1115171		
102046	2237	40213227	1992-01-26	1992-01-26 00:00:00	1992-01-26	1992-01-26 00:00:00	1992-01-26	581452		0	0	0		0	0	0	148824	0	113	40213227		
30242	2507	1713671	2003-03-03	2003-03-03 00:00:00	2003-03-17	2003-03-17 00:00:00	2003-03-17	38000177		0	0	14		0	0	0	165994	0	562251	1713671		
42669	3536	920300	2006-11-28	2006-11-28 00:00:00	2006-12-05	2006-12-05 00:00:00	2006-12-05	38000177		0	0	7		0	0	0	234843	0	311989	920300		
155106	3414	40213296	2008-08-28	2008-08-28 00:00:00	2008-08-28	2008-08-28 00:00:00	2008-08-28	581452		0	0	0		0	0	0	226472	0	52	40213296		
41177	3414	1127433	1994-07-24	1994-07-24 00:00:00	1994-08-07	1994-08-07 00:00:00	1994-08-07	38000177		0	0	14		0	0	0	226486	0	313782	1127433		
1897	152	1127433	2017-02-26	2017-02-26 00:00:00	2017-03-19	2017-03-19 00:00:00	2017-03-19	38000177		0	0	21		0	0	0	10295	0	313782	1127433		
61952	5152	19133873	1976-08-14	1976-08-14 00:00:00	1976-08-23	1976-08-23 00:00:00	1976-08-23	38000177		0	0	9		0	0	0	342637	0	834061	19133873		
53349	4433	19059056	1943-07-25	1943-07-25 00:00:00	1943-08-08	1943-08-08 00:00:00	1943-08-08	38000177		0	0	14		0	0	0	294648	0	243670	19059056		
63199	5251	19059056	1928-11-13	1928-11-13 00:00:00	1928-12-11	1928-12-11 00:00:00	1928-12-11	38000177		0	0	28		0	0	0	349381	0	243670	19059056		
12566	1057	1127433	1989-01-08	1989-01-08 00:00:00	1989-02-07	1989-02-07 00:00:00	1989-02-07	38000177		0	0	30		0	0	0	69302	0	313782	1127433		
8319	693	19059056	1951-11-28	1951-11-28 00:00:00	1951-12-12	1951-12-12 00:00:00	1951-12-12	38000177		0	0	14		0	0	0	45910	0	243670	19059056		
23109	1905	1127433	2018-01-20	2018-01-20 00:00:00	2018-02-03	2018-02-03 00:00:00	2018-02-03	38000177		0	0	14		0	0	0	126808	0	313782	1127433		
8379	700	1127433	2003-05-06	2003-05-06 00:00:00	2003-05-13	2003-05-13 00:00:00	2003-05-13	38000177		0	0	7		0	0	0	46241	0	313782	1127433		
11653	970	1127433	2003-08-16	2003-08-16 00:00:00	2003-08-23	2003-08-23 00:00:00	2003-08-23	38000177		0	0	7		0	0	0	64490	0	313782	1127433		
20204	1658	19133905	2005-02-26	2005-02-26 00:00:00	2005-03-08	2005-03-08 00:00:00	2005-03-08	38000177		0	0	10		0	0	0	111346	0	834102	19133905		
36673	3026	19006318	1958-07-06	1958-07-06 00:00:00	1958-07-20	1958-07-20 00:00:00	1958-07-20	38000177		0	0	14		0	0	0	201779	0	105078	19006318		
30664	669	40213160	1970-03-11	1970-03-11 00:00:00	1970-03-11	1970-03-11 00:00:00	1970-03-11	581452		0	0	0		0	0	0	44197	0	10	40213160		
42154	3495	19133873	1968-06-02	1968-06-02 00:00:00	1968-06-14	1968-06-14 00:00:00	1968-06-14	38000177		0	0	12		0	0	0	231794	0	834061	19133873		
14517	1216	19128065	1987-07-05	1987-07-05 00:00:00	1988-06-29	1988-06-29 00:00:00	1988-06-29	38000177		0	0	360		0	0	0	80111	0	749882	19128065		
15188	328	40213160	1983-10-09	1983-10-09 00:00:00	1983-10-09	1983-10-09 00:00:00	1983-10-09	581452		0	0	0		0	0	0	21633	0	10	40213160		
1809	145	19078461	1982-06-01	1982-06-01 00:00:00	1982-06-22	1982-06-22 00:00:00	1982-06-22	38000177		0	0	21		0	0	0	9801	0	310965	19078461		
25140	2069	1127078	1955-05-03	1955-05-03 00:00:00	1955-06-02	1955-06-02 00:00:00	1955-06-02	38000177		0	0	30		0	0	0	137584	0	282464	1127078		
33051	722	40213296	2009-12-08	2009-12-08 00:00:00	2009-12-08	2009-12-08 00:00:00	2009-12-08	581452		0	0	0		0	0	0	47789	0	52	40213296		
161034	3543	40213260	2010-01-05	2010-01-05 00:00:00	2010-01-05	2010-01-05 00:00:00	2010-01-05	581452		0	0	0		0	0	0	235365	0	121	40213260		
15124	1264	1124300	1987-12-14	1987-12-14 00:00:00	1987-12-14	1987-12-14 00:00:00	\N	38000177		0	0	0		0	0	0	83329	0	00781178901	45011828		
43577	3612	40229134	1982-06-24	1982-06-24 00:00:00	1982-07-08	1982-07-08 00:00:00	1982-07-08	38000177		0	0	14		0	0	0	239960	0	1043400	40229134		
15220	1271	1118084	2010-10-14	2010-10-14 00:00:00	2010-10-14	2010-10-14 00:00:00	\N	38000177		0	0	0		0	0	0	83838	0	00025152531	44923712		
46345	3839	1713671	1957-04-12	1957-04-12 00:00:00	1957-04-26	1957-04-26 00:00:00	1957-04-26	38000177		0	0	14		0	0	0	254910	0	562251	1713671		
14874	321	40213260	2012-02-12	2012-02-12 00:00:00	2012-02-12	2012-02-12 00:00:00	2012-02-12	581452		0	0	0		0	0	0	21300	0	121	40213260		
55240	4587	1332419	2003-07-12	2003-07-12 00:00:00	2003-07-12	2003-07-12 00:00:00	\N	38000177		0	0	0		0	0	0	305555	0	197361	1332419		
33659	2786	1127433	1987-11-05	1987-11-05 00:00:00	1987-12-03	1987-12-03 00:00:00	1987-12-03	38000177		0	0	28		0	0	0	184612	0	313782	1127433		
43844	3630	19133873	1965-05-30	1965-05-30 00:00:00	1965-06-07	1965-06-07 00:00:00	1965-06-07	38000177		0	0	8		0	0	0	241563	0	834061	19133873		
15933	1321	19006318	1962-10-14	1962-10-14 00:00:00	1962-10-28	1962-10-28 00:00:00	1962-10-28	38000177		0	0	14		0	0	0	87605	0	105078	19006318		
36421	3002	1713671	2011-12-27	2011-12-27 00:00:00	2012-01-10	2012-01-10 00:00:00	2012-01-10	38000177		0	0	14		0	0	0	200380	0	562251	1713671		
28151	2328	1127433	2007-10-04	2007-10-04 00:00:00	2007-10-18	2007-10-18 00:00:00	2007-10-18	38000177		0	0	14		0	0	0	154888	0	313782	1127433		
11073	923	19133873	1970-11-02	1970-11-02 00:00:00	1970-11-13	1970-11-13 00:00:00	1970-11-13	38000177		0	0	11		0	0	0	61472	0	834061	19133873		
21608	1776	35605858	1984-10-13	1984-10-13 00:00:00	1984-10-13	1984-10-13 00:00:00	1984-10-13	38000177		0	0	0		0	0	0	118804	0	1732136	35605858		
11451	954	19078461	2007-04-08	2007-04-08 00:00:00	2007-04-29	2007-04-29 00:00:00	2007-04-29	38000177		0	0	21		0	0	0	63419	0	310965	19078461		
21714	1782	1118084	1988-01-01	1988-01-01 00:00:00	1988-01-01	1988-01-01 00:00:00	\N	38000177		0	0	0		0	0	0	119346	0	00025152531	44923712		
36053	2969	1127078	1967-11-07	1967-11-07 00:00:00	1967-12-12	1967-12-12 00:00:00	1967-12-12	38000177		0	0	35		0	0	0	198243	0	282464	1127078		
5714	479	19006318	1957-04-13	1957-04-13 00:00:00	1957-04-27	1957-04-27 00:00:00	1957-04-27	38000177		0	0	14		0	0	0	31883	0	105078	19006318		
47762	3960	1118084	1997-05-21	1997-05-21 00:00:00	1997-05-21	1997-05-21 00:00:00	\N	38000177		0	0	0		0	0	0	263272	0	00025152531	44923712		
47791	3962	1127433	1963-10-13	1963-10-13 00:00:00	1963-10-20	1963-10-20 00:00:00	1963-10-20	38000177		0	0	7		0	0	0	263476	0	313782	1127433		
13399	1123	1127078	1968-09-08	1968-09-08 00:00:00	1968-09-22	1968-09-22 00:00:00	1968-09-22	38000177		0	0	14		0	0	0	74014	0	282464	1127078		
41006	3401	1124300	1997-08-02	1997-08-02 00:00:00	1997-08-02	1997-08-02 00:00:00	\N	38000177		0	0	0		0	0	0	225632	0	00781178901	45011828		
21106	1739	19078461	2011-09-28	2011-09-28 00:00:00	2011-10-19	2011-10-19 00:00:00	2011-10-19	38000177		0	0	21		0	0	0	116172	0	310965	19078461		
3180	262	1127078	1967-03-21	1967-03-21 00:00:00	1967-06-19	1967-06-19 00:00:00	1967-06-19	38000177		0	0	90		0	0	0	17354	0	282464	1127078		
3217	264	40165015	1969-10-25	1969-10-25 00:00:00	1969-10-25	1969-10-25 00:00:00	\N	38000177		0	0	0		0	0	0	17537	0	861467	40165015		
4386	364	1127433	2016-09-10	2016-09-10 00:00:00	2016-09-24	2016-09-24 00:00:00	2016-09-24	38000177		0	0	14		0	0	0	24135	0	313782	1127433		
19753	430	40213201	1997-06-28	1997-06-28 00:00:00	1997-06-28	1997-06-28 00:00:00	1997-06-28	581452		0	0	0		0	0	0	28511	0	33	40213201		
11578	964	19019979	1979-11-07	1979-11-07 00:00:00	1979-11-21	1979-11-21 00:00:00	1979-11-21	38000177		0	0	14		0	0	0	64186	0	198405	19019979		
6154	515	1127433	1976-11-13	1976-11-13 00:00:00	1976-12-20	1976-12-20 00:00:00	1976-12-20	38000177		0	0	37		0	0	0	34389	0	313782	1127433		
42801	933	40213296	2012-10-02	2012-10-02 00:00:00	2012-10-02	2012-10-02 00:00:00	2012-10-02	581452		0	0	0		0	0	0	62094	0	52	40213296		
233	17	40165015	1971-10-27	1971-10-27 00:00:00	1971-10-27	1971-10-27 00:00:00	\N	38000177		0	0	0		0	0	0	1373	0	861467	40165015		
36	2	40236824	1952-06-24	1952-06-24 00:00:00	1952-07-08	1952-07-08 00:00:00	1952-07-08	38000177		0	0	14		0	0	0	153	0	1094107	40236824		
17805	1475	19059056	1966-04-21	1966-04-21 00:00:00	1966-05-05	1966-05-05 00:00:00	1966-05-05	38000177		0	0	14		0	0	0	98250	0	243670	19059056		
7750	648	1127433	1944-03-16	1944-03-16 00:00:00	1944-03-30	1944-03-30 00:00:00	1944-03-30	38000177		0	0	14		0	0	0	42913	0	313782	1127433		
10658	885	1118084	2018-11-23	2018-11-23 00:00:00	2018-11-23	2018-11-23 00:00:00	\N	38000177		0	0	0		0	0	0	58979	0	00025152531	44923712		
36215	2985	1127433	1969-10-18	1969-10-18 00:00:00	1969-10-25	1969-10-25 00:00:00	1969-10-25	38000177		0	0	7		0	0	0	199249	0	313782	1127433		
43399	3598	19133905	1963-02-03	1963-02-03 00:00:00	1963-02-15	1963-02-15 00:00:00	1963-02-15	38000177		0	0	12		0	0	0	238928	0	834102	19133905		
59664	4960	40231925	1943-09-30	1943-09-30 00:00:00	1943-09-30	1943-09-30 00:00:00	\N	38000177		0	0	0		0	0	0	329706	0	1049221	40231925		
39021	3224	1127433	1983-01-18	1983-01-18 00:00:00	1983-02-01	1983-02-01 00:00:00	1983-02-01	38000177		0	0	14		0	0	0	214378	0	313782	1127433		
35517	775	40213227	2010-01-27	2010-01-27 00:00:00	2010-01-27	2010-01-27 00:00:00	2010-01-27	581452		0	0	0		0	0	0	51486	0	113	40213227		
27069	2232	19128065	1983-04-05	1983-04-05 00:00:00	1984-03-30	1984-03-30 00:00:00	1984-03-30	38000177		0	0	360		0	0	0	148494	0	749882	19128065		
102048	2237	40213201	1995-02-12	1995-02-12 00:00:00	1995-02-12	1995-02-12 00:00:00	1995-02-12	581452		0	0	0		0	0	0	148831	0	33	40213201		
30243	2507	1713671	2005-09-09	2005-09-09 00:00:00	2006-04-21	2006-04-21 00:00:00	2006-04-21	38000177		0	0	224		0	0	0	165965	0	562251	1713671		
42670	3536	40236824	2006-11-28	2006-11-28 00:00:00	2006-12-12	2006-12-12 00:00:00	2006-12-12	38000177		0	0	14		0	0	0	234843	0	1094107	40236824		
155107	3414	40213227	2008-08-28	2008-08-28 00:00:00	2008-08-28	2008-08-28 00:00:00	2008-08-28	581452		0	0	0		0	0	0	226472	0	113	40213227		
41178	3414	1127433	1985-03-05	1985-03-05 00:00:00	1985-03-12	1985-03-12 00:00:00	1985-03-12	38000177		0	0	7		0	0	0	226485	0	313782	1127433		
1898	152	1127433	2010-09-23	2010-09-23 00:00:00	2010-09-30	2010-09-30 00:00:00	2010-09-30	38000177		0	0	7		0	0	0	10268	0	313782	1127433		
61953	5152	1127433	1987-12-31	1987-12-31 00:00:00	1988-02-04	1988-02-04 00:00:00	1988-02-04	38000177		0	0	35		0	0	0	342593	0	313782	1127433		
53352	4435	1127433	2000-03-29	2000-03-29 00:00:00	2000-04-19	2000-04-19 00:00:00	2000-04-19	38000177		0	0	21		0	0	0	294823	0	313782	1127433		
63200	5251	19115351	1922-02-27	1922-02-27 00:00:00	1922-05-08	1922-05-08 00:00:00	1922-05-08	38000177		0	0	70		0	0	0	349386	0	563026	19115351		
20839	1718	1127078	1969-08-02	1969-08-02 00:00:00	1969-08-16	1969-08-16 00:00:00	1969-08-16	38000177		0	0	14		0	0	0	114867	0	282464	1127078		
8320	693	19006318	1951-11-28	1951-11-28 00:00:00	1951-12-12	1951-12-12 00:00:00	1951-12-12	38000177		0	0	14		0	0	0	45910	0	105078	19006318		
23110	1905	920300	2006-03-09	2006-03-09 00:00:00	2006-03-16	2006-03-16 00:00:00	2006-03-16	38000177		0	0	7		0	0	0	126817	0	311989	920300		
8380	700	43012754	1994-05-31	1994-05-31 00:00:00	1995-05-26	1995-05-26 00:00:00	1995-05-26	38000177		0	0	360		0	0	0	46269	0	1366343	43012754		
11654	970	1118084	1986-12-17	1986-12-17 00:00:00	1986-12-17	1986-12-17 00:00:00	\N	38000177		0	0	0		0	0	0	64540	0	00025152531	44923712		
20205	1658	1118084	1948-01-07	1948-01-07 00:00:00	1948-01-07	1948-01-07 00:00:00	\N	38000177		0	0	0		0	0	0	111322	0	00025152531	44923712		
36674	3026	1127078	1958-07-06	1958-07-06 00:00:00	1958-07-20	1958-07-20 00:00:00	1958-07-20	38000177		0	0	14		0	0	0	201779	0	282464	1127078		
30668	669	40213160	1970-06-10	1970-06-10 00:00:00	1970-06-10	1970-06-10 00:00:00	1970-06-10	581452		0	0	0		0	0	0	44185	0	10	40213160		
42155	3495	19128065	1982-05-28	1982-05-28 00:00:00	1983-05-23	1983-05-23 00:00:00	1983-05-23	38000177		0	0	360		0	0	0	231798	0	749882	19128065		
14518	1216	19133873	1971-03-22	1971-03-22 00:00:00	1971-04-01	1971-04-01 00:00:00	1971-04-01	38000177		0	0	10		0	0	0	80096	0	834061	19133873		
15190	328	40213314	1980-01-06	1980-01-06 00:00:00	1980-01-06	1980-01-06 00:00:00	1980-01-06	581452		0	0	0		0	0	0	21646	0	49	40213314		
1810	145	1124300	1990-10-06	1990-10-06 00:00:00	1990-10-06	1990-10-06 00:00:00	\N	38000177		0	0	0		0	0	0	9746	0	00781178901	45011828		
25141	2069	19133873	1965-09-18	1965-09-18 00:00:00	1965-09-30	1965-09-30 00:00:00	1965-09-30	38000177		0	0	12		0	0	0	137615	0	834061	19133873		
33055	722	40213260	2019-02-12	2019-02-12 00:00:00	2019-02-12	2019-02-12 00:00:00	2019-02-12	581452		0	0	0		0	0	0	47761	0	121	40213260		
161041	3543	40213296	1998-07-21	1998-07-21 00:00:00	1998-07-21	1998-07-21 00:00:00	1998-07-21	581452		0	0	0		0	0	0	235387	0	52	40213296		
15125	1264	1127433	1974-04-13	1974-04-13 00:00:00	1974-04-27	1974-04-27 00:00:00	1974-04-27	38000177		0	0	14		0	0	0	83313	0	313782	1127433		
43578	3612	920334	2008-07-04	2008-07-04 00:00:00	2008-07-11	2008-07-11 00:00:00	2008-07-11	38000177		0	0	7		0	0	0	239962	0	311995	920334		
15221	1271	40229134	1968-09-01	1968-09-01 00:00:00	1968-09-15	1968-09-15 00:00:00	1968-09-15	38000177		0	0	14		0	0	0	83804	0	1043400	40229134		
46346	3839	1127433	2012-05-26	2012-05-26 00:00:00	2012-08-24	2012-08-24 00:00:00	2012-08-24	38000177		0	0	90		0	0	0	254863	0	313782	1127433		
14880	321	40213160	1966-10-23	1966-10-23 00:00:00	1966-10-23	1966-10-23 00:00:00	1966-10-23	581452		0	0	0		0	0	0	21262	0	10	40213160		
55241	4587	19126352	2003-07-12	2003-07-12 00:00:00	2003-07-12	2003-07-12 00:00:00	\N	38000177		0	0	0		0	0	0	305555	0	705129	19126352		
33660	2786	19059056	1947-01-26	1947-01-26 00:00:00	1947-02-09	1947-02-09 00:00:00	1947-02-09	38000177		0	0	14		0	0	0	184638	0	243670	19059056		
43845	3630	1127433	1986-06-29	1986-06-29 00:00:00	1986-07-13	1986-07-13 00:00:00	1986-07-13	38000177		0	0	14		0	0	0	241556	0	313782	1127433		
15934	1321	1713671	1965-02-21	1965-02-21 00:00:00	1965-03-14	1965-03-14 00:00:00	1965-03-14	38000177		0	0	21		0	0	0	87656	0	562251	1713671		
36422	3002	46233988	1975-04-07	1975-04-07 00:00:00	1975-04-15	1975-04-15 00:00:00	1975-04-15	38000177		0	0	8		0	0	0	200349	0	1652673	46233988		
28152	2328	19133873	1960-12-26	1960-12-26 00:00:00	1961-01-04	1961-01-04 00:00:00	1961-01-04	38000177		0	0	9		0	0	0	154813	0	834061	19133873		
11074	923	1127433	1968-07-23	1968-07-23 00:00:00	1968-08-06	1968-08-06 00:00:00	1968-08-06	38000177		0	0	14		0	0	0	61471	0	313782	1127433		
21609	1776	782047	1984-10-13	1984-10-13 00:00:00	1984-10-13	1984-10-13 00:00:00	1984-10-13	38000177		0	0	0		0	0	0	118804	0	542347	782047		
11452	954	19078461	1997-11-28	1997-11-28 00:00:00	1997-12-26	1997-12-26 00:00:00	1997-12-26	38000177		0	0	28		0	0	0	63418	0	310965	19078461		
74119	1618	40213296	2013-05-22	2013-05-22 00:00:00	2013-05-22	2013-05-22 00:00:00	2013-05-22	581452		0	0	0		0	0	0	108811	0	52	40213296		
36054	2970	1713671	2008-11-25	2008-11-25 00:00:00	2008-12-02	2008-12-02 00:00:00	2008-12-02	38000177		0	0	7		0	0	0	198387	0	562251	1713671		
5715	479	40229134	1944-02-29	1944-02-29 00:00:00	1944-03-14	1944-03-14 00:00:00	1944-03-14	38000177		0	0	14		0	0	0	31904	0	1043400	40229134		
47763	3960	19133905	1980-04-23	1980-04-23 00:00:00	1980-05-06	1980-05-06 00:00:00	1980-05-06	38000177		0	0	13		0	0	0	263258	0	834102	19133905		
47792	3962	1118084	1989-11-24	1989-11-24 00:00:00	1989-11-24	1989-11-24 00:00:00	\N	38000177		0	0	0		0	0	0	263440	0	00025152531	44923712		
13400	1123	46233988	1968-09-08	1968-09-08 00:00:00	1968-09-22	1968-09-22 00:00:00	1968-09-22	38000177		0	0	14		0	0	0	74014	0	1652673	46233988		
41007	3401	1127433	1994-07-21	1994-07-21 00:00:00	1994-08-04	1994-08-04 00:00:00	1994-08-04	38000177		0	0	14		0	0	0	225624	0	313782	1127433		
21107	1739	1115171	1997-03-15	1997-03-15 00:00:00	1997-06-13	1997-06-13 00:00:00	1997-06-13	38000177		0	0	90		0	0	0	116171	0	849574	1115171		
3181	262	1118084	1999-12-13	1999-12-13 00:00:00	1999-12-13	1999-12-13 00:00:00	\N	38000177		0	0	0		0	0	0	17358	0	00025152531	44923712		
3218	264	40229134	2010-11-12	2010-11-12 00:00:00	2010-11-26	2010-11-26 00:00:00	2010-11-26	38000177		0	0	14		0	0	0	17567	0	1043400	40229134		
4387	364	1713671	1975-04-22	1975-04-22 00:00:00	1975-04-29	1975-04-29 00:00:00	1975-04-29	38000177		0	0	7		0	0	0	24218	0	562251	1713671		
19758	430	40213227	1993-06-05	1993-06-05 00:00:00	1993-06-05	1993-06-05 00:00:00	1993-06-05	581452		0	0	0		0	0	0	28534	0	113	40213227		
11579	964	19074843	1979-11-07	1979-11-07 00:00:00	1979-11-21	1979-11-21 00:00:00	1979-11-21	38000177		0	0	14		0	0	0	64186	0	309045	19074843		
6155	515	40220960	2014-05-24	2014-05-24 00:00:00	2014-05-24	2014-05-24 00:00:00	2014-05-24	38000177		0	0	0		0	0	0	34401	0	1804799	40220960		
42805	933	40213227	1994-11-29	1994-11-29 00:00:00	1994-11-29	1994-11-29 00:00:00	1994-11-29	581452		0	0	0		0	0	0	62102	0	113	40213227		
234	17	19078461	2012-01-19	2012-01-19 00:00:00	2012-02-02	2012-02-02 00:00:00	2012-02-02	38000177		0	0	14		0	0	0	1376	0	310965	19078461		
37	2	920300	1952-06-24	1952-06-24 00:00:00	1952-07-01	1952-07-01 00:00:00	1952-07-01	38000177		0	0	7		0	0	0	153	0	311989	920300		
17806	1475	19059056	1951-02-25	1951-02-25 00:00:00	1951-04-26	1951-04-26 00:00:00	1951-04-26	38000177		0	0	60		0	0	0	98248	0	243670	19059056		
7751	648	1127433	1937-02-19	1937-02-19 00:00:00	1937-03-05	1937-03-05 00:00:00	1937-03-05	38000177		0	0	14		0	0	0	42947	0	313782	1127433		
10659	885	1127433	1993-12-10	1993-12-10 00:00:00	1993-12-24	1993-12-24 00:00:00	1993-12-24	38000177		0	0	14		0	0	0	59040	0	313782	1127433		
36216	2985	19129655	1967-06-21	1967-06-21 00:00:00	1967-07-05	1967-07-05 00:00:00	1967-07-05	38000177		0	0	14		0	0	0	199221	0	789980	19129655		
43400	3598	19133905	1980-09-10	1980-09-10 00:00:00	1980-09-21	1980-09-21 00:00:00	1980-09-21	38000177		0	0	11		0	0	0	238925	0	834102	19133905		
59665	4960	1127433	1989-12-21	1989-12-21 00:00:00	1990-03-21	1990-03-21 00:00:00	1990-03-21	38000177		0	0	90		0	0	0	329712	0	313782	1127433		
39022	3224	40174880	2016-12-31	2016-12-31 00:00:00	2016-12-31	2016-12-31 00:00:00	\N	38000177		0	0	0		0	0	0	214381	0	966222	40174880		
35522	775	40213227	1999-12-01	1999-12-01 00:00:00	1999-12-01	1999-12-01 00:00:00	1999-12-01	581452		0	0	0		0	0	0	51502	0	113	40213227		
27070	2232	1127433	1999-07-18	1999-07-18 00:00:00	1999-08-01	1999-08-01 00:00:00	1999-08-01	38000177		0	0	14		0	0	0	148521	0	313782	1127433		
97331	2134	40213160	1955-04-24	1955-04-24 00:00:00	1955-04-24	1955-04-24 00:00:00	1955-04-24	581452		0	0	0		0	0	0	142030	0	10	40213160		
30244	2507	19128065	1984-04-12	1984-04-12 00:00:00	1985-04-07	1985-04-07 00:00:00	1985-04-07	38000177		0	0	360		0	0	0	165968	0	749882	19128065		
42671	3537	19112599	1963-07-16	1963-07-16 00:00:00	1963-07-16	1963-07-16 00:00:00	\N	38000177		0	0	0		0	0	0	234895	0	477045	19112599		
155113	3414	40213160	1967-12-07	1967-12-07 00:00:00	1967-12-07	1967-12-07 00:00:00	1967-12-07	581452		0	0	0		0	0	0	226478	0	10	40213160		
41179	3414	40229134	1969-08-17	1969-08-17 00:00:00	1969-08-31	1969-08-31 00:00:00	1969-08-31	38000177		0	0	14		0	0	0	226446	0	1043400	40229134		
1899	152	782047	1973-12-15	1973-12-15 00:00:00	1973-12-15	1973-12-15 00:00:00	1973-12-15	38000177		0	0	0		0	0	0	10291	0	542347	782047		
61954	5152	1118084	2012-05-13	2012-05-13 00:00:00	2012-05-13	2012-05-13 00:00:00	\N	38000177		0	0	0		0	0	0	342599	0	00025152531	44923712		
53353	4435	1118084	2000-10-14	2000-10-14 00:00:00	2000-10-14	2000-10-14 00:00:00	\N	38000177		0	0	0		0	0	0	294819	0	00025152531	44923712		
63201	5251	19059056	1935-11-05	1935-11-05 00:00:00	1935-11-19	1935-11-19 00:00:00	1935-11-19	38000177		0	0	14		0	0	0	349384	0	243670	19059056		
20840	1718	40229134	1991-10-27	1991-10-27 00:00:00	1991-11-03	1991-11-03 00:00:00	1991-11-03	38000177		0	0	7		0	0	0	114851	0	1043400	40229134		
8321	693	19059056	1968-09-16	1968-09-16 00:00:00	1968-11-15	1968-11-15 00:00:00	1968-11-15	38000177		0	0	60		0	0	0	45891	0	243670	19059056		
23111	1905	40236824	2006-03-09	2006-03-09 00:00:00	2006-03-16	2006-03-16 00:00:00	2006-03-16	38000177		0	0	7		0	0	0	126817	0	1094107	40236824		
8381	700	1713671	1998-08-29	1998-08-29 00:00:00	1998-09-05	1998-09-05 00:00:00	1998-09-05	38000177		0	0	7		0	0	0	46287	0	562251	1713671		
11655	970	19133873	1965-01-11	1965-01-11 00:00:00	1965-01-20	1965-01-20 00:00:00	1965-01-20	38000177		0	0	9		0	0	0	64518	0	834061	19133873		
20206	1658	1127433	1982-01-12	1982-01-12 00:00:00	1982-01-26	1982-01-26 00:00:00	1982-01-26	38000177		0	0	14		0	0	0	111391	0	313782	1127433		
36675	3026	19133905	2004-08-09	2004-08-09 00:00:00	2004-08-21	2004-08-21 00:00:00	2004-08-21	38000177		0	0	12		0	0	0	201777	0	834102	19133905		
30678	669	40213296	2012-11-07	2012-11-07 00:00:00	2012-11-07	2012-11-07 00:00:00	2012-11-07	581452		0	0	0		0	0	0	44163	0	52	40213296		
42156	3495	1127078	1966-04-12	1966-04-12 00:00:00	1966-04-26	1966-04-26 00:00:00	1966-04-26	38000177		0	0	14		0	0	0	231797	0	282464	1127078		
14519	1216	920334	1988-09-03	1988-09-03 00:00:00	1988-09-10	1988-09-10 00:00:00	1988-09-10	38000177		0	0	7		0	0	0	80098	0	311995	920334		
15194	328	40213160	1979-02-04	1979-02-04 00:00:00	1979-02-04	1979-02-04 00:00:00	1979-02-04	581452		0	0	0		0	0	0	21652	0	10	40213160		
1811	145	40169216	1952-12-06	1952-12-06 00:00:00	1952-12-06	1952-12-06 00:00:00	\N	38000177		0	0	0		0	0	0	9764	0	895994	40169216		
25142	2070	19128065	1978-10-23	1978-10-23 00:00:00	1979-10-18	1979-10-18 00:00:00	1979-10-18	38000177		0	0	360		0	0	0	137735	0	749882	19128065		
33057	722	40213306	1990-05-29	1990-05-29 00:00:00	1990-05-29	1990-05-29 00:00:00	1990-05-29	581452		0	0	0		0	0	0	47786	0	43	40213306		
161044	3543	40213296	2000-07-25	2000-07-25 00:00:00	2000-07-25	2000-07-25 00:00:00	2000-07-25	581452		0	0	0		0	0	0	235364	0	52	40213296		
15126	1264	1127433	2014-05-03	2014-05-03 00:00:00	2014-05-17	2014-05-17 00:00:00	2014-05-17	38000177		0	0	14		0	0	0	83330	0	313782	1127433		
43579	3612	920300	2007-05-06	2007-05-06 00:00:00	2007-05-13	2007-05-13 00:00:00	2007-05-13	38000177		0	0	7		0	0	0	239957	0	311989	920300		
15222	1271	19128065	1981-12-30	1981-12-30 00:00:00	1982-12-25	1982-12-25 00:00:00	1982-12-25	38000177		0	0	360		0	0	0	83844	0	749882	19128065		
15223	1271	19059056	1969-10-24	1969-10-24 00:00:00	1969-11-07	1969-11-07 00:00:00	1969-11-07	38000177		0	0	14		0	0	0	83819	0	243670	19059056		
14882	321	40213306	1984-01-15	1984-01-15 00:00:00	1984-01-15	1984-01-15 00:00:00	1984-01-15	581452		0	0	0		0	0	0	21332	0	43	40213306		
55242	4587	40220960	2017-11-18	2017-11-18 00:00:00	2017-11-18	2017-11-18 00:00:00	2017-11-18	38000177		0	0	0		0	0	0	305610	0	1804799	40220960		
33661	2786	19006318	1947-01-26	1947-01-26 00:00:00	1947-02-09	1947-02-09 00:00:00	1947-02-09	38000177		0	0	14		0	0	0	184638	0	105078	19006318		
43846	3630	1127433	1964-06-25	1964-06-25 00:00:00	1964-07-09	1964-07-09 00:00:00	1964-07-09	38000177		0	0	14		0	0	0	241571	0	313782	1127433		
15935	1322	1713671	1949-08-04	1949-08-04 00:00:00	1949-08-18	1949-08-18 00:00:00	1949-08-18	38000177		0	0	14		0	0	0	87736	0	562251	1713671		
36423	3002	40229134	2014-11-27	2014-11-27 00:00:00	2014-12-11	2014-12-11 00:00:00	2014-12-11	38000177		0	0	14		0	0	0	200348	0	1043400	40229134		
28153	2328	19133905	2016-07-08	2016-07-08 00:00:00	2016-07-19	2016-07-19 00:00:00	2016-07-19	38000177		0	0	11		0	0	0	154871	0	834102	19133905		
11075	923	1713671	2010-05-24	2010-05-24 00:00:00	2010-06-07	2010-06-07 00:00:00	2010-06-07	38000177		0	0	14		0	0	0	61434	0	562251	1713671		
21610	1776	40165015	1984-10-14	1984-10-14 00:00:00	1984-10-14	1984-10-14 00:00:00	\N	38000177		0	0	0		0	0	0	118804	0	861467	40165015		
11453	954	19019979	1976-03-04	1976-03-04 00:00:00	1976-03-26	1976-03-26 00:00:00	1976-03-26	38000177		0	0	22		0	0	0	63395	0	198405	19019979		
74123	1618	40213314	1977-04-20	1977-04-20 00:00:00	1977-04-20	1977-04-20 00:00:00	1977-04-20	581452		0	0	0		0	0	0	108779	0	49	40213314		
36055	2970	19133873	1980-01-31	1980-01-31 00:00:00	1980-02-11	1980-02-11 00:00:00	1980-02-11	38000177		0	0	11		0	0	0	198305	0	834061	19133873		
5716	479	1127433	1964-03-23	1964-03-23 00:00:00	1964-04-06	1964-04-06 00:00:00	1964-04-06	38000177		0	0	14		0	0	0	31877	0	313782	1127433		
47764	3960	19006318	1958-04-16	1958-04-16 00:00:00	1958-04-30	1958-04-30 00:00:00	1958-04-30	38000177		0	0	14		0	0	0	263303	0	105078	19006318		
47793	3962	1127433	1969-02-22	1969-02-22 00:00:00	1969-03-08	1969-03-08 00:00:00	1969-03-08	38000177		0	0	14		0	0	0	263447	0	313782	1127433		
13401	1123	19019979	1974-11-06	1974-11-06 00:00:00	1974-11-27	1974-11-27 00:00:00	1974-11-27	38000177		0	0	21		0	0	0	73968	0	198405	19019979		
41008	3401	1115171	1995-05-31	1995-05-31 00:00:00	1995-06-28	1995-06-28 00:00:00	1995-06-28	38000177		0	0	28		0	0	0	225625	0	849574	1115171		
21108	1739	1118084	2009-04-26	2009-04-26 00:00:00	2009-04-26	2009-04-26 00:00:00	\N	38000177		0	0	0		0	0	0	116198	0	00025152531	44923712		
3182	262	19133873	1974-10-24	1974-10-24 00:00:00	1974-11-01	1974-11-01 00:00:00	1974-11-01	38000177		0	0	8		0	0	0	17413	0	834061	19133873		
3219	264	1713671	1977-01-27	1977-01-27 00:00:00	1977-02-17	1977-02-17 00:00:00	1977-02-17	38000177		0	0	21		0	0	0	17592	0	562251	1713671		
4388	364	19078461	1991-08-21	1991-08-21 00:00:00	1991-09-04	1991-09-04 00:00:00	1991-09-04	38000177		0	0	14		0	0	0	24211	0	310965	19078461		
42290	921	40213260	2017-06-27	2017-06-27 00:00:00	2017-06-27	2017-06-27 00:00:00	2017-06-27	581452		0	0	0		0	0	0	61382	0	121	40213260		
11580	964	1124300	2012-08-15	2012-08-15 00:00:00	2012-08-15	2012-08-15 00:00:00	\N	38000177		0	0	0		0	0	0	64164	0	00781178901	45011828		
6156	515	40162522	1976-11-20	1976-11-20 00:00:00	1976-11-20	1976-11-20 00:00:00	\N	38000177		0	0	0		0	0	0	34393	0	857005	40162522		
42806	933	40213306	1994-11-29	1994-11-29 00:00:00	1994-11-29	1994-11-29 00:00:00	1994-11-29	581452		0	0	0		0	0	0	62102	0	43	40213306		
235	17	19059056	1958-11-29	1958-11-29 00:00:00	1959-01-28	1959-01-28 00:00:00	1959-01-28	38000177		0	0	60		0	0	0	1377	0	243670	19059056		
38	2	40223774	2002-10-13	2002-10-13 00:00:00	2002-10-13	2002-10-13 00:00:00	\N	38000177		0	0	0		0	0	0	144	0	998582	40223774		
17807	1475	40165015	1951-02-25	1951-02-25 00:00:00	1951-02-25	1951-02-25 00:00:00	\N	38000177		0	0	0		0	0	0	98248	0	861467	40165015		
7752	648	1115171	2000-02-03	2000-02-03 00:00:00	2000-03-04	2000-03-04 00:00:00	2000-03-04	38000177		0	0	30		0	0	0	42965	0	849574	1115171		
10660	885	19073188	1993-12-10	1993-12-10 00:00:00	1993-12-24	1993-12-24 00:00:00	1993-12-24	38000177		0	0	14		0	0	0	59040	0	308192	19073188		
36217	2985	1127078	1967-06-21	1967-06-21 00:00:00	1967-07-05	1967-07-05 00:00:00	1967-07-05	38000177		0	0	14		0	0	0	199221	0	282464	1127078		
43401	3598	19133768	2014-12-14	2014-12-14 00:00:00	2014-12-14	2014-12-14 00:00:00	2014-12-14	38000177		0	0	0		0	0	0	238946	0	833036	19133768		
59666	4960	19059056	1935-01-01	1935-01-01 00:00:00	1935-01-15	1935-01-15 00:00:00	1935-01-15	38000177		0	0	14		0	0	0	329705	0	243670	19059056		
39033	3226	19078461	2008-05-26	2008-05-26 00:00:00	2008-06-16	2008-06-16 00:00:00	2008-06-16	38000177		0	0	21		0	0	0	214451	0	310965	19078461		
35525	775	40213201	2004-12-29	2004-12-29 00:00:00	2004-12-29	2004-12-29 00:00:00	2004-12-29	581452		0	0	0		0	0	0	51474	0	33	40213201		
27071	2232	19128065	1977-05-06	1977-05-06 00:00:00	1978-05-01	1978-05-01 00:00:00	1978-05-01	38000177		0	0	360		0	0	0	148524	0	749882	19128065		
97336	2134	40213227	2010-11-14	2010-11-14 00:00:00	2010-11-14	2010-11-14 00:00:00	2010-11-14	581452		0	0	0		0	0	0	141954	0	113	40213227		
30245	2507	1127433	1979-08-27	1979-08-27 00:00:00	1979-09-17	1979-09-17 00:00:00	1979-09-17	38000177		0	0	21		0	0	0	165952	0	313782	1127433		
42672	3537	1713671	1987-03-24	1987-03-24 00:00:00	1987-04-14	1987-04-14 00:00:00	1987-04-14	38000177		0	0	21		0	0	0	234969	0	562251	1713671		
155117	3414	40213160	1972-03-02	1972-03-02 00:00:00	1972-03-02	1972-03-02 00:00:00	1972-03-02	581452		0	0	0		0	0	0	226441	0	10	40213160		
41180	3414	1127433	2013-10-27	2013-10-27 00:00:00	2013-11-10	2013-11-10 00:00:00	2013-11-10	38000177		0	0	14		0	0	0	226476	0	313782	1127433		
1900	152	19078924	1973-12-15	1973-12-15 00:00:00	1973-12-15	1973-12-15 00:00:00	1973-12-15	38000177		0	0	0		0	0	0	10291	0	311700	19078924		
61955	5152	1127433	2002-09-18	2002-09-18 00:00:00	2002-10-09	2002-10-09 00:00:00	2002-10-09	38000177		0	0	21		0	0	0	342594	0	313782	1127433		
53354	4435	19133873	1976-08-26	1976-08-26 00:00:00	1976-09-08	1976-09-08 00:00:00	1976-09-08	38000177		0	0	13		0	0	0	294758	0	834061	19133873		
63202	5252	19059056	1973-09-10	1973-09-10 00:00:00	1973-09-24	1973-09-24 00:00:00	1973-09-24	38000177		0	0	14		0	0	0	349399	0	243670	19059056		
20841	1719	40229134	2015-01-28	2015-01-28 00:00:00	2015-02-04	2015-02-04 00:00:00	2015-02-04	38000177		0	0	7		0	0	0	114962	0	1043400	40229134		
8322	693	1127433	1965-05-20	1965-05-20 00:00:00	1965-05-27	1965-05-27 00:00:00	1965-05-27	38000177		0	0	7		0	0	0	45885	0	313782	1127433		
23112	1905	1127433	2003-11-28	2003-11-28 00:00:00	2003-12-05	2003-12-05 00:00:00	2003-12-05	38000177		0	0	7		0	0	0	126807	0	313782	1127433		
8382	700	1713671	2004-12-16	2004-12-16 00:00:00	2004-12-30	2004-12-30 00:00:00	2004-12-30	38000177		0	0	14		0	0	0	46289	0	562251	1713671		
11656	970	19133873	1960-05-11	1960-05-11 00:00:00	1960-05-23	1960-05-23 00:00:00	1960-05-23	38000177		0	0	12		0	0	0	64517	0	834061	19133873		
20207	1658	1127433	1974-10-12	1974-10-12 00:00:00	1974-10-19	1974-10-19 00:00:00	1974-10-19	38000177		0	0	7		0	0	0	111357	0	313782	1127433		
36676	3026	19078461	1980-05-11	1980-05-11 00:00:00	1980-05-25	1980-05-25 00:00:00	1980-05-25	38000177		0	0	14		0	0	0	201792	0	310965	19078461		
30680	669	40213306	1991-12-04	1991-12-04 00:00:00	1991-12-04	1991-12-04 00:00:00	1991-12-04	581452		0	0	0		0	0	0	44187	0	43	40213306		
42157	3495	19006318	1966-04-12	1966-04-12 00:00:00	1966-04-26	1966-04-26 00:00:00	1966-04-26	38000177		0	0	14		0	0	0	231797	0	105078	19006318		
14520	1216	1713671	1997-04-12	1997-04-12 00:00:00	1997-04-19	1997-04-19 00:00:00	1997-04-19	38000177		0	0	7		0	0	0	80090	0	562251	1713671		
15195	328	40213314	1979-02-04	1979-02-04 00:00:00	1979-02-04	1979-02-04 00:00:00	1979-02-04	581452		0	0	0		0	0	0	21652	0	49	40213314		
1812	145	1154615	1952-12-06	1952-12-06 00:00:00	1952-12-06	1952-12-06 00:00:00	\N	38000177		0	0	0		0	0	0	9764	0	745679	1154615		
25143	2070	40232448	1969-11-15	1969-11-15 00:00:00	1969-11-15	1969-11-15 00:00:00	\N	38000177		0	0	0		0	0	0	137741	0	1049630	40232448		
134554	2953	40213227	2005-02-11	2005-02-11 00:00:00	2005-02-11	2005-02-11 00:00:00	2005-02-11	581452		0	0	0		0	0	0	197156	0	113	40213227		
161046	3543	40213227	2000-07-25	2000-07-25 00:00:00	2000-07-25	2000-07-25 00:00:00	2000-07-25	581452		0	0	0		0	0	0	235364	0	113	40213227		
15127	1264	40169281	1988-01-08	1988-01-08 00:00:00	1988-01-08	1988-01-08 00:00:00	\N	38000177		0	0	0		0	0	0	83310	0	896209	40169281		
43580	3612	40236824	2007-05-06	2007-05-06 00:00:00	2007-05-13	2007-05-13 00:00:00	2007-05-13	38000177		0	0	7		0	0	0	239957	0	1094107	40236824		
38054	830	40213227	2009-12-02	2009-12-02 00:00:00	2009-12-02	2009-12-02 00:00:00	2009-12-02	581452		0	0	0		0	0	0	54981	0	113	40213227		
15224	1271	1127433	1986-02-10	1986-02-10 00:00:00	1986-02-17	1986-02-17 00:00:00	1986-02-17	38000177		0	0	7		0	0	0	83805	0	313782	1127433		
14884	321	40213296	2005-01-23	2005-01-23 00:00:00	2005-01-23	2005-01-23 00:00:00	2005-01-23	581452		0	0	0		0	0	0	21286	0	52	40213296		
55243	4587	1127433	1967-02-25	1967-02-25 00:00:00	1967-03-04	1967-03-04 00:00:00	1967-03-04	38000177		0	0	7		0	0	0	305609	0	313782	1127433		
33662	2786	1115171	2004-01-08	2004-01-08 00:00:00	2004-02-24	2004-02-24 00:00:00	2004-02-24	38000177		0	0	47		0	0	0	184614	0	849574	1115171		
43847	3630	19078461	2009-02-12	2009-02-12 00:00:00	2009-03-14	2009-03-14 00:00:00	2009-03-14	38000177		0	0	30		0	0	0	241557	0	310965	19078461		
15936	1322	40229134	1957-02-07	1957-02-07 00:00:00	1957-02-14	1957-02-14 00:00:00	1957-02-14	38000177		0	0	7		0	0	0	87741	0	1043400	40229134		
36424	3002	1127078	1981-12-09	1981-12-09 00:00:00	1982-01-13	1982-01-13 00:00:00	1982-01-13	38000177		0	0	35		0	0	0	200334	0	282464	1127078		
28154	2328	40229134	1972-05-15	1972-05-15 00:00:00	1972-05-22	1972-05-22 00:00:00	1972-05-22	38000177		0	0	7		0	0	0	154815	0	1043400	40229134		
11076	923	1124300	1995-02-26	1995-02-26 00:00:00	1995-02-26	1995-02-26 00:00:00	\N	38000177		0	0	0		0	0	0	61446	0	00781178901	45011828		
21611	1776	35605482	1984-10-13	1984-10-13 00:00:00	1984-10-13	1984-10-13 00:00:00	1984-10-13	38000177		0	0	0		0	0	0	118804	0	1740467	35605482		
11454	954	1124300	2015-12-15	2015-12-15 00:00:00	2015-12-15	2015-12-15 00:00:00	\N	38000177		0	0	0		0	0	0	63415	0	00781178901	45011828		
74126	1618	40213160	1973-10-24	1973-10-24 00:00:00	1973-10-24	1973-10-24 00:00:00	1973-10-24	581452		0	0	0		0	0	0	108815	0	10	40213160		
36056	2970	1127433	1981-02-23	1981-02-23 00:00:00	1981-03-02	1981-03-02 00:00:00	1981-03-02	38000177		0	0	7		0	0	0	198317	0	313782	1127433		
5717	479	1127433	2018-09-21	2018-09-21 00:00:00	2018-10-05	2018-10-05 00:00:00	2018-10-05	38000177		0	0	14		0	0	0	31908	0	313782	1127433		
47765	3960	19059056	1958-04-16	1958-04-16 00:00:00	1958-04-30	1958-04-30 00:00:00	1958-04-30	38000177		0	0	14		0	0	0	263303	0	243670	19059056		
47794	3962	1115171	1999-09-08	1999-09-08 00:00:00	1999-10-13	1999-10-13 00:00:00	1999-10-13	38000177		0	0	35		0	0	0	263464	0	849574	1115171		
13403	1123	1713671	1994-06-22	1994-06-22 00:00:00	1994-06-29	1994-06-29 00:00:00	1994-06-29	38000177		0	0	7		0	0	0	74012	0	562251	1713671		
41009	3401	1713671	1960-12-16	1960-12-16 00:00:00	1960-12-23	1960-12-23 00:00:00	1960-12-23	38000177		0	0	7		0	0	0	225592	0	562251	1713671		
21109	1739	1713671	1970-11-17	1970-11-17 00:00:00	1970-11-24	1970-11-24 00:00:00	1970-11-24	38000177		0	0	7		0	0	0	116215	0	562251	1713671		
3183	262	1713671	1980-10-16	1980-10-16 00:00:00	1980-11-06	1980-11-06 00:00:00	1980-11-06	38000177		0	0	21		0	0	0	17406	0	562251	1713671		
3220	264	19126352	2005-09-02	2005-09-02 00:00:00	2011-11-11	2011-11-11 00:00:00	2011-11-11	38000177		0	0	2261		0	0	0	17530	0	705129	19126352		
4389	364	1713671	1986-12-05	1986-12-05 00:00:00	1986-12-12	1986-12-12 00:00:00	1986-12-12	38000177		0	0	7		0	0	0	24200	0	562251	1713671		
42291	921	40213227	2017-06-27	2017-06-27 00:00:00	2017-06-27	2017-06-27 00:00:00	2017-06-27	581452		0	0	0		0	0	0	61382	0	113	40213227		
11595	967	1127433	1984-08-01	1984-08-01 00:00:00	1984-08-08	1984-08-08 00:00:00	1984-08-08	38000177		0	0	7		0	0	0	64303	0	313782	1127433		
6157	515	19075601	1997-11-29	1997-11-29 00:00:00	2014-05-24	2014-05-24 00:00:00	2014-05-24	38000177		0	0	6020		0	0	0	34345	0	309362	19075601		
42810	933	40213160	1973-06-05	1973-06-05 00:00:00	1973-06-05	1973-06-05 00:00:00	1973-06-05	581452		0	0	0		0	0	0	62066	0	10	40213160		
236	17	19074679	1967-11-06	1967-11-06 00:00:00	1968-05-27	1968-05-27 00:00:00	1968-05-27	38000177		0	0	203		0	0	0	1346	0	308971	19074679		
39	2	40169281	1990-10-02	1990-10-02 00:00:00	1990-10-02	1990-10-02 00:00:00	\N	38000177		0	0	0		0	0	0	195	0	896209	40169281		
17808	1475	1127433	2000-01-09	2000-01-09 00:00:00	2000-01-23	2000-01-23 00:00:00	2000-01-23	38000177		0	0	14		0	0	0	98275	0	313782	1127433		
12653	273	40213160	1980-08-24	1980-08-24 00:00:00	1980-08-24	1980-08-24 00:00:00	1980-08-24	581452		0	0	0		0	0	0	18252	0	10	40213160		
10661	886	1127078	1985-09-21	1985-09-21 00:00:00	1985-10-05	1985-10-05 00:00:00	1985-10-05	38000177		0	0	14		0	0	0	59096	0	282464	1127078		
36218	2985	19078461	2008-12-17	2008-12-17 00:00:00	2009-01-21	2009-01-21 00:00:00	2009-01-21	38000177		0	0	35		0	0	0	199191	0	310965	19078461		
43402	3598	1545959	2014-12-14	2014-12-14 00:00:00	2014-12-14	2014-12-14 00:00:00	2014-12-14	38000177		0	0	0		0	0	0	238946	0	259255	1545959		
59667	4960	40174880	1977-03-31	1977-03-31 00:00:00	1977-03-31	1977-03-31 00:00:00	\N	38000177		0	0	0		0	0	0	329696	0	966222	40174880		
39034	3226	19059056	1971-02-23	1971-02-23 00:00:00	1971-03-09	1971-03-09 00:00:00	1971-03-09	38000177		0	0	14		0	0	0	214497	0	243670	19059056		
30199	2503	19112599	1978-03-12	1978-03-12 00:00:00	1978-03-12	1978-03-12 00:00:00	\N	38000177		0	0	0		0	0	0	165710	0	477045	19112599		
27072	2232	1127433	1979-03-18	1979-03-18 00:00:00	1979-03-25	1979-03-25 00:00:00	1979-03-25	38000177		0	0	7		0	0	0	148505	0	313782	1127433		
97339	2134	40213227	2000-09-17	2000-09-17 00:00:00	2000-09-17	2000-09-17 00:00:00	2000-09-17	581452		0	0	0		0	0	0	142037	0	113	40213227		
30246	2507	19128065	1981-04-28	1981-04-28 00:00:00	1982-04-23	1982-04-23 00:00:00	1982-04-23	38000177		0	0	360		0	0	0	165978	0	749882	19128065		
42673	3537	19059056	1966-01-30	1966-01-30 00:00:00	1966-02-20	1966-02-20 00:00:00	1966-02-20	38000177		0	0	21		0	0	0	234982	0	243670	19059056		
155120	3414	40213160	1967-07-06	1967-07-06 00:00:00	1967-07-06	1967-07-06 00:00:00	1967-07-06	581452		0	0	0		0	0	0	226453	0	10	40213160		
41181	3415	1127433	1983-09-09	1983-09-09 00:00:00	1983-10-09	1983-10-09 00:00:00	1983-10-09	38000177		0	0	30		0	0	0	226550	0	313782	1127433		
1901	152	35605858	1973-12-15	1973-12-15 00:00:00	1973-12-15	1973-12-15 00:00:00	1973-12-15	38000177		0	0	0		0	0	0	10291	0	1732136	35605858		
61956	5153	1127433	1955-10-03	1955-10-03 00:00:00	1955-10-10	1955-10-10 00:00:00	1955-10-10	38000177		0	0	7		0	0	0	342732	0	313782	1127433		
53355	4435	1127433	2015-09-28	2015-09-28 00:00:00	2015-10-28	2015-10-28 00:00:00	2015-10-28	38000177		0	0	30		0	0	0	294783	0	313782	1127433		
63203	5252	1713671	1978-02-24	1978-02-24 00:00:00	1978-03-03	1978-03-03 00:00:00	1978-03-03	38000177		0	0	7		0	0	0	349458	0	562251	1713671		
20842	1719	1127433	1973-06-25	1973-06-25 00:00:00	1973-07-02	1973-07-02 00:00:00	1973-07-02	38000177		0	0	7		0	0	0	114956	0	313782	1127433		
8323	693	1713671	1980-03-19	1980-03-19 00:00:00	1980-04-02	1980-04-02 00:00:00	1980-04-02	38000177		0	0	14		0	0	0	45898	0	562251	1713671		
23113	1905	1539411	1992-03-06	1992-03-06 00:00:00	1992-03-06	1992-03-06 00:00:00	\N	38000177		0	0	0		0	0	0	126782	0	312961	1539411		
8383	700	19128065	1997-05-15	1997-05-15 00:00:00	1997-12-17	1997-12-17 00:00:00	1997-12-17	38000177		0	0	216		0	0	0	46236	0	749882	19128065		
11657	970	1127433	1977-03-27	1977-03-27 00:00:00	1977-04-10	1977-04-10 00:00:00	1977-04-10	38000177		0	0	14		0	0	0	64475	0	313782	1127433		
20208	1658	1713671	1943-12-28	1943-12-28 00:00:00	1944-01-04	1944-01-04 00:00:00	1944-01-04	38000177		0	0	7		0	0	0	111413	0	562251	1713671		
36677	3026	1127433	1971-01-22	1971-01-22 00:00:00	1971-02-05	1971-02-05 00:00:00	1971-02-05	38000177		0	0	14		0	0	0	201759	0	313782	1127433		
30685	669	40213160	1970-01-07	1970-01-07 00:00:00	1970-01-07	1970-01-07 00:00:00	1970-01-07	581452		0	0	0		0	0	0	44184	0	10	40213160		
42158	3495	19078461	1995-10-10	1995-10-10 00:00:00	1995-10-31	1995-10-31 00:00:00	1995-10-31	38000177		0	0	21		0	0	0	231815	0	310965	19078461		
14521	1217	1127078	1974-02-19	1974-02-19 00:00:00	1974-03-05	1974-03-05 00:00:00	1974-03-05	38000177		0	0	14		0	0	0	80148	0	282464	1127078		
15197	328	40213160	1979-07-08	1979-07-08 00:00:00	1979-07-08	1979-07-08 00:00:00	1979-07-08	581452		0	0	0		0	0	0	21653	0	10	40213160		
1813	145	1127433	1957-12-15	1957-12-15 00:00:00	1957-12-22	1957-12-22 00:00:00	1957-12-22	38000177		0	0	7		0	0	0	9766	0	313782	1127433		
25144	2070	40229134	2001-05-10	2001-05-10 00:00:00	2001-05-24	2001-05-24 00:00:00	2001-05-24	38000177		0	0	14		0	0	0	137701	0	1043400	40229134		
134555	2953	40213251	1987-10-23	1987-10-23 00:00:00	1987-10-23	1987-10-23 00:00:00	1987-10-23	581452		0	0	0		0	0	0	197142	0	21	40213251		
161048	3543	40213160	1963-06-25	1963-06-25 00:00:00	1963-06-25	1963-06-25 00:00:00	1963-06-25	581452		0	0	0		0	0	0	235399	0	10	40213160		
15128	1264	1127433	1993-03-31	1993-03-31 00:00:00	1993-04-14	1993-04-14 00:00:00	1993-04-14	38000177		0	0	14		0	0	0	83315	0	313782	1127433		
43581	3612	40229134	2000-04-30	2000-04-30 00:00:00	2000-05-14	2000-05-14 00:00:00	2000-05-14	38000177		0	0	14		0	0	0	239973	0	1043400	40229134		
38055	830	40213260	2009-12-02	2009-12-02 00:00:00	2009-12-02	2009-12-02 00:00:00	2009-12-02	581452		0	0	0		0	0	0	54981	0	121	40213260		
15225	1272	1713671	2001-12-24	2001-12-24 00:00:00	2001-12-31	2001-12-31 00:00:00	2001-12-31	38000177		0	0	7		0	0	0	83911	0	562251	1713671		
14885	321	40213296	2003-01-19	2003-01-19 00:00:00	2003-01-19	2003-01-19 00:00:00	2003-01-19	581452		0	0	0		0	0	0	21268	0	52	40213296		
55244	4587	1118084	1968-04-24	1968-04-24 00:00:00	1968-04-24	1968-04-24 00:00:00	\N	38000177		0	0	0		0	0	0	305609	0	00025152531	44923712		
33663	2786	40236824	1965-05-13	1965-05-13 00:00:00	1965-05-20	1965-05-20 00:00:00	1965-05-20	38000177		0	0	7		0	0	0	184636	0	1094107	40236824		
43849	3630	19059056	1956-06-06	1956-06-06 00:00:00	1956-06-20	1956-06-20 00:00:00	1956-06-20	38000177		0	0	14		0	0	0	241573	0	243670	19059056		
26395	2172	1127078	1984-05-29	1984-05-29 00:00:00	1984-06-12	1984-06-12 00:00:00	1984-06-12	38000177		0	0	14		0	0	0	144664	0	282464	1127078		
36425	3002	1127078	1977-03-01	1977-03-01 00:00:00	1977-03-15	1977-03-15 00:00:00	1977-03-15	38000177		0	0	14		0	0	0	200350	0	282464	1127078		
28155	2328	19059056	1955-08-23	1955-08-23 00:00:00	1955-09-06	1955-09-06 00:00:00	1955-09-06	38000177		0	0	14		0	0	0	154823	0	243670	19059056		
11077	923	1127433	1976-10-30	1976-10-30 00:00:00	1976-11-06	1976-11-06 00:00:00	1976-11-06	38000177		0	0	7		0	0	0	61487	0	313782	1127433		
21612	1776	35605482	1984-10-13	1984-10-13 00:00:00	1984-10-13	1984-10-13 00:00:00	1984-10-13	38000177		0	0	0		0	0	0	118804	0	1740467	35605482		
21913	1796	1713671	2015-11-28	2015-11-28 00:00:00	2015-12-12	2015-12-12 00:00:00	2015-12-12	38000177		0	0	14		0	0	0	120402	0	562251	1713671		
47105	3904	19128022	1993-02-18	1993-02-18 00:00:00	1994-02-13	1994-02-13 00:00:00	1994-02-13	38000177		0	0	360		0	0	0	259627	0	749785	19128022		
36057	2970	1124300	2004-11-27	2004-11-27 00:00:00	2004-11-27	2004-11-27 00:00:00	\N	38000177		0	0	0		0	0	0	198353	0	00781178901	45011828		
5718	479	1127433	1984-08-09	1984-08-09 00:00:00	1984-08-23	1984-08-23 00:00:00	1984-08-23	38000177		0	0	14		0	0	0	31936	0	313782	1127433		
47766	3960	40229134	1970-11-28	1970-11-28 00:00:00	1970-12-12	1970-12-12 00:00:00	1970-12-12	38000177		0	0	14		0	0	0	263290	0	1043400	40229134		
47795	3962	19006318	1956-12-17	1956-12-17 00:00:00	1956-12-31	1956-12-31 00:00:00	1956-12-31	38000177		0	0	14		0	0	0	263452	0	105078	19006318		
13404	1123	1118084	2007-02-01	2007-02-01 00:00:00	2007-02-01	2007-02-01 00:00:00	\N	38000177		0	0	0		0	0	0	73973	0	00025152531	44923712		
41010	3401	19059056	1965-10-14	1965-10-14 00:00:00	1965-12-20	1965-12-20 00:00:00	1965-12-20	38000177		0	0	67		0	0	0	225623	0	243670	19059056		
21110	1739	1127078	1973-02-14	1973-02-14 00:00:00	1973-03-07	1973-03-07 00:00:00	1973-03-07	38000177		0	0	21		0	0	0	116169	0	282464	1127078		
3184	262	1115171	2005-05-30	2005-05-30 00:00:00	2005-06-13	2005-06-13 00:00:00	2005-06-13	38000177		0	0	14		0	0	0	17412	0	849574	1115171		
3221	264	1332419	2005-09-02	2005-09-02 00:00:00	2005-09-02	2005-09-02 00:00:00	\N	38000177		0	0	0		0	0	0	17530	0	197361	1332419		
4390	364	40229134	1951-05-12	1951-05-12 00:00:00	1951-05-19	1951-05-19 00:00:00	1951-05-19	38000177		0	0	7		0	0	0	24215	0	1043400	40229134		
42298	921	40213260	2016-06-21	2016-06-21 00:00:00	2016-06-21	2016-06-21 00:00:00	2016-06-21	581452		0	0	0		0	0	0	61366	0	121	40213260		
11596	967	1127433	1987-06-16	1987-06-16 00:00:00	1987-06-23	1987-06-23 00:00:00	1987-06-23	38000177		0	0	7		0	0	0	64353	0	313782	1127433		
6158	515	1127433	1985-04-07	1985-04-07 00:00:00	1985-05-05	1985-05-05 00:00:00	1985-05-05	38000177		0	0	28		0	0	0	34390	0	313782	1127433		
53703	1175	40213201	2007-02-11	2007-02-11 00:00:00	2007-02-11	2007-02-11 00:00:00	2007-02-11	581452		0	0	0		0	0	0	77463	0	33	40213201		
237	17	1713671	1973-03-13	1973-03-13 00:00:00	1973-03-20	1973-03-20 00:00:00	1973-03-20	38000177		0	0	7		0	0	0	1307	0	562251	1713671		
40	2	40171902	2007-09-04	2007-09-04 00:00:00	2007-09-04	2007-09-04 00:00:00	\N	38000177		0	0	0		0	0	0	137	0	897718	40171902		
17809	1475	40173590	2005-02-17	2005-02-17 00:00:00	2005-02-17	2005-02-17 00:00:00	\N	38000177		0	0	0		0	0	0	98302	0	904419	40173590		
12655	273	40213227	2016-11-06	2016-11-06 00:00:00	2016-11-06	2016-11-06 00:00:00	2016-11-06	581452		0	0	0		0	0	0	18323	0	113	40213227		
10662	886	1713671	1999-02-11	1999-02-11 00:00:00	1999-02-25	1999-02-25 00:00:00	1999-02-25	38000177		0	0	14		0	0	0	59061	0	562251	1713671		
36219	2985	1127433	2017-10-12	2017-10-12 00:00:00	2017-10-26	2017-10-26 00:00:00	2017-10-26	38000177		0	0	14		0	0	0	199219	0	313782	1127433		
43403	3598	1332419	1996-04-07	1996-04-07 00:00:00	1996-04-07	1996-04-07 00:00:00	\N	38000177		0	0	0		0	0	0	239010	0	197361	1332419		
59688	4963	1127433	2006-02-25	2006-02-25 00:00:00	2006-03-18	2006-03-18 00:00:00	2006-03-18	38000177		0	0	21		0	0	0	329967	0	313782	1127433		
39035	3226	46233988	1971-02-23	1971-02-23 00:00:00	1971-03-09	1971-03-09 00:00:00	1971-03-09	38000177		0	0	14		0	0	0	214497	0	1652673	46233988		
30200	2503	19128022	1989-02-06	1989-02-06 00:00:00	1990-02-01	1990-02-01 00:00:00	1990-02-01	38000177		0	0	360		0	0	0	165674	0	749785	19128022		
27073	2233	40236824	1998-03-03	1998-03-03 00:00:00	1998-03-10	1998-03-10 00:00:00	1998-03-10	38000177		0	0	7		0	0	0	148586	0	1094107	40236824		
97350	2134	40213201	2015-10-11	2015-10-11 00:00:00	2015-10-11	2015-10-11 00:00:00	2015-10-11	581452		0	0	0		0	0	0	141983	0	33	40213201		
30247	2507	1118084	2006-05-12	2006-05-12 00:00:00	2006-05-12	2006-05-12 00:00:00	\N	38000177		0	0	0		0	0	0	165933	0	00025152531	44923712		
42674	3537	19078461	1974-12-05	1974-12-05 00:00:00	1975-01-02	1975-01-02 00:00:00	1975-01-02	38000177		0	0	28		0	0	0	234963	0	310965	19078461		
37701	3117	1127433	2015-03-24	2015-03-24 00:00:00	2015-04-07	2015-04-07 00:00:00	2015-04-07	38000177		0	0	14		0	0	0	207399	0	313782	1127433		
41182	3415	40165015	1983-09-09	1983-09-09 00:00:00	1983-09-09	1983-09-09 00:00:00	\N	38000177		0	0	0		0	0	0	226550	0	861467	40165015		
1902	152	19079524	1973-12-15	1973-12-15 00:00:00	1973-12-16	1973-12-16 00:00:00	1973-12-16	38000177		0	0	1		0	0	0	10291	0	313002	19079524		
61957	5153	1115171	2014-06-14	2014-06-14 00:00:00	2014-08-20	2014-08-20 00:00:00	2014-08-20	38000177		0	0	67		0	0	0	342653	0	849574	1115171		
53356	4435	40165015	2015-09-28	2015-09-28 00:00:00	2015-09-28	2015-09-28 00:00:00	\N	38000177		0	0	0		0	0	0	294783	0	861467	40165015		
63204	5252	1127433	1961-04-17	1961-04-17 00:00:00	1961-04-24	1961-04-24 00:00:00	1961-04-24	38000177		0	0	7		0	0	0	349453	0	313782	1127433		
20843	1719	1127433	2007-12-17	2007-12-17 00:00:00	2008-01-07	2008-01-07 00:00:00	2008-01-07	38000177		0	0	21		0	0	0	115000	0	313782	1127433		
56159	4662	35605858	1989-07-27	1989-07-27 00:00:00	1989-07-27	1989-07-27 00:00:00	1989-07-27	38000177		0	0	0		0	0	0	310773	0	1732136	35605858		
23114	1905	19075601	1999-12-17	1999-12-17 00:00:00	1999-12-17	1999-12-17 00:00:00	\N	38000177		0	0	0		0	0	0	126803	0	309362	19075601		
8384	700	1127433	2008-09-05	2008-09-05 00:00:00	2008-09-26	2008-09-26 00:00:00	2008-09-26	38000177		0	0	21		0	0	0	46232	0	313782	1127433		
11658	970	19078461	2002-12-21	2002-12-21 00:00:00	2003-01-18	2003-01-18 00:00:00	2003-01-18	38000177		0	0	28		0	0	0	64478	0	310965	19078461		
20209	1658	1713671	1940-01-29	1940-01-29 00:00:00	1940-02-12	1940-02-12 00:00:00	1940-02-12	38000177		0	0	14		0	0	0	111354	0	562251	1713671		
36678	3026	19133873	1971-12-26	1971-12-26 00:00:00	1972-01-07	1972-01-07 00:00:00	1972-01-07	38000177		0	0	12		0	0	0	201761	0	834061	19133873		
30694	669	40213160	1974-04-17	1974-04-17 00:00:00	1974-04-17	1974-04-17 00:00:00	1974-04-17	581452		0	0	0		0	0	0	\N	0	10	40213160		
42159	3495	1127433	2002-12-01	2002-12-01 00:00:00	2002-12-08	2002-12-08 00:00:00	2002-12-08	38000177		0	0	7		0	0	0	231852	0	313782	1127433		
14522	1217	46233988	1974-02-19	1974-02-19 00:00:00	1974-03-05	1974-03-05 00:00:00	1974-03-05	38000177		0	0	14		0	0	0	80148	0	1652673	46233988		
15205	328	40213306	2002-11-24	2002-11-24 00:00:00	2002-11-24	2002-11-24 00:00:00	2002-11-24	581452		0	0	0		0	0	0	21650	0	43	40213306		
1814	145	40236824	1980-03-01	1980-03-01 00:00:00	1980-03-08	1980-03-08 00:00:00	1980-03-08	38000177		0	0	7		0	0	0	9785	0	1094107	40236824		
25145	2070	19078461	2017-07-09	2017-07-09 00:00:00	2017-08-13	2017-08-13 00:00:00	2017-08-13	38000177		0	0	35		0	0	0	137730	0	310965	19078461		
134558	2953	40213160	1987-10-23	1987-10-23 00:00:00	1987-10-23	1987-10-23 00:00:00	1987-10-23	581452		0	0	0		0	0	0	197142	0	10	40213160		
161056	3543	40213160	1959-03-24	1959-03-24 00:00:00	1959-03-24	1959-03-24 00:00:00	1959-03-24	581452		0	0	0		0	0	0	235350	0	10	40213160		
15129	1264	1127433	2001-02-02	2001-02-02 00:00:00	2001-02-09	2001-02-09 00:00:00	2001-02-09	38000177		0	0	7		0	0	0	83339	0	313782	1127433		
43582	3613	1118084	2010-06-05	2010-06-05 00:00:00	2010-06-05	2010-06-05 00:00:00	\N	38000177		0	0	0		0	0	0	240018	0	00025152531	44923712		
38056	830	40213160	1959-03-04	1959-03-04 00:00:00	1959-03-04	1959-03-04 00:00:00	1959-03-04	581452		0	0	0		0	0	0	54946	0	10	40213160		
15226	1272	1124300	2015-11-24	2015-11-24 00:00:00	2015-11-24	2015-11-24 00:00:00	\N	38000177		0	0	0		0	0	0	83969	0	00781178901	45011828		
14887	321	40213227	2003-01-19	2003-01-19 00:00:00	2003-01-19	2003-01-19 00:00:00	2003-01-19	581452		0	0	0		0	0	0	21268	0	113	40213227		
55245	4587	19059056	1936-02-07	1936-02-07 00:00:00	1936-02-21	1936-02-21 00:00:00	1936-02-21	38000177		0	0	14		0	0	0	305611	0	243670	19059056		
33664	2786	920300	1965-05-13	1965-05-13 00:00:00	1965-05-20	1965-05-20 00:00:00	1965-05-20	38000177		0	0	7		0	0	0	184636	0	311989	920300		
43850	3630	19006318	1956-06-06	1956-06-06 00:00:00	1956-06-20	1956-06-20 00:00:00	1956-06-20	38000177		0	0	14		0	0	0	241573	0	105078	19006318		
26396	2172	19073183	1984-05-29	1984-05-29 00:00:00	1984-06-12	1984-06-12 00:00:00	1984-06-12	38000177		0	0	14		0	0	0	144664	0	308182	19073183		
36426	3002	19006318	1977-03-01	1977-03-01 00:00:00	1977-03-15	1977-03-15 00:00:00	1977-03-15	38000177		0	0	14		0	0	0	200350	0	105078	19006318		
28156	2328	19006318	1955-08-23	1955-08-23 00:00:00	1955-09-06	1955-09-06 00:00:00	1955-09-06	38000177		0	0	14		0	0	0	154823	0	105078	19006318		
11078	923	1127433	1987-02-02	1987-02-02 00:00:00	1987-02-16	1987-02-16 00:00:00	1987-02-16	38000177		0	0	14		0	0	0	61489	0	313782	1127433		
21613	1776	19079524	1984-10-13	1984-10-13 00:00:00	1984-10-14	1984-10-14 00:00:00	1984-10-14	38000177		0	0	1		0	0	0	118804	0	313002	19079524		
21914	1796	19128022	2000-02-23	2000-02-23 00:00:00	2001-02-17	2001-02-17 00:00:00	2001-02-17	38000177		0	0	360		0	0	0	120390	0	749785	19128022		
47106	3904	1713671	1999-07-16	1999-07-16 00:00:00	1999-07-23	1999-07-23 00:00:00	1999-07-23	38000177		0	0	7		0	0	0	259595	0	562251	1713671		
36058	2970	1127433	2018-09-25	2018-09-25 00:00:00	2018-10-02	2018-10-02 00:00:00	2018-10-02	38000177		0	0	7		0	0	0	198293	0	313782	1127433		
5719	480	1127433	1984-03-03	1984-03-03 00:00:00	1984-03-17	1984-03-17 00:00:00	1984-03-17	38000177		0	0	14		0	0	0	31995	0	313782	1127433		
14820	320	40213260	2007-02-25	2007-02-25 00:00:00	2007-02-25	2007-02-25 00:00:00	2007-02-25	581452		0	0	0		0	0	0	21191	0	121	40213260		
47796	3962	19059056	1956-12-17	1956-12-17 00:00:00	1956-12-31	1956-12-31 00:00:00	1956-12-31	38000177		0	0	14		0	0	0	263452	0	243670	19059056		
13405	1124	19059056	1939-09-15	1939-09-15 00:00:00	1939-10-06	1939-10-06 00:00:00	1939-10-06	38000177		0	0	21		0	0	0	74109	0	243670	19059056		
41011	3401	1713671	2002-06-25	2002-06-25 00:00:00	2002-07-16	2002-07-16 00:00:00	2002-07-16	38000177		0	0	21		0	0	0	225596	0	562251	1713671		
21111	1739	1127433	1999-10-14	1999-10-14 00:00:00	1999-10-28	1999-10-28 00:00:00	1999-10-28	38000177		0	0	14		0	0	0	116213	0	313782	1127433		
3185	262	40236446	1978-07-31	1978-07-31 00:00:00	1982-08-09	1982-08-09 00:00:00	1982-08-09	38000177		0	0	1470		0	0	0	17361	0	1091392	40236446		
3222	264	1539411	2005-09-02	2005-09-02 00:00:00	2005-09-02	2005-09-02 00:00:00	\N	38000177		0	0	0		0	0	0	17530	0	312961	1539411		
4391	364	1127433	2017-08-18	2017-08-18 00:00:00	2017-09-08	2017-09-08 00:00:00	2017-09-08	38000177		0	0	21		0	0	0	24212	0	313782	1127433		
6973	587	1127433	1983-02-17	1983-02-17 00:00:00	1983-02-24	1983-02-24 00:00:00	1983-02-24	38000177		0	0	7		0	0	0	38901	0	313782	1127433		
11597	967	1127433	2011-07-09	2011-07-09 00:00:00	2011-07-16	2011-07-16 00:00:00	2011-07-16	38000177		0	0	7		0	0	0	64305	0	313782	1127433		
6159	515	1713671	2012-01-13	2012-01-13 00:00:00	2012-02-03	2012-02-03 00:00:00	2012-02-03	38000177		0	0	21		0	0	0	34369	0	562251	1713671		
53705	1175	40213227	2012-05-13	2012-05-13 00:00:00	2012-05-13	2012-05-13 00:00:00	2012-05-13	581452		0	0	0		0	0	0	77491	0	113	40213227		
238	17	40236824	1995-01-02	1995-01-02 00:00:00	1995-01-09	1995-01-09 00:00:00	1995-01-09	38000177		0	0	7		0	0	0	1299	0	1094107	40236824		
41	2	19018935	2007-09-04	2007-09-04 00:00:00	2007-09-04	2007-09-04 00:00:00	\N	38000177		0	0	0		0	0	0	137	0	197604	19018935		
17810	1476	40169216	1946-09-21	1946-09-21 00:00:00	1946-09-21	1946-09-21 00:00:00	\N	38000177		0	0	0		0	0	0	98365	0	895994	40169216		
12656	273	40213296	2016-11-06	2016-11-06 00:00:00	2016-11-06	2016-11-06 00:00:00	2016-11-06	581452		0	0	0		0	0	0	18323	0	52	40213296		
10663	886	1124300	2018-06-15	2018-06-15 00:00:00	2018-06-15	2018-06-15 00:00:00	\N	38000177		0	0	0		0	0	0	59076	0	00781178901	45011828		
36221	2985	19059056	1964-12-12	1964-12-12 00:00:00	1964-12-26	1964-12-26 00:00:00	1964-12-26	38000177		0	0	14		0	0	0	199268	0	243670	19059056		
43404	3598	19126352	1996-04-07	1996-04-07 00:00:00	2014-12-14	2014-12-14 00:00:00	2014-12-14	38000177		0	0	6825		0	0	0	239010	0	705129	19126352		
59689	4963	1127433	1980-10-29	1980-10-29 00:00:00	1980-11-05	1980-11-05 00:00:00	1980-11-05	38000177		0	0	7		0	0	0	329962	0	313782	1127433		
39036	3226	40229134	2008-06-25	2008-06-25 00:00:00	2008-07-02	2008-07-02 00:00:00	2008-07-02	38000177		0	0	7		0	0	0	214477	0	1043400	40229134		
30201	2503	19133873	1985-09-17	1985-09-17 00:00:00	1985-09-29	1985-09-29 00:00:00	1985-09-29	38000177		0	0	12		0	0	0	165711	0	834061	19133873		
27074	2233	920300	1998-03-03	1998-03-03 00:00:00	1998-03-10	1998-03-10 00:00:00	1998-03-10	38000177		0	0	7		0	0	0	148586	0	311989	920300		
97351	2134	40213198	2014-09-28	2014-09-28 00:00:00	2014-09-28	2014-09-28 00:00:00	2014-09-28	581452		0	0	0		0	0	0	\N	0	133	40213198		
30248	2507	1127078	1969-08-19	1969-08-19 00:00:00	1969-09-02	1969-09-02 00:00:00	1969-09-02	38000177		0	0	14		0	0	0	165967	0	282464	1127078		
42675	3537	1551192	1962-06-20	1962-06-20 00:00:00	1962-06-20	1962-06-20 00:00:00	1962-06-20	38000177		0	0	0		0	0	0	234981	0	312617	1551192		
37702	3117	19128065	1989-07-18	1989-07-18 00:00:00	1990-07-13	1990-07-13 00:00:00	1990-07-13	38000177		0	0	360		0	0	0	207380	0	749882	19128065		
41183	3415	1127433	1999-06-20	1999-06-20 00:00:00	1999-06-27	1999-06-27 00:00:00	1999-06-27	38000177		0	0	7		0	0	0	226498	0	313782	1127433		
1903	152	1367571	1973-12-15	1973-12-15 00:00:00	1973-12-15	1973-12-15 00:00:00	1973-12-15	38000177		0	0	0		0	0	0	10291	0	314659	19080464		
61958	5153	40165015	2014-06-21	2014-06-21 00:00:00	2014-06-21	2014-06-21 00:00:00	\N	38000177		0	0	0		0	0	0	342742	0	861467	40165015		
53357	4435	1127433	1982-03-15	1982-03-15 00:00:00	1982-03-29	1982-03-29 00:00:00	1982-03-29	38000177		0	0	14		0	0	0	294781	0	313782	1127433		
63205	5252	19133873	1967-03-19	1967-03-19 00:00:00	1967-03-31	1967-03-31 00:00:00	1967-03-31	38000177		0	0	12		0	0	0	349442	0	834061	19133873		
20844	1719	1127078	1959-06-11	1959-06-11 00:00:00	1959-06-25	1959-06-25 00:00:00	1959-06-25	38000177		0	0	14		0	0	0	114951	0	282464	1127078		
56160	4662	35605482	1989-07-27	1989-07-27 00:00:00	1989-07-27	1989-07-27 00:00:00	1989-07-27	38000177		0	0	0		0	0	0	310773	0	1740467	35605482		
23115	1905	1127433	1996-12-01	1996-12-01 00:00:00	1996-12-15	1996-12-15 00:00:00	1996-12-15	38000177		0	0	14		0	0	0	126789	0	313782	1127433		
8385	700	1115171	2017-06-11	2017-06-11 00:00:00	2017-07-02	2017-07-02 00:00:00	2017-07-02	38000177		0	0	21		0	0	0	46233	0	849574	1115171		
11659	970	19133873	1960-07-25	1960-07-25 00:00:00	1960-08-03	1960-08-03 00:00:00	1960-08-03	38000177		0	0	9		0	0	0	64487	0	834061	19133873		
20210	1658	1127433	2016-04-18	2016-04-18 00:00:00	2016-04-25	2016-04-25 00:00:00	2016-04-25	38000177		0	0	7		0	0	0	111297	0	313782	1127433		
36679	3026	19059056	1971-07-28	1971-07-28 00:00:00	1971-10-26	1971-10-26 00:00:00	1971-10-26	38000177		0	0	90		0	0	0	201791	0	243670	19059056		
30700	669	40213227	2000-12-13	2000-12-13 00:00:00	2000-12-13	2000-12-13 00:00:00	2000-12-13	581452		0	0	0		0	0	0	44190	0	113	40213227		
42160	3495	19059056	1967-02-19	1967-02-19 00:00:00	1967-03-05	1967-03-05 00:00:00	1967-03-05	38000177		0	0	14		0	0	0	231846	0	243670	19059056		
14523	1217	19133905	2012-11-21	2012-11-21 00:00:00	2012-12-01	2012-12-01 00:00:00	2012-12-01	38000177		0	0	10		0	0	0	80139	0	834102	19133905		
15210	328	40213227	2000-12-31	2000-12-31 00:00:00	2000-12-31	2000-12-31 00:00:00	2000-12-31	581452		0	0	0		0	0	0	21639	0	113	40213227		
1815	145	920300	1980-03-01	1980-03-01 00:00:00	1980-03-08	1980-03-08 00:00:00	1980-03-08	38000177		0	0	7		0	0	0	9785	0	311989	920300		
25146	2070	19078461	2001-07-19	2001-07-19 00:00:00	2001-08-02	2001-08-02 00:00:00	2001-08-02	38000177		0	0	14		0	0	0	137729	0	310965	19078461		
134569	2953	40213160	1983-07-22	1983-07-22 00:00:00	1983-07-22	1983-07-22 00:00:00	1983-07-22	581452		0	0	0		0	0	0	197115	0	10	40213160		
161059	3543	40213260	2008-07-15	2008-07-15 00:00:00	2008-07-15	2008-07-15 00:00:00	2008-07-15	581452		0	0	0		0	0	0	235355	0	121	40213260		
15130	1264	1713671	1982-05-21	1982-05-21 00:00:00	1982-06-04	1982-06-04 00:00:00	1982-06-04	38000177		0	0	14		0	0	0	83324	0	562251	1713671		
43583	3613	19073183	1981-01-15	1981-01-15 00:00:00	1981-01-29	1981-01-29 00:00:00	1981-01-29	38000177		0	0	14		0	0	0	240043	0	308182	19073183		
38058	830	40213296	1999-09-08	1999-09-08 00:00:00	1999-09-08	1999-09-08 00:00:00	1999-09-08	581452		0	0	0		0	0	0	54996	0	52	40213296		
15227	1272	1127433	2002-01-07	2002-01-07 00:00:00	2002-01-21	2002-01-21 00:00:00	2002-01-21	38000177		0	0	14		0	0	0	83929	0	313782	1127433		
14899	321	40213160	1962-04-22	1962-04-22 00:00:00	1962-04-22	1962-04-22 00:00:00	1962-04-22	581452		0	0	0		0	0	0	21295	0	10	40213160		
55246	4587	1713671	2012-07-18	2012-07-18 00:00:00	2012-08-08	2012-08-08 00:00:00	2012-08-08	38000177		0	0	21		0	0	0	305629	0	562251	1713671		
33665	2786	1713671	1927-06-19	1927-06-19 00:00:00	1927-07-03	1927-07-03 00:00:00	1927-07-03	38000177		0	0	14		0	0	0	184633	0	562251	1713671		
43851	3631	1127433	1989-05-24	1989-05-24 00:00:00	1989-05-31	1989-05-31 00:00:00	1989-05-31	38000177		0	0	7		0	0	0	241603	0	313782	1127433		
26397	2172	1713671	1996-11-20	1996-11-20 00:00:00	1996-11-27	1996-11-27 00:00:00	1996-11-27	38000177		0	0	7		0	0	0	144692	0	562251	1713671		
36430	3004	1127433	2018-04-04	2018-04-04 00:00:00	2018-04-11	2018-04-11 00:00:00	2018-04-11	38000177		0	0	7		0	0	0	200470	0	313782	1127433		
28157	2328	1713671	1981-10-02	1981-10-02 00:00:00	1981-10-09	1981-10-09 00:00:00	1981-10-09	38000177		0	0	7		0	0	0	154807	0	562251	1713671		
11079	923	1127433	2000-10-21	2000-10-21 00:00:00	2000-10-28	2000-10-28 00:00:00	2000-10-28	38000177		0	0	7		0	0	0	61433	0	313782	1127433		
21614	1776	42707627	1984-10-13	1984-10-13 00:00:00	1984-10-13	1984-10-13 00:00:00	1984-10-13	38000177		0	0	0		0	0	0	118804	0	1234995	42707627		
21915	1796	1115171	1994-11-11	1994-11-11 00:00:00	1994-11-25	1994-11-25 00:00:00	1994-11-25	38000177		0	0	14		0	0	0	120427	0	849574	1115171		
47107	3904	40229134	2009-06-09	2009-06-09 00:00:00	2009-06-16	2009-06-16 00:00:00	2009-06-16	38000177		0	0	7		0	0	0	259626	0	1043400	40229134		
36059	2970	40229134	2003-10-05	2003-10-05 00:00:00	2003-10-12	2003-10-12 00:00:00	2003-10-12	38000177		0	0	7		0	0	0	198291	0	1043400	40229134		
5720	480	1127433	2013-09-12	2013-09-12 00:00:00	2013-09-19	2013-09-19 00:00:00	2013-09-19	38000177		0	0	7		0	0	0	31984	0	313782	1127433		
14822	320	40213227	2007-02-25	2007-02-25 00:00:00	2007-02-25	2007-02-25 00:00:00	2007-02-25	581452		0	0	0		0	0	0	21191	0	113	40213227		
47797	3962	920300	1997-06-21	1997-06-21 00:00:00	1997-06-28	1997-06-28 00:00:00	1997-06-28	38000177		0	0	7		0	0	0	263449	0	311989	920300		
13406	1124	1713671	2013-06-29	2013-06-29 00:00:00	2013-07-06	2013-07-06 00:00:00	2013-07-06	38000177		0	0	7		0	0	0	74099	0	562251	1713671		
41012	3401	1127078	1962-10-30	1962-10-30 00:00:00	1962-11-13	1962-11-13 00:00:00	1962-11-13	38000177		0	0	14		0	0	0	225648	0	282464	1127078		
21112	1740	19059056	1961-06-21	1961-06-21 00:00:00	1961-07-12	1961-07-12 00:00:00	1961-07-12	38000177		0	0	21		0	0	0	116291	0	243670	19059056		
3186	263	19059056	1960-02-12	1960-02-12 00:00:00	1960-02-26	1960-02-26 00:00:00	1960-02-26	38000177		0	0	14		0	0	0	17481	0	243670	19059056		
3223	264	19075601	2005-09-02	2005-09-02 00:00:00	2011-11-11	2011-11-11 00:00:00	2011-11-11	38000177		0	0	2261		0	0	0	17530	0	309362	19075601		
4392	364	1127433	2018-07-05	2018-07-05 00:00:00	2018-08-04	2018-08-04 00:00:00	2018-08-04	38000177		0	0	30		0	0	0	24213	0	313782	1127433		
6974	587	1118084	2015-06-01	2015-06-01 00:00:00	2015-06-01	2015-06-01 00:00:00	\N	38000177		0	0	0		0	0	0	38909	0	00025152531	44923712		
11598	967	1115171	2007-05-20	2007-05-20 00:00:00	2007-06-10	2007-06-10 00:00:00	2007-06-10	38000177		0	0	21		0	0	0	64319	0	849574	1115171		
6160	515	1118084	1981-03-27	1981-03-27 00:00:00	1981-03-27	1981-03-27 00:00:00	\N	38000177		0	0	0		0	0	0	34359	0	00025152531	44923712		
53714	1176	40213160	1963-01-25	1963-01-25 00:00:00	1963-01-25	1963-01-25 00:00:00	1963-01-25	581452		0	0	0		0	0	0	77722	0	10	40213160		
239	17	920300	1995-01-02	1995-01-02 00:00:00	1995-01-09	1995-01-09 00:00:00	1995-01-09	38000177		0	0	7		0	0	0	1299	0	311989	920300		
42	2	40163554	2007-09-04	2007-09-04 00:00:00	2007-09-04	2007-09-04 00:00:00	\N	38000177		0	0	0		0	0	0	137	0	855332	40163554		
17811	1476	1154615	1946-09-21	1946-09-21 00:00:00	1946-09-21	1946-09-21 00:00:00	\N	38000177		0	0	0		0	0	0	98365	0	745679	1154615		
12660	273	40213160	1976-02-22	1976-02-22 00:00:00	1976-02-22	1976-02-22 00:00:00	1976-02-22	581452		0	0	0		0	0	0	18248	0	10	40213160		
10664	886	1127433	1995-11-29	1995-11-29 00:00:00	1995-12-06	1995-12-06 00:00:00	1995-12-06	38000177		0	0	7		0	0	0	59077	0	313782	1127433		
36222	2985	1127433	1982-11-28	1982-11-28 00:00:00	1982-12-05	1982-12-05 00:00:00	1982-12-05	38000177		0	0	7		0	0	0	199230	0	313782	1127433		
37983	3141	1127433	1987-09-11	1987-09-11 00:00:00	1987-09-18	1987-09-18 00:00:00	1987-09-18	38000177		0	0	7		0	0	0	208994	0	313782	1127433		
59690	4963	1127433	1976-05-29	1976-05-29 00:00:00	1976-06-05	1976-06-05 00:00:00	1976-06-05	38000177		0	0	7		0	0	0	329897	0	313782	1127433		
39037	3226	1713671	1971-04-30	1971-04-30 00:00:00	1971-05-07	1971-05-07 00:00:00	1971-05-07	38000177		0	0	7		0	0	0	214439	0	562251	1713671		
30202	2503	1127433	2013-05-26	2013-05-26 00:00:00	2013-06-09	2013-06-09 00:00:00	2013-06-09	38000177		0	0	14		0	0	0	165654	0	313782	1127433		
27075	2233	1115171	2001-09-06	2001-09-06 00:00:00	2001-09-20	2001-09-20 00:00:00	2001-09-20	38000177		0	0	14		0	0	0	148605	0	849574	1115171		
142959	3141	40213160	1971-07-18	1971-07-18 00:00:00	1971-07-18	1971-07-18 00:00:00	1971-07-18	581452		0	0	0		0	0	0	209014	0	10	40213160		
30263	2509	19133873	1984-03-03	1984-03-03 00:00:00	1984-03-14	1984-03-14 00:00:00	1984-03-14	38000177		0	0	11		0	0	0	166096	0	834061	19133873		
42676	3537	19008572	1967-05-04	1967-05-04 00:00:00	1967-05-18	1967-05-18 00:00:00	1967-05-18	38000177		0	0	14		0	0	0	234905	0	106258	19008572		
37703	3117	19128065	1994-06-22	1994-06-22 00:00:00	1995-06-17	1995-06-17 00:00:00	1995-06-17	38000177		0	0	360		0	0	0	207376	0	749882	19128065		
41184	3415	19059056	1979-11-22	1979-11-22 00:00:00	1980-02-20	1980-02-20 00:00:00	1980-02-20	38000177		0	0	90		0	0	0	226551	0	243670	19059056		
1904	152	35605482	1973-12-15	1973-12-15 00:00:00	1973-12-15	1973-12-15 00:00:00	1973-12-15	38000177		0	0	0		0	0	0	10291	0	1740467	35605482		
61960	5153	1127433	1970-03-27	1970-03-27 00:00:00	1970-04-10	1970-04-10 00:00:00	1970-04-10	38000177		0	0	14		0	0	0	342733	0	313782	1127433		
53358	4435	19126352	2002-04-15	2002-04-15 00:00:00	2002-04-15	2002-04-15 00:00:00	\N	38000177		0	0	0		0	0	0	294776	0	705129	19126352		
63206	5252	1127433	1987-01-08	1987-01-08 00:00:00	1987-01-15	1987-01-15 00:00:00	1987-01-15	38000177		0	0	7		0	0	0	349415	0	313782	1127433		
20845	1719	19006318	1959-06-11	1959-06-11 00:00:00	1959-06-25	1959-06-25 00:00:00	1959-06-25	38000177		0	0	14		0	0	0	114951	0	105078	19006318		
56161	4662	35605482	1989-07-27	1989-07-27 00:00:00	1989-07-27	1989-07-27 00:00:00	1989-07-27	38000177		0	0	0		0	0	0	310773	0	1740467	35605482		
23116	1905	1332419	1995-03-10	1995-03-10 00:00:00	1995-03-10	1995-03-10 00:00:00	\N	38000177		0	0	0		0	0	0	126783	0	197361	1332419		
8386	700	19133873	1991-11-20	1991-11-20 00:00:00	1991-12-01	1991-12-01 00:00:00	1991-12-01	38000177		0	0	11		0	0	0	46286	0	834061	19133873		
11660	970	1713671	2000-03-03	2000-03-03 00:00:00	2000-03-10	2000-03-10 00:00:00	2000-03-10	38000177		0	0	7		0	0	0	64522	0	562251	1713671		
20211	1658	1713671	1937-07-16	1937-07-16 00:00:00	1937-08-06	1937-08-06 00:00:00	1937-08-06	38000177		0	0	21		0	0	0	111387	0	562251	1713671		
36680	3026	19078461	2019-05-31	2019-05-31 00:00:00	2019-05-31	2019-05-31 00:00:00	\N	38000177		0	0	0		0	0	0	201730	0	310965	19078461		
30703	669	40213227	2010-11-03	2010-11-03 00:00:00	2010-11-03	2010-11-03 00:00:00	2010-11-03	581452		0	0	0		0	0	0	44191	0	113	40213227		
42161	3495	1118084	2001-02-27	2001-02-27 00:00:00	2001-02-27	2001-02-27 00:00:00	\N	38000177		0	0	0		0	0	0	231823	0	00025152531	44923712		
14524	1217	1127433	2015-05-28	2015-05-28 00:00:00	2015-06-11	2015-06-11 00:00:00	2015-06-11	38000177		0	0	14		0	0	0	80169	0	313782	1127433		
15211	328	40213306	2000-12-31	2000-12-31 00:00:00	2000-12-31	2000-12-31 00:00:00	2000-12-31	581452		0	0	0		0	0	0	21639	0	43	40213306		
1816	145	1127433	1977-12-17	1977-12-17 00:00:00	1977-12-31	1977-12-31 00:00:00	1977-12-31	38000177		0	0	14		0	0	0	9784	0	313782	1127433		
25147	2070	19059056	1968-02-08	1968-02-08 00:00:00	1968-02-22	1968-02-22 00:00:00	1968-02-22	38000177		0	0	14		0	0	0	137734	0	243670	19059056		
134573	2953	40213314	1983-02-18	1983-02-18 00:00:00	1983-02-18	1983-02-18 00:00:00	1983-02-18	581452		0	0	0		0	0	0	197131	0	49	40213314		
63316	5258	1127433	1997-11-02	1997-11-02 00:00:00	1997-11-16	1997-11-16 00:00:00	1997-11-16	38000177		0	0	14		0	0	0	349891	0	313782	1127433		
12115	1016	920300	2010-08-18	2010-08-18 00:00:00	2010-08-25	2010-08-25 00:00:00	2010-08-25	38000177		0	0	7		0	0	0	66898	0	311989	920300		
43584	3613	19059056	1981-01-15	1981-01-15 00:00:00	1981-01-29	1981-01-29 00:00:00	1981-01-29	38000177		0	0	14		0	0	0	240043	0	243670	19059056		
38065	830	40213306	1981-08-19	1981-08-19 00:00:00	1981-08-19	1981-08-19 00:00:00	1981-08-19	581452		0	0	0		0	0	0	54984	0	43	40213306		
15228	1272	40229134	1986-11-08	1986-11-08 00:00:00	1986-11-22	1986-11-22 00:00:00	1986-11-22	38000177		0	0	14		0	0	0	83865	0	1043400	40229134		
60539	5035	19059056	1935-05-07	1935-05-07 00:00:00	1935-05-28	1935-05-28 00:00:00	1935-05-28	38000177		0	0	21		0	0	0	334617	0	243670	19059056		
55247	4587	1127433	2003-07-02	2003-07-02 00:00:00	2003-07-16	2003-07-16 00:00:00	2003-07-16	38000177		0	0	14		0	0	0	305598	0	313782	1127433		
33666	2786	1127433	2009-07-24	2009-07-24 00:00:00	2009-08-23	2009-08-23 00:00:00	2009-08-23	38000177		0	0	30		0	0	0	184616	0	313782	1127433		
43852	3631	1713671	2002-02-20	2002-02-20 00:00:00	2002-03-06	2002-03-06 00:00:00	2002-03-06	38000177		0	0	14		0	0	0	241606	0	562251	1713671		
26398	2172	1127433	2016-01-19	2016-01-19 00:00:00	2016-01-26	2016-01-26 00:00:00	2016-01-26	38000177		0	0	7		0	0	0	144663	0	313782	1127433		
36431	3004	1118084	1991-05-16	1991-05-16 00:00:00	1991-05-16	1991-05-16 00:00:00	\N	38000177		0	0	0		0	0	0	200448	0	00025152531	44923712		
28158	2328	19059056	1959-06-03	1959-06-03 00:00:00	1959-06-24	1959-06-24 00:00:00	1959-06-24	38000177		0	0	21		0	0	0	154898	0	243670	19059056		
11080	923	19059056	1989-04-03	1989-04-03 00:00:00	1989-04-24	1989-04-24 00:00:00	1989-04-24	38000177		0	0	21		0	0	0	61494	0	243670	19059056		
21615	1776	1127433	1997-12-07	1997-12-07 00:00:00	1997-12-28	1997-12-28 00:00:00	1997-12-28	38000177		0	0	21		0	0	0	118884	0	313782	1127433		
21916	1796	19073188	1994-11-11	1994-11-11 00:00:00	1994-11-25	1994-11-25 00:00:00	1994-11-25	38000177		0	0	14		0	0	0	120427	0	308192	19073188		
47108	3904	1118084	2015-01-04	2015-01-04 00:00:00	2015-01-04	2015-01-04 00:00:00	\N	38000177		0	0	0		0	0	0	259612	0	00025152531	44923712		
36060	2970	19078461	2015-01-15	2015-01-15 00:00:00	2015-02-14	2015-02-14 00:00:00	2015-02-14	38000177		0	0	30		0	0	0	198343	0	310965	19078461		
5721	480	1127433	1960-07-08	1960-07-08 00:00:00	1960-07-22	1960-07-22 00:00:00	1960-07-22	38000177		0	0	14		0	0	0	31966	0	313782	1127433		
14825	320	40213227	1998-03-01	1998-03-01 00:00:00	1998-03-01	1998-03-01 00:00:00	1998-03-01	581452		0	0	0		0	0	0	21251	0	113	40213227		
47798	3962	40236824	1997-06-21	1997-06-21 00:00:00	1997-06-28	1997-06-28 00:00:00	1997-06-28	38000177		0	0	7		0	0	0	263449	0	1094107	40236824		
13407	1124	1127433	1971-10-02	1971-10-02 00:00:00	1971-10-16	1971-10-16 00:00:00	1971-10-16	38000177		0	0	14		0	0	0	74112	0	313782	1127433		
41013	3401	19129655	1962-10-30	1962-10-30 00:00:00	1962-11-13	1962-11-13 00:00:00	1962-11-13	38000177		0	0	14		0	0	0	225648	0	789980	19129655		
21113	1740	19115351	1952-09-06	1952-09-06 00:00:00	1953-01-31	1953-01-31 00:00:00	1953-01-31	38000177		0	0	147		0	0	0	116290	0	563026	19115351		
3187	263	19006318	1960-02-12	1960-02-12 00:00:00	1960-02-26	1960-02-26 00:00:00	1960-02-26	38000177		0	0	14		0	0	0	17481	0	105078	19006318		
3224	264	19078461	1995-06-05	1995-06-05 00:00:00	1995-06-19	1995-06-19 00:00:00	1995-06-19	38000177		0	0	14		0	0	0	17587	0	310965	19078461		
4393	364	40229134	1948-01-20	1948-01-20 00:00:00	1948-02-03	1948-02-03 00:00:00	1948-02-03	38000177		0	0	14		0	0	0	24214	0	1043400	40229134		
6975	587	19128022	1995-03-03	1995-03-03 00:00:00	1996-02-26	1996-02-26 00:00:00	1996-02-26	38000177		0	0	360		0	0	0	38873	0	749785	19128022		
11599	967	40229134	2018-03-08	2018-03-08 00:00:00	2018-03-22	2018-03-22 00:00:00	2018-03-22	38000177		0	0	14		0	0	0	64366	0	1043400	40229134		
6161	515	40229134	1966-05-11	1966-05-11 00:00:00	1966-05-25	1966-05-25 00:00:00	1966-05-25	38000177		0	0	14		0	0	0	34414	0	1043400	40229134		
53718	1176	40213227	2004-03-12	2004-03-12 00:00:00	2004-03-12	2004-03-12 00:00:00	2004-03-12	581452		0	0	0		0	0	0	77585	0	113	40213227		
240	17	920334	2000-02-20	2000-02-20 00:00:00	2000-02-27	2000-02-27 00:00:00	2000-02-27	38000177		0	0	7		0	0	0	1315	0	311995	920334		
43	2	19078461	1993-03-29	1993-03-29 00:00:00	1993-05-28	1993-05-28 00:00:00	1993-05-28	38000177		0	0	60		0	0	0	117	0	310965	19078461		
17812	1476	1124300	1980-06-27	1980-06-27 00:00:00	1980-06-27	1980-06-27 00:00:00	\N	38000177		0	0	0		0	0	0	98386	0	00781178901	45011828		
12662	273	40213227	2007-12-02	2007-12-02 00:00:00	2007-12-02	2007-12-02 00:00:00	2007-12-02	581452		0	0	0		0	0	0	18232	0	113	40213227		
10665	886	19133873	1992-07-06	1992-07-06 00:00:00	1992-07-18	1992-07-18 00:00:00	1992-07-18	38000177		0	0	12		0	0	0	59079	0	834061	19133873		
36223	2985	19059056	1979-08-26	1979-08-26 00:00:00	1979-09-16	1979-09-16 00:00:00	1979-09-16	38000177		0	0	21		0	0	0	199187	0	243670	19059056		
37984	3141	1124300	2010-09-15	2010-09-15 00:00:00	2010-09-15	2010-09-15 00:00:00	\N	38000177		0	0	0		0	0	0	208971	0	00781178901	45011828		
59691	4963	19133873	1986-08-26	1986-08-26 00:00:00	1986-09-07	1986-09-07 00:00:00	1986-09-07	38000177		0	0	12		0	0	0	329867	0	834061	19133873		
39038	3226	1713671	1997-05-22	1997-05-22 00:00:00	1997-07-17	1997-07-17 00:00:00	1997-07-17	38000177		0	0	56		0	0	0	214458	0	562251	1713671		
30203	2503	19128022	1993-01-21	1993-01-21 00:00:00	1994-01-16	1994-01-16 00:00:00	1994-01-16	38000177		0	0	360		0	0	0	165655	0	749785	19128022		
27076	2233	19128065	1991-12-28	1991-12-28 00:00:00	1992-12-22	1992-12-22 00:00:00	1992-12-22	38000177		0	0	360		0	0	0	148563	0	749882	19128065		
142960	3141	40213296	2011-02-13	2011-02-13 00:00:00	2011-02-13	2011-02-13 00:00:00	2011-02-13	581452		0	0	0		0	0	0	208967	0	52	40213296		
30264	2509	19133905	2006-05-02	2006-05-02 00:00:00	2006-05-13	2006-05-13 00:00:00	2006-05-13	38000177		0	0	11		0	0	0	166050	0	834102	19133905		
42677	3537	1127433	1990-12-22	1990-12-22 00:00:00	1990-12-29	1990-12-29 00:00:00	1990-12-29	38000177		0	0	7		0	0	0	234897	0	313782	1127433		
37704	3117	19133873	1981-08-01	1981-08-01 00:00:00	1981-08-11	1981-08-11 00:00:00	1981-08-11	38000177		0	0	10		0	0	0	207367	0	834061	19133873		
41185	3415	19133905	2008-09-28	2008-09-28 00:00:00	2008-10-06	2008-10-06 00:00:00	2008-10-06	38000177		0	0	8		0	0	0	226532	0	834102	19133905		
1905	152	35605482	1973-12-15	1973-12-15 00:00:00	1973-12-15	1973-12-15 00:00:00	1973-12-15	38000177		0	0	0		0	0	0	10291	0	1740467	35605482		
61961	5153	1118084	1987-02-05	1987-02-05 00:00:00	1987-02-05	1987-02-05 00:00:00	\N	38000177		0	0	0		0	0	0	342690	0	00025152531	44923712		
53359	4435	19075601	2002-04-15	2002-04-15 00:00:00	2002-04-15	2002-04-15 00:00:00	\N	38000177		0	0	0		0	0	0	294776	0	309362	19075601		
63207	5252	40236824	2015-12-30	2015-12-30 00:00:00	2016-01-06	2016-01-06 00:00:00	2016-01-06	38000177		0	0	7		0	0	0	349416	0	1094107	40236824		
20846	1719	40229134	1973-03-18	1973-03-18 00:00:00	1973-03-25	1973-03-25 00:00:00	1973-03-25	38000177		0	0	7		0	0	0	114921	0	1043400	40229134		
56162	4662	42707627	1989-07-27	1989-07-27 00:00:00	1989-07-27	1989-07-27 00:00:00	1989-07-27	38000177		0	0	0		0	0	0	310773	0	1234995	42707627		
4913	409	40232448	1955-10-26	1955-10-26 00:00:00	1955-10-26	1955-10-26 00:00:00	\N	38000177		0	0	0		0	0	0	27087	0	1049630	40232448		
8387	700	40231925	1997-06-05	1997-06-05 00:00:00	1997-06-05	1997-06-05 00:00:00	\N	38000177		0	0	0		0	0	0	46234	0	1049221	40231925		
11661	970	19133905	1997-03-10	1997-03-10 00:00:00	1997-03-21	1997-03-21 00:00:00	1997-03-21	38000177		0	0	11		0	0	0	64521	0	834102	19133905		
20212	1658	1332419	1996-02-19	1996-02-19 00:00:00	1996-02-19	1996-02-19 00:00:00	\N	38000177		0	0	0		0	0	0	111269	0	197361	1332419		
36681	3026	1124300	1996-04-27	1996-04-27 00:00:00	1996-04-27	1996-04-27 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00781178901	45011828		
30704	669	40213296	2010-11-03	2010-11-03 00:00:00	2010-11-03	2010-11-03 00:00:00	2010-11-03	581452		0	0	0		0	0	0	44191	0	52	40213296		
42162	3495	1713671	1996-02-21	1996-02-21 00:00:00	1996-03-06	1996-03-06 00:00:00	1996-03-06	38000177		0	0	14		0	0	0	231829	0	562251	1713671		
14525	1217	19059056	1988-10-20	1988-10-20 00:00:00	1988-11-24	1988-11-24 00:00:00	1988-11-24	38000177		0	0	35		0	0	0	80181	0	243670	19059056		
29645	2456	19006318	1956-05-18	1956-05-18 00:00:00	1956-06-01	1956-06-01 00:00:00	1956-06-01	38000177		0	0	14		0	0	0	162812	0	105078	19006318		
1817	145	1127433	1981-07-06	1981-07-06 00:00:00	1981-08-05	1981-08-05 00:00:00	1981-08-05	38000177		0	0	30		0	0	0	9800	0	313782	1127433		
25148	2070	19129655	1968-02-08	1968-02-08 00:00:00	1968-02-22	1968-02-22 00:00:00	1968-02-22	38000177		0	0	14		0	0	0	137734	0	789980	19129655		
134574	2953	40213160	1983-02-18	1983-02-18 00:00:00	1983-02-18	1983-02-18 00:00:00	1983-02-18	581452		0	0	0		0	0	0	197131	0	10	40213160		
63317	5259	1713671	1972-02-10	1972-02-10 00:00:00	1972-02-24	1972-02-24 00:00:00	1972-02-24	38000177		0	0	14		0	0	0	349934	0	562251	1713671		
12116	1016	40236824	2010-08-18	2010-08-18 00:00:00	2010-09-01	2010-09-01 00:00:00	2010-09-01	38000177		0	0	14		0	0	0	66898	0	1094107	40236824		
43585	3613	19133873	1991-10-18	1991-10-18 00:00:00	1991-10-26	1991-10-26 00:00:00	1991-10-26	38000177		0	0	8		0	0	0	240045	0	834061	19133873		
38068	830	40213160	1963-11-06	1963-11-06 00:00:00	1963-11-06	1963-11-06 00:00:00	1963-11-06	581452		0	0	0		0	0	0	55019	0	10	40213160		
15229	1272	1127078	1985-04-06	1985-04-06 00:00:00	1985-04-20	1985-04-20 00:00:00	1985-04-20	38000177		0	0	14		0	0	0	83942	0	282464	1127078		
60540	5035	19059056	1948-04-19	1948-04-19 00:00:00	1948-07-18	1948-07-18 00:00:00	1948-07-18	38000177		0	0	90		0	0	0	334618	0	243670	19059056		
55248	4587	45892894	2016-01-26	2016-01-26 00:00:00	2016-01-26	2016-01-26 00:00:00	\N	38000177		0	0	0		0	0	0	305600	0	1599803	45892894		
33667	2786	19059056	1957-03-05	1957-03-05 00:00:00	1957-04-02	1957-04-02 00:00:00	1957-04-02	38000177		0	0	28		0	0	0	184610	0	243670	19059056		
43853	3631	1127433	1994-03-03	1994-03-03 00:00:00	1994-03-10	1994-03-10 00:00:00	1994-03-10	38000177		0	0	7		0	0	0	241604	0	313782	1127433		
26399	2172	19078461	2007-07-07	2007-07-07 00:00:00	2007-09-05	2007-09-05 00:00:00	2007-09-05	38000177		0	0	60		0	0	0	144702	0	310965	19078461		
36432	3004	1127078	1951-01-01	1951-01-01 00:00:00	1951-01-15	1951-01-15 00:00:00	1951-01-15	38000177		0	0	14		0	0	0	200471	0	282464	1127078		
28159	2328	19133873	1961-04-08	1961-04-08 00:00:00	1961-04-18	1961-04-18 00:00:00	1961-04-18	38000177		0	0	10		0	0	0	154814	0	834061	19133873		
11081	923	1127433	2001-05-22	2001-05-22 00:00:00	2001-06-05	2001-06-05 00:00:00	2001-06-05	38000177		0	0	14		0	0	0	61422	0	313782	1127433		
21616	1776	1127433	1977-05-08	1977-05-08 00:00:00	1977-05-15	1977-05-15 00:00:00	1977-05-15	38000177		0	0	7		0	0	0	118783	0	313782	1127433		
21917	1796	19078461	1997-06-28	1997-06-28 00:00:00	1997-07-12	1997-07-12 00:00:00	1997-07-12	38000177		0	0	14		0	0	0	120433	0	310965	19078461		
47109	3904	40229134	1995-05-05	1995-05-05 00:00:00	1995-05-12	1995-05-12 00:00:00	1995-05-12	38000177		0	0	7		0	0	0	259594	0	1043400	40229134		
36061	2970	19008572	1999-04-17	1999-04-17 00:00:00	1999-04-17	1999-04-17 00:00:00	\N	38000177		0	0	0		0	0	0	198321	0	106258	19008572		
5722	480	1127433	1994-11-07	1994-11-07 00:00:00	1994-11-14	1994-11-14 00:00:00	1994-11-14	38000177		0	0	7		0	0	0	32027	0	313782	1127433		
14826	320	40213296	1998-03-01	1998-03-01 00:00:00	1998-03-01	1998-03-01 00:00:00	1998-03-01	581452		0	0	0		0	0	0	21251	0	52	40213296		
47800	3962	19078461	2011-12-09	2011-12-09 00:00:00	2011-12-23	2011-12-23 00:00:00	2011-12-23	38000177		0	0	14		0	0	0	263466	0	310965	19078461		
13408	1124	1127433	1998-11-20	1998-11-20 00:00:00	1998-12-04	1998-12-04 00:00:00	1998-12-04	38000177		0	0	14		0	0	0	74077	0	313782	1127433		
41014	3401	1127433	1982-08-02	1982-08-02 00:00:00	1982-08-09	1982-08-09 00:00:00	1982-08-09	38000177		0	0	7		0	0	0	225616	0	313782	1127433		
21114	1740	1713671	1995-10-10	1995-10-10 00:00:00	1995-10-17	1995-10-17 00:00:00	1995-10-17	38000177		0	0	7		0	0	0	116306	0	562251	1713671		
3188	263	19059056	1958-03-31	1958-03-31 00:00:00	1958-04-14	1958-04-14 00:00:00	1958-04-14	38000177		0	0	14		0	0	0	17421	0	243670	19059056		
3225	264	19133873	1958-05-04	1958-05-04 00:00:00	1958-05-13	1958-05-13 00:00:00	1958-05-13	38000177		0	0	9		0	0	0	17507	0	834061	19133873		
4394	364	19059056	1947-10-20	1947-10-20 00:00:00	1947-11-03	1947-11-03 00:00:00	1947-11-03	38000177		0	0	14		0	0	0	24136	0	243670	19059056		
6976	587	19128065	1994-03-08	1994-03-08 00:00:00	1995-03-03	1995-03-03 00:00:00	1995-03-03	38000177		0	0	360		0	0	0	38871	0	749882	19128065		
11600	967	1127433	1956-10-26	1956-10-26 00:00:00	1956-11-09	1956-11-09 00:00:00	1956-11-09	38000177		0	0	14		0	0	0	64277	0	313782	1127433		
11617	967	19075601	2011-07-16	2011-07-16 00:00:00	2011-07-16	2011-07-16 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	309362	19075601		
53719	1176	40213296	2004-03-12	2004-03-12 00:00:00	2004-03-12	2004-03-12 00:00:00	2004-03-12	581452		0	0	0		0	0	0	77585	0	52	40213296		
242	17	1127433	2012-11-25	2012-11-25 00:00:00	2012-12-09	2012-12-09 00:00:00	2012-12-09	38000177		0	0	14		0	0	0	1326	0	313782	1127433		
44	2	1127433	1980-07-27	1980-07-27 00:00:00	1980-08-10	1980-08-10 00:00:00	1980-08-10	38000177		0	0	14		0	0	0	140	0	313782	1127433		
17814	1476	40231925	1956-11-01	1956-11-01 00:00:00	1956-11-01	1956-11-01 00:00:00	\N	38000177		0	0	0		0	0	0	98492	0	1049221	40231925		
12665	273	40213160	1976-05-23	1976-05-23 00:00:00	1976-05-23	1976-05-23 00:00:00	1976-05-23	581452		0	0	0		0	0	0	18299	0	10	40213160		
10666	886	19059056	1989-01-03	1989-01-03 00:00:00	1989-01-17	1989-01-17 00:00:00	1989-01-17	38000177		0	0	14		0	0	0	59074	0	243670	19059056		
36224	2985	1713671	1981-02-07	1981-02-07 00:00:00	1981-02-21	1981-02-21 00:00:00	1981-02-21	38000177		0	0	14		0	0	0	199229	0	562251	1713671		
37985	3141	40229134	1979-08-25	1979-08-25 00:00:00	1979-09-08	1979-09-08 00:00:00	1979-09-08	38000177		0	0	14		0	0	0	208965	0	1043400	40229134		
59692	4963	19059056	1981-12-28	1981-12-28 00:00:00	1982-02-01	1982-02-01 00:00:00	1982-02-01	38000177		0	0	35		0	0	0	329966	0	243670	19059056		
39039	3226	19133905	2004-10-24	2004-10-24 00:00:00	2004-11-03	2004-11-03 00:00:00	2004-11-03	38000177		0	0	10		0	0	0	214476	0	834102	19133905		
30204	2503	1127433	1999-01-07	1999-01-07 00:00:00	1999-01-21	1999-01-21 00:00:00	1999-01-21	38000177		0	0	14		0	0	0	165651	0	313782	1127433		
27077	2233	19133873	1976-01-15	1976-01-15 00:00:00	1976-01-27	1976-01-27 00:00:00	1976-01-27	38000177		0	0	12		0	0	0	148583	0	834061	19133873		
142965	3141	40213160	1976-01-18	1976-01-18 00:00:00	1976-01-18	1976-01-18 00:00:00	1976-01-18	581452		0	0	0		0	0	0	209016	0	10	40213160		
30265	2509	1118084	2006-05-20	2006-05-20 00:00:00	2006-05-20	2006-05-20 00:00:00	\N	38000177		0	0	0		0	0	0	166050	0	00025152531	44923712		
42678	3537	1127433	1980-08-01	1980-08-01 00:00:00	1980-08-31	1980-08-31 00:00:00	1980-08-31	38000177		0	0	30		0	0	0	234966	0	313782	1127433		
37705	3117	19075001	2005-03-16	2005-03-16 00:00:00	2005-03-30	2005-03-30 00:00:00	2005-03-30	38000177		0	0	14		0	0	0	207392	0	309097	19075001		
41186	3415	19133905	2008-05-22	2008-05-22 00:00:00	2008-05-29	2008-05-29 00:00:00	2008-05-29	38000177		0	0	7		0	0	0	226502	0	834102	19133905		
1906	152	40220386	1973-12-15	1973-12-15 00:00:00	1973-12-15	1973-12-15 00:00:00	1973-12-15	38000177		0	0	0		0	0	0	10291	0	1808217	40220386		
61962	5153	1713671	2001-12-09	2001-12-09 00:00:00	2001-12-23	2001-12-23 00:00:00	2001-12-23	38000177		0	0	14		0	0	0	342731	0	562251	1713671		
53360	4435	1539411	2002-04-15	2002-04-15 00:00:00	2002-04-15	2002-04-15 00:00:00	\N	38000177		0	0	0		0	0	0	294776	0	312961	1539411		
63208	5252	920300	2015-12-30	2015-12-30 00:00:00	2016-01-06	2016-01-06 00:00:00	2016-01-06	38000177		0	0	7		0	0	0	349416	0	311989	920300		
20847	1719	1115171	2006-02-20	2006-02-20 00:00:00	2006-03-13	2006-03-13 00:00:00	2006-03-13	38000177		0	0	21		0	0	0	114997	0	849574	1115171		
56163	4662	1713671	1958-12-26	1958-12-26 00:00:00	1959-01-09	1959-01-09 00:00:00	1959-01-09	38000177		0	0	14		0	0	0	310786	0	562251	1713671		
4914	409	19059056	1955-10-10	1955-10-10 00:00:00	1955-11-09	1955-11-09 00:00:00	1955-11-09	38000177		0	0	30		0	0	0	27149	0	243670	19059056		
8388	700	1118084	2014-12-27	2014-12-27 00:00:00	2014-12-27	2014-12-27 00:00:00	\N	38000177		0	0	0		0	0	0	46261	0	00025152531	44923712		
11662	970	1127078	1956-11-14	1956-11-14 00:00:00	1956-11-28	1956-11-28 00:00:00	1956-11-28	38000177		0	0	14		0	0	0	64531	0	282464	1127078		
20213	1658	19126352	1996-02-19	1996-02-19 00:00:00	1996-02-19	1996-02-19 00:00:00	\N	38000177		0	0	0		0	0	0	111269	0	705129	19126352		
47149	3909	19129655	1962-08-21	1962-08-21 00:00:00	1962-09-04	1962-09-04 00:00:00	1962-09-04	38000177		0	0	14		0	0	0	259871	0	789980	19129655		
111373	2447	40213306	2002-09-25	2002-09-25 00:00:00	2002-09-25	2002-09-25 00:00:00	2002-09-25	581452		0	0	0		0	0	0	162326	0	43	40213306		
42163	3495	1127433	1981-05-14	1981-05-14 00:00:00	1981-05-28	1981-05-28 00:00:00	1981-05-28	38000177		0	0	14		0	0	0	231813	0	313782	1127433		
14526	1217	1124300	2013-02-26	2013-02-26 00:00:00	2013-02-26	2013-02-26 00:00:00	\N	38000177		0	0	0		0	0	0	80152	0	00781178901	45011828		
29646	2456	19059056	1956-05-18	1956-05-18 00:00:00	1956-06-01	1956-06-01 00:00:00	1956-06-01	38000177		0	0	14		0	0	0	162812	0	243670	19059056		
1818	145	1127433	1969-05-17	1969-05-17 00:00:00	1969-05-31	1969-05-31 00:00:00	1969-05-31	38000177		0	0	14		0	0	0	9673	0	313782	1127433		
25149	2070	1118084	2008-07-02	2008-07-02 00:00:00	2008-07-02	2008-07-02 00:00:00	\N	38000177		0	0	0		0	0	0	137753	0	00025152531	44923712		
45895	3799	1127078	1976-02-13	1976-02-13 00:00:00	1976-02-27	1976-02-27 00:00:00	1976-02-27	38000177		0	0	14		0	0	0	252535	0	282464	1127078		
63318	5259	1713671	2012-02-01	2012-02-01 00:00:00	2012-02-22	2012-02-22 00:00:00	2012-02-22	38000177		0	0	21		0	0	0	350000	0	562251	1713671		
12117	1016	1127433	2013-06-02	2013-06-02 00:00:00	2013-06-16	2013-06-16 00:00:00	2013-06-16	38000177		0	0	14		0	0	0	66901	0	313782	1127433		
43586	3613	46233988	1977-10-16	1977-10-16 00:00:00	1977-10-30	1977-10-30 00:00:00	1977-10-30	38000177		0	0	14		0	0	0	240033	0	1652673	46233988		
38075	830	40213160	1959-05-06	1959-05-06 00:00:00	1959-05-06	1959-05-06 00:00:00	1959-05-06	581452		0	0	0		0	0	0	55015	0	10	40213160		
15230	1272	19075001	1985-04-06	1985-04-06 00:00:00	1985-04-20	1985-04-20 00:00:00	1985-04-20	38000177		0	0	14		0	0	0	83942	0	309097	19075001		
60541	5035	19133905	1976-04-21	1976-04-21 00:00:00	1976-05-01	1976-05-01 00:00:00	1976-05-01	38000177		0	0	10		0	0	0	334639	0	834102	19133905		
55249	4587	1127433	1960-04-01	1960-04-01 00:00:00	1960-06-07	1960-06-07 00:00:00	1960-06-07	38000177		0	0	67		0	0	0	305567	0	313782	1127433		
33668	2786	19006318	1957-03-05	1957-03-05 00:00:00	1957-04-02	1957-04-02 00:00:00	1957-04-02	38000177		0	0	28		0	0	0	184610	0	105078	19006318		
43854	3631	40229134	1978-09-10	1978-09-10 00:00:00	1978-09-17	1978-09-17 00:00:00	1978-09-17	38000177		0	0	7		0	0	0	241616	0	1043400	40229134		
26400	2173	1713671	1949-07-07	1949-07-07 00:00:00	1949-07-28	1949-07-28 00:00:00	1949-07-28	38000177		0	0	21		0	0	0	144728	0	562251	1713671		
36433	3004	19006318	1951-01-01	1951-01-01 00:00:00	1951-01-15	1951-01-15 00:00:00	1951-01-15	38000177		0	0	14		0	0	0	200471	0	105078	19006318		
28160	2328	1713671	1993-08-22	1993-08-22 00:00:00	1993-10-03	1993-10-03 00:00:00	1993-10-03	38000177		0	0	42		0	0	0	154854	0	562251	1713671		
11082	923	1713671	1999-05-14	1999-05-14 00:00:00	1999-05-28	1999-05-28 00:00:00	1999-05-28	38000177		0	0	14		0	0	0	61421	0	562251	1713671		
21617	1776	19059056	1921-06-27	1921-06-27 00:00:00	1921-07-11	1921-07-11 00:00:00	1921-07-11	38000177		0	0	14		0	0	0	118790	0	243670	19059056		
21918	1796	42902245	1999-02-28	1999-02-28 00:00:00	2000-02-23	2000-02-23 00:00:00	2000-02-23	38000177		0	0	360		0	0	0	120416	0	1359133	42902245		
47110	3904	1127078	1984-12-03	1984-12-03 00:00:00	1984-12-17	1984-12-17 00:00:00	1984-12-17	38000177		0	0	14		0	0	0	259641	0	282464	1127078		
36062	2970	19133905	2017-05-23	2017-05-23 00:00:00	2017-05-30	2017-05-30 00:00:00	2017-05-30	38000177		0	0	7		0	0	0	198390	0	834102	19133905		
5723	480	1118084	1983-06-22	1983-06-22 00:00:00	1983-06-22	1983-06-22 00:00:00	\N	38000177		0	0	0		0	0	0	32010	0	00025152531	44923712		
14828	320	40213160	1956-05-27	1956-05-27 00:00:00	1956-05-27	1956-05-27 00:00:00	1956-05-27	581452		0	0	0		0	0	0	21208	0	10	40213160		
47801	3962	19059056	1981-09-21	1981-09-21 00:00:00	1981-10-12	1981-10-12 00:00:00	1981-10-12	38000177		0	0	21		0	0	0	263463	0	243670	19059056		
13409	1124	1127433	1940-07-21	1940-07-21 00:00:00	1940-07-28	1940-07-28 00:00:00	1940-07-28	38000177		0	0	7		0	0	0	74094	0	313782	1127433		
41023	3403	19128065	1986-03-12	1986-03-12 00:00:00	1987-03-07	1987-03-07 00:00:00	1987-03-07	38000177		0	0	360		0	0	0	225723	0	749882	19128065		
21115	1740	19059056	1957-02-12	1957-02-12 00:00:00	1957-02-26	1957-02-26 00:00:00	1957-02-26	38000177		0	0	14		0	0	0	116267	0	243670	19059056		
3189	263	1127433	2010-11-05	2010-11-05 00:00:00	2011-01-04	2011-01-04 00:00:00	2011-01-04	38000177		0	0	60		0	0	0	17423	0	313782	1127433		
3226	264	1127433	1984-09-16	1984-09-16 00:00:00	1984-09-30	1984-09-30 00:00:00	1984-09-30	38000177		0	0	14		0	0	0	17586	0	313782	1127433		
4395	364	19006318	1947-10-20	1947-10-20 00:00:00	1947-11-03	1947-11-03 00:00:00	1947-11-03	38000177		0	0	14		0	0	0	24136	0	105078	19006318		
6977	587	19128022	1996-02-26	1996-02-26 00:00:00	1997-02-20	1997-02-20 00:00:00	1997-02-20	38000177		0	0	360		0	0	0	38874	0	749785	19128022		
11601	967	1127433	2014-06-01	2014-06-01 00:00:00	2014-06-15	2014-06-15 00:00:00	2014-06-15	38000177		0	0	14		0	0	0	64279	0	313782	1127433		
11618	967	1713671	1947-05-29	1947-05-29 00:00:00	1947-07-03	1947-07-03 00:00:00	1947-07-03	38000177		0	0	35		0	0	0	64345	0	562251	1713671		
53727	1176	40213296	2005-04-15	2005-04-15 00:00:00	2005-04-15	2005-04-15 00:00:00	2005-04-15	581452		0	0	0		0	0	0	\N	0	52	40213296		
244	17	19074679	1966-10-31	1966-10-31 00:00:00	1967-05-01	1967-05-01 00:00:00	1967-05-01	38000177		0	0	182		0	0	0	1364	0	308971	19074679		
45	2	1127433	1955-10-22	1955-10-22 00:00:00	1955-10-29	1955-10-29 00:00:00	1955-10-29	38000177		0	0	7		0	0	0	103	0	313782	1127433		
17815	1476	19059056	1956-11-01	1956-11-01 00:00:00	1956-12-31	1956-12-31 00:00:00	1956-12-31	38000177		0	0	60		0	0	0	98492	0	243670	19059056		
12667	273	40213306	1996-07-07	1996-07-07 00:00:00	1996-07-07	1996-07-07 00:00:00	1996-07-07	581452		0	0	0		0	0	0	\N	0	43	40213306		
25699	2114	1310034	1988-06-15	1988-06-15 00:00:00	1988-06-15	1988-06-15 00:00:00	1988-06-15	38000177		0	0	0		0	0	0	140683	0	834357	1310034		
36225	2985	19078461	2016-07-13	2016-07-13 00:00:00	2016-10-11	2016-10-11 00:00:00	2016-10-11	38000177		0	0	90		0	0	0	199192	0	310965	19078461		
37986	3141	19078461	1998-05-28	1998-05-28 00:00:00	1998-06-11	1998-06-11 00:00:00	1998-06-11	38000177		0	0	14		0	0	0	208990	0	310965	19078461		
59693	4963	1127078	1980-01-08	1980-01-08 00:00:00	1980-01-22	1980-01-22 00:00:00	1980-01-22	38000177		0	0	14		0	0	0	329909	0	282464	1127078		
39040	3226	1118084	2012-07-07	2012-07-07 00:00:00	2012-07-07	2012-07-07 00:00:00	\N	38000177		0	0	0		0	0	0	214496	0	00025152531	44923712		
30205	2503	1118084	2017-02-24	2017-02-24 00:00:00	2017-02-24	2017-02-24 00:00:00	\N	38000177		0	0	0		0	0	0	165729	0	00025152531	44923712		
27078	2233	40229134	2013-06-03	2013-06-03 00:00:00	2013-06-10	2013-06-10 00:00:00	2013-06-10	38000177		0	0	7		0	0	0	148562	0	1043400	40229134		
142972	3141	40213296	2013-02-17	2013-02-17 00:00:00	2013-02-17	2013-02-17 00:00:00	2013-02-17	581452		0	0	0		0	0	0	208970	0	52	40213296		
30266	2509	1127433	1972-06-24	1972-06-24 00:00:00	1972-07-01	1972-07-01 00:00:00	1972-07-01	38000177		0	0	7		0	0	0	166049	0	313782	1127433		
42679	3537	1127433	2015-08-28	2015-08-28 00:00:00	2015-09-11	2015-09-11 00:00:00	2015-09-11	38000177		0	0	14		0	0	0	234967	0	313782	1127433		
37706	3117	1127433	2005-03-16	2005-03-16 00:00:00	2005-03-30	2005-03-30 00:00:00	2005-03-30	38000177		0	0	14		0	0	0	207392	0	313782	1127433		
41187	3415	40229134	1992-01-28	1992-01-28 00:00:00	1992-02-04	1992-02-04 00:00:00	1992-02-04	38000177		0	0	7		0	0	0	226519	0	1043400	40229134		
1907	152	42707627	1973-12-15	1973-12-15 00:00:00	1973-12-15	1973-12-15 00:00:00	1973-12-15	38000177		0	0	0		0	0	0	10291	0	1234995	42707627		
61963	5153	19133905	1972-01-07	1972-01-07 00:00:00	1972-01-17	1972-01-17 00:00:00	1972-01-17	38000177		0	0	10		0	0	0	342679	0	834102	19133905		
53361	4435	1332419	2002-04-15	2002-04-15 00:00:00	2002-04-15	2002-04-15 00:00:00	\N	38000177		0	0	0		0	0	0	294776	0	197361	1332419		
63209	5252	19075601	2018-11-27	2018-11-27 00:00:00	2018-11-27	2018-11-27 00:00:00	2018-11-27	38000177		0	0	0		0	0	0	349481	0	309362	19075601		
20848	1719	40169216	1961-04-15	1961-04-15 00:00:00	1961-04-15	1961-04-15 00:00:00	\N	38000177		0	0	0		0	0	0	114883	0	895994	40169216		
56164	4662	1115171	1998-07-29	1998-07-29 00:00:00	1998-08-19	1998-08-19 00:00:00	1998-08-19	38000177		0	0	21		0	0	0	310774	0	849574	1115171		
4915	409	1713671	1994-12-06	1994-12-06 00:00:00	1994-12-13	1994-12-13 00:00:00	1994-12-13	38000177		0	0	7		0	0	0	27045	0	562251	1713671		
8389	700	1713671	2000-10-17	2000-10-17 00:00:00	2000-10-31	2000-10-31 00:00:00	2000-10-31	38000177		0	0	14		0	0	0	46235	0	562251	1713671		
11663	970	19006318	1956-11-14	1956-11-14 00:00:00	1956-11-28	1956-11-28 00:00:00	1956-11-28	38000177		0	0	14		0	0	0	64531	0	105078	19006318		
20214	1658	1539411	1996-02-19	1996-02-19 00:00:00	1996-02-19	1996-02-19 00:00:00	\N	38000177		0	0	0		0	0	0	111269	0	312961	1539411		
47150	3909	1118084	1999-08-29	1999-08-29 00:00:00	1999-08-29	1999-08-29 00:00:00	\N	38000177		0	0	0		0	0	0	259864	0	00025152531	44923712		
111377	2447	40213227	2011-10-05	2011-10-05 00:00:00	2011-10-05	2011-10-05 00:00:00	2011-10-05	581452		0	0	0		0	0	0	162329	0	113	40213227		
42164	3495	1127433	2008-10-06	2008-10-06 00:00:00	2008-10-20	2008-10-20 00:00:00	2008-10-20	38000177		0	0	14		0	0	0	231854	0	313782	1127433		
14527	1217	1127433	2006-12-13	2006-12-13 00:00:00	2006-12-27	2006-12-27 00:00:00	2006-12-27	38000177		0	0	14		0	0	0	80167	0	313782	1127433		
29647	2456	1713671	2018-06-09	2018-06-09 00:00:00	2018-06-23	2018-06-23 00:00:00	2018-06-23	38000177		0	0	14		0	0	0	162811	0	562251	1713671		
1819	145	19133905	1991-08-21	1991-08-21 00:00:00	1991-08-31	1991-08-31 00:00:00	1991-08-31	38000177		0	0	10		0	0	0	9747	0	834102	19133905		
25150	2070	19059056	1993-10-08	1993-10-08 00:00:00	1993-10-29	1993-10-29 00:00:00	1993-10-29	38000177		0	0	21		0	0	0	137728	0	243670	19059056		
45896	3799	40229134	2007-07-12	2007-07-12 00:00:00	2007-07-26	2007-07-26 00:00:00	2007-07-26	38000177		0	0	14		0	0	0	252590	0	1043400	40229134		
63319	5259	40165015	2008-04-26	2008-04-26 00:00:00	2008-04-26	2008-04-26 00:00:00	\N	38000177		0	0	0		0	0	0	350015	0	861467	40165015		
12118	1016	19128065	1983-05-31	1983-05-31 00:00:00	1984-05-25	1984-05-25 00:00:00	1984-05-25	38000177		0	0	360		0	0	0	66923	0	749882	19128065		
43587	3613	1127078	1977-10-16	1977-10-16 00:00:00	1977-10-30	1977-10-30 00:00:00	1977-10-30	38000177		0	0	14		0	0	0	240033	0	282464	1127078		
38079	830	40213160	1959-08-05	1959-08-05 00:00:00	1959-08-05	1959-08-05 00:00:00	1959-08-05	581452		0	0	0		0	0	0	54947	0	10	40213160		
15231	1272	1127078	1982-06-30	1982-06-30 00:00:00	1982-07-14	1982-07-14 00:00:00	1982-07-14	38000177		0	0	14		0	0	0	83912	0	282464	1127078		
60542	5035	1118084	1969-06-07	1969-06-07 00:00:00	1969-06-07	1969-06-07 00:00:00	\N	38000177		0	0	0		0	0	0	334625	0	00025152531	44923712		
55250	4587	1115171	2011-09-29	2011-09-29 00:00:00	2011-11-28	2011-11-28 00:00:00	2011-11-28	38000177		0	0	60		0	0	0	305570	0	849574	1115171		
33669	2786	40162522	1957-03-05	1957-03-05 00:00:00	1957-03-05	1957-03-05 00:00:00	\N	38000177		0	0	0		0	0	0	184610	0	857005	40162522		
43855	3631	40229134	2015-03-22	2015-03-22 00:00:00	2015-03-29	2015-03-29 00:00:00	2015-03-29	38000177		0	0	7		0	0	0	241607	0	1043400	40229134		
26401	2173	19059056	1942-08-04	1942-08-04 00:00:00	1942-10-23	1942-10-23 00:00:00	1942-10-23	38000177		0	0	80		0	0	0	144758	0	243670	19059056		
36434	3004	1127433	1992-10-22	1992-10-22 00:00:00	1992-11-05	1992-11-05 00:00:00	1992-11-05	38000177		0	0	14		0	0	0	200512	0	313782	1127433		
39965	3308	19133873	1950-08-14	1950-08-14 00:00:00	1950-08-22	1950-08-22 00:00:00	1950-08-22	38000177		0	0	8		0	0	0	219657	0	834061	19133873		
11083	923	1713671	2005-01-31	2005-01-31 00:00:00	2005-02-14	2005-02-14 00:00:00	2005-02-14	38000177		0	0	14		0	0	0	61423	0	562251	1713671		
21618	1776	19059056	1922-09-09	1922-09-09 00:00:00	1922-12-08	1922-12-08 00:00:00	1922-12-08	38000177		0	0	90		0	0	0	118800	0	243670	19059056		
7903	170	40213160	1976-01-15	1976-01-15 00:00:00	1976-01-15	1976-01-15 00:00:00	1976-01-15	581452		0	0	0		0	0	0	11576	0	10	40213160		
47111	3904	19074843	1984-12-03	1984-12-03 00:00:00	1984-12-17	1984-12-17 00:00:00	1984-12-17	38000177		0	0	14		0	0	0	259641	0	309045	19074843		
36063	2970	1127433	1993-01-19	1993-01-19 00:00:00	1993-02-09	1993-02-09 00:00:00	1993-02-09	38000177		0	0	21		0	0	0	198342	0	313782	1127433		
5724	480	19078461	1994-11-12	1994-11-12 00:00:00	1994-11-26	1994-11-26 00:00:00	1994-11-26	38000177		0	0	14		0	0	0	31969	0	310965	19078461		
14830	320	40213296	1996-02-25	1996-02-25 00:00:00	1996-02-25	1996-02-25 00:00:00	1996-02-25	581452		0	0	0		0	0	0	21181	0	52	40213296		
47802	3962	19133905	2003-11-13	2003-11-13 00:00:00	2003-11-22	2003-11-22 00:00:00	2003-11-22	38000177		0	0	9		0	0	0	263441	0	834102	19133905		
13410	1124	19078461	1992-10-16	1992-10-16 00:00:00	1992-10-30	1992-10-30 00:00:00	1992-10-30	38000177		0	0	14		0	0	0	74114	0	310965	19078461		
41024	3403	19133873	1980-11-01	1980-11-01 00:00:00	1980-11-08	1980-11-08 00:00:00	1980-11-08	38000177		0	0	7		0	0	0	225740	0	834061	19133873		
21116	1740	19006318	1957-02-12	1957-02-12 00:00:00	1957-02-26	1957-02-26 00:00:00	1957-02-26	38000177		0	0	14		0	0	0	116267	0	105078	19006318		
3190	263	19018935	2016-08-28	2016-08-28 00:00:00	2016-08-28	2016-08-28 00:00:00	\N	38000177		0	0	0		0	0	0	17499	0	197604	19018935		
3227	264	19059056	1952-06-21	1952-06-21 00:00:00	1952-07-19	1952-07-19 00:00:00	1952-07-19	38000177		0	0	28		0	0	0	17533	0	243670	19059056		
4396	364	19006318	1950-02-13	1950-02-13 00:00:00	1950-02-27	1950-02-27 00:00:00	1950-02-27	38000177		0	0	14		0	0	0	24203	0	105078	19006318		
6978	587	1127433	1980-11-07	1980-11-07 00:00:00	1980-11-14	1980-11-14 00:00:00	1980-11-14	38000177		0	0	7		0	0	0	38900	0	313782	1127433		
11602	967	1713671	1955-10-17	1955-10-17 00:00:00	1955-11-07	1955-11-07 00:00:00	1955-11-07	38000177		0	0	21		0	0	0	64272	0	562251	1713671		
11619	967	40174880	1993-09-30	1993-09-30 00:00:00	1993-09-30	1993-09-30 00:00:00	\N	38000177		0	0	0		0	0	0	64356	0	966222	40174880		
53732	1176	40213160	1963-03-29	1963-03-29 00:00:00	1963-03-29	1963-03-29 00:00:00	1963-03-29	581452		0	0	0		0	0	0	77715	0	10	40213160		
245	17	19006318	1951-04-10	1951-04-10 00:00:00	1951-04-24	1951-04-24 00:00:00	1951-04-24	38000177		0	0	14		0	0	0	1311	0	105078	19006318		
46	2	1713671	1926-09-15	1926-09-15 00:00:00	1926-10-06	1926-10-06 00:00:00	1926-10-06	38000177		0	0	21		0	0	0	150	0	562251	1713671		
17816	1476	19075601	2011-05-26	2011-05-26 00:00:00	2011-05-26	2011-05-26 00:00:00	2011-05-26	38000177		0	0	0		0	0	0	98421	0	309362	19075601		
12669	273	40213314	1977-02-20	1977-02-20 00:00:00	1977-02-20	1977-02-20 00:00:00	1977-02-20	581452		0	0	0		0	0	0	18300	0	49	40213314		
25700	2114	40243436	1988-06-15	1988-06-15 00:00:00	1988-06-15	1988-06-15 00:00:00	1988-06-15	38000177		0	0	0		0	0	0	140683	0	1190795	40243436		
36226	2985	1124300	2001-12-23	2001-12-23 00:00:00	2001-12-23	2001-12-23 00:00:00	\N	38000177		0	0	0		0	0	0	199215	0	00781178901	45011828		
37987	3141	1127433	1985-08-20	1985-08-20 00:00:00	1985-09-03	1985-09-03 00:00:00	1985-09-03	38000177		0	0	14		0	0	0	208989	0	313782	1127433		
59694	4963	19073183	1980-01-08	1980-01-08 00:00:00	1980-01-22	1980-01-22 00:00:00	1980-01-22	38000177		0	0	14		0	0	0	329909	0	308182	19073183		
39041	3226	1127433	1984-04-06	1984-04-06 00:00:00	1984-04-27	1984-04-27 00:00:00	1984-04-27	38000177		0	0	21		0	0	0	214449	0	313782	1127433		
30206	2504	1127433	2006-04-02	2006-04-02 00:00:00	2006-04-16	2006-04-16 00:00:00	2006-04-16	38000177		0	0	14		0	0	0	165804	0	313782	1127433		
27079	2233	1713671	2015-03-15	2015-03-15 00:00:00	2015-03-29	2015-03-29 00:00:00	2015-03-29	38000177		0	0	14		0	0	0	148576	0	562251	1713671		
142974	3141	40213227	2013-02-17	2013-02-17 00:00:00	2013-02-17	2013-02-17 00:00:00	2013-02-17	581452		0	0	0		0	0	0	208970	0	113	40213227		
30267	2509	19128065	1987-05-15	1987-05-15 00:00:00	1988-05-09	1988-05-09 00:00:00	1988-05-09	38000177		0	0	360		0	0	0	166101	0	749882	19128065		
42680	3537	1713671	1985-04-12	1985-04-12 00:00:00	1985-04-26	1985-04-26 00:00:00	1985-04-26	38000177		0	0	14		0	0	0	234896	0	562251	1713671		
37707	3117	19078461	2018-09-18	2018-09-18 00:00:00	2018-10-09	2018-10-09 00:00:00	2018-10-09	38000177		0	0	21		0	0	0	207400	0	310965	19078461		
41188	3415	1127433	2005-11-12	2005-11-12 00:00:00	2005-11-26	2005-11-26 00:00:00	2005-11-26	38000177		0	0	14		0	0	0	226549	0	313782	1127433		
1908	152	46275444	1973-12-15	1973-12-15 00:00:00	1973-12-15	1973-12-15 00:00:00	1973-12-15	38000177		0	0	0		0	0	0	10291	0	1659149	46275444		
61964	5153	1127433	1960-01-08	1960-01-08 00:00:00	1960-01-29	1960-01-29 00:00:00	1960-01-29	38000177		0	0	21		0	0	0	342650	0	313782	1127433		
53362	4435	1127433	1989-12-01	1989-12-01 00:00:00	1989-12-08	1989-12-08 00:00:00	1989-12-08	38000177		0	0	7		0	0	0	294805	0	313782	1127433		
63210	5252	40220960	2018-11-27	2018-11-27 00:00:00	2018-11-27	2018-11-27 00:00:00	2018-11-27	38000177		0	0	0		0	0	0	349481	0	1804799	40220960		
20849	1719	1154615	1961-04-15	1961-04-15 00:00:00	1961-04-15	1961-04-15 00:00:00	\N	38000177		0	0	0		0	0	0	114883	0	745679	1154615		
56165	4662	19059056	1965-01-02	1965-01-02 00:00:00	1965-02-01	1965-02-01 00:00:00	1965-02-01	38000177		0	0	30		0	0	0	310771	0	243670	19059056		
4916	409	1127433	2011-11-17	2011-11-17 00:00:00	2011-11-24	2011-11-24 00:00:00	2011-11-24	38000177		0	0	7		0	0	0	27012	0	313782	1127433		
8390	700	19073183	1980-12-30	1980-12-30 00:00:00	1981-01-13	1981-01-13 00:00:00	1981-01-13	38000177		0	0	14		0	0	0	46268	0	308182	19073183		
11664	971	1118084	1980-09-15	1980-09-15 00:00:00	1980-09-15	1980-09-15 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00025152531	44923712		
20215	1658	19078461	2010-12-21	2010-12-21 00:00:00	2011-01-11	2011-01-11 00:00:00	2011-01-11	38000177		0	0	21		0	0	0	111382	0	310965	19078461		
47151	3909	1127433	1997-12-03	1997-12-03 00:00:00	1997-12-10	1997-12-10 00:00:00	1997-12-10	38000177		0	0	7		0	0	0	259868	0	313782	1127433		
111386	2447	40213251	1985-07-03	1985-07-03 00:00:00	1985-07-03	1985-07-03 00:00:00	1985-07-03	581452		0	0	0		0	0	0	162308	0	21	40213251		
52623	4375	40229134	1946-05-27	1946-05-27 00:00:00	1946-06-03	1946-06-03 00:00:00	1946-06-03	38000177		0	0	7		0	0	0	290635	0	1043400	40229134		
14528	1217	1115171	2019-04-14	2019-04-14 00:00:00	2019-04-28	2019-04-28 00:00:00	2019-04-28	38000177		0	0	14		0	0	0	80185	0	849574	1115171		
29648	2456	40229134	1959-11-30	1959-11-30 00:00:00	1959-12-14	1959-12-14 00:00:00	1959-12-14	38000177		0	0	14		0	0	0	162768	0	1043400	40229134		
1820	145	19059056	1973-01-28	1973-01-28 00:00:00	1973-03-29	1973-03-29 00:00:00	1973-03-29	38000177		0	0	60		0	0	0	9798	0	243670	19059056		
25151	2070	1127433	1980-09-04	1980-09-04 00:00:00	1980-09-18	1980-09-18 00:00:00	1980-09-18	38000177		0	0	14		0	0	0	137654	0	313782	1127433		
45897	3799	1127433	1973-10-15	1973-10-15 00:00:00	1973-10-22	1973-10-22 00:00:00	1973-10-22	38000177		0	0	7		0	0	0	252561	0	313782	1127433		
63320	5259	1118084	1999-11-06	1999-11-06 00:00:00	1999-11-06	1999-11-06 00:00:00	\N	38000177		0	0	0		0	0	0	349951	0	00025152531	44923712		
22583	1854	40231925	2015-02-08	2015-02-08 00:00:00	2015-02-08	2015-02-08 00:00:00	\N	38000177		0	0	0		0	0	0	124134	0	1049221	40231925		
43588	3613	19133873	1981-04-29	1981-04-29 00:00:00	1981-05-11	1981-05-11 00:00:00	1981-05-11	38000177		0	0	12		0	0	0	240022	0	834061	19133873		
50847	4224	1118084	1986-01-19	1986-01-19 00:00:00	1986-01-19	1986-01-19 00:00:00	\N	38000177		0	0	0		0	0	0	280561	0	00025152531	44923712		
15232	1272	1713671	2009-08-28	2009-08-28 00:00:00	2009-09-18	2009-09-18 00:00:00	2009-09-18	38000177		0	0	21		0	0	0	83952	0	562251	1713671		
60556	5037	1127433	2012-09-01	2012-09-01 00:00:00	2012-09-15	2012-09-15 00:00:00	2012-09-15	38000177		0	0	14		0	0	0	334735	0	313782	1127433		
55251	4587	19078461	2018-04-25	2018-04-25 00:00:00	2018-06-24	2018-06-24 00:00:00	2018-06-24	38000177		0	0	60		0	0	0	305571	0	310965	19078461		
33670	2786	19059056	1936-09-16	1936-09-16 00:00:00	1936-09-30	1936-09-30 00:00:00	1936-09-30	38000177		0	0	14		0	0	0	184607	0	243670	19059056		
43856	3631	1127078	1980-04-30	1980-04-30 00:00:00	1980-06-04	1980-06-04 00:00:00	1980-06-04	38000177		0	0	35		0	0	0	241580	0	282464	1127078		
26402	2173	40231925	1942-08-04	1942-08-04 00:00:00	1942-08-04	1942-08-04 00:00:00	\N	38000177		0	0	0		0	0	0	144758	0	1049221	40231925		
36435	3004	40229134	2001-12-06	2001-12-06 00:00:00	2001-12-20	2001-12-20 00:00:00	2001-12-20	38000177		0	0	14		0	0	0	200488	0	1043400	40229134		
39966	3308	19133873	1949-05-04	1949-05-04 00:00:00	1949-05-17	1949-05-17 00:00:00	1949-05-17	38000177		0	0	13		0	0	0	219662	0	834061	19133873		
11084	923	19133873	1965-09-21	1965-09-21 00:00:00	1965-09-28	1965-09-28 00:00:00	1965-09-28	38000177		0	0	7		0	0	0	61419	0	834061	19133873		
21619	1776	19059056	1992-12-03	1992-12-03 00:00:00	1993-01-02	1993-01-02 00:00:00	1993-01-02	38000177		0	0	30		0	0	0	118805	0	243670	19059056		
7908	170	40213227	2014-01-09	2014-01-09 00:00:00	2014-01-09	2014-01-09 00:00:00	2014-01-09	581452		0	0	0		0	0	0	11542	0	113	40213227		
47112	3904	19128022	1995-02-08	1995-02-08 00:00:00	1996-02-03	1996-02-03 00:00:00	1996-02-03	38000177		0	0	360		0	0	0	259628	0	749785	19128022		
36064	2970	1594382	1999-05-06	1999-05-06 00:00:00	1999-05-06	1999-05-06 00:00:00	\N	38000177		0	0	0		0	0	0	198331	0	1870230	1594382		
5725	480	1127433	1954-02-10	1954-02-10 00:00:00	1954-03-12	1954-03-12 00:00:00	1954-03-12	38000177		0	0	30		0	0	0	31965	0	313782	1127433		
14833	320	40213160	1956-10-28	1956-10-28 00:00:00	1956-10-28	1956-10-28 00:00:00	1956-10-28	581452		0	0	0		0	0	0	21209	0	10	40213160		
47805	3962	1127078	1953-07-06	1953-07-06 00:00:00	1953-07-20	1953-07-20 00:00:00	1953-07-20	38000177		0	0	14		0	0	0	263462	0	282464	1127078		
13411	1124	40229134	1991-05-11	1991-05-11 00:00:00	1991-05-25	1991-05-25 00:00:00	1991-05-25	38000177		0	0	14		0	0	0	74047	0	1043400	40229134		
41026	3403	19128065	1984-03-22	1984-03-22 00:00:00	1985-03-17	1985-03-17 00:00:00	1985-03-17	38000177		0	0	360		0	0	0	225734	0	749882	19128065		
21117	1740	1127433	1992-08-26	1992-08-26 00:00:00	1992-09-09	1992-09-09 00:00:00	1992-09-09	38000177		0	0	14		0	0	0	116305	0	313782	1127433		
3191	263	40171902	2016-08-28	2016-08-28 00:00:00	2016-08-28	2016-08-28 00:00:00	\N	38000177		0	0	0		0	0	0	17499	0	897718	40171902		
3228	264	19059056	1954-08-10	1954-08-10 00:00:00	1954-08-24	1954-08-24 00:00:00	1954-08-24	38000177		0	0	14		0	0	0	17515	0	243670	19059056		
4397	364	1127078	1950-02-13	1950-02-13 00:00:00	1950-02-27	1950-02-27 00:00:00	1950-02-27	38000177		0	0	14		0	0	0	24203	0	282464	1127078		
6979	588	19073183	1981-02-27	1981-02-27 00:00:00	1981-03-13	1981-03-13 00:00:00	1981-03-13	38000177		0	0	14		0	0	0	38923	0	308182	19073183		
11603	967	19078461	1977-04-06	1977-04-06 00:00:00	1977-04-27	1977-04-27 00:00:00	1977-04-27	38000177		0	0	21		0	0	0	64315	0	310965	19078461		
22079	1814	35605858	2018-04-03	2018-04-03 00:00:00	2018-04-03	2018-04-03 00:00:00	2018-04-03	38000177		0	0	0		0	0	0	121406	0	1732136	35605858		
53744	1176	40213160	1963-06-28	1963-06-28 00:00:00	1963-06-28	1963-06-28 00:00:00	1963-06-28	581452		0	0	0		0	0	0	77723	0	10	40213160		
246	17	19059056	1951-04-10	1951-04-10 00:00:00	1951-04-24	1951-04-24 00:00:00	1951-04-24	38000177		0	0	14		0	0	0	1311	0	243670	19059056		
47	3	19078461	2015-08-21	2015-08-21 00:00:00	2015-09-04	2015-09-04 00:00:00	2015-09-04	38000177		0	0	14		0	0	0	299	0	310965	19078461		
17817	1476	40220960	2011-05-26	2011-05-26 00:00:00	2011-05-26	2011-05-26 00:00:00	2011-05-26	38000177		0	0	0		0	0	0	98421	0	1804799	40220960		
12674	273	40213296	2018-11-11	2018-11-11 00:00:00	2018-11-11	2018-11-11 00:00:00	2018-11-11	581452		0	0	0		0	0	0	18245	0	52	40213296		
25701	2114	46275916	1988-06-15	1988-06-15 00:00:00	1988-06-15	1988-06-15 00:00:00	1988-06-15	38000177		0	0	0		0	0	0	140683	0	1660014	46275916		
36227	2985	1713671	2001-06-19	2001-06-19 00:00:00	2001-07-10	2001-07-10 00:00:00	2001-07-10	38000177		0	0	21		0	0	0	199215	0	562251	1713671		
37988	3141	1127433	1984-08-02	1984-08-02 00:00:00	1984-08-09	1984-08-09 00:00:00	1984-08-09	38000177		0	0	7		0	0	0	209001	0	313782	1127433		
59695	4963	19133905	2010-08-31	2010-08-31 00:00:00	2010-09-07	2010-09-07 00:00:00	2010-09-07	38000177		0	0	7		0	0	0	329939	0	834102	19133905		
39042	3226	1713671	1978-12-06	1978-12-06 00:00:00	1978-12-20	1978-12-20 00:00:00	1978-12-20	38000177		0	0	14		0	0	0	214486	0	562251	1713671		
30207	2504	1127433	1966-09-18	1966-09-18 00:00:00	1966-10-02	1966-10-02 00:00:00	1966-10-02	38000177		0	0	14		0	0	0	165816	0	313782	1127433		
27080	2233	1713671	1973-11-30	1973-11-30 00:00:00	1973-12-07	1973-12-07 00:00:00	1973-12-07	38000177		0	0	7		0	0	0	148581	0	562251	1713671		
142976	3141	40213160	1971-05-16	1971-05-16 00:00:00	1971-05-16	1971-05-16 00:00:00	1971-05-16	581452		0	0	0		0	0	0	208973	0	10	40213160		
30268	2509	1127433	2004-04-06	2004-04-06 00:00:00	2004-04-20	2004-04-20 00:00:00	2004-04-20	38000177		0	0	14		0	0	0	166097	0	313782	1127433		
42681	3537	19008572	1978-01-13	1978-01-13 00:00:00	1978-02-03	1978-02-03 00:00:00	1978-02-03	38000177		0	0	21		0	0	0	234948	0	106258	19008572		
37708	3117	19128022	1993-06-27	1993-06-27 00:00:00	1994-06-22	1994-06-22 00:00:00	1994-06-22	38000177		0	0	360		0	0	0	207375	0	749785	19128022		
41189	3415	1127433	1985-10-22	1985-10-22 00:00:00	1985-10-29	1985-10-29 00:00:00	1985-10-29	38000177		0	0	7		0	0	0	226547	0	313782	1127433		
1909	152	19016749	1973-12-15	1973-12-15 00:00:00	1973-12-15	1973-12-15 00:00:00	1973-12-15	38000177		0	0	0		0	0	0	10291	0	73032	19016749		
61965	5153	19133905	1998-04-02	1998-04-02 00:00:00	1998-04-09	1998-04-09 00:00:00	1998-04-09	38000177		0	0	7		0	0	0	342670	0	834102	19133905		
53363	4435	19078461	1978-04-03	1978-04-03 00:00:00	1978-04-24	1978-04-24 00:00:00	1978-04-24	38000177		0	0	21		0	0	0	294822	0	310965	19078461		
63211	5252	1127433	1987-10-11	1987-10-11 00:00:00	1987-11-01	1987-11-01 00:00:00	1987-11-01	38000177		0	0	21		0	0	0	349450	0	313782	1127433		
20850	1719	1118084	1996-05-19	1996-05-19 00:00:00	1996-05-19	1996-05-19 00:00:00	\N	38000177		0	0	0		0	0	0	114926	0	00025152531	44923712		
56166	4662	40231925	1965-01-02	1965-01-02 00:00:00	1965-01-02	1965-01-02 00:00:00	\N	38000177		0	0	0		0	0	0	310771	0	1049221	40231925		
4917	409	1118084	1993-01-13	1993-01-13 00:00:00	1993-01-13	1993-01-13 00:00:00	\N	38000177		0	0	0		0	0	0	27129	0	00025152531	44923712		
8391	700	1127078	1980-12-30	1980-12-30 00:00:00	1981-01-13	1981-01-13 00:00:00	1981-01-13	38000177		0	0	14		0	0	0	46268	0	282464	1127078		
11665	971	1127433	1965-08-20	1965-08-20 00:00:00	1965-09-17	1965-09-17 00:00:00	1965-09-17	38000177		0	0	28		0	0	0	64662	0	313782	1127433		
20216	1659	1713671	1974-12-19	1974-12-19 00:00:00	1975-06-05	1975-06-05 00:00:00	1975-06-05	38000177		0	0	168		0	0	0	111549	0	562251	1713671		
47152	3909	1127433	1964-09-03	1964-09-03 00:00:00	1964-09-17	1964-09-17 00:00:00	1964-09-17	38000177		0	0	14		0	0	0	259854	0	313782	1127433		
111388	2447	40213160	1985-07-03	1985-07-03 00:00:00	1985-07-03	1985-07-03 00:00:00	1985-07-03	581452		0	0	0		0	0	0	162308	0	10	40213160		
52624	4375	40229134	1966-07-08	1966-07-08 00:00:00	1966-07-22	1966-07-22 00:00:00	1966-07-22	38000177		0	0	14		0	0	0	290605	0	1043400	40229134		
14529	1217	19059056	1973-09-09	1973-09-09 00:00:00	1973-09-23	1973-09-23 00:00:00	1973-09-23	38000177		0	0	14		0	0	0	80162	0	243670	19059056		
29649	2456	1127433	2001-08-03	2001-08-03 00:00:00	2001-08-17	2001-08-17 00:00:00	2001-08-17	38000177		0	0	14		0	0	0	162772	0	313782	1127433		
1821	145	1127433	1979-10-24	1979-10-24 00:00:00	1979-11-14	1979-11-14 00:00:00	1979-11-14	38000177		0	0	21		0	0	0	9799	0	313782	1127433		
25152	2070	1127433	2005-09-02	2005-09-02 00:00:00	2005-09-09	2005-09-09 00:00:00	2005-09-09	38000177		0	0	7		0	0	0	137658	0	313782	1127433		
45898	3799	1127433	1985-03-19	1985-03-19 00:00:00	1985-04-02	1985-04-02 00:00:00	1985-04-02	38000177		0	0	14		0	0	0	252573	0	313782	1127433		
63321	5259	1127433	2008-04-19	2008-04-19 00:00:00	2008-05-26	2008-05-26 00:00:00	2008-05-26	38000177		0	0	37		0	0	0	350005	0	313782	1127433		
22584	1854	19078461	2015-02-08	2015-02-08 00:00:00	2015-03-08	2015-03-08 00:00:00	2015-03-08	38000177		0	0	28		0	0	0	124134	0	310965	19078461		
43589	3614	46233710	1974-06-25	1974-06-25 00:00:00	1974-07-09	1974-07-09 00:00:00	1974-07-09	38000177		0	0	14		0	0	0	240107	0	1650142	46233710		
50848	4224	19006318	1951-02-12	1951-02-12 00:00:00	1951-02-26	1951-02-26 00:00:00	1951-02-26	38000177		0	0	14		0	0	0	280556	0	105078	19006318		
15233	1272	40243436	1991-08-30	1991-08-30 00:00:00	1991-08-30	1991-08-30 00:00:00	1991-08-30	38000177		0	0	0		0	0	0	83860	0	1190795	40243436		
60557	5037	42902245	1999-12-28	1999-12-28 00:00:00	2000-12-22	2000-12-22 00:00:00	2000-12-22	38000177		0	0	360		0	0	0	334760	0	1359133	42902245		
55252	4587	1713671	1945-05-20	1945-05-20 00:00:00	1945-05-27	1945-05-27 00:00:00	1945-05-27	38000177		0	0	7		0	0	0	305595	0	562251	1713671		
33671	2786	1127433	2003-11-17	2003-11-17 00:00:00	2003-12-01	2003-12-01 00:00:00	2003-12-01	38000177		0	0	14		0	0	0	184620	0	313782	1127433		
33427	2768	1127433	1980-07-13	1980-07-13 00:00:00	1980-07-20	1980-07-20 00:00:00	1980-07-20	38000177		0	0	7		0	0	0	183135	0	313782	1127433		
26403	2173	1127433	1959-08-07	1959-08-07 00:00:00	1959-08-14	1959-08-14 00:00:00	1959-08-14	38000177		0	0	7		0	0	0	144723	0	313782	1127433		
36436	3004	1127433	2008-07-17	2008-07-17 00:00:00	2008-07-31	2008-07-31 00:00:00	2008-07-31	38000177		0	0	14		0	0	0	200502	0	313782	1127433		
39967	3308	1539411	1991-02-11	1991-02-11 00:00:00	1991-02-11	1991-02-11 00:00:00	\N	38000177		0	0	0		0	0	0	219631	0	312961	1539411		
11085	923	19075001	1985-06-14	1985-06-14 00:00:00	1985-06-28	1985-06-28 00:00:00	1985-06-28	38000177		0	0	14		0	0	0	61479	0	309097	19075001		
21620	1776	19059056	1918-01-21	1918-01-21 00:00:00	1918-02-04	1918-02-04 00:00:00	1918-02-04	38000177		0	0	14		0	0	0	118789	0	243670	19059056		
7909	170	40213296	2014-01-09	2014-01-09 00:00:00	2014-01-09	2014-01-09 00:00:00	2014-01-09	581452		0	0	0		0	0	0	11542	0	52	40213296		
47113	3904	1127078	1979-05-23	1979-05-23 00:00:00	1979-06-06	1979-06-06 00:00:00	1979-06-06	38000177		0	0	14		0	0	0	259640	0	282464	1127078		
36065	2970	1107882	1999-05-06	1999-05-06 00:00:00	1999-05-06	1999-05-06 00:00:00	\N	38000177		0	0	0		0	0	0	198331	0	311372	1107882		
5726	480	1127433	1958-10-13	1958-10-13 00:00:00	1958-10-20	1958-10-20 00:00:00	1958-10-20	38000177		0	0	7		0	0	0	31986	0	313782	1127433		
14843	320	40213160	1961-01-29	1961-01-29 00:00:00	1961-01-29	1961-01-29 00:00:00	1961-01-29	581452		0	0	0		0	0	0	21245	0	10	40213160		
237453	5213	40213227	1992-10-08	1992-10-08 00:00:00	1992-10-08	1992-10-08 00:00:00	1992-10-08	581452		0	0	0		0	0	0	346736	0	113	40213227		
13412	1124	19059056	1940-08-31	1940-08-31 00:00:00	1940-09-14	1940-09-14 00:00:00	1940-09-14	38000177		0	0	14		0	0	0	74110	0	243670	19059056		
41027	3403	1115171	2012-10-07	2012-10-07 00:00:00	2012-11-11	2012-11-11 00:00:00	2012-11-11	38000177		0	0	35		0	0	0	225745	0	849574	1115171		
21118	1740	1127433	1988-08-09	1988-08-09 00:00:00	1988-08-16	1988-08-16 00:00:00	1988-08-16	38000177		0	0	7		0	0	0	116264	0	313782	1127433		
3192	263	40163554	2016-08-28	2016-08-28 00:00:00	2016-08-28	2016-08-28 00:00:00	\N	38000177		0	0	0		0	0	0	17499	0	855332	40163554		
3229	264	19006318	1954-08-10	1954-08-10 00:00:00	1954-08-24	1954-08-24 00:00:00	1954-08-24	38000177		0	0	14		0	0	0	17515	0	105078	19006318		
4405	366	1127433	1998-11-03	1998-11-03 00:00:00	1999-02-01	1999-02-01 00:00:00	1999-02-01	38000177		0	0	90		0	0	0	24356	0	313782	1127433		
6980	588	1127078	1981-02-27	1981-02-27 00:00:00	1981-03-13	1981-03-13 00:00:00	1981-03-13	38000177		0	0	14		0	0	0	38923	0	282464	1127078		
11604	967	19133873	1937-10-31	1937-10-31 00:00:00	1937-11-10	1937-11-10 00:00:00	1937-11-10	38000177		0	0	10		0	0	0	64333	0	834061	19133873		
22080	1814	19078924	2018-04-03	2018-04-03 00:00:00	2018-04-03	2018-04-03 00:00:00	2018-04-03	38000177		0	0	0		0	0	0	121406	0	311700	19078924		
53746	1176	40213227	2013-10-25	2013-10-25 00:00:00	2013-10-25	2013-10-25 00:00:00	2013-10-25	581452		0	0	0		0	0	0	77580	0	113	40213227		
247	17	19059056	1969-02-04	1969-02-04 00:00:00	1969-03-11	1969-03-11 00:00:00	1969-03-11	38000177		0	0	35		0	0	0	1372	0	243670	19059056		
48	3	1127433	2010-08-27	2010-08-27 00:00:00	2010-10-26	2010-10-26 00:00:00	2010-10-26	38000177		0	0	60		0	0	0	314	0	313782	1127433		
17818	1476	1127433	1961-08-21	1961-08-21 00:00:00	1961-10-20	1961-10-20 00:00:00	1961-10-20	38000177		0	0	60		0	0	0	98494	0	313782	1127433		
12678	273	40213314	1978-02-19	1978-02-19 00:00:00	1978-02-19	1978-02-19 00:00:00	1978-02-19	581452		0	0	0		0	0	0	18226	0	49	40213314		
25702	2114	1118084	2002-07-02	2002-07-02 00:00:00	2002-07-02	2002-07-02 00:00:00	\N	38000177		0	0	0		0	0	0	140688	0	00025152531	44923712		
36228	2985	1127433	1993-01-26	1993-01-26 00:00:00	1993-02-09	1993-02-09 00:00:00	1993-02-09	38000177		0	0	14		0	0	0	199190	0	313782	1127433		
37989	3141	19059056	1981-11-11	1981-11-11 00:00:00	1981-12-09	1981-12-09 00:00:00	1981-12-09	38000177		0	0	28		0	0	0	208988	0	243670	19059056		
59696	4963	1127433	1982-07-06	1982-07-06 00:00:00	1982-07-13	1982-07-13 00:00:00	1982-07-13	38000177		0	0	7		0	0	0	329929	0	313782	1127433		
18398	1523	1124300	1996-01-21	1996-01-21 00:00:00	1996-01-21	1996-01-21 00:00:00	\N	38000177		0	0	0		0	0	0	101876	0	00781178901	45011828		
30208	2504	19006318	1966-09-18	1966-09-18 00:00:00	1966-10-02	1966-10-02 00:00:00	1966-10-02	38000177		0	0	14		0	0	0	165816	0	105078	19006318		
27081	2233	19128065	1988-01-18	1988-01-18 00:00:00	1989-01-12	1989-01-12 00:00:00	1989-01-12	38000177		0	0	360		0	0	0	148577	0	749882	19128065		
142985	3141	40213160	1971-10-17	1971-10-17 00:00:00	1971-10-17	1971-10-17 00:00:00	1971-10-17	581452		0	0	0		0	0	0	208974	0	10	40213160		
30269	2509	19059056	1975-11-04	1975-11-04 00:00:00	1975-12-04	1975-12-04 00:00:00	1975-12-04	38000177		0	0	30		0	0	0	166089	0	243670	19059056		
42682	3537	19073188	1989-11-23	1989-11-23 00:00:00	1989-12-07	1989-12-07 00:00:00	1989-12-07	38000177		0	0	14		0	0	0	234957	0	308192	19073188		
37710	3117	920300	1997-08-23	1997-08-23 00:00:00	1997-08-30	1997-08-30 00:00:00	1997-08-30	38000177		0	0	7		0	0	0	207335	0	311989	920300		
41190	3415	1118084	2005-04-14	2005-04-14 00:00:00	2005-04-14	2005-04-14 00:00:00	\N	38000177		0	0	0		0	0	0	226529	0	00025152531	44923712		
1910	152	1118084	2000-03-11	2000-03-11 00:00:00	2000-03-11	2000-03-11 00:00:00	\N	38000177		0	0	0		0	0	0	10252	0	00025152531	44923712		
61966	5153	1127433	1982-11-21	1982-11-21 00:00:00	1982-11-28	1982-11-28 00:00:00	1982-11-28	38000177		0	0	7		0	0	0	342668	0	313782	1127433		
53364	4435	1115171	2018-11-11	2018-11-11 00:00:00	2018-12-09	2018-12-09 00:00:00	2018-12-09	38000177		0	0	28		0	0	0	294784	0	849574	1115171		
63212	5252	19059056	1969-10-01	1969-10-01 00:00:00	1969-12-30	1969-12-30 00:00:00	1969-12-30	38000177		0	0	90		0	0	0	349398	0	243670	19059056		
20851	1719	19133873	1965-06-12	1965-06-12 00:00:00	1965-06-23	1965-06-23 00:00:00	1965-06-23	38000177		0	0	11		0	0	0	114943	0	834061	19133873		
56192	4665	19128065	1996-08-06	1996-08-06 00:00:00	1997-08-01	1997-08-01 00:00:00	1997-08-01	38000177		0	0	360		0	0	0	310910	0	749882	19128065		
4918	409	19078461	2013-02-19	2013-02-19 00:00:00	2013-03-19	2013-03-19 00:00:00	2013-03-19	38000177		0	0	28		0	0	0	27154	0	310965	19078461		
8392	701	1124300	1994-10-11	1994-10-11 00:00:00	1994-10-11	1994-10-11 00:00:00	\N	38000177		0	0	0		0	0	0	46310	0	00781178901	45011828		
11666	971	1127433	1961-09-12	1961-09-12 00:00:00	1961-09-26	1961-09-26 00:00:00	1961-09-26	38000177		0	0	14		0	0	0	64590	0	313782	1127433		
20217	1659	1127433	2004-08-24	2004-08-24 00:00:00	2004-09-07	2004-09-07 00:00:00	2004-09-07	38000177		0	0	14		0	0	0	111458	0	313782	1127433		
47153	3909	40229134	1995-06-08	1995-06-08 00:00:00	1995-06-15	1995-06-15 00:00:00	1995-06-15	38000177		0	0	7		0	0	0	259832	0	1043400	40229134		
111392	2447	40213314	1981-01-28	1981-01-28 00:00:00	1981-01-28	1981-01-28 00:00:00	1981-01-28	581452		0	0	0		0	0	0	162316	0	49	40213314		
52625	4375	19133905	1957-12-04	1957-12-04 00:00:00	1957-12-12	1957-12-12 00:00:00	1957-12-12	38000177		0	0	8		0	0	0	290636	0	834102	19133905		
14530	1217	1713671	1993-06-01	1993-06-01 00:00:00	1993-06-15	1993-06-15 00:00:00	1993-06-15	38000177		0	0	14		0	0	0	80158	0	562251	1713671		
29650	2456	1127433	1998-10-10	1998-10-10 00:00:00	1998-10-17	1998-10-17 00:00:00	1998-10-17	38000177		0	0	7		0	0	0	162771	0	313782	1127433		
1822	145	1127433	1984-04-12	1984-04-12 00:00:00	1984-04-26	1984-04-26 00:00:00	1984-04-26	38000177		0	0	14		0	0	0	9802	0	313782	1127433		
25153	2070	1127433	1978-05-16	1978-05-16 00:00:00	1978-05-30	1978-05-30 00:00:00	1978-05-30	38000177		0	0	14		0	0	0	137726	0	313782	1127433		
45899	3799	19059056	1982-08-11	1982-08-11 00:00:00	1982-08-25	1982-08-25 00:00:00	1982-08-25	38000177		0	0	14		0	0	0	252528	0	243670	19059056		
63322	5259	19006318	1959-02-24	1959-02-24 00:00:00	1959-03-10	1959-03-10 00:00:00	1959-03-10	38000177		0	0	14		0	0	0	349970	0	105078	19006318		
22585	1854	19073188	2015-02-08	2015-02-08 00:00:00	2015-03-08	2015-03-08 00:00:00	2015-03-08	38000177		0	0	28		0	0	0	124134	0	308192	19073188		
43590	3614	19078461	1974-06-25	1974-06-25 00:00:00	1974-07-09	1974-07-09 00:00:00	1974-07-09	38000177		0	0	14		0	0	0	240107	0	310965	19078461		
50849	4224	1127078	1951-02-12	1951-02-12 00:00:00	1951-02-26	1951-02-26 00:00:00	1951-02-26	38000177		0	0	14		0	0	0	280556	0	282464	1127078		
15234	1272	46275916	1991-08-30	1991-08-30 00:00:00	1991-08-30	1991-08-30 00:00:00	1991-08-30	38000177		0	0	0		0	0	0	83860	0	1660014	46275916		
60558	5037	1124300	2009-07-28	2009-07-28 00:00:00	2009-07-28	2009-07-28 00:00:00	\N	38000177		0	0	0		0	0	0	334768	0	00781178901	45011828		
68792	1506	40213227	1997-02-08	1997-02-08 00:00:00	1997-02-08	1997-02-08 00:00:00	1997-02-08	581452		0	0	0		0	0	0	100431	0	113	40213227		
33672	2786	1115171	2006-12-23	2006-12-23 00:00:00	2007-01-06	2007-01-06 00:00:00	2007-01-06	38000177		0	0	14		0	0	0	184615	0	849574	1115171		
33441	2770	1127433	1991-01-30	1991-01-30 00:00:00	1991-02-06	1991-02-06 00:00:00	1991-02-06	38000177		0	0	7		0	0	0	183320	0	313782	1127433		
26404	2173	1713671	1974-11-21	1974-11-21 00:00:00	1974-12-05	1974-12-05 00:00:00	1974-12-05	38000177		0	0	14		0	0	0	144842	0	562251	1713671		
36437	3004	19133873	1958-10-12	1958-10-12 00:00:00	1958-10-22	1958-10-22 00:00:00	1958-10-22	38000177		0	0	10		0	0	0	200464	0	834061	19133873		
39968	3308	1118084	1984-06-15	1984-06-15 00:00:00	1984-06-15	1984-06-15 00:00:00	\N	38000177		0	0	0		0	0	0	219682	0	00025152531	44923712		
11086	923	1127433	1985-06-14	1985-06-14 00:00:00	1985-06-28	1985-06-28 00:00:00	1985-06-28	38000177		0	0	14		0	0	0	61479	0	313782	1127433		
21621	1776	19059056	1920-09-07	1920-09-07 00:00:00	1920-10-05	1920-10-05 00:00:00	1920-10-05	38000177		0	0	28		0	0	0	118798	0	243670	19059056		
7915	170	40213306	1993-04-08	1993-04-08 00:00:00	1993-04-08	1993-04-08 00:00:00	1993-04-08	581452		0	0	0		0	0	0	11551	0	43	40213306		
47114	3904	19073183	1979-05-23	1979-05-23 00:00:00	1979-06-06	1979-06-06 00:00:00	1979-06-06	38000177		0	0	14		0	0	0	259640	0	308182	19073183		
23490	510	40213296	2005-10-08	2005-10-08 00:00:00	2005-10-08	2005-10-08 00:00:00	2005-10-08	581452		0	0	0		0	0	0	34091	0	52	40213296		
5727	480	40229134	2010-05-02	2010-05-02 00:00:00	2010-05-16	2010-05-16 00:00:00	2010-05-16	38000177		0	0	14		0	0	0	32033	0	1043400	40229134		
14847	320	40213160	1956-07-29	1956-07-29 00:00:00	1956-07-29	1956-07-29 00:00:00	1956-07-29	581452		0	0	0		0	0	0	21241	0	10	40213160		
237461	5213	40213227	1999-11-18	1999-11-18 00:00:00	1999-11-18	1999-11-18 00:00:00	1999-11-18	581452		0	0	0		0	0	0	346719	0	113	40213227		
13413	1124	1127433	1991-10-01	1991-10-01 00:00:00	1991-10-22	1991-10-22 00:00:00	1991-10-22	38000177		0	0	21		0	0	0	74113	0	313782	1127433		
41028	3403	19059056	1982-10-19	1982-10-19 00:00:00	1982-11-02	1982-11-02 00:00:00	1982-11-02	38000177		0	0	14		0	0	0	225721	0	243670	19059056		
21119	1740	1127433	2010-08-24	2010-08-24 00:00:00	2010-09-23	2010-09-23 00:00:00	2010-09-23	38000177		0	0	30		0	0	0	116292	0	313782	1127433		
3193	263	19078461	2013-08-21	2013-08-21 00:00:00	2013-09-11	2013-09-11 00:00:00	2013-09-11	38000177		0	0	21		0	0	0	17424	0	310965	19078461		
3230	264	1545959	2011-11-11	2011-11-11 00:00:00	2011-11-11	2011-11-11 00:00:00	2011-11-11	38000177		0	0	0		0	0	0	17590	0	259255	1545959		
4406	366	19059056	1912-01-15	1912-01-15 00:00:00	1912-01-29	1912-01-29 00:00:00	1912-01-29	38000177		0	0	14		0	0	0	24312	0	243670	19059056		
6981	588	1127433	2016-03-02	2016-03-02 00:00:00	2016-03-16	2016-03-16 00:00:00	2016-03-16	38000177		0	0	14		0	0	0	38918	0	313782	1127433		
11605	967	1127433	1973-01-13	1973-01-13 00:00:00	1973-01-27	1973-01-27 00:00:00	1973-01-27	38000177		0	0	14		0	0	0	64314	0	313782	1127433		
22081	1814	782047	2018-04-03	2018-04-03 00:00:00	2018-04-03	2018-04-03 00:00:00	2018-04-03	38000177		0	0	0		0	0	0	121406	0	542347	782047		
30944	2563	1127433	1983-04-16	1983-04-16 00:00:00	1983-04-23	1983-04-23 00:00:00	1983-04-23	38000177		0	0	7		0	0	0	169789	0	313782	1127433		
248	18	19133873	1979-05-24	1979-05-24 00:00:00	1979-06-01	1979-06-01 00:00:00	1979-06-01	38000177		0	0	8		0	0	0	1385	0	834061	19133873		
49	3	19059056	1923-12-22	1923-12-22 00:00:00	1924-01-12	1924-01-12 00:00:00	1924-01-12	38000177		0	0	21		0	0	0	342	0	243670	19059056		
17819	1476	1127433	1978-08-18	1978-08-18 00:00:00	1978-09-01	1978-09-01 00:00:00	1978-09-01	38000177		0	0	14		0	0	0	98352	0	313782	1127433		
12684	273	40213314	1977-08-21	1977-08-21 00:00:00	1977-08-21	1977-08-21 00:00:00	1977-08-21	581452		0	0	0		0	0	0	18250	0	49	40213314		
25703	2114	1127433	1999-12-07	1999-12-07 00:00:00	1999-12-28	1999-12-28 00:00:00	1999-12-28	38000177		0	0	21		0	0	0	140684	0	313782	1127433		
36229	2985	19128065	1984-09-08	1984-09-08 00:00:00	1985-09-03	1985-09-03 00:00:00	1985-09-03	38000177		0	0	360		0	0	0	199254	0	749882	19128065		
37990	3141	1713671	1976-11-16	1976-11-16 00:00:00	1976-11-23	1976-11-23 00:00:00	1976-11-23	38000177		0	0	7		0	0	0	208964	0	562251	1713671		
59697	4963	1124300	2009-03-21	2009-03-21 00:00:00	2009-03-21	2009-03-21 00:00:00	\N	38000177		0	0	0		0	0	0	329877	0	00781178901	45011828		
18399	1523	1127433	1988-11-02	1988-11-02 00:00:00	1989-01-31	1989-01-31 00:00:00	1989-01-31	38000177		0	0	90		0	0	0	101881	0	313782	1127433		
30209	2504	1127433	1968-01-11	1968-01-11 00:00:00	1968-02-08	1968-02-08 00:00:00	1968-02-08	38000177		0	0	28		0	0	0	165852	0	313782	1127433		
27082	2233	40229134	2009-04-10	2009-04-10 00:00:00	2009-04-24	2009-04-24 00:00:00	2009-04-24	38000177		0	0	14		0	0	0	148587	0	1043400	40229134		
142988	3141	40213227	2002-10-20	2002-10-20 00:00:00	2002-10-20	2002-10-20 00:00:00	2002-10-20	581452		0	0	0		0	0	0	209022	0	113	40213227		
30270	2509	1713671	2018-05-17	2018-05-17 00:00:00	2018-05-31	2018-05-31 00:00:00	2018-05-31	38000177		0	0	14		0	0	0	166100	0	562251	1713671		
42683	3537	1127433	1989-11-23	1989-11-23 00:00:00	1989-12-07	1989-12-07 00:00:00	1989-12-07	38000177		0	0	14		0	0	0	234957	0	313782	1127433		
37711	3117	40236824	1997-08-23	1997-08-23 00:00:00	1997-08-30	1997-08-30 00:00:00	1997-08-30	38000177		0	0	7		0	0	0	207335	0	1094107	40236824		
41191	3415	1115171	2015-08-22	2015-08-22 00:00:00	2015-09-05	2015-09-05 00:00:00	2015-09-05	38000177		0	0	14		0	0	0	226552	0	849574	1115171		
1911	153	19078461	2011-02-02	2011-02-02 00:00:00	2011-02-16	2011-02-16 00:00:00	2011-02-16	38000177		0	0	14		0	0	0	10333	0	310965	19078461		
61968	5153	1127433	1977-03-30	1977-03-30 00:00:00	1977-04-29	1977-04-29 00:00:00	1977-04-29	38000177		0	0	30		0	0	0	342652	0	313782	1127433		
53365	4435	19133905	2005-11-09	2005-11-09 00:00:00	2005-11-17	2005-11-17 00:00:00	2005-11-17	38000177		0	0	8		0	0	0	294806	0	834102	19133905		
63213	5252	40169281	1999-04-13	1999-04-13 00:00:00	1999-04-13	1999-04-13 00:00:00	\N	38000177		0	0	0		0	0	0	349425	0	896209	40169281		
20852	1719	1127433	1993-02-23	1993-02-23 00:00:00	1993-03-30	1993-03-30 00:00:00	1993-03-30	38000177		0	0	35		0	0	0	114994	0	313782	1127433		
56193	4665	19128065	1999-07-22	1999-07-22 00:00:00	2000-07-16	2000-07-16 00:00:00	2000-07-16	38000177		0	0	360		0	0	0	310904	0	749882	19128065		
4919	409	920300	1991-11-01	1991-11-01 00:00:00	1991-11-08	1991-11-08 00:00:00	1991-11-08	38000177		0	0	7		0	0	0	27100	0	311989	920300		
8393	701	19059056	1958-07-27	1958-07-27 00:00:00	1958-08-10	1958-08-10 00:00:00	1958-08-10	38000177		0	0	14		0	0	0	46350	0	243670	19059056		
11667	971	19059056	1946-06-18	1946-06-18 00:00:00	1946-07-02	1946-07-02 00:00:00	1946-07-02	38000177		0	0	14		0	0	0	64627	0	243670	19059056		
20218	1659	1127433	1971-06-07	1971-06-07 00:00:00	1971-06-14	1971-06-14 00:00:00	1971-06-14	38000177		0	0	7		0	0	0	111453	0	313782	1127433		
47154	3909	19133905	2015-03-05	2015-03-05 00:00:00	2015-03-12	2015-03-12 00:00:00	2015-03-12	38000177		0	0	7		0	0	0	259869	0	834102	19133905		
111394	2447	40213160	1981-01-28	1981-01-28 00:00:00	1981-01-28	1981-01-28 00:00:00	1981-01-28	581452		0	0	0		0	0	0	162316	0	10	40213160		
52626	4375	40163554	2006-06-25	2006-06-25 00:00:00	2006-06-25	2006-06-25 00:00:00	\N	38000177		0	0	0		0	0	0	290646	0	855332	40163554		
14531	1217	1713671	2015-07-15	2015-07-15 00:00:00	2015-08-05	2015-08-05 00:00:00	2015-08-05	38000177		0	0	21		0	0	0	80170	0	562251	1713671		
29651	2456	40229134	1972-11-06	1972-11-06 00:00:00	1972-11-20	1972-11-20 00:00:00	1972-11-20	38000177		0	0	14		0	0	0	162753	0	1043400	40229134		
1823	145	1127433	1995-02-02	1995-02-02 00:00:00	1995-02-16	1995-02-16 00:00:00	1995-02-16	38000177		0	0	14		0	0	0	9726	0	313782	1127433		
25154	2070	1127433	1988-02-07	1988-02-07 00:00:00	1988-04-07	1988-04-07 00:00:00	1988-04-07	38000177		0	0	60		0	0	0	137727	0	313782	1127433		
45900	3799	19133873	1984-03-09	1984-03-09 00:00:00	1984-03-18	1984-03-18 00:00:00	1984-03-18	38000177		0	0	9		0	0	0	252563	0	834061	19133873		
63323	5259	1127078	1959-02-24	1959-02-24 00:00:00	1959-03-10	1959-03-10 00:00:00	1959-03-10	38000177		0	0	14		0	0	0	349970	0	282464	1127078		
22586	1854	1127433	1993-05-07	1993-05-07 00:00:00	1993-05-14	1993-05-14 00:00:00	1993-05-14	38000177		0	0	7		0	0	0	124063	0	313782	1127433		
43591	3614	1713671	1953-02-26	1953-02-26 00:00:00	1953-03-12	1953-03-12 00:00:00	1953-03-12	38000177		0	0	14		0	0	0	240135	0	562251	1713671		
50850	4224	19078461	2010-10-21	2010-10-21 00:00:00	2010-11-04	2010-11-04 00:00:00	2010-11-04	38000177		0	0	14		0	0	0	280591	0	310965	19078461		
15235	1272	1310034	1991-08-30	1991-08-30 00:00:00	1991-08-30	1991-08-30 00:00:00	1991-08-30	38000177		0	0	0		0	0	0	83860	0	834357	1310034		
60559	5037	43012754	2000-12-22	2000-12-22 00:00:00	2001-12-17	2001-12-17 00:00:00	2001-12-17	38000177		0	0	360		0	0	0	334762	0	1366343	43012754		
68808	1506	40213198	2011-04-30	2011-04-30 00:00:00	2011-04-30	2011-04-30 00:00:00	2011-04-30	581452		0	0	0		0	0	0	100439	0	133	40213198		
33673	2786	19059056	1939-07-17	1939-07-17 00:00:00	1939-10-15	1939-10-15 00:00:00	1939-10-15	38000177		0	0	90		0	0	0	184608	0	243670	19059056		
33442	2770	1127433	1952-01-28	1952-01-28 00:00:00	1952-02-11	1952-02-11 00:00:00	1952-02-11	38000177		0	0	14		0	0	0	183397	0	313782	1127433		
26405	2173	1118084	1975-02-17	1975-02-17 00:00:00	1975-02-17	1975-02-17 00:00:00	\N	38000177		0	0	0		0	0	0	144842	0	00025152531	44923712		
36438	3004	1713671	1995-10-21	1995-10-21 00:00:00	1995-10-28	1995-10-28 00:00:00	1995-10-28	38000177		0	0	7		0	0	0	200459	0	562251	1713671		
39969	3308	19133768	1996-11-18	1996-11-18 00:00:00	1996-11-18	1996-11-18 00:00:00	1996-11-18	38000177		0	0	0		0	0	0	219656	0	833036	19133768		
11087	923	1713671	1961-10-15	1961-10-15 00:00:00	1961-10-29	1961-10-29 00:00:00	1961-10-29	38000177		0	0	14		0	0	0	61417	0	562251	1713671		
21622	1776	19059056	1945-04-23	1945-04-23 00:00:00	1945-05-14	1945-05-14 00:00:00	1945-05-14	38000177		0	0	21		0	0	0	118803	0	243670	19059056		
7917	170	40213227	1993-04-08	1993-04-08 00:00:00	1993-04-08	1993-04-08 00:00:00	1993-04-08	581452		0	0	0		0	0	0	11551	0	113	40213227		
47115	3904	920300	2005-03-29	2005-03-29 00:00:00	2005-04-05	2005-04-05 00:00:00	2005-04-05	38000177		0	0	7		0	0	0	259638	0	311989	920300		
23492	510	40213227	1996-10-19	1996-10-19 00:00:00	1996-10-19	1996-10-19 00:00:00	1996-10-19	581452		0	0	0		0	0	0	34103	0	113	40213227		
5728	480	1127433	2004-04-11	2004-04-11 00:00:00	2004-04-25	2004-04-25 00:00:00	2004-04-25	38000177		0	0	14		0	0	0	32110	0	313782	1127433		
94781	2079	40213260	2006-07-07	2006-07-07 00:00:00	2006-07-07	2006-07-07 00:00:00	2006-07-07	581452		0	0	0		0	0	0	138479	0	121	40213260		
73913	1613	40213160	1955-07-23	1955-07-23 00:00:00	1955-07-23	1955-07-23 00:00:00	1955-07-23	581452		0	0	0		0	0	0	108504	0	10	40213160		
13414	1124	1127433	2005-03-26	2005-03-26 00:00:00	2005-04-23	2005-04-23 00:00:00	2005-04-23	38000177		0	0	28		0	0	0	74115	0	313782	1127433		
41029	3403	19074841	1982-10-19	1982-10-19 00:00:00	1982-11-02	1982-11-02 00:00:00	1982-11-02	38000177		0	0	14		0	0	0	225721	0	309043	19074841		
21120	1740	19074679	1953-02-14	1953-02-14 00:00:00	1953-08-15	1953-08-15 00:00:00	1953-08-15	38000177		0	0	182		0	0	0	116258	0	308971	19074679		
3194	263	40229134	1955-02-16	1955-02-16 00:00:00	1955-03-02	1955-03-02 00:00:00	1955-03-02	38000177		0	0	14		0	0	0	17425	0	1043400	40229134		
3231	264	19133768	2011-11-11	2011-11-11 00:00:00	2011-11-11	2011-11-11 00:00:00	2011-11-11	38000177		0	0	0		0	0	0	17590	0	833036	19133768		
4407	366	1127433	1996-08-24	1996-08-24 00:00:00	1996-09-14	1996-09-14 00:00:00	1996-09-14	38000177		0	0	21		0	0	0	24355	0	313782	1127433		
6982	588	1127433	2010-05-07	2010-05-07 00:00:00	2010-05-14	2010-05-14 00:00:00	2010-05-14	38000177		0	0	7		0	0	0	38935	0	313782	1127433		
11606	967	1118084	1973-10-25	1973-10-25 00:00:00	1973-10-25	1973-10-25 00:00:00	\N	38000177		0	0	0		0	0	0	64314	0	00025152531	44923712		
22082	1814	42707627	2018-04-03	2018-04-03 00:00:00	2018-04-03	2018-04-03 00:00:00	2018-04-03	38000177		0	0	0		0	0	0	121406	0	1234995	42707627		
30945	2563	19059056	1986-06-04	1986-06-04 00:00:00	1986-06-18	1986-06-18 00:00:00	1986-06-18	38000177		0	0	14		0	0	0	169792	0	243670	19059056		
249	18	1713671	1974-06-13	1974-06-13 00:00:00	1974-06-20	1974-06-20 00:00:00	1974-06-20	38000177		0	0	7		0	0	0	1384	0	562251	1713671		
50	3	40229134	1948-06-14	1948-06-14 00:00:00	1948-06-21	1948-06-21 00:00:00	1948-06-21	38000177		0	0	7		0	0	0	359	0	1043400	40229134		
17820	1476	19059056	1978-08-22	1978-08-22 00:00:00	1978-10-21	1978-10-21 00:00:00	1978-10-21	38000177		0	0	60		0	0	0	98367	0	243670	19059056		
12688	273	40213306	1998-03-08	1998-03-08 00:00:00	1998-03-08	1998-03-08 00:00:00	1998-03-08	581452		0	0	0		0	0	0	18308	0	43	40213306		
25704	2115	40231925	2004-09-05	2004-09-05 00:00:00	2004-09-05	2004-09-05 00:00:00	\N	38000177		0	0	0		0	0	0	140751	0	1049221	40231925		
36230	2985	19128065	1983-09-14	1983-09-14 00:00:00	1984-09-08	1984-09-08 00:00:00	1984-09-08	38000177		0	0	360		0	0	0	199253	0	749882	19128065		
38013	3144	920300	1998-06-24	1998-06-24 00:00:00	1998-07-01	1998-07-01 00:00:00	1998-07-01	38000177		0	0	7		0	0	0	209213	0	311989	920300		
59698	4963	1127433	2011-12-24	2011-12-24 00:00:00	2011-12-31	2011-12-31 00:00:00	2011-12-31	38000177		0	0	7		0	0	0	329908	0	313782	1127433		
18400	1523	19059056	1973-08-09	1973-08-09 00:00:00	1973-08-23	1973-08-23 00:00:00	1973-08-23	38000177		0	0	14		0	0	0	101880	0	243670	19059056		
40671	3371	1115171	1998-06-25	1998-06-25 00:00:00	1998-07-16	1998-07-16 00:00:00	1998-07-16	38000177		0	0	21		0	0	0	223600	0	849574	1115171		
27083	2233	1127433	1973-01-28	1973-01-28 00:00:00	1973-02-04	1973-02-04 00:00:00	1973-02-04	38000177		0	0	7		0	0	0	148549	0	313782	1127433		
19723	1622	1127433	2015-02-08	2015-02-08 00:00:00	2015-02-22	2015-02-22 00:00:00	2015-02-22	38000177		0	0	14		0	0	0	108938	0	313782	1127433		
30271	2509	1127078	1974-07-12	1974-07-12 00:00:00	1974-07-26	1974-07-26 00:00:00	1974-07-26	38000177		0	0	14		0	0	0	166070	0	282464	1127078		
42684	3537	1127433	1978-08-14	1978-08-14 00:00:00	1978-09-11	1978-09-11 00:00:00	1978-09-11	38000177		0	0	28		0	0	0	234965	0	313782	1127433		
37712	3117	19128065	1992-07-02	1992-07-02 00:00:00	1993-06-27	1993-06-27 00:00:00	1993-06-27	38000177		0	0	360		0	0	0	207381	0	749882	19128065		
41193	3417	19133873	1917-04-18	1917-04-18 00:00:00	1917-04-29	1917-04-29 00:00:00	1917-04-29	38000177		0	0	11		0	0	0	226602	0	834061	19133873		
1912	153	1118084	1984-05-15	1984-05-15 00:00:00	1984-05-15	1984-05-15 00:00:00	\N	38000177		0	0	0		0	0	0	10414	0	00025152531	44923712		
41248	3420	1118084	1998-11-10	1998-11-10 00:00:00	1998-11-10	1998-11-10 00:00:00	\N	38000177		0	0	0		0	0	0	226868	0	00025152531	44923712		
53366	4436	1118084	2008-06-01	2008-06-01 00:00:00	2008-06-01	2008-06-01 00:00:00	\N	38000177		0	0	0		0	0	0	294882	0	00025152531	44923712		
63214	5252	1713671	1979-03-19	1979-03-19 00:00:00	1979-04-09	1979-04-09 00:00:00	1979-04-09	38000177		0	0	21		0	0	0	349444	0	562251	1713671		
20853	1719	19059056	1987-02-22	1987-02-22 00:00:00	1987-03-29	1987-03-29 00:00:00	1987-03-29	38000177		0	0	35		0	0	0	114917	0	243670	19059056		
56194	4665	1713671	1983-01-15	1983-01-15 00:00:00	1983-01-22	1983-01-22 00:00:00	1983-01-22	38000177		0	0	7		0	0	0	310882	0	562251	1713671		
4920	409	40236824	1991-11-01	1991-11-01 00:00:00	1991-11-08	1991-11-08 00:00:00	1991-11-08	38000177		0	0	7		0	0	0	27100	0	1094107	40236824		
8395	701	19078461	2015-05-04	2015-05-04 00:00:00	2015-05-25	2015-05-25 00:00:00	2015-05-25	38000177		0	0	21		0	0	0	46365	0	310965	19078461		
11668	971	19006318	1946-06-18	1946-06-18 00:00:00	1946-07-02	1946-07-02 00:00:00	1946-07-02	38000177		0	0	14		0	0	0	64627	0	105078	19006318		
20219	1659	1115171	2011-08-02	2011-08-02 00:00:00	2011-08-16	2011-08-16 00:00:00	2011-08-16	38000177		0	0	14		0	0	0	111445	0	849574	1115171		
47155	3909	19128065	1977-08-04	1977-08-04 00:00:00	1978-07-30	1978-07-30 00:00:00	1978-07-30	38000177		0	0	360		0	0	0	259844	0	749882	19128065		
111397	2447	40213160	1981-04-29	1981-04-29 00:00:00	1981-04-29	1981-04-29 00:00:00	1981-04-29	581452		0	0	0		0	0	0	162306	0	10	40213160		
22672	492	40213227	1997-12-19	1997-12-19 00:00:00	1997-12-19	1997-12-19 00:00:00	1997-12-19	581452		0	0	0		0	0	0	32930	0	113	40213227		
14532	1217	40229134	2003-07-05	2003-07-05 00:00:00	2003-07-12	2003-07-12 00:00:00	2003-07-12	38000177		0	0	7		0	0	0	80159	0	1043400	40229134		
29652	2456	1118084	1995-05-04	1995-05-04 00:00:00	1995-05-04	1995-05-04 00:00:00	\N	38000177		0	0	0		0	0	0	162792	0	00025152531	44923712		
1824	145	1127078	1950-10-21	1950-10-21 00:00:00	1950-11-04	1950-11-04 00:00:00	1950-11-04	38000177		0	0	14		0	0	0	9775	0	282464	1127078		
41413	3434	19059056	1961-02-20	1961-02-20 00:00:00	1961-03-06	1961-03-06 00:00:00	1961-03-06	38000177		0	0	14		0	0	0	227682	0	243670	19059056		
45901	3799	40162522	2000-04-22	2000-04-22 00:00:00	2000-04-22	2000-04-22 00:00:00	\N	38000177		0	0	0		0	0	0	252529	0	857005	40162522		
63324	5259	40229134	1973-02-11	1973-02-11 00:00:00	1973-02-18	1973-02-18 00:00:00	1973-02-18	38000177		0	0	7		0	0	0	349972	0	1043400	40229134		
22587	1854	1127433	1986-07-05	1986-07-05 00:00:00	1986-07-12	1986-07-12 00:00:00	1986-07-12	38000177		0	0	7		0	0	0	124062	0	313782	1127433		
43592	3614	1127433	1952-09-17	1952-09-17 00:00:00	1952-10-01	1952-10-01 00:00:00	1952-10-01	38000177		0	0	14		0	0	0	240140	0	313782	1127433		
50851	4224	1127433	1978-07-24	1978-07-24 00:00:00	1978-08-07	1978-08-07 00:00:00	1978-08-07	38000177		0	0	14		0	0	0	280515	0	313782	1127433		
15236	1272	19133873	1990-12-16	1990-12-16 00:00:00	1990-12-23	1990-12-23 00:00:00	1990-12-23	38000177		0	0	7		0	0	0	83902	0	834061	19133873		
60560	5037	40229134	2014-08-03	2014-08-03 00:00:00	2014-08-17	2014-08-17 00:00:00	2014-08-17	38000177		0	0	14		0	0	0	334774	0	1043400	40229134		
68823	1506	40213227	2007-04-07	2007-04-07 00:00:00	2007-04-07	2007-04-07 00:00:00	2007-04-07	581452		0	0	0		0	0	0	100465	0	113	40213227		
33674	2786	1118084	1959-10-11	1959-10-11 00:00:00	1959-10-11	1959-10-11 00:00:00	\N	38000177		0	0	0		0	0	0	184573	0	00025152531	44923712		
33443	2770	19074679	1945-03-31	1945-03-31 00:00:00	1945-09-01	1945-09-01 00:00:00	1945-09-01	38000177		0	0	154		0	0	0	183302	0	308971	19074679		
26406	2173	1713671	1996-12-12	1996-12-12 00:00:00	1997-01-02	1997-01-02 00:00:00	1997-01-02	38000177		0	0	21		0	0	0	144870	0	562251	1713671		
36439	3004	19133873	1957-08-01	1957-08-01 00:00:00	1957-08-14	1957-08-14 00:00:00	1957-08-14	38000177		0	0	13		0	0	0	200463	0	834061	19133873		
39970	3308	1545959	1996-11-18	1996-11-18 00:00:00	1996-11-18	1996-11-18 00:00:00	1996-11-18	38000177		0	0	0		0	0	0	219656	0	259255	1545959		
11088	924	1713671	2018-09-11	2018-09-11 00:00:00	2018-09-18	2018-09-18 00:00:00	2018-09-18	38000177		0	0	7		0	0	0	61518	0	562251	1713671		
11405	950	19059056	1985-05-26	1985-05-26 00:00:00	1985-06-16	1985-06-16 00:00:00	1985-06-16	38000177		0	0	21		0	0	0	63098	0	243670	19059056		
7918	170	40213160	1971-05-13	1971-05-13 00:00:00	1971-05-13	1971-05-13 00:00:00	1971-05-13	581452		0	0	0		0	0	0	11562	0	10	40213160		
47116	3904	40236824	2005-03-29	2005-03-29 00:00:00	2005-04-05	2005-04-05 00:00:00	2005-04-05	38000177		0	0	7		0	0	0	259638	0	1094107	40236824		
23498	510	40213160	1966-03-12	1966-03-12 00:00:00	1966-03-12	1966-03-12 00:00:00	1966-03-12	581452		0	0	0		0	0	0	34114	0	10	40213160		
5729	480	1127433	1944-07-20	1944-07-20 00:00:00	1944-07-27	1944-07-27 00:00:00	1944-07-27	38000177		0	0	7		0	0	0	32019	0	313782	1127433		
94785	2079	40213160	1960-11-25	1960-11-25 00:00:00	1960-11-25	1960-11-25 00:00:00	1960-11-25	581452		0	0	0		0	0	0	138497	0	10	40213160		
73915	1613	40213160	1959-04-25	1959-04-25 00:00:00	1959-04-25	1959-04-25 00:00:00	1959-04-25	581452		0	0	0		0	0	0	108506	0	10	40213160		
13415	1124	1127433	1958-04-24	1958-04-24 00:00:00	1958-05-08	1958-05-08 00:00:00	1958-05-08	38000177		0	0	14		0	0	0	74075	0	313782	1127433		
41030	3403	1118084	2008-08-08	2008-08-08 00:00:00	2008-08-08	2008-08-08 00:00:00	\N	38000177		0	0	0		0	0	0	225757	0	00025152531	44923712		
21121	1740	40229134	1962-10-16	1962-10-16 00:00:00	1962-10-23	1962-10-23 00:00:00	1962-10-23	38000177		0	0	7		0	0	0	116304	0	1043400	40229134		
3195	263	1118084	1991-03-28	1991-03-28 00:00:00	1991-03-28	1991-03-28 00:00:00	\N	38000177		0	0	0		0	0	0	17501	0	00025152531	44923712		
3237	266	1551192	1973-02-24	1973-02-24 00:00:00	1973-02-24	1973-02-24 00:00:00	1973-02-24	38000177		0	0	0		0	0	0	17690	0	312617	1551192		
4408	366	1118084	1944-08-29	1944-08-29 00:00:00	1944-08-29	1944-08-29 00:00:00	\N	38000177		0	0	0		0	0	0	24337	0	00025152531	44923712		
6983	588	40229134	1981-11-26	1981-11-26 00:00:00	1981-12-10	1981-12-10 00:00:00	1981-12-10	38000177		0	0	14		0	0	0	38916	0	1043400	40229134		
11607	967	1713671	2016-04-13	2016-04-13 00:00:00	2016-04-20	2016-04-20 00:00:00	2016-04-20	38000177		0	0	7		0	0	0	64365	0	562251	1713671		
22083	1814	46275444	2018-04-03	2018-04-03 00:00:00	2018-04-03	2018-04-03 00:00:00	2018-04-03	38000177		0	0	0		0	0	0	121406	0	1659149	46275444		
30946	2563	19059056	1979-01-12	1979-01-12 00:00:00	1979-04-12	1979-04-12 00:00:00	1979-04-12	38000177		0	0	90		0	0	0	169791	0	243670	19059056		
250	18	40162522	1995-06-25	1995-06-25 00:00:00	1995-06-25	1995-06-25 00:00:00	\N	38000177		0	0	0		0	0	0	1383	0	857005	40162522		
51	3	19078461	1987-11-28	1987-11-28 00:00:00	1987-12-26	1987-12-26 00:00:00	1987-12-26	38000177		0	0	28		0	0	0	313	0	310965	19078461		
17821	1476	1713671	1967-09-02	1967-09-02 00:00:00	1967-09-09	1967-09-09 00:00:00	1967-09-09	38000177		0	0	7		0	0	0	98326	0	562251	1713671		
12690	273	40213227	1998-03-08	1998-03-08 00:00:00	1998-03-08	1998-03-08 00:00:00	1998-03-08	581452		0	0	0		0	0	0	18308	0	113	40213227		
25705	2115	19059056	1989-12-16	1989-12-16 00:00:00	1990-03-16	1990-03-16 00:00:00	1990-03-16	38000177		0	0	90		0	0	0	140704	0	243670	19059056		
36231	2985	1713671	1993-02-07	1993-02-07 00:00:00	1993-02-14	1993-02-14 00:00:00	1993-02-14	38000177		0	0	7		0	0	0	199250	0	562251	1713671		
38014	3144	920334	1998-07-01	1998-07-01 00:00:00	1998-07-08	1998-07-08 00:00:00	1998-07-08	38000177		0	0	7		0	0	0	209214	0	311995	920334		
59699	4964	40231925	1978-06-13	1978-06-13 00:00:00	1978-06-13	1978-06-13 00:00:00	\N	38000177		0	0	0		0	0	0	329970	0	1049221	40231925		
18401	1523	1713671	2011-09-27	2011-09-27 00:00:00	2011-10-18	2011-10-18 00:00:00	2011-10-18	38000177		0	0	21		0	0	0	101836	0	562251	1713671		
40672	3371	19133873	1984-01-26	1984-01-26 00:00:00	1984-02-03	1984-02-03 00:00:00	1984-02-03	38000177		0	0	8		0	0	0	223604	0	834061	19133873		
27084	2233	1118084	2014-07-10	2014-07-10 00:00:00	2014-07-10	2014-07-10 00:00:00	\N	38000177		0	0	0		0	0	0	148555	0	00025152531	44923712		
19724	1623	1127433	2019-01-19	2019-01-19 00:00:00	2019-02-02	2019-02-02 00:00:00	2019-02-02	38000177		0	0	14		0	0	0	109092	0	313782	1127433		
30272	2509	19006318	1974-07-12	1974-07-12 00:00:00	1974-07-26	1974-07-26 00:00:00	1974-07-26	38000177		0	0	14		0	0	0	166070	0	105078	19006318		
42685	3537	19008572	1972-06-21	1972-06-21 00:00:00	1972-07-12	1972-07-12 00:00:00	1972-07-12	38000177		0	0	21		0	0	0	234968	0	106258	19008572		
37713	3117	1118084	2008-04-14	2008-04-14 00:00:00	2008-04-14	2008-04-14 00:00:00	\N	38000177		0	0	0		0	0	0	207340	0	00025152531	44923712		
41194	3417	40229134	1957-07-22	1957-07-22 00:00:00	1957-08-05	1957-08-05 00:00:00	1957-08-05	38000177		0	0	14		0	0	0	226581	0	1043400	40229134		
1913	153	1713671	1948-04-22	1948-04-22 00:00:00	1948-04-29	1948-04-29 00:00:00	1948-04-29	38000177		0	0	7		0	0	0	10365	0	562251	1713671		
41249	3420	1713671	1970-02-05	1970-02-05 00:00:00	1970-02-12	1970-02-12 00:00:00	1970-02-12	38000177		0	0	7		0	0	0	226904	0	562251	1713671		
53367	4436	1127433	2007-08-30	2007-08-30 00:00:00	2007-09-13	2007-09-13 00:00:00	2007-09-13	38000177		0	0	14		0	0	0	294882	0	313782	1127433		
63215	5252	1127433	1961-12-06	1961-12-06 00:00:00	1961-12-13	1961-12-13 00:00:00	1961-12-13	38000177		0	0	7		0	0	0	349409	0	313782	1127433		
20854	1719	1713671	2005-06-30	2005-06-30 00:00:00	2005-07-14	2005-07-14 00:00:00	2005-07-14	38000177		0	0	14		0	0	0	114895	0	562251	1713671		
56195	4665	19128022	1995-08-12	1995-08-12 00:00:00	1996-08-06	1996-08-06 00:00:00	1996-08-06	38000177		0	0	360		0	0	0	310909	0	749785	19128022		
4921	409	1551192	1951-12-30	1951-12-30 00:00:00	1951-12-30	1951-12-30 00:00:00	1951-12-30	38000177		0	0	0		0	0	0	27031	0	312617	1551192		
8396	701	19059056	1959-05-07	1959-05-07 00:00:00	1959-05-21	1959-05-21 00:00:00	1959-05-21	38000177		0	0	14		0	0	0	46323	0	243670	19059056		
11669	971	1127433	2010-01-26	2010-01-26 00:00:00	2010-02-02	2010-02-02 00:00:00	2010-02-02	38000177		0	0	7		0	0	0	64587	0	313782	1127433		
20220	1659	46233988	1971-03-07	1971-03-07 00:00:00	1971-03-21	1971-03-21 00:00:00	1971-03-21	38000177		0	0	14		0	0	0	111502	0	1652673	46233988		
47156	3909	1713671	1977-02-21	1977-02-21 00:00:00	1977-03-07	1977-03-07 00:00:00	1977-03-07	38000177		0	0	14		0	0	0	259830	0	562251	1713671		
111401	2448	40213160	1964-10-21	1964-10-21 00:00:00	1964-10-21	1964-10-21 00:00:00	1964-10-21	581452		0	0	0		0	0	0	162368	0	10	40213160		
30711	670	40213227	1995-12-01	1995-12-01 00:00:00	1995-12-01	1995-12-01 00:00:00	1995-12-01	581452		0	0	0		0	0	0	44248	0	113	40213227		
14533	1217	40169281	1995-06-30	1995-06-30 00:00:00	1995-06-30	1995-06-30 00:00:00	\N	38000177		0	0	0		0	0	0	80192	0	896209	40169281		
29653	2456	19133905	1981-10-21	1981-10-21 00:00:00	1981-10-28	1981-10-28 00:00:00	1981-10-28	38000177		0	0	7		0	0	0	162754	0	834102	19133905		
1825	145	40231925	2003-05-17	2003-05-17 00:00:00	2003-05-17	2003-05-17 00:00:00	\N	38000177		0	0	0		0	0	0	9805	0	1049221	40231925		
41414	3434	40229134	1978-08-22	1978-08-22 00:00:00	1978-09-05	1978-09-05 00:00:00	1978-09-05	38000177		0	0	14		0	0	0	227727	0	1043400	40229134		
45902	3799	1127433	2000-04-22	2000-04-22 00:00:00	2000-07-21	2000-07-21 00:00:00	2000-07-21	38000177		0	0	90		0	0	0	252529	0	313782	1127433		
63325	5259	1713671	1992-09-18	1992-09-18 00:00:00	1992-09-25	1992-09-25 00:00:00	1992-09-25	38000177		0	0	7		0	0	0	349999	0	562251	1713671		
22588	1854	40236824	2005-12-06	2005-12-06 00:00:00	2005-12-20	2005-12-20 00:00:00	2005-12-20	38000177		0	0	14		0	0	0	124081	0	1094107	40236824		
43593	3614	1127433	1959-11-25	1959-11-25 00:00:00	1959-12-02	1959-12-02 00:00:00	1959-12-02	38000177		0	0	7		0	0	0	240141	0	313782	1127433		
50852	4224	1127433	1996-12-04	1996-12-04 00:00:00	1996-12-11	1996-12-11 00:00:00	1996-12-11	38000177		0	0	7		0	0	0	280453	0	313782	1127433		
15237	1272	19133905	2018-12-14	2018-12-14 00:00:00	2018-12-27	2018-12-27 00:00:00	2018-12-27	38000177		0	0	13		0	0	0	83970	0	834102	19133905		
60561	5037	19132304	2006-11-21	2006-11-21 00:00:00	2007-11-24	2007-11-24 00:00:00	2007-11-24	38000177		0	0	368		0	0	0	334797	0	807283	19132304		
68834	1506	40213201	2012-05-05	2012-05-05 00:00:00	2012-05-05	2012-05-05 00:00:00	2012-05-05	581452		0	0	0		0	0	0	100408	0	33	40213201		
33675	2786	1713671	1962-06-21	1962-06-21 00:00:00	1962-07-12	1962-07-12 00:00:00	1962-07-12	38000177		0	0	21		0	0	0	184603	0	562251	1713671		
33444	2770	40220960	2015-08-15	2015-08-15 00:00:00	2015-08-15	2015-08-15 00:00:00	2015-08-15	38000177		0	0	0		0	0	0	183245	0	1804799	40220960		
26407	2173	1127433	2012-08-27	2012-08-27 00:00:00	2012-09-10	2012-09-10 00:00:00	2012-09-10	38000177		0	0	14		0	0	0	144750	0	313782	1127433		
36440	3004	1713671	1965-08-07	1965-08-07 00:00:00	1965-08-28	1965-08-28 00:00:00	1965-08-28	38000177		0	0	21		0	0	0	200433	0	562251	1713671		
39971	3308	1127433	1977-12-18	1977-12-18 00:00:00	1978-01-22	1978-01-22 00:00:00	1978-01-22	38000177		0	0	35		0	0	0	219655	0	313782	1127433		
11089	924	19128065	1981-06-05	1981-06-05 00:00:00	1982-05-31	1982-05-31 00:00:00	1982-05-31	38000177		0	0	360		0	0	0	61508	0	749882	19128065		
11406	950	19059056	1972-09-10	1972-09-10 00:00:00	1972-09-24	1972-09-24 00:00:00	1972-09-24	38000177		0	0	14		0	0	0	63089	0	243670	19059056		
7923	170	40213227	2002-04-18	2002-04-18 00:00:00	2002-04-18	2002-04-18 00:00:00	2002-04-18	581452		0	0	0		0	0	0	11554	0	113	40213227		
47117	3904	19128022	1997-01-28	1997-01-28 00:00:00	1998-01-23	1998-01-23 00:00:00	1998-01-23	38000177		0	0	360		0	0	0	259613	0	749785	19128022		
23501	510	40213260	2015-10-03	2015-10-03 00:00:00	2015-10-03	2015-10-03 00:00:00	2015-10-03	581452		0	0	0		0	0	0	34136	0	121	40213260		
5730	480	1713671	1950-05-01	1950-05-01 00:00:00	1950-05-15	1950-05-15 00:00:00	1950-05-15	38000177		0	0	14		0	0	0	32085	0	562251	1713671		
94802	2079	40213227	1997-06-13	1997-06-13 00:00:00	1997-06-13	1997-06-13 00:00:00	1997-06-13	581452		0	0	0		0	0	0	138461	0	113	40213227		
105971	2325	40213160	1971-04-08	1971-04-08 00:00:00	1971-04-08	1971-04-08 00:00:00	1971-04-08	581452		0	0	0		0	0	0	154609	0	10	40213160		
13416	1124	1127433	1954-05-29	1954-05-29 00:00:00	1954-06-12	1954-06-12 00:00:00	1954-06-12	38000177		0	0	14		0	0	0	74093	0	313782	1127433		
41031	3403	1127078	1980-03-03	1980-03-03 00:00:00	1980-03-24	1980-03-24 00:00:00	1980-03-24	38000177		0	0	21		0	0	0	225742	0	282464	1127078		
21122	1740	1118084	1989-10-12	1989-10-12 00:00:00	1989-10-12	1989-10-12 00:00:00	\N	38000177		0	0	0		0	0	0	116281	0	00025152531	44923712		
3196	263	1127433	1988-09-04	1988-09-04 00:00:00	1988-09-11	1988-09-11 00:00:00	1988-09-11	38000177		0	0	7		0	0	0	17442	0	313782	1127433		
3238	266	19133905	1999-04-22	1999-04-22 00:00:00	1999-05-05	1999-05-05 00:00:00	1999-05-05	38000177		0	0	13		0	0	0	17659	0	834102	19133905		
4409	366	40236824	1951-03-06	1951-03-06 00:00:00	1951-03-13	1951-03-13 00:00:00	1951-03-13	38000177		0	0	7		0	0	0	24269	0	1094107	40236824		
6984	588	1118084	2019-06-08	2019-06-08 00:00:00	2019-06-08	2019-06-08 00:00:00	\N	38000177		0	0	0		0	0	0	38960	0	00025152531	44923712		
11608	967	1127433	1994-02-18	1994-02-18 00:00:00	1994-03-04	1994-03-04 00:00:00	1994-03-04	38000177		0	0	14		0	0	0	64357	0	313782	1127433		
22084	1814	35605482	2018-04-03	2018-04-03 00:00:00	2018-04-03	2018-04-03 00:00:00	2018-04-03	38000177		0	0	0		0	0	0	121406	0	1740467	35605482		
30947	2563	1118084	2009-01-22	2009-01-22 00:00:00	2009-01-22	2009-01-22 00:00:00	\N	38000177		0	0	0		0	0	0	169773	0	00025152531	44923712		
251	18	1127433	1995-06-25	1995-06-25 00:00:00	1995-09-23	1995-09-23 00:00:00	1995-09-23	38000177		0	0	90		0	0	0	1383	0	313782	1127433		
52	3	1127433	1950-01-25	1950-01-25 00:00:00	1950-02-24	1950-02-24 00:00:00	1950-02-24	38000177		0	0	30		0	0	0	344	0	313782	1127433		
17822	1476	19059056	1957-10-27	1957-10-27 00:00:00	1957-11-10	1957-11-10 00:00:00	1957-11-10	38000177		0	0	14		0	0	0	98493	0	243670	19059056		
12692	273	40213160	1975-12-21	1975-12-21 00:00:00	1975-12-21	1975-12-21 00:00:00	1975-12-21	581452		0	0	0		0	0	0	18298	0	10	40213160		
25706	2115	40236824	1986-10-22	1986-10-22 00:00:00	1986-10-29	1986-10-29 00:00:00	1986-10-29	38000177		0	0	7		0	0	0	140707	0	1094107	40236824		
36232	2986	19133873	1948-05-10	1948-05-10 00:00:00	1948-05-17	1948-05-17 00:00:00	1948-05-17	38000177		0	0	7		0	0	0	199346	0	834061	19133873		
48473	4017	19059056	1948-11-06	1948-11-06 00:00:00	1948-11-27	1948-11-27 00:00:00	1948-11-27	38000177		0	0	21		0	0	0	267031	0	243670	19059056		
59700	4964	1127433	1978-06-13	1978-06-13 00:00:00	1978-08-12	1978-08-12 00:00:00	1978-08-12	38000177		0	0	60		0	0	0	329970	0	313782	1127433		
18402	1523	19078461	2001-08-25	2001-08-25 00:00:00	2001-09-08	2001-09-08 00:00:00	2001-09-08	38000177		0	0	14		0	0	0	101866	0	310965	19078461		
40696	3375	19006318	1956-11-19	1956-11-19 00:00:00	1956-12-03	1956-12-03 00:00:00	1956-12-03	38000177		0	0	14		0	0	0	223883	0	105078	19006318		
27085	2233	40229134	1986-01-03	1986-01-03 00:00:00	1986-01-10	1986-01-10 00:00:00	1986-01-10	38000177		0	0	7		0	0	0	148585	0	1043400	40229134		
19725	1623	1127433	1968-01-14	1968-01-14 00:00:00	1968-02-04	1968-02-04 00:00:00	1968-02-04	38000177		0	0	21		0	0	0	109138	0	313782	1127433		
165286	3634	40213306	1992-04-27	1992-04-27 00:00:00	1992-04-27	1992-04-27 00:00:00	1992-04-27	581452		0	0	0		0	0	0	241715	0	43	40213306		
42686	3537	19059056	1967-12-21	1967-12-21 00:00:00	1968-01-04	1968-01-04 00:00:00	1968-01-04	38000177		0	0	14		0	0	0	234956	0	243670	19059056		
37714	3117	1127433	1985-10-28	1985-10-28 00:00:00	1985-11-04	1985-11-04 00:00:00	1985-11-04	38000177		0	0	7		0	0	0	207379	0	313782	1127433		
41195	3417	920300	1950-05-07	1950-05-07 00:00:00	1950-05-14	1950-05-14 00:00:00	1950-05-14	38000177		0	0	7		0	0	0	226606	0	311989	920300		
1914	153	1127433	1996-10-22	1996-10-22 00:00:00	1996-11-05	1996-11-05 00:00:00	1996-11-05	38000177		0	0	14		0	0	0	10396	0	313782	1127433		
41250	3420	1127433	2002-07-29	2002-07-29 00:00:00	2002-08-05	2002-08-05 00:00:00	2002-08-05	38000177		0	0	7		0	0	0	226887	0	313782	1127433		
53368	4436	19078461	2017-06-22	2017-06-22 00:00:00	2017-08-28	2017-08-28 00:00:00	2017-08-28	38000177		0	0	67		0	0	0	294883	0	310965	19078461		
63216	5252	1115171	2005-03-31	2005-03-31 00:00:00	2005-06-29	2005-06-29 00:00:00	2005-06-29	38000177		0	0	90		0	0	0	349451	0	849574	1115171		
20855	1719	40173590	2017-06-13	2017-06-13 00:00:00	2017-06-13	2017-06-13 00:00:00	\N	38000177		0	0	0		0	0	0	114975	0	904419	40173590		
56196	4665	19075601	2009-01-31	2009-01-31 00:00:00	2009-01-31	2009-01-31 00:00:00	2009-01-31	38000177		0	0	0		0	0	0	310894	0	309362	19075601		
4922	409	19078461	2007-01-31	2007-01-31 00:00:00	2007-02-21	2007-02-21 00:00:00	2007-02-21	38000177		0	0	21		0	0	0	27153	0	310965	19078461		
8397	701	19006318	1959-05-07	1959-05-07 00:00:00	1959-05-21	1959-05-21 00:00:00	1959-05-21	38000177		0	0	14		0	0	0	46323	0	105078	19006318		
11670	971	19059056	1946-01-02	1946-01-02 00:00:00	1946-01-16	1946-01-16 00:00:00	1946-01-16	38000177		0	0	14		0	0	0	64588	0	243670	19059056		
3872	321	1127078	1966-08-18	1966-08-18 00:00:00	1966-10-17	1966-10-17 00:00:00	1966-10-17	38000177		0	0	60		0	0	0	21318	0	282464	1127078		
47157	3909	19006318	1961-10-17	1961-10-17 00:00:00	1961-10-31	1961-10-31 00:00:00	1961-10-31	38000177		0	0	14		0	0	0	259840	0	105078	19006318		
111409	2448	40213296	2004-07-21	2004-07-21 00:00:00	2004-07-21	2004-07-21 00:00:00	2004-07-21	581452		0	0	0		0	0	0	162398	0	52	40213296		
30712	670	40213306	1995-12-01	1995-12-01 00:00:00	1995-12-01	1995-12-01 00:00:00	1995-12-01	581452		0	0	0		0	0	0	44248	0	43	40213306		
14534	1217	19078461	2014-07-11	2014-07-11 00:00:00	2014-08-08	2014-08-08 00:00:00	2014-08-08	38000177		0	0	28		0	0	0	80184	0	310965	19078461		
29654	2456	1127433	2002-04-17	2002-04-17 00:00:00	2002-05-01	2002-05-01 00:00:00	2002-05-01	38000177		0	0	14		0	0	0	162817	0	313782	1127433		
1826	145	1115171	2003-05-17	2003-05-17 00:00:00	2003-08-15	2003-08-15 00:00:00	2003-08-15	38000177		0	0	90		0	0	0	9805	0	849574	1115171		
41416	3434	40229134	2001-04-11	2001-04-11 00:00:00	2001-04-25	2001-04-25 00:00:00	2001-04-25	38000177		0	0	14		0	0	0	227693	0	1043400	40229134		
45903	3799	19019979	1980-07-08	1980-07-08 00:00:00	1980-07-22	1980-07-22 00:00:00	1980-07-22	38000177		0	0	14		0	0	0	252527	0	198405	19019979		
63326	5259	1127433	1973-09-29	1973-09-29 00:00:00	1973-11-28	1973-11-28 00:00:00	1973-11-28	38000177		0	0	60		0	0	0	350003	0	313782	1127433		
22589	1854	920300	2005-12-06	2005-12-06 00:00:00	2005-12-13	2005-12-13 00:00:00	2005-12-13	38000177		0	0	7		0	0	0	124081	0	311989	920300		
43594	3614	1127433	2008-03-30	2008-03-30 00:00:00	2008-04-13	2008-04-13 00:00:00	2008-04-13	38000177		0	0	14		0	0	0	240115	0	313782	1127433		
50853	4225	1124300	2014-06-20	2014-06-20 00:00:00	2014-06-20	2014-06-20 00:00:00	\N	38000177		0	0	0		0	0	0	280598	0	00781178901	45011828		
15238	1272	40229134	2008-10-04	2008-10-04 00:00:00	2008-10-18	2008-10-18 00:00:00	2008-10-18	38000177		0	0	14		0	0	0	83951	0	1043400	40229134		
60562	5037	19127904	2004-12-01	2004-12-01 00:00:00	2005-11-26	2005-11-26 00:00:00	2005-11-26	38000177		0	0	360		0	0	0	334779	0	748856	19127904		
29277	2424	19078924	1997-06-06	1997-06-06 00:00:00	1997-06-06	1997-06-06 00:00:00	1997-06-06	38000177		0	0	0		0	0	0	160819	0	311700	19078924		
33676	2786	19059056	1956-01-19	1956-01-19 00:00:00	1956-02-09	1956-02-09 00:00:00	1956-02-09	38000177		0	0	21		0	0	0	184609	0	243670	19059056		
33445	2770	19075601	2015-08-15	2015-08-15 00:00:00	2015-08-15	2015-08-15 00:00:00	2015-08-15	38000177		0	0	0		0	0	0	183245	0	309362	19075601		
26408	2173	19059056	1934-11-14	1934-11-14 00:00:00	1934-11-28	1934-11-28 00:00:00	1934-11-28	38000177		0	0	14		0	0	0	144873	0	243670	19059056		
36441	3004	1713671	2006-06-22	2006-06-22 00:00:00	2006-06-29	2006-06-29 00:00:00	2006-06-29	38000177		0	0	7		0	0	0	200460	0	562251	1713671		
39972	3308	1127433	1991-02-05	1991-02-05 00:00:00	1991-02-19	1991-02-19 00:00:00	1991-02-19	38000177		0	0	14		0	0	0	219642	0	313782	1127433		
11090	924	19128065	1979-06-16	1979-06-16 00:00:00	1980-06-10	1980-06-10 00:00:00	1980-06-10	38000177		0	0	360		0	0	0	61506	0	749882	19128065		
11407	950	46233988	1972-09-10	1972-09-10 00:00:00	1972-09-24	1972-09-24 00:00:00	1972-09-24	38000177		0	0	14		0	0	0	63089	0	1652673	46233988		
7928	171	40213160	1968-06-17	1968-06-17 00:00:00	1968-06-17	1968-06-17 00:00:00	1968-06-17	581452		0	0	0		0	0	0	11596	0	10	40213160		
47118	3904	1713671	2010-05-20	2010-05-20 00:00:00	2010-05-27	2010-05-27 00:00:00	2010-05-27	38000177		0	0	7		0	0	0	259610	0	562251	1713671		
23507	510	40213227	2008-08-16	2008-08-16 00:00:00	2008-08-16	2008-08-16 00:00:00	2008-08-16	581452		0	0	0		0	0	0	34137	0	113	40213227		
5731	480	1127433	1995-11-21	1995-11-21 00:00:00	1995-12-05	1995-12-05 00:00:00	1995-12-05	38000177		0	0	14		0	0	0	31970	0	313782	1127433		
94803	2079	40213296	1997-06-13	1997-06-13 00:00:00	1997-06-13	1997-06-13 00:00:00	1997-06-13	581452		0	0	0		0	0	0	138461	0	52	40213296		
105979	2325	40213227	2012-11-08	2012-11-08 00:00:00	2012-11-08	2012-11-08 00:00:00	2012-11-08	581452		0	0	0		0	0	0	154633	0	113	40213227		
13417	1124	1127433	1938-06-23	1938-06-23 00:00:00	1938-06-30	1938-06-30 00:00:00	1938-06-30	38000177		0	0	7		0	0	0	74091	0	313782	1127433		
41032	3403	19078461	2005-11-22	2005-11-22 00:00:00	2005-12-13	2005-12-13 00:00:00	2005-12-13	38000177		0	0	21		0	0	0	225744	0	310965	19078461		
21123	1740	920300	2012-10-04	2012-10-04 00:00:00	2012-10-11	2012-10-11 00:00:00	2012-10-11	38000177		0	0	7		0	0	0	116297	0	311989	920300		
3197	263	1127433	1979-02-23	1979-02-23 00:00:00	1979-03-23	1979-03-23 00:00:00	1979-03-23	38000177		0	0	28		0	0	0	17422	0	313782	1127433		
3239	266	1127078	1967-05-27	1967-05-27 00:00:00	1967-07-10	1967-07-10 00:00:00	1967-07-10	38000177		0	0	44		0	0	0	17638	0	282464	1127078		
4410	366	920300	1951-03-06	1951-03-06 00:00:00	1951-03-13	1951-03-13 00:00:00	1951-03-13	38000177		0	0	7		0	0	0	24269	0	311989	920300		
6985	588	1115171	2008-12-02	2008-12-02 00:00:00	2008-12-23	2008-12-23 00:00:00	2008-12-23	38000177		0	0	21		0	0	0	38938	0	849574	1115171		
11609	967	40162522	2003-03-12	2003-03-12 00:00:00	2003-03-12	2003-03-12 00:00:00	\N	38000177		0	0	0		0	0	0	64318	0	857005	40162522		
22085	1814	35605482	2018-04-03	2018-04-03 00:00:00	2018-04-03	2018-04-03 00:00:00	2018-04-03	38000177		0	0	0		0	0	0	121406	0	1740467	35605482		
30948	2563	1115171	2000-03-06	2000-03-06 00:00:00	2000-03-27	2000-03-27 00:00:00	2000-03-27	38000177		0	0	21		0	0	0	169793	0	849574	1115171		
252	18	1127078	1970-09-22	1970-09-22 00:00:00	1970-10-06	1970-10-06 00:00:00	1970-10-06	38000177		0	0	14		0	0	0	1381	0	282464	1127078		
53	3	1713671	1985-03-22	1985-03-22 00:00:00	1985-03-29	1985-03-29 00:00:00	1985-03-29	38000177		0	0	7		0	0	0	319	0	562251	1713671		
17823	1476	19133905	2002-11-07	2002-11-07 00:00:00	2002-11-20	2002-11-20 00:00:00	2002-11-20	38000177		0	0	13		0	0	0	98419	0	834102	19133905		
10807	902	19006318	1952-05-17	1952-05-17 00:00:00	1952-05-31	1952-05-31 00:00:00	1952-05-31	38000177		0	0	14		0	0	0	60015	0	105078	19006318		
25707	2115	920300	1986-10-22	1986-10-22 00:00:00	1986-10-29	1986-10-29 00:00:00	1986-10-29	38000177		0	0	7		0	0	0	140707	0	311989	920300		
36233	2986	46275916	1946-03-12	1946-03-12 00:00:00	1946-03-12	1946-03-12 00:00:00	1946-03-12	38000177		0	0	0		0	0	0	199353	0	1660014	46275916		
48474	4017	1127433	1930-02-08	1930-02-08 00:00:00	1930-02-22	1930-02-22 00:00:00	1930-02-22	38000177		0	0	14		0	0	0	267033	0	313782	1127433		
59702	4964	19128065	1976-01-30	1976-01-30 00:00:00	1977-01-24	1977-01-24 00:00:00	1977-01-24	38000177		0	0	360		0	0	0	330009	0	749882	19128065		
18403	1523	19073188	2001-08-25	2001-08-25 00:00:00	2001-09-08	2001-09-08 00:00:00	2001-09-08	38000177		0	0	14		0	0	0	101866	0	308192	19073188		
40697	3375	1127078	1956-11-19	1956-11-19 00:00:00	1956-12-03	1956-12-03 00:00:00	1956-12-03	38000177		0	0	14		0	0	0	223883	0	282464	1127078		
27086	2233	1115171	1997-06-24	1997-06-24 00:00:00	1997-07-29	1997-07-29 00:00:00	1997-07-29	38000177		0	0	35		0	0	0	148604	0	849574	1115171		
19726	1623	40229134	2009-04-08	2009-04-08 00:00:00	2009-04-22	2009-04-22 00:00:00	2009-04-22	38000177		0	0	14		0	0	0	109082	0	1043400	40229134		
165288	3634	40213227	1992-04-27	1992-04-27 00:00:00	1992-04-27	1992-04-27 00:00:00	1992-04-27	581452		0	0	0		0	0	0	241715	0	113	40213227		
56371	4677	40229134	1967-12-23	1967-12-23 00:00:00	1967-12-30	1967-12-30 00:00:00	1967-12-30	38000177		0	0	7		0	0	0	311696	0	1043400	40229134		
37715	3118	40169281	1986-06-08	1986-06-08 00:00:00	1986-06-08	1986-06-08 00:00:00	\N	38000177		0	0	0		0	0	0	207509	0	896209	40169281		
41196	3417	40236824	1950-05-07	1950-05-07 00:00:00	1950-05-14	1950-05-14 00:00:00	1950-05-14	38000177		0	0	7		0	0	0	226606	0	1094107	40236824		
1915	153	19059056	1943-10-08	1943-10-08 00:00:00	1943-10-22	1943-10-22 00:00:00	1943-10-22	38000177		0	0	14		0	0	0	10336	0	243670	19059056		
41251	3420	19019979	1975-09-02	1975-09-02 00:00:00	1975-09-23	1975-09-23 00:00:00	1975-09-23	38000177		0	0	21		0	0	0	226882	0	198405	19019979		
53369	4436	1127078	1968-05-12	1968-05-12 00:00:00	1968-05-26	1968-05-26 00:00:00	1968-05-26	38000177		0	0	14		0	0	0	294878	0	282464	1127078		
63217	5252	1118084	1995-11-09	1995-11-09 00:00:00	1995-11-09	1995-11-09 00:00:00	\N	38000177		0	0	0		0	0	0	349478	0	00025152531	44923712		
20856	1719	1127433	2004-12-27	2004-12-27 00:00:00	2005-01-26	2005-01-26 00:00:00	2005-01-26	38000177		0	0	30		0	0	0	114996	0	313782	1127433		
56197	4665	40220960	2009-01-31	2009-01-31 00:00:00	2009-01-31	2009-01-31 00:00:00	2009-01-31	38000177		0	0	0		0	0	0	310894	0	1804799	40220960		
4923	410	1127078	1950-08-27	1950-08-27 00:00:00	1950-10-01	1950-10-01 00:00:00	1950-10-01	38000177		0	0	35		0	0	0	27155	0	282464	1127078		
8398	701	920300	1990-09-18	1990-09-18 00:00:00	1990-09-25	1990-09-25 00:00:00	1990-09-25	38000177		0	0	7		0	0	0	46347	0	311989	920300		
11671	971	19006318	1946-01-02	1946-01-02 00:00:00	1946-01-16	1946-01-16 00:00:00	1946-01-16	38000177		0	0	14		0	0	0	64588	0	105078	19006318		
3873	321	1713671	1991-04-21	1991-04-21 00:00:00	1991-05-12	1991-05-12 00:00:00	1991-05-12	38000177		0	0	21		0	0	0	21273	0	562251	1713671		
47158	3909	19059056	1961-10-17	1961-10-17 00:00:00	1961-10-31	1961-10-31 00:00:00	1961-10-31	38000177		0	0	14		0	0	0	259840	0	243670	19059056		
111411	2448	40213296	2006-07-26	2006-07-26 00:00:00	2006-07-26	2006-07-26 00:00:00	2006-07-26	581452		0	0	0		0	0	0	162351	0	52	40213296		
30714	670	40213296	2013-11-02	2013-11-02 00:00:00	2013-11-02	2013-11-02 00:00:00	2013-11-02	581452		0	0	0		0	0	0	44203	0	52	40213296		
14535	1217	1127433	2010-11-22	2010-11-22 00:00:00	2010-12-06	2010-12-06 00:00:00	2010-12-06	38000177		0	0	14		0	0	0	80138	0	313782	1127433		
1427	114	46233988	1977-06-15	1977-06-15 00:00:00	1977-06-29	1977-06-29 00:00:00	1977-06-29	38000177		0	0	14		0	0	0	7552	0	1652673	46233988		
12285	1032	19059056	1986-09-01	1986-09-01 00:00:00	1986-09-15	1986-09-15 00:00:00	1986-09-15	38000177		0	0	14		0	0	0	67951	0	243670	19059056		
41417	3434	19133905	1994-07-30	1994-07-30 00:00:00	1994-08-12	1994-08-12 00:00:00	1994-08-12	38000177		0	0	13		0	0	0	227746	0	834102	19133905		
45904	3799	19073188	1989-09-17	1989-09-17 00:00:00	1989-10-01	1989-10-01 00:00:00	1989-10-01	38000177		0	0	14		0	0	0	252536	0	308192	19073188		
63327	5259	19133873	1966-05-20	1966-05-20 00:00:00	1966-05-31	1966-05-31 00:00:00	1966-05-31	38000177		0	0	11		0	0	0	349933	0	834061	19133873		
22590	1854	1118084	2012-04-06	2012-04-06 00:00:00	2012-04-06	2012-04-06 00:00:00	\N	38000177		0	0	0		0	0	0	124118	0	00025152531	44923712		
43595	3614	19078461	1993-04-11	1993-04-11 00:00:00	1993-05-16	1993-05-16 00:00:00	1993-05-16	38000177		0	0	35		0	0	0	240099	0	310965	19078461		
50854	4225	1127433	1983-11-11	1983-11-11 00:00:00	1983-11-18	1983-11-18 00:00:00	1983-11-18	38000177		0	0	7		0	0	0	280620	0	313782	1127433		
15239	1272	1115171	1994-12-24	1994-12-24 00:00:00	1995-01-07	1995-01-07 00:00:00	1995-01-07	38000177		0	0	14		0	0	0	83861	0	849574	1115171		
60563	5037	19128022	1997-01-12	1997-01-12 00:00:00	1998-01-07	1998-01-07 00:00:00	1998-01-07	38000177		0	0	360		0	0	0	334745	0	749785	19128022		
29278	2424	35605858	1997-06-06	1997-06-06 00:00:00	1997-06-06	1997-06-06 00:00:00	1997-06-06	38000177		0	0	0		0	0	0	160819	0	1732136	35605858		
33677	2786	40229134	1963-04-29	1963-04-29 00:00:00	1963-05-13	1963-05-13 00:00:00	1963-05-13	38000177		0	0	14		0	0	0	184604	0	1043400	40229134		
33446	2770	1127433	1941-12-08	1941-12-08 00:00:00	1941-12-22	1941-12-22 00:00:00	1941-12-22	38000177		0	0	14		0	0	0	183310	0	313782	1127433		
26409	2173	19059056	1940-10-13	1940-10-13 00:00:00	1940-11-12	1940-11-12 00:00:00	1940-11-12	38000177		0	0	30		0	0	0	144757	0	243670	19059056		
36457	3007	19078461	1979-07-21	1979-07-21 00:00:00	1979-09-19	1979-09-19 00:00:00	1979-09-19	38000177		0	0	60		0	0	0	200600	0	310965	19078461		
39973	3308	19059056	1948-11-14	1948-11-14 00:00:00	1948-11-28	1948-11-28 00:00:00	1948-11-28	38000177		0	0	14		0	0	0	219645	0	243670	19059056		
11092	924	1127433	1968-02-04	1968-02-04 00:00:00	1968-02-11	1968-02-11 00:00:00	1968-02-11	38000177		0	0	7		0	0	0	61527	0	313782	1127433		
11408	950	40236446	1981-05-21	1981-05-21 00:00:00	1982-04-08	1982-04-08 00:00:00	1982-04-08	38000177		0	0	322		0	0	0	63108	0	1091392	40236446		
7930	171	40213160	1968-11-17	1968-11-17 00:00:00	1968-11-17	1968-11-17 00:00:00	1968-11-17	581452		0	0	0		0	0	0	11622	0	10	40213160		
47119	3904	1127433	1991-06-21	1991-06-21 00:00:00	1991-06-28	1991-06-28 00:00:00	1991-06-28	38000177		0	0	7		0	0	0	259593	0	313782	1127433		
23510	510	40213306	1987-10-10	1987-10-10 00:00:00	1987-10-10	1987-10-10 00:00:00	1987-10-10	581452		0	0	0		0	0	0	34090	0	43	40213306		
5732	480	1127433	2010-09-15	2010-09-15 00:00:00	2010-09-22	2010-09-22 00:00:00	2010-09-22	38000177		0	0	7		0	0	0	32092	0	313782	1127433		
94805	2079	40213227	2017-09-08	2017-09-08 00:00:00	2017-09-08	2017-09-08 00:00:00	2017-09-08	581452		0	0	0		0	0	0	138444	0	113	40213227		
105980	2325	40213296	2012-11-08	2012-11-08 00:00:00	2012-11-08	2012-11-08 00:00:00	2012-11-08	581452		0	0	0		0	0	0	154633	0	52	40213296		
13418	1124	19059056	1945-08-19	1945-08-19 00:00:00	1945-10-18	1945-10-18 00:00:00	1945-10-18	38000177		0	0	60		0	0	0	74111	0	243670	19059056		
41033	3403	19059056	1986-07-21	1986-07-21 00:00:00	1986-08-04	1986-08-04 00:00:00	1986-08-04	38000177		0	0	14		0	0	0	225743	0	243670	19059056		
21124	1740	40236824	2012-10-04	2012-10-04 00:00:00	2012-10-11	2012-10-11 00:00:00	2012-10-11	38000177		0	0	7		0	0	0	116297	0	1094107	40236824		
3198	263	1713671	1963-04-25	1963-04-25 00:00:00	1963-05-02	1963-05-02 00:00:00	1963-05-02	38000177		0	0	7		0	0	0	17434	0	562251	1713671		
3240	266	1551192	1984-12-25	1984-12-25 00:00:00	1984-12-25	1984-12-25 00:00:00	1984-12-25	38000177		0	0	0		0	0	0	17691	0	312617	1551192		
4411	366	1127433	1954-11-21	1954-11-21 00:00:00	1954-12-28	1954-12-28 00:00:00	1954-12-28	38000177		0	0	37		0	0	0	24353	0	313782	1127433		
127966	2815	40213160	1967-08-25	1967-08-25 00:00:00	1967-08-25	1967-08-25 00:00:00	1967-08-25	581452		0	0	0		0	0	0	186561	0	10	40213160		
11610	967	1127433	2003-03-12	2003-03-12 00:00:00	2003-06-10	2003-06-10 00:00:00	2003-06-10	38000177		0	0	90		0	0	0	64318	0	313782	1127433		
22086	1814	19079524	2018-04-03	2018-04-03 00:00:00	2018-04-03	2018-04-03 00:00:00	2018-04-03	38000177		0	0	0		0	0	0	121406	0	313002	19079524		
30949	2563	1127433	1991-02-12	1991-02-12 00:00:00	1991-02-26	1991-02-26 00:00:00	1991-02-26	38000177		0	0	14		0	0	0	169806	0	313782	1127433		
253	18	920300	1997-12-26	1997-12-26 00:00:00	1998-01-02	1998-01-02 00:00:00	1998-01-02	38000177		0	0	7		0	0	0	1395	0	311989	920300		
54	3	19059056	1967-05-26	1967-05-26 00:00:00	1967-06-16	1967-06-16 00:00:00	1967-06-16	38000177		0	0	21		0	0	0	346	0	243670	19059056		
17824	1476	1713671	1948-11-11	1948-11-11 00:00:00	1948-11-18	1948-11-18 00:00:00	1948-11-18	38000177		0	0	7		0	0	0	98531	0	562251	1713671		
10808	902	19059056	1990-12-15	1990-12-15 00:00:00	1990-12-25	1990-12-25 00:00:00	1990-12-25	38000177		0	0	10		0	0	0	60000	0	243670	19059056		
25708	2115	1127433	2004-08-29	2004-08-29 00:00:00	2004-10-05	2004-10-05 00:00:00	2004-10-05	38000177		0	0	37		0	0	0	140705	0	313782	1127433		
36234	2986	40243436	1946-03-12	1946-03-12 00:00:00	1946-03-12	1946-03-12 00:00:00	1946-03-12	38000177		0	0	0		0	0	0	199353	0	1190795	40243436		
48475	4017	19018935	1998-04-09	1998-04-09 00:00:00	1998-04-09	1998-04-09 00:00:00	\N	38000177		0	0	0		0	0	0	267002	0	197604	19018935		
59703	4964	40229134	1966-05-13	1966-05-13 00:00:00	1966-05-27	1966-05-27 00:00:00	1966-05-27	38000177		0	0	14		0	0	0	329983	0	1043400	40229134		
18404	1523	1127433	1974-07-29	1974-07-29 00:00:00	1974-08-12	1974-08-12 00:00:00	1974-08-12	38000177		0	0	14		0	0	0	101883	0	313782	1127433		
40698	3375	1713671	2007-10-12	2007-10-12 00:00:00	2007-10-26	2007-10-26 00:00:00	2007-10-26	38000177		0	0	14		0	0	0	223872	0	562251	1713671		
27087	2233	1127433	1987-01-13	1987-01-13 00:00:00	1987-02-17	1987-02-17 00:00:00	1987-02-17	38000177		0	0	35		0	0	0	148603	0	313782	1127433		
19727	1623	19126352	2017-07-14	2017-07-14 00:00:00	2017-07-14	2017-07-14 00:00:00	\N	38000177		0	0	0		0	0	0	109072	0	705129	19126352		
165289	3634	40213160	1970-08-03	1970-08-03 00:00:00	1970-08-03	1970-08-03 00:00:00	1970-08-03	581452		0	0	0		0	0	0	241716	0	10	40213160		
56372	4677	1127433	1977-04-14	1977-04-14 00:00:00	1977-05-19	1977-05-19 00:00:00	1977-05-19	38000177		0	0	35		0	0	0	311667	0	313782	1127433		
37716	3118	1118084	1985-12-21	1985-12-21 00:00:00	1985-12-21	1985-12-21 00:00:00	\N	38000177		0	0	0		0	0	0	207484	0	00025152531	44923712		
41197	3417	1127433	1995-08-02	1995-08-02 00:00:00	1995-08-09	1995-08-09 00:00:00	1995-08-09	38000177		0	0	7		0	0	0	226655	0	313782	1127433		
1916	153	19059056	1956-08-30	1956-08-30 00:00:00	1956-09-20	1956-09-20 00:00:00	1956-09-20	38000177		0	0	21		0	0	0	10317	0	243670	19059056		
41252	3420	40229134	1973-06-15	1973-06-15 00:00:00	1973-06-29	1973-06-29 00:00:00	1973-06-29	38000177		0	0	14		0	0	0	226844	0	1043400	40229134		
53370	4436	19008572	1984-06-02	1984-06-02 00:00:00	1984-06-02	1984-06-02 00:00:00	\N	38000177		0	0	0		0	0	0	294836	0	106258	19008572		
63218	5252	19133905	1990-02-15	1990-02-15 00:00:00	1990-02-28	1990-02-28 00:00:00	1990-02-28	38000177		0	0	13		0	0	0	349459	0	834102	19133905		
20857	1719	1127433	1959-08-28	1959-08-28 00:00:00	1959-09-11	1959-09-11 00:00:00	1959-09-11	38000177		0	0	14		0	0	0	114887	0	313782	1127433		
56198	4665	1115171	2003-08-20	2003-08-20 00:00:00	2003-09-03	2003-09-03 00:00:00	2003-09-03	38000177		0	0	14		0	0	0	310864	0	849574	1115171		
4924	410	1124300	1986-12-16	1986-12-16 00:00:00	1986-12-16	1986-12-16 00:00:00	\N	38000177		0	0	0		0	0	0	27241	0	00781178901	45011828		
8399	701	40236824	1990-09-18	1990-09-18 00:00:00	1990-09-25	1990-09-25 00:00:00	1990-09-25	38000177		0	0	7		0	0	0	46347	0	1094107	40236824		
11672	971	19078461	1985-12-01	1985-12-01 00:00:00	1985-12-15	1985-12-15 00:00:00	1985-12-15	38000177		0	0	14		0	0	0	64581	0	310965	19078461		
3874	321	1127433	1978-03-02	1978-03-02 00:00:00	1978-03-23	1978-03-23 00:00:00	1978-03-23	38000177		0	0	21		0	0	0	21320	0	313782	1127433		
47159	3909	1127433	2012-12-23	2012-12-23 00:00:00	2013-01-06	2013-01-06 00:00:00	2013-01-06	38000177		0	0	14		0	0	0	259855	0	313782	1127433		
111413	2448	40213227	2006-07-26	2006-07-26 00:00:00	2006-07-26	2006-07-26 00:00:00	2006-07-26	581452		0	0	0		0	0	0	162351	0	113	40213227		
30717	670	40213160	1974-04-13	1974-04-13 00:00:00	1974-04-13	1974-04-13 00:00:00	1974-04-13	581452		0	0	0		0	0	0	44211	0	10	40213160		
14536	1217	19075601	2018-10-19	2018-10-19 00:00:00	2018-10-19	2018-10-19 00:00:00	2018-10-19	38000177		0	0	0		0	0	0	80147	0	309362	19075601		
1428	114	1127078	1977-06-15	1977-06-15 00:00:00	1977-06-29	1977-06-29 00:00:00	1977-06-29	38000177		0	0	14		0	0	0	7552	0	282464	1127078		
12286	1032	1127433	2010-08-28	2010-08-28 00:00:00	2010-09-11	2010-09-11 00:00:00	2010-09-11	38000177		0	0	14		0	0	0	67932	0	313782	1127433		
41418	3434	19006318	1950-05-12	1950-05-12 00:00:00	1950-05-26	1950-05-26 00:00:00	1950-05-26	38000177		0	0	14		0	0	0	227698	0	105078	19006318		
45905	3799	1127433	1989-09-17	1989-09-17 00:00:00	1989-10-01	1989-10-01 00:00:00	1989-10-01	38000177		0	0	14		0	0	0	252536	0	313782	1127433		
63328	5259	19133873	1973-08-24	1973-08-24 00:00:00	1973-09-04	1973-09-04 00:00:00	1973-09-04	38000177		0	0	11		0	0	0	349943	0	834061	19133873		
22591	1854	40236824	2009-02-03	2009-02-03 00:00:00	2009-02-10	2009-02-10 00:00:00	2009-02-10	38000177		0	0	7		0	0	0	124125	0	1094107	40236824		
43596	3614	1127078	1952-11-07	1952-11-07 00:00:00	1952-11-21	1952-11-21 00:00:00	1952-11-21	38000177		0	0	14		0	0	0	240117	0	282464	1127078		
50855	4225	19059056	1983-04-28	1983-04-28 00:00:00	1983-05-12	1983-05-12 00:00:00	1983-05-12	38000177		0	0	14		0	0	0	280617	0	243670	19059056		
15240	1272	40232448	1980-05-24	1980-05-24 00:00:00	1980-05-24	1980-05-24 00:00:00	\N	38000177		0	0	0		0	0	0	83864	0	1049630	40232448		
60564	5037	1127433	2002-04-08	2002-04-08 00:00:00	2002-04-15	2002-04-15 00:00:00	2002-04-15	38000177		0	0	7		0	0	0	334711	0	313782	1127433		
29279	2424	42707627	1997-06-06	1997-06-06 00:00:00	1997-06-06	1997-06-06 00:00:00	1997-06-06	38000177		0	0	0		0	0	0	160819	0	1234995	42707627		
33678	2786	1127433	2002-03-19	2002-03-19 00:00:00	2002-05-18	2002-05-18 00:00:00	2002-05-18	38000177		0	0	60		0	0	0	184613	0	313782	1127433		
33447	2770	19078461	2009-10-09	2009-10-09 00:00:00	2009-11-08	2009-11-08 00:00:00	2009-11-08	38000177		0	0	30		0	0	0	183307	0	310965	19078461		
26410	2173	40229134	1997-02-27	1997-02-27 00:00:00	1997-03-06	1997-03-06 00:00:00	1997-03-06	38000177		0	0	7		0	0	0	144871	0	1043400	40229134		
36458	3007	40162522	1979-07-21	1979-07-21 00:00:00	1979-07-21	1979-07-21 00:00:00	\N	38000177		0	0	0		0	0	0	200600	0	857005	40162522		
39974	3308	19006318	1948-11-14	1948-11-14 00:00:00	1948-11-28	1948-11-28 00:00:00	1948-11-28	38000177		0	0	14		0	0	0	219645	0	105078	19006318		
11093	924	19133905	1995-08-11	1995-08-11 00:00:00	1995-08-20	1995-08-20 00:00:00	1995-08-20	38000177		0	0	9		0	0	0	61548	0	834102	19133905		
11409	950	1118084	2010-02-28	2010-02-28 00:00:00	2010-02-28	2010-02-28 00:00:00	\N	38000177		0	0	0		0	0	0	63113	0	00025152531	44923712		
7937	171	40213160	1968-08-19	1968-08-19 00:00:00	1968-08-19	1968-08-19 00:00:00	1968-08-19	581452		0	0	0		0	0	0	11628	0	10	40213160		
47120	3904	1127433	2006-01-01	2006-01-01 00:00:00	2006-01-22	2006-01-22 00:00:00	2006-01-22	38000177		0	0	21		0	0	0	259644	0	313782	1127433		
23512	510	40213160	1970-09-12	1970-09-12 00:00:00	1970-09-12	1970-09-12 00:00:00	1970-09-12	581452		0	0	0		0	0	0	34121	0	10	40213160		
5733	480	19059056	1937-10-16	1937-10-16 00:00:00	1937-10-30	1937-10-30 00:00:00	1937-10-30	38000177		0	0	14		0	0	0	32034	0	243670	19059056		
120347	2646	40213227	1996-09-13	1996-09-13 00:00:00	1996-09-13	1996-09-13 00:00:00	1996-09-13	581452		0	0	0		0	0	0	175062	0	113	40213227		
105985	2325	40213227	2002-10-03	2002-10-03 00:00:00	2002-10-03	2002-10-03 00:00:00	2002-10-03	581452		0	0	0		0	0	0	154630	0	113	40213227		
13419	1124	1127433	1975-07-25	1975-07-25 00:00:00	1975-08-01	1975-08-01 00:00:00	1975-08-01	38000177		0	0	7		0	0	0	74076	0	313782	1127433		
20163	439	40213314	1978-12-07	1978-12-07 00:00:00	1978-12-07	1978-12-07 00:00:00	1978-12-07	581452		0	0	0		0	0	0	29123	0	49	40213314		
25579	558	40213160	1961-04-13	1961-04-13 00:00:00	1961-04-13	1961-04-13 00:00:00	1961-04-13	581452		0	0	0		0	0	0	37035	0	10	40213160		
3199	263	19059056	1957-06-04	1957-06-04 00:00:00	1957-06-18	1957-06-18 00:00:00	1957-06-18	38000177		0	0	14		0	0	0	17480	0	243670	19059056		
3241	266	46233988	1967-06-26	1967-06-26 00:00:00	1967-07-10	1967-07-10 00:00:00	1967-07-10	38000177		0	0	14		0	0	0	17684	0	1652673	46233988		
4412	366	1127433	1965-07-10	1965-07-10 00:00:00	1965-07-17	1965-07-17 00:00:00	1965-07-17	38000177		0	0	7		0	0	0	24274	0	313782	1127433		
127968	2815	40213160	1963-05-24	1963-05-24 00:00:00	1963-05-24	1963-05-24 00:00:00	1963-05-24	581452		0	0	0		0	0	0	186544	0	10	40213160		
11611	967	19078461	2002-02-15	2002-02-15 00:00:00	2002-04-16	2002-04-16 00:00:00	2002-04-16	38000177		0	0	60		0	0	0	64317	0	310965	19078461		
22087	1814	1367571	2018-04-03	2018-04-03 00:00:00	2018-04-03	2018-04-03 00:00:00	2018-04-03	38000177		0	0	0		0	0	0	121406	0	314659	19080464		
30950	2563	19059056	1972-04-11	1972-04-11 00:00:00	1972-05-18	1972-05-18 00:00:00	1972-05-18	38000177		0	0	37		0	0	0	169790	0	243670	19059056		
254	18	40236824	1997-12-26	1997-12-26 00:00:00	1998-01-09	1998-01-09 00:00:00	1998-01-09	38000177		0	0	14		0	0	0	1395	0	1094107	40236824		
55	3	1127433	1969-03-17	1969-03-17 00:00:00	1969-03-24	1969-03-24 00:00:00	1969-03-24	38000177		0	0	7		0	0	0	220	0	313782	1127433		
17825	1476	40173590	2004-12-02	2004-12-02 00:00:00	2004-12-02	2004-12-02 00:00:00	\N	38000177		0	0	0		0	0	0	98458	0	904419	40173590		
10809	902	1713671	1999-11-04	1999-11-04 00:00:00	1999-11-11	1999-11-11 00:00:00	1999-11-11	38000177		0	0	7		0	0	0	60037	0	562251	1713671		
25709	2115	40229134	2016-09-21	2016-09-21 00:00:00	2016-10-05	2016-10-05 00:00:00	2016-10-05	38000177		0	0	14		0	0	0	140711	0	1043400	40229134		
36235	2986	1127433	1958-08-29	1958-08-29 00:00:00	1958-09-12	1958-09-12 00:00:00	1958-09-12	38000177		0	0	14		0	0	0	199284	0	313782	1127433		
48476	4017	40163554	1998-04-09	1998-04-09 00:00:00	1998-04-09	1998-04-09 00:00:00	\N	38000177		0	0	0		0	0	0	267002	0	855332	40163554		
59704	4964	1118084	2000-05-23	2000-05-23 00:00:00	2000-05-23	2000-05-23 00:00:00	\N	38000177		0	0	0		0	0	0	330024	0	00025152531	44923712		
18405	1523	40229134	1959-06-25	1959-06-25 00:00:00	1959-07-09	1959-07-09 00:00:00	1959-07-09	38000177		0	0	14		0	0	0	101882	0	1043400	40229134		
40699	3375	1127433	2007-02-24	2007-02-24 00:00:00	2007-03-03	2007-03-03 00:00:00	2007-03-03	38000177		0	0	7		0	0	0	223855	0	313782	1127433		
27092	2235	19133905	2000-10-19	2000-10-19 00:00:00	2000-10-26	2000-10-26 00:00:00	2000-10-26	38000177		0	0	7		0	0	0	148691	0	834102	19133905		
19728	1623	1539411	2017-07-14	2017-07-14 00:00:00	2017-07-14	2017-07-14 00:00:00	\N	38000177		0	0	0		0	0	0	109072	0	312961	1539411		
165299	3634	40213296	2012-04-23	2012-04-23 00:00:00	2012-04-23	2012-04-23 00:00:00	2012-04-23	581452		0	0	0		0	0	0	241742	0	52	40213296		
56373	4677	1118084	1996-09-19	1996-09-19 00:00:00	1996-09-19	1996-09-19 00:00:00	\N	38000177		0	0	0		0	0	0	311707	0	00025152531	44923712		
37717	3118	1127078	1953-12-01	1953-12-01 00:00:00	1953-12-15	1953-12-15 00:00:00	1953-12-15	38000177		0	0	14		0	0	0	207533	0	282464	1127078		
41198	3417	1127433	2014-06-17	2014-06-17 00:00:00	2014-07-17	2014-07-17 00:00:00	2014-07-17	38000177		0	0	30		0	0	0	226626	0	313782	1127433		
1917	153	19133873	1948-05-09	1948-05-09 00:00:00	1948-05-19	1948-05-19 00:00:00	1948-05-19	38000177		0	0	10		0	0	0	10346	0	834061	19133873		
41253	3420	19128065	1984-08-25	1984-08-25 00:00:00	1985-08-20	1985-08-20 00:00:00	1985-08-20	38000177		0	0	360		0	0	0	226876	0	749882	19128065		
53371	4436	1127433	1980-05-23	1980-05-23 00:00:00	1980-06-22	1980-06-22 00:00:00	1980-06-22	38000177		0	0	30		0	0	0	294879	0	313782	1127433		
63219	5252	1115171	2015-11-04	2015-11-04 00:00:00	2015-11-25	2015-11-25 00:00:00	2015-11-25	38000177		0	0	21		0	0	0	349400	0	849574	1115171		
20858	1719	1127433	2007-01-07	2007-01-07 00:00:00	2007-01-21	2007-01-21 00:00:00	2007-01-21	38000177		0	0	14		0	0	0	114998	0	313782	1127433		
56199	4665	19128065	1997-08-01	1997-08-01 00:00:00	1998-07-27	1998-07-27 00:00:00	1998-07-27	38000177		0	0	360		0	0	0	310911	0	749882	19128065		
4925	410	1127433	1999-10-03	1999-10-03 00:00:00	1999-10-17	1999-10-17 00:00:00	1999-10-17	38000177		0	0	14		0	0	0	27194	0	313782	1127433		
8400	701	1127433	1970-12-22	1970-12-22 00:00:00	1970-12-29	1970-12-29 00:00:00	1970-12-29	38000177		0	0	7		0	0	0	46345	0	313782	1127433		
11673	971	920334	2005-06-28	2005-06-28 00:00:00	2005-07-05	2005-07-05 00:00:00	2005-07-05	38000177		0	0	7		0	0	0	64606	0	311995	920334		
3875	321	1118084	2003-06-20	2003-06-20 00:00:00	2003-06-20	2003-06-20 00:00:00	\N	38000177		0	0	0		0	0	0	21268	0	00025152531	44923712		
47160	3909	19059056	1967-02-02	1967-02-02 00:00:00	1967-02-16	1967-02-16 00:00:00	1967-02-16	38000177		0	0	14		0	0	0	259856	0	243670	19059056		
111417	2448	40213260	2015-07-22	2015-07-22 00:00:00	2015-07-22	2015-07-22 00:00:00	2015-07-22	581452		0	0	0		0	0	0	162376	0	121	40213260		
30719	670	40213314	1977-10-08	1977-10-08 00:00:00	1977-10-08	1977-10-08 00:00:00	1977-10-08	581452		0	0	0		0	0	0	44232	0	49	40213314		
14537	1217	40220960	2018-10-19	2018-10-19 00:00:00	2018-10-19	2018-10-19 00:00:00	2018-10-19	38000177		0	0	0		0	0	0	80147	0	1804799	40220960		
1429	114	1127433	1999-11-18	1999-11-18 00:00:00	1999-12-02	1999-12-02 00:00:00	1999-12-02	38000177		0	0	14		0	0	0	7517	0	313782	1127433		
12287	1032	19059056	1969-08-10	1969-08-10 00:00:00	1969-11-08	1969-11-08 00:00:00	1969-11-08	38000177		0	0	90		0	0	0	67949	0	243670	19059056		
41419	3434	1127078	1950-05-12	1950-05-12 00:00:00	1950-05-26	1950-05-26 00:00:00	1950-05-26	38000177		0	0	14		0	0	0	227698	0	282464	1127078		
45906	3799	19133873	1983-09-01	1983-09-01 00:00:00	1983-09-08	1983-09-08 00:00:00	1983-09-08	38000177		0	0	7		0	0	0	252572	0	834061	19133873		
63329	5259	19133905	1994-09-03	1994-09-03 00:00:00	1994-09-15	1994-09-15 00:00:00	1994-09-15	38000177		0	0	12		0	0	0	349996	0	834102	19133905		
22592	1854	920300	2009-02-03	2009-02-03 00:00:00	2009-02-10	2009-02-10 00:00:00	2009-02-10	38000177		0	0	7		0	0	0	124125	0	311989	920300		
43597	3614	19006318	1952-11-07	1952-11-07 00:00:00	1952-11-21	1952-11-21 00:00:00	1952-11-21	38000177		0	0	14		0	0	0	240117	0	105078	19006318		
50856	4225	19073183	1983-04-28	1983-04-28 00:00:00	1983-05-12	1983-05-12 00:00:00	1983-05-12	38000177		0	0	14		0	0	0	280617	0	308182	19073183		
15241	1273	1127433	1974-04-20	1974-04-20 00:00:00	1974-05-18	1974-05-18 00:00:00	1974-05-18	38000177		0	0	28		0	0	0	84070	0	313782	1127433		
60565	5037	1713671	2007-03-15	2007-03-15 00:00:00	2007-04-05	2007-04-05 00:00:00	2007-04-05	38000177		0	0	21		0	0	0	334712	0	562251	1713671		
29280	2424	19059056	1979-08-14	1979-08-14 00:00:00	1979-11-12	1979-11-12 00:00:00	1979-11-12	38000177		0	0	90		0	0	0	160818	0	243670	19059056		
33679	2786	19059056	1966-03-16	1966-03-16 00:00:00	1966-03-30	1966-03-30 00:00:00	1966-03-30	38000177		0	0	14		0	0	0	184611	0	243670	19059056		
33448	2770	1115171	2004-11-04	2004-11-04 00:00:00	2004-12-04	2004-12-04 00:00:00	2004-12-04	38000177		0	0	30		0	0	0	183305	0	849574	1115171		
26411	2173	19133873	1934-05-29	1934-05-29 00:00:00	1934-06-09	1934-06-09 00:00:00	1934-06-09	38000177		0	0	11		0	0	0	144863	0	834061	19133873		
36459	3007	19078461	1989-11-25	1989-11-25 00:00:00	1989-12-16	1989-12-16 00:00:00	1989-12-16	38000177		0	0	21		0	0	0	200601	0	310965	19078461		
39975	3308	1127433	1979-11-17	1979-11-17 00:00:00	1979-11-24	1979-11-24 00:00:00	1979-11-24	38000177		0	0	7		0	0	0	219643	0	313782	1127433		
11094	924	1115171	2008-03-15	2008-03-15 00:00:00	2008-03-29	2008-03-29 00:00:00	2008-03-29	38000177		0	0	14		0	0	0	61542	0	849574	1115171		
11410	950	1713671	2013-09-19	2013-09-19 00:00:00	2013-10-10	2013-10-10 00:00:00	2013-10-10	38000177		0	0	21		0	0	0	63088	0	562251	1713671		
7939	171	40213227	2000-06-12	2000-06-12 00:00:00	2000-06-12	2000-06-12 00:00:00	2000-06-12	581452		0	0	0		0	0	0	11634	0	113	40213227		
47121	3904	19133873	1986-04-17	1986-04-17 00:00:00	1986-04-27	1986-04-27 00:00:00	1986-04-27	38000177		0	0	10		0	0	0	259592	0	834061	19133873		
23517	510	40213160	1966-01-08	1966-01-08 00:00:00	1966-01-08	1966-01-08 00:00:00	1966-01-08	581452		0	0	0		0	0	0	34125	0	10	40213160		
5734	480	19059056	1943-10-15	1943-10-15 00:00:00	1943-11-05	1943-11-05 00:00:00	1943-11-05	38000177		0	0	21		0	0	0	31964	0	243670	19059056		
120348	2646	40213306	1996-09-13	1996-09-13 00:00:00	1996-09-13	1996-09-13 00:00:00	1996-09-13	581452		0	0	0		0	0	0	175062	0	43	40213306		
105990	2325	40213227	1993-08-26	1993-08-26 00:00:00	1993-08-26	1993-08-26 00:00:00	1993-08-26	581452		0	0	0		0	0	0	154581	0	113	40213227		
13420	1124	19075601	1999-08-29	1999-08-29 00:00:00	1999-08-29	1999-08-29 00:00:00	1999-08-29	38000177		0	0	0		0	0	0	74069	0	309362	19075601		
20164	439	40213314	1978-01-05	1978-01-05 00:00:00	1978-01-05	1978-01-05 00:00:00	1978-01-05	581452		0	0	0		0	0	0	29109	0	49	40213314		
25588	558	40213296	2000-11-09	2000-11-09 00:00:00	2000-11-09	2000-11-09 00:00:00	2000-11-09	581452		0	0	0		0	0	0	37039	0	52	40213296		
3200	263	1713671	2002-01-21	2002-01-21 00:00:00	2002-02-11	2002-02-11 00:00:00	2002-02-11	38000177		0	0	21		0	0	0	17447	0	562251	1713671		
3242	266	1713671	2003-07-31	2003-07-31 00:00:00	2003-08-21	2003-08-21 00:00:00	2003-08-21	38000177		0	0	21		0	0	0	17683	0	562251	1713671		
4413	366	1127433	1999-07-03	1999-07-03 00:00:00	1999-07-10	1999-07-10 00:00:00	1999-07-10	38000177		0	0	7		0	0	0	24297	0	313782	1127433		
127971	2815	40213160	1963-02-22	1963-02-22 00:00:00	1963-02-22	1963-02-22 00:00:00	1963-02-22	581452		0	0	0		0	0	0	186558	0	10	40213160		
11612	967	1127433	1939-01-14	1939-01-14 00:00:00	1939-01-28	1939-01-28 00:00:00	1939-01-28	38000177		0	0	14		0	0	0	64349	0	313782	1127433		
22088	1814	1154029	2018-04-03	2018-04-03 00:00:00	2018-04-03	2018-04-03 00:00:00	2018-04-03	38000177		0	0	0		0	0	0	121406	0	4337	1154029		
30951	2564	19128022	1992-08-07	1992-08-07 00:00:00	1993-08-02	1993-08-02 00:00:00	1993-08-02	38000177		0	0	360		0	0	0	169838	0	749785	19128022		
255	18	1115171	1998-10-07	1998-10-07 00:00:00	1999-01-05	1999-01-05 00:00:00	1999-01-05	38000177		0	0	90		0	0	0	1379	0	849574	1115171		
56	3	1127433	1956-12-15	1956-12-15 00:00:00	1956-12-22	1956-12-22 00:00:00	1956-12-22	38000177		0	0	7		0	0	0	262	0	313782	1127433		
17826	1476	19059056	1955-02-19	1955-02-19 00:00:00	1955-03-12	1955-03-12 00:00:00	1955-03-12	38000177		0	0	21		0	0	0	98491	0	243670	19059056		
10810	902	19133905	2006-04-11	2006-04-11 00:00:00	2006-04-19	2006-04-19 00:00:00	2006-04-19	38000177		0	0	8		0	0	0	59986	0	834102	19133905		
25710	2115	19129655	1975-09-12	1975-09-12 00:00:00	1975-09-26	1975-09-26 00:00:00	1975-09-26	38000177		0	0	14		0	0	0	140761	0	789980	19129655		
36237	2986	1713671	1971-09-10	1971-09-10 00:00:00	1971-10-01	1971-10-01 00:00:00	1971-10-01	38000177		0	0	21		0	0	0	199329	0	562251	1713671		
59617	4957	19128065	1985-09-28	1985-09-28 00:00:00	1986-09-23	1986-09-23 00:00:00	1986-09-23	38000177		0	0	360		0	0	0	329558	0	749882	19128065		
59705	4964	1127433	1973-11-23	1973-11-23 00:00:00	1973-12-07	1973-12-07 00:00:00	1973-12-07	38000177		0	0	14		0	0	0	329985	0	313782	1127433		
18406	1523	40229134	2014-08-14	2014-08-14 00:00:00	2014-08-28	2014-08-28 00:00:00	2014-08-28	38000177		0	0	14		0	0	0	101888	0	1043400	40229134		
40701	3375	19059056	1958-02-03	1958-02-03 00:00:00	1958-02-17	1958-02-17 00:00:00	1958-02-17	38000177		0	0	14		0	0	0	223856	0	243670	19059056		
27093	2235	19059056	1968-11-03	1968-11-03 00:00:00	1968-12-01	1968-12-01 00:00:00	1968-12-01	38000177		0	0	28		0	0	0	148637	0	243670	19059056		
19729	1623	19075601	2017-07-14	2017-07-14 00:00:00	2017-07-14	2017-07-14 00:00:00	\N	38000177		0	0	0		0	0	0	109072	0	309362	19075601		
165301	3634	40213227	2012-04-23	2012-04-23 00:00:00	2012-04-23	2012-04-23 00:00:00	2012-04-23	581452		0	0	0		0	0	0	241742	0	113	40213227		
56374	4677	19078461	1993-10-13	1993-10-13 00:00:00	1993-11-03	1993-11-03 00:00:00	1993-11-03	38000177		0	0	21		0	0	0	311723	0	310965	19078461		
37718	3118	19006318	1953-12-01	1953-12-01 00:00:00	1953-12-15	1953-12-15 00:00:00	1953-12-15	38000177		0	0	14		0	0	0	207533	0	105078	19006318		
41199	3417	1713671	1945-09-11	1945-09-11 00:00:00	1945-09-18	1945-09-18 00:00:00	1945-09-18	38000177		0	0	7		0	0	0	226617	0	562251	1713671		
1918	153	1713671	1985-11-15	1985-11-15 00:00:00	1985-12-06	1985-12-06 00:00:00	1985-12-06	38000177		0	0	21		0	0	0	10324	0	562251	1713671		
41254	3420	1127433	1982-12-15	1982-12-15 00:00:00	1983-01-12	1983-01-12 00:00:00	1983-01-12	38000177		0	0	28		0	0	0	226910	0	313782	1127433		
53372	4436	40243436	2003-06-13	2003-06-13 00:00:00	2003-06-13	2003-06-13 00:00:00	2003-06-13	38000177		0	0	0		0	0	0	294881	0	1190795	40243436		
63220	5253	1713671	1988-07-24	1988-07-24 00:00:00	1988-07-31	1988-07-31 00:00:00	1988-07-31	38000177		0	0	7		0	0	0	349541	0	562251	1713671		
20859	1719	19059056	1967-03-09	1967-03-09 00:00:00	1967-04-08	1967-04-08 00:00:00	1967-04-08	38000177		0	0	30		0	0	0	114916	0	243670	19059056		
56200	4665	19078461	2005-09-22	2005-09-22 00:00:00	2005-10-27	2005-10-27 00:00:00	2005-10-27	38000177		0	0	35		0	0	0	310865	0	310965	19078461		
4927	410	19133873	1957-07-24	1957-07-24 00:00:00	1957-08-03	1957-08-03 00:00:00	1957-08-03	38000177		0	0	10		0	0	0	27188	0	834061	19133873		
8401	701	19133873	1962-05-11	1962-05-11 00:00:00	1962-05-24	1962-05-24 00:00:00	1962-05-24	38000177		0	0	13		0	0	0	46318	0	834061	19133873		
11674	971	1127433	1979-07-02	1979-07-02 00:00:00	1979-07-09	1979-07-09 00:00:00	1979-07-09	38000177		0	0	7		0	0	0	64609	0	313782	1127433		
3876	321	19006318	1962-05-11	1962-05-11 00:00:00	1962-05-25	1962-05-25 00:00:00	1962-05-25	38000177		0	0	14		0	0	0	21278	0	105078	19006318		
47161	3909	46233988	1967-02-02	1967-02-02 00:00:00	1967-02-16	1967-02-16 00:00:00	1967-02-16	38000177		0	0	14		0	0	0	259856	0	1652673	46233988		
133951	2942	40213160	1955-01-05	1955-01-05 00:00:00	1955-01-05	1955-01-05 00:00:00	1955-01-05	581452		0	0	0		0	0	0	196195	0	10	40213160		
30723	670	40213227	2004-12-10	2004-12-10 00:00:00	2004-12-10	2004-12-10 00:00:00	2004-12-10	581452		0	0	0		0	0	0	44251	0	113	40213227		
14541	1219	40171902	2007-12-10	2007-12-10 00:00:00	2007-12-10	2007-12-10 00:00:00	\N	38000177		0	0	0		0	0	0	80264	0	897718	40171902		
1430	114	19133873	1975-10-07	1975-10-07 00:00:00	1975-10-18	1975-10-18 00:00:00	1975-10-18	38000177		0	0	11		0	0	0	7527	0	834061	19133873		
12288	1032	1115171	1994-02-08	1994-02-08 00:00:00	1994-03-01	1994-03-01 00:00:00	1994-03-01	38000177		0	0	21		0	0	0	67954	0	849574	1115171		
41420	3434	19059056	1951-06-06	1951-06-06 00:00:00	1951-08-12	1951-08-12 00:00:00	1951-08-12	38000177		0	0	67		0	0	0	227681	0	243670	19059056		
45907	3799	1127433	1981-11-19	1981-11-19 00:00:00	1981-11-26	1981-11-26 00:00:00	1981-11-26	38000177		0	0	7		0	0	0	252532	0	313782	1127433		
63330	5259	1127433	1987-09-05	1987-09-05 00:00:00	1987-09-12	1987-09-12 00:00:00	1987-09-12	38000177		0	0	7		0	0	0	349946	0	313782	1127433		
22593	1854	19128065	1989-10-04	1989-10-04 00:00:00	1990-09-29	1990-09-29 00:00:00	1990-09-29	38000177		0	0	360		0	0	0	124083	0	749882	19128065		
43598	3614	964261	2009-06-11	2009-06-11 00:00:00	2009-06-11	2009-06-11 00:00:00	\N	38000177		0	0	0		0	0	0	240143	0	2001499	964261		
50857	4225	19059056	1980-04-29	1980-04-29 00:00:00	1980-05-13	1980-05-13 00:00:00	1980-05-13	38000177		0	0	14		0	0	0	280623	0	243670	19059056		
15242	1273	19059056	1943-05-05	1943-05-05 00:00:00	1943-06-02	1943-06-02 00:00:00	1943-06-02	38000177		0	0	28		0	0	0	84069	0	243670	19059056		
60566	5037	19128022	1991-02-13	1991-02-13 00:00:00	1992-02-08	1992-02-08 00:00:00	1992-02-08	38000177		0	0	360		0	0	0	334719	0	749785	19128022		
29281	2424	40231925	1979-08-14	1979-08-14 00:00:00	1979-08-14	1979-08-14 00:00:00	\N	38000177		0	0	0		0	0	0	160818	0	1049221	40231925		
33680	2786	19059056	1935-06-24	1935-06-24 00:00:00	1935-07-08	1935-07-08 00:00:00	1935-07-08	38000177		0	0	14		0	0	0	184566	0	243670	19059056		
33449	2770	40162522	2004-11-04	2004-11-04 00:00:00	2004-11-04	2004-11-04 00:00:00	\N	38000177		0	0	0		0	0	0	183305	0	857005	40162522		
26412	2173	19133873	1938-07-21	1938-07-21 00:00:00	1938-08-01	1938-08-01 00:00:00	1938-08-01	38000177		0	0	11		0	0	0	144725	0	834061	19133873		
36460	3007	1713671	1998-01-21	1998-01-21 00:00:00	1998-01-28	1998-01-28 00:00:00	1998-01-28	38000177		0	0	7		0	0	0	200619	0	562251	1713671		
39976	3308	1127433	1977-08-02	1977-08-02 00:00:00	1977-08-16	1977-08-16 00:00:00	1977-08-16	38000177		0	0	14		0	0	0	219640	0	313782	1127433		
11095	924	1115171	1998-04-01	1998-04-01 00:00:00	1998-05-07	1998-05-07 00:00:00	1998-05-07	38000177		0	0	36		0	0	0	61541	0	849574	1115171		
11411	950	1127433	1983-04-16	1983-04-16 00:00:00	1983-06-15	1983-06-15 00:00:00	1983-06-15	38000177		0	0	60		0	0	0	63096	0	313782	1127433		
7943	171	40213260	2019-03-18	2019-03-18 00:00:00	2019-03-18	2019-03-18 00:00:00	2019-03-18	581452		0	0	0		0	0	0	11607	0	121	40213260		
47123	3906	1127433	1990-06-23	1990-06-23 00:00:00	1990-07-07	1990-07-07 00:00:00	1990-07-07	38000177		0	0	14		0	0	0	259731	0	313782	1127433		
23519	510	40213227	2016-10-08	2016-10-08 00:00:00	2016-10-08	2016-10-08 00:00:00	2016-10-08	581452		0	0	0		0	0	0	34107	0	113	40213227		
5735	480	19133905	1980-02-29	1980-02-29 00:00:00	1980-03-07	1980-03-07 00:00:00	1980-03-07	38000177		0	0	7		0	0	0	32070	0	834102	19133905		
120353	2646	40213296	2014-07-18	2014-07-18 00:00:00	2014-07-18	2014-07-18 00:00:00	2014-07-18	581452		0	0	0		0	0	0	175089	0	52	40213296		
105991	2325	40213306	1993-08-26	1993-08-26 00:00:00	1993-08-26	1993-08-26 00:00:00	1993-08-26	581452		0	0	0		0	0	0	154581	0	43	40213306		
13421	1124	40220960	1999-08-29	1999-08-29 00:00:00	1999-08-29	1999-08-29 00:00:00	1999-08-29	38000177		0	0	0		0	0	0	74069	0	1804799	40220960		
20165	439	40213160	1978-01-05	1978-01-05 00:00:00	1978-01-05	1978-01-05 00:00:00	1978-01-05	581452		0	0	0		0	0	0	29109	0	10	40213160		
25591	558	40213160	1965-10-14	1965-10-14 00:00:00	1965-10-14	1965-10-14 00:00:00	1965-10-14	581452		0	0	0		0	0	0	36955	0	10	40213160		
3201	264	1713671	1987-05-26	1987-05-26 00:00:00	1987-06-02	1987-06-02 00:00:00	1987-06-02	38000177		0	0	7		0	0	0	17552	0	562251	1713671		
3243	266	1124300	2006-10-04	2006-10-04 00:00:00	2006-10-04	2006-10-04 00:00:00	\N	38000177		0	0	0		0	0	0	17634	0	00781178901	45011828		
4414	366	40165015	1954-11-28	1954-11-28 00:00:00	1954-11-28	1954-11-28 00:00:00	\N	38000177		0	0	0		0	0	0	24416	0	861467	40165015		
127975	2815	40213227	2014-05-02	2014-05-02 00:00:00	2014-05-02	2014-05-02 00:00:00	2014-05-02	581452		0	0	0		0	0	0	186554	0	113	40213227		
11613	967	1127433	2019-02-07	2019-02-07 00:00:00	2019-02-28	2019-02-28 00:00:00	2019-02-28	38000177		0	0	21		0	0	0	64321	0	313782	1127433		
22089	1814	40220386	2018-04-03	2018-04-03 00:00:00	2018-04-03	2018-04-03 00:00:00	2018-04-03	38000177		0	0	0		0	0	0	121406	0	1808217	40220386		
30952	2564	19059056	1978-08-11	1978-08-11 00:00:00	1978-08-25	1978-08-25 00:00:00	1978-08-25	38000177		0	0	14		0	0	0	169846	0	243670	19059056		
256	18	920334	1998-01-02	1998-01-02 00:00:00	1998-01-09	1998-01-09 00:00:00	1998-01-09	38000177		0	0	7		0	0	0	1389	0	311995	920334		
57	3	40163554	2001-07-23	2001-07-23 00:00:00	2001-07-23	2001-07-23 00:00:00	\N	38000177		0	0	0		0	0	0	258	0	855332	40163554		
17827	1476	1713671	1949-08-23	1949-08-23 00:00:00	1949-09-27	1949-09-27 00:00:00	1949-09-27	38000177		0	0	35		0	0	0	98436	0	562251	1713671		
10811	902	19075001	1990-12-11	1990-12-11 00:00:00	1990-12-25	1990-12-25 00:00:00	1990-12-25	38000177		0	0	14		0	0	0	60038	0	309097	19075001		
25711	2115	1127433	1975-09-12	1975-09-12 00:00:00	1975-09-26	1975-09-26 00:00:00	1975-09-26	38000177		0	0	14		0	0	0	140761	0	313782	1127433		
36238	2986	1127433	2018-06-05	2018-06-05 00:00:00	2018-06-19	2018-06-19 00:00:00	2018-06-19	38000177		0	0	14		0	0	0	199336	0	313782	1127433		
59618	4957	1127433	1983-09-05	1983-09-05 00:00:00	1983-09-19	1983-09-19 00:00:00	1983-09-19	38000177		0	0	14		0	0	0	329554	0	313782	1127433		
59706	4964	19133873	1970-04-20	1970-04-20 00:00:00	1970-04-30	1970-04-30 00:00:00	1970-04-30	38000177		0	0	10		0	0	0	329988	0	834061	19133873		
18407	1523	19006318	1957-02-04	1957-02-04 00:00:00	1957-02-18	1957-02-18 00:00:00	1957-02-18	38000177		0	0	14		0	0	0	101837	0	105078	19006318		
40702	3375	19006318	1958-02-03	1958-02-03 00:00:00	1958-02-17	1958-02-17 00:00:00	1958-02-17	38000177		0	0	14		0	0	0	223856	0	105078	19006318		
27094	2235	40229134	2002-09-09	2002-09-09 00:00:00	2002-09-16	2002-09-16 00:00:00	2002-09-16	38000177		0	0	7		0	0	0	148678	0	1043400	40229134		
19730	1623	1332419	2017-07-14	2017-07-14 00:00:00	2017-07-14	2017-07-14 00:00:00	\N	38000177		0	0	0		0	0	0	109072	0	197361	1332419		
165305	3634	40213160	1975-02-03	1975-02-03 00:00:00	1975-02-03	1975-02-03 00:00:00	1975-02-03	581452		0	0	0		0	0	0	241719	0	10	40213160		
56375	4677	1713671	2008-08-11	2008-08-11 00:00:00	2008-08-18	2008-08-18 00:00:00	2008-08-18	38000177		0	0	7		0	0	0	311697	0	562251	1713671		
37719	3118	19133873	1950-03-03	1950-03-03 00:00:00	1950-03-16	1950-03-16 00:00:00	1950-03-16	38000177		0	0	13		0	0	0	207465	0	834061	19133873		
41200	3417	1124300	1948-12-28	1948-12-28 00:00:00	1948-12-28	1948-12-28 00:00:00	\N	38000177		0	0	0		0	0	0	226605	0	00781178901	45011828		
1919	153	19059056	1970-02-09	1970-02-09 00:00:00	1970-02-23	1970-02-23 00:00:00	1970-02-23	38000177		0	0	14		0	0	0	10318	0	243670	19059056		
41255	3420	19133873	1980-01-22	1980-01-22 00:00:00	1980-02-04	1980-02-04 00:00:00	1980-02-04	38000177		0	0	13		0	0	0	226866	0	834061	19133873		
53373	4436	46275916	2003-06-13	2003-06-13 00:00:00	2003-06-13	2003-06-13 00:00:00	2003-06-13	38000177		0	0	0		0	0	0	294881	0	1660014	46275916		
63221	5253	1127433	1991-03-13	1991-03-13 00:00:00	1991-03-20	1991-03-20 00:00:00	1991-03-20	38000177		0	0	7		0	0	0	349523	0	313782	1127433		
20860	1719	19059056	1958-02-03	1958-02-03 00:00:00	1958-02-17	1958-02-17 00:00:00	1958-02-17	38000177		0	0	14		0	0	0	114985	0	243670	19059056		
56201	4665	1118084	2015-11-30	2015-11-30 00:00:00	2015-11-30	2015-11-30 00:00:00	\N	38000177		0	0	0		0	0	0	310902	0	00025152531	44923712		
4929	410	19059056	1951-04-24	1951-04-24 00:00:00	1951-05-08	1951-05-08 00:00:00	1951-05-08	38000177		0	0	14		0	0	0	27221	0	243670	19059056		
8402	701	1115171	2008-06-04	2008-06-04 00:00:00	2008-07-09	2008-07-09 00:00:00	2008-07-09	38000177		0	0	35		0	0	0	46364	0	849574	1115171		
11675	971	40236824	2005-06-21	2005-06-21 00:00:00	2005-07-05	2005-07-05 00:00:00	2005-07-05	38000177		0	0	14		0	0	0	64594	0	1094107	40236824		
3877	321	19059056	1962-05-11	1962-05-11 00:00:00	1962-05-25	1962-05-25 00:00:00	1962-05-25	38000177		0	0	14		0	0	0	21278	0	243670	19059056		
47162	3909	1127433	2011-02-27	2011-02-27 00:00:00	2011-03-29	2011-03-29 00:00:00	2011-03-29	38000177		0	0	30		0	0	0	259843	0	313782	1127433		
133955	2942	40213227	2015-03-18	2015-03-18 00:00:00	2015-03-18	2015-03-18 00:00:00	2015-03-18	581452		0	0	0		0	0	0	196150	0	113	40213227		
30726	670	40213306	1995-12-22	1995-12-22 00:00:00	1995-12-22	1995-12-22 00:00:00	1995-12-22	581452		0	0	0		0	0	0	\N	0	43	40213306		
14542	1219	19018935	2007-12-10	2007-12-10 00:00:00	2007-12-10	2007-12-10 00:00:00	\N	38000177		0	0	0		0	0	0	80264	0	197604	19018935		
1431	114	19133873	1976-01-17	1976-01-17 00:00:00	1976-01-28	1976-01-28 00:00:00	1976-01-28	38000177		0	0	11		0	0	0	7530	0	834061	19133873		
12289	1032	1127433	2010-10-03	2010-10-03 00:00:00	2010-10-24	2010-10-24 00:00:00	2010-10-24	38000177		0	0	21		0	0	0	67956	0	313782	1127433		
41421	3435	1127433	2009-04-23	2009-04-23 00:00:00	2009-07-22	2009-07-22 00:00:00	2009-07-22	38000177		0	0	90		0	0	0	227834	0	313782	1127433		
45925	3803	19133873	1973-07-22	1973-07-22 00:00:00	1973-08-03	1973-08-03 00:00:00	1973-08-03	38000177		0	0	12		0	0	0	252805	0	834061	19133873		
63331	5259	19133905	2011-03-21	2011-03-21 00:00:00	2011-04-02	2011-04-02 00:00:00	2011-04-02	38000177		0	0	12		0	0	0	349969	0	834102	19133905		
22594	1854	920334	2005-12-13	2005-12-13 00:00:00	2005-12-20	2005-12-20 00:00:00	2005-12-20	38000177		0	0	7		0	0	0	124124	0	311995	920334		
43599	3614	40229134	1992-07-05	1992-07-05 00:00:00	1992-07-12	1992-07-12 00:00:00	1992-07-12	38000177		0	0	7		0	0	0	240137	0	1043400	40229134		
50858	4225	19073183	1980-04-29	1980-04-29 00:00:00	1980-05-13	1980-05-13 00:00:00	1980-05-13	38000177		0	0	14		0	0	0	280623	0	308182	19073183		
15243	1273	1118084	1976-08-19	1976-08-19 00:00:00	1976-08-19	1976-08-19 00:00:00	\N	38000177		0	0	0		0	0	0	83998	0	00025152531	44923712		
60567	5037	19128065	1995-01-23	1995-01-23 00:00:00	1996-01-18	1996-01-18 00:00:00	1996-01-18	38000177		0	0	360		0	0	0	334807	0	749882	19128065		
29282	2424	1124300	2004-04-19	2004-04-19 00:00:00	2004-04-19	2004-04-19 00:00:00	\N	38000177		0	0	0		0	0	0	160866	0	00781178901	45011828		
33681	2786	19077572	2002-10-12	2002-10-12 00:00:00	2002-10-12	2002-10-12 00:00:00	\N	38000177		0	0	0		0	0	0	184597	0	310436	19077572		
33450	2770	40229134	1973-06-10	1973-06-10 00:00:00	1973-06-17	1973-06-17 00:00:00	1973-06-17	38000177		0	0	7		0	0	0	183313	0	1043400	40229134		
26413	2173	1713671	1991-03-10	1991-03-10 00:00:00	1991-03-17	1991-03-17 00:00:00	1991-03-17	38000177		0	0	7		0	0	0	144737	0	562251	1713671		
39923	3304	19133905	1989-03-05	1989-03-05 00:00:00	1989-03-16	1989-03-16 00:00:00	1989-03-16	38000177		0	0	11		0	0	0	219427	0	834102	19133905		
39977	3308	1127078	1951-07-19	1951-07-19 00:00:00	1951-08-16	1951-08-16 00:00:00	1951-08-16	38000177		0	0	28		0	0	0	219653	0	282464	1127078		
11096	924	19074841	1998-04-01	1998-04-01 00:00:00	1998-05-07	1998-05-07 00:00:00	1998-05-07	38000177		0	0	36		0	0	0	61541	0	309043	19074841		
11412	950	19129655	1974-02-21	1974-02-21 00:00:00	1974-03-07	1974-03-07 00:00:00	1974-03-07	38000177		0	0	14		0	0	0	63118	0	789980	19129655		
7945	171	40213227	2019-03-18	2019-03-18 00:00:00	2019-03-18	2019-03-18 00:00:00	2019-03-18	581452		0	0	0		0	0	0	11607	0	113	40213227		
47124	3906	19059056	1947-01-28	1947-01-28 00:00:00	1947-02-11	1947-02-11 00:00:00	1947-02-11	38000177		0	0	14		0	0	0	259668	0	243670	19059056		
23520	510	40213260	2016-10-08	2016-10-08 00:00:00	2016-10-08	2016-10-08 00:00:00	2016-10-08	581452		0	0	0		0	0	0	34107	0	121	40213260		
5736	480	19126352	2016-10-05	2016-10-05 00:00:00	2016-10-05	2016-10-05 00:00:00	\N	38000177		0	0	0		0	0	0	32082	0	705129	19126352		
120355	2646	40213227	2008-03-07	2008-03-07 00:00:00	2008-03-07	2008-03-07 00:00:00	2008-03-07	581452		0	0	0		0	0	0	175079	0	113	40213227		
105999	2325	40213160	1975-05-29	1975-05-29 00:00:00	1975-05-29	1975-05-29 00:00:00	1975-05-29	581452		0	0	0		0	0	0	154572	0	10	40213160		
13422	1124	1127433	1951-09-20	1951-09-20 00:00:00	1951-10-04	1951-10-04 00:00:00	1951-10-04	38000177		0	0	14		0	0	0	74096	0	313782	1127433		
20166	439	40213160	1982-04-29	1982-04-29 00:00:00	1982-04-29	1982-04-29 00:00:00	1982-04-29	581452		0	0	0		0	0	0	29135	0	10	40213160		
25596	558	40213306	1982-11-04	1982-11-04 00:00:00	1982-11-04	1982-11-04 00:00:00	1982-11-04	581452		0	0	0		0	0	0	36962	0	43	40213306		
3202	264	19073188	1987-03-26	1987-03-26 00:00:00	1987-04-09	1987-04-09 00:00:00	1987-04-09	38000177		0	0	14		0	0	0	17574	0	308192	19073188		
3244	266	19078461	2018-09-26	2018-09-26 00:00:00	2018-11-25	2018-11-25 00:00:00	2018-11-25	38000177		0	0	60		0	0	0	17694	0	310965	19078461		
53789	4472	40229134	1960-09-16	1960-09-16 00:00:00	1960-09-30	1960-09-30 00:00:00	1960-09-30	38000177		0	0	14		0	0	0	297480	0	1043400	40229134		
127976	2815	40213260	2014-05-02	2014-05-02 00:00:00	2014-05-02	2014-05-02 00:00:00	2014-05-02	581452		0	0	0		0	0	0	186554	0	121	40213260		
11614	967	19126352	2011-07-16	2011-07-16 00:00:00	2011-07-16	2011-07-16 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	705129	19126352		
22090	1814	19059056	1949-09-30	1949-09-30 00:00:00	1949-11-29	1949-11-29 00:00:00	1949-11-29	38000177		0	0	60		0	0	0	121428	0	243670	19059056		
30953	2564	19059056	1979-07-07	1979-07-07 00:00:00	1979-07-21	1979-07-21 00:00:00	1979-07-21	38000177		0	0	14		0	0	0	169893	0	243670	19059056		
64191	5329	1713671	1967-05-13	1967-05-13 00:00:00	1967-05-20	1967-05-20 00:00:00	1967-05-20	38000177		0	0	7		0	0	0	354745	0	562251	1713671		
58	3	40171902	2001-07-23	2001-07-23 00:00:00	2001-07-23	2001-07-23 00:00:00	\N	38000177		0	0	0		0	0	0	258	0	897718	40171902		
17828	1476	19018935	2003-11-27	2003-11-27 00:00:00	2003-11-27	2003-11-27 00:00:00	\N	38000177		0	0	0		0	0	0	98473	0	197604	19018935		
10812	902	1118084	1991-09-05	1991-09-05 00:00:00	1991-09-05	1991-09-05 00:00:00	\N	38000177		0	0	0		0	0	0	60038	0	00025152531	44923712		
25713	2115	40229134	1972-10-20	1972-10-20 00:00:00	1972-11-03	1972-11-03 00:00:00	1972-11-03	38000177		0	0	14		0	0	0	140691	0	1043400	40229134		
36239	2986	1127433	1974-12-02	1974-12-02 00:00:00	1974-12-23	1974-12-23 00:00:00	1974-12-23	38000177		0	0	21		0	0	0	199354	0	313782	1127433		
59619	4957	19078461	2004-11-07	2004-11-07 00:00:00	2004-12-05	2004-12-05 00:00:00	2004-12-05	38000177		0	0	28		0	0	0	329511	0	310965	19078461		
59707	4964	19059056	1965-01-08	1965-01-08 00:00:00	1965-01-22	1965-01-22 00:00:00	1965-01-22	38000177		0	0	14		0	0	0	329969	0	243670	19059056		
18408	1523	19059056	1957-02-04	1957-02-04 00:00:00	1957-02-18	1957-02-18 00:00:00	1957-02-18	38000177		0	0	14		0	0	0	101837	0	243670	19059056		
45729	3786	19078461	2007-06-28	2007-06-28 00:00:00	2007-08-02	2007-08-02 00:00:00	2007-08-02	38000177		0	0	35		0	0	0	251665	0	310965	19078461		
27095	2235	19059056	1959-03-28	1959-03-28 00:00:00	1959-04-25	1959-04-25 00:00:00	1959-04-25	38000177		0	0	28		0	0	0	148700	0	243670	19059056		
19731	1623	40229134	1958-12-21	1958-12-21 00:00:00	1959-01-04	1959-01-04 00:00:00	1959-01-04	38000177		0	0	14		0	0	0	109083	0	1043400	40229134		
165310	3634	40213160	1970-06-01	1970-06-01 00:00:00	1970-06-01	1970-06-01 00:00:00	1970-06-01	581452		0	0	0		0	0	0	241708	0	10	40213160		
56376	4677	1127433	1983-10-15	1983-10-15 00:00:00	1983-11-05	1983-11-05 00:00:00	1983-11-05	38000177		0	0	21		0	0	0	311668	0	313782	1127433		
37720	3118	1713671	2004-06-22	2004-06-22 00:00:00	2004-07-13	2004-07-13 00:00:00	2004-07-13	38000177		0	0	21		0	0	0	207458	0	562251	1713671		
20714	450	40213260	2017-04-24	2017-04-24 00:00:00	2017-04-24	2017-04-24 00:00:00	2017-04-24	581452		0	0	0		0	0	0	30049	0	121	40213260		
1920	153	19133873	1951-07-07	1951-07-07 00:00:00	1951-07-15	1951-07-15 00:00:00	1951-07-15	38000177		0	0	8		0	0	0	10405	0	834061	19133873		
41256	3420	1127433	2005-10-20	2005-10-20 00:00:00	2005-10-27	2005-10-27 00:00:00	2005-10-27	38000177		0	0	7		0	0	0	226890	0	313782	1127433		
53374	4436	1310034	2003-06-13	2003-06-13 00:00:00	2003-06-13	2003-06-13 00:00:00	2003-06-13	38000177		0	0	0		0	0	0	294881	0	834357	1310034		
63222	5253	1713671	2009-12-17	2009-12-17 00:00:00	2009-12-31	2009-12-31 00:00:00	2009-12-31	38000177		0	0	14		0	0	0	349527	0	562251	1713671		
20861	1719	19006318	1958-02-03	1958-02-03 00:00:00	1958-02-17	1958-02-17 00:00:00	1958-02-17	38000177		0	0	14		0	0	0	114985	0	105078	19006318		
56202	4665	19133873	1988-09-07	1988-09-07 00:00:00	1988-09-16	1988-09-16 00:00:00	1988-09-16	38000177		0	0	9		0	0	0	310874	0	834061	19133873		
4930	410	19006318	1951-04-24	1951-04-24 00:00:00	1951-05-08	1951-05-08 00:00:00	1951-05-08	38000177		0	0	14		0	0	0	27221	0	105078	19006318		
8411	703	1127433	1995-12-24	1995-12-24 00:00:00	1996-01-07	1996-01-07 00:00:00	1996-01-07	38000177		0	0	14		0	0	0	46458	0	313782	1127433		
11676	971	920300	2005-06-21	2005-06-21 00:00:00	2005-06-28	2005-06-28 00:00:00	2005-06-28	38000177		0	0	7		0	0	0	64594	0	311989	920300		
3878	321	1127433	1983-11-22	1983-11-22 00:00:00	1983-12-06	1983-12-06 00:00:00	1983-12-06	38000177		0	0	14		0	0	0	21321	0	313782	1127433		
47163	3909	40165015	2011-02-27	2011-02-27 00:00:00	2011-02-27	2011-02-27 00:00:00	\N	38000177		0	0	0		0	0	0	259843	0	861467	40165015		
133959	2942	40213160	1958-07-09	1958-07-09 00:00:00	1958-07-09	1958-07-09 00:00:00	1958-07-09	581452		0	0	0		0	0	0	196134	0	10	40213160		
30729	670	40213160	1974-07-13	1974-07-13 00:00:00	1974-07-13	1974-07-13 00:00:00	1974-07-13	581452		0	0	0		0	0	0	44230	0	10	40213160		
14543	1219	40163554	2007-12-10	2007-12-10 00:00:00	2007-12-10	2007-12-10 00:00:00	\N	38000177		0	0	0		0	0	0	80264	0	855332	40163554		
1432	114	19128022	1990-02-17	1990-02-17 00:00:00	1991-02-12	1991-02-12 00:00:00	1991-02-12	38000177		0	0	360		0	0	0	7554	0	749785	19128022		
12290	1032	1127433	1979-03-21	1979-03-21 00:00:00	1979-04-11	1979-04-11 00:00:00	1979-04-11	38000177		0	0	21		0	0	0	67950	0	313782	1127433		
41422	3435	1713671	1979-06-10	1979-06-10 00:00:00	1979-06-24	1979-06-24 00:00:00	1979-06-24	38000177		0	0	14		0	0	0	227809	0	562251	1713671		
45926	3803	19059056	1962-04-20	1962-04-20 00:00:00	1962-05-04	1962-05-04 00:00:00	1962-05-04	38000177		0	0	14		0	0	0	252759	0	243670	19059056		
63332	5259	19059056	1972-10-13	1972-10-13 00:00:00	1972-11-03	1972-11-03 00:00:00	1972-11-03	38000177		0	0	21		0	0	0	350002	0	243670	19059056		
22595	1854	1127433	1992-08-17	1992-08-17 00:00:00	1992-08-24	1992-08-24 00:00:00	1992-08-24	38000177		0	0	7		0	0	0	124080	0	313782	1127433		
43600	3614	1127433	1990-10-06	1990-10-06 00:00:00	1990-10-13	1990-10-13 00:00:00	1990-10-13	38000177		0	0	7		0	0	0	240105	0	313782	1127433		
50859	4225	1713671	2002-10-29	2002-10-29 00:00:00	2002-11-05	2002-11-05 00:00:00	2002-11-05	38000177		0	0	7		0	0	0	280629	0	562251	1713671		
15244	1273	1127433	1947-11-29	1947-11-29 00:00:00	1947-12-13	1947-12-13 00:00:00	1947-12-13	38000177		0	0	14		0	0	0	83976	0	313782	1127433		
60568	5037	19128022	1996-01-18	1996-01-18 00:00:00	1997-01-12	1997-01-12 00:00:00	1997-01-12	38000177		0	0	360		0	0	0	334742	0	749785	19128022		
29283	2424	19133873	1971-04-02	1971-04-02 00:00:00	1971-04-09	1971-04-09 00:00:00	1971-04-09	38000177		0	0	7		0	0	0	160802	0	834061	19133873		
33682	2786	19078461	2014-12-25	2014-12-25 00:00:00	2015-01-15	2015-01-15 00:00:00	2015-01-15	38000177		0	0	21		0	0	0	184617	0	310965	19078461		
33451	2770	19078461	2001-10-23	2001-10-23 00:00:00	2001-11-20	2001-11-20 00:00:00	2001-11-20	38000177		0	0	28		0	0	0	183304	0	310965	19078461		
26414	2173	19133905	1998-09-09	1998-09-09 00:00:00	1998-09-20	1998-09-20 00:00:00	1998-09-20	38000177		0	0	11		0	0	0	144872	0	834102	19133905		
39924	3304	1127433	1975-06-26	1975-06-26 00:00:00	1975-07-26	1975-07-26 00:00:00	1975-07-26	38000177		0	0	30		0	0	0	219484	0	313782	1127433		
39978	3308	19059056	1949-09-14	1949-09-14 00:00:00	1949-09-28	1949-09-28 00:00:00	1949-09-28	38000177		0	0	14		0	0	0	219673	0	243670	19059056		
11097	924	1118084	2004-10-07	2004-10-07 00:00:00	2004-10-07	2004-10-07 00:00:00	\N	38000177		0	0	0		0	0	0	61566	0	00025152531	44923712		
11413	950	1127078	1974-02-21	1974-02-21 00:00:00	1974-03-07	1974-03-07 00:00:00	1974-03-07	38000177		0	0	14		0	0	0	63118	0	282464	1127078		
54545	4531	1127433	2009-12-24	2009-12-24 00:00:00	2009-12-31	2009-12-31 00:00:00	2009-12-31	38000177		0	0	7		0	0	0	301754	0	313782	1127433		
47125	3906	19006318	1947-01-28	1947-01-28 00:00:00	1947-02-11	1947-02-11 00:00:00	1947-02-11	38000177		0	0	14		0	0	0	259668	0	105078	19006318		
94714	2078	40213160	1983-02-16	1983-02-16 00:00:00	1983-02-16	1983-02-16 00:00:00	1983-02-16	581452		0	0	0		0	0	0	138395	0	10	40213160		
5737	480	1332419	2016-10-05	2016-10-05 00:00:00	2016-10-05	2016-10-05 00:00:00	\N	38000177		0	0	0		0	0	0	32082	0	197361	1332419		
120359	2646	40213160	1979-06-22	1979-06-22 00:00:00	1979-06-22	1979-06-22 00:00:00	1979-06-22	581452		0	0	0		0	0	0	175058	0	10	40213160		
106001	2325	40213160	1971-02-04	1971-02-04 00:00:00	1971-02-04	1971-02-04 00:00:00	1971-02-04	581452		0	0	0		0	0	0	154623	0	10	40213160		
13423	1124	1124300	1968-10-12	1968-10-12 00:00:00	1968-10-12	1968-10-12 00:00:00	\N	38000177		0	0	0		0	0	0	74045	0	00781178901	45011828		
33438	729	40213160	1961-12-09	1961-12-09 00:00:00	1961-12-09	1961-12-09 00:00:00	1961-12-09	581452		0	0	0		0	0	0	48430	0	10	40213160		
42910	3558	1118084	1994-12-09	1994-12-09 00:00:00	1994-12-09	1994-12-09 00:00:00	\N	38000177		0	0	0		0	0	0	236228	0	00025152531	44923712		
3203	264	19078461	1987-03-26	1987-03-26 00:00:00	1987-04-09	1987-04-09 00:00:00	1987-04-09	38000177		0	0	14		0	0	0	17574	0	310965	19078461		
3245	266	40162522	2018-09-26	2018-09-26 00:00:00	2018-09-26	2018-09-26 00:00:00	\N	38000177		0	0	0		0	0	0	17694	0	857005	40162522		
53790	4472	1713671	1956-08-28	1956-08-28 00:00:00	1956-11-13	1956-11-13 00:00:00	1956-11-13	38000177		0	0	77		0	0	0	297533	0	562251	1713671		
127980	2815	40213227	2004-04-02	2004-04-02 00:00:00	2004-04-02	2004-04-02 00:00:00	2004-04-02	581452		0	0	0		0	0	0	186502	0	113	40213227		
11615	967	1332419	2011-07-16	2011-07-16 00:00:00	2011-07-16	2011-07-16 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	197361	1332419		
22091	1814	19006318	1945-07-29	1945-07-29 00:00:00	1945-08-12	1945-08-12 00:00:00	1945-08-12	38000177		0	0	14		0	0	0	121446	0	105078	19006318		
30954	2564	19073183	1979-07-07	1979-07-07 00:00:00	1979-07-21	1979-07-21 00:00:00	1979-07-21	38000177		0	0	14		0	0	0	169893	0	308182	19073183		
64192	5329	1124300	1980-09-04	1980-09-04 00:00:00	1980-09-04	1980-09-04 00:00:00	\N	38000177		0	0	0		0	0	0	354821	0	00781178901	45011828		
59	3	19018935	2001-07-23	2001-07-23 00:00:00	2001-07-23	2001-07-23 00:00:00	\N	38000177		0	0	0		0	0	0	258	0	197604	19018935		
17829	1476	40163554	2003-11-27	2003-11-27 00:00:00	2003-11-27	2003-11-27 00:00:00	\N	38000177		0	0	0		0	0	0	98473	0	855332	40163554		
10813	902	40229134	1970-05-23	1970-05-23 00:00:00	1970-06-06	1970-06-06 00:00:00	1970-06-06	38000177		0	0	14		0	0	0	60004	0	1043400	40229134		
25714	2115	1118084	2004-06-01	2004-06-01 00:00:00	2004-06-01	2004-06-01 00:00:00	\N	38000177		0	0	0		0	0	0	140719	0	00025152531	44923712		
36240	2986	40169281	1990-10-30	1990-10-30 00:00:00	1990-10-30	1990-10-30 00:00:00	\N	38000177		0	0	0		0	0	0	199301	0	896209	40169281		
59620	4957	19128065	1986-09-23	1986-09-23 00:00:00	1987-09-18	1987-09-18 00:00:00	1987-09-18	38000177		0	0	360		0	0	0	329559	0	749882	19128065		
27451	2272	1127433	1994-09-14	1994-09-14 00:00:00	1994-09-21	1994-09-21 00:00:00	1994-09-21	38000177		0	0	7		0	0	0	151022	0	313782	1127433		
18409	1523	1713671	1971-05-30	1971-05-30 00:00:00	1971-06-06	1971-06-06 00:00:00	1971-06-06	38000177		0	0	7		0	0	0	101823	0	562251	1713671		
45730	3786	19133873	1961-10-27	1961-10-27 00:00:00	1961-11-06	1961-11-06 00:00:00	1961-11-06	38000177		0	0	10		0	0	0	251667	0	834061	19133873		
27096	2235	1713671	1968-06-11	1968-06-11 00:00:00	1968-07-02	1968-07-02 00:00:00	1968-07-02	38000177		0	0	21		0	0	0	148634	0	562251	1713671		
19732	1623	19059056	1952-08-23	1952-08-23 00:00:00	1952-09-20	1952-09-20 00:00:00	1952-09-20	38000177		0	0	28		0	0	0	109136	0	243670	19059056		
165314	3634	40213160	1970-11-02	1970-11-02 00:00:00	1970-11-02	1970-11-02 00:00:00	1970-11-02	581452		0	0	0		0	0	0	241699	0	10	40213160		
56377	4677	19059056	1973-07-20	1973-07-20 00:00:00	1973-08-03	1973-08-03 00:00:00	1973-08-03	38000177		0	0	14		0	0	0	311666	0	243670	19059056		
37721	3118	19059056	1972-08-22	1972-08-22 00:00:00	1972-09-28	1972-09-28 00:00:00	1972-09-28	38000177		0	0	37		0	0	0	207534	0	243670	19059056		
20717	450	40213160	1967-09-18	1967-09-18 00:00:00	1967-09-18	1967-09-18 00:00:00	1967-09-18	581452		0	0	0		0	0	0	30000	0	10	40213160		
1921	153	19059056	1972-10-10	1972-10-10 00:00:00	1972-10-24	1972-10-24 00:00:00	1972-10-24	38000177		0	0	14		0	0	0	10319	0	243670	19059056		
41257	3420	1127078	1969-09-03	1969-09-03 00:00:00	1969-10-03	1969-10-03 00:00:00	1969-10-03	38000177		0	0	30		0	0	0	226881	0	282464	1127078		
166543	3661	40213160	1978-10-22	1978-10-22 00:00:00	1978-10-22	1978-10-22 00:00:00	1978-10-22	581452		0	0	0		0	0	0	243657	0	10	40213160		
63223	5253	1127433	1991-10-18	1991-10-18 00:00:00	1991-10-25	1991-10-25 00:00:00	1991-10-25	38000177		0	0	7		0	0	0	349524	0	313782	1127433		
20862	1719	19059056	1961-09-15	1961-09-15 00:00:00	1961-10-06	1961-10-06 00:00:00	1961-10-06	38000177		0	0	21		0	0	0	114915	0	243670	19059056		
56203	4665	1127433	1988-09-09	1988-09-09 00:00:00	1988-09-16	1988-09-16 00:00:00	1988-09-16	38000177		0	0	7		0	0	0	310900	0	313782	1127433		
4932	410	1127433	2004-08-30	2004-08-30 00:00:00	2004-09-13	2004-09-13 00:00:00	2004-09-13	38000177		0	0	14		0	0	0	27195	0	313782	1127433		
8412	703	1127433	1966-07-27	1966-07-27 00:00:00	1966-10-25	1966-10-25 00:00:00	1966-10-25	38000177		0	0	90		0	0	0	46508	0	313782	1127433		
11677	971	1713671	1970-11-28	1970-11-28 00:00:00	1970-12-12	1970-12-12 00:00:00	1970-12-12	38000177		0	0	14		0	0	0	64591	0	562251	1713671		
3879	321	1713671	1998-10-26	1998-10-26 00:00:00	1998-11-09	1998-11-09 00:00:00	1998-11-09	38000177		0	0	14		0	0	0	21309	0	562251	1713671		
47164	3909	1127078	1962-08-13	1962-08-13 00:00:00	1962-09-04	1962-09-04 00:00:00	1962-09-04	38000177		0	0	22		0	0	0	259841	0	282464	1127078		
133961	2942	40213160	1955-07-06	1955-07-06 00:00:00	1955-07-06	1955-07-06 00:00:00	1955-07-06	581452		0	0	0		0	0	0	196239	0	10	40213160		
30731	670	40213314	1977-04-08	1977-04-08 00:00:00	1977-04-08	1977-04-08 00:00:00	1977-04-08	581452		0	0	0		0	0	0	44214	0	49	40213314		
14544	1219	1127433	2013-10-08	2013-10-08 00:00:00	2013-10-15	2013-10-15 00:00:00	2013-10-15	38000177		0	0	7		0	0	0	80213	0	313782	1127433		
1433	114	1713671	2012-01-23	2012-01-23 00:00:00	2012-02-06	2012-02-06 00:00:00	2012-02-06	38000177		0	0	14		0	0	0	7506	0	562251	1713671		
12291	1032	1127433	2017-03-07	2017-03-07 00:00:00	2017-03-14	2017-03-14 00:00:00	2017-03-14	38000177		0	0	7		0	0	0	67934	0	313782	1127433		
41423	3435	1115171	2019-05-22	2019-05-22 00:00:00	2019-05-22	2019-05-22 00:00:00	\N	38000177		0	0	0		0	0	0	227831	0	849574	1115171		
45927	3803	19129655	1962-04-20	1962-04-20 00:00:00	1962-05-04	1962-05-04 00:00:00	1962-05-04	38000177		0	0	14		0	0	0	252759	0	789980	19129655		
63333	5259	1115171	2012-03-06	2012-03-06 00:00:00	2012-03-27	2012-03-27 00:00:00	2012-03-27	38000177		0	0	21		0	0	0	350006	0	849574	1115171		
22596	1854	40169216	1972-11-09	1972-11-09 00:00:00	1993-01-05	1993-01-05 00:00:00	1993-01-05	38000177		0	0	7362		0	0	0	124059	0	895994	40169216		
43601	3614	40222846	2006-04-16	2006-04-16 00:00:00	2006-04-16	2006-04-16 00:00:00	\N	38000177		0	0	0		0	0	0	240150	0	996740	40222846		
50860	4225	19133873	1991-08-01	1991-08-01 00:00:00	1991-08-10	1991-08-10 00:00:00	1991-08-10	38000177		0	0	9		0	0	0	280615	0	834061	19133873		
15245	1273	1127433	2004-09-03	2004-09-03 00:00:00	2004-09-10	2004-09-10 00:00:00	2004-09-10	38000177		0	0	7		0	0	0	83977	0	313782	1127433		
60569	5037	40224805	2001-12-17	2001-12-17 00:00:00	2002-12-12	2002-12-12 00:00:00	2002-12-12	38000177		0	0	360		0	0	0	334763	0	1000126	40224805		
29284	2424	40229134	1975-12-05	1975-12-05 00:00:00	1975-12-12	1975-12-12 00:00:00	1975-12-12	38000177		0	0	7		0	0	0	160837	0	1043400	40229134		
29323	2427	1127433	2004-02-15	2004-02-15 00:00:00	2004-02-29	2004-02-29 00:00:00	2004-02-29	38000177		0	0	14		0	0	0	161010	0	313782	1127433		
33452	2770	40229134	1996-04-07	1996-04-07 00:00:00	1996-04-14	1996-04-14 00:00:00	1996-04-14	38000177		0	0	7		0	0	0	183247	0	1043400	40229134		
26415	2173	19078461	1987-07-30	1987-07-30 00:00:00	1987-08-27	1987-08-27 00:00:00	1987-08-27	38000177		0	0	28		0	0	0	144891	0	310965	19078461		
39925	3304	40231925	1975-06-26	1975-06-26 00:00:00	1975-06-26	1975-06-26 00:00:00	\N	38000177		0	0	0		0	0	0	219484	0	1049221	40231925		
39979	3308	19006318	1949-09-14	1949-09-14 00:00:00	1949-09-28	1949-09-28 00:00:00	1949-09-28	38000177		0	0	14		0	0	0	219673	0	105078	19006318		
11098	924	19078461	2013-09-29	2013-09-29 00:00:00	2013-12-27	2013-12-27 00:00:00	2013-12-27	38000177		0	0	89		0	0	0	61543	0	310965	19078461		
11414	951	1127433	1967-12-30	1967-12-30 00:00:00	1968-01-20	1968-01-20 00:00:00	1968-01-20	38000177		0	0	21		0	0	0	63219	0	313782	1127433		
54546	4531	1713671	1983-02-03	1983-02-03 00:00:00	1983-02-17	1983-02-17 00:00:00	1983-02-17	38000177		0	0	14		0	0	0	301752	0	562251	1713671		
47126	3906	1713671	1968-05-24	1968-05-24 00:00:00	1968-06-14	1968-06-14 00:00:00	1968-06-14	38000177		0	0	21		0	0	0	259742	0	562251	1713671		
94716	2078	40213227	2013-08-21	2013-08-21 00:00:00	2013-08-21	2013-08-21 00:00:00	2013-08-21	581452		0	0	0		0	0	0	138409	0	113	40213227		
5738	480	1539411	2016-10-05	2016-10-05 00:00:00	2016-10-05	2016-10-05 00:00:00	\N	38000177		0	0	0		0	0	0	32082	0	312961	1539411		
120366	2646	40213306	1998-07-17	1998-07-17 00:00:00	1998-07-17	1998-07-17 00:00:00	1998-07-17	581452		0	0	0		0	0	0	175072	0	43	40213306		
106007	2325	40213296	2010-11-04	2010-11-04 00:00:00	2010-11-04	2010-11-04 00:00:00	2010-11-04	581452		0	0	0		0	0	0	154588	0	52	40213296		
13424	1125	19059056	1967-01-08	1967-01-08 00:00:00	1967-03-09	1967-03-09 00:00:00	1967-03-09	38000177		0	0	60		0	0	0	74137	0	243670	19059056		
33461	730	40213227	2018-12-15	2018-12-15 00:00:00	2018-12-15	2018-12-15 00:00:00	2018-12-15	581452		0	0	0		0	0	0	48512	0	113	40213227		
42911	3558	1713671	1973-04-20	1973-04-20 00:00:00	1973-05-11	1973-05-11 00:00:00	1973-05-11	38000177		0	0	21		0	0	0	236227	0	562251	1713671		
3204	264	1127433	1972-10-09	1972-10-09 00:00:00	1972-10-30	1972-10-30 00:00:00	1972-10-30	38000177		0	0	21		0	0	0	17535	0	313782	1127433		
3246	266	19059056	1971-09-17	1971-09-17 00:00:00	1971-10-01	1971-10-01 00:00:00	1971-10-01	38000177		0	0	14		0	0	0	17737	0	243670	19059056		
53791	4472	19075601	2010-04-24	2010-04-24 00:00:00	2015-10-03	2015-10-03 00:00:00	2015-10-03	38000177		0	0	1988		0	0	0	297556	0	309362	19075601		
127981	2815	40213296	2004-04-02	2004-04-02 00:00:00	2004-04-02	2004-04-02 00:00:00	2004-04-02	581452		0	0	0		0	0	0	186502	0	52	40213296		
11616	967	1539411	2011-07-16	2011-07-16 00:00:00	2011-07-16	2011-07-16 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	312961	1539411		
22092	1814	19059056	1945-07-29	1945-07-29 00:00:00	1945-08-12	1945-08-12 00:00:00	1945-08-12	38000177		0	0	14		0	0	0	121446	0	243670	19059056		
30955	2564	19128022	1996-07-17	1996-07-17 00:00:00	1997-07-12	1997-07-12 00:00:00	1997-07-12	38000177		0	0	360		0	0	0	169853	0	749785	19128022		
64193	5329	1127433	1996-03-22	1996-03-22 00:00:00	1996-04-05	1996-04-05 00:00:00	1996-04-05	38000177		0	0	14		0	0	0	354782	0	313782	1127433		
60	3	1118084	1957-12-08	1957-12-08 00:00:00	1957-12-08	1957-12-08 00:00:00	\N	38000177		0	0	0		0	0	0	345	0	00025152531	44923712		
17830	1476	40171902	2003-11-27	2003-11-27 00:00:00	2003-11-27	2003-11-27 00:00:00	\N	38000177		0	0	0		0	0	0	98473	0	897718	40171902		
10814	902	19059056	1965-03-10	1965-03-10 00:00:00	1965-03-31	1965-03-31 00:00:00	1965-03-31	38000177		0	0	21		0	0	0	60066	0	243670	19059056		
25715	2115	1127078	1970-12-12	1970-12-12 00:00:00	1970-12-26	1970-12-26 00:00:00	1970-12-26	38000177		0	0	14		0	0	0	140702	0	282464	1127078		
36241	2986	1127433	1978-12-06	1978-12-06 00:00:00	1978-12-13	1978-12-13 00:00:00	1978-12-13	38000177		0	0	7		0	0	0	199330	0	313782	1127433		
59621	4957	19078461	1986-08-14	1986-08-14 00:00:00	1986-11-12	1986-11-12 00:00:00	1986-11-12	38000177		0	0	90		0	0	0	329510	0	310965	19078461		
27452	2272	1127078	1987-11-19	1987-11-19 00:00:00	1988-02-17	1988-02-17 00:00:00	1988-02-17	38000177		0	0	90		0	0	0	151060	0	282464	1127078		
18410	1524	1713671	1981-04-02	1981-04-02 00:00:00	1981-04-23	1981-04-23 00:00:00	1981-04-23	38000177		0	0	21		0	0	0	101912	0	562251	1713671		
45731	3786	40229134	1964-12-08	1964-12-08 00:00:00	1964-12-15	1964-12-15 00:00:00	1964-12-15	38000177		0	0	7		0	0	0	251709	0	1043400	40229134		
27097	2235	19133905	1992-07-19	1992-07-19 00:00:00	1992-07-31	1992-07-31 00:00:00	1992-07-31	38000177		0	0	12		0	0	0	148690	0	834102	19133905		
19733	1623	19059056	1955-09-05	1955-09-05 00:00:00	1955-09-19	1955-09-19 00:00:00	1955-09-19	38000177		0	0	14		0	0	0	109137	0	243670	19059056		
165317	3634	40213227	2001-07-30	2001-07-30 00:00:00	2001-07-30	2001-07-30 00:00:00	2001-07-30	581452		0	0	0		0	0	0	241724	0	113	40213227		
56378	4677	40165015	2000-06-29	2000-06-29 00:00:00	2000-06-29	2000-06-29 00:00:00	\N	38000177		0	0	0		0	0	0	311724	0	861467	40165015		
37722	3118	19059056	1964-04-06	1964-04-06 00:00:00	1964-06-05	1964-06-05 00:00:00	1964-06-05	38000177		0	0	60		0	0	0	207402	0	243670	19059056		
20718	450	40213296	2010-04-05	2010-04-05 00:00:00	2010-04-05	2010-04-05 00:00:00	2010-04-05	581452		0	0	0		0	0	0	30019	0	52	40213296		
1922	153	1127433	1990-01-23	1990-01-23 00:00:00	1990-02-22	1990-02-22 00:00:00	1990-02-22	38000177		0	0	30		0	0	0	10332	0	313782	1127433		
41258	3420	19078461	2003-01-27	2003-01-27 00:00:00	2003-02-26	2003-02-26 00:00:00	2003-02-26	38000177		0	0	30		0	0	0	226912	0	310965	19078461		
166547	3661	40213251	1984-10-14	1984-10-14 00:00:00	1984-10-14	1984-10-14 00:00:00	1984-10-14	581452		0	0	0		0	0	0	243697	0	21	40213251		
63224	5253	40229134	1974-09-03	1974-09-03 00:00:00	1974-09-10	1974-09-10 00:00:00	1974-09-10	38000177		0	0	7		0	0	0	349489	0	1043400	40229134		
20863	1719	40229134	1961-03-05	1961-03-05 00:00:00	1961-03-19	1961-03-19 00:00:00	1961-03-19	38000177		0	0	14		0	0	0	114965	0	1043400	40229134		
56204	4666	1127433	2003-06-16	2003-06-16 00:00:00	2003-06-23	2003-06-23 00:00:00	2003-06-23	38000177		0	0	7		0	0	0	310918	0	313782	1127433		
4934	410	1127433	1990-04-04	1990-04-04 00:00:00	1990-04-25	1990-04-25 00:00:00	1990-04-25	38000177		0	0	21		0	0	0	27157	0	313782	1127433		
8413	703	1713671	2004-05-26	2004-05-26 00:00:00	2004-06-09	2004-06-09 00:00:00	2004-06-09	38000177		0	0	14		0	0	0	46441	0	562251	1713671		
11678	971	19078461	1994-03-03	1994-03-03 00:00:00	1994-03-24	1994-03-24 00:00:00	1994-03-24	38000177		0	0	21		0	0	0	64582	0	310965	19078461		
3880	321	19059056	1967-11-11	1967-11-11 00:00:00	1967-11-25	1967-11-25 00:00:00	1967-11-25	38000177		0	0	14		0	0	0	21319	0	243670	19059056		
62577	5203	1332419	1994-10-05	1994-10-05 00:00:00	1994-10-05	1994-10-05 00:00:00	\N	38000177		0	0	0		0	0	0	346109	0	197361	1332419		
133973	2942	40213227	2005-02-09	2005-02-09 00:00:00	2005-02-09	2005-02-09 00:00:00	2005-02-09	581452		0	0	0		0	0	0	196148	0	113	40213227		
30733	670	40213314	1977-09-24	1977-09-24 00:00:00	1977-09-24	1977-09-24 00:00:00	1977-09-24	581452		0	0	0		0	0	0	\N	0	49	40213314		
14545	1219	40222846	2014-11-09	2014-11-09 00:00:00	2014-11-09	2014-11-09 00:00:00	\N	38000177		0	0	0		0	0	0	80289	0	996740	40222846		
1434	114	19075601	2004-11-22	2004-11-22 00:00:00	2004-11-22	2004-11-22 00:00:00	2004-11-22	38000177		0	0	0		0	0	0	7548	0	309362	19075601		
12292	1032	1713671	1953-04-13	1953-04-13 00:00:00	1953-05-04	1953-05-04 00:00:00	1953-05-04	38000177		0	0	21		0	0	0	67901	0	562251	1713671		
41424	3435	42902245	1998-03-06	1998-03-06 00:00:00	1999-03-01	1999-03-01 00:00:00	1999-03-01	38000177		0	0	360		0	0	0	227813	0	1359133	42902245		
45928	3803	1127433	1975-05-04	1975-05-04 00:00:00	1975-05-11	1975-05-11 00:00:00	1975-05-11	38000177		0	0	7		0	0	0	252755	0	313782	1127433		
63334	5259	19078461	2004-05-19	2004-05-19 00:00:00	2004-06-09	2004-06-09 00:00:00	2004-06-09	38000177		0	0	21		0	0	0	350004	0	310965	19078461		
22597	1854	1154615	1972-11-09	1972-11-09 00:00:00	1993-01-05	1993-01-05 00:00:00	1993-01-05	38000177		0	0	7362		0	0	0	124059	0	745679	1154615		
43602	3614	1127078	1951-05-17	1951-05-17 00:00:00	1951-08-15	1951-08-15 00:00:00	1951-08-15	38000177		0	0	90		0	0	0	240097	0	282464	1127078		
50861	4225	1127433	2002-09-01	2002-09-01 00:00:00	2002-10-06	2002-10-06 00:00:00	2002-10-06	38000177		0	0	35		0	0	0	280593	0	313782	1127433		
15246	1273	19073188	2009-11-14	2009-11-14 00:00:00	2009-11-28	2009-11-28 00:00:00	2009-11-28	38000177		0	0	14		0	0	0	83978	0	308192	19073188		
60570	5037	19133873	1985-06-22	1985-06-22 00:00:00	1985-07-03	1985-07-03 00:00:00	1985-07-03	38000177		0	0	11		0	0	0	334737	0	834061	19133873		
29285	2424	1127433	2005-06-30	2005-06-30 00:00:00	2005-07-14	2005-07-14 00:00:00	2005-07-14	38000177		0	0	14		0	0	0	160807	0	313782	1127433		
29324	2427	1127433	1957-07-24	1957-07-24 00:00:00	1957-07-31	1957-07-31 00:00:00	1957-07-31	38000177		0	0	7		0	0	0	160966	0	313782	1127433		
33453	2770	1127433	1961-10-09	1961-10-09 00:00:00	1961-10-23	1961-10-23 00:00:00	1961-10-23	38000177		0	0	14		0	0	0	183389	0	313782	1127433		
26416	2173	1127433	2010-06-27	2010-06-27 00:00:00	2010-09-02	2010-09-02 00:00:00	2010-09-02	38000177		0	0	67		0	0	0	144892	0	313782	1127433		
39926	3304	1713671	2010-01-13	2010-01-13 00:00:00	2010-01-20	2010-01-20 00:00:00	2010-01-20	38000177		0	0	7		0	0	0	219465	0	562251	1713671		
39980	3308	19133873	1960-11-14	1960-11-14 00:00:00	1960-11-27	1960-11-27 00:00:00	1960-11-27	38000177		0	0	13		0	0	0	219664	0	834061	19133873		
11099	924	1127433	1977-02-15	1977-02-15 00:00:00	1977-03-08	1977-03-08 00:00:00	1977-03-08	38000177		0	0	21		0	0	0	61539	0	313782	1127433		
11415	951	1713671	2002-05-31	2002-05-31 00:00:00	2002-06-21	2002-06-21 00:00:00	2002-06-21	38000177		0	0	21		0	0	0	63189	0	562251	1713671		
54547	4531	19059056	1943-09-08	1943-09-08 00:00:00	1943-09-22	1943-09-22 00:00:00	1943-09-22	38000177		0	0	14		0	0	0	301704	0	243670	19059056		
47127	3906	1713671	2010-05-23	2010-05-23 00:00:00	2010-05-30	2010-05-30 00:00:00	2010-05-30	38000177		0	0	7		0	0	0	259666	0	562251	1713671		
94719	2078	40213306	2004-08-11	2004-08-11 00:00:00	2004-08-11	2004-08-11 00:00:00	2004-08-11	581452		0	0	0		0	0	0	138406	0	43	40213306		
5739	480	19075601	2016-10-05	2016-10-05 00:00:00	2016-10-05	2016-10-05 00:00:00	\N	38000177		0	0	0		0	0	0	32082	0	309362	19075601		
120369	2646	40213160	1974-12-20	1974-12-20 00:00:00	1974-12-20	1974-12-20 00:00:00	1974-12-20	581452		0	0	0		0	0	0	175054	0	10	40213160		
174592	3839	40213160	1955-06-27	1955-06-27 00:00:00	1955-06-27	1955-06-27 00:00:00	1955-06-27	581452		0	0	0		0	0	0	254893	0	10	40213160		
13425	1125	19059056	1952-09-11	1952-09-11 00:00:00	1952-10-09	1952-10-09 00:00:00	1952-10-09	38000177		0	0	28		0	0	0	74135	0	243670	19059056		
33462	730	40213260	2007-04-14	2007-04-14 00:00:00	2007-04-14	2007-04-14 00:00:00	2007-04-14	581452		0	0	0		0	0	0	48509	0	121	40213260		
42912	3558	1127433	2011-03-09	2011-03-09 00:00:00	2011-03-23	2011-03-23 00:00:00	2011-03-23	38000177		0	0	14		0	0	0	236217	0	313782	1127433		
3205	264	1127433	1977-07-27	1977-07-27 00:00:00	1977-08-24	1977-08-24 00:00:00	1977-08-24	38000177		0	0	28		0	0	0	17585	0	313782	1127433		
3247	266	19006318	1971-09-17	1971-09-17 00:00:00	1971-10-01	1971-10-01 00:00:00	1971-10-01	38000177		0	0	14		0	0	0	17737	0	105078	19006318		
53792	4472	19126352	2010-04-24	2010-04-24 00:00:00	2015-10-03	2015-10-03 00:00:00	2015-10-03	38000177		0	0	1988		0	0	0	297556	0	705129	19126352		
139264	3059	40213160	1970-09-27	1970-09-27 00:00:00	1970-09-27	1970-09-27 00:00:00	1970-09-27	581452		0	0	0		0	0	0	203498	0	10	40213160		
168009	3694	40213160	1957-12-17	1957-12-17 00:00:00	1957-12-17	1957-12-17 00:00:00	1957-12-17	581452		0	0	0		0	0	0	245483	0	10	40213160		
19824	431	40213198	2013-08-29	2013-08-29 00:00:00	2013-08-29	2013-08-29 00:00:00	2013-08-29	581452		0	0	0		0	0	0	28643	0	133	40213198		
30956	2564	1127078	1983-05-31	1983-05-31 00:00:00	1983-06-21	1983-06-21 00:00:00	1983-06-21	38000177		0	0	21		0	0	0	169847	0	282464	1127078		
64194	5329	1127433	1998-07-14	1998-07-14 00:00:00	1998-08-04	1998-08-04 00:00:00	1998-08-04	38000177		0	0	21		0	0	0	354832	0	313782	1127433		
61	3	1127433	1986-10-04	1986-10-04 00:00:00	1986-12-03	1986-12-03 00:00:00	1986-12-03	38000177		0	0	60		0	0	0	348	0	313782	1127433		
17831	1476	1713671	1958-12-14	1958-12-14 00:00:00	1958-12-28	1958-12-28 00:00:00	1958-12-28	38000177		0	0	14		0	0	0	98534	0	562251	1713671		
10815	902	19126352	2011-05-21	2011-05-21 00:00:00	2011-05-21	2011-05-21 00:00:00	\N	38000177		0	0	0		0	0	0	60045	0	705129	19126352		
25716	2115	19059056	1968-02-21	1968-02-21 00:00:00	1968-03-27	1968-03-27 00:00:00	1968-03-27	38000177		0	0	35		0	0	0	140701	0	243670	19059056		
36242	2986	1118084	1980-05-24	1980-05-24 00:00:00	1980-05-24	1980-05-24 00:00:00	\N	38000177		0	0	0		0	0	0	199330	0	00025152531	44923712		
59622	4957	1127433	1978-11-12	1978-11-12 00:00:00	1978-11-19	1978-11-19 00:00:00	1978-11-19	38000177		0	0	7		0	0	0	329515	0	313782	1127433		
27453	2272	1127433	1996-09-02	1996-09-02 00:00:00	1996-10-07	1996-10-07 00:00:00	1996-10-07	38000177		0	0	35		0	0	0	151061	0	313782	1127433		
18411	1524	19059056	1973-01-10	1973-01-10 00:00:00	1973-01-24	1973-01-24 00:00:00	1973-01-24	38000177		0	0	14		0	0	0	101908	0	243670	19059056		
45734	3786	19078461	1991-10-01	1991-10-01 00:00:00	1991-10-15	1991-10-15 00:00:00	1991-10-15	38000177		0	0	14		0	0	0	251663	0	310965	19078461		
27098	2235	19075601	2012-12-12	2012-12-12 00:00:00	2012-12-12	2012-12-12 00:00:00	2012-12-12	38000177		0	0	0		0	0	0	148639	0	309362	19075601		
19734	1623	1127433	2006-08-08	2006-08-08 00:00:00	2006-08-22	2006-08-22 00:00:00	2006-08-22	38000177		0	0	14		0	0	0	109087	0	313782	1127433		
165322	3634	40213296	2010-04-19	2010-04-19 00:00:00	2010-04-19	2010-04-19 00:00:00	2010-04-19	581452		0	0	0		0	0	0	241726	0	52	40213296		
56379	4677	1127433	1984-12-13	1984-12-13 00:00:00	1984-12-27	1984-12-27 00:00:00	1984-12-27	38000177		0	0	14		0	0	0	311654	0	313782	1127433		
37723	3118	40162522	1964-04-06	1964-04-06 00:00:00	1964-04-06	1964-04-06 00:00:00	\N	38000177		0	0	0		0	0	0	207402	0	857005	40162522		
20720	450	40213227	2010-04-05	2010-04-05 00:00:00	2010-04-05	2010-04-05 00:00:00	2010-04-05	581452		0	0	0		0	0	0	30019	0	113	40213227		
1923	153	1127433	1944-06-06	1944-06-06 00:00:00	1944-06-20	1944-06-20 00:00:00	1944-06-20	38000177		0	0	14		0	0	0	10404	0	313782	1127433		
41260	3420	19133873	1970-01-02	1970-01-02 00:00:00	1970-01-14	1970-01-14 00:00:00	1970-01-14	38000177		0	0	12		0	0	0	226843	0	834061	19133873		
166552	3661	40213314	1979-04-22	1979-04-22 00:00:00	1979-04-22	1979-04-22 00:00:00	1979-04-22	581452		0	0	0		0	0	0	243693	0	49	40213314		
63225	5253	1713671	1964-02-17	1964-02-17 00:00:00	1964-03-02	1964-03-02 00:00:00	1964-03-02	38000177		0	0	14		0	0	0	349522	0	562251	1713671		
20864	1719	1127433	1991-03-08	1991-03-08 00:00:00	1991-04-05	1991-04-05 00:00:00	1991-04-05	38000177		0	0	28		0	0	0	114918	0	313782	1127433		
7426	621	19059056	1919-04-17	1919-04-17 00:00:00	1919-05-17	1919-05-17 00:00:00	1919-05-17	38000177		0	0	30		0	0	0	41485	0	243670	19059056		
4935	410	1127433	1975-02-18	1975-02-18 00:00:00	1975-02-25	1975-02-25 00:00:00	1975-02-25	38000177		0	0	7		0	0	0	27197	0	313782	1127433		
8414	703	40229134	2013-12-25	2013-12-25 00:00:00	2014-01-08	2014-01-08 00:00:00	2014-01-08	38000177		0	0	14		0	0	0	46447	0	1043400	40229134		
11679	971	19133905	1966-08-18	1966-08-18 00:00:00	1966-08-28	1966-08-28 00:00:00	1966-08-28	38000177		0	0	10		0	0	0	64607	0	834102	19133905		
22998	499	40213306	1981-07-10	1981-07-10 00:00:00	1981-07-10	1981-07-10 00:00:00	1981-07-10	581452		0	0	0		0	0	0	33347	0	43	40213306		
62578	5203	1127433	1941-05-16	1941-05-16 00:00:00	1941-05-30	1941-05-30 00:00:00	1941-05-30	38000177		0	0	14		0	0	0	346112	0	313782	1127433		
28613	2358	1713671	1981-08-03	1981-08-03 00:00:00	1981-08-17	1981-08-17 00:00:00	1981-08-17	38000177		0	0	14		0	0	0	157149	0	562251	1713671		
30737	670	40213160	1974-02-09	1974-02-09 00:00:00	1974-02-09	1974-02-09 00:00:00	1974-02-09	581452		0	0	0		0	0	0	44229	0	10	40213160		
14546	1219	1713671	2008-04-23	2008-04-23 00:00:00	2008-05-14	2008-05-14 00:00:00	2008-05-14	38000177		0	0	21		0	0	0	80239	0	562251	1713671		
1435	114	40220960	2004-11-22	2004-11-22 00:00:00	2004-11-22	2004-11-22 00:00:00	2004-11-22	38000177		0	0	0		0	0	0	7548	0	1804799	40220960		
12293	1032	1127433	1990-07-26	1990-07-26 00:00:00	1990-08-23	1990-08-23 00:00:00	1990-08-23	38000177		0	0	28		0	0	0	67952	0	313782	1127433		
41425	3435	19128022	1993-04-01	1993-04-01 00:00:00	1994-03-27	1994-03-27 00:00:00	1994-03-27	38000177		0	0	360		0	0	0	227779	0	749785	19128022		
45929	3803	1127433	1983-08-29	1983-08-29 00:00:00	1983-09-12	1983-09-12 00:00:00	1983-09-12	38000177		0	0	14		0	0	0	252764	0	313782	1127433		
63344	5262	19078461	2015-05-08	2015-05-08 00:00:00	2015-06-12	2015-06-12 00:00:00	2015-06-12	38000177		0	0	35		0	0	0	350077	0	310965	19078461		
22598	1854	1127433	2006-04-26	2006-04-26 00:00:00	2006-07-25	2006-07-25 00:00:00	2006-07-25	38000177		0	0	90		0	0	0	124133	0	313782	1127433		
43603	3614	1124300	1989-11-03	1989-11-03 00:00:00	1989-11-03	1989-11-03 00:00:00	\N	38000177		0	0	0		0	0	0	240095	0	00781178901	45011828		
50862	4225	1713671	2003-03-11	2003-03-11 00:00:00	2003-03-18	2003-03-18 00:00:00	2003-03-18	38000177		0	0	7		0	0	0	280622	0	562251	1713671		
15247	1273	1115171	2009-11-14	2009-11-14 00:00:00	2009-11-28	2009-11-28 00:00:00	2009-11-28	38000177		0	0	14		0	0	0	83978	0	849574	1115171		
60571	5037	19078461	1994-12-14	1994-12-14 00:00:00	1995-01-04	1995-01-04 00:00:00	1995-01-04	38000177		0	0	21		0	0	0	334734	0	310965	19078461		
29286	2424	1713671	1994-03-12	1994-03-12 00:00:00	1994-03-26	1994-03-26 00:00:00	1994-03-26	38000177		0	0	14		0	0	0	160840	0	562251	1713671		
29325	2427	1127433	1975-07-21	1975-07-21 00:00:00	1975-08-04	1975-08-04 00:00:00	1975-08-04	38000177		0	0	14		0	0	0	161030	0	313782	1127433		
33454	2770	1713671	1951-03-08	1951-03-08 00:00:00	1951-03-29	1951-03-29 00:00:00	1951-03-29	38000177		0	0	21		0	0	0	183312	0	562251	1713671		
26417	2173	1713671	2009-04-07	2009-04-07 00:00:00	2009-04-21	2009-04-21 00:00:00	2009-04-21	38000177		0	0	14		0	0	0	144808	0	562251	1713671		
39927	3304	1127078	1963-09-06	1963-09-06 00:00:00	1963-09-20	1963-09-20 00:00:00	1963-09-20	38000177		0	0	14		0	0	0	219449	0	282464	1127078		
39981	3308	1332419	1995-02-20	1995-02-20 00:00:00	1995-02-20	1995-02-20 00:00:00	\N	38000177		0	0	0		0	0	0	219638	0	197361	1332419		
11100	924	40165015	1977-02-15	1977-02-15 00:00:00	1977-02-15	1977-02-15 00:00:00	\N	38000177		0	0	0		0	0	0	61539	0	861467	40165015		
11416	951	1713671	2013-12-27	2013-12-27 00:00:00	2014-01-17	2014-01-17 00:00:00	2014-01-17	38000177		0	0	21		0	0	0	63190	0	562251	1713671		
54548	4531	19133905	1941-02-18	1941-02-18 00:00:00	1941-02-28	1941-02-28 00:00:00	1941-02-28	38000177		0	0	10		0	0	0	301813	0	834102	19133905		
47128	3906	1127433	1978-03-13	1978-03-13 00:00:00	1978-03-20	1978-03-20 00:00:00	1978-03-20	38000177		0	0	7		0	0	0	259655	0	313782	1127433		
94721	2078	40213227	2004-08-11	2004-08-11 00:00:00	2004-08-11	2004-08-11 00:00:00	2004-08-11	581452		0	0	0		0	0	0	138406	0	113	40213227		
5740	480	1127433	1961-06-17	1961-06-17 00:00:00	1961-07-08	1961-07-08 00:00:00	1961-07-08	38000177		0	0	21		0	0	0	31967	0	313782	1127433		
120378	2646	40213160	1975-03-21	1975-03-21 00:00:00	1975-03-21	1975-03-21 00:00:00	1975-03-21	581452		0	0	0		0	0	0	175095	0	10	40213160		
8483	182	40213198	2015-12-13	2015-12-13 00:00:00	2015-12-13	2015-12-13 00:00:00	2015-12-13	581452		0	0	0		0	0	0	12311	0	133	40213198		
13426	1125	1118084	1986-06-30	1986-06-30 00:00:00	1986-06-30	1986-06-30 00:00:00	\N	38000177		0	0	0		0	0	0	74184	0	00025152531	44923712		
33466	730	40213227	1991-12-28	1991-12-28 00:00:00	1991-12-28	1991-12-28 00:00:00	1991-12-28	581452		0	0	0		0	0	0	48451	0	113	40213227		
42913	3558	19128065	1977-03-03	1977-03-03 00:00:00	1978-02-26	1978-02-26 00:00:00	1978-02-26	38000177		0	0	360		0	0	0	236191	0	749882	19128065		
3206	264	1115171	2008-07-31	2008-07-31 00:00:00	2008-08-21	2008-08-21 00:00:00	2008-08-21	38000177		0	0	21		0	0	0	17589	0	849574	1115171		
3252	268	1127433	1990-03-23	1990-03-23 00:00:00	1990-03-30	1990-03-30 00:00:00	1990-03-30	38000177		0	0	7		0	0	0	17795	0	313782	1127433		
53793	4472	1539411	2010-04-24	2010-04-24 00:00:00	2010-04-24	2010-04-24 00:00:00	\N	38000177		0	0	0		0	0	0	297556	0	312961	1539411		
139267	3059	40213296	2010-04-25	2010-04-25 00:00:00	2010-04-25	2010-04-25 00:00:00	2010-04-25	581452		0	0	0		0	0	0	203525	0	52	40213296		
168013	3694	40213227	1999-04-20	1999-04-20 00:00:00	1999-04-20	1999-04-20 00:00:00	1999-04-20	581452		0	0	0		0	0	0	245536	0	113	40213227		
19826	431	40213201	2014-09-04	2014-09-04 00:00:00	2014-09-04	2014-09-04 00:00:00	2014-09-04	581452		0	0	0		0	0	0	28581	0	33	40213201		
30957	2564	1127078	1986-06-05	1986-06-05 00:00:00	1986-07-05	1986-07-05 00:00:00	1986-07-05	38000177		0	0	30		0	0	0	169906	0	282464	1127078		
64195	5329	19133905	1985-01-28	1985-01-28 00:00:00	1985-02-09	1985-02-09 00:00:00	1985-02-09	38000177		0	0	12		0	0	0	354757	0	834102	19133905		
62	3	40162522	1986-10-04	1986-10-04 00:00:00	1986-10-04	1986-10-04 00:00:00	\N	38000177		0	0	0		0	0	0	348	0	857005	40162522		
17837	1478	40232448	1964-04-10	1964-04-10 00:00:00	1964-04-10	1964-04-10 00:00:00	\N	38000177		0	0	0		0	0	0	98628	0	1049630	40232448		
10816	902	1332419	2011-05-21	2011-05-21 00:00:00	2011-05-21	2011-05-21 00:00:00	\N	38000177		0	0	0		0	0	0	60045	0	197361	1332419		
25717	2115	1127433	2011-04-02	2011-04-02 00:00:00	2011-06-01	2011-06-01 00:00:00	2011-06-01	38000177		0	0	60		0	0	0	140706	0	313782	1127433		
36243	2986	40174880	2015-09-23	2015-09-23 00:00:00	2015-09-23	2015-09-23 00:00:00	\N	38000177		0	0	0		0	0	0	199350	0	966222	40174880		
59623	4957	1127078	1971-12-01	1971-12-01 00:00:00	1971-12-15	1971-12-15 00:00:00	1971-12-15	38000177		0	0	14		0	0	0	329557	0	282464	1127078		
27454	2272	19133905	2001-03-14	2001-03-14 00:00:00	2001-03-26	2001-03-26 00:00:00	2001-03-26	38000177		0	0	12		0	0	0	150987	0	834102	19133905		
18412	1524	40236824	2008-02-06	2008-02-06 00:00:00	2008-02-13	2008-02-13 00:00:00	2008-02-13	38000177		0	0	7		0	0	0	101956	0	1094107	40236824		
45735	3786	19133905	2013-05-01	2013-05-01 00:00:00	2013-05-12	2013-05-12 00:00:00	2013-05-12	38000177		0	0	11		0	0	0	251717	0	834102	19133905		
27099	2235	40220960	2012-12-12	2012-12-12 00:00:00	2012-12-12	2012-12-12 00:00:00	2012-12-12	38000177		0	0	0		0	0	0	148639	0	1804799	40220960		
19735	1623	19133905	2017-07-05	2017-07-05 00:00:00	2017-07-18	2017-07-18 00:00:00	2017-07-18	38000177		0	0	13		0	0	0	109088	0	834102	19133905		
84516	1848	40213227	2016-05-05	2016-05-05 00:00:00	2016-05-05	2016-05-05 00:00:00	2016-05-05	581452		0	0	0		0	0	0	123600	0	113	40213227		
56380	4677	19133905	2016-04-22	2016-04-22 00:00:00	2016-05-03	2016-05-03 00:00:00	2016-05-03	38000177		0	0	11		0	0	0	311648	0	834102	19133905		
37724	3118	1127078	1952-07-05	1952-07-05 00:00:00	1952-07-19	1952-07-19 00:00:00	1952-07-19	38000177		0	0	14		0	0	0	207532	0	282464	1127078		
20725	450	40213227	2018-04-30	2018-04-30 00:00:00	2018-04-30	2018-04-30 00:00:00	2018-04-30	581452		0	0	0		0	0	0	30020	0	113	40213227		
1924	153	19133873	1943-09-11	1943-09-11 00:00:00	1943-09-18	1943-09-18 00:00:00	1943-09-18	38000177		0	0	7		0	0	0	10334	0	834061	19133873		
41261	3420	1127433	1993-04-22	1993-04-22 00:00:00	1993-04-29	1993-04-29 00:00:00	1993-04-29	38000177		0	0	7		0	0	0	226867	0	313782	1127433		
166556	3661	40213227	2000-12-03	2000-12-03 00:00:00	2000-12-03	2000-12-03 00:00:00	2000-12-03	581452		0	0	0		0	0	0	243702	0	113	40213227		
63226	5253	1127433	1980-04-13	1980-04-13 00:00:00	1980-04-20	1980-04-20 00:00:00	1980-04-20	38000177		0	0	7		0	0	0	349540	0	313782	1127433		
20865	1720	1127433	2009-12-23	2009-12-23 00:00:00	2010-01-06	2010-01-06 00:00:00	2010-01-06	38000177		0	0	14		0	0	0	115003	0	313782	1127433		
7427	621	19133873	1926-02-09	1926-02-09 00:00:00	1926-02-17	1926-02-17 00:00:00	1926-02-17	38000177		0	0	8		0	0	0	41446	0	834061	19133873		
4936	410	19078461	2019-02-06	2019-02-06 00:00:00	2019-03-08	2019-03-08 00:00:00	2019-03-08	38000177		0	0	30		0	0	0	27159	0	310965	19078461		
8415	703	19059056	1954-05-31	1954-05-31 00:00:00	1954-06-14	1954-06-14 00:00:00	1954-06-14	38000177		0	0	14		0	0	0	46448	0	243670	19059056		
11680	972	1118084	2002-06-12	2002-06-12 00:00:00	2002-06-12	2002-06-12 00:00:00	\N	38000177		0	0	0		0	0	0	64678	0	00025152531	44923712		
23001	499	40213227	2000-05-26	2000-05-26 00:00:00	2000-05-26	2000-05-26 00:00:00	2000-05-26	581452		0	0	0		0	0	0	\N	0	113	40213227		
62579	5203	40229134	1973-08-03	1973-08-03 00:00:00	1973-08-10	1973-08-10 00:00:00	1973-08-10	38000177		0	0	7		0	0	0	346123	0	1043400	40229134		
28614	2358	19133873	1973-12-25	1973-12-25 00:00:00	1974-01-07	1974-01-07 00:00:00	1974-01-07	38000177		0	0	13		0	0	0	157163	0	834061	19133873		
30739	670	40213160	1978-10-14	1978-10-14 00:00:00	1978-10-14	1978-10-14 00:00:00	1978-10-14	581452		0	0	0		0	0	0	44215	0	10	40213160		
14547	1219	19059056	1978-08-11	1978-08-11 00:00:00	1978-08-25	1978-08-25 00:00:00	1978-08-25	38000177		0	0	14		0	0	0	80256	0	243670	19059056		
1436	114	40229134	2009-11-30	2009-11-30 00:00:00	2009-12-07	2009-12-07 00:00:00	2009-12-07	38000177		0	0	7		0	0	0	7513	0	1043400	40229134		
12294	1032	1127433	1980-10-13	1980-10-13 00:00:00	1980-10-20	1980-10-20 00:00:00	1980-10-20	38000177		0	0	7		0	0	0	67885	0	313782	1127433		
41426	3435	19078461	2014-04-27	2014-04-27 00:00:00	2014-05-18	2014-05-18 00:00:00	2014-05-18	38000177		0	0	21		0	0	0	227835	0	310965	19078461		
45930	3803	1713671	1961-08-12	1961-08-12 00:00:00	1961-09-02	1961-09-02 00:00:00	1961-09-02	38000177		0	0	21		0	0	0	252763	0	562251	1713671		
63345	5262	19128065	1992-11-21	1992-11-21 00:00:00	1993-11-16	1993-11-16 00:00:00	1993-11-16	38000177		0	0	360		0	0	0	350127	0	749882	19128065		
22599	1854	1127433	1973-06-21	1973-06-21 00:00:00	1973-07-05	1973-07-05 00:00:00	1973-07-05	38000177		0	0	14		0	0	0	124074	0	313782	1127433		
43604	3614	1127433	1952-03-13	1952-03-13 00:00:00	1952-03-20	1952-03-20 00:00:00	1952-03-20	38000177		0	0	7		0	0	0	240146	0	313782	1127433		
50863	4226	1127433	1983-03-09	1983-03-09 00:00:00	1983-03-16	1983-03-16 00:00:00	1983-03-16	38000177		0	0	7		0	0	0	280768	0	313782	1127433		
15248	1273	40229134	1941-09-13	1941-09-13 00:00:00	1941-09-20	1941-09-20 00:00:00	1941-09-20	38000177		0	0	7		0	0	0	84061	0	1043400	40229134		
60572	5037	19128022	1993-02-02	1993-02-02 00:00:00	1994-01-28	1994-01-28 00:00:00	1994-01-28	38000177		0	0	360		0	0	0	334722	0	749785	19128022		
29287	2424	1127078	1964-03-05	1964-03-05 00:00:00	1964-03-19	1964-03-19 00:00:00	1964-03-19	38000177		0	0	14		0	0	0	160847	0	282464	1127078		
29326	2427	19133905	1978-09-17	1978-09-17 00:00:00	1978-09-26	1978-09-26 00:00:00	1978-09-26	38000177		0	0	9		0	0	0	161036	0	834102	19133905		
33455	2770	40220960	2018-12-15	2018-12-15 00:00:00	2018-12-15	2018-12-15 00:00:00	2018-12-15	38000177		0	0	0		0	0	0	183308	0	1804799	40220960		
26418	2173	1127433	1960-03-02	1960-03-02 00:00:00	1960-03-23	1960-03-23 00:00:00	1960-03-23	38000177		0	0	21		0	0	0	144889	0	313782	1127433		
39928	3304	19129655	1963-09-06	1963-09-06 00:00:00	1963-09-20	1963-09-20 00:00:00	1963-09-20	38000177		0	0	14		0	0	0	219449	0	789980	19129655		
39982	3308	19059056	1952-09-09	1952-09-09 00:00:00	1952-09-30	1952-09-30 00:00:00	1952-09-30	38000177		0	0	21		0	0	0	219654	0	243670	19059056		
11101	924	19006318	1977-02-15	1977-02-15 00:00:00	1977-03-08	1977-03-08 00:00:00	1977-03-08	38000177		0	0	21		0	0	0	61539	0	105078	19006318		
11417	951	40229134	1984-01-20	1984-01-20 00:00:00	1984-02-03	1984-02-03 00:00:00	1984-02-03	38000177		0	0	14		0	0	0	63138	0	1043400	40229134		
54549	4532	19133873	1911-04-27	1911-04-27 00:00:00	1911-05-10	1911-05-10 00:00:00	1911-05-10	38000177		0	0	13		0	0	0	301912	0	834061	19133873		
47129	3906	1127433	1957-03-12	1957-03-12 00:00:00	1957-03-19	1957-03-19 00:00:00	1957-03-19	38000177		0	0	7		0	0	0	259672	0	313782	1127433		
28547	621	40213227	2004-01-14	2004-01-14 00:00:00	2004-01-14	2004-01-14 00:00:00	2004-01-14	581452		0	0	0		0	0	0	41405	0	113	40213227		
5741	480	40229134	1975-09-23	1975-09-23 00:00:00	1975-10-07	1975-10-07 00:00:00	1975-10-07	38000177		0	0	14		0	0	0	32022	0	1043400	40229134		
14112	304	40213227	2017-06-05	2017-06-05 00:00:00	2017-06-05	2017-06-05 00:00:00	2017-06-05	581452		0	0	0		0	0	0	20233	0	113	40213227		
8488	183	40213160	1975-07-03	1975-07-03 00:00:00	1975-07-03	1975-07-03 00:00:00	1975-07-03	581452		0	0	0		0	0	0	12340	0	10	40213160		
13427	1125	40229134	1958-09-11	1958-09-11 00:00:00	1958-09-25	1958-09-25 00:00:00	1958-09-25	38000177		0	0	14		0	0	0	74195	0	1043400	40229134		
33471	730	40213296	1997-04-19	1997-04-19 00:00:00	1997-04-19	1997-04-19 00:00:00	1997-04-19	581452		0	0	0		0	0	0	48490	0	52	40213296		
42914	3558	920300	1992-04-19	1992-04-19 00:00:00	1992-04-26	1992-04-26 00:00:00	1992-04-26	38000177		0	0	7		0	0	0	236219	0	311989	920300		
97562	2138	40213260	2007-02-04	2007-02-04 00:00:00	2007-02-04	2007-02-04 00:00:00	2007-02-04	581452		0	0	0		0	0	0	142439	0	121	40213260		
44858	975	40213160	1969-10-26	1969-10-26 00:00:00	1969-10-26	1969-10-26 00:00:00	1969-10-26	581452		0	0	0		0	0	0	65045	0	10	40213160		
53794	4472	1332419	2010-04-24	2010-04-24 00:00:00	2010-04-24	2010-04-24 00:00:00	\N	38000177		0	0	0		0	0	0	297556	0	197361	1332419		
46501	1016	40213260	2018-06-20	2018-06-20 00:00:00	2018-06-20	2018-06-20 00:00:00	2018-06-20	581452		0	0	0		0	0	0	66882	0	121	40213260		
168014	3694	40213296	1999-04-20	1999-04-20 00:00:00	1999-04-20	1999-04-20 00:00:00	1999-04-20	581452		0	0	0		0	0	0	245536	0	52	40213296		
19852	432	40213201	1997-03-17	1997-03-17 00:00:00	1997-03-17	1997-03-17 00:00:00	1997-03-17	581452		0	0	0		0	0	0	28694	0	33	40213201		
30958	2564	19078461	2009-12-22	2009-12-22 00:00:00	2010-01-19	2010-01-19 00:00:00	2010-01-19	38000177		0	0	28		0	0	0	169908	0	310965	19078461		
64196	5329	40220960	1989-03-01	1989-03-01 00:00:00	1989-03-01	1989-03-01 00:00:00	1989-03-01	38000177		0	0	0		0	0	0	354810	0	1804799	40220960		
63	3	19126352	2012-09-24	2012-09-24 00:00:00	2012-09-24	2012-09-24 00:00:00	\N	38000177		0	0	0		0	0	0	277	0	705129	19126352		
17838	1478	1127433	2012-08-14	2012-08-14 00:00:00	2012-08-21	2012-08-21 00:00:00	2012-08-21	38000177		0	0	7		0	0	0	98575	0	313782	1127433		
10817	902	1539411	2011-05-21	2011-05-21 00:00:00	2011-05-21	2011-05-21 00:00:00	\N	38000177		0	0	0		0	0	0	60045	0	312961	1539411		
25718	2115	1127433	1971-09-05	1971-09-05 00:00:00	1971-09-19	1971-09-19 00:00:00	1971-09-19	38000177		0	0	14		0	0	0	140756	0	313782	1127433		
36244	2986	19133873	1949-10-12	1949-10-12 00:00:00	1949-10-24	1949-10-24 00:00:00	1949-10-24	38000177		0	0	12		0	0	0	199319	0	834061	19133873		
59624	4957	46233988	1971-12-01	1971-12-01 00:00:00	1971-12-15	1971-12-15 00:00:00	1971-12-15	38000177		0	0	14		0	0	0	329557	0	1652673	46233988		
27455	2272	19127922	2002-10-11	2002-10-11 00:00:00	2003-10-06	2003-10-06 00:00:00	2003-10-06	38000177		0	0	360		0	0	0	151058	0	748962	19127922		
18413	1524	920300	2008-02-06	2008-02-06 00:00:00	2008-02-13	2008-02-13 00:00:00	2008-02-13	38000177		0	0	7		0	0	0	101956	0	311989	920300		
45736	3786	19129655	1962-11-18	1962-11-18 00:00:00	1962-12-02	1962-12-02 00:00:00	1962-12-02	38000177		0	0	14		0	0	0	251655	0	789980	19129655		
27100	2235	1713671	1953-12-30	1953-12-30 00:00:00	1954-01-20	1954-01-20 00:00:00	1954-01-20	38000177		0	0	21		0	0	0	148653	0	562251	1713671		
19736	1623	1127078	1956-02-04	1956-02-04 00:00:00	1956-02-18	1956-02-18 00:00:00	1956-02-18	38000177		0	0	14		0	0	0	109127	0	282464	1127078		
84521	1848	40213227	1996-08-29	1996-08-29 00:00:00	1996-08-29	1996-08-29 00:00:00	1996-08-29	581452		0	0	0		0	0	0	123638	0	113	40213227		
56381	4677	1115171	2017-03-03	2017-03-03 00:00:00	2017-03-17	2017-03-17 00:00:00	2017-03-17	38000177		0	0	14		0	0	0	311698	0	849574	1115171		
37725	3118	19006318	1952-07-05	1952-07-05 00:00:00	1952-07-19	1952-07-19 00:00:00	1952-07-19	38000177		0	0	14		0	0	0	207532	0	105078	19006318		
20726	450	40213260	2018-04-30	2018-04-30 00:00:00	2018-04-30	2018-04-30 00:00:00	2018-04-30	581452		0	0	0		0	0	0	30020	0	121	40213260		
165766	3644	40213160	1955-01-19	1955-01-19 00:00:00	1955-01-19	1955-01-19 00:00:00	1955-01-19	581452		0	0	0		0	0	0	242500	0	10	40213160		
41265	3422	1127433	1981-03-21	1981-03-21 00:00:00	1981-04-04	1981-04-04 00:00:00	1981-04-04	38000177		0	0	14		0	0	0	227025	0	313782	1127433		
166557	3661	40213306	2000-12-03	2000-12-03 00:00:00	2000-12-03	2000-12-03 00:00:00	2000-12-03	581452		0	0	0		0	0	0	243702	0	43	40213306		
63227	5253	1115171	1997-07-02	1997-07-02 00:00:00	1997-07-30	1997-07-30 00:00:00	1997-07-30	38000177		0	0	28		0	0	0	349573	0	849574	1115171		
20866	1720	1118084	2014-05-11	2014-05-11 00:00:00	2014-05-11	2014-05-11 00:00:00	\N	38000177		0	0	0		0	0	0	115018	0	00025152531	44923712		
7428	621	1127433	2017-05-01	2017-05-01 00:00:00	2017-05-15	2017-05-15 00:00:00	2017-05-15	38000177		0	0	14		0	0	0	41418	0	313782	1127433		
4937	410	40162522	2019-02-06	2019-02-06 00:00:00	2019-02-06	2019-02-06 00:00:00	\N	38000177		0	0	0		0	0	0	27159	0	857005	40162522		
8416	703	19006318	1954-05-31	1954-05-31 00:00:00	1954-06-14	1954-06-14 00:00:00	1954-06-14	38000177		0	0	14		0	0	0	46448	0	105078	19006318		
11681	972	19075601	2019-01-30	2019-01-30 00:00:00	2019-01-30	2019-01-30 00:00:00	2019-01-30	38000177		0	0	0		0	0	0	64683	0	309362	19075601		
23002	499	40213296	2000-05-26	2000-05-26 00:00:00	2000-05-26	2000-05-26 00:00:00	2000-05-26	581452		0	0	0		0	0	0	\N	0	52	40213296		
62580	5203	1539411	1991-09-18	1991-09-18 00:00:00	1991-09-18	1991-09-18 00:00:00	\N	38000177		0	0	0		0	0	0	346096	0	312961	1539411		
28615	2358	1118084	2007-09-17	2007-09-17 00:00:00	2007-09-17	2007-09-17 00:00:00	\N	38000177		0	0	0		0	0	0	157152	0	00025152531	44923712		
30745	670	40213227	2015-11-06	2015-11-06 00:00:00	2015-11-06	2015-11-06 00:00:00	2015-11-06	581452		0	0	0		0	0	0	44262	0	113	40213227		
14548	1219	1124300	1978-12-24	1978-12-24 00:00:00	1978-12-24	1978-12-24 00:00:00	\N	38000177		0	0	0		0	0	0	80256	0	00781178901	45011828		
1437	114	964261	2006-03-05	2006-03-05 00:00:00	2006-03-05	2006-03-05 00:00:00	\N	38000177		0	0	0		0	0	0	7511	0	2001499	964261		
12295	1033	19019979	1980-12-20	1980-12-20 00:00:00	1981-03-20	1981-03-20 00:00:00	1981-03-20	38000177		0	0	90		0	0	0	67968	0	198405	19019979		
41427	3435	1127433	1985-09-01	1985-09-01 00:00:00	1985-09-15	1985-09-15 00:00:00	1985-09-15	38000177		0	0	14		0	0	0	227810	0	313782	1127433		
45931	3803	920300	2002-05-10	2002-05-10 00:00:00	2002-05-17	2002-05-17 00:00:00	2002-05-17	38000177		0	0	7		0	0	0	252757	0	311989	920300		
63346	5262	19128022	1989-12-04	1989-12-04 00:00:00	1990-11-29	1990-11-29 00:00:00	1990-11-29	38000177		0	0	360		0	0	0	350124	0	749785	19128022		
22600	1854	1127433	2012-12-12	2012-12-12 00:00:00	2012-12-26	2012-12-26 00:00:00	2012-12-26	38000177		0	0	14		0	0	0	124091	0	313782	1127433		
43605	3614	19059056	1967-12-19	1967-12-19 00:00:00	1968-01-23	1968-01-23 00:00:00	1968-01-23	38000177		0	0	35		0	0	0	240098	0	243670	19059056		
50864	4226	40229134	1975-04-15	1975-04-15 00:00:00	1975-04-22	1975-04-22 00:00:00	1975-04-22	38000177		0	0	7		0	0	0	280764	0	1043400	40229134		
15249	1273	40222846	2012-10-18	2012-10-18 00:00:00	2012-10-18	2012-10-18 00:00:00	\N	38000177		0	0	0		0	0	0	84007	0	996740	40222846		
60573	5037	40224805	1992-02-08	1992-02-08 00:00:00	1993-02-02	1993-02-02 00:00:00	1993-02-02	38000177		0	0	360		0	0	0	334720	0	1000126	40224805		
29288	2424	19006318	1964-03-05	1964-03-05 00:00:00	1964-03-19	1964-03-19 00:00:00	1964-03-19	38000177		0	0	14		0	0	0	160847	0	105078	19006318		
29327	2427	19133905	2007-09-06	2007-09-06 00:00:00	2007-09-15	2007-09-15 00:00:00	2007-09-15	38000177		0	0	9		0	0	0	161000	0	834102	19133905		
33456	2770	19075601	2018-12-15	2018-12-15 00:00:00	2018-12-15	2018-12-15 00:00:00	2018-12-15	38000177		0	0	0		0	0	0	183308	0	309362	19075601		
26419	2174	40229134	2000-08-02	2000-08-02 00:00:00	2000-08-09	2000-08-09 00:00:00	2000-08-09	38000177		0	0	7		0	0	0	144937	0	1043400	40229134		
39929	3304	19059056	1986-05-29	1986-05-29 00:00:00	1986-06-19	1986-06-19 00:00:00	1986-06-19	38000177		0	0	21		0	0	0	219486	0	243670	19059056		
39983	3308	19126352	1981-04-27	1981-04-27 00:00:00	1996-11-18	1996-11-18 00:00:00	1996-11-18	38000177		0	0	5684		0	0	0	219681	0	705129	19126352		
11102	924	19078461	1987-06-15	1987-06-15 00:00:00	1987-06-29	1987-06-29 00:00:00	1987-06-29	38000177		0	0	14		0	0	0	61540	0	310965	19078461		
11418	951	1118084	1985-10-15	1985-10-15 00:00:00	1985-10-15	1985-10-15 00:00:00	\N	38000177		0	0	0		0	0	0	63138	0	00025152531	44923712		
54550	4532	40174880	1964-04-03	1964-04-03 00:00:00	1964-04-03	1964-04-03 00:00:00	\N	38000177		0	0	0		0	0	0	301895	0	966222	40174880		
47130	3906	1124300	1984-04-28	1984-04-28 00:00:00	1984-04-28	1984-04-28 00:00:00	\N	38000177		0	0	0		0	0	0	259662	0	00781178901	45011828		
40735	887	40213227	1999-05-15	1999-05-15 00:00:00	1999-05-15	1999-05-15 00:00:00	1999-05-15	581452		0	0	0		0	0	0	59158	0	113	40213227		
5742	480	1127433	2002-08-20	2002-08-20 00:00:00	2002-09-03	2002-09-03 00:00:00	2002-09-03	38000177		0	0	14		0	0	0	32030	0	313782	1127433		
14119	304	40213227	1998-05-18	1998-05-18 00:00:00	1998-05-18	1998-05-18 00:00:00	1998-05-18	581452		0	0	0		0	0	0	20270	0	113	40213227		
8497	183	40213160	1979-10-04	1979-10-04 00:00:00	1979-10-04	1979-10-04 00:00:00	1979-10-04	581452		0	0	0		0	0	0	12380	0	10	40213160		
13428	1125	1127078	1956-07-20	1956-07-20 00:00:00	1956-08-03	1956-08-03 00:00:00	1956-08-03	38000177		0	0	14		0	0	0	74136	0	282464	1127078		
44755	974	40213227	2007-07-01	2007-07-01 00:00:00	2007-07-01	2007-07-01 00:00:00	2007-07-01	581452		0	0	0		0	0	0	64974	0	113	40213227		
42915	3558	40236824	1992-04-19	1992-04-19 00:00:00	1992-04-26	1992-04-26 00:00:00	1992-04-26	38000177		0	0	7		0	0	0	236219	0	1094107	40236824		
97567	2138	40213160	1959-08-09	1959-08-09 00:00:00	1959-08-09	1959-08-09 00:00:00	1959-08-09	581452		0	0	0		0	0	0	142444	0	10	40213160		
97635	2140	40213198	2016-08-31	2016-08-31 00:00:00	2016-08-31	2016-08-31 00:00:00	2016-08-31	581452		0	0	0		0	0	0	142543	0	133	40213198		
53795	4472	1127433	1987-02-03	1987-02-03 00:00:00	1987-02-17	1987-02-17 00:00:00	1987-02-17	38000177		0	0	14		0	0	0	297486	0	313782	1127433		
46503	1016	40213227	2018-06-20	2018-06-20 00:00:00	2018-06-20	2018-06-20 00:00:00	2018-06-20	581452		0	0	0		0	0	0	66882	0	113	40213227		
168017	3694	40213260	2007-04-10	2007-04-10 00:00:00	2007-04-10	2007-04-10 00:00:00	2007-04-10	581452		0	0	0		0	0	0	245492	0	121	40213260		
27878	2307	19059056	1967-05-06	1967-05-06 00:00:00	1967-05-20	1967-05-20 00:00:00	1967-05-20	38000177		0	0	14		0	0	0	153497	0	243670	19059056		
30959	2564	1127433	1995-12-15	1995-12-15 00:00:00	1996-01-05	1996-01-05 00:00:00	1996-01-05	38000177		0	0	21		0	0	0	169907	0	313782	1127433		
64197	5329	19059056	1946-10-03	1946-10-03 00:00:00	1946-10-24	1946-10-24 00:00:00	1946-10-24	38000177		0	0	21		0	0	0	354812	0	243670	19059056		
64	3	1539411	2012-09-24	2012-09-24 00:00:00	2012-09-24	2012-09-24 00:00:00	\N	38000177		0	0	0		0	0	0	277	0	312961	1539411		
17839	1478	1713671	1998-04-14	1998-04-14 00:00:00	1998-04-28	1998-04-28 00:00:00	1998-04-28	38000177		0	0	14		0	0	0	98654	0	562251	1713671		
10818	902	19075601	2011-05-21	2011-05-21 00:00:00	2011-05-21	2011-05-21 00:00:00	\N	38000177		0	0	0		0	0	0	60045	0	309362	19075601		
25719	2116	1713671	1966-04-15	1966-04-15 00:00:00	1966-04-29	1966-04-29 00:00:00	1966-04-29	38000177		0	0	14		0	0	0	140825	0	562251	1713671		
36245	2987	1127078	1979-05-21	1979-05-21 00:00:00	1979-08-19	1979-08-19 00:00:00	1979-08-19	38000177		0	0	90		0	0	0	199368	0	282464	1127078		
59625	4957	1127433	2003-09-05	2003-09-05 00:00:00	2003-09-12	2003-09-12 00:00:00	2003-09-12	38000177		0	0	7		0	0	0	329555	0	313782	1127433		
27456	2273	1118084	2016-05-03	2016-05-03 00:00:00	2016-05-03	2016-05-03 00:00:00	\N	38000177		0	0	0		0	0	0	151130	0	00025152531	44923712		
18414	1524	1127433	1988-02-23	1988-02-23 00:00:00	1988-03-01	1988-03-01 00:00:00	1988-03-01	38000177		0	0	7		0	0	0	101953	0	313782	1127433		
45737	3786	19059056	1962-11-18	1962-11-18 00:00:00	1962-12-02	1962-12-02 00:00:00	1962-12-02	38000177		0	0	14		0	0	0	251655	0	243670	19059056		
34193	747	40213160	1964-02-29	1964-02-29 00:00:00	1964-02-29	1964-02-29 00:00:00	1964-02-29	581452		0	0	0		0	0	0	49491	0	10	40213160		
19737	1623	1713671	1957-08-18	1957-08-18 00:00:00	1957-09-01	1957-09-01 00:00:00	1957-09-01	38000177		0	0	14		0	0	0	109117	0	562251	1713671		
27147	2238	1127433	2009-04-18	2009-04-18 00:00:00	2009-05-02	2009-05-02 00:00:00	2009-05-02	38000177		0	0	14		0	0	0	148930	0	313782	1127433		
56382	4677	19073188	2017-03-03	2017-03-03 00:00:00	2017-03-17	2017-03-17 00:00:00	2017-03-17	38000177		0	0	14		0	0	0	311698	0	308192	19073188		
37726	3118	19059056	1949-11-30	1949-11-30 00:00:00	1949-12-14	1949-12-14 00:00:00	1949-12-14	38000177		0	0	14		0	0	0	207530	0	243670	19059056		
20727	450	40213160	1967-07-17	1967-07-17 00:00:00	1967-07-17	1967-07-17 00:00:00	1967-07-17	581452		0	0	0		0	0	0	30039	0	10	40213160		
32477	2693	19133873	1961-04-17	1961-04-17 00:00:00	1961-04-24	1961-04-24 00:00:00	1961-04-24	38000177		0	0	7		0	0	0	178401	0	834061	19133873		
41266	3422	19074679	1980-01-14	1980-01-14 00:00:00	1980-01-14	1980-01-14 00:00:00	\N	38000177		0	0	0		0	0	0	226994	0	308971	19074679		
166560	3661	40213227	2009-12-13	2009-12-13 00:00:00	2009-12-13	2009-12-13 00:00:00	2009-12-13	581452		0	0	0		0	0	0	243675	0	113	40213227		
63228	5253	19129655	1961-01-12	1961-01-12 00:00:00	1961-01-26	1961-01-26 00:00:00	1961-01-26	38000177		0	0	14		0	0	0	349491	0	789980	19129655		
20867	1720	1127078	1981-06-01	1981-06-01 00:00:00	1981-06-15	1981-06-15 00:00:00	1981-06-15	38000177		0	0	14		0	0	0	115039	0	282464	1127078		
7429	621	1713671	1951-01-31	1951-01-31 00:00:00	1951-02-21	1951-02-21 00:00:00	1951-02-21	38000177		0	0	21		0	0	0	41451	0	562251	1713671		
4938	410	1115171	2004-08-09	2004-08-09 00:00:00	2004-08-23	2004-08-23 00:00:00	2004-08-23	38000177		0	0	14		0	0	0	27158	0	849574	1115171		
34303	2834	19126352	1948-05-08	1948-05-08 00:00:00	1999-12-04	1999-12-04 00:00:00	1999-12-04	38000177		0	0	18837		0	0	0	188149	0	705129	19126352		
11682	972	40220960	2019-01-30	2019-01-30 00:00:00	2019-01-30	2019-01-30 00:00:00	2019-01-30	38000177		0	0	0		0	0	0	64683	0	1804799	40220960		
23005	499	40213260	2009-05-22	2009-05-22 00:00:00	2009-05-22	2009-05-22 00:00:00	2009-05-22	581452		0	0	0		0	0	0	33407	0	121	40213260		
62581	5203	19133873	1949-11-23	1949-11-23 00:00:00	1949-12-03	1949-12-03 00:00:00	1949-12-03	38000177		0	0	10		0	0	0	346077	0	834061	19133873		
28616	2358	1127078	1977-10-04	1977-10-04 00:00:00	1977-10-18	1977-10-18 00:00:00	1977-10-18	38000177		0	0	14		0	0	0	157110	0	282464	1127078		
30749	670	40213296	2015-11-06	2015-11-06 00:00:00	2015-11-06	2015-11-06 00:00:00	2015-11-06	581452		0	0	0		0	0	0	44262	0	52	40213296		
14549	1219	19077572	2014-01-13	2014-01-13 00:00:00	2014-01-13	2014-01-13 00:00:00	\N	38000177		0	0	0		0	0	0	80233	0	310436	19077572		
1438	114	19128065	1988-02-28	1988-02-28 00:00:00	1989-02-22	1989-02-22 00:00:00	1989-02-22	38000177		0	0	360		0	0	0	7553	0	749882	19128065		
12296	1033	1115171	1995-02-05	1995-02-05 00:00:00	1995-03-05	1995-03-05 00:00:00	1995-03-05	38000177		0	0	28		0	0	0	67969	0	849574	1115171		
41428	3435	19128022	1996-03-16	1996-03-16 00:00:00	1997-03-11	1997-03-11 00:00:00	1997-03-11	38000177		0	0	360		0	0	0	227780	0	749785	19128022		
45932	3803	40236824	2002-05-10	2002-05-10 00:00:00	2002-05-17	2002-05-17 00:00:00	2002-05-17	38000177		0	0	7		0	0	0	252757	0	1094107	40236824		
63347	5262	19128022	1991-11-27	1991-11-27 00:00:00	1992-11-21	1992-11-21 00:00:00	1992-11-21	38000177		0	0	360		0	0	0	350126	0	749785	19128022		
22602	1854	19078461	1999-08-03	1999-08-03 00:00:00	1999-08-31	1999-08-31 00:00:00	1999-08-31	38000177		0	0	28		0	0	0	124132	0	310965	19078461		
43606	3614	19133873	1958-06-11	1958-06-11 00:00:00	1958-06-20	1958-06-20 00:00:00	1958-06-20	38000177		0	0	9		0	0	0	240136	0	834061	19133873		
50865	4226	40169281	2006-01-01	2006-01-01 00:00:00	2006-01-01	2006-01-01 00:00:00	\N	38000177		0	0	0		0	0	0	280709	0	896209	40169281		
15250	1273	19077572	2011-10-24	2011-10-24 00:00:00	2011-10-24	2011-10-24 00:00:00	\N	38000177		0	0	0		0	0	0	83993	0	310436	19077572		
60574	5037	19073183	1982-05-04	1982-05-04 00:00:00	1982-05-18	1982-05-18 00:00:00	1982-05-18	38000177		0	0	14		0	0	0	334739	0	308182	19073183		
29289	2424	19079524	1997-06-06	1997-06-06 00:00:00	1997-06-06	1997-06-06 00:00:00	1997-06-06	38000177		0	0	0		0	0	0	160819	0	313002	19079524		
29328	2427	1127433	1959-10-01	1959-10-01 00:00:00	1959-10-15	1959-10-15 00:00:00	1959-10-15	38000177		0	0	14		0	0	0	160980	0	313782	1127433		
33457	2770	1118084	1972-06-12	1972-06-12 00:00:00	1972-06-12	1972-06-12 00:00:00	\N	38000177		0	0	0		0	0	0	183276	0	00025152531	44923712		
26420	2174	1713671	2013-03-21	2013-03-21 00:00:00	2013-04-04	2013-04-04 00:00:00	2013-04-04	38000177		0	0	14		0	0	0	144938	0	562251	1713671		
39930	3304	19059056	1964-11-29	1964-11-29 00:00:00	1964-12-20	1964-12-20 00:00:00	1964-12-20	38000177		0	0	21		0	0	0	219483	0	243670	19059056		
39984	3308	19059056	1947-10-08	1947-10-08 00:00:00	1947-10-22	1947-10-22 00:00:00	1947-10-22	38000177		0	0	14		0	0	0	219672	0	243670	19059056		
11103	924	46233988	1969-06-28	1969-06-28 00:00:00	1969-07-12	1969-07-12 00:00:00	1969-07-12	38000177		0	0	14		0	0	0	61531	0	1652673	46233988		
11419	951	19006318	1954-11-17	1954-11-17 00:00:00	1954-12-01	1954-12-01 00:00:00	1954-12-01	38000177		0	0	14		0	0	0	63141	0	105078	19006318		
54551	4532	19059056	1912-10-17	1912-10-17 00:00:00	1912-10-31	1912-10-31 00:00:00	1912-10-31	38000177		0	0	14		0	0	0	301883	0	243670	19059056		
47131	3906	19133905	1982-04-01	1982-04-01 00:00:00	1982-04-12	1982-04-12 00:00:00	1982-04-12	38000177		0	0	11		0	0	0	259675	0	834102	19133905		
40736	887	40213296	1999-05-15	1999-05-15 00:00:00	1999-05-15	1999-05-15 00:00:00	1999-05-15	581452		0	0	0		0	0	0	59158	0	52	40213296		
22451	487	40213160	1966-01-26	1966-01-26 00:00:00	1966-01-26	1966-01-26 00:00:00	1966-01-26	581452		0	0	0		0	0	0	32538	0	10	40213160		
14122	304	40213296	1998-05-18	1998-05-18 00:00:00	1998-05-18	1998-05-18 00:00:00	1998-05-18	581452		0	0	0		0	0	0	20270	0	52	40213296		
8498	183	40213160	1975-04-03	1975-04-03 00:00:00	1975-04-03	1975-04-03 00:00:00	1975-04-03	581452		0	0	0		0	0	0	12377	0	10	40213160		
13429	1125	1127433	2006-02-24	2006-02-24 00:00:00	2006-03-10	2006-03-10 00:00:00	2006-03-10	38000177		0	0	14		0	0	0	74198	0	313782	1127433		
44756	974	40213260	2007-07-01	2007-07-01 00:00:00	2007-07-01	2007-07-01 00:00:00	2007-07-01	581452		0	0	0		0	0	0	64974	0	121	40213260		
42917	3558	40169281	2016-05-07	2016-05-07 00:00:00	2016-05-07	2016-05-07 00:00:00	\N	38000177		0	0	0		0	0	0	236238	0	896209	40169281		
97573	2138	40213296	1998-10-04	1998-10-04 00:00:00	1998-10-04	1998-10-04 00:00:00	1998-10-04	581452		0	0	0		0	0	0	142449	0	52	40213296		
31537	687	40213227	2018-03-03	2018-03-03 00:00:00	2018-03-03	2018-03-03 00:00:00	2018-03-03	581452		0	0	0		0	0	0	\N	0	113	40213227		
53796	4472	19133873	1938-10-26	1938-10-26 00:00:00	1938-11-07	1938-11-07 00:00:00	1938-11-07	38000177		0	0	12		0	0	0	297513	0	834061	19133873		
46505	1016	40213160	1968-02-21	1968-02-21 00:00:00	1968-02-21	1968-02-21 00:00:00	1968-02-21	581452		0	0	0		0	0	0	66869	0	10	40213160		
168020	3694	40213160	1961-06-27	1961-06-27 00:00:00	1961-06-27	1961-06-27 00:00:00	1961-06-27	581452		0	0	0		0	0	0	245500	0	10	40213160		
27879	2307	19128065	1978-09-21	1978-09-21 00:00:00	1979-09-16	1979-09-16 00:00:00	1979-09-16	38000177		0	0	360		0	0	0	153488	0	749882	19128065		
30960	2564	1118084	2018-12-24	2018-12-24 00:00:00	2018-12-24	2018-12-24 00:00:00	\N	38000177		0	0	0		0	0	0	169872	0	00025152531	44923712		
64198	5329	19078461	2000-09-22	2000-09-22 00:00:00	2000-10-06	2000-10-06 00:00:00	2000-10-06	38000177		0	0	14		0	0	0	354833	0	310965	19078461		
65	3	19075601	2012-09-24	2012-09-24 00:00:00	2012-09-24	2012-09-24 00:00:00	\N	38000177		0	0	0		0	0	0	277	0	309362	19075601		
17840	1478	1551192	1981-04-12	1981-04-12 00:00:00	1981-04-12	1981-04-12 00:00:00	1981-04-12	38000177		0	0	0		0	0	0	98641	0	312617	1551192		
10819	902	40165015	1968-01-15	1968-01-15 00:00:00	1968-01-15	1968-01-15 00:00:00	\N	38000177		0	0	0		0	0	0	60067	0	861467	40165015		
25720	2116	1115171	2006-10-25	2006-10-25 00:00:00	2006-11-08	2006-11-08 00:00:00	2006-11-08	38000177		0	0	14		0	0	0	140840	0	849574	1115171		
36246	2987	19019979	1975-08-10	1975-08-10 00:00:00	1975-08-24	1975-08-24 00:00:00	1975-08-24	38000177		0	0	14		0	0	0	199372	0	198405	19019979		
59626	4957	1118084	2004-05-16	2004-05-16 00:00:00	2004-05-16	2004-05-16 00:00:00	\N	38000177		0	0	0		0	0	0	329555	0	00025152531	44923712		
27457	2273	1127078	1994-05-24	1994-05-24 00:00:00	1994-06-21	1994-06-21 00:00:00	1994-06-21	38000177		0	0	28		0	0	0	151093	0	282464	1127078		
18415	1524	1118084	2004-02-17	2004-02-17 00:00:00	2004-02-17	2004-02-17 00:00:00	\N	38000177		0	0	0		0	0	0	101955	0	00025152531	44923712		
45738	3786	1127433	1982-07-13	1982-07-13 00:00:00	1982-07-27	1982-07-27 00:00:00	1982-07-27	38000177		0	0	14		0	0	0	251643	0	313782	1127433		
34198	747	40213260	2013-09-21	2013-09-21 00:00:00	2013-09-21	2013-09-21 00:00:00	2013-09-21	581452		0	0	0		0	0	0	49505	0	121	40213260		
19738	1623	1118084	1988-12-17	1988-12-17 00:00:00	1988-12-17	1988-12-17 00:00:00	\N	38000177		0	0	0		0	0	0	109126	0	00025152531	44923712		
27148	2238	1118084	2002-07-17	2002-07-17 00:00:00	2002-07-17	2002-07-17 00:00:00	\N	38000177		0	0	0		0	0	0	149020	0	00025152531	44923712		
56383	4677	1115171	2000-06-29	2000-06-29 00:00:00	2000-07-27	2000-07-27 00:00:00	2000-07-27	38000177		0	0	28		0	0	0	311724	0	849574	1115171		
37727	3118	19006318	1949-11-30	1949-11-30 00:00:00	1949-12-14	1949-12-14 00:00:00	1949-12-14	38000177		0	0	14		0	0	0	207530	0	105078	19006318		
32658	712	40213296	2018-08-16	2018-08-16 00:00:00	2018-08-16	2018-08-16 00:00:00	2018-08-16	581452		0	0	0		0	0	0	47266	0	52	40213296		
32478	2693	19128065	1981-08-24	1981-08-24 00:00:00	1982-08-19	1982-08-19 00:00:00	1982-08-19	38000177		0	0	360		0	0	0	178393	0	749882	19128065		
41267	3422	19008572	1993-12-24	1993-12-24 00:00:00	1993-12-24	1993-12-24 00:00:00	\N	38000177		0	0	0		0	0	0	226956	0	106258	19008572		
166565	3661	40213314	1978-05-21	1978-05-21 00:00:00	1978-05-21	1978-05-21 00:00:00	1978-05-21	581452		0	0	0		0	0	0	243624	0	49	40213314		
63229	5253	1127078	1961-01-12	1961-01-12 00:00:00	1961-01-26	1961-01-26 00:00:00	1961-01-26	38000177		0	0	14		0	0	0	349491	0	282464	1127078		
20868	1720	19074843	1981-06-01	1981-06-01 00:00:00	1981-06-15	1981-06-15 00:00:00	1981-06-15	38000177		0	0	14		0	0	0	115039	0	309045	19074843		
7430	621	1713671	1979-08-15	1979-08-15 00:00:00	1979-09-05	1979-09-05 00:00:00	1979-09-05	38000177		0	0	21		0	0	0	41434	0	562251	1713671		
4939	410	1713671	1996-03-02	1996-03-02 00:00:00	1996-03-16	1996-03-16 00:00:00	1996-03-16	38000177		0	0	14		0	0	0	27217	0	562251	1713671		
34304	2834	1539411	1991-07-13	1991-07-13 00:00:00	1991-07-13	1991-07-13 00:00:00	\N	38000177		0	0	0		0	0	0	188115	0	312961	1539411		
11683	972	19133905	2012-03-07	2012-03-07 00:00:00	2012-03-20	2012-03-20 00:00:00	2012-03-20	38000177		0	0	13		0	0	0	64709	0	834102	19133905		
23009	499	40213260	2010-01-01	2010-01-01 00:00:00	2010-01-01	2010-01-01 00:00:00	2010-01-01	581452		0	0	0		0	0	0	33354	0	121	40213260		
62582	5203	1545959	1999-02-17	1999-02-17 00:00:00	1999-02-17	1999-02-17 00:00:00	1999-02-17	38000177		0	0	0		0	0	0	346136	0	259255	1545959		
28617	2358	46233988	1977-10-04	1977-10-04 00:00:00	1977-10-18	1977-10-18 00:00:00	1977-10-18	38000177		0	0	14		0	0	0	157110	0	1652673	46233988		
34425	752	40213227	2007-12-23	2007-12-23 00:00:00	2007-12-23	2007-12-23 00:00:00	2007-12-23	581452		0	0	0		0	0	0	49666	0	113	40213227		
14550	1219	19059056	1968-03-01	1968-03-01 00:00:00	1968-04-05	1968-04-05 00:00:00	1968-04-05	38000177		0	0	35		0	0	0	80255	0	243670	19059056		
1439	115	19059056	1961-07-07	1961-07-07 00:00:00	1961-07-21	1961-07-21 00:00:00	1961-07-21	38000177		0	0	14		0	0	0	7579	0	243670	19059056		
12298	1033	19133873	1982-03-25	1982-03-25 00:00:00	1982-04-02	1982-04-02 00:00:00	1982-04-02	38000177		0	0	8		0	0	0	68012	0	834061	19133873		
41429	3435	1127078	1977-05-15	1977-05-15 00:00:00	1977-06-12	1977-06-12 00:00:00	1977-06-12	38000177		0	0	28		0	0	0	227832	0	282464	1127078		
45933	3803	19128065	1974-04-10	1974-04-10 00:00:00	1975-04-05	1975-04-05 00:00:00	1975-04-05	38000177		0	0	360		0	0	0	252770	0	749882	19128065		
63348	5262	19133905	2008-07-05	2008-07-05 00:00:00	2008-07-17	2008-07-17 00:00:00	2008-07-17	38000177		0	0	12		0	0	0	350079	0	834102	19133905		
22603	1855	1118084	2016-11-20	2016-11-20 00:00:00	2016-11-20	2016-11-20 00:00:00	\N	38000177		0	0	0		0	0	0	124190	0	00025152531	44923712		
43607	3614	1713671	1993-07-02	1993-07-02 00:00:00	1993-07-09	1993-07-09 00:00:00	1993-07-09	38000177		0	0	7		0	0	0	240113	0	562251	1713671		
50866	4226	1127433	1996-10-20	1996-10-20 00:00:00	1996-11-10	1996-11-10 00:00:00	1996-11-10	38000177		0	0	21		0	0	0	280776	0	313782	1127433		
15251	1273	40229134	1969-04-28	1969-04-28 00:00:00	1969-05-12	1969-05-12 00:00:00	1969-05-12	38000177		0	0	14		0	0	0	84016	0	1043400	40229134		
60575	5037	1127078	1982-05-04	1982-05-04 00:00:00	1982-05-18	1982-05-18 00:00:00	1982-05-18	38000177		0	0	14		0	0	0	334739	0	282464	1127078		
29290	2424	19016749	1997-06-06	1997-06-06 00:00:00	1997-06-06	1997-06-06 00:00:00	1997-06-06	38000177		0	0	0		0	0	0	160819	0	73032	19016749		
29329	2427	1118084	1984-12-23	1984-12-23 00:00:00	1984-12-23	1984-12-23 00:00:00	\N	38000177		0	0	0		0	0	0	161049	0	00025152531	44923712		
33458	2770	1551192	1948-02-04	1948-02-04 00:00:00	1948-02-04	1948-02-04 00:00:00	1948-02-04	38000177		0	0	0		0	0	0	183303	0	312617	1551192		
26421	2174	1713671	1978-03-16	1978-03-16 00:00:00	1978-04-06	1978-04-06 00:00:00	1978-04-06	38000177		0	0	21		0	0	0	144928	0	562251	1713671		
39931	3304	40229134	1984-10-17	1984-10-17 00:00:00	1984-10-31	1984-10-31 00:00:00	1984-10-31	38000177		0	0	14		0	0	0	219426	0	1043400	40229134		
39985	3308	19006318	1947-10-08	1947-10-08 00:00:00	1947-10-22	1947-10-22 00:00:00	1947-10-22	38000177		0	0	14		0	0	0	219672	0	105078	19006318		
11104	924	19059056	1969-06-28	1969-06-28 00:00:00	1969-07-12	1969-07-12 00:00:00	1969-07-12	38000177		0	0	14		0	0	0	61531	0	243670	19059056		
11420	951	1127078	1954-11-17	1954-11-17 00:00:00	1954-12-01	1954-12-01 00:00:00	1954-12-01	38000177		0	0	14		0	0	0	63141	0	282464	1127078		
54552	4532	19059056	1911-03-08	1911-03-08 00:00:00	1911-03-22	1911-03-22 00:00:00	1911-03-22	38000177		0	0	14		0	0	0	301860	0	243670	19059056		
47132	3906	1713671	1978-05-31	1978-05-31 00:00:00	1978-06-07	1978-06-07 00:00:00	1978-06-07	38000177		0	0	7		0	0	0	259674	0	562251	1713671		
40743	887	40213260	2009-01-03	2009-01-03 00:00:00	2009-01-03	2009-01-03 00:00:00	2009-01-03	581452		0	0	0		0	0	0	59135	0	121	40213260		
22454	487	40213260	2016-01-13	2016-01-13 00:00:00	2016-01-13	2016-01-13 00:00:00	2016-01-13	581452		0	0	0		0	0	0	32573	0	121	40213260		
14123	304	40213160	1956-10-15	1956-10-15 00:00:00	1956-10-15	1956-10-15 00:00:00	1956-10-15	581452		0	0	0		0	0	0	20261	0	10	40213160		
8500	183	40213227	2005-12-15	2005-12-15 00:00:00	2005-12-15	2005-12-15 00:00:00	2005-12-15	581452		0	0	0		0	0	0	12386	0	113	40213227		
13430	1125	1127433	1959-11-20	1959-11-20 00:00:00	1959-11-27	1959-11-27 00:00:00	1959-11-27	38000177		0	0	7		0	0	0	74202	0	313782	1127433		
23541	1937	40236824	2004-06-09	2004-06-09 00:00:00	2004-06-16	2004-06-16 00:00:00	2004-06-16	38000177		0	0	7		0	0	0	128888	0	1094107	40236824		
42918	3558	19133905	2010-02-06	2010-02-06 00:00:00	2010-02-16	2010-02-16 00:00:00	2010-02-16	38000177		0	0	10		0	0	0	236220	0	834102	19133905		
97575	2138	40213160	1955-03-20	1955-03-20 00:00:00	1955-03-20	1955-03-20 00:00:00	1955-03-20	581452		0	0	0		0	0	0	142391	0	10	40213160		
31544	687	40213296	2007-03-24	2007-03-24 00:00:00	2007-03-24	2007-03-24 00:00:00	2007-03-24	581452		0	0	0		0	0	0	45480	0	52	40213296		
53797	4472	19078461	2000-12-18	2000-12-18 00:00:00	2001-01-08	2001-01-08 00:00:00	2001-01-08	38000177		0	0	21		0	0	0	297545	0	310965	19078461		
46508	1016	40213227	1999-02-17	1999-02-17 00:00:00	1999-02-17	1999-02-17 00:00:00	1999-02-17	581452		0	0	0		0	0	0	66877	0	113	40213227		
168023	3694	40213296	1997-04-15	1997-04-15 00:00:00	1997-04-15	1997-04-15 00:00:00	1997-04-15	581452		0	0	0		0	0	0	245490	0	52	40213296		
27880	2307	1127433	2013-02-07	2013-02-07 00:00:00	2013-03-09	2013-03-09 00:00:00	2013-03-09	38000177		0	0	30		0	0	0	153485	0	313782	1127433		
30961	2564	42902245	1999-07-02	1999-07-02 00:00:00	2000-06-26	2000-06-26 00:00:00	2000-06-26	38000177		0	0	360		0	0	0	169854	0	1359133	42902245		
64199	5329	1127433	1960-05-12	1960-05-12 00:00:00	1960-05-19	1960-05-19 00:00:00	1960-05-19	38000177		0	0	7		0	0	0	354744	0	313782	1127433		
66	3	1332419	2012-09-24	2012-09-24 00:00:00	2012-09-24	2012-09-24 00:00:00	\N	38000177		0	0	0		0	0	0	277	0	197361	1332419		
17841	1478	19133873	1969-11-01	1969-11-01 00:00:00	1969-11-14	1969-11-14 00:00:00	1969-11-14	38000177		0	0	13		0	0	0	98612	0	834061	19133873		
10820	902	19059056	1968-01-15	1968-01-15 00:00:00	1968-02-14	1968-02-14 00:00:00	1968-02-14	38000177		0	0	30		0	0	0	60067	0	243670	19059056		
25721	2116	1118084	1990-10-04	1990-10-04 00:00:00	1990-10-04	1990-10-04 00:00:00	\N	38000177		0	0	0		0	0	0	140805	0	00025152531	44923712		
36247	2987	19129655	1975-08-10	1975-08-10 00:00:00	1975-08-24	1975-08-24 00:00:00	1975-08-24	38000177		0	0	14		0	0	0	199372	0	789980	19129655		
59627	4957	1115171	2019-06-20	2019-06-20 00:00:00	2019-06-20	2019-06-20 00:00:00	\N	38000177		0	0	0		0	0	0	329512	0	849574	1115171		
27458	2273	1713671	2010-08-03	2010-08-03 00:00:00	2010-08-17	2010-08-17 00:00:00	2010-08-17	38000177		0	0	14		0	0	0	151097	0	562251	1713671		
18416	1524	19133905	2003-04-19	2003-04-19 00:00:00	2003-04-30	2003-04-30 00:00:00	2003-04-30	38000177		0	0	11		0	0	0	101955	0	834102	19133905		
45739	3786	920300	1988-01-17	1988-01-17 00:00:00	1988-01-24	1988-01-24 00:00:00	1988-01-24	38000177		0	0	7		0	0	0	251714	0	311989	920300		
34202	747	40213227	2014-09-27	2014-09-27 00:00:00	2014-09-27	2014-09-27 00:00:00	2014-09-27	581452		0	0	0		0	0	0	49466	0	113	40213227		
19744	1626	1118084	1970-01-10	1970-01-10 00:00:00	1970-01-10	1970-01-10 00:00:00	\N	38000177		0	0	0		0	0	0	109228	0	00025152531	44923712		
27149	2238	19078461	1989-01-16	1989-01-16 00:00:00	1989-02-20	1989-02-20 00:00:00	1989-02-20	38000177		0	0	35		0	0	0	148927	0	310965	19078461		
56384	4677	19073188	2000-06-29	2000-06-29 00:00:00	2000-07-27	2000-07-27 00:00:00	2000-07-27	38000177		0	0	28		0	0	0	311724	0	308192	19073188		
37729	3118	19059056	1956-07-26	1956-07-26 00:00:00	1956-08-16	1956-08-16 00:00:00	1956-08-16	38000177		0	0	21		0	0	0	207401	0	243670	19059056		
32661	712	40213160	1979-10-18	1979-10-18 00:00:00	1979-10-18	1979-10-18 00:00:00	1979-10-18	581452		0	0	0		0	0	0	47213	0	10	40213160		
32479	2693	19128065	1978-09-09	1978-09-09 00:00:00	1979-09-04	1979-09-04 00:00:00	1979-09-04	38000177		0	0	360		0	0	0	178392	0	749882	19128065		
41268	3422	1127433	1990-01-22	1990-01-22 00:00:00	1990-02-05	1990-02-05 00:00:00	1990-02-05	38000177		0	0	14		0	0	0	226984	0	313782	1127433		
166566	3661	40213160	1978-05-21	1978-05-21 00:00:00	1978-05-21	1978-05-21 00:00:00	1978-05-21	581452		0	0	0		0	0	0	243624	0	10	40213160		
63230	5253	920334	1995-01-19	1995-01-19 00:00:00	1995-01-26	1995-01-26 00:00:00	1995-01-26	38000177		0	0	7		0	0	0	349485	0	311995	920334		
20869	1720	1713671	1980-11-20	1980-11-20 00:00:00	1980-12-04	1980-12-04 00:00:00	1980-12-04	38000177		0	0	14		0	0	0	115029	0	562251	1713671		
7431	621	19059056	1922-12-27	1922-12-27 00:00:00	1923-01-24	1923-01-24 00:00:00	1923-01-24	38000177		0	0	28		0	0	0	41486	0	243670	19059056		
4940	410	1713671	2010-05-31	2010-05-31 00:00:00	2010-06-14	2010-06-14 00:00:00	2010-06-14	38000177		0	0	14		0	0	0	27175	0	562251	1713671		
34305	2834	19059056	1941-10-17	1941-10-17 00:00:00	1941-10-31	1941-10-31 00:00:00	1941-10-31	38000177		0	0	14		0	0	0	188127	0	243670	19059056		
11685	972	1127433	2008-09-20	2008-09-20 00:00:00	2008-10-04	2008-10-04 00:00:00	2008-10-04	38000177		0	0	14		0	0	0	64723	0	313782	1127433		
23011	499	40213227	2011-01-07	2011-01-07 00:00:00	2011-01-07	2011-01-07 00:00:00	2011-01-07	581452		0	0	0		0	0	0	33408	0	113	40213227		
5375	117	40213160	1969-01-11	1969-01-11 00:00:00	1969-01-11	1969-01-11 00:00:00	1969-01-11	581452		0	0	0		0	0	0	7807	0	10	40213160		
28618	2358	1127433	1984-07-29	1984-07-29 00:00:00	1984-08-19	1984-08-19 00:00:00	1984-08-19	38000177		0	0	21		0	0	0	157130	0	313782	1127433		
34428	752	40213201	2012-11-18	2012-11-18 00:00:00	2012-11-18	2012-11-18 00:00:00	2012-11-18	581452		0	0	0		0	0	0	49696	0	33	40213201		
14551	1219	19133873	1942-11-14	1942-11-14 00:00:00	1942-11-25	1942-11-25 00:00:00	1942-11-25	38000177		0	0	11		0	0	0	80208	0	834061	19133873		
1440	115	19133905	1983-11-08	1983-11-08 00:00:00	1983-11-15	1983-11-15 00:00:00	1983-11-15	38000177		0	0	7		0	0	0	7615	0	834102	19133905		
12300	1033	1127433	1974-07-22	1974-07-22 00:00:00	1974-08-05	1974-08-05 00:00:00	1974-08-05	38000177		0	0	14		0	0	0	67970	0	313782	1127433		
41430	3435	1115171	2018-04-27	2018-04-27 00:00:00	2018-05-27	2018-05-27 00:00:00	2018-05-27	38000177		0	0	30		0	0	0	227830	0	849574	1115171		
45934	3803	19059056	1961-12-04	1961-12-04 00:00:00	1961-12-18	1961-12-18 00:00:00	1961-12-18	38000177		0	0	14		0	0	0	252809	0	243670	19059056		
63349	5262	40229134	2012-08-23	2012-08-23 00:00:00	2012-09-06	2012-09-06 00:00:00	2012-09-06	38000177		0	0	14		0	0	0	350123	0	1043400	40229134		
22604	1855	1127433	1991-12-27	1991-12-27 00:00:00	1992-01-10	1992-01-10 00:00:00	1992-01-10	38000177		0	0	14		0	0	0	124139	0	313782	1127433		
43608	3614	19077572	2004-07-25	2004-07-25 00:00:00	2004-07-25	2004-07-25 00:00:00	\N	38000177		0	0	0		0	0	0	240067	0	310436	19077572		
50867	4226	40232448	1964-12-08	1964-12-08 00:00:00	1964-12-08	1964-12-08 00:00:00	\N	38000177		0	0	0		0	0	0	280649	0	1049630	40232448		
15252	1273	1713671	1977-06-05	1977-06-05 00:00:00	1977-06-26	1977-06-26 00:00:00	1977-06-26	38000177		0	0	21		0	0	0	84018	0	562251	1713671		
60576	5037	1127078	1977-11-13	1977-11-13 00:00:00	1977-11-27	1977-11-27 00:00:00	1977-11-27	38000177		0	0	14		0	0	0	334775	0	282464	1127078		
29291	2424	46275444	1997-06-06	1997-06-06 00:00:00	1997-06-06	1997-06-06 00:00:00	1997-06-06	38000177		0	0	0		0	0	0	160819	0	1659149	46275444		
29330	2428	1127433	2008-02-28	2008-02-28 00:00:00	2008-03-06	2008-03-06 00:00:00	2008-03-06	38000177		0	0	7		0	0	0	161103	0	313782	1127433		
33459	2771	1127433	1913-07-30	1913-07-30 00:00:00	1913-08-06	1913-08-06 00:00:00	1913-08-06	38000177		0	0	7		0	0	0	183415	0	313782	1127433		
26422	2174	1713671	1996-06-26	1996-06-26 00:00:00	1996-07-10	1996-07-10 00:00:00	1996-07-10	38000177		0	0	14		0	0	0	144930	0	562251	1713671		
39932	3304	19133905	1985-10-13	1985-10-13 00:00:00	1985-10-21	1985-10-21 00:00:00	1985-10-21	38000177		0	0	8		0	0	0	219450	0	834102	19133905		
39992	3311	1127433	1979-01-15	1979-01-15 00:00:00	1979-01-29	1979-01-29 00:00:00	1979-01-29	38000177		0	0	14		0	0	0	219798	0	313782	1127433		
11105	924	1713671	1971-04-08	1971-04-08 00:00:00	1971-04-22	1971-04-22 00:00:00	1971-04-22	38000177		0	0	14		0	0	0	61546	0	562251	1713671		
11421	951	40229134	1971-11-20	1971-11-20 00:00:00	1971-12-04	1971-12-04 00:00:00	1971-12-04	38000177		0	0	14		0	0	0	63136	0	1043400	40229134		
54553	4532	19133873	1912-02-07	1912-02-07 00:00:00	1912-02-14	1912-02-14 00:00:00	1912-02-14	38000177		0	0	7		0	0	0	301913	0	834061	19133873		
47133	3906	40173590	2012-10-31	2012-10-31 00:00:00	2012-10-31	2012-10-31 00:00:00	\N	38000177		0	0	0		0	0	0	259712	0	904419	40173590		
40753	887	40213306	1982-04-24	1982-04-24 00:00:00	1982-04-24	1982-04-24 00:00:00	1982-04-24	581452		0	0	0		0	0	0	59132	0	43	40213306		
22460	487	40213227	1998-12-09	1998-12-09 00:00:00	1998-12-09	1998-12-09 00:00:00	1998-12-09	581452		0	0	0		0	0	0	32612	0	113	40213227		
14130	304	40213227	2007-09-24	2007-09-24 00:00:00	2007-09-24	2007-09-24 00:00:00	2007-09-24	581452		0	0	0		0	0	0	20235	0	113	40213227		
8501	183	40213160	1975-01-30	1975-01-30 00:00:00	1975-01-30	1975-01-30 00:00:00	1975-01-30	581452		0	0	0		0	0	0	12395	0	10	40213160		
13431	1125	19078461	2014-07-30	2014-07-30 00:00:00	2014-08-29	2014-08-29 00:00:00	2014-08-29	38000177		0	0	30		0	0	0	74138	0	310965	19078461		
23542	1937	1118084	2001-03-25	2001-03-25 00:00:00	2001-03-25	2001-03-25 00:00:00	\N	38000177		0	0	0		0	0	0	128884	0	00025152531	44923712		
42919	3558	1127433	1964-02-02	1964-02-02 00:00:00	1964-02-09	1964-02-09 00:00:00	1964-02-09	38000177		0	0	7		0	0	0	236218	0	313782	1127433		
97579	2138	40213227	2016-07-24	2016-07-24 00:00:00	2016-07-24	2016-07-24 00:00:00	2016-07-24	581452		0	0	0		0	0	0	142370	0	113	40213227		
31547	687	40213227	1999-03-13	1999-03-13 00:00:00	1999-03-13	1999-03-13 00:00:00	1999-03-13	581452		0	0	0		0	0	0	45549	0	113	40213227		
53798	4472	1124300	1975-03-19	1975-03-19 00:00:00	1975-03-19	1975-03-19 00:00:00	\N	38000177		0	0	0		0	0	0	297526	0	00781178901	45011828		
46512	1016	40213227	2009-06-24	2009-06-24 00:00:00	2009-06-24	2009-06-24 00:00:00	2009-06-24	581452		0	0	0		0	0	0	66916	0	113	40213227		
168030	3694	40213227	2018-09-25	2018-09-25 00:00:00	2018-09-25	2018-09-25 00:00:00	2018-09-25	581452		0	0	0		0	0	0	245556	0	113	40213227		
27881	2307	19128065	1979-09-16	1979-09-16 00:00:00	1980-09-10	1980-09-10 00:00:00	1980-09-10	38000177		0	0	360		0	0	0	153489	0	749882	19128065		
30962	2564	40229134	2002-09-24	2002-09-24 00:00:00	2002-10-08	2002-10-08 00:00:00	2002-10-08	38000177		0	0	14		0	0	0	169836	0	1043400	40229134		
64200	5329	40236824	1991-01-10	1991-01-10 00:00:00	1991-01-17	1991-01-17 00:00:00	1991-01-17	38000177		0	0	7		0	0	0	354781	0	1094107	40236824		
67	3	1713671	1956-12-15	1956-12-15 00:00:00	1956-12-29	1956-12-29 00:00:00	1956-12-29	38000177		0	0	14		0	0	0	262	0	562251	1713671		
17842	1478	1127433	1997-12-22	1997-12-22 00:00:00	1997-12-29	1997-12-29 00:00:00	1997-12-29	38000177		0	0	7		0	0	0	98632	0	313782	1127433		
10821	902	1127433	1973-12-30	1973-12-30 00:00:00	1974-01-06	1974-01-06 00:00:00	1974-01-06	38000177		0	0	7		0	0	0	60036	0	313782	1127433		
25722	2116	1127433	1965-02-04	1965-02-04 00:00:00	1965-02-11	1965-02-11 00:00:00	1965-02-11	38000177		0	0	7		0	0	0	140790	0	313782	1127433		
36248	2987	1118084	2015-05-02	2015-05-02 00:00:00	2015-05-02	2015-05-02 00:00:00	\N	38000177		0	0	0		0	0	0	199367	0	00025152531	44923712		
59628	4957	1713671	1978-05-06	1978-05-06 00:00:00	1978-05-20	1978-05-20 00:00:00	1978-05-20	38000177		0	0	14		0	0	0	329514	0	562251	1713671		
27459	2273	1713671	1997-05-28	1997-05-28 00:00:00	1997-07-02	1997-07-02 00:00:00	1997-07-02	38000177		0	0	35		0	0	0	151086	0	562251	1713671		
18418	1525	1127078	1966-09-28	1966-09-28 00:00:00	1966-10-12	1966-10-12 00:00:00	1966-10-12	38000177		0	0	14		0	0	0	102008	0	282464	1127078		
45740	3786	40236824	1988-01-17	1988-01-17 00:00:00	1988-01-24	1988-01-24 00:00:00	1988-01-24	38000177		0	0	7		0	0	0	251714	0	1094107	40236824		
34203	747	40213260	2014-09-27	2014-09-27 00:00:00	2014-09-27	2014-09-27 00:00:00	2014-09-27	581452		0	0	0		0	0	0	49466	0	121	40213260		
19745	1626	19126352	2006-10-29	2006-10-29 00:00:00	2006-10-29	2006-10-29 00:00:00	\N	38000177		0	0	0		0	0	0	109219	0	705129	19126352		
27169	2240	1127433	1987-07-01	1987-07-01 00:00:00	1987-09-29	1987-09-29 00:00:00	1987-09-29	38000177		0	0	90		0	0	0	149136	0	313782	1127433		
56385	4677	19133873	1965-10-18	1965-10-18 00:00:00	1965-10-26	1965-10-26 00:00:00	1965-10-26	38000177		0	0	8		0	0	0	311643	0	834061	19133873		
37730	3118	1713671	1966-05-09	1966-05-09 00:00:00	1966-05-16	1966-05-16 00:00:00	1966-05-16	38000177		0	0	7		0	0	0	207434	0	562251	1713671		
32664	712	40213160	1975-07-17	1975-07-17 00:00:00	1975-07-17	1975-07-17 00:00:00	1975-07-17	581452		0	0	0		0	0	0	47249	0	10	40213160		
32480	2693	1127433	1995-10-15	1995-10-15 00:00:00	1995-10-22	1995-10-22 00:00:00	1995-10-22	38000177		0	0	7		0	0	0	178428	0	313782	1127433		
41269	3422	19074679	1978-12-16	1978-12-16 00:00:00	1979-06-30	1979-06-30 00:00:00	1979-06-30	38000177		0	0	196		0	0	0	226981	0	308971	19074679		
166572	3661	40213160	1982-09-19	1982-09-19 00:00:00	1982-09-19	1982-09-19 00:00:00	1982-09-19	581452		0	0	0		0	0	0	\N	0	10	40213160		
63231	5253	19078461	2011-01-18	2011-01-18 00:00:00	2011-02-01	2011-02-01 00:00:00	2011-02-01	38000177		0	0	14		0	0	0	349574	0	310965	19078461		
20870	1720	19078461	2007-10-30	2007-10-30 00:00:00	2007-12-04	2007-12-04 00:00:00	2007-12-04	38000177		0	0	35		0	0	0	115002	0	310965	19078461		
7432	621	19133873	1926-04-21	1926-04-21 00:00:00	1926-04-29	1926-04-29 00:00:00	1926-04-29	38000177		0	0	8		0	0	0	41447	0	834061	19133873		
4942	410	1127433	1982-10-17	1982-10-17 00:00:00	1982-10-31	1982-10-31 00:00:00	1982-10-31	38000177		0	0	14		0	0	0	27198	0	313782	1127433		
34306	2834	1118084	1972-01-06	1972-01-06 00:00:00	1972-01-06	1972-01-06 00:00:00	\N	38000177		0	0	0		0	0	0	188163	0	00025152531	44923712		
11686	972	1713671	2014-09-15	2014-09-15 00:00:00	2014-10-06	2014-10-06 00:00:00	2014-10-06	38000177		0	0	21		0	0	0	64710	0	562251	1713671		
23016	499	40213160	1959-07-31	1959-07-31 00:00:00	1959-07-31	1959-07-31 00:00:00	1959-07-31	581452		0	0	0		0	0	0	33306	0	10	40213160		
5379	117	40213160	1969-03-15	1969-03-15 00:00:00	1969-03-15	1969-03-15 00:00:00	1969-03-15	581452		0	0	0		0	0	0	7788	0	10	40213160		
28619	2358	1127433	1986-04-22	1986-04-22 00:00:00	1986-05-06	1986-05-06 00:00:00	1986-05-06	38000177		0	0	14		0	0	0	157133	0	313782	1127433		
34434	752	40213227	2017-12-10	2017-12-10 00:00:00	2017-12-10	2017-12-10 00:00:00	2017-12-10	581452		0	0	0		0	0	0	49699	0	113	40213227		
14552	1219	1127433	1949-01-19	1949-01-19 00:00:00	1949-02-02	1949-02-02 00:00:00	1949-02-02	38000177		0	0	14		0	0	0	80209	0	313782	1127433		
1441	115	1127433	2001-06-30	2001-06-30 00:00:00	2001-07-14	2001-07-14 00:00:00	2001-07-14	38000177		0	0	14		0	0	0	7576	0	313782	1127433		
12301	1033	19133873	1984-01-28	1984-01-28 00:00:00	1984-02-06	1984-02-06 00:00:00	1984-02-06	38000177		0	0	9		0	0	0	67972	0	834061	19133873		
41431	3435	19128022	1997-03-11	1997-03-11 00:00:00	1998-03-06	1998-03-06 00:00:00	1998-03-06	38000177		0	0	360		0	0	0	227781	0	749785	19128022		
45935	3803	19006318	1961-12-04	1961-12-04 00:00:00	1961-12-18	1961-12-18 00:00:00	1961-12-18	38000177		0	0	14		0	0	0	252809	0	105078	19006318		
63350	5262	1713671	1993-10-31	1993-10-31 00:00:00	1993-11-21	1993-11-21 00:00:00	1993-11-21	38000177		0	0	21		0	0	0	350085	0	562251	1713671		
22605	1855	1127433	2016-10-31	2016-10-31 00:00:00	2016-11-14	2016-11-14 00:00:00	2016-11-14	38000177		0	0	14		0	0	0	124171	0	313782	1127433		
43609	3614	40169281	2004-07-25	2004-07-25 00:00:00	2004-07-25	2004-07-25 00:00:00	\N	38000177		0	0	0		0	0	0	240067	0	896209	40169281		
50868	4226	1127078	1965-08-04	1965-08-04 00:00:00	1965-08-18	1965-08-18 00:00:00	1965-08-18	38000177		0	0	14		0	0	0	280741	0	282464	1127078		
15265	1276	1127433	2015-09-14	2015-09-14 00:00:00	2015-09-28	2015-09-28 00:00:00	2015-09-28	38000177		0	0	14		0	0	0	84136	0	313782	1127433		
60579	5039	1127433	1979-12-25	1979-12-25 00:00:00	1980-01-01	1980-01-01 00:00:00	1980-01-01	38000177		0	0	7		0	0	0	334855	0	313782	1127433		
29292	2424	1127078	1967-11-02	1967-11-02 00:00:00	1967-11-16	1967-11-16 00:00:00	1967-11-16	38000177		0	0	14		0	0	0	160821	0	282464	1127078		
29331	2428	19128065	1989-06-16	1989-06-16 00:00:00	1990-06-11	1990-06-11 00:00:00	1990-06-11	38000177		0	0	360		0	0	0	161069	0	749882	19128065		
33460	2771	40171902	1981-02-06	1981-02-06 00:00:00	1981-02-06	1981-02-06 00:00:00	\N	38000177		0	0	0		0	0	0	183479	0	897718	40171902		
26423	2174	1127433	1991-06-03	1991-06-03 00:00:00	1991-06-17	1991-06-17 00:00:00	1991-06-17	38000177		0	0	14		0	0	0	144935	0	313782	1127433		
39933	3304	19133905	1998-11-27	1998-11-27 00:00:00	1998-12-08	1998-12-08 00:00:00	1998-12-08	38000177		0	0	11		0	0	0	219463	0	834102	19133905		
39993	3311	1118084	1995-07-05	1995-07-05 00:00:00	1995-07-05	1995-07-05 00:00:00	\N	38000177		0	0	0		0	0	0	219824	0	00025152531	44923712		
11106	925	40169281	2014-10-03	2014-10-03 00:00:00	2014-10-03	2014-10-03 00:00:00	\N	38000177		0	0	0		0	0	0	61605	0	896209	40169281		
11422	951	19078461	2019-01-22	2019-01-22 00:00:00	2019-02-26	2019-02-26 00:00:00	2019-02-26	38000177		0	0	35		0	0	0	63222	0	310965	19078461		
54554	4532	19059056	1911-07-20	1911-07-20 00:00:00	1911-08-03	1911-08-03 00:00:00	1911-08-03	38000177		0	0	14		0	0	0	301898	0	243670	19059056		
47134	3906	19059056	1989-09-14	1989-09-14 00:00:00	1989-10-19	1989-10-19 00:00:00	1989-10-19	38000177		0	0	35		0	0	0	259752	0	243670	19059056		
40754	887	40213160	1958-06-21	1958-06-21 00:00:00	1958-06-21	1958-06-21 00:00:00	1958-06-21	581452		0	0	0		0	0	0	59140	0	10	40213160		
22462	487	40213306	1987-12-02	1987-12-02 00:00:00	1987-12-02	1987-12-02 00:00:00	1987-12-02	581452		0	0	0		0	0	0	32571	0	43	40213306		
14131	304	40213260	2007-09-24	2007-09-24 00:00:00	2007-09-24	2007-09-24 00:00:00	2007-09-24	581452		0	0	0		0	0	0	20235	0	121	40213260		
8505	183	40213306	1996-12-05	1996-12-05 00:00:00	1996-12-05	1996-12-05 00:00:00	1996-12-05	581452		0	0	0		0	0	0	12402	0	43	40213306		
13432	1125	40165015	2014-07-30	2014-07-30 00:00:00	2014-07-30	2014-07-30 00:00:00	\N	38000177		0	0	0		0	0	0	74138	0	861467	40165015		
13196	1107	1127433	1979-07-28	1979-07-28 00:00:00	1979-08-25	1979-08-25 00:00:00	1979-08-25	38000177		0	0	28		0	0	0	72855	0	313782	1127433		
42920	3558	19059056	1961-01-16	1961-01-16 00:00:00	1961-01-30	1961-01-30 00:00:00	1961-01-30	38000177		0	0	14		0	0	0	236229	0	243670	19059056		
97585	2138	40213160	1955-06-19	1955-06-19 00:00:00	1955-06-19	1955-06-19 00:00:00	1955-06-19	581452		0	0	0		0	0	0	142425	0	10	40213160		
31548	687	40213296	2009-03-28	2009-03-28 00:00:00	2009-03-28	2009-03-28 00:00:00	2009-03-28	581452		0	0	0		0	0	0	45466	0	52	40213296		
53799	4472	19059056	1940-02-07	1940-02-07 00:00:00	1940-02-21	1940-02-21 00:00:00	1940-02-21	38000177		0	0	14		0	0	0	297535	0	243670	19059056		
46513	1016	40213296	2009-06-24	2009-06-24 00:00:00	2009-06-24	2009-06-24 00:00:00	2009-06-24	581452		0	0	0		0	0	0	66916	0	52	40213296		
168032	3694	40213160	1957-09-17	1957-09-17 00:00:00	1957-09-17	1957-09-17 00:00:00	1957-09-17	581452		0	0	0		0	0	0	245529	0	10	40213160		
27882	2307	1127078	1972-03-09	1972-03-09 00:00:00	1972-03-23	1972-03-23 00:00:00	1972-03-23	38000177		0	0	14		0	0	0	153483	0	282464	1127078		
30963	2564	1127433	1993-08-23	1993-08-23 00:00:00	1993-09-06	1993-09-06 00:00:00	1993-09-06	38000177		0	0	14		0	0	0	169851	0	313782	1127433		
64201	5329	920300	1991-01-10	1991-01-10 00:00:00	1991-01-17	1991-01-17 00:00:00	1991-01-17	38000177		0	0	7		0	0	0	354781	0	311989	920300		
257	18	19128065	1979-11-14	1979-11-14 00:00:00	1980-11-08	1980-11-08 00:00:00	1980-11-08	38000177		0	0	360		0	0	0	1409	0	749882	19128065		
17843	1478	1118084	2001-12-26	2001-12-26 00:00:00	2001-12-26	2001-12-26 00:00:00	\N	38000177		0	0	0		0	0	0	98643	0	00025152531	44923712		
10842	905	19133873	1972-01-18	1972-01-18 00:00:00	1972-01-29	1972-01-29 00:00:00	1972-01-29	38000177		0	0	11		0	0	0	60198	0	834061	19133873		
25723	2116	19077572	2018-02-19	2018-02-19 00:00:00	2018-02-19	2018-02-19 00:00:00	\N	38000177		0	0	0		0	0	0	140839	0	310436	19077572		
7799	652	46233988	1973-10-01	1973-10-01 00:00:00	1973-10-15	1973-10-15 00:00:00	1973-10-15	38000177		0	0	14		0	0	0	43163	0	1652673	46233988		
59629	4957	1127433	2009-09-30	2009-09-30 00:00:00	2009-10-07	2009-10-07 00:00:00	2009-10-07	38000177		0	0	7		0	0	0	329534	0	313782	1127433		
27460	2274	19078461	1997-11-22	1997-11-22 00:00:00	1997-12-13	1997-12-13 00:00:00	1997-12-13	38000177		0	0	21		0	0	0	151210	0	310965	19078461		
18419	1525	40162522	1993-08-23	1993-08-23 00:00:00	1993-08-23	1993-08-23 00:00:00	\N	38000177		0	0	0		0	0	0	102031	0	857005	40162522		
45741	3787	1332419	2013-04-13	2013-04-13 00:00:00	2013-04-13	2013-04-13 00:00:00	\N	38000177		0	0	0		0	0	0	251748	0	197361	1332419		
34206	747	40213160	1964-05-30	1964-05-30 00:00:00	1964-05-30	1964-05-30 00:00:00	1964-05-30	581452		0	0	0		0	0	0	49447	0	10	40213160		
19746	1626	1332419	2006-10-29	2006-10-29 00:00:00	2006-10-29	2006-10-29 00:00:00	\N	38000177		0	0	0		0	0	0	109219	0	197361	1332419		
27170	2240	1127433	2004-09-16	2004-09-16 00:00:00	2004-09-23	2004-09-23 00:00:00	2004-09-23	38000177		0	0	7		0	0	0	149100	0	313782	1127433		
56386	4678	1127433	1974-01-06	1974-01-06 00:00:00	1974-01-13	1974-01-13 00:00:00	1974-01-13	38000177		0	0	7		0	0	0	311739	0	313782	1127433		
37731	3118	19133873	1950-10-15	1950-10-15 00:00:00	1950-10-24	1950-10-24 00:00:00	1950-10-24	38000177		0	0	9		0	0	0	207482	0	834061	19133873		
32667	712	40213160	1975-02-13	1975-02-13 00:00:00	1975-02-13	1975-02-13 00:00:00	1975-02-13	581452		0	0	0		0	0	0	47228	0	10	40213160		
32481	2693	1127433	2006-03-27	2006-03-27 00:00:00	2006-04-17	2006-04-17 00:00:00	2006-04-17	38000177		0	0	21		0	0	0	178366	0	313782	1127433		
41270	3422	1127433	2006-08-18	2006-08-18 00:00:00	2006-09-01	2006-09-01 00:00:00	2006-09-01	38000177		0	0	14		0	0	0	227028	0	313782	1127433		
166579	3661	40213160	1978-07-23	1978-07-23 00:00:00	1978-07-23	1978-07-23 00:00:00	1978-07-23	581452		0	0	0		0	0	0	243633	0	10	40213160		
63232	5253	40236824	1995-01-12	1995-01-12 00:00:00	1995-01-26	1995-01-26 00:00:00	1995-01-26	38000177		0	0	14		0	0	0	349544	0	1094107	40236824		
20871	1720	1127433	1998-03-21	1998-03-21 00:00:00	1998-06-19	1998-06-19 00:00:00	1998-06-19	38000177		0	0	90		0	0	0	115001	0	313782	1127433		
7433	621	1124300	1953-11-29	1953-11-29 00:00:00	1953-11-29	1953-11-29 00:00:00	\N	38000177		0	0	0		0	0	0	41372	0	00781178901	45011828		
4943	410	1127433	2010-09-26	2010-09-26 00:00:00	2010-10-10	2010-10-10 00:00:00	2010-10-10	38000177		0	0	14		0	0	0	27219	0	313782	1127433		
34307	2834	19133768	1999-12-04	1999-12-04 00:00:00	1999-12-04	1999-12-04 00:00:00	1999-12-04	38000177		0	0	0		0	0	0	188165	0	833036	19133768		
11687	972	19059056	1971-04-25	1971-04-25 00:00:00	1971-05-09	1971-05-09 00:00:00	1971-05-09	38000177		0	0	14		0	0	0	64663	0	243670	19059056		
23023	499	40213227	1993-07-23	1993-07-23 00:00:00	1993-07-23	1993-07-23 00:00:00	1993-07-23	581452		0	0	0		0	0	0	33351	0	113	40213227		
5382	117	40213260	2018-10-06	2018-10-06 00:00:00	2018-10-06	2018-10-06 00:00:00	2018-10-06	581452		0	0	0		0	0	0	7763	0	121	40213260		
28620	2358	1127433	2016-10-01	2016-10-01 00:00:00	2016-10-15	2016-10-15 00:00:00	2016-10-15	38000177		0	0	14		0	0	0	157143	0	313782	1127433		
34440	753	40213227	1999-05-16	1999-05-16 00:00:00	1999-05-16	1999-05-16 00:00:00	1999-05-16	581452		0	0	0		0	0	0	49755	0	113	40213227		
14553	1219	1127433	1947-08-20	1947-08-20 00:00:00	1947-08-27	1947-08-27 00:00:00	1947-08-27	38000177		0	0	7		0	0	0	80284	0	313782	1127433		
1442	115	920334	1976-02-24	1976-02-24 00:00:00	1976-03-02	1976-03-02 00:00:00	1976-03-02	38000177		0	0	7		0	0	0	7567	0	311995	920334		
12302	1033	19128065	1988-07-16	1988-07-16 00:00:00	1989-07-11	1989-07-11 00:00:00	1989-07-11	38000177		0	0	360		0	0	0	67991	0	749882	19128065		
41432	3435	1127078	1979-12-24	1979-12-24 00:00:00	1980-01-07	1980-01-07 00:00:00	1980-01-07	38000177		0	0	14		0	0	0	227801	0	282464	1127078		
45936	3803	1118084	2003-12-24	2003-12-24 00:00:00	2003-12-24	2003-12-24 00:00:00	\N	38000177		0	0	0		0	0	0	252766	0	00025152531	44923712		
63352	5262	1118084	2010-04-13	2010-04-13 00:00:00	2010-04-13	2010-04-13 00:00:00	\N	38000177		0	0	0		0	0	0	350147	0	00025152531	44923712		
22606	1855	1127078	1976-12-10	1976-12-10 00:00:00	1976-12-24	1976-12-24 00:00:00	1976-12-24	38000177		0	0	14		0	0	0	124172	0	282464	1127078		
43610	3614	1127078	1953-12-01	1953-12-01 00:00:00	1953-12-15	1953-12-15 00:00:00	1953-12-15	38000177		0	0	14		0	0	0	240118	0	282464	1127078		
50869	4226	19129655	1965-08-04	1965-08-04 00:00:00	1965-08-18	1965-08-18 00:00:00	1965-08-18	38000177		0	0	14		0	0	0	280741	0	789980	19129655		
15266	1276	1127433	1992-02-03	1992-02-03 00:00:00	1992-02-17	1992-02-17 00:00:00	1992-02-17	38000177		0	0	14		0	0	0	84133	0	313782	1127433		
60580	5039	1713671	1981-08-22	1981-08-22 00:00:00	1981-08-29	1981-08-29 00:00:00	1981-08-29	38000177		0	0	7		0	0	0	334861	0	562251	1713671		
29293	2424	1127433	1997-09-08	1997-09-08 00:00:00	1997-09-22	1997-09-22 00:00:00	1997-09-22	38000177		0	0	14		0	0	0	160869	0	313782	1127433		
29332	2428	19078461	1996-04-14	1996-04-14 00:00:00	1996-05-19	1996-05-19 00:00:00	1996-05-19	38000177		0	0	35		0	0	0	161081	0	310965	19078461		
33461	2771	1713671	2015-02-05	2015-02-05 00:00:00	2015-02-19	2015-02-19 00:00:00	2015-02-19	38000177		0	0	14		0	0	0	183547	0	562251	1713671		
26424	2174	19128022	1990-06-16	1990-06-16 00:00:00	1991-06-11	1991-06-11 00:00:00	1991-06-11	38000177		0	0	360		0	0	0	144931	0	749785	19128022		
39934	3304	1127433	2012-05-14	2012-05-14 00:00:00	2012-05-28	2012-05-28 00:00:00	2012-05-28	38000177		0	0	14		0	0	0	219448	0	313782	1127433		
39994	3311	1713671	1977-12-24	1977-12-24 00:00:00	1977-12-31	1977-12-31 00:00:00	1977-12-31	38000177		0	0	7		0	0	0	219846	0	562251	1713671		
11107	925	19059056	1971-05-18	1971-05-18 00:00:00	1971-06-01	1971-06-01 00:00:00	1971-06-01	38000177		0	0	14		0	0	0	61638	0	243670	19059056		
11423	951	1127433	1990-12-09	1990-12-09 00:00:00	1990-12-23	1990-12-23 00:00:00	1990-12-23	38000177		0	0	14		0	0	0	63166	0	313782	1127433		
54555	4532	19078461	1998-08-17	1998-08-17 00:00:00	1998-09-07	1998-09-07 00:00:00	1998-09-07	38000177		0	0	21		0	0	0	301894	0	310965	19078461		
47135	3906	1115171	2011-04-02	2011-04-02 00:00:00	2011-06-01	2011-06-01 00:00:00	2011-06-01	38000177		0	0	60		0	0	0	259730	0	849574	1115171		
70454	1541	40213160	1964-01-06	1964-01-06 00:00:00	1964-01-06	1964-01-06 00:00:00	1964-01-06	581452		0	0	0		0	0	0	103245	0	10	40213160		
22464	487	40213227	2017-01-18	2017-01-18 00:00:00	2017-01-18	2017-01-18 00:00:00	2017-01-18	581452		0	0	0		0	0	0	32590	0	113	40213227		
94645	2076	40213306	1988-03-24	1988-03-24 00:00:00	1988-03-24	1988-03-24 00:00:00	1988-03-24	581452		0	0	0		0	0	0	138158	0	43	40213306		
8507	183	40213227	1996-12-05	1996-12-05 00:00:00	1996-12-05	1996-12-05 00:00:00	1996-12-05	581452		0	0	0		0	0	0	12402	0	113	40213227		
13433	1125	1713671	1964-10-02	1964-10-02 00:00:00	1964-10-23	1964-10-23 00:00:00	1964-10-23	38000177		0	0	21		0	0	0	74196	0	562251	1713671		
13197	1107	1713671	1992-05-23	1992-05-23 00:00:00	1992-06-06	1992-06-06 00:00:00	1992-06-06	38000177		0	0	14		0	0	0	72922	0	562251	1713671		
42921	3558	1127078	1964-01-01	1964-01-01 00:00:00	1964-01-15	1964-01-15 00:00:00	1964-01-15	38000177		0	0	14		0	0	0	236215	0	282464	1127078		
97589	2138	40213260	2006-01-29	2006-01-29 00:00:00	2006-01-29	2006-01-29 00:00:00	2006-01-29	581452		0	0	0		0	0	0	142450	0	121	40213260		
31550	687	40213227	2009-03-28	2009-03-28 00:00:00	2009-03-28	2009-03-28 00:00:00	2009-03-28	581452		0	0	0		0	0	0	45466	0	113	40213227		
53800	4472	1713671	1970-12-22	1970-12-22 00:00:00	1971-01-05	1971-01-05 00:00:00	1971-01-05	38000177		0	0	14		0	0	0	297525	0	562251	1713671		
46527	1017	40213306	1981-05-03	1981-05-03 00:00:00	1981-05-03	1981-05-03 00:00:00	1981-05-03	581452		0	0	0		0	0	0	66950	0	43	40213306		
179110	3938	40213227	1992-08-26	1992-08-26 00:00:00	1992-08-26	1992-08-26 00:00:00	1992-08-26	581452		0	0	0		0	0	0	261732	0	113	40213227		
27883	2307	1124300	2003-11-12	2003-11-12 00:00:00	2003-11-12	2003-11-12 00:00:00	\N	38000177		0	0	0		0	0	0	153523	0	00781178901	45011828		
30964	2564	19133873	1991-08-06	1991-08-06 00:00:00	1991-08-17	1991-08-17 00:00:00	1991-08-17	38000177		0	0	11		0	0	0	169888	0	834061	19133873		
64202	5329	1127078	1951-07-30	1951-07-30 00:00:00	1951-09-28	1951-09-28 00:00:00	1951-09-28	38000177		0	0	60		0	0	0	354828	0	282464	1127078		
258	18	1124300	2009-03-21	2009-03-21 00:00:00	2009-03-21	2009-03-21 00:00:00	\N	38000177		0	0	0		0	0	0	1449	0	00781178901	45011828		
17844	1478	19078461	2001-09-22	2001-09-22 00:00:00	2001-10-06	2001-10-06 00:00:00	2001-10-06	38000177		0	0	14		0	0	0	98643	0	310965	19078461		
10843	905	1127433	2018-09-22	2018-09-22 00:00:00	2018-09-29	2018-09-29 00:00:00	2018-09-29	38000177		0	0	7		0	0	0	60157	0	313782	1127433		
25724	2116	40229134	1972-07-04	1972-07-04 00:00:00	1972-07-18	1972-07-18 00:00:00	1972-07-18	38000177		0	0	14		0	0	0	140803	0	1043400	40229134		
7800	652	19059056	1991-05-18	1991-05-18 00:00:00	1991-06-08	1991-06-08 00:00:00	1991-06-08	38000177		0	0	21		0	0	0	43185	0	243670	19059056		
59651	4960	1127433	1930-09-03	1930-09-03 00:00:00	1930-09-17	1930-09-17 00:00:00	1930-09-17	38000177		0	0	14		0	0	0	329655	0	313782	1127433		
27461	2274	1127433	1960-08-21	1960-08-21 00:00:00	1960-09-25	1960-09-25 00:00:00	1960-09-25	38000177		0	0	35		0	0	0	151206	0	313782	1127433		
18420	1525	1127433	1993-08-23	1993-08-23 00:00:00	1993-11-21	1993-11-21 00:00:00	1993-11-21	38000177		0	0	90		0	0	0	102031	0	313782	1127433		
45742	3787	19075601	2013-04-13	2013-04-13 00:00:00	2016-08-27	2016-08-27 00:00:00	2016-08-27	38000177		0	0	1232		0	0	0	251748	0	309362	19075601		
34210	747	40213227	1995-04-15	1995-04-15 00:00:00	1995-04-15	1995-04-15 00:00:00	1995-04-15	581452		0	0	0		0	0	0	49464	0	113	40213227		
19747	1626	1539411	2006-10-29	2006-10-29 00:00:00	2006-10-29	2006-10-29 00:00:00	\N	38000177		0	0	0		0	0	0	109219	0	312961	1539411		
27171	2240	19059056	1966-10-05	1966-10-05 00:00:00	1966-10-19	1966-10-19 00:00:00	1966-10-19	38000177		0	0	14		0	0	0	149135	0	243670	19059056		
56387	4678	1127433	1973-01-23	1973-01-23 00:00:00	1973-02-06	1973-02-06 00:00:00	1973-02-06	38000177		0	0	14		0	0	0	311764	0	313782	1127433		
37732	3118	40232448	1952-12-25	1952-12-25 00:00:00	1952-12-25	1952-12-25 00:00:00	\N	38000177		0	0	0		0	0	0	207525	0	1049630	40232448		
32668	712	40213306	1997-01-09	1997-01-09 00:00:00	1997-01-09	1997-01-09 00:00:00	1997-01-09	581452		0	0	0		0	0	0	47261	0	43	40213306		
32482	2693	1118084	1997-05-27	1997-05-27 00:00:00	1997-05-27	1997-05-27 00:00:00	\N	38000177		0	0	0		0	0	0	178415	0	00025152531	44923712		
41271	3422	19115351	1980-09-15	1980-09-15 00:00:00	1981-03-16	1981-03-16 00:00:00	1981-03-16	38000177		0	0	182		0	0	0	226983	0	563026	19115351		
166580	3661	40213314	1978-07-23	1978-07-23 00:00:00	1978-07-23	1978-07-23 00:00:00	1978-07-23	581452		0	0	0		0	0	0	243633	0	49	40213314		
63233	5253	920300	1995-01-12	1995-01-12 00:00:00	1995-01-19	1995-01-19 00:00:00	1995-01-19	38000177		0	0	7		0	0	0	349544	0	311989	920300		
20872	1720	1713671	2005-12-12	2005-12-12 00:00:00	2006-01-02	2006-01-02 00:00:00	2006-01-02	38000177		0	0	21		0	0	0	115031	0	562251	1713671		
7434	621	40171902	2015-03-18	2015-03-18 00:00:00	2015-03-18	2015-03-18 00:00:00	\N	38000177		0	0	0		0	0	0	41407	0	897718	40171902		
4944	410	40236824	1995-09-21	1995-09-21 00:00:00	1995-09-28	1995-09-28 00:00:00	1995-09-28	38000177		0	0	7		0	0	0	27193	0	1094107	40236824		
34308	2834	1545959	1999-12-04	1999-12-04 00:00:00	1999-12-04	1999-12-04 00:00:00	1999-12-04	38000177		0	0	0		0	0	0	188165	0	259255	1545959		
11688	972	46233988	1971-04-25	1971-04-25 00:00:00	1971-05-09	1971-05-09 00:00:00	1971-05-09	38000177		0	0	14		0	0	0	64663	0	1652673	46233988		
33241	726	40213160	1955-08-07	1955-08-07 00:00:00	1955-08-07	1955-08-07 00:00:00	1955-08-07	581452		0	0	0		0	0	0	48101	0	10	40213160		
5391	117	40213160	1969-06-14	1969-06-14 00:00:00	1969-06-14	1969-06-14 00:00:00	1969-06-14	581452		0	0	0		0	0	0	7762	0	10	40213160		
28621	2358	1713671	2002-07-31	2002-07-31 00:00:00	2002-08-21	2002-08-21 00:00:00	2002-08-21	38000177		0	0	21		0	0	0	157134	0	562251	1713671		
34442	753	40213306	1990-05-06	1990-05-06 00:00:00	1990-05-06	1990-05-06 00:00:00	1990-05-06	581452		0	0	0		0	0	0	49761	0	43	40213306		
236004	5184	40213260	2015-03-13	2015-03-13 00:00:00	2015-03-13	2015-03-13 00:00:00	2015-03-13	581452		0	0	0		0	0	0	344589	0	121	40213260		
1443	115	40236824	1975-11-28	1975-11-28 00:00:00	1975-12-05	1975-12-05 00:00:00	1975-12-05	38000177		0	0	7		0	0	0	7608	0	1094107	40236824		
12303	1033	1713671	2013-12-02	2013-12-02 00:00:00	2013-12-09	2013-12-09 00:00:00	2013-12-09	38000177		0	0	7		0	0	0	68017	0	562251	1713671		
41433	3435	1713671	2004-11-02	2004-11-02 00:00:00	2004-11-23	2004-11-23 00:00:00	2004-11-23	38000177		0	0	21		0	0	0	227777	0	562251	1713671		
45937	3803	1713671	2014-09-13	2014-09-13 00:00:00	2014-12-06	2014-12-06 00:00:00	2014-12-06	38000177		0	0	84		0	0	0	252758	0	562251	1713671		
63353	5262	1127078	1973-08-20	1973-08-20 00:00:00	1973-09-03	1973-09-03 00:00:00	1973-09-03	38000177		0	0	14		0	0	0	350073	0	282464	1127078		
22607	1855	46233988	1976-12-10	1976-12-10 00:00:00	1976-12-24	1976-12-24 00:00:00	1976-12-24	38000177		0	0	14		0	0	0	124172	0	1652673	46233988		
43611	3614	19006318	1953-12-01	1953-12-01 00:00:00	1953-12-15	1953-12-15 00:00:00	1953-12-15	38000177		0	0	14		0	0	0	240118	0	105078	19006318		
50870	4226	19059056	1967-07-16	1967-07-16 00:00:00	1967-07-30	1967-07-30 00:00:00	1967-07-30	38000177		0	0	14		0	0	0	280661	0	243670	19059056		
15267	1276	40229134	2017-04-13	2017-04-13 00:00:00	2017-04-27	2017-04-27 00:00:00	2017-04-27	38000177		0	0	14		0	0	0	84198	0	1043400	40229134		
60581	5039	19059056	1974-10-21	1974-10-21 00:00:00	1974-11-04	1974-11-04 00:00:00	1974-11-04	38000177		0	0	14		0	0	0	334864	0	243670	19059056		
29294	2424	1713671	1964-05-11	1964-05-11 00:00:00	1964-06-01	1964-06-01 00:00:00	1964-06-01	38000177		0	0	21		0	0	0	160810	0	562251	1713671		
29333	2428	1127078	1984-01-18	1984-01-18 00:00:00	1984-02-17	1984-02-17 00:00:00	1984-02-17	38000177		0	0	30		0	0	0	161080	0	282464	1127078		
33462	2771	40243436	1955-11-11	1955-11-11 00:00:00	1955-11-11	1955-11-11 00:00:00	1955-11-11	38000177		0	0	0		0	0	0	183470	0	1190795	40243436		
26425	2174	1118084	2012-02-06	2012-02-06 00:00:00	2012-02-06	2012-02-06 00:00:00	\N	38000177		0	0	0		0	0	0	144947	0	00025152531	44923712		
39935	3304	40229134	1990-08-03	1990-08-03 00:00:00	1990-08-10	1990-08-10 00:00:00	1990-08-10	38000177		0	0	7		0	0	0	219446	0	1043400	40229134		
39995	3311	1127433	1969-10-10	1969-10-10 00:00:00	1969-10-24	1969-10-24 00:00:00	1969-10-24	38000177		0	0	14		0	0	0	219754	0	313782	1127433		
11108	925	46233988	1971-05-18	1971-05-18 00:00:00	1971-06-01	1971-06-01 00:00:00	1971-06-01	38000177		0	0	14		0	0	0	61638	0	1652673	46233988		
11424	951	1127433	1995-09-25	1995-09-25 00:00:00	1995-11-24	1995-11-24 00:00:00	1995-11-24	38000177		0	0	60		0	0	0	63220	0	313782	1127433		
54556	4532	19133873	1912-07-15	1912-07-15 00:00:00	1912-07-25	1912-07-25 00:00:00	1912-07-25	38000177		0	0	10		0	0	0	301829	0	834061	19133873		
47136	3906	1127433	1978-06-20	1978-06-20 00:00:00	1978-07-04	1978-07-04 00:00:00	1978-07-04	38000177		0	0	14		0	0	0	259743	0	313782	1127433		
70462	1541	40213160	1963-08-05	1963-08-05 00:00:00	1963-08-05	1963-08-05 00:00:00	1963-08-05	581452		0	0	0		0	0	0	103244	0	10	40213160		
22465	487	40213260	2017-01-18	2017-01-18 00:00:00	2017-01-18	2017-01-18 00:00:00	2017-01-18	581452		0	0	0		0	0	0	32590	0	121	40213260		
94649	2076	40213160	1967-06-08	1967-06-08 00:00:00	1967-06-08	1967-06-08 00:00:00	1967-06-08	581452		0	0	0		0	0	0	138197	0	10	40213160		
8509	183	40213296	2014-10-30	2014-10-30 00:00:00	2014-10-30	2014-10-30 00:00:00	2014-10-30	581452		0	0	0		0	0	0	12369	0	52	40213296		
33395	729	40213160	1966-06-11	1966-06-11 00:00:00	1966-06-11	1966-06-11 00:00:00	1966-06-11	581452		0	0	0		0	0	0	48407	0	10	40213160		
13198	1107	1713671	1955-02-23	1955-02-23 00:00:00	1955-03-16	1955-03-16 00:00:00	1955-03-16	38000177		0	0	21		0	0	0	72843	0	562251	1713671		
42922	3559	1127433	1956-10-20	1956-10-20 00:00:00	1956-11-03	1956-11-03 00:00:00	1956-11-03	38000177		0	0	14		0	0	0	236244	0	313782	1127433		
97590	2138	40213227	2006-01-29	2006-01-29 00:00:00	2006-01-29	2006-01-29 00:00:00	2006-01-29	581452		0	0	0		0	0	0	142450	0	113	40213227		
31557	687	40213260	2017-09-30	2017-09-30 00:00:00	2017-09-30	2017-09-30 00:00:00	2017-09-30	581452		0	0	0		0	0	0	45481	0	121	40213260		
53801	4472	1127433	1967-03-12	1967-03-12 00:00:00	1967-03-19	1967-03-19 00:00:00	1967-03-19	38000177		0	0	7		0	0	0	297483	0	313782	1127433		
46536	1017	40213160	1958-09-21	1958-09-21 00:00:00	1958-09-21	1958-09-21 00:00:00	1958-09-21	581452		0	0	0		0	0	0	66956	0	10	40213160		
1056	23	40213160	1983-08-18	1983-08-18 00:00:00	1983-08-18	1983-08-18 00:00:00	1983-08-18	581452		0	0	0		0	0	0	1772	0	10	40213160		
27884	2307	1127433	1999-09-28	1999-09-28 00:00:00	1999-10-19	1999-10-19 00:00:00	1999-10-19	38000177		0	0	21		0	0	0	153484	0	313782	1127433		
30970	2566	40229134	1946-09-18	1946-09-18 00:00:00	1946-09-25	1946-09-25 00:00:00	1946-09-25	38000177		0	0	7		0	0	0	169995	0	1043400	40229134		
64203	5329	1127433	1968-12-18	1968-12-18 00:00:00	1969-02-16	1969-02-16 00:00:00	1969-02-16	38000177		0	0	60		0	0	0	354830	0	313782	1127433		
259	18	1127433	2016-01-06	2016-01-06 00:00:00	2016-02-03	2016-02-03 00:00:00	2016-02-03	38000177		0	0	28		0	0	0	1380	0	313782	1127433		
17845	1478	1551192	1977-11-22	1977-11-22 00:00:00	1977-11-22	1977-11-22 00:00:00	1977-11-22	38000177		0	0	0		0	0	0	98640	0	312617	1551192		
10844	905	19074679	1977-03-12	1977-03-12 00:00:00	1977-03-12	1977-03-12 00:00:00	\N	38000177		0	0	0		0	0	0	60183	0	308971	19074679		
25725	2116	1127433	2015-09-27	2015-09-27 00:00:00	2015-12-26	2015-12-26 00:00:00	2015-12-26	38000177		0	0	90		0	0	0	140842	0	313782	1127433		
7801	652	19078461	1997-04-07	1997-04-07 00:00:00	1997-04-28	1997-04-28 00:00:00	1997-04-28	38000177		0	0	21		0	0	0	43186	0	310965	19078461		
59652	4960	19059056	1955-08-17	1955-08-17 00:00:00	1955-09-07	1955-09-07 00:00:00	1955-09-07	38000177		0	0	21		0	0	0	329709	0	243670	19059056		
27462	2274	19059056	1949-07-20	1949-07-20 00:00:00	1949-08-03	1949-08-03 00:00:00	1949-08-03	38000177		0	0	14		0	0	0	151199	0	243670	19059056		
18421	1525	19128065	1978-07-23	1978-07-23 00:00:00	1979-07-18	1979-07-18 00:00:00	1979-07-18	38000177		0	0	360		0	0	0	101992	0	749882	19128065		
45743	3787	1539411	2013-04-13	2013-04-13 00:00:00	2013-04-13	2013-04-13 00:00:00	\N	38000177		0	0	0		0	0	0	251748	0	312961	1539411		
34212	747	40213160	1968-08-31	1968-08-31 00:00:00	1968-08-31	1968-08-31 00:00:00	1968-08-31	581452		0	0	0		0	0	0	49493	0	10	40213160		
19748	1626	19075601	2006-10-29	2006-10-29 00:00:00	2006-10-29	2006-10-29 00:00:00	\N	38000177		0	0	0		0	0	0	109219	0	309362	19075601		
27172	2240	1713671	1959-10-21	1959-10-21 00:00:00	1959-10-28	1959-10-28 00:00:00	1959-10-28	38000177		0	0	7		0	0	0	149165	0	562251	1713671		
56388	4678	1127433	1982-09-22	1982-09-22 00:00:00	1982-10-06	1982-10-06 00:00:00	1982-10-06	38000177		0	0	14		0	0	0	311727	0	313782	1127433		
37733	3118	1127078	1951-05-08	1951-05-08 00:00:00	1951-05-22	1951-05-22 00:00:00	1951-05-22	38000177		0	0	14		0	0	0	207531	0	282464	1127078		
32669	712	40213227	1997-01-09	1997-01-09 00:00:00	1997-01-09	1997-01-09 00:00:00	1997-01-09	581452		0	0	0		0	0	0	47261	0	113	40213227		
32483	2693	1127433	1977-08-27	1977-08-27 00:00:00	1977-09-03	1977-09-03 00:00:00	1977-09-03	38000177		0	0	7		0	0	0	178403	0	313782	1127433		
41272	3422	1127433	1995-09-20	1995-09-20 00:00:00	1995-10-04	1995-10-04 00:00:00	1995-10-04	38000177		0	0	14		0	0	0	226961	0	313782	1127433		
1971	158	19078461	2001-10-18	2001-10-18 00:00:00	2001-11-08	2001-11-08 00:00:00	2001-11-08	38000177		0	0	21		0	0	0	10792	0	310965	19078461		
63235	5253	40169281	1984-08-25	1984-08-25 00:00:00	1984-08-25	1984-08-25 00:00:00	\N	38000177		0	0	0		0	0	0	349557	0	896209	40169281		
20873	1720	19059056	1979-12-26	1979-12-26 00:00:00	1980-01-09	1980-01-09 00:00:00	1980-01-09	38000177		0	0	14		0	0	0	115010	0	243670	19059056		
7435	621	40163554	2015-03-18	2015-03-18 00:00:00	2015-03-18	2015-03-18 00:00:00	\N	38000177		0	0	0		0	0	0	41407	0	855332	40163554		
4945	410	920300	1995-09-21	1995-09-21 00:00:00	1995-09-28	1995-09-28 00:00:00	1995-09-28	38000177		0	0	7		0	0	0	27193	0	311989	920300		
34309	2834	19059056	1938-07-18	1938-07-18 00:00:00	1938-08-01	1938-08-01 00:00:00	1938-08-01	38000177		0	0	14		0	0	0	188112	0	243670	19059056		
11689	972	19133905	1999-07-04	1999-07-04 00:00:00	1999-07-13	1999-07-13 00:00:00	1999-07-13	38000177		0	0	9		0	0	0	64708	0	834102	19133905		
33246	726	40213296	1997-09-14	1997-09-14 00:00:00	1997-09-14	1997-09-14 00:00:00	1997-09-14	581452		0	0	0		0	0	0	48073	0	52	40213296		
5393	117	40213306	1991-10-05	1991-10-05 00:00:00	1991-10-05	1991-10-05 00:00:00	1991-10-05	581452		0	0	0		0	0	0	7769	0	43	40213306		
28622	2359	1127433	2004-03-21	2004-03-21 00:00:00	2004-04-04	2004-04-04 00:00:00	2004-04-04	38000177		0	0	14		0	0	0	157271	0	313782	1127433		
34445	753	40213160	1967-12-31	1967-12-31 00:00:00	1967-12-31	1967-12-31 00:00:00	1967-12-31	581452		0	0	0		0	0	0	49777	0	10	40213160		
236018	5184	40213227	1995-09-01	1995-09-01 00:00:00	1995-09-01	1995-09-01 00:00:00	1995-09-01	581452		0	0	0		0	0	0	344551	0	113	40213227		
1444	115	920300	1975-11-28	1975-11-28 00:00:00	1975-12-05	1975-12-05 00:00:00	1975-12-05	38000177		0	0	7		0	0	0	7608	0	311989	920300		
12304	1033	1127078	1977-03-06	1977-03-06 00:00:00	1977-04-10	1977-04-10 00:00:00	1977-04-10	38000177		0	0	35		0	0	0	67967	0	282464	1127078		
41434	3435	1713671	2009-06-05	2009-06-05 00:00:00	2009-06-12	2009-06-12 00:00:00	2009-06-12	38000177		0	0	7		0	0	0	227773	0	562251	1713671		
45939	3803	19133873	1974-05-03	1974-05-03 00:00:00	1974-05-14	1974-05-14 00:00:00	1974-05-14	38000177		0	0	11		0	0	0	252754	0	834061	19133873		
63354	5262	1713671	2003-06-06	2003-06-06 00:00:00	2003-06-27	2003-06-27 00:00:00	2003-06-27	38000177		0	0	21		0	0	0	350103	0	562251	1713671		
22608	1855	40169216	1977-03-27	1977-03-27 00:00:00	1977-03-27	1977-03-27 00:00:00	\N	38000177		0	0	0		0	0	0	124163	0	895994	40169216		
43612	3615	40229134	1977-06-15	1977-06-15 00:00:00	1977-06-29	1977-06-29 00:00:00	1977-06-29	38000177		0	0	14		0	0	0	240214	0	1043400	40229134		
50871	4226	19006318	1967-07-16	1967-07-16 00:00:00	1967-07-30	1967-07-30 00:00:00	1967-07-30	38000177		0	0	14		0	0	0	280661	0	105078	19006318		
15268	1276	1124300	1995-08-21	1995-08-21 00:00:00	1995-08-21	1995-08-21 00:00:00	\N	38000177		0	0	0		0	0	0	84209	0	00781178901	45011828		
60582	5039	19006318	1974-10-21	1974-10-21 00:00:00	1974-11-04	1974-11-04 00:00:00	1974-11-04	38000177		0	0	14		0	0	0	334864	0	105078	19006318		
29295	2424	40229134	1991-10-31	1991-10-31 00:00:00	1991-11-07	1991-11-07 00:00:00	1991-11-07	38000177		0	0	7		0	0	0	160820	0	1043400	40229134		
29334	2428	19059056	1977-04-10	1977-04-10 00:00:00	1977-04-24	1977-04-24 00:00:00	1977-04-24	38000177		0	0	14		0	0	0	161123	0	243670	19059056		
33463	2771	46275916	1955-11-11	1955-11-11 00:00:00	1955-11-11	1955-11-11 00:00:00	1955-11-11	38000177		0	0	0		0	0	0	183470	0	1660014	46275916		
26426	2174	1127078	1974-12-27	1974-12-27 00:00:00	1975-01-10	1975-01-10 00:00:00	1975-01-10	38000177		0	0	14		0	0	0	144939	0	282464	1127078		
39936	3304	1118084	2001-05-19	2001-05-19 00:00:00	2001-05-19	2001-05-19 00:00:00	\N	38000177		0	0	0		0	0	0	219442	0	00025152531	44923712		
39996	3311	40229134	1981-02-18	1981-02-18 00:00:00	1981-02-25	1981-02-25 00:00:00	1981-02-25	38000177		0	0	7		0	0	0	219799	0	1043400	40229134		
11109	925	1127433	1982-01-21	1982-01-21 00:00:00	1982-02-04	1982-02-04 00:00:00	1982-02-04	38000177		0	0	14		0	0	0	61603	0	313782	1127433		
11425	951	19059056	1957-11-22	1957-11-22 00:00:00	1957-12-06	1957-12-06 00:00:00	1957-12-06	38000177		0	0	14		0	0	0	63168	0	243670	19059056		
54557	4532	1127433	1943-04-20	1943-04-20 00:00:00	1943-05-04	1943-05-04 00:00:00	1943-05-04	38000177		0	0	14		0	0	0	301831	0	313782	1127433		
47137	3906	40229134	2001-10-20	2001-10-20 00:00:00	2001-10-27	2001-10-27 00:00:00	2001-10-27	38000177		0	0	7		0	0	0	259745	0	1043400	40229134		
70465	1541	40213227	1994-07-11	1994-07-11 00:00:00	1994-07-11	1994-07-11 00:00:00	1994-07-11	581452		0	0	0		0	0	0	103256	0	113	40213227		
22467	487	40213306	1988-08-17	1988-08-17 00:00:00	1988-08-17	1988-08-17 00:00:00	1988-08-17	581452		0	0	0		0	0	0	32587	0	43	40213306		
94652	2076	40213260	2016-12-29	2016-12-29 00:00:00	2016-12-29	2016-12-29 00:00:00	2016-12-29	581452		0	0	0		0	0	0	138156	0	121	40213260		
8513	183	40213314	1977-03-31	1977-03-31 00:00:00	1977-03-31	1977-03-31 00:00:00	1977-03-31	581452		0	0	0		0	0	0	12396	0	49	40213314		
33400	729	40213227	2012-07-07	2012-07-07 00:00:00	2012-07-07	2012-07-07 00:00:00	2012-07-07	581452		0	0	0		0	0	0	48382	0	113	40213227		
13199	1107	19075601	1997-03-14	1997-03-14 00:00:00	2007-06-15	2007-06-15 00:00:00	2007-06-15	38000177		0	0	3745		0	0	0	72869	0	309362	19075601		
42923	3559	1124300	1991-08-06	1991-08-06 00:00:00	1991-08-06	1991-08-06 00:00:00	\N	38000177		0	0	0		0	0	0	236288	0	00781178901	45011828		
44814	975	40213306	1988-10-23	1988-10-23 00:00:00	1988-10-23	1988-10-23 00:00:00	1988-10-23	581452		0	0	0		0	0	0	65068	0	43	40213306		
31558	687	40213160	1967-09-30	1967-09-30 00:00:00	1967-09-30	1967-09-30 00:00:00	1967-09-30	581452		0	0	0		0	0	0	45537	0	10	40213160		
53802	4472	1127433	2009-01-28	2009-01-28 00:00:00	2009-02-04	2009-02-04 00:00:00	2009-02-04	38000177		0	0	7		0	0	0	297498	0	313782	1127433		
104740	2297	40213314	1977-08-11	1977-08-11 00:00:00	1977-08-11	1977-08-11 00:00:00	1977-08-11	581452		0	0	0		0	0	0	152948	0	49	40213314		
1064	23	40213296	2018-09-13	2018-09-13 00:00:00	2018-09-13	2018-09-13 00:00:00	2018-09-13	581452		0	0	0		0	0	0	1812	0	52	40213296		
27885	2307	19073188	1985-07-16	1985-07-16 00:00:00	1985-07-30	1985-07-30 00:00:00	1985-07-30	38000177		0	0	14		0	0	0	153490	0	308192	19073188		
30971	2566	1713671	2003-04-16	2003-04-16 00:00:00	2003-04-30	2003-04-30 00:00:00	2003-04-30	38000177		0	0	14		0	0	0	169941	0	562251	1713671		
64204	5329	1127433	2009-12-01	2009-12-01 00:00:00	2009-12-15	2009-12-15 00:00:00	2009-12-15	38000177		0	0	14		0	0	0	354765	0	313782	1127433		
260	18	1127433	1983-05-31	1983-05-31 00:00:00	1983-06-28	1983-06-28 00:00:00	1983-06-28	38000177		0	0	28		0	0	0	1382	0	313782	1127433		
17846	1478	1551192	1990-11-23	1990-11-23 00:00:00	1990-11-23	1990-11-23 00:00:00	1990-11-23	38000177		0	0	0		0	0	0	98642	0	312617	1551192		
10845	905	46233988	1972-02-03	1972-02-03 00:00:00	1972-02-17	1972-02-17 00:00:00	1972-02-17	38000177		0	0	14		0	0	0	60158	0	1652673	46233988		
25726	2116	19073188	2012-10-07	2012-10-07 00:00:00	2012-11-11	2012-11-11 00:00:00	2012-11-11	38000177		0	0	35		0	0	0	140841	0	308192	19073188		
7802	652	1127433	1973-11-07	1973-11-07 00:00:00	1973-11-14	1973-11-14 00:00:00	1973-11-14	38000177		0	0	7		0	0	0	43157	0	313782	1127433		
59653	4960	19059056	1909-06-16	1909-06-16 00:00:00	1909-06-30	1909-06-30 00:00:00	1909-06-30	38000177		0	0	14		0	0	0	329755	0	243670	19059056		
27463	2274	19006318	1949-07-20	1949-07-20 00:00:00	1949-08-03	1949-08-03 00:00:00	1949-08-03	38000177		0	0	14		0	0	0	151199	0	105078	19006318		
18422	1525	1713671	2013-02-16	2013-02-16 00:00:00	2013-03-09	2013-03-09 00:00:00	2013-03-09	38000177		0	0	21		0	0	0	102011	0	562251	1713671		
45744	3787	19126352	2013-04-13	2013-04-13 00:00:00	2016-08-27	2016-08-27 00:00:00	2016-08-27	38000177		0	0	1232		0	0	0	251748	0	705129	19126352		
34213	747	40213160	1963-12-28	1963-12-28 00:00:00	1963-12-28	1963-12-28 00:00:00	1963-12-28	581452		0	0	0		0	0	0	49446	0	10	40213160		
19749	1626	19133905	1987-10-28	1987-10-28 00:00:00	1987-11-09	1987-11-09 00:00:00	1987-11-09	38000177		0	0	12		0	0	0	109274	0	834102	19133905		
27173	2240	19133905	2004-06-01	2004-06-01 00:00:00	2004-06-09	2004-06-09 00:00:00	2004-06-09	38000177		0	0	8		0	0	0	149144	0	834102	19133905		
56389	4678	40229134	2016-07-02	2016-07-02 00:00:00	2016-07-16	2016-07-16 00:00:00	2016-07-16	38000177		0	0	14		0	0	0	311742	0	1043400	40229134		
37734	3118	19006318	1951-05-08	1951-05-08 00:00:00	1951-05-22	1951-05-22 00:00:00	1951-05-22	38000177		0	0	14		0	0	0	207531	0	105078	19006318		
32678	712	40213296	2016-08-11	2016-08-11 00:00:00	2016-08-11	2016-08-11 00:00:00	2016-08-11	581452		0	0	0		0	0	0	47259	0	52	40213296		
32484	2693	40236824	1983-11-04	1983-11-04 00:00:00	1983-11-11	1983-11-11 00:00:00	1983-11-11	38000177		0	0	7		0	0	0	178368	0	1094107	40236824		
41273	3422	40243436	1973-11-12	1973-11-12 00:00:00	1973-11-12	1973-11-12 00:00:00	1973-11-12	38000177		0	0	0		0	0	0	226979	0	1190795	40243436		
1972	158	40229134	1995-03-23	1995-03-23 00:00:00	1995-04-06	1995-04-06 00:00:00	1995-04-06	38000177		0	0	14		0	0	0	10823	0	1043400	40229134		
63236	5253	1127433	1971-04-20	1971-04-20 00:00:00	1971-05-20	1971-05-20 00:00:00	1971-05-20	38000177		0	0	30		0	0	0	349571	0	313782	1127433		
20874	1720	19074843	1979-12-26	1979-12-26 00:00:00	1980-01-09	1980-01-09 00:00:00	1980-01-09	38000177		0	0	14		0	0	0	115010	0	309045	19074843		
7436	621	19018935	2015-03-18	2015-03-18 00:00:00	2015-03-18	2015-03-18 00:00:00	\N	38000177		0	0	0		0	0	0	41407	0	197604	19018935		
4946	410	1713671	1974-03-01	1974-03-01 00:00:00	1974-03-15	1974-03-15 00:00:00	1974-03-15	38000177		0	0	14		0	0	0	27224	0	562251	1713671		
34310	2835	40220960	1988-07-05	1988-07-05 00:00:00	1988-07-05	1988-07-05 00:00:00	1988-07-05	38000177		0	0	0		0	0	0	188306	0	1804799	40220960		
11690	972	1127078	1974-01-20	1974-01-20 00:00:00	1974-04-20	1974-04-20 00:00:00	1974-04-20	38000177		0	0	90		0	0	0	64718	0	282464	1127078		
33250	726	40213227	2015-06-14	2015-06-14 00:00:00	2015-06-14	2015-06-14 00:00:00	2015-06-14	581452		0	0	0		0	0	0	48131	0	113	40213227		
5403	117	40213296	2012-04-14	2012-04-14 00:00:00	2012-04-14	2012-04-14 00:00:00	2012-04-14	581452		0	0	0		0	0	0	7773	0	52	40213296		
28623	2359	1127433	1995-06-07	1995-06-07 00:00:00	1995-07-07	1995-07-07 00:00:00	1995-07-07	38000177		0	0	30		0	0	0	157238	0	313782	1127433		
28679	2366	1127433	1983-06-25	1983-06-25 00:00:00	1983-09-23	1983-09-23 00:00:00	1983-09-23	38000177		0	0	90		0	0	0	157517	0	313782	1127433		
1713	137	1551192	1972-10-23	1972-10-23 00:00:00	1972-10-23	1972-10-23 00:00:00	1972-10-23	38000177		0	0	0		0	0	0	9118	0	312617	1551192		
1445	115	1127433	2011-04-14	2011-04-14 00:00:00	2011-04-28	2011-04-28 00:00:00	2011-04-28	38000177		0	0	14		0	0	0	7638	0	313782	1127433		
12305	1033	1118084	2007-07-17	2007-07-17 00:00:00	2007-07-17	2007-07-17 00:00:00	\N	38000177		0	0	0		0	0	0	67983	0	00025152531	44923712		
41435	3435	1127078	1983-11-08	1983-11-08 00:00:00	1983-12-06	1983-12-06 00:00:00	1983-12-06	38000177		0	0	28		0	0	0	227833	0	282464	1127078		
45940	3803	1115171	2000-12-09	2000-12-09 00:00:00	2001-01-13	2001-01-13 00:00:00	2001-01-13	38000177		0	0	35		0	0	0	252801	0	849574	1115171		
63355	5262	1127433	2008-06-22	2008-06-22 00:00:00	2008-06-29	2008-06-29 00:00:00	2008-06-29	38000177		0	0	7		0	0	0	350122	0	313782	1127433		
22609	1855	1154615	1977-03-27	1977-03-27 00:00:00	1977-03-27	1977-03-27 00:00:00	\N	38000177		0	0	0		0	0	0	124163	0	745679	1154615		
43613	3615	1127433	2011-01-02	2011-01-02 00:00:00	2011-01-09	2011-01-09 00:00:00	2011-01-09	38000177		0	0	7		0	0	0	240203	0	313782	1127433		
50872	4226	1124300	2002-11-28	2002-11-28 00:00:00	2002-11-28	2002-11-28 00:00:00	\N	38000177		0	0	0		0	0	0	280643	0	00781178901	45011828		
60165	1316	40213201	2015-05-26	2015-05-26 00:00:00	2015-05-26	2015-05-26 00:00:00	2015-05-26	581452		0	0	0		0	0	0	87208	0	33	40213201		
60583	5039	1332419	2008-12-30	2008-12-30 00:00:00	2008-12-30	2008-12-30 00:00:00	\N	38000177		0	0	0		0	0	0	334908	0	197361	1332419		
29296	2424	1713671	1968-09-16	1968-09-16 00:00:00	1968-09-23	1968-09-23 00:00:00	1968-09-23	38000177		0	0	7		0	0	0	160801	0	562251	1713671		
29335	2428	1713671	2007-08-29	2007-08-29 00:00:00	2007-09-19	2007-09-19 00:00:00	2007-09-19	38000177		0	0	21		0	0	0	161085	0	562251	1713671		
33464	2771	1127433	1920-09-15	1920-09-15 00:00:00	1920-09-29	1920-09-29 00:00:00	1920-09-29	38000177		0	0	14		0	0	0	183508	0	313782	1127433		
26427	2174	46233988	1974-12-27	1974-12-27 00:00:00	1975-01-10	1975-01-10 00:00:00	1975-01-10	38000177		0	0	14		0	0	0	144939	0	1652673	46233988		
39937	3304	1127433	1977-07-15	1977-07-15 00:00:00	1977-10-13	1977-10-13 00:00:00	1977-10-13	38000177		0	0	90		0	0	0	219485	0	313782	1127433		
39997	3311	1127433	2012-01-07	2012-01-07 00:00:00	2012-01-21	2012-01-21 00:00:00	2012-01-21	38000177		0	0	14		0	0	0	219832	0	313782	1127433		
11110	925	19078461	2018-02-01	2018-02-01 00:00:00	2018-03-03	2018-03-03 00:00:00	2018-03-03	38000177		0	0	30		0	0	0	61642	0	310965	19078461		
11426	951	19006318	1957-11-22	1957-11-22 00:00:00	1957-12-06	1957-12-06 00:00:00	1957-12-06	38000177		0	0	14		0	0	0	63168	0	105078	19006318		
54558	4532	19059056	1984-03-03	1984-03-03 00:00:00	1984-05-02	1984-05-02 00:00:00	1984-05-02	38000177		0	0	60		0	0	0	301893	0	243670	19059056		
47138	3906	1127433	1989-10-18	1989-10-18 00:00:00	1989-10-25	1989-10-25 00:00:00	1989-10-25	38000177		0	0	7		0	0	0	259676	0	313782	1127433		
70468	1541	40213260	2013-04-29	2013-04-29 00:00:00	2013-04-29	2013-04-29 00:00:00	2013-04-29	581452		0	0	0		0	0	0	103260	0	121	40213260		
22477	487	40213296	2006-12-20	2006-12-20 00:00:00	2006-12-20	2006-12-20 00:00:00	2006-12-20	581452		0	0	0		0	0	0	32588	0	52	40213296		
94654	2076	40213227	2018-01-04	2018-01-04 00:00:00	2018-01-04	2018-01-04 00:00:00	2018-01-04	581452		0	0	0		0	0	0	138161	0	113	40213227		
8515	183	40213314	1977-09-29	1977-09-29 00:00:00	1977-09-29	1977-09-29 00:00:00	1977-09-29	581452		0	0	0		0	0	0	12342	0	49	40213314		
33402	729	40213260	2012-07-07	2012-07-07 00:00:00	2012-07-07	2012-07-07 00:00:00	2012-07-07	581452		0	0	0		0	0	0	48382	0	121	40213260		
13200	1107	19059056	1928-08-10	1928-08-10 00:00:00	1928-08-24	1928-08-24 00:00:00	1928-08-24	38000177		0	0	14		0	0	0	72916	0	243670	19059056		
42924	3559	1127433	1967-04-08	1967-04-08 00:00:00	1967-04-29	1967-04-29 00:00:00	1967-04-29	38000177		0	0	21		0	0	0	236258	0	313782	1127433		
44816	975	40213260	2015-03-15	2015-03-15 00:00:00	2015-03-15	2015-03-15 00:00:00	2015-03-15	581452		0	0	0		0	0	0	65016	0	121	40213260		
31563	687	40213160	1967-07-01	1967-07-01 00:00:00	1967-07-01	1967-07-01 00:00:00	1967-07-01	581452		0	0	0		0	0	0	45525	0	10	40213160		
53803	4473	40236824	1999-08-28	1999-08-28 00:00:00	1999-09-04	1999-09-04 00:00:00	1999-09-04	38000177		0	0	7		0	0	0	297565	0	1094107	40236824		
104743	2297	40213227	1996-02-08	1996-02-08 00:00:00	1996-02-08	1996-02-08 00:00:00	1996-02-08	581452		0	0	0		0	0	0	152925	0	113	40213227		
1068	23	40213314	1979-11-15	1979-11-15 00:00:00	1979-11-15	1979-11-15 00:00:00	1979-11-15	581452		0	0	0		0	0	0	1769	0	49	40213314		
27886	2307	19078461	1985-07-16	1985-07-16 00:00:00	1985-07-30	1985-07-30 00:00:00	1985-07-30	38000177		0	0	14		0	0	0	153490	0	310965	19078461		
30972	2566	1127433	2012-01-07	2012-01-07 00:00:00	2012-02-11	2012-02-11 00:00:00	2012-02-11	38000177		0	0	35		0	0	0	170037	0	313782	1127433		
64205	5329	1713671	1979-04-20	1979-04-20 00:00:00	1979-05-04	1979-05-04 00:00:00	1979-05-04	38000177		0	0	14		0	0	0	354790	0	562251	1713671		
262	19	40229134	2007-04-21	2007-04-21 00:00:00	2007-04-28	2007-04-28 00:00:00	2007-04-28	38000177		0	0	7		0	0	0	1454	0	1043400	40229134		
17847	1478	1127433	1975-09-05	1975-09-05 00:00:00	1975-09-19	1975-09-19 00:00:00	1975-09-19	38000177		0	0	14		0	0	0	98652	0	313782	1127433		
10846	905	19059056	1972-02-03	1972-02-03 00:00:00	1972-02-17	1972-02-17 00:00:00	1972-02-17	38000177		0	0	14		0	0	0	60158	0	243670	19059056		
25727	2116	40165015	2012-10-07	2012-10-07 00:00:00	2012-10-07	2012-10-07 00:00:00	\N	38000177		0	0	0		0	0	0	140841	0	861467	40165015		
18261	1512	42902245	1998-04-17	1998-04-17 00:00:00	1998-12-09	1998-12-09 00:00:00	1998-12-09	38000177		0	0	236		0	0	0	100965	0	1359133	42902245		
59654	4960	1127433	1964-10-19	1964-10-19 00:00:00	1964-11-02	1964-11-02 00:00:00	1964-11-02	38000177		0	0	14		0	0	0	329710	0	313782	1127433		
27464	2274	1115171	2008-07-18	2008-07-18 00:00:00	2008-08-01	2008-08-01 00:00:00	2008-08-01	38000177		0	0	14		0	0	0	151211	0	849574	1115171		
18423	1525	1127433	1977-07-20	1977-07-20 00:00:00	1977-07-27	1977-07-27 00:00:00	1977-07-27	38000177		0	0	7		0	0	0	101964	0	313782	1127433		
45745	3787	19133768	2016-08-27	2016-08-27 00:00:00	2016-08-27	2016-08-27 00:00:00	2016-08-27	38000177		0	0	0		0	0	0	251789	0	833036	19133768		
34215	747	40213296	2004-07-24	2004-07-24 00:00:00	2004-07-24	2004-07-24 00:00:00	2004-07-24	581452		0	0	0		0	0	0	49486	0	52	40213296		
19750	1626	19133905	1958-09-15	1958-09-15 00:00:00	1958-09-26	1958-09-26 00:00:00	1958-09-26	38000177		0	0	11		0	0	0	109203	0	834102	19133905		
27174	2240	1118084	2000-04-04	2000-04-04 00:00:00	2000-04-04	2000-04-04 00:00:00	\N	38000177		0	0	0		0	0	0	149111	0	00025152531	44923712		
56390	4678	1713671	1972-03-06	1972-03-06 00:00:00	1972-03-27	1972-03-27 00:00:00	1972-03-27	38000177		0	0	21		0	0	0	311738	0	562251	1713671		
37735	3119	1127433	2012-06-16	2012-06-16 00:00:00	2012-07-07	2012-07-07 00:00:00	2012-07-07	38000177		0	0	21		0	0	0	207539	0	313782	1127433		
32680	712	40213227	2016-08-11	2016-08-11 00:00:00	2016-08-11	2016-08-11 00:00:00	2016-08-11	581452		0	0	0		0	0	0	47259	0	113	40213227		
32485	2693	920300	1983-11-04	1983-11-04 00:00:00	1983-11-11	1983-11-11 00:00:00	1983-11-11	38000177		0	0	7		0	0	0	178368	0	311989	920300		
41274	3422	46275916	1973-11-12	1973-11-12 00:00:00	1973-11-12	1973-11-12 00:00:00	1973-11-12	38000177		0	0	0		0	0	0	226979	0	1660014	46275916		
1973	158	19059056	1975-02-09	1975-02-09 00:00:00	1975-02-23	1975-02-23 00:00:00	1975-02-23	38000177		0	0	14		0	0	0	10851	0	243670	19059056		
63237	5253	40231925	1971-04-20	1971-04-20 00:00:00	1971-04-20	1971-04-20 00:00:00	\N	38000177		0	0	0		0	0	0	349571	0	1049221	40231925		
20875	1720	1127433	1991-09-26	1991-09-26 00:00:00	1991-10-03	1991-10-03 00:00:00	1991-10-03	38000177		0	0	7		0	0	0	115030	0	313782	1127433		
7437	621	19059056	1915-11-04	1915-11-04 00:00:00	1915-11-18	1915-11-18 00:00:00	1915-11-18	38000177		0	0	14		0	0	0	41367	0	243670	19059056		
4947	411	1713671	2002-07-13	2002-07-13 00:00:00	2002-08-03	2002-08-03 00:00:00	2002-08-03	38000177		0	0	21		0	0	0	27335	0	562251	1713671		
34311	2835	19059056	1914-12-02	1914-12-02 00:00:00	1914-12-23	1914-12-23 00:00:00	1914-12-23	38000177		0	0	21		0	0	0	188300	0	243670	19059056		
35511	2926	1713671	2006-02-23	2006-02-23 00:00:00	2006-03-09	2006-03-09 00:00:00	2006-03-09	38000177		0	0	14		0	0	0	195145	0	562251	1713671		
33254	726	40213260	2006-09-17	2006-09-17 00:00:00	2006-09-17	2006-09-17 00:00:00	2006-09-17	581452		0	0	0		0	0	0	48083	0	121	40213260		
5406	117	40213227	2010-04-10	2010-04-10 00:00:00	2010-04-10	2010-04-10 00:00:00	2010-04-10	581452		0	0	0		0	0	0	7784	0	113	40213227		
28624	2359	1127433	1984-11-14	1984-11-14 00:00:00	1984-11-21	1984-11-21 00:00:00	1984-11-21	38000177		0	0	7		0	0	0	157179	0	313782	1127433		
28681	2366	19128065	1980-09-04	1980-09-04 00:00:00	1981-08-30	1981-08-30 00:00:00	1981-08-30	38000177		0	0	360		0	0	0	157487	0	749882	19128065		
1714	137	1118084	2005-04-12	2005-04-12 00:00:00	2005-04-12	2005-04-12 00:00:00	\N	38000177		0	0	0		0	0	0	9150	0	00025152531	44923712		
1446	115	40236824	1976-02-17	1976-02-17 00:00:00	1976-03-02	1976-03-02 00:00:00	1976-03-02	38000177		0	0	14		0	0	0	7573	0	1094107	40236824		
12306	1033	19133873	1983-03-31	1983-03-31 00:00:00	1983-04-13	1983-04-13 00:00:00	1983-04-13	38000177		0	0	13		0	0	0	67987	0	834061	19133873		
41436	3435	1127078	1978-04-10	1978-04-10 00:00:00	1978-04-24	1978-04-24 00:00:00	1978-04-24	38000177		0	0	14		0	0	0	227800	0	282464	1127078		
73264	1600	40213198	2011-09-05	2011-09-05 00:00:00	2011-09-05	2011-09-05 00:00:00	2011-09-05	581452		0	0	0		0	0	0	107463	0	133	40213198		
63356	5262	1115171	2007-01-29	2007-01-29 00:00:00	2007-02-19	2007-02-19 00:00:00	2007-02-19	38000177		0	0	21		0	0	0	350076	0	849574	1115171		
22610	1855	19019979	1979-10-10	1979-10-10 00:00:00	1979-10-31	1979-10-31 00:00:00	1979-10-31	38000177		0	0	21		0	0	0	124136	0	198405	19019979		
117388	2580	40213227	2000-02-28	2000-02-28 00:00:00	2000-02-28	2000-02-28 00:00:00	2000-02-28	581452		0	0	0		0	0	0	170885	0	113	40213227		
50873	4226	1127433	2017-10-21	2017-10-21 00:00:00	2017-11-11	2017-11-11 00:00:00	2017-11-11	38000177		0	0	21		0	0	0	280762	0	313782	1127433		
60171	1316	40213227	2010-09-07	2010-09-07 00:00:00	2010-09-07	2010-09-07 00:00:00	2010-09-07	581452		0	0	0		0	0	0	87205	0	113	40213227		
60584	5039	1118084	2010-10-02	2010-10-02 00:00:00	2010-10-02	2010-10-02 00:00:00	\N	38000177		0	0	0		0	0	0	334908	0	00025152531	44923712		
29297	2425	19078461	2003-01-08	2003-01-08 00:00:00	2003-01-22	2003-01-22 00:00:00	2003-01-22	38000177		0	0	14		0	0	0	160874	0	310965	19078461		
29336	2428	1713671	1987-03-08	1987-03-08 00:00:00	1987-03-29	1987-03-29 00:00:00	1987-03-29	38000177		0	0	21		0	0	0	161093	0	562251	1713671		
33465	2771	40220960	1991-10-18	1991-10-18 00:00:00	1991-10-18	1991-10-18 00:00:00	1991-10-18	38000177		0	0	0		0	0	0	183504	0	1804799	40220960		
26428	2174	1713671	1995-03-15	1995-03-15 00:00:00	1995-03-29	1995-03-29 00:00:00	1995-03-29	38000177		0	0	14		0	0	0	144929	0	562251	1713671		
39938	3304	40229134	1997-06-06	1997-06-06 00:00:00	1997-06-13	1997-06-13 00:00:00	1997-06-13	38000177		0	0	7		0	0	0	219447	0	1043400	40229134		
39998	3311	19133905	2015-10-02	2015-10-02 00:00:00	2015-10-12	2015-10-12 00:00:00	2015-10-12	38000177		0	0	10		0	0	0	219817	0	834102	19133905		
11111	925	1115171	1999-04-21	1999-04-21 00:00:00	1999-07-20	1999-07-20 00:00:00	1999-07-20	38000177		0	0	90		0	0	0	61600	0	849574	1115171		
11427	951	1127433	1966-12-14	1966-12-14 00:00:00	1967-01-04	1967-01-04 00:00:00	1967-01-04	38000177		0	0	21		0	0	0	63218	0	313782	1127433		
54559	4532	40165015	1984-03-03	1984-03-03 00:00:00	1984-03-03	1984-03-03 00:00:00	\N	38000177		0	0	0		0	0	0	301893	0	861467	40165015		
47139	3906	1127433	1955-07-17	1955-07-17 00:00:00	1955-07-24	1955-07-24 00:00:00	1955-07-24	38000177		0	0	7		0	0	0	259671	0	313782	1127433		
70471	1541	40213160	1968-04-08	1968-04-08 00:00:00	1968-04-08	1968-04-08 00:00:00	1968-04-08	581452		0	0	0		0	0	0	103296	0	10	40213160		
22479	487	40213227	2006-12-20	2006-12-20 00:00:00	2006-12-20	2006-12-20 00:00:00	2006-12-20	581452		0	0	0		0	0	0	32588	0	113	40213227		
94655	2076	40213260	2018-01-04	2018-01-04 00:00:00	2018-01-04	2018-01-04 00:00:00	2018-01-04	581452		0	0	0		0	0	0	138161	0	121	40213260		
8521	183	40213314	1978-03-30	1978-03-30 00:00:00	1978-03-30	1978-03-30 00:00:00	1978-03-30	581452		0	0	0		0	0	0	12364	0	49	40213314		
33403	729	40213160	1961-10-07	1961-10-07 00:00:00	1961-10-07	1961-10-07 00:00:00	1961-10-07	581452		0	0	0		0	0	0	48399	0	10	40213160		
13201	1107	19133905	2002-05-30	2002-05-30 00:00:00	2002-06-06	2002-06-06 00:00:00	2002-06-06	38000177		0	0	7		0	0	0	72930	0	834102	19133905		
42925	3559	19059056	1950-05-23	1950-05-23 00:00:00	1950-06-06	1950-06-06 00:00:00	1950-06-06	38000177		0	0	14		0	0	0	236247	0	243670	19059056		
44818	975	40213227	1997-11-02	1997-11-02 00:00:00	1997-11-02	1997-11-02 00:00:00	1997-11-02	581452		0	0	0		0	0	0	65052	0	113	40213227		
6047	505	46233988	1972-04-27	1972-04-27 00:00:00	1972-05-11	1972-05-11 00:00:00	1972-05-11	38000177		0	0	14		0	0	0	33792	0	1652673	46233988		
53804	4473	920300	1999-08-28	1999-08-28 00:00:00	1999-09-04	1999-09-04 00:00:00	1999-09-04	38000177		0	0	7		0	0	0	297565	0	311989	920300		
104744	2297	40213306	1996-02-08	1996-02-08 00:00:00	1996-02-08	1996-02-08 00:00:00	1996-02-08	581452		0	0	0		0	0	0	152925	0	43	40213306		
1071	23	40213251	1984-08-23	1984-08-23 00:00:00	1984-08-23	1984-08-23 00:00:00	1984-08-23	581452		0	0	0		0	0	0	1809	0	21	40213251		
27887	2307	19133873	1973-11-01	1973-11-01 00:00:00	1973-11-09	1973-11-09 00:00:00	1973-11-09	38000177		0	0	8		0	0	0	153527	0	834061	19133873		
30973	2566	19059056	1941-02-15	1941-02-15 00:00:00	1941-03-01	1941-03-01 00:00:00	1941-03-01	38000177		0	0	14		0	0	0	169947	0	243670	19059056		
64206	5329	1127433	1947-01-03	1947-01-03 00:00:00	1947-01-17	1947-01-17 00:00:00	1947-01-17	38000177		0	0	14		0	0	0	354740	0	313782	1127433		
265	19	40174880	2004-01-17	2004-01-17 00:00:00	2004-01-17	2004-01-17 00:00:00	\N	38000177		0	0	0		0	0	0	1497	0	966222	40174880		
17848	1478	1127433	1980-07-26	1980-07-26 00:00:00	1980-08-02	1980-08-02 00:00:00	1980-08-02	38000177		0	0	7		0	0	0	98615	0	313782	1127433		
10847	905	46233988	1974-06-17	1974-06-17 00:00:00	1974-07-01	1974-07-01 00:00:00	1974-07-01	38000177		0	0	14		0	0	0	60216	0	1652673	46233988		
25728	2116	19078461	2012-10-07	2012-10-07 00:00:00	2012-11-11	2012-11-11 00:00:00	2012-11-11	38000177		0	0	35		0	0	0	140841	0	310965	19078461		
18262	1512	40224805	1995-05-03	1995-05-03 00:00:00	1996-04-27	1996-04-27 00:00:00	1996-04-27	38000177		0	0	360		0	0	0	100963	0	1000126	40224805		
59655	4960	19059056	1952-08-11	1952-08-11 00:00:00	1952-09-01	1952-09-01 00:00:00	1952-09-01	38000177		0	0	21		0	0	0	329708	0	243670	19059056		
27465	2274	40229134	1967-09-19	1967-09-19 00:00:00	1967-10-03	1967-10-03 00:00:00	1967-10-03	38000177		0	0	14		0	0	0	151135	0	1043400	40229134		
18424	1525	1118084	1998-10-11	1998-10-11 00:00:00	1998-10-11	1998-10-11 00:00:00	\N	38000177		0	0	0		0	0	0	101983	0	00025152531	44923712		
45746	3787	1545959	2016-08-27	2016-08-27 00:00:00	2016-08-27	2016-08-27 00:00:00	2016-08-27	38000177		0	0	0		0	0	0	251789	0	259255	1545959		
48615	4027	40243436	2014-06-21	2014-06-21 00:00:00	2014-06-21	2014-06-21 00:00:00	2014-06-21	38000177		0	0	0		0	0	0	267885	0	1190795	40243436		
19751	1626	1713671	1995-01-25	1995-01-25 00:00:00	1995-02-01	1995-02-01 00:00:00	1995-02-01	38000177		0	0	7		0	0	0	109278	0	562251	1713671		
27179	2242	1713671	1977-07-06	1977-07-06 00:00:00	1977-07-20	1977-07-20 00:00:00	1977-07-20	38000177		0	0	14		0	0	0	149220	0	562251	1713671		
56391	4678	19059056	1957-08-13	1957-08-13 00:00:00	1957-09-03	1957-09-03 00:00:00	1957-09-03	38000177		0	0	21		0	0	0	311726	0	243670	19059056		
37736	3119	1127433	2008-06-27	2008-06-27 00:00:00	2008-07-04	2008-07-04 00:00:00	2008-07-04	38000177		0	0	7		0	0	0	207577	0	313782	1127433		
32681	712	40213160	1975-04-17	1975-04-17 00:00:00	1975-04-17	1975-04-17 00:00:00	1975-04-17	581452		0	0	0		0	0	0	47248	0	10	40213160		
32486	2693	1713671	1976-09-22	1976-09-22 00:00:00	1976-10-06	1976-10-06 00:00:00	1976-10-06	38000177		0	0	14		0	0	0	178374	0	562251	1713671		
41275	3422	1310034	1973-11-12	1973-11-12 00:00:00	1973-11-12	1973-11-12 00:00:00	1973-11-12	38000177		0	0	0		0	0	0	226979	0	834357	1310034		
1974	158	1127433	1992-06-23	1992-06-23 00:00:00	1992-07-07	1992-07-07 00:00:00	1992-07-07	38000177		0	0	14		0	0	0	10791	0	313782	1127433		
63238	5253	1118084	1996-01-14	1996-01-14 00:00:00	1996-01-14	1996-01-14 00:00:00	\N	38000177		0	0	0		0	0	0	349508	0	00025152531	44923712		
20876	1720	19133873	1980-02-27	1980-02-27 00:00:00	1980-03-09	1980-03-09 00:00:00	1980-03-09	38000177		0	0	11		0	0	0	115028	0	834061	19133873		
7438	621	19078461	1982-12-10	1982-12-10 00:00:00	1982-12-31	1982-12-31 00:00:00	1982-12-31	38000177		0	0	21		0	0	0	41488	0	310965	19078461		
4948	411	1124300	2003-03-02	2003-03-02 00:00:00	2003-03-02	2003-03-02 00:00:00	\N	38000177		0	0	0		0	0	0	27379	0	00781178901	45011828		
34312	2835	1127433	1989-10-21	1989-10-21 00:00:00	1989-11-27	1989-11-27 00:00:00	1989-11-27	38000177		0	0	37		0	0	0	188344	0	313782	1127433		
35512	2926	42902245	1998-08-30	1998-08-30 00:00:00	1999-08-25	1999-08-25 00:00:00	1999-08-25	38000177		0	0	360		0	0	0	195143	0	1359133	42902245		
33258	726	40213160	1958-08-10	1958-08-10 00:00:00	1958-08-10	1958-08-10 00:00:00	1958-08-10	581452		0	0	0		0	0	0	48098	0	10	40213160		
5407	117	40213296	2010-04-10	2010-04-10 00:00:00	2010-04-10	2010-04-10 00:00:00	2010-04-10	581452		0	0	0		0	0	0	7784	0	52	40213296		
28625	2359	19133905	1962-11-18	1962-11-18 00:00:00	1962-11-27	1962-11-27 00:00:00	1962-11-27	38000177		0	0	9		0	0	0	157177	0	834102	19133905		
28682	2366	19133873	1978-10-04	1978-10-04 00:00:00	1978-10-11	1978-10-11 00:00:00	1978-10-11	38000177		0	0	7		0	0	0	157528	0	834061	19133873		
1715	137	19019979	1974-03-16	1974-03-16 00:00:00	1974-04-06	1974-04-06 00:00:00	1974-04-06	38000177		0	0	21		0	0	0	9119	0	198405	19019979		
1447	115	920300	1976-02-17	1976-02-17 00:00:00	1976-02-24	1976-02-24 00:00:00	1976-02-24	38000177		0	0	7		0	0	0	7573	0	311989	920300		
12307	1033	964261	1999-07-29	1999-07-29 00:00:00	1999-07-29	1999-07-29 00:00:00	\N	38000177		0	0	0		0	0	0	67973	0	2001499	964261		
41437	3435	1118084	2016-06-29	2016-06-29 00:00:00	2016-06-29	2016-06-29 00:00:00	\N	38000177		0	0	0		0	0	0	227788	0	00025152531	44923712		
73272	1600	40213227	2007-10-15	2007-10-15 00:00:00	2007-10-15	2007-10-15 00:00:00	2007-10-15	581452		0	0	0		0	0	0	107381	0	113	40213227		
63357	5262	1127433	1983-12-27	1983-12-27 00:00:00	1984-01-10	1984-01-10 00:00:00	1984-01-10	38000177		0	0	14		0	0	0	350101	0	313782	1127433		
22611	1855	1127433	1998-11-16	1998-11-16 00:00:00	1998-11-23	1998-11-23 00:00:00	1998-11-23	38000177		0	0	7		0	0	0	124144	0	313782	1127433		
117389	2580	40213296	2000-02-28	2000-02-28 00:00:00	2000-02-28	2000-02-28 00:00:00	2000-02-28	581452		0	0	0		0	0	0	170885	0	52	40213296		
50874	4226	40229134	1995-12-09	1995-12-09 00:00:00	1995-12-16	1995-12-16 00:00:00	1995-12-16	38000177		0	0	7		0	0	0	280642	0	1043400	40229134		
60191	1316	40213160	1955-04-12	1955-04-12 00:00:00	1955-04-12	1955-04-12 00:00:00	1955-04-12	581452		0	0	0		0	0	0	87162	0	10	40213160		
49424	1082	40213160	1956-04-28	1956-04-28 00:00:00	1956-04-28	1956-04-28 00:00:00	1956-04-28	581452		0	0	0		0	0	0	70928	0	10	40213160		
29298	2425	19078461	1991-04-27	1991-04-27 00:00:00	1991-05-11	1991-05-11 00:00:00	1991-05-11	38000177		0	0	14		0	0	0	160873	0	310965	19078461		
29337	2428	920300	2002-08-03	2002-08-03 00:00:00	2002-08-10	2002-08-10 00:00:00	2002-08-10	38000177		0	0	7		0	0	0	161097	0	311989	920300		
33466	2771	19018935	1978-01-20	1978-01-20 00:00:00	1978-01-20	1978-01-20 00:00:00	\N	38000177		0	0	0		0	0	0	183520	0	197604	19018935		
26429	2175	19059056	1977-09-20	1977-09-20 00:00:00	1977-10-04	1977-10-04 00:00:00	1977-10-04	38000177		0	0	14		0	0	0	144973	0	243670	19059056		
39955	3307	19133905	1995-05-03	1995-05-03 00:00:00	1995-05-15	1995-05-15 00:00:00	1995-05-15	38000177		0	0	12		0	0	0	219616	0	834102	19133905		
39999	3311	19133905	2011-09-12	2011-09-12 00:00:00	2011-09-20	2011-09-20 00:00:00	2011-09-20	38000177		0	0	8		0	0	0	219769	0	834102	19133905		
11112	925	19133905	1999-09-22	1999-09-22 00:00:00	1999-10-04	1999-10-04 00:00:00	1999-10-04	38000177		0	0	12		0	0	0	61602	0	834102	19133905		
11428	951	19073188	2008-02-24	2008-02-24 00:00:00	2008-03-09	2008-03-09 00:00:00	2008-03-09	38000177		0	0	14		0	0	0	63142	0	308192	19073188		
54560	4532	1127433	1980-06-28	1980-06-28 00:00:00	1980-07-12	1980-07-12 00:00:00	1980-07-12	38000177		0	0	14		0	0	0	301920	0	313782	1127433		
47140	3906	1713671	1945-08-13	1945-08-13 00:00:00	1945-08-27	1945-08-27 00:00:00	1945-08-27	38000177		0	0	14		0	0	0	259670	0	562251	1713671		
70477	1541	40213227	2014-05-05	2014-05-05 00:00:00	2014-05-05	2014-05-05 00:00:00	2014-05-05	581452		0	0	0		0	0	0	103288	0	113	40213227		
22482	488	40213160	1959-09-11	1959-09-11 00:00:00	1959-09-11	1959-09-11 00:00:00	1959-09-11	581452		0	0	0		0	0	0	32632	0	10	40213160		
94658	2077	40213227	2004-07-25	2004-07-25 00:00:00	2004-07-25	2004-07-25 00:00:00	2004-07-25	581452		0	0	0		0	0	0	138324	0	113	40213227		
8527	183	40213227	2016-11-03	2016-11-03 00:00:00	2016-11-03	2016-11-03 00:00:00	2016-11-03	581452		0	0	0		0	0	0	12389	0	113	40213227		
33406	729	40213160	1962-03-10	1962-03-10 00:00:00	1962-03-10	1962-03-10 00:00:00	1962-03-10	581452		0	0	0		0	0	0	48400	0	10	40213160		
13202	1107	1539411	1991-02-08	1991-02-08 00:00:00	1991-02-08	1991-02-08 00:00:00	\N	38000177		0	0	0		0	0	0	72877	0	312961	1539411		
42926	3559	19006318	1950-05-23	1950-05-23 00:00:00	1950-06-06	1950-06-06 00:00:00	1950-06-06	38000177		0	0	14		0	0	0	236247	0	105078	19006318		
44822	975	40213227	2016-03-20	2016-03-20 00:00:00	2016-03-20	2016-03-20 00:00:00	2016-03-20	581452		0	0	0		0	0	0	65062	0	113	40213227		
6048	505	19078461	1983-10-20	1983-10-20 00:00:00	1983-11-03	1983-11-03 00:00:00	1983-11-03	38000177		0	0	14		0	0	0	33740	0	310965	19078461		
53805	4473	1127433	1996-04-15	1996-04-15 00:00:00	1996-04-29	1996-04-29 00:00:00	1996-04-29	38000177		0	0	14		0	0	0	297596	0	313782	1127433		
104746	2297	40213314	1977-02-10	1977-02-10 00:00:00	1977-02-10	1977-02-10 00:00:00	1977-02-10	581452		0	0	0		0	0	0	152956	0	49	40213314		
12354	266	40213296	2006-05-08	2006-05-08 00:00:00	2006-05-08	2006-05-08 00:00:00	2006-05-08	581452		0	0	0		0	0	0	17634	0	52	40213296		
27888	2307	19059056	1966-08-25	1966-08-25 00:00:00	1966-09-08	1966-09-08 00:00:00	1966-09-08	38000177		0	0	14		0	0	0	153531	0	243670	19059056		
30974	2566	1115171	2014-01-01	2014-01-01 00:00:00	2014-03-02	2014-03-02 00:00:00	2014-03-02	38000177		0	0	60		0	0	0	170038	0	849574	1115171		
64207	5329	1127433	1977-05-01	1977-05-01 00:00:00	1977-05-15	1977-05-15 00:00:00	1977-05-15	38000177		0	0	14		0	0	0	354749	0	313782	1127433		
266	19	1127433	1997-08-25	1997-08-25 00:00:00	1997-09-01	1997-09-01 00:00:00	1997-09-01	38000177		0	0	7		0	0	0	1507	0	313782	1127433		
17850	1478	19078461	2013-08-04	2013-08-04 00:00:00	2013-08-18	2013-08-18 00:00:00	2013-08-18	38000177		0	0	14		0	0	0	98644	0	310965	19078461		
10848	905	19019979	1974-06-17	1974-06-17 00:00:00	1974-07-01	1974-07-01 00:00:00	1974-07-01	38000177		0	0	14		0	0	0	60216	0	198405	19019979		
25729	2116	45892894	2019-01-15	2019-01-15 00:00:00	2019-01-15	2019-01-15 00:00:00	\N	38000177		0	0	0		0	0	0	140789	0	1599803	45892894		
18263	1512	1713671	2005-09-13	2005-09-13 00:00:00	2005-10-04	2005-10-04 00:00:00	2005-10-04	38000177		0	0	21		0	0	0	101005	0	562251	1713671		
59656	4960	1118084	1949-11-28	1949-11-28 00:00:00	1949-11-28	1949-11-28 00:00:00	\N	38000177		0	0	0		0	0	0	329743	0	00025152531	44923712		
27466	2274	1127433	2003-11-05	2003-11-05 00:00:00	2003-11-19	2003-11-19 00:00:00	2003-11-19	38000177		0	0	14		0	0	0	151193	0	313782	1127433		
18425	1525	19128065	1977-07-28	1977-07-28 00:00:00	1978-07-23	1978-07-23 00:00:00	1978-07-23	38000177		0	0	360		0	0	0	101978	0	749882	19128065		
45747	3787	1127433	1980-11-01	1980-11-01 00:00:00	1980-11-15	1980-11-15 00:00:00	1980-11-15	38000177		0	0	14		0	0	0	251786	0	313782	1127433		
48616	4027	46275916	2014-06-21	2014-06-21 00:00:00	2014-06-21	2014-06-21 00:00:00	2014-06-21	38000177		0	0	0		0	0	0	267885	0	1660014	46275916		
19752	1626	46275916	2010-10-10	2010-10-10 00:00:00	2010-10-10	2010-10-10 00:00:00	2010-10-10	38000177		0	0	0		0	0	0	109220	0	1660014	46275916		
27180	2242	1713671	1934-08-09	1934-08-09 00:00:00	1934-08-30	1934-08-30 00:00:00	1934-08-30	38000177		0	0	21		0	0	0	149203	0	562251	1713671		
56392	4678	1713671	1975-06-15	1975-06-15 00:00:00	1975-07-06	1975-07-06 00:00:00	1975-07-06	38000177		0	0	21		0	0	0	311731	0	562251	1713671		
37737	3119	1118084	2015-06-27	2015-06-27 00:00:00	2015-06-27	2015-06-27 00:00:00	\N	38000177		0	0	0		0	0	0	207559	0	00025152531	44923712		
32686	712	40213314	1977-04-14	1977-04-14 00:00:00	1977-04-14	1977-04-14 00:00:00	1977-04-14	581452		0	0	0		0	0	0	47237	0	49	40213314		
32487	2693	19059056	1972-10-30	1972-10-30 00:00:00	1972-11-20	1972-11-20 00:00:00	1972-11-20	38000177		0	0	21		0	0	0	178365	0	243670	19059056		
41276	3422	1118084	2001-08-27	2001-08-27 00:00:00	2001-08-27	2001-08-27 00:00:00	\N	38000177		0	0	0		0	0	0	227013	0	00025152531	44923712		
1975	158	1127078	1950-02-17	1950-02-17 00:00:00	1950-03-10	1950-03-10 00:00:00	1950-03-10	38000177		0	0	21		0	0	0	10848	0	282464	1127078		
63239	5253	1127433	1979-05-08	1979-05-08 00:00:00	1979-08-06	1979-08-06 00:00:00	1979-08-06	38000177		0	0	90		0	0	0	349572	0	313782	1127433		
43898	956	40213227	1996-08-07	1996-08-07 00:00:00	1996-08-07	1996-08-07 00:00:00	1996-08-07	581452		0	0	0		0	0	0	63497	0	113	40213227		
7439	621	40220960	1995-11-29	1995-11-29 00:00:00	1995-11-29	1995-11-29 00:00:00	1995-11-29	38000177		0	0	0		0	0	0	41422	0	1804799	40220960		
4949	411	40229134	1973-11-17	1973-11-17 00:00:00	1973-12-01	1973-12-01 00:00:00	1973-12-01	38000177		0	0	14		0	0	0	27309	0	1043400	40229134		
34313	2835	40229134	1998-01-23	1998-01-23 00:00:00	1998-02-06	1998-02-06 00:00:00	1998-02-06	38000177		0	0	14		0	0	0	188321	0	1043400	40229134		
35513	2926	1713671	2016-01-10	2016-01-10 00:00:00	2016-01-24	2016-01-24 00:00:00	2016-01-24	38000177		0	0	14		0	0	0	195177	0	562251	1713671		
33267	726	40213160	1956-02-05	1956-02-05 00:00:00	1956-02-05	1956-02-05 00:00:00	1956-02-05	581452		0	0	0		0	0	0	48118	0	10	40213160		
20221	1659	1127078	1971-03-07	1971-03-07 00:00:00	1971-03-21	1971-03-21 00:00:00	1971-03-21	38000177		0	0	14		0	0	0	111502	0	282464	1127078		
28626	2359	40220960	2014-10-06	2014-10-06 00:00:00	2014-10-06	2014-10-06 00:00:00	2014-10-06	38000177		0	0	0		0	0	0	157242	0	1804799	40220960		
28683	2366	19059056	1970-07-02	1970-07-02 00:00:00	1970-07-16	1970-07-16 00:00:00	1970-07-16	38000177		0	0	14		0	0	0	157524	0	243670	19059056		
1716	137	19133873	1985-11-10	1985-11-10 00:00:00	1985-11-17	1985-11-17 00:00:00	1985-11-17	38000177		0	0	7		0	0	0	9196	0	834061	19133873		
1449	115	1127433	1997-10-13	1997-10-13 00:00:00	1997-10-27	1997-10-27 00:00:00	1997-10-27	38000177		0	0	14		0	0	0	7575	0	313782	1127433		
44401	3676	19128022	1990-10-08	1990-10-08 00:00:00	1991-10-03	1991-10-03 00:00:00	1991-10-03	38000177		0	0	360		0	0	0	244487	0	749785	19128022		
41438	3435	40229134	1989-08-23	1989-08-23 00:00:00	1989-09-06	1989-09-06 00:00:00	1989-09-06	38000177		0	0	14		0	0	0	227811	0	1043400	40229134		
17515	379	40213314	1978-03-04	1978-03-04 00:00:00	1978-03-04	1978-03-04 00:00:00	1978-03-04	581452		0	0	0		0	0	0	25113	0	49	40213314		
63358	5262	19128022	1993-11-16	1993-11-16 00:00:00	1994-11-11	1994-11-11 00:00:00	1994-11-11	38000177		0	0	360		0	0	0	350128	0	749785	19128022		
22612	1855	1127433	2004-03-22	2004-03-22 00:00:00	2004-04-05	2004-04-05 00:00:00	2004-04-05	38000177		0	0	14		0	0	0	124214	0	313782	1127433		
117393	2580	40213160	1958-09-15	1958-09-15 00:00:00	1958-09-15	1958-09-15 00:00:00	1958-09-15	581452		0	0	0		0	0	0	170898	0	10	40213160		
50876	4227	1127433	1993-10-27	1993-10-27 00:00:00	1993-11-03	1993-11-03 00:00:00	1993-11-03	38000177		0	0	7		0	0	0	280854	0	313782	1127433		
60208	1317	40213160	1955-10-14	1955-10-14 00:00:00	1955-10-14	1955-10-14 00:00:00	1955-10-14	581452		0	0	0		0	0	0	87260	0	10	40213160		
49429	1082	40213160	1959-10-10	1959-10-10 00:00:00	1959-10-10	1959-10-10 00:00:00	1959-10-10	581452		0	0	0		0	0	0	\N	0	10	40213160		
29300	2425	19059056	1965-02-21	1965-02-21 00:00:00	1965-03-07	1965-03-07 00:00:00	1965-03-07	38000177		0	0	14		0	0	0	160917	0	243670	19059056		
29338	2428	40236824	2002-08-03	2002-08-03 00:00:00	2002-08-10	2002-08-10 00:00:00	2002-08-10	38000177		0	0	7		0	0	0	161097	0	1094107	40236824		
33467	2771	40163554	1978-01-20	1978-01-20 00:00:00	1978-01-20	1978-01-20 00:00:00	\N	38000177		0	0	0		0	0	0	183520	0	855332	40163554		
26430	2175	46233988	1977-09-20	1977-09-20 00:00:00	1977-10-04	1977-10-04 00:00:00	1977-10-04	38000177		0	0	14		0	0	0	144973	0	1652673	46233988		
39956	3307	19059056	1972-09-15	1972-09-15 00:00:00	1972-10-15	1972-10-15 00:00:00	1972-10-15	38000177		0	0	30		0	0	0	219553	0	243670	19059056		
40000	3311	19008572	1990-03-21	1990-03-21 00:00:00	1990-03-21	1990-03-21 00:00:00	\N	38000177		0	0	0		0	0	0	219862	0	106258	19008572		
11113	925	1115171	2008-07-02	2008-07-02 00:00:00	2008-07-23	2008-07-23 00:00:00	2008-07-23	38000177		0	0	21		0	0	0	61641	0	849574	1115171		
11429	951	19078461	2008-02-24	2008-02-24 00:00:00	2008-03-09	2008-03-09 00:00:00	2008-03-09	38000177		0	0	14		0	0	0	63142	0	310965	19078461		
54561	4532	19059056	1946-03-04	1946-03-04 00:00:00	1946-03-18	1946-03-18 00:00:00	1946-03-18	38000177		0	0	14		0	0	0	301938	0	243670	19059056		
47141	3906	1127433	2004-05-03	2004-05-03 00:00:00	2004-06-07	2004-06-07 00:00:00	2004-06-07	38000177		0	0	35		0	0	0	259753	0	313782	1127433		
70478	1541	40213260	2014-05-05	2014-05-05 00:00:00	2014-05-05	2014-05-05 00:00:00	2014-05-05	581452		0	0	0		0	0	0	103288	0	121	40213260		
22484	488	40213160	1955-01-07	1955-01-07 00:00:00	1955-01-07	1955-01-07 00:00:00	1955-01-07	581452		0	0	0		0	0	0	32687	0	10	40213160		
94662	2077	40213227	1994-05-29	1994-05-29 00:00:00	1994-05-29	1994-05-29 00:00:00	1994-05-29	581452		0	0	0		0	0	0	138294	0	113	40213227		
24173	525	40213198	2014-06-30	2014-06-30 00:00:00	2014-06-30	2014-06-30 00:00:00	2014-06-30	581452		0	0	0		0	0	0	35023	0	133	40213198		
33409	729	40213260	2011-07-02	2011-07-02 00:00:00	2011-07-02	2011-07-02 00:00:00	2011-07-02	581452		0	0	0		0	0	0	48395	0	121	40213260		
13203	1107	19059056	1927-12-14	1927-12-14 00:00:00	1928-03-13	1928-03-13 00:00:00	1928-03-13	38000177		0	0	90		0	0	0	72861	0	243670	19059056		
42927	3559	1127433	1975-11-13	1975-11-13 00:00:00	1975-12-11	1975-12-11 00:00:00	1975-12-11	38000177		0	0	28		0	0	0	236259	0	313782	1127433		
44823	975	40213260	2016-03-20	2016-03-20 00:00:00	2016-03-20	2016-03-20 00:00:00	2016-03-20	581452		0	0	0		0	0	0	65062	0	121	40213260		
6049	505	19075001	1983-10-20	1983-10-20 00:00:00	1983-11-03	1983-11-03 00:00:00	1983-11-03	38000177		0	0	14		0	0	0	33740	0	309097	19075001		
53806	4473	1118084	2012-06-29	2012-06-29 00:00:00	2012-06-29	2012-06-29 00:00:00	\N	38000177		0	0	0		0	0	0	297625	0	00025152531	44923712		
104750	2297	40213227	2005-02-17	2005-02-17 00:00:00	2005-02-17	2005-02-17 00:00:00	2005-02-17	581452		0	0	0		0	0	0	152951	0	113	40213227		
12355	266	40213160	1971-04-12	1971-04-12 00:00:00	1971-04-12	1971-04-12 00:00:00	1971-04-12	581452		0	0	0		0	0	0	17666	0	10	40213160		
38347	3172	1127433	1986-11-21	1986-11-21 00:00:00	1986-11-28	1986-11-28 00:00:00	1986-11-28	38000177		0	0	7		0	0	0	210851	0	313782	1127433		
30975	2566	19059056	1942-03-27	1942-03-27 00:00:00	1942-04-10	1942-04-10 00:00:00	1942-04-10	38000177		0	0	14		0	0	0	170043	0	243670	19059056		
64208	5329	19078461	2011-02-25	2011-02-25 00:00:00	2011-03-25	2011-03-25 00:00:00	2011-03-25	38000177		0	0	28		0	0	0	354835	0	310965	19078461		
270	19	1713671	2018-08-13	2018-08-13 00:00:00	2018-08-20	2018-08-20 00:00:00	2018-08-20	38000177		0	0	7		0	0	0	1455	0	562251	1713671		
98624	2160	40213306	1982-09-13	1982-09-13 00:00:00	1982-09-13	1982-09-13 00:00:00	1982-09-13	581452		0	0	0		0	0	0	143993	0	43	40213306		
10849	905	46233988	1972-06-25	1972-06-25 00:00:00	1972-07-09	1972-07-09 00:00:00	1972-07-09	38000177		0	0	14		0	0	0	60173	0	1652673	46233988		
25730	2116	40229134	2005-12-02	2005-12-02 00:00:00	2005-12-16	2005-12-16 00:00:00	2005-12-16	38000177		0	0	14		0	0	0	140847	0	1043400	40229134		
18264	1512	40229134	1983-04-05	1983-04-05 00:00:00	1983-04-12	1983-04-12 00:00:00	1983-04-12	38000177		0	0	7		0	0	0	100952	0	1043400	40229134		
59657	4960	1713671	1943-05-05	1943-05-05 00:00:00	1943-05-12	1943-05-12 00:00:00	1943-05-12	38000177		0	0	7		0	0	0	329657	0	562251	1713671		
27467	2274	1127433	1966-07-26	1966-07-26 00:00:00	1966-08-09	1966-08-09 00:00:00	1966-08-09	38000177		0	0	14		0	0	0	151207	0	313782	1127433		
18426	1525	1115171	2013-02-09	2013-02-09 00:00:00	2013-02-23	2013-02-23 00:00:00	2013-02-23	38000177		0	0	14		0	0	0	102032	0	849574	1115171		
45748	3787	1127433	1979-09-28	1979-09-28 00:00:00	1979-10-12	1979-10-12 00:00:00	1979-10-12	38000177		0	0	14		0	0	0	251773	0	313782	1127433		
48617	4027	1310034	2014-06-21	2014-06-21 00:00:00	2014-06-21	2014-06-21 00:00:00	2014-06-21	38000177		0	0	0		0	0	0	267885	0	834357	1310034		
19753	1626	40243436	2010-10-10	2010-10-10 00:00:00	2010-10-10	2010-10-10 00:00:00	2010-10-10	38000177		0	0	0		0	0	0	109220	0	1190795	40243436		
27181	2242	19075601	2013-12-21	2013-12-21 00:00:00	2013-12-21	2013-12-21 00:00:00	2013-12-21	38000177		0	0	0		0	0	0	149279	0	309362	19075601		
56393	4678	1127433	2017-12-01	2017-12-01 00:00:00	2017-12-22	2017-12-22 00:00:00	2017-12-22	38000177		0	0	21		0	0	0	311728	0	313782	1127433		
37738	3119	19059056	1982-01-05	1982-01-05 00:00:00	1982-01-19	1982-01-19 00:00:00	1982-01-19	38000177		0	0	14		0	0	0	207535	0	243670	19059056		
13876	299	40213227	1993-03-27	1993-03-27 00:00:00	1993-03-27	1993-03-27 00:00:00	1993-03-27	581452		0	0	0		0	0	0	19987	0	113	40213227		
32488	2693	40229134	2014-01-03	2014-01-03 00:00:00	2014-01-17	2014-01-17 00:00:00	2014-01-17	38000177		0	0	14		0	0	0	178430	0	1043400	40229134		
41277	3422	19133873	1975-03-08	1975-03-08 00:00:00	1975-03-19	1975-03-19 00:00:00	1975-03-19	38000177		0	0	11		0	0	0	226953	0	834061	19133873		
1976	158	1127433	1954-07-13	1954-07-13 00:00:00	1954-07-20	1954-07-20 00:00:00	1954-07-20	38000177		0	0	7		0	0	0	10819	0	313782	1127433		
24823	2041	19133873	1964-06-25	1964-06-25 00:00:00	1964-07-07	1964-07-07 00:00:00	1964-07-07	38000177		0	0	12		0	0	0	135857	0	834061	19133873		
48431	4014	1713671	1970-07-19	1970-07-19 00:00:00	1970-08-02	1970-08-02 00:00:00	1970-08-02	38000177		0	0	14		0	0	0	266767	0	562251	1713671		
7440	621	1713671	1966-02-23	1966-02-23 00:00:00	1966-03-02	1966-03-02 00:00:00	1966-03-02	38000177		0	0	7		0	0	0	41471	0	562251	1713671		
4950	411	1127433	1982-06-01	1982-06-01 00:00:00	1982-06-15	1982-06-15 00:00:00	1982-06-15	38000177		0	0	14		0	0	0	27255	0	313782	1127433		
34314	2835	1127433	1966-05-12	1966-05-12 00:00:00	1966-05-19	1966-05-19 00:00:00	1966-05-19	38000177		0	0	7		0	0	0	188260	0	313782	1127433		
35514	2926	1118084	2017-10-29	2017-10-29 00:00:00	2017-10-29	2017-10-29 00:00:00	\N	38000177		0	0	0		0	0	0	195177	0	00025152531	44923712		
33269	726	40213227	1995-09-10	1995-09-10 00:00:00	1995-09-10	1995-09-10 00:00:00	1995-09-10	581452		0	0	0		0	0	0	48125	0	113	40213227		
20222	1659	1118084	2006-08-25	2006-08-25 00:00:00	2006-08-25	2006-08-25 00:00:00	\N	38000177		0	0	0		0	0	0	111542	0	00025152531	44923712		
28627	2359	1115171	2008-12-16	2008-12-16 00:00:00	2009-01-06	2009-01-06 00:00:00	2009-01-06	38000177		0	0	21		0	0	0	157241	0	849574	1115171		
28684	2366	19059056	1972-03-10	1972-03-10 00:00:00	1972-03-24	1972-03-24 00:00:00	1972-03-24	38000177		0	0	14		0	0	0	157515	0	243670	19059056		
1717	137	19128022	1990-05-31	1990-05-31 00:00:00	1991-05-26	1991-05-26 00:00:00	1991-05-26	38000177		0	0	360		0	0	0	9233	0	749785	19128022		
1450	115	19078461	2006-06-09	2006-06-09 00:00:00	2006-07-09	2006-07-09 00:00:00	2006-07-09	38000177		0	0	30		0	0	0	7637	0	310965	19078461		
44402	3676	1127433	1975-10-19	1975-10-19 00:00:00	1975-11-02	1975-11-02 00:00:00	1975-11-02	38000177		0	0	14		0	0	0	244547	0	313782	1127433		
41439	3436	1127433	1971-07-30	1971-07-30 00:00:00	1971-08-13	1971-08-13 00:00:00	1971-08-13	38000177		0	0	14		0	0	0	227877	0	313782	1127433		
17517	379	40213160	1975-12-06	1975-12-06 00:00:00	1975-12-06	1975-12-06 00:00:00	1975-12-06	581452		0	0	0		0	0	0	25111	0	10	40213160		
63359	5262	1127433	1990-12-24	1990-12-24 00:00:00	1991-03-24	1991-03-24 00:00:00	1991-03-24	38000177		0	0	90		0	0	0	350075	0	313782	1127433		
22613	1855	19019979	1978-10-31	1978-10-31 00:00:00	1978-11-14	1978-11-14 00:00:00	1978-11-14	38000177		0	0	14		0	0	0	124135	0	198405	19019979		
117400	2580	40213260	2008-06-09	2008-06-09 00:00:00	2008-06-09	2008-06-09 00:00:00	2008-06-09	581452		0	0	0		0	0	0	170886	0	121	40213260		
50877	4227	19075001	1997-08-15	1997-08-15 00:00:00	1997-08-29	1997-08-29 00:00:00	1997-08-29	38000177		0	0	14		0	0	0	280797	0	309097	19075001		
128759	2832	40213160	1965-05-23	1965-05-23 00:00:00	1965-05-23	1965-05-23 00:00:00	1965-05-23	581452		0	0	0		0	0	0	187990	0	10	40213160		
49436	1082	40213260	2005-12-31	2005-12-31 00:00:00	2005-12-31	2005-12-31 00:00:00	2005-12-31	581452		0	0	0		0	0	0	71037	0	121	40213260		
29301	2425	19129655	1965-02-21	1965-02-21 00:00:00	1965-03-07	1965-03-07 00:00:00	1965-03-07	38000177		0	0	14		0	0	0	160917	0	789980	19129655		
29339	2428	1713671	1987-06-06	1987-06-06 00:00:00	1987-06-13	1987-06-13 00:00:00	1987-06-13	38000177		0	0	7		0	0	0	161094	0	562251	1713671		
33468	2771	1118084	1946-09-23	1946-09-23 00:00:00	1946-09-23	1946-09-23 00:00:00	\N	38000177		0	0	0		0	0	0	183543	0	00025152531	44923712		
26431	2175	1127433	1992-02-06	1992-02-06 00:00:00	1992-02-13	1992-02-13 00:00:00	1992-02-13	38000177		0	0	7		0	0	0	145045	0	313782	1127433		
39957	3307	1127433	1981-01-30	1981-01-30 00:00:00	1981-02-20	1981-02-20 00:00:00	1981-02-20	38000177		0	0	21		0	0	0	219577	0	313782	1127433		
40001	3311	1115171	2011-09-18	2011-09-18 00:00:00	2011-10-09	2011-10-09 00:00:00	2011-10-09	38000177		0	0	21		0	0	0	219835	0	849574	1115171		
11114	925	19006318	1973-07-27	1973-07-27 00:00:00	1973-08-10	1973-08-10 00:00:00	1973-08-10	38000177		0	0	14		0	0	0	61606	0	105078	19006318		
11430	951	19133905	2004-11-02	2004-11-02 00:00:00	2004-11-13	2004-11-13 00:00:00	2004-11-13	38000177		0	0	11		0	0	0	63212	0	834102	19133905		
54562	4532	1124300	1945-08-26	1945-08-26 00:00:00	1945-08-26	1945-08-26 00:00:00	\N	38000177		0	0	0		0	0	0	301904	0	00781178901	45011828		
21955	1801	40163554	2007-08-08	2007-08-08 00:00:00	2007-08-08	2007-08-08 00:00:00	\N	38000177		0	0	0		0	0	0	120779	0	855332	40163554		
70487	1541	40213227	2006-01-30	2006-01-30 00:00:00	2006-01-30	2006-01-30 00:00:00	2006-01-30	581452		0	0	0		0	0	0	103287	0	113	40213227		
22487	488	40213296	1997-04-11	1997-04-11 00:00:00	1997-04-11	1997-04-11 00:00:00	1997-04-11	581452		0	0	0		0	0	0	32647	0	52	40213296		
94674	2077	40213201	1999-06-27	1999-06-27 00:00:00	1999-06-27	1999-06-27 00:00:00	1999-06-27	581452		0	0	0		0	0	0	138319	0	33	40213201		
24181	525	40213227	1993-04-19	1993-04-19 00:00:00	1993-04-19	1993-04-19 00:00:00	1993-04-19	581452		0	0	0		0	0	0	35003	0	113	40213227		
33413	729	40213306	1984-03-17	1984-03-17 00:00:00	1984-03-17	1984-03-17 00:00:00	1984-03-17	581452		0	0	0		0	0	0	48421	0	43	40213306		
13204	1107	1115171	2000-02-20	2000-02-20 00:00:00	2000-03-05	2000-03-05 00:00:00	2000-03-05	38000177		0	0	14		0	0	0	72857	0	849574	1115171		
42928	3559	1127433	1983-04-29	1983-04-29 00:00:00	1983-05-13	1983-05-13 00:00:00	1983-05-13	38000177		0	0	14		0	0	0	236276	0	313782	1127433		
44828	975	40213160	1965-07-25	1965-07-25 00:00:00	1965-07-25	1965-07-25 00:00:00	1965-07-25	581452		0	0	0		0	0	0	65007	0	10	40213160		
6050	505	19133873	1979-05-10	1979-05-10 00:00:00	1979-05-20	1979-05-20 00:00:00	1979-05-20	38000177		0	0	10		0	0	0	33736	0	834061	19133873		
53807	4473	19073188	1991-02-27	1991-02-27 00:00:00	1991-03-13	1991-03-13 00:00:00	1991-03-13	38000177		0	0	14		0	0	0	297597	0	308192	19073188		
104754	2297	40213160	1978-08-17	1978-08-17 00:00:00	1978-08-17	1978-08-17 00:00:00	1978-08-17	581452		0	0	0		0	0	0	152957	0	10	40213160		
12366	266	40213306	1989-03-20	1989-03-20 00:00:00	1989-03-20	1989-03-20 00:00:00	1989-03-20	581452		0	0	0		0	0	0	17633	0	43	40213306		
38348	3172	19128065	1998-12-06	1998-12-06 00:00:00	1999-12-01	1999-12-01 00:00:00	1999-12-01	38000177		0	0	360		0	0	0	210840	0	749882	19128065		
30976	2566	1713671	1980-02-10	1980-02-10 00:00:00	1980-03-02	1980-03-02 00:00:00	1980-03-02	38000177		0	0	21		0	0	0	169940	0	562251	1713671		
64209	5329	1127433	2012-05-04	2012-05-04 00:00:00	2012-05-18	2012-05-18 00:00:00	2012-05-18	38000177		0	0	14		0	0	0	354792	0	313782	1127433		
271	19	1127433	2017-05-07	2017-05-07 00:00:00	2017-05-21	2017-05-21 00:00:00	2017-05-21	38000177		0	0	14		0	0	0	1483	0	313782	1127433		
48219	3997	1115171	2005-05-03	2005-05-03 00:00:00	2005-06-07	2005-06-07 00:00:00	2005-06-07	38000177		0	0	35		0	0	0	265704	0	849574	1115171		
10850	905	19059056	1972-06-25	1972-06-25 00:00:00	1972-07-09	1972-07-09 00:00:00	1972-07-09	38000177		0	0	14		0	0	0	60173	0	243670	19059056		
36196	2985	19128065	1985-09-03	1985-09-03 00:00:00	1986-08-29	1986-08-29 00:00:00	1986-08-29	38000177		0	0	360		0	0	0	199255	0	749882	19128065		
18265	1512	19128065	1992-05-18	1992-05-18 00:00:00	1993-05-13	1993-05-13 00:00:00	1993-05-13	38000177		0	0	360		0	0	0	101009	0	749882	19128065		
59658	4960	1127433	1948-01-02	1948-01-02 00:00:00	1948-01-16	1948-01-16 00:00:00	1948-01-16	38000177		0	0	14		0	0	0	329659	0	313782	1127433		
27468	2274	19133905	1983-12-14	1983-12-14 00:00:00	1983-12-26	1983-12-26 00:00:00	1983-12-26	38000177		0	0	12		0	0	0	151145	0	834102	19133905		
28888	2387	1127433	2012-08-30	2012-08-30 00:00:00	2012-09-13	2012-09-13 00:00:00	2012-09-13	38000177		0	0	14		0	0	0	158781	0	313782	1127433		
45749	3787	1127078	1966-06-18	1966-06-18 00:00:00	1966-08-17	1966-08-17 00:00:00	1966-08-17	38000177		0	0	60		0	0	0	251785	0	282464	1127078		
48618	4027	19128065	1999-10-31	1999-10-31 00:00:00	2000-10-25	2000-10-25 00:00:00	2000-10-25	38000177		0	0	360		0	0	0	267856	0	749882	19128065		
19754	1626	1310034	2010-10-10	2010-10-10 00:00:00	2010-10-10	2010-10-10 00:00:00	2010-10-10	38000177		0	0	0		0	0	0	109220	0	834357	1310034		
27182	2242	40220960	2013-12-21	2013-12-21 00:00:00	2013-12-21	2013-12-21 00:00:00	2013-12-21	38000177		0	0	0		0	0	0	149279	0	1804799	40220960		
56394	4678	1118084	1991-01-02	1991-01-02 00:00:00	1991-01-02	1991-01-02 00:00:00	\N	38000177		0	0	0		0	0	0	311752	0	00025152531	44923712		
37739	3119	1115171	1996-11-01	1996-11-01 00:00:00	1996-11-15	1996-11-15 00:00:00	1996-11-15	38000177		0	0	14		0	0	0	207537	0	849574	1115171		
13890	299	40213306	1984-03-17	1984-03-17 00:00:00	1984-03-17	1984-03-17 00:00:00	1984-03-17	581452		0	0	0		0	0	0	19956	0	43	40213306		
32489	2693	19129655	1963-06-20	1963-06-20 00:00:00	1963-07-04	1963-07-04 00:00:00	1963-07-04	38000177		0	0	14		0	0	0	178378	0	789980	19129655		
41278	3422	1713671	1980-10-04	1980-10-04 00:00:00	1980-10-18	1980-10-18 00:00:00	1980-10-18	38000177		0	0	14		0	0	0	226954	0	562251	1713671		
1977	158	1127433	1967-10-12	1967-10-12 00:00:00	1967-10-19	1967-10-19 00:00:00	1967-10-19	38000177		0	0	7		0	0	0	10821	0	313782	1127433		
24824	2041	1127433	1993-04-12	1993-04-12 00:00:00	1993-05-03	1993-05-03 00:00:00	1993-05-03	38000177		0	0	21		0	0	0	135855	0	313782	1127433		
48432	4014	19008572	1997-11-27	1997-11-27 00:00:00	1997-11-27	1997-11-27 00:00:00	\N	38000177		0	0	0		0	0	0	266731	0	106258	19008572		
7441	621	40173590	2003-01-08	2003-01-08 00:00:00	2003-01-08	2003-01-08 00:00:00	\N	38000177		0	0	0		0	0	0	41389	0	904419	40173590		
4951	411	40231925	1980-08-29	1980-08-29 00:00:00	1980-08-29	1980-08-29 00:00:00	\N	38000177		0	0	0		0	0	0	27403	0	1049221	40231925		
34315	2835	1127433	1915-10-29	1915-10-29 00:00:00	1915-11-05	1915-11-05 00:00:00	1915-11-05	38000177		0	0	7		0	0	0	188231	0	313782	1127433		
35515	2926	1127433	1990-10-12	1990-10-12 00:00:00	1990-10-26	1990-10-26 00:00:00	1990-10-26	38000177		0	0	14		0	0	0	195155	0	313782	1127433		
33284	727	40213227	2004-01-09	2004-01-09 00:00:00	2004-01-09	2004-01-09 00:00:00	2004-01-09	581452		0	0	0		0	0	0	48233	0	113	40213227		
20223	1659	19019979	1980-03-19	1980-03-19 00:00:00	1980-06-17	1980-06-17 00:00:00	1980-06-17	38000177		0	0	90		0	0	0	111456	0	198405	19019979		
28628	2359	19075601	2015-05-18	2015-05-18 00:00:00	2015-05-18	2015-05-18 00:00:00	\N	38000177		0	0	0		0	0	0	157174	0	309362	19075601		
28685	2366	19129655	1966-06-10	1966-06-10 00:00:00	1966-06-24	1966-06-24 00:00:00	1966-06-24	38000177		0	0	14		0	0	0	157485	0	789980	19129655		
1718	137	40162522	1984-08-11	1984-08-11 00:00:00	1984-08-11	1984-08-11 00:00:00	\N	38000177		0	0	0		0	0	0	9121	0	857005	40162522		
1451	115	40165015	2006-06-09	2006-06-09 00:00:00	2006-06-09	2006-06-09 00:00:00	\N	38000177		0	0	0		0	0	0	7637	0	861467	40165015		
44404	3676	1713671	1989-10-01	1989-10-01 00:00:00	1989-10-08	1989-10-08 00:00:00	1989-10-08	38000177		0	0	7		0	0	0	244549	0	562251	1713671		
41440	3436	1115171	1995-09-09	1995-09-09 00:00:00	1995-09-30	1995-09-30 00:00:00	1995-09-30	38000177		0	0	21		0	0	0	227855	0	849574	1115171		
17522	379	40213314	1977-03-05	1977-03-05 00:00:00	1977-03-05	1977-03-05 00:00:00	1977-03-05	581452		0	0	0		0	0	0	25071	0	49	40213314		
63360	5262	19128065	1997-10-26	1997-10-26 00:00:00	1998-10-21	1998-10-21 00:00:00	1998-10-21	38000177		0	0	360		0	0	0	350083	0	749882	19128065		
22614	1855	1127433	1995-01-24	1995-01-24 00:00:00	1995-02-14	1995-02-14 00:00:00	1995-02-14	38000177		0	0	21		0	0	0	124140	0	313782	1127433		
117402	2580	40213160	1959-02-16	1959-02-16 00:00:00	1959-02-16	1959-02-16 00:00:00	1959-02-16	581452		0	0	0		0	0	0	170932	0	10	40213160		
50878	4227	1115171	1997-08-15	1997-08-15 00:00:00	1997-08-29	1997-08-29 00:00:00	1997-08-29	38000177		0	0	14		0	0	0	280797	0	849574	1115171		
128762	2832	40213160	1970-01-25	1970-01-25 00:00:00	1970-01-25	1970-01-25 00:00:00	1970-01-25	581452		0	0	0		0	0	0	187971	0	10	40213160		
49443	1082	40213227	2017-03-04	2017-03-04 00:00:00	2017-03-04	2017-03-04 00:00:00	2017-03-04	581452		0	0	0		0	0	0	71039	0	113	40213227		
29302	2425	19059056	1962-01-08	1962-01-08 00:00:00	1962-01-29	1962-01-29 00:00:00	1962-01-29	38000177		0	0	21		0	0	0	160870	0	243670	19059056		
29340	2428	19019979	1975-02-20	1975-02-20 00:00:00	1975-03-06	1975-03-06 00:00:00	1975-03-06	38000177		0	0	14		0	0	0	161098	0	198405	19019979		
33469	2771	19059056	1946-11-23	1946-11-23 00:00:00	1946-12-14	1946-12-14 00:00:00	1946-12-14	38000177		0	0	21		0	0	0	183469	0	243670	19059056		
26432	2175	19133873	1979-12-12	1979-12-12 00:00:00	1979-12-22	1979-12-22 00:00:00	1979-12-22	38000177		0	0	10		0	0	0	144999	0	834061	19133873		
39958	3307	920300	2009-11-03	2009-11-03 00:00:00	2009-11-10	2009-11-10 00:00:00	2009-11-10	38000177		0	0	7		0	0	0	219582	0	311989	920300		
40002	3311	1127433	1974-07-20	1974-07-20 00:00:00	1974-08-03	1974-08-03 00:00:00	1974-08-03	38000177		0	0	14		0	0	0	219797	0	313782	1127433		
11115	925	19059056	1973-07-27	1973-07-27 00:00:00	1973-08-10	1973-08-10 00:00:00	1973-08-10	38000177		0	0	14		0	0	0	61606	0	243670	19059056		
11446	954	19006318	1976-03-12	1976-03-12 00:00:00	1976-03-26	1976-03-26 00:00:00	1976-03-26	38000177		0	0	14		0	0	0	63386	0	105078	19006318		
54563	4532	19059056	1956-10-21	1956-10-21 00:00:00	1956-11-11	1956-11-11 00:00:00	1956-11-11	38000177		0	0	21		0	0	0	301891	0	243670	19059056		
21956	1801	19018935	2007-08-08	2007-08-08 00:00:00	2007-08-08	2007-08-08 00:00:00	\N	38000177		0	0	0		0	0	0	120779	0	197604	19018935		
70488	1541	40213296	2006-01-30	2006-01-30 00:00:00	2006-01-30	2006-01-30 00:00:00	2006-01-30	581452		0	0	0		0	0	0	103287	0	52	40213296		
22489	488	40213227	1997-04-11	1997-04-11 00:00:00	1997-04-11	1997-04-11 00:00:00	1997-04-11	581452		0	0	0		0	0	0	32647	0	113	40213227		
237411	5213	40213201	2004-12-16	2004-12-16 00:00:00	2004-12-16	2004-12-16 00:00:00	2004-12-16	581452		0	0	0		0	0	0	346752	0	33	40213201		
24189	526	40213227	2002-12-11	2002-12-11 00:00:00	2002-12-11	2002-12-11 00:00:00	2002-12-11	581452		0	0	0		0	0	0	35087	0	113	40213227		
33418	729	40213227	1993-03-27	1993-03-27 00:00:00	1993-03-27	1993-03-27 00:00:00	1993-03-27	581452		0	0	0		0	0	0	48390	0	113	40213227		
13205	1107	19059056	1929-01-07	1929-01-07 00:00:00	1929-01-21	1929-01-21 00:00:00	1929-01-21	38000177		0	0	14		0	0	0	72862	0	243670	19059056		
42929	3559	1127078	1951-06-17	1951-06-17 00:00:00	1951-07-01	1951-07-01 00:00:00	1951-07-01	38000177		0	0	14		0	0	0	236256	0	282464	1127078		
44833	975	40213160	1965-04-25	1965-04-25 00:00:00	1965-04-25	1965-04-25 00:00:00	1965-04-25	581452		0	0	0		0	0	0	65056	0	10	40213160		
6051	505	19059056	1987-11-06	1987-11-06 00:00:00	1987-12-04	1987-12-04 00:00:00	1987-12-04	38000177		0	0	28		0	0	0	33829	0	243670	19059056		
53808	4473	1127433	1991-02-27	1991-02-27 00:00:00	1991-03-13	1991-03-13 00:00:00	1991-03-13	38000177		0	0	14		0	0	0	297597	0	313782	1127433		
104762	2297	40213296	2013-09-12	2013-09-12 00:00:00	2013-09-12	2013-09-12 00:00:00	2013-09-12	581452		0	0	0		0	0	0	152950	0	52	40213296		
12369	266	40213160	1967-01-09	1967-01-09 00:00:00	1967-01-09	1967-01-09 00:00:00	1967-01-09	581452		0	0	0		0	0	0	17739	0	10	40213160		
38349	3172	40231925	1999-01-16	1999-01-16 00:00:00	1999-01-16	1999-01-16 00:00:00	\N	38000177		0	0	0		0	0	0	210877	0	1049221	40231925		
30977	2566	1713671	2007-03-17	2007-03-17 00:00:00	2007-03-24	2007-03-24 00:00:00	2007-03-24	38000177		0	0	7		0	0	0	169999	0	562251	1713671		
64210	5329	1127078	1953-09-17	1953-09-17 00:00:00	1953-10-08	1953-10-08 00:00:00	1953-10-08	38000177		0	0	21		0	0	0	354829	0	282464	1127078		
273	19	19133905	2000-05-15	2000-05-15 00:00:00	2000-05-27	2000-05-27 00:00:00	2000-05-27	38000177		0	0	12		0	0	0	1453	0	834102	19133905		
48220	3997	19059056	1967-09-17	1967-09-17 00:00:00	1967-10-08	1967-10-08 00:00:00	1967-10-08	38000177		0	0	21		0	0	0	265699	0	243670	19059056		
10851	905	1127078	1979-02-26	1979-02-26 00:00:00	1979-03-12	1979-03-12 00:00:00	1979-03-12	38000177		0	0	14		0	0	0	60193	0	282464	1127078		
36198	2985	1127433	1990-10-09	1990-10-09 00:00:00	1991-01-07	1991-01-07 00:00:00	1991-01-07	38000177		0	0	90		0	0	0	199189	0	313782	1127433		
18266	1512	1713671	1994-05-05	1994-05-05 00:00:00	1994-05-12	1994-05-12 00:00:00	1994-05-12	38000177		0	0	7		0	0	0	100940	0	562251	1713671		
59659	4960	1713671	1960-04-16	1960-04-16 00:00:00	1960-04-23	1960-04-23 00:00:00	1960-04-23	38000177		0	0	7		0	0	0	329750	0	562251	1713671		
27469	2274	1118084	1987-06-11	1987-06-11 00:00:00	1987-06-11	1987-06-11 00:00:00	\N	38000177		0	0	0		0	0	0	151181	0	00025152531	44923712		
28889	2387	19128065	1983-02-19	1983-02-19 00:00:00	1984-02-14	1984-02-14 00:00:00	1984-02-14	38000177		0	0	360		0	0	0	158740	0	749882	19128065		
45750	3787	1127433	2010-10-04	2010-10-04 00:00:00	2010-10-11	2010-10-11 00:00:00	2010-10-11	38000177		0	0	7		0	0	0	251736	0	313782	1127433		
48619	4027	19128022	1989-12-22	1989-12-22 00:00:00	1990-12-17	1990-12-17 00:00:00	1990-12-17	38000177		0	0	360		0	0	0	267805	0	749785	19128022		
30213	2504	1127433	1968-12-04	1968-12-04 00:00:00	1968-12-18	1968-12-18 00:00:00	1968-12-18	38000177		0	0	14		0	0	0	165853	0	313782	1127433		
27183	2242	40229134	1976-02-23	1976-02-23 00:00:00	1976-03-08	1976-03-08 00:00:00	1976-03-08	38000177		0	0	14		0	0	0	149233	0	1043400	40229134		
56401	4680	19115351	1946-04-08	1946-04-08 00:00:00	1946-04-08	1946-04-08 00:00:00	\N	38000177		0	0	0		0	0	0	311942	0	563026	19115351		
37740	3119	1127078	1985-07-03	1985-07-03 00:00:00	1985-09-01	1985-09-01 00:00:00	1985-09-01	38000177		0	0	60		0	0	0	207536	0	282464	1127078		
13895	299	40213260	2011-12-10	2011-12-10 00:00:00	2011-12-10	2011-12-10 00:00:00	2011-12-10	581452		0	0	0		0	0	0	19985	0	121	40213260		
32490	2693	1127078	1963-06-20	1963-06-20 00:00:00	1963-07-04	1963-07-04 00:00:00	1963-07-04	38000177		0	0	14		0	0	0	178378	0	282464	1127078		
41280	3422	40229134	1980-05-10	1980-05-10 00:00:00	1980-05-17	1980-05-17 00:00:00	1980-05-17	38000177		0	0	7		0	0	0	227024	0	1043400	40229134		
1978	158	19133873	1952-05-08	1952-05-08 00:00:00	1952-05-16	1952-05-16 00:00:00	1952-05-16	38000177		0	0	8		0	0	0	10818	0	834061	19133873		
24825	2041	1127433	1972-07-14	1972-07-14 00:00:00	1972-07-21	1972-07-21 00:00:00	1972-07-21	38000177		0	0	7		0	0	0	135811	0	313782	1127433		
48433	4014	19073188	1983-10-14	1983-10-14 00:00:00	1983-10-28	1983-10-28 00:00:00	1983-10-28	38000177		0	0	14		0	0	0	266810	0	308192	19073188		
7464	624	40229134	1969-10-17	1969-10-17 00:00:00	1969-10-24	1969-10-24 00:00:00	1969-10-24	38000177		0	0	7		0	0	0	41636	0	1043400	40229134		
4952	411	19059056	1980-08-29	1980-08-29 00:00:00	1980-09-28	1980-09-28 00:00:00	1980-09-28	38000177		0	0	30		0	0	0	27403	0	243670	19059056		
34316	2835	1127433	2004-11-11	2004-11-11 00:00:00	2004-11-18	2004-11-18 00:00:00	2004-11-18	38000177		0	0	7		0	0	0	188216	0	313782	1127433		
35516	2926	19128022	1999-08-25	1999-08-25 00:00:00	2000-08-19	2000-08-19 00:00:00	2000-08-19	38000177		0	0	360		0	0	0	195144	0	749785	19128022		
36627	3023	19133873	1995-07-15	1995-07-15 00:00:00	1995-07-26	1995-07-26 00:00:00	1995-07-26	38000177		0	0	11		0	0	0	201539	0	834061	19133873		
20224	1659	46233988	1976-07-17	1976-07-17 00:00:00	1976-07-31	1976-07-31 00:00:00	1976-07-31	38000177		0	0	14		0	0	0	111474	0	1652673	46233988		
28629	2359	19133905	1983-04-13	1983-04-13 00:00:00	1983-04-26	1983-04-26 00:00:00	1983-04-26	38000177		0	0	13		0	0	0	157178	0	834102	19133905		
28686	2366	1127078	1966-06-10	1966-06-10 00:00:00	1966-06-24	1966-06-24 00:00:00	1966-06-24	38000177		0	0	14		0	0	0	157485	0	282464	1127078		
1719	137	1127433	1984-08-11	1984-08-11 00:00:00	1984-09-10	1984-09-10 00:00:00	1984-09-10	38000177		0	0	30		0	0	0	9121	0	313782	1127433		
1452	115	19059056	1962-08-17	1962-08-17 00:00:00	1962-09-14	1962-09-14 00:00:00	1962-09-14	38000177		0	0	28		0	0	0	7635	0	243670	19059056		
44405	3676	40229134	1979-10-23	1979-10-23 00:00:00	1979-10-30	1979-10-30 00:00:00	1979-10-30	38000177		0	0	7		0	0	0	244497	0	1043400	40229134		
41441	3436	19059056	1970-03-05	1970-03-05 00:00:00	1970-03-26	1970-03-26 00:00:00	1970-03-26	38000177		0	0	21		0	0	0	227853	0	243670	19059056		
17527	379	40213296	2015-08-01	2015-08-01 00:00:00	2015-08-01	2015-08-01 00:00:00	2015-08-01	581452		0	0	0		0	0	0	25090	0	52	40213296		
53545	1173	40213227	2005-11-14	2005-11-14 00:00:00	2005-11-14	2005-11-14 00:00:00	2005-11-14	581452		0	0	0		0	0	0	77215	0	113	40213227		
22615	1855	19078461	1996-12-05	1996-12-05 00:00:00	1996-12-26	1996-12-26 00:00:00	1996-12-26	38000177		0	0	21		0	0	0	124141	0	310965	19078461		
117409	2580	40213160	1963-05-20	1963-05-20 00:00:00	1963-05-20	1963-05-20 00:00:00	1963-05-20	581452		0	0	0		0	0	0	170875	0	10	40213160		
50879	4227	40162522	1997-08-15	1997-08-15 00:00:00	1997-08-15	1997-08-15 00:00:00	\N	38000177		0	0	0		0	0	0	280797	0	857005	40162522		
128769	2832	40213296	2005-05-01	2005-05-01 00:00:00	2005-05-01	2005-05-01 00:00:00	2005-05-01	581452		0	0	0		0	0	0	187981	0	52	40213296		
49461	1083	40213306	1988-05-19	1988-05-19 00:00:00	1988-05-19	1988-05-19 00:00:00	1988-05-19	581452		0	0	0		0	0	0	71079	0	43	40213306		
29303	2425	1127433	1971-06-21	1971-06-21 00:00:00	1971-07-05	1971-07-05 00:00:00	1971-07-05	38000177		0	0	14		0	0	0	160913	0	313782	1127433		
29341	2428	19006318	1975-02-20	1975-02-20 00:00:00	1975-03-06	1975-03-06 00:00:00	1975-03-06	38000177		0	0	14		0	0	0	161098	0	105078	19006318		
33470	2771	19059056	1940-03-08	1940-03-08 00:00:00	1940-03-29	1940-03-29 00:00:00	1940-03-29	38000177		0	0	21		0	0	0	183468	0	243670	19059056		
26433	2175	1127078	1980-08-22	1980-08-22 00:00:00	1980-09-05	1980-09-05 00:00:00	1980-09-05	38000177		0	0	14		0	0	0	144974	0	282464	1127078		
39959	3307	40236824	2009-11-03	2009-11-03 00:00:00	2009-11-10	2009-11-10 00:00:00	2009-11-10	38000177		0	0	7		0	0	0	219582	0	1094107	40236824		
40003	3311	1127433	1986-02-13	1986-02-13 00:00:00	1986-02-27	1986-02-27 00:00:00	1986-02-27	38000177		0	0	14		0	0	0	219755	0	313782	1127433		
11116	925	1127433	2007-04-30	2007-04-30 00:00:00	2007-05-14	2007-05-14 00:00:00	2007-05-14	38000177		0	0	14		0	0	0	61586	0	313782	1127433		
11447	954	19074843	1979-11-03	1979-11-03 00:00:00	1979-11-17	1979-11-17 00:00:00	1979-11-17	38000177		0	0	14		0	0	0	63371	0	309045	19074843		
54564	4532	1127433	1949-03-04	1949-03-04 00:00:00	1949-03-11	1949-03-11 00:00:00	1949-03-11	38000177		0	0	7		0	0	0	301917	0	313782	1127433		
21957	1801	40171902	2007-08-08	2007-08-08 00:00:00	2007-08-08	2007-08-08 00:00:00	\N	38000177		0	0	0		0	0	0	120779	0	897718	40171902		
70490	1541	40213296	2004-01-26	2004-01-26 00:00:00	2004-01-26	2004-01-26 00:00:00	2004-01-26	581452		0	0	0		0	0	0	103270	0	52	40213296		
22494	488	40213260	2007-05-04	2007-05-04 00:00:00	2007-05-04	2007-05-04 00:00:00	2007-05-04	581452		0	0	0		0	0	0	32639	0	121	40213260		
237415	5213	40213227	2010-01-14	2010-01-14 00:00:00	2010-01-14	2010-01-14 00:00:00	2010-01-14	581452		0	0	0		0	0	0	346686	0	113	40213227		
24191	526	40213160	1971-06-02	1971-06-02 00:00:00	1971-06-02	1971-06-02 00:00:00	1971-06-02	581452		0	0	0		0	0	0	35050	0	10	40213160		
33424	729	40213296	2001-07-07	2001-07-07 00:00:00	2001-07-07	2001-07-07 00:00:00	2001-07-07	581452		0	0	0		0	0	0	48393	0	52	40213296		
13206	1108	1127078	1980-06-30	1980-06-30 00:00:00	1980-07-21	1980-07-21 00:00:00	1980-07-21	38000177		0	0	21		0	0	0	72996	0	282464	1127078		
42930	3559	1713671	2011-07-24	2011-07-24 00:00:00	2011-07-31	2011-07-31 00:00:00	2011-07-31	38000177		0	0	7		0	0	0	236296	0	562251	1713671		
44835	975	40213306	1985-10-20	1985-10-20 00:00:00	1985-10-20	1985-10-20 00:00:00	1985-10-20	581452		0	0	0		0	0	0	65067	0	43	40213306		
6052	505	19078461	1993-08-04	1993-08-04 00:00:00	1993-09-08	1993-09-08 00:00:00	1993-09-08	38000177		0	0	35		0	0	0	33830	0	310965	19078461		
53809	4473	1115171	2004-06-29	2004-06-29 00:00:00	2004-08-03	2004-08-03 00:00:00	2004-08-03	38000177		0	0	35		0	0	0	297585	0	849574	1115171		
104764	2297	40213160	1973-12-13	1973-12-13 00:00:00	1973-12-13	1973-12-13 00:00:00	1973-12-13	581452		0	0	0		0	0	0	152946	0	10	40213160		
19803	431	40213227	1992-05-21	1992-05-21 00:00:00	1992-05-21	1992-05-21 00:00:00	1992-05-21	581452		0	0	0		0	0	0	\N	0	113	40213227		
38350	3172	1713671	1993-07-31	1993-07-31 00:00:00	1993-08-07	1993-08-07 00:00:00	1993-08-07	38000177		0	0	7		0	0	0	210834	0	562251	1713671		
30978	2566	1127433	2015-11-22	2015-11-22 00:00:00	2016-01-21	2016-01-21 00:00:00	2016-01-21	38000177		0	0	60		0	0	0	169984	0	313782	1127433		
64223	5331	1127433	1998-03-02	1998-03-02 00:00:00	1998-03-16	1998-03-16 00:00:00	1998-03-16	38000177		0	0	14		0	0	0	354903	0	313782	1127433		
274	19	19078461	1981-11-08	1981-11-08 00:00:00	1981-12-08	1981-12-08 00:00:00	1981-12-08	38000177		0	0	30		0	0	0	1544	0	310965	19078461		
48221	3997	19133873	1973-04-27	1973-04-27 00:00:00	1973-05-10	1973-05-10 00:00:00	1973-05-10	38000177		0	0	13		0	0	0	265730	0	834061	19133873		
10852	905	1713671	1980-06-24	1980-06-24 00:00:00	1980-07-15	1980-07-15 00:00:00	1980-07-15	38000177		0	0	21		0	0	0	60213	0	562251	1713671		
36199	2985	40231925	1990-10-09	1990-10-09 00:00:00	1990-10-09	1990-10-09 00:00:00	\N	38000177		0	0	0		0	0	0	199189	0	1049221	40231925		
18267	1512	19129655	1977-03-12	1977-03-12 00:00:00	1977-03-26	1977-03-26 00:00:00	1977-03-26	38000177		0	0	14		0	0	0	100943	0	789980	19129655		
59660	4960	19133873	1919-05-13	1919-05-13 00:00:00	1919-05-26	1919-05-26 00:00:00	1919-05-26	38000177		0	0	13		0	0	0	329715	0	834061	19133873		
27470	2274	1127433	1954-01-26	1954-01-26 00:00:00	1954-02-09	1954-02-09 00:00:00	1954-02-09	38000177		0	0	14		0	0	0	151133	0	313782	1127433		
28890	2387	1127433	1972-05-08	1972-05-08 00:00:00	1972-05-15	1972-05-15 00:00:00	1972-05-15	38000177		0	0	7		0	0	0	158776	0	313782	1127433		
45751	3787	40229134	1986-02-14	1986-02-14 00:00:00	1986-02-28	1986-02-28 00:00:00	1986-02-28	38000177		0	0	14		0	0	0	251764	0	1043400	40229134		
48620	4027	1127433	2012-03-21	2012-03-21 00:00:00	2012-04-11	2012-04-11 00:00:00	2012-04-11	38000177		0	0	21		0	0	0	267884	0	313782	1127433		
30214	2504	1127433	1970-12-28	1970-12-28 00:00:00	1971-01-04	1971-01-04 00:00:00	1971-01-04	38000177		0	0	7		0	0	0	165773	0	313782	1127433		
27184	2242	1115171	1996-07-24	1996-07-24 00:00:00	1996-08-14	1996-08-14 00:00:00	1996-08-14	38000177		0	0	21		0	0	0	149231	0	849574	1115171		
56402	4680	40220960	2000-01-01	2000-01-01 00:00:00	2000-01-01	2000-01-01 00:00:00	2000-01-01	38000177		0	0	0		0	0	0	311966	0	1804799	40220960		
37741	3119	19019979	1978-02-25	1978-02-25 00:00:00	1978-03-11	1978-03-11 00:00:00	1978-03-11	38000177		0	0	14		0	0	0	207590	0	198405	19019979		
13898	299	40213160	1962-08-18	1962-08-18 00:00:00	1962-08-18	1962-08-18 00:00:00	1962-08-18	581452		0	0	0		0	0	0	19971	0	10	40213160		
32491	2693	40236824	1984-01-24	1984-01-24 00:00:00	1984-01-31	1984-01-31 00:00:00	1984-01-31	38000177		0	0	7		0	0	0	178427	0	1094107	40236824		
41281	3422	1594382	1994-01-09	1994-01-09 00:00:00	1994-01-09	1994-01-09 00:00:00	\N	38000177		0	0	0		0	0	0	227027	0	1870230	1594382		
1979	158	19059056	1952-01-29	1952-01-29 00:00:00	1952-02-19	1952-02-19 00:00:00	1952-02-19	38000177		0	0	21		0	0	0	10849	0	243670	19059056		
24826	2041	1539411	1998-09-01	1998-09-01 00:00:00	1998-09-01	1998-09-01 00:00:00	\N	38000177		0	0	0		0	0	0	135804	0	312961	1539411		
48434	4014	19059056	1983-10-14	1983-10-14 00:00:00	1983-10-28	1983-10-28 00:00:00	1983-10-28	38000177		0	0	14		0	0	0	266810	0	243670	19059056		
7465	624	1127433	1973-04-23	1973-04-23 00:00:00	1973-05-07	1973-05-07 00:00:00	1973-05-07	38000177		0	0	14		0	0	0	41693	0	313782	1127433		
4953	411	1127433	2012-03-25	2012-03-25 00:00:00	2012-04-01	2012-04-01 00:00:00	2012-04-01	38000177		0	0	7		0	0	0	27338	0	313782	1127433		
34317	2835	1124300	1950-10-19	1950-10-19 00:00:00	1950-10-19	1950-10-19 00:00:00	\N	38000177		0	0	0		0	0	0	188286	0	00781178901	45011828		
35517	2926	19128065	1995-09-15	1995-09-15 00:00:00	1996-09-09	1996-09-09 00:00:00	1996-09-09	38000177		0	0	360		0	0	0	195141	0	749882	19128065		
36628	3023	1713671	2013-01-09	2013-01-09 00:00:00	2013-01-16	2013-01-16 00:00:00	2013-01-16	38000177		0	0	7		0	0	0	201519	0	562251	1713671		
20225	1659	19019979	1976-07-17	1976-07-17 00:00:00	1976-07-31	1976-07-31 00:00:00	1976-07-31	38000177		0	0	14		0	0	0	111474	0	198405	19019979		
28630	2359	19075601	2011-04-25	2011-04-25 00:00:00	2014-10-06	2014-10-06 00:00:00	2014-10-06	38000177		0	0	1260		0	0	0	157234	0	309362	19075601		
28687	2366	19133873	1968-11-13	1968-11-13 00:00:00	1968-11-21	1968-11-21 00:00:00	1968-11-21	38000177		0	0	8		0	0	0	157527	0	834061	19133873		
1720	137	1115171	2007-04-13	2007-04-13 00:00:00	2007-04-27	2007-04-27 00:00:00	2007-04-27	38000177		0	0	14		0	0	0	9123	0	849574	1115171		
1453	115	1713671	1964-04-27	1964-04-27 00:00:00	1964-05-18	1964-05-18 00:00:00	1964-05-18	38000177		0	0	21		0	0	0	7572	0	562251	1713671		
44406	3676	1127433	2005-07-07	2005-07-07 00:00:00	2005-07-21	2005-07-21 00:00:00	2005-07-21	38000177		0	0	14		0	0	0	244551	0	313782	1127433		
41442	3436	19133905	1987-01-23	1987-01-23 00:00:00	1987-02-01	1987-02-01 00:00:00	1987-02-01	38000177		0	0	9		0	0	0	227863	0	834102	19133905		
17532	379	40213296	2016-08-06	2016-08-06 00:00:00	2016-08-06	2016-08-06 00:00:00	2016-08-06	581452		0	0	0		0	0	0	25099	0	52	40213296		
53558	1173	40213227	2016-01-11	2016-01-11 00:00:00	2016-01-11	2016-01-11 00:00:00	2016-01-11	581452		0	0	0		0	0	0	77297	0	113	40213227		
22616	1855	40236446	1989-03-17	1989-03-17 00:00:00	1989-09-22	1989-09-22 00:00:00	1989-09-22	38000177		0	0	189		0	0	0	124166	0	1091392	40236446		
117413	2580	40213296	2002-03-04	2002-03-04 00:00:00	2002-03-04	2002-03-04 00:00:00	2002-03-04	581452		0	0	0		0	0	0	170892	0	52	40213296		
50880	4227	40229134	1977-10-17	1977-10-17 00:00:00	1977-10-31	1977-10-31 00:00:00	1977-10-31	38000177		0	0	14		0	0	0	280853	0	1043400	40229134		
128779	2832	40213306	1987-04-19	1987-04-19 00:00:00	1987-04-19	1987-04-19 00:00:00	1987-04-19	581452		0	0	0		0	0	0	187921	0	43	40213306		
49462	1083	40213160	1966-10-27	1966-10-27 00:00:00	1966-10-27	1966-10-27 00:00:00	1966-10-27	581452		0	0	0		0	0	0	71177	0	10	40213160		
29304	2425	19133873	1961-10-13	1961-10-13 00:00:00	1961-10-20	1961-10-20 00:00:00	1961-10-20	38000177		0	0	7		0	0	0	160939	0	834061	19133873		
29342	2428	1124300	2015-10-08	2015-10-08 00:00:00	2015-10-08	2015-10-08 00:00:00	\N	38000177		0	0	0		0	0	0	161079	0	00781178901	45011828		
33471	2771	40229134	1973-12-22	1973-12-22 00:00:00	1973-12-29	1973-12-29 00:00:00	1973-12-29	38000177		0	0	7		0	0	0	183529	0	1043400	40229134		
26434	2175	19074843	1980-08-22	1980-08-22 00:00:00	1980-09-05	1980-09-05 00:00:00	1980-09-05	38000177		0	0	14		0	0	0	144974	0	309045	19074843		
39960	3307	1127078	1975-08-31	1975-08-31 00:00:00	1975-09-30	1975-09-30 00:00:00	1975-09-30	38000177		0	0	30		0	0	0	219554	0	282464	1127078		
40004	3311	19059056	1965-01-03	1965-01-03 00:00:00	1965-01-17	1965-01-17 00:00:00	1965-01-17	38000177		0	0	14		0	0	0	219795	0	243670	19059056		
11117	925	19078461	2005-06-18	2005-06-18 00:00:00	2005-08-17	2005-08-17 00:00:00	2005-08-17	38000177		0	0	60		0	0	0	61601	0	310965	19078461		
11448	954	19019979	1979-11-03	1979-11-03 00:00:00	1979-11-17	1979-11-17 00:00:00	1979-11-17	38000177		0	0	14		0	0	0	63371	0	198405	19019979		
54565	4532	1127433	1983-02-02	1983-02-02 00:00:00	1983-02-16	1983-02-16 00:00:00	1983-02-16	38000177		0	0	14		0	0	0	301847	0	313782	1127433		
21958	1801	1127433	1967-01-05	1967-01-05 00:00:00	1967-01-26	1967-01-26 00:00:00	1967-01-26	38000177		0	0	21		0	0	0	120751	0	313782	1127433		
12853	1081	1713671	1981-02-23	1981-02-23 00:00:00	1981-03-02	1981-03-02 00:00:00	1981-03-02	38000177		0	0	7		0	0	0	70834	0	562251	1713671		
2802	225	1127078	1966-10-24	1966-10-24 00:00:00	1966-11-23	1966-11-23 00:00:00	1966-11-23	38000177		0	0	30		0	0	0	15148	0	282464	1127078		
73865	1612	40213260	2013-07-31	2013-07-31 00:00:00	2013-07-31	2013-07-31 00:00:00	2013-07-31	581452		0	0	0		0	0	0	108401	0	121	40213260		
154167	3394	40213227	2007-12-15	2007-12-15 00:00:00	2007-12-15	2007-12-15 00:00:00	2007-12-15	581452		0	0	0		0	0	0	225170	0	113	40213227		
33428	729	40213227	2003-07-12	2003-07-12 00:00:00	2003-07-12	2003-07-12 00:00:00	2003-07-12	581452		0	0	0		0	0	0	48376	0	113	40213227		
13207	1108	920300	2006-08-18	2006-08-18 00:00:00	2006-08-25	2006-08-25 00:00:00	2006-08-25	38000177		0	0	7		0	0	0	72969	0	311989	920300		
42931	3559	1127433	1977-05-22	1977-05-22 00:00:00	1977-05-29	1977-05-29 00:00:00	1977-05-29	38000177		0	0	7		0	0	0	236278	0	313782	1127433		
44837	975	40213160	1965-02-21	1965-02-21 00:00:00	1965-02-21	1965-02-21 00:00:00	1965-02-21	581452		0	0	0		0	0	0	65040	0	10	40213160		
6053	505	1118084	2001-11-13	2001-11-13 00:00:00	2001-11-13	2001-11-13 00:00:00	\N	38000177		0	0	0		0	0	0	33842	0	00025152531	44923712		
53810	4473	1713671	2005-06-09	2005-06-09 00:00:00	2005-06-16	2005-06-16 00:00:00	2005-06-16	38000177		0	0	7		0	0	0	297566	0	562251	1713671		
104767	2297	40213227	2015-09-17	2015-09-17 00:00:00	2015-09-17	2015-09-17 00:00:00	2015-09-17	581452		0	0	0		0	0	0	152961	0	113	40213227		
19807	431	40213227	1999-06-10	1999-06-10 00:00:00	1999-06-10	1999-06-10 00:00:00	1999-06-10	581452		0	0	0		0	0	0	28570	0	113	40213227		
38351	3172	1127433	1980-02-06	1980-02-06 00:00:00	1980-02-13	1980-02-13 00:00:00	1980-02-13	38000177		0	0	7		0	0	0	210850	0	313782	1127433		
30979	2566	40162522	2015-11-22	2015-11-22 00:00:00	2015-11-22	2015-11-22 00:00:00	\N	38000177		0	0	0		0	0	0	169984	0	857005	40162522		
64224	5331	1127433	2017-08-19	2017-08-19 00:00:00	2017-08-26	2017-08-26 00:00:00	2017-08-26	38000177		0	0	7		0	0	0	354949	0	313782	1127433		
275	19	19078461	2003-07-16	2003-07-16 00:00:00	2003-08-15	2003-08-15 00:00:00	2003-08-15	38000177		0	0	30		0	0	0	1545	0	310965	19078461		
48222	3997	40229134	2017-07-22	2017-07-22 00:00:00	2017-07-29	2017-07-29 00:00:00	2017-07-29	38000177		0	0	7		0	0	0	265772	0	1043400	40229134		
27377	2265	40232448	1967-03-09	1967-03-09 00:00:00	1967-03-09	1967-03-09 00:00:00	\N	38000177		0	0	0		0	0	0	150513	0	1049630	40232448		
36200	2985	1713671	1983-08-18	1983-08-18 00:00:00	1983-08-25	1983-08-25 00:00:00	1983-08-25	38000177		0	0	7		0	0	0	199263	0	562251	1713671		
18268	1512	19019979	1977-03-12	1977-03-12 00:00:00	1977-03-26	1977-03-26 00:00:00	1977-03-26	38000177		0	0	14		0	0	0	100943	0	198405	19019979		
59661	4960	40229134	1918-09-28	1918-09-28 00:00:00	1918-10-05	1918-10-05 00:00:00	1918-10-05	38000177		0	0	7		0	0	0	329735	0	1043400	40229134		
27471	2274	19078461	1976-02-02	1976-02-02 00:00:00	1976-02-16	1976-02-16 00:00:00	1976-02-16	38000177		0	0	14		0	0	0	151209	0	310965	19078461		
28891	2387	1115171	2002-10-27	2002-10-27 00:00:00	2002-11-10	2002-11-10 00:00:00	2002-11-10	38000177		0	0	14		0	0	0	158759	0	849574	1115171		
45752	3787	1127433	1978-07-16	1978-07-16 00:00:00	1978-07-23	1978-07-23 00:00:00	1978-07-23	38000177		0	0	7		0	0	0	251733	0	313782	1127433		
48621	4027	19128022	1996-11-15	1996-11-15 00:00:00	1997-11-10	1997-11-10 00:00:00	1997-11-10	38000177		0	0	360		0	0	0	267878	0	749785	19128022		
30215	2504	19128065	1979-08-21	1979-08-21 00:00:00	1980-08-15	1980-08-15 00:00:00	1980-08-15	38000177		0	0	360		0	0	0	165817	0	749882	19128065		
27185	2242	1127433	2001-08-02	2001-08-02 00:00:00	2001-08-09	2001-08-09 00:00:00	2001-08-09	38000177		0	0	7		0	0	0	149236	0	313782	1127433		
56403	4680	19075601	2000-01-01	2000-01-01 00:00:00	2000-01-01	2000-01-01 00:00:00	2000-01-01	38000177		0	0	0		0	0	0	311966	0	309362	19075601		
37742	3119	46233988	1978-02-25	1978-02-25 00:00:00	1978-03-11	1978-03-11 00:00:00	1978-03-11	38000177		0	0	14		0	0	0	207590	0	1652673	46233988		
13900	299	40213160	1966-11-19	1966-11-19 00:00:00	1966-11-19	1966-11-19 00:00:00	1966-11-19	581452		0	0	0		0	0	0	19999	0	10	40213160		
32492	2693	920300	1984-01-24	1984-01-24 00:00:00	1984-01-31	1984-01-31 00:00:00	1984-01-31	38000177		0	0	7		0	0	0	178427	0	311989	920300		
41282	3422	1107882	1994-01-09	1994-01-09 00:00:00	1994-01-09	1994-01-09 00:00:00	\N	38000177		0	0	0		0	0	0	227027	0	311372	1107882		
1980	158	19059056	1961-12-28	1961-12-28 00:00:00	1962-01-18	1962-01-18 00:00:00	1962-01-18	38000177		0	0	21		0	0	0	10850	0	243670	19059056		
24827	2041	19075601	1998-09-01	1998-09-01 00:00:00	1998-09-01	1998-09-01 00:00:00	\N	38000177		0	0	0		0	0	0	135804	0	309362	19075601		
48435	4014	19078461	2018-10-29	2018-10-29 00:00:00	2018-12-28	2018-12-28 00:00:00	2018-12-28	38000177		0	0	60		0	0	0	266741	0	310965	19078461		
7466	624	19059056	1965-07-15	1965-07-15 00:00:00	1965-08-12	1965-08-12 00:00:00	1965-08-12	38000177		0	0	28		0	0	0	41691	0	243670	19059056		
4954	411	19133873	1964-01-07	1964-01-07 00:00:00	1964-01-14	1964-01-14 00:00:00	1964-01-14	38000177		0	0	7		0	0	0	27319	0	834061	19133873		
34318	2835	1127433	2013-10-12	2013-10-12 00:00:00	2013-10-19	2013-10-19 00:00:00	2013-10-19	38000177		0	0	7		0	0	0	188272	0	313782	1127433		
35518	2926	19128022	2002-08-09	2002-08-09 00:00:00	2003-08-04	2003-08-04 00:00:00	2003-08-04	38000177		0	0	360		0	0	0	195182	0	749785	19128022		
36629	3023	1127433	2014-04-05	2014-04-05 00:00:00	2014-04-12	2014-04-12 00:00:00	2014-04-12	38000177		0	0	7		0	0	0	201514	0	313782	1127433		
20226	1659	1127433	1983-05-03	1983-05-03 00:00:00	1983-05-17	1983-05-17 00:00:00	1983-05-17	38000177		0	0	14		0	0	0	111457	0	313782	1127433		
28631	2359	19126352	2011-04-25	2011-04-25 00:00:00	2011-04-25	2011-04-25 00:00:00	\N	38000177		0	0	0		0	0	0	157234	0	705129	19126352		
28688	2366	1127078	1974-12-09	1974-12-09 00:00:00	1975-03-09	1975-03-09 00:00:00	1975-03-09	38000177		0	0	90		0	0	0	157516	0	282464	1127078		
1721	137	19059056	1972-08-23	1972-08-23 00:00:00	1972-09-06	1972-09-06 00:00:00	1972-09-06	38000177		0	0	14		0	0	0	9232	0	243670	19059056		
1454	115	1118084	2001-04-04	2001-04-04 00:00:00	2001-04-04	2001-04-04 00:00:00	\N	38000177		0	0	0		0	0	0	7591	0	00025152531	44923712		
44407	3676	19128065	1993-09-22	1993-09-22 00:00:00	1994-09-17	1994-09-17 00:00:00	1994-09-17	38000177		0	0	360		0	0	0	244503	0	749882	19128065		
41443	3436	40229134	1996-02-07	1996-02-07 00:00:00	1996-02-21	1996-02-21 00:00:00	1996-02-21	38000177		0	0	14		0	0	0	227895	0	1043400	40229134		
17536	379	40213227	2016-08-06	2016-08-06 00:00:00	2016-08-06	2016-08-06 00:00:00	2016-08-06	581452		0	0	0		0	0	0	25099	0	113	40213227		
53564	1173	40213227	1995-09-18	1995-09-18 00:00:00	1995-09-18	1995-09-18 00:00:00	1995-09-18	581452		0	0	0		0	0	0	77261	0	113	40213227		
37959	828	40213296	1996-08-06	1996-08-06 00:00:00	1996-08-06	1996-08-06 00:00:00	1996-08-06	581452		0	0	0		0	0	0	54836	0	52	40213296		
117417	2580	40213160	1958-11-17	1958-11-17 00:00:00	1958-11-17	1958-11-17 00:00:00	1958-11-17	581452		0	0	0		0	0	0	170871	0	10	40213160		
50881	4227	1127433	2001-06-25	2001-06-25 00:00:00	2001-07-02	2001-07-02 00:00:00	2001-07-02	38000177		0	0	7		0	0	0	280784	0	313782	1127433		
128781	2832	40213260	2015-08-23	2015-08-23 00:00:00	2015-08-23	2015-08-23 00:00:00	2015-08-23	581452		0	0	0		0	0	0	187983	0	121	40213260		
22834	1878	1124300	2010-07-25	2010-07-25 00:00:00	2010-07-25	2010-07-25 00:00:00	\N	38000177		0	0	0		0	0	0	125330	0	00781178901	45011828		
29305	2425	19059056	1968-04-27	1968-04-27 00:00:00	1968-06-26	1968-06-26 00:00:00	1968-06-26	38000177		0	0	60		0	0	0	160872	0	243670	19059056		
29343	2428	19128065	1988-06-21	1988-06-21 00:00:00	1989-06-16	1989-06-16 00:00:00	1989-06-16	38000177		0	0	360		0	0	0	161068	0	749882	19128065		
33472	2771	19059056	1914-07-23	1914-07-23 00:00:00	1914-10-21	1914-10-21 00:00:00	1914-10-21	38000177		0	0	90		0	0	0	183467	0	243670	19059056		
26435	2175	19075601	2000-11-09	2000-11-09 00:00:00	2000-11-09	2000-11-09 00:00:00	\N	38000177		0	0	0		0	0	0	145084	0	309362	19075601		
39961	3307	40231925	1982-03-17	1982-03-17 00:00:00	1982-03-17	1982-03-17 00:00:00	\N	38000177		0	0	0		0	0	0	219578	0	1049221	40231925		
40005	3311	19059056	1965-11-13	1965-11-13 00:00:00	1965-12-04	1965-12-04 00:00:00	1965-12-04	38000177		0	0	21		0	0	0	219796	0	243670	19059056		
11118	925	1124300	2005-01-09	2005-01-09 00:00:00	2005-01-09	2005-01-09 00:00:00	\N	38000177		0	0	0		0	0	0	61595	0	00781178901	45011828		
11449	954	19019979	1983-01-25	1983-01-25 00:00:00	1983-02-15	1983-02-15 00:00:00	1983-02-15	38000177		0	0	21		0	0	0	63396	0	198405	19019979		
54566	4532	19133905	1937-01-17	1937-01-17 00:00:00	1937-01-30	1937-01-30 00:00:00	1937-01-30	38000177		0	0	13		0	0	0	301906	0	834102	19133905		
21959	1801	1118084	1994-07-31	1994-07-31 00:00:00	1994-07-31	1994-07-31 00:00:00	\N	38000177		0	0	0		0	0	0	120787	0	00025152531	44923712		
12854	1081	1127433	1963-03-10	1963-03-10 00:00:00	1963-03-17	1963-03-17 00:00:00	1963-03-17	38000177		0	0	7		0	0	0	70860	0	313782	1127433		
2803	225	40229134	1973-10-21	1973-10-21 00:00:00	1973-10-28	1973-10-28 00:00:00	1973-10-28	38000177		0	0	7		0	0	0	15176	0	1043400	40229134		
73867	1612	40213160	1964-01-07	1964-01-07 00:00:00	1964-01-07	1964-01-07 00:00:00	1964-01-07	581452		0	0	0		0	0	0	108377	0	10	40213160		
154168	3394	40213296	2007-12-15	2007-12-15 00:00:00	2007-12-15	2007-12-15 00:00:00	2007-12-15	581452		0	0	0		0	0	0	225170	0	52	40213296		
33429	729	40213296	2003-07-12	2003-07-12 00:00:00	2003-07-12	2003-07-12 00:00:00	2003-07-12	581452		0	0	0		0	0	0	48376	0	52	40213296		
13208	1108	40236824	2006-08-18	2006-08-18 00:00:00	2006-09-01	2006-09-01 00:00:00	2006-09-01	38000177		0	0	14		0	0	0	72969	0	1094107	40236824		
42932	3559	1127433	1978-10-26	1978-10-26 00:00:00	1978-11-16	1978-11-16 00:00:00	1978-11-16	38000177		0	0	21		0	0	0	236260	0	313782	1127433		
44838	975	40213296	2006-02-19	2006-02-19 00:00:00	2006-02-19	2006-02-19 00:00:00	2006-02-19	581452		0	0	0		0	0	0	65069	0	52	40213296		
6054	505	920334	1998-06-28	1998-06-28 00:00:00	1998-07-05	1998-07-05 00:00:00	1998-07-05	38000177		0	0	7		0	0	0	33790	0	311995	920334		
53811	4473	1127078	1973-04-15	1973-04-15 00:00:00	1973-04-29	1973-04-29 00:00:00	1973-04-29	38000177		0	0	14		0	0	0	297589	0	282464	1127078		
104768	2297	40213296	2015-09-17	2015-09-17 00:00:00	2015-09-17	2015-09-17 00:00:00	2015-09-17	581452		0	0	0		0	0	0	152961	0	52	40213296		
19810	431	40213160	1955-12-29	1955-12-29 00:00:00	1955-12-29	1955-12-29 00:00:00	1955-12-29	581452		0	0	0		0	0	0	28633	0	10	40213160		
38352	3172	42902245	1999-12-01	1999-12-01 00:00:00	2000-11-25	2000-11-25 00:00:00	2000-11-25	38000177		0	0	360		0	0	0	210841	0	1359133	42902245		
30980	2566	1713671	1959-05-02	1959-05-02 00:00:00	1959-05-23	1959-05-23 00:00:00	1959-05-23	38000177		0	0	21		0	0	0	169938	0	562251	1713671		
64225	5331	1127433	1989-10-13	1989-10-13 00:00:00	1989-10-27	1989-10-27 00:00:00	1989-10-27	38000177		0	0	14		0	0	0	354902	0	313782	1127433		
276	19	40231925	2003-07-16	2003-07-16 00:00:00	2003-07-16	2003-07-16 00:00:00	\N	38000177		0	0	0		0	0	0	1545	0	1049221	40231925		
48223	3997	1115171	1998-02-25	1998-02-25 00:00:00	1998-03-11	1998-03-11 00:00:00	1998-03-11	38000177		0	0	14		0	0	0	265703	0	849574	1115171		
27378	2265	1127433	1986-05-23	1986-05-23 00:00:00	1986-05-30	1986-05-30 00:00:00	1986-05-30	38000177		0	0	7		0	0	0	150559	0	313782	1127433		
36201	2985	40243436	1967-06-17	1967-06-17 00:00:00	1967-06-17	1967-06-17 00:00:00	1967-06-17	38000177		0	0	0		0	0	0	199186	0	1190795	40243436		
18269	1512	19006318	1976-05-02	1976-05-02 00:00:00	1976-05-16	1976-05-16 00:00:00	1976-05-16	38000177		0	0	14		0	0	0	100956	0	105078	19006318		
59662	4960	1127433	1991-02-14	1991-02-14 00:00:00	1991-03-07	1991-03-07 00:00:00	1991-03-07	38000177		0	0	21		0	0	0	329714	0	313782	1127433		
27472	2274	1127433	1958-06-29	1958-06-29 00:00:00	1958-07-06	1958-07-06 00:00:00	1958-07-06	38000177		0	0	7		0	0	0	151190	0	313782	1127433		
28892	2387	1118084	2006-04-04	2006-04-04 00:00:00	2006-04-04	2006-04-04 00:00:00	\N	38000177		0	0	0		0	0	0	158778	0	00025152531	44923712		
45753	3787	1124300	1998-07-20	1998-07-20 00:00:00	1998-07-20	1998-07-20 00:00:00	\N	38000177		0	0	0		0	0	0	251750	0	00781178901	45011828		
48622	4027	19133873	1976-08-25	1976-08-25 00:00:00	1976-09-03	1976-09-03 00:00:00	1976-09-03	38000177		0	0	9		0	0	0	267868	0	834061	19133873		
30216	2504	1118084	1989-12-31	1989-12-31 00:00:00	1989-12-31	1989-12-31 00:00:00	\N	38000177		0	0	0		0	0	0	165847	0	00025152531	44923712		
27186	2242	1118084	1964-09-16	1964-09-16 00:00:00	1964-09-16	1964-09-16 00:00:00	\N	38000177		0	0	0		0	0	0	149249	0	00025152531	44923712		
56404	4680	19059056	1928-09-25	1928-09-25 00:00:00	1928-12-24	1928-12-24 00:00:00	1928-12-24	38000177		0	0	90		0	0	0	311940	0	243670	19059056		
129421	2845	40213160	1955-09-08	1955-09-08 00:00:00	1955-09-08	1955-09-08 00:00:00	1955-09-08	581452		0	0	0		0	0	0	188944	0	10	40213160		
13904	300	40213160	1972-12-01	1972-12-01 00:00:00	1972-12-01	1972-12-01 00:00:00	1972-12-01	581452		0	0	0		0	0	0	20073	0	10	40213160		
32493	2693	1713671	1975-08-29	1975-08-29 00:00:00	1975-09-19	1975-09-19 00:00:00	1975-09-19	38000177		0	0	21		0	0	0	178402	0	562251	1713671		
41283	3422	19073188	1988-09-24	1988-09-24 00:00:00	1988-10-08	1988-10-08 00:00:00	1988-10-08	38000177		0	0	14		0	0	0	227030	0	308192	19073188		
1981	158	1713671	1983-04-18	1983-04-18 00:00:00	1983-05-09	1983-05-09 00:00:00	1983-05-09	38000177		0	0	21		0	0	0	10795	0	562251	1713671		
24828	2041	1332419	1998-09-01	1998-09-01 00:00:00	1998-09-01	1998-09-01 00:00:00	\N	38000177		0	0	0		0	0	0	135804	0	197361	1332419		
48436	4014	40231925	2018-10-29	2018-10-29 00:00:00	2018-10-29	2018-10-29 00:00:00	\N	38000177		0	0	0		0	0	0	266741	0	1049221	40231925		
3134	69	40213201	2010-01-13	2010-01-13 00:00:00	2010-01-13	2010-01-13 00:00:00	2010-01-13	581452		0	0	0		0	0	0	4635	0	33	40213201		
4955	411	1127433	2005-10-13	2005-10-13 00:00:00	2005-10-27	2005-10-27 00:00:00	2005-10-27	38000177		0	0	14		0	0	0	27337	0	313782	1127433		
34319	2835	1127433	1988-11-11	1988-11-11 00:00:00	1988-11-25	1988-11-25 00:00:00	1988-11-25	38000177		0	0	14		0	0	0	188343	0	313782	1127433		
35519	2926	19128022	2000-08-19	2000-08-19 00:00:00	2001-08-14	2001-08-14 00:00:00	2001-08-14	38000177		0	0	360		0	0	0	195181	0	749785	19128022		
36630	3023	43012433	2005-08-29	2005-08-29 00:00:00	2006-08-24	2006-08-24 00:00:00	2006-08-24	38000177		0	0	360		0	0	0	201538	0	1367439	43012433		
20227	1659	1127433	1980-01-29	1980-01-29 00:00:00	1980-02-05	1980-02-05 00:00:00	1980-02-05	38000177		0	0	7		0	0	0	111486	0	313782	1127433		
28632	2359	1332419	2011-04-25	2011-04-25 00:00:00	2011-04-25	2011-04-25 00:00:00	\N	38000177		0	0	0		0	0	0	157234	0	197361	1332419		
28689	2366	40229134	1982-01-18	1982-01-18 00:00:00	1982-01-25	1982-01-25 00:00:00	1982-01-25	38000177		0	0	7		0	0	0	157529	0	1043400	40229134		
1722	137	46233988	1972-08-23	1972-08-23 00:00:00	1972-09-06	1972-09-06 00:00:00	1972-09-06	38000177		0	0	14		0	0	0	9232	0	1652673	46233988		
1455	115	19128065	1974-10-23	1974-10-23 00:00:00	1975-10-18	1975-10-18 00:00:00	1975-10-18	38000177		0	0	360		0	0	0	7598	0	749882	19128065		
44408	3676	19133905	1989-08-07	1989-08-07 00:00:00	1989-08-18	1989-08-18 00:00:00	1989-08-18	38000177		0	0	11		0	0	0	244498	0	834102	19133905		
41444	3436	1713671	2015-10-08	2015-10-08 00:00:00	2015-10-22	2015-10-22 00:00:00	2015-10-22	38000177		0	0	14		0	0	0	227865	0	562251	1713671		
17540	379	40213227	1997-08-09	1997-08-09 00:00:00	1997-08-09	1997-08-09 00:00:00	1997-08-09	581452		0	0	0		0	0	0	25097	0	113	40213227		
33061	722	40213160	1969-10-21	1969-10-21 00:00:00	1969-10-21	1969-10-21 00:00:00	1969-10-21	581452		0	0	0		0	0	0	47753	0	10	40213160		
37964	828	40213160	1957-03-26	1957-03-26 00:00:00	1957-03-26	1957-03-26 00:00:00	1957-03-26	581452		0	0	0		0	0	0	54849	0	10	40213160		
48833	1070	40213227	1995-02-16	1995-02-16 00:00:00	1995-02-16	1995-02-16 00:00:00	1995-02-16	581452		0	0	0		0	0	0	70054	0	113	40213227		
50882	4227	19006318	1960-10-20	1960-10-20 00:00:00	1960-11-03	1960-11-03 00:00:00	1960-11-03	38000177		0	0	14		0	0	0	280850	0	105078	19006318		
128783	2832	40213227	2016-08-28	2016-08-28 00:00:00	2016-08-28	2016-08-28 00:00:00	2016-08-28	581452		0	0	0		0	0	0	187892	0	113	40213227		
22835	1878	19133873	1987-09-13	1987-09-13 00:00:00	1987-09-24	1987-09-24 00:00:00	1987-09-24	38000177		0	0	11		0	0	0	125320	0	834061	19133873		
29306	2425	1124300	1994-07-29	1994-07-29 00:00:00	1994-07-29	1994-07-29 00:00:00	\N	38000177		0	0	0		0	0	0	160899	0	00781178901	45011828		
29344	2428	1713671	2010-09-11	2010-09-11 00:00:00	2010-09-18	2010-09-18 00:00:00	2010-09-18	38000177		0	0	7		0	0	0	161086	0	562251	1713671		
33694	2788	19073183	1983-03-23	1983-03-23 00:00:00	1983-04-06	1983-04-06 00:00:00	1983-04-06	38000177		0	0	14		0	0	0	184699	0	308182	19073183		
26436	2175	19126352	2000-11-09	2000-11-09 00:00:00	2000-11-09	2000-11-09 00:00:00	\N	38000177		0	0	0		0	0	0	145084	0	705129	19126352		
39962	3307	19059056	1982-03-17	1982-03-17 00:00:00	1982-04-16	1982-04-16 00:00:00	1982-04-16	38000177		0	0	30		0	0	0	219578	0	243670	19059056		
40006	3311	1150771	1990-03-30	1990-03-30 00:00:00	1990-03-30	1990-03-30 00:00:00	\N	38000177		0	0	0		0	0	0	219805	0	197378	1150771		
11359	947	1127433	2009-09-28	2009-09-28 00:00:00	2009-10-19	2009-10-19 00:00:00	2009-10-19	38000177		0	0	21		0	0	0	62864	0	313782	1127433		
11450	954	19133905	1994-04-14	1994-04-14 00:00:00	1994-04-25	1994-04-25 00:00:00	1994-04-25	38000177		0	0	11		0	0	0	63376	0	834102	19133905		
54567	4532	19059056	1974-06-10	1974-06-10 00:00:00	1974-06-24	1974-06-24 00:00:00	1974-06-24	38000177		0	0	14		0	0	0	301892	0	243670	19059056		
21960	1801	1551192	1955-05-18	1955-05-18 00:00:00	1955-05-18	1955-05-18 00:00:00	1955-05-18	38000177		0	0	0		0	0	0	120748	0	312617	1551192		
12855	1081	1127433	2001-06-26	2001-06-26 00:00:00	2001-07-03	2001-07-03 00:00:00	2001-07-03	38000177		0	0	7		0	0	0	70845	0	313782	1127433		
2804	225	19059056	1973-08-09	1973-08-09 00:00:00	1973-08-30	1973-08-30 00:00:00	1973-08-30	38000177		0	0	21		0	0	0	15150	0	243670	19059056		
73869	1612	40213306	1985-12-17	1985-12-17 00:00:00	1985-12-17	1985-12-17 00:00:00	1985-12-17	581452		0	0	0		0	0	0	108435	0	43	40213306		
154172	3394	40213160	1970-09-12	1970-09-12 00:00:00	1970-09-12	1970-09-12 00:00:00	1970-09-12	581452		0	0	0		0	0	0	225150	0	10	40213160		
26183	571	40213160	1955-05-09	1955-05-09 00:00:00	1955-05-09	1955-05-09 00:00:00	1955-05-09	581452		0	0	0		0	0	0	37813	0	10	40213160		
13209	1108	1127078	1971-05-21	1971-05-21 00:00:00	1971-06-04	1971-06-04 00:00:00	1971-06-04	38000177		0	0	14		0	0	0	72971	0	282464	1127078		
42933	3559	1713671	2015-01-20	2015-01-20 00:00:00	2015-02-03	2015-02-03 00:00:00	2015-02-03	38000177		0	0	14		0	0	0	236318	0	562251	1713671		
44839	975	40213296	2008-02-24	2008-02-24 00:00:00	2008-02-24	2008-02-24 00:00:00	2008-02-24	581452		0	0	0		0	0	0	65015	0	52	40213296		
6055	505	1551192	1983-09-14	1983-09-14 00:00:00	1983-09-14	1983-09-14 00:00:00	1983-09-14	38000177		0	0	0		0	0	0	33828	0	312617	1551192		
53812	4473	46233988	1973-04-15	1973-04-15 00:00:00	1973-04-29	1973-04-29 00:00:00	1973-04-29	38000177		0	0	14		0	0	0	297589	0	1652673	46233988		
104771	2297	40213160	1974-05-16	1974-05-16 00:00:00	1974-05-16	1974-05-16 00:00:00	1974-05-16	581452		0	0	0		0	0	0	152947	0	10	40213160		
19814	431	40213227	2009-08-06	2009-08-06 00:00:00	2009-08-06	2009-08-06 00:00:00	2009-08-06	581452		0	0	0		0	0	0	28641	0	113	40213227		
38353	3172	19128022	1996-12-16	1996-12-16 00:00:00	1997-12-11	1997-12-11 00:00:00	1997-12-11	38000177		0	0	360		0	0	0	210854	0	749785	19128022		
30981	2566	40236824	1982-11-15	1982-11-15 00:00:00	1982-11-22	1982-11-22 00:00:00	1982-11-22	38000177		0	0	7		0	0	0	169996	0	1094107	40236824		
64226	5331	1127078	1970-03-26	1970-03-26 00:00:00	1970-05-25	1970-05-25 00:00:00	1970-05-25	38000177		0	0	60		0	0	0	354939	0	282464	1127078		
277	19	1124300	1985-05-16	1985-05-16 00:00:00	1985-05-16	1985-05-16 00:00:00	\N	38000177		0	0	0		0	0	0	1541	0	00781178901	45011828		
48224	3997	1127433	1997-01-17	1997-01-17 00:00:00	1997-01-31	1997-01-31 00:00:00	1997-01-31	38000177		0	0	14		0	0	0	265702	0	313782	1127433		
27379	2266	1127433	1995-05-31	1995-05-31 00:00:00	1995-06-14	1995-06-14 00:00:00	1995-06-14	38000177		0	0	14		0	0	0	150621	0	313782	1127433		
36202	2985	1310034	1967-06-17	1967-06-17 00:00:00	1967-06-17	1967-06-17 00:00:00	1967-06-17	38000177		0	0	0		0	0	0	199186	0	834357	1310034		
18270	1512	19059056	1976-05-02	1976-05-02 00:00:00	1976-05-16	1976-05-16 00:00:00	1976-05-16	38000177		0	0	14		0	0	0	100956	0	243670	19059056		
13640	1143	19078461	2008-04-18	2008-04-18 00:00:00	2008-05-23	2008-05-23 00:00:00	2008-05-23	38000177		0	0	35		0	0	0	75459	0	310965	19078461		
27473	2274	19133873	1954-10-25	1954-10-25 00:00:00	1954-11-06	1954-11-06 00:00:00	1954-11-06	38000177		0	0	12		0	0	0	151189	0	834061	19133873		
28894	2387	1713671	2006-09-03	2006-09-03 00:00:00	2006-09-10	2006-09-10 00:00:00	2006-09-10	38000177		0	0	7		0	0	0	158779	0	562251	1713671		
45754	3788	1713671	2009-12-11	2009-12-11 00:00:00	2010-01-01	2010-01-01 00:00:00	2010-01-01	38000177		0	0	21		0	0	0	251847	0	562251	1713671		
48623	4027	19112599	1975-02-13	1975-02-13 00:00:00	1975-02-13	1975-02-13 00:00:00	\N	38000177		0	0	0		0	0	0	267867	0	477045	19112599		
30217	2504	1127078	1963-08-05	1963-08-05 00:00:00	1963-10-04	1963-10-04 00:00:00	1963-10-04	38000177		0	0	60		0	0	0	165851	0	282464	1127078		
27187	2242	19059056	1939-08-04	1939-08-04 00:00:00	1939-09-08	1939-09-08 00:00:00	1939-09-08	38000177		0	0	35		0	0	0	149263	0	243670	19059056		
56405	4680	19059056	1967-07-31	1967-07-31 00:00:00	1967-08-14	1967-08-14 00:00:00	1967-08-14	38000177		0	0	14		0	0	0	311946	0	243670	19059056		
129425	2845	40213160	1955-03-10	1955-03-10 00:00:00	1955-03-10	1955-03-10 00:00:00	1955-03-10	581452		0	0	0		0	0	0	188969	0	10	40213160		
13917	300	40213227	1994-11-04	1994-11-04 00:00:00	1994-11-04	1994-11-04 00:00:00	1994-11-04	581452		0	0	0		0	0	0	20065	0	113	40213227		
32494	2693	1127433	1962-01-27	1962-01-27 00:00:00	1962-02-10	1962-02-10 00:00:00	1962-02-10	38000177		0	0	14		0	0	0	178421	0	313782	1127433		
41284	3422	19078461	1988-09-24	1988-09-24 00:00:00	1988-10-08	1988-10-08 00:00:00	1988-10-08	38000177		0	0	14		0	0	0	227030	0	310965	19078461		
1982	158	1118084	1983-11-11	1983-11-11 00:00:00	1983-11-11	1983-11-11 00:00:00	\N	38000177		0	0	0		0	0	0	10795	0	00025152531	44923712		
24829	2041	19126352	1998-09-01	1998-09-01 00:00:00	1998-09-01	1998-09-01 00:00:00	\N	38000177		0	0	0		0	0	0	135804	0	705129	19126352		
48437	4014	1127433	1977-02-27	1977-02-27 00:00:00	1977-03-13	1977-03-13 00:00:00	1977-03-13	38000177		0	0	14		0	0	0	266787	0	313782	1127433		
3135	69	40213198	2010-01-13	2010-01-13 00:00:00	2010-01-13	2010-01-13 00:00:00	2010-01-13	581452		0	0	0		0	0	0	4635	0	133	40213198		
4956	411	19133873	1963-11-28	1963-11-28 00:00:00	1963-12-05	1963-12-05 00:00:00	1963-12-05	38000177		0	0	7		0	0	0	27364	0	834061	19133873		
34320	2835	19059056	1956-07-15	1956-07-15 00:00:00	1956-08-19	1956-08-19 00:00:00	1956-08-19	38000177		0	0	35		0	0	0	188340	0	243670	19059056		
35520	2927	1127433	1945-04-10	1945-04-10 00:00:00	1945-04-24	1945-04-24 00:00:00	1945-04-24	38000177		0	0	14		0	0	0	195275	0	313782	1127433		
36631	3023	42902245	2000-09-24	2000-09-24 00:00:00	2001-09-19	2001-09-19 00:00:00	2001-09-19	38000177		0	0	360		0	0	0	201521	0	1359133	42902245		
20246	1661	1127078	1957-09-17	1957-09-17 00:00:00	1957-10-01	1957-10-01 00:00:00	1957-10-01	38000177		0	0	14		0	0	0	111695	0	282464	1127078		
28633	2359	1539411	2011-04-25	2011-04-25 00:00:00	2011-04-25	2011-04-25 00:00:00	\N	38000177		0	0	0		0	0	0	157234	0	312961	1539411		
28690	2366	1118084	2006-06-25	2006-06-25 00:00:00	2006-06-25	2006-06-25 00:00:00	\N	38000177		0	0	0		0	0	0	157506	0	00025152531	44923712		
1723	137	19008572	2002-06-30	2002-06-30 00:00:00	2002-06-30	2002-06-30 00:00:00	\N	38000177		0	0	0		0	0	0	9230	0	106258	19008572		
1456	115	19006318	1960-12-25	1960-12-25 00:00:00	1961-01-08	1961-01-08 00:00:00	1961-01-08	38000177		0	0	14		0	0	0	7623	0	105078	19006318		
44409	3676	1118084	2015-09-22	2015-09-22 00:00:00	2015-09-22	2015-09-22 00:00:00	\N	38000177		0	0	0		0	0	0	244543	0	00025152531	44923712		
41445	3436	1127433	1969-04-19	1969-04-19 00:00:00	1969-05-03	1969-05-03 00:00:00	1969-05-03	38000177		0	0	14		0	0	0	227875	0	313782	1127433		
17541	379	40213306	1997-08-09	1997-08-09 00:00:00	1997-08-09	1997-08-09 00:00:00	1997-08-09	581452		0	0	0		0	0	0	25097	0	43	40213306		
33066	722	40213160	1969-05-20	1969-05-20 00:00:00	1969-05-20	1969-05-20 00:00:00	1969-05-20	581452		0	0	0		0	0	0	47791	0	10	40213160		
37967	828	40213160	1955-03-22	1955-03-22 00:00:00	1955-03-22	1955-03-22 00:00:00	1955-03-22	581452		0	0	0		0	0	0	54856	0	10	40213160		
48834	1070	40213306	1995-02-16	1995-02-16 00:00:00	1995-02-16	1995-02-16 00:00:00	1995-02-16	581452		0	0	0		0	0	0	70054	0	43	40213306		
50883	4227	1127078	1960-10-20	1960-10-20 00:00:00	1960-11-03	1960-11-03 00:00:00	1960-11-03	38000177		0	0	14		0	0	0	280850	0	282464	1127078		
128788	2832	40213296	2007-05-06	2007-05-06 00:00:00	2007-05-06	2007-05-06 00:00:00	2007-05-06	581452		0	0	0		0	0	0	187972	0	52	40213296		
22836	1878	19019979	1976-02-08	1976-02-08 00:00:00	1976-02-29	1976-02-29 00:00:00	1976-02-29	38000177		0	0	21		0	0	0	125347	0	198405	19019979		
29307	2425	19059056	1966-01-08	1966-01-08 00:00:00	1966-04-08	1966-04-08 00:00:00	1966-04-08	38000177		0	0	90		0	0	0	160871	0	243670	19059056		
29360	2431	1713671	1986-04-02	1986-04-02 00:00:00	1986-04-16	1986-04-16 00:00:00	1986-04-16	38000177		0	0	14		0	0	0	161227	0	562251	1713671		
33695	2788	1127078	1983-03-23	1983-03-23 00:00:00	1983-04-06	1983-04-06 00:00:00	1983-04-06	38000177		0	0	14		0	0	0	184699	0	282464	1127078		
39873	3298	1124300	2006-10-30	2006-10-30 00:00:00	2006-10-30	2006-10-30 00:00:00	\N	38000177		0	0	0		0	0	0	219132	0	00781178901	45011828		
39963	3307	1124300	2003-07-05	2003-07-05 00:00:00	2003-07-05	2003-07-05 00:00:00	\N	38000177		0	0	0		0	0	0	219619	0	00781178901	45011828		
36461	3007	19059056	1969-04-09	1969-04-09 00:00:00	1969-05-14	1969-05-14 00:00:00	1969-05-14	38000177		0	0	35		0	0	0	200599	0	243670	19059056		
11360	947	1127433	2008-05-02	2008-05-02 00:00:00	2008-05-16	2008-05-16 00:00:00	2008-05-16	38000177		0	0	14		0	0	0	62872	0	313782	1127433		
25441	2090	40165015	2004-09-07	2004-09-07 00:00:00	2004-09-07	2004-09-07 00:00:00	\N	38000177		0	0	0		0	0	0	139374	0	861467	40165015		
54568	4532	1713671	1983-06-30	1983-06-30 00:00:00	1983-07-07	1983-07-07 00:00:00	1983-07-07	38000177		0	0	7		0	0	0	301896	0	562251	1713671		
21961	1801	19133905	1981-12-27	1981-12-27 00:00:00	1982-01-03	1982-01-03 00:00:00	1982-01-03	38000177		0	0	7		0	0	0	120761	0	834102	19133905		
12856	1082	19133873	1966-02-25	1966-02-25 00:00:00	1966-03-10	1966-03-10 00:00:00	1966-03-10	38000177		0	0	13		0	0	0	70903	0	834061	19133873		
2805	225	40236824	1987-02-07	1987-02-07 00:00:00	1987-02-14	1987-02-14 00:00:00	1987-02-14	38000177		0	0	7		0	0	0	15205	0	1094107	40236824		
73876	1612	40213160	1963-11-05	1963-11-05 00:00:00	1963-11-05	1963-11-05 00:00:00	1963-11-05	581452		0	0	0		0	0	0	108368	0	10	40213160		
154175	3394	40213296	2005-12-10	2005-12-10 00:00:00	2005-12-10	2005-12-10 00:00:00	2005-12-10	581452		0	0	0		0	0	0	225154	0	52	40213296		
26187	571	40213260	2007-08-27	2007-08-27 00:00:00	2007-08-27	2007-08-27 00:00:00	2007-08-27	581452		0	0	0		0	0	0	37821	0	121	40213260		
13210	1108	19129655	1971-05-21	1971-05-21 00:00:00	1971-06-04	1971-06-04 00:00:00	1971-06-04	38000177		0	0	14		0	0	0	72971	0	789980	19129655		
42934	3559	19059056	1953-06-20	1953-06-20 00:00:00	1953-07-20	1953-07-20 00:00:00	1953-07-20	38000177		0	0	30		0	0	0	236257	0	243670	19059056		
44841	975	40213227	2006-02-19	2006-02-19 00:00:00	2006-02-19	2006-02-19 00:00:00	2006-02-19	581452		0	0	0		0	0	0	65069	0	113	40213227		
6056	505	1127433	2019-02-28	2019-02-28 00:00:00	2019-03-07	2019-03-07 00:00:00	2019-03-07	38000177		0	0	7		0	0	0	33779	0	313782	1127433		
53813	4473	19133873	1981-09-15	1981-09-15 00:00:00	1981-09-23	1981-09-23 00:00:00	1981-09-23	38000177		0	0	8		0	0	0	297611	0	834061	19133873		
104776	2297	40213160	1974-02-14	1974-02-14 00:00:00	1974-02-14	1974-02-14 00:00:00	1974-02-14	581452		0	0	0		0	0	0	152936	0	10	40213160		
2821	63	40213160	1960-11-23	1960-11-23 00:00:00	1960-11-23	1960-11-23 00:00:00	1960-11-23	581452		0	0	0		0	0	0	4291	0	10	40213160		
38354	3172	19133873	1977-07-23	1977-07-23 00:00:00	1977-07-30	1977-07-30 00:00:00	1977-07-30	38000177		0	0	7		0	0	0	210833	0	834061	19133873		
30982	2566	920300	1982-11-15	1982-11-15 00:00:00	1982-11-22	1982-11-22 00:00:00	1982-11-22	38000177		0	0	7		0	0	0	169996	0	311989	920300		
64227	5331	1118084	2004-09-03	2004-09-03 00:00:00	2004-09-03	2004-09-03 00:00:00	\N	38000177		0	0	0		0	0	0	354941	0	00025152531	44923712		
279	19	40171902	2011-04-10	2011-04-10 00:00:00	2011-04-10	2011-04-10 00:00:00	\N	38000177		0	0	0		0	0	0	1471	0	897718	40171902		
48225	3997	1713671	1991-02-14	1991-02-14 00:00:00	1991-02-28	1991-02-28 00:00:00	1991-02-28	38000177		0	0	14		0	0	0	265769	0	562251	1713671		
27380	2266	1127433	2006-12-07	2006-12-07 00:00:00	2006-12-21	2006-12-21 00:00:00	2006-12-21	38000177		0	0	14		0	0	0	150638	0	313782	1127433		
3087	250	19128065	1988-02-10	1988-02-10 00:00:00	1989-02-04	1989-02-04 00:00:00	1989-02-04	38000177		0	0	360		0	0	0	16785	0	749882	19128065		
18271	1512	1115171	2010-10-01	2010-10-01 00:00:00	2010-10-15	2010-10-15 00:00:00	2010-10-15	38000177		0	0	14		0	0	0	100938	0	849574	1115171		
13641	1143	1127433	1992-02-05	1992-02-05 00:00:00	1992-02-12	1992-02-12 00:00:00	1992-02-12	38000177		0	0	7		0	0	0	75443	0	313782	1127433		
27474	2274	1127433	1975-03-25	1975-03-25 00:00:00	1975-04-08	1975-04-08 00:00:00	1975-04-08	38000177		0	0	14		0	0	0	151208	0	313782	1127433		
22815	495	40213306	1989-03-04	1989-03-04 00:00:00	1989-03-04	1989-03-04 00:00:00	1989-03-04	581452		0	0	0		0	0	0	33099	0	43	40213306		
45755	3788	19059056	1968-07-21	1968-07-21 00:00:00	1968-08-04	1968-08-04 00:00:00	1968-08-04	38000177		0	0	14		0	0	0	251821	0	243670	19059056		
48624	4027	1127433	2002-06-26	2002-06-26 00:00:00	2002-07-03	2002-07-03 00:00:00	2002-07-03	38000177		0	0	7		0	0	0	267826	0	313782	1127433		
165241	3633	40213296	2016-03-06	2016-03-06 00:00:00	2016-03-06	2016-03-06 00:00:00	2016-03-06	581452		0	0	0		0	0	0	241648	0	52	40213296		
27188	2242	19133905	1980-10-22	1980-10-22 00:00:00	1980-11-04	1980-11-04 00:00:00	1980-11-04	38000177		0	0	13		0	0	0	149234	0	834102	19133905		
56406	4680	1127433	1950-06-21	1950-06-21 00:00:00	1950-06-28	1950-06-28 00:00:00	1950-06-28	38000177		0	0	7		0	0	0	311886	0	313782	1127433		
129428	2845	40213227	1994-10-13	1994-10-13 00:00:00	1994-10-13	1994-10-13 00:00:00	1994-10-13	581452		0	0	0		0	0	0	188949	0	113	40213227		
13918	300	40213306	1994-11-04	1994-11-04 00:00:00	1994-11-04	1994-11-04 00:00:00	1994-11-04	581452		0	0	0		0	0	0	20065	0	43	40213306		
32495	2693	1127433	1967-09-22	1967-09-22 00:00:00	1967-10-06	1967-10-06 00:00:00	1967-10-06	38000177		0	0	14		0	0	0	178425	0	313782	1127433		
41286	3422	19133905	2012-09-19	2012-09-19 00:00:00	2012-09-29	2012-09-29 00:00:00	2012-09-29	38000177		0	0	10		0	0	0	227029	0	834102	19133905		
1983	158	1713671	2017-08-17	2017-08-17 00:00:00	2017-09-07	2017-09-07 00:00:00	2017-09-07	38000177		0	0	21		0	0	0	10798	0	562251	1713671		
24830	2041	40229134	1974-06-13	1974-06-13 00:00:00	1974-06-27	1974-06-27 00:00:00	1974-06-27	38000177		0	0	14		0	0	0	135790	0	1043400	40229134		
48438	4014	19006318	1968-02-24	1968-02-24 00:00:00	1968-03-09	1968-03-09 00:00:00	1968-03-09	38000177		0	0	14		0	0	0	266751	0	105078	19006318		
3144	69	40213227	2015-02-11	2015-02-11 00:00:00	2015-02-11	2015-02-11 00:00:00	2015-02-11	581452		0	0	0		0	0	0	4668	0	113	40213227		
4957	411	1713671	2017-09-20	2017-09-20 00:00:00	2017-10-04	2017-10-04 00:00:00	2017-10-04	38000177		0	0	14		0	0	0	27339	0	562251	1713671		
34321	2835	1127433	2018-01-29	2018-01-29 00:00:00	2018-03-05	2018-03-05 00:00:00	2018-03-05	38000177		0	0	35		0	0	0	188347	0	313782	1127433		
35521	2927	1127433	1958-05-21	1958-05-21 00:00:00	1958-06-04	1958-06-04 00:00:00	1958-06-04	38000177		0	0	14		0	0	0	195199	0	313782	1127433		
36632	3023	1118084	2018-02-02	2018-02-02 00:00:00	2018-02-02	2018-02-02 00:00:00	\N	38000177		0	0	0		0	0	0	201513	0	00025152531	44923712		
20247	1661	19006318	1957-09-17	1957-09-17 00:00:00	1957-10-01	1957-10-01 00:00:00	1957-10-01	38000177		0	0	14		0	0	0	111695	0	105078	19006318		
28634	2359	1127433	1927-12-03	1927-12-03 00:00:00	1927-12-10	1927-12-10 00:00:00	1927-12-10	38000177		0	0	7		0	0	0	157175	0	313782	1127433		
28691	2366	19128022	1989-07-19	1989-07-19 00:00:00	1990-07-14	1990-07-14 00:00:00	1990-07-14	38000177		0	0	360		0	0	0	157512	0	749785	19128022		
1724	137	1713671	1983-07-17	1983-07-17 00:00:00	1983-08-07	1983-08-07 00:00:00	1983-08-07	38000177		0	0	21		0	0	0	9125	0	562251	1713671		
1457	115	1127078	1960-12-25	1960-12-25 00:00:00	1961-01-08	1961-01-08 00:00:00	1961-01-08	38000177		0	0	14		0	0	0	7623	0	282464	1127078		
44410	3676	46233988	1971-06-10	1971-06-10 00:00:00	1971-06-24	1971-06-24 00:00:00	1971-06-24	38000177		0	0	14		0	0	0	244501	0	1652673	46233988		
41446	3436	1713671	1983-05-14	1983-05-14 00:00:00	1983-06-04	1983-06-04 00:00:00	1983-06-04	38000177		0	0	21		0	0	0	227878	0	562251	1713671		
9378	199	40213227	2002-06-05	2002-06-05 00:00:00	2002-06-05	2002-06-05 00:00:00	2002-06-05	581452		0	0	0		0	0	0	13668	0	113	40213227		
33070	722	40213227	2011-12-13	2011-12-13 00:00:00	2011-12-13	2011-12-13 00:00:00	2011-12-13	581452		0	0	0		0	0	0	47784	0	113	40213227		
37969	828	40213160	1956-03-20	1956-03-20 00:00:00	1956-03-20	1956-03-20 00:00:00	1956-03-20	581452		0	0	0		0	0	0	54831	0	10	40213160		
48835	1070	40213160	1973-02-08	1973-02-08 00:00:00	1973-02-08	1973-02-08 00:00:00	1973-02-08	581452		0	0	0		0	0	0	70067	0	10	40213160		
50884	4227	46275916	2003-04-06	2003-04-06 00:00:00	2003-04-06	2003-04-06 00:00:00	2003-04-06	38000177		0	0	0		0	0	0	280798	0	1660014	46275916		
128790	2832	40213227	2007-05-06	2007-05-06 00:00:00	2007-05-06	2007-05-06 00:00:00	2007-05-06	581452		0	0	0		0	0	0	187972	0	113	40213227		
22837	1878	1713671	2007-02-04	2007-02-04 00:00:00	2007-02-18	2007-02-18 00:00:00	2007-02-18	38000177		0	0	14		0	0	0	125324	0	562251	1713671		
29308	2425	1713671	2017-01-15	2017-01-15 00:00:00	2017-02-05	2017-02-05 00:00:00	2017-02-05	38000177		0	0	21		0	0	0	160946	0	562251	1713671		
29361	2431	1118084	2013-07-30	2013-07-30 00:00:00	2013-07-30	2013-07-30 00:00:00	\N	38000177		0	0	0		0	0	0	161204	0	00025152531	44923712		
33696	2788	1127433	2017-11-24	2017-11-24 00:00:00	2018-01-30	2018-01-30 00:00:00	2018-01-30	38000177		0	0	67		0	0	0	184724	0	313782	1127433		
39874	3298	19133873	1972-12-10	1972-12-10 00:00:00	1972-12-20	1972-12-20 00:00:00	1972-12-20	38000177		0	0	10		0	0	0	219125	0	834061	19133873		
39964	3307	1713671	1968-01-17	1968-01-17 00:00:00	1968-01-24	1968-01-24 00:00:00	1968-01-24	38000177		0	0	7		0	0	0	219551	0	562251	1713671		
36462	3007	1127433	1983-01-28	1983-01-28 00:00:00	1983-02-04	1983-02-04 00:00:00	1983-02-04	38000177		0	0	7		0	0	0	200577	0	313782	1127433		
11361	947	19133873	1974-02-22	1974-02-22 00:00:00	1974-03-06	1974-03-06 00:00:00	1974-03-06	38000177		0	0	12		0	0	0	62894	0	834061	19133873		
25443	2090	1127433	2011-06-10	2011-06-10 00:00:00	2011-06-24	2011-06-24 00:00:00	2011-06-24	38000177		0	0	14		0	0	0	139390	0	313782	1127433		
54569	4532	1713671	1926-05-14	1926-05-14 00:00:00	1926-05-21	1926-05-21 00:00:00	1926-05-21	38000177		0	0	7		0	0	0	301830	0	562251	1713671		
21962	1801	1127433	2009-11-24	2009-11-24 00:00:00	2009-12-01	2009-12-01 00:00:00	2009-12-01	38000177		0	0	7		0	0	0	120736	0	313782	1127433		
12857	1082	19059056	1962-11-11	1962-11-11 00:00:00	1962-12-11	1962-12-11 00:00:00	1962-12-11	38000177		0	0	30		0	0	0	71052	0	243670	19059056		
2806	225	920300	1987-02-07	1987-02-07 00:00:00	1987-02-14	1987-02-14 00:00:00	1987-02-14	38000177		0	0	7		0	0	0	15205	0	311989	920300		
73881	1612	40213227	2005-08-10	2005-08-10 00:00:00	2005-08-10	2005-08-10 00:00:00	2005-08-10	581452		0	0	0		0	0	0	108411	0	113	40213227		
154177	3394	40213306	1988-01-23	1988-01-23 00:00:00	1988-01-23	1988-01-23 00:00:00	1988-01-23	581452		0	0	0		0	0	0	225138	0	43	40213306		
26189	571	40213227	1996-09-09	1996-09-09 00:00:00	1996-09-09	1996-09-09 00:00:00	1996-09-09	581452		0	0	0		0	0	0	37819	0	113	40213227		
13211	1108	920300	2011-10-07	2011-10-07 00:00:00	2011-10-14	2011-10-14 00:00:00	2011-10-14	38000177		0	0	7		0	0	0	72970	0	311989	920300		
42935	3559	40165015	1995-09-18	1995-09-18 00:00:00	1995-09-18	1995-09-18 00:00:00	\N	38000177		0	0	0		0	0	0	236261	0	861467	40165015		
60041	4990	40229134	1971-03-09	1971-03-09 00:00:00	1971-03-23	1971-03-23 00:00:00	1971-03-23	38000177		0	0	14		0	0	0	331974	0	1043400	40229134		
89504	1962	40213160	1964-07-15	1964-07-15 00:00:00	1964-07-15	1964-07-15 00:00:00	1964-07-15	581452		0	0	0		0	0	0	130493	0	10	40213160		
53814	4473	1713671	2018-10-12	2018-10-12 00:00:00	2018-10-26	2018-10-26 00:00:00	2018-10-26	38000177		0	0	14		0	0	0	297614	0	562251	1713671		
61913	5150	19133873	1952-01-02	1952-01-02 00:00:00	1952-01-13	1952-01-13 00:00:00	1952-01-13	38000177		0	0	11		0	0	0	342372	0	834061	19133873		
2831	63	40213227	1998-05-21	1998-05-21 00:00:00	1998-05-21	1998-05-21 00:00:00	1998-05-21	581452		0	0	0		0	0	0	4278	0	113	40213227		
38355	3172	40229134	2005-01-23	2005-01-23 00:00:00	2005-01-30	2005-01-30 00:00:00	2005-01-30	38000177		0	0	7		0	0	0	210853	0	1043400	40229134		
104876	2300	40213227	1993-12-09	1993-12-09 00:00:00	1993-12-09	1993-12-09 00:00:00	1993-12-09	581452		0	0	0		0	0	0	153160	0	113	40213227		
64229	5331	19128065	1979-07-17	1979-07-17 00:00:00	1980-07-11	1980-07-11 00:00:00	1980-07-11	38000177		0	0	360		0	0	0	354920	0	749882	19128065		
280	19	19018935	2011-04-10	2011-04-10 00:00:00	2011-04-10	2011-04-10 00:00:00	\N	38000177		0	0	0		0	0	0	1471	0	197604	19018935		
48226	3997	1127078	1978-04-13	1978-04-13 00:00:00	1978-06-12	1978-06-12 00:00:00	1978-06-12	38000177		0	0	60		0	0	0	265700	0	282464	1127078		
27381	2266	1127078	1978-06-25	1978-06-25 00:00:00	1978-07-16	1978-07-16 00:00:00	1978-07-16	38000177		0	0	21		0	0	0	150635	0	282464	1127078		
3088	250	40229134	2002-08-13	2002-08-13 00:00:00	2002-08-27	2002-08-27 00:00:00	2002-08-27	38000177		0	0	14		0	0	0	16805	0	1043400	40229134		
18272	1512	19128022	1991-05-24	1991-05-24 00:00:00	1992-05-18	1992-05-18 00:00:00	1992-05-18	38000177		0	0	360		0	0	0	101008	0	749785	19128022		
13642	1143	40229134	1999-07-18	1999-07-18 00:00:00	1999-08-01	1999-08-01 00:00:00	1999-08-01	38000177		0	0	14		0	0	0	75419	0	1043400	40229134		
27483	2277	1124300	2001-03-15	2001-03-15 00:00:00	2001-03-15	2001-03-15 00:00:00	\N	38000177		0	0	0		0	0	0	151335	0	00781178901	45011828		
22820	495	40213160	1973-04-28	1973-04-28 00:00:00	1973-04-28	1973-04-28 00:00:00	1973-04-28	581452		0	0	0		0	0	0	33089	0	10	40213160		
45756	3788	19129655	1968-07-21	1968-07-21 00:00:00	1968-08-04	1968-08-04 00:00:00	1968-08-04	38000177		0	0	14		0	0	0	251821	0	789980	19129655		
48625	4027	19127922	2002-10-15	2002-10-15 00:00:00	2003-10-10	2003-10-10 00:00:00	2003-10-10	38000177		0	0	360		0	0	0	267857	0	748962	19127922		
165247	3633	40213160	1977-05-08	1977-05-08 00:00:00	1977-05-08	1977-05-08 00:00:00	1977-05-08	581452		0	0	0		0	0	0	241669	0	10	40213160		
27189	2242	1127433	1969-02-02	1969-02-02 00:00:00	1969-02-16	1969-02-16 00:00:00	1969-02-16	38000177		0	0	14		0	0	0	149230	0	313782	1127433		
56407	4680	1124300	1952-07-25	1952-07-25 00:00:00	1952-07-25	1952-07-25 00:00:00	\N	38000177		0	0	0		0	0	0	311899	0	00781178901	45011828		
129439	2846	40213296	2014-07-06	2014-07-06 00:00:00	2014-07-06	2014-07-06 00:00:00	2014-07-06	581452		0	0	0		0	0	0	189051	0	52	40213296		
10151	851	1127078	1982-05-27	1982-05-27 00:00:00	1982-06-10	1982-06-10 00:00:00	1982-06-10	38000177		0	0	14		0	0	0	56272	0	282464	1127078		
6634	144	40213314	1978-05-26	1978-05-26 00:00:00	1978-05-26	1978-05-26 00:00:00	1978-05-26	581452		0	0	0		0	0	0	9641	0	49	40213314		
41287	3422	1127078	1977-11-21	1977-11-21 00:00:00	1977-12-26	1977-12-26 00:00:00	1977-12-26	38000177		0	0	35		0	0	0	226980	0	282464	1127078		
1984	158	19059056	1948-10-25	1948-10-25 00:00:00	1949-01-23	1949-01-23 00:00:00	1949-01-23	38000177		0	0	90		0	0	0	10847	0	243670	19059056		
24831	2041	19059056	1968-02-18	1968-02-18 00:00:00	1968-03-03	1968-03-03 00:00:00	1968-03-03	38000177		0	0	14		0	0	0	135845	0	243670	19059056		
48439	4014	19059056	1968-02-24	1968-02-24 00:00:00	1968-03-09	1968-03-09 00:00:00	1968-03-09	38000177		0	0	14		0	0	0	266751	0	243670	19059056		
3162	69	40213227	1994-11-02	1994-11-02 00:00:00	1994-11-02	1994-11-02 00:00:00	1994-11-02	581452		0	0	0		0	0	0	4662	0	113	40213227		
4958	411	19112599	1961-03-13	1961-03-13 00:00:00	1961-03-13	1961-03-13 00:00:00	\N	38000177		0	0	0		0	0	0	27318	0	477045	19112599		
34322	2835	40236824	1957-12-07	1957-12-07 00:00:00	1957-12-14	1957-12-14 00:00:00	1957-12-14	38000177		0	0	7		0	0	0	188352	0	1094107	40236824		
35522	2927	19059056	1957-02-18	1957-02-18 00:00:00	1957-03-25	1957-03-25 00:00:00	1957-03-25	38000177		0	0	35		0	0	0	195294	0	243670	19059056		
36633	3023	40236824	2008-11-29	2008-11-29 00:00:00	2008-12-06	2008-12-06 00:00:00	2008-12-06	38000177		0	0	7		0	0	0	201536	0	1094107	40236824		
20248	1661	40229134	1963-02-19	1963-02-19 00:00:00	1963-02-26	1963-02-26 00:00:00	1963-02-26	38000177		0	0	7		0	0	0	111682	0	1043400	40229134		
28635	2359	1127433	1978-11-29	1978-11-29 00:00:00	1978-12-13	1978-12-13 00:00:00	1978-12-13	38000177		0	0	14		0	0	0	157278	0	313782	1127433		
28692	2366	19128065	1985-08-09	1985-08-09 00:00:00	1986-08-04	1986-08-04 00:00:00	1986-08-04	38000177		0	0	360		0	0	0	157510	0	749882	19128065		
1725	137	19133873	1978-11-04	1978-11-04 00:00:00	1978-11-13	1978-11-13 00:00:00	1978-11-13	38000177		0	0	9		0	0	0	9124	0	834061	19133873		
1458	115	1127433	1978-05-23	1978-05-23 00:00:00	1978-06-06	1978-06-06 00:00:00	1978-06-06	38000177		0	0	14		0	0	0	7636	0	313782	1127433		
44411	3676	1127078	1971-06-10	1971-06-10 00:00:00	1971-06-24	1971-06-24 00:00:00	1971-06-24	38000177		0	0	14		0	0	0	244501	0	282464	1127078		
41447	3436	1127433	1979-04-12	1979-04-12 00:00:00	1979-04-19	1979-04-19 00:00:00	1979-04-19	38000177		0	0	7		0	0	0	227862	0	313782	1127433		
63077	1379	40213227	2011-03-12	2011-03-12 00:00:00	2011-03-12	2011-03-12 00:00:00	2011-03-12	581452		0	0	0		0	0	0	91472	0	113	40213227		
33071	722	40213296	2011-12-13	2011-12-13 00:00:00	2011-12-13	2011-12-13 00:00:00	2011-12-13	581452		0	0	0		0	0	0	47784	0	52	40213296		
37971	828	40213227	1994-08-02	1994-08-02 00:00:00	1994-08-02	1994-08-02 00:00:00	1994-08-02	581452		0	0	0		0	0	0	54872	0	113	40213227		
45570	994	40213227	1994-01-12	1994-01-12 00:00:00	1994-01-12	1994-01-12 00:00:00	1994-01-12	581452		0	0	0		0	0	0	65873	0	113	40213227		
50885	4227	1310034	2003-04-06	2003-04-06 00:00:00	2003-04-06	2003-04-06 00:00:00	2003-04-06	38000177		0	0	0		0	0	0	280798	0	834357	1310034		
128793	2832	40213260	2015-02-15	2015-02-15 00:00:00	2015-02-15	2015-02-15 00:00:00	2015-02-15	581452		0	0	0		0	0	0	187957	0	121	40213260		
22838	1878	19133905	2013-07-12	2013-07-12 00:00:00	2013-07-20	2013-07-20 00:00:00	2013-07-20	38000177		0	0	8		0	0	0	125325	0	834102	19133905		
29309	2425	40229134	2008-09-20	2008-09-20 00:00:00	2008-10-04	2008-10-04 00:00:00	2008-10-04	38000177		0	0	14		0	0	0	160945	0	1043400	40229134		
29362	2431	19059056	1975-06-30	1975-06-30 00:00:00	1975-07-30	1975-07-30 00:00:00	1975-07-30	38000177		0	0	30		0	0	0	161243	0	243670	19059056		
33697	2788	1124300	2018-06-27	2018-06-27 00:00:00	2018-06-27	2018-06-27 00:00:00	\N	38000177		0	0	0		0	0	0	184746	0	00781178901	45011828		
39875	3298	1127433	1985-05-04	1985-05-04 00:00:00	1985-05-18	1985-05-18 00:00:00	1985-05-18	38000177		0	0	14		0	0	0	219147	0	313782	1127433		
10395	222	40213160	1955-08-19	1955-08-19 00:00:00	1955-08-19	1955-08-19 00:00:00	1955-08-19	581452		0	0	0		0	0	0	14956	0	10	40213160		
36463	3007	1127078	1967-01-20	1967-01-20 00:00:00	1967-02-03	1967-02-03 00:00:00	1967-02-03	38000177		0	0	14		0	0	0	200579	0	282464	1127078		
11362	947	19133905	2006-06-06	2006-06-06 00:00:00	2006-06-13	2006-06-13 00:00:00	2006-06-13	38000177		0	0	7		0	0	0	62846	0	834102	19133905		
25444	2090	40236824	1994-07-01	1994-07-01 00:00:00	1994-07-08	1994-07-08 00:00:00	1994-07-08	38000177		0	0	7		0	0	0	139376	0	1094107	40236824		
54578	4534	1713671	1943-12-02	1943-12-02 00:00:00	1943-12-09	1943-12-09 00:00:00	1943-12-09	38000177		0	0	7		0	0	0	302052	0	562251	1713671		
21963	1801	40229134	1964-01-31	1964-01-31 00:00:00	1964-02-14	1964-02-14 00:00:00	1964-02-14	38000177		0	0	14		0	0	0	120729	0	1043400	40229134		
12858	1082	19006318	1955-12-18	1955-12-18 00:00:00	1956-01-01	1956-01-01 00:00:00	1956-01-01	38000177		0	0	14		0	0	0	71022	0	105078	19006318		
2807	225	19133905	2013-09-25	2013-09-25 00:00:00	2013-10-02	2013-10-02 00:00:00	2013-10-02	38000177		0	0	7		0	0	0	15199	0	834102	19133905		
73882	1612	40213296	2005-08-10	2005-08-10 00:00:00	2005-08-10	2005-08-10 00:00:00	2005-08-10	581452		0	0	0		0	0	0	108411	0	52	40213296		
48901	4055	19059056	1970-07-29	1970-07-29 00:00:00	1970-08-12	1970-08-12 00:00:00	1970-08-12	38000177		0	0	14		0	0	0	269530	0	243670	19059056		
26190	571	40213296	1996-09-09	1996-09-09 00:00:00	1996-09-09	1996-09-09 00:00:00	1996-09-09	581452		0	0	0		0	0	0	37819	0	52	40213296		
13212	1108	40236824	2011-10-07	2011-10-07 00:00:00	2011-10-14	2011-10-14 00:00:00	2011-10-14	38000177		0	0	7		0	0	0	72970	0	1094107	40236824		
42936	3559	1127433	1995-09-18	1995-09-18 00:00:00	1995-11-17	1995-11-17 00:00:00	1995-11-17	38000177		0	0	60		0	0	0	236261	0	313782	1127433		
60042	4990	19059056	1967-03-29	1967-03-29 00:00:00	1967-06-27	1967-06-27 00:00:00	1967-06-27	38000177		0	0	90		0	0	0	331968	0	243670	19059056		
89509	1962	40213306	1986-06-11	1986-06-11 00:00:00	1986-06-11	1986-06-11 00:00:00	1986-06-11	581452		0	0	0		0	0	0	130520	0	43	40213306		
53815	4473	1713671	1977-04-29	1977-04-29 00:00:00	1977-05-20	1977-05-20 00:00:00	1977-05-20	38000177		0	0	21		0	0	0	297609	0	562251	1713671		
61914	5150	1127433	1970-11-01	1970-11-01 00:00:00	1970-11-15	1970-11-15 00:00:00	1970-11-15	38000177		0	0	14		0	0	0	342335	0	313782	1127433		
2832	63	40213296	1998-05-21	1998-05-21 00:00:00	1998-05-21	1998-05-21 00:00:00	1998-05-21	581452		0	0	0		0	0	0	4278	0	52	40213296		
38356	3172	19074843	1983-04-19	1983-04-19 00:00:00	1983-05-03	1983-05-03 00:00:00	1983-05-03	38000177		0	0	14		0	0	0	210863	0	309045	19074843		
104878	2300	40213198	2015-03-19	2015-03-19 00:00:00	2015-03-19	2015-03-19 00:00:00	2015-03-19	581452		0	0	0		0	0	0	153154	0	133	40213198		
64230	5331	1713671	1993-07-14	1993-07-14 00:00:00	1993-07-28	1993-07-28 00:00:00	1993-07-28	38000177		0	0	14		0	0	0	354959	0	562251	1713671		
281	19	40163554	2011-04-10	2011-04-10 00:00:00	2011-04-10	2011-04-10 00:00:00	\N	38000177		0	0	0		0	0	0	1471	0	855332	40163554		
48227	3997	1127433	1987-02-16	1987-02-16 00:00:00	1987-03-02	1987-03-02 00:00:00	1987-03-02	38000177		0	0	14		0	0	0	265768	0	313782	1127433		
27382	2266	19078461	2015-07-07	2015-07-07 00:00:00	2015-08-11	2015-08-11 00:00:00	2015-08-11	38000177		0	0	35		0	0	0	150639	0	310965	19078461		
3089	250	19128022	1992-01-20	1992-01-20 00:00:00	1993-01-14	1993-01-14 00:00:00	1993-01-14	38000177		0	0	360		0	0	0	16818	0	749785	19128022		
18275	1513	1127433	1968-07-26	1968-07-26 00:00:00	1968-08-09	1968-08-09 00:00:00	1968-08-09	38000177		0	0	14		0	0	0	101114	0	313782	1127433		
13643	1143	1127078	1976-01-02	1976-01-02 00:00:00	1976-03-02	1976-03-02 00:00:00	1976-03-02	38000177		0	0	60		0	0	0	75454	0	282464	1127078		
27484	2277	1127078	1977-04-05	1977-04-05 00:00:00	1977-05-05	1977-05-05 00:00:00	1977-05-05	38000177		0	0	30		0	0	0	151384	0	282464	1127078		
22823	495	40213260	2019-05-25	2019-05-25 00:00:00	2019-05-25	2019-05-25 00:00:00	2019-05-25	581452		0	0	0		0	0	0	33044	0	121	40213260		
45757	3788	40236446	1975-08-09	1975-08-09 00:00:00	1982-08-17	1982-08-17 00:00:00	1982-08-17	38000177		0	0	2565		0	0	0	251817	0	1091392	40236446		
48626	4027	19128065	1988-01-02	1988-01-02 00:00:00	1988-12-27	1988-12-27 00:00:00	1988-12-27	38000177		0	0	360		0	0	0	267804	0	749882	19128065		
165249	3633	40213314	1977-05-08	1977-05-08 00:00:00	1977-05-08	1977-05-08 00:00:00	1977-05-08	581452		0	0	0		0	0	0	241669	0	49	40213314		
27190	2242	40231925	1942-05-25	1942-05-25 00:00:00	1942-05-25	1942-05-25 00:00:00	\N	38000177		0	0	0		0	0	0	149229	0	1049221	40231925		
56408	4680	19059056	1985-06-24	1985-06-24 00:00:00	1985-08-23	1985-08-23 00:00:00	1985-08-23	38000177		0	0	60		0	0	0	311949	0	243670	19059056		
129441	2846	40213227	2014-07-06	2014-07-06 00:00:00	2014-07-06	2014-07-06 00:00:00	2014-07-06	581452		0	0	0		0	0	0	189051	0	113	40213227		
10152	851	1118084	2016-03-09	2016-03-09 00:00:00	2016-03-09	2016-03-09 00:00:00	\N	38000177		0	0	0		0	0	0	56297	0	00025152531	44923712		
6636	144	40213314	1977-05-27	1977-05-27 00:00:00	1977-05-27	1977-05-27 00:00:00	1977-05-27	581452		0	0	0		0	0	0	9668	0	49	40213314		
41288	3422	1713671	1995-06-04	1995-06-04 00:00:00	1995-06-18	1995-06-18 00:00:00	1995-06-18	38000177		0	0	14		0	0	0	226957	0	562251	1713671		
1985	158	1127433	1953-08-31	1953-08-31 00:00:00	1953-09-14	1953-09-14 00:00:00	1953-09-14	38000177		0	0	14		0	0	0	10844	0	313782	1127433		
24832	2041	46233988	1968-02-18	1968-02-18 00:00:00	1968-03-03	1968-03-03 00:00:00	1968-03-03	38000177		0	0	14		0	0	0	135845	0	1652673	46233988		
48440	4014	19075001	1993-07-04	1993-07-04 00:00:00	1993-07-18	1993-07-18 00:00:00	1993-07-18	38000177		0	0	14		0	0	0	266752	0	309097	19075001		
34211	2827	19133873	1934-10-14	1934-10-14 00:00:00	1934-10-21	1934-10-21 00:00:00	1934-10-21	38000177		0	0	7		0	0	0	187468	0	834061	19133873		
69918	1528	40213160	1963-12-20	1963-12-20 00:00:00	1963-12-20	1963-12-20 00:00:00	1963-12-20	581452		0	0	0		0	0	0	102225	0	10	40213160		
34323	2835	920300	1957-12-07	1957-12-07 00:00:00	1957-12-14	1957-12-14 00:00:00	1957-12-14	38000177		0	0	7		0	0	0	188352	0	311989	920300		
35523	2927	40229134	1990-12-31	1990-12-31 00:00:00	1991-01-14	1991-01-14 00:00:00	1991-01-14	38000177		0	0	14		0	0	0	195203	0	1043400	40229134		
36634	3023	920300	2008-11-29	2008-11-29 00:00:00	2008-12-06	2008-12-06 00:00:00	2008-12-06	38000177		0	0	7		0	0	0	201536	0	311989	920300		
20249	1661	1127433	1994-02-11	1994-02-11 00:00:00	1994-02-25	1994-02-25 00:00:00	1994-02-25	38000177		0	0	14		0	0	0	111637	0	313782	1127433		
28636	2359	1127433	1998-03-23	1998-03-23 00:00:00	1998-04-22	1998-04-22 00:00:00	1998-04-22	38000177		0	0	30		0	0	0	157239	0	313782	1127433		
28693	2366	1115171	2001-05-21	2001-05-21 00:00:00	2001-06-11	2001-06-11 00:00:00	2001-06-11	38000177		0	0	21		0	0	0	157518	0	849574	1115171		
1741	140	1127433	2015-11-09	2015-11-09 00:00:00	2015-11-23	2015-11-23 00:00:00	2015-11-23	38000177		0	0	14		0	0	0	9349	0	313782	1127433		
1459	116	19059056	1944-10-08	1944-10-08 00:00:00	1944-12-07	1944-12-07 00:00:00	1944-12-07	38000177		0	0	60		0	0	0	7651	0	243670	19059056		
44412	3676	40229134	1978-05-22	1978-05-22 00:00:00	1978-05-29	1978-05-29 00:00:00	1978-05-29	38000177		0	0	7		0	0	0	244507	0	1043400	40229134		
41448	3436	920300	1997-12-12	1997-12-12 00:00:00	1997-12-19	1997-12-19 00:00:00	1997-12-19	38000177		0	0	7		0	0	0	227881	0	311989	920300		
63078	1379	40213260	2011-03-12	2011-03-12 00:00:00	2011-03-12	2011-03-12 00:00:00	2011-03-12	581452		0	0	0		0	0	0	91472	0	121	40213260		
33080	723	40213227	2001-11-15	2001-11-15 00:00:00	2001-11-15	2001-11-15 00:00:00	2001-11-15	581452		0	0	0		0	0	0	47858	0	113	40213227		
37973	828	40213160	1955-09-20	1955-09-20 00:00:00	1955-09-20	1955-09-20 00:00:00	1955-09-20	581452		0	0	0		0	0	0	54848	0	10	40213160		
45581	994	40213227	2010-07-28	2010-07-28 00:00:00	2010-07-28	2010-07-28 00:00:00	2010-07-28	581452		0	0	0		0	0	0	65925	0	113	40213227		
50886	4227	40243436	2003-04-06	2003-04-06 00:00:00	2003-04-06	2003-04-06 00:00:00	2003-04-06	38000177		0	0	0		0	0	0	280798	0	1190795	40243436		
56928	1246	40213201	2004-09-17	2004-09-17 00:00:00	2004-09-17	2004-09-17 00:00:00	2004-09-17	581452		0	0	0		0	0	0	82129	0	33	40213201		
22839	1878	1127433	1990-03-27	1990-03-27 00:00:00	1990-04-04	1990-04-04 00:00:00	1990-04-04	38000177		0	0	8		0	0	0	125326	0	313782	1127433		
29310	2425	19128065	1979-01-19	1979-01-19 00:00:00	1980-01-14	1980-01-14 00:00:00	1980-01-14	38000177		0	0	360		0	0	0	160877	0	749882	19128065		
29363	2431	19128065	1986-07-12	1986-07-12 00:00:00	1987-07-07	1987-07-07 00:00:00	1987-07-07	38000177		0	0	360		0	0	0	161191	0	749882	19128065		
33698	2788	1127078	1980-01-08	1980-01-08 00:00:00	1980-02-12	1980-02-12 00:00:00	1980-02-12	38000177		0	0	35		0	0	0	184723	0	282464	1127078		
39876	3298	19133873	1984-04-22	1984-04-22 00:00:00	1984-04-30	1984-04-30 00:00:00	1984-04-30	38000177		0	0	8		0	0	0	219126	0	834061	19133873		
10399	222	40213227	2012-11-16	2012-11-16 00:00:00	2012-11-16	2012-11-16 00:00:00	2012-11-16	581452		0	0	0		0	0	0	14970	0	113	40213227		
36464	3007	46233988	1967-01-20	1967-01-20 00:00:00	1967-02-03	1967-02-03 00:00:00	1967-02-03	38000177		0	0	14		0	0	0	200579	0	1652673	46233988		
11363	947	1124300	2000-06-08	2000-06-08 00:00:00	2000-06-08	2000-06-08 00:00:00	\N	38000177		0	0	0		0	0	0	62858	0	00781178901	45011828		
25445	2090	920300	1994-07-01	1994-07-01 00:00:00	1994-07-08	1994-07-08 00:00:00	1994-07-08	38000177		0	0	7		0	0	0	139376	0	311989	920300		
54579	4534	19059056	1946-10-28	1946-10-28 00:00:00	1946-11-11	1946-11-11 00:00:00	1946-11-11	38000177		0	0	14		0	0	0	302026	0	243670	19059056		
21964	1801	1115171	2003-09-28	2003-09-28 00:00:00	2003-10-19	2003-10-19 00:00:00	2003-10-19	38000177		0	0	21		0	0	0	120754	0	849574	1115171		
12859	1082	19059056	1955-12-18	1955-12-18 00:00:00	1956-01-01	1956-01-01 00:00:00	1956-01-01	38000177		0	0	14		0	0	0	71022	0	243670	19059056		
2808	225	19112599	1969-01-24	1969-01-24 00:00:00	1969-01-24	1969-01-24 00:00:00	\N	38000177		0	0	0		0	0	0	15175	0	477045	19112599		
73890	1612	40213227	2014-08-06	2014-08-06 00:00:00	2014-08-06	2014-08-06 00:00:00	2014-08-06	581452		0	0	0		0	0	0	108432	0	113	40213227		
48902	4055	1115171	1997-06-28	1997-06-28 00:00:00	1997-07-12	1997-07-12 00:00:00	1997-07-12	38000177		0	0	14		0	0	0	269536	0	849574	1115171		
26197	571	40213160	1959-06-22	1959-06-22 00:00:00	1959-06-22	1959-06-22 00:00:00	1959-06-22	581452		0	0	0		0	0	0	37800	0	10	40213160		
13213	1108	40229134	1981-02-19	1981-02-19 00:00:00	1981-02-26	1981-02-26 00:00:00	1981-02-26	38000177		0	0	7		0	0	0	72938	0	1043400	40229134		
42937	3560	1127433	1991-08-22	1991-08-22 00:00:00	1991-08-29	1991-08-29 00:00:00	1991-08-29	38000177		0	0	7		0	0	0	236357	0	313782	1127433		
60043	4990	1118084	2002-08-02	2002-08-02 00:00:00	2002-08-02	2002-08-02 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00025152531	44923712		
30959	675	40213227	2009-07-14	2009-07-14 00:00:00	2009-07-14	2009-07-14 00:00:00	2009-07-14	581452		0	0	0		0	0	0	44660	0	113	40213227		
53816	4473	19078461	1997-08-07	1997-08-07 00:00:00	1997-09-04	1997-09-04 00:00:00	1997-09-04	38000177		0	0	28		0	0	0	297583	0	310965	19078461		
61915	5150	1127433	1979-10-03	1979-10-03 00:00:00	1979-10-17	1979-10-17 00:00:00	1979-10-17	38000177		0	0	14		0	0	0	342344	0	313782	1127433		
2835	63	40213160	1956-08-23	1956-08-23 00:00:00	1956-08-23	1956-08-23 00:00:00	1956-08-23	581452		0	0	0		0	0	0	4261	0	10	40213160		
38357	3172	1127078	1983-04-19	1983-04-19 00:00:00	1983-05-03	1983-05-03 00:00:00	1983-05-03	38000177		0	0	14		0	0	0	210863	0	282464	1127078		
104883	2300	40213227	2002-01-03	2002-01-03 00:00:00	2002-01-03	2002-01-03 00:00:00	2002-01-03	581452		0	0	0		0	0	0	153150	0	113	40213227		
64231	5331	1713671	2001-07-21	2001-07-21 00:00:00	2001-08-11	2001-08-11 00:00:00	2001-08-11	38000177		0	0	21		0	0	0	354926	0	562251	1713671		
282	19	1713671	1970-03-31	1970-03-31 00:00:00	1970-04-21	1970-04-21 00:00:00	1970-04-21	38000177		0	0	21		0	0	0	1509	0	562251	1713671		
48228	3997	1127433	1979-06-07	1979-06-07 00:00:00	1979-06-21	1979-06-21 00:00:00	1979-06-21	38000177		0	0	14		0	0	0	265701	0	313782	1127433		
27383	2266	1127433	1985-10-17	1985-10-17 00:00:00	1985-10-24	1985-10-24 00:00:00	1985-10-24	38000177		0	0	7		0	0	0	150671	0	313782	1127433		
3090	250	19059056	1975-12-05	1975-12-05 00:00:00	1975-12-19	1975-12-19 00:00:00	1975-12-19	38000177		0	0	14		0	0	0	16784	0	243670	19059056		
18276	1513	40236824	2007-06-10	2007-06-10 00:00:00	2007-06-17	2007-06-17 00:00:00	2007-06-17	38000177		0	0	7		0	0	0	101107	0	1094107	40236824		
13644	1143	1127078	1979-11-12	1979-11-12 00:00:00	1979-11-26	1979-11-26 00:00:00	1979-11-26	38000177		0	0	14		0	0	0	75455	0	282464	1127078		
27485	2277	19059056	1970-10-15	1970-10-15 00:00:00	1970-10-29	1970-10-29 00:00:00	1970-10-29	38000177		0	0	14		0	0	0	151355	0	243670	19059056		
22825	495	40213227	2019-05-25	2019-05-25 00:00:00	2019-05-25	2019-05-25 00:00:00	2019-05-25	581452		0	0	0		0	0	0	33044	0	113	40213227		
45758	3788	1124300	2006-12-14	2006-12-14 00:00:00	2006-12-14	2006-12-14 00:00:00	\N	38000177		0	0	0		0	0	0	251845	0	00781178901	45011828		
48627	4027	40229134	1974-10-04	1974-10-04 00:00:00	1974-10-11	1974-10-11 00:00:00	1974-10-11	38000177		0	0	7		0	0	0	267866	0	1043400	40229134		
165252	3633	40213160	1972-11-05	1972-11-05 00:00:00	1972-11-05	1972-11-05 00:00:00	1972-11-05	581452		0	0	0		0	0	0	241665	0	10	40213160		
27191	2242	19059056	1942-05-25	1942-05-25 00:00:00	1942-08-23	1942-08-23 00:00:00	1942-08-23	38000177		0	0	90		0	0	0	149229	0	243670	19059056		
56409	4680	19078461	1976-01-29	1976-01-29 00:00:00	1976-02-12	1976-02-12 00:00:00	1976-02-12	38000177		0	0	14		0	0	0	311947	0	310965	19078461		
129443	2846	40213160	1973-03-04	1973-03-04 00:00:00	1973-03-04	1973-03-04 00:00:00	1973-03-04	581452		0	0	0		0	0	0	189025	0	10	40213160		
10153	851	1713671	2015-12-24	2015-12-24 00:00:00	2016-01-07	2016-01-07 00:00:00	2016-01-07	38000177		0	0	14		0	0	0	56297	0	562251	1713671		
6639	144	40213160	1979-11-30	1979-11-30 00:00:00	1979-11-30	1979-11-30 00:00:00	1979-11-30	581452		0	0	0		0	0	0	9648	0	10	40213160		
41289	3423	1713671	1984-06-15	1984-06-15 00:00:00	1984-06-22	1984-06-22 00:00:00	1984-06-22	38000177		0	0	7		0	0	0	227034	0	562251	1713671		
1986	158	1127433	2014-03-29	2014-03-29 00:00:00	2014-04-05	2014-04-05 00:00:00	2014-04-05	38000177		0	0	7		0	0	0	10846	0	313782	1127433		
24833	2041	19059056	1966-01-15	1966-01-15 00:00:00	1966-02-05	1966-02-05 00:00:00	1966-02-05	38000177		0	0	21		0	0	0	135852	0	243670	19059056		
48441	4014	19059056	1993-07-04	1993-07-04 00:00:00	1993-07-18	1993-07-18 00:00:00	1993-07-18	38000177		0	0	14		0	0	0	266752	0	243670	19059056		
34212	2827	19078461	1999-06-24	1999-06-24 00:00:00	1999-07-29	1999-07-29 00:00:00	1999-07-29	38000177		0	0	35		0	0	0	187514	0	310965	19078461		
69920	1528	40213160	1959-04-17	1959-04-17 00:00:00	1959-04-17	1959-04-17 00:00:00	1959-04-17	581452		0	0	0		0	0	0	102249	0	10	40213160		
34324	2835	19059056	1913-11-07	1913-11-07 00:00:00	1913-12-07	1913-12-07 00:00:00	1913-12-07	38000177		0	0	30		0	0	0	188299	0	243670	19059056		
35524	2927	1127433	1983-03-09	1983-03-09 00:00:00	1983-06-07	1983-06-07 00:00:00	1983-06-07	38000177		0	0	90		0	0	0	195295	0	313782	1127433		
36635	3023	19073183	1985-11-02	1985-11-02 00:00:00	1985-11-16	1985-11-16 00:00:00	1985-11-16	38000177		0	0	14		0	0	0	201537	0	308182	19073183		
20250	1661	40229134	2003-08-16	2003-08-16 00:00:00	2003-08-30	2003-08-30 00:00:00	2003-08-30	38000177		0	0	14		0	0	0	111638	0	1043400	40229134		
28637	2359	40162522	1998-03-23	1998-03-23 00:00:00	1998-03-23	1998-03-23 00:00:00	\N	38000177		0	0	0		0	0	0	157239	0	857005	40162522		
28694	2366	1127433	2003-08-14	2003-08-14 00:00:00	2003-08-21	2003-08-21 00:00:00	2003-08-21	38000177		0	0	7		0	0	0	157521	0	313782	1127433		
1742	140	1127078	1976-05-20	1976-05-20 00:00:00	1976-06-17	1976-06-17 00:00:00	1976-06-17	38000177		0	0	28		0	0	0	9415	0	282464	1127078		
1460	116	1713671	1943-10-30	1943-10-30 00:00:00	1943-11-20	1943-11-20 00:00:00	1943-11-20	38000177		0	0	21		0	0	0	7664	0	562251	1713671		
44413	3676	40243436	1997-02-13	1997-02-13 00:00:00	1997-02-13	1997-02-13 00:00:00	1997-02-13	38000177		0	0	0		0	0	0	244486	0	1190795	40243436		
41449	3436	40236824	1997-12-12	1997-12-12 00:00:00	1997-12-19	1997-12-19 00:00:00	1997-12-19	38000177		0	0	7		0	0	0	227881	0	1094107	40236824		
63081	1379	40213227	1994-04-09	1994-04-09 00:00:00	1994-04-09	1994-04-09 00:00:00	1994-04-09	581452		0	0	0		0	0	0	91482	0	113	40213227		
33081	723	40213296	2001-11-15	2001-11-15 00:00:00	2001-11-15	2001-11-15 00:00:00	2001-11-15	581452		0	0	0		0	0	0	47858	0	52	40213296		
37991	829	40213160	1978-02-12	1978-02-12 00:00:00	1978-02-12	1978-02-12 00:00:00	1978-02-12	581452		0	0	0		0	0	0	54901	0	10	40213160		
45583	994	40213260	2010-07-28	2010-07-28 00:00:00	2010-07-28	2010-07-28 00:00:00	2010-07-28	581452		0	0	0		0	0	0	65925	0	121	40213260		
50887	4227	1127433	1992-02-27	1992-02-27 00:00:00	1992-03-05	1992-03-05 00:00:00	1992-03-05	38000177		0	0	7		0	0	0	280783	0	313782	1127433		
56931	1246	40213227	1999-08-20	1999-08-20 00:00:00	1999-08-20	1999-08-20 00:00:00	1999-08-20	581452		0	0	0		0	0	0	82084	0	113	40213227		
22840	1878	19074843	1980-05-01	1980-05-01 00:00:00	1980-05-15	1980-05-15 00:00:00	1980-05-15	38000177		0	0	14		0	0	0	125337	0	309045	19074843		
29312	2427	1127433	1998-08-29	1998-08-29 00:00:00	1998-09-12	1998-09-12 00:00:00	1998-09-12	38000177		0	0	14		0	0	0	161038	0	313782	1127433		
29364	2431	1713671	2017-12-14	2017-12-14 00:00:00	2018-01-04	2018-01-04 00:00:00	2018-01-04	38000177		0	0	21		0	0	0	161205	0	562251	1713671		
44157	3655	1332419	2006-08-31	2006-08-31 00:00:00	2006-08-31	2006-08-31 00:00:00	\N	38000177		0	0	0		0	0	0	243290	0	197361	1332419		
39877	3298	1127078	1975-11-22	1975-11-22 00:00:00	1975-12-06	1975-12-06 00:00:00	1975-12-06	38000177		0	0	14		0	0	0	219164	0	282464	1127078		
10401	222	40213227	2002-09-20	2002-09-20 00:00:00	2002-09-20	2002-09-20 00:00:00	2002-09-20	581452		0	0	0		0	0	0	14929	0	113	40213227		
36465	3007	19133905	2016-12-03	2016-12-03 00:00:00	2016-12-15	2016-12-15 00:00:00	2016-12-15	38000177		0	0	12		0	0	0	200639	0	834102	19133905		
11364	947	1127078	1968-07-21	1968-07-21 00:00:00	1968-08-04	1968-08-04 00:00:00	1968-08-04	38000177		0	0	14		0	0	0	62862	0	282464	1127078		
25446	2090	19128065	1989-04-11	1989-04-11 00:00:00	1990-04-06	1990-04-06 00:00:00	1990-04-06	38000177		0	0	360		0	0	0	139393	0	749882	19128065		
54580	4534	1127433	1973-02-22	1973-02-22 00:00:00	1973-03-08	1973-03-08 00:00:00	1973-03-08	38000177		0	0	14		0	0	0	302085	0	313782	1127433		
21965	1801	19059056	1963-12-01	1963-12-01 00:00:00	1963-12-22	1963-12-22 00:00:00	1963-12-22	38000177		0	0	21		0	0	0	120749	0	243670	19059056		
12860	1082	40229134	1961-09-04	1961-09-04 00:00:00	1961-09-11	1961-09-11 00:00:00	1961-09-11	38000177		0	0	7		0	0	0	70939	0	1043400	40229134		
2817	227	1118084	2009-11-01	2009-11-01 00:00:00	2009-11-01	2009-11-01 00:00:00	\N	38000177		0	0	0		0	0	0	15346	0	00025152531	44923712		
73891	1612	40213260	2014-08-06	2014-08-06 00:00:00	2014-08-06	2014-08-06 00:00:00	2014-08-06	581452		0	0	0		0	0	0	108432	0	121	40213260		
2635	211	1118084	2009-02-13	2009-02-13 00:00:00	2009-02-13	2009-02-13 00:00:00	\N	38000177		0	0	0		0	0	0	14402	0	00025152531	44923712		
26200	571	40213227	2006-08-21	2006-08-21 00:00:00	2006-08-21	2006-08-21 00:00:00	2006-08-21	581452		0	0	0		0	0	0	37785	0	113	40213227		
13214	1108	920300	2013-01-16	2013-01-16 00:00:00	2013-01-23	2013-01-23 00:00:00	2013-01-23	38000177		0	0	7		0	0	0	72941	0	311989	920300		
42938	3560	19133905	1994-05-22	1994-05-22 00:00:00	1994-06-04	1994-06-04 00:00:00	1994-06-04	38000177		0	0	13		0	0	0	236370	0	834102	19133905		
60044	4990	40236824	1986-05-26	1986-05-26 00:00:00	1986-06-02	1986-06-02 00:00:00	1986-06-02	38000177		0	0	7		0	0	0	331962	0	1094107	40236824		
43300	3589	19073183	1983-02-17	1983-02-17 00:00:00	1983-03-03	1983-03-03 00:00:00	1983-03-03	38000177		0	0	14		0	0	0	238410	0	308182	19073183		
53817	4474	19078461	2017-10-17	2017-10-17 00:00:00	2017-11-21	2017-11-21 00:00:00	2017-11-21	38000177		0	0	35		0	0	0	297693	0	310965	19078461		
61916	5150	1127433	1973-12-13	1973-12-13 00:00:00	1973-12-20	1973-12-20 00:00:00	1973-12-20	38000177		0	0	7		0	0	0	342379	0	313782	1127433		
2839	63	40213296	1996-05-16	1996-05-16 00:00:00	1996-05-16	1996-05-16 00:00:00	1996-05-16	581452		0	0	0		0	0	0	4251	0	52	40213296		
38358	3172	1115171	2004-09-16	2004-09-16 00:00:00	2004-11-15	2004-11-15 00:00:00	2004-11-15	38000177		0	0	60		0	0	0	210822	0	849574	1115171		
57911	1267	40213160	1955-10-13	1955-10-13 00:00:00	1955-10-13	1955-10-13 00:00:00	1955-10-13	581452		0	0	0		0	0	0	83543	0	10	40213160		
64233	5331	19128065	1981-07-06	1981-07-06 00:00:00	1982-07-01	1982-07-01 00:00:00	1982-07-01	38000177		0	0	360		0	0	0	354921	0	749882	19128065		
283	19	1127433	1977-09-01	1977-09-01 00:00:00	1977-09-08	1977-09-08 00:00:00	1977-09-08	38000177		0	0	7		0	0	0	1510	0	313782	1127433		
48229	3997	1713671	1992-08-30	1992-08-30 00:00:00	1992-09-13	1992-09-13 00:00:00	1992-09-13	38000177		0	0	14		0	0	0	265739	0	562251	1713671		
27384	2266	1127433	1984-03-18	1984-03-18 00:00:00	1984-04-01	1984-04-01 00:00:00	1984-04-01	38000177		0	0	14		0	0	0	150623	0	313782	1127433		
3091	250	46233988	1975-12-05	1975-12-05 00:00:00	1975-12-19	1975-12-19 00:00:00	1975-12-19	38000177		0	0	14		0	0	0	16784	0	1652673	46233988		
18277	1513	920300	2007-06-10	2007-06-10 00:00:00	2007-06-17	2007-06-17 00:00:00	2007-06-17	38000177		0	0	7		0	0	0	101107	0	311989	920300		
13645	1143	19129655	1973-09-14	1973-09-14 00:00:00	1973-09-28	1973-09-28 00:00:00	1973-09-28	38000177		0	0	14		0	0	0	75450	0	789980	19129655		
27486	2277	19129655	1970-10-15	1970-10-15 00:00:00	1970-10-29	1970-10-29 00:00:00	1970-10-29	38000177		0	0	14		0	0	0	151355	0	789980	19129655		
22829	495	40213296	2011-04-02	2011-04-02 00:00:00	2011-04-02	2011-04-02 00:00:00	2011-04-02	581452		0	0	0		0	0	0	33043	0	52	40213296		
45759	3788	1127433	2005-07-12	2005-07-12 00:00:00	2005-08-02	2005-08-02 00:00:00	2005-08-02	38000177		0	0	21		0	0	0	251824	0	313782	1127433		
48628	4027	19128065	1997-11-10	1997-11-10 00:00:00	1998-11-05	1998-11-05 00:00:00	1998-11-05	38000177		0	0	360		0	0	0	267879	0	749882	19128065		
165262	3633	40213227	2003-08-17	2003-08-17 00:00:00	2003-08-17	2003-08-17 00:00:00	2003-08-17	581452		0	0	0		0	0	0	241645	0	113	40213227		
27192	2243	1127433	1977-08-22	1977-08-22 00:00:00	1977-09-05	1977-09-05 00:00:00	1977-09-05	38000177		0	0	14		0	0	0	149327	0	313782	1127433		
56410	4680	1127433	1979-10-24	1979-10-24 00:00:00	1980-01-22	1980-01-22 00:00:00	1980-01-22	38000177		0	0	90		0	0	0	311948	0	313782	1127433		
129450	2846	40213296	2012-07-01	2012-07-01 00:00:00	2012-07-01	2012-07-01 00:00:00	2012-07-01	581452		0	0	0		0	0	0	189004	0	52	40213296		
10154	851	19133873	1989-08-22	1989-08-22 00:00:00	1989-09-04	1989-09-04 00:00:00	1989-09-04	38000177		0	0	13		0	0	0	56320	0	834061	19133873		
6646	145	40213201	2015-03-03	2015-03-03 00:00:00	2015-03-03	2015-03-03 00:00:00	2015-03-03	581452		0	0	0		0	0	0	9711	0	33	40213201		
41290	3423	19078461	1989-12-02	1989-12-02 00:00:00	1989-12-16	1989-12-16 00:00:00	1989-12-16	38000177		0	0	14		0	0	0	227094	0	310965	19078461		
1987	159	19133873	1968-04-20	1968-04-20 00:00:00	1968-04-30	1968-04-30 00:00:00	1968-04-30	38000177		0	0	10		0	0	0	10926	0	834061	19133873		
24834	2041	19007333	2008-02-14	2008-02-14 00:00:00	2011-05-29	2011-05-29 00:00:00	2011-05-29	38000177		0	0	1200		0	0	0	135860	0	105586	19007333		
48442	4014	1713671	1999-11-26	1999-11-26 00:00:00	1999-12-03	1999-12-03 00:00:00	1999-12-03	38000177		0	0	7		0	0	0	266743	0	562251	1713671		
34213	2827	19078461	1984-04-08	1984-04-08 00:00:00	1984-05-13	1984-05-13 00:00:00	1984-05-13	38000177		0	0	35		0	0	0	187512	0	310965	19078461		
69923	1528	40213160	1959-09-18	1959-09-18 00:00:00	1959-09-18	1959-09-18 00:00:00	1959-09-18	581452		0	0	0		0	0	0	102250	0	10	40213160		
34325	2835	19073188	1983-01-28	1983-01-28 00:00:00	1983-02-11	1983-02-11 00:00:00	1983-02-11	38000177		0	0	14		0	0	0	188342	0	308192	19073188		
45983	3807	40236446	1956-09-18	1956-09-18 00:00:00	1964-09-26	1964-09-26 00:00:00	1964-09-26	38000177		0	0	2930		0	0	0	252969	0	1091392	40236446		
36636	3023	1127078	1985-11-02	1985-11-02 00:00:00	1985-11-16	1985-11-16 00:00:00	1985-11-16	38000177		0	0	14		0	0	0	201537	0	282464	1127078		
20251	1661	19059056	1963-04-19	1963-04-19 00:00:00	1963-05-24	1963-05-24 00:00:00	1963-05-24	38000177		0	0	35		0	0	0	111650	0	243670	19059056		
28638	2359	19133905	1945-10-12	1945-10-12 00:00:00	1945-10-24	1945-10-24 00:00:00	1945-10-24	38000177		0	0	12		0	0	0	157176	0	834102	19133905		
28695	2366	1127433	2008-06-06	2008-06-06 00:00:00	2008-06-20	2008-06-20 00:00:00	2008-06-20	38000177		0	0	14		0	0	0	157522	0	313782	1127433		
1743	140	19128065	1994-04-05	1994-04-05 00:00:00	1995-03-31	1995-03-31 00:00:00	1995-03-31	38000177		0	0	360		0	0	0	9410	0	749882	19128065		
1461	116	40223768	2000-12-03	2000-12-03 00:00:00	2000-12-03	2000-12-03 00:00:00	\N	38000177		0	0	0		0	0	0	7736	0	997223	40223768		
44414	3676	1310034	1997-02-13	1997-02-13 00:00:00	1997-02-13	1997-02-13 00:00:00	1997-02-13	38000177		0	0	0		0	0	0	244486	0	834357	1310034		
41450	3436	1127433	1992-07-18	1992-07-18 00:00:00	1992-07-25	1992-07-25 00:00:00	1992-07-25	38000177		0	0	7		0	0	0	227880	0	313782	1127433		
111167	2442	40213160	1971-11-29	1971-11-29 00:00:00	1971-11-29	1971-11-29 00:00:00	1971-11-29	581452		0	0	0		0	0	0	161971	0	10	40213160		
33084	723	40213306	1983-01-13	1983-01-13 00:00:00	1983-01-13	1983-01-13 00:00:00	1983-01-13	581452		0	0	0		0	0	0	47870	0	43	40213306		
37998	829	40213227	1996-06-09	1996-06-09 00:00:00	1996-06-09	1996-06-09 00:00:00	1996-06-09	581452		0	0	0		0	0	0	54892	0	113	40213227		
45588	994	40213227	2001-08-01	2001-08-01 00:00:00	2001-08-01	2001-08-01 00:00:00	2001-08-01	581452		0	0	0		0	0	0	65879	0	113	40213227		
50888	4227	1127078	1957-08-31	1957-08-31 00:00:00	1957-09-14	1957-09-14 00:00:00	1957-09-14	38000177		0	0	14		0	0	0	280856	0	282464	1127078		
56941	1246	40213227	1992-01-03	1992-01-03 00:00:00	1992-01-03	1992-01-03 00:00:00	1992-01-03	581452		0	0	0		0	0	0	82082	0	113	40213227		
22841	1878	1127078	1980-05-01	1980-05-01 00:00:00	1980-05-15	1980-05-15 00:00:00	1980-05-15	38000177		0	0	14		0	0	0	125337	0	282464	1127078		
29313	2427	1127433	1972-05-11	1972-05-11 00:00:00	1972-05-18	1972-05-18 00:00:00	1972-05-18	38000177		0	0	7		0	0	0	161035	0	313782	1127433		
29365	2431	19078461	1995-05-16	1995-05-16 00:00:00	1995-05-30	1995-05-30 00:00:00	1995-05-30	38000177		0	0	14		0	0	0	161244	0	310965	19078461		
44158	3655	19075601	2006-08-31	2006-08-31 00:00:00	2010-12-16	2010-12-16 00:00:00	2010-12-16	38000177		0	0	1568		0	0	0	243290	0	309362	19075601		
39878	3298	19129655	1975-11-22	1975-11-22 00:00:00	1975-12-06	1975-12-06 00:00:00	1975-12-06	38000177		0	0	14		0	0	0	219164	0	789980	19129655		
10403	222	40213160	1956-08-24	1956-08-24 00:00:00	1956-08-24	1956-08-24 00:00:00	1956-08-24	581452		0	0	0		0	0	0	14942	0	10	40213160		
36466	3007	1127433	1999-06-20	1999-06-20 00:00:00	1999-06-27	1999-06-27 00:00:00	1999-06-27	38000177		0	0	7		0	0	0	200578	0	313782	1127433		
11365	947	19133873	1976-06-27	1976-06-27 00:00:00	1976-07-10	1976-07-10 00:00:00	1976-07-10	38000177		0	0	13		0	0	0	62900	0	834061	19133873		
25447	2090	46275916	1974-03-20	1974-03-20 00:00:00	1974-03-20	1974-03-20 00:00:00	1974-03-20	38000177		0	0	0		0	0	0	139372	0	1660014	46275916		
54581	4534	1118084	1985-04-09	1985-04-09 00:00:00	1985-04-09	1985-04-09 00:00:00	\N	38000177		0	0	0		0	0	0	302016	0	00025152531	44923712		
21966	1801	19078461	1996-12-19	1996-12-19 00:00:00	1997-01-02	1997-01-02 00:00:00	1997-01-02	38000177		0	0	14		0	0	0	120753	0	310965	19078461		
12862	1082	40229134	2005-12-20	2005-12-20 00:00:00	2005-12-27	2005-12-27 00:00:00	2005-12-27	38000177		0	0	7		0	0	0	70966	0	1043400	40229134		
2818	227	1713671	1989-09-27	1989-09-27 00:00:00	1989-10-11	1989-10-11 00:00:00	1989-10-11	38000177		0	0	14		0	0	0	15327	0	562251	1713671		
73893	1612	40213296	2003-08-06	2003-08-06 00:00:00	2003-08-06	2003-08-06 00:00:00	2003-08-06	581452		0	0	0		0	0	0	108400	0	52	40213296		
2636	211	1127433	2003-03-07	2003-03-07 00:00:00	2003-03-28	2003-03-28 00:00:00	2003-03-28	38000177		0	0	21		0	0	0	14406	0	313782	1127433		
26201	571	40213260	2006-08-21	2006-08-21 00:00:00	2006-08-21	2006-08-21 00:00:00	2006-08-21	581452		0	0	0		0	0	0	37785	0	121	40213260		
13215	1108	1118084	2013-02-04	2013-02-04 00:00:00	2013-02-04	2013-02-04 00:00:00	\N	38000177		0	0	0		0	0	0	72941	0	00025152531	44923712		
42939	3560	1127433	2012-04-28	2012-04-28 00:00:00	2012-05-12	2012-05-12 00:00:00	2012-05-12	38000177		0	0	14		0	0	0	236372	0	313782	1127433		
60045	4990	920300	1986-05-26	1986-05-26 00:00:00	1986-06-02	1986-06-02 00:00:00	1986-06-02	38000177		0	0	7		0	0	0	331962	0	311989	920300		
43301	3589	1127078	1983-02-17	1983-02-17 00:00:00	1983-03-03	1983-03-03 00:00:00	1983-03-03	38000177		0	0	14		0	0	0	238410	0	282464	1127078		
53818	4474	19059056	1966-11-18	1966-11-18 00:00:00	1966-12-02	1966-12-02 00:00:00	1966-12-02	38000177		0	0	14		0	0	0	297634	0	243670	19059056		
61917	5150	19059056	1947-08-31	1947-08-31 00:00:00	1947-10-05	1947-10-05 00:00:00	1947-10-05	38000177		0	0	35		0	0	0	342333	0	243670	19059056		
2842	63	40213160	1956-03-21	1956-03-21 00:00:00	1956-03-21	1956-03-21 00:00:00	1956-03-21	581452		0	0	0		0	0	0	4260	0	10	40213160		
38359	3172	1713671	2018-09-27	2018-09-27 00:00:00	2018-10-04	2018-10-04 00:00:00	2018-10-04	38000177		0	0	7		0	0	0	210824	0	562251	1713671		
57914	1267	40213198	2018-02-08	2018-02-08 00:00:00	2018-02-08	2018-02-08 00:00:00	2018-02-08	581452		0	0	0		0	0	0	83606	0	133	40213198		
64234	5331	1127433	2017-02-17	2017-02-17 00:00:00	2017-03-24	2017-03-24 00:00:00	2017-03-24	38000177		0	0	35		0	0	0	354940	0	313782	1127433		
236667	5196	40213198	2016-11-18	2016-11-18 00:00:00	2016-11-18	2016-11-18 00:00:00	2016-11-18	581452		0	0	0		0	0	0	345544	0	133	40213198		
48230	3998	1115171	2008-08-02	2008-08-02 00:00:00	2008-09-06	2008-09-06 00:00:00	2008-09-06	38000177		0	0	35		0	0	0	265793	0	849574	1115171		
27385	2266	19074841	1984-03-18	1984-03-18 00:00:00	1984-04-01	1984-04-01 00:00:00	1984-04-01	38000177		0	0	14		0	0	0	150623	0	309043	19074841		
3092	250	1127078	1983-02-17	1983-02-17 00:00:00	1983-03-10	1983-03-10 00:00:00	1983-03-10	38000177		0	0	21		0	0	0	16793	0	282464	1127078		
18278	1513	1127433	1995-12-01	1995-12-01 00:00:00	1995-12-15	1995-12-15 00:00:00	1995-12-15	38000177		0	0	14		0	0	0	101152	0	313782	1127433		
13646	1143	19059056	1973-09-14	1973-09-14 00:00:00	1973-09-28	1973-09-28 00:00:00	1973-09-28	38000177		0	0	14		0	0	0	75450	0	243670	19059056		
27487	2277	19059056	1971-04-07	1971-04-07 00:00:00	1971-07-06	1971-07-06 00:00:00	1971-07-06	38000177		0	0	90		0	0	0	151383	0	243670	19059056		
22831	495	40213227	2011-04-02	2011-04-02 00:00:00	2011-04-02	2011-04-02 00:00:00	2011-04-02	581452		0	0	0		0	0	0	33043	0	113	40213227		
45760	3788	19133873	1965-02-10	1965-02-10 00:00:00	1965-02-21	1965-02-21 00:00:00	1965-02-21	38000177		0	0	11		0	0	0	251840	0	834061	19133873		
48629	4027	19128065	1995-11-21	1995-11-21 00:00:00	1996-11-15	1996-11-15 00:00:00	1996-11-15	38000177		0	0	360		0	0	0	267877	0	749882	19128065		
165269	3633	40213227	2014-03-02	2014-03-02 00:00:00	2014-03-02	2014-03-02 00:00:00	2014-03-02	581452		0	0	0		0	0	0	241687	0	113	40213227		
30450	664	40213227	2003-09-11	2003-09-11 00:00:00	2003-09-11	2003-09-11 00:00:00	2003-09-11	581452		0	0	0		0	0	0	43876	0	113	40213227		
56411	4680	40231925	1979-10-24	1979-10-24 00:00:00	1979-10-24	1979-10-24 00:00:00	\N	38000177		0	0	0		0	0	0	311948	0	1049221	40231925		
129451	2846	40213314	1977-06-05	1977-06-05 00:00:00	1977-06-05	1977-06-05 00:00:00	1977-06-05	581452		0	0	0		0	0	0	189044	0	49	40213314		
10155	851	1127078	1992-10-01	1992-10-01 00:00:00	1992-10-22	1992-10-22 00:00:00	1992-10-22	38000177		0	0	21		0	0	0	56291	0	282464	1127078		
6662	145	40213160	1955-11-22	1955-11-22 00:00:00	1955-11-22	1955-11-22 00:00:00	1955-11-22	581452		0	0	0		0	0	0	9783	0	10	40213160		
41291	3423	1127078	1979-12-20	1979-12-20 00:00:00	1980-01-03	1980-01-03 00:00:00	1980-01-03	38000177		0	0	14		0	0	0	227092	0	282464	1127078		
1988	159	19078461	1997-12-23	1997-12-23 00:00:00	1998-02-28	1998-02-28 00:00:00	1998-02-28	38000177		0	0	67		0	0	0	10922	0	310965	19078461		
24835	2041	19019273	2008-02-14	2008-02-14 00:00:00	2011-05-29	2011-05-29 00:00:00	2011-05-29	38000177		0	0	1200		0	0	0	135860	0	198014	19019273		
48443	4014	1118084	2006-10-02	2006-10-02 00:00:00	2006-10-02	2006-10-02 00:00:00	\N	38000177		0	0	0		0	0	0	266750	0	00025152531	44923712		
34214	2827	19059056	1968-03-19	1968-03-19 00:00:00	1968-04-02	1968-04-02 00:00:00	1968-04-02	38000177		0	0	14		0	0	0	187511	0	243670	19059056		
69928	1528	40213260	2009-01-09	2009-01-09 00:00:00	2009-01-09	2009-01-09 00:00:00	2009-01-09	581452		0	0	0		0	0	0	102269	0	121	40213260		
34326	2835	1127433	1983-01-28	1983-01-28 00:00:00	1983-02-11	1983-02-11 00:00:00	1983-02-11	38000177		0	0	14		0	0	0	188342	0	313782	1127433		
45984	3807	1127078	1956-01-02	1956-01-02 00:00:00	1956-03-02	1956-03-02 00:00:00	1956-03-02	38000177		0	0	60		0	0	0	253023	0	282464	1127078		
36637	3023	1127433	2017-06-26	2017-06-26 00:00:00	2017-07-03	2017-07-03 00:00:00	2017-07-03	38000177		0	0	7		0	0	0	201520	0	313782	1127433		
20252	1661	1127433	1986-06-18	1986-06-18 00:00:00	1986-07-09	1986-07-09 00:00:00	1986-07-09	38000177		0	0	21		0	0	0	111653	0	313782	1127433		
28639	2359	40229134	1998-12-10	1998-12-10 00:00:00	1998-12-17	1998-12-17 00:00:00	1998-12-17	38000177		0	0	7		0	0	0	157270	0	1043400	40229134		
28696	2367	1127433	2004-05-04	2004-05-04 00:00:00	2004-05-11	2004-05-11 00:00:00	2004-05-11	38000177		0	0	7		0	0	0	157551	0	313782	1127433		
1744	140	19133873	1974-06-30	1974-06-30 00:00:00	1974-07-08	1974-07-08 00:00:00	1974-07-08	38000177		0	0	8		0	0	0	9352	0	834061	19133873		
1462	116	40165015	1964-06-16	1964-06-16 00:00:00	1964-06-16	1964-06-16 00:00:00	\N	38000177		0	0	0		0	0	0	7653	0	861467	40165015		
44415	3676	46275916	1997-02-13	1997-02-13 00:00:00	1997-02-13	1997-02-13 00:00:00	1997-02-13	38000177		0	0	0		0	0	0	244486	0	1660014	46275916		
41452	3436	1127433	1964-08-05	1964-08-05 00:00:00	1964-08-12	1964-08-12 00:00:00	1964-08-12	38000177		0	0	7		0	0	0	227856	0	313782	1127433		
111172	2442	40213227	1994-02-28	1994-02-28 00:00:00	1994-02-28	1994-02-28 00:00:00	1994-02-28	581452		0	0	0		0	0	0	161928	0	113	40213227		
33086	723	40213260	2010-12-09	2010-12-09 00:00:00	2010-12-09	2010-12-09 00:00:00	2010-12-09	581452		0	0	0		0	0	0	47819	0	121	40213260		
37999	829	40213306	1996-06-09	1996-06-09 00:00:00	1996-06-09	1996-06-09 00:00:00	1996-06-09	581452		0	0	0		0	0	0	54892	0	43	40213306		
45589	994	40213296	2001-08-01	2001-08-01 00:00:00	2001-08-01	2001-08-01 00:00:00	2001-08-01	581452		0	0	0		0	0	0	65879	0	52	40213296		
50889	4227	1127433	1969-06-29	1969-06-29 00:00:00	1969-07-13	1969-07-13 00:00:00	1969-07-13	38000177		0	0	14		0	0	0	280796	0	313782	1127433		
56949	1246	40213227	2009-10-16	2009-10-16 00:00:00	2009-10-16	2009-10-16 00:00:00	2009-10-16	581452		0	0	0		0	0	0	82036	0	113	40213227		
22842	1878	19019979	1980-12-04	1980-12-04 00:00:00	1980-12-25	1980-12-25 00:00:00	1980-12-25	38000177		0	0	21		0	0	0	125348	0	198405	19019979		
29314	2427	1127433	1986-04-23	1986-04-23 00:00:00	1986-05-07	1986-05-07 00:00:00	1986-05-07	38000177		0	0	14		0	0	0	161031	0	313782	1127433		
29366	2431	19133873	1979-05-04	1979-05-04 00:00:00	1979-05-17	1979-05-17 00:00:00	1979-05-17	38000177		0	0	13		0	0	0	161203	0	834061	19133873		
44159	3655	19059056	1936-05-26	1936-05-26 00:00:00	1936-06-09	1936-06-09 00:00:00	1936-06-09	38000177		0	0	14		0	0	0	243254	0	243670	19059056		
39879	3298	19133873	1984-06-02	1984-06-02 00:00:00	1984-06-13	1984-06-13 00:00:00	1984-06-13	38000177		0	0	11		0	0	0	219163	0	834061	19133873		
10413	222	40213201	2017-12-15	2017-12-15 00:00:00	2017-12-15	2017-12-15 00:00:00	2017-12-15	581452		0	0	0		0	0	0	14963	0	33	40213201		
36467	3007	19133873	1967-11-20	1967-11-20 00:00:00	1967-12-01	1967-12-01 00:00:00	1967-12-01	38000177		0	0	11		0	0	0	200629	0	834061	19133873		
11366	947	1127433	2002-07-24	2002-07-24 00:00:00	2002-07-31	2002-07-31 00:00:00	2002-07-31	38000177		0	0	7		0	0	0	62845	0	313782	1127433		
25448	2090	1310034	1974-03-20	1974-03-20 00:00:00	1974-03-20	1974-03-20 00:00:00	1974-03-20	38000177		0	0	0		0	0	0	139372	0	834357	1310034		
54582	4534	1127433	1998-06-10	1998-06-10 00:00:00	1998-08-16	1998-08-16 00:00:00	1998-08-16	38000177		0	0	67		0	0	0	302078	0	313782	1127433		
21973	1804	19059056	1937-11-14	1937-11-14 00:00:00	1937-11-28	1937-11-28 00:00:00	1937-11-28	38000177		0	0	14		0	0	0	120864	0	243670	19059056		
12863	1082	1127433	1989-12-16	1989-12-16 00:00:00	1989-12-30	1989-12-30 00:00:00	1989-12-30	38000177		0	0	14		0	0	0	70931	0	313782	1127433		
2819	227	1127078	1980-07-01	1980-07-01 00:00:00	1980-09-29	1980-09-29 00:00:00	1980-09-29	38000177		0	0	90		0	0	0	15306	0	282464	1127078		
73894	1612	40213160	1964-04-07	1964-04-07 00:00:00	1964-04-07	1964-04-07 00:00:00	1964-04-07	581452		0	0	0		0	0	0	108369	0	10	40213160		
2637	211	19074679	1967-10-12	1967-10-12 00:00:00	1968-03-28	1968-03-28 00:00:00	1968-03-28	38000177		0	0	168		0	0	0	14405	0	308971	19074679		
26204	571	40213160	1955-02-07	1955-02-07 00:00:00	1955-02-07	1955-02-07 00:00:00	1955-02-07	581452		0	0	0		0	0	0	37834	0	10	40213160		
13216	1108	40236824	2013-01-16	2013-01-16 00:00:00	2013-01-23	2013-01-23 00:00:00	2013-01-23	38000177		0	0	7		0	0	0	72941	0	1094107	40236824		
42940	3560	1127433	1976-07-11	1976-07-11 00:00:00	1976-07-25	1976-07-25 00:00:00	1976-07-25	38000177		0	0	14		0	0	0	236356	0	313782	1127433		
60046	4990	1713671	2012-12-24	2012-12-24 00:00:00	2012-12-31	2012-12-31 00:00:00	2012-12-31	38000177		0	0	7		0	0	0	331958	0	562251	1713671		
43302	3589	1150771	1981-08-09	1981-08-09 00:00:00	1981-08-09	1981-08-09 00:00:00	\N	38000177		0	0	0		0	0	0	238475	0	197378	1150771		
53819	4474	19006318	1966-11-18	1966-11-18 00:00:00	1966-12-02	1966-12-02 00:00:00	1966-12-02	38000177		0	0	14		0	0	0	297634	0	105078	19006318		
61918	5150	1127433	1958-12-06	1958-12-06 00:00:00	1959-01-03	1959-01-03 00:00:00	1959-01-03	38000177		0	0	28		0	0	0	342334	0	313782	1127433		
2852	63	40213227	2017-02-15	2017-02-15 00:00:00	2017-02-15	2017-02-15 00:00:00	2017-02-15	581452		0	0	0		0	0	0	4269	0	113	40213227		
38360	3172	1127433	2015-12-20	2015-12-20 00:00:00	2016-01-03	2016-01-03 00:00:00	2016-01-03	38000177		0	0	14		0	0	0	210871	0	313782	1127433		
57920	1267	40213227	2003-05-15	2003-05-15 00:00:00	2003-05-15	2003-05-15 00:00:00	2003-05-15	581452		0	0	0		0	0	0	83557	0	113	40213227		
64235	5331	19073188	2017-02-17	2017-02-17 00:00:00	2017-03-24	2017-03-24 00:00:00	2017-03-24	38000177		0	0	35		0	0	0	354940	0	308192	19073188		
236671	5196	40213160	1956-07-13	1956-07-13 00:00:00	1956-07-13	1956-07-13 00:00:00	1956-07-13	581452		0	0	0		0	0	0	345516	0	10	40213160		
48231	3998	19059056	1974-12-17	1974-12-17 00:00:00	1975-01-14	1975-01-14 00:00:00	1975-01-14	38000177		0	0	28		0	0	0	265790	0	243670	19059056		
27386	2266	1713671	1980-03-24	1980-03-24 00:00:00	1980-04-07	1980-04-07 00:00:00	1980-04-07	38000177		0	0	14		0	0	0	150640	0	562251	1713671		
3093	250	19073183	1980-10-26	1980-10-26 00:00:00	1980-11-09	1980-11-09 00:00:00	1980-11-09	38000177		0	0	14		0	0	0	16817	0	308182	19073183		
18279	1513	1127433	2010-03-31	2010-03-31 00:00:00	2010-04-14	2010-04-14 00:00:00	2010-04-14	38000177		0	0	14		0	0	0	101153	0	313782	1127433		
13647	1143	1127433	1990-04-24	1990-04-24 00:00:00	1990-05-08	1990-05-08 00:00:00	1990-05-08	38000177		0	0	14		0	0	0	75447	0	313782	1127433		
27488	2277	1127078	1970-03-13	1970-03-13 00:00:00	1970-03-27	1970-03-27 00:00:00	1970-03-27	38000177		0	0	14		0	0	0	151326	0	282464	1127078		
22833	495	40213227	2001-03-17	2001-03-17 00:00:00	2001-03-17	2001-03-17 00:00:00	2001-03-17	581452		0	0	0		0	0	0	33100	0	113	40213227		
45761	3788	19133905	2004-03-06	2004-03-06 00:00:00	2004-03-14	2004-03-14 00:00:00	2004-03-14	38000177		0	0	8		0	0	0	251859	0	834102	19133905		
48630	4027	1127078	1976-06-07	1976-06-07 00:00:00	1976-06-21	1976-06-21 00:00:00	1976-06-21	38000177		0	0	14		0	0	0	267875	0	282464	1127078		
165271	3633	40213296	2014-03-02	2014-03-02 00:00:00	2014-03-02	2014-03-02 00:00:00	2014-03-02	581452		0	0	0		0	0	0	241687	0	52	40213296		
30451	664	40213306	2003-09-11	2003-09-11 00:00:00	2003-09-11	2003-09-11 00:00:00	2003-09-11	581452		0	0	0		0	0	0	43876	0	43	40213306		
56412	4680	19059056	1910-11-22	1910-11-22 00:00:00	1910-12-06	1910-12-06 00:00:00	1910-12-06	38000177		0	0	14		0	0	0	311884	0	243670	19059056		
129454	2846	40213160	1977-06-05	1977-06-05 00:00:00	1977-06-05	1977-06-05 00:00:00	1977-06-05	581452		0	0	0		0	0	0	189044	0	10	40213160		
10156	851	1127078	1982-06-26	1982-06-26 00:00:00	1982-07-26	1982-07-26 00:00:00	1982-07-26	38000177		0	0	30		0	0	0	56290	0	282464	1127078		
193659	4255	40213296	2013-05-04	2013-05-04 00:00:00	2013-05-04	2013-05-04 00:00:00	2013-05-04	581452		0	0	0		0	0	0	282522	0	52	40213296		
41292	3423	1127433	1986-10-28	1986-10-28 00:00:00	1986-11-18	1986-11-18 00:00:00	1986-11-18	38000177		0	0	21		0	0	0	227093	0	313782	1127433		
1989	159	40229134	1997-08-18	1997-08-18 00:00:00	1997-08-25	1997-08-25 00:00:00	1997-08-25	38000177		0	0	7		0	0	0	10859	0	1043400	40229134		
24836	2041	1127078	1965-02-27	1965-02-27 00:00:00	1965-03-13	1965-03-13 00:00:00	1965-03-13	38000177		0	0	14		0	0	0	135844	0	282464	1127078		
48444	4014	1127433	1976-09-11	1976-09-11 00:00:00	1976-09-18	1976-09-18 00:00:00	1976-09-18	38000177		0	0	7		0	0	0	266768	0	313782	1127433		
34215	2827	1127433	1984-03-23	1984-03-23 00:00:00	1984-04-06	1984-04-06 00:00:00	1984-04-06	38000177		0	0	14		0	0	0	187518	0	313782	1127433		
69930	1528	40213296	2001-01-19	2001-01-19 00:00:00	2001-01-19	2001-01-19 00:00:00	2001-01-19	581452		0	0	0		0	0	0	102257	0	52	40213296		
34327	2835	40165015	1983-01-28	1983-01-28 00:00:00	1983-01-28	1983-01-28 00:00:00	\N	38000177		0	0	0		0	0	0	188342	0	861467	40165015		
45985	3807	19059056	1948-01-14	1948-01-14 00:00:00	1948-01-28	1948-01-28 00:00:00	1948-01-28	38000177		0	0	14		0	0	0	253001	0	243670	19059056		
36640	3025	1545959	2002-10-14	2002-10-14 00:00:00	2002-10-14	2002-10-14 00:00:00	2002-10-14	38000177		0	0	0		0	0	0	201587	0	259255	1545959		
30711	2545	40223768	2000-09-14	2000-09-14 00:00:00	2000-09-14	2000-09-14 00:00:00	\N	38000177		0	0	0		0	0	0	168423	0	997223	40223768		
28640	2359	1124300	1965-01-30	1965-01-30 00:00:00	1965-01-30	1965-01-30 00:00:00	\N	38000177		0	0	0		0	0	0	157257	0	00781178901	45011828		
28697	2367	1127078	1983-03-16	1983-03-16 00:00:00	1983-04-13	1983-04-13 00:00:00	1983-04-13	38000177		0	0	28		0	0	0	157572	0	282464	1127078		
1745	140	1127433	1986-12-05	1986-12-05 00:00:00	1986-12-19	1986-12-19 00:00:00	1986-12-19	38000177		0	0	14		0	0	0	9408	0	313782	1127433		
1463	116	1127433	1964-06-16	1964-06-16 00:00:00	1964-09-14	1964-09-14 00:00:00	1964-09-14	38000177		0	0	90		0	0	0	7653	0	313782	1127433		
44416	3676	1713671	1981-02-24	1981-02-24 00:00:00	1981-06-16	1981-06-16 00:00:00	1981-06-16	38000177		0	0	112		0	0	0	244508	0	562251	1713671		
41453	3436	1127078	1965-03-31	1965-03-31 00:00:00	1965-04-14	1965-04-14 00:00:00	1965-04-14	38000177		0	0	14		0	0	0	227844	0	282464	1127078		
111173	2442	40213306	1994-02-28	1994-02-28 00:00:00	1994-02-28	1994-02-28 00:00:00	1994-02-28	581452		0	0	0		0	0	0	161928	0	43	40213306		
33089	723	40213227	1993-11-04	1993-11-04 00:00:00	1993-11-04	1993-11-04 00:00:00	1993-11-04	581452		0	0	0		0	0	0	47832	0	113	40213227		
103025	2260	40213201	2008-09-07	2008-09-07 00:00:00	2008-09-07	2008-09-07 00:00:00	2008-09-07	581452		0	0	0		0	0	0	150191	0	33	40213201		
45592	994	40213296	1999-07-28	1999-07-28 00:00:00	1999-07-28	1999-07-28 00:00:00	1999-07-28	581452		0	0	0		0	0	0	65902	0	52	40213296		
50890	4227	19006318	1959-04-14	1959-04-14 00:00:00	1959-04-28	1959-04-28 00:00:00	1959-04-28	38000177		0	0	14		0	0	0	280857	0	105078	19006318		
57433	1257	40213160	1977-02-26	1977-02-26 00:00:00	1977-02-26	1977-02-26 00:00:00	1977-02-26	581452		0	0	0		0	0	0	82793	0	10	40213160		
22843	1878	46233988	1975-06-14	1975-06-14 00:00:00	1975-06-28	1975-06-28 00:00:00	1975-06-28	38000177		0	0	14		0	0	0	125336	0	1652673	46233988		
29315	2427	1713671	1965-01-15	1965-01-15 00:00:00	1965-01-29	1965-01-29 00:00:00	1965-01-29	38000177		0	0	14		0	0	0	161034	0	562251	1713671		
29367	2431	19129655	1976-05-25	1976-05-25 00:00:00	1976-06-08	1976-06-08 00:00:00	1976-06-08	38000177		0	0	14		0	0	0	161231	0	789980	19129655		
44160	3655	1545959	2010-12-16	2010-12-16 00:00:00	2010-12-16	2010-12-16 00:00:00	2010-12-16	38000177		0	0	0		0	0	0	243260	0	259255	1545959		
39881	3300	1124300	2016-08-16	2016-08-16 00:00:00	2016-08-16	2016-08-16 00:00:00	\N	38000177		0	0	0		0	0	0	219248	0	00781178901	45011828		
10421	222	40213227	1993-09-24	1993-09-24 00:00:00	1993-09-24	1993-09-24 00:00:00	1993-09-24	581452		0	0	0		0	0	0	14907	0	113	40213227		
36468	3007	1127433	2006-09-18	2006-09-18 00:00:00	2006-10-02	2006-10-02 00:00:00	2006-10-02	38000177		0	0	14		0	0	0	200603	0	313782	1127433		
11367	948	1127433	1965-12-13	1965-12-13 00:00:00	1965-12-20	1965-12-20 00:00:00	1965-12-20	38000177		0	0	7		0	0	0	62968	0	313782	1127433		
25449	2090	40243436	1974-03-20	1974-03-20 00:00:00	1974-03-20	1974-03-20 00:00:00	1974-03-20	38000177		0	0	0		0	0	0	139372	0	1190795	40243436		
54583	4534	40229134	2003-02-11	2003-02-11 00:00:00	2003-02-18	2003-02-18 00:00:00	2003-02-18	38000177		0	0	7		0	0	0	302025	0	1043400	40229134		
21974	1804	1127433	1986-06-02	1986-06-02 00:00:00	1986-06-23	1986-06-23 00:00:00	1986-06-23	38000177		0	0	21		0	0	0	120877	0	313782	1127433		
12864	1082	19008572	1988-08-22	1988-08-22 00:00:00	1988-08-22	1988-08-22 00:00:00	\N	38000177		0	0	0		0	0	0	70909	0	106258	19008572		
2820	227	40165015	2014-07-03	2014-07-03 00:00:00	2014-07-03	2014-07-03 00:00:00	\N	38000177		0	0	0		0	0	0	15313	0	861467	40165015		
73908	1613	40213160	1955-01-22	1955-01-22 00:00:00	1955-01-22	1955-01-22 00:00:00	1955-01-22	581452		0	0	0		0	0	0	108459	0	10	40213160		
2638	211	19059056	1973-02-12	1973-02-12 00:00:00	1973-02-26	1973-02-26 00:00:00	1973-02-26	38000177		0	0	14		0	0	0	14355	0	243670	19059056		
106165	2328	40213160	1959-09-07	1959-09-07 00:00:00	1959-09-07	1959-09-07 00:00:00	1959-09-07	581452		0	0	0		0	0	0	154862	0	10	40213160		
13217	1108	920334	2006-08-25	2006-08-25 00:00:00	2006-09-01	2006-09-01 00:00:00	2006-09-01	38000177		0	0	7		0	0	0	72940	0	311995	920334		
42941	3560	1124300	1994-08-14	1994-08-14 00:00:00	1994-08-14	1994-08-14 00:00:00	\N	38000177		0	0	0		0	0	0	236406	0	00781178901	45011828		
60047	4990	1127433	2002-07-31	2002-07-31 00:00:00	2002-08-07	2002-08-07 00:00:00	2002-08-07	38000177		0	0	7		0	0	0	332004	0	313782	1127433		
43303	3589	19073183	1985-09-24	1985-09-24 00:00:00	1985-10-08	1985-10-08 00:00:00	1985-10-08	38000177		0	0	14		0	0	0	238481	0	308182	19073183		
53820	4474	1127433	1994-08-01	1994-08-01 00:00:00	1994-08-08	1994-08-08 00:00:00	1994-08-08	38000177		0	0	7		0	0	0	297631	0	313782	1127433		
222436	4883	40213227	2007-03-23	2007-03-23 00:00:00	2007-03-23	2007-03-23 00:00:00	2007-03-23	581452		0	0	0		0	0	0	324654	0	113	40213227		
2861	63	40213260	2007-12-26	2007-12-26 00:00:00	2007-12-26	2007-12-26 00:00:00	2007-12-26	581452		0	0	0		0	0	0	4257	0	121	40213260		
38361	3172	1124300	2012-10-28	2012-10-28 00:00:00	2012-10-28	2012-10-28 00:00:00	\N	38000177		0	0	0		0	0	0	210885	0	00781178901	45011828		
57930	1267	40213227	1994-05-19	1994-05-19 00:00:00	1994-05-19	1994-05-19 00:00:00	1994-05-19	581452		0	0	0		0	0	0	83556	0	113	40213227		
64236	5331	40162522	2017-02-17	2017-02-17 00:00:00	2017-02-17	2017-02-17 00:00:00	\N	38000177		0	0	0		0	0	0	354940	0	857005	40162522		
236675	5196	40213201	2017-11-24	2017-11-24 00:00:00	2017-11-24	2017-11-24 00:00:00	2017-11-24	581452		0	0	0		0	0	0	345489	0	33	40213201		
48232	3998	1127433	2006-07-10	2006-07-10 00:00:00	2006-07-17	2006-07-17 00:00:00	2006-07-17	38000177		0	0	7		0	0	0	265806	0	313782	1127433		
27387	2266	19129655	1969-06-12	1969-06-12 00:00:00	1969-06-26	1969-06-26 00:00:00	1969-06-26	38000177		0	0	14		0	0	0	150626	0	789980	19129655		
3094	250	1127078	1980-10-26	1980-10-26 00:00:00	1980-11-09	1980-11-09 00:00:00	1980-11-09	38000177		0	0	14		0	0	0	16817	0	282464	1127078		
18280	1513	19133905	2009-11-28	2009-11-28 00:00:00	2009-12-10	2009-12-10 00:00:00	2009-12-10	38000177		0	0	12		0	0	0	101108	0	834102	19133905		
13648	1143	40231925	1983-11-26	1983-11-26 00:00:00	1983-11-26	1983-11-26 00:00:00	\N	38000177		0	0	0		0	0	0	75457	0	1049221	40231925		
27489	2277	1127433	2005-10-09	2005-10-09 00:00:00	2005-10-23	2005-10-23 00:00:00	2005-10-23	38000177		0	0	14		0	0	0	151325	0	313782	1127433		
22835	495	40213160	1968-10-26	1968-10-26 00:00:00	1968-10-26	1968-10-26 00:00:00	1968-10-26	581452		0	0	0		0	0	0	33086	0	10	40213160		
45762	3788	19133873	1975-11-25	1975-11-25 00:00:00	1975-12-02	1975-12-02 00:00:00	1975-12-02	38000177		0	0	7		0	0	0	251838	0	834061	19133873		
48631	4027	19128022	1992-12-06	1992-12-06 00:00:00	1993-12-01	1993-12-01 00:00:00	1993-12-01	38000177		0	0	360		0	0	0	267876	0	749785	19128022		
165273	3633	40213160	1973-02-04	1973-02-04 00:00:00	1973-02-04	1973-02-04 00:00:00	1973-02-04	581452		0	0	0		0	0	0	241659	0	10	40213160		
30457	664	40213160	1982-03-18	1982-03-18 00:00:00	1982-03-18	1982-03-18 00:00:00	1982-03-18	581452		0	0	0		0	0	0	43837	0	10	40213160		
56413	4680	19059056	1913-04-13	1913-04-13 00:00:00	1913-04-27	1913-04-27 00:00:00	1913-04-27	38000177		0	0	14		0	0	0	311894	0	243670	19059056		
129462	2846	40213160	1972-12-03	1972-12-03 00:00:00	1972-12-03	1972-12-03 00:00:00	1972-12-03	581452		0	0	0		0	0	0	189017	0	10	40213160		
10189	855	1124300	1999-03-08	1999-03-08 00:00:00	1999-03-08	1999-03-08 00:00:00	\N	38000177		0	0	0		0	0	0	56512	0	00781178901	45011828		
193660	4255	40213314	1977-04-02	1977-04-02 00:00:00	1977-04-02	1977-04-02 00:00:00	1977-04-02	581452		0	0	0		0	0	0	282558	0	49	40213314		
32099	700	40213251	1984-05-30	1984-05-30 00:00:00	1984-05-30	1984-05-30 00:00:00	1984-05-30	581452		0	0	0		0	0	0	46280	0	21	40213251		
1990	159	19078461	1976-05-19	1976-05-19 00:00:00	1976-06-16	1976-06-16 00:00:00	1976-06-16	38000177		0	0	28		0	0	0	10920	0	310965	19078461		
24837	2041	19129655	1965-02-27	1965-02-27 00:00:00	1965-03-13	1965-03-13 00:00:00	1965-03-13	38000177		0	0	14		0	0	0	135844	0	789980	19129655		
48445	4014	40223834	1997-12-09	1997-12-09 00:00:00	1997-12-09	1997-12-09 00:00:00	\N	38000177		0	0	0		0	0	0	266770	0	997501	40223834		
34216	2827	1713671	1927-09-29	1927-09-29 00:00:00	1927-10-13	1927-10-13 00:00:00	1927-10-13	38000177		0	0	14		0	0	0	187506	0	562251	1713671		
69932	1528	40213227	2001-01-19	2001-01-19 00:00:00	2001-01-19	2001-01-19 00:00:00	2001-01-19	581452		0	0	0		0	0	0	102257	0	113	40213227		
34328	2835	19133905	1981-10-28	1981-10-28 00:00:00	1981-11-04	1981-11-04 00:00:00	1981-11-04	38000177		0	0	7		0	0	0	188270	0	834102	19133905		
45986	3807	19006318	1948-01-14	1948-01-14 00:00:00	1948-01-28	1948-01-28 00:00:00	1948-01-28	38000177		0	0	14		0	0	0	253001	0	105078	19006318		
36641	3025	19133768	2002-10-14	2002-10-14 00:00:00	2002-10-14	2002-10-14 00:00:00	2002-10-14	38000177		0	0	0		0	0	0	201587	0	833036	19133768		
30712	2545	19059056	1949-09-24	1949-09-24 00:00:00	1949-10-08	1949-10-08 00:00:00	1949-10-08	38000177		0	0	14		0	0	0	168432	0	243670	19059056		
28641	2359	1127433	2007-12-01	2007-12-01 00:00:00	2007-12-22	2007-12-22 00:00:00	2007-12-22	38000177		0	0	21		0	0	0	157240	0	313782	1127433		
28698	2367	19133905	2018-06-26	2018-06-26 00:00:00	2018-07-08	2018-07-08 00:00:00	2018-07-08	38000177		0	0	12		0	0	0	157582	0	834102	19133905		
1746	140	19059056	1970-05-31	1970-05-31 00:00:00	1970-06-21	1970-06-21 00:00:00	1970-06-21	38000177		0	0	21		0	0	0	9414	0	243670	19059056		
1464	116	1127433	1959-07-22	1959-07-22 00:00:00	1959-08-12	1959-08-12 00:00:00	1959-08-12	38000177		0	0	21		0	0	0	7652	0	313782	1127433		
44422	3678	40165015	2009-10-30	2009-10-30 00:00:00	2009-10-30	2009-10-30 00:00:00	\N	38000177		0	0	0		0	0	0	244602	0	861467	40165015		
41454	3436	19006318	1965-03-31	1965-03-31 00:00:00	1965-04-14	1965-04-14 00:00:00	1965-04-14	38000177		0	0	14		0	0	0	227844	0	105078	19006318		
111179	2442	40213160	1972-02-28	1972-02-28 00:00:00	1972-02-28	1972-02-28 00:00:00	1972-02-28	581452		0	0	0		0	0	0	161937	0	10	40213160		
33092	723	40213160	1961-04-20	1961-04-20 00:00:00	1961-04-20	1961-04-20 00:00:00	1961-04-20	581452		0	0	0		0	0	0	47809	0	10	40213160		
103030	2260	40213227	2013-10-06	2013-10-06 00:00:00	2013-10-06	2013-10-06 00:00:00	2013-10-06	581452		0	0	0		0	0	0	150219	0	113	40213227		
45593	994	40213160	1959-12-30	1959-12-30 00:00:00	1959-12-30	1959-12-30 00:00:00	1959-12-30	581452		0	0	0		0	0	0	65909	0	10	40213160		
50891	4227	1127078	1959-04-14	1959-04-14 00:00:00	1959-04-28	1959-04-28 00:00:00	1959-04-28	38000177		0	0	14		0	0	0	280857	0	282464	1127078		
57434	1257	40213314	1977-02-26	1977-02-26 00:00:00	1977-02-26	1977-02-26 00:00:00	1977-02-26	581452		0	0	0		0	0	0	82793	0	49	40213314		
22844	1878	19019979	1975-06-14	1975-06-14 00:00:00	1975-06-28	1975-06-28 00:00:00	1975-06-28	38000177		0	0	14		0	0	0	125336	0	198405	19019979		
29316	2427	19078461	1994-06-09	1994-06-09 00:00:00	1994-07-07	1994-07-07 00:00:00	1994-07-07	38000177		0	0	28		0	0	0	160963	0	310965	19078461		
29368	2431	1127078	1976-05-25	1976-05-25 00:00:00	1976-06-08	1976-06-08 00:00:00	1976-06-08	38000177		0	0	14		0	0	0	161231	0	282464	1127078		
44161	3655	19133768	2010-12-16	2010-12-16 00:00:00	2010-12-16	2010-12-16 00:00:00	2010-12-16	38000177		0	0	0		0	0	0	243260	0	833036	19133768		
39882	3300	19128065	1997-07-27	1997-07-27 00:00:00	1998-07-22	1998-07-22 00:00:00	1998-07-22	38000177		0	0	360		0	0	0	219222	0	749882	19128065		
107601	2358	40213296	2013-09-17	2013-09-17 00:00:00	2013-09-17	2013-09-17 00:00:00	2013-09-17	581452		0	0	0		0	0	0	157114	0	52	40213296		
36469	3007	1118084	2007-08-28	2007-08-28 00:00:00	2007-08-28	2007-08-28 00:00:00	\N	38000177		0	0	0		0	0	0	200589	0	00025152531	44923712		
11368	948	40231925	1972-05-15	1972-05-15 00:00:00	1972-05-15	1972-05-15 00:00:00	\N	38000177		0	0	0		0	0	0	62962	0	1049221	40231925		
25450	2090	1124300	2002-06-12	2002-06-12 00:00:00	2002-06-12	2002-06-12 00:00:00	\N	38000177		0	0	0		0	0	0	139370	0	00781178901	45011828		
54584	4534	19133873	1955-02-03	1955-02-03 00:00:00	1955-02-16	1955-02-16 00:00:00	1955-02-16	38000177		0	0	13		0	0	0	302082	0	834061	19133873		
21975	1804	1127433	1989-07-12	1989-07-12 00:00:00	1989-07-19	1989-07-19 00:00:00	1989-07-19	38000177		0	0	7		0	0	0	120891	0	313782	1127433		
12865	1082	1115171	2018-07-20	2018-07-20 00:00:00	2018-08-10	2018-08-10 00:00:00	2018-08-10	38000177		0	0	21		0	0	0	71053	0	849574	1115171		
2821	227	1115171	2014-07-03	2014-07-03 00:00:00	2014-07-31	2014-07-31 00:00:00	2014-07-31	38000177		0	0	28		0	0	0	15313	0	849574	1115171		
8439	182	40213227	2001-09-16	2001-09-16 00:00:00	2001-09-16	2001-09-16 00:00:00	2001-09-16	581452		0	0	0		0	0	0	12333	0	113	40213227		
2639	211	46233988	1973-02-12	1973-02-12 00:00:00	1973-02-26	1973-02-26 00:00:00	1973-02-26	38000177		0	0	14		0	0	0	14355	0	1652673	46233988		
106167	2328	40213160	1955-06-06	1955-06-06 00:00:00	1955-06-06	1955-06-06 00:00:00	1955-06-06	581452		0	0	0		0	0	0	154892	0	10	40213160		
13218	1108	1127078	1975-07-29	1975-07-29 00:00:00	1975-08-26	1975-08-26 00:00:00	1975-08-26	38000177		0	0	28		0	0	0	72995	0	282464	1127078		
42942	3560	40165015	1988-04-12	1988-04-12 00:00:00	1988-04-12	1988-04-12 00:00:00	\N	38000177		0	0	0		0	0	0	236409	0	861467	40165015		
60048	4990	19133905	2008-02-04	2008-02-04 00:00:00	2008-02-12	2008-02-12 00:00:00	2008-02-12	38000177		0	0	8		0	0	0	331986	0	834102	19133905		
43304	3589	19019979	1985-09-24	1985-09-24 00:00:00	1985-10-08	1985-10-08 00:00:00	1985-10-08	38000177		0	0	14		0	0	0	238481	0	198405	19019979		
53821	4474	19073188	2017-11-17	2017-11-17 00:00:00	2017-11-21	2017-11-21 00:00:00	2017-11-21	38000177		0	0	4		0	0	0	297682	0	308192	19073188		
222440	4883	40213198	2011-04-15	2011-04-15 00:00:00	2011-04-15	2011-04-15 00:00:00	2011-04-15	581452		0	0	0		0	0	0	324698	0	133	40213198		
56747	1242	40213296	1999-03-17	1999-03-17 00:00:00	1999-03-17	1999-03-17 00:00:00	1999-03-17	581452		0	0	0		0	0	0	81808	0	52	40213296		
38371	3174	1127433	1994-12-23	1994-12-23 00:00:00	1995-01-06	1995-01-06 00:00:00	1995-01-06	38000177		0	0	14		0	0	0	210942	0	313782	1127433		
57936	1267	40213201	2019-02-14	2019-02-14 00:00:00	2019-02-14	2019-02-14 00:00:00	2019-02-14	581452		0	0	0		0	0	0	83593	0	33	40213201		
236644	5196	40213160	1955-01-07	1955-01-07 00:00:00	1955-01-07	1955-01-07 00:00:00	1955-01-07	581452		0	0	0		0	0	0	345558	0	10	40213160		
236682	5196	40213227	2012-10-26	2012-10-26 00:00:00	2012-10-26	2012-10-26 00:00:00	2012-10-26	581452		0	0	0		0	0	0	345561	0	113	40213227		
48233	3998	40165015	2016-10-24	2016-10-24 00:00:00	2016-10-24	2016-10-24 00:00:00	\N	38000177		0	0	0		0	0	0	265850	0	861467	40165015		
27388	2266	19059056	1969-06-12	1969-06-12 00:00:00	1969-06-26	1969-06-26 00:00:00	1969-06-26	38000177		0	0	14		0	0	0	150626	0	243670	19059056		
3101	254	1713671	1975-07-13	1975-07-13 00:00:00	1975-08-03	1975-08-03 00:00:00	1975-08-03	38000177		0	0	21		0	0	0	16957	0	562251	1713671		
18281	1513	1118084	2011-01-01	2011-01-01 00:00:00	2011-01-01	2011-01-01 00:00:00	\N	38000177		0	0	0		0	0	0	101109	0	00025152531	44923712		
13649	1143	1127433	1983-11-26	1983-11-26 00:00:00	1983-12-26	1983-12-26 00:00:00	1983-12-26	38000177		0	0	30		0	0	0	75457	0	313782	1127433		
27490	2277	1127433	1992-07-06	1992-07-06 00:00:00	1992-07-20	1992-07-20 00:00:00	1992-07-20	38000177		0	0	14		0	0	0	151377	0	313782	1127433		
22841	495	40213306	1989-01-14	1989-01-14 00:00:00	1989-01-14	1989-01-14 00:00:00	1989-01-14	581452		0	0	0		0	0	0	33051	0	43	40213306		
45763	3788	1127433	1987-04-22	1987-04-22 00:00:00	1987-04-29	1987-04-29 00:00:00	1987-04-29	38000177		0	0	7		0	0	0	251858	0	313782	1127433		
48632	4027	1713671	1983-04-06	1983-04-06 00:00:00	1983-04-27	1983-04-27 00:00:00	1983-04-27	38000177		0	0	21		0	0	0	267832	0	562251	1713671		
165275	3633	40213160	1972-09-03	1972-09-03 00:00:00	1972-09-03	1972-09-03 00:00:00	1972-09-03	581452		0	0	0		0	0	0	241686	0	10	40213160		
30460	664	40213314	1981-12-17	1981-12-17 00:00:00	1981-12-17	1981-12-17 00:00:00	1981-12-17	581452		0	0	0		0	0	0	43864	0	49	40213314		
56414	4680	1127433	1988-08-07	1988-08-07 00:00:00	1988-08-28	1988-08-28 00:00:00	1988-08-28	38000177		0	0	21		0	0	0	311951	0	313782	1127433		
129465	2846	40213227	2003-11-30	2003-11-30 00:00:00	2003-11-30	2003-11-30 00:00:00	2003-11-30	581452		0	0	0		0	0	0	189049	0	113	40213227		
10190	855	19059056	1962-03-18	1962-03-18 00:00:00	1962-04-01	1962-04-01 00:00:00	1962-04-01	38000177		0	0	14		0	0	0	56495	0	243670	19059056		
193663	4255	40213227	2005-02-12	2005-02-12 00:00:00	2005-02-12	2005-02-12 00:00:00	2005-02-12	581452		0	0	0		0	0	0	282546	0	113	40213227		
32104	700	40213227	2000-08-16	2000-08-16 00:00:00	2000-08-16	2000-08-16 00:00:00	2000-08-16	581452		0	0	0		0	0	0	46252	0	113	40213227		
1991	159	40165015	1997-12-30	1997-12-30 00:00:00	1997-12-30	1997-12-30 00:00:00	\N	38000177		0	0	0		0	0	0	10924	0	861467	40165015		
24838	2041	1124300	2007-07-09	2007-07-09 00:00:00	2007-07-09	2007-07-09 00:00:00	\N	38000177		0	0	0		0	0	0	135867	0	00781178901	45011828		
48446	4014	1594382	1997-12-09	1997-12-09 00:00:00	1997-12-09	1997-12-09 00:00:00	\N	38000177		0	0	0		0	0	0	266770	0	1870230	1594382		
34217	2827	1127433	1987-05-28	1987-05-28 00:00:00	1987-08-26	1987-08-26 00:00:00	1987-08-26	38000177		0	0	90		0	0	0	187513	0	313782	1127433		
69941	1529	40213160	1967-06-12	1967-06-12 00:00:00	1967-06-12	1967-06-12 00:00:00	1967-06-12	581452		0	0	0		0	0	0	102297	0	10	40213160		
34329	2835	40220960	1994-09-27	1994-09-27 00:00:00	1994-09-27	1994-09-27 00:00:00	1994-09-27	38000177		0	0	0		0	0	0	188345	0	1804799	40220960		
45988	3807	1127433	1977-03-06	1977-03-06 00:00:00	1977-03-13	1977-03-13 00:00:00	1977-03-13	38000177		0	0	7		0	0	0	252971	0	313782	1127433		
36642	3025	1127078	1953-10-15	1953-10-15 00:00:00	1953-11-05	1953-11-05 00:00:00	1953-11-05	38000177		0	0	21		0	0	0	201582	0	282464	1127078		
30713	2545	19006318	1949-09-24	1949-09-24 00:00:00	1949-10-08	1949-10-08 00:00:00	1949-10-08	38000177		0	0	14		0	0	0	168432	0	105078	19006318		
28642	2359	1713671	1938-07-20	1938-07-20 00:00:00	1938-08-31	1938-08-31 00:00:00	1938-08-31	38000177		0	0	42		0	0	0	157274	0	562251	1713671		
28699	2367	1713671	1978-10-17	1978-10-17 00:00:00	1978-11-07	1978-11-07 00:00:00	1978-11-07	38000177		0	0	21		0	0	0	157558	0	562251	1713671		
1747	140	1127433	1995-01-07	1995-01-07 00:00:00	1995-01-28	1995-01-28 00:00:00	1995-01-28	38000177		0	0	21		0	0	0	9348	0	313782	1127433		
1465	116	19059056	1936-02-18	1936-02-18 00:00:00	1936-03-24	1936-03-24 00:00:00	1936-03-24	38000177		0	0	35		0	0	0	7650	0	243670	19059056		
44423	3678	1115171	2009-10-30	2009-10-30 00:00:00	2009-11-29	2009-11-29 00:00:00	2009-11-29	38000177		0	0	30		0	0	0	244602	0	849574	1115171		
41455	3436	40165015	1976-04-23	1976-04-23 00:00:00	1976-04-23	1976-04-23 00:00:00	\N	38000177		0	0	0		0	0	0	227854	0	861467	40165015		
180730	3972	40213160	1959-04-19	1959-04-19 00:00:00	1959-04-19	1959-04-19 00:00:00	1959-04-19	581452		0	0	0		0	0	0	264120	0	10	40213160		
33102	723	40213227	2011-12-15	2011-12-15 00:00:00	2011-12-15	2011-12-15 00:00:00	2011-12-15	581452		0	0	0		0	0	0	47860	0	113	40213227		
151587	3335	40213160	1972-07-02	1972-07-02 00:00:00	1972-07-02	1972-07-02 00:00:00	1972-07-02	581452		0	0	0		0	0	0	221281	0	10	40213160		
18644	1540	1127433	1966-06-18	1966-06-18 00:00:00	1966-07-02	1966-07-02 00:00:00	1966-07-02	38000177		0	0	14		0	0	0	103165	0	313782	1127433		
50892	4227	1118084	1988-06-29	1988-06-29 00:00:00	1988-06-29	1988-06-29 00:00:00	\N	38000177		0	0	0		0	0	0	280782	0	00025152531	44923712		
57440	1257	40213227	1995-07-29	1995-07-29 00:00:00	1995-07-29	1995-07-29 00:00:00	1995-07-29	581452		0	0	0		0	0	0	82798	0	113	40213227		
22845	1878	19019979	1975-12-21	1975-12-21 00:00:00	1976-01-04	1976-01-04 00:00:00	1976-01-04	38000177		0	0	14		0	0	0	125331	0	198405	19019979		
29317	2427	19078461	2008-12-20	2008-12-20 00:00:00	2009-01-19	2009-01-19 00:00:00	2009-01-19	38000177		0	0	30		0	0	0	160964	0	310965	19078461		
20289	442	40213201	2014-06-21	2014-06-21 00:00:00	2014-06-21	2014-06-21 00:00:00	2014-06-21	581452		0	0	0		0	0	0	29275	0	33	40213201		
44162	3655	40229134	1940-10-04	1940-10-04 00:00:00	1940-10-18	1940-10-18 00:00:00	1940-10-18	38000177		0	0	14		0	0	0	243248	0	1043400	40229134		
39883	3300	40236824	2018-09-12	2018-09-12 00:00:00	2018-09-26	2018-09-26 00:00:00	2018-09-26	38000177		0	0	14		0	0	0	219221	0	1094107	40236824		
107604	2358	40213227	2013-09-17	2013-09-17 00:00:00	2013-09-17	2013-09-17 00:00:00	2013-09-17	581452		0	0	0		0	0	0	157114	0	113	40213227		
36486	3010	1713671	1982-03-10	1982-03-10 00:00:00	1982-03-31	1982-03-31 00:00:00	1982-03-31	38000177		0	0	21		0	0	0	200770	0	562251	1713671		
11369	948	1127433	1972-05-15	1972-05-15 00:00:00	1972-07-14	1972-07-14 00:00:00	1972-07-14	38000177		0	0	60		0	0	0	62962	0	313782	1127433		
25451	2090	19059056	1971-03-07	1971-03-07 00:00:00	1971-06-05	1971-06-05 00:00:00	1971-06-05	38000177		0	0	90		0	0	0	139371	0	243670	19059056		
54585	4534	19133873	1953-01-01	1953-01-01 00:00:00	1953-01-13	1953-01-13 00:00:00	1953-01-13	38000177		0	0	12		0	0	0	302086	0	834061	19133873		
21976	1804	19059056	1955-10-29	1955-10-29 00:00:00	1955-11-12	1955-11-12 00:00:00	1955-11-12	38000177		0	0	14		0	0	0	120875	0	243670	19059056		
12866	1082	1594382	1988-09-06	1988-09-06 00:00:00	1988-09-06	1988-09-06 00:00:00	\N	38000177		0	0	0		0	0	0	70905	0	1870230	1594382		
2822	227	19073188	2014-07-03	2014-07-03 00:00:00	2014-07-31	2014-07-31 00:00:00	2014-07-31	38000177		0	0	28		0	0	0	15313	0	308192	19073188		
8455	182	40213201	2016-12-18	2016-12-18 00:00:00	2016-12-18	2016-12-18 00:00:00	2016-12-18	581452		0	0	0		0	0	0	12288	0	33	40213201		
2640	211	19115351	1968-06-20	1968-06-20 00:00:00	1968-12-26	1968-12-26 00:00:00	1968-12-26	38000177		0	0	189		0	0	0	14378	0	563026	19115351		
106174	2328	40213227	2016-01-04	2016-01-04 00:00:00	2016-01-04	2016-01-04 00:00:00	2016-01-04	581452		0	0	0		0	0	0	154876	0	113	40213227		
13219	1108	19133873	1979-07-11	1979-07-11 00:00:00	1979-07-23	1979-07-23 00:00:00	1979-07-23	38000177		0	0	12		0	0	0	72946	0	834061	19133873		
42943	3560	19059056	1988-04-12	1988-04-12 00:00:00	1988-05-12	1988-05-12 00:00:00	1988-05-12	38000177		0	0	30		0	0	0	236409	0	243670	19059056		
60049	4990	1713671	1988-09-25	1988-09-25 00:00:00	1988-10-16	1988-10-16 00:00:00	1988-10-16	38000177		0	0	21		0	0	0	332002	0	562251	1713671		
43305	3589	1124300	2016-11-06	2016-11-06 00:00:00	2016-11-06	2016-11-06 00:00:00	\N	38000177		0	0	0		0	0	0	238446	0	00781178901	45011828		
53822	4474	19078461	1983-06-13	1983-06-13 00:00:00	1983-06-27	1983-06-27 00:00:00	1983-06-27	38000177		0	0	14		0	0	0	297690	0	310965	19078461		
222460	4883	40213227	2017-05-19	2017-05-19 00:00:00	2017-05-19	2017-05-19 00:00:00	2017-05-19	581452		0	0	0		0	0	0	324709	0	113	40213227		
56750	1242	40213227	2001-03-21	2001-03-21 00:00:00	2001-03-21	2001-03-21 00:00:00	2001-03-21	581452		0	0	0		0	0	0	81818	0	113	40213227		
38372	3174	1118084	2014-12-19	2014-12-19 00:00:00	2014-12-19	2014-12-19 00:00:00	\N	38000177		0	0	0		0	0	0	210943	0	00025152531	44923712		
9985	836	1127078	1980-12-06	1980-12-06 00:00:00	1980-12-20	1980-12-20 00:00:00	1980-12-20	38000177		0	0	14		0	0	0	55312	0	282464	1127078		
236647	5196	40213227	1993-08-13	1993-08-13 00:00:00	1993-08-13	1993-08-13 00:00:00	1993-08-13	581452		0	0	0		0	0	0	345485	0	113	40213227		
236683	5196	40213227	2002-08-09	2002-08-09 00:00:00	2002-08-09	2002-08-09 00:00:00	2002-08-09	581452		0	0	0		0	0	0	345539	0	113	40213227		
48234	3998	19078461	2016-10-24	2016-10-24 00:00:00	2016-12-23	2016-12-23 00:00:00	2016-12-23	38000177		0	0	60		0	0	0	265850	0	310965	19078461		
27389	2266	1127433	1991-04-28	1991-04-28 00:00:00	1991-05-05	1991-05-05 00:00:00	1991-05-05	38000177		0	0	7		0	0	0	150641	0	313782	1127433		
3102	254	1124300	1985-06-05	1985-06-05 00:00:00	1985-06-05	1985-06-05 00:00:00	\N	38000177		0	0	0		0	0	0	16972	0	00781178901	45011828		
18283	1513	19128065	1984-05-12	1984-05-12 00:00:00	1985-05-07	1985-05-07 00:00:00	1985-05-07	38000177		0	0	360		0	0	0	101029	0	749882	19128065		
13650	1143	19133873	1975-06-21	1975-06-21 00:00:00	1975-07-03	1975-07-03 00:00:00	1975-07-03	38000177		0	0	12		0	0	0	75402	0	834061	19133873		
27491	2277	1127433	1977-10-04	1977-10-04 00:00:00	1977-10-18	1977-10-18 00:00:00	1977-10-18	38000177		0	0	14		0	0	0	151352	0	313782	1127433		
73077	1597	40213201	2010-10-30	2010-10-30 00:00:00	2010-10-30	2010-10-30 00:00:00	2010-10-30	581452		0	0	0		0	0	0	107128	0	33	40213201		
45764	3788	1127078	1974-05-21	1974-05-21 00:00:00	1974-06-25	1974-06-25 00:00:00	1974-06-25	38000177		0	0	35		0	0	0	251823	0	282464	1127078		
48633	4027	1713671	1974-05-11	1974-05-11 00:00:00	1974-05-18	1974-05-18 00:00:00	1974-05-18	38000177		0	0	7		0	0	0	267829	0	562251	1713671		
165277	3633	40213227	1994-08-07	1994-08-07 00:00:00	1994-08-07	1994-08-07 00:00:00	1994-08-07	581452		0	0	0		0	0	0	241642	0	113	40213227		
30461	664	40213160	1981-12-17	1981-12-17 00:00:00	1981-12-17	1981-12-17 00:00:00	1981-12-17	581452		0	0	0		0	0	0	43864	0	10	40213160		
56415	4680	19059056	1925-04-23	1925-04-23 00:00:00	1925-05-14	1925-05-14 00:00:00	1925-05-14	38000177		0	0	21		0	0	0	311939	0	243670	19059056		
39584	864	40213227	1993-07-19	1993-07-19 00:00:00	1993-07-19	1993-07-19 00:00:00	1993-07-19	581452		0	0	0		0	0	0	57243	0	113	40213227		
10191	855	19129655	1962-03-18	1962-03-18 00:00:00	1962-04-01	1962-04-01 00:00:00	1962-04-01	38000177		0	0	14		0	0	0	56495	0	789980	19129655		
193664	4255	40213160	1973-10-06	1973-10-06 00:00:00	1973-10-06	1973-10-06 00:00:00	1973-10-06	581452		0	0	0		0	0	0	282531	0	10	40213160		
32105	700	40213306	2000-08-16	2000-08-16 00:00:00	2000-08-16	2000-08-16 00:00:00	2000-08-16	581452		0	0	0		0	0	0	46252	0	43	40213306		
1992	159	1539411	1991-03-26	1991-03-26 00:00:00	1991-03-26	1991-03-26 00:00:00	\N	38000177		0	0	0		0	0	0	10884	0	312961	1539411		
24839	2041	19059056	1969-11-01	1969-11-01 00:00:00	1969-11-15	1969-11-15 00:00:00	1969-11-15	38000177		0	0	14		0	0	0	135834	0	243670	19059056		
48470	4017	1713671	2005-09-12	2005-09-12 00:00:00	2005-10-03	2005-10-03 00:00:00	2005-10-03	38000177		0	0	21		0	0	0	267036	0	562251	1713671		
34218	2827	40165015	1987-05-28	1987-05-28 00:00:00	1987-05-28	1987-05-28 00:00:00	\N	38000177		0	0	0		0	0	0	187513	0	861467	40165015		
69944	1529	40213296	2003-06-23	2003-06-23 00:00:00	2003-06-23	2003-06-23 00:00:00	2003-06-23	581452		0	0	0		0	0	0	102323	0	52	40213296		
34330	2835	1127433	1963-02-14	1963-02-14 00:00:00	1963-03-14	1963-03-14 00:00:00	1963-03-14	38000177		0	0	28		0	0	0	188341	0	313782	1127433		
45989	3807	1118084	1988-06-27	1988-06-27 00:00:00	1988-06-27	1988-06-27 00:00:00	\N	38000177		0	0	0		0	0	0	252990	0	00025152531	44923712		
36643	3025	1118084	1984-08-03	1984-08-03 00:00:00	1984-08-03	1984-08-03 00:00:00	\N	38000177		0	0	0		0	0	0	201573	0	00025152531	44923712		
30714	2545	19133905	1988-05-16	1988-05-16 00:00:00	1988-05-29	1988-05-29 00:00:00	1988-05-29	38000177		0	0	13		0	0	0	168391	0	834102	19133905		
28643	2359	40229134	1941-01-31	1941-01-31 00:00:00	1941-02-14	1941-02-14 00:00:00	1941-02-14	38000177		0	0	14		0	0	0	157275	0	1043400	40229134		
28700	2367	1127433	2003-04-01	2003-04-01 00:00:00	2003-04-08	2003-04-08 00:00:00	2003-04-08	38000177		0	0	7		0	0	0	157581	0	313782	1127433		
1748	140	19128065	1988-05-06	1988-05-06 00:00:00	1989-05-01	1989-05-01 00:00:00	1989-05-01	38000177		0	0	360		0	0	0	9380	0	749882	19128065		
1466	116	1127433	1938-03-10	1938-03-10 00:00:00	1938-03-24	1938-03-24 00:00:00	1938-03-24	38000177		0	0	14		0	0	0	7703	0	313782	1127433		
44424	3678	19075001	1988-12-24	1988-12-24 00:00:00	1989-01-07	1989-01-07 00:00:00	1989-01-07	38000177		0	0	14		0	0	0	244591	0	309097	19075001		
41456	3436	46233710	1976-04-23	1976-04-23 00:00:00	1976-05-21	1976-05-21 00:00:00	1976-05-21	38000177		0	0	28		0	0	0	227854	0	1650142	46233710		
180739	3972	40213160	1963-10-13	1963-10-13 00:00:00	1963-10-13	1963-10-13 00:00:00	1963-10-13	581452		0	0	0		0	0	0	264124	0	10	40213160		
33103	723	40213260	2011-12-15	2011-12-15 00:00:00	2011-12-15	2011-12-15 00:00:00	2011-12-15	581452		0	0	0		0	0	0	47860	0	121	40213260		
151590	3335	40213227	2014-04-06	2014-04-06 00:00:00	2014-04-06	2014-04-06 00:00:00	2014-04-06	581452		0	0	0		0	0	0	221236	0	113	40213227		
18645	1540	40220960	2018-12-10	2018-12-10 00:00:00	2018-12-10	2018-12-10 00:00:00	2018-12-10	38000177		0	0	0		0	0	0	103181	0	1804799	40220960		
60463	5031	1127433	1928-02-17	1928-02-17 00:00:00	1928-02-24	1928-02-24 00:00:00	1928-02-24	38000177		0	0	7		0	0	0	334323	0	313782	1127433		
57441	1257	40213306	1995-07-29	1995-07-29 00:00:00	1995-07-29	1995-07-29 00:00:00	1995-07-29	581452		0	0	0		0	0	0	82798	0	43	40213306		
22846	1878	19006318	1975-12-21	1975-12-21 00:00:00	1976-01-04	1976-01-04 00:00:00	1976-01-04	38000177		0	0	14		0	0	0	125331	0	105078	19006318		
29318	2427	40165015	2008-12-20	2008-12-20 00:00:00	2008-12-20	2008-12-20 00:00:00	\N	38000177		0	0	0		0	0	0	160964	0	861467	40165015		
20298	442	40213198	2013-06-15	2013-06-15 00:00:00	2013-06-15	2013-06-15 00:00:00	2013-06-15	581452		0	0	0		0	0	0	29321	0	133	40213198		
44163	3655	1713671	1972-01-20	1972-01-20 00:00:00	1972-01-27	1972-01-27 00:00:00	1972-01-27	38000177		0	0	7		0	0	0	243264	0	562251	1713671		
39884	3300	920300	2018-09-12	2018-09-12 00:00:00	2018-09-19	2018-09-19 00:00:00	2018-09-19	38000177		0	0	7		0	0	0	219221	0	311989	920300		
107609	2358	40213296	2011-09-13	2011-09-13 00:00:00	2011-09-13	2011-09-13 00:00:00	2011-09-13	581452		0	0	0		0	0	0	157162	0	52	40213296		
36487	3010	19133905	1984-07-24	1984-07-24 00:00:00	1984-08-06	1984-08-06 00:00:00	1984-08-06	38000177		0	0	13		0	0	0	200771	0	834102	19133905		
11370	948	19133905	1993-06-19	1993-06-19 00:00:00	1993-06-26	1993-06-26 00:00:00	1993-06-26	38000177		0	0	7		0	0	0	62954	0	834102	19133905		
25452	2091	1127433	2013-02-05	2013-02-05 00:00:00	2013-02-19	2013-02-19 00:00:00	2013-02-19	38000177		0	0	14		0	0	0	139437	0	313782	1127433		
54586	4534	19074679	1957-02-26	1957-02-26 00:00:00	1957-02-26	1957-02-26 00:00:00	\N	38000177		0	0	0		0	0	0	302075	0	308971	19074679		
21977	1804	19059056	1940-03-10	1940-03-10 00:00:00	1940-03-24	1940-03-24 00:00:00	1940-03-24	38000177		0	0	14		0	0	0	120886	0	243670	19059056		
12867	1082	43012036	1988-09-06	1988-09-06 00:00:00	1988-09-06	1988-09-06 00:00:00	\N	38000177		0	0	0		0	0	0	70905	0	1363309	43012036		
13289	1115	40229134	2010-10-11	2010-10-11 00:00:00	2010-10-18	2010-10-18 00:00:00	2010-10-18	38000177		0	0	7		0	0	0	73488	0	1043400	40229134		
8470	182	40213227	2011-11-20	2011-11-20 00:00:00	2011-11-20	2011-11-20 00:00:00	2011-11-20	581452		0	0	0		0	0	0	12323	0	113	40213227		
2641	211	40229134	2006-11-25	2006-11-25 00:00:00	2006-12-09	2006-12-09 00:00:00	2006-12-09	38000177		0	0	14		0	0	0	14354	0	1043400	40229134		
106176	2328	40213227	1997-01-20	1997-01-20 00:00:00	1997-01-20	1997-01-20 00:00:00	1997-01-20	581452		0	0	0		0	0	0	154841	0	113	40213227		
13220	1108	1127433	2014-09-05	2014-09-05 00:00:00	2014-09-19	2014-09-19 00:00:00	2014-09-19	38000177		0	0	14		0	0	0	72944	0	313782	1127433		
42944	3560	1127433	1980-06-12	1980-06-12 00:00:00	1980-06-19	1980-06-19 00:00:00	1980-06-19	38000177		0	0	7		0	0	0	236353	0	313782	1127433		
60050	4990	40236824	1981-02-16	1981-02-16 00:00:00	1981-02-23	1981-02-23 00:00:00	1981-02-23	38000177		0	0	7		0	0	0	331931	0	1094107	40236824		
43306	3589	19059056	1983-11-14	1983-11-14 00:00:00	1984-01-13	1984-01-13 00:00:00	1984-01-13	38000177		0	0	60		0	0	0	238447	0	243670	19059056		
53823	4474	40229134	1966-10-04	1966-10-04 00:00:00	1966-10-18	1966-10-18 00:00:00	1966-10-18	38000177		0	0	14		0	0	0	297670	0	1043400	40229134		
222462	4883	40213227	1997-06-27	1997-06-27 00:00:00	1997-06-27	1997-06-27 00:00:00	1997-06-27	581452		0	0	0		0	0	0	324671	0	113	40213227		
56751	1242	40213296	2001-03-21	2001-03-21 00:00:00	2001-03-21	2001-03-21 00:00:00	2001-03-21	581452		0	0	0		0	0	0	81818	0	52	40213296		
38373	3174	1115171	2000-01-02	2000-01-02 00:00:00	2000-02-06	2000-02-06 00:00:00	2000-02-06	38000177		0	0	35		0	0	0	210955	0	849574	1115171		
10017	841	1713671	2018-03-16	2018-03-16 00:00:00	2018-03-23	2018-03-23 00:00:00	2018-03-23	38000177		0	0	7		0	0	0	55549	0	562251	1713671		
236651	5196	40213160	1955-07-08	1955-07-08 00:00:00	1955-07-08	1955-07-08 00:00:00	1955-07-08	581452		0	0	0		0	0	0	345525	0	10	40213160		
236690	5197	40213160	1958-03-25	1958-03-25 00:00:00	1958-03-25	1958-03-25 00:00:00	1958-03-25	581452		0	0	0		0	0	0	345648	0	10	40213160		
48235	3998	1127433	1978-10-25	1978-10-25 00:00:00	1978-11-08	1978-11-08 00:00:00	1978-11-08	38000177		0	0	14		0	0	0	265791	0	313782	1127433		
27390	2266	19059056	1993-03-29	1993-03-29 00:00:00	1993-04-19	1993-04-19 00:00:00	1993-04-19	38000177		0	0	21		0	0	0	150636	0	243670	19059056		
3103	254	40229134	1953-07-09	1953-07-09 00:00:00	1953-07-16	1953-07-16 00:00:00	1953-07-16	38000177		0	0	7		0	0	0	16920	0	1043400	40229134		
18284	1513	1127078	1969-12-17	1969-12-17 00:00:00	1969-12-31	1969-12-31 00:00:00	1969-12-31	38000177		0	0	14		0	0	0	101028	0	282464	1127078		
13651	1143	1127078	1980-11-20	1980-11-20 00:00:00	1980-12-11	1980-12-11 00:00:00	1980-12-11	38000177		0	0	21		0	0	0	75456	0	282464	1127078		
27492	2277	19059056	1987-07-12	1987-07-12 00:00:00	1987-08-02	1987-08-02 00:00:00	1987-08-02	38000177		0	0	21		0	0	0	151385	0	243670	19059056		
73079	1597	40213198	2010-10-30	2010-10-30 00:00:00	2010-10-30	2010-10-30 00:00:00	2010-10-30	581452		0	0	0		0	0	0	107128	0	133	40213198		
45765	3788	19133905	1997-11-24	1997-11-24 00:00:00	1997-12-07	1997-12-07 00:00:00	1997-12-07	38000177		0	0	13		0	0	0	251820	0	834102	19133905		
48634	4027	1127433	1994-04-30	1994-04-30 00:00:00	1994-05-07	1994-05-07 00:00:00	1994-05-07	38000177		0	0	7		0	0	0	267853	0	313782	1127433		
165278	3633	40213306	1994-08-07	1994-08-07 00:00:00	1994-08-07	1994-08-07 00:00:00	1994-08-07	581452		0	0	0		0	0	0	241642	0	43	40213306		
30464	664	40213251	1986-06-19	1986-06-19 00:00:00	1986-06-19	1986-06-19 00:00:00	1986-06-19	581452		0	0	0		0	0	0	43851	0	21	40213251		
56416	4680	1127433	1933-01-13	1933-01-13 00:00:00	1933-01-20	1933-01-20 00:00:00	1933-01-20	38000177		0	0	7		0	0	0	311878	0	313782	1127433		
39589	864	40213201	1988-09-26	1988-09-26 00:00:00	1988-09-26	1988-09-26 00:00:00	1988-09-26	581452		0	0	0		0	0	0	57349	0	33	40213201		
10192	855	1127433	1968-12-22	1968-12-22 00:00:00	1968-12-29	1968-12-29 00:00:00	1968-12-29	38000177		0	0	7		0	0	0	56479	0	313782	1127433		
193668	4255	40213160	1973-08-04	1973-08-04 00:00:00	1973-08-04	1973-08-04 00:00:00	1973-08-04	581452		0	0	0		0	0	0	282556	0	10	40213160		
32109	700	40213160	1979-02-21	1979-02-21 00:00:00	1979-02-21	1979-02-21 00:00:00	1979-02-21	581452		0	0	0		0	0	0	46265	0	10	40213160		
12465	1051	1127433	1982-02-12	1982-02-12 00:00:00	1982-02-19	1982-02-19 00:00:00	1982-02-19	38000177		0	0	7		0	0	0	68875	0	313782	1127433		
24840	2041	1127433	1994-04-28	1994-04-28 00:00:00	1994-06-02	1994-06-02 00:00:00	1994-06-02	38000177		0	0	35		0	0	0	135856	0	313782	1127433		
48471	4017	40220960	2014-08-07	2014-08-07 00:00:00	2014-08-07	2014-08-07 00:00:00	2014-08-07	38000177		0	0	0		0	0	0	267006	0	1804799	40220960		
34219	2827	19059056	1936-11-04	1936-11-04 00:00:00	1936-12-02	1936-12-02 00:00:00	1936-12-02	38000177		0	0	28		0	0	0	187509	0	243670	19059056		
69946	1529	40213227	1993-10-11	1993-10-11 00:00:00	1993-10-11	1993-10-11 00:00:00	1993-10-11	581452		0	0	0		0	0	0	102334	0	113	40213227		
34331	2835	1713671	1949-09-02	1949-09-02 00:00:00	1949-09-23	1949-09-23 00:00:00	1949-09-23	38000177		0	0	21		0	0	0	188351	0	562251	1713671		
46006	3811	19133905	1994-03-31	1994-03-31 00:00:00	1994-04-09	1994-04-09 00:00:00	1994-04-09	38000177		0	0	9		0	0	0	253221	0	834102	19133905		
36644	3025	1127433	2001-01-14	2001-01-14 00:00:00	2001-01-21	2001-01-21 00:00:00	2001-01-21	38000177		0	0	7		0	0	0	201620	0	313782	1127433		
30715	2545	1118084	1987-01-02	1987-01-02 00:00:00	1987-01-02	1987-01-02 00:00:00	\N	38000177		0	0	0		0	0	0	168386	0	00025152531	44923712		
64364	5343	40229134	1998-01-04	1998-01-04 00:00:00	1998-01-11	1998-01-11 00:00:00	1998-01-11	38000177		0	0	7		0	0	0	355911	0	1043400	40229134		
28701	2367	1127433	1999-09-04	1999-09-04 00:00:00	1999-09-18	1999-09-18 00:00:00	1999-09-18	38000177		0	0	14		0	0	0	157576	0	313782	1127433		
1749	140	40224805	1996-03-25	1996-03-25 00:00:00	1997-03-20	1997-03-20 00:00:00	1997-03-20	38000177		0	0	360		0	0	0	9411	0	1000126	40224805		
1467	116	19059056	1929-05-08	1929-05-08 00:00:00	1929-05-22	1929-05-22 00:00:00	1929-05-22	38000177		0	0	14		0	0	0	7725	0	243670	19059056		
44425	3678	19078461	1988-12-24	1988-12-24 00:00:00	1989-01-07	1989-01-07 00:00:00	1989-01-07	38000177		0	0	14		0	0	0	244591	0	310965	19078461		
41457	3436	19078461	1976-04-23	1976-04-23 00:00:00	1976-05-21	1976-05-21 00:00:00	1976-05-21	38000177		0	0	28		0	0	0	227854	0	310965	19078461		
180743	3972	40213227	2001-02-04	2001-02-04 00:00:00	2001-02-04	2001-02-04 00:00:00	2001-02-04	581452		0	0	0		0	0	0	264130	0	113	40213227		
33106	723	40213296	2003-11-20	2003-11-20 00:00:00	2003-11-20	2003-11-20 00:00:00	2003-11-20	581452		0	0	0		0	0	0	47842	0	52	40213296		
151591	3335	40213296	2014-04-06	2014-04-06 00:00:00	2014-04-06	2014-04-06 00:00:00	2014-04-06	581452		0	0	0		0	0	0	221236	0	52	40213296		
18646	1540	19075601	2018-12-10	2018-12-10 00:00:00	2018-12-10	2018-12-10 00:00:00	2018-12-10	38000177		0	0	0		0	0	0	103181	0	309362	19075601		
60464	5031	1127433	1943-08-05	1943-08-05 00:00:00	1943-08-19	1943-08-19 00:00:00	1943-08-19	38000177		0	0	14		0	0	0	334326	0	313782	1127433		
57444	1257	40213160	1973-07-07	1973-07-07 00:00:00	1973-07-07	1973-07-07 00:00:00	1973-07-07	581452		0	0	0		0	0	0	82790	0	10	40213160		
22847	1879	19133873	1968-09-11	1968-09-11 00:00:00	1968-09-23	1968-09-23 00:00:00	1968-09-23	38000177		0	0	12		0	0	0	125358	0	834061	19133873		
29319	2427	19074841	1985-10-24	1985-10-24 00:00:00	1985-11-07	1985-11-07 00:00:00	1985-11-07	38000177		0	0	14		0	0	0	160981	0	309043	19074841		
8957	191	40213201	1986-09-02	1986-09-02 00:00:00	1986-09-02	1986-09-02 00:00:00	1986-09-02	581452		0	0	0		0	0	0	13124	0	33	40213201		
44164	3655	1127433	1997-08-04	1997-08-04 00:00:00	1997-08-25	1997-08-25 00:00:00	1997-08-25	38000177		0	0	21		0	0	0	243259	0	313782	1127433		
39885	3300	40169216	1985-08-11	1985-08-11 00:00:00	1985-08-11	1985-08-11 00:00:00	\N	38000177		0	0	0		0	0	0	219236	0	895994	40169216		
107612	2358	40213227	2003-06-10	2003-06-10 00:00:00	2003-06-10	2003-06-10 00:00:00	2003-06-10	581452		0	0	0		0	0	0	157160	0	113	40213227		
36488	3010	1127433	2008-09-30	2008-09-30 00:00:00	2008-10-07	2008-10-07 00:00:00	2008-10-07	38000177		0	0	7		0	0	0	200784	0	313782	1127433		
11371	948	1127078	1964-05-13	1964-05-13 00:00:00	1964-05-27	1964-05-27 00:00:00	1964-05-27	38000177		0	0	14		0	0	0	62922	0	282464	1127078		
25453	2091	1713671	1968-10-04	1968-10-04 00:00:00	1968-10-18	1968-10-18 00:00:00	1968-10-18	38000177		0	0	14		0	0	0	139474	0	562251	1713671		
54587	4534	1545959	2011-11-30	2011-11-30 00:00:00	2011-11-30	2011-11-30 00:00:00	2011-11-30	38000177		0	0	0		0	0	0	302079	0	259255	1545959		
21978	1804	40229134	1981-09-14	1981-09-14 00:00:00	1981-09-21	1981-09-21 00:00:00	1981-09-21	38000177		0	0	7		0	0	0	120893	0	1043400	40229134		
12868	1082	1118084	1989-09-30	1989-09-30 00:00:00	1989-09-30	1989-09-30 00:00:00	\N	38000177		0	0	0		0	0	0	70905	0	00025152531	44923712		
13291	1115	40232448	1950-07-26	1950-07-26 00:00:00	1950-07-26	1950-07-26 00:00:00	\N	38000177		0	0	0		0	0	0	73343	0	1049630	40232448		
8478	182	40213227	1992-09-20	1992-09-20 00:00:00	1992-09-20	1992-09-20 00:00:00	1992-09-20	581452		0	0	0		0	0	0	12285	0	113	40213227		
2643	212	1115171	2011-01-20	2011-01-20 00:00:00	2011-02-03	2011-02-03 00:00:00	2011-02-03	38000177		0	0	14		0	0	0	14439	0	849574	1115171		
106177	2328	40213296	1997-01-20	1997-01-20 00:00:00	1997-01-20	1997-01-20 00:00:00	1997-01-20	581452		0	0	0		0	0	0	154841	0	52	40213296		
13221	1108	1127433	1978-06-14	1978-06-14 00:00:00	1978-06-28	1978-06-28 00:00:00	1978-06-28	38000177		0	0	14		0	0	0	72945	0	313782	1127433		
42945	3560	1127433	2017-04-10	2017-04-10 00:00:00	2017-05-01	2017-05-01 00:00:00	2017-05-01	38000177		0	0	21		0	0	0	236410	0	313782	1127433		
60051	4990	920300	1981-02-16	1981-02-16 00:00:00	1981-02-23	1981-02-23 00:00:00	1981-02-23	38000177		0	0	7		0	0	0	331931	0	311989	920300		
43307	3589	1127433	2007-03-16	2007-03-16 00:00:00	2007-03-30	2007-03-30 00:00:00	2007-03-30	38000177		0	0	14		0	0	0	238459	0	313782	1127433		
53824	4474	19078461	2002-05-18	2002-05-18 00:00:00	2002-06-08	2002-06-08 00:00:00	2002-06-08	38000177		0	0	21		0	0	0	297691	0	310965	19078461		
37744	823	40213201	2010-12-20	2010-12-20 00:00:00	2010-12-20	2010-12-20 00:00:00	2010-12-20	581452		0	0	0		0	0	0	54570	0	33	40213201		
56754	1242	40213160	1964-02-19	1964-02-19 00:00:00	1964-02-19	1964-02-19 00:00:00	1964-02-19	581452		0	0	0		0	0	0	81772	0	10	40213160		
38374	3174	19128022	1996-11-28	1996-11-28 00:00:00	1997-11-23	1997-11-23 00:00:00	1997-11-23	38000177		0	0	360		0	0	0	210944	0	749785	19128022		
10018	841	19008572	1966-08-24	1966-08-24 00:00:00	1966-09-14	1966-09-14 00:00:00	1966-09-14	38000177		0	0	21		0	0	0	55521	0	106258	19008572		
7255	608	19126352	2005-07-27	2005-07-27 00:00:00	2005-07-27	2005-07-27 00:00:00	\N	38000177		0	0	0		0	0	0	40358	0	705129	19126352		
236696	5197	40213160	1955-03-22	1955-03-22 00:00:00	1955-03-22	1955-03-22 00:00:00	1955-03-22	581452		0	0	0		0	0	0	345646	0	10	40213160		
48236	3998	1713671	1999-12-19	1999-12-19 00:00:00	2000-01-09	2000-01-09 00:00:00	2000-01-09	38000177		0	0	21		0	0	0	265860	0	562251	1713671		
37849	3128	19128022	1994-06-14	1994-06-14 00:00:00	1995-06-09	1995-06-09 00:00:00	1995-06-09	38000177		0	0	360		0	0	0	208176	0	749785	19128022		
3104	254	1127433	1988-05-28	1988-05-28 00:00:00	1988-06-04	1988-06-04 00:00:00	1988-06-04	38000177		0	0	7		0	0	0	16907	0	313782	1127433		
18285	1513	46233988	1969-12-17	1969-12-17 00:00:00	1969-12-31	1969-12-31 00:00:00	1969-12-31	38000177		0	0	14		0	0	0	101028	0	1652673	46233988		
13652	1143	1118084	2015-04-07	2015-04-07 00:00:00	2015-04-07	2015-04-07 00:00:00	\N	38000177		0	0	0		0	0	0	75464	0	00025152531	44923712		
13683	1145	19133873	1940-12-10	1940-12-10 00:00:00	1940-12-23	1940-12-23 00:00:00	1940-12-23	38000177		0	0	13		0	0	0	75561	0	834061	19133873		
73087	1597	40213227	2015-11-28	2015-11-28 00:00:00	2015-11-28	2015-11-28 00:00:00	2015-11-28	581452		0	0	0		0	0	0	107199	0	113	40213227		
45766	3788	19059056	1967-08-26	1967-08-26 00:00:00	1967-09-25	1967-09-25 00:00:00	1967-09-25	38000177		0	0	30		0	0	0	251800	0	243670	19059056		
48635	4027	19019979	1975-05-30	1975-05-30 00:00:00	1975-06-13	1975-06-13 00:00:00	1975-06-13	38000177		0	0	14		0	0	0	267828	0	198405	19019979		
27101	2235	1713671	1975-09-16	1975-09-16 00:00:00	1975-09-23	1975-09-23 00:00:00	1975-09-23	38000177		0	0	7		0	0	0	148657	0	562251	1713671		
30466	664	40213160	1986-06-19	1986-06-19 00:00:00	1986-06-19	1986-06-19 00:00:00	1986-06-19	581452		0	0	0		0	0	0	43851	0	10	40213160		
7471	624	1118084	1978-04-30	1978-04-30 00:00:00	1978-04-30	1978-04-30 00:00:00	\N	38000177		0	0	0		0	0	0	41721	0	00025152531	44923712		
154908	3409	40213227	2016-07-07	2016-07-07 00:00:00	2016-07-07	2016-07-07 00:00:00	2016-07-07	581452		0	0	0		0	0	0	226088	0	113	40213227		
10194	855	19059056	1958-03-18	1958-03-18 00:00:00	1958-04-01	1958-04-01 00:00:00	1958-04-01	38000177		0	0	14		0	0	0	56503	0	243670	19059056		
193673	4255	40213160	1974-01-05	1974-01-05 00:00:00	1974-01-05	1974-01-05 00:00:00	1974-01-05	581452		0	0	0		0	0	0	282557	0	10	40213160		
32113	700	40213227	2012-05-23	2012-05-23 00:00:00	2012-05-23	2012-05-23 00:00:00	2012-05-23	581452		0	0	0		0	0	0	46261	0	113	40213227		
12467	1051	40229134	2010-03-11	2010-03-11 00:00:00	2010-03-25	2010-03-25 00:00:00	2010-03-25	38000177		0	0	14		0	0	0	68943	0	1043400	40229134		
24841	2041	19019979	1974-09-21	1974-09-21 00:00:00	1974-10-19	1974-10-19 00:00:00	1974-10-19	38000177		0	0	28		0	0	0	135854	0	198405	19019979		
48472	4017	19059056	1937-04-08	1937-04-08 00:00:00	1937-05-08	1937-05-08 00:00:00	1937-05-08	38000177		0	0	30		0	0	0	267030	0	243670	19059056		
34220	2827	19059056	1924-02-11	1924-02-11 00:00:00	1924-02-25	1924-02-25 00:00:00	1924-02-25	38000177		0	0	14		0	0	0	187519	0	243670	19059056		
69951	1529	40213306	1984-09-03	1984-09-03 00:00:00	1984-09-03	1984-09-03 00:00:00	1984-09-03	581452		0	0	0		0	0	0	102342	0	43	40213306		
34332	2835	19078461	2012-01-31	2012-01-31 00:00:00	2012-03-31	2012-03-31 00:00:00	2012-03-31	38000177		0	0	60		0	0	0	188346	0	310965	19078461		
46007	3811	40173590	2000-08-24	2000-08-24 00:00:00	2000-08-24	2000-08-24 00:00:00	\N	38000177		0	0	0		0	0	0	253235	0	904419	40173590		
36645	3025	19059056	1948-08-26	1948-08-26 00:00:00	1948-09-09	1948-09-09 00:00:00	1948-09-09	38000177		0	0	14		0	0	0	201677	0	243670	19059056		
30716	2545	1713671	1984-02-10	1984-02-10 00:00:00	1984-02-24	1984-02-24 00:00:00	1984-02-24	38000177		0	0	14		0	0	0	168431	0	562251	1713671		
64365	5343	19128065	1997-12-24	1997-12-24 00:00:00	1998-12-19	1998-12-19 00:00:00	1998-12-19	38000177		0	0	360		0	0	0	355938	0	749882	19128065		
28702	2367	1127433	1978-03-14	1978-03-14 00:00:00	1978-03-21	1978-03-21 00:00:00	1978-03-21	38000177		0	0	7		0	0	0	157575	0	313782	1127433		
1750	140	1127433	1992-03-25	1992-03-25 00:00:00	1992-04-22	1992-04-22 00:00:00	1992-04-22	38000177		0	0	28		0	0	0	9417	0	313782	1127433		
1468	116	19133905	2004-10-03	2004-10-03 00:00:00	2004-10-14	2004-10-14 00:00:00	2004-10-14	38000177		0	0	11		0	0	0	7723	0	834102	19133905		
44426	3678	19019979	1986-08-19	1986-08-19 00:00:00	1986-09-02	1986-09-02 00:00:00	1986-09-02	38000177		0	0	14		0	0	0	244590	0	198405	19019979		
41458	3436	1124300	2003-02-20	2003-02-20 00:00:00	2003-02-20	2003-02-20 00:00:00	\N	38000177		0	0	0		0	0	0	227918	0	00781178901	45011828		
180744	3972	40213296	2001-02-04	2001-02-04 00:00:00	2001-02-04	2001-02-04 00:00:00	2001-02-04	581452		0	0	0		0	0	0	264130	0	52	40213296		
39316	859	40213160	1962-02-12	1962-02-12 00:00:00	1962-02-12	1962-02-12 00:00:00	1962-02-12	581452		0	0	0		0	0	0	56764	0	10	40213160		
151606	3335	40213160	1972-12-03	1972-12-03 00:00:00	1972-12-03	1972-12-03 00:00:00	1972-12-03	581452		0	0	0		0	0	0	221227	0	10	40213160		
18647	1540	1127433	1971-11-11	1971-11-11 00:00:00	1971-11-18	1971-11-18 00:00:00	1971-11-18	38000177		0	0	7		0	0	0	103156	0	313782	1127433		
60465	5031	1115171	2009-08-28	2009-08-28 00:00:00	2009-09-11	2009-09-11 00:00:00	2009-09-11	38000177		0	0	14		0	0	0	334283	0	849574	1115171		
57450	1257	40213227	2004-08-07	2004-08-07 00:00:00	2004-08-07	2004-08-07 00:00:00	2004-08-07	581452		0	0	0		0	0	0	82815	0	113	40213227		
22848	1879	19078461	1982-01-01	1982-01-01 00:00:00	1982-01-29	1982-01-29 00:00:00	1982-01-29	38000177		0	0	28		0	0	0	125367	0	310965	19078461		
29320	2427	1127433	1985-10-24	1985-10-24 00:00:00	1985-11-07	1985-11-07 00:00:00	1985-11-07	38000177		0	0	14		0	0	0	160981	0	313782	1127433		
15841	1316	1713671	1958-07-14	1958-07-14 00:00:00	1958-08-04	1958-08-04 00:00:00	1958-08-04	38000177		0	0	21		0	0	0	87154	0	562251	1713671		
44165	3655	40220960	2001-12-13	2001-12-13 00:00:00	2001-12-13	2001-12-13 00:00:00	2001-12-13	38000177		0	0	0		0	0	0	243245	0	1804799	40220960		
39886	3300	1154615	1985-08-11	1985-08-11 00:00:00	1985-08-11	1985-08-11 00:00:00	\N	38000177		0	0	0		0	0	0	219236	0	745679	1154615		
107614	2358	40213160	1976-05-18	1976-05-18 00:00:00	1976-05-18	1976-05-18 00:00:00	1976-05-18	581452		0	0	0		0	0	0	157118	0	10	40213160		
36489	3010	1115171	1996-08-13	1996-08-13 00:00:00	1996-09-10	1996-09-10 00:00:00	1996-09-10	38000177		0	0	28		0	0	0	200800	0	849574	1115171		
11372	948	19006318	1964-05-13	1964-05-13 00:00:00	1964-05-27	1964-05-27 00:00:00	1964-05-27	38000177		0	0	14		0	0	0	62922	0	105078	19006318		
25454	2091	1127433	1995-12-27	1995-12-27 00:00:00	1996-01-10	1996-01-10 00:00:00	1996-01-10	38000177		0	0	14		0	0	0	139476	0	313782	1127433		
54588	4534	19133768	2011-11-30	2011-11-30 00:00:00	2011-11-30	2011-11-30 00:00:00	2011-11-30	38000177		0	0	0		0	0	0	302079	0	833036	19133768		
21979	1804	19133873	1945-02-08	1945-02-08 00:00:00	1945-02-19	1945-02-19 00:00:00	1945-02-19	38000177		0	0	11		0	0	0	120827	0	834061	19133873		
12870	1082	1127433	1962-10-24	1962-10-24 00:00:00	1962-11-07	1962-11-07 00:00:00	1962-11-07	38000177		0	0	14		0	0	0	70940	0	313782	1127433		
13292	1115	1713671	1988-02-11	1988-02-11 00:00:00	1988-02-25	1988-02-25 00:00:00	1988-02-25	38000177		0	0	14		0	0	0	73454	0	562251	1713671		
8481	182	40213160	1955-08-21	1955-08-21 00:00:00	1955-08-21	1955-08-21 00:00:00	1955-08-21	581452		0	0	0		0	0	0	12294	0	10	40213160		
2644	212	19115351	2014-08-16	2014-08-16 00:00:00	2015-05-02	2015-05-02 00:00:00	2015-05-02	38000177		0	0	259		0	0	0	14476	0	563026	19115351		
106183	2329	40213160	1975-12-23	1975-12-23 00:00:00	1975-12-23	1975-12-23 00:00:00	1975-12-23	581452		0	0	0		0	0	0	154951	0	10	40213160		
13222	1108	1115171	2008-07-24	2008-07-24 00:00:00	2008-08-14	2008-08-14 00:00:00	2008-08-14	38000177		0	0	21		0	0	0	72947	0	849574	1115171		
42946	3560	1127433	1987-02-26	1987-02-26 00:00:00	1987-03-19	1987-03-19 00:00:00	1987-03-19	38000177		0	0	21		0	0	0	236412	0	313782	1127433		
60052	4990	1127078	1974-01-21	1974-01-21 00:00:00	1974-04-21	1974-04-21 00:00:00	1974-04-21	38000177		0	0	90		0	0	0	331969	0	282464	1127078		
43308	3589	1551192	1998-03-31	1998-03-31 00:00:00	1998-03-31	1998-03-31 00:00:00	1998-03-31	38000177		0	0	0		0	0	0	238448	0	312617	1551192		
53825	4474	1118084	1998-12-15	1998-12-15 00:00:00	1998-12-15	1998-12-15 00:00:00	\N	38000177		0	0	0		0	0	0	297654	0	00025152531	44923712		
37745	823	40213198	2010-12-20	2010-12-20 00:00:00	2010-12-20	2010-12-20 00:00:00	2010-12-20	581452		0	0	0		0	0	0	54570	0	133	40213198		
56757	1242	40213160	1959-11-18	1959-11-18 00:00:00	1959-11-18	1959-11-18 00:00:00	1959-11-18	581452		0	0	0		0	0	0	81828	0	10	40213160		
38375	3174	40224805	1997-11-23	1997-11-23 00:00:00	1998-11-18	1998-11-18 00:00:00	1998-11-18	38000177		0	0	360		0	0	0	210980	0	1000126	40224805		
10019	841	1127433	1972-11-26	1972-11-26 00:00:00	1972-12-17	1972-12-17 00:00:00	1972-12-17	38000177		0	0	21		0	0	0	55570	0	313782	1127433		
7256	608	19075601	2005-07-27	2005-07-27 00:00:00	2005-07-27	2005-07-27 00:00:00	\N	38000177		0	0	0		0	0	0	40358	0	309362	19075601		
7169	155	40213160	1955-01-14	1955-01-14 00:00:00	1955-01-14	1955-01-14 00:00:00	1955-01-14	581452		0	0	0		0	0	0	10541	0	10	40213160		
48237	3998	19059056	1953-06-10	1953-06-10 00:00:00	1953-06-24	1953-06-24 00:00:00	1953-06-24	38000177		0	0	14		0	0	0	265777	0	243670	19059056		
37850	3128	1713671	1990-05-11	1990-05-11 00:00:00	1990-06-01	1990-06-01 00:00:00	1990-06-01	38000177		0	0	21		0	0	0	208219	0	562251	1713671		
3105	254	19075601	2006-05-05	2006-05-05 00:00:00	2006-05-05	2006-05-05 00:00:00	2006-05-05	38000177		0	0	0		0	0	0	16975	0	309362	19075601		
18286	1513	19115351	1983-03-27	1983-03-27 00:00:00	1983-03-27	1983-03-27 00:00:00	\N	38000177		0	0	0		0	0	0	101091	0	563026	19115351		
13653	1143	1127433	2012-12-02	2012-12-02 00:00:00	2012-12-16	2012-12-16 00:00:00	2012-12-16	38000177		0	0	14		0	0	0	75449	0	313782	1127433		
13684	1145	19059056	1941-04-21	1941-04-21 00:00:00	1941-05-05	1941-05-05 00:00:00	1941-05-05	38000177		0	0	14		0	0	0	75547	0	243670	19059056		
73096	1597	40213227	1995-08-05	1995-08-05 00:00:00	1995-08-05	1995-08-05 00:00:00	1995-08-05	581452		0	0	0		0	0	0	107111	0	113	40213227		
45767	3788	1127433	1968-12-19	1968-12-19 00:00:00	1968-12-26	1968-12-26 00:00:00	1968-12-26	38000177		0	0	7		0	0	0	251837	0	313782	1127433		
48636	4027	19006318	1975-05-30	1975-05-30 00:00:00	1975-06-13	1975-06-13 00:00:00	1975-06-13	38000177		0	0	14		0	0	0	267828	0	105078	19006318		
27102	2235	19133873	1963-12-05	1963-12-05 00:00:00	1963-12-17	1963-12-17 00:00:00	1963-12-17	38000177		0	0	12		0	0	0	148688	0	834061	19133873		
143716	3158	40213227	1992-11-12	1992-11-12 00:00:00	1992-11-12	1992-11-12 00:00:00	1992-11-12	581452		0	0	0		0	0	0	210002	0	113	40213227		
7472	624	1127433	2019-05-27	2019-05-27 00:00:00	2019-05-27	2019-05-27 00:00:00	\N	38000177		0	0	0		0	0	0	41697	0	313782	1127433		
154914	3409	40213160	1956-01-05	1956-01-05 00:00:00	1956-01-05	1956-01-05 00:00:00	1956-01-05	581452		0	0	0		0	0	0	226110	0	10	40213160		
10195	855	19006318	1958-03-18	1958-03-18 00:00:00	1958-04-01	1958-04-01 00:00:00	1958-04-01	38000177		0	0	14		0	0	0	56503	0	105078	19006318		
204964	4498	40213314	1978-08-01	1978-08-01 00:00:00	1978-08-01	1978-08-01 00:00:00	1978-08-01	581452		0	0	0		0	0	0	299442	0	49	40213314		
32116	700	40213160	1983-05-25	1983-05-25 00:00:00	1983-05-25	1983-05-25 00:00:00	1983-05-25	581452		0	0	0		0	0	0	46248	0	10	40213160		
12468	1051	40236824	2000-03-14	2000-03-14 00:00:00	2000-03-28	2000-03-28 00:00:00	2000-03-28	38000177		0	0	14		0	0	0	68885	0	1094107	40236824		
24844	2043	19059056	1973-01-09	1973-01-09 00:00:00	1973-02-08	1973-02-08 00:00:00	1973-02-08	38000177		0	0	30		0	0	0	135903	0	243670	19059056		
53189	4418	1127433	1968-11-25	1968-11-25 00:00:00	1968-12-09	1968-12-09 00:00:00	1968-12-09	38000177		0	0	14		0	0	0	293781	0	313782	1127433		
34221	2827	1127433	1971-01-22	1971-01-22 00:00:00	1971-01-29	1971-01-29 00:00:00	1971-01-29	38000177		0	0	7		0	0	0	187446	0	313782	1127433		
148174	3258	40213314	1981-09-09	1981-09-09 00:00:00	1981-09-09	1981-09-09 00:00:00	1981-09-09	581452		0	0	0		0	0	0	216569	0	49	40213314		
34333	2836	19133873	1985-08-09	1985-08-09 00:00:00	1985-08-22	1985-08-22 00:00:00	1985-08-22	38000177		0	0	13		0	0	0	188386	0	834061	19133873		
46008	3811	19133905	2008-04-13	2008-04-13 00:00:00	2008-04-22	2008-04-22 00:00:00	2008-04-22	38000177		0	0	9		0	0	0	253184	0	834102	19133905		
36646	3025	19006318	1948-08-26	1948-08-26 00:00:00	1948-09-09	1948-09-09 00:00:00	1948-09-09	38000177		0	0	14		0	0	0	201677	0	105078	19006318		
30718	2546	40236824	1993-04-26	1993-04-26 00:00:00	1993-05-03	1993-05-03 00:00:00	1993-05-03	38000177		0	0	7		0	0	0	168520	0	1094107	40236824		
64366	5343	19019979	1986-02-15	1986-02-15 00:00:00	1986-03-01	1986-03-01 00:00:00	1986-03-01	38000177		0	0	14		0	0	0	355837	0	198405	19019979		
28703	2367	1127433	1990-01-06	1990-01-06 00:00:00	1990-01-27	1990-01-27 00:00:00	1990-01-27	38000177		0	0	21		0	0	0	157574	0	313782	1127433		
1751	140	1124300	2003-11-14	2003-11-14 00:00:00	2003-11-14	2003-11-14 00:00:00	\N	38000177		0	0	0		0	0	0	9338	0	00781178901	45011828		
1469	116	1127433	1994-11-27	1994-11-27 00:00:00	1994-12-11	1994-12-11 00:00:00	1994-12-11	38000177		0	0	14		0	0	0	7657	0	313782	1127433		
44427	3678	19073183	1986-08-19	1986-08-19 00:00:00	1986-09-02	1986-09-02 00:00:00	1986-09-02	38000177		0	0	14		0	0	0	244590	0	308182	19073183		
4489	372	1713671	1969-10-05	1969-10-05 00:00:00	1969-10-19	1969-10-19 00:00:00	1969-10-19	38000177		0	0	14		0	0	0	24754	0	562251	1713671		
180746	3972	40213227	2010-01-17	2010-01-17 00:00:00	2010-01-17	2010-01-17 00:00:00	2010-01-17	581452		0	0	0		0	0	0	264138	0	113	40213227		
39322	859	40213160	1957-08-12	1957-08-12 00:00:00	1957-08-12	1957-08-12 00:00:00	1957-08-12	581452		0	0	0		0	0	0	56748	0	10	40213160		
151609	3335	40213160	1976-11-21	1976-11-21 00:00:00	1976-11-21	1976-11-21 00:00:00	1976-11-21	581452		0	0	0		0	0	0	221231	0	10	40213160		
18648	1540	1713671	2009-05-27	2009-05-27 00:00:00	2009-06-17	2009-06-17 00:00:00	2009-06-17	38000177		0	0	21		0	0	0	103171	0	562251	1713671		
60466	5031	19074679	1941-02-01	1941-02-01 00:00:00	1941-02-01	1941-02-01 00:00:00	\N	38000177		0	0	0		0	0	0	334343	0	308971	19074679		
57451	1257	40213227	2014-11-08	2014-11-08 00:00:00	2014-11-08	2014-11-08 00:00:00	2014-11-08	581452		0	0	0		0	0	0	82800	0	113	40213227		
22849	1879	19133905	2019-04-24	2019-04-24 00:00:00	2019-05-07	2019-05-07 00:00:00	2019-05-07	38000177		0	0	13		0	0	0	125403	0	834102	19133905		
29321	2427	1127433	1994-11-29	1994-11-29 00:00:00	1994-12-13	1994-12-13 00:00:00	1994-12-13	38000177		0	0	14		0	0	0	161037	0	313782	1127433		
15842	1316	1118084	1994-05-03	1994-05-03 00:00:00	1994-05-03	1994-05-03 00:00:00	\N	38000177		0	0	0		0	0	0	87201	0	00025152531	44923712		
44166	3655	19075601	2001-12-13	2001-12-13 00:00:00	2001-12-13	2001-12-13 00:00:00	2001-12-13	38000177		0	0	0		0	0	0	243245	0	309362	19075601		
39887	3300	43012754	1999-07-17	1999-07-17 00:00:00	2000-07-11	2000-07-11 00:00:00	2000-07-11	38000177		0	0	360		0	0	0	219223	0	1366343	43012754		
107617	2358	40213160	1972-02-15	1972-02-15 00:00:00	1972-02-15	1972-02-15 00:00:00	1972-02-15	581452		0	0	0		0	0	0	157155	0	10	40213160		
36490	3010	1127433	1989-05-22	1989-05-22 00:00:00	1989-07-21	1989-07-21 00:00:00	1989-07-21	38000177		0	0	60		0	0	0	200799	0	313782	1127433		
11373	948	1115171	2007-12-29	2007-12-29 00:00:00	2008-01-19	2008-01-19 00:00:00	2008-01-19	38000177		0	0	21		0	0	0	62965	0	849574	1115171		
25455	2091	1127433	1984-11-09	1984-11-09 00:00:00	1984-11-23	1984-11-23 00:00:00	1984-11-23	38000177		0	0	14		0	0	0	139475	0	313782	1127433		
54589	4534	19115351	1956-10-23	1956-10-23 00:00:00	1957-10-22	1957-10-22 00:00:00	1957-10-22	38000177		0	0	364		0	0	0	302074	0	563026	19115351		
21980	1804	19059056	1936-03-12	1936-03-12 00:00:00	1936-03-26	1936-03-26 00:00:00	1936-03-26	38000177		0	0	14		0	0	0	120885	0	243670	19059056		
12871	1082	19006318	1958-04-20	1958-04-20 00:00:00	1958-05-04	1958-05-04 00:00:00	1958-05-04	38000177		0	0	14		0	0	0	70926	0	105078	19006318		
13293	1115	40165015	2014-12-12	2014-12-12 00:00:00	2014-12-12	2014-12-12 00:00:00	\N	38000177		0	0	0		0	0	0	73390	0	861467	40165015		
12830	277	40213227	1995-12-05	1995-12-05 00:00:00	1995-12-05	1995-12-05 00:00:00	1995-12-05	581452		0	0	0		0	0	0	18461	0	113	40213227		
2645	212	19128065	1991-02-09	1991-02-09 00:00:00	1992-02-04	1992-02-04 00:00:00	1992-02-04	38000177		0	0	360		0	0	0	14430	0	749882	19128065		
120427	2647	40213160	1971-08-22	1971-08-22 00:00:00	1971-08-22	1971-08-22 00:00:00	1971-08-22	581452		0	0	0		0	0	0	175122	0	10	40213160		
13223	1108	1127433	2000-05-12	2000-05-12 00:00:00	2000-05-19	2000-05-19 00:00:00	2000-05-19	38000177		0	0	7		0	0	0	72985	0	313782	1127433		
42947	3560	1713671	1961-01-08	1961-01-08 00:00:00	1961-01-29	1961-01-29 00:00:00	1961-01-29	38000177		0	0	21		0	0	0	236350	0	562251	1713671		
60053	4991	19008572	1997-07-13	1997-07-13 00:00:00	1997-07-13	1997-07-13 00:00:00	\N	38000177		0	0	0		0	0	0	332032	0	106258	19008572		
43316	3592	1118084	2001-07-07	2001-07-07 00:00:00	2001-07-07	2001-07-07 00:00:00	\N	38000177		0	0	0		0	0	0	238627	0	00025152531	44923712		
53826	4474	40229134	2018-10-02	2018-10-02 00:00:00	2018-10-09	2018-10-09 00:00:00	2018-10-09	38000177		0	0	7		0	0	0	297681	0	1043400	40229134		
37747	823	40213227	2016-01-18	2016-01-18 00:00:00	2016-01-18	2016-01-18 00:00:00	2016-01-18	581452		0	0	0		0	0	0	54527	0	113	40213227		
56768	1242	40213260	2010-03-17	2010-03-17 00:00:00	2010-03-17	2010-03-17 00:00:00	2010-03-17	581452		0	0	0		0	0	0	81780	0	121	40213260		
38376	3174	40229134	1989-08-29	1989-08-29 00:00:00	1989-09-12	1989-09-12 00:00:00	1989-09-12	38000177		0	0	14		0	0	0	210975	0	1043400	40229134		
10020	841	46233710	1972-11-26	1972-11-26 00:00:00	1972-12-17	1972-12-17 00:00:00	1972-12-17	38000177		0	0	21		0	0	0	55570	0	1650142	46233710		
7257	608	1127078	1978-11-08	1978-11-08 00:00:00	1978-11-22	1978-11-22 00:00:00	1978-11-22	38000177		0	0	14		0	0	0	40405	0	282464	1127078		
7174	155	40213160	1955-04-15	1955-04-15 00:00:00	1955-04-15	1955-04-15 00:00:00	1955-04-15	581452		0	0	0		0	0	0	10524	0	10	40213160		
48238	3998	40229134	1964-02-15	1964-02-15 00:00:00	1964-02-22	1964-02-22 00:00:00	1964-02-22	38000177		0	0	7		0	0	0	265845	0	1043400	40229134		
37851	3128	1127078	1984-09-08	1984-09-08 00:00:00	1984-10-15	1984-10-15 00:00:00	1984-10-15	38000177		0	0	37		0	0	0	208164	0	282464	1127078		
3106	254	40220960	2006-05-05	2006-05-05 00:00:00	2006-05-05	2006-05-05 00:00:00	2006-05-05	38000177		0	0	0		0	0	0	16975	0	1804799	40220960		
18287	1513	19129655	1972-07-21	1972-07-21 00:00:00	1972-08-04	1972-08-04 00:00:00	1972-08-04	38000177		0	0	14		0	0	0	101085	0	789980	19129655		
13654	1143	40229134	1983-06-12	1983-06-12 00:00:00	1983-06-19	1983-06-19 00:00:00	1983-06-19	38000177		0	0	7		0	0	0	75441	0	1043400	40229134		
13685	1145	1713671	2016-09-29	2016-09-29 00:00:00	2017-03-30	2017-03-30 00:00:00	2017-03-30	38000177		0	0	182		0	0	0	75659	0	562251	1713671		
31165	2583	1127078	1971-07-10	1971-07-10 00:00:00	1971-10-08	1971-10-08 00:00:00	1971-10-08	38000177		0	0	90		0	0	0	171042	0	282464	1127078		
45768	3789	1127433	1950-09-02	1950-09-02 00:00:00	1950-09-09	1950-09-09 00:00:00	1950-09-09	38000177		0	0	7		0	0	0	251923	0	313782	1127433		
48637	4027	1124300	2008-04-16	2008-04-16 00:00:00	2008-04-16	2008-04-16 00:00:00	\N	38000177		0	0	0		0	0	0	267883	0	00781178901	45011828		
27103	2235	19006318	1960-02-16	1960-02-16 00:00:00	1960-03-01	1960-03-01 00:00:00	1960-03-01	38000177		0	0	14		0	0	0	148658	0	105078	19006318		
143723	3158	40213160	1955-08-18	1955-08-18 00:00:00	1955-08-18	1955-08-18 00:00:00	1955-08-18	581452		0	0	0		0	0	0	209923	0	10	40213160		
7473	624	1127433	1966-07-22	1966-07-22 00:00:00	1966-08-05	1966-08-05 00:00:00	1966-08-05	38000177		0	0	14		0	0	0	41621	0	313782	1127433		
154929	3410	40213296	2004-04-21	2004-04-21 00:00:00	2004-04-21	2004-04-21 00:00:00	2004-04-21	581452		0	0	0		0	0	0	226162	0	52	40213296		
10196	855	40229134	1980-10-08	1980-10-08 00:00:00	1980-10-22	1980-10-22 00:00:00	1980-10-22	38000177		0	0	14		0	0	0	56483	0	1043400	40229134		
1879	41	40213227	2006-02-11	2006-02-11 00:00:00	2006-02-11	2006-02-11 00:00:00	2006-02-11	581452		0	0	0		0	0	0	2975	0	113	40213227		
32117	700	40213314	1979-08-22	1979-08-22 00:00:00	1979-08-22	1979-08-22 00:00:00	1979-08-22	581452		0	0	0		0	0	0	46246	0	49	40213314		
12469	1051	920300	2000-03-14	2000-03-14 00:00:00	2000-03-21	2000-03-21 00:00:00	2000-03-21	38000177		0	0	7		0	0	0	68885	0	311989	920300		
24845	2043	1127433	1966-09-15	1966-09-15 00:00:00	1966-09-29	1966-09-29 00:00:00	1966-09-29	38000177		0	0	14		0	0	0	135927	0	313782	1127433		
53190	4418	19078461	2006-09-30	2006-09-30 00:00:00	2006-11-06	2006-11-06 00:00:00	2006-11-06	38000177		0	0	37		0	0	0	293748	0	310965	19078461		
34231	2829	1127433	1992-08-11	1992-08-11 00:00:00	1992-08-18	1992-08-18 00:00:00	1992-08-18	38000177		0	0	7		0	0	0	187661	0	313782	1127433		
148175	3258	40213160	1981-09-09	1981-09-09 00:00:00	1981-09-09	1981-09-09 00:00:00	1981-09-09	581452		0	0	0		0	0	0	216569	0	10	40213160		
34334	2836	1127078	1986-02-02	1986-02-02 00:00:00	1986-02-23	1986-02-23 00:00:00	1986-02-23	38000177		0	0	21		0	0	0	188373	0	282464	1127078		
46009	3811	19077572	2005-09-22	2005-09-22 00:00:00	2005-09-22	2005-09-22 00:00:00	\N	38000177		0	0	0		0	0	0	253126	0	310436	19077572		
36648	3025	19075601	1997-06-02	1997-06-02 00:00:00	2002-10-14	2002-10-14 00:00:00	2002-10-14	38000177		0	0	1960		0	0	0	201653	0	309362	19075601		
30719	2546	920300	1993-04-26	1993-04-26 00:00:00	1993-05-03	1993-05-03 00:00:00	1993-05-03	38000177		0	0	7		0	0	0	168520	0	311989	920300		
64367	5343	19073183	1986-02-15	1986-02-15 00:00:00	1986-03-01	1986-03-01 00:00:00	1986-03-01	38000177		0	0	14		0	0	0	355837	0	308182	19073183		
28704	2367	19059056	1975-04-27	1975-04-27 00:00:00	1975-05-11	1975-05-11 00:00:00	1975-05-11	38000177		0	0	14		0	0	0	157579	0	243670	19059056		
1752	140	19128022	1989-05-01	1989-05-01 00:00:00	1990-04-26	1990-04-26 00:00:00	1990-04-26	38000177		0	0	360		0	0	0	9381	0	749785	19128022		
1470	116	19059056	1927-07-05	1927-07-05 00:00:00	1927-07-19	1927-07-19 00:00:00	1927-07-19	38000177		0	0	14		0	0	0	7667	0	243670	19059056		
44428	3678	40229134	1985-09-23	1985-09-23 00:00:00	1985-09-30	1985-09-30 00:00:00	1985-09-30	38000177		0	0	7		0	0	0	244580	0	1043400	40229134		
4490	372	1150837	1985-05-29	1985-05-29 00:00:00	1985-05-29	1985-05-29 00:00:00	\N	38000177		0	0	0		0	0	0	24765	0	141918	1150837		
180747	3972	40213260	2010-01-17	2010-01-17 00:00:00	2010-01-17	2010-01-17 00:00:00	2010-01-17	581452		0	0	0		0	0	0	264138	0	121	40213260		
39324	859	40213160	1957-11-11	1957-11-11 00:00:00	1957-11-11	1957-11-11 00:00:00	1957-11-11	581452		0	0	0		0	0	0	56732	0	10	40213160		
151612	3335	40213227	2004-02-29	2004-02-29 00:00:00	2004-02-29	2004-02-29 00:00:00	2004-02-29	581452		0	0	0		0	0	0	221295	0	113	40213227		
18649	1540	19133905	1986-04-12	1986-04-12 00:00:00	1986-04-25	1986-04-25 00:00:00	1986-04-25	38000177		0	0	13		0	0	0	103217	0	834102	19133905		
60467	5031	19115351	1945-05-26	1945-05-26 00:00:00	1945-09-08	1945-09-08 00:00:00	1945-09-08	38000177		0	0	105		0	0	0	334310	0	563026	19115351		
57452	1257	40213296	2014-11-08	2014-11-08 00:00:00	2014-11-08	2014-11-08 00:00:00	2014-11-08	581452		0	0	0		0	0	0	82800	0	52	40213296		
22850	1879	40173590	2019-05-04	2019-05-04 00:00:00	2019-05-04	2019-05-04 00:00:00	\N	38000177		0	0	0		0	0	0	125427	0	904419	40173590		
29322	2427	1127433	1968-10-01	1968-10-01 00:00:00	1968-10-15	1968-10-15 00:00:00	1968-10-15	38000177		0	0	14		0	0	0	161028	0	313782	1127433		
15843	1316	40229134	1949-12-22	1949-12-22 00:00:00	1950-01-05	1950-01-05 00:00:00	1950-01-05	38000177		0	0	14		0	0	0	87225	0	1043400	40229134		
44167	3655	1127433	1972-01-15	1972-01-15 00:00:00	1972-01-22	1972-01-22 00:00:00	1972-01-22	38000177		0	0	7		0	0	0	243277	0	313782	1127433		
39888	3300	1713671	2004-06-08	2004-06-08 00:00:00	2004-06-22	2004-06-22 00:00:00	2004-06-22	38000177		0	0	14		0	0	0	219195	0	562251	1713671		
107620	2358	40213160	1971-11-16	1971-11-16 00:00:00	1971-11-16	1971-11-16 00:00:00	1971-11-16	581452		0	0	0		0	0	0	157115	0	10	40213160		
36491	3010	1127078	1972-07-31	1972-07-31 00:00:00	1972-08-28	1972-08-28 00:00:00	1972-08-28	38000177		0	0	28		0	0	0	200796	0	282464	1127078		
11374	948	19133905	1980-08-08	1980-08-08 00:00:00	1980-08-15	1980-08-15 00:00:00	1980-08-15	38000177		0	0	7		0	0	0	62966	0	834102	19133905		
25456	2091	1713671	2004-07-17	2004-07-17 00:00:00	2004-07-31	2004-07-31 00:00:00	2004-07-31	38000177		0	0	14		0	0	0	139424	0	562251	1713671		
54590	4534	19059056	1945-04-19	1945-04-19 00:00:00	1945-05-03	1945-05-03 00:00:00	1945-05-03	38000177		0	0	14		0	0	0	302048	0	243670	19059056		
21981	1804	1118084	1972-05-22	1972-05-22 00:00:00	1972-05-22	1972-05-22 00:00:00	\N	38000177		0	0	0		0	0	0	120843	0	00025152531	44923712		
12872	1082	1127078	1958-04-20	1958-04-20 00:00:00	1958-05-04	1958-05-04 00:00:00	1958-05-04	38000177		0	0	14		0	0	0	70926	0	282464	1127078		
13294	1115	19078461	2014-12-12	2014-12-12 00:00:00	2015-02-10	2015-02-10 00:00:00	2015-02-10	38000177		0	0	60		0	0	0	73390	0	310965	19078461		
12831	277	40213160	1964-08-11	1964-08-11 00:00:00	1964-08-11	1964-08-11 00:00:00	1964-08-11	581452		0	0	0		0	0	0	18472	0	10	40213160		
2646	212	1127078	1975-02-23	1975-02-23 00:00:00	1975-03-09	1975-03-09 00:00:00	1975-03-09	38000177		0	0	14		0	0	0	14429	0	282464	1127078		
120428	2647	40213160	1975-10-26	1975-10-26 00:00:00	1975-10-26	1975-10-26 00:00:00	1975-10-26	581452		0	0	0		0	0	0	\N	0	10	40213160		
13224	1108	920334	2014-03-06	2014-03-06 00:00:00	2014-03-13	2014-03-13 00:00:00	2014-03-13	38000177		0	0	7		0	0	0	72943	0	311995	920334		
42948	3560	1127433	2016-11-27	2016-11-27 00:00:00	2016-12-04	2016-12-04 00:00:00	2016-12-04	38000177		0	0	7		0	0	0	236358	0	313782	1127433		
60054	4991	19133873	1973-06-01	1973-06-01 00:00:00	1973-06-11	1973-06-11 00:00:00	1973-06-11	38000177		0	0	10		0	0	0	332027	0	834061	19133873		
43317	3592	1713671	1984-05-04	1984-05-04 00:00:00	1984-05-25	1984-05-25 00:00:00	1984-05-25	38000177		0	0	21		0	0	0	238631	0	562251	1713671		
53827	4474	1127433	1981-09-29	1981-09-29 00:00:00	1981-10-06	1981-10-06 00:00:00	1981-10-06	38000177		0	0	7		0	0	0	297652	0	313782	1127433		
37754	823	40213227	2006-01-23	2006-01-23 00:00:00	2006-01-23	2006-01-23 00:00:00	2006-01-23	581452		0	0	0		0	0	0	54524	0	113	40213227		
56770	1242	40213227	2010-03-17	2010-03-17 00:00:00	2010-03-17	2010-03-17 00:00:00	2010-03-17	581452		0	0	0		0	0	0	81780	0	113	40213227		
38377	3174	1713671	2005-01-22	2005-01-22 00:00:00	2005-01-29	2005-01-29 00:00:00	2005-01-29	38000177		0	0	7		0	0	0	210979	0	562251	1713671		
10021	841	40165015	1972-11-26	1972-11-26 00:00:00	1972-11-26	1972-11-26 00:00:00	\N	38000177		0	0	0		0	0	0	55570	0	861467	40165015		
7258	608	46233988	1978-11-08	1978-11-08 00:00:00	1978-11-22	1978-11-22 00:00:00	1978-11-22	38000177		0	0	14		0	0	0	40405	0	1652673	46233988		
7176	155	40213227	1997-04-11	1997-04-11 00:00:00	1997-04-11	1997-04-11 00:00:00	1997-04-11	581452		0	0	0		0	0	0	10596	0	113	40213227		
48239	3998	19133905	2005-05-13	2005-05-13 00:00:00	2005-05-26	2005-05-26 00:00:00	2005-05-26	38000177		0	0	13		0	0	0	265776	0	834102	19133905		
37852	3128	19019979	1982-09-05	1982-09-05 00:00:00	1982-09-19	1982-09-19 00:00:00	1982-09-19	38000177		0	0	14		0	0	0	208163	0	198405	19019979		
3107	254	1127433	2000-10-07	2000-10-07 00:00:00	2000-10-21	2000-10-21 00:00:00	2000-10-21	38000177		0	0	14		0	0	0	16968	0	313782	1127433		
18288	1513	19059056	1972-07-21	1972-07-21 00:00:00	1972-08-04	1972-08-04 00:00:00	1972-08-04	38000177		0	0	14		0	0	0	101085	0	243670	19059056		
13655	1143	1713671	2007-05-31	2007-05-31 00:00:00	2007-06-07	2007-06-07 00:00:00	2007-06-07	38000177		0	0	7		0	0	0	75395	0	562251	1713671		
13686	1145	1127433	1958-04-20	1958-04-20 00:00:00	1958-04-27	1958-04-27 00:00:00	1958-04-27	38000177		0	0	7		0	0	0	75628	0	313782	1127433		
31166	2583	1124300	2006-11-23	2006-11-23 00:00:00	2006-11-23	2006-11-23 00:00:00	\N	38000177		0	0	0		0	0	0	171054	0	00781178901	45011828		
45769	3789	1127433	2006-06-10	2006-06-10 00:00:00	2006-06-24	2006-06-24 00:00:00	2006-06-24	38000177		0	0	14		0	0	0	251881	0	313782	1127433		
48638	4027	19078461	2006-02-16	2006-02-16 00:00:00	2006-03-23	2006-03-23 00:00:00	2006-03-23	38000177		0	0	35		0	0	0	267883	0	310965	19078461		
27104	2235	19059056	1960-02-16	1960-02-16 00:00:00	1960-03-01	1960-03-01 00:00:00	1960-03-01	38000177		0	0	14		0	0	0	148658	0	243670	19059056		
143724	3159	40213296	2001-07-05	2001-07-05 00:00:00	2001-07-05	2001-07-05 00:00:00	2001-07-05	581452		0	0	0		0	0	0	210069	0	52	40213296		
7474	624	1713671	2009-08-06	2009-08-06 00:00:00	2009-08-13	2009-08-13 00:00:00	2009-08-13	38000177		0	0	7		0	0	0	41664	0	562251	1713671		
154932	3410	40213260	2014-04-16	2014-04-16 00:00:00	2014-04-16	2014-04-16 00:00:00	2014-04-16	581452		0	0	0		0	0	0	226164	0	121	40213260		
42502	3526	19078461	1974-05-09	1974-05-09 00:00:00	1974-05-30	1974-05-30 00:00:00	1974-05-30	38000177		0	0	21		0	0	0	234004	0	310965	19078461		
1886	41	40213227	1995-11-04	1995-11-04 00:00:00	1995-11-04	1995-11-04 00:00:00	1995-11-04	581452		0	0	0		0	0	0	2967	0	113	40213227		
32122	700	40213160	1978-11-22	1978-11-22 00:00:00	1978-11-22	1978-11-22 00:00:00	1978-11-22	581452		0	0	0		0	0	0	46245	0	10	40213160		
12471	1051	1127433	1991-08-06	1991-08-06 00:00:00	1991-08-20	1991-08-20 00:00:00	1991-08-20	38000177		0	0	14		0	0	0	68937	0	313782	1127433		
24846	2043	1713671	2004-09-08	2004-09-08 00:00:00	2004-11-24	2004-11-24 00:00:00	2004-11-24	38000177		0	0	77		0	0	0	135874	0	562251	1713671		
53191	4418	1115171	2003-02-20	2003-02-20 00:00:00	2003-03-20	2003-03-20 00:00:00	2003-03-20	38000177		0	0	28		0	0	0	293747	0	849574	1115171		
34232	2829	1127433	1978-02-09	1978-02-09 00:00:00	1978-04-10	1978-04-10 00:00:00	1978-04-10	38000177		0	0	60		0	0	0	187670	0	313782	1127433		
2091	164	1115171	2000-10-31	2000-10-31 00:00:00	2000-11-28	2000-11-28 00:00:00	2000-11-28	38000177		0	0	28		0	0	0	11280	0	849574	1115171		
34335	2836	1118084	2019-01-10	2019-01-10 00:00:00	2019-01-10	2019-01-10 00:00:00	\N	38000177		0	0	0		0	0	0	188401	0	00025152531	44923712		
46010	3811	1127433	1932-08-24	1932-08-24 00:00:00	1932-09-07	1932-09-07 00:00:00	1932-09-07	38000177		0	0	14		0	0	0	253144	0	313782	1127433		
36649	3025	1539411	1991-02-25	1991-02-25 00:00:00	1991-02-25	1991-02-25 00:00:00	\N	38000177		0	0	0		0	0	0	201568	0	312961	1539411		
30720	2546	1124300	2011-09-10	2011-09-10 00:00:00	2011-09-10	2011-09-10 00:00:00	\N	38000177		0	0	0		0	0	0	168527	0	00781178901	45011828		
64368	5343	40224805	1996-12-29	1996-12-29 00:00:00	1997-12-24	1997-12-24 00:00:00	1997-12-24	38000177		0	0	360		0	0	0	355882	0	1000126	40224805		
133975	2942	40213160	1956-01-04	1956-01-04 00:00:00	1956-01-04	1956-01-04 00:00:00	1956-01-04	581452		0	0	0		0	0	0	196117	0	10	40213160		
1753	140	19128022	1997-03-20	1997-03-20 00:00:00	1998-03-15	1998-03-15 00:00:00	1998-03-15	38000177		0	0	360		0	0	0	9413	0	749785	19128022		
1471	116	19078461	2001-03-04	2001-03-04 00:00:00	2001-03-25	2001-03-25 00:00:00	2001-03-25	38000177		0	0	21		0	0	0	7654	0	310965	19078461		
44429	3678	19078461	2018-03-17	2018-03-17 00:00:00	2018-06-15	2018-06-15 00:00:00	2018-06-15	38000177		0	0	90		0	0	0	244603	0	310965	19078461		
4491	372	19059056	1968-02-06	1968-02-06 00:00:00	1968-02-27	1968-02-27 00:00:00	1968-02-27	38000177		0	0	21		0	0	0	24786	0	243670	19059056		
141875	3117	40213296	2013-08-07	2013-08-07 00:00:00	2013-08-07	2013-08-07 00:00:00	2013-08-07	581452		0	0	0		0	0	0	207353	0	52	40213296		
39333	859	40213227	2018-05-21	2018-05-21 00:00:00	2018-05-21	2018-05-21 00:00:00	2018-05-21	581452		0	0	0		0	0	0	56894	0	113	40213227		
162892	3582	40213160	1956-11-04	1956-11-04 00:00:00	1956-11-04	1956-11-04 00:00:00	1956-11-04	581452		0	0	0		0	0	0	238092	0	10	40213160		
18650	1540	1127078	1964-07-26	1964-07-26 00:00:00	1964-08-09	1964-08-09 00:00:00	1964-08-09	38000177		0	0	14		0	0	0	103159	0	282464	1127078		
60468	5031	19059056	1920-06-06	1920-06-06 00:00:00	1920-06-20	1920-06-20 00:00:00	1920-06-20	38000177		0	0	14		0	0	0	334292	0	243670	19059056		
57456	1257	40213296	2012-11-03	2012-11-03 00:00:00	2012-11-03	2012-11-03 00:00:00	2012-11-03	581452		0	0	0		0	0	0	82817	0	52	40213296		
22851	1879	1118084	1995-10-15	1995-10-15 00:00:00	1995-10-15	1995-10-15 00:00:00	\N	38000177		0	0	0		0	0	0	125376	0	00025152531	44923712		
175074	3849	40213160	1964-02-27	1964-02-27 00:00:00	1964-02-27	1964-02-27 00:00:00	1964-02-27	581452		0	0	0		0	0	0	255432	0	10	40213160		
15844	1316	1127433	2013-03-13	2013-03-13 00:00:00	2013-03-27	2013-03-27 00:00:00	2013-03-27	38000177		0	0	14		0	0	0	87223	0	313782	1127433		
232405	5107	40213314	1978-05-13	1978-05-13 00:00:00	1978-05-13	1978-05-13 00:00:00	1978-05-13	581452		0	0	0		0	0	0	339327	0	49	40213314		
39889	3300	920334	2018-09-19	2018-09-19 00:00:00	2018-09-26	2018-09-26 00:00:00	2018-09-26	38000177		0	0	7		0	0	0	219249	0	311995	920334		
107623	2358	40213227	1994-05-31	1994-05-31 00:00:00	1994-05-31	1994-05-31 00:00:00	1994-05-31	581452		0	0	0		0	0	0	157123	0	113	40213227		
36492	3010	1713671	1996-08-10	1996-08-10 00:00:00	1996-08-17	1996-08-17 00:00:00	1996-08-17	38000177		0	0	7		0	0	0	200772	0	562251	1713671		
11375	948	19078461	1978-03-15	1978-03-15 00:00:00	1978-04-05	1978-04-05 00:00:00	1978-04-05	38000177		0	0	21		0	0	0	62963	0	310965	19078461		
25457	2091	1127433	1988-06-25	1988-06-25 00:00:00	1988-07-16	1988-07-16 00:00:00	1988-07-16	38000177		0	0	21		0	0	0	139481	0	313782	1127433		
54627	4538	1127433	1986-09-21	1986-09-21 00:00:00	1986-09-28	1986-09-28 00:00:00	1986-09-28	38000177		0	0	7		0	0	0	302389	0	313782	1127433		
21982	1804	40220960	1999-06-14	1999-06-14 00:00:00	1999-06-14	1999-06-14 00:00:00	1999-06-14	38000177		0	0	0		0	0	0	120884	0	1804799	40220960		
12874	1082	19006318	1956-08-25	1956-08-25 00:00:00	1956-09-08	1956-09-08 00:00:00	1956-09-08	38000177		0	0	14		0	0	0	70968	0	105078	19006318		
13295	1115	1127433	1970-05-09	1970-05-09 00:00:00	1970-05-16	1970-05-16 00:00:00	1970-05-16	38000177		0	0	7		0	0	0	73453	0	313782	1127433		
12837	277	40213260	2015-01-06	2015-01-06 00:00:00	2015-01-06	2015-01-06 00:00:00	2015-01-06	581452		0	0	0		0	0	0	18488	0	121	40213260		
2647	212	40229134	1996-06-13	1996-06-13 00:00:00	1996-06-20	1996-06-20 00:00:00	1996-06-20	38000177		0	0	7		0	0	0	14412	0	1043400	40229134		
128440	2825	40213227	1996-11-19	1996-11-19 00:00:00	1996-11-19	1996-11-19 00:00:00	1996-11-19	581452		0	0	0		0	0	0	187237	0	113	40213227		
13225	1108	920300	2012-11-10	2012-11-10 00:00:00	2012-11-17	2012-11-17 00:00:00	2012-11-17	38000177		0	0	7		0	0	0	72986	0	311989	920300		
42949	3560	1127433	1978-03-01	1978-03-01 00:00:00	1978-03-15	1978-03-15 00:00:00	1978-03-15	38000177		0	0	14		0	0	0	236411	0	313782	1127433		
60055	4991	1118084	2006-04-12	2006-04-12 00:00:00	2006-04-12	2006-04-12 00:00:00	\N	38000177		0	0	0		0	0	0	332043	0	00025152531	44923712		
43318	3592	19059056	1978-09-07	1978-09-07 00:00:00	1978-11-06	1978-11-06 00:00:00	1978-11-06	38000177		0	0	60		0	0	0	238591	0	243670	19059056		
53828	4474	19078461	1980-07-07	1980-07-07 00:00:00	1980-07-28	1980-07-28 00:00:00	1980-07-28	38000177		0	0	21		0	0	0	297689	0	310965	19078461		
37760	823	40213227	1995-11-27	1995-11-27 00:00:00	1995-11-27	1995-11-27 00:00:00	1995-11-27	581452		0	0	0		0	0	0	54543	0	113	40213227		
56772	1242	40213260	2009-03-11	2009-03-11 00:00:00	2009-03-11	2009-03-11 00:00:00	2009-03-11	581452		0	0	0		0	0	0	81810	0	121	40213260		
38378	3174	19133873	1991-12-18	1991-12-18 00:00:00	1991-12-26	1991-12-26 00:00:00	1991-12-26	38000177		0	0	8		0	0	0	210976	0	834061	19133873		
10022	841	1551192	1966-01-02	1966-01-02 00:00:00	1966-01-02	1966-01-02 00:00:00	1966-01-02	38000177		0	0	0		0	0	0	55509	0	312617	1551192		
7259	608	19059056	1975-04-13	1975-04-13 00:00:00	1975-04-27	1975-04-27 00:00:00	1975-04-27	38000177		0	0	14		0	0	0	40384	0	243670	19059056		
7177	155	40213296	1997-04-11	1997-04-11 00:00:00	1997-04-11	1997-04-11 00:00:00	1997-04-11	581452		0	0	0		0	0	0	10596	0	52	40213296		
48240	3998	1127433	1975-03-07	1975-03-07 00:00:00	1975-03-14	1975-03-14 00:00:00	1975-03-14	38000177		0	0	7		0	0	0	265858	0	313782	1127433		
37853	3128	40169216	1976-07-30	1976-07-30 00:00:00	1976-07-30	1976-07-30 00:00:00	\N	38000177		0	0	0		0	0	0	208195	0	895994	40169216		
3108	254	40229134	1962-10-29	1962-10-29 00:00:00	1962-11-12	1962-11-12 00:00:00	1962-11-12	38000177		0	0	14		0	0	0	16955	0	1043400	40229134		
18289	1513	19133873	1975-09-30	1975-09-30 00:00:00	1975-10-12	1975-10-12 00:00:00	1975-10-12	38000177		0	0	12		0	0	0	101117	0	834061	19133873		
13656	1143	1127433	1979-08-16	1979-08-16 00:00:00	1979-08-30	1979-08-30 00:00:00	1979-08-30	38000177		0	0	14		0	0	0	75416	0	313782	1127433		
13687	1145	1115171	2018-08-13	2018-08-13 00:00:00	2018-10-12	2018-10-12 00:00:00	2018-10-12	38000177		0	0	60		0	0	0	75559	0	849574	1115171		
31167	2583	19078461	1989-07-05	1989-07-05 00:00:00	1989-07-19	1989-07-19 00:00:00	1989-07-19	38000177		0	0	14		0	0	0	171044	0	310965	19078461		
45770	3789	1127433	1971-10-21	1971-10-21 00:00:00	1971-10-28	1971-10-28 00:00:00	1971-10-28	38000177		0	0	7		0	0	0	251875	0	313782	1127433		
59115	4913	1713671	2010-01-21	2010-01-21 00:00:00	2010-01-28	2010-01-28 00:00:00	2010-01-28	38000177		0	0	7		0	0	0	326524	0	562251	1713671		
27105	2235	19006318	1955-07-17	1955-07-17 00:00:00	1955-07-31	1955-07-31 00:00:00	1955-07-31	38000177		0	0	14		0	0	0	148679	0	105078	19006318		
143726	3159	40213227	2001-07-05	2001-07-05 00:00:00	2001-07-05	2001-07-05 00:00:00	2001-07-05	581452		0	0	0		0	0	0	210069	0	113	40213227		
7475	624	1127433	2019-05-16	2019-05-16 00:00:00	2019-05-23	2019-05-23 00:00:00	2019-05-23	38000177		0	0	7		0	0	0	41666	0	313782	1127433		
154934	3410	40213227	2006-04-26	2006-04-26 00:00:00	2006-04-26	2006-04-26 00:00:00	2006-04-26	581452		0	0	0		0	0	0	226152	0	113	40213227		
42503	3526	40229134	2015-01-05	2015-01-05 00:00:00	2015-01-19	2015-01-19 00:00:00	2015-01-19	38000177		0	0	14		0	0	0	233912	0	1043400	40229134		
1887	41	40213306	1995-11-04	1995-11-04 00:00:00	1995-11-04	1995-11-04 00:00:00	1995-11-04	581452		0	0	0		0	0	0	2967	0	43	40213306		
32123	700	40213314	1978-11-22	1978-11-22 00:00:00	1978-11-22	1978-11-22 00:00:00	1978-11-22	581452		0	0	0		0	0	0	46245	0	49	40213314		
12472	1051	1713671	2005-08-16	2005-08-16 00:00:00	2005-08-30	2005-08-30 00:00:00	2005-08-30	38000177		0	0	14		0	0	0	68942	0	562251	1713671		
24847	2043	19006318	1958-05-28	1958-05-28 00:00:00	1958-06-11	1958-06-11 00:00:00	1958-06-11	38000177		0	0	14		0	0	0	135907	0	105078	19006318		
53192	4418	19133873	1959-04-20	1959-04-20 00:00:00	1959-05-03	1959-05-03 00:00:00	1959-05-03	38000177		0	0	13		0	0	0	293715	0	834061	19133873		
34233	2829	1118084	1988-01-13	1988-01-13 00:00:00	1988-01-13	1988-01-13 00:00:00	\N	38000177		0	0	0		0	0	0	187624	0	00025152531	44923712		
2092	164	1124300	2009-02-11	2009-02-11 00:00:00	2009-02-11	2009-02-11 00:00:00	\N	38000177		0	0	0		0	0	0	11276	0	00781178901	45011828		
34336	2836	1127433	2012-01-04	2012-01-04 00:00:00	2012-02-08	2012-02-08 00:00:00	2012-02-08	38000177		0	0	35		0	0	0	188376	0	313782	1127433		
46011	3811	1127433	1998-08-03	1998-08-03 00:00:00	1998-08-17	1998-08-17 00:00:00	1998-08-17	38000177		0	0	14		0	0	0	253217	0	313782	1127433		
36651	3025	1127433	1992-08-31	1992-08-31 00:00:00	1992-09-07	1992-09-07 00:00:00	1992-09-07	38000177		0	0	7		0	0	0	201631	0	313782	1127433		
30721	2546	1127433	1992-09-01	1992-09-01 00:00:00	1992-09-08	1992-09-08 00:00:00	1992-09-08	38000177		0	0	7		0	0	0	168519	0	313782	1127433		
64369	5343	1713671	2001-03-16	2001-03-16 00:00:00	2001-03-30	2001-03-30 00:00:00	2001-03-30	38000177		0	0	14		0	0	0	355824	0	562251	1713671		
133982	2942	40213260	2007-02-21	2007-02-21 00:00:00	2007-02-21	2007-02-21 00:00:00	2007-02-21	581452		0	0	0		0	0	0	196141	0	121	40213260		
1754	140	19133873	1972-08-22	1972-08-22 00:00:00	1972-09-04	1972-09-04 00:00:00	1972-09-04	38000177		0	0	13		0	0	0	9406	0	834061	19133873		
1472	116	1124300	1970-02-14	1970-02-14 00:00:00	1970-02-14	1970-02-14 00:00:00	\N	38000177		0	0	0		0	0	0	7687	0	00781178901	45011828		
44430	3678	19133873	1982-03-27	1982-03-27 00:00:00	1982-04-06	1982-04-06 00:00:00	1982-04-06	38000177		0	0	10		0	0	0	244579	0	834061	19133873		
4492	372	1127433	1980-02-05	1980-02-05 00:00:00	1980-02-12	1980-02-12 00:00:00	1980-02-12	38000177		0	0	7		0	0	0	24756	0	313782	1127433		
141878	3117	40213314	1977-01-05	1977-01-05 00:00:00	1977-01-05	1977-01-05 00:00:00	1977-01-05	581452		0	0	0		0	0	0	207347	0	49	40213314		
39340	859	40213227	2008-04-14	2008-04-14 00:00:00	2008-04-14	2008-04-14 00:00:00	2008-04-14	581452		0	0	0		0	0	0	56771	0	113	40213227		
28333	616	40213306	1981-08-29	1981-08-29 00:00:00	1981-08-29	1981-08-29 00:00:00	1981-08-29	581452		0	0	0		0	0	0	41095	0	43	40213306		
18651	1540	19006318	1964-07-26	1964-07-26 00:00:00	1964-08-09	1964-08-09 00:00:00	1964-08-09	38000177		0	0	14		0	0	0	103159	0	105078	19006318		
60469	5031	1118084	1956-06-17	1956-06-17 00:00:00	1956-06-17	1956-06-17 00:00:00	\N	38000177		0	0	0		0	0	0	334386	0	00025152531	44923712		
68739	1505	40213160	1958-08-16	1958-08-16 00:00:00	1958-08-16	1958-08-16 00:00:00	1958-08-16	581452		0	0	0		0	0	0	100392	0	10	40213160		
22852	1879	19059056	1963-05-11	1963-05-11 00:00:00	1963-05-25	1963-05-25 00:00:00	1963-05-25	38000177		0	0	14		0	0	0	125418	0	243670	19059056		
15795	1314	1539411	2012-01-14	2012-01-14 00:00:00	2012-01-14	2012-01-14 00:00:00	\N	38000177		0	0	0		0	0	0	87014	0	312961	1539411		
15846	1317	1127433	1964-04-14	1964-04-14 00:00:00	1964-04-21	1964-04-21 00:00:00	1964-04-21	38000177		0	0	7		0	0	0	87287	0	313782	1127433		
232409	5107	40213227	2017-05-13	2017-05-13 00:00:00	2017-05-13	2017-05-13 00:00:00	2017-05-13	581452		0	0	0		0	0	0	339317	0	113	40213227		
39890	3300	40229134	1983-05-03	1983-05-03 00:00:00	1983-05-10	1983-05-10 00:00:00	1983-05-10	38000177		0	0	7		0	0	0	219217	0	1043400	40229134		
107624	2358	40213306	1994-05-31	1994-05-31 00:00:00	1994-05-31	1994-05-31 00:00:00	1994-05-31	581452		0	0	0		0	0	0	157123	0	43	40213306		
36493	3010	1127433	2000-01-07	2000-01-07 00:00:00	2000-01-14	2000-01-14 00:00:00	2000-01-14	38000177		0	0	7		0	0	0	200767	0	313782	1127433		
11376	948	19078461	2000-11-05	2000-11-05 00:00:00	2000-12-05	2000-12-05 00:00:00	2000-12-05	38000177		0	0	30		0	0	0	62964	0	310965	19078461		
25458	2091	1124300	2001-10-26	2001-10-26 00:00:00	2001-10-26	2001-10-26 00:00:00	\N	38000177		0	0	0		0	0	0	139435	0	00781178901	45011828		
54628	4538	1118084	1987-05-22	1987-05-22 00:00:00	1987-05-22	1987-05-22 00:00:00	\N	38000177		0	0	0		0	0	0	302389	0	00025152531	44923712		
21983	1804	19075601	1999-06-14	1999-06-14 00:00:00	1999-06-14	1999-06-14 00:00:00	1999-06-14	38000177		0	0	0		0	0	0	120884	0	309362	19075601		
12875	1082	19059056	1956-08-25	1956-08-25 00:00:00	1956-09-08	1956-09-08 00:00:00	1956-09-08	38000177		0	0	14		0	0	0	70968	0	243670	19059056		
13296	1115	1118084	1987-05-17	1987-05-17 00:00:00	1987-05-17	1987-05-17 00:00:00	\N	38000177		0	0	0		0	0	0	73391	0	00025152531	44923712		
12839	277	40213227	2015-01-06	2015-01-06 00:00:00	2015-01-06	2015-01-06 00:00:00	2015-01-06	581452		0	0	0		0	0	0	18488	0	113	40213227		
2649	212	19133905	1993-12-15	1993-12-15 00:00:00	1993-12-22	1993-12-22 00:00:00	1993-12-22	38000177		0	0	7		0	0	0	14468	0	834102	19133905		
128454	2825	40213227	2007-01-16	2007-01-16 00:00:00	2007-01-16	2007-01-16 00:00:00	2007-01-16	581452		0	0	0		0	0	0	187240	0	113	40213227		
13226	1108	40236824	2012-11-10	2012-11-10 00:00:00	2012-11-17	2012-11-17 00:00:00	2012-11-17	38000177		0	0	7		0	0	0	72986	0	1094107	40236824		
42950	3561	1115171	1998-08-22	1998-08-22 00:00:00	1998-09-12	1998-09-12 00:00:00	1998-09-12	38000177		0	0	21		0	0	0	236476	0	849574	1115171		
60056	4991	40236824	2007-08-14	2007-08-14 00:00:00	2007-08-21	2007-08-21 00:00:00	2007-08-21	38000177		0	0	7		0	0	0	332024	0	1094107	40236824		
43320	3592	1127078	1973-12-11	1973-12-11 00:00:00	1974-01-01	1974-01-01 00:00:00	1974-01-01	38000177		0	0	21		0	0	0	238590	0	282464	1127078		
53829	4474	40229134	1966-02-23	1966-02-23 00:00:00	1966-03-09	1966-03-09 00:00:00	1966-03-09	38000177		0	0	14		0	0	0	297694	0	1043400	40229134		
54911	1202	40213306	2002-09-29	2002-09-29 00:00:00	2002-09-29	2002-09-29 00:00:00	2002-09-29	581452		0	0	0		0	0	0	79037	0	43	40213306		
7018	592	19128022	1990-10-19	1990-10-19 00:00:00	1991-10-14	1991-10-14 00:00:00	1991-10-14	38000177		0	0	360		0	0	0	39084	0	749785	19128022		
139317	3060	40213227	2015-11-28	2015-11-28 00:00:00	2015-11-28	2015-11-28 00:00:00	2015-11-28	581452		0	0	0		0	0	0	203603	0	113	40213227		
10023	841	1127433	1966-08-31	1966-08-31 00:00:00	1966-09-07	1966-09-07 00:00:00	1966-09-07	38000177		0	0	7		0	0	0	55561	0	313782	1127433		
7260	608	46233988	1975-04-13	1975-04-13 00:00:00	1975-04-27	1975-04-27 00:00:00	1975-04-27	38000177		0	0	14		0	0	0	40384	0	1652673	46233988		
7182	155	40213260	2007-08-03	2007-08-03 00:00:00	2007-08-03	2007-08-03 00:00:00	2007-08-03	581452		0	0	0		0	0	0	10598	0	121	40213260		
48241	3998	1118084	1986-06-22	1986-06-22 00:00:00	1986-06-22	1986-06-22 00:00:00	\N	38000177		0	0	0		0	0	0	265808	0	00025152531	44923712		
37854	3128	1154615	1976-07-30	1976-07-30 00:00:00	1976-07-30	1976-07-30 00:00:00	\N	38000177		0	0	0		0	0	0	208195	0	745679	1154615		
3109	254	19059056	1992-12-10	1992-12-10 00:00:00	1992-12-31	1992-12-31 00:00:00	1992-12-31	38000177		0	0	21		0	0	0	16919	0	243670	19059056		
43327	3592	40236824	2016-02-18	2016-02-18 00:00:00	2016-02-25	2016-02-25 00:00:00	2016-02-25	38000177		0	0	7		0	0	0	238582	0	1094107	40236824		
13657	1144	1118084	2014-09-14	2014-09-14 00:00:00	2014-09-14	2014-09-14 00:00:00	\N	38000177		0	0	0		0	0	0	75484	0	00025152531	44923712		
13688	1145	1127433	1948-12-30	1948-12-30 00:00:00	1949-01-06	1949-01-06 00:00:00	1949-01-06	38000177		0	0	7		0	0	0	75540	0	313782	1127433		
31168	2583	920300	2000-07-13	2000-07-13 00:00:00	2000-07-20	2000-07-20 00:00:00	2000-07-20	38000177		0	0	7		0	0	0	171027	0	311989	920300		
45771	3789	1127433	1974-11-30	1974-11-30 00:00:00	1974-12-14	1974-12-14 00:00:00	1974-12-14	38000177		0	0	14		0	0	0	251871	0	313782	1127433		
59117	4913	1124300	2004-05-25	2004-05-25 00:00:00	2004-05-25	2004-05-25 00:00:00	\N	38000177		0	0	0		0	0	0	326572	0	00781178901	45011828		
27106	2235	19059056	1955-07-17	1955-07-17 00:00:00	1955-07-31	1955-07-31 00:00:00	1955-07-31	38000177		0	0	14		0	0	0	148679	0	243670	19059056		
143728	3159	40213160	1959-10-01	1959-10-01 00:00:00	1959-10-01	1959-10-01 00:00:00	1959-10-01	581452		0	0	0		0	0	0	210098	0	10	40213160		
7476	624	19059056	1947-01-23	1947-01-23 00:00:00	1947-04-23	1947-04-23 00:00:00	1947-04-23	38000177		0	0	90		0	0	0	41688	0	243670	19059056		
154935	3410	40213296	2006-04-26	2006-04-26 00:00:00	2006-04-26	2006-04-26 00:00:00	2006-04-26	581452		0	0	0		0	0	0	226152	0	52	40213296		
42504	3526	19059056	1964-09-23	1964-09-23 00:00:00	1964-10-23	1964-10-23 00:00:00	1964-10-23	38000177		0	0	30		0	0	0	234001	0	243670	19059056		
1889	41	40213160	1973-11-03	1973-11-03 00:00:00	1973-11-03	1973-11-03 00:00:00	1973-11-03	581452		0	0	0		0	0	0	2948	0	10	40213160		
32125	700	40213160	1978-09-20	1978-09-20 00:00:00	1978-09-20	1978-09-20 00:00:00	1978-09-20	581452		0	0	0		0	0	0	46237	0	10	40213160		
12473	1051	1127078	1975-06-17	1975-06-17 00:00:00	1975-07-17	1975-07-17 00:00:00	1975-07-17	38000177		0	0	30		0	0	0	68870	0	282464	1127078		
24848	2043	19059056	1958-05-28	1958-05-28 00:00:00	1958-06-11	1958-06-11 00:00:00	1958-06-11	38000177		0	0	14		0	0	0	135907	0	243670	19059056		
53193	4418	19126352	2008-02-01	2008-02-01 00:00:00	2008-02-01	2008-02-01 00:00:00	\N	38000177		0	0	0		0	0	0	293696	0	705129	19126352		
34234	2829	40236446	1958-09-02	1958-09-02 00:00:00	1968-09-09	1968-09-09 00:00:00	1968-09-09	38000177		0	0	3660		0	0	0	187630	0	1091392	40236446		
2093	164	19133873	1966-06-05	1966-06-05 00:00:00	1966-06-15	1966-06-15 00:00:00	1966-06-15	38000177		0	0	10		0	0	0	11243	0	834061	19133873		
34337	2836	920334	2008-11-15	2008-11-15 00:00:00	2008-11-22	2008-11-22 00:00:00	2008-11-22	38000177		0	0	7		0	0	0	188356	0	311995	920334		
46012	3811	19059056	1925-05-04	1925-05-04 00:00:00	1925-06-01	1925-06-01 00:00:00	1925-06-01	38000177		0	0	28		0	0	0	253139	0	243670	19059056		
36652	3025	1127433	1996-05-16	1996-05-16 00:00:00	1996-05-30	1996-05-30 00:00:00	1996-05-30	38000177		0	0	14		0	0	0	201675	0	313782	1127433		
30722	2546	19128022	1995-02-21	1995-02-21 00:00:00	1996-02-16	1996-02-16 00:00:00	1996-02-16	38000177		0	0	360		0	0	0	168468	0	749785	19128022		
64370	5343	19133873	1994-08-30	1994-08-30 00:00:00	1994-09-11	1994-09-11 00:00:00	1994-09-11	38000177		0	0	12		0	0	0	355876	0	834061	19133873		
133988	2942	40213227	1994-11-30	1994-11-30 00:00:00	1994-11-30	1994-11-30 00:00:00	1994-11-30	581452		0	0	0		0	0	0	196145	0	113	40213227		
1755	140	19128065	1993-04-10	1993-04-10 00:00:00	1994-04-05	1994-04-05 00:00:00	1994-04-05	38000177		0	0	360		0	0	0	9409	0	749882	19128065		
1501	119	920334	2009-01-31	2009-01-31 00:00:00	2009-02-07	2009-02-07 00:00:00	2009-02-07	38000177		0	0	7		0	0	0	7868	0	311995	920334		
44431	3678	1127433	1980-06-06	1980-06-06 00:00:00	1980-06-20	1980-06-20 00:00:00	1980-06-20	38000177		0	0	14		0	0	0	244578	0	313782	1127433		
4493	372	920300	1984-06-03	1984-06-03 00:00:00	1984-06-10	1984-06-10 00:00:00	1984-06-10	38000177		0	0	7		0	0	0	24745	0	311989	920300		
141879	3117	40213314	1977-07-06	1977-07-06 00:00:00	1977-07-06	1977-07-06 00:00:00	1977-07-06	581452		0	0	0		0	0	0	207384	0	49	40213314		
39341	859	40213260	2008-04-14	2008-04-14 00:00:00	2008-04-14	2008-04-14 00:00:00	2008-04-14	581452		0	0	0		0	0	0	56771	0	121	40213260		
28335	616	40213160	1959-06-13	1959-06-13 00:00:00	1959-06-13	1959-06-13 00:00:00	1959-06-13	581452		0	0	0		0	0	0	41128	0	10	40213160		
18652	1540	1127433	2004-12-08	2004-12-08 00:00:00	2004-12-15	2004-12-15 00:00:00	2004-12-15	38000177		0	0	7		0	0	0	103166	0	313782	1127433		
60470	5031	1115171	2019-01-04	2019-01-04 00:00:00	2019-01-18	2019-01-18 00:00:00	2019-01-18	38000177		0	0	14		0	0	0	334422	0	849574	1115171		
163707	3601	40213160	1959-09-25	1959-09-25 00:00:00	1959-09-25	1959-09-25 00:00:00	1959-09-25	581452		0	0	0		0	0	0	239235	0	10	40213160		
22853	1879	19129655	1963-05-11	1963-05-11 00:00:00	1963-05-25	1963-05-25 00:00:00	1963-05-25	38000177		0	0	14		0	0	0	125418	0	789980	19129655		
15796	1314	1332419	2012-01-14	2012-01-14 00:00:00	2012-01-14	2012-01-14 00:00:00	\N	38000177		0	0	0		0	0	0	87014	0	197361	1332419		
15847	1317	19133873	1964-10-04	1964-10-04 00:00:00	1964-10-13	1964-10-13 00:00:00	1964-10-13	38000177		0	0	9		0	0	0	87288	0	834061	19133873		
71783	1569	40213201	2002-12-06	2002-12-06 00:00:00	2002-12-06	2002-12-06 00:00:00	2002-12-06	581452		0	0	0		0	0	0	105321	0	33	40213201		
39891	3300	1127433	2009-10-12	2009-10-12 00:00:00	2009-10-26	2009-10-26 00:00:00	2009-10-26	38000177		0	0	14		0	0	0	219259	0	313782	1127433		
44235	3661	920300	2008-03-05	2008-03-05 00:00:00	2008-03-12	2008-03-12 00:00:00	2008-03-12	38000177		0	0	7		0	0	0	243689	0	311989	920300		
36494	3010	1124300	2003-12-26	2003-12-26 00:00:00	2003-12-26	2003-12-26 00:00:00	\N	38000177		0	0	0		0	0	0	200753	0	00781178901	45011828		
11377	948	19129655	1961-08-21	1961-08-21 00:00:00	1961-09-04	1961-09-04 00:00:00	1961-09-04	38000177		0	0	14		0	0	0	62921	0	789980	19129655		
25459	2091	1127433	1979-07-29	1979-07-29 00:00:00	1979-08-12	1979-08-12 00:00:00	1979-08-12	38000177		0	0	14		0	0	0	139480	0	313782	1127433		
54629	4538	920300	2012-06-04	2012-06-04 00:00:00	2012-06-11	2012-06-11 00:00:00	2012-06-11	38000177		0	0	7		0	0	0	302353	0	311989	920300		
21984	1804	40236824	1976-11-11	1976-11-11 00:00:00	1976-11-18	1976-11-18 00:00:00	1976-11-18	38000177		0	0	7		0	0	0	120876	0	1094107	40236824		
12876	1082	19128065	1976-07-10	1976-07-10 00:00:00	1977-07-05	1977-07-05 00:00:00	1977-07-05	38000177		0	0	360		0	0	0	70971	0	749882	19128065		
13297	1115	1127433	1959-07-20	1959-07-20 00:00:00	1959-08-03	1959-08-03 00:00:00	1959-08-03	38000177		0	0	14		0	0	0	73451	0	313782	1127433		
12841	277	40213160	1964-05-12	1964-05-12 00:00:00	1964-05-12	1964-05-12 00:00:00	1964-05-12	581452		0	0	0		0	0	0	18501	0	10	40213160		
2650	212	19133873	1972-09-07	1972-09-07 00:00:00	1972-09-18	1972-09-18 00:00:00	1972-09-18	38000177		0	0	11		0	0	0	14465	0	834061	19133873		
128469	2825	40213201	1991-08-27	1991-08-27 00:00:00	1991-08-27	1991-08-27 00:00:00	1991-08-27	581452		0	0	0		0	0	0	187296	0	33	40213201		
13227	1108	920300	2014-02-27	2014-02-27 00:00:00	2014-03-06	2014-03-06 00:00:00	2014-03-06	38000177		0	0	7		0	0	0	72942	0	311989	920300		
42951	3561	1127433	2010-06-11	2010-06-11 00:00:00	2010-07-11	2010-07-11 00:00:00	2010-07-11	38000177		0	0	30		0	0	0	236537	0	313782	1127433		
60057	4991	920300	2007-08-14	2007-08-14 00:00:00	2007-08-21	2007-08-21 00:00:00	2007-08-21	38000177		0	0	7		0	0	0	332024	0	311989	920300		
43321	3592	1713671	1965-10-30	1965-10-30 00:00:00	1965-11-06	1965-11-06 00:00:00	1965-11-06	38000177		0	0	7		0	0	0	238630	0	562251	1713671		
53830	4474	19133873	1965-11-26	1965-11-26 00:00:00	1965-12-08	1965-12-08 00:00:00	1965-12-08	38000177		0	0	12		0	0	0	297669	0	834061	19133873		
54913	1202	40213227	2002-09-29	2002-09-29 00:00:00	2002-09-29	2002-09-29 00:00:00	2002-09-29	581452		0	0	0		0	0	0	79037	0	113	40213227		
7019	592	19128065	1987-11-04	1987-11-04 00:00:00	1988-10-29	1988-10-29 00:00:00	1988-10-29	38000177		0	0	360		0	0	0	39131	0	749882	19128065		
139329	3060	40213227	2005-10-01	2005-10-01 00:00:00	2005-10-01	2005-10-01 00:00:00	2005-10-01	581452		0	0	0		0	0	0	203636	0	113	40213227		
10024	841	19112599	1954-02-05	1954-02-05 00:00:00	1954-02-05	1954-02-05 00:00:00	\N	38000177		0	0	0		0	0	0	55559	0	477045	19112599		
7261	608	19078461	2004-10-21	2004-10-21 00:00:00	2004-11-04	2004-11-04 00:00:00	2004-11-04	38000177		0	0	14		0	0	0	40408	0	310965	19078461		
7184	155	40213227	2016-04-22	2016-04-22 00:00:00	2016-04-22	2016-04-22 00:00:00	2016-04-22	581452		0	0	0		0	0	0	10648	0	113	40213227		
48242	3998	1127433	1972-10-28	1972-10-28 00:00:00	1973-01-26	1973-01-26 00:00:00	1973-01-26	38000177		0	0	90		0	0	0	265789	0	313782	1127433		
37855	3128	1551192	1974-02-19	1974-02-19 00:00:00	1974-02-19	1974-02-19 00:00:00	1974-02-19	38000177		0	0	0		0	0	0	208162	0	312617	1551192		
3110	254	1713671	1991-11-29	1991-11-29 00:00:00	1991-12-06	1991-12-06 00:00:00	1991-12-06	38000177		0	0	7		0	0	0	16966	0	562251	1713671		
43328	3592	1127433	1998-11-27	1998-11-27 00:00:00	1998-12-11	1998-12-11 00:00:00	1998-12-11	38000177		0	0	14		0	0	0	238594	0	313782	1127433		
13658	1144	40229134	1992-10-15	1992-10-15 00:00:00	1992-10-29	1992-10-29 00:00:00	1992-10-29	38000177		0	0	14		0	0	0	75515	0	1043400	40229134		
13689	1145	19059056	1938-11-22	1938-11-22 00:00:00	1938-12-06	1938-12-06 00:00:00	1938-12-06	38000177		0	0	14		0	0	0	75578	0	243670	19059056		
31169	2583	40236824	2000-07-13	2000-07-13 00:00:00	2000-07-20	2000-07-20 00:00:00	2000-07-20	38000177		0	0	7		0	0	0	171027	0	1094107	40236824		
45772	3789	1713671	1951-04-30	1951-04-30 00:00:00	1951-05-21	1951-05-21 00:00:00	1951-05-21	38000177		0	0	21		0	0	0	251870	0	562251	1713671		
59118	4913	19078461	2002-06-04	2002-06-04 00:00:00	2002-07-09	2002-07-09 00:00:00	2002-07-09	38000177		0	0	35		0	0	0	326572	0	310965	19078461		
27107	2235	1118084	1983-05-21	1983-05-21 00:00:00	1983-05-21	1983-05-21 00:00:00	\N	38000177		0	0	0		0	0	0	148671	0	00025152531	44923712		
41530	905	40213296	2010-10-02	2010-10-02 00:00:00	2010-10-02	2010-10-02 00:00:00	2010-10-02	581452		0	0	0		0	0	0	60211	0	52	40213296		
7477	624	1713671	2012-06-15	2012-06-15 00:00:00	2012-07-06	2012-07-06 00:00:00	2012-07-06	38000177		0	0	21		0	0	0	41665	0	562251	1713671		
154937	3410	40213160	1969-03-26	1969-03-26 00:00:00	1969-03-26	1969-03-26 00:00:00	1969-03-26	581452		0	0	0		0	0	0	226156	0	10	40213160		
42505	3526	1713671	1961-10-31	1961-10-31 00:00:00	1961-12-26	1961-12-26 00:00:00	1961-12-26	38000177		0	0	56		0	0	0	233905	0	562251	1713671		
1891	41	40213160	1974-02-02	1974-02-02 00:00:00	1974-02-02	1974-02-02 00:00:00	1974-02-02	581452		0	0	0		0	0	0	2994	0	10	40213160		
32126	700	40213314	1978-09-20	1978-09-20 00:00:00	1978-09-20	1978-09-20 00:00:00	1978-09-20	581452		0	0	0		0	0	0	46237	0	49	40213314		
12474	1051	1713671	2017-09-10	2017-09-10 00:00:00	2017-09-24	2017-09-24 00:00:00	2017-09-24	38000177		0	0	14		0	0	0	68910	0	562251	1713671		
24849	2043	1713671	1974-12-08	1974-12-08 00:00:00	1975-03-30	1975-03-30 00:00:00	1975-03-30	38000177		0	0	112		0	0	0	135895	0	562251	1713671		
53194	4418	19075601	2008-02-01	2008-02-01 00:00:00	2008-02-01	2008-02-01 00:00:00	\N	38000177		0	0	0		0	0	0	293696	0	309362	19075601		
34235	2829	1127433	1990-09-04	1990-09-04 00:00:00	1990-09-18	1990-09-18 00:00:00	1990-09-18	38000177		0	0	14		0	0	0	187671	0	313782	1127433		
2094	165	920300	2005-07-12	2005-07-12 00:00:00	2005-07-19	2005-07-19 00:00:00	2005-07-19	38000177		0	0	7		0	0	0	11315	0	311989	920300		
34338	2836	40236824	2011-01-05	2011-01-05 00:00:00	2011-01-12	2011-01-12 00:00:00	2011-01-12	38000177		0	0	7		0	0	0	188388	0	1094107	40236824		
46013	3811	19059056	1927-05-22	1927-05-22 00:00:00	1927-08-20	1927-08-20 00:00:00	1927-08-20	38000177		0	0	90		0	0	0	253140	0	243670	19059056		
36653	3025	1127078	1950-05-25	1950-05-25 00:00:00	1950-06-08	1950-06-08 00:00:00	1950-06-08	38000177		0	0	14		0	0	0	201645	0	282464	1127078		
30723	2546	19128065	1991-03-14	1991-03-14 00:00:00	1992-03-08	1992-03-08 00:00:00	1992-03-08	38000177		0	0	360		0	0	0	168467	0	749882	19128065		
64371	5343	1118084	2019-02-12	2019-02-12 00:00:00	2019-02-12	2019-02-12 00:00:00	\N	38000177		0	0	0		0	0	0	355856	0	00025152531	44923712		
134004	2942	40213260	2006-02-15	2006-02-15 00:00:00	2006-02-15	2006-02-15 00:00:00	2006-02-15	581452		0	0	0		0	0	0	196071	0	121	40213260		
1756	141	1127078	1987-10-31	1987-10-31 00:00:00	1987-11-14	1987-11-14 00:00:00	1987-11-14	38000177		0	0	14		0	0	0	9443	0	282464	1127078		
1502	119	1713671	1976-05-18	1976-05-18 00:00:00	1976-05-25	1976-05-25 00:00:00	1976-05-25	38000177		0	0	7		0	0	0	7866	0	562251	1713671		
44432	3678	40229134	2008-10-01	2008-10-01 00:00:00	2008-10-08	2008-10-08 00:00:00	2008-10-08	38000177		0	0	7		0	0	0	244595	0	1043400	40229134		
4494	372	40236824	1984-06-03	1984-06-03 00:00:00	1984-06-10	1984-06-10 00:00:00	1984-06-10	38000177		0	0	7		0	0	0	24745	0	1094107	40236824		
141884	3117	40213160	1974-01-09	1974-01-09 00:00:00	1974-01-09	1974-01-09 00:00:00	1974-01-09	581452		0	0	0		0	0	0	207393	0	10	40213160		
96367	2114	40213160	1965-05-05	1965-05-05 00:00:00	1965-05-05	1965-05-05 00:00:00	1965-05-05	581452		0	0	0		0	0	0	140649	0	10	40213160		
28346	616	40213260	2010-01-09	2010-01-09 00:00:00	2010-01-09	2010-01-09 00:00:00	2010-01-09	581452		0	0	0		0	0	0	41103	0	121	40213260		
18653	1540	1118084	1994-03-11	1994-03-11 00:00:00	1994-03-11	1994-03-11 00:00:00	\N	38000177		0	0	0		0	0	0	103201	0	00025152531	44923712		
60471	5031	19073188	2019-01-04	2019-01-04 00:00:00	2019-01-18	2019-01-18 00:00:00	2019-01-18	38000177		0	0	14		0	0	0	334422	0	308192	19073188		
163713	3601	40213160	1959-11-27	1959-11-27 00:00:00	1959-11-27	1959-11-27 00:00:00	1959-11-27	581452		0	0	0		0	0	0	239190	0	10	40213160		
22854	1879	19133905	1984-02-05	1984-02-05 00:00:00	1984-02-16	1984-02-16 00:00:00	1984-02-16	38000177		0	0	11		0	0	0	125393	0	834102	19133905		
15797	1314	1713671	1970-06-07	1970-06-07 00:00:00	1970-06-21	1970-06-21 00:00:00	1970-06-21	38000177		0	0	14		0	0	0	87036	0	562251	1713671		
15848	1317	19126352	2009-12-25	2009-12-25 00:00:00	2009-12-25	2009-12-25 00:00:00	\N	38000177		0	0	0		0	0	0	87331	0	705129	19126352		
71790	1569	40213227	2008-07-04	2008-07-04 00:00:00	2008-07-04	2008-07-04 00:00:00	2008-07-04	581452		0	0	0		0	0	0	105324	0	113	40213227		
39892	3300	19133873	1997-04-17	1997-04-17 00:00:00	1997-04-28	1997-04-28 00:00:00	1997-04-28	38000177		0	0	11		0	0	0	219194	0	834061	19133873		
44236	3661	40236824	2008-03-05	2008-03-05 00:00:00	2008-03-19	2008-03-19 00:00:00	2008-03-19	38000177		0	0	14		0	0	0	243689	0	1094107	40236824		
36495	3010	19075601	2015-03-18	2015-03-18 00:00:00	2015-03-18	2015-03-18 00:00:00	2015-03-18	38000177		0	0	0		0	0	0	200792	0	309362	19075601		
11378	948	19059056	1961-08-21	1961-08-21 00:00:00	1961-09-04	1961-09-04 00:00:00	1961-09-04	38000177		0	0	14		0	0	0	62921	0	243670	19059056		
25460	2091	19073188	2004-01-01	2004-01-01 00:00:00	2004-01-15	2004-01-15 00:00:00	2004-01-15	38000177		0	0	14		0	0	0	139445	0	308192	19073188		
54630	4538	40236824	2012-06-04	2012-06-04 00:00:00	2012-06-18	2012-06-18 00:00:00	2012-06-18	38000177		0	0	14		0	0	0	302353	0	1094107	40236824		
21985	1804	920300	1976-11-11	1976-11-11 00:00:00	1976-11-18	1976-11-18 00:00:00	1976-11-18	38000177		0	0	7		0	0	0	120876	0	311989	920300		
12877	1082	1127433	1959-09-29	1959-09-29 00:00:00	1959-10-13	1959-10-13 00:00:00	1959-10-13	38000177		0	0	14		0	0	0	71008	0	313782	1127433		
13298	1115	1127433	2007-01-09	2007-01-09 00:00:00	2007-01-23	2007-01-23 00:00:00	2007-01-23	38000177		0	0	14		0	0	0	73389	0	313782	1127433		
12843	277	40213296	2004-01-06	2004-01-06 00:00:00	2004-01-06	2004-01-06 00:00:00	2004-01-06	581452		0	0	0		0	0	0	18469	0	52	40213296		
2651	212	19019979	1980-04-14	1980-04-14 00:00:00	1980-04-28	1980-04-28 00:00:00	1980-04-28	38000177		0	0	14		0	0	0	14415	0	198405	19019979		
103265	2265	40213306	1986-06-01	1986-06-01 00:00:00	1986-06-01	1986-06-01 00:00:00	1986-06-01	581452		0	0	0		0	0	0	150532	0	43	40213306		
13228	1108	40236824	2014-02-27	2014-02-27 00:00:00	2014-03-13	2014-03-13 00:00:00	2014-03-13	38000177		0	0	14		0	0	0	72942	0	1094107	40236824		
42952	3561	19018935	1973-04-16	1973-04-16 00:00:00	1973-04-16	1973-04-16 00:00:00	\N	38000177		0	0	0		0	0	0	236440	0	197604	19018935		
60058	4991	19078461	1994-08-04	1994-08-04 00:00:00	1994-08-25	1994-08-25 00:00:00	1994-08-25	38000177		0	0	21		0	0	0	332055	0	310965	19078461		
43322	3592	19078461	1989-01-12	1989-01-12 00:00:00	1989-01-26	1989-01-26 00:00:00	1989-01-26	38000177		0	0	14		0	0	0	238592	0	310965	19078461		
53831	4474	19133873	1973-02-24	1973-02-24 00:00:00	1973-03-09	1973-03-09 00:00:00	1973-03-09	38000177		0	0	13		0	0	0	297651	0	834061	19133873		
54920	1202	40213160	1981-03-15	1981-03-15 00:00:00	1981-03-15	1981-03-15 00:00:00	1981-03-15	581452		0	0	0		0	0	0	79053	0	10	40213160		
7020	592	40224805	1992-10-08	1992-10-08 00:00:00	1993-10-03	1993-10-03 00:00:00	1993-10-03	38000177		0	0	360		0	0	0	39085	0	1000126	40224805		
43008	938	40213198	2010-12-02	2010-12-02 00:00:00	2010-12-02	2010-12-02 00:00:00	2010-12-02	581452		0	0	0		0	0	0	62367	0	133	40213198		
10025	841	1713671	1997-04-07	1997-04-07 00:00:00	1997-04-28	1997-04-28 00:00:00	1997-04-28	38000177		0	0	21		0	0	0	55575	0	562251	1713671		
7262	608	19133873	1981-04-26	1981-04-26 00:00:00	1981-05-03	1981-05-03 00:00:00	1981-05-03	38000177		0	0	7		0	0	0	40378	0	834061	19133873		
7195	155	40213160	1959-04-17	1959-04-17 00:00:00	1959-04-17	1959-04-17 00:00:00	1959-04-17	581452		0	0	0		0	0	0	10635	0	10	40213160		
48243	3998	1127433	1990-02-05	1990-02-05 00:00:00	1990-02-12	1990-02-12 00:00:00	1990-02-12	38000177		0	0	7		0	0	0	265805	0	313782	1127433		
37856	3128	19008572	1989-12-13	1989-12-13 00:00:00	1990-01-03	1990-01-03 00:00:00	1990-01-03	38000177		0	0	21		0	0	0	208200	0	106258	19008572		
3111	254	1713671	1993-03-08	1993-03-08 00:00:00	1993-04-05	1993-04-05 00:00:00	1993-04-05	38000177		0	0	28		0	0	0	16908	0	562251	1713671		
43329	3592	1127433	1986-05-09	1986-05-09 00:00:00	1986-05-16	1986-05-16 00:00:00	1986-05-16	38000177		0	0	7		0	0	0	238587	0	313782	1127433		
13659	1144	46233988	1971-03-04	1971-03-04 00:00:00	1971-03-18	1971-03-18 00:00:00	1971-03-18	38000177		0	0	14		0	0	0	75503	0	1652673	46233988		
13690	1145	19078461	1977-02-05	1977-02-05 00:00:00	1977-04-06	1977-04-06 00:00:00	1977-04-06	38000177		0	0	60		0	0	0	75556	0	310965	19078461		
31170	2583	19059056	1973-07-20	1973-07-20 00:00:00	1973-08-03	1973-08-03 00:00:00	1973-08-03	38000177		0	0	14		0	0	0	171061	0	243670	19059056		
45773	3789	40236824	1994-06-08	1994-06-08 00:00:00	1994-06-15	1994-06-15 00:00:00	1994-06-15	38000177		0	0	7		0	0	0	251926	0	1094107	40236824		
41700	3454	19075001	2019-03-12	2019-03-12 00:00:00	2019-04-16	2019-04-16 00:00:00	2019-04-16	38000177		0	0	35		0	0	0	229144	0	309097	19075001		
27108	2235	1127433	2012-03-24	2012-03-24 00:00:00	2012-03-31	2012-03-31 00:00:00	2012-03-31	38000177		0	0	7		0	0	0	148693	0	313782	1127433		
41532	905	40213227	2010-10-02	2010-10-02 00:00:00	2010-10-02	2010-10-02 00:00:00	2010-10-02	581452		0	0	0		0	0	0	60211	0	113	40213227		
7478	624	1713671	1992-11-06	1992-11-06 00:00:00	1992-11-13	1992-11-13 00:00:00	1992-11-13	38000177		0	0	7		0	0	0	41662	0	562251	1713671		
154940	3410	40213227	1995-08-09	1995-08-09 00:00:00	1995-08-09	1995-08-09 00:00:00	1995-08-09	581452		0	0	0		0	0	0	226151	0	113	40213227		
42506	3526	19006318	1953-08-22	1953-08-22 00:00:00	1953-09-05	1953-09-05 00:00:00	1953-09-05	38000177		0	0	14		0	0	0	233997	0	105078	19006318		
1896	41	40213227	2016-01-30	2016-01-30 00:00:00	2016-01-30	2016-01-30 00:00:00	2016-01-30	581452		0	0	0		0	0	0	2933	0	113	40213227		
32750	715	40213160	1983-10-25	1983-10-25 00:00:00	1983-10-25	1983-10-25 00:00:00	1983-10-25	581452		0	0	0		0	0	0	47321	0	10	40213160		
43027	3567	19128065	1988-05-27	1988-05-27 00:00:00	1989-05-22	1989-05-22 00:00:00	1989-05-22	38000177		0	0	360		0	0	0	236994	0	749882	19128065		
24850	2043	1127433	1973-12-30	1973-12-30 00:00:00	1974-01-06	1974-01-06 00:00:00	1974-01-06	38000177		0	0	7		0	0	0	135915	0	313782	1127433		
53195	4418	1539411	2008-02-01	2008-02-01 00:00:00	2008-02-01	2008-02-01 00:00:00	\N	38000177		0	0	0		0	0	0	293696	0	312961	1539411		
34236	2829	40174880	2017-08-18	2017-08-18 00:00:00	2017-08-18	2017-08-18 00:00:00	\N	38000177		0	0	0		0	0	0	187647	0	966222	40174880		
2095	165	40236824	2005-07-12	2005-07-12 00:00:00	2005-07-19	2005-07-19 00:00:00	2005-07-19	38000177		0	0	7		0	0	0	11315	0	1094107	40236824		
34339	2836	920300	2011-01-05	2011-01-05 00:00:00	2011-01-12	2011-01-12 00:00:00	2011-01-12	38000177		0	0	7		0	0	0	188388	0	311989	920300		
46014	3811	1127433	1991-11-23	1991-11-23 00:00:00	1991-12-07	1991-12-07 00:00:00	1991-12-07	38000177		0	0	14		0	0	0	253216	0	313782	1127433		
36654	3025	19006318	1950-05-25	1950-05-25 00:00:00	1950-06-08	1950-06-08 00:00:00	1950-06-08	38000177		0	0	14		0	0	0	201645	0	105078	19006318		
30724	2546	1127078	1976-01-22	1976-01-22 00:00:00	1976-02-12	1976-02-12 00:00:00	1976-02-12	38000177		0	0	21		0	0	0	168458	0	282464	1127078		
64372	5343	19133905	2008-08-11	2008-08-11 00:00:00	2008-08-24	2008-08-24 00:00:00	2008-08-24	38000177		0	0	13		0	0	0	355935	0	834102	19133905		
134008	2942	40213296	1996-12-04	1996-12-04 00:00:00	1996-12-04	1996-12-04 00:00:00	1996-12-04	581452		0	0	0		0	0	0	196140	0	52	40213296		
1757	141	19075001	1987-10-31	1987-10-31 00:00:00	1987-11-14	1987-11-14 00:00:00	1987-11-14	38000177		0	0	14		0	0	0	9443	0	309097	19075001		
1503	119	19059056	1967-05-28	1967-05-28 00:00:00	1967-07-27	1967-07-27 00:00:00	1967-07-27	38000177		0	0	60		0	0	0	7923	0	243670	19059056		
44433	3678	1127078	1978-06-15	1978-06-15 00:00:00	1978-06-29	1978-06-29 00:00:00	1978-06-29	38000177		0	0	14		0	0	0	244610	0	282464	1127078		
4495	372	1127433	1996-03-30	1996-03-30 00:00:00	1996-04-13	1996-04-13 00:00:00	1996-04-13	38000177		0	0	14		0	0	0	24716	0	313782	1127433		
141888	3117	40213227	1996-02-14	1996-02-14 00:00:00	1996-02-14	1996-02-14 00:00:00	1996-02-14	581452		0	0	0		0	0	0	207366	0	113	40213227		
96370	2114	40213227	2007-02-07	2007-02-07 00:00:00	2007-02-07	2007-02-07 00:00:00	2007-02-07	581452		0	0	0		0	0	0	140665	0	113	40213227		
28349	616	40213227	2010-01-09	2010-01-09 00:00:00	2010-01-09	2010-01-09 00:00:00	2010-01-09	581452		0	0	0		0	0	0	41103	0	113	40213227		
18654	1540	1115171	1998-09-21	1998-09-21 00:00:00	1998-10-05	1998-10-05 00:00:00	1998-10-05	38000177		0	0	14		0	0	0	103187	0	849574	1115171		
60472	5031	40231925	1982-10-07	1982-10-07 00:00:00	1982-10-07	1982-10-07 00:00:00	\N	38000177		0	0	0		0	0	0	334280	0	1049221	40231925		
163718	3601	40213227	2000-10-27	2000-10-27 00:00:00	2000-10-27	2000-10-27 00:00:00	2000-10-27	581452		0	0	0		0	0	0	239210	0	113	40213227		
22855	1879	1713671	1965-10-02	1965-10-02 00:00:00	1965-10-23	1965-10-23 00:00:00	1965-10-23	38000177		0	0	21		0	0	0	125370	0	562251	1713671		
15798	1314	19059056	1935-05-03	1935-05-03 00:00:00	1935-05-17	1935-05-17 00:00:00	1935-05-17	38000177		0	0	14		0	0	0	87055	0	243670	19059056		
15849	1317	1332419	2009-12-25	2009-12-25 00:00:00	2009-12-25	2009-12-25 00:00:00	\N	38000177		0	0	0		0	0	0	87331	0	197361	1332419		
94057	2064	40213314	1977-06-15	1977-06-15 00:00:00	1977-06-15	1977-06-15 00:00:00	1977-06-15	581452		0	0	0		0	0	0	137264	0	49	40213314		
39893	3301	1115171	2011-05-31	2011-05-31 00:00:00	2011-07-30	2011-07-30 00:00:00	2011-07-30	38000177		0	0	60		0	0	0	219287	0	849574	1115171		
44237	3661	1713671	1994-03-27	1994-03-27 00:00:00	1994-04-17	1994-04-17 00:00:00	1994-04-17	38000177		0	0	21		0	0	0	243655	0	562251	1713671		
36496	3010	40220960	2015-03-18	2015-03-18 00:00:00	2015-03-18	2015-03-18 00:00:00	2015-03-18	38000177		0	0	0		0	0	0	200792	0	1804799	40220960		
11379	948	1127078	1967-05-12	1967-05-12 00:00:00	1967-08-10	1967-08-10 00:00:00	1967-08-10	38000177		0	0	90		0	0	0	62961	0	282464	1127078		
25461	2091	1127433	2004-01-01	2004-01-01 00:00:00	2004-01-15	2004-01-15 00:00:00	2004-01-15	38000177		0	0	14		0	0	0	139445	0	313782	1127433		
54631	4538	1127433	2009-06-08	2009-06-08 00:00:00	2009-06-22	2009-06-22 00:00:00	2009-06-22	38000177		0	0	14		0	0	0	302352	0	313782	1127433		
164336	3614	40213160	1955-04-17	1955-04-17 00:00:00	1955-04-17	1955-04-17 00:00:00	1955-04-17	581452		0	0	0		0	0	0	240093	0	10	40213160		
12878	1082	19078461	2011-02-18	2011-02-18 00:00:00	2011-03-04	2011-03-04 00:00:00	2011-03-04	38000177		0	0	14		0	0	0	71024	0	310965	19078461		
13299	1115	19133905	1967-01-29	1967-01-29 00:00:00	1967-02-08	1967-02-08 00:00:00	1967-02-08	38000177		0	0	10		0	0	0	73452	0	834102	19133905		
12849	277	40213227	2006-01-10	2006-01-10 00:00:00	2006-01-10	2006-01-10 00:00:00	2006-01-10	581452		0	0	0		0	0	0	18464	0	113	40213227		
2652	212	19074843	1980-04-14	1980-04-14 00:00:00	1980-04-28	1980-04-28 00:00:00	1980-04-28	38000177		0	0	14		0	0	0	14415	0	309045	19074843		
103270	2265	40213306	1985-11-17	1985-11-17 00:00:00	1985-11-17	1985-11-17 00:00:00	1985-11-17	581452		0	0	0		0	0	0	150531	0	43	40213306		
101710	2230	40213160	1973-10-25	1973-10-25 00:00:00	1973-10-25	1973-10-25 00:00:00	1973-10-25	581452		0	0	0		0	0	0	148365	0	10	40213160		
58387	4852	19133905	1966-10-12	1966-10-12 00:00:00	1966-10-22	1966-10-22 00:00:00	1966-10-22	38000177		0	0	10		0	0	0	322831	0	834102	19133905		
60059	4991	1127433	1985-04-23	1985-04-23 00:00:00	1985-05-07	1985-05-07 00:00:00	1985-05-07	38000177		0	0	14		0	0	0	332021	0	313782	1127433		
43323	3592	40229134	2007-04-01	2007-04-01 00:00:00	2007-04-15	2007-04-15 00:00:00	2007-04-15	38000177		0	0	14		0	0	0	238571	0	1043400	40229134		
53832	4474	19133873	1969-10-22	1969-10-22 00:00:00	1969-10-30	1969-10-30 00:00:00	1969-10-30	38000177		0	0	8		0	0	0	297696	0	834061	19133873		
54922	1202	40213227	2011-10-09	2011-10-09 00:00:00	2011-10-09	2011-10-09 00:00:00	2011-10-09	581452		0	0	0		0	0	0	79040	0	113	40213227		
7021	592	1713671	2012-11-11	2012-11-11 00:00:00	2012-11-18	2012-11-18 00:00:00	2012-11-18	38000177		0	0	7		0	0	0	39083	0	562251	1713671		
43011	938	40213201	2011-12-08	2011-12-08 00:00:00	2011-12-08	2011-12-08 00:00:00	2011-12-08	581452		0	0	0		0	0	0	62337	0	33	40213201		
10026	841	1127433	2017-08-23	2017-08-23 00:00:00	2017-09-20	2017-09-20 00:00:00	2017-09-20	38000177		0	0	28		0	0	0	55511	0	313782	1127433		
7263	608	1127433	2004-03-27	2004-03-27 00:00:00	2004-04-03	2004-04-03 00:00:00	2004-04-03	38000177		0	0	7		0	0	0	40383	0	313782	1127433		
27285	2256	19128022	1994-07-26	1994-07-26 00:00:00	1995-07-21	1995-07-21 00:00:00	1995-07-21	38000177		0	0	360		0	0	0	149952	0	749785	19128022		
48244	3998	1713671	1991-05-25	1991-05-25 00:00:00	1991-06-15	1991-06-15 00:00:00	1991-06-15	38000177		0	0	21		0	0	0	265859	0	562251	1713671		
37857	3129	1127433	1972-02-13	1972-02-13 00:00:00	1972-02-20	1972-02-20 00:00:00	1972-02-20	38000177		0	0	7		0	0	0	208287	0	313782	1127433		
7753	648	1127433	1980-04-13	1980-04-13 00:00:00	1980-04-27	1980-04-27 00:00:00	1980-04-27	38000177		0	0	14		0	0	0	42903	0	313782	1127433		
43330	3593	19006318	1957-12-18	1957-12-18 00:00:00	1958-01-01	1958-01-01 00:00:00	1958-01-01	38000177		0	0	14		0	0	0	238677	0	105078	19006318		
13660	1144	1127078	1971-03-04	1971-03-04 00:00:00	1971-03-18	1971-03-18 00:00:00	1971-03-18	38000177		0	0	14		0	0	0	75503	0	282464	1127078		
13691	1145	40162522	1977-02-05	1977-02-05 00:00:00	1977-02-05	1977-02-05 00:00:00	\N	38000177		0	0	0		0	0	0	75556	0	857005	40162522		
31171	2583	19006318	1973-07-20	1973-07-20 00:00:00	1973-08-03	1973-08-03 00:00:00	1973-08-03	38000177		0	0	14		0	0	0	171061	0	105078	19006318		
45774	3789	920300	1994-06-08	1994-06-08 00:00:00	1994-06-15	1994-06-15 00:00:00	1994-06-15	38000177		0	0	7		0	0	0	251926	0	311989	920300		
41701	3454	1127433	2019-03-12	2019-03-12 00:00:00	2019-04-16	2019-04-16 00:00:00	2019-04-16	38000177		0	0	35		0	0	0	229144	0	313782	1127433		
27109	2235	1713671	2002-10-10	2002-10-10 00:00:00	2002-10-17	2002-10-17 00:00:00	2002-10-17	38000177		0	0	7		0	0	0	148638	0	562251	1713671		
41533	905	40213160	1969-03-01	1969-03-01 00:00:00	1969-03-01	1969-03-01 00:00:00	1969-03-01	581452		0	0	0		0	0	0	60218	0	10	40213160		
7479	624	1127433	1961-11-07	1961-11-07 00:00:00	1961-11-14	1961-11-14 00:00:00	1961-11-14	38000177		0	0	7		0	0	0	41682	0	313782	1127433		
154950	3410	40213306	1986-07-30	1986-07-30 00:00:00	1986-07-30	1986-07-30 00:00:00	1986-07-30	581452		0	0	0		0	0	0	226220	0	43	40213306		
42507	3526	1127078	1953-08-22	1953-08-22 00:00:00	1953-09-05	1953-09-05 00:00:00	1953-09-05	38000177		0	0	14		0	0	0	233997	0	282464	1127078		
1897	41	40213296	2016-01-30	2016-01-30 00:00:00	2016-01-30	2016-01-30 00:00:00	2016-01-30	581452		0	0	0		0	0	0	2933	0	52	40213296		
32756	715	40213314	1984-04-24	1984-04-24 00:00:00	1984-04-24	1984-04-24 00:00:00	1984-04-24	581452		0	0	0		0	0	0	47338	0	49	40213314		
43028	3567	40229134	1991-12-21	1991-12-21 00:00:00	1992-01-04	1992-01-04 00:00:00	1992-01-04	38000177		0	0	14		0	0	0	237047	0	1043400	40229134		
24851	2043	19133873	1970-05-28	1970-05-28 00:00:00	1970-06-04	1970-06-04 00:00:00	1970-06-04	38000177		0	0	7		0	0	0	135894	0	834061	19133873		
53196	4418	1332419	2008-02-01	2008-02-01 00:00:00	2008-02-01	2008-02-01 00:00:00	\N	38000177		0	0	0		0	0	0	293696	0	197361	1332419		
34237	2829	19059056	1951-01-02	1951-01-02 00:00:00	1951-01-16	1951-01-16 00:00:00	1951-01-16	38000177		0	0	14		0	0	0	187639	0	243670	19059056		
2096	165	1127433	2013-04-15	2013-04-15 00:00:00	2013-06-14	2013-06-14 00:00:00	2013-06-14	38000177		0	0	60		0	0	0	11329	0	313782	1127433		
34340	2836	1127078	1984-02-13	1984-02-13 00:00:00	1984-04-13	1984-04-13 00:00:00	1984-04-13	38000177		0	0	60		0	0	0	188372	0	282464	1127078		
54973	1205	40213160	1960-06-30	1960-06-30 00:00:00	1960-06-30	1960-06-30 00:00:00	1960-06-30	581452		0	0	0		0	0	0	79205	0	10	40213160		
36655	3025	19126352	1949-10-31	1949-10-31 00:00:00	2002-10-14	2002-10-14 00:00:00	2002-10-14	38000177		0	0	19341		0	0	0	201680	0	705129	19126352		
35682	2942	19008572	1964-09-03	1964-09-03 00:00:00	1964-09-24	1964-09-24 00:00:00	1964-09-24	38000177		0	0	21		0	0	0	196129	0	106258	19008572		
64373	5343	19133873	1991-03-04	1991-03-04 00:00:00	1991-03-16	1991-03-16 00:00:00	1991-03-16	38000177		0	0	12		0	0	0	355861	0	834061	19133873		
134010	2942	40213198	2019-04-17	2019-04-17 00:00:00	2019-04-17	2019-04-17 00:00:00	2019-04-17	581452		0	0	0		0	0	0	196151	0	133	40213198		
1758	141	19128065	1999-02-19	1999-02-19 00:00:00	2000-02-14	2000-02-14 00:00:00	2000-02-14	38000177		0	0	360		0	0	0	9444	0	749882	19128065		
1504	119	19075001	2015-02-15	2015-02-15 00:00:00	2015-03-01	2015-03-01 00:00:00	2015-03-01	38000177		0	0	14		0	0	0	7872	0	309097	19075001		
44434	3678	46233988	1978-06-15	1978-06-15 00:00:00	1978-06-29	1978-06-29 00:00:00	1978-06-29	38000177		0	0	14		0	0	0	244610	0	1652673	46233988		
4496	374	1127433	2004-07-10	2004-07-10 00:00:00	2004-07-17	2004-07-17 00:00:00	2004-07-17	38000177		0	0	7		0	0	0	24842	0	313782	1127433		
141889	3117	40213306	1996-02-14	1996-02-14 00:00:00	1996-02-14	1996-02-14 00:00:00	1996-02-14	581452		0	0	0		0	0	0	207366	0	43	40213306		
96371	2114	40213296	2007-02-07	2007-02-07 00:00:00	2007-02-07	2007-02-07 00:00:00	2007-02-07	581452		0	0	0		0	0	0	140665	0	52	40213296		
28350	616	40213227	2001-01-13	2001-01-13 00:00:00	2001-01-13	2001-01-13 00:00:00	2001-01-13	581452		0	0	0		0	0	0	41098	0	113	40213227		
18655	1540	19073188	1998-09-21	1998-09-21 00:00:00	1998-10-05	1998-10-05 00:00:00	1998-10-05	38000177		0	0	14		0	0	0	103187	0	308192	19073188		
60473	5031	1127433	1982-10-07	1982-10-07 00:00:00	1982-10-28	1982-10-28 00:00:00	1982-10-28	38000177		0	0	21		0	0	0	334280	0	313782	1127433		
163719	3601	40213296	2000-10-27	2000-10-27 00:00:00	2000-10-27	2000-10-27 00:00:00	2000-10-27	581452		0	0	0		0	0	0	239210	0	52	40213296		
22856	1879	1127433	1983-02-23	1983-02-23 00:00:00	1983-03-23	1983-03-23 00:00:00	1983-03-23	38000177		0	0	28		0	0	0	125368	0	313782	1127433		
15799	1314	1127433	1998-10-04	1998-10-04 00:00:00	1998-10-11	1998-10-11 00:00:00	1998-10-11	38000177		0	0	7		0	0	0	87050	0	313782	1127433		
15850	1317	19075601	2009-12-25	2009-12-25 00:00:00	2009-12-25	2009-12-25 00:00:00	\N	38000177		0	0	0		0	0	0	87331	0	309362	19075601		
94064	2064	40213160	1981-03-18	1981-03-18 00:00:00	1981-03-18	1981-03-18 00:00:00	1981-03-18	581452		0	0	0		0	0	0	137275	0	10	40213160		
39894	3301	19133873	1939-11-27	1939-11-27 00:00:00	1939-12-09	1939-12-09 00:00:00	1939-12-09	38000177		0	0	12		0	0	0	219303	0	834061	19133873		
44238	3661	920334	2008-03-12	2008-03-12 00:00:00	2008-03-19	2008-03-19 00:00:00	2008-03-19	38000177		0	0	7		0	0	0	243622	0	311995	920334		
36497	3010	1127433	1980-10-06	1980-10-06 00:00:00	1980-12-05	1980-12-05 00:00:00	1980-12-05	38000177		0	0	60		0	0	0	200798	0	313782	1127433		
11380	948	19059056	1960-05-11	1960-05-11 00:00:00	1960-05-25	1960-05-25 00:00:00	1960-05-25	38000177		0	0	14		0	0	0	62943	0	243670	19059056		
25462	2091	1713671	1967-09-08	1967-09-08 00:00:00	1967-09-15	1967-09-15 00:00:00	1967-09-15	38000177		0	0	7		0	0	0	139472	0	562251	1713671		
54632	4538	1127433	1972-10-02	1972-10-02 00:00:00	1972-11-08	1972-11-08 00:00:00	1972-11-08	38000177		0	0	37		0	0	0	302314	0	313782	1127433		
164344	3614	40213227	1992-07-12	1992-07-12 00:00:00	1992-07-12	1992-07-12 00:00:00	1992-07-12	581452		0	0	0		0	0	0	\N	0	113	40213227		
12879	1082	1713671	1986-04-17	1986-04-17 00:00:00	1986-04-24	1986-04-24 00:00:00	1986-04-24	38000177		0	0	7		0	0	0	70908	0	562251	1713671		
13300	1115	1127433	1984-11-14	1984-11-14 00:00:00	1984-12-05	1984-12-05 00:00:00	1984-12-05	38000177		0	0	21		0	0	0	73388	0	313782	1127433		
12850	277	40213296	2006-01-10	2006-01-10 00:00:00	2006-01-10	2006-01-10 00:00:00	2006-01-10	581452		0	0	0		0	0	0	18464	0	52	40213296		
2653	212	1127433	2007-04-20	2007-04-20 00:00:00	2007-05-11	2007-05-11 00:00:00	2007-05-11	38000177		0	0	21		0	0	0	14438	0	313782	1127433		
103272	2265	40213160	1963-05-26	1963-05-26 00:00:00	1963-05-26	1963-05-26 00:00:00	1963-05-26	581452		0	0	0		0	0	0	150598	0	10	40213160		
101711	2230	40213306	1996-12-12	1996-12-12 00:00:00	1996-12-12	1996-12-12 00:00:00	1996-12-12	581452		0	0	0		0	0	0	148384	0	43	40213306		
58388	4852	1118084	1990-09-17	1990-09-17 00:00:00	1990-09-17	1990-09-17 00:00:00	\N	38000177		0	0	0		0	0	0	322808	0	00025152531	44923712		
60060	4991	1127433	1976-04-16	1976-04-16 00:00:00	1976-04-23	1976-04-23 00:00:00	1976-04-23	38000177		0	0	7		0	0	0	332071	0	313782	1127433		
43324	3592	1713671	1981-10-26	1981-10-26 00:00:00	1981-11-09	1981-11-09 00:00:00	1981-11-09	38000177		0	0	14		0	0	0	238570	0	562251	1713671		
53833	4474	19133873	1972-07-19	1972-07-19 00:00:00	1972-07-28	1972-07-28 00:00:00	1972-07-28	38000177		0	0	9		0	0	0	297641	0	834061	19133873		
54925	1202	40213314	1981-09-13	1981-09-13 00:00:00	1981-09-13	1981-09-13 00:00:00	1981-09-13	581452		0	0	0		0	0	0	79078	0	49	40213314		
7022	592	1713671	1993-08-30	1993-08-30 00:00:00	1993-09-13	1993-09-13 00:00:00	1993-09-13	38000177		0	0	14		0	0	0	39129	0	562251	1713671		
43015	938	40213227	2006-11-09	2006-11-09 00:00:00	2006-11-09	2006-11-09 00:00:00	2006-11-09	581452		0	0	0		0	0	0	62358	0	113	40213227		
10027	841	1118084	1991-05-26	1991-05-26 00:00:00	1991-05-26	1991-05-26 00:00:00	\N	38000177		0	0	0		0	0	0	55515	0	00025152531	44923712		
7264	608	1127433	1988-04-04	1988-04-04 00:00:00	1988-04-18	1988-04-18 00:00:00	1988-04-18	38000177		0	0	14		0	0	0	40407	0	313782	1127433		
27286	2256	1127078	1985-05-04	1985-05-04 00:00:00	1985-07-03	1985-07-03 00:00:00	1985-07-03	38000177		0	0	60		0	0	0	149936	0	282464	1127078		
48245	3998	46275916	1982-08-26	1982-08-26 00:00:00	1982-08-26	1982-08-26 00:00:00	1982-08-26	38000177		0	0	0		0	0	0	265792	0	1660014	46275916		
37858	3129	1713671	2012-04-15	2012-04-15 00:00:00	2012-04-29	2012-04-29 00:00:00	2012-04-29	38000177		0	0	14		0	0	0	208252	0	562251	1713671		
7754	648	1127433	1936-10-27	1936-10-27 00:00:00	1936-11-10	1936-11-10 00:00:00	1936-11-10	38000177		0	0	14		0	0	0	42946	0	313782	1127433		
43331	3593	19059056	1957-12-18	1957-12-18 00:00:00	1958-01-01	1958-01-01 00:00:00	1958-01-01	38000177		0	0	14		0	0	0	238677	0	243670	19059056		
13661	1144	19059056	1990-10-04	1990-10-04 00:00:00	1990-11-08	1990-11-08 00:00:00	1990-11-08	38000177		0	0	35		0	0	0	75496	0	243670	19059056		
13692	1145	1127433	1977-03-12	1977-03-12 00:00:00	1977-03-26	1977-03-26 00:00:00	1977-03-26	38000177		0	0	14		0	0	0	75573	0	313782	1127433		
31172	2583	1127433	1985-10-26	1985-10-26 00:00:00	1985-11-09	1985-11-09 00:00:00	1985-11-09	38000177		0	0	14		0	0	0	171019	0	313782	1127433		
19971	1640	19078461	1992-03-17	1992-03-17 00:00:00	1992-03-31	1992-03-31 00:00:00	1992-03-31	38000177		0	0	14		0	0	0	110030	0	310965	19078461		
41702	3454	1118084	2016-10-19	2016-10-19 00:00:00	2016-10-19	2016-10-19 00:00:00	\N	38000177		0	0	0		0	0	0	229180	0	00025152531	44923712		
27113	2237	1127433	1936-05-05	1936-05-05 00:00:00	1936-05-12	1936-05-12 00:00:00	1936-05-12	38000177		0	0	7		0	0	0	148744	0	313782	1127433		
41535	905	40213160	1973-02-10	1973-02-10 00:00:00	1973-02-10	1973-02-10 00:00:00	1973-02-10	581452		0	0	0		0	0	0	\N	0	10	40213160		
7480	624	1127433	1968-07-27	1968-07-27 00:00:00	1968-08-17	1968-08-17 00:00:00	1968-08-17	38000177		0	0	21		0	0	0	41692	0	313782	1127433		
154953	3410	40213160	1964-09-23	1964-09-23 00:00:00	1964-09-23	1964-09-23 00:00:00	1964-09-23	581452		0	0	0		0	0	0	226199	0	10	40213160		
42508	3526	19006318	1951-05-21	1951-05-21 00:00:00	1951-06-04	1951-06-04 00:00:00	1951-06-04	38000177		0	0	14		0	0	0	233947	0	105078	19006318		
1900	41	40213160	1973-09-01	1973-09-01 00:00:00	1973-09-01	1973-09-01 00:00:00	1973-09-01	581452		0	0	0		0	0	0	2957	0	10	40213160		
32757	715	40213251	1984-04-24	1984-04-24 00:00:00	1984-04-24	1984-04-24 00:00:00	1984-04-24	581452		0	0	0		0	0	0	47338	0	21	40213251		
43030	3567	19059056	1972-11-29	1972-11-29 00:00:00	1972-12-13	1972-12-13 00:00:00	1972-12-13	38000177		0	0	14		0	0	0	237054	0	243670	19059056		
24852	2043	1118084	1997-08-21	1997-08-21 00:00:00	1997-08-21	1997-08-21 00:00:00	\N	38000177		0	0	0		0	0	0	135905	0	00025152531	44923712		
53197	4418	1127433	2010-01-20	2010-01-20 00:00:00	2010-01-27	2010-01-27 00:00:00	2010-01-27	38000177		0	0	7		0	0	0	293752	0	313782	1127433		
34238	2829	1127433	1992-10-18	1992-10-18 00:00:00	1992-11-01	1992-11-01 00:00:00	1992-11-01	38000177		0	0	14		0	0	0	187634	0	313782	1127433		
2097	165	46233988	1972-08-20	1972-08-20 00:00:00	1972-09-03	1972-09-03 00:00:00	1972-09-03	38000177		0	0	14		0	0	0	11356	0	1652673	46233988		
34341	2836	19133905	2001-02-02	2001-02-02 00:00:00	2001-02-13	2001-02-13 00:00:00	2001-02-13	38000177		0	0	11		0	0	0	188387	0	834102	19133905		
54978	1205	40213227	1994-09-08	1994-09-08 00:00:00	1994-09-08	1994-09-08 00:00:00	1994-09-08	581452		0	0	0		0	0	0	79198	0	113	40213227		
36656	3025	19059056	1946-10-22	1946-10-22 00:00:00	1946-11-05	1946-11-05 00:00:00	1946-11-05	38000177		0	0	14		0	0	0	201644	0	243670	19059056		
35683	2942	19059056	1954-05-25	1954-05-25 00:00:00	1954-06-24	1954-06-24 00:00:00	1954-06-24	38000177		0	0	30		0	0	0	196054	0	243670	19059056		
64374	5343	1127433	1998-09-10	1998-09-10 00:00:00	1998-11-09	1998-11-09 00:00:00	1998-11-09	38000177		0	0	60		0	0	0	355928	0	313782	1127433		
111419	2448	40213227	2015-07-22	2015-07-22 00:00:00	2015-07-22	2015-07-22 00:00:00	2015-07-22	581452		0	0	0		0	0	0	162376	0	113	40213227		
29563	2447	1115171	2011-02-09	2011-02-09 00:00:00	2011-03-09	2011-03-09 00:00:00	2011-03-09	38000177		0	0	28		0	0	0	162324	0	849574	1115171		
1505	119	19078461	2015-02-15	2015-02-15 00:00:00	2015-03-01	2015-03-01 00:00:00	2015-03-01	38000177		0	0	14		0	0	0	7872	0	310965	19078461		
44435	3678	40229134	2016-02-16	2016-02-16 00:00:00	2016-02-23	2016-02-23 00:00:00	2016-02-23	38000177		0	0	7		0	0	0	244589	0	1043400	40229134		
4497	374	1127433	1993-11-24	1993-11-24 00:00:00	1993-12-29	1993-12-29 00:00:00	1993-12-29	38000177		0	0	35		0	0	0	24847	0	313782	1127433		
141895	3117	40213227	2005-02-23	2005-02-23 00:00:00	2005-02-23	2005-02-23 00:00:00	2005-02-23	581452		0	0	0		0	0	0	207339	0	113	40213227		
96378	2114	40213260	2015-01-28	2015-01-28 00:00:00	2015-01-28	2015-01-28 00:00:00	2015-01-28	581452		0	0	0		0	0	0	140641	0	121	40213260		
28351	616	40213296	2001-01-13	2001-01-13 00:00:00	2001-01-13	2001-01-13 00:00:00	2001-01-13	581452		0	0	0		0	0	0	41098	0	52	40213296		
18656	1540	19133873	1960-01-23	1960-01-23 00:00:00	1960-01-30	1960-01-30 00:00:00	1960-01-30	38000177		0	0	7		0	0	0	103212	0	834061	19133873		
60474	5031	19074841	1982-10-07	1982-10-07 00:00:00	1982-10-28	1982-10-28 00:00:00	1982-10-28	38000177		0	0	21		0	0	0	334280	0	309043	19074841		
163721	3601	40213160	1960-02-26	1960-02-26 00:00:00	1960-02-26	1960-02-26 00:00:00	1960-02-26	581452		0	0	0		0	0	0	239236	0	10	40213160		
22857	1879	40165015	1994-11-25	1994-11-25 00:00:00	1994-11-25	1994-11-25 00:00:00	\N	38000177		0	0	0		0	0	0	125382	0	861467	40165015		
15800	1314	40165015	1946-07-22	1946-07-22 00:00:00	1946-07-22	1946-07-22 00:00:00	\N	38000177		0	0	0		0	0	0	87046	0	861467	40165015		
15851	1317	1539411	2009-12-25	2009-12-25 00:00:00	2009-12-25	2009-12-25 00:00:00	\N	38000177		0	0	0		0	0	0	87331	0	312961	1539411		
94067	2064	40213306	1996-07-10	1996-07-10 00:00:00	1996-07-10	1996-07-10 00:00:00	1996-07-10	581452		0	0	0		0	0	0	137310	0	43	40213306		
39895	3301	1713671	2008-07-12	2008-07-12 00:00:00	2008-08-02	2008-08-02 00:00:00	2008-08-02	38000177		0	0	21		0	0	0	219284	0	562251	1713671		
44239	3661	1127433	1988-01-13	1988-01-13 00:00:00	1988-01-27	1988-01-27 00:00:00	1988-01-27	38000177		0	0	14		0	0	0	243654	0	313782	1127433		
36498	3010	40231925	1980-10-06	1980-10-06 00:00:00	1980-10-06	1980-10-06 00:00:00	\N	38000177		0	0	0		0	0	0	200798	0	1049221	40231925		
11381	948	19006318	1960-05-11	1960-05-11 00:00:00	1960-05-25	1960-05-25 00:00:00	1960-05-25	38000177		0	0	14		0	0	0	62943	0	105078	19006318		
25463	2091	19059056	1965-06-12	1965-06-12 00:00:00	1965-06-26	1965-06-26 00:00:00	1965-06-26	38000177		0	0	14		0	0	0	139444	0	243670	19059056		
54634	4538	1713671	2012-11-25	2012-11-25 00:00:00	2012-12-02	2012-12-02 00:00:00	2012-12-02	38000177		0	0	7		0	0	0	302354	0	562251	1713671		
164354	3615	40213160	1955-08-17	1955-08-17 00:00:00	1955-08-17	1955-08-17 00:00:00	1955-08-17	581452		0	0	0		0	0	0	240229	0	10	40213160		
12880	1083	1127433	2006-11-12	2006-11-12 00:00:00	2006-11-19	2006-11-19 00:00:00	2006-11-19	38000177		0	0	7		0	0	0	71174	0	313782	1127433		
13301	1115	19059056	1958-01-14	1958-01-14 00:00:00	1958-02-13	1958-02-13 00:00:00	1958-02-13	38000177		0	0	30		0	0	0	73385	0	243670	19059056		
12855	277	40213260	2013-12-31	2013-12-31 00:00:00	2013-12-31	2013-12-31 00:00:00	2013-12-31	581452		0	0	0		0	0	0	18496	0	121	40213260		
2655	212	1118084	2012-12-30	2012-12-30 00:00:00	2012-12-30	2012-12-30 00:00:00	\N	38000177		0	0	0		0	0	0	14452	0	00025152531	44923712		
103273	2265	40213160	1963-07-28	1963-07-28 00:00:00	1963-07-28	1963-07-28 00:00:00	1963-07-28	581452		0	0	0		0	0	0	150510	0	10	40213160		
101713	2230	40213227	1996-12-12	1996-12-12 00:00:00	1996-12-12	1996-12-12 00:00:00	1996-12-12	581452		0	0	0		0	0	0	148384	0	113	40213227		
58389	4852	40236824	1994-02-06	1994-02-06 00:00:00	1994-02-20	1994-02-20 00:00:00	1994-02-20	38000177		0	0	14		0	0	0	322852	0	1094107	40236824		
60061	4991	19059056	1973-03-31	1973-03-31 00:00:00	1973-04-21	1973-04-21 00:00:00	1973-04-21	38000177		0	0	21		0	0	0	332052	0	243670	19059056		
43325	3592	1713671	2005-11-08	2005-11-08 00:00:00	2005-11-29	2005-11-29 00:00:00	2005-11-29	38000177		0	0	21		0	0	0	238632	0	562251	1713671		
53834	4475	1127433	2014-10-18	2014-10-18 00:00:00	2014-10-25	2014-10-25 00:00:00	2014-10-25	38000177		0	0	7		0	0	0	297742	0	313782	1127433		
132702	2914	40213260	2006-10-07	2006-10-07 00:00:00	2006-10-07	2006-10-07 00:00:00	2006-10-07	581452		0	0	0		0	0	0	194163	0	121	40213260		
7023	592	1127433	1975-08-01	1975-08-01 00:00:00	1975-08-08	1975-08-08 00:00:00	1975-08-08	38000177		0	0	7		0	0	0	39127	0	313782	1127433		
43029	938	40213227	1996-09-12	1996-09-12 00:00:00	1996-09-12	1996-09-12 00:00:00	1996-09-12	581452		0	0	0		0	0	0	62403	0	113	40213227		
10028	841	19008572	1965-07-04	1965-07-04 00:00:00	1965-07-25	1965-07-25 00:00:00	1965-07-25	38000177		0	0	21		0	0	0	55524	0	106258	19008572		
7265	608	19126352	1999-07-21	1999-07-21 00:00:00	2005-07-13	2005-07-13 00:00:00	2005-07-13	38000177		0	0	2184		0	0	0	40356	0	705129	19126352		
27287	2256	40229134	1989-11-11	1989-11-11 00:00:00	1989-11-25	1989-11-25 00:00:00	1989-11-25	38000177		0	0	14		0	0	0	149965	0	1043400	40229134		
48246	3998	1310034	1982-08-26	1982-08-26 00:00:00	1982-08-26	1982-08-26 00:00:00	1982-08-26	38000177		0	0	0		0	0	0	265792	0	834357	1310034		
37859	3129	19128022	1992-04-07	1992-04-07 00:00:00	1993-04-02	1993-04-02 00:00:00	1993-04-02	38000177		0	0	360		0	0	0	208281	0	749785	19128022		
7755	648	1127433	1994-11-05	1994-11-05 00:00:00	1994-11-12	1994-11-12 00:00:00	1994-11-12	38000177		0	0	7		0	0	0	42952	0	313782	1127433		
43332	3593	1127433	1974-06-17	1974-06-17 00:00:00	1974-07-01	1974-07-01 00:00:00	1974-07-01	38000177		0	0	14		0	0	0	238702	0	313782	1127433		
13662	1144	40229134	1999-06-27	1999-06-27 00:00:00	1999-07-04	1999-07-04 00:00:00	1999-07-04	38000177		0	0	7		0	0	0	75517	0	1043400	40229134		
13693	1145	1127433	2012-08-14	2012-08-14 00:00:00	2012-08-28	2012-08-28 00:00:00	2012-08-28	38000177		0	0	14		0	0	0	75571	0	313782	1127433		
31173	2583	19133873	1973-02-01	1973-02-01 00:00:00	1973-02-09	1973-02-09 00:00:00	1973-02-09	38000177		0	0	8		0	0	0	171048	0	834061	19133873		
19972	1640	19133905	2005-03-24	2005-03-24 00:00:00	2005-04-06	2005-04-06 00:00:00	2005-04-06	38000177		0	0	13		0	0	0	110103	0	834102	19133905		
41703	3454	1127433	2014-08-24	2014-08-24 00:00:00	2014-08-31	2014-08-31 00:00:00	2014-08-31	38000177		0	0	7		0	0	0	229148	0	313782	1127433		
27114	2237	1127433	1960-06-15	1960-06-15 00:00:00	1960-06-29	1960-06-29 00:00:00	1960-06-29	38000177		0	0	14		0	0	0	148848	0	313782	1127433		
118055	2596	40213227	1997-12-27	1997-12-27 00:00:00	1997-12-27	1997-12-27 00:00:00	1997-12-27	581452		0	0	0		0	0	0	171803	0	113	40213227		
7481	624	19059056	1964-07-22	1964-07-22 00:00:00	1964-08-19	1964-08-19 00:00:00	1964-08-19	38000177		0	0	28		0	0	0	41690	0	243670	19059056		
215722	4731	40213160	1972-04-11	1972-04-11 00:00:00	1972-04-11	1972-04-11 00:00:00	1972-04-11	581452		0	0	0		0	0	0	315198	0	10	40213160		
42509	3526	19059056	1951-05-21	1951-05-21 00:00:00	1951-06-04	1951-06-04 00:00:00	1951-06-04	38000177		0	0	14		0	0	0	233947	0	243670	19059056		
1904	41	40213314	1977-04-23	1977-04-23 00:00:00	1977-04-23	1977-04-23 00:00:00	1977-04-23	581452		0	0	0		0	0	0	2960	0	49	40213314		
44038	959	40213296	1998-04-01	1998-04-01 00:00:00	1998-04-01	1998-04-01 00:00:00	1998-04-01	581452		0	0	0		0	0	0	63734	0	52	40213296		
43031	3567	1127433	2002-06-29	2002-06-29 00:00:00	2002-07-13	2002-07-13 00:00:00	2002-07-13	38000177		0	0	14		0	0	0	237050	0	313782	1127433		
24853	2043	1713671	2017-10-08	2017-10-08 00:00:00	2017-10-15	2017-10-15 00:00:00	2017-10-15	38000177		0	0	7		0	0	0	135876	0	562251	1713671		
53198	4418	19078461	1994-07-23	1994-07-23 00:00:00	1994-08-06	1994-08-06 00:00:00	1994-08-06	38000177		0	0	14		0	0	0	293746	0	310965	19078461		
34239	2829	1127433	1959-01-21	1959-01-21 00:00:00	1959-02-04	1959-02-04 00:00:00	1959-02-04	38000177		0	0	14		0	0	0	187631	0	313782	1127433		
2098	165	1127078	1972-08-20	1972-08-20 00:00:00	1972-09-03	1972-09-03 00:00:00	1972-09-03	38000177		0	0	14		0	0	0	11356	0	282464	1127078		
34342	2836	1127078	1991-11-24	1991-11-24 00:00:00	1991-12-15	1991-12-15 00:00:00	1991-12-15	38000177		0	0	21		0	0	0	188374	0	282464	1127078		
54985	1205	40213227	2001-08-02	2001-08-02 00:00:00	2001-08-02	2001-08-02 00:00:00	2001-08-02	581452		0	0	0		0	0	0	\N	0	113	40213227		
36657	3025	19006318	1946-10-22	1946-10-22 00:00:00	1946-11-05	1946-11-05 00:00:00	1946-11-05	38000177		0	0	14		0	0	0	201644	0	105078	19006318		
35684	2942	19133905	2003-01-13	2003-01-13 00:00:00	2003-01-24	2003-01-24 00:00:00	2003-01-24	38000177		0	0	11		0	0	0	196221	0	834102	19133905		
64375	5343	1551192	1984-04-26	1984-04-26 00:00:00	1984-04-26	1984-04-26 00:00:00	1984-04-26	38000177		0	0	0		0	0	0	355926	0	312617	1551192		
111420	2448	40213160	1964-12-23	1964-12-23 00:00:00	1964-12-23	1964-12-23 00:00:00	1964-12-23	581452		0	0	0		0	0	0	162393	0	10	40213160		
29564	2447	40229134	1995-07-24	1995-07-24 00:00:00	1995-08-07	1995-08-07 00:00:00	1995-08-07	38000177		0	0	14		0	0	0	162311	0	1043400	40229134		
1506	119	920334	2012-04-01	2012-04-01 00:00:00	2012-04-08	2012-04-08 00:00:00	2012-04-08	38000177		0	0	7		0	0	0	7928	0	311995	920334		
44436	3678	1118084	2017-07-30	2017-07-30 00:00:00	2017-07-30	2017-07-30 00:00:00	\N	38000177		0	0	0		0	0	0	244589	0	00025152531	44923712		
4498	374	1115171	1995-01-23	1995-01-23 00:00:00	1995-02-20	1995-02-20 00:00:00	1995-02-20	38000177		0	0	28		0	0	0	24848	0	849574	1115171		
141902	3117	40213160	1974-04-10	1974-04-10 00:00:00	1974-04-10	1974-04-10 00:00:00	1974-04-10	581452		0	0	0		0	0	0	207358	0	10	40213160		
96381	2114	40213160	1970-01-07	1970-01-07 00:00:00	1970-01-07	1970-01-07 00:00:00	1970-01-07	581452		0	0	0		0	0	0	140633	0	10	40213160		
28355	616	40213160	1963-12-14	1963-12-14 00:00:00	1963-12-14	1963-12-14 00:00:00	1963-12-14	581452		0	0	0		0	0	0	41126	0	10	40213160		
18657	1540	1713671	1965-04-11	1965-04-11 00:00:00	1965-05-30	1965-05-30 00:00:00	1965-05-30	38000177		0	0	49		0	0	0	103168	0	562251	1713671		
60475	5031	19115351	1941-05-24	1941-05-24 00:00:00	1941-10-25	1941-10-25 00:00:00	1941-10-25	38000177		0	0	154		0	0	0	334344	0	563026	19115351		
163729	3601	40213227	1992-06-19	1992-06-19 00:00:00	1992-06-19	1992-06-19 00:00:00	1992-06-19	581452		0	0	0		0	0	0	239126	0	113	40213227		
22858	1879	1115171	1994-11-25	1994-11-25 00:00:00	1995-01-24	1995-01-24 00:00:00	1995-01-24	38000177		0	0	60		0	0	0	125382	0	849574	1115171		
15801	1314	1713671	1996-06-22	1996-06-22 00:00:00	1996-10-12	1996-10-12 00:00:00	1996-10-12	38000177		0	0	112		0	0	0	86972	0	562251	1713671		
15852	1317	1115171	1999-01-18	1999-01-18 00:00:00	1999-02-01	1999-02-01 00:00:00	1999-02-01	38000177		0	0	14		0	0	0	87279	0	849574	1115171		
94069	2064	40213227	1999-07-14	1999-07-14 00:00:00	1999-07-14	1999-07-14 00:00:00	1999-07-14	581452		0	0	0		0	0	0	137311	0	113	40213227		
39896	3301	19133905	1996-07-08	1996-07-08 00:00:00	1996-07-21	1996-07-21 00:00:00	1996-07-21	38000177		0	0	13		0	0	0	219267	0	834102	19133905		
44240	3661	1118084	2016-02-18	2016-02-18 00:00:00	2016-02-18	2016-02-18 00:00:00	\N	38000177		0	0	0		0	0	0	243692	0	00025152531	44923712		
36499	3010	19133873	1964-12-12	1964-12-12 00:00:00	1964-12-22	1964-12-22 00:00:00	1964-12-22	38000177		0	0	10		0	0	0	200794	0	834061	19133873		
11382	948	1124300	1998-03-03	1998-03-03 00:00:00	1998-03-03	1998-03-03 00:00:00	\N	38000177		0	0	0		0	0	0	62912	0	00781178901	45011828		
25464	2091	19006318	1965-06-12	1965-06-12 00:00:00	1965-06-26	1965-06-26 00:00:00	1965-06-26	38000177		0	0	14		0	0	0	139444	0	105078	19006318		
54635	4538	1115171	2003-12-26	2003-12-26 00:00:00	2004-01-09	2004-01-09 00:00:00	2004-01-09	38000177		0	0	14		0	0	0	302316	0	849574	1115171		
2495	199	1127433	2010-02-04	2010-02-04 00:00:00	2010-02-18	2010-02-18 00:00:00	2010-02-18	38000177		0	0	14		0	0	0	13694	0	313782	1127433		
12881	1083	1551192	1980-05-06	1980-05-06 00:00:00	1980-05-06	1980-05-06 00:00:00	1980-05-06	38000177		0	0	0		0	0	0	71057	0	312617	1551192		
13302	1115	1127433	1950-06-27	1950-06-27 00:00:00	1950-07-04	1950-07-04 00:00:00	1950-07-04	38000177		0	0	7		0	0	0	73489	0	313782	1127433		
12858	277	40213160	1964-03-10	1964-03-10 00:00:00	1964-03-10	1964-03-10 00:00:00	1964-03-10	581452		0	0	0		0	0	0	18471	0	10	40213160		
2656	212	19073188	1996-04-15	1996-04-15 00:00:00	1996-04-29	1996-04-29 00:00:00	1996-04-29	38000177		0	0	14		0	0	0	14417	0	308192	19073188		
103275	2265	40213160	1963-10-27	1963-10-27 00:00:00	1963-10-27	1963-10-27 00:00:00	1963-10-27	581452		0	0	0		0	0	0	150526	0	10	40213160		
101715	2230	40213160	1978-05-04	1978-05-04 00:00:00	1978-05-04	1978-05-04 00:00:00	1978-05-04	581452		0	0	0		0	0	0	148368	0	10	40213160		
58390	4852	920300	1994-02-06	1994-02-06 00:00:00	1994-02-13	1994-02-13 00:00:00	1994-02-13	38000177		0	0	7		0	0	0	322852	0	311989	920300		
60062	4991	19128065	1987-06-26	1987-06-26 00:00:00	1988-06-20	1988-06-20 00:00:00	1988-06-20	38000177		0	0	360		0	0	0	332061	0	749882	19128065		
43326	3592	920300	2016-02-18	2016-02-18 00:00:00	2016-02-25	2016-02-25 00:00:00	2016-02-25	38000177		0	0	7		0	0	0	238582	0	311989	920300		
6093	510	19059056	1969-09-28	1969-09-28 00:00:00	1969-10-12	1969-10-12 00:00:00	1969-10-12	38000177		0	0	14		0	0	0	34095	0	243670	19059056		
132707	2915	40213227	2006-04-09	2006-04-09 00:00:00	2006-04-09	2006-04-09 00:00:00	2006-04-09	581452		0	0	0		0	0	0	194368	0	113	40213227		
7024	592	1713671	1995-03-14	1995-03-14 00:00:00	1995-03-28	1995-03-28 00:00:00	1995-03-28	38000177		0	0	14		0	0	0	39112	0	562251	1713671		
7070	596	19133905	1972-01-09	1972-01-09 00:00:00	1972-01-17	1972-01-17 00:00:00	1972-01-17	38000177		0	0	8		0	0	0	39383	0	834102	19133905		
10029	841	1713671	1994-06-23	1994-06-23 00:00:00	1994-07-14	1994-07-14 00:00:00	1994-07-14	38000177		0	0	21		0	0	0	55563	0	562251	1713671		
7266	608	1539411	1999-07-21	1999-07-21 00:00:00	1999-07-21	1999-07-21 00:00:00	\N	38000177		0	0	0		0	0	0	40356	0	312961	1539411		
27288	2256	42902245	2000-06-24	2000-06-24 00:00:00	2001-06-19	2001-06-19 00:00:00	2001-06-19	38000177		0	0	360		0	0	0	149957	0	1359133	42902245		
48247	3998	40243436	1982-08-26	1982-08-26 00:00:00	1982-08-26	1982-08-26 00:00:00	1982-08-26	38000177		0	0	0		0	0	0	265792	0	1190795	40243436		
37860	3129	19078461	1998-03-27	1998-03-27 00:00:00	1998-05-26	1998-05-26 00:00:00	1998-05-26	38000177		0	0	60		0	0	0	208248	0	310965	19078461		
7756	648	1127433	1963-07-07	1963-07-07 00:00:00	1963-08-11	1963-08-11 00:00:00	1963-08-11	38000177		0	0	35		0	0	0	42962	0	313782	1127433		
43333	3593	19018935	2017-06-14	2017-06-14 00:00:00	2017-06-14	2017-06-14 00:00:00	\N	38000177		0	0	0		0	0	0	238652	0	197604	19018935		
13663	1144	1115171	2009-05-02	2009-05-02 00:00:00	2009-07-01	2009-07-01 00:00:00	2009-07-01	38000177		0	0	60		0	0	0	75498	0	849574	1115171		
13694	1145	19133873	1939-04-24	1939-04-24 00:00:00	1939-05-06	1939-05-06 00:00:00	1939-05-06	38000177		0	0	12		0	0	0	75582	0	834061	19133873		
31174	2583	19128022	1989-05-16	1989-05-16 00:00:00	1990-05-11	1990-05-11 00:00:00	1990-05-11	38000177		0	0	360		0	0	0	171037	0	749785	19128022		
19973	1640	19075601	2015-06-10	2015-06-10 00:00:00	2015-06-10	2015-06-10 00:00:00	2015-06-10	38000177		0	0	0		0	0	0	110067	0	309362	19075601		
41704	3454	1127433	1995-10-02	1995-10-02 00:00:00	1995-10-09	1995-10-09 00:00:00	1995-10-09	38000177		0	0	7		0	0	0	229196	0	313782	1127433		
27115	2237	1124300	1967-01-16	1967-01-16 00:00:00	1967-01-16	1967-01-16 00:00:00	\N	38000177		0	0	0		0	0	0	148774	0	00781178901	45011828		
118060	2596	40213160	1967-07-08	1967-07-08 00:00:00	1967-07-08	1967-07-08 00:00:00	1967-07-08	581452		0	0	0		0	0	0	171779	0	10	40213160		
7482	625	1118084	2014-02-13	2014-02-13 00:00:00	2014-02-13	2014-02-13 00:00:00	\N	38000177		0	0	0		0	0	0	41787	0	00025152531	44923712		
215731	4732	40213227	2016-09-25	2016-09-25 00:00:00	2016-09-25	2016-09-25 00:00:00	2016-09-25	581452		0	0	0		0	0	0	315315	0	113	40213227		
42510	3526	19059056	1966-10-13	1966-10-13 00:00:00	1966-11-17	1966-11-17 00:00:00	1966-11-17	38000177		0	0	35		0	0	0	234002	0	243670	19059056		
40869	3389	1124300	1996-06-08	1996-06-08 00:00:00	1996-06-08	1996-06-08 00:00:00	\N	38000177		0	0	0		0	0	0	224764	0	00781178901	45011828		
44040	959	40213227	1992-04-22	1992-04-22 00:00:00	1992-04-22	1992-04-22 00:00:00	1992-04-22	581452		0	0	0		0	0	0	63762	0	113	40213227		
43032	3567	1713671	2011-02-25	2011-02-25 00:00:00	2011-03-11	2011-03-11 00:00:00	2011-03-11	38000177		0	0	14		0	0	0	237008	0	562251	1713671		
24854	2043	1127433	1995-09-23	1995-09-23 00:00:00	1995-09-30	1995-09-30 00:00:00	1995-09-30	38000177		0	0	7		0	0	0	135935	0	313782	1127433		
53199	4418	1127433	1992-10-21	1992-10-21 00:00:00	1992-10-28	1992-10-28 00:00:00	1992-10-28	38000177		0	0	7		0	0	0	293719	0	313782	1127433		
34240	2829	19006318	1952-06-06	1952-06-06 00:00:00	1952-06-20	1952-06-20 00:00:00	1952-06-20	38000177		0	0	14		0	0	0	187640	0	105078	19006318		
2099	165	19128065	1986-05-19	1986-05-19 00:00:00	1987-05-14	1987-05-14 00:00:00	1987-05-14	38000177		0	0	360		0	0	0	11331	0	749882	19128065		
34343	2836	1127433	1998-09-09	1998-09-09 00:00:00	1998-10-14	1998-10-14 00:00:00	1998-10-14	38000177		0	0	35		0	0	0	188375	0	313782	1127433		
54986	1205	40213296	2001-08-02	2001-08-02 00:00:00	2001-08-02	2001-08-02 00:00:00	2001-08-02	581452		0	0	0		0	0	0	\N	0	52	40213296		
36659	3025	19008572	1971-12-02	1971-12-02 00:00:00	1971-12-02	1971-12-02 00:00:00	\N	38000177		0	0	0		0	0	0	201565	0	106258	19008572		
35685	2942	19073188	1979-01-20	1979-01-20 00:00:00	1979-02-03	1979-02-03 00:00:00	1979-02-03	38000177		0	0	14		0	0	0	196192	0	308192	19073188		
64376	5343	1127433	1985-01-23	1985-01-23 00:00:00	1985-01-30	1985-01-30 00:00:00	1985-01-30	38000177		0	0	7		0	0	0	355858	0	313782	1127433		
111423	2448	40213160	1965-03-24	1965-03-24 00:00:00	1965-03-24	1965-03-24 00:00:00	1965-03-24	581452		0	0	0		0	0	0	162369	0	10	40213160		
29565	2447	1124300	2017-02-27	2017-02-27 00:00:00	2017-02-27	2017-02-27 00:00:00	\N	38000177		0	0	0		0	0	0	162330	0	00781178901	45011828		
1507	119	19078461	2008-12-18	2008-12-18 00:00:00	2009-01-08	2009-01-08 00:00:00	2009-01-08	38000177		0	0	21		0	0	0	7924	0	310965	19078461		
33879	2802	19059056	1944-03-12	1944-03-12 00:00:00	1944-04-09	1944-04-09 00:00:00	1944-04-09	38000177		0	0	28		0	0	0	185708	0	243670	19059056		
4499	374	1124300	2015-07-17	2015-07-17 00:00:00	2015-07-17	2015-07-17 00:00:00	\N	38000177		0	0	0		0	0	0	24836	0	00781178901	45011828		
166026	3650	40213227	1998-06-05	1998-06-05 00:00:00	1998-06-05	1998-06-05 00:00:00	1998-06-05	581452		0	0	0		0	0	0	242962	0	113	40213227		
96383	2114	40213227	1996-05-15	1996-05-15 00:00:00	1996-05-15	1996-05-15 00:00:00	1996-05-15	581452		0	0	0		0	0	0	\N	0	113	40213227		
28361	616	40213160	1959-04-11	1959-04-11 00:00:00	1959-04-11	1959-04-11 00:00:00	1959-04-11	581452		0	0	0		0	0	0	41074	0	10	40213160		
18658	1540	40162522	1973-04-10	1973-04-10 00:00:00	1973-04-10	1973-04-10 00:00:00	\N	38000177		0	0	0		0	0	0	103154	0	857005	40162522		
60476	5031	19059056	1924-08-03	1924-08-03 00:00:00	1924-08-17	1924-08-17 00:00:00	1924-08-17	38000177		0	0	14		0	0	0	334357	0	243670	19059056		
163733	3601	40213260	2010-06-18	2010-06-18 00:00:00	2010-06-18	2010-06-18 00:00:00	2010-06-18	581452		0	0	0		0	0	0	239205	0	121	40213260		
22859	1879	40229134	1980-05-12	1980-05-12 00:00:00	1980-05-26	1980-05-26 00:00:00	1980-05-26	38000177		0	0	14		0	0	0	125371	0	1043400	40229134		
15802	1314	19059056	1930-10-13	1930-10-13 00:00:00	1930-10-27	1930-10-27 00:00:00	1930-10-27	38000177		0	0	14		0	0	0	87058	0	243670	19059056		
15853	1317	1713671	2010-08-28	2010-08-28 00:00:00	2010-09-18	2010-09-18 00:00:00	2010-09-18	38000177		0	0	21		0	0	0	87249	0	562251	1713671		
94070	2064	40213306	1999-07-14	1999-07-14 00:00:00	1999-07-14	1999-07-14 00:00:00	1999-07-14	581452		0	0	0		0	0	0	137311	0	43	40213306		
39897	3301	1127433	2016-12-30	2016-12-30 00:00:00	2017-01-13	2017-01-13 00:00:00	2017-01-13	38000177		0	0	14		0	0	0	219288	0	313782	1127433		
44241	3661	1127433	1980-08-02	1980-08-02 00:00:00	1980-08-16	1980-08-16 00:00:00	1980-08-16	38000177		0	0	14		0	0	0	243642	0	313782	1127433		
36500	3010	1713671	1989-03-30	1989-03-30 00:00:00	1989-04-13	1989-04-13 00:00:00	1989-04-13	38000177		0	0	14		0	0	0	200782	0	562251	1713671		
11383	948	1127433	1974-05-09	1974-05-09 00:00:00	1974-05-23	1974-05-23 00:00:00	1974-05-23	38000177		0	0	14		0	0	0	62916	0	313782	1127433		
25465	2091	40229134	1967-12-31	1967-12-31 00:00:00	1968-01-07	1968-01-07 00:00:00	1968-01-07	38000177		0	0	7		0	0	0	139441	0	1043400	40229134		
54636	4538	920334	2012-06-11	2012-06-11 00:00:00	2012-06-18	2012-06-18 00:00:00	2012-06-18	38000177		0	0	7		0	0	0	302392	0	311995	920334		
2496	199	19059056	1945-12-21	1945-12-21 00:00:00	1946-01-04	1946-01-04 00:00:00	1946-01-04	38000177		0	0	14		0	0	0	13696	0	243670	19059056		
12882	1083	19008572	1967-12-23	1967-12-23 00:00:00	1968-01-13	1968-01-13 00:00:00	1968-01-13	38000177		0	0	21		0	0	0	71065	0	106258	19008572		
13303	1115	1127078	1954-01-05	1954-01-05 00:00:00	1954-01-19	1954-01-19 00:00:00	1954-01-19	38000177		0	0	14		0	0	0	73469	0	282464	1127078		
48855	4051	1127433	1995-11-23	1995-11-23 00:00:00	1995-12-07	1995-12-07 00:00:00	1995-12-07	38000177		0	0	14		0	0	0	269252	0	313782	1127433		
13115	1101	1127433	1993-09-09	1993-09-09 00:00:00	1993-09-16	1993-09-16 00:00:00	1993-09-16	38000177		0	0	7		0	0	0	72352	0	313782	1127433		
103277	2265	40213260	2013-08-25	2013-08-25 00:00:00	2013-08-25	2013-08-25 00:00:00	2013-08-25	581452		0	0	0		0	0	0	150585	0	121	40213260		
101719	2230	40213296	2014-01-02	2014-01-02 00:00:00	2014-01-02	2014-01-02 00:00:00	2014-01-02	581452		0	0	0		0	0	0	148413	0	52	40213296		
58391	4852	1713671	1986-10-24	1986-10-24 00:00:00	1986-10-30	1986-10-30 00:00:00	1986-10-30	38000177		0	0	6		0	0	0	322834	0	562251	1713671		
60063	4991	1127078	1971-09-08	1971-09-08 00:00:00	1971-09-22	1971-09-22 00:00:00	1971-09-22	38000177		0	0	14		0	0	0	332076	0	282464	1127078		
53785	4472	19059056	1955-09-25	1955-09-25 00:00:00	1955-10-16	1955-10-16 00:00:00	1955-10-16	38000177		0	0	21		0	0	0	297544	0	243670	19059056		
6094	510	40236446	1975-09-30	1975-09-30 00:00:00	1983-10-08	1983-10-08 00:00:00	1983-10-08	38000177		0	0	2930		0	0	0	34072	0	1091392	40236446		
132721	2915	40213227	2015-08-16	2015-08-16 00:00:00	2015-08-16	2015-08-16 00:00:00	2015-08-16	581452		0	0	0		0	0	0	194370	0	113	40213227		
7025	592	19128065	1985-11-14	1985-11-14 00:00:00	1986-11-09	1986-11-09 00:00:00	1986-11-09	38000177		0	0	360		0	0	0	39130	0	749882	19128065		
7071	596	40223774	2001-12-31	2001-12-31 00:00:00	2001-12-31	2001-12-31 00:00:00	\N	38000177		0	0	0		0	0	0	39376	0	998582	40223774		
10030	841	19008572	1961-12-07	1961-12-07 00:00:00	1961-12-21	1961-12-21 00:00:00	1961-12-21	38000177		0	0	14		0	0	0	55522	0	106258	19008572		
7267	608	19075601	1999-07-21	1999-07-21 00:00:00	2005-07-13	2005-07-13 00:00:00	2005-07-13	38000177		0	0	2184		0	0	0	40356	0	309362	19075601		
27297	2258	1127433	1977-11-25	1977-11-25 00:00:00	1978-02-23	1978-02-23 00:00:00	1978-02-23	38000177		0	0	90		0	0	0	150058	0	313782	1127433		
48248	3998	19059056	1970-09-09	1970-09-09 00:00:00	1970-11-08	1970-11-08 00:00:00	1970-11-08	38000177		0	0	60		0	0	0	265849	0	243670	19059056		
37861	3129	1127433	2008-08-31	2008-08-31 00:00:00	2008-09-30	2008-09-30 00:00:00	2008-09-30	38000177		0	0	30		0	0	0	208249	0	313782	1127433		
7757	649	19133873	1975-09-19	1975-09-19 00:00:00	1975-10-02	1975-10-02 00:00:00	1975-10-02	38000177		0	0	13		0	0	0	43016	0	834061	19133873		
43334	3593	40171902	2017-06-14	2017-06-14 00:00:00	2017-06-14	2017-06-14 00:00:00	\N	38000177		0	0	0		0	0	0	238652	0	897718	40171902		
13664	1144	1127433	2003-01-04	2003-01-04 00:00:00	2003-02-03	2003-02-03 00:00:00	2003-02-03	38000177		0	0	30		0	0	0	75497	0	313782	1127433		
13695	1145	1713671	1995-04-22	1995-04-22 00:00:00	1995-05-06	1995-05-06 00:00:00	1995-05-06	38000177		0	0	14		0	0	0	75569	0	562251	1713671		
31175	2583	19059056	1973-01-30	1973-01-30 00:00:00	1973-02-13	1973-02-13 00:00:00	1973-02-13	38000177		0	0	14		0	0	0	171029	0	243670	19059056		
19974	1640	40220960	2015-06-10	2015-06-10 00:00:00	2015-06-10	2015-06-10 00:00:00	2015-06-10	38000177		0	0	0		0	0	0	110067	0	1804799	40220960		
41705	3454	19059056	1983-09-11	1983-09-11 00:00:00	1983-09-25	1983-09-25 00:00:00	1983-09-25	38000177		0	0	14		0	0	0	229149	0	243670	19059056		
27116	2237	19059056	1931-10-27	1931-10-27 00:00:00	1931-11-10	1931-11-10 00:00:00	1931-11-10	38000177		0	0	14		0	0	0	148767	0	243670	19059056		
118062	2596	40213306	1988-12-17	1988-12-17 00:00:00	1988-12-17	1988-12-17 00:00:00	1988-12-17	581452		0	0	0		0	0	0	171800	0	43	40213306		
7483	625	19133873	1979-06-17	1979-06-17 00:00:00	1979-06-28	1979-06-28 00:00:00	1979-06-28	38000177		0	0	11		0	0	0	41741	0	834061	19133873		
215733	4732	40213160	1960-07-03	1960-07-03 00:00:00	1960-07-03	1960-07-03 00:00:00	1960-07-03	581452		0	0	0		0	0	0	315306	0	10	40213160		
42511	3526	1124300	1986-06-06	1986-06-06 00:00:00	1986-06-06	1986-06-06 00:00:00	\N	38000177		0	0	0		0	0	0	233970	0	00781178901	45011828		
40870	3389	1127078	1961-01-18	1961-01-18 00:00:00	1961-02-01	1961-02-01 00:00:00	1961-02-01	38000177		0	0	14		0	0	0	224782	0	282464	1127078		
44041	959	40213227	2009-04-01	2009-04-01 00:00:00	2009-04-01	2009-04-01 00:00:00	2009-04-01	581452		0	0	0		0	0	0	63796	0	113	40213227		
43033	3567	1127433	2012-03-03	2012-03-03 00:00:00	2012-03-17	2012-03-17 00:00:00	2012-03-17	38000177		0	0	14		0	0	0	237052	0	313782	1127433		
24855	2044	1713671	2015-05-17	2015-05-17 00:00:00	2015-05-31	2015-05-31 00:00:00	2015-05-31	38000177		0	0	14		0	0	0	135981	0	562251	1713671		
53200	4419	1127078	1959-07-02	1959-07-02 00:00:00	1959-08-06	1959-08-06 00:00:00	1959-08-06	38000177		0	0	35		0	0	0	293817	0	282464	1127078		
34241	2829	1127078	1952-06-06	1952-06-06 00:00:00	1952-06-20	1952-06-20 00:00:00	1952-06-20	38000177		0	0	14		0	0	0	187640	0	282464	1127078		
2100	165	1127433	1992-09-23	1992-09-23 00:00:00	1992-09-30	1992-09-30 00:00:00	1992-09-30	38000177		0	0	7		0	0	0	11313	0	313782	1127433		
34344	2836	40229134	1994-12-19	1994-12-19 00:00:00	1994-12-26	1994-12-26 00:00:00	1994-12-26	38000177		0	0	7		0	0	0	188354	0	1043400	40229134		
54988	1205	40213260	2010-09-02	2010-09-02 00:00:00	2010-09-02	2010-09-02 00:00:00	2010-09-02	581452		0	0	0		0	0	0	79211	0	121	40213260		
36662	3025	1332419	1995-03-06	1995-03-06 00:00:00	1995-03-06	1995-03-06 00:00:00	\N	38000177		0	0	0		0	0	0	201652	0	197361	1332419		
35686	2942	19059056	1979-01-20	1979-01-20 00:00:00	1979-02-03	1979-02-03 00:00:00	1979-02-03	38000177		0	0	14		0	0	0	196192	0	243670	19059056		
64377	5343	1127078	1988-05-28	1988-05-28 00:00:00	1988-06-11	1988-06-11 00:00:00	1988-06-11	38000177		0	0	14		0	0	0	355827	0	282464	1127078		
111425	2448	40213260	2014-07-16	2014-07-16 00:00:00	2014-07-16	2014-07-16 00:00:00	2014-07-16	581452		0	0	0		0	0	0	162400	0	121	40213260		
29566	2447	40169281	2017-10-11	2017-10-11 00:00:00	2017-10-11	2017-10-11 00:00:00	\N	38000177		0	0	0		0	0	0	162331	0	896209	40169281		
1508	119	1118084	1995-05-01	1995-05-01 00:00:00	1995-05-01	1995-05-01 00:00:00	\N	38000177		0	0	0		0	0	0	7880	0	00025152531	44923712		
33880	2802	1332419	1994-10-15	1994-10-15 00:00:00	1994-10-15	1994-10-15 00:00:00	\N	38000177		0	0	0		0	0	0	185721	0	197361	1332419		
4500	374	19128065	1993-11-04	1993-11-04 00:00:00	1994-10-30	1994-10-30 00:00:00	1994-10-30	38000177		0	0	360		0	0	0	24801	0	749882	19128065		
166040	3650	40213227	2008-02-15	2008-02-15 00:00:00	2008-02-15	2008-02-15 00:00:00	2008-02-15	581452		0	0	0		0	0	0	243008	0	113	40213227		
96391	2114	40213227	2016-02-03	2016-02-03 00:00:00	2016-02-03	2016-02-03 00:00:00	2016-02-03	581452		0	0	0		0	0	0	140680	0	113	40213227		
28366	616	40213160	1959-09-12	1959-09-12 00:00:00	1959-09-12	1959-09-12 00:00:00	1959-09-12	581452		0	0	0		0	0	0	41075	0	10	40213160		
18659	1540	1127433	1973-04-10	1973-04-10 00:00:00	1973-05-10	1973-05-10 00:00:00	1973-05-10	38000177		0	0	30		0	0	0	103154	0	313782	1127433		
60477	5031	40173590	2000-10-14	2000-10-14 00:00:00	2000-10-14	2000-10-14 00:00:00	\N	38000177		0	0	0		0	0	0	334341	0	904419	40173590		
163737	3601	40213296	2002-11-01	2002-11-01 00:00:00	2002-11-01	2002-11-01 00:00:00	2002-11-01	581452		0	0	0		0	0	0	239203	0	52	40213296		
22860	1879	1127433	1984-03-17	1984-03-17 00:00:00	1984-04-07	1984-04-07 00:00:00	1984-04-07	38000177		0	0	21		0	0	0	125369	0	313782	1127433		
15803	1314	1127433	2012-04-22	2012-04-22 00:00:00	2012-05-06	2012-05-06 00:00:00	2012-05-06	38000177		0	0	14		0	0	0	87051	0	313782	1127433		
15854	1317	1713671	1978-07-13	1978-07-13 00:00:00	1978-07-27	1978-07-27 00:00:00	1978-07-27	38000177		0	0	14		0	0	0	87245	0	562251	1713671		
94071	2064	40213251	1984-04-04	1984-04-04 00:00:00	1984-04-04	1984-04-04 00:00:00	1984-04-04	581452		0	0	0		0	0	0	137300	0	21	40213251		
39898	3301	19059056	1938-10-02	1938-10-02 00:00:00	1938-10-16	1938-10-16 00:00:00	1938-10-16	38000177		0	0	14		0	0	0	219270	0	243670	19059056		
44277	3666	19133873	1972-05-27	1972-05-27 00:00:00	1972-06-06	1972-06-06 00:00:00	1972-06-06	38000177		0	0	10		0	0	0	243874	0	834061	19133873		
36501	3010	19059056	1973-07-24	1973-07-24 00:00:00	1973-08-14	1973-08-14 00:00:00	1973-08-14	38000177		0	0	21		0	0	0	200797	0	243670	19059056		
11384	949	1713671	2018-01-13	2018-01-13 00:00:00	2018-01-27	2018-01-27 00:00:00	2018-01-27	38000177		0	0	14		0	0	0	63061	0	562251	1713671		
152950	3367	40213227	2014-03-10	2014-03-10 00:00:00	2014-03-10	2014-03-10 00:00:00	2014-03-10	581452		0	0	0		0	0	0	223324	0	113	40213227		
54637	4538	40231925	1972-10-09	1972-10-09 00:00:00	1972-10-09	1972-10-09 00:00:00	\N	38000177		0	0	0		0	0	0	302360	0	1049221	40231925		
25533	2098	1127433	2005-07-18	2005-07-18 00:00:00	2005-08-01	2005-08-01 00:00:00	2005-08-01	38000177		0	0	14		0	0	0	139841	0	313782	1127433		
12883	1083	1551192	1967-10-11	1967-10-11 00:00:00	1967-10-11	1967-10-11 00:00:00	1967-10-11	38000177		0	0	0		0	0	0	71055	0	312617	1551192		
13304	1115	19006318	1954-01-05	1954-01-05 00:00:00	1954-01-19	1954-01-19 00:00:00	1954-01-19	38000177		0	0	14		0	0	0	73469	0	105078	19006318		
48856	4051	40229134	2005-01-08	2005-01-08 00:00:00	2005-01-15	2005-01-15 00:00:00	2005-01-15	38000177		0	0	7		0	0	0	269267	0	1043400	40229134		
13116	1101	19078461	2009-12-03	2009-12-03 00:00:00	2009-12-31	2009-12-31 00:00:00	2009-12-31	38000177		0	0	28		0	0	0	72329	0	310965	19078461		
114574	2518	40213260	2006-08-25	2006-08-25 00:00:00	2006-08-25	2006-08-25 00:00:00	2006-08-25	581452		0	0	0		0	0	0	166568	0	121	40213260		
101724	2230	40213227	2016-01-07	2016-01-07 00:00:00	2016-01-07	2016-01-07 00:00:00	2016-01-07	581452		0	0	0		0	0	0	148372	0	113	40213227		
58392	4852	1127433	1985-03-19	1985-03-19 00:00:00	1985-04-16	1985-04-16 00:00:00	1985-04-16	38000177		0	0	28		0	0	0	322781	0	313782	1127433		
60064	4991	1594382	1997-08-01	1997-08-01 00:00:00	1997-08-01	1997-08-01 00:00:00	\N	38000177		0	0	0		0	0	0	332033	0	1870230	1594382		
53786	4472	19059056	1938-02-11	1938-02-11 00:00:00	1938-02-25	1938-02-25 00:00:00	1938-02-25	38000177		0	0	14		0	0	0	297528	0	243670	19059056		
6095	510	1127078	1967-06-08	1967-06-08 00:00:00	1967-06-22	1967-06-22 00:00:00	1967-06-22	38000177		0	0	14		0	0	0	34113	0	282464	1127078		
132733	2915	40213198	2010-05-02	2010-05-02 00:00:00	2010-05-02	2010-05-02 00:00:00	2010-05-02	581452		0	0	0		0	0	0	194288	0	133	40213198		
7026	592	1124300	2007-03-09	2007-03-09 00:00:00	2007-03-09	2007-03-09 00:00:00	\N	38000177		0	0	0		0	0	0	39113	0	00781178901	45011828		
7072	596	40223768	2001-03-06	2001-03-06 00:00:00	2001-03-06	2001-03-06 00:00:00	\N	38000177		0	0	0		0	0	0	39323	0	997223	40223768		
56851	1245	40213201	2000-12-08	2000-12-08 00:00:00	2000-12-08	2000-12-08 00:00:00	2000-12-08	581452		0	0	0		0	0	0	81919	0	33	40213201		
7268	608	1332419	1999-07-21	1999-07-21 00:00:00	1999-07-21	1999-07-21 00:00:00	\N	38000177		0	0	0		0	0	0	40356	0	197361	1332419		
27298	2258	40231925	1977-11-25	1977-11-25 00:00:00	1977-11-25	1977-11-25 00:00:00	\N	38000177		0	0	0		0	0	0	150058	0	1049221	40231925		
5815	486	40236824	1998-03-29	1998-03-29 00:00:00	1998-04-05	1998-04-05 00:00:00	1998-04-05	38000177		0	0	7		0	0	0	32508	0	1094107	40236824		
37862	3129	19133905	2009-04-09	2009-04-09 00:00:00	2009-04-17	2009-04-17 00:00:00	2009-04-17	38000177		0	0	8		0	0	0	208251	0	834102	19133905		
7758	649	19133873	1979-09-12	1979-09-12 00:00:00	1979-09-22	1979-09-22 00:00:00	1979-09-22	38000177		0	0	10		0	0	0	43032	0	834061	19133873		
43335	3593	40163554	2017-06-14	2017-06-14 00:00:00	2017-06-14	2017-06-14 00:00:00	\N	38000177		0	0	0		0	0	0	238652	0	855332	40163554		
13665	1144	1127433	1987-10-04	1987-10-04 00:00:00	1987-10-11	1987-10-11 00:00:00	1987-10-11	38000177		0	0	7		0	0	0	75519	0	313782	1127433		
13696	1145	19133905	2018-09-01	2018-09-01 00:00:00	2018-09-10	2018-09-10 00:00:00	2018-09-10	38000177		0	0	9		0	0	0	75546	0	834102	19133905		
31176	2583	19129655	1973-01-30	1973-01-30 00:00:00	1973-02-13	1973-02-13 00:00:00	1973-02-13	38000177		0	0	14		0	0	0	171029	0	789980	19129655		
19975	1640	19077572	2013-08-21	2013-08-21 00:00:00	2013-08-21	2013-08-21 00:00:00	\N	38000177		0	0	0		0	0	0	110027	0	310436	19077572		
41706	3454	19073183	1983-09-11	1983-09-11 00:00:00	1983-09-25	1983-09-25 00:00:00	1983-09-25	38000177		0	0	14		0	0	0	229149	0	308182	19073183		
27117	2237	1127433	2001-11-01	2001-11-01 00:00:00	2001-11-15	2001-11-15 00:00:00	2001-11-15	38000177		0	0	14		0	0	0	148764	0	313782	1127433		
118066	2596	40213160	1967-02-04	1967-02-04 00:00:00	1967-02-04	1967-02-04 00:00:00	1967-02-04	581452		0	0	0		0	0	0	171778	0	10	40213160		
7484	625	19059056	1975-05-24	1975-05-24 00:00:00	1975-06-07	1975-06-07 00:00:00	1975-06-07	38000177		0	0	14		0	0	0	41738	0	243670	19059056		
215743	4732	40213227	1997-08-03	1997-08-03 00:00:00	1997-08-03	1997-08-03 00:00:00	1997-08-03	581452		0	0	0		0	0	0	315269	0	113	40213227		
42512	3526	1713671	1950-05-05	1950-05-05 00:00:00	1950-05-12	1950-05-12 00:00:00	1950-05-12	38000177		0	0	7		0	0	0	233943	0	562251	1713671		
40871	3389	19006318	1961-01-18	1961-01-18 00:00:00	1961-02-01	1961-02-01 00:00:00	1961-02-01	38000177		0	0	14		0	0	0	224782	0	105078	19006318		
44042	959	40213260	2009-04-01	2009-04-01 00:00:00	2009-04-01	2009-04-01 00:00:00	2009-04-01	581452		0	0	0		0	0	0	63796	0	121	40213260		
43034	3567	1124300	2004-05-10	2004-05-10 00:00:00	2004-05-10	2004-05-10 00:00:00	\N	38000177		0	0	0		0	0	0	236991	0	00781178901	45011828		
24856	2044	1713671	1962-12-14	1962-12-14 00:00:00	1962-12-21	1962-12-21 00:00:00	1962-12-21	38000177		0	0	7		0	0	0	135952	0	562251	1713671		
53201	4419	1127433	1956-01-21	1956-01-21 00:00:00	1956-01-28	1956-01-28 00:00:00	1956-01-28	38000177		0	0	7		0	0	0	293859	0	313782	1127433		
34242	2830	1713671	1996-08-12	1996-08-12 00:00:00	1996-08-26	1996-08-26 00:00:00	1996-08-26	38000177		0	0	14		0	0	0	187754	0	562251	1713671		
2102	165	1127433	2012-11-18	2012-11-18 00:00:00	2012-11-25	2012-11-25 00:00:00	2012-11-25	38000177		0	0	7		0	0	0	11316	0	313782	1127433		
34345	2836	19133905	2009-06-04	2009-06-04 00:00:00	2009-06-12	2009-06-12 00:00:00	2009-06-12	38000177		0	0	8		0	0	0	188400	0	834102	19133905		
54994	1205	40213160	1960-03-31	1960-03-31 00:00:00	1960-03-31	1960-03-31 00:00:00	1960-03-31	581452		0	0	0		0	0	0	79220	0	10	40213160		
36663	3025	19078461	1996-02-23	1996-02-23 00:00:00	1996-03-15	1996-03-15 00:00:00	1996-03-15	38000177		0	0	21		0	0	0	201586	0	310965	19078461		
35687	2942	19018935	2016-09-28	2016-09-28 00:00:00	2016-09-28	2016-09-28 00:00:00	\N	38000177		0	0	0		0	0	0	196074	0	197604	19018935		
64378	5343	19073183	1988-05-28	1988-05-28 00:00:00	1988-06-11	1988-06-11 00:00:00	1988-06-11	38000177		0	0	14		0	0	0	355827	0	308182	19073183		
111428	2448	40213306	1986-09-17	1986-09-17 00:00:00	1986-09-17	1986-09-17 00:00:00	1986-09-17	581452		0	0	0		0	0	0	162350	0	43	40213306		
29567	2447	40229134	1985-06-27	1985-06-27 00:00:00	1985-07-04	1985-07-04 00:00:00	1985-07-04	38000177		0	0	7		0	0	0	162303	0	1043400	40229134		
1511	119	1713671	2000-01-23	2000-01-23 00:00:00	2000-02-13	2000-02-13 00:00:00	2000-02-13	38000177		0	0	21		0	0	0	7887	0	562251	1713671		
33881	2802	19075601	1997-11-01	1997-11-01 00:00:00	1997-12-13	1997-12-13 00:00:00	1997-12-13	38000177		0	0	42		0	0	0	185703	0	309362	19075601		
4501	374	40236446	1992-11-04	1992-11-04 00:00:00	1997-11-13	1997-11-13 00:00:00	1997-11-13	38000177		0	0	1835		0	0	0	24798	0	1091392	40236446		
146113	3214	40213160	1972-07-25	1972-07-25 00:00:00	1972-07-25	1972-07-25 00:00:00	1972-07-25	581452		0	0	0		0	0	0	213542	0	10	40213160		
96392	2114	40213260	2016-02-03	2016-02-03 00:00:00	2016-02-03	2016-02-03 00:00:00	2016-02-03	581452		0	0	0		0	0	0	140680	0	121	40213260		
28374	616	40213296	1999-01-09	1999-01-09 00:00:00	1999-01-09	1999-01-09 00:00:00	1999-01-09	581452		0	0	0		0	0	0	41105	0	52	40213296		
18660	1540	1127433	1984-11-27	1984-11-27 00:00:00	1984-12-04	1984-12-04 00:00:00	1984-12-04	38000177		0	0	7		0	0	0	103158	0	313782	1127433		
60478	5031	1127433	1990-08-17	1990-08-17 00:00:00	1990-10-16	1990-10-16 00:00:00	1990-10-16	38000177		0	0	60		0	0	0	334281	0	313782	1127433		
163742	3601	40213160	1964-05-29	1964-05-29 00:00:00	1964-05-29	1964-05-29 00:00:00	1964-05-29	581452		0	0	0		0	0	0	239165	0	10	40213160		
22861	1879	19133873	1967-10-31	1967-10-31 00:00:00	1967-11-13	1967-11-13 00:00:00	1967-11-13	38000177		0	0	13		0	0	0	125434	0	834061	19133873		
15804	1314	19077572	2017-07-15	2017-07-15 00:00:00	2017-07-15	2017-07-15 00:00:00	\N	38000177		0	0	0		0	0	0	87005	0	310436	19077572		
15855	1317	19006318	1952-12-03	1952-12-03 00:00:00	1952-12-08	1952-12-08 00:00:00	1952-12-08	38000177		0	0	5		0	0	0	87283	0	105078	19006318		
94076	2064	40213160	1976-12-15	1976-12-15 00:00:00	1976-12-15	1976-12-15 00:00:00	1976-12-15	581452		0	0	0		0	0	0	137288	0	10	40213160		
39899	3301	1713671	1983-12-02	1983-12-02 00:00:00	1983-12-09	1983-12-09 00:00:00	1983-12-09	38000177		0	0	7		0	0	0	219282	0	562251	1713671		
44278	3666	1127433	1979-12-16	1979-12-16 00:00:00	1979-12-30	1979-12-30 00:00:00	1979-12-30	38000177		0	0	14		0	0	0	243881	0	313782	1127433		
36502	3011	1127078	1983-04-07	1983-04-07 00:00:00	1983-04-28	1983-04-28 00:00:00	1983-04-28	38000177		0	0	21		0	0	0	200802	0	282464	1127078		
11385	949	1127433	2005-10-17	2005-10-17 00:00:00	2005-10-31	2005-10-31 00:00:00	2005-10-31	38000177		0	0	14		0	0	0	63044	0	313782	1127433		
152951	3367	40213260	2014-03-10	2014-03-10 00:00:00	2014-03-10	2014-03-10 00:00:00	2014-03-10	581452		0	0	0		0	0	0	223324	0	121	40213260		
54638	4538	19078461	2011-10-29	2011-10-29 00:00:00	2011-12-28	2011-12-28 00:00:00	2011-12-28	38000177		0	0	60		0	0	0	302317	0	310965	19078461		
25534	2098	1118084	2001-11-06	2001-11-06 00:00:00	2001-11-06	2001-11-06 00:00:00	\N	38000177		0	0	0		0	0	0	139875	0	00025152531	44923712		
12884	1083	1124300	2005-04-29	2005-04-29 00:00:00	2005-04-29	2005-04-29 00:00:00	\N	38000177		0	0	0		0	0	0	71084	0	00781178901	45011828		
57663	4791	1118084	2004-08-03	2004-08-03 00:00:00	2004-08-03	2004-08-03 00:00:00	\N	38000177		0	0	0		0	0	0	318808	0	00025152531	44923712		
48857	4051	1713671	2011-05-30	2011-05-30 00:00:00	2011-06-13	2011-06-13 00:00:00	2011-06-13	38000177		0	0	14		0	0	0	269268	0	562251	1713671		
13117	1101	46275916	1982-08-22	1982-08-22 00:00:00	1982-08-22	1982-08-22 00:00:00	1982-08-22	38000177		0	0	0		0	0	0	72326	0	1660014	46275916		
114577	2518	40213227	1995-06-16	1995-06-16 00:00:00	1995-06-16	1995-06-16 00:00:00	1995-06-16	581452		0	0	0		0	0	0	166589	0	113	40213227		
101725	2230	40213296	2016-01-07	2016-01-07 00:00:00	2016-01-07	2016-01-07 00:00:00	2016-01-07	581452		0	0	0		0	0	0	148372	0	52	40213296		
58393	4852	40236824	1995-04-06	1995-04-06 00:00:00	1995-04-20	1995-04-20 00:00:00	1995-04-20	38000177		0	0	14		0	0	0	322853	0	1094107	40236824		
60065	4991	1107882	1997-08-01	1997-08-01 00:00:00	1997-08-01	1997-08-01 00:00:00	\N	38000177		0	0	0		0	0	0	332033	0	311372	1107882		
53787	4472	19059056	1936-07-06	1936-07-06 00:00:00	1936-07-20	1936-07-20 00:00:00	1936-07-20	38000177		0	0	14		0	0	0	297534	0	243670	19059056		
6096	510	19006318	1967-06-08	1967-06-08 00:00:00	1967-06-22	1967-06-22 00:00:00	1967-06-22	38000177		0	0	14		0	0	0	34113	0	105078	19006318		
44687	3698	1127433	1952-10-28	1952-10-28 00:00:00	1952-11-11	1952-11-11 00:00:00	1952-11-11	38000177		0	0	14		0	0	0	245894	0	313782	1127433		
7027	592	19133873	1975-11-29	1975-11-29 00:00:00	1975-12-09	1975-12-09 00:00:00	1975-12-09	38000177		0	0	10		0	0	0	39111	0	834061	19133873		
7073	596	19059056	1962-10-01	1962-10-01 00:00:00	1962-10-15	1962-10-15 00:00:00	1962-10-15	38000177		0	0	14		0	0	0	39324	0	243670	19059056		
56864	1245	40213227	2006-01-06	2006-01-06 00:00:00	2006-01-06	2006-01-06 00:00:00	2006-01-06	581452		0	0	0		0	0	0	81895	0	113	40213227		
7269	609	19133905	2010-01-03	2010-01-03 00:00:00	2010-01-11	2010-01-11 00:00:00	2010-01-11	38000177		0	0	8		0	0	0	40458	0	834102	19133905		
27299	2258	1118084	1995-01-30	1995-01-30 00:00:00	1995-01-30	1995-01-30 00:00:00	\N	38000177		0	0	0		0	0	0	150085	0	00025152531	44923712		
5816	486	920300	1998-03-29	1998-03-29 00:00:00	1998-04-05	1998-04-05 00:00:00	1998-04-05	38000177		0	0	7		0	0	0	32508	0	311989	920300		
37863	3129	1118084	2014-12-23	2014-12-23 00:00:00	2014-12-23	2014-12-23 00:00:00	\N	38000177		0	0	0		0	0	0	208286	0	00025152531	44923712		
7759	649	40243436	2011-01-25	2011-01-25 00:00:00	2011-01-25	2011-01-25 00:00:00	2011-01-25	38000177		0	0	0		0	0	0	42970	0	1190795	40243436		
43336	3593	1127433	1984-01-01	1984-01-01 00:00:00	1984-01-22	1984-01-22 00:00:00	1984-01-22	38000177		0	0	21		0	0	0	238687	0	313782	1127433		
13666	1144	19133905	2013-09-13	2013-09-13 00:00:00	2013-09-22	2013-09-22 00:00:00	2013-09-22	38000177		0	0	9		0	0	0	75501	0	834102	19133905		
13697	1145	1713671	1944-08-10	1944-08-10 00:00:00	1944-09-07	1944-09-07 00:00:00	1944-09-07	38000177		0	0	28		0	0	0	75539	0	562251	1713671		
31177	2583	1713671	1995-04-04	1995-04-04 00:00:00	1995-04-18	1995-04-18 00:00:00	1995-04-18	38000177		0	0	14		0	0	0	171034	0	562251	1713671		
19976	1640	19133873	1948-05-11	1948-05-11 00:00:00	1948-05-24	1948-05-24 00:00:00	1948-05-24	38000177		0	0	13		0	0	0	110028	0	834061	19133873		
41707	3454	19019979	1986-09-02	1986-09-02 00:00:00	1986-09-16	1986-09-16 00:00:00	1986-09-16	38000177		0	0	14		0	0	0	229177	0	198405	19019979		
27118	2237	19059056	1934-08-18	1934-08-18 00:00:00	1934-09-01	1934-09-01 00:00:00	1934-09-01	38000177		0	0	14		0	0	0	148750	0	243670	19059056		
118071	2596	40213160	1967-04-08	1967-04-08 00:00:00	1967-04-08	1967-04-08 00:00:00	1967-04-08	581452		0	0	0		0	0	0	171749	0	10	40213160		
7485	625	46233988	1975-05-24	1975-05-24 00:00:00	1975-06-07	1975-06-07 00:00:00	1975-06-07	38000177		0	0	14		0	0	0	41738	0	1652673	46233988		
215744	4732	40213296	1997-08-03	1997-08-03 00:00:00	1997-08-03	1997-08-03 00:00:00	1997-08-03	581452		0	0	0		0	0	0	315269	0	52	40213296		
42513	3526	1713671	1977-03-18	1977-03-18 00:00:00	1977-04-08	1977-04-08 00:00:00	1977-04-08	38000177		0	0	21		0	0	0	233992	0	562251	1713671		
40872	3389	1713671	2007-04-01	2007-04-01 00:00:00	2007-04-22	2007-04-22 00:00:00	2007-04-22	38000177		0	0	21		0	0	0	224781	0	562251	1713671		
44051	959	40213296	2000-04-05	2000-04-05 00:00:00	2000-04-05	2000-04-05 00:00:00	2000-04-05	581452		0	0	0		0	0	0	63805	0	52	40213296		
43035	3567	19128065	1987-06-02	1987-06-02 00:00:00	1988-05-27	1988-05-27 00:00:00	1988-05-27	38000177		0	0	360		0	0	0	236993	0	749882	19128065		
24857	2044	1713671	1996-09-24	1996-09-24 00:00:00	1996-10-01	1996-10-01 00:00:00	1996-10-01	38000177		0	0	7		0	0	0	135968	0	562251	1713671		
53202	4419	1124300	1990-12-31	1990-12-31 00:00:00	1990-12-31	1990-12-31 00:00:00	\N	38000177		0	0	0		0	0	0	293852	0	00781178901	45011828		
34243	2830	1127433	1987-10-03	1987-10-03 00:00:00	1987-10-17	1987-10-17 00:00:00	1987-10-17	38000177		0	0	14		0	0	0	187722	0	313782	1127433		
2103	165	1127078	1974-02-11	1974-02-11 00:00:00	1974-02-25	1974-02-25 00:00:00	1974-02-25	38000177		0	0	14		0	0	0	11327	0	282464	1127078		
34346	2836	40236824	2007-09-28	2007-09-28 00:00:00	2007-10-05	2007-10-05 00:00:00	2007-10-05	38000177		0	0	7		0	0	0	188404	0	1094107	40236824		
54996	1205	40213306	1982-08-26	1982-08-26 00:00:00	1982-08-26	1982-08-26 00:00:00	1982-08-26	581452		0	0	0		0	0	0	79161	0	43	40213306		
36664	3025	1127433	1979-09-01	1979-09-01 00:00:00	1979-09-08	1979-09-08 00:00:00	1979-09-08	38000177		0	0	7		0	0	0	201716	0	313782	1127433		
35688	2942	40171902	2016-09-28	2016-09-28 00:00:00	2016-09-28	2016-09-28 00:00:00	\N	38000177		0	0	0		0	0	0	196074	0	897718	40171902		
64379	5343	1150771	1984-05-11	1984-05-11 00:00:00	1984-05-11	1984-05-11 00:00:00	\N	38000177		0	0	0		0	0	0	355857	0	197378	1150771		
111440	2448	40213160	1969-06-25	1969-06-25 00:00:00	1969-06-25	1969-06-25 00:00:00	1969-06-25	581452		0	0	0		0	0	0	162385	0	10	40213160		
29568	2448	1118084	2000-05-22	2000-05-22 00:00:00	2000-05-22	2000-05-22 00:00:00	\N	38000177		0	0	0		0	0	0	162366	0	00025152531	44923712		
1512	119	1713671	1968-04-07	1968-04-07 00:00:00	1968-04-21	1968-04-21 00:00:00	1968-04-21	38000177		0	0	14		0	0	0	7884	0	562251	1713671		
33882	2802	1127433	1993-01-02	1993-01-02 00:00:00	1993-01-16	1993-01-16 00:00:00	1993-01-16	38000177		0	0	14		0	0	0	185714	0	313782	1127433		
4502	374	1127433	1991-03-05	1991-03-05 00:00:00	1991-03-19	1991-03-19 00:00:00	1991-03-19	38000177		0	0	14		0	0	0	24822	0	313782	1127433		
146120	3214	40213160	1972-05-23	1972-05-23 00:00:00	1972-05-23	1972-05-23 00:00:00	1972-05-23	581452		0	0	0		0	0	0	213530	0	10	40213160		
96394	2114	40213160	1965-10-06	1965-10-06 00:00:00	1965-10-06	1965-10-06 00:00:00	1965-10-06	581452		0	0	0		0	0	0	140679	0	10	40213160		
134326	2949	40213227	2011-09-27	2011-09-27 00:00:00	2011-09-27	2011-09-27 00:00:00	2011-09-27	581452		0	0	0		0	0	0	196806	0	113	40213227		
18661	1541	1127433	1983-03-13	1983-03-13 00:00:00	1983-03-27	1983-03-27 00:00:00	1983-03-27	38000177		0	0	14		0	0	0	103301	0	313782	1127433		
60479	5031	1713671	1986-05-31	1986-05-31 00:00:00	1986-06-21	1986-06-21 00:00:00	1986-06-21	38000177		0	0	21		0	0	0	334395	0	562251	1713671		
163748	3601	40213306	1982-03-05	1982-03-05 00:00:00	1982-03-05	1982-03-05 00:00:00	1982-03-05	581452		0	0	0		0	0	0	239124	0	43	40213306		
22862	1879	19059056	1988-04-16	1988-04-16 00:00:00	1988-04-30	1988-04-30 00:00:00	1988-04-30	38000177		0	0	14		0	0	0	125381	0	243670	19059056		
15805	1315	19059056	1962-09-10	1962-09-10 00:00:00	1962-09-24	1962-09-24 00:00:00	1962-09-24	38000177		0	0	14		0	0	0	87119	0	243670	19059056		
15856	1317	1127433	1992-05-05	1992-05-05 00:00:00	1992-05-12	1992-05-12 00:00:00	1992-05-12	38000177		0	0	7		0	0	0	87297	0	313782	1127433		
94080	2064	40213160	1976-09-15	1976-09-15 00:00:00	1976-09-15	1976-09-15 00:00:00	1976-09-15	581452		0	0	0		0	0	0	137263	0	10	40213160		
39900	3301	19059056	1973-01-31	1973-01-31 00:00:00	1973-02-28	1973-02-28 00:00:00	1973-02-28	38000177		0	0	28		0	0	0	219285	0	243670	19059056		
44279	3666	1127433	1991-08-22	1991-08-22 00:00:00	1991-09-05	1991-09-05 00:00:00	1991-09-05	38000177		0	0	14		0	0	0	243860	0	313782	1127433		
36503	3011	19074843	1980-01-09	1980-01-09 00:00:00	1980-01-23	1980-01-23 00:00:00	1980-01-23	38000177		0	0	14		0	0	0	200825	0	309045	19074843		
11386	949	1118084	2000-02-25	2000-02-25 00:00:00	2000-02-25	2000-02-25 00:00:00	\N	38000177		0	0	0		0	0	0	63015	0	00025152531	44923712		
152953	3367	40213160	1963-08-12	1963-08-12 00:00:00	1963-08-12	1963-08-12 00:00:00	1963-08-12	581452		0	0	0		0	0	0	223345	0	10	40213160		
54639	4538	1713671	1997-03-18	1997-03-18 00:00:00	1997-04-08	1997-04-08 00:00:00	1997-04-08	38000177		0	0	21		0	0	0	302309	0	562251	1713671		
25535	2098	19128065	1979-06-15	1979-06-15 00:00:00	1980-06-09	1980-06-09 00:00:00	1980-06-09	38000177		0	0	360		0	0	0	139866	0	749882	19128065		
12885	1083	40229134	2016-03-20	2016-03-20 00:00:00	2016-03-27	2016-03-27 00:00:00	2016-03-27	38000177		0	0	7		0	0	0	71132	0	1043400	40229134		
57664	4791	1127433	1981-01-24	1981-01-24 00:00:00	1981-01-31	1981-01-31 00:00:00	1981-01-31	38000177		0	0	7		0	0	0	318778	0	313782	1127433		
48858	4051	19019979	1982-05-04	1982-05-04 00:00:00	1982-06-08	1982-06-08 00:00:00	1982-06-08	38000177		0	0	35		0	0	0	269261	0	198405	19019979		
13118	1101	40243436	1982-08-22	1982-08-22 00:00:00	1982-08-22	1982-08-22 00:00:00	1982-08-22	38000177		0	0	0		0	0	0	72326	0	1190795	40243436		
114579	2518	40213227	2015-01-16	2015-01-16 00:00:00	2015-01-16	2015-01-16 00:00:00	2015-01-16	581452		0	0	0		0	0	0	166576	0	113	40213227		
101727	2230	40213314	1977-04-28	1977-04-28 00:00:00	1977-04-28	1977-04-28 00:00:00	1977-04-28	581452		0	0	0		0	0	0	148379	0	49	40213314		
58394	4852	920300	1995-04-06	1995-04-06 00:00:00	1995-04-13	1995-04-13 00:00:00	1995-04-13	38000177		0	0	7		0	0	0	322853	0	311989	920300		
60066	4991	19128065	1992-05-30	1992-05-30 00:00:00	1993-05-25	1993-05-25 00:00:00	1993-05-25	38000177		0	0	360		0	0	0	332010	0	749882	19128065		
53788	4472	40229134	1940-05-18	1940-05-18 00:00:00	1940-05-25	1940-05-25 00:00:00	1940-05-25	38000177		0	0	7		0	0	0	297479	0	1043400	40229134		
6097	510	40231925	1983-09-30	1983-09-30 00:00:00	1983-09-30	1983-09-30 00:00:00	\N	38000177		0	0	0		0	0	0	34069	0	1049221	40231925		
44688	3698	1127433	2009-06-24	2009-06-24 00:00:00	2009-07-08	2009-07-08 00:00:00	2009-07-08	38000177		0	0	14		0	0	0	245877	0	313782	1127433		
139273	3059	40213227	2012-04-29	2012-04-29 00:00:00	2012-04-29	2012-04-29 00:00:00	2012-04-29	581452		0	0	0		0	0	0	203531	0	113	40213227		
7074	596	19006318	1950-10-18	1950-10-18 00:00:00	1950-11-01	1950-11-01 00:00:00	1950-11-01	38000177		0	0	14		0	0	0	39311	0	105078	19006318		
56875	1245	40213227	2016-07-01	2016-07-01 00:00:00	2016-07-01	2016-07-01 00:00:00	2016-07-01	581452		0	0	0		0	0	0	81923	0	113	40213227		
7270	609	40229134	1991-02-01	1991-02-01 00:00:00	1991-02-15	1991-02-15 00:00:00	1991-02-15	38000177		0	0	14		0	0	0	40417	0	1043400	40229134		
27300	2258	1127433	1985-03-16	1985-03-16 00:00:00	1985-04-06	1985-04-06 00:00:00	1985-04-06	38000177		0	0	21		0	0	0	150060	0	313782	1127433		
27331	2260	1127433	2009-04-16	2009-04-16 00:00:00	2009-05-07	2009-05-07 00:00:00	2009-05-07	38000177		0	0	21		0	0	0	150222	0	313782	1127433		
37864	3129	19128022	1989-04-23	1989-04-23 00:00:00	1990-04-18	1990-04-18 00:00:00	1990-04-18	38000177		0	0	360		0	0	0	208257	0	749785	19128022		
7760	649	1310034	2011-01-25	2011-01-25 00:00:00	2011-01-25	2011-01-25 00:00:00	2011-01-25	38000177		0	0	0		0	0	0	42970	0	834357	1310034		
43337	3593	19078461	1987-09-03	1987-09-03 00:00:00	1987-09-24	1987-09-24 00:00:00	1987-09-24	38000177		0	0	21		0	0	0	238688	0	310965	19078461		
13667	1144	1127078	1972-06-09	1972-06-09 00:00:00	1972-06-23	1972-06-23 00:00:00	1972-06-23	38000177		0	0	14		0	0	0	75520	0	282464	1127078		
13698	1145	40236824	1957-10-21	1957-10-21 00:00:00	1957-10-28	1957-10-28 00:00:00	1957-10-28	38000177		0	0	7		0	0	0	75585	0	1094107	40236824		
31179	2583	1127433	2018-10-25	2018-10-25 00:00:00	2018-11-08	2018-11-08 00:00:00	2018-11-08	38000177		0	0	14		0	0	0	171021	0	313782	1127433		
19977	1640	40229134	1989-03-18	1989-03-18 00:00:00	1989-04-01	1989-04-01 00:00:00	1989-04-01	38000177		0	0	14		0	0	0	110083	0	1043400	40229134		
41708	3454	19073183	1986-09-02	1986-09-02 00:00:00	1986-09-16	1986-09-16 00:00:00	1986-09-16	38000177		0	0	14		0	0	0	229177	0	308182	19073183		
27119	2237	40173590	1999-10-24	1999-10-24 00:00:00	1999-10-24	1999-10-24 00:00:00	\N	38000177		0	0	0		0	0	0	148826	0	904419	40173590		
118074	2596	40213227	2017-11-04	2017-11-04 00:00:00	2017-11-04	2017-11-04 00:00:00	2017-11-04	581452		0	0	0		0	0	0	171772	0	113	40213227		
7486	625	19133873	1979-04-07	1979-04-07 00:00:00	1979-04-15	1979-04-15 00:00:00	1979-04-15	38000177		0	0	8		0	0	0	41774	0	834061	19133873		
215754	4732	40213160	1956-04-01	1956-04-01 00:00:00	1956-04-01	1956-04-01 00:00:00	1956-04-01	581452		0	0	0		0	0	0	315256	0	10	40213160		
42514	3526	1713671	1957-03-11	1957-03-11 00:00:00	1957-03-18	1957-03-18 00:00:00	1957-03-18	38000177		0	0	7		0	0	0	233949	0	562251	1713671		
40873	3389	1127433	2005-02-04	2005-02-04 00:00:00	2005-02-18	2005-02-18 00:00:00	2005-02-18	38000177		0	0	14		0	0	0	224789	0	313782	1127433		
44053	959	40213227	2000-04-05	2000-04-05 00:00:00	2000-04-05	2000-04-05 00:00:00	2000-04-05	581452		0	0	0		0	0	0	63805	0	113	40213227		
43037	3568	19129655	1970-02-23	1970-02-23 00:00:00	1970-03-09	1970-03-09 00:00:00	1970-03-09	38000177		0	0	14		0	0	0	237075	0	789980	19129655		
24858	2044	1124300	1997-01-18	1997-01-18 00:00:00	1997-01-18	1997-01-18 00:00:00	\N	38000177		0	0	0		0	0	0	135968	0	00781178901	45011828		
53203	4419	19059056	1971-03-06	1971-03-06 00:00:00	1971-04-03	1971-04-03 00:00:00	1971-04-03	38000177		0	0	28		0	0	0	293818	0	243670	19059056		
34244	2830	19128065	1994-07-08	1994-07-08 00:00:00	1995-07-03	1995-07-03 00:00:00	1995-07-03	38000177		0	0	360		0	0	0	187694	0	749882	19128065		
2104	165	40229134	1983-05-26	1983-05-26 00:00:00	1983-06-09	1983-06-09 00:00:00	1983-06-09	38000177		0	0	14		0	0	0	11371	0	1043400	40229134		
34347	2836	920300	2007-09-28	2007-09-28 00:00:00	2007-10-05	2007-10-05 00:00:00	2007-10-05	38000177		0	0	7		0	0	0	188404	0	311989	920300		
54998	1205	40213296	1999-10-28	1999-10-28 00:00:00	1999-10-28	1999-10-28 00:00:00	1999-10-28	581452		0	0	0		0	0	0	79209	0	52	40213296		
36665	3026	1127433	2010-03-28	2010-03-28 00:00:00	2010-04-04	2010-04-04 00:00:00	2010-04-04	38000177		0	0	7		0	0	0	201771	0	313782	1127433		
35689	2942	40163554	2016-09-28	2016-09-28 00:00:00	2016-09-28	2016-09-28 00:00:00	\N	38000177		0	0	0		0	0	0	196074	0	855332	40163554		
64380	5343	1127433	2016-11-04	2016-11-04 00:00:00	2016-11-18	2016-11-18 00:00:00	2016-11-18	38000177		0	0	14		0	0	0	355930	0	313782	1127433		
111446	2448	40213227	1995-09-27	1995-09-27 00:00:00	1995-09-27	1995-09-27 00:00:00	1995-09-27	581452		0	0	0		0	0	0	162397	0	113	40213227		
29570	2448	1713671	2011-10-04	2011-10-04 00:00:00	2011-10-11	2011-10-11 00:00:00	2011-10-11	38000177		0	0	7		0	0	0	162367	0	562251	1713671		
1513	119	19128065	1974-12-06	1974-12-06 00:00:00	1975-12-01	1975-12-01 00:00:00	1975-12-01	38000177		0	0	360		0	0	0	7938	0	749882	19128065		
33883	2802	1713671	1949-10-01	1949-10-01 00:00:00	1949-10-08	1949-10-08 00:00:00	1949-10-08	38000177		0	0	7		0	0	0	185729	0	562251	1713671		
4503	374	1127433	1986-04-06	1986-04-06 00:00:00	1986-04-20	1986-04-20 00:00:00	1986-04-20	38000177		0	0	14		0	0	0	24812	0	313782	1127433		
146123	3214	40213160	1977-01-25	1977-01-25 00:00:00	1977-01-25	1977-01-25 00:00:00	1977-01-25	581452		0	0	0		0	0	0	213501	0	10	40213160		
96406	2114	40213306	1987-09-30	1987-09-30 00:00:00	1987-09-30	1987-09-30 00:00:00	1987-09-30	581452		0	0	0		0	0	0	140638	0	43	40213306		
180794	3973	40213260	2018-08-30	2018-08-30 00:00:00	2018-08-30	2018-08-30 00:00:00	2018-08-30	581452		0	0	0		0	0	0	264215	0	121	40213260		
18663	1541	19128065	1982-03-30	1982-03-30 00:00:00	1983-03-25	1983-03-25 00:00:00	1983-03-25	38000177		0	0	360		0	0	0	103263	0	749882	19128065		
60480	5031	40229134	1973-04-30	1973-04-30 00:00:00	1973-05-07	1973-05-07 00:00:00	1973-05-07	38000177		0	0	7		0	0	0	334331	0	1043400	40229134		
6400	539	1713671	1969-08-09	1969-08-09 00:00:00	1969-08-16	1969-08-16 00:00:00	1969-08-16	38000177		0	0	7		0	0	0	35771	0	562251	1713671		
22876	1882	40229134	2018-10-20	2018-10-20 00:00:00	2018-11-03	2018-11-03 00:00:00	2018-11-03	38000177		0	0	14		0	0	0	125519	0	1043400	40229134		
15806	1315	19006318	1962-09-10	1962-09-10 00:00:00	1962-09-24	1962-09-24 00:00:00	1962-09-24	38000177		0	0	14		0	0	0	87119	0	105078	19006318		
15857	1317	1713671	1968-12-21	1968-12-21 00:00:00	1969-01-11	1969-01-11 00:00:00	1969-01-11	38000177		0	0	21		0	0	0	87243	0	562251	1713671		
94081	2064	40213160	1976-07-14	1976-07-14 00:00:00	1976-07-14	1976-07-14 00:00:00	1976-07-14	581452		0	0	0		0	0	0	137287	0	10	40213160		
39901	3301	1127433	1985-01-27	1985-01-27 00:00:00	1985-02-10	1985-02-10 00:00:00	1985-02-10	38000177		0	0	14		0	0	0	219266	0	313782	1127433		
44280	3666	1127433	2013-06-02	2013-06-02 00:00:00	2013-06-23	2013-06-23 00:00:00	2013-06-23	38000177		0	0	21		0	0	0	243869	0	313782	1127433		
36504	3011	1127078	1980-01-09	1980-01-09 00:00:00	1980-01-23	1980-01-23 00:00:00	1980-01-23	38000177		0	0	14		0	0	0	200825	0	282464	1127078		
11387	949	1115171	2005-06-22	2005-06-22 00:00:00	2005-07-13	2005-07-13 00:00:00	2005-07-13	38000177		0	0	21		0	0	0	63023	0	849574	1115171		
152962	3367	40213227	2005-03-14	2005-03-14 00:00:00	2005-03-14	2005-03-14 00:00:00	2005-03-14	581452		0	0	0		0	0	0	223330	0	113	40213227		
52942	1158	40213160	1980-04-13	1980-04-13 00:00:00	1980-04-13	1980-04-13 00:00:00	1980-04-13	581452		0	0	0		0	0	0	76494	0	10	40213160		
25536	2098	40229134	1970-12-21	1970-12-21 00:00:00	1970-12-28	1970-12-28 00:00:00	1970-12-28	38000177		0	0	7		0	0	0	139903	0	1043400	40229134		
12886	1083	40232448	1968-06-08	1968-06-08 00:00:00	1968-06-08	1968-06-08 00:00:00	\N	38000177		0	0	0		0	0	0	71066	0	1049630	40232448		
57665	4791	1127078	1968-06-18	1968-06-18 00:00:00	1968-07-18	1968-07-18 00:00:00	1968-07-18	38000177		0	0	30		0	0	0	318771	0	282464	1127078		
48859	4051	1127078	1975-08-09	1975-08-09 00:00:00	1975-08-23	1975-08-23 00:00:00	1975-08-23	38000177		0	0	14		0	0	0	269269	0	282464	1127078		
13119	1101	1310034	1982-08-22	1982-08-22 00:00:00	1982-08-22	1982-08-22 00:00:00	1982-08-22	38000177		0	0	0		0	0	0	72326	0	834357	1310034		
135279	2969	40213160	1965-07-01	1965-07-01 00:00:00	1965-07-01	1965-07-01 00:00:00	1965-07-01	581452		0	0	0		0	0	0	198253	0	10	40213160		
101730	2230	40213306	1993-12-09	1993-12-09 00:00:00	1993-12-09	1993-12-09 00:00:00	1993-12-09	581452		0	0	0		0	0	0	148383	0	43	40213306		
58395	4852	19133905	1970-05-08	1970-05-08 00:00:00	1970-05-17	1970-05-17 00:00:00	1970-05-17	38000177		0	0	9		0	0	0	322850	0	834102	19133905		
60067	4991	1713671	1972-11-09	1972-11-09 00:00:00	1972-11-16	1972-11-16 00:00:00	1972-11-16	38000177		0	0	7		0	0	0	332056	0	562251	1713671		
127856	2812	40213227	2010-03-29	2010-03-29 00:00:00	2010-03-29	2010-03-29 00:00:00	2010-03-29	581452		0	0	0		0	0	0	186367	0	113	40213227		
6098	510	1118084	2008-01-10	2008-01-10 00:00:00	2008-01-10	2008-01-10 00:00:00	\N	38000177		0	0	0		0	0	0	34092	0	00025152531	44923712		
44689	3698	1118084	1992-02-09	1992-02-09 00:00:00	1992-02-09	1992-02-09 00:00:00	\N	38000177		0	0	0		0	0	0	245824	0	00025152531	44923712		
139274	3059	40213296	2012-04-29	2012-04-29 00:00:00	2012-04-29	2012-04-29 00:00:00	2012-04-29	581452		0	0	0		0	0	0	203531	0	52	40213296		
7075	596	1127078	1950-10-18	1950-10-18 00:00:00	1950-11-01	1950-11-01 00:00:00	1950-11-01	38000177		0	0	14		0	0	0	39311	0	282464	1127078		
144118	3167	40213227	2001-12-02	2001-12-02 00:00:00	2001-12-02	2001-12-02 00:00:00	2001-12-02	581452		0	0	0		0	0	0	210545	0	113	40213227		
7271	609	1713671	1974-10-28	1974-10-28 00:00:00	1974-11-18	1974-11-18 00:00:00	1974-11-18	38000177		0	0	21		0	0	0	40456	0	562251	1713671		
27301	2258	1713671	1991-05-28	1991-05-28 00:00:00	1991-06-18	1991-06-18 00:00:00	1991-06-18	38000177		0	0	21		0	0	0	150092	0	562251	1713671		
27332	2260	1118084	1983-11-19	1983-11-19 00:00:00	1983-11-19	1983-11-19 00:00:00	\N	38000177		0	0	0		0	0	0	150257	0	00025152531	44923712		
37865	3129	1127433	1998-11-07	1998-11-07 00:00:00	1998-11-21	1998-11-21 00:00:00	1998-11-21	38000177		0	0	14		0	0	0	208276	0	313782	1127433		
7761	649	46275916	2011-01-25	2011-01-25 00:00:00	2011-01-25	2011-01-25 00:00:00	2011-01-25	38000177		0	0	0		0	0	0	42970	0	1660014	46275916		
43338	3593	1118084	1988-02-29	1988-02-29 00:00:00	1988-02-29	1988-02-29 00:00:00	\N	38000177		0	0	0		0	0	0	238688	0	00025152531	44923712		
13668	1144	40229134	2013-10-16	2013-10-16 00:00:00	2013-10-30	2013-10-30 00:00:00	2013-10-30	38000177		0	0	14		0	0	0	75473	0	1043400	40229134		
13699	1145	920300	1957-10-21	1957-10-21 00:00:00	1957-10-28	1957-10-28 00:00:00	1957-10-28	38000177		0	0	7		0	0	0	75585	0	311989	920300		
31180	2583	19078461	1993-06-28	1993-06-28 00:00:00	1993-07-28	1993-07-28 00:00:00	1993-07-28	38000177		0	0	30		0	0	0	171045	0	310965	19078461		
19978	1640	40222846	2014-06-17	2014-06-17 00:00:00	2014-06-17	2014-06-17 00:00:00	\N	38000177		0	0	0		0	0	0	110088	0	996740	40222846		
41709	3454	40229134	1998-02-27	1998-02-27 00:00:00	1998-03-13	1998-03-13 00:00:00	1998-03-13	38000177		0	0	14		0	0	0	229146	0	1043400	40229134		
27120	2237	19078461	2005-10-29	2005-10-29 00:00:00	2005-12-28	2005-12-28 00:00:00	2005-12-28	38000177		0	0	60		0	0	0	148809	0	310965	19078461		
118075	2596	40213260	2017-11-04	2017-11-04 00:00:00	2017-11-04	2017-11-04 00:00:00	2017-11-04	581452		0	0	0		0	0	0	171772	0	121	40213260		
7487	625	1127078	1974-12-25	1974-12-25 00:00:00	1975-01-24	1975-01-24 00:00:00	1975-01-24	38000177		0	0	30		0	0	0	41733	0	282464	1127078		
59989	1313	40213160	1974-11-06	1974-11-06 00:00:00	1974-11-06	1974-11-06 00:00:00	1974-11-06	581452		0	0	0		0	0	0	86920	0	10	40213160		
42515	3526	19133873	1955-01-13	1955-01-13 00:00:00	1955-01-20	1955-01-20 00:00:00	1955-01-20	38000177		0	0	7		0	0	0	233906	0	834061	19133873		
40874	3389	1127433	1998-04-05	1998-04-05 00:00:00	1998-04-19	1998-04-19 00:00:00	1998-04-19	38000177		0	0	14		0	0	0	224788	0	313782	1127433		
44056	959	40213160	1958-09-03	1958-09-03 00:00:00	1958-09-03	1958-09-03 00:00:00	1958-09-03	581452		0	0	0		0	0	0	63770	0	10	40213160		
43038	3568	19059056	1970-02-23	1970-02-23 00:00:00	1970-03-09	1970-03-09 00:00:00	1970-03-09	38000177		0	0	14		0	0	0	237075	0	243670	19059056		
24859	2044	19133873	1978-04-20	1978-04-20 00:00:00	1978-05-02	1978-05-02 00:00:00	1978-05-02	38000177		0	0	12		0	0	0	135976	0	834061	19133873		
53204	4419	19059056	1972-01-28	1972-01-28 00:00:00	1972-03-03	1972-03-03 00:00:00	1972-03-03	38000177		0	0	35		0	0	0	293819	0	243670	19059056		
34245	2830	1127078	1976-12-29	1976-12-29 00:00:00	1977-01-12	1977-01-12 00:00:00	1977-01-12	38000177		0	0	14		0	0	0	187773	0	282464	1127078		
2105	165	1127433	1991-02-26	1991-02-26 00:00:00	1991-03-12	1991-03-12 00:00:00	1991-03-12	38000177		0	0	14		0	0	0	11328	0	313782	1127433		
34348	2836	920300	2008-11-08	2008-11-08 00:00:00	2008-11-15	2008-11-15 00:00:00	2008-11-15	38000177		0	0	7		0	0	0	188405	0	311989	920300		
235297	5168	40213227	2013-08-23	2013-08-23 00:00:00	2013-08-23	2013-08-23 00:00:00	2013-08-23	581452		0	0	0		0	0	0	343636	0	113	40213227		
36666	3026	40231925	2019-06-07	2019-06-07 00:00:00	2019-06-07	2019-06-07 00:00:00	\N	38000177		0	0	0		0	0	0	201763	0	1049221	40231925		
35690	2942	19006318	1957-09-20	1957-09-20 00:00:00	1957-10-04	1957-10-04 00:00:00	1957-10-04	38000177		0	0	14		0	0	0	196191	0	105078	19006318		
64381	5343	1551192	1999-05-11	1999-05-11 00:00:00	1999-05-11	1999-05-11 00:00:00	1999-05-11	38000177		0	0	0		0	0	0	355929	0	312617	1551192		
225105	4942	40213296	1997-01-09	1997-01-09 00:00:00	1997-01-09	1997-01-09 00:00:00	1997-01-09	581452		0	0	0		0	0	0	328532	0	52	40213296		
29571	2448	964261	1991-07-09	1991-07-09 00:00:00	1991-07-09	1991-07-09 00:00:00	\N	38000177		0	0	0		0	0	0	162338	0	2001499	964261		
1514	119	40236824	2012-03-25	2012-03-25 00:00:00	2012-04-08	2012-04-08 00:00:00	2012-04-08	38000177		0	0	14		0	0	0	7869	0	1094107	40236824		
33884	2802	19059056	1951-11-20	1951-11-20 00:00:00	1951-12-11	1951-12-11 00:00:00	1951-12-11	38000177		0	0	21		0	0	0	185710	0	243670	19059056		
4504	374	19133905	2002-07-24	2002-07-24 00:00:00	2002-08-03	2002-08-03 00:00:00	2002-08-03	38000177		0	0	10		0	0	0	24839	0	834102	19133905		
146124	3214	40213314	1977-01-25	1977-01-25 00:00:00	1977-01-25	1977-01-25 00:00:00	1977-01-25	581452		0	0	0		0	0	0	213501	0	49	40213314		
96408	2114	40213296	2005-02-02	2005-02-02 00:00:00	2005-02-02	2005-02-02 00:00:00	2005-02-02	581452		0	0	0		0	0	0	140639	0	52	40213296		
145964	3211	40213260	2006-11-24	2006-11-24 00:00:00	2006-11-24	2006-11-24 00:00:00	2006-11-24	581452		0	0	0		0	0	0	213327	0	121	40213260		
18664	1541	1118084	2007-02-07	2007-02-07 00:00:00	2007-02-07	2007-02-07 00:00:00	\N	38000177		0	0	0		0	0	0	103289	0	00025152531	44923712		
60482	5031	19115351	1948-05-29	1948-05-29 00:00:00	1949-01-29	1949-01-29 00:00:00	1949-01-29	38000177		0	0	245		0	0	0	334311	0	563026	19115351		
6401	539	19059056	1971-04-04	1971-04-04 00:00:00	1971-04-18	1971-04-18 00:00:00	1971-04-18	38000177		0	0	14		0	0	0	35826	0	243670	19059056		
50962	4235	40229134	2001-12-23	2001-12-23 00:00:00	2001-12-30	2001-12-30 00:00:00	2001-12-30	38000177		0	0	7		0	0	0	281205	0	1043400	40229134		
15807	1315	19133873	1965-10-08	1965-10-08 00:00:00	1965-10-16	1965-10-16 00:00:00	1965-10-16	38000177		0	0	8		0	0	0	87128	0	834061	19133873		
15858	1317	19133905	1995-08-03	1995-08-03 00:00:00	1995-08-10	1995-08-10 00:00:00	1995-08-10	38000177		0	0	7		0	0	0	87246	0	834102	19133905		
94082	2064	40213227	2008-07-23	2008-07-23 00:00:00	2008-07-23	2008-07-23 00:00:00	2008-07-23	581452		0	0	0		0	0	0	137303	0	113	40213227		
39902	3301	1713671	1972-12-10	1972-12-10 00:00:00	1972-12-24	1972-12-24 00:00:00	1972-12-24	38000177		0	0	14		0	0	0	219264	0	562251	1713671		
18801	1553	1713671	1989-11-18	1989-11-18 00:00:00	1989-12-09	1989-12-09 00:00:00	1989-12-09	38000177		0	0	21		0	0	0	103971	0	562251	1713671		
36505	3011	1115171	2003-03-14	2003-03-14 00:00:00	2003-04-04	2003-04-04 00:00:00	2003-04-04	38000177		0	0	21		0	0	0	200849	0	849574	1115171		
11388	949	1127433	1990-03-09	1990-03-09 00:00:00	1990-03-23	1990-03-23 00:00:00	1990-03-23	38000177		0	0	14		0	0	0	62987	0	313782	1127433		
152963	3367	40213296	2005-03-14	2005-03-14 00:00:00	2005-03-14	2005-03-14 00:00:00	2005-03-14	581452		0	0	0		0	0	0	223330	0	52	40213296		
52951	1158	40213227	2013-06-30	2013-06-30 00:00:00	2013-06-30	2013-06-30 00:00:00	2013-06-30	581452		0	0	0		0	0	0	76517	0	113	40213227		
25537	2098	1127433	1973-11-19	1973-11-19 00:00:00	1973-12-03	1973-12-03 00:00:00	1973-12-03	38000177		0	0	14		0	0	0	139855	0	313782	1127433		
12887	1083	1127433	1987-10-28	1987-10-28 00:00:00	1987-11-04	1987-11-04 00:00:00	1987-11-04	38000177		0	0	7		0	0	0	71088	0	313782	1127433		
57666	4791	1127078	1969-11-10	1969-11-10 00:00:00	1969-11-24	1969-11-24 00:00:00	1969-11-24	38000177		0	0	14		0	0	0	318816	0	282464	1127078		
48860	4051	19129655	1975-08-09	1975-08-09 00:00:00	1975-08-23	1975-08-23 00:00:00	1975-08-23	38000177		0	0	14		0	0	0	269269	0	789980	19129655		
13120	1101	40169281	2003-06-29	2003-06-29 00:00:00	2003-06-29	2003-06-29 00:00:00	\N	38000177		0	0	0		0	0	0	72303	0	896209	40169281		
135284	2969	40213160	1965-09-30	1965-09-30 00:00:00	1965-09-30	1965-09-30 00:00:00	1965-09-30	581452		0	0	0		0	0	0	198225	0	10	40213160		
101732	2230	40213160	1974-01-24	1974-01-24 00:00:00	1974-01-24	1974-01-24 00:00:00	1974-01-24	581452		0	0	0		0	0	0	148390	0	10	40213160		
58396	4852	1127433	1967-10-29	1967-10-29 00:00:00	1967-11-11	1967-11-11 00:00:00	1967-11-11	38000177		0	0	13		0	0	0	322849	0	313782	1127433		
60068	4991	1127433	1983-01-18	1983-01-18 00:00:00	1983-02-01	1983-02-01 00:00:00	1983-02-01	38000177		0	0	14		0	0	0	332029	0	313782	1127433		
127866	2812	40213201	2005-02-28	2005-02-28 00:00:00	2005-02-28	2005-02-28 00:00:00	2005-02-28	581452		0	0	0		0	0	0	186286	0	33	40213201		
6099	510	1127433	2005-06-04	2005-06-04 00:00:00	2005-08-10	2005-08-10 00:00:00	2005-08-10	38000177		0	0	67		0	0	0	34083	0	313782	1127433		
44690	3698	19133873	1966-09-03	1966-09-03 00:00:00	1966-09-15	1966-09-15 00:00:00	1966-09-15	38000177		0	0	12		0	0	0	245828	0	834061	19133873		
139277	3059	40213160	1970-07-26	1970-07-26 00:00:00	1970-07-26	1970-07-26 00:00:00	1970-07-26	581452		0	0	0		0	0	0	203486	0	10	40213160		
7076	596	1127433	1958-02-26	1958-02-26 00:00:00	1958-03-12	1958-03-12 00:00:00	1958-03-12	38000177		0	0	14		0	0	0	39351	0	313782	1127433		
144119	3167	40213296	2001-12-02	2001-12-02 00:00:00	2001-12-02	2001-12-02 00:00:00	2001-12-02	581452		0	0	0		0	0	0	210545	0	52	40213296		
7272	609	1127433	2018-03-08	2018-03-08 00:00:00	2018-03-15	2018-03-15 00:00:00	2018-03-15	38000177		0	0	7		0	0	0	40418	0	313782	1127433		
27302	2258	1127433	2003-11-11	2003-11-11 00:00:00	2003-11-25	2003-11-25 00:00:00	2003-11-25	38000177		0	0	14		0	0	0	150094	0	313782	1127433		
27333	2260	1127433	1952-02-17	1952-02-17 00:00:00	1952-02-24	1952-02-24 00:00:00	1952-02-24	38000177		0	0	7		0	0	0	150179	0	313782	1127433		
37866	3129	1127433	2006-12-25	2006-12-25 00:00:00	2007-01-08	2007-01-08 00:00:00	2007-01-08	38000177		0	0	14		0	0	0	208291	0	313782	1127433		
7762	649	19133873	1985-05-25	1985-05-25 00:00:00	1985-06-04	1985-06-04 00:00:00	1985-06-04	38000177		0	0	10		0	0	0	43033	0	834061	19133873		
43339	3593	19078461	2018-09-02	2018-09-02 00:00:00	2018-09-30	2018-09-30 00:00:00	2018-09-30	38000177		0	0	28		0	0	0	238690	0	310965	19078461		
13669	1144	1127433	2006-03-31	2006-03-31 00:00:00	2006-04-14	2006-04-14 00:00:00	2006-04-14	38000177		0	0	14		0	0	0	75476	0	313782	1127433		
13700	1146	1713671	1960-03-17	1960-03-17 00:00:00	1960-03-31	1960-03-31 00:00:00	1960-03-31	38000177		0	0	14		0	0	0	75668	0	562251	1713671		
31181	2583	1127433	1986-08-20	1986-08-20 00:00:00	1986-10-19	1986-10-19 00:00:00	1986-10-19	38000177		0	0	60		0	0	0	171043	0	313782	1127433		
19979	1640	1127433	2006-09-14	2006-09-14 00:00:00	2006-11-13	2006-11-13 00:00:00	2006-11-13	38000177		0	0	60		0	0	0	110031	0	313782	1127433		
41710	3454	19019979	1984-07-11	1984-07-11 00:00:00	1984-07-25	1984-07-25 00:00:00	1984-07-25	38000177		0	0	14		0	0	0	229191	0	198405	19019979		
27121	2237	40162522	2005-10-29	2005-10-29 00:00:00	2005-10-29	2005-10-29 00:00:00	\N	38000177		0	0	0		0	0	0	148809	0	857005	40162522		
118090	2597	40213160	1971-05-04	1971-05-04 00:00:00	1971-05-04	1971-05-04 00:00:00	1971-05-04	581452		0	0	0		0	0	0	171883	0	10	40213160		
39541	3268	1127433	2014-06-10	2014-06-10 00:00:00	2014-06-17	2014-06-17 00:00:00	2014-06-17	38000177		0	0	7		0	0	0	217176	0	313782	1127433		
59990	1313	40213160	1970-03-04	1970-03-04 00:00:00	1970-03-04	1970-03-04 00:00:00	1970-03-04	581452		0	0	0		0	0	0	86929	0	10	40213160		
42516	3526	19059056	1961-12-24	1961-12-24 00:00:00	1962-01-07	1962-01-07 00:00:00	1962-01-07	38000177		0	0	14		0	0	0	234000	0	243670	19059056		
40875	3389	1713671	2010-08-12	2010-08-12 00:00:00	2010-09-02	2010-09-02 00:00:00	2010-09-02	38000177		0	0	21		0	0	0	224748	0	562251	1713671		
63103	5241	40236824	2019-04-11	2019-04-11 00:00:00	2019-04-18	2019-04-18 00:00:00	2019-04-18	38000177		0	0	7		0	0	0	348727	0	1094107	40236824		
43039	3568	1115171	2002-07-31	2002-07-31 00:00:00	2002-08-30	2002-08-30 00:00:00	2002-08-30	38000177		0	0	30		0	0	0	237070	0	849574	1115171		
24860	2044	1127433	1993-08-07	1993-08-07 00:00:00	1993-08-14	1993-08-14 00:00:00	1993-08-14	38000177		0	0	7		0	0	0	135967	0	313782	1127433		
53205	4419	1127433	1983-07-04	1983-07-04 00:00:00	1983-08-08	1983-08-08 00:00:00	1983-08-08	38000177		0	0	35		0	0	0	293820	0	313782	1127433		
34246	2830	46233988	1976-12-29	1976-12-29 00:00:00	1977-01-12	1977-01-12 00:00:00	1977-01-12	38000177		0	0	14		0	0	0	187773	0	1652673	46233988		
2106	165	1118084	2006-10-21	2006-10-21 00:00:00	2006-10-21	2006-10-21 00:00:00	\N	38000177		0	0	0		0	0	0	11345	0	00025152531	44923712		
17983	1490	19078461	2011-01-20	2011-01-20 00:00:00	2011-02-10	2011-02-10 00:00:00	2011-02-10	38000177		0	0	21		0	0	0	99328	0	310965	19078461		
235298	5168	40213296	2013-08-23	2013-08-23 00:00:00	2013-08-23	2013-08-23 00:00:00	2013-08-23	581452		0	0	0		0	0	0	343636	0	52	40213296		
36667	3026	40229134	1966-06-09	1966-06-09 00:00:00	1966-06-16	1966-06-16 00:00:00	1966-06-16	38000177		0	0	7		0	0	0	201804	0	1043400	40229134		
46149	3823	1124300	1993-10-23	1993-10-23 00:00:00	1993-10-23	1993-10-23 00:00:00	\N	38000177		0	0	0		0	0	0	253943	0	00781178901	45011828		
225090	4942	40213160	1955-07-07	1955-07-07 00:00:00	1955-07-07	1955-07-07 00:00:00	1955-07-07	581452		0	0	0		0	0	0	328486	0	10	40213160		
225116	4942	40213160	1955-01-06	1955-01-06 00:00:00	1955-01-06	1955-01-06 00:00:00	1955-01-06	581452		0	0	0		0	0	0	328525	0	10	40213160		
29572	2448	1713671	1970-11-16	1970-11-16 00:00:00	1970-11-30	1970-11-30 00:00:00	1970-11-30	38000177		0	0	14		0	0	0	162363	0	562251	1713671		
1515	119	920300	2012-03-25	2012-03-25 00:00:00	2012-04-01	2012-04-01 00:00:00	2012-04-01	38000177		0	0	7		0	0	0	7869	0	311989	920300		
33885	2802	1127433	1952-08-06	1952-08-06 00:00:00	1952-08-20	1952-08-20 00:00:00	1952-08-20	38000177		0	0	14		0	0	0	185760	0	313782	1127433		
4505	374	1713671	1987-08-05	1987-08-05 00:00:00	1987-08-19	1987-08-19 00:00:00	1987-08-19	38000177		0	0	14		0	0	0	24838	0	562251	1713671		
146127	3214	40213160	1972-10-24	1972-10-24 00:00:00	1972-10-24	1972-10-24 00:00:00	1972-10-24	581452		0	0	0		0	0	0	213531	0	10	40213160		
103286	2265	40213260	2014-08-31	2014-08-31 00:00:00	2014-08-31	2014-08-31 00:00:00	2014-08-31	581452		0	0	0		0	0	0	150536	0	121	40213260		
145965	3211	40213160	1957-08-02	1957-08-02 00:00:00	1957-08-02	1957-08-02 00:00:00	1957-08-02	581452		0	0	0		0	0	0	213374	0	10	40213160		
18665	1541	1127433	1996-01-08	1996-01-08 00:00:00	1996-01-22	1996-01-22 00:00:00	1996-01-22	38000177		0	0	14		0	0	0	103248	0	313782	1127433		
60483	5031	1127433	2002-02-06	2002-02-06 00:00:00	2002-02-13	2002-02-13 00:00:00	2002-02-13	38000177		0	0	7		0	0	0	334289	0	313782	1127433		
6402	539	19059056	1933-07-24	1933-07-24 00:00:00	1933-08-07	1933-08-07 00:00:00	1933-08-07	38000177		0	0	14		0	0	0	35788	0	243670	19059056		
61429	5111	19133768	1984-12-03	1984-12-03 00:00:00	1984-12-03	1984-12-03 00:00:00	1984-12-03	38000177		0	0	0		0	0	0	339626	0	833036	19133768		
15808	1315	1115171	2010-02-21	2010-02-21 00:00:00	2010-03-07	2010-03-07 00:00:00	2010-03-07	38000177		0	0	14		0	0	0	87108	0	849574	1115171		
15859	1317	19059056	1952-11-03	1952-11-03 00:00:00	1952-12-08	1952-12-08 00:00:00	1952-12-08	38000177		0	0	35		0	0	0	87274	0	243670	19059056		
29853	651	40213160	1977-10-13	1977-10-13 00:00:00	1977-10-13	1977-10-13 00:00:00	1977-10-13	581452		0	0	0		0	0	0	43123	0	10	40213160		
39903	3301	19059056	1948-06-11	1948-06-11 00:00:00	1948-07-11	1948-07-11 00:00:00	1948-07-11	38000177		0	0	30		0	0	0	219261	0	243670	19059056		
18802	1553	1127078	1978-01-11	1978-01-11 00:00:00	1978-02-01	1978-02-01 00:00:00	1978-02-01	38000177		0	0	21		0	0	0	103938	0	282464	1127078		
36506	3011	19133873	1980-01-10	1980-01-10 00:00:00	1980-01-20	1980-01-20 00:00:00	1980-01-20	38000177		0	0	10		0	0	0	200822	0	834061	19133873		
11389	949	1713671	1992-04-25	1992-04-25 00:00:00	1992-05-02	1992-05-02 00:00:00	1992-05-02	38000177		0	0	7		0	0	0	62988	0	562251	1713671		
152964	3367	40213160	1963-06-10	1963-06-10 00:00:00	1963-06-10	1963-06-10 00:00:00	1963-06-10	581452		0	0	0		0	0	0	223333	0	10	40213160		
52957	1158	40213160	1979-11-11	1979-11-11 00:00:00	1979-11-11	1979-11-11 00:00:00	1979-11-11	581452		0	0	0		0	0	0	76493	0	10	40213160		
25538	2098	1713671	2007-08-28	2007-08-28 00:00:00	2008-07-22	2008-07-22 00:00:00	2008-07-22	38000177		0	0	329		0	0	0	139906	0	562251	1713671		
12888	1083	19059056	1967-05-14	1967-05-14 00:00:00	1967-06-18	1967-06-18 00:00:00	1967-06-18	38000177		0	0	35		0	0	0	71054	0	243670	19059056		
57667	4791	40229134	1970-03-12	1970-03-12 00:00:00	1970-03-26	1970-03-26 00:00:00	1970-03-26	38000177		0	0	14		0	0	0	318811	0	1043400	40229134		
48861	4051	19133873	1986-12-11	1986-12-11 00:00:00	1986-12-24	1986-12-24 00:00:00	1986-12-24	38000177		0	0	13		0	0	0	269235	0	834061	19133873		
13121	1101	40229134	1978-03-10	1978-03-10 00:00:00	1978-03-24	1978-03-24 00:00:00	1978-03-24	38000177		0	0	14		0	0	0	72300	0	1043400	40229134		
135291	2970	40213227	2016-04-22	2016-04-22 00:00:00	2016-04-22	2016-04-22 00:00:00	2016-04-22	581452		0	0	0		0	0	0	198378	0	113	40213227		
30798	672	40213160	1955-10-10	1955-10-10 00:00:00	1955-10-10	1955-10-10 00:00:00	1955-10-10	581452		0	0	0		0	0	0	44345	0	10	40213160		
58397	4852	19006318	1950-08-12	1950-08-12 00:00:00	1950-08-26	1950-08-26 00:00:00	1950-08-26	38000177		0	0	14		0	0	0	322791	0	105078	19006318		
60069	4991	1127433	1992-09-08	1992-09-08 00:00:00	1992-10-13	1992-10-13 00:00:00	1992-10-13	38000177		0	0	35		0	0	0	332054	0	313782	1127433		
127881	2813	40213201	2000-09-29	2000-09-29 00:00:00	2000-09-29	2000-09-29 00:00:00	2000-09-29	581452		0	0	0		0	0	0	186399	0	33	40213201		
6100	510	1115171	2012-02-05	2012-02-05 00:00:00	2012-02-26	2012-02-26 00:00:00	2012-02-26	38000177		0	0	21		0	0	0	34084	0	849574	1115171		
44691	3698	1127433	1960-07-04	1960-07-04 00:00:00	1960-07-11	1960-07-11 00:00:00	1960-07-11	38000177		0	0	7		0	0	0	245827	0	313782	1127433		
139300	3060	40213201	1990-04-07	1990-04-07 00:00:00	1990-04-07	1990-04-07 00:00:00	1990-04-07	581452		0	0	0		0	0	0	203592	0	33	40213201		
7078	596	19133905	1981-12-12	1981-12-12 00:00:00	1981-12-22	1981-12-22 00:00:00	1981-12-22	38000177		0	0	10		0	0	0	39375	0	834102	19133905		
144121	3167	40213260	2012-01-01	2012-01-01 00:00:00	2012-01-01	2012-01-01 00:00:00	2012-01-01	581452		0	0	0		0	0	0	210563	0	121	40213260		
7273	609	1127433	1975-12-01	1975-12-01 00:00:00	1975-12-15	1975-12-15 00:00:00	1975-12-15	38000177		0	0	14		0	0	0	40414	0	313782	1127433		
27303	2258	19059056	1959-11-30	1959-11-30 00:00:00	1959-12-14	1959-12-14 00:00:00	1959-12-14	38000177		0	0	14		0	0	0	150095	0	243670	19059056		
27334	2260	40229134	1969-10-15	1969-10-15 00:00:00	1969-10-22	1969-10-22 00:00:00	1969-10-22	38000177		0	0	7		0	0	0	150247	0	1043400	40229134		
37867	3129	19128065	1986-05-09	1986-05-09 00:00:00	1987-05-04	1987-05-04 00:00:00	1987-05-04	38000177		0	0	360		0	0	0	208280	0	749882	19128065		
7763	649	46233988	1970-07-02	1970-07-02 00:00:00	1970-07-16	1970-07-16 00:00:00	1970-07-16	38000177		0	0	14		0	0	0	43025	0	1652673	46233988		
43340	3593	19078461	2017-08-17	2017-08-17 00:00:00	2017-09-07	2017-09-07 00:00:00	2017-09-07	38000177		0	0	21		0	0	0	238689	0	310965	19078461		
13671	1144	1127078	1980-01-16	1980-01-16 00:00:00	1980-01-30	1980-01-30 00:00:00	1980-01-30	38000177		0	0	14		0	0	0	75495	0	282464	1127078		
13701	1146	19128065	1974-01-06	1974-01-06 00:00:00	1975-01-01	1975-01-01 00:00:00	1975-01-01	38000177		0	0	360		0	0	0	75690	0	749882	19128065		
31182	2583	40165015	1986-08-20	1986-08-20 00:00:00	1986-08-20	1986-08-20 00:00:00	\N	38000177		0	0	0		0	0	0	171043	0	861467	40165015		
19980	1640	40162522	2006-09-14	2006-09-14 00:00:00	2006-09-14	2006-09-14 00:00:00	\N	38000177		0	0	0		0	0	0	110031	0	857005	40162522		
41711	3454	19073183	1984-07-11	1984-07-11 00:00:00	1984-07-25	1984-07-25 00:00:00	1984-07-25	38000177		0	0	14		0	0	0	229191	0	308182	19073183		
27122	2237	19075601	2005-12-04	2005-12-04 00:00:00	2005-12-04	2005-12-04 00:00:00	\N	38000177		0	0	0		0	0	0	148757	0	309362	19075601		
118095	2597	40213227	1993-11-02	1993-11-02 00:00:00	1993-11-02	1993-11-02 00:00:00	1993-11-02	581452		0	0	0		0	0	0	171860	0	113	40213227		
39542	3268	19059056	1970-07-06	1970-07-06 00:00:00	1970-08-10	1970-08-10 00:00:00	1970-08-10	38000177		0	0	35		0	0	0	217212	0	243670	19059056		
60000	1313	40213296	2010-02-17	2010-02-17 00:00:00	2010-02-17	2010-02-17 00:00:00	2010-02-17	581452		0	0	0		0	0	0	86924	0	52	40213296		
42517	3526	19059056	1972-08-17	1972-08-17 00:00:00	1972-09-16	1972-09-16 00:00:00	1972-09-16	38000177		0	0	30		0	0	0	234003	0	243670	19059056		
40876	3389	19133905	2003-03-28	2003-03-28 00:00:00	2003-04-10	2003-04-10 00:00:00	2003-04-10	38000177		0	0	13		0	0	0	224779	0	834102	19133905		
63104	5241	19078461	1976-01-13	1976-01-13 00:00:00	1976-02-10	1976-02-10 00:00:00	1976-02-10	38000177		0	0	28		0	0	0	348798	0	310965	19078461		
43040	3568	40165015	2002-07-31	2002-07-31 00:00:00	2002-07-31	2002-07-31 00:00:00	\N	38000177		0	0	0		0	0	0	237070	0	861467	40165015		
24861	2044	1127078	1964-11-27	1964-11-27 00:00:00	1964-12-11	1964-12-11 00:00:00	1964-12-11	38000177		0	0	14		0	0	0	135982	0	282464	1127078		
53206	4419	1127433	2013-03-03	2013-03-03 00:00:00	2013-03-24	2013-03-24 00:00:00	2013-03-24	38000177		0	0	21		0	0	0	293822	0	313782	1127433		
34247	2830	1551192	1988-12-02	1988-12-02 00:00:00	1988-12-02	1988-12-02 00:00:00	1988-12-02	38000177		0	0	0		0	0	0	187723	0	312617	1551192		
2133	170	1115171	2004-01-31	2004-01-31 00:00:00	2004-03-06	2004-03-06 00:00:00	2004-03-06	38000177		0	0	35		0	0	0	11567	0	849574	1115171		
17984	1490	19059056	1941-01-22	1941-01-22 00:00:00	1941-02-05	1941-02-05 00:00:00	1941-02-05	38000177		0	0	14		0	0	0	99365	0	243670	19059056		
235308	5169	40213160	1958-05-12	1958-05-12 00:00:00	1958-05-12	1958-05-12 00:00:00	1958-05-12	581452		0	0	0		0	0	0	343658	0	10	40213160		
36668	3026	1127433	1955-03-25	1955-03-25 00:00:00	1955-04-08	1955-04-08 00:00:00	1955-04-08	38000177		0	0	14		0	0	0	201803	0	313782	1127433		
46150	3823	1127433	2014-05-20	2014-05-20 00:00:00	2014-06-03	2014-06-03 00:00:00	2014-06-03	38000177		0	0	14		0	0	0	253924	0	313782	1127433		
225096	4942	40213160	1959-04-09	1959-04-09 00:00:00	1959-04-09	1959-04-09 00:00:00	1959-04-09	581452		0	0	0		0	0	0	328512	0	10	40213160		
225117	4943	40213260	2011-08-17	2011-08-17 00:00:00	2011-08-17	2011-08-17 00:00:00	2011-08-17	581452		0	0	0		0	0	0	328562	0	121	40213260		
29573	2448	1127433	1979-12-26	1979-12-26 00:00:00	1980-01-02	1980-01-02 00:00:00	1980-01-02	38000177		0	0	7		0	0	0	162389	0	313782	1127433		
1516	119	19128065	1977-11-20	1977-11-20 00:00:00	1978-11-15	1978-11-15 00:00:00	1978-11-15	38000177		0	0	360		0	0	0	7940	0	749882	19128065		
33886	2802	19006318	1952-08-06	1952-08-06 00:00:00	1952-08-20	1952-08-20 00:00:00	1952-08-20	38000177		0	0	14		0	0	0	185760	0	105078	19006318		
4506	374	19133905	2015-10-17	2015-10-17 00:00:00	2015-10-27	2015-10-27 00:00:00	2015-10-27	38000177		0	0	10		0	0	0	24843	0	834102	19133905		
146130	3214	40213296	2012-02-21	2012-02-21 00:00:00	2012-02-21	2012-02-21 00:00:00	2012-02-21	581452		0	0	0		0	0	0	213520	0	52	40213296		
103288	2265	40213227	2014-08-31	2014-08-31 00:00:00	2014-08-31	2014-08-31 00:00:00	2014-08-31	581452		0	0	0		0	0	0	150536	0	113	40213227		
145966	3211	40213296	1999-07-23	1999-07-23 00:00:00	1999-07-23	1999-07-23 00:00:00	1999-07-23	581452		0	0	0		0	0	0	213356	0	52	40213296		
18667	1541	19133873	1972-08-04	1972-08-04 00:00:00	1972-08-16	1972-08-16 00:00:00	1972-08-16	38000177		0	0	12		0	0	0	103240	0	834061	19133873		
60484	5031	1127433	2015-01-07	2015-01-07 00:00:00	2015-01-14	2015-01-14 00:00:00	2015-01-14	38000177		0	0	7		0	0	0	334322	0	313782	1127433		
6403	539	19126352	1982-11-28	1982-11-28 00:00:00	1999-07-25	1999-07-25 00:00:00	1999-07-25	38000177		0	0	6083		0	0	0	35855	0	705129	19126352		
61430	5111	1127433	1948-09-10	1948-09-10 00:00:00	1948-09-17	1948-09-17 00:00:00	1948-09-17	38000177		0	0	7		0	0	0	339600	0	313782	1127433		
15809	1315	1127078	1964-05-25	1964-05-25 00:00:00	1964-06-08	1964-06-08 00:00:00	1964-06-08	38000177		0	0	14		0	0	0	87106	0	282464	1127078		
15860	1317	1713671	1986-12-21	1986-12-21 00:00:00	1987-01-04	1987-01-04 00:00:00	1987-01-04	38000177		0	0	14		0	0	0	87254	0	562251	1713671		
29854	651	40213314	1977-10-13	1977-10-13 00:00:00	1977-10-13	1977-10-13 00:00:00	1977-10-13	581452		0	0	0		0	0	0	43123	0	49	40213314		
39904	3301	1124300	1974-05-11	1974-05-11 00:00:00	1974-05-11	1974-05-11 00:00:00	\N	38000177		0	0	0		0	0	0	219317	0	00781178901	45011828		
18803	1553	1713671	2009-12-14	2009-12-14 00:00:00	2009-12-21	2009-12-21 00:00:00	2009-12-21	38000177		0	0	7		0	0	0	103993	0	562251	1713671		
107651	2359	40213227	1997-02-03	1997-02-03 00:00:00	1997-02-03	1997-02-03 00:00:00	1997-02-03	581452		0	0	0		0	0	0	157209	0	113	40213227		
11390	949	1127433	1974-07-05	1974-07-05 00:00:00	1974-10-03	1974-10-03 00:00:00	1974-10-03	38000177		0	0	90		0	0	0	63022	0	313782	1127433		
152974	3367	40213296	2003-03-10	2003-03-10 00:00:00	2003-03-10	2003-03-10 00:00:00	2003-03-10	581452		0	0	0		0	0	0	223293	0	52	40213296		
52958	1158	40213314	1979-11-11	1979-11-11 00:00:00	1979-11-11	1979-11-11 00:00:00	1979-11-11	581452		0	0	0		0	0	0	76493	0	49	40213314		
25539	2098	19078461	2007-04-23	2007-04-23 00:00:00	2007-05-14	2007-05-14 00:00:00	2007-05-14	38000177		0	0	21		0	0	0	139842	0	310965	19078461		
12890	1083	19008572	1976-08-04	1976-08-04 00:00:00	1976-08-25	1976-08-25 00:00:00	1976-08-25	38000177		0	0	21		0	0	0	71172	0	106258	19008572		
57668	4791	1127433	2007-11-21	2007-11-21 00:00:00	2007-12-19	2007-12-19 00:00:00	2007-12-19	38000177		0	0	28		0	0	0	318825	0	313782	1127433		
48862	4052	1127078	1986-12-19	1986-12-19 00:00:00	1987-01-02	1987-01-02 00:00:00	1987-01-02	38000177		0	0	14		0	0	0	269342	0	282464	1127078		
13122	1101	19133873	1976-03-12	1976-03-12 00:00:00	1976-03-19	1976-03-19 00:00:00	1976-03-19	38000177		0	0	7		0	0	0	72340	0	834061	19133873		
135292	2970	40213260	2016-04-22	2016-04-22 00:00:00	2016-04-22	2016-04-22 00:00:00	2016-04-22	581452		0	0	0		0	0	0	198378	0	121	40213260		
30800	672	40213260	2007-12-10	2007-12-10 00:00:00	2007-12-10	2007-12-10 00:00:00	2007-12-10	581452		0	0	0		0	0	0	44391	0	121	40213260		
58398	4852	1127078	1950-08-12	1950-08-12 00:00:00	1950-08-26	1950-08-26 00:00:00	1950-08-26	38000177		0	0	14		0	0	0	322791	0	282464	1127078		
60070	4991	19128065	1986-07-01	1986-07-01 00:00:00	1987-06-26	1987-06-26 00:00:00	1987-06-26	38000177		0	0	360		0	0	0	332025	0	749882	19128065		
127889	2813	40213227	2016-02-26	2016-02-26 00:00:00	2016-02-26	2016-02-26 00:00:00	2016-02-26	581452		0	0	0		0	0	0	186386	0	113	40213227		
6101	510	1127078	1966-08-28	1966-08-28 00:00:00	1966-09-11	1966-09-11 00:00:00	1966-09-11	38000177		0	0	14		0	0	0	34116	0	282464	1127078		
44692	3699	964261	1999-07-08	1999-07-08 00:00:00	1999-07-08	1999-07-08 00:00:00	\N	38000177		0	0	0		0	0	0	245930	0	2001499	964261		
139311	3060	40213227	1995-12-23	1995-12-23 00:00:00	1995-12-23	1995-12-23 00:00:00	1995-12-23	581452		0	0	0		0	0	0	203593	0	113	40213227		
7079	596	1127078	1953-09-18	1953-09-18 00:00:00	1953-11-17	1953-11-17 00:00:00	1953-11-17	38000177		0	0	60		0	0	0	39390	0	282464	1127078		
144123	3167	40213227	2012-01-01	2012-01-01 00:00:00	2012-01-01	2012-01-01 00:00:00	2012-01-01	581452		0	0	0		0	0	0	210563	0	113	40213227		
7274	609	1118084	2001-04-22	2001-04-22 00:00:00	2001-04-22	2001-04-22 00:00:00	\N	38000177		0	0	0		0	0	0	40433	0	00025152531	44923712		
27304	2258	19006318	1959-11-30	1959-11-30 00:00:00	1959-12-14	1959-12-14 00:00:00	1959-12-14	38000177		0	0	14		0	0	0	150095	0	105078	19006318		
27335	2260	40173590	2012-09-30	2012-09-30 00:00:00	2012-09-30	2012-09-30 00:00:00	\N	38000177		0	0	0		0	0	0	150193	0	904419	40173590		
37868	3129	1713671	1975-01-02	1975-01-02 00:00:00	1975-01-09	1975-01-09 00:00:00	1975-01-09	38000177		0	0	7		0	0	0	208288	0	562251	1713671		
7764	649	19059056	1970-07-02	1970-07-02 00:00:00	1970-07-16	1970-07-16 00:00:00	1970-07-16	38000177		0	0	14		0	0	0	43025	0	243670	19059056		
43341	3593	1127433	1961-09-29	1961-09-29 00:00:00	1961-10-13	1961-10-13 00:00:00	1961-10-13	38000177		0	0	14		0	0	0	238666	0	313782	1127433		
13672	1144	1127433	1981-06-10	1981-06-10 00:00:00	1981-06-17	1981-06-17 00:00:00	1981-06-17	38000177		0	0	7		0	0	0	75518	0	313782	1127433		
13702	1146	1127078	1965-06-12	1965-06-12 00:00:00	1965-07-03	1965-07-03 00:00:00	1965-07-03	38000177		0	0	21		0	0	0	75738	0	282464	1127078		
238416	5233	40213160	1956-11-27	1956-11-27 00:00:00	1956-11-27	1956-11-27 00:00:00	1956-11-27	581452		0	0	0		0	0	0	348161	0	10	40213160		
19981	1640	1127433	1992-03-25	1992-03-25 00:00:00	1992-04-01	1992-04-01 00:00:00	1992-04-01	38000177		0	0	7		0	0	0	110043	0	313782	1127433		
41712	3454	19078461	2005-09-07	2005-09-07 00:00:00	2005-09-21	2005-09-21 00:00:00	2005-09-21	38000177		0	0	14		0	0	0	229143	0	310965	19078461		
27123	2237	19126352	2005-12-04	2005-12-04 00:00:00	2005-12-04	2005-12-04 00:00:00	\N	38000177		0	0	0		0	0	0	148757	0	705129	19126352		
118096	2597	40213306	1993-11-02	1993-11-02 00:00:00	1993-11-02	1993-11-02 00:00:00	1993-11-02	581452		0	0	0		0	0	0	171860	0	43	40213306		
39543	3268	40229134	1988-11-23	1988-11-23 00:00:00	1988-12-07	1988-12-07 00:00:00	1988-12-07	38000177		0	0	14		0	0	0	217165	0	1043400	40229134		
60004	1313	40213160	1970-05-06	1970-05-06 00:00:00	1970-05-06	1970-05-06 00:00:00	1970-05-06	581452		0	0	0		0	0	0	86898	0	10	40213160		
42518	3526	40162522	1972-08-17	1972-08-17 00:00:00	1972-08-17	1972-08-17 00:00:00	\N	38000177		0	0	0		0	0	0	234003	0	857005	40162522		
40891	3391	40229134	1994-10-19	1994-10-19 00:00:00	1994-10-26	1994-10-26 00:00:00	1994-10-26	38000177		0	0	7		0	0	0	224906	0	1043400	40229134		
63105	5241	1124300	2001-04-01	2001-04-01 00:00:00	2001-04-01	2001-04-01 00:00:00	\N	38000177		0	0	0		0	0	0	348724	0	00781178901	45011828		
43041	3568	1127433	1976-04-24	1976-04-24 00:00:00	1976-05-08	1976-05-08 00:00:00	1976-05-08	38000177		0	0	14		0	0	0	237066	0	313782	1127433		
24862	2044	19129655	1964-11-27	1964-11-27 00:00:00	1964-12-11	1964-12-11 00:00:00	1964-12-11	38000177		0	0	14		0	0	0	135982	0	789980	19129655		
53207	4419	1127433	2005-05-12	2005-05-12 00:00:00	2005-05-26	2005-05-26 00:00:00	2005-05-26	38000177		0	0	14		0	0	0	293794	0	313782	1127433		
34248	2830	19128022	1990-07-29	1990-07-29 00:00:00	1991-07-24	1991-07-24 00:00:00	1991-07-24	38000177		0	0	360		0	0	0	187692	0	749785	19128022		
2134	170	1713671	1979-03-29	1979-03-29 00:00:00	1979-04-19	1979-04-19 00:00:00	1979-04-19	38000177		0	0	21		0	0	0	11568	0	562251	1713671		
17985	1490	1713671	1985-01-08	1985-01-08 00:00:00	1985-01-29	1985-01-29 00:00:00	1985-01-29	38000177		0	0	21		0	0	0	99362	0	562251	1713671		
235310	5169	40213160	1955-11-07	1955-11-07 00:00:00	1955-11-07	1955-11-07 00:00:00	1955-11-07	581452		0	0	0		0	0	0	343687	0	10	40213160		
36669	3026	1127433	1995-11-03	1995-11-03 00:00:00	1995-11-17	1995-11-17 00:00:00	1995-11-17	38000177		0	0	14		0	0	0	201768	0	313782	1127433		
46151	3823	1127433	1969-10-25	1969-10-25 00:00:00	1969-11-01	1969-11-01 00:00:00	1969-11-01	38000177		0	0	7		0	0	0	253908	0	313782	1127433		
225099	4942	40213227	2005-05-05	2005-05-05 00:00:00	2005-05-05	2005-05-05 00:00:00	2005-05-05	581452		0	0	0		0	0	0	328535	0	113	40213227		
225128	4943	40213160	1961-07-12	1961-07-12 00:00:00	1961-07-12	1961-07-12 00:00:00	1961-07-12	581452		0	0	0		0	0	0	328545	0	10	40213160		
29574	2448	19128065	1983-06-16	1983-06-16 00:00:00	1984-06-10	1984-06-10 00:00:00	1984-06-10	38000177		0	0	360		0	0	0	162379	0	749882	19128065		
1517	120	1127433	2000-11-08	2000-11-08 00:00:00	2000-11-22	2000-11-22 00:00:00	2000-11-22	38000177		0	0	14		0	0	0	8006	0	313782	1127433		
33887	2802	19133873	1940-10-02	1940-10-02 00:00:00	1940-10-11	1940-10-11 00:00:00	1940-10-11	38000177		0	0	9		0	0	0	185704	0	834061	19133873		
4513	376	920300	1996-05-13	1996-05-13 00:00:00	1996-05-20	1996-05-20 00:00:00	1996-05-20	38000177		0	0	7		0	0	0	24923	0	311989	920300		
146134	3214	40213227	2014-02-25	2014-02-25 00:00:00	2014-02-25	2014-02-25 00:00:00	2014-02-25	581452		0	0	0		0	0	0	213511	0	113	40213227		
103305	2265	40213296	2006-08-06	2006-08-06 00:00:00	2006-08-06	2006-08-06 00:00:00	2006-08-06	581452		0	0	0		0	0	0	150501	0	52	40213296		
9471	202	40213227	1999-10-02	1999-10-02 00:00:00	1999-10-02	1999-10-02 00:00:00	1999-10-02	581452		0	0	0		0	0	0	13861	0	113	40213227		
18668	1541	19129655	1963-09-26	1963-09-26 00:00:00	1963-10-10	1963-10-10 00:00:00	1963-10-10	38000177		0	0	14		0	0	0	103290	0	789980	19129655		
60485	5031	1713671	1930-08-30	1930-08-30 00:00:00	1930-09-20	1930-09-20 00:00:00	1930-09-20	38000177		0	0	21		0	0	0	334325	0	562251	1713671		
6404	539	1127433	1989-01-16	1989-01-16 00:00:00	1989-01-23	1989-01-23 00:00:00	1989-01-23	38000177		0	0	7		0	0	0	35836	0	313782	1127433		
61431	5111	19126352	1967-07-24	1967-07-24 00:00:00	1984-12-03	1984-12-03 00:00:00	1984-12-03	38000177		0	0	6342		0	0	0	339598	0	705129	19126352		
15810	1315	1127433	1974-10-14	1974-10-14 00:00:00	1974-10-28	1974-10-28 00:00:00	1974-10-28	38000177		0	0	14		0	0	0	87107	0	313782	1127433		
15861	1317	19059056	1971-02-23	1971-02-23 00:00:00	1971-03-16	1971-03-16 00:00:00	1971-03-16	38000177		0	0	21		0	0	0	87276	0	243670	19059056		
29855	651	40213251	1984-04-26	1984-04-26 00:00:00	1984-04-26	1984-04-26 00:00:00	1984-04-26	581452		0	0	0		0	0	0	43066	0	21	40213251		
39905	3301	1713671	2006-05-10	2006-05-10 00:00:00	2006-05-17	2006-05-17 00:00:00	2006-05-17	38000177		0	0	7		0	0	0	219283	0	562251	1713671		
18804	1553	40229134	1979-11-09	1979-11-09 00:00:00	1979-11-16	1979-11-16 00:00:00	1979-11-16	38000177		0	0	7		0	0	0	103954	0	1043400	40229134		
107661	2359	40213227	2016-05-23	2016-05-23 00:00:00	2016-05-23	2016-05-23 00:00:00	2016-05-23	581452		0	0	0		0	0	0	157280	0	113	40213227		
11391	949	19059056	1961-01-30	1961-01-30 00:00:00	1961-02-13	1961-02-13 00:00:00	1961-02-13	38000177		0	0	14		0	0	0	63021	0	243670	19059056		
152976	3367	40213227	1995-05-08	1995-05-08 00:00:00	1995-05-08	1995-05-08 00:00:00	1995-05-08	581452		0	0	0		0	0	0	223291	0	113	40213227		
52966	1158	40213227	2001-12-09	2001-12-09 00:00:00	2001-12-09	2001-12-09 00:00:00	2001-12-09	581452		0	0	0		0	0	0	76504	0	113	40213227		
25540	2098	19059056	1962-11-01	1962-11-01 00:00:00	1962-11-15	1962-11-15 00:00:00	1962-11-15	38000177		0	0	14		0	0	0	139864	0	243670	19059056		
12891	1083	19128065	1984-04-24	1984-04-24 00:00:00	1985-04-19	1985-04-19 00:00:00	1985-04-19	38000177		0	0	360		0	0	0	71175	0	749882	19128065		
57669	4791	1127433	1989-10-27	1989-10-27 00:00:00	1989-11-10	1989-11-10 00:00:00	1989-11-10	38000177		0	0	14		0	0	0	318801	0	313782	1127433		
48863	4052	19059056	1979-05-19	1979-05-19 00:00:00	1979-06-02	1979-06-02 00:00:00	1979-06-02	38000177		0	0	14		0	0	0	269330	0	243670	19059056		
13123	1101	1127078	1981-06-12	1981-06-12 00:00:00	1981-07-03	1981-07-03 00:00:00	1981-07-03	38000177		0	0	21		0	0	0	72325	0	282464	1127078		
135297	2970	40213160	1965-07-23	1965-07-23 00:00:00	1965-07-23	1965-07-23 00:00:00	1965-07-23	581452		0	0	0		0	0	0	198294	0	10	40213160		
30805	672	40213227	2017-01-30	2017-01-30 00:00:00	2017-01-30	2017-01-30 00:00:00	2017-01-30	581452		0	0	0		0	0	0	44343	0	113	40213227		
58399	4852	19006318	1950-01-24	1950-01-24 00:00:00	1950-02-07	1950-02-07 00:00:00	1950-02-07	38000177		0	0	14		0	0	0	322790	0	105078	19006318		
60071	4992	19128065	2001-05-02	2001-05-02 00:00:00	2002-04-27	2002-04-27 00:00:00	2002-04-27	38000177		0	0	360		0	0	0	332099	0	749882	19128065		
46420	1015	40213198	2018-12-31	2018-12-31 00:00:00	2018-12-31	2018-12-31 00:00:00	2018-12-31	581452		0	0	0		0	0	0	66792	0	133	40213198		
6102	510	1713671	1975-06-17	1975-06-17 00:00:00	1975-07-08	1975-07-08 00:00:00	1975-07-08	38000177		0	0	21		0	0	0	34068	0	562251	1713671		
44693	3699	46233988	1976-10-16	1976-10-16 00:00:00	1976-10-30	1976-10-30 00:00:00	1976-10-30	38000177		0	0	14		0	0	0	245931	0	1652673	46233988		
57819	1265	40213160	1981-01-18	1981-01-18 00:00:00	1981-01-18	1981-01-18 00:00:00	1981-01-18	581452		0	0	0		0	0	0	83407	0	10	40213160		
7080	596	1127433	1979-12-15	1979-12-15 00:00:00	1980-01-05	1980-01-05 00:00:00	1980-01-05	38000177		0	0	21		0	0	0	39325	0	313782	1127433		
144129	3167	40213160	1960-11-13	1960-11-13 00:00:00	1960-11-13	1960-11-13 00:00:00	1960-11-13	581452		0	0	0		0	0	0	210581	0	10	40213160		
7275	609	46275916	2014-12-02	2014-12-02 00:00:00	2014-12-02	2014-12-02 00:00:00	2014-12-02	38000177		0	0	0		0	0	0	40413	0	1660014	46275916		
27305	2258	1127433	1979-07-19	1979-07-19 00:00:00	1979-07-26	1979-07-26 00:00:00	1979-07-26	38000177		0	0	7		0	0	0	150077	0	313782	1127433		
27336	2261	1115171	2007-11-17	2007-11-17 00:00:00	2007-12-08	2007-12-08 00:00:00	2007-12-08	38000177		0	0	21		0	0	0	150336	0	849574	1115171		
37878	3132	1118084	2007-04-17	2007-04-17 00:00:00	2007-04-17	2007-04-17 00:00:00	\N	38000177		0	0	0		0	0	0	208441	0	00025152531	44923712		
7765	649	1127078	1974-03-13	1974-03-13 00:00:00	1974-04-17	1974-04-17 00:00:00	1974-04-17	38000177		0	0	35		0	0	0	42978	0	282464	1127078		
43342	3593	19133873	1965-04-06	1965-04-06 00:00:00	1965-04-15	1965-04-15 00:00:00	1965-04-15	38000177		0	0	9		0	0	0	238667	0	834061	19133873		
13673	1144	19133873	1975-03-14	1975-03-14 00:00:00	1975-03-23	1975-03-23 00:00:00	1975-03-23	38000177		0	0	9		0	0	0	75470	0	834061	19133873		
13703	1146	19133905	2001-12-10	2001-12-10 00:00:00	2001-12-22	2001-12-22 00:00:00	2001-12-22	38000177		0	0	12		0	0	0	75719	0	834102	19133905		
238424	5233	40213227	1998-09-29	1998-09-29 00:00:00	1998-09-29	1998-09-29 00:00:00	1998-09-29	581452		0	0	0		0	0	0	348154	0	113	40213227		
19982	1640	1713671	2000-09-22	2000-09-22 00:00:00	2000-10-13	2000-10-13 00:00:00	2000-10-13	38000177		0	0	21		0	0	0	110085	0	562251	1713671		
41713	3454	1127078	1983-04-06	1983-04-06 00:00:00	1983-04-20	1983-04-20 00:00:00	1983-04-20	38000177		0	0	14		0	0	0	229190	0	282464	1127078		
27124	2237	1539411	2005-12-04	2005-12-04 00:00:00	2005-12-04	2005-12-04 00:00:00	\N	38000177		0	0	0		0	0	0	148757	0	312961	1539411		
28210	614	40213296	2007-01-07	2007-01-07 00:00:00	2007-01-07	2007-01-07 00:00:00	2007-01-07	581452		0	0	0		0	0	0	40840	0	52	40213296		
39544	3268	1713671	1992-08-14	1992-08-14 00:00:00	1992-10-30	1992-10-30 00:00:00	1992-10-30	38000177		0	0	77		0	0	0	217186	0	562251	1713671		
60005	1313	40213160	1970-08-05	1970-08-05 00:00:00	1970-08-05	1970-08-05 00:00:00	1970-08-05	581452		0	0	0		0	0	0	86930	0	10	40213160		
42519	3526	40229134	1994-03-07	1994-03-07 00:00:00	1994-03-14	1994-03-14 00:00:00	1994-03-14	38000177		0	0	7		0	0	0	233954	0	1043400	40229134		
40892	3391	1127433	2008-07-16	2008-07-16 00:00:00	2008-07-30	2008-07-30 00:00:00	2008-07-30	38000177		0	0	14		0	0	0	224909	0	313782	1127433		
63106	5241	1127433	2017-05-17	2017-05-17 00:00:00	2017-08-15	2017-08-15 00:00:00	2017-08-15	38000177		0	0	90		0	0	0	348801	0	313782	1127433		
43042	3568	1127433	1986-06-21	1986-06-21 00:00:00	1986-07-05	1986-07-05 00:00:00	1986-07-05	38000177		0	0	14		0	0	0	237105	0	313782	1127433		
24863	2044	1127433	2016-10-14	2016-10-14 00:00:00	2016-10-28	2016-10-28 00:00:00	2016-10-28	38000177		0	0	14		0	0	0	135971	0	313782	1127433		
53434	4442	19128065	1998-05-27	1998-05-27 00:00:00	1999-05-22	1999-05-22 00:00:00	1999-05-22	38000177		0	0	360		0	0	0	295313	0	749882	19128065		
34249	2830	19133873	1986-01-24	1986-01-24 00:00:00	1986-01-31	1986-01-31 00:00:00	1986-01-31	38000177		0	0	7		0	0	0	187806	0	834061	19133873		
2135	170	1127078	1971-12-31	1971-12-31 00:00:00	1972-01-14	1972-01-14 00:00:00	1972-01-14	38000177		0	0	14		0	0	0	11536	0	282464	1127078		
17986	1490	1713671	2017-02-20	2017-02-20 00:00:00	2017-02-27	2017-02-27 00:00:00	2017-02-27	38000177		0	0	7		0	0	0	99375	0	562251	1713671		
235317	5169	40213260	2006-07-31	2006-07-31 00:00:00	2006-07-31	2006-07-31 00:00:00	2006-07-31	581452		0	0	0		0	0	0	343724	0	121	40213260		
36670	3026	1713671	1972-12-19	1972-12-19 00:00:00	1973-01-02	1973-01-02 00:00:00	1973-01-02	38000177		0	0	14		0	0	0	201758	0	562251	1713671		
46152	3823	40171902	2008-11-05	2008-11-05 00:00:00	2008-11-05	2008-11-05 00:00:00	\N	38000177		0	0	0		0	0	0	253982	0	897718	40171902		
225103	4942	40213260	2006-05-11	2006-05-11 00:00:00	2006-05-11	2006-05-11 00:00:00	2006-05-11	581452		0	0	0		0	0	0	328522	0	121	40213260		
225132	4943	40213227	2003-06-11	2003-06-11 00:00:00	2003-06-11	2003-06-11 00:00:00	2003-06-11	581452		0	0	0		0	0	0	328609	0	113	40213227		
29575	2448	1713671	1988-04-02	1988-04-02 00:00:00	1988-04-23	1988-04-23 00:00:00	1988-04-23	38000177		0	0	21		0	0	0	162391	0	562251	1713671		
1518	120	19133873	1981-08-22	1981-08-22 00:00:00	1981-09-01	1981-09-01 00:00:00	1981-09-01	38000177		0	0	10		0	0	0	8001	0	834061	19133873		
33888	2802	19059056	1973-06-18	1973-06-18 00:00:00	1973-07-02	1973-07-02 00:00:00	1973-07-02	38000177		0	0	14		0	0	0	185712	0	243670	19059056		
4514	376	40236824	1996-05-13	1996-05-13 00:00:00	1996-05-20	1996-05-20 00:00:00	1996-05-20	38000177		0	0	7		0	0	0	24923	0	1094107	40236824		
146135	3214	40213296	2014-02-25	2014-02-25 00:00:00	2014-02-25	2014-02-25 00:00:00	2014-02-25	581452		0	0	0		0	0	0	213511	0	52	40213296		
103306	2265	40213160	1967-06-04	1967-06-04 00:00:00	1967-06-04	1967-06-04 00:00:00	1967-06-04	581452		0	0	0		0	0	0	150495	0	10	40213160		
9480	202	40213227	1992-08-22	1992-08-22 00:00:00	1992-08-22	1992-08-22 00:00:00	1992-08-22	581452		0	0	0		0	0	0	13823	0	113	40213227		
18669	1541	19059056	1963-09-26	1963-09-26 00:00:00	1963-10-10	1963-10-10 00:00:00	1963-10-10	38000177		0	0	14		0	0	0	103290	0	243670	19059056		
60486	5031	40229134	1922-07-28	1922-07-28 00:00:00	1922-08-11	1922-08-11 00:00:00	1922-08-11	38000177		0	0	14		0	0	0	334271	0	1043400	40229134		
6405	539	40236824	1990-06-09	1990-06-09 00:00:00	1990-06-16	1990-06-16 00:00:00	1990-06-16	38000177		0	0	7		0	0	0	35786	0	1094107	40236824		
61432	5111	1118084	1979-12-06	1979-12-06 00:00:00	1979-12-06	1979-12-06 00:00:00	\N	38000177		0	0	0		0	0	0	339629	0	00025152531	44923712		
15811	1315	19059056	1961-05-29	1961-05-29 00:00:00	1961-06-12	1961-06-12 00:00:00	1961-06-12	38000177		0	0	14		0	0	0	87118	0	243670	19059056		
15862	1317	19059056	1982-09-14	1982-09-14 00:00:00	1982-10-14	1982-10-14 00:00:00	1982-10-14	38000177		0	0	30		0	0	0	87277	0	243670	19059056		
29860	651	40213160	1982-04-15	1982-04-15 00:00:00	1982-04-15	1982-04-15 00:00:00	1982-04-15	581452		0	0	0		0	0	0	43065	0	10	40213160		
39906	3301	1713671	2011-09-03	2011-09-03 00:00:00	2011-09-10	2011-09-10 00:00:00	2011-09-10	38000177		0	0	7		0	0	0	219340	0	562251	1713671		
18805	1553	1127433	1990-06-28	1990-06-28 00:00:00	1990-07-19	1990-07-19 00:00:00	1990-07-19	38000177		0	0	21		0	0	0	103939	0	313782	1127433		
107673	2359	40213227	2006-03-27	2006-03-27 00:00:00	2006-03-27	2006-03-27 00:00:00	2006-03-27	581452		0	0	0		0	0	0	157211	0	113	40213227		
11392	949	1713671	2012-08-26	2012-08-26 00:00:00	2012-09-02	2012-09-02 00:00:00	2012-09-02	38000177		0	0	7		0	0	0	63060	0	562251	1713671		
152980	3367	40213160	1963-11-11	1963-11-11 00:00:00	1963-11-11	1963-11-11 00:00:00	1963-11-11	581452		0	0	0		0	0	0	223312	0	10	40213160		
52967	1158	40213306	2001-12-09	2001-12-09 00:00:00	2001-12-09	2001-12-09 00:00:00	2001-12-09	581452		0	0	0		0	0	0	76504	0	43	40213306		
25541	2098	19129655	1962-11-01	1962-11-01 00:00:00	1962-11-15	1962-11-15 00:00:00	1962-11-15	38000177		0	0	14		0	0	0	139864	0	789980	19129655		
12892	1083	19008572	1982-02-28	1982-02-28 00:00:00	1982-03-14	1982-03-14 00:00:00	1982-03-14	38000177		0	0	14		0	0	0	71068	0	106258	19008572		
57670	4791	40231925	2002-04-21	2002-04-21 00:00:00	2002-04-21	2002-04-21 00:00:00	\N	38000177		0	0	0		0	0	0	318824	0	1049221	40231925		
48864	4052	19073183	1979-05-19	1979-05-19 00:00:00	1979-06-02	1979-06-02 00:00:00	1979-06-02	38000177		0	0	14		0	0	0	269330	0	308182	19073183		
13124	1101	1127433	1974-10-19	1974-10-19 00:00:00	1974-11-02	1974-11-02 00:00:00	1974-11-02	38000177		0	0	14		0	0	0	72356	0	313782	1127433		
135299	2970	40213160	1970-03-27	1970-03-27 00:00:00	1970-03-27	1970-03-27 00:00:00	1970-03-27	581452		0	0	0		0	0	0	198282	0	10	40213160		
30823	672	40213160	1959-11-09	1959-11-09 00:00:00	1959-11-09	1959-11-09 00:00:00	1959-11-09	581452		0	0	0		0	0	0	44359	0	10	40213160		
58400	4852	1127078	1950-01-24	1950-01-24 00:00:00	1950-02-07	1950-02-07 00:00:00	1950-02-07	38000177		0	0	14		0	0	0	322790	0	282464	1127078		
60072	4992	19019979	1987-09-03	1987-09-03 00:00:00	1987-09-17	1987-09-17 00:00:00	1987-09-17	38000177		0	0	14		0	0	0	332156	0	198405	19019979		
46428	1015	40213227	2014-11-24	2014-11-24 00:00:00	2014-11-24	2014-11-24 00:00:00	2014-11-24	581452		0	0	0		0	0	0	66791	0	113	40213227		
6103	510	19059056	1984-12-23	1984-12-23 00:00:00	1985-01-20	1985-01-20 00:00:00	1985-01-20	38000177		0	0	28		0	0	0	34082	0	243670	19059056		
44694	3699	19133873	1974-11-29	1974-11-29 00:00:00	1974-12-10	1974-12-10 00:00:00	1974-12-10	38000177		0	0	11		0	0	0	245896	0	834061	19133873		
57826	1266	40213260	2017-12-18	2017-12-18 00:00:00	2017-12-18	2017-12-18 00:00:00	2017-12-18	581452		0	0	0		0	0	0	83463	0	121	40213260		
7082	596	1127433	1982-09-21	1982-09-21 00:00:00	1982-10-05	1982-10-05 00:00:00	1982-10-05	38000177		0	0	14		0	0	0	39326	0	313782	1127433		
144131	3168	40213227	2012-06-16	2012-06-16 00:00:00	2012-06-16	2012-06-16 00:00:00	2012-06-16	581452		0	0	0		0	0	0	210641	0	113	40213227		
7276	609	1310034	2014-12-02	2014-12-02 00:00:00	2014-12-02	2014-12-02 00:00:00	2014-12-02	38000177		0	0	0		0	0	0	40413	0	834357	1310034		
27306	2258	19059056	1961-08-16	1961-08-16 00:00:00	1961-08-30	1961-08-30 00:00:00	1961-08-30	38000177		0	0	14		0	0	0	150080	0	243670	19059056		
27337	2261	40165015	1993-02-19	1993-02-19 00:00:00	1993-02-19	1993-02-19 00:00:00	\N	38000177		0	0	0		0	0	0	150334	0	861467	40165015		
37879	3132	1127433	1995-07-01	1995-07-01 00:00:00	1995-09-29	1995-09-29 00:00:00	1995-09-29	38000177		0	0	90		0	0	0	208386	0	313782	1127433		
7766	649	19133873	1972-05-26	1972-05-26 00:00:00	1972-06-02	1972-06-02 00:00:00	1972-06-02	38000177		0	0	7		0	0	0	43015	0	834061	19133873		
43343	3593	1127078	1953-03-14	1953-03-14 00:00:00	1953-04-13	1953-04-13 00:00:00	1953-04-13	38000177		0	0	30		0	0	0	238686	0	282464	1127078		
13674	1145	19059056	1961-10-22	1961-10-22 00:00:00	1961-11-26	1961-11-26 00:00:00	1961-11-26	38000177		0	0	35		0	0	0	75555	0	243670	19059056		
13704	1146	1127433	1990-11-30	1990-11-30 00:00:00	1990-12-14	1990-12-14 00:00:00	1990-12-14	38000177		0	0	14		0	0	0	75744	0	313782	1127433		
238425	5233	40213296	1998-09-29	1998-09-29 00:00:00	1998-09-29	1998-09-29 00:00:00	1998-09-29	581452		0	0	0		0	0	0	348154	0	52	40213296		
19983	1640	1713671	2019-05-16	2019-05-16 00:00:00	2019-06-06	2019-06-06 00:00:00	2019-06-06	38000177		0	0	21		0	0	0	110092	0	562251	1713671		
41714	3454	19073183	1983-04-06	1983-04-06 00:00:00	1983-04-20	1983-04-20 00:00:00	1983-04-20	38000177		0	0	14		0	0	0	229190	0	308182	19073183		
27125	2237	1332419	2005-12-04	2005-12-04 00:00:00	2005-12-04	2005-12-04 00:00:00	\N	38000177		0	0	0		0	0	0	148757	0	197361	1332419		
28216	614	40213260	2014-01-26	2014-01-26 00:00:00	2014-01-26	2014-01-26 00:00:00	2014-01-26	581452		0	0	0		0	0	0	40844	0	121	40213260		
39545	3268	1118084	2009-04-17	2009-04-17 00:00:00	2009-04-17	2009-04-17 00:00:00	\N	38000177		0	0	0		0	0	0	217183	0	00025152531	44923712		
60014	1313	40213227	2002-02-06	2002-02-06 00:00:00	2002-02-06	2002-02-06 00:00:00	2002-02-06	581452		0	0	0		0	0	0	86942	0	113	40213227		
42520	3526	1127433	2012-05-10	2012-05-10 00:00:00	2012-06-14	2012-06-14 00:00:00	2012-06-14	38000177		0	0	35		0	0	0	233987	0	313782	1127433		
40893	3391	1713671	1994-07-26	1994-07-26 00:00:00	1994-10-04	1994-10-04 00:00:00	1994-10-04	38000177		0	0	70		0	0	0	224914	0	562251	1713671		
63108	5241	1127433	2017-03-18	2017-03-18 00:00:00	2017-03-25	2017-03-25 00:00:00	2017-03-25	38000177		0	0	7		0	0	0	348771	0	313782	1127433		
43043	3568	19133873	1984-01-15	1984-01-15 00:00:00	1984-01-28	1984-01-28 00:00:00	1984-01-28	38000177		0	0	13		0	0	0	237095	0	834061	19133873		
24864	2044	19059056	1966-04-14	1966-04-14 00:00:00	1966-04-28	1966-04-28 00:00:00	1966-04-28	38000177		0	0	14		0	0	0	135960	0	243670	19059056		
53435	4442	1127433	1994-03-10	1994-03-10 00:00:00	1994-03-17	1994-03-17 00:00:00	1994-03-17	38000177		0	0	7		0	0	0	295295	0	313782	1127433		
34250	2830	19128022	1991-07-24	1991-07-24 00:00:00	1992-07-18	1992-07-18 00:00:00	1992-07-18	38000177		0	0	360		0	0	0	187693	0	749785	19128022		
2136	170	40236824	1996-03-11	1996-03-11 00:00:00	1996-03-18	1996-03-18 00:00:00	1996-03-18	38000177		0	0	7		0	0	0	11577	0	1094107	40236824		
17987	1490	1118084	1974-02-18	1974-02-18 00:00:00	1974-02-18	1974-02-18 00:00:00	\N	38000177		0	0	0		0	0	0	99319	0	00025152531	44923712		
235319	5169	40213227	2004-06-07	2004-06-07 00:00:00	2004-06-07	2004-06-07 00:00:00	2004-06-07	581452		0	0	0		0	0	0	343723	0	113	40213227		
36671	3026	19078461	2017-05-11	2017-05-11 00:00:00	2017-08-09	2017-08-09 00:00:00	2017-08-09	38000177		0	0	90		0	0	0	201729	0	310965	19078461		
46153	3823	19018935	2008-11-05	2008-11-05 00:00:00	2008-11-05	2008-11-05 00:00:00	\N	38000177		0	0	0		0	0	0	253982	0	197604	19018935		
225104	4942	40213227	1997-01-09	1997-01-09 00:00:00	1997-01-09	1997-01-09 00:00:00	1997-01-09	581452		0	0	0		0	0	0	328532	0	113	40213227		
225133	4943	40213296	2003-06-11	2003-06-11 00:00:00	2003-06-11	2003-06-11 00:00:00	2003-06-11	581452		0	0	0		0	0	0	328609	0	52	40213296		
29576	2448	40229134	1981-08-24	1981-08-24 00:00:00	1981-08-31	1981-08-31 00:00:00	1981-08-31	38000177		0	0	7		0	0	0	162390	0	1043400	40229134		
1519	120	1124300	2017-03-18	2017-03-18 00:00:00	2017-03-18	2017-03-18 00:00:00	\N	38000177		0	0	0		0	0	0	7972	0	00781178901	45011828		
33889	2802	19059056	1943-02-16	1943-02-16 00:00:00	1943-03-02	1943-03-02 00:00:00	1943-03-02	38000177		0	0	14		0	0	0	185765	0	243670	19059056		
4515	376	1127433	1977-12-29	1977-12-29 00:00:00	1978-01-12	1978-01-12 00:00:00	1978-01-12	38000177		0	0	14		0	0	0	24940	0	313782	1127433		
146138	3214	40213227	1994-04-26	1994-04-26 00:00:00	1994-04-26	1994-04-26 00:00:00	1994-04-26	581452		0	0	0		0	0	0	213516	0	113	40213227		
103310	2265	40213227	1995-06-11	1995-06-11 00:00:00	1995-06-11	1995-06-11 00:00:00	1995-06-11	581452		0	0	0		0	0	0	150534	0	113	40213227		
20767	452	40213227	1994-05-27	1994-05-27 00:00:00	1994-05-27	1994-05-27 00:00:00	1994-05-27	581452		0	0	0		0	0	0	30116	0	113	40213227		
18670	1541	1127433	1982-01-19	1982-01-19 00:00:00	1982-02-16	1982-02-16 00:00:00	1982-02-16	38000177		0	0	28		0	0	0	103300	0	313782	1127433		
60487	5031	19078461	2017-01-02	2017-01-02 00:00:00	2017-01-30	2017-01-30 00:00:00	2017-01-30	38000177		0	0	28		0	0	0	334284	0	310965	19078461		
6406	539	920300	1990-06-09	1990-06-09 00:00:00	1990-06-16	1990-06-16 00:00:00	1990-06-16	38000177		0	0	7		0	0	0	35786	0	311989	920300		
61433	5111	1127433	1960-06-17	1960-06-17 00:00:00	1960-07-01	1960-07-01 00:00:00	1960-07-01	38000177		0	0	14		0	0	0	339619	0	313782	1127433		
15812	1315	19129655	1961-05-29	1961-05-29 00:00:00	1961-06-12	1961-06-12 00:00:00	1961-06-12	38000177		0	0	14		0	0	0	87118	0	789980	19129655		
15863	1317	40169281	1997-07-11	1997-07-11 00:00:00	1997-07-11	1997-07-11 00:00:00	\N	38000177		0	0	0		0	0	0	87328	0	896209	40169281		
29866	651	40213296	2018-12-06	2018-12-06 00:00:00	2018-12-06	2018-12-06 00:00:00	2018-12-06	581452		0	0	0		0	0	0	43116	0	52	40213296		
39907	3301	19133905	1976-08-02	1976-08-02 00:00:00	1976-08-13	1976-08-13 00:00:00	1976-08-13	38000177		0	0	11		0	0	0	219331	0	834102	19133905		
18806	1553	1127433	1977-08-24	1977-08-24 00:00:00	1977-08-31	1977-08-31 00:00:00	1977-08-31	38000177		0	0	7		0	0	0	103992	0	313782	1127433		
2165	173	1127433	2002-04-06	2002-04-06 00:00:00	2002-04-20	2002-04-20 00:00:00	2002-04-20	38000177		0	0	14		0	0	0	11742	0	313782	1127433		
11393	949	1127078	1960-01-06	1960-01-06 00:00:00	1960-01-20	1960-01-20 00:00:00	1960-01-20	38000177		0	0	14		0	0	0	63028	0	282464	1127078		
152983	3367	40213160	1968-02-12	1968-02-12 00:00:00	1968-02-12	1968-02-12 00:00:00	1968-02-12	581452		0	0	0		0	0	0	223349	0	10	40213160		
52968	1158	40213314	1980-10-12	1980-10-12 00:00:00	1980-10-12	1980-10-12 00:00:00	1980-10-12	581452		0	0	0		0	0	0	76532	0	49	40213314		
25545	2100	1115171	2009-09-15	2009-09-15 00:00:00	2009-10-13	2009-10-13 00:00:00	2009-10-13	38000177		0	0	28		0	0	0	139972	0	849574	1115171		
12893	1083	1127433	2006-10-21	2006-10-21 00:00:00	2006-11-04	2006-11-04 00:00:00	2006-11-04	38000177		0	0	14		0	0	0	71058	0	313782	1127433		
57671	4791	19078461	2002-04-21	2002-04-21 00:00:00	2002-07-20	2002-07-20 00:00:00	2002-07-20	38000177		0	0	90		0	0	0	318824	0	310965	19078461		
48865	4052	1115171	1999-06-28	1999-06-28 00:00:00	1999-07-12	1999-07-12 00:00:00	1999-07-12	38000177		0	0	14		0	0	0	269416	0	849574	1115171		
13125	1101	1127433	2009-02-01	2009-02-01 00:00:00	2009-02-15	2009-02-15 00:00:00	2009-02-15	38000177		0	0	14		0	0	0	72345	0	313782	1127433		
135304	2970	40213160	1965-09-24	1965-09-24 00:00:00	1965-09-24	1965-09-24 00:00:00	1965-09-24	581452		0	0	0		0	0	0	198278	0	10	40213160		
116463	2559	40213227	2009-05-30	2009-05-30 00:00:00	2009-05-30	2009-05-30 00:00:00	2009-05-30	581452		0	0	0		0	0	0	169638	0	113	40213227		
58401	4852	1127433	1962-12-15	1962-12-15 00:00:00	1962-12-22	1962-12-22 00:00:00	1962-12-22	38000177		0	0	7		0	0	0	322785	0	313782	1127433		
60073	4992	19073183	1987-09-03	1987-09-03 00:00:00	1987-09-17	1987-09-17 00:00:00	1987-09-17	38000177		0	0	14		0	0	0	332156	0	308182	19073183		
46438	1015	40213160	1955-04-04	1955-04-04 00:00:00	1955-04-04	1955-04-04 00:00:00	1955-04-04	581452		0	0	0		0	0	0	66842	0	10	40213160		
6104	510	1127433	1984-09-27	1984-09-27 00:00:00	1984-10-11	1984-10-11 00:00:00	1984-10-11	38000177		0	0	14		0	0	0	34070	0	313782	1127433		
44695	3699	1127078	1976-10-16	1976-10-16 00:00:00	1976-10-30	1976-10-30 00:00:00	1976-10-30	38000177		0	0	14		0	0	0	245931	0	282464	1127078		
57834	1266	40213160	1967-06-19	1967-06-19 00:00:00	1967-06-19	1967-06-19 00:00:00	1967-06-19	581452		0	0	0		0	0	0	83446	0	10	40213160		
7083	596	1118084	1984-02-28	1984-02-28 00:00:00	1984-02-28	1984-02-28 00:00:00	\N	38000177		0	0	0		0	0	0	39326	0	00025152531	44923712		
144134	3168	40213227	2002-03-23	2002-03-23 00:00:00	2002-03-23	2002-03-23 00:00:00	2002-03-23	581452		0	0	0		0	0	0	210636	0	113	40213227		
7277	609	40243436	2014-12-02	2014-12-02 00:00:00	2014-12-02	2014-12-02 00:00:00	2014-12-02	38000177		0	0	0		0	0	0	40413	0	1190795	40243436		
27307	2258	1127433	1981-03-09	1981-03-09 00:00:00	1981-04-06	1981-04-06 00:00:00	1981-04-06	38000177		0	0	28		0	0	0	150059	0	313782	1127433		
27338	2261	19078461	1993-02-19	1993-02-19 00:00:00	1993-05-20	1993-05-20 00:00:00	1993-05-20	38000177		0	0	90		0	0	0	150334	0	310965	19078461		
37880	3132	19059056	1965-11-23	1965-11-23 00:00:00	1965-12-07	1965-12-07 00:00:00	1965-12-07	38000177		0	0	14		0	0	0	208393	0	243670	19059056		
7767	649	40229134	1973-08-16	1973-08-16 00:00:00	1973-08-23	1973-08-23 00:00:00	1973-08-23	38000177		0	0	7		0	0	0	42990	0	1043400	40229134		
43344	3593	1713671	2008-08-11	2008-08-11 00:00:00	2008-08-18	2008-08-18 00:00:00	2008-08-18	38000177		0	0	7		0	0	0	238720	0	562251	1713671		
13675	1145	40236824	1956-09-17	1956-09-17 00:00:00	1956-09-24	1956-09-24 00:00:00	1956-09-24	38000177		0	0	7		0	0	0	75544	0	1094107	40236824		
13705	1146	1713671	1967-06-01	1967-06-01 00:00:00	1967-06-08	1967-06-08 00:00:00	1967-06-08	38000177		0	0	7		0	0	0	75687	0	562251	1713671		
9131	195	40213296	1998-03-23	1998-03-23 00:00:00	1998-03-23	1998-03-23 00:00:00	1998-03-23	581452		0	0	0		0	0	0	13376	0	52	40213296		
19984	1640	1127433	1978-08-30	1978-08-30 00:00:00	1978-09-06	1978-09-06 00:00:00	1978-09-06	38000177		0	0	7		0	0	0	110081	0	313782	1127433		
41715	3454	40231925	1997-02-21	1997-02-21 00:00:00	1997-02-21	1997-02-21 00:00:00	\N	38000177		0	0	0		0	0	0	229142	0	1049221	40231925		
27126	2237	19059056	1940-08-10	1940-08-10 00:00:00	1940-09-14	1940-09-14 00:00:00	1940-09-14	38000177		0	0	35		0	0	0	148804	0	243670	19059056		
28218	614	40213260	2015-02-01	2015-02-01 00:00:00	2015-02-01	2015-02-01 00:00:00	2015-02-01	581452		0	0	0		0	0	0	40832	0	121	40213260		
39546	3268	1127433	2018-05-21	2018-05-21 00:00:00	2018-06-11	2018-06-11 00:00:00	2018-06-11	38000177		0	0	21		0	0	0	217215	0	313782	1127433		
60018	1313	40213227	1992-01-29	1992-01-29 00:00:00	1992-01-29	1992-01-29 00:00:00	1992-01-29	581452		0	0	0		0	0	0	86912	0	113	40213227		
42521	3526	19078461	2000-11-09	2000-11-09 00:00:00	2000-12-09	2000-12-09 00:00:00	2000-12-09	38000177		0	0	30		0	0	0	234005	0	310965	19078461		
40894	3391	1713671	1999-08-18	1999-08-18 00:00:00	1999-09-08	1999-09-08 00:00:00	1999-09-08	38000177		0	0	21		0	0	0	224908	0	562251	1713671		
63109	5242	1713671	1987-10-18	1987-10-18 00:00:00	1987-10-25	1987-10-25 00:00:00	1987-10-25	38000177		0	0	7		0	0	0	348803	0	562251	1713671		
43044	3568	19006318	1971-11-28	1971-11-28 00:00:00	1971-12-12	1971-12-12 00:00:00	1971-12-12	38000177		0	0	14		0	0	0	237111	0	105078	19006318		
24865	2044	1127433	1967-03-19	1967-03-19 00:00:00	1967-03-26	1967-03-26 00:00:00	1967-03-26	38000177		0	0	7		0	0	0	136027	0	313782	1127433		
53436	4442	1713671	1984-11-05	1984-11-05 00:00:00	1984-11-19	1984-11-19 00:00:00	1984-11-19	38000177		0	0	14		0	0	0	295284	0	562251	1713671		
34251	2830	1551192	1985-11-12	1985-11-12 00:00:00	1985-11-12	1985-11-12 00:00:00	1985-11-12	38000177		0	0	0		0	0	0	187721	0	312617	1551192		
125089	2752	40213227	2012-05-13	2012-05-13 00:00:00	2012-05-13	2012-05-13 00:00:00	2012-05-13	581452		0	0	0		0	0	0	182055	0	113	40213227		
17988	1490	40229134	1992-10-18	1992-10-18 00:00:00	1992-11-01	1992-11-01 00:00:00	1992-11-01	38000177		0	0	14		0	0	0	99363	0	1043400	40229134		
235321	5169	40213160	1956-05-07	1956-05-07 00:00:00	1956-05-07	1956-05-07 00:00:00	1956-05-07	581452		0	0	0		0	0	0	343693	0	10	40213160		
36672	3026	19133905	2018-08-26	2018-08-26 00:00:00	2018-09-06	2018-09-06 00:00:00	2018-09-06	38000177		0	0	11		0	0	0	201793	0	834102	19133905		
46154	3823	40163554	2008-11-05	2008-11-05 00:00:00	2008-11-05	2008-11-05 00:00:00	\N	38000177		0	0	0		0	0	0	253982	0	855332	40163554		
123001	2704	40213160	1971-11-20	1971-11-20 00:00:00	1971-11-20	1971-11-20 00:00:00	1971-11-20	581452		0	0	0		0	0	0	179123	0	10	40213160		
225144	4943	40213227	2012-08-22	2012-08-22 00:00:00	2012-08-22	2012-08-22 00:00:00	2012-08-22	581452		0	0	0		0	0	0	328552	0	113	40213227		
29577	2448	19133873	1978-05-31	1978-05-31 00:00:00	1978-06-07	1978-06-07 00:00:00	1978-06-07	38000177		0	0	7		0	0	0	162337	0	834061	19133873		
1520	120	19078461	2016-03-30	2016-03-30 00:00:00	2016-04-13	2016-04-13 00:00:00	2016-04-13	38000177		0	0	14		0	0	0	7972	0	310965	19078461		
33899	2804	1127433	1983-04-09	1983-04-09 00:00:00	1983-05-16	1983-05-16 00:00:00	1983-05-16	38000177		0	0	37		0	0	0	185851	0	313782	1127433		
4516	376	19078461	2017-04-20	2017-04-20 00:00:00	2017-05-25	2017-05-25 00:00:00	2017-05-25	38000177		0	0	35		0	0	0	24943	0	310965	19078461		
146139	3214	40213306	1994-04-26	1994-04-26 00:00:00	1994-04-26	1994-04-26 00:00:00	1994-04-26	581452		0	0	0		0	0	0	213516	0	43	40213306		
103312	2265	40213296	2004-08-01	2004-08-01 00:00:00	2004-08-01	2004-08-01 00:00:00	2004-08-01	581452		0	0	0		0	0	0	150492	0	52	40213296		
20770	452	40213160	1967-08-18	1967-08-18 00:00:00	1967-08-18	1967-08-18 00:00:00	1967-08-18	581452		0	0	0		0	0	0	30096	0	10	40213160		
18671	1541	19133873	1966-12-20	1966-12-20 00:00:00	1967-01-01	1967-01-01 00:00:00	1967-01-01	38000177		0	0	12		0	0	0	103234	0	834061	19133873		
60488	5031	40220960	1995-08-19	1995-08-19 00:00:00	1995-08-19	1995-08-19 00:00:00	1995-08-19	38000177		0	0	0		0	0	0	334282	0	1804799	40220960		
6407	539	1127433	1950-11-24	1950-11-24 00:00:00	1950-12-08	1950-12-08 00:00:00	1950-12-08	38000177		0	0	14		0	0	0	35794	0	313782	1127433		
61434	5111	1713671	1961-05-31	1961-05-31 00:00:00	1961-06-21	1961-06-21 00:00:00	1961-06-21	38000177		0	0	21		0	0	0	339587	0	562251	1713671		
15813	1315	1713671	1989-10-06	1989-10-06 00:00:00	1989-10-20	1989-10-20 00:00:00	1989-10-20	38000177		0	0	14		0	0	0	87130	0	562251	1713671		
15864	1317	19006318	1963-03-16	1963-03-16 00:00:00	1963-04-06	1963-04-06 00:00:00	1963-04-06	38000177		0	0	21		0	0	0	87275	0	105078	19006318		
29868	651	40213227	2018-12-06	2018-12-06 00:00:00	2018-12-06	2018-12-06 00:00:00	2018-12-06	581452		0	0	0		0	0	0	43116	0	113	40213227		
39908	3301	1127433	1975-11-19	1975-11-19 00:00:00	1975-11-26	1975-11-26 00:00:00	1975-11-26	38000177		0	0	7		0	0	0	219330	0	313782	1127433		
18807	1553	1127078	1968-01-04	1968-01-04 00:00:00	1968-04-03	1968-04-03 00:00:00	1968-04-03	38000177		0	0	90		0	0	0	103937	0	282464	1127078		
2166	173	46233988	1971-01-08	1971-01-08 00:00:00	1971-01-22	1971-01-22 00:00:00	1971-01-22	38000177		0	0	14		0	0	0	11770	0	1652673	46233988		
11394	949	19006318	1960-01-06	1960-01-06 00:00:00	1960-01-20	1960-01-20 00:00:00	1960-01-20	38000177		0	0	14		0	0	0	63028	0	105078	19006318		
152988	3367	40213306	1985-05-06	1985-05-06 00:00:00	1985-05-06	1985-05-06 00:00:00	1985-05-06	581452		0	0	0		0	0	0	223341	0	43	40213306		
25490	2094	19133873	1950-08-08	1950-08-08 00:00:00	1950-08-21	1950-08-21 00:00:00	1950-08-21	38000177		0	0	13		0	0	0	139601	0	834061	19133873		
25546	2100	40165015	1976-06-10	1976-06-10 00:00:00	1976-06-10	1976-06-10 00:00:00	\N	38000177		0	0	0		0	0	0	139975	0	861467	40165015		
12894	1084	1118084	2016-06-15	2016-06-15 00:00:00	2016-06-15	2016-06-15 00:00:00	\N	38000177		0	0	0		0	0	0	71235	0	00025152531	44923712		
57672	4791	1127433	2016-06-04	2016-06-04 00:00:00	2016-06-18	2016-06-18 00:00:00	2016-06-18	38000177		0	0	14		0	0	0	318793	0	313782	1127433		
48866	4052	19008572	1981-12-26	1981-12-26 00:00:00	1982-01-09	1982-01-09 00:00:00	1982-01-09	38000177		0	0	14		0	0	0	269318	0	106258	19008572		
13126	1101	1124300	2016-01-25	2016-01-25 00:00:00	2016-01-25	2016-01-25 00:00:00	\N	38000177		0	0	0		0	0	0	72330	0	00781178901	45011828		
135306	2970	40213260	2015-04-17	2015-04-17 00:00:00	2015-04-17	2015-04-17 00:00:00	2015-04-17	581452		0	0	0		0	0	0	198355	0	121	40213260		
116464	2559	40213260	2009-05-30	2009-05-30 00:00:00	2009-05-30	2009-05-30 00:00:00	2009-05-30	581452		0	0	0		0	0	0	169638	0	121	40213260		
58402	4852	40229134	1977-07-25	1977-07-25 00:00:00	1977-08-08	1977-08-08 00:00:00	1977-08-08	38000177		0	0	14		0	0	0	322851	0	1043400	40229134		
60074	4992	40236446	1995-05-14	1995-05-14 00:00:00	1998-05-31	1998-05-31 00:00:00	1998-05-31	38000177		0	0	1113		0	0	0	332124	0	1091392	40236446		
46440	1015	40213260	2007-01-15	2007-01-15 00:00:00	2007-01-15	2007-01-15 00:00:00	2007-01-15	581452		0	0	0		0	0	0	66847	0	121	40213260		
6105	510	40229134	2006-08-03	2006-08-03 00:00:00	2006-08-17	2006-08-17 00:00:00	2006-08-17	38000177		0	0	14		0	0	0	34077	0	1043400	40229134		
44696	3699	19078461	1994-10-12	1994-10-12 00:00:00	1994-11-02	1994-11-02 00:00:00	1994-11-02	38000177		0	0	21		0	0	0	245928	0	310965	19078461		
57837	1266	40213296	2007-01-15	2007-01-15 00:00:00	2007-01-15	2007-01-15 00:00:00	2007-01-15	581452		0	0	0		0	0	0	83493	0	52	40213296		
7084	596	19006318	1949-02-11	1949-02-11 00:00:00	1949-02-25	1949-02-25 00:00:00	1949-02-25	38000177		0	0	14		0	0	0	39310	0	105078	19006318		
144135	3168	40213306	2002-03-23	2002-03-23 00:00:00	2002-03-23	2002-03-23 00:00:00	2002-03-23	581452		0	0	0		0	0	0	210636	0	43	40213306		
7278	609	1713671	1970-01-09	1970-01-09 00:00:00	1970-01-23	1970-01-23 00:00:00	1970-01-23	38000177		0	0	14		0	0	0	40439	0	562251	1713671		
27308	2258	19133873	1968-04-01	1968-04-01 00:00:00	1968-04-09	1968-04-09 00:00:00	1968-04-09	38000177		0	0	8		0	0	0	150074	0	834061	19133873		
27339	2261	1127078	1975-08-18	1975-08-18 00:00:00	1975-09-22	1975-09-22 00:00:00	1975-09-22	38000177		0	0	35		0	0	0	150309	0	282464	1127078		
3041	246	1154615	1963-12-02	1963-12-02 00:00:00	1963-12-02	1963-12-02 00:00:00	\N	38000177		0	0	0		0	0	0	16519	0	745679	1154615		
7768	649	1124300	2007-05-29	2007-05-29 00:00:00	2007-05-29	2007-05-29 00:00:00	\N	38000177		0	0	0		0	0	0	43008	0	00781178901	45011828		
43345	3593	1713671	1988-05-26	1988-05-26 00:00:00	1988-06-02	1988-06-02 00:00:00	1988-06-02	38000177		0	0	7		0	0	0	238703	0	562251	1713671		
13676	1145	920300	1956-09-17	1956-09-17 00:00:00	1956-09-24	1956-09-24 00:00:00	1956-09-24	38000177		0	0	7		0	0	0	75544	0	311989	920300		
13706	1146	19059056	1971-11-20	1971-11-20 00:00:00	1971-12-18	1971-12-18 00:00:00	1971-12-18	38000177		0	0	28		0	0	0	75741	0	243670	19059056		
9143	195	40213160	1958-11-24	1958-11-24 00:00:00	1958-11-24	1958-11-24 00:00:00	1958-11-24	581452		0	0	0		0	0	0	13360	0	10	40213160		
19985	1640	40173590	1996-05-08	1996-05-08 00:00:00	1996-05-08	1996-05-08 00:00:00	\N	38000177		0	0	0		0	0	0	110023	0	904419	40173590		
41716	3454	1115171	1997-02-21	1997-02-21 00:00:00	1997-05-22	1997-05-22 00:00:00	1997-05-22	38000177		0	0	90		0	0	0	229142	0	849574	1115171		
27127	2237	19059056	1933-09-09	1933-09-09 00:00:00	1933-09-23	1933-09-23 00:00:00	1933-09-23	38000177		0	0	14		0	0	0	148845	0	243670	19059056		
28220	614	40213227	2015-02-01	2015-02-01 00:00:00	2015-02-01	2015-02-01 00:00:00	2015-02-01	581452		0	0	0		0	0	0	40832	0	113	40213227		
39547	3268	19078461	2013-07-25	2013-07-25 00:00:00	2013-08-15	2013-08-15 00:00:00	2013-08-15	38000177		0	0	21		0	0	0	217214	0	310965	19078461		
60019	1313	40213306	1992-01-29	1992-01-29 00:00:00	1992-01-29	1992-01-29 00:00:00	1992-01-29	581452		0	0	0		0	0	0	86912	0	43	40213306		
42522	3527	40220960	2013-11-28	2013-11-28 00:00:00	2013-11-28	2013-11-28 00:00:00	2013-11-28	38000177		0	0	0		0	0	0	234074	0	1804799	40220960		
40895	3391	19133873	1990-09-09	1990-09-09 00:00:00	1990-09-17	1990-09-17 00:00:00	1990-09-17	38000177		0	0	8		0	0	0	224926	0	834061	19133873		
63110	5242	1127433	1975-11-18	1975-11-18 00:00:00	1975-12-02	1975-12-02 00:00:00	1975-12-02	38000177		0	0	14		0	0	0	348829	0	313782	1127433		
43045	3568	19059056	1971-11-28	1971-11-28 00:00:00	1971-12-12	1971-12-12 00:00:00	1971-12-12	38000177		0	0	14		0	0	0	237111	0	243670	19059056		
20794	1715	1127433	2015-01-08	2015-01-08 00:00:00	2015-01-15	2015-01-15 00:00:00	2015-01-15	38000177		0	0	7		0	0	0	114565	0	313782	1127433		
53437	4442	19128022	1995-06-12	1995-06-12 00:00:00	1996-06-06	1996-06-06 00:00:00	1996-06-06	38000177		0	0	360		0	0	0	295312	0	749785	19128022		
34252	2830	1154615	2006-08-11	2006-08-11 00:00:00	2006-08-11	2006-08-11 00:00:00	\N	38000177		0	0	0		0	0	0	187767	0	745679	1154615		
125092	2752	40213160	1955-02-20	1955-02-20 00:00:00	1955-02-20	1955-02-20 00:00:00	1955-02-20	581452		0	0	0		0	0	0	182041	0	10	40213160		
17989	1490	1115171	1998-11-10	1998-11-10 00:00:00	1998-11-24	1998-11-24 00:00:00	1998-11-24	38000177		0	0	14		0	0	0	99327	0	849574	1115171		
235329	5169	40213227	1995-06-12	1995-06-12 00:00:00	1995-06-12	1995-06-12 00:00:00	1995-06-12	581452		0	0	0		0	0	0	343703	0	113	40213227		
35653	2939	19128065	1983-10-20	1983-10-20 00:00:00	1984-10-14	1984-10-14 00:00:00	1984-10-14	38000177		0	0	360		0	0	0	195930	0	749882	19128065		
46155	3823	1127433	2013-08-07	2013-08-07 00:00:00	2013-08-21	2013-08-21 00:00:00	2013-08-21	38000177		0	0	14		0	0	0	253923	0	313782	1127433		
123007	2704	40213227	1993-08-14	1993-08-14 00:00:00	1993-08-14	1993-08-14 00:00:00	1993-08-14	581452		0	0	0		0	0	0	179164	0	113	40213227		
225145	4943	40213260	2012-08-22	2012-08-22 00:00:00	2012-08-22	2012-08-22 00:00:00	2012-08-22	581452		0	0	0		0	0	0	328552	0	121	40213260		
29578	2448	920300	1998-08-14	1998-08-14 00:00:00	1998-08-21	1998-08-21 00:00:00	1998-08-21	38000177		0	0	7		0	0	0	162392	0	311989	920300		
1521	120	19019979	1978-12-15	1978-12-15 00:00:00	1978-12-29	1978-12-29 00:00:00	1978-12-29	38000177		0	0	14		0	0	0	7976	0	198405	19019979		
33900	2804	19078461	2015-06-30	2015-06-30 00:00:00	2015-07-21	2015-07-21 00:00:00	2015-07-21	38000177		0	0	21		0	0	0	185856	0	310965	19078461		
4517	376	1713671	1966-09-07	1966-09-07 00:00:00	1966-09-14	1966-09-14 00:00:00	1966-09-14	38000177		0	0	7		0	0	0	24897	0	562251	1713671		
71099	1556	40213306	1996-02-22	1996-02-22 00:00:00	1996-02-22	1996-02-22 00:00:00	1996-02-22	581452		0	0	0		0	0	0	104165	0	43	40213306		
103314	2265	40213227	2004-08-01	2004-08-01 00:00:00	2004-08-01	2004-08-01 00:00:00	2004-08-01	581452		0	0	0		0	0	0	150492	0	113	40213227		
20777	452	40213296	2002-09-13	2002-09-13 00:00:00	2002-09-13	2002-09-13 00:00:00	2002-09-13	581452		0	0	0		0	0	0	30144	0	52	40213296		
18673	1542	19018935	2015-11-25	2015-11-25 00:00:00	2015-11-25	2015-11-25 00:00:00	\N	38000177		0	0	0		0	0	0	103319	0	197604	19018935		
60489	5031	1127433	1995-05-23	1995-05-23 00:00:00	1995-06-13	1995-06-13 00:00:00	1995-06-13	38000177		0	0	21		0	0	0	334282	0	313782	1127433		
6408	539	19133768	1999-07-25	1999-07-25 00:00:00	1999-07-25	1999-07-25 00:00:00	1999-07-25	38000177		0	0	0		0	0	0	35858	0	833036	19133768		
61435	5111	19133873	1949-04-09	1949-04-09 00:00:00	1949-04-17	1949-04-17 00:00:00	1949-04-17	38000177		0	0	8		0	0	0	339618	0	834061	19133873		
15814	1315	1127433	1962-02-24	1962-02-24 00:00:00	1962-03-10	1962-03-10 00:00:00	1962-03-10	38000177		0	0	14		0	0	0	87132	0	313782	1127433		
15865	1317	19059056	1963-03-16	1963-03-16 00:00:00	1963-04-06	1963-04-06 00:00:00	1963-04-06	38000177		0	0	21		0	0	0	87275	0	243670	19059056		
29871	651	40213227	2000-02-03	2000-02-03 00:00:00	2000-02-03	2000-02-03 00:00:00	2000-02-03	581452		0	0	0		0	0	0	43092	0	113	40213227		
39909	3301	19078461	1988-11-06	1988-11-06 00:00:00	1988-11-27	1988-11-27 00:00:00	1988-11-27	38000177		0	0	21		0	0	0	219286	0	310965	19078461		
58896	1289	40213306	1985-02-05	1985-02-05 00:00:00	1985-02-05	1985-02-05 00:00:00	1985-02-05	581452		0	0	0		0	0	0	85178	0	43	40213306		
2167	173	1127078	1971-01-08	1971-01-08 00:00:00	1971-01-22	1971-01-22 00:00:00	1971-01-22	38000177		0	0	14		0	0	0	11770	0	282464	1127078		
11395	949	1713671	2001-09-19	2001-09-19 00:00:00	2001-10-03	2001-10-03 00:00:00	2001-10-03	38000177		0	0	14		0	0	0	63059	0	562251	1713671		
93522	2052	40213227	2004-12-20	2004-12-20 00:00:00	2004-12-20	2004-12-20 00:00:00	2004-12-20	581452		0	0	0		0	0	0	136436	0	113	40213227		
25491	2094	1127078	1950-07-06	1950-07-06 00:00:00	1950-10-04	1950-10-04 00:00:00	1950-10-04	38000177		0	0	90		0	0	0	139572	0	282464	1127078		
25547	2100	1713671	1982-09-11	1982-09-11 00:00:00	1982-09-18	1982-09-18 00:00:00	1982-09-18	38000177		0	0	7		0	0	0	139940	0	562251	1713671		
12895	1084	1127433	2004-06-29	2004-06-29 00:00:00	2004-07-06	2004-07-06 00:00:00	2004-07-06	38000177		0	0	7		0	0	0	71189	0	313782	1127433		
57673	4792	19128065	1974-01-28	1974-01-28 00:00:00	1975-01-23	1975-01-23 00:00:00	1975-01-23	38000177		0	0	360		0	0	0	318868	0	749882	19128065		
48867	4052	19128022	1993-03-27	1993-03-27 00:00:00	1994-03-22	1994-03-22 00:00:00	1994-03-22	38000177		0	0	360		0	0	0	269349	0	749785	19128022		
13127	1101	1127433	2014-10-06	2014-10-06 00:00:00	2014-10-20	2014-10-20 00:00:00	2014-10-20	38000177		0	0	14		0	0	0	72330	0	313782	1127433		
135309	2970	40213296	2005-10-21	2005-10-21 00:00:00	2005-10-21	2005-10-21 00:00:00	2005-10-21	581452		0	0	0		0	0	0	198344	0	52	40213296		
116474	2559	40213296	1998-02-21	1998-02-21 00:00:00	1998-02-21	1998-02-21 00:00:00	1998-02-21	581452		0	0	0		0	0	0	169636	0	52	40213296		
58403	4852	1127433	2003-01-26	2003-01-26 00:00:00	2003-03-02	2003-03-02 00:00:00	2003-03-02	38000177		0	0	35		0	0	0	322783	0	313782	1127433		
60075	4992	1127433	2004-05-07	2004-05-07 00:00:00	2004-05-21	2004-05-21 00:00:00	2004-05-21	38000177		0	0	14		0	0	0	332090	0	313782	1127433		
46442	1015	40213227	2005-01-03	2005-01-03 00:00:00	2005-01-03	2005-01-03 00:00:00	2005-01-03	581452		0	0	0		0	0	0	66846	0	113	40213227		
6106	510	1127433	2012-07-27	2012-07-27 00:00:00	2012-08-03	2012-08-03 00:00:00	2012-08-03	38000177		0	0	7		0	0	0	34115	0	313782	1127433		
44697	3699	1713671	2007-11-01	2007-11-01 00:00:00	2007-11-15	2007-11-15 00:00:00	2007-11-15	38000177		0	0	14		0	0	0	245927	0	562251	1713671		
57839	1266	40213227	2018-12-24	2018-12-24 00:00:00	2018-12-24	2018-12-24 00:00:00	2018-12-24	581452		0	0	0		0	0	0	83501	0	113	40213227		
7085	596	19059056	1949-02-11	1949-02-11 00:00:00	1949-02-25	1949-02-25 00:00:00	1949-02-25	38000177		0	0	14		0	0	0	39310	0	243670	19059056		
144136	3168	40213251	1984-12-29	1984-12-29 00:00:00	1984-12-29	1984-12-29 00:00:00	1984-12-29	581452		0	0	0		0	0	0	210627	0	21	40213251		
7279	610	1127433	2010-08-22	2010-08-22 00:00:00	2010-09-05	2010-09-05 00:00:00	2010-09-05	38000177		0	0	14		0	0	0	40614	0	313782	1127433		
27328	2260	19078461	1994-09-02	1994-09-02 00:00:00	1994-12-01	1994-12-01 00:00:00	1994-12-01	38000177		0	0	90		0	0	0	150220	0	310965	19078461		
27340	2261	1127433	1974-01-13	1974-01-13 00:00:00	1974-01-20	1974-01-20 00:00:00	1974-01-20	38000177		0	0	7		0	0	0	150300	0	313782	1127433		
3042	246	1127433	1970-03-05	1970-03-05 00:00:00	1970-03-12	1970-03-12 00:00:00	1970-03-12	38000177		0	0	7		0	0	0	16577	0	313782	1127433		
7769	649	19019979	1978-04-26	1978-04-26 00:00:00	1978-06-25	1978-06-25 00:00:00	1978-06-25	38000177		0	0	60		0	0	0	42979	0	198405	19019979		
43356	3595	1127433	1999-11-02	1999-11-02 00:00:00	1999-11-16	1999-11-16 00:00:00	1999-11-16	38000177		0	0	14		0	0	0	238790	0	313782	1127433		
13677	1145	40229134	1968-11-28	1968-11-28 00:00:00	1968-12-05	1968-12-05 00:00:00	1968-12-05	38000177		0	0	7		0	0	0	75630	0	1043400	40229134		
13707	1146	19133905	1990-12-26	1990-12-26 00:00:00	1991-01-03	1991-01-03 00:00:00	1991-01-03	38000177		0	0	8		0	0	0	75670	0	834102	19133905		
9151	195	40213227	2009-03-23	2009-03-23 00:00:00	2009-03-23	2009-03-23 00:00:00	2009-03-23	581452		0	0	0		0	0	0	13433	0	113	40213227		
19986	1640	40229134	2003-06-18	2003-06-18 00:00:00	2003-07-02	2003-07-02 00:00:00	2003-07-02	38000177		0	0	14		0	0	0	110024	0	1043400	40229134		
41717	3455	19115351	1991-05-21	1991-05-21 00:00:00	1994-08-15	1994-08-15 00:00:00	1994-08-15	38000177		0	0	1182		0	0	0	229257	0	563026	19115351		
27128	2237	1127433	1991-03-17	1991-03-17 00:00:00	1991-05-16	1991-05-16 00:00:00	1991-05-16	38000177		0	0	60		0	0	0	148808	0	313782	1127433		
28224	614	40213306	1984-06-03	1984-06-03 00:00:00	1984-06-03	1984-06-03 00:00:00	1984-06-03	581452		0	0	0		0	0	0	40812	0	43	40213306		
39555	3270	1127433	2019-05-09	2019-05-09 00:00:00	2019-05-16	2019-05-16 00:00:00	2019-05-16	38000177		0	0	7		0	0	0	217356	0	313782	1127433		
215352	4722	40213227	1992-07-05	1992-07-05 00:00:00	1992-07-05	1992-07-05 00:00:00	1992-07-05	581452		0	0	0		0	0	0	314598	0	113	40213227		
42523	3527	19075601	2013-11-28	2013-11-28 00:00:00	2013-11-28	2013-11-28 00:00:00	2013-11-28	38000177		0	0	0		0	0	0	234074	0	309362	19075601		
40896	3391	1713671	1982-08-27	1982-08-27 00:00:00	1982-09-10	1982-09-10 00:00:00	1982-09-10	38000177		0	0	14		0	0	0	224922	0	562251	1713671		
63111	5242	19133905	2017-05-12	2017-05-12 00:00:00	2017-05-21	2017-05-21 00:00:00	2017-05-21	38000177		0	0	9		0	0	0	348845	0	834102	19133905		
43046	3568	19078461	1984-03-16	1984-03-16 00:00:00	1984-04-06	1984-04-06 00:00:00	1984-04-06	38000177		0	0	21		0	0	0	237102	0	310965	19078461		
20795	1715	46233710	1972-09-20	1972-09-20 00:00:00	1972-10-04	1972-10-04 00:00:00	1972-10-04	38000177		0	0	14		0	0	0	114570	0	1650142	46233710		
53438	4442	19019979	1987-02-14	1987-02-14 00:00:00	1987-03-07	1987-03-07 00:00:00	1987-03-07	38000177		0	0	21		0	0	0	295332	0	198405	19019979		
34253	2830	40169216	2006-08-11	2006-08-11 00:00:00	2006-08-11	2006-08-11 00:00:00	\N	38000177		0	0	0		0	0	0	187767	0	895994	40169216		
125100	2752	40213198	2016-06-05	2016-06-05 00:00:00	2016-06-05	2016-06-05 00:00:00	2016-06-05	581452		0	0	0		0	0	0	182057	0	133	40213198		
17990	1490	19059056	1942-09-07	1942-09-07 00:00:00	1942-09-21	1942-09-21 00:00:00	1942-09-21	38000177		0	0	14		0	0	0	99353	0	243670	19059056		
235331	5169	40213227	2014-09-15	2014-09-15 00:00:00	2014-09-15	2014-09-15 00:00:00	2014-09-15	581452		0	0	0		0	0	0	343674	0	113	40213227		
35655	2939	19128065	1981-10-30	1981-10-30 00:00:00	1982-10-25	1982-10-25 00:00:00	1982-10-25	38000177		0	0	360		0	0	0	195929	0	749882	19128065		
46156	3823	1127433	1997-07-09	1997-07-09 00:00:00	1997-07-23	1997-07-23 00:00:00	1997-07-23	38000177		0	0	14		0	0	0	253921	0	313782	1127433		
123008	2704	40213306	1993-08-14	1993-08-14 00:00:00	1993-08-14	1993-08-14 00:00:00	1993-08-14	581452		0	0	0		0	0	0	179164	0	43	40213306		
225147	4943	40213227	1993-01-13	1993-01-13 00:00:00	1993-01-13	1993-01-13 00:00:00	1993-01-13	581452		0	0	0		0	0	0	328606	0	113	40213227		
29579	2448	40236824	1998-08-14	1998-08-14 00:00:00	1998-08-21	1998-08-21 00:00:00	1998-08-21	38000177		0	0	7		0	0	0	162392	0	1094107	40236824		
1522	120	46233988	1978-12-15	1978-12-15 00:00:00	1978-12-29	1978-12-29 00:00:00	1978-12-29	38000177		0	0	14		0	0	0	7976	0	1652673	46233988		
33901	2804	19078461	1988-03-20	1988-03-20 00:00:00	1988-04-10	1988-04-10 00:00:00	1988-04-10	38000177		0	0	21		0	0	0	185852	0	310965	19078461		
4518	376	1127433	1986-12-31	1986-12-31 00:00:00	1987-01-14	1987-01-14 00:00:00	1987-01-14	38000177		0	0	14		0	0	0	24922	0	313782	1127433		
71101	1556	40213227	1996-02-22	1996-02-22 00:00:00	1996-02-22	1996-02-22 00:00:00	1996-02-22	581452		0	0	0		0	0	0	104165	0	113	40213227		
103327	2266	40213306	1991-05-04	1991-05-04 00:00:00	1991-05-04	1991-05-04 00:00:00	1991-05-04	581452		0	0	0		0	0	0	\N	0	43	40213306		
47350	3926	40229134	2005-01-23	2005-01-23 00:00:00	2005-02-06	2005-02-06 00:00:00	2005-02-06	38000177		0	0	14		0	0	0	260927	0	1043400	40229134		
18674	1542	40171902	2015-11-25	2015-11-25 00:00:00	2015-11-25	2015-11-25 00:00:00	\N	38000177		0	0	0		0	0	0	103319	0	897718	40171902		
60490	5031	19059056	1922-01-08	1922-01-08 00:00:00	1922-01-22	1922-01-22 00:00:00	1922-01-22	38000177		0	0	14		0	0	0	334356	0	243670	19059056		
6409	539	1545959	1999-07-25	1999-07-25 00:00:00	1999-07-25	1999-07-25 00:00:00	1999-07-25	38000177		0	0	0		0	0	0	35858	0	259255	1545959		
4169	347	1127433	1975-08-21	1975-08-21 00:00:00	1975-09-04	1975-09-04 00:00:00	1975-09-04	38000177		0	0	14		0	0	0	23064	0	313782	1127433		
15815	1315	1118084	1996-03-21	1996-03-21 00:00:00	1996-03-21	1996-03-21 00:00:00	\N	38000177		0	0	0		0	0	0	87124	0	00025152531	44923712		
15866	1317	1127433	1957-10-09	1957-10-09 00:00:00	1957-10-16	1957-10-16 00:00:00	1957-10-16	38000177		0	0	7		0	0	0	87241	0	313782	1127433		
29872	651	40213306	2000-02-03	2000-02-03 00:00:00	2000-02-03	2000-02-03 00:00:00	2000-02-03	581452		0	0	0		0	0	0	43092	0	43	40213306		
15961	1323	1127433	1987-05-11	1987-05-11 00:00:00	1987-07-10	1987-07-10 00:00:00	1987-07-10	38000177		0	0	60		0	0	0	87846	0	313782	1127433		
58902	1289	40213227	1994-02-15	1994-02-15 00:00:00	1994-02-15	1994-02-15 00:00:00	1994-02-15	581452		0	0	0		0	0	0	85226	0	113	40213227		
2168	173	1713671	2005-08-02	2005-08-02 00:00:00	2005-08-16	2005-08-16 00:00:00	2005-08-16	38000177		0	0	14		0	0	0	11743	0	562251	1713671		
11396	949	40169281	1983-08-29	1983-08-29 00:00:00	1983-08-29	1983-08-29 00:00:00	\N	38000177		0	0	0		0	0	0	62997	0	896209	40169281		
93523	2052	40213296	2004-12-20	2004-12-20 00:00:00	2004-12-20	2004-12-20 00:00:00	2004-12-20	581452		0	0	0		0	0	0	136436	0	52	40213296		
25492	2094	19078461	2002-07-17	2002-07-17 00:00:00	2002-08-07	2002-08-07 00:00:00	2002-08-07	38000177		0	0	21		0	0	0	139574	0	310965	19078461		
25548	2100	19059056	1947-07-02	1947-07-02 00:00:00	1947-07-16	1947-07-16 00:00:00	1947-07-16	38000177		0	0	14		0	0	0	140015	0	243670	19059056		
12896	1084	1115171	2016-10-13	2016-10-13 00:00:00	2016-11-10	2016-11-10 00:00:00	2016-11-10	38000177		0	0	28		0	0	0	71209	0	849574	1115171		
57674	4792	19059056	1969-03-11	1969-03-11 00:00:00	1969-04-10	1969-04-10 00:00:00	1969-04-10	38000177		0	0	30		0	0	0	318826	0	243670	19059056		
48868	4052	1124300	2015-09-18	2015-09-18 00:00:00	2015-09-18	2015-09-18 00:00:00	\N	38000177		0	0	0		0	0	0	269405	0	00781178901	45011828		
13128	1102	1118084	2012-05-02	2012-05-02 00:00:00	2012-05-02	2012-05-02 00:00:00	\N	38000177		0	0	0		0	0	0	72402	0	00025152531	44923712		
135321	2970	40213227	2007-10-26	2007-10-26 00:00:00	2007-10-26	2007-10-26 00:00:00	2007-10-26	581452		0	0	0		0	0	0	198376	0	113	40213227		
116479	2559	40213260	2008-05-24	2008-05-24 00:00:00	2008-05-24	2008-05-24 00:00:00	2008-05-24	581452		0	0	0		0	0	0	169617	0	121	40213260		
58405	4852	920334	1994-02-13	1994-02-13 00:00:00	1994-02-20	1994-02-20 00:00:00	1994-02-20	38000177		0	0	7		0	0	0	322787	0	311995	920334		
60076	4992	19133905	2014-03-01	2014-03-01 00:00:00	2014-03-14	2014-03-14 00:00:00	2014-03-14	38000177		0	0	13		0	0	0	332097	0	834102	19133905		
46445	1015	40213260	2006-01-09	2006-01-09 00:00:00	2006-01-09	2006-01-09 00:00:00	2006-01-09	581452		0	0	0		0	0	0	66804	0	121	40213260		
6109	512	40229134	1963-10-02	1963-10-02 00:00:00	1963-10-16	1963-10-16 00:00:00	1963-10-16	38000177		0	0	14		0	0	0	34200	0	1043400	40229134		
44698	3699	1118084	2014-01-15	2014-01-15 00:00:00	2014-01-15	2014-01-15 00:00:00	\N	38000177		0	0	0		0	0	0	245925	0	00025152531	44923712		
57843	1266	40213160	1967-08-14	1967-08-14 00:00:00	1967-08-14	1967-08-14 00:00:00	1967-08-14	581452		0	0	0		0	0	0	83464	0	10	40213160		
7086	596	19133873	1952-07-09	1952-07-09 00:00:00	1952-07-20	1952-07-20 00:00:00	1952-07-20	38000177		0	0	11		0	0	0	39374	0	834061	19133873		
144138	3168	40213160	1984-12-29	1984-12-29 00:00:00	1984-12-29	1984-12-29 00:00:00	1984-12-29	581452		0	0	0		0	0	0	210627	0	10	40213160		
7281	610	1118084	2004-12-07	2004-12-07 00:00:00	2004-12-07	2004-12-07 00:00:00	\N	38000177		0	0	0		0	0	0	40622	0	00025152531	44923712		
27329	2260	40162522	1994-09-02	1994-09-02 00:00:00	1994-09-02	1994-09-02 00:00:00	\N	38000177		0	0	0		0	0	0	150220	0	857005	40162522		
27341	2261	19059056	1969-07-19	1969-07-19 00:00:00	1969-08-02	1969-08-02 00:00:00	1969-08-02	38000177		0	0	14		0	0	0	150288	0	243670	19059056		
3043	246	1713671	2001-03-31	2001-03-31 00:00:00	2001-04-07	2001-04-07 00:00:00	2001-04-07	38000177		0	0	7		0	0	0	16606	0	562251	1713671		
7770	649	1127433	2010-03-23	2010-03-23 00:00:00	2010-04-06	2010-04-06 00:00:00	2010-04-06	38000177		0	0	14		0	0	0	42993	0	313782	1127433		
43357	3595	1127433	1957-07-03	1957-07-03 00:00:00	1957-07-10	1957-07-10 00:00:00	1957-07-10	38000177		0	0	7		0	0	0	238774	0	313782	1127433		
13678	1145	19078461	2006-08-02	2006-08-02 00:00:00	2006-08-16	2006-08-16 00:00:00	2006-08-16	38000177		0	0	14		0	0	0	75557	0	310965	19078461		
13708	1146	1713671	2015-09-20	2015-09-20 00:00:00	2015-10-04	2015-10-04 00:00:00	2015-10-04	38000177		0	0	14		0	0	0	75722	0	562251	1713671		
9152	195	40213260	2009-03-23	2009-03-23 00:00:00	2009-03-23	2009-03-23 00:00:00	2009-03-23	581452		0	0	0		0	0	0	13433	0	121	40213260		
19987	1640	1118084	1976-04-20	1976-04-20 00:00:00	1976-04-20	1976-04-20 00:00:00	\N	38000177		0	0	0		0	0	0	110039	0	00025152531	44923712		
41718	3455	1127433	2000-05-15	2000-05-15 00:00:00	2000-05-29	2000-05-29 00:00:00	2000-05-29	38000177		0	0	14		0	0	0	229250	0	313782	1127433		
27129	2237	19059056	1943-10-29	1943-10-29 00:00:00	1943-11-19	1943-11-19 00:00:00	1943-11-19	38000177		0	0	21		0	0	0	148805	0	243670	19059056		
28227	614	40213306	1984-10-14	1984-10-14 00:00:00	1984-10-14	1984-10-14 00:00:00	1984-10-14	581452		0	0	0		0	0	0	40837	0	43	40213306		
39556	3270	19133905	2006-12-20	2006-12-20 00:00:00	2007-01-02	2007-01-02 00:00:00	2007-01-02	38000177		0	0	13		0	0	0	217331	0	834102	19133905		
225532	4952	40213296	2012-03-31	2012-03-31 00:00:00	2012-03-31	2012-03-31 00:00:00	2012-03-31	581452		0	0	0		0	0	0	329182	0	52	40213296		
42524	3527	1118084	2002-03-25	2002-03-25 00:00:00	2002-03-25	2002-03-25 00:00:00	\N	38000177		0	0	0		0	0	0	234042	0	00025152531	44923712		
40897	3391	1127433	2005-12-25	2005-12-25 00:00:00	2006-01-24	2006-01-24 00:00:00	2006-01-24	38000177		0	0	30		0	0	0	224901	0	313782	1127433		
63112	5242	1124300	2000-02-03	2000-02-03 00:00:00	2000-02-03	2000-02-03 00:00:00	\N	38000177		0	0	0		0	0	0	348817	0	00781178901	45011828		
43047	3568	1118084	2012-12-04	2012-12-04 00:00:00	2012-12-04	2012-12-04 00:00:00	\N	38000177		0	0	0		0	0	0	237086	0	00025152531	44923712		
20796	1715	1127433	1972-09-20	1972-09-20 00:00:00	1972-10-04	1972-10-04 00:00:00	1972-10-04	38000177		0	0	14		0	0	0	114570	0	313782	1127433		
53439	4442	1118084	2015-04-28	2015-04-28 00:00:00	2015-04-28	2015-04-28 00:00:00	\N	38000177		0	0	0		0	0	0	295308	0	00025152531	44923712		
34254	2830	40232448	1975-06-22	1975-06-22 00:00:00	1975-06-22	1975-06-22 00:00:00	\N	38000177		0	0	0		0	0	0	187706	0	1049630	40232448		
125102	2752	40213227	1992-05-03	1992-05-03 00:00:00	1992-05-03	1992-05-03 00:00:00	1992-05-03	581452		0	0	0		0	0	0	182084	0	113	40213227		
17991	1490	40162522	1982-05-08	1982-05-08 00:00:00	1982-05-08	1982-05-08 00:00:00	\N	38000177		0	0	0		0	0	0	99305	0	857005	40162522		
235334	5169	40213296	1997-01-27	1997-01-27 00:00:00	1997-01-27	1997-01-27 00:00:00	1997-01-27	581452		0	0	0		0	0	0	\N	0	52	40213296		
35656	2939	920300	1994-02-23	1994-02-23 00:00:00	1994-03-02	1994-03-02 00:00:00	1994-03-02	38000177		0	0	7		0	0	0	195976	0	311989	920300		
46164	3825	19133905	1988-11-25	1988-11-25 00:00:00	1988-12-04	1988-12-04 00:00:00	1988-12-04	38000177		0	0	9		0	0	0	254081	0	834102	19133905		
123009	2704	40213296	2011-08-20	2011-08-20 00:00:00	2011-08-20	2011-08-20 00:00:00	2011-08-20	581452		0	0	0		0	0	0	179144	0	52	40213296		
123061	2705	40213227	2003-11-01	2003-11-01 00:00:00	2003-11-01	2003-11-01 00:00:00	2003-11-01	581452		0	0	0		0	0	0	179247	0	113	40213227		
29591	2450	19059056	1970-08-22	1970-08-22 00:00:00	1970-09-26	1970-09-26 00:00:00	1970-09-26	38000177		0	0	35		0	0	0	162559	0	243670	19059056		
1523	120	19059056	1992-11-10	1992-11-10 00:00:00	1993-02-08	1993-02-08 00:00:00	1993-02-08	38000177		0	0	90		0	0	0	7970	0	243670	19059056		
33902	2804	19059056	1965-02-28	1965-02-28 00:00:00	1965-03-14	1965-03-14 00:00:00	1965-03-14	38000177		0	0	14		0	0	0	185848	0	243670	19059056		
4519	376	1713671	1969-04-29	1969-04-29 00:00:00	1969-05-20	1969-05-20 00:00:00	1969-05-20	38000177		0	0	21		0	0	0	24920	0	562251	1713671		
71102	1556	40213306	1996-10-31	1996-10-31 00:00:00	1996-10-31	1996-10-31 00:00:00	1996-10-31	581452		0	0	0		0	0	0	104238	0	43	40213306		
45443	3759	920300	1987-09-10	1987-09-10 00:00:00	1987-09-17	1987-09-17 00:00:00	1987-09-17	38000177		0	0	7		0	0	0	249883	0	311989	920300		
47351	3926	1127433	1992-12-07	1992-12-07 00:00:00	1992-12-14	1992-12-14 00:00:00	1992-12-14	38000177		0	0	7		0	0	0	260973	0	313782	1127433		
18675	1542	40163554	2015-11-25	2015-11-25 00:00:00	2015-11-25	2015-11-25 00:00:00	\N	38000177		0	0	0		0	0	0	103319	0	855332	40163554		
60491	5031	19059056	1946-02-20	1946-02-20 00:00:00	1946-03-20	1946-03-20 00:00:00	1946-03-20	38000177		0	0	28		0	0	0	334345	0	243670	19059056		
6410	539	1310034	1972-01-02	1972-01-02 00:00:00	1972-01-02	1972-01-02 00:00:00	1972-01-02	38000177		0	0	0		0	0	0	35857	0	834357	1310034		
4170	347	1713671	1992-12-24	1992-12-24 00:00:00	1993-01-07	1993-01-07 00:00:00	1993-01-07	38000177		0	0	14		0	0	0	23067	0	562251	1713671		
15816	1315	1127078	1962-05-29	1962-05-29 00:00:00	1962-08-04	1962-08-04 00:00:00	1962-08-04	38000177		0	0	67		0	0	0	87105	0	282464	1127078		
15867	1317	1124300	1989-11-19	1989-11-19 00:00:00	1989-11-19	1989-11-19 00:00:00	\N	38000177		0	0	0		0	0	0	87326	0	00781178901	45011828		
59783	4971	1127433	1991-08-06	1991-08-06 00:00:00	1991-08-20	1991-08-20 00:00:00	1991-08-20	38000177		0	0	14		0	0	0	330656	0	313782	1127433		
15962	1323	40231925	1987-05-11	1987-05-11 00:00:00	1987-05-11	1987-05-11 00:00:00	\N	38000177		0	0	0		0	0	0	87846	0	1049221	40231925		
58904	1289	40213160	1967-02-21	1967-02-21 00:00:00	1967-02-21	1967-02-21 00:00:00	1967-02-21	581452		0	0	0		0	0	0	85217	0	10	40213160		
2169	173	40229134	2001-02-02	2001-02-02 00:00:00	2001-02-09	2001-02-09 00:00:00	2001-02-09	38000177		0	0	7		0	0	0	11741	0	1043400	40229134		
11397	949	1127433	2018-05-06	2018-05-06 00:00:00	2018-05-20	2018-05-20 00:00:00	2018-05-20	38000177		0	0	14		0	0	0	63045	0	313782	1127433		
93538	2053	40213160	1955-06-09	1955-06-09 00:00:00	1955-06-09	1955-06-09 00:00:00	1955-06-09	581452		0	0	0		0	0	0	136523	0	10	40213160		
25493	2094	19059056	1948-09-14	1948-09-14 00:00:00	1948-10-14	1948-10-14 00:00:00	1948-10-14	38000177		0	0	30		0	0	0	139571	0	243670	19059056		
25549	2100	19006318	1947-07-02	1947-07-02 00:00:00	1947-07-16	1947-07-16 00:00:00	1947-07-16	38000177		0	0	14		0	0	0	140015	0	105078	19006318		
12897	1084	1127433	2019-02-20	2019-02-20 00:00:00	2019-03-06	2019-03-06 00:00:00	2019-03-06	38000177		0	0	14		0	0	0	71239	0	313782	1127433		
57675	4792	40162522	1969-03-11	1969-03-11 00:00:00	1969-03-11	1969-03-11 00:00:00	\N	38000177		0	0	0		0	0	0	318826	0	857005	40162522		
48869	4052	1115171	2007-01-01	2007-01-01 00:00:00	2007-01-22	2007-01-22 00:00:00	2007-01-22	38000177		0	0	21		0	0	0	269417	0	849574	1115171		
13129	1102	1115171	2003-02-14	2003-02-14 00:00:00	2003-03-23	2003-03-23 00:00:00	2003-03-23	38000177		0	0	37		0	0	0	72428	0	849574	1115171		
135322	2970	40213296	2007-10-26	2007-10-26 00:00:00	2007-10-26	2007-10-26 00:00:00	2007-10-26	581452		0	0	0		0	0	0	198376	0	52	40213296		
116482	2559	40213296	2000-02-26	2000-02-26 00:00:00	2000-02-26	2000-02-26 00:00:00	2000-02-26	581452		0	0	0		0	0	0	169566	0	52	40213296		
58406	4852	19133873	1960-11-30	1960-11-30 00:00:00	1960-12-08	1960-12-08 00:00:00	1960-12-08	38000177		0	0	8		0	0	0	322784	0	834061	19133873		
60077	4992	1118084	2019-03-24	2019-03-24 00:00:00	2019-03-24	2019-03-24 00:00:00	\N	38000177		0	0	0		0	0	0	332098	0	00025152531	44923712		
57321	4757	1127433	2018-10-17	2018-10-17 00:00:00	2018-10-24	2018-10-24 00:00:00	2018-10-24	38000177		0	0	7		0	0	0	316926	0	313782	1127433		
6110	512	1713671	1999-02-11	1999-02-11 00:00:00	1999-02-25	1999-02-25 00:00:00	1999-02-25	38000177		0	0	14		0	0	0	34176	0	562251	1713671		
44699	3699	1713671	1988-03-26	1988-03-26 00:00:00	1988-04-16	1988-04-16 00:00:00	1988-04-16	38000177		0	0	21		0	0	0	245946	0	562251	1713671		
57846	1266	40213227	2009-01-19	2009-01-19 00:00:00	2009-01-19	2009-01-19 00:00:00	2009-01-19	581452		0	0	0		0	0	0	83462	0	113	40213227		
7087	596	1115171	2000-05-03	2000-05-03 00:00:00	2000-05-17	2000-05-17 00:00:00	2000-05-17	38000177		0	0	14		0	0	0	39327	0	849574	1115171		
144142	3168	40213306	2003-10-25	2003-10-25 00:00:00	2003-10-25	2003-10-25 00:00:00	2003-10-25	581452		0	0	0		0	0	0	210609	0	43	40213306		
7282	610	1127433	2008-12-04	2008-12-04 00:00:00	2009-02-02	2009-02-02 00:00:00	2009-02-02	38000177		0	0	60		0	0	0	40482	0	313782	1127433		
27330	2260	1127433	1997-05-29	1997-05-29 00:00:00	1997-06-12	1997-06-12 00:00:00	1997-06-12	38000177		0	0	14		0	0	0	150181	0	313782	1127433		
27342	2261	19078461	1994-04-15	1994-04-15 00:00:00	1994-04-29	1994-04-29 00:00:00	1994-04-29	38000177		0	0	14		0	0	0	150335	0	310965	19078461		
3054	248	1127433	2009-05-19	2009-05-19 00:00:00	2009-06-18	2009-06-18 00:00:00	2009-06-18	38000177		0	0	30		0	0	0	16667	0	313782	1127433		
7771	649	19059056	1972-11-18	1972-11-18 00:00:00	1973-02-16	1973-02-16 00:00:00	1973-02-16	38000177		0	0	90		0	0	0	42974	0	243670	19059056		
43358	3595	19078461	1987-07-29	1987-07-29 00:00:00	1987-08-19	1987-08-19 00:00:00	1987-08-19	38000177		0	0	21		0	0	0	238832	0	310965	19078461		
13679	1145	40229134	2002-06-08	2002-06-08 00:00:00	2002-06-15	2002-06-15 00:00:00	2002-06-15	38000177		0	0	7		0	0	0	75639	0	1043400	40229134		
13709	1146	40236824	1986-02-08	1986-02-08 00:00:00	1986-02-15	1986-02-15 00:00:00	1986-02-15	38000177		0	0	7		0	0	0	75743	0	1094107	40236824		
9154	195	40213160	1958-08-25	1958-08-25 00:00:00	1958-08-25	1958-08-25 00:00:00	1958-08-25	581452		0	0	0		0	0	0	13367	0	10	40213160		
19989	1641	1127433	1967-04-20	1967-04-20 00:00:00	1967-05-11	1967-05-11 00:00:00	1967-05-11	38000177		0	0	21		0	0	0	110175	0	313782	1127433		
41720	3455	19128065	1983-05-23	1983-05-23 00:00:00	1984-05-17	1984-05-17 00:00:00	1984-05-17	38000177		0	0	360		0	0	0	229207	0	749882	19128065		
27130	2237	1127433	1990-02-15	1990-02-15 00:00:00	1990-03-22	1990-03-22 00:00:00	1990-03-22	38000177		0	0	35		0	0	0	148807	0	313782	1127433		
28230	614	40213160	1968-08-11	1968-08-11 00:00:00	1968-08-11	1968-08-11 00:00:00	1968-08-11	581452		0	0	0		0	0	0	40805	0	10	40213160		
39557	3270	19133873	1985-01-02	1985-01-02 00:00:00	1985-01-10	1985-01-10 00:00:00	1985-01-10	38000177		0	0	8		0	0	0	217255	0	834061	19133873		
225534	4952	40213227	2012-03-31	2012-03-31 00:00:00	2012-03-31	2012-03-31 00:00:00	2012-03-31	581452		0	0	0		0	0	0	329182	0	113	40213227		
42525	3527	19059056	1963-04-04	1963-04-04 00:00:00	1963-07-03	1963-07-03 00:00:00	1963-07-03	38000177		0	0	90		0	0	0	234046	0	243670	19059056		
40898	3391	19078461	1997-06-10	1997-06-10 00:00:00	1997-08-09	1997-08-09 00:00:00	1997-08-09	38000177		0	0	60		0	0	0	224903	0	310965	19078461		
63113	5242	1127433	1993-10-30	1993-10-30 00:00:00	1993-11-13	1993-11-13 00:00:00	1993-11-13	38000177		0	0	14		0	0	0	348804	0	313782	1127433		
43048	3568	1127433	1977-07-15	1977-07-15 00:00:00	1977-07-22	1977-07-22 00:00:00	1977-07-22	38000177		0	0	7		0	0	0	237094	0	313782	1127433		
20797	1715	40229134	2019-06-27	2019-06-27 00:00:00	2019-06-27	2019-06-27 00:00:00	\N	38000177		0	0	0		0	0	0	114547	0	1043400	40229134		
53440	4442	19019979	1991-09-12	1991-09-12 00:00:00	1991-12-11	1991-12-11 00:00:00	1991-12-11	38000177		0	0	90		0	0	0	295333	0	198405	19019979		
34255	2830	40229134	1992-06-18	1992-06-18 00:00:00	1992-07-02	1992-07-02 00:00:00	1992-07-02	38000177		0	0	14		0	0	0	187704	0	1043400	40229134		
125104	2752	40213201	2017-06-11	2017-06-11 00:00:00	2017-06-11	2017-06-11 00:00:00	2017-06-11	581452		0	0	0		0	0	0	182108	0	33	40213201		
17992	1490	1127433	1982-05-08	1982-05-08 00:00:00	1982-08-06	1982-08-06 00:00:00	1982-08-06	38000177		0	0	90		0	0	0	99305	0	313782	1127433		
235337	5169	40213296	1997-02-03	1997-02-03 00:00:00	1997-02-03	1997-02-03 00:00:00	1997-02-03	581452		0	0	0		0	0	0	\N	0	52	40213296		
35657	2939	40236824	1994-02-23	1994-02-23 00:00:00	1994-03-02	1994-03-02 00:00:00	1994-03-02	38000177		0	0	7		0	0	0	195976	0	1094107	40236824		
46165	3825	1127433	1958-08-15	1958-08-15 00:00:00	1958-08-29	1958-08-29 00:00:00	1958-08-29	38000177		0	0	14		0	0	0	254080	0	313782	1127433		
123017	2704	40213227	2013-08-24	2013-08-24 00:00:00	2013-08-24	2013-08-24 00:00:00	2013-08-24	581452		0	0	0		0	0	0	179138	0	113	40213227		
123075	2705	40213227	1993-09-04	1993-09-04 00:00:00	1993-09-04	1993-09-04 00:00:00	1993-09-04	581452		0	0	0		0	0	0	179192	0	113	40213227		
29592	2450	1118084	1986-05-15	1986-05-15 00:00:00	1986-05-15	1986-05-15 00:00:00	\N	38000177		0	0	0		0	0	0	162501	0	00025152531	44923712		
1524	120	40162522	1992-11-10	1992-11-10 00:00:00	1992-11-10	1992-11-10 00:00:00	\N	38000177		0	0	0		0	0	0	7970	0	857005	40162522		
33903	2804	1713671	1964-01-10	1964-01-10 00:00:00	1964-01-17	1964-01-17 00:00:00	1964-01-17	38000177		0	0	7		0	0	0	185890	0	562251	1713671		
4521	376	1127433	2012-02-13	2012-02-13 00:00:00	2012-03-12	2012-03-12 00:00:00	2012-03-12	38000177		0	0	28		0	0	0	24941	0	313782	1127433		
71110	1556	40213160	1973-09-06	1973-09-06 00:00:00	1973-09-06	1973-09-06 00:00:00	1973-09-06	581452		0	0	0		0	0	0	104219	0	10	40213160		
45444	3759	40236824	1987-09-10	1987-09-10 00:00:00	1987-09-17	1987-09-17 00:00:00	1987-09-17	38000177		0	0	7		0	0	0	249883	0	1094107	40236824		
47352	3926	19059056	1957-05-09	1957-05-09 00:00:00	1957-07-15	1957-07-15 00:00:00	1957-07-15	38000177		0	0	67		0	0	0	261006	0	243670	19059056		
18676	1542	1127433	2016-10-19	2016-10-19 00:00:00	2016-11-02	2016-11-02 00:00:00	2016-11-02	38000177		0	0	14		0	0	0	103331	0	313782	1127433		
56537	4690	40236824	2010-07-10	2010-07-10 00:00:00	2010-07-17	2010-07-17 00:00:00	2010-07-17	38000177		0	0	7		0	0	0	312518	0	1094107	40236824		
6411	539	40243436	1972-01-02	1972-01-02 00:00:00	1972-01-02	1972-01-02 00:00:00	1972-01-02	38000177		0	0	0		0	0	0	35857	0	1190795	40243436		
4171	347	40169281	1999-11-07	1999-11-07 00:00:00	1999-11-07	1999-11-07 00:00:00	\N	38000177		0	0	0		0	0	0	23108	0	896209	40169281		
15817	1315	1127433	1973-02-09	1973-02-09 00:00:00	1973-02-23	1973-02-23 00:00:00	1973-02-23	38000177		0	0	14		0	0	0	87115	0	313782	1127433		
15868	1318	40229134	1942-06-16	1942-06-16 00:00:00	1942-06-23	1942-06-23 00:00:00	1942-06-23	38000177		0	0	7		0	0	0	87337	0	1043400	40229134		
59784	4971	40169281	2000-12-05	2000-12-05 00:00:00	2000-12-05	2000-12-05 00:00:00	\N	38000177		0	0	0		0	0	0	330636	0	896209	40169281		
15963	1323	19133873	1971-05-18	1971-05-18 00:00:00	1971-05-28	1971-05-28 00:00:00	1971-05-28	38000177		0	0	10		0	0	0	87872	0	834061	19133873		
58909	1289	40213160	1962-08-21	1962-08-21 00:00:00	1962-08-21	1962-08-21 00:00:00	1962-08-21	581452		0	0	0		0	0	0	85214	0	10	40213160		
2170	173	1127433	2011-07-10	2011-07-10 00:00:00	2011-07-24	2011-07-24 00:00:00	2011-07-24	38000177		0	0	14		0	0	0	11766	0	313782	1127433		
11398	949	1127433	1959-11-09	1959-11-09 00:00:00	1959-11-16	1959-11-16 00:00:00	1959-11-16	38000177		0	0	7		0	0	0	62985	0	313782	1127433		
93549	2053	40213227	2014-09-04	2014-09-04 00:00:00	2014-09-04	2014-09-04 00:00:00	2014-09-04	581452		0	0	0		0	0	0	136497	0	113	40213227		
25494	2094	1127433	1966-08-11	1966-08-11 00:00:00	1966-08-25	1966-08-25 00:00:00	1966-08-25	38000177		0	0	14		0	0	0	139573	0	313782	1127433		
25550	2100	1124300	1976-01-16	1976-01-16 00:00:00	1976-01-16	1976-01-16 00:00:00	\N	38000177		0	0	0		0	0	0	139976	0	00781178901	45011828		
12898	1084	1127433	1987-10-18	1987-10-18 00:00:00	1987-10-25	1987-10-25 00:00:00	1987-10-25	38000177		0	0	7		0	0	0	71204	0	313782	1127433		
57677	4792	40236824	1981-05-22	1981-05-22 00:00:00	1981-05-29	1981-05-29 00:00:00	1981-05-29	38000177		0	0	7		0	0	0	318878	0	1094107	40236824		
48870	4052	19059056	1978-06-04	1978-06-04 00:00:00	1978-06-18	1978-06-18 00:00:00	1978-06-18	38000177		0	0	14		0	0	0	269302	0	243670	19059056		
13130	1102	1127433	1983-11-26	1983-11-26 00:00:00	1983-12-10	1983-12-10 00:00:00	1983-12-10	38000177		0	0	14		0	0	0	72485	0	313782	1127433		
33150	2749	1118084	1994-04-08	1994-04-08 00:00:00	1994-04-08	1994-04-08 00:00:00	\N	38000177		0	0	0		0	0	0	181809	0	00025152531	44923712		
116484	2559	40213227	2000-02-26	2000-02-26 00:00:00	2000-02-26	2000-02-26 00:00:00	2000-02-26	581452		0	0	0		0	0	0	169566	0	113	40213227		
58408	4852	40236824	1993-11-30	1993-11-30 00:00:00	1993-12-07	1993-12-07 00:00:00	1993-12-07	38000177		0	0	7		0	0	0	322835	0	1094107	40236824		
60078	4992	19128065	1999-05-13	1999-05-13 00:00:00	2000-05-07	2000-05-07 00:00:00	2000-05-07	38000177		0	0	360		0	0	0	332084	0	749882	19128065		
57322	4757	1127433	1985-09-02	1985-09-02 00:00:00	1985-09-09	1985-09-09 00:00:00	1985-09-09	38000177		0	0	7		0	0	0	316893	0	313782	1127433		
6111	512	1127078	1960-02-05	1960-02-05 00:00:00	1960-02-19	1960-02-19 00:00:00	1960-02-19	38000177		0	0	14		0	0	0	34211	0	282464	1127078		
44700	3700	1127433	1981-01-21	1981-01-21 00:00:00	1981-02-04	1981-02-04 00:00:00	1981-02-04	38000177		0	0	14		0	0	0	246008	0	313782	1127433		
57847	1266	40213296	2009-01-19	2009-01-19 00:00:00	2009-01-19	2009-01-19 00:00:00	2009-01-19	581452		0	0	0		0	0	0	83462	0	52	40213296		
7168	603	1127433	1983-09-12	1983-09-12 00:00:00	1983-12-11	1983-12-11 00:00:00	1983-12-11	38000177		0	0	90		0	0	0	39931	0	313782	1127433		
144145	3168	40213160	1980-04-26	1980-04-26 00:00:00	1980-04-26	1980-04-26 00:00:00	1980-04-26	581452		0	0	0		0	0	0	210616	0	10	40213160		
7283	610	40165015	2008-12-04	2008-12-04 00:00:00	2008-12-04	2008-12-04 00:00:00	\N	38000177		0	0	0		0	0	0	40482	0	861467	40165015		
48173	3993	19059056	1957-10-09	1957-10-09 00:00:00	1957-10-30	1957-10-30 00:00:00	1957-10-30	38000177		0	0	21		0	0	0	265523	0	243670	19059056		
27343	2261	1127433	1990-05-30	1990-05-30 00:00:00	1990-06-13	1990-06-13 00:00:00	1990-06-13	38000177		0	0	14		0	0	0	150339	0	313782	1127433		
3055	248	1118084	2012-12-09	2012-12-09 00:00:00	2012-12-09	2012-12-09 00:00:00	\N	38000177		0	0	0		0	0	0	16680	0	00025152531	44923712		
7775	651	40236824	2011-06-10	2011-06-10 00:00:00	2011-06-17	2011-06-17 00:00:00	2011-06-17	38000177		0	0	7		0	0	0	43085	0	1094107	40236824		
49122	4077	1127433	2013-07-17	2013-07-17 00:00:00	2013-07-31	2013-07-31 00:00:00	2013-07-31	38000177		0	0	14		0	0	0	270901	0	313782	1127433		
13680	1145	40229134	1964-02-27	1964-02-27 00:00:00	1964-03-12	1964-03-12 00:00:00	1964-03-12	38000177		0	0	14		0	0	0	75566	0	1043400	40229134		
13710	1146	920300	1986-02-08	1986-02-08 00:00:00	1986-02-15	1986-02-15 00:00:00	1986-02-15	38000177		0	0	7		0	0	0	75743	0	311989	920300		
9158	195	40213160	1958-06-23	1958-06-23 00:00:00	1958-06-23	1958-06-23 00:00:00	1958-06-23	581452		0	0	0		0	0	0	13403	0	10	40213160		
19992	1641	1713671	1995-07-05	1995-07-05 00:00:00	1995-07-26	1995-07-26 00:00:00	1995-07-26	38000177		0	0	21		0	0	0	110167	0	562251	1713671		
41721	3455	19128065	1984-05-17	1984-05-17 00:00:00	1985-05-12	1985-05-12 00:00:00	1985-05-12	38000177		0	0	360		0	0	0	229208	0	749882	19128065		
27131	2237	920334	1968-12-10	1968-12-10 00:00:00	1968-12-17	1968-12-17 00:00:00	1968-12-17	38000177		0	0	7		0	0	0	148843	0	311995	920334		
28235	614	40213227	1996-12-22	1996-12-22 00:00:00	1996-12-22	1996-12-22 00:00:00	1996-12-22	581452		0	0	0		0	0	0	40815	0	113	40213227		
39558	3270	19133873	1983-05-16	1983-05-16 00:00:00	1983-05-26	1983-05-26 00:00:00	1983-05-26	38000177		0	0	10		0	0	0	217306	0	834061	19133873		
225537	4952	40213306	1992-07-25	1992-07-25 00:00:00	1992-07-25	1992-07-25 00:00:00	1992-07-25	581452		0	0	0		0	0	0	329137	0	43	40213306		
42526	3527	19133873	1975-06-28	1975-06-28 00:00:00	1975-07-08	1975-07-08 00:00:00	1975-07-08	38000177		0	0	10		0	0	0	234051	0	834061	19133873		
40899	3391	40165015	1997-06-10	1997-06-10 00:00:00	1997-06-10	1997-06-10 00:00:00	\N	38000177		0	0	0		0	0	0	224903	0	861467	40165015		
63114	5242	19018935	2018-08-31	2018-08-31 00:00:00	2018-08-31	2018-08-31 00:00:00	\N	38000177		0	0	0		0	0	0	348827	0	197604	19018935		
43049	3568	1127078	1975-06-27	1975-06-27 00:00:00	1975-08-01	1975-08-01 00:00:00	1975-08-01	38000177		0	0	35		0	0	0	237101	0	282464	1127078		
20799	1715	19059056	1959-04-09	1959-04-09 00:00:00	1959-04-23	1959-04-23 00:00:00	1959-04-23	38000177		0	0	14		0	0	0	114569	0	243670	19059056		
53441	4442	1713671	2005-12-01	2005-12-01 00:00:00	2005-12-08	2005-12-08 00:00:00	2005-12-08	38000177		0	0	7		0	0	0	295283	0	562251	1713671		
34256	2830	1127433	1982-07-02	1982-07-02 00:00:00	1982-07-09	1982-07-09 00:00:00	1982-07-09	38000177		0	0	7		0	0	0	187708	0	313782	1127433		
125117	2752	40213227	2002-03-24	2002-03-24 00:00:00	2002-03-24	2002-03-24 00:00:00	2002-03-24	581452		0	0	0		0	0	0	182087	0	113	40213227		
17993	1490	1127433	1970-09-08	1970-09-08 00:00:00	1970-12-07	1970-12-07 00:00:00	1970-12-07	38000177		0	0	90		0	0	0	99304	0	313782	1127433		
235341	5169	40213160	1955-05-09	1955-05-09 00:00:00	1955-05-09	1955-05-09 00:00:00	1955-05-09	581452		0	0	0		0	0	0	343656	0	10	40213160		
35660	2939	19128065	1978-11-15	1978-11-15 00:00:00	1979-11-10	1979-11-10 00:00:00	1979-11-10	38000177		0	0	360		0	0	0	195946	0	749882	19128065		
46166	3825	19078461	1988-12-14	1988-12-14 00:00:00	1988-12-28	1988-12-28 00:00:00	1988-12-28	38000177		0	0	14		0	0	0	254067	0	310965	19078461		
123018	2704	40213296	2013-08-24	2013-08-24 00:00:00	2013-08-24	2013-08-24 00:00:00	2013-08-24	581452		0	0	0		0	0	0	179138	0	52	40213296		
123081	2705	40213198	2010-12-11	2010-12-11 00:00:00	2010-12-11	2010-12-11 00:00:00	2010-12-11	581452		0	0	0		0	0	0	179219	0	133	40213198		
29593	2450	19133905	1985-11-29	1985-11-29 00:00:00	1985-12-12	1985-12-12 00:00:00	1985-12-12	38000177		0	0	13		0	0	0	162501	0	834102	19133905		
1525	120	1115171	2007-07-25	2007-07-25 00:00:00	2007-08-15	2007-08-15 00:00:00	2007-08-15	38000177		0	0	21		0	0	0	7971	0	849574	1115171		
33904	2804	1127433	1956-09-14	1956-09-14 00:00:00	1956-09-21	1956-09-21 00:00:00	1956-09-21	38000177		0	0	7		0	0	0	185844	0	313782	1127433		
4522	376	19128065	1979-04-03	1979-04-03 00:00:00	1980-03-28	1980-03-28 00:00:00	1980-03-28	38000177		0	0	360		0	0	0	24924	0	749882	19128065		
71111	1556	40213160	1973-12-06	1973-12-06 00:00:00	1973-12-06	1973-12-06 00:00:00	1973-12-06	581452		0	0	0		0	0	0	104159	0	10	40213160		
45445	3759	19008572	1983-08-18	1983-08-18 00:00:00	1983-08-18	1983-08-18 00:00:00	\N	38000177		0	0	0		0	0	0	249936	0	106258	19008572		
47354	3926	19059056	1950-05-29	1950-05-29 00:00:00	1950-06-12	1950-06-12 00:00:00	1950-06-12	38000177		0	0	14		0	0	0	260975	0	243670	19059056		
18677	1542	40229134	1970-09-01	1970-09-01 00:00:00	1970-09-15	1970-09-15 00:00:00	1970-09-15	38000177		0	0	14		0	0	0	103338	0	1043400	40229134		
56538	4690	19059056	1991-05-26	1991-05-26 00:00:00	1991-06-09	1991-06-09 00:00:00	1991-06-09	38000177		0	0	14		0	0	0	312467	0	243670	19059056		
6412	539	46275916	1972-01-02	1972-01-02 00:00:00	1972-01-02	1972-01-02 00:00:00	1972-01-02	38000177		0	0	0		0	0	0	35857	0	1660014	46275916		
4172	347	19078461	2015-07-20	2015-07-20 00:00:00	2015-08-17	2015-08-17 00:00:00	2015-08-17	38000177		0	0	28		0	0	0	23114	0	310965	19078461		
15818	1315	19059056	1960-05-04	1960-05-04 00:00:00	1960-06-08	1960-06-08 00:00:00	1960-06-08	38000177		0	0	35		0	0	0	87104	0	243670	19059056		
15869	1318	1127433	1997-10-24	1997-10-24 00:00:00	1997-11-07	1997-11-07 00:00:00	1997-11-07	38000177		0	0	14		0	0	0	87345	0	313782	1127433		
59785	4971	1127433	1974-10-04	1974-10-04 00:00:00	1974-10-18	1974-10-18 00:00:00	1974-10-18	38000177		0	0	14		0	0	0	330650	0	313782	1127433		
15964	1323	1127078	1962-03-02	1962-03-02 00:00:00	1962-03-16	1962-03-16 00:00:00	1962-03-16	38000177		0	0	14		0	0	0	87860	0	282464	1127078		
58911	1289	40213227	2013-03-19	2013-03-19 00:00:00	2013-03-19	2013-03-19 00:00:00	2013-03-19	581452		0	0	0		0	0	0	85205	0	113	40213227		
2171	173	1124300	2003-07-04	2003-07-04 00:00:00	2003-07-04	2003-07-04 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00781178901	45011828		
11400	950	1127433	1984-07-09	1984-07-09 00:00:00	1984-07-30	1984-07-30 00:00:00	1984-07-30	38000177		0	0	21		0	0	0	63097	0	313782	1127433		
93557	2053	40213198	2018-09-27	2018-09-27 00:00:00	2018-09-27	2018-09-27 00:00:00	2018-09-27	581452		0	0	0		0	0	0	136499	0	133	40213198		
25495	2094	1115171	2014-08-04	2014-08-04 00:00:00	2014-08-18	2014-08-18 00:00:00	2014-08-18	38000177		0	0	14		0	0	0	139575	0	849574	1115171		
25551	2100	19059056	1976-06-03	1976-06-03 00:00:00	1976-07-10	1976-07-10 00:00:00	1976-07-10	38000177		0	0	37		0	0	0	139971	0	243670	19059056		
57607	4784	1115171	2018-08-28	2018-08-28 00:00:00	2018-10-02	2018-10-02 00:00:00	2018-10-02	38000177		0	0	35		0	0	0	318453	0	849574	1115171		
57678	4792	920300	1981-05-22	1981-05-22 00:00:00	1981-05-29	1981-05-29 00:00:00	1981-05-29	38000177		0	0	7		0	0	0	318878	0	311989	920300		
48871	4052	19128065	1997-03-06	1997-03-06 00:00:00	1998-03-01	1998-03-01 00:00:00	1998-03-01	38000177		0	0	360		0	0	0	269331	0	749882	19128065		
13131	1102	19074841	1983-11-26	1983-11-26 00:00:00	1983-12-10	1983-12-10 00:00:00	1983-12-10	38000177		0	0	14		0	0	0	72485	0	309043	19074841		
33151	2749	1127433	1991-03-21	1991-03-21 00:00:00	1991-03-28	1991-03-28 00:00:00	1991-03-28	38000177		0	0	7		0	0	0	181819	0	313782	1127433		
116486	2559	40213160	1958-05-24	1958-05-24 00:00:00	1958-05-24	1958-05-24 00:00:00	1958-05-24	581452		0	0	0		0	0	0	169532	0	10	40213160		
70836	1550	40213227	2011-12-24	2011-12-24 00:00:00	2011-12-24	2011-12-24 00:00:00	2011-12-24	581452		0	0	0		0	0	0	103793	0	113	40213227		
58437	4853	19133873	1964-09-27	1964-09-27 00:00:00	1964-10-08	1964-10-08 00:00:00	1964-10-08	38000177		0	0	11		0	0	0	322883	0	834061	19133873		
57323	4757	1127433	1961-10-29	1961-10-29 00:00:00	1961-11-05	1961-11-05 00:00:00	1961-11-05	38000177		0	0	7		0	0	0	316900	0	313782	1127433		
6112	512	19006318	1960-02-05	1960-02-05 00:00:00	1960-02-19	1960-02-19 00:00:00	1960-02-19	38000177		0	0	14		0	0	0	34211	0	105078	19006318		
44701	3700	1127078	1970-06-11	1970-06-11 00:00:00	1970-08-10	1970-08-10 00:00:00	1970-08-10	38000177		0	0	60		0	0	0	245971	0	282464	1127078		
57851	1266	40213260	2017-01-09	2017-01-09 00:00:00	2017-01-09	2017-01-09 00:00:00	2017-01-09	581452		0	0	0		0	0	0	83495	0	121	40213260		
7169	603	1127433	1979-04-09	1979-04-09 00:00:00	1979-04-23	1979-04-23 00:00:00	1979-04-23	38000177		0	0	14		0	0	0	39987	0	313782	1127433		
144146	3168	40213160	1980-06-28	1980-06-28 00:00:00	1980-06-28	1980-06-28 00:00:00	1980-06-28	581452		0	0	0		0	0	0	210625	0	10	40213160		
7285	610	1127433	1993-05-21	1993-05-21 00:00:00	1993-06-04	1993-06-04 00:00:00	1993-06-04	38000177		0	0	14		0	0	0	40590	0	313782	1127433		
48174	3993	1127433	2013-09-05	2013-09-05 00:00:00	2013-09-12	2013-09-12 00:00:00	2013-09-12	38000177		0	0	7		0	0	0	265459	0	313782	1127433		
27344	2261	1127433	2012-03-31	2012-03-31 00:00:00	2012-04-07	2012-04-07 00:00:00	2012-04-07	38000177		0	0	7		0	0	0	150273	0	313782	1127433		
3056	248	40229134	1981-02-16	1981-02-16 00:00:00	1981-03-02	1981-03-02 00:00:00	1981-03-02	38000177		0	0	14		0	0	0	16677	0	1043400	40229134		
7776	651	920300	2011-06-10	2011-06-10 00:00:00	2011-06-17	2011-06-17 00:00:00	2011-06-17	38000177		0	0	7		0	0	0	43085	0	311989	920300		
49123	4077	1127078	1979-08-18	1979-08-18 00:00:00	1979-10-17	1979-10-17 00:00:00	1979-10-17	38000177		0	0	60		0	0	0	270887	0	282464	1127078		
13681	1145	1115171	2011-12-18	2011-12-18 00:00:00	2012-01-17	2012-01-17 00:00:00	2012-01-17	38000177		0	0	30		0	0	0	75558	0	849574	1115171		
13711	1146	1713671	1970-03-29	1970-03-29 00:00:00	1970-04-12	1970-04-12 00:00:00	1970-04-12	38000177		0	0	14		0	0	0	75742	0	562251	1713671		
9809	209	40213227	1993-03-05	1993-03-05 00:00:00	1993-03-05	1993-03-05 00:00:00	1993-03-05	581452		0	0	0		0	0	0	14250	0	113	40213227		
19993	1641	1118084	1997-10-31	1997-10-31 00:00:00	1997-10-31	1997-10-31 00:00:00	\N	38000177		0	0	0		0	0	0	110130	0	00025152531	44923712		
41722	3455	19059056	1971-03-17	1971-03-17 00:00:00	1971-03-31	1971-03-31 00:00:00	1971-03-31	38000177		0	0	14		0	0	0	229206	0	243670	19059056		
27132	2237	920300	1968-12-03	1968-12-03 00:00:00	1968-12-10	1968-12-10 00:00:00	1968-12-10	38000177		0	0	7		0	0	0	148790	0	311989	920300		
28240	614	40213227	2005-01-02	2005-01-02 00:00:00	2005-01-02	2005-01-02 00:00:00	2005-01-02	581452		0	0	0		0	0	0	40830	0	113	40213227		
39559	3270	1127078	1976-02-23	1976-02-23 00:00:00	1976-04-23	1976-04-23 00:00:00	1976-04-23	38000177		0	0	60		0	0	0	217350	0	282464	1127078		
225539	4952	40213227	1992-07-25	1992-07-25 00:00:00	1992-07-25	1992-07-25 00:00:00	1992-07-25	581452		0	0	0		0	0	0	329137	0	113	40213227		
42527	3527	19059056	1971-04-22	1971-04-22 00:00:00	1971-05-06	1971-05-06 00:00:00	1971-05-06	38000177		0	0	14		0	0	0	234048	0	243670	19059056		
40900	3391	1127433	2015-08-05	2015-08-05 00:00:00	2015-08-19	2015-08-19 00:00:00	2015-08-19	38000177		0	0	14		0	0	0	224929	0	313782	1127433		
63115	5242	40163554	2018-08-31	2018-08-31 00:00:00	2018-08-31	2018-08-31 00:00:00	\N	38000177		0	0	0		0	0	0	348827	0	855332	40163554		
43050	3569	19128065	1987-08-14	1987-08-14 00:00:00	1988-08-08	1988-08-08 00:00:00	1988-08-08	38000177		0	0	360		0	0	0	237165	0	749882	19128065		
20800	1715	19006318	1959-04-09	1959-04-09 00:00:00	1959-04-23	1959-04-23 00:00:00	1959-04-23	38000177		0	0	14		0	0	0	114569	0	105078	19006318		
63911	5309	1713671	1978-05-19	1978-05-19 00:00:00	1978-06-02	1978-06-02 00:00:00	1978-06-02	38000177		0	0	14		0	0	0	353063	0	562251	1713671		
53241	4423	1127433	1991-05-20	1991-05-20 00:00:00	1991-06-03	1991-06-03 00:00:00	1991-06-03	38000177		0	0	14		0	0	0	294090	0	313782	1127433		
231097	5078	40213227	1992-06-01	1992-06-01 00:00:00	1992-06-01	1992-06-01 00:00:00	1992-06-01	581452		0	0	0		0	0	0	337670	0	113	40213227		
17994	1490	1127433	1993-01-10	1993-01-10 00:00:00	1993-02-09	1993-02-09 00:00:00	1993-02-09	38000177		0	0	30		0	0	0	99306	0	313782	1127433		
68668	1504	40213227	2013-04-02	2013-04-02 00:00:00	2013-04-02	2013-04-02 00:00:00	2013-04-02	581452		0	0	0		0	0	0	100293	0	113	40213227		
35661	2939	19006318	1963-12-24	1963-12-24 00:00:00	1964-01-07	1964-01-07 00:00:00	1964-01-07	38000177		0	0	14		0	0	0	195944	0	105078	19006318		
46167	3825	1713671	1988-02-21	1988-02-21 00:00:00	1988-03-06	1988-03-06 00:00:00	1988-03-06	38000177		0	0	14		0	0	0	254060	0	562251	1713671		
123023	2704	40213160	1976-07-24	1976-07-24 00:00:00	1976-07-24	1976-07-24 00:00:00	1976-07-24	581452		0	0	0		0	0	0	179134	0	10	40213160		
123086	2705	40213201	2008-11-29	2008-11-29 00:00:00	2008-11-29	2008-11-29 00:00:00	2008-11-29	581452		0	0	0		0	0	0	179218	0	33	40213201		
29595	2450	1127433	1966-11-13	1966-11-13 00:00:00	1966-11-27	1966-11-27 00:00:00	1966-11-27	38000177		0	0	14		0	0	0	162498	0	313782	1127433		
1526	120	1127078	1978-06-06	1978-06-06 00:00:00	1978-06-20	1978-06-20 00:00:00	1978-06-20	38000177		0	0	14		0	0	0	8003	0	282464	1127078		
33905	2804	1127433	1983-08-09	1983-08-09 00:00:00	1983-08-16	1983-08-16 00:00:00	1983-08-16	38000177		0	0	7		0	0	0	185825	0	313782	1127433		
4523	376	1124300	1999-07-07	1999-07-07 00:00:00	1999-07-07	1999-07-07 00:00:00	\N	38000177		0	0	0		0	0	0	24951	0	00781178901	45011828		
71113	1556	40213314	1977-03-03	1977-03-03 00:00:00	1977-03-03	1977-03-03 00:00:00	1977-03-03	581452		0	0	0		0	0	0	104230	0	49	40213314		
45446	3759	19128065	1981-07-21	1981-07-21 00:00:00	1982-07-16	1982-07-16 00:00:00	1982-07-16	38000177		0	0	360		0	0	0	249860	0	749882	19128065		
47355	3926	19006318	1950-05-29	1950-05-29 00:00:00	1950-06-12	1950-06-12 00:00:00	1950-06-12	38000177		0	0	14		0	0	0	260975	0	105078	19006318		
18678	1542	1713671	1976-09-02	1976-09-02 00:00:00	1976-09-16	1976-09-16 00:00:00	1976-09-16	38000177		0	0	14		0	0	0	103307	0	562251	1713671		
56539	4690	19059056	1965-02-22	1965-02-22 00:00:00	1965-04-23	1965-04-23 00:00:00	1965-04-23	38000177		0	0	60		0	0	0	312520	0	243670	19059056		
6413	539	1127433	1957-03-08	1957-03-08 00:00:00	1957-03-15	1957-03-15 00:00:00	1957-03-15	38000177		0	0	7		0	0	0	35770	0	313782	1127433		
4173	347	40231925	1982-10-11	1982-10-11 00:00:00	1982-10-11	1982-10-11 00:00:00	\N	38000177		0	0	0		0	0	0	23113	0	1049221	40231925		
15819	1315	19133873	1971-03-21	1971-03-21 00:00:00	1971-04-02	1971-04-02 00:00:00	1971-04-02	38000177		0	0	12		0	0	0	87133	0	834061	19133873		
15870	1318	19077572	2011-08-30	2011-08-30 00:00:00	2011-08-30	2011-08-30 00:00:00	\N	38000177		0	0	0		0	0	0	87416	0	310436	19077572		
59786	4971	1127433	1983-11-28	1983-11-28 00:00:00	1983-12-12	1983-12-12 00:00:00	1983-12-12	38000177		0	0	14		0	0	0	330512	0	313782	1127433		
15965	1323	19129655	1962-03-02	1962-03-02 00:00:00	1962-03-16	1962-03-16 00:00:00	1962-03-16	38000177		0	0	14		0	0	0	87860	0	789980	19129655		
58912	1289	40213260	2013-03-19	2013-03-19 00:00:00	2013-03-19	2013-03-19 00:00:00	2013-03-19	581452		0	0	0		0	0	0	85205	0	121	40213260		
2172	173	19133873	1976-10-23	1976-10-23 00:00:00	1976-11-03	1976-11-03 00:00:00	1976-11-03	38000177		0	0	11		0	0	0	11749	0	834061	19133873		
11401	950	19133873	1981-03-29	1981-03-29 00:00:00	1981-04-08	1981-04-08 00:00:00	1981-04-08	38000177		0	0	10		0	0	0	63100	0	834061	19133873		
93559	2053	40213227	2004-07-08	2004-07-08 00:00:00	2004-07-08	2004-07-08 00:00:00	2004-07-08	581452		0	0	0		0	0	0	136469	0	113	40213227		
25496	2094	1118084	1985-08-16	1985-08-16 00:00:00	1985-08-16	1985-08-16 00:00:00	\N	38000177		0	0	0		0	0	0	139585	0	00025152531	44923712		
25552	2100	19133873	1945-10-27	1945-10-27 00:00:00	1945-11-05	1945-11-05 00:00:00	1945-11-05	38000177		0	0	9		0	0	0	139981	0	834061	19133873		
57608	4784	1115171	1998-07-09	1998-07-09 00:00:00	1998-07-23	1998-07-23 00:00:00	1998-07-23	38000177		0	0	14		0	0	0	318451	0	849574	1115171		
57680	4792	40236824	1979-04-15	1979-04-15 00:00:00	1979-04-22	1979-04-22 00:00:00	1979-04-22	38000177		0	0	7		0	0	0	318863	0	1094107	40236824		
48872	4052	1127433	1990-07-02	1990-07-02 00:00:00	1990-07-09	1990-07-09 00:00:00	1990-07-09	38000177		0	0	7		0	0	0	269378	0	313782	1127433		
13132	1102	1127433	2005-07-01	2005-07-01 00:00:00	2005-07-08	2005-07-08 00:00:00	2005-07-08	38000177		0	0	7		0	0	0	72416	0	313782	1127433		
33152	2749	1127433	1980-08-09	1980-08-09 00:00:00	1980-09-13	1980-09-13 00:00:00	1980-09-13	38000177		0	0	35		0	0	0	181848	0	313782	1127433		
34992	763	40213227	2016-03-24	2016-03-24 00:00:00	2016-03-24	2016-03-24 00:00:00	2016-03-24	581452		0	0	0		0	0	0	50795	0	113	40213227		
70837	1550	40213296	2011-12-24	2011-12-24 00:00:00	2011-12-24	2011-12-24 00:00:00	2011-12-24	581452		0	0	0		0	0	0	103793	0	52	40213296		
58438	4853	19133873	1965-04-09	1965-04-09 00:00:00	1965-04-22	1965-04-22 00:00:00	1965-04-22	38000177		0	0	13		0	0	0	322867	0	834061	19133873		
57324	4757	19115351	2001-03-17	2001-03-17 00:00:00	2001-08-18	2001-08-18 00:00:00	2001-08-18	38000177		0	0	154		0	0	0	316963	0	563026	19115351		
6113	512	19133873	1960-05-03	1960-05-03 00:00:00	1960-05-11	1960-05-11 00:00:00	1960-05-11	38000177		0	0	8		0	0	0	34198	0	834061	19133873		
44702	3700	1118084	2005-04-13	2005-04-13 00:00:00	2005-04-13	2005-04-13 00:00:00	\N	38000177		0	0	0		0	0	0	246027	0	00025152531	44923712		
57863	1266	40213227	2000-07-03	2000-07-03 00:00:00	2000-07-03	2000-07-03 00:00:00	2000-07-03	581452		0	0	0		0	0	0	83496	0	113	40213227		
7170	603	1118084	1995-12-15	1995-12-15 00:00:00	1995-12-15	1995-12-15 00:00:00	\N	38000177		0	0	0		0	0	0	39949	0	00025152531	44923712		
144147	3168	40213160	1980-09-27	1980-09-27 00:00:00	1980-09-27	1980-09-27 00:00:00	1980-09-27	581452		0	0	0		0	0	0	210617	0	10	40213160		
7287	610	1127078	1973-11-28	1973-11-28 00:00:00	1973-12-26	1973-12-26 00:00:00	1973-12-26	38000177		0	0	28		0	0	0	40477	0	282464	1127078		
48175	3993	19133873	1949-05-26	1949-05-26 00:00:00	1949-06-04	1949-06-04 00:00:00	1949-06-04	38000177		0	0	9		0	0	0	265505	0	834061	19133873		
27345	2261	1118084	2001-08-17	2001-08-17 00:00:00	2001-08-17	2001-08-17 00:00:00	\N	38000177		0	0	0		0	0	0	150347	0	00025152531	44923712		
3057	248	1127433	1996-04-16	1996-04-16 00:00:00	1996-04-23	1996-04-23 00:00:00	1996-04-23	38000177		0	0	7		0	0	0	16706	0	313782	1127433		
7777	651	1115171	2007-08-26	2007-08-26 00:00:00	2007-09-09	2007-09-09 00:00:00	2007-09-09	38000177		0	0	14		0	0	0	43080	0	849574	1115171		
49124	4077	1127433	1975-03-23	1975-03-23 00:00:00	1975-04-06	1975-04-06 00:00:00	1975-04-06	38000177		0	0	14		0	0	0	270898	0	313782	1127433		
13682	1145	1118084	1981-12-01	1981-12-01 00:00:00	1981-12-01	1981-12-01 00:00:00	\N	38000177		0	0	0		0	0	0	75610	0	00025152531	44923712		
13712	1146	19059056	1969-12-09	1969-12-09 00:00:00	1969-12-30	1969-12-30 00:00:00	1969-12-30	38000177		0	0	21		0	0	0	75739	0	243670	19059056		
9813	209	40213227	2002-03-01	2002-03-01 00:00:00	2002-03-01	2002-03-01 00:00:00	2002-03-01	581452		0	0	0		0	0	0	14251	0	113	40213227		
19994	1641	1127433	1981-05-23	1981-05-23 00:00:00	1981-05-30	1981-05-30 00:00:00	1981-05-30	38000177		0	0	7		0	0	0	110119	0	313782	1127433		
41723	3455	19129655	1971-03-17	1971-03-17 00:00:00	1971-03-31	1971-03-31 00:00:00	1971-03-31	38000177		0	0	14		0	0	0	229206	0	789980	19129655		
27133	2237	40236824	1968-12-03	1968-12-03 00:00:00	1968-12-17	1968-12-17 00:00:00	1968-12-17	38000177		0	0	14		0	0	0	148790	0	1094107	40236824		
28242	614	40213296	2005-01-02	2005-01-02 00:00:00	2005-01-02	2005-01-02 00:00:00	2005-01-02	581452		0	0	0		0	0	0	40830	0	52	40213296		
39560	3270	1124300	2005-10-03	2005-10-03 00:00:00	2005-10-03	2005-10-03 00:00:00	\N	38000177		0	0	0		0	0	0	217307	0	00781178901	45011828		
236826	5199	40213260	2012-07-10	2012-07-10 00:00:00	2012-07-10	2012-07-10 00:00:00	2012-07-10	581452		0	0	0		0	0	0	345765	0	121	40213260		
42528	3527	1551192	1963-04-09	1963-04-09 00:00:00	1963-04-09	1963-04-09 00:00:00	1963-04-09	38000177		0	0	0		0	0	0	234047	0	312617	1551192		
40901	3391	1124300	2019-05-29	2019-05-29 00:00:00	2019-05-29	2019-05-29 00:00:00	\N	38000177		0	0	0		0	0	0	224882	0	00781178901	45011828		
63116	5242	40171902	2018-08-31	2018-08-31 00:00:00	2018-08-31	2018-08-31 00:00:00	\N	38000177		0	0	0		0	0	0	348827	0	897718	40171902		
43052	3569	1127433	1977-01-14	1977-01-14 00:00:00	1977-01-28	1977-01-28 00:00:00	1977-01-28	38000177		0	0	14		0	0	0	237178	0	313782	1127433		
20801	1715	40229134	1994-03-06	1994-03-06 00:00:00	1994-03-13	1994-03-13 00:00:00	1994-03-13	38000177		0	0	7		0	0	0	114558	0	1043400	40229134		
63912	5309	19059056	1964-11-07	1964-11-07 00:00:00	1964-12-12	1964-12-12 00:00:00	1964-12-12	38000177		0	0	35		0	0	0	353146	0	243670	19059056		
53242	4423	19075001	1991-05-20	1991-05-20 00:00:00	1991-06-03	1991-06-03 00:00:00	1991-06-03	38000177		0	0	14		0	0	0	294090	0	309097	19075001		
58981	4899	19133905	1994-07-22	1994-07-22 00:00:00	1994-08-04	1994-08-04 00:00:00	1994-08-04	38000177		0	0	13		0	0	0	325778	0	834102	19133905		
17995	1490	19059056	1940-11-23	1940-11-23 00:00:00	1940-12-14	1940-12-14 00:00:00	1940-12-14	38000177		0	0	21		0	0	0	99303	0	243670	19059056		
68671	1504	40213198	2010-03-16	2010-03-16 00:00:00	2010-03-16	2010-03-16 00:00:00	2010-03-16	581452		0	0	0		0	0	0	100223	0	133	40213198		
35662	2939	1127078	1963-12-24	1963-12-24 00:00:00	1964-01-07	1964-01-07 00:00:00	1964-01-07	38000177		0	0	14		0	0	0	195944	0	282464	1127078		
46170	3825	1124300	1994-06-21	1994-06-21 00:00:00	1994-06-21	1994-06-21 00:00:00	\N	38000177		0	0	0		0	0	0	254101	0	00781178901	45011828		
123028	2704	40213160	1972-04-22	1972-04-22 00:00:00	1972-04-22	1972-04-22 00:00:00	1972-04-22	581452		0	0	0		0	0	0	179124	0	10	40213160		
55449	4604	1127433	1971-03-26	1971-03-26 00:00:00	1971-04-09	1971-04-09 00:00:00	1971-04-09	38000177		0	0	14		0	0	0	306711	0	313782	1127433		
29596	2450	19059056	1952-07-27	1952-07-27 00:00:00	1952-08-10	1952-08-10 00:00:00	1952-08-10	38000177		0	0	14		0	0	0	162492	0	243670	19059056		
1527	120	19006318	1978-06-06	1978-06-06 00:00:00	1978-06-20	1978-06-20 00:00:00	1978-06-20	38000177		0	0	14		0	0	0	8003	0	105078	19006318		
33906	2804	1713671	1998-05-25	1998-05-25 00:00:00	1998-06-15	1998-06-15 00:00:00	1998-06-15	38000177		0	0	21		0	0	0	185858	0	562251	1713671		
4524	376	1127433	1973-05-26	1973-05-26 00:00:00	1973-06-02	1973-06-02 00:00:00	1973-06-02	38000177		0	0	7		0	0	0	24902	0	313782	1127433		
71118	1556	40213160	1978-03-09	1978-03-09 00:00:00	1978-03-09	1978-03-09 00:00:00	1978-03-09	581452		0	0	0		0	0	0	104222	0	10	40213160		
45447	3759	1127433	1982-08-05	1982-08-05 00:00:00	1982-08-19	1982-08-19 00:00:00	1982-08-19	38000177		0	0	14		0	0	0	249933	0	313782	1127433		
47356	3926	19133873	1952-07-07	1952-07-07 00:00:00	1952-07-16	1952-07-16 00:00:00	1952-07-16	38000177		0	0	9		0	0	0	260922	0	834061	19133873		
18679	1542	1118084	2005-07-02	2005-07-02 00:00:00	2005-07-02	2005-07-02 00:00:00	\N	38000177		0	0	0		0	0	0	103317	0	00025152531	44923712		
56540	4690	1713671	1964-11-07	1964-11-07 00:00:00	1964-11-28	1964-11-28 00:00:00	1964-11-28	38000177		0	0	21		0	0	0	312452	0	562251	1713671		
6414	539	1332419	1994-02-20	1994-02-20 00:00:00	1994-02-20	1994-02-20 00:00:00	\N	38000177		0	0	0		0	0	0	35781	0	197361	1332419		
4174	347	19078461	1982-10-11	1982-10-11 00:00:00	1982-11-10	1982-11-10 00:00:00	1982-11-10	38000177		0	0	30		0	0	0	23113	0	310965	19078461		
15821	1316	1115171	2018-09-27	2018-09-27 00:00:00	2018-12-26	2018-12-26 00:00:00	2018-12-26	38000177		0	0	90		0	0	0	87224	0	849574	1115171		
15871	1318	19059056	1949-05-07	1949-05-07 00:00:00	1949-06-11	1949-06-11 00:00:00	1949-06-11	38000177		0	0	35		0	0	0	87398	0	243670	19059056		
59787	4971	1127433	2000-05-27	2000-05-27 00:00:00	2000-06-03	2000-06-03 00:00:00	2000-06-03	38000177		0	0	7		0	0	0	330552	0	313782	1127433		
15966	1323	19078461	1997-09-15	1997-09-15 00:00:00	1997-10-06	1997-10-06 00:00:00	1997-10-06	38000177		0	0	21		0	0	0	87847	0	310965	19078461		
58915	1289	40213296	2004-03-23	2004-03-23 00:00:00	2004-03-23	2004-03-23 00:00:00	2004-03-23	581452		0	0	0		0	0	0	85227	0	52	40213296		
2173	173	1127433	1983-11-03	1983-11-03 00:00:00	1983-11-10	1983-11-10 00:00:00	1983-11-10	38000177		0	0	7		0	0	0	11767	0	313782	1127433		
11402	950	1127433	1985-06-05	1985-06-05 00:00:00	1985-06-12	1985-06-12 00:00:00	1985-06-12	38000177		0	0	7		0	0	0	63128	0	313782	1127433		
3298	72	40213201	2013-10-14	2013-10-14 00:00:00	2013-10-14	2013-10-14 00:00:00	2013-10-14	581452		0	0	0		0	0	0	4899	0	33	40213201		
25497	2094	1127433	2018-12-17	2018-12-17 00:00:00	2018-12-24	2018-12-24 00:00:00	2018-12-24	38000177		0	0	7		0	0	0	139646	0	313782	1127433		
25553	2100	19059056	1960-06-22	1960-06-22 00:00:00	1960-07-27	1960-07-27 00:00:00	1960-07-27	38000177		0	0	35		0	0	0	139969	0	243670	19059056		
57609	4784	19059056	1967-04-02	1967-04-02 00:00:00	1967-04-23	1967-04-23 00:00:00	1967-04-23	38000177		0	0	21		0	0	0	318450	0	243670	19059056		
57681	4792	920300	1979-04-15	1979-04-15 00:00:00	1979-04-22	1979-04-22 00:00:00	1979-04-22	38000177		0	0	7		0	0	0	318863	0	311989	920300		
48873	4052	19059056	1985-11-24	1985-11-24 00:00:00	1985-12-24	1985-12-24 00:00:00	1985-12-24	38000177		0	0	30		0	0	0	269341	0	243670	19059056		
13133	1102	1713671	1975-04-24	1975-04-24 00:00:00	1975-05-01	1975-05-01 00:00:00	1975-05-01	38000177		0	0	7		0	0	0	72386	0	562251	1713671		
33153	2749	40229134	1966-09-19	1966-09-19 00:00:00	1966-09-26	1966-09-26 00:00:00	1966-09-26	38000177		0	0	7		0	0	0	181800	0	1043400	40229134		
34993	763	40213260	2016-03-24	2016-03-24 00:00:00	2016-03-24	2016-03-24 00:00:00	2016-03-24	581452		0	0	0		0	0	0	50795	0	121	40213260		
70840	1550	40213160	1969-07-19	1969-07-19 00:00:00	1969-07-19	1969-07-19 00:00:00	1969-07-19	581452		0	0	0		0	0	0	103764	0	10	40213160		
58439	4853	1127433	1995-03-18	1995-03-18 00:00:00	1995-04-01	1995-04-01 00:00:00	1995-04-01	38000177		0	0	14		0	0	0	322885	0	313782	1127433		
57325	4757	19059056	1982-09-06	1982-09-06 00:00:00	1982-09-20	1982-09-20 00:00:00	1982-09-20	38000177		0	0	14		0	0	0	316962	0	243670	19059056		
6114	512	1127433	2001-09-12	2001-09-12 00:00:00	2001-09-26	2001-09-26 00:00:00	2001-09-26	38000177		0	0	14		0	0	0	34205	0	313782	1127433		
44703	3700	1713671	2007-06-12	2007-06-12 00:00:00	2007-07-03	2007-07-03 00:00:00	2007-07-03	38000177		0	0	21		0	0	0	245986	0	562251	1713671		
31417	685	40213296	2006-02-13	2006-02-13 00:00:00	2006-02-13	2006-02-13 00:00:00	2006-02-13	581452		0	0	0		0	0	0	45326	0	52	40213296		
7171	603	40229134	2014-03-12	2014-03-12 00:00:00	2014-03-26	2014-03-26 00:00:00	2014-03-26	38000177		0	0	14		0	0	0	40035	0	1043400	40229134		
144148	3168	40213314	1980-04-26	1980-04-26 00:00:00	1980-04-26	1980-04-26 00:00:00	1980-04-26	581452		0	0	0		0	0	0	210616	0	49	40213314		
7288	610	19059056	1976-10-11	1976-10-11 00:00:00	1976-12-10	1976-12-10 00:00:00	1976-12-10	38000177		0	0	60		0	0	0	40479	0	243670	19059056		
48176	3993	40236824	1965-03-01	1965-03-01 00:00:00	1965-03-08	1965-03-08 00:00:00	1965-03-08	38000177		0	0	7		0	0	0	265525	0	1094107	40236824		
27346	2261	19059056	1973-10-13	1973-10-13 00:00:00	1973-10-27	1973-10-27 00:00:00	1973-10-27	38000177		0	0	14		0	0	0	150308	0	243670	19059056		
3058	248	19006318	1975-06-17	1975-06-17 00:00:00	1975-07-01	1975-07-01 00:00:00	1975-07-01	38000177		0	0	14		0	0	0	16710	0	105078	19006318		
7778	651	1127433	1997-01-22	1997-01-22 00:00:00	1997-02-05	1997-02-05 00:00:00	1997-02-05	38000177		0	0	14		0	0	0	43101	0	313782	1127433		
49125	4077	1713671	2006-11-18	2006-11-18 00:00:00	2006-11-25	2006-11-25 00:00:00	2006-11-25	38000177		0	0	7		0	0	0	270915	0	562251	1713671		
27405	2267	40229134	1983-10-21	1983-10-21 00:00:00	1983-10-28	1983-10-28 00:00:00	1983-10-28	38000177		0	0	7		0	0	0	150708	0	1043400	40229134		
13713	1146	1118084	1998-04-25	1998-04-25 00:00:00	1998-04-25	1998-04-25 00:00:00	\N	38000177		0	0	0		0	0	0	75708	0	00025152531	44923712		
160477	3531	40213296	2007-07-04	2007-07-04 00:00:00	2007-07-04	2007-07-04 00:00:00	2007-07-04	581452		0	0	0		0	0	0	234580	0	52	40213296		
19995	1641	1713671	1958-10-09	1958-10-09 00:00:00	1958-10-16	1958-10-16 00:00:00	1958-10-16	38000177		0	0	7		0	0	0	110125	0	562251	1713671		
41724	3455	19115351	2000-04-03	2000-04-03 00:00:00	2000-10-09	2000-10-09 00:00:00	2000-10-09	38000177		0	0	189		0	0	0	229224	0	563026	19115351		
27134	2237	40229134	1968-02-05	1968-02-05 00:00:00	1968-02-19	1968-02-19 00:00:00	1968-02-19	38000177		0	0	14		0	0	0	148789	0	1043400	40229134		
28244	614	40213160	1964-05-10	1964-05-10 00:00:00	1964-05-10	1964-05-10 00:00:00	1964-05-10	581452		0	0	0		0	0	0	40793	0	10	40213160		
39561	3270	46233988	1974-11-30	1974-11-30 00:00:00	1974-12-14	1974-12-14 00:00:00	1974-12-14	38000177		0	0	14		0	0	0	217280	0	1652673	46233988		
236831	5199	40213160	1962-06-26	1962-06-26 00:00:00	1962-06-26	1962-06-26 00:00:00	1962-06-26	581452		0	0	0		0	0	0	345740	0	10	40213160		
42529	3527	1713671	2015-07-16	2015-07-16 00:00:00	2015-07-23	2015-07-23 00:00:00	2015-07-23	38000177		0	0	7		0	0	0	234075	0	562251	1713671		
40902	3391	1127433	2009-12-04	2009-12-04 00:00:00	2010-02-02	2010-02-02 00:00:00	2010-02-02	38000177		0	0	60		0	0	0	224902	0	313782	1127433		
63117	5242	1127433	1996-12-07	1996-12-07 00:00:00	1996-12-14	1996-12-14 00:00:00	1996-12-14	38000177		0	0	7		0	0	0	348844	0	313782	1127433		
43053	3569	40220960	1987-07-14	1987-07-14 00:00:00	1987-07-14	1987-07-14 00:00:00	1987-07-14	38000177		0	0	0		0	0	0	237140	0	1804799	40220960		
20802	1715	1127433	1984-09-24	1984-09-24 00:00:00	1984-10-08	1984-10-08 00:00:00	1984-10-08	38000177		0	0	14		0	0	0	114534	0	313782	1127433		
63913	5309	1118084	1993-05-08	1993-05-08 00:00:00	1993-05-08	1993-05-08 00:00:00	\N	38000177		0	0	0		0	0	0	353093	0	00025152531	44923712		
53243	4423	46275916	1989-04-21	1989-04-21 00:00:00	1989-04-21	1989-04-21 00:00:00	1989-04-21	38000177		0	0	0		0	0	0	294121	0	1660014	46275916		
58982	4899	40169281	1969-02-25	1969-02-25 00:00:00	1969-02-25	1969-02-25 00:00:00	\N	38000177		0	0	0		0	0	0	325826	0	896209	40169281		
17996	1490	1127433	2018-10-01	2018-10-01 00:00:00	2018-10-31	2018-10-31 00:00:00	2018-10-31	38000177		0	0	30		0	0	0	99329	0	313782	1127433		
68688	1504	40213227	2003-02-04	2003-02-04 00:00:00	2003-02-04	2003-02-04 00:00:00	2003-02-04	581452		0	0	0		0	0	0	100309	0	113	40213227		
35663	2939	19133905	1977-03-27	1977-03-27 00:00:00	1977-04-07	1977-04-07 00:00:00	1977-04-07	38000177		0	0	11		0	0	0	195949	0	834102	19133905		
46171	3825	1127433	1988-01-28	1988-01-28 00:00:00	1988-02-18	1988-02-18 00:00:00	1988-02-18	38000177		0	0	21		0	0	0	254066	0	313782	1127433		
123030	2704	40213227	2002-08-24	2002-08-24 00:00:00	2002-08-24	2002-08-24 00:00:00	2002-08-24	581452		0	0	0		0	0	0	179167	0	113	40213227		
55463	4606	1127433	1990-10-09	1990-10-09 00:00:00	1990-10-16	1990-10-16 00:00:00	1990-10-16	38000177		0	0	7		0	0	0	306857	0	313782	1127433		
29597	2450	19006318	1952-07-27	1952-07-27 00:00:00	1952-08-10	1952-08-10 00:00:00	1952-08-10	38000177		0	0	14		0	0	0	162492	0	105078	19006318		
1528	120	1127078	1979-12-28	1979-12-28 00:00:00	1980-01-18	1980-01-18 00:00:00	1980-01-18	38000177		0	0	21		0	0	0	7968	0	282464	1127078		
33907	2804	19059056	1952-08-05	1952-08-05 00:00:00	1952-11-03	1952-11-03 00:00:00	1952-11-03	38000177		0	0	90		0	0	0	185847	0	243670	19059056		
4525	376	19078461	2014-04-01	2014-04-01 00:00:00	2014-05-06	2014-05-06 00:00:00	2014-05-06	38000177		0	0	35		0	0	0	24942	0	310965	19078461		
71120	1556	40213296	2013-11-21	2013-11-21 00:00:00	2013-11-21	2013-11-21 00:00:00	2013-11-21	581452		0	0	0		0	0	0	104214	0	52	40213296		
45448	3759	19128065	1979-08-01	1979-08-01 00:00:00	1980-07-26	1980-07-26 00:00:00	1980-07-26	38000177		0	0	360		0	0	0	249859	0	749882	19128065		
47357	3926	920300	1991-10-29	1991-10-29 00:00:00	1991-11-05	1991-11-05 00:00:00	1991-11-05	38000177		0	0	7		0	0	0	260985	0	311989	920300		
18680	1542	19078461	1978-02-19	1978-02-19 00:00:00	1978-03-05	1978-03-05 00:00:00	1978-03-05	38000177		0	0	14		0	0	0	103303	0	310965	19078461		
56541	4690	920334	2012-09-02	2012-09-02 00:00:00	2012-09-09	2012-09-09 00:00:00	2012-09-09	38000177		0	0	7		0	0	0	312496	0	311995	920334		
6415	539	1127433	1972-12-15	1972-12-15 00:00:00	1972-12-22	1972-12-22 00:00:00	1972-12-22	38000177		0	0	7		0	0	0	35772	0	313782	1127433		
4175	347	1118084	2011-12-28	2011-12-28 00:00:00	2011-12-28	2011-12-28 00:00:00	\N	38000177		0	0	0		0	0	0	23111	0	00025152531	44923712		
15822	1316	1127078	1950-08-24	1950-08-24 00:00:00	1950-09-07	1950-09-07 00:00:00	1950-09-07	38000177		0	0	14		0	0	0	87230	0	282464	1127078		
15872	1318	40229134	1944-05-13	1944-05-13 00:00:00	1944-05-27	1944-05-27 00:00:00	1944-05-27	38000177		0	0	14		0	0	0	87338	0	1043400	40229134		
59788	4971	19075601	1997-11-18	1997-11-18 00:00:00	2007-09-04	2007-09-04 00:00:00	2007-09-04	38000177		0	0	3577		0	0	0	330578	0	309362	19075601		
15967	1323	1127433	2018-06-18	2018-06-18 00:00:00	2018-07-16	2018-07-16 00:00:00	2018-07-16	38000177		0	0	28		0	0	0	87850	0	313782	1127433		
58919	1289	40213227	2004-03-23	2004-03-23 00:00:00	2004-03-23	2004-03-23 00:00:00	2004-03-23	581452		0	0	0		0	0	0	85227	0	113	40213227		
2174	173	19133873	1968-04-27	1968-04-27 00:00:00	1968-05-04	1968-05-04 00:00:00	1968-05-04	38000177		0	0	7		0	0	0	11764	0	834061	19133873		
11403	950	19078461	1988-03-02	1988-03-02 00:00:00	1988-05-31	1988-05-31 00:00:00	1988-05-31	38000177		0	0	90		0	0	0	63099	0	310965	19078461		
3306	72	40213227	2018-11-12	2018-11-12 00:00:00	2018-11-12	2018-11-12 00:00:00	2018-11-12	581452		0	0	0		0	0	0	4881	0	113	40213227		
25498	2094	19006318	1945-02-02	1945-02-02 00:00:00	1945-02-16	1945-02-16 00:00:00	1945-02-16	38000177		0	0	14		0	0	0	139588	0	105078	19006318		
25554	2100	1127433	1954-07-12	1954-07-12 00:00:00	1954-07-19	1954-07-19 00:00:00	1954-07-19	38000177		0	0	7		0	0	0	140033	0	313782	1127433		
57610	4784	1127433	2010-07-18	2010-07-18 00:00:00	2010-08-01	2010-08-01 00:00:00	2010-08-01	38000177		0	0	14		0	0	0	318484	0	313782	1127433		
57682	4792	1127433	1950-05-21	1950-05-21 00:00:00	1950-06-04	1950-06-04 00:00:00	1950-06-04	38000177		0	0	14		0	0	0	318830	0	313782	1127433		
48874	4052	19008572	1979-06-15	1979-06-15 00:00:00	1979-07-06	1979-07-06 00:00:00	1979-07-06	38000177		0	0	21		0	0	0	269334	0	106258	19008572		
13134	1102	1127433	2013-10-26	2013-10-26 00:00:00	2013-11-09	2013-11-09 00:00:00	2013-11-09	38000177		0	0	14		0	0	0	72468	0	313782	1127433		
33154	2749	1127433	1978-09-05	1978-09-05 00:00:00	1978-09-19	1978-09-19 00:00:00	1978-09-19	38000177		0	0	14		0	0	0	181847	0	313782	1127433		
35002	763	40213160	1970-02-26	1970-02-26 00:00:00	1970-02-26	1970-02-26 00:00:00	1970-02-26	581452		0	0	0		0	0	0	50772	0	10	40213160		
70841	1550	40213160	1969-04-19	1969-04-19 00:00:00	1969-04-19	1969-04-19 00:00:00	1969-04-19	581452		0	0	0		0	0	0	103752	0	10	40213160		
58440	4853	1124300	1999-04-20	1999-04-20 00:00:00	1999-04-20	1999-04-20 00:00:00	\N	38000177		0	0	0		0	0	0	322926	0	00781178901	45011828		
57326	4757	19078461	2004-05-27	2004-05-27 00:00:00	2004-06-17	2004-06-17 00:00:00	2004-06-17	38000177		0	0	21		0	0	0	316964	0	310965	19078461		
6115	512	1127433	1969-01-29	1969-01-29 00:00:00	1969-02-28	1969-02-28 00:00:00	1969-02-28	38000177		0	0	30		0	0	0	34169	0	313782	1127433		
44704	3700	46233988	1971-04-02	1971-04-02 00:00:00	1971-04-16	1971-04-16 00:00:00	1971-04-16	38000177		0	0	14		0	0	0	245968	0	1652673	46233988		
31421	685	40213227	2008-02-18	2008-02-18 00:00:00	2008-02-18	2008-02-18 00:00:00	2008-02-18	581452		0	0	0		0	0	0	45277	0	113	40213227		
7172	603	1115171	2015-09-29	2015-09-29 00:00:00	2015-10-20	2015-10-20 00:00:00	2015-10-20	38000177		0	0	21		0	0	0	39933	0	849574	1115171		
144149	3168	40213314	1980-06-28	1980-06-28 00:00:00	1980-06-28	1980-06-28 00:00:00	1980-06-28	581452		0	0	0		0	0	0	210625	0	49	40213314		
7289	610	1127433	1989-12-02	1989-12-02 00:00:00	1989-12-23	1989-12-23 00:00:00	1989-12-23	38000177		0	0	21		0	0	0	40480	0	313782	1127433		
48177	3993	920300	1965-03-01	1965-03-01 00:00:00	1965-03-08	1965-03-08 00:00:00	1965-03-08	38000177		0	0	7		0	0	0	265525	0	311989	920300		
27347	2261	19059056	1964-02-03	1964-02-03 00:00:00	1964-02-17	1964-02-17 00:00:00	1964-02-17	38000177		0	0	14		0	0	0	150303	0	243670	19059056		
3059	248	19059056	1975-06-17	1975-06-17 00:00:00	1975-07-01	1975-07-01 00:00:00	1975-07-01	38000177		0	0	14		0	0	0	16710	0	243670	19059056		
7779	651	19133873	1988-11-29	1988-11-29 00:00:00	1988-12-06	1988-12-06 00:00:00	1988-12-06	38000177		0	0	7		0	0	0	43107	0	834061	19133873		
49126	4077	40229134	1990-11-04	1990-11-04 00:00:00	1990-11-18	1990-11-18 00:00:00	1990-11-18	38000177		0	0	14		0	0	0	270912	0	1043400	40229134		
27406	2267	1118084	2009-11-17	2009-11-17 00:00:00	2009-11-17	2009-11-17 00:00:00	\N	38000177		0	0	0		0	0	0	150684	0	00025152531	44923712		
13714	1146	1127078	1959-12-11	1959-12-11 00:00:00	1959-12-25	1959-12-25 00:00:00	1959-12-25	38000177		0	0	14		0	0	0	75748	0	282464	1127078		
160483	3531	40213227	2018-04-04	2018-04-04 00:00:00	2018-04-04	2018-04-04 00:00:00	2018-04-04	581452		0	0	0		0	0	0	234516	0	113	40213227		
19996	1641	19059056	1956-09-11	1956-09-11 00:00:00	1956-10-16	1956-10-16 00:00:00	1956-10-16	38000177		0	0	35		0	0	0	110172	0	243670	19059056		
41725	3455	1115171	2017-09-02	2017-09-02 00:00:00	2017-10-07	2017-10-07 00:00:00	2017-10-07	38000177		0	0	35		0	0	0	229218	0	849574	1115171		
27135	2237	1713671	1971-12-29	1971-12-29 00:00:00	1972-01-12	1972-01-12 00:00:00	1972-01-12	38000177		0	0	14		0	0	0	148813	0	562251	1713671		
154839	3408	40213160	1970-03-16	1970-03-16 00:00:00	1970-03-16	1970-03-16 00:00:00	1970-03-16	581452		0	0	0		0	0	0	226010	0	10	40213160		
39562	3270	1127078	1974-11-30	1974-11-30 00:00:00	1974-12-14	1974-12-14 00:00:00	1974-12-14	38000177		0	0	14		0	0	0	217280	0	282464	1127078		
236837	5200	40213160	1955-11-23	1955-11-23 00:00:00	1955-11-23	1955-11-23 00:00:00	1955-11-23	581452		0	0	0		0	0	0	345913	0	10	40213160		
42530	3527	1127433	1987-09-13	1987-09-13 00:00:00	1987-09-20	1987-09-20 00:00:00	1987-09-20	38000177		0	0	7		0	0	0	234053	0	313782	1127433		
40903	3392	19128065	1983-12-12	1983-12-12 00:00:00	1984-12-06	1984-12-06 00:00:00	1984-12-06	38000177		0	0	360		0	0	0	224994	0	749882	19128065		
63118	5242	1115171	1997-12-20	1997-12-20 00:00:00	1998-01-10	1998-01-10 00:00:00	1998-01-10	38000177		0	0	21		0	0	0	348802	0	849574	1115171		
43054	3569	1127433	2005-07-04	2005-07-04 00:00:00	2005-07-11	2005-07-11 00:00:00	2005-07-11	38000177		0	0	7		0	0	0	237181	0	313782	1127433		
20803	1715	1127433	2019-03-12	2019-03-12 00:00:00	2019-04-16	2019-04-16 00:00:00	2019-04-16	38000177		0	0	35		0	0	0	114557	0	313782	1127433		
63914	5309	1539411	1991-04-22	1991-04-22 00:00:00	1991-04-22	1991-04-22 00:00:00	\N	38000177		0	0	0		0	0	0	353140	0	312961	1539411		
53244	4423	40243436	1989-04-21	1989-04-21 00:00:00	1989-04-21	1989-04-21 00:00:00	1989-04-21	38000177		0	0	0		0	0	0	294121	0	1190795	40243436		
58983	4899	1713671	1931-05-28	1931-05-28 00:00:00	1931-06-04	1931-06-04 00:00:00	1931-06-04	38000177		0	0	7		0	0	0	325774	0	562251	1713671		
17997	1490	1713671	1960-02-03	1960-02-03 00:00:00	1960-02-24	1960-02-24 00:00:00	1960-02-24	38000177		0	0	21		0	0	0	99361	0	562251	1713671		
125648	2764	40213306	1996-07-19	1996-07-19 00:00:00	1996-07-19	1996-07-19 00:00:00	1996-07-19	581452		0	0	0		0	0	0	182763	0	43	40213306		
35664	2939	19133873	1954-03-03	1954-03-03 00:00:00	1954-03-16	1954-03-16 00:00:00	1954-03-16	38000177		0	0	13		0	0	0	195948	0	834061	19133873		
46172	3825	19075601	1998-01-02	1998-01-02 00:00:00	1998-01-02	1998-01-02 00:00:00	1998-01-02	38000177		0	0	0		0	0	0	254062	0	309362	19075601		
44945	3719	1127433	1964-02-04	1964-02-04 00:00:00	1964-02-11	1964-02-11 00:00:00	1964-02-11	38000177		0	0	7		0	0	0	247156	0	313782	1127433		
55464	4606	1127433	2018-04-10	2018-04-10 00:00:00	2018-04-17	2018-04-17 00:00:00	2018-04-17	38000177		0	0	7		0	0	0	306842	0	313782	1127433		
29598	2450	1127433	2005-07-01	2005-07-01 00:00:00	2005-07-15	2005-07-15 00:00:00	2005-07-15	38000177		0	0	14		0	0	0	162542	0	313782	1127433		
1759	141	40224805	2000-02-14	2000-02-14 00:00:00	2001-02-08	2001-02-08 00:00:00	2001-02-08	38000177		0	0	360		0	0	0	9445	0	1000126	40224805		
33908	2804	19078461	1993-02-13	1993-02-13 00:00:00	1993-03-13	1993-03-13 00:00:00	1993-03-13	38000177		0	0	28		0	0	0	185853	0	310965	19078461		
4526	376	19133873	1972-01-01	1972-01-01 00:00:00	1972-01-13	1972-01-13 00:00:00	1972-01-13	38000177		0	0	12		0	0	0	24901	0	834061	19133873		
71123	1556	40213227	2005-11-10	2005-11-10 00:00:00	2005-11-10	2005-11-10 00:00:00	2005-11-10	581452		0	0	0		0	0	0	104206	0	113	40213227		
45449	3759	1127433	1987-03-26	1987-03-26 00:00:00	1987-04-16	1987-04-16 00:00:00	1987-04-16	38000177		0	0	21		0	0	0	249879	0	313782	1127433		
47358	3926	40236824	1991-10-29	1991-10-29 00:00:00	1991-11-12	1991-11-12 00:00:00	1991-11-12	38000177		0	0	14		0	0	0	260985	0	1094107	40236824		
37411	3092	1713671	2004-08-11	2004-08-11 00:00:00	2004-09-01	2004-09-01 00:00:00	2004-09-01	38000177		0	0	21		0	0	0	205842	0	562251	1713671		
56542	4690	19059056	1974-01-20	1974-01-20 00:00:00	1974-02-10	1974-02-10 00:00:00	1974-02-10	38000177		0	0	21		0	0	0	312491	0	243670	19059056		
6416	539	40165015	1956-01-02	1956-01-02 00:00:00	1956-01-02	1956-01-02 00:00:00	\N	38000177		0	0	0		0	0	0	35859	0	861467	40165015		
4176	348	19133873	1986-03-16	1986-03-16 00:00:00	1986-03-27	1986-03-27 00:00:00	1986-03-27	38000177		0	0	11		0	0	0	23141	0	834061	19133873		
15823	1316	19006318	1950-08-24	1950-08-24 00:00:00	1950-09-07	1950-09-07 00:00:00	1950-09-07	38000177		0	0	14		0	0	0	87230	0	105078	19006318		
15873	1318	1127433	1998-06-06	1998-06-06 00:00:00	1998-06-13	1998-06-13 00:00:00	1998-06-13	38000177		0	0	7		0	0	0	87346	0	313782	1127433		
59789	4971	40173590	2015-02-24	2015-02-24 00:00:00	2015-02-24	2015-02-24 00:00:00	\N	38000177		0	0	0		0	0	0	330583	0	904419	40173590		
15968	1323	1127433	2011-08-23	2011-08-23 00:00:00	2011-09-06	2011-09-06 00:00:00	2011-09-06	38000177		0	0	14		0	0	0	87852	0	313782	1127433		
58920	1289	40213160	1962-11-20	1962-11-20 00:00:00	1962-11-20	1962-11-20 00:00:00	1962-11-20	581452		0	0	0		0	0	0	85169	0	10	40213160		
2185	176	40229134	2013-07-21	2013-07-21 00:00:00	2013-07-28	2013-07-28 00:00:00	2013-07-28	38000177		0	0	7		0	0	0	11907	0	1043400	40229134		
11404	950	1713671	1984-12-20	1984-12-20 00:00:00	1984-12-27	1984-12-27 00:00:00	1984-12-27	38000177		0	0	7		0	0	0	63127	0	562251	1713671		
3308	72	40213160	1955-07-11	1955-07-11 00:00:00	1955-07-11	1955-07-11 00:00:00	1955-07-11	581452		0	0	0		0	0	0	4907	0	10	40213160		
25499	2094	19059056	1945-02-02	1945-02-02 00:00:00	1945-02-16	1945-02-16 00:00:00	1945-02-16	38000177		0	0	14		0	0	0	139588	0	243670	19059056		
25555	2100	1713671	1955-02-27	1955-02-27 00:00:00	1955-03-06	1955-03-06 00:00:00	1955-03-06	38000177		0	0	7		0	0	0	139932	0	562251	1713671		
57611	4784	1127433	1996-03-02	1996-03-02 00:00:00	1996-03-16	1996-03-16 00:00:00	1996-03-16	38000177		0	0	14		0	0	0	318481	0	313782	1127433		
57683	4792	1127433	2017-04-03	2017-04-03 00:00:00	2017-04-24	2017-04-24 00:00:00	2017-04-24	38000177		0	0	21		0	0	0	318829	0	313782	1127433		
48875	4052	19073183	1985-07-20	1985-07-20 00:00:00	1985-08-03	1985-08-03 00:00:00	1985-08-03	38000177		0	0	14		0	0	0	269348	0	308182	19073183		
13135	1102	40231925	2003-02-21	2003-02-21 00:00:00	2003-02-21	2003-02-21 00:00:00	\N	38000177		0	0	0		0	0	0	72384	0	1049221	40231925		
33155	2749	1115171	2007-10-13	2007-10-13 00:00:00	2007-10-27	2007-10-27 00:00:00	2007-10-27	38000177		0	0	14		0	0	0	181829	0	849574	1115171		
35007	763	40213260	2015-03-19	2015-03-19 00:00:00	2015-03-19	2015-03-19 00:00:00	2015-03-19	581452		0	0	0		0	0	0	50778	0	121	40213260		
70843	1550	40213306	1991-02-02	1991-02-02 00:00:00	1991-02-02	1991-02-02 00:00:00	1991-02-02	581452		0	0	0		0	0	0	103778	0	43	40213306		
58441	4853	1713671	2009-11-17	2009-11-17 00:00:00	2009-12-08	2009-12-08 00:00:00	2009-12-08	38000177		0	0	21		0	0	0	322874	0	562251	1713671		
57327	4758	1127078	1962-09-22	1962-09-22 00:00:00	1962-10-06	1962-10-06 00:00:00	1962-10-06	38000177		0	0	14		0	0	0	317010	0	282464	1127078		
6116	512	19059056	1956-03-10	1956-03-10 00:00:00	1956-04-07	1956-04-07 00:00:00	1956-04-07	38000177		0	0	28		0	0	0	34167	0	243670	19059056		
44705	3700	1127078	1971-04-02	1971-04-02 00:00:00	1971-04-16	1971-04-16 00:00:00	1971-04-16	38000177		0	0	14		0	0	0	245968	0	282464	1127078		
31422	685	40213296	2008-02-18	2008-02-18 00:00:00	2008-02-18	2008-02-18 00:00:00	2008-02-18	581452		0	0	0		0	0	0	45277	0	52	40213296		
7173	603	1127433	2002-06-04	2002-06-04 00:00:00	2002-06-11	2002-06-11 00:00:00	2002-06-11	38000177		0	0	7		0	0	0	40005	0	313782	1127433		
49159	1077	40213227	2017-12-01	2017-12-01 00:00:00	2017-12-01	2017-12-01 00:00:00	2017-12-01	581452		0	0	0		0	0	0	70625	0	113	40213227		
7290	610	19133873	1973-08-27	1973-08-27 00:00:00	1973-09-03	1973-09-03 00:00:00	1973-09-03	38000177		0	0	7		0	0	0	40578	0	834061	19133873		
48178	3993	1127433	1976-08-11	1976-08-11 00:00:00	1976-08-25	1976-08-25 00:00:00	1976-08-25	38000177		0	0	14		0	0	0	265542	0	313782	1127433		
27348	2261	19059056	1990-11-30	1990-11-30 00:00:00	1990-12-14	1990-12-14 00:00:00	1990-12-14	38000177		0	0	14		0	0	0	150316	0	243670	19059056		
3060	248	19078461	1990-04-29	1990-04-29 00:00:00	1990-07-28	1990-07-28 00:00:00	1990-07-28	38000177		0	0	90		0	0	0	16666	0	310965	19078461		
7780	651	19128022	1992-04-26	1992-04-26 00:00:00	1993-04-21	1993-04-21 00:00:00	1993-04-21	38000177		0	0	360		0	0	0	43111	0	749785	19128022		
49127	4077	1127433	2006-01-12	2006-01-12 00:00:00	2006-01-26	2006-01-26 00:00:00	2006-01-26	38000177		0	0	14		0	0	0	270893	0	313782	1127433		
27407	2267	1713671	2008-10-14	2008-10-14 00:00:00	2008-11-04	2008-11-04 00:00:00	2008-11-04	38000177		0	0	21		0	0	0	150684	0	562251	1713671		
13715	1146	19006318	1959-12-11	1959-12-11 00:00:00	1959-12-25	1959-12-25 00:00:00	1959-12-25	38000177		0	0	14		0	0	0	75748	0	105078	19006318		
160484	3531	40213260	2018-04-04	2018-04-04 00:00:00	2018-04-04	2018-04-04 00:00:00	2018-04-04	581452		0	0	0		0	0	0	234516	0	121	40213260		
19997	1641	19059056	1962-06-17	1962-06-17 00:00:00	1962-07-24	1962-07-24 00:00:00	1962-07-24	38000177		0	0	37		0	0	0	110173	0	243670	19059056		
41726	3455	1118084	2009-11-02	2009-11-02 00:00:00	2009-11-02	2009-11-02 00:00:00	\N	38000177		0	0	0		0	0	0	229227	0	00025152531	44923712		
27136	2237	19133905	1955-10-18	1955-10-18 00:00:00	1955-10-31	1955-10-31 00:00:00	1955-10-31	38000177		0	0	13		0	0	0	148760	0	834102	19133905		
154844	3408	40213160	1974-06-17	1974-06-17 00:00:00	1974-06-17	1974-06-17 00:00:00	1974-06-17	581452		0	0	0		0	0	0	226028	0	10	40213160		
39563	3270	1115171	1995-06-13	1995-06-13 00:00:00	1995-07-18	1995-07-18 00:00:00	1995-07-18	38000177		0	0	35		0	0	0	217351	0	849574	1115171		
236843	5200	40213227	2016-10-19	2016-10-19 00:00:00	2016-10-19	2016-10-19 00:00:00	2016-10-19	581452		0	0	0		0	0	0	345863	0	113	40213227		
42531	3527	1551192	1962-03-10	1962-03-10 00:00:00	1962-03-10	1962-03-10 00:00:00	1962-03-10	38000177		0	0	0		0	0	0	234045	0	312617	1551192		
40904	3392	1127433	2013-09-12	2013-09-12 00:00:00	2013-09-19	2013-09-19 00:00:00	2013-09-19	38000177		0	0	7		0	0	0	224978	0	313782	1127433		
63119	5242	19129655	1964-09-14	1964-09-14 00:00:00	1964-09-28	1964-09-28 00:00:00	1964-09-28	38000177		0	0	14		0	0	0	348830	0	789980	19129655		
43055	3569	40173590	2018-12-11	2018-12-11 00:00:00	2018-12-11	2018-12-11 00:00:00	\N	38000177		0	0	0		0	0	0	237138	0	904419	40173590		
20804	1715	1127433	2010-09-27	2010-09-27 00:00:00	2010-10-25	2010-10-25 00:00:00	2010-10-25	38000177		0	0	28		0	0	0	114556	0	313782	1127433		
63916	5309	19075601	1997-05-05	1997-05-05 00:00:00	1997-05-05	1997-05-05 00:00:00	\N	38000177		0	0	0		0	0	0	353131	0	309362	19075601		
53245	4423	1310034	1989-04-21	1989-04-21 00:00:00	1989-04-21	1989-04-21 00:00:00	1989-04-21	38000177		0	0	0		0	0	0	294121	0	834357	1310034		
58984	4899	19059056	1976-10-15	1976-10-15 00:00:00	1976-12-21	1976-12-21 00:00:00	1976-12-21	38000177		0	0	67		0	0	0	325810	0	243670	19059056		
17998	1490	1127433	1968-09-29	1968-09-29 00:00:00	1968-10-13	1968-10-13 00:00:00	1968-10-13	38000177		0	0	14		0	0	0	99381	0	313782	1127433		
125650	2764	40213227	1996-07-19	1996-07-19 00:00:00	1996-07-19	1996-07-19 00:00:00	1996-07-19	581452		0	0	0		0	0	0	182763	0	113	40213227		
35665	2939	19133905	1977-08-06	1977-08-06 00:00:00	1977-08-17	1977-08-17 00:00:00	1977-08-17	38000177		0	0	11		0	0	0	195950	0	834102	19133905		
46173	3825	40220960	1998-01-02	1998-01-02 00:00:00	1998-01-02	1998-01-02 00:00:00	1998-01-02	38000177		0	0	0		0	0	0	254062	0	1804799	40220960		
44946	3719	1118084	2003-08-16	2003-08-16 00:00:00	2003-08-16	2003-08-16 00:00:00	\N	38000177		0	0	0		0	0	0	247196	0	00025152531	44923712		
55465	4606	1127078	1992-05-12	1992-05-12 00:00:00	1992-06-09	1992-06-09 00:00:00	1992-06-09	38000177		0	0	28		0	0	0	306865	0	282464	1127078		
29599	2450	1127433	1984-05-18	1984-05-18 00:00:00	1984-06-01	1984-06-01 00:00:00	1984-06-01	38000177		0	0	14		0	0	0	162539	0	313782	1127433		
1760	141	1127078	1995-07-30	1995-07-30 00:00:00	1995-09-28	1995-09-28 00:00:00	1995-09-28	38000177		0	0	60		0	0	0	9484	0	282464	1127078		
33909	2804	19078461	1996-02-26	1996-02-26 00:00:00	1996-03-11	1996-03-11 00:00:00	1996-03-11	38000177		0	0	14		0	0	0	185854	0	310965	19078461		
4527	376	19059056	1965-04-06	1965-04-06 00:00:00	1965-07-05	1965-07-05 00:00:00	1965-07-05	38000177		0	0	90		0	0	0	24938	0	243670	19059056		
71130	1556	40213160	1973-07-05	1973-07-05 00:00:00	1973-07-05	1973-07-05 00:00:00	1973-07-05	581452		0	0	0		0	0	0	104158	0	10	40213160		
45450	3759	1127433	2010-07-05	2010-07-05 00:00:00	2010-07-19	2010-07-19 00:00:00	2010-07-19	38000177		0	0	14		0	0	0	249975	0	313782	1127433		
47359	3926	1127433	1977-02-14	1977-02-14 00:00:00	1977-03-14	1977-03-14 00:00:00	1977-03-14	38000177		0	0	28		0	0	0	261009	0	313782	1127433		
37412	3092	19129655	1961-01-07	1961-01-07 00:00:00	1961-01-21	1961-01-21 00:00:00	1961-01-21	38000177		0	0	14		0	0	0	205894	0	789980	19129655		
56543	4690	40173590	2016-10-01	2016-10-01 00:00:00	2016-10-01	2016-10-01 00:00:00	\N	38000177		0	0	0		0	0	0	312474	0	904419	40173590		
6417	539	1539411	1991-02-03	1991-02-03 00:00:00	1991-02-03	1991-02-03 00:00:00	\N	38000177		0	0	0		0	0	0	35833	0	312961	1539411		
4177	348	1127433	1990-01-10	1990-01-10 00:00:00	1990-04-10	1990-04-10 00:00:00	1990-04-10	38000177		0	0	90		0	0	0	23116	0	313782	1127433		
15824	1316	1127433	2004-07-26	2004-07-26 00:00:00	2004-08-09	2004-08-09 00:00:00	2004-08-09	38000177		0	0	14		0	0	0	87156	0	313782	1127433		
15874	1318	1127433	2014-06-20	2014-06-20 00:00:00	2014-07-04	2014-07-04 00:00:00	2014-07-04	38000177		0	0	14		0	0	0	87348	0	313782	1127433		
59790	4971	19059056	1971-07-06	1971-07-06 00:00:00	1971-08-03	1971-08-03 00:00:00	1971-08-03	38000177		0	0	28		0	0	0	330511	0	243670	19059056		
15969	1323	1127433	1977-12-08	1977-12-08 00:00:00	1977-12-29	1977-12-29 00:00:00	1977-12-29	38000177		0	0	21		0	0	0	87845	0	313782	1127433		
58933	1289	40213296	2002-03-19	2002-03-19 00:00:00	2002-03-19	2002-03-19 00:00:00	2002-03-19	581452		0	0	0		0	0	0	85221	0	52	40213296		
2186	176	1127078	1975-05-16	1975-05-16 00:00:00	1975-07-22	1975-07-22 00:00:00	1975-07-22	38000177		0	0	67		0	0	0	11929	0	282464	1127078		
237112	5206	40213160	1980-12-06	1980-12-06 00:00:00	1980-12-06	1980-12-06 00:00:00	1980-12-06	581452		0	0	0		0	0	0	346276	0	10	40213160		
3331	72	40213198	2012-10-08	2012-10-08 00:00:00	2012-10-08	2012-10-08 00:00:00	2012-10-08	581452		0	0	0		0	0	0	4875	0	133	40213198		
25500	2094	1127433	1989-12-09	1989-12-09 00:00:00	1989-12-16	1989-12-16 00:00:00	1989-12-16	38000177		0	0	7		0	0	0	139595	0	313782	1127433		
25556	2100	1127433	2015-04-01	2015-04-01 00:00:00	2015-04-15	2015-04-15 00:00:00	2015-04-15	38000177		0	0	14		0	0	0	140013	0	313782	1127433		
57612	4784	19078461	2009-11-22	2009-11-22 00:00:00	2009-12-13	2009-12-13 00:00:00	2009-12-13	38000177		0	0	21		0	0	0	318452	0	310965	19078461		
57684	4792	1127433	1990-09-17	1990-09-17 00:00:00	1990-10-22	1990-10-22 00:00:00	1990-10-22	38000177		0	0	35		0	0	0	318828	0	313782	1127433		
48876	4052	1127078	1985-07-20	1985-07-20 00:00:00	1985-08-03	1985-08-03 00:00:00	1985-08-03	38000177		0	0	14		0	0	0	269348	0	282464	1127078		
13136	1102	1127433	1970-10-06	1970-10-06 00:00:00	1970-10-20	1970-10-20 00:00:00	1970-10-20	38000177		0	0	14		0	0	0	72365	0	313782	1127433		
33156	2749	1127433	2014-03-29	2014-03-29 00:00:00	2014-04-05	2014-04-05 00:00:00	2014-04-05	38000177		0	0	7		0	0	0	181834	0	313782	1127433		
35024	764	40213160	1974-06-25	1974-06-25 00:00:00	1974-06-25	1974-06-25 00:00:00	1974-06-25	581452		0	0	0		0	0	0	50831	0	10	40213160		
70847	1550	40213160	1969-06-21	1969-06-21 00:00:00	1969-06-21	1969-06-21 00:00:00	1969-06-21	581452		0	0	0		0	0	0	103759	0	10	40213160		
58454	4855	1127078	1982-11-19	1982-11-19 00:00:00	1982-12-03	1982-12-03 00:00:00	1982-12-03	38000177		0	0	14		0	0	0	322999	0	282464	1127078		
57328	4758	19059056	1958-05-08	1958-05-08 00:00:00	1958-05-22	1958-05-22 00:00:00	1958-05-22	38000177		0	0	14		0	0	0	317030	0	243670	19059056		
6117	512	1127433	2013-06-07	2013-06-07 00:00:00	2013-06-14	2013-06-14 00:00:00	2013-06-14	38000177		0	0	7		0	0	0	34220	0	313782	1127433		
44706	3700	1127433	1973-12-23	1973-12-23 00:00:00	1974-01-06	1974-01-06 00:00:00	1974-01-06	38000177		0	0	14		0	0	0	245970	0	313782	1127433		
31428	685	40213160	1971-01-18	1971-01-18 00:00:00	1971-01-18	1971-01-18 00:00:00	1971-01-18	581452		0	0	0		0	0	0	45268	0	10	40213160		
7174	603	1713671	2009-04-07	2009-04-07 00:00:00	2009-04-21	2009-04-21 00:00:00	2009-04-21	38000177		0	0	14		0	0	0	40007	0	562251	1713671		
49165	1077	40213227	2007-10-05	2007-10-05 00:00:00	2007-10-05	2007-10-05 00:00:00	2007-10-05	581452		0	0	0		0	0	0	70612	0	113	40213227		
7291	610	40236824	2013-09-15	2013-09-15 00:00:00	2013-09-22	2013-09-22 00:00:00	2013-09-22	38000177		0	0	7		0	0	0	40542	0	1094107	40236824		
48179	3993	1115171	1999-03-13	1999-03-13 00:00:00	1999-04-03	1999-04-03 00:00:00	1999-04-03	38000177		0	0	21		0	0	0	265522	0	849574	1115171		
27349	2261	19075001	1990-11-30	1990-11-30 00:00:00	1990-12-14	1990-12-14 00:00:00	1990-12-14	38000177		0	0	14		0	0	0	150316	0	309097	19075001		
3061	248	40165015	1990-04-29	1990-04-29 00:00:00	1990-04-29	1990-04-29 00:00:00	\N	38000177		0	0	0		0	0	0	16666	0	861467	40165015		
7781	651	19059056	1983-04-04	1983-04-04 00:00:00	1983-04-18	1983-04-18 00:00:00	1983-04-18	38000177		0	0	14		0	0	0	43087	0	243670	19059056		
49128	4077	1118084	2010-10-14	2010-10-14 00:00:00	2010-10-14	2010-10-14 00:00:00	\N	38000177		0	0	0		0	0	0	270900	0	00025152531	44923712		
27431	2270	19128065	1994-05-17	1994-05-17 00:00:00	1995-05-12	1995-05-12 00:00:00	1995-05-12	38000177		0	0	360		0	0	0	150969	0	749882	19128065		
13716	1146	19133873	1967-04-15	1967-04-15 00:00:00	1967-04-27	1967-04-27 00:00:00	1967-04-27	38000177		0	0	12		0	0	0	75715	0	834061	19133873		
160488	3532	40213296	2012-07-22	2012-07-22 00:00:00	2012-07-22	2012-07-22 00:00:00	2012-07-22	581452		0	0	0		0	0	0	234608	0	52	40213296		
19998	1641	19059056	1957-07-08	1957-07-08 00:00:00	1957-07-22	1957-07-22 00:00:00	1957-07-22	38000177		0	0	14		0	0	0	110196	0	243670	19059056		
41727	3455	1713671	1979-08-08	1979-08-08 00:00:00	1979-08-29	1979-08-29 00:00:00	1979-08-29	38000177		0	0	21		0	0	0	229233	0	562251	1713671		
27137	2237	920300	1971-01-13	1971-01-13 00:00:00	1971-01-20	1971-01-20 00:00:00	1971-01-20	38000177		0	0	7		0	0	0	148763	0	311989	920300		
154845	3408	40213160	1969-12-15	1969-12-15 00:00:00	1969-12-15	1969-12-15 00:00:00	1969-12-15	581452		0	0	0		0	0	0	226024	0	10	40213160		
39570	3272	19128065	1988-05-19	1988-05-19 00:00:00	1989-05-14	1989-05-14 00:00:00	1989-05-14	38000177		0	0	360		0	0	0	217431	0	749882	19128065		
236844	5200	40213260	2007-08-29	2007-08-29 00:00:00	2007-08-29	2007-08-29 00:00:00	2007-08-29	581452		0	0	0		0	0	0	345929	0	121	40213260		
42532	3527	19059056	1979-01-15	1979-01-15 00:00:00	1979-04-15	1979-04-15 00:00:00	1979-04-15	38000177		0	0	90		0	0	0	234050	0	243670	19059056		
40905	3392	920300	1997-01-21	1997-01-21 00:00:00	1997-01-28	1997-01-28 00:00:00	1997-01-28	38000177		0	0	7		0	0	0	224990	0	311989	920300		
63120	5242	1127078	1964-09-14	1964-09-14 00:00:00	1964-09-28	1964-09-28 00:00:00	1964-09-28	38000177		0	0	14		0	0	0	348830	0	282464	1127078		
43056	3569	1118084	1999-09-10	1999-09-10 00:00:00	1999-09-10	1999-09-10 00:00:00	\N	38000177		0	0	0		0	0	0	237180	0	00025152531	44923712		
20805	1716	19059056	1978-11-13	1978-11-13 00:00:00	1978-12-04	1978-12-04 00:00:00	1978-12-04	38000177		0	0	21		0	0	0	114704	0	243670	19059056		
63917	5309	19126352	1988-12-26	1988-12-26 00:00:00	1988-12-26	1988-12-26 00:00:00	\N	38000177		0	0	0		0	0	0	353129	0	705129	19126352		
53246	4423	40229134	2001-10-15	2001-10-15 00:00:00	2001-10-29	2001-10-29 00:00:00	2001-10-29	38000177		0	0	14		0	0	0	294088	0	1043400	40229134		
58985	4899	19059056	1924-07-24	1924-07-24 00:00:00	1924-08-07	1924-08-07 00:00:00	1924-08-07	38000177		0	0	14		0	0	0	325842	0	243670	19059056		
17999	1491	19075601	1997-02-18	1997-02-18 00:00:00	2011-07-12	2011-07-12 00:00:00	2011-07-12	38000177		0	0	5257		0	0	0	99447	0	309362	19075601		
125651	2764	40213160	1974-02-01	1974-02-01 00:00:00	1974-02-01	1974-02-01 00:00:00	1974-02-01	581452		0	0	0		0	0	0	182758	0	10	40213160		
35666	2939	1124300	1997-10-31	1997-10-31 00:00:00	1997-10-31	1997-10-31 00:00:00	\N	38000177		0	0	0		0	0	0	195924	0	00781178901	45011828		
46174	3825	1127433	1992-06-06	1992-06-06 00:00:00	1992-06-13	1992-06-13 00:00:00	1992-06-13	38000177		0	0	7		0	0	0	254038	0	313782	1127433		
44947	3719	1127078	1968-11-07	1968-11-07 00:00:00	1968-12-07	1968-12-07 00:00:00	1968-12-07	38000177		0	0	30		0	0	0	247203	0	282464	1127078		
55466	4606	1118084	2016-12-17	2016-12-17 00:00:00	2016-12-17	2016-12-17 00:00:00	\N	38000177		0	0	0		0	0	0	306871	0	00025152531	44923712		
29600	2450	1127433	1994-05-22	1994-05-22 00:00:00	1994-05-29	1994-05-29 00:00:00	1994-05-29	38000177		0	0	7		0	0	0	162540	0	313782	1127433		
1761	141	1127078	1987-01-13	1987-01-13 00:00:00	1987-01-27	1987-01-27 00:00:00	1987-01-27	38000177		0	0	14		0	0	0	9469	0	282464	1127078		
33910	2804	40229134	1961-06-07	1961-06-07 00:00:00	1961-06-21	1961-06-21 00:00:00	1961-06-21	38000177		0	0	14		0	0	0	185878	0	1043400	40229134		
4528	376	19059056	1969-02-14	1969-02-14 00:00:00	1969-05-15	1969-05-15 00:00:00	1969-05-15	38000177		0	0	90		0	0	0	24939	0	243670	19059056		
71133	1556	40213227	2015-11-26	2015-11-26 00:00:00	2015-11-26	2015-11-26 00:00:00	2015-11-26	581452		0	0	0		0	0	0	104166	0	113	40213227		
45451	3759	1124300	2009-03-16	2009-03-16 00:00:00	2009-03-16	2009-03-16 00:00:00	\N	38000177		0	0	0		0	0	0	249880	0	00781178901	45011828		
47360	3926	40169281	1984-10-15	1984-10-15 00:00:00	1984-10-15	1984-10-15 00:00:00	\N	38000177		0	0	0		0	0	0	260949	0	896209	40169281		
37413	3092	19059056	1961-01-07	1961-01-07 00:00:00	1961-01-21	1961-01-21 00:00:00	1961-01-21	38000177		0	0	14		0	0	0	205894	0	243670	19059056		
56544	4690	19078461	1992-05-04	1992-05-04 00:00:00	1992-05-25	1992-05-25 00:00:00	1992-05-25	38000177		0	0	21		0	0	0	312468	0	310965	19078461		
6418	539	1127433	1986-08-11	1986-08-11 00:00:00	1986-08-25	1986-08-25 00:00:00	1986-08-25	38000177		0	0	14		0	0	0	35784	0	313782	1127433		
4178	348	40162522	1990-01-10	1990-01-10 00:00:00	1990-01-10	1990-01-10 00:00:00	\N	38000177		0	0	0		0	0	0	23116	0	857005	40162522		
15826	1316	19133905	2004-08-16	2004-08-16 00:00:00	2004-08-26	2004-08-26 00:00:00	2004-08-26	38000177		0	0	10		0	0	0	87229	0	834102	19133905		
15875	1318	19059056	1943-04-04	1943-04-04 00:00:00	1943-04-18	1943-04-18 00:00:00	1943-04-18	38000177		0	0	14		0	0	0	87354	0	243670	19059056		
59791	4971	19059056	1940-04-19	1940-04-19 00:00:00	1940-05-19	1940-05-19 00:00:00	1940-05-19	38000177		0	0	30		0	0	0	330662	0	243670	19059056		
15970	1323	1713671	1970-07-14	1970-07-14 00:00:00	1970-07-28	1970-07-28 00:00:00	1970-07-28	38000177		0	0	14		0	0	0	87871	0	562251	1713671		
58938	1289	40213160	1962-06-19	1962-06-19 00:00:00	1962-06-19	1962-06-19 00:00:00	1962-06-19	581452		0	0	0		0	0	0	85189	0	10	40213160		
2187	176	40165015	1996-04-25	1996-04-25 00:00:00	1996-04-25	1996-04-25 00:00:00	\N	38000177		0	0	0		0	0	0	11893	0	861467	40165015		
237113	5206	40213314	1977-01-22	1977-01-22 00:00:00	1977-01-22	1977-01-22 00:00:00	1977-01-22	581452		0	0	0		0	0	0	346265	0	49	40213314		
237157	5207	40213227	1997-09-24	1997-09-24 00:00:00	1997-09-24	1997-09-24 00:00:00	1997-09-24	581452		0	0	0		0	0	0	346331	0	113	40213227		
25518	2097	19059056	1982-11-04	1982-11-04 00:00:00	1982-12-02	1982-12-02 00:00:00	1982-12-02	38000177		0	0	28		0	0	0	139807	0	243670	19059056		
25557	2100	19059056	1945-01-12	1945-01-12 00:00:00	1945-01-26	1945-01-26 00:00:00	1945-01-26	38000177		0	0	14		0	0	0	139962	0	243670	19059056		
57613	4784	19059056	1958-11-10	1958-11-10 00:00:00	1958-12-15	1958-12-15 00:00:00	1958-12-15	38000177		0	0	35		0	0	0	318490	0	243670	19059056		
57685	4792	1118084	1988-10-27	1988-10-27 00:00:00	1988-10-27	1988-10-27 00:00:00	\N	38000177		0	0	0		0	0	0	318871	0	00025152531	44923712		
48877	4052	1127433	1995-01-15	1995-01-15 00:00:00	1995-01-22	1995-01-22 00:00:00	1995-01-22	38000177		0	0	7		0	0	0	269344	0	313782	1127433		
13137	1102	1713671	1981-09-04	1981-09-04 00:00:00	1981-09-11	1981-09-11 00:00:00	1981-09-11	38000177		0	0	7		0	0	0	72443	0	562251	1713671		
33157	2749	1127433	1974-04-08	1974-04-08 00:00:00	1974-04-29	1974-04-29 00:00:00	1974-04-29	38000177		0	0	21		0	0	0	181846	0	313782	1127433		
35027	764	40213160	1969-10-21	1969-10-21 00:00:00	1969-10-21	1969-10-21 00:00:00	1969-10-21	581452		0	0	0		0	0	0	50849	0	10	40213160		
70854	1550	40213260	2019-01-12	2019-01-12 00:00:00	2019-01-12	2019-01-12 00:00:00	2019-01-12	581452		0	0	0		0	0	0	103791	0	121	40213260		
58455	4855	19073183	1982-11-19	1982-11-19 00:00:00	1982-12-03	1982-12-03 00:00:00	1982-12-03	38000177		0	0	14		0	0	0	322999	0	308182	19073183		
57329	4758	19006318	1958-05-08	1958-05-08 00:00:00	1958-05-22	1958-05-22 00:00:00	1958-05-22	38000177		0	0	14		0	0	0	317030	0	105078	19006318		
6118	512	40165015	1967-03-11	1967-03-11 00:00:00	1967-03-11	1967-03-11 00:00:00	\N	38000177		0	0	0		0	0	0	34168	0	861467	40165015		
44707	3700	19073188	1982-07-31	1982-07-31 00:00:00	1982-08-14	1982-08-14 00:00:00	1982-08-14	38000177		0	0	14		0	0	0	245999	0	308192	19073188		
31430	685	40213227	2017-02-13	2017-02-13 00:00:00	2017-02-13	2017-02-13 00:00:00	2017-02-13	581452		0	0	0		0	0	0	45343	0	113	40213227		
7175	603	1127078	1964-11-22	1964-11-22 00:00:00	1964-12-20	1964-12-20 00:00:00	1964-12-20	38000177		0	0	28		0	0	0	39930	0	282464	1127078		
49173	1077	40213227	1997-08-22	1997-08-22 00:00:00	1997-08-22	1997-08-22 00:00:00	1997-08-22	581452		0	0	0		0	0	0	70631	0	113	40213227		
7292	610	920300	2013-09-15	2013-09-15 00:00:00	2013-09-22	2013-09-22 00:00:00	2013-09-22	38000177		0	0	7		0	0	0	40542	0	311989	920300		
48184	3995	46233988	1973-05-03	1973-05-03 00:00:00	1973-05-17	1973-05-17 00:00:00	1973-05-17	38000177		0	0	14		0	0	0	265617	0	1652673	46233988		
27350	2261	19059056	1964-08-12	1964-08-12 00:00:00	1964-08-26	1964-08-26 00:00:00	1964-08-26	38000177		0	0	14		0	0	0	150341	0	243670	19059056		
3062	248	40229134	1984-01-18	1984-01-18 00:00:00	1984-01-25	1984-01-25 00:00:00	1984-01-25	38000177		0	0	7		0	0	0	16724	0	1043400	40229134		
7782	651	19059056	1987-08-11	1987-08-11 00:00:00	1987-09-10	1987-09-10 00:00:00	1987-09-10	38000177		0	0	30		0	0	0	43078	0	243670	19059056		
49129	4077	19133873	1988-10-26	1988-10-26 00:00:00	1988-11-03	1988-11-03 00:00:00	1988-11-03	38000177		0	0	8		0	0	0	270890	0	834061	19133873		
27432	2270	1115171	2012-01-24	2012-01-24 00:00:00	2012-02-07	2012-02-07 00:00:00	2012-02-07	38000177		0	0	14		0	0	0	150940	0	849574	1115171		
13717	1146	19059056	1970-11-25	1970-11-25 00:00:00	1971-01-24	1971-01-24 00:00:00	1971-01-24	38000177		0	0	60		0	0	0	75740	0	243670	19059056		
160490	3532	40213227	2012-07-22	2012-07-22 00:00:00	2012-07-22	2012-07-22 00:00:00	2012-07-22	581452		0	0	0		0	0	0	234608	0	113	40213227		
19999	1641	19006318	1957-07-08	1957-07-08 00:00:00	1957-07-22	1957-07-22 00:00:00	1957-07-22	38000177		0	0	14		0	0	0	110196	0	105078	19006318		
41728	3455	40236824	1998-07-04	1998-07-04 00:00:00	1998-07-18	1998-07-18 00:00:00	1998-07-18	38000177		0	0	14		0	0	0	229242	0	1094107	40236824		
27138	2237	40236824	1971-01-13	1971-01-13 00:00:00	1971-01-20	1971-01-20 00:00:00	1971-01-20	38000177		0	0	7		0	0	0	148763	0	1094107	40236824		
154849	3408	40213160	1969-10-13	1969-10-13 00:00:00	1969-10-13	1969-10-13 00:00:00	1969-10-13	581452		0	0	0		0	0	0	226009	0	10	40213160		
39571	3272	1127433	1987-04-11	1987-04-11 00:00:00	1987-05-09	1987-05-09 00:00:00	1987-05-09	38000177		0	0	28		0	0	0	217477	0	313782	1127433		
236848	5200	40213160	1956-04-25	1956-04-25 00:00:00	1956-04-25	1956-04-25 00:00:00	1956-04-25	581452		0	0	0		0	0	0	345914	0	10	40213160		
42533	3527	40231925	1979-01-15	1979-01-15 00:00:00	1979-01-15	1979-01-15 00:00:00	\N	38000177		0	0	0		0	0	0	234050	0	1049221	40231925		
40906	3392	40236824	1997-01-21	1997-01-21 00:00:00	1997-01-28	1997-01-28 00:00:00	1997-01-28	38000177		0	0	7		0	0	0	224990	0	1094107	40236824		
63140	5245	1127433	2004-06-02	2004-06-02 00:00:00	2004-06-23	2004-06-23 00:00:00	2004-06-23	38000177		0	0	21		0	0	0	348937	0	313782	1127433		
43057	3569	1127433	2015-08-13	2015-08-13 00:00:00	2015-08-27	2015-08-27 00:00:00	2015-08-27	38000177		0	0	14		0	0	0	237184	0	313782	1127433		
20806	1716	1118084	1977-11-01	1977-11-01 00:00:00	1977-11-01	1977-11-01 00:00:00	\N	38000177		0	0	0		0	0	0	114661	0	00025152531	44923712		
63918	5309	1127078	1957-05-04	1957-05-04 00:00:00	1957-05-18	1957-05-18 00:00:00	1957-05-18	38000177		0	0	14		0	0	0	353144	0	282464	1127078		
53247	4423	1118084	2011-03-01	2011-03-01 00:00:00	2011-03-01	2011-03-01 00:00:00	\N	38000177		0	0	0		0	0	0	294118	0	00025152531	44923712		
58986	4899	1124300	1964-05-01	1964-05-01 00:00:00	1964-05-01	1964-05-01 00:00:00	\N	38000177		0	0	0		0	0	0	325791	0	00781178901	45011828		
18000	1491	19126352	1997-02-18	1997-02-18 00:00:00	2011-07-12	2011-07-12 00:00:00	2011-07-12	38000177		0	0	5257		0	0	0	99447	0	705129	19126352		
125652	2764	40213314	1977-04-15	1977-04-15 00:00:00	1977-04-15	1977-04-15 00:00:00	1977-04-15	581452		0	0	0		0	0	0	182818	0	49	40213314		
35667	2939	19059056	1964-06-21	1964-06-21 00:00:00	1964-07-19	1964-07-19 00:00:00	1964-07-19	38000177		0	0	28		0	0	0	195988	0	243670	19059056		
46176	3825	19059056	1965-10-11	1965-10-11 00:00:00	1965-10-25	1965-10-25 00:00:00	1965-10-25	38000177		0	0	14		0	0	0	254065	0	243670	19059056		
44948	3719	920300	2015-01-22	2015-01-22 00:00:00	2015-01-29	2015-01-29 00:00:00	2015-01-29	38000177		0	0	7		0	0	0	247191	0	311989	920300		
55467	4606	1127433	1987-09-07	1987-09-07 00:00:00	1987-09-14	1987-09-14 00:00:00	1987-09-14	38000177		0	0	7		0	0	0	306831	0	313782	1127433		
29601	2450	1127433	2014-03-09	2014-03-09 00:00:00	2014-04-06	2014-04-06 00:00:00	2014-04-06	38000177		0	0	28		0	0	0	162560	0	313782	1127433		
1762	141	19075001	1987-01-13	1987-01-13 00:00:00	1987-01-27	1987-01-27 00:00:00	1987-01-27	38000177		0	0	14		0	0	0	9469	0	309097	19075001		
33911	2804	40162522	1983-04-16	1983-04-16 00:00:00	1983-04-16	1983-04-16 00:00:00	\N	38000177		0	0	0		0	0	0	185857	0	857005	40162522		
4529	376	19129655	1964-03-12	1964-03-12 00:00:00	1964-03-26	1964-03-26 00:00:00	1964-03-26	38000177		0	0	14		0	0	0	24906	0	789980	19129655		
102927	2258	40213296	1999-07-08	1999-07-08 00:00:00	1999-07-08	1999-07-08 00:00:00	1999-07-08	581452		0	0	0		0	0	0	150037	0	52	40213296		
45452	3759	19078461	2008-12-21	2008-12-21 00:00:00	2009-01-25	2009-01-25 00:00:00	2009-01-25	38000177		0	0	35		0	0	0	249880	0	310965	19078461		
47362	3926	1127433	1991-08-26	1991-08-26 00:00:00	1991-09-30	1991-09-30 00:00:00	1991-09-30	38000177		0	0	35		0	0	0	261011	0	313782	1127433		
37414	3092	1118084	1994-06-02	1994-06-02 00:00:00	1994-06-02	1994-06-02 00:00:00	\N	38000177		0	0	0		0	0	0	205837	0	00025152531	44923712		
56545	4690	1127433	2007-05-05	2007-05-05 00:00:00	2007-05-26	2007-05-26 00:00:00	2007-05-26	38000177		0	0	21		0	0	0	312471	0	313782	1127433		
6419	539	1118084	1968-12-02	1968-12-02 00:00:00	1968-12-02	1968-12-02 00:00:00	\N	38000177		0	0	0		0	0	0	35805	0	00025152531	44923712		
4179	348	1118084	2010-07-09	2010-07-09 00:00:00	2010-07-09	2010-07-09 00:00:00	\N	38000177		0	0	0		0	0	0	23152	0	00025152531	44923712		
15827	1316	1127433	1985-06-02	1985-06-02 00:00:00	1985-06-09	1985-06-09 00:00:00	1985-06-09	38000177		0	0	7		0	0	0	87180	0	313782	1127433		
15876	1318	1713671	1954-09-26	1954-09-26 00:00:00	1954-10-17	1954-10-17 00:00:00	1954-10-17	38000177		0	0	21		0	0	0	87341	0	562251	1713671		
59792	4971	19059056	1936-06-25	1936-06-25 00:00:00	1936-07-09	1936-07-09 00:00:00	1936-07-09	38000177		0	0	14		0	0	0	330543	0	243670	19059056		
15971	1323	1115171	2016-04-29	2016-04-29 00:00:00	2016-05-29	2016-05-29 00:00:00	2016-05-29	38000177		0	0	30		0	0	0	87849	0	849574	1115171		
118790	2613	40213160	1960-04-22	1960-04-22 00:00:00	1960-04-22	1960-04-22 00:00:00	1960-04-22	581452		0	0	0		0	0	0	172757	0	10	40213160		
2188	176	19059056	1971-07-22	1971-07-22 00:00:00	1971-08-05	1971-08-05 00:00:00	1971-08-05	38000177		0	0	14		0	0	0	11928	0	243670	19059056		
237114	5206	40213160	1977-01-22	1977-01-22 00:00:00	1977-01-22	1977-01-22 00:00:00	1977-01-22	581452		0	0	0		0	0	0	346265	0	10	40213160		
237160	5207	40213160	1956-09-19	1956-09-19 00:00:00	1956-09-19	1956-09-19 00:00:00	1956-09-19	581452		0	0	0		0	0	0	346312	0	10	40213160		
25519	2097	19078461	1993-02-07	1993-02-07 00:00:00	1993-02-21	1993-02-21 00:00:00	1993-02-21	38000177		0	0	14		0	0	0	139808	0	310965	19078461		
25558	2100	19006318	1945-01-12	1945-01-12 00:00:00	1945-01-26	1945-01-26 00:00:00	1945-01-26	38000177		0	0	14		0	0	0	139962	0	105078	19006318		
57614	4784	1127433	1953-10-08	1953-10-08 00:00:00	1953-10-15	1953-10-15 00:00:00	1953-10-15	38000177		0	0	7		0	0	0	318455	0	313782	1127433		
57686	4792	1127433	1996-10-09	1996-10-09 00:00:00	1996-10-16	1996-10-16 00:00:00	1996-10-16	38000177		0	0	7		0	0	0	318842	0	313782	1127433		
48878	4052	40232448	1977-12-04	1977-12-04 00:00:00	1977-12-04	1977-12-04 00:00:00	\N	38000177		0	0	0		0	0	0	269373	0	1049630	40232448		
13138	1102	40232448	1970-02-13	1970-02-13 00:00:00	1970-02-13	1970-02-13 00:00:00	\N	38000177		0	0	0		0	0	0	72442	0	1049630	40232448		
33158	2749	1127433	1983-05-31	1983-05-31 00:00:00	1983-06-21	1983-06-21 00:00:00	1983-06-21	38000177		0	0	21		0	0	0	181849	0	313782	1127433		
78053	1707	40213160	1975-07-21	1975-07-21 00:00:00	1975-07-21	1975-07-21 00:00:00	1975-07-21	581452		0	0	0		0	0	0	114139	0	10	40213160		
70855	1550	40213227	1993-05-15	1993-05-15 00:00:00	1993-05-15	1993-05-15 00:00:00	1993-05-15	581452		0	0	0		0	0	0	\N	0	113	40213227		
58456	4855	40236824	2004-10-01	2004-10-01 00:00:00	2004-10-08	2004-10-08 00:00:00	2004-10-08	38000177		0	0	7		0	0	0	323019	0	1094107	40236824		
57330	4758	1127433	1999-11-11	1999-11-11 00:00:00	2000-02-09	2000-02-09 00:00:00	2000-02-09	38000177		0	0	90		0	0	0	316969	0	313782	1127433		
6119	512	19059056	1967-03-11	1967-03-11 00:00:00	1967-04-10	1967-04-10 00:00:00	1967-04-10	38000177		0	0	30		0	0	0	34168	0	243670	19059056		
44708	3700	1127433	1982-07-31	1982-07-31 00:00:00	1982-08-14	1982-08-14 00:00:00	1982-08-14	38000177		0	0	14		0	0	0	245999	0	313782	1127433		
31431	685	40213260	2017-02-13	2017-02-13 00:00:00	2017-02-13	2017-02-13 00:00:00	2017-02-13	581452		0	0	0		0	0	0	45343	0	121	40213260		
7176	603	19059056	1959-08-21	1959-08-21 00:00:00	1959-09-04	1959-09-04 00:00:00	1959-09-04	38000177		0	0	14		0	0	0	40008	0	243670	19059056		
49176	1077	40213198	2011-10-28	2011-10-28 00:00:00	2011-10-28	2011-10-28 00:00:00	2011-10-28	581452		0	0	0		0	0	0	70635	0	133	40213198		
7293	610	19133873	1966-09-09	1966-09-09 00:00:00	1966-09-18	1966-09-18 00:00:00	1966-09-18	38000177		0	0	9		0	0	0	40474	0	834061	19133873		
48185	3995	1127078	1973-05-03	1973-05-03 00:00:00	1973-05-17	1973-05-17 00:00:00	1973-05-17	38000177		0	0	14		0	0	0	265617	0	282464	1127078		
27351	2261	19006318	1964-08-12	1964-08-12 00:00:00	1964-08-26	1964-08-26 00:00:00	1964-08-26	38000177		0	0	14		0	0	0	150341	0	105078	19006318		
3063	248	1713671	1998-12-28	1998-12-28 00:00:00	1999-01-18	1999-01-18 00:00:00	1999-01-18	38000177		0	0	21		0	0	0	16707	0	562251	1713671		
7783	651	1310034	1999-01-28	1999-01-28 00:00:00	1999-01-28	1999-01-28 00:00:00	1999-01-28	38000177		0	0	0		0	0	0	43079	0	834357	1310034		
49130	4077	1127433	1971-11-30	1971-11-30 00:00:00	1971-12-14	1971-12-14 00:00:00	1971-12-14	38000177		0	0	14		0	0	0	270889	0	313782	1127433		
27433	2270	40229134	2016-04-12	2016-04-12 00:00:00	2016-04-26	2016-04-26 00:00:00	2016-04-26	38000177		0	0	14		0	0	0	150922	0	1043400	40229134		
13718	1146	19129655	1961-05-18	1961-05-18 00:00:00	1961-06-01	1961-06-01 00:00:00	1961-06-01	38000177		0	0	14		0	0	0	75749	0	789980	19129655		
160503	3532	40213227	1992-09-13	1992-09-13 00:00:00	1992-09-13	1992-09-13 00:00:00	1992-09-13	581452		0	0	0		0	0	0	234614	0	113	40213227		
20000	1641	1127433	1967-02-07	1967-02-07 00:00:00	1967-02-21	1967-02-21 00:00:00	1967-02-21	38000177		0	0	14		0	0	0	110155	0	313782	1127433		
41729	3455	920300	1998-07-04	1998-07-04 00:00:00	1998-07-11	1998-07-11 00:00:00	1998-07-11	38000177		0	0	7		0	0	0	229242	0	311989	920300		
27139	2238	19133873	1970-12-26	1970-12-26 00:00:00	1971-01-05	1971-01-05 00:00:00	1971-01-05	38000177		0	0	10		0	0	0	148974	0	834061	19133873		
154852	3408	40213227	2000-09-18	2000-09-18 00:00:00	2000-09-18	2000-09-18 00:00:00	2000-09-18	581452		0	0	0		0	0	0	226045	0	113	40213227		
39572	3272	19059056	1972-01-14	1972-01-14 00:00:00	1972-01-28	1972-01-28 00:00:00	1972-01-28	38000177		0	0	14		0	0	0	217420	0	243670	19059056		
789	17	40213227	1992-07-20	1992-07-20 00:00:00	1992-07-20	1992-07-20 00:00:00	1992-07-20	581452		0	0	0		0	0	0	1291	0	113	40213227		
42534	3527	1713671	2001-05-19	2001-05-19 00:00:00	2001-06-09	2001-06-09 00:00:00	2001-06-09	38000177		0	0	21		0	0	0	234140	0	562251	1713671		
40907	3392	46233988	1974-11-10	1974-11-10 00:00:00	1974-11-24	1974-11-24 00:00:00	1974-11-24	38000177		0	0	14		0	0	0	224970	0	1652673	46233988		
63141	5245	1127433	1990-12-02	1990-12-02 00:00:00	1990-12-16	1990-12-16 00:00:00	1990-12-16	38000177		0	0	14		0	0	0	348971	0	313782	1127433		
43058	3569	19128065	1986-08-19	1986-08-19 00:00:00	1987-08-14	1987-08-14 00:00:00	1987-08-14	38000177		0	0	360		0	0	0	237164	0	749882	19128065		
20807	1716	19059056	1971-08-31	1971-08-31 00:00:00	1971-09-21	1971-09-21 00:00:00	1971-09-21	38000177		0	0	21		0	0	0	114703	0	243670	19059056		
63920	5309	19059056	1953-04-18	1953-04-18 00:00:00	1953-05-02	1953-05-02 00:00:00	1953-05-02	38000177		0	0	14		0	0	0	353089	0	243670	19059056		
53248	4423	19073183	1984-03-21	1984-03-21 00:00:00	1984-04-04	1984-04-04 00:00:00	1984-04-04	38000177		0	0	14		0	0	0	294089	0	308182	19073183		
58987	4899	19059056	1945-06-20	1945-06-20 00:00:00	1945-07-04	1945-07-04 00:00:00	1945-07-04	38000177		0	0	14		0	0	0	325814	0	243670	19059056		
18001	1491	1332419	1997-02-18	1997-02-18 00:00:00	1997-02-18	1997-02-18 00:00:00	\N	38000177		0	0	0		0	0	0	99447	0	197361	1332419		
125657	2765	40213227	2005-05-24	2005-05-24 00:00:00	2005-05-24	2005-05-24 00:00:00	2005-05-24	581452		0	0	0		0	0	0	\N	0	113	40213227		
35668	2939	19133873	1953-03-25	1953-03-25 00:00:00	1953-04-04	1953-04-04 00:00:00	1953-04-04	38000177		0	0	10		0	0	0	195986	0	834061	19133873		
46177	3825	1127078	1956-05-31	1956-05-31 00:00:00	1956-06-30	1956-06-30 00:00:00	1956-06-30	38000177		0	0	30		0	0	0	254107	0	282464	1127078		
44949	3719	40236824	2015-01-22	2015-01-22 00:00:00	2015-01-29	2015-01-29 00:00:00	2015-01-29	38000177		0	0	7		0	0	0	247191	0	1094107	40236824		
55468	4606	1127433	2006-10-24	2006-10-24 00:00:00	2006-11-07	2006-11-07 00:00:00	2006-11-07	38000177		0	0	14		0	0	0	306866	0	313782	1127433		
92828	2037	40213160	1960-07-22	1960-07-22 00:00:00	1960-07-22	1960-07-22 00:00:00	1960-07-22	581452		0	0	0		0	0	0	135627	0	10	40213160		
1763	141	1127433	1987-03-16	1987-03-16 00:00:00	1987-03-30	1987-03-30 00:00:00	1987-03-30	38000177		0	0	14		0	0	0	9437	0	313782	1127433		
33912	2804	19059056	1954-04-27	1954-04-27 00:00:00	1954-05-11	1954-05-11 00:00:00	1954-05-11	38000177		0	0	14		0	0	0	185816	0	243670	19059056		
4530	376	19059056	1964-03-12	1964-03-12 00:00:00	1964-03-26	1964-03-26 00:00:00	1964-03-26	38000177		0	0	14		0	0	0	24906	0	243670	19059056		
102929	2258	40213160	1956-12-27	1956-12-27 00:00:00	1956-12-27	1956-12-27 00:00:00	1956-12-27	581452		0	0	0		0	0	0	150061	0	10	40213160		
45453	3759	19059056	1964-11-07	1964-11-07 00:00:00	1964-11-21	1964-11-21 00:00:00	1964-11-21	38000177		0	0	14		0	0	0	249927	0	243670	19059056		
47363	3926	19059056	1948-05-26	1948-05-26 00:00:00	1948-06-09	1948-06-09 00:00:00	1948-06-09	38000177		0	0	14		0	0	0	260987	0	243670	19059056		
37415	3092	1127078	1964-05-24	1964-05-24 00:00:00	1964-08-22	1964-08-22 00:00:00	1964-08-22	38000177		0	0	90		0	0	0	205905	0	282464	1127078		
56546	4690	1127433	2013-09-08	2013-09-08 00:00:00	2013-09-15	2013-09-15 00:00:00	2013-09-15	38000177		0	0	7		0	0	0	312524	0	313782	1127433		
6420	539	40229134	1981-06-10	1981-06-10 00:00:00	1981-06-17	1981-06-17 00:00:00	1981-06-17	38000177		0	0	7		0	0	0	35795	0	1043400	40229134		
4180	348	19019979	1977-08-16	1977-08-16 00:00:00	1977-08-30	1977-08-30 00:00:00	1977-08-30	38000177		0	0	14		0	0	0	23132	0	198405	19019979		
15828	1316	19059056	1949-10-21	1949-10-21 00:00:00	1949-11-04	1949-11-04 00:00:00	1949-11-04	38000177		0	0	14		0	0	0	87157	0	243670	19059056		
15877	1318	40222846	2012-08-24	2012-08-24 00:00:00	2012-08-24	2012-08-24 00:00:00	\N	38000177		0	0	0		0	0	0	87347	0	996740	40222846		
59793	4971	1127433	1968-03-06	1968-03-06 00:00:00	1968-03-20	1968-03-20 00:00:00	1968-03-20	38000177		0	0	14		0	0	0	330548	0	313782	1127433		
15981	1325	40229134	1970-11-18	1970-11-18 00:00:00	1970-12-02	1970-12-02 00:00:00	1970-12-02	38000177		0	0	14		0	0	0	87983	0	1043400	40229134		
118806	2613	40213160	1955-10-21	1955-10-21 00:00:00	1955-10-21	1955-10-21 00:00:00	1955-10-21	581452		0	0	0		0	0	0	172753	0	10	40213160		
2189	176	19133905	2003-12-19	2003-12-19 00:00:00	2003-12-28	2003-12-28 00:00:00	2003-12-28	38000177		0	0	9		0	0	0	11906	0	834102	19133905		
237121	5206	40213314	1977-03-26	1977-03-26 00:00:00	1977-03-26	1977-03-26 00:00:00	1977-03-26	581452		0	0	0		0	0	0	346262	0	49	40213314		
237165	5207	40213160	1956-06-20	1956-06-20 00:00:00	1956-06-20	1956-06-20 00:00:00	1956-06-20	581452		0	0	0		0	0	0	346386	0	10	40213160		
25520	2097	19133873	1986-12-15	1986-12-15 00:00:00	1986-12-23	1986-12-23 00:00:00	1986-12-23	38000177		0	0	8		0	0	0	139769	0	834061	19133873		
25559	2100	19059056	1959-08-13	1959-08-13 00:00:00	1959-08-27	1959-08-27 00:00:00	1959-08-27	38000177		0	0	14		0	0	0	139968	0	243670	19059056		
57615	4784	19133873	1963-03-23	1963-03-23 00:00:00	1963-03-31	1963-03-31 00:00:00	1963-03-31	38000177		0	0	8		0	0	0	318418	0	834061	19133873		
57687	4792	1127433	1988-01-01	1988-01-01 00:00:00	1988-01-31	1988-01-31 00:00:00	1988-01-31	38000177		0	0	30		0	0	0	318827	0	313782	1127433		
48879	4052	1127433	2004-02-26	2004-02-26 00:00:00	2004-03-04	2004-03-04 00:00:00	2004-03-04	38000177		0	0	7		0	0	0	269345	0	313782	1127433		
116352	2556	40213306	1990-08-13	1990-08-13 00:00:00	1990-08-13	1990-08-13 00:00:00	1990-08-13	581452		0	0	0		0	0	0	169381	0	43	40213306		
33159	2749	1127078	1961-05-16	1961-05-16 00:00:00	1961-05-30	1961-05-30 00:00:00	1961-05-30	38000177		0	0	14		0	0	0	181823	0	282464	1127078		
78056	1707	40213227	2001-10-22	2001-10-22 00:00:00	2001-10-22	2001-10-22 00:00:00	2001-10-22	581452		0	0	0		0	0	0	114117	0	113	40213227		
70863	1550	40213160	1973-10-20	1973-10-20 00:00:00	1973-10-20	1973-10-20 00:00:00	1973-10-20	581452		0	0	0		0	0	0	103796	0	10	40213160		
58457	4855	1118084	2014-07-23	2014-07-23 00:00:00	2014-07-23	2014-07-23 00:00:00	\N	38000177		0	0	0		0	0	0	323050	0	00025152531	44923712		
57331	4758	19078461	1987-06-05	1987-06-05 00:00:00	1987-06-26	1987-06-26 00:00:00	1987-06-26	38000177		0	0	21		0	0	0	316966	0	310965	19078461		
6120	512	19059056	1955-08-13	1955-08-13 00:00:00	1955-08-27	1955-08-27 00:00:00	1955-08-27	38000177		0	0	14		0	0	0	34221	0	243670	19059056		
44709	3700	46233988	1978-08-04	1978-08-04 00:00:00	1978-08-18	1978-08-18 00:00:00	1978-08-18	38000177		0	0	14		0	0	0	245987	0	1652673	46233988		
31436	685	40213306	1988-04-11	1988-04-11 00:00:00	1988-04-11	1988-04-11 00:00:00	1988-04-11	581452		0	0	0		0	0	0	45350	0	43	40213306		
7177	603	19006318	1959-08-21	1959-08-21 00:00:00	1959-09-04	1959-09-04 00:00:00	1959-09-04	38000177		0	0	14		0	0	0	40008	0	105078	19006318		
9819	822	1127078	1975-09-16	1975-09-16 00:00:00	1975-09-30	1975-09-30 00:00:00	1975-09-30	38000177		0	0	14		0	0	0	54463	0	282464	1127078		
7294	610	1115171	1995-08-24	1995-08-24 00:00:00	1995-09-14	1995-09-14 00:00:00	1995-09-14	38000177		0	0	21		0	0	0	40481	0	849574	1115171		
48186	3995	920300	2014-02-27	2014-02-27 00:00:00	2014-03-06	2014-03-06 00:00:00	2014-03-06	38000177		0	0	7		0	0	0	265600	0	311989	920300		
27352	2261	1127433	2017-04-12	2017-04-12 00:00:00	2017-04-26	2017-04-26 00:00:00	2017-04-26	38000177		0	0	14		0	0	0	150315	0	313782	1127433		
3064	248	19075001	1995-09-21	1995-09-21 00:00:00	1995-10-05	1995-10-05 00:00:00	1995-10-05	38000177		0	0	14		0	0	0	16682	0	309097	19075001		
7784	651	40243436	1999-01-28	1999-01-28 00:00:00	1999-01-28	1999-01-28 00:00:00	1999-01-28	38000177		0	0	0		0	0	0	43079	0	1190795	40243436		
49131	4077	19078461	2012-02-26	2012-02-26 00:00:00	2012-04-01	2012-04-01 00:00:00	2012-04-01	38000177		0	0	35		0	0	0	270888	0	310965	19078461		
27434	2270	1127078	1988-05-08	1988-05-08 00:00:00	1988-05-29	1988-05-29 00:00:00	1988-05-29	38000177		0	0	21		0	0	0	150939	0	282464	1127078		
13719	1146	19059056	1961-05-18	1961-05-18 00:00:00	1961-06-01	1961-06-01 00:00:00	1961-06-01	38000177		0	0	14		0	0	0	75749	0	243670	19059056		
160504	3532	40213306	1992-09-13	1992-09-13 00:00:00	1992-09-13	1992-09-13 00:00:00	1992-09-13	581452		0	0	0		0	0	0	234614	0	43	40213306		
20001	1641	19006318	1967-02-07	1967-02-07 00:00:00	1967-02-21	1967-02-21 00:00:00	1967-02-21	38000177		0	0	14		0	0	0	110155	0	105078	19006318		
41730	3455	19128065	1986-05-07	1986-05-07 00:00:00	1987-05-02	1987-05-02 00:00:00	1987-05-02	38000177		0	0	360		0	0	0	229209	0	749882	19128065		
27140	2238	1127433	2003-10-14	2003-10-14 00:00:00	2003-10-28	2003-10-28 00:00:00	2003-10-28	38000177		0	0	14		0	0	0	148924	0	313782	1127433		
154855	3408	40213296	2009-07-13	2009-07-13 00:00:00	2009-07-13	2009-07-13 00:00:00	2009-07-13	581452		0	0	0		0	0	0	226048	0	52	40213296		
39573	3272	1713671	1999-04-02	1999-04-02 00:00:00	1999-04-16	1999-04-16 00:00:00	1999-04-16	38000177		0	0	14		0	0	0	217442	0	562251	1713671		
803	18	40213160	1966-07-27	1966-07-27 00:00:00	1966-07-27	1966-07-27 00:00:00	1966-07-27	581452		0	0	0		0	0	0	1392	0	10	40213160		
42535	3527	19078461	1974-02-19	1974-02-19 00:00:00	1974-03-12	1974-03-12 00:00:00	1974-03-12	38000177		0	0	21		0	0	0	234049	0	310965	19078461		
40908	3392	1127078	1974-11-10	1974-11-10 00:00:00	1974-11-24	1974-11-24 00:00:00	1974-11-24	38000177		0	0	14		0	0	0	224970	0	282464	1127078		
63142	5245	19133873	1984-03-11	1984-03-11 00:00:00	1984-03-23	1984-03-23 00:00:00	1984-03-23	38000177		0	0	12		0	0	0	348985	0	834061	19133873		
43059	3569	1127433	1995-06-02	1995-06-02 00:00:00	1995-06-16	1995-06-16 00:00:00	1995-06-16	38000177		0	0	14		0	0	0	237160	0	313782	1127433		
20808	1716	40229134	1982-07-02	1982-07-02 00:00:00	1982-07-16	1982-07-16 00:00:00	1982-07-16	38000177		0	0	14		0	0	0	114604	0	1043400	40229134		
63921	5309	19006318	1953-04-18	1953-04-18 00:00:00	1953-05-02	1953-05-02 00:00:00	1953-05-02	38000177		0	0	14		0	0	0	353089	0	105078	19006318		
53249	4423	1127078	1984-03-21	1984-03-21 00:00:00	1984-04-04	1984-04-04 00:00:00	1984-04-04	38000177		0	0	14		0	0	0	294089	0	282464	1127078		
59022	4905	19133873	1977-08-18	1977-08-18 00:00:00	1977-08-31	1977-08-31 00:00:00	1977-08-31	38000177		0	0	13		0	0	0	326027	0	834061	19133873		
18002	1491	1539411	1997-02-18	1997-02-18 00:00:00	1997-02-18	1997-02-18 00:00:00	\N	38000177		0	0	0		0	0	0	99447	0	312961	1539411		
194546	4275	40213251	1984-12-23	1984-12-23 00:00:00	1984-12-23	1984-12-23 00:00:00	1984-12-23	581452		0	0	0		0	0	0	283693	0	21	40213251		
35669	2939	1127433	1974-09-29	1974-09-29 00:00:00	1974-10-06	1974-10-06 00:00:00	1974-10-06	38000177		0	0	7		0	0	0	195916	0	313782	1127433		
46178	3825	1127078	1955-07-06	1955-07-06 00:00:00	1955-07-20	1955-07-20 00:00:00	1955-07-20	38000177		0	0	14		0	0	0	254040	0	282464	1127078		
44951	3719	19133873	1972-05-21	1972-05-21 00:00:00	1972-05-29	1972-05-29 00:00:00	1972-05-29	38000177		0	0	8		0	0	0	247208	0	834061	19133873		
55469	4606	1713671	1994-12-16	1994-12-16 00:00:00	1994-12-30	1994-12-30 00:00:00	1994-12-30	38000177		0	0	14		0	0	0	306858	0	562251	1713671		
13098	283	40213314	1981-11-09	1981-11-09 00:00:00	1981-11-09	1981-11-09 00:00:00	1981-11-09	581452		0	0	0		0	0	0	18889	0	49	40213314		
1764	141	19078461	2013-09-23	2013-09-23 00:00:00	2013-10-21	2013-10-21 00:00:00	2013-10-21	38000177		0	0	28		0	0	0	9485	0	310965	19078461		
33913	2804	19006318	1954-04-27	1954-04-27 00:00:00	1954-05-11	1954-05-11 00:00:00	1954-05-11	38000177		0	0	14		0	0	0	185816	0	105078	19006318		
4532	377	19059056	1971-10-09	1971-10-09 00:00:00	1971-11-13	1971-11-13 00:00:00	1971-11-13	38000177		0	0	35		0	0	0	24964	0	243670	19059056		
102931	2258	40213160	1956-09-27	1956-09-27 00:00:00	1956-09-27	1956-09-27 00:00:00	1956-09-27	581452		0	0	0		0	0	0	150097	0	10	40213160		
45454	3759	19129655	1964-11-07	1964-11-07 00:00:00	1964-11-21	1964-11-21 00:00:00	1964-11-21	38000177		0	0	14		0	0	0	249927	0	789980	19129655		
47364	3926	19006318	1948-05-26	1948-05-26 00:00:00	1948-06-09	1948-06-09 00:00:00	1948-06-09	38000177		0	0	14		0	0	0	260987	0	105078	19006318		
37416	3092	19133873	1970-07-20	1970-07-20 00:00:00	1970-08-01	1970-08-01 00:00:00	1970-08-01	38000177		0	0	12		0	0	0	205865	0	834061	19133873		
56547	4690	1115171	2004-05-06	2004-05-06 00:00:00	2004-05-20	2004-05-20 00:00:00	2004-05-20	38000177		0	0	14		0	0	0	312470	0	849574	1115171		
6421	539	40236824	1984-04-23	1984-04-23 00:00:00	1984-04-30	1984-04-30 00:00:00	1984-04-30	38000177		0	0	7		0	0	0	35835	0	1094107	40236824		
4181	348	1127433	1994-12-16	1994-12-16 00:00:00	1994-12-30	1994-12-30 00:00:00	1994-12-30	38000177		0	0	14		0	0	0	23142	0	313782	1127433		
15829	1316	19006318	1949-10-21	1949-10-21 00:00:00	1949-11-04	1949-11-04 00:00:00	1949-11-04	38000177		0	0	14		0	0	0	87157	0	105078	19006318		
15878	1318	1115171	2010-06-12	2010-06-12 00:00:00	2010-07-03	2010-07-03 00:00:00	2010-07-03	38000177		0	0	21		0	0	0	87401	0	849574	1115171		
59794	4971	920300	1992-10-06	1992-10-06 00:00:00	1992-10-13	1992-10-13 00:00:00	1992-10-13	38000177		0	0	7		0	0	0	330549	0	311989	920300		
15982	1325	1127433	2001-04-06	2001-04-06 00:00:00	2001-04-13	2001-04-13 00:00:00	2001-04-13	38000177		0	0	7		0	0	0	87951	0	313782	1127433		
118813	2613	40213296	1997-12-12	1997-12-12 00:00:00	1997-12-12	1997-12-12 00:00:00	1997-12-12	581452		0	0	0		0	0	0	172784	0	52	40213296		
2190	176	1713671	1969-02-09	1969-02-09 00:00:00	1969-02-16	1969-02-16 00:00:00	1969-02-16	38000177		0	0	7		0	0	0	11879	0	562251	1713671		
237122	5206	40213160	1977-03-26	1977-03-26 00:00:00	1977-03-26	1977-03-26 00:00:00	1977-03-26	581452		0	0	0		0	0	0	346262	0	10	40213160		
237171	5207	40213160	1956-04-18	1956-04-18 00:00:00	1956-04-18	1956-04-18 00:00:00	1956-04-18	581452		0	0	0		0	0	0	346311	0	10	40213160		
25521	2097	1127433	1982-09-06	1982-09-06 00:00:00	1982-09-20	1982-09-20 00:00:00	1982-09-20	38000177		0	0	14		0	0	0	139767	0	313782	1127433		
25560	2100	1115171	2012-08-28	2012-08-28 00:00:00	2012-11-26	2012-11-26 00:00:00	2012-11-26	38000177		0	0	90		0	0	0	139973	0	849574	1115171		
57616	4784	46233710	1976-09-06	1976-09-06 00:00:00	1976-09-20	1976-09-20 00:00:00	1976-09-20	38000177		0	0	14		0	0	0	318440	0	1650142	46233710		
57688	4792	40229134	2000-12-10	2000-12-10 00:00:00	2000-12-17	2000-12-17 00:00:00	2000-12-17	38000177		0	0	7		0	0	0	318844	0	1043400	40229134		
48880	4053	1713671	1975-08-05	1975-08-05 00:00:00	1975-08-12	1975-08-12 00:00:00	1975-08-12	38000177		0	0	7		0	0	0	269465	0	562251	1713671		
116355	2556	40213296	2010-01-04	2010-01-04 00:00:00	2010-01-04	2010-01-04 00:00:00	2010-01-04	581452		0	0	0		0	0	0	169402	0	52	40213296		
33160	2749	19059056	1966-08-18	1966-08-18 00:00:00	1966-11-16	1966-11-16 00:00:00	1966-11-16	38000177		0	0	90		0	0	0	181845	0	243670	19059056		
78058	1707	40213296	2012-08-20	2012-08-20 00:00:00	2012-08-20	2012-08-20 00:00:00	2012-08-20	581452		0	0	0		0	0	0	114160	0	52	40213296		
70869	1550	40213227	2002-10-26	2002-10-26 00:00:00	2002-10-26	2002-10-26 00:00:00	2002-10-26	581452		0	0	0		0	0	0	103788	0	113	40213227		
58458	4855	19019979	1987-02-20	1987-02-20 00:00:00	1987-03-22	1987-03-22 00:00:00	1987-03-22	38000177		0	0	30		0	0	0	323022	0	198405	19019979		
57332	4758	1127433	1991-05-06	1991-05-06 00:00:00	1991-05-27	1991-05-27 00:00:00	1991-05-27	38000177		0	0	21		0	0	0	316968	0	313782	1127433		
6121	512	1115171	1994-12-14	1994-12-14 00:00:00	1994-12-28	1994-12-28 00:00:00	1994-12-28	38000177		0	0	14		0	0	0	34166	0	849574	1115171		
44710	3700	19059056	1978-08-04	1978-08-04 00:00:00	1978-08-18	1978-08-18 00:00:00	1978-08-18	38000177		0	0	14		0	0	0	245987	0	243670	19059056		
31440	685	40213160	1966-10-17	1966-10-17 00:00:00	1966-10-17	1966-10-17 00:00:00	1966-10-17	581452		0	0	0		0	0	0	45281	0	10	40213160		
7178	603	19078461	2008-04-03	2008-04-03 00:00:00	2008-05-08	2008-05-08 00:00:00	2008-05-08	38000177		0	0	35		0	0	0	39932	0	310965	19078461		
9820	822	19006318	1975-09-16	1975-09-16 00:00:00	1975-09-30	1975-09-30 00:00:00	1975-09-30	38000177		0	0	14		0	0	0	54463	0	105078	19006318		
7295	610	19128065	1982-07-26	1982-07-26 00:00:00	1983-07-21	1983-07-21 00:00:00	1983-07-21	38000177		0	0	360		0	0	0	40594	0	749882	19128065		
48187	3995	40236824	2014-02-27	2014-02-27 00:00:00	2014-03-06	2014-03-06 00:00:00	2014-03-06	38000177		0	0	7		0	0	0	265600	0	1094107	40236824		
27364	2264	19059056	1972-06-15	1972-06-15 00:00:00	1972-06-29	1972-06-29 00:00:00	1972-06-29	38000177		0	0	14		0	0	0	150447	0	243670	19059056		
3065	248	1127433	1995-09-21	1995-09-21 00:00:00	1995-10-05	1995-10-05 00:00:00	1995-10-05	38000177		0	0	14		0	0	0	16682	0	313782	1127433		
7785	651	46275916	1999-01-28	1999-01-28 00:00:00	1999-01-28	1999-01-28 00:00:00	1999-01-28	38000177		0	0	0		0	0	0	43079	0	1660014	46275916		
49132	4077	1127433	1983-11-22	1983-11-22 00:00:00	1983-11-29	1983-11-29 00:00:00	1983-11-29	38000177		0	0	7		0	0	0	270910	0	313782	1127433		
27435	2270	1118084	2019-03-12	2019-03-12 00:00:00	2019-03-12	2019-03-12 00:00:00	\N	38000177		0	0	0		0	0	0	150980	0	00025152531	44923712		
13720	1146	1127433	2011-10-08	2011-10-08 00:00:00	2011-10-15	2011-10-15 00:00:00	2011-10-15	38000177		0	0	7		0	0	0	75721	0	313782	1127433		
160506	3532	40213227	2001-11-11	2001-11-11 00:00:00	2001-11-11	2001-11-11 00:00:00	2001-11-11	581452		0	0	0		0	0	0	234624	0	113	40213227		
20002	1641	1713671	1988-05-23	1988-05-23 00:00:00	1988-06-06	1988-06-06 00:00:00	1988-06-06	38000177		0	0	14		0	0	0	110165	0	562251	1713671		
41731	3455	19073188	2012-08-08	2012-08-08 00:00:00	2012-08-29	2012-08-29 00:00:00	2012-08-29	38000177		0	0	21		0	0	0	229260	0	308192	19073188		
27141	2238	19078461	2000-09-20	2000-09-20 00:00:00	2000-10-11	2000-10-11 00:00:00	2000-10-11	38000177		0	0	21		0	0	0	148928	0	310965	19078461		
27690	603	40213260	2006-03-10	2006-03-10 00:00:00	2006-03-10	2006-03-10 00:00:00	2006-03-10	581452		0	0	0		0	0	0	40025	0	121	40213260		
39575	3272	1127078	1971-08-03	1971-08-03 00:00:00	1971-08-17	1971-08-17 00:00:00	1971-08-17	38000177		0	0	14		0	0	0	217474	0	282464	1127078		
806	18	40213227	1997-07-16	1997-07-16 00:00:00	1997-07-16	1997-07-16 00:00:00	1997-07-16	581452		0	0	0		0	0	0	1403	0	113	40213227		
42536	3527	19133873	1971-07-03	1971-07-03 00:00:00	1971-07-15	1971-07-15 00:00:00	1971-07-15	38000177		0	0	12		0	0	0	234089	0	834061	19133873		
40909	3392	1124300	2002-02-10	2002-02-10 00:00:00	2002-02-10	2002-02-10 00:00:00	\N	38000177		0	0	0		0	0	0	224971	0	00781178901	45011828		
63143	5245	1713671	1984-09-10	1984-09-10 00:00:00	1984-09-24	1984-09-24 00:00:00	1984-09-24	38000177		0	0	14		0	0	0	348986	0	562251	1713671		
43061	3569	1127433	2011-07-15	2011-07-15 00:00:00	2011-07-22	2011-07-22 00:00:00	2011-07-22	38000177		0	0	7		0	0	0	237162	0	313782	1127433		
20809	1716	19006318	1950-06-21	1950-06-21 00:00:00	1950-07-05	1950-07-05 00:00:00	1950-07-05	38000177		0	0	14		0	0	0	114634	0	105078	19006318		
181963	3997	40213160	1971-08-30	1971-08-30 00:00:00	1971-08-30	1971-08-30 00:00:00	1971-08-30	581452		0	0	0		0	0	0	265714	0	10	40213160		
53250	4423	19059056	1979-03-04	1979-03-04 00:00:00	1979-04-03	1979-04-03 00:00:00	1979-04-03	38000177		0	0	30		0	0	0	294120	0	243670	19059056		
59023	4905	1127433	1982-07-11	1982-07-11 00:00:00	1982-07-18	1982-07-18 00:00:00	1982-07-18	38000177		0	0	7		0	0	0	326033	0	313782	1127433		
18003	1491	19133873	1970-12-28	1970-12-28 00:00:00	1971-01-05	1971-01-05 00:00:00	1971-01-05	38000177		0	0	8		0	0	0	99410	0	834061	19133873		
194548	4275	40213160	1984-12-23	1984-12-23 00:00:00	1984-12-23	1984-12-23 00:00:00	1984-12-23	581452		0	0	0		0	0	0	283693	0	10	40213160		
35670	2939	19128065	1974-12-06	1974-12-06 00:00:00	1975-12-01	1975-12-01 00:00:00	1975-12-01	38000177		0	0	360		0	0	0	196004	0	749882	19128065		
46179	3825	920334	1988-07-25	1988-07-25 00:00:00	1988-08-01	1988-08-01 00:00:00	1988-08-01	38000177		0	0	7		0	0	0	254037	0	311995	920334		
44952	3719	19078461	1989-11-17	1989-11-17 00:00:00	1989-12-22	1989-12-22 00:00:00	1989-12-22	38000177		0	0	35		0	0	0	247167	0	310965	19078461		
55470	4606	40162522	2013-06-03	2013-06-03 00:00:00	2013-06-03	2013-06-03 00:00:00	\N	38000177		0	0	0		0	0	0	306867	0	857005	40162522		
13100	283	40213160	1981-02-09	1981-02-09 00:00:00	1981-02-09	1981-02-09 00:00:00	1981-02-09	581452		0	0	0		0	0	0	18888	0	10	40213160		
1765	141	1118084	2015-11-12	2015-11-12 00:00:00	2015-11-12	2015-11-12 00:00:00	\N	38000177		0	0	0		0	0	0	9485	0	00025152531	44923712		
33914	2804	1127433	1963-02-16	1963-02-16 00:00:00	1963-02-23	1963-02-23 00:00:00	1963-02-23	38000177		0	0	7		0	0	0	185845	0	313782	1127433		
4533	377	1127078	1977-08-04	1977-08-04 00:00:00	1977-08-25	1977-08-25 00:00:00	1977-08-25	38000177		0	0	21		0	0	0	24966	0	282464	1127078		
102935	2258	40213260	2006-11-30	2006-11-30 00:00:00	2006-11-30	2006-11-30 00:00:00	2006-11-30	581452		0	0	0		0	0	0	150038	0	121	40213260		
45455	3759	1127078	1974-07-18	1974-07-18 00:00:00	1974-09-16	1974-09-16 00:00:00	1974-09-16	38000177		0	0	60		0	0	0	249932	0	282464	1127078		
47365	3926	1127433	1962-09-11	1962-09-11 00:00:00	1962-09-25	1962-09-25 00:00:00	1962-09-25	38000177		0	0	14		0	0	0	260925	0	313782	1127433		
37417	3092	19059056	1956-05-22	1956-05-22 00:00:00	1956-06-05	1956-06-05 00:00:00	1956-06-05	38000177		0	0	14		0	0	0	205904	0	243670	19059056		
56548	4691	1127078	1969-05-20	1969-05-20 00:00:00	1969-08-18	1969-08-18 00:00:00	1969-08-18	38000177		0	0	90		0	0	0	312597	0	282464	1127078		
6422	539	920300	1984-04-23	1984-04-23 00:00:00	1984-04-30	1984-04-30 00:00:00	1984-04-30	38000177		0	0	7		0	0	0	35835	0	311989	920300		
4182	348	1127433	2003-11-29	2003-11-29 00:00:00	2003-12-06	2003-12-06 00:00:00	2003-12-06	38000177		0	0	7		0	0	0	23146	0	313782	1127433		
15830	1316	19133873	1963-09-29	1963-09-29 00:00:00	1963-10-08	1963-10-08 00:00:00	1963-10-08	38000177		0	0	9		0	0	0	87219	0	834061	19133873		
15879	1318	1713671	1984-10-24	1984-10-24 00:00:00	1984-11-07	1984-11-07 00:00:00	1984-11-07	38000177		0	0	14		0	0	0	87351	0	562251	1713671		
59795	4971	40236824	1992-10-06	1992-10-06 00:00:00	1992-10-13	1992-10-13 00:00:00	1992-10-13	38000177		0	0	7		0	0	0	330549	0	1094107	40236824		
15983	1325	1127433	2011-10-17	2011-10-17 00:00:00	2012-01-15	2012-01-15 00:00:00	2012-01-15	38000177		0	0	90		0	0	0	87939	0	313782	1127433		
118815	2613	40213227	1997-12-12	1997-12-12 00:00:00	1997-12-12	1997-12-12 00:00:00	1997-12-12	581452		0	0	0		0	0	0	172784	0	113	40213227		
2191	176	19078461	1990-08-02	1990-08-02 00:00:00	1990-08-23	1990-08-23 00:00:00	1990-08-23	38000177		0	0	21		0	0	0	11931	0	310965	19078461		
237123	5206	40213227	2007-12-08	2007-12-08 00:00:00	2007-12-08	2007-12-08 00:00:00	2007-12-08	581452		0	0	0		0	0	0	346306	0	113	40213227		
7888	170	40213160	1971-10-14	1971-10-14 00:00:00	1971-10-14	1971-10-14 00:00:00	1971-10-14	581452		0	0	0		0	0	0	11563	0	10	40213160		
25522	2097	1127078	1979-04-24	1979-04-24 00:00:00	1979-05-08	1979-05-08 00:00:00	1979-05-08	38000177		0	0	14		0	0	0	139765	0	282464	1127078		
25561	2100	1115171	2014-12-16	2014-12-16 00:00:00	2014-12-30	2014-12-30 00:00:00	2014-12-30	38000177		0	0	14		0	0	0	139974	0	849574	1115171		
57617	4784	1127433	1976-09-06	1976-09-06 00:00:00	1976-09-20	1976-09-20 00:00:00	1976-09-20	38000177		0	0	14		0	0	0	318440	0	313782	1127433		
57689	4792	1127433	2013-11-10	2013-11-10 00:00:00	2013-11-17	2013-11-17 00:00:00	2013-11-17	38000177		0	0	7		0	0	0	318874	0	313782	1127433		
48881	4053	1127433	1988-06-28	1988-06-28 00:00:00	1988-07-12	1988-07-12 00:00:00	1988-07-12	38000177		0	0	14		0	0	0	269419	0	313782	1127433		
116356	2556	40213227	2010-01-04	2010-01-04 00:00:00	2010-01-04	2010-01-04 00:00:00	2010-01-04	581452		0	0	0		0	0	0	169402	0	113	40213227		
33161	2749	19133873	1974-03-17	1974-03-17 00:00:00	1974-03-25	1974-03-25 00:00:00	1974-03-25	38000177		0	0	8		0	0	0	181788	0	834061	19133873		
78060	1707	40213227	2012-08-20	2012-08-20 00:00:00	2012-08-20	2012-08-20 00:00:00	2012-08-20	581452		0	0	0		0	0	0	114160	0	113	40213227		
70875	1551	40213227	2018-03-12	2018-03-12 00:00:00	2018-03-12	2018-03-12 00:00:00	2018-03-12	581452		0	0	0		0	0	0	103865	0	113	40213227		
58459	4855	19006318	1978-06-07	1978-06-07 00:00:00	1978-06-21	1978-06-21 00:00:00	1978-06-21	38000177		0	0	14		0	0	0	323030	0	105078	19006318		
57333	4758	40229134	1967-01-22	1967-01-22 00:00:00	1967-01-29	1967-01-29 00:00:00	1967-01-29	38000177		0	0	7		0	0	0	316996	0	1043400	40229134		
6122	512	19075001	1994-12-14	1994-12-14 00:00:00	1994-12-28	1994-12-28 00:00:00	1994-12-28	38000177		0	0	14		0	0	0	34166	0	309097	19075001		
44711	3700	19006318	1970-03-13	1970-03-13 00:00:00	1970-03-27	1970-03-27 00:00:00	1970-03-27	38000177		0	0	14		0	0	0	245967	0	105078	19006318		
31442	685	40213227	1997-04-21	1997-04-21 00:00:00	1997-04-21	1997-04-21 00:00:00	1997-04-21	581452		0	0	0		0	0	0	45323	0	113	40213227		
7179	603	40229134	1983-11-03	1983-11-03 00:00:00	1983-11-10	1983-11-10 00:00:00	1983-11-10	38000177		0	0	7		0	0	0	39942	0	1043400	40229134		
9821	822	1124300	2013-09-21	2013-09-21 00:00:00	2013-09-21	2013-09-21 00:00:00	\N	38000177		0	0	0		0	0	0	54510	0	00781178901	45011828		
7296	610	19112599	1967-09-19	1967-09-19 00:00:00	1967-09-19	1967-09-19 00:00:00	\N	38000177		0	0	0		0	0	0	40509	0	477045	19112599		
48188	3995	40229134	1998-04-23	1998-04-23 00:00:00	1998-04-30	1998-04-30 00:00:00	1998-04-30	38000177		0	0	7		0	0	0	265595	0	1043400	40229134		
27365	2264	19006318	1972-06-15	1972-06-15 00:00:00	1972-06-29	1972-06-29 00:00:00	1972-06-29	38000177		0	0	14		0	0	0	150447	0	105078	19006318		
3066	248	1127433	1990-12-21	1990-12-21 00:00:00	1990-12-28	1990-12-28 00:00:00	1990-12-28	38000177		0	0	7		0	0	0	16688	0	313782	1127433		
7786	651	1127433	2013-11-22	2013-11-22 00:00:00	2013-12-06	2013-12-06 00:00:00	2013-12-06	38000177		0	0	14		0	0	0	43110	0	313782	1127433		
49133	4078	1118084	1995-10-09	1995-10-09 00:00:00	1995-10-09	1995-10-09 00:00:00	\N	38000177		0	0	0		0	0	0	271048	0	00025152531	44923712		
27436	2270	40224805	2001-04-10	2001-04-10 00:00:00	2002-04-05	2002-04-05 00:00:00	2002-04-05	38000177		0	0	360		0	0	0	150956	0	1000126	40224805		
13721	1146	19133905	1978-11-15	1978-11-15 00:00:00	1978-11-27	1978-11-27 00:00:00	1978-11-27	38000177		0	0	12		0	0	0	75718	0	834102	19133905		
160515	3532	40213160	1971-03-21	1971-03-21 00:00:00	1971-03-21	1971-03-21 00:00:00	1971-03-21	581452		0	0	0		0	0	0	234602	0	10	40213160		
20003	1641	1127433	1963-12-05	1963-12-05 00:00:00	1963-12-12	1963-12-12 00:00:00	1963-12-12	38000177		0	0	7		0	0	0	110126	0	313782	1127433		
41732	3455	19078461	2012-08-08	2012-08-08 00:00:00	2012-08-29	2012-08-29 00:00:00	2012-08-29	38000177		0	0	21		0	0	0	229260	0	310965	19078461		
27142	2238	1154615	1971-08-11	1971-08-11 00:00:00	1971-08-11	1971-08-11 00:00:00	\N	38000177		0	0	0		0	0	0	148888	0	745679	1154615		
27697	603	40213227	1997-11-28	1997-11-28 00:00:00	1997-11-28	1997-11-28 00:00:00	1997-11-28	581452		0	0	0		0	0	0	39904	0	113	40213227		
39576	3272	46233988	1971-08-03	1971-08-03 00:00:00	1971-08-17	1971-08-17 00:00:00	1971-08-17	38000177		0	0	14		0	0	0	217474	0	1652673	46233988		
809	18	40213306	1988-07-06	1988-07-06 00:00:00	1988-07-06	1988-07-06 00:00:00	1988-07-06	581452		0	0	0		0	0	0	1448	0	43	40213306		
42537	3527	1127433	1969-06-03	1969-06-03 00:00:00	1969-06-17	1969-06-17 00:00:00	1969-06-17	38000177		0	0	14		0	0	0	234019	0	313782	1127433		
40910	3392	1713671	1974-01-28	1974-01-28 00:00:00	1974-02-18	1974-02-18 00:00:00	1974-02-18	38000177		0	0	21		0	0	0	224959	0	562251	1713671		
63144	5245	19078461	1989-09-07	1989-09-07 00:00:00	1989-09-21	1989-09-21 00:00:00	1989-09-21	38000177		0	0	14		0	0	0	348934	0	310965	19078461		
43062	3569	19128065	1982-09-09	1982-09-09 00:00:00	1983-09-04	1983-09-04 00:00:00	1983-09-04	38000177		0	0	360		0	0	0	237163	0	749882	19128065		
20810	1716	19059056	1950-06-21	1950-06-21 00:00:00	1950-07-05	1950-07-05 00:00:00	1950-07-05	38000177		0	0	14		0	0	0	114634	0	243670	19059056		
181975	3998	40213227	2009-06-11	2009-06-11 00:00:00	2009-06-11	2009-06-11 00:00:00	2009-06-11	581452		0	0	0		0	0	0	265840	0	113	40213227		
53251	4423	46233988	1977-07-12	1977-07-12 00:00:00	1977-07-26	1977-07-26 00:00:00	1977-07-26	38000177		0	0	14		0	0	0	294110	0	1652673	46233988		
59024	4905	1127078	1978-07-31	1978-07-31 00:00:00	1978-08-30	1978-08-30 00:00:00	1978-08-30	38000177		0	0	30		0	0	0	326057	0	282464	1127078		
18004	1491	1127433	1995-08-07	1995-08-07 00:00:00	1995-09-06	1995-09-06 00:00:00	1995-09-06	38000177		0	0	30		0	0	0	99454	0	313782	1127433		
194551	4275	40213314	1981-03-22	1981-03-22 00:00:00	1981-03-22	1981-03-22 00:00:00	1981-03-22	581452		0	0	0		0	0	0	283690	0	49	40213314		
46015	3811	1713671	1966-11-15	1966-11-15 00:00:00	1966-11-22	1966-11-22 00:00:00	1966-11-22	38000177		0	0	7		0	0	0	253167	0	562251	1713671		
46180	3825	1127433	2009-03-13	2009-03-13 00:00:00	2009-03-27	2009-03-27 00:00:00	2009-03-27	38000177		0	0	14		0	0	0	254068	0	313782	1127433		
44953	3719	1713671	1964-02-09	1964-02-09 00:00:00	1964-02-23	1964-02-23 00:00:00	1964-02-23	38000177		0	0	14		0	0	0	247206	0	562251	1713671		
55471	4606	1115171	2013-06-03	2013-06-03 00:00:00	2013-07-03	2013-07-03 00:00:00	2013-07-03	38000177		0	0	30		0	0	0	306867	0	849574	1115171		
13101	283	40213314	1981-02-09	1981-02-09 00:00:00	1981-02-09	1981-02-09 00:00:00	1981-02-09	581452		0	0	0		0	0	0	18888	0	49	40213314		
1766	141	19133873	1993-09-22	1993-09-22 00:00:00	1993-10-04	1993-10-04 00:00:00	1993-10-04	38000177		0	0	12		0	0	0	9449	0	834061	19133873		
33915	2804	1127433	2017-08-18	2017-08-18 00:00:00	2017-09-01	2017-09-01 00:00:00	2017-09-01	38000177		0	0	14		0	0	0	185828	0	313782	1127433		
4534	377	19128065	1986-12-29	1986-12-29 00:00:00	1987-12-24	1987-12-24 00:00:00	1987-12-24	38000177		0	0	360		0	0	0	24973	0	749882	19128065		
102936	2258	40213260	2007-12-06	2007-12-06 00:00:00	2007-12-06	2007-12-06 00:00:00	2007-12-06	581452		0	0	0		0	0	0	150054	0	121	40213260		
45456	3759	40229134	1966-03-03	1966-03-03 00:00:00	1966-03-17	1966-03-17 00:00:00	1966-03-17	38000177		0	0	14		0	0	0	249944	0	1043400	40229134		
47366	3926	920334	1991-11-05	1991-11-05 00:00:00	1991-11-12	1991-11-12 00:00:00	1991-11-12	38000177		0	0	7		0	0	0	260972	0	311995	920334		
37418	3092	1127433	1965-08-05	1965-08-05 00:00:00	1965-08-12	1965-08-12 00:00:00	1965-08-12	38000177		0	0	7		0	0	0	205882	0	313782	1127433		
56549	4691	1127078	1962-03-28	1962-03-28 00:00:00	1962-06-26	1962-06-26 00:00:00	1962-06-26	38000177		0	0	90		0	0	0	312596	0	282464	1127078		
6423	539	19075601	1997-03-09	1997-03-09 00:00:00	1999-07-25	1999-07-25 00:00:00	1999-07-25	38000177		0	0	868		0	0	0	35845	0	309362	19075601		
4183	348	1127433	1991-05-05	1991-05-05 00:00:00	1991-06-09	1991-06-09 00:00:00	1991-06-09	38000177		0	0	35		0	0	0	23117	0	313782	1127433		
15831	1316	19059056	1968-05-05	1968-05-05 00:00:00	1968-06-09	1968-06-09 00:00:00	1968-06-09	38000177		0	0	35		0	0	0	87221	0	243670	19059056		
15880	1318	19133873	1949-10-09	1949-10-09 00:00:00	1949-10-16	1949-10-16 00:00:00	1949-10-16	38000177		0	0	7		0	0	0	87335	0	834061	19133873		
59796	4971	40220960	2007-09-04	2007-09-04 00:00:00	2007-09-04	2007-09-04 00:00:00	2007-09-04	38000177		0	0	0		0	0	0	330506	0	1804799	40220960		
15984	1325	19133905	2018-05-12	2018-05-12 00:00:00	2018-05-21	2018-05-21 00:00:00	2018-05-21	38000177		0	0	9		0	0	0	87963	0	834102	19133905		
30379	662	40213296	2000-09-27	2000-09-27 00:00:00	2000-09-27	2000-09-27 00:00:00	2000-09-27	581452		0	0	0		0	0	0	43759	0	52	40213296		
2192	176	1118084	2003-03-06	2003-03-06 00:00:00	2003-03-06	2003-03-06 00:00:00	\N	38000177		0	0	0		0	0	0	11924	0	00025152531	44923712		
237127	5206	40213227	2018-10-27	2018-10-27 00:00:00	2018-10-27	2018-10-27 00:00:00	2018-10-27	581452		0	0	0		0	0	0	346302	0	113	40213227		
7891	170	40213160	1971-07-15	1971-07-15 00:00:00	1971-07-15	1971-07-15 00:00:00	1971-07-15	581452		0	0	0		0	0	0	11537	0	10	40213160		
25523	2097	19074843	1979-04-24	1979-04-24 00:00:00	1979-05-08	1979-05-08 00:00:00	1979-05-08	38000177		0	0	14		0	0	0	139765	0	309045	19074843		
25562	2100	19059056	1944-08-01	1944-08-01 00:00:00	1944-08-15	1944-08-15 00:00:00	1944-08-15	38000177		0	0	14		0	0	0	139961	0	243670	19059056		
57618	4784	40229134	1987-01-06	1987-01-06 00:00:00	1987-01-13	1987-01-13 00:00:00	1987-01-13	38000177		0	0	7		0	0	0	318495	0	1043400	40229134		
57690	4792	19133873	1951-06-17	1951-06-17 00:00:00	1951-06-25	1951-06-25 00:00:00	1951-06-25	38000177		0	0	8		0	0	0	318831	0	834061	19133873		
48882	4053	1127433	1965-06-18	1965-06-18 00:00:00	1965-06-25	1965-06-25 00:00:00	1965-06-25	38000177		0	0	7		0	0	0	269448	0	313782	1127433		
116363	2556	40213160	1968-09-02	1968-09-02 00:00:00	1968-09-02	1968-09-02 00:00:00	1968-09-02	581452		0	0	0		0	0	0	169423	0	10	40213160		
33162	2750	19133905	2000-09-10	2000-09-10 00:00:00	2000-09-19	2000-09-19 00:00:00	2000-09-19	38000177		0	0	9		0	0	0	181922	0	834102	19133905		
46727	3871	40229134	2010-12-15	2010-12-15 00:00:00	2010-12-22	2010-12-22 00:00:00	2010-12-22	38000177		0	0	7		0	0	0	257022	0	1043400	40229134		
43193	3578	19059056	1973-11-25	1973-11-25 00:00:00	1973-12-09	1973-12-09 00:00:00	1973-12-09	38000177		0	0	14		0	0	0	237865	0	243670	19059056		
58460	4855	19019979	1978-06-07	1978-06-07 00:00:00	1978-06-21	1978-06-21 00:00:00	1978-06-21	38000177		0	0	14		0	0	0	323030	0	198405	19019979		
57334	4758	40229134	1985-05-08	1985-05-08 00:00:00	1985-05-15	1985-05-15 00:00:00	1985-05-15	38000177		0	0	7		0	0	0	317027	0	1043400	40229134		
6123	512	1118084	1993-02-24	1993-02-24 00:00:00	1993-02-24	1993-02-24 00:00:00	\N	38000177		0	0	0		0	0	0	34194	0	00025152531	44923712		
44712	3700	19059056	1970-03-13	1970-03-13 00:00:00	1970-03-27	1970-03-27 00:00:00	1970-03-27	38000177		0	0	14		0	0	0	245967	0	243670	19059056		
31443	685	40213160	1966-07-18	1966-07-18 00:00:00	1966-07-18	1966-07-18 00:00:00	1966-07-18	581452		0	0	0		0	0	0	45266	0	10	40213160		
7180	603	40229134	1973-05-10	1973-05-10 00:00:00	1973-05-24	1973-05-24 00:00:00	1973-05-24	38000177		0	0	14		0	0	0	39956	0	1043400	40229134		
9822	823	40165015	2011-07-23	2011-07-23 00:00:00	2011-07-23	2011-07-23 00:00:00	\N	38000177		0	0	0		0	0	0	54557	0	861467	40165015		
7297	610	40229134	1998-01-28	1998-01-28 00:00:00	1998-02-11	1998-02-11 00:00:00	1998-02-11	38000177		0	0	14		0	0	0	40567	0	1043400	40229134		
48189	3995	1127078	1974-02-27	1974-02-27 00:00:00	1974-05-28	1974-05-28 00:00:00	1974-05-28	38000177		0	0	90		0	0	0	265612	0	282464	1127078		
27366	2264	1124300	2009-06-15	2009-06-15 00:00:00	2009-06-15	2009-06-15 00:00:00	\N	38000177		0	0	0		0	0	0	150476	0	00781178901	45011828		
3067	248	19019979	1982-11-07	1982-11-07 00:00:00	1982-12-07	1982-12-07 00:00:00	1982-12-07	38000177		0	0	30		0	0	0	16664	0	198405	19019979		
7787	651	1118084	2012-04-11	2012-04-11 00:00:00	2012-04-11	2012-04-11 00:00:00	\N	38000177		0	0	0		0	0	0	43096	0	00025152531	44923712		
49134	4078	1713671	1952-08-08	1952-08-08 00:00:00	1952-08-22	1952-08-22 00:00:00	1952-08-22	38000177		0	0	14		0	0	0	271013	0	562251	1713671		
27437	2270	19128065	1996-05-06	1996-05-06 00:00:00	1997-05-01	1997-05-01 00:00:00	1997-05-01	38000177		0	0	360		0	0	0	150926	0	749882	19128065		
13722	1146	40165015	2001-09-11	2001-09-11 00:00:00	2001-09-11	2001-09-11 00:00:00	\N	38000177		0	0	0		0	0	0	75753	0	861467	40165015		
160516	3532	40213160	1970-10-18	1970-10-18 00:00:00	1970-10-18	1970-10-18 00:00:00	1970-10-18	581452		0	0	0		0	0	0	234601	0	10	40213160		
20004	1641	19059056	1964-06-13	1964-06-13 00:00:00	1964-07-04	1964-07-04 00:00:00	1964-07-04	38000177		0	0	21		0	0	0	110174	0	243670	19059056		
41733	3455	40165015	2012-08-08	2012-08-08 00:00:00	2012-08-08	2012-08-08 00:00:00	\N	38000177		0	0	0		0	0	0	229260	0	861467	40165015		
27143	2238	40169216	1971-08-11	1971-08-11 00:00:00	1971-08-11	1971-08-11 00:00:00	\N	38000177		0	0	0		0	0	0	148888	0	895994	40169216		
27698	603	40213296	1997-11-28	1997-11-28 00:00:00	1997-11-28	1997-11-28 00:00:00	1997-11-28	581452		0	0	0		0	0	0	39904	0	52	40213296		
39577	3272	1118084	2004-09-18	2004-09-18 00:00:00	2004-09-18	2004-09-18 00:00:00	\N	38000177		0	0	0		0	0	0	217446	0	00025152531	44923712		
819	18	40213296	2005-11-23	2005-11-23 00:00:00	2005-11-23	2005-11-23 00:00:00	2005-11-23	581452		0	0	0		0	0	0	1428	0	52	40213296		
42538	3528	1713671	1965-02-05	1965-02-05 00:00:00	1965-02-26	1965-02-26 00:00:00	1965-02-26	38000177		0	0	21		0	0	0	234229	0	562251	1713671		
40911	3392	19006318	1969-04-19	1969-04-19 00:00:00	1969-05-03	1969-05-03 00:00:00	1969-05-03	38000177		0	0	14		0	0	0	224992	0	105078	19006318		
63145	5245	1115171	2001-09-18	2001-09-18 00:00:00	2001-10-16	2001-10-16 00:00:00	2001-10-16	38000177		0	0	28		0	0	0	348935	0	849574	1115171		
43063	3569	19059056	1966-01-26	1966-01-26 00:00:00	1966-02-16	1966-02-16 00:00:00	1966-02-16	38000177		0	0	21		0	0	0	237186	0	243670	19059056		
20811	1716	19006318	1951-10-31	1951-10-31 00:00:00	1951-11-14	1951-11-14 00:00:00	1951-11-14	38000177		0	0	14		0	0	0	114669	0	105078	19006318		
181985	3998	40213201	2013-11-14	2013-11-14 00:00:00	2013-11-14	2013-11-14 00:00:00	2013-11-14	581452		0	0	0		0	0	0	265857	0	33	40213201		
53252	4423	1127078	1977-07-12	1977-07-12 00:00:00	1977-07-26	1977-07-26 00:00:00	1977-07-26	38000177		0	0	14		0	0	0	294110	0	282464	1127078		
59025	4905	1127433	1988-06-08	1988-06-08 00:00:00	1988-06-29	1988-06-29 00:00:00	1988-06-29	38000177		0	0	21		0	0	0	326058	0	313782	1127433		
18005	1491	40231925	1995-08-07	1995-08-07 00:00:00	1995-08-07	1995-08-07 00:00:00	\N	38000177		0	0	0		0	0	0	99454	0	1049221	40231925		
194557	4275	40213306	2003-04-21	2003-04-21 00:00:00	2003-04-21	2003-04-21 00:00:00	2003-04-21	581452		0	0	0		0	0	0	283695	0	43	40213306		
46016	3811	40222846	2007-02-14	2007-02-14 00:00:00	2007-02-14	2007-02-14 00:00:00	\N	38000177		0	0	0		0	0	0	253218	0	996740	40222846		
46066	3817	1127433	1995-10-08	1995-10-08 00:00:00	1995-12-07	1995-12-07 00:00:00	1995-12-07	38000177		0	0	60		0	0	0	253529	0	313782	1127433		
44954	3719	40222846	2013-04-27	2013-04-27 00:00:00	2013-04-27	2013-04-27 00:00:00	\N	38000177		0	0	0		0	0	0	247163	0	996740	40222846		
55472	4607	19133873	1973-09-15	1973-09-15 00:00:00	1973-09-26	1973-09-26 00:00:00	1973-09-26	38000177		0	0	11		0	0	0	306918	0	834061	19133873		
13106	283	40213160	1985-01-28	1985-01-28 00:00:00	1985-01-28	1985-01-28 00:00:00	1985-01-28	581452		0	0	0		0	0	0	\N	0	10	40213160		
1775	143	19059056	1965-11-26	1965-11-26 00:00:00	1965-12-10	1965-12-10 00:00:00	1965-12-10	38000177		0	0	14		0	0	0	9575	0	243670	19059056		
33916	2804	1713671	1973-11-02	1973-11-02 00:00:00	1973-11-23	1973-11-23 00:00:00	1973-11-23	38000177		0	0	21		0	0	0	185879	0	562251	1713671		
60623	5043	19078461	1994-08-26	1994-08-26 00:00:00	1994-11-01	1994-11-01 00:00:00	1994-11-01	38000177		0	0	67		0	0	0	335130	0	310965	19078461		
102939	2258	40213227	2007-12-06	2007-12-06 00:00:00	2007-12-06	2007-12-06 00:00:00	2007-12-06	581452		0	0	0		0	0	0	150054	0	113	40213227		
45467	3761	1127078	1958-01-11	1958-01-11 00:00:00	1958-02-08	1958-02-08 00:00:00	1958-02-08	38000177		0	0	28		0	0	0	250042	0	282464	1127078		
47367	3926	1124300	1988-01-07	1988-01-07 00:00:00	1988-01-07	1988-01-07 00:00:00	\N	38000177		0	0	0		0	0	0	260984	0	00781178901	45011828		
37419	3092	1127433	2007-06-08	2007-06-08 00:00:00	2007-06-22	2007-06-22 00:00:00	2007-06-22	38000177		0	0	14		0	0	0	205907	0	313782	1127433		
56550	4691	1713671	1973-11-15	1973-11-15 00:00:00	1973-11-29	1973-11-29 00:00:00	1973-11-29	38000177		0	0	14		0	0	0	312573	0	562251	1713671		
6424	539	19074679	1933-03-26	1933-03-26 00:00:00	1933-07-09	1933-07-09 00:00:00	1933-07-09	38000177		0	0	105		0	0	0	35823	0	308971	19074679		
4184	348	1713671	1977-05-25	1977-05-25 00:00:00	1977-06-08	1977-06-08 00:00:00	1977-06-08	38000177		0	0	14		0	0	0	23140	0	562251	1713671		
15832	1316	19059056	1959-12-28	1959-12-28 00:00:00	1960-01-18	1960-01-18 00:00:00	1960-01-18	38000177		0	0	21		0	0	0	87220	0	243670	19059056		
15881	1318	19059056	1972-07-10	1972-07-10 00:00:00	1972-07-31	1972-07-31 00:00:00	1972-07-31	38000177		0	0	21		0	0	0	87400	0	243670	19059056		
59797	4971	19126352	1995-11-07	1995-11-07 00:00:00	1995-11-07	1995-11-07 00:00:00	\N	38000177		0	0	0		0	0	0	330503	0	705129	19126352		
15985	1325	1118084	2000-12-19	2000-12-19 00:00:00	2000-12-19	2000-12-19 00:00:00	\N	38000177		0	0	0		0	0	0	87985	0	00025152531	44923712		
30384	662	40213160	1960-12-27	1960-12-27 00:00:00	1960-12-27	1960-12-27 00:00:00	1960-12-27	581452		0	0	0		0	0	0	43686	0	10	40213160		
2193	176	40229134	1966-08-19	1966-08-19 00:00:00	1966-08-26	1966-08-26 00:00:00	1966-08-26	38000177		0	0	7		0	0	0	11896	0	1043400	40229134		
237128	5206	40213296	2018-10-27	2018-10-27 00:00:00	2018-10-27	2018-10-27 00:00:00	2018-10-27	581452		0	0	0		0	0	0	346302	0	52	40213296		
7896	170	40213296	2012-01-05	2012-01-05 00:00:00	2012-01-05	2012-01-05 00:00:00	2012-01-05	581452		0	0	0		0	0	0	11559	0	52	40213296		
25524	2097	1115171	1998-10-23	1998-10-23 00:00:00	1998-11-27	1998-11-27 00:00:00	1998-11-27	38000177		0	0	35		0	0	0	139810	0	849574	1115171		
36023	2965	1127433	2008-11-28	2008-11-28 00:00:00	2008-12-05	2008-12-05 00:00:00	2008-12-05	38000177		0	0	7		0	0	0	197900	0	313782	1127433		
57619	4784	1127433	2009-05-16	2009-05-16 00:00:00	2009-05-23	2009-05-23 00:00:00	2009-05-23	38000177		0	0	7		0	0	0	318432	0	313782	1127433		
57691	4792	1127433	1962-10-30	1962-10-30 00:00:00	1962-11-06	1962-11-06 00:00:00	1962-11-06	38000177		0	0	7		0	0	0	318876	0	313782	1127433		
48883	4053	1127433	2015-12-29	2015-12-29 00:00:00	2016-01-05	2016-01-05 00:00:00	2016-01-05	38000177		0	0	7		0	0	0	269468	0	313782	1127433		
116370	2556	40213227	1999-08-23	1999-08-23 00:00:00	1999-08-23	1999-08-23 00:00:00	1999-08-23	581452		0	0	0		0	0	0	169384	0	113	40213227		
33163	2750	40229134	1956-01-05	1956-01-05 00:00:00	1956-01-12	1956-01-12 00:00:00	1956-01-12	38000177		0	0	7		0	0	0	181944	0	1043400	40229134		
46728	3871	19133873	1966-05-25	1966-05-25 00:00:00	1966-06-05	1966-06-05 00:00:00	1966-06-05	38000177		0	0	11		0	0	0	257007	0	834061	19133873		
43194	3578	19073188	1991-01-10	1991-01-10 00:00:00	1991-01-24	1991-01-24 00:00:00	1991-01-24	38000177		0	0	14		0	0	0	237870	0	308192	19073188		
58461	4855	920300	2004-10-01	2004-10-01 00:00:00	2004-10-08	2004-10-08 00:00:00	2004-10-08	38000177		0	0	7		0	0	0	323019	0	311989	920300		
57335	4758	1713671	1969-09-29	1969-09-29 00:00:00	1969-10-13	1969-10-13 00:00:00	1969-10-13	38000177		0	0	14		0	0	0	317026	0	562251	1713671		
6124	512	19059056	1970-01-24	1970-01-24 00:00:00	1970-03-02	1970-03-02 00:00:00	1970-03-02	38000177		0	0	37		0	0	0	34170	0	243670	19059056		
44713	3700	40162522	2010-04-03	2010-04-03 00:00:00	2010-04-03	2010-04-03 00:00:00	\N	38000177		0	0	0		0	0	0	246010	0	857005	40162522		
31446	685	40213260	2016-02-08	2016-02-08 00:00:00	2016-02-08	2016-02-08 00:00:00	2016-02-08	581452		0	0	0		0	0	0	45328	0	121	40213260		
7181	603	19133873	1960-11-17	1960-11-17 00:00:00	1960-11-30	1960-11-30 00:00:00	1960-11-30	38000177		0	0	13		0	0	0	39934	0	834061	19133873		
9823	823	1115171	2011-07-23	2011-07-23 00:00:00	2011-09-21	2011-09-21 00:00:00	2011-09-21	38000177		0	0	60		0	0	0	54557	0	849574	1115171		
7298	610	1127078	1965-06-29	1965-06-29 00:00:00	1965-07-13	1965-07-13 00:00:00	1965-07-13	38000177		0	0	14		0	0	0	40476	0	282464	1127078		
48190	3995	19128065	1986-02-04	1986-02-04 00:00:00	1987-01-30	1987-01-30 00:00:00	1987-01-30	38000177		0	0	360		0	0	0	265597	0	749882	19128065		
27367	2264	40236824	1989-05-31	1989-05-31 00:00:00	1989-06-07	1989-06-07 00:00:00	1989-06-07	38000177		0	0	7		0	0	0	150428	0	1094107	40236824		
3068	249	42902245	1998-08-03	1998-08-03 00:00:00	1999-07-29	1999-07-29 00:00:00	1999-07-29	38000177		0	0	360		0	0	0	16740	0	1359133	42902245		
7788	651	40236824	2014-07-29	2014-07-29 00:00:00	2014-08-05	2014-08-05 00:00:00	2014-08-05	38000177		0	0	7		0	0	0	43098	0	1094107	40236824		
49135	4078	19112599	1953-08-26	1953-08-26 00:00:00	1953-08-26	1953-08-26 00:00:00	\N	38000177		0	0	0		0	0	0	270949	0	477045	19112599		
27438	2270	42902245	1998-04-26	1998-04-26 00:00:00	1999-04-21	1999-04-21 00:00:00	1999-04-21	38000177		0	0	360		0	0	0	150927	0	1359133	42902245		
13723	1146	19078461	2001-09-11	2001-09-11 00:00:00	2001-10-11	2001-10-11 00:00:00	2001-10-11	38000177		0	0	30		0	0	0	75753	0	310965	19078461		
160519	3532	40213160	1975-06-22	1975-06-22 00:00:00	1975-06-22	1975-06-22 00:00:00	1975-06-22	581452		0	0	0		0	0	0	234642	0	10	40213160		
20005	1642	19059056	1951-11-18	1951-11-18 00:00:00	1951-12-02	1951-12-02 00:00:00	1951-12-02	38000177		0	0	14		0	0	0	110203	0	243670	19059056		
41734	3455	19128022	1991-04-11	1991-04-11 00:00:00	1992-04-05	1992-04-05 00:00:00	1992-04-05	38000177		0	0	360		0	0	0	229237	0	749785	19128022		
27144	2238	1127433	1978-10-13	1978-10-13 00:00:00	1978-10-27	1978-10-27 00:00:00	1978-10-27	38000177		0	0	14		0	0	0	148933	0	313782	1127433		
27700	603	40213227	2007-03-16	2007-03-16 00:00:00	2007-03-16	2007-03-16 00:00:00	2007-03-16	581452		0	0	0		0	0	0	39992	0	113	40213227		
39578	3272	1127433	1988-01-07	1988-01-07 00:00:00	1988-01-14	1988-01-14 00:00:00	1988-01-14	38000177		0	0	7		0	0	0	217441	0	313782	1127433		
824	18	40213296	2006-12-06	2006-12-06 00:00:00	2006-12-06	2006-12-06 00:00:00	2006-12-06	581452		0	0	0		0	0	0	1442	0	52	40213296		
42539	3528	1127433	1993-08-31	1993-08-31 00:00:00	1993-09-28	1993-09-28 00:00:00	1993-09-28	38000177		0	0	28		0	0	0	234281	0	313782	1127433		
40912	3392	1127078	1969-04-19	1969-04-19 00:00:00	1969-05-03	1969-05-03 00:00:00	1969-05-03	38000177		0	0	14		0	0	0	224992	0	282464	1127078		
63146	5245	1118084	2015-12-10	2015-12-10 00:00:00	2015-12-10	2015-12-10 00:00:00	\N	38000177		0	0	0		0	0	0	349037	0	00025152531	44923712		
43064	3569	1127433	1972-07-25	1972-07-25 00:00:00	1972-08-01	1972-08-01 00:00:00	1972-08-01	38000177		0	0	7		0	0	0	237128	0	313782	1127433		
20812	1716	19059056	1951-10-31	1951-10-31 00:00:00	1951-11-14	1951-11-14 00:00:00	1951-11-14	38000177		0	0	14		0	0	0	114669	0	243670	19059056		
181989	3998	40213227	1998-06-18	1998-06-18 00:00:00	1998-06-18	1998-06-18 00:00:00	1998-06-18	581452		0	0	0		0	0	0	265830	0	113	40213227		
53253	4423	40229134	1998-09-22	1998-09-22 00:00:00	1998-09-29	1998-09-29 00:00:00	1998-09-29	38000177		0	0	7		0	0	0	294109	0	1043400	40229134		
208115	4565	40213201	2012-04-24	2012-04-24 00:00:00	2012-04-24	2012-04-24 00:00:00	2012-04-24	581452		0	0	0		0	0	0	304196	0	33	40213201		
18006	1491	19059056	1990-10-11	1990-10-11 00:00:00	1990-11-01	1990-11-01 00:00:00	1990-11-01	38000177		0	0	21		0	0	0	99453	0	243670	19059056		
194561	4275	40213314	1980-06-23	1980-06-23 00:00:00	1980-06-23	1980-06-23 00:00:00	1980-06-23	581452		0	0	0		0	0	0	283689	0	49	40213314		
46017	3811	19059056	1945-04-17	1945-04-17 00:00:00	1945-05-08	1945-05-08 00:00:00	1945-05-08	38000177		0	0	21		0	0	0	253141	0	243670	19059056		
46067	3817	40165015	1995-10-08	1995-10-08 00:00:00	1995-10-08	1995-10-08 00:00:00	\N	38000177		0	0	0		0	0	0	253529	0	861467	40165015		
44955	3719	19077572	2012-01-03	2012-01-03 00:00:00	2012-01-03	2012-01-03 00:00:00	\N	38000177		0	0	0		0	0	0	247188	0	310436	19077572		
55473	4607	1124300	2014-12-30	2014-12-30 00:00:00	2014-12-30	2014-12-30 00:00:00	\N	38000177		0	0	0		0	0	0	306907	0	00781178901	45011828		
13107	283	40213251	1985-01-28	1985-01-28 00:00:00	1985-01-28	1985-01-28 00:00:00	1985-01-28	581452		0	0	0		0	0	0	\N	0	21	40213251		
1776	143	19129655	1965-11-26	1965-11-26 00:00:00	1965-12-10	1965-12-10 00:00:00	1965-12-10	38000177		0	0	14		0	0	0	9575	0	789980	19129655		
33917	2804	1118084	1990-06-17	1990-06-17 00:00:00	1990-06-17	1990-06-17 00:00:00	\N	38000177		0	0	0		0	0	0	185883	0	00025152531	44923712		
60624	5043	19128065	1994-11-04	1994-11-04 00:00:00	1995-10-30	1995-10-30 00:00:00	1995-10-30	38000177		0	0	360		0	0	0	335139	0	749882	19128065		
102944	2258	40213227	1997-07-03	1997-07-03 00:00:00	1997-07-03	1997-07-03 00:00:00	1997-07-03	581452		0	0	0		0	0	0	150108	0	113	40213227		
45468	3761	19129655	1961-11-16	1961-11-16 00:00:00	1961-11-30	1961-11-30 00:00:00	1961-11-30	38000177		0	0	14		0	0	0	250115	0	789980	19129655		
47368	3926	19059056	1963-07-14	1963-07-14 00:00:00	1963-07-28	1963-07-28 00:00:00	1963-07-28	38000177		0	0	14		0	0	0	261007	0	243670	19059056		
37420	3092	1713671	2013-07-24	2013-07-24 00:00:00	2013-08-14	2013-08-14 00:00:00	2013-08-14	38000177		0	0	21		0	0	0	205885	0	562251	1713671		
56551	4691	19059056	1978-12-29	1978-12-29 00:00:00	1979-01-28	1979-01-28 00:00:00	1979-01-28	38000177		0	0	30		0	0	0	312598	0	243670	19059056		
54121	4497	19006318	1958-06-01	1958-06-01 00:00:00	1958-06-15	1958-06-15 00:00:00	1958-06-15	38000177		0	0	14		0	0	0	299386	0	105078	19006318		
4185	348	1115171	1994-03-25	1994-03-25 00:00:00	1994-04-15	1994-04-15 00:00:00	1994-04-15	38000177		0	0	21		0	0	0	23118	0	849574	1115171		
15833	1316	1127433	1953-03-23	1953-03-23 00:00:00	1953-03-30	1953-03-30 00:00:00	1953-03-30	38000177		0	0	7		0	0	0	87217	0	313782	1127433		
15882	1318	1118084	1973-02-17	1973-02-17 00:00:00	1973-02-17	1973-02-17 00:00:00	\N	38000177		0	0	0		0	0	0	87400	0	00025152531	44923712		
59798	4971	1332419	1995-11-07	1995-11-07 00:00:00	1995-11-07	1995-11-07 00:00:00	\N	38000177		0	0	0		0	0	0	330503	0	197361	1332419		
15986	1325	1127433	1989-12-27	1989-12-27 00:00:00	1990-01-10	1990-01-10 00:00:00	1990-01-10	38000177		0	0	14		0	0	0	87937	0	313782	1127433		
30392	662	40213227	1992-03-17	1992-03-17 00:00:00	1992-03-17	1992-03-17 00:00:00	1992-03-17	581452		0	0	0		0	0	0	43692	0	113	40213227		
2194	176	40229134	1986-08-20	1986-08-20 00:00:00	1986-09-03	1986-09-03 00:00:00	1986-09-03	38000177		0	0	14		0	0	0	11905	0	1043400	40229134		
237130	5206	40213296	2016-10-22	2016-10-22 00:00:00	2016-10-22	2016-10-22 00:00:00	2016-10-22	581452		0	0	0		0	0	0	346270	0	52	40213296		
12069	260	40213306	1991-08-31	1991-08-31 00:00:00	1991-08-31	1991-08-31 00:00:00	1991-08-31	581452		0	0	0		0	0	0	17208	0	43	40213306		
25525	2097	1713671	2009-11-20	2009-11-20 00:00:00	2009-12-04	2009-12-04 00:00:00	2009-12-04	38000177		0	0	14		0	0	0	139763	0	562251	1713671		
36024	2966	1713671	2018-02-05	2018-02-05 00:00:00	2018-02-26	2018-02-26 00:00:00	2018-02-26	38000177		0	0	21		0	0	0	198052	0	562251	1713671		
57620	4784	1124300	1987-11-08	1987-11-08 00:00:00	1987-11-08	1987-11-08 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00781178901	45011828		
19889	1634	40236824	1974-10-08	1974-10-08 00:00:00	1974-10-15	1974-10-15 00:00:00	1974-10-15	38000177		0	0	7		0	0	0	109783	0	1094107	40236824		
48884	4053	1115171	2014-09-24	2014-09-24 00:00:00	2014-10-08	2014-10-08 00:00:00	2014-10-08	38000177		0	0	14		0	0	0	269420	0	849574	1115171		
116373	2556	40213160	1968-06-03	1968-06-03 00:00:00	1968-06-03	1968-06-03 00:00:00	1968-06-03	581452		0	0	0		0	0	0	169397	0	10	40213160		
33164	2750	1127433	1935-03-18	1935-03-18 00:00:00	1935-03-25	1935-03-25 00:00:00	1935-03-25	38000177		0	0	7		0	0	0	181886	0	313782	1127433		
46729	3871	1127078	1968-01-14	1968-01-14 00:00:00	1968-01-28	1968-01-28 00:00:00	1968-01-28	38000177		0	0	14		0	0	0	257039	0	282464	1127078		
43195	3578	19059056	1991-01-10	1991-01-10 00:00:00	1991-01-24	1991-01-24 00:00:00	1991-01-24	38000177		0	0	14		0	0	0	237870	0	243670	19059056		
58462	4855	19133873	1984-11-03	1984-11-03 00:00:00	1984-11-14	1984-11-14 00:00:00	1984-11-14	38000177		0	0	11		0	0	0	323004	0	834061	19133873		
57336	4758	1713671	1979-10-24	1979-10-24 00:00:00	1979-10-31	1979-10-31 00:00:00	1979-10-31	38000177		0	0	7		0	0	0	316971	0	562251	1713671		
6125	512	19078461	2013-07-14	2013-07-14 00:00:00	2013-07-28	2013-07-28 00:00:00	2013-07-28	38000177		0	0	14		0	0	0	34171	0	310965	19078461		
44714	3700	19078461	2010-04-03	2010-04-03 00:00:00	2010-04-24	2010-04-24 00:00:00	2010-04-24	38000177		0	0	21		0	0	0	246010	0	310965	19078461		
104786	2298	40213160	1971-04-08	1971-04-08 00:00:00	1971-04-08	1971-04-08 00:00:00	1971-04-08	581452		0	0	0		0	0	0	152991	0	10	40213160		
7182	603	19074841	1985-05-31	1985-05-31 00:00:00	1985-06-14	1985-06-14 00:00:00	1985-06-14	38000177		0	0	14		0	0	0	39979	0	309043	19074841		
9824	823	40173590	2005-01-17	2005-01-17 00:00:00	2005-01-17	2005-01-17 00:00:00	\N	38000177		0	0	0		0	0	0	54579	0	904419	40173590		
7299	610	1127433	1977-10-10	1977-10-10 00:00:00	1977-10-24	1977-10-24 00:00:00	1977-10-24	38000177		0	0	14		0	0	0	40569	0	313782	1127433		
48191	3995	1127078	1978-01-07	1978-01-07 00:00:00	1978-01-21	1978-01-21 00:00:00	1978-01-21	38000177		0	0	14		0	0	0	265613	0	282464	1127078		
27368	2264	920300	1989-05-31	1989-05-31 00:00:00	1989-06-07	1989-06-07 00:00:00	1989-06-07	38000177		0	0	7		0	0	0	150428	0	311989	920300		
3069	249	19128022	1995-08-19	1995-08-19 00:00:00	1996-08-13	1996-08-13 00:00:00	1996-08-13	38000177		0	0	360		0	0	0	16738	0	749785	19128022		
7789	651	920300	2014-07-29	2014-07-29 00:00:00	2014-08-05	2014-08-05 00:00:00	2014-08-05	38000177		0	0	7		0	0	0	43098	0	311989	920300		
49136	4078	1127433	1967-09-12	1967-09-12 00:00:00	1967-09-19	1967-09-19 00:00:00	1967-09-19	38000177		0	0	7		0	0	0	270950	0	313782	1127433		
27439	2270	40236824	2001-06-19	2001-06-19 00:00:00	2001-06-26	2001-06-26 00:00:00	2001-06-26	38000177		0	0	7		0	0	0	150925	0	1094107	40236824		
24141	525	40213227	2000-04-10	2000-04-10 00:00:00	2000-04-10	2000-04-10 00:00:00	2000-04-10	581452		0	0	0		0	0	0	35005	0	113	40213227		
148706	3270	40213160	1970-12-03	1970-12-03 00:00:00	1970-12-03	1970-12-03 00:00:00	1970-12-03	581452		0	0	0		0	0	0	217340	0	10	40213160		
20007	1642	19128065	1975-03-27	1975-03-27 00:00:00	1976-03-21	1976-03-21 00:00:00	1976-03-21	38000177		0	0	360		0	0	0	110216	0	749882	19128065		
41735	3455	920334	1998-07-11	1998-07-11 00:00:00	1998-07-18	1998-07-18 00:00:00	1998-07-18	38000177		0	0	7		0	0	0	229235	0	311995	920334		
27145	2238	1127433	1986-04-23	1986-04-23 00:00:00	1986-05-07	1986-05-07 00:00:00	1986-05-07	38000177		0	0	14		0	0	0	148890	0	313782	1127433		
27701	603	40213260	2007-03-16	2007-03-16 00:00:00	2007-03-16	2007-03-16 00:00:00	2007-03-16	581452		0	0	0		0	0	0	39992	0	121	40213260		
51332	4268	1115171	2016-12-07	2016-12-07 00:00:00	2016-12-28	2016-12-28 00:00:00	2016-12-28	38000177		0	0	21		0	0	0	283214	0	849574	1115171		
826	18	40213227	2006-12-06	2006-12-06 00:00:00	2006-12-06	2006-12-06 00:00:00	2006-12-06	581452		0	0	0		0	0	0	1442	0	113	40213227		
42541	3528	19115351	1960-10-10	1960-10-10 00:00:00	1961-07-31	1961-07-31 00:00:00	1961-07-31	38000177		0	0	294		0	0	0	234208	0	563026	19115351		
40913	3392	19128065	1981-12-22	1981-12-22 00:00:00	1982-12-17	1982-12-17 00:00:00	1982-12-17	38000177		0	0	360		0	0	0	224993	0	749882	19128065		
32520	709	40213227	2000-07-09	2000-07-09 00:00:00	2000-07-09	2000-07-09 00:00:00	2000-07-09	581452		0	0	0		0	0	0	46947	0	113	40213227		
43065	3569	19128065	1979-09-25	1979-09-25 00:00:00	1980-09-19	1980-09-19 00:00:00	1980-09-19	38000177		0	0	360		0	0	0	237202	0	749882	19128065		
20813	1716	1115171	2009-06-24	2009-06-24 00:00:00	2009-07-31	2009-07-31 00:00:00	2009-07-31	38000177		0	0	37		0	0	0	114708	0	849574	1115171		
181994	3998	40213198	2012-11-08	2012-11-08 00:00:00	2012-11-08	2012-11-08 00:00:00	2012-11-08	581452		0	0	0		0	0	0	265831	0	133	40213198		
4877	105	40213306	1988-05-27	1988-05-27 00:00:00	1988-05-27	1988-05-27 00:00:00	1988-05-27	581452		0	0	0		0	0	0	7135	0	43	40213306		
208116	4565	40213227	1996-08-13	1996-08-13 00:00:00	1996-08-13	1996-08-13 00:00:00	1996-08-13	581452		0	0	0		0	0	0	304172	0	113	40213227		
18007	1491	19129655	1970-08-27	1970-08-27 00:00:00	1970-09-10	1970-09-10 00:00:00	1970-09-10	38000177		0	0	14		0	0	0	99424	0	789980	19129655		
194562	4275	40213160	1980-06-23	1980-06-23 00:00:00	1980-06-23	1980-06-23 00:00:00	1980-06-23	581452		0	0	0		0	0	0	283689	0	10	40213160		
46018	3811	1127433	1963-10-02	1963-10-02 00:00:00	1963-10-16	1963-10-16 00:00:00	1963-10-16	38000177		0	0	14		0	0	0	253119	0	313782	1127433		
46068	3817	1118084	2000-05-29	2000-05-29 00:00:00	2000-05-29	2000-05-29 00:00:00	\N	38000177		0	0	0		0	0	0	253499	0	00025152531	44923712		
44957	3719	19078461	2004-06-04	2004-06-04 00:00:00	2004-09-02	2004-09-02 00:00:00	2004-09-02	38000177		0	0	90		0	0	0	247169	0	310965	19078461		
55474	4607	19078461	1984-10-13	1984-10-13 00:00:00	1984-11-03	1984-11-03 00:00:00	1984-11-03	38000177		0	0	21		0	0	0	306874	0	310965	19078461		
13117	283	40213227	2012-07-30	2012-07-30 00:00:00	2012-07-30	2012-07-30 00:00:00	2012-07-30	581452		0	0	0		0	0	0	18876	0	113	40213227		
1777	143	1115171	2004-08-24	2004-08-24 00:00:00	2004-09-28	2004-09-28 00:00:00	2004-09-28	38000177		0	0	35		0	0	0	9611	0	849574	1115171		
33923	2806	19059056	1958-05-20	1958-05-20 00:00:00	1958-06-03	1958-06-03 00:00:00	1958-06-03	38000177		0	0	14		0	0	0	185956	0	243670	19059056		
60625	5043	19128022	1997-10-19	1997-10-19 00:00:00	1998-10-14	1998-10-14 00:00:00	1998-10-14	38000177		0	0	360		0	0	0	335161	0	749785	19128022		
102945	2258	40213296	1997-07-03	1997-07-03 00:00:00	1997-07-03	1997-07-03 00:00:00	1997-07-03	581452		0	0	0		0	0	0	150108	0	52	40213296		
45469	3761	19059056	1961-11-16	1961-11-16 00:00:00	1961-11-30	1961-11-30 00:00:00	1961-11-30	38000177		0	0	14		0	0	0	250115	0	243670	19059056		
47369	3926	1127433	1982-11-13	1982-11-13 00:00:00	1982-12-11	1982-12-11 00:00:00	1982-12-11	38000177		0	0	28		0	0	0	261010	0	313782	1127433		
37421	3092	1127433	1982-04-27	1982-04-27 00:00:00	1982-05-04	1982-05-04 00:00:00	1982-05-04	38000177		0	0	7		0	0	0	205867	0	313782	1127433		
56552	4691	40162522	1978-12-29	1978-12-29 00:00:00	1978-12-29	1978-12-29 00:00:00	\N	38000177		0	0	0		0	0	0	312598	0	857005	40162522		
54124	4497	19133873	1963-08-04	1963-08-04 00:00:00	1963-08-14	1963-08-14 00:00:00	1963-08-14	38000177		0	0	10		0	0	0	299396	0	834061	19133873		
4186	348	19073188	1994-03-25	1994-03-25 00:00:00	1994-04-15	1994-04-15 00:00:00	1994-04-15	38000177		0	0	21		0	0	0	23118	0	308192	19073188		
15834	1316	1127433	1976-09-26	1976-09-26 00:00:00	1976-10-03	1976-10-03 00:00:00	1976-10-03	38000177		0	0	7		0	0	0	87179	0	313782	1127433		
15883	1318	19059056	1941-05-21	1941-05-21 00:00:00	1941-06-04	1941-06-04 00:00:00	1941-06-04	38000177		0	0	14		0	0	0	87373	0	243670	19059056		
59799	4971	1539411	1995-11-07	1995-11-07 00:00:00	1995-11-07	1995-11-07 00:00:00	\N	38000177		0	0	0		0	0	0	330503	0	312961	1539411		
15987	1325	1713671	1987-11-09	1987-11-09 00:00:00	1987-11-23	1987-11-23 00:00:00	1987-11-23	38000177		0	0	14		0	0	0	87988	0	562251	1713671		
138585	3044	40213260	2019-01-22	2019-01-22 00:00:00	2019-01-22	2019-01-22 00:00:00	2019-01-22	581452		0	0	0		0	0	0	202603	0	121	40213260		
2195	177	1124300	2000-05-31	2000-05-31 00:00:00	2000-05-31	2000-05-31 00:00:00	\N	38000177		0	0	0		0	0	0	11990	0	00781178901	45011828		
237138	5206	40213306	1998-11-28	1998-11-28 00:00:00	1998-11-28	1998-11-28 00:00:00	1998-11-28	581452		0	0	0		0	0	0	346303	0	43	40213306		
12072	260	40213227	2011-07-23	2011-07-23 00:00:00	2011-07-23	2011-07-23 00:00:00	2011-07-23	581452		0	0	0		0	0	0	17243	0	113	40213227		
25526	2097	920300	1996-04-06	1996-04-06 00:00:00	1996-04-13	1996-04-13 00:00:00	1996-04-13	38000177		0	0	7		0	0	0	139777	0	311989	920300		
36025	2966	1127433	1989-01-07	1989-01-07 00:00:00	1989-01-21	1989-01-21 00:00:00	1989-01-21	38000177		0	0	14		0	0	0	198046	0	313782	1127433		
57621	4784	1713671	1970-02-17	1970-02-17 00:00:00	1970-03-03	1970-03-03 00:00:00	1970-03-03	38000177		0	0	14		0	0	0	318456	0	562251	1713671		
19890	1634	920300	1974-10-08	1974-10-08 00:00:00	1974-10-15	1974-10-15 00:00:00	1974-10-15	38000177		0	0	7		0	0	0	109783	0	311989	920300		
48885	4053	1118084	1999-03-07	1999-03-07 00:00:00	1999-03-07	1999-03-07 00:00:00	\N	38000177		0	0	0		0	0	0	269444	0	00025152531	44923712		
116374	2556	40213260	2017-12-25	2017-12-25 00:00:00	2017-12-25	2017-12-25 00:00:00	2017-12-25	581452		0	0	0		0	0	0	169406	0	121	40213260		
33165	2750	1127433	1997-02-03	1997-02-03 00:00:00	1997-02-17	1997-02-17 00:00:00	1997-02-17	38000177		0	0	14		0	0	0	181880	0	313782	1127433		
46730	3871	19129655	1968-01-14	1968-01-14 00:00:00	1968-01-28	1968-01-28 00:00:00	1968-01-28	38000177		0	0	14		0	0	0	257039	0	789980	19129655		
43196	3578	1713671	1983-12-09	1983-12-09 00:00:00	1983-12-16	1983-12-16 00:00:00	1983-12-16	38000177		0	0	7		0	0	0	237876	0	562251	1713671		
58463	4855	19128022	1993-08-27	1993-08-27 00:00:00	1994-08-22	1994-08-22 00:00:00	1994-08-22	38000177		0	0	360		0	0	0	323008	0	749785	19128022		
57337	4758	46275916	1989-08-13	1989-08-13 00:00:00	1989-08-13	1989-08-13 00:00:00	1989-08-13	38000177		0	0	0		0	0	0	316967	0	1660014	46275916		
27369	596	40213160	1955-08-09	1955-08-09 00:00:00	1955-08-09	1955-08-09 00:00:00	1955-08-09	581452		0	0	0		0	0	0	39342	0	10	40213160		
44715	3700	19073188	2010-04-03	2010-04-03 00:00:00	2010-04-24	2010-04-24 00:00:00	2010-04-24	38000177		0	0	21		0	0	0	246010	0	308192	19073188		
104795	2298	40213227	2012-03-22	2012-03-22 00:00:00	2012-03-22	2012-03-22 00:00:00	2012-03-22	581452		0	0	0		0	0	0	152983	0	113	40213227		
7183	603	1127433	1985-05-31	1985-05-31 00:00:00	1985-06-14	1985-06-14 00:00:00	1985-06-14	38000177		0	0	14		0	0	0	39979	0	313782	1127433		
9825	823	1713671	1980-05-24	1980-05-24 00:00:00	1980-06-14	1980-06-14 00:00:00	1980-06-14	38000177		0	0	21		0	0	0	54512	0	562251	1713671		
7300	610	46233710	1977-10-10	1977-10-10 00:00:00	1977-10-24	1977-10-24 00:00:00	1977-10-24	38000177		0	0	14		0	0	0	40569	0	1650142	46233710		
48192	3995	1713671	1986-09-30	1986-09-30 00:00:00	1986-10-07	1986-10-07 00:00:00	1986-10-07	38000177		0	0	7		0	0	0	265591	0	562251	1713671		
27369	2264	46233988	1972-03-26	1972-03-26 00:00:00	1972-04-09	1972-04-09 00:00:00	1972-04-09	38000177		0	0	14		0	0	0	150437	0	1652673	46233988		
3070	249	19127922	2002-07-13	2002-07-13 00:00:00	2003-07-08	2003-07-08 00:00:00	2003-07-08	38000177		0	0	360		0	0	0	16769	0	748962	19127922		
7790	651	1713671	1995-02-28	1995-02-28 00:00:00	1995-03-07	1995-03-07 00:00:00	1995-03-07	38000177		0	0	7		0	0	0	43100	0	562251	1713671		
59616	4957	1127433	1977-02-04	1977-02-04 00:00:00	1977-02-11	1977-02-11 00:00:00	1977-02-11	38000177		0	0	7		0	0	0	329513	0	313782	1127433		
27440	2270	920300	2001-06-19	2001-06-19 00:00:00	2001-06-26	2001-06-26 00:00:00	2001-06-26	38000177		0	0	7		0	0	0	150925	0	311989	920300		
24153	525	40213160	1955-03-21	1955-03-21 00:00:00	1955-03-21	1955-03-21 00:00:00	1955-03-21	581452		0	0	0		0	0	0	35033	0	10	40213160		
148707	3270	40213227	2001-06-07	2001-06-07 00:00:00	2001-06-07	2001-06-07 00:00:00	2001-06-07	581452		0	0	0		0	0	0	217349	0	113	40213227		
31094	677	40213306	1983-08-05	1983-08-05 00:00:00	1983-08-05	1983-08-05 00:00:00	1983-08-05	581452		0	0	0		0	0	0	44794	0	43	40213306		
41736	3455	1127433	2014-08-19	2014-08-19 00:00:00	2014-09-18	2014-09-18 00:00:00	2014-09-18	38000177		0	0	30		0	0	0	229261	0	313782	1127433		
27146	2238	1127433	2005-08-16	2005-08-16 00:00:00	2005-09-06	2005-09-06 00:00:00	2005-09-06	38000177		0	0	21		0	0	0	148929	0	313782	1127433		
27703	603	40213160	1956-11-16	1956-11-16 00:00:00	1956-11-16	1956-11-16 00:00:00	1956-11-16	581452		0	0	0		0	0	0	40010	0	10	40213160		
51333	4268	19078461	2012-05-18	2012-05-18 00:00:00	2012-06-01	2012-06-01 00:00:00	2012-06-01	38000177		0	0	14		0	0	0	283213	0	310965	19078461		
828	18	40213260	2015-12-30	2015-12-30 00:00:00	2015-12-30	2015-12-30 00:00:00	2015-12-30	581452		0	0	0		0	0	0	1421	0	121	40213260		
42542	3528	1127433	1961-12-19	1961-12-19 00:00:00	1962-01-02	1962-01-02 00:00:00	1962-01-02	38000177		0	0	14		0	0	0	234243	0	313782	1127433		
40914	3392	1127433	1968-04-25	1968-04-25 00:00:00	1968-05-09	1968-05-09 00:00:00	1968-05-09	38000177		0	0	14		0	0	0	224988	0	313782	1127433		
32523	709	40213160	1955-05-08	1955-05-08 00:00:00	1955-05-08	1955-05-08 00:00:00	1955-05-08	581452		0	0	0		0	0	0	46982	0	10	40213160		
43066	3569	19128065	1988-08-08	1988-08-08 00:00:00	1989-08-03	1989-08-03 00:00:00	1989-08-03	38000177		0	0	360		0	0	0	237168	0	749882	19128065		
20814	1716	1127433	1990-01-30	1990-01-30 00:00:00	1990-02-06	1990-02-06 00:00:00	1990-02-06	38000177		0	0	7		0	0	0	114622	0	313782	1127433		
159679	3514	40213314	1977-07-25	1977-07-25 00:00:00	1977-07-25	1977-07-25 00:00:00	1977-07-25	581452		0	0	0		0	0	0	233219	0	49	40213314		
4878	105	40213160	1965-09-17	1965-09-17 00:00:00	1965-09-17	1965-09-17 00:00:00	1965-09-17	581452		0	0	0		0	0	0	7138	0	10	40213160		
208124	4565	40213198	2011-04-19	2011-04-19 00:00:00	2011-04-19	2011-04-19 00:00:00	2011-04-19	581452		0	0	0		0	0	0	304175	0	133	40213198		
18008	1491	1127078	1970-08-27	1970-08-27 00:00:00	1970-09-10	1970-09-10 00:00:00	1970-09-10	38000177		0	0	14		0	0	0	99424	0	282464	1127078		
194566	4275	40213314	1980-04-20	1980-04-20 00:00:00	1980-04-20	1980-04-20 00:00:00	1980-04-20	581452		0	0	0		0	0	0	283718	0	49	40213314		
46019	3811	1127433	1932-05-17	1932-05-17 00:00:00	1932-05-24	1932-05-24 00:00:00	1932-05-24	38000177		0	0	7		0	0	0	253143	0	313782	1127433		
46069	3817	1127433	1997-06-12	1997-06-12 00:00:00	1997-06-19	1997-06-19 00:00:00	1997-06-19	38000177		0	0	7		0	0	0	253490	0	313782	1127433		
44958	3720	1713671	2016-07-25	2016-07-25 00:00:00	2016-08-08	2016-08-08 00:00:00	2016-08-08	38000177		0	0	14		0	0	0	247238	0	562251	1713671		
55475	4607	1127433	1998-01-04	1998-01-04 00:00:00	1998-01-11	1998-01-11 00:00:00	1998-01-11	38000177		0	0	7		0	0	0	306896	0	313782	1127433		
13121	283	40213314	1980-12-08	1980-12-08 00:00:00	1980-12-08	1980-12-08 00:00:00	1980-12-08	581452		0	0	0		0	0	0	18851	0	49	40213314		
1778	143	1713671	2007-12-18	2007-12-18 00:00:00	2008-01-08	2008-01-08 00:00:00	2008-01-08	38000177		0	0	21		0	0	0	9574	0	562251	1713671		
33924	2806	19006318	1958-05-20	1958-05-20 00:00:00	1958-06-03	1958-06-03 00:00:00	1958-06-03	38000177		0	0	14		0	0	0	185956	0	105078	19006318		
60626	5043	19128065	1992-11-14	1992-11-14 00:00:00	1993-11-09	1993-11-09 00:00:00	1993-11-09	38000177		0	0	360		0	0	0	335137	0	749882	19128065		
232893	5117	40213227	2009-03-16	2009-03-16 00:00:00	2009-03-16	2009-03-16 00:00:00	2009-03-16	581452		0	0	0		0	0	0	340048	0	113	40213227		
45470	3761	1127433	1994-08-28	1994-08-28 00:00:00	1994-10-27	1994-10-27 00:00:00	1994-10-27	38000177		0	0	60		0	0	0	250043	0	313782	1127433		
47370	3927	1127433	1979-01-20	1979-01-20 00:00:00	1979-02-24	1979-02-24 00:00:00	1979-02-24	38000177		0	0	35		0	0	0	261036	0	313782	1127433		
37422	3092	1127433	2011-07-31	2011-07-31 00:00:00	2011-08-21	2011-08-21 00:00:00	2011-08-21	38000177		0	0	21		0	0	0	205841	0	313782	1127433		
56553	4691	1713671	1991-05-24	1991-05-24 00:00:00	1991-06-14	1991-06-14 00:00:00	1991-06-14	38000177		0	0	21		0	0	0	312603	0	562251	1713671		
54125	4497	19059056	1958-02-17	1958-02-17 00:00:00	1958-03-03	1958-03-03 00:00:00	1958-03-03	38000177		0	0	14		0	0	0	299359	0	243670	19059056		
4187	348	1713671	1984-10-29	1984-10-29 00:00:00	1984-11-12	1984-11-12 00:00:00	1984-11-12	38000177		0	0	14		0	0	0	23144	0	562251	1713671		
15835	1316	1127433	2013-04-30	2013-04-30 00:00:00	2013-05-14	2013-05-14 00:00:00	2013-05-14	38000177		0	0	14		0	0	0	87183	0	313782	1127433		
15884	1318	19018935	2017-08-01	2017-08-01 00:00:00	2017-08-01	2017-08-01 00:00:00	\N	38000177		0	0	0		0	0	0	87417	0	197604	19018935		
59800	4971	1118084	1978-02-10	1978-02-10 00:00:00	1978-02-10	1978-02-10 00:00:00	\N	38000177		0	0	0		0	0	0	330630	0	00025152531	44923712		
15988	1325	40229134	2009-10-29	2009-10-29 00:00:00	2009-11-12	2009-11-12 00:00:00	2009-11-12	38000177		0	0	14		0	0	0	87961	0	1043400	40229134		
138588	3044	40213306	1991-03-26	1991-03-26 00:00:00	1991-03-26	1991-03-26 00:00:00	1991-03-26	581452		0	0	0		0	0	0	202631	0	43	40213306		
2196	177	40162522	2002-05-14	2002-05-14 00:00:00	2002-05-14	2002-05-14 00:00:00	\N	38000177		0	0	0		0	0	0	11981	0	857005	40162522		
237140	5206	40213227	1998-11-28	1998-11-28 00:00:00	1998-11-28	1998-11-28 00:00:00	1998-11-28	581452		0	0	0		0	0	0	346303	0	113	40213227		
12073	260	40213296	2011-07-23	2011-07-23 00:00:00	2011-07-23	2011-07-23 00:00:00	2011-07-23	581452		0	0	0		0	0	0	17243	0	52	40213296		
25527	2097	40236824	1996-04-06	1996-04-06 00:00:00	1996-04-13	1996-04-13 00:00:00	1996-04-13	38000177		0	0	7		0	0	0	139777	0	1094107	40236824		
36026	2966	1713671	2007-10-24	2007-10-24 00:00:00	2007-11-07	2007-11-07 00:00:00	2007-11-07	38000177		0	0	14		0	0	0	198100	0	562251	1713671		
57622	4784	19133905	2004-02-08	2004-02-08 00:00:00	2004-02-19	2004-02-19 00:00:00	2004-02-19	38000177		0	0	11		0	0	0	318482	0	834102	19133905		
19891	1634	19059056	1941-01-08	1941-01-08 00:00:00	1941-01-22	1941-01-22 00:00:00	1941-01-22	38000177		0	0	14		0	0	0	109731	0	243670	19059056		
48886	4053	40229134	1963-08-20	1963-08-20 00:00:00	1963-08-27	1963-08-27 00:00:00	1963-08-27	38000177		0	0	7		0	0	0	269421	0	1043400	40229134		
34911	762	40213227	2005-07-20	2005-07-20 00:00:00	2005-07-20	2005-07-20 00:00:00	2005-07-20	581452		0	0	0		0	0	0	50694	0	113	40213227		
33166	2750	19059056	1949-05-01	1949-05-01 00:00:00	1949-05-15	1949-05-15 00:00:00	1949-05-15	38000177		0	0	14		0	0	0	181871	0	243670	19059056		
46731	3871	19059056	1968-06-12	1968-06-12 00:00:00	1968-09-10	1968-09-10 00:00:00	1968-09-10	38000177		0	0	90		0	0	0	257017	0	243670	19059056		
43197	3578	19133905	1992-06-28	1992-06-28 00:00:00	1992-07-06	1992-07-06 00:00:00	1992-07-06	38000177		0	0	8		0	0	0	237869	0	834102	19133905		
58464	4855	40236824	2005-11-03	2005-11-03 00:00:00	2005-11-10	2005-11-10 00:00:00	2005-11-10	38000177		0	0	7		0	0	0	322996	0	1094107	40236824		
57338	4758	40243436	1989-08-13	1989-08-13 00:00:00	1989-08-13	1989-08-13 00:00:00	1989-08-13	38000177		0	0	0		0	0	0	316967	0	1190795	40243436		
27373	597	40213160	1957-04-15	1957-04-15 00:00:00	1957-04-15	1957-04-15 00:00:00	1957-04-15	581452		0	0	0		0	0	0	39411	0	10	40213160		
44716	3700	1127078	1971-07-06	1971-07-06 00:00:00	1971-09-11	1971-09-11 00:00:00	1971-09-11	38000177		0	0	67		0	0	0	245972	0	282464	1127078		
104797	2298	40213296	2012-03-22	2012-03-22 00:00:00	2012-03-22	2012-03-22 00:00:00	2012-03-22	581452		0	0	0		0	0	0	152983	0	52	40213296		
7194	605	19078461	1997-05-02	1997-05-02 00:00:00	1997-05-23	1997-05-23 00:00:00	1997-05-23	38000177		0	0	21		0	0	0	40163	0	310965	19078461		
9826	823	19059056	1949-10-25	1949-10-25 00:00:00	1949-11-15	1949-11-15 00:00:00	1949-11-15	38000177		0	0	21		0	0	0	54544	0	243670	19059056		
1235	28	40213314	1980-02-06	1980-02-06 00:00:00	1980-02-06	1980-02-06 00:00:00	1980-02-06	581452		0	0	0		0	0	0	1964	0	49	40213314		
48193	3995	1124300	2005-11-21	2005-11-21 00:00:00	2005-11-21	2005-11-21 00:00:00	\N	38000177		0	0	0		0	0	0	265584	0	00781178901	45011828		
27370	2264	19059056	1972-03-26	1972-03-26 00:00:00	1972-04-09	1972-04-09 00:00:00	1972-04-09	38000177		0	0	14		0	0	0	150437	0	243670	19059056		
3071	249	1127433	2011-01-19	2011-01-19 00:00:00	2011-01-26	2011-01-26 00:00:00	2011-01-26	38000177		0	0	7		0	0	0	16768	0	313782	1127433		
7791	651	1713671	1987-07-04	1987-07-04 00:00:00	1987-07-18	1987-07-18 00:00:00	1987-07-18	38000177		0	0	14		0	0	0	43106	0	562251	1713671		
16901	1399	1127433	1988-04-01	1988-04-01 00:00:00	1988-04-08	1988-04-08 00:00:00	1988-04-08	38000177		0	0	7		0	0	0	93045	0	313782	1127433		
27441	2272	19128065	1998-11-01	1998-11-01 00:00:00	1999-10-27	1999-10-27 00:00:00	1999-10-27	38000177		0	0	360		0	0	0	151066	0	749882	19128065		
65702	1438	40213160	1955-04-29	1955-04-29 00:00:00	1955-04-29	1955-04-29 00:00:00	1955-04-29	581452		0	0	0		0	0	0	\N	0	10	40213160		
148720	3270	40213160	1970-09-03	1970-09-03 00:00:00	1970-09-03	1970-09-03 00:00:00	1970-09-03	581452		0	0	0		0	0	0	217334	0	10	40213160		
31100	677	40213227	1994-01-21	1994-01-21 00:00:00	1994-01-21	1994-01-21 00:00:00	1994-01-21	581452		0	0	0		0	0	0	44801	0	113	40213227		
41737	3455	19133873	1983-01-15	1983-01-15 00:00:00	1983-01-26	1983-01-26 00:00:00	1983-01-26	38000177		0	0	11		0	0	0	229201	0	834061	19133873		
73198	1599	40213260	2010-05-10	2010-05-10 00:00:00	2010-05-10	2010-05-10 00:00:00	2010-05-10	581452		0	0	0		0	0	0	107311	0	121	40213260		
27707	603	40213160	1956-08-17	1956-08-17 00:00:00	1956-08-17	1956-08-17 00:00:00	1956-08-17	581452		0	0	0		0	0	0	39995	0	10	40213160		
51334	4268	19133873	1967-08-11	1967-08-11 00:00:00	1967-08-22	1967-08-22 00:00:00	1967-08-22	38000177		0	0	11		0	0	0	283266	0	834061	19133873		
118440	2604	40213260	2006-03-11	2006-03-11 00:00:00	2006-03-11	2006-03-11 00:00:00	2006-03-11	581452		0	0	0		0	0	0	172287	0	121	40213260		
42543	3528	19074679	1959-11-16	1959-11-16 00:00:00	1960-06-13	1960-06-13 00:00:00	1960-06-13	38000177		0	0	210		0	0	0	234248	0	308971	19074679		
2823	227	19128022	1989-08-23	1989-08-23 00:00:00	1990-08-18	1990-08-18 00:00:00	1990-08-18	38000177		0	0	360		0	0	0	15368	0	749785	19128022		
62937	5230	1713671	1949-02-18	1949-02-18 00:00:00	1949-03-11	1949-03-11 00:00:00	1949-03-11	38000177		0	0	21		0	0	0	347986	0	562251	1713671		
43067	3570	1127433	1980-09-14	1980-09-14 00:00:00	1980-10-05	1980-10-05 00:00:00	1980-10-05	38000177		0	0	21		0	0	0	237226	0	313782	1127433		
20815	1716	1127433	2010-08-25	2010-08-25 00:00:00	2010-10-24	2010-10-24 00:00:00	2010-10-24	38000177		0	0	60		0	0	0	114709	0	313782	1127433		
159681	3514	40213227	1996-10-14	1996-10-14 00:00:00	1996-10-14	1996-10-14 00:00:00	1996-10-14	581452		0	0	0		0	0	0	233204	0	113	40213227		
4880	105	40213160	1965-11-19	1965-11-19 00:00:00	1965-11-19	1965-11-19 00:00:00	1965-11-19	581452		0	0	0		0	0	0	7120	0	10	40213160		
61984	1354	40213160	1983-03-25	1983-03-25 00:00:00	1983-03-25	1983-03-25 00:00:00	1983-03-25	581452		0	0	0		0	0	0	89736	0	10	40213160		
18009	1491	1545959	2011-07-12	2011-07-12 00:00:00	2011-07-12	2011-07-12 00:00:00	2011-07-12	38000177		0	0	0		0	0	0	99456	0	259255	1545959		
194567	4275	40213160	1980-04-20	1980-04-20 00:00:00	1980-04-20	1980-04-20 00:00:00	1980-04-20	581452		0	0	0		0	0	0	283718	0	10	40213160		
46020	3811	40229134	1929-06-13	1929-06-13 00:00:00	1929-06-27	1929-06-27 00:00:00	1929-06-27	38000177		0	0	14		0	0	0	253211	0	1043400	40229134		
46070	3817	1127433	2010-07-13	2010-07-13 00:00:00	2010-07-27	2010-07-27 00:00:00	2010-07-27	38000177		0	0	14		0	0	0	253523	0	313782	1127433		
44959	3720	1713671	1997-04-16	1997-04-16 00:00:00	1997-04-23	1997-04-23 00:00:00	1997-04-23	38000177		0	0	7		0	0	0	247235	0	562251	1713671		
55476	4607	1115171	2007-08-05	2007-08-05 00:00:00	2007-09-09	2007-09-09 00:00:00	2007-09-09	38000177		0	0	35		0	0	0	306877	0	849574	1115171		
13122	283	40213160	1980-12-08	1980-12-08 00:00:00	1980-12-08	1980-12-08 00:00:00	1980-12-08	581452		0	0	0		0	0	0	18851	0	10	40213160		
1779	143	1127433	2000-08-16	2000-08-16 00:00:00	2000-08-23	2000-08-23 00:00:00	2000-08-23	38000177		0	0	7		0	0	0	9573	0	313782	1127433		
27900	607	40213198	2016-03-11	2016-03-11 00:00:00	2016-03-11	2016-03-11 00:00:00	2016-03-11	581452		0	0	0		0	0	0	40282	0	133	40213198		
60627	5043	19128065	1987-12-11	1987-12-11 00:00:00	1988-12-05	1988-12-05 00:00:00	1988-12-05	38000177		0	0	360		0	0	0	335165	0	749882	19128065		
232894	5117	40213260	2009-03-16	2009-03-16 00:00:00	2009-03-16	2009-03-16 00:00:00	2009-03-16	581452		0	0	0		0	0	0	340048	0	121	40213260		
45471	3761	19006318	1957-11-12	1957-11-12 00:00:00	1957-11-26	1957-11-26 00:00:00	1957-11-26	38000177		0	0	14		0	0	0	250076	0	105078	19006318		
47371	3927	1713671	1961-12-29	1961-12-29 00:00:00	1962-01-19	1962-01-19 00:00:00	1962-01-19	38000177		0	0	21		0	0	0	261099	0	562251	1713671		
37423	3092	19059056	1955-10-25	1955-10-25 00:00:00	1955-11-08	1955-11-08 00:00:00	1955-11-08	38000177		0	0	14		0	0	0	205870	0	243670	19059056		
56554	4691	19133873	1967-04-03	1967-04-03 00:00:00	1967-04-12	1967-04-12 00:00:00	1967-04-12	38000177		0	0	9		0	0	0	312574	0	834061	19133873		
54126	4497	19006318	1958-02-17	1958-02-17 00:00:00	1958-03-03	1958-03-03 00:00:00	1958-03-03	38000177		0	0	14		0	0	0	299359	0	105078	19006318		
4188	348	19078461	2015-11-21	2015-11-21 00:00:00	2015-12-05	2015-12-05 00:00:00	2015-12-05	38000177		0	0	14		0	0	0	23119	0	310965	19078461		
15837	1316	1127433	1952-03-18	1952-03-18 00:00:00	1952-04-01	1952-04-01 00:00:00	1952-04-01	38000177		0	0	14		0	0	0	87216	0	313782	1127433		
15885	1318	40163554	2017-08-01	2017-08-01 00:00:00	2017-08-01	2017-08-01 00:00:00	\N	38000177		0	0	0		0	0	0	87417	0	855332	40163554		
59801	4971	1127433	1964-08-29	1964-08-29 00:00:00	1964-09-12	1964-09-12 00:00:00	1964-09-12	38000177		0	0	14		0	0	0	330547	0	313782	1127433		
15989	1325	1127433	1974-04-24	1974-04-24 00:00:00	1974-05-01	1974-05-01 00:00:00	1974-05-01	38000177		0	0	7		0	0	0	87950	0	313782	1127433		
138595	3044	40213160	1974-01-01	1974-01-01 00:00:00	1974-01-01	1974-01-01 00:00:00	1974-01-01	581452		0	0	0		0	0	0	202648	0	10	40213160		
2197	177	19133873	1969-03-13	1969-03-13 00:00:00	1969-03-24	1969-03-24 00:00:00	1969-03-24	38000177		0	0	11		0	0	0	12003	0	834061	19133873		
237142	5206	40213314	1977-12-24	1977-12-24 00:00:00	1977-12-24	1977-12-24 00:00:00	1977-12-24	581452		0	0	0		0	0	0	346284	0	49	40213314		
12076	260	40213227	2000-09-09	2000-09-09 00:00:00	2000-09-09	2000-09-09 00:00:00	2000-09-09	581452		0	0	0		0	0	0	17271	0	113	40213227		
25528	2097	1127078	1982-09-24	1982-09-24 00:00:00	1982-10-08	1982-10-08 00:00:00	1982-10-08	38000177		0	0	14		0	0	0	139800	0	282464	1127078		
36027	2966	1127433	1976-11-06	1976-11-06 00:00:00	1976-12-11	1976-12-11 00:00:00	1976-12-11	38000177		0	0	35		0	0	0	198045	0	313782	1127433		
57623	4784	1127433	1971-01-15	1971-01-15 00:00:00	1971-01-29	1971-01-29 00:00:00	1971-01-29	38000177		0	0	14		0	0	0	318494	0	313782	1127433		
19892	1634	40229134	1975-03-23	1975-03-23 00:00:00	1975-03-30	1975-03-30 00:00:00	1975-03-30	38000177		0	0	7		0	0	0	109738	0	1043400	40229134		
48887	4053	19059056	1964-09-11	1964-09-11 00:00:00	1964-10-02	1964-10-02 00:00:00	1964-10-02	38000177		0	0	21		0	0	0	269418	0	243670	19059056		
34913	762	40213260	2007-08-01	2007-08-01 00:00:00	2007-08-01	2007-08-01 00:00:00	2007-08-01	581452		0	0	0		0	0	0	50695	0	121	40213260		
33167	2750	19077572	2008-03-05	2008-03-05 00:00:00	2008-03-05	2008-03-05 00:00:00	\N	38000177		0	0	0		0	0	0	181917	0	310436	19077572		
46732	3871	1115171	1994-03-28	1994-03-28 00:00:00	1994-05-27	1994-05-27 00:00:00	1994-05-27	38000177		0	0	60		0	0	0	257018	0	849574	1115171		
43198	3579	40229134	2017-07-22	2017-07-22 00:00:00	2017-07-29	2017-07-29 00:00:00	2017-07-29	38000177		0	0	7		0	0	0	237924	0	1043400	40229134		
58465	4855	920300	2005-11-03	2005-11-03 00:00:00	2005-11-10	2005-11-10 00:00:00	2005-11-10	38000177		0	0	7		0	0	0	322996	0	311989	920300		
57339	4758	1310034	1989-08-13	1989-08-13 00:00:00	1989-08-13	1989-08-13 00:00:00	1989-08-13	38000177		0	0	0		0	0	0	316967	0	834357	1310034		
27379	597	40213227	2003-06-30	2003-06-30 00:00:00	2003-06-30	2003-06-30 00:00:00	2003-06-30	581452		0	0	0		0	0	0	39438	0	113	40213227		
44717	3701	1713671	2005-02-22	2005-02-22 00:00:00	2005-03-08	2005-03-08 00:00:00	2005-03-08	38000177		0	0	14		0	0	0	246042	0	562251	1713671		
104799	2298	40213160	1971-07-08	1971-07-08 00:00:00	1971-07-08	1971-07-08 00:00:00	1971-07-08	581452		0	0	0		0	0	0	153022	0	10	40213160		
7195	605	1127433	2013-06-09	2013-06-09 00:00:00	2013-06-16	2013-06-16 00:00:00	2013-06-16	38000177		0	0	7		0	0	0	40178	0	313782	1127433		
9827	823	1118084	1979-01-26	1979-01-26 00:00:00	1979-01-26	1979-01-26 00:00:00	\N	38000177		0	0	0		0	0	0	54560	0	00025152531	44923712		
1236	28	40213160	1980-02-06	1980-02-06 00:00:00	1980-02-06	1980-02-06 00:00:00	1980-02-06	581452		0	0	0		0	0	0	1964	0	10	40213160		
48194	3995	19078461	2010-03-25	2010-03-25 00:00:00	2010-04-15	2010-04-15 00:00:00	2010-04-15	38000177		0	0	21		0	0	0	265615	0	310965	19078461		
27371	2265	1127433	1996-06-07	1996-06-07 00:00:00	1996-06-14	1996-06-14 00:00:00	1996-06-14	38000177		0	0	7		0	0	0	150522	0	313782	1127433		
3072	249	19078461	2004-11-19	2004-11-19 00:00:00	2004-12-10	2004-12-10 00:00:00	2004-12-10	38000177		0	0	21		0	0	0	16780	0	310965	19078461		
7792	652	1127433	2004-12-02	2004-12-02 00:00:00	2004-12-16	2004-12-16 00:00:00	2004-12-16	38000177		0	0	14		0	0	0	43182	0	313782	1127433		
16902	1399	1127433	1992-07-18	1992-07-18 00:00:00	1992-07-25	1992-07-25 00:00:00	1992-07-25	38000177		0	0	7		0	0	0	93111	0	313782	1127433		
27442	2272	1127078	1982-09-16	1982-09-16 00:00:00	1982-12-15	1982-12-15 00:00:00	1982-12-15	38000177		0	0	90		0	0	0	151059	0	282464	1127078		
65706	1438	40213227	1994-01-28	1994-01-28 00:00:00	1994-01-28	1994-01-28 00:00:00	1994-01-28	581452		0	0	0		0	0	0	95799	0	113	40213227		
148725	3270	40213296	2012-04-05	2012-04-05 00:00:00	2012-04-05	2012-04-05 00:00:00	2012-04-05	581452		0	0	0		0	0	0	217308	0	52	40213296		
31103	677	40213160	1966-05-13	1966-05-13 00:00:00	1966-05-13	1966-05-13 00:00:00	1966-05-13	581452		0	0	0		0	0	0	44795	0	10	40213160		
41738	3455	19128065	1993-03-31	1993-03-31 00:00:00	1994-03-26	1994-03-26 00:00:00	1994-03-26	38000177		0	0	360		0	0	0	229244	0	749882	19128065		
73205	1599	40213296	2000-05-15	2000-05-15 00:00:00	2000-05-15	2000-05-15 00:00:00	2000-05-15	581452		0	0	0		0	0	0	107309	0	52	40213296		
27710	603	40213227	2017-04-07	2017-04-07 00:00:00	2017-04-07	2017-04-07 00:00:00	2017-04-07	581452		0	0	0		0	0	0	39918	0	113	40213227		
51335	4268	40231925	1970-05-03	1970-05-03 00:00:00	1970-05-03	1970-05-03 00:00:00	\N	38000177		0	0	0		0	0	0	283264	0	1049221	40231925		
118442	2604	40213160	1961-02-18	1961-02-18 00:00:00	1961-02-18	1961-02-18 00:00:00	1961-02-18	581452		0	0	0		0	0	0	172320	0	10	40213160		
42544	3528	1115171	1997-07-09	1997-07-09 00:00:00	1997-08-06	1997-08-06 00:00:00	1997-08-06	38000177		0	0	28		0	0	0	234282	0	849574	1115171		
2824	227	1127433	2005-10-20	2005-10-20 00:00:00	2005-10-27	2005-10-27 00:00:00	2005-10-27	38000177		0	0	7		0	0	0	15349	0	313782	1127433		
62938	5230	1713671	2004-10-29	2004-10-29 00:00:00	2004-11-05	2004-11-05 00:00:00	2004-11-05	38000177		0	0	7		0	0	0	347956	0	562251	1713671		
43068	3570	40229134	1990-02-09	1990-02-09 00:00:00	1990-02-16	1990-02-16 00:00:00	1990-02-16	38000177		0	0	7		0	0	0	237291	0	1043400	40229134		
20816	1716	1127433	1965-03-06	1965-03-06 00:00:00	1965-03-13	1965-03-13 00:00:00	1965-03-13	38000177		0	0	7		0	0	0	114733	0	313782	1127433		
159682	3514	40213306	1996-10-14	1996-10-14 00:00:00	1996-10-14	1996-10-14 00:00:00	1996-10-14	581452		0	0	0		0	0	0	233204	0	43	40213306		
159745	3516	40213198	2010-09-09	2010-09-09 00:00:00	2010-09-09	2010-09-09 00:00:00	2010-09-09	581452		0	0	0		0	0	0	233362	0	133	40213198		
61992	1354	40213160	1978-09-15	1978-09-15 00:00:00	1978-09-15	1978-09-15 00:00:00	1978-09-15	581452		0	0	0		0	0	0	89752	0	10	40213160		
18010	1491	19133768	2011-07-12	2011-07-12 00:00:00	2011-07-12	2011-07-12 00:00:00	2011-07-12	38000177		0	0	0		0	0	0	99456	0	833036	19133768		
194568	4275	40213306	2002-04-15	2002-04-15 00:00:00	2002-04-15	2002-04-15 00:00:00	2002-04-15	581452		0	0	0		0	0	0	283707	0	43	40213306		
46021	3811	19133905	1944-12-24	1944-12-24 00:00:00	1945-01-04	1945-01-04 00:00:00	1945-01-04	38000177		0	0	11		0	0	0	253145	0	834102	19133905		
46071	3817	1115171	2019-02-18	2019-02-18 00:00:00	2019-03-25	2019-03-25 00:00:00	2019-03-25	38000177		0	0	35		0	0	0	253531	0	849574	1115171		
44960	3720	19059056	1956-12-02	1956-12-02 00:00:00	1956-12-16	1956-12-16 00:00:00	1956-12-16	38000177		0	0	14		0	0	0	247240	0	243670	19059056		
55477	4607	1127078	1975-04-25	1975-04-25 00:00:00	1975-05-09	1975-05-09 00:00:00	1975-05-09	38000177		0	0	14		0	0	0	306879	0	282464	1127078		
13123	283	40213160	1981-05-11	1981-05-11 00:00:00	1981-05-11	1981-05-11 00:00:00	1981-05-11	581452		0	0	0		0	0	0	18839	0	10	40213160		
1780	143	40229134	1982-10-29	1982-10-29 00:00:00	1982-11-12	1982-11-12 00:00:00	1982-11-12	38000177		0	0	14		0	0	0	9549	0	1043400	40229134		
27905	607	40213227	2001-12-21	2001-12-21 00:00:00	2001-12-21	2001-12-21 00:00:00	2001-12-21	581452		0	0	0		0	0	0	40301	0	113	40213227		
60628	5043	19128065	1996-10-24	1996-10-24 00:00:00	1997-10-19	1997-10-19 00:00:00	1997-10-19	38000177		0	0	360		0	0	0	335160	0	749882	19128065		
232895	5117	40213227	2001-02-05	2001-02-05 00:00:00	2001-02-05	2001-02-05 00:00:00	2001-02-05	581452		0	0	0		0	0	0	340113	0	113	40213227		
45472	3761	19059056	1957-11-12	1957-11-12 00:00:00	1957-11-26	1957-11-26 00:00:00	1957-11-26	38000177		0	0	14		0	0	0	250076	0	243670	19059056		
47372	3927	19129655	1962-02-27	1962-02-27 00:00:00	1962-03-13	1962-03-13 00:00:00	1962-03-13	38000177		0	0	14		0	0	0	261015	0	789980	19129655		
37424	3092	19006318	1955-10-25	1955-10-25 00:00:00	1955-11-08	1955-11-08 00:00:00	1955-11-08	38000177		0	0	14		0	0	0	205870	0	105078	19006318		
56555	4691	1124300	2002-01-12	2002-01-12 00:00:00	2002-01-12	2002-01-12 00:00:00	\N	38000177		0	0	0		0	0	0	312593	0	00781178901	45011828		
54129	4498	19019979	1989-01-21	1989-01-21 00:00:00	1989-02-25	1989-02-25 00:00:00	1989-02-25	38000177		0	0	35		0	0	0	299494	0	198405	19019979		
4189	348	19073183	1979-08-25	1979-08-25 00:00:00	1979-09-08	1979-09-08 00:00:00	1979-09-08	38000177		0	0	14		0	0	0	23133	0	308182	19073183		
15838	1316	1713671	1997-11-20	1997-11-20 00:00:00	1997-12-11	1997-12-11 00:00:00	1997-12-11	38000177		0	0	21		0	0	0	87227	0	562251	1713671		
15886	1318	40171902	2017-08-01	2017-08-01 00:00:00	2017-08-01	2017-08-01 00:00:00	\N	38000177		0	0	0		0	0	0	87417	0	897718	40171902		
59802	4971	1127433	2004-01-26	2004-01-26 00:00:00	2004-02-25	2004-02-25 00:00:00	2004-02-25	38000177		0	0	30		0	0	0	330515	0	313782	1127433		
15990	1325	1713671	2002-02-14	2002-02-14 00:00:00	2002-02-28	2002-02-28 00:00:00	2002-02-28	38000177		0	0	14		0	0	0	87986	0	562251	1713671		
80256	1756	40213227	2003-10-19	2003-10-19 00:00:00	2003-10-19	2003-10-19 00:00:00	2003-10-19	581452		0	0	0		0	0	0	117419	0	113	40213227		
2198	177	40236824	2016-05-28	2016-05-28 00:00:00	2016-06-04	2016-06-04 00:00:00	2016-06-04	38000177		0	0	7		0	0	0	12006	0	1094107	40236824		
237147	5206	40213160	1977-06-25	1977-06-25 00:00:00	1977-06-25	1977-06-25 00:00:00	1977-06-25	581452		0	0	0		0	0	0	346266	0	10	40213160		
12086	260	40213296	2009-07-18	2009-07-18 00:00:00	2009-07-18	2009-07-18 00:00:00	2009-07-18	581452		0	0	0		0	0	0	17209	0	52	40213296		
25529	2097	19073183	1982-09-24	1982-09-24 00:00:00	1982-10-08	1982-10-08 00:00:00	1982-10-08	38000177		0	0	14		0	0	0	139800	0	308182	19073183		
36028	2966	19126352	2013-11-23	2013-11-23 00:00:00	2013-11-23	2013-11-23 00:00:00	\N	38000177		0	0	0		0	0	0	198110	0	705129	19126352		
57644	4788	19078461	1989-08-11	1989-08-11 00:00:00	1989-09-01	1989-09-01 00:00:00	1989-09-01	38000177		0	0	21		0	0	0	318668	0	310965	19078461		
19893	1634	1127433	2006-07-07	2006-07-07 00:00:00	2006-07-21	2006-07-21 00:00:00	2006-07-21	38000177		0	0	14		0	0	0	109730	0	313782	1127433		
48888	4053	19133873	1971-07-10	1971-07-10 00:00:00	1971-07-21	1971-07-21 00:00:00	1971-07-21	38000177		0	0	11		0	0	0	269426	0	834061	19133873		
34916	762	40213160	1955-06-22	1955-06-22 00:00:00	1955-06-22	1955-06-22 00:00:00	1955-06-22	581452		0	0	0		0	0	0	50679	0	10	40213160		
33168	2750	1127433	2003-01-24	2003-01-24 00:00:00	2003-01-31	2003-01-31 00:00:00	2003-01-31	38000177		0	0	7		0	0	0	181958	0	313782	1127433		
46733	3871	1124300	1999-10-18	1999-10-18 00:00:00	1999-10-18	1999-10-18 00:00:00	\N	38000177		0	0	0		0	0	0	257052	0	00781178901	45011828		
43199	3579	1127078	1968-09-10	1968-09-10 00:00:00	1968-09-24	1968-09-24 00:00:00	1968-09-24	38000177		0	0	14		0	0	0	237955	0	282464	1127078		
58466	4855	1713671	2005-11-03	2005-11-03 00:00:00	2005-11-24	2005-11-24 00:00:00	2005-11-24	38000177		0	0	21		0	0	0	322996	0	562251	1713671		
57340	4758	1124300	1996-11-14	1996-11-14 00:00:00	1996-11-14	1996-11-14 00:00:00	\N	38000177		0	0	0		0	0	0	317029	0	00781178901	45011828		
27384	597	40213201	2018-12-10	2018-12-10 00:00:00	2018-12-10	2018-12-10 00:00:00	2018-12-10	581452		0	0	0		0	0	0	39403	0	33	40213201		
44718	3701	1713671	1979-07-09	1979-07-09 00:00:00	1979-07-30	1979-07-30 00:00:00	1979-07-30	38000177		0	0	21		0	0	0	246032	0	562251	1713671		
104804	2298	40213160	1975-10-09	1975-10-09 00:00:00	1975-10-09	1975-10-09 00:00:00	1975-10-09	581452		0	0	0		0	0	0	152996	0	10	40213160		
7196	605	19112599	1959-07-06	1959-07-06 00:00:00	1959-07-06	1959-07-06 00:00:00	\N	38000177		0	0	0		0	0	0	40114	0	477045	19112599		
9828	823	1127433	2009-02-01	2009-02-01 00:00:00	2009-02-08	2009-02-08 00:00:00	2009-02-08	38000177		0	0	7		0	0	0	54532	0	313782	1127433		
1242	28	40213160	1980-07-09	1980-07-09 00:00:00	1980-07-09	1980-07-09 00:00:00	1980-07-09	581452		0	0	0		0	0	0	1965	0	10	40213160		
48195	3995	1127433	1986-01-09	1986-01-09 00:00:00	1986-01-30	1986-01-30 00:00:00	1986-01-30	38000177		0	0	21		0	0	0	265614	0	313782	1127433		
27372	2265	1127433	1964-06-12	1964-06-12 00:00:00	1964-06-26	1964-06-26 00:00:00	1964-06-26	38000177		0	0	14		0	0	0	150529	0	313782	1127433		
3073	249	1124300	2016-12-06	2016-12-06 00:00:00	2016-12-06	2016-12-06 00:00:00	\N	38000177		0	0	0		0	0	0	16737	0	00781178901	45011828		
7793	652	19059056	1969-08-06	1969-08-06 00:00:00	1969-08-20	1969-08-20 00:00:00	1969-08-20	38000177		0	0	14		0	0	0	43144	0	243670	19059056		
16903	1399	40236446	1972-06-26	1972-06-26 00:00:00	1978-07-05	1978-07-05 00:00:00	1978-07-05	38000177		0	0	2200		0	0	0	93080	0	1091392	40236446		
27443	2272	19128065	2001-10-16	2001-10-16 00:00:00	2002-10-11	2002-10-11 00:00:00	2002-10-11	38000177		0	0	360		0	0	0	151056	0	749882	19128065		
65713	1438	40213160	1955-07-01	1955-07-01 00:00:00	1955-07-01	1955-07-01 00:00:00	1955-07-01	581452		0	0	0		0	0	0	95815	0	10	40213160		
148727	3270	40213227	2012-04-05	2012-04-05 00:00:00	2012-04-05	2012-04-05 00:00:00	2012-04-05	581452		0	0	0		0	0	0	217308	0	113	40213227		
111943	2459	40213314	1977-02-28	1977-02-28 00:00:00	1977-02-28	1977-02-28 00:00:00	1977-02-28	581452		0	0	0		0	0	0	163065	0	49	40213314		
41739	3455	19115351	1997-03-31	1997-03-31 00:00:00	1997-07-07	1997-07-07 00:00:00	1997-07-07	38000177		0	0	98		0	0	0	229223	0	563026	19115351		
84496	1848	40213227	2005-10-20	2005-10-20 00:00:00	2005-10-20	2005-10-20 00:00:00	2005-10-20	581452		0	0	0		0	0	0	123598	0	113	40213227		
27715	603	40213160	1961-02-17	1961-02-17 00:00:00	1961-02-17	1961-02-17 00:00:00	1961-02-17	581452		0	0	0		0	0	0	39999	0	10	40213160		
51336	4268	1118084	1997-06-23	1997-06-23 00:00:00	1997-06-23	1997-06-23 00:00:00	\N	38000177		0	0	0		0	0	0	283257	0	00025152531	44923712		
118446	2604	40213296	1996-03-16	1996-03-16 00:00:00	1996-03-16	1996-03-16 00:00:00	1996-03-16	581452		0	0	0		0	0	0	172285	0	52	40213296		
42545	3528	1118084	1998-03-13	1998-03-13 00:00:00	1998-03-13	1998-03-13 00:00:00	\N	38000177		0	0	0		0	0	0	234282	0	00025152531	44923712		
2825	227	1713671	2017-07-21	2017-07-21 00:00:00	2017-07-28	2017-07-28 00:00:00	2017-07-28	38000177		0	0	7		0	0	0	15319	0	562251	1713671		
62939	5230	19059056	1961-09-06	1961-09-06 00:00:00	1961-11-05	1961-11-05 00:00:00	1961-11-05	38000177		0	0	60		0	0	0	347940	0	243670	19059056		
43071	3570	40229134	1963-11-19	1963-11-19 00:00:00	1963-11-26	1963-11-26 00:00:00	1963-11-26	38000177		0	0	7		0	0	0	237266	0	1043400	40229134		
20817	1716	1127433	1963-04-14	1963-04-14 00:00:00	1963-05-12	1963-05-12 00:00:00	1963-05-12	38000177		0	0	28		0	0	0	114700	0	313782	1127433		
159684	3514	40213314	1978-01-23	1978-01-23 00:00:00	1978-01-23	1978-01-23 00:00:00	1978-01-23	581452		0	0	0		0	0	0	233191	0	49	40213314		
53623	4456	19128065	1980-05-10	1980-05-10 00:00:00	1981-05-05	1981-05-05 00:00:00	1981-05-05	38000177		0	0	360		0	0	0	296589	0	749882	19128065		
61993	1354	40213314	1978-09-15	1978-09-15 00:00:00	1978-09-15	1978-09-15 00:00:00	1978-09-15	581452		0	0	0		0	0	0	89752	0	49	40213314		
18011	1491	19078461	1982-04-26	1982-04-26 00:00:00	1982-07-25	1982-07-25 00:00:00	1982-07-25	38000177		0	0	90		0	0	0	99451	0	310965	19078461		
194570	4275	40213227	2002-04-15	2002-04-15 00:00:00	2002-04-15	2002-04-15 00:00:00	2002-04-15	581452		0	0	0		0	0	0	283707	0	113	40213227		
46022	3811	1127433	1985-10-05	1985-10-05 00:00:00	1985-11-09	1985-11-09 00:00:00	1985-11-09	38000177		0	0	35		0	0	0	253142	0	313782	1127433		
46072	3817	19059056	1967-02-07	1967-02-07 00:00:00	1967-02-21	1967-02-21 00:00:00	1967-02-21	38000177		0	0	14		0	0	0	253524	0	243670	19059056		
44961	3720	1118084	1990-06-11	1990-06-11 00:00:00	1990-06-11	1990-06-11 00:00:00	\N	38000177		0	0	0		0	0	0	247318	0	00025152531	44923712		
55478	4607	46233988	1975-04-25	1975-04-25 00:00:00	1975-05-09	1975-05-09 00:00:00	1975-05-09	38000177		0	0	14		0	0	0	306879	0	1652673	46233988		
26090	569	40213227	1994-03-26	1994-03-26 00:00:00	1994-03-26	1994-03-26 00:00:00	1994-03-26	581452		0	0	0		0	0	0	37718	0	113	40213227		
1781	143	19074841	2001-04-05	2001-04-05 00:00:00	2001-04-19	2001-04-19 00:00:00	2001-04-19	38000177		0	0	14		0	0	0	9586	0	309043	19074841		
27910	607	40213160	1955-11-25	1955-11-25 00:00:00	1955-11-25	1955-11-25 00:00:00	1955-11-25	581452		0	0	0		0	0	0	40288	0	10	40213160		
60629	5043	1127433	2013-09-16	2013-09-16 00:00:00	2013-09-30	2013-09-30 00:00:00	2013-09-30	38000177		0	0	14		0	0	0	335158	0	313782	1127433		
232896	5117	40213296	2001-02-05	2001-02-05 00:00:00	2001-02-05	2001-02-05 00:00:00	2001-02-05	581452		0	0	0		0	0	0	340113	0	52	40213296		
45473	3761	19133873	1957-02-16	1957-02-16 00:00:00	1957-02-24	1957-02-24 00:00:00	1957-02-24	38000177		0	0	8		0	0	0	250050	0	834061	19133873		
47373	3927	19059056	1962-02-27	1962-02-27 00:00:00	1962-03-13	1962-03-13 00:00:00	1962-03-13	38000177		0	0	14		0	0	0	261015	0	243670	19059056		
37425	3092	46275916	1995-09-20	1995-09-20 00:00:00	1995-09-20	1995-09-20 00:00:00	1995-09-20	38000177		0	0	0		0	0	0	205906	0	1660014	46275916		
56556	4691	19133873	1969-10-09	1969-10-09 00:00:00	1969-10-20	1969-10-20 00:00:00	1969-10-20	38000177		0	0	11		0	0	0	312600	0	834061	19133873		
54130	4498	1118084	2013-12-26	2013-12-26 00:00:00	2013-12-26	2013-12-26 00:00:00	\N	38000177		0	0	0		0	0	0	299498	0	00025152531	44923712		
4190	348	1127078	1979-08-25	1979-08-25 00:00:00	1979-09-08	1979-09-08 00:00:00	1979-09-08	38000177		0	0	14		0	0	0	23133	0	282464	1127078		
15839	1316	1127433	2006-08-19	2006-08-19 00:00:00	2006-09-16	2006-09-16 00:00:00	2006-09-16	38000177		0	0	28		0	0	0	87222	0	313782	1127433		
5411	453	1127078	1976-03-28	1976-03-28 00:00:00	1976-04-11	1976-04-11 00:00:00	1976-04-11	38000177		0	0	14		0	0	0	30199	0	282464	1127078		
59803	4972	1127433	1957-10-10	1957-10-10 00:00:00	1957-10-24	1957-10-24 00:00:00	1957-10-24	38000177		0	0	14		0	0	0	330687	0	313782	1127433		
15991	1325	1127433	1990-05-03	1990-05-03 00:00:00	1990-05-17	1990-05-17 00:00:00	1990-05-17	38000177		0	0	14		0	0	0	87984	0	313782	1127433		
80258	1756	40213296	2014-08-17	2014-08-17 00:00:00	2014-08-17	2014-08-17 00:00:00	2014-08-17	581452		0	0	0		0	0	0	117415	0	52	40213296		
2199	177	920300	2016-05-28	2016-05-28 00:00:00	2016-06-04	2016-06-04 00:00:00	2016-06-04	38000177		0	0	7		0	0	0	12006	0	311989	920300		
237148	5207	40213227	2017-02-15	2017-02-15 00:00:00	2017-02-15	2017-02-15 00:00:00	2017-02-15	581452		0	0	0		0	0	0	\N	0	113	40213227		
54499	4529	920300	1993-12-22	1993-12-22 00:00:00	1993-12-29	1993-12-29 00:00:00	1993-12-29	38000177		0	0	7		0	0	0	301593	0	311989	920300		
25530	2097	1127433	1988-02-01	1988-02-01 00:00:00	1988-02-15	1988-02-15 00:00:00	1988-02-15	38000177		0	0	14		0	0	0	139760	0	313782	1127433		
36029	2966	19075601	2013-11-23	2013-11-23 00:00:00	2013-11-23	2013-11-23 00:00:00	\N	38000177		0	0	0		0	0	0	198110	0	309362	19075601		
57645	4788	1118084	2014-01-02	2014-01-02 00:00:00	2014-01-02	2014-01-02 00:00:00	\N	38000177		0	0	0		0	0	0	318685	0	00025152531	44923712		
19894	1634	40220960	2009-07-03	2009-07-03 00:00:00	2009-07-03	2009-07-03 00:00:00	2009-07-03	38000177		0	0	0		0	0	0	109765	0	1804799	40220960		
48889	4053	1127433	2017-11-21	2017-11-21 00:00:00	2017-12-26	2017-12-26 00:00:00	2017-12-26	38000177		0	0	35		0	0	0	269452	0	313782	1127433		
34935	762	40213160	1955-03-23	1955-03-23 00:00:00	1955-03-23	1955-03-23 00:00:00	1955-03-23	581452		0	0	0		0	0	0	50712	0	10	40213160		
33169	2750	46275916	2011-05-25	2011-05-25 00:00:00	2011-05-25	2011-05-25 00:00:00	2011-05-25	38000177		0	0	0		0	0	0	181876	0	1660014	46275916		
46734	3871	1713671	1985-12-25	1985-12-25 00:00:00	1986-01-01	1986-01-01 00:00:00	1986-01-01	38000177		0	0	7		0	0	0	257021	0	562251	1713671		
43200	3579	46233988	1968-09-10	1968-09-10 00:00:00	1968-09-24	1968-09-24 00:00:00	1968-09-24	38000177		0	0	14		0	0	0	237955	0	1652673	46233988		
58467	4855	19078461	2018-08-06	2018-08-06 00:00:00	2018-08-20	2018-08-20 00:00:00	2018-08-20	38000177		0	0	14		0	0	0	323055	0	310965	19078461		
57341	4758	1127433	1995-10-21	1995-10-21 00:00:00	1995-11-04	1995-11-04 00:00:00	1995-11-04	38000177		0	0	14		0	0	0	317029	0	313782	1127433		
72163	1577	40213227	2013-07-19	2013-07-19 00:00:00	2013-07-19	2013-07-19 00:00:00	2013-07-19	581452		0	0	0		0	0	0	105938	0	113	40213227		
44719	3701	1127433	1995-10-30	1995-10-30 00:00:00	1995-11-06	1995-11-06 00:00:00	1995-11-06	38000177		0	0	7		0	0	0	246039	0	313782	1127433		
104808	2298	40213227	1992-02-27	1992-02-27 00:00:00	1992-02-27	1992-02-27 00:00:00	1992-02-27	581452		0	0	0		0	0	0	152977	0	113	40213227		
7197	605	19128065	1977-05-06	1977-05-06 00:00:00	1978-05-01	1978-05-01 00:00:00	1978-05-01	38000177		0	0	360		0	0	0	40118	0	749882	19128065		
9830	823	1127433	2013-07-12	2013-07-12 00:00:00	2013-09-10	2013-09-10 00:00:00	2013-09-10	38000177		0	0	60		0	0	0	54558	0	313782	1127433		
1244	28	40213314	1980-04-09	1980-04-09 00:00:00	1980-04-09	1980-04-09 00:00:00	1980-04-09	581452		0	0	0		0	0	0	1981	0	49	40213314		
48196	3996	1115171	2016-06-22	2016-06-22 00:00:00	2016-07-13	2016-07-13 00:00:00	2016-07-13	38000177		0	0	21		0	0	0	265698	0	849574	1115171		
27373	2265	1127433	1978-10-26	1978-10-26 00:00:00	1978-11-09	1978-11-09 00:00:00	1978-11-09	38000177		0	0	14		0	0	0	150603	0	313782	1127433		
3074	249	42902245	1999-07-29	1999-07-29 00:00:00	2000-07-23	2000-07-23 00:00:00	2000-07-23	38000177		0	0	360		0	0	0	16741	0	1359133	42902245		
7794	652	19006318	1969-08-06	1969-08-06 00:00:00	1969-08-20	1969-08-20 00:00:00	1969-08-20	38000177		0	0	14		0	0	0	43144	0	105078	19006318		
16904	1399	19059056	1960-11-26	1960-11-26 00:00:00	1960-12-10	1960-12-10 00:00:00	1960-12-10	38000177		0	0	14		0	0	0	93115	0	243670	19059056		
27444	2272	40224805	1994-11-22	1994-11-22 00:00:00	1995-11-17	1995-11-17 00:00:00	1995-11-17	38000177		0	0	360		0	0	0	151035	0	1000126	40224805		
65715	1438	40213160	1957-01-04	1957-01-04 00:00:00	1957-01-04	1957-01-04 00:00:00	1957-01-04	581452		0	0	0		0	0	0	95816	0	10	40213160		
148731	3270	40213160	1975-03-06	1975-03-06 00:00:00	1975-03-06	1975-03-06 00:00:00	1975-03-06	581452		0	0	0		0	0	0	217337	0	10	40213160		
111946	2459	40213251	1984-06-18	1984-06-18 00:00:00	1984-06-18	1984-06-18 00:00:00	1984-06-18	581452		0	0	0		0	0	0	163058	0	21	40213251		
41740	3456	1713671	1986-05-12	1986-05-12 00:00:00	1986-05-26	1986-05-26 00:00:00	1986-05-26	38000177		0	0	14		0	0	0	229299	0	562251	1713671		
84503	1848	40213198	2010-02-04	2010-02-04 00:00:00	2010-02-04	2010-02-04 00:00:00	2010-02-04	581452		0	0	0		0	0	0	\N	0	133	40213198		
54093	4496	1127078	1950-04-13	1950-04-13 00:00:00	1950-04-27	1950-04-27 00:00:00	1950-04-27	38000177		0	0	14		0	0	0	299280	0	282464	1127078		
51337	4268	19128065	1974-08-13	1974-08-13 00:00:00	1975-08-08	1975-08-08 00:00:00	1975-08-08	38000177		0	0	360		0	0	0	283230	0	749882	19128065		
118448	2604	40213160	1956-08-18	1956-08-18 00:00:00	1956-08-18	1956-08-18 00:00:00	1956-08-18	581452		0	0	0		0	0	0	172305	0	10	40213160		
42546	3528	1127433	2011-11-04	2011-11-04 00:00:00	2011-11-11	2011-11-11 00:00:00	2011-11-11	38000177		0	0	7		0	0	0	234240	0	313782	1127433		
2826	227	19133905	1999-08-07	1999-08-07 00:00:00	1999-08-14	1999-08-14 00:00:00	1999-08-14	38000177		0	0	7		0	0	0	15316	0	834102	19133905		
62940	5230	1713671	1949-08-15	1949-08-15 00:00:00	1949-09-05	1949-09-05 00:00:00	1949-09-05	38000177		0	0	21		0	0	0	347945	0	562251	1713671		
43072	3570	1713671	1956-07-03	1956-07-03 00:00:00	1956-08-14	1956-08-14 00:00:00	1956-08-14	38000177		0	0	42		0	0	0	237265	0	562251	1713671		
20818	1716	19059056	1966-01-26	1966-01-26 00:00:00	1966-03-02	1966-03-02 00:00:00	1966-03-02	38000177		0	0	35		0	0	0	114701	0	243670	19059056		
57534	1259	40213227	1992-04-13	1992-04-13 00:00:00	1992-04-13	1992-04-13 00:00:00	1992-04-13	581452		0	0	0		0	0	0	82995	0	113	40213227		
53624	4456	1127433	1969-05-13	1969-05-13 00:00:00	1969-05-20	1969-05-20 00:00:00	1969-05-20	38000177		0	0	7		0	0	0	296578	0	313782	1127433		
61996	1354	40213160	1978-07-14	1978-07-14 00:00:00	1978-07-14	1978-07-14 00:00:00	1978-07-14	581452		0	0	0		0	0	0	89729	0	10	40213160		
18012	1491	1127078	1974-06-24	1974-06-24 00:00:00	1974-07-08	1974-07-08 00:00:00	1974-07-08	38000177		0	0	14		0	0	0	99425	0	282464	1127078		
194573	4275	40213160	1980-09-22	1980-09-22 00:00:00	1980-09-22	1980-09-22 00:00:00	1980-09-22	581452		0	0	0		0	0	0	283719	0	10	40213160		
46023	3811	1713671	1942-07-09	1942-07-09 00:00:00	1942-07-16	1942-07-16 00:00:00	1942-07-16	38000177		0	0	7		0	0	0	253212	0	562251	1713671		
46073	3817	19059056	1968-07-31	1968-07-31 00:00:00	1968-08-14	1968-08-14 00:00:00	1968-08-14	38000177		0	0	14		0	0	0	253515	0	243670	19059056		
44962	3720	19133905	2002-09-02	2002-09-02 00:00:00	2002-09-13	2002-09-13 00:00:00	2002-09-13	38000177		0	0	11		0	0	0	247286	0	834102	19133905		
55479	4607	1127433	1988-10-13	1988-10-13 00:00:00	1988-12-12	1988-12-12 00:00:00	1988-12-12	38000177		0	0	60		0	0	0	306875	0	313782	1127433		
157928	3477	40213160	1966-03-08	1966-03-08 00:00:00	1966-03-08	1966-03-08 00:00:00	1966-03-08	581452		0	0	0		0	0	0	230668	0	10	40213160		
1782	143	1127433	2001-04-05	2001-04-05 00:00:00	2001-04-19	2001-04-19 00:00:00	2001-04-19	38000177		0	0	14		0	0	0	9586	0	313782	1127433		
39204	856	40213260	2019-06-14	2019-06-14 00:00:00	2019-06-14	2019-06-14 00:00:00	2019-06-14	581452		0	0	0		0	0	0	56563	0	121	40213260		
60630	5043	19128022	1991-11-20	1991-11-20 00:00:00	1992-11-14	1992-11-14 00:00:00	1992-11-14	38000177		0	0	360		0	0	0	335136	0	749785	19128022		
232908	5118	40213260	2017-07-19	2017-07-19 00:00:00	2017-07-19	2017-07-19 00:00:00	2017-07-19	581452		0	0	0		0	0	0	340271	0	121	40213260		
45474	3761	1127433	1958-10-10	1958-10-10 00:00:00	1958-10-24	1958-10-24 00:00:00	1958-10-24	38000177		0	0	14		0	0	0	250051	0	313782	1127433		
47374	3927	19078461	2013-12-13	2013-12-13 00:00:00	2014-01-17	2014-01-17 00:00:00	2014-01-17	38000177		0	0	35		0	0	0	261038	0	310965	19078461		
37426	3092	40243436	1995-09-20	1995-09-20 00:00:00	1995-09-20	1995-09-20 00:00:00	1995-09-20	38000177		0	0	0		0	0	0	205906	0	1190795	40243436		
56557	4691	1127433	2006-03-09	2006-03-09 00:00:00	2006-03-16	2006-03-16 00:00:00	2006-03-16	38000177		0	0	7		0	0	0	312540	0	313782	1127433		
54131	4498	19128065	1992-05-15	1992-05-15 00:00:00	1993-05-10	1993-05-10 00:00:00	1993-05-10	38000177		0	0	360		0	0	0	299456	0	749882	19128065		
4191	348	1127078	1984-10-08	1984-10-08 00:00:00	1985-01-06	1985-01-06 00:00:00	1985-01-06	38000177		0	0	90		0	0	0	23115	0	282464	1127078		
15840	1316	1127433	1998-03-22	1998-03-22 00:00:00	1998-03-29	1998-03-29 00:00:00	1998-03-29	38000177		0	0	7		0	0	0	87228	0	313782	1127433		
5412	453	1127433	2014-04-18	2014-04-18 00:00:00	2014-04-25	2014-04-25 00:00:00	2014-04-25	38000177		0	0	7		0	0	0	30187	0	313782	1127433		
59804	4972	19059056	1956-09-13	1956-09-13 00:00:00	1956-10-04	1956-10-04 00:00:00	1956-10-04	38000177		0	0	21		0	0	0	330722	0	243670	19059056		
15992	1325	40229134	1966-01-03	1966-01-03 00:00:00	1966-01-10	1966-01-10 00:00:00	1966-01-10	38000177		0	0	7		0	0	0	87982	0	1043400	40229134		
80260	1756	40213227	2014-08-17	2014-08-17 00:00:00	2014-08-17	2014-08-17 00:00:00	2014-08-17	581452		0	0	0		0	0	0	117415	0	113	40213227		
2200	177	40220960	2009-11-08	2009-11-08 00:00:00	2009-11-08	2009-11-08 00:00:00	2009-11-08	38000177		0	0	0		0	0	0	11982	0	1804799	40220960		
237150	5207	40213160	1960-12-21	1960-12-21 00:00:00	1960-12-21	1960-12-21 00:00:00	1960-12-21	581452		0	0	0		0	0	0	346318	0	10	40213160		
54500	4529	40236824	1993-12-22	1993-12-22 00:00:00	1993-12-29	1993-12-29 00:00:00	1993-12-29	38000177		0	0	7		0	0	0	301593	0	1094107	40236824		
25531	2097	19133873	1990-11-05	1990-11-05 00:00:00	1990-11-12	1990-11-12 00:00:00	1990-11-12	38000177		0	0	7		0	0	0	139770	0	834061	19133873		
36030	2966	1332419	2013-11-23	2013-11-23 00:00:00	2013-11-23	2013-11-23 00:00:00	\N	38000177		0	0	0		0	0	0	198110	0	197361	1332419		
57646	4788	1127078	1977-08-27	1977-08-27 00:00:00	1977-09-10	1977-09-10 00:00:00	1977-09-10	38000177		0	0	14		0	0	0	318659	0	282464	1127078		
19895	1634	19075601	2009-07-03	2009-07-03 00:00:00	2009-07-03	2009-07-03 00:00:00	2009-07-03	38000177		0	0	0		0	0	0	109765	0	309362	19075601		
48890	4053	1115171	2016-01-12	2016-01-12 00:00:00	2016-01-26	2016-01-26 00:00:00	2016-01-26	38000177		0	0	14		0	0	0	269428	0	849574	1115171		
34942	762	40213160	1955-09-21	1955-09-21 00:00:00	1955-09-21	1955-09-21 00:00:00	1955-09-21	581452		0	0	0		0	0	0	50669	0	10	40213160		
33170	2750	40243436	2011-05-25	2011-05-25 00:00:00	2011-05-25	2011-05-25 00:00:00	2011-05-25	38000177		0	0	0		0	0	0	181876	0	1190795	40243436		
46735	3871	40236446	1969-09-10	1969-09-10 00:00:00	1980-09-17	1980-09-17 00:00:00	1980-09-17	38000177		0	0	4025		0	0	0	257035	0	1091392	40236446		
43201	3579	1115171	1996-04-21	1996-04-21 00:00:00	1996-06-27	1996-06-27 00:00:00	1996-06-27	38000177		0	0	67		0	0	0	237962	0	849574	1115171		
58468	4855	1127078	1982-04-30	1982-04-30 00:00:00	1982-05-14	1982-05-14 00:00:00	1982-05-14	38000177		0	0	14		0	0	0	323031	0	282464	1127078		
57342	4758	1127433	2013-06-09	2013-06-09 00:00:00	2013-06-16	2013-06-16 00:00:00	2013-06-16	38000177		0	0	7		0	0	0	316998	0	313782	1127433		
72175	1577	40213227	1993-07-09	1993-07-09 00:00:00	1993-07-09	1993-07-09 00:00:00	1993-07-09	581452		0	0	0		0	0	0	105873	0	113	40213227		
44721	3701	1127433	1984-12-18	1984-12-18 00:00:00	1985-01-24	1985-01-24 00:00:00	1985-01-24	38000177		0	0	37		0	0	0	246068	0	313782	1127433		
104809	2298	40213306	1992-02-27	1992-02-27 00:00:00	1992-02-27	1992-02-27 00:00:00	1992-02-27	581452		0	0	0		0	0	0	152977	0	43	40213306		
7198	605	40229134	1987-03-09	1987-03-09 00:00:00	1987-03-16	1987-03-16 00:00:00	1987-03-16	38000177		0	0	7		0	0	0	40184	0	1043400	40229134		
9831	823	19078461	2017-10-19	2017-10-19 00:00:00	2017-11-18	2017-11-18 00:00:00	2017-11-18	38000177		0	0	30		0	0	0	54559	0	310965	19078461		
1245	28	40213160	1980-04-09	1980-04-09 00:00:00	1980-04-09	1980-04-09 00:00:00	1980-04-09	581452		0	0	0		0	0	0	1981	0	10	40213160		
48197	3996	19126352	2003-02-25	2003-02-25 00:00:00	2003-02-25	2003-02-25 00:00:00	\N	38000177		0	0	0		0	0	0	265643	0	705129	19126352		
27374	2265	1127433	1975-09-26	1975-09-26 00:00:00	1975-10-10	1975-10-10 00:00:00	1975-10-10	38000177		0	0	14		0	0	0	150548	0	313782	1127433		
3075	249	19128022	2000-07-23	2000-07-23 00:00:00	2001-07-18	2001-07-18 00:00:00	2001-07-18	38000177		0	0	360		0	0	0	16742	0	749785	19128022		
7795	652	40236824	1991-03-12	1991-03-12 00:00:00	1991-03-19	1991-03-19 00:00:00	1991-03-19	38000177		0	0	7		0	0	0	43160	0	1094107	40236824		
16905	1399	1124300	1992-10-09	1992-10-09 00:00:00	1992-10-09	1992-10-09 00:00:00	\N	38000177		0	0	0		0	0	0	93062	0	00781178901	45011828		
27445	2272	19133905	2013-11-17	2013-11-17 00:00:00	2013-11-27	2013-11-27 00:00:00	2013-11-27	38000177		0	0	10		0	0	0	151013	0	834102	19133905		
65721	1438	40213227	2003-01-24	2003-01-24 00:00:00	2003-01-24	2003-01-24 00:00:00	2003-01-24	581452		0	0	0		0	0	0	95800	0	113	40213227		
148735	3270	40213296	2010-04-01	2010-04-01 00:00:00	2010-04-01	2010-04-01 00:00:00	2010-04-01	581452		0	0	0		0	0	0	217269	0	52	40213296		
111949	2459	40213314	1977-08-29	1977-08-29 00:00:00	1977-08-29	1977-08-29 00:00:00	1977-08-29	581452		0	0	0		0	0	0	163009	0	49	40213314		
41741	3456	19059056	1943-07-08	1943-07-08 00:00:00	1943-07-22	1943-07-22 00:00:00	1943-07-22	38000177		0	0	14		0	0	0	229300	0	243670	19059056		
84508	1848	40213201	2011-02-17	2011-02-17 00:00:00	2011-02-17	2011-02-17 00:00:00	2011-02-17	581452		0	0	0		0	0	0	123636	0	33	40213201		
54094	4496	19006318	1950-04-13	1950-04-13 00:00:00	1950-04-27	1950-04-27 00:00:00	1950-04-27	38000177		0	0	14		0	0	0	299280	0	105078	19006318		
51339	4268	40173590	2016-01-11	2016-01-11 00:00:00	2016-01-11	2016-01-11 00:00:00	\N	38000177		0	0	0		0	0	0	283237	0	904419	40173590		
118449	2604	40213160	1956-06-16	1956-06-16 00:00:00	1956-06-16	1956-06-16 00:00:00	1956-06-16	581452		0	0	0		0	0	0	172258	0	10	40213160		
42733	3541	19059056	1991-04-01	1991-04-01 00:00:00	1991-04-15	1991-04-15 00:00:00	1991-04-15	38000177		0	0	14		0	0	0	235216	0	243670	19059056		
2827	227	19128022	1991-08-13	1991-08-13 00:00:00	1992-08-07	1992-08-07 00:00:00	1992-08-07	38000177		0	0	360		0	0	0	15323	0	749785	19128022		
62941	5230	1127433	1983-12-12	1983-12-12 00:00:00	1983-12-19	1983-12-19 00:00:00	1983-12-19	38000177		0	0	7		0	0	0	347955	0	313782	1127433		
58482	1280	40213260	2005-12-28	2005-12-28 00:00:00	2005-12-28	2005-12-28 00:00:00	2005-12-28	581452		0	0	0		0	0	0	84591	0	121	40213260		
20819	1716	1713671	1959-06-22	1959-06-22 00:00:00	1959-06-29	1959-06-29 00:00:00	1959-06-29	38000177		0	0	7		0	0	0	114643	0	562251	1713671		
57544	1259	40213198	2013-04-22	2013-04-22 00:00:00	2013-04-22	2013-04-22 00:00:00	2013-04-22	581452		0	0	0		0	0	0	82928	0	133	40213198		
53625	4456	40229134	1967-02-09	1967-02-09 00:00:00	1967-02-23	1967-02-23 00:00:00	1967-02-23	38000177		0	0	14		0	0	0	296550	0	1043400	40229134		
61997	1354	40213314	1978-07-14	1978-07-14 00:00:00	1978-07-14	1978-07-14 00:00:00	1978-07-14	581452		0	0	0		0	0	0	89729	0	49	40213314		
18013	1491	19133873	1979-05-08	1979-05-08 00:00:00	1979-05-19	1979-05-19 00:00:00	1979-05-19	38000177		0	0	11		0	0	0	99432	0	834061	19133873		
160743	3537	40213296	2001-07-01	2001-07-01 00:00:00	2001-07-01	2001-07-01 00:00:00	2001-07-01	581452		0	0	0		0	0	0	234919	0	52	40213296		
46024	3811	1124300	1955-12-13	1955-12-13 00:00:00	1955-12-13	1955-12-13 00:00:00	\N	38000177		0	0	0		0	0	0	253151	0	00781178901	45011828		
46074	3817	19006318	1968-07-31	1968-07-31 00:00:00	1968-08-14	1968-08-14 00:00:00	1968-08-14	38000177		0	0	14		0	0	0	253515	0	105078	19006318		
44963	3720	1127433	1957-11-17	1957-11-17 00:00:00	1957-11-24	1957-11-24 00:00:00	1957-11-24	38000177		0	0	7		0	0	0	247271	0	313782	1127433		
55480	4607	1127078	1974-07-08	1974-07-08 00:00:00	1974-07-22	1974-07-22 00:00:00	1974-07-22	38000177		0	0	14		0	0	0	306897	0	282464	1127078		
157930	3477	40213160	1961-07-04	1961-07-04 00:00:00	1961-07-04	1961-07-04 00:00:00	1961-07-04	581452		0	0	0		0	0	0	230680	0	10	40213160		
1783	143	1124300	1999-01-17	1999-01-17 00:00:00	1999-01-17	1999-01-17 00:00:00	\N	38000177		0	0	0		0	0	0	9593	0	00781178901	45011828		
39205	856	40213306	1991-08-16	1991-08-16 00:00:00	1991-08-16	1991-08-16 00:00:00	1991-08-16	581452		0	0	0		0	0	0	56546	0	43	40213306		
60631	5043	19128022	1995-10-30	1995-10-30 00:00:00	1996-10-24	1996-10-24 00:00:00	1996-10-24	38000177		0	0	360		0	0	0	335159	0	749785	19128022		
232909	5118	40213160	1967-12-27	1967-12-27 00:00:00	1967-12-27	1967-12-27 00:00:00	1967-12-27	581452		0	0	0		0	0	0	340263	0	10	40213160		
45475	3761	1713671	1987-06-11	1987-06-11 00:00:00	1987-06-18	1987-06-18 00:00:00	1987-06-18	38000177		0	0	7		0	0	0	250064	0	562251	1713671		
47375	3927	1713671	1986-05-09	1986-05-09 00:00:00	1986-05-30	1986-05-30 00:00:00	1986-05-30	38000177		0	0	21		0	0	0	261100	0	562251	1713671		
37427	3092	1310034	1995-09-20	1995-09-20 00:00:00	1995-09-20	1995-09-20 00:00:00	1995-09-20	38000177		0	0	0		0	0	0	205906	0	834357	1310034		
56558	4691	19133873	1974-02-28	1974-02-28 00:00:00	1974-03-13	1974-03-13 00:00:00	1974-03-13	38000177		0	0	13		0	0	0	312587	0	834061	19133873		
54132	4498	1127433	1983-12-01	1983-12-01 00:00:00	1983-12-15	1983-12-15 00:00:00	1983-12-15	38000177		0	0	14		0	0	0	299435	0	313782	1127433		
4192	349	19128065	1981-07-06	1981-07-06 00:00:00	1982-07-01	1982-07-01 00:00:00	1982-07-01	38000177		0	0	360		0	0	0	23230	0	749882	19128065		
1163	94	1124300	1988-06-07	1988-06-07 00:00:00	1988-06-07	1988-06-07 00:00:00	\N	38000177		0	0	0		0	0	0	6321	0	00781178901	45011828		
5413	453	19059056	1971-10-07	1971-10-07 00:00:00	1971-10-21	1971-10-21 00:00:00	1971-10-21	38000177		0	0	14		0	0	0	30221	0	243670	19059056		
59805	4972	1115171	1999-08-20	1999-08-20 00:00:00	1999-09-19	1999-09-19 00:00:00	1999-09-19	38000177		0	0	30		0	0	0	330664	0	849574	1115171		
15993	1325	19078461	2013-09-22	2013-09-22 00:00:00	2013-10-06	2013-10-06 00:00:00	2013-10-06	38000177		0	0	14		0	0	0	87975	0	310965	19078461		
80262	1756	40213160	1972-11-12	1972-11-12 00:00:00	1972-11-12	1972-11-12 00:00:00	1972-11-12	581452		0	0	0		0	0	0	117437	0	10	40213160		
2201	177	19075601	2009-11-08	2009-11-08 00:00:00	2009-11-08	2009-11-08 00:00:00	2009-11-08	38000177		0	0	0		0	0	0	11982	0	309362	19075601		
237155	5207	40213296	1997-09-24	1997-09-24 00:00:00	1997-09-24	1997-09-24 00:00:00	1997-09-24	581452		0	0	0		0	0	0	346331	0	52	40213296		
54502	4529	40231925	1998-10-05	1998-10-05 00:00:00	1998-10-05	1998-10-05 00:00:00	\N	38000177		0	0	0		0	0	0	301614	0	1049221	40231925		
25532	2097	1118084	2014-03-21	2014-03-21 00:00:00	2014-03-21	2014-03-21 00:00:00	\N	38000177		0	0	0		0	0	0	139778	0	00025152531	44923712		
36031	2966	1539411	2013-11-23	2013-11-23 00:00:00	2013-11-23	2013-11-23 00:00:00	\N	38000177		0	0	0		0	0	0	198110	0	312961	1539411		
57647	4788	46233988	1977-08-27	1977-08-27 00:00:00	1977-09-10	1977-09-10 00:00:00	1977-09-10	38000177		0	0	14		0	0	0	318659	0	1652673	46233988		
19896	1634	40229134	1956-08-11	1956-08-11 00:00:00	1956-08-25	1956-08-25 00:00:00	1956-08-25	38000177		0	0	14		0	0	0	109782	0	1043400	40229134		
48891	4053	19073188	2016-01-12	2016-01-12 00:00:00	2016-01-26	2016-01-26 00:00:00	2016-01-26	38000177		0	0	14		0	0	0	269428	0	308192	19073188		
56416	1235	40213314	1978-05-01	1978-05-01 00:00:00	1978-05-01	1978-05-01 00:00:00	1978-05-01	581452		0	0	0		0	0	0	81304	0	49	40213314		
33171	2750	1310034	2011-05-25	2011-05-25 00:00:00	2011-05-25	2011-05-25 00:00:00	2011-05-25	38000177		0	0	0		0	0	0	181876	0	834357	1310034		
46736	3871	1127433	1969-11-20	1969-11-20 00:00:00	1969-12-04	1969-12-04 00:00:00	1969-12-04	38000177		0	0	14		0	0	0	257036	0	313782	1127433		
43202	3579	19059056	1965-10-26	1965-10-26 00:00:00	1965-11-16	1965-11-16 00:00:00	1965-11-16	38000177		0	0	21		0	0	0	237960	0	243670	19059056		
58469	4855	19073183	1982-04-30	1982-04-30 00:00:00	1982-05-14	1982-05-14 00:00:00	1982-05-14	38000177		0	0	14		0	0	0	323031	0	308182	19073183		
57343	4758	1713671	2002-03-10	2002-03-10 00:00:00	2002-03-31	2002-03-31 00:00:00	2002-03-31	38000177		0	0	21		0	0	0	317008	0	562251	1713671		
72196	1577	40213227	2003-05-23	2003-05-23 00:00:00	2003-05-23	2003-05-23 00:00:00	2003-05-23	581452		0	0	0		0	0	0	105875	0	113	40213227		
44722	3701	19059056	1966-12-09	1966-12-09 00:00:00	1966-12-23	1966-12-23 00:00:00	1966-12-23	38000177		0	0	14		0	0	0	246067	0	243670	19059056		
104813	2298	40213227	2004-03-11	2004-03-11 00:00:00	2004-03-11	2004-03-11 00:00:00	2004-03-11	581452		0	0	0		0	0	0	152981	0	113	40213227		
7200	605	1127078	1961-08-30	1961-08-30 00:00:00	1961-09-13	1961-09-13 00:00:00	1961-09-13	38000177		0	0	14		0	0	0	40188	0	282464	1127078		
9832	823	40169281	2009-02-09	2009-02-09 00:00:00	2009-02-09	2009-02-09 00:00:00	\N	38000177		0	0	0		0	0	0	54598	0	896209	40169281		
12536	270	40213160	1958-07-15	1958-07-15 00:00:00	1958-07-15	1958-07-15 00:00:00	1958-07-15	581452		0	0	0		0	0	0	18018	0	10	40213160		
48198	3996	1118084	2003-02-27	2003-02-27 00:00:00	2003-02-27	2003-02-27 00:00:00	\N	38000177		0	0	0		0	0	0	265643	0	00025152531	44923712		
27375	2265	1118084	2002-05-28	2002-05-28 00:00:00	2002-05-28	2002-05-28 00:00:00	\N	38000177		0	0	0		0	0	0	150581	0	00025152531	44923712		
3076	249	19128065	1997-08-08	1997-08-08 00:00:00	1998-08-03	1998-08-03 00:00:00	1998-08-03	38000177		0	0	360		0	0	0	16739	0	749882	19128065		
7796	652	920300	1991-03-12	1991-03-12 00:00:00	1991-03-19	1991-03-19 00:00:00	1991-03-19	38000177		0	0	7		0	0	0	43160	0	311989	920300		
16906	1399	1115171	2000-09-25	2000-09-25 00:00:00	2000-10-30	2000-10-30 00:00:00	2000-10-30	38000177		0	0	35		0	0	0	93039	0	849574	1115171		
27446	2272	19129144	2003-10-06	2003-10-06 00:00:00	2004-09-30	2004-09-30 00:00:00	2004-09-30	38000177		0	0	360		0	0	0	151079	0	757594	19129144		
65725	1438	40213160	1955-12-30	1955-12-30 00:00:00	1955-12-30	1955-12-30 00:00:00	1955-12-30	581452		0	0	0		0	0	0	95786	0	10	40213160		
148736	3270	40213160	1970-07-02	1970-07-02 00:00:00	1970-07-02	1970-07-02 00:00:00	1970-07-02	581452		0	0	0		0	0	0	217281	0	10	40213160		
111954	2460	40213227	2006-08-23	2006-08-23 00:00:00	2006-08-23	2006-08-23 00:00:00	2006-08-23	581452		0	0	0		0	0	0	\N	0	113	40213227		
41742	3456	46275916	1991-12-12	1991-12-12 00:00:00	1991-12-12	1991-12-12 00:00:00	1991-12-12	38000177		0	0	0		0	0	0	229296	0	1660014	46275916		
49478	4105	1713671	2004-12-19	2004-12-19 00:00:00	2005-01-02	2005-01-02 00:00:00	2005-01-02	38000177		0	0	14		0	0	0	272711	0	562251	1713671		
54095	4496	1118084	1980-08-21	1980-08-21 00:00:00	1980-08-21	1980-08-21 00:00:00	\N	38000177		0	0	0		0	0	0	299333	0	00025152531	44923712		
51340	4268	1127078	1959-01-24	1959-01-24 00:00:00	1959-02-07	1959-02-07 00:00:00	1959-02-07	38000177		0	0	14		0	0	0	283248	0	282464	1127078		
118452	2604	40213227	2017-12-02	2017-12-02 00:00:00	2017-12-02	2017-12-02 00:00:00	2017-12-02	581452		0	0	0		0	0	0	172263	0	113	40213227		
42734	3541	1127078	1978-12-07	1978-12-07 00:00:00	1978-12-21	1978-12-21 00:00:00	1978-12-21	38000177		0	0	14		0	0	0	235214	0	282464	1127078		
2828	227	19059056	1974-04-04	1974-04-04 00:00:00	1974-04-18	1974-04-18 00:00:00	1974-04-18	38000177		0	0	14		0	0	0	15320	0	243670	19059056		
62942	5230	40173590	2005-11-09	2005-11-09 00:00:00	2005-11-09	2005-11-09 00:00:00	\N	38000177		0	0	0		0	0	0	348020	0	904419	40173590		
58485	1280	40213227	1993-01-20	1993-01-20 00:00:00	1993-01-20	1993-01-20 00:00:00	1993-01-20	581452		0	0	0		0	0	0	84631	0	113	40213227		
20820	1716	1127433	1970-09-07	1970-09-07 00:00:00	1970-10-05	1970-10-05 00:00:00	1970-10-05	38000177		0	0	28		0	0	0	114702	0	313782	1127433		
57547	1259	40213227	2009-03-30	2009-03-30 00:00:00	2009-03-30	2009-03-30 00:00:00	2009-03-30	581452		0	0	0		0	0	0	82997	0	113	40213227		
53626	4456	1127433	1976-01-24	1976-01-24 00:00:00	1976-02-07	1976-02-07 00:00:00	1976-02-07	38000177		0	0	14		0	0	0	296551	0	313782	1127433		
62002	1354	40213160	1978-12-15	1978-12-15 00:00:00	1978-12-15	1978-12-15 00:00:00	1978-12-15	581452		0	0	0		0	0	0	89768	0	10	40213160		
18014	1491	1127433	2001-06-06	2001-06-06 00:00:00	2001-06-27	2001-06-27 00:00:00	2001-06-27	38000177		0	0	21		0	0	0	99455	0	313782	1127433		
160753	3537	40213260	2012-04-22	2012-04-22 00:00:00	2012-04-22	2012-04-22 00:00:00	2012-04-22	581452		0	0	0		0	0	0	\N	0	121	40213260		
46029	3813	1118084	2006-07-12	2006-07-12 00:00:00	2006-07-12	2006-07-12 00:00:00	\N	38000177		0	0	0		0	0	0	253277	0	00025152531	44923712		
46075	3817	1127433	1964-12-21	1964-12-21 00:00:00	1965-01-04	1965-01-04 00:00:00	1965-01-04	38000177		0	0	14		0	0	0	253486	0	313782	1127433		
44964	3720	1713671	1999-07-19	1999-07-19 00:00:00	1999-08-09	1999-08-09 00:00:00	1999-08-09	38000177		0	0	21		0	0	0	247275	0	562251	1713671		
55481	4608	920300	1990-01-12	1990-01-12 00:00:00	1990-01-19	1990-01-19 00:00:00	1990-01-19	38000177		0	0	7		0	0	0	307083	0	311989	920300		
157932	3477	40213160	1961-09-05	1961-09-05 00:00:00	1961-09-05	1961-09-05 00:00:00	1961-09-05	581452		0	0	0		0	0	0	230665	0	10	40213160		
1784	143	19133873	1979-05-20	1979-05-20 00:00:00	1979-05-29	1979-05-29 00:00:00	1979-05-29	38000177		0	0	9		0	0	0	9568	0	834061	19133873		
16879	364	40213227	2017-09-24	2017-09-24 00:00:00	2017-09-24	2017-09-24 00:00:00	2017-09-24	581452		0	0	0		0	0	0	24155	0	113	40213227		
60632	5043	1118084	2008-03-25	2008-03-25 00:00:00	2008-03-25	2008-03-25 00:00:00	\N	38000177		0	0	0		0	0	0	335173	0	00025152531	44923712		
232914	5118	40213296	2007-07-25	2007-07-25 00:00:00	2007-07-25	2007-07-25 00:00:00	2007-07-25	581452		0	0	0		0	0	0	340270	0	52	40213296		
45476	3761	1127433	1987-05-29	1987-05-29 00:00:00	1987-06-12	1987-06-12 00:00:00	1987-06-12	38000177		0	0	14		0	0	0	250063	0	313782	1127433		
47376	3927	19078461	1998-09-12	1998-09-12 00:00:00	1998-10-03	1998-10-03 00:00:00	1998-10-03	38000177		0	0	21		0	0	0	261037	0	310965	19078461		
37428	3093	19128065	1988-06-06	1988-06-06 00:00:00	1989-06-01	1989-06-01 00:00:00	1989-06-01	38000177		0	0	360		0	0	0	205946	0	749882	19128065		
56571	4694	1127078	1982-08-04	1982-08-04 00:00:00	1982-11-02	1982-11-02 00:00:00	1982-11-02	38000177		0	0	90		0	0	0	312718	0	282464	1127078		
54133	4498	40236446	1986-05-22	1986-05-22 00:00:00	1995-05-30	1995-05-30 00:00:00	1995-05-30	38000177		0	0	3295		0	0	0	299436	0	1091392	40236446		
4193	349	19128065	1976-08-01	1976-08-01 00:00:00	1977-07-27	1977-07-27 00:00:00	1977-07-27	38000177		0	0	360		0	0	0	23227	0	749882	19128065		
1164	94	1127433	1994-10-24	1994-10-24 00:00:00	1994-11-07	1994-11-07 00:00:00	1994-11-07	38000177		0	0	14		0	0	0	6369	0	313782	1127433		
5414	453	19006318	1971-10-07	1971-10-07 00:00:00	1971-10-21	1971-10-21 00:00:00	1971-10-21	38000177		0	0	14		0	0	0	30221	0	105078	19006318		
59806	4972	1127078	1956-01-17	1956-01-17 00:00:00	1956-01-31	1956-01-31 00:00:00	1956-01-31	38000177		0	0	14		0	0	0	330692	0	282464	1127078		
15994	1325	19073188	2013-09-22	2013-09-22 00:00:00	2013-10-06	2013-10-06 00:00:00	2013-10-06	38000177		0	0	14		0	0	0	87975	0	308192	19073188		
80264	1756	40213160	1973-01-14	1973-01-14 00:00:00	1973-01-14	1973-01-14 00:00:00	1973-01-14	581452		0	0	0		0	0	0	117427	0	10	40213160		
2202	177	1713671	1976-05-07	1976-05-07 00:00:00	1976-05-14	1976-05-14 00:00:00	1976-05-14	38000177		0	0	7		0	0	0	11970	0	562251	1713671		
62672	1371	40213160	1976-03-23	1976-03-23 00:00:00	1976-03-23	1976-03-23 00:00:00	1976-03-23	581452		0	0	0		0	0	0	90931	0	10	40213160		
54503	4529	19128065	1984-10-10	1984-10-10 00:00:00	1985-10-05	1985-10-05 00:00:00	1985-10-05	38000177		0	0	360		0	0	0	301607	0	749882	19128065		
54877	4559	1713671	1992-05-28	1992-05-28 00:00:00	1992-06-11	1992-06-11 00:00:00	1992-06-11	38000177		0	0	14		0	0	0	303777	0	562251	1713671		
36032	2966	1127433	2016-11-23	2016-11-23 00:00:00	2016-12-07	2016-12-07 00:00:00	2016-12-07	38000177		0	0	14		0	0	0	198105	0	313782	1127433		
57648	4788	1127078	1976-07-20	1976-07-20 00:00:00	1976-08-03	1976-08-03 00:00:00	1976-08-03	38000177		0	0	14		0	0	0	318678	0	282464	1127078		
19897	1634	1127433	1985-02-03	1985-02-03 00:00:00	1985-02-17	1985-02-17 00:00:00	1985-02-17	38000177		0	0	14		0	0	0	109740	0	313782	1127433		
48896	4055	40229134	2013-12-23	2013-12-23 00:00:00	2014-01-06	2014-01-06 00:00:00	2014-01-06	38000177		0	0	14		0	0	0	269558	0	1043400	40229134		
56422	1235	40213227	2006-08-07	2006-08-07 00:00:00	2006-08-07	2006-08-07 00:00:00	2006-08-07	581452		0	0	0		0	0	0	81344	0	113	40213227		
33172	2750	19059056	1926-10-29	1926-10-29 00:00:00	1927-01-27	1927-01-27 00:00:00	1927-01-27	38000177		0	0	90		0	0	0	181870	0	243670	19059056		
46737	3871	1127433	1963-09-08	1963-09-08 00:00:00	1963-09-15	1963-09-15 00:00:00	1963-09-15	38000177		0	0	7		0	0	0	257006	0	313782	1127433		
43203	3579	19078461	2004-11-12	2004-11-12 00:00:00	2004-12-03	2004-12-03 00:00:00	2004-12-03	38000177		0	0	21		0	0	0	237963	0	310965	19078461		
58470	4855	19128065	1992-09-01	1992-09-01 00:00:00	1993-08-27	1993-08-27 00:00:00	1993-08-27	38000177		0	0	360		0	0	0	323007	0	749882	19128065		
57344	4758	920300	2018-04-04	2018-04-04 00:00:00	2018-04-11	2018-04-11 00:00:00	2018-04-11	38000177		0	0	7		0	0	0	317009	0	311989	920300		
34550	2857	1127433	1965-11-02	1965-11-02 00:00:00	1965-11-16	1965-11-16 00:00:00	1965-11-16	38000177		0	0	14		0	0	0	189708	0	313782	1127433		
44723	3701	19078461	1996-07-23	1996-07-23 00:00:00	1996-08-27	1996-08-27 00:00:00	1996-08-27	38000177		0	0	35		0	0	0	246070	0	310965	19078461		
104815	2298	40213296	2014-03-27	2014-03-27 00:00:00	2014-03-27	2014-03-27 00:00:00	2014-03-27	581452		0	0	0		0	0	0	153028	0	52	40213296		
7201	605	19006318	1961-08-30	1961-08-30 00:00:00	1961-09-13	1961-09-13 00:00:00	1961-09-13	38000177		0	0	14		0	0	0	40188	0	105078	19006318		
9833	823	19075601	2019-04-15	2019-04-15 00:00:00	2019-04-15	2019-04-15 00:00:00	2019-04-15	38000177		0	0	0		0	0	0	54601	0	309362	19075601		
12549	270	40213296	2000-07-18	2000-07-18 00:00:00	2000-07-18	2000-07-18 00:00:00	2000-07-18	581452		0	0	0		0	0	0	18010	0	52	40213296		
48199	3996	1539411	2003-02-25	2003-02-25 00:00:00	2003-02-25	2003-02-25 00:00:00	\N	38000177		0	0	0		0	0	0	265643	0	312961	1539411		
27376	2265	1713671	1997-03-26	1997-03-26 00:00:00	1997-08-13	1997-08-13 00:00:00	1997-08-13	38000177		0	0	140		0	0	0	150596	0	562251	1713671		
3077	249	19129144	2004-07-06	2004-07-06 00:00:00	2005-07-01	2005-07-01 00:00:00	2005-07-01	38000177		0	0	360		0	0	0	16776	0	757594	19129144		
7797	652	19078461	1986-08-07	1986-08-07 00:00:00	1986-09-11	1986-09-11 00:00:00	1986-09-11	38000177		0	0	35		0	0	0	43184	0	310965	19078461		
16907	1399	1127433	2008-04-21	2008-04-21 00:00:00	2008-05-26	2008-05-26 00:00:00	2008-05-26	38000177		0	0	35		0	0	0	93040	0	313782	1127433		
27447	2272	1118084	2015-12-12	2015-12-12 00:00:00	2015-12-12	2015-12-12 00:00:00	\N	38000177		0	0	0		0	0	0	151020	0	00025152531	44923712		
65731	1438	40213198	2017-03-10	2017-03-10 00:00:00	2017-03-10	2017-03-10 00:00:00	2017-03-10	581452		0	0	0		0	0	0	95835	0	133	40213198		
148744	3270	40213227	1992-05-28	1992-05-28 00:00:00	1992-05-28	1992-05-28 00:00:00	1992-05-28	581452		0	0	0		0	0	0	217346	0	113	40213227		
111955	2460	40213306	2006-08-23	2006-08-23 00:00:00	2006-08-23	2006-08-23 00:00:00	2006-08-23	581452		0	0	0		0	0	0	\N	0	43	40213306		
41743	3456	1310034	1991-12-12	1991-12-12 00:00:00	1991-12-12	1991-12-12 00:00:00	1991-12-12	38000177		0	0	0		0	0	0	229296	0	834357	1310034		
49479	4105	1127433	1957-05-14	1957-05-14 00:00:00	1957-05-28	1957-05-28 00:00:00	1957-05-28	38000177		0	0	14		0	0	0	272696	0	313782	1127433		
54096	4496	19059056	1964-08-01	1964-08-01 00:00:00	1964-08-22	1964-08-22 00:00:00	1964-08-22	38000177		0	0	21		0	0	0	299306	0	243670	19059056		
51341	4268	19006318	1959-01-24	1959-01-24 00:00:00	1959-02-07	1959-02-07 00:00:00	1959-02-07	38000177		0	0	14		0	0	0	283248	0	105078	19006318		
179623	3949	40213227	2000-04-10	2000-04-10 00:00:00	2000-04-10	2000-04-10 00:00:00	2000-04-10	581452		0	0	0		0	0	0	262490	0	113	40213227		
42735	3542	19078461	2010-07-03	2010-07-03 00:00:00	2010-09-01	2010-09-01 00:00:00	2010-09-01	38000177		0	0	60		0	0	0	235326	0	310965	19078461		
176743	3885	40213260	2014-06-27	2014-06-27 00:00:00	2014-06-27	2014-06-27 00:00:00	2014-06-27	581452		0	0	0		0	0	0	\N	0	121	40213260		
62943	5230	1127433	1996-06-12	1996-06-12 00:00:00	1996-06-26	1996-06-26 00:00:00	1996-06-26	38000177		0	0	14		0	0	0	347961	0	313782	1127433		
58490	1280	40213227	2002-12-11	2002-12-11 00:00:00	2002-12-11	2002-12-11 00:00:00	2002-12-11	581452		0	0	0		0	0	0	84569	0	113	40213227		
20821	1716	40165015	1993-06-18	1993-06-18 00:00:00	1993-06-18	1993-06-18 00:00:00	\N	38000177		0	0	0		0	0	0	114707	0	861467	40165015		
57551	1259	40213201	2014-04-28	2014-04-28 00:00:00	2014-04-28	2014-04-28 00:00:00	2014-04-28	581452		0	0	0		0	0	0	82957	0	33	40213201		
53628	4456	40229134	2010-03-31	2010-03-31 00:00:00	2010-04-14	2010-04-14 00:00:00	2010-04-14	38000177		0	0	14		0	0	0	296579	0	1043400	40229134		
62013	1355	40213227	2005-08-19	2005-08-19 00:00:00	2005-08-19	2005-08-19 00:00:00	2005-08-19	581452		0	0	0		0	0	0	89845	0	113	40213227		
18015	1491	1124300	2006-05-20	2006-05-20 00:00:00	2006-05-20	2006-05-20 00:00:00	\N	38000177		0	0	0		0	0	0	99420	0	00781178901	45011828		
160754	3537	40213160	1962-03-04	1962-03-04 00:00:00	1962-03-04	1962-03-04 00:00:00	1962-03-04	581452		0	0	0		0	0	0	234973	0	10	40213160		
46030	3813	19078461	1994-11-07	1994-11-07 00:00:00	1994-11-28	1994-11-28 00:00:00	1994-11-28	38000177		0	0	21		0	0	0	253261	0	310965	19078461		
46076	3817	1127433	2017-06-25	2017-06-25 00:00:00	2017-07-09	2017-07-09 00:00:00	2017-07-09	38000177		0	0	14		0	0	0	253492	0	313782	1127433		
44965	3720	19059056	1968-09-10	1968-09-10 00:00:00	1968-12-09	1968-12-09 00:00:00	1968-12-09	38000177		0	0	90		0	0	0	247308	0	243670	19059056		
55482	4608	40236824	1990-01-12	1990-01-12 00:00:00	1990-01-19	1990-01-19 00:00:00	1990-01-19	38000177		0	0	7		0	0	0	307083	0	1094107	40236824		
157937	3477	40213227	1993-06-15	1993-06-15 00:00:00	1993-06-15	1993-06-15 00:00:00	1993-06-15	581452		0	0	0		0	0	0	230735	0	113	40213227		
1785	143	1127433	1979-06-16	1979-06-16 00:00:00	1979-07-07	1979-07-07 00:00:00	1979-07-07	38000177		0	0	21		0	0	0	9609	0	313782	1127433		
16881	364	40213198	2010-12-26	2010-12-26 00:00:00	2010-12-26	2010-12-26 00:00:00	2010-12-26	581452		0	0	0		0	0	0	24199	0	133	40213198		
60633	5043	19128022	1993-11-09	1993-11-09 00:00:00	1994-11-04	1994-11-04 00:00:00	1994-11-04	38000177		0	0	360		0	0	0	335138	0	749785	19128022		
232920	5118	40213160	1967-10-25	1967-10-25 00:00:00	1967-10-25	1967-10-25 00:00:00	1967-10-25	581452		0	0	0		0	0	0	340178	0	10	40213160		
45477	3761	19006318	1959-10-26	1959-10-26 00:00:00	1959-11-09	1959-11-09 00:00:00	1959-11-09	38000177		0	0	14		0	0	0	250078	0	105078	19006318		
47377	3927	1713671	1962-07-26	1962-07-26 00:00:00	1962-08-16	1962-08-16 00:00:00	1962-08-16	38000177		0	0	21		0	0	0	261013	0	562251	1713671		
37429	3093	1127433	1984-11-19	1984-11-19 00:00:00	1984-12-10	1984-12-10 00:00:00	1984-12-10	38000177		0	0	21		0	0	0	205972	0	313782	1127433		
56572	4694	1127433	2001-02-25	2001-02-25 00:00:00	2001-03-27	2001-03-27 00:00:00	2001-03-27	38000177		0	0	30		0	0	0	312720	0	313782	1127433		
54134	4498	1127433	1979-12-12	1979-12-12 00:00:00	1979-12-26	1979-12-26 00:00:00	1979-12-26	38000177		0	0	14		0	0	0	299469	0	313782	1127433		
4194	349	1124300	1994-02-08	1994-02-08 00:00:00	1994-02-08	1994-02-08 00:00:00	\N	38000177		0	0	0		0	0	0	23221	0	00781178901	45011828		
1165	94	19133873	1955-10-12	1955-10-12 00:00:00	1955-10-19	1955-10-19 00:00:00	1955-10-19	38000177		0	0	7		0	0	0	6314	0	834061	19133873		
5415	453	19059056	1992-04-17	1992-04-17 00:00:00	1992-05-08	1992-05-08 00:00:00	1992-05-08	38000177		0	0	21		0	0	0	30152	0	243670	19059056		
59807	4972	19006318	1956-01-17	1956-01-17 00:00:00	1956-01-31	1956-01-31 00:00:00	1956-01-31	38000177		0	0	14		0	0	0	330692	0	105078	19006318		
73575	1606	40213227	2001-01-08	2001-01-08 00:00:00	2001-01-08	2001-01-08 00:00:00	2001-01-08	581452		0	0	0		0	0	0	107871	0	113	40213227		
80267	1756	40213160	1973-04-15	1973-04-15 00:00:00	1973-04-15	1973-04-15 00:00:00	1973-04-15	581452		0	0	0		0	0	0	117438	0	10	40213160		
2203	177	19078461	2011-12-03	2011-12-03 00:00:00	2011-12-17	2011-12-17 00:00:00	2011-12-17	38000177		0	0	14		0	0	0	11994	0	310965	19078461		
62686	1371	40213296	2011-04-19	2011-04-19 00:00:00	2011-04-19	2011-04-19 00:00:00	2011-04-19	581452		0	0	0		0	0	0	90924	0	52	40213296		
54504	4529	1127433	1965-04-12	1965-04-12 00:00:00	1965-04-19	1965-04-19 00:00:00	1965-04-19	38000177		0	0	7		0	0	0	301546	0	313782	1127433		
54878	4559	1713671	1962-01-14	1962-01-14 00:00:00	1962-01-28	1962-01-28 00:00:00	1962-01-28	38000177		0	0	14		0	0	0	303790	0	562251	1713671		
36033	2966	1118084	2001-02-19	2001-02-19 00:00:00	2001-02-19	2001-02-19 00:00:00	\N	38000177		0	0	0		0	0	0	198119	0	00025152531	44923712		
57649	4788	46233988	1976-07-20	1976-07-20 00:00:00	1976-08-03	1976-08-03 00:00:00	1976-08-03	38000177		0	0	14		0	0	0	318678	0	1652673	46233988		
19898	1634	1127433	1950-11-07	1950-11-07 00:00:00	1950-11-21	1950-11-21 00:00:00	1950-11-21	38000177		0	0	14		0	0	0	109728	0	313782	1127433		
48897	4055	1127433	1979-09-29	1979-09-29 00:00:00	1979-10-06	1979-10-06 00:00:00	1979-10-06	38000177		0	0	7		0	0	0	269509	0	313782	1127433		
56424	1235	40213160	1975-11-03	1975-11-03 00:00:00	1975-11-03	1975-11-03 00:00:00	1975-11-03	581452		0	0	0		0	0	0	81327	0	10	40213160		
33173	2750	19133905	1973-09-25	1973-09-25 00:00:00	1973-10-03	1973-10-03 00:00:00	1973-10-03	38000177		0	0	8		0	0	0	181888	0	834102	19133905		
46738	3871	1127433	1991-05-25	1991-05-25 00:00:00	1991-06-01	1991-06-01 00:00:00	1991-06-01	38000177		0	0	7		0	0	0	257063	0	313782	1127433		
43204	3579	46275916	2006-05-20	2006-05-20 00:00:00	2006-05-20	2006-05-20 00:00:00	2006-05-20	38000177		0	0	0		0	0	0	237964	0	1660014	46275916		
16431	1360	19128022	1991-09-21	1991-09-21 00:00:00	1992-09-15	1992-09-15 00:00:00	1992-09-15	38000177		0	0	360		0	0	0	90254	0	749785	19128022		
57345	4758	40236824	2018-04-04	2018-04-04 00:00:00	2018-04-11	2018-04-11 00:00:00	2018-04-11	38000177		0	0	7		0	0	0	317009	0	1094107	40236824		
34551	2857	1127433	1979-12-02	1979-12-02 00:00:00	1979-12-16	1979-12-16 00:00:00	1979-12-16	38000177		0	0	14		0	0	0	189670	0	313782	1127433		
44724	3701	19133873	1959-12-16	1959-12-16 00:00:00	1959-12-25	1959-12-25 00:00:00	1959-12-25	38000177		0	0	9		0	0	0	246057	0	834061	19133873		
104816	2298	40213160	1971-02-04	1971-02-04 00:00:00	1971-02-04	1971-02-04 00:00:00	1971-02-04	581452		0	0	0		0	0	0	153021	0	10	40213160		
7202	605	19059056	1957-01-11	1957-01-11 00:00:00	1957-01-25	1957-01-25 00:00:00	1957-01-25	38000177		0	0	14		0	0	0	40179	0	243670	19059056		
9834	823	40220960	2019-04-15	2019-04-15 00:00:00	2019-04-15	2019-04-15 00:00:00	2019-04-15	38000177		0	0	0		0	0	0	54601	0	1804799	40220960		
12551	270	40213227	2000-07-18	2000-07-18 00:00:00	2000-07-18	2000-07-18 00:00:00	2000-07-18	581452		0	0	0		0	0	0	18010	0	113	40213227		
48200	3996	1332419	2003-02-25	2003-02-25 00:00:00	2003-02-25	2003-02-25 00:00:00	\N	38000177		0	0	0		0	0	0	265643	0	197361	1332419		
110143	2419	40213227	2006-03-17	2006-03-17 00:00:00	2006-03-17	2006-03-17 00:00:00	2006-03-17	581452		0	0	0		0	0	0	160581	0	113	40213227		
3078	249	19133905	2013-07-21	2013-07-21 00:00:00	2013-08-01	2013-08-01 00:00:00	2013-08-01	38000177		0	0	11		0	0	0	16757	0	834102	19133905		
7798	652	19059056	1973-10-01	1973-10-01 00:00:00	1973-10-15	1973-10-15 00:00:00	1973-10-15	38000177		0	0	14		0	0	0	43163	0	243670	19059056		
16908	1399	40229134	1967-05-25	1967-05-25 00:00:00	1967-06-01	1967-06-01 00:00:00	1967-06-01	38000177		0	0	7		0	0	0	92994	0	1043400	40229134		
27448	2272	19133905	2010-06-20	2010-06-20 00:00:00	2010-07-02	2010-07-02 00:00:00	2010-07-02	38000177		0	0	12		0	0	0	151033	0	834102	19133905		
65736	1438	40213296	1996-02-02	1996-02-02 00:00:00	1996-02-02	1996-02-02 00:00:00	1996-02-02	581452		0	0	0		0	0	0	95794	0	52	40213296		
168094	3695	40213160	1980-10-13	1980-10-13 00:00:00	1980-10-13	1980-10-13 00:00:00	1980-10-13	581452		0	0	0		0	0	0	245678	0	10	40213160		
111956	2460	40213180	2006-08-23	2006-08-23 00:00:00	2006-08-23	2006-08-23 00:00:00	2006-08-23	581452		0	0	0		0	0	0	\N	0	114	40213180		
41744	3456	40243436	1991-12-12	1991-12-12 00:00:00	1991-12-12	1991-12-12 00:00:00	1991-12-12	38000177		0	0	0		0	0	0	229296	0	1190795	40243436		
49480	4105	1127433	1995-09-13	1995-09-13 00:00:00	1995-09-27	1995-09-27 00:00:00	1995-09-27	38000177		0	0	14		0	0	0	272776	0	313782	1127433		
54097	4496	1127433	2010-04-21	2010-04-21 00:00:00	2010-05-05	2010-05-05 00:00:00	2010-05-05	38000177		0	0	14		0	0	0	299313	0	313782	1127433		
51342	4268	1127433	1971-05-28	1971-05-28 00:00:00	1971-06-11	1971-06-11 00:00:00	1971-06-11	38000177		0	0	14		0	0	0	283210	0	313782	1127433		
179627	3949	40213160	1969-11-24	1969-11-24 00:00:00	1969-11-24	1969-11-24 00:00:00	1969-11-24	581452		0	0	0		0	0	0	262499	0	10	40213160		
42736	3542	19059056	1950-11-21	1950-11-21 00:00:00	1950-12-12	1950-12-12 00:00:00	1950-12-12	38000177		0	0	21		0	0	0	235238	0	243670	19059056		
176744	3885	40213296	2003-06-13	2003-06-13 00:00:00	2003-06-13	2003-06-13 00:00:00	2003-06-13	581452		0	0	0		0	0	0	\N	0	52	40213296		
62944	5230	1127433	2013-04-06	2013-04-06 00:00:00	2013-04-20	2013-04-20 00:00:00	2013-04-20	38000177		0	0	14		0	0	0	347943	0	313782	1127433		
51046	1118	40213296	2014-02-23	2014-02-23 00:00:00	2014-02-23	2014-02-23 00:00:00	2014-02-23	581452		0	0	0		0	0	0	\N	0	52	40213296		
20822	1716	1127433	1993-06-18	1993-06-18 00:00:00	1993-09-16	1993-09-16 00:00:00	1993-09-16	38000177		0	0	90		0	0	0	114707	0	313782	1127433		
57562	1259	40213227	1999-04-05	1999-04-05 00:00:00	1999-04-05	1999-04-05 00:00:00	1999-04-05	581452		0	0	0		0	0	0	82996	0	113	40213227		
53629	4456	1127433	1999-12-09	1999-12-09 00:00:00	1999-12-16	1999-12-16 00:00:00	1999-12-16	38000177		0	0	7		0	0	0	296553	0	313782	1127433		
62014	1355	40213296	2005-08-19	2005-08-19 00:00:00	2005-08-19	2005-08-19 00:00:00	2005-08-19	581452		0	0	0		0	0	0	89845	0	52	40213296		
2137	170	920300	1996-03-11	1996-03-11 00:00:00	1996-03-18	1996-03-18 00:00:00	1996-03-18	38000177		0	0	7		0	0	0	11577	0	311989	920300		
160759	3537	40213160	1966-06-05	1966-06-05 00:00:00	1966-06-05	1966-06-05 00:00:00	1966-06-05	581452		0	0	0		0	0	0	234913	0	10	40213160		
46031	3813	40229134	1995-08-06	1995-08-06 00:00:00	1995-08-13	1995-08-13 00:00:00	1995-08-13	38000177		0	0	7		0	0	0	253281	0	1043400	40229134		
46077	3817	1127433	2011-05-17	2011-05-17 00:00:00	2011-05-31	2011-05-31 00:00:00	2011-05-31	38000177		0	0	14		0	0	0	253530	0	313782	1127433		
44966	3720	1127433	1996-09-13	1996-09-13 00:00:00	1996-09-27	1996-09-27 00:00:00	1996-09-27	38000177		0	0	14		0	0	0	247320	0	313782	1127433		
55483	4608	19078461	2006-12-04	2006-12-04 00:00:00	2007-01-01	2007-01-01 00:00:00	2007-01-01	38000177		0	0	28		0	0	0	307069	0	310965	19078461		
157942	3477	40213260	2012-09-04	2012-09-04 00:00:00	2012-09-04	2012-09-04 00:00:00	2012-09-04	581452		0	0	0		0	0	0	230672	0	121	40213260		
1786	143	40162522	1981-04-27	1981-04-27 00:00:00	1981-04-27	1981-04-27 00:00:00	\N	38000177		0	0	0		0	0	0	9610	0	857005	40162522		
16888	364	40213227	1996-10-06	1996-10-06 00:00:00	1996-10-06	1996-10-06 00:00:00	1996-10-06	581452		0	0	0		0	0	0	24146	0	113	40213227		
60634	5043	19128022	1990-11-25	1990-11-25 00:00:00	1991-11-20	1991-11-20 00:00:00	1991-11-20	38000177		0	0	360		0	0	0	335135	0	749785	19128022		
232922	5118	40213227	2018-07-25	2018-07-25 00:00:00	2018-07-25	2018-07-25 00:00:00	2018-07-25	581452		0	0	0		0	0	0	340262	0	113	40213227		
45478	3761	19059056	1959-10-26	1959-10-26 00:00:00	1959-11-09	1959-11-09 00:00:00	1959-11-09	38000177		0	0	14		0	0	0	250078	0	243670	19059056		
47378	3927	1127433	1973-06-11	1973-06-11 00:00:00	1973-06-18	1973-06-18 00:00:00	1973-06-18	38000177		0	0	7		0	0	0	261044	0	313782	1127433		
37430	3093	19059056	1973-05-16	1973-05-16 00:00:00	1973-06-06	1973-06-06 00:00:00	1973-06-06	38000177		0	0	21		0	0	0	205970	0	243670	19059056		
56573	4694	40165015	2001-02-25	2001-02-25 00:00:00	2001-02-25	2001-02-25 00:00:00	\N	38000177		0	0	0		0	0	0	312720	0	861467	40165015		
54135	4498	19112599	1978-03-01	1978-03-01 00:00:00	1978-03-01	1978-03-01 00:00:00	\N	38000177		0	0	0		0	0	0	299481	0	477045	19112599		
4195	349	19128065	1978-07-22	1978-07-22 00:00:00	1979-07-17	1979-07-17 00:00:00	1979-07-17	38000177		0	0	360		0	0	0	23228	0	749882	19128065		
1166	94	19133873	1959-12-30	1959-12-30 00:00:00	1960-01-10	1960-01-10 00:00:00	1960-01-10	38000177		0	0	11		0	0	0	6353	0	834061	19133873		
5416	454	1127433	1958-01-01	1958-01-01 00:00:00	1958-01-08	1958-01-08 00:00:00	1958-01-08	38000177		0	0	7		0	0	0	30347	0	313782	1127433		
59808	4972	1127433	1984-07-11	1984-07-11 00:00:00	1984-07-25	1984-07-25 00:00:00	1984-07-25	38000177		0	0	14		0	0	0	330668	0	313782	1127433		
47577	1039	40213160	1960-11-26	1960-11-26 00:00:00	1960-11-26	1960-11-26 00:00:00	1960-11-26	581452		0	0	0		0	0	0	68387	0	10	40213160		
80270	1756	40213160	1977-07-17	1977-07-17 00:00:00	1977-07-17	1977-07-17 00:00:00	1977-07-17	581452		0	0	0		0	0	0	117431	0	10	40213160		
2204	177	19073188	2011-12-03	2011-12-03 00:00:00	2011-12-17	2011-12-17 00:00:00	2011-12-17	38000177		0	0	14		0	0	0	11994	0	308192	19073188		
62688	1371	40213227	2013-04-23	2013-04-23 00:00:00	2013-04-23	2013-04-23 00:00:00	2013-04-23	581452		0	0	0		0	0	0	90905	0	113	40213227		
54506	4529	1118084	1997-08-30	1997-08-30 00:00:00	1997-08-30	1997-08-30 00:00:00	\N	38000177		0	0	0		0	0	0	301561	0	00025152531	44923712		
54879	4559	19078461	1985-03-06	1985-03-06 00:00:00	1985-03-27	1985-03-27 00:00:00	1985-03-27	38000177		0	0	21		0	0	0	303806	0	310965	19078461		
36034	2966	1713671	1991-10-25	1991-10-25 00:00:00	1991-11-08	1991-11-08 00:00:00	1991-11-08	38000177		0	0	14		0	0	0	198086	0	562251	1713671		
57650	4788	19133873	1978-09-10	1978-09-10 00:00:00	1978-09-20	1978-09-20 00:00:00	1978-09-20	38000177		0	0	10		0	0	0	318675	0	834061	19133873		
19899	1634	19018935	2014-08-29	2014-08-29 00:00:00	2014-08-29	2014-08-29 00:00:00	\N	38000177		0	0	0		0	0	0	109777	0	197604	19018935		
48898	4055	1127433	1970-05-01	1970-05-01 00:00:00	1970-05-15	1970-05-15 00:00:00	1970-05-15	38000177		0	0	14		0	0	0	269525	0	313782	1127433		
56427	1235	40213314	1977-10-31	1977-10-31 00:00:00	1977-10-31	1977-10-31 00:00:00	1977-10-31	581452		0	0	0		0	0	0	81317	0	49	40213314		
33174	2750	1118084	1963-01-23	1963-01-23 00:00:00	1963-01-23	1963-01-23 00:00:00	\N	38000177		0	0	0		0	0	0	181946	0	00025152531	44923712		
46739	3871	19078461	2003-09-24	2003-09-24 00:00:00	2003-10-08	2003-10-08 00:00:00	2003-10-08	38000177		0	0	14		0	0	0	257040	0	310965	19078461		
43205	3579	40243436	2006-05-20	2006-05-20 00:00:00	2006-05-20	2006-05-20 00:00:00	2006-05-20	38000177		0	0	0		0	0	0	237964	0	1190795	40243436		
16432	1361	40231925	1999-10-31	1999-10-31 00:00:00	1999-10-31	1999-10-31 00:00:00	\N	38000177		0	0	0		0	0	0	90292	0	1049221	40231925		
57346	4759	19115351	2017-09-12	2017-09-12 00:00:00	2018-05-01	2018-05-01 00:00:00	2018-05-01	38000177		0	0	231		0	0	0	317078	0	563026	19115351		
34552	2857	19133873	1968-03-22	1968-03-22 00:00:00	1968-03-30	1968-03-30 00:00:00	1968-03-30	38000177		0	0	8		0	0	0	189709	0	834061	19133873		
44726	3701	40229134	1980-06-16	1980-06-16 00:00:00	1980-06-23	1980-06-23 00:00:00	1980-06-23	38000177		0	0	7		0	0	0	246119	0	1043400	40229134		
42346	923	40213296	1998-11-18	1998-11-18 00:00:00	1998-11-18	1998-11-18 00:00:00	1998-11-18	581452		0	0	0		0	0	0	61470	0	52	40213296		
7203	605	19006318	1957-01-11	1957-01-11 00:00:00	1957-01-25	1957-01-25 00:00:00	1957-01-25	38000177		0	0	14		0	0	0	40179	0	105078	19006318		
9836	823	40229134	1970-05-08	1970-05-08 00:00:00	1970-05-15	1970-05-15 00:00:00	1970-05-15	38000177		0	0	7		0	0	0	54550	0	1043400	40229134		
27240	2250	19059056	1960-10-12	1960-10-12 00:00:00	1960-10-26	1960-10-26 00:00:00	1960-10-26	38000177		0	0	14		0	0	0	149629	0	243670	19059056		
48201	3996	19075601	2003-02-25	2003-02-25 00:00:00	2003-02-25	2003-02-25 00:00:00	\N	38000177		0	0	0		0	0	0	265643	0	309362	19075601		
86620	1900	40213296	2003-12-29	2003-12-29 00:00:00	2003-12-29	2003-12-29 00:00:00	2003-12-29	581452		0	0	0		0	0	0	126519	0	52	40213296		
3079	249	1713671	1987-01-31	1987-01-31 00:00:00	1987-02-07	1987-02-07 00:00:00	1987-02-07	38000177		0	0	7		0	0	0	16766	0	562251	1713671		
10853	905	1127433	1988-02-23	1988-02-23 00:00:00	1988-03-15	1988-03-15 00:00:00	1988-03-15	38000177		0	0	21		0	0	0	60194	0	313782	1127433		
16909	1399	40232448	1962-07-20	1962-07-20 00:00:00	1962-07-20	1962-07-20 00:00:00	\N	38000177		0	0	0		0	0	0	93044	0	1049630	40232448		
27449	2272	19128022	1993-11-27	1993-11-27 00:00:00	1994-11-22	1994-11-22 00:00:00	1994-11-22	38000177		0	0	360		0	0	0	151034	0	749785	19128022		
76628	1674	40213314	1977-12-19	1977-12-19 00:00:00	1977-12-19	1977-12-19 00:00:00	1977-12-19	581452		0	0	0		0	0	0	112396	0	49	40213314		
168096	3695	40213314	1980-07-14	1980-07-14 00:00:00	1980-07-14	1980-07-14 00:00:00	1980-07-14	581452		0	0	0		0	0	0	245596	0	49	40213314		
111958	2460	40213306	2006-08-30	2006-08-30 00:00:00	2006-08-30	2006-08-30 00:00:00	2006-08-30	581452		0	0	0		0	0	0	163135	0	43	40213306		
1551	35	40213260	2010-03-23	2010-03-23 00:00:00	2010-03-23	2010-03-23 00:00:00	2010-03-23	581452		0	0	0		0	0	0	2482	0	121	40213260		
49481	4105	1127433	1947-12-03	1947-12-03 00:00:00	1947-12-17	1947-12-17 00:00:00	1947-12-17	38000177		0	0	14		0	0	0	272756	0	313782	1127433		
54098	4496	19059056	1970-06-22	1970-06-22 00:00:00	1970-09-20	1970-09-20 00:00:00	1970-09-20	38000177		0	0	90		0	0	0	299307	0	243670	19059056		
51343	4268	19128065	1975-08-08	1975-08-08 00:00:00	1976-08-02	1976-08-02 00:00:00	1976-08-02	38000177		0	0	360		0	0	0	283231	0	749882	19128065		
179631	3949	40213296	2013-02-18	2013-02-18 00:00:00	2013-02-18	2013-02-18 00:00:00	2013-02-18	581452		0	0	0		0	0	0	262470	0	52	40213296		
42737	3542	1127433	1993-01-14	1993-01-14 00:00:00	1993-02-04	1993-02-04 00:00:00	1993-02-04	38000177		0	0	21		0	0	0	235323	0	313782	1127433		
176751	3885	40213160	1963-02-22	1963-02-22 00:00:00	1963-02-22	1963-02-22 00:00:00	1963-02-22	581452		0	0	0		0	0	0	258261	0	10	40213160		
62950	5232	1127433	2007-11-15	2007-11-15 00:00:00	2007-11-22	2007-11-22 00:00:00	2007-11-22	38000177		0	0	7		0	0	0	348090	0	313782	1127433		
51047	1118	40213160	1974-01-20	1974-01-20 00:00:00	1974-01-20	1974-01-20 00:00:00	1974-01-20	581452		0	0	0		0	0	0	73710	0	10	40213160		
20823	1716	40232448	1948-11-09	1948-11-09 00:00:00	1948-11-09	1948-11-09 00:00:00	\N	38000177		0	0	0		0	0	0	114731	0	1049630	40232448		
43119	3572	1127433	1984-01-20	1984-01-20 00:00:00	1984-02-19	1984-02-19 00:00:00	1984-02-19	38000177		0	0	30		0	0	0	237444	0	313782	1127433		
53630	4457	1713671	2009-07-09	2009-07-09 00:00:00	2009-07-23	2009-07-23 00:00:00	2009-07-23	38000177		0	0	14		0	0	0	296622	0	562251	1713671		
62018	1355	40213160	1964-01-17	1964-01-17 00:00:00	1964-01-17	1964-01-17 00:00:00	1964-01-17	581452		0	0	0		0	0	0	89826	0	10	40213160		
2138	170	1127433	1994-06-03	1994-06-03 00:00:00	1994-06-24	1994-06-24 00:00:00	1994-06-24	38000177		0	0	21		0	0	0	11580	0	313782	1127433		
160765	3537	40213227	1992-11-08	1992-11-08 00:00:00	1992-11-08	1992-11-08 00:00:00	1992-11-08	581452		0	0	0		0	0	0	234936	0	113	40213227		
46032	3813	1127433	2012-10-01	2012-10-01 00:00:00	2012-10-15	2012-10-15 00:00:00	2012-10-15	38000177		0	0	14		0	0	0	253302	0	313782	1127433		
46078	3817	1127433	2012-09-16	2012-09-16 00:00:00	2012-09-23	2012-09-23 00:00:00	2012-09-23	38000177		0	0	7		0	0	0	253514	0	313782	1127433		
44967	3720	1127433	2008-05-09	2008-05-09 00:00:00	2008-05-16	2008-05-16 00:00:00	2008-05-16	38000177		0	0	7		0	0	0	247287	0	313782	1127433		
55484	4608	19073188	2006-12-04	2006-12-04 00:00:00	2007-01-01	2007-01-01 00:00:00	2007-01-01	38000177		0	0	28		0	0	0	307069	0	308192	19073188		
157944	3477	40213227	2012-09-04	2012-09-04 00:00:00	2012-09-04	2012-09-04 00:00:00	2012-09-04	581452		0	0	0		0	0	0	230672	0	113	40213227		
1787	143	1127433	1981-04-27	1981-04-27 00:00:00	1981-05-27	1981-05-27 00:00:00	1981-05-27	38000177		0	0	30		0	0	0	9610	0	313782	1127433		
207842	4560	40213227	1999-01-13	1999-01-13 00:00:00	1999-01-13	1999-01-13 00:00:00	1999-01-13	581452		0	0	0		0	0	0	303845	0	113	40213227		
60635	5043	40162522	1994-09-02	1994-09-02 00:00:00	1994-09-02	1994-09-02 00:00:00	\N	38000177		0	0	0		0	0	0	335153	0	857005	40162522		
232923	5118	40213260	2018-07-25	2018-07-25 00:00:00	2018-07-25	2018-07-25 00:00:00	2018-07-25	581452		0	0	0		0	0	0	340262	0	121	40213260		
45479	3761	19006318	1959-07-22	1959-07-22 00:00:00	1959-08-05	1959-08-05 00:00:00	1959-08-05	38000177		0	0	14		0	0	0	250077	0	105078	19006318		
47379	3927	19059056	1960-04-10	1960-04-10 00:00:00	1960-05-15	1960-05-15 00:00:00	1960-05-15	38000177		0	0	35		0	0	0	261034	0	243670	19059056		
37431	3093	1127433	2019-03-26	2019-03-26 00:00:00	2019-04-02	2019-04-02 00:00:00	2019-04-02	38000177		0	0	7		0	0	0	205945	0	313782	1127433		
56574	4694	19078461	2012-12-24	2012-12-24 00:00:00	2013-01-07	2013-01-07 00:00:00	2013-01-07	38000177		0	0	14		0	0	0	312721	0	310965	19078461		
54136	4498	1127433	2005-04-29	2005-04-29 00:00:00	2005-05-13	2005-05-13 00:00:00	2005-05-13	38000177		0	0	14		0	0	0	299439	0	313782	1127433		
4196	349	1713671	2008-09-11	2008-09-11 00:00:00	2008-09-25	2008-09-25 00:00:00	2008-09-25	38000177		0	0	14		0	0	0	23182	0	562251	1713671		
1167	94	1127433	1982-07-03	1982-07-03 00:00:00	1982-07-10	1982-07-10 00:00:00	1982-07-10	38000177		0	0	7		0	0	0	6340	0	313782	1127433		
5417	454	1115171	2006-02-13	2006-02-13 00:00:00	2006-05-14	2006-05-14 00:00:00	2006-05-14	38000177		0	0	90		0	0	0	30276	0	849574	1115171		
59809	4972	1713671	1980-04-13	1980-04-13 00:00:00	1980-11-30	1980-11-30 00:00:00	1980-11-30	38000177		0	0	231		0	0	0	330703	0	562251	1713671		
47585	1039	40213227	2002-03-30	2002-03-30 00:00:00	2002-03-30	2002-03-30 00:00:00	2002-03-30	581452		0	0	0		0	0	0	68359	0	113	40213227		
80271	1756	40213314	1977-07-17	1977-07-17 00:00:00	1977-07-17	1977-07-17 00:00:00	1977-07-17	581452		0	0	0		0	0	0	117431	0	49	40213314		
2205	177	1115171	2007-09-15	2007-09-15 00:00:00	2007-10-06	2007-10-06 00:00:00	2007-10-06	38000177		0	0	21		0	0	0	11969	0	849574	1115171		
62689	1371	40213296	2013-04-23	2013-04-23 00:00:00	2013-04-23	2013-04-23 00:00:00	2013-04-23	581452		0	0	0		0	0	0	90905	0	52	40213296		
54507	4530	1127433	1991-11-14	1991-11-14 00:00:00	1991-11-21	1991-11-21 00:00:00	1991-11-21	38000177		0	0	7		0	0	0	301646	0	313782	1127433		
54880	4559	920300	2005-02-05	2005-02-05 00:00:00	2005-02-12	2005-02-12 00:00:00	2005-02-12	38000177		0	0	7		0	0	0	303739	0	311989	920300		
36035	2966	1127433	2002-06-12	2002-06-12 00:00:00	2002-07-17	2002-07-17 00:00:00	2002-07-17	38000177		0	0	35		0	0	0	198047	0	313782	1127433		
57651	4788	1127078	1978-07-27	1978-07-27 00:00:00	1978-08-10	1978-08-10 00:00:00	1978-08-10	38000177		0	0	14		0	0	0	318660	0	282464	1127078		
19900	1634	40171902	2014-08-29	2014-08-29 00:00:00	2014-08-29	2014-08-29 00:00:00	\N	38000177		0	0	0		0	0	0	109777	0	897718	40171902		
48899	4055	1127078	1980-01-08	1980-01-08 00:00:00	1980-01-29	1980-01-29 00:00:00	1980-01-29	38000177		0	0	21		0	0	0	269535	0	282464	1127078		
56432	1235	40213227	2017-06-05	2017-06-05 00:00:00	2017-06-05	2017-06-05 00:00:00	2017-06-05	581452		0	0	0		0	0	0	81313	0	113	40213227		
33175	2750	19075601	2007-09-26	2007-09-26 00:00:00	2007-09-26	2007-09-26 00:00:00	\N	38000177		0	0	0		0	0	0	181874	0	309362	19075601		
46740	3871	19074841	2003-09-24	2003-09-24 00:00:00	2003-10-08	2003-10-08 00:00:00	2003-10-08	38000177		0	0	14		0	0	0	257040	0	309043	19074841		
43206	3579	1310034	2006-05-20	2006-05-20 00:00:00	2006-05-20	2006-05-20 00:00:00	2006-05-20	38000177		0	0	0		0	0	0	237964	0	834357	1310034		
16433	1361	1115171	1999-10-31	1999-10-31 00:00:00	1999-12-30	1999-12-30 00:00:00	1999-12-30	38000177		0	0	60		0	0	0	90292	0	849574	1115171		
57347	4759	1118084	2018-05-25	2018-05-25 00:00:00	2018-05-25	2018-05-25 00:00:00	\N	38000177		0	0	0		0	0	0	317078	0	00025152531	44923712		
34553	2857	40162522	1980-10-12	1980-10-12 00:00:00	1980-10-12	1980-10-12 00:00:00	\N	38000177		0	0	0		0	0	0	189671	0	857005	40162522		
44728	3701	19059056	1962-05-13	1962-05-13 00:00:00	1962-06-03	1962-06-03 00:00:00	1962-06-03	38000177		0	0	21		0	0	0	246066	0	243670	19059056		
42350	923	40213306	1981-02-18	1981-02-18 00:00:00	1981-02-18	1981-02-18 00:00:00	1981-02-18	581452		0	0	0		0	0	0	61456	0	43	40213306		
7204	605	40229134	1961-03-22	1961-03-22 00:00:00	1961-04-05	1961-04-05 00:00:00	1961-04-05	38000177		0	0	14		0	0	0	40115	0	1043400	40229134		
9837	823	1127433	1964-08-08	1964-08-08 00:00:00	1964-08-22	1964-08-22 00:00:00	1964-08-22	38000177		0	0	14		0	0	0	54511	0	313782	1127433		
27241	2250	19006318	1960-10-12	1960-10-12 00:00:00	1960-10-26	1960-10-26 00:00:00	1960-10-26	38000177		0	0	14		0	0	0	149629	0	105078	19006318		
48202	3996	1127433	2016-10-05	2016-10-05 00:00:00	2016-10-12	2016-10-12 00:00:00	2016-10-12	38000177		0	0	7		0	0	0	265669	0	313782	1127433		
99052	2168	40213296	1998-09-24	1998-09-24 00:00:00	1998-09-24	1998-09-24 00:00:00	1998-09-24	581452		0	0	0		0	0	0	144406	0	52	40213296		
3080	249	1115171	2005-11-05	2005-11-05 00:00:00	2005-11-26	2005-11-26 00:00:00	2005-11-26	38000177		0	0	21		0	0	0	16781	0	849574	1115171		
10854	905	1713671	1998-12-30	1998-12-30 00:00:00	1999-01-13	1999-01-13 00:00:00	1999-01-13	38000177		0	0	14		0	0	0	60151	0	562251	1713671		
16910	1399	1127433	1994-12-28	1994-12-28 00:00:00	1995-01-19	1995-01-19 00:00:00	1995-01-19	38000177		0	0	22		0	0	0	93107	0	313782	1127433		
27450	2272	42902245	1999-10-27	1999-10-27 00:00:00	2000-10-21	2000-10-21 00:00:00	2000-10-21	38000177		0	0	360		0	0	0	151068	0	1359133	42902245		
76638	1674	40213251	1984-10-08	1984-10-08 00:00:00	1984-10-08	1984-10-08 00:00:00	1984-10-08	581452		0	0	0		0	0	0	112360	0	21	40213251		
168097	3695	40213160	1980-07-14	1980-07-14 00:00:00	1980-07-14	1980-07-14 00:00:00	1980-07-14	581452		0	0	0		0	0	0	245596	0	10	40213160		
111959	2460	40213314	1985-10-16	1985-10-16 00:00:00	1985-10-16	1985-10-16 00:00:00	1985-10-16	581452		0	0	0		0	0	0	163080	0	49	40213314		
1554	35	40213160	1960-08-30	1960-08-30 00:00:00	1960-08-30	1960-08-30 00:00:00	1960-08-30	581452		0	0	0		0	0	0	2412	0	10	40213160		
49482	4105	19133873	1950-05-24	1950-05-24 00:00:00	1950-06-06	1950-06-06 00:00:00	1950-06-06	38000177		0	0	13		0	0	0	272757	0	834061	19133873		
54099	4496	19073188	2006-10-11	2006-10-11 00:00:00	2006-11-01	2006-11-01 00:00:00	2006-11-01	38000177		0	0	21		0	0	0	299308	0	308192	19073188		
51344	4268	1127078	1961-06-12	1961-06-12 00:00:00	1961-07-12	1961-07-12 00:00:00	1961-07-12	38000177		0	0	30		0	0	0	283208	0	282464	1127078		
179634	3949	40213306	1991-04-01	1991-04-01 00:00:00	1991-04-01	1991-04-01 00:00:00	1991-04-01	581452		0	0	0		0	0	0	262487	0	43	40213306		
42738	3542	1713671	1994-12-12	1994-12-12 00:00:00	1994-12-26	1994-12-26 00:00:00	1994-12-26	38000177		0	0	14		0	0	0	235260	0	562251	1713671		
176762	3885	40213306	1985-11-15	1985-11-15 00:00:00	1985-11-15	1985-11-15 00:00:00	1985-11-15	581452		0	0	0		0	0	0	258242	0	43	40213306		
62951	5232	1713671	1973-10-14	1973-10-14 00:00:00	1973-10-28	1973-10-28 00:00:00	1973-10-28	38000177		0	0	14		0	0	0	348079	0	562251	1713671		
51049	1118	40213314	1977-07-17	1977-07-17 00:00:00	1977-07-17	1977-07-17 00:00:00	1977-07-17	581452		0	0	0		0	0	0	73698	0	49	40213314		
20829	1718	40229134	2011-10-14	2011-10-14 00:00:00	2011-10-28	2011-10-28 00:00:00	2011-10-28	38000177		0	0	14		0	0	0	114860	0	1043400	40229134		
43120	3572	40231925	1984-01-20	1984-01-20 00:00:00	1984-01-20	1984-01-20 00:00:00	\N	38000177		0	0	0		0	0	0	237444	0	1049221	40231925		
53631	4457	19133873	1994-06-10	1994-06-10 00:00:00	1994-06-20	1994-06-20 00:00:00	1994-06-20	38000177		0	0	10		0	0	0	296631	0	834061	19133873		
173596	3817	40213160	1964-11-27	1964-11-27 00:00:00	1964-11-27	1964-11-27 00:00:00	1964-11-27	581452		0	0	0		0	0	0	253525	0	10	40213160		
2139	170	19128065	1985-01-31	1985-01-31 00:00:00	1986-01-26	1986-01-26 00:00:00	1986-01-26	38000177		0	0	360		0	0	0	11525	0	749882	19128065		
160767	3537	40213160	1961-10-01	1961-10-01 00:00:00	1961-10-01	1961-10-01 00:00:00	1961-10-01	581452		0	0	0		0	0	0	234972	0	10	40213160		
46033	3813	19019979	1982-09-11	1982-09-11 00:00:00	1982-12-10	1982-12-10 00:00:00	1982-12-10	38000177		0	0	90		0	0	0	253260	0	198405	19019979		
46079	3817	1127433	1968-08-18	1968-08-18 00:00:00	1968-08-25	1968-08-25 00:00:00	1968-08-25	38000177		0	0	7		0	0	0	253487	0	313782	1127433		
44968	3720	19078461	2013-01-01	2013-01-01 00:00:00	2013-01-15	2013-01-15 00:00:00	2013-01-15	38000177		0	0	14		0	0	0	247321	0	310965	19078461		
55485	4608	1713671	2015-11-19	2015-11-19 00:00:00	2015-12-03	2015-12-03 00:00:00	2015-12-03	38000177		0	0	14		0	0	0	307035	0	562251	1713671		
157946	3477	40213296	2003-07-01	2003-07-01 00:00:00	2003-07-01	2003-07-01 00:00:00	2003-07-01	581452		0	0	0		0	0	0	230643	0	52	40213296		
1788	144	1127433	1980-10-21	1980-10-21 00:00:00	1980-11-04	1980-11-04 00:00:00	1980-11-04	38000177		0	0	14		0	0	0	9613	0	313782	1127433		
207846	4560	40213160	1972-10-11	1972-10-11 00:00:00	1972-10-11	1972-10-11 00:00:00	1972-10-11	581452		0	0	0		0	0	0	303827	0	10	40213160		
60636	5043	1127433	2004-08-04	2004-08-04 00:00:00	2004-08-18	2004-08-18 00:00:00	2004-08-18	38000177		0	0	14		0	0	0	335134	0	313782	1127433		
232929	5118	40213160	1972-06-28	1972-06-28 00:00:00	1972-06-28	1972-06-28 00:00:00	1972-06-28	581452		0	0	0		0	0	0	340266	0	10	40213160		
45480	3761	1127078	1959-07-22	1959-07-22 00:00:00	1959-08-05	1959-08-05 00:00:00	1959-08-05	38000177		0	0	14		0	0	0	250077	0	282464	1127078		
47380	3927	19059056	1948-10-19	1948-10-19 00:00:00	1948-11-09	1948-11-09 00:00:00	1948-11-09	38000177		0	0	21		0	0	0	261012	0	243670	19059056		
37432	3093	920300	1998-07-29	1998-07-29 00:00:00	1998-08-05	1998-08-05 00:00:00	1998-08-05	38000177		0	0	7		0	0	0	205915	0	311989	920300		
56575	4694	1124300	2018-01-17	2018-01-17 00:00:00	2018-01-17	2018-01-17 00:00:00	\N	38000177		0	0	0		0	0	0	312774	0	00781178901	45011828		
54137	4498	40229134	1996-03-01	1996-03-01 00:00:00	1996-03-15	1996-03-15 00:00:00	1996-03-15	38000177		0	0	14		0	0	0	299484	0	1043400	40229134		
4197	349	1713671	1990-10-06	1990-10-06 00:00:00	1990-10-20	1990-10-20 00:00:00	1990-10-20	38000177		0	0	14		0	0	0	23199	0	562251	1713671		
1168	94	1127433	1998-07-23	1998-07-23 00:00:00	1998-08-27	1998-08-27 00:00:00	1998-08-27	38000177		0	0	35		0	0	0	6301	0	313782	1127433		
5418	454	1713671	1951-06-30	1951-06-30 00:00:00	1951-07-07	1951-07-07 00:00:00	1951-07-07	38000177		0	0	7		0	0	0	30344	0	562251	1713671		
59810	4972	1713671	1970-07-10	1970-07-10 00:00:00	1970-07-31	1970-07-31 00:00:00	1970-07-31	38000177		0	0	21		0	0	0	330688	0	562251	1713671		
47586	1039	40213296	2002-03-30	2002-03-30 00:00:00	2002-03-30	2002-03-30 00:00:00	2002-03-30	581452		0	0	0		0	0	0	68359	0	52	40213296		
80279	1756	40213227	1994-10-09	1994-10-09 00:00:00	1994-10-09	1994-10-09 00:00:00	1994-10-09	581452		0	0	0		0	0	0	117413	0	113	40213227		
2206	177	19128065	1981-04-15	1981-04-15 00:00:00	1982-04-10	1982-04-10 00:00:00	1982-04-10	38000177		0	0	360		0	0	0	11961	0	749882	19128065		
62692	1371	40213160	1971-09-21	1971-09-21 00:00:00	1971-09-21	1971-09-21 00:00:00	1971-09-21	581452		0	0	0		0	0	0	90928	0	10	40213160		
54508	4530	1127433	1980-07-19	1980-07-19 00:00:00	1980-10-17	1980-10-17 00:00:00	1980-10-17	38000177		0	0	90		0	0	0	301619	0	313782	1127433		
54881	4559	40236824	2005-02-05	2005-02-05 00:00:00	2005-02-12	2005-02-12 00:00:00	2005-02-12	38000177		0	0	7		0	0	0	303739	0	1094107	40236824		
36036	2966	19129655	1963-10-02	1963-10-02 00:00:00	1963-10-16	1963-10-16 00:00:00	1963-10-16	38000177		0	0	14		0	0	0	198044	0	789980	19129655		
57652	4788	19006318	1978-07-27	1978-07-27 00:00:00	1978-08-10	1978-08-10 00:00:00	1978-08-10	38000177		0	0	14		0	0	0	318660	0	105078	19006318		
19901	1634	40163554	2014-08-29	2014-08-29 00:00:00	2014-08-29	2014-08-29 00:00:00	\N	38000177		0	0	0		0	0	0	109777	0	855332	40163554		
48900	4055	1118084	2007-02-20	2007-02-20 00:00:00	2007-02-20	2007-02-20 00:00:00	\N	38000177		0	0	0		0	0	0	269518	0	00025152531	44923712		
56433	1235	40213296	2017-06-05	2017-06-05 00:00:00	2017-06-05	2017-06-05 00:00:00	2017-06-05	581452		0	0	0		0	0	0	81313	0	52	40213296		
33176	2750	19126352	2007-09-26	2007-09-26 00:00:00	2007-09-26	2007-09-26 00:00:00	\N	38000177		0	0	0		0	0	0	181874	0	705129	19126352		
46753	3874	42902245	1998-12-04	1998-12-04 00:00:00	1999-11-29	1999-11-29 00:00:00	1999-11-29	38000177		0	0	360		0	0	0	257295	0	1359133	42902245		
43207	3579	19128065	1981-10-12	1981-10-12 00:00:00	1982-10-07	1982-10-07 00:00:00	1982-10-07	38000177		0	0	360		0	0	0	237919	0	749882	19128065		
16434	1361	1127433	1980-09-30	1980-09-30 00:00:00	1980-10-14	1980-10-14 00:00:00	1980-10-14	38000177		0	0	14		0	0	0	90371	0	313782	1127433		
57348	4759	19133873	1992-05-21	1992-05-21 00:00:00	1992-05-29	1992-05-29 00:00:00	1992-05-29	38000177		0	0	8		0	0	0	317060	0	834061	19133873		
34554	2857	1127433	1980-10-12	1980-10-12 00:00:00	1980-12-10	1980-12-10 00:00:00	1980-12-10	38000177		0	0	59		0	0	0	189671	0	313782	1127433		
44729	3701	1124300	1994-05-10	1994-05-10 00:00:00	1994-05-10	1994-05-10 00:00:00	\N	38000177		0	0	0		0	0	0	246072	0	00781178901	45011828		
42355	923	40213160	1959-02-18	1959-02-18 00:00:00	1959-02-18	1959-02-18 00:00:00	1959-02-18	581452		0	0	0		0	0	0	61480	0	10	40213160		
7205	605	19078461	2015-04-19	2015-04-19 00:00:00	2015-05-10	2015-05-10 00:00:00	2015-05-10	38000177		0	0	21		0	0	0	40165	0	310965	19078461		
9838	825	40229134	2010-04-13	2010-04-13 00:00:00	2010-04-20	2010-04-20 00:00:00	2010-04-20	38000177		0	0	7		0	0	0	54643	0	1043400	40229134		
27242	2250	1118084	1995-03-18	1995-03-18 00:00:00	1995-03-18	1995-03-18 00:00:00	\N	38000177		0	0	0		0	0	0	149683	0	00025152531	44923712		
48203	3996	19078461	2010-08-23	2010-08-23 00:00:00	2010-09-22	2010-09-22 00:00:00	2010-09-22	38000177		0	0	30		0	0	0	265697	0	310965	19078461		
99054	2168	40213227	1998-09-24	1998-09-24 00:00:00	1998-09-24	1998-09-24 00:00:00	1998-09-24	581452		0	0	0		0	0	0	144406	0	113	40213227		
3081	249	40236824	2017-09-10	2017-09-10 00:00:00	2017-09-17	2017-09-17 00:00:00	2017-09-17	38000177		0	0	7		0	0	0	16758	0	1094107	40236824		
10855	905	19128065	1988-08-17	1988-08-17 00:00:00	1989-08-12	1989-08-12 00:00:00	1989-08-12	38000177		0	0	360		0	0	0	60206	0	749882	19128065		
16911	1401	46233988	1978-01-02	1978-01-02 00:00:00	1978-01-16	1978-01-16 00:00:00	1978-01-16	38000177		0	0	14		0	0	0	93189	0	1652673	46233988		
42748	932	40213160	1969-06-02	1969-06-02 00:00:00	1969-06-02	1969-06-02 00:00:00	1969-06-02	581452		0	0	0		0	0	0	62020	0	10	40213160		
76639	1674	40213160	1977-01-17	1977-01-17 00:00:00	1977-01-17	1977-01-17 00:00:00	1977-01-17	581452		0	0	0		0	0	0	112371	0	10	40213160		
233750	5137	40213227	1999-05-19	1999-05-19 00:00:00	1999-05-19	1999-05-19 00:00:00	1999-05-19	581452		0	0	0		0	0	0	341444	0	113	40213227		
111960	2460	40213251	1985-10-16	1985-10-16 00:00:00	1985-10-16	1985-10-16 00:00:00	1985-10-16	581452		0	0	0		0	0	0	163080	0	21	40213251		
1563	35	40213227	1992-04-21	1992-04-21 00:00:00	1992-04-21	1992-04-21 00:00:00	1992-04-21	581452		0	0	0		0	0	0	2478	0	113	40213227		
49483	4105	19078461	2000-11-14	2000-11-14 00:00:00	2000-12-05	2000-12-05 00:00:00	2000-12-05	38000177		0	0	21		0	0	0	272707	0	310965	19078461		
54100	4496	40231925	2006-10-11	2006-10-11 00:00:00	2006-10-11	2006-10-11 00:00:00	\N	38000177		0	0	0		0	0	0	299308	0	1049221	40231925		
30606	2540	19077572	2018-04-10	2018-04-10 00:00:00	2018-04-10	2018-04-10 00:00:00	\N	38000177		0	0	0		0	0	0	167902	0	310436	19077572		
179639	3949	40213227	2011-02-14	2011-02-14 00:00:00	2011-02-14	2011-02-14 00:00:00	2011-02-14	581452		0	0	0		0	0	0	262491	0	113	40213227		
42739	3542	19059056	1938-03-29	1938-03-29 00:00:00	1938-04-12	1938-04-12 00:00:00	1938-04-12	38000177		0	0	14		0	0	0	235237	0	243670	19059056		
96005	2105	40213296	2014-08-24	2014-08-24 00:00:00	2014-08-24	2014-08-24 00:00:00	2014-08-24	581452		0	0	0		0	0	0	140241	0	52	40213296		
62952	5232	1127078	1969-01-29	1969-01-29 00:00:00	1969-02-12	1969-02-12 00:00:00	1969-02-12	38000177		0	0	14		0	0	0	348068	0	282464	1127078		
51054	1118	40213160	1973-11-18	1973-11-18 00:00:00	1973-11-18	1973-11-18 00:00:00	1973-11-18	581452		0	0	0		0	0	0	73755	0	10	40213160		
20830	1718	1124300	2010-07-28	2010-07-28 00:00:00	2010-07-28	2010-07-28 00:00:00	\N	38000177		0	0	0		0	0	0	114821	0	00781178901	45011828		
43121	3573	19059056	1970-04-05	1970-04-05 00:00:00	1970-04-19	1970-04-19 00:00:00	1970-04-19	38000177		0	0	14		0	0	0	237627	0	243670	19059056		
53632	4457	19133905	2003-11-02	2003-11-02 00:00:00	2003-11-09	2003-11-09 00:00:00	2003-11-09	38000177		0	0	7		0	0	0	296621	0	834102	19133905		
173600	3817	40213160	1965-01-01	1965-01-01 00:00:00	1965-01-01	1965-01-01 00:00:00	1965-01-01	581452		0	0	0		0	0	0	\N	0	10	40213160		
2140	170	19128065	1988-01-16	1988-01-16 00:00:00	1989-01-10	1989-01-10 00:00:00	1989-01-10	38000177		0	0	360		0	0	0	11570	0	749882	19128065		
63831	5302	1713671	2004-10-01	2004-10-01 00:00:00	2004-10-08	2004-10-08 00:00:00	2004-10-08	38000177		0	0	7		0	0	0	352790	0	562251	1713671		
46034	3813	19128065	1986-09-30	1986-09-30 00:00:00	1987-09-25	1987-09-25 00:00:00	1987-09-25	38000177		0	0	360		0	0	0	253298	0	749882	19128065		
46080	3817	1127433	1991-03-30	1991-03-30 00:00:00	1991-04-06	1991-04-06 00:00:00	1991-04-06	38000177		0	0	7		0	0	0	253491	0	313782	1127433		
44969	3720	1127078	1957-02-19	1957-02-19 00:00:00	1957-03-12	1957-03-12 00:00:00	1957-03-12	38000177		0	0	21		0	0	0	247307	0	282464	1127078		
55486	4608	1127433	1977-07-04	1977-07-04 00:00:00	1977-07-18	1977-07-18 00:00:00	1977-07-18	38000177		0	0	14		0	0	0	306970	0	313782	1127433		
157948	3477	40213227	2003-07-01	2003-07-01 00:00:00	2003-07-01	2003-07-01 00:00:00	2003-07-01	581452		0	0	0		0	0	0	230643	0	113	40213227		
1789	144	1127433	2010-07-21	2010-07-21 00:00:00	2010-07-28	2010-07-28 00:00:00	2010-07-28	38000177		0	0	7		0	0	0	9662	0	313782	1127433		
207855	4560	40213160	1968-07-10	1968-07-10 00:00:00	1968-07-10	1968-07-10 00:00:00	1968-07-10	581452		0	0	0		0	0	0	303850	0	10	40213160		
60637	5044	1118084	2015-07-23	2015-07-23 00:00:00	2015-07-23	2015-07-23 00:00:00	\N	38000177		0	0	0		0	0	0	335183	0	00025152531	44923712		
232935	5118	40213160	1968-03-27	1968-03-27 00:00:00	1968-03-27	1968-03-27 00:00:00	1968-03-27	581452		0	0	0		0	0	0	340179	0	10	40213160		
45481	3761	1127433	1981-11-29	1981-11-29 00:00:00	1981-12-06	1981-12-06 00:00:00	1981-12-06	38000177		0	0	7		0	0	0	250054	0	313782	1127433		
47381	3927	1118084	1981-02-08	1981-02-08 00:00:00	1981-02-08	1981-02-08 00:00:00	\N	38000177		0	0	0		0	0	0	261094	0	00025152531	44923712		
37433	3093	40236824	1998-07-29	1998-07-29 00:00:00	1998-08-05	1998-08-05 00:00:00	1998-08-05	38000177		0	0	7		0	0	0	205915	0	1094107	40236824		
56576	4694	1127433	1982-02-07	1982-02-07 00:00:00	1982-02-21	1982-02-21 00:00:00	1982-02-21	38000177		0	0	14		0	0	0	312747	0	313782	1127433		
54138	4498	19133873	1978-07-19	1978-07-19 00:00:00	1978-07-26	1978-07-26 00:00:00	1978-07-26	38000177		0	0	7		0	0	0	299468	0	834061	19133873		
4198	349	19128065	1982-07-01	1982-07-01 00:00:00	1983-06-26	1983-06-26 00:00:00	1983-06-26	38000177		0	0	360		0	0	0	23173	0	749882	19128065		
6471	545	19128065	1988-09-19	1988-09-19 00:00:00	1989-09-14	1989-09-14 00:00:00	1989-09-14	38000177		0	0	360		0	0	0	36068	0	749882	19128065		
5419	454	40229134	1959-06-04	1959-06-04 00:00:00	1959-06-11	1959-06-11 00:00:00	1959-06-11	38000177		0	0	7		0	0	0	30320	0	1043400	40229134		
59811	4972	1127433	2016-09-19	2016-09-19 00:00:00	2016-12-18	2016-12-18 00:00:00	2016-12-18	38000177		0	0	90		0	0	0	330665	0	313782	1127433		
47587	1039	40213160	1960-08-27	1960-08-27 00:00:00	1960-08-27	1960-08-27 00:00:00	1960-08-27	581452		0	0	0		0	0	0	68402	0	10	40213160		
80280	1756	40213306	1994-10-09	1994-10-09 00:00:00	1994-10-09	1994-10-09 00:00:00	1994-10-09	581452		0	0	0		0	0	0	117413	0	43	40213306		
2207	177	1127078	1969-12-04	1969-12-04 00:00:00	1969-12-18	1969-12-18 00:00:00	1969-12-18	38000177		0	0	14		0	0	0	11956	0	282464	1127078		
62695	1371	40213160	1971-12-21	1971-12-21 00:00:00	1971-12-21	1971-12-21 00:00:00	1971-12-21	581452		0	0	0		0	0	0	90878	0	10	40213160		
54509	4530	40231925	1980-07-19	1980-07-19 00:00:00	1980-07-19	1980-07-19 00:00:00	\N	38000177		0	0	0		0	0	0	301619	0	1049221	40231925		
54882	4559	19059056	1945-12-14	1945-12-14 00:00:00	1946-02-12	1946-02-12 00:00:00	1946-02-12	38000177		0	0	60		0	0	0	303766	0	243670	19059056		
3390	74	40213306	1995-09-20	1995-09-20 00:00:00	1995-09-20	1995-09-20 00:00:00	1995-09-20	581452		0	0	0		0	0	0	5029	0	43	40213306		
2497	199	19006318	1945-12-21	1945-12-21 00:00:00	1946-01-04	1946-01-04 00:00:00	1946-01-04	38000177		0	0	14		0	0	0	13696	0	105078	19006318		
19902	1634	19059056	1966-12-11	1966-12-11 00:00:00	1967-02-09	1967-02-09 00:00:00	1967-02-09	38000177		0	0	60		0	0	0	109687	0	243670	19059056		
2589	207	1118084	1975-07-29	1975-07-29 00:00:00	1975-07-29	1975-07-29 00:00:00	\N	38000177		0	0	0		0	0	0	14137	0	00025152531	44923712		
56434	1235	40213160	1975-09-01	1975-09-01 00:00:00	1975-09-01	1975-09-01 00:00:00	1975-09-01	581452		0	0	0		0	0	0	81351	0	10	40213160		
33177	2750	1332419	2007-09-26	2007-09-26 00:00:00	2007-09-26	2007-09-26 00:00:00	\N	38000177		0	0	0		0	0	0	181874	0	197361	1332419		
46754	3874	1118084	2014-10-06	2014-10-06 00:00:00	2014-10-06	2014-10-06 00:00:00	\N	38000177		0	0	0		0	0	0	257283	0	00025152531	44923712		
43208	3579	19059056	1969-12-25	1969-12-25 00:00:00	1970-01-08	1970-01-08 00:00:00	1970-01-08	38000177		0	0	14		0	0	0	237961	0	243670	19059056		
26893	2217	1115171	1995-02-05	1995-02-05 00:00:00	1995-02-19	1995-02-19 00:00:00	1995-02-19	38000177		0	0	14		0	0	0	147682	0	849574	1115171		
57349	4759	1127433	1987-03-05	1987-03-05 00:00:00	1987-03-12	1987-03-12 00:00:00	1987-03-12	38000177		0	0	7		0	0	0	317058	0	313782	1127433		
34555	2857	1127433	1969-08-02	1969-08-02 00:00:00	1969-08-09	1969-08-09 00:00:00	1969-08-09	38000177		0	0	7		0	0	0	189732	0	313782	1127433		
44730	3701	19059056	1955-12-16	1955-12-16 00:00:00	1956-02-14	1956-02-14 00:00:00	1956-02-14	38000177		0	0	60		0	0	0	246065	0	243670	19059056		
42357	923	40213227	2000-11-22	2000-11-22 00:00:00	2000-11-22	2000-11-22 00:00:00	2000-11-22	581452		0	0	0		0	0	0	61428	0	113	40213227		
7206	605	1118084	1995-02-21	1995-02-21 00:00:00	1995-02-21	1995-02-21 00:00:00	\N	38000177		0	0	0		0	0	0	40122	0	00025152531	44923712		
9839	825	19129655	1971-01-10	1971-01-10 00:00:00	1971-01-24	1971-01-24 00:00:00	1971-01-24	38000177		0	0	14		0	0	0	54645	0	789980	19129655		
27243	2250	1127433	1974-08-13	1974-08-13 00:00:00	1974-08-20	1974-08-20 00:00:00	1974-08-20	38000177		0	0	7		0	0	0	149681	0	313782	1127433		
48204	3996	19133873	1979-07-03	1979-07-03 00:00:00	1979-07-11	1979-07-11 00:00:00	1979-07-11	38000177		0	0	8		0	0	0	265665	0	834061	19133873		
99055	2168	40213160	1956-12-20	1956-12-20 00:00:00	1956-12-20	1956-12-20 00:00:00	1956-12-20	581452		0	0	0		0	0	0	144566	0	10	40213160		
3082	249	920300	2017-09-10	2017-09-10 00:00:00	2017-09-17	2017-09-17 00:00:00	2017-09-17	38000177		0	0	7		0	0	0	16758	0	311989	920300		
10856	905	1115171	2019-03-29	2019-03-29 00:00:00	2019-04-26	2019-04-26 00:00:00	2019-04-26	38000177		0	0	28		0	0	0	60197	0	849574	1115171		
16912	1401	19059056	1978-01-02	1978-01-02 00:00:00	1978-01-16	1978-01-16 00:00:00	1978-01-16	38000177		0	0	14		0	0	0	93189	0	243670	19059056		
42751	932	40213227	2011-03-07	2011-03-07 00:00:00	2011-03-07	2011-03-07 00:00:00	2011-03-07	581452		0	0	0		0	0	0	62040	0	113	40213227		
76640	1674	40213314	1977-01-17	1977-01-17 00:00:00	1977-01-17	1977-01-17 00:00:00	1977-01-17	581452		0	0	0		0	0	0	112371	0	49	40213314		
233756	5137	40213306	1989-08-23	1989-08-23 00:00:00	1989-08-23	1989-08-23 00:00:00	1989-08-23	581452		0	0	0		0	0	0	341390	0	43	40213306		
111970	2460	40213251	1989-07-19	1989-07-19 00:00:00	1989-07-19	1989-07-19 00:00:00	1989-07-19	581452		0	0	0		0	0	0	163083	0	21	40213251		
1565	35	40213296	2002-05-07	2002-05-07 00:00:00	2002-05-07	2002-05-07 00:00:00	2002-05-07	581452		0	0	0		0	0	0	2442	0	52	40213296		
49484	4105	19075601	2019-02-16	2019-02-16 00:00:00	2019-02-16	2019-02-16 00:00:00	2019-02-16	38000177		0	0	0		0	0	0	272705	0	309362	19075601		
54101	4496	1115171	2006-10-11	2006-10-11 00:00:00	2006-11-01	2006-11-01 00:00:00	2006-11-01	38000177		0	0	21		0	0	0	299308	0	849574	1115171		
30607	2540	1115171	1997-11-20	1997-11-20 00:00:00	1997-12-11	1997-12-11 00:00:00	1997-12-11	38000177		0	0	21		0	0	0	167990	0	849574	1115171		
179640	3949	40213296	2011-02-14	2011-02-14 00:00:00	2011-02-14	2011-02-14 00:00:00	2011-02-14	581452		0	0	0		0	0	0	262491	0	52	40213296		
42740	3542	1713671	1988-05-30	1988-05-30 00:00:00	1988-06-06	1988-06-06 00:00:00	1988-06-06	38000177		0	0	7		0	0	0	235235	0	562251	1713671		
96008	2105	40213160	1975-04-27	1975-04-27 00:00:00	1975-04-27	1975-04-27 00:00:00	1975-04-27	581452		0	0	0		0	0	0	140240	0	10	40213160		
62953	5232	46233988	1969-01-29	1969-01-29 00:00:00	1969-02-12	1969-02-12 00:00:00	1969-02-12	38000177		0	0	14		0	0	0	348068	0	1652673	46233988		
51058	1118	40213160	1978-07-23	1978-07-23 00:00:00	1978-07-23	1978-07-23 00:00:00	1978-07-23	581452		0	0	0		0	0	0	73714	0	10	40213160		
20831	1718	1713671	1973-09-19	1973-09-19 00:00:00	1973-10-03	1973-10-03 00:00:00	1973-10-03	38000177		0	0	14		0	0	0	114855	0	562251	1713671		
43122	3573	19133905	1941-07-02	1941-07-02 00:00:00	1941-07-15	1941-07-15 00:00:00	1941-07-15	38000177		0	0	13		0	0	0	237517	0	834102	19133905		
53633	4457	19073183	1987-07-18	1987-07-18 00:00:00	1987-08-01	1987-08-01 00:00:00	1987-08-01	38000177		0	0	14		0	0	0	296623	0	308182	19073183		
173601	3817	40213306	1986-11-28	1986-11-28 00:00:00	1986-11-28	1986-11-28 00:00:00	1986-11-28	581452		0	0	0		0	0	0	253478	0	43	40213306		
2141	170	19133905	2003-12-21	2003-12-21 00:00:00	2004-01-02	2004-01-02 00:00:00	2004-01-02	38000177		0	0	12		0	0	0	11535	0	834102	19133905		
63832	5302	19059056	1973-05-25	1973-05-25 00:00:00	1973-06-08	1973-06-08 00:00:00	1973-06-08	38000177		0	0	14		0	0	0	352793	0	243670	19059056		
46035	3814	19128065	1992-11-06	1992-11-06 00:00:00	1993-11-01	1993-11-01 00:00:00	1993-11-01	38000177		0	0	360		0	0	0	253365	0	749882	19128065		
46090	3820	1124300	2005-07-23	2005-07-23 00:00:00	2005-07-23	2005-07-23 00:00:00	\N	38000177		0	0	0		0	0	0	253678	0	00781178901	45011828		
44970	3720	1127433	1979-01-16	1979-01-16 00:00:00	1979-02-15	1979-02-15 00:00:00	1979-02-15	38000177		0	0	30		0	0	0	247309	0	313782	1127433		
55487	4608	1127433	1992-06-20	1992-06-20 00:00:00	1992-08-19	1992-08-19 00:00:00	1992-08-19	38000177		0	0	60		0	0	0	307067	0	313782	1127433		
157955	3477	40213160	1961-12-05	1961-12-05 00:00:00	1961-12-05	1961-12-05 00:00:00	1961-12-05	581452		0	0	0		0	0	0	230623	0	10	40213160		
1790	144	19128022	1999-10-20	1999-10-20 00:00:00	2000-10-14	2000-10-14 00:00:00	2000-10-14	38000177		0	0	360		0	0	0	9623	0	749785	19128022		
207858	4560	40213160	1968-04-10	1968-04-10 00:00:00	1968-04-10	1968-04-10 00:00:00	1968-04-10	581452		0	0	0		0	0	0	303823	0	10	40213160		
60638	5044	1127433	1986-08-06	1986-08-06 00:00:00	1986-08-20	1986-08-20 00:00:00	1986-08-20	38000177		0	0	14		0	0	0	335216	0	313782	1127433		
232938	5118	40213227	1999-01-27	1999-01-27 00:00:00	1999-01-27	1999-01-27 00:00:00	1999-01-27	581452		0	0	0		0	0	0	340258	0	113	40213227		
45482	3761	40229134	2002-03-18	2002-03-18 00:00:00	2002-04-01	2002-04-01 00:00:00	2002-04-01	38000177		0	0	14		0	0	0	250055	0	1043400	40229134		
47382	3927	19059056	1949-04-17	1949-04-17 00:00:00	1949-05-01	1949-05-01 00:00:00	1949-05-01	38000177		0	0	14		0	0	0	261056	0	243670	19059056		
37434	3093	1127433	2011-02-28	2011-02-28 00:00:00	2011-03-14	2011-03-14 00:00:00	2011-03-14	38000177		0	0	14		0	0	0	205908	0	313782	1127433		
56577	4694	1713671	1993-01-16	1993-01-16 00:00:00	1993-01-30	1993-01-30 00:00:00	1993-01-30	38000177		0	0	14		0	0	0	312749	0	562251	1713671		
54139	4498	43012754	1991-05-21	1991-05-21 00:00:00	1992-05-15	1992-05-15 00:00:00	1992-05-15	38000177		0	0	360		0	0	0	299455	0	1366343	43012754		
4199	349	1115171	2001-09-09	2001-09-09 00:00:00	2001-09-23	2001-09-23 00:00:00	2001-09-23	38000177		0	0	14		0	0	0	23242	0	849574	1115171		
6472	545	19133873	1983-06-04	1983-06-04 00:00:00	1983-06-12	1983-06-12 00:00:00	1983-06-12	38000177		0	0	8		0	0	0	36051	0	834061	19133873		
5420	454	1713671	1969-11-29	1969-11-29 00:00:00	1969-12-06	1969-12-06 00:00:00	1969-12-06	38000177		0	0	7		0	0	0	30266	0	562251	1713671		
59812	4972	1124300	1988-09-20	1988-09-20 00:00:00	1988-09-20	1988-09-20 00:00:00	\N	38000177		0	0	0		0	0	0	330736	0	00781178901	45011828		
47590	1039	40213160	1965-02-27	1965-02-27 00:00:00	1965-02-27	1965-02-27 00:00:00	1965-02-27	581452		0	0	0		0	0	0	68391	0	10	40213160		
80286	1756	40213296	2012-08-12	2012-08-12 00:00:00	2012-08-12	2012-08-12 00:00:00	2012-08-12	581452		0	0	0		0	0	0	117422	0	52	40213296		
2208	177	19129655	1969-12-04	1969-12-04 00:00:00	1969-12-18	1969-12-18 00:00:00	1969-12-18	38000177		0	0	14		0	0	0	11956	0	789980	19129655		
62700	1371	40213160	1971-07-20	1971-07-20 00:00:00	1971-07-20	1971-07-20 00:00:00	1971-07-20	581452		0	0	0		0	0	0	90916	0	10	40213160		
54510	4530	19128065	1988-04-13	1988-04-13 00:00:00	1989-04-08	1989-04-08 00:00:00	1989-04-08	38000177		0	0	360		0	0	0	301638	0	749882	19128065		
54883	4559	40229134	2015-05-25	2015-05-25 00:00:00	2015-06-01	2015-06-01 00:00:00	2015-06-01	38000177		0	0	7		0	0	0	303741	0	1043400	40229134		
3393	74	40213160	1972-09-13	1972-09-13 00:00:00	1972-09-13	1972-09-13 00:00:00	1972-09-13	581452		0	0	0		0	0	0	4973	0	10	40213160		
2498	199	1115171	2007-07-06	2007-07-06 00:00:00	2007-08-05	2007-08-05 00:00:00	2007-08-05	38000177		0	0	30		0	0	0	13646	0	849574	1115171		
19903	1634	1127433	1992-01-13	1992-01-13 00:00:00	1992-01-20	1992-01-20 00:00:00	1992-01-20	38000177		0	0	7		0	0	0	109741	0	313782	1127433		
2604	209	19075001	2016-05-03	2016-05-03 00:00:00	2016-05-17	2016-05-17 00:00:00	2016-05-17	38000177		0	0	14		0	0	0	14232	0	309097	19075001		
56435	1235	40213314	1977-05-02	1977-05-02 00:00:00	1977-05-02	1977-05-02 00:00:00	1977-05-02	581452		0	0	0		0	0	0	81329	0	49	40213314		
33178	2750	1539411	2007-09-26	2007-09-26 00:00:00	2007-09-26	2007-09-26 00:00:00	\N	38000177		0	0	0		0	0	0	181874	0	312961	1539411		
46755	3874	40229134	2012-06-15	2012-06-15 00:00:00	2012-06-29	2012-06-29 00:00:00	2012-06-29	38000177		0	0	14		0	0	0	257271	0	1043400	40229134		
43209	3579	40229134	1990-02-19	1990-02-19 00:00:00	1990-03-05	1990-03-05 00:00:00	1990-03-05	38000177		0	0	14		0	0	0	237923	0	1043400	40229134		
26894	2217	40162522	1995-12-02	1995-12-02 00:00:00	1995-12-02	1995-12-02 00:00:00	\N	38000177		0	0	0		0	0	0	147668	0	857005	40162522		
57350	4759	1127078	1980-12-25	1980-12-25 00:00:00	1981-01-29	1981-01-29 00:00:00	1981-01-29	38000177		0	0	35		0	0	0	317117	0	282464	1127078		
34556	2857	19133873	1979-01-15	1979-01-15 00:00:00	1979-01-26	1979-01-26 00:00:00	1979-01-26	38000177		0	0	11		0	0	0	189722	0	834061	19133873		
44731	3701	1127433	1968-05-06	1968-05-06 00:00:00	1968-05-20	1968-05-20 00:00:00	1968-05-20	38000177		0	0	14		0	0	0	246030	0	313782	1127433		
42358	923	40213296	2000-11-22	2000-11-22 00:00:00	2000-11-22	2000-11-22 00:00:00	2000-11-22	581452		0	0	0		0	0	0	61428	0	52	40213296		
7207	605	1127433	1970-01-31	1970-01-31 00:00:00	1970-02-14	1970-02-14 00:00:00	1970-02-14	38000177		0	0	14		0	0	0	40180	0	313782	1127433		
9840	825	19059056	1971-01-10	1971-01-10 00:00:00	1971-01-24	1971-01-24 00:00:00	1971-01-24	38000177		0	0	14		0	0	0	54645	0	243670	19059056		
27244	2250	1127433	1958-07-27	1958-07-27 00:00:00	1958-08-10	1958-08-10 00:00:00	1958-08-10	38000177		0	0	14		0	0	0	149626	0	313782	1127433		
48205	3996	1127433	1989-05-08	1989-05-08 00:00:00	1989-06-14	1989-06-14 00:00:00	1989-06-14	38000177		0	0	37		0	0	0	265696	0	313782	1127433		
179518	3946	40213160	1960-08-30	1960-08-30 00:00:00	1960-08-30	1960-08-30 00:00:00	1960-08-30	581452		0	0	0		0	0	0	262360	0	10	40213160		
3083	250	19059056	1975-01-09	1975-01-09 00:00:00	1975-01-30	1975-01-30 00:00:00	1975-01-30	38000177		0	0	21		0	0	0	16792	0	243670	19059056		
10857	905	1127078	1974-03-24	1974-03-24 00:00:00	1974-06-22	1974-06-22 00:00:00	1974-06-22	38000177		0	0	90		0	0	0	60190	0	282464	1127078		
16913	1401	1124300	2007-08-03	2007-08-03 00:00:00	2007-08-03	2007-08-03 00:00:00	\N	38000177		0	0	0		0	0	0	93165	0	00781178901	45011828		
42752	932	40213296	2011-03-07	2011-03-07 00:00:00	2011-03-07	2011-03-07 00:00:00	2011-03-07	581452		0	0	0		0	0	0	62040	0	52	40213296		
76642	1674	40213227	2019-06-10	2019-06-10 00:00:00	2019-06-10	2019-06-10 00:00:00	2019-06-10	581452		0	0	0		0	0	0	112402	0	113	40213227		
233761	5137	40213260	2018-03-28	2018-03-28 00:00:00	2018-03-28	2018-03-28 00:00:00	2018-03-28	581452		0	0	0		0	0	0	341394	0	121	40213260		
111973	2460	40213160	1989-07-19	1989-07-19 00:00:00	1989-07-19	1989-07-19 00:00:00	1989-07-19	581452		0	0	0		0	0	0	163083	0	10	40213160		
1567	35	40213160	1965-03-02	1965-03-02 00:00:00	1965-03-02	1965-03-02 00:00:00	1965-03-02	581452		0	0	0		0	0	0	2414	0	10	40213160		
49485	4105	40220960	2019-02-16	2019-02-16 00:00:00	2019-02-16	2019-02-16 00:00:00	2019-02-16	38000177		0	0	0		0	0	0	272705	0	1804799	40220960		
54102	4496	1127433	1972-03-02	1972-03-02 00:00:00	1972-03-09	1972-03-09 00:00:00	1972-03-09	38000177		0	0	7		0	0	0	299270	0	313782	1127433		
30608	2540	19059056	1953-11-28	1953-11-28 00:00:00	1953-12-19	1953-12-19 00:00:00	1953-12-19	38000177		0	0	21		0	0	0	167984	0	243670	19059056		
179645	3949	40213160	1969-08-25	1969-08-25 00:00:00	1969-08-25	1969-08-25 00:00:00	1969-08-25	581452		0	0	0		0	0	0	262449	0	10	40213160		
42741	3542	19133873	1941-01-28	1941-01-28 00:00:00	1941-02-06	1941-02-06 00:00:00	1941-02-06	38000177		0	0	9		0	0	0	235319	0	834061	19133873		
96009	2105	40213314	1977-01-23	1977-01-23 00:00:00	1977-01-23	1977-01-23 00:00:00	1977-01-23	581452		0	0	0		0	0	0	140229	0	49	40213314		
62954	5232	1127433	2003-07-09	2003-07-09 00:00:00	2003-07-16	2003-07-16 00:00:00	2003-07-16	38000177		0	0	7		0	0	0	348098	0	313782	1127433		
51061	1118	40213306	1994-04-03	1994-04-03 00:00:00	1994-04-03	1994-04-03 00:00:00	1994-04-03	581452		0	0	0		0	0	0	\N	0	43	40213306		
20832	1718	19073188	1980-07-26	1980-07-26 00:00:00	1980-08-09	1980-08-09 00:00:00	1980-08-09	38000177		0	0	14		0	0	0	114861	0	308192	19073188		
43123	3573	1115171	2000-01-24	2000-01-24 00:00:00	2000-03-24	2000-03-24 00:00:00	2000-03-24	38000177		0	0	60		0	0	0	237630	0	849574	1115171		
53634	4457	1127078	1987-07-18	1987-07-18 00:00:00	1987-08-01	1987-08-01 00:00:00	1987-08-01	38000177		0	0	14		0	0	0	296623	0	282464	1127078		
173606	3817	40213260	2015-08-14	2015-08-14 00:00:00	2015-08-14	2015-08-14 00:00:00	2015-08-14	581452		0	0	0		0	0	0	253503	0	121	40213260		
2142	170	1115171	1998-04-04	1998-04-04 00:00:00	1998-05-02	1998-05-02 00:00:00	1998-05-02	38000177		0	0	28		0	0	0	11581	0	849574	1115171		
63833	5302	1127433	1980-04-19	1980-04-19 00:00:00	1980-04-26	1980-04-26 00:00:00	1980-04-26	38000177		0	0	7		0	0	0	352770	0	313782	1127433		
46036	3814	19078461	1995-09-12	1995-09-12 00:00:00	1995-10-10	1995-10-10 00:00:00	1995-10-10	38000177		0	0	28		0	0	0	253314	0	310965	19078461		
46091	3820	19078461	2015-08-31	2015-08-31 00:00:00	2015-09-28	2015-09-28 00:00:00	2015-09-28	38000177		0	0	28		0	0	0	253656	0	310965	19078461		
44971	3720	1127433	1967-01-07	1967-01-07 00:00:00	1967-01-14	1967-01-14 00:00:00	1967-01-14	38000177		0	0	7		0	0	0	247282	0	313782	1127433		
55488	4608	19059056	1964-02-27	1964-02-27 00:00:00	1964-03-12	1964-03-12 00:00:00	1964-03-12	38000177		0	0	14		0	0	0	307063	0	243670	19059056		
157959	3477	40213306	1983-05-31	1983-05-31 00:00:00	1983-05-31	1983-05-31 00:00:00	1983-05-31	581452		0	0	0		0	0	0	230641	0	43	40213306		
1791	144	40236824	2011-01-04	2011-01-04 00:00:00	2011-01-11	2011-01-11 00:00:00	2011-01-11	38000177		0	0	7		0	0	0	9633	0	1094107	40236824		
207864	4560	40213296	2011-05-25	2011-05-25 00:00:00	2011-05-25	2011-05-25 00:00:00	2011-05-25	581452		0	0	0		0	0	0	303841	0	52	40213296		
60639	5044	1127433	1993-05-15	1993-05-15 00:00:00	1993-05-29	1993-05-29 00:00:00	1993-05-29	38000177		0	0	14		0	0	0	335210	0	313782	1127433		
4535	377	40229134	1979-01-02	1979-01-02 00:00:00	1979-01-16	1979-01-16 00:00:00	1979-01-16	38000177		0	0	14		0	0	0	25012	0	1043400	40229134		
45483	3761	1127433	1991-06-06	1991-06-06 00:00:00	1991-06-13	1991-06-13 00:00:00	1991-06-13	38000177		0	0	7		0	0	0	250067	0	313782	1127433		
47383	3927	19006318	1949-04-17	1949-04-17 00:00:00	1949-05-01	1949-05-01 00:00:00	1949-05-01	38000177		0	0	14		0	0	0	261056	0	105078	19006318		
37435	3093	1118084	2009-11-03	2009-11-03 00:00:00	2009-11-03	2009-11-03 00:00:00	\N	38000177		0	0	0		0	0	0	205961	0	00025152531	44923712		
56578	4694	19128065	2001-07-05	2001-07-05 00:00:00	2002-06-30	2002-06-30 00:00:00	2002-06-30	38000177		0	0	360		0	0	0	312714	0	749882	19128065		
54140	4498	1551192	1978-02-18	1978-02-18 00:00:00	1978-02-18	1978-02-18 00:00:00	1978-02-18	38000177		0	0	0		0	0	0	299492	0	312617	1551192		
4200	349	1127078	1969-08-28	1969-08-28 00:00:00	1969-10-27	1969-10-27 00:00:00	1969-10-27	38000177		0	0	60		0	0	0	23241	0	282464	1127078		
6473	545	1127078	1974-10-23	1974-10-23 00:00:00	1974-11-20	1974-11-20 00:00:00	1974-11-20	38000177		0	0	28		0	0	0	36143	0	282464	1127078		
5421	454	1118084	1970-09-09	1970-09-09 00:00:00	1970-09-09	1970-09-09 00:00:00	\N	38000177		0	0	0		0	0	0	30266	0	00025152531	44923712		
59813	4972	19133905	1974-05-25	1974-05-25 00:00:00	1974-06-02	1974-06-02 00:00:00	1974-06-02	38000177		0	0	8		0	0	0	330713	0	834102	19133905		
47591	1039	40213306	1982-10-02	1982-10-02 00:00:00	1982-10-02	1982-10-02 00:00:00	1982-10-02	581452		0	0	0		0	0	0	68349	0	43	40213306		
105433	2314	40213160	1956-06-16	1956-06-16 00:00:00	1956-06-16	1956-06-16 00:00:00	1956-06-16	581452		0	0	0		0	0	0	153911	0	10	40213160		
2209	177	1115171	2002-05-07	2002-05-07 00:00:00	2002-07-13	2002-07-13 00:00:00	2002-07-13	38000177		0	0	67		0	0	0	11955	0	849574	1115171		
62703	1371	40213306	1993-04-13	1993-04-13 00:00:00	1993-04-13	1993-04-13 00:00:00	1993-04-13	581452		0	0	0		0	0	0	90908	0	43	40213306		
54511	4530	40229134	1990-01-25	1990-01-25 00:00:00	1990-02-08	1990-02-08 00:00:00	1990-02-08	38000177		0	0	14		0	0	0	301636	0	1043400	40229134		
54884	4559	1127078	1950-11-18	1950-11-18 00:00:00	1950-12-02	1950-12-02 00:00:00	1950-12-02	38000177		0	0	14		0	0	0	303779	0	282464	1127078		
3395	74	40213227	1994-01-05	1994-01-05 00:00:00	1994-01-05	1994-01-05 00:00:00	1994-01-05	581452		0	0	0		0	0	0	5028	0	113	40213227		
2499	199	1124300	1983-04-07	1983-04-07 00:00:00	1983-04-07	1983-04-07 00:00:00	\N	38000177		0	0	0		0	0	0	13665	0	00781178901	45011828		
19904	1634	1115171	2008-01-17	2008-01-17 00:00:00	2008-01-31	2008-01-31 00:00:00	2008-01-31	38000177		0	0	14		0	0	0	109690	0	849574	1115171		
2605	209	1127433	2016-05-03	2016-05-03 00:00:00	2016-05-17	2016-05-17 00:00:00	2016-05-17	38000177		0	0	14		0	0	0	14232	0	313782	1127433		
56439	1236	40213227	2002-06-13	2002-06-13 00:00:00	2002-06-13	2002-06-13 00:00:00	2002-06-13	581452		0	0	0		0	0	0	81372	0	113	40213227		
33179	2750	19078461	1980-07-31	1980-07-31 00:00:00	1980-08-14	1980-08-14 00:00:00	1980-08-14	38000177		0	0	14		0	0	0	181873	0	310965	19078461		
46756	3874	1127078	1986-09-28	1986-09-28 00:00:00	1986-11-27	1986-11-27 00:00:00	1986-11-27	38000177		0	0	60		0	0	0	257236	0	282464	1127078		
43210	3579	40165015	1996-04-28	1996-04-28 00:00:00	1996-04-28	1996-04-28 00:00:00	\N	38000177		0	0	0		0	0	0	237934	0	861467	40165015		
26895	2217	1115171	1995-12-02	1995-12-02 00:00:00	1996-03-01	1996-03-01 00:00:00	1996-03-01	38000177		0	0	90		0	0	0	147668	0	849574	1115171		
57351	4759	19115351	2012-09-04	2012-09-04 00:00:00	2013-08-13	2013-08-13 00:00:00	2013-08-13	38000177		0	0	343		0	0	0	317087	0	563026	19115351		
34557	2857	1124300	2006-03-16	2006-03-16 00:00:00	2006-03-16	2006-03-16 00:00:00	\N	38000177		0	0	0		0	0	0	189713	0	00781178901	45011828		
44732	3701	40162522	1984-12-25	1984-12-25 00:00:00	1984-12-25	1984-12-25 00:00:00	\N	38000177		0	0	0		0	0	0	246071	0	857005	40162522		
42360	923	40213260	2008-11-12	2008-11-12 00:00:00	2008-11-12	2008-11-12 00:00:00	2008-11-12	581452		0	0	0		0	0	0	61458	0	121	40213260		
7208	605	1127433	1972-04-09	1972-04-09 00:00:00	1972-04-23	1972-04-23 00:00:00	1972-04-23	38000177		0	0	14		0	0	0	40116	0	313782	1127433		
9841	825	46233988	1971-03-22	1971-03-22 00:00:00	1971-04-05	1971-04-05 00:00:00	1971-04-05	38000177		0	0	14		0	0	0	54679	0	1652673	46233988		
27245	2250	1127433	1993-12-27	1993-12-27 00:00:00	1994-01-03	1994-01-03 00:00:00	1994-01-03	38000177		0	0	7		0	0	0	149682	0	313782	1127433		
48206	3996	1127433	2003-04-05	2003-04-05 00:00:00	2003-04-12	2003-04-12 00:00:00	2003-04-12	38000177		0	0	7		0	0	0	265676	0	313782	1127433		
32720	2711	19133873	1957-05-10	1957-05-10 00:00:00	1957-05-23	1957-05-23 00:00:00	1957-05-23	38000177		0	0	13		0	0	0	179719	0	834061	19133873		
3084	250	1118084	2008-12-26	2008-12-26 00:00:00	2008-12-26	2008-12-26 00:00:00	\N	38000177		0	0	0		0	0	0	16801	0	00025152531	44923712		
10858	905	1124300	2009-04-29	2009-04-29 00:00:00	2009-04-29	2009-04-29 00:00:00	\N	38000177		0	0	0		0	0	0	60196	0	00781178901	45011828		
16914	1401	19128065	1995-12-09	1995-12-09 00:00:00	1996-12-03	1996-12-03 00:00:00	1996-12-03	38000177		0	0	360		0	0	0	93139	0	749882	19128065		
42758	932	40213260	2019-02-25	2019-02-25 00:00:00	2019-02-25	2019-02-25 00:00:00	2019-02-25	581452		0	0	0		0	0	0	62053	0	121	40213260		
76643	1674	40213296	2019-06-10	2019-06-10 00:00:00	2019-06-10	2019-06-10 00:00:00	2019-06-10	581452		0	0	0		0	0	0	112402	0	52	40213296		
233763	5137	40213160	1967-11-29	1967-11-29 00:00:00	1967-11-29	1967-11-29 00:00:00	1967-11-29	581452		0	0	0		0	0	0	341406	0	10	40213160		
111975	2460	40213227	2016-10-26	2016-10-26 00:00:00	2016-10-26	2016-10-26 00:00:00	2016-10-26	581452		0	0	0		0	0	0	163137	0	113	40213227		
1569	35	40213227	2002-05-07	2002-05-07 00:00:00	2002-05-07	2002-05-07 00:00:00	2002-05-07	581452		0	0	0		0	0	0	2442	0	113	40213227		
49486	4105	1127433	1950-08-04	1950-08-04 00:00:00	1950-08-18	1950-08-18 00:00:00	1950-08-18	38000177		0	0	14		0	0	0	272720	0	313782	1127433		
54104	4496	1713671	1955-11-02	1955-11-02 00:00:00	1955-11-23	1955-11-23 00:00:00	1955-11-23	38000177		0	0	21		0	0	0	299310	0	562251	1713671		
30609	2540	45892894	2019-04-05	2019-04-05 00:00:00	2019-04-05	2019-04-05 00:00:00	\N	38000177		0	0	0		0	0	0	167929	0	1599803	45892894		
179651	3949	40213160	1974-02-25	1974-02-25 00:00:00	1974-02-25	1974-02-25 00:00:00	1974-02-25	581452		0	0	0		0	0	0	262451	0	10	40213160		
42742	3542	40173590	2017-09-23	2017-09-23 00:00:00	2017-09-23	2017-09-23 00:00:00	\N	38000177		0	0	0		0	0	0	235247	0	904419	40173590		
96013	2105	40213227	2006-03-12	2006-03-12 00:00:00	2006-03-12	2006-03-12 00:00:00	2006-03-12	581452		0	0	0		0	0	0	140236	0	113	40213227		
62955	5232	1118084	2011-04-09	2011-04-09 00:00:00	2011-04-09	2011-04-09 00:00:00	\N	38000177		0	0	0		0	0	0	348095	0	00025152531	44923712		
51065	1118	40213227	2006-04-23	2006-04-23 00:00:00	2006-04-23	2006-04-23 00:00:00	2006-04-23	581452		0	0	0		0	0	0	73741	0	113	40213227		
20833	1718	1127433	1980-07-26	1980-07-26 00:00:00	1980-08-09	1980-08-09 00:00:00	1980-08-09	38000177		0	0	14		0	0	0	114861	0	313782	1127433		
43124	3573	19059056	1936-02-19	1936-02-19 00:00:00	1936-03-20	1936-03-20 00:00:00	1936-03-20	38000177		0	0	30		0	0	0	237623	0	243670	19059056		
53635	4457	1127078	1994-02-11	1994-02-11 00:00:00	1994-02-25	1994-02-25 00:00:00	1994-02-25	38000177		0	0	14		0	0	0	296638	0	282464	1127078		
173608	3817	40213160	1965-04-09	1965-04-09 00:00:00	1965-04-09	1965-04-09 00:00:00	1965-04-09	581452		0	0	0		0	0	0	253469	0	10	40213160		
2143	170	1127433	2014-01-21	2014-01-21 00:00:00	2014-02-04	2014-02-04 00:00:00	2014-02-04	38000177		0	0	14		0	0	0	11524	0	313782	1127433		
63834	5302	1713671	2007-01-12	2007-01-12 00:00:00	2007-01-19	2007-01-19 00:00:00	2007-01-19	38000177		0	0	7		0	0	0	352782	0	562251	1713671		
46037	3814	1124300	2013-04-10	2013-04-10 00:00:00	2013-04-10	2013-04-10 00:00:00	\N	38000177		0	0	0		0	0	0	253355	0	00781178901	45011828		
46095	3820	1127433	2015-12-11	2015-12-11 00:00:00	2015-12-18	2015-12-18 00:00:00	2015-12-18	38000177		0	0	7		0	0	0	253615	0	313782	1127433		
44972	3720	1127433	2010-10-04	2010-10-04 00:00:00	2010-10-11	2010-10-11 00:00:00	2010-10-11	38000177		0	0	7		0	0	0	247247	0	313782	1127433		
55489	4608	1118084	1997-03-25	1997-03-25 00:00:00	1997-03-25	1997-03-25 00:00:00	\N	38000177		0	0	0		0	0	0	307017	0	00025152531	44923712		
157964	3477	40213260	2011-08-30	2011-08-30 00:00:00	2011-08-30	2011-08-30 00:00:00	2011-08-30	581452		0	0	0		0	0	0	230740	0	121	40213260		
1792	144	920300	2011-01-04	2011-01-04 00:00:00	2011-01-11	2011-01-11 00:00:00	2011-01-11	38000177		0	0	7		0	0	0	9633	0	311989	920300		
207867	4560	40213227	2019-06-19	2019-06-19 00:00:00	2019-06-19	2019-06-19 00:00:00	2019-06-19	581452		0	0	0		0	0	0	303870	0	113	40213227		
60640	5044	19133873	1979-08-26	1979-08-26 00:00:00	1979-09-07	1979-09-07 00:00:00	1979-09-07	38000177		0	0	12		0	0	0	335190	0	834061	19133873		
4536	377	19128065	1986-01-03	1986-01-03 00:00:00	1986-12-29	1986-12-29 00:00:00	1986-12-29	38000177		0	0	360		0	0	0	24972	0	749882	19128065		
45484	3761	1124300	1990-11-29	1990-11-29 00:00:00	1990-11-29	1990-11-29 00:00:00	\N	38000177		0	0	0		0	0	0	250109	0	00781178901	45011828		
47384	3927	1127433	1977-01-16	1977-01-16 00:00:00	1977-01-30	1977-01-30 00:00:00	1977-01-30	38000177		0	0	14		0	0	0	261035	0	313782	1127433		
37437	3093	19133873	1983-01-27	1983-01-27 00:00:00	1983-02-05	1983-02-05 00:00:00	1983-02-05	38000177		0	0	9		0	0	0	205928	0	834061	19133873		
56579	4694	40224805	2002-06-30	2002-06-30 00:00:00	2003-03-30	2003-03-30 00:00:00	2003-03-30	38000177		0	0	273		0	0	0	312715	0	1000126	40224805		
54141	4498	19059056	1983-11-19	1983-11-19 00:00:00	1984-02-17	1984-02-17 00:00:00	1984-02-17	38000177		0	0	90		0	0	0	299493	0	243670	19059056		
4202	349	1713671	1997-06-11	1997-06-11 00:00:00	1997-06-25	1997-06-25 00:00:00	1997-06-25	38000177		0	0	14		0	0	0	23245	0	562251	1713671		
6474	545	19078461	2018-09-30	2018-09-30 00:00:00	2018-10-21	2018-10-21 00:00:00	2018-10-21	38000177		0	0	21		0	0	0	36147	0	310965	19078461		
5422	454	19078461	1981-08-11	1981-08-11 00:00:00	1981-09-08	1981-09-08 00:00:00	1981-09-08	38000177		0	0	28		0	0	0	30272	0	310965	19078461		
59814	4972	19078461	1997-08-30	1997-08-30 00:00:00	1997-09-29	1997-09-29 00:00:00	1997-09-29	38000177		0	0	30		0	0	0	330724	0	310965	19078461		
47605	1039	40213296	2000-03-25	2000-03-25 00:00:00	2000-03-25	2000-03-25 00:00:00	2000-03-25	581452		0	0	0		0	0	0	68395	0	52	40213296		
105444	2314	40213160	1955-06-11	1955-06-11 00:00:00	1955-06-11	1955-06-11 00:00:00	1955-06-11	581452		0	0	0		0	0	0	153860	0	10	40213160		
2210	177	1127078	1973-10-15	1973-10-15 00:00:00	1973-11-04	1973-11-04 00:00:00	1973-11-04	38000177		0	0	20		0	0	0	11954	0	282464	1127078		
62705	1371	40213227	1993-04-13	1993-04-13 00:00:00	1993-04-13	1993-04-13 00:00:00	1993-04-13	581452		0	0	0		0	0	0	90908	0	113	40213227		
54512	4530	1127078	1969-05-13	1969-05-13 00:00:00	1969-06-12	1969-06-12 00:00:00	1969-06-12	38000177		0	0	30		0	0	0	301617	0	282464	1127078		
54885	4559	19006318	1950-11-18	1950-11-18 00:00:00	1950-12-02	1950-12-02 00:00:00	1950-12-02	38000177		0	0	14		0	0	0	303779	0	105078	19006318		
3396	74	40213306	1994-01-05	1994-01-05 00:00:00	1994-01-05	1994-01-05 00:00:00	1994-01-05	581452		0	0	0		0	0	0	5028	0	43	40213306		
2500	199	19133905	1993-08-14	1993-08-14 00:00:00	1993-08-24	1993-08-24 00:00:00	1993-08-24	38000177		0	0	10		0	0	0	13647	0	834102	19133905		
19905	1634	1127433	1981-07-16	1981-07-16 00:00:00	1981-08-06	1981-08-06 00:00:00	1981-08-06	38000177		0	0	21		0	0	0	109689	0	313782	1127433		
2607	209	920300	1985-04-02	1985-04-02 00:00:00	1985-04-09	1985-04-09 00:00:00	1985-04-09	38000177		0	0	7		0	0	0	14282	0	311989	920300		
203410	4465	40213160	1973-05-04	1973-05-04 00:00:00	1973-05-04	1973-05-04 00:00:00	1973-05-04	581452		0	0	0		0	0	0	297078	0	10	40213160		
33180	2750	1115171	2001-03-29	2001-03-29 00:00:00	2001-04-12	2001-04-12 00:00:00	2001-04-12	38000177		0	0	14		0	0	0	181936	0	849574	1115171		
46757	3874	19128022	1997-12-09	1997-12-09 00:00:00	1998-12-04	1998-12-04 00:00:00	1998-12-04	38000177		0	0	360		0	0	0	257273	0	749785	19128022		
43211	3579	1124300	1997-09-08	1997-09-08 00:00:00	1997-09-08	1997-09-08 00:00:00	\N	38000177		0	0	0		0	0	0	237934	0	00781178901	45011828		
26896	2217	40229134	2001-01-06	2001-01-06 00:00:00	2001-01-13	2001-01-13 00:00:00	2001-01-13	38000177		0	0	7		0	0	0	147629	0	1043400	40229134		
57353	4759	1127433	2005-01-07	2005-01-07 00:00:00	2005-02-04	2005-02-04 00:00:00	2005-02-04	38000177		0	0	28		0	0	0	317066	0	313782	1127433		
34558	2857	1127433	1989-07-27	1989-07-27 00:00:00	1989-08-17	1989-08-17 00:00:00	1989-08-17	38000177		0	0	21		0	0	0	189700	0	313782	1127433		
34589	2858	19019273	1988-03-02	1988-03-02 00:00:00	1988-03-02	1988-03-02 00:00:00	\N	38000177		0	0	0		0	0	0	189801	0	198014	19019273		
42364	923	40213160	1959-04-22	1959-04-22 00:00:00	1959-04-22	1959-04-22 00:00:00	1959-04-22	581452		0	0	0		0	0	0	61438	0	10	40213160		
51773	4304	19115351	1981-10-18	1981-10-18 00:00:00	1982-04-25	1982-04-25 00:00:00	1982-04-25	38000177		0	0	189		0	0	0	285507	0	563026	19115351		
9842	825	1127078	1971-03-22	1971-03-22 00:00:00	1971-04-05	1971-04-05 00:00:00	1971-04-05	38000177		0	0	14		0	0	0	54679	0	282464	1127078		
27246	2250	1127433	1988-07-17	1988-07-17 00:00:00	1988-08-07	1988-08-07 00:00:00	1988-08-07	38000177		0	0	21		0	0	0	149650	0	313782	1127433		
48207	3996	40231925	1989-05-15	1989-05-15 00:00:00	1989-05-15	1989-05-15 00:00:00	\N	38000177		0	0	0		0	0	0	265650	0	1049221	40231925		
32721	2711	1127433	2015-11-03	2015-11-03 00:00:00	2016-01-02	2016-01-02 00:00:00	2016-01-02	38000177		0	0	60		0	0	0	179616	0	313782	1127433		
3085	250	1127433	2018-06-05	2018-06-05 00:00:00	2018-06-19	2018-06-19 00:00:00	2018-06-19	38000177		0	0	14		0	0	0	16794	0	313782	1127433		
10859	905	1127433	2008-10-01	2008-10-01 00:00:00	2008-10-22	2008-10-22 00:00:00	2008-10-22	38000177		0	0	21		0	0	0	60196	0	313782	1127433		
16915	1401	1713671	2005-04-25	2005-04-25 00:00:00	2005-05-16	2005-05-16 00:00:00	2005-05-16	38000177		0	0	21		0	0	0	93157	0	562251	1713671		
42761	932	40213160	1969-11-03	1969-11-03 00:00:00	1969-11-03	1969-11-03 00:00:00	1969-11-03	581452		0	0	0		0	0	0	62021	0	10	40213160		
76647	1674	40213160	1977-06-20	1977-06-20 00:00:00	1977-06-20	1977-06-20 00:00:00	1977-06-20	581452		0	0	0		0	0	0	112357	0	10	40213160		
233766	5137	40213227	2019-04-03	2019-04-03 00:00:00	2019-04-03	2019-04-03 00:00:00	2019-04-03	581452		0	0	0		0	0	0	341449	0	113	40213227		
111978	2460	40213160	1984-11-14	1984-11-14 00:00:00	1984-11-14	1984-11-14 00:00:00	1984-11-14	581452		0	0	0		0	0	0	163094	0	10	40213160		
1574	35	40213296	2000-05-02	2000-05-02 00:00:00	2000-05-02	2000-05-02 00:00:00	2000-05-02	581452		0	0	0		0	0	0	2422	0	52	40213296		
49487	4105	19006318	1951-10-12	1951-10-12 00:00:00	1951-10-26	1951-10-26 00:00:00	1951-10-26	38000177		0	0	14		0	0	0	272778	0	105078	19006318		
54105	4496	40236824	1985-04-19	1985-04-19 00:00:00	1985-04-26	1985-04-26 00:00:00	1985-04-26	38000177		0	0	7		0	0	0	299255	0	1094107	40236824		
30610	2540	19059056	1950-11-30	1950-11-30 00:00:00	1950-12-14	1950-12-14 00:00:00	1950-12-14	38000177		0	0	14		0	0	0	167925	0	243670	19059056		
102640	2250	40213160	1960-05-25	1960-05-25 00:00:00	1960-05-25	1960-05-25 00:00:00	1960-05-25	581452		0	0	0		0	0	0	149639	0	10	40213160		
42743	3542	19133873	1938-01-02	1938-01-02 00:00:00	1938-01-13	1938-01-13 00:00:00	1938-01-13	38000177		0	0	11		0	0	0	235232	0	834061	19133873		
37789	3123	19073183	1979-07-26	1979-07-26 00:00:00	1979-08-09	1979-08-09 00:00:00	1979-08-09	38000177		0	0	14		0	0	0	207832	0	308182	19073183		
62956	5232	1127433	1983-02-17	1983-02-17 00:00:00	1983-02-24	1983-02-24 00:00:00	1983-02-24	38000177		0	0	7		0	0	0	348089	0	313782	1127433		
51067	1118	40213314	1977-01-16	1977-01-16 00:00:00	1977-01-16	1977-01-16 00:00:00	1977-01-16	581452		0	0	0		0	0	0	73713	0	49	40213314		
20834	1718	1127433	1980-03-09	1980-03-09 00:00:00	1980-03-23	1980-03-23 00:00:00	1980-03-23	38000177		0	0	14		0	0	0	114843	0	313782	1127433		
43125	3573	1127433	1968-11-30	1968-11-30 00:00:00	1968-12-07	1968-12-07 00:00:00	1968-12-07	38000177		0	0	7		0	0	0	237578	0	313782	1127433		
53636	4457	19078461	2006-07-22	2006-07-22 00:00:00	2006-08-21	2006-08-21 00:00:00	2006-08-21	38000177		0	0	30		0	0	0	296640	0	310965	19078461		
173611	3817	40213296	2005-07-01	2005-07-01 00:00:00	2005-07-01	2005-07-01 00:00:00	2005-07-01	581452		0	0	0		0	0	0	253510	0	52	40213296		
2144	170	1118084	2009-04-15	2009-04-15 00:00:00	2009-04-15	2009-04-15 00:00:00	\N	38000177		0	0	0		0	0	0	11546	0	00025152531	44923712		
63835	5302	1124300	2010-07-15	2010-07-15 00:00:00	2010-07-15	2010-07-15 00:00:00	\N	38000177		0	0	0		0	0	0	352766	0	00781178901	45011828		
46038	3814	19006318	1976-07-23	1976-07-23 00:00:00	1976-08-06	1976-08-06 00:00:00	1976-08-06	38000177		0	0	14		0	0	0	253356	0	105078	19006318		
46096	3820	1127433	2002-12-25	2002-12-25 00:00:00	2003-01-08	2003-01-08 00:00:00	2003-01-08	38000177		0	0	14		0	0	0	253654	0	313782	1127433		
44973	3720	19006318	1954-07-05	1954-07-05 00:00:00	1954-07-19	1954-07-19 00:00:00	1954-07-19	38000177		0	0	14		0	0	0	247239	0	105078	19006318		
55490	4608	40169281	1992-01-30	1992-01-30 00:00:00	1992-01-30	1992-01-30 00:00:00	\N	38000177		0	0	0		0	0	0	306976	0	896209	40169281		
6227	135	40213296	2013-12-10	2013-12-10 00:00:00	2013-12-10	2013-12-10 00:00:00	2013-12-10	581452		0	0	0		0	0	0	9028	0	52	40213296		
1793	144	1124300	2011-12-01	2011-12-01 00:00:00	2011-12-01	2011-12-01 00:00:00	\N	38000177		0	0	0		0	0	0	9633	0	00781178901	45011828		
207868	4560	40213260	2019-06-19	2019-06-19 00:00:00	2019-06-19	2019-06-19 00:00:00	2019-06-19	581452		0	0	0		0	0	0	303870	0	121	40213260		
60641	5044	19075601	2010-02-03	2010-02-03 00:00:00	2010-02-03	2010-02-03 00:00:00	\N	38000177		0	0	0		0	0	0	335206	0	309362	19075601		
4537	377	1127433	2010-07-19	2010-07-19 00:00:00	2010-07-26	2010-07-26 00:00:00	2010-07-26	38000177		0	0	7		0	0	0	24976	0	313782	1127433		
55943	4643	19133873	1909-09-15	1909-09-15 00:00:00	1909-09-27	1909-09-27 00:00:00	1909-09-27	38000177		0	0	12		0	0	0	309605	0	834061	19133873		
47385	3927	1127433	2011-04-02	2011-04-02 00:00:00	2011-04-16	2011-04-16 00:00:00	2011-04-16	38000177		0	0	14		0	0	0	261045	0	313782	1127433		
37438	3093	19133873	1979-02-01	1979-02-01 00:00:00	1979-02-13	1979-02-13 00:00:00	1979-02-13	38000177		0	0	12		0	0	0	205913	0	834061	19133873		
56580	4694	19128022	1999-07-16	1999-07-16 00:00:00	2000-07-10	2000-07-10 00:00:00	2000-07-10	38000177		0	0	360		0	0	0	312765	0	749785	19128022		
54142	4498	1713671	1981-08-09	1981-08-09 00:00:00	1981-08-16	1981-08-16 00:00:00	1981-08-16	38000177		0	0	7		0	0	0	299474	0	562251	1713671		
174347	3833	40213296	2007-03-14	2007-03-14 00:00:00	2007-03-14	2007-03-14 00:00:00	2007-03-14	581452		0	0	0		0	0	0	254547	0	52	40213296		
16974	1407	19128065	1981-11-07	1981-11-07 00:00:00	1982-11-02	1982-11-02 00:00:00	1982-11-02	38000177		0	0	360		0	0	0	93459	0	749882	19128065		
5423	454	40236824	1954-03-24	1954-03-24 00:00:00	1954-03-31	1954-03-31 00:00:00	1954-03-31	38000177		0	0	7		0	0	0	30279	0	1094107	40236824		
59815	4972	40231925	1997-08-30	1997-08-30 00:00:00	1997-08-30	1997-08-30 00:00:00	\N	38000177		0	0	0		0	0	0	330724	0	1049221	40231925		
47609	1039	40213227	2011-03-26	2011-03-26 00:00:00	2011-03-26	2011-03-26 00:00:00	2011-03-26	581452		0	0	0		0	0	0	68356	0	113	40213227		
105449	2314	40213227	1993-12-25	1993-12-25 00:00:00	1993-12-25	1993-12-25 00:00:00	1993-12-25	581452		0	0	0		0	0	0	153841	0	113	40213227		
18851	1558	1127433	2006-04-06	2006-04-06 00:00:00	2006-04-13	2006-04-13 00:00:00	2006-04-13	38000177		0	0	7		0	0	0	104309	0	313782	1127433		
62708	1371	40213227	2002-04-23	2002-04-23 00:00:00	2002-04-23	2002-04-23 00:00:00	2002-04-23	581452		0	0	0		0	0	0	90911	0	113	40213227		
54513	4530	1127433	1988-07-07	1988-07-07 00:00:00	1988-09-05	1988-09-05 00:00:00	1988-09-05	38000177		0	0	60		0	0	0	301620	0	313782	1127433		
54886	4559	1127433	1962-04-03	1962-04-03 00:00:00	1962-05-01	1962-05-01 00:00:00	1962-05-01	38000177		0	0	28		0	0	0	303804	0	313782	1127433		
3401	74	40213296	2012-07-11	2012-07-11 00:00:00	2012-07-11	2012-07-11 00:00:00	2012-07-11	581452		0	0	0		0	0	0	5035	0	52	40213296		
2501	199	19059056	1965-01-26	1965-01-26 00:00:00	1965-02-16	1965-02-16 00:00:00	1965-02-16	38000177		0	0	21		0	0	0	13644	0	243670	19059056		
19906	1634	1124300	1978-12-18	1978-12-18 00:00:00	1978-12-18	1978-12-18 00:00:00	\N	38000177		0	0	0		0	0	0	109753	0	00781178901	45011828		
2608	209	40236824	1985-04-02	1985-04-02 00:00:00	1985-04-09	1985-04-09 00:00:00	1985-04-09	38000177		0	0	7		0	0	0	14282	0	1094107	40236824		
203414	4466	40213227	2005-08-05	2005-08-05 00:00:00	2005-08-05	2005-08-05 00:00:00	2005-08-05	581452		0	0	0		0	0	0	297114	0	113	40213227		
33181	2750	19075001	2001-03-29	2001-03-29 00:00:00	2001-04-12	2001-04-12 00:00:00	2001-04-12	38000177		0	0	14		0	0	0	181936	0	309097	19075001		
46758	3874	19133873	1985-03-08	1985-03-08 00:00:00	1985-03-18	1985-03-18 00:00:00	1985-03-18	38000177		0	0	10		0	0	0	257237	0	834061	19133873		
43212	3580	1127078	1983-05-22	1983-05-22 00:00:00	1983-06-05	1983-06-05 00:00:00	1983-06-05	38000177		0	0	14		0	0	0	238010	0	282464	1127078		
26897	2217	19128065	1993-06-25	1993-06-25 00:00:00	1994-06-20	1994-06-20 00:00:00	1994-06-20	38000177		0	0	360		0	0	0	147657	0	749882	19128065		
57354	4759	19133905	1998-06-12	1998-06-12 00:00:00	1998-06-23	1998-06-23 00:00:00	1998-06-23	38000177		0	0	11		0	0	0	317075	0	834102	19133905		
34559	2857	1127433	1984-11-27	1984-11-27 00:00:00	1984-12-04	1984-12-04 00:00:00	1984-12-04	38000177		0	0	7		0	0	0	189686	0	313782	1127433		
34590	2858	19089061	1988-03-02	1988-03-02 00:00:00	1988-03-16	1988-03-16 00:00:00	1988-03-16	38000177		0	0	14		0	0	0	189801	0	567645	19089061		
42366	923	40213160	1963-10-23	1963-10-23 00:00:00	1963-10-23	1963-10-23 00:00:00	1963-10-23	581452		0	0	0		0	0	0	61424	0	10	40213160		
51774	4304	1713671	1968-07-08	1968-07-08 00:00:00	1968-07-15	1968-07-15 00:00:00	1968-07-15	38000177		0	0	7		0	0	0	285457	0	562251	1713671		
9843	825	46233988	1972-08-13	1972-08-13 00:00:00	1972-08-27	1972-08-27 00:00:00	1972-08-27	38000177		0	0	14		0	0	0	54646	0	1652673	46233988		
27247	2250	40229134	1965-12-03	1965-12-03 00:00:00	1965-12-10	1965-12-10 00:00:00	1965-12-10	38000177		0	0	7		0	0	0	149627	0	1043400	40229134		
48208	3996	40229134	1979-12-16	1979-12-16 00:00:00	1979-12-30	1979-12-30 00:00:00	1979-12-30	38000177		0	0	14		0	0	0	265654	0	1043400	40229134		
32722	2711	1127433	1980-02-05	1980-02-05 00:00:00	1980-02-12	1980-02-12 00:00:00	1980-02-12	38000177		0	0	7		0	0	0	179621	0	313782	1127433		
3086	250	1127433	1995-01-25	1995-01-25 00:00:00	1995-02-08	1995-02-08 00:00:00	1995-02-08	38000177		0	0	14		0	0	0	16804	0	313782	1127433		
10860	905	19115351	1974-09-20	1974-09-20 00:00:00	1975-02-28	1975-02-28 00:00:00	1975-02-28	38000177		0	0	161		0	0	0	60191	0	563026	19115351		
16916	1401	1713671	2001-08-09	2001-08-09 00:00:00	2001-08-23	2001-08-23 00:00:00	2001-08-23	38000177		0	0	14		0	0	0	93155	0	562251	1713671		
42763	932	40213296	2009-03-02	2009-03-02 00:00:00	2009-03-02	2009-03-02 00:00:00	2009-03-02	581452		0	0	0		0	0	0	62051	0	52	40213296		
76649	1674	40213227	2008-09-15	2008-09-15 00:00:00	2008-09-15	2008-09-15 00:00:00	2008-09-15	581452		0	0	0		0	0	0	112388	0	113	40213227		
233767	5137	40213260	2019-04-03	2019-04-03 00:00:00	2019-04-03	2019-04-03 00:00:00	2019-04-03	581452		0	0	0		0	0	0	341449	0	121	40213260		
111979	2460	40213314	1984-11-14	1984-11-14 00:00:00	1984-11-14	1984-11-14 00:00:00	1984-11-14	581452		0	0	0		0	0	0	163094	0	49	40213314		
1576	35	40213227	2012-01-17	2012-01-17 00:00:00	2012-01-17	2012-01-17 00:00:00	2012-01-17	581452		0	0	0		0	0	0	2423	0	113	40213227		
49488	4105	19059056	1951-10-12	1951-10-12 00:00:00	1951-10-26	1951-10-26 00:00:00	1951-10-26	38000177		0	0	14		0	0	0	272778	0	243670	19059056		
54106	4496	920300	1985-04-19	1985-04-19 00:00:00	1985-04-26	1985-04-26 00:00:00	1985-04-26	38000177		0	0	7		0	0	0	299255	0	311989	920300		
30611	2540	40162522	1950-11-30	1950-11-30 00:00:00	1950-11-30	1950-11-30 00:00:00	\N	38000177		0	0	0		0	0	0	167925	0	857005	40162522		
102647	2250	40213160	1956-06-13	1956-06-13 00:00:00	1956-06-13	1956-06-13 00:00:00	1956-06-13	581452		0	0	0		0	0	0	149635	0	10	40213160		
42744	3542	1127433	1957-05-09	1957-05-09 00:00:00	1957-05-23	1957-05-23 00:00:00	1957-05-23	38000177		0	0	14		0	0	0	235322	0	313782	1127433		
37790	3123	19019979	1979-07-26	1979-07-26 00:00:00	1979-08-09	1979-08-09 00:00:00	1979-08-09	38000177		0	0	14		0	0	0	207832	0	198405	19019979		
62957	5232	19059056	1972-06-12	1972-06-12 00:00:00	1972-09-10	1972-09-10 00:00:00	1972-09-10	38000177		0	0	90		0	0	0	348065	0	243670	19059056		
51072	1118	40213296	2013-08-18	2013-08-18 00:00:00	2013-08-18	2013-08-18 00:00:00	2013-08-18	581452		0	0	0		0	0	0	73744	0	52	40213296		
20835	1718	1127433	1986-12-20	1986-12-20 00:00:00	1987-01-03	1987-01-03 00:00:00	1987-01-03	38000177		0	0	14		0	0	0	114868	0	313782	1127433		
43126	3573	40229134	2010-06-13	2010-06-13 00:00:00	2010-06-20	2010-06-20 00:00:00	2010-06-20	38000177		0	0	7		0	0	0	237546	0	1043400	40229134		
53637	4457	1118084	2016-08-19	2016-08-19 00:00:00	2016-08-19	2016-08-19 00:00:00	\N	38000177		0	0	0		0	0	0	296643	0	00025152531	44923712		
173617	3817	40213260	2016-08-19	2016-08-19 00:00:00	2016-08-19	2016-08-19 00:00:00	2016-08-19	581452		0	0	0		0	0	0	253484	0	121	40213260		
2145	171	19078461	1994-05-15	1994-05-15 00:00:00	1994-06-05	1994-06-05 00:00:00	1994-06-05	38000177		0	0	21		0	0	0	11610	0	310965	19078461		
63836	5302	1127433	1992-07-23	1992-07-23 00:00:00	1992-08-06	1992-08-06 00:00:00	1992-08-06	38000177		0	0	14		0	0	0	352780	0	313782	1127433		
46039	3814	19059056	1976-07-23	1976-07-23 00:00:00	1976-08-06	1976-08-06 00:00:00	1976-08-06	38000177		0	0	14		0	0	0	253356	0	243670	19059056		
46097	3820	1127433	1977-11-12	1977-11-12 00:00:00	1977-12-17	1977-12-17 00:00:00	1977-12-17	38000177		0	0	35		0	0	0	253650	0	313782	1127433		
44974	3720	19059056	1954-07-05	1954-07-05 00:00:00	1954-07-19	1954-07-19 00:00:00	1954-07-19	38000177		0	0	14		0	0	0	247239	0	243670	19059056		
55491	4608	40229134	1962-11-18	1962-11-18 00:00:00	1962-11-25	1962-11-25 00:00:00	1962-11-25	38000177		0	0	7		0	0	0	306990	0	1043400	40229134		
6230	135	40213227	1993-08-17	1993-08-17 00:00:00	1993-08-17	1993-08-17 00:00:00	1993-08-17	581452		0	0	0		0	0	0	9057	0	113	40213227		
1794	144	1127078	1977-02-07	1977-02-07 00:00:00	1977-02-21	1977-02-21 00:00:00	1977-02-21	38000177		0	0	14		0	0	0	9634	0	282464	1127078		
207874	4560	40213306	1990-01-03	1990-01-03 00:00:00	1990-01-03	1990-01-03 00:00:00	1990-01-03	581452		0	0	0		0	0	0	303860	0	43	40213306		
60642	5044	19126352	2010-02-03	2010-02-03 00:00:00	2010-02-03	2010-02-03 00:00:00	\N	38000177		0	0	0		0	0	0	335206	0	705129	19126352		
4538	377	1713671	1994-09-30	1994-09-30 00:00:00	1994-10-21	1994-10-21 00:00:00	1994-10-21	38000177		0	0	21		0	0	0	24969	0	562251	1713671		
55944	4643	1713671	1958-08-11	1958-08-11 00:00:00	1958-08-25	1958-08-25 00:00:00	1958-08-25	38000177		0	0	14		0	0	0	309526	0	562251	1713671		
47386	3928	1127433	2005-03-27	2005-03-27 00:00:00	2005-05-01	2005-05-01 00:00:00	2005-05-01	38000177		0	0	35		0	0	0	261133	0	313782	1127433		
37439	3093	40229134	2016-07-30	2016-07-30 00:00:00	2016-08-06	2016-08-06 00:00:00	2016-08-06	38000177		0	0	7		0	0	0	205910	0	1043400	40229134		
56581	4694	19112599	1982-07-22	1982-07-22 00:00:00	1982-07-22	1982-07-22 00:00:00	\N	38000177		0	0	0		0	0	0	312703	0	477045	19112599		
54147	4500	1551192	1962-08-09	1962-08-09 00:00:00	1962-08-09	1962-08-09 00:00:00	1962-08-09	38000177		0	0	0		0	0	0	299602	0	312617	1551192		
174351	3833	40213160	1966-02-02	1966-02-02 00:00:00	1966-02-02	1966-02-02 00:00:00	1966-02-02	581452		0	0	0		0	0	0	254501	0	10	40213160		
8943	191	40213227	1992-09-15	1992-09-15 00:00:00	1992-09-15	1992-09-15 00:00:00	1992-09-15	581452		0	0	0		0	0	0	13051	0	113	40213227		
5424	454	920300	1954-03-24	1954-03-24 00:00:00	1954-03-31	1954-03-31 00:00:00	1954-03-31	38000177		0	0	7		0	0	0	30279	0	311989	920300		
71626	1566	40213160	1972-10-14	1972-10-14 00:00:00	1972-10-14	1972-10-14 00:00:00	1972-10-14	581452		0	0	0		0	0	0	105070	0	10	40213160		
47610	1039	40213260	2011-03-26	2011-03-26 00:00:00	2011-03-26	2011-03-26 00:00:00	2011-03-26	581452		0	0	0		0	0	0	68356	0	121	40213260		
105451	2314	40213227	2012-09-08	2012-09-08 00:00:00	2012-09-08	2012-09-08 00:00:00	2012-09-08	581452		0	0	0		0	0	0	153834	0	113	40213227		
18852	1558	35605482	1962-06-14	1962-06-14 00:00:00	1962-06-14	1962-06-14 00:00:00	1962-06-14	38000177		0	0	0		0	0	0	104301	0	1740467	35605482		
20445	445	40213227	1993-08-27	1993-08-27 00:00:00	1993-08-27	1993-08-27 00:00:00	1993-08-27	581452		0	0	0		0	0	0	29572	0	113	40213227		
54514	4530	1127078	1976-08-04	1976-08-04 00:00:00	1976-09-08	1976-09-08 00:00:00	1976-09-08	38000177		0	0	35		0	0	0	301618	0	282464	1127078		
54887	4559	1127433	1950-09-21	1950-09-21 00:00:00	1950-10-05	1950-10-05 00:00:00	1950-10-05	38000177		0	0	14		0	0	0	303734	0	313782	1127433		
14696	318	40213227	2004-05-10	2004-05-10 00:00:00	2004-05-10	2004-05-10 00:00:00	2004-05-10	581452		0	0	0		0	0	0	21097	0	113	40213227		
2502	199	19059056	1942-04-27	1942-04-27 00:00:00	1942-05-11	1942-05-11 00:00:00	1942-05-11	38000177		0	0	14		0	0	0	13657	0	243670	19059056		
19907	1634	40220960	2016-03-11	2016-03-11 00:00:00	2016-03-11	2016-03-11 00:00:00	2016-03-11	38000177		0	0	0		0	0	0	109691	0	1804799	40220960		
2609	209	40220960	1992-07-31	1992-07-31 00:00:00	1992-07-31	1992-07-31 00:00:00	1992-07-31	38000177		0	0	0		0	0	0	14215	0	1804799	40220960		
203423	4466	40213160	1972-03-10	1972-03-10 00:00:00	1972-03-10	1972-03-10 00:00:00	1972-03-10	581452		0	0	0		0	0	0	297119	0	10	40213160		
33182	2750	19133873	1928-12-03	1928-12-03 00:00:00	1928-12-14	1928-12-14 00:00:00	1928-12-14	38000177		0	0	11		0	0	0	181942	0	834061	19133873		
46759	3874	19112599	1984-01-13	1984-01-13 00:00:00	1984-01-13	1984-01-13 00:00:00	\N	38000177		0	0	0		0	0	0	257306	0	477045	19112599		
43213	3580	19075001	1983-05-22	1983-05-22 00:00:00	1983-06-05	1983-06-05 00:00:00	1983-06-05	38000177		0	0	14		0	0	0	238010	0	309097	19075001		
26898	2217	19133873	1983-08-11	1983-08-11 00:00:00	1983-08-22	1983-08-22 00:00:00	1983-08-22	38000177		0	0	11		0	0	0	147667	0	834061	19133873		
57355	4759	40165015	1989-06-16	1989-06-16 00:00:00	1989-06-16	1989-06-16 00:00:00	\N	38000177		0	0	0		0	0	0	317119	0	861467	40165015		
34560	2857	1127078	1967-08-24	1967-08-24 00:00:00	1967-09-07	1967-09-07 00:00:00	1967-09-07	38000177		0	0	14		0	0	0	189669	0	282464	1127078		
34591	2859	1713671	1995-02-20	1995-02-20 00:00:00	1995-03-06	1995-03-06 00:00:00	1995-03-06	38000177		0	0	14		0	0	0	190064	0	562251	1713671		
42375	923	40213227	2009-11-18	2009-11-18 00:00:00	2009-11-18	2009-11-18 00:00:00	2009-11-18	581452		0	0	0		0	0	0	61429	0	113	40213227		
51775	4304	1118084	2002-02-19	2002-02-19 00:00:00	2002-02-19	2002-02-19 00:00:00	\N	38000177		0	0	0		0	0	0	285508	0	00025152531	44923712		
9844	825	19059056	1972-08-13	1972-08-13 00:00:00	1972-08-27	1972-08-27 00:00:00	1972-08-27	38000177		0	0	14		0	0	0	54646	0	243670	19059056		
27248	2250	1127433	2007-10-14	2007-10-14 00:00:00	2007-10-28	2007-10-28 00:00:00	2007-10-28	38000177		0	0	14		0	0	0	149665	0	313782	1127433		
48209	3996	19078461	1983-05-19	1983-05-19 00:00:00	1983-06-09	1983-06-09 00:00:00	1983-06-09	38000177		0	0	21		0	0	0	265652	0	310965	19078461		
32723	2711	1118084	1989-09-04	1989-09-04 00:00:00	1989-09-04	1989-09-04 00:00:00	\N	38000177		0	0	0		0	0	0	179626	0	00025152531	44923712		
25653	2109	19059056	1971-02-16	1971-02-16 00:00:00	1971-03-02	1971-03-02 00:00:00	1971-03-02	38000177		0	0	14		0	0	0	140408	0	243670	19059056		
10862	905	1127433	2007-11-01	2007-11-01 00:00:00	2007-12-06	2007-12-06 00:00:00	2007-12-06	38000177		0	0	35		0	0	0	60195	0	313782	1127433		
16917	1401	19128065	1991-01-04	1991-01-04 00:00:00	1991-12-30	1991-12-30 00:00:00	1991-12-30	38000177		0	0	360		0	0	0	93169	0	749882	19128065		
42774	933	40213314	1977-09-06	1977-09-06 00:00:00	1977-09-06	1977-09-06 00:00:00	1977-09-06	581452		0	0	0		0	0	0	62086	0	49	40213314		
76652	1674	40213227	2000-05-15	2000-05-15 00:00:00	2000-05-15	2000-05-15 00:00:00	2000-05-15	581452		0	0	0		0	0	0	112347	0	113	40213227		
233768	5137	40213160	1967-09-27	1967-09-27 00:00:00	1967-09-27	1967-09-27 00:00:00	1967-09-27	581452		0	0	0		0	0	0	341435	0	10	40213160		
111981	2460	40213314	1985-01-16	1985-01-16 00:00:00	1985-01-16	1985-01-16 00:00:00	1985-01-16	581452		0	0	0		0	0	0	163079	0	49	40213314		
1582	35	40213160	1960-06-28	1960-06-28 00:00:00	1960-06-28	1960-06-28 00:00:00	1960-06-28	581452		0	0	0		0	0	0	2400	0	10	40213160		
49489	4105	1127433	1993-06-20	1993-06-20 00:00:00	1993-07-04	1993-07-04 00:00:00	1993-07-04	38000177		0	0	14		0	0	0	272710	0	313782	1127433		
54107	4496	19133873	1953-10-08	1953-10-08 00:00:00	1953-10-20	1953-10-20 00:00:00	1953-10-20	38000177		0	0	12		0	0	0	299309	0	834061	19133873		
30612	2540	19006318	1950-11-30	1950-11-30 00:00:00	1950-12-14	1950-12-14 00:00:00	1950-12-14	38000177		0	0	14		0	0	0	167925	0	105078	19006318		
102651	2250	40213227	1998-03-18	1998-03-18 00:00:00	1998-03-18	1998-03-18 00:00:00	1998-03-18	581452		0	0	0		0	0	0	149643	0	113	40213227		
42745	3542	19078461	2009-05-18	2009-05-18 00:00:00	2009-06-08	2009-06-08 00:00:00	2009-06-08	38000177		0	0	21		0	0	0	235325	0	310965	19078461		
37791	3123	1519937	2008-04-04	2008-04-04 00:00:00	2009-03-30	2009-03-30 00:00:00	2009-03-30	38000177		0	0	360		0	0	0	207849	0	389221	1519937		
62958	5232	19133905	1989-04-14	1989-04-14 00:00:00	1989-04-27	1989-04-27 00:00:00	1989-04-27	38000177		0	0	13		0	0	0	348083	0	834102	19133905		
51075	1118	40213227	2016-03-06	2016-03-06 00:00:00	2016-03-06	2016-03-06 00:00:00	2016-03-06	581452		0	0	0		0	0	0	73742	0	113	40213227		
20836	1718	19133873	1982-11-23	1982-11-23 00:00:00	1982-12-05	1982-12-05 00:00:00	1982-12-05	38000177		0	0	12		0	0	0	114850	0	834061	19133873		
43127	3573	1713671	1949-06-04	1949-06-04 00:00:00	1949-06-25	1949-06-25 00:00:00	1949-06-25	38000177		0	0	21		0	0	0	237519	0	562251	1713671		
53638	4457	19078461	1999-09-27	1999-09-27 00:00:00	1999-11-26	1999-11-26 00:00:00	1999-11-26	38000177		0	0	60		0	0	0	296639	0	310965	19078461		
173619	3817	40213227	2016-08-19	2016-08-19 00:00:00	2016-08-19	2016-08-19 00:00:00	2016-08-19	581452		0	0	0		0	0	0	253484	0	113	40213227		
2146	171	19019979	1979-09-10	1979-09-10 00:00:00	1979-10-10	1979-10-10 00:00:00	1979-10-10	38000177		0	0	30		0	0	0	11608	0	198405	19019979		
63837	5302	19128065	1988-08-14	1988-08-14 00:00:00	1989-08-09	1989-08-09 00:00:00	1989-08-09	38000177		0	0	360		0	0	0	352816	0	749882	19128065		
46040	3814	1127433	1988-10-29	1988-10-29 00:00:00	1988-11-05	1988-11-05 00:00:00	1988-11-05	38000177		0	0	7		0	0	0	253363	0	313782	1127433		
46098	3820	19133873	1968-07-05	1968-07-05 00:00:00	1968-07-12	1968-07-12 00:00:00	1968-07-12	38000177		0	0	7		0	0	0	253657	0	834061	19133873		
44975	3720	1713671	1971-12-11	1971-12-11 00:00:00	1971-12-25	1971-12-25 00:00:00	1971-12-25	38000177		0	0	14		0	0	0	247242	0	562251	1713671		
55492	4608	1713671	2008-09-25	2008-09-25 00:00:00	2008-10-02	2008-10-02 00:00:00	2008-10-02	38000177		0	0	7		0	0	0	307008	0	562251	1713671		
6231	135	40213306	1993-08-17	1993-08-17 00:00:00	1993-08-17	1993-08-17 00:00:00	1993-08-17	581452		0	0	0		0	0	0	9057	0	43	40213306		
1795	144	46233988	1977-02-07	1977-02-07 00:00:00	1977-02-21	1977-02-21 00:00:00	1977-02-21	38000177		0	0	14		0	0	0	9634	0	1652673	46233988		
207877	4560	40213260	2018-06-13	2018-06-13 00:00:00	2018-06-13	2018-06-13 00:00:00	2018-06-13	581452		0	0	0		0	0	0	303842	0	121	40213260		
60643	5044	1332419	2010-02-03	2010-02-03 00:00:00	2010-02-03	2010-02-03 00:00:00	\N	38000177		0	0	0		0	0	0	335206	0	197361	1332419		
4539	377	19133873	1970-09-18	1970-09-18 00:00:00	1970-09-30	1970-09-30 00:00:00	1970-09-30	38000177		0	0	12		0	0	0	24955	0	834061	19133873		
55945	4643	19133905	1994-06-20	1994-06-20 00:00:00	1994-07-02	1994-07-02 00:00:00	1994-07-02	38000177		0	0	12		0	0	0	309596	0	834102	19133905		
47387	3928	19133905	2006-06-02	2006-06-02 00:00:00	2006-06-14	2006-06-14 00:00:00	2006-06-14	38000177		0	0	12		0	0	0	261137	0	834102	19133905		
37440	3093	1127078	1981-02-24	1981-02-24 00:00:00	1981-03-10	1981-03-10 00:00:00	1981-03-10	38000177		0	0	14		0	0	0	205971	0	282464	1127078		
56582	4694	40236824	2015-08-29	2015-08-29 00:00:00	2015-09-05	2015-09-05 00:00:00	2015-09-05	38000177		0	0	7		0	0	0	312677	0	1094107	40236824		
54148	4500	19078461	2011-06-19	2011-06-19 00:00:00	2011-07-24	2011-07-24 00:00:00	2011-07-24	38000177		0	0	35		0	0	0	299608	0	310965	19078461		
174357	3834	40213160	1955-12-25	1955-12-25 00:00:00	1955-12-25	1955-12-25 00:00:00	1955-12-25	581452		0	0	0		0	0	0	254609	0	10	40213160		
20239	440	40213160	1973-03-21	1973-03-21 00:00:00	1973-03-21	1973-03-21 00:00:00	1973-03-21	581452		0	0	0		0	0	0	29202	0	10	40213160		
5425	454	1127433	1992-12-17	1992-12-17 00:00:00	1992-12-31	1992-12-31 00:00:00	1992-12-31	38000177		0	0	14		0	0	0	30352	0	313782	1127433		
71629	1566	40213227	1992-06-27	1992-06-27 00:00:00	1992-06-27	1992-06-27 00:00:00	1992-06-27	581452		0	0	0		0	0	0	\N	0	113	40213227		
47611	1039	40213160	1960-06-25	1960-06-25 00:00:00	1960-06-25	1960-06-25 00:00:00	1960-06-25	581452		0	0	0		0	0	0	68386	0	10	40213160		
105456	2314	40213296	1995-12-30	1995-12-30 00:00:00	1995-12-30	1995-12-30 00:00:00	1995-12-30	581452		0	0	0		0	0	0	153914	0	52	40213296		
18853	1558	35605482	1962-06-14	1962-06-14 00:00:00	1962-06-14	1962-06-14 00:00:00	1962-06-14	38000177		0	0	0		0	0	0	104301	0	1740467	35605482		
26752	582	40213160	1959-06-10	1959-06-10 00:00:00	1959-06-10	1959-06-10 00:00:00	1959-06-10	581452		0	0	0		0	0	0	38534	0	10	40213160		
54515	4530	1115171	2008-09-20	2008-09-20 00:00:00	2008-10-04	2008-10-04 00:00:00	2008-10-04	38000177		0	0	14		0	0	0	301621	0	849574	1115171		
54889	4559	19059056	1947-03-09	1947-03-09 00:00:00	1947-03-23	1947-03-23 00:00:00	1947-03-23	38000177		0	0	14		0	0	0	303803	0	243670	19059056		
14702	318	40213296	1997-05-19	1997-05-19 00:00:00	1997-05-19	1997-05-19 00:00:00	1997-05-19	581452		0	0	0		0	0	0	21096	0	52	40213296		
2503	199	40229134	1954-01-27	1954-01-27 00:00:00	1954-02-10	1954-02-10 00:00:00	1954-02-10	38000177		0	0	14		0	0	0	13678	0	1043400	40229134		
19908	1634	19075601	2016-03-11	2016-03-11 00:00:00	2016-03-11	2016-03-11 00:00:00	2016-03-11	38000177		0	0	0		0	0	0	109691	0	309362	19075601		
2610	209	19075001	1992-04-18	1992-04-18 00:00:00	1992-05-02	1992-05-02 00:00:00	1992-05-02	38000177		0	0	14		0	0	0	14215	0	309097	19075001		
203425	4466	40213296	2015-08-21	2015-08-21 00:00:00	2015-08-21	2015-08-21 00:00:00	2015-08-21	581452		0	0	0		0	0	0	297130	0	52	40213296		
33183	2750	1127433	1983-01-21	1983-01-21 00:00:00	1983-02-04	1983-02-04 00:00:00	1983-02-04	38000177		0	0	14		0	0	0	181933	0	313782	1127433		
46760	3874	19133905	2016-06-09	2016-06-09 00:00:00	2016-06-16	2016-06-16 00:00:00	2016-06-16	38000177		0	0	7		0	0	0	257288	0	834102	19133905		
43214	3580	1127433	2003-02-25	2003-02-25 00:00:00	2003-03-04	2003-03-04 00:00:00	2003-03-04	38000177		0	0	7		0	0	0	238000	0	313782	1127433		
26899	2217	42902245	2001-05-14	2001-05-14 00:00:00	2002-05-09	2002-05-09 00:00:00	2002-05-09	38000177		0	0	360		0	0	0	147690	0	1359133	42902245		
57356	4759	19059056	1989-06-16	1989-06-16 00:00:00	1989-09-14	1989-09-14 00:00:00	1989-09-14	38000177		0	0	90		0	0	0	317119	0	243670	19059056		
34561	2857	1127433	1987-07-08	1987-07-08 00:00:00	1987-10-06	1987-10-06 00:00:00	1987-10-06	38000177		0	0	90		0	0	0	189699	0	313782	1127433		
34592	2859	1127433	1966-01-17	1966-01-17 00:00:00	1966-01-31	1966-01-31 00:00:00	1966-01-31	38000177		0	0	14		0	0	0	190060	0	313782	1127433		
42376	923	40213260	2009-11-18	2009-11-18 00:00:00	2009-11-18	2009-11-18 00:00:00	2009-11-18	581452		0	0	0		0	0	0	61429	0	121	40213260		
51776	4304	1127433	1988-05-03	1988-05-03 00:00:00	1988-05-17	1988-05-17 00:00:00	1988-05-17	38000177		0	0	14		0	0	0	285458	0	313782	1127433		
9845	825	46233988	1971-08-18	1971-08-18 00:00:00	1971-09-01	1971-09-01 00:00:00	1971-09-01	38000177		0	0	14		0	0	0	54668	0	1652673	46233988		
27249	2250	1127433	1973-02-11	1973-02-11 00:00:00	1973-02-18	1973-02-18 00:00:00	1973-02-18	38000177		0	0	7		0	0	0	149695	0	313782	1127433		
48210	3996	19059056	1976-09-01	1976-09-01 00:00:00	1976-09-22	1976-09-22 00:00:00	1976-09-22	38000177		0	0	21		0	0	0	265651	0	243670	19059056		
32724	2711	19008572	2019-06-11	2019-06-11 00:00:00	2019-06-25	2019-06-25 00:00:00	2019-06-25	38000177		0	0	14		0	0	0	179782	0	106258	19008572		
25654	2109	46233988	1971-02-16	1971-02-16 00:00:00	1971-03-02	1971-03-02 00:00:00	1971-03-02	38000177		0	0	14		0	0	0	140408	0	1652673	46233988		
10867	905	1127433	1973-01-30	1973-01-30 00:00:00	1973-02-13	1973-02-13 00:00:00	1973-02-13	38000177		0	0	14		0	0	0	60148	0	313782	1127433		
16918	1401	1127433	1987-03-14	1987-03-14 00:00:00	1987-05-13	1987-05-13 00:00:00	1987-05-13	38000177		0	0	60		0	0	0	93178	0	313782	1127433		
42777	933	40213160	1977-09-06	1977-09-06 00:00:00	1977-09-06	1977-09-06 00:00:00	1977-09-06	581452		0	0	0		0	0	0	62086	0	10	40213160		
76653	1674	40213306	2000-05-15	2000-05-15 00:00:00	2000-05-15	2000-05-15 00:00:00	2000-05-15	581452		0	0	0		0	0	0	112347	0	43	40213306		
233772	5137	40213296	2007-09-26	2007-09-26 00:00:00	2007-09-26	2007-09-26 00:00:00	2007-09-26	581452		0	0	0		0	0	0	341391	0	52	40213296		
111982	2460	40213160	1985-01-16	1985-01-16 00:00:00	1985-01-16	1985-01-16 00:00:00	1985-01-16	581452		0	0	0		0	0	0	163079	0	10	40213160		
1588	35	40213160	1960-11-29	1960-11-29 00:00:00	1960-11-29	1960-11-29 00:00:00	1960-11-29	581452		0	0	0		0	0	0	2401	0	10	40213160		
49490	4105	1713671	1977-04-26	1977-04-26 00:00:00	1977-05-10	1977-05-10 00:00:00	1977-05-10	38000177		0	0	14		0	0	0	272721	0	562251	1713671		
54108	4496	19059056	1960-12-29	1960-12-29 00:00:00	1961-01-19	1961-01-19 00:00:00	1961-01-19	38000177		0	0	21		0	0	0	299305	0	243670	19059056		
30613	2540	1115171	1996-11-04	1996-11-04 00:00:00	1996-11-25	1996-11-25 00:00:00	1996-11-25	38000177		0	0	21		0	0	0	167989	0	849574	1115171		
102652	2250	40213296	1998-03-18	1998-03-18 00:00:00	1998-03-18	1998-03-18 00:00:00	1998-03-18	581452		0	0	0		0	0	0	149643	0	52	40213296		
42746	3542	1713671	1993-02-08	1993-02-08 00:00:00	1993-02-15	1993-02-15 00:00:00	1993-02-15	38000177		0	0	7		0	0	0	235259	0	562251	1713671		
37792	3123	1713671	2017-06-14	2017-06-14 00:00:00	2017-06-28	2017-06-28 00:00:00	2017-06-28	38000177		0	0	14		0	0	0	207838	0	562251	1713671		
62959	5232	1127078	1976-07-21	1976-07-21 00:00:00	1976-08-20	1976-08-20 00:00:00	1976-08-20	38000177		0	0	30		0	0	0	348066	0	282464	1127078		
140883	3093	40213296	2015-03-21	2015-03-21 00:00:00	2015-03-21	2015-03-21 00:00:00	2015-03-21	581452		0	0	0		0	0	0	205927	0	52	40213296		
20837	1718	1127433	2006-02-19	2006-02-19 00:00:00	2006-03-12	2006-03-12 00:00:00	2006-03-12	38000177		0	0	21		0	0	0	114854	0	313782	1127433		
43128	3573	40173590	2003-10-18	2003-10-18 00:00:00	2003-10-18	2003-10-18 00:00:00	\N	38000177		0	0	0		0	0	0	237525	0	904419	40173590		
53639	4457	40162522	1999-09-27	1999-09-27 00:00:00	1999-09-27	1999-09-27 00:00:00	\N	38000177		0	0	0		0	0	0	296639	0	857005	40162522		
173620	3817	40213227	1995-12-08	1995-12-08 00:00:00	1995-12-08	1995-12-08 00:00:00	1995-12-08	581452		0	0	0		0	0	0	253481	0	113	40213227		
2147	171	1713671	1988-05-31	1988-05-31 00:00:00	1988-06-14	1988-06-14 00:00:00	1988-06-14	38000177		0	0	14		0	0	0	11617	0	562251	1713671		
63838	5302	19133873	1989-01-15	1989-01-15 00:00:00	1989-01-26	1989-01-26 00:00:00	1989-01-26	38000177		0	0	11		0	0	0	352811	0	834061	19133873		
46041	3814	1127433	1987-06-26	1987-06-26 00:00:00	1987-08-25	1987-08-25 00:00:00	1987-08-25	38000177		0	0	60		0	0	0	253313	0	313782	1127433		
46099	3820	1127433	1998-03-07	1998-03-07 00:00:00	1998-03-21	1998-03-21 00:00:00	1998-03-21	38000177		0	0	14		0	0	0	253653	0	313782	1127433		
44976	3721	1713671	2001-10-03	2001-10-03 00:00:00	2001-10-17	2001-10-17 00:00:00	2001-10-17	38000177		0	0	14		0	0	0	247335	0	562251	1713671		
55493	4608	40162522	1987-10-15	1987-10-15 00:00:00	1987-10-15	1987-10-15 00:00:00	\N	38000177		0	0	0		0	0	0	306947	0	857005	40162522		
17544	379	40213314	1977-09-03	1977-09-03 00:00:00	1977-09-03	1977-09-03 00:00:00	1977-09-03	581452		0	0	0		0	0	0	25078	0	49	40213314		
1796	144	19128022	1996-11-04	1996-11-04 00:00:00	1997-10-30	1997-10-30 00:00:00	1997-10-30	38000177		0	0	360		0	0	0	9665	0	749785	19128022		
207880	4560	40213160	1968-02-07	1968-02-07 00:00:00	1968-02-07	1968-02-07 00:00:00	1968-02-07	581452		0	0	0		0	0	0	303853	0	10	40213160		
60644	5044	1539411	2010-02-03	2010-02-03 00:00:00	2010-02-03	2010-02-03 00:00:00	\N	38000177		0	0	0		0	0	0	335206	0	312961	1539411		
4540	377	46275916	1996-11-07	1996-11-07 00:00:00	1996-11-07	1996-11-07 00:00:00	1996-11-07	38000177		0	0	0		0	0	0	24997	0	1660014	46275916		
55946	4644	1539411	1993-11-25	1993-11-25 00:00:00	1993-11-25	1993-11-25 00:00:00	\N	38000177		0	0	0		0	0	0	309633	0	312961	1539411		
47388	3928	1127078	1982-09-24	1982-09-24 00:00:00	1982-10-08	1982-10-08 00:00:00	1982-10-08	38000177		0	0	14		0	0	0	261114	0	282464	1127078		
37453	3096	19128065	1977-12-18	1977-12-18 00:00:00	1978-12-13	1978-12-13 00:00:00	1978-12-13	38000177		0	0	360		0	0	0	206073	0	749882	19128065		
5199	437	1713671	1959-11-10	1959-11-10 00:00:00	1959-11-17	1959-11-17 00:00:00	1959-11-17	38000177		0	0	7		0	0	0	29009	0	562251	1713671		
54149	4500	1118084	1997-05-22	1997-05-22 00:00:00	1997-05-22	1997-05-22 00:00:00	\N	38000177		0	0	0		0	0	0	299591	0	00025152531	44923712		
174359	3834	40213227	2017-06-18	2017-06-18 00:00:00	2017-06-18	2017-06-18 00:00:00	2017-06-18	581452		0	0	0		0	0	0	254565	0	113	40213227		
20243	440	40213227	2014-04-09	2014-04-09 00:00:00	2014-04-09	2014-04-09 00:00:00	2014-04-09	581452		0	0	0		0	0	0	29168	0	113	40213227		
5426	454	1127433	1999-02-06	1999-02-06 00:00:00	1999-02-20	1999-02-20 00:00:00	1999-02-20	38000177		0	0	14		0	0	0	30285	0	313782	1127433		
71632	1566	40213260	2017-11-04	2017-11-04 00:00:00	2017-11-04	2017-11-04 00:00:00	2017-11-04	581452		0	0	0		0	0	0	105022	0	121	40213260		
47614	1039	40213306	1982-05-22	1982-05-22 00:00:00	1982-05-22	1982-05-22 00:00:00	1982-05-22	581452		0	0	0		0	0	0	68366	0	43	40213306		
1307	102	1127078	1983-06-28	1983-06-28 00:00:00	1983-08-02	1983-08-02 00:00:00	1983-08-02	38000177		0	0	35		0	0	0	6978	0	282464	1127078		
18854	1558	19078219	1962-06-14	1962-06-14 00:00:00	1962-06-14	1962-06-14 00:00:00	1962-06-14	38000177		0	0	0		0	0	0	104301	0	56795	19078219		
26755	582	40213296	2001-03-14	2001-03-14 00:00:00	2001-03-14	2001-03-14 00:00:00	2001-03-14	581452		0	0	0		0	0	0	38540	0	52	40213296		
54516	4530	1118084	2008-11-29	2008-11-29 00:00:00	2008-11-29	2008-11-29 00:00:00	\N	38000177		0	0	0		0	0	0	301621	0	00025152531	44923712		
54890	4559	1713671	2009-05-18	2009-05-18 00:00:00	2009-06-08	2009-06-08 00:00:00	2009-06-08	38000177		0	0	21		0	0	0	303794	0	562251	1713671		
14706	318	40213160	1956-04-09	1956-04-09 00:00:00	1956-04-09	1956-04-09 00:00:00	1956-04-09	581452		0	0	0		0	0	0	21052	0	10	40213160		
2504	199	920300	2003-05-06	2003-05-06 00:00:00	2003-05-13	2003-05-13 00:00:00	2003-05-13	38000177		0	0	7		0	0	0	13648	0	311989	920300		
19909	1634	19059056	1939-03-08	1939-03-08 00:00:00	1939-03-22	1939-03-22 00:00:00	1939-03-22	38000177		0	0	14		0	0	0	109708	0	243670	19059056		
2611	209	1127433	1992-04-18	1992-04-18 00:00:00	1992-05-02	1992-05-02 00:00:00	1992-05-02	38000177		0	0	14		0	0	0	14215	0	313782	1127433		
203427	4466	40213160	1972-06-09	1972-06-09 00:00:00	1972-06-09	1972-06-09 00:00:00	1972-06-09	581452		0	0	0		0	0	0	297132	0	10	40213160		
33184	2750	40222846	2009-06-28	2009-06-28 00:00:00	2009-06-28	2009-06-28 00:00:00	\N	38000177		0	0	0		0	0	0	181924	0	996740	40222846		
46761	3874	19133873	1986-06-14	1986-06-14 00:00:00	1986-06-23	1986-06-23 00:00:00	1986-06-23	38000177		0	0	9		0	0	0	257238	0	834061	19133873		
43215	3580	1127433	1986-03-13	1986-03-13 00:00:00	1986-03-27	1986-03-27 00:00:00	1986-03-27	38000177		0	0	14		0	0	0	238001	0	313782	1127433		
26900	2217	19128065	1994-06-20	1994-06-20 00:00:00	1995-06-15	1995-06-15 00:00:00	1995-06-15	38000177		0	0	360		0	0	0	147658	0	749882	19128065		
57358	4759	19019979	1985-05-08	1985-05-08 00:00:00	1985-06-07	1985-06-07 00:00:00	1985-06-07	38000177		0	0	30		0	0	0	317118	0	198405	19019979		
34562	2858	19133873	1918-05-20	1918-05-20 00:00:00	1918-05-30	1918-05-30 00:00:00	1918-05-30	38000177		0	0	10		0	0	0	189822	0	834061	19133873		
34593	2859	19006318	1955-12-25	1955-12-25 00:00:00	1956-01-08	1956-01-08 00:00:00	1956-01-08	38000177		0	0	14		0	0	0	189967	0	105078	19006318		
222467	4883	40213201	2012-04-20	2012-04-20 00:00:00	2012-04-20	2012-04-20 00:00:00	2012-04-20	581452		0	0	0		0	0	0	324675	0	33	40213201		
51777	4304	19133905	1996-05-24	1996-05-24 00:00:00	1996-06-03	1996-06-03 00:00:00	1996-06-03	38000177		0	0	10		0	0	0	285519	0	834102	19133905		
9846	825	19059056	1971-08-18	1971-08-18 00:00:00	1971-09-01	1971-09-01 00:00:00	1971-09-01	38000177		0	0	14		0	0	0	54668	0	243670	19059056		
27269	2256	19128065	1999-06-30	1999-06-30 00:00:00	2000-06-24	2000-06-24 00:00:00	2000-06-24	38000177		0	0	360		0	0	0	149956	0	749882	19128065		
48211	3997	19077344	2018-11-08	2018-11-08 00:00:00	2018-11-08	2018-11-08 00:00:00	\N	38000177		0	0	0		0	0	0	265735	0	310325	19077344		
32725	2711	19134077	2019-06-11	2019-06-11 00:00:00	2019-06-25	2019-06-25 00:00:00	2019-06-25	38000177		0	0	14		0	0	0	179782	0	835900	19134077		
25655	2109	1127433	1985-06-23	1985-06-23 00:00:00	1985-07-07	1985-07-07 00:00:00	1985-07-07	38000177		0	0	14		0	0	0	140425	0	313782	1127433		
10868	905	19073188	1989-01-16	1989-01-16 00:00:00	1989-01-30	1989-01-30 00:00:00	1989-01-30	38000177		0	0	14		0	0	0	60217	0	308192	19073188		
16919	1401	40162522	1987-03-14	1987-03-14 00:00:00	1987-03-14	1987-03-14 00:00:00	\N	38000177		0	0	0		0	0	0	93178	0	857005	40162522		
42780	933	40213160	1973-03-06	1973-03-06 00:00:00	1973-03-06	1973-03-06 00:00:00	1973-03-06	581452		0	0	0		0	0	0	62075	0	10	40213160		
76658	1674	40213306	1997-05-12	1997-05-12 00:00:00	1997-05-12	1997-05-12 00:00:00	1997-05-12	581452		0	0	0		0	0	0	112367	0	43	40213306		
233774	5137	40213227	2008-07-23	2008-07-23 00:00:00	2008-07-23	2008-07-23 00:00:00	2008-07-23	581452		0	0	0		0	0	0	341420	0	113	40213227		
16551	1371	19133905	2009-05-22	2009-05-22 00:00:00	2009-05-29	2009-05-29 00:00:00	2009-05-29	38000177		0	0	7		0	0	0	90902	0	834102	19133905		
1591	35	40213306	1982-05-25	1982-05-25 00:00:00	1982-05-25	1982-05-25 00:00:00	1982-05-25	581452		0	0	0		0	0	0	2419	0	43	40213306		
49491	4105	19059056	1960-09-24	1960-09-24 00:00:00	1960-10-15	1960-10-15 00:00:00	1960-10-15	38000177		0	0	21		0	0	0	272706	0	243670	19059056		
54109	4497	19078461	1978-01-31	1978-01-31 00:00:00	1978-03-07	1978-03-07 00:00:00	1978-03-07	38000177		0	0	35		0	0	0	299368	0	310965	19078461		
30614	2540	19059056	1969-02-02	1969-02-02 00:00:00	1969-02-16	1969-02-16 00:00:00	1969-02-16	38000177		0	0	14		0	0	0	167997	0	243670	19059056		
102655	2250	40213227	2017-12-27	2017-12-27 00:00:00	2017-12-27	2017-12-27 00:00:00	2017-12-27	581452		0	0	0		0	0	0	149680	0	113	40213227		
42747	3542	19078461	2002-09-15	2002-09-15 00:00:00	2002-11-21	2002-11-21 00:00:00	2002-11-21	38000177		0	0	67		0	0	0	235324	0	310965	19078461		
37793	3123	1124300	2018-04-12	2018-04-12 00:00:00	2018-04-12	2018-04-12 00:00:00	\N	38000177		0	0	0		0	0	0	207838	0	00781178901	45011828		
62960	5232	19133873	1978-02-04	1978-02-04 00:00:00	1978-02-13	1978-02-13 00:00:00	1978-02-13	38000177		0	0	9		0	0	0	348096	0	834061	19133873		
140887	3093	40213160	1972-03-04	1972-03-04 00:00:00	1972-03-04	1972-03-04 00:00:00	1972-03-04	581452		0	0	0		0	0	0	205933	0	10	40213160		
20838	1718	46233988	1969-08-02	1969-08-02 00:00:00	1969-08-16	1969-08-16 00:00:00	1969-08-16	38000177		0	0	14		0	0	0	114867	0	1652673	46233988		
43129	3573	1118084	1963-09-30	1963-09-30 00:00:00	1963-09-30	1963-09-30 00:00:00	\N	38000177		0	0	0		0	0	0	237521	0	00025152531	44923712		
53640	4457	1713671	1985-01-06	1985-01-06 00:00:00	1985-01-27	1985-01-27 00:00:00	1985-01-27	38000177		0	0	21		0	0	0	296630	0	562251	1713671		
184909	4064	40213296	2003-10-20	2003-10-20 00:00:00	2003-10-20	2003-10-20 00:00:00	2003-10-20	581452		0	0	0		0	0	0	270107	0	52	40213296		
2148	171	1115171	2000-03-04	2000-03-04 00:00:00	2000-03-18	2000-03-18 00:00:00	2000-03-18	38000177		0	0	14		0	0	0	11611	0	849574	1115171		
63839	5302	19128065	1986-08-25	1986-08-25 00:00:00	1987-08-20	1987-08-20 00:00:00	1987-08-20	38000177		0	0	360		0	0	0	352815	0	749882	19128065		
46042	3814	19133873	1987-12-08	1987-12-08 00:00:00	1987-12-17	1987-12-17 00:00:00	1987-12-17	38000177		0	0	9		0	0	0	253335	0	834061	19133873		
46100	3820	19059056	1989-08-16	1989-08-16 00:00:00	1989-09-20	1989-09-20 00:00:00	1989-09-20	38000177		0	0	35		0	0	0	253652	0	243670	19059056		
44977	3721	1118084	2002-08-27	2002-08-27 00:00:00	2002-08-27	2002-08-27 00:00:00	\N	38000177		0	0	0		0	0	0	247335	0	00025152531	44923712		
55494	4608	1127433	2010-07-14	2010-07-14 00:00:00	2010-10-12	2010-10-12 00:00:00	2010-10-12	38000177		0	0	90		0	0	0	307071	0	313782	1127433		
17547	379	40213160	1980-03-08	1980-03-08 00:00:00	1980-03-08	1980-03-08 00:00:00	1980-03-08	581452		0	0	0		0	0	0	25103	0	10	40213160		
1797	144	1713671	1986-01-28	1986-01-28 00:00:00	1986-02-18	1986-02-18 00:00:00	1986-02-18	38000177		0	0	21		0	0	0	9661	0	562251	1713671		
207884	4560	40213227	2009-05-20	2009-05-20 00:00:00	2009-05-20	2009-05-20 00:00:00	2009-05-20	581452		0	0	0		0	0	0	303834	0	113	40213227		
60645	5044	19073188	2013-02-13	2013-02-13 00:00:00	2013-02-27	2013-02-27 00:00:00	2013-02-27	38000177		0	0	14		0	0	0	335218	0	308192	19073188		
4541	377	1310034	1996-11-07	1996-11-07 00:00:00	1996-11-07	1996-11-07 00:00:00	1996-11-07	38000177		0	0	0		0	0	0	24997	0	834357	1310034		
87821	1926	40213160	1970-09-19	1970-09-19 00:00:00	1970-09-19	1970-09-19 00:00:00	1970-09-19	581452		0	0	0		0	0	0	128258	0	10	40213160		
59145	1293	40213201	2006-01-31	2006-01-31 00:00:00	2006-01-31	2006-01-31 00:00:00	2006-01-31	581452		0	0	0		0	0	0	85520	0	33	40213201		
37455	3096	40171902	2011-10-02	2011-10-02 00:00:00	2011-10-02	2011-10-02 00:00:00	\N	38000177		0	0	0		0	0	0	206066	0	897718	40171902		
5200	437	19059056	1947-06-07	1947-06-07 00:00:00	1947-06-21	1947-06-21 00:00:00	1947-06-21	38000177		0	0	14		0	0	0	28982	0	243670	19059056		
54150	4500	19133905	2006-07-18	2006-07-18 00:00:00	2006-07-27	2006-07-27 00:00:00	2006-07-27	38000177		0	0	9		0	0	0	299592	0	834102	19133905		
174362	3834	40213160	1960-06-26	1960-06-26 00:00:00	1960-06-26	1960-06-26 00:00:00	1960-06-26	581452		0	0	0		0	0	0	254613	0	10	40213160		
20244	440	40213296	2014-04-09	2014-04-09 00:00:00	2014-04-09	2014-04-09 00:00:00	2014-04-09	581452		0	0	0		0	0	0	29168	0	52	40213296		
5427	454	40222846	2014-02-11	2014-02-11 00:00:00	2014-02-11	2014-02-11 00:00:00	\N	38000177		0	0	0		0	0	0	30290	0	996740	40222846		
71634	1566	40213227	2009-11-14	2009-11-14 00:00:00	2009-11-14	2009-11-14 00:00:00	2009-11-14	581452		0	0	0		0	0	0	104989	0	113	40213227		
80207	1755	40213160	1960-02-24	1960-02-24 00:00:00	1960-02-24	1960-02-24 00:00:00	1960-02-24	581452		0	0	0		0	0	0	117408	0	10	40213160		
1308	102	19059056	1991-08-20	1991-08-20 00:00:00	1991-09-24	1991-09-24 00:00:00	1991-09-24	38000177		0	0	35		0	0	0	6979	0	243670	19059056		
18855	1558	1367571	1962-06-14	1962-06-14 00:00:00	1962-06-14	1962-06-14 00:00:00	1962-06-14	38000177		0	0	0		0	0	0	104301	0	314659	19080464		
26758	582	40213227	2001-03-14	2001-03-14 00:00:00	2001-03-14	2001-03-14 00:00:00	2001-03-14	581452		0	0	0		0	0	0	38540	0	113	40213227		
54517	4531	19078461	2017-04-15	2017-04-15 00:00:00	2017-04-29	2017-04-29 00:00:00	2017-04-29	38000177		0	0	14		0	0	0	301710	0	310965	19078461		
54891	4559	1713671	2011-10-14	2011-10-14 00:00:00	2011-10-28	2011-10-28 00:00:00	2011-10-28	38000177		0	0	14		0	0	0	303778	0	562251	1713671		
52971	1158	40213251	1984-07-15	1984-07-15 00:00:00	1984-07-15	1984-07-15 00:00:00	1984-07-15	581452		0	0	0		0	0	0	76510	0	21	40213251		
2505	199	40236824	2003-05-06	2003-05-06 00:00:00	2003-05-13	2003-05-13 00:00:00	2003-05-13	38000177		0	0	7		0	0	0	13648	0	1094107	40236824		
19910	1634	45892894	2015-01-15	2015-01-15 00:00:00	2015-01-15	2015-01-15 00:00:00	\N	38000177		0	0	0		0	0	0	109797	0	1599803	45892894		
2613	209	1713671	1981-01-07	1981-01-07 00:00:00	1981-01-21	1981-01-21 00:00:00	1981-01-21	38000177		0	0	14		0	0	0	14264	0	562251	1713671		
203434	4466	40213306	1994-08-05	1994-08-05 00:00:00	1994-08-05	1994-08-05 00:00:00	1994-08-05	581452		0	0	0		0	0	0	297129	0	43	40213306		
33185	2750	1713671	1989-01-13	1989-01-13 00:00:00	1989-02-03	1989-02-03 00:00:00	1989-02-03	38000177		0	0	21		0	0	0	181947	0	562251	1713671		
46762	3874	19128022	1996-12-14	1996-12-14 00:00:00	1997-12-09	1997-12-09 00:00:00	1997-12-09	38000177		0	0	360		0	0	0	257272	0	749785	19128022		
43216	3580	40229134	2006-10-15	2006-10-15 00:00:00	2006-10-22	2006-10-22 00:00:00	2006-10-22	38000177		0	0	7		0	0	0	238004	0	1043400	40229134		
26901	2217	19128022	1995-06-15	1995-06-15 00:00:00	1996-06-09	1996-06-09 00:00:00	1996-06-09	38000177		0	0	360		0	0	0	147659	0	749785	19128022		
57359	4759	19115351	2016-01-12	2016-01-12 00:00:00	2016-09-06	2016-09-06 00:00:00	2016-09-06	38000177		0	0	238		0	0	0	317070	0	563026	19115351		
34563	2858	1713671	2005-01-25	2005-01-25 00:00:00	2005-02-01	2005-02-01 00:00:00	2005-02-01	38000177		0	0	7		0	0	0	189815	0	562251	1713671		
34594	2859	1127433	1955-12-25	1955-12-25 00:00:00	1956-01-08	1956-01-08 00:00:00	1956-01-08	38000177		0	0	14		0	0	0	189967	0	313782	1127433		
222485	4884	40213160	1973-01-27	1973-01-27 00:00:00	1973-01-27	1973-01-27 00:00:00	1973-01-27	581452		0	0	0		0	0	0	324760	0	10	40213160		
51778	4304	1127433	1993-10-30	1993-10-30 00:00:00	1993-11-06	1993-11-06 00:00:00	1993-11-06	38000177		0	0	7		0	0	0	285486	0	313782	1127433		
9847	825	1127433	1982-01-31	1982-01-31 00:00:00	1982-02-14	1982-02-14 00:00:00	1982-02-14	38000177		0	0	14		0	0	0	54691	0	313782	1127433		
27270	2256	1127433	2004-12-20	2004-12-20 00:00:00	2005-01-03	2005-01-03 00:00:00	2005-01-03	38000177		0	0	14		0	0	0	149938	0	313782	1127433		
48212	3997	1127433	2001-04-01	2001-04-01 00:00:00	2001-04-15	2001-04-15 00:00:00	2001-04-15	38000177		0	0	14		0	0	0	265740	0	313782	1127433		
32726	2711	1127433	1952-12-14	1952-12-14 00:00:00	1952-12-28	1952-12-28 00:00:00	1952-12-28	38000177		0	0	14		0	0	0	179707	0	313782	1127433		
25689	2114	1127433	2018-01-20	2018-01-20 00:00:00	2018-02-10	2018-02-10 00:00:00	2018-02-10	38000177		0	0	21		0	0	0	140686	0	313782	1127433		
10869	905	1127433	1989-01-16	1989-01-16 00:00:00	1989-01-30	1989-01-30 00:00:00	1989-01-30	38000177		0	0	14		0	0	0	60217	0	313782	1127433		
16920	1401	1713671	2002-01-27	2002-01-27 00:00:00	2002-02-17	2002-02-17 00:00:00	2002-02-17	38000177		0	0	21		0	0	0	93146	0	562251	1713671		
65332	1430	40213227	1994-11-29	1994-11-29 00:00:00	1994-11-29	1994-11-29 00:00:00	1994-11-29	581452		0	0	0		0	0	0	95105	0	113	40213227		
76666	1674	40213160	1981-09-21	1981-09-21 00:00:00	1981-09-21	1981-09-21 00:00:00	1981-09-21	581452		0	0	0		0	0	0	112398	0	10	40213160		
4477	97	40213227	1994-07-25	1994-07-25 00:00:00	1994-07-25	1994-07-25 00:00:00	1994-07-25	581452		0	0	0		0	0	0	6609	0	113	40213227		
16552	1371	19133873	1974-05-30	1974-05-30 00:00:00	1974-06-09	1974-06-09 00:00:00	1974-06-09	38000177		0	0	10		0	0	0	90913	0	834061	19133873		
171854	3778	40213227	2015-10-11	2015-10-11 00:00:00	2015-10-11	2015-10-11 00:00:00	2015-10-11	581452		0	0	0		0	0	0	251098	0	113	40213227		
49492	4105	1124300	1983-04-12	1983-04-12 00:00:00	1983-04-12	1983-04-12 00:00:00	\N	38000177		0	0	0		0	0	0	272746	0	00781178901	45011828		
54110	4497	19078461	1987-07-18	1987-07-18 00:00:00	1987-09-16	1987-09-16 00:00:00	1987-09-16	38000177		0	0	60		0	0	0	299369	0	310965	19078461		
30615	2540	19006318	1969-02-02	1969-02-02 00:00:00	1969-02-16	1969-02-16 00:00:00	1969-02-16	38000177		0	0	14		0	0	0	167997	0	105078	19006318		
102664	2250	40213160	1956-08-15	1956-08-15 00:00:00	1956-08-15	1956-08-15 00:00:00	1956-08-15	581452		0	0	0		0	0	0	149668	0	10	40213160		
42748	3542	1713671	1961-06-23	1961-06-23 00:00:00	1961-07-14	1961-07-14 00:00:00	1961-07-14	38000177		0	0	21		0	0	0	235263	0	562251	1713671		
37794	3123	1713671	1981-02-22	1981-02-22 00:00:00	1981-03-01	1981-03-01 00:00:00	1981-03-01	38000177		0	0	7		0	0	0	207806	0	562251	1713671		
62961	5232	40231925	2016-09-19	2016-09-19 00:00:00	2016-09-19	2016-09-19 00:00:00	\N	38000177		0	0	0		0	0	0	348067	0	1049221	40231925		
140892	3093	40213296	2013-03-16	2013-03-16 00:00:00	2013-03-16	2013-03-16 00:00:00	2013-03-16	581452		0	0	0		0	0	0	205939	0	52	40213296		
57151	1250	40213260	2006-04-10	2006-04-10 00:00:00	2006-04-10	2006-04-10 00:00:00	2006-04-10	581452		0	0	0		0	0	0	82358	0	121	40213260		
43130	3573	19059056	1937-03-15	1937-03-15 00:00:00	1937-03-29	1937-03-29 00:00:00	1937-03-29	38000177		0	0	14		0	0	0	237624	0	243670	19059056		
53641	4459	1118084	2005-05-29	2005-05-29 00:00:00	2005-05-29	2005-05-29 00:00:00	\N	38000177		0	0	0		0	0	0	296711	0	00025152531	44923712		
184913	4064	40213227	1994-02-21	1994-02-21 00:00:00	1994-02-21	1994-02-21 00:00:00	1994-02-21	581452		0	0	0		0	0	0	270105	0	113	40213227		
2149	171	1127433	1981-10-30	1981-10-30 00:00:00	1981-11-06	1981-11-06 00:00:00	1981-11-06	38000177		0	0	7		0	0	0	11585	0	313782	1127433		
63840	5302	40229134	1996-01-03	1996-01-03 00:00:00	1996-01-17	1996-01-17 00:00:00	1996-01-17	38000177		0	0	14		0	0	0	352789	0	1043400	40229134		
46043	3814	19019979	1975-09-27	1975-09-27 00:00:00	1975-12-26	1975-12-26 00:00:00	1975-12-26	38000177		0	0	90		0	0	0	253312	0	198405	19019979		
46101	3820	1115171	2013-09-12	2013-09-12 00:00:00	2013-10-10	2013-10-10 00:00:00	2013-10-10	38000177		0	0	28		0	0	0	253655	0	849574	1115171		
44978	3721	1127433	1965-10-06	1965-10-06 00:00:00	1965-10-13	1965-10-13 00:00:00	1965-10-13	38000177		0	0	7		0	0	0	247324	0	313782	1127433		
41014	893	40213198	2019-05-06	2019-05-06 00:00:00	2019-05-06	2019-05-06 00:00:00	2019-05-06	581452		0	0	0		0	0	0	59533	0	133	40213198		
47272	3920	1713671	1986-05-03	1986-05-03 00:00:00	1986-05-10	1986-05-10 00:00:00	1986-05-10	38000177		0	0	7		0	0	0	260671	0	562251	1713671		
1798	144	19128065	1998-10-25	1998-10-25 00:00:00	1999-10-20	1999-10-20 00:00:00	1999-10-20	38000177		0	0	360		0	0	0	9666	0	749882	19128065		
207885	4560	40213296	2009-05-20	2009-05-20 00:00:00	2009-05-20	2009-05-20 00:00:00	2009-05-20	581452		0	0	0		0	0	0	303834	0	52	40213296		
60646	5044	1115171	2013-02-13	2013-02-13 00:00:00	2013-02-27	2013-02-27 00:00:00	2013-02-27	38000177		0	0	14		0	0	0	335218	0	849574	1115171		
4542	377	40243436	1996-11-07	1996-11-07 00:00:00	1996-11-07	1996-11-07 00:00:00	1996-11-07	38000177		0	0	0		0	0	0	24997	0	1190795	40243436		
87825	1926	40213160	1970-07-18	1970-07-18 00:00:00	1970-07-18	1970-07-18 00:00:00	1970-07-18	581452		0	0	0		0	0	0	128239	0	10	40213160		
59156	1294	40213314	1977-10-29	1977-10-29 00:00:00	1977-10-29	1977-10-29 00:00:00	1977-10-29	581452		0	0	0		0	0	0	85638	0	49	40213314		
37456	3096	40163554	2011-10-02	2011-10-02 00:00:00	2011-10-02	2011-10-02 00:00:00	\N	38000177		0	0	0		0	0	0	206066	0	855332	40163554		
5201	437	40236824	1978-03-01	1978-03-01 00:00:00	1978-03-15	1978-03-15 00:00:00	1978-03-15	38000177		0	0	14		0	0	0	28974	0	1094107	40236824		
54151	4500	1127433	1989-10-17	1989-10-17 00:00:00	1989-10-24	1989-10-24 00:00:00	1989-10-24	38000177		0	0	7		0	0	0	299534	0	313782	1127433		
168315	3700	40213160	1967-05-10	1967-05-10 00:00:00	1967-05-10	1967-05-10 00:00:00	1967-05-10	581452		0	0	0		0	0	0	246000	0	10	40213160		
5365	449	1713671	1999-11-09	1999-11-09 00:00:00	2000-02-29	2000-02-29 00:00:00	2000-02-29	38000177		0	0	112		0	0	0	29982	0	562251	1713671		
5428	454	40163554	2005-03-05	2005-03-05 00:00:00	2005-03-05	2005-03-05 00:00:00	\N	38000177		0	0	0		0	0	0	30329	0	855332	40163554		
71635	1566	40213296	2009-11-14	2009-11-14 00:00:00	2009-11-14	2009-11-14 00:00:00	2009-11-14	581452		0	0	0		0	0	0	104989	0	52	40213296		
80210	1755	40213260	2009-06-24	2009-06-24 00:00:00	2009-06-24	2009-06-24 00:00:00	2009-06-24	581452		0	0	0		0	0	0	117401	0	121	40213260		
1309	102	46233988	1974-01-16	1974-01-16 00:00:00	1974-01-30	1974-01-30 00:00:00	1974-01-30	38000177		0	0	14		0	0	0	6971	0	1652673	46233988		
18856	1558	19079524	1962-06-14	1962-06-14 00:00:00	1962-06-14	1962-06-14 00:00:00	1962-06-14	38000177		0	0	0		0	0	0	104301	0	313002	19079524		
26761	582	40213227	2010-04-14	2010-04-14 00:00:00	2010-04-14	2010-04-14 00:00:00	2010-04-14	581452		0	0	0		0	0	0	38551	0	113	40213227		
54518	4531	1127433	1967-12-11	1967-12-11 00:00:00	1967-12-25	1967-12-25 00:00:00	1967-12-25	38000177		0	0	14		0	0	0	301747	0	313782	1127433		
54892	4559	1127433	1965-01-27	1965-01-27 00:00:00	1965-02-10	1965-02-10 00:00:00	1965-02-10	38000177		0	0	14		0	0	0	303756	0	313782	1127433		
52973	1158	40213160	1984-07-15	1984-07-15 00:00:00	1984-07-15	1984-07-15 00:00:00	1984-07-15	581452		0	0	0		0	0	0	76510	0	10	40213160		
2506	199	40229134	1951-01-12	1951-01-12 00:00:00	1951-01-19	1951-01-19 00:00:00	1951-01-19	38000177		0	0	7		0	0	0	13637	0	1043400	40229134		
19911	1634	1713671	1959-03-28	1959-03-28 00:00:00	1959-04-04	1959-04-04 00:00:00	1959-04-04	38000177		0	0	7		0	0	0	109737	0	562251	1713671		
2614	209	1118084	1988-07-08	1988-07-08 00:00:00	1988-07-08	1988-07-08 00:00:00	\N	38000177		0	0	0		0	0	0	14284	0	00025152531	44923712		
203436	4466	40213227	1994-08-05	1994-08-05 00:00:00	1994-08-05	1994-08-05 00:00:00	1994-08-05	581452		0	0	0		0	0	0	297129	0	113	40213227		
172838	3799	40213160	1972-02-29	1972-02-29 00:00:00	1972-02-29	1972-02-29 00:00:00	1972-02-29	581452		0	0	0		0	0	0	252565	0	10	40213160		
46763	3874	1713671	1994-06-16	1994-06-16 00:00:00	1994-06-30	1994-06-30 00:00:00	1994-06-30	38000177		0	0	14		0	0	0	257212	0	562251	1713671		
43217	3580	1713671	1995-10-20	1995-10-20 00:00:00	1995-10-27	1995-10-27 00:00:00	1995-10-27	38000177		0	0	7		0	0	0	237983	0	562251	1713671		
26902	2217	40224805	1999-05-25	1999-05-25 00:00:00	2000-05-19	2000-05-19 00:00:00	2000-05-19	38000177		0	0	360		0	0	0	147687	0	1000126	40224805		
57360	4759	1127433	1979-02-06	1979-02-06 00:00:00	1979-02-13	1979-02-13 00:00:00	1979-02-13	38000177		0	0	7		0	0	0	317055	0	313782	1127433		
34564	2858	1127433	2010-05-30	2010-05-30 00:00:00	2010-06-13	2010-06-13 00:00:00	2010-06-13	38000177		0	0	14		0	0	0	189958	0	313782	1127433		
34595	2859	1713671	1982-07-04	1982-07-04 00:00:00	1982-07-25	1982-07-25 00:00:00	1982-07-25	38000177		0	0	21		0	0	0	190063	0	562251	1713671		
222487	4884	40213306	1995-11-04	1995-11-04 00:00:00	1995-11-04	1995-11-04 00:00:00	1995-11-04	581452		0	0	0		0	0	0	324773	0	43	40213306		
51779	4304	19074679	1979-10-07	1979-10-07 00:00:00	1980-03-16	1980-03-16 00:00:00	1980-03-16	38000177		0	0	161		0	0	0	285506	0	308971	19074679		
9848	825	1127433	2013-08-02	2013-08-02 00:00:00	2013-08-23	2013-08-23 00:00:00	2013-08-23	38000177		0	0	21		0	0	0	54655	0	313782	1127433		
27271	2256	19128065	1995-07-21	1995-07-21 00:00:00	1996-07-15	1996-07-15 00:00:00	1996-07-15	38000177		0	0	360		0	0	0	149953	0	749882	19128065		
48213	3997	1118084	2011-09-26	2011-09-26 00:00:00	2011-09-26	2011-09-26 00:00:00	\N	38000177		0	0	0		0	0	0	265726	0	00025152531	44923712		
32727	2711	1127433	1979-05-25	1979-05-25 00:00:00	1979-06-24	1979-06-24 00:00:00	1979-06-24	38000177		0	0	30		0	0	0	179610	0	313782	1127433		
25690	2114	1127078	1971-09-23	1971-09-23 00:00:00	1971-10-14	1971-10-14 00:00:00	1971-10-14	38000177		0	0	21		0	0	0	140681	0	282464	1127078		
10870	905	1127433	1997-10-07	1997-10-07 00:00:00	1997-10-21	1997-10-21 00:00:00	1997-10-21	38000177		0	0	14		0	0	0	60215	0	313782	1127433		
16921	1401	1713671	1977-10-13	1977-10-13 00:00:00	1977-10-27	1977-10-27 00:00:00	1977-10-27	38000177		0	0	14		0	0	0	93134	0	562251	1713671		
30080	2495	42902245	2000-08-26	2000-08-26 00:00:00	2001-08-21	2001-08-21 00:00:00	2001-08-21	38000177		0	0	360		0	0	0	165166	0	1359133	42902245		
48477	4017	40171902	1998-04-09	1998-04-09 00:00:00	1998-04-09	1998-04-09 00:00:00	\N	38000177		0	0	0		0	0	0	267002	0	897718	40171902		
63652	5290	1713671	1992-11-14	1992-11-14 00:00:00	1992-11-21	1992-11-21 00:00:00	1992-11-21	38000177		0	0	7		0	0	0	351937	0	562251	1713671		
16553	1371	1713671	1990-08-06	1990-08-06 00:00:00	1990-08-20	1990-08-20 00:00:00	1990-08-20	38000177		0	0	14		0	0	0	90914	0	562251	1713671		
171857	3778	40213260	2015-10-11	2015-10-11 00:00:00	2015-10-11	2015-10-11 00:00:00	2015-10-11	581452		0	0	0		0	0	0	251098	0	121	40213260		
49493	4105	1127433	2009-02-16	2009-02-16 00:00:00	2009-02-23	2009-02-23 00:00:00	2009-02-23	38000177		0	0	7		0	0	0	272730	0	313782	1127433		
54111	4497	19006318	1974-01-11	1974-01-11 00:00:00	1974-01-25	1974-01-25 00:00:00	1974-01-25	38000177		0	0	14		0	0	0	299387	0	105078	19006318		
30616	2540	1124300	1975-01-02	1975-01-02 00:00:00	1975-01-02	1975-01-02 00:00:00	\N	38000177		0	0	0		0	0	0	167913	0	00781178901	45011828		
102671	2250	40213227	2007-03-14	2007-03-14 00:00:00	2007-03-14	2007-03-14 00:00:00	2007-03-14	581452		0	0	0		0	0	0	149631	0	113	40213227		
42749	3542	40229134	1948-06-05	1948-06-05 00:00:00	1948-06-12	1948-06-12 00:00:00	1948-06-12	38000177		0	0	7		0	0	0	235233	0	1043400	40229134		
37795	3123	40224805	2004-04-25	2004-04-25 00:00:00	2005-04-20	2005-04-20 00:00:00	2005-04-20	38000177		0	0	360		0	0	0	207840	0	1000126	40224805		
62962	5232	19078461	2016-09-19	2016-09-19 00:00:00	2016-11-18	2016-11-18 00:00:00	2016-11-18	38000177		0	0	60		0	0	0	348067	0	310965	19078461		
140894	3093	40213227	2013-03-16	2013-03-16 00:00:00	2013-03-16	2013-03-16 00:00:00	2013-03-16	581452		0	0	0		0	0	0	205939	0	113	40213227		
114174	2509	40213227	2000-07-09	2000-07-09 00:00:00	2000-07-09	2000-07-09 00:00:00	2000-07-09	581452		0	0	0		0	0	0	166081	0	113	40213227		
43131	3573	1127433	1940-04-10	1940-04-10 00:00:00	1940-04-24	1940-04-24 00:00:00	1940-04-24	38000177		0	0	14		0	0	0	237575	0	313782	1127433		
53642	4459	1127078	1972-11-16	1972-11-16 00:00:00	1972-12-07	1972-12-07 00:00:00	1972-12-07	38000177		0	0	21		0	0	0	296732	0	282464	1127078		
64506	1411	40213260	2016-12-06	2016-12-06 00:00:00	2016-12-06	2016-12-06 00:00:00	2016-12-06	581452		0	0	0		0	0	0	93945	0	121	40213260		
2150	171	1118084	2007-12-21	2007-12-21 00:00:00	2007-12-21	2007-12-21 00:00:00	\N	38000177		0	0	0		0	0	0	11605	0	00025152531	44923712		
63841	5302	19128022	1991-07-30	1991-07-30 00:00:00	1992-07-24	1992-07-24 00:00:00	1992-07-24	38000177		0	0	360		0	0	0	352772	0	749785	19128022		
46044	3814	1127433	1977-08-19	1977-08-19 00:00:00	1977-09-02	1977-09-02 00:00:00	1977-09-02	38000177		0	0	14		0	0	0	253333	0	313782	1127433		
46102	3820	19128065	1986-10-06	1986-10-06 00:00:00	1987-10-01	1987-10-01 00:00:00	1987-10-01	38000177		0	0	360		0	0	0	253631	0	749882	19128065		
44979	3721	1127433	1978-08-28	1978-08-28 00:00:00	1978-09-11	1978-09-11 00:00:00	1978-09-11	38000177		0	0	14		0	0	0	247322	0	313782	1127433		
41017	893	40213260	2007-02-26	2007-02-26 00:00:00	2007-02-26	2007-02-26 00:00:00	2007-02-26	581452		0	0	0		0	0	0	59518	0	121	40213260		
47273	3920	1115171	2012-11-24	2012-11-24 00:00:00	2012-12-29	2012-12-29 00:00:00	2012-12-29	38000177		0	0	35		0	0	0	260686	0	849574	1115171		
1799	144	1127433	1984-01-21	1984-01-21 00:00:00	1984-01-28	1984-01-28 00:00:00	1984-01-28	38000177		0	0	7		0	0	0	9630	0	313782	1127433		
41367	3431	40169216	1964-10-16	1964-10-16 00:00:00	1964-10-16	1964-10-16 00:00:00	\N	38000177		0	0	0		0	0	0	227454	0	895994	40169216		
60647	5045	19059056	1981-04-26	1981-04-26 00:00:00	1981-05-24	1981-05-24 00:00:00	1981-05-24	38000177		0	0	28		0	0	0	335242	0	243670	19059056		
4543	377	1713671	2015-11-15	2015-11-15 00:00:00	2015-11-29	2015-11-29 00:00:00	2015-11-29	38000177		0	0	14		0	0	0	25014	0	562251	1713671		
87829	1926	40213160	1970-12-19	1970-12-19 00:00:00	1970-12-19	1970-12-19 00:00:00	1970-12-19	581452		0	0	0		0	0	0	128240	0	10	40213160		
59159	1294	40213160	1977-10-29	1977-10-29 00:00:00	1977-10-29	1977-10-29 00:00:00	1977-10-29	581452		0	0	0		0	0	0	85638	0	10	40213160		
163624	3599	40213227	2008-05-16	2008-05-16 00:00:00	2008-05-16	2008-05-16 00:00:00	2008-05-16	581452		0	0	0		0	0	0	239029	0	113	40213227		
5202	437	920300	1978-03-01	1978-03-01 00:00:00	1978-03-08	1978-03-08 00:00:00	1978-03-08	38000177		0	0	7		0	0	0	28974	0	311989	920300		
54153	4500	19078461	1984-03-16	1984-03-16 00:00:00	1984-03-30	1984-03-30 00:00:00	1984-03-30	38000177		0	0	14		0	0	0	299603	0	310965	19078461		
168320	3700	40213160	1966-12-07	1966-12-07 00:00:00	1966-12-07	1966-12-07 00:00:00	1966-12-07	581452		0	0	0		0	0	0	245952	0	10	40213160		
5366	449	43012036	1984-11-21	1984-11-21 00:00:00	1984-11-21	1984-11-21 00:00:00	\N	38000177		0	0	0		0	0	0	29904	0	1363309	43012036		
5429	454	19018935	2005-03-05	2005-03-05 00:00:00	2005-03-05	2005-03-05 00:00:00	\N	38000177		0	0	0		0	0	0	30329	0	197604	19018935		
71642	1567	40213160	1975-04-03	1975-04-03 00:00:00	1975-04-03	1975-04-03 00:00:00	1975-04-03	581452		0	0	0		0	0	0	105137	0	10	40213160		
80215	1755	40213160	1959-09-23	1959-09-23 00:00:00	1959-09-23	1959-09-23 00:00:00	1959-09-23	581452		0	0	0		0	0	0	117388	0	10	40213160		
1310	102	1127078	1974-01-16	1974-01-16 00:00:00	1974-01-30	1974-01-30 00:00:00	1974-01-30	38000177		0	0	14		0	0	0	6971	0	282464	1127078		
18857	1558	782047	1962-06-14	1962-06-14 00:00:00	1962-06-14	1962-06-14 00:00:00	1962-06-14	38000177		0	0	0		0	0	0	104301	0	542347	782047		
26762	582	40213260	2010-04-14	2010-04-14 00:00:00	2010-04-14	2010-04-14 00:00:00	2010-04-14	581452		0	0	0		0	0	0	38551	0	121	40213260		
54519	4531	19078461	1982-06-13	1982-06-13 00:00:00	1982-06-27	1982-06-27 00:00:00	1982-06-27	38000177		0	0	14		0	0	0	301706	0	310965	19078461		
54893	4559	19129655	1965-01-27	1965-01-27 00:00:00	1965-02-10	1965-02-10 00:00:00	1965-02-10	38000177		0	0	14		0	0	0	303756	0	789980	19129655		
52975	1158	40213160	1980-01-13	1980-01-13 00:00:00	1980-01-13	1980-01-13 00:00:00	1980-01-13	581452		0	0	0		0	0	0	76482	0	10	40213160		
2525	202	19133905	1989-07-02	1989-07-02 00:00:00	1989-07-13	1989-07-13 00:00:00	1989-07-13	38000177		0	0	11		0	0	0	13843	0	834102	19133905		
19912	1634	19077572	2013-08-23	2013-08-23 00:00:00	2013-08-23	2013-08-23 00:00:00	\N	38000177		0	0	0		0	0	0	109696	0	310436	19077572		
2615	209	40243436	1976-12-31	1976-12-31 00:00:00	1976-12-31	1976-12-31 00:00:00	1976-12-31	38000177		0	0	0		0	0	0	14267	0	1190795	40243436		
203437	4466	40213160	1972-01-07	1972-01-07 00:00:00	1972-01-07	1972-01-07 00:00:00	1972-01-07	581452		0	0	0		0	0	0	297131	0	10	40213160		
172841	3799	40213227	2003-10-14	2003-10-14 00:00:00	2003-10-14	2003-10-14 00:00:00	2003-10-14	581452		0	0	0		0	0	0	252551	0	113	40213227		
46764	3874	1127078	1983-08-15	1983-08-15 00:00:00	1983-08-29	1983-08-29 00:00:00	1983-08-29	38000177		0	0	14		0	0	0	257289	0	282464	1127078		
43218	3580	1127433	1986-04-10	1986-04-10 00:00:00	1986-05-01	1986-05-01 00:00:00	1986-05-01	38000177		0	0	21		0	0	0	237965	0	313782	1127433		
26903	2217	1713671	2009-11-23	2009-11-23 00:00:00	2009-12-07	2009-12-07 00:00:00	2009-12-07	38000177		0	0	14		0	0	0	147669	0	562251	1713671		
57361	4759	19019979	1979-12-01	1979-12-01 00:00:00	1980-02-29	1980-02-29 00:00:00	1980-02-29	38000177		0	0	90		0	0	0	317116	0	198405	19019979		
34565	2858	1127433	2004-11-29	2004-11-29 00:00:00	2004-12-20	2004-12-20 00:00:00	2004-12-20	38000177		0	0	21		0	0	0	189775	0	313782	1127433		
34596	2859	1713671	1955-02-16	1955-02-16 00:00:00	1955-03-09	1955-03-09 00:00:00	1955-03-09	38000177		0	0	21		0	0	0	190058	0	562251	1713671		
222492	4884	40213296	2012-10-27	2012-10-27 00:00:00	2012-10-27	2012-10-27 00:00:00	2012-10-27	581452		0	0	0		0	0	0	324774	0	52	40213296		
51780	4304	19115351	1977-09-08	1977-09-08 00:00:00	1978-05-11	1978-05-11 00:00:00	1978-05-11	38000177		0	0	245		0	0	0	285471	0	563026	19115351		
9849	825	1127433	1971-03-12	1971-03-12 00:00:00	1971-03-26	1971-03-26 00:00:00	1971-03-26	38000177		0	0	14		0	0	0	54689	0	313782	1127433		
27272	2256	1124300	2012-03-23	2012-03-23 00:00:00	2012-03-23	2012-03-23 00:00:00	\N	38000177		0	0	0		0	0	0	149935	0	00781178901	45011828		
48214	3997	40229134	1983-08-26	1983-08-26 00:00:00	1983-09-02	1983-09-02 00:00:00	1983-09-02	38000177		0	0	7		0	0	0	265738	0	1043400	40229134		
32728	2711	40229134	1972-05-18	1972-05-18 00:00:00	1972-05-25	1972-05-25 00:00:00	1972-05-25	38000177		0	0	7		0	0	0	179775	0	1043400	40229134		
25691	2114	19078461	2008-08-12	2008-08-12 00:00:00	2008-09-09	2008-09-09 00:00:00	2008-09-09	38000177		0	0	28		0	0	0	140685	0	310965	19078461		
10872	905	19074679	1976-03-06	1976-03-06 00:00:00	1976-08-14	1976-08-14 00:00:00	1976-08-14	38000177		0	0	161		0	0	0	60178	0	308971	19074679		
16922	1401	19128065	1993-12-19	1993-12-19 00:00:00	1994-12-14	1994-12-14 00:00:00	1994-12-14	38000177		0	0	360		0	0	0	93138	0	749882	19128065		
30081	2495	19128022	1994-09-27	1994-09-27 00:00:00	1995-09-22	1995-09-22 00:00:00	1995-09-22	38000177		0	0	360		0	0	0	165164	0	749785	19128022		
48478	4017	1127433	1984-03-04	1984-03-04 00:00:00	1984-03-18	1984-03-18 00:00:00	1984-03-18	38000177		0	0	14		0	0	0	266946	0	313782	1127433		
63653	5290	1127078	1956-09-21	1956-09-21 00:00:00	1956-10-05	1956-10-05 00:00:00	1956-10-05	38000177		0	0	14		0	0	0	352010	0	282464	1127078		
31361	2599	19128065	1997-01-06	1997-01-06 00:00:00	1998-01-01	1998-01-01 00:00:00	1998-01-01	38000177		0	0	360		0	0	0	171984	0	749882	19128065		
171864	3778	40213160	1965-03-14	1965-03-14 00:00:00	1965-03-14	1965-03-14 00:00:00	1965-03-14	581452		0	0	0		0	0	0	251078	0	10	40213160		
49495	4106	19059056	1960-01-09	1960-01-09 00:00:00	1960-02-06	1960-02-06 00:00:00	1960-02-06	38000177		0	0	28		0	0	0	272859	0	243670	19059056		
54112	4497	19078461	1974-01-11	1974-01-11 00:00:00	1974-01-25	1974-01-25 00:00:00	1974-01-25	38000177		0	0	14		0	0	0	299387	0	310965	19078461		
30617	2540	1127433	1985-05-31	1985-05-31 00:00:00	1985-07-05	1985-07-05 00:00:00	1985-07-05	38000177		0	0	35		0	0	0	167988	0	313782	1127433		
102672	2250	40213260	2007-03-14	2007-03-14 00:00:00	2007-03-14	2007-03-14 00:00:00	2007-03-14	581452		0	0	0		0	0	0	149631	0	121	40213260		
42750	3542	1124300	1980-08-05	1980-08-05 00:00:00	1980-08-05	1980-08-05 00:00:00	\N	38000177		0	0	0		0	0	0	235285	0	00781178901	45011828		
37796	3123	1127433	2005-01-28	2005-01-28 00:00:00	2005-02-04	2005-02-04 00:00:00	2005-02-04	38000177		0	0	7		0	0	0	207796	0	313782	1127433		
62963	5233	1118084	1998-06-25	1998-06-25 00:00:00	1998-06-25	1998-06-25 00:00:00	\N	38000177		0	0	0		0	0	0	348153	0	00025152531	44923712		
140904	3093	40213227	2002-11-30	2002-11-30 00:00:00	2002-11-30	2002-11-30 00:00:00	2002-11-30	581452		0	0	0		0	0	0	205937	0	113	40213227		
114176	2509	40213296	2009-06-14	2009-06-14 00:00:00	2009-06-14	2009-06-14 00:00:00	2009-06-14	581452		0	0	0		0	0	0	166086	0	52	40213296		
43132	3573	1127433	1957-07-12	1957-07-12 00:00:00	1957-09-10	1957-09-10 00:00:00	1957-09-10	38000177		0	0	60		0	0	0	237626	0	313782	1127433		
53643	4459	1127433	1977-12-04	1977-12-04 00:00:00	1977-12-11	1977-12-11 00:00:00	1977-12-11	38000177		0	0	7		0	0	0	296688	0	313782	1127433		
64508	1411	40213227	2016-12-06	2016-12-06 00:00:00	2016-12-06	2016-12-06 00:00:00	2016-12-06	581452		0	0	0		0	0	0	93945	0	113	40213227		
2151	171	1127433	2001-01-03	2001-01-03 00:00:00	2001-01-17	2001-01-17 00:00:00	2001-01-17	38000177		0	0	14		0	0	0	11621	0	313782	1127433		
63864	5306	1127078	1971-01-22	1971-01-22 00:00:00	1971-02-05	1971-02-05 00:00:00	1971-02-05	38000177		0	0	14		0	0	0	352939	0	282464	1127078		
46045	3814	19128065	1997-10-11	1997-10-11 00:00:00	1998-10-06	1998-10-06 00:00:00	1998-10-06	38000177		0	0	360		0	0	0	253340	0	749882	19128065		
46103	3820	1127078	1967-08-07	1967-08-07 00:00:00	1967-08-21	1967-08-21 00:00:00	1967-08-21	38000177		0	0	14		0	0	0	253620	0	282464	1127078		
44980	3721	1713671	1978-12-17	1978-12-17 00:00:00	1979-01-07	1979-01-07 00:00:00	1979-01-07	38000177		0	0	21		0	0	0	247326	0	562251	1713671		
41022	893	40213227	2005-02-14	2005-02-14 00:00:00	2005-02-14	2005-02-14 00:00:00	2005-02-14	581452		0	0	0		0	0	0	59517	0	113	40213227		
47274	3920	1118084	2011-01-09	2011-01-09 00:00:00	2011-01-09	2011-01-09 00:00:00	\N	38000177		0	0	0		0	0	0	260666	0	00025152531	44923712		
1800	144	19128065	1991-12-01	1991-12-01 00:00:00	1992-11-25	1992-11-25 00:00:00	1992-11-25	38000177		0	0	360		0	0	0	9638	0	749882	19128065		
41368	3431	40220960	2001-10-17	2001-10-17 00:00:00	2001-10-17	2001-10-17 00:00:00	2001-10-17	38000177		0	0	0		0	0	0	227443	0	1804799	40220960		
60648	5045	19133905	1999-12-08	1999-12-08 00:00:00	1999-12-20	1999-12-20 00:00:00	1999-12-20	38000177		0	0	12		0	0	0	335287	0	834102	19133905		
4545	377	1124300	2003-02-13	2003-02-13 00:00:00	2003-02-13	2003-02-13 00:00:00	\N	38000177		0	0	0		0	0	0	25013	0	00781178901	45011828		
87830	1926	40213296	2011-01-29	2011-01-29 00:00:00	2011-01-29	2011-01-29 00:00:00	2011-01-29	581452		0	0	0		0	0	0	128231	0	52	40213296		
59166	1294	40213160	1973-07-28	1973-07-28 00:00:00	1973-07-28	1973-07-28 00:00:00	1973-07-28	581452		0	0	0		0	0	0	85617	0	10	40213160		
163625	3599	40213296	2008-05-16	2008-05-16 00:00:00	2008-05-16	2008-05-16 00:00:00	2008-05-16	581452		0	0	0		0	0	0	239029	0	52	40213296		
5203	437	19059056	1960-11-25	1960-11-25 00:00:00	1960-12-09	1960-12-09 00:00:00	1960-12-09	38000177		0	0	14		0	0	0	29050	0	243670	19059056		
54154	4500	19112599	1963-10-04	1963-10-04 00:00:00	1963-10-04	1963-10-04 00:00:00	\N	38000177		0	0	0		0	0	0	299645	0	477045	19112599		
168323	3700	40213296	2006-09-06	2006-09-06 00:00:00	2006-09-06	2006-09-06 00:00:00	2006-09-06	581452		0	0	0		0	0	0	245994	0	52	40213296		
5367	449	40236824	1996-11-24	1996-11-24 00:00:00	1996-12-08	1996-12-08 00:00:00	1996-12-08	38000177		0	0	14		0	0	0	29917	0	1094107	40236824		
5430	454	40171902	2005-03-05	2005-03-05 00:00:00	2005-03-05	2005-03-05 00:00:00	\N	38000177		0	0	0		0	0	0	30329	0	897718	40171902		
71643	1567	40213314	1977-12-01	1977-12-01 00:00:00	1977-12-01	1977-12-01 00:00:00	1977-12-01	581452		0	0	0		0	0	0	105140	0	49	40213314		
80224	1755	40213227	2010-06-30	2010-06-30 00:00:00	2010-06-30	2010-06-30 00:00:00	2010-06-30	581452		0	0	0		0	0	0	117340	0	113	40213227		
1312	102	1124300	2008-12-03	2008-12-03 00:00:00	2008-12-03	2008-12-03 00:00:00	\N	38000177		0	0	0		0	0	0	6990	0	00781178901	45011828		
18858	1558	35605858	1962-06-14	1962-06-14 00:00:00	1962-06-14	1962-06-14 00:00:00	1962-06-14	38000177		0	0	0		0	0	0	104301	0	1732136	35605858		
26764	582	40213160	1959-08-12	1959-08-12 00:00:00	1959-08-12	1959-08-12 00:00:00	1959-08-12	581452		0	0	0		0	0	0	38576	0	10	40213160		
54520	4531	1127433	1924-02-26	1924-02-26 00:00:00	1924-03-11	1924-03-11 00:00:00	1924-03-11	38000177		0	0	14		0	0	0	301682	0	313782	1127433		
54894	4559	920300	2001-12-31	2001-12-31 00:00:00	2002-01-07	2002-01-07 00:00:00	2002-01-07	38000177		0	0	7		0	0	0	303738	0	311989	920300		
52976	1158	40213314	1980-01-13	1980-01-13 00:00:00	1980-01-13	1980-01-13 00:00:00	1980-01-13	581452		0	0	0		0	0	0	76482	0	49	40213314		
2526	202	45892894	2016-11-27	2016-11-27 00:00:00	2016-11-27	2016-11-27 00:00:00	\N	38000177		0	0	0		0	0	0	13813	0	1599803	45892894		
19913	1635	1713671	1993-05-29	1993-05-29 00:00:00	1993-06-26	1993-06-26 00:00:00	1993-06-26	38000177		0	0	28		0	0	0	109852	0	562251	1713671		
2616	209	46275916	1976-12-31	1976-12-31 00:00:00	1976-12-31	1976-12-31 00:00:00	1976-12-31	38000177		0	0	0		0	0	0	14267	0	1660014	46275916		
203440	4466	40213296	2013-08-16	2013-08-16 00:00:00	2013-08-16	2013-08-16 00:00:00	2013-08-16	581452		0	0	0		0	0	0	297126	0	52	40213296		
172842	3799	40213296	2012-07-24	2012-07-24 00:00:00	2012-07-24	2012-07-24 00:00:00	2012-07-24	581452		0	0	0		0	0	0	252559	0	52	40213296		
46765	3874	19074843	1983-08-15	1983-08-15 00:00:00	1983-08-29	1983-08-29 00:00:00	1983-08-29	38000177		0	0	14		0	0	0	257289	0	309045	19074843		
43219	3580	1127433	1990-05-10	1990-05-10 00:00:00	1990-05-31	1990-05-31 00:00:00	1990-05-31	38000177		0	0	21		0	0	0	237967	0	313782	1127433		
26904	2217	19128022	1998-05-30	1998-05-30 00:00:00	1999-05-25	1999-05-25 00:00:00	1999-05-25	38000177		0	0	360		0	0	0	147660	0	749785	19128022		
57362	4759	1127433	2007-06-08	2007-06-08 00:00:00	2007-06-15	2007-06-15 00:00:00	2007-06-15	38000177		0	0	7		0	0	0	317103	0	313782	1127433		
34566	2858	1124300	1953-05-26	1953-05-26 00:00:00	1953-05-26	1953-05-26 00:00:00	\N	38000177		0	0	0		0	0	0	189761	0	00781178901	45011828		
34597	2859	19133905	2005-04-08	2005-04-08 00:00:00	2005-04-17	2005-04-17 00:00:00	2005-04-17	38000177		0	0	9		0	0	0	189981	0	834102	19133905		
222495	4884	40213227	2004-09-11	2004-09-11 00:00:00	2004-09-11	2004-09-11 00:00:00	2004-09-11	581452		0	0	0		0	0	0	324809	0	113	40213227		
51782	4304	40229134	1967-05-11	1967-05-11 00:00:00	1967-05-25	1967-05-25 00:00:00	1967-05-25	38000177		0	0	14		0	0	0	285484	0	1043400	40229134		
9850	825	1127433	1976-02-05	1976-02-05 00:00:00	1976-02-19	1976-02-19 00:00:00	1976-02-19	38000177		0	0	14		0	0	0	54626	0	313782	1127433		
27273	2256	42902245	2002-06-14	2002-06-14 00:00:00	2003-06-09	2003-06-09 00:00:00	2003-06-09	38000177		0	0	360		0	0	0	149908	0	1359133	42902245		
48215	3997	1713671	2013-03-22	2013-03-22 00:00:00	2013-04-12	2013-04-12 00:00:00	2013-04-12	38000177		0	0	21		0	0	0	265733	0	562251	1713671		
32729	2711	1713671	1975-06-21	1975-06-21 00:00:00	1975-06-28	1975-06-28 00:00:00	1975-06-28	38000177		0	0	7		0	0	0	179746	0	562251	1713671		
25692	2114	1127433	1990-04-18	1990-04-18 00:00:00	1990-04-25	1990-04-25 00:00:00	1990-04-25	38000177		0	0	7		0	0	0	140671	0	313782	1127433		
10873	906	19078461	2001-10-08	2001-10-08 00:00:00	2001-10-29	2001-10-29 00:00:00	2001-10-29	38000177		0	0	21		0	0	0	60235	0	310965	19078461		
16923	1401	19128065	1987-01-25	1987-01-25 00:00:00	1988-01-20	1988-01-20 00:00:00	1988-01-20	38000177		0	0	360		0	0	0	93190	0	749882	19128065		
30082	2495	1127433	2013-12-20	2013-12-20 00:00:00	2013-12-27	2013-12-27 00:00:00	2013-12-27	38000177		0	0	7		0	0	0	165133	0	313782	1127433		
48479	4017	1124300	1963-08-13	1963-08-13 00:00:00	1963-08-13	1963-08-13 00:00:00	\N	38000177		0	0	0		0	0	0	266985	0	00781178901	45011828		
63654	5290	19006318	1956-09-21	1956-09-21 00:00:00	1956-10-05	1956-10-05 00:00:00	1956-10-05	38000177		0	0	14		0	0	0	352010	0	105078	19006318		
31362	2599	1127078	1986-08-19	1986-08-19 00:00:00	1986-09-16	1986-09-16 00:00:00	1986-09-16	38000177		0	0	28		0	0	0	171959	0	282464	1127078		
171867	3778	40213296	2005-01-30	2005-01-30 00:00:00	2005-01-30	2005-01-30 00:00:00	2005-01-30	581452		0	0	0		0	0	0	251105	0	52	40213296		
49496	4106	1127433	1991-06-05	1991-06-05 00:00:00	1991-06-12	1991-06-12 00:00:00	1991-06-12	38000177		0	0	7		0	0	0	272837	0	313782	1127433		
54113	4497	1127433	1996-04-13	1996-04-13 00:00:00	1996-04-27	1996-04-27 00:00:00	1996-04-27	38000177		0	0	14		0	0	0	299381	0	313782	1127433		
30618	2540	1127433	1971-08-23	1971-08-23 00:00:00	1971-09-06	1971-09-06 00:00:00	1971-09-06	38000177		0	0	14		0	0	0	167880	0	313782	1127433		
102674	2250	40213296	1996-03-13	1996-03-13 00:00:00	1996-03-13	1996-03-13 00:00:00	1996-03-13	581452		0	0	0		0	0	0	149647	0	52	40213296		
42751	3542	40162522	2002-09-22	2002-09-22 00:00:00	2002-09-22	2002-09-22 00:00:00	\N	38000177		0	0	0		0	0	0	235321	0	857005	40162522		
37797	3123	19073183	1982-12-26	1982-12-26 00:00:00	1983-01-09	1983-01-09 00:00:00	1983-01-09	38000177		0	0	14		0	0	0	207779	0	308182	19073183		
62964	5233	19078461	1980-04-20	1980-04-20 00:00:00	1980-07-19	1980-07-19 00:00:00	1980-07-19	38000177		0	0	90		0	0	0	348173	0	310965	19078461		
140908	3093	40213160	1976-06-05	1976-06-05 00:00:00	1976-06-05	1976-06-05 00:00:00	1976-06-05	581452		0	0	0		0	0	0	205923	0	10	40213160		
114178	2509	40213160	1969-11-16	1969-11-16 00:00:00	1969-11-16	1969-11-16 00:00:00	1969-11-16	581452		0	0	0		0	0	0	166073	0	10	40213160		
43133	3573	1713671	1957-09-05	1957-09-05 00:00:00	1957-09-19	1957-09-19 00:00:00	1957-09-19	38000177		0	0	14		0	0	0	237581	0	562251	1713671		
53644	4459	1127433	1982-05-20	1982-05-20 00:00:00	1982-06-10	1982-06-10 00:00:00	1982-06-10	38000177		0	0	21		0	0	0	296733	0	313782	1127433		
64512	1411	40213160	1966-03-08	1966-03-08 00:00:00	1966-03-08	1966-03-08 00:00:00	1966-03-08	581452		0	0	0		0	0	0	93910	0	10	40213160		
2152	171	1127433	1983-06-21	1983-06-21 00:00:00	1983-07-12	1983-07-12 00:00:00	1983-07-12	38000177		0	0	21		0	0	0	11609	0	313782	1127433		
63865	5306	19129655	1971-01-22	1971-01-22 00:00:00	1971-02-05	1971-02-05 00:00:00	1971-02-05	38000177		0	0	14		0	0	0	352939	0	789980	19129655		
46046	3814	1127433	1983-02-01	1983-02-01 00:00:00	1983-02-15	1983-02-15 00:00:00	1983-02-15	38000177		0	0	14		0	0	0	253334	0	313782	1127433		
46104	3820	19006318	1967-08-07	1967-08-07 00:00:00	1967-08-21	1967-08-21 00:00:00	1967-08-21	38000177		0	0	14		0	0	0	253620	0	105078	19006318		
44981	3721	1127433	1972-06-12	1972-06-12 00:00:00	1972-06-26	1972-06-26 00:00:00	1972-06-26	38000177		0	0	14		0	0	0	247352	0	313782	1127433		
41027	893	40213227	2015-04-13	2015-04-13 00:00:00	2015-04-13	2015-04-13 00:00:00	2015-04-13	581452		0	0	0		0	0	0	59486	0	113	40213227		
47275	3920	1127433	1999-01-16	1999-01-16 00:00:00	1999-01-30	1999-01-30 00:00:00	1999-01-30	38000177		0	0	14		0	0	0	260672	0	313782	1127433		
1801	144	19128022	1993-11-20	1993-11-20 00:00:00	1994-11-15	1994-11-15 00:00:00	1994-11-15	38000177		0	0	360		0	0	0	9664	0	749785	19128022		
41369	3431	19075601	2001-10-17	2001-10-17 00:00:00	2001-10-17	2001-10-17 00:00:00	2001-10-17	38000177		0	0	0		0	0	0	227443	0	309362	19075601		
60649	5045	19128065	1980-02-27	1980-02-27 00:00:00	1981-02-21	1981-02-21 00:00:00	1981-02-21	38000177		0	0	360		0	0	0	335264	0	749882	19128065		
4546	377	1713671	2000-12-20	2000-12-20 00:00:00	2001-01-10	2001-01-10 00:00:00	2001-01-10	38000177		0	0	21		0	0	0	25013	0	562251	1713671		
182518	4010	40213306	1999-12-02	1999-12-02 00:00:00	1999-12-02	1999-12-02 00:00:00	1999-12-02	581452		0	0	0		0	0	0	\N	0	43	40213306		
59169	1294	40213296	2014-07-26	2014-07-26 00:00:00	2014-07-26	2014-07-26 00:00:00	2014-07-26	581452		0	0	0		0	0	0	85649	0	52	40213296		
163628	3599	40213306	1989-03-03	1989-03-03 00:00:00	1989-03-03	1989-03-03 00:00:00	1989-03-03	581452		0	0	0		0	0	0	239069	0	43	40213306		
5204	437	1127433	2007-07-06	2007-07-06 00:00:00	2007-08-03	2007-08-03 00:00:00	2007-08-03	38000177		0	0	28		0	0	0	29052	0	313782	1127433		
54155	4500	46233710	1974-12-12	1974-12-12 00:00:00	1974-12-26	1974-12-26 00:00:00	1974-12-26	38000177		0	0	14		0	0	0	299587	0	1650142	46233710		
168330	3700	40213260	2016-08-31	2016-08-31 00:00:00	2016-08-31	2016-08-31 00:00:00	2016-08-31	581452		0	0	0		0	0	0	245950	0	121	40213260		
5368	449	920300	1996-11-24	1996-11-24 00:00:00	1996-12-01	1996-12-01 00:00:00	1996-12-01	38000177		0	0	7		0	0	0	29917	0	311989	920300		
5431	454	1127433	1961-08-01	1961-08-01 00:00:00	1961-08-08	1961-08-08 00:00:00	1961-08-08	38000177		0	0	7		0	0	0	30348	0	313782	1127433		
71649	1567	40213296	2017-01-26	2017-01-26 00:00:00	2017-01-26	2017-01-26 00:00:00	2017-01-26	581452		0	0	0		0	0	0	105121	0	52	40213296		
80225	1755	40213260	2010-06-30	2010-06-30 00:00:00	2010-06-30	2010-06-30 00:00:00	2010-06-30	581452		0	0	0		0	0	0	117340	0	121	40213260		
1313	102	19128065	1988-06-11	1988-06-11 00:00:00	1989-06-06	1989-06-06 00:00:00	1989-06-06	38000177		0	0	360		0	0	0	6973	0	749882	19128065		
18859	1558	40220386	1962-06-14	1962-06-14 00:00:00	1962-06-14	1962-06-14 00:00:00	1962-06-14	38000177		0	0	0		0	0	0	104301	0	1808217	40220386		
26769	582	40213260	2009-04-08	2009-04-08 00:00:00	2009-04-08	2009-04-08 00:00:00	2009-04-08	581452		0	0	0		0	0	0	38607	0	121	40213260		
54521	4531	1332419	1994-10-29	1994-10-29 00:00:00	1994-10-29	1994-10-29 00:00:00	\N	38000177		0	0	0		0	0	0	301684	0	197361	1332419		
54895	4559	40236824	2001-12-31	2001-12-31 00:00:00	2002-01-07	2002-01-07 00:00:00	2002-01-07	38000177		0	0	7		0	0	0	303738	0	1094107	40236824		
52981	1159	40213314	1981-10-03	1981-10-03 00:00:00	1981-10-03	1981-10-03 00:00:00	1981-10-03	581452		0	0	0		0	0	0	76563	0	49	40213314		
2527	202	1127433	1971-07-29	1971-07-29 00:00:00	1971-08-12	1971-08-12 00:00:00	1971-08-12	38000177		0	0	14		0	0	0	13907	0	313782	1127433		
19914	1635	1127433	2005-07-19	2005-07-19 00:00:00	2005-08-02	2005-08-02 00:00:00	2005-08-02	38000177		0	0	14		0	0	0	109854	0	313782	1127433		
2617	209	1310034	1976-12-31	1976-12-31 00:00:00	1976-12-31	1976-12-31 00:00:00	1976-12-31	38000177		0	0	0		0	0	0	14267	0	834357	1310034		
203443	4466	40213227	2013-08-16	2013-08-16 00:00:00	2013-08-16	2013-08-16 00:00:00	2013-08-16	581452		0	0	0		0	0	0	297126	0	113	40213227		
10529	877	1127078	1984-01-27	1984-01-27 00:00:00	1984-02-10	1984-02-10 00:00:00	1984-02-10	38000177		0	0	14		0	0	0	58438	0	282464	1127078		
46766	3875	1118084	2000-02-01	2000-02-01 00:00:00	2000-02-01	2000-02-01 00:00:00	\N	38000177		0	0	0		0	0	0	257373	0	00025152531	44923712		
43220	3580	1713671	2007-08-08	2007-08-08 00:00:00	2007-08-29	2007-08-29 00:00:00	2007-08-29	38000177		0	0	21		0	0	0	237972	0	562251	1713671		
26905	2217	42902245	2000-05-19	2000-05-19 00:00:00	2001-05-14	2001-05-14 00:00:00	2001-05-14	38000177		0	0	360		0	0	0	147688	0	1359133	42902245		
57363	4759	1713671	2009-03-25	2009-03-25 00:00:00	2009-04-01	2009-04-01 00:00:00	2009-04-01	38000177		0	0	7		0	0	0	317089	0	562251	1713671		
34567	2858	1713671	1978-08-09	1978-08-09 00:00:00	1978-08-23	1978-08-23 00:00:00	1978-08-23	38000177		0	0	14		0	0	0	189886	0	562251	1713671		
34598	2859	19059056	1945-01-15	1945-01-15 00:00:00	1945-01-29	1945-01-29 00:00:00	1945-01-29	38000177		0	0	14		0	0	0	189982	0	243670	19059056		
233775	5137	40213296	2008-07-23	2008-07-23 00:00:00	2008-07-23	2008-07-23 00:00:00	2008-07-23	581452		0	0	0		0	0	0	341420	0	52	40213296		
51783	4305	1127433	2019-06-12	2019-06-12 00:00:00	2019-06-12	2019-06-12 00:00:00	\N	38000177		0	0	0		0	0	0	285537	0	313782	1127433		
9851	825	1127433	1984-07-30	1984-07-30 00:00:00	1984-08-13	1984-08-13 00:00:00	1984-08-13	38000177		0	0	14		0	0	0	54653	0	313782	1127433		
27274	2256	19127904	2003-06-09	2003-06-09 00:00:00	2004-06-03	2004-06-03 00:00:00	2004-06-03	38000177		0	0	360		0	0	0	149909	0	748856	19127904		
48216	3997	19133873	1967-05-21	1967-05-21 00:00:00	1967-06-02	1967-06-02 00:00:00	1967-06-02	38000177		0	0	12		0	0	0	265774	0	834061	19133873		
32730	2711	19008572	1964-09-24	1964-09-24 00:00:00	1964-10-08	1964-10-08 00:00:00	1964-10-08	38000177		0	0	14		0	0	0	179636	0	106258	19008572		
25693	2114	1127078	1974-11-27	1974-11-27 00:00:00	1974-12-18	1974-12-18 00:00:00	1974-12-18	38000177		0	0	21		0	0	0	140682	0	282464	1127078		
10874	906	1118084	2011-09-07	2011-09-07 00:00:00	2011-09-07	2011-09-07 00:00:00	\N	38000177		0	0	0		0	0	0	60269	0	00025152531	44923712		
16924	1401	1127433	1986-03-21	1986-03-21 00:00:00	1986-04-18	1986-04-18 00:00:00	1986-04-18	38000177		0	0	28		0	0	0	93177	0	313782	1127433		
30083	2495	1124300	2015-04-10	2015-04-10 00:00:00	2015-04-10	2015-04-10 00:00:00	\N	38000177		0	0	0		0	0	0	165183	0	00781178901	45011828		
48480	4017	40231925	1934-01-24	1934-01-24 00:00:00	1934-01-24	1934-01-24 00:00:00	\N	38000177		0	0	0		0	0	0	267032	0	1049221	40231925		
63655	5290	40232448	1955-11-27	1955-11-27 00:00:00	1955-11-27	1955-11-27 00:00:00	\N	38000177		0	0	0		0	0	0	351894	0	1049630	40232448		
31363	2599	1127078	1983-01-07	1983-01-07 00:00:00	1983-02-06	1983-02-06 00:00:00	1983-02-06	38000177		0	0	30		0	0	0	171957	0	282464	1127078		
171869	3778	40213160	1965-06-13	1965-06-13 00:00:00	1965-06-13	1965-06-13 00:00:00	1965-06-13	581452		0	0	0		0	0	0	251054	0	10	40213160		
49497	4106	1127433	1985-10-25	1985-10-25 00:00:00	1985-11-01	1985-11-01 00:00:00	1985-11-01	38000177		0	0	7		0	0	0	272865	0	313782	1127433		
54114	4497	19133873	1971-04-07	1971-04-07 00:00:00	1971-04-15	1971-04-15 00:00:00	1971-04-15	38000177		0	0	8		0	0	0	299416	0	834061	19133873		
30619	2540	19059056	1962-08-04	1962-08-04 00:00:00	1962-08-25	1962-08-25 00:00:00	1962-08-25	38000177		0	0	21		0	0	0	167985	0	243670	19059056		
94946	2082	40213227	2013-04-11	2013-04-11 00:00:00	2013-04-11	2013-04-11 00:00:00	2013-04-11	581452		0	0	0		0	0	0	138674	0	113	40213227		
42752	3543	19075601	1998-07-21	1998-07-21 00:00:00	1998-07-21	1998-07-21 00:00:00	\N	38000177		0	0	0		0	0	0	235387	0	309362	19075601		
37798	3123	19019979	1982-12-26	1982-12-26 00:00:00	1983-01-09	1983-01-09 00:00:00	1983-01-09	38000177		0	0	14		0	0	0	207779	0	198405	19019979		
62965	5233	1127433	1993-09-09	1993-09-09 00:00:00	1993-10-07	1993-10-07 00:00:00	1993-10-07	38000177		0	0	28		0	0	0	348174	0	313782	1127433		
140911	3093	40213160	1971-12-04	1971-12-04 00:00:00	1971-12-04	1971-12-04 00:00:00	1971-12-04	581452		0	0	0		0	0	0	205919	0	10	40213160		
114180	2509	40213260	2019-06-09	2019-06-09 00:00:00	2019-06-09	2019-06-09 00:00:00	2019-06-09	581452		0	0	0		0	0	0	166088	0	121	40213260		
43134	3573	1127433	1989-03-31	1989-03-31 00:00:00	1989-04-21	1989-04-21 00:00:00	1989-04-21	38000177		0	0	21		0	0	0	237629	0	313782	1127433		
53645	4459	1115171	2015-10-04	2015-10-04 00:00:00	2015-11-01	2015-11-01 00:00:00	2015-11-01	38000177		0	0	28		0	0	0	296736	0	849574	1115171		
64516	1411	40213306	1988-02-02	1988-02-02 00:00:00	1988-02-02	1988-02-02 00:00:00	1988-02-02	581452		0	0	0		0	0	0	93917	0	43	40213306		
2153	171	19133905	1991-11-02	1991-11-02 00:00:00	1991-11-10	1991-11-10 00:00:00	1991-11-10	38000177		0	0	8		0	0	0	11626	0	834102	19133905		
63866	5306	1127433	1990-08-27	1990-08-27 00:00:00	1990-09-24	1990-09-24 00:00:00	1990-09-24	38000177		0	0	28		0	0	0	352981	0	313782	1127433		
46047	3814	19128022	1998-10-06	1998-10-06 00:00:00	1999-10-01	1999-10-01 00:00:00	1999-10-01	38000177		0	0	360		0	0	0	253342	0	749785	19128022		
46105	3820	19133873	1968-11-10	1968-11-10 00:00:00	1968-11-21	1968-11-21 00:00:00	1968-11-21	38000177		0	0	11		0	0	0	253658	0	834061	19133873		
44982	3721	1127433	1981-05-19	1981-05-19 00:00:00	1981-06-02	1981-06-02 00:00:00	1981-06-02	38000177		0	0	14		0	0	0	247333	0	313782	1127433		
41034	893	40213227	1995-10-02	1995-10-02 00:00:00	1995-10-02	1995-10-02 00:00:00	1995-10-02	581452		0	0	0		0	0	0	59512	0	113	40213227		
47276	3920	1127078	1974-12-01	1974-12-01 00:00:00	1974-12-15	1974-12-15 00:00:00	1974-12-15	38000177		0	0	14		0	0	0	260689	0	282464	1127078		
1802	144	19059056	1978-10-30	1978-10-30 00:00:00	1978-11-20	1978-11-20 00:00:00	1978-11-20	38000177		0	0	21		0	0	0	9612	0	243670	19059056		
41370	3431	19078461	1981-09-05	1981-09-05 00:00:00	1981-09-26	1981-09-26 00:00:00	1981-09-26	38000177		0	0	21		0	0	0	227479	0	310965	19078461		
60650	5045	19128065	1977-03-14	1977-03-14 00:00:00	1978-03-09	1978-03-09 00:00:00	1978-03-09	38000177		0	0	360		0	0	0	335291	0	749882	19128065		
4547	377	1127433	1998-06-06	1998-06-06 00:00:00	1998-06-20	1998-06-20 00:00:00	1998-06-20	38000177		0	0	14		0	0	0	24958	0	313782	1127433		
182520	4010	40213227	1999-12-02	1999-12-02 00:00:00	1999-12-02	1999-12-02 00:00:00	1999-12-02	581452		0	0	0		0	0	0	\N	0	113	40213227		
59177	1294	40213160	1973-02-24	1973-02-24 00:00:00	1973-02-24	1973-02-24 00:00:00	1973-02-24	581452		0	0	0		0	0	0	85616	0	10	40213160		
163632	3599	40213160	1966-08-12	1966-08-12 00:00:00	1966-08-12	1966-08-12 00:00:00	1966-08-12	581452		0	0	0		0	0	0	239074	0	10	40213160		
5205	437	40231925	2017-11-06	2017-11-06 00:00:00	2017-11-06	2017-11-06 00:00:00	\N	38000177		0	0	0		0	0	0	29054	0	1049221	40231925		
54156	4500	1127433	1974-12-12	1974-12-12 00:00:00	1974-12-26	1974-12-26 00:00:00	1974-12-26	38000177		0	0	14		0	0	0	299587	0	313782	1127433		
168333	3700	40213227	1997-11-05	1997-11-05 00:00:00	1997-11-05	1997-11-05 00:00:00	1997-11-05	581452		0	0	0		0	0	0	246025	0	113	40213227		
5369	449	920334	1996-12-01	1996-12-01 00:00:00	1996-12-08	1996-12-08 00:00:00	1996-12-08	38000177		0	0	7		0	0	0	29981	0	311995	920334		
5432	454	1713671	1953-07-05	1953-07-05 00:00:00	1953-07-19	1953-07-19 00:00:00	1953-07-19	38000177		0	0	14		0	0	0	30346	0	562251	1713671		
71652	1567	40213160	1979-12-06	1979-12-06 00:00:00	1979-12-06	1979-12-06 00:00:00	1979-12-06	581452		0	0	0		0	0	0	105094	0	10	40213160		
80230	1755	40213296	1999-06-23	1999-06-23 00:00:00	1999-06-23	1999-06-23 00:00:00	1999-06-23	581452		0	0	0		0	0	0	117391	0	52	40213296		
1314	102	19128065	1993-05-16	1993-05-16 00:00:00	1994-05-11	1994-05-11 00:00:00	1994-05-11	38000177		0	0	360		0	0	0	6982	0	749882	19128065		
18860	1558	42707627	1962-06-14	1962-06-14 00:00:00	1962-06-14	1962-06-14 00:00:00	1962-06-14	38000177		0	0	0		0	0	0	104301	0	1234995	42707627		
26777	582	40213306	1981-11-04	1981-11-04 00:00:00	1981-11-04	1981-11-04 00:00:00	1981-11-04	581452		0	0	0		0	0	0	38562	0	43	40213306		
54522	4531	1539411	1994-10-29	1994-10-29 00:00:00	1994-10-29	1994-10-29 00:00:00	\N	38000177		0	0	0		0	0	0	301684	0	312961	1539411		
54896	4559	40173590	2015-07-28	2015-07-28 00:00:00	2015-07-28	2015-07-28 00:00:00	\N	38000177		0	0	0		0	0	0	303732	0	904419	40173590		
64266	1407	40213160	1968-07-20	1968-07-20 00:00:00	1968-07-20	1968-07-20 00:00:00	1968-07-20	581452		0	0	0		0	0	0	93559	0	10	40213160		
2528	202	1713671	2010-03-04	2010-03-04 00:00:00	2010-03-25	2010-03-25 00:00:00	2010-03-25	38000177		0	0	21		0	0	0	13851	0	562251	1713671		
19915	1635	40229134	1981-08-03	1981-08-03 00:00:00	1981-08-17	1981-08-17 00:00:00	1981-08-17	38000177		0	0	14		0	0	0	109844	0	1043400	40229134		
2618	209	1713671	2009-05-02	2009-05-02 00:00:00	2009-05-16	2009-05-16 00:00:00	2009-05-16	38000177		0	0	14		0	0	0	14237	0	562251	1713671		
203444	4466	40213160	1976-09-10	1976-09-10 00:00:00	1976-09-10	1976-09-10 00:00:00	1976-09-10	581452		0	0	0		0	0	0	297122	0	10	40213160		
10530	877	1127433	2014-07-22	2014-07-22 00:00:00	2014-07-29	2014-07-29 00:00:00	2014-07-29	38000177		0	0	7		0	0	0	58384	0	313782	1127433		
46767	3875	1127433	1977-01-17	1977-01-17 00:00:00	1977-01-31	1977-01-31 00:00:00	1977-01-31	38000177		0	0	14		0	0	0	257380	0	313782	1127433		
43221	3580	19078461	1993-03-16	1993-03-16 00:00:00	1993-04-20	1993-04-20 00:00:00	1993-04-20	38000177		0	0	35		0	0	0	237968	0	310965	19078461		
26906	2218	1551192	1989-03-26	1989-03-26 00:00:00	1989-03-26	1989-03-26 00:00:00	1989-03-26	38000177		0	0	0		0	0	0	147708	0	312617	1551192		
57364	4759	40229134	2000-08-10	2000-08-10 00:00:00	2000-08-24	2000-08-24 00:00:00	2000-08-24	38000177		0	0	14		0	0	0	317076	0	1043400	40229134		
34568	2858	1713671	1999-02-19	1999-02-19 00:00:00	1999-03-12	1999-03-12 00:00:00	1999-03-12	38000177		0	0	21		0	0	0	189747	0	562251	1713671		
34599	2859	19006318	1945-01-15	1945-01-15 00:00:00	1945-01-29	1945-01-29 00:00:00	1945-01-29	38000177		0	0	14		0	0	0	189982	0	105078	19006318		
233784	5137	40213160	1972-03-01	1972-03-01 00:00:00	1972-03-01	1972-03-01 00:00:00	1972-03-01	581452		0	0	0		0	0	0	\N	0	10	40213160		
51784	4305	1118084	1997-12-27	1997-12-27 00:00:00	1997-12-27	1997-12-27 00:00:00	\N	38000177		0	0	0		0	0	0	285570	0	00025152531	44923712		
9852	825	1118084	2011-02-14	2011-02-14 00:00:00	2011-02-14	2011-02-14 00:00:00	\N	38000177		0	0	0		0	0	0	54662	0	00025152531	44923712		
27275	2256	42902245	1998-07-05	1998-07-05 00:00:00	1999-06-30	1999-06-30 00:00:00	1999-06-30	38000177		0	0	360		0	0	0	149955	0	1359133	42902245		
48217	3997	19133873	1969-08-23	1969-08-23 00:00:00	1969-09-01	1969-09-01 00:00:00	1969-09-01	38000177		0	0	9		0	0	0	265728	0	834061	19133873		
32731	2711	1127433	1988-05-07	1988-05-07 00:00:00	1988-05-28	1988-05-28 00:00:00	1988-05-28	38000177		0	0	21		0	0	0	179612	0	313782	1127433		
25694	2114	1127078	1970-07-06	1970-07-06 00:00:00	1970-07-20	1970-07-20 00:00:00	1970-07-20	38000177		0	0	14		0	0	0	140648	0	282464	1127078		
10875	906	19059056	1974-01-19	1974-01-19 00:00:00	1974-02-02	1974-02-02 00:00:00	1974-02-02	38000177		0	0	14		0	0	0	60274	0	243670	19059056		
16925	1401	19059056	1989-11-28	1989-11-28 00:00:00	1989-12-12	1989-12-12 00:00:00	1989-12-12	38000177		0	0	14		0	0	0	93179	0	243670	19059056		
30084	2495	43012754	2004-08-05	2004-08-05 00:00:00	2005-07-31	2005-07-31 00:00:00	2005-07-31	38000177		0	0	360		0	0	0	165156	0	1366343	43012754		
48481	4017	19077572	2010-05-20	2010-05-20 00:00:00	2010-05-20	2010-05-20 00:00:00	\N	38000177		0	0	0		0	0	0	267004	0	310436	19077572		
63656	5290	19078461	2000-05-08	2000-05-08 00:00:00	2000-05-29	2000-05-29 00:00:00	2000-05-29	38000177		0	0	21		0	0	0	352034	0	310965	19078461		
31364	2599	1127078	1981-11-22	1981-11-22 00:00:00	1981-12-13	1981-12-13 00:00:00	1981-12-13	38000177		0	0	21		0	0	0	171956	0	282464	1127078		
171883	3779	40213227	2012-04-14	2012-04-14 00:00:00	2012-04-14	2012-04-14 00:00:00	2012-04-14	581452		0	0	0		0	0	0	251143	0	113	40213227		
49498	4106	1118084	1984-02-07	1984-02-07 00:00:00	1984-02-07	1984-02-07 00:00:00	\N	38000177		0	0	0		0	0	0	272825	0	00025152531	44923712		
54115	4497	1127433	1978-03-06	1978-03-06 00:00:00	1978-03-20	1978-03-20 00:00:00	1978-03-20	38000177		0	0	14		0	0	0	299397	0	313782	1127433		
30620	2540	19059056	1972-02-04	1972-02-04 00:00:00	1972-02-25	1972-02-25 00:00:00	1972-02-25	38000177		0	0	21		0	0	0	167986	0	243670	19059056		
94948	2082	40213198	2010-03-25	2010-03-25 00:00:00	2010-03-25	2010-03-25 00:00:00	2010-03-25	581452		0	0	0		0	0	0	138731	0	133	40213198		
42753	3543	1713671	2004-04-02	2004-04-02 00:00:00	2004-04-23	2004-04-23 00:00:00	2004-04-23	38000177		0	0	21		0	0	0	235370	0	562251	1713671		
37799	3123	19128022	1994-06-17	1994-06-17 00:00:00	1995-06-12	1995-06-12 00:00:00	1995-06-12	38000177		0	0	360		0	0	0	207773	0	749785	19128022		
62966	5233	19078461	2003-02-17	2003-02-17 00:00:00	2003-03-03	2003-03-03 00:00:00	2003-03-03	38000177		0	0	14		0	0	0	348175	0	310965	19078461		
140913	3093	40213227	1993-11-20	1993-11-20 00:00:00	1993-11-20	1993-11-20 00:00:00	1993-11-20	581452		0	0	0		0	0	0	205953	0	113	40213227		
12475	1051	920334	2000-03-21	2000-03-21 00:00:00	2000-03-28	2000-03-28 00:00:00	2000-03-28	38000177		0	0	7		0	0	0	68950	0	311995	920334		
43135	3573	19059056	1934-10-27	1934-10-27 00:00:00	1935-01-25	1935-01-25 00:00:00	1935-01-25	38000177		0	0	90		0	0	0	237622	0	243670	19059056		
53646	4459	1127433	1968-12-03	1968-12-03 00:00:00	1968-12-10	1968-12-10 00:00:00	1968-12-10	38000177		0	0	7		0	0	0	296728	0	313782	1127433		
64521	1411	40213227	1997-02-11	1997-02-11 00:00:00	1997-02-11	1997-02-11 00:00:00	1997-02-11	581452		0	0	0		0	0	0	93973	0	113	40213227		
12622	1062	1127433	1983-09-16	1983-09-16 00:00:00	1983-09-23	1983-09-23 00:00:00	1983-09-23	38000177		0	0	7		0	0	0	69676	0	313782	1127433		
63867	5306	19133905	1995-04-29	1995-04-29 00:00:00	1995-05-11	1995-05-11 00:00:00	1995-05-11	38000177		0	0	12		0	0	0	352925	0	834102	19133905		
46048	3814	19128065	1996-10-16	1996-10-16 00:00:00	1997-10-11	1997-10-11 00:00:00	1997-10-11	38000177		0	0	360		0	0	0	253338	0	749882	19128065		
46106	3820	19128022	1990-09-15	1990-09-15 00:00:00	1991-09-10	1991-09-10 00:00:00	1991-09-10	38000177		0	0	360		0	0	0	253667	0	749785	19128022		
44983	3721	19059056	1968-02-03	1968-02-03 00:00:00	1968-02-17	1968-02-17 00:00:00	1968-02-17	38000177		0	0	14		0	0	0	247340	0	243670	19059056		
41036	893	40213260	2006-02-20	2006-02-20 00:00:00	2006-02-20	2006-02-20 00:00:00	2006-02-20	581452		0	0	0		0	0	0	59529	0	121	40213260		
47277	3920	46233988	1974-12-01	1974-12-01 00:00:00	1974-12-15	1974-12-15 00:00:00	1974-12-15	38000177		0	0	14		0	0	0	260689	0	1652673	46233988		
1803	144	1713671	1979-09-04	1979-09-04 00:00:00	1979-09-25	1979-09-25 00:00:00	1979-09-25	38000177		0	0	21		0	0	0	9629	0	562251	1713671		
41371	3431	40236824	1988-10-29	1988-10-29 00:00:00	1988-11-05	1988-11-05 00:00:00	1988-11-05	38000177		0	0	7		0	0	0	227399	0	1094107	40236824		
60651	5045	1127433	1989-12-29	1989-12-29 00:00:00	1990-01-12	1990-01-12 00:00:00	1990-01-12	38000177		0	0	14		0	0	0	335286	0	313782	1127433		
4548	377	19059056	1974-08-29	1974-08-29 00:00:00	1974-09-19	1974-09-19 00:00:00	1974-09-19	38000177		0	0	21		0	0	0	24965	0	243670	19059056		
182522	4010	40213314	1977-08-11	1977-08-11 00:00:00	1977-08-11	1977-08-11 00:00:00	1977-08-11	581452		0	0	0		0	0	0	266478	0	49	40213314		
59180	1294	40213306	1994-12-17	1994-12-17 00:00:00	1994-12-17	1994-12-17 00:00:00	1994-12-17	581452		0	0	0		0	0	0	85661	0	43	40213306		
163635	3599	40213160	1966-10-14	1966-10-14 00:00:00	1966-10-14	1966-10-14 00:00:00	1966-10-14	581452		0	0	0		0	0	0	239054	0	10	40213160		
5206	437	1115171	2017-11-06	2017-11-06 00:00:00	2018-01-05	2018-01-05 00:00:00	2018-01-05	38000177		0	0	60		0	0	0	29054	0	849574	1115171		
54157	4500	19078461	2010-04-25	2010-04-25 00:00:00	2010-07-24	2010-07-24 00:00:00	2010-07-24	38000177		0	0	90		0	0	0	299607	0	310965	19078461		
168335	3700	40213227	2009-06-24	2009-06-24 00:00:00	2009-06-24	2009-06-24 00:00:00	2009-06-24	581452		0	0	0		0	0	0	245949	0	113	40213227		
5370	449	1127433	2001-06-27	2001-06-27 00:00:00	2001-07-11	2001-07-11 00:00:00	2001-07-11	38000177		0	0	14		0	0	0	29913	0	313782	1127433		
5433	454	19059056	1943-03-20	1943-03-20 00:00:00	1943-04-03	1943-04-03 00:00:00	1943-04-03	38000177		0	0	14		0	0	0	30271	0	243670	19059056		
71653	1567	40213160	1975-06-05	1975-06-05 00:00:00	1975-06-05	1975-06-05 00:00:00	1975-06-05	581452		0	0	0		0	0	0	105091	0	10	40213160		
80241	1755	40213306	1981-11-04	1981-11-04 00:00:00	1981-11-04	1981-11-04 00:00:00	1981-11-04	581452		0	0	0		0	0	0	117399	0	43	40213306		
1315	102	19128065	1996-04-30	1996-04-30 00:00:00	1997-04-25	1997-04-25 00:00:00	1997-04-25	38000177		0	0	360		0	0	0	6974	0	749882	19128065		
18861	1558	46275444	1962-06-14	1962-06-14 00:00:00	1962-06-14	1962-06-14 00:00:00	1962-06-14	38000177		0	0	0		0	0	0	104301	0	1659149	46275444		
26780	582	40213227	1993-11-17	1993-11-17 00:00:00	1993-11-17	1993-11-17 00:00:00	1993-11-17	581452		0	0	0		0	0	0	38548	0	113	40213227		
54523	4531	19126352	1994-10-29	1994-10-29 00:00:00	2017-04-29	2017-04-29 00:00:00	2017-04-29	38000177		0	0	8218		0	0	0	301684	0	705129	19126352		
54897	4559	19059056	1966-11-06	1966-11-06 00:00:00	1966-12-11	1966-12-11 00:00:00	1966-12-11	38000177		0	0	35		0	0	0	303805	0	243670	19059056		
64268	1407	40213160	1968-02-17	1968-02-17 00:00:00	1968-02-17	1968-02-17 00:00:00	1968-02-17	581452		0	0	0		0	0	0	93496	0	10	40213160		
2529	202	19059056	1951-09-28	1951-09-28 00:00:00	1951-10-12	1951-10-12 00:00:00	1951-10-12	38000177		0	0	14		0	0	0	13906	0	243670	19059056		
19916	1635	19059056	1973-08-14	1973-08-14 00:00:00	1973-11-12	1973-11-12 00:00:00	1973-11-12	38000177		0	0	90		0	0	0	109856	0	243670	19059056		
2620	209	1713671	1999-10-28	1999-10-28 00:00:00	1999-11-18	1999-11-18 00:00:00	1999-11-18	38000177		0	0	21		0	0	0	14211	0	562251	1713671		
64660	1415	40213260	2019-01-27	2019-01-27 00:00:00	2019-01-27	2019-01-27 00:00:00	2019-01-27	581452		0	0	0		0	0	0	94175	0	121	40213260		
10531	877	1127433	1999-04-06	1999-04-06 00:00:00	1999-04-27	1999-04-27 00:00:00	1999-04-27	38000177		0	0	21		0	0	0	58441	0	313782	1127433		
46768	3875	920300	2005-12-06	2005-12-06 00:00:00	2005-12-13	2005-12-13 00:00:00	2005-12-13	38000177		0	0	7		0	0	0	257346	0	311989	920300		
43222	3580	1124300	2017-07-31	2017-07-31 00:00:00	2017-07-31	2017-07-31 00:00:00	\N	38000177		0	0	0		0	0	0	237980	0	00781178901	45011828		
26907	2218	19019979	1986-09-08	1986-09-08 00:00:00	1986-09-29	1986-09-29 00:00:00	1986-09-29	38000177		0	0	21		0	0	0	147707	0	198405	19019979		
57365	4759	19133873	1986-06-30	1986-06-30 00:00:00	1986-07-10	1986-07-10 00:00:00	1986-07-10	38000177		0	0	10		0	0	0	317040	0	834061	19133873		
34569	2858	1127433	1977-03-02	1977-03-02 00:00:00	1977-03-16	1977-03-16 00:00:00	1977-03-16	38000177		0	0	14		0	0	0	189744	0	313782	1127433		
34600	2859	19133873	1951-06-13	1951-06-13 00:00:00	1951-06-25	1951-06-25 00:00:00	1951-06-25	38000177		0	0	12		0	0	0	190022	0	834061	19133873		
132749	2915	40213227	1996-02-11	1996-02-11 00:00:00	1996-02-11	1996-02-11 00:00:00	1996-02-11	581452		0	0	0		0	0	0	194312	0	113	40213227		
51785	4305	1551192	2004-04-20	2004-04-20 00:00:00	2004-04-20	2004-04-20 00:00:00	2004-04-20	38000177		0	0	0		0	0	0	285535	0	312617	1551192		
9853	825	1713671	2017-09-16	2017-09-16 00:00:00	2017-09-30	2017-09-30 00:00:00	2017-09-30	38000177		0	0	14		0	0	0	54667	0	562251	1713671		
27276	2256	43012754	2004-06-03	2004-06-03 00:00:00	2005-05-29	2005-05-29 00:00:00	2005-05-29	38000177		0	0	360		0	0	0	149910	0	1366343	43012754		
3991	331	1713671	1969-08-18	1969-08-18 00:00:00	1969-09-01	1969-09-01 00:00:00	1969-09-01	38000177		0	0	14		0	0	0	21820	0	562251	1713671		
32732	2711	1713671	1999-10-09	1999-10-09 00:00:00	1999-10-30	1999-10-30 00:00:00	1999-10-30	38000177		0	0	21		0	0	0	179794	0	562251	1713671		
25695	2114	46233988	1970-07-06	1970-07-06 00:00:00	1970-07-20	1970-07-20 00:00:00	1970-07-20	38000177		0	0	14		0	0	0	140648	0	1652673	46233988		
10876	906	920334	2017-03-29	2017-03-29 00:00:00	2017-04-05	2017-04-05 00:00:00	2017-04-05	38000177		0	0	7		0	0	0	60265	0	311995	920334		
27391	2266	46233988	1971-12-11	1971-12-11 00:00:00	1971-12-25	1971-12-25 00:00:00	1971-12-25	38000177		0	0	14		0	0	0	150627	0	1652673	46233988		
30085	2495	1127433	1990-09-28	1990-09-28 00:00:00	1990-10-12	1990-10-12 00:00:00	1990-10-12	38000177		0	0	14		0	0	0	165151	0	313782	1127433		
48482	4017	1127433	1986-10-14	1986-10-14 00:00:00	1986-10-21	1986-10-21 00:00:00	1986-10-21	38000177		0	0	7		0	0	0	266947	0	313782	1127433		
63657	5290	1127433	1979-05-29	1979-05-29 00:00:00	1979-08-27	1979-08-27 00:00:00	1979-08-27	38000177		0	0	90		0	0	0	352032	0	313782	1127433		
31365	2599	42902245	1998-01-01	1998-01-01 00:00:00	1998-12-27	1998-12-27 00:00:00	1998-12-27	38000177		0	0	360		0	0	0	171985	0	1359133	42902245		
171884	3779	40213296	2012-04-14	2012-04-14 00:00:00	2012-04-14	2012-04-14 00:00:00	2012-04-14	581452		0	0	0		0	0	0	251143	0	52	40213296		
49499	4106	19059056	1947-06-16	1947-06-16 00:00:00	1947-06-30	1947-06-30 00:00:00	1947-06-30	38000177		0	0	14		0	0	0	272840	0	243670	19059056		
54116	4497	19059056	1973-05-29	1973-05-29 00:00:00	1973-06-26	1973-06-26 00:00:00	1973-06-26	38000177		0	0	28		0	0	0	299366	0	243670	19059056		
30621	2540	1127433	1991-11-30	1991-11-30 00:00:00	1991-12-07	1991-12-07 00:00:00	1991-12-07	38000177		0	0	7		0	0	0	167996	0	313782	1127433		
94957	2082	40213201	2008-03-13	2008-03-13 00:00:00	2008-03-13	2008-03-13 00:00:00	2008-03-13	581452		0	0	0		0	0	0	138695	0	33	40213201		
42754	3543	19059056	1978-07-14	1978-07-14 00:00:00	1978-09-19	1978-09-19 00:00:00	1978-09-19	38000177		0	0	67		0	0	0	235330	0	243670	19059056		
37810	3125	1127433	1962-10-20	1962-10-20 00:00:00	1962-11-03	1962-11-03 00:00:00	1962-11-03	38000177		0	0	14		0	0	0	207934	0	313782	1127433		
62967	5233	19059056	1958-10-08	1958-10-08 00:00:00	1958-11-12	1958-11-12 00:00:00	1958-11-12	38000177		0	0	35		0	0	0	348170	0	243670	19059056		
140914	3093	40213306	1993-11-20	1993-11-20 00:00:00	1993-11-20	1993-11-20 00:00:00	1993-11-20	581452		0	0	0		0	0	0	205953	0	43	40213306		
12476	1051	1118084	2001-03-17	2001-03-17 00:00:00	2001-03-17	2001-03-17 00:00:00	\N	38000177		0	0	0		0	0	0	68950	0	00025152531	44923712		
43136	3573	1127433	2010-11-27	2010-11-27 00:00:00	2010-12-18	2010-12-18 00:00:00	2010-12-18	38000177		0	0	21		0	0	0	237631	0	313782	1127433		
53647	4459	1713671	1985-04-07	1985-04-07 00:00:00	1985-04-21	1985-04-21 00:00:00	1985-04-21	38000177		0	0	14		0	0	0	296721	0	562251	1713671		
64530	1411	40213260	2015-12-01	2015-12-01 00:00:00	2015-12-01	2015-12-01 00:00:00	2015-12-01	581452		0	0	0		0	0	0	93951	0	121	40213260		
12623	1062	1127433	1992-08-22	1992-08-22 00:00:00	1992-09-05	1992-09-05 00:00:00	1992-09-05	38000177		0	0	14		0	0	0	69665	0	313782	1127433		
63868	5306	19128065	1989-12-10	1989-12-10 00:00:00	1990-12-05	1990-12-05 00:00:00	1990-12-05	38000177		0	0	360		0	0	0	352963	0	749882	19128065		
46049	3814	40224805	1993-11-01	1993-11-01 00:00:00	1994-10-27	1994-10-27 00:00:00	1994-10-27	38000177		0	0	360		0	0	0	253357	0	1000126	40224805		
55053	1206	40213160	1969-01-20	1969-01-20 00:00:00	1969-01-20	1969-01-20 00:00:00	1969-01-20	581452		0	0	0		0	0	0	79270	0	10	40213160		
44984	3721	19006318	1968-02-03	1968-02-03 00:00:00	1968-02-17	1968-02-17 00:00:00	1968-02-17	38000177		0	0	14		0	0	0	247340	0	105078	19006318		
41043	893	40213160	1958-09-01	1958-09-01 00:00:00	1958-09-01	1958-09-01 00:00:00	1958-09-01	581452		0	0	0		0	0	0	59482	0	10	40213160		
47278	3920	40165015	2009-11-10	2009-11-10 00:00:00	2009-11-10	2009-11-10 00:00:00	\N	38000177		0	0	0		0	0	0	260685	0	861467	40165015		
1804	145	1127078	1955-06-27	1955-06-27 00:00:00	1955-08-01	1955-08-01 00:00:00	1955-08-01	38000177		0	0	35		0	0	0	9811	0	282464	1127078		
41372	3431	920300	1988-10-29	1988-10-29 00:00:00	1988-11-05	1988-11-05 00:00:00	1988-11-05	38000177		0	0	7		0	0	0	227399	0	311989	920300		
60652	5045	19128065	1975-03-25	1975-03-25 00:00:00	1976-03-19	1976-03-19 00:00:00	1976-03-19	38000177		0	0	360		0	0	0	335289	0	749882	19128065		
4549	377	46233988	1974-08-29	1974-08-29 00:00:00	1974-09-19	1974-09-19 00:00:00	1974-09-19	38000177		0	0	21		0	0	0	24965	0	1652673	46233988		
182523	4010	40213160	1977-08-11	1977-08-11 00:00:00	1977-08-11	1977-08-11 00:00:00	1977-08-11	581452		0	0	0		0	0	0	266478	0	10	40213160		
63361	5262	1127078	1978-04-10	1978-04-10 00:00:00	1978-05-01	1978-05-01 00:00:00	1978-05-01	38000177		0	0	21		0	0	0	350074	0	282464	1127078		
163639	3599	40213260	2016-05-06	2016-05-06 00:00:00	2016-05-06	2016-05-06 00:00:00	2016-05-06	581452		0	0	0		0	0	0	239066	0	121	40213260		
5207	437	1127078	1951-08-30	1951-08-30 00:00:00	1951-09-13	1951-09-13 00:00:00	1951-09-13	38000177		0	0	14		0	0	0	29013	0	282464	1127078		
54158	4500	19078461	2003-12-16	2003-12-16 00:00:00	2004-01-06	2004-01-06 00:00:00	2004-01-06	38000177		0	0	21		0	0	0	299605	0	310965	19078461		
168338	3700	40213260	2017-09-06	2017-09-06 00:00:00	2017-09-06	2017-09-06 00:00:00	2017-09-06	581452		0	0	0		0	0	0	246022	0	121	40213260		
5371	449	1124300	1993-08-11	1993-08-11 00:00:00	1993-08-11	1993-08-11 00:00:00	\N	38000177		0	0	0		0	0	0	29911	0	00781178901	45011828		
5434	454	19078461	1991-12-15	1991-12-15 00:00:00	1991-12-29	1991-12-29 00:00:00	1991-12-29	38000177		0	0	14		0	0	0	30275	0	310965	19078461		
71656	1567	40213227	1997-05-15	1997-05-15 00:00:00	1997-05-15	1997-05-15 00:00:00	1997-05-15	581452		0	0	0		0	0	0	105125	0	113	40213227		
80246	1755	40213160	1964-04-15	1964-04-15 00:00:00	1964-04-15	1964-04-15 00:00:00	1964-04-15	581452		0	0	0		0	0	0	117355	0	10	40213160		
1316	102	19075001	1994-06-10	1994-06-10 00:00:00	1994-07-15	1994-07-15 00:00:00	1994-07-15	38000177		0	0	35		0	0	0	6980	0	309097	19075001		
18862	1558	19078924	1962-06-14	1962-06-14 00:00:00	1962-06-14	1962-06-14 00:00:00	1962-06-14	38000177		0	0	0		0	0	0	104301	0	311700	19078924		
152947	3367	40213260	2013-03-04	2013-03-04 00:00:00	2013-03-04	2013-03-04 00:00:00	2013-03-04	581452		0	0	0		0	0	0	223294	0	121	40213260		
54524	4531	1127433	1916-05-21	1916-05-21 00:00:00	1916-05-28	1916-05-28 00:00:00	1916-05-28	38000177		0	0	7		0	0	0	301681	0	313782	1127433		
54898	4559	40162522	1966-11-06	1966-11-06 00:00:00	1966-11-06	1966-11-06 00:00:00	\N	38000177		0	0	0		0	0	0	303805	0	857005	40162522		
64283	1407	40213227	2018-11-17	2018-11-17 00:00:00	2018-11-17	2018-11-17 00:00:00	2018-11-17	581452		0	0	0		0	0	0	93549	0	113	40213227		
2530	202	1127433	1964-03-11	1964-03-11 00:00:00	1964-03-18	1964-03-18 00:00:00	1964-03-18	38000177		0	0	7		0	0	0	13842	0	313782	1127433		
19917	1635	40229134	2014-07-30	2014-07-30 00:00:00	2014-08-06	2014-08-06 00:00:00	2014-08-06	38000177		0	0	7		0	0	0	109822	0	1043400	40229134		
2622	209	40231925	2003-01-21	2003-01-21 00:00:00	2003-01-21	2003-01-21 00:00:00	\N	38000177		0	0	0		0	0	0	14268	0	1049221	40231925		
64661	1415	40213296	2009-02-01	2009-02-01 00:00:00	2009-02-01	2009-02-01 00:00:00	2009-02-01	581452		0	0	0		0	0	0	94173	0	52	40213296		
10532	877	1127433	2005-10-22	2005-10-22 00:00:00	2005-11-05	2005-11-05 00:00:00	2005-11-05	38000177		0	0	14		0	0	0	58442	0	313782	1127433		
46769	3875	40236824	2005-12-06	2005-12-06 00:00:00	2005-12-20	2005-12-20 00:00:00	2005-12-20	38000177		0	0	14		0	0	0	257346	0	1094107	40236824		
43223	3580	40236824	1998-04-25	1998-04-25 00:00:00	1998-05-02	1998-05-02 00:00:00	1998-05-02	38000177		0	0	7		0	0	0	238003	0	1094107	40236824		
26908	2218	19133873	1988-01-18	1988-01-18 00:00:00	1988-01-31	1988-01-31 00:00:00	1988-01-31	38000177		0	0	13		0	0	0	147701	0	834061	19133873		
57366	4759	19078461	2017-01-02	2017-01-02 00:00:00	2017-01-16	2017-01-16 00:00:00	2017-01-16	38000177		0	0	14		0	0	0	317072	0	310965	19078461		
34570	2858	1713671	1982-05-09	1982-05-09 00:00:00	1982-05-23	1982-05-23 00:00:00	1982-05-23	38000177		0	0	14		0	0	0	189783	0	562251	1713671		
34601	2859	1127433	1992-05-23	1992-05-23 00:00:00	1992-06-13	1992-06-13 00:00:00	1992-06-13	38000177		0	0	21		0	0	0	190015	0	313782	1127433		
132760	2915	40213201	2011-05-08	2011-05-08 00:00:00	2011-05-08	2011-05-08 00:00:00	2011-05-08	581452		0	0	0		0	0	0	194337	0	33	40213201		
51786	4305	1127433	1973-09-29	1973-09-29 00:00:00	1973-10-13	1973-10-13 00:00:00	1973-10-13	38000177		0	0	14		0	0	0	285658	0	313782	1127433		
9854	825	40229134	1997-09-22	1997-09-22 00:00:00	1997-09-29	1997-09-29 00:00:00	1997-09-29	38000177		0	0	7		0	0	0	54629	0	1043400	40229134		
27277	2256	19128065	1996-07-15	1996-07-15 00:00:00	1997-07-10	1997-07-10 00:00:00	1997-07-10	38000177		0	0	360		0	0	0	149954	0	749882	19128065		
3992	331	1127433	1968-01-10	1968-01-10 00:00:00	1968-01-24	1968-01-24 00:00:00	1968-01-24	38000177		0	0	14		0	0	0	21782	0	313782	1127433		
32733	2711	19059056	1955-09-28	1955-09-28 00:00:00	1955-10-12	1955-10-12 00:00:00	1955-10-12	38000177		0	0	14		0	0	0	179801	0	243670	19059056		
25696	2114	1127433	1996-05-06	1996-05-06 00:00:00	1996-05-13	1996-05-13 00:00:00	1996-05-13	38000177		0	0	7		0	0	0	140676	0	313782	1127433		
10877	906	19133873	1976-03-10	1976-03-10 00:00:00	1976-03-19	1976-03-19 00:00:00	1976-03-19	38000177		0	0	9		0	0	0	60242	0	834061	19133873		
27392	2266	1127078	1971-12-11	1971-12-11 00:00:00	1971-12-25	1971-12-25 00:00:00	1971-12-25	38000177		0	0	14		0	0	0	150627	0	282464	1127078		
30086	2495	19133905	2013-04-05	2013-04-05 00:00:00	2013-04-14	2013-04-14 00:00:00	2013-04-14	38000177		0	0	9		0	0	0	165163	0	834102	19133905		
48483	4017	19126352	2000-04-20	2000-04-20 00:00:00	2000-04-20	2000-04-20 00:00:00	\N	38000177		0	0	0		0	0	0	266929	0	705129	19126352		
63658	5290	1118084	1995-05-15	1995-05-15 00:00:00	1995-05-15	1995-05-15 00:00:00	\N	38000177		0	0	0		0	0	0	352008	0	00025152531	44923712		
41840	3464	1127433	2004-01-09	2004-01-09 00:00:00	2004-04-08	2004-04-08 00:00:00	2004-04-08	38000177		0	0	90		0	0	0	229948	0	313782	1127433		
9211	196	40213296	1996-10-26	1996-10-26 00:00:00	1996-10-26	1996-10-26 00:00:00	1996-10-26	581452		0	0	0		0	0	0	13495	0	52	40213296		
49500	4106	19006318	1947-06-16	1947-06-16 00:00:00	1947-06-30	1947-06-30 00:00:00	1947-06-30	38000177		0	0	14		0	0	0	272840	0	105078	19006318		
77500	1695	40213260	2016-03-31	2016-03-31 00:00:00	2016-03-31	2016-03-31 00:00:00	2016-03-31	581452		0	0	0		0	0	0	113459	0	121	40213260		
30622	2540	19059056	1942-08-23	1942-08-23 00:00:00	1942-09-13	1942-09-13 00:00:00	1942-09-13	38000177		0	0	21		0	0	0	167924	0	243670	19059056		
3751	312	40165015	1991-05-14	1991-05-14 00:00:00	1991-05-14	1991-05-14 00:00:00	\N	38000177		0	0	0		0	0	0	20658	0	861467	40165015		
42755	3543	19128065	1977-06-24	1977-06-24 00:00:00	1978-06-19	1978-06-19 00:00:00	1978-06-19	38000177		0	0	360		0	0	0	235378	0	749882	19128065		
37811	3125	19059056	1963-12-27	1963-12-27 00:00:00	1964-01-31	1964-01-31 00:00:00	1964-01-31	38000177		0	0	35		0	0	0	208005	0	243670	19059056		
62968	5233	1127433	1956-11-18	1956-11-18 00:00:00	1956-12-02	1956-12-02 00:00:00	1956-12-02	38000177		0	0	14		0	0	0	348136	0	313782	1127433		
48345	4009	19006318	1952-03-30	1952-03-30 00:00:00	1952-04-13	1952-04-13 00:00:00	1952-04-13	38000177		0	0	14		0	0	0	266428	0	105078	19006318		
12477	1051	40232448	1970-03-01	1970-03-01 00:00:00	1970-03-01	1970-03-01 00:00:00	\N	38000177		0	0	0		0	0	0	68864	0	1049630	40232448		
43137	3573	1127433	1926-06-12	1926-06-12 00:00:00	1926-06-26	1926-06-26 00:00:00	1926-06-26	38000177		0	0	14		0	0	0	237571	0	313782	1127433		
53648	4459	1127433	1966-09-07	1966-09-07 00:00:00	1966-09-14	1966-09-14 00:00:00	1966-09-14	38000177		0	0	7		0	0	0	296727	0	313782	1127433		
64540	1412	40213260	2011-12-03	2011-12-03 00:00:00	2011-12-03	2011-12-03 00:00:00	2011-12-03	581452		0	0	0		0	0	0	94032	0	121	40213260		
12624	1062	40229134	1973-03-16	1973-03-16 00:00:00	1973-03-23	1973-03-23 00:00:00	1973-03-23	38000177		0	0	7		0	0	0	69684	0	1043400	40229134		
63869	5306	1127078	1969-09-24	1969-09-24 00:00:00	1969-10-08	1969-10-08 00:00:00	1969-10-08	38000177		0	0	14		0	0	0	352938	0	282464	1127078		
46050	3814	1713671	1975-12-03	1975-12-03 00:00:00	1975-12-17	1975-12-17 00:00:00	1975-12-17	38000177		0	0	14		0	0	0	253360	0	562251	1713671		
55055	1206	40213260	2014-02-10	2014-02-10 00:00:00	2014-02-10	2014-02-10 00:00:00	2014-02-10	581452		0	0	0		0	0	0	79269	0	121	40213260		
44985	3721	19133905	2015-02-13	2015-02-13 00:00:00	2015-02-23	2015-02-23 00:00:00	2015-02-23	38000177		0	0	10		0	0	0	247329	0	834102	19133905		
41053	893	40213160	1955-02-28	1955-02-28 00:00:00	1955-02-28	1955-02-28 00:00:00	1955-02-28	581452		0	0	0		0	0	0	59460	0	10	40213160		
47279	3920	19078461	2009-11-10	2009-11-10 00:00:00	2010-01-09	2010-01-09 00:00:00	2010-01-09	38000177		0	0	60		0	0	0	260685	0	310965	19078461		
236020	5184	40213227	2006-01-06	2006-01-06 00:00:00	2006-01-06	2006-01-06 00:00:00	2006-01-06	581452		0	0	0		0	0	0	344545	0	113	40213227		
41373	3431	19059056	1967-06-16	1967-06-16 00:00:00	1967-07-07	1967-07-07 00:00:00	1967-07-07	38000177		0	0	21		0	0	0	227474	0	243670	19059056		
60653	5045	19133873	1965-07-25	1965-07-25 00:00:00	1965-08-03	1965-08-03 00:00:00	1965-08-03	38000177		0	0	9		0	0	0	335260	0	834061	19133873		
4550	377	19128065	1985-01-08	1985-01-08 00:00:00	1986-01-03	1986-01-03 00:00:00	1986-01-03	38000177		0	0	360		0	0	0	24971	0	749882	19128065		
182525	4010	40213227	2009-01-22	2009-01-22 00:00:00	2009-01-22	2009-01-22 00:00:00	2009-01-22	581452		0	0	0		0	0	0	266504	0	113	40213227		
63362	5262	19133905	2005-06-11	2005-06-11 00:00:00	2005-06-19	2005-06-19 00:00:00	2005-06-19	38000177		0	0	8		0	0	0	350089	0	834102	19133905		
163642	3599	40213227	2017-05-12	2017-05-12 00:00:00	2017-05-12	2017-05-12 00:00:00	2017-05-12	581452		0	0	0		0	0	0	239063	0	113	40213227		
5208	437	19006318	1951-08-30	1951-08-30 00:00:00	1951-09-13	1951-09-13 00:00:00	1951-09-13	38000177		0	0	14		0	0	0	29013	0	105078	19006318		
54159	4500	1127078	1961-11-12	1961-11-12 00:00:00	1961-11-26	1961-11-26 00:00:00	1961-11-26	38000177		0	0	14		0	0	0	299586	0	282464	1127078		
168340	3700	40213227	2017-09-06	2017-09-06 00:00:00	2017-09-06	2017-09-06 00:00:00	2017-09-06	581452		0	0	0		0	0	0	246022	0	113	40213227		
5372	449	40229134	2001-02-19	2001-02-19 00:00:00	2001-02-26	2001-02-26 00:00:00	2001-02-26	38000177		0	0	7		0	0	0	29918	0	1043400	40229134		
5435	454	40236824	1954-05-16	1954-05-16 00:00:00	1954-05-23	1954-05-23 00:00:00	1954-05-23	38000177		0	0	7		0	0	0	30371	0	1094107	40236824		
71658	1567	40213306	1997-05-15	1997-05-15 00:00:00	1997-05-15	1997-05-15 00:00:00	1997-05-15	581452		0	0	0		0	0	0	105125	0	43	40213306		
80249	1755	40213160	1959-11-25	1959-11-25 00:00:00	1959-11-25	1959-11-25 00:00:00	1959-11-25	581452		0	0	0		0	0	0	117352	0	10	40213160		
1317	102	40231925	1994-06-10	1994-06-10 00:00:00	1994-06-10	1994-06-10 00:00:00	\N	38000177		0	0	0		0	0	0	6980	0	1049221	40231925		
18863	1558	19059056	1957-02-12	1957-02-12 00:00:00	1957-02-26	1957-02-26 00:00:00	1957-02-26	38000177		0	0	14		0	0	0	104376	0	243670	19059056		
52835	1155	40213160	1966-10-31	1966-10-31 00:00:00	1966-10-31	1966-10-31 00:00:00	1966-10-31	581452		0	0	0		0	0	0	76370	0	10	40213160		
54525	4531	1127433	1944-05-20	1944-05-20 00:00:00	1944-06-03	1944-06-03 00:00:00	1944-06-03	38000177		0	0	14		0	0	0	301745	0	313782	1127433		
54899	4559	19129655	1966-11-06	1966-11-06 00:00:00	1966-12-11	1966-12-11 00:00:00	1966-12-11	38000177		0	0	35		0	0	0	303805	0	789980	19129655		
64284	1407	40213260	2017-11-11	2017-11-11 00:00:00	2017-11-11	2017-11-11 00:00:00	2017-11-11	581452		0	0	0		0	0	0	93546	0	121	40213260		
2531	202	1127433	2015-10-18	2015-10-18 00:00:00	2015-11-15	2015-11-15 00:00:00	2015-11-15	38000177		0	0	28		0	0	0	13909	0	313782	1127433		
19918	1635	1713671	1990-11-21	1990-11-21 00:00:00	1990-12-05	1990-12-05 00:00:00	1990-12-05	38000177		0	0	14		0	0	0	109845	0	562251	1713671		
2623	209	19073188	2003-01-21	2003-01-21 00:00:00	2003-02-04	2003-02-04 00:00:00	2003-02-04	38000177		0	0	14		0	0	0	14268	0	308192	19073188		
145082	3189	40213227	2007-06-27	2007-06-27 00:00:00	2007-06-27	2007-06-27 00:00:00	2007-06-27	581452		0	0	0		0	0	0	212258	0	113	40213227		
10533	877	1118084	2016-02-13	2016-02-13 00:00:00	2016-02-13	2016-02-13 00:00:00	\N	38000177		0	0	0		0	0	0	58416	0	00025152531	44923712		
46770	3875	19128065	1975-10-30	1975-10-30 00:00:00	1976-10-24	1976-10-24 00:00:00	1976-10-24	38000177		0	0	360		0	0	0	257392	0	749882	19128065		
43224	3580	920300	1998-04-25	1998-04-25 00:00:00	1998-05-02	1998-05-02 00:00:00	1998-05-02	38000177		0	0	7		0	0	0	238003	0	311989	920300		
26909	2218	1551192	1994-01-01	1994-01-01 00:00:00	1994-01-01	1994-01-01 00:00:00	1994-01-01	38000177		0	0	0		0	0	0	147710	0	312617	1551192		
136253	2991	40213227	1993-12-24	1993-12-24 00:00:00	1993-12-24	1993-12-24 00:00:00	1993-12-24	581452		0	0	0		0	0	0	199680	0	113	40213227		
34571	2858	1127433	1991-02-19	1991-02-19 00:00:00	1991-03-05	1991-03-05 00:00:00	1991-03-05	38000177		0	0	14		0	0	0	189891	0	313782	1127433		
34602	2859	1127433	1969-08-22	1969-08-22 00:00:00	1969-11-20	1969-11-20 00:00:00	1969-11-20	38000177		0	0	90		0	0	0	190014	0	313782	1127433		
66264	1450	40213260	2014-12-28	2014-12-28 00:00:00	2014-12-28	2014-12-28 00:00:00	2014-12-28	581452		0	0	0		0	0	0	96709	0	121	40213260		
51787	4305	19133905	1984-08-31	1984-08-31 00:00:00	1984-09-09	1984-09-09 00:00:00	1984-09-09	38000177		0	0	9		0	0	0	285575	0	834102	19133905		
9855	825	40229134	1988-02-06	1988-02-06 00:00:00	1988-02-13	1988-02-13 00:00:00	1988-02-13	38000177		0	0	7		0	0	0	54665	0	1043400	40229134		
27278	2256	1713671	2005-08-23	2005-08-23 00:00:00	2005-09-06	2005-09-06 00:00:00	2005-09-06	38000177		0	0	14		0	0	0	149926	0	562251	1713671		
3993	332	40229134	1982-09-26	1982-09-26 00:00:00	1982-10-10	1982-10-10 00:00:00	1982-10-10	38000177		0	0	14		0	0	0	22014	0	1043400	40229134		
32734	2711	19006318	1955-09-28	1955-09-28 00:00:00	1955-10-12	1955-10-12 00:00:00	1955-10-12	38000177		0	0	14		0	0	0	179801	0	105078	19006318		
25697	2114	19059056	1969-12-02	1969-12-02 00:00:00	1969-12-16	1969-12-16 00:00:00	1969-12-16	38000177		0	0	14		0	0	0	140678	0	243670	19059056		
10878	906	1127078	1974-05-03	1974-05-03 00:00:00	1974-05-17	1974-05-17 00:00:00	1974-05-17	38000177		0	0	14		0	0	0	60225	0	282464	1127078		
27393	2266	1118084	2008-04-28	2008-04-28 00:00:00	2008-04-28	2008-04-28 00:00:00	\N	38000177		0	0	0		0	0	0	150678	0	00025152531	44923712		
30087	2495	19128065	2001-08-21	2001-08-21 00:00:00	2002-08-16	2002-08-16 00:00:00	2002-08-16	38000177		0	0	360		0	0	0	165154	0	749882	19128065		
48484	4017	1539411	2000-04-20	2000-04-20 00:00:00	2000-04-20	2000-04-20 00:00:00	\N	38000177		0	0	0		0	0	0	266929	0	312961	1539411		
63659	5290	1127433	1957-06-19	1957-06-19 00:00:00	1957-06-26	1957-06-26 00:00:00	1957-06-26	38000177		0	0	7		0	0	0	351911	0	313782	1127433		
41841	3464	19019979	1981-04-09	1981-04-09 00:00:00	1981-04-23	1981-04-23 00:00:00	1981-04-23	38000177		0	0	14		0	0	0	229986	0	198405	19019979		
9213	196	40213227	1996-10-26	1996-10-26 00:00:00	1996-10-26	1996-10-26 00:00:00	1996-10-26	581452		0	0	0		0	0	0	13495	0	113	40213227		
49501	4106	19059056	1949-01-01	1949-01-01 00:00:00	1949-01-15	1949-01-15 00:00:00	1949-01-15	38000177		0	0	14		0	0	0	272788	0	243670	19059056		
77503	1695	40213260	2016-11-10	2016-11-10 00:00:00	2016-11-10	2016-11-10 00:00:00	2016-11-10	581452		0	0	0		0	0	0	113508	0	121	40213260		
30623	2540	1127433	1990-10-27	1990-10-27 00:00:00	1990-11-03	1990-11-03 00:00:00	1990-11-03	38000177		0	0	7		0	0	0	167980	0	313782	1127433		
3752	312	1127433	1991-05-14	1991-05-14 00:00:00	1991-06-13	1991-06-13 00:00:00	1991-06-13	38000177		0	0	30		0	0	0	20658	0	313782	1127433		
42756	3543	1118084	1993-10-24	1993-10-24 00:00:00	1993-10-24	1993-10-24 00:00:00	\N	38000177		0	0	0		0	0	0	235373	0	00025152531	44923712		
37812	3125	46233710	1976-05-29	1976-05-29 00:00:00	1976-06-12	1976-06-12 00:00:00	1976-06-12	38000177		0	0	14		0	0	0	207996	0	1650142	46233710		
62969	5233	1127433	2012-02-12	2012-02-12 00:00:00	2012-02-26	2012-02-26 00:00:00	2012-02-26	38000177		0	0	14		0	0	0	348140	0	313782	1127433		
48346	4009	19059056	1952-03-30	1952-03-30 00:00:00	1952-04-13	1952-04-13 00:00:00	1952-04-13	38000177		0	0	14		0	0	0	266428	0	243670	19059056		
12478	1051	1713671	1975-09-20	1975-09-20 00:00:00	1975-10-04	1975-10-04 00:00:00	1975-10-04	38000177		0	0	14		0	0	0	68866	0	562251	1713671		
43138	3573	1127433	1978-09-04	1978-09-04 00:00:00	1978-09-25	1978-09-25 00:00:00	1978-09-25	38000177		0	0	21		0	0	0	237628	0	313782	1127433		
53649	4459	1115171	1999-07-11	1999-07-11 00:00:00	1999-08-15	1999-08-15 00:00:00	1999-08-15	38000177		0	0	35		0	0	0	296734	0	849574	1115171		
64545	1412	40213160	1961-10-21	1961-10-21 00:00:00	1961-10-21	1961-10-21 00:00:00	1961-10-21	581452		0	0	0		0	0	0	94012	0	10	40213160		
12625	1062	1127433	2005-09-04	2005-09-04 00:00:00	2005-10-04	2005-10-04 00:00:00	2005-10-04	38000177		0	0	30		0	0	0	69664	0	313782	1127433		
63870	5306	46233988	1969-09-24	1969-09-24 00:00:00	1969-10-08	1969-10-08 00:00:00	1969-10-08	38000177		0	0	14		0	0	0	352938	0	1652673	46233988		
46051	3814	19128022	1991-11-12	1991-11-12 00:00:00	1992-11-06	1992-11-06 00:00:00	1992-11-06	38000177		0	0	360		0	0	0	253364	0	749785	19128022		
55065	1206	40213160	1964-10-19	1964-10-19 00:00:00	1964-10-19	1964-10-19 00:00:00	1964-10-19	581452		0	0	0		0	0	0	79242	0	10	40213160		
44986	3721	1713671	1996-09-04	1996-09-04 00:00:00	1996-09-11	1996-09-11 00:00:00	1996-09-11	38000177		0	0	7		0	0	0	247388	0	562251	1713671		
41055	893	40213160	1955-08-29	1955-08-29 00:00:00	1955-08-29	1955-08-29 00:00:00	1955-08-29	581452		0	0	0		0	0	0	59480	0	10	40213160		
47280	3920	1713671	1981-09-22	1981-09-22 00:00:00	1981-10-06	1981-10-06 00:00:00	1981-10-06	38000177		0	0	14		0	0	0	260669	0	562251	1713671		
236021	5184	40213296	2006-01-06	2006-01-06 00:00:00	2006-01-06	2006-01-06 00:00:00	2006-01-06	581452		0	0	0		0	0	0	344545	0	52	40213296		
41374	3431	1127433	2000-08-17	2000-08-17 00:00:00	2000-09-07	2000-09-07 00:00:00	2000-09-07	38000177		0	0	21		0	0	0	227482	0	313782	1127433		
60654	5045	1118084	1995-05-14	1995-05-14 00:00:00	1995-05-14	1995-05-14 00:00:00	\N	38000177		0	0	0		0	0	0	335263	0	00025152531	44923712		
4551	377	1127433	1987-02-04	1987-02-04 00:00:00	1987-02-25	1987-02-25 00:00:00	1987-02-25	38000177		0	0	21		0	0	0	24967	0	313782	1127433		
182534	4010	40213314	1977-10-13	1977-10-13 00:00:00	1977-10-13	1977-10-13 00:00:00	1977-10-13	581452		0	0	0		0	0	0	266459	0	49	40213314		
63363	5262	43012754	1996-10-31	1996-10-31 00:00:00	1997-10-26	1997-10-26 00:00:00	1997-10-26	38000177		0	0	360		0	0	0	350082	0	1366343	43012754		
163643	3599	40213260	2017-05-12	2017-05-12 00:00:00	2017-05-12	2017-05-12 00:00:00	2017-05-12	581452		0	0	0		0	0	0	239063	0	121	40213260		
5209	437	1115171	2010-05-19	2010-05-19 00:00:00	2010-06-16	2010-06-16 00:00:00	2010-06-16	38000177		0	0	28		0	0	0	29053	0	849574	1115171		
54160	4500	19115351	1962-08-22	1962-08-22 00:00:00	1963-04-10	1963-04-10 00:00:00	1963-04-10	38000177		0	0	231		0	0	0	299660	0	563026	19115351		
168343	3700	40213306	1988-11-02	1988-11-02 00:00:00	1988-11-02	1988-11-02 00:00:00	1988-11-02	581452		0	0	0		0	0	0	245959	0	43	40213306		
5373	450	1713671	1989-05-13	1989-05-13 00:00:00	1989-05-27	1989-05-27 00:00:00	1989-05-27	38000177		0	0	14		0	0	0	30021	0	562251	1713671		
5436	454	920300	1954-05-16	1954-05-16 00:00:00	1954-05-23	1954-05-23 00:00:00	1954-05-23	38000177		0	0	7		0	0	0	30371	0	311989	920300		
71664	1567	40213227	2016-04-14	2016-04-14 00:00:00	2016-04-14	2016-04-14 00:00:00	2016-04-14	581452		0	0	0		0	0	0	105099	0	113	40213227		
118761	2613	40213227	2006-05-19	2006-05-19 00:00:00	2006-05-19	2006-05-19 00:00:00	2006-05-19	581452		0	0	0		0	0	0	172813	0	113	40213227		
1318	102	19078461	1994-06-10	1994-06-10 00:00:00	1994-07-15	1994-07-15 00:00:00	1994-07-15	38000177		0	0	35		0	0	0	6980	0	310965	19078461		
18864	1558	19006318	1957-02-12	1957-02-12 00:00:00	1957-02-26	1957-02-26 00:00:00	1957-02-26	38000177		0	0	14		0	0	0	104376	0	105078	19006318		
52838	1155	40213306	1990-01-15	1990-01-15 00:00:00	1990-01-15	1990-01-15 00:00:00	1990-01-15	581452		0	0	0		0	0	0	76339	0	43	40213306		
54526	4531	19059056	1915-01-26	1915-01-26 00:00:00	1915-02-09	1915-02-09 00:00:00	1915-02-09	38000177		0	0	14		0	0	0	301755	0	243670	19059056		
54900	4559	1124300	1983-05-29	1983-05-29 00:00:00	1983-05-29	1983-05-29 00:00:00	\N	38000177		0	0	0		0	0	0	303736	0	00781178901	45011828		
64285	1407	40213260	2018-11-17	2018-11-17 00:00:00	2018-11-17	2018-11-17 00:00:00	2018-11-17	581452		0	0	0		0	0	0	93549	0	121	40213260		
2532	202	1127433	2014-11-18	2014-11-18 00:00:00	2014-12-02	2014-12-02 00:00:00	2014-12-02	38000177		0	0	14		0	0	0	13889	0	313782	1127433		
19919	1635	19133873	1983-03-29	1983-03-29 00:00:00	1983-04-06	1983-04-06 00:00:00	1983-04-06	38000177		0	0	8		0	0	0	109819	0	834061	19133873		
2624	209	19078461	2003-01-21	2003-01-21 00:00:00	2003-02-04	2003-02-04 00:00:00	2003-02-04	38000177		0	0	14		0	0	0	14268	0	310965	19078461		
145083	3189	40213296	2007-06-27	2007-06-27 00:00:00	2007-06-27	2007-06-27 00:00:00	2007-06-27	581452		0	0	0		0	0	0	212258	0	52	40213296		
10534	877	1127078	1984-12-06	1984-12-06 00:00:00	1985-01-05	1985-01-05 00:00:00	1985-01-05	38000177		0	0	30		0	0	0	58439	0	282464	1127078		
81981	1791	40213160	1955-03-03	1955-03-03 00:00:00	1955-03-03	1955-03-03 00:00:00	1955-03-03	581452		0	0	0		0	0	0	120061	0	10	40213160		
43225	3580	1713671	2014-11-17	2014-11-17 00:00:00	2015-02-09	2015-02-09 00:00:00	2015-02-09	38000177		0	0	84		0	0	0	238006	0	562251	1713671		
26910	2218	42902245	2000-04-07	2000-04-07 00:00:00	2001-04-02	2001-04-02 00:00:00	2001-04-02	38000177		0	0	360		0	0	0	147760	0	1359133	42902245		
136255	2991	40213227	2001-05-04	2001-05-04 00:00:00	2001-05-04	2001-05-04 00:00:00	2001-05-04	581452		0	0	0		0	0	0	199662	0	113	40213227		
34572	2858	19059056	1936-02-04	1936-02-04 00:00:00	1936-03-05	1936-03-05 00:00:00	1936-03-05	38000177		0	0	30		0	0	0	189899	0	243670	19059056		
34603	2859	1713671	1964-09-22	1964-09-22 00:00:00	1964-09-29	1964-09-29 00:00:00	1964-09-29	38000177		0	0	7		0	0	0	190059	0	562251	1713671		
66265	1450	40213227	2014-12-28	2014-12-28 00:00:00	2014-12-28	2014-12-28 00:00:00	2014-12-28	581452		0	0	0		0	0	0	96709	0	113	40213227		
51788	4305	40229134	1999-10-14	1999-10-14 00:00:00	1999-10-28	1999-10-28 00:00:00	1999-10-28	38000177		0	0	14		0	0	0	285531	0	1043400	40229134		
9856	825	1127433	1972-04-15	1972-04-15 00:00:00	1972-04-29	1972-04-29 00:00:00	1972-04-29	38000177		0	0	14		0	0	0	54625	0	313782	1127433		
27279	2256	1713671	1994-09-06	1994-09-06 00:00:00	1994-09-13	1994-09-13 00:00:00	1994-09-13	38000177		0	0	7		0	0	0	149918	0	562251	1713671		
3994	332	40229134	2005-10-28	2005-10-28 00:00:00	2005-11-04	2005-11-04 00:00:00	2005-11-04	38000177		0	0	7		0	0	0	21958	0	1043400	40229134		
32735	2711	40229134	1966-11-08	1966-11-08 00:00:00	1966-11-22	1966-11-22 00:00:00	1966-11-22	38000177		0	0	14		0	0	0	179774	0	1043400	40229134		
25698	2114	19006318	1969-12-02	1969-12-02 00:00:00	1969-12-16	1969-12-16 00:00:00	1969-12-16	38000177		0	0	14		0	0	0	140678	0	105078	19006318		
10879	906	46233988	1974-05-03	1974-05-03 00:00:00	1974-05-17	1974-05-17 00:00:00	1974-05-17	38000177		0	0	14		0	0	0	60225	0	1652673	46233988		
27394	2267	19059056	1990-09-08	1990-09-08 00:00:00	1990-10-13	1990-10-13 00:00:00	1990-10-13	38000177		0	0	35		0	0	0	150706	0	243670	19059056		
30088	2495	19019979	1992-09-27	1992-09-27 00:00:00	1992-10-11	1992-10-11 00:00:00	1992-10-11	38000177		0	0	14		0	0	0	165162	0	198405	19019979		
48485	4017	19075601	2000-04-20	2000-04-20 00:00:00	2014-08-07	2014-08-07 00:00:00	2014-08-07	38000177		0	0	5222		0	0	0	266929	0	309362	19075601		
63660	5290	1551192	1955-01-30	1955-01-30 00:00:00	1955-01-30	1955-01-30 00:00:00	1955-01-30	38000177		0	0	0		0	0	0	352029	0	312617	1551192		
41842	3464	46233988	1981-04-09	1981-04-09 00:00:00	1981-04-23	1981-04-23 00:00:00	1981-04-23	38000177		0	0	14		0	0	0	229986	0	1652673	46233988		
9214	196	40213160	1955-01-22	1955-01-22 00:00:00	1955-01-22	1955-01-22 00:00:00	1955-01-22	581452		0	0	0		0	0	0	13476	0	10	40213160		
49502	4106	19006318	1949-01-01	1949-01-01 00:00:00	1949-01-15	1949-01-15 00:00:00	1949-01-15	38000177		0	0	14		0	0	0	272788	0	105078	19006318		
77504	1695	40213296	2006-02-16	2006-02-16 00:00:00	2006-02-16	2006-02-16 00:00:00	2006-02-16	581452		0	0	0		0	0	0	113444	0	52	40213296		
30624	2540	1127433	1972-12-21	1972-12-21 00:00:00	1973-01-04	1973-01-04 00:00:00	1973-01-04	38000177		0	0	14		0	0	0	167987	0	313782	1127433		
3753	312	1713671	1974-12-18	1974-12-18 00:00:00	1975-01-01	1975-01-01 00:00:00	1975-01-01	38000177		0	0	14		0	0	0	20661	0	562251	1713671		
42757	3543	19006318	1960-05-05	1960-05-05 00:00:00	1960-05-19	1960-05-19 00:00:00	1960-05-19	38000177		0	0	14		0	0	0	235375	0	105078	19006318		
37813	3125	19078461	1976-05-29	1976-05-29 00:00:00	1976-06-12	1976-06-12 00:00:00	1976-06-12	38000177		0	0	14		0	0	0	207996	0	310965	19078461		
62970	5234	1127433	1949-02-28	1949-02-28 00:00:00	1949-03-14	1949-03-14 00:00:00	1949-03-14	38000177		0	0	14		0	0	0	348219	0	313782	1127433		
48347	4009	1127433	1959-01-12	1959-01-12 00:00:00	1959-01-19	1959-01-19 00:00:00	1959-01-19	38000177		0	0	7		0	0	0	266441	0	313782	1127433		
12479	1051	1551192	1966-03-06	1966-03-06 00:00:00	1966-03-06	1966-03-06 00:00:00	1966-03-06	38000177		0	0	0		0	0	0	68869	0	312617	1551192		
43139	3573	19059056	1928-03-02	1928-03-02 00:00:00	1928-03-16	1928-03-16 00:00:00	1928-03-16	38000177		0	0	14		0	0	0	237547	0	243670	19059056		
53650	4459	19059056	1970-11-13	1970-11-13 00:00:00	1970-11-27	1970-11-27 00:00:00	1970-11-27	38000177		0	0	14		0	0	0	296709	0	243670	19059056		
64550	1412	40213296	2001-05-19	2001-05-19 00:00:00	2001-05-19	2001-05-19 00:00:00	2001-05-19	581452		0	0	0		0	0	0	94048	0	52	40213296		
12626	1062	1713671	2018-01-15	2018-01-15 00:00:00	2018-01-22	2018-01-22 00:00:00	2018-01-22	38000177		0	0	7		0	0	0	69687	0	562251	1713671		
63871	5306	1127433	2003-08-08	2003-08-08 00:00:00	2003-09-12	2003-09-12 00:00:00	2003-09-12	38000177		0	0	35		0	0	0	352983	0	313782	1127433		
18063	1496	1124300	1957-12-25	1957-12-25 00:00:00	1957-12-25	1957-12-25 00:00:00	\N	38000177		0	0	0		0	0	0	99659	0	00781178901	45011828		
55071	1206	40213227	2006-02-20	2006-02-20 00:00:00	2006-02-20	2006-02-20 00:00:00	2006-02-20	581452		0	0	0		0	0	0	79227	0	113	40213227		
55445	4604	40229134	1986-08-14	1986-08-14 00:00:00	1986-08-28	1986-08-28 00:00:00	1986-08-28	38000177		0	0	14		0	0	0	306727	0	1043400	40229134		
146598	3224	40213160	1964-12-25	1964-12-25 00:00:00	1964-12-25	1964-12-25 00:00:00	1964-12-25	581452		0	0	0		0	0	0	214353	0	10	40213160		
47281	3920	1127078	1974-05-18	1974-05-18 00:00:00	1974-06-01	1974-06-01 00:00:00	1974-06-01	38000177		0	0	14		0	0	0	260673	0	282464	1127078		
236023	5184	40213160	1965-02-26	1965-02-26 00:00:00	1965-02-26	1965-02-26 00:00:00	1965-02-26	581452		0	0	0		0	0	0	344530	0	10	40213160		
41375	3431	19133873	1971-11-19	1971-11-19 00:00:00	1971-12-02	1971-12-02 00:00:00	1971-12-02	38000177		0	0	13		0	0	0	227457	0	834061	19133873		
60655	5045	1127433	1967-04-28	1967-04-28 00:00:00	1967-05-12	1967-05-12 00:00:00	1967-05-12	38000177		0	0	14		0	0	0	335231	0	313782	1127433		
4552	377	19128065	1987-12-24	1987-12-24 00:00:00	1988-12-18	1988-12-18 00:00:00	1988-12-18	38000177		0	0	360		0	0	0	24974	0	749882	19128065		
182535	4010	40213160	1977-10-13	1977-10-13 00:00:00	1977-10-13	1977-10-13 00:00:00	1977-10-13	581452		0	0	0		0	0	0	266459	0	10	40213160		
63372	5264	40229134	2016-02-22	2016-02-22 00:00:00	2016-02-29	2016-02-29 00:00:00	2016-02-29	38000177		0	0	7		0	0	0	350245	0	1043400	40229134		
6312	528	920300	1981-06-18	1981-06-18 00:00:00	1981-06-25	1981-06-25 00:00:00	1981-06-25	38000177		0	0	7		0	0	0	35218	0	311989	920300		
5211	437	40229134	2002-09-23	2002-09-23 00:00:00	2002-10-07	2002-10-07 00:00:00	2002-10-07	38000177		0	0	14		0	0	0	28993	0	1043400	40229134		
54161	4500	19074679	1961-09-13	1961-09-13 00:00:00	1962-01-03	1962-01-03 00:00:00	1962-01-03	38000177		0	0	112		0	0	0	299601	0	308971	19074679		
168347	3700	40213296	2007-06-20	2007-06-20 00:00:00	2007-06-20	2007-06-20 00:00:00	2007-06-20	581452		0	0	0		0	0	0	245960	0	52	40213296		
5374	450	1127433	2008-10-15	2008-10-15 00:00:00	2008-10-22	2008-10-22 00:00:00	2008-10-22	38000177		0	0	7		0	0	0	30008	0	313782	1127433		
5437	454	19059056	1936-01-08	1936-01-08 00:00:00	1936-01-22	1936-01-22 00:00:00	1936-01-22	38000177		0	0	14		0	0	0	30292	0	243670	19059056		
71665	1567	40213296	2016-04-14	2016-04-14 00:00:00	2016-04-14	2016-04-14 00:00:00	2016-04-14	581452		0	0	0		0	0	0	105099	0	52	40213296		
118762	2613	40213260	2006-05-19	2006-05-19 00:00:00	2006-05-19	2006-05-19 00:00:00	2006-05-19	581452		0	0	0		0	0	0	172813	0	121	40213260		
1319	103	964261	2002-05-19	2002-05-19 00:00:00	2002-05-19	2002-05-19 00:00:00	\N	38000177		0	0	0		0	0	0	7047	0	2001499	964261		
18865	1558	19059056	1969-04-10	1969-04-10 00:00:00	1969-05-01	1969-05-01 00:00:00	1969-05-01	38000177		0	0	21		0	0	0	104302	0	243670	19059056		
52842	1155	40213306	1988-10-24	1988-10-24 00:00:00	1988-10-24	1988-10-24 00:00:00	1988-10-24	581452		0	0	0		0	0	0	76338	0	43	40213306		
54527	4531	19078461	1995-04-20	1995-04-20 00:00:00	1995-05-20	1995-05-20 00:00:00	1995-05-20	38000177		0	0	30		0	0	0	301708	0	310965	19078461		
54901	4560	19059056	1969-06-23	1969-06-23 00:00:00	1969-07-07	1969-07-07 00:00:00	1969-07-07	38000177		0	0	14		0	0	0	303816	0	243670	19059056		
64286	1407	40213296	2007-11-17	2007-11-17 00:00:00	2007-11-17	2007-11-17 00:00:00	2007-11-17	581452		0	0	0		0	0	0	93544	0	52	40213296		
2533	202	19059056	1942-04-13	1942-04-13 00:00:00	1942-05-18	1942-05-18 00:00:00	1942-05-18	38000177		0	0	35		0	0	0	13880	0	243670	19059056		
19920	1635	46275916	2013-03-27	2013-03-27 00:00:00	2013-03-27	2013-03-27 00:00:00	2013-03-27	38000177		0	0	0		0	0	0	109831	0	1660014	46275916		
2625	209	1127433	1958-10-15	1958-10-15 00:00:00	1958-10-22	1958-10-22 00:00:00	1958-10-22	38000177		0	0	7		0	0	0	14258	0	313782	1127433		
145086	3189	40213160	1970-05-27	1970-05-27 00:00:00	1970-05-27	1970-05-27 00:00:00	1970-05-27	581452		0	0	0		0	0	0	212262	0	10	40213160		
10535	877	19112599	1978-06-07	1978-06-07 00:00:00	1978-06-07	1978-06-07 00:00:00	\N	38000177		0	0	0		0	0	0	58348	0	477045	19112599		
43402	946	40213296	2001-03-28	2001-03-28 00:00:00	2001-03-28	2001-03-28 00:00:00	2001-03-28	581452		0	0	0		0	0	0	62769	0	52	40213296		
43226	3580	19128065	1986-03-21	1986-03-21 00:00:00	1987-03-16	1987-03-16 00:00:00	1987-03-16	38000177		0	0	360		0	0	0	238028	0	749882	19128065		
26911	2218	40236824	2015-06-19	2015-06-19 00:00:00	2015-06-26	2015-06-26 00:00:00	2015-06-26	38000177		0	0	7		0	0	0	147757	0	1094107	40236824		
136256	2991	40213296	2001-05-04	2001-05-04 00:00:00	2001-05-04	2001-05-04 00:00:00	2001-05-04	581452		0	0	0		0	0	0	199662	0	52	40213296		
34573	2858	1127433	1982-02-23	1982-02-23 00:00:00	1982-03-02	1982-03-02 00:00:00	1982-03-02	38000177		0	0	7		0	0	0	189782	0	313782	1127433		
34604	2859	1127433	1944-01-08	1944-01-08 00:00:00	1944-01-15	1944-01-15 00:00:00	1944-01-15	38000177		0	0	7		0	0	0	189962	0	313782	1127433		
66268	1450	40213296	2006-12-03	2006-12-03 00:00:00	2006-12-03	2006-12-03 00:00:00	2006-12-03	581452		0	0	0		0	0	0	96692	0	52	40213296		
51791	4305	19059056	1958-12-17	1958-12-17 00:00:00	1958-12-31	1958-12-31 00:00:00	1958-12-31	38000177		0	0	14		0	0	0	285587	0	243670	19059056		
9857	825	19078461	2011-06-23	2011-06-23 00:00:00	2011-07-14	2011-07-14 00:00:00	2011-07-14	38000177		0	0	21		0	0	0	54654	0	310965	19078461		
27280	2256	19133873	1989-05-17	1989-05-17 00:00:00	1989-05-29	1989-05-29 00:00:00	1989-05-29	38000177		0	0	12		0	0	0	149961	0	834061	19133873		
3995	332	19059056	1979-09-18	1979-09-18 00:00:00	1979-10-02	1979-10-02 00:00:00	1979-10-02	38000177		0	0	14		0	0	0	21908	0	243670	19059056		
32736	2711	19008572	1974-02-24	1974-02-24 00:00:00	1974-03-17	1974-03-17 00:00:00	1974-03-17	38000177		0	0	21		0	0	0	179745	0	106258	19008572		
61747	5138	1127433	2001-08-28	2001-08-28 00:00:00	2001-11-26	2001-11-26 00:00:00	2001-11-26	38000177		0	0	90		0	0	0	341453	0	313782	1127433		
10880	906	1115171	2011-10-07	2011-10-07 00:00:00	2012-01-05	2012-01-05 00:00:00	2012-01-05	38000177		0	0	90		0	0	0	60236	0	849574	1115171		
27395	2267	19128065	1985-11-08	1985-11-08 00:00:00	1986-11-03	1986-11-03 00:00:00	1986-11-03	38000177		0	0	360		0	0	0	150743	0	749882	19128065		
30089	2495	19019979	1987-06-26	1987-06-26 00:00:00	1987-08-25	1987-08-25 00:00:00	1987-08-25	38000177		0	0	60		0	0	0	165161	0	198405	19019979		
48486	4017	1332419	2000-04-20	2000-04-20 00:00:00	2000-04-20	2000-04-20 00:00:00	\N	38000177		0	0	0		0	0	0	266929	0	197361	1332419		
63661	5290	19129655	1971-09-03	1971-09-03 00:00:00	1971-10-08	1971-10-08 00:00:00	1971-10-08	38000177		0	0	35		0	0	0	352031	0	789980	19129655		
41843	3464	40228214	2009-05-29	2009-05-29 00:00:00	2009-05-29	2009-05-29 00:00:00	\N	38000177		0	0	0		0	0	0	229905	0	1014678	40228214		
9230	197	40213260	2011-10-23	2011-10-23 00:00:00	2011-10-23	2011-10-23 00:00:00	2011-10-23	581452		0	0	0		0	0	0	13566	0	121	40213260		
49503	4106	19059056	1966-02-18	1966-02-18 00:00:00	1966-03-18	1966-03-18 00:00:00	1966-03-18	38000177		0	0	28		0	0	0	272861	0	243670	19059056		
88789	1947	40213227	2010-06-27	2010-06-27 00:00:00	2010-06-27	2010-06-27 00:00:00	2010-06-27	581452		0	0	0		0	0	0	129453	0	113	40213227		
30625	2541	19128022	1992-09-17	1992-09-17 00:00:00	1993-09-12	1993-09-12 00:00:00	1993-09-12	38000177		0	0	360		0	0	0	168036	0	749785	19128022		
3754	312	1713671	2012-04-26	2012-04-26 00:00:00	2012-05-03	2012-05-03 00:00:00	2012-05-03	38000177		0	0	7		0	0	0	20693	0	562251	1713671		
42758	3543	1127078	1960-05-05	1960-05-05 00:00:00	1960-05-19	1960-05-19 00:00:00	1960-05-19	38000177		0	0	14		0	0	0	235375	0	282464	1127078		
37814	3125	1127078	1953-06-17	1953-06-17 00:00:00	1953-07-08	1953-07-08 00:00:00	1953-07-08	38000177		0	0	21		0	0	0	208003	0	282464	1127078		
62971	5234	19059056	1962-09-30	1962-09-30 00:00:00	1962-10-21	1962-10-21 00:00:00	1962-10-21	38000177		0	0	21		0	0	0	348229	0	243670	19059056		
48348	4009	1127433	1979-03-06	1979-03-06 00:00:00	1979-03-20	1979-03-20 00:00:00	1979-03-20	38000177		0	0	14		0	0	0	266443	0	313782	1127433		
12480	1051	19078461	1988-08-07	1988-08-07 00:00:00	1988-08-21	1988-08-21 00:00:00	1988-08-21	38000177		0	0	14		0	0	0	68936	0	310965	19078461		
65430	1431	40213160	1955-09-17	1955-09-17 00:00:00	1955-09-17	1955-09-17 00:00:00	1955-09-17	581452		0	0	0		0	0	0	95197	0	10	40213160		
53651	4459	19078461	2012-12-03	2012-12-03 00:00:00	2012-12-17	2012-12-17 00:00:00	2012-12-17	38000177		0	0	14		0	0	0	296735	0	310965	19078461		
197834	4347	40213227	2017-05-28	2017-05-28 00:00:00	2017-05-28	2017-05-28 00:00:00	2017-05-28	581452		0	0	0		0	0	0	288262	0	113	40213227		
12627	1062	19059056	1966-12-16	1966-12-16 00:00:00	1966-12-30	1966-12-30 00:00:00	1966-12-30	38000177		0	0	14		0	0	0	69677	0	243670	19059056		
63872	5306	1127433	1997-06-19	1997-06-19 00:00:00	1997-07-10	1997-07-10 00:00:00	1997-07-10	38000177		0	0	21		0	0	0	352982	0	313782	1127433		
18064	1496	19059056	1922-08-06	1922-08-06 00:00:00	1922-08-20	1922-08-20 00:00:00	1922-08-20	38000177		0	0	14		0	0	0	99701	0	243670	19059056		
55072	1206	40213296	2006-02-20	2006-02-20 00:00:00	2006-02-20	2006-02-20 00:00:00	2006-02-20	581452		0	0	0		0	0	0	79227	0	52	40213296		
55446	4604	19133873	1971-02-27	1971-02-27 00:00:00	1971-03-11	1971-03-11 00:00:00	1971-03-11	38000177		0	0	12		0	0	0	306761	0	834061	19133873		
146601	3224	40213227	2011-04-22	2011-04-22 00:00:00	2011-04-22	2011-04-22 00:00:00	2011-04-22	581452		0	0	0		0	0	0	214337	0	113	40213227		
47282	3920	19006318	1974-05-18	1974-05-18 00:00:00	1974-06-01	1974-06-01 00:00:00	1974-06-01	38000177		0	0	14		0	0	0	260673	0	105078	19006318		
236026	5184	40213227	2016-03-18	2016-03-18 00:00:00	2016-03-18	2016-03-18 00:00:00	2016-03-18	581452		0	0	0		0	0	0	344564	0	113	40213227		
41376	3431	1127433	1975-11-22	1975-11-22 00:00:00	1975-12-06	1975-12-06 00:00:00	1975-12-06	38000177		0	0	14		0	0	0	227475	0	313782	1127433		
60656	5045	19133873	1974-09-16	1974-09-16 00:00:00	1974-09-24	1974-09-24 00:00:00	1974-09-24	38000177		0	0	8		0	0	0	335266	0	834061	19133873		
4553	377	1127433	1995-07-13	1995-07-13 00:00:00	1995-08-17	1995-08-17 00:00:00	1995-08-17	38000177		0	0	35		0	0	0	24996	0	313782	1127433		
182537	4010	40213296	2017-05-11	2017-05-11 00:00:00	2017-05-11	2017-05-11 00:00:00	2017-05-11	581452		0	0	0		0	0	0	266512	0	52	40213296		
63373	5264	1127433	1980-04-26	1980-04-26 00:00:00	1980-05-03	1980-05-03 00:00:00	1980-05-03	38000177		0	0	7		0	0	0	350206	0	313782	1127433		
6313	528	40236824	1981-06-18	1981-06-18 00:00:00	1981-06-25	1981-06-25 00:00:00	1981-06-25	38000177		0	0	7		0	0	0	35218	0	1094107	40236824		
5212	437	920334	1978-03-08	1978-03-08 00:00:00	1978-03-15	1978-03-15 00:00:00	1978-03-15	38000177		0	0	7		0	0	0	28975	0	311995	920334		
54162	4500	1713671	2012-03-20	2012-03-20 00:00:00	2012-04-03	2012-04-03 00:00:00	2012-04-03	38000177		0	0	14		0	0	0	299594	0	562251	1713671		
168355	3701	40213227	1994-04-11	1994-04-11 00:00:00	1994-04-11	1994-04-11 00:00:00	1994-04-11	581452		0	0	0		0	0	0	246072	0	113	40213227		
5375	450	46233988	1970-06-23	1970-06-23 00:00:00	1970-07-07	1970-07-07 00:00:00	1970-07-07	38000177		0	0	14		0	0	0	30038	0	1652673	46233988		
5438	454	19059056	1935-07-30	1935-07-30 00:00:00	1935-08-13	1935-08-13 00:00:00	1935-08-13	38000177		0	0	14		0	0	0	30304	0	243670	19059056		
140215	3079	40213227	1994-09-08	1994-09-08 00:00:00	1994-09-08	1994-09-08 00:00:00	1994-09-08	581452		0	0	0		0	0	0	204953	0	113	40213227		
118765	2613	40213227	2016-07-15	2016-07-15 00:00:00	2016-07-15	2016-07-15 00:00:00	2016-07-15	581452		0	0	0		0	0	0	172774	0	113	40213227		
1321	103	1127433	2002-04-30	2002-04-30 00:00:00	2002-05-07	2002-05-07 00:00:00	2002-05-07	38000177		0	0	7		0	0	0	7046	0	313782	1127433		
18866	1558	1713671	1974-01-13	1974-01-13 00:00:00	1974-02-03	1974-02-03 00:00:00	1974-02-03	38000177		0	0	21		0	0	0	104381	0	562251	1713671		
52846	1155	40213227	2017-03-13	2017-03-13 00:00:00	2017-03-13	2017-03-13 00:00:00	2017-03-13	581452		0	0	0		0	0	0	76341	0	113	40213227		
54528	4531	19059056	1930-04-21	1930-04-21 00:00:00	1930-05-19	1930-05-19 00:00:00	1930-05-19	38000177		0	0	28		0	0	0	301823	0	243670	19059056		
54902	4560	19019979	1976-08-20	1976-08-20 00:00:00	1976-09-10	1976-09-10 00:00:00	1976-09-10	38000177		0	0	21		0	0	0	303808	0	198405	19019979		
64291	1407	40213227	2009-11-21	2009-11-21 00:00:00	2009-11-21	2009-11-21 00:00:00	2009-11-21	581452		0	0	0		0	0	0	93517	0	113	40213227		
2534	202	40220960	1997-10-25	1997-10-25 00:00:00	1997-10-25	1997-10-25 00:00:00	1997-10-25	38000177		0	0	0		0	0	0	13877	0	1804799	40220960		
30379	2518	920300	1973-10-01	1973-10-01 00:00:00	1973-10-08	1973-10-08 00:00:00	1973-10-08	38000177		0	0	7		0	0	0	166529	0	311989	920300		
2633	211	40229134	1969-08-03	1969-08-03 00:00:00	1969-08-10	1969-08-10 00:00:00	1969-08-10	38000177		0	0	7		0	0	0	14388	0	1043400	40229134		
145090	3189	40213227	2016-06-22	2016-06-22 00:00:00	2016-06-22	2016-06-22 00:00:00	2016-06-22	581452		0	0	0		0	0	0	212293	0	113	40213227		
10536	877	19128022	1995-04-09	1995-04-09 00:00:00	1996-04-03	1996-04-03 00:00:00	1996-04-03	38000177		0	0	360		0	0	0	58386	0	749785	19128022		
43407	946	40213160	1965-03-17	1965-03-17 00:00:00	1965-03-17	1965-03-17 00:00:00	1965-03-17	581452		0	0	0		0	0	0	62837	0	10	40213160		
43227	3580	46233988	1979-03-18	1979-03-18 00:00:00	1979-04-01	1979-04-01 00:00:00	1979-04-01	38000177		0	0	14		0	0	0	238009	0	1652673	46233988		
26912	2218	920300	2015-06-19	2015-06-19 00:00:00	2015-06-26	2015-06-26 00:00:00	2015-06-26	38000177		0	0	7		0	0	0	147757	0	311989	920300		
136258	2991	40213160	1960-08-12	1960-08-12 00:00:00	1960-08-12	1960-08-12 00:00:00	1960-08-12	581452		0	0	0		0	0	0	199634	0	10	40213160		
34574	2858	19126352	2014-07-09	2014-07-09 00:00:00	2014-07-09	2014-07-09 00:00:00	\N	38000177		0	0	0		0	0	0	189870	0	705129	19126352		
34605	2859	19133873	1951-09-27	1951-09-27 00:00:00	1951-10-04	1951-10-04 00:00:00	1951-10-04	38000177		0	0	7		0	0	0	190023	0	834061	19133873		
66269	1450	40213160	1963-10-20	1963-10-20 00:00:00	1963-10-20	1963-10-20 00:00:00	1963-10-20	581452		0	0	0		0	0	0	96729	0	10	40213160		
51792	4305	19006318	1958-12-17	1958-12-17 00:00:00	1958-12-31	1958-12-31 00:00:00	1958-12-31	38000177		0	0	14		0	0	0	285587	0	105078	19006318		
9858	826	19128065	1976-06-22	1976-06-22 00:00:00	1977-06-17	1977-06-17 00:00:00	1977-06-17	38000177		0	0	360		0	0	0	54716	0	749882	19128065		
27281	2256	1127433	1992-09-05	1992-09-05 00:00:00	1992-09-19	1992-09-19 00:00:00	1992-09-19	38000177		0	0	14		0	0	0	149951	0	313782	1127433		
3996	332	1154615	1965-06-20	1965-06-20 00:00:00	1965-06-20	1965-06-20 00:00:00	\N	38000177		0	0	0		0	0	0	22030	0	745679	1154615		
32737	2711	19008572	1981-09-08	1981-09-08 00:00:00	1981-09-22	1981-09-22 00:00:00	1981-09-22	38000177		0	0	14		0	0	0	179622	0	106258	19008572		
61748	5138	19078461	2009-05-18	2009-05-18 00:00:00	2009-06-08	2009-06-08 00:00:00	2009-06-08	38000177		0	0	21		0	0	0	341454	0	310965	19078461		
10881	906	1127433	1986-12-12	1986-12-12 00:00:00	1986-12-26	1986-12-26 00:00:00	1986-12-26	38000177		0	0	14		0	0	0	60234	0	313782	1127433		
27396	2267	1713671	1980-12-20	1980-12-20 00:00:00	1980-12-27	1980-12-27 00:00:00	1980-12-27	38000177		0	0	7		0	0	0	150722	0	562251	1713671		
30090	2495	19128263	2005-07-31	2005-07-31 00:00:00	2006-07-26	2006-07-26 00:00:00	2006-07-26	38000177		0	0	360		0	0	0	165157	0	751905	19128263		
48487	4017	1713671	2012-11-01	2012-11-01 00:00:00	2012-11-22	2012-11-22 00:00:00	2012-11-22	38000177		0	0	21		0	0	0	266977	0	562251	1713671		
63662	5290	40231925	1971-09-03	1971-09-03 00:00:00	1971-09-03	1971-09-03 00:00:00	\N	38000177		0	0	0		0	0	0	352031	0	1049221	40231925		
41844	3464	1594382	2009-05-29	2009-05-29 00:00:00	2009-05-29	2009-05-29 00:00:00	\N	38000177		0	0	0		0	0	0	229905	0	1870230	1594382		
9232	197	40213227	2011-10-23	2011-10-23 00:00:00	2011-10-23	2011-10-23 00:00:00	2011-10-23	581452		0	0	0		0	0	0	13566	0	113	40213227		
49504	4106	19133873	1944-07-05	1944-07-05 00:00:00	1944-07-17	1944-07-17 00:00:00	1944-07-17	38000177		0	0	12		0	0	0	272831	0	834061	19133873		
724	16	40213227	2002-12-25	2002-12-25 00:00:00	2002-12-25	2002-12-25 00:00:00	2002-12-25	581452		0	0	0		0	0	0	1261	0	113	40213227		
30626	2541	1127433	1989-04-28	1989-04-28 00:00:00	1989-05-05	1989-05-05 00:00:00	1989-05-05	38000177		0	0	7		0	0	0	168052	0	313782	1127433		
3755	312	1127433	2006-12-03	2006-12-03 00:00:00	2006-12-10	2006-12-10 00:00:00	2006-12-10	38000177		0	0	7		0	0	0	20675	0	313782	1127433		
42759	3543	1127433	1994-09-25	1994-09-25 00:00:00	1994-10-30	1994-10-30 00:00:00	1994-10-30	38000177		0	0	35		0	0	0	235331	0	313782	1127433		
37815	3125	1127433	2014-08-28	2014-08-28 00:00:00	2014-09-25	2014-09-25 00:00:00	2014-09-25	38000177		0	0	28		0	0	0	207931	0	313782	1127433		
62972	5234	40169281	1998-04-29	1998-04-29 00:00:00	1998-04-29	1998-04-29 00:00:00	\N	38000177		0	0	0		0	0	0	348208	0	896209	40169281		
48349	4009	1127433	1952-11-26	1952-11-26 00:00:00	1952-12-10	1952-12-10 00:00:00	1952-12-10	38000177		0	0	14		0	0	0	266388	0	313782	1127433		
12481	1051	19128065	1985-12-31	1985-12-31 00:00:00	1986-12-26	1986-12-26 00:00:00	1986-12-26	38000177		0	0	360		0	0	0	68888	0	749882	19128065		
65432	1431	40213227	2000-10-07	2000-10-07 00:00:00	2000-10-07	2000-10-07 00:00:00	2000-10-07	581452		0	0	0		0	0	0	95204	0	113	40213227		
53652	4460	1127433	1993-12-17	1993-12-17 00:00:00	1994-01-07	1994-01-07 00:00:00	1994-01-07	38000177		0	0	21		0	0	0	296740	0	313782	1127433		
197835	4347	40213260	2017-05-28	2017-05-28 00:00:00	2017-05-28	2017-05-28 00:00:00	2017-05-28	581452		0	0	0		0	0	0	288262	0	121	40213260		
12628	1062	19006318	1966-12-16	1966-12-16 00:00:00	1966-12-30	1966-12-30 00:00:00	1966-12-30	38000177		0	0	14		0	0	0	69677	0	105078	19006318		
63873	5306	46233988	1969-03-20	1969-03-20 00:00:00	1969-04-03	1969-04-03 00:00:00	1969-04-03	38000177		0	0	14		0	0	0	352951	0	1652673	46233988		
18065	1496	19059056	1933-05-10	1933-05-10 00:00:00	1933-06-14	1933-06-14 00:00:00	1933-06-14	38000177		0	0	35		0	0	0	99644	0	243670	19059056		
137015	3007	40213227	2008-06-04	2008-06-04 00:00:00	2008-06-04	2008-06-04 00:00:00	2008-06-04	581452		0	0	0		0	0	0	200618	0	113	40213227		
55447	4604	1127433	1987-10-23	1987-10-23 00:00:00	1987-10-30	1987-10-30 00:00:00	1987-10-30	38000177		0	0	7		0	0	0	306714	0	313782	1127433		
6194	135	40213160	1976-05-25	1976-05-25 00:00:00	1976-05-25	1976-05-25 00:00:00	1976-05-25	581452		0	0	0		0	0	0	9068	0	10	40213160		
47283	3920	19133873	1976-07-07	1976-07-07 00:00:00	1976-07-16	1976-07-16 00:00:00	1976-07-16	38000177		0	0	9		0	0	0	260634	0	834061	19133873		
236027	5184	40213260	2016-03-18	2016-03-18 00:00:00	2016-03-18	2016-03-18 00:00:00	2016-03-18	581452		0	0	0		0	0	0	344564	0	121	40213260		
41377	3431	1118084	1999-05-19	1999-05-19 00:00:00	1999-05-19	1999-05-19 00:00:00	\N	38000177		0	0	0		0	0	0	227405	0	00025152531	44923712		
60657	5045	40229134	1985-02-08	1985-02-08 00:00:00	1985-02-22	1985-02-22 00:00:00	1985-02-22	38000177		0	0	14		0	0	0	335268	0	1043400	40229134		
4558	379	19128022	1989-03-25	1989-03-25 00:00:00	1990-03-20	1990-03-20 00:00:00	1990-03-20	38000177		0	0	360		0	0	0	25109	0	749785	19128022		
182538	4010	40213314	1978-07-13	1978-07-13 00:00:00	1978-07-13	1978-07-13 00:00:00	1978-07-13	581452		0	0	0		0	0	0	266460	0	49	40213314		
63374	5264	1713671	1992-02-11	1992-02-11 00:00:00	1992-02-25	1992-02-25 00:00:00	1992-02-25	38000177		0	0	14		0	0	0	350213	0	562251	1713671		
6315	528	1127433	2002-04-13	2002-04-13 00:00:00	2002-07-12	2002-07-12 00:00:00	2002-07-12	38000177		0	0	90		0	0	0	35211	0	313782	1127433		
5213	437	1127433	1950-01-23	1950-01-23 00:00:00	1950-02-06	1950-02-06 00:00:00	1950-02-06	38000177		0	0	14		0	0	0	28965	0	313782	1127433		
54163	4500	19078461	2007-07-19	2007-07-19 00:00:00	2007-08-09	2007-08-09 00:00:00	2007-08-09	38000177		0	0	21		0	0	0	299606	0	310965	19078461		
10652	227	40213160	1972-03-24	1972-03-24 00:00:00	1972-03-24	1972-03-24 00:00:00	1972-03-24	581452		0	0	0		0	0	0	\N	0	10	40213160		
5376	450	1127078	1970-06-23	1970-06-23 00:00:00	1970-07-07	1970-07-07 00:00:00	1970-07-07	38000177		0	0	14		0	0	0	30038	0	282464	1127078		
5439	454	1127433	1975-03-28	1975-03-28 00:00:00	1975-04-11	1975-04-11 00:00:00	1975-04-11	38000177		0	0	14		0	0	0	30283	0	313782	1127433		
140234	3080	40213227	2012-10-25	2012-10-25 00:00:00	2012-10-25	2012-10-25 00:00:00	2012-10-25	581452		0	0	0		0	0	0	204981	0	113	40213227		
118771	2613	40213160	1956-01-20	1956-01-20 00:00:00	1956-01-20	1956-01-20 00:00:00	1956-01-20	581452		0	0	0		0	0	0	172737	0	10	40213160		
1322	103	19133905	2009-08-26	2009-08-26 00:00:00	2009-09-05	2009-09-05 00:00:00	2009-09-05	38000177		0	0	10		0	0	0	7035	0	834102	19133905		
18867	1558	19133905	1999-08-03	1999-08-03 00:00:00	1999-08-11	1999-08-11 00:00:00	1999-08-11	38000177		0	0	8		0	0	0	104308	0	834102	19133905		
52847	1155	40213260	2017-03-13	2017-03-13 00:00:00	2017-03-13	2017-03-13 00:00:00	2017-03-13	581452		0	0	0		0	0	0	76341	0	121	40213260		
54529	4531	40231925	1930-04-21	1930-04-21 00:00:00	1930-04-21	1930-04-21 00:00:00	\N	38000177		0	0	0		0	0	0	301823	0	1049221	40231925		
54903	4560	1118084	2007-02-04	2007-02-04 00:00:00	2007-02-04	2007-02-04 00:00:00	\N	38000177		0	0	0		0	0	0	303866	0	00025152531	44923712		
64292	1407	40213296	2009-11-21	2009-11-21 00:00:00	2009-11-21	2009-11-21 00:00:00	2009-11-21	581452		0	0	0		0	0	0	93517	0	52	40213296		
2535	202	19075601	1997-10-25	1997-10-25 00:00:00	1997-10-25	1997-10-25 00:00:00	1997-10-25	38000177		0	0	0		0	0	0	13877	0	309362	19075601		
30380	2518	40236824	1973-10-01	1973-10-01 00:00:00	1973-10-08	1973-10-08 00:00:00	1973-10-08	38000177		0	0	7		0	0	0	166529	0	1094107	40236824		
2634	211	1713671	2016-11-27	2016-11-27 00:00:00	2016-12-11	2016-12-11 00:00:00	2016-12-11	38000177		0	0	14		0	0	0	14391	0	562251	1713671		
145091	3189	40213260	2016-06-22	2016-06-22 00:00:00	2016-06-22	2016-06-22 00:00:00	2016-06-22	581452		0	0	0		0	0	0	212293	0	121	40213260		
10548	879	1713671	1998-04-01	1998-04-01 00:00:00	1998-04-08	1998-04-08 00:00:00	1998-04-08	38000177		0	0	7		0	0	0	58560	0	562251	1713671		
43409	946	40213227	2003-04-02	2003-04-02 00:00:00	2003-04-02	2003-04-02 00:00:00	2003-04-02	581452		0	0	0		0	0	0	62830	0	113	40213227		
43228	3580	19059056	1979-03-18	1979-03-18 00:00:00	1979-04-01	1979-04-01 00:00:00	1979-04-01	38000177		0	0	14		0	0	0	238009	0	243670	19059056		
26913	2218	40236824	2016-07-23	2016-07-23 00:00:00	2016-07-30	2016-07-30 00:00:00	2016-07-30	38000177		0	0	7		0	0	0	147758	0	1094107	40236824		
136261	2991	40213306	1982-05-07	1982-05-07 00:00:00	1982-05-07	1982-05-07 00:00:00	1982-05-07	581452		0	0	0		0	0	0	199639	0	43	40213306		
34575	2858	1332419	2014-07-09	2014-07-09 00:00:00	2014-07-09	2014-07-09 00:00:00	\N	38000177		0	0	0		0	0	0	189870	0	197361	1332419		
34606	2859	1127433	1948-06-02	1948-06-02 00:00:00	1948-06-09	1948-06-09 00:00:00	1948-06-09	38000177		0	0	7		0	0	0	190030	0	313782	1127433		
184474	4053	40213306	1984-11-25	1984-11-25 00:00:00	1984-11-25	1984-11-25 00:00:00	1984-11-25	581452		0	0	0		0	0	0	269440	0	43	40213306		
62266	5184	1127078	1965-05-15	1965-05-15 00:00:00	1965-06-14	1965-06-14 00:00:00	1965-06-14	38000177		0	0	30		0	0	0	344591	0	282464	1127078		
9859	826	19133905	1998-12-30	1998-12-30 00:00:00	1999-01-08	1999-01-08 00:00:00	1999-01-08	38000177		0	0	9		0	0	0	54705	0	834102	19133905		
27282	2256	19128065	2001-06-19	2001-06-19 00:00:00	2002-06-14	2002-06-14 00:00:00	2002-06-14	38000177		0	0	360		0	0	0	149907	0	749882	19128065		
3997	332	40169216	1965-06-20	1965-06-20 00:00:00	1965-06-20	1965-06-20 00:00:00	\N	38000177		0	0	0		0	0	0	22030	0	895994	40169216		
32738	2711	1713671	1982-02-26	1982-02-26 00:00:00	1982-03-05	1982-03-05 00:00:00	1982-03-05	38000177		0	0	7		0	0	0	179637	0	562251	1713671		
61749	5138	1127078	1978-09-28	1978-09-28 00:00:00	1978-10-12	1978-10-12 00:00:00	1978-10-12	38000177		0	0	14		0	0	0	341475	0	282464	1127078		
10882	906	40236824	2017-03-22	2017-03-22 00:00:00	2017-04-05	2017-04-05 00:00:00	2017-04-05	38000177		0	0	14		0	0	0	60224	0	1094107	40236824		
27397	2267	19128065	1983-11-19	1983-11-19 00:00:00	1984-11-13	1984-11-13 00:00:00	1984-11-13	38000177		0	0	360		0	0	0	150688	0	749882	19128065		
30091	2495	40229134	1985-05-08	1985-05-08 00:00:00	1985-05-22	1985-05-22 00:00:00	1985-05-22	38000177		0	0	14		0	0	0	165123	0	1043400	40229134		
48488	4017	1127433	1936-05-08	1936-05-08 00:00:00	1936-05-22	1936-05-22 00:00:00	1936-05-22	38000177		0	0	14		0	0	0	267034	0	313782	1127433		
63663	5290	19059056	1971-09-03	1971-09-03 00:00:00	1971-10-08	1971-10-08 00:00:00	1971-10-08	38000177		0	0	35		0	0	0	352031	0	243670	19059056		
41845	3464	42902245	1998-04-20	1998-04-20 00:00:00	1999-04-15	1999-04-15 00:00:00	1999-04-15	38000177		0	0	360		0	0	0	229979	0	1359133	42902245		
9246	197	40213296	2003-09-28	2003-09-28 00:00:00	2003-09-28	2003-09-28 00:00:00	2003-09-28	581452		0	0	0		0	0	0	13565	0	52	40213296		
49505	4106	1127433	1963-01-21	1963-01-21 00:00:00	1963-02-04	1963-02-04 00:00:00	1963-02-04	38000177		0	0	14		0	0	0	272860	0	313782	1127433		
728	16	40213306	1993-12-15	1993-12-15 00:00:00	1993-12-15	1993-12-15 00:00:00	1993-12-15	581452		0	0	0		0	0	0	1256	0	43	40213306		
30627	2541	1127433	1991-08-06	1991-08-06 00:00:00	1991-08-27	1991-08-27 00:00:00	1991-08-27	38000177		0	0	21		0	0	0	168020	0	313782	1127433		
3756	312	1127078	1977-04-27	1977-04-27 00:00:00	1977-07-26	1977-07-26 00:00:00	1977-07-26	38000177		0	0	90		0	0	0	20657	0	282464	1127078		
42760	3543	19059056	1961-04-30	1961-04-30 00:00:00	1961-05-14	1961-05-14 00:00:00	1961-05-14	38000177		0	0	14		0	0	0	235327	0	243670	19059056		
37816	3125	19078461	2011-09-29	2011-09-29 00:00:00	2011-10-13	2011-10-13 00:00:00	2011-10-13	38000177		0	0	14		0	0	0	207930	0	310965	19078461		
62973	5234	1127433	1995-04-02	1995-04-02 00:00:00	1995-04-16	1995-04-16 00:00:00	1995-04-16	38000177		0	0	14		0	0	0	348286	0	313782	1127433		
48350	4009	920300	1996-08-23	1996-08-23 00:00:00	1996-08-30	1996-08-30 00:00:00	1996-08-30	38000177		0	0	7		0	0	0	266381	0	311989	920300		
12482	1051	19059056	1970-01-14	1970-01-14 00:00:00	1970-01-28	1970-01-28 00:00:00	1970-01-28	38000177		0	0	14		0	0	0	68911	0	243670	19059056		
65440	1431	40213227	1992-06-13	1992-06-13 00:00:00	1992-06-13	1992-06-13 00:00:00	1992-06-13	581452		0	0	0		0	0	0	95275	0	113	40213227		
53653	4460	1713671	1950-03-22	1950-03-22 00:00:00	1950-04-05	1950-04-05 00:00:00	1950-04-05	38000177		0	0	14		0	0	0	296815	0	562251	1713671		
197837	4347	40213306	1988-06-12	1988-06-12 00:00:00	1988-06-12	1988-06-12 00:00:00	1988-06-12	581452		0	0	0		0	0	0	288288	0	43	40213306		
12629	1062	1127433	1981-05-11	1981-05-11 00:00:00	1981-05-18	1981-05-18 00:00:00	1981-05-18	38000177		0	0	7		0	0	0	69675	0	313782	1127433		
63874	5306	19059056	1969-03-20	1969-03-20 00:00:00	1969-04-03	1969-04-03 00:00:00	1969-04-03	38000177		0	0	14		0	0	0	352951	0	243670	19059056		
18066	1496	1115171	1994-06-16	1994-06-16 00:00:00	1994-07-16	1994-07-16 00:00:00	1994-07-16	38000177		0	0	30		0	0	0	99743	0	849574	1115171		
137016	3007	40213296	2008-06-04	2008-06-04 00:00:00	2008-06-04	2008-06-04 00:00:00	2008-06-04	581452		0	0	0		0	0	0	200618	0	52	40213296		
55448	4604	40229134	1977-09-12	1977-09-12 00:00:00	1977-09-19	1977-09-19 00:00:00	1977-09-19	38000177		0	0	7		0	0	0	306712	0	1043400	40229134		
6205	135	40213160	1971-11-23	1971-11-23 00:00:00	1971-11-23	1971-11-23 00:00:00	1971-11-23	581452		0	0	0		0	0	0	9064	0	10	40213160		
47284	3920	46233988	1975-08-30	1975-08-30 00:00:00	1975-09-13	1975-09-13 00:00:00	1975-09-13	38000177		0	0	14		0	0	0	260674	0	1652673	46233988		
236029	5184	40213160	1969-05-30	1969-05-30 00:00:00	1969-05-30	1969-05-30 00:00:00	1969-05-30	581452		0	0	0		0	0	0	344540	0	10	40213160		
41378	3432	19074679	1954-09-03	1954-09-03 00:00:00	1955-04-01	1955-04-01 00:00:00	1955-04-01	38000177		0	0	210		0	0	0	227484	0	308971	19074679		
60658	5045	1127433	1979-05-23	1979-05-23 00:00:00	1979-06-06	1979-06-06 00:00:00	1979-06-06	38000177		0	0	14		0	0	0	335241	0	313782	1127433		
4559	379	19073183	1980-01-02	1980-01-02 00:00:00	1980-01-16	1980-01-16 00:00:00	1980-01-16	38000177		0	0	14		0	0	0	25076	0	308182	19073183		
182540	4010	40213160	1982-04-15	1982-04-15 00:00:00	1982-04-15	1982-04-15 00:00:00	1982-04-15	581452		0	0	0		0	0	0	266506	0	10	40213160		
63375	5264	19019979	1978-11-02	1978-11-02 00:00:00	1978-11-30	1978-11-30 00:00:00	1978-11-30	38000177		0	0	28		0	0	0	350205	0	198405	19019979		
6316	528	1118084	2002-07-02	2002-07-02 00:00:00	2002-07-02	2002-07-02 00:00:00	\N	38000177		0	0	0		0	0	0	35211	0	00025152531	44923712		
5222	439	1713671	1986-07-23	1986-07-23 00:00:00	1986-08-13	1986-08-13 00:00:00	1986-08-13	38000177		0	0	21		0	0	0	29114	0	562251	1713671		
54164	4501	19128065	1987-11-22	1987-11-22 00:00:00	1988-11-16	1988-11-16 00:00:00	1988-11-16	38000177		0	0	360		0	0	0	299716	0	749882	19128065		
10658	227	40213160	1972-02-25	1972-02-25 00:00:00	1972-02-25	1972-02-25 00:00:00	1972-02-25	581452		0	0	0		0	0	0	15331	0	10	40213160		
5377	450	1127433	1967-10-09	1967-10-09 00:00:00	1967-10-16	1967-10-16 00:00:00	1967-10-16	38000177		0	0	7		0	0	0	30005	0	313782	1127433		
5440	454	40229134	1961-09-08	1961-09-08 00:00:00	1961-09-22	1961-09-22 00:00:00	1961-09-22	38000177		0	0	14		0	0	0	30349	0	1043400	40229134		
140246	3080	40213227	2002-08-29	2002-08-29 00:00:00	2002-08-29	2002-08-29 00:00:00	2002-08-29	581452		0	0	0		0	0	0	205048	0	113	40213227		
118774	2613	40213260	2007-05-25	2007-05-25 00:00:00	2007-05-25	2007-05-25 00:00:00	2007-05-25	581452		0	0	0		0	0	0	172773	0	121	40213260		
1324	103	1127433	2018-12-21	2018-12-21 00:00:00	2019-01-04	2019-01-04 00:00:00	2019-01-04	38000177		0	0	14		0	0	0	7049	0	313782	1127433		
18868	1558	19059056	1957-09-01	1957-09-01 00:00:00	1957-09-15	1957-09-15 00:00:00	1957-09-15	38000177		0	0	14		0	0	0	104314	0	243670	19059056		
14938	1249	1127433	2016-02-26	2016-02-26 00:00:00	2016-03-04	2016-03-04 00:00:00	2016-03-04	38000177		0	0	7		0	0	0	82279	0	313782	1127433		
54530	4531	1127433	1949-05-21	1949-05-21 00:00:00	1949-06-04	1949-06-04 00:00:00	1949-06-04	38000177		0	0	14		0	0	0	301814	0	313782	1127433		
54904	4560	1713671	2000-02-26	2000-02-26 00:00:00	2000-03-04	2000-03-04 00:00:00	2000-03-04	38000177		0	0	7		0	0	0	303821	0	562251	1713671		
104896	2300	40213227	2011-02-24	2011-02-24 00:00:00	2011-02-24	2011-02-24 00:00:00	2011-02-24	581452		0	0	0		0	0	0	153152	0	113	40213227		
2536	202	1118084	1982-02-16	1982-02-16 00:00:00	1982-02-16	1982-02-16 00:00:00	\N	38000177		0	0	0		0	0	0	13822	0	00025152531	44923712		
30381	2518	19078461	1992-11-06	1992-11-06 00:00:00	1992-12-04	1992-12-04 00:00:00	1992-12-04	38000177		0	0	28		0	0	0	166543	0	310965	19078461		
23580	512	40213160	1955-04-29	1955-04-29 00:00:00	1955-04-29	1955-04-29 00:00:00	1955-04-29	581452		0	0	0		0	0	0	34188	0	10	40213160		
145096	3189	40213160	1965-09-22	1965-09-22 00:00:00	1965-09-22	1965-09-22 00:00:00	1965-09-22	581452		0	0	0		0	0	0	212304	0	10	40213160		
10549	879	1713671	2013-05-28	2013-05-28 00:00:00	2013-06-11	2013-06-11 00:00:00	2013-06-11	38000177		0	0	14		0	0	0	58561	0	562251	1713671		
43411	947	40213296	2008-05-16	2008-05-16 00:00:00	2008-05-16	2008-05-16 00:00:00	2008-05-16	581452		0	0	0		0	0	0	\N	0	52	40213296		
43229	3580	40162522	1989-05-15	1989-05-15 00:00:00	1989-05-15	1989-05-15 00:00:00	\N	38000177		0	0	0		0	0	0	237966	0	857005	40162522		
26914	2218	920300	2016-07-23	2016-07-23 00:00:00	2016-07-30	2016-07-30 00:00:00	2016-07-30	38000177		0	0	7		0	0	0	147758	0	311989	920300		
136266	2991	40213160	1960-06-10	1960-06-10 00:00:00	1960-06-10	1960-06-10 00:00:00	1960-06-10	581452		0	0	0		0	0	0	199624	0	10	40213160		
34576	2858	1539411	2014-07-09	2014-07-09 00:00:00	2014-07-09	2014-07-09 00:00:00	\N	38000177		0	0	0		0	0	0	189870	0	312961	1539411		
34607	2859	19059056	1943-10-08	1943-10-08 00:00:00	1943-10-22	1943-10-22 00:00:00	1943-10-22	38000177		0	0	14		0	0	0	190005	0	243670	19059056		
184517	4055	40213306	1991-01-09	1991-01-09 00:00:00	1991-01-09	1991-01-09 00:00:00	1991-01-09	581452		0	0	0		0	0	0	269548	0	43	40213306		
62267	5184	19059056	1969-03-16	1969-03-16 00:00:00	1969-03-30	1969-03-30 00:00:00	1969-03-30	38000177		0	0	14		0	0	0	344583	0	243670	19059056		
9860	826	920300	1998-08-07	1998-08-07 00:00:00	1998-08-14	1998-08-14 00:00:00	1998-08-14	38000177		0	0	7		0	0	0	54719	0	311989	920300		
27283	2256	1127433	1992-02-23	1992-02-23 00:00:00	1992-03-08	1992-03-08 00:00:00	1992-03-08	38000177		0	0	14		0	0	0	149916	0	313782	1127433		
3998	332	1551192	1979-09-18	1979-09-18 00:00:00	1979-09-18	1979-09-18 00:00:00	1979-09-18	38000177		0	0	0		0	0	0	21908	0	312617	1551192		
32739	2711	45892894	2016-03-18	2016-03-18 00:00:00	2016-03-18	2016-03-18 00:00:00	\N	38000177		0	0	0		0	0	0	179797	0	1599803	45892894		
61750	5138	46233988	1978-09-28	1978-09-28 00:00:00	1978-10-12	1978-10-12 00:00:00	1978-10-12	38000177		0	0	14		0	0	0	341475	0	1652673	46233988		
10883	906	920300	2017-03-22	2017-03-22 00:00:00	2017-03-29	2017-03-29 00:00:00	2017-03-29	38000177		0	0	7		0	0	0	60224	0	311989	920300		
27398	2267	1127433	1979-07-05	1979-07-05 00:00:00	1979-07-12	1979-07-12 00:00:00	1979-07-12	38000177		0	0	7		0	0	0	150721	0	313782	1127433		
30092	2495	19128065	1996-09-16	1996-09-16 00:00:00	1997-09-11	1997-09-11 00:00:00	1997-09-11	38000177		0	0	360		0	0	0	165165	0	749882	19128065		
48489	4017	19059056	1934-01-17	1934-01-17 00:00:00	1934-03-25	1934-03-25 00:00:00	1934-03-25	38000177		0	0	67		0	0	0	267029	0	243670	19059056		
63664	5290	19126352	2017-08-11	2017-08-11 00:00:00	2017-08-11	2017-08-11 00:00:00	\N	38000177		0	0	0		0	0	0	351955	0	705129	19126352		
41846	3464	1124300	2017-04-25	2017-04-25 00:00:00	2017-04-25	2017-04-25 00:00:00	\N	38000177		0	0	0		0	0	0	229921	0	00781178901	45011828		
9249	197	40213306	1984-09-02	1984-09-02 00:00:00	1984-09-02	1984-09-02 00:00:00	1984-09-02	581452		0	0	0		0	0	0	13576	0	43	40213306		
49506	4107	1127433	1984-09-11	1984-09-11 00:00:00	1984-09-25	1984-09-25 00:00:00	1984-09-25	38000177		0	0	14		0	0	0	272911	0	313782	1127433		
730	16	40213227	1993-12-15	1993-12-15 00:00:00	1993-12-15	1993-12-15 00:00:00	1993-12-15	581452		0	0	0		0	0	0	1256	0	113	40213227		
30628	2541	46233988	1977-06-20	1977-06-20 00:00:00	1977-07-04	1977-07-04 00:00:00	1977-07-04	38000177		0	0	14		0	0	0	168063	0	1652673	46233988		
3757	312	1127433	2009-05-30	2009-05-30 00:00:00	2009-06-06	2009-06-06 00:00:00	2009-06-06	38000177		0	0	7		0	0	0	20676	0	313782	1127433		
42762	3543	1539411	1992-09-29	1992-09-29 00:00:00	1992-09-29	1992-09-29 00:00:00	\N	38000177		0	0	0		0	0	0	235385	0	312961	1539411		
37817	3125	19059056	1951-12-25	1951-12-25 00:00:00	1952-01-08	1952-01-08 00:00:00	1952-01-08	38000177		0	0	14		0	0	0	207988	0	243670	19059056		
62974	5234	40236824	1971-10-01	1971-10-01 00:00:00	1971-10-08	1971-10-08 00:00:00	1971-10-08	38000177		0	0	7		0	0	0	348220	0	1094107	40236824		
48351	4009	40236824	1996-08-23	1996-08-23 00:00:00	1996-08-30	1996-08-30 00:00:00	1996-08-30	38000177		0	0	7		0	0	0	266381	0	1094107	40236824		
12483	1051	1154615	1969-02-15	1969-02-15 00:00:00	1969-02-15	1969-02-15 00:00:00	\N	38000177		0	0	0		0	0	0	68872	0	745679	1154615		
65444	1432	40213160	1962-05-08	1962-05-08 00:00:00	1962-05-08	1962-05-08 00:00:00	1962-05-08	581452		0	0	0		0	0	0	95371	0	10	40213160		
53654	4460	1127433	2008-08-21	2008-08-21 00:00:00	2008-08-28	2008-08-28 00:00:00	2008-08-28	38000177		0	0	7		0	0	0	296798	0	313782	1127433		
197839	4347	40213260	2016-05-22	2016-05-22 00:00:00	2016-05-22	2016-05-22 00:00:00	2016-05-22	581452		0	0	0		0	0	0	288266	0	121	40213260		
12630	1062	1127078	1972-01-26	1972-01-26 00:00:00	1972-03-01	1972-03-01 00:00:00	1972-03-01	38000177		0	0	35		0	0	0	69662	0	282464	1127078		
63875	5306	1124300	2013-01-23	2013-01-23 00:00:00	2013-01-23	2013-01-23 00:00:00	\N	38000177		0	0	0		0	0	0	352985	0	00781178901	45011828		
18067	1496	19075001	1989-06-07	1989-06-07 00:00:00	1989-07-12	1989-07-12 00:00:00	1989-07-12	38000177		0	0	35		0	0	0	99742	0	309097	19075001		
80029	1751	40213306	1999-12-01	1999-12-01 00:00:00	1999-12-01	1999-12-01 00:00:00	1999-12-01	581452		0	0	0		0	0	0	117090	0	43	40213306		
29702	648	40213201	1999-12-10	1999-12-10 00:00:00	1999-12-10	1999-12-10 00:00:00	1999-12-10	581452		0	0	0		0	0	0	42934	0	33	40213201		
199767	4388	40213160	1967-04-29	1967-04-29 00:00:00	1967-04-29	1967-04-29 00:00:00	1967-04-29	581452		0	0	0		0	0	0	291649	0	10	40213160		
47285	3920	19059056	1975-08-30	1975-08-30 00:00:00	1975-09-13	1975-09-13 00:00:00	1975-09-13	38000177		0	0	14		0	0	0	260674	0	243670	19059056		
236036	5184	40213296	2008-01-11	2008-01-11 00:00:00	2008-01-11	2008-01-11 00:00:00	2008-01-11	581452		0	0	0		0	0	0	344585	0	52	40213296		
41379	3432	19006318	1955-01-22	1955-01-22 00:00:00	1955-02-05	1955-02-05 00:00:00	1955-02-05	38000177		0	0	14		0	0	0	227501	0	105078	19006318		
26543	578	40213306	1990-07-25	1990-07-25 00:00:00	1990-07-25	1990-07-25 00:00:00	1990-07-25	581452		0	0	0		0	0	0	38241	0	43	40213306		
4560	379	19019979	1980-01-02	1980-01-02 00:00:00	1980-01-16	1980-01-16 00:00:00	1980-01-16	38000177		0	0	14		0	0	0	25076	0	198405	19019979		
182544	4010	40213227	2019-05-16	2019-05-16 00:00:00	2019-05-16	2019-05-16 00:00:00	2019-05-16	581452		0	0	0		0	0	0	266524	0	113	40213227		
63376	5264	1127078	1977-09-08	1977-09-08 00:00:00	1977-12-07	1977-12-07 00:00:00	1977-12-07	38000177		0	0	90		0	0	0	350204	0	282464	1127078		
6317	528	19128065	1978-04-29	1978-04-29 00:00:00	1979-04-24	1979-04-24 00:00:00	1979-04-24	38000177		0	0	360		0	0	0	35162	0	749882	19128065		
5223	439	1127433	1980-10-14	1980-10-14 00:00:00	1980-10-21	1980-10-21 00:00:00	1980-10-21	38000177		0	0	7		0	0	0	29162	0	313782	1127433		
54165	4501	19128022	1993-10-21	1993-10-21 00:00:00	1994-10-16	1994-10-16 00:00:00	1994-10-16	38000177		0	0	360		0	0	0	299683	0	749785	19128022		
10665	227	40213227	2002-11-29	2002-11-29 00:00:00	2002-11-29	2002-11-29 00:00:00	2002-11-29	581452		0	0	0		0	0	0	15311	0	113	40213227		
5378	450	1127433	1983-08-14	1983-08-14 00:00:00	1983-09-11	1983-09-11 00:00:00	1983-09-11	38000177		0	0	28		0	0	0	30054	0	313782	1127433		
5441	454	19077572	2013-02-16	2013-02-16 00:00:00	2013-02-16	2013-02-16 00:00:00	\N	38000177		0	0	0		0	0	0	30331	0	310436	19077572		
140250	3080	40213201	2007-09-27	2007-09-27 00:00:00	2007-09-27	2007-09-27 00:00:00	2007-09-27	581452		0	0	0		0	0	0	205006	0	33	40213201		
118782	2613	40213160	1955-08-19	1955-08-19 00:00:00	1955-08-19	1955-08-19 00:00:00	1955-08-19	581452		0	0	0		0	0	0	172736	0	10	40213160		
1325	103	40229134	1974-07-22	1974-07-22 00:00:00	1974-07-29	1974-07-29 00:00:00	1974-07-29	38000177		0	0	7		0	0	0	7043	0	1043400	40229134		
18869	1558	19006318	1957-09-01	1957-09-01 00:00:00	1957-09-15	1957-09-15 00:00:00	1957-09-15	38000177		0	0	14		0	0	0	104314	0	105078	19006318		
14939	1249	1127433	2000-06-24	2000-06-24 00:00:00	2000-07-01	2000-07-01 00:00:00	2000-07-01	38000177		0	0	7		0	0	0	82310	0	313782	1127433		
54531	4531	40173590	2004-12-25	2004-12-25 00:00:00	2004-12-25	2004-12-25 00:00:00	\N	38000177		0	0	0		0	0	0	301781	0	904419	40173590		
54905	4560	1127433	2012-10-07	2012-10-07 00:00:00	2012-10-21	2012-10-21 00:00:00	2012-10-21	38000177		0	0	14		0	0	0	303849	0	313782	1127433		
104899	2300	40213201	2016-03-24	2016-03-24 00:00:00	2016-03-24	2016-03-24 00:00:00	2016-03-24	581452		0	0	0		0	0	0	153146	0	33	40213201		
2537	202	19059056	1940-05-02	1940-05-02 00:00:00	1940-05-23	1940-05-23 00:00:00	1940-05-23	38000177		0	0	21		0	0	0	13879	0	243670	19059056		
30382	2518	40169281	1983-11-25	1983-11-25 00:00:00	1983-11-25	1983-11-25 00:00:00	\N	38000177		0	0	0		0	0	0	166514	0	896209	40169281		
23583	512	40213160	1955-01-28	1955-01-28 00:00:00	1955-01-28	1955-01-28 00:00:00	1955-01-28	581452		0	0	0		0	0	0	34180	0	10	40213160		
145100	3189	40213227	1997-04-09	1997-04-09 00:00:00	1997-04-09	1997-04-09 00:00:00	1997-04-09	581452		0	0	0		0	0	0	212269	0	113	40213227		
10550	879	1127433	2007-06-27	2007-06-27 00:00:00	2007-07-25	2007-07-25 00:00:00	2007-07-25	38000177		0	0	28		0	0	0	58581	0	313782	1127433		
43415	947	40213160	1967-01-06	1967-01-06 00:00:00	1967-01-06	1967-01-06 00:00:00	1967-01-06	581452		0	0	0		0	0	0	62896	0	10	40213160		
43230	3580	1127433	1989-05-15	1989-05-15 00:00:00	1989-06-14	1989-06-14 00:00:00	1989-06-14	38000177		0	0	30		0	0	0	237966	0	313782	1127433		
26915	2218	19128065	1999-04-13	1999-04-13 00:00:00	2000-04-07	2000-04-07 00:00:00	2000-04-07	38000177		0	0	360		0	0	0	147759	0	749882	19128065		
136269	2991	40213227	2011-06-03	2011-06-03 00:00:00	2011-06-03	2011-06-03 00:00:00	2011-06-03	581452		0	0	0		0	0	0	199658	0	113	40213227		
34577	2858	19075601	2014-07-09	2014-07-09 00:00:00	2014-07-09	2014-07-09 00:00:00	\N	38000177		0	0	0		0	0	0	189870	0	309362	19075601		
34608	2859	1118084	1976-10-24	1976-10-24 00:00:00	1976-10-24	1976-10-24 00:00:00	\N	38000177		0	0	0		0	0	0	190034	0	00025152531	44923712		
117746	2588	40213227	1996-06-09	1996-06-09 00:00:00	1996-06-09	1996-06-09 00:00:00	1996-06-09	581452		0	0	0		0	0	0	171276	0	113	40213227		
62268	5184	46233988	1969-03-16	1969-03-16 00:00:00	1969-03-30	1969-03-30 00:00:00	1969-03-30	38000177		0	0	14		0	0	0	344583	0	1652673	46233988		
9861	826	40236824	1998-08-07	1998-08-07 00:00:00	1998-08-14	1998-08-14 00:00:00	1998-08-14	38000177		0	0	7		0	0	0	54719	0	1094107	40236824		
27284	2256	1127078	1990-06-07	1990-06-07 00:00:00	1990-07-07	1990-07-07 00:00:00	1990-07-07	38000177		0	0	30		0	0	0	149937	0	282464	1127078		
3999	332	1127433	1993-12-29	1993-12-29 00:00:00	1994-01-12	1994-01-12 00:00:00	1994-01-12	38000177		0	0	14		0	0	0	21921	0	313782	1127433		
32740	2711	40229134	1996-04-09	1996-04-09 00:00:00	1996-04-23	1996-04-23 00:00:00	1996-04-23	38000177		0	0	14		0	0	0	179668	0	1043400	40229134		
61751	5138	40229134	1993-02-12	1993-02-12 00:00:00	1993-02-26	1993-02-26 00:00:00	1993-02-26	38000177		0	0	14		0	0	0	341504	0	1043400	40229134		
10884	906	19128022	1989-02-09	1989-02-09 00:00:00	1990-02-04	1990-02-04 00:00:00	1990-02-04	38000177		0	0	360		0	0	0	60254	0	749785	19128022		
27399	2267	46233988	1971-10-08	1971-10-08 00:00:00	1971-10-22	1971-10-22 00:00:00	1971-10-22	38000177		0	0	14		0	0	0	150687	0	1652673	46233988		
30093	2495	19129144	2003-08-11	2003-08-11 00:00:00	2004-08-05	2004-08-05 00:00:00	2004-08-05	38000177		0	0	360		0	0	0	165155	0	757594	19129144		
48490	4017	1127433	1989-02-09	1989-02-09 00:00:00	1989-02-23	1989-02-23 00:00:00	1989-02-23	38000177		0	0	14		0	0	0	266948	0	313782	1127433		
63665	5290	19075601	2017-08-11	2017-08-11 00:00:00	2017-08-11	2017-08-11 00:00:00	\N	38000177		0	0	0		0	0	0	351955	0	309362	19075601		
41847	3464	19078461	1997-04-15	1997-04-15 00:00:00	1997-05-15	1997-05-15 00:00:00	1997-05-15	38000177		0	0	30		0	0	0	229947	0	310965	19078461		
21151	459	40213160	1971-02-08	1971-02-08 00:00:00	1971-02-08	1971-02-08 00:00:00	1971-02-08	581452		0	0	0		0	0	0	30721	0	10	40213160		
49507	4107	19073188	1984-09-11	1984-09-11 00:00:00	1984-09-25	1984-09-25 00:00:00	1984-09-25	38000177		0	0	14		0	0	0	272911	0	308192	19073188		
733	16	40213160	1972-06-21	1972-06-21 00:00:00	1972-06-21	1972-06-21 00:00:00	1972-06-21	581452		0	0	0		0	0	0	1206	0	10	40213160		
30629	2541	1127078	1977-06-20	1977-06-20 00:00:00	1977-07-04	1977-07-04 00:00:00	1977-07-04	38000177		0	0	14		0	0	0	168063	0	282464	1127078		
3758	312	1127433	1972-05-24	1972-05-24 00:00:00	1972-05-31	1972-05-31 00:00:00	1972-05-31	38000177		0	0	7		0	0	0	20660	0	313782	1127433		
42763	3543	19126352	1992-09-29	1992-09-29 00:00:00	1992-09-29	1992-09-29 00:00:00	\N	38000177		0	0	0		0	0	0	235385	0	705129	19126352		
37818	3125	19006318	1951-12-25	1951-12-25 00:00:00	1952-01-08	1952-01-08 00:00:00	1952-01-08	38000177		0	0	14		0	0	0	207988	0	105078	19006318		
62975	5234	920300	1971-10-01	1971-10-01 00:00:00	1971-10-08	1971-10-08 00:00:00	1971-10-08	38000177		0	0	7		0	0	0	348220	0	311989	920300		
48352	4009	19115351	2005-07-26	2005-07-26 00:00:00	2006-05-02	2006-05-02 00:00:00	2006-05-02	38000177		0	0	280		0	0	0	266396	0	563026	19115351		
12484	1051	40169216	1969-02-15	1969-02-15 00:00:00	1969-02-15	1969-02-15 00:00:00	\N	38000177		0	0	0		0	0	0	68872	0	895994	40169216		
65448	1432	40213260	2012-09-04	2012-09-04 00:00:00	2012-09-04	2012-09-04 00:00:00	2012-09-04	581452		0	0	0		0	0	0	95405	0	121	40213260		
53655	4460	1127433	2003-07-19	2003-07-19 00:00:00	2003-08-18	2003-08-18 00:00:00	2003-08-18	38000177		0	0	30		0	0	0	296741	0	313782	1127433		
197841	4347	40213296	2009-05-03	2009-05-03 00:00:00	2009-05-03	2009-05-03 00:00:00	2009-05-03	581452		0	0	0		0	0	0	288289	0	52	40213296		
12631	1062	19006318	1972-01-26	1972-01-26 00:00:00	1972-03-01	1972-03-01 00:00:00	1972-03-01	38000177		0	0	35		0	0	0	69662	0	105078	19006318		
63876	5306	40165015	2013-01-22	2013-01-22 00:00:00	2013-01-22	2013-01-22 00:00:00	\N	38000177		0	0	0		0	0	0	352985	0	861467	40165015		
18068	1496	1127433	1989-06-07	1989-06-07 00:00:00	1989-07-12	1989-07-12 00:00:00	1989-07-12	38000177		0	0	35		0	0	0	99742	0	313782	1127433		
80031	1751	40213227	1999-12-01	1999-12-01 00:00:00	1999-12-01	1999-12-01 00:00:00	1999-12-01	581452		0	0	0		0	0	0	117090	0	113	40213227		
29708	648	40213227	1994-07-29	1994-07-29 00:00:00	1994-07-29	1994-07-29 00:00:00	1994-07-29	581452		0	0	0		0	0	0	42933	0	113	40213227		
199773	4388	40213260	2017-09-23	2017-09-23 00:00:00	2017-09-23	2017-09-23 00:00:00	2017-09-23	581452		0	0	0		0	0	0	291749	0	121	40213260		
47286	3920	19128022	1991-07-28	1991-07-28 00:00:00	1992-07-22	1992-07-22 00:00:00	1992-07-22	38000177		0	0	360		0	0	0	260675	0	749785	19128022		
236041	5184	40213160	1964-11-27	1964-11-27 00:00:00	1964-11-27	1964-11-27 00:00:00	1964-11-27	581452		0	0	0		0	0	0	344537	0	10	40213160		
41380	3432	19059056	1955-01-22	1955-01-22 00:00:00	1955-02-05	1955-02-05 00:00:00	1955-02-05	38000177		0	0	14		0	0	0	227501	0	243670	19059056		
26545	578	40213160	1967-09-06	1967-09-06 00:00:00	1967-09-06	1967-09-06 00:00:00	1967-09-06	581452		0	0	0		0	0	0	38246	0	10	40213160		
4561	379	1713671	2000-03-08	2000-03-08 00:00:00	2000-06-07	2000-06-07 00:00:00	2000-06-07	38000177		0	0	91		0	0	0	25058	0	562251	1713671		
182545	4010	40213296	2019-05-16	2019-05-16 00:00:00	2019-05-16	2019-05-16 00:00:00	2019-05-16	581452		0	0	0		0	0	0	266524	0	52	40213296		
63377	5264	1127078	1968-08-26	1968-08-26 00:00:00	1968-09-09	1968-09-09 00:00:00	1968-09-09	38000177		0	0	14		0	0	0	350218	0	282464	1127078		
6318	528	19128065	1979-04-24	1979-04-24 00:00:00	1980-04-18	1980-04-18 00:00:00	1980-04-18	38000177		0	0	360		0	0	0	35163	0	749882	19128065		
5224	439	19128065	1992-09-20	1992-09-20 00:00:00	1993-09-15	1993-09-15 00:00:00	1993-09-15	38000177		0	0	360		0	0	0	29161	0	749882	19128065		
54166	4501	1127433	1983-01-31	1983-01-31 00:00:00	1983-02-07	1983-02-07 00:00:00	1983-02-07	38000177		0	0	7		0	0	0	299705	0	313782	1127433		
10672	227	40213296	2013-09-27	2013-09-27 00:00:00	2013-09-27	2013-09-27 00:00:00	2013-09-27	581452		0	0	0		0	0	0	15312	0	52	40213296		
5379	450	19078461	2015-03-27	2015-03-27 00:00:00	2015-04-10	2015-04-10 00:00:00	2015-04-10	38000177		0	0	14		0	0	0	30056	0	310965	19078461		
5442	455	1127433	1951-05-28	1951-05-28 00:00:00	1951-06-04	1951-06-04 00:00:00	1951-06-04	38000177		0	0	7		0	0	0	30398	0	313782	1127433		
49564	1085	40213260	2016-06-04	2016-06-04 00:00:00	2016-06-04	2016-06-04 00:00:00	2016-06-04	581452		0	0	0		0	0	0	71309	0	121	40213260		
30347	662	40213260	2011-09-28	2011-09-28 00:00:00	2011-09-28	2011-09-28 00:00:00	2011-09-28	581452		0	0	0		0	0	0	43696	0	121	40213260		
1326	103	1118084	2008-06-01	2008-06-01 00:00:00	2008-06-01	2008-06-01 00:00:00	\N	38000177		0	0	0		0	0	0	7066	0	00025152531	44923712		
18870	1558	19133905	2000-12-04	2000-12-04 00:00:00	2000-12-11	2000-12-11 00:00:00	2000-12-11	38000177		0	0	7		0	0	0	104373	0	834102	19133905		
14940	1249	1713671	1981-07-14	1981-07-14 00:00:00	1981-08-04	1981-08-04 00:00:00	1981-08-04	38000177		0	0	21		0	0	0	82276	0	562251	1713671		
54532	4531	1713671	1985-01-12	1985-01-12 00:00:00	1985-01-19	1985-01-19 00:00:00	1985-01-19	38000177		0	0	7		0	0	0	301749	0	562251	1713671		
54906	4560	19019979	1975-06-22	1975-06-22 00:00:00	1975-07-27	1975-07-27 00:00:00	1975-07-27	38000177		0	0	35		0	0	0	303807	0	198405	19019979		
12160	262	40213160	1965-04-12	1965-04-12 00:00:00	1965-04-12	1965-04-12 00:00:00	1965-04-12	581452		0	0	0		0	0	0	17367	0	10	40213160		
2538	202	19077572	2016-01-02	2016-01-02 00:00:00	2016-01-02	2016-01-02 00:00:00	\N	38000177		0	0	0		0	0	0	13860	0	310436	19077572		
30383	2518	920300	1976-11-04	1976-11-04 00:00:00	1976-11-11	1976-11-11 00:00:00	1976-11-11	38000177		0	0	7		0	0	0	166504	0	311989	920300		
23586	512	40213260	2006-10-13	2006-10-13 00:00:00	2006-10-13	2006-10-13 00:00:00	2006-10-13	581452		0	0	0		0	0	0	34237	0	121	40213260		
145102	3189	40213260	2015-06-17	2015-06-17 00:00:00	2015-06-17	2015-06-17 00:00:00	2015-06-17	581452		0	0	0		0	0	0	212285	0	121	40213260		
10551	879	1713671	1982-08-14	1982-08-14 00:00:00	1982-09-04	1982-09-04 00:00:00	1982-09-04	38000177		0	0	21		0	0	0	58558	0	562251	1713671		
43423	947	40213160	1971-09-10	1971-09-10 00:00:00	1971-09-10	1971-09-10 00:00:00	1971-09-10	581452		0	0	0		0	0	0	62855	0	10	40213160		
234756	5157	40213160	1963-09-19	1963-09-19 00:00:00	1963-09-19	1963-09-19 00:00:00	1963-09-19	581452		0	0	0		0	0	0	342919	0	10	40213160		
26916	2218	19128022	2002-03-28	2002-03-28 00:00:00	2003-03-23	2003-03-23 00:00:00	2003-03-23	38000177		0	0	360		0	0	0	147761	0	749785	19128022		
136270	2991	40213260	2011-06-03	2011-06-03 00:00:00	2011-06-03	2011-06-03 00:00:00	2011-06-03	581452		0	0	0		0	0	0	199658	0	121	40213260		
34578	2858	19059056	1925-09-29	1925-09-29 00:00:00	1925-10-29	1925-10-29 00:00:00	1925-10-29	38000177		0	0	30		0	0	0	189898	0	243670	19059056		
34609	2860	19059056	1945-05-29	1945-05-29 00:00:00	1945-08-27	1945-08-27 00:00:00	1945-08-27	38000177		0	0	90		0	0	0	190129	0	243670	19059056		
117750	2588	40213306	1987-05-31	1987-05-31 00:00:00	1987-05-31	1987-05-31 00:00:00	1987-05-31	581452		0	0	0		0	0	0	171303	0	43	40213306		
62269	5184	1713671	1973-08-04	1973-08-04 00:00:00	1973-08-25	1973-08-25 00:00:00	1973-08-25	38000177		0	0	21		0	0	0	344529	0	562251	1713671		
9862	826	19128065	1982-05-22	1982-05-22 00:00:00	1983-05-17	1983-05-17 00:00:00	1983-05-17	38000177		0	0	360		0	0	0	54709	0	749882	19128065		
37669	3115	19129655	1968-10-26	1968-10-26 00:00:00	1968-11-09	1968-11-09 00:00:00	1968-11-09	38000177		0	0	14		0	0	0	207214	0	789980	19129655		
4000	332	1127433	1978-04-12	1978-04-12 00:00:00	1978-04-19	1978-04-19 00:00:00	1978-04-19	38000177		0	0	7		0	0	0	21994	0	313782	1127433		
32741	2711	40232448	1953-07-16	1953-07-16 00:00:00	1953-07-16	1953-07-16 00:00:00	\N	38000177		0	0	0		0	0	0	179649	0	1049630	40232448		
61752	5138	1124300	2018-05-11	2018-05-11 00:00:00	2018-05-11	2018-05-11 00:00:00	\N	38000177		0	0	0		0	0	0	341473	0	00781178901	45011828		
10885	906	19133873	1979-01-07	1979-01-07 00:00:00	1979-01-15	1979-01-15 00:00:00	1979-01-15	38000177		0	0	8		0	0	0	60271	0	834061	19133873		
27400	2267	19059056	1971-10-08	1971-10-08 00:00:00	1971-10-22	1971-10-22 00:00:00	1971-10-22	38000177		0	0	14		0	0	0	150687	0	243670	19059056		
9367	778	1127078	1980-12-04	1980-12-04 00:00:00	1981-01-01	1981-01-01 00:00:00	1981-01-01	38000177		0	0	28		0	0	0	51671	0	282464	1127078		
48491	4017	40222846	2011-05-15	2011-05-15 00:00:00	2011-05-15	2011-05-15 00:00:00	\N	38000177		0	0	0		0	0	0	266976	0	996740	40222846		
63666	5290	1332419	2017-08-11	2017-08-11 00:00:00	2017-08-11	2017-08-11 00:00:00	\N	38000177		0	0	0		0	0	0	351955	0	197361	1332419		
41848	3464	42902245	1999-04-15	1999-04-15 00:00:00	2000-04-09	2000-04-09 00:00:00	2000-04-09	38000177		0	0	360		0	0	0	229980	0	1359133	42902245		
21157	459	40213160	1971-05-10	1971-05-10 00:00:00	1971-05-10	1971-05-10 00:00:00	1971-05-10	581452		0	0	0		0	0	0	30683	0	10	40213160		
49508	4107	19129655	1971-04-09	1971-04-09 00:00:00	1971-04-23	1971-04-23 00:00:00	1971-04-23	38000177		0	0	14		0	0	0	272910	0	789980	19129655		
736	16	40213296	2011-10-19	2011-10-19 00:00:00	2011-10-19	2011-10-19 00:00:00	2011-10-19	581452		0	0	0		0	0	0	1264	0	52	40213296		
30630	2541	19133873	1984-10-13	1984-10-13 00:00:00	1984-10-26	1984-10-26 00:00:00	1984-10-26	38000177		0	0	13		0	0	0	168050	0	834061	19133873		
3759	312	1115171	2012-03-24	2012-03-24 00:00:00	2012-04-07	2012-04-07 00:00:00	2012-04-07	38000177		0	0	14		0	0	0	20659	0	849574	1115171		
42764	3543	40231925	1978-07-21	1978-07-21 00:00:00	1978-07-21	1978-07-21 00:00:00	\N	38000177		0	0	0		0	0	0	235332	0	1049221	40231925		
37819	3125	1118084	1985-01-05	1985-01-05 00:00:00	1985-01-05	1985-01-05 00:00:00	\N	38000177		0	0	0		0	0	0	207976	0	00025152531	44923712		
62976	5234	40236824	1977-11-17	1977-11-17 00:00:00	1977-11-24	1977-11-24 00:00:00	1977-11-24	38000177		0	0	7		0	0	0	348226	0	1094107	40236824		
48353	4009	19006318	1954-09-04	1954-09-04 00:00:00	1954-09-18	1954-09-18 00:00:00	1954-09-18	38000177		0	0	14		0	0	0	266385	0	105078	19006318		
12487	1053	19128065	1991-01-21	1991-01-21 00:00:00	1992-01-16	1992-01-16 00:00:00	1992-01-16	38000177		0	0	360		0	0	0	69060	0	749882	19128065		
65450	1432	40213227	2012-09-04	2012-09-04 00:00:00	2012-09-04	2012-09-04 00:00:00	2012-09-04	581452		0	0	0		0	0	0	95405	0	113	40213227		
53656	4460	40162522	2003-07-19	2003-07-19 00:00:00	2003-07-19	2003-07-19 00:00:00	\N	38000177		0	0	0		0	0	0	296741	0	857005	40162522		
197844	4347	40213227	1999-04-18	1999-04-18 00:00:00	1999-04-18	1999-04-18 00:00:00	1999-04-18	581452		0	0	0		0	0	0	288251	0	113	40213227		
12632	1062	19059056	1969-02-03	1969-02-03 00:00:00	1969-04-11	1969-04-11 00:00:00	1969-04-11	38000177		0	0	67		0	0	0	69661	0	243670	19059056		
55625	1219	40213227	1993-09-20	1993-09-20 00:00:00	1993-09-20	1993-09-20 00:00:00	1993-09-20	581452		0	0	0		0	0	0	80253	0	113	40213227		
18069	1496	1127433	1979-08-29	1979-08-29 00:00:00	1979-10-28	1979-10-28 00:00:00	1979-10-28	38000177		0	0	60		0	0	0	99741	0	313782	1127433		
80032	1751	40213314	1978-03-08	1978-03-08 00:00:00	1978-03-08	1978-03-08 00:00:00	1978-03-08	581452		0	0	0		0	0	0	117062	0	49	40213314		
40999	893	40213296	1997-10-06	1997-10-06 00:00:00	1997-10-06	1997-10-06 00:00:00	1997-10-06	581452		0	0	0		0	0	0	59526	0	52	40213296		
199775	4388	40213227	2017-09-23	2017-09-23 00:00:00	2017-09-23	2017-09-23 00:00:00	2017-09-23	581452		0	0	0		0	0	0	291749	0	113	40213227		
47287	3920	1127433	1989-01-29	1989-01-29 00:00:00	1989-02-28	1989-02-28 00:00:00	1989-02-28	38000177		0	0	30		0	0	0	260684	0	313782	1127433		
236043	5184	40213160	1964-09-25	1964-09-25 00:00:00	1964-09-25	1964-09-25 00:00:00	1964-09-25	581452		0	0	0		0	0	0	344570	0	10	40213160		
41382	3432	19059056	1974-12-29	1974-12-29 00:00:00	1975-01-26	1975-01-26 00:00:00	1975-01-26	38000177		0	0	28		0	0	0	227487	0	243670	19059056		
26547	578	40213160	1967-11-08	1967-11-08 00:00:00	1967-11-08	1967-11-08 00:00:00	1967-11-08	581452		0	0	0		0	0	0	38282	0	10	40213160		
4562	379	1127433	2014-06-12	2014-06-12 00:00:00	2014-06-26	2014-06-26 00:00:00	2014-06-26	38000177		0	0	14		0	0	0	25059	0	313782	1127433		
182549	4010	40213251	1984-04-26	1984-04-26 00:00:00	1984-04-26	1984-04-26 00:00:00	1984-04-26	581452		0	0	0		0	0	0	266469	0	21	40213251		
63378	5264	46233988	1968-08-26	1968-08-26 00:00:00	1968-09-09	1968-09-09 00:00:00	1968-09-09	38000177		0	0	14		0	0	0	350218	0	1652673	46233988		
6320	528	40229134	1971-08-25	1971-08-25 00:00:00	1971-09-08	1971-09-08 00:00:00	1971-09-08	38000177		0	0	14		0	0	0	35152	0	1043400	40229134		
5225	439	1115171	2002-10-18	2002-10-18 00:00:00	2002-11-08	2002-11-08 00:00:00	2002-11-08	38000177		0	0	21		0	0	0	29154	0	849574	1115171		
3545	78	40213306	1989-03-09	1989-03-09 00:00:00	1989-03-09	1989-03-09 00:00:00	1989-03-09	581452		0	0	0		0	0	0	5159	0	43	40213306		
10674	227	40213227	2013-09-27	2013-09-27 00:00:00	2013-09-27	2013-09-27 00:00:00	2013-09-27	581452		0	0	0		0	0	0	15312	0	113	40213227		
5380	450	1713671	1974-02-08	1974-02-08 00:00:00	1974-02-15	1974-02-15 00:00:00	1974-02-15	38000177		0	0	7		0	0	0	30006	0	562251	1713671		
5443	455	19078461	2001-07-05	2001-07-05 00:00:00	2001-08-09	2001-08-09 00:00:00	2001-08-09	38000177		0	0	35		0	0	0	30471	0	310965	19078461		
49566	1085	40213227	2016-06-04	2016-06-04 00:00:00	2016-06-04	2016-06-04 00:00:00	2016-06-04	581452		0	0	0		0	0	0	71309	0	113	40213227		
30349	662	40213227	2011-09-28	2011-09-28 00:00:00	2011-09-28	2011-09-28 00:00:00	2011-09-28	581452		0	0	0		0	0	0	43696	0	113	40213227		
1327	103	1127433	1996-09-03	1996-09-03 00:00:00	1996-09-10	1996-09-10 00:00:00	1996-09-10	38000177		0	0	7		0	0	0	7034	0	313782	1127433		
18871	1558	1118084	1992-09-01	1992-09-01 00:00:00	1992-09-01	1992-09-01 00:00:00	\N	38000177		0	0	0		0	0	0	104353	0	00025152531	44923712		
25399	2088	19059056	1955-09-21	1955-09-21 00:00:00	1955-10-12	1955-10-12 00:00:00	1955-10-12	38000177		0	0	21		0	0	0	139179	0	243670	19059056		
54533	4531	1713671	1935-06-28	1935-06-28 00:00:00	1935-07-05	1935-07-05 00:00:00	1935-07-05	38000177		0	0	7		0	0	0	301744	0	562251	1713671		
54907	4560	1127433	1983-07-06	1983-07-06 00:00:00	1983-08-05	1983-08-05 00:00:00	1983-08-05	38000177		0	0	30		0	0	0	303810	0	313782	1127433		
12167	262	40213260	2014-08-04	2014-08-04 00:00:00	2014-08-04	2014-08-04 00:00:00	2014-08-04	581452		0	0	0		0	0	0	17386	0	121	40213260		
2539	202	1713671	1953-12-24	1953-12-24 00:00:00	1954-01-14	1954-01-14 00:00:00	1954-01-14	38000177		0	0	21		0	0	0	13845	0	562251	1713671		
30384	2518	40236824	1976-11-04	1976-11-04 00:00:00	1976-11-11	1976-11-11 00:00:00	1976-11-11	38000177		0	0	7		0	0	0	166504	0	1094107	40236824		
23589	512	40213160	1955-07-29	1955-07-29 00:00:00	1955-07-29	1955-07-29 00:00:00	1955-07-29	581452		0	0	0		0	0	0	34223	0	10	40213160		
145107	3189	40213296	2005-06-22	2005-06-22 00:00:00	2005-06-22	2005-06-22 00:00:00	2005-06-22	581452		0	0	0		0	0	0	212283	0	52	40213296		
10552	879	19059056	1953-04-06	1953-04-06 00:00:00	1953-04-20	1953-04-20 00:00:00	1953-04-20	38000177		0	0	14		0	0	0	58525	0	243670	19059056		
43427	947	40213227	1997-12-12	1997-12-12 00:00:00	1997-12-12	1997-12-12 00:00:00	1997-12-12	581452		0	0	0		0	0	0	62858	0	113	40213227		
106102	2327	40213296	2001-06-20	2001-06-20 00:00:00	2001-06-20	2001-06-20 00:00:00	2001-06-20	581452		0	0	0		0	0	0	154800	0	52	40213296		
26917	2218	1124300	2011-08-03	2011-08-03 00:00:00	2011-08-03	2011-08-03 00:00:00	\N	38000177		0	0	0		0	0	0	147718	0	00781178901	45011828		
136277	2991	40213160	1965-02-12	1965-02-12 00:00:00	1965-02-12	1965-02-12 00:00:00	1965-02-12	581452		0	0	0		0	0	0	199677	0	10	40213160		
34579	2858	40231925	1925-09-29	1925-09-29 00:00:00	1925-09-29	1925-09-29 00:00:00	\N	38000177		0	0	0		0	0	0	189898	0	1049221	40231925		
34610	2860	920300	2001-12-24	2001-12-24 00:00:00	2001-12-31	2001-12-31 00:00:00	2001-12-31	38000177		0	0	7		0	0	0	190154	0	311989	920300		
117752	2588	40213260	2014-08-31	2014-08-31 00:00:00	2014-08-31	2014-08-31 00:00:00	2014-08-31	581452		0	0	0		0	0	0	171306	0	121	40213260		
62270	5184	19059056	1973-12-29	1973-12-29 00:00:00	1974-02-02	1974-02-02 00:00:00	1974-02-02	38000177		0	0	35		0	0	0	344592	0	243670	19059056		
9863	826	1118084	1991-06-29	1991-06-29 00:00:00	1991-06-29	1991-06-29 00:00:00	\N	38000177		0	0	0		0	0	0	54704	0	00025152531	44923712		
37670	3115	19059056	1968-10-26	1968-10-26 00:00:00	1968-11-09	1968-11-09 00:00:00	1968-11-09	38000177		0	0	14		0	0	0	207214	0	243670	19059056		
4001	332	19059056	1972-08-25	1972-08-25 00:00:00	1972-10-24	1972-10-24 00:00:00	1972-10-24	38000177		0	0	60		0	0	0	21905	0	243670	19059056		
32742	2711	1154615	1953-07-02	1953-07-02 00:00:00	1953-07-02	1953-07-02 00:00:00	\N	38000177		0	0	0		0	0	0	179649	0	745679	1154615		
222244	4878	40213160	1967-12-16	1967-12-16 00:00:00	1967-12-16	1967-12-16 00:00:00	1967-12-16	581452		0	0	0		0	0	0	324334	0	10	40213160		
10886	906	40229134	1991-05-21	1991-05-21 00:00:00	1991-05-28	1991-05-28 00:00:00	1991-05-28	38000177		0	0	7		0	0	0	60264	0	1043400	40229134		
27402	2267	46233988	1969-08-24	1969-08-24 00:00:00	1969-09-07	1969-09-07 00:00:00	1969-09-07	38000177		0	0	14		0	0	0	150712	0	1652673	46233988		
9368	778	19128022	1994-01-05	1994-01-05 00:00:00	1994-12-31	1994-12-31 00:00:00	1994-12-31	38000177		0	0	360		0	0	0	51693	0	749785	19128022		
48492	4018	19059056	1968-01-25	1968-01-25 00:00:00	1968-02-08	1968-02-08 00:00:00	1968-02-08	38000177		0	0	14		0	0	0	267109	0	243670	19059056		
63667	5290	1539411	2017-08-11	2017-08-11 00:00:00	2017-08-11	2017-08-11 00:00:00	\N	38000177		0	0	0		0	0	0	351955	0	312961	1539411		
41849	3464	40236824	2005-06-04	2005-06-04 00:00:00	2005-06-11	2005-06-11 00:00:00	2005-06-11	38000177		0	0	7		0	0	0	229957	0	1094107	40236824		
21162	459	40213227	2012-09-10	2012-09-10 00:00:00	2012-09-10	2012-09-10 00:00:00	2012-09-10	581452		0	0	0		0	0	0	30709	0	113	40213227		
49509	4107	1127078	1971-04-09	1971-04-09 00:00:00	1971-04-23	1971-04-23 00:00:00	1971-04-23	38000177		0	0	14		0	0	0	272910	0	282464	1127078		
738	16	40213160	1976-09-22	1976-09-22 00:00:00	1976-09-22	1976-09-22 00:00:00	1976-09-22	581452		0	0	0		0	0	0	1214	0	10	40213160		
30631	2541	1127433	1987-03-01	1987-03-01 00:00:00	1987-03-08	1987-03-08 00:00:00	1987-03-08	38000177		0	0	7		0	0	0	168016	0	313782	1127433		
3760	312	19075001	1985-01-15	1985-01-15 00:00:00	1985-01-29	1985-01-29 00:00:00	1985-01-29	38000177		0	0	14		0	0	0	20662	0	309097	19075001		
42765	3543	1332419	1995-10-03	1995-10-03 00:00:00	1995-10-03	1995-10-03 00:00:00	\N	38000177		0	0	0		0	0	0	235386	0	197361	1332419		
37820	3125	1713671	1966-05-03	1966-05-03 00:00:00	1966-05-17	1966-05-17 00:00:00	1966-05-17	38000177		0	0	14		0	0	0	207935	0	562251	1713671		
62977	5234	920300	1977-11-17	1977-11-17 00:00:00	1977-11-24	1977-11-24 00:00:00	1977-11-24	38000177		0	0	7		0	0	0	348226	0	311989	920300		
48354	4009	1127078	1954-09-04	1954-09-04 00:00:00	1954-09-18	1954-09-18 00:00:00	1954-09-18	38000177		0	0	14		0	0	0	266385	0	282464	1127078		
12488	1053	1127433	1979-10-22	1979-10-22 00:00:00	1979-10-29	1979-10-29 00:00:00	1979-10-29	38000177		0	0	7		0	0	0	69047	0	313782	1127433		
65457	1432	40213227	1995-03-28	1995-03-28 00:00:00	1995-03-28	1995-03-28 00:00:00	1995-03-28	581452		0	0	0		0	0	0	95355	0	113	40213227		
53657	4460	1127433	1987-11-04	1987-11-04 00:00:00	1987-11-11	1987-11-11 00:00:00	1987-11-11	38000177		0	0	7		0	0	0	296777	0	313782	1127433		
197852	4347	40213227	2007-04-29	2007-04-29 00:00:00	2007-04-29	2007-04-29 00:00:00	2007-04-29	581452		0	0	0		0	0	0	288260	0	113	40213227		
12633	1062	1124300	2000-08-29	2000-08-29 00:00:00	2000-08-29	2000-08-29 00:00:00	\N	38000177		0	0	0		0	0	0	69648	0	00781178901	45011828		
55647	1219	40213227	2003-11-17	2003-11-17 00:00:00	2003-11-17	2003-11-17 00:00:00	2003-11-17	581452		0	0	0		0	0	0	80230	0	113	40213227		
18070	1496	1713671	1988-08-06	1988-08-06 00:00:00	1988-08-27	1988-08-27 00:00:00	1988-08-27	38000177		0	0	21		0	0	0	99648	0	562251	1713671		
80033	1751	40213160	1978-03-08	1978-03-08 00:00:00	1978-03-08	1978-03-08 00:00:00	1978-03-08	581452		0	0	0		0	0	0	117062	0	10	40213160		
41000	893	40213160	1956-02-27	1956-02-27 00:00:00	1956-02-27	1956-02-27 00:00:00	1956-02-27	581452		0	0	0		0	0	0	59502	0	10	40213160		
199777	4388	40213160	1967-01-28	1967-01-28 00:00:00	1967-01-28	1967-01-28 00:00:00	1967-01-28	581452		0	0	0		0	0	0	291730	0	10	40213160		
47288	3920	19128022	1993-07-17	1993-07-17 00:00:00	1994-07-12	1994-07-12 00:00:00	1994-07-12	38000177		0	0	360		0	0	0	260676	0	749785	19128022		
236048	5184	40213306	1986-08-22	1986-08-22 00:00:00	1986-08-22	1986-08-22 00:00:00	1986-08-22	581452		0	0	0		0	0	0	344577	0	43	40213306		
41383	3432	1713671	1955-12-17	1955-12-17 00:00:00	1955-12-24	1955-12-24 00:00:00	1955-12-24	38000177		0	0	7		0	0	0	227526	0	562251	1713671		
26551	578	40213227	2019-05-29	2019-05-29 00:00:00	2019-05-29	2019-05-29 00:00:00	2019-05-29	581452		0	0	0		0	0	0	38285	0	113	40213227		
4563	379	1127433	1985-06-06	1985-06-06 00:00:00	1985-06-13	1985-06-13 00:00:00	1985-06-13	38000177		0	0	7		0	0	0	25064	0	313782	1127433		
182552	4010	40213160	1978-01-12	1978-01-12 00:00:00	1978-01-12	1978-01-12 00:00:00	1978-01-12	581452		0	0	0		0	0	0	266479	0	10	40213160		
63379	5264	1118084	2004-07-13	2004-07-13 00:00:00	2004-07-13	2004-07-13 00:00:00	\N	38000177		0	0	0		0	0	0	350215	0	00025152531	44923712		
6321	528	1713671	1969-04-18	1969-04-18 00:00:00	1969-05-02	1969-05-02 00:00:00	1969-05-02	38000177		0	0	14		0	0	0	35217	0	562251	1713671		
5226	439	40229134	2007-08-11	2007-08-11 00:00:00	2007-08-18	2007-08-18 00:00:00	2007-08-18	38000177		0	0	7		0	0	0	29115	0	1043400	40229134		
3549	78	40213227	2018-12-13	2018-12-13 00:00:00	2018-12-13	2018-12-13 00:00:00	2018-12-13	581452		0	0	0		0	0	0	5191	0	113	40213227		
10677	227	40213160	1971-12-24	1971-12-24 00:00:00	1971-12-24	1971-12-24 00:00:00	1971-12-24	581452		0	0	0		0	0	0	15324	0	10	40213160		
5381	450	1118084	2005-03-10	2005-03-10 00:00:00	2005-03-10	2005-03-10 00:00:00	\N	38000177		0	0	0		0	0	0	30022	0	00025152531	44923712		
5444	455	1127433	1993-03-10	1993-03-10 00:00:00	1993-03-17	1993-03-17 00:00:00	1993-03-17	38000177		0	0	7		0	0	0	30459	0	313782	1127433		
49572	1085	40213160	1965-09-11	1965-09-11 00:00:00	1965-09-11	1965-09-11 00:00:00	1965-09-11	581452		0	0	0		0	0	0	71292	0	10	40213160		
30352	662	40213160	1965-09-01	1965-09-01 00:00:00	1965-09-01	1965-09-01 00:00:00	1965-09-01	581452		0	0	0		0	0	0	43756	0	10	40213160		
1328	103	1127078	1972-03-02	1972-03-02 00:00:00	1972-03-23	1972-03-23 00:00:00	1972-03-23	38000177		0	0	21		0	0	0	7068	0	282464	1127078		
18872	1558	1127433	1996-01-21	1996-01-21 00:00:00	1996-01-28	1996-01-28 00:00:00	1996-01-28	38000177		0	0	7		0	0	0	104386	0	313782	1127433		
25400	2088	1127433	1992-06-18	1992-06-18 00:00:00	1992-09-16	1992-09-16 00:00:00	1992-09-16	38000177		0	0	90		0	0	0	139183	0	313782	1127433		
54534	4531	19078461	2004-10-29	2004-10-29 00:00:00	2004-11-19	2004-11-19 00:00:00	2004-11-19	38000177		0	0	21		0	0	0	301709	0	310965	19078461		
54908	4560	40231925	1983-07-06	1983-07-06 00:00:00	1983-07-06	1983-07-06 00:00:00	\N	38000177		0	0	0		0	0	0	303810	0	1049221	40231925		
12171	262	40213296	2004-08-09	2004-08-09 00:00:00	2004-08-09	2004-08-09 00:00:00	2004-08-09	581452		0	0	0		0	0	0	17384	0	52	40213296		
2540	202	1127433	1948-12-18	1948-12-18 00:00:00	1949-01-01	1949-01-01 00:00:00	1949-01-01	38000177		0	0	14		0	0	0	13840	0	313782	1127433		
28562	621	40213227	1993-11-17	1993-11-17 00:00:00	1993-11-17	1993-11-17 00:00:00	1993-11-17	581452		0	0	0		0	0	0	41388	0	113	40213227		
23594	512	40213260	2007-10-19	2007-10-19 00:00:00	2007-10-19	2007-10-19 00:00:00	2007-10-19	581452		0	0	0		0	0	0	34232	0	121	40213260		
145111	3189	40213160	1966-02-23	1966-02-23 00:00:00	1966-02-23	1966-02-23 00:00:00	1966-02-23	581452		0	0	0		0	0	0	212305	0	10	40213160		
10553	879	19006318	1953-04-06	1953-04-06 00:00:00	1953-04-20	1953-04-20 00:00:00	1953-04-20	38000177		0	0	14		0	0	0	58525	0	105078	19006318		
43434	947	40213160	1967-03-10	1967-03-10 00:00:00	1967-03-10	1967-03-10 00:00:00	1967-03-10	581452		0	0	0		0	0	0	62890	0	10	40213160		
106104	2327	40213227	2009-07-15	2009-07-15 00:00:00	2009-07-15	2009-07-15 00:00:00	2009-07-15	581452		0	0	0		0	0	0	154772	0	113	40213227		
26918	2218	1127433	2005-06-02	2005-06-02 00:00:00	2005-06-09	2005-06-09 00:00:00	2005-06-09	38000177		0	0	7		0	0	0	147705	0	313782	1127433		
136289	2992	40213227	2018-07-20	2018-07-20 00:00:00	2018-07-20	2018-07-20 00:00:00	2018-07-20	581452		0	0	0		0	0	0	199725	0	113	40213227		
34580	2858	19059056	1944-09-20	1944-09-20 00:00:00	1944-10-18	1944-10-18 00:00:00	1944-10-18	38000177		0	0	28		0	0	0	189900	0	243670	19059056		
34611	2860	40236824	2001-12-24	2001-12-24 00:00:00	2001-12-31	2001-12-31 00:00:00	2001-12-31	38000177		0	0	7		0	0	0	190154	0	1094107	40236824		
117754	2588	40213160	1964-12-06	1964-12-06 00:00:00	1964-12-06	1964-12-06 00:00:00	1964-12-06	581452		0	0	0		0	0	0	171254	0	10	40213160		
62271	5184	19128065	1980-06-05	1980-06-05 00:00:00	1981-05-31	1981-05-31 00:00:00	1981-05-31	38000177		0	0	360		0	0	0	344555	0	749882	19128065		
9864	826	19128065	1974-07-03	1974-07-03 00:00:00	1975-06-28	1975-06-28 00:00:00	1975-06-28	38000177		0	0	360		0	0	0	54715	0	749882	19128065		
37671	3115	19133873	1974-03-15	1974-03-15 00:00:00	1974-03-26	1974-03-26 00:00:00	1974-03-26	38000177		0	0	11		0	0	0	207225	0	834061	19133873		
4003	332	1713671	1990-04-08	1990-04-08 00:00:00	1990-04-29	1990-04-29 00:00:00	1990-04-29	38000177		0	0	21		0	0	0	22056	0	562251	1713671		
32743	2711	40169216	1953-07-02	1953-07-02 00:00:00	1953-07-02	1953-07-02 00:00:00	\N	38000177		0	0	0		0	0	0	179649	0	895994	40169216		
222247	4878	40213306	1985-02-16	1985-02-16 00:00:00	1985-02-16	1985-02-16 00:00:00	1985-02-16	581452		0	0	0		0	0	0	324339	0	43	40213306		
10887	906	19128022	1992-01-25	1992-01-25 00:00:00	1993-01-19	1993-01-19 00:00:00	1993-01-19	38000177		0	0	360		0	0	0	60226	0	749785	19128022		
27403	2267	19059056	1969-08-24	1969-08-24 00:00:00	1969-09-07	1969-09-07 00:00:00	1969-09-07	38000177		0	0	14		0	0	0	150712	0	243670	19059056		
9369	778	1713671	2001-09-08	2001-09-08 00:00:00	2001-09-22	2001-09-22 00:00:00	2001-09-22	38000177		0	0	14		0	0	0	51690	0	562251	1713671		
48493	4018	46233988	1968-01-25	1968-01-25 00:00:00	1968-02-08	1968-02-08 00:00:00	1968-02-08	38000177		0	0	14		0	0	0	267109	0	1652673	46233988		
63668	5290	19059056	1954-11-01	1954-11-01 00:00:00	1954-12-01	1954-12-01 00:00:00	1954-12-01	38000177		0	0	30		0	0	0	352028	0	243670	19059056		
41850	3464	920300	2005-06-04	2005-06-04 00:00:00	2005-06-11	2005-06-11 00:00:00	2005-06-11	38000177		0	0	7		0	0	0	229957	0	311989	920300		
21163	459	40213296	2012-09-10	2012-09-10 00:00:00	2012-09-10	2012-09-10 00:00:00	2012-09-10	581452		0	0	0		0	0	0	30709	0	52	40213296		
49510	4107	19078461	1992-01-19	1992-01-19 00:00:00	1992-02-02	1992-02-02 00:00:00	1992-02-02	38000177		0	0	14		0	0	0	272889	0	310965	19078461		
118346	2602	40213160	1955-08-24	1955-08-24 00:00:00	1955-08-24	1955-08-24 00:00:00	1955-08-24	581452		0	0	0		0	0	0	172076	0	10	40213160		
30632	2541	1127433	2011-08-08	2011-08-08 00:00:00	2011-08-15	2011-08-15 00:00:00	2011-08-15	38000177		0	0	7		0	0	0	168034	0	313782	1127433		
3761	312	19078461	1985-01-15	1985-01-15 00:00:00	1985-01-29	1985-01-29 00:00:00	1985-01-29	38000177		0	0	14		0	0	0	20662	0	310965	19078461		
42766	3543	1127433	1975-05-19	1975-05-19 00:00:00	1975-06-02	1975-06-02 00:00:00	1975-06-02	38000177		0	0	14		0	0	0	235368	0	313782	1127433		
37821	3125	1127433	1954-04-15	1954-04-15 00:00:00	1954-04-29	1954-04-29 00:00:00	1954-04-29	38000177		0	0	14		0	0	0	207993	0	313782	1127433		
62978	5234	19133873	1936-12-02	1936-12-02 00:00:00	1936-12-15	1936-12-15 00:00:00	1936-12-15	38000177		0	0	13		0	0	0	348242	0	834061	19133873		
48355	4009	1115171	2004-06-06	2004-06-06 00:00:00	2004-06-20	2004-06-20 00:00:00	2004-06-20	38000177		0	0	14		0	0	0	266434	0	849574	1115171		
12489	1053	19006318	1978-08-31	1978-08-31 00:00:00	1978-09-14	1978-09-14 00:00:00	1978-09-14	38000177		0	0	14		0	0	0	69028	0	105078	19006318		
65460	1432	40213296	2003-04-08	2003-04-08 00:00:00	2003-04-08	2003-04-08 00:00:00	2003-04-08	581452		0	0	0		0	0	0	95356	0	52	40213296		
53658	4460	1127433	1952-07-05	1952-07-05 00:00:00	1952-07-19	1952-07-19 00:00:00	1952-07-19	38000177		0	0	14		0	0	0	296813	0	313782	1127433		
197853	4347	40213160	1966-12-18	1966-12-18 00:00:00	1966-12-18	1966-12-18 00:00:00	1966-12-18	581452		0	0	0		0	0	0	288300	0	10	40213160		
12634	1062	19133905	1994-02-18	1994-02-18 00:00:00	1994-02-28	1994-02-28 00:00:00	1994-02-28	38000177		0	0	10		0	0	0	69652	0	834102	19133905		
15463	1289	1127433	1989-04-16	1989-04-16 00:00:00	1989-05-07	1989-05-07 00:00:00	1989-05-07	38000177		0	0	21		0	0	0	85241	0	313782	1127433		
18071	1496	1713671	1984-09-12	1984-09-12 00:00:00	1984-09-19	1984-09-19 00:00:00	1984-09-19	38000177		0	0	7		0	0	0	99647	0	562251	1713671		
80034	1751	40213314	1978-01-04	1978-01-04 00:00:00	1978-01-04	1978-01-04 00:00:00	1978-01-04	581452		0	0	0		0	0	0	117053	0	49	40213314		
146572	3223	40213227	1998-03-11	1998-03-11 00:00:00	1998-03-11	1998-03-11 00:00:00	1998-03-11	581452		0	0	0		0	0	0	214231	0	113	40213227		
199787	4388	40213227	1998-02-28	1998-02-28 00:00:00	1998-02-28	1998-02-28 00:00:00	1998-02-28	581452		0	0	0		0	0	0	291723	0	113	40213227		
47289	3920	40229134	1975-04-14	1975-04-14 00:00:00	1975-04-21	1975-04-21 00:00:00	1975-04-21	38000177		0	0	7		0	0	0	260633	0	1043400	40229134		
236059	5185	40213227	1996-10-14	1996-10-14 00:00:00	1996-10-14	1996-10-14 00:00:00	1996-10-14	581452		0	0	0		0	0	0	344718	0	113	40213227		
41384	3432	1127433	1989-09-30	1989-09-30 00:00:00	1989-10-07	1989-10-07 00:00:00	1989-10-07	38000177		0	0	7		0	0	0	227523	0	313782	1127433		
26554	578	40213260	2018-04-25	2018-04-25 00:00:00	2018-04-25	2018-04-25 00:00:00	2018-04-25	581452		0	0	0		0	0	0	38228	0	121	40213260		
4564	379	1127433	2016-07-28	2016-07-28 00:00:00	2016-08-04	2016-08-04 00:00:00	2016-08-04	38000177		0	0	7		0	0	0	25060	0	313782	1127433		
182559	4010	40213306	2000-04-13	2000-04-13 00:00:00	2000-04-13	2000-04-13 00:00:00	2000-04-13	581452		0	0	0		0	0	0	266521	0	43	40213306		
63380	5264	1713671	2010-07-12	2010-07-12 00:00:00	2010-08-02	2010-08-02 00:00:00	2010-08-02	38000177		0	0	21		0	0	0	350207	0	562251	1713671		
6322	528	19128065	1976-05-09	1976-05-09 00:00:00	1977-05-04	1977-05-04 00:00:00	1977-05-04	38000177		0	0	360		0	0	0	35161	0	749882	19128065		
5227	439	1127078	1980-06-15	1980-06-15 00:00:00	1980-06-29	1980-06-29 00:00:00	1980-06-29	38000177		0	0	14		0	0	0	29108	0	282464	1127078		
3550	78	40213260	2018-12-13	2018-12-13 00:00:00	2018-12-13	2018-12-13 00:00:00	2018-12-13	581452		0	0	0		0	0	0	5191	0	121	40213260		
65054	1425	40213201	2002-02-26	2002-02-26 00:00:00	2002-02-26	2002-02-26 00:00:00	2002-02-26	581452		0	0	0		0	0	0	94704	0	33	40213201		
5382	450	40165015	1981-07-25	1981-07-25 00:00:00	1981-07-25	1981-07-25 00:00:00	\N	38000177		0	0	0		0	0	0	30053	0	861467	40165015		
5445	455	19059056	1960-02-11	1960-02-11 00:00:00	1960-03-12	1960-03-12 00:00:00	1960-03-12	38000177		0	0	30		0	0	0	30467	0	243670	19059056		
49579	1085	40213160	1965-06-12	1965-06-12 00:00:00	1965-06-12	1965-06-12 00:00:00	1965-06-12	581452		0	0	0		0	0	0	71274	0	10	40213160		
30355	662	40213160	1961-02-28	1961-02-28 00:00:00	1961-02-28	1961-02-28 00:00:00	1961-02-28	581452		0	0	0		0	0	0	43704	0	10	40213160		
68506	1500	40213260	2012-05-07	2012-05-07 00:00:00	2012-05-07	2012-05-07 00:00:00	2012-05-07	581452		0	0	0		0	0	0	100125	0	121	40213260		
18883	1560	40229134	1963-04-07	1963-04-07 00:00:00	1963-04-14	1963-04-14 00:00:00	1963-04-14	38000177		0	0	7		0	0	0	104438	0	1043400	40229134		
25401	2088	19006318	1977-03-18	1977-03-18 00:00:00	1977-04-08	1977-04-08 00:00:00	1977-04-08	38000177		0	0	21		0	0	0	139182	0	105078	19006318		
54535	4531	1127433	1941-09-17	1941-09-17 00:00:00	1941-10-01	1941-10-01 00:00:00	1941-10-01	38000177		0	0	14		0	0	0	301739	0	313782	1127433		
54909	4560	1713671	1979-10-04	1979-10-04 00:00:00	1979-10-18	1979-10-18 00:00:00	1979-10-18	38000177		0	0	14		0	0	0	303847	0	562251	1713671		
40691	886	40213160	1988-03-15	1988-03-15 00:00:00	1988-03-15	1988-03-15 00:00:00	1988-03-15	581452		0	0	0		0	0	0	59087	0	10	40213160		
2541	202	1115171	2008-09-26	2008-09-26 00:00:00	2008-10-24	2008-10-24 00:00:00	2008-10-24	38000177		0	0	28		0	0	0	13908	0	849574	1115171		
70523	1542	40213160	1966-03-02	1966-03-02 00:00:00	1966-03-02	1966-03-02 00:00:00	1966-03-02	581452		0	0	0		0	0	0	103324	0	10	40213160		
23596	512	40213227	2015-06-26	2015-06-26 00:00:00	2015-06-26	2015-06-26 00:00:00	2015-06-26	581452		0	0	0		0	0	0	34235	0	113	40213227		
145118	3189	40213160	1965-11-24	1965-11-24 00:00:00	1965-11-24	1965-11-24 00:00:00	1965-11-24	581452		0	0	0		0	0	0	212239	0	10	40213160		
10554	879	1127433	1986-02-17	1986-02-17 00:00:00	1986-03-19	1986-03-19 00:00:00	1986-03-19	38000177		0	0	30		0	0	0	58580	0	313782	1127433		
43435	947	40213260	2017-07-14	2017-07-14 00:00:00	2017-07-14	2017-07-14 00:00:00	2017-07-14	581452		0	0	0		0	0	0	62854	0	121	40213260		
106105	2327	40213260	2009-07-15	2009-07-15 00:00:00	2009-07-15	2009-07-15 00:00:00	2009-07-15	581452		0	0	0		0	0	0	154772	0	121	40213260		
26919	2218	1127078	1980-12-08	1980-12-08 00:00:00	1980-12-22	1980-12-22 00:00:00	1980-12-22	38000177		0	0	14		0	0	0	147753	0	282464	1127078		
136292	2992	40213260	2006-07-21	2006-07-21 00:00:00	2006-07-21	2006-07-21 00:00:00	2006-07-21	581452		0	0	0		0	0	0	199708	0	121	40213260		
34581	2858	1127433	1986-02-07	1986-02-07 00:00:00	1986-04-08	1986-04-08 00:00:00	1986-04-08	38000177		0	0	60		0	0	0	189903	0	313782	1127433		
34612	2860	19133873	1949-10-21	1949-10-21 00:00:00	1949-11-02	1949-11-02 00:00:00	1949-11-02	38000177		0	0	12		0	0	0	190123	0	834061	19133873		
117757	2588	40213296	2004-09-05	2004-09-05 00:00:00	2004-09-05	2004-09-05 00:00:00	2004-09-05	581452		0	0	0		0	0	0	171305	0	52	40213296		
62272	5184	1127078	1967-01-05	1967-01-05 00:00:00	1967-01-19	1967-01-19 00:00:00	1967-01-19	38000177		0	0	14		0	0	0	344569	0	282464	1127078		
15011	1253	19059056	1969-02-23	1969-02-23 00:00:00	1969-03-09	1969-03-09 00:00:00	1969-03-09	38000177		0	0	14		0	0	0	82549	0	243670	19059056		
37672	3115	19128065	1990-11-25	1990-11-25 00:00:00	1991-11-20	1991-11-20 00:00:00	1991-11-20	38000177		0	0	360		0	0	0	207230	0	749882	19128065		
4004	332	19128065	1979-05-31	1979-05-31 00:00:00	1980-05-25	1980-05-25 00:00:00	1980-05-25	38000177		0	0	360		0	0	0	21963	0	749882	19128065		
32744	2711	19077572	2010-11-15	2010-11-15 00:00:00	2010-11-15	2010-11-15 00:00:00	\N	38000177		0	0	0		0	0	0	179812	0	310436	19077572		
222249	4878	40213260	2013-06-22	2013-06-22 00:00:00	2013-06-22	2013-06-22 00:00:00	2013-06-22	581452		0	0	0		0	0	0	324383	0	121	40213260		
49067	4071	40165015	1969-12-07	1969-12-07 00:00:00	1969-12-07	1969-12-07 00:00:00	\N	38000177		0	0	0		0	0	0	270582	0	861467	40165015		
27404	2267	19078461	1980-02-28	1980-02-28 00:00:00	1980-04-03	1980-04-03 00:00:00	1980-04-03	38000177		0	0	35		0	0	0	150705	0	310965	19078461		
9370	778	40224805	1994-12-31	1994-12-31 00:00:00	1995-12-26	1995-12-26 00:00:00	1995-12-26	38000177		0	0	360		0	0	0	51694	0	1000126	40224805		
48494	4018	1127433	1975-12-14	1975-12-14 00:00:00	1976-01-04	1976-01-04 00:00:00	1976-01-04	38000177		0	0	21		0	0	0	267051	0	313782	1127433		
63669	5291	19078461	2008-03-29	2008-03-29 00:00:00	2008-04-12	2008-04-12 00:00:00	2008-04-12	38000177		0	0	14		0	0	0	352036	0	310965	19078461		
41851	3464	19008572	2009-05-20	2009-05-20 00:00:00	2009-05-20	2009-05-20 00:00:00	\N	38000177		0	0	0		0	0	0	229998	0	106258	19008572		
168162	3697	40213198	2016-06-18	2016-06-18 00:00:00	2016-06-18	2016-06-18 00:00:00	2016-06-18	581452		0	0	0		0	0	0	245788	0	133	40213198		
49511	4107	19133873	1987-04-18	1987-04-18 00:00:00	1987-05-01	1987-05-01 00:00:00	1987-05-01	38000177		0	0	13		0	0	0	272928	0	834061	19133873		
118359	2603	40213260	2010-05-26	2010-05-26 00:00:00	2010-05-26	2010-05-26 00:00:00	2010-05-26	581452		0	0	0		0	0	0	172208	0	121	40213260		
30633	2541	1127433	2007-09-27	2007-09-27 00:00:00	2007-10-11	2007-10-11 00:00:00	2007-10-11	38000177		0	0	14		0	0	0	168060	0	313782	1127433		
3780	316	1127433	2007-10-25	2007-10-25 00:00:00	2007-11-24	2007-11-24 00:00:00	2007-11-24	38000177		0	0	30		0	0	0	20983	0	313782	1127433		
42767	3543	920300	2013-08-09	2013-08-09 00:00:00	2013-08-16	2013-08-16 00:00:00	2013-08-16	38000177		0	0	7		0	0	0	235372	0	311989	920300		
37822	3125	19078461	1975-09-30	1975-09-30 00:00:00	1975-10-21	1975-10-21 00:00:00	1975-10-21	38000177		0	0	21		0	0	0	208006	0	310965	19078461		
62979	5234	19059056	1937-09-27	1937-09-27 00:00:00	1937-10-11	1937-10-11 00:00:00	1937-10-11	38000177		0	0	14		0	0	0	348296	0	243670	19059056		
48356	4009	1118084	1992-05-15	1992-05-15 00:00:00	1992-05-15	1992-05-15 00:00:00	\N	38000177		0	0	0		0	0	0	266436	0	00025152531	44923712		
12490	1053	1127078	1978-08-31	1978-08-31 00:00:00	1978-09-14	1978-09-14 00:00:00	1978-09-14	38000177		0	0	14		0	0	0	69028	0	282464	1127078		
65462	1432	40213227	2003-04-08	2003-04-08 00:00:00	2003-04-08	2003-04-08 00:00:00	2003-04-08	581452		0	0	0		0	0	0	95356	0	113	40213227		
53659	4460	1118084	1979-10-21	1979-10-21 00:00:00	1979-10-21	1979-10-21 00:00:00	\N	38000177		0	0	0		0	0	0	296814	0	00025152531	44923712		
197854	4347	40213296	2007-04-29	2007-04-29 00:00:00	2007-04-29	2007-04-29 00:00:00	2007-04-29	581452		0	0	0		0	0	0	288260	0	52	40213296		
12635	1062	19059056	1971-10-28	1971-10-28 00:00:00	1971-11-11	1971-11-11 00:00:00	1971-11-11	38000177		0	0	14		0	0	0	69688	0	243670	19059056		
15464	1289	19078461	1997-05-25	1997-05-25 00:00:00	1997-08-23	1997-08-23 00:00:00	1997-08-23	38000177		0	0	90		0	0	0	85242	0	310965	19078461		
18072	1496	19059056	1940-04-08	1940-04-08 00:00:00	1940-04-29	1940-04-29 00:00:00	1940-04-29	38000177		0	0	21		0	0	0	99645	0	243670	19059056		
80035	1751	40213160	1978-01-04	1978-01-04 00:00:00	1978-01-04	1978-01-04 00:00:00	1978-01-04	581452		0	0	0		0	0	0	117053	0	10	40213160		
146581	3223	40213201	1983-10-26	1983-10-26 00:00:00	1983-10-26	1983-10-26 00:00:00	1983-10-26	581452		0	0	0		0	0	0	214283	0	33	40213201		
199791	4388	40213160	1966-11-26	1966-11-26 00:00:00	1966-11-26	1966-11-26 00:00:00	1966-11-26	581452		0	0	0		0	0	0	291707	0	10	40213160		
47290	3920	1127433	2004-05-17	2004-05-17 00:00:00	2004-05-31	2004-05-31 00:00:00	2004-05-31	38000177		0	0	14		0	0	0	260636	0	313782	1127433		
30863	2555	19059056	1953-11-10	1953-11-10 00:00:00	1953-11-24	1953-11-24 00:00:00	1953-11-24	38000177		0	0	14		0	0	0	169346	0	243670	19059056		
41385	3432	1127433	1992-07-16	1992-07-16 00:00:00	1992-07-30	1992-07-30 00:00:00	1992-07-30	38000177		0	0	14		0	0	0	227489	0	313782	1127433		
26559	578	40213296	2008-01-09	2008-01-09 00:00:00	2008-01-09	2008-01-09 00:00:00	2008-01-09	581452		0	0	0		0	0	0	38211	0	52	40213296		
4565	379	19128022	1991-03-15	1991-03-15 00:00:00	1992-03-09	1992-03-09 00:00:00	1992-03-09	38000177		0	0	360		0	0	0	25100	0	749785	19128022		
49854	4137	1127433	1976-08-23	1976-08-23 00:00:00	1976-08-30	1976-08-30 00:00:00	1976-08-30	38000177		0	0	7		0	0	0	274993	0	313782	1127433		
63381	5265	19078461	1982-08-21	1982-08-21 00:00:00	1982-09-25	1982-09-25 00:00:00	1982-09-25	38000177		0	0	35		0	0	0	350328	0	310965	19078461		
6323	528	19128065	1975-05-15	1975-05-15 00:00:00	1976-05-09	1976-05-09 00:00:00	1976-05-09	38000177		0	0	360		0	0	0	35183	0	749882	19128065		
5228	439	1127433	1993-04-08	1993-04-08 00:00:00	1993-06-07	1993-06-07 00:00:00	1993-06-07	38000177		0	0	60		0	0	0	29153	0	313782	1127433		
3554	78	40213160	1967-04-13	1967-04-13 00:00:00	1967-04-13	1967-04-13 00:00:00	1967-04-13	581452		0	0	0		0	0	0	5206	0	10	40213160		
65064	1425	40213227	2007-03-27	2007-03-27 00:00:00	2007-03-27	2007-03-27 00:00:00	2007-03-27	581452		0	0	0		0	0	0	94717	0	113	40213227		
5383	450	19059056	1981-07-25	1981-07-25 00:00:00	1981-09-23	1981-09-23 00:00:00	1981-09-23	38000177		0	0	60		0	0	0	30053	0	243670	19059056		
5446	455	19078461	2014-06-02	2014-06-02 00:00:00	2014-06-16	2014-06-16 00:00:00	2014-06-16	38000177		0	0	14		0	0	0	30472	0	310965	19078461		
49581	1085	40213260	2015-09-26	2015-09-26 00:00:00	2015-09-26	2015-09-26 00:00:00	2015-09-26	581452		0	0	0		0	0	0	71283	0	121	40213260		
30357	662	40213260	2010-09-22	2010-09-22 00:00:00	2010-09-22	2010-09-22 00:00:00	2010-09-22	581452		0	0	0		0	0	0	43761	0	121	40213260		
68509	1500	40213160	1962-07-23	1962-07-23 00:00:00	1962-07-23	1962-07-23 00:00:00	1962-07-23	581452		0	0	0		0	0	0	100131	0	10	40213160		
18884	1560	19059056	1935-04-14	1935-04-14 00:00:00	1935-04-28	1935-04-28 00:00:00	1935-04-28	38000177		0	0	14		0	0	0	104513	0	243670	19059056		
25402	2088	19078461	1977-03-18	1977-03-18 00:00:00	1977-04-08	1977-04-08 00:00:00	1977-04-08	38000177		0	0	21		0	0	0	139182	0	310965	19078461		
54536	4531	19075601	1997-11-15	1997-11-15 00:00:00	2017-04-29	2017-04-29 00:00:00	2017-04-29	38000177		0	0	7105		0	0	0	301712	0	309362	19075601		
54910	4561	1713671	1996-11-30	1996-11-30 00:00:00	1996-12-14	1996-12-14 00:00:00	1996-12-14	38000177		0	0	14		0	0	0	303922	0	562251	1713671		
40697	886	40213227	2006-03-14	2006-03-14 00:00:00	2006-03-14	2006-03-14 00:00:00	2006-03-14	581452		0	0	0		0	0	0	59050	0	113	40213227		
2542	202	1127433	2013-06-10	2013-06-10 00:00:00	2013-06-17	2013-06-17 00:00:00	2013-06-17	38000177		0	0	7		0	0	0	13888	0	313782	1127433		
36096	2975	1115171	2011-01-19	2011-01-19 00:00:00	2011-04-19	2011-04-19 00:00:00	2011-04-19	38000177		0	0	90		0	0	0	198693	0	849574	1115171		
23600	512	40213227	2005-10-07	2005-10-07 00:00:00	2005-10-07	2005-10-07 00:00:00	2005-10-07	581452		0	0	0		0	0	0	34231	0	113	40213227		
156148	3436	40213227	2004-02-23	2004-02-23 00:00:00	2004-02-23	2004-02-23 00:00:00	2004-02-23	581452		0	0	0		0	0	0	227910	0	113	40213227		
10555	879	1124300	1989-02-16	1989-02-16 00:00:00	1989-02-16	1989-02-16 00:00:00	\N	38000177		0	0	0		0	0	0	58529	0	00781178901	45011828		
43442	947	40213227	2018-07-20	2018-07-20 00:00:00	2018-07-20	2018-07-20 00:00:00	2018-07-20	581452		0	0	0		0	0	0	62878	0	113	40213227		
106118	2327	40213160	1962-06-20	1962-06-20 00:00:00	1962-06-20	1962-06-20 00:00:00	1962-06-20	581452		0	0	0		0	0	0	154781	0	10	40213160		
26920	2218	19073183	1980-12-08	1980-12-08 00:00:00	1980-12-22	1980-12-22 00:00:00	1980-12-22	38000177		0	0	14		0	0	0	147753	0	308182	19073183		
136294	2992	40213160	1956-12-28	1956-12-28 00:00:00	1956-12-28	1956-12-28 00:00:00	1956-12-28	581452		0	0	0		0	0	0	199746	0	10	40213160		
34582	2858	1127433	2018-04-12	2018-04-12 00:00:00	2018-04-26	2018-04-26 00:00:00	2018-04-26	38000177		0	0	14		0	0	0	189896	0	313782	1127433		
34613	2860	1127433	1976-06-29	1976-06-29 00:00:00	1976-07-13	1976-07-13 00:00:00	1976-07-13	38000177		0	0	14		0	0	0	190124	0	313782	1127433		
117759	2589	40213227	2005-11-01	2005-11-01 00:00:00	2005-11-01	2005-11-01 00:00:00	2005-11-01	581452		0	0	0		0	0	0	171325	0	113	40213227		
231779	5094	40213160	1979-01-08	1979-01-08 00:00:00	1979-01-08	1979-01-08 00:00:00	1979-01-08	581452		0	0	0		0	0	0	338461	0	10	40213160		
15012	1253	1127433	1975-08-05	1975-08-05 00:00:00	1975-10-04	1975-10-04 00:00:00	1975-10-04	38000177		0	0	60		0	0	0	82550	0	313782	1127433		
37673	3115	1127433	2000-07-06	2000-07-06 00:00:00	2000-07-20	2000-07-20 00:00:00	2000-07-20	38000177		0	0	14		0	0	0	207209	0	313782	1127433		
4005	332	1127433	2019-03-30	2019-03-30 00:00:00	2019-04-13	2019-04-13 00:00:00	2019-04-13	38000177		0	0	14		0	0	0	21938	0	313782	1127433		
32745	2711	19133905	2018-06-09	2018-06-09 00:00:00	2018-06-19	2018-06-19 00:00:00	2018-06-19	38000177		0	0	10		0	0	0	179800	0	834102	19133905		
222253	4878	40213160	1963-06-15	1963-06-15 00:00:00	1963-06-15	1963-06-15 00:00:00	1963-06-15	581452		0	0	0		0	0	0	324330	0	10	40213160		
49068	4071	1127433	2003-12-07	2003-12-07 00:00:00	2003-12-14	2003-12-14 00:00:00	2003-12-14	38000177		0	0	7		0	0	0	270590	0	313782	1127433		
42700	931	40213260	2011-09-23	2011-09-23 00:00:00	2011-09-23	2011-09-23 00:00:00	2011-09-23	581452		0	0	0		0	0	0	61946	0	121	40213260		
9371	778	19059056	1978-07-18	1978-07-18 00:00:00	1978-08-01	1978-08-01 00:00:00	1978-08-01	38000177		0	0	14		0	0	0	51648	0	243670	19059056		
48495	4018	19059056	1978-07-22	1978-07-22 00:00:00	1978-08-12	1978-08-12 00:00:00	1978-08-12	38000177		0	0	21		0	0	0	267052	0	243670	19059056		
63670	5291	1127433	1992-09-09	1992-09-09 00:00:00	1992-09-16	1992-09-16 00:00:00	1992-09-16	38000177		0	0	7		0	0	0	352049	0	313782	1127433		
41852	3464	1713671	2014-12-16	2014-12-16 00:00:00	2014-12-23	2014-12-23 00:00:00	2014-12-23	38000177		0	0	7		0	0	0	229944	0	562251	1713671		
168165	3697	40213160	1956-03-03	1956-03-03 00:00:00	1956-03-03	1956-03-03 00:00:00	1956-03-03	581452		0	0	0		0	0	0	245740	0	10	40213160		
49512	4107	19059056	1972-01-12	1972-01-12 00:00:00	1972-01-26	1972-01-26 00:00:00	1972-01-26	38000177		0	0	14		0	0	0	272914	0	243670	19059056		
118362	2603	40213160	1961-02-01	1961-02-01 00:00:00	1961-02-01	1961-02-01 00:00:00	1961-02-01	581452		0	0	0		0	0	0	172227	0	10	40213160		
30634	2541	1118084	2017-12-07	2017-12-07 00:00:00	2017-12-07	2017-12-07 00:00:00	\N	38000177		0	0	0		0	0	0	168049	0	00025152531	44923712		
3781	316	19059056	1932-05-12	1932-05-12 00:00:00	1932-06-02	1932-06-02 00:00:00	1932-06-02	38000177		0	0	21		0	0	0	20888	0	243670	19059056		
42768	3543	40236824	2013-08-09	2013-08-09 00:00:00	2013-08-16	2013-08-16 00:00:00	2013-08-16	38000177		0	0	7		0	0	0	235372	0	1094107	40236824		
37823	3125	1127433	1979-06-22	1979-06-22 00:00:00	1979-07-06	1979-07-06 00:00:00	1979-07-06	38000177		0	0	14		0	0	0	207937	0	313782	1127433		
62980	5234	1713671	1990-07-29	1990-07-29 00:00:00	1990-08-19	1990-08-19 00:00:00	1990-08-19	38000177		0	0	21		0	0	0	348269	0	562251	1713671		
48357	4009	40229134	1956-07-18	1956-07-18 00:00:00	1956-07-25	1956-07-25 00:00:00	1956-07-25	38000177		0	0	7		0	0	0	266378	0	1043400	40229134		
12491	1053	19115351	1984-09-21	1984-09-21 00:00:00	1984-12-07	1984-12-07 00:00:00	1984-12-07	38000177		0	0	77		0	0	0	69018	0	563026	19115351		
65469	1432	40213160	1961-12-05	1961-12-05 00:00:00	1961-12-05	1961-12-05 00:00:00	1961-12-05	581452		0	0	0		0	0	0	95413	0	10	40213160		
53660	4460	40229134	2009-07-26	2009-07-26 00:00:00	2009-08-02	2009-08-02 00:00:00	2009-08-02	38000177		0	0	7		0	0	0	296828	0	1043400	40229134		
197861	4347	40213160	1971-03-21	1971-03-21 00:00:00	1971-03-21	1971-03-21 00:00:00	1971-03-21	581452		0	0	0		0	0	0	288310	0	10	40213160		
12636	1062	19006318	1971-10-28	1971-10-28 00:00:00	1971-11-11	1971-11-11 00:00:00	1971-11-11	38000177		0	0	14		0	0	0	69688	0	105078	19006318		
15465	1289	1713671	2004-07-11	2004-07-11 00:00:00	2004-08-01	2004-08-01 00:00:00	2004-08-01	38000177		0	0	21		0	0	0	85166	0	562251	1713671		
18073	1496	19133873	1933-10-07	1933-10-07 00:00:00	1933-10-17	1933-10-17 00:00:00	1933-10-17	38000177		0	0	10		0	0	0	99720	0	834061	19133873		
80043	1751	40213160	1982-09-08	1982-09-08 00:00:00	1982-09-08	1982-09-08 00:00:00	1982-09-08	581452		0	0	0		0	0	0	117086	0	10	40213160		
146592	3224	40213306	1983-01-28	1983-01-28 00:00:00	1983-01-28	1983-01-28 00:00:00	1983-01-28	581452		0	0	0		0	0	0	\N	0	43	40213306		
199794	4388	40213306	1989-01-14	1989-01-14 00:00:00	1989-01-14	1989-01-14 00:00:00	1989-01-14	581452		0	0	0		0	0	0	291718	0	43	40213306		
47291	3921	1115171	1999-07-10	1999-07-10 00:00:00	1999-09-08	1999-09-08 00:00:00	1999-09-08	38000177		0	0	60		0	0	0	260704	0	849574	1115171		
30864	2555	19006318	1953-11-10	1953-11-10 00:00:00	1953-11-24	1953-11-24 00:00:00	1953-11-24	38000177		0	0	14		0	0	0	169346	0	105078	19006318		
41386	3432	19115351	1953-11-08	1953-11-08 00:00:00	1954-02-21	1954-02-21 00:00:00	1954-02-21	38000177		0	0	105		0	0	0	227483	0	563026	19115351		
26568	579	40213160	1961-06-28	1961-06-28 00:00:00	1961-06-28	1961-06-28 00:00:00	1961-06-28	581452		0	0	0		0	0	0	38310	0	10	40213160		
4566	379	19019979	1977-02-16	1977-02-16 00:00:00	1977-03-18	1977-03-18 00:00:00	1977-03-18	38000177		0	0	30		0	0	0	25065	0	198405	19019979		
49855	4137	19059056	1966-06-17	1966-06-17 00:00:00	1966-07-01	1966-07-01 00:00:00	1966-07-01	38000177		0	0	14		0	0	0	274986	0	243670	19059056		
63382	5265	1127433	2018-12-15	2018-12-15 00:00:00	2018-12-29	2018-12-29 00:00:00	2018-12-29	38000177		0	0	14		0	0	0	350285	0	313782	1127433		
6324	528	19059056	1960-07-22	1960-07-22 00:00:00	1960-08-05	1960-08-05 00:00:00	1960-08-05	38000177		0	0	14		0	0	0	35160	0	243670	19059056		
5229	439	1127433	1987-08-17	1987-08-17 00:00:00	1987-08-24	1987-08-24 00:00:00	1987-08-24	38000177		0	0	7		0	0	0	29103	0	313782	1127433		
3555	78	40213160	1967-06-15	1967-06-15 00:00:00	1967-06-15	1967-06-15 00:00:00	1967-06-15	581452		0	0	0		0	0	0	5168	0	10	40213160		
65072	1425	40213227	1997-01-28	1997-01-28 00:00:00	1997-01-28	1997-01-28 00:00:00	1997-01-28	581452		0	0	0		0	0	0	94726	0	113	40213227		
5387	452	1127078	1965-12-31	1965-12-31 00:00:00	1966-01-14	1966-01-14 00:00:00	1966-01-14	38000177		0	0	14		0	0	0	30087	0	282464	1127078		
5447	455	1713671	1950-03-07	1950-03-07 00:00:00	1950-03-21	1950-03-21 00:00:00	1950-03-21	38000177		0	0	14		0	0	0	30416	0	562251	1713671		
61540	5121	1127433	2019-01-19	2019-01-19 00:00:00	2019-01-26	2019-01-26 00:00:00	2019-01-26	38000177		0	0	7		0	0	0	340513	0	313782	1127433		
30361	662	40213160	1961-05-31	1961-05-31 00:00:00	1961-05-31	1961-05-31 00:00:00	1961-05-31	581452		0	0	0		0	0	0	43746	0	10	40213160		
68512	1500	40213160	1967-01-23	1967-01-23 00:00:00	1967-01-23	1967-01-23 00:00:00	1967-01-23	581452		0	0	0		0	0	0	100118	0	10	40213160		
18885	1560	19059056	1941-09-28	1941-09-28 00:00:00	1941-10-12	1941-10-12 00:00:00	1941-10-12	38000177		0	0	14		0	0	0	104505	0	243670	19059056		
25403	2088	1713671	1974-06-15	1974-06-15 00:00:00	1974-08-10	1974-08-10 00:00:00	1974-08-10	38000177		0	0	56		0	0	0	139200	0	562251	1713671		
54537	4531	19059056	1918-02-21	1918-02-21 00:00:00	1918-03-07	1918-03-07 00:00:00	1918-03-07	38000177		0	0	14		0	0	0	301756	0	243670	19059056		
54911	4561	1127433	1984-08-06	1984-08-06 00:00:00	1984-08-13	1984-08-13 00:00:00	1984-08-13	38000177		0	0	7		0	0	0	303938	0	313782	1127433		
40698	886	40213180	2006-03-14	2006-03-14 00:00:00	2006-03-14	2006-03-14 00:00:00	2006-03-14	581452		0	0	0		0	0	0	59050	0	114	40213180		
2755	222	1118084	1988-02-22	1988-02-22 00:00:00	1988-02-22	1988-02-22 00:00:00	\N	38000177		0	0	0		0	0	0	14926	0	00025152531	44923712		
36097	2975	1551192	1975-05-30	1975-05-30 00:00:00	1975-05-30	1975-05-30 00:00:00	1975-05-30	38000177		0	0	0		0	0	0	198628	0	312617	1551192		
23609	512	40213227	1996-03-01	1996-03-01 00:00:00	1996-03-01	1996-03-01 00:00:00	1996-03-01	581452		0	0	0		0	0	0	34195	0	113	40213227		
156149	3436	40213296	2004-02-23	2004-02-23 00:00:00	2004-02-23	2004-02-23 00:00:00	2004-02-23	581452		0	0	0		0	0	0	227910	0	52	40213296		
10556	879	19059056	1967-04-23	1967-04-23 00:00:00	1967-05-28	1967-05-28 00:00:00	1967-05-28	38000177		0	0	35		0	0	0	58579	0	243670	19059056		
43443	947	40213260	2018-07-20	2018-07-20 00:00:00	2018-07-20	2018-07-20 00:00:00	2018-07-20	581452		0	0	0		0	0	0	62878	0	121	40213260		
106125	2328	40213260	2006-10-09	2006-10-09 00:00:00	2006-10-09	2006-10-09 00:00:00	2006-10-09	581452		0	0	0		0	0	0	154804	0	121	40213260		
26921	2218	19128022	1995-05-04	1995-05-04 00:00:00	1996-04-28	1996-04-28 00:00:00	1996-04-28	38000177		0	0	360		0	0	0	147735	0	749785	19128022		
54841	1201	40213160	1973-06-20	1973-06-20 00:00:00	1973-06-20	1973-06-20 00:00:00	1973-06-20	581452		0	0	0		0	0	0	78992	0	10	40213160		
34583	2858	1713671	1950-03-20	1950-03-20 00:00:00	1950-04-10	1950-04-10 00:00:00	1950-04-10	38000177		0	0	21		0	0	0	189780	0	562251	1713671		
34614	2860	19006318	1955-09-25	1955-09-25 00:00:00	1955-10-09	1955-10-09 00:00:00	1955-10-09	38000177		0	0	14		0	0	0	190161	0	105078	19006318		
117760	2589	40213306	2005-11-01	2005-11-01 00:00:00	2005-11-01	2005-11-01 00:00:00	2005-11-01	581452		0	0	0		0	0	0	171325	0	43	40213306		
231783	5094	40213296	2018-05-07	2018-05-07 00:00:00	2018-05-07	2018-05-07 00:00:00	2018-05-07	581452		0	0	0		0	0	0	338464	0	52	40213296		
15013	1253	1118084	1997-03-13	1997-03-13 00:00:00	1997-03-13	1997-03-13 00:00:00	\N	38000177		0	0	0		0	0	0	82535	0	00025152531	44923712		
37674	3115	1127433	1973-04-27	1973-04-27 00:00:00	1973-05-04	1973-05-04 00:00:00	1973-05-04	38000177		0	0	7		0	0	0	207254	0	313782	1127433		
4006	332	1118084	2007-05-19	2007-05-19 00:00:00	2007-05-19	2007-05-19 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00025152531	44923712		
32746	2711	1127433	1968-05-27	1968-05-27 00:00:00	1968-06-03	1968-06-03 00:00:00	1968-06-03	38000177		0	0	7		0	0	0	179631	0	313782	1127433		
19465	1605	19059056	1948-01-27	1948-01-27 00:00:00	1948-02-17	1948-02-17 00:00:00	1948-02-17	38000177		0	0	21		0	0	0	107745	0	243670	19059056		
49069	4072	1713671	1977-06-02	1977-06-02 00:00:00	1977-06-23	1977-06-23 00:00:00	1977-06-23	38000177		0	0	21		0	0	0	270683	0	562251	1713671		
42703	931	40213227	2011-09-23	2011-09-23 00:00:00	2011-09-23	2011-09-23 00:00:00	2011-09-23	581452		0	0	0		0	0	0	61946	0	113	40213227		
9372	778	46233988	1978-07-18	1978-07-18 00:00:00	1978-08-01	1978-08-01 00:00:00	1978-08-01	38000177		0	0	14		0	0	0	51648	0	1652673	46233988		
48496	4018	1713671	1966-01-19	1966-01-19 00:00:00	1966-02-02	1966-02-02 00:00:00	1966-02-02	38000177		0	0	14		0	0	0	267064	0	562251	1713671		
63671	5291	1124300	2014-08-25	2014-08-25 00:00:00	2014-08-25	2014-08-25 00:00:00	\N	38000177		0	0	0		0	0	0	352095	0	00781178901	45011828		
27555	2283	19059056	1939-03-12	1939-03-12 00:00:00	1939-03-26	1939-03-26 00:00:00	1939-03-26	38000177		0	0	14		0	0	0	151893	0	243670	19059056		
168170	3697	40213160	1955-02-26	1955-02-26 00:00:00	1955-02-26	1955-02-26 00:00:00	1955-02-26	581452		0	0	0		0	0	0	245806	0	10	40213160		
49513	4107	19133905	1995-01-21	1995-01-21 00:00:00	1995-01-29	1995-01-29 00:00:00	1995-01-29	38000177		0	0	8		0	0	0	272890	0	834102	19133905		
118363	2603	40213160	1960-11-02	1960-11-02 00:00:00	1960-11-02	1960-11-02 00:00:00	1960-11-02	581452		0	0	0		0	0	0	172237	0	10	40213160		
30635	2541	40220960	1998-08-10	1998-08-10 00:00:00	1998-08-10	1998-08-10 00:00:00	1998-08-10	38000177		0	0	0		0	0	0	168027	0	1804799	40220960		
3782	316	40229134	2007-11-23	2007-11-23 00:00:00	2007-12-07	2007-12-07 00:00:00	2007-12-07	38000177		0	0	14		0	0	0	20864	0	1043400	40229134		
42769	3543	19128065	1980-06-08	1980-06-08 00:00:00	1981-06-03	1981-06-03 00:00:00	1981-06-03	38000177		0	0	360		0	0	0	235337	0	749882	19128065		
37824	3125	19078461	2003-03-10	2003-03-10 00:00:00	2003-04-14	2003-04-14 00:00:00	2003-04-14	38000177		0	0	35		0	0	0	207929	0	310965	19078461		
62981	5234	1713671	2000-07-25	2000-07-25 00:00:00	2000-08-15	2000-08-15 00:00:00	2000-08-15	38000177		0	0	21		0	0	0	348288	0	562251	1713671		
48358	4009	19059056	1951-09-03	1951-09-03 00:00:00	1951-10-07	1951-10-07 00:00:00	1951-10-07	38000177		0	0	34		0	0	0	266439	0	243670	19059056		
12492	1053	1127433	2017-05-28	2017-05-28 00:00:00	2017-06-04	2017-06-04 00:00:00	2017-06-04	38000177		0	0	7		0	0	0	69010	0	313782	1127433		
238819	5242	40213227	2004-08-06	2004-08-06 00:00:00	2004-08-06	2004-08-06 00:00:00	2004-08-06	581452		0	0	0		0	0	0	348825	0	113	40213227		
53661	4460	19133873	1951-12-08	1951-12-08 00:00:00	1951-12-16	1951-12-16 00:00:00	1951-12-16	38000177		0	0	8		0	0	0	296816	0	834061	19133873		
197866	4348	40213306	2004-08-25	2004-08-25 00:00:00	2004-08-25	2004-08-25 00:00:00	2004-08-25	581452		0	0	0		0	0	0	288318	0	43	40213306		
12637	1062	1127433	1979-05-24	1979-05-24 00:00:00	1979-06-23	1979-06-23 00:00:00	1979-06-23	38000177		0	0	30		0	0	0	69663	0	313782	1127433		
15466	1289	1127078	1965-03-18	1965-03-18 00:00:00	1965-04-08	1965-04-08 00:00:00	1965-04-08	38000177		0	0	21		0	0	0	85239	0	282464	1127078		
18074	1497	19077344	1983-03-05	1983-03-05 00:00:00	1983-03-05	1983-03-05 00:00:00	\N	38000177		0	0	0		0	0	0	99768	0	310325	19077344		
80047	1751	40213251	1984-09-19	1984-09-19 00:00:00	1984-09-19	1984-09-19 00:00:00	1984-09-19	581452		0	0	0		0	0	0	117087	0	21	40213251		
146596	3224	40213260	2010-04-16	2010-04-16 00:00:00	2010-04-16	2010-04-16 00:00:00	2010-04-16	581452		0	0	0		0	0	0	214377	0	121	40213260		
199797	4388	40213260	2017-06-03	2017-06-03 00:00:00	2017-06-03	2017-06-03 00:00:00	2017-06-03	581452		0	0	0		0	0	0	291680	0	121	40213260		
47292	3921	40231925	1999-07-10	1999-07-10 00:00:00	1999-07-10	1999-07-10 00:00:00	\N	38000177		0	0	0		0	0	0	260704	0	1049221	40231925		
30866	2555	1127433	1995-04-08	1995-04-08 00:00:00	1995-04-22	1995-04-22 00:00:00	1995-04-22	38000177		0	0	14		0	0	0	169319	0	313782	1127433		
41387	3432	19078461	2007-09-10	2007-09-10 00:00:00	2007-11-09	2007-11-09 00:00:00	2007-11-09	38000177		0	0	60		0	0	0	227490	0	310965	19078461		
26571	579	40213227	2002-04-17	2002-04-17 00:00:00	2002-04-17	2002-04-17 00:00:00	2002-04-17	581452		0	0	0		0	0	0	38347	0	113	40213227		
4567	379	1713671	1994-07-08	1994-07-08 00:00:00	1994-07-29	1994-07-29 00:00:00	1994-07-29	38000177		0	0	21		0	0	0	25106	0	562251	1713671		
49856	4137	1115171	2006-08-09	2006-08-09 00:00:00	2006-08-23	2006-08-23 00:00:00	2006-08-23	38000177		0	0	14		0	0	0	275053	0	849574	1115171		
63383	5265	19059056	1970-12-08	1970-12-08 00:00:00	1970-12-22	1970-12-22 00:00:00	1970-12-22	38000177		0	0	14		0	0	0	350326	0	243670	19059056		
6325	528	19006318	1960-07-22	1960-07-22 00:00:00	1960-08-05	1960-08-05 00:00:00	1960-08-05	38000177		0	0	14		0	0	0	35160	0	105078	19006318		
5230	439	1127078	1983-05-31	1983-05-31 00:00:00	1983-06-30	1983-06-30 00:00:00	1983-06-30	38000177		0	0	30		0	0	0	29151	0	282464	1127078		
3558	78	40213160	1971-12-16	1971-12-16 00:00:00	1971-12-16	1971-12-16 00:00:00	1971-12-16	581452		0	0	0		0	0	0	5172	0	10	40213160		
44569	970	40213227	1993-10-03	1993-10-03 00:00:00	1993-10-03	1993-10-03 00:00:00	1993-10-03	581452		0	0	0		0	0	0	64494	0	113	40213227		
5388	452	19059056	1964-10-26	1964-10-26 00:00:00	1964-11-30	1964-11-30 00:00:00	1964-11-30	38000177		0	0	35		0	0	0	30148	0	243670	19059056		
5448	455	19059056	1954-04-22	1954-04-22 00:00:00	1954-05-13	1954-05-13 00:00:00	1954-05-13	38000177		0	0	21		0	0	0	30466	0	243670	19059056		
61541	5121	1127433	2013-06-30	2013-06-30 00:00:00	2013-07-14	2013-07-14 00:00:00	2013-07-14	38000177		0	0	14		0	0	0	340508	0	313782	1127433		
30363	662	40213227	2002-10-02	2002-10-02 00:00:00	2002-10-02	2002-10-02 00:00:00	2002-10-02	581452		0	0	0		0	0	0	43726	0	113	40213227		
68517	1500	40213306	1984-09-03	1984-09-03 00:00:00	1984-09-03	1984-09-03 00:00:00	1984-09-03	581452		0	0	0		0	0	0	100122	0	43	40213306		
18886	1560	19059056	1940-06-16	1940-06-16 00:00:00	1940-07-07	1940-07-07 00:00:00	1940-07-07	38000177		0	0	21		0	0	0	104433	0	243670	19059056		
25404	2088	920300	1951-10-25	1951-10-25 00:00:00	1951-11-01	1951-11-01 00:00:00	1951-11-01	38000177		0	0	7		0	0	0	139263	0	311989	920300		
54538	4531	40229134	2008-07-24	2008-07-24 00:00:00	2008-07-31	2008-07-31 00:00:00	2008-07-31	38000177		0	0	7		0	0	0	301819	0	1043400	40229134		
54912	4561	1713671	1958-04-05	1958-04-05 00:00:00	1958-04-12	1958-04-12 00:00:00	1958-04-12	38000177		0	0	7		0	0	0	303871	0	562251	1713671		
40699	886	40213306	2006-03-14	2006-03-14 00:00:00	2006-03-14	2006-03-14 00:00:00	2006-03-14	581452		0	0	0		0	0	0	59050	0	43	40213306		
2756	222	19059056	1966-11-15	1966-11-15 00:00:00	1966-12-20	1966-12-20 00:00:00	1966-12-20	38000177		0	0	35		0	0	0	14933	0	243670	19059056		
36098	2975	1713671	2018-07-16	2018-07-16 00:00:00	2018-07-30	2018-07-30 00:00:00	2018-07-30	38000177		0	0	14		0	0	0	198584	0	562251	1713671		
23610	512	40213296	1996-03-01	1996-03-01 00:00:00	1996-03-01	1996-03-01 00:00:00	1996-03-01	581452		0	0	0		0	0	0	34195	0	52	40213296		
156152	3436	40213160	1963-07-22	1963-07-22 00:00:00	1963-07-22	1963-07-22 00:00:00	1963-07-22	581452		0	0	0		0	0	0	227900	0	10	40213160		
10557	879	1713671	1956-08-23	1956-08-23 00:00:00	1956-08-30	1956-08-30 00:00:00	1956-08-30	38000177		0	0	7		0	0	0	58520	0	562251	1713671		
124843	2747	40213227	2014-06-22	2014-06-22 00:00:00	2014-06-22	2014-06-22 00:00:00	2014-06-22	581452		0	0	0		0	0	0	181693	0	113	40213227		
106129	2328	40213260	2007-10-15	2007-10-15 00:00:00	2007-10-15	2007-10-15 00:00:00	2007-10-15	581452		0	0	0		0	0	0	154843	0	121	40213260		
26922	2218	40232448	1979-03-30	1979-03-30 00:00:00	1979-03-30	1979-03-30 00:00:00	\N	38000177		0	0	0		0	0	0	147700	0	1049630	40232448		
54848	1201	40213296	2012-10-17	2012-10-17 00:00:00	2012-10-17	2012-10-17 00:00:00	2012-10-17	581452		0	0	0		0	0	0	79008	0	52	40213296		
34584	2858	19059056	1912-03-11	1912-03-11 00:00:00	1912-04-10	1912-04-10 00:00:00	1912-04-10	38000177		0	0	30		0	0	0	189897	0	243670	19059056		
34615	2860	1127433	1955-09-25	1955-09-25 00:00:00	1955-10-09	1955-10-09 00:00:00	1955-10-09	38000177		0	0	14		0	0	0	190161	0	313782	1127433		
117761	2589	40213180	2005-11-01	2005-11-01 00:00:00	2005-11-01	2005-11-01 00:00:00	2005-11-01	581452		0	0	0		0	0	0	171325	0	114	40213180		
231784	5094	40213251	1984-04-16	1984-04-16 00:00:00	1984-04-16	1984-04-16 00:00:00	1984-04-16	581452		0	0	0		0	0	0	338475	0	21	40213251		
15014	1253	1713671	1995-09-13	1995-09-13 00:00:00	1995-10-04	1995-10-04 00:00:00	1995-10-04	38000177		0	0	21		0	0	0	82509	0	562251	1713671		
37675	3115	1713671	1980-08-15	1980-08-15 00:00:00	1980-08-29	1980-08-29 00:00:00	1980-08-29	38000177		0	0	14		0	0	0	207255	0	562251	1713671		
4007	332	1127433	1980-08-27	1980-08-27 00:00:00	1980-09-24	1980-09-24 00:00:00	1980-09-24	38000177		0	0	28		0	0	0	21909	0	313782	1127433		
32747	2712	1127433	2018-03-11	2018-03-11 00:00:00	2018-04-08	2018-04-08 00:00:00	2018-04-08	38000177		0	0	28		0	0	0	179886	0	313782	1127433		
19466	1605	1127433	1964-10-31	1964-10-31 00:00:00	1964-11-14	1964-11-14 00:00:00	1964-11-14	38000177		0	0	14		0	0	0	107677	0	313782	1127433		
49070	4072	1127433	2002-11-10	2002-11-10 00:00:00	2002-11-17	2002-11-17 00:00:00	2002-11-17	38000177		0	0	7		0	0	0	270696	0	313782	1127433		
42712	931	40213160	1961-02-24	1961-02-24 00:00:00	1961-02-24	1961-02-24 00:00:00	1961-02-24	581452		0	0	0		0	0	0	61949	0	10	40213160		
9373	778	19078461	2001-12-03	2001-12-03 00:00:00	2001-12-17	2001-12-17 00:00:00	2001-12-17	38000177		0	0	14		0	0	0	51674	0	310965	19078461		
48497	4018	19059056	1964-12-20	1964-12-20 00:00:00	1965-01-19	1965-01-19 00:00:00	1965-01-19	38000177		0	0	30		0	0	0	267048	0	243670	19059056		
63672	5291	19128022	1997-09-03	1997-09-03 00:00:00	1998-08-29	1998-08-29 00:00:00	1998-08-29	38000177		0	0	360		0	0	0	352057	0	749785	19128022		
27556	2283	1713671	1953-09-02	1953-09-02 00:00:00	1953-09-16	1953-09-16 00:00:00	1953-09-16	38000177		0	0	14		0	0	0	151877	0	562251	1713671		
168179	3697	40213227	2012-05-26	2012-05-26 00:00:00	2012-05-26	2012-05-26 00:00:00	2012-05-26	581452		0	0	0		0	0	0	245786	0	113	40213227		
49514	4107	1124300	2014-08-16	2014-08-16 00:00:00	2014-08-16	2014-08-16 00:00:00	\N	38000177		0	0	0		0	0	0	272888	0	00781178901	45011828		
118372	2603	40213227	1994-10-26	1994-10-26 00:00:00	1994-10-26	1994-10-26 00:00:00	1994-10-26	581452		0	0	0		0	0	0	172218	0	113	40213227		
30636	2541	19075601	1998-08-10	1998-08-10 00:00:00	1998-08-10	1998-08-10 00:00:00	1998-08-10	38000177		0	0	0		0	0	0	168027	0	309362	19075601		
3783	316	19059056	1927-10-01	1927-10-01 00:00:00	1927-10-15	1927-10-15 00:00:00	1927-10-15	38000177		0	0	14		0	0	0	20877	0	243670	19059056		
42770	3543	920300	2018-09-13	2018-09-13 00:00:00	2018-09-20	2018-09-20 00:00:00	2018-09-20	38000177		0	0	7		0	0	0	235349	0	311989	920300		
37825	3125	40229134	1967-08-20	1967-08-20 00:00:00	1967-09-03	1967-09-03 00:00:00	1967-09-03	38000177		0	0	14		0	0	0	207925	0	1043400	40229134		
62982	5234	1127433	1956-06-25	1956-06-25 00:00:00	1956-07-09	1956-07-09 00:00:00	1956-07-09	38000177		0	0	14		0	0	0	348222	0	313782	1127433		
48359	4009	1127433	1984-01-08	1984-01-08 00:00:00	1984-01-15	1984-01-15 00:00:00	1984-01-15	38000177		0	0	7		0	0	0	266427	0	313782	1127433		
12493	1053	19128022	1990-01-26	1990-01-26 00:00:00	1991-01-21	1991-01-21 00:00:00	1991-01-21	38000177		0	0	360		0	0	0	69059	0	749785	19128022		
238820	5242	40213296	2004-08-06	2004-08-06 00:00:00	2004-08-06	2004-08-06 00:00:00	2004-08-06	581452		0	0	0		0	0	0	348825	0	52	40213296		
53662	4460	1127433	2006-08-24	2006-08-24 00:00:00	2006-09-07	2006-09-07 00:00:00	2006-09-07	38000177		0	0	14		0	0	0	296827	0	313782	1127433		
197868	4348	40213227	2004-08-25	2004-08-25 00:00:00	2004-08-25	2004-08-25 00:00:00	2004-08-25	581452		0	0	0		0	0	0	288318	0	113	40213227		
12638	1062	40165015	1979-05-24	1979-05-24 00:00:00	1979-05-24	1979-05-24 00:00:00	\N	38000177		0	0	0		0	0	0	69663	0	861467	40165015		
15467	1289	40229134	1976-12-26	1976-12-26 00:00:00	1977-01-09	1977-01-09 00:00:00	1977-01-09	38000177		0	0	14		0	0	0	85194	0	1043400	40229134		
18075	1497	19059056	1940-11-10	1940-11-10 00:00:00	1940-11-24	1940-11-24 00:00:00	1940-11-24	38000177		0	0	14		0	0	0	99884	0	243670	19059056		
80053	1751	40213227	2011-04-13	2011-04-13 00:00:00	2011-04-13	2011-04-13 00:00:00	2011-04-13	581452		0	0	0		0	0	0	117093	0	113	40213227		
6138	133	40213227	2003-02-17	2003-02-17 00:00:00	2003-02-17	2003-02-17 00:00:00	2003-02-17	581452		0	0	0		0	0	0	8971	0	113	40213227		
34709	2866	1127433	2018-10-03	2018-10-03 00:00:00	2018-10-31	2018-10-31 00:00:00	2018-10-31	38000177		0	0	28		0	0	0	190697	0	313782	1127433		
47293	3921	1127078	1986-08-17	1986-08-17 00:00:00	1986-09-16	1986-09-16 00:00:00	1986-09-16	38000177		0	0	30		0	0	0	260703	0	282464	1127078		
30868	2555	40229134	2004-09-22	2004-09-22 00:00:00	2004-09-29	2004-09-29 00:00:00	2004-09-29	38000177		0	0	7		0	0	0	169324	0	1043400	40229134		
41388	3432	1124300	1994-06-16	1994-06-16 00:00:00	1994-06-16	1994-06-16 00:00:00	\N	38000177		0	0	0		0	0	0	227517	0	00781178901	45011828		
26572	579	40213296	2002-04-17	2002-04-17 00:00:00	2002-04-17	2002-04-17 00:00:00	2002-04-17	581452		0	0	0		0	0	0	38347	0	52	40213296		
4568	379	1713671	1982-09-27	1982-09-27 00:00:00	1982-10-04	1982-10-04 00:00:00	1982-10-04	38000177		0	0	7		0	0	0	25062	0	562251	1713671		
49857	4137	40169281	2013-02-06	2013-02-06 00:00:00	2013-02-06	2013-02-06 00:00:00	\N	38000177		0	0	0		0	0	0	275036	0	896209	40169281		
63384	5265	1713671	1991-11-27	1991-11-27 00:00:00	1991-12-18	1991-12-18 00:00:00	1991-12-18	38000177		0	0	21		0	0	0	350280	0	562251	1713671		
6326	528	1713671	1963-01-30	1963-01-30 00:00:00	1963-02-13	1963-02-13 00:00:00	1963-02-13	38000177		0	0	14		0	0	0	35206	0	562251	1713671		
5231	439	1115171	2002-12-21	2002-12-21 00:00:00	2003-01-04	2003-01-04 00:00:00	2003-01-04	38000177		0	0	14		0	0	0	29166	0	849574	1115171		
3564	78	40213227	2008-11-13	2008-11-13 00:00:00	2008-11-13	2008-11-13 00:00:00	2008-11-13	581452		0	0	0		0	0	0	5176	0	113	40213227		
44570	970	40213160	1955-11-13	1955-11-13 00:00:00	1955-11-13	1955-11-13 00:00:00	1955-11-13	581452		0	0	0		0	0	0	64553	0	10	40213160		
5389	452	1118084	2002-04-15	2002-04-15 00:00:00	2002-04-15	2002-04-15 00:00:00	\N	38000177		0	0	0		0	0	0	30079	0	00025152531	44923712		
5449	455	1127078	1952-08-09	1952-08-09 00:00:00	1952-08-30	1952-08-30 00:00:00	1952-08-30	38000177		0	0	21		0	0	0	30455	0	282464	1127078		
61542	5121	1127078	1964-11-16	1964-11-16 00:00:00	1964-11-30	1964-11-30 00:00:00	1964-11-30	38000177		0	0	14		0	0	0	340498	0	282464	1127078		
30364	662	40213296	2002-10-02	2002-10-02 00:00:00	2002-10-02	2002-10-02 00:00:00	2002-10-02	581452		0	0	0		0	0	0	43726	0	52	40213296		
59875	4976	19133873	1913-01-15	1913-01-15 00:00:00	1913-01-25	1913-01-25 00:00:00	1913-01-25	38000177		0	0	10		0	0	0	331067	0	834061	19133873		
18887	1560	19059056	1937-05-14	1937-05-14 00:00:00	1937-05-28	1937-05-28 00:00:00	1937-05-28	38000177		0	0	14		0	0	0	104453	0	243670	19059056		
25405	2088	40236824	1951-10-25	1951-10-25 00:00:00	1951-11-01	1951-11-01 00:00:00	1951-11-01	38000177		0	0	7		0	0	0	139263	0	1094107	40236824		
54539	4531	19078461	1983-07-22	1983-07-22 00:00:00	1983-10-20	1983-10-20 00:00:00	1983-10-20	38000177		0	0	90		0	0	0	301707	0	310965	19078461		
54913	4561	19133873	1959-04-12	1959-04-12 00:00:00	1959-04-20	1959-04-20 00:00:00	1959-04-20	38000177		0	0	8		0	0	0	303883	0	834061	19133873		
40708	887	40213260	2008-06-28	2008-06-28 00:00:00	2008-06-28	2008-06-28 00:00:00	2008-06-28	581452		0	0	0		0	0	0	59160	0	121	40213260		
2757	222	1713671	1994-02-09	1994-02-09 00:00:00	1994-02-23	1994-02-23 00:00:00	1994-02-23	38000177		0	0	14		0	0	0	14938	0	562251	1713671		
36099	2975	40229134	1973-09-09	1973-09-09 00:00:00	1973-09-16	1973-09-16 00:00:00	1973-09-16	38000177		0	0	7		0	0	0	198567	0	1043400	40229134		
23613	512	40213160	1959-01-30	1959-01-30 00:00:00	1959-01-30	1959-01-30 00:00:00	1959-01-30	581452		0	0	0		0	0	0	34190	0	10	40213160		
160566	3533	40213160	1966-11-09	1966-11-09 00:00:00	1966-11-09	1966-11-09 00:00:00	1966-11-09	581452		0	0	0		0	0	0	234698	0	10	40213160		
10558	879	19073188	2011-09-13	2011-09-13 00:00:00	2011-09-27	2011-09-27 00:00:00	2011-09-27	38000177		0	0	14		0	0	0	58550	0	308192	19073188		
124844	2747	40213296	2014-06-22	2014-06-22 00:00:00	2014-06-22	2014-06-22 00:00:00	2014-06-22	581452		0	0	0		0	0	0	181693	0	52	40213296		
106141	2328	40213160	1955-09-05	1955-09-05 00:00:00	1955-09-05	1955-09-05 00:00:00	1955-09-05	581452		0	0	0		0	0	0	154873	0	10	40213160		
26923	2218	19059056	1984-02-12	1984-02-12 00:00:00	1984-02-26	1984-02-26 00:00:00	1984-02-26	38000177		0	0	14		0	0	0	147706	0	243670	19059056		
54858	1201	40213227	2004-08-18	2004-08-18 00:00:00	2004-08-18	2004-08-18 00:00:00	2004-08-18	581452		0	0	0		0	0	0	79005	0	113	40213227		
34585	2858	1127433	1950-07-19	1950-07-19 00:00:00	1950-08-02	1950-08-02 00:00:00	1950-08-02	38000177		0	0	14		0	0	0	189901	0	313782	1127433		
34616	2860	19006318	1946-01-24	1946-01-24 00:00:00	1946-02-07	1946-02-07 00:00:00	1946-02-07	38000177		0	0	14		0	0	0	190160	0	105078	19006318		
117764	2589	40213314	1984-05-29	1984-05-29 00:00:00	1984-05-29	1984-05-29 00:00:00	1984-05-29	581452		0	0	0		0	0	0	171334	0	49	40213314		
231786	5094	40213314	1979-07-09	1979-07-09 00:00:00	1979-07-09	1979-07-09 00:00:00	1979-07-09	581452		0	0	0		0	0	0	338451	0	49	40213314		
15015	1253	19059056	1956-12-28	1956-12-28 00:00:00	1957-01-11	1957-01-11 00:00:00	1957-01-11	38000177		0	0	14		0	0	0	82525	0	243670	19059056		
37676	3115	1713671	1988-12-07	1988-12-07 00:00:00	1988-12-14	1988-12-14 00:00:00	1988-12-14	38000177		0	0	7		0	0	0	207257	0	562251	1713671		
4008	332	1127433	1969-02-14	1969-02-14 00:00:00	1969-02-21	1969-02-21 00:00:00	1969-02-21	38000177		0	0	7		0	0	0	21936	0	313782	1127433		
32748	2712	40229134	1995-10-30	1995-10-30 00:00:00	1995-11-13	1995-11-13 00:00:00	1995-11-13	38000177		0	0	14		0	0	0	179828	0	1043400	40229134		
19467	1605	1127433	1992-08-20	1992-08-20 00:00:00	1992-08-27	1992-08-27 00:00:00	1992-08-27	38000177		0	0	7		0	0	0	107671	0	313782	1127433		
49071	4072	1115171	2004-04-16	2004-04-16 00:00:00	2004-04-30	2004-04-30 00:00:00	2004-04-30	38000177		0	0	14		0	0	0	270689	0	849574	1115171		
42715	931	40213160	1965-08-27	1965-08-27 00:00:00	1965-08-27	1965-08-27 00:00:00	1965-08-27	581452		0	0	0		0	0	0	61996	0	10	40213160		
9374	778	1127078	1988-03-16	1988-03-16 00:00:00	1988-06-14	1988-06-14 00:00:00	1988-06-14	38000177		0	0	90		0	0	0	51673	0	282464	1127078		
48498	4018	19133905	1987-06-09	1987-06-09 00:00:00	1987-06-17	1987-06-17 00:00:00	1987-06-17	38000177		0	0	8		0	0	0	267065	0	834102	19133905		
63673	5291	1127078	1981-03-06	1981-03-06 00:00:00	1981-03-20	1981-03-20 00:00:00	1981-03-20	38000177		0	0	14		0	0	0	352056	0	282464	1127078		
38015	3144	1127078	1965-05-02	1965-05-02 00:00:00	1965-05-16	1965-05-16 00:00:00	1965-05-16	38000177		0	0	14		0	0	0	209209	0	282464	1127078		
168181	3697	40213201	2017-06-24	2017-06-24 00:00:00	2017-06-24	2017-06-24 00:00:00	2017-06-24	581452		0	0	0		0	0	0	245767	0	33	40213201		
143674	3157	40213227	1994-07-15	1994-07-15 00:00:00	1994-07-15	1994-07-15 00:00:00	1994-07-15	581452		0	0	0		0	0	0	209815	0	113	40213227		
118376	2603	40213160	1965-04-28	1965-04-28 00:00:00	1965-04-28	1965-04-28 00:00:00	1965-04-28	581452		0	0	0		0	0	0	172171	0	10	40213160		
30637	2541	1127433	2003-11-06	2003-11-06 00:00:00	2003-12-06	2003-12-06 00:00:00	2003-12-06	38000177		0	0	30		0	0	0	168022	0	313782	1127433		
3784	316	1127433	2010-01-19	2010-01-19 00:00:00	2010-01-26	2010-01-26 00:00:00	2010-01-26	38000177		0	0	7		0	0	0	20896	0	313782	1127433		
42771	3543	40236824	2018-09-13	2018-09-13 00:00:00	2018-09-20	2018-09-20 00:00:00	2018-09-20	38000177		0	0	7		0	0	0	235349	0	1094107	40236824		
37826	3125	19059056	1986-12-22	1986-12-22 00:00:00	1987-01-19	1987-01-19 00:00:00	1987-01-19	38000177		0	0	28		0	0	0	208007	0	243670	19059056		
25244	550	40213227	1992-06-03	1992-06-03 00:00:00	1992-06-03	1992-06-03 00:00:00	1992-06-03	581452		0	0	0		0	0	0	36462	0	113	40213227		
48360	4009	19059056	1955-08-18	1955-08-18 00:00:00	1955-09-08	1955-09-08 00:00:00	1955-09-08	38000177		0	0	21		0	0	0	266432	0	243670	19059056		
12494	1053	40236824	2018-04-11	2018-04-11 00:00:00	2018-04-18	2018-04-18 00:00:00	2018-04-18	38000177		0	0	7		0	0	0	69058	0	1094107	40236824		
238827	5242	40213227	1993-11-05	1993-11-05 00:00:00	1993-11-05	1993-11-05 00:00:00	1993-11-05	581452		0	0	0		0	0	0	\N	0	113	40213227		
53663	4460	1127433	1961-03-19	1961-03-19 00:00:00	1961-04-09	1961-04-09 00:00:00	1961-04-09	38000177		0	0	21		0	0	0	296738	0	313782	1127433		
197873	4348	40213314	1982-11-24	1982-11-24 00:00:00	1982-11-24	1982-11-24 00:00:00	1982-11-24	581452		0	0	0		0	0	0	288352	0	49	40213314		
63785	5300	1127433	2007-06-15	2007-06-15 00:00:00	2007-06-29	2007-06-29 00:00:00	2007-06-29	38000177		0	0	14		0	0	0	352616	0	313782	1127433		
15492	1292	40229134	1995-09-16	1995-09-16 00:00:00	1995-09-30	1995-09-30 00:00:00	1995-09-30	38000177		0	0	14		0	0	0	85385	0	1043400	40229134		
18076	1497	1551192	1941-05-10	1941-05-10 00:00:00	1941-05-10	1941-05-10 00:00:00	1941-05-10	38000177		0	0	0		0	0	0	99778	0	312617	1551192		
80054	1751	40213314	1978-12-06	1978-12-06 00:00:00	1978-12-06	1978-12-06 00:00:00	1978-12-06	581452		0	0	0		0	0	0	117083	0	49	40213314		
6139	133	40213306	2003-02-17	2003-02-17 00:00:00	2003-02-17	2003-02-17 00:00:00	2003-02-17	581452		0	0	0		0	0	0	8971	0	43	40213306		
34710	2866	19128065	1984-07-13	1984-07-13 00:00:00	1985-07-08	1985-07-08 00:00:00	1985-07-08	38000177		0	0	360		0	0	0	190667	0	749882	19128065		
47294	3921	19078461	2004-08-12	2004-08-12 00:00:00	2004-09-02	2004-09-02 00:00:00	2004-09-02	38000177		0	0	21		0	0	0	260705	0	310965	19078461		
30869	2555	1127433	2013-08-10	2013-08-10 00:00:00	2013-08-24	2013-08-24 00:00:00	2013-08-24	38000177		0	0	14		0	0	0	169289	0	313782	1127433		
41389	3432	1127433	1967-05-10	1967-05-10 00:00:00	1967-08-08	1967-08-08 00:00:00	1967-08-08	38000177		0	0	90		0	0	0	227486	0	313782	1127433		
26580	579	40213306	1983-10-05	1983-10-05 00:00:00	1983-10-05	1983-10-05 00:00:00	1983-10-05	581452		0	0	0		0	0	0	38333	0	43	40213306		
4569	379	1124300	2014-01-28	2014-01-28 00:00:00	2014-01-28	2014-01-28 00:00:00	\N	38000177		0	0	0		0	0	0	25082	0	00781178901	45011828		
49858	4137	1713671	2002-10-07	2002-10-07 00:00:00	2002-11-18	2002-11-18 00:00:00	2002-11-18	38000177		0	0	42		0	0	0	274999	0	562251	1713671		
63385	5265	1115171	2008-03-12	2008-03-12 00:00:00	2008-04-02	2008-04-02 00:00:00	2008-04-02	38000177		0	0	21		0	0	0	350270	0	849574	1115171		
55089	4574	19059056	1958-10-02	1958-10-02 00:00:00	1958-10-16	1958-10-16 00:00:00	1958-10-16	38000177		0	0	14		0	0	0	304747	0	243670	19059056		
5232	439	19075001	2002-12-21	2002-12-21 00:00:00	2003-01-04	2003-01-04 00:00:00	2003-01-04	38000177		0	0	14		0	0	0	29166	0	309097	19075001		
3565	78	40213296	2008-11-13	2008-11-13 00:00:00	2008-11-13	2008-11-13 00:00:00	2008-11-13	581452		0	0	0		0	0	0	5176	0	52	40213296		
55851	1223	40213227	1993-08-20	1993-08-20 00:00:00	1993-08-20	1993-08-20 00:00:00	1993-08-20	581452		0	0	0		0	0	0	80470	0	113	40213227		
5390	452	1127078	1963-01-05	1963-01-05 00:00:00	1963-01-19	1963-01-19 00:00:00	1963-01-19	38000177		0	0	14		0	0	0	30108	0	282464	1127078		
5450	455	1118084	1986-08-15	1986-08-15 00:00:00	1986-08-15	1986-08-15 00:00:00	\N	38000177		0	0	0		0	0	0	30427	0	00025152531	44923712		
61543	5121	19006318	1964-11-16	1964-11-16 00:00:00	1964-11-30	1964-11-30 00:00:00	1964-11-30	38000177		0	0	14		0	0	0	340498	0	105078	19006318		
30368	662	40213306	1982-11-23	1982-11-23 00:00:00	1982-11-23	1982-11-23 00:00:00	1982-11-23	581452		0	0	0		0	0	0	43712	0	43	40213306		
59876	4976	19059056	1913-12-07	1913-12-07 00:00:00	1914-01-04	1914-01-04 00:00:00	1914-01-04	38000177		0	0	28		0	0	0	330921	0	243670	19059056		
18888	1560	1118084	1974-12-20	1974-12-20 00:00:00	1974-12-20	1974-12-20 00:00:00	\N	38000177		0	0	0		0	0	0	104473	0	00025152531	44923712		
25406	2088	1127433	1972-07-10	1972-07-10 00:00:00	1972-07-24	1972-07-24 00:00:00	1972-07-24	38000177		0	0	14		0	0	0	139261	0	313782	1127433		
54540	4531	19059056	1948-05-28	1948-05-28 00:00:00	1948-06-11	1948-06-11 00:00:00	1948-06-11	38000177		0	0	14		0	0	0	301705	0	243670	19059056		
54914	4561	19133905	1980-04-12	1980-04-12 00:00:00	1980-04-20	1980-04-20 00:00:00	1980-04-20	38000177		0	0	8		0	0	0	303920	0	834102	19133905		
40713	887	40213227	2010-01-09	2010-01-09 00:00:00	2010-01-09	2010-01-09 00:00:00	2010-01-09	581452		0	0	0		0	0	0	59174	0	113	40213227		
2758	222	19059056	1953-09-03	1953-09-03 00:00:00	1953-09-17	1953-09-17 00:00:00	1953-09-17	38000177		0	0	14		0	0	0	14916	0	243670	19059056		
36100	2975	1127433	1984-11-03	1984-11-03 00:00:00	1984-11-10	1984-11-10 00:00:00	1984-11-10	38000177		0	0	7		0	0	0	198623	0	313782	1127433		
203375	4465	40213296	2013-02-01	2013-02-01 00:00:00	2013-02-01	2013-02-01 00:00:00	2013-02-01	581452		0	0	0		0	0	0	297042	0	52	40213296		
160570	3533	40213260	2011-11-30	2011-11-30 00:00:00	2011-11-30	2011-11-30 00:00:00	2011-11-30	581452		0	0	0		0	0	0	234671	0	121	40213260		
10559	879	1127433	2011-09-13	2011-09-13 00:00:00	2011-09-27	2011-09-27 00:00:00	2011-09-27	38000177		0	0	14		0	0	0	58550	0	313782	1127433		
124848	2747	40213160	1972-11-19	1972-11-19 00:00:00	1972-11-19	1972-11-19 00:00:00	1972-11-19	581452		0	0	0		0	0	0	181679	0	10	40213160		
106143	2328	40213227	2005-10-03	2005-10-03 00:00:00	2005-10-03	2005-10-03 00:00:00	2005-10-03	581452		0	0	0		0	0	0	154842	0	113	40213227		
26924	2218	19073183	1984-02-12	1984-02-12 00:00:00	1984-02-26	1984-02-26 00:00:00	1984-02-26	38000177		0	0	14		0	0	0	147706	0	308182	19073183		
54859	1201	40213160	1973-03-21	1973-03-21 00:00:00	1973-03-21	1973-03-21 00:00:00	1973-03-21	581452		0	0	0		0	0	0	79014	0	10	40213160		
34586	2858	1127433	1979-07-01	1979-07-01 00:00:00	1979-07-15	1979-07-15 00:00:00	1979-07-15	38000177		0	0	14		0	0	0	189902	0	313782	1127433		
34617	2860	19059056	1946-01-24	1946-01-24 00:00:00	1946-02-07	1946-02-07 00:00:00	1946-02-07	38000177		0	0	14		0	0	0	190160	0	243670	19059056		
117765	2589	40213251	1984-05-29	1984-05-29 00:00:00	1984-05-29	1984-05-29 00:00:00	1984-05-29	581452		0	0	0		0	0	0	171334	0	21	40213251		
231788	5094	40213314	1978-08-07	1978-08-07 00:00:00	1978-08-07	1978-08-07 00:00:00	1978-08-07	581452		0	0	0		0	0	0	338479	0	49	40213314		
15016	1253	19006318	1956-12-28	1956-12-28 00:00:00	1957-01-11	1957-01-11 00:00:00	1957-01-11	38000177		0	0	14		0	0	0	82525	0	105078	19006318		
37677	3115	19129655	1968-04-14	1968-04-14 00:00:00	1968-04-28	1968-04-28 00:00:00	1968-04-28	38000177		0	0	14		0	0	0	207262	0	789980	19129655		
4024	334	1127433	1992-03-25	1992-03-25 00:00:00	1992-04-08	1992-04-08 00:00:00	1992-04-08	38000177		0	0	14		0	0	0	22131	0	313782	1127433		
32750	2712	19059056	1968-12-04	1968-12-04 00:00:00	1968-12-25	1968-12-25 00:00:00	1968-12-25	38000177		0	0	21		0	0	0	179882	0	243670	19059056		
19468	1605	19075601	2006-09-17	2006-09-17 00:00:00	2006-09-17	2006-09-17 00:00:00	2006-09-17	38000177		0	0	0		0	0	0	107770	0	309362	19075601		
49072	4072	1127433	1999-08-27	1999-08-27 00:00:00	1999-09-10	1999-09-10 00:00:00	1999-09-10	38000177		0	0	14		0	0	0	270688	0	313782	1127433		
42724	931	40213306	1983-07-29	1983-07-29 00:00:00	1983-07-29	1983-07-29 00:00:00	1983-07-29	581452		0	0	0		0	0	0	61955	0	43	40213306		
9375	778	1118084	2011-05-06	2011-05-06 00:00:00	2011-05-06	2011-05-06 00:00:00	\N	38000177		0	0	0		0	0	0	51684	0	00025152531	44923712		
48499	4018	19059056	1966-06-25	1966-06-25 00:00:00	1966-07-09	1966-07-09 00:00:00	1966-07-09	38000177		0	0	14		0	0	0	267067	0	243670	19059056		
63674	5291	19073183	1981-03-06	1981-03-06 00:00:00	1981-03-20	1981-03-20 00:00:00	1981-03-20	38000177		0	0	14		0	0	0	352056	0	308182	19073183		
38016	3144	19129655	1965-05-02	1965-05-02 00:00:00	1965-05-16	1965-05-16 00:00:00	1965-05-16	38000177		0	0	14		0	0	0	209209	0	789980	19129655		
46763	1021	40213160	1955-05-19	1955-05-19 00:00:00	1955-05-19	1955-05-19 00:00:00	1955-05-19	581452		0	0	0		0	0	0	67195	0	10	40213160		
143683	3157	40213160	1957-06-14	1957-06-14 00:00:00	1957-06-14	1957-06-14 00:00:00	1957-06-14	581452		0	0	0		0	0	0	209897	0	10	40213160		
118383	2603	40213296	2000-05-31	2000-05-31 00:00:00	2000-05-31	2000-05-31 00:00:00	2000-05-31	581452		0	0	0		0	0	0	172207	0	52	40213296		
30638	2541	40231925	2003-11-06	2003-11-06 00:00:00	2003-11-06	2003-11-06 00:00:00	\N	38000177		0	0	0		0	0	0	168022	0	1049221	40231925		
3785	316	1127433	2012-02-01	2012-02-01 00:00:00	2012-05-01	2012-05-01 00:00:00	2012-05-01	38000177		0	0	90		0	0	0	20984	0	313782	1127433		
42778	3545	1124300	2011-12-13	2011-12-13 00:00:00	2011-12-13	2011-12-13 00:00:00	\N	38000177		0	0	0		0	0	0	235450	0	00781178901	45011828		
37827	3125	19059056	1957-07-17	1957-07-17 00:00:00	1957-07-31	1957-07-31 00:00:00	1957-07-31	38000177		0	0	14		0	0	0	208004	0	243670	19059056		
17234	372	40213160	1961-08-19	1961-08-19 00:00:00	1961-08-19	1961-08-19 00:00:00	1961-08-19	581452		0	0	0		0	0	0	24759	0	10	40213160		
48361	4009	19074679	2007-03-28	2007-03-28 00:00:00	2007-03-28	2007-03-28 00:00:00	\N	38000177		0	0	0		0	0	0	266450	0	308971	19074679		
12495	1053	920300	2018-04-11	2018-04-11 00:00:00	2018-04-18	2018-04-18 00:00:00	2018-04-18	38000177		0	0	7		0	0	0	69058	0	311989	920300		
238830	5242	40213260	2013-08-02	2013-08-02 00:00:00	2013-08-02	2013-08-02 00:00:00	2013-08-02	581452		0	0	0		0	0	0	348842	0	121	40213260		
53664	4460	19059056	1944-01-18	1944-01-18 00:00:00	1944-02-01	1944-02-01 00:00:00	1944-02-01	38000177		0	0	14		0	0	0	296799	0	243670	19059056		
76798	1677	40213160	1970-03-21	1970-03-21 00:00:00	1970-03-21	1970-03-21 00:00:00	1970-03-21	581452		0	0	0		0	0	0	112521	0	10	40213160		
63786	5300	19078461	1994-01-18	1994-01-18 00:00:00	1994-02-08	1994-02-08 00:00:00	1994-02-08	38000177		0	0	21		0	0	0	352655	0	310965	19078461		
15493	1292	1713671	1974-11-14	1974-11-14 00:00:00	1974-12-05	1974-12-05 00:00:00	1974-12-05	38000177		0	0	21		0	0	0	85421	0	562251	1713671		
18077	1497	19133905	1978-06-08	1978-06-08 00:00:00	1978-06-19	1978-06-19 00:00:00	1978-06-19	38000177		0	0	11		0	0	0	99847	0	834102	19133905		
80063	1751	40213160	1978-06-07	1978-06-07 00:00:00	1978-06-07	1978-06-07 00:00:00	1978-06-07	581452		0	0	0		0	0	0	117054	0	10	40213160		
6141	133	40213251	1984-05-21	1984-05-21 00:00:00	1984-05-21	1984-05-21 00:00:00	1984-05-21	581452		0	0	0		0	0	0	8983	0	21	40213251		
34711	2866	1713671	1984-08-25	1984-08-25 00:00:00	1984-09-01	1984-09-01 00:00:00	1984-09-01	38000177		0	0	7		0	0	0	190663	0	562251	1713671		
47295	3921	42902245	2002-10-02	2002-10-02 00:00:00	2003-09-27	2003-09-27 00:00:00	2003-09-27	38000177		0	0	360		0	0	0	260720	0	1359133	42902245		
30870	2555	1127433	1971-04-08	1971-04-08 00:00:00	1971-05-14	1971-05-14 00:00:00	1971-05-14	38000177		0	0	36		0	0	0	169313	0	313782	1127433		
41390	3432	1127433	1964-06-03	1964-06-03 00:00:00	1964-06-24	1964-06-24 00:00:00	1964-06-24	38000177		0	0	21		0	0	0	227485	0	313782	1127433		
26583	579	40213260	2011-09-07	2011-09-07 00:00:00	2011-09-07	2011-09-07 00:00:00	2011-09-07	581452		0	0	0		0	0	0	38372	0	121	40213260		
4570	380	1713671	1998-04-22	1998-04-22 00:00:00	1998-04-29	1998-04-29 00:00:00	1998-04-29	38000177		0	0	7		0	0	0	25143	0	562251	1713671		
49859	4137	1118084	2002-07-09	2002-07-09 00:00:00	2002-07-09	2002-07-09 00:00:00	\N	38000177		0	0	0		0	0	0	275017	0	00025152531	44923712		
63386	5265	19059056	1971-02-06	1971-02-06 00:00:00	1971-02-20	1971-02-20 00:00:00	1971-02-20	38000177		0	0	14		0	0	0	350305	0	243670	19059056		
55090	4574	19006318	1958-10-02	1958-10-02 00:00:00	1958-10-16	1958-10-16 00:00:00	1958-10-16	38000177		0	0	14		0	0	0	304747	0	105078	19006318		
5233	439	1118084	2013-05-08	2013-05-08 00:00:00	2013-05-08	2013-05-08 00:00:00	\N	38000177		0	0	0		0	0	0	29148	0	00025152531	44923712		
3568	78	40213227	2000-11-02	2000-11-02 00:00:00	2000-11-02	2000-11-02 00:00:00	2000-11-02	581452		0	0	0		0	0	0	5200	0	113	40213227		
55860	1223	40213201	2017-06-09	2017-06-09 00:00:00	2017-06-09	2017-06-09 00:00:00	2017-06-09	581452		0	0	0		0	0	0	80463	0	33	40213201		
5391	452	19129655	1963-01-05	1963-01-05 00:00:00	1963-01-19	1963-01-19 00:00:00	1963-01-19	38000177		0	0	14		0	0	0	30108	0	789980	19129655		
5451	455	1127078	1951-09-23	1951-09-23 00:00:00	1951-10-14	1951-10-14 00:00:00	1951-10-14	38000177		0	0	21		0	0	0	30454	0	282464	1127078		
61544	5121	1127433	1998-10-19	1998-10-19 00:00:00	1998-11-16	1998-11-16 00:00:00	1998-11-16	38000177		0	0	28		0	0	0	340507	0	313782	1127433		
127260	2799	40213160	1980-09-10	1980-09-10 00:00:00	1980-09-10	1980-09-10 00:00:00	1980-09-10	581452		0	0	0		0	0	0	185488	0	10	40213160		
59877	4976	19059056	1917-08-16	1917-08-16 00:00:00	1917-11-14	1917-11-14 00:00:00	1917-11-14	38000177		0	0	90		0	0	0	331100	0	243670	19059056		
18889	1560	1127433	2009-02-05	2009-02-05 00:00:00	2009-03-12	2009-03-12 00:00:00	2009-03-12	38000177		0	0	35		0	0	0	104434	0	313782	1127433		
25407	2088	1127433	1974-01-05	1974-01-05 00:00:00	1974-02-02	1974-02-02 00:00:00	1974-02-02	38000177		0	0	28		0	0	0	139181	0	313782	1127433		
54541	4531	19059056	1916-07-19	1916-07-19 00:00:00	1916-08-02	1916-08-02 00:00:00	1916-08-02	38000177		0	0	14		0	0	0	301822	0	243670	19059056		
54915	4561	1127433	2004-12-24	2004-12-24 00:00:00	2005-01-07	2005-01-07 00:00:00	2005-01-07	38000177		0	0	14		0	0	0	303949	0	313782	1127433		
40718	887	40213160	1958-09-20	1958-09-20 00:00:00	1958-09-20	1958-09-20 00:00:00	1958-09-20	581452		0	0	0		0	0	0	59114	0	10	40213160		
2759	222	19006318	1953-09-03	1953-09-03 00:00:00	1953-09-17	1953-09-17 00:00:00	1953-09-17	38000177		0	0	14		0	0	0	14916	0	105078	19006318		
36101	2975	40229134	1997-08-06	1997-08-06 00:00:00	1997-08-20	1997-08-20 00:00:00	1997-08-20	38000177		0	0	14		0	0	0	198691	0	1043400	40229134		
203376	4465	40213160	1973-07-06	1973-07-06 00:00:00	1973-07-06	1973-07-06 00:00:00	1973-07-06	581452		0	0	0		0	0	0	297060	0	10	40213160		
160578	3533	40213306	1984-02-01	1984-02-01 00:00:00	1984-02-01	1984-02-01 00:00:00	1984-02-01	581452		0	0	0		0	0	0	234689	0	43	40213306		
10560	879	40231925	2009-03-16	2009-03-16 00:00:00	2009-03-16	2009-03-16 00:00:00	\N	38000177		0	0	0		0	0	0	58582	0	1049221	40231925		
124852	2747	40213227	2003-10-12	2003-10-12 00:00:00	2003-10-12	2003-10-12 00:00:00	2003-10-12	581452		0	0	0		0	0	0	181672	0	113	40213227		
174689	3841	40213160	1972-03-08	1972-03-08 00:00:00	1972-03-08	1972-03-08 00:00:00	1972-03-08	581452		0	0	0		0	0	0	254997	0	10	40213160		
26925	2220	1713671	2014-09-06	2014-09-06 00:00:00	2014-09-13	2014-09-13 00:00:00	2014-09-13	38000177		0	0	7		0	0	0	147775	0	562251	1713671		
173062	3804	40213160	1964-11-12	1964-11-12 00:00:00	1964-11-12	1964-11-12 00:00:00	1964-11-12	581452		0	0	0		0	0	0	252874	0	10	40213160		
34587	2858	1115171	1998-01-05	1998-01-05 00:00:00	1998-02-04	1998-02-04 00:00:00	1998-02-04	38000177		0	0	30		0	0	0	189904	0	849574	1115171		
34618	2860	19078461	2001-11-01	2001-11-01 00:00:00	2001-12-01	2001-12-01 00:00:00	2001-12-01	38000177		0	0	30		0	0	0	190130	0	310965	19078461		
117769	2589	40213251	1988-03-01	1988-03-01 00:00:00	1988-03-01	1988-03-01 00:00:00	1988-03-01	581452		0	0	0		0	0	0	171314	0	21	40213251		
231789	5094	40213160	1978-08-07	1978-08-07 00:00:00	1978-08-07	1978-08-07 00:00:00	1978-08-07	581452		0	0	0		0	0	0	338479	0	10	40213160		
15043	1257	1127433	1977-02-20	1977-02-20 00:00:00	1977-02-27	1977-02-27 00:00:00	1977-02-27	38000177		0	0	7		0	0	0	82807	0	313782	1127433		
37678	3115	1127078	1968-04-14	1968-04-14 00:00:00	1968-04-28	1968-04-28 00:00:00	1968-04-28	38000177		0	0	14		0	0	0	207262	0	282464	1127078		
4025	334	40173590	2005-06-15	2005-06-15 00:00:00	2005-06-15	2005-06-15 00:00:00	\N	38000177		0	0	0		0	0	0	22137	0	904419	40173590		
32751	2712	1713671	1974-03-15	1974-03-15 00:00:00	1974-03-22	1974-03-22 00:00:00	1974-03-22	38000177		0	0	7		0	0	0	179874	0	562251	1713671		
19469	1605	40220960	2006-09-17	2006-09-17 00:00:00	2006-09-17	2006-09-17 00:00:00	2006-09-17	38000177		0	0	0		0	0	0	107770	0	1804799	40220960		
49073	4072	40229134	2010-10-28	2010-10-28 00:00:00	2010-11-11	2010-11-11 00:00:00	2010-11-11	38000177		0	0	14		0	0	0	270671	0	1043400	40229134		
42727	931	40213260	2010-09-17	2010-09-17 00:00:00	2010-09-17	2010-09-17 00:00:00	2010-09-17	581452		0	0	0		0	0	0	61977	0	121	40213260		
5955	498	1127078	1977-08-16	1977-08-16 00:00:00	1977-09-20	1977-09-20 00:00:00	1977-09-20	38000177		0	0	35		0	0	0	33246	0	282464	1127078		
48500	4018	19006318	1966-06-25	1966-06-25 00:00:00	1966-07-09	1966-07-09 00:00:00	1966-07-09	38000177		0	0	14		0	0	0	267067	0	105078	19006318		
63675	5291	1127433	1979-10-29	1979-10-29 00:00:00	1979-11-12	1979-11-12 00:00:00	1979-11-12	38000177		0	0	14		0	0	0	352065	0	313782	1127433		
38017	3144	1713671	2003-08-06	2003-08-06 00:00:00	2003-08-20	2003-08-20 00:00:00	2003-08-20	38000177		0	0	14		0	0	0	209225	0	562251	1713671		
46765	1021	40213227	1994-12-22	1994-12-22 00:00:00	1994-12-22	1994-12-22 00:00:00	1994-12-22	581452		0	0	0		0	0	0	67160	0	113	40213227		
143685	3157	40213160	1955-06-10	1955-06-10 00:00:00	1955-06-10	1955-06-10 00:00:00	1955-06-10	581452		0	0	0		0	0	0	209850	0	10	40213160		
118384	2603	40213160	1960-08-31	1960-08-31 00:00:00	1960-08-31	1960-08-31 00:00:00	1960-08-31	581452		0	0	0		0	0	0	172226	0	10	40213160		
30639	2541	1127433	1999-02-23	1999-02-23 00:00:00	1999-03-09	1999-03-09 00:00:00	1999-03-09	38000177		0	0	14		0	0	0	168033	0	313782	1127433		
3786	316	19059056	1929-03-24	1929-03-24 00:00:00	1929-04-28	1929-04-28 00:00:00	1929-04-28	38000177		0	0	35		0	0	0	20887	0	243670	19059056		
52553	4370	1127433	1968-08-30	1968-08-30 00:00:00	1968-09-13	1968-09-13 00:00:00	1968-09-13	38000177		0	0	14		0	0	0	290125	0	313782	1127433		
37828	3125	1127433	2010-07-06	2010-07-06 00:00:00	2010-07-13	2010-07-13 00:00:00	2010-07-13	38000177		0	0	7		0	0	0	207948	0	313782	1127433		
17236	372	40213160	1961-10-21	1961-10-21 00:00:00	1961-10-21	1961-10-21 00:00:00	1961-10-21	581452		0	0	0		0	0	0	24766	0	10	40213160		
48363	4009	1127433	1983-07-13	1983-07-13 00:00:00	1983-07-27	1983-07-27 00:00:00	1983-07-27	38000177		0	0	14		0	0	0	266433	0	313782	1127433		
12496	1053	19078461	2017-03-23	2017-03-23 00:00:00	2017-04-13	2017-04-13 00:00:00	2017-04-13	38000177		0	0	21		0	0	0	69043	0	310965	19078461		
238833	5242	40213227	2013-08-02	2013-08-02 00:00:00	2013-08-02	2013-08-02 00:00:00	2013-08-02	581452		0	0	0		0	0	0	348842	0	113	40213227		
53665	4460	40229134	1989-04-05	1989-04-05 00:00:00	1989-04-12	1989-04-12 00:00:00	1989-04-12	38000177		0	0	7		0	0	0	296812	0	1043400	40229134		
126661	2786	40213227	1994-08-27	1994-08-27 00:00:00	1994-08-27	1994-08-27 00:00:00	1994-08-27	581452		0	0	0		0	0	0	184548	0	113	40213227		
63787	5300	1713671	1984-06-29	1984-06-29 00:00:00	1984-07-06	1984-07-06 00:00:00	1984-07-06	38000177		0	0	7		0	0	0	352641	0	562251	1713671		
15494	1292	1118084	1990-03-23	1990-03-23 00:00:00	1990-03-23	1990-03-23 00:00:00	\N	38000177		0	0	0		0	0	0	85357	0	00025152531	44923712		
18078	1497	19059056	1943-09-26	1943-09-26 00:00:00	1943-10-24	1943-10-24 00:00:00	1943-10-24	38000177		0	0	28		0	0	0	99779	0	243670	19059056		
80067	1751	40213296	2017-11-22	2017-11-22 00:00:00	2017-11-22	2017-11-22 00:00:00	2017-11-22	581452		0	0	0		0	0	0	117075	0	52	40213296		
6144	133	40213160	1985-11-25	1985-11-25 00:00:00	1985-11-25	1985-11-25 00:00:00	1985-11-25	581452		0	0	0		0	0	0	8984	0	10	40213160		
34712	2866	1118084	2005-10-21	2005-10-21 00:00:00	2005-10-21	2005-10-21 00:00:00	\N	38000177		0	0	0		0	0	0	190665	0	00025152531	44923712		
47296	3921	1127078	1982-02-09	1982-02-09 00:00:00	1982-02-23	1982-02-23 00:00:00	1982-02-23	38000177		0	0	14		0	0	0	260722	0	282464	1127078		
30871	2555	19059056	1953-04-02	1953-04-02 00:00:00	1953-04-16	1953-04-16 00:00:00	1953-04-16	38000177		0	0	14		0	0	0	169345	0	243670	19059056		
41391	3432	19078461	1986-09-25	1986-09-25 00:00:00	1986-10-16	1986-10-16 00:00:00	1986-10-16	38000177		0	0	21		0	0	0	227488	0	310965	19078461		
70231	1537	40213160	1956-10-24	1956-10-24 00:00:00	1956-10-24	1956-10-24 00:00:00	1956-10-24	581452		0	0	0		0	0	0	102863	0	10	40213160		
4571	380	40236446	1983-11-09	1983-11-09 00:00:00	1984-03-21	1984-03-21 00:00:00	1984-03-21	38000177		0	0	133		0	0	0	25126	0	1091392	40236446		
49860	4137	1127433	2013-08-05	2013-08-05 00:00:00	2013-08-19	2013-08-19 00:00:00	2013-08-19	38000177		0	0	14		0	0	0	275020	0	313782	1127433		
63387	5265	46233988	1971-02-06	1971-02-06 00:00:00	1971-02-20	1971-02-20 00:00:00	1971-02-20	38000177		0	0	14		0	0	0	350305	0	1652673	46233988		
55091	4574	1713671	2000-03-31	2000-03-31 00:00:00	2000-04-21	2000-04-21 00:00:00	2000-04-21	38000177		0	0	21		0	0	0	304690	0	562251	1713671		
5234	439	1127078	1982-06-26	1982-06-26 00:00:00	1982-07-10	1982-07-10 00:00:00	1982-07-10	38000177		0	0	14		0	0	0	29118	0	282464	1127078		
22720	1867	19019979	1977-01-13	1977-01-13 00:00:00	1977-01-27	1977-01-27 00:00:00	1977-01-27	38000177		0	0	14		0	0	0	124698	0	198405	19019979		
84812	1855	40213160	1980-02-29	1980-02-29 00:00:00	1980-02-29	1980-02-29 00:00:00	1980-02-29	581452		0	0	0		0	0	0	124150	0	10	40213160		
5392	452	1115171	2013-06-07	2013-06-07 00:00:00	2013-08-06	2013-08-06 00:00:00	2013-08-06	38000177		0	0	60		0	0	0	30150	0	849574	1115171		
5452	455	40229134	1985-08-10	1985-08-10 00:00:00	1985-08-17	1985-08-17 00:00:00	1985-08-17	38000177		0	0	7		0	0	0	30399	0	1043400	40229134		
61545	5121	1118084	2000-02-01	2000-02-01 00:00:00	2000-02-01	2000-02-01 00:00:00	\N	38000177		0	0	0		0	0	0	340507	0	00025152531	44923712		
127261	2799	40213314	1980-09-10	1980-09-10 00:00:00	1980-09-10	1980-09-10 00:00:00	1980-09-10	581452		0	0	0		0	0	0	185488	0	49	40213314		
59878	4976	1127433	1956-11-20	1956-11-20 00:00:00	1956-12-04	1956-12-04 00:00:00	1956-12-04	38000177		0	0	14		0	0	0	330969	0	313782	1127433		
18890	1560	19078461	2017-01-29	2017-01-29 00:00:00	2017-04-29	2017-04-29 00:00:00	2017-04-29	38000177		0	0	90		0	0	0	104435	0	310965	19078461		
25408	2088	19059056	1912-11-14	1912-11-14 00:00:00	1912-11-28	1912-11-28 00:00:00	1912-11-28	38000177		0	0	14		0	0	0	139205	0	243670	19059056		
54542	4531	1124300	1950-03-13	1950-03-13 00:00:00	1950-03-13	1950-03-13 00:00:00	\N	38000177		0	0	0		0	0	0	301765	0	00781178901	45011828		
54916	4561	1118084	1984-06-22	1984-06-22 00:00:00	1984-06-22	1984-06-22 00:00:00	\N	38000177		0	0	0		0	0	0	303891	0	00025152531	44923712		
40724	887	40213227	2019-03-02	2019-03-02 00:00:00	2019-03-02	2019-03-02 00:00:00	2019-03-02	581452		0	0	0		0	0	0	59100	0	113	40213227		
2761	222	1127433	2014-07-18	2014-07-18 00:00:00	2014-08-01	2014-08-01 00:00:00	2014-08-01	38000177		0	0	14		0	0	0	14935	0	313782	1127433		
36102	2975	1118084	1997-09-16	1997-09-16 00:00:00	1997-09-16	1997-09-16 00:00:00	\N	38000177		0	0	0		0	0	0	198691	0	00025152531	44923712		
203386	4465	40213160	1978-01-06	1978-01-06 00:00:00	1978-01-06	1978-01-06 00:00:00	1978-01-06	581452		0	0	0		0	0	0	297064	0	10	40213160		
139739	3070	40213160	1967-01-01	1967-01-01 00:00:00	1967-01-01	1967-01-01 00:00:00	1967-01-01	581452		0	0	0		0	0	0	204365	0	10	40213160		
10561	879	19073188	2009-03-16	2009-03-16 00:00:00	2009-04-06	2009-04-06 00:00:00	2009-04-06	38000177		0	0	21		0	0	0	58582	0	308192	19073188		
124857	2747	40213296	2012-06-17	2012-06-17 00:00:00	2012-06-17	2012-06-17 00:00:00	2012-06-17	581452		0	0	0		0	0	0	181703	0	52	40213296		
174697	3841	40213227	1993-12-01	1993-12-01 00:00:00	1993-12-01	1993-12-01 00:00:00	1993-12-01	581452		0	0	0		0	0	0	255013	0	113	40213227		
26926	2220	40229134	1980-08-24	1980-08-24 00:00:00	1980-08-31	1980-08-31 00:00:00	1980-08-31	38000177		0	0	7		0	0	0	147770	0	1043400	40229134		
173068	3804	40213260	2010-07-08	2010-07-08 00:00:00	2010-07-08	2010-07-08 00:00:00	2010-07-08	581452		0	0	0		0	0	0	252889	0	121	40213260		
34588	2858	19059056	1911-06-15	1911-06-15 00:00:00	1911-06-29	1911-06-29 00:00:00	1911-06-29	38000177		0	0	14		0	0	0	189840	0	243670	19059056		
34619	2860	40162522	2001-11-01	2001-11-01 00:00:00	2001-11-01	2001-11-01 00:00:00	\N	38000177		0	0	0		0	0	0	190130	0	857005	40162522		
117772	2589	40213160	1988-03-01	1988-03-01 00:00:00	1988-03-01	1988-03-01 00:00:00	1988-03-01	581452		0	0	0		0	0	0	171314	0	10	40213160		
231801	5094	40213227	2009-07-13	2009-07-13 00:00:00	2009-07-13	2009-07-13 00:00:00	2009-07-13	581452		0	0	0		0	0	0	338490	0	113	40213227		
15044	1257	1127433	1973-12-24	1973-12-24 00:00:00	1974-01-07	1974-01-07 00:00:00	1974-01-07	38000177		0	0	14		0	0	0	82803	0	313782	1127433		
37680	3115	40229134	2008-03-12	2008-03-12 00:00:00	2008-03-26	2008-03-26 00:00:00	2008-03-26	38000177		0	0	14		0	0	0	207227	0	1043400	40229134		
4026	334	19133873	1940-02-13	1940-02-13 00:00:00	1940-02-25	1940-02-25 00:00:00	1940-02-25	38000177		0	0	12		0	0	0	22141	0	834061	19133873		
32752	2712	1127433	1978-11-13	1978-11-13 00:00:00	1978-11-20	1978-11-20 00:00:00	1978-11-20	38000177		0	0	7		0	0	0	179814	0	313782	1127433		
19470	1605	1127433	1992-01-16	1992-01-16 00:00:00	1992-02-13	1992-02-13 00:00:00	1992-02-13	38000177		0	0	28		0	0	0	107749	0	313782	1127433		
49074	4072	1115171	2010-01-18	2010-01-18 00:00:00	2010-02-01	2010-02-01 00:00:00	2010-02-01	38000177		0	0	14		0	0	0	270685	0	849574	1115171		
42729	932	40213227	2000-05-08	2000-05-08 00:00:00	2000-05-08	2000-05-08 00:00:00	2000-05-08	581452		0	0	0		0	0	0	62037	0	113	40213227		
5956	498	1127078	1974-08-02	1974-08-02 00:00:00	1974-08-16	1974-08-16 00:00:00	1974-08-16	38000177		0	0	14		0	0	0	33293	0	282464	1127078		
48501	4018	1127433	2005-07-12	2005-07-12 00:00:00	2005-07-26	2005-07-26 00:00:00	2005-07-26	38000177		0	0	14		0	0	0	267060	0	313782	1127433		
63676	5291	40229134	2002-01-02	2002-01-02 00:00:00	2002-01-16	2002-01-16 00:00:00	2002-01-16	38000177		0	0	14		0	0	0	352055	0	1043400	40229134		
38018	3144	19133873	1964-01-28	1964-01-28 00:00:00	1964-02-07	1964-02-07 00:00:00	1964-02-07	38000177		0	0	10		0	0	0	209179	0	834061	19133873		
46776	1022	40213227	1996-02-06	1996-02-06 00:00:00	1996-02-06	1996-02-06 00:00:00	1996-02-06	581452		0	0	0		0	0	0	67241	0	113	40213227		
143697	3158	40213227	2001-03-22	2001-03-22 00:00:00	2001-03-22	2001-03-22 00:00:00	2001-03-22	581452		0	0	0		0	0	0	210003	0	113	40213227		
118387	2603	40213306	1982-07-21	1982-07-21 00:00:00	1982-07-21	1982-07-21 00:00:00	1982-07-21	581452		0	0	0		0	0	0	172204	0	43	40213306		
30640	2541	1127433	1994-04-11	1994-04-11 00:00:00	1994-04-18	1994-04-18 00:00:00	1994-04-18	38000177		0	0	7		0	0	0	168053	0	313782	1127433		
3787	316	19075601	1997-11-25	1997-11-25 00:00:00	1997-11-25	1997-11-25 00:00:00	\N	38000177		0	0	0		0	0	0	20942	0	309362	19075601		
52554	4370	1118084	1999-03-24	1999-03-24 00:00:00	1999-03-24	1999-03-24 00:00:00	\N	38000177		0	0	0		0	0	0	290137	0	00025152531	44923712		
37829	3125	1127433	1972-04-19	1972-04-19 00:00:00	1972-04-26	1972-04-26 00:00:00	1972-04-26	38000177		0	0	7		0	0	0	207946	0	313782	1127433		
17242	372	40213160	1962-01-20	1962-01-20 00:00:00	1962-01-20	1962-01-20 00:00:00	1962-01-20	581452		0	0	0		0	0	0	24733	0	10	40213160		
48364	4009	1713671	1987-06-13	1987-06-13 00:00:00	1987-07-04	1987-07-04 00:00:00	1987-07-04	38000177		0	0	21		0	0	0	266380	0	562251	1713671		
12497	1053	1127433	2004-09-23	2004-09-23 00:00:00	2004-10-07	2004-10-07 00:00:00	2004-10-07	38000177		0	0	14		0	0	0	69007	0	313782	1127433		
238839	5242	40213160	1967-07-07	1967-07-07 00:00:00	1967-07-07	1967-07-07 00:00:00	1967-07-07	581452		0	0	0		0	0	0	348836	0	10	40213160		
53666	4460	1115171	2012-04-02	2012-04-02 00:00:00	2012-06-01	2012-06-01 00:00:00	2012-06-01	38000177		0	0	60		0	0	0	296797	0	849574	1115171		
126664	2786	40213227	2004-12-11	2004-12-11 00:00:00	2004-12-11	2004-12-11 00:00:00	2004-12-11	581452		0	0	0		0	0	0	184551	0	113	40213227		
63788	5300	1127433	1959-05-24	1959-05-24 00:00:00	1959-06-07	1959-06-07 00:00:00	1959-06-07	38000177		0	0	14		0	0	0	352633	0	313782	1127433		
15495	1292	19078461	1986-02-26	1986-02-26 00:00:00	1986-03-26	1986-03-26 00:00:00	1986-03-26	38000177		0	0	28		0	0	0	85415	0	310965	19078461		
18079	1497	1127433	1975-11-05	1975-11-05 00:00:00	1975-12-05	1975-12-05 00:00:00	1975-12-05	38000177		0	0	30		0	0	0	99780	0	313782	1127433		
217697	4777	40213160	1958-08-19	1958-08-19 00:00:00	1958-08-19	1958-08-19 00:00:00	1958-08-19	581452		0	0	0		0	0	0	318086	0	10	40213160		
6145	133	40213251	1985-11-25	1985-11-25 00:00:00	1985-11-25	1985-11-25 00:00:00	1985-11-25	581452		0	0	0		0	0	0	8984	0	21	40213251		
34713	2866	1127078	1969-08-05	1969-08-05 00:00:00	1969-08-19	1969-08-19 00:00:00	1969-08-19	38000177		0	0	14		0	0	0	190666	0	282464	1127078		
47297	3921	19073183	1982-02-09	1982-02-09 00:00:00	1982-02-23	1982-02-23 00:00:00	1982-02-23	38000177		0	0	14		0	0	0	260722	0	308182	19073183		
30872	2555	19006318	1953-04-02	1953-04-02 00:00:00	1953-04-16	1953-04-16 00:00:00	1953-04-16	38000177		0	0	14		0	0	0	169345	0	105078	19006318		
41392	3432	19006318	1957-04-04	1957-04-04 00:00:00	1957-04-18	1957-04-18 00:00:00	1957-04-18	38000177		0	0	14		0	0	0	227502	0	105078	19006318		
70236	1537	40213160	1956-08-22	1956-08-22 00:00:00	1956-08-22	1956-08-22 00:00:00	1956-08-22	581452		0	0	0		0	0	0	102888	0	10	40213160		
4572	380	40229134	2009-08-25	2009-08-25 00:00:00	2009-09-08	2009-09-08 00:00:00	2009-09-08	38000177		0	0	14		0	0	0	25153	0	1043400	40229134		
49861	4137	1127433	2004-04-01	2004-04-01 00:00:00	2004-04-15	2004-04-15 00:00:00	2004-04-15	38000177		0	0	14		0	0	0	274984	0	313782	1127433		
63388	5265	1118084	2003-03-05	2003-03-05 00:00:00	2003-03-05	2003-03-05 00:00:00	\N	38000177		0	0	0		0	0	0	350309	0	00025152531	44923712		
55092	4574	19133873	1958-12-02	1958-12-02 00:00:00	1958-12-14	1958-12-14 00:00:00	1958-12-14	38000177		0	0	12		0	0	0	304738	0	834061	19133873		
5235	439	19073183	1982-06-26	1982-06-26 00:00:00	1982-07-10	1982-07-10 00:00:00	1982-07-10	38000177		0	0	14		0	0	0	29118	0	308182	19073183		
22721	1867	19129655	1977-01-13	1977-01-13 00:00:00	1977-01-27	1977-01-27 00:00:00	1977-01-27	38000177		0	0	14		0	0	0	124698	0	789980	19129655		
84817	1855	40213314	1977-02-25	1977-02-25 00:00:00	1977-02-25	1977-02-25 00:00:00	1977-02-25	581452		0	0	0		0	0	0	124148	0	49	40213314		
5393	452	1127433	2008-12-14	2008-12-14 00:00:00	2008-12-21	2008-12-21 00:00:00	2008-12-21	38000177		0	0	7		0	0	0	30106	0	313782	1127433		
5453	455	1127433	2007-11-27	2007-11-27 00:00:00	2007-12-11	2007-12-11 00:00:00	2007-12-11	38000177		0	0	14		0	0	0	30381	0	313782	1127433		
61546	5121	1127433	1988-10-12	1988-10-12 00:00:00	1988-10-26	1988-10-26 00:00:00	1988-10-26	38000177		0	0	14		0	0	0	340455	0	313782	1127433		
127267	2799	40213314	1981-06-10	1981-06-10 00:00:00	1981-06-10	1981-06-10 00:00:00	1981-06-10	581452		0	0	0		0	0	0	185489	0	49	40213314		
59879	4977	19078461	1980-06-01	1980-06-01 00:00:00	1980-07-06	1980-07-06 00:00:00	1980-07-06	38000177		0	0	35		0	0	0	331109	0	310965	19078461		
18891	1560	1127433	1997-12-12	1997-12-12 00:00:00	1997-12-26	1997-12-26 00:00:00	1997-12-26	38000177		0	0	14		0	0	0	104443	0	313782	1127433		
25409	2088	1127433	1909-09-18	1909-09-18 00:00:00	1909-10-02	1909-10-02 00:00:00	1909-10-02	38000177		0	0	14		0	0	0	139225	0	313782	1127433		
54543	4531	19133768	2017-04-29	2017-04-29 00:00:00	2017-04-29	2017-04-29 00:00:00	2017-04-29	38000177		0	0	0		0	0	0	301711	0	833036	19133768		
54917	4561	1713671	1958-07-19	1958-07-19 00:00:00	1958-07-26	1958-07-26 00:00:00	1958-07-26	38000177		0	0	7		0	0	0	303909	0	562251	1713671		
40725	887	40213296	2001-05-19	2001-05-19 00:00:00	2001-05-19	2001-05-19 00:00:00	2001-05-19	581452		0	0	0		0	0	0	59134	0	52	40213296		
2762	222	19059056	1954-11-16	1954-11-16 00:00:00	1954-11-30	1954-11-30 00:00:00	1954-11-30	38000177		0	0	14		0	0	0	14939	0	243670	19059056		
36103	2975	1127433	2000-01-19	2000-01-19 00:00:00	2000-02-16	2000-02-16 00:00:00	2000-02-16	38000177		0	0	28		0	0	0	198692	0	313782	1127433		
203393	4465	40213227	1995-03-31	1995-03-31 00:00:00	1995-03-31	1995-03-31 00:00:00	1995-03-31	581452		0	0	0		0	0	0	297053	0	113	40213227		
139746	3070	40213227	2008-10-05	2008-10-05 00:00:00	2008-10-05	2008-10-05 00:00:00	2008-10-05	581452		0	0	0		0	0	0	204379	0	113	40213227		
10562	879	1115171	2009-03-16	2009-03-16 00:00:00	2009-04-06	2009-04-06 00:00:00	2009-04-06	38000177		0	0	21		0	0	0	58582	0	849574	1115171		
124864	2747	40213306	1994-10-02	1994-10-02 00:00:00	1994-10-02	1994-10-02 00:00:00	1994-10-02	581452		0	0	0		0	0	0	181669	0	43	40213306		
174698	3841	40213306	1993-12-01	1993-12-01 00:00:00	1993-12-01	1993-12-01 00:00:00	1993-12-01	581452		0	0	0		0	0	0	255013	0	43	40213306		
26927	2220	40229134	2007-01-31	2007-01-31 00:00:00	2007-02-07	2007-02-07 00:00:00	2007-02-07	38000177		0	0	7		0	0	0	147855	0	1043400	40229134		
184373	4051	40213306	1995-12-06	1995-12-06 00:00:00	1995-12-06	1995-12-06 00:00:00	1995-12-06	581452		0	0	0		0	0	0	269280	0	43	40213306		
184382	4052	40213227	2018-04-26	2018-04-26 00:00:00	2018-04-26	2018-04-26 00:00:00	2018-04-26	581452		0	0	0		0	0	0	269368	0	113	40213227		
34620	2860	1118084	1982-05-25	1982-05-25 00:00:00	1982-05-25	1982-05-25 00:00:00	\N	38000177		0	0	0		0	0	0	190116	0	00025152531	44923712		
117775	2589	40213227	2014-11-11	2014-11-11 00:00:00	2014-11-11	2014-11-11 00:00:00	2014-11-11	581452		0	0	0		0	0	0	171328	0	113	40213227		
118142	2598	40213306	1995-12-26	1995-12-26 00:00:00	1995-12-26	1995-12-26 00:00:00	1995-12-26	581452		0	0	0		0	0	0	171920	0	43	40213306		
15045	1257	1713671	1977-09-09	1977-09-09 00:00:00	1977-09-16	1977-09-16 00:00:00	1977-09-16	38000177		0	0	7		0	0	0	82844	0	562251	1713671		
37681	3115	1127433	1968-09-12	1968-09-12 00:00:00	1968-09-19	1968-09-19 00:00:00	1968-09-19	38000177		0	0	7		0	0	0	207208	0	313782	1127433		
4027	334	40231925	2006-08-29	2006-08-29 00:00:00	2006-08-29	2006-08-29 00:00:00	\N	38000177		0	0	0		0	0	0	22116	0	1049221	40231925		
32753	2712	19059056	1964-05-29	1964-05-29 00:00:00	1964-06-12	1964-06-12 00:00:00	1964-06-12	38000177		0	0	14		0	0	0	179816	0	243670	19059056		
19471	1605	1713671	2018-08-03	2018-08-03 00:00:00	2018-08-24	2018-08-24 00:00:00	2018-08-24	38000177		0	0	21		0	0	0	107675	0	562251	1713671		
49075	4072	19073188	2010-01-18	2010-01-18 00:00:00	2010-02-01	2010-02-01 00:00:00	2010-02-01	38000177		0	0	14		0	0	0	270685	0	308192	19073188		
42730	932	40213160	1974-02-04	1974-02-04 00:00:00	1974-02-04	1974-02-04 00:00:00	1974-02-04	581452		0	0	0		0	0	0	62010	0	10	40213160		
5957	498	46233988	1974-08-02	1974-08-02 00:00:00	1974-08-16	1974-08-16 00:00:00	1974-08-16	38000177		0	0	14		0	0	0	33293	0	1652673	46233988		
48502	4018	1127433	1990-05-04	1990-05-04 00:00:00	1990-05-11	1990-05-11 00:00:00	1990-05-11	38000177		0	0	7		0	0	0	267054	0	313782	1127433		
63677	5291	19128022	1992-09-29	1992-09-29 00:00:00	1993-09-24	1993-09-24 00:00:00	1993-09-24	38000177		0	0	360		0	0	0	352072	0	749785	19128022		
38019	3144	1118084	2007-05-03	2007-05-03 00:00:00	2007-05-03	2007-05-03 00:00:00	\N	38000177		0	0	0		0	0	0	209237	0	00025152531	44923712		
46780	1022	40213160	1964-07-07	1964-07-07 00:00:00	1964-07-07	1964-07-07 00:00:00	1964-07-07	581452		0	0	0		0	0	0	67243	0	10	40213160		
28156	613	40213227	1997-01-17	1997-01-17 00:00:00	1997-01-17	1997-01-17 00:00:00	1997-01-17	581452		0	0	0		0	0	0	40780	0	113	40213227		
168242	3698	40213198	2016-09-06	2016-09-06 00:00:00	2016-09-06	2016-09-06 00:00:00	2016-09-06	581452		0	0	0		0	0	0	245846	0	133	40213198		
30641	2541	19128065	1989-09-25	1989-09-25 00:00:00	1990-09-20	1990-09-20 00:00:00	1990-09-20	38000177		0	0	360		0	0	0	168055	0	749882	19128065		
3788	316	1127433	1937-10-24	1937-10-24 00:00:00	1937-11-07	1937-11-07 00:00:00	1937-11-07	38000177		0	0	14		0	0	0	20861	0	313782	1127433		
52555	4370	1127433	1969-06-27	1969-06-27 00:00:00	1969-07-11	1969-07-11 00:00:00	1969-07-11	38000177		0	0	14		0	0	0	290121	0	313782	1127433		
37830	3125	1713671	2017-07-27	2017-07-27 00:00:00	2017-08-17	2017-08-17 00:00:00	2017-08-17	38000177		0	0	21		0	0	0	207986	0	562251	1713671		
17245	372	40213160	1966-04-23	1966-04-23 00:00:00	1966-04-23	1966-04-23 00:00:00	1966-04-23	581452		0	0	0		0	0	0	24776	0	10	40213160		
48365	4010	19128065	1999-03-21	1999-03-21 00:00:00	2000-03-15	2000-03-15 00:00:00	2000-03-15	38000177		0	0	360		0	0	0	266476	0	749882	19128065		
12498	1053	1127433	2001-11-12	2001-11-12 00:00:00	2002-02-10	2002-02-10 00:00:00	2002-02-10	38000177		0	0	90		0	0	0	69042	0	313782	1127433		
146284	3217	40213160	1983-10-11	1983-10-11 00:00:00	1983-10-11	1983-10-11 00:00:00	1983-10-11	581452		0	0	0		0	0	0	213782	0	10	40213160		
131616	2892	40213160	1973-03-09	1973-03-09 00:00:00	1973-03-09	1973-03-09 00:00:00	1973-03-09	581452		0	0	0		0	0	0	192433	0	10	40213160		
117159	2574	40213160	1961-06-14	1961-06-14 00:00:00	1961-06-14	1961-06-14 00:00:00	1961-06-14	581452		0	0	0		0	0	0	170486	0	10	40213160		
63789	5300	1367571	1945-02-13	1945-02-13 00:00:00	1945-02-13	1945-02-13 00:00:00	1945-02-13	38000177		0	0	0		0	0	0	352654	0	314659	19080464		
15496	1292	19059056	1953-05-31	1953-05-31 00:00:00	1953-06-14	1953-06-14 00:00:00	1953-06-14	38000177		0	0	14		0	0	0	85437	0	243670	19059056		
18080	1497	1127433	1992-03-11	1992-03-11 00:00:00	1992-03-18	1992-03-18 00:00:00	1992-03-18	38000177		0	0	7		0	0	0	99800	0	313782	1127433		
217698	4777	40213160	1959-01-20	1959-01-20 00:00:00	1959-01-20	1959-01-20 00:00:00	1959-01-20	581452		0	0	0		0	0	0	318061	0	10	40213160		
6148	133	40213314	1981-05-25	1981-05-25 00:00:00	1981-05-25	1981-05-25 00:00:00	1981-05-25	581452		0	0	0		0	0	0	8980	0	49	40213314		
34714	2866	19059056	1967-09-01	1967-09-01 00:00:00	1967-09-15	1967-09-15 00:00:00	1967-09-15	38000177		0	0	14		0	0	0	190655	0	243670	19059056		
47298	3921	19127904	2003-09-27	2003-09-27 00:00:00	2004-09-21	2004-09-21 00:00:00	2004-09-21	38000177		0	0	360		0	0	0	260734	0	748856	19127904		
30873	2556	40229134	1982-07-01	1982-07-01 00:00:00	1982-07-15	1982-07-15 00:00:00	1982-07-15	38000177		0	0	14		0	0	0	169394	0	1043400	40229134		
41393	3432	19059056	1957-04-04	1957-04-04 00:00:00	1957-04-18	1957-04-18 00:00:00	1957-04-18	38000177		0	0	14		0	0	0	227502	0	243670	19059056		
70240	1537	40213227	2018-02-28	2018-02-28 00:00:00	2018-02-28	2018-02-28 00:00:00	2018-02-28	581452		0	0	0		0	0	0	102852	0	113	40213227		
4573	380	46233988	1973-03-14	1973-03-14 00:00:00	1973-03-28	1973-03-28 00:00:00	1973-03-28	38000177		0	0	14		0	0	0	25129	0	1652673	46233988		
49862	4137	1127433	1999-04-06	1999-04-06 00:00:00	1999-05-04	1999-05-04 00:00:00	1999-05-04	38000177		0	0	28		0	0	0	275051	0	313782	1127433		
63389	5265	1713671	2008-04-14	2008-04-14 00:00:00	2008-05-05	2008-05-05 00:00:00	2008-05-05	38000177		0	0	21		0	0	0	350304	0	562251	1713671		
55095	4574	19133905	1982-09-21	1982-09-21 00:00:00	1982-10-02	1982-10-02 00:00:00	1982-10-02	38000177		0	0	11		0	0	0	304727	0	834102	19133905		
5236	439	19133873	1981-07-07	1981-07-07 00:00:00	1981-07-19	1981-07-19 00:00:00	1981-07-19	38000177		0	0	12		0	0	0	29163	0	834061	19133873		
22722	1867	19133873	1972-11-20	1972-11-20 00:00:00	1972-12-03	1972-12-03 00:00:00	1972-12-03	38000177		0	0	13		0	0	0	124695	0	834061	19133873		
84820	1855	40213227	2009-02-20	2009-02-20 00:00:00	2009-02-20	2009-02-20 00:00:00	2009-02-20	581452		0	0	0		0	0	0	124206	0	113	40213227		
5394	452	1127433	1976-03-28	1976-03-28 00:00:00	1976-04-04	1976-04-04 00:00:00	1976-04-04	38000177		0	0	7		0	0	0	30136	0	313782	1127433		
5454	455	1127433	1966-04-30	1966-04-30 00:00:00	1966-05-14	1966-05-14 00:00:00	1966-05-14	38000177		0	0	14		0	0	0	30456	0	313782	1127433		
61561	5123	40229134	1985-03-28	1985-03-28 00:00:00	1985-04-04	1985-04-04 00:00:00	1985-04-04	38000177		0	0	7		0	0	0	340636	0	1043400	40229134		
127269	2799	40213160	1980-12-10	1980-12-10 00:00:00	1980-12-10	1980-12-10 00:00:00	1980-12-10	581452		0	0	0		0	0	0	185481	0	10	40213160		
59880	4977	1127433	1963-02-01	1963-02-01 00:00:00	1963-02-15	1963-02-15 00:00:00	1963-02-15	38000177		0	0	14		0	0	0	331184	0	313782	1127433		
18892	1560	1127433	1946-07-16	1946-07-16 00:00:00	1946-07-23	1946-07-23 00:00:00	1946-07-23	38000177		0	0	7		0	0	0	104439	0	313782	1127433		
25410	2088	1713671	1914-01-20	1914-01-20 00:00:00	1914-01-27	1914-01-27 00:00:00	1914-01-27	38000177		0	0	7		0	0	0	139223	0	562251	1713671		
54544	4531	1545959	2017-04-29	2017-04-29 00:00:00	2017-04-29	2017-04-29 00:00:00	2017-04-29	38000177		0	0	0		0	0	0	301711	0	259255	1545959		
54918	4561	40231925	1988-08-20	1988-08-20 00:00:00	1988-08-20	1988-08-20 00:00:00	\N	38000177		0	0	0		0	0	0	303948	0	1049221	40231925		
40727	887	40213160	1958-04-19	1958-04-19 00:00:00	1958-04-19	1958-04-19 00:00:00	1958-04-19	581452		0	0	0		0	0	0	59113	0	10	40213160		
2763	222	19006318	1954-11-16	1954-11-16 00:00:00	1954-11-30	1954-11-30 00:00:00	1954-11-30	38000177		0	0	14		0	0	0	14939	0	105078	19006318		
36104	2975	1127433	2017-09-23	2017-09-23 00:00:00	2017-10-07	2017-10-07 00:00:00	2017-10-07	38000177		0	0	14		0	0	0	198583	0	313782	1127433		
203394	4465	40213306	1995-03-31	1995-03-31 00:00:00	1995-03-31	1995-03-31 00:00:00	1995-03-31	581452		0	0	0		0	0	0	297053	0	43	40213306		
139747	3070	40213296	2008-10-05	2008-10-05 00:00:00	2008-10-05	2008-10-05 00:00:00	2008-10-05	581452		0	0	0		0	0	0	204379	0	52	40213296		
4981	412	1127078	1961-04-17	1961-04-17 00:00:00	1961-05-22	1961-05-22 00:00:00	1961-05-22	38000177		0	0	35		0	0	0	27408	0	282464	1127078		
124866	2747	40213227	1994-10-02	1994-10-02 00:00:00	1994-10-02	1994-10-02 00:00:00	1994-10-02	581452		0	0	0		0	0	0	181669	0	113	40213227		
174704	3841	40213227	2005-09-07	2005-09-07 00:00:00	2005-09-07	2005-09-07 00:00:00	2005-09-07	581452		0	0	0		0	0	0	255051	0	113	40213227		
26928	2220	40229134	1966-12-15	1966-12-15 00:00:00	1966-12-22	1966-12-22 00:00:00	1966-12-22	38000177		0	0	7		0	0	0	147851	0	1043400	40229134		
184374	4051	40213227	2016-01-27	2016-01-27 00:00:00	2016-01-27	2016-01-27 00:00:00	2016-01-27	581452		0	0	0		0	0	0	269292	0	113	40213227		
184388	4052	40213160	1981-03-26	1981-03-26 00:00:00	1981-03-26	1981-03-26 00:00:00	1981-03-26	581452		0	0	0		0	0	0	269363	0	10	40213160		
34621	2860	1713671	2014-01-20	2014-01-20 00:00:00	2014-01-27	2014-01-27 00:00:00	2014-01-27	38000177		0	0	7		0	0	0	190159	0	562251	1713671		
117778	2589	40213160	1983-11-29	1983-11-29 00:00:00	1983-11-29	1983-11-29 00:00:00	1983-11-29	581452		0	0	0		0	0	0	171351	0	10	40213160		
118144	2598	40213227	1995-12-26	1995-12-26 00:00:00	1995-12-26	1995-12-26 00:00:00	1995-12-26	581452		0	0	0		0	0	0	171920	0	113	40213227		
15046	1257	19075601	2016-11-12	2016-11-12 00:00:00	2016-11-12	2016-11-12 00:00:00	\N	38000177		0	0	0		0	0	0	82829	0	309362	19075601		
37682	3115	1127433	2009-09-09	2009-09-09 00:00:00	2009-09-30	2009-09-30 00:00:00	2009-09-30	38000177		0	0	21		0	0	0	207281	0	313782	1127433		
4028	334	19078461	2006-08-29	2006-08-29 00:00:00	2006-09-28	2006-09-28 00:00:00	2006-09-28	38000177		0	0	30		0	0	0	22116	0	310965	19078461		
32754	2712	19129655	1964-05-29	1964-05-29 00:00:00	1964-06-12	1964-06-12 00:00:00	1964-06-12	38000177		0	0	14		0	0	0	179816	0	789980	19129655		
19472	1605	19074841	1999-12-03	1999-12-03 00:00:00	1999-12-31	1999-12-31 00:00:00	1999-12-31	38000177		0	0	28		0	0	0	107750	0	309043	19074841		
49076	4072	19059056	1977-10-21	1977-10-21 00:00:00	1977-12-20	1977-12-20 00:00:00	1977-12-20	38000177		0	0	60		0	0	0	270687	0	243670	19059056		
42734	932	40213306	1991-04-29	1991-04-29 00:00:00	1991-04-29	1991-04-29 00:00:00	1991-04-29	581452		0	0	0		0	0	0	62034	0	43	40213306		
5958	498	1127433	1988-02-06	1988-02-06 00:00:00	1988-02-13	1988-02-13 00:00:00	1988-02-13	38000177		0	0	7		0	0	0	33271	0	313782	1127433		
48503	4018	1127433	1967-08-08	1967-08-08 00:00:00	1967-08-15	1967-08-15 00:00:00	1967-08-15	38000177		0	0	7		0	0	0	267103	0	313782	1127433		
63678	5291	19128065	1991-10-05	1991-10-05 00:00:00	1992-09-29	1992-09-29 00:00:00	1992-09-29	38000177		0	0	360		0	0	0	352071	0	749882	19128065		
38021	3144	1127078	1967-11-25	1967-11-25 00:00:00	1967-12-09	1967-12-09 00:00:00	1967-12-09	38000177		0	0	14		0	0	0	209238	0	282464	1127078		
46783	1022	40213160	1969-03-11	1969-03-11 00:00:00	1969-03-11	1969-03-11 00:00:00	1969-03-11	581452		0	0	0		0	0	0	67229	0	10	40213160		
28180	613	40213201	2002-02-15	2002-02-15 00:00:00	2002-02-15	2002-02-15 00:00:00	2002-02-15	581452		0	0	0		0	0	0	40705	0	33	40213201		
168247	3698	40213227	2012-08-14	2012-08-14 00:00:00	2012-08-14	2012-08-14 00:00:00	2012-08-14	581452		0	0	0		0	0	0	245816	0	113	40213227		
30642	2541	1115171	1997-01-27	1997-01-27 00:00:00	1997-02-10	1997-02-10 00:00:00	1997-02-10	38000177		0	0	14		0	0	0	168021	0	849574	1115171		
3789	316	1127433	1956-11-04	1956-11-04 00:00:00	1956-11-18	1956-11-18 00:00:00	1956-11-18	38000177		0	0	14		0	0	0	20955	0	313782	1127433		
52556	4370	40231925	1991-11-22	1991-11-22 00:00:00	1991-11-22	1991-11-22 00:00:00	\N	38000177		0	0	0		0	0	0	290161	0	1049221	40231925		
37831	3125	19059056	1988-11-09	1988-11-09 00:00:00	1988-11-23	1988-11-23 00:00:00	1988-11-23	38000177		0	0	14		0	0	0	208008	0	243670	19059056		
17252	372	40213296	2001-05-19	2001-05-19 00:00:00	2001-05-19	2001-05-19 00:00:00	2001-05-19	581452		0	0	0		0	0	0	24781	0	52	40213296		
48366	4010	19128022	1994-04-16	1994-04-16 00:00:00	1995-04-11	1995-04-11 00:00:00	1995-04-11	38000177		0	0	360		0	0	0	266497	0	749785	19128022		
12500	1053	19133873	1985-03-25	1985-03-25 00:00:00	1985-04-02	1985-04-02 00:00:00	1985-04-02	38000177		0	0	8		0	0	0	69005	0	834061	19133873		
146285	3217	40213314	1983-10-11	1983-10-11 00:00:00	1983-10-11	1983-10-11 00:00:00	1983-10-11	581452		0	0	0		0	0	0	213782	0	49	40213314		
131618	2892	40213227	1995-09-08	1995-09-08 00:00:00	1995-09-08	1995-09-08 00:00:00	1995-09-08	581452		0	0	0		0	0	0	192390	0	113	40213227		
117162	2574	40213260	2012-01-10	2012-01-10 00:00:00	2012-01-10	2012-01-10 00:00:00	2012-01-10	581452		0	0	0		0	0	0	170492	0	121	40213260		
63790	5300	40220386	1945-02-13	1945-02-13 00:00:00	1945-02-13	1945-02-13 00:00:00	1945-02-13	38000177		0	0	0		0	0	0	352654	0	1808217	40220386		
15497	1292	19006318	1953-05-31	1953-05-31 00:00:00	1953-06-14	1953-06-14 00:00:00	1953-06-14	38000177		0	0	14		0	0	0	85437	0	105078	19006318		
18081	1497	1127433	1979-05-21	1979-05-21 00:00:00	1979-06-04	1979-06-04 00:00:00	1979-06-04	38000177		0	0	14		0	0	0	99766	0	313782	1127433		
217702	4777	40213296	2000-11-21	2000-11-21 00:00:00	2000-11-21	2000-11-21 00:00:00	2000-11-21	581452		0	0	0		0	0	0	318119	0	52	40213296		
6149	133	40213160	1981-05-25	1981-05-25 00:00:00	1981-05-25	1981-05-25 00:00:00	1981-05-25	581452		0	0	0		0	0	0	8980	0	10	40213160		
34715	2866	19129655	1967-09-01	1967-09-01 00:00:00	1967-09-15	1967-09-15 00:00:00	1967-09-15	38000177		0	0	14		0	0	0	190655	0	789980	19129655		
47299	3921	1118084	2014-06-26	2014-06-26 00:00:00	2014-06-26	2014-06-26 00:00:00	\N	38000177		0	0	0		0	0	0	260749	0	00025152531	44923712		
30874	2556	1713671	1998-08-06	1998-08-06 00:00:00	1998-08-27	1998-08-27 00:00:00	1998-08-27	38000177		0	0	21		0	0	0	169388	0	562251	1713671		
41394	3432	1127433	1994-12-01	1994-12-01 00:00:00	1994-12-08	1994-12-08 00:00:00	1994-12-08	38000177		0	0	7		0	0	0	227530	0	313782	1127433		
70242	1537	40213227	1998-06-24	1998-06-24 00:00:00	1998-06-24	1998-06-24 00:00:00	1998-06-24	581452		0	0	0		0	0	0	102883	0	113	40213227		
4574	380	1127078	1973-03-14	1973-03-14 00:00:00	1973-03-28	1973-03-28 00:00:00	1973-03-28	38000177		0	0	14		0	0	0	25129	0	282464	1127078		
49863	4137	19059056	1963-01-15	1963-01-15 00:00:00	1963-01-29	1963-01-29 00:00:00	1963-01-29	38000177		0	0	14		0	0	0	274995	0	243670	19059056		
63390	5265	19133873	1973-09-26	1973-09-26 00:00:00	1973-10-07	1973-10-07 00:00:00	1973-10-07	38000177		0	0	11		0	0	0	350274	0	834061	19133873		
55103	4576	1127433	1963-04-02	1963-04-02 00:00:00	1963-04-09	1963-04-09 00:00:00	1963-04-09	38000177		0	0	7		0	0	0	304828	0	313782	1127433		
5237	439	1713671	1990-01-03	1990-01-03 00:00:00	1990-01-17	1990-01-17 00:00:00	1990-01-17	38000177		0	0	14		0	0	0	29165	0	562251	1713671		
22723	1867	46233988	1973-03-19	1973-03-19 00:00:00	1973-04-02	1973-04-02 00:00:00	1973-04-02	38000177		0	0	14		0	0	0	124677	0	1652673	46233988		
84824	1855	40213160	1975-11-28	1975-11-28 00:00:00	1975-11-28	1975-11-28 00:00:00	1975-11-28	581452		0	0	0		0	0	0	124154	0	10	40213160		
5395	452	1127078	1967-08-05	1967-08-05 00:00:00	1967-08-19	1967-08-19 00:00:00	1967-08-19	38000177		0	0	14		0	0	0	30088	0	282464	1127078		
48099	3987	19133873	1965-12-06	1965-12-06 00:00:00	1965-12-17	1965-12-17 00:00:00	1965-12-17	38000177		0	0	11		0	0	0	265039	0	834061	19133873		
61562	5123	19128065	1993-05-24	1993-05-24 00:00:00	1994-05-19	1994-05-19 00:00:00	1994-05-19	38000177		0	0	360		0	0	0	340652	0	749882	19128065		
138562	3044	40213296	2009-01-27	2009-01-27 00:00:00	2009-01-27	2009-01-27 00:00:00	2009-01-27	581452		0	0	0		0	0	0	202602	0	52	40213296		
59881	4977	1127078	1962-03-07	1962-03-07 00:00:00	1962-03-21	1962-03-21 00:00:00	1962-03-21	38000177		0	0	14		0	0	0	331116	0	282464	1127078		
176246	3875	40213160	1958-03-01	1958-03-01 00:00:00	1958-03-01	1958-03-01 00:00:00	1958-03-01	581452		0	0	0		0	0	0	257399	0	10	40213160		
25411	2088	19133905	1941-04-17	1941-04-17 00:00:00	1941-04-24	1941-04-24 00:00:00	1941-04-24	38000177		0	0	7		0	0	0	139169	0	834102	19133905		
44115	3652	920300	2011-10-13	2011-10-13 00:00:00	2011-10-20	2011-10-20 00:00:00	2011-10-20	38000177		0	0	7		0	0	0	243123	0	311989	920300		
54919	4561	1127433	1988-08-20	1988-08-20 00:00:00	1988-11-18	1988-11-18 00:00:00	1988-11-18	38000177		0	0	90		0	0	0	303948	0	313782	1127433		
40728	887	40213160	1962-12-22	1962-12-22 00:00:00	1962-12-22	1962-12-22 00:00:00	1962-12-22	581452		0	0	0		0	0	0	59128	0	10	40213160		
2764	222	1127078	1960-04-29	1960-04-29 00:00:00	1960-05-20	1960-05-20 00:00:00	1960-05-20	38000177		0	0	21		0	0	0	14932	0	282464	1127078		
36105	2975	1713671	2016-12-24	2016-12-24 00:00:00	2017-01-14	2017-01-14 00:00:00	2017-01-14	38000177		0	0	21		0	0	0	198582	0	562251	1713671		
203397	4465	40213160	1973-10-05	1973-10-05 00:00:00	1973-10-05	1973-10-05 00:00:00	1973-10-05	581452		0	0	0		0	0	0	297044	0	10	40213160		
139749	3070	40213160	1971-08-22	1971-08-22 00:00:00	1971-08-22	1971-08-22 00:00:00	1971-08-22	581452		0	0	0		0	0	0	204330	0	10	40213160		
4983	412	1127433	1964-06-27	1964-06-27 00:00:00	1964-07-04	1964-07-04 00:00:00	1964-07-04	38000177		0	0	7		0	0	0	27425	0	313782	1127433		
124873	2747	40213160	1977-03-13	1977-03-13 00:00:00	1977-03-13	1977-03-13 00:00:00	1977-03-13	581452		0	0	0		0	0	0	181682	0	10	40213160		
185983	4086	40213296	2012-12-12	2012-12-12 00:00:00	2012-12-12	2012-12-12 00:00:00	2012-12-12	581452		0	0	0		0	0	0	271577	0	52	40213296		
26929	2220	40231925	2005-02-04	2005-02-04 00:00:00	2005-02-04	2005-02-04 00:00:00	\N	38000177		0	0	0		0	0	0	147792	0	1049221	40231925		
184375	4051	40213296	2016-01-27	2016-01-27 00:00:00	2016-01-27	2016-01-27 00:00:00	2016-01-27	581452		0	0	0		0	0	0	269292	0	52	40213296		
184392	4052	40213314	1977-03-24	1977-03-24 00:00:00	1977-03-24	1977-03-24 00:00:00	1977-03-24	581452		0	0	0		0	0	0	269332	0	49	40213314		
34622	2860	19133873	1953-11-14	1953-11-14 00:00:00	1953-11-21	1953-11-21 00:00:00	1953-11-21	38000177		0	0	7		0	0	0	190133	0	834061	19133873		
117782	2589	40213314	1983-08-30	1983-08-30 00:00:00	1983-08-30	1983-08-30 00:00:00	1983-08-30	581452		0	0	0		0	0	0	171340	0	49	40213314		
118147	2598	40213160	1978-12-19	1978-12-19 00:00:00	1978-12-19	1978-12-19 00:00:00	1978-12-19	581452		0	0	0		0	0	0	171917	0	10	40213160		
15047	1257	19126352	2016-11-12	2016-11-12 00:00:00	2016-11-12	2016-11-12 00:00:00	\N	38000177		0	0	0		0	0	0	82829	0	705129	19126352		
48142	3991	1127433	1958-01-29	1958-01-29 00:00:00	1958-03-30	1958-03-30 00:00:00	1958-03-30	38000177		0	0	60		0	0	0	265375	0	313782	1127433		
4029	334	40236824	1964-07-13	1964-07-13 00:00:00	1964-07-20	1964-07-20 00:00:00	1964-07-20	38000177		0	0	7		0	0	0	22142	0	1094107	40236824		
32755	2712	1127433	1980-07-01	1980-07-01 00:00:00	1980-07-08	1980-07-08 00:00:00	1980-07-08	38000177		0	0	7		0	0	0	179826	0	313782	1127433		
19473	1605	40162522	1999-12-03	1999-12-03 00:00:00	1999-12-03	1999-12-03 00:00:00	\N	38000177		0	0	0		0	0	0	107750	0	857005	40162522		
49077	4072	1713671	1998-01-21	1998-01-21 00:00:00	1998-02-11	1998-02-11 00:00:00	1998-02-11	38000177		0	0	21		0	0	0	270695	0	562251	1713671		
42737	932	40213160	1969-08-04	1969-08-04 00:00:00	1969-08-04	1969-08-04 00:00:00	1969-08-04	581452		0	0	0		0	0	0	62008	0	10	40213160		
5959	499	1551192	1972-03-19	1972-03-19 00:00:00	1972-03-19	1972-03-19 00:00:00	1972-03-19	38000177		0	0	0		0	0	0	33417	0	312617	1551192		
48504	4018	1127078	1964-06-23	1964-06-23 00:00:00	1964-07-07	1964-07-07 00:00:00	1964-07-07	38000177		0	0	14		0	0	0	267108	0	282464	1127078		
63679	5291	1127433	1996-08-01	1996-08-01 00:00:00	1996-08-15	1996-08-15 00:00:00	1996-08-15	38000177		0	0	14		0	0	0	352066	0	313782	1127433		
38022	3144	19129655	1967-11-25	1967-11-25 00:00:00	1967-12-09	1967-12-09 00:00:00	1967-12-09	38000177		0	0	14		0	0	0	209238	0	789980	19129655		
46791	1022	40213296	2006-04-11	2006-04-11 00:00:00	2006-04-11	2006-04-11 00:00:00	2006-04-11	581452		0	0	0		0	0	0	67215	0	52	40213296		
28182	613	40213227	2017-06-02	2017-06-02 00:00:00	2017-06-02	2017-06-02 00:00:00	2017-06-02	581452		0	0	0		0	0	0	40722	0	113	40213227		
168253	3698	40213201	2017-09-12	2017-09-12 00:00:00	2017-09-12	2017-09-12 00:00:00	2017-09-12	581452		0	0	0		0	0	0	245837	0	33	40213201		
30643	2542	1713671	2006-07-24	2006-07-24 00:00:00	2006-08-14	2006-08-14 00:00:00	2006-08-14	38000177		0	0	21		0	0	0	168156	0	562251	1713671		
3790	316	1332419	1994-11-08	1994-11-08 00:00:00	1994-11-08	1994-11-08 00:00:00	\N	38000177		0	0	0		0	0	0	20918	0	197361	1332419		
52557	4370	1127433	1991-11-22	1991-11-22 00:00:00	1992-01-21	1992-01-21 00:00:00	1992-01-21	38000177		0	0	60		0	0	0	290161	0	313782	1127433		
155179	3415	40213260	2015-08-08	2015-08-08 00:00:00	2015-08-08	2015-08-08 00:00:00	2015-08-08	581452		0	0	0		0	0	0	226544	0	121	40213260		
17254	372	40213260	2012-05-19	2012-05-19 00:00:00	2012-05-19	2012-05-19 00:00:00	2012-05-19	581452		0	0	0		0	0	0	24730	0	121	40213260		
48367	4010	1127433	1999-11-24	1999-11-24 00:00:00	1999-12-01	1999-12-01 00:00:00	1999-12-01	38000177		0	0	7		0	0	0	266516	0	313782	1127433		
12501	1053	1127433	1978-08-19	1978-08-19 00:00:00	1978-09-02	1978-09-02 00:00:00	1978-09-02	38000177		0	0	14		0	0	0	69044	0	313782	1127433		
146291	3217	40213160	1984-03-13	1984-03-13 00:00:00	1984-03-13	1984-03-13 00:00:00	1984-03-13	581452		0	0	0		0	0	0	213792	0	10	40213160		
131619	2892	40213306	1995-09-08	1995-09-08 00:00:00	1995-09-08	1995-09-08 00:00:00	1995-09-08	581452		0	0	0		0	0	0	192390	0	43	40213306		
117164	2574	40213227	2012-01-10	2012-01-10 00:00:00	2012-01-10	2012-01-10 00:00:00	2012-01-10	581452		0	0	0		0	0	0	170492	0	113	40213227		
63791	5300	46275444	1945-02-13	1945-02-13 00:00:00	1945-02-13	1945-02-13 00:00:00	1945-02-13	38000177		0	0	0		0	0	0	352654	0	1659149	46275444		
15498	1292	40229134	1959-05-31	1959-05-31 00:00:00	1959-06-14	1959-06-14 00:00:00	1959-06-14	38000177		0	0	14		0	0	0	85423	0	1043400	40229134		
18082	1497	19006318	1945-05-07	1945-05-07 00:00:00	1945-05-21	1945-05-21 00:00:00	1945-05-21	38000177		0	0	14		0	0	0	99755	0	105078	19006318		
217704	4777	40213227	2000-11-21	2000-11-21 00:00:00	2000-11-21	2000-11-21 00:00:00	2000-11-21	581452		0	0	0		0	0	0	318119	0	113	40213227		
6155	133	40213227	2013-08-26	2013-08-26 00:00:00	2013-08-26	2013-08-26 00:00:00	2013-08-26	581452		0	0	0		0	0	0	8977	0	113	40213227		
34716	2867	1127433	2003-10-05	2003-10-05 00:00:00	2003-10-19	2003-10-19 00:00:00	2003-10-19	38000177		0	0	14		0	0	0	190704	0	313782	1127433		
47300	3921	1115171	2007-07-19	2007-07-19 00:00:00	2007-08-23	2007-08-23 00:00:00	2007-08-23	38000177		0	0	35		0	0	0	260706	0	849574	1115171		
30875	2556	1127433	1981-09-12	1981-09-12 00:00:00	1981-10-17	1981-10-17 00:00:00	1981-10-17	38000177		0	0	35		0	0	0	169377	0	313782	1127433		
41395	3432	1127433	1951-12-10	1951-12-10 00:00:00	1951-12-17	1951-12-17 00:00:00	1951-12-17	38000177		0	0	7		0	0	0	227561	0	313782	1127433		
70243	1537	40213296	1998-06-24	1998-06-24 00:00:00	1998-06-24	1998-06-24 00:00:00	1998-06-24	581452		0	0	0		0	0	0	102883	0	52	40213296		
4575	380	46233988	1974-02-14	1974-02-14 00:00:00	1974-02-28	1974-02-28 00:00:00	1974-02-28	38000177		0	0	14		0	0	0	25146	0	1652673	46233988		
49864	4137	19006318	1963-01-15	1963-01-15 00:00:00	1963-01-29	1963-01-29 00:00:00	1963-01-29	38000177		0	0	14		0	0	0	274995	0	105078	19006318		
63391	5265	1127433	1990-08-26	1990-08-26 00:00:00	1990-09-09	1990-09-09 00:00:00	1990-09-09	38000177		0	0	14		0	0	0	350313	0	313782	1127433		
55105	4576	1127433	1968-05-13	1968-05-13 00:00:00	1968-05-20	1968-05-20 00:00:00	1968-05-20	38000177		0	0	7		0	0	0	304770	0	313782	1127433		
5238	440	19128065	1987-12-05	1987-12-05 00:00:00	1988-11-29	1988-11-29 00:00:00	1988-11-29	38000177		0	0	360		0	0	0	29193	0	749882	19128065		
22724	1867	1127078	1973-03-19	1973-03-19 00:00:00	1973-04-02	1973-04-02 00:00:00	1973-04-02	38000177		0	0	14		0	0	0	124677	0	282464	1127078		
84830	1855	40213306	1998-11-27	1998-11-27 00:00:00	1998-11-27	1998-11-27 00:00:00	1998-11-27	581452		0	0	0		0	0	0	\N	0	43	40213306		
5396	452	46233988	1967-08-05	1967-08-05 00:00:00	1967-08-19	1967-08-19 00:00:00	1967-08-19	38000177		0	0	14		0	0	0	30088	0	1652673	46233988		
48100	3987	1124300	1997-02-03	1997-02-03 00:00:00	1997-02-03	1997-02-03 00:00:00	\N	38000177		0	0	0		0	0	0	265106	0	00781178901	45011828		
61563	5123	19059056	1984-01-02	1984-01-02 00:00:00	1984-02-06	1984-02-06 00:00:00	1984-02-06	38000177		0	0	35		0	0	0	340685	0	243670	19059056		
138564	3044	40213160	1969-07-01	1969-07-01 00:00:00	1969-07-01	1969-07-01 00:00:00	1969-07-01	581452		0	0	0		0	0	0	202645	0	10	40213160		
59882	4977	19129655	1962-03-07	1962-03-07 00:00:00	1962-03-21	1962-03-21 00:00:00	1962-03-21	38000177		0	0	14		0	0	0	331116	0	789980	19129655		
176250	3875	40213227	1999-09-04	1999-09-04 00:00:00	1999-09-04	1999-09-04 00:00:00	1999-09-04	581452		0	0	0		0	0	0	257373	0	113	40213227		
25412	2088	40229134	1922-03-15	1922-03-15 00:00:00	1922-03-22	1922-03-22 00:00:00	1922-03-22	38000177		0	0	7		0	0	0	139165	0	1043400	40229134		
44116	3652	19059056	1975-10-11	1975-10-11 00:00:00	1975-10-25	1975-10-25 00:00:00	1975-10-25	38000177		0	0	14		0	0	0	243131	0	243670	19059056		
54920	4561	19006318	1952-06-30	1952-06-30 00:00:00	1952-07-14	1952-07-14 00:00:00	1952-07-14	38000177		0	0	14		0	0	0	303923	0	105078	19006318		
70405	1540	40213296	1998-12-21	1998-12-21 00:00:00	1998-12-21	1998-12-21 00:00:00	1998-12-21	581452		0	0	0		0	0	0	103227	0	52	40213296		
2765	222	1713671	1973-07-06	1973-07-06 00:00:00	1973-09-07	1973-09-07 00:00:00	1973-09-07	38000177		0	0	63		0	0	0	14937	0	562251	1713671		
36106	2975	1127433	2008-05-24	2008-05-24 00:00:00	2008-05-31	2008-05-31 00:00:00	2008-05-31	38000177		0	0	7		0	0	0	198580	0	313782	1127433		
203402	4465	40213314	1976-12-31	1976-12-31 00:00:00	1976-12-31	1976-12-31 00:00:00	1976-12-31	581452		0	0	0		0	0	0	297080	0	49	40213314		
139752	3070	40213227	1998-08-16	1998-08-16 00:00:00	1998-08-16	1998-08-16 00:00:00	1998-08-16	581452		0	0	0		0	0	0	204342	0	113	40213227		
4984	412	1127433	1965-06-30	1965-06-30 00:00:00	1965-07-21	1965-07-21 00:00:00	1965-07-21	38000177		0	0	21		0	0	0	27410	0	313782	1127433		
124874	2747	40213314	1977-03-13	1977-03-13 00:00:00	1977-03-13	1977-03-13 00:00:00	1977-03-13	581452		0	0	0		0	0	0	181682	0	49	40213314		
185989	4086	40213227	2004-06-03	2004-06-03 00:00:00	2004-06-03	2004-06-03 00:00:00	2004-06-03	581452		0	0	0		0	0	0	271584	0	113	40213227		
26930	2220	1115171	2005-02-04	2005-02-04 00:00:00	2005-05-05	2005-05-05 00:00:00	2005-05-05	38000177		0	0	90		0	0	0	147792	0	849574	1115171		
184377	4051	40213296	2014-01-22	2014-01-22 00:00:00	2014-01-22	2014-01-22 00:00:00	2014-01-22	581452		0	0	0		0	0	0	269285	0	52	40213296		
184397	4052	40213160	1976-07-22	1976-07-22 00:00:00	1976-07-22	1976-07-22 00:00:00	1976-07-22	581452		0	0	0		0	0	0	269328	0	10	40213160		
34623	2860	19019273	2006-10-01	2006-10-01 00:00:00	2006-10-01	2006-10-01 00:00:00	\N	38000177		0	0	0		0	0	0	190105	0	198014	19019273		
54379	4521	1539411	1991-01-24	1991-01-24 00:00:00	1991-01-24	1991-01-24 00:00:00	\N	38000177		0	0	0		0	0	0	301091	0	312961	1539411		
118160	2598	40213314	1977-06-14	1977-06-14 00:00:00	1977-06-14	1977-06-14 00:00:00	1977-06-14	581452		0	0	0		0	0	0	171916	0	49	40213314		
15048	1257	1332419	2016-11-12	2016-11-12 00:00:00	2016-11-12	2016-11-12 00:00:00	\N	38000177		0	0	0		0	0	0	82829	0	197361	1332419		
48143	3991	1713671	1971-02-02	1971-02-02 00:00:00	1971-03-02	1971-03-02 00:00:00	1971-03-02	38000177		0	0	28		0	0	0	265392	0	562251	1713671		
4030	334	920300	1964-07-13	1964-07-13 00:00:00	1964-07-20	1964-07-20 00:00:00	1964-07-20	38000177		0	0	7		0	0	0	22142	0	311989	920300		
32756	2712	1127433	1998-11-23	1998-11-23 00:00:00	1998-12-30	1998-12-30 00:00:00	1998-12-30	38000177		0	0	37		0	0	0	179884	0	313782	1127433		
19474	1605	19078461	1999-12-03	1999-12-03 00:00:00	1999-12-31	1999-12-31 00:00:00	1999-12-31	38000177		0	0	28		0	0	0	107750	0	310965	19078461		
49078	4072	1118084	2011-11-17	2011-11-17 00:00:00	2011-11-17	2011-11-17 00:00:00	\N	38000177		0	0	0		0	0	0	270672	0	00025152531	44923712		
19557	1609	1127433	1960-11-01	1960-11-01 00:00:00	1960-12-06	1960-12-06 00:00:00	1960-12-06	38000177		0	0	35		0	0	0	108161	0	313782	1127433		
5960	499	1713671	1962-08-27	1962-08-27 00:00:00	1962-09-17	1962-09-17 00:00:00	1962-09-17	38000177		0	0	21		0	0	0	33345	0	562251	1713671		
48505	4018	19129655	1964-06-23	1964-06-23 00:00:00	1964-07-07	1964-07-07 00:00:00	1964-07-07	38000177		0	0	14		0	0	0	267108	0	789980	19129655		
63680	5291	19128022	1989-10-15	1989-10-15 00:00:00	1990-10-10	1990-10-10 00:00:00	1990-10-10	38000177		0	0	360		0	0	0	352070	0	749785	19128022		
38023	3144	1713671	1990-11-03	1990-11-03 00:00:00	1990-11-24	1990-11-24 00:00:00	1990-11-24	38000177		0	0	21		0	0	0	209223	0	562251	1713671		
46793	1022	40213227	2006-04-11	2006-04-11 00:00:00	2006-04-11	2006-04-11 00:00:00	2006-04-11	581452		0	0	0		0	0	0	67215	0	113	40213227		
203907	4476	40213260	2012-04-08	2012-04-08 00:00:00	2012-04-08	2012-04-08 00:00:00	2012-04-08	581452		0	0	0		0	0	0	297779	0	121	40213260		
241512	5301	40213227	1992-12-03	1992-12-03 00:00:00	1992-12-03	1992-12-03 00:00:00	1992-12-03	581452		0	0	0		0	0	0	352701	0	113	40213227		
30644	2542	19078461	1978-05-12	1978-05-12 00:00:00	1978-07-11	1978-07-11 00:00:00	1978-07-11	38000177		0	0	60		0	0	0	168090	0	310965	19078461		
3791	316	1539411	1991-10-22	1991-10-22 00:00:00	1991-10-22	1991-10-22 00:00:00	\N	38000177		0	0	0		0	0	0	20937	0	312961	1539411		
52564	4372	19128065	1995-04-30	1995-04-30 00:00:00	1996-04-24	1996-04-24 00:00:00	1996-04-24	38000177		0	0	360		0	0	0	290232	0	749882	19128065		
155185	3415	40213160	1965-11-13	1965-11-13 00:00:00	1965-11-13	1965-11-13 00:00:00	1965-11-13	581452		0	0	0		0	0	0	226503	0	10	40213160		
17256	372	40213227	2012-05-19	2012-05-19 00:00:00	2012-05-19	2012-05-19 00:00:00	2012-05-19	581452		0	0	0		0	0	0	24730	0	113	40213227		
48368	4010	19074679	1977-08-11	1977-08-11 00:00:00	1978-05-18	1978-05-18 00:00:00	1978-05-18	38000177		0	0	280		0	0	0	266478	0	308971	19074679		
12502	1053	19073183	1981-06-12	1981-06-12 00:00:00	1981-06-26	1981-06-26 00:00:00	1981-06-26	38000177		0	0	14		0	0	0	69011	0	308182	19073183		
146303	3218	40213160	1957-07-07	1957-07-07 00:00:00	1957-07-07	1957-07-07 00:00:00	1957-07-07	581452		0	0	0		0	0	0	213827	0	10	40213160		
131620	2892	40213227	2015-07-24	2015-07-24 00:00:00	2015-07-24	2015-07-24 00:00:00	2015-07-24	581452		0	0	0		0	0	0	192440	0	113	40213227		
117191	2576	40213306	2002-12-19	2002-12-19 00:00:00	2002-12-19	2002-12-19 00:00:00	2002-12-19	581452		0	0	0		0	0	0	\N	0	43	40213306		
63792	5300	19078924	1945-02-13	1945-02-13 00:00:00	1945-02-13	1945-02-13 00:00:00	1945-02-13	38000177		0	0	0		0	0	0	352654	0	311700	19078924		
15499	1292	1127433	1981-06-24	1981-06-24 00:00:00	1981-07-08	1981-07-08 00:00:00	1981-07-08	38000177		0	0	14		0	0	0	85384	0	313782	1127433		
18083	1497	19059056	1945-05-07	1945-05-07 00:00:00	1945-05-21	1945-05-21 00:00:00	1945-05-21	38000177		0	0	14		0	0	0	99755	0	243670	19059056		
217710	4777	40213260	2008-05-13	2008-05-13 00:00:00	2008-05-13	2008-05-13 00:00:00	2008-05-13	581452		0	0	0		0	0	0	318093	0	121	40213260		
6163	133	40213160	1981-08-24	1981-08-24 00:00:00	1981-08-24	1981-08-24 00:00:00	1981-08-24	581452		0	0	0		0	0	0	8963	0	10	40213160		
34717	2867	1118084	2014-12-24	2014-12-24 00:00:00	2014-12-24	2014-12-24 00:00:00	\N	38000177		0	0	0		0	0	0	190705	0	00025152531	44923712		
47301	3921	1127433	2008-02-25	2008-02-25 00:00:00	2008-03-10	2008-03-10 00:00:00	2008-03-10	38000177		0	0	14		0	0	0	260727	0	313782	1127433		
30876	2556	1127433	1991-05-28	1991-05-28 00:00:00	1991-06-11	1991-06-11 00:00:00	1991-06-11	38000177		0	0	14		0	0	0	169378	0	313782	1127433		
41405	3434	1124300	1983-11-05	1983-11-05 00:00:00	1983-11-05	1983-11-05 00:00:00	\N	38000177		0	0	0		0	0	0	227738	0	00781178901	45011828		
70245	1537	40213260	2006-06-14	2006-06-14 00:00:00	2006-06-14	2006-06-14 00:00:00	2006-06-14	581452		0	0	0		0	0	0	102850	0	121	40213260		
4576	380	1127078	1974-02-14	1974-02-14 00:00:00	1974-02-28	1974-02-28 00:00:00	1974-02-28	38000177		0	0	14		0	0	0	25146	0	282464	1127078		
49865	4137	1115171	2013-02-17	2013-02-17 00:00:00	2013-03-17	2013-03-17 00:00:00	2013-03-17	38000177		0	0	28		0	0	0	275054	0	849574	1115171		
63392	5265	1310034	2008-06-05	2008-06-05 00:00:00	2008-06-05	2008-06-05 00:00:00	2008-06-05	38000177		0	0	0		0	0	0	350271	0	834357	1310034		
55106	4576	1127078	1955-04-25	1955-04-25 00:00:00	1955-05-09	1955-05-09 00:00:00	1955-05-09	38000177		0	0	14		0	0	0	304856	0	282464	1127078		
5239	440	1115171	2006-01-06	2006-01-06 00:00:00	2006-01-20	2006-01-20 00:00:00	2006-01-20	38000177		0	0	14		0	0	0	29205	0	849574	1115171		
22725	1867	19019979	1974-07-23	1974-07-23 00:00:00	1974-08-06	1974-08-06 00:00:00	1974-08-06	38000177		0	0	14		0	0	0	124705	0	198405	19019979		
84832	1855	40213160	1975-08-29	1975-08-29 00:00:00	1975-08-29	1975-08-29 00:00:00	1975-08-29	581452		0	0	0		0	0	0	124201	0	10	40213160		
5397	452	1127433	2017-02-21	2017-02-21 00:00:00	2017-02-28	2017-02-28 00:00:00	2017-02-28	38000177		0	0	7		0	0	0	30107	0	313782	1127433		
48101	3987	1127078	1956-08-12	1956-08-12 00:00:00	1956-09-02	1956-09-02 00:00:00	1956-09-02	38000177		0	0	21		0	0	0	265026	0	282464	1127078		
61564	5123	1127433	2004-04-21	2004-04-21 00:00:00	2004-05-21	2004-05-21 00:00:00	2004-05-21	38000177		0	0	30		0	0	0	340687	0	313782	1127433		
138568	3044	40213227	2011-02-01	2011-02-01 00:00:00	2011-02-01	2011-02-01 00:00:00	2011-02-01	581452		0	0	0		0	0	0	202639	0	113	40213227		
59883	4977	40165015	2010-12-13	2010-12-13 00:00:00	2010-12-13	2010-12-13 00:00:00	\N	38000177		0	0	0		0	0	0	331120	0	861467	40165015		
176251	3875	40213296	1999-09-04	1999-09-04 00:00:00	1999-09-04	1999-09-04 00:00:00	1999-09-04	581452		0	0	0		0	0	0	257373	0	52	40213296		
25413	2088	40162522	1969-03-02	1969-03-02 00:00:00	1969-03-02	1969-03-02 00:00:00	\N	38000177		0	0	0		0	0	0	139180	0	857005	40162522		
44117	3652	46233988	1975-10-11	1975-10-11 00:00:00	1975-10-25	1975-10-25 00:00:00	1975-10-25	38000177		0	0	14		0	0	0	243131	0	1652673	46233988		
54921	4561	1127078	1952-06-30	1952-06-30 00:00:00	1952-07-14	1952-07-14 00:00:00	1952-07-14	38000177		0	0	14		0	0	0	303923	0	282464	1127078		
70407	1540	40213160	1958-11-03	1958-11-03 00:00:00	1958-11-03	1958-11-03 00:00:00	1958-11-03	581452		0	0	0		0	0	0	103219	0	10	40213160		
2766	222	19133905	1974-03-09	1974-03-09 00:00:00	1974-03-19	1974-03-19 00:00:00	1974-03-19	38000177		0	0	10		0	0	0	14884	0	834102	19133905		
36107	2975	1127078	1965-11-18	1965-11-18 00:00:00	1965-12-18	1965-12-18 00:00:00	1965-12-18	38000177		0	0	30		0	0	0	198626	0	282464	1127078		
203403	4465	40213227	2004-04-09	2004-04-09 00:00:00	2004-04-09	2004-04-09 00:00:00	2004-04-09	581452		0	0	0		0	0	0	297066	0	113	40213227		
139756	3070	40213306	1986-12-21	1986-12-21 00:00:00	1986-12-21	1986-12-21 00:00:00	1986-12-21	581452		0	0	0		0	0	0	\N	0	43	40213306		
4985	412	1127078	1957-10-10	1957-10-10 00:00:00	1957-10-24	1957-10-24 00:00:00	1957-10-24	38000177		0	0	14		0	0	0	27473	0	282464	1127078		
124878	2747	40213160	1973-02-18	1973-02-18 00:00:00	1973-02-18	1973-02-18 00:00:00	1973-02-18	581452		0	0	0		0	0	0	181710	0	10	40213160		
185991	4086	40213160	1973-08-09	1973-08-09 00:00:00	1973-08-09	1973-08-09 00:00:00	1973-08-09	581452		0	0	0		0	0	0	271602	0	10	40213160		
26931	2220	1713671	1976-03-20	1976-03-20 00:00:00	1976-04-03	1976-04-03 00:00:00	1976-04-03	38000177		0	0	14		0	0	0	147796	0	562251	1713671		
184380	4052	40213296	2018-04-26	2018-04-26 00:00:00	2018-04-26	2018-04-26 00:00:00	2018-04-26	581452		0	0	0		0	0	0	269368	0	52	40213296		
184399	4052	40213306	1998-08-13	1998-08-13 00:00:00	1998-08-13	1998-08-13 00:00:00	1998-08-13	581452		0	0	0		0	0	0	269400	0	43	40213306		
34624	2860	19007333	2006-10-01	2006-10-01 00:00:00	2010-04-13	2010-04-13 00:00:00	2010-04-13	38000177		0	0	1290		0	0	0	190105	0	105586	19007333		
54380	4521	1332419	1994-02-10	1994-02-10 00:00:00	1994-02-10	1994-02-10 00:00:00	\N	38000177		0	0	0		0	0	0	301032	0	197361	1332419		
118163	2598	40213227	2015-05-12	2015-05-12 00:00:00	2015-05-12	2015-05-12 00:00:00	2015-05-12	581452		0	0	0		0	0	0	171907	0	113	40213227		
15049	1257	1539411	2016-11-12	2016-11-12 00:00:00	2016-11-12	2016-11-12 00:00:00	\N	38000177		0	0	0		0	0	0	82829	0	312961	1539411		
48144	3991	19006318	1945-12-28	1945-12-28 00:00:00	1946-01-11	1946-01-11 00:00:00	1946-01-11	38000177		0	0	14		0	0	0	265364	0	105078	19006318		
4031	334	19059056	1937-03-26	1937-03-26 00:00:00	1937-04-09	1937-04-09 00:00:00	1937-04-09	38000177		0	0	14		0	0	0	22212	0	243670	19059056		
32757	2712	40231925	1998-11-30	1998-11-30 00:00:00	1998-11-30	1998-11-30 00:00:00	\N	38000177		0	0	0		0	0	0	179817	0	1049221	40231925		
19475	1605	1124300	1971-08-09	1971-08-09 00:00:00	1971-08-09	1971-08-09 00:00:00	\N	38000177		0	0	0		0	0	0	107743	0	00781178901	45011828		
49079	4072	1127078	1980-06-19	1980-06-19 00:00:00	1980-07-03	1980-07-03 00:00:00	1980-07-03	38000177		0	0	14		0	0	0	270698	0	282464	1127078		
19558	1609	1127433	1984-06-19	1984-06-19 00:00:00	1984-06-26	1984-06-26 00:00:00	1984-06-26	38000177		0	0	7		0	0	0	108179	0	313782	1127433		
5961	499	1118084	1997-08-02	1997-08-02 00:00:00	1997-08-02	1997-08-02 00:00:00	\N	38000177		0	0	0		0	0	0	33302	0	00025152531	44923712		
48506	4018	40229134	2000-06-18	2000-06-18 00:00:00	2000-07-02	2000-07-02 00:00:00	2000-07-02	38000177		0	0	14		0	0	0	267055	0	1043400	40229134		
63681	5291	1127078	1976-12-25	1976-12-25 00:00:00	1977-01-08	1977-01-08 00:00:00	1977-01-08	38000177		0	0	14		0	0	0	352069	0	282464	1127078		
38024	3144	40229134	1974-11-16	1974-11-16 00:00:00	1974-11-30	1974-11-30 00:00:00	1974-11-30	38000177		0	0	14		0	0	0	209181	0	1043400	40229134		
46798	1022	40213160	1964-12-08	1964-12-08 00:00:00	1964-12-08	1964-12-08 00:00:00	1964-12-08	581452		0	0	0		0	0	0	67244	0	10	40213160		
203913	4476	40213160	1962-09-30	1962-09-30 00:00:00	1962-09-30	1962-09-30 00:00:00	1962-09-30	581452		0	0	0		0	0	0	297786	0	10	40213160		
241514	5302	40213306	1992-07-31	1992-07-31 00:00:00	1992-07-31	1992-07-31 00:00:00	1992-07-31	581452		0	0	0		0	0	0	352774	0	43	40213306		
30645	2542	1150837	1986-06-26	1986-06-26 00:00:00	1986-06-26	1986-06-26 00:00:00	\N	38000177		0	0	0		0	0	0	168123	0	141918	1150837		
3792	316	1127433	1996-05-08	1996-05-08 00:00:00	1996-05-15	1996-05-15 00:00:00	1996-05-15	38000177		0	0	7		0	0	0	20862	0	313782	1127433		
52565	4372	1127433	1987-07-11	1987-07-11 00:00:00	1987-07-25	1987-07-25 00:00:00	1987-07-25	38000177		0	0	14		0	0	0	290206	0	313782	1127433		
155187	3415	40213227	1997-11-15	1997-11-15 00:00:00	1997-11-15	1997-11-15 00:00:00	1997-11-15	581452		0	0	0		0	0	0	226527	0	113	40213227		
17257	372	40213227	1993-03-06	1993-03-06 00:00:00	1993-03-06	1993-03-06 00:00:00	1993-03-06	581452		0	0	0		0	0	0	24760	0	113	40213227		
48369	4010	19128022	2000-03-15	2000-03-15 00:00:00	2001-03-10	2001-03-10 00:00:00	2001-03-10	38000177		0	0	360		0	0	0	266477	0	749785	19128022		
12503	1053	19019979	1981-06-12	1981-06-12 00:00:00	1981-06-26	1981-06-26 00:00:00	1981-06-26	38000177		0	0	14		0	0	0	69011	0	198405	19019979		
146310	3218	40213160	1957-04-07	1957-04-07 00:00:00	1957-04-07	1957-04-07 00:00:00	1957-04-07	581452		0	0	0		0	0	0	213865	0	10	40213160		
131621	2892	40213296	2015-07-24	2015-07-24 00:00:00	2015-07-24	2015-07-24 00:00:00	2015-07-24	581452		0	0	0		0	0	0	192440	0	52	40213296		
117193	2576	40213314	1980-02-14	1980-02-14 00:00:00	1980-02-14	1980-02-14 00:00:00	1980-02-14	581452		0	0	0		0	0	0	170533	0	49	40213314		
63793	5300	782047	1945-02-13	1945-02-13 00:00:00	1945-02-13	1945-02-13 00:00:00	1945-02-13	38000177		0	0	0		0	0	0	352654	0	542347	782047		
15500	1292	1127433	1999-01-15	1999-01-15 00:00:00	1999-03-23	1999-03-23 00:00:00	1999-03-23	38000177		0	0	67		0	0	0	85417	0	313782	1127433		
18084	1497	1127433	1983-10-25	1983-10-25 00:00:00	1983-11-08	1983-11-08 00:00:00	1983-11-08	38000177		0	0	14		0	0	0	99769	0	313782	1127433		
217714	4777	40213160	1963-04-23	1963-04-23 00:00:00	1963-04-23	1963-04-23 00:00:00	1963-04-23	581452		0	0	0		0	0	0	318117	0	10	40213160		
6164	133	40213314	1981-03-23	1981-03-23 00:00:00	1981-03-23	1981-03-23 00:00:00	1981-03-23	581452		0	0	0		0	0	0	8960	0	49	40213314		
34718	2867	19019979	1979-06-11	1979-06-11 00:00:00	1979-06-25	1979-06-25 00:00:00	1979-06-25	38000177		0	0	14		0	0	0	190698	0	198405	19019979		
47302	3921	19128022	1997-10-28	1997-10-28 00:00:00	1998-10-23	1998-10-23 00:00:00	1998-10-23	38000177		0	0	360		0	0	0	260740	0	749785	19128022		
41335	3428	45892894	2018-05-26	2018-05-26 00:00:00	2018-05-26	2018-05-26 00:00:00	\N	38000177		0	0	0		0	0	0	227304	0	1599803	45892894		
41406	3434	19059056	1965-08-12	1965-08-12 00:00:00	1965-11-10	1965-11-10 00:00:00	1965-11-10	38000177		0	0	90		0	0	0	227683	0	243670	19059056		
70259	1537	40213160	1957-01-23	1957-01-23 00:00:00	1957-01-23	1957-01-23 00:00:00	1957-01-23	581452		0	0	0		0	0	0	102889	0	10	40213160		
4577	380	46233988	1972-01-11	1972-01-11 00:00:00	1972-01-25	1972-01-25 00:00:00	1972-01-25	38000177		0	0	14		0	0	0	25145	0	1652673	46233988		
49866	4137	19078461	2002-12-14	2002-12-14 00:00:00	2002-12-28	2002-12-28 00:00:00	2002-12-28	38000177		0	0	14		0	0	0	275052	0	310965	19078461		
63393	5265	40243436	2008-06-05	2008-06-05 00:00:00	2008-06-05	2008-06-05 00:00:00	2008-06-05	38000177		0	0	0		0	0	0	350271	0	1190795	40243436		
55107	4576	19006318	1955-04-25	1955-04-25 00:00:00	1955-05-09	1955-05-09 00:00:00	1955-05-09	38000177		0	0	14		0	0	0	304856	0	105078	19006318		
5240	440	1118084	2009-02-17	2009-02-17 00:00:00	2009-02-17	2009-02-17 00:00:00	\N	38000177		0	0	0		0	0	0	29179	0	00025152531	44923712		
22726	1867	19129655	1974-07-23	1974-07-23 00:00:00	1974-08-06	1974-08-06 00:00:00	1974-08-06	38000177		0	0	14		0	0	0	124705	0	789980	19129655		
84835	1855	40213227	1998-01-02	1998-01-02 00:00:00	1998-01-02	1998-01-02 00:00:00	1998-01-02	581452		0	0	0		0	0	0	124188	0	113	40213227		
5398	452	19078461	2009-08-18	2009-08-18 00:00:00	2009-09-01	2009-09-01 00:00:00	2009-09-01	38000177		0	0	14		0	0	0	30109	0	310965	19078461		
48102	3987	40173590	2014-02-22	2014-02-22 00:00:00	2014-02-22	2014-02-22 00:00:00	\N	38000177		0	0	0		0	0	0	265059	0	904419	40173590		
61565	5123	40162522	2004-04-21	2004-04-21 00:00:00	2004-04-21	2004-04-21 00:00:00	\N	38000177		0	0	0		0	0	0	340687	0	857005	40162522		
138569	3044	40213296	2011-02-01	2011-02-01 00:00:00	2011-02-01	2011-02-01 00:00:00	2011-02-01	581452		0	0	0		0	0	0	202639	0	52	40213296		
59884	4977	40220386	2010-12-08	2010-12-08 00:00:00	2010-12-08	2010-12-08 00:00:00	2010-12-08	38000177		0	0	0		0	0	0	331120	0	1808217	40220386		
176259	3875	40213160	1958-05-03	1958-05-03 00:00:00	1958-05-03	1958-05-03 00:00:00	1958-05-03	581452		0	0	0		0	0	0	257383	0	10	40213160		
25414	2088	1127433	1969-03-02	1969-03-02 00:00:00	1969-05-01	1969-05-01 00:00:00	1969-05-01	38000177		0	0	60		0	0	0	139180	0	313782	1127433		
44118	3652	1127433	2015-03-04	2015-03-04 00:00:00	2015-03-11	2015-03-11 00:00:00	2015-03-11	38000177		0	0	7		0	0	0	243129	0	313782	1127433		
54922	4561	1127433	2015-06-23	2015-06-23 00:00:00	2015-06-30	2015-06-30 00:00:00	2015-06-30	38000177		0	0	7		0	0	0	303913	0	313782	1127433		
70409	1540	40213260	2009-08-03	2009-08-03 00:00:00	2009-08-03	2009-08-03 00:00:00	2009-08-03	581452		0	0	0		0	0	0	103204	0	121	40213260		
2767	222	1127433	1965-10-31	1965-10-31 00:00:00	1965-11-07	1965-11-07 00:00:00	1965-11-07	38000177		0	0	7		0	0	0	14936	0	313782	1127433		
36108	2975	19059056	1965-05-22	1965-05-22 00:00:00	1965-06-05	1965-06-05 00:00:00	1965-06-05	38000177		0	0	14		0	0	0	198644	0	243670	19059056		
56394	1235	40213306	1997-07-28	1997-07-28 00:00:00	1997-07-28	1997-07-28 00:00:00	1997-07-28	581452		0	0	0		0	0	0	81335	0	43	40213306		
139758	3070	40213260	2016-10-30	2016-10-30 00:00:00	2016-10-30	2016-10-30 00:00:00	2016-10-30	581452		0	0	0		0	0	0	204381	0	121	40213260		
4986	412	19006318	1957-10-10	1957-10-10 00:00:00	1957-10-24	1957-10-24 00:00:00	1957-10-24	38000177		0	0	14		0	0	0	27473	0	105078	19006318		
124880	2747	40213160	1972-09-17	1972-09-17 00:00:00	1972-09-17	1972-09-17 00:00:00	1972-09-17	581452		0	0	0		0	0	0	181709	0	10	40213160		
185996	4087	40213251	1984-10-10	1984-10-10 00:00:00	1984-10-10	1984-10-10 00:00:00	1984-10-10	581452		0	0	0		0	0	0	271626	0	21	40213251		
26932	2220	40229134	1978-06-20	1978-06-20 00:00:00	1978-07-04	1978-07-04 00:00:00	1978-07-04	38000177		0	0	14		0	0	0	147863	0	1043400	40229134		
184335	4051	40213314	1977-12-21	1977-12-21 00:00:00	1977-12-21	1977-12-21 00:00:00	1977-12-21	581452		0	0	0		0	0	0	269288	0	49	40213314		
184401	4052	40213227	1998-08-13	1998-08-13 00:00:00	1998-08-13	1998-08-13 00:00:00	1998-08-13	581452		0	0	0		0	0	0	269400	0	113	40213227		
34625	2860	1127433	1952-02-24	1952-02-24 00:00:00	1952-03-02	1952-03-02 00:00:00	1952-03-02	38000177		0	0	7		0	0	0	190148	0	313782	1127433		
54381	4521	19059056	1924-04-02	1924-04-02 00:00:00	1924-07-01	1924-07-01 00:00:00	1924-07-01	38000177		0	0	90		0	0	0	301008	0	243670	19059056		
118164	2598	40213296	2015-05-12	2015-05-12 00:00:00	2015-05-12	2015-05-12 00:00:00	2015-05-12	581452		0	0	0		0	0	0	171907	0	52	40213296		
15050	1257	19019979	1977-04-05	1977-04-05 00:00:00	1977-04-19	1977-04-19 00:00:00	1977-04-19	38000177		0	0	14		0	0	0	82809	0	198405	19019979		
48145	3991	19059056	1945-12-28	1945-12-28 00:00:00	1946-01-11	1946-01-11 00:00:00	1946-01-11	38000177		0	0	14		0	0	0	265364	0	243670	19059056		
4032	334	1127433	1963-11-22	1963-11-22 00:00:00	1963-12-06	1963-12-06 00:00:00	1963-12-06	38000177		0	0	14		0	0	0	22122	0	313782	1127433		
32758	2712	1118084	2000-08-08	2000-08-08 00:00:00	2000-08-08	2000-08-08 00:00:00	\N	38000177		0	0	0		0	0	0	179817	0	00025152531	44923712		
19476	1605	1127433	2016-05-05	2016-05-05 00:00:00	2016-05-26	2016-05-26 00:00:00	2016-05-26	38000177		0	0	21		0	0	0	107752	0	313782	1127433		
49080	4072	19074843	1980-06-19	1980-06-19 00:00:00	1980-07-03	1980-07-03 00:00:00	1980-07-03	38000177		0	0	14		0	0	0	270698	0	309045	19074843		
19559	1609	19059056	1949-03-17	1949-03-17 00:00:00	1949-03-31	1949-03-31 00:00:00	1949-03-31	38000177		0	0	14		0	0	0	108195	0	243670	19059056		
5962	499	1127433	1963-10-01	1963-10-01 00:00:00	1963-10-15	1963-10-15 00:00:00	1963-10-15	38000177		0	0	14		0	0	0	33358	0	313782	1127433		
48507	4018	1118084	2001-08-08	2001-08-08 00:00:00	2001-08-08	2001-08-08 00:00:00	\N	38000177		0	0	0		0	0	0	267055	0	00025152531	44923712		
63682	5291	19133905	2000-09-09	2000-09-09 00:00:00	2000-09-22	2000-09-22 00:00:00	2000-09-22	38000177		0	0	13		0	0	0	352075	0	834102	19133905		
38025	3144	19059056	1968-01-03	1968-01-03 00:00:00	1968-02-07	1968-02-07 00:00:00	1968-02-07	38000177		0	0	35		0	0	0	209183	0	243670	19059056		
46799	1022	40213296	2004-04-06	2004-04-06 00:00:00	2004-04-06	2004-04-06 00:00:00	2004-04-06	581452		0	0	0		0	0	0	67265	0	52	40213296		
203918	4476	40213160	1962-04-29	1962-04-29 00:00:00	1962-04-29	1962-04-29 00:00:00	1962-04-29	581452		0	0	0		0	0	0	297785	0	10	40213160		
241519	5302	40213296	2012-08-24	2012-08-24 00:00:00	2012-08-24	2012-08-24 00:00:00	2012-08-24	581452		0	0	0		0	0	0	352778	0	52	40213296		
30646	2542	1713671	1975-03-29	1975-03-29 00:00:00	1975-04-12	1975-04-12 00:00:00	1975-04-12	38000177		0	0	14		0	0	0	168187	0	562251	1713671		
3793	316	1713671	1952-12-01	1952-12-01 00:00:00	1952-12-22	1952-12-22 00:00:00	1952-12-22	38000177		0	0	21		0	0	0	20960	0	562251	1713671		
52566	4372	1127433	2012-10-13	2012-10-13 00:00:00	2012-10-20	2012-10-20 00:00:00	2012-10-20	38000177		0	0	7		0	0	0	290246	0	313782	1127433		
155191	3415	40213306	1988-11-05	1988-11-05 00:00:00	1988-11-05	1988-11-05 00:00:00	1988-11-05	581452		0	0	0		0	0	0	226511	0	43	40213306		
17266	372	40213227	2003-05-24	2003-05-24 00:00:00	2003-05-24	2003-05-24 00:00:00	2003-05-24	581452		0	0	0		0	0	0	24761	0	113	40213227		
48370	4010	19133873	1981-03-18	1981-03-18 00:00:00	1981-03-30	1981-03-30 00:00:00	1981-03-30	38000177		0	0	12		0	0	0	266493	0	834061	19133873		
12504	1053	19115351	1982-09-10	1982-09-10 00:00:00	1984-03-02	1984-03-02 00:00:00	1984-03-02	38000177		0	0	539		0	0	0	69017	0	563026	19115351		
146314	3218	40213160	1961-10-08	1961-10-08 00:00:00	1961-10-08	1961-10-08 00:00:00	1961-10-08	581452		0	0	0		0	0	0	213869	0	10	40213160		
131636	2893	40213227	2005-03-09	2005-03-09 00:00:00	2005-03-09	2005-03-09 00:00:00	2005-03-09	581452		0	0	0		0	0	0	192556	0	113	40213227		
117194	2576	40213160	1980-02-14	1980-02-14 00:00:00	1980-02-14	1980-02-14 00:00:00	1980-02-14	581452		0	0	0		0	0	0	170533	0	10	40213160		
63794	5300	35605482	1945-02-13	1945-02-13 00:00:00	1945-02-13	1945-02-13 00:00:00	1945-02-13	38000177		0	0	0		0	0	0	352654	0	1740467	35605482		
15501	1292	1551192	1963-06-14	1963-06-14 00:00:00	1963-06-14	1963-06-14 00:00:00	1963-06-14	38000177		0	0	0		0	0	0	85413	0	312617	1551192		
18085	1497	1127433	2000-07-26	2000-07-26 00:00:00	2000-08-23	2000-08-23 00:00:00	2000-08-23	38000177		0	0	28		0	0	0	99781	0	313782	1127433		
217720	4777	40213160	1958-10-21	1958-10-21 00:00:00	1958-10-21	1958-10-21 00:00:00	1958-10-21	581452		0	0	0		0	0	0	318114	0	10	40213160		
6166	133	40213160	1981-03-23	1981-03-23 00:00:00	1981-03-23	1981-03-23 00:00:00	1981-03-23	581452		0	0	0		0	0	0	8960	0	10	40213160		
34719	2867	19128022	1996-07-21	1996-07-21 00:00:00	1997-07-16	1997-07-16 00:00:00	1997-07-16	38000177		0	0	360		0	0	0	190749	0	749785	19128022		
47303	3921	42902245	2001-10-07	2001-10-07 00:00:00	2002-10-02	2002-10-02 00:00:00	2002-10-02	38000177		0	0	360		0	0	0	260719	0	1359133	42902245		
41336	3428	1127433	2003-10-25	2003-10-25 00:00:00	2003-11-08	2003-11-08 00:00:00	2003-11-08	38000177		0	0	14		0	0	0	227250	0	313782	1127433		
41407	3434	1115171	2009-04-23	2009-04-23 00:00:00	2009-05-14	2009-05-14 00:00:00	2009-05-14	38000177		0	0	21		0	0	0	227685	0	849574	1115171		
70262	1537	40213296	1996-06-19	1996-06-19 00:00:00	1996-06-19	1996-06-19 00:00:00	1996-06-19	581452		0	0	0		0	0	0	102857	0	52	40213296		
4578	380	1127078	1972-01-11	1972-01-11 00:00:00	1972-01-25	1972-01-25 00:00:00	1972-01-25	38000177		0	0	14		0	0	0	25145	0	282464	1127078		
49867	4137	1127433	1973-02-23	1973-02-23 00:00:00	1973-03-09	1973-03-09 00:00:00	1973-03-09	38000177		0	0	14		0	0	0	275019	0	313782	1127433		
63394	5265	46275916	2008-06-05	2008-06-05 00:00:00	2008-06-05	2008-06-05 00:00:00	2008-06-05	38000177		0	0	0		0	0	0	350271	0	1660014	46275916		
55109	4576	1124300	1993-03-31	1993-03-31 00:00:00	1993-03-31	1993-03-31 00:00:00	\N	38000177		0	0	0		0	0	0	304854	0	00781178901	45011828		
5241	440	1713671	1983-03-14	1983-03-14 00:00:00	1983-03-21	1983-03-21 00:00:00	1983-03-21	38000177		0	0	7		0	0	0	29171	0	562251	1713671		
22727	1867	19006318	1977-07-29	1977-07-29 00:00:00	1977-08-12	1977-08-12 00:00:00	1977-08-12	38000177		0	0	14		0	0	0	124706	0	105078	19006318		
84836	1855	40213306	1998-01-02	1998-01-02 00:00:00	1998-01-02	1998-01-02 00:00:00	1998-01-02	581452		0	0	0		0	0	0	124188	0	43	40213306		
5399	452	19073188	2009-08-18	2009-08-18 00:00:00	2009-09-01	2009-09-01 00:00:00	2009-09-01	38000177		0	0	14		0	0	0	30109	0	308192	19073188		
48103	3987	40229134	2010-08-17	2010-08-17 00:00:00	2010-08-31	2010-08-31 00:00:00	2010-08-31	38000177		0	0	14		0	0	0	265073	0	1043400	40229134		
61566	5123	19128065	1995-05-14	1995-05-14 00:00:00	1996-05-08	1996-05-08 00:00:00	1996-05-08	38000177		0	0	360		0	0	0	340646	0	749882	19128065		
138573	3044	40213160	1969-09-30	1969-09-30 00:00:00	1969-09-30	1969-09-30 00:00:00	1969-09-30	581452		0	0	0		0	0	0	202607	0	10	40213160		
59885	4977	19079524	2010-12-07	2010-12-07 00:00:00	2010-12-13	2010-12-13 00:00:00	2010-12-13	38000177		0	0	6		0	0	0	331120	0	313002	19079524		
176261	3875	40213160	1958-08-02	1958-08-02 00:00:00	1958-08-02	1958-08-02 00:00:00	1958-08-02	581452		0	0	0		0	0	0	257400	0	10	40213160		
25415	2088	19059056	1921-09-14	1921-09-14 00:00:00	1921-09-28	1921-09-28 00:00:00	1921-09-28	38000177		0	0	14		0	0	0	139177	0	243670	19059056		
44119	3652	19128065	1989-08-26	1989-08-26 00:00:00	1990-08-21	1990-08-21 00:00:00	1990-08-21	38000177		0	0	360		0	0	0	243091	0	749882	19128065		
108893	2389	40213296	2010-12-14	2010-12-14 00:00:00	2010-12-14	2010-12-14 00:00:00	2010-12-14	581452		0	0	0		0	0	0	158875	0	52	40213296		
70416	1540	40213227	2009-08-03	2009-08-03 00:00:00	2009-08-03	2009-08-03 00:00:00	2009-08-03	581452		0	0	0		0	0	0	103204	0	113	40213227		
2768	222	1713671	1988-04-26	1988-04-26 00:00:00	1988-05-10	1988-05-10 00:00:00	1988-05-10	38000177		0	0	14		0	0	0	14893	0	562251	1713671		
36109	2975	19129655	1965-05-22	1965-05-22 00:00:00	1965-06-05	1965-06-05 00:00:00	1965-06-05	38000177		0	0	14		0	0	0	198644	0	789980	19129655		
56396	1235	40213227	1997-07-28	1997-07-28 00:00:00	1997-07-28	1997-07-28 00:00:00	1997-07-28	581452		0	0	0		0	0	0	81335	0	113	40213227		
139765	3070	40213160	1967-03-05	1967-03-05 00:00:00	1967-03-05	1967-03-05 00:00:00	1967-03-05	581452		0	0	0		0	0	0	204345	0	10	40213160		
54686	1197	40213227	2009-11-22	2009-11-22 00:00:00	2009-11-22	2009-11-22 00:00:00	2009-11-22	581452		0	0	0		0	0	0	78862	0	113	40213227		
172962	3803	40213296	2000-09-27	2000-09-27 00:00:00	2000-09-27	2000-09-27 00:00:00	2000-09-27	581452		0	0	0		0	0	0	252785	0	52	40213296		
186001	4087	40213314	1978-12-27	1978-12-27 00:00:00	1978-12-27	1978-12-27 00:00:00	1978-12-27	581452		0	0	0		0	0	0	271676	0	49	40213314		
26933	2220	40229134	1947-12-16	1947-12-16 00:00:00	1947-12-23	1947-12-23 00:00:00	1947-12-23	38000177		0	0	7		0	0	0	147838	0	1043400	40229134		
184337	4051	40213160	1974-06-26	1974-06-26 00:00:00	1974-06-26	1974-06-26 00:00:00	1974-06-26	581452		0	0	0		0	0	0	269257	0	10	40213160		
184406	4052	40213314	1977-09-22	1977-09-22 00:00:00	1977-09-22	1977-09-22 00:00:00	1977-09-22	581452		0	0	0		0	0	0	269312	0	49	40213314		
34626	2860	1127433	2004-09-01	2004-09-01 00:00:00	2004-09-08	2004-09-08 00:00:00	2004-09-08	38000177		0	0	7		0	0	0	190127	0	313782	1127433		
54382	4521	19059056	1928-03-12	1928-03-12 00:00:00	1928-05-11	1928-05-11 00:00:00	1928-05-11	38000177		0	0	60		0	0	0	301009	0	243670	19059056		
118173	2599	40213160	1982-10-02	1982-10-02 00:00:00	1982-10-02	1982-10-02 00:00:00	1982-10-02	581452		0	0	0		0	0	0	171950	0	10	40213160		
15051	1257	19006318	1977-04-05	1977-04-05 00:00:00	1977-04-19	1977-04-19 00:00:00	1977-04-19	38000177		0	0	14		0	0	0	82809	0	105078	19006318		
48146	3991	19006318	1947-07-02	1947-07-02 00:00:00	1947-07-16	1947-07-16 00:00:00	1947-07-16	38000177		0	0	14		0	0	0	265398	0	105078	19006318		
4033	334	1127433	2012-11-25	2012-11-25 00:00:00	2012-12-02	2012-12-02 00:00:00	2012-12-02	38000177		0	0	7		0	0	0	22210	0	313782	1127433		
32759	2712	1127433	1988-09-26	1988-09-26 00:00:00	1988-10-03	1988-10-03 00:00:00	1988-10-03	38000177		0	0	7		0	0	0	179815	0	313782	1127433		
19477	1605	19126352	2017-10-22	2017-10-22 00:00:00	2017-10-22	2017-10-22 00:00:00	\N	38000177		0	0	0		0	0	0	107709	0	705129	19126352		
49081	4072	46233988	1975-02-04	1975-02-04 00:00:00	1975-02-18	1975-02-18 00:00:00	1975-02-18	38000177		0	0	14		0	0	0	270684	0	1652673	46233988		
19560	1609	1127433	1955-05-19	1955-05-19 00:00:00	1955-06-02	1955-06-02 00:00:00	1955-06-02	38000177		0	0	14		0	0	0	108196	0	313782	1127433		
5963	499	19112599	1963-05-14	1963-05-14 00:00:00	1963-05-14	1963-05-14 00:00:00	\N	38000177		0	0	0		0	0	0	33357	0	477045	19112599		
48508	4019	40229134	1992-07-22	1992-07-22 00:00:00	1992-08-05	1992-08-05 00:00:00	1992-08-05	38000177		0	0	14		0	0	0	267163	0	1043400	40229134		
63683	5291	46233988	1976-07-15	1976-07-15 00:00:00	1976-07-29	1976-07-29 00:00:00	1976-07-29	38000177		0	0	14		0	0	0	352077	0	1652673	46233988		
38026	3144	1127433	1980-10-31	1980-10-31 00:00:00	1980-11-28	1980-11-28 00:00:00	1980-11-28	38000177		0	0	28		0	0	0	209184	0	313782	1127433		
46802	1022	40213306	1987-01-27	1987-01-27 00:00:00	1987-01-27	1987-01-27 00:00:00	1987-01-27	581452		0	0	0		0	0	0	67264	0	43	40213306		
203923	4476	40213160	1966-11-20	1966-11-20 00:00:00	1966-11-20	1966-11-20 00:00:00	1966-11-20	581452		0	0	0		0	0	0	297880	0	10	40213160		
241522	5302	40213160	1972-05-12	1972-05-12 00:00:00	1972-05-12	1972-05-12 00:00:00	1972-05-12	581452		0	0	0		0	0	0	352818	0	10	40213160		
30647	2542	1713671	1970-05-12	1970-05-12 00:00:00	1970-05-19	1970-05-19 00:00:00	1970-05-19	38000177		0	0	7		0	0	0	168103	0	562251	1713671		
3794	316	19126352	1976-07-06	1976-07-06 00:00:00	1976-07-06	1976-07-06 00:00:00	\N	38000177		0	0	0		0	0	0	20912	0	705129	19126352		
52567	4372	19074843	1985-12-08	1985-12-08 00:00:00	1985-12-22	1985-12-22 00:00:00	1985-12-22	38000177		0	0	14		0	0	0	290211	0	309045	19074843		
166496	3660	40213160	1977-07-02	1977-07-02 00:00:00	1977-07-02	1977-07-02 00:00:00	1977-07-02	581452		0	0	0		0	0	0	243574	0	10	40213160		
17267	372	40213296	2003-05-24	2003-05-24 00:00:00	2003-05-24	2003-05-24 00:00:00	2003-05-24	581452		0	0	0		0	0	0	24761	0	52	40213296		
48371	4010	19073183	1982-12-05	1982-12-05 00:00:00	1982-12-19	1982-12-19 00:00:00	1982-12-19	38000177		0	0	14		0	0	0	266456	0	308182	19073183		
12505	1053	1127433	2018-05-08	2018-05-08 00:00:00	2018-05-22	2018-05-22 00:00:00	2018-05-22	38000177		0	0	14		0	0	0	69027	0	313782	1127433		
146317	3218	40213160	1957-02-03	1957-02-03 00:00:00	1957-02-03	1957-02-03 00:00:00	1957-02-03	581452		0	0	0		0	0	0	213826	0	10	40213160		
131644	2893	40213198	2010-04-07	2010-04-07 00:00:00	2010-04-07	2010-04-07 00:00:00	2010-04-07	581452		0	0	0		0	0	0	192474	0	133	40213198		
117198	2576	40213251	1984-10-18	1984-10-18 00:00:00	1984-10-18	1984-10-18 00:00:00	1984-10-18	581452		0	0	0		0	0	0	170569	0	21	40213251		
63795	5300	35605482	1945-02-13	1945-02-13 00:00:00	1945-02-13	1945-02-13 00:00:00	1945-02-13	38000177		0	0	0		0	0	0	352654	0	1740467	35605482		
15502	1292	19059056	1972-02-26	1972-02-26 00:00:00	1972-03-11	1972-03-11 00:00:00	1972-03-11	38000177		0	0	14		0	0	0	85414	0	243670	19059056		
18086	1497	19078461	2007-02-18	2007-02-18 00:00:00	2007-03-20	2007-03-20 00:00:00	2007-03-20	38000177		0	0	30		0	0	0	99782	0	310965	19078461		
205944	4520	40213201	1994-01-22	1994-01-22 00:00:00	1994-01-22	1994-01-22 00:00:00	1994-01-22	581452		0	0	0		0	0	0	300938	0	33	40213201		
76258	1666	40213227	1996-05-25	1996-05-25 00:00:00	1996-05-25	1996-05-25 00:00:00	1996-05-25	581452		0	0	0		0	0	0	111896	0	113	40213227		
34720	2867	1127078	1988-06-07	1988-06-07 00:00:00	1988-07-07	1988-07-07 00:00:00	1988-07-07	38000177		0	0	30		0	0	0	190700	0	282464	1127078		
47304	3921	19074841	1994-02-23	1994-02-23 00:00:00	1994-03-09	1994-03-09 00:00:00	1994-03-09	38000177		0	0	14		0	0	0	260723	0	309043	19074841		
41337	3428	1118084	2006-09-02	2006-09-02 00:00:00	2006-09-02	2006-09-02 00:00:00	\N	38000177		0	0	0		0	0	0	227282	0	00025152531	44923712		
41408	3434	19133873	1964-01-19	1964-01-19 00:00:00	1964-02-01	1964-02-01 00:00:00	1964-02-01	38000177		0	0	13		0	0	0	227694	0	834061	19133873		
6813	148	40213160	1979-03-25	1979-03-25 00:00:00	1979-03-25	1979-03-25 00:00:00	1979-03-25	581452		0	0	0		0	0	0	10011	0	10	40213160		
4579	380	1127433	2013-07-12	2013-07-12 00:00:00	2013-07-26	2013-07-26 00:00:00	2013-07-26	38000177		0	0	14		0	0	0	25154	0	313782	1127433		
49880	4139	1118084	2011-09-17	2011-09-17 00:00:00	2011-09-17	2011-09-17 00:00:00	\N	38000177		0	0	0		0	0	0	275152	0	00025152531	44923712		
63395	5265	1127433	2012-02-11	2012-02-11 00:00:00	2012-03-03	2012-03-03 00:00:00	2012-03-03	38000177		0	0	21		0	0	0	350272	0	313782	1127433		
55110	4576	19128065	1976-09-11	1976-09-11 00:00:00	1977-09-06	1977-09-06 00:00:00	1977-09-06	38000177		0	0	360		0	0	0	304774	0	749882	19128065		
5242	440	1713671	2016-08-11	2016-08-11 00:00:00	2016-08-25	2016-08-25 00:00:00	2016-08-25	38000177		0	0	14		0	0	0	29192	0	562251	1713671		
22728	1867	1127078	1977-07-29	1977-07-29 00:00:00	1977-08-12	1977-08-12 00:00:00	1977-08-12	38000177		0	0	14		0	0	0	124706	0	282464	1127078		
84842	1855	40213227	2016-11-11	2016-11-11 00:00:00	2016-11-11	2016-11-11 00:00:00	2016-11-11	581452		0	0	0		0	0	0	\N	0	113	40213227		
5400	452	19059056	1973-09-14	1973-09-14 00:00:00	1973-10-05	1973-10-05 00:00:00	1973-10-05	38000177		0	0	21		0	0	0	30149	0	243670	19059056		
48104	3987	1127433	1989-05-23	1989-05-23 00:00:00	1989-06-06	1989-06-06 00:00:00	1989-06-06	38000177		0	0	14		0	0	0	265042	0	313782	1127433		
61567	5123	19019979	1983-11-03	1983-11-03 00:00:00	1983-11-17	1983-11-17 00:00:00	1983-11-17	38000177		0	0	14		0	0	0	340639	0	198405	19019979		
138578	3044	40213160	1969-04-29	1969-04-29 00:00:00	1969-04-29	1969-04-29 00:00:00	1969-04-29	581452		0	0	0		0	0	0	202596	0	10	40213160		
59886	4977	1367571	2010-12-07	2010-12-07 00:00:00	2010-12-07	2010-12-07 00:00:00	2010-12-07	38000177		0	0	0		0	0	0	331120	0	314659	19080464		
176270	3875	40213160	1962-11-03	1962-11-03 00:00:00	1962-11-03	1962-11-03 00:00:00	1962-11-03	581452		0	0	0		0	0	0	257385	0	10	40213160		
25416	2088	1118084	1945-03-02	1945-03-02 00:00:00	1945-03-02	1945-03-02 00:00:00	\N	38000177		0	0	0		0	0	0	139313	0	00025152531	44923712		
44120	3652	19128022	1994-07-31	1994-07-31 00:00:00	1995-07-26	1995-07-26 00:00:00	1995-07-26	38000177		0	0	360		0	0	0	243083	0	749785	19128022		
108895	2389	40213227	2010-12-14	2010-12-14 00:00:00	2010-12-14	2010-12-14 00:00:00	2010-12-14	581452		0	0	0		0	0	0	158875	0	113	40213227		
70417	1540	40213160	1959-01-05	1959-01-05 00:00:00	1959-01-05	1959-01-05 00:00:00	1959-01-05	581452		0	0	0		0	0	0	103189	0	10	40213160		
2769	222	1115171	2003-09-07	2003-09-07 00:00:00	2003-11-13	2003-11-13 00:00:00	2003-11-13	38000177		0	0	67		0	0	0	14934	0	849574	1115171		
36110	2975	1127433	2004-04-06	2004-04-06 00:00:00	2004-04-13	2004-04-13 00:00:00	2004-04-13	38000177		0	0	7		0	0	0	198643	0	313782	1127433		
217150	4764	40213160	1973-08-01	1973-08-01 00:00:00	1973-08-01	1973-08-01 00:00:00	1973-08-01	581452		0	0	0		0	0	0	317503	0	10	40213160		
139769	3070	40213227	2017-11-05	2017-11-05 00:00:00	2017-11-05	2017-11-05 00:00:00	2017-11-05	581452		0	0	0		0	0	0	204344	0	113	40213227		
54692	1197	40213251	1984-03-11	1984-03-11 00:00:00	1984-03-11	1984-03-11 00:00:00	1984-03-11	581452		0	0	0		0	0	0	78879	0	21	40213251		
114590	2518	40213160	1958-08-01	1958-08-01 00:00:00	1958-08-01	1958-08-01 00:00:00	1958-08-01	581452		0	0	0		0	0	0	166558	0	10	40213160		
186002	4087	40213160	1982-09-29	1982-09-29 00:00:00	1982-09-29	1982-09-29 00:00:00	1982-09-29	581452		0	0	0		0	0	0	271625	0	10	40213160		
26934	2220	19059056	1942-05-15	1942-05-15 00:00:00	1942-05-29	1942-05-29 00:00:00	1942-05-29	38000177		0	0	14		0	0	0	147776	0	243670	19059056		
184339	4051	40213314	1977-06-22	1977-06-22 00:00:00	1977-06-22	1977-06-22 00:00:00	1977-06-22	581452		0	0	0		0	0	0	269246	0	49	40213314		
184408	4052	40213314	1977-06-23	1977-06-23 00:00:00	1977-06-23	1977-06-23 00:00:00	1977-06-23	581452		0	0	0		0	0	0	269351	0	49	40213314		
34627	2860	920334	1996-11-19	1996-11-19 00:00:00	1996-11-26	1996-11-26 00:00:00	1996-11-26	38000177		0	0	7		0	0	0	190125	0	311995	920334		
54383	4521	40231925	1972-05-11	1972-05-11 00:00:00	1972-05-11	1972-05-11 00:00:00	\N	38000177		0	0	0		0	0	0	301012	0	1049221	40231925		
118183	2599	40213314	1978-07-08	1978-07-08 00:00:00	1978-07-08	1978-07-08 00:00:00	1978-07-08	581452		0	0	0		0	0	0	171962	0	49	40213314		
15052	1257	40229134	1987-06-19	1987-06-19 00:00:00	1987-07-03	1987-07-03 00:00:00	1987-07-03	38000177		0	0	14		0	0	0	82845	0	1043400	40229134		
48147	3991	19059056	1947-07-02	1947-07-02 00:00:00	1947-07-16	1947-07-16 00:00:00	1947-07-16	38000177		0	0	14		0	0	0	265398	0	243670	19059056		
4034	334	19133905	1974-09-05	1974-09-05 00:00:00	1974-09-15	1974-09-15 00:00:00	1974-09-15	38000177		0	0	10		0	0	0	22147	0	834102	19133905		
32760	2712	19059056	1966-09-05	1966-09-05 00:00:00	1966-09-19	1966-09-19 00:00:00	1966-09-19	38000177		0	0	14		0	0	0	179860	0	243670	19059056		
19478	1605	19075601	2017-10-22	2017-10-22 00:00:00	2017-10-22	2017-10-22 00:00:00	\N	38000177		0	0	0		0	0	0	107709	0	309362	19075601		
49082	4072	1127078	1975-02-04	1975-02-04 00:00:00	1975-02-18	1975-02-18 00:00:00	1975-02-18	38000177		0	0	14		0	0	0	270684	0	282464	1127078		
19561	1609	19006318	1955-05-19	1955-05-19 00:00:00	1955-06-02	1955-06-02 00:00:00	1955-06-02	38000177		0	0	14		0	0	0	108196	0	105078	19006318		
5964	499	19129655	1961-12-09	1961-12-09 00:00:00	1961-12-23	1961-12-23 00:00:00	1961-12-23	38000177		0	0	14		0	0	0	33401	0	789980	19129655		
48509	4019	40229134	1974-01-29	1974-01-29 00:00:00	1974-02-12	1974-02-12 00:00:00	1974-02-12	38000177		0	0	14		0	0	0	267136	0	1043400	40229134		
63684	5291	1127078	1976-07-15	1976-07-15 00:00:00	1976-07-29	1976-07-29 00:00:00	1976-07-29	38000177		0	0	14		0	0	0	352077	0	282464	1127078		
38029	3144	1127433	1965-02-18	1965-02-18 00:00:00	1965-02-25	1965-02-25 00:00:00	1965-02-25	38000177		0	0	7		0	0	0	209208	0	313782	1127433		
46807	1022	40213227	2015-04-07	2015-04-07 00:00:00	2015-04-07	2015-04-07 00:00:00	2015-04-07	581452		0	0	0		0	0	0	67218	0	113	40213227		
203925	4476	40213160	1962-07-01	1962-07-01 00:00:00	1962-07-01	1962-07-01 00:00:00	1962-07-01	581452		0	0	0		0	0	0	297803	0	10	40213160		
241528	5302	40213160	1976-02-20	1976-02-20 00:00:00	1976-02-20	1976-02-20 00:00:00	1976-02-20	581452		0	0	0		0	0	0	352820	0	10	40213160		
30648	2542	1713671	1969-03-21	1969-03-21 00:00:00	1969-04-11	1969-04-11 00:00:00	1969-04-11	38000177		0	0	21		0	0	0	168075	0	562251	1713671		
3795	316	1127433	1963-06-01	1963-06-01 00:00:00	1963-06-15	1963-06-15 00:00:00	1963-06-15	38000177		0	0	14		0	0	0	20956	0	313782	1127433		
52568	4372	1127078	1985-12-08	1985-12-08 00:00:00	1985-12-22	1985-12-22 00:00:00	1985-12-22	38000177		0	0	14		0	0	0	290211	0	282464	1127078		
39663	865	40213227	2012-11-21	2012-11-21 00:00:00	2012-11-21	2012-11-21 00:00:00	2012-11-21	581452		0	0	0		0	0	0	57357	0	113	40213227		
17273	372	40213306	1984-02-25	1984-02-25 00:00:00	1984-02-25	1984-02-25 00:00:00	1984-02-25	581452		0	0	0		0	0	0	24772	0	43	40213306		
48372	4010	1127078	1982-12-05	1982-12-05 00:00:00	1982-12-19	1982-12-19 00:00:00	1982-12-19	38000177		0	0	14		0	0	0	266456	0	282464	1127078		
12506	1053	46233988	1976-06-28	1976-06-28 00:00:00	1976-07-12	1976-07-12 00:00:00	1976-07-12	38000177		0	0	14		0	0	0	69052	0	1652673	46233988		
146322	3218	40213227	2017-12-31	2017-12-31 00:00:00	2017-12-31	2017-12-31 00:00:00	2017-12-31	581452		0	0	0		0	0	0	213874	0	113	40213227		
131646	2893	40213201	2010-04-07	2010-04-07 00:00:00	2010-04-07	2010-04-07 00:00:00	2010-04-07	581452		0	0	0		0	0	0	192474	0	33	40213201		
117201	2576	40213160	1984-10-18	1984-10-18 00:00:00	1984-10-18	1984-10-18 00:00:00	1984-10-18	581452		0	0	0		0	0	0	170569	0	10	40213160		
63796	5300	19078219	1945-02-13	1945-02-13 00:00:00	1945-02-13	1945-02-13 00:00:00	1945-02-13	38000177		0	0	0		0	0	0	352654	0	56795	19078219		
15503	1292	19059056	1960-05-24	1960-05-24 00:00:00	1960-06-28	1960-06-28 00:00:00	1960-06-28	38000177		0	0	35		0	0	0	85411	0	243670	19059056		
18087	1497	1127433	2007-05-01	2007-05-01 00:00:00	2007-05-15	2007-05-15 00:00:00	2007-05-15	38000177		0	0	14		0	0	0	99922	0	313782	1127433		
6129	133	40213314	1982-02-22	1982-02-22 00:00:00	1982-02-22	1982-02-22 00:00:00	1982-02-22	581452		0	0	0		0	0	0	8981	0	49	40213314		
76263	1666	40213201	2001-06-23	2001-06-23 00:00:00	2001-06-23	2001-06-23 00:00:00	2001-06-23	581452		0	0	0		0	0	0	111856	0	33	40213201		
34721	2868	40229134	2009-05-31	2009-05-31 00:00:00	2009-06-07	2009-06-07 00:00:00	2009-06-07	38000177		0	0	7		0	0	0	190808	0	1043400	40229134		
47305	3921	1127433	1994-02-23	1994-02-23 00:00:00	1994-03-09	1994-03-09 00:00:00	1994-03-09	38000177		0	0	14		0	0	0	260723	0	313782	1127433		
41338	3428	1115171	2004-06-04	2004-06-04 00:00:00	2004-08-03	2004-08-03 00:00:00	2004-08-03	38000177		0	0	60		0	0	0	227262	0	849574	1115171		
41409	3434	1127433	1968-09-06	1968-09-06 00:00:00	1968-09-13	1968-09-13 00:00:00	1968-09-13	38000177		0	0	7		0	0	0	227726	0	313782	1127433		
6814	148	40213314	1979-03-25	1979-03-25 00:00:00	1979-03-25	1979-03-25 00:00:00	1979-03-25	581452		0	0	0		0	0	0	10011	0	49	40213314		
4580	380	19133905	1996-07-16	1996-07-16 00:00:00	1996-07-27	1996-07-27 00:00:00	1996-07-27	38000177		0	0	11		0	0	0	25118	0	834102	19133905		
49882	4139	1127433	2017-05-04	2017-05-04 00:00:00	2017-05-11	2017-05-11 00:00:00	2017-05-11	38000177		0	0	7		0	0	0	275157	0	313782	1127433		
63402	5267	1127433	2008-09-26	2008-09-26 00:00:00	2008-10-03	2008-10-03 00:00:00	2008-10-03	38000177		0	0	7		0	0	0	350399	0	313782	1127433		
55111	4576	19059056	1957-08-12	1957-08-12 00:00:00	1957-09-09	1957-09-09 00:00:00	1957-09-09	38000177		0	0	28		0	0	0	304849	0	243670	19059056		
5243	440	1127078	1975-11-28	1975-11-28 00:00:00	1975-12-26	1975-12-26 00:00:00	1975-12-26	38000177		0	0	28		0	0	0	29169	0	282464	1127078		
22729	1867	19006318	1978-05-06	1978-05-06 00:00:00	1978-05-20	1978-05-20 00:00:00	1978-05-20	38000177		0	0	14		0	0	0	124693	0	105078	19006318		
84843	1855	40213296	2016-11-11	2016-11-11 00:00:00	2016-11-11	2016-11-11 00:00:00	2016-11-11	581452		0	0	0		0	0	0	\N	0	52	40213296		
5401	452	19133873	1973-03-17	1973-03-17 00:00:00	1973-03-24	1973-03-24 00:00:00	1973-03-24	38000177		0	0	7		0	0	0	30085	0	834061	19133873		
48105	3987	19078461	1993-01-21	1993-01-21 00:00:00	1993-02-18	1993-02-18 00:00:00	1993-02-18	38000177		0	0	28		0	0	0	265028	0	310965	19078461		
61568	5123	19133873	1990-03-14	1990-03-14 00:00:00	1990-03-26	1990-03-26 00:00:00	1990-03-26	38000177		0	0	12		0	0	0	340637	0	834061	19133873		
138581	3044	40213227	2000-04-04	2000-04-04 00:00:00	2000-04-04	2000-04-04 00:00:00	2000-04-04	581452		0	0	0		0	0	0	202634	0	113	40213227		
59887	4977	46275444	2010-12-08	2010-12-08 00:00:00	2010-12-08	2010-12-08 00:00:00	2010-12-08	38000177		0	0	0		0	0	0	331120	0	1659149	46275444		
176278	3875	40213306	1982-02-20	1982-02-20 00:00:00	1982-02-20	1982-02-20 00:00:00	1982-02-20	581452		0	0	0		0	0	0	257371	0	43	40213306		
25417	2088	1713671	1990-01-22	1990-01-22 00:00:00	1990-02-12	1990-02-12 00:00:00	1990-02-12	38000177		0	0	21		0	0	0	139262	0	562251	1713671		
44121	3652	19128065	1996-07-20	1996-07-20 00:00:00	1997-07-15	1997-07-15 00:00:00	1997-07-15	38000177		0	0	360		0	0	0	243084	0	749882	19128065		
108902	2389	40213306	1990-11-20	1990-11-20 00:00:00	1990-11-20	1990-11-20 00:00:00	1990-11-20	581452		0	0	0		0	0	0	158899	0	43	40213306		
70422	1540	40213260	2008-07-28	2008-07-28 00:00:00	2008-07-28	2008-07-28 00:00:00	2008-07-28	581452		0	0	0		0	0	0	103209	0	121	40213260		
2777	224	19133873	1959-07-04	1959-07-04 00:00:00	1959-07-17	1959-07-17 00:00:00	1959-07-17	38000177		0	0	13		0	0	0	15084	0	834061	19133873		
36111	2975	1713671	1976-03-01	1976-03-01 00:00:00	1976-03-08	1976-03-08 00:00:00	1976-03-08	38000177		0	0	7		0	0	0	198660	0	562251	1713671		
217152	4764	40213296	2009-08-05	2009-08-05 00:00:00	2009-08-05	2009-08-05 00:00:00	2009-08-05	581452		0	0	0		0	0	0	317515	0	52	40213296		
139770	3070	40213260	2017-11-05	2017-11-05 00:00:00	2017-11-05	2017-11-05 00:00:00	2017-11-05	581452		0	0	0		0	0	0	204344	0	121	40213260		
54700	1197	40213314	1978-11-12	1978-11-12 00:00:00	1978-11-12	1978-11-12 00:00:00	1978-11-12	581452		0	0	0		0	0	0	78850	0	49	40213314		
114605	2518	40213198	2019-02-08	2019-02-08 00:00:00	2019-02-08	2019-02-08 00:00:00	2019-02-08	581452		0	0	0		0	0	0	166528	0	133	40213198		
186007	4087	40213160	1978-06-28	1978-06-28 00:00:00	1978-06-28	1978-06-28 00:00:00	1978-06-28	581452		0	0	0		0	0	0	271630	0	10	40213160		
57292	4755	1713671	1973-08-30	1973-08-30 00:00:00	1973-09-13	1973-09-13 00:00:00	1973-09-13	38000177		0	0	14		0	0	0	316764	0	562251	1713671		
146739	3227	40213227	2002-05-14	2002-05-14 00:00:00	2002-05-14	2002-05-14 00:00:00	2002-05-14	581452		0	0	0		0	0	0	214520	0	113	40213227		
184412	4052	40213296	2016-04-21	2016-04-21 00:00:00	2016-04-21	2016-04-21 00:00:00	2016-04-21	581452		0	0	0		0	0	0	269385	0	52	40213296		
34628	2860	920300	1996-11-12	1996-11-12 00:00:00	1996-11-19	1996-11-19 00:00:00	1996-11-19	38000177		0	0	7		0	0	0	190103	0	311989	920300		
54384	4521	19059056	1972-05-11	1972-05-11 00:00:00	1972-08-09	1972-08-09 00:00:00	1972-08-09	38000177		0	0	90		0	0	0	301012	0	243670	19059056		
118184	2599	40213160	1978-07-08	1978-07-08 00:00:00	1978-07-08	1978-07-08 00:00:00	1978-07-08	581452		0	0	0		0	0	0	171962	0	10	40213160		
15053	1257	1124300	2010-03-08	2010-03-08 00:00:00	2010-03-08	2010-03-08 00:00:00	\N	38000177		0	0	0		0	0	0	82816	0	00781178901	45011828		
48148	3991	1127433	1994-01-17	1994-01-17 00:00:00	1994-01-31	1994-01-31 00:00:00	1994-01-31	38000177		0	0	14		0	0	0	265344	0	313782	1127433		
4035	334	1127433	1962-11-12	1962-11-12 00:00:00	1962-11-26	1962-11-26 00:00:00	1962-11-26	38000177		0	0	14		0	0	0	22145	0	313782	1127433		
32761	2712	19129655	1966-09-05	1966-09-05 00:00:00	1966-09-19	1966-09-19 00:00:00	1966-09-19	38000177		0	0	14		0	0	0	179860	0	789980	19129655		
19479	1605	1539411	2017-10-22	2017-10-22 00:00:00	2017-10-22	2017-10-22 00:00:00	\N	38000177		0	0	0		0	0	0	107709	0	312961	1539411		
49083	4072	40229134	1995-10-18	1995-10-18 00:00:00	1995-11-01	1995-11-01 00:00:00	1995-11-01	38000177		0	0	14		0	0	0	270694	0	1043400	40229134		
19562	1609	1127433	1993-10-13	1993-10-13 00:00:00	1994-01-10	1994-01-10 00:00:00	1994-01-10	38000177		0	0	89		0	0	0	108163	0	313782	1127433		
5965	499	19059056	1961-12-09	1961-12-09 00:00:00	1961-12-23	1961-12-23 00:00:00	1961-12-23	38000177		0	0	14		0	0	0	33401	0	243670	19059056		
48510	4019	40229134	2012-03-06	2012-03-06 00:00:00	2012-03-20	2012-03-20 00:00:00	2012-03-20	38000177		0	0	14		0	0	0	267141	0	1043400	40229134		
63685	5291	40229134	2007-09-05	2007-09-05 00:00:00	2007-09-12	2007-09-12 00:00:00	2007-09-12	38000177		0	0	7		0	0	0	352067	0	1043400	40229134		
38030	3144	40229134	1992-03-10	1992-03-10 00:00:00	1992-03-24	1992-03-24 00:00:00	1992-03-24	38000177		0	0	14		0	0	0	209212	0	1043400	40229134		
114991	2526	40213227	2006-08-14	2006-08-14 00:00:00	2006-08-14	2006-08-14 00:00:00	2006-08-14	581452		0	0	0		0	0	0	167021	0	113	40213227		
203930	4477	40213160	1964-07-30	1964-07-30 00:00:00	1964-07-30	1964-07-30 00:00:00	1964-07-30	581452		0	0	0		0	0	0	297970	0	10	40213160		
241539	5302	40213227	2004-08-13	2004-08-13 00:00:00	2004-08-13	2004-08-13 00:00:00	2004-08-13	581452		0	0	0		0	0	0	352765	0	113	40213227		
30649	2542	1127433	1980-03-02	1980-03-02 00:00:00	1980-04-01	1980-04-01 00:00:00	1980-04-01	38000177		0	0	30		0	0	0	168091	0	313782	1127433		
3796	316	1127433	1932-12-04	1932-12-04 00:00:00	1932-12-18	1932-12-18 00:00:00	1932-12-18	38000177		0	0	14		0	0	0	20953	0	313782	1127433		
52569	4372	1551192	1981-01-03	1981-01-03 00:00:00	1981-01-03	1981-01-03 00:00:00	1981-01-03	38000177		0	0	0		0	0	0	290259	0	312617	1551192		
39677	866	40213160	1958-12-21	1958-12-21 00:00:00	1958-12-21	1958-12-21 00:00:00	1958-12-21	581452		0	0	0		0	0	0	57480	0	10	40213160		
17275	372	40213260	2011-05-14	2011-05-14 00:00:00	2011-05-14	2011-05-14 00:00:00	2011-05-14	581452		0	0	0		0	0	0	24783	0	121	40213260		
48374	4010	40229134	2006-01-13	2006-01-13 00:00:00	2006-01-20	2006-01-20 00:00:00	2006-01-20	38000177		0	0	7		0	0	0	266494	0	1043400	40229134		
12507	1053	1127078	1976-06-28	1976-06-28 00:00:00	1976-07-12	1976-07-12 00:00:00	1976-07-12	38000177		0	0	14		0	0	0	69052	0	282464	1127078		
117067	2572	40213160	1974-06-04	1974-06-04 00:00:00	1974-06-04	1974-06-04 00:00:00	1974-06-04	581452		0	0	0		0	0	0	170354	0	10	40213160		
131648	2893	40213227	1995-01-11	1995-01-11 00:00:00	1995-01-11	1995-01-11 00:00:00	1995-01-11	581452		0	0	0		0	0	0	192469	0	113	40213227		
146372	3219	40213160	1980-06-28	1980-06-28 00:00:00	1980-06-28	1980-06-28 00:00:00	1980-06-28	581452		0	0	0		0	0	0	213921	0	10	40213160		
63797	5300	19079524	1945-02-13	1945-02-13 00:00:00	1945-02-14	1945-02-14 00:00:00	1945-02-14	38000177		0	0	1		0	0	0	352654	0	313002	19079524		
15504	1292	1551192	1960-09-21	1960-09-21 00:00:00	1960-09-21	1960-09-21 00:00:00	1960-09-21	38000177		0	0	0		0	0	0	85412	0	312617	1551192		
18088	1497	1124300	1974-07-25	1974-07-25 00:00:00	1974-07-25	1974-07-25 00:00:00	\N	38000177		0	0	0		0	0	0	99827	0	00781178901	45011828		
160840	3539	40213227	2003-08-29	2003-08-29 00:00:00	2003-08-29	2003-08-29 00:00:00	2003-08-29	581452		0	0	0		0	0	0	235068	0	113	40213227		
47183	3913	19008572	1981-10-23	1981-10-23 00:00:00	1981-10-23	1981-10-23 00:00:00	\N	38000177		0	0	0		0	0	0	260078	0	106258	19008572		
34722	2868	1127078	1967-10-20	1967-10-20 00:00:00	1967-11-03	1967-11-03 00:00:00	1967-11-03	38000177		0	0	14		0	0	0	190809	0	282464	1127078		
47306	3921	1127078	1983-08-14	1983-08-14 00:00:00	1983-08-28	1983-08-28 00:00:00	1983-08-28	38000177		0	0	14		0	0	0	260729	0	282464	1127078		
41339	3428	40231925	2004-06-04	2004-06-04 00:00:00	2004-06-04	2004-06-04 00:00:00	\N	38000177		0	0	0		0	0	0	227262	0	1049221	40231925		
41410	3434	1127433	1973-06-21	1973-06-21 00:00:00	1973-07-05	1973-07-05 00:00:00	1973-07-05	38000177		0	0	14		0	0	0	227696	0	313782	1127433		
6817	148	40213306	2000-10-22	2000-10-22 00:00:00	2000-10-22	2000-10-22 00:00:00	2000-10-22	581452		0	0	0		0	0	0	10003	0	43	40213306		
91982	2020	40213160	1971-04-10	1971-04-10 00:00:00	1971-04-10	1971-04-10 00:00:00	1971-04-10	581452		0	0	0		0	0	0	134286	0	10	40213160		
49883	4139	1127078	1971-07-04	1971-07-04 00:00:00	1971-07-18	1971-07-18 00:00:00	1971-07-18	38000177		0	0	14		0	0	0	275137	0	282464	1127078		
63403	5267	19133873	1979-03-04	1979-03-04 00:00:00	1979-03-16	1979-03-16 00:00:00	1979-03-16	38000177		0	0	12		0	0	0	350355	0	834061	19133873		
55112	4576	1127433	1955-10-23	1955-10-23 00:00:00	1955-10-30	1955-10-30 00:00:00	1955-10-30	38000177		0	0	7		0	0	0	304852	0	313782	1127433		
5244	440	40224805	1994-10-29	1994-10-29 00:00:00	1995-10-24	1995-10-24 00:00:00	1995-10-24	38000177		0	0	360		0	0	0	29194	0	1000126	40224805		
22730	1867	19019979	1978-05-06	1978-05-06 00:00:00	1978-05-20	1978-05-20 00:00:00	1978-05-20	38000177		0	0	14		0	0	0	124693	0	198405	19019979		
84845	1855	40213160	1975-06-27	1975-06-27 00:00:00	1975-06-27	1975-06-27 00:00:00	1975-06-27	581452		0	0	0		0	0	0	124153	0	10	40213160		
5402	452	19133905	2003-08-28	2003-08-28 00:00:00	2003-09-06	2003-09-06 00:00:00	2003-09-06	38000177		0	0	9		0	0	0	30105	0	834102	19133905		
48106	3987	1127078	1964-11-19	1964-11-19 00:00:00	1965-02-17	1965-02-17 00:00:00	1965-02-17	38000177		0	0	90		0	0	0	265027	0	282464	1127078		
61569	5123	1115171	1994-09-11	1994-09-11 00:00:00	1994-12-10	1994-12-10 00:00:00	1994-12-10	38000177		0	0	90		0	0	0	340686	0	849574	1115171		
68427	1498	40213306	1986-05-20	1986-05-20 00:00:00	1986-05-20	1986-05-20 00:00:00	1986-05-20	581452		0	0	0		0	0	0	99964	0	43	40213306		
59888	4977	35605858	2010-12-07	2010-12-07 00:00:00	2010-12-08	2010-12-08 00:00:00	2010-12-08	38000177		0	0	1		0	0	0	331120	0	1732136	35605858		
176282	3875	40213296	2001-09-08	2001-09-08 00:00:00	2001-09-08	2001-09-08 00:00:00	2001-09-08	581452		0	0	0		0	0	0	257339	0	52	40213296		
25418	2088	40229134	1915-12-29	1915-12-29 00:00:00	1916-01-05	1916-01-05 00:00:00	1916-01-05	38000177		0	0	7		0	0	0	139164	0	1043400	40229134		
44122	3652	19128022	1992-08-10	1992-08-10 00:00:00	1993-08-05	1993-08-05 00:00:00	1993-08-05	38000177		0	0	360		0	0	0	243125	0	749785	19128022		
108903	2389	40213227	1993-11-23	1993-11-23 00:00:00	1993-11-23	1993-11-23 00:00:00	1993-11-23	581452		0	0	0		0	0	0	158872	0	113	40213227		
70425	1540	40213160	1962-08-20	1962-08-20 00:00:00	1962-08-20	1962-08-20 00:00:00	1962-08-20	581452		0	0	0		0	0	0	103163	0	10	40213160		
2778	224	19078461	2010-06-19	2010-06-19 00:00:00	2010-07-19	2010-07-19 00:00:00	2010-07-19	38000177		0	0	30		0	0	0	15111	0	310965	19078461		
36112	2975	1713671	1988-10-06	1988-10-06 00:00:00	1988-10-13	1988-10-13 00:00:00	1988-10-13	38000177		0	0	7		0	0	0	198624	0	562251	1713671		
217158	4764	40213160	1968-11-27	1968-11-27 00:00:00	1968-11-27	1968-11-27 00:00:00	1968-11-27	581452		0	0	0		0	0	0	317500	0	10	40213160		
139774	3070	40213306	1989-08-06	1989-08-06 00:00:00	1989-08-06	1989-08-06 00:00:00	1989-08-06	581452		0	0	0		0	0	0	204339	0	43	40213306		
54701	1197	40213160	1978-11-12	1978-11-12 00:00:00	1978-11-12	1978-11-12 00:00:00	1978-11-12	581452		0	0	0		0	0	0	78850	0	10	40213160		
114606	2518	40213160	1955-01-28	1955-01-28 00:00:00	1955-01-28	1955-01-28 00:00:00	1955-01-28	581452		0	0	0		0	0	0	166523	0	10	40213160		
154297	3397	40213227	1995-08-19	1995-08-19 00:00:00	1995-08-19	1995-08-19 00:00:00	1995-08-19	581452		0	0	0		0	0	0	225365	0	113	40213227		
57293	4755	40229134	1941-07-27	1941-07-27 00:00:00	1941-08-03	1941-08-03 00:00:00	1941-08-03	38000177		0	0	7		0	0	0	316754	0	1043400	40229134		
146742	3227	40213306	1990-05-01	1990-05-01 00:00:00	1990-05-01	1990-05-01 00:00:00	1990-05-01	581452		0	0	0		0	0	0	214554	0	43	40213306		
184415	4052	40213227	2007-08-23	2007-08-23 00:00:00	2007-08-23	2007-08-23 00:00:00	2007-08-23	581452		0	0	0		0	0	0	269403	0	113	40213227		
34629	2860	40236824	1996-11-12	1996-11-12 00:00:00	1996-11-26	1996-11-26 00:00:00	1996-11-26	38000177		0	0	14		0	0	0	190103	0	1094107	40236824		
54385	4521	1713671	1976-11-22	1976-11-22 00:00:00	1976-11-29	1976-11-29 00:00:00	1976-11-29	38000177		0	0	7		0	0	0	301020	0	562251	1713671		
201234	4419	40213160	1956-04-30	1956-04-30 00:00:00	1956-04-30	1956-04-30 00:00:00	1956-04-30	581452		0	0	0		0	0	0	293824	0	10	40213160		
15054	1257	19133873	1976-02-28	1976-02-28 00:00:00	1976-03-09	1976-03-09 00:00:00	1976-03-09	38000177		0	0	10		0	0	0	82843	0	834061	19133873		
48149	3991	1713671	1988-08-06	1988-08-06 00:00:00	1988-08-20	1988-08-20 00:00:00	1988-08-20	38000177		0	0	14		0	0	0	265383	0	562251	1713671		
4036	334	40229134	1982-08-26	1982-08-26 00:00:00	1982-09-02	1982-09-02 00:00:00	1982-09-02	38000177		0	0	7		0	0	0	22128	0	1043400	40229134		
32762	2712	1713671	1988-09-08	1988-09-08 00:00:00	1988-09-29	1988-09-29 00:00:00	1988-09-29	38000177		0	0	21		0	0	0	179827	0	562251	1713671		
19480	1605	1332419	2017-10-22	2017-10-22 00:00:00	2017-10-22	2017-10-22 00:00:00	\N	38000177		0	0	0		0	0	0	107709	0	197361	1332419		
49084	4072	1127433	2013-12-09	2013-12-09 00:00:00	2013-12-23	2013-12-23 00:00:00	2013-12-23	38000177		0	0	14		0	0	0	270691	0	313782	1127433		
19563	1609	19059056	1950-10-13	1950-10-13 00:00:00	1950-11-03	1950-11-03 00:00:00	1950-11-03	38000177		0	0	21		0	0	0	108158	0	243670	19059056		
5966	499	40169216	1962-04-30	1962-04-30 00:00:00	1962-04-30	1962-04-30 00:00:00	\N	38000177		0	0	0		0	0	0	33344	0	895994	40169216		
48511	4019	19059056	1987-10-31	1987-10-31 00:00:00	1987-11-21	1987-11-21 00:00:00	1987-11-21	38000177		0	0	21		0	0	0	267170	0	243670	19059056		
35435	774	40213296	2010-05-17	2010-05-17 00:00:00	2010-05-17	2010-05-17 00:00:00	2010-05-17	581452		0	0	0		0	0	0	51370	0	52	40213296		
38031	3144	40236824	1998-06-24	1998-06-24 00:00:00	1998-07-08	1998-07-08 00:00:00	1998-07-08	38000177		0	0	14		0	0	0	209213	0	1094107	40236824		
97280	2133	40213260	2015-06-08	2015-06-08 00:00:00	2015-06-08	2015-06-08 00:00:00	2015-06-08	581452		0	0	0		0	0	0	141892	0	121	40213260		
203932	4477	40213160	1968-10-31	1968-10-31 00:00:00	1968-10-31	1968-10-31 00:00:00	1968-10-31	581452		0	0	0		0	0	0	297959	0	10	40213160		
241540	5302	40213306	1995-08-04	1995-08-04 00:00:00	1995-08-04	1995-08-04 00:00:00	1995-08-04	581452		0	0	0		0	0	0	352775	0	43	40213306		
30650	2542	40229134	1994-10-11	1994-10-11 00:00:00	1994-10-18	1994-10-18 00:00:00	1994-10-18	38000177		0	0	7		0	0	0	168198	0	1043400	40229134		
178642	3927	40213227	1998-02-03	1998-02-03 00:00:00	1998-02-03	1998-02-03 00:00:00	1998-02-03	581452		0	0	0		0	0	0	261084	0	113	40213227		
52570	4372	19128022	1994-05-05	1994-05-05 00:00:00	1995-04-30	1995-04-30 00:00:00	1995-04-30	38000177		0	0	360		0	0	0	290231	0	749785	19128022		
39680	866	40213160	1959-02-22	1959-02-22 00:00:00	1959-02-22	1959-02-22 00:00:00	1959-02-22	581452		0	0	0		0	0	0	57470	0	10	40213160		
170554	3750	40213296	2001-10-27	2001-10-27 00:00:00	2001-10-27	2001-10-27 00:00:00	2001-10-27	581452		0	0	0		0	0	0	249234	0	52	40213296		
48375	4010	1124300	2012-12-17	2012-12-17 00:00:00	2012-12-17	2012-12-17 00:00:00	\N	38000177		0	0	0		0	0	0	266522	0	00781178901	45011828		
12508	1053	19074679	1982-12-03	1982-12-03 00:00:00	1983-05-06	1983-05-06 00:00:00	1983-05-06	38000177		0	0	154		0	0	0	69039	0	308971	19074679		
197618	4342	40213227	1998-08-14	1998-08-14 00:00:00	1998-08-14	1998-08-14 00:00:00	1998-08-14	581452		0	0	0		0	0	0	287867	0	113	40213227		
131654	2893	40213227	2015-05-06	2015-05-06 00:00:00	2015-05-06	2015-05-06 00:00:00	2015-05-06	581452		0	0	0		0	0	0	192510	0	113	40213227		
146388	3219	40213160	1984-12-29	1984-12-29 00:00:00	1984-12-29	1984-12-29 00:00:00	1984-12-29	581452		0	0	0		0	0	0	213924	0	10	40213160		
63798	5300	42707627	1945-02-13	1945-02-13 00:00:00	1945-02-13	1945-02-13 00:00:00	1945-02-13	38000177		0	0	0		0	0	0	352654	0	1234995	42707627		
15505	1292	1127433	1987-01-20	1987-01-20 00:00:00	1987-02-17	1987-02-17 00:00:00	1987-02-17	38000177		0	0	28		0	0	0	85416	0	313782	1127433		
18089	1497	19059056	1942-06-16	1942-06-16 00:00:00	1942-06-30	1942-06-30 00:00:00	1942-06-30	38000177		0	0	14		0	0	0	99908	0	243670	19059056		
160841	3539	40213306	2003-08-29	2003-08-29 00:00:00	2003-08-29	2003-08-29 00:00:00	2003-08-29	581452		0	0	0		0	0	0	235068	0	43	40213306		
47184	3913	1115171	2017-11-12	2017-11-12 00:00:00	2017-11-26	2017-11-26 00:00:00	2017-11-26	38000177		0	0	14		0	0	0	260089	0	849574	1115171		
34723	2868	46233988	1967-10-20	1967-10-20 00:00:00	1967-11-03	1967-11-03 00:00:00	1967-11-03	38000177		0	0	14		0	0	0	190809	0	1652673	46233988		
47307	3921	19073183	1983-08-14	1983-08-14 00:00:00	1983-08-28	1983-08-28 00:00:00	1983-08-28	38000177		0	0	14		0	0	0	260729	0	308182	19073183		
41340	3428	1127433	1978-07-22	1978-07-22 00:00:00	1978-08-05	1978-08-05 00:00:00	1978-08-05	38000177		0	0	14		0	0	0	227249	0	313782	1127433		
41411	3434	19059056	1954-01-10	1954-01-10 00:00:00	1954-01-24	1954-01-24 00:00:00	1954-01-24	38000177		0	0	14		0	0	0	227756	0	243670	19059056		
6819	148	40213227	2000-10-22	2000-10-22 00:00:00	2000-10-22	2000-10-22 00:00:00	2000-10-22	581452		0	0	0		0	0	0	10003	0	113	40213227		
91985	2020	40213227	2013-01-26	2013-01-26 00:00:00	2013-01-26	2013-01-26 00:00:00	2013-01-26	581452		0	0	0		0	0	0	134306	0	113	40213227		
49884	4139	1115171	2016-01-23	2016-01-23 00:00:00	2016-02-27	2016-02-27 00:00:00	2016-02-27	38000177		0	0	35		0	0	0	275165	0	849574	1115171		
63404	5267	19128065	1984-11-09	1984-11-09 00:00:00	1985-11-04	1985-11-04 00:00:00	1985-11-04	38000177		0	0	360		0	0	0	350401	0	749882	19128065		
8773	188	40213296	2002-11-24	2002-11-24 00:00:00	2002-11-24	2002-11-24 00:00:00	2002-11-24	581452		0	0	0		0	0	0	12810	0	52	40213296		
48997	1073	40213227	2018-04-12	2018-04-12 00:00:00	2018-04-12	2018-04-12 00:00:00	2018-04-12	581452		0	0	0		0	0	0	70355	0	113	40213227		
22731	1867	40229134	1983-04-28	1983-04-28 00:00:00	1983-05-05	1983-05-05 00:00:00	1983-05-05	38000177		0	0	7		0	0	0	124703	0	1043400	40229134		
96130	2108	40213227	1992-09-25	1992-09-25 00:00:00	1992-09-25	1992-09-25 00:00:00	1992-09-25	581452		0	0	0		0	0	0	140303	0	113	40213227		
5403	452	40229134	2017-10-27	2017-10-27 00:00:00	2017-11-10	2017-11-10 00:00:00	2017-11-10	38000177		0	0	14		0	0	0	30127	0	1043400	40229134		
48107	3987	19078461	2010-04-20	2010-04-20 00:00:00	2010-05-20	2010-05-20 00:00:00	2010-05-20	38000177		0	0	30		0	0	0	265030	0	310965	19078461		
61570	5123	1124300	2016-08-06	2016-08-06 00:00:00	2016-08-06	2016-08-06 00:00:00	\N	38000177		0	0	0		0	0	0	340683	0	00781178901	45011828		
68429	1498	40213296	2006-03-27	2006-03-27 00:00:00	2006-03-27	2006-03-27 00:00:00	2006-03-27	581452		0	0	0		0	0	0	99928	0	52	40213296		
59889	4977	42707627	2010-12-08	2010-12-08 00:00:00	2010-12-08	2010-12-08 00:00:00	2010-12-08	38000177		0	0	0		0	0	0	331120	0	1234995	42707627		
716	16	40213160	1972-03-22	1972-03-22 00:00:00	1972-03-22	1972-03-22 00:00:00	1972-03-22	581452		0	0	0		0	0	0	1197	0	10	40213160		
25419	2088	1127433	1930-05-09	1930-05-09 00:00:00	1930-05-16	1930-05-16 00:00:00	1930-05-16	38000177		0	0	7		0	0	0	139226	0	313782	1127433		
44123	3652	19133873	1978-04-06	1978-04-06 00:00:00	1978-04-16	1978-04-16 00:00:00	1978-04-16	38000177		0	0	10		0	0	0	243079	0	834061	19133873		
108908	2389	40213160	1974-03-12	1974-03-12 00:00:00	1974-03-12	1974-03-12 00:00:00	1974-03-12	581452		0	0	0		0	0	0	158851	0	10	40213160		
37872	826	40213160	1959-03-26	1959-03-26 00:00:00	1959-03-26	1959-03-26 00:00:00	1959-03-26	581452		0	0	0		0	0	0	54725	0	10	40213160		
2779	224	1127433	2008-02-27	2008-02-27 00:00:00	2008-03-12	2008-03-12 00:00:00	2008-03-12	38000177		0	0	14		0	0	0	15039	0	313782	1127433		
36113	2976	1127433	1966-08-26	1966-08-26 00:00:00	1966-09-09	1966-09-09 00:00:00	1966-09-09	38000177		0	0	14		0	0	0	198704	0	313782	1127433		
217174	4764	40213227	2011-08-10	2011-08-10 00:00:00	2011-08-10	2011-08-10 00:00:00	2011-08-10	581452		0	0	0		0	0	0	317466	0	113	40213227		
139776	3070	40213160	1967-06-04	1967-06-04 00:00:00	1967-06-04	1967-06-04 00:00:00	1967-06-04	581452		0	0	0		0	0	0	204390	0	10	40213160		
54703	1197	40213296	2018-06-10	2018-06-10 00:00:00	2018-06-10	2018-06-10 00:00:00	2018-06-10	581452		0	0	0		0	0	0	78841	0	52	40213296		
114612	2518	40213227	2005-08-19	2005-08-19 00:00:00	2005-08-19	2005-08-19 00:00:00	2005-08-19	581452		0	0	0		0	0	0	166591	0	113	40213227		
24290	528	40213260	2009-05-29	2009-05-29 00:00:00	2009-05-29	2009-05-29 00:00:00	2009-05-29	581452		0	0	0		0	0	0	35203	0	121	40213260		
57294	4755	19059056	1925-12-02	1925-12-02 00:00:00	1926-03-02	1926-03-02 00:00:00	1926-03-02	38000177		0	0	90		0	0	0	316706	0	243670	19059056		
146744	3227	40213296	2012-05-29	2012-05-29 00:00:00	2012-05-29	2012-05-29 00:00:00	2012-05-29	581452		0	0	0		0	0	0	214541	0	52	40213296		
184417	4052	40213251	1984-04-12	1984-04-12 00:00:00	1984-04-12	1984-04-12 00:00:00	1984-04-12	581452		0	0	0		0	0	0	269315	0	21	40213251		
34630	2861	1118084	2006-10-10	2006-10-10 00:00:00	2006-10-10	2006-10-10 00:00:00	\N	38000177		0	0	0		0	0	0	190232	0	00025152531	44923712		
54386	4521	1713671	1950-06-28	1950-06-28 00:00:00	1950-07-12	1950-07-12 00:00:00	1950-07-12	38000177		0	0	14		0	0	0	300962	0	562251	1713671		
201241	4419	40213160	1960-08-01	1960-08-01 00:00:00	1960-08-01	1960-08-01 00:00:00	1960-08-01	581452		0	0	0		0	0	0	293839	0	10	40213160		
15055	1257	1713671	2015-02-01	2015-02-01 00:00:00	2015-03-29	2015-03-29 00:00:00	2015-03-29	38000177		0	0	56		0	0	0	82831	0	562251	1713671		
48150	3991	1118084	1981-08-11	1981-08-11 00:00:00	1981-08-11	1981-08-11 00:00:00	\N	38000177		0	0	0		0	0	0	265359	0	00025152531	44923712		
2994	244	1127433	1974-10-16	1974-10-16 00:00:00	1974-10-30	1974-10-30 00:00:00	1974-10-30	38000177		0	0	14		0	0	0	16284	0	313782	1127433		
95051	2084	40213306	1984-12-12	1984-12-12 00:00:00	1984-12-12	1984-12-12 00:00:00	1984-12-12	581452		0	0	0		0	0	0	138868	0	43	40213306		
19481	1605	1713671	2003-09-10	2003-09-10 00:00:00	2003-10-01	2003-10-01 00:00:00	2003-10-01	38000177		0	0	21		0	0	0	107780	0	562251	1713671		
16872	1397	19128065	1990-11-16	1990-11-16 00:00:00	1991-11-11	1991-11-11 00:00:00	1991-11-11	38000177		0	0	360		0	0	0	92845	0	749882	19128065		
19564	1609	19059056	1943-06-23	1943-06-23 00:00:00	1943-07-07	1943-07-07 00:00:00	1943-07-07	38000177		0	0	14		0	0	0	108194	0	243670	19059056		
5967	499	1154615	1962-04-30	1962-04-30 00:00:00	1962-04-30	1962-04-30 00:00:00	\N	38000177		0	0	0		0	0	0	33344	0	745679	1154615		
48512	4019	1127433	1988-04-05	1988-04-05 00:00:00	1988-04-12	1988-04-12 00:00:00	1988-04-12	38000177		0	0	7		0	0	0	267137	0	313782	1127433		
35437	774	40213260	2017-05-22	2017-05-22 00:00:00	2017-05-22	2017-05-22 00:00:00	2017-05-22	581452		0	0	0		0	0	0	\N	0	121	40213260		
38032	3144	1127078	1966-01-02	1966-01-02 00:00:00	1966-01-16	1966-01-16 00:00:00	1966-01-16	38000177		0	0	14		0	0	0	209215	0	282464	1127078		
97281	2133	40213160	1965-11-15	1965-11-15 00:00:00	1965-11-15	1965-11-15 00:00:00	1965-11-15	581452		0	0	0		0	0	0	141940	0	10	40213160		
203935	4477	40213160	1964-02-27	1964-02-27 00:00:00	1964-02-27	1964-02-27 00:00:00	1964-02-27	581452		0	0	0		0	0	0	297969	0	10	40213160		
241542	5302	40213227	1995-08-04	1995-08-04 00:00:00	1995-08-04	1995-08-04 00:00:00	1995-08-04	581452		0	0	0		0	0	0	352775	0	113	40213227		
13791	298	40213227	2014-01-14	2014-01-14 00:00:00	2014-01-14	2014-01-14 00:00:00	2014-01-14	581452		0	0	0		0	0	0	19899	0	113	40213227		
199381	4380	40213260	2015-04-27	2015-04-27 00:00:00	2015-04-27	2015-04-27 00:00:00	2015-04-27	581452		0	0	0		0	0	0	291063	0	121	40213260		
52571	4372	920300	2009-05-28	2009-05-28 00:00:00	2009-06-04	2009-06-04 00:00:00	2009-06-04	38000177		0	0	7		0	0	0	290291	0	311989	920300		
39682	866	40213160	1963-08-25	1963-08-25 00:00:00	1963-08-25	1963-08-25 00:00:00	1963-08-25	581452		0	0	0		0	0	0	57448	0	10	40213160		
170560	3750	40213260	2010-12-18	2010-12-18 00:00:00	2010-12-18	2010-12-18 00:00:00	2010-12-18	581452		0	0	0		0	0	0	249205	0	121	40213260		
48376	4010	19128022	1997-03-31	1997-03-31 00:00:00	1998-03-26	1998-03-26 00:00:00	1998-03-26	38000177		0	0	360		0	0	0	266520	0	749785	19128022		
12509	1053	40236824	2014-02-25	2014-02-25 00:00:00	2014-03-04	2014-03-04 00:00:00	2014-03-04	38000177		0	0	7		0	0	0	69008	0	1094107	40236824		
197619	4342	40213296	1998-08-14	1998-08-14 00:00:00	1998-08-14	1998-08-14 00:00:00	1998-08-14	581452		0	0	0		0	0	0	287867	0	52	40213296		
216437	4750	40213160	1968-03-20	1968-03-20 00:00:00	1968-03-20	1968-03-20 00:00:00	1968-03-20	581452		0	0	0		0	0	0	316390	0	10	40213160		
146389	3219	40213251	1984-12-29	1984-12-29 00:00:00	1984-12-29	1984-12-29 00:00:00	1984-12-29	581452		0	0	0		0	0	0	213924	0	21	40213251		
63799	5300	35605858	1945-02-13	1945-02-13 00:00:00	1945-02-13	1945-02-13 00:00:00	1945-02-13	38000177		0	0	0		0	0	0	352654	0	1732136	35605858		
15506	1292	40232448	1954-09-04	1954-09-04 00:00:00	1954-09-04	1954-09-04 00:00:00	\N	38000177		0	0	0		0	0	0	85418	0	1049630	40232448		
18090	1497	1713671	2006-05-14	2006-05-14 00:00:00	2006-05-21	2006-05-21 00:00:00	2006-05-21	38000177		0	0	7		0	0	0	99754	0	562251	1713671		
160845	3539	40213160	1981-08-21	1981-08-21 00:00:00	1981-08-21	1981-08-21 00:00:00	1981-08-21	581452		0	0	0		0	0	0	235086	0	10	40213160		
47185	3913	1713671	1966-10-05	1966-10-05 00:00:00	1967-04-12	1967-04-12 00:00:00	1967-04-12	38000177		0	0	189		0	0	0	260136	0	562251	1713671		
34725	2868	19128065	1988-08-04	1988-08-04 00:00:00	1989-07-30	1989-07-30 00:00:00	1989-07-30	38000177		0	0	360		0	0	0	190787	0	749882	19128065		
47308	3921	19128022	1995-11-08	1995-11-08 00:00:00	1996-11-02	1996-11-02 00:00:00	1996-11-02	38000177		0	0	360		0	0	0	260739	0	749785	19128022		
41341	3428	19133873	1970-06-05	1970-06-05 00:00:00	1970-06-15	1970-06-15 00:00:00	1970-06-15	38000177		0	0	10		0	0	0	227248	0	834061	19133873		
41412	3434	19006318	1954-01-10	1954-01-10 00:00:00	1954-01-24	1954-01-24 00:00:00	1954-01-24	38000177		0	0	14		0	0	0	227756	0	105078	19006318		
6822	148	40213227	2009-11-01	2009-11-01 00:00:00	2009-11-01	2009-11-01 00:00:00	2009-11-01	581452		0	0	0		0	0	0	10025	0	113	40213227		
91986	2020	40213296	2013-01-26	2013-01-26 00:00:00	2013-01-26	2013-01-26 00:00:00	2013-01-26	581452		0	0	0		0	0	0	134306	0	52	40213296		
49885	4139	1115171	2006-06-30	2006-06-30 00:00:00	2006-08-29	2006-08-29 00:00:00	2006-08-29	38000177		0	0	60		0	0	0	275167	0	849574	1115171		
63405	5267	46233988	1968-06-26	1968-06-26 00:00:00	1968-07-10	1968-07-10 00:00:00	1968-07-10	38000177		0	0	14		0	0	0	350413	0	1652673	46233988		
8775	188	40213227	2004-11-28	2004-11-28 00:00:00	2004-11-28	2004-11-28 00:00:00	2004-11-28	581452		0	0	0		0	0	0	12822	0	113	40213227		
49001	1073	40213227	1997-09-04	1997-09-04 00:00:00	1997-09-04	1997-09-04 00:00:00	1997-09-04	581452		0	0	0		0	0	0	70400	0	113	40213227		
22732	1867	1713671	1973-07-24	1973-07-24 00:00:00	1973-07-31	1973-07-31 00:00:00	1973-07-31	38000177		0	0	7		0	0	0	124689	0	562251	1713671		
208336	4570	40213227	2008-03-29	2008-03-29 00:00:00	2008-03-29	2008-03-29 00:00:00	2008-03-29	581452		0	0	0		0	0	0	304497	0	113	40213227		
5404	453	19059056	1971-04-10	1971-04-10 00:00:00	1971-05-08	1971-05-08 00:00:00	1971-05-08	38000177		0	0	28		0	0	0	30151	0	243670	19059056		
48120	3989	40173590	2018-01-29	2018-01-29 00:00:00	2018-01-29	2018-01-29 00:00:00	\N	38000177		0	0	0		0	0	0	265193	0	904419	40173590		
61571	5123	42902245	1998-04-28	1998-04-28 00:00:00	1999-04-23	1999-04-23 00:00:00	1999-04-23	38000177		0	0	360		0	0	0	340653	0	1359133	42902245		
68431	1498	40213227	2006-03-27	2006-03-27 00:00:00	2006-03-27	2006-03-27 00:00:00	2006-03-27	581452		0	0	0		0	0	0	99928	0	113	40213227		
59890	4977	35605482	2010-12-07	2010-12-07 00:00:00	2010-12-07	2010-12-07 00:00:00	2010-12-07	38000177		0	0	0		0	0	0	331120	0	1740467	35605482		
73646	1608	40213201	2007-12-29	2007-12-29 00:00:00	2007-12-29	2007-12-29 00:00:00	2007-12-29	581452		0	0	0		0	0	0	107998	0	33	40213201		
25420	2088	1127433	1932-12-07	1932-12-07 00:00:00	1932-12-14	1932-12-14 00:00:00	1932-12-14	38000177		0	0	7		0	0	0	139166	0	313782	1127433		
44124	3652	1713671	1992-11-27	1992-11-27 00:00:00	1992-12-11	1992-12-11 00:00:00	1992-12-11	38000177		0	0	14		0	0	0	243121	0	562251	1713671		
108911	2389	40213160	1969-12-09	1969-12-09 00:00:00	1969-12-09	1969-12-09 00:00:00	1969-12-09	581452		0	0	0		0	0	0	158848	0	10	40213160		
37883	826	40213160	1958-10-23	1958-10-23 00:00:00	1958-10-23	1958-10-23 00:00:00	1958-10-23	581452		0	0	0		0	0	0	54724	0	10	40213160		
2780	224	19059056	1946-05-28	1946-05-28 00:00:00	1946-06-11	1946-06-11 00:00:00	1946-06-11	38000177		0	0	14		0	0	0	15028	0	243670	19059056		
36114	2976	40169281	1981-04-16	1981-04-16 00:00:00	1981-04-16	1981-04-16 00:00:00	\N	38000177		0	0	0		0	0	0	198770	0	896209	40169281		
217175	4764	40213296	2011-08-10	2011-08-10 00:00:00	2011-08-10	2011-08-10 00:00:00	2011-08-10	581452		0	0	0		0	0	0	317466	0	52	40213296		
139783	3070	40213296	2006-10-01	2006-10-01 00:00:00	2006-10-01	2006-10-01 00:00:00	2006-10-01	581452		0	0	0		0	0	0	204336	0	52	40213296		
54705	1197	40213314	1978-09-10	1978-09-10 00:00:00	1978-09-10	1978-09-10 00:00:00	1978-09-10	581452		0	0	0		0	0	0	78876	0	49	40213314		
114622	2518	40213160	1955-07-29	1955-07-29 00:00:00	1955-07-29	1955-07-29 00:00:00	1955-07-29	581452		0	0	0		0	0	0	166556	0	10	40213160		
24295	528	40213160	1959-11-06	1959-11-06 00:00:00	1959-11-06	1959-11-06 00:00:00	1959-11-06	581452		0	0	0		0	0	0	35166	0	10	40213160		
57295	4755	19078461	2014-05-24	2014-05-24 00:00:00	2014-06-23	2014-06-23 00:00:00	2014-06-23	38000177		0	0	30		0	0	0	316711	0	310965	19078461		
146747	3227	40213227	2012-05-29	2012-05-29 00:00:00	2012-05-29	2012-05-29 00:00:00	2012-05-29	581452		0	0	0		0	0	0	214541	0	113	40213227		
184420	4052	40213160	1976-09-23	1976-09-23 00:00:00	1976-09-23	1976-09-23 00:00:00	1976-09-23	581452		0	0	0		0	0	0	269350	0	10	40213160		
34631	2861	1115171	2005-03-20	2005-03-20 00:00:00	2005-04-03	2005-04-03 00:00:00	2005-04-03	38000177		0	0	14		0	0	0	190245	0	849574	1115171		
54387	4521	40229134	1972-12-10	1972-12-10 00:00:00	1972-12-17	1972-12-17 00:00:00	1972-12-17	38000177		0	0	7		0	0	0	301006	0	1043400	40229134		
201260	4419	40213260	2006-06-05	2006-06-05 00:00:00	2006-06-05	2006-06-05 00:00:00	2006-06-05	581452		0	0	0		0	0	0	293831	0	121	40213260		
15056	1257	40229134	1980-10-20	1980-10-20 00:00:00	1980-10-27	1980-10-27 00:00:00	1980-10-27	38000177		0	0	7		0	0	0	82836	0	1043400	40229134		
48151	3991	19133905	1972-02-22	1972-02-22 00:00:00	1972-02-29	1972-02-29 00:00:00	1972-02-29	38000177		0	0	7		0	0	0	265342	0	834102	19133905		
15103	1261	40169281	2005-07-09	2005-07-09 00:00:00	2005-07-09	2005-07-09 00:00:00	\N	38000177		0	0	0		0	0	0	83130	0	896209	40169281		
95054	2084	40213160	1963-03-20	1963-03-20 00:00:00	1963-03-20	1963-03-20 00:00:00	1963-03-20	581452		0	0	0		0	0	0	138842	0	10	40213160		
19482	1605	19059056	1937-02-23	1937-02-23 00:00:00	1937-03-09	1937-03-09 00:00:00	1937-03-09	38000177		0	0	14		0	0	0	107697	0	243670	19059056		
16873	1397	40229134	2008-12-18	2008-12-18 00:00:00	2008-12-25	2008-12-25 00:00:00	2008-12-25	38000177		0	0	7		0	0	0	92798	0	1043400	40229134		
19575	1611	1127433	1991-07-28	1991-07-28 00:00:00	1991-10-26	1991-10-26 00:00:00	1991-10-26	38000177		0	0	90		0	0	0	108355	0	313782	1127433		
5968	499	1127433	1976-06-19	1976-06-19 00:00:00	1976-07-03	1976-07-03 00:00:00	1976-07-03	38000177		0	0	14		0	0	0	33456	0	313782	1127433		
48513	4019	1124300	2005-04-30	2005-04-30 00:00:00	2005-04-30	2005-04-30 00:00:00	\N	38000177		0	0	0		0	0	0	267186	0	00781178901	45011828		
85914	1882	40213227	2000-10-14	2000-10-14 00:00:00	2000-10-14	2000-10-14 00:00:00	2000-10-14	581452		0	0	0		0	0	0	125529	0	113	40213227		
38033	3144	19006318	1966-01-02	1966-01-02 00:00:00	1966-01-16	1966-01-16 00:00:00	1966-01-16	38000177		0	0	14		0	0	0	209215	0	105078	19006318		
97284	2133	40213296	2005-06-13	2005-06-13 00:00:00	2005-06-13	2005-06-13 00:00:00	2005-06-13	581452		0	0	0		0	0	0	141890	0	52	40213296		
203936	4477	40213260	2013-11-21	2013-11-21 00:00:00	2013-11-21	2013-11-21 00:00:00	2013-11-21	581452		0	0	0		0	0	0	297977	0	121	40213260		
241547	5302	40213296	2014-08-29	2014-08-29 00:00:00	2014-08-29	2014-08-29 00:00:00	2014-08-29	581452		0	0	0		0	0	0	352805	0	52	40213296		
13796	298	40213296	1996-07-30	1996-07-30 00:00:00	1996-07-30	1996-07-30 00:00:00	1996-07-30	581452		0	0	0		0	0	0	19938	0	52	40213296		
199384	4380	40213227	2015-04-27	2015-04-27 00:00:00	2015-04-27	2015-04-27 00:00:00	2015-04-27	581452		0	0	0		0	0	0	291063	0	113	40213227		
52572	4372	40236824	2009-05-28	2009-05-28 00:00:00	2009-06-04	2009-06-04 00:00:00	2009-06-04	38000177		0	0	7		0	0	0	290291	0	1094107	40236824		
39690	866	40213260	2008-09-14	2008-09-14 00:00:00	2008-09-14	2008-09-14 00:00:00	2008-09-14	581452		0	0	0		0	0	0	57508	0	121	40213260		
170567	3750	40213227	2011-12-24	2011-12-24 00:00:00	2011-12-24	2011-12-24 00:00:00	2011-12-24	581452		0	0	0		0	0	0	249272	0	113	40213227		
48377	4010	19128022	1998-03-26	1998-03-26 00:00:00	1999-03-21	1999-03-21 00:00:00	1999-03-21	38000177		0	0	360		0	0	0	266475	0	749785	19128022		
12510	1053	1118084	2015-03-11	2015-03-11 00:00:00	2015-03-11	2015-03-11 00:00:00	\N	38000177		0	0	0		0	0	0	69008	0	00025152531	44923712		
197629	4342	40213160	1962-06-15	1962-06-15 00:00:00	1962-06-15	1962-06-15 00:00:00	1962-06-15	581452		0	0	0		0	0	0	287855	0	10	40213160		
216448	4750	40213227	1994-05-11	1994-05-11 00:00:00	1994-05-11	1994-05-11 00:00:00	1994-05-11	581452		0	0	0		0	0	0	316322	0	113	40213227		
223430	4905	40213296	2012-09-06	2012-09-06 00:00:00	2012-09-06	2012-09-06 00:00:00	2012-09-06	581452		0	0	0		0	0	0	326073	0	52	40213296		
63800	5300	1127433	2002-12-25	2002-12-25 00:00:00	2003-01-08	2003-01-08 00:00:00	2003-01-08	38000177		0	0	14		0	0	0	352606	0	313782	1127433		
15507	1292	40165015	1999-01-22	1999-01-22 00:00:00	1999-01-22	1999-01-22 00:00:00	\N	38000177		0	0	0		0	0	0	85356	0	861467	40165015		
18091	1498	1124300	2007-04-21	2007-04-21 00:00:00	2007-04-21	2007-04-21 00:00:00	\N	38000177		0	0	0		0	0	0	99928	0	00781178901	45011828		
160847	3539	40213251	1984-05-18	1984-05-18 00:00:00	1984-05-18	1984-05-18 00:00:00	1984-05-18	581452		0	0	0		0	0	0	235077	0	21	40213251		
47186	3913	19059056	1969-11-10	1969-11-10 00:00:00	1970-01-09	1970-01-09 00:00:00	1970-01-09	38000177		0	0	60		0	0	0	260086	0	243670	19059056		
34726	2868	1545959	2016-02-10	2016-02-10 00:00:00	2016-02-10	2016-02-10 00:00:00	2016-02-10	38000177		0	0	0		0	0	0	190820	0	259255	1545959		
57769	4799	1124300	1997-02-19	1997-02-19 00:00:00	1997-02-19	1997-02-19 00:00:00	\N	38000177		0	0	0		0	0	0	319273	0	00781178901	45011828		
41347	3430	19129655	1964-01-31	1964-01-31 00:00:00	1964-02-14	1964-02-14 00:00:00	1964-02-14	38000177		0	0	14		0	0	0	227379	0	789980	19129655		
42125	918	40213227	1994-12-09	1994-12-09 00:00:00	1994-12-09	1994-12-09 00:00:00	1994-12-09	581452		0	0	0		0	0	0	61212	0	113	40213227		
6823	148	40213314	1979-01-21	1979-01-21 00:00:00	1979-01-21	1979-01-21 00:00:00	1979-01-21	581452		0	0	0		0	0	0	9992	0	49	40213314		
91995	2020	40213160	1971-02-06	1971-02-06 00:00:00	1971-02-06	1971-02-06 00:00:00	1971-02-06	581452		0	0	0		0	0	0	134271	0	10	40213160		
49886	4139	19128022	1992-09-21	1992-09-21 00:00:00	1993-09-16	1993-09-16 00:00:00	1993-09-16	38000177		0	0	360		0	0	0	275139	0	749785	19128022		
63406	5267	19059056	1968-06-26	1968-06-26 00:00:00	1968-07-10	1968-07-10 00:00:00	1968-07-10	38000177		0	0	14		0	0	0	350413	0	243670	19059056		
8776	188	40213296	2004-11-28	2004-11-28 00:00:00	2004-11-28	2004-11-28 00:00:00	2004-11-28	581452		0	0	0		0	0	0	12822	0	52	40213296		
49018	1073	40213201	2003-05-15	2003-05-15 00:00:00	2003-05-15	2003-05-15 00:00:00	2003-05-15	581452		0	0	0		0	0	0	70373	0	33	40213201		
22733	1867	1118084	2006-07-04	2006-07-04 00:00:00	2006-07-04	2006-07-04 00:00:00	\N	38000177		0	0	0		0	0	0	124732	0	00025152531	44923712		
208340	4570	40213227	1998-01-31	1998-01-31 00:00:00	1998-01-31	1998-01-31 00:00:00	1998-01-31	581452		0	0	0		0	0	0	304517	0	113	40213227		
5405	453	19073188	2004-02-05	2004-02-05 00:00:00	2004-03-04	2004-03-04 00:00:00	2004-03-04	38000177		0	0	28		0	0	0	30240	0	308192	19073188		
48121	3989	1127433	1994-02-13	1994-02-13 00:00:00	1994-02-20	1994-02-20 00:00:00	1994-02-20	38000177		0	0	7		0	0	0	265171	0	313782	1127433		
61572	5123	1713671	1993-05-21	1993-05-21 00:00:00	1993-05-28	1993-05-28 00:00:00	1993-05-28	38000177		0	0	7		0	0	0	340642	0	562251	1713671		
68432	1498	40213160	1964-08-25	1964-08-25 00:00:00	1964-08-25	1964-08-25 00:00:00	1964-08-25	581452		0	0	0		0	0	0	99950	0	10	40213160		
59891	4977	35605482	2010-12-08	2010-12-08 00:00:00	2010-12-08	2010-12-08 00:00:00	2010-12-08	38000177		0	0	0		0	0	0	331120	0	1740467	35605482		
73648	1608	40213227	1992-10-03	1992-10-03 00:00:00	1992-10-03	1992-10-03 00:00:00	1992-10-03	581452		0	0	0		0	0	0	107960	0	113	40213227		
25421	2088	40169281	1968-11-19	1968-11-19 00:00:00	1968-11-19	1968-11-19 00:00:00	\N	38000177		0	0	0		0	0	0	139318	0	896209	40169281		
44125	3652	1127078	1974-04-07	1974-04-07 00:00:00	1974-04-21	1974-04-21 00:00:00	1974-04-21	38000177		0	0	14		0	0	0	243130	0	282464	1127078		
124393	2736	40213160	1974-07-17	1974-07-17 00:00:00	1974-07-17	1974-07-17 00:00:00	1974-07-17	581452		0	0	0		0	0	0	181141	0	10	40213160		
4339	94	40213160	1955-09-02	1955-09-02 00:00:00	1955-09-02	1955-09-02 00:00:00	1955-09-02	581452		0	0	0		0	0	0	6374	0	10	40213160		
2781	224	19059056	1944-11-01	1944-11-01 00:00:00	1944-11-15	1944-11-15 00:00:00	1944-11-15	38000177		0	0	14		0	0	0	15040	0	243670	19059056		
36115	2976	1124300	1995-09-26	1995-09-26 00:00:00	1995-09-26	1995-09-26 00:00:00	\N	38000177		0	0	0		0	0	0	198773	0	00781178901	45011828		
217177	4764	40213306	1990-10-24	1990-10-24 00:00:00	1990-10-24	1990-10-24 00:00:00	1990-10-24	581452		0	0	0		0	0	0	317474	0	43	40213306		
241016	5291	40213296	2018-02-04	2018-02-04 00:00:00	2018-02-04	2018-02-04 00:00:00	2018-02-04	581452		0	0	0		0	0	0	352085	0	52	40213296		
54706	1197	40213160	1978-09-10	1978-09-10 00:00:00	1978-09-10	1978-09-10 00:00:00	1978-09-10	581452		0	0	0		0	0	0	78876	0	10	40213160		
114626	2518	40213160	1956-01-27	1956-01-27 00:00:00	1956-01-27	1956-01-27 00:00:00	1956-01-27	581452		0	0	0		0	0	0	166586	0	10	40213160		
24298	528	40213160	1964-05-08	1964-05-08 00:00:00	1964-05-08	1964-05-08 00:00:00	1964-05-08	581452		0	0	0		0	0	0	35198	0	10	40213160		
57296	4755	19133905	1944-09-06	1944-09-06 00:00:00	1944-09-16	1944-09-16 00:00:00	1944-09-16	38000177		0	0	10		0	0	0	316755	0	834102	19133905		
146753	3227	40213160	1970-06-02	1970-06-02 00:00:00	1970-06-02	1970-06-02 00:00:00	1970-06-02	581452		0	0	0		0	0	0	214535	0	10	40213160		
184423	4052	40213160	1976-12-23	1976-12-23 00:00:00	1976-12-23	1976-12-23 00:00:00	1976-12-23	581452		0	0	0		0	0	0	269311	0	10	40213160		
34632	2861	1127433	2019-06-19	2019-06-19 00:00:00	2019-06-19	2019-06-19 00:00:00	\N	38000177		0	0	0		0	0	0	190247	0	313782	1127433		
54388	4521	1124300	1958-10-11	1958-10-11 00:00:00	1958-10-11	1958-10-11 00:00:00	\N	38000177		0	0	0		0	0	0	300979	0	00781178901	45011828		
201264	4419	40213227	2017-08-07	2017-08-07 00:00:00	2017-08-07	2017-08-07 00:00:00	2017-08-07	581452		0	0	0		0	0	0	293833	0	113	40213227		
13896	1162	40223774	2000-07-07	2000-07-07 00:00:00	2000-07-07	2000-07-07 00:00:00	\N	38000177		0	0	0		0	0	0	76763	0	998582	40223774		
48152	3991	19059056	1948-07-15	1948-07-15 00:00:00	1948-08-19	1948-08-19 00:00:00	1948-08-19	38000177		0	0	35		0	0	0	265374	0	243670	19059056		
15104	1261	1118084	2005-10-24	2005-10-24 00:00:00	2005-10-24	2005-10-24 00:00:00	\N	38000177		0	0	0		0	0	0	83130	0	00025152531	44923712		
95055	2084	40213160	1963-01-16	1963-01-16 00:00:00	1963-01-16	1963-01-16 00:00:00	1963-01-16	581452		0	0	0		0	0	0	138865	0	10	40213160		
19483	1605	19059056	1938-04-04	1938-04-04 00:00:00	1938-04-18	1938-04-18 00:00:00	1938-04-18	38000177		0	0	14		0	0	0	107698	0	243670	19059056		
16874	1397	19128022	1995-10-21	1995-10-21 00:00:00	1996-10-15	1996-10-15 00:00:00	1996-10-15	38000177		0	0	360		0	0	0	92737	0	749785	19128022		
19576	1611	40231925	1991-07-28	1991-07-28 00:00:00	1991-07-28	1991-07-28 00:00:00	\N	38000177		0	0	0		0	0	0	108355	0	1049221	40231925		
5969	499	19008572	1969-07-29	1969-07-29 00:00:00	1969-08-19	1969-08-19 00:00:00	1969-08-19	38000177		0	0	21		0	0	0	33317	0	106258	19008572		
48514	4019	40231925	1991-05-04	1991-05-04 00:00:00	1991-05-04	1991-05-04 00:00:00	\N	38000177		0	0	0		0	0	0	267171	0	1049221	40231925		
85919	1882	40213227	2010-10-30	2010-10-30 00:00:00	2010-10-30	2010-10-30 00:00:00	2010-10-30	581452		0	0	0		0	0	0	125585	0	113	40213227		
38034	3144	19059056	1964-07-22	1964-07-22 00:00:00	1964-08-05	1964-08-05 00:00:00	1964-08-05	38000177		0	0	14		0	0	0	209226	0	243670	19059056		
97298	2133	40213160	1966-02-14	1966-02-14 00:00:00	1966-02-14	1966-02-14 00:00:00	1966-02-14	581452		0	0	0		0	0	0	141898	0	10	40213160		
203941	4477	40213160	1964-04-30	1964-04-30 00:00:00	1964-04-30	1964-04-30 00:00:00	1964-04-30	581452		0	0	0		0	0	0	297955	0	10	40213160		
241549	5302	40213227	2014-08-29	2014-08-29 00:00:00	2014-08-29	2014-08-29 00:00:00	2014-08-29	581452		0	0	0		0	0	0	352805	0	113	40213227		
13800	298	40213227	1993-08-17	1993-08-17 00:00:00	1993-08-17	1993-08-17 00:00:00	1993-08-17	581452		0	0	0		0	0	0	19867	0	113	40213227		
199389	4380	40213160	1964-12-28	1964-12-28 00:00:00	1964-12-28	1964-12-28 00:00:00	1964-12-28	581452		0	0	0		0	0	0	291043	0	10	40213160		
52573	4372	19128022	1996-04-24	1996-04-24 00:00:00	1997-04-19	1997-04-19 00:00:00	1997-04-19	38000177		0	0	360		0	0	0	290233	0	749785	19128022		
39696	866	40213160	1959-05-24	1959-05-24 00:00:00	1959-05-24	1959-05-24 00:00:00	1959-05-24	581452		0	0	0		0	0	0	57481	0	10	40213160		
170568	3750	40213260	2011-12-24	2011-12-24 00:00:00	2011-12-24	2011-12-24 00:00:00	2011-12-24	581452		0	0	0		0	0	0	249272	0	121	40213260		
48378	4010	1115171	2019-05-25	2019-05-25 00:00:00	2019-06-15	2019-06-15 00:00:00	2019-06-15	38000177		0	0	21		0	0	0	266492	0	849574	1115171		
12511	1053	920300	2014-02-25	2014-02-25 00:00:00	2014-03-04	2014-03-04 00:00:00	2014-03-04	38000177		0	0	7		0	0	0	69008	0	311989	920300		
197634	4343	40213160	1955-03-28	1955-03-28 00:00:00	1955-03-28	1955-03-28 00:00:00	1955-03-28	581452		0	0	0		0	0	0	288056	0	10	40213160		
216454	4750	40213160	1963-09-18	1963-09-18 00:00:00	1963-09-18	1963-09-18 00:00:00	1963-09-18	581452		0	0	0		0	0	0	316302	0	10	40213160		
223435	4905	40213160	1973-05-10	1973-05-10 00:00:00	1973-05-10	1973-05-10 00:00:00	1973-05-10	581452		0	0	0		0	0	0	326047	0	10	40213160		
63801	5300	1118084	1981-09-03	1981-09-03 00:00:00	1981-09-03	1981-09-03 00:00:00	\N	38000177		0	0	0		0	0	0	352592	0	00025152531	44923712		
15508	1293	1127433	2016-09-12	2016-09-12 00:00:00	2016-12-11	2016-12-11 00:00:00	2016-12-11	38000177		0	0	90		0	0	0	85594	0	313782	1127433		
18092	1498	1713671	2000-06-12	2000-06-12 00:00:00	2000-07-03	2000-07-03 00:00:00	2000-07-03	38000177		0	0	21		0	0	0	99938	0	562251	1713671		
160854	3539	40213314	1981-05-22	1981-05-22 00:00:00	1981-05-22	1981-05-22 00:00:00	1981-05-22	581452		0	0	0		0	0	0	235096	0	49	40213314		
47187	3913	40229134	1982-07-14	1982-07-14 00:00:00	1982-07-28	1982-07-28 00:00:00	1982-07-28	38000177		0	0	14		0	0	0	260079	0	1043400	40229134		
34727	2868	19133768	2016-02-10	2016-02-10 00:00:00	2016-02-10	2016-02-10 00:00:00	2016-02-10	38000177		0	0	0		0	0	0	190820	0	833036	19133768		
57771	4800	1127433	1977-04-12	1977-04-12 00:00:00	1977-04-27	1977-04-27 00:00:00	1977-04-27	38000177		0	0	15		0	0	0	319341	0	313782	1127433		
41348	3430	19059056	1964-01-31	1964-01-31 00:00:00	1964-02-14	1964-02-14 00:00:00	1964-02-14	38000177		0	0	14		0	0	0	227379	0	243670	19059056		
42146	918	40213227	2005-05-27	2005-05-27 00:00:00	2005-05-27	2005-05-27 00:00:00	2005-05-27	581452		0	0	0		0	0	0	61116	0	113	40213227		
6824	148	40213160	1979-01-21	1979-01-21 00:00:00	1979-01-21	1979-01-21 00:00:00	1979-01-21	581452		0	0	0		0	0	0	9992	0	10	40213160		
91997	2020	40213227	1993-01-02	1993-01-02 00:00:00	1993-01-02	1993-01-02 00:00:00	1993-01-02	581452		0	0	0		0	0	0	134266	0	113	40213227		
49887	4139	19128022	1993-09-16	1993-09-16 00:00:00	1994-09-11	1994-09-11 00:00:00	1994-09-11	38000177		0	0	360		0	0	0	275140	0	749785	19128022		
111228	2443	40213160	1962-04-05	1962-04-05 00:00:00	1962-04-05	1962-04-05 00:00:00	1962-04-05	581452		0	0	0		0	0	0	162062	0	10	40213160		
8778	188	40213227	2014-04-27	2014-04-27 00:00:00	2014-04-27	2014-04-27 00:00:00	2014-04-27	581452		0	0	0		0	0	0	12782	0	113	40213227		
12281	1032	1127433	1985-08-09	1985-08-09 00:00:00	1985-08-23	1985-08-23 00:00:00	1985-08-23	38000177		0	0	14		0	0	0	67907	0	313782	1127433		
22734	1867	1713671	1982-07-17	1982-07-17 00:00:00	1982-07-31	1982-07-31 00:00:00	1982-07-31	38000177		0	0	14		0	0	0	124675	0	562251	1713671		
219634	4820	40213296	1999-01-07	1999-01-07 00:00:00	1999-01-07	1999-01-07 00:00:00	1999-01-07	581452		0	0	0		0	0	0	320598	0	52	40213296		
5406	453	1115171	2004-02-05	2004-02-05 00:00:00	2004-03-04	2004-03-04 00:00:00	2004-03-04	38000177		0	0	28		0	0	0	30240	0	849574	1115171		
48122	3989	1118084	1965-01-11	1965-01-11 00:00:00	1965-01-11	1965-01-11 00:00:00	\N	38000177		0	0	0		0	0	0	265202	0	00025152531	44923712		
55984	1226	40213227	2011-10-30	2011-10-30 00:00:00	2011-10-30	2011-10-30 00:00:00	2011-10-30	581452		0	0	0		0	0	0	80684	0	113	40213227		
68433	1498	40213227	2015-03-24	2015-03-24 00:00:00	2015-03-24	2015-03-24 00:00:00	2015-03-24	581452		0	0	0		0	0	0	99986	0	113	40213227		
59892	4977	19078924	2010-12-08	2010-12-08 00:00:00	2010-12-08	2010-12-08 00:00:00	2010-12-08	38000177		0	0	0		0	0	0	331120	0	311700	19078924		
73653	1608	40213227	2013-01-26	2013-01-26 00:00:00	2013-01-26	2013-01-26 00:00:00	2013-01-26	581452		0	0	0		0	0	0	108037	0	113	40213227		
25422	2088	1127433	2012-05-25	2012-05-25 00:00:00	2012-06-15	2012-06-15 00:00:00	2012-06-15	38000177		0	0	21		0	0	0	139185	0	313782	1127433		
44126	3652	46233988	1974-04-07	1974-04-07 00:00:00	1974-04-21	1974-04-21 00:00:00	1974-04-21	38000177		0	0	14		0	0	0	243130	0	1652673	46233988		
124401	2736	40213227	2003-05-07	2003-05-07 00:00:00	2003-05-07	2003-05-07 00:00:00	2003-05-07	581452		0	0	0		0	0	0	181088	0	113	40213227		
4342	94	40213160	1957-03-08	1957-03-08 00:00:00	1957-03-08	1957-03-08 00:00:00	1957-03-08	581452		0	0	0		0	0	0	6317	0	10	40213160		
2782	224	19078461	2009-07-24	2009-07-24 00:00:00	2009-08-23	2009-08-23 00:00:00	2009-08-23	38000177		0	0	30		0	0	0	15110	0	310965	19078461		
36116	2976	1127433	2013-07-04	2013-07-04 00:00:00	2013-07-11	2013-07-11 00:00:00	2013-07-11	38000177		0	0	7		0	0	0	198728	0	313782	1127433		
156105	3436	40213160	1963-02-18	1963-02-18 00:00:00	1963-02-18	1963-02-18 00:00:00	1963-02-18	581452		0	0	0		0	0	0	227885	0	10	40213160		
241018	5291	40213227	2018-02-04	2018-02-04 00:00:00	2018-02-04	2018-02-04 00:00:00	2018-02-04	581452		0	0	0		0	0	0	352085	0	113	40213227		
54709	1197	40213160	1979-02-11	1979-02-11 00:00:00	1979-02-11	1979-02-11 00:00:00	1979-02-11	581452		0	0	0		0	0	0	78867	0	10	40213160		
114632	2518	40213296	1997-06-20	1997-06-20 00:00:00	1997-06-20	1997-06-20 00:00:00	1997-06-20	581452		0	0	0		0	0	0	166548	0	52	40213296		
24303	528	40213160	1960-02-05	1960-02-05 00:00:00	1960-02-05	1960-02-05 00:00:00	1960-02-05	581452		0	0	0		0	0	0	35156	0	10	40213160		
57297	4755	1127433	1932-12-04	1932-12-04 00:00:00	1932-12-18	1932-12-18 00:00:00	1932-12-18	38000177		0	0	14		0	0	0	316681	0	313782	1127433		
146755	3227	40213227	1993-05-04	1993-05-04 00:00:00	1993-05-04	1993-05-04 00:00:00	1993-05-04	581452		0	0	0		0	0	0	214555	0	113	40213227		
184426	4053	40213160	1962-03-04	1962-03-04 00:00:00	1962-03-04	1962-03-04 00:00:00	1962-03-04	581452		0	0	0		0	0	0	269477	0	10	40213160		
34633	2861	19133873	1964-07-05	1964-07-05 00:00:00	1964-07-13	1964-07-13 00:00:00	1964-07-13	38000177		0	0	8		0	0	0	190204	0	834061	19133873		
54389	4521	1713671	1961-06-23	1961-06-23 00:00:00	1961-07-14	1961-07-14 00:00:00	1961-07-14	38000177		0	0	21		0	0	0	300963	0	562251	1713671		
201266	4419	40213160	1956-01-30	1956-01-30 00:00:00	1956-01-30	1956-01-30 00:00:00	1956-01-30	581452		0	0	0		0	0	0	293809	0	10	40213160		
13897	1162	40229134	1933-09-13	1933-09-13 00:00:00	1933-09-20	1933-09-20 00:00:00	1933-09-20	38000177		0	0	7		0	0	0	76695	0	1043400	40229134		
48153	3991	40173590	2016-01-23	2016-01-23 00:00:00	2016-01-23	2016-01-23 00:00:00	\N	38000177		0	0	0		0	0	0	265352	0	904419	40173590		
15105	1261	19133873	1973-06-01	1973-06-01 00:00:00	1973-06-10	1973-06-10 00:00:00	1973-06-10	38000177		0	0	9		0	0	0	83246	0	834061	19133873		
95061	2084	40213296	2005-11-02	2005-11-02 00:00:00	2005-11-02	2005-11-02 00:00:00	2005-11-02	581452		0	0	0		0	0	0	138889	0	52	40213296		
19484	1605	1713671	1989-08-23	1989-08-23 00:00:00	1989-09-06	1989-09-06 00:00:00	1989-09-06	38000177		0	0	14		0	0	0	107755	0	562251	1713671		
16875	1397	1127433	1989-02-15	1989-02-15 00:00:00	1989-03-01	1989-03-01 00:00:00	1989-03-01	38000177		0	0	14		0	0	0	92840	0	313782	1127433		
19577	1611	1713671	2002-10-06	2002-10-06 00:00:00	2002-10-27	2002-10-27 00:00:00	2002-10-27	38000177		0	0	21		0	0	0	108338	0	562251	1713671		
5970	499	1127433	1987-02-26	1987-02-26 00:00:00	1987-03-12	1987-03-12 00:00:00	1987-03-12	38000177		0	0	14		0	0	0	33418	0	313782	1127433		
48515	4019	1127433	1991-05-04	1991-05-04 00:00:00	1991-08-02	1991-08-02 00:00:00	1991-08-02	38000177		0	0	90		0	0	0	267171	0	313782	1127433		
85920	1882	40213296	2010-10-30	2010-10-30 00:00:00	2010-10-30	2010-10-30 00:00:00	2010-10-30	581452		0	0	0		0	0	0	125585	0	52	40213296		
38035	3145	1713671	1974-11-14	1974-11-14 00:00:00	1974-11-28	1974-11-28 00:00:00	1974-11-28	38000177		0	0	14		0	0	0	209255	0	562251	1713671		
97300	2133	40213227	2016-06-13	2016-06-13 00:00:00	2016-06-13	2016-06-13 00:00:00	2016-06-13	581452		0	0	0		0	0	0	141928	0	113	40213227		
203945	4477	40213227	1995-02-02	1995-02-02 00:00:00	1995-02-02	1995-02-02 00:00:00	1995-02-02	581452		0	0	0		0	0	0	297972	0	113	40213227		
241550	5302	40213160	1971-12-10	1971-12-10 00:00:00	1971-12-10	1971-12-10 00:00:00	1971-12-10	581452		0	0	0		0	0	0	352817	0	10	40213160		
13806	298	40213160	1955-02-08	1955-02-08 00:00:00	1955-02-08	1955-02-08 00:00:00	1955-02-08	581452		0	0	0		0	0	0	19926	0	10	40213160		
199391	4380	40213160	1964-09-28	1964-09-28 00:00:00	1964-09-28	1964-09-28 00:00:00	1964-09-28	581452		0	0	0		0	0	0	291008	0	10	40213160		
52574	4372	19127922	2002-03-24	2002-03-24 00:00:00	2003-03-19	2003-03-19 00:00:00	2003-03-19	38000177		0	0	360		0	0	0	290248	0	748962	19127922		
129515	2847	40213160	1962-07-22	1962-07-22 00:00:00	1962-07-22	1962-07-22 00:00:00	1962-07-22	581452		0	0	0		0	0	0	189066	0	10	40213160		
170574	3750	40213227	2001-02-17	2001-02-17 00:00:00	2001-02-17	2001-02-17 00:00:00	2001-02-17	581452		0	0	0		0	0	0	249270	0	113	40213227		
48379	4010	1127433	1994-01-27	1994-01-27 00:00:00	1994-02-10	1994-02-10 00:00:00	1994-02-10	38000177		0	0	14		0	0	0	266515	0	313782	1127433		
12512	1053	1127433	1989-01-21	1989-01-21 00:00:00	1989-02-18	1989-02-18 00:00:00	1989-02-18	38000177		0	0	28		0	0	0	69040	0	313782	1127433		
197642	4343	40213227	1996-02-19	1996-02-19 00:00:00	1996-02-19	1996-02-19 00:00:00	1996-02-19	581452		0	0	0		0	0	0	288030	0	113	40213227		
216455	4750	40213296	2003-07-30	2003-07-30 00:00:00	2003-07-30	2003-07-30 00:00:00	2003-07-30	581452		0	0	0		0	0	0	316331	0	52	40213296		
84145	1840	40213227	2017-07-29	2017-07-29 00:00:00	2017-07-29	2017-07-29 00:00:00	2017-07-29	581452		0	0	0		0	0	0	\N	0	113	40213227		
63802	5300	1127433	2015-04-19	2015-04-19 00:00:00	2015-05-03	2015-05-03 00:00:00	2015-05-03	38000177		0	0	14		0	0	0	352656	0	313782	1127433		
64064	5322	19008572	1957-02-13	1957-02-13 00:00:00	1957-03-06	1957-03-06 00:00:00	1957-03-06	38000177		0	0	21		0	0	0	354104	0	106258	19008572		
18093	1498	40229134	1987-10-15	1987-10-15 00:00:00	1987-10-28	1987-10-28 00:00:00	1987-10-28	38000177		0	0	13		0	0	0	99936	0	1043400	40229134		
160856	3539	40213160	1981-05-22	1981-05-22 00:00:00	1981-05-22	1981-05-22 00:00:00	1981-05-22	581452		0	0	0		0	0	0	235096	0	10	40213160		
47188	3913	1124300	2001-07-05	2001-07-05 00:00:00	2001-07-05	2001-07-05 00:00:00	\N	38000177		0	0	0		0	0	0	260109	0	00781178901	45011828		
34728	2868	19128065	1978-09-26	1978-09-26 00:00:00	1979-09-21	1979-09-21 00:00:00	1979-09-21	38000177		0	0	360		0	0	0	190810	0	749882	19128065		
57772	4800	1127433	2007-11-14	2007-11-14 00:00:00	2007-11-21	2007-11-21 00:00:00	2007-11-21	38000177		0	0	7		0	0	0	319324	0	313782	1127433		
41349	3430	19128065	1977-07-01	1977-07-01 00:00:00	1978-06-26	1978-06-26 00:00:00	1978-06-26	38000177		0	0	360		0	0	0	227344	0	749882	19128065		
149605	3290	40213260	2019-04-03	2019-04-03 00:00:00	2019-04-03	2019-04-03 00:00:00	2019-04-03	581452		0	0	0		0	0	0	218572	0	121	40213260		
6827	148	40213296	2018-10-21	2018-10-21 00:00:00	2018-10-21	2018-10-21 00:00:00	2018-10-21	581452		0	0	0		0	0	0	10007	0	52	40213296		
91998	2020	40213306	1993-01-02	1993-01-02 00:00:00	1993-01-02	1993-01-02 00:00:00	1993-01-02	581452		0	0	0		0	0	0	134266	0	43	40213306		
49888	4139	19128022	1991-09-27	1991-09-27 00:00:00	1992-09-21	1992-09-21 00:00:00	1992-09-21	38000177		0	0	360		0	0	0	275138	0	749785	19128022		
111235	2443	40213227	1993-02-04	1993-02-04 00:00:00	1993-02-04	1993-02-04 00:00:00	1993-02-04	581452		0	0	0		0	0	0	162080	0	113	40213227		
8779	188	40213260	2014-04-27	2014-04-27 00:00:00	2014-04-27	2014-04-27 00:00:00	2014-04-27	581452		0	0	0		0	0	0	12782	0	121	40213260		
12282	1032	19078461	1991-07-19	1991-07-19 00:00:00	1991-08-23	1991-08-23 00:00:00	1991-08-23	38000177		0	0	35		0	0	0	67953	0	310965	19078461		
22735	1867	1127433	2018-06-21	2018-06-21 00:00:00	2018-07-26	2018-07-26 00:00:00	2018-07-26	38000177		0	0	35		0	0	0	124730	0	313782	1127433		
171463	3769	40213198	2014-09-21	2014-09-21 00:00:00	2014-09-21	2014-09-21 00:00:00	2014-09-21	581452		0	0	0		0	0	0	250570	0	133	40213198		
5407	453	40165015	2004-02-05	2004-02-05 00:00:00	2004-02-05	2004-02-05 00:00:00	\N	38000177		0	0	0		0	0	0	30240	0	861467	40165015		
48123	3989	45892894	2018-10-15	2018-10-15 00:00:00	2018-10-15	2018-10-15 00:00:00	\N	38000177		0	0	0		0	0	0	265260	0	1599803	45892894		
55999	1227	40213227	2019-04-24	2019-04-24 00:00:00	2019-04-24	2019-04-24 00:00:00	2019-04-24	581452		0	0	0		0	0	0	80851	0	113	40213227		
68434	1498	40213260	2015-03-24	2015-03-24 00:00:00	2015-03-24	2015-03-24 00:00:00	2015-03-24	581452		0	0	0		0	0	0	99986	0	121	40213260		
59893	4977	782047	2010-12-08	2010-12-08 00:00:00	2010-12-08	2010-12-08 00:00:00	2010-12-08	38000177		0	0	0		0	0	0	331120	0	542347	782047		
73668	1608	40213198	2010-01-09	2010-01-09 00:00:00	2010-01-09	2010-01-09 00:00:00	2010-01-09	581452		0	0	0		0	0	0	107999	0	133	40213198		
25423	2088	19059056	1911-09-07	1911-09-07 00:00:00	1911-12-06	1911-12-06 00:00:00	1911-12-06	38000177		0	0	90		0	0	0	139176	0	243670	19059056		
44127	3652	1713671	2007-03-02	2007-03-02 00:00:00	2007-03-23	2007-03-23 00:00:00	2007-03-23	38000177		0	0	21		0	0	0	243101	0	562251	1713671		
135699	2980	40213160	1972-03-26	1972-03-26 00:00:00	1972-03-26	1972-03-26 00:00:00	1972-03-26	581452		0	0	0		0	0	0	198897	0	10	40213160		
4345	94	40213198	2017-12-22	2017-12-22 00:00:00	2017-12-22	2017-12-22 00:00:00	2017-12-22	581452		0	0	0		0	0	0	6395	0	133	40213198		
2783	224	1127433	1996-02-19	1996-02-19 00:00:00	1996-03-04	1996-03-04 00:00:00	1996-03-04	38000177		0	0	14		0	0	0	15109	0	313782	1127433		
36117	2976	1127433	2011-05-06	2011-05-06 00:00:00	2011-05-20	2011-05-20 00:00:00	2011-05-20	38000177		0	0	14		0	0	0	198736	0	313782	1127433		
156107	3436	40213306	1985-10-14	1985-10-14 00:00:00	1985-10-14	1985-10-14 00:00:00	1985-10-14	581452		0	0	0		0	0	0	227908	0	43	40213306		
241022	5291	40213160	1979-11-04	1979-11-04 00:00:00	1979-11-04	1979-11-04 00:00:00	1979-11-04	581452		0	0	0		0	0	0	352061	0	10	40213160		
54710	1197	40213314	1979-08-12	1979-08-12 00:00:00	1979-08-12	1979-08-12 00:00:00	1979-08-12	581452		0	0	0		0	0	0	78851	0	49	40213314		
146602	3224	40213260	2011-04-22	2011-04-22 00:00:00	2011-04-22	2011-04-22 00:00:00	2011-04-22	581452		0	0	0		0	0	0	214337	0	121	40213260		
24310	528	40213160	1959-09-04	1959-09-04 00:00:00	1959-09-04	1959-09-04 00:00:00	1959-09-04	581452		0	0	0		0	0	0	35155	0	10	40213160		
57298	4756	1127433	1953-06-21	1953-06-21 00:00:00	1953-06-28	1953-06-28 00:00:00	1953-06-28	38000177		0	0	7		0	0	0	316828	0	313782	1127433		
146757	3227	40213306	1993-05-04	1993-05-04 00:00:00	1993-05-04	1993-05-04 00:00:00	1993-05-04	581452		0	0	0		0	0	0	214555	0	43	40213306		
117658	2586	40213227	2001-09-16	2001-09-16 00:00:00	2001-09-16	2001-09-16 00:00:00	2001-09-16	581452		0	0	0		0	0	0	171173	0	113	40213227		
184427	4053	40213227	2003-12-21	2003-12-21 00:00:00	2003-12-21	2003-12-21 00:00:00	2003-12-21	581452		0	0	0		0	0	0	269460	0	113	40213227		
54390	4521	1127433	1967-08-16	1967-08-16 00:00:00	1967-08-23	1967-08-23 00:00:00	1967-08-23	38000177		0	0	7		0	0	0	301017	0	313782	1127433		
201267	4419	40213260	2007-06-11	2007-06-11 00:00:00	2007-06-11	2007-06-11 00:00:00	2007-06-11	581452		0	0	0		0	0	0	293857	0	121	40213260		
13898	1162	19133905	1981-09-24	1981-09-24 00:00:00	1981-10-01	1981-10-01 00:00:00	1981-10-01	38000177		0	0	7		0	0	0	76700	0	834102	19133905		
48160	3993	46233710	1974-07-03	1974-07-03 00:00:00	1974-07-31	1974-07-31 00:00:00	1974-07-31	38000177		0	0	28		0	0	0	265524	0	1650142	46233710		
15106	1261	19008572	1989-05-20	1989-05-20 00:00:00	1989-05-20	1989-05-20 00:00:00	\N	38000177		0	0	0		0	0	0	83247	0	106258	19008572		
7661	644	19006318	1977-12-18	1977-12-18 00:00:00	1978-01-01	1978-01-01 00:00:00	1978-01-01	38000177		0	0	14		0	0	0	42648	0	105078	19006318		
19485	1605	40243436	2019-05-12	2019-05-12 00:00:00	2019-05-12	2019-05-12 00:00:00	2019-05-12	38000177		0	0	0		0	0	0	107753	0	1190795	40243436		
16876	1397	19059056	1986-01-31	1986-01-31 00:00:00	1986-02-14	1986-02-14 00:00:00	1986-02-14	38000177		0	0	14		0	0	0	92837	0	243670	19059056		
19578	1611	1127078	1955-07-23	1955-07-23 00:00:00	1955-08-06	1955-08-06 00:00:00	1955-08-06	38000177		0	0	14		0	0	0	108320	0	282464	1127078		
5971	499	40229134	2009-12-25	2009-12-25 00:00:00	2010-01-01	2010-01-01 00:00:00	2010-01-01	38000177		0	0	7		0	0	0	33400	0	1043400	40229134		
48516	4019	19133873	1968-01-04	1968-01-04 00:00:00	1968-01-11	1968-01-11 00:00:00	1968-01-11	38000177		0	0	7		0	0	0	267168	0	834061	19133873		
97203	2131	40213160	1955-06-30	1955-06-30 00:00:00	1955-06-30	1955-06-30 00:00:00	1955-06-30	581452		0	0	0		0	0	0	141790	0	10	40213160		
38036	3145	1713671	1991-05-13	1991-05-13 00:00:00	1991-06-03	1991-06-03 00:00:00	1991-06-03	38000177		0	0	21		0	0	0	209286	0	562251	1713671		
97301	2133	40213260	2016-06-13	2016-06-13 00:00:00	2016-06-13	2016-06-13 00:00:00	2016-06-13	581452		0	0	0		0	0	0	141928	0	121	40213260		
203947	4477	40213227	2005-12-01	2005-12-01 00:00:00	2005-12-01	2005-12-01 00:00:00	2005-12-01	581452		0	0	0		0	0	0	297938	0	113	40213227		
241551	5302	40213160	1972-02-11	1972-02-11 00:00:00	1972-02-11	1972-02-11 00:00:00	1972-02-11	581452		0	0	0		0	0	0	352784	0	10	40213160		
13808	298	40213198	2018-02-06	2018-02-06 00:00:00	2018-02-06	2018-02-06 00:00:00	2018-02-06	581452		0	0	0		0	0	0	19901	0	133	40213198		
199394	4380	40213160	1964-07-27	1964-07-27 00:00:00	1964-07-27	1964-07-27 00:00:00	1964-07-27	581452		0	0	0		0	0	0	291042	0	10	40213160		
52575	4372	19129144	2004-03-13	2004-03-13 00:00:00	2005-03-08	2005-03-08 00:00:00	2005-03-08	38000177		0	0	360		0	0	0	290212	0	757594	19129144		
129518	2847	40213296	2006-01-22	2006-01-22 00:00:00	2006-01-22	2006-01-22 00:00:00	2006-01-22	581452		0	0	0		0	0	0	189058	0	52	40213296		
170575	3750	40213296	2001-02-17	2001-02-17 00:00:00	2001-02-17	2001-02-17 00:00:00	2001-02-17	581452		0	0	0		0	0	0	249270	0	52	40213296		
48380	4010	1127433	1985-01-24	1985-01-24 00:00:00	1985-02-07	1985-02-07 00:00:00	1985-02-07	38000177		0	0	14		0	0	0	266462	0	313782	1127433		
12513	1053	19133873	1981-02-04	1981-02-04 00:00:00	1981-02-13	1981-02-13 00:00:00	1981-02-13	38000177		0	0	9		0	0	0	69045	0	834061	19133873		
197643	4343	40213296	1996-02-19	1996-02-19 00:00:00	1996-02-19	1996-02-19 00:00:00	1996-02-19	581452		0	0	0		0	0	0	288030	0	52	40213296		
216457	4750	40213227	2005-08-03	2005-08-03 00:00:00	2005-08-03	2005-08-03 00:00:00	2005-08-03	581452		0	0	0		0	0	0	316377	0	113	40213227		
84148	1840	40213160	1980-04-12	1980-04-12 00:00:00	1980-04-12	1980-04-12 00:00:00	1980-04-12	581452		0	0	0		0	0	0	122803	0	10	40213160		
63803	5300	1127433	2018-03-18	2018-03-18 00:00:00	2018-04-17	2018-04-17 00:00:00	2018-04-17	38000177		0	0	30		0	0	0	352657	0	313782	1127433		
64065	5322	40173590	2007-05-09	2007-05-09 00:00:00	2007-05-09	2007-05-09 00:00:00	\N	38000177		0	0	0		0	0	0	354256	0	904419	40173590		
18094	1498	1713671	1965-10-17	1965-10-17 00:00:00	1965-10-31	1965-10-31 00:00:00	1965-10-31	38000177		0	0	14		0	0	0	99932	0	562251	1713671		
160860	3539	40213314	1982-02-19	1982-02-19 00:00:00	1982-02-19	1982-02-19 00:00:00	1982-02-19	581452		0	0	0		0	0	0	235097	0	49	40213314		
47189	3913	1127433	2004-06-28	2004-06-28 00:00:00	2004-07-12	2004-07-12 00:00:00	2004-07-12	38000177		0	0	14		0	0	0	260189	0	313782	1127433		
34729	2868	19128065	1980-09-15	1980-09-15 00:00:00	1981-09-10	1981-09-10 00:00:00	1981-09-10	38000177		0	0	360		0	0	0	190812	0	749882	19128065		
99705	2184	40213227	2000-11-01	2000-11-01 00:00:00	2000-11-01	2000-11-01 00:00:00	2000-11-01	581452		0	0	0		0	0	0	145561	0	113	40213227		
41350	3430	1118084	2003-06-20	2003-06-20 00:00:00	2003-06-20	2003-06-20 00:00:00	\N	38000177		0	0	0		0	0	0	227335	0	00025152531	44923712		
149606	3290	40213306	1990-01-17	1990-01-17 00:00:00	1990-01-17	1990-01-17 00:00:00	1990-01-17	581452		0	0	0		0	0	0	\N	0	43	40213306		
6828	148	40213314	1979-12-23	1979-12-23 00:00:00	1979-12-23	1979-12-23 00:00:00	1979-12-23	581452		0	0	0		0	0	0	10012	0	49	40213314		
57911	4811	1118084	1999-10-25	1999-10-25 00:00:00	1999-10-25	1999-10-25 00:00:00	\N	38000177		0	0	0		0	0	0	320046	0	00025152531	44923712		
49889	4139	920334	1996-12-09	1996-12-09 00:00:00	1996-12-16	1996-12-16 00:00:00	1996-12-16	38000177		0	0	7		0	0	0	275154	0	311995	920334		
111236	2443	40213260	2012-11-02	2012-11-02 00:00:00	2012-11-02	2012-11-02 00:00:00	2012-11-02	581452		0	0	0		0	0	0	162054	0	121	40213260		
8781	188	40213160	1963-04-28	1963-04-28 00:00:00	1963-04-28	1963-04-28 00:00:00	1963-04-28	581452		0	0	0		0	0	0	12832	0	10	40213160		
12283	1032	1124300	1989-05-22	1989-05-22 00:00:00	1989-05-22	1989-05-22 00:00:00	\N	38000177		0	0	0		0	0	0	67922	0	00781178901	45011828		
22736	1867	1127433	1990-08-17	1990-08-17 00:00:00	1990-10-16	1990-10-16 00:00:00	1990-10-16	38000177		0	0	60		0	0	0	124729	0	313782	1127433		
171464	3769	40213160	1955-04-17	1955-04-17 00:00:00	1955-04-17	1955-04-17 00:00:00	1955-04-17	581452		0	0	0		0	0	0	250526	0	10	40213160		
5408	453	1127433	1977-02-09	1977-02-09 00:00:00	1977-02-23	1977-02-23 00:00:00	1977-02-23	38000177		0	0	14		0	0	0	30208	0	313782	1127433		
48124	3989	1127433	1974-12-02	1974-12-02 00:00:00	1974-12-16	1974-12-16 00:00:00	1974-12-16	38000177		0	0	14		0	0	0	265250	0	313782	1127433		
56008	1227	40213227	1992-05-20	1992-05-20 00:00:00	1992-05-20	1992-05-20 00:00:00	1992-05-20	581452		0	0	0		0	0	0	80793	0	113	40213227		
68437	1498	40213260	2014-03-18	2014-03-18 00:00:00	2014-03-18	2014-03-18 00:00:00	2014-03-18	581452		0	0	0		0	0	0	99972	0	121	40213260		
59894	4977	19059528	2010-12-08	2010-12-08 00:00:00	2010-12-08	2010-12-08 00:00:00	2010-12-08	38000177		0	0	0		0	0	0	331120	0	480	19059528		
73676	1608	40213227	2002-11-30	2002-11-30 00:00:00	2002-11-30	2002-11-30 00:00:00	2002-11-30	581452		0	0	0		0	0	0	107978	0	113	40213227		
25424	2088	1127433	2002-10-24	2002-10-24 00:00:00	2002-11-14	2002-11-14 00:00:00	2002-11-14	38000177		0	0	21		0	0	0	139184	0	313782	1127433		
44128	3652	19128065	1987-09-06	1987-09-06 00:00:00	1988-08-31	1988-08-31 00:00:00	1988-08-31	38000177		0	0	360		0	0	0	243132	0	749882	19128065		
135702	2980	40213160	1976-07-18	1976-07-18 00:00:00	1976-07-18	1976-07-18 00:00:00	1976-07-18	581452		0	0	0		0	0	0	198980	0	10	40213160		
4353	94	40213227	2013-05-31	2013-05-31 00:00:00	2013-05-31	2013-05-31 00:00:00	2013-05-31	581452		0	0	0		0	0	0	6363	0	113	40213227		
2784	224	1127433	1969-11-25	1969-11-25 00:00:00	1969-12-16	1969-12-16 00:00:00	1969-12-16	38000177		0	0	21		0	0	0	15091	0	313782	1127433		
36118	2976	1713671	1964-05-11	1964-05-11 00:00:00	1964-05-25	1964-05-25 00:00:00	1964-05-25	38000177		0	0	14		0	0	0	198724	0	562251	1713671		
156120	3436	40213227	1995-07-31	1995-07-31 00:00:00	1995-07-31	1995-07-31 00:00:00	1995-07-31	581452		0	0	0		0	0	0	227915	0	113	40213227		
241024	5291	40213314	1977-03-27	1977-03-27 00:00:00	1977-03-27	1977-03-27 00:00:00	1977-03-27	581452		0	0	0		0	0	0	352052	0	49	40213314		
54713	1197	40213306	2000-11-12	2000-11-12 00:00:00	2000-11-12	2000-11-12 00:00:00	2000-11-12	581452		0	0	0		0	0	0	78859	0	43	40213306		
146618	3224	40213296	2003-03-28	2003-03-28 00:00:00	2003-03-28	2003-03-28 00:00:00	2003-03-28	581452		0	0	0		0	0	0	214357	0	52	40213296		
24312	528	40213227	2001-06-08	2001-06-08 00:00:00	2001-06-08	2001-06-08 00:00:00	2001-06-08	581452		0	0	0		0	0	0	35175	0	113	40213227		
57299	4756	1127433	1991-07-18	1991-07-18 00:00:00	1991-08-01	1991-08-01 00:00:00	1991-08-01	38000177		0	0	14		0	0	0	316782	0	313782	1127433		
146758	3227	40213160	1970-03-03	1970-03-03 00:00:00	1970-03-03	1970-03-03 00:00:00	1970-03-03	581452		0	0	0		0	0	0	214504	0	10	40213160		
117666	2586	40213260	2018-08-19	2018-08-19 00:00:00	2018-08-19	2018-08-19 00:00:00	2018-08-19	581452		0	0	0		0	0	0	171137	0	121	40213260		
184428	4053	40213296	2003-12-21	2003-12-21 00:00:00	2003-12-21	2003-12-21 00:00:00	2003-12-21	581452		0	0	0		0	0	0	269460	0	52	40213296		
54391	4521	19059056	1933-04-15	1933-04-15 00:00:00	1933-06-14	1933-06-14 00:00:00	1933-06-14	38000177		0	0	60		0	0	0	301010	0	243670	19059056		
201269	4419	40213227	2007-06-11	2007-06-11 00:00:00	2007-06-11	2007-06-11 00:00:00	2007-06-11	581452		0	0	0		0	0	0	293857	0	113	40213227		
13899	1162	19059056	1952-10-08	1952-10-08 00:00:00	1952-11-07	1952-11-07 00:00:00	1952-11-07	38000177		0	0	30		0	0	0	76729	0	243670	19059056		
48161	3993	1127433	1974-07-03	1974-07-03 00:00:00	1974-07-31	1974-07-31 00:00:00	1974-07-31	38000177		0	0	28		0	0	0	265524	0	313782	1127433		
60545	1323	40213160	1961-10-14	1961-10-14 00:00:00	1961-10-14	1961-10-14 00:00:00	1961-10-14	581452		0	0	0		0	0	0	87854	0	10	40213160		
7662	644	19059056	1977-12-18	1977-12-18 00:00:00	1978-01-01	1978-01-01 00:00:00	1978-01-01	38000177		0	0	14		0	0	0	42648	0	243670	19059056		
19486	1605	46275916	2019-05-12	2019-05-12 00:00:00	2019-05-12	2019-05-12 00:00:00	2019-05-12	38000177		0	0	0		0	0	0	107753	0	1660014	46275916		
16877	1397	40224805	1994-10-26	1994-10-26 00:00:00	1995-10-21	1995-10-21 00:00:00	1995-10-21	38000177		0	0	360		0	0	0	92736	0	1000126	40224805		
19579	1611	19006318	1955-07-23	1955-07-23 00:00:00	1955-08-06	1955-08-06 00:00:00	1955-08-06	38000177		0	0	14		0	0	0	108320	0	105078	19006318		
5972	499	1127433	1997-03-17	1997-03-17 00:00:00	1997-03-31	1997-03-31 00:00:00	1997-03-31	38000177		0	0	14		0	0	0	33336	0	313782	1127433		
48517	4019	19129655	1966-11-06	1966-11-06 00:00:00	1966-11-20	1966-11-20 00:00:00	1966-11-20	38000177		0	0	14		0	0	0	267154	0	789980	19129655		
97209	2131	40213160	1955-12-15	1955-12-15 00:00:00	1955-12-15	1955-12-15 00:00:00	1955-12-15	581452		0	0	0		0	0	0	141815	0	10	40213160		
38037	3145	1127078	1976-03-01	1976-03-01 00:00:00	1976-05-30	1976-05-30 00:00:00	1976-05-30	38000177		0	0	90		0	0	0	209301	0	282464	1127078		
97302	2133	40213296	2007-06-18	2007-06-18 00:00:00	2007-06-18	2007-06-18 00:00:00	2007-06-18	581452		0	0	0		0	0	0	141916	0	52	40213296		
203948	4477	40213296	2005-12-01	2005-12-01 00:00:00	2005-12-01	2005-12-01 00:00:00	2005-12-01	581452		0	0	0		0	0	0	297938	0	52	40213296		
113099	2485	40213227	2004-11-17	2004-11-17 00:00:00	2004-11-17	2004-11-17 00:00:00	2004-11-17	581452		0	0	0		0	0	0	164579	0	113	40213227		
13822	298	40213201	2019-02-12	2019-02-12 00:00:00	2019-02-12	2019-02-12 00:00:00	2019-02-12	581452		0	0	0		0	0	0	19944	0	33	40213201		
199397	4380	40213227	1995-08-14	1995-08-14 00:00:00	1995-08-14	1995-08-14 00:00:00	1995-08-14	581452		0	0	0		0	0	0	291002	0	113	40213227		
52576	4372	1127433	2019-06-04	2019-06-04 00:00:00	2019-06-25	2019-06-25 00:00:00	2019-06-25	38000177		0	0	21		0	0	0	290289	0	313782	1127433		
129520	2847	40213160	1967-01-22	1967-01-22 00:00:00	1967-01-22	1967-01-22 00:00:00	1967-01-22	581452		0	0	0		0	0	0	189070	0	10	40213160		
170578	3750	40213306	1982-09-25	1982-09-25 00:00:00	1982-09-25	1982-09-25 00:00:00	1982-09-25	581452		0	0	0		0	0	0	249267	0	43	40213306		
48381	4010	19133905	2015-10-21	2015-10-21 00:00:00	2015-10-31	2015-10-31 00:00:00	2015-10-31	38000177		0	0	10		0	0	0	266455	0	834102	19133905		
12514	1054	1127433	2000-02-03	2000-02-03 00:00:00	2000-05-03	2000-05-03 00:00:00	2000-05-03	38000177		0	0	90		0	0	0	69136	0	313782	1127433		
72769	1590	40213306	1982-06-06	1982-06-06 00:00:00	1982-06-06	1982-06-06 00:00:00	1982-06-06	581452		0	0	0		0	0	0	106731	0	43	40213306		
216458	4750	40213296	2005-08-03	2005-08-03 00:00:00	2005-08-03	2005-08-03 00:00:00	2005-08-03	581452		0	0	0		0	0	0	316377	0	52	40213296		
84149	1840	40213296	2015-04-25	2015-04-25 00:00:00	2015-04-25	2015-04-25 00:00:00	2015-04-25	581452		0	0	0		0	0	0	122822	0	52	40213296		
63804	5300	40165015	2018-03-18	2018-03-18 00:00:00	2018-03-18	2018-03-18 00:00:00	\N	38000177		0	0	0		0	0	0	352657	0	861467	40165015		
64066	5322	40232448	1950-02-11	1950-02-11 00:00:00	1950-02-11	1950-02-11 00:00:00	\N	38000177		0	0	0		0	0	0	354071	0	1049630	40232448		
28555	2352	19133905	2013-02-10	2013-02-10 00:00:00	2013-02-18	2013-02-18 00:00:00	2013-02-18	38000177		0	0	8		0	0	0	156603	0	834102	19133905		
160868	3540	40213227	1997-11-03	1997-11-03 00:00:00	1997-11-03	1997-11-03 00:00:00	1997-11-03	581452		0	0	0		0	0	0	235120	0	113	40213227		
47190	3913	1127433	1972-01-01	1972-01-01 00:00:00	1972-01-15	1972-01-15 00:00:00	1972-01-15	38000177		0	0	14		0	0	0	260171	0	313782	1127433		
34730	2868	1127078	1966-06-21	1966-06-21 00:00:00	1966-07-05	1966-07-05 00:00:00	1966-07-05	38000177		0	0	14		0	0	0	190803	0	282464	1127078		
99709	2184	40213260	2017-06-21	2017-06-21 00:00:00	2017-06-21	2017-06-21 00:00:00	2017-06-21	581452		0	0	0		0	0	0	145557	0	121	40213260		
41351	3430	19059056	1972-10-15	1972-10-15 00:00:00	1973-01-13	1973-01-13 00:00:00	1973-01-13	38000177		0	0	90		0	0	0	227329	0	243670	19059056		
149613	3290	40213227	1992-02-19	1992-02-19 00:00:00	1992-02-19	1992-02-19 00:00:00	1992-02-19	581452		0	0	0		0	0	0	218570	0	113	40213227		
6835	148	40213160	1983-09-25	1983-09-25 00:00:00	1983-09-25	1983-09-25 00:00:00	1983-09-25	581452		0	0	0		0	0	0	10014	0	10	40213160		
57912	4811	1713671	2003-07-07	2003-07-07 00:00:00	2003-07-28	2003-07-28 00:00:00	2003-07-28	38000177		0	0	21		0	0	0	320077	0	562251	1713671		
49890	4139	1115171	1994-11-30	1994-11-30 00:00:00	1995-02-28	1995-02-28 00:00:00	1995-02-28	38000177		0	0	90		0	0	0	275166	0	849574	1115171		
111240	2444	40213227	2016-10-09	2016-10-09 00:00:00	2016-10-09	2016-10-09 00:00:00	2016-10-09	581452		0	0	0		0	0	0	162151	0	113	40213227		
8790	188	40213160	1967-10-29	1967-10-29 00:00:00	1967-10-29	1967-10-29 00:00:00	1967-10-29	581452		0	0	0		0	0	0	12775	0	10	40213160		
12284	1032	1713671	1976-08-25	1976-08-25 00:00:00	1976-11-17	1976-11-17 00:00:00	1976-11-17	38000177		0	0	84		0	0	0	67883	0	562251	1713671		
22737	1867	19073183	1981-07-30	1981-07-30 00:00:00	1981-08-13	1981-08-13 00:00:00	1981-08-13	38000177		0	0	14		0	0	0	124707	0	308182	19073183		
171470	3769	40213227	2000-07-02	2000-07-02 00:00:00	2000-07-02	2000-07-02 00:00:00	2000-07-02	581452		0	0	0		0	0	0	250500	0	113	40213227		
5409	453	1118084	2004-05-26	2004-05-26 00:00:00	2004-05-26	2004-05-26 00:00:00	\N	38000177		0	0	0		0	0	0	30198	0	00025152531	44923712		
48125	3989	19059056	1928-10-27	1928-10-27 00:00:00	1928-11-10	1928-11-10 00:00:00	1928-11-10	38000177		0	0	14		0	0	0	265237	0	243670	19059056		
56016	1227	40213227	2009-08-26	2009-08-26 00:00:00	2009-08-26	2009-08-26 00:00:00	2009-08-26	581452		0	0	0		0	0	0	80768	0	113	40213227		
68444	1498	40213296	2004-03-22	2004-03-22 00:00:00	2004-03-22	2004-03-22 00:00:00	2004-03-22	581452		0	0	0		0	0	0	99971	0	52	40213296		
59895	4977	1127433	2013-11-09	2013-11-09 00:00:00	2013-12-14	2013-12-14 00:00:00	2013-12-14	38000177		0	0	35		0	0	0	331121	0	313782	1127433		
71905	1571	40213160	1955-09-09	1955-09-09 00:00:00	1955-09-09	1955-09-09 00:00:00	1955-09-09	581452		0	0	0		0	0	0	105513	0	10	40213160		
25425	2088	1713671	1935-02-09	1935-02-09 00:00:00	1935-02-16	1935-02-16 00:00:00	1935-02-16	38000177		0	0	7		0	0	0	139168	0	562251	1713671		
44129	3652	1118084	2009-05-23	2009-05-23 00:00:00	2009-05-23	2009-05-23 00:00:00	\N	38000177		0	0	0		0	0	0	243110	0	00025152531	44923712		
135706	2980	40213227	2003-07-20	2003-07-20 00:00:00	2003-07-20	2003-07-20 00:00:00	2003-07-20	581452		0	0	0		0	0	0	198912	0	113	40213227		
4360	94	40213160	1955-03-04	1955-03-04 00:00:00	1955-03-04	1955-03-04 00:00:00	1955-03-04	581452		0	0	0		0	0	0	6307	0	10	40213160		
2785	224	40174880	2016-09-24	2016-09-24 00:00:00	2016-09-24	2016-09-24 00:00:00	\N	38000177		0	0	0		0	0	0	15027	0	966222	40174880		
36119	2976	19074679	1955-06-23	1955-06-23 00:00:00	1955-11-03	1955-11-03 00:00:00	1955-11-03	38000177		0	0	133		0	0	0	198734	0	308971	19074679		
156122	3436	40213296	2006-02-27	2006-02-27 00:00:00	2006-02-27	2006-02-27 00:00:00	2006-02-27	581452		0	0	0		0	0	0	227840	0	52	40213296		
241025	5291	40213160	1976-06-27	1976-06-27 00:00:00	1976-06-27	1976-06-27 00:00:00	1976-06-27	581452		0	0	0		0	0	0	352051	0	10	40213160		
54715	1197	40213227	2000-11-12	2000-11-12 00:00:00	2000-11-12	2000-11-12 00:00:00	2000-11-12	581452		0	0	0		0	0	0	78859	0	113	40213227		
146619	3224	40213160	1960-06-24	1960-06-24 00:00:00	1960-06-24	1960-06-24 00:00:00	1960-06-24	581452		0	0	0		0	0	0	214349	0	10	40213160		
24313	528	40213296	2001-06-08	2001-06-08 00:00:00	2001-06-08	2001-06-08 00:00:00	2001-06-08	581452		0	0	0		0	0	0	35175	0	52	40213296		
57300	4756	19059056	1969-05-25	1969-05-25 00:00:00	1969-06-22	1969-06-22 00:00:00	1969-06-22	38000177		0	0	28		0	0	0	316861	0	243670	19059056		
146766	3227	40213160	1969-12-30	1969-12-30 00:00:00	1969-12-30	1969-12-30 00:00:00	1969-12-30	581452		0	0	0		0	0	0	214534	0	10	40213160		
117672	2586	40213160	1973-06-10	1973-06-10 00:00:00	1973-06-10	1973-06-10 00:00:00	1973-06-10	581452		0	0	0		0	0	0	171166	0	10	40213160		
184430	4053	40213227	1993-12-05	1993-12-05 00:00:00	1993-12-05	1993-12-05 00:00:00	1993-12-05	581452		0	0	0		0	0	0	269443	0	113	40213227		
54392	4521	1127433	1951-12-07	1951-12-07 00:00:00	1951-12-28	1951-12-28 00:00:00	1951-12-28	38000177		0	0	21		0	0	0	301011	0	313782	1127433		
201271	4419	40213227	1997-09-01	1997-09-01 00:00:00	1997-09-01	1997-09-01 00:00:00	1997-09-01	581452		0	0	0		0	0	0	293800	0	113	40213227		
13900	1162	40162522	1952-10-08	1952-10-08 00:00:00	1952-10-08	1952-10-08 00:00:00	\N	38000177		0	0	0		0	0	0	76729	0	857005	40162522		
48162	3993	1127433	1990-07-20	1990-07-20 00:00:00	1990-07-27	1990-07-27 00:00:00	1990-07-27	38000177		0	0	7		0	0	0	265458	0	313782	1127433		
60553	1323	40213160	1962-01-13	1962-01-13 00:00:00	1962-01-13	1962-01-13 00:00:00	1962-01-13	581452		0	0	0		0	0	0	87810	0	10	40213160		
7663	644	1127433	2003-11-04	2003-11-04 00:00:00	2003-11-11	2003-11-11 00:00:00	2003-11-11	38000177		0	0	7		0	0	0	42636	0	313782	1127433		
19487	1605	1310034	2019-05-12	2019-05-12 00:00:00	2019-05-12	2019-05-12 00:00:00	2019-05-12	38000177		0	0	0		0	0	0	107753	0	834357	1310034		
16878	1397	1127433	2001-01-10	2001-01-10 00:00:00	2001-01-31	2001-01-31 00:00:00	2001-01-31	38000177		0	0	21		0	0	0	92839	0	313782	1127433		
19580	1611	19133873	1952-08-09	1952-08-09 00:00:00	1952-08-22	1952-08-22 00:00:00	1952-08-22	38000177		0	0	13		0	0	0	108347	0	834061	19133873		
5973	499	40229134	1973-05-20	1973-05-20 00:00:00	1973-06-03	1973-06-03 00:00:00	1973-06-03	38000177		0	0	14		0	0	0	33318	0	1043400	40229134		
48518	4019	1127078	1966-11-06	1966-11-06 00:00:00	1966-11-20	1966-11-20 00:00:00	1966-11-20	38000177		0	0	14		0	0	0	267154	0	282464	1127078		
97211	2131	40213227	1993-08-05	1993-08-05 00:00:00	1993-08-05	1993-08-05 00:00:00	1993-08-05	581452		0	0	0		0	0	0	141805	0	113	40213227		
38038	3145	40229134	1987-09-01	1987-09-01 00:00:00	1987-09-08	1987-09-08 00:00:00	1987-09-08	38000177		0	0	7		0	0	0	209256	0	1043400	40229134		
97304	2133	40213227	2007-06-18	2007-06-18 00:00:00	2007-06-18	2007-06-18 00:00:00	2007-06-18	581452		0	0	0		0	0	0	141916	0	113	40213227		
118006	2594	40213160	1975-11-05	1975-11-05 00:00:00	1975-11-05	1975-11-05 00:00:00	1975-11-05	581452		0	0	0		0	0	0	171685	0	10	40213160		
184074	4044	40213227	2001-05-13	2001-05-13 00:00:00	2001-05-13	2001-05-13 00:00:00	2001-05-13	581452		0	0	0		0	0	0	268961	0	113	40213227		
13827	298	40213160	1957-02-12	1957-02-12 00:00:00	1957-02-12	1957-02-12 00:00:00	1957-02-12	581452		0	0	0		0	0	0	19879	0	10	40213160		
199401	4380	40213227	2006-05-01	2006-05-01 00:00:00	2006-05-01	2006-05-01 00:00:00	2006-05-01	581452		0	0	0		0	0	0	291055	0	113	40213227		
52577	4372	40229134	1982-01-30	1982-01-30 00:00:00	1982-02-06	1982-02-06 00:00:00	1982-02-06	38000177		0	0	7		0	0	0	290261	0	1043400	40229134		
129521	2847	40213260	2013-02-10	2013-02-10 00:00:00	2013-02-10	2013-02-10 00:00:00	2013-02-10	581452		0	0	0		0	0	0	189130	0	121	40213260		
170581	3750	40213227	1993-02-06	1993-02-06 00:00:00	1993-02-06	1993-02-06 00:00:00	1993-02-06	581452		0	0	0		0	0	0	249202	0	113	40213227		
48383	4010	43012754	1991-05-02	1991-05-02 00:00:00	1992-04-26	1992-04-26 00:00:00	1992-04-26	38000177		0	0	360		0	0	0	266496	0	1366343	43012754		
12515	1054	40162522	2000-02-03	2000-02-03 00:00:00	2000-02-03	2000-02-03 00:00:00	\N	38000177		0	0	0		0	0	0	69136	0	857005	40162522		
72774	1590	40213160	1960-07-10	1960-07-10 00:00:00	1960-07-10	1960-07-10 00:00:00	1960-07-10	581452		0	0	0		0	0	0	106689	0	10	40213160		
216466	4750	40213160	1963-12-18	1963-12-18 00:00:00	1963-12-18	1963-12-18 00:00:00	1963-12-18	581452		0	0	0		0	0	0	316405	0	10	40213160		
84154	1840	40213314	1977-09-24	1977-09-24 00:00:00	1977-09-24	1977-09-24 00:00:00	1977-09-24	581452		0	0	0		0	0	0	122829	0	49	40213314		
63805	5300	1127433	1998-11-10	1998-11-10 00:00:00	1998-11-17	1998-11-17 00:00:00	1998-11-17	38000177		0	0	7		0	0	0	352642	0	313782	1127433		
64067	5322	1551192	1963-06-27	1963-06-27 00:00:00	1963-06-27	1963-06-27 00:00:00	1963-06-27	38000177		0	0	0		0	0	0	354088	0	312617	1551192		
28556	2352	1118084	2012-08-01	2012-08-01 00:00:00	2012-08-01	2012-08-01 00:00:00	\N	38000177		0	0	0		0	0	0	156614	0	00025152531	44923712		
160869	3540	40213306	1997-11-03	1997-11-03 00:00:00	1997-11-03	1997-11-03 00:00:00	1997-11-03	581452		0	0	0		0	0	0	235120	0	43	40213306		
47191	3913	19133873	1979-06-24	1979-06-24 00:00:00	1979-07-01	1979-07-01 00:00:00	1979-07-01	38000177		0	0	7		0	0	0	260172	0	834061	19133873		
34731	2868	19129655	1966-06-21	1966-06-21 00:00:00	1966-07-05	1966-07-05 00:00:00	1966-07-05	38000177		0	0	14		0	0	0	190803	0	789980	19129655		
99718	2184	40213227	2008-04-30	2008-04-30 00:00:00	2008-04-30	2008-04-30 00:00:00	2008-04-30	581452		0	0	0		0	0	0	145555	0	113	40213227		
41352	3430	19078461	2005-09-22	2005-09-22 00:00:00	2005-10-13	2005-10-13 00:00:00	2005-10-13	38000177		0	0	21		0	0	0	227363	0	310965	19078461		
149614	3290	40213306	1992-02-19	1992-02-19 00:00:00	1992-02-19	1992-02-19 00:00:00	1992-02-19	581452		0	0	0		0	0	0	218570	0	43	40213306		
6838	148	40213251	1984-09-30	1984-09-30 00:00:00	1984-09-30	1984-09-30 00:00:00	1984-09-30	581452		0	0	0		0	0	0	9995	0	21	40213251		
57913	4812	19126352	2011-07-27	2011-07-27 00:00:00	2011-07-27	2011-07-27 00:00:00	\N	38000177		0	0	0		0	0	0	320171	0	705129	19126352		
49891	4139	40236824	1996-12-02	1996-12-02 00:00:00	1996-12-16	1996-12-16 00:00:00	1996-12-16	38000177		0	0	14		0	0	0	275103	0	1094107	40236824		
111243	2444	40213160	1956-01-15	1956-01-15 00:00:00	1956-01-15	1956-01-15 00:00:00	1956-01-15	581452		0	0	0		0	0	0	162135	0	10	40213160		
84675	1852	40213227	2007-02-07	2007-02-07 00:00:00	2007-02-07	2007-02-07 00:00:00	2007-02-07	581452		0	0	0		0	0	0	123941	0	113	40213227		
22757	1870	1127433	1947-10-21	1947-10-21 00:00:00	1947-11-04	1947-11-04 00:00:00	1947-11-04	38000177		0	0	14		0	0	0	124948	0	313782	1127433		
22738	1867	1127078	1981-07-30	1981-07-30 00:00:00	1981-08-13	1981-08-13 00:00:00	1981-08-13	38000177		0	0	14		0	0	0	124707	0	282464	1127078		
180937	3976	40213227	2014-05-01	2014-05-01 00:00:00	2014-05-01	2014-05-01 00:00:00	2014-05-01	581452		0	0	0		0	0	0	264368	0	113	40213227		
5410	453	46233988	1976-03-28	1976-03-28 00:00:00	1976-04-11	1976-04-11 00:00:00	1976-04-11	38000177		0	0	14		0	0	0	30199	0	1652673	46233988		
48126	3989	1127433	1959-01-20	1959-01-20 00:00:00	1959-02-03	1959-02-03 00:00:00	1959-02-03	38000177		0	0	14		0	0	0	265155	0	313782	1127433		
56022	1227	40213227	1999-06-30	1999-06-30 00:00:00	1999-06-30	1999-06-30 00:00:00	1999-06-30	581452		0	0	0		0	0	0	80731	0	113	40213227		
68448	1498	40213227	1995-05-30	1995-05-30 00:00:00	1995-05-30	1995-05-30 00:00:00	1995-05-30	581452		0	0	0		0	0	0	99958	0	113	40213227		
59896	4977	1127433	2015-03-31	2015-03-31 00:00:00	2015-04-14	2015-04-14 00:00:00	2015-04-14	38000177		0	0	14		0	0	0	331114	0	313782	1127433		
71910	1571	40213227	2015-07-24	2015-07-24 00:00:00	2015-07-24	2015-07-24 00:00:00	2015-07-24	581452		0	0	0		0	0	0	105456	0	113	40213227		
25426	2088	40229134	1983-06-11	1983-06-11 00:00:00	1983-06-25	1983-06-25 00:00:00	1983-06-25	38000177		0	0	14		0	0	0	139230	0	1043400	40229134		
44130	3652	19133905	2002-05-11	2002-05-11 00:00:00	2002-05-21	2002-05-21 00:00:00	2002-05-21	38000177		0	0	10		0	0	0	243081	0	834102	19133905		
135709	2980	40213160	1972-05-28	1972-05-28 00:00:00	1972-05-28	1972-05-28 00:00:00	1972-05-28	581452		0	0	0		0	0	0	198925	0	10	40213160		
4367	94	40213160	1956-03-02	1956-03-02 00:00:00	1956-03-02	1956-03-02 00:00:00	1956-03-02	581452		0	0	0		0	0	0	6384	0	10	40213160		
2786	224	19074679	1955-11-22	1955-11-22 00:00:00	1956-04-03	1956-04-03 00:00:00	1956-04-03	38000177		0	0	133		0	0	0	15121	0	308971	19074679		
36120	2976	19115351	1955-12-01	1955-12-01 00:00:00	1956-07-19	1956-07-19 00:00:00	1956-07-19	38000177		0	0	231		0	0	0	198707	0	563026	19115351		
156128	3436	40213260	2013-03-18	2013-03-18 00:00:00	2013-03-18	2013-03-18 00:00:00	2013-03-18	581452		0	0	0		0	0	0	227887	0	121	40213260		
241028	5291	40213227	2008-01-20	2008-01-20 00:00:00	2008-01-20	2008-01-20 00:00:00	2008-01-20	581452		0	0	0		0	0	0	352038	0	113	40213227		
54719	1197	40213160	1983-03-06	1983-03-06 00:00:00	1983-03-06	1983-03-06 00:00:00	1983-03-06	581452		0	0	0		0	0	0	78869	0	10	40213160		
146626	3224	40213306	1981-02-27	1981-02-27 00:00:00	1981-02-27	1981-02-27 00:00:00	1981-02-27	581452		0	0	0		0	0	0	214365	0	43	40213306		
24316	528	40213227	1993-08-13	1993-08-13 00:00:00	1993-08-13	1993-08-13 00:00:00	1993-08-13	581452		0	0	0		0	0	0	35172	0	113	40213227		
57301	4756	40173590	2004-09-11	2004-09-11 00:00:00	2004-09-11	2004-09-11 00:00:00	\N	38000177		0	0	0		0	0	0	316875	0	904419	40173590		
146770	3227	40213296	2010-05-25	2010-05-25 00:00:00	2010-05-25	2010-05-25 00:00:00	2010-05-25	581452		0	0	0		0	0	0	214557	0	52	40213296		
117677	2586	40213160	1968-12-08	1968-12-08 00:00:00	1968-12-08	1968-12-08 00:00:00	1968-12-08	581452		0	0	0		0	0	0	171203	0	10	40213160		
184435	4053	40213260	2011-11-27	2011-11-27 00:00:00	2011-11-27	2011-11-27 00:00:00	2011-11-27	581452		0	0	0		0	0	0	269461	0	121	40213260		
51727	4297	19073183	1984-03-04	1984-03-04 00:00:00	1984-03-18	1984-03-18 00:00:00	1984-03-18	38000177		0	0	14		0	0	0	285197	0	308182	19073183		
201272	4419	40213296	1997-09-01	1997-09-01 00:00:00	1997-09-01	1997-09-01 00:00:00	1997-09-01	581452		0	0	0		0	0	0	293800	0	52	40213296		
13901	1162	1713671	1943-04-06	1943-04-06 00:00:00	1943-04-27	1943-04-27 00:00:00	1943-04-27	38000177		0	0	21		0	0	0	76704	0	562251	1713671		
48163	3993	40236824	1961-01-20	1961-01-20 00:00:00	1961-02-03	1961-02-03 00:00:00	1961-02-03	38000177		0	0	14		0	0	0	265506	0	1094107	40236824		
195936	4305	40213160	1958-05-02	1958-05-02 00:00:00	1958-05-02	1958-05-02 00:00:00	1958-05-02	581452		0	0	0		0	0	0	285533	0	10	40213160		
7664	644	40229134	1984-09-22	1984-09-22 00:00:00	1984-09-29	1984-09-29 00:00:00	1984-09-29	38000177		0	0	7		0	0	0	42656	0	1043400	40229134		
19488	1605	1127433	2011-05-22	2011-05-22 00:00:00	2011-08-30	2011-08-30 00:00:00	2011-08-30	38000177		0	0	100		0	0	0	107781	0	313782	1127433		
16879	1397	19128022	1993-10-31	1993-10-31 00:00:00	1994-10-26	1994-10-26 00:00:00	1994-10-26	38000177		0	0	360		0	0	0	92750	0	749785	19128022		
19581	1611	19078461	2013-11-29	2013-11-29 00:00:00	2013-12-20	2013-12-20 00:00:00	2013-12-20	38000177		0	0	21		0	0	0	108356	0	310965	19078461		
5974	499	1713671	1995-10-13	1995-10-13 00:00:00	1995-11-03	1995-11-03 00:00:00	1995-11-03	38000177		0	0	21		0	0	0	33474	0	562251	1713671		
48519	4019	19078461	1979-12-28	1979-12-28 00:00:00	1980-01-11	1980-01-11 00:00:00	1980-01-11	38000177		0	0	14		0	0	0	267169	0	310965	19078461		
97220	2131	40213227	2002-08-01	2002-08-01 00:00:00	2002-08-01	2002-08-01 00:00:00	2002-08-01	581452		0	0	0		0	0	0	141834	0	113	40213227		
38039	3145	1127433	2005-05-08	2005-05-08 00:00:00	2005-05-15	2005-05-15 00:00:00	2005-05-15	38000177		0	0	7		0	0	0	209287	0	313782	1127433		
97307	2133	40213227	1996-08-19	1996-08-19 00:00:00	1996-08-19	1996-08-19 00:00:00	1996-08-19	581452		0	0	0		0	0	0	141925	0	113	40213227		
118009	2594	40213160	1975-06-04	1975-06-04 00:00:00	1975-06-04	1975-06-04 00:00:00	1975-06-04	581452		0	0	0		0	0	0	171684	0	10	40213160		
184075	4044	40213296	2001-05-13	2001-05-13 00:00:00	2001-05-13	2001-05-13 00:00:00	2001-05-13	581452		0	0	0		0	0	0	268961	0	52	40213296		
15954	343	40213160	1975-01-11	1975-01-11 00:00:00	1975-01-11	1975-01-11 00:00:00	1975-01-11	581452		0	0	0		0	0	0	22961	0	10	40213160		
199403	4380	40213296	2006-05-01	2006-05-01 00:00:00	2006-05-01	2006-05-01 00:00:00	2006-05-01	581452		0	0	0		0	0	0	291055	0	52	40213296		
52578	4372	19112599	1981-01-19	1981-01-19 00:00:00	1981-01-19	1981-01-19 00:00:00	\N	38000177		0	0	0		0	0	0	290260	0	477045	19112599		
129524	2847	40213227	2014-02-16	2014-02-16 00:00:00	2014-02-16	2014-02-16 00:00:00	2014-02-16	581452		0	0	0		0	0	0	189060	0	113	40213227		
7633	642	19059056	1935-10-26	1935-10-26 00:00:00	1936-01-08	1936-01-08 00:00:00	1936-01-08	38000177		0	0	74		0	0	0	42461	0	243670	19059056		
48384	4010	19115351	1978-07-13	1978-07-13 00:00:00	1978-07-13	1978-07-13 00:00:00	\N	38000177		0	0	0		0	0	0	266460	0	563026	19115351		
12516	1054	1127433	1999-11-12	1999-11-12 00:00:00	1999-11-26	1999-11-26 00:00:00	1999-11-26	38000177		0	0	14		0	0	0	69127	0	313782	1127433		
72777	1590	40213296	2000-10-08	2000-10-08 00:00:00	2000-10-08	2000-10-08 00:00:00	2000-10-08	581452		0	0	0		0	0	0	106734	0	52	40213296		
216470	4750	40213160	1963-07-17	1963-07-17 00:00:00	1963-07-17	1963-07-17 00:00:00	1963-07-17	581452		0	0	0		0	0	0	316404	0	10	40213160		
84156	1840	40213296	2016-02-27	2016-02-27 00:00:00	2016-02-27	2016-02-27 00:00:00	2016-02-27	581452		0	0	0		0	0	0	122814	0	52	40213296		
63806	5300	1127433	1965-04-09	1965-04-09 00:00:00	1965-04-23	1965-04-23 00:00:00	1965-04-23	38000177		0	0	14		0	0	0	352635	0	313782	1127433		
64068	5322	19059056	1947-06-21	1947-06-21 00:00:00	1947-07-05	1947-07-05 00:00:00	1947-07-05	38000177		0	0	14		0	0	0	354134	0	243670	19059056		
28557	2352	19133905	2018-08-02	2018-08-02 00:00:00	2018-08-13	2018-08-13 00:00:00	2018-08-13	38000177		0	0	11		0	0	0	156742	0	834102	19133905		
160873	3540	40213160	1979-01-08	1979-01-08 00:00:00	1979-01-08	1979-01-08 00:00:00	1979-01-08	581452		0	0	0		0	0	0	235158	0	10	40213160		
47192	3913	1127433	1996-10-19	1996-10-19 00:00:00	1996-11-02	1996-11-02 00:00:00	1996-11-02	38000177		0	0	14		0	0	0	260087	0	313782	1127433		
34732	2868	19133873	1968-02-12	1968-02-12 00:00:00	1968-02-24	1968-02-24 00:00:00	1968-02-24	38000177		0	0	12		0	0	0	190801	0	834061	19133873		
99719	2184	40213296	2008-04-30	2008-04-30 00:00:00	2008-04-30	2008-04-30 00:00:00	2008-04-30	581452		0	0	0		0	0	0	145555	0	52	40213296		
41353	3430	19075601	2012-04-14	2012-04-14 00:00:00	2012-04-14	2012-04-14 00:00:00	\N	38000177		0	0	0		0	0	0	227376	0	309362	19075601		
149622	3290	40213160	1969-09-10	1969-09-10 00:00:00	1969-09-10	1969-09-10 00:00:00	1969-09-10	581452		0	0	0		0	0	0	218601	0	10	40213160		
236604	5195	40213227	1992-05-06	1992-05-06 00:00:00	1992-05-06	1992-05-06 00:00:00	1992-05-06	581452		0	0	0		0	0	0	345423	0	113	40213227		
57914	4812	19075601	2011-07-27	2011-07-27 00:00:00	2011-07-27	2011-07-27 00:00:00	\N	38000177		0	0	0		0	0	0	320171	0	309362	19075601		
49892	4139	920300	1996-12-02	1996-12-02 00:00:00	1996-12-09	1996-12-09 00:00:00	1996-12-09	38000177		0	0	7		0	0	0	275103	0	311989	920300		
111248	2444	40213260	2007-08-19	2007-08-19 00:00:00	2007-08-19	2007-08-19 00:00:00	2007-08-19	581452		0	0	0		0	0	0	162150	0	121	40213260		
84683	1852	40213296	2017-02-22	2017-02-22 00:00:00	2017-02-22	2017-02-22 00:00:00	2017-02-22	581452		0	0	0		0	0	0	123944	0	52	40213296		
22758	1870	1127433	1927-04-13	1927-04-13 00:00:00	1927-04-20	1927-04-20 00:00:00	1927-04-20	38000177		0	0	7		0	0	0	124924	0	313782	1127433		
33204	2752	19078461	1982-10-20	1982-10-20 00:00:00	1982-11-17	1982-11-17 00:00:00	1982-11-17	38000177		0	0	28		0	0	0	182117	0	310965	19078461		
180938	3976	40213260	2014-05-01	2014-05-01 00:00:00	2014-05-01	2014-05-01 00:00:00	2014-05-01	581452		0	0	0		0	0	0	264368	0	121	40213260		
48053	3984	19006318	1956-08-28	1956-08-28 00:00:00	1956-09-11	1956-09-11 00:00:00	1956-09-11	38000177		0	0	14		0	0	0	264846	0	105078	19006318		
48127	3989	1127433	1999-01-26	1999-01-26 00:00:00	1999-02-09	1999-02-09 00:00:00	1999-02-09	38000177		0	0	14		0	0	0	265173	0	313782	1127433		
56025	1227	40213201	2004-07-28	2004-07-28 00:00:00	2004-07-28	2004-07-28 00:00:00	2004-07-28	581452		0	0	0		0	0	0	80762	0	33	40213201		
68452	1498	40213160	1964-11-23	1964-11-23 00:00:00	1964-11-23	1964-11-23 00:00:00	1964-11-23	581452		0	0	0		0	0	0	99940	0	10	40213160		
59897	4977	1713671	1974-10-19	1974-10-19 00:00:00	1974-10-26	1974-10-26 00:00:00	1974-10-26	38000177		0	0	7		0	0	0	331186	0	562251	1713671		
71915	1572	40213227	2004-07-02	2004-07-02 00:00:00	2004-07-02	2004-07-02 00:00:00	2004-07-02	581452		0	0	0		0	0	0	105592	0	113	40213227		
25427	2088	1713671	1981-05-14	1981-05-14 00:00:00	1981-05-28	1981-05-28 00:00:00	1981-05-28	38000177		0	0	14		0	0	0	139229	0	562251	1713671		
44131	3652	1713671	2010-07-11	2010-07-11 00:00:00	2010-07-25	2010-07-25 00:00:00	2010-07-25	38000177		0	0	14		0	0	0	243116	0	562251	1713671		
135711	2980	40213306	1994-07-10	1994-07-10 00:00:00	1994-07-10	1994-07-10 00:00:00	1994-07-10	581452		0	0	0		0	0	0	199003	0	43	40213306		
4372	94	40213201	2018-12-28	2018-12-28 00:00:00	2018-12-28	2018-12-28 00:00:00	2018-12-28	581452		0	0	0		0	0	0	6366	0	33	40213201		
2787	224	1127433	1959-09-14	1959-09-14 00:00:00	1959-10-19	1959-10-19 00:00:00	1959-10-19	38000177		0	0	35		0	0	0	15090	0	313782	1127433		
36121	2976	19006318	1958-01-08	1958-01-08 00:00:00	1958-01-22	1958-01-22 00:00:00	1958-01-22	38000177		0	0	14		0	0	0	198753	0	105078	19006318		
156133	3436	40213160	1967-08-14	1967-08-14 00:00:00	1967-08-14	1967-08-14 00:00:00	1967-08-14	581452		0	0	0		0	0	0	227898	0	10	40213160		
241030	5291	40213160	1976-03-28	1976-03-28 00:00:00	1976-03-28	1976-03-28 00:00:00	1976-03-28	581452		0	0	0		0	0	0	352078	0	10	40213160		
147241	3237	40213201	1993-02-10	1993-02-10 00:00:00	1993-02-10	1993-02-10 00:00:00	1993-02-10	581452		0	0	0		0	0	0	215227	0	33	40213201		
146629	3224	40213160	1960-09-23	1960-09-23 00:00:00	1960-09-23	1960-09-23 00:00:00	1960-09-23	581452		0	0	0		0	0	0	214387	0	10	40213160		
24321	528	40213306	1981-07-31	1981-07-31 00:00:00	1981-07-31	1981-07-31 00:00:00	1981-07-31	581452		0	0	0		0	0	0	35212	0	43	40213306		
57302	4756	1124300	1985-04-16	1985-04-16 00:00:00	1985-04-16	1985-04-16 00:00:00	\N	38000177		0	0	0		0	0	0	316847	0	00781178901	45011828		
146775	3227	40213160	1974-09-03	1974-09-03 00:00:00	1974-09-03	1974-09-03 00:00:00	1974-09-03	581452		0	0	0		0	0	0	214506	0	10	40213160		
54287	4513	40162522	1976-03-27	1976-03-27 00:00:00	1976-03-27	1976-03-27 00:00:00	\N	38000177		0	0	0		0	0	0	300569	0	857005	40162522		
184441	4053	40213160	1962-05-06	1962-05-06 00:00:00	1962-05-06	1962-05-06 00:00:00	1962-05-06	581452		0	0	0		0	0	0	269470	0	10	40213160		
51728	4297	1127078	1976-11-03	1976-11-03 00:00:00	1976-11-17	1976-11-17 00:00:00	1976-11-17	38000177		0	0	14		0	0	0	285199	0	282464	1127078		
109075	2392	40213201	1983-12-16	1983-12-16 00:00:00	1983-12-16	1983-12-16 00:00:00	1983-12-16	581452		0	0	0		0	0	0	159079	0	33	40213201		
13902	1162	1127433	1922-12-31	1922-12-31 00:00:00	1923-01-14	1923-01-14 00:00:00	1923-01-14	38000177		0	0	14		0	0	0	76673	0	313782	1127433		
48164	3993	920300	1961-01-20	1961-01-20 00:00:00	1961-01-27	1961-01-27 00:00:00	1961-01-27	38000177		0	0	7		0	0	0	265506	0	311989	920300		
195938	4305	40213160	1958-02-28	1958-02-28 00:00:00	1958-02-28	1958-02-28 00:00:00	1958-02-28	581452		0	0	0		0	0	0	285646	0	10	40213160		
7665	644	40229134	1980-09-26	1980-09-26 00:00:00	1980-10-10	1980-10-10 00:00:00	1980-10-10	38000177		0	0	14		0	0	0	42643	0	1043400	40229134		
19489	1606	1713671	2006-05-06	2006-05-06 00:00:00	2006-08-12	2006-08-12 00:00:00	2006-08-12	38000177		0	0	98		0	0	0	107805	0	562251	1713671		
16880	1397	19128022	1996-10-15	1996-10-15 00:00:00	1997-10-10	1997-10-10 00:00:00	1997-10-10	38000177		0	0	360		0	0	0	92767	0	749785	19128022		
19582	1611	1127433	1990-09-07	1990-09-07 00:00:00	1990-09-21	1990-09-21 00:00:00	1990-09-21	38000177		0	0	14		0	0	0	108337	0	313782	1127433		
5975	499	1551192	1959-10-21	1959-10-21 00:00:00	1959-10-21	1959-10-21 00:00:00	1959-10-21	38000177		0	0	0		0	0	0	33413	0	312617	1551192		
48520	4020	1124300	1999-03-11	1999-03-11 00:00:00	1999-03-11	1999-03-11 00:00:00	\N	38000177		0	0	0		0	0	0	267261	0	00781178901	45011828		
21273	1750	40165015	2012-09-09	2012-09-09 00:00:00	2012-09-09	2012-09-09 00:00:00	\N	38000177		0	0	0		0	0	0	117017	0	861467	40165015		
38040	3145	1127078	1974-05-11	1974-05-11 00:00:00	1974-06-10	1974-06-10 00:00:00	1974-06-10	38000177		0	0	30		0	0	0	209300	0	282464	1127078		
97312	2133	40213160	1965-09-13	1965-09-13 00:00:00	1965-09-13	1965-09-13 00:00:00	1965-09-13	581452		0	0	0		0	0	0	141897	0	10	40213160		
118011	2594	40213227	2017-06-07	2017-06-07 00:00:00	2017-06-07	2017-06-07 00:00:00	2017-06-07	581452		0	0	0		0	0	0	171709	0	113	40213227		
184076	4044	40213296	2003-05-18	2003-05-18 00:00:00	2003-05-18	2003-05-18 00:00:00	2003-05-18	581452		0	0	0		0	0	0	268977	0	52	40213296		
15958	343	40213160	1970-05-09	1970-05-09 00:00:00	1970-05-09	1970-05-09 00:00:00	1970-05-09	581452		0	0	0		0	0	0	22874	0	10	40213160		
210688	4621	40213306	1998-09-28	1998-09-28 00:00:00	1998-09-28	1998-09-28 00:00:00	1998-09-28	581452		0	0	0		0	0	0	307757	0	43	40213306		
52579	4372	1127433	1997-06-08	1997-06-08 00:00:00	1997-06-29	1997-06-29 00:00:00	1997-06-29	38000177		0	0	21		0	0	0	290287	0	313782	1127433		
129525	2847	40213260	2014-02-16	2014-02-16 00:00:00	2014-02-16	2014-02-16 00:00:00	2014-02-16	581452		0	0	0		0	0	0	189060	0	121	40213260		
7634	642	19059056	1938-04-30	1938-04-30 00:00:00	1938-05-14	1938-05-14 00:00:00	1938-05-14	38000177		0	0	14		0	0	0	42496	0	243670	19059056		
227191	4988	40213198	2018-07-17	2018-07-17 00:00:00	2018-07-17	2018-07-17 00:00:00	2018-07-17	581452		0	0	0		0	0	0	331853	0	133	40213198		
12517	1054	19073188	1999-11-12	1999-11-12 00:00:00	1999-11-26	1999-11-26 00:00:00	1999-11-26	38000177		0	0	14		0	0	0	69127	0	308192	19073188		
72782	1590	40213160	1960-12-10	1960-12-10 00:00:00	1960-12-10	1960-12-10 00:00:00	1960-12-10	581452		0	0	0		0	0	0	106690	0	10	40213160		
216474	4750	40213260	2013-04-10	2013-04-10 00:00:00	2013-04-10	2013-04-10 00:00:00	2013-04-10	581452		0	0	0		0	0	0	316327	0	121	40213260		
84157	1840	40213160	1975-09-27	1975-09-27 00:00:00	1975-09-27	1975-09-27 00:00:00	1975-09-27	581452		0	0	0		0	0	0	122847	0	10	40213160		
63807	5300	19059056	1942-11-17	1942-11-17 00:00:00	1943-02-15	1943-02-15 00:00:00	1943-02-15	38000177		0	0	90		0	0	0	352653	0	243670	19059056		
64069	5322	19006318	1947-06-21	1947-06-21 00:00:00	1947-07-05	1947-07-05 00:00:00	1947-07-05	38000177		0	0	14		0	0	0	354134	0	105078	19006318		
28558	2352	1127078	1977-03-23	1977-03-23 00:00:00	1977-04-22	1977-04-22 00:00:00	1977-04-22	38000177		0	0	30		0	0	0	156659	0	282464	1127078		
160875	3540	40213296	2014-11-24	2014-11-24 00:00:00	2014-11-24	2014-11-24 00:00:00	2014-11-24	581452		0	0	0		0	0	0	235168	0	52	40213296		
47193	3913	19129655	1964-04-10	1964-04-10 00:00:00	1964-04-24	1964-04-24 00:00:00	1964-04-24	38000177		0	0	14		0	0	0	260139	0	789980	19129655		
34733	2868	19128065	1979-09-21	1979-09-21 00:00:00	1980-09-15	1980-09-15 00:00:00	1980-09-15	38000177		0	0	360		0	0	0	190811	0	749882	19128065		
51620	1131	40213260	2015-12-02	2015-12-02 00:00:00	2015-12-02	2015-12-02 00:00:00	2015-12-02	581452		0	0	0		0	0	0	74475	0	121	40213260		
41354	3430	40229134	1975-03-06	1975-03-06 00:00:00	1975-03-13	1975-03-13 00:00:00	1975-03-13	38000177		0	0	7		0	0	0	227391	0	1043400	40229134		
149623	3290	40213296	2009-07-22	2009-07-22 00:00:00	2009-07-22	2009-07-22 00:00:00	2009-07-22	581452		0	0	0		0	0	0	218590	0	52	40213296		
236607	5195	40213160	1960-10-26	1960-10-26 00:00:00	1960-10-26	1960-10-26 00:00:00	1960-10-26	581452		0	0	0		0	0	0	345469	0	10	40213160		
57915	4812	1539411	2011-07-27	2011-07-27 00:00:00	2011-07-27	2011-07-27 00:00:00	\N	38000177		0	0	0		0	0	0	320171	0	312961	1539411		
49893	4139	19128065	1988-10-12	1988-10-12 00:00:00	1989-10-07	1989-10-07 00:00:00	1989-10-07	38000177		0	0	360		0	0	0	275160	0	749882	19128065		
111254	2444	40213160	1956-04-15	1956-04-15 00:00:00	1956-04-15	1956-04-15 00:00:00	1956-04-15	581452		0	0	0		0	0	0	162145	0	10	40213160		
84686	1852	40213160	1978-02-01	1978-02-01 00:00:00	1978-02-01	1978-02-01 00:00:00	1978-02-01	581452		0	0	0		0	0	0	123956	0	10	40213160		
22759	1870	19133905	1939-09-30	1939-09-30 00:00:00	1939-10-12	1939-10-12 00:00:00	1939-10-12	38000177		0	0	12		0	0	0	124947	0	834102	19133905		
33205	2752	1127433	1967-03-22	1967-03-22 00:00:00	1967-04-12	1967-04-12 00:00:00	1967-04-12	38000177		0	0	21		0	0	0	182115	0	313782	1127433		
180942	3976	40213160	1963-12-26	1963-12-26 00:00:00	1963-12-26	1963-12-26 00:00:00	1963-12-26	581452		0	0	0		0	0	0	264371	0	10	40213160		
48054	3984	1127078	1956-08-28	1956-08-28 00:00:00	1956-09-11	1956-09-11 00:00:00	1956-09-11	38000177		0	0	14		0	0	0	264846	0	282464	1127078		
48128	3989	40236824	1954-11-01	1954-11-01 00:00:00	1954-11-08	1954-11-08 00:00:00	1954-11-08	38000177		0	0	7		0	0	0	265154	0	1094107	40236824		
125892	2770	40213227	2002-05-18	2002-05-18 00:00:00	2002-05-18	2002-05-18 00:00:00	2002-05-18	581452		0	0	0		0	0	0	183242	0	113	40213227		
68453	1498	40213160	1964-06-23	1964-06-23 00:00:00	1964-06-23	1964-06-23 00:00:00	1964-06-23	581452		0	0	0		0	0	0	99939	0	10	40213160		
59898	4977	40229134	1988-07-15	1988-07-15 00:00:00	1988-07-22	1988-07-22 00:00:00	1988-07-22	38000177		0	0	7		0	0	0	331188	0	1043400	40229134		
71916	1572	40213296	2004-07-02	2004-07-02 00:00:00	2004-07-02	2004-07-02 00:00:00	2004-07-02	581452		0	0	0		0	0	0	105592	0	52	40213296		
25428	2088	1127433	1938-12-28	1938-12-28 00:00:00	1939-01-04	1939-01-04 00:00:00	1939-01-04	38000177		0	0	7		0	0	0	139259	0	313782	1127433		
44132	3652	1127433	1992-06-01	1992-06-01 00:00:00	1992-06-15	1992-06-15 00:00:00	1992-06-15	38000177		0	0	14		0	0	0	243112	0	313782	1127433		
137452	3017	40213306	1981-01-02	1981-01-02 00:00:00	1981-01-02	1981-01-02 00:00:00	1981-01-02	581452		0	0	0		0	0	0	201269	0	43	40213306		
8629	720	1713671	1998-02-05	1998-02-05 00:00:00	1998-02-26	1998-02-26 00:00:00	1998-02-26	38000177		0	0	21		0	0	0	47676	0	562251	1713671		
2788	224	1124300	1977-02-21	1977-02-21 00:00:00	1977-02-21	1977-02-21 00:00:00	\N	38000177		0	0	0		0	0	0	15100	0	00781178901	45011828		
36122	2976	19059056	1958-01-08	1958-01-08 00:00:00	1958-01-22	1958-01-22 00:00:00	1958-01-22	38000177		0	0	14		0	0	0	198753	0	243670	19059056		
156140	3436	40213160	1963-04-22	1963-04-22 00:00:00	1963-04-22	1963-04-22 00:00:00	1963-04-22	581452		0	0	0		0	0	0	227847	0	10	40213160		
241033	5291	40213306	1996-08-11	1996-08-11 00:00:00	1996-08-11	1996-08-11 00:00:00	1996-08-11	581452		0	0	0		0	0	0	352091	0	43	40213306		
147264	3237	40213227	1998-03-11	1998-03-11 00:00:00	1998-03-11	1998-03-11 00:00:00	1998-03-11	581452		0	0	0		0	0	0	215211	0	113	40213227		
146635	3224	40213227	1993-03-12	1993-03-12 00:00:00	1993-03-12	1993-03-12 00:00:00	1993-03-12	581452		0	0	0		0	0	0	214341	0	113	40213227		
24326	528	40213227	2010-06-04	2010-06-04 00:00:00	2010-06-04	2010-06-04 00:00:00	2010-06-04	581452		0	0	0		0	0	0	35216	0	113	40213227		
57303	4756	1127433	1997-10-26	1997-10-26 00:00:00	1997-11-09	1997-11-09 00:00:00	1997-11-09	38000177		0	0	14		0	0	0	316784	0	313782	1127433		
43783	3626	1124300	2016-07-25	2016-07-25 00:00:00	2016-07-25	2016-07-25 00:00:00	\N	38000177		0	0	0		0	0	0	241163	0	00781178901	45011828		
54288	4513	19078461	1976-03-27	1976-03-27 00:00:00	1976-04-26	1976-04-26 00:00:00	1976-04-26	38000177		0	0	30		0	0	0	300569	0	310965	19078461		
184445	4053	40213296	2001-12-16	2001-12-16 00:00:00	2001-12-16	2001-12-16 00:00:00	2001-12-16	581452		0	0	0		0	0	0	269482	0	52	40213296		
51729	4297	19006318	1976-11-03	1976-11-03 00:00:00	1976-11-17	1976-11-17 00:00:00	1976-11-17	38000177		0	0	14		0	0	0	285199	0	105078	19006318		
109086	2392	40213227	1997-05-16	1997-05-16 00:00:00	1997-05-16	1997-05-16 00:00:00	1997-05-16	581452		0	0	0		0	0	0	158971	0	113	40213227		
13903	1162	40223768	1999-02-13	1999-02-13 00:00:00	1999-02-13	1999-02-13 00:00:00	\N	38000177		0	0	0		0	0	0	76780	0	997223	40223768		
48165	3993	920334	1961-01-27	1961-01-27 00:00:00	1961-02-03	1961-02-03 00:00:00	1961-02-03	38000177		0	0	7		0	0	0	265480	0	311995	920334		
195941	4305	40213296	1997-11-28	1997-11-28 00:00:00	1997-11-28	1997-11-28 00:00:00	1997-11-28	581452		0	0	0		0	0	0	285570	0	52	40213296		
7666	644	1127078	1975-12-21	1975-12-21 00:00:00	1976-01-04	1976-01-04 00:00:00	1976-01-04	38000177		0	0	14		0	0	0	42637	0	282464	1127078		
19490	1606	1127433	1985-01-29	1985-01-29 00:00:00	1985-02-05	1985-02-05 00:00:00	1985-02-05	38000177		0	0	7		0	0	0	107846	0	313782	1127433		
16881	1397	19133873	1977-02-21	1977-02-21 00:00:00	1977-03-04	1977-03-04 00:00:00	1977-03-04	38000177		0	0	11		0	0	0	92727	0	834061	19133873		
19583	1611	1127433	1968-12-13	1968-12-13 00:00:00	1968-12-27	1968-12-27 00:00:00	1968-12-27	38000177		0	0	14		0	0	0	108349	0	313782	1127433		
5976	499	1127433	1989-08-29	1989-08-29 00:00:00	1989-09-12	1989-09-12 00:00:00	1989-09-12	38000177		0	0	14		0	0	0	33320	0	313782	1127433		
48521	4020	1713671	1979-10-28	1979-10-28 00:00:00	1979-11-04	1979-11-04 00:00:00	1979-11-04	38000177		0	0	7		0	0	0	267269	0	562251	1713671		
21274	1750	19075001	2012-09-09	2012-09-09 00:00:00	2012-10-14	2012-10-14 00:00:00	2012-10-14	38000177		0	0	35		0	0	0	117017	0	309097	19075001		
38041	3145	1124300	2010-12-03	2010-12-03 00:00:00	2010-12-03	2010-12-03 00:00:00	\N	38000177		0	0	0		0	0	0	209260	0	00781178901	45011828		
97316	2133	40213306	1987-08-10	1987-08-10 00:00:00	1987-08-10	1987-08-10 00:00:00	1987-08-10	581452		0	0	0		0	0	0	141931	0	43	40213306		
118012	2594	40213296	2017-06-07	2017-06-07 00:00:00	2017-06-07	2017-06-07 00:00:00	2017-06-07	581452		0	0	0		0	0	0	171709	0	52	40213296		
184082	4044	40213160	1959-12-13	1959-12-13 00:00:00	1959-12-13	1959-12-13 00:00:00	1959-12-13	581452		0	0	0		0	0	0	268927	0	10	40213160		
5797	126	40213201	2014-01-20	2014-01-20 00:00:00	2014-01-20	2014-01-20 00:00:00	2014-01-20	581452		0	0	0		0	0	0	8425	0	33	40213201		
210691	4621	40213227	1998-09-28	1998-09-28 00:00:00	1998-09-28	1998-09-28 00:00:00	1998-09-28	581452		0	0	0		0	0	0	307757	0	113	40213227		
52580	4372	1118084	2017-10-16	2017-10-16 00:00:00	2017-10-16	2017-10-16 00:00:00	\N	38000177		0	0	0		0	0	0	290210	0	00025152531	44923712		
166312	3655	40213227	2006-08-31	2006-08-31 00:00:00	2006-08-31	2006-08-31 00:00:00	2006-08-31	581452		0	0	0		0	0	0	243290	0	113	40213227		
7635	642	40165015	1989-12-23	1989-12-23 00:00:00	1989-12-23	1989-12-23 00:00:00	\N	38000177		0	0	0		0	0	0	42464	0	861467	40165015		
227195	4988	40213227	1995-05-02	1995-05-02 00:00:00	1995-05-02	1995-05-02 00:00:00	1995-05-02	581452		0	0	0		0	0	0	331819	0	113	40213227		
12518	1054	1713671	1986-02-12	1986-02-12 00:00:00	1986-02-19	1986-02-19 00:00:00	1986-02-19	38000177		0	0	7		0	0	0	69122	0	562251	1713671		
72786	1590	40213160	1965-03-13	1965-03-13 00:00:00	1965-03-13	1965-03-13 00:00:00	1965-03-13	581452		0	0	0		0	0	0	106678	0	10	40213160		
177254	3895	40213227	1995-05-26	1995-05-26 00:00:00	1995-05-26	1995-05-26 00:00:00	1995-05-26	581452		0	0	0		0	0	0	259039	0	113	40213227		
111768	2456	40213260	2007-12-23	2007-12-23 00:00:00	2007-12-23	2007-12-23 00:00:00	2007-12-23	581452		0	0	0		0	0	0	162795	0	121	40213260		
63808	5300	1713671	1978-01-19	1978-01-19 00:00:00	1978-01-26	1978-01-26 00:00:00	1978-01-26	38000177		0	0	7		0	0	0	352604	0	562251	1713671		
64070	5322	1124300	1982-06-02	1982-06-02 00:00:00	1982-06-02	1982-06-02 00:00:00	\N	38000177		0	0	0		0	0	0	354112	0	00781178901	45011828		
28559	2352	19074679	1970-10-26	1970-10-26 00:00:00	1971-09-27	1971-09-27 00:00:00	1971-09-27	38000177		0	0	336		0	0	0	156656	0	308971	19074679		
160878	3540	40213227	2016-11-28	2016-11-28 00:00:00	2016-11-28	2016-11-28 00:00:00	2016-11-28	581452		0	0	0		0	0	0	235132	0	113	40213227		
47194	3913	1127078	1964-04-10	1964-04-10 00:00:00	1964-04-24	1964-04-24 00:00:00	1964-04-24	38000177		0	0	14		0	0	0	260139	0	282464	1127078		
34734	2868	19059056	1967-05-12	1967-05-12 00:00:00	1967-05-26	1967-05-26 00:00:00	1967-05-26	38000177		0	0	14		0	0	0	190776	0	243670	19059056		
51621	1131	40213296	2006-11-08	2006-11-08 00:00:00	2006-11-08	2006-11-08 00:00:00	2006-11-08	581452		0	0	0		0	0	0	74466	0	52	40213296		
41355	3430	40169281	1992-03-07	1992-03-07 00:00:00	1992-03-07	1992-03-07 00:00:00	\N	38000177		0	0	0		0	0	0	227368	0	896209	40169281		
149626	3290	40213227	2001-07-11	2001-07-11 00:00:00	2001-07-11	2001-07-11 00:00:00	2001-07-11	581452		0	0	0		0	0	0	218541	0	113	40213227		
236610	5195	40213227	2003-02-19	2003-02-19 00:00:00	2003-02-19	2003-02-19 00:00:00	2003-02-19	581452		0	0	0		0	0	0	345415	0	113	40213227		
57916	4812	1332419	2011-07-27	2011-07-27 00:00:00	2011-07-27	2011-07-27 00:00:00	\N	38000177		0	0	0		0	0	0	320171	0	197361	1332419		
49894	4139	19078461	2010-08-22	2010-08-22 00:00:00	2010-10-21	2010-10-21 00:00:00	2010-10-21	38000177		0	0	60		0	0	0	275164	0	310965	19078461		
111261	2444	40213160	1955-11-13	1955-11-13 00:00:00	1955-11-13	1955-11-13 00:00:00	1955-11-13	581452		0	0	0		0	0	0	162112	0	10	40213160		
84693	1852	40213227	2015-02-18	2015-02-18 00:00:00	2015-02-18	2015-02-18 00:00:00	2015-02-18	581452		0	0	0		0	0	0	123960	0	113	40213227		
22760	1870	19059056	1953-01-25	1953-01-25 00:00:00	1953-02-08	1953-02-08 00:00:00	1953-02-08	38000177		0	0	14		0	0	0	124946	0	243670	19059056		
33206	2752	1127433	2010-04-15	2010-04-15 00:00:00	2010-04-29	2010-04-29 00:00:00	2010-04-29	38000177		0	0	14		0	0	0	182064	0	313782	1127433		
180945	3976	40213227	1994-11-17	1994-11-17 00:00:00	1994-11-17	1994-11-17 00:00:00	1994-11-17	581452		0	0	0		0	0	0	264339	0	113	40213227		
48055	3984	1127433	2004-07-19	2004-07-19 00:00:00	2004-08-02	2004-08-02 00:00:00	2004-08-02	38000177		0	0	14		0	0	0	264824	0	313782	1127433		
48129	3989	920300	1954-11-01	1954-11-01 00:00:00	1954-11-08	1954-11-08 00:00:00	1954-11-08	38000177		0	0	7		0	0	0	265154	0	311989	920300		
179754	3951	40213227	2015-03-21	2015-03-21 00:00:00	2015-03-21	2015-03-21 00:00:00	2015-03-21	581452		0	0	0		0	0	0	262614	0	113	40213227		
75535	1649	40213260	2007-03-14	2007-03-14 00:00:00	2007-03-14	2007-03-14 00:00:00	2007-03-14	581452		0	0	0		0	0	0	110625	0	121	40213260		
59899	4977	1127078	1964-06-14	1964-06-14 00:00:00	1964-06-28	1964-06-28 00:00:00	1964-06-28	38000177		0	0	14		0	0	0	331117	0	282464	1127078		
71920	1572	40213306	1985-05-24	1985-05-24 00:00:00	1985-05-24	1985-05-24 00:00:00	1985-05-24	581452		0	0	0		0	0	0	105553	0	43	40213306		
25429	2088	19059056	1923-10-18	1923-10-18 00:00:00	1923-11-08	1923-11-08 00:00:00	1923-11-08	38000177		0	0	21		0	0	0	139178	0	243670	19059056		
92520	2030	40213160	1962-09-30	1962-09-30 00:00:00	1962-09-30	1962-09-30 00:00:00	1962-09-30	581452		0	0	0		0	0	0	135168	0	10	40213160		
137456	3017	40213227	2009-05-29	2009-05-29 00:00:00	2009-05-29	2009-05-29 00:00:00	2009-05-29	581452		0	0	0		0	0	0	201286	0	113	40213227		
8630	720	40229134	2013-03-17	2013-03-17 00:00:00	2013-03-31	2013-03-31 00:00:00	2013-03-31	38000177		0	0	14		0	0	0	47619	0	1043400	40229134		
2791	224	1127433	1992-02-19	1992-02-19 00:00:00	1992-03-11	1992-03-11 00:00:00	1992-03-11	38000177		0	0	21		0	0	0	15108	0	313782	1127433		
36123	2976	1127433	2005-09-19	2005-09-19 00:00:00	2005-10-03	2005-10-03 00:00:00	2005-10-03	38000177		0	0	14		0	0	0	198709	0	313782	1127433		
156144	3436	40213227	2014-03-24	2014-03-24 00:00:00	2014-03-24	2014-03-24 00:00:00	2014-03-24	581452		0	0	0		0	0	0	227912	0	113	40213227		
241044	5291	40213314	1978-03-26	1978-03-26 00:00:00	1978-03-26	1978-03-26 00:00:00	1978-03-26	581452		0	0	0		0	0	0	352059	0	49	40213314		
57730	1264	40213227	1998-01-09	1998-01-09 00:00:00	1998-01-09	1998-01-09 00:00:00	1998-01-09	581452		0	0	0		0	0	0	83302	0	113	40213227		
146636	3224	40213160	1960-04-22	1960-04-22 00:00:00	1960-04-22	1960-04-22 00:00:00	1960-04-22	581452		0	0	0		0	0	0	214386	0	10	40213160		
24327	528	40213260	2010-06-04	2010-06-04 00:00:00	2010-06-04	2010-06-04 00:00:00	2010-06-04	581452		0	0	0		0	0	0	35216	0	121	40213260		
57304	4756	1127433	1977-06-03	1977-06-03 00:00:00	1977-06-10	1977-06-10 00:00:00	1977-06-10	38000177		0	0	7		0	0	0	316843	0	313782	1127433		
43797	3628	1127433	1920-04-30	1920-04-30 00:00:00	1920-05-14	1920-05-14 00:00:00	1920-05-14	38000177		0	0	14		0	0	0	241296	0	313782	1127433		
54289	4513	1127433	1986-12-14	1986-12-14 00:00:00	1986-12-28	1986-12-28 00:00:00	1986-12-28	38000177		0	0	14		0	0	0	300583	0	313782	1127433		
184450	4053	40213260	2012-12-02	2012-12-02 00:00:00	2012-12-02	2012-12-02 00:00:00	2012-12-02	581452		0	0	0		0	0	0	269447	0	121	40213260		
51730	4297	19128065	1989-12-18	1989-12-18 00:00:00	1990-12-13	1990-12-13 00:00:00	1990-12-13	38000177		0	0	360		0	0	0	285191	0	749882	19128065		
80647	1764	40213306	1981-10-01	1981-10-01 00:00:00	1981-10-01	1981-10-01 00:00:00	1981-10-01	581452		0	0	0		0	0	0	117973	0	43	40213306		
13904	1162	19059056	1993-03-07	1993-03-07 00:00:00	1993-04-06	1993-04-06 00:00:00	1993-04-06	38000177		0	0	30		0	0	0	76731	0	243670	19059056		
48166	3993	40231925	1974-07-03	1974-07-03 00:00:00	1974-07-03	1974-07-03 00:00:00	\N	38000177		0	0	0		0	0	0	265524	0	1049221	40231925		
129210	2842	40213296	1999-03-25	1999-03-25 00:00:00	1999-03-25	1999-03-25 00:00:00	1999-03-25	581452		0	0	0		0	0	0	188713	0	52	40213296		
7667	644	19129655	1975-12-21	1975-12-21 00:00:00	1976-01-04	1976-01-04 00:00:00	1976-01-04	38000177		0	0	14		0	0	0	42637	0	789980	19129655		
19491	1606	1127433	1988-10-08	1988-10-08 00:00:00	1988-10-15	1988-10-15 00:00:00	1988-10-15	38000177		0	0	7		0	0	0	107875	0	313782	1127433		
16882	1397	1551192	1977-11-14	1977-11-14 00:00:00	1977-11-14	1977-11-14 00:00:00	1977-11-14	38000177		0	0	0		0	0	0	92836	0	312617	1551192		
19584	1611	1124300	1997-10-10	1997-10-10 00:00:00	1997-10-10	1997-10-10 00:00:00	\N	38000177		0	0	0		0	0	0	108336	0	00781178901	45011828		
16435	1361	40236824	1973-10-10	1973-10-10 00:00:00	1973-10-17	1973-10-17 00:00:00	1973-10-17	38000177		0	0	7		0	0	0	90370	0	1094107	40236824		
48522	4020	19133905	1991-03-08	1991-03-08 00:00:00	1991-03-16	1991-03-16 00:00:00	1991-03-16	38000177		0	0	8		0	0	0	267256	0	834102	19133905		
21275	1750	1127433	2012-09-09	2012-09-09 00:00:00	2012-10-14	2012-10-14 00:00:00	2012-10-14	38000177		0	0	35		0	0	0	117017	0	313782	1127433		
38042	3145	19129655	1975-04-06	1975-04-06 00:00:00	1975-04-20	1975-04-20 00:00:00	1975-04-20	38000177		0	0	14		0	0	0	209270	0	789980	19129655		
97321	2133	40213160	1970-05-18	1970-05-18 00:00:00	1970-05-18	1970-05-18 00:00:00	1970-05-18	581452		0	0	0		0	0	0	141912	0	10	40213160		
118016	2594	40213314	1977-08-24	1977-08-24 00:00:00	1977-08-24	1977-08-24 00:00:00	1977-08-24	581452		0	0	0		0	0	0	171718	0	49	40213314		
184089	4044	40213160	1964-07-05	1964-07-05 00:00:00	1964-07-05	1964-07-05 00:00:00	1964-07-05	581452		0	0	0		0	0	0	268945	0	10	40213160		
5801	126	40213227	1998-07-27	1998-07-27 00:00:00	1998-07-27	1998-07-27 00:00:00	1998-07-27	581452		0	0	0		0	0	0	8455	0	113	40213227		
210693	4621	40213227	2007-10-08	2007-10-08 00:00:00	2007-10-08	2007-10-08 00:00:00	2007-10-08	581452		0	0	0		0	0	0	307760	0	113	40213227		
52581	4372	19078461	1993-10-27	1993-10-27 00:00:00	1993-11-26	1993-11-26 00:00:00	1993-11-26	38000177		0	0	30		0	0	0	290286	0	310965	19078461		
166316	3655	40213201	2001-08-02	2001-08-02 00:00:00	2001-08-02	2001-08-02 00:00:00	2001-08-02	581452		0	0	0		0	0	0	243245	0	33	40213201		
7636	642	19075001	1989-12-23	1989-12-23 00:00:00	1990-01-20	1990-01-20 00:00:00	1990-01-20	38000177		0	0	28		0	0	0	42464	0	309097	19075001		
227198	4988	40213160	1956-03-27	1956-03-27 00:00:00	1956-03-27	1956-03-27 00:00:00	1956-03-27	581452		0	0	0		0	0	0	331804	0	10	40213160		
12519	1054	1713671	1987-03-22	1987-03-22 00:00:00	1987-04-12	1987-04-12 00:00:00	1987-04-12	38000177		0	0	21		0	0	0	69149	0	562251	1713671		
72787	1590	40213160	1960-09-11	1960-09-11 00:00:00	1960-09-11	1960-09-11 00:00:00	1960-09-11	581452		0	0	0		0	0	0	106737	0	10	40213160		
177259	3895	40213201	1990-04-27	1990-04-27 00:00:00	1990-04-27	1990-04-27 00:00:00	1990-04-27	581452		0	0	0		0	0	0	259067	0	33	40213201		
111774	2456	40213160	1955-10-02	1955-10-02 00:00:00	1955-10-02	1955-10-02 00:00:00	1955-10-02	581452		0	0	0		0	0	0	162824	0	10	40213160		
63809	5301	19059056	1936-03-07	1936-03-07 00:00:00	1936-04-04	1936-04-04 00:00:00	1936-04-04	38000177		0	0	28		0	0	0	352695	0	243670	19059056		
64071	5322	1713671	1970-06-25	1970-06-25 00:00:00	1970-07-16	1970-07-16 00:00:00	1970-07-16	38000177		0	0	21		0	0	0	354179	0	562251	1713671		
28560	2352	1127433	2000-01-24	2000-01-24 00:00:00	2000-02-07	2000-02-07 00:00:00	2000-02-07	38000177		0	0	14		0	0	0	156619	0	313782	1127433		
160879	3540	40213296	2016-11-28	2016-11-28 00:00:00	2016-11-28	2016-11-28 00:00:00	2016-11-28	581452		0	0	0		0	0	0	235132	0	52	40213296		
47195	3913	1150771	1981-11-09	1981-11-09 00:00:00	1981-11-09	1981-11-09 00:00:00	\N	38000177		0	0	0		0	0	0	260154	0	197378	1150771		
34735	2868	19006318	1967-05-12	1967-05-12 00:00:00	1967-05-26	1967-05-26 00:00:00	1967-05-26	38000177		0	0	14		0	0	0	190776	0	105078	19006318		
51623	1131	40213227	2006-11-08	2006-11-08 00:00:00	2006-11-08	2006-11-08 00:00:00	2006-11-08	581452		0	0	0		0	0	0	74466	0	113	40213227		
41356	3430	1713671	1966-05-20	1966-05-20 00:00:00	1966-05-27	1966-05-27 00:00:00	1966-05-27	38000177		0	0	7		0	0	0	227395	0	562251	1713671		
145391	3196	40213296	2010-04-13	2010-04-13 00:00:00	2010-04-13	2010-04-13 00:00:00	2010-04-13	581452		0	0	0		0	0	0	212635	0	52	40213296		
52477	1148	40213227	1999-07-03	1999-07-03 00:00:00	1999-07-03	1999-07-03 00:00:00	1999-07-03	581452		0	0	0		0	0	0	75868	0	113	40213227		
57918	4812	19128065	1975-09-11	1975-09-11 00:00:00	1976-09-05	1976-09-05 00:00:00	1976-09-05	38000177		0	0	360		0	0	0	320132	0	749882	19128065		
49895	4139	40165015	2010-08-22	2010-08-22 00:00:00	2010-08-22	2010-08-22 00:00:00	\N	38000177		0	0	0		0	0	0	275164	0	861467	40165015		
111263	2444	40213227	2006-08-13	2006-08-13 00:00:00	2006-08-13	2006-08-13 00:00:00	2006-08-13	581452		0	0	0		0	0	0	162106	0	113	40213227		
84694	1852	40213296	2015-02-18	2015-02-18 00:00:00	2015-02-18	2015-02-18 00:00:00	2015-02-18	581452		0	0	0		0	0	0	123960	0	52	40213296		
22761	1870	1713671	1932-10-09	1932-10-09 00:00:00	1932-10-16	1932-10-16 00:00:00	1932-10-16	38000177		0	0	7		0	0	0	124941	0	562251	1713671		
33207	2752	19059056	1954-04-01	1954-04-01 00:00:00	1954-04-15	1954-04-15 00:00:00	1954-04-15	38000177		0	0	14		0	0	0	182113	0	243670	19059056		
180946	3976	40213160	1963-09-26	1963-09-26 00:00:00	1963-09-26	1963-09-26 00:00:00	1963-09-26	581452		0	0	0		0	0	0	264389	0	10	40213160		
48056	3984	19075001	2004-07-19	2004-07-19 00:00:00	2004-08-02	2004-08-02 00:00:00	2004-08-02	38000177		0	0	14		0	0	0	264824	0	309097	19075001		
48130	3989	1127433	1975-03-25	1975-03-25 00:00:00	1975-04-22	1975-04-22 00:00:00	1975-04-22	38000177		0	0	28		0	0	0	265247	0	313782	1127433		
179758	3951	40213201	2010-05-29	2010-05-29 00:00:00	2010-05-29	2010-05-29 00:00:00	2010-05-29	581452		0	0	0		0	0	0	262612	0	33	40213201		
75537	1649	40213227	2007-03-14	2007-03-14 00:00:00	2007-03-14	2007-03-14 00:00:00	2007-03-14	581452		0	0	0		0	0	0	110625	0	113	40213227		
59900	4977	1127433	1982-06-02	1982-06-02 00:00:00	1982-06-09	1982-06-09 00:00:00	1982-06-09	38000177		0	0	7		0	0	0	331110	0	313782	1127433		
71924	1572	40213160	1962-09-28	1962-09-28 00:00:00	1962-09-28	1962-09-28 00:00:00	1962-09-28	581452		0	0	0		0	0	0	105563	0	10	40213160		
25434	2090	40229134	1969-11-14	1969-11-14 00:00:00	1969-11-21	1969-11-21 00:00:00	1969-11-21	38000177		0	0	7		0	0	0	139352	0	1043400	40229134		
92522	2030	40213227	2013-04-28	2013-04-28 00:00:00	2013-04-28	2013-04-28 00:00:00	2013-04-28	581452		0	0	0		0	0	0	135156	0	113	40213227		
137457	3017	40213260	2009-05-29	2009-05-29 00:00:00	2009-05-29	2009-05-29 00:00:00	2009-05-29	581452		0	0	0		0	0	0	201286	0	121	40213260		
8631	720	1127433	1997-02-28	1997-02-28 00:00:00	1997-03-14	1997-03-14 00:00:00	1997-03-14	38000177		0	0	14		0	0	0	47659	0	313782	1127433		
2792	224	40229134	1985-12-28	1985-12-28 00:00:00	1986-01-11	1986-01-11 00:00:00	1986-01-11	38000177		0	0	14		0	0	0	15037	0	1043400	40229134		
31962	697	40213306	1989-04-05	1989-04-05 00:00:00	1989-04-05	1989-04-05 00:00:00	1989-04-05	581452		0	0	0		0	0	0	\N	0	43	40213306		
156145	3436	40213260	2014-03-24	2014-03-24 00:00:00	2014-03-24	2014-03-24 00:00:00	2014-03-24	581452		0	0	0		0	0	0	227912	0	121	40213260		
241045	5291	40213160	1976-01-25	1976-01-25 00:00:00	1976-01-25	1976-01-25 00:00:00	1976-01-25	581452		0	0	0		0	0	0	352050	0	10	40213160		
146963	3231	40213201	2014-08-21	2014-08-21 00:00:00	2014-08-21	2014-08-21 00:00:00	2014-08-21	581452		0	0	0		0	0	0	214793	0	33	40213201		
146641	3224	40213227	2001-03-23	2001-03-23 00:00:00	2001-03-23	2001-03-23 00:00:00	2001-03-23	581452		0	0	0		0	0	0	214334	0	113	40213227		
24330	528	40213296	1999-06-04	1999-06-04 00:00:00	1999-06-04	1999-06-04 00:00:00	1999-06-04	581452		0	0	0		0	0	0	35174	0	52	40213296		
57305	4756	19078461	1994-08-15	1994-08-15 00:00:00	1994-09-12	1994-09-12 00:00:00	1994-09-12	38000177		0	0	28		0	0	0	316783	0	310965	19078461		
43798	3628	1127433	1926-09-11	1926-09-11 00:00:00	1926-09-25	1926-09-25 00:00:00	1926-09-25	38000177		0	0	14		0	0	0	241404	0	313782	1127433		
54290	4513	1127433	1978-01-16	1978-01-16 00:00:00	1978-04-16	1978-04-16 00:00:00	1978-04-16	38000177		0	0	90		0	0	0	300570	0	313782	1127433		
184451	4053	40213160	1962-08-05	1962-08-05 00:00:00	1962-08-05	1962-08-05 00:00:00	1962-08-05	581452		0	0	0		0	0	0	269429	0	10	40213160		
51731	4297	1127433	1986-04-19	1986-04-19 00:00:00	1986-05-24	1986-05-24 00:00:00	1986-05-24	38000177		0	0	35		0	0	0	285177	0	313782	1127433		
80648	1764	40213260	2010-09-09	2010-09-09 00:00:00	2010-09-09	2010-09-09 00:00:00	2010-09-09	581452		0	0	0		0	0	0	117967	0	121	40213260		
13905	1162	1127433	1921-08-24	1921-08-24 00:00:00	1921-09-07	1921-09-07 00:00:00	1921-09-07	38000177		0	0	14		0	0	0	76703	0	313782	1127433		
48167	3993	1713671	1987-12-09	1987-12-09 00:00:00	1987-12-23	1987-12-23 00:00:00	1987-12-23	38000177		0	0	14		0	0	0	265510	0	562251	1713671		
129217	2842	40213227	2001-03-29	2001-03-29 00:00:00	2001-03-29	2001-03-29 00:00:00	2001-03-29	581452		0	0	0		0	0	0	188662	0	113	40213227		
7668	644	19019979	1976-10-16	1976-10-16 00:00:00	1976-10-30	1976-10-30 00:00:00	1976-10-30	38000177		0	0	14		0	0	0	42665	0	198405	19019979		
19492	1606	1127433	1995-05-04	1995-05-04 00:00:00	1995-05-18	1995-05-18 00:00:00	1995-05-18	38000177		0	0	14		0	0	0	107807	0	313782	1127433		
16883	1397	1115171	1998-01-12	1998-01-12 00:00:00	1998-01-26	1998-01-26 00:00:00	1998-01-26	38000177		0	0	14		0	0	0	92838	0	849574	1115171		
19585	1611	1127433	1977-06-21	1977-06-21 00:00:00	1977-07-05	1977-07-05 00:00:00	1977-07-05	38000177		0	0	14		0	0	0	108317	0	313782	1127433		
16436	1361	920300	1973-10-10	1973-10-10 00:00:00	1973-10-17	1973-10-17 00:00:00	1973-10-17	38000177		0	0	7		0	0	0	90370	0	311989	920300		
16459	1365	19078461	1996-05-30	1996-05-30 00:00:00	1996-07-29	1996-07-29 00:00:00	1996-07-29	38000177		0	0	60		0	0	0	90457	0	310965	19078461		
21276	1750	1115171	1996-04-01	1996-04-01 00:00:00	1996-04-15	1996-04-15 00:00:00	1996-04-15	38000177		0	0	14		0	0	0	117005	0	849574	1115171		
38043	3145	19059056	1975-04-06	1975-04-06 00:00:00	1975-04-20	1975-04-20 00:00:00	1975-04-20	38000177		0	0	14		0	0	0	209270	0	243670	19059056		
81533	1782	40213201	2018-12-11	2018-12-11 00:00:00	2018-12-11	2018-12-11 00:00:00	2018-12-11	581452		0	0	0		0	0	0	\N	0	33	40213201		
118018	2594	40213314	1977-02-02	1977-02-02 00:00:00	1977-02-02	1977-02-02 00:00:00	1977-02-02	581452		0	0	0		0	0	0	171704	0	49	40213314		
184091	4045	40213227	1996-04-06	1996-04-06 00:00:00	1996-04-06	1996-04-06 00:00:00	1996-04-06	581452		0	0	0		0	0	0	269027	0	113	40213227		
20621	449	40213227	1992-12-03	1992-12-03 00:00:00	1992-12-03	1992-12-03 00:00:00	1992-12-03	581452		0	0	0		0	0	0	\N	0	113	40213227		
210696	4621	40213160	1981-07-06	1981-07-06 00:00:00	1981-07-06	1981-07-06 00:00:00	1981-07-06	581452		0	0	0		0	0	0	307763	0	10	40213160		
52582	4372	19128022	1997-04-19	1997-04-19 00:00:00	1998-04-14	1998-04-14 00:00:00	1998-04-14	38000177		0	0	360		0	0	0	290247	0	749785	19128022		
166319	3655	40213227	1996-07-04	1996-07-04 00:00:00	1996-07-04	1996-07-04 00:00:00	1996-07-04	581452		0	0	0		0	0	0	243301	0	113	40213227		
18095	1498	1127433	2015-04-17	2015-04-17 00:00:00	2015-05-01	2015-05-01 00:00:00	2015-05-01	38000177		0	0	14		0	0	0	99975	0	313782	1127433		
166395	3658	40213296	2000-12-10	2000-12-10 00:00:00	2000-12-10	2000-12-10 00:00:00	2000-12-10	581452		0	0	0		0	0	0	243512	0	52	40213296		
12520	1054	1713671	1988-06-13	1988-06-13 00:00:00	1988-06-20	1988-06-20 00:00:00	1988-06-20	38000177		0	0	7		0	0	0	69123	0	562251	1713671		
72790	1590	40213227	2011-04-10	2011-04-10 00:00:00	2011-04-10	2011-04-10 00:00:00	2011-04-10	581452		0	0	0		0	0	0	106727	0	113	40213227		
177264	3895	40213227	2014-08-22	2014-08-22 00:00:00	2014-08-22	2014-08-22 00:00:00	2014-08-22	581452		0	0	0		0	0	0	259020	0	113	40213227		
111777	2456	40213227	2006-12-17	2006-12-17 00:00:00	2006-12-17	2006-12-17 00:00:00	2006-12-17	581452		0	0	0		0	0	0	162790	0	113	40213227		
63810	5301	1127433	1949-04-30	1949-04-30 00:00:00	1949-05-07	1949-05-07 00:00:00	1949-05-07	38000177		0	0	7		0	0	0	352729	0	313782	1127433		
64072	5322	1713671	1993-01-27	1993-01-27 00:00:00	1993-02-10	1993-02-10 00:00:00	1993-02-10	38000177		0	0	14		0	0	0	354080	0	562251	1713671		
235361	5169	40213198	2019-01-07	2019-01-07 00:00:00	2019-01-07	2019-01-07 00:00:00	2019-01-07	581452		0	0	0		0	0	0	343728	0	133	40213198		
5946	129	40213314	1977-09-12	1977-09-12 00:00:00	1977-09-12	1977-09-12 00:00:00	1977-09-12	581452		0	0	0		0	0	0	8687	0	49	40213314		
24206	1990	19133905	2002-11-28	2002-11-28 00:00:00	2002-12-07	2002-12-07 00:00:00	2002-12-07	38000177		0	0	9		0	0	0	132487	0	834102	19133905		
34737	2868	1127433	1966-02-22	1966-02-22 00:00:00	1966-03-01	1966-03-01 00:00:00	1966-03-01	38000177		0	0	7		0	0	0	190797	0	313782	1127433		
51643	1131	40213160	1965-11-17	1965-11-17 00:00:00	1965-11-17	1965-11-17 00:00:00	1965-11-17	581452		0	0	0		0	0	0	74439	0	10	40213160		
41357	3430	1713671	1989-02-28	1989-02-28 00:00:00	1989-03-14	1989-03-14 00:00:00	1989-03-14	38000177		0	0	14		0	0	0	227354	0	562251	1713671		
145394	3196	40213160	1970-09-15	1970-09-15 00:00:00	1970-09-15	1970-09-15 00:00:00	1970-09-15	581452		0	0	0		0	0	0	212638	0	10	40213160		
52478	1148	40213296	1999-07-03	1999-07-03 00:00:00	1999-07-03	1999-07-03 00:00:00	1999-07-03	581452		0	0	0		0	0	0	75868	0	52	40213296		
57919	4812	19133873	1964-02-17	1964-02-17 00:00:00	1964-02-26	1964-02-26 00:00:00	1964-02-26	38000177		0	0	9		0	0	0	320135	0	834061	19133873		
49896	4139	1115171	2007-09-23	2007-09-23 00:00:00	2007-10-07	2007-10-07 00:00:00	2007-10-07	38000177		0	0	14		0	0	0	275163	0	849574	1115171		
111264	2444	40213260	2006-08-13	2006-08-13 00:00:00	2006-08-13	2006-08-13 00:00:00	2006-08-13	581452		0	0	0		0	0	0	162106	0	121	40213260		
84699	1852	40213306	1995-04-26	1995-04-26 00:00:00	1995-04-26	1995-04-26 00:00:00	1995-04-26	581452		0	0	0		0	0	0	123875	0	43	40213306		
22762	1870	40236824	1957-05-08	1957-05-08 00:00:00	1957-05-15	1957-05-15 00:00:00	1957-05-15	38000177		0	0	7		0	0	0	124935	0	1094107	40236824		
33208	2752	920300	1972-04-15	1972-04-15 00:00:00	1972-04-22	1972-04-22 00:00:00	1972-04-22	38000177		0	0	7		0	0	0	182073	0	311989	920300		
180949	3976	40213227	2005-04-21	2005-04-21 00:00:00	2005-04-21	2005-04-21 00:00:00	2005-04-21	581452		0	0	0		0	0	0	\N	0	113	40213227		
48057	3984	19006318	1955-12-13	1955-12-13 00:00:00	1955-12-27	1955-12-27 00:00:00	1955-12-27	38000177		0	0	14		0	0	0	264823	0	105078	19006318		
48131	3989	19133905	1996-11-05	1996-11-05 00:00:00	1996-11-16	1996-11-16 00:00:00	1996-11-16	38000177		0	0	11		0	0	0	265172	0	834102	19133905		
179759	3951	40213198	2010-05-29	2010-05-29 00:00:00	2010-05-29	2010-05-29 00:00:00	2010-05-29	581452		0	0	0		0	0	0	262612	0	133	40213198		
86818	1903	40213227	2013-06-25	2013-06-25 00:00:00	2013-06-25	2013-06-25 00:00:00	2013-06-25	581452		0	0	0		0	0	0	126717	0	113	40213227		
59901	4977	1118084	1997-11-23	1997-11-23 00:00:00	1997-11-23	1997-11-23 00:00:00	\N	38000177		0	0	0		0	0	0	331149	0	00025152531	44923712		
71929	1572	40213260	2012-06-22	2012-06-22 00:00:00	2012-06-22	2012-06-22 00:00:00	2012-06-22	581452		0	0	0		0	0	0	105617	0	121	40213260		
25435	2090	19128065	1985-05-02	1985-05-02 00:00:00	1986-04-27	1986-04-27 00:00:00	1986-04-27	38000177		0	0	360		0	0	0	139401	0	749882	19128065		
92523	2030	40213260	2013-04-28	2013-04-28 00:00:00	2013-04-28	2013-04-28 00:00:00	2013-04-28	581452		0	0	0		0	0	0	135156	0	121	40213260		
137463	3017	40213160	1958-01-24	1958-01-24 00:00:00	1958-01-24	1958-01-24 00:00:00	1958-01-24	581452		0	0	0		0	0	0	201259	0	10	40213160		
8632	720	920300	1998-09-17	1998-09-17 00:00:00	1998-09-24	1998-09-24 00:00:00	1998-09-24	38000177		0	0	7		0	0	0	47667	0	311989	920300		
2793	225	19059056	1965-11-30	1965-11-30 00:00:00	1965-12-28	1965-12-28 00:00:00	1965-12-28	38000177		0	0	28		0	0	0	15147	0	243670	19059056		
31966	697	40213160	1970-03-25	1970-03-25 00:00:00	1970-03-25	1970-03-25 00:00:00	1970-03-25	581452		0	0	0		0	0	0	46140	0	10	40213160		
149223	3283	40213306	2001-12-21	2001-12-21 00:00:00	2001-12-21	2001-12-21 00:00:00	2001-12-21	581452		0	0	0		0	0	0	\N	0	43	40213306		
241048	5291	40213314	1977-09-25	1977-09-25 00:00:00	1977-09-25	1977-09-25 00:00:00	1977-09-25	581452		0	0	0		0	0	0	352080	0	49	40213314		
146968	3231	40213160	1955-08-04	1955-08-04 00:00:00	1955-08-04	1955-08-04 00:00:00	1955-08-04	581452		0	0	0		0	0	0	214750	0	10	40213160		
146642	3224	40213296	2001-03-23	2001-03-23 00:00:00	2001-03-23	2001-03-23 00:00:00	2001-03-23	581452		0	0	0		0	0	0	214334	0	52	40213296		
59497	4945	40236824	1985-05-21	1985-05-21 00:00:00	1985-05-28	1985-05-28 00:00:00	1985-05-28	38000177		0	0	7		0	0	0	328740	0	1094107	40236824		
57306	4756	1713671	2000-10-22	2000-10-22 00:00:00	2000-11-12	2000-11-12 00:00:00	2000-11-12	38000177		0	0	21		0	0	0	316845	0	562251	1713671		
43799	3628	1713671	1992-02-06	1992-02-06 00:00:00	1992-02-20	1992-02-20 00:00:00	1992-02-20	38000177		0	0	14		0	0	0	241362	0	562251	1713671		
54291	4513	1127433	1978-12-05	1978-12-05 00:00:00	1978-12-19	1978-12-19 00:00:00	1978-12-19	38000177		0	0	14		0	0	0	300519	0	313782	1127433		
184454	4053	40213227	2012-12-02	2012-12-02 00:00:00	2012-12-02	2012-12-02 00:00:00	2012-12-02	581452		0	0	0		0	0	0	269447	0	113	40213227		
51732	4297	1118084	2017-02-14	2017-02-14 00:00:00	2017-02-14	2017-02-14 00:00:00	\N	38000177		0	0	0		0	0	0	285174	0	00025152531	44923712		
80650	1764	40213227	2010-09-09	2010-09-09 00:00:00	2010-09-09	2010-09-09 00:00:00	2010-09-09	581452		0	0	0		0	0	0	117967	0	113	40213227		
13906	1162	19059056	1924-09-05	1924-09-05 00:00:00	1924-09-19	1924-09-19 00:00:00	1924-09-19	38000177		0	0	14		0	0	0	76755	0	243670	19059056		
48168	3993	1127433	1991-08-31	1991-08-31 00:00:00	1991-09-21	1991-09-21 00:00:00	1991-09-21	38000177		0	0	21		0	0	0	265521	0	313782	1127433		
129218	2842	40213296	2001-03-29	2001-03-29 00:00:00	2001-03-29	2001-03-29 00:00:00	2001-03-29	581452		0	0	0		0	0	0	188662	0	52	40213296		
7669	644	1713671	1996-02-22	1996-02-22 00:00:00	1996-03-07	1996-03-07 00:00:00	1996-03-07	38000177		0	0	14		0	0	0	42635	0	562251	1713671		
19493	1606	19074841	1995-05-04	1995-05-04 00:00:00	1995-05-18	1995-05-18 00:00:00	1995-05-18	38000177		0	0	14		0	0	0	107807	0	309043	19074841		
16884	1397	43012754	1992-11-05	1992-11-05 00:00:00	1993-10-31	1993-10-31 00:00:00	1993-10-31	38000177		0	0	360		0	0	0	92749	0	1366343	43012754		
19586	1611	19133905	1981-04-10	1981-04-10 00:00:00	1981-04-23	1981-04-23 00:00:00	1981-04-23	38000177		0	0	13		0	0	0	108276	0	834102	19133905		
16437	1361	19059056	1955-01-13	1955-01-13 00:00:00	1955-03-14	1955-03-14 00:00:00	1955-03-14	38000177		0	0	60		0	0	0	90289	0	243670	19059056		
16460	1365	46233710	1975-10-26	1975-10-26 00:00:00	1975-11-09	1975-11-09 00:00:00	1975-11-09	38000177		0	0	14		0	0	0	90466	0	1650142	46233710		
21277	1750	1118084	2002-08-24	2002-08-24 00:00:00	2002-08-24	2002-08-24 00:00:00	\N	38000177		0	0	0		0	0	0	117012	0	00025152531	44923712		
38044	3145	1127433	2001-12-15	2001-12-15 00:00:00	2002-01-05	2002-01-05 00:00:00	2002-01-05	38000177		0	0	21		0	0	0	209303	0	313782	1127433		
81544	1782	40213296	1996-01-02	1996-01-02 00:00:00	1996-01-02	1996-01-02 00:00:00	1996-01-02	581452		0	0	0		0	0	0	119293	0	52	40213296		
118019	2594	40213314	1977-02-23	1977-02-23 00:00:00	1977-02-23	1977-02-23 00:00:00	1977-02-23	581452		0	0	0		0	0	0	171687	0	49	40213314		
184092	4045	40213306	1996-04-06	1996-04-06 00:00:00	1996-04-06	1996-04-06 00:00:00	1996-04-06	581452		0	0	0		0	0	0	269027	0	43	40213306		
20628	449	40213160	1960-04-07	1960-04-07 00:00:00	1960-04-07	1960-04-07 00:00:00	1960-04-07	581452		0	0	0		0	0	0	29965	0	10	40213160		
52422	1146	40213227	2001-01-25	2001-01-25 00:00:00	2001-01-25	2001-01-25 00:00:00	2001-01-25	581452		0	0	0		0	0	0	75731	0	113	40213227		
52583	4372	1713671	1996-11-04	1996-11-04 00:00:00	1996-11-11	1996-11-11 00:00:00	1996-11-11	38000177		0	0	7		0	0	0	290243	0	562251	1713671		
236905	5201	40213227	2009-05-13	2009-05-13 00:00:00	2009-05-13	2009-05-13 00:00:00	2009-05-13	581452		0	0	0		0	0	0	345947	0	113	40213227		
18096	1498	1127078	1969-01-19	1969-01-19 00:00:00	1969-02-02	1969-02-02 00:00:00	1969-02-02	38000177		0	0	14		0	0	0	99949	0	282464	1127078		
166403	3658	40213160	1961-08-13	1961-08-13 00:00:00	1961-08-13	1961-08-13 00:00:00	1961-08-13	581452		0	0	0		0	0	0	243444	0	10	40213160		
44161	962	40213160	1955-10-21	1955-10-21 00:00:00	1955-10-21	1955-10-21 00:00:00	1955-10-21	581452		0	0	0		0	0	0	64107	0	10	40213160		
72791	1590	40213260	2011-04-10	2011-04-10 00:00:00	2011-04-10	2011-04-10 00:00:00	2011-04-10	581452		0	0	0		0	0	0	106727	0	121	40213260		
51557	4284	19059056	1947-07-01	1947-07-01 00:00:00	1947-07-15	1947-07-15 00:00:00	1947-07-15	38000177		0	0	14		0	0	0	284382	0	243670	19059056		
111778	2456	40213260	2006-12-17	2006-12-17 00:00:00	2006-12-17	2006-12-17 00:00:00	2006-12-17	581452		0	0	0		0	0	0	162790	0	121	40213260		
63811	5301	19059056	1923-09-03	1923-09-03 00:00:00	1923-09-17	1923-09-17 00:00:00	1923-09-17	38000177		0	0	14		0	0	0	352746	0	243670	19059056		
64073	5322	19078461	2000-09-29	2000-09-29 00:00:00	2000-10-27	2000-10-27 00:00:00	2000-10-27	38000177		0	0	28		0	0	0	354261	0	310965	19078461		
235370	5170	40213296	2009-01-02	2009-01-02 00:00:00	2009-01-02	2009-01-02 00:00:00	2009-01-02	581452		0	0	0		0	0	0	343782	0	52	40213296		
5949	129	40213314	1977-03-14	1977-03-14 00:00:00	1977-03-14	1977-03-14 00:00:00	1977-03-14	581452		0	0	0		0	0	0	8717	0	49	40213314		
24207	1990	40229134	1980-11-18	1980-11-18 00:00:00	1980-12-02	1980-12-02 00:00:00	1980-12-02	38000177		0	0	14		0	0	0	132483	0	1043400	40229134		
34738	2868	1127078	1970-03-02	1970-03-02 00:00:00	1970-03-16	1970-03-16 00:00:00	1970-03-16	38000177		0	0	14		0	0	0	190818	0	282464	1127078		
51647	1131	40213260	2016-04-13	2016-04-13 00:00:00	2016-04-13	2016-04-13 00:00:00	2016-04-13	581452		0	0	0		0	0	0	74432	0	121	40213260		
41358	3430	19126352	2001-03-17	2001-03-17 00:00:00	2001-03-17	2001-03-17 00:00:00	\N	38000177		0	0	0		0	0	0	227371	0	705129	19126352		
57848	4807	920300	2002-04-21	2002-04-21 00:00:00	2002-04-28	2002-04-28 00:00:00	2002-04-28	38000177		0	0	7		0	0	0	319858	0	311989	920300		
52482	1148	40213160	1958-03-01	1958-03-01 00:00:00	1958-03-01	1958-03-01 00:00:00	1958-03-01	581452		0	0	0		0	0	0	75925	0	10	40213160		
57920	4812	1713671	1997-08-04	1997-08-04 00:00:00	1997-08-18	1997-08-18 00:00:00	1997-08-18	38000177		0	0	14		0	0	0	320126	0	562251	1713671		
211319	4634	40213160	1963-07-18	1963-07-18 00:00:00	1963-07-18	1963-07-18 00:00:00	1963-07-18	581452		0	0	0		0	0	0	308860	0	10	40213160		
111268	2444	40213160	1959-09-27	1959-09-27 00:00:00	1959-09-27	1959-09-27 00:00:00	1959-09-27	581452		0	0	0		0	0	0	162115	0	10	40213160		
84701	1852	40213227	1995-04-26	1995-04-26 00:00:00	1995-04-26	1995-04-26 00:00:00	1995-04-26	581452		0	0	0		0	0	0	123875	0	113	40213227		
22763	1870	920300	1957-05-08	1957-05-08 00:00:00	1957-05-15	1957-05-15 00:00:00	1957-05-15	38000177		0	0	7		0	0	0	124935	0	311989	920300		
33209	2752	40236824	1972-04-15	1972-04-15 00:00:00	1972-04-22	1972-04-22 00:00:00	1972-04-22	38000177		0	0	7		0	0	0	182073	0	1094107	40236824		
180950	3976	40213296	2005-04-21	2005-04-21 00:00:00	2005-04-21	2005-04-21 00:00:00	2005-04-21	581452		0	0	0		0	0	0	\N	0	52	40213296		
48058	3984	1127078	1955-12-13	1955-12-13 00:00:00	1955-12-27	1955-12-27 00:00:00	1955-12-27	38000177		0	0	14		0	0	0	264823	0	282464	1127078		
48132	3989	1115171	2003-11-21	2003-11-21 00:00:00	2004-02-19	2004-02-19 00:00:00	2004-02-19	38000177		0	0	90		0	0	0	265248	0	849574	1115171		
179764	3951	40213227	1994-10-01	1994-10-01 00:00:00	1994-10-01	1994-10-01 00:00:00	1994-10-01	581452		0	0	0		0	0	0	262682	0	113	40213227		
86820	1903	40213260	2013-06-25	2013-06-25 00:00:00	2013-06-25	2013-06-25 00:00:00	2013-06-25	581452		0	0	0		0	0	0	126717	0	121	40213260		
59902	4977	19133905	1981-06-24	1981-06-24 00:00:00	1981-07-06	1981-07-06 00:00:00	1981-07-06	38000177		0	0	12		0	0	0	331124	0	834102	19133905		
71932	1572	40213160	1963-03-01	1963-03-01 00:00:00	1963-03-01	1963-03-01 00:00:00	1963-03-01	581452		0	0	0		0	0	0	105564	0	10	40213160		
25436	2090	1127433	1999-05-05	1999-05-05 00:00:00	1999-05-12	1999-05-12 00:00:00	1999-05-12	38000177		0	0	7		0	0	0	139377	0	313782	1127433		
92526	2030	40213160	1962-12-30	1962-12-30 00:00:00	1962-12-30	1962-12-30 00:00:00	1962-12-30	581452		0	0	0		0	0	0	135121	0	10	40213160		
137466	3017	40213160	1957-11-22	1957-11-22 00:00:00	1957-11-22	1957-11-22 00:00:00	1957-11-22	581452		0	0	0		0	0	0	201216	0	10	40213160		
19091	1577	19078461	2017-01-20	2017-01-20 00:00:00	2017-04-20	2017-04-20 00:00:00	2017-04-20	38000177		0	0	90		0	0	0	105934	0	310965	19078461		
2794	225	1127433	1978-04-06	1978-04-06 00:00:00	1978-04-20	1978-04-20 00:00:00	1978-04-20	38000177		0	0	14		0	0	0	15143	0	313782	1127433		
31970	697	40213306	1986-04-23	1986-04-23 00:00:00	1986-04-23	1986-04-23 00:00:00	1986-04-23	581452		0	0	0		0	0	0	\N	0	43	40213306		
149227	3283	40213160	1979-03-23	1979-03-23 00:00:00	1979-03-23	1979-03-23 00:00:00	1979-03-23	581452		0	0	0		0	0	0	218131	0	10	40213160		
241051	5291	40213227	1999-08-15	1999-08-15 00:00:00	1999-08-15	1999-08-15 00:00:00	1999-08-15	581452		0	0	0		0	0	0	352092	0	113	40213227		
146974	3232	40213160	1968-08-26	1968-08-26 00:00:00	1968-08-26	1968-08-26 00:00:00	1968-08-26	581452		0	0	0		0	0	0	214865	0	10	40213160		
102827	2256	40213160	1978-11-15	1978-11-15 00:00:00	1978-11-15	1978-11-15 00:00:00	1978-11-15	581452		0	0	0		0	0	0	149921	0	10	40213160		
59498	4945	920300	1985-05-21	1985-05-21 00:00:00	1985-05-28	1985-05-28 00:00:00	1985-05-28	38000177		0	0	7		0	0	0	328740	0	311989	920300		
57307	4756	1127433	1952-03-19	1952-03-19 00:00:00	1952-03-26	1952-03-26 00:00:00	1952-03-26	38000177		0	0	7		0	0	0	316863	0	313782	1127433		
43800	3628	1127433	2000-08-16	2000-08-16 00:00:00	2000-08-30	2000-08-30 00:00:00	2000-08-30	38000177		0	0	14		0	0	0	241395	0	313782	1127433		
54292	4513	19133905	2014-07-07	2014-07-07 00:00:00	2014-07-20	2014-07-20 00:00:00	2014-07-20	38000177		0	0	13		0	0	0	300566	0	834102	19133905		
184465	4053	40213160	1966-08-28	1966-08-28 00:00:00	1966-08-28	1966-08-28 00:00:00	1966-08-28	581452		0	0	0		0	0	0	269432	0	10	40213160		
51737	4299	40229134	2015-02-02	2015-02-02 00:00:00	2015-02-16	2015-02-16 00:00:00	2015-02-16	38000177		0	0	14		0	0	0	285256	0	1043400	40229134		
89650	1966	40213160	1966-04-05	1966-04-05 00:00:00	1966-04-05	1966-04-05 00:00:00	1966-04-05	581452		0	0	0		0	0	0	130678	0	10	40213160		
13907	1162	1127433	2002-07-15	2002-07-15 00:00:00	2002-07-29	2002-07-29 00:00:00	2002-07-29	38000177		0	0	14		0	0	0	76754	0	313782	1127433		
48169	3993	40229134	1991-06-24	1991-06-24 00:00:00	1991-07-01	1991-07-01 00:00:00	1991-07-01	38000177		0	0	7		0	0	0	265470	0	1043400	40229134		
129221	2842	40213306	1982-06-24	1982-06-24 00:00:00	1982-06-24	1982-06-24 00:00:00	1982-06-24	581452		0	0	0		0	0	0	188689	0	43	40213306		
7670	644	1124300	2013-05-30	2013-05-30 00:00:00	2013-05-30	2013-05-30 00:00:00	\N	38000177		0	0	0		0	0	0	42673	0	00781178901	45011828		
19494	1606	40229134	1999-04-16	1999-04-16 00:00:00	1999-04-30	1999-04-30 00:00:00	1999-04-30	38000177		0	0	14		0	0	0	107803	0	1043400	40229134		
16885	1397	1150771	1977-11-27	1977-11-27 00:00:00	1977-11-27	1977-11-27 00:00:00	\N	38000177		0	0	0		0	0	0	92780	0	197378	1150771		
19587	1611	19059056	1972-11-20	1972-11-20 00:00:00	1972-12-04	1972-12-04 00:00:00	1972-12-04	38000177		0	0	14		0	0	0	108353	0	243670	19059056		
16438	1361	1118084	1982-02-10	1982-02-10 00:00:00	1982-02-10	1982-02-10 00:00:00	\N	38000177		0	0	0		0	0	0	90316	0	00025152531	44923712		
16461	1365	19078461	1975-10-26	1975-10-26 00:00:00	1975-11-09	1975-11-09 00:00:00	1975-11-09	38000177		0	0	14		0	0	0	90466	0	310965	19078461		
21278	1750	1127433	2017-11-03	2017-11-03 00:00:00	2017-11-17	2017-11-17 00:00:00	2017-11-17	38000177		0	0	14		0	0	0	117021	0	313782	1127433		
2356	53	40213160	1962-11-21	1962-11-21 00:00:00	1962-11-21	1962-11-21 00:00:00	1962-11-21	581452		0	0	0		0	0	0	3700	0	10	40213160		
81548	1782	40213227	1993-12-28	1993-12-28 00:00:00	1993-12-28	1993-12-28 00:00:00	1993-12-28	581452		0	0	0		0	0	0	119301	0	113	40213227		
118021	2594	40213296	2015-06-03	2015-06-03 00:00:00	2015-06-03	2015-06-03 00:00:00	2015-06-03	581452		0	0	0		0	0	0	171696	0	52	40213296		
184094	4045	40213227	2005-04-16	2005-04-16 00:00:00	2005-04-16	2005-04-16 00:00:00	2005-04-16	581452		0	0	0		0	0	0	269030	0	113	40213227		
20632	449	40213227	2011-08-04	2011-08-04 00:00:00	2011-08-04	2011-08-04 00:00:00	2011-08-04	581452		0	0	0		0	0	0	29871	0	113	40213227		
52423	1146	40213296	2001-01-25	2001-01-25 00:00:00	2001-01-25	2001-01-25 00:00:00	2001-01-25	581452		0	0	0		0	0	0	75731	0	52	40213296		
52584	4372	920300	2013-07-04	2013-07-04 00:00:00	2013-07-11	2013-07-11 00:00:00	2013-07-11	38000177		0	0	7		0	0	0	290292	0	311989	920300		
236906	5201	40213314	1978-09-13	1978-09-13 00:00:00	1978-09-13	1978-09-13 00:00:00	1978-09-13	581452		0	0	0		0	0	0	345968	0	49	40213314		
18097	1498	19129655	1969-01-19	1969-01-19 00:00:00	1969-02-02	1969-02-02 00:00:00	1969-02-02	38000177		0	0	14		0	0	0	99949	0	789980	19129655		
166406	3658	40213306	1983-02-20	1983-02-20 00:00:00	1983-02-20	1983-02-20 00:00:00	1983-02-20	581452		0	0	0		0	0	0	\N	0	43	40213306		
25346	552	40213227	2002-09-24	2002-09-24 00:00:00	2002-09-24	2002-09-24 00:00:00	2002-09-24	581452		0	0	0		0	0	0	36659	0	113	40213227		
72795	1590	40213296	2002-10-13	2002-10-13 00:00:00	2002-10-13	2002-10-13 00:00:00	2002-10-13	581452		0	0	0		0	0	0	106726	0	52	40213296		
51558	4284	19133905	1998-04-01	1998-04-01 00:00:00	1998-04-08	1998-04-08 00:00:00	1998-04-08	38000177		0	0	7		0	0	0	284394	0	834102	19133905		
111786	2456	40213160	1960-04-03	1960-04-03 00:00:00	1960-04-03	1960-04-03 00:00:00	1960-04-03	581452		0	0	0		0	0	0	162758	0	10	40213160		
63812	5301	19133905	1986-03-28	1986-03-28 00:00:00	1986-04-04	1986-04-04 00:00:00	1986-04-04	38000177		0	0	7		0	0	0	352752	0	834102	19133905		
64074	5322	19059056	1949-01-23	1949-01-23 00:00:00	1949-02-06	1949-02-06 00:00:00	1949-02-06	38000177		0	0	14		0	0	0	354158	0	243670	19059056		
235373	5170	40213160	1973-12-07	1973-12-07 00:00:00	1973-12-07	1973-12-07 00:00:00	1973-12-07	581452		0	0	0		0	0	0	343804	0	10	40213160		
5953	129	40213227	2016-06-27	2016-06-27 00:00:00	2016-06-27	2016-06-27 00:00:00	2016-06-27	581452		0	0	0		0	0	0	8721	0	113	40213227		
24208	1990	19128065	1984-05-02	1984-05-02 00:00:00	1985-04-27	1985-04-27 00:00:00	1985-04-27	38000177		0	0	360		0	0	0	132489	0	749882	19128065		
34739	2868	19128065	1983-08-31	1983-08-31 00:00:00	1984-08-25	1984-08-25 00:00:00	1984-08-25	38000177		0	0	360		0	0	0	190764	0	749882	19128065		
51648	1131	40213296	2008-11-12	2008-11-12 00:00:00	2008-11-12	2008-11-12 00:00:00	2008-11-12	581452		0	0	0		0	0	0	74431	0	52	40213296		
41359	3430	19075601	2001-03-17	2001-03-17 00:00:00	2011-10-08	2011-10-08 00:00:00	2011-10-08	38000177		0	0	3857		0	0	0	227371	0	309362	19075601		
57849	4807	19059056	1946-03-24	1946-03-24 00:00:00	1946-04-14	1946-04-14 00:00:00	1946-04-14	38000177		0	0	21		0	0	0	319805	0	243670	19059056		
52489	1148	40213160	1957-11-30	1957-11-30 00:00:00	1957-11-30	1957-11-30 00:00:00	1957-11-30	581452		0	0	0		0	0	0	75936	0	10	40213160		
57921	4812	19059056	1968-03-01	1968-03-01 00:00:00	1968-03-29	1968-03-29 00:00:00	1968-03-29	38000177		0	0	28		0	0	0	320161	0	243670	19059056		
211321	4634	40213160	1967-10-19	1967-10-19 00:00:00	1967-10-19	1967-10-19 00:00:00	1967-10-19	581452		0	0	0		0	0	0	308855	0	10	40213160		
104344	2289	40213201	2016-08-30	2016-08-30 00:00:00	2016-08-30	2016-08-30 00:00:00	2016-08-30	581452		0	0	0		0	0	0	152228	0	33	40213201		
84707	1852	40213314	1977-01-26	1977-01-26 00:00:00	1977-01-26	1977-01-26 00:00:00	1977-01-26	581452		0	0	0		0	0	0	123869	0	49	40213314		
22764	1870	1118084	1957-05-29	1957-05-29 00:00:00	1957-05-29	1957-05-29 00:00:00	\N	38000177		0	0	0		0	0	0	124935	0	00025152531	44923712		
33211	2752	1127433	1969-03-02	1969-03-02 00:00:00	1969-05-01	1969-05-01 00:00:00	1969-05-01	38000177		0	0	60		0	0	0	182116	0	313782	1127433		
180957	3976	40213160	1963-07-25	1963-07-25 00:00:00	1963-07-25	1963-07-25 00:00:00	1963-07-25	581452		0	0	0		0	0	0	264362	0	10	40213160		
48059	3984	1127433	2016-01-05	2016-01-05 00:00:00	2016-02-02	2016-02-02 00:00:00	2016-02-02	38000177		0	0	28		0	0	0	264887	0	313782	1127433		
48133	3989	19077572	2017-01-23	2017-01-23 00:00:00	2017-01-23	2017-01-23 00:00:00	\N	38000177		0	0	0		0	0	0	265186	0	310436	19077572		
22078	479	40213227	2011-07-10	2011-07-10 00:00:00	2011-07-10	2011-07-10 00:00:00	2011-07-10	581452		0	0	0		0	0	0	31922	0	113	40213227		
86824	1903	40213160	1962-11-27	1962-11-27 00:00:00	1962-11-27	1962-11-27 00:00:00	1962-11-27	581452		0	0	0		0	0	0	126728	0	10	40213160		
59903	4977	1127433	1990-08-13	1990-08-13 00:00:00	1990-08-27	1990-08-27 00:00:00	1990-08-27	38000177		0	0	14		0	0	0	331163	0	313782	1127433		
71933	1572	40213160	1967-06-02	1967-06-02 00:00:00	1967-06-02	1967-06-02 00:00:00	1967-06-02	581452		0	0	0		0	0	0	105585	0	10	40213160		
25437	2090	19078461	2016-04-07	2016-04-07 00:00:00	2016-04-21	2016-04-21 00:00:00	2016-04-21	38000177		0	0	14		0	0	0	139375	0	310965	19078461		
103826	2277	40213227	2007-09-16	2007-09-16 00:00:00	2007-09-16	2007-09-16 00:00:00	2007-09-16	581452		0	0	0		0	0	0	151368	0	113	40213227		
211819	4644	40213160	1962-10-11	1962-10-11 00:00:00	1962-10-11	1962-10-11 00:00:00	1962-10-11	581452		0	0	0		0	0	0	309691	0	10	40213160		
19092	1577	1127433	2003-05-15	2003-05-15 00:00:00	2003-05-22	2003-05-22 00:00:00	2003-05-22	38000177		0	0	7		0	0	0	105878	0	313782	1127433		
2795	225	1127433	2010-08-28	2010-08-28 00:00:00	2010-09-11	2010-09-11 00:00:00	2010-09-11	38000177		0	0	14		0	0	0	15184	0	313782	1127433		
31972	697	40213260	2015-05-13	2015-05-13 00:00:00	2015-05-13	2015-05-13 00:00:00	2015-05-13	581452		0	0	0		0	0	0	46098	0	121	40213260		
149234	3283	40213227	2000-09-15	2000-09-15 00:00:00	2000-09-15	2000-09-15 00:00:00	2000-09-15	581452		0	0	0		0	0	0	218117	0	113	40213227		
241052	5291	40213306	1999-08-15	1999-08-15 00:00:00	1999-08-15	1999-08-15 00:00:00	1999-08-15	581452		0	0	0		0	0	0	352092	0	43	40213306		
146980	3232	40213227	1995-03-06	1995-03-06 00:00:00	1995-03-06	1995-03-06 00:00:00	1995-03-06	581452		0	0	0		0	0	0	214824	0	113	40213227		
102828	2256	40213314	1978-11-15	1978-11-15 00:00:00	1978-11-15	1978-11-15 00:00:00	1978-11-15	581452		0	0	0		0	0	0	149921	0	49	40213314		
59499	4945	40229134	1982-05-03	1982-05-03 00:00:00	1982-05-17	1982-05-17 00:00:00	1982-05-17	38000177		0	0	14		0	0	0	328667	0	1043400	40229134		
57308	4756	19077572	2018-12-01	2018-12-01 00:00:00	2018-12-01	2018-12-01 00:00:00	\N	38000177		0	0	0		0	0	0	316860	0	310436	19077572		
43801	3628	19059056	1915-10-23	1915-10-23 00:00:00	1915-11-06	1915-11-06 00:00:00	1915-11-06	38000177		0	0	14		0	0	0	241333	0	243670	19059056		
54293	4513	1115171	2003-09-02	2003-09-02 00:00:00	2003-10-07	2003-10-07 00:00:00	2003-10-07	38000177		0	0	35		0	0	0	300587	0	849574	1115171		
117705	2588	40213227	2006-09-10	2006-09-10 00:00:00	2006-09-10	2006-09-10 00:00:00	2006-09-10	581452		0	0	0		0	0	0	171294	0	113	40213227		
51738	4299	1127433	1982-01-12	1982-01-12 00:00:00	1982-01-19	1982-01-19 00:00:00	1982-01-19	38000177		0	0	7		0	0	0	285245	0	313782	1127433		
89652	1966	40213227	2013-01-29	2013-01-29 00:00:00	2013-01-29	2013-01-29 00:00:00	2013-01-29	581452		0	0	0		0	0	0	130721	0	113	40213227		
13908	1162	1124300	1963-07-08	1963-07-08 00:00:00	1963-07-08	1963-07-08 00:00:00	\N	38000177		0	0	0		0	0	0	76663	0	00781178901	45011828		
48170	3993	1127433	1947-07-06	1947-07-06 00:00:00	1947-07-13	1947-07-13 00:00:00	1947-07-13	38000177		0	0	7		0	0	0	265479	0	313782	1127433		
129231	2842	40213227	2010-04-01	2010-04-01 00:00:00	2010-04-01	2010-04-01 00:00:00	2010-04-01	581452		0	0	0		0	0	0	188664	0	113	40213227		
7671	644	1127078	1982-09-29	1982-09-29 00:00:00	1982-11-28	1982-11-28 00:00:00	1982-11-28	38000177		0	0	60		0	0	0	42666	0	282464	1127078		
19495	1606	19059056	1962-04-04	1962-04-04 00:00:00	1962-04-25	1962-04-25 00:00:00	1962-04-25	38000177		0	0	21		0	0	0	107796	0	243670	19059056		
16886	1397	1124300	2016-08-26	2016-08-26 00:00:00	2016-08-26	2016-08-26 00:00:00	\N	38000177		0	0	0		0	0	0	92745	0	00781178901	45011828		
19588	1611	1713671	1972-05-25	1972-05-25 00:00:00	1972-06-15	1972-06-15 00:00:00	1972-06-15	38000177		0	0	21		0	0	0	108274	0	562251	1713671		
16439	1361	19059056	1942-04-21	1942-04-21 00:00:00	1942-05-05	1942-05-05 00:00:00	1942-05-05	38000177		0	0	14		0	0	0	90376	0	243670	19059056		
16462	1365	1118084	2002-06-28	2002-06-28 00:00:00	2002-06-28	2002-06-28 00:00:00	\N	38000177		0	0	0		0	0	0	90475	0	00025152531	44923712		
21279	1750	1127078	1968-08-12	1968-08-12 00:00:00	1968-08-26	1968-08-26 00:00:00	1968-08-26	38000177		0	0	14		0	0	0	117022	0	282464	1127078		
2363	53	40213160	1967-04-19	1967-04-19 00:00:00	1967-04-19	1967-04-19 00:00:00	1967-04-19	581452		0	0	0		0	0	0	3703	0	10	40213160		
48530	1062	40213160	1966-11-27	1966-11-27 00:00:00	1966-11-27	1966-11-27 00:00:00	1966-11-27	581452		0	0	0		0	0	0	69679	0	10	40213160		
118026	2594	40213160	1980-02-27	1980-02-27 00:00:00	1980-02-27	1980-02-27 00:00:00	1980-02-27	581452		0	0	0		0	0	0	171732	0	10	40213160		
184096	4045	40213227	2016-02-27	2016-02-27 00:00:00	2016-02-27	2016-02-27 00:00:00	2016-02-27	581452		0	0	0		0	0	0	268995	0	113	40213227		
20634	449	40213260	2011-08-04	2011-08-04 00:00:00	2011-08-04	2011-08-04 00:00:00	2011-08-04	581452		0	0	0		0	0	0	29871	0	121	40213260		
241673	5306	40213306	1991-03-24	1991-03-24 00:00:00	1991-03-24	1991-03-24 00:00:00	1991-03-24	581452		0	0	0		0	0	0	352973	0	43	40213306		
52585	4372	40236824	2013-07-04	2013-07-04 00:00:00	2013-07-11	2013-07-11 00:00:00	2013-07-11	38000177		0	0	7		0	0	0	290292	0	1094107	40236824		
236907	5201	40213160	1978-09-13	1978-09-13 00:00:00	1978-09-13	1978-09-13 00:00:00	1978-09-13	581452		0	0	0		0	0	0	345968	0	10	40213160		
18098	1498	1127433	2008-09-11	2008-09-11 00:00:00	2008-09-18	2008-09-18 00:00:00	2008-09-18	38000177		0	0	7		0	0	0	99960	0	313782	1127433		
166409	3658	40213160	1965-11-14	1965-11-14 00:00:00	1965-11-14	1965-11-14 00:00:00	1965-11-14	581452		0	0	0		0	0	0	243486	0	10	40213160		
183041	4021	40213227	2016-04-13	2016-04-13 00:00:00	2016-04-13	2016-04-13 00:00:00	2016-04-13	581452		0	0	0		0	0	0	267346	0	113	40213227		
72797	1590	40213227	2002-10-13	2002-10-13 00:00:00	2002-10-13	2002-10-13 00:00:00	2002-10-13	581452		0	0	0		0	0	0	106726	0	113	40213227		
51559	4284	1127433	1958-03-20	1958-03-20 00:00:00	1958-04-03	1958-04-03 00:00:00	1958-04-03	38000177		0	0	14		0	0	0	284368	0	313782	1127433		
111790	2456	40213227	2017-02-12	2017-02-12 00:00:00	2017-02-12	2017-02-12 00:00:00	2017-02-12	581452		0	0	0		0	0	0	162797	0	113	40213227		
63813	5301	920334	1940-09-08	1940-09-08 00:00:00	1940-09-15	1940-09-15 00:00:00	1940-09-15	38000177		0	0	7		0	0	0	352726	0	311995	920334		
64075	5322	19006318	1949-01-23	1949-01-23 00:00:00	1949-02-06	1949-02-06 00:00:00	1949-02-06	38000177		0	0	14		0	0	0	354158	0	105078	19006318		
235380	5170	40213160	1969-04-04	1969-04-04 00:00:00	1969-04-04	1969-04-04 00:00:00	1969-04-04	581452		0	0	0		0	0	0	343768	0	10	40213160		
5954	129	40213296	2016-06-27	2016-06-27 00:00:00	2016-06-27	2016-06-27 00:00:00	2016-06-27	581452		0	0	0		0	0	0	8721	0	52	40213296		
24210	1990	19129655	1970-04-25	1970-04-25 00:00:00	1970-05-09	1970-05-09 00:00:00	1970-05-09	38000177		0	0	14		0	0	0	132508	0	789980	19129655		
34740	2868	19075601	2002-10-16	2002-10-16 00:00:00	2016-02-10	2016-02-10 00:00:00	2016-02-10	38000177		0	0	4865		0	0	0	190783	0	309362	19075601		
51651	1131	40213227	1998-10-28	1998-10-28 00:00:00	1998-10-28	1998-10-28 00:00:00	1998-10-28	581452		0	0	0		0	0	0	74465	0	113	40213227		
41360	3430	1539411	2001-03-17	2001-03-17 00:00:00	2001-03-17	2001-03-17 00:00:00	\N	38000177		0	0	0		0	0	0	227371	0	312961	1539411		
57850	4807	19133873	1961-04-05	1961-04-05 00:00:00	1961-04-13	1961-04-13 00:00:00	1961-04-13	38000177		0	0	8		0	0	0	319788	0	834061	19133873		
52491	1148	40213160	1962-05-26	1962-05-26 00:00:00	1962-05-26	1962-05-26 00:00:00	1962-05-26	581452		0	0	0		0	0	0	75893	0	10	40213160		
57922	4812	1118084	1989-12-18	1989-12-18 00:00:00	1989-12-18	1989-12-18 00:00:00	\N	38000177		0	0	0		0	0	0	320159	0	00025152531	44923712		
211322	4634	40213227	2013-11-14	2013-11-14 00:00:00	2013-11-14	2013-11-14 00:00:00	2013-11-14	581452		0	0	0		0	0	0	308837	0	113	40213227		
104355	2289	40213227	1992-03-24	1992-03-24 00:00:00	1992-03-24	1992-03-24 00:00:00	1992-03-24	581452		0	0	0		0	0	0	152276	0	113	40213227		
84710	1852	40213160	1973-11-14	1973-11-14 00:00:00	1973-11-14	1973-11-14 00:00:00	1973-11-14	581452		0	0	0		0	0	0	123923	0	10	40213160		
22765	1870	1127433	1932-07-24	1932-07-24 00:00:00	1932-07-31	1932-07-31 00:00:00	1932-07-31	38000177		0	0	7		0	0	0	124916	0	313782	1127433		
33212	2752	19059056	1960-01-14	1960-01-14 00:00:00	1960-01-28	1960-01-28 00:00:00	1960-01-28	38000177		0	0	14		0	0	0	182114	0	243670	19059056		
180961	3976	40213306	1985-08-29	1985-08-29 00:00:00	1985-08-29	1985-08-29 00:00:00	1985-08-29	581452		0	0	0		0	0	0	264331	0	43	40213306		
48069	3986	19128065	1978-08-06	1978-08-06 00:00:00	1979-08-01	1979-08-01 00:00:00	1979-08-01	38000177		0	0	360		0	0	0	265003	0	749882	19128065		
48134	3989	1127433	1981-01-13	1981-01-13 00:00:00	1981-01-20	1981-01-20 00:00:00	1981-01-20	38000177		0	0	7		0	0	0	265257	0	313782	1127433		
22080	479	40213201	2005-11-20	2005-11-20 00:00:00	2005-11-20	2005-11-20 00:00:00	2005-11-20	581452		0	0	0		0	0	0	31946	0	33	40213201		
122100	2684	40213160	1961-10-22	1961-10-22 00:00:00	1961-10-22	1961-10-22 00:00:00	1961-10-22	581452		0	0	0		0	0	0	177864	0	10	40213160		
59904	4977	19128065	1975-12-04	1975-12-04 00:00:00	1976-11-28	1976-11-28 00:00:00	1976-11-28	38000177		0	0	360		0	0	0	331194	0	749882	19128065		
58939	1289	40213260	2012-03-13	2012-03-13 00:00:00	2012-03-13	2012-03-13 00:00:00	2012-03-13	581452		0	0	0		0	0	0	85223	0	121	40213260		
25438	2090	1127078	1976-06-08	1976-06-08 00:00:00	1976-07-06	1976-07-06 00:00:00	1976-07-06	38000177		0	0	28		0	0	0	139373	0	282464	1127078		
103827	2277	40213296	2007-09-16	2007-09-16 00:00:00	2007-09-16	2007-09-16 00:00:00	2007-09-16	581452		0	0	0		0	0	0	151368	0	52	40213296		
211822	4644	40213160	1967-06-15	1967-06-15 00:00:00	1967-06-15	1967-06-15 00:00:00	1967-06-15	581452		0	0	0		0	0	0	309684	0	10	40213160		
19093	1577	40236824	1955-03-22	1955-03-22 00:00:00	1955-03-29	1955-03-29 00:00:00	1955-03-29	38000177		0	0	7		0	0	0	105836	0	1094107	40236824		
2796	225	1127078	1971-09-28	1971-09-28 00:00:00	1971-10-19	1971-10-19 00:00:00	1971-10-19	38000177		0	0	21		0	0	0	15149	0	282464	1127078		
31977	697	40213160	1965-07-21	1965-07-21 00:00:00	1965-07-21	1965-07-21 00:00:00	1965-07-21	581452		0	0	0		0	0	0	46130	0	10	40213160		
149235	3283	40213306	2000-09-15	2000-09-15 00:00:00	2000-09-15	2000-09-15 00:00:00	2000-09-15	581452		0	0	0		0	0	0	218117	0	43	40213306		
241054	5291	40213296	2016-01-31	2016-01-31 00:00:00	2016-01-31	2016-01-31 00:00:00	2016-01-31	581452		0	0	0		0	0	0	352039	0	52	40213296		
146986	3232	40213296	2003-09-22	2003-09-22 00:00:00	2003-09-22	2003-09-22 00:00:00	2003-09-22	581452		0	0	0		0	0	0	214844	0	52	40213296		
102834	2256	40213306	2001-04-18	2001-04-18 00:00:00	2001-04-18	2001-04-18 00:00:00	2001-04-18	581452		0	0	0		0	0	0	149932	0	43	40213306		
59501	4945	1118084	1989-03-06	1989-03-06 00:00:00	1989-03-06	1989-03-06 00:00:00	\N	38000177		0	0	0		0	0	0	328668	0	00025152531	44923712		
57309	4756	19133905	2006-04-02	2006-04-02 00:00:00	2006-04-11	2006-04-11 00:00:00	2006-04-11	38000177		0	0	9		0	0	0	316788	0	834102	19133905		
43802	3628	1713671	1929-07-09	1929-07-09 00:00:00	1929-07-16	1929-07-16 00:00:00	1929-07-16	38000177		0	0	7		0	0	0	241405	0	562251	1713671		
54294	4513	1118084	1995-12-27	1995-12-27 00:00:00	1995-12-27	1995-12-27 00:00:00	\N	38000177		0	0	0		0	0	0	300546	0	00025152531	44923712		
117707	2588	40213296	2006-09-10	2006-09-10 00:00:00	2006-09-10	2006-09-10 00:00:00	2006-09-10	581452		0	0	0		0	0	0	171294	0	52	40213296		
51739	4299	19133905	1993-01-10	1993-01-10 00:00:00	1993-01-17	1993-01-17 00:00:00	1993-01-17	38000177		0	0	7		0	0	0	285277	0	834102	19133905		
89653	1966	40213260	2013-01-29	2013-01-29 00:00:00	2013-01-29	2013-01-29 00:00:00	2013-01-29	581452		0	0	0		0	0	0	130721	0	121	40213260		
13909	1162	19133905	1987-12-01	1987-12-01 00:00:00	1987-12-13	1987-12-13 00:00:00	1987-12-13	38000177		0	0	12		0	0	0	76701	0	834102	19133905		
48171	3993	1124300	1980-08-09	1980-08-09 00:00:00	1980-08-09	1980-08-09 00:00:00	\N	38000177		0	0	0		0	0	0	265454	0	00781178901	45011828		
129232	2842	40213260	2010-04-01	2010-04-01 00:00:00	2010-04-01	2010-04-01 00:00:00	2010-04-01	581452		0	0	0		0	0	0	188664	0	121	40213260		
7672	644	19128065	1990-10-13	1990-10-13 00:00:00	1991-10-08	1991-10-08 00:00:00	1991-10-08	38000177		0	0	360		0	0	0	42616	0	749882	19128065		
19496	1606	19059056	1953-12-12	1953-12-12 00:00:00	1954-01-16	1954-01-16 00:00:00	1954-01-16	38000177		0	0	35		0	0	0	107795	0	243670	19059056		
32841	2721	46233988	1971-11-20	1971-11-20 00:00:00	1971-12-04	1971-12-04 00:00:00	1971-12-04	38000177		0	0	14		0	0	0	180331	0	1652673	46233988		
18625	404	40213296	2001-11-20	2001-11-20 00:00:00	2001-11-20	2001-11-20 00:00:00	2001-11-20	581452		0	0	0		0	0	0	26552	0	52	40213296		
16440	1361	40229134	2000-06-08	2000-06-08 00:00:00	2000-06-22	2000-06-22 00:00:00	2000-06-22	38000177		0	0	14		0	0	0	90335	0	1043400	40229134		
16463	1365	19059056	1974-02-25	1974-02-25 00:00:00	1974-05-26	1974-05-26 00:00:00	1974-05-26	38000177		0	0	90		0	0	0	90455	0	243670	19059056		
21280	1750	19006318	1968-08-12	1968-08-12 00:00:00	1968-08-26	1968-08-26 00:00:00	1968-08-26	38000177		0	0	14		0	0	0	117022	0	105078	19006318		
2364	53	40213160	1963-01-23	1963-01-23 00:00:00	1963-01-23	1963-01-23 00:00:00	1963-01-23	581452		0	0	0		0	0	0	3685	0	10	40213160		
48536	1062	40213260	2016-06-19	2016-06-19 00:00:00	2016-06-19	2016-06-19 00:00:00	2016-06-19	581452		0	0	0		0	0	0	69702	0	121	40213260		
118034	2596	40213160	1971-10-09	1971-10-09 00:00:00	1971-10-09	1971-10-09 00:00:00	1971-10-09	581452		0	0	0		0	0	0	171787	0	10	40213160		
184097	4045	40213296	2016-02-27	2016-02-27 00:00:00	2016-02-27	2016-02-27 00:00:00	2016-02-27	581452		0	0	0		0	0	0	268995	0	52	40213296		
20638	449	40213160	1960-02-04	1960-02-04 00:00:00	1960-02-04	1960-02-04 00:00:00	1960-02-04	581452		0	0	0		0	0	0	29954	0	10	40213160		
241675	5306	40213160	1969-09-28	1969-09-28 00:00:00	1969-09-28	1969-09-28 00:00:00	1969-09-28	581452		0	0	0		0	0	0	352941	0	10	40213160		
52586	4373	1713671	1990-03-08	1990-03-08 00:00:00	1990-03-15	1990-03-15 00:00:00	1990-03-15	38000177		0	0	7		0	0	0	290352	0	562251	1713671		
236909	5201	40213227	2000-05-03	2000-05-03 00:00:00	2000-05-03	2000-05-03 00:00:00	2000-05-03	581452		0	0	0		0	0	0	345954	0	113	40213227		
18111	1500	1713671	2008-07-19	2008-07-19 00:00:00	2008-08-02	2008-08-02 00:00:00	2008-08-02	38000177		0	0	14		0	0	0	100129	0	562251	1713671		
166413	3658	40213227	2002-12-15	2002-12-15 00:00:00	2002-12-15	2002-12-15 00:00:00	2002-12-15	581452		0	0	0		0	0	0	243453	0	113	40213227		
183047	4021	40213227	2006-01-18	2006-01-18 00:00:00	2006-01-18	2006-01-18 00:00:00	2006-01-18	581452		0	0	0		0	0	0	267301	0	113	40213227		
72804	1590	40213227	1992-09-27	1992-09-27 00:00:00	1992-09-27	1992-09-27 00:00:00	1992-09-27	581452		0	0	0		0	0	0	106743	0	113	40213227		
51560	4284	19006318	1958-03-20	1958-03-20 00:00:00	1958-04-03	1958-04-03 00:00:00	1958-04-03	38000177		0	0	14		0	0	0	284368	0	105078	19006318		
111792	2456	40213227	1997-05-04	1997-05-04 00:00:00	1997-05-04	1997-05-04 00:00:00	1997-05-04	581452		0	0	0		0	0	0	162763	0	113	40213227		
63814	5301	1127433	1959-01-04	1959-01-04 00:00:00	1959-02-08	1959-02-08 00:00:00	1959-02-08	38000177		0	0	35		0	0	0	352696	0	313782	1127433		
64076	5322	1713671	1985-08-29	1985-08-29 00:00:00	1985-12-26	1985-12-26 00:00:00	1985-12-26	38000177		0	0	119		0	0	0	354110	0	562251	1713671		
55007	1205	40213160	1964-10-01	1964-10-01 00:00:00	1964-10-01	1964-10-01 00:00:00	1964-10-01	581452		0	0	0		0	0	0	79165	0	10	40213160		
5960	129	40213296	2018-07-02	2018-07-02 00:00:00	2018-07-02	2018-07-02 00:00:00	2018-07-02	581452		0	0	0		0	0	0	8703	0	52	40213296		
24211	1990	19059056	1970-04-25	1970-04-25 00:00:00	1970-05-09	1970-05-09 00:00:00	1970-05-09	38000177		0	0	14		0	0	0	132508	0	243670	19059056		
34741	2868	19126352	2002-10-16	2002-10-16 00:00:00	2016-02-10	2016-02-10 00:00:00	2016-02-10	38000177		0	0	4865		0	0	0	190783	0	705129	19126352		
51656	1131	40213227	2017-04-19	2017-04-19 00:00:00	2017-04-19	2017-04-19 00:00:00	2017-04-19	581452		0	0	0		0	0	0	74476	0	113	40213227		
41361	3430	1332419	2001-03-17	2001-03-17 00:00:00	2001-03-17	2001-03-17 00:00:00	\N	38000177		0	0	0		0	0	0	227371	0	197361	1332419		
57853	4807	1127078	1954-03-03	1954-03-03 00:00:00	1954-03-17	1954-03-17 00:00:00	1954-03-17	38000177		0	0	14		0	0	0	319806	0	282464	1127078		
52494	1148	40213227	2018-11-03	2018-11-03 00:00:00	2018-11-03	2018-11-03 00:00:00	2018-11-03	581452		0	0	0		0	0	0	75872	0	113	40213227		
57923	4812	1713671	2011-10-12	2011-10-12 00:00:00	2011-11-02	2011-11-02 00:00:00	2011-11-02	38000177		0	0	21		0	0	0	320112	0	562251	1713671		
211323	4634	40213260	2013-11-14	2013-11-14 00:00:00	2013-11-14	2013-11-14 00:00:00	2013-11-14	581452		0	0	0		0	0	0	308837	0	121	40213260		
115635	2541	40213227	2007-05-07	2007-05-07 00:00:00	2007-05-07	2007-05-07 00:00:00	2007-05-07	581452		0	0	0		0	0	0	168013	0	113	40213227		
84711	1852	40213160	1973-08-15	1973-08-15 00:00:00	1973-08-15	1973-08-15 00:00:00	1973-08-15	581452		0	0	0		0	0	0	123881	0	10	40213160		
22766	1870	1127433	1943-01-16	1943-01-16 00:00:00	1943-01-30	1943-01-30 00:00:00	1943-01-30	38000177		0	0	14		0	0	0	124956	0	313782	1127433		
33213	2752	19059056	1952-06-10	1952-06-10 00:00:00	1952-06-24	1952-06-24 00:00:00	1952-06-24	38000177		0	0	14		0	0	0	182106	0	243670	19059056		
180966	3976	40213160	1968-03-28	1968-03-28 00:00:00	1968-03-28	1968-03-28 00:00:00	1968-03-28	581452		0	0	0		0	0	0	264392	0	10	40213160		
48070	3986	1713671	1966-02-05	1966-02-05 00:00:00	1966-02-26	1966-02-26 00:00:00	1966-02-26	38000177		0	0	21		0	0	0	264979	0	562251	1713671		
48135	3989	1713671	1994-04-20	1994-04-20 00:00:00	1994-05-04	1994-05-04 00:00:00	1994-05-04	38000177		0	0	14		0	0	0	265252	0	562251	1713671		
22084	480	40213201	2004-04-21	2004-04-21 00:00:00	2004-04-21	2004-04-21 00:00:00	2004-04-21	581452		0	0	0		0	0	0	32138	0	33	40213201		
59835	4975	1115171	2014-01-08	2014-01-08 00:00:00	2014-01-22	2014-01-22 00:00:00	2014-01-22	38000177		0	0	14		0	0	0	330920	0	849574	1115171		
59909	4979	1115171	1996-01-10	1996-01-10 00:00:00	1996-01-24	1996-01-24 00:00:00	1996-01-24	38000177		0	0	14		0	0	0	331244	0	849574	1115171		
67418	1475	40213227	1996-05-30	1996-05-30 00:00:00	1996-05-30	1996-05-30 00:00:00	1996-05-30	581452		0	0	0		0	0	0	98293	0	113	40213227		
25439	2090	19133905	2008-07-02	2008-07-02 00:00:00	2008-07-14	2008-07-14 00:00:00	2008-07-14	38000177		0	0	12		0	0	0	139389	0	834102	19133905		
124381	2736	40213160	1969-11-12	1969-11-12 00:00:00	1969-11-12	1969-11-12 00:00:00	1969-11-12	581452		0	0	0		0	0	0	181131	0	10	40213160		
211826	4644	40213227	2004-07-15	2004-07-15 00:00:00	2004-07-15	2004-07-15 00:00:00	2004-07-15	581452		0	0	0		0	0	0	309636	0	113	40213227		
19094	1577	920300	1955-03-22	1955-03-22 00:00:00	1955-03-29	1955-03-29 00:00:00	1955-03-29	38000177		0	0	7		0	0	0	105836	0	311989	920300		
2797	225	1118084	2005-07-13	2005-07-13 00:00:00	2005-07-13	2005-07-13 00:00:00	\N	38000177		0	0	0		0	0	0	15174	0	00025152531	44923712		
31979	697	40213227	2007-01-03	2007-01-03 00:00:00	2007-01-03	2007-01-03 00:00:00	2007-01-03	581452		0	0	0		0	0	0	46160	0	113	40213227		
149237	3283	40213314	1979-09-21	1979-09-21 00:00:00	1979-09-21	1979-09-21 00:00:00	1979-09-21	581452		0	0	0		0	0	0	218094	0	49	40213314		
209527	4595	40213306	1986-04-10	1986-04-10 00:00:00	1986-04-10	1986-04-10 00:00:00	1986-04-10	581452		0	0	0		0	0	0	\N	0	43	40213306		
146991	3232	40213160	1964-05-25	1964-05-25 00:00:00	1964-05-25	1964-05-25 00:00:00	1964-05-25	581452		0	0	0		0	0	0	214847	0	10	40213160		
102836	2256	40213227	2001-04-18	2001-04-18 00:00:00	2001-04-18	2001-04-18 00:00:00	2001-04-18	581452		0	0	0		0	0	0	149932	0	113	40213227		
59502	4945	1127433	1992-11-22	1992-11-22 00:00:00	1992-12-06	1992-12-06 00:00:00	1992-12-06	38000177		0	0	14		0	0	0	328711	0	313782	1127433		
57310	4756	1127433	2010-12-01	2010-12-01 00:00:00	2010-12-15	2010-12-15 00:00:00	2010-12-15	38000177		0	0	14		0	0	0	316786	0	313782	1127433		
43803	3628	19059056	1917-01-29	1917-01-29 00:00:00	1917-02-12	1917-02-12 00:00:00	1917-02-12	38000177		0	0	14		0	0	0	241372	0	243670	19059056		
54295	4513	19059056	1966-09-25	1966-09-25 00:00:00	1966-10-16	1966-10-16 00:00:00	1966-10-16	38000177		0	0	21		0	0	0	300568	0	243670	19059056		
117709	2588	40213260	2015-09-06	2015-09-06 00:00:00	2015-09-06	2015-09-06 00:00:00	2015-09-06	581452		0	0	0		0	0	0	171283	0	121	40213260		
51740	4299	1127078	1973-12-08	1973-12-08 00:00:00	1973-12-22	1973-12-22 00:00:00	1973-12-22	38000177		0	0	14		0	0	0	285232	0	282464	1127078		
89657	1966	40213160	1961-10-03	1961-10-03 00:00:00	1961-10-03	1961-10-03 00:00:00	1961-10-03	581452		0	0	0		0	0	0	130724	0	10	40213160		
13910	1162	1127433	1942-02-15	1942-02-15 00:00:00	1942-02-22	1942-02-22 00:00:00	1942-02-22	38000177		0	0	7		0	0	0	76674	0	313782	1127433		
48172	3993	19133905	1965-04-15	1965-04-15 00:00:00	1965-04-23	1965-04-23 00:00:00	1965-04-23	38000177		0	0	8		0	0	0	265482	0	834102	19133905		
207176	4546	40213160	1973-02-09	1973-02-09 00:00:00	1973-02-09	1973-02-09 00:00:00	1973-02-09	581452		0	0	0		0	0	0	302770	0	10	40213160		
7673	644	19133873	1987-06-04	1987-06-04 00:00:00	1987-06-14	1987-06-14 00:00:00	1987-06-14	38000177		0	0	10		0	0	0	42644	0	834061	19133873		
19497	1606	19006318	1953-12-12	1953-12-12 00:00:00	1954-01-16	1954-01-16 00:00:00	1954-01-16	38000177		0	0	35		0	0	0	107795	0	105078	19006318		
32842	2721	19059056	1971-11-20	1971-11-20 00:00:00	1971-12-04	1971-12-04 00:00:00	1971-12-04	38000177		0	0	14		0	0	0	180331	0	243670	19059056		
18631	404	40213160	1961-02-21	1961-02-21 00:00:00	1961-02-21	1961-02-21 00:00:00	1961-02-21	581452		0	0	0		0	0	0	26702	0	10	40213160		
16441	1361	19078461	1974-07-02	1974-07-02 00:00:00	1974-07-30	1974-07-30 00:00:00	1974-07-30	38000177		0	0	28		0	0	0	90290	0	310965	19078461		
16464	1365	920300	1995-01-08	1995-01-08 00:00:00	1995-01-15	1995-01-15 00:00:00	1995-01-15	38000177		0	0	7		0	0	0	90464	0	311989	920300		
21281	1750	1127433	2001-05-22	2001-05-22 00:00:00	2001-05-29	2001-05-29 00:00:00	2001-05-29	38000177		0	0	7		0	0	0	117019	0	313782	1127433		
2366	53	40213160	1963-04-24	1963-04-24 00:00:00	1963-04-24	1963-04-24 00:00:00	1963-04-24	581452		0	0	0		0	0	0	3701	0	10	40213160		
48538	1062	40213227	1998-06-28	1998-06-28 00:00:00	1998-06-28	1998-06-28 00:00:00	1998-06-28	581452		0	0	0		0	0	0	69648	0	113	40213227		
118041	2596	40213296	2006-11-04	2006-11-04 00:00:00	2006-11-04	2006-11-04 00:00:00	2006-11-04	581452		0	0	0		0	0	0	171773	0	52	40213296		
184099	4045	40213160	1974-05-25	1974-05-25 00:00:00	1974-05-25	1974-05-25 00:00:00	1974-05-25	581452		0	0	0		0	0	0	269042	0	10	40213160		
20642	449	40213306	1981-06-18	1981-06-18 00:00:00	1981-06-18	1981-06-18 00:00:00	1981-06-18	581452		0	0	0		0	0	0	29961	0	43	40213306		
241681	5306	40213160	1969-06-29	1969-06-29 00:00:00	1969-06-29	1969-06-29 00:00:00	1969-06-29	581452		0	0	0		0	0	0	352928	0	10	40213160		
52587	4373	1127078	1976-11-01	1976-11-01 00:00:00	1976-12-06	1976-12-06 00:00:00	1976-12-06	38000177		0	0	35		0	0	0	290373	0	282464	1127078		
236910	5201	40213306	2000-05-03	2000-05-03 00:00:00	2000-05-03	2000-05-03 00:00:00	2000-05-03	581452		0	0	0		0	0	0	345954	0	43	40213306		
18112	1500	1127433	1973-11-12	1973-11-12 00:00:00	1973-11-26	1973-11-26 00:00:00	1973-11-26	38000177		0	0	14		0	0	0	100109	0	313782	1127433		
166414	3658	40213296	2002-12-15	2002-12-15 00:00:00	2002-12-15	2002-12-15 00:00:00	2002-12-15	581452		0	0	0		0	0	0	243453	0	52	40213296		
183048	4021	40213260	2006-01-18	2006-01-18 00:00:00	2006-01-18	2006-01-18 00:00:00	2006-01-18	581452		0	0	0		0	0	0	267301	0	121	40213260		
219227	4811	40213306	1984-07-17	1984-07-17 00:00:00	1984-07-17	1984-07-17 00:00:00	1984-07-17	581452		0	0	0		0	0	0	320060	0	43	40213306		
51561	4284	19059056	1945-10-02	1945-10-02 00:00:00	1945-10-16	1945-10-16 00:00:00	1945-10-16	38000177		0	0	14		0	0	0	284406	0	243670	19059056		
111793	2456	40213296	1997-05-04	1997-05-04 00:00:00	1997-05-04	1997-05-04 00:00:00	1997-05-04	581452		0	0	0		0	0	0	162763	0	52	40213296		
63815	5301	40236824	1940-09-01	1940-09-01 00:00:00	1940-09-15	1940-09-15 00:00:00	1940-09-15	38000177		0	0	14		0	0	0	352704	0	1094107	40236824		
235125	5165	40213227	2005-12-23	2005-12-23 00:00:00	2005-12-23	2005-12-23 00:00:00	2005-12-23	581452		0	0	0		0	0	0	343353	0	113	40213227		
55009	1205	40213227	2011-09-08	2011-09-08 00:00:00	2011-09-08	2011-09-08 00:00:00	2011-09-08	581452		0	0	0		0	0	0	79178	0	113	40213227		
66996	1466	40213160	1968-06-11	1968-06-11 00:00:00	1968-06-11	1968-06-11 00:00:00	1968-06-11	581452		0	0	0		0	0	0	97654	0	10	40213160		
24212	1990	1127433	2014-07-06	2014-07-06 00:00:00	2014-07-20	2014-07-20 00:00:00	2014-07-20	38000177		0	0	14		0	0	0	132488	0	313782	1127433		
34742	2868	1332419	2002-10-16	2002-10-16 00:00:00	2002-10-16	2002-10-16 00:00:00	\N	38000177		0	0	0		0	0	0	190783	0	197361	1332419		
169248	3721	40213296	2005-02-25	2005-02-25 00:00:00	2005-02-25	2005-02-25 00:00:00	2005-02-25	581452		0	0	0		0	0	0	247404	0	52	40213296		
41362	3430	40220960	2011-10-08	2011-10-08 00:00:00	2011-10-08	2011-10-08 00:00:00	2011-10-08	38000177		0	0	0		0	0	0	227336	0	1804799	40220960		
57854	4807	19133905	1987-03-29	1987-03-29 00:00:00	1987-04-11	1987-04-11 00:00:00	1987-04-11	38000177		0	0	13		0	0	0	319857	0	834102	19133905		
52511	1148	40213227	2008-09-06	2008-09-06 00:00:00	2008-09-06	2008-09-06 00:00:00	2008-09-06	581452		0	0	0		0	0	0	75897	0	113	40213227		
57924	4812	19059056	1972-03-08	1972-03-08 00:00:00	1972-06-06	1972-06-06 00:00:00	1972-06-06	38000177		0	0	90		0	0	0	320162	0	243670	19059056		
211326	4634	40213160	1963-02-14	1963-02-14 00:00:00	1963-02-14	1963-02-14 00:00:00	1963-02-14	581452		0	0	0		0	0	0	308884	0	10	40213160		
115638	2541	40213160	1976-06-07	1976-06-07 00:00:00	1976-06-07	1976-06-07 00:00:00	1976-06-07	581452		0	0	0		0	0	0	168066	0	10	40213160		
486	11	40213227	1995-08-01	1995-08-01 00:00:00	1995-08-01	1995-08-01 00:00:00	1995-08-01	581452		0	0	0		0	0	0	938	0	113	40213227		
82560	1804	40213227	1996-12-02	1996-12-02 00:00:00	1996-12-02	1996-12-02 00:00:00	1996-12-02	581452		0	0	0		0	0	0	120883	0	113	40213227		
33214	2752	19006318	1952-06-10	1952-06-10 00:00:00	1952-06-24	1952-06-24 00:00:00	1952-06-24	38000177		0	0	14		0	0	0	182106	0	105078	19006318		
180969	3976	40213306	1985-11-07	1985-11-07 00:00:00	1985-11-07	1985-11-07 00:00:00	1985-11-07	581452		0	0	0		0	0	0	264395	0	43	40213306		
48071	3986	1124300	1996-06-07	1996-06-07 00:00:00	1996-06-07	1996-06-07 00:00:00	\N	38000177		0	0	0		0	0	0	264998	0	00781178901	45011828		
48136	3989	1127433	1978-04-09	1978-04-09 00:00:00	1978-04-23	1978-04-23 00:00:00	1978-04-23	38000177		0	0	14		0	0	0	265159	0	313782	1127433		
22092	480	40213227	2009-05-20	2009-05-20 00:00:00	2009-05-20	2009-05-20 00:00:00	2009-05-20	581452		0	0	0		0	0	0	32122	0	113	40213227		
59836	4975	1118084	2004-01-14	2004-01-14 00:00:00	2004-01-14	2004-01-14 00:00:00	\N	38000177		0	0	0		0	0	0	330857	0	00025152531	44923712		
59910	4979	1713671	1976-09-27	1976-09-27 00:00:00	1976-10-11	1976-10-11 00:00:00	1976-10-11	38000177		0	0	14		0	0	0	331290	0	562251	1713671		
67423	1475	40213227	2006-02-23	2006-02-23 00:00:00	2006-02-23	2006-02-23 00:00:00	2006-02-23	581452		0	0	0		0	0	0	98296	0	113	40213227		
25440	2090	1127433	2004-09-07	2004-09-07 00:00:00	2004-12-06	2004-12-06 00:00:00	2004-12-06	38000177		0	0	90		0	0	0	139374	0	313782	1127433		
124387	2736	40213296	2013-05-22	2013-05-22 00:00:00	2013-05-22	2013-05-22 00:00:00	2013-05-22	581452		0	0	0		0	0	0	181139	0	52	40213296		
211827	4644	40213296	2004-07-15	2004-07-15 00:00:00	2004-07-15	2004-07-15 00:00:00	2004-07-15	581452		0	0	0		0	0	0	309636	0	52	40213296		
19095	1577	19078461	1991-01-16	1991-01-16 00:00:00	1991-03-17	1991-03-17 00:00:00	1991-03-17	38000177		0	0	60		0	0	0	105930	0	310965	19078461		
2798	225	1127433	1981-05-04	1981-05-04 00:00:00	1981-06-08	1981-06-08 00:00:00	1981-06-08	38000177		0	0	35		0	0	0	15144	0	313782	1127433		
31980	697	40213296	2007-01-03	2007-01-03 00:00:00	2007-01-03	2007-01-03 00:00:00	2007-01-03	581452		0	0	0		0	0	0	46160	0	52	40213296		
149241	3283	40213227	2009-09-25	2009-09-25 00:00:00	2009-09-25	2009-09-25 00:00:00	2009-09-25	581452		0	0	0		0	0	0	218120	0	113	40213227		
209530	4595	40213160	1963-03-21	1963-03-21 00:00:00	1963-03-21	1963-03-21 00:00:00	1963-03-21	581452		0	0	0		0	0	0	306191	0	10	40213160		
146994	3232	40213306	1986-02-24	1986-02-24 00:00:00	1986-02-24	1986-02-24 00:00:00	1986-02-24	581452		0	0	0		0	0	0	214870	0	43	40213306		
102837	2256	40213251	1984-07-25	1984-07-25 00:00:00	1984-07-25	1984-07-25 00:00:00	1984-07-25	581452		0	0	0		0	0	0	149924	0	21	40213251		
59503	4945	19133905	1994-11-08	1994-11-08 00:00:00	1994-11-18	1994-11-18 00:00:00	1994-11-18	38000177		0	0	10		0	0	0	328727	0	834102	19133905		
57311	4756	1713671	1973-06-23	1973-06-23 00:00:00	1973-07-14	1973-07-14 00:00:00	1973-07-14	38000177		0	0	21		0	0	0	316866	0	562251	1713671		
43804	3628	19075601	2002-04-13	2002-04-13 00:00:00	2006-08-19	2006-08-19 00:00:00	2006-08-19	38000177		0	0	1589		0	0	0	241325	0	309362	19075601		
54296	4513	1115171	2004-08-02	2004-08-02 00:00:00	2004-10-01	2004-10-01 00:00:00	2004-10-01	38000177		0	0	60		0	0	0	300588	0	849574	1115171		
117711	2588	40213227	2015-09-06	2015-09-06 00:00:00	2015-09-06	2015-09-06 00:00:00	2015-09-06	581452		0	0	0		0	0	0	171283	0	113	40213227		
51741	4299	1127433	1978-03-18	1978-03-18 00:00:00	1978-04-01	1978-04-01 00:00:00	1978-04-01	38000177		0	0	14		0	0	0	285254	0	313782	1127433		
89664	1967	40213160	1956-06-21	1956-06-21 00:00:00	1956-06-21	1956-06-21 00:00:00	1956-06-21	581452		0	0	0		0	0	0	130771	0	10	40213160		
13911	1162	1127433	1994-07-27	1994-07-27 00:00:00	1994-08-10	1994-08-10 00:00:00	1994-08-10	38000177		0	0	14		0	0	0	76715	0	313782	1127433		
98806	2164	40213160	1977-09-09	1977-09-09 00:00:00	1977-09-09	1977-09-09 00:00:00	1977-09-09	581452		0	0	0		0	0	0	144131	0	10	40213160		
207178	4546	40213296	2012-01-06	2012-01-06 00:00:00	2012-01-06	2012-01-06 00:00:00	2012-01-06	581452		0	0	0		0	0	0	302779	0	52	40213296		
7674	644	19128022	1993-09-27	1993-09-27 00:00:00	1994-09-22	1994-09-22 00:00:00	1994-09-22	38000177		0	0	360		0	0	0	42624	0	749785	19128022		
19498	1606	19059056	1953-03-17	1953-03-17 00:00:00	1953-03-31	1953-03-31 00:00:00	1953-03-31	38000177		0	0	14		0	0	0	107823	0	243670	19059056		
32843	2721	1713671	2015-12-25	2015-12-25 00:00:00	2016-01-08	2016-01-08 00:00:00	2016-01-08	38000177		0	0	14		0	0	0	180350	0	562251	1713671		
18635	404	40213227	2011-11-22	2011-11-22 00:00:00	2011-11-22	2011-11-22 00:00:00	2011-11-22	581452		0	0	0		0	0	0	\N	0	113	40213227		
16442	1361	1127433	1978-10-13	1978-10-13 00:00:00	1978-10-27	1978-10-27 00:00:00	1978-10-27	38000177		0	0	14		0	0	0	90378	0	313782	1127433		
16465	1365	40236824	1995-01-08	1995-01-08 00:00:00	1995-01-15	1995-01-15 00:00:00	1995-01-15	38000177		0	0	7		0	0	0	90464	0	1094107	40236824		
21282	1750	1127078	1974-01-13	1974-01-13 00:00:00	1974-04-13	1974-04-13 00:00:00	1974-04-13	38000177		0	0	90		0	0	0	117003	0	282464	1127078		
77337	1690	40213227	2005-07-13	2005-07-13 00:00:00	2005-07-13	2005-07-13 00:00:00	2005-07-13	581452		0	0	0		0	0	0	113175	0	113	40213227		
48540	1062	40213227	2017-06-25	2017-06-25 00:00:00	2017-06-25	2017-06-25 00:00:00	2017-06-25	581452		0	0	0		0	0	0	69672	0	113	40213227		
118044	2596	40213227	2008-11-08	2008-11-08 00:00:00	2008-11-08	2008-11-08 00:00:00	2008-11-08	581452		0	0	0		0	0	0	171791	0	113	40213227		
184105	4045	40213314	1977-01-22	1977-01-22 00:00:00	1977-01-22	1977-01-22 00:00:00	1977-01-22	581452		0	0	0		0	0	0	269000	0	49	40213314		
20651	449	40213306	1981-07-30	1981-07-30 00:00:00	1981-07-30	1981-07-30 00:00:00	1981-07-30	581452		0	0	0		0	0	0	\N	0	43	40213306		
241683	5306	40213296	2009-01-25	2009-01-25 00:00:00	2009-01-25	2009-01-25 00:00:00	2009-01-25	581452		0	0	0		0	0	0	352979	0	52	40213296		
52588	4373	46233988	1976-11-01	1976-11-01 00:00:00	1976-12-06	1976-12-06 00:00:00	1976-12-06	38000177		0	0	35		0	0	0	290373	0	1652673	46233988		
236912	5201	40213314	1979-05-09	1979-05-09 00:00:00	1979-05-09	1979-05-09 00:00:00	1979-05-09	581452		0	0	0		0	0	0	345969	0	49	40213314		
18113	1500	1127078	1968-03-26	1968-03-26 00:00:00	1968-04-16	1968-04-16 00:00:00	1968-04-16	38000177		0	0	21		0	0	0	100079	0	282464	1127078		
13253	286	40213227	2000-01-29	2000-01-29 00:00:00	2000-01-29	2000-01-29 00:00:00	2000-01-29	581452		0	0	0		0	0	0	19156	0	113	40213227		
183057	4022	40213160	1960-03-26	1960-03-26 00:00:00	1960-03-26	1960-03-26 00:00:00	1960-03-26	581452		0	0	0		0	0	0	267400	0	10	40213160		
219231	4811	40213160	1962-09-25	1962-09-25 00:00:00	1962-09-25	1962-09-25 00:00:00	1962-09-25	581452		0	0	0		0	0	0	320028	0	10	40213160		
51562	4284	19006318	1945-10-02	1945-10-02 00:00:00	1945-10-16	1945-10-16 00:00:00	1945-10-16	38000177		0	0	14		0	0	0	284406	0	105078	19006318		
111797	2456	40213160	1955-07-31	1955-07-31 00:00:00	1955-07-31	1955-07-31 00:00:00	1955-07-31	581452		0	0	0		0	0	0	162813	0	10	40213160		
63816	5301	920300	1940-09-01	1940-09-01 00:00:00	1940-09-08	1940-09-08 00:00:00	1940-09-08	38000177		0	0	7		0	0	0	352704	0	311989	920300		
235126	5165	40213296	2005-12-23	2005-12-23 00:00:00	2005-12-23	2005-12-23 00:00:00	2005-12-23	581452		0	0	0		0	0	0	343353	0	52	40213296		
55010	1205	40213260	2011-09-08	2011-09-08 00:00:00	2011-09-08	2011-09-08 00:00:00	2011-09-08	581452		0	0	0		0	0	0	79178	0	121	40213260		
67000	1466	40213227	2019-03-12	2019-03-12 00:00:00	2019-03-12	2019-03-12 00:00:00	2019-03-12	581452		0	0	0		0	0	0	97619	0	113	40213227		
24213	1990	1118084	2005-05-07	2005-05-07 00:00:00	2005-05-07	2005-05-07 00:00:00	\N	38000177		0	0	0		0	0	0	132521	0	00025152531	44923712		
34743	2868	1124300	2003-10-15	2003-10-15 00:00:00	2003-10-15	2003-10-15 00:00:00	\N	38000177		0	0	0		0	0	0	190783	0	00781178901	45011828		
169250	3721	40213160	1964-07-24	1964-07-24 00:00:00	1964-07-24	1964-07-24 00:00:00	1964-07-24	581452		0	0	0		0	0	0	247338	0	10	40213160		
41363	3431	19059056	1966-06-21	1966-06-21 00:00:00	1966-07-05	1966-07-05 00:00:00	1966-07-05	38000177		0	0	14		0	0	0	227445	0	243670	19059056		
57856	4807	19059056	1971-05-17	1971-05-17 00:00:00	1971-06-14	1971-06-14 00:00:00	1971-06-14	38000177		0	0	28		0	0	0	319808	0	243670	19059056		
52512	1148	40213260	2008-09-06	2008-09-06 00:00:00	2008-09-06	2008-09-06 00:00:00	2008-09-06	581452		0	0	0		0	0	0	75897	0	121	40213260		
57925	4812	19133905	1986-07-26	1986-07-26 00:00:00	1986-08-06	1986-08-06 00:00:00	1986-08-06	38000177		0	0	11		0	0	0	320110	0	834102	19133905		
211330	4634	40213227	2005-07-28	2005-07-28 00:00:00	2005-07-28	2005-07-28 00:00:00	2005-07-28	581452		0	0	0		0	0	0	308875	0	113	40213227		
115639	2541	40213314	1977-09-05	1977-09-05 00:00:00	1977-09-05	1977-09-05 00:00:00	1977-09-05	581452		0	0	0		0	0	0	168040	0	49	40213314		
488	11	40213160	1955-01-11	1955-01-11 00:00:00	1955-01-11	1955-01-11 00:00:00	1955-01-11	581452		0	0	0		0	0	0	911	0	10	40213160		
52108	4333	1127433	1995-12-10	1995-12-10 00:00:00	1995-12-17	1995-12-17 00:00:00	1995-12-17	38000177		0	0	7		0	0	0	287358	0	313782	1127433		
22790	1874	19078461	2006-11-22	2006-11-22 00:00:00	2006-12-13	2006-12-13 00:00:00	2006-12-13	38000177		0	0	21		0	0	0	125105	0	310965	19078461		
192253	4224	40213227	1997-01-15	1997-01-15 00:00:00	1997-01-15	1997-01-15 00:00:00	1997-01-15	581452		0	0	0		0	0	0	280563	0	113	40213227		
48072	3986	19128065	1979-08-01	1979-08-01 00:00:00	1980-07-26	1980-07-26 00:00:00	1980-07-26	38000177		0	0	360		0	0	0	265004	0	749882	19128065		
48137	3989	1127433	1971-01-14	1971-01-14 00:00:00	1971-01-21	1971-01-21 00:00:00	1971-01-21	38000177		0	0	7		0	0	0	265169	0	313782	1127433		
76459	1670	40213160	1964-04-12	1964-04-12 00:00:00	1964-04-12	1964-04-12 00:00:00	1964-04-12	581452		0	0	0		0	0	0	112163	0	10	40213160		
59837	4975	1713671	1985-04-22	1985-04-22 00:00:00	1985-05-06	1985-05-06 00:00:00	1985-05-06	38000177		0	0	14		0	0	0	330881	0	562251	1713671		
59911	4979	19133873	1986-04-05	1986-04-05 00:00:00	1986-04-14	1986-04-14 00:00:00	1986-04-14	38000177		0	0	9		0	0	0	331249	0	834061	19133873		
118856	2615	40213227	1999-02-28	1999-02-28 00:00:00	1999-02-28	1999-02-28 00:00:00	1999-02-28	581452		0	0	0		0	0	0	172914	0	113	40213227		
93473	2051	40213260	2012-11-18	2012-11-18 00:00:00	2012-11-18	2012-11-18 00:00:00	2012-11-18	581452		0	0	0		0	0	0	136404	0	121	40213260		
124389	2736	40213227	1992-07-08	1992-07-08 00:00:00	1992-07-08	1992-07-08 00:00:00	1992-07-08	581452		0	0	0		0	0	0	181146	0	113	40213227		
211831	4644	40213260	2012-08-23	2012-08-23 00:00:00	2012-08-23	2012-08-23 00:00:00	2012-08-23	581452		0	0	0		0	0	0	309638	0	121	40213260		
19096	1577	40162522	1991-01-16	1991-01-16 00:00:00	1991-01-16	1991-01-16 00:00:00	\N	38000177		0	0	0		0	0	0	105930	0	857005	40162522		
2799	225	1127078	1975-06-21	1975-06-21 00:00:00	1975-07-21	1975-07-21 00:00:00	1975-07-21	38000177		0	0	30		0	0	0	15151	0	282464	1127078		
31982	697	40213296	2009-01-07	2009-01-07 00:00:00	2009-01-07	2009-01-07 00:00:00	2009-01-07	581452		0	0	0		0	0	0	46096	0	52	40213296		
149244	3283	40213296	2018-07-20	2018-07-20 00:00:00	2018-07-20	2018-07-20 00:00:00	2018-07-20	581452		0	0	0		0	0	0	218100	0	52	40213296		
209532	4595	40213227	2013-07-19	2013-07-19 00:00:00	2013-07-19	2013-07-19 00:00:00	2013-07-19	581452		0	0	0		0	0	0	306197	0	113	40213227		
42829	3550	19075001	1986-05-12	1986-05-12 00:00:00	1986-05-26	1986-05-26 00:00:00	1986-05-26	38000177		0	0	14		0	0	0	235730	0	309097	19075001		
102854	2256	40213160	1979-04-18	1979-04-18 00:00:00	1979-04-18	1979-04-18 00:00:00	1979-04-18	581452		0	0	0		0	0	0	149922	0	10	40213160		
59504	4945	1713671	1995-07-10	1995-07-10 00:00:00	1995-07-17	1995-07-17 00:00:00	1995-07-17	38000177		0	0	7		0	0	0	328680	0	562251	1713671		
57312	4756	1127433	1985-11-25	1985-11-25 00:00:00	1985-12-16	1985-12-16 00:00:00	1985-12-16	38000177		0	0	21		0	0	0	316781	0	313782	1127433		
43805	3628	19126352	2002-04-13	2002-04-13 00:00:00	2006-08-19	2006-08-19 00:00:00	2006-08-19	38000177		0	0	1589		0	0	0	241325	0	705129	19126352		
54297	4513	46233988	1967-05-23	1967-05-23 00:00:00	1967-06-06	1967-06-06 00:00:00	1967-06-06	38000177		0	0	14		0	0	0	300549	0	1652673	46233988		
117728	2588	40213306	1985-09-22	1985-09-22 00:00:00	1985-09-22	1985-09-22 00:00:00	1985-09-22	581452		0	0	0		0	0	0	\N	0	43	40213306		
51742	4299	1127433	1989-05-23	1989-05-23 00:00:00	1989-06-20	1989-06-20 00:00:00	1989-06-20	38000177		0	0	28		0	0	0	285234	0	313782	1127433		
89673	1967	40213296	1997-10-23	1997-10-23 00:00:00	1997-10-23	1997-10-23 00:00:00	1997-10-23	581452		0	0	0		0	0	0	130841	0	52	40213296		
195856	4304	40213227	2007-11-25	2007-11-25 00:00:00	2007-11-25	2007-11-25 00:00:00	2007-11-25	581452		0	0	0		0	0	0	285476	0	113	40213227		
3985	331	19016749	1997-04-18	1997-04-18 00:00:00	1997-04-18	1997-04-18 00:00:00	1997-04-18	38000177		0	0	0		0	0	0	21811	0	73032	19016749		
207185	4546	40213227	2002-01-25	2002-01-25 00:00:00	2002-01-25	2002-01-25 00:00:00	2002-01-25	581452		0	0	0		0	0	0	302796	0	113	40213227		
7675	644	40236824	1997-11-16	1997-11-16 00:00:00	1997-11-23	1997-11-23 00:00:00	1997-11-23	38000177		0	0	7		0	0	0	42657	0	1094107	40236824		
19499	1606	19006318	1953-03-17	1953-03-17 00:00:00	1953-03-31	1953-03-31 00:00:00	1953-03-31	38000177		0	0	14		0	0	0	107823	0	105078	19006318		
32844	2721	1127433	1971-04-26	1971-04-26 00:00:00	1971-05-10	1971-05-10 00:00:00	1971-05-10	38000177		0	0	14		0	0	0	180327	0	313782	1127433		
18636	404	40213260	2011-11-22	2011-11-22 00:00:00	2011-11-22	2011-11-22 00:00:00	2011-11-22	581452		0	0	0		0	0	0	\N	0	121	40213260		
16443	1361	46233710	1978-10-13	1978-10-13 00:00:00	1978-10-27	1978-10-27 00:00:00	1978-10-27	38000177		0	0	14		0	0	0	90378	0	1650142	46233710		
16467	1365	920334	1993-09-21	1993-09-21 00:00:00	1993-09-28	1993-09-28 00:00:00	1993-09-28	38000177		0	0	7		0	0	0	90529	0	311995	920334		
21283	1750	19078461	1995-04-23	1995-04-23 00:00:00	1995-05-07	1995-05-07 00:00:00	1995-05-07	38000177		0	0	14		0	0	0	117004	0	310965	19078461		
77349	1691	40213227	1995-07-20	1995-07-20 00:00:00	1995-07-20	1995-07-20 00:00:00	1995-07-20	581452		0	0	0		0	0	0	113277	0	113	40213227		
48541	1062	40213260	2017-06-25	2017-06-25 00:00:00	2017-06-25	2017-06-25 00:00:00	2017-06-25	581452		0	0	0		0	0	0	69672	0	121	40213260		
118045	2596	40213296	2008-11-08	2008-11-08 00:00:00	2008-11-08	2008-11-08 00:00:00	2008-11-08	581452		0	0	0		0	0	0	171791	0	52	40213296		
184108	4045	40213314	1977-07-23	1977-07-23 00:00:00	1977-07-23	1977-07-23 00:00:00	1977-07-23	581452		0	0	0		0	0	0	269021	0	49	40213314		
20660	449	40213260	2010-07-29	2010-07-29 00:00:00	2010-07-29	2010-07-29 00:00:00	2010-07-29	581452		0	0	0		0	0	0	29890	0	121	40213260		
241685	5306	40213227	2000-04-02	2000-04-02 00:00:00	2000-04-02	2000-04-02 00:00:00	2000-04-02	581452		0	0	0		0	0	0	352976	0	113	40213227		
52589	4373	46233988	1977-05-30	1977-05-30 00:00:00	1977-06-13	1977-06-13 00:00:00	1977-06-13	38000177		0	0	14		0	0	0	290365	0	1652673	46233988		
236917	5201	40213251	1984-02-15	1984-02-15 00:00:00	1984-02-15	1984-02-15 00:00:00	1984-02-15	581452		0	0	0		0	0	0	345992	0	21	40213251		
18114	1500	1124300	2001-10-25	2001-10-25 00:00:00	2001-10-25	2001-10-25 00:00:00	\N	38000177		0	0	0		0	0	0	100080	0	00781178901	45011828		
13266	287	40213296	2016-09-12	2016-09-12 00:00:00	2016-09-12	2016-09-12 00:00:00	2016-09-12	581452		0	0	0		0	0	0	19206	0	52	40213296		
183061	4022	40213160	1959-10-24	1959-10-24 00:00:00	1959-10-24	1959-10-24 00:00:00	1959-10-24	581452		0	0	0		0	0	0	267399	0	10	40213160		
219233	4811	40213260	2012-04-17	2012-04-17 00:00:00	2012-04-17	2012-04-17 00:00:00	2012-04-17	581452		0	0	0		0	0	0	320021	0	121	40213260		
51563	4284	19059056	1945-04-21	1945-04-21 00:00:00	1945-05-05	1945-05-05 00:00:00	1945-05-05	38000177		0	0	14		0	0	0	284405	0	243670	19059056		
111809	2456	40213160	1956-01-01	1956-01-01 00:00:00	1956-01-01	1956-01-01 00:00:00	1956-01-01	581452		0	0	0		0	0	0	162814	0	10	40213160		
63817	5301	1124300	1953-01-12	1953-01-12 00:00:00	1953-01-12	1953-01-12 00:00:00	\N	38000177		0	0	0		0	0	0	352741	0	00781178901	45011828		
235128	5165	40213160	1968-11-22	1968-11-22 00:00:00	1968-11-22	1968-11-22 00:00:00	1968-11-22	581452		0	0	0		0	0	0	343387	0	10	40213160		
55020	1205	40213160	1960-01-28	1960-01-28 00:00:00	1960-01-28	1960-01-28 00:00:00	1960-01-28	581452		0	0	0		0	0	0	79204	0	10	40213160		
67001	1466	40213260	2019-03-12	2019-03-12 00:00:00	2019-03-12	2019-03-12 00:00:00	2019-03-12	581452		0	0	0		0	0	0	97619	0	121	40213260		
24214	1990	1127433	1970-05-07	1970-05-07 00:00:00	1970-05-14	1970-05-14 00:00:00	1970-05-14	38000177		0	0	7		0	0	0	132535	0	313782	1127433		
34744	2868	1539411	2002-10-16	2002-10-16 00:00:00	2002-10-16	2002-10-16 00:00:00	\N	38000177		0	0	0		0	0	0	190783	0	312961	1539411		
169260	3721	40213160	1964-02-21	1964-02-21 00:00:00	1964-02-21	1964-02-21 00:00:00	1964-02-21	581452		0	0	0		0	0	0	247392	0	10	40213160		
41364	3431	19129655	1966-06-21	1966-06-21 00:00:00	1966-07-05	1966-07-05 00:00:00	1966-07-05	38000177		0	0	14		0	0	0	227445	0	789980	19129655		
57857	4807	19133905	1967-07-12	1967-07-12 00:00:00	1967-07-25	1967-07-25 00:00:00	1967-07-25	38000177		0	0	13		0	0	0	319797	0	834102	19133905		
52515	1148	40213160	1957-09-28	1957-09-28 00:00:00	1957-09-28	1957-09-28 00:00:00	1957-09-28	581452		0	0	0		0	0	0	75924	0	10	40213160		
57926	4812	19059056	1955-03-12	1955-03-12 00:00:00	1955-03-26	1955-03-26 00:00:00	1955-03-26	38000177		0	0	14		0	0	0	320113	0	243670	19059056		
211331	4634	40213296	2005-07-28	2005-07-28 00:00:00	2005-07-28	2005-07-28 00:00:00	2005-07-28	581452		0	0	0		0	0	0	308875	0	52	40213296		
115645	2541	40213306	1999-03-01	1999-03-01 00:00:00	1999-03-01	1999-03-01 00:00:00	1999-03-01	581452		0	0	0		0	0	0	\N	0	43	40213306		
492	11	40213227	2004-02-10	2004-02-10 00:00:00	2004-02-10	2004-02-10 00:00:00	2004-02-10	581452		0	0	0		0	0	0	936	0	113	40213227		
52109	4333	19059056	1980-05-03	1980-05-03 00:00:00	1980-05-17	1980-05-17 00:00:00	1980-05-17	38000177		0	0	14		0	0	0	287411	0	243670	19059056		
22791	1874	1713671	2010-10-28	2010-10-28 00:00:00	2010-11-04	2010-11-04 00:00:00	2010-11-04	38000177		0	0	7		0	0	0	125151	0	562251	1713671		
20934	455	40213227	2001-02-06	2001-02-06 00:00:00	2001-02-06	2001-02-06 00:00:00	2001-02-06	581452		0	0	0		0	0	0	30449	0	113	40213227		
48073	3986	19074679	2011-07-29	2011-07-29 00:00:00	2012-03-16	2012-03-16 00:00:00	2012-03-16	38000177		0	0	231		0	0	0	264964	0	308971	19074679		
58599	4867	19133905	1948-02-09	1948-02-09 00:00:00	1948-02-20	1948-02-20 00:00:00	1948-02-20	38000177		0	0	11		0	0	0	323665	0	834102	19133905		
76461	1670	40213160	1964-09-13	1964-09-13 00:00:00	1964-09-13	1964-09-13 00:00:00	1964-09-13	581452		0	0	0		0	0	0	112181	0	10	40213160		
59838	4975	1127433	1977-08-04	1977-08-04 00:00:00	1977-08-18	1977-08-18 00:00:00	1977-08-18	38000177		0	0	14		0	0	0	330880	0	313782	1127433		
59912	4979	19128022	1997-06-13	1997-06-13 00:00:00	1998-06-08	1998-06-08 00:00:00	1998-06-08	38000177		0	0	360		0	0	0	331258	0	749785	19128022		
130134	2860	40213227	2012-10-26	2012-10-26 00:00:00	2012-10-26	2012-10-26 00:00:00	2012-10-26	581452		0	0	0		0	0	0	190101	0	113	40213227		
93481	2052	40213160	1962-11-12	1962-11-12 00:00:00	1962-11-12	1962-11-12 00:00:00	1962-11-12	581452		0	0	0		0	0	0	136445	0	10	40213160		
124390	2736	40213306	1992-07-08	1992-07-08 00:00:00	1992-07-08	1992-07-08 00:00:00	1992-07-08	581452		0	0	0		0	0	0	181146	0	43	40213306		
211834	4644	40213160	1962-12-13	1962-12-13 00:00:00	1962-12-13	1962-12-13 00:00:00	1962-12-13	581452		0	0	0		0	0	0	309682	0	10	40213160		
19097	1577	19059056	1926-07-19	1926-07-19 00:00:00	1926-08-02	1926-08-02 00:00:00	1926-08-02	38000177		0	0	14		0	0	0	105841	0	243670	19059056		
2800	225	1127433	2016-12-01	2016-12-01 00:00:00	2016-12-22	2016-12-22 00:00:00	2016-12-22	38000177		0	0	21		0	0	0	15146	0	313782	1127433		
208719	4578	40213227	1996-05-05	1996-05-05 00:00:00	1996-05-05	1996-05-05 00:00:00	1996-05-05	581452		0	0	0		0	0	0	304936	0	113	40213227		
149250	3283	40213160	1978-12-22	1978-12-22 00:00:00	1978-12-22	1978-12-22 00:00:00	1978-12-22	581452		0	0	0		0	0	0	218093	0	10	40213160		
209533	4595	40213260	2013-07-19	2013-07-19 00:00:00	2013-07-19	2013-07-19 00:00:00	2013-07-19	581452		0	0	0		0	0	0	306197	0	121	40213260		
42830	3550	1127078	1986-05-12	1986-05-12 00:00:00	1986-05-26	1986-05-26 00:00:00	1986-05-26	38000177		0	0	14		0	0	0	235730	0	282464	1127078		
43676	3621	19059056	1950-01-15	1950-01-15 00:00:00	1950-01-29	1950-01-29 00:00:00	1950-01-29	38000177		0	0	14		0	0	0	240659	0	243670	19059056		
59506	4945	1713671	1997-02-14	1997-02-14 00:00:00	1997-02-21	1997-02-21 00:00:00	1997-02-21	38000177		0	0	7		0	0	0	328681	0	562251	1713671		
57313	4756	1127433	2003-05-26	2003-05-26 00:00:00	2003-06-09	2003-06-09 00:00:00	2003-06-09	38000177		0	0	14		0	0	0	316868	0	313782	1127433		
43806	3628	1332419	2002-04-13	2002-04-13 00:00:00	2002-04-13	2002-04-13 00:00:00	\N	38000177		0	0	0		0	0	0	241325	0	197361	1332419		
54298	4513	19059056	1967-05-23	1967-05-23 00:00:00	1967-06-06	1967-06-06 00:00:00	1967-06-06	38000177		0	0	14		0	0	0	300549	0	243670	19059056		
117730	2588	40213160	1969-03-16	1969-03-16 00:00:00	1969-03-16	1969-03-16 00:00:00	1969-03-16	581452		0	0	0		0	0	0	171257	0	10	40213160		
51743	4299	1115171	1996-10-11	1996-10-11 00:00:00	1996-11-08	1996-11-08 00:00:00	1996-11-08	38000177		0	0	28		0	0	0	285235	0	849574	1115171		
89676	1967	40213227	1997-10-23	1997-10-23 00:00:00	1997-10-23	1997-10-23 00:00:00	1997-10-23	581452		0	0	0		0	0	0	130841	0	113	40213227		
195857	4304	40213296	2007-11-25	2007-11-25 00:00:00	2007-11-25	2007-11-25 00:00:00	2007-11-25	581452		0	0	0		0	0	0	285476	0	52	40213296		
3986	331	42707627	1997-04-18	1997-04-18 00:00:00	1997-04-18	1997-04-18 00:00:00	1997-04-18	38000177		0	0	0		0	0	0	21811	0	1234995	42707627		
207187	4546	40213160	1968-10-04	1968-10-04 00:00:00	1968-10-04	1968-10-04 00:00:00	1968-10-04	581452		0	0	0		0	0	0	302802	0	10	40213160		
7676	644	920300	1997-11-16	1997-11-16 00:00:00	1997-11-23	1997-11-23 00:00:00	1997-11-23	38000177		0	0	7		0	0	0	42657	0	311989	920300		
19500	1606	1127433	2018-02-10	2018-02-10 00:00:00	2018-02-17	2018-02-17 00:00:00	2018-02-17	38000177		0	0	7		0	0	0	107862	0	313782	1127433		
32845	2721	1118084	2010-07-23	2010-07-23 00:00:00	2010-07-23	2010-07-23 00:00:00	\N	38000177		0	0	0		0	0	0	180322	0	00025152531	44923712		
18637	404	40213160	1960-11-22	1960-11-22 00:00:00	1960-11-22	1960-11-22 00:00:00	1960-11-22	581452		0	0	0		0	0	0	26596	0	10	40213160		
16444	1361	19059056	1952-07-18	1952-07-18 00:00:00	1952-08-01	1952-08-01 00:00:00	1952-08-01	38000177		0	0	14		0	0	0	90357	0	243670	19059056		
16468	1365	920300	1993-11-13	1993-11-13 00:00:00	1993-11-20	1993-11-20 00:00:00	1993-11-20	38000177		0	0	7		0	0	0	\N	0	311989	920300		
21284	1750	19078461	2010-10-29	2010-10-29 00:00:00	2010-11-19	2010-11-19 00:00:00	2010-11-19	38000177		0	0	21		0	0	0	117016	0	310965	19078461		
77366	1691	40213227	2015-08-06	2015-08-06 00:00:00	2015-08-06	2015-08-06 00:00:00	2015-08-06	581452		0	0	0		0	0	0	113281	0	113	40213227		
48544	1062	40213160	1971-04-25	1971-04-25 00:00:00	1971-04-25	1971-04-25 00:00:00	1971-04-25	581452		0	0	0		0	0	0	69691	0	10	40213160		
118048	2596	40213260	2016-10-29	2016-10-29 00:00:00	2016-10-29	2016-10-29 00:00:00	2016-10-29	581452		0	0	0		0	0	0	171775	0	121	40213260		
184114	4045	40213160	1978-09-30	1978-09-30 00:00:00	1978-09-30	1978-09-30 00:00:00	1978-09-30	581452		0	0	0		0	0	0	269022	0	10	40213160		
20662	449	40213160	1964-10-08	1964-10-08 00:00:00	1964-10-08	1964-10-08 00:00:00	1964-10-08	581452		0	0	0		0	0	0	29885	0	10	40213160		
14147	1185	1127433	1962-07-16	1962-07-16 00:00:00	1962-07-30	1962-07-30 00:00:00	1962-07-30	38000177		0	0	14		0	0	0	78089	0	313782	1127433		
52590	4373	19019979	1977-05-30	1977-05-30 00:00:00	1977-06-13	1977-06-13 00:00:00	1977-06-13	38000177		0	0	14		0	0	0	290365	0	198405	19019979		
236921	5201	40213296	2018-04-11	2018-04-11 00:00:00	2018-04-11	2018-04-11 00:00:00	2018-04-11	581452		0	0	0		0	0	0	345950	0	52	40213296		
18115	1500	1713671	1994-08-16	1994-08-16 00:00:00	1994-08-23	1994-08-23 00:00:00	1994-08-23	38000177		0	0	7		0	0	0	100091	0	562251	1713671		
13268	287	40213160	1976-10-18	1976-10-18 00:00:00	1976-10-18	1976-10-18 00:00:00	1976-10-18	581452		0	0	0		0	0	0	19169	0	10	40213160		
183063	4022	40213160	1964-06-27	1964-06-27 00:00:00	1964-06-27	1964-06-27 00:00:00	1964-06-27	581452		0	0	0		0	0	0	267378	0	10	40213160		
219234	4812	40213160	1955-03-23	1955-03-23 00:00:00	1955-03-23	1955-03-23 00:00:00	1955-03-23	581452		0	0	0		0	0	0	320095	0	10	40213160		
51564	4284	19006318	1945-04-21	1945-04-21 00:00:00	1945-05-05	1945-05-05 00:00:00	1945-05-05	38000177		0	0	14		0	0	0	284405	0	105078	19006318		
23708	515	40213201	2008-01-26	2008-01-26 00:00:00	2008-01-26	2008-01-26 00:00:00	2008-01-26	581452		0	0	0		0	0	0	34398	0	33	40213201		
63818	5301	1127433	1929-09-11	1929-09-11 00:00:00	1929-09-18	1929-09-18 00:00:00	1929-09-18	38000177		0	0	7		0	0	0	352659	0	313782	1127433		
235134	5165	40213260	2014-12-19	2014-12-19 00:00:00	2014-12-19	2014-12-19 00:00:00	2014-12-19	581452		0	0	0		0	0	0	343315	0	121	40213260		
55022	1206	40213160	1964-07-20	1964-07-20 00:00:00	1964-07-20	1964-07-20 00:00:00	1964-07-20	581452		0	0	0		0	0	0	79256	0	10	40213160		
67004	1466	40213227	2001-11-13	2001-11-13 00:00:00	2001-11-13	2001-11-13 00:00:00	2001-11-13	581452		0	0	0		0	0	0	97632	0	113	40213227		
24215	1990	1127433	1978-06-23	1978-06-23 00:00:00	1978-07-14	1978-07-14 00:00:00	1978-07-14	38000177		0	0	21		0	0	0	132503	0	313782	1127433		
34745	2868	19128065	1981-09-10	1981-09-10 00:00:00	1982-09-05	1982-09-05 00:00:00	1982-09-05	38000177		0	0	360		0	0	0	190813	0	749882	19128065		
169262	3721	40213260	2014-05-16	2014-05-16 00:00:00	2014-05-16	2014-05-16 00:00:00	2014-05-16	581452		0	0	0		0	0	0	247360	0	121	40213260		
41365	3431	19133873	1967-10-15	1967-10-15 00:00:00	1967-10-28	1967-10-28 00:00:00	1967-10-28	38000177		0	0	13		0	0	0	227446	0	834061	19133873		
57859	4807	1713671	1976-03-26	1976-03-26 00:00:00	1976-04-09	1976-04-09 00:00:00	1976-04-09	38000177		0	0	14		0	0	0	319845	0	562251	1713671		
134543	2953	40213227	2014-02-21	2014-02-21 00:00:00	2014-02-21	2014-02-21 00:00:00	2014-02-21	581452		0	0	0		0	0	0	197159	0	113	40213227		
57927	4812	19006318	1955-03-12	1955-03-12 00:00:00	1955-03-26	1955-03-26 00:00:00	1955-03-26	38000177		0	0	14		0	0	0	320113	0	105078	19006318		
211336	4634	40213296	2003-07-24	2003-07-24 00:00:00	2003-07-24	2003-07-24 00:00:00	2003-07-24	581452		0	0	0		0	0	0	308835	0	52	40213296		
115656	2541	40213314	1977-03-07	1977-03-07 00:00:00	1977-03-07	1977-03-07 00:00:00	1977-03-07	581452		0	0	0		0	0	0	168018	0	49	40213314		
498	11	40213227	2014-04-08	2014-04-08 00:00:00	2014-04-08	2014-04-08 00:00:00	2014-04-08	581452		0	0	0		0	0	0	941	0	113	40213227		
52110	4333	1127433	1968-04-15	1968-04-15 00:00:00	1968-05-06	1968-05-06 00:00:00	1968-05-06	38000177		0	0	21		0	0	0	287410	0	313782	1127433		
22792	1874	19078461	1987-04-15	1987-04-15 00:00:00	1987-05-06	1987-05-06 00:00:00	1987-05-06	38000177		0	0	21		0	0	0	125104	0	310965	19078461		
20936	455	40213201	2016-05-03	2016-05-03 00:00:00	2016-05-03	2016-05-03 00:00:00	2016-05-03	581452		0	0	0		0	0	0	30452	0	33	40213201		
48074	3986	1713671	1990-08-01	1990-08-01 00:00:00	1990-08-22	1990-08-22 00:00:00	1990-08-22	38000177		0	0	21		0	0	0	265013	0	562251	1713671		
58600	4867	19078461	1979-09-08	1979-09-08 00:00:00	1979-11-07	1979-11-07 00:00:00	1979-11-07	38000177		0	0	60		0	0	0	323684	0	310965	19078461		
76465	1670	40213306	1986-11-30	1986-11-30 00:00:00	1986-11-30	1986-11-30 00:00:00	1986-11-30	581452		0	0	0		0	0	0	112168	0	43	40213306		
59839	4975	19133905	2011-07-03	2011-07-03 00:00:00	2011-07-15	2011-07-15 00:00:00	2011-07-15	38000177		0	0	12		0	0	0	330908	0	834102	19133905		
59913	4979	19019979	1978-03-15	1978-03-15 00:00:00	1978-06-13	1978-06-13 00:00:00	1978-06-13	38000177		0	0	90		0	0	0	331243	0	198405	19019979		
130148	2861	40213160	1968-04-15	1968-04-15 00:00:00	1968-04-15	1968-04-15 00:00:00	1968-04-15	581452		0	0	0		0	0	0	190249	0	10	40213160		
93482	2052	40213160	1967-02-13	1967-02-13 00:00:00	1967-02-13	1967-02-13 00:00:00	1967-02-13	581452		0	0	0		0	0	0	136420	0	10	40213160		
191240	4202	40213306	1995-02-18	1995-02-18 00:00:00	1995-02-18	1995-02-18 00:00:00	1995-02-18	581452		0	0	0		0	0	0	\N	0	43	40213306		
211837	4644	40213227	1993-11-25	1993-11-25 00:00:00	1993-11-25	1993-11-25 00:00:00	1993-11-25	581452		0	0	0		0	0	0	309633	0	113	40213227		
19098	1577	1713671	1954-09-17	1954-09-17 00:00:00	1954-09-24	1954-09-24 00:00:00	1954-09-24	38000177		0	0	7		0	0	0	105835	0	562251	1713671		
103972	2280	40213296	2013-01-30	2013-01-30 00:00:00	2013-01-30	2013-01-30 00:00:00	2013-01-30	581452		0	0	0		0	0	0	151639	0	52	40213296		
208725	4578	40213160	1965-01-31	1965-01-31 00:00:00	1965-01-31	1965-01-31 00:00:00	1965-01-31	581452		0	0	0		0	0	0	304969	0	10	40213160		
149251	3283	40213314	1978-12-22	1978-12-22 00:00:00	1978-12-22	1978-12-22 00:00:00	1978-12-22	581452		0	0	0		0	0	0	218093	0	49	40213314		
209536	4595	40213306	1985-04-18	1985-04-18 00:00:00	1985-04-18	1985-04-18 00:00:00	1985-04-18	581452		0	0	0		0	0	0	306167	0	43	40213306		
42831	3550	19019979	1994-10-11	1994-10-11 00:00:00	1994-11-08	1994-11-08 00:00:00	1994-11-08	38000177		0	0	28		0	0	0	235756	0	198405	19019979		
43677	3621	1127433	1967-07-03	1967-07-03 00:00:00	1967-07-10	1967-07-10 00:00:00	1967-07-10	38000177		0	0	7		0	0	0	240579	0	313782	1127433		
59536	4949	1118084	2013-02-28	2013-02-28 00:00:00	2013-02-28	2013-02-28 00:00:00	\N	38000177		0	0	0		0	0	0	329008	0	00025152531	44923712		
57314	4756	1713671	1987-10-02	1987-10-02 00:00:00	1987-10-09	1987-10-09 00:00:00	1987-10-09	38000177		0	0	7		0	0	0	316829	0	562251	1713671		
43807	3628	1539411	2002-04-13	2002-04-13 00:00:00	2002-04-13	2002-04-13 00:00:00	\N	38000177		0	0	0		0	0	0	241325	0	312961	1539411		
54299	4513	40229134	1966-03-01	1966-03-01 00:00:00	1966-03-15	1966-03-15 00:00:00	1966-03-15	38000177		0	0	14		0	0	0	300579	0	1043400	40229134		
117733	2588	40213160	1965-05-09	1965-05-09 00:00:00	1965-05-09	1965-05-09 00:00:00	1965-05-09	581452		0	0	0		0	0	0	171255	0	10	40213160		
51744	4299	1124300	2013-08-20	2013-08-20 00:00:00	2013-08-20	2013-08-20 00:00:00	\N	38000177		0	0	0		0	0	0	285247	0	00781178901	45011828		
100959	2213	40213160	1966-06-29	1966-06-29 00:00:00	1966-06-29	1966-06-29 00:00:00	1966-06-29	581452		0	0	0		0	0	0	147396	0	10	40213160		
62291	5185	1127433	1956-07-09	1956-07-09 00:00:00	1956-07-23	1956-07-23 00:00:00	1956-07-23	38000177		0	0	14		0	0	0	344601	0	313782	1127433		
3987	331	46275444	1997-04-18	1997-04-18 00:00:00	1997-04-18	1997-04-18 00:00:00	1997-04-18	38000177		0	0	0		0	0	0	21811	0	1659149	46275444		
207190	4546	40213260	2018-06-29	2018-06-29 00:00:00	2018-06-29	2018-06-29 00:00:00	2018-06-29	581452		0	0	0		0	0	0	302799	0	121	40213260		
7677	644	1127433	2015-10-11	2015-10-11 00:00:00	2015-10-25	2015-10-25 00:00:00	2015-10-25	38000177		0	0	14		0	0	0	42615	0	313782	1127433		
19501	1606	1127433	2012-08-14	2012-08-14 00:00:00	2012-08-28	2012-08-28 00:00:00	2012-08-28	38000177		0	0	14		0	0	0	107822	0	313782	1127433		
32846	2721	1127433	1990-06-10	1990-06-10 00:00:00	1990-06-17	1990-06-17 00:00:00	1990-06-17	38000177		0	0	7		0	0	0	180329	0	313782	1127433		
18638	404	40213306	1983-01-04	1983-01-04 00:00:00	1983-01-04	1983-01-04 00:00:00	1983-01-04	581452		0	0	0		0	0	0	26651	0	43	40213306		
16445	1361	19006318	1952-07-18	1952-07-18 00:00:00	1952-08-01	1952-08-01 00:00:00	1952-08-01	38000177		0	0	14		0	0	0	90357	0	105078	19006318		
16469	1365	40236824	1993-11-13	1993-11-13 00:00:00	1993-11-27	1993-11-27 00:00:00	1993-11-27	38000177		0	0	14		0	0	0	\N	0	1094107	40236824		
21285	1751	1127078	1986-05-28	1986-05-28 00:00:00	1986-07-02	1986-07-02 00:00:00	1986-07-02	38000177		0	0	35		0	0	0	117077	0	282464	1127078		
48569	4022	19059056	1968-02-01	1968-02-01 00:00:00	1968-03-07	1968-03-07 00:00:00	1968-03-07	38000177		0	0	35		0	0	0	267385	0	243670	19059056		
48548	1062	40213306	1989-06-18	1989-06-18 00:00:00	1989-06-18	1989-06-18 00:00:00	1989-06-18	581452		0	0	0		0	0	0	69694	0	43	40213306		
54047	4491	1127433	1975-05-02	1975-05-02 00:00:00	1975-05-23	1975-05-23 00:00:00	1975-05-23	38000177		0	0	21		0	0	0	299024	0	313782	1127433		
237176	5207	40213227	2007-08-22	2007-08-22 00:00:00	2007-08-22	2007-08-22 00:00:00	2007-08-22	581452		0	0	0		0	0	0	346396	0	113	40213227		
20665	449	40213160	1960-07-07	1960-07-07 00:00:00	1960-07-07	1960-07-07 00:00:00	1960-07-07	581452		0	0	0		0	0	0	29955	0	10	40213160		
14148	1185	40165015	2008-02-11	2008-02-11 00:00:00	2008-02-11	2008-02-11 00:00:00	\N	38000177		0	0	0		0	0	0	78150	0	861467	40165015		
52591	4373	40232448	1976-07-18	1976-07-18 00:00:00	1976-07-18	1976-07-18 00:00:00	\N	38000177		0	0	0		0	0	0	290341	0	1049630	40232448		
236926	5201	40213160	1983-02-09	1983-02-09 00:00:00	1983-02-09	1983-02-09 00:00:00	1983-02-09	581452		0	0	0		0	0	0	345972	0	10	40213160		
18116	1500	1713671	1985-02-20	1985-02-20 00:00:00	1985-02-27	1985-02-27 00:00:00	1985-02-27	38000177		0	0	7		0	0	0	100128	0	562251	1713671		
13273	287	40213227	1998-04-13	1998-04-13 00:00:00	1998-04-13	1998-04-13 00:00:00	1998-04-13	581452		0	0	0		0	0	0	19175	0	113	40213227		
183065	4022	40213227	1992-09-26	1992-09-26 00:00:00	1992-09-26	1992-09-26 00:00:00	1992-09-26	581452		0	0	0		0	0	0	267373	0	113	40213227		
219235	4812	40213160	1955-06-22	1955-06-22 00:00:00	1955-06-22	1955-06-22 00:00:00	1955-06-22	581452		0	0	0		0	0	0	320115	0	10	40213160		
51598	4288	1127078	1953-06-29	1953-06-29 00:00:00	1953-07-13	1953-07-13 00:00:00	1953-07-13	38000177		0	0	14		0	0	0	284654	0	282464	1127078		
23726	515	40213227	1992-10-31	1992-10-31 00:00:00	1992-10-31	1992-10-31 00:00:00	1992-10-31	581452		0	0	0		0	0	0	34363	0	113	40213227		
63819	5301	40236824	1940-11-24	1940-11-24 00:00:00	1940-12-01	1940-12-01 00:00:00	1940-12-01	38000177		0	0	7		0	0	0	352727	0	1094107	40236824		
235135	5165	40213227	2014-12-19	2014-12-19 00:00:00	2014-12-19	2014-12-19 00:00:00	2014-12-19	581452		0	0	0		0	0	0	343315	0	113	40213227		
55034	1206	40213296	2004-02-16	2004-02-16 00:00:00	2004-02-16	2004-02-16 00:00:00	2004-02-16	581452		0	0	0		0	0	0	79267	0	52	40213296		
67013	1466	40213227	2009-11-24	2009-11-24 00:00:00	2009-11-24	2009-11-24 00:00:00	2009-11-24	581452		0	0	0		0	0	0	97633	0	113	40213227		
24216	1990	40231925	1978-06-23	1978-06-23 00:00:00	1978-06-23	1978-06-23 00:00:00	\N	38000177		0	0	0		0	0	0	132503	0	1049221	40231925		
34746	2868	19059056	1969-02-05	1969-02-05 00:00:00	1969-04-06	1969-04-06 00:00:00	1969-04-06	38000177		0	0	60		0	0	0	190817	0	243670	19059056		
169264	3721	40213260	2015-05-22	2015-05-22 00:00:00	2015-05-22	2015-05-22 00:00:00	2015-05-22	581452		0	0	0		0	0	0	247383	0	121	40213260		
41366	3431	1154615	1964-10-16	1964-10-16 00:00:00	1964-10-16	1964-10-16 00:00:00	\N	38000177		0	0	0		0	0	0	227454	0	745679	1154615		
57860	4807	1127433	1974-03-15	1974-03-15 00:00:00	1974-03-22	1974-03-22 00:00:00	1974-03-22	38000177		0	0	7		0	0	0	319856	0	313782	1127433		
134545	2953	40213160	1983-04-22	1983-04-22 00:00:00	1983-04-22	1983-04-22 00:00:00	1983-04-22	581452		0	0	0		0	0	0	197139	0	10	40213160		
57928	4812	19078461	1981-12-16	1981-12-16 00:00:00	1982-01-06	1982-01-06 00:00:00	1982-01-06	38000177		0	0	21		0	0	0	320163	0	310965	19078461		
211347	4634	40213160	1963-04-18	1963-04-18 00:00:00	1963-04-18	1963-04-18 00:00:00	1963-04-18	581452		0	0	0		0	0	0	308843	0	10	40213160		
115658	2541	40213296	2015-10-19	2015-10-19 00:00:00	2015-10-19	2015-10-19 00:00:00	2015-10-19	581452		0	0	0		0	0	0	168031	0	52	40213296		
507	11	40213160	1955-11-01	1955-11-01 00:00:00	1955-11-01	1955-11-01 00:00:00	1955-11-01	581452		0	0	0		0	0	0	958	0	10	40213160		
52111	4333	19078461	2011-12-01	2011-12-01 00:00:00	2011-12-15	2011-12-15 00:00:00	2011-12-15	38000177		0	0	14		0	0	0	287413	0	310965	19078461		
22793	1874	1713671	1978-12-20	1978-12-20 00:00:00	1979-01-17	1979-01-17 00:00:00	1979-01-17	38000177		0	0	28		0	0	0	125132	0	562251	1713671		
32223	703	40213227	2000-12-29	2000-12-29 00:00:00	2000-12-29	2000-12-29 00:00:00	2000-12-29	581452		0	0	0		0	0	0	46486	0	113	40213227		
48075	3986	40229134	2005-10-17	2005-10-17 00:00:00	2005-10-31	2005-10-31 00:00:00	2005-10-31	38000177		0	0	14		0	0	0	265015	0	1043400	40229134		
58601	4867	1713671	2011-10-17	2011-10-17 00:00:00	2011-10-31	2011-10-31 00:00:00	2011-10-31	38000177		0	0	14		0	0	0	323672	0	562251	1713671		
76469	1670	40213227	2015-02-01	2015-02-01 00:00:00	2015-02-01	2015-02-01 00:00:00	2015-02-01	581452		0	0	0		0	0	0	112171	0	113	40213227		
59840	4975	19133873	1973-10-19	1973-10-19 00:00:00	1973-10-30	1973-10-30 00:00:00	1973-10-30	38000177		0	0	11		0	0	0	330904	0	834061	19133873		
59914	4979	1127078	1986-02-01	1986-02-01 00:00:00	1986-02-15	1986-02-15 00:00:00	1986-02-15	38000177		0	0	14		0	0	0	331294	0	282464	1127078		
130153	2861	40213160	1964-03-16	1964-03-16 00:00:00	1964-03-16	1964-03-16 00:00:00	1964-03-16	581452		0	0	0		0	0	0	190192	0	10	40213160		
93494	2052	40213306	1984-05-07	1984-05-07 00:00:00	1984-05-07	1984-05-07 00:00:00	1984-05-07	581452		0	0	0		0	0	0	136432	0	43	40213306		
191248	4202	40213296	2013-05-25	2013-05-25 00:00:00	2013-05-25	2013-05-25 00:00:00	2013-05-25	581452		0	0	0		0	0	0	278977	0	52	40213296		
211841	4644	40213227	2013-08-29	2013-08-29 00:00:00	2013-08-29	2013-08-29 00:00:00	2013-08-29	581452		0	0	0		0	0	0	309664	0	113	40213227		
19099	1577	1124300	1962-03-29	1962-03-29 00:00:00	1962-03-29	1962-03-29 00:00:00	\N	38000177		0	0	0		0	0	0	105867	0	00781178901	45011828		
94562	2075	40213227	2007-02-20	2007-02-20 00:00:00	2007-02-20	2007-02-20 00:00:00	2007-02-20	581452		0	0	0		0	0	0	138128	0	113	40213227		
208728	4578	40213296	2006-06-04	2006-06-04 00:00:00	2006-06-04	2006-06-04 00:00:00	2006-06-04	581452		0	0	0		0	0	0	304985	0	52	40213296		
149254	3283	40213160	1983-06-24	1983-06-24 00:00:00	1983-06-24	1983-06-24 00:00:00	1983-06-24	581452		0	0	0		0	0	0	218134	0	10	40213160		
209544	4595	40213160	1967-06-23	1967-06-23 00:00:00	1967-06-23	1967-06-23 00:00:00	1967-06-23	581452		0	0	0		0	0	0	306163	0	10	40213160		
42832	3550	19133905	2019-05-20	2019-05-20 00:00:00	2019-05-29	2019-05-29 00:00:00	2019-05-29	38000177		0	0	9		0	0	0	235729	0	834102	19133905		
43678	3621	19059056	1927-05-30	1927-05-30 00:00:00	1927-06-13	1927-06-13 00:00:00	1927-06-13	38000177		0	0	14		0	0	0	240622	0	243670	19059056		
59537	4949	1115171	1994-10-26	1994-10-26 00:00:00	1994-11-16	1994-11-16 00:00:00	1994-11-16	38000177		0	0	21		0	0	0	329048	0	849574	1115171		
57315	4756	1127433	1949-05-12	1949-05-12 00:00:00	1949-05-26	1949-05-26 00:00:00	1949-05-26	38000177		0	0	14		0	0	0	316827	0	313782	1127433		
43808	3628	1127433	1965-10-25	1965-10-25 00:00:00	1965-11-01	1965-11-01 00:00:00	1965-11-01	38000177		0	0	7		0	0	0	241361	0	313782	1127433		
54300	4514	19019979	1979-04-16	1979-04-16 00:00:00	1979-07-15	1979-07-15 00:00:00	1979-07-15	38000177		0	0	90		0	0	0	300590	0	198405	19019979		
117736	2588	40213160	1965-02-07	1965-02-07 00:00:00	1965-02-07	1965-02-07 00:00:00	1965-02-07	581452		0	0	0		0	0	0	171247	0	10	40213160		
51745	4299	1127433	1985-09-06	1985-09-06 00:00:00	1985-09-20	1985-09-20 00:00:00	1985-09-20	38000177		0	0	14		0	0	0	285248	0	313782	1127433		
100967	2213	40213227	1992-08-26	1992-08-26 00:00:00	1992-08-26	1992-08-26 00:00:00	1992-08-26	581452		0	0	0		0	0	0	147400	0	113	40213227		
62292	5185	1115171	2000-01-04	2000-01-04 00:00:00	2000-03-11	2000-03-11 00:00:00	2000-03-11	38000177		0	0	67		0	0	0	344724	0	849574	1115171		
3988	331	35605858	1997-04-18	1997-04-18 00:00:00	1997-04-18	1997-04-18 00:00:00	1997-04-18	38000177		0	0	0		0	0	0	21811	0	1732136	35605858		
207195	4546	40213227	2010-01-01	2010-01-01 00:00:00	2010-01-01	2010-01-01 00:00:00	2010-01-01	581452		0	0	0		0	0	0	302824	0	113	40213227		
7678	644	1127433	1989-06-02	1989-06-02 00:00:00	1989-06-09	1989-06-09 00:00:00	1989-06-09	38000177		0	0	7		0	0	0	42612	0	313782	1127433		
19502	1606	1127433	1990-04-09	1990-04-09 00:00:00	1990-04-23	1990-04-23 00:00:00	1990-04-23	38000177		0	0	14		0	0	0	107801	0	313782	1127433		
32847	2721	1127433	2013-04-07	2013-04-07 00:00:00	2013-04-14	2013-04-14 00:00:00	2013-04-14	38000177		0	0	7		0	0	0	180310	0	313782	1127433		
18646	404	40213260	2011-02-08	2011-02-08 00:00:00	2011-02-08	2011-02-08 00:00:00	2011-02-08	581452		0	0	0		0	0	0	26554	0	121	40213260		
16446	1361	1127433	1987-06-22	1987-06-22 00:00:00	1987-07-06	1987-07-06 00:00:00	1987-07-06	38000177		0	0	14		0	0	0	90291	0	313782	1127433		
16470	1365	19128065	1980-08-02	1980-08-02 00:00:00	1981-07-28	1981-07-28 00:00:00	1981-07-28	38000177		0	0	360		0	0	0	90424	0	749882	19128065		
21286	1751	19078461	1999-04-23	1999-04-23 00:00:00	1999-05-14	1999-05-14 00:00:00	1999-05-14	38000177		0	0	21		0	0	0	117080	0	310965	19078461		
48570	4022	1713671	2012-06-26	2012-06-26 00:00:00	2012-07-03	2012-07-03 00:00:00	2012-07-03	38000177		0	0	7		0	0	0	267414	0	562251	1713671		
48550	1062	40213296	2006-07-09	2006-07-09 00:00:00	2006-07-09	2006-07-09 00:00:00	2006-07-09	581452		0	0	0		0	0	0	69695	0	52	40213296		
54048	4491	19059056	1949-11-23	1949-11-23 00:00:00	1949-12-14	1949-12-14 00:00:00	1949-12-14	38000177		0	0	21		0	0	0	299022	0	243670	19059056		
237179	5207	40213260	2007-08-22	2007-08-22 00:00:00	2007-08-22	2007-08-22 00:00:00	2007-08-22	581452		0	0	0		0	0	0	346396	0	121	40213260		
20666	449	40213306	1981-08-06	1981-08-06 00:00:00	1981-08-06	1981-08-06 00:00:00	1981-08-06	581452		0	0	0		0	0	0	29988	0	43	40213306		
14149	1185	1115171	2008-02-11	2008-02-11 00:00:00	2008-04-11	2008-04-11 00:00:00	2008-04-11	38000177		0	0	60		0	0	0	78150	0	849574	1115171		
52592	4373	1118084	2018-01-10	2018-01-10 00:00:00	2018-01-10	2018-01-10 00:00:00	\N	38000177		0	0	0		0	0	0	290340	0	00025152531	44923712		
236930	5201	40213160	1978-12-13	1978-12-13 00:00:00	1978-12-13	1978-12-13 00:00:00	1978-12-13	581452		0	0	0		0	0	0	345959	0	10	40213160		
18117	1500	19059056	1965-07-26	1965-07-26 00:00:00	1965-08-09	1965-08-09 00:00:00	1965-08-09	38000177		0	0	14		0	0	0	100078	0	243670	19059056		
13274	287	40213251	1984-02-05	1984-02-05 00:00:00	1984-02-05	1984-02-05 00:00:00	1984-02-05	581452		0	0	0		0	0	0	19172	0	21	40213251		
183068	4022	40213296	2000-10-07	2000-10-07 00:00:00	2000-10-07	2000-10-07 00:00:00	2000-10-07	581452		0	0	0		0	0	0	267383	0	52	40213296		
219239	4812	40213296	1998-03-04	1998-03-04 00:00:00	1998-03-04	1998-03-04 00:00:00	1998-03-04	581452		0	0	0		0	0	0	320169	0	52	40213296		
51599	4288	19006318	1953-06-29	1953-06-29 00:00:00	1953-07-13	1953-07-13 00:00:00	1953-07-13	38000177		0	0	14		0	0	0	284654	0	105078	19006318		
23732	515	40213227	2002-12-28	2002-12-28 00:00:00	2002-12-28	2002-12-28 00:00:00	2002-12-28	581452		0	0	0		0	0	0	34409	0	113	40213227		
63820	5301	920300	1940-11-24	1940-11-24 00:00:00	1940-12-01	1940-12-01 00:00:00	1940-12-01	38000177		0	0	7		0	0	0	352727	0	311989	920300		
235145	5165	40213306	1986-02-21	1986-02-21 00:00:00	1986-02-21	1986-02-21 00:00:00	1986-02-21	581452		0	0	0		0	0	0	343367	0	43	40213306		
55039	1206	40213227	2015-02-16	2015-02-16 00:00:00	2015-02-16	2015-02-16 00:00:00	2015-02-16	581452		0	0	0		0	0	0	79283	0	113	40213227		
67014	1466	40213296	2009-11-24	2009-11-24 00:00:00	2009-11-24	2009-11-24 00:00:00	2009-11-24	581452		0	0	0		0	0	0	97633	0	52	40213296		
24217	1990	19129655	1978-06-23	1978-06-23 00:00:00	1978-07-14	1978-07-14 00:00:00	1978-07-14	38000177		0	0	21		0	0	0	132503	0	789980	19129655		
34747	2869	40229134	1976-04-27	1976-04-27 00:00:00	1976-05-11	1976-05-11 00:00:00	1976-05-11	38000177		0	0	14		0	0	0	190890	0	1043400	40229134		
169266	3721	40213227	2015-05-22	2015-05-22 00:00:00	2015-05-22	2015-05-22 00:00:00	2015-05-22	581452		0	0	0		0	0	0	247383	0	113	40213227		
55580	4615	40229134	1963-08-08	1963-08-08 00:00:00	1963-08-15	1963-08-15 00:00:00	1963-08-15	38000177		0	0	7		0	0	0	307421	0	1043400	40229134		
57861	4807	40236824	2002-07-06	2002-07-06 00:00:00	2002-07-13	2002-07-13 00:00:00	2002-07-13	38000177		0	0	7		0	0	0	319886	0	1094107	40236824		
134546	2953	40213314	1983-04-22	1983-04-22 00:00:00	1983-04-22	1983-04-22 00:00:00	1983-04-22	581452		0	0	0		0	0	0	197139	0	49	40213314		
57929	4812	1127078	1956-12-13	1956-12-13 00:00:00	1956-12-27	1956-12-27 00:00:00	1956-12-27	38000177		0	0	14		0	0	0	320140	0	282464	1127078		
211350	4634	40213227	1995-07-13	1995-07-13 00:00:00	1995-07-13	1995-07-13 00:00:00	1995-07-13	581452		0	0	0		0	0	0	308848	0	113	40213227		
115659	2541	40213314	1978-03-06	1978-03-06 00:00:00	1978-03-06	1978-03-06 00:00:00	1978-03-06	581452		0	0	0		0	0	0	168006	0	49	40213314		
509	11	40213160	1955-07-12	1955-07-12 00:00:00	1955-07-12	1955-07-12 00:00:00	1955-07-12	581452		0	0	0		0	0	0	957	0	10	40213160		
52112	4333	19059056	1959-08-26	1959-08-26 00:00:00	1959-09-30	1959-09-30 00:00:00	1959-09-30	38000177		0	0	35		0	0	0	287409	0	243670	19059056		
22794	1874	1127433	1982-04-29	1982-04-29 00:00:00	1982-05-06	1982-05-06 00:00:00	1982-05-06	38000177		0	0	7		0	0	0	125129	0	313782	1127433		
32232	703	40213160	1955-12-09	1955-12-09 00:00:00	1955-12-09	1955-12-09 00:00:00	1955-12-09	581452		0	0	0		0	0	0	46445	0	10	40213160		
48076	3986	1127433	1990-04-09	1990-04-09 00:00:00	1990-04-23	1990-04-23 00:00:00	1990-04-23	38000177		0	0	14		0	0	0	265021	0	313782	1127433		
58602	4867	19133905	1962-12-18	1962-12-18 00:00:00	1962-12-27	1962-12-27 00:00:00	1962-12-27	38000177		0	0	9		0	0	0	323708	0	834102	19133905		
76470	1670	40213260	2015-02-01	2015-02-01 00:00:00	2015-02-01	2015-02-01 00:00:00	2015-02-01	581452		0	0	0		0	0	0	112171	0	121	40213260		
59841	4975	1127433	1999-11-25	1999-11-25 00:00:00	1999-12-23	1999-12-23 00:00:00	1999-12-23	38000177		0	0	28		0	0	0	330919	0	313782	1127433		
59915	4979	19073183	1986-02-01	1986-02-01 00:00:00	1986-02-15	1986-02-15 00:00:00	1986-02-15	38000177		0	0	14		0	0	0	331294	0	308182	19073183		
130154	2861	40213160	1963-12-16	1963-12-16 00:00:00	1963-12-16	1963-12-16 00:00:00	1963-12-16	581452		0	0	0		0	0	0	190214	0	10	40213160		
93496	2052	40213227	2013-03-11	2013-03-11 00:00:00	2013-03-11	2013-03-11 00:00:00	2013-03-11	581452		0	0	0		0	0	0	136457	0	113	40213227		
191250	4202	40213227	2013-05-25	2013-05-25 00:00:00	2013-05-25	2013-05-25 00:00:00	2013-05-25	581452		0	0	0		0	0	0	278977	0	113	40213227		
42191	3501	19133873	1961-01-27	1961-01-27 00:00:00	1961-02-09	1961-02-09 00:00:00	1961-02-09	38000177		0	0	13		0	0	0	232066	0	834061	19133873		
19100	1577	19059056	1925-07-01	1925-07-01 00:00:00	1925-07-15	1925-07-15 00:00:00	1925-07-15	38000177		0	0	14		0	0	0	105840	0	243670	19059056		
94563	2075	40213296	2007-02-20	2007-02-20 00:00:00	2007-02-20	2007-02-20 00:00:00	2007-02-20	581452		0	0	0		0	0	0	138128	0	52	40213296		
208730	4578	40213227	2006-06-04	2006-06-04 00:00:00	2006-06-04	2006-06-04 00:00:00	2006-06-04	581452		0	0	0		0	0	0	304985	0	113	40213227		
149258	3283	40213160	1978-10-20	1978-10-20 00:00:00	1978-10-20	1978-10-20 00:00:00	1978-10-20	581452		0	0	0		0	0	0	218130	0	10	40213160		
52839	4390	19059056	1966-05-30	1966-05-30 00:00:00	1966-06-20	1966-06-20 00:00:00	1966-06-20	38000177		0	0	21		0	0	0	291789	0	243670	19059056		
42833	3550	19133873	1988-07-02	1988-07-02 00:00:00	1988-07-10	1988-07-10 00:00:00	1988-07-10	38000177		0	0	8		0	0	0	235746	0	834061	19133873		
43679	3621	1127433	1930-01-23	1930-01-23 00:00:00	1930-01-30	1930-01-30 00:00:00	1930-01-30	38000177		0	0	7		0	0	0	240591	0	313782	1127433		
59538	4949	19128022	1992-08-17	1992-08-17 00:00:00	1993-08-12	1993-08-12 00:00:00	1993-08-12	38000177		0	0	360		0	0	0	329040	0	749785	19128022		
57317	4757	19059056	1975-02-17	1975-02-17 00:00:00	1975-03-17	1975-03-17 00:00:00	1975-03-17	38000177		0	0	28		0	0	0	316961	0	243670	19059056		
43809	3628	1127433	1987-09-15	1987-09-15 00:00:00	1987-09-29	1987-09-29 00:00:00	1987-09-29	38000177		0	0	14		0	0	0	241356	0	313782	1127433		
54301	4514	46233988	1978-09-04	1978-09-04 00:00:00	1978-09-18	1978-09-18 00:00:00	1978-09-18	38000177		0	0	14		0	0	0	300694	0	1652673	46233988		
54343	4520	1127433	1948-10-16	1948-10-16 00:00:00	1948-10-30	1948-10-30 00:00:00	1948-10-30	38000177		0	0	14		0	0	0	300945	0	313782	1127433		
51746	4299	19073188	1985-09-06	1985-09-06 00:00:00	1985-09-20	1985-09-20 00:00:00	1985-09-20	38000177		0	0	14		0	0	0	285248	0	308192	19073188		
100968	2213	40213306	1983-08-17	1983-08-17 00:00:00	1983-08-17	1983-08-17 00:00:00	1983-08-17	581452		0	0	0		0	0	0	147398	0	43	40213306		
62293	5185	40222846	2010-11-02	2010-11-02 00:00:00	2010-11-02	2010-11-02 00:00:00	\N	38000177		0	0	0		0	0	0	344697	0	996740	40222846		
3989	331	19079524	1997-04-18	1997-04-18 00:00:00	1997-04-19	1997-04-19 00:00:00	1997-04-19	38000177		0	0	1		0	0	0	21811	0	313002	19079524		
207196	4546	40213296	2010-01-01	2010-01-01 00:00:00	2010-01-01	2010-01-01 00:00:00	2010-01-01	581452		0	0	0		0	0	0	302824	0	52	40213296		
207283	4548	40213227	2006-06-20	2006-06-20 00:00:00	2006-06-20	2006-06-20 00:00:00	2006-06-20	581452		0	0	0		0	0	0	303078	0	113	40213227		
19503	1606	19133873	1958-04-01	1958-04-01 00:00:00	1958-04-11	1958-04-11 00:00:00	1958-04-11	38000177		0	0	10		0	0	0	107844	0	834061	19133873		
32848	2721	19059056	1989-10-16	1989-10-16 00:00:00	1989-11-20	1989-11-20 00:00:00	1989-11-20	38000177		0	0	35		0	0	0	180347	0	243670	19059056		
18652	404	40213227	2001-11-13	2001-11-13 00:00:00	2001-11-13	2001-11-13 00:00:00	2001-11-13	581452		0	0	0		0	0	0	\N	0	113	40213227		
16447	1361	19133873	1955-09-06	1955-09-06 00:00:00	1955-09-16	1955-09-16 00:00:00	1955-09-16	38000177		0	0	10		0	0	0	90366	0	834061	19133873		
16471	1365	1127433	1978-06-05	1978-06-05 00:00:00	1978-06-12	1978-06-12 00:00:00	1978-06-12	38000177		0	0	7		0	0	0	90501	0	313782	1127433		
21287	1751	19019979	1980-09-12	1980-09-12 00:00:00	1980-09-26	1980-09-26 00:00:00	1980-09-26	38000177		0	0	14		0	0	0	117076	0	198405	19019979		
48571	4022	1713671	2015-12-24	2015-12-24 00:00:00	2015-12-31	2015-12-31 00:00:00	2015-12-31	38000177		0	0	7		0	0	0	267365	0	562251	1713671		
48556	1062	40213227	2008-07-13	2008-07-13 00:00:00	2008-07-13	2008-07-13 00:00:00	2008-07-13	581452		0	0	0		0	0	0	69701	0	113	40213227		
54049	4491	1127433	2001-05-29	2001-05-29 00:00:00	2001-06-05	2001-06-05 00:00:00	2001-06-05	38000177		0	0	7		0	0	0	299020	0	313782	1127433		
237180	5207	40213296	1996-01-17	1996-01-17 00:00:00	1996-01-17	1996-01-17 00:00:00	1996-01-17	581452		0	0	0		0	0	0	346394	0	52	40213296		
21288	462	40213227	1998-11-19	1998-11-19 00:00:00	1998-11-19	1998-11-19 00:00:00	1998-11-19	581452		0	0	0		0	0	0	30878	0	113	40213227		
14150	1185	19133873	1947-04-22	1947-04-22 00:00:00	1947-05-03	1947-05-03 00:00:00	1947-05-03	38000177		0	0	11		0	0	0	78178	0	834061	19133873		
52593	4373	19133873	1977-02-03	1977-02-03 00:00:00	1977-02-12	1977-02-12 00:00:00	1977-02-12	38000177		0	0	9		0	0	0	290378	0	834061	19133873		
39151	855	40213160	1957-03-01	1957-03-01 00:00:00	1957-03-01	1957-03-01 00:00:00	1957-03-01	581452		0	0	0		0	0	0	56496	0	10	40213160		
18118	1500	1127433	2015-04-30	2015-04-30 00:00:00	2015-05-07	2015-05-07 00:00:00	2015-05-07	38000177		0	0	7		0	0	0	100072	0	313782	1127433		
13276	287	40213306	1998-04-13	1998-04-13 00:00:00	1998-04-13	1998-04-13 00:00:00	1998-04-13	581452		0	0	0		0	0	0	19175	0	43	40213306		
183070	4022	40213227	2000-10-07	2000-10-07 00:00:00	2000-10-07	2000-10-07 00:00:00	2000-10-07	581452		0	0	0		0	0	0	267383	0	113	40213227		
219243	4812	40213160	1959-09-23	1959-09-23 00:00:00	1959-09-23	1959-09-23 00:00:00	1959-09-23	581452		0	0	0		0	0	0	320179	0	10	40213160		
51601	4288	19133905	1973-02-21	1973-02-21 00:00:00	1973-03-06	1973-03-06 00:00:00	1973-03-06	38000177		0	0	13		0	0	0	284699	0	834102	19133905		
23737	515	40213227	2013-01-19	2013-01-19 00:00:00	2013-01-19	2013-01-19 00:00:00	2013-01-19	581452		0	0	0		0	0	0	34331	0	113	40213227		
63821	5301	19059056	1921-10-22	1921-10-22 00:00:00	1921-11-05	1921-11-05 00:00:00	1921-11-05	38000177		0	0	14		0	0	0	352734	0	243670	19059056		
235148	5165	40213260	2013-12-13	2013-12-13 00:00:00	2013-12-13	2013-12-13 00:00:00	2013-12-13	581452		0	0	0		0	0	0	343380	0	121	40213260		
55040	1206	40213260	2015-02-16	2015-02-16 00:00:00	2015-02-16	2015-02-16 00:00:00	2015-02-16	581452		0	0	0		0	0	0	79283	0	121	40213260		
67015	1466	40213160	1968-11-12	1968-11-12 00:00:00	1968-11-12	1968-11-12 00:00:00	1968-11-12	581452		0	0	0		0	0	0	97655	0	10	40213160		
24218	1990	1127433	1998-04-10	1998-04-10 00:00:00	1998-04-24	1998-04-24 00:00:00	1998-04-24	38000177		0	0	14		0	0	0	132486	0	313782	1127433		
34748	2869	1115171	2000-12-03	2000-12-03 00:00:00	2000-12-24	2000-12-24 00:00:00	2000-12-24	38000177		0	0	21		0	0	0	190828	0	849574	1115171		
169268	3721	40213296	2003-11-21	2003-11-21 00:00:00	2003-11-21	2003-11-21 00:00:00	2003-11-21	581452		0	0	0		0	0	0	247381	0	52	40213296		
55581	4615	19128065	1974-03-21	1974-03-21 00:00:00	1975-03-16	1975-03-16 00:00:00	1975-03-16	38000177		0	0	360		0	0	0	307378	0	749882	19128065		
57862	4807	920300	2002-07-06	2002-07-06 00:00:00	2002-07-13	2002-07-13 00:00:00	2002-07-13	38000177		0	0	7		0	0	0	319886	0	311989	920300		
134547	2953	40213314	1984-01-20	1984-01-20 00:00:00	1984-01-20	1984-01-20 00:00:00	1984-01-20	581452		0	0	0		0	0	0	197140	0	49	40213314		
57930	4812	1127433	1967-03-09	1967-03-09 00:00:00	1967-04-06	1967-04-06 00:00:00	1967-04-06	38000177		0	0	28		0	0	0	320160	0	313782	1127433		
98897	2165	40213260	2006-06-13	2006-06-13 00:00:00	2006-06-13	2006-06-13 00:00:00	2006-06-13	581452		0	0	0		0	0	0	144268	0	121	40213260		
103331	2266	40213160	1969-05-24	1969-05-24 00:00:00	1969-05-24	1969-05-24 00:00:00	1969-05-24	581452		0	0	0		0	0	0	150628	0	10	40213160		
518	11	40213260	2006-02-21	2006-02-21 00:00:00	2006-02-21	2006-02-21 00:00:00	2006-02-21	581452		0	0	0		0	0	0	974	0	121	40213260		
52113	4333	1713671	2002-01-19	2002-01-19 00:00:00	2002-02-02	2002-02-02 00:00:00	2002-02-02	38000177		0	0	14		0	0	0	287428	0	562251	1713671		
22795	1874	19019979	1978-05-18	1978-05-18 00:00:00	1978-06-01	1978-06-01 00:00:00	1978-06-01	38000177		0	0	14		0	0	0	125103	0	198405	19019979		
32236	703	40213227	1992-05-08	1992-05-08 00:00:00	1992-05-08	1992-05-08 00:00:00	1992-05-08	581452		0	0	0		0	0	0	46455	0	113	40213227		
48077	3986	46233988	1967-04-26	1967-04-26 00:00:00	1967-05-10	1967-05-10 00:00:00	1967-05-10	38000177		0	0	14		0	0	0	264967	0	1652673	46233988		
23274	505	40213260	2019-03-05	2019-03-05 00:00:00	2019-03-05	2019-03-05 00:00:00	2019-03-05	581452		0	0	0		0	0	0	33814	0	121	40213260		
76474	1670	40213227	1995-01-22	1995-01-22 00:00:00	1995-01-22	1995-01-22 00:00:00	1995-01-22	581452		0	0	0		0	0	0	112122	0	113	40213227		
59842	4975	1713671	1968-08-16	1968-08-16 00:00:00	1968-12-13	1968-12-13 00:00:00	1968-12-13	38000177		0	0	119		0	0	0	330845	0	562251	1713671		
59916	4979	42902245	2000-05-28	2000-05-28 00:00:00	2001-05-23	2001-05-23 00:00:00	2001-05-23	38000177		0	0	360		0	0	0	331259	0	1359133	42902245		
105478	2314	40213227	2002-07-13	2002-07-13 00:00:00	2002-07-13	2002-07-13 00:00:00	2002-07-13	581452		0	0	0		0	0	0	153915	0	113	40213227		
93497	2052	40213260	2013-03-11	2013-03-11 00:00:00	2013-03-11	2013-03-11 00:00:00	2013-03-11	581452		0	0	0		0	0	0	136457	0	121	40213260		
191253	4202	40213160	1976-04-24	1976-04-24 00:00:00	1976-04-24	1976-04-24 00:00:00	1976-04-24	581452		0	0	0		0	0	0	278950	0	10	40213160		
42192	3501	1127433	1962-08-16	1962-08-16 00:00:00	1962-08-23	1962-08-23 00:00:00	1962-08-23	38000177		0	0	7		0	0	0	232080	0	313782	1127433		
19101	1577	35605482	1997-01-31	1997-01-31 00:00:00	1997-01-31	1997-01-31 00:00:00	1997-01-31	38000177		0	0	0		0	0	0	105932	0	1740467	35605482		
94565	2075	40213227	2017-06-27	2017-06-27 00:00:00	2017-06-27	2017-06-27 00:00:00	2017-06-27	581452		0	0	0		0	0	0	138015	0	113	40213227		
208734	4578	40213260	2014-05-25	2014-05-25 00:00:00	2014-05-25	2014-05-25 00:00:00	2014-05-25	581452		0	0	0		0	0	0	304939	0	121	40213260		
149259	3283	40213314	1978-10-20	1978-10-20 00:00:00	1978-10-20	1978-10-20 00:00:00	1978-10-20	581452		0	0	0		0	0	0	218130	0	49	40213314		
52840	4390	19059056	1986-01-27	1986-01-27 00:00:00	1986-02-17	1986-02-17 00:00:00	1986-02-17	38000177		0	0	21		0	0	0	291791	0	243670	19059056		
42834	3550	40229134	1995-10-03	1995-10-03 00:00:00	1995-10-10	1995-10-10 00:00:00	1995-10-10	38000177		0	0	7		0	0	0	235704	0	1043400	40229134		
43680	3621	19133873	1932-03-07	1932-03-07 00:00:00	1932-03-14	1932-03-14 00:00:00	1932-03-14	38000177		0	0	7		0	0	0	240618	0	834061	19133873		
59539	4949	19128065	1988-09-07	1988-09-07 00:00:00	1989-09-02	1989-09-02 00:00:00	1989-09-02	38000177		0	0	360		0	0	0	329052	0	749882	19128065		
57318	4757	920300	2008-04-14	2008-04-14 00:00:00	2008-04-21	2008-04-21 00:00:00	2008-04-21	38000177		0	0	7		0	0	0	316896	0	311989	920300		
43810	3628	19059056	1973-04-26	1973-04-26 00:00:00	1973-05-31	1973-05-31 00:00:00	1973-05-31	38000177		0	0	35		0	0	0	241354	0	243670	19059056		
54302	4514	1127078	1978-09-04	1978-09-04 00:00:00	1978-09-18	1978-09-18 00:00:00	1978-09-18	38000177		0	0	14		0	0	0	300694	0	282464	1127078		
54344	4520	19059056	1929-04-28	1929-04-28 00:00:00	1929-05-12	1929-05-12 00:00:00	1929-05-12	38000177		0	0	14		0	0	0	300876	0	243670	19059056		
51747	4299	19078461	2011-11-20	2011-11-20 00:00:00	2011-12-11	2011-12-11 00:00:00	2011-12-11	38000177		0	0	21		0	0	0	285236	0	310965	19078461		
100970	2213	40213260	2013-01-02	2013-01-02 00:00:00	2013-01-02	2013-01-02 00:00:00	2013-01-02	581452		0	0	0		0	0	0	147375	0	121	40213260		
62294	5185	1124300	1968-09-20	1968-09-20 00:00:00	1968-09-20	1968-09-20 00:00:00	\N	38000177		0	0	0		0	0	0	344610	0	00781178901	45011828		
3990	331	1127433	1998-05-31	1998-05-31 00:00:00	1998-06-07	1998-06-07 00:00:00	1998-06-07	38000177		0	0	7		0	0	0	21823	0	313782	1127433		
207201	4546	40213306	1990-11-23	1990-11-23 00:00:00	1990-11-23	1990-11-23 00:00:00	1990-11-23	581452		0	0	0		0	0	0	302776	0	43	40213306		
207284	4548	40213306	2006-06-20	2006-06-20 00:00:00	2006-06-20	2006-06-20 00:00:00	2006-06-20	581452		0	0	0		0	0	0	303078	0	43	40213306		
19504	1606	1127433	2011-04-13	2011-04-13 00:00:00	2011-04-20	2011-04-20 00:00:00	2011-04-20	38000177		0	0	7		0	0	0	107877	0	313782	1127433		
32849	2721	40171902	2017-04-22	2017-04-22 00:00:00	2017-04-22	2017-04-22 00:00:00	\N	38000177		0	0	0		0	0	0	180323	0	897718	40171902		
18653	404	40213296	2001-11-13	2001-11-13 00:00:00	2001-11-13	2001-11-13 00:00:00	2001-11-13	581452		0	0	0		0	0	0	\N	0	52	40213296		
16448	1361	1127433	2008-08-28	2008-08-28 00:00:00	2008-09-11	2008-09-11 00:00:00	2008-09-11	38000177		0	0	14		0	0	0	90374	0	313782	1127433		
16472	1365	1127078	1963-10-21	1963-10-21 00:00:00	1963-11-04	1963-11-04 00:00:00	1963-11-04	38000177		0	0	14		0	0	0	90484	0	282464	1127078		
21288	1751	19133905	2011-05-15	2011-05-15 00:00:00	2011-05-22	2011-05-22 00:00:00	2011-05-22	38000177		0	0	7		0	0	0	117049	0	834102	19133905		
48578	4024	1127433	1981-09-16	1981-09-16 00:00:00	1981-09-23	1981-09-23 00:00:00	1981-09-23	38000177		0	0	7		0	0	0	267515	0	313782	1127433		
48559	1062	40213296	2008-07-13	2008-07-13 00:00:00	2008-07-13	2008-07-13 00:00:00	2008-07-13	581452		0	0	0		0	0	0	69701	0	52	40213296		
54051	4491	1127433	2018-06-08	2018-06-08 00:00:00	2018-06-22	2018-06-22 00:00:00	2018-06-22	38000177		0	0	14		0	0	0	298987	0	313782	1127433		
237201	5207	40213260	2006-08-16	2006-08-16 00:00:00	2006-08-16	2006-08-16 00:00:00	2006-08-16	581452		0	0	0		0	0	0	346361	0	121	40213260		
21290	462	40213160	1981-07-02	1981-07-02 00:00:00	1981-07-02	1981-07-02 00:00:00	1981-07-02	581452		0	0	0		0	0	0	30903	0	10	40213160		
14151	1185	40173590	1997-01-05	1997-01-05 00:00:00	1997-01-05	1997-01-05 00:00:00	\N	38000177		0	0	0		0	0	0	78100	0	904419	40173590		
52594	4373	1551192	1976-07-04	1976-07-04 00:00:00	1976-07-04	1976-07-04 00:00:00	1976-07-04	38000177		0	0	0		0	0	0	290372	0	312617	1551192		
39159	855	40213160	1957-05-03	1957-05-03 00:00:00	1957-05-03	1957-05-03 00:00:00	1957-05-03	581452		0	0	0		0	0	0	56470	0	10	40213160		
18132	1504	1713671	1942-02-11	1942-02-11 00:00:00	1942-02-25	1942-02-25 00:00:00	1942-02-25	38000177		0	0	14		0	0	0	100265	0	562251	1713671		
13284	287	40213314	1977-01-16	1977-01-16 00:00:00	1977-01-16	1977-01-16 00:00:00	1977-01-16	581452		0	0	0		0	0	0	19162	0	49	40213314		
183074	4022	40213306	1981-10-10	1981-10-10 00:00:00	1981-10-10	1981-10-10 00:00:00	1981-10-10	581452		0	0	0		0	0	0	267382	0	43	40213306		
219245	4812	40213227	2006-06-14	2006-06-14 00:00:00	2006-06-14	2006-06-14 00:00:00	2006-06-14	581452		0	0	0		0	0	0	320146	0	113	40213227		
51602	4288	1127433	1974-06-28	1974-06-28 00:00:00	1974-07-05	1974-07-05 00:00:00	1974-07-05	38000177		0	0	7		0	0	0	284675	0	313782	1127433		
202529	4447	40213160	1955-09-06	1955-09-06 00:00:00	1955-09-06	1955-09-06 00:00:00	1955-09-06	581452		0	0	0		0	0	0	\N	0	10	40213160		
63822	5301	40220960	2003-05-01	2003-05-01 00:00:00	2003-05-01	2003-05-01 00:00:00	2003-05-01	38000177		0	0	0		0	0	0	352672	0	1804799	40220960		
235153	5166	40213296	1996-04-23	1996-04-23 00:00:00	1996-04-23	1996-04-23 00:00:00	1996-04-23	581452		0	0	0		0	0	0	343428	0	52	40213296		
55041	1206	40213160	1964-05-18	1964-05-18 00:00:00	1964-05-18	1964-05-18 00:00:00	1964-05-18	581452		0	0	0		0	0	0	79235	0	10	40213160		
67018	1466	40213160	1973-02-13	1973-02-13 00:00:00	1973-02-13	1973-02-13 00:00:00	1973-02-13	581452		0	0	0		0	0	0	97637	0	10	40213160		
24219	1990	1127078	1975-04-10	1975-04-10 00:00:00	1975-07-09	1975-07-09 00:00:00	1975-07-09	38000177		0	0	90		0	0	0	132502	0	282464	1127078		
34749	2869	1127433	1968-11-20	1968-11-20 00:00:00	1968-11-27	1968-11-27 00:00:00	1968-11-27	38000177		0	0	7		0	0	0	190888	0	313782	1127433		
169274	3721	40213160	1964-04-24	1964-04-24 00:00:00	1964-04-24	1964-04-24 00:00:00	1964-04-24	581452		0	0	0		0	0	0	247342	0	10	40213160		
55582	4615	19078461	2011-04-24	2011-04-24 00:00:00	2011-05-22	2011-05-22 00:00:00	2011-05-22	38000177		0	0	28		0	0	0	307376	0	310965	19078461		
57863	4807	1127433	1972-05-09	1972-05-09 00:00:00	1972-06-13	1972-06-13 00:00:00	1972-06-13	38000177		0	0	35		0	0	0	319809	0	313782	1127433		
134548	2953	40213251	1984-01-20	1984-01-20 00:00:00	1984-01-20	1984-01-20 00:00:00	1984-01-20	581452		0	0	0		0	0	0	197140	0	21	40213251		
57931	4812	19128065	1981-08-10	1981-08-10 00:00:00	1982-01-13	1982-01-13 00:00:00	1982-01-13	38000177		0	0	156		0	0	0	320143	0	749882	19128065		
98903	2165	40213160	1955-02-08	1955-02-08 00:00:00	1955-02-08	1955-02-08 00:00:00	1955-02-08	581452		0	0	0		0	0	0	144213	0	10	40213160		
103333	2266	40213227	2011-07-02	2011-07-02 00:00:00	2011-07-02	2011-07-02 00:00:00	2011-07-02	581452		0	0	0		0	0	0	150657	0	113	40213227		
18557	403	40213227	2004-03-01	2004-03-01 00:00:00	2004-03-01	2004-03-01 00:00:00	2004-03-01	581452		0	0	0		0	0	0	26528	0	113	40213227		
52115	4333	1127433	1980-01-17	1980-01-17 00:00:00	1980-01-31	1980-01-31 00:00:00	1980-01-31	38000177		0	0	14		0	0	0	287357	0	313782	1127433		
22796	1874	1118084	2014-12-20	2014-12-20 00:00:00	2014-12-20	2014-12-20 00:00:00	\N	38000177		0	0	0		0	0	0	125134	0	00025152531	44923712		
32239	703	40213227	2011-06-03	2011-06-03 00:00:00	2011-06-03	2011-06-03 00:00:00	2011-06-03	581452		0	0	0		0	0	0	46488	0	113	40213227		
48078	3986	19059056	1967-04-26	1967-04-26 00:00:00	1967-05-10	1967-05-10 00:00:00	1967-05-10	38000177		0	0	14		0	0	0	264967	0	243670	19059056		
23277	505	40213227	2001-02-06	2001-02-06 00:00:00	2001-02-06	2001-02-06 00:00:00	2001-02-06	581452		0	0	0		0	0	0	33842	0	113	40213227		
76477	1670	40213227	2007-01-07	2007-01-07 00:00:00	2007-01-07	2007-01-07 00:00:00	2007-01-07	581452		0	0	0		0	0	0	112178	0	113	40213227		
59843	4975	19059056	1961-05-12	1961-05-12 00:00:00	1961-05-26	1961-05-26 00:00:00	1961-05-26	38000177		0	0	14		0	0	0	330873	0	243670	19059056		
59917	4979	19128065	2001-05-23	2001-05-23 00:00:00	2002-05-18	2002-05-18 00:00:00	2002-05-18	38000177		0	0	360		0	0	0	331250	0	749882	19128065		
105480	2314	40213198	2016-10-01	2016-10-01 00:00:00	2016-10-01	2016-10-01 00:00:00	2016-10-01	581452		0	0	0		0	0	0	153836	0	133	40213198		
93499	2052	40213227	1993-05-17	1993-05-17 00:00:00	1993-05-17	1993-05-17 00:00:00	1993-05-17	581452		0	0	0		0	0	0	136435	0	113	40213227		
191254	4202	40213160	1971-08-21	1971-08-21 00:00:00	1971-08-21	1971-08-21 00:00:00	1971-08-21	581452		0	0	0		0	0	0	278995	0	10	40213160		
42193	3501	1127433	2012-02-03	2012-02-03 00:00:00	2012-02-17	2012-02-17 00:00:00	2012-02-17	38000177		0	0	14		0	0	0	232084	0	313782	1127433		
19102	1577	35605482	1997-01-31	1997-01-31 00:00:00	1997-01-31	1997-01-31 00:00:00	1997-01-31	38000177		0	0	0		0	0	0	105932	0	1740467	35605482		
94572	2075	40213227	1999-06-01	1999-06-01 00:00:00	1999-06-01	1999-06-01 00:00:00	1999-06-01	581452		0	0	0		0	0	0	138127	0	113	40213227		
208741	4578	40213160	1964-08-30	1964-08-30 00:00:00	1964-08-30	1964-08-30 00:00:00	1964-08-30	581452		0	0	0		0	0	0	304968	0	10	40213160		
149261	3283	40213251	1984-06-29	1984-06-29 00:00:00	1984-06-29	1984-06-29 00:00:00	1984-06-29	581452		0	0	0		0	0	0	218125	0	21	40213251		
52841	4390	1713671	1974-07-06	1974-07-06 00:00:00	1974-07-20	1974-07-20 00:00:00	1974-07-20	38000177		0	0	14		0	0	0	291816	0	562251	1713671		
42835	3550	1127433	2012-07-04	2012-07-04 00:00:00	2012-07-25	2012-07-25 00:00:00	2012-07-25	38000177		0	0	21		0	0	0	235758	0	313782	1127433		
43681	3621	19059056	1929-08-03	1929-08-03 00:00:00	1929-09-02	1929-09-02 00:00:00	1929-09-02	38000177		0	0	30		0	0	0	240657	0	243670	19059056		
59540	4949	19128065	1987-09-13	1987-09-13 00:00:00	1988-09-07	1988-09-07 00:00:00	1988-09-07	38000177		0	0	360		0	0	0	329051	0	749882	19128065		
57319	4757	40236824	2008-04-14	2008-04-14 00:00:00	2008-04-21	2008-04-21 00:00:00	2008-04-21	38000177		0	0	7		0	0	0	316896	0	1094107	40236824		
43811	3628	1713671	1924-07-13	1924-07-13 00:00:00	1924-07-27	1924-07-27 00:00:00	1924-07-27	38000177		0	0	14		0	0	0	241403	0	562251	1713671		
54303	4514	19128065	1991-05-09	1991-05-09 00:00:00	1992-05-03	1992-05-03 00:00:00	1992-05-03	38000177		0	0	360		0	0	0	300695	0	749882	19128065		
54345	4520	19133768	1996-09-28	1996-09-28 00:00:00	1996-09-28	1996-09-28 00:00:00	1996-09-28	38000177		0	0	0		0	0	0	300940	0	833036	19133768		
51748	4299	19019979	1974-11-17	1974-11-17 00:00:00	1974-12-08	1974-12-08 00:00:00	1974-12-08	38000177		0	0	21		0	0	0	285233	0	198405	19019979		
100972	2213	40213227	2013-01-02	2013-01-02 00:00:00	2013-01-02	2013-01-02 00:00:00	2013-01-02	581452		0	0	0		0	0	0	147375	0	113	40213227		
62295	5185	19077572	2009-12-07	2009-12-07 00:00:00	2009-12-07	2009-12-07 00:00:00	\N	38000177		0	0	0		0	0	0	344664	0	310436	19077572		
83673	1829	40213227	2008-07-29	2008-07-29 00:00:00	2008-07-29	2008-07-29 00:00:00	2008-07-29	581452		0	0	0		0	0	0	122297	0	113	40213227		
207204	4546	40213160	1968-12-06	1968-12-06 00:00:00	1968-12-06	1968-12-06 00:00:00	1968-12-06	581452		0	0	0		0	0	0	302831	0	10	40213160		
207285	4548	40213180	2006-06-20	2006-06-20 00:00:00	2006-06-20	2006-06-20 00:00:00	2006-06-20	581452		0	0	0		0	0	0	303078	0	114	40213180		
19505	1606	1127078	1956-11-19	1956-11-19 00:00:00	1956-12-03	1956-12-03 00:00:00	1956-12-03	38000177		0	0	14		0	0	0	107824	0	282464	1127078		
32850	2721	19018935	2017-04-22	2017-04-22 00:00:00	2017-04-22	2017-04-22 00:00:00	\N	38000177		0	0	0		0	0	0	180323	0	197604	19018935		
18655	404	40213160	1965-03-30	1965-03-30 00:00:00	1965-03-30	1965-03-30 00:00:00	1965-03-30	581452		0	0	0		0	0	0	26683	0	10	40213160		
16452	1365	1127433	1993-10-19	1993-10-19 00:00:00	1993-11-02	1993-11-02 00:00:00	1993-11-02	38000177		0	0	14		0	0	0	90505	0	313782	1127433		
16473	1365	19073188	2009-02-25	2009-02-25 00:00:00	2009-03-11	2009-03-11 00:00:00	2009-03-11	38000177		0	0	14		0	0	0	90425	0	308192	19073188		
21289	1751	1127433	1988-02-21	1988-02-21 00:00:00	1988-02-28	1988-02-28 00:00:00	1988-02-28	38000177		0	0	7		0	0	0	117057	0	313782	1127433		
48579	4024	19128022	1997-12-29	1997-12-29 00:00:00	1998-12-24	1998-12-24 00:00:00	1998-12-24	38000177		0	0	360		0	0	0	267572	0	749785	19128022		
48563	1062	40213160	1967-01-22	1967-01-22 00:00:00	1967-01-22	1967-01-22 00:00:00	1967-01-22	581452		0	0	0		0	0	0	69668	0	10	40213160		
54052	4491	1127433	1992-04-07	1992-04-07 00:00:00	1992-06-06	1992-06-06 00:00:00	1992-06-06	38000177		0	0	60		0	0	0	299027	0	313782	1127433		
178570	3926	40213201	2014-07-07	2014-07-07 00:00:00	2014-07-07	2014-07-07 00:00:00	2014-07-07	581452		0	0	0		0	0	0	260921	0	33	40213201		
21293	462	40213251	1984-07-19	1984-07-19 00:00:00	1984-07-19	1984-07-19 00:00:00	1984-07-19	581452		0	0	0		0	0	0	30913	0	21	40213251		
14152	1185	1713671	1988-01-12	1988-01-12 00:00:00	1988-01-26	1988-01-26 00:00:00	1988-01-26	38000177		0	0	14		0	0	0	78091	0	562251	1713671		
52595	4373	46233988	1978-10-06	1978-10-06 00:00:00	1978-10-20	1978-10-20 00:00:00	1978-10-20	38000177		0	0	14		0	0	0	290398	0	1652673	46233988		
39178	856	40213227	2000-08-25	2000-08-25 00:00:00	2000-08-25	2000-08-25 00:00:00	2000-08-25	581452		0	0	0		0	0	0	56549	0	113	40213227		
18133	1504	19133905	1960-11-30	1960-11-30 00:00:00	1960-12-12	1960-12-12 00:00:00	1960-12-12	38000177		0	0	12		0	0	0	100268	0	834102	19133905		
13286	287	40213160	1976-06-21	1976-06-21 00:00:00	1976-06-21	1976-06-21 00:00:00	1976-06-21	581452		0	0	0		0	0	0	19211	0	10	40213160		
183080	4022	40213160	1959-12-26	1959-12-26 00:00:00	1959-12-26	1959-12-26 00:00:00	1959-12-26	581452		0	0	0		0	0	0	267393	0	10	40213160		
219246	4812	40213260	2006-06-14	2006-06-14 00:00:00	2006-06-14	2006-06-14 00:00:00	2006-06-14	581452		0	0	0		0	0	0	320146	0	121	40213260		
13489	1131	1118084	2004-12-14	2004-12-14 00:00:00	2004-12-14	2004-12-14 00:00:00	\N	38000177		0	0	0		0	0	0	74473	0	00025152531	44923712		
202531	4447	40213227	1993-06-01	1993-06-01 00:00:00	1993-06-01	1993-06-01 00:00:00	1993-06-01	581452		0	0	0		0	0	0	295749	0	113	40213227		
63823	5301	19075601	2003-05-01	2003-05-01 00:00:00	2003-05-01	2003-05-01 00:00:00	2003-05-01	38000177		0	0	0		0	0	0	352672	0	309362	19075601		
235156	5166	40213227	2013-06-11	2013-06-11 00:00:00	2013-06-11	2013-06-11 00:00:00	2013-06-11	581452		0	0	0		0	0	0	343490	0	113	40213227		
55043	1206	40213227	1996-11-25	1996-11-25 00:00:00	1996-11-25	1996-11-25 00:00:00	1996-11-25	581452		0	0	0		0	0	0	79226	0	113	40213227		
67021	1466	40213260	2018-03-06	2018-03-06 00:00:00	2018-03-06	2018-03-06 00:00:00	2018-03-06	581452		0	0	0		0	0	0	97634	0	121	40213260		
24220	1991	40229134	1971-07-01	1971-07-01 00:00:00	1971-07-08	1971-07-08 00:00:00	1971-07-08	38000177		0	0	7		0	0	0	132632	0	1043400	40229134		
34750	2869	19059056	1951-11-18	1951-11-18 00:00:00	1951-12-09	1951-12-09 00:00:00	1951-12-09	38000177		0	0	21		0	0	0	190821	0	243670	19059056		
169275	3721	40213160	1968-10-18	1968-10-18 00:00:00	1968-10-18	1968-10-18 00:00:00	1968-10-18	581452		0	0	0		0	0	0	247400	0	10	40213160		
55583	4615	1713671	1955-08-26	1955-08-26 00:00:00	1955-09-16	1955-09-16 00:00:00	1955-09-16	38000177		0	0	21		0	0	0	307420	0	562251	1713671		
57864	4807	1127433	1988-07-27	1988-07-27 00:00:00	1988-08-10	1988-08-10 00:00:00	1988-08-10	38000177		0	0	14		0	0	0	319799	0	313782	1127433		
134551	2953	40213306	2005-02-11	2005-02-11 00:00:00	2005-02-11	2005-02-11 00:00:00	2005-02-11	581452		0	0	0		0	0	0	197156	0	43	40213306		
57932	4812	19133905	1997-05-27	1997-05-27 00:00:00	1997-06-06	1997-06-06 00:00:00	1997-06-06	38000177		0	0	10		0	0	0	320111	0	834102	19133905		
98904	2165	40213160	1955-08-09	1955-08-09 00:00:00	1955-08-09	1955-08-09 00:00:00	1955-08-09	581452		0	0	0		0	0	0	144194	0	10	40213160		
103334	2266	40213296	2011-07-02	2011-07-02 00:00:00	2011-07-02	2011-07-02 00:00:00	2011-07-02	581452		0	0	0		0	0	0	150657	0	52	40213296		
18570	403	40213227	1994-01-03	1994-01-03 00:00:00	1994-01-03	1994-01-03 00:00:00	1994-01-03	581452		0	0	0		0	0	0	26429	0	113	40213227		
52116	4333	1127433	1970-12-27	1970-12-27 00:00:00	1971-01-03	1971-01-03 00:00:00	1971-01-03	38000177		0	0	7		0	0	0	287355	0	313782	1127433		
22797	1874	19128022	1992-10-11	1992-10-11 00:00:00	1993-10-06	1993-10-06 00:00:00	1993-10-06	38000177		0	0	360		0	0	0	125123	0	749785	19128022		
29956	653	40213160	1956-01-06	1956-01-06 00:00:00	1956-01-06	1956-01-06 00:00:00	1956-01-06	581452		0	0	0		0	0	0	43280	0	10	40213160		
48080	3986	1127433	1973-09-24	1973-09-24 00:00:00	1973-10-01	1973-10-01 00:00:00	1973-10-01	38000177		0	0	7		0	0	0	264966	0	313782	1127433		
23282	505	40213260	2019-01-08	2019-01-08 00:00:00	2019-01-08	2019-01-08 00:00:00	2019-01-08	581452		0	0	0		0	0	0	33782	0	121	40213260		
76478	1670	40213296	2007-01-07	2007-01-07 00:00:00	2007-01-07	2007-01-07 00:00:00	2007-01-07	581452		0	0	0		0	0	0	112178	0	52	40213296		
59844	4975	19006318	1961-05-12	1961-05-12 00:00:00	1961-05-26	1961-05-26 00:00:00	1961-05-26	38000177		0	0	14		0	0	0	330873	0	105078	19006318		
59918	4979	1127433	1978-07-14	1978-07-14 00:00:00	1978-07-28	1978-07-28 00:00:00	1978-07-28	38000177		0	0	14		0	0	0	331291	0	313782	1127433		
105483	2314	40213201	2017-10-07	2017-10-07 00:00:00	2017-10-07	2017-10-07 00:00:00	2017-10-07	581452		0	0	0		0	0	0	153827	0	33	40213201		
93501	2052	40213160	1962-08-13	1962-08-13 00:00:00	1962-08-13	1962-08-13 00:00:00	1962-08-13	581452		0	0	0		0	0	0	136416	0	10	40213160		
191258	4202	40213160	1972-01-22	1972-01-22 00:00:00	1972-01-22	1972-01-22 00:00:00	1972-01-22	581452		0	0	0		0	0	0	278986	0	10	40213160		
42194	3501	19059056	1969-01-17	1969-01-17 00:00:00	1969-02-07	1969-02-07 00:00:00	1969-02-07	38000177		0	0	21		0	0	0	232079	0	243670	19059056		
19103	1577	1367571	1997-01-31	1997-01-31 00:00:00	1997-01-31	1997-01-31 00:00:00	1997-01-31	38000177		0	0	0		0	0	0	105932	0	314659	19080464		
94573	2075	40213160	1970-11-10	1970-11-10 00:00:00	1970-11-10	1970-11-10 00:00:00	1970-11-10	581452		0	0	0		0	0	0	138139	0	10	40213160		
208743	4578	40213160	1964-11-01	1964-11-01 00:00:00	1964-11-01	1964-11-01 00:00:00	1964-11-01	581452		0	0	0		0	0	0	304989	0	10	40213160		
139697	3069	40213160	1966-07-27	1966-07-27 00:00:00	1966-07-27	1966-07-27 00:00:00	1966-07-27	581452		0	0	0		0	0	0	204295	0	10	40213160		
52842	4390	40229134	1962-11-19	1962-11-19 00:00:00	1962-12-03	1962-12-03 00:00:00	1962-12-03	38000177		0	0	14		0	0	0	291812	0	1043400	40229134		
42838	3552	1713671	1999-11-02	1999-11-02 00:00:00	1999-11-23	1999-11-23 00:00:00	1999-11-23	38000177		0	0	21		0	0	0	235806	0	562251	1713671		
43682	3621	1127433	1973-12-15	1973-12-15 00:00:00	1974-01-05	1974-01-05 00:00:00	1974-01-05	38000177		0	0	21		0	0	0	240633	0	313782	1127433		
59541	4949	19059056	1973-08-28	1973-08-28 00:00:00	1973-09-11	1973-09-11 00:00:00	1973-09-11	38000177		0	0	14		0	0	0	329029	0	243670	19059056		
57320	4757	1118084	1994-10-05	1994-10-05 00:00:00	1994-10-05	1994-10-05 00:00:00	\N	38000177		0	0	0		0	0	0	316948	0	00025152531	44923712		
43812	3628	1127433	1999-03-10	1999-03-10 00:00:00	1999-03-24	1999-03-24 00:00:00	1999-03-24	38000177		0	0	14		0	0	0	241299	0	313782	1127433		
54304	4514	19128065	1992-05-03	1992-05-03 00:00:00	1993-04-28	1993-04-28 00:00:00	1993-04-28	38000177		0	0	360		0	0	0	300696	0	749882	19128065		
54346	4520	1545959	1996-09-28	1996-09-28 00:00:00	1996-09-28	1996-09-28 00:00:00	1996-09-28	38000177		0	0	0		0	0	0	300940	0	259255	1545959		
109196	2395	40213160	1964-01-24	1964-01-24 00:00:00	1964-01-24	1964-01-24 00:00:00	1964-01-24	581452		0	0	0		0	0	0	159257	0	10	40213160		
143355	3149	40213160	1955-10-31	1955-10-31 00:00:00	1955-10-31	1955-10-31 00:00:00	1955-10-31	581452		0	0	0		0	0	0	209512	0	10	40213160		
62296	5185	19059056	1938-06-30	1938-06-30 00:00:00	1938-07-14	1938-07-14 00:00:00	1938-07-14	38000177		0	0	14		0	0	0	344689	0	243670	19059056		
83674	1829	40213296	2008-07-29	2008-07-29 00:00:00	2008-07-29	2008-07-29 00:00:00	2008-07-29	581452		0	0	0		0	0	0	122297	0	52	40213296		
8171	176	40213160	1965-08-04	1965-08-04 00:00:00	1965-08-04	1965-08-04 00:00:00	1965-08-04	581452		0	0	0		0	0	0	11882	0	10	40213160		
207286	4548	40213251	1988-03-22	1988-03-22 00:00:00	1988-03-22	1988-03-22 00:00:00	1988-03-22	581452		0	0	0		0	0	0	303073	0	21	40213251		
19506	1606	19006318	1956-11-19	1956-11-19 00:00:00	1956-12-03	1956-12-03 00:00:00	1956-12-03	38000177		0	0	14		0	0	0	107824	0	105078	19006318		
32851	2721	40163554	2017-04-22	2017-04-22 00:00:00	2017-04-22	2017-04-22 00:00:00	\N	38000177		0	0	0		0	0	0	180323	0	855332	40163554		
103507	2270	40213227	2010-06-02	2010-06-02 00:00:00	2010-06-02	2010-06-02 00:00:00	2010-06-02	581452		0	0	0		0	0	0	150948	0	113	40213227		
16453	1365	19128065	1982-07-23	1982-07-23 00:00:00	1983-07-18	1983-07-18 00:00:00	1983-07-18	38000177		0	0	360		0	0	0	90485	0	749882	19128065		
16474	1365	1115171	2009-02-25	2009-02-25 00:00:00	2009-03-11	2009-03-11 00:00:00	2009-03-11	38000177		0	0	14		0	0	0	90425	0	849574	1115171		
21290	1751	1127433	2017-05-24	2017-05-24 00:00:00	2017-06-07	2017-06-07 00:00:00	2017-06-07	38000177		0	0	14		0	0	0	117051	0	313782	1127433		
48580	4024	1118084	2016-05-08	2016-05-08 00:00:00	2016-05-08	2016-05-08 00:00:00	\N	38000177		0	0	0		0	0	0	267547	0	00025152531	44923712		
48565	1062	40213160	1966-09-25	1966-09-25 00:00:00	1966-09-25	1966-09-25 00:00:00	1966-09-25	581452		0	0	0		0	0	0	69667	0	10	40213160		
54053	4491	19133905	2015-02-09	2015-02-09 00:00:00	2015-02-19	2015-02-19 00:00:00	2015-02-19	38000177		0	0	10		0	0	0	298999	0	834102	19133905		
178572	3926	40213227	2009-02-23	2009-02-23 00:00:00	2009-02-23	2009-02-23 00:00:00	2009-02-23	581452		0	0	0		0	0	0	260919	0	113	40213227		
21300	462	40213314	1977-05-26	1977-05-26 00:00:00	1977-05-26	1977-05-26 00:00:00	1977-05-26	581452		0	0	0		0	0	0	30894	0	49	40213314		
14153	1185	1118084	1978-08-06	1978-08-06 00:00:00	1978-08-06	1978-08-06 00:00:00	\N	38000177		0	0	0		0	0	0	78142	0	00025152531	44923712		
52596	4373	19019979	1978-10-06	1978-10-06 00:00:00	1978-10-20	1978-10-20 00:00:00	1978-10-20	38000177		0	0	14		0	0	0	290398	0	198405	19019979		
39184	856	40213296	2009-06-19	2009-06-19 00:00:00	2009-06-19	2009-06-19 00:00:00	2009-06-19	581452		0	0	0		0	0	0	56561	0	52	40213296		
18134	1504	40229134	1993-12-05	1993-12-05 00:00:00	1993-12-12	1993-12-12 00:00:00	1993-12-12	38000177		0	0	7		0	0	0	100271	0	1043400	40229134		
13289	287	40213227	2008-05-19	2008-05-19 00:00:00	2008-05-19	2008-05-19 00:00:00	2008-05-19	581452		0	0	0		0	0	0	19193	0	113	40213227		
138004	3030	40213314	1982-10-26	1982-10-26 00:00:00	1982-10-26	1982-10-26 00:00:00	1982-10-26	581452		0	0	0		0	0	0	202007	0	49	40213314		
100395	2200	40213160	1978-05-21	1978-05-21 00:00:00	1978-05-21	1978-05-21 00:00:00	1978-05-21	581452		0	0	0		0	0	0	146604	0	10	40213160		
13490	1131	1127433	1989-05-07	1989-05-07 00:00:00	1989-06-04	1989-06-04 00:00:00	1989-06-04	38000177		0	0	28		0	0	0	74479	0	313782	1127433		
202533	4447	40213160	1955-09-13	1955-09-13 00:00:00	1955-09-13	1955-09-13 00:00:00	1955-09-13	581452		0	0	0		0	0	0	295740	0	10	40213160		
63824	5301	19059056	1925-11-30	1925-11-30 00:00:00	1925-12-30	1925-12-30 00:00:00	1925-12-30	38000177		0	0	30		0	0	0	352658	0	243670	19059056		
235157	5166	40213160	1955-09-13	1955-09-13 00:00:00	1955-09-13	1955-09-13 00:00:00	1955-09-13	581452		0	0	0		0	0	0	343410	0	10	40213160		
55045	1206	40213306	1986-04-14	1986-04-14 00:00:00	1986-04-14	1986-04-14 00:00:00	1986-04-14	581452		0	0	0		0	0	0	79223	0	43	40213306		
28580	2356	1127433	2015-12-14	2015-12-14 00:00:00	2015-12-28	2015-12-28 00:00:00	2015-12-28	38000177		0	0	14		0	0	0	156909	0	313782	1127433		
24221	1991	1127433	1992-12-02	1992-12-02 00:00:00	1992-12-16	1992-12-16 00:00:00	1992-12-16	38000177		0	0	14		0	0	0	132610	0	313782	1127433		
34751	2869	1115171	2013-01-20	2013-01-20 00:00:00	2013-02-19	2013-02-19 00:00:00	2013-02-19	38000177		0	0	30		0	0	0	190829	0	849574	1115171		
46273	3833	1127078	1976-04-02	1976-04-02 00:00:00	1976-05-02	1976-05-02 00:00:00	1976-05-02	38000177		0	0	30		0	0	0	254526	0	282464	1127078		
55584	4615	19059056	1969-12-02	1969-12-02 00:00:00	1969-12-30	1969-12-30 00:00:00	1969-12-30	38000177		0	0	28		0	0	0	307375	0	243670	19059056		
37422	817	40213227	2008-09-25	2008-09-25 00:00:00	2008-09-25	2008-09-25 00:00:00	2008-09-25	581452		0	0	0		0	0	0	54156	0	113	40213227		
134552	2953	40213180	2005-02-11	2005-02-11 00:00:00	2005-02-11	2005-02-11 00:00:00	2005-02-11	581452		0	0	0		0	0	0	197156	0	114	40213180		
242421	5322	40213198	2012-08-15	2012-08-15 00:00:00	2012-08-15	2012-08-15 00:00:00	2012-08-15	581452		0	0	0		0	0	0	354178	0	133	40213198		
98914	2166	40213306	1993-04-25	1993-04-25 00:00:00	1993-04-25	1993-04-25 00:00:00	1993-04-25	581452		0	0	0		0	0	0	144338	0	43	40213306		
103340	2266	40213227	2001-06-16	2001-06-16 00:00:00	2001-06-16	2001-06-16 00:00:00	2001-06-16	581452		0	0	0		0	0	0	150676	0	113	40213227		
18575	403	40213201	1988-12-05	1988-12-05 00:00:00	1988-12-05	1988-12-05 00:00:00	1988-12-05	581452		0	0	0		0	0	0	26524	0	33	40213201		
52117	4333	1124300	1994-06-03	1994-06-03 00:00:00	1994-06-03	1994-06-03 00:00:00	\N	38000177		0	0	0		0	0	0	287379	0	00781178901	45011828		
22798	1874	19128065	1989-10-27	1989-10-27 00:00:00	1990-10-22	1990-10-22 00:00:00	1990-10-22	38000177		0	0	360		0	0	0	125122	0	749882	19128065		
29959	653	40213260	2007-01-05	2007-01-05 00:00:00	2007-01-05	2007-01-05 00:00:00	2007-01-05	581452		0	0	0		0	0	0	43212	0	121	40213260		
48081	3986	1127433	1987-04-11	1987-04-11 00:00:00	1987-04-25	1987-04-25 00:00:00	1987-04-25	38000177		0	0	14		0	0	0	265020	0	313782	1127433		
23284	505	40213160	1968-11-12	1968-11-12 00:00:00	1968-11-12	1968-11-12 00:00:00	1968-11-12	581452		0	0	0		0	0	0	33794	0	10	40213160		
76482	1670	40213160	1968-12-15	1968-12-15 00:00:00	1968-12-15	1968-12-15 00:00:00	1968-12-15	581452		0	0	0		0	0	0	112144	0	10	40213160		
59845	4975	1713671	1983-10-15	1983-10-15 00:00:00	1983-10-22	1983-10-22 00:00:00	1983-10-22	38000177		0	0	7		0	0	0	330870	0	562251	1713671		
59919	4979	1124300	2014-08-28	2014-08-28 00:00:00	2014-08-28	2014-08-28 00:00:00	\N	38000177		0	0	0		0	0	0	331279	0	00781178901	45011828		
105488	2315	40213251	1984-04-21	1984-04-21 00:00:00	1984-04-21	1984-04-21 00:00:00	1984-04-21	581452		0	0	0		0	0	0	153946	0	21	40213251		
93502	2052	40213160	1962-06-11	1962-06-11 00:00:00	1962-06-11	1962-06-11 00:00:00	1962-06-11	581452		0	0	0		0	0	0	136442	0	10	40213160		
191260	4202	40213306	1995-02-25	1995-02-25 00:00:00	1995-02-25	1995-02-25 00:00:00	1995-02-25	581452		0	0	0		0	0	0	\N	0	43	40213306		
42195	3501	1118084	1985-03-09	1985-03-09 00:00:00	1985-03-09	1985-03-09 00:00:00	\N	38000177		0	0	0		0	0	0	232126	0	00025152531	44923712		
19104	1577	19079524	1997-01-31	1997-01-31 00:00:00	1997-02-01	1997-02-01 00:00:00	1997-02-01	38000177		0	0	1		0	0	0	105932	0	313002	19079524		
94578	2075	40213260	2016-06-21	2016-06-21 00:00:00	2016-06-21	2016-06-21 00:00:00	2016-06-21	581452		0	0	0		0	0	0	138129	0	121	40213260		
208745	4578	40213296	2004-05-30	2004-05-30 00:00:00	2004-05-30	2004-05-30 00:00:00	2004-05-30	581452		0	0	0		0	0	0	304937	0	52	40213296		
139701	3069	40213296	2002-03-06	2002-03-06 00:00:00	2002-03-06	2002-03-06 00:00:00	2002-03-06	581452		0	0	0		0	0	0	204267	0	52	40213296		
52843	4390	19128065	1977-01-12	1977-01-12 00:00:00	1978-01-07	1978-01-07 00:00:00	1978-01-07	38000177		0	0	360		0	0	0	291836	0	749882	19128065		
42839	3552	19006318	1957-07-13	1957-07-13 00:00:00	1957-07-27	1957-07-27 00:00:00	1957-07-27	38000177		0	0	14		0	0	0	235853	0	105078	19006318		
43683	3621	1127433	1963-12-08	1963-12-08 00:00:00	1964-03-07	1964-03-07 00:00:00	1964-03-07	38000177		0	0	90		0	0	0	240632	0	313782	1127433		
59542	4949	46233988	1973-08-28	1973-08-28 00:00:00	1973-09-11	1973-09-11 00:00:00	1973-09-11	38000177		0	0	14		0	0	0	329029	0	1652673	46233988		
21142	1743	1124300	2002-01-15	2002-01-15 00:00:00	2002-01-15	2002-01-15 00:00:00	\N	38000177		0	0	0		0	0	0	116494	0	00781178901	45011828		
43813	3628	1124300	1954-03-07	1954-03-07 00:00:00	1954-03-07	1954-03-07 00:00:00	\N	38000177		0	0	0		0	0	0	241370	0	00781178901	45011828		
54305	4514	19128065	1989-05-19	1989-05-19 00:00:00	1990-05-14	1990-05-14 00:00:00	1990-05-14	38000177		0	0	360		0	0	0	300664	0	749882	19128065		
54347	4520	19126352	1991-01-05	1991-01-05 00:00:00	1996-09-28	1996-09-28 00:00:00	1996-09-28	38000177		0	0	2093		0	0	0	300927	0	705129	19126352		
109197	2395	40213160	1959-05-22	1959-05-22 00:00:00	1959-05-22	1959-05-22 00:00:00	1959-05-22	581452		0	0	0		0	0	0	159275	0	10	40213160		
143358	3149	40213201	2017-05-22	2017-05-22 00:00:00	2017-05-22	2017-05-22 00:00:00	2017-05-22	581452		0	0	0		0	0	0	209523	0	33	40213201		
62297	5185	40229134	2012-03-23	2012-03-23 00:00:00	2012-03-30	2012-03-30 00:00:00	2012-03-30	38000177		0	0	7		0	0	0	344708	0	1043400	40229134		
195906	4305	40213260	2009-11-20	2009-11-20 00:00:00	2009-11-20	2009-11-20 00:00:00	2009-11-20	581452		0	0	0		0	0	0	285547	0	121	40213260		
8174	176	40213260	2014-11-26	2014-11-26 00:00:00	2014-11-26	2014-11-26 00:00:00	2014-11-26	581452		0	0	0		0	0	0	11920	0	121	40213260		
207288	4548	40213160	1988-03-22	1988-03-22 00:00:00	1988-03-22	1988-03-22 00:00:00	1988-03-22	581452		0	0	0		0	0	0	303073	0	10	40213160		
19507	1606	40229134	2000-12-28	2000-12-28 00:00:00	2001-01-04	2001-01-04 00:00:00	2001-01-04	38000177		0	0	7		0	0	0	107859	0	1043400	40229134		
32852	2721	1713671	2016-06-14	2016-06-14 00:00:00	2016-06-28	2016-06-28 00:00:00	2016-06-28	38000177		0	0	14		0	0	0	180330	0	562251	1713671		
103508	2270	40213160	1983-02-23	1983-02-23 00:00:00	1983-02-23	1983-02-23 00:00:00	1983-02-23	581452		0	0	0		0	0	0	150962	0	10	40213160		
35328	771	40213160	1959-08-19	1959-08-19 00:00:00	1959-08-19	1959-08-19 00:00:00	1959-08-19	581452		0	0	0		0	0	0	51235	0	10	40213160		
16476	1365	19133905	2007-11-22	2007-11-22 00:00:00	2007-11-30	2007-11-30 00:00:00	2007-11-30	38000177		0	0	8		0	0	0	90507	0	834102	19133905		
21291	1751	19133873	1985-06-20	1985-06-20 00:00:00	1985-06-29	1985-06-29 00:00:00	1985-06-29	38000177		0	0	9		0	0	0	117098	0	834061	19133873		
48581	4024	40229134	2006-04-29	2006-04-29 00:00:00	2006-05-13	2006-05-13 00:00:00	2006-05-13	38000177		0	0	14		0	0	0	267558	0	1043400	40229134		
125386	2758	40213227	2001-10-26	2001-10-26 00:00:00	2001-10-26	2001-10-26 00:00:00	2001-10-26	581452		0	0	0		0	0	0	182393	0	113	40213227		
54054	4491	40173590	2006-07-09	2006-07-09 00:00:00	2006-07-09	2006-07-09 00:00:00	\N	38000177		0	0	0		0	0	0	299006	0	904419	40173590		
178578	3926	40213160	1955-07-25	1955-07-25 00:00:00	1955-07-25	1955-07-25 00:00:00	1955-07-25	581452		0	0	0		0	0	0	260939	0	10	40213160		
32580	710	40213296	2001-04-24	2001-04-24 00:00:00	2001-04-24	2001-04-24 00:00:00	2001-04-24	581452		0	0	0		0	0	0	47020	0	52	40213296		
14154	1185	40229134	2012-08-30	2012-08-30 00:00:00	2012-09-13	2012-09-13 00:00:00	2012-09-13	38000177		0	0	14		0	0	0	78107	0	1043400	40229134		
52597	4374	1127078	1978-08-27	1978-08-27 00:00:00	1978-09-10	1978-09-10 00:00:00	1978-09-10	38000177		0	0	14		0	0	0	290485	0	282464	1127078		
60189	5002	19074843	1985-11-05	1985-11-05 00:00:00	1985-11-19	1985-11-19 00:00:00	1985-11-19	38000177		0	0	14		0	0	0	332719	0	309045	19074843		
18135	1504	1713671	1989-03-01	1989-03-01 00:00:00	1989-03-08	1989-03-08 00:00:00	1989-03-08	38000177		0	0	7		0	0	0	100241	0	562251	1713671		
13291	287	40213160	1981-01-18	1981-01-18 00:00:00	1981-01-18	1981-01-18 00:00:00	1981-01-18	581452		0	0	0		0	0	0	19203	0	10	40213160		
63047	5239	19133905	2001-01-20	2001-01-20 00:00:00	2001-01-29	2001-01-29 00:00:00	2001-01-29	38000177		0	0	9		0	0	0	348548	0	834102	19133905		
100399	2200	40213160	1973-11-18	1973-11-18 00:00:00	1973-11-18	1973-11-18 00:00:00	1973-11-18	581452		0	0	0		0	0	0	146602	0	10	40213160		
13491	1131	19059056	1967-07-15	1967-07-15 00:00:00	1967-07-29	1967-07-29 00:00:00	1967-07-29	38000177		0	0	14		0	0	0	74426	0	243670	19059056		
202540	4447	40213160	1955-01-25	1955-01-25 00:00:00	1955-01-25	1955-01-25 00:00:00	1955-01-25	581452		0	0	0		0	0	0	295764	0	10	40213160		
63825	5301	19059056	1923-05-30	1923-05-30 00:00:00	1923-06-13	1923-06-13 00:00:00	1923-06-13	38000177		0	0	14		0	0	0	352745	0	243670	19059056		
235159	5166	40213160	1957-03-19	1957-03-19 00:00:00	1957-03-19	1957-03-19 00:00:00	1957-03-19	581452		0	0	0		0	0	0	343411	0	10	40213160		
68702	1504	40213201	2008-03-04	2008-03-04 00:00:00	2008-03-04	2008-03-04 00:00:00	2008-03-04	581452		0	0	0		0	0	0	100222	0	33	40213201		
28581	2356	1115171	1998-12-26	1998-12-26 00:00:00	1999-01-30	1999-01-30 00:00:00	1999-01-30	38000177		0	0	35		0	0	0	156927	0	849574	1115171		
24222	1991	40229134	1954-09-14	1954-09-14 00:00:00	1954-09-28	1954-09-28 00:00:00	1954-09-28	38000177		0	0	14		0	0	0	132555	0	1043400	40229134		
34752	2869	40231925	2013-01-20	2013-01-20 00:00:00	2013-01-20	2013-01-20 00:00:00	\N	38000177		0	0	0		0	0	0	190829	0	1049221	40231925		
46274	3833	1127433	2018-08-18	2018-08-18 00:00:00	2018-09-01	2018-09-01 00:00:00	2018-09-01	38000177		0	0	14		0	0	0	254500	0	313782	1127433		
55585	4615	19073188	1984-01-09	1984-01-09 00:00:00	1984-01-23	1984-01-23 00:00:00	1984-01-23	38000177		0	0	14		0	0	0	307409	0	308192	19073188		
37423	817	40213260	2008-09-25	2008-09-25 00:00:00	2008-09-25	2008-09-25 00:00:00	2008-09-25	581452		0	0	0		0	0	0	54156	0	121	40213260		
39307	3248	19133905	2007-04-03	2007-04-03 00:00:00	2007-04-15	2007-04-15 00:00:00	2007-04-15	38000177		0	0	12		0	0	0	215857	0	834102	19133905		
242435	5322	40213227	2018-07-25	2018-07-25 00:00:00	2018-07-25	2018-07-25 00:00:00	2018-07-25	581452		0	0	0		0	0	0	354203	0	113	40213227		
98916	2166	40213227	1993-04-25	1993-04-25 00:00:00	1993-04-25	1993-04-25 00:00:00	1993-04-25	581452		0	0	0		0	0	0	144338	0	113	40213227		
103346	2266	40213306	1991-11-16	1991-11-16 00:00:00	1991-11-16	1991-11-16 00:00:00	1991-11-16	581452		0	0	0		0	0	0	150666	0	43	40213306		
10858	232	40213227	2016-01-06	2016-01-06 00:00:00	2016-01-06	2016-01-06 00:00:00	2016-01-06	581452		0	0	0		0	0	0	15549	0	113	40213227		
52118	4333	19059056	1955-11-15	1955-11-15 00:00:00	1955-11-29	1955-11-29 00:00:00	1955-11-29	38000177		0	0	14		0	0	0	287419	0	243670	19059056		
22799	1874	1127433	1987-06-22	1987-06-22 00:00:00	1987-07-06	1987-07-06 00:00:00	1987-07-06	38000177		0	0	14		0	0	0	125131	0	313782	1127433		
29971	653	40213160	1955-01-07	1955-01-07 00:00:00	1955-01-07	1955-01-07 00:00:00	1955-01-07	581452		0	0	0		0	0	0	43270	0	10	40213160		
48082	3986	19133873	1967-02-27	1967-02-27 00:00:00	1967-03-08	1967-03-08 00:00:00	1967-03-08	38000177		0	0	9		0	0	0	264985	0	834061	19133873		
23287	505	40213227	1992-01-28	1992-01-28 00:00:00	1992-01-28	1992-01-28 00:00:00	1992-01-28	581452		0	0	0		0	0	0	33773	0	113	40213227		
76495	1670	40213160	1964-06-14	1964-06-14 00:00:00	1964-06-14	1964-06-14 00:00:00	1964-06-14	581452		0	0	0		0	0	0	112141	0	10	40213160		
59846	4975	1127078	1960-04-16	1960-04-16 00:00:00	1960-04-30	1960-04-30 00:00:00	1960-04-30	38000177		0	0	14		0	0	0	330848	0	282464	1127078		
59920	4979	19128022	1995-06-24	1995-06-24 00:00:00	1996-06-18	1996-06-18 00:00:00	1996-06-18	38000177		0	0	360		0	0	0	331274	0	749785	19128022		
105493	2315	40213227	1999-11-13	1999-11-13 00:00:00	1999-11-13	1999-11-13 00:00:00	1999-11-13	581452		0	0	0		0	0	0	153960	0	113	40213227		
93512	2052	40213260	2012-03-05	2012-03-05 00:00:00	2012-03-05	2012-03-05 00:00:00	2012-03-05	581452		0	0	0		0	0	0	136459	0	121	40213260		
191266	4202	40213227	2002-11-16	2002-11-16 00:00:00	2002-11-16	2002-11-16 00:00:00	2002-11-16	581452		0	0	0		0	0	0	278948	0	113	40213227		
42196	3501	19133873	1957-09-01	1957-09-01 00:00:00	1957-09-13	1957-09-13 00:00:00	1957-09-13	38000177		0	0	12		0	0	0	232120	0	834061	19133873		
19105	1577	40220386	1997-01-31	1997-01-31 00:00:00	1997-01-31	1997-01-31 00:00:00	1997-01-31	38000177		0	0	0		0	0	0	105932	0	1808217	40220386		
94584	2075	40213160	1966-03-08	1966-03-08 00:00:00	1966-03-08	1966-03-08 00:00:00	1966-03-08	581452		0	0	0		0	0	0	138023	0	10	40213160		
161459	3552	40213260	2007-05-24	2007-05-24 00:00:00	2007-05-24	2007-05-24 00:00:00	2007-05-24	581452		0	0	0		0	0	0	235801	0	121	40213260		
139708	3069	40213160	1962-04-25	1962-04-25 00:00:00	1962-04-25	1962-04-25 00:00:00	1962-04-25	581452		0	0	0		0	0	0	204257	0	10	40213160		
52844	4391	45892894	2016-06-20	2016-06-20 00:00:00	2016-06-20	2016-06-20 00:00:00	\N	38000177		0	0	0		0	0	0	292012	0	1599803	45892894		
42840	3552	19059056	1957-07-13	1957-07-13 00:00:00	1957-07-27	1957-07-27 00:00:00	1957-07-27	38000177		0	0	14		0	0	0	235853	0	243670	19059056		
43684	3621	40231925	1963-12-08	1963-12-08 00:00:00	1963-12-08	1963-12-08 00:00:00	\N	38000177		0	0	0		0	0	0	240632	0	1049221	40231925		
19903	432	40213227	2011-06-06	2011-06-06 00:00:00	2011-06-06	2011-06-06 00:00:00	2011-06-06	581452		0	0	0		0	0	0	28703	0	113	40213227		
21143	1743	1127433	1968-03-20	1968-03-20 00:00:00	1968-04-03	1968-04-03 00:00:00	1968-04-03	38000177		0	0	14		0	0	0	116532	0	313782	1127433		
43814	3628	40229134	1931-02-06	1931-02-06 00:00:00	1931-02-20	1931-02-20 00:00:00	1931-02-20	38000177		0	0	14		0	0	0	241358	0	1043400	40229134		
54306	4514	40232448	1976-06-28	1976-06-28 00:00:00	1976-06-28	1976-06-28 00:00:00	\N	38000177		0	0	0		0	0	0	300670	0	1049630	40232448		
54348	4520	1127433	1981-02-24	1981-02-24 00:00:00	1981-03-10	1981-03-10 00:00:00	1981-03-10	38000177		0	0	14		0	0	0	300874	0	313782	1127433		
109198	2395	40213296	2001-02-23	2001-02-23 00:00:00	2001-02-23	2001-02-23 00:00:00	2001-02-23	581452		0	0	0		0	0	0	159288	0	52	40213296		
143361	3149	40213198	2016-05-16	2016-05-16 00:00:00	2016-05-16	2016-05-16 00:00:00	2016-05-16	581452		0	0	0		0	0	0	209561	0	133	40213198		
62298	5185	19133905	2014-10-27	2014-10-27 00:00:00	2014-11-04	2014-11-04 00:00:00	2014-11-04	38000177		0	0	8		0	0	0	344700	0	834102	19133905		
195909	4305	40213260	2008-11-14	2008-11-14 00:00:00	2008-11-14	2008-11-14 00:00:00	2008-11-14	581452		0	0	0		0	0	0	285634	0	121	40213260		
8178	176	40213306	1986-09-03	1986-09-03 00:00:00	1986-09-03	1986-09-03 00:00:00	1986-09-03	581452		0	0	0		0	0	0	11930	0	43	40213306		
207291	4548	40213314	1984-01-24	1984-01-24 00:00:00	1984-01-24	1984-01-24 00:00:00	1984-01-24	581452		0	0	0		0	0	0	303012	0	49	40213314		
19508	1606	19133873	1958-06-12	1958-06-12 00:00:00	1958-06-25	1958-06-25 00:00:00	1958-06-25	38000177		0	0	13		0	0	0	107879	0	834061	19133873		
32853	2721	1713671	1973-01-19	1973-01-19 00:00:00	1973-02-02	1973-02-02 00:00:00	1973-02-02	38000177		0	0	14		0	0	0	180308	0	562251	1713671		
103516	2270	40213306	2001-05-23	2001-05-23 00:00:00	2001-05-23	2001-05-23 00:00:00	2001-05-23	581452		0	0	0		0	0	0	150967	0	43	40213306		
35331	771	40213160	1959-03-18	1959-03-18 00:00:00	1959-03-18	1959-03-18 00:00:00	1959-03-18	581452		0	0	0		0	0	0	51243	0	10	40213160		
16487	1367	19128065	1983-04-06	1983-04-06 00:00:00	1984-03-31	1984-03-31 00:00:00	1984-03-31	38000177		0	0	360		0	0	0	90604	0	749882	19128065		
21292	1751	19133873	1990-05-07	1990-05-07 00:00:00	1990-05-17	1990-05-17 00:00:00	1990-05-17	38000177		0	0	10		0	0	0	117058	0	834061	19133873		
48582	4024	1713671	1997-09-29	1997-09-29 00:00:00	1997-10-20	1997-10-20 00:00:00	1997-10-20	38000177		0	0	21		0	0	0	267509	0	562251	1713671		
28945	2392	1127433	1984-02-24	1984-02-24 00:00:00	1984-03-09	1984-03-09 00:00:00	1984-03-09	38000177		0	0	14		0	0	0	159045	0	313782	1127433		
54055	4491	920300	1976-02-22	1976-02-22 00:00:00	1976-02-29	1976-02-29 00:00:00	1976-02-29	38000177		0	0	7		0	0	0	298967	0	311989	920300		
3671	304	1115171	2017-12-07	2017-12-07 00:00:00	2018-01-13	2018-01-13 00:00:00	2018-01-13	38000177		0	0	37		0	0	0	20257	0	849574	1115171		
32584	710	40213227	2012-04-24	2012-04-24 00:00:00	2012-04-24	2012-04-24 00:00:00	2012-04-24	581452		0	0	0		0	0	0	47000	0	113	40213227		
14155	1185	1713671	1983-09-22	1983-09-22 00:00:00	1983-09-29	1983-09-29 00:00:00	1983-09-29	38000177		0	0	7		0	0	0	78161	0	562251	1713671		
52598	4374	19129655	1978-08-27	1978-08-27 00:00:00	1978-09-10	1978-09-10 00:00:00	1978-09-10	38000177		0	0	14		0	0	0	290485	0	789980	19129655		
60190	5002	19019979	1985-11-05	1985-11-05 00:00:00	1985-11-19	1985-11-19 00:00:00	1985-11-19	38000177		0	0	14		0	0	0	332719	0	198405	19019979		
18136	1504	40229134	2004-10-17	2004-10-17 00:00:00	2004-10-31	2004-10-31 00:00:00	2004-10-31	38000177		0	0	14		0	0	0	100278	0	1043400	40229134		
50529	1107	40213227	1998-03-20	1998-03-20 00:00:00	1998-03-20	1998-03-20 00:00:00	1998-03-20	581452		0	0	0		0	0	0	72886	0	113	40213227		
63048	5239	1127078	1972-08-19	1972-08-19 00:00:00	1972-10-18	1972-10-18 00:00:00	1972-10-18	38000177		0	0	60		0	0	0	348556	0	282464	1127078		
100401	2200	40213227	2004-12-26	2004-12-26 00:00:00	2004-12-26	2004-12-26 00:00:00	2004-12-26	581452		0	0	0		0	0	0	146680	0	113	40213227		
13492	1131	46233988	1967-07-15	1967-07-15 00:00:00	1967-07-29	1967-07-29 00:00:00	1967-07-29	38000177		0	0	14		0	0	0	74426	0	1652673	46233988		
202550	4447	40213198	2017-01-24	2017-01-24 00:00:00	2017-01-24	2017-01-24 00:00:00	2017-01-24	581452		0	0	0		0	0	0	295711	0	133	40213198		
63826	5301	40229134	1974-06-14	1974-06-14 00:00:00	1974-06-21	1974-06-21 00:00:00	1974-06-21	38000177		0	0	7		0	0	0	352731	0	1043400	40229134		
235162	5166	40213198	2017-05-30	2017-05-30 00:00:00	2017-05-30	2017-05-30 00:00:00	2017-05-30	581452		0	0	0		0	0	0	343491	0	133	40213198		
68720	1504	40213227	1992-06-16	1992-06-16 00:00:00	1992-06-16	1992-06-16 00:00:00	1992-06-16	581452		0	0	0		0	0	0	100231	0	113	40213227		
28582	2356	40236446	1988-10-30	1988-10-30 00:00:00	1990-06-17	1990-06-17 00:00:00	1990-06-17	38000177		0	0	595		0	0	0	156899	0	1091392	40236446		
24223	1991	40229134	1965-12-03	1965-12-03 00:00:00	1965-12-10	1965-12-10 00:00:00	1965-12-10	38000177		0	0	7		0	0	0	132603	0	1043400	40229134		
34753	2869	1127433	1968-12-16	1968-12-16 00:00:00	1968-12-30	1968-12-30 00:00:00	1968-12-30	38000177		0	0	14		0	0	0	190825	0	313782	1127433		
46275	3834	19133905	2005-03-09	2005-03-09 00:00:00	2005-03-18	2005-03-18 00:00:00	2005-03-18	38000177		0	0	9		0	0	0	254553	0	834102	19133905		
55586	4615	19078461	1984-01-09	1984-01-09 00:00:00	1984-01-23	1984-01-23 00:00:00	1984-01-23	38000177		0	0	14		0	0	0	307409	0	310965	19078461		
37428	817	40213160	1957-10-24	1957-10-24 00:00:00	1957-10-24	1957-10-24 00:00:00	1957-10-24	581452		0	0	0		0	0	0	54153	0	10	40213160		
39308	3248	40163554	2007-03-30	2007-03-30 00:00:00	2007-03-30	2007-03-30 00:00:00	\N	38000177		0	0	0		0	0	0	215888	0	855332	40163554		
27996	2318	1367571	1969-03-09	1969-03-09 00:00:00	1969-03-09	1969-03-09 00:00:00	1969-03-09	38000177		0	0	0		0	0	0	154115	0	314659	19080464		
98917	2166	40213160	1973-12-23	1973-12-23 00:00:00	1973-12-23	1973-12-23 00:00:00	1973-12-23	581452		0	0	0		0	0	0	144329	0	10	40213160		
103349	2266	40213296	2009-06-27	2009-06-27 00:00:00	2009-06-27	2009-06-27 00:00:00	2009-06-27	581452		0	0	0		0	0	0	150669	0	52	40213296		
10865	232	40213227	1995-11-08	1995-11-08 00:00:00	1995-11-08	1995-11-08 00:00:00	1995-11-08	581452		0	0	0		0	0	0	15610	0	113	40213227		
52119	4333	40229134	1983-08-27	1983-08-27 00:00:00	1983-09-10	1983-09-10 00:00:00	1983-09-10	38000177		0	0	14		0	0	0	287416	0	1043400	40229134		
22800	1874	1127433	2000-11-27	2000-11-27 00:00:00	2000-12-11	2000-12-11 00:00:00	2000-12-11	38000177		0	0	14		0	0	0	125120	0	313782	1127433		
29974	653	40213227	2004-12-24	2004-12-24 00:00:00	2004-12-24	2004-12-24 00:00:00	2004-12-24	581452		0	0	0		0	0	0	43211	0	113	40213227		
48083	3986	1115171	2014-08-18	2014-08-18 00:00:00	2014-09-08	2014-09-08 00:00:00	2014-09-08	38000177		0	0	21		0	0	0	265025	0	849574	1115171		
23288	505	40213306	1992-01-28	1992-01-28 00:00:00	1992-01-28	1992-01-28 00:00:00	1992-01-28	581452		0	0	0		0	0	0	33773	0	43	40213306		
76497	1670	40213260	2014-01-26	2014-01-26 00:00:00	2014-01-26	2014-01-26 00:00:00	2014-01-26	581452		0	0	0		0	0	0	112126	0	121	40213260		
59847	4975	19006318	1960-04-16	1960-04-16 00:00:00	1960-04-30	1960-04-30 00:00:00	1960-04-30	38000177		0	0	14		0	0	0	330848	0	105078	19006318		
149831	3295	40213227	1993-05-17	1993-05-17 00:00:00	1993-05-17	1993-05-17 00:00:00	1993-05-17	581452		0	0	0		0	0	0	218977	0	113	40213227		
105494	2315	40213306	1999-11-13	1999-11-13 00:00:00	1999-11-13	1999-11-13 00:00:00	1999-11-13	581452		0	0	0		0	0	0	153960	0	43	40213306		
93517	2052	40213296	2002-12-16	2002-12-16 00:00:00	2002-12-16	2002-12-16 00:00:00	2002-12-16	581452		0	0	0		0	0	0	136454	0	52	40213296		
191270	4202	40213296	2011-05-21	2011-05-21 00:00:00	2011-05-21	2011-05-21 00:00:00	2011-05-21	581452		0	0	0		0	0	0	278959	0	52	40213296		
124144	2731	40213260	2010-07-12	2010-07-12 00:00:00	2010-07-12	2010-07-12 00:00:00	2010-07-12	581452		0	0	0		0	0	0	180813	0	121	40213260		
19106	1577	46275444	1997-01-31	1997-01-31 00:00:00	1997-01-31	1997-01-31 00:00:00	1997-01-31	38000177		0	0	0		0	0	0	105932	0	1659149	46275444		
94585	2075	40213160	1966-05-10	1966-05-10 00:00:00	1966-05-10	1966-05-10 00:00:00	1966-05-10	581452		0	0	0		0	0	0	138136	0	10	40213160		
161460	3552	40213160	1957-04-25	1957-04-25 00:00:00	1957-04-25	1957-04-25 00:00:00	1957-04-25	581452		0	0	0		0	0	0	235857	0	10	40213160		
139711	3069	40213227	1994-02-23	1994-02-23 00:00:00	1994-02-23	1994-02-23 00:00:00	1994-02-23	581452		0	0	0		0	0	0	204277	0	113	40213227		
52845	4391	19078461	1987-02-20	1987-02-20 00:00:00	1987-03-20	1987-03-20 00:00:00	1987-03-20	38000177		0	0	28		0	0	0	291940	0	310965	19078461		
42841	3552	1127433	2016-08-30	2016-08-30 00:00:00	2016-09-06	2016-09-06 00:00:00	2016-09-06	38000177		0	0	7		0	0	0	235851	0	313782	1127433		
43685	3621	1127433	1989-01-16	1989-01-16 00:00:00	1989-03-17	1989-03-17 00:00:00	1989-03-17	38000177		0	0	60		0	0	0	240634	0	313782	1127433		
160377	3529	40213227	2005-08-10	2005-08-10 00:00:00	2005-08-10	2005-08-10 00:00:00	2005-08-10	581452		0	0	0		0	0	0	234298	0	113	40213227		
21144	1743	19059056	1967-11-20	1967-11-20 00:00:00	1967-12-11	1967-12-11 00:00:00	1967-12-11	38000177		0	0	21		0	0	0	116507	0	243670	19059056		
43815	3628	1545959	2006-08-19	2006-08-19 00:00:00	2006-08-19	2006-08-19 00:00:00	2006-08-19	38000177		0	0	0		0	0	0	241357	0	259255	1545959		
54307	4514	1713671	1981-10-23	1981-10-23 00:00:00	1981-11-06	1981-11-06 00:00:00	1981-11-06	38000177		0	0	14		0	0	0	300650	0	562251	1713671		
54349	4520	19133873	1940-04-04	1940-04-04 00:00:00	1940-04-12	1940-04-12 00:00:00	1940-04-12	38000177		0	0	8		0	0	0	300944	0	834061	19133873		
109200	2395	40213227	2001-02-23	2001-02-23 00:00:00	2001-02-23	2001-02-23 00:00:00	2001-02-23	581452		0	0	0		0	0	0	159288	0	113	40213227		
143369	3149	40213227	2012-04-23	2012-04-23 00:00:00	2012-04-23	2012-04-23 00:00:00	2012-04-23	581452		0	0	0		0	0	0	209492	0	113	40213227		
62299	5185	19133873	1949-10-25	1949-10-25 00:00:00	1949-11-07	1949-11-07 00:00:00	1949-11-07	38000177		0	0	13		0	0	0	344648	0	834061	19133873		
195912	4305	40213227	1999-10-22	1999-10-22 00:00:00	1999-10-22	1999-10-22 00:00:00	1999-10-22	581452		0	0	0		0	0	0	285545	0	113	40213227		
8181	176	40213296	2006-10-04	2006-10-04 00:00:00	2006-10-04	2006-10-04 00:00:00	2006-10-04	581452		0	0	0		0	0	0	11919	0	52	40213296		
207292	4548	40213160	1984-01-24	1984-01-24 00:00:00	1984-01-24	1984-01-24 00:00:00	1984-01-24	581452		0	0	0		0	0	0	303012	0	10	40213160		
19509	1606	19059056	1964-05-14	1964-05-14 00:00:00	1964-07-13	1964-07-13 00:00:00	1964-07-13	38000177		0	0	60		0	0	0	107855	0	243670	19059056		
551	40	1713671	1998-10-12	1998-10-12 00:00:00	1998-10-26	1998-10-26 00:00:00	1998-10-26	38000177		0	0	14		0	0	0	2873	0	562251	1713671		
103518	2270	40213227	2001-05-23	2001-05-23 00:00:00	2001-05-23	2001-05-23 00:00:00	2001-05-23	581452		0	0	0		0	0	0	150967	0	113	40213227		
35339	771	40213227	1993-07-14	1993-07-14 00:00:00	1993-07-14	1993-07-14 00:00:00	1993-07-14	581452		0	0	0		0	0	0	51218	0	113	40213227		
16488	1367	1127078	1969-03-15	1969-03-15 00:00:00	1969-06-13	1969-06-13 00:00:00	1969-06-13	38000177		0	0	90		0	0	0	90620	0	282464	1127078		
21293	1751	1127433	2008-04-02	2008-04-02 00:00:00	2008-04-09	2008-04-09 00:00:00	2008-04-09	38000177		0	0	7		0	0	0	117097	0	313782	1127433		
48583	4024	40224805	1995-01-14	1995-01-14 00:00:00	1996-01-09	1996-01-09 00:00:00	1996-01-09	38000177		0	0	360		0	0	0	267560	0	1000126	40224805		
28946	2392	19059056	1919-09-16	1919-09-16 00:00:00	1919-09-30	1919-09-30 00:00:00	1919-09-30	38000177		0	0	14		0	0	0	159047	0	243670	19059056		
54056	4491	40236824	1976-02-22	1976-02-22 00:00:00	1976-02-29	1976-02-29 00:00:00	1976-02-29	38000177		0	0	7		0	0	0	298967	0	1094107	40236824		
3672	304	19133905	2005-09-14	2005-09-14 00:00:00	2005-09-23	2005-09-23 00:00:00	2005-09-23	38000177		0	0	9		0	0	0	20254	0	834102	19133905		
32585	710	40213260	2012-04-24	2012-04-24 00:00:00	2012-04-24	2012-04-24 00:00:00	2012-04-24	581452		0	0	0		0	0	0	47000	0	121	40213260		
14156	1185	19059056	1971-05-30	1971-05-30 00:00:00	1971-06-20	1971-06-20 00:00:00	1971-06-20	38000177		0	0	21		0	0	0	78147	0	243670	19059056		
1833	40	40213201	2018-06-27	2018-06-27 00:00:00	2018-06-27	2018-06-27 00:00:00	2018-06-27	581452		0	0	0		0	0	0	2861	0	33	40213201		
60191	5002	1127433	1996-03-30	1996-03-30 00:00:00	1996-06-28	1996-06-28 00:00:00	1996-06-28	38000177		0	0	90		0	0	0	332714	0	313782	1127433		
59285	4927	19128065	1996-06-22	1996-06-22 00:00:00	1997-06-17	1997-06-17 00:00:00	1997-06-17	38000177		0	0	360		0	0	0	327448	0	749882	19128065		
50546	1107	40213201	1993-02-19	1993-02-19 00:00:00	1993-02-19	1993-02-19 00:00:00	1993-02-19	581452		0	0	0		0	0	0	72878	0	33	40213201		
63049	5239	46233988	1970-10-12	1970-10-12 00:00:00	1970-10-26	1970-10-26 00:00:00	1970-10-26	38000177		0	0	14		0	0	0	348573	0	1652673	46233988		
100407	2200	40213227	2015-06-21	2015-06-21 00:00:00	2015-06-21	2015-06-21 00:00:00	2015-06-21	581452		0	0	0		0	0	0	146712	0	113	40213227		
13493	1131	40229134	1988-01-22	1988-01-22 00:00:00	1988-02-05	1988-02-05 00:00:00	1988-02-05	38000177		0	0	14		0	0	0	74444	0	1043400	40229134		
202559	4447	40213227	2002-08-27	2002-08-27 00:00:00	2002-08-27	2002-08-27 00:00:00	2002-08-27	581452		0	0	0		0	0	0	295751	0	113	40213227		
63827	5301	19018935	1999-01-07	1999-01-07 00:00:00	1999-01-07	1999-01-07 00:00:00	\N	38000177		0	0	0		0	0	0	352693	0	197604	19018935		
81321	1778	40213227	2002-07-20	2002-07-20 00:00:00	2002-07-20	2002-07-20 00:00:00	2002-07-20	581452		0	0	0		0	0	0	118965	0	113	40213227		
68733	1505	40213160	1955-02-12	1955-02-12 00:00:00	1955-02-12	1955-02-12 00:00:00	1955-02-12	581452		0	0	0		0	0	0	100360	0	10	40213160		
28583	2356	1127078	1984-06-28	1984-06-28 00:00:00	1984-07-12	1984-07-12 00:00:00	1984-07-12	38000177		0	0	14		0	0	0	156926	0	282464	1127078		
24224	1991	19059056	1958-07-15	1958-07-15 00:00:00	1958-10-13	1958-10-13 00:00:00	1958-10-13	38000177		0	0	90		0	0	0	132607	0	243670	19059056		
34754	2869	1127433	1991-05-06	1991-05-06 00:00:00	1991-05-20	1991-05-20 00:00:00	1991-05-20	38000177		0	0	14		0	0	0	190863	0	313782	1127433		
46276	3834	1127433	1967-06-15	1967-06-15 00:00:00	1967-06-29	1967-06-29 00:00:00	1967-06-29	38000177		0	0	14		0	0	0	254620	0	313782	1127433		
236474	5193	40213260	2010-08-26	2010-08-26 00:00:00	2010-08-26	2010-08-26 00:00:00	2010-08-26	581452		0	0	0		0	0	0	345228	0	121	40213260		
37435	817	40213260	2007-09-20	2007-09-20 00:00:00	2007-09-20	2007-09-20 00:00:00	2007-09-20	581452		0	0	0		0	0	0	54120	0	121	40213260		
39309	3248	19018935	2007-03-30	2007-03-30 00:00:00	2007-03-30	2007-03-30 00:00:00	\N	38000177		0	0	0		0	0	0	215888	0	197604	19018935		
27997	2318	19079524	1969-03-09	1969-03-09 00:00:00	1969-03-09	1969-03-09 00:00:00	1969-03-09	38000177		0	0	0		0	0	0	154115	0	313002	19079524		
98923	2166	40213260	2019-06-09	2019-06-09 00:00:00	2019-06-09	2019-06-09 00:00:00	2019-06-09	581452		0	0	0		0	0	0	144302	0	121	40213260		
103355	2266	40213260	2018-12-15	2018-12-15 00:00:00	2018-12-15	2018-12-15 00:00:00	2018-12-15	581452		0	0	0		0	0	0	150680	0	121	40213260		
10871	232	40213201	2010-12-08	2010-12-08 00:00:00	2010-12-08	2010-12-08 00:00:00	2010-12-08	581452		0	0	0		0	0	0	15560	0	33	40213201		
62583	5203	19133768	1999-02-17	1999-02-17 00:00:00	1999-02-17	1999-02-17 00:00:00	1999-02-17	38000177		0	0	0		0	0	0	346136	0	833036	19133768		
56583	4694	920300	2015-08-29	2015-08-29 00:00:00	2015-09-05	2015-09-05 00:00:00	2015-09-05	38000177		0	0	7		0	0	0	312677	0	311989	920300		
29978	653	40213160	1958-01-10	1958-01-10 00:00:00	1958-01-10	1958-01-10 00:00:00	1958-01-10	581452		0	0	0		0	0	0	43218	0	10	40213160		
48084	3986	19115351	2009-08-13	2009-08-13 00:00:00	2010-01-21	2010-01-21 00:00:00	2010-01-21	38000177		0	0	161		0	0	0	265023	0	563026	19115351		
23290	505	40213160	1973-05-15	1973-05-15 00:00:00	1973-05-15	1973-05-15 00:00:00	1973-05-15	581452		0	0	0		0	0	0	33797	0	10	40213160		
182858	4018	40213160	1968-11-05	1968-11-05 00:00:00	1968-11-05	1968-11-05 00:00:00	1968-11-05	581452		0	0	0		0	0	0	267092	0	10	40213160		
59848	4975	1127433	1983-05-25	1983-05-25 00:00:00	1983-06-01	1983-06-01 00:00:00	1983-06-01	38000177		0	0	7		0	0	0	330905	0	313782	1127433		
149841	3295	40213201	2009-04-06	2009-04-06 00:00:00	2009-04-06	2009-04-06 00:00:00	2009-04-06	581452		0	0	0		0	0	0	218981	0	33	40213201		
105496	2315	40213314	1977-08-06	1977-08-06 00:00:00	1977-08-06	1977-08-06 00:00:00	1977-08-06	581452		0	0	0		0	0	0	153965	0	49	40213314		
12048	260	40213160	1970-03-21	1970-03-21 00:00:00	1970-03-21	1970-03-21 00:00:00	1970-03-21	581452		0	0	0		0	0	0	17185	0	10	40213160		
191275	4202	40213227	1993-10-09	1993-10-09 00:00:00	1993-10-09	1993-10-09 00:00:00	1993-10-09	581452		0	0	0		0	0	0	278975	0	113	40213227		
124147	2731	40213227	1992-10-05	1992-10-05 00:00:00	1992-10-05	1992-10-05 00:00:00	1992-10-05	581452		0	0	0		0	0	0	180798	0	113	40213227		
19107	1577	19078924	1997-01-31	1997-01-31 00:00:00	1997-01-31	1997-01-31 00:00:00	1997-01-31	38000177		0	0	0		0	0	0	105932	0	311700	19078924		
94588	2075	40213160	1966-08-09	1966-08-09 00:00:00	1966-08-09	1966-08-09 00:00:00	1966-08-09	581452		0	0	0		0	0	0	138009	0	10	40213160		
161473	3553	40213227	2002-06-01	2002-06-01 00:00:00	2002-06-01	2002-06-01 00:00:00	2002-06-01	581452		0	0	0		0	0	0	235903	0	113	40213227		
139713	3069	40213260	2012-08-22	2012-08-22 00:00:00	2012-08-22	2012-08-22 00:00:00	2012-08-22	581452		0	0	0		0	0	0	204264	0	121	40213260		
52846	4391	40229134	1947-12-04	1947-12-04 00:00:00	1947-12-18	1947-12-18 00:00:00	1947-12-18	38000177		0	0	14		0	0	0	292016	0	1043400	40229134		
42842	3552	1713671	1993-06-15	1993-06-15 00:00:00	1993-06-29	1993-06-29 00:00:00	1993-06-29	38000177		0	0	14		0	0	0	235822	0	562251	1713671		
43686	3621	1127433	1959-02-28	1959-02-28 00:00:00	1959-03-07	1959-03-07 00:00:00	1959-03-07	38000177		0	0	7		0	0	0	240637	0	313782	1127433		
214838	4712	40213160	1968-09-27	1968-09-27 00:00:00	1968-09-27	1968-09-27 00:00:00	1968-09-27	581452		0	0	0		0	0	0	313747	0	10	40213160		
21146	1743	19078461	2012-03-24	2012-03-24 00:00:00	2012-04-14	2012-04-14 00:00:00	2012-04-14	38000177		0	0	21		0	0	0	116512	0	310965	19078461		
43816	3628	19133768	2006-08-19	2006-08-19 00:00:00	2006-08-19	2006-08-19 00:00:00	2006-08-19	38000177		0	0	0		0	0	0	241357	0	833036	19133768		
54308	4514	1127078	1977-02-11	1977-02-11 00:00:00	1977-02-25	1977-02-25 00:00:00	1977-02-25	38000177		0	0	14		0	0	0	300589	0	282464	1127078		
54350	4520	1127433	1985-02-13	1985-02-13 00:00:00	1985-03-06	1985-03-06 00:00:00	1985-03-06	38000177		0	0	21		0	0	0	300894	0	313782	1127433		
109213	2395	40213306	1981-04-17	1981-04-17 00:00:00	1981-04-17	1981-04-17 00:00:00	1981-04-17	581452		0	0	0		0	0	0	159284	0	43	40213306		
147720	3248	40213227	2017-05-26	2017-05-26 00:00:00	2017-05-26	2017-05-26 00:00:00	2017-05-26	581452		0	0	0		0	0	0	215877	0	113	40213227		
62300	5185	1713671	2019-02-17	2019-02-17 00:00:00	2019-02-17	2019-02-17 00:00:00	\N	38000177		0	0	0		0	0	0	344702	0	562251	1713671		
195913	4305	40213296	1999-10-22	1999-10-22 00:00:00	1999-10-22	1999-10-22 00:00:00	1999-10-22	581452		0	0	0		0	0	0	285545	0	52	40213296		
8182	176	40213260	2015-12-02	2015-12-02 00:00:00	2015-12-02	2015-12-02 00:00:00	2015-12-02	581452		0	0	0		0	0	0	11890	0	121	40213260		
207299	4548	40213314	1984-03-27	1984-03-27 00:00:00	1984-03-27	1984-03-27 00:00:00	1984-03-27	581452		0	0	0		0	0	0	303057	0	49	40213314		
19510	1606	1127433	1977-08-04	1977-08-04 00:00:00	1977-08-18	1977-08-18 00:00:00	1977-08-18	38000177		0	0	14		0	0	0	107856	0	313782	1127433		
552	40	19059056	1967-08-13	1967-08-13 00:00:00	1967-09-12	1967-09-12 00:00:00	1967-09-12	38000177		0	0	30		0	0	0	2863	0	243670	19059056		
103526	2270	40213314	1979-08-08	1979-08-08 00:00:00	1979-08-08	1979-08-08 00:00:00	1979-08-08	581452		0	0	0		0	0	0	150959	0	49	40213314		
35341	771	40213306	1981-07-01	1981-07-01 00:00:00	1981-07-01	1981-07-01 00:00:00	1981-07-01	581452		0	0	0		0	0	0	51190	0	43	40213306		
16489	1367	1127433	1980-03-08	1980-03-08 00:00:00	1980-03-22	1980-03-22 00:00:00	1980-03-22	38000177		0	0	14		0	0	0	90622	0	313782	1127433		
21294	1751	1127078	1987-05-28	1987-05-28 00:00:00	1987-06-27	1987-06-27 00:00:00	1987-06-27	38000177		0	0	30		0	0	0	117078	0	282464	1127078		
48584	4024	1713671	2000-05-16	2000-05-16 00:00:00	2000-05-23	2000-05-23 00:00:00	2000-05-23	38000177		0	0	7		0	0	0	267531	0	562251	1713671		
28947	2392	1127433	1955-05-18	1955-05-18 00:00:00	1955-05-25	1955-05-25 00:00:00	1955-05-25	38000177		0	0	7		0	0	0	159026	0	313782	1127433		
54057	4491	1127433	1984-04-25	1984-04-25 00:00:00	1984-05-02	1984-05-02 00:00:00	1984-05-02	38000177		0	0	7		0	0	0	299029	0	313782	1127433		
3673	304	1127078	1957-04-02	1957-04-02 00:00:00	1957-07-01	1957-07-01 00:00:00	1957-07-01	38000177		0	0	90		0	0	0	20210	0	282464	1127078		
32603	711	40213227	1993-01-01	1993-01-01 00:00:00	1993-01-01	1993-01-01 00:00:00	1993-01-01	581452		0	0	0		0	0	0	47101	0	113	40213227		
14157	1185	19059056	1941-10-25	1941-10-25 00:00:00	1941-11-08	1941-11-08 00:00:00	1941-11-08	38000177		0	0	14		0	0	0	78108	0	243670	19059056		
1845	40	40213227	2003-04-02	2003-04-02 00:00:00	2003-04-02	2003-04-02 00:00:00	2003-04-02	581452		0	0	0		0	0	0	2830	0	113	40213227		
60192	5002	1127433	2009-09-15	2009-09-15 00:00:00	2009-09-29	2009-09-29 00:00:00	2009-09-29	38000177		0	0	14		0	0	0	332704	0	313782	1127433		
59286	4927	43012433	2001-05-27	2001-05-27 00:00:00	2002-05-22	2002-05-22 00:00:00	2002-05-22	38000177		0	0	360		0	0	0	327502	0	1367439	43012433		
50563	1108	40213160	1974-07-10	1974-07-10 00:00:00	1974-07-10	1974-07-10 00:00:00	1974-07-10	581452		0	0	0		0	0	0	72959	0	10	40213160		
63050	5239	19059056	1970-10-12	1970-10-12 00:00:00	1970-10-26	1970-10-26 00:00:00	1970-10-26	38000177		0	0	14		0	0	0	348573	0	243670	19059056		
100408	2200	40213296	2015-06-21	2015-06-21 00:00:00	2015-06-21	2015-06-21 00:00:00	2015-06-21	581452		0	0	0		0	0	0	146712	0	52	40213296		
13494	1131	1127433	1982-03-16	1982-03-16 00:00:00	1982-03-23	1982-03-23 00:00:00	1982-03-23	38000177		0	0	7		0	0	0	74454	0	313782	1127433		
202561	4447	40213227	2013-03-26	2013-03-26 00:00:00	2013-03-26	2013-03-26 00:00:00	2013-03-26	581452		0	0	0		0	0	0	295702	0	113	40213227		
63828	5301	40163554	1999-01-07	1999-01-07 00:00:00	1999-01-07	1999-01-07 00:00:00	\N	38000177		0	0	0		0	0	0	352693	0	855332	40163554		
81322	1778	40213306	2002-07-20	2002-07-20 00:00:00	2002-07-20	2002-07-20 00:00:00	2002-07-20	581452		0	0	0		0	0	0	118965	0	43	40213306		
68736	1505	40213227	2015-03-21	2015-03-21 00:00:00	2015-03-21	2015-03-21 00:00:00	2015-03-21	581452		0	0	0		0	0	0	100348	0	113	40213227		
28584	2356	1713671	2007-10-15	2007-10-15 00:00:00	2007-10-22	2007-10-22 00:00:00	2007-10-22	38000177		0	0	7		0	0	0	156908	0	562251	1713671		
24225	1991	1332419	1994-10-17	1994-10-17 00:00:00	1994-10-17	1994-10-17 00:00:00	\N	38000177		0	0	0		0	0	0	132600	0	197361	1332419		
95694	2098	40213227	1994-01-26	1994-01-26 00:00:00	1994-01-26	1994-01-26 00:00:00	1994-01-26	581452		0	0	0		0	0	0	139873	0	113	40213227		
46277	3834	19006318	1957-10-04	1957-10-04 00:00:00	1957-10-18	1957-10-18 00:00:00	1957-10-18	38000177		0	0	14		0	0	0	254567	0	105078	19006318		
236478	5193	40213160	1960-12-01	1960-12-01 00:00:00	1960-12-01	1960-12-01 00:00:00	1960-12-01	581452		0	0	0		0	0	0	345203	0	10	40213160		
37440	817	40213227	2019-02-07	2019-02-07 00:00:00	2019-02-07	2019-02-07 00:00:00	2019-02-07	581452		0	0	0		0	0	0	54129	0	113	40213227		
39310	3248	40171902	2007-03-30	2007-03-30 00:00:00	2007-03-30	2007-03-30 00:00:00	\N	38000177		0	0	0		0	0	0	215888	0	897718	40171902		
27998	2318	35605858	1969-03-09	1969-03-09 00:00:00	1969-03-09	1969-03-09 00:00:00	1969-03-09	38000177		0	0	0		0	0	0	154115	0	1732136	35605858		
98925	2166	40213227	2002-05-05	2002-05-05 00:00:00	2002-05-05	2002-05-05 00:00:00	2002-05-05	581452		0	0	0		0	0	0	144341	0	113	40213227		
103357	2266	40213160	1969-08-23	1969-08-23 00:00:00	1969-08-23	1969-08-23 00:00:00	1969-08-23	581452		0	0	0		0	0	0	150645	0	10	40213160		
10872	232	40213198	2010-12-08	2010-12-08 00:00:00	2010-12-08	2010-12-08 00:00:00	2010-12-08	581452		0	0	0		0	0	0	15560	0	133	40213198		
13577	293	40213160	1969-09-23	1969-09-23 00:00:00	1969-09-23	1969-09-23 00:00:00	1969-09-23	581452		0	0	0		0	0	0	19497	0	10	40213160		
56584	4694	19128065	1996-07-31	1996-07-31 00:00:00	1997-07-26	1997-07-26 00:00:00	1997-07-26	38000177		0	0	360		0	0	0	312775	0	749882	19128065		
29980	653	40213160	1955-07-08	1955-07-08 00:00:00	1955-07-08	1955-07-08 00:00:00	1955-07-08	581452		0	0	0		0	0	0	43228	0	10	40213160		
48085	3986	19078461	2007-07-23	2007-07-23 00:00:00	2007-08-27	2007-08-27 00:00:00	2007-08-27	38000177		0	0	35		0	0	0	265022	0	310965	19078461		
23297	505	40213227	2011-02-22	2011-02-22 00:00:00	2011-02-22	2011-02-22 00:00:00	2011-02-22	581452		0	0	0		0	0	0	33811	0	113	40213227		
182864	4018	40213260	2014-08-12	2014-08-12 00:00:00	2014-08-12	2014-08-12 00:00:00	2014-08-12	581452		0	0	0		0	0	0	267101	0	121	40213260		
59849	4975	1127433	1999-01-01	1999-01-01 00:00:00	1999-01-29	1999-01-29 00:00:00	1999-01-29	38000177		0	0	28		0	0	0	330918	0	313782	1127433		
149846	3295	40213227	2003-12-15	2003-12-15 00:00:00	2003-12-15	2003-12-15 00:00:00	2003-12-15	581452		0	0	0		0	0	0	218942	0	113	40213227		
105497	2315	40213160	1977-08-06	1977-08-06 00:00:00	1977-08-06	1977-08-06 00:00:00	1977-08-06	581452		0	0	0		0	0	0	153965	0	10	40213160		
12054	260	40213160	1974-06-22	1974-06-22 00:00:00	1974-06-22	1974-06-22 00:00:00	1974-06-22	581452		0	0	0		0	0	0	17238	0	10	40213160		
191276	4202	40213306	1993-10-09	1993-10-09 00:00:00	1993-10-09	1993-10-09 00:00:00	1993-10-09	581452		0	0	0		0	0	0	278975	0	43	40213306		
124154	2731	40213227	2011-07-18	2011-07-18 00:00:00	2011-07-18	2011-07-18 00:00:00	2011-07-18	581452		0	0	0		0	0	0	180801	0	113	40213227		
19108	1577	782047	1997-01-31	1997-01-31 00:00:00	1997-01-31	1997-01-31 00:00:00	1997-01-31	38000177		0	0	0		0	0	0	105932	0	542347	782047		
163137	3589	40213227	2012-03-13	2012-03-13 00:00:00	2012-03-13	2012-03-13 00:00:00	2012-03-13	581452		0	0	0		0	0	0	238508	0	113	40213227		
161475	3553	40213227	1992-04-04	1992-04-04 00:00:00	1992-04-04	1992-04-04 00:00:00	1992-04-04	581452		0	0	0		0	0	0	235966	0	113	40213227		
139715	3069	40213227	2012-08-22	2012-08-22 00:00:00	2012-08-22	2012-08-22 00:00:00	2012-08-22	581452		0	0	0		0	0	0	204264	0	113	40213227		
52847	4391	19133873	1953-11-03	1953-11-03 00:00:00	1953-11-10	1953-11-10 00:00:00	1953-11-10	38000177		0	0	7		0	0	0	292009	0	834061	19133873		
42843	3552	1127433	1964-02-14	1964-02-14 00:00:00	1964-02-21	1964-02-21 00:00:00	1964-02-21	38000177		0	0	7		0	0	0	235843	0	313782	1127433		
43687	3621	40169281	1971-07-17	1971-07-17 00:00:00	1971-07-17	1971-07-17 00:00:00	\N	38000177		0	0	0		0	0	0	240651	0	896209	40169281		
214842	4712	40213296	2008-01-25	2008-01-25 00:00:00	2008-01-25	2008-01-25 00:00:00	2008-01-25	581452		0	0	0		0	0	0	313754	0	52	40213296		
21147	1743	19059056	1965-12-30	1965-12-30 00:00:00	1966-01-29	1966-01-29 00:00:00	1966-01-29	38000177		0	0	30		0	0	0	116506	0	243670	19059056		
43817	3628	1127433	1985-09-25	1985-09-25 00:00:00	1985-10-25	1985-10-25 00:00:00	1985-10-25	38000177		0	0	30		0	0	0	241355	0	313782	1127433		
54309	4514	1127433	2014-06-29	2014-06-29 00:00:00	2014-07-06	2014-07-06 00:00:00	2014-07-06	38000177		0	0	7		0	0	0	300663	0	313782	1127433		
54351	4520	19078461	1987-03-26	1987-03-26 00:00:00	1987-04-23	1987-04-23 00:00:00	1987-04-23	38000177		0	0	28		0	0	0	300895	0	310965	19078461		
109225	2396	40213201	1986-01-15	1986-01-15 00:00:00	1986-01-15	1986-01-15 00:00:00	1986-01-15	581452		0	0	0		0	0	0	159330	0	33	40213201		
147731	3248	40213227	1996-07-19	1996-07-19 00:00:00	1996-07-19	1996-07-19 00:00:00	1996-07-19	581452		0	0	0		0	0	0	215913	0	113	40213227		
62301	5185	1713671	1943-11-27	1943-11-27 00:00:00	1943-12-04	1943-12-04 00:00:00	1943-12-04	38000177		0	0	7		0	0	0	344597	0	562251	1713671		
195915	4305	40213227	1992-02-07	1992-02-07 00:00:00	1992-02-07	1992-02-07 00:00:00	1992-02-07	581452		0	0	0		0	0	0	285543	0	113	40213227		
8184	176	40213227	2015-12-02	2015-12-02 00:00:00	2015-12-02	2015-12-02 00:00:00	2015-12-02	581452		0	0	0		0	0	0	11890	0	113	40213227		
207300	4548	40213160	1984-03-27	1984-03-27 00:00:00	1984-03-27	1984-03-27 00:00:00	1984-03-27	581452		0	0	0		0	0	0	303057	0	10	40213160		
49051	4071	1127433	1992-11-27	1992-11-27 00:00:00	1992-12-18	1992-12-18 00:00:00	1992-12-18	38000177		0	0	21		0	0	0	270584	0	313782	1127433		
553	40	1127433	2002-03-21	2002-03-21 00:00:00	2002-03-28	2002-03-28 00:00:00	2002-03-28	38000177		0	0	7		0	0	0	2874	0	313782	1127433		
55661	4622	19006318	1957-09-17	1957-09-17 00:00:00	1957-10-01	1957-10-01 00:00:00	1957-10-01	38000177		0	0	14		0	0	0	307797	0	105078	19006318		
35344	771	40213160	1959-05-20	1959-05-20 00:00:00	1959-05-20	1959-05-20 00:00:00	1959-05-20	581452		0	0	0		0	0	0	51197	0	10	40213160		
16490	1367	19059056	1978-03-28	1978-03-28 00:00:00	1978-04-18	1978-04-18 00:00:00	1978-04-18	38000177		0	0	21		0	0	0	90621	0	243670	19059056		
21295	1751	40229134	1979-04-22	1979-04-22 00:00:00	1979-04-29	1979-04-29 00:00:00	1979-04-29	38000177		0	0	7		0	0	0	117095	0	1043400	40229134		
48585	4024	1713671	2003-08-13	2003-08-13 00:00:00	2003-08-27	2003-08-27 00:00:00	2003-08-27	38000177		0	0	14		0	0	0	267557	0	562251	1713671		
28948	2392	1118084	1948-05-16	1948-05-16 00:00:00	1948-05-16	1948-05-16 00:00:00	\N	38000177		0	0	0		0	0	0	159019	0	00025152531	44923712		
54058	4491	1118084	1984-07-22	1984-07-22 00:00:00	1984-07-22	1984-07-22 00:00:00	\N	38000177		0	0	0		0	0	0	298977	0	00025152531	44923712		
3674	304	1127433	1959-05-24	1959-05-24 00:00:00	1959-06-07	1959-06-07 00:00:00	1959-06-07	38000177		0	0	14		0	0	0	20215	0	313782	1127433		
48667	4032	40163554	2010-07-20	2010-07-20 00:00:00	2010-07-20	2010-07-20 00:00:00	\N	38000177		0	0	0		0	0	0	268200	0	855332	40163554		
14158	1185	40229134	2011-06-06	2011-06-06 00:00:00	2011-06-20	2011-06-20 00:00:00	2011-06-20	38000177		0	0	14		0	0	0	78162	0	1043400	40229134		
1848	40	40213160	1956-11-14	1956-11-14 00:00:00	1956-11-14	1956-11-14 00:00:00	1956-11-14	581452		0	0	0		0	0	0	2808	0	10	40213160		
60204	5004	19008572	1994-02-06	1994-02-06 00:00:00	1994-02-27	1994-02-27 00:00:00	1994-02-27	38000177		0	0	21		0	0	0	332887	0	106258	19008572		
59287	4927	19128022	2004-05-11	2004-05-11 00:00:00	2005-04-01	2005-04-01 00:00:00	2005-04-01	38000177		0	0	325		0	0	0	327537	0	749785	19128022		
200656	4406	40213198	2010-03-06	2010-03-06 00:00:00	2010-03-06	2010-03-06 00:00:00	2010-03-06	581452		0	0	0		0	0	0	292856	0	133	40213198		
63051	5239	1118084	2011-08-30	2011-08-30 00:00:00	2011-08-30	2011-08-30 00:00:00	\N	38000177		0	0	0		0	0	0	348559	0	00025152531	44923712		
100410	2200	40213160	1973-09-16	1973-09-16 00:00:00	1973-09-16	1973-09-16 00:00:00	1973-09-16	581452		0	0	0		0	0	0	146640	0	10	40213160		
13495	1131	40229134	1995-10-14	1995-10-14 00:00:00	1995-10-21	1995-10-21 00:00:00	1995-10-21	38000177		0	0	7		0	0	0	74424	0	1043400	40229134		
202567	4447	40213160	1955-07-26	1955-07-26 00:00:00	1955-07-26	1955-07-26 00:00:00	1955-07-26	581452		0	0	0		0	0	0	295816	0	10	40213160		
63829	5301	40171902	1999-01-07	1999-01-07 00:00:00	1999-01-07	1999-01-07 00:00:00	\N	38000177		0	0	0		0	0	0	352693	0	897718	40171902		
31481	2610	19059056	1960-06-20	1960-06-20 00:00:00	1960-07-04	1960-07-04 00:00:00	1960-07-04	38000177		0	0	14		0	0	0	172612	0	243670	19059056		
80014	1750	40213296	2009-06-10	2009-06-10 00:00:00	2009-06-10	2009-06-10 00:00:00	2009-06-10	581452		0	0	0		0	0	0	117029	0	52	40213296		
28585	2356	1118084	2017-02-10	2017-02-10 00:00:00	2017-02-10	2017-02-10 00:00:00	\N	38000177		0	0	0		0	0	0	156898	0	00025152531	44923712		
24226	1991	19126352	1993-10-11	1993-10-11 00:00:00	2011-02-21	2011-02-21 00:00:00	2011-02-21	38000177		0	0	6342		0	0	0	132581	0	705129	19126352		
95697	2098	40213160	1962-12-12	1962-12-12 00:00:00	1962-12-12	1962-12-12 00:00:00	1962-12-12	581452		0	0	0		0	0	0	139847	0	10	40213160		
46278	3834	1127078	1957-10-04	1957-10-04 00:00:00	1957-10-18	1957-10-18 00:00:00	1957-10-18	38000177		0	0	14		0	0	0	254567	0	282464	1127078		
236480	5193	40213160	1965-08-05	1965-08-05 00:00:00	1965-08-05	1965-08-05 00:00:00	1965-08-05	581452		0	0	0		0	0	0	345186	0	10	40213160		
37452	817	40213160	1958-01-23	1958-01-23 00:00:00	1958-01-23	1958-01-23 00:00:00	1958-01-23	581452		0	0	0		0	0	0	54168	0	10	40213160		
39311	3248	920300	1989-08-08	1989-08-08 00:00:00	1989-08-15	1989-08-15 00:00:00	1989-08-15	38000177		0	0	7		0	0	0	215919	0	311989	920300		
27999	2318	42707627	1969-03-09	1969-03-09 00:00:00	1969-03-09	1969-03-09 00:00:00	1969-03-09	38000177		0	0	0		0	0	0	154115	0	1234995	42707627		
98929	2166	40213160	1969-10-19	1969-10-19 00:00:00	1969-10-19	1969-10-19 00:00:00	1969-10-19	581452		0	0	0		0	0	0	144294	0	10	40213160		
103361	2266	40213160	1973-11-24	1973-11-24 00:00:00	1973-11-24	1973-11-24 00:00:00	1973-11-24	581452		0	0	0		0	0	0	150630	0	10	40213160		
239809	5264	40213160	1968-07-09	1968-07-09 00:00:00	1968-07-09	1968-07-09 00:00:00	1968-07-09	581452		0	0	0		0	0	0	350247	0	10	40213160		
13579	293	40213160	1965-03-23	1965-03-23 00:00:00	1965-03-23	1965-03-23 00:00:00	1965-03-23	581452		0	0	0		0	0	0	19493	0	10	40213160		
56585	4694	1713671	1993-12-03	1993-12-03 00:00:00	1993-12-24	1993-12-24 00:00:00	1993-12-24	38000177		0	0	21		0	0	0	312750	0	562251	1713671		
29982	653	40213296	1996-11-29	1996-11-29 00:00:00	1996-11-29	1996-11-29 00:00:00	1996-11-29	581452		0	0	0		0	0	0	43210	0	52	40213296		
48086	3986	1127433	1992-06-18	1992-06-18 00:00:00	1992-06-25	1992-06-25 00:00:00	1992-06-25	38000177		0	0	7		0	0	0	264983	0	313782	1127433		
23298	505	40213296	2011-02-22	2011-02-22 00:00:00	2011-02-22	2011-02-22 00:00:00	2011-02-22	581452		0	0	0		0	0	0	33811	0	52	40213296		
182871	4018	40213296	2005-07-19	2005-07-19 00:00:00	2005-07-19	2005-07-19 00:00:00	2005-07-19	581452		0	0	0		0	0	0	267097	0	52	40213296		
59850	4975	19059056	1965-03-09	1965-03-09 00:00:00	1965-03-30	1965-03-30 00:00:00	1965-03-30	38000177		0	0	21		0	0	0	330917	0	243670	19059056		
52025	1138	40213306	2002-10-24	2002-10-24 00:00:00	2002-10-24	2002-10-24 00:00:00	2002-10-24	581452		0	0	0		0	0	0	75128	0	43	40213306		
105505	2315	40213160	1978-01-07	1978-01-07 00:00:00	1978-01-07	1978-01-07 00:00:00	1978-01-07	581452		0	0	0		0	0	0	153953	0	10	40213160		
12058	260	40213160	1969-12-20	1969-12-20 00:00:00	1969-12-20	1969-12-20 00:00:00	1969-12-20	581452		0	0	0		0	0	0	17234	0	10	40213160		
191278	4202	40213160	1971-10-23	1971-10-23 00:00:00	1971-10-23	1971-10-23 00:00:00	1971-10-23	581452		0	0	0		0	0	0	278984	0	10	40213160		
124155	2731	40213260	2011-07-18	2011-07-18 00:00:00	2011-07-18	2011-07-18 00:00:00	2011-07-18	581452		0	0	0		0	0	0	180801	0	121	40213260		
19109	1577	42707627	1997-01-31	1997-01-31 00:00:00	1997-01-31	1997-01-31 00:00:00	1997-01-31	38000177		0	0	0		0	0	0	105932	0	1234995	42707627		
163138	3589	40213227	2003-03-03	2003-03-03 00:00:00	2003-03-03	2003-03-03 00:00:00	2003-03-03	581452		0	0	0		0	0	0	238505	0	113	40213227		
161484	3553	40213227	2012-06-23	2012-06-23 00:00:00	2012-06-23	2012-06-23 00:00:00	2012-06-23	581452		0	0	0		0	0	0	235921	0	113	40213227		
139721	3069	40213160	1962-01-24	1962-01-24 00:00:00	1962-01-24	1962-01-24 00:00:00	1962-01-24	581452		0	0	0		0	0	0	204292	0	10	40213160		
52848	4391	19059056	1952-11-06	1952-11-06 00:00:00	1952-11-20	1952-11-20 00:00:00	1952-11-20	38000177		0	0	14		0	0	0	291939	0	243670	19059056		
42844	3552	19059056	1965-07-08	1965-07-08 00:00:00	1965-08-07	1965-08-07 00:00:00	1965-08-07	38000177		0	0	30		0	0	0	235837	0	243670	19059056		
43688	3621	19059056	1923-07-06	1923-07-06 00:00:00	1923-07-20	1923-07-20 00:00:00	1923-07-20	38000177		0	0	14		0	0	0	240560	0	243670	19059056		
214844	4712	40213160	1968-06-28	1968-06-28 00:00:00	1968-06-28	1968-06-28 00:00:00	1968-06-28	581452		0	0	0		0	0	0	313764	0	10	40213160		
21148	1743	1127433	2012-06-21	2012-06-21 00:00:00	2012-07-05	2012-07-05 00:00:00	2012-07-05	38000177		0	0	14		0	0	0	116552	0	313782	1127433		
43818	3628	1713671	1998-09-25	1998-09-25 00:00:00	1998-10-16	1998-10-16 00:00:00	1998-10-16	38000177		0	0	21		0	0	0	241394	0	562251	1713671		
54310	4514	1118084	2015-03-29	2015-03-29 00:00:00	2015-03-29	2015-03-29 00:00:00	\N	38000177		0	0	0		0	0	0	300663	0	00025152531	44923712		
54352	4520	19059056	1945-10-27	1945-10-27 00:00:00	1945-11-10	1945-11-10 00:00:00	1945-11-10	38000177		0	0	14		0	0	0	300892	0	243670	19059056		
109232	2396	40213227	1992-02-19	1992-02-19 00:00:00	1992-02-19	1992-02-19 00:00:00	1992-02-19	581452		0	0	0		0	0	0	159366	0	113	40213227		
147748	3248	40213201	2012-04-27	2012-04-27 00:00:00	2012-04-27	2012-04-27 00:00:00	2012-04-27	581452		0	0	0		0	0	0	215849	0	33	40213201		
62302	5185	1127433	1993-01-01	1993-01-01 00:00:00	1993-01-15	1993-01-15 00:00:00	1993-01-15	38000177		0	0	14		0	0	0	344706	0	313782	1127433		
195926	4305	40213160	1962-11-02	1962-11-02 00:00:00	1962-11-02	1962-11-02 00:00:00	1962-11-02	581452		0	0	0		0	0	0	285628	0	10	40213160		
8186	176	40213227	2006-10-04	2006-10-04 00:00:00	2006-10-04	2006-10-04 00:00:00	2006-10-04	581452		0	0	0		0	0	0	11919	0	113	40213227		
60558	1323	40213306	1983-08-06	1983-08-06 00:00:00	1983-08-06	1983-08-06 00:00:00	1983-08-06	581452		0	0	0		0	0	0	87828	0	43	40213306		
49052	4071	964261	2005-09-19	2005-09-19 00:00:00	2005-09-19	2005-09-19 00:00:00	\N	38000177		0	0	0		0	0	0	270627	0	2001499	964261		
554	40	1127433	1972-02-28	1972-02-28 00:00:00	1972-03-06	1972-03-06 00:00:00	1972-03-06	38000177		0	0	7		0	0	0	2868	0	313782	1127433		
55662	4622	1127433	2010-11-23	2010-11-23 00:00:00	2010-12-07	2010-12-07 00:00:00	2010-12-07	38000177		0	0	14		0	0	0	307817	0	313782	1127433		
103531	2270	40213160	1978-11-08	1978-11-08 00:00:00	1978-11-08	1978-11-08 00:00:00	1978-11-08	581452		0	0	0		0	0	0	150938	0	10	40213160		
16491	1367	19059056	1992-05-18	1992-05-18 00:00:00	1992-06-01	1992-06-01 00:00:00	1992-06-01	38000177		0	0	14		0	0	0	90623	0	243670	19059056		
21296	1751	1124300	2017-09-08	2017-09-08 00:00:00	2017-09-08	2017-09-08 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00781178901	45011828		
48586	4024	40169281	2006-05-07	2006-05-07 00:00:00	2006-05-07	2006-05-07 00:00:00	\N	38000177		0	0	0		0	0	0	267565	0	896209	40169281		
28949	2392	1713671	1932-08-18	1932-08-18 00:00:00	1932-09-08	1932-09-08 00:00:00	1932-09-08	38000177		0	0	21		0	0	0	159017	0	562251	1713671		
54059	4492	40229134	1952-06-06	1952-06-06 00:00:00	1952-06-13	1952-06-13 00:00:00	1952-06-13	38000177		0	0	7		0	0	0	299049	0	1043400	40229134		
3675	304	40229134	2003-09-03	2003-09-03 00:00:00	2003-09-10	2003-09-10 00:00:00	2003-09-10	38000177		0	0	7		0	0	0	20252	0	1043400	40229134		
48668	4032	40171902	2010-07-20	2010-07-20 00:00:00	2010-07-20	2010-07-20 00:00:00	\N	38000177		0	0	0		0	0	0	268200	0	897718	40171902		
14159	1185	40229134	1946-04-13	1946-04-13 00:00:00	1946-04-27	1946-04-27 00:00:00	1946-04-27	38000177		0	0	14		0	0	0	78087	0	1043400	40229134		
1851	40	40213227	2013-05-29	2013-05-29 00:00:00	2013-05-29	2013-05-29 00:00:00	2013-05-29	581452		0	0	0		0	0	0	2855	0	113	40213227		
60205	5004	19073183	1979-06-26	1979-06-26 00:00:00	1979-07-10	1979-07-10 00:00:00	1979-07-10	38000177		0	0	14		0	0	0	332835	0	308182	19073183		
59288	4927	46233988	1978-05-18	1978-05-18 00:00:00	1978-06-08	1978-06-08 00:00:00	1978-06-08	38000177		0	0	21		0	0	0	327477	0	1652673	46233988		
211946	4646	40213227	2015-05-26	2015-05-26 00:00:00	2015-05-26	2015-05-26 00:00:00	2015-05-26	581452		0	0	0		0	0	0	309749	0	113	40213227		
63052	5239	19078461	1997-03-11	1997-03-11 00:00:00	1997-06-09	1997-06-09 00:00:00	1997-06-09	38000177		0	0	90		0	0	0	348604	0	310965	19078461		
100413	2200	40213160	1974-02-17	1974-02-17 00:00:00	1974-02-17	1974-02-17 00:00:00	1974-02-17	581452		0	0	0		0	0	0	146641	0	10	40213160		
13496	1131	19059056	1966-04-08	1966-04-08 00:00:00	1966-04-22	1966-04-22 00:00:00	1966-04-22	38000177		0	0	14		0	0	0	74449	0	243670	19059056		
39760	3289	40229134	1986-10-13	1986-10-13 00:00:00	1986-10-20	1986-10-20 00:00:00	1986-10-20	38000177		0	0	7		0	0	0	218535	0	1043400	40229134		
63830	5302	1713671	2017-04-21	2017-04-21 00:00:00	2017-04-28	2017-04-28 00:00:00	2017-04-28	38000177		0	0	7		0	0	0	352792	0	562251	1713671		
31482	2610	19006318	1960-06-20	1960-06-20 00:00:00	1960-07-04	1960-07-04 00:00:00	1960-07-04	38000177		0	0	14		0	0	0	172612	0	105078	19006318		
80019	1750	40213160	1968-05-22	1968-05-22 00:00:00	1968-05-22	1968-05-22 00:00:00	1968-05-22	581452		0	0	0		0	0	0	116991	0	10	40213160		
28586	2356	1115171	2017-05-25	2017-05-25 00:00:00	2017-06-15	2017-06-15 00:00:00	2017-06-15	38000177		0	0	21		0	0	0	156928	0	849574	1115171		
24227	1991	1539411	1993-10-11	1993-10-11 00:00:00	1993-10-11	1993-10-11 00:00:00	\N	38000177		0	0	0		0	0	0	132581	0	312961	1539411		
95699	2098	40213260	2012-07-04	2012-07-04 00:00:00	2012-07-04	2012-07-04 00:00:00	2012-07-04	581452		0	0	0		0	0	0	139891	0	121	40213260		
46279	3834	1127433	2012-04-18	2012-04-18 00:00:00	2012-05-02	2012-05-02 00:00:00	2012-05-02	38000177		0	0	14		0	0	0	254589	0	313782	1127433		
236492	5193	40213227	2011-09-01	2011-09-01 00:00:00	2011-09-01	2011-09-01 00:00:00	2011-09-01	581452		0	0	0		0	0	0	345196	0	113	40213227		
37459	817	40213296	1997-05-22	1997-05-22 00:00:00	1997-05-22	1997-05-22 00:00:00	1997-05-22	581452		0	0	0		0	0	0	54118	0	52	40213296		
39312	3248	40236824	1989-08-08	1989-08-08 00:00:00	1989-08-22	1989-08-22 00:00:00	1989-08-22	38000177		0	0	14		0	0	0	215919	0	1094107	40236824		
28000	2318	19016749	1969-03-09	1969-03-09 00:00:00	1969-03-09	1969-03-09 00:00:00	1969-03-09	38000177		0	0	0		0	0	0	154115	0	73032	19016749		
98933	2166	40213160	1970-01-18	1970-01-18 00:00:00	1970-01-18	1970-01-18 00:00:00	1970-01-18	581452		0	0	0		0	0	0	144320	0	10	40213160		
103362	2266	40213160	1969-03-22	1969-03-22 00:00:00	1969-03-22	1969-03-22 00:00:00	1969-03-22	581452		0	0	0		0	0	0	150644	0	10	40213160		
239811	5264	40213227	2009-11-10	2009-11-10 00:00:00	2009-11-10	2009-11-10 00:00:00	2009-11-10	581452		0	0	0		0	0	0	350212	0	113	40213227		
13585	293	40213260	2016-09-27	2016-09-27 00:00:00	2016-09-27	2016-09-27 00:00:00	2016-09-27	581452		0	0	0		0	0	0	19491	0	121	40213260		
56586	4694	1127433	1998-02-11	1998-02-11 00:00:00	1998-03-13	1998-03-13 00:00:00	1998-03-13	38000177		0	0	30		0	0	0	312719	0	313782	1127433		
29984	653	40213198	2018-03-09	2018-03-09 00:00:00	2018-03-09	2018-03-09 00:00:00	2018-03-09	581452		0	0	0		0	0	0	43214	0	133	40213198		
48087	3986	1127433	2011-08-06	2011-08-06 00:00:00	2011-09-03	2011-09-03 00:00:00	2011-09-03	38000177		0	0	28		0	0	0	265024	0	313782	1127433		
23300	505	40213296	2009-02-17	2009-02-17 00:00:00	2009-02-17	2009-02-17 00:00:00	2009-02-17	581452		0	0	0		0	0	0	33843	0	52	40213296		
182873	4018	40213227	2005-07-19	2005-07-19 00:00:00	2005-07-19	2005-07-19 00:00:00	2005-07-19	581452		0	0	0		0	0	0	267097	0	113	40213227		
59851	4975	19006318	1965-03-09	1965-03-09 00:00:00	1965-03-30	1965-03-30 00:00:00	1965-03-30	38000177		0	0	21		0	0	0	330917	0	105078	19006318		
52027	1138	40213227	2002-10-24	2002-10-24 00:00:00	2002-10-24	2002-10-24 00:00:00	2002-10-24	581452		0	0	0		0	0	0	75128	0	113	40213227		
105506	2315	40213296	2018-11-10	2018-11-10 00:00:00	2018-11-10	2018-11-10 00:00:00	2018-11-10	581452		0	0	0		0	0	0	153961	0	52	40213296		
12060	260	40213160	1969-10-18	1969-10-18 00:00:00	1969-10-18	1969-10-18 00:00:00	1969-10-18	581452		0	0	0		0	0	0	17219	0	10	40213160		
186677	4101	40213227	2002-03-09	2002-03-09 00:00:00	2002-03-09	2002-03-09 00:00:00	2002-03-09	581452		0	0	0		0	0	0	272489	0	113	40213227		
124161	2731	40213296	2000-10-16	2000-10-16 00:00:00	2000-10-16	2000-10-16 00:00:00	2000-10-16	581452		0	0	0		0	0	0	180788	0	52	40213296		
19110	1577	19016749	1997-01-31	1997-01-31 00:00:00	1997-01-31	1997-01-31 00:00:00	1997-01-31	38000177		0	0	0		0	0	0	105932	0	73032	19016749		
163139	3589	40213306	2003-03-03	2003-03-03 00:00:00	2003-03-03	2003-03-03 00:00:00	2003-03-03	581452		0	0	0		0	0	0	238505	0	43	40213306		
161498	3553	40213201	1997-05-03	1997-05-03 00:00:00	1997-05-03	1997-05-03 00:00:00	1997-05-03	581452		0	0	0		0	0	0	235917	0	33	40213201		
139730	3069	40213260	2011-08-17	2011-08-17 00:00:00	2011-08-17	2011-08-17 00:00:00	2011-08-17	581452		0	0	0		0	0	0	204269	0	121	40213260		
52849	4391	1713671	1957-08-18	1957-08-18 00:00:00	1957-09-08	1957-09-08 00:00:00	1957-09-08	38000177		0	0	21		0	0	0	291946	0	562251	1713671		
42845	3552	1127433	2017-05-04	2017-05-04 00:00:00	2017-05-18	2017-05-18 00:00:00	2017-05-18	38000177		0	0	14		0	0	0	235862	0	313782	1127433		
43689	3621	1124300	1955-08-27	1955-08-27 00:00:00	1955-08-27	1955-08-27 00:00:00	\N	38000177		0	0	0		0	0	0	240574	0	00781178901	45011828		
214846	4712	40213160	1968-04-26	1968-04-26 00:00:00	1968-04-26	1968-04-26 00:00:00	1968-04-26	581452		0	0	0		0	0	0	313791	0	10	40213160		
21149	1743	1127433	2006-07-03	2006-07-03 00:00:00	2006-07-24	2006-07-24 00:00:00	2006-07-24	38000177		0	0	21		0	0	0	116510	0	313782	1127433		
43819	3628	1127433	1967-07-22	1967-07-22 00:00:00	1967-08-26	1967-08-26 00:00:00	1967-08-26	38000177		0	0	35		0	0	0	241353	0	313782	1127433		
54311	4514	40229134	1999-05-19	1999-05-19 00:00:00	1999-06-02	1999-06-02 00:00:00	1999-06-02	38000177		0	0	14		0	0	0	300641	0	1043400	40229134		
54353	4520	19059056	1937-08-28	1937-08-28 00:00:00	1937-09-18	1937-09-18 00:00:00	1937-09-18	38000177		0	0	21		0	0	0	300890	0	243670	19059056		
56268	1232	40213260	2015-12-21	2015-12-21 00:00:00	2015-12-21	2015-12-21 00:00:00	2015-12-21	581452		0	0	0		0	0	0	81208	0	121	40213260		
108170	2372	40213260	2009-04-03	2009-04-03 00:00:00	2009-04-03	2009-04-03 00:00:00	2009-04-03	581452		0	0	0		0	0	0	157858	0	121	40213260		
62303	5185	19133873	1936-05-13	1936-05-13 00:00:00	1936-05-21	1936-05-21 00:00:00	1936-05-21	38000177		0	0	8		0	0	0	344647	0	834061	19133873		
195933	4305	40213160	1958-08-01	1958-08-01 00:00:00	1958-08-01	1958-08-01 00:00:00	1958-08-01	581452		0	0	0		0	0	0	285647	0	10	40213160		
8193	176	40213227	1998-09-23	1998-09-23 00:00:00	1998-09-23	1998-09-23 00:00:00	1998-09-23	581452		0	0	0		0	0	0	11923	0	113	40213227		
60560	1323	40213260	2011-05-07	2011-05-07 00:00:00	2011-05-07	2011-05-07 00:00:00	2011-05-07	581452		0	0	0		0	0	0	87840	0	121	40213260		
49053	4071	1127433	1965-10-03	1965-10-03 00:00:00	1965-10-17	1965-10-17 00:00:00	1965-10-17	38000177		0	0	14		0	0	0	270611	0	313782	1127433		
555	41	1127433	1984-11-04	1984-11-04 00:00:00	1984-11-18	1984-11-18 00:00:00	1984-11-18	38000177		0	0	14		0	0	0	2903	0	313782	1127433		
55663	4622	19133873	1961-09-28	1961-09-28 00:00:00	1961-10-09	1961-10-09 00:00:00	1961-10-09	38000177		0	0	11		0	0	0	307830	0	834061	19133873		
103532	2270	40213314	1978-11-08	1978-11-08 00:00:00	1978-11-08	1978-11-08 00:00:00	1978-11-08	581452		0	0	0		0	0	0	150938	0	49	40213314		
16492	1367	1713671	1990-11-24	1990-11-24 00:00:00	1990-12-08	1990-12-08 00:00:00	1990-12-08	38000177		0	0	14		0	0	0	90630	0	562251	1713671		
21297	1751	1713671	2015-11-18	2015-11-18 00:00:00	2015-11-25	2015-11-25 00:00:00	2015-11-25	38000177		0	0	7		0	0	0	117050	0	562251	1713671		
48587	4024	19133873	1989-08-04	1989-08-04 00:00:00	1989-08-11	1989-08-11 00:00:00	1989-08-11	38000177		0	0	7		0	0	0	267517	0	834061	19133873		
28951	2394	19059056	1912-09-22	1912-09-22 00:00:00	1912-10-06	1912-10-06 00:00:00	1912-10-06	38000177		0	0	14		0	0	0	159141	0	243670	19059056		
54060	4492	1713671	2002-04-18	2002-04-18 00:00:00	2002-05-09	2002-05-09 00:00:00	2002-05-09	38000177		0	0	21		0	0	0	299103	0	562251	1713671		
3676	304	1127433	1965-10-31	1965-10-31 00:00:00	1965-11-14	1965-11-14 00:00:00	1965-11-14	38000177		0	0	14		0	0	0	20216	0	313782	1127433		
48669	4032	19018935	2010-07-20	2010-07-20 00:00:00	2010-07-20	2010-07-20 00:00:00	\N	38000177		0	0	0		0	0	0	268200	0	197604	19018935		
14160	1185	1127433	2000-07-23	2000-07-23 00:00:00	2000-07-30	2000-07-30 00:00:00	2000-07-30	38000177		0	0	7		0	0	0	78106	0	313782	1127433		
1854	40	40213260	2006-04-19	2006-04-19 00:00:00	2006-04-19	2006-04-19 00:00:00	2006-04-19	581452		0	0	0		0	0	0	2848	0	121	40213260		
60206	5004	1127078	1979-06-26	1979-06-26 00:00:00	1979-07-10	1979-07-10 00:00:00	1979-07-10	38000177		0	0	14		0	0	0	332835	0	282464	1127078		
59289	4927	19059056	1978-05-18	1978-05-18 00:00:00	1978-06-08	1978-06-08 00:00:00	1978-06-08	38000177		0	0	21		0	0	0	327477	0	243670	19059056		
211961	4646	40213201	2009-11-24	2009-11-24 00:00:00	2009-11-24	2009-11-24 00:00:00	2009-11-24	581452		0	0	0		0	0	0	309815	0	33	40213201		
63053	5239	40162522	1979-02-14	1979-02-14 00:00:00	1979-02-14	1979-02-14 00:00:00	\N	38000177		0	0	0		0	0	0	348557	0	857005	40162522		
100415	2200	40213227	1995-12-17	1995-12-17 00:00:00	1995-12-17	1995-12-17 00:00:00	1995-12-17	581452		0	0	0		0	0	0	146658	0	113	40213227		
13497	1131	19129655	1966-04-08	1966-04-08 00:00:00	1966-04-22	1966-04-22 00:00:00	1966-04-22	38000177		0	0	14		0	0	0	74449	0	789980	19129655		
39761	3289	19059056	1957-07-15	1957-07-15 00:00:00	1957-07-29	1957-07-29 00:00:00	1957-07-29	38000177		0	0	14		0	0	0	218506	0	243670	19059056		
159836	3518	40213160	1962-10-29	1962-10-29 00:00:00	1962-10-29	1962-10-29 00:00:00	1962-10-29	581452		0	0	0		0	0	0	233570	0	10	40213160		
31483	2610	19128065	1975-06-12	1975-06-12 00:00:00	1976-06-06	1976-06-06 00:00:00	1976-06-06	38000177		0	0	360		0	0	0	172608	0	749882	19128065		
80024	1750	40213306	1990-11-21	1990-11-21 00:00:00	1990-11-21	1990-11-21 00:00:00	1990-11-21	581452		0	0	0		0	0	0	117009	0	43	40213306		
28587	2356	19019979	1985-02-23	1985-02-23 00:00:00	1985-03-09	1985-03-09 00:00:00	1985-03-09	38000177		0	0	14		0	0	0	156871	0	198405	19019979		
24228	1991	1545959	2011-02-21	2011-02-21 00:00:00	2011-02-21	2011-02-21 00:00:00	2011-02-21	38000177		0	0	0		0	0	0	132611	0	259255	1545959		
95700	2098	40213227	2013-07-10	2013-07-10 00:00:00	2013-07-10	2013-07-10 00:00:00	2013-07-10	581452		0	0	0		0	0	0	139840	0	113	40213227		
46280	3834	19075601	2003-08-10	2003-08-10 00:00:00	2003-08-10	2003-08-10 00:00:00	\N	38000177		0	0	0		0	0	0	254576	0	309362	19075601		
236493	5193	40213260	2011-09-01	2011-09-01 00:00:00	2011-09-01	2011-09-01 00:00:00	2011-09-01	581452		0	0	0		0	0	0	345196	0	121	40213260		
99784	2185	40213227	2001-10-04	2001-10-04 00:00:00	2001-10-04	2001-10-04 00:00:00	2001-10-04	581452		0	0	0		0	0	0	145665	0	113	40213227		
39313	3248	1127433	1968-09-29	1968-09-29 00:00:00	1968-10-13	1968-10-13 00:00:00	1968-10-13	38000177		0	0	14		0	0	0	215879	0	313782	1127433		
28001	2318	46275444	1969-03-09	1969-03-09 00:00:00	1969-03-09	1969-03-09 00:00:00	1969-03-09	38000177		0	0	0		0	0	0	154115	0	1659149	46275444		
37574	820	40213160	1969-05-01	1969-05-01 00:00:00	1969-05-01	1969-05-01 00:00:00	1969-05-01	581452		0	0	0		0	0	0	54340	0	10	40213160		
103366	2267	40213260	2015-12-14	2015-12-14 00:00:00	2015-12-14	2015-12-14 00:00:00	2015-12-14	581452		0	0	0		0	0	0	150753	0	121	40213260		
239812	5264	40213296	2009-11-10	2009-11-10 00:00:00	2009-11-10	2009-11-10 00:00:00	2009-11-10	581452		0	0	0		0	0	0	350212	0	52	40213296		
13587	293	40213227	2016-09-27	2016-09-27 00:00:00	2016-09-27	2016-09-27 00:00:00	2016-09-27	581452		0	0	0		0	0	0	19491	0	113	40213227		
56597	4696	19059056	1966-01-08	1966-01-08 00:00:00	1966-01-29	1966-01-29 00:00:00	1966-01-29	38000177		0	0	21		0	0	0	312835	0	243670	19059056		
29988	653	40213227	2014-02-14	2014-02-14 00:00:00	2014-02-14	2014-02-14 00:00:00	2014-02-14	581452		0	0	0		0	0	0	43249	0	113	40213227		
48088	3986	40229134	1971-03-07	1971-03-07 00:00:00	1971-03-14	1971-03-14 00:00:00	1971-03-14	38000177		0	0	7		0	0	0	264965	0	1043400	40229134		
174419	3835	40213160	1966-05-28	1966-05-28 00:00:00	1966-05-28	1966-05-28 00:00:00	1966-05-28	581452		0	0	0		0	0	0	254671	0	10	40213160		
182876	4018	40213306	1984-05-08	1984-05-08 00:00:00	1984-05-08	1984-05-08 00:00:00	1984-05-08	581452		0	0	0		0	0	0	267076	0	43	40213306		
59852	4975	1127433	2001-11-25	2001-11-25 00:00:00	2001-12-02	2001-12-02 00:00:00	2001-12-02	38000177		0	0	7		0	0	0	330883	0	313782	1127433		
52029	1138	40213314	1981-04-09	1981-04-09 00:00:00	1981-04-09	1981-04-09 00:00:00	1981-04-09	581452		0	0	0		0	0	0	75002	0	49	40213314		
105508	2315	40213227	2018-11-10	2018-11-10 00:00:00	2018-11-10	2018-11-10 00:00:00	2018-11-10	581452		0	0	0		0	0	0	153961	0	113	40213227		
137332	3014	40213227	2016-04-23	2016-04-23 00:00:00	2016-04-23	2016-04-23 00:00:00	2016-04-23	581452		0	0	0		0	0	0	201007	0	113	40213227		
186678	4101	40213296	2002-03-09	2002-03-09 00:00:00	2002-03-09	2002-03-09 00:00:00	2002-03-09	581452		0	0	0		0	0	0	272489	0	52	40213296		
38213	3161	19006318	1953-09-19	1953-09-19 00:00:00	1953-10-03	1953-10-03 00:00:00	1953-10-03	38000177		0	0	14		0	0	0	210221	0	105078	19006318		
19111	1577	35605858	1997-01-31	1997-01-31 00:00:00	1997-01-31	1997-01-31 00:00:00	1997-01-31	38000177		0	0	0		0	0	0	105932	0	1732136	35605858		
163141	3589	40213314	1982-03-08	1982-03-08 00:00:00	1982-03-08	1982-03-08 00:00:00	1982-03-08	581452		0	0	0		0	0	0	238499	0	49	40213314		
91348	2005	40213160	1973-11-17	1973-11-17 00:00:00	1973-11-17	1973-11-17 00:00:00	1973-11-17	581452		0	0	0		0	0	0	133535	0	10	40213160		
139732	3069	40213227	2004-03-10	2004-03-10 00:00:00	2004-03-10	2004-03-10 00:00:00	2004-03-10	581452		0	0	0		0	0	0	204281	0	113	40213227		
52850	4391	1127433	2011-10-10	2011-10-10 00:00:00	2011-10-24	2011-10-24 00:00:00	2011-10-24	38000177		0	0	14		0	0	0	291941	0	313782	1127433		
42846	3552	1127433	2014-01-23	2014-01-23 00:00:00	2014-02-06	2014-02-06 00:00:00	2014-02-06	38000177		0	0	14		0	0	0	235807	0	313782	1127433		
43690	3621	1127433	1960-05-06	1960-05-06 00:00:00	1960-05-27	1960-05-27 00:00:00	1960-05-27	38000177		0	0	21		0	0	0	240631	0	313782	1127433		
214851	4712	40213227	2010-01-29	2010-01-29 00:00:00	2010-01-29	2010-01-29 00:00:00	2010-01-29	581452		0	0	0		0	0	0	313759	0	113	40213227		
21150	1743	1127078	1969-01-13	1969-01-13 00:00:00	1969-01-27	1969-01-27 00:00:00	1969-01-27	38000177		0	0	14		0	0	0	116554	0	282464	1127078		
43820	3628	19133873	1927-05-27	1927-05-27 00:00:00	1927-06-08	1927-06-08 00:00:00	1927-06-08	38000177		0	0	12		0	0	0	241297	0	834061	19133873		
66194	1448	40213160	1978-03-08	1978-03-08 00:00:00	1978-03-08	1978-03-08 00:00:00	1978-03-08	581452		0	0	0		0	0	0	96619	0	10	40213160		
54354	4520	19059056	1938-10-13	1938-10-13 00:00:00	1938-11-03	1938-11-03 00:00:00	1938-11-03	38000177		0	0	21		0	0	0	300891	0	243670	19059056		
56270	1232	40213227	2015-12-21	2015-12-21 00:00:00	2015-12-21	2015-12-21 00:00:00	2015-12-21	581452		0	0	0		0	0	0	81208	0	113	40213227		
108172	2372	40213160	1959-07-10	1959-07-10 00:00:00	1959-07-10	1959-07-10 00:00:00	1959-07-10	581452		0	0	0		0	0	0	157817	0	10	40213160		
62304	5185	1127433	1955-03-05	1955-03-05 00:00:00	1955-03-12	1955-03-12 00:00:00	1955-03-12	38000177		0	0	7		0	0	0	344599	0	313782	1127433		
129177	2841	40213227	1993-07-11	1993-07-11 00:00:00	1993-07-11	1993-07-11 00:00:00	1993-07-11	581452		0	0	0		0	0	0	188640	0	113	40213227		
8199	176	40213160	1965-03-03	1965-03-03 00:00:00	1965-03-03	1965-03-03 00:00:00	1965-03-03	581452		0	0	0		0	0	0	11908	0	10	40213160		
60565	1323	40213227	2012-09-08	2012-09-08 00:00:00	2012-09-08	2012-09-08 00:00:00	2012-09-08	581452		0	0	0		0	0	0	87830	0	113	40213227		
49055	4071	1124300	1998-08-07	1998-08-07 00:00:00	1998-08-07	1998-08-07 00:00:00	\N	38000177		0	0	0		0	0	0	270638	0	00781178901	45011828		
556	41	1127433	1999-07-05	1999-07-05 00:00:00	1999-07-19	1999-07-19 00:00:00	1999-07-19	38000177		0	0	14		0	0	0	2893	0	313782	1127433		
55664	4622	40229134	1983-01-06	1983-01-06 00:00:00	1983-01-20	1983-01-20 00:00:00	1983-01-20	38000177		0	0	14		0	0	0	307833	0	1043400	40229134		
103534	2270	40213296	2018-06-06	2018-06-06 00:00:00	2018-06-06	2018-06-06 00:00:00	2018-06-06	581452		0	0	0		0	0	0	150980	0	52	40213296		
16493	1367	19059056	1966-04-25	1966-04-25 00:00:00	1966-05-30	1966-05-30 00:00:00	1966-05-30	38000177		0	0	35		0	0	0	90619	0	243670	19059056		
21298	1751	1115171	2004-03-18	2004-03-18 00:00:00	2004-04-01	2004-04-01 00:00:00	2004-04-01	38000177		0	0	14		0	0	0	117081	0	849574	1115171		
48588	4024	1127433	2005-07-10	2005-07-10 00:00:00	2005-08-07	2005-08-07 00:00:00	2005-08-07	38000177		0	0	28		0	0	0	267530	0	313782	1127433		
28952	2394	1127433	1914-08-14	1914-08-14 00:00:00	1914-08-28	1914-08-28 00:00:00	1914-08-28	38000177		0	0	14		0	0	0	159120	0	313782	1127433		
54061	4492	19059056	1949-06-21	1949-06-21 00:00:00	1949-07-05	1949-07-05 00:00:00	1949-07-05	38000177		0	0	14		0	0	0	299045	0	243670	19059056		
3677	304	1127433	1978-01-17	1978-01-17 00:00:00	1978-02-07	1978-02-07 00:00:00	1978-02-07	38000177		0	0	21		0	0	0	20212	0	313782	1127433		
48670	4032	1127433	1989-08-19	1989-08-19 00:00:00	1989-09-23	1989-09-23 00:00:00	1989-09-23	38000177		0	0	35		0	0	0	268269	0	313782	1127433		
14161	1185	1713671	1980-10-22	1980-10-22 00:00:00	1980-10-29	1980-10-29 00:00:00	1980-10-29	38000177		0	0	7		0	0	0	78104	0	562251	1713671		
1867	41	40213296	2014-01-25	2014-01-25 00:00:00	2014-01-25	2014-01-25 00:00:00	2014-01-25	581452		0	0	0		0	0	0	2976	0	52	40213296		
88942	1950	40213201	2006-12-14	2006-12-14 00:00:00	2006-12-14	2006-12-14 00:00:00	2006-12-14	581452		0	0	0		0	0	0	129660	0	33	40213201		
59290	4927	40229134	1990-07-15	1990-07-15 00:00:00	1990-07-22	1990-07-22 00:00:00	1990-07-22	38000177		0	0	7		0	0	0	327482	0	1043400	40229134		
12263	264	40213227	2002-08-16	2002-08-16 00:00:00	2002-08-16	2002-08-16 00:00:00	2002-08-16	581452		0	0	0		0	0	0	17582	0	113	40213227		
63054	5239	1127433	1979-02-14	1979-02-14 00:00:00	1979-05-15	1979-05-15 00:00:00	1979-05-15	38000177		0	0	90		0	0	0	348557	0	313782	1127433		
100416	2200	40213306	1995-12-17	1995-12-17 00:00:00	1995-12-17	1995-12-17 00:00:00	1995-12-17	581452		0	0	0		0	0	0	146658	0	43	40213306		
13498	1131	40229134	2016-04-05	2016-04-05 00:00:00	2016-04-12	2016-04-12 00:00:00	2016-04-12	38000177		0	0	7		0	0	0	74438	0	1043400	40229134		
39762	3289	19006318	1957-07-15	1957-07-15 00:00:00	1957-07-29	1957-07-29 00:00:00	1957-07-29	38000177		0	0	14		0	0	0	218506	0	105078	19006318		
131710	2894	40213227	1993-10-09	1993-10-09 00:00:00	1993-10-09	1993-10-09 00:00:00	1993-10-09	581452		0	0	0		0	0	0	192564	0	113	40213227		
31484	2610	40165015	2000-09-02	2000-09-02 00:00:00	2000-09-02	2000-09-02 00:00:00	\N	38000177		0	0	0		0	0	0	172596	0	861467	40165015		
136974	3007	40213227	1998-03-04	1998-03-04 00:00:00	1998-03-04	1998-03-04 00:00:00	1998-03-04	581452		0	0	0		0	0	0	200652	0	113	40213227		
28588	2357	19133873	1951-01-14	1951-01-14 00:00:00	1951-01-24	1951-01-24 00:00:00	1951-01-24	38000177		0	0	10		0	0	0	156933	0	834061	19133873		
24229	1991	19133768	2011-02-21	2011-02-21 00:00:00	2011-02-21	2011-02-21 00:00:00	2011-02-21	38000177		0	0	0		0	0	0	132611	0	833036	19133768		
95702	2098	40213260	2013-07-10	2013-07-10 00:00:00	2013-07-10	2013-07-10 00:00:00	2013-07-10	581452		0	0	0		0	0	0	139840	0	121	40213260		
46281	3834	19126352	2003-08-10	2003-08-10 00:00:00	2003-08-10	2003-08-10 00:00:00	\N	38000177		0	0	0		0	0	0	254576	0	705129	19126352		
236494	5193	40213306	1983-05-12	1983-05-12 00:00:00	1983-05-12	1983-05-12 00:00:00	1983-05-12	581452		0	0	0		0	0	0	345213	0	43	40213306		
99810	2186	40213160	1978-01-19	1978-01-19 00:00:00	1978-01-19	1978-01-19 00:00:00	1978-01-19	581452		0	0	0		0	0	0	145748	0	10	40213160		
39314	3248	1127433	1986-11-06	1986-11-06 00:00:00	1986-11-20	1986-11-20 00:00:00	1986-11-20	38000177		0	0	14		0	0	0	215897	0	313782	1127433		
28002	2318	40220386	1969-03-09	1969-03-09 00:00:00	1969-03-09	1969-03-09 00:00:00	1969-03-09	38000177		0	0	0		0	0	0	154115	0	1808217	40220386		
37579	820	40213160	1964-08-27	1964-08-27 00:00:00	1964-08-27	1964-08-27 00:00:00	1964-08-27	581452		0	0	0		0	0	0	54364	0	10	40213160		
103372	2267	40213296	2005-12-19	2005-12-19 00:00:00	2005-12-19	2005-12-19 00:00:00	2005-12-19	581452		0	0	0		0	0	0	150751	0	52	40213296		
239815	5264	40213160	1972-10-10	1972-10-10 00:00:00	1972-10-10	1972-10-10 00:00:00	1972-10-10	581452		0	0	0		0	0	0	350233	0	10	40213160		
44613	3694	19059056	1971-08-29	1971-08-29 00:00:00	1971-11-27	1971-11-27 00:00:00	1971-11-27	38000177		0	0	90		0	0	0	245560	0	243670	19059056		
56599	4696	1127433	1962-02-03	1962-02-03 00:00:00	1962-02-10	1962-02-10 00:00:00	1962-02-10	38000177		0	0	7		0	0	0	312823	0	313782	1127433		
29991	653	40213260	2005-12-30	2005-12-30 00:00:00	2005-12-30	2005-12-30 00:00:00	2005-12-30	581452		0	0	0		0	0	0	43204	0	121	40213260		
48089	3987	1713671	1974-08-05	1974-08-05 00:00:00	1974-08-12	1974-08-12 00:00:00	1974-08-12	38000177		0	0	7		0	0	0	265031	0	562251	1713671		
174421	3835	40213296	2005-09-24	2005-09-24 00:00:00	2005-09-24	2005-09-24 00:00:00	2005-09-24	581452		0	0	0		0	0	0	254664	0	52	40213296		
182878	4018	40213306	1987-05-12	1987-05-12 00:00:00	1987-05-12	1987-05-12 00:00:00	1987-05-12	581452		0	0	0		0	0	0	267077	0	43	40213306		
59853	4975	19059056	1960-02-04	1960-02-04 00:00:00	1960-02-18	1960-02-18 00:00:00	1960-02-18	38000177		0	0	14		0	0	0	330872	0	243670	19059056		
104607	2294	40213260	2010-11-26	2010-11-26 00:00:00	2010-11-26	2010-11-26 00:00:00	2010-11-26	581452		0	0	0		0	0	0	152699	0	121	40213260		
105511	2315	40213314	1978-07-08	1978-07-08 00:00:00	1978-07-08	1978-07-08 00:00:00	1978-07-08	581452		0	0	0		0	0	0	153924	0	49	40213314		
137333	3014	40213296	2016-04-23	2016-04-23 00:00:00	2016-04-23	2016-04-23 00:00:00	2016-04-23	581452		0	0	0		0	0	0	201007	0	52	40213296		
186684	4101	40213296	2000-03-04	2000-03-04 00:00:00	2000-03-04	2000-03-04 00:00:00	2000-03-04	581452		0	0	0		0	0	0	272478	0	52	40213296		
38214	3161	19059056	1953-09-19	1953-09-19 00:00:00	1953-10-03	1953-10-03 00:00:00	1953-10-03	38000177		0	0	14		0	0	0	210221	0	243670	19059056		
19112	1577	1127433	1990-06-07	1990-06-07 00:00:00	1990-06-21	1990-06-21 00:00:00	1990-06-21	38000177		0	0	14		0	0	0	105838	0	313782	1127433		
163159	3589	40213251	1985-12-09	1985-12-09 00:00:00	1985-12-09	1985-12-09 00:00:00	1985-12-09	581452		0	0	0		0	0	0	238501	0	21	40213251		
91351	2005	40213314	1977-07-16	1977-07-16 00:00:00	1977-07-16	1977-07-16 00:00:00	1977-07-16	581452		0	0	0		0	0	0	133538	0	49	40213314		
139733	3069	40213296	2004-03-10	2004-03-10 00:00:00	2004-03-10	2004-03-10 00:00:00	2004-03-10	581452		0	0	0		0	0	0	204281	0	52	40213296		
52851	4391	1118084	1978-06-18	1978-06-18 00:00:00	1978-06-18	1978-06-18 00:00:00	\N	38000177		0	0	0		0	0	0	291972	0	00025152531	44923712		
42847	3552	1127433	2002-10-31	2002-10-31 00:00:00	2002-11-07	2002-11-07 00:00:00	2002-11-07	38000177		0	0	7		0	0	0	235824	0	313782	1127433		
4987	412	1127078	1955-08-20	1955-08-20 00:00:00	1955-09-03	1955-09-03 00:00:00	1955-09-03	38000177		0	0	14		0	0	0	27429	0	282464	1127078		
214852	4712	40213296	2010-01-29	2010-01-29 00:00:00	2010-01-29	2010-01-29 00:00:00	2010-01-29	581452		0	0	0		0	0	0	313759	0	52	40213296		
21151	1743	46233988	1969-01-13	1969-01-13 00:00:00	1969-01-27	1969-01-27 00:00:00	1969-01-27	38000177		0	0	14		0	0	0	116554	0	1652673	46233988		
43821	3629	40162522	1973-05-27	1973-05-27 00:00:00	1973-05-27	1973-05-27 00:00:00	\N	38000177		0	0	0		0	0	0	241433	0	857005	40162522		
66199	1448	40213227	2015-12-16	2015-12-16 00:00:00	2015-12-16	2015-12-16 00:00:00	2015-12-16	581452		0	0	0		0	0	0	96595	0	113	40213227		
54355	4520	40169281	1957-09-14	1957-09-14 00:00:00	1957-09-14	1957-09-14 00:00:00	\N	38000177		0	0	0		0	0	0	300899	0	896209	40169281		
56277	1232	40213306	1986-12-29	1986-12-29 00:00:00	1986-12-29	1986-12-29 00:00:00	1986-12-29	581452		0	0	0		0	0	0	81195	0	43	40213306		
108173	2372	40213227	1993-07-09	1993-07-09 00:00:00	1993-07-09	1993-07-09 00:00:00	1993-07-09	581452		0	0	0		0	0	0	157833	0	113	40213227		
125758	2767	40213227	2008-02-06	2008-02-06 00:00:00	2008-02-06	2008-02-06 00:00:00	2008-02-06	581452		0	0	0		0	0	0	183118	0	113	40213227		
129183	2841	40213160	1955-06-12	1955-06-12 00:00:00	1955-06-12	1955-06-12 00:00:00	1955-06-12	581452		0	0	0		0	0	0	188623	0	10	40213160		
8202	176	40213160	1965-05-05	1965-05-05 00:00:00	1965-05-05	1965-05-05 00:00:00	1965-05-05	581452		0	0	0		0	0	0	11912	0	10	40213160		
60566	1323	40213260	2012-09-08	2012-09-08 00:00:00	2012-09-08	2012-09-08 00:00:00	2012-09-08	581452		0	0	0		0	0	0	87830	0	121	40213260		
49056	4071	19059056	1952-11-01	1952-11-01 00:00:00	1952-11-15	1952-11-15 00:00:00	1952-11-15	38000177		0	0	14		0	0	0	270629	0	243670	19059056		
557	41	19078461	1990-01-18	1990-01-18 00:00:00	1990-02-22	1990-02-22 00:00:00	1990-02-22	38000177		0	0	35		0	0	0	2891	0	310965	19078461		
55665	4622	19059056	1966-06-19	1966-06-19 00:00:00	1966-07-03	1966-07-03 00:00:00	1966-07-03	38000177		0	0	14		0	0	0	307798	0	243670	19059056		
103535	2270	40213251	1984-02-29	1984-02-29 00:00:00	1984-02-29	1984-02-29 00:00:00	1984-02-29	581452		0	0	0		0	0	0	150974	0	21	40213251		
16494	1367	1124300	2005-02-04	2005-02-04 00:00:00	2005-02-04	2005-02-04 00:00:00	\N	38000177		0	0	0		0	0	0	90656	0	00781178901	45011828		
21299	1751	1127433	2013-01-14	2013-01-14 00:00:00	2013-02-18	2013-02-18 00:00:00	2013-02-18	38000177		0	0	35		0	0	0	117082	0	313782	1127433		
48589	4026	1127078	1962-11-01	1962-11-01 00:00:00	1962-12-01	1962-12-01 00:00:00	1962-12-01	38000177		0	0	30		0	0	0	267690	0	282464	1127078		
28953	2394	1124300	1953-02-04	1953-02-04 00:00:00	1953-02-04	1953-02-04 00:00:00	\N	38000177		0	0	0		0	0	0	159188	0	00781178901	45011828		
54062	4492	40236824	1976-09-14	1976-09-14 00:00:00	1976-09-21	1976-09-21 00:00:00	1976-09-21	38000177		0	0	7		0	0	0	299074	0	1094107	40236824		
3678	304	40162522	2017-12-14	2017-12-14 00:00:00	2017-12-14	2017-12-14 00:00:00	\N	38000177		0	0	0		0	0	0	20209	0	857005	40162522		
48671	4032	1713671	1996-07-27	1996-07-27 00:00:00	1996-08-03	1996-08-03 00:00:00	1996-08-03	38000177		0	0	7		0	0	0	268274	0	562251	1713671		
14162	1185	1115171	2004-06-26	2004-06-26 00:00:00	2004-07-31	2004-07-31 00:00:00	2004-07-31	38000177		0	0	35		0	0	0	78149	0	849574	1115171		
1872	41	40213160	1977-10-22	1977-10-22 00:00:00	1977-10-22	1977-10-22 00:00:00	1977-10-22	581452		0	0	0		0	0	0	\N	0	10	40213160		
88962	1950	40213227	2001-11-15	2001-11-15 00:00:00	2001-11-15	2001-11-15 00:00:00	2001-11-15	581452		0	0	0		0	0	0	129619	0	113	40213227		
59291	4927	40229134	2007-05-22	2007-05-22 00:00:00	2007-05-29	2007-05-29 00:00:00	2007-05-29	38000177		0	0	7		0	0	0	327495	0	1043400	40229134		
12275	264	40213227	1994-07-22	1994-07-22 00:00:00	1994-07-22	1994-07-22 00:00:00	1994-07-22	581452		0	0	0		0	0	0	17550	0	113	40213227		
63055	5239	46233988	1971-07-02	1971-07-02 00:00:00	1971-07-16	1971-07-16 00:00:00	1971-07-16	38000177		0	0	14		0	0	0	348584	0	1652673	46233988		
100419	2200	40213314	1977-05-15	1977-05-15 00:00:00	1977-05-15	1977-05-15 00:00:00	1977-05-15	581452		0	0	0		0	0	0	146695	0	49	40213314		
13499	1131	40231925	1979-01-30	1979-01-30 00:00:00	1979-01-30	1979-01-30 00:00:00	\N	38000177		0	0	0		0	0	0	74478	0	1049221	40231925		
39763	3289	19133905	1993-04-20	1993-04-20 00:00:00	1993-05-03	1993-05-03 00:00:00	1993-05-03	38000177		0	0	13		0	0	0	218537	0	834102	19133905		
131716	2894	40213201	1988-09-10	1988-09-10 00:00:00	1988-09-10	1988-09-10 00:00:00	1988-09-10	581452		0	0	0		0	0	0	192608	0	33	40213201		
31485	2610	1127433	2000-09-02	2000-09-02 00:00:00	2000-11-30	2000-11-30 00:00:00	2000-11-30	38000177		0	0	89		0	0	0	172596	0	313782	1127433		
136975	3007	40213160	1966-11-02	1966-11-02 00:00:00	1966-11-02	1966-11-02 00:00:00	1966-11-02	581452		0	0	0		0	0	0	200624	0	10	40213160		
28589	2357	19059056	1941-03-04	1941-03-04 00:00:00	1941-03-18	1941-03-18 00:00:00	1941-03-18	38000177		0	0	14		0	0	0	156945	0	243670	19059056		
24230	1991	1124300	1977-07-24	1977-07-24 00:00:00	1977-07-24	1977-07-24 00:00:00	\N	38000177		0	0	0		0	0	0	132608	0	00781178901	45011828		
95714	2098	40213296	2002-07-10	2002-07-10 00:00:00	2002-07-10	2002-07-10 00:00:00	2002-07-10	581452		0	0	0		0	0	0	139889	0	52	40213296		
46282	3834	1332419	2003-08-10	2003-08-10 00:00:00	2003-08-10	2003-08-10 00:00:00	\N	38000177		0	0	0		0	0	0	254576	0	197361	1332419		
236498	5193	40213227	1992-05-21	1992-05-21 00:00:00	1992-05-21	1992-05-21 00:00:00	1992-05-21	581452		0	0	0		0	0	0	345224	0	113	40213227		
51706	1132	40213227	2004-05-10	2004-05-10 00:00:00	2004-05-10	2004-05-10 00:00:00	2004-05-10	581452		0	0	0		0	0	0	74548	0	113	40213227		
39315	3248	19059056	1961-05-04	1961-05-04 00:00:00	1961-06-08	1961-06-08 00:00:00	1961-06-08	38000177		0	0	35		0	0	0	215878	0	243670	19059056		
28003	2318	35605482	1969-03-09	1969-03-09 00:00:00	1969-03-09	1969-03-09 00:00:00	1969-03-09	38000177		0	0	0		0	0	0	154115	0	1740467	35605482		
37581	820	40213227	2015-05-28	2015-05-28 00:00:00	2015-05-28	2015-05-28 00:00:00	2015-05-28	581452		0	0	0		0	0	0	54315	0	113	40213227		
192084	4220	40213227	2013-08-13	2013-08-13 00:00:00	2013-08-13	2013-08-13 00:00:00	2013-08-13	581452		0	0	0		0	0	0	280192	0	113	40213227		
239826	5264	40213306	1990-01-02	1990-01-02 00:00:00	1990-01-02	1990-01-02 00:00:00	1990-01-02	581452		0	0	0		0	0	0	350260	0	43	40213306		
44614	3694	1127433	2017-09-14	2017-09-14 00:00:00	2017-09-21	2017-09-21 00:00:00	2017-09-21	38000177		0	0	7		0	0	0	245527	0	313782	1127433		
78951	1727	40213227	2010-10-21	2010-10-21 00:00:00	2010-10-21	2010-10-21 00:00:00	2010-10-21	581452		0	0	0		0	0	0	115500	0	113	40213227		
70627	1545	40213160	1969-05-16	1969-05-16 00:00:00	1969-05-16	1969-05-16 00:00:00	1969-05-16	581452		0	0	0		0	0	0	103516	0	10	40213160		
48090	3987	19078461	2008-03-01	2008-03-01 00:00:00	2008-04-30	2008-04-30 00:00:00	2008-04-30	38000177		0	0	60		0	0	0	265029	0	310965	19078461		
174426	3835	40213227	1997-06-07	1997-06-07 00:00:00	1997-06-07	1997-06-07 00:00:00	1997-06-07	581452		0	0	0		0	0	0	254660	0	113	40213227		
182880	4018	40213227	2015-08-18	2015-08-18 00:00:00	2015-08-18	2015-08-18 00:00:00	2015-08-18	581452		0	0	0		0	0	0	267087	0	113	40213227		
59854	4975	19006318	1960-02-04	1960-02-04 00:00:00	1960-02-18	1960-02-18 00:00:00	1960-02-18	38000177		0	0	14		0	0	0	330872	0	105078	19006318		
104611	2294	40213296	2003-01-10	2003-01-10 00:00:00	2003-01-10	2003-01-10 00:00:00	2003-01-10	581452		0	0	0		0	0	0	152743	0	52	40213296		
105516	2315	40213227	2011-04-16	2011-04-16 00:00:00	2011-04-16	2011-04-16 00:00:00	2011-04-16	581452		0	0	0		0	0	0	153950	0	113	40213227		
137340	3014	40213160	1978-06-10	1978-06-10 00:00:00	1978-06-10	1978-06-10 00:00:00	1978-06-10	581452		0	0	0		0	0	0	201024	0	10	40213160		
186689	4101	40213260	2011-03-05	2011-03-05 00:00:00	2011-03-05	2011-03-05 00:00:00	2011-03-05	581452		0	0	0		0	0	0	272490	0	121	40213260		
38215	3161	1713671	2016-11-13	2016-11-13 00:00:00	2016-11-27	2016-11-27 00:00:00	2016-11-27	38000177		0	0	14		0	0	0	210215	0	562251	1713671		
19113	1577	1127433	1972-08-25	1972-08-25 00:00:00	1972-09-08	1972-09-08 00:00:00	1972-09-08	38000177		0	0	14		0	0	0	105837	0	313782	1127433		
163161	3589	40213160	1985-12-09	1985-12-09 00:00:00	1985-12-09	1985-12-09 00:00:00	1985-12-09	581452		0	0	0		0	0	0	238501	0	10	40213160		
91355	2005	40213306	1995-08-26	1995-08-26 00:00:00	1995-08-26	1995-08-26 00:00:00	1995-08-26	581452		0	0	0		0	0	0	133495	0	43	40213306		
139738	3069	40213306	1983-10-19	1983-10-19 00:00:00	1983-10-19	1983-10-19 00:00:00	1983-10-19	581452		0	0	0		0	0	0	204275	0	43	40213306		
52852	4391	19059056	1945-12-13	1945-12-13 00:00:00	1946-03-13	1946-03-13 00:00:00	1946-03-13	38000177		0	0	90		0	0	0	291938	0	243670	19059056		
42848	3552	19074841	1979-06-25	1979-06-25 00:00:00	1979-07-23	1979-07-23 00:00:00	1979-07-23	38000177		0	0	28		0	0	0	235861	0	309043	19074841		
4988	412	19075601	2004-06-18	2004-06-18 00:00:00	2004-06-18	2004-06-18 00:00:00	2004-06-18	38000177		0	0	0		0	0	0	27423	0	309362	19075601		
214858	4712	40213227	1999-10-01	1999-10-01 00:00:00	1999-10-01	1999-10-01 00:00:00	1999-10-01	581452		0	0	0		0	0	0	313774	0	113	40213227		
21152	1743	19078461	1999-09-08	1999-09-08 00:00:00	1999-10-08	1999-10-08 00:00:00	1999-10-08	38000177		0	0	30		0	0	0	116509	0	310965	19078461		
43822	3629	19059056	1965-09-29	1965-09-29 00:00:00	1965-12-28	1965-12-28 00:00:00	1965-12-28	38000177		0	0	90		0	0	0	241470	0	243670	19059056		
66200	1448	40213296	2015-12-16	2015-12-16 00:00:00	2015-12-16	2015-12-16 00:00:00	2015-12-16	581452		0	0	0		0	0	0	96595	0	52	40213296		
54356	4520	1713671	1957-09-10	1957-09-10 00:00:00	1957-09-17	1957-09-17 00:00:00	1957-09-17	38000177		0	0	7		0	0	0	300899	0	562251	1713671		
56279	1232	40213227	2006-12-25	2006-12-25 00:00:00	2006-12-25	2006-12-25 00:00:00	2006-12-25	581452		0	0	0		0	0	0	81196	0	113	40213227		
108177	2372	40213227	2010-04-09	2010-04-09 00:00:00	2010-04-09	2010-04-09 00:00:00	2010-04-09	581452		0	0	0		0	0	0	157836	0	113	40213227		
125768	2767	40213201	2002-07-10	2002-07-10 00:00:00	2002-07-10	2002-07-10 00:00:00	2002-07-10	581452		0	0	0		0	0	0	183116	0	33	40213201		
207165	4546	40213160	1969-03-07	1969-03-07 00:00:00	1969-03-07	1969-03-07 00:00:00	1969-03-07	581452		0	0	0		0	0	0	302803	0	10	40213160		
8205	176	40213306	1986-09-10	1986-09-10 00:00:00	1986-09-10	1986-09-10 00:00:00	1986-09-10	581452		0	0	0		0	0	0	11918	0	43	40213306		
60570	1323	40213296	2001-05-12	2001-05-12 00:00:00	2001-05-12	2001-05-12 00:00:00	2001-05-12	581452		0	0	0		0	0	0	87838	0	52	40213296		
49057	4071	1127433	1962-09-11	1962-09-11 00:00:00	1962-09-18	1962-09-18 00:00:00	1962-09-18	38000177		0	0	7		0	0	0	270609	0	313782	1127433		
558	41	1551192	1976-02-10	1976-02-10 00:00:00	1976-02-10	1976-02-10 00:00:00	1976-02-10	38000177		0	0	0		0	0	0	2898	0	312617	1551192		
55666	4622	19059056	1962-12-20	1962-12-20 00:00:00	1963-01-24	1963-01-24 00:00:00	1963-01-24	38000177		0	0	35		0	0	0	307828	0	243670	19059056		
103539	2270	40213160	1979-02-07	1979-02-07 00:00:00	1979-02-07	1979-02-07 00:00:00	1979-02-07	581452		0	0	0		0	0	0	150972	0	10	40213160		
16495	1367	19059056	1965-12-26	1965-12-26 00:00:00	1966-01-09	1966-01-09 00:00:00	1966-01-09	38000177		0	0	14		0	0	0	90591	0	243670	19059056		
21300	1751	19078461	1995-05-16	1995-05-16 00:00:00	1995-06-13	1995-06-13 00:00:00	1995-06-13	38000177		0	0	28		0	0	0	117079	0	310965	19078461		
48590	4026	1127078	1961-04-01	1961-04-01 00:00:00	1961-04-15	1961-04-15 00:00:00	1961-04-15	38000177		0	0	14		0	0	0	267629	0	282464	1127078		
28954	2394	19059056	1912-02-25	1912-02-25 00:00:00	1912-03-10	1912-03-10 00:00:00	1912-03-10	38000177		0	0	14		0	0	0	159152	0	243670	19059056		
54063	4492	920300	1976-09-14	1976-09-14 00:00:00	1976-09-21	1976-09-21 00:00:00	1976-09-21	38000177		0	0	7		0	0	0	299074	0	311989	920300		
3679	304	1713671	1964-05-24	1964-05-24 00:00:00	1964-06-14	1964-06-14 00:00:00	1964-06-14	38000177		0	0	21		0	0	0	20274	0	562251	1713671		
48672	4032	1115171	2001-10-20	2001-10-20 00:00:00	2001-11-10	2001-11-10 00:00:00	2001-11-10	38000177		0	0	21		0	0	0	268212	0	849574	1115171		
14163	1185	40229134	1948-04-22	1948-04-22 00:00:00	1948-04-29	1948-04-29 00:00:00	1948-04-29	38000177		0	0	7		0	0	0	78157	0	1043400	40229134		
7555	636	1713671	2005-05-18	2005-05-18 00:00:00	2005-05-25	2005-05-25 00:00:00	2005-05-25	38000177		0	0	7		0	0	0	42141	0	562251	1713671		
881	19	40213227	1993-02-14	1993-02-14 00:00:00	1993-02-14	1993-02-14 00:00:00	1993-02-14	581452		0	0	0		0	0	0	1468	0	113	40213227		
59292	4927	1127433	2014-11-20	2014-11-20 00:00:00	2014-12-04	2014-12-04 00:00:00	2014-12-04	38000177		0	0	14		0	0	0	327438	0	313782	1127433		
12280	264	40213160	1956-07-06	1956-07-06 00:00:00	1956-07-06	1956-07-06 00:00:00	1956-07-06	581452		0	0	0		0	0	0	17543	0	10	40213160		
63056	5239	19059056	1971-07-02	1971-07-02 00:00:00	1971-07-16	1971-07-16 00:00:00	1971-07-16	38000177		0	0	14		0	0	0	348584	0	243670	19059056		
12338	266	40213296	2008-05-12	2008-05-12 00:00:00	2008-05-12	2008-05-12 00:00:00	2008-05-12	581452		0	0	0		0	0	0	17642	0	52	40213296		
13500	1131	1127433	1979-01-30	1979-01-30 00:00:00	1979-04-30	1979-04-30 00:00:00	1979-04-30	38000177		0	0	90		0	0	0	74478	0	313782	1127433		
39764	3289	19128065	1974-11-23	1974-11-23 00:00:00	1975-11-18	1975-11-18 00:00:00	1975-11-18	38000177		0	0	360		0	0	0	218510	0	749882	19128065		
131729	2894	40213227	2003-12-06	2003-12-06 00:00:00	2003-12-06	2003-12-06 00:00:00	2003-12-06	581452		0	0	0		0	0	0	192647	0	113	40213227		
31486	2610	19133905	1983-09-13	1983-09-13 00:00:00	1983-09-20	1983-09-20 00:00:00	1983-09-20	38000177		0	0	7		0	0	0	172551	0	834102	19133905		
136980	3007	40213160	1970-12-02	1970-12-02 00:00:00	1970-12-02	1970-12-02 00:00:00	1970-12-02	581452		0	0	0		0	0	0	200628	0	10	40213160		
28590	2357	1127433	1999-07-10	1999-07-10 00:00:00	1999-08-07	1999-08-07 00:00:00	1999-08-07	38000177		0	0	28		0	0	0	157005	0	313782	1127433		
24231	1991	1127433	1977-01-06	1977-01-06 00:00:00	1977-02-10	1977-02-10 00:00:00	1977-02-10	38000177		0	0	35		0	0	0	132608	0	313782	1127433		
95716	2098	40213160	1962-10-10	1962-10-10 00:00:00	1962-10-10	1962-10-10 00:00:00	1962-10-10	581452		0	0	0		0	0	0	139908	0	10	40213160		
46283	3834	1539411	2003-08-10	2003-08-10 00:00:00	2003-08-10	2003-08-10 00:00:00	\N	38000177		0	0	0		0	0	0	254576	0	312961	1539411		
236500	5193	40213160	1961-02-02	1961-02-02 00:00:00	1961-02-02	1961-02-02 00:00:00	1961-02-02	581452		0	0	0		0	0	0	345182	0	10	40213160		
51709	1132	40213227	1995-05-15	1995-05-15 00:00:00	1995-05-15	1995-05-15 00:00:00	1995-05-15	581452		0	0	0		0	0	0	74528	0	113	40213227		
39316	3248	40231925	2014-10-14	2014-10-14 00:00:00	2014-10-14	2014-10-14 00:00:00	\N	38000177		0	0	0		0	0	0	215859	0	1049221	40231925		
28004	2318	35605482	1969-03-09	1969-03-09 00:00:00	1969-03-09	1969-03-09 00:00:00	1969-03-09	38000177		0	0	0		0	0	0	154115	0	1740467	35605482		
37582	820	40213260	2015-05-28	2015-05-28 00:00:00	2015-05-28	2015-05-28 00:00:00	2015-05-28	581452		0	0	0		0	0	0	54315	0	121	40213260		
7415	160	40213260	2011-07-28	2011-07-28 00:00:00	2011-07-28	2011-07-28 00:00:00	2011-07-28	581452		0	0	0		0	0	0	11015	0	121	40213260		
239828	5264	40213260	2017-10-31	2017-10-31 00:00:00	2017-10-31	2017-10-31 00:00:00	2017-10-31	581452		0	0	0		0	0	0	350243	0	121	40213260		
44615	3694	19074679	1969-04-06	1969-04-06 00:00:00	1969-09-14	1969-09-14 00:00:00	1969-09-14	38000177		0	0	161		0	0	0	245559	0	308971	19074679		
78960	1727	40213160	1955-02-16	1955-02-16 00:00:00	1955-02-16	1955-02-16 00:00:00	1955-02-16	581452		0	0	0		0	0	0	115435	0	10	40213160		
70632	1545	40213227	2002-09-27	2002-09-27 00:00:00	2002-09-27	2002-09-27 00:00:00	2002-09-27	581452		0	0	0		0	0	0	103532	0	113	40213227		
48091	3987	40165015	2008-03-01	2008-03-01 00:00:00	2008-03-01	2008-03-01 00:00:00	\N	38000177		0	0	0		0	0	0	265029	0	861467	40165015		
174439	3835	40213160	1965-12-25	1965-12-25 00:00:00	1965-12-25	1965-12-25 00:00:00	1965-12-25	581452		0	0	0		0	0	0	254670	0	10	40213160		
182881	4018	40213260	2015-08-18	2015-08-18 00:00:00	2015-08-18	2015-08-18 00:00:00	2015-08-18	581452		0	0	0		0	0	0	267087	0	121	40213260		
59855	4976	1713671	1991-09-14	1991-09-14 00:00:00	1991-09-28	1991-09-28 00:00:00	1991-09-28	38000177		0	0	14		0	0	0	330985	0	562251	1713671		
104612	2294	40213227	2003-01-10	2003-01-10 00:00:00	2003-01-10	2003-01-10 00:00:00	2003-01-10	581452		0	0	0		0	0	0	152743	0	113	40213227		
80338	1758	40213260	2011-03-04	2011-03-04 00:00:00	2011-03-04	2011-03-04 00:00:00	2011-03-04	581452		0	0	0		0	0	0	117571	0	121	40213260		
137343	3014	40213227	1996-03-01	1996-03-01 00:00:00	1996-03-01	1996-03-01 00:00:00	1996-03-01	581452		0	0	0		0	0	0	201028	0	113	40213227		
186691	4101	40213227	2011-03-05	2011-03-05 00:00:00	2011-03-05	2011-03-05 00:00:00	2011-03-05	581452		0	0	0		0	0	0	272490	0	113	40213227		
38216	3161	19059056	1960-06-25	1960-06-25 00:00:00	1960-07-09	1960-07-09 00:00:00	1960-07-09	38000177		0	0	14		0	0	0	210248	0	243670	19059056		
19114	1577	1127433	1989-10-14	1989-10-14 00:00:00	1989-10-28	1989-10-28 00:00:00	1989-10-28	38000177		0	0	14		0	0	0	105876	0	313782	1127433		
163163	3589	40213314	1981-06-09	1981-06-09 00:00:00	1981-06-09	1981-06-09 00:00:00	1981-06-09	581452		0	0	0		0	0	0	238498	0	49	40213314		
91357	2005	40213227	1995-08-26	1995-08-26 00:00:00	1995-08-26	1995-08-26 00:00:00	1995-08-26	581452		0	0	0		0	0	0	133495	0	113	40213227		
240976	5290	40213227	1995-11-17	1995-11-17 00:00:00	1995-11-17	1995-11-17 00:00:00	1995-11-17	581452		0	0	0		0	0	0	351972	0	113	40213227		
52853	4391	19078461	2016-11-26	2016-11-26 00:00:00	2017-02-24	2017-02-24 00:00:00	2017-02-24	38000177		0	0	90		0	0	0	291943	0	310965	19078461		
42849	3552	40162522	1979-06-25	1979-06-25 00:00:00	1979-06-25	1979-06-25 00:00:00	\N	38000177		0	0	0		0	0	0	235861	0	857005	40162522		
4989	412	1127078	1953-08-13	1953-08-13 00:00:00	1953-08-27	1953-08-27 00:00:00	1953-08-27	38000177		0	0	14		0	0	0	27466	0	282464	1127078		
214860	4712	40213260	2019-03-29	2019-03-29 00:00:00	2019-03-29	2019-03-29 00:00:00	2019-03-29	581452		0	0	0		0	0	0	313785	0	121	40213260		
21153	1743	1713671	1985-05-25	1985-05-25 00:00:00	1985-06-15	1985-06-15 00:00:00	1985-06-15	38000177		0	0	21		0	0	0	116533	0	562251	1713671		
43823	3629	1127433	1990-02-27	1990-02-27 00:00:00	1990-03-13	1990-03-13 00:00:00	1990-03-13	38000177		0	0	14		0	0	0	241472	0	313782	1127433		
66203	1448	40213314	1977-03-02	1977-03-02 00:00:00	1977-03-02	1977-03-02 00:00:00	1977-03-02	581452		0	0	0		0	0	0	96578	0	49	40213314		
54357	4520	1332419	1994-01-22	1994-01-22 00:00:00	1994-01-22	1994-01-22 00:00:00	\N	38000177		0	0	0		0	0	0	300938	0	197361	1332419		
56280	1232	40213296	2006-12-25	2006-12-25 00:00:00	2006-12-25	2006-12-25 00:00:00	2006-12-25	581452		0	0	0		0	0	0	81196	0	52	40213296		
108178	2372	40213260	2010-04-09	2010-04-09 00:00:00	2010-04-09	2010-04-09 00:00:00	2010-04-09	581452		0	0	0		0	0	0	157836	0	121	40213260		
125771	2767	40213227	2018-04-04	2018-04-04 00:00:00	2018-04-04	2018-04-04 00:00:00	2018-04-04	581452		0	0	0		0	0	0	183097	0	113	40213227		
55342	4595	19133873	1970-07-13	1970-07-13 00:00:00	1970-07-22	1970-07-22 00:00:00	1970-07-22	38000177		0	0	9		0	0	0	306150	0	834061	19133873		
8209	176	40213296	2008-10-08	2008-10-08 00:00:00	2008-10-08	2008-10-08 00:00:00	2008-10-08	581452		0	0	0		0	0	0	11945	0	52	40213296		
60578	1323	40213160	1961-08-12	1961-08-12 00:00:00	1961-08-12	1961-08-12 00:00:00	1961-08-12	581452		0	0	0		0	0	0	87809	0	10	40213160		
49058	4071	1713671	1990-05-23	1990-05-23 00:00:00	1990-06-06	1990-06-06 00:00:00	1990-06-06	38000177		0	0	14		0	0	0	270642	0	562251	1713671		
559	41	1127078	1979-12-21	1979-12-21 00:00:00	1980-01-11	1980-01-11 00:00:00	1980-01-11	38000177		0	0	21		0	0	0	2899	0	282464	1127078		
55667	4622	1118084	1997-08-03	1997-08-03 00:00:00	1997-08-03	1997-08-03 00:00:00	\N	38000177		0	0	0		0	0	0	307781	0	00025152531	44923712		
103541	2270	40213160	1978-09-06	1978-09-06 00:00:00	1978-09-06	1978-09-06 00:00:00	1978-09-06	581452		0	0	0		0	0	0	150971	0	10	40213160		
16496	1367	19129655	1965-12-26	1965-12-26 00:00:00	1966-01-09	1966-01-09 00:00:00	1966-01-09	38000177		0	0	14		0	0	0	90591	0	789980	19129655		
21301	1752	1127078	1982-06-20	1982-06-20 00:00:00	1982-07-04	1982-07-04 00:00:00	1982-07-04	38000177		0	0	14		0	0	0	117113	0	282464	1127078		
48591	4026	19129655	1961-04-01	1961-04-01 00:00:00	1961-04-15	1961-04-15 00:00:00	1961-04-15	38000177		0	0	14		0	0	0	267629	0	789980	19129655		
28955	2394	19133905	1978-11-29	1978-11-29 00:00:00	1978-12-09	1978-12-09 00:00:00	1978-12-09	38000177		0	0	10		0	0	0	159121	0	834102	19133905		
54064	4492	1127433	1964-03-23	1964-03-23 00:00:00	1964-05-22	1964-05-22 00:00:00	1964-05-22	38000177		0	0	60		0	0	0	299048	0	313782	1127433		
3680	304	1127433	2004-03-22	2004-03-22 00:00:00	2004-04-19	2004-04-19 00:00:00	2004-04-19	38000177		0	0	28		0	0	0	20256	0	313782	1127433		
48673	4032	1118084	1991-01-22	1991-01-22 00:00:00	1991-01-22	1991-01-22 00:00:00	\N	38000177		0	0	0		0	0	0	268195	0	00025152531	44923712		
14164	1185	1713671	1976-09-28	1976-09-28 00:00:00	1976-10-05	1976-10-05 00:00:00	1976-10-05	38000177		0	0	7		0	0	0	78103	0	562251	1713671		
7556	636	40171902	1999-05-28	1999-05-28 00:00:00	1999-05-28	1999-05-28 00:00:00	\N	38000177		0	0	0		0	0	0	42125	0	897718	40171902		
888	19	40213160	1955-01-16	1955-01-16 00:00:00	1955-01-16	1955-01-16 00:00:00	1955-01-16	581452		0	0	0		0	0	0	1491	0	10	40213160		
59293	4927	19019979	1977-10-20	1977-10-20 00:00:00	1977-11-03	1977-11-03 00:00:00	1977-11-03	38000177		0	0	14		0	0	0	327488	0	198405	19019979		
143738	3159	40213296	1999-07-01	1999-07-01 00:00:00	1999-07-01	1999-07-01 00:00:00	1999-07-01	581452		0	0	0		0	0	0	210030	0	52	40213296		
63057	5239	1713671	2006-08-21	2006-08-21 00:00:00	2006-08-28	2006-08-28 00:00:00	2006-08-28	38000177		0	0	7		0	0	0	348542	0	562251	1713671		
12340	266	40213227	2008-05-12	2008-05-12 00:00:00	2008-05-12	2008-05-12 00:00:00	2008-05-12	581452		0	0	0		0	0	0	17642	0	113	40213227		
13501	1132	1713671	1963-07-19	1963-07-19 00:00:00	1963-08-09	1963-08-09 00:00:00	1963-08-09	38000177		0	0	21		0	0	0	74506	0	562251	1713671		
39765	3289	1127078	1958-10-27	1958-10-27 00:00:00	1958-11-10	1958-11-10 00:00:00	1958-11-10	38000177		0	0	14		0	0	0	218508	0	282464	1127078		
131736	2895	40213160	1958-03-30	1958-03-30 00:00:00	1958-03-30	1958-03-30 00:00:00	1958-03-30	581452		0	0	0		0	0	0	192696	0	10	40213160		
31487	2610	19059056	1969-05-18	1969-05-18 00:00:00	1969-07-17	1969-07-17 00:00:00	1969-07-17	38000177		0	0	60		0	0	0	172594	0	243670	19059056		
136984	3007	40213296	2006-05-31	2006-05-31 00:00:00	2006-05-31	2006-05-31 00:00:00	2006-05-31	581452		0	0	0		0	0	0	200595	0	52	40213296		
28591	2357	1713671	1956-05-06	1956-05-06 00:00:00	1956-05-20	1956-05-20 00:00:00	1956-05-20	38000177		0	0	14		0	0	0	157017	0	562251	1713671		
24232	1991	1127433	1988-08-19	1988-08-19 00:00:00	1988-08-26	1988-08-26 00:00:00	1988-08-26	38000177		0	0	7		0	0	0	132633	0	313782	1127433		
95718	2098	40213160	1963-03-13	1963-03-13 00:00:00	1963-03-13	1963-03-13 00:00:00	1963-03-13	581452		0	0	0		0	0	0	139880	0	10	40213160		
46284	3834	19059056	1959-11-12	1959-11-12 00:00:00	1959-11-26	1959-11-26 00:00:00	1959-11-26	38000177		0	0	14		0	0	0	254555	0	243670	19059056		
236513	5194	40213201	2012-02-23	2012-02-23 00:00:00	2012-02-23	2012-02-23 00:00:00	2012-02-23	581452		0	0	0		0	0	0	345283	0	33	40213201		
51720	1132	40213198	2018-07-30	2018-07-30 00:00:00	2018-07-30	2018-07-30 00:00:00	2018-07-30	581452		0	0	0		0	0	0	74521	0	133	40213198		
39317	3248	920334	1989-08-15	1989-08-15 00:00:00	1989-08-22	1989-08-22 00:00:00	1989-08-22	38000177		0	0	7		0	0	0	215847	0	311995	920334		
28005	2318	19078924	1969-03-09	1969-03-09 00:00:00	1969-03-09	1969-03-09 00:00:00	1969-03-09	38000177		0	0	0		0	0	0	154115	0	311700	19078924		
37583	820	40213160	1964-10-29	1964-10-29 00:00:00	1964-10-29	1964-10-29 00:00:00	1964-10-29	581452		0	0	0		0	0	0	54336	0	10	40213160		
7416	160	40213160	1961-11-02	1961-11-02 00:00:00	1961-11-02	1961-11-02 00:00:00	1961-11-02	581452		0	0	0		0	0	0	11007	0	10	40213160		
239837	5264	40213227	2018-11-06	2018-11-06 00:00:00	2018-11-06	2018-11-06 00:00:00	2018-11-06	581452		0	0	0		0	0	0	350224	0	113	40213227		
44616	3694	40236446	1965-04-07	1965-04-07 00:00:00	1966-02-09	1966-02-09 00:00:00	1966-02-09	38000177		0	0	308		0	0	0	245510	0	1091392	40236446		
78968	1727	40213201	2015-11-18	2015-11-18 00:00:00	2015-11-18	2015-11-18 00:00:00	2015-11-18	581452		0	0	0		0	0	0	115479	0	33	40213201		
70642	1545	40213296	2012-10-12	2012-10-12 00:00:00	2012-10-12	2012-10-12 00:00:00	2012-10-12	581452		0	0	0		0	0	0	103493	0	52	40213296		
48092	3987	920300	2004-01-26	2004-01-26 00:00:00	2004-02-02	2004-02-02 00:00:00	2004-02-02	38000177		0	0	7		0	0	0	265066	0	311989	920300		
174442	3835	40213160	1970-08-29	1970-08-29 00:00:00	1970-08-29	1970-08-29 00:00:00	1970-08-29	581452		0	0	0		0	0	0	254653	0	10	40213160		
182889	4019	40213160	1963-08-06	1963-08-06 00:00:00	1963-08-06	1963-08-06 00:00:00	1963-08-06	581452		0	0	0		0	0	0	267156	0	10	40213160		
59856	4976	1115171	1995-01-25	1995-01-25 00:00:00	1995-02-15	1995-02-15 00:00:00	1995-02-15	38000177		0	0	21		0	0	0	331108	0	849574	1115171		
104614	2294	40213306	1983-01-28	1983-01-28 00:00:00	1983-01-28	1983-01-28 00:00:00	1983-01-28	581452		0	0	0		0	0	0	152665	0	43	40213306		
59921	4979	19128065	1993-07-04	1993-07-04 00:00:00	1994-06-29	1994-06-29 00:00:00	1994-06-29	38000177		0	0	360		0	0	0	331281	0	749882	19128065		
137344	3014	40213306	1996-03-01	1996-03-01 00:00:00	1996-03-01	1996-03-01 00:00:00	1996-03-01	581452		0	0	0		0	0	0	201028	0	43	40213306		
186696	4101	40213160	1964-10-03	1964-10-03 00:00:00	1964-10-03	1964-10-03 00:00:00	1964-10-03	581452		0	0	0		0	0	0	272503	0	10	40213160		
38217	3161	19059056	1970-07-08	1970-07-08 00:00:00	1970-07-29	1970-07-29 00:00:00	1970-07-29	38000177		0	0	21		0	0	0	210203	0	243670	19059056		
19115	1578	1713671	1992-07-31	1992-07-31 00:00:00	1992-08-21	1992-08-21 00:00:00	1992-08-21	38000177		0	0	21		0	0	0	106010	0	562251	1713671		
163164	3589	40213160	1981-06-09	1981-06-09 00:00:00	1981-06-09	1981-06-09 00:00:00	1981-06-09	581452		0	0	0		0	0	0	238498	0	10	40213160		
91363	2005	40213160	1974-01-19	1974-01-19 00:00:00	1974-01-19	1974-01-19 00:00:00	1974-01-19	581452		0	0	0		0	0	0	133484	0	10	40213160		
240977	5290	40213160	1955-01-14	1955-01-14 00:00:00	1955-01-14	1955-01-14 00:00:00	1955-01-14	581452		0	0	0		0	0	0	352013	0	10	40213160		
52854	4391	40165015	2016-11-26	2016-11-26 00:00:00	2016-11-26	2016-11-26 00:00:00	\N	38000177		0	0	0		0	0	0	291943	0	861467	40165015		
42850	3552	19059056	1979-06-25	1979-06-25 00:00:00	1979-07-23	1979-07-23 00:00:00	1979-07-23	38000177		0	0	28		0	0	0	235861	0	243670	19059056		
5007	418	1127078	1958-07-20	1958-07-20 00:00:00	1958-08-03	1958-08-03 00:00:00	1958-08-03	38000177		0	0	14		0	0	0	27667	0	282464	1127078		
214862	4712	40213160	1972-12-29	1972-12-29 00:00:00	1972-12-29	1972-12-29 00:00:00	1972-12-29	581452		0	0	0		0	0	0	313768	0	10	40213160		
21154	1743	1713671	1986-08-16	1986-08-16 00:00:00	1986-08-23	1986-08-23 00:00:00	1986-08-23	38000177		0	0	7		0	0	0	116482	0	562251	1713671		
43824	3629	1118084	2000-07-27	2000-07-27 00:00:00	2000-07-27	2000-07-27 00:00:00	\N	38000177		0	0	0		0	0	0	241452	0	00025152531	44923712		
66205	1448	40213160	1973-12-05	1973-12-05 00:00:00	1973-12-05	1973-12-05 00:00:00	1973-12-05	581452		0	0	0		0	0	0	96627	0	10	40213160		
54358	4520	1118084	1962-05-15	1962-05-15 00:00:00	1962-05-15	1962-05-15 00:00:00	\N	38000177		0	0	0		0	0	0	300923	0	00025152531	44923712		
56289	1232	40213260	2014-12-15	2014-12-15 00:00:00	2014-12-15	2014-12-15 00:00:00	2014-12-15	581452		0	0	0		0	0	0	81216	0	121	40213260		
108187	2372	40213227	2001-04-13	2001-04-13 00:00:00	2001-04-13	2001-04-13 00:00:00	2001-04-13	581452		0	0	0		0	0	0	157877	0	113	40213227		
125775	2767	40213227	1997-06-11	1997-06-11 00:00:00	1997-06-11	1997-06-11 00:00:00	1997-06-11	581452		0	0	0		0	0	0	183062	0	113	40213227		
55343	4595	1127433	1986-04-01	1986-04-01 00:00:00	1986-04-08	1986-04-08 00:00:00	1986-04-08	38000177		0	0	7		0	0	0	306187	0	313782	1127433		
8211	177	40213227	1998-02-15	1998-02-15 00:00:00	1998-02-15	1998-02-15 00:00:00	1998-02-15	581452		0	0	0		0	0	0	11990	0	113	40213227		
60580	1323	40213227	1992-07-25	1992-07-25 00:00:00	1992-07-25	1992-07-25 00:00:00	1992-07-25	581452		0	0	0		0	0	0	87866	0	113	40213227		
49060	4071	19133905	2014-01-08	2014-01-08 00:00:00	2014-01-17	2014-01-17 00:00:00	2014-01-17	38000177		0	0	9		0	0	0	270628	0	834102	19133905		
560	41	1118084	2008-07-31	2008-07-31 00:00:00	2008-07-31	2008-07-31 00:00:00	\N	38000177		0	0	0		0	0	0	2911	0	00025152531	44923712		
55668	4622	1127433	1986-09-14	1986-09-14 00:00:00	1986-09-28	1986-09-28 00:00:00	1986-09-28	38000177		0	0	14		0	0	0	307816	0	313782	1127433		
103542	2270	40213314	1978-09-06	1978-09-06 00:00:00	1978-09-06	1978-09-06 00:00:00	1978-09-06	581452		0	0	0		0	0	0	150971	0	49	40213314		
16497	1367	1127078	1967-11-29	1967-11-29 00:00:00	1967-12-13	1967-12-13 00:00:00	1967-12-13	38000177		0	0	14		0	0	0	90609	0	282464	1127078		
21302	1752	19073183	1982-06-20	1982-06-20 00:00:00	1982-07-04	1982-07-04 00:00:00	1982-07-04	38000177		0	0	14		0	0	0	117113	0	308182	19073183		
48592	4026	1154615	1960-02-02	1960-02-02 00:00:00	1960-02-02	1960-02-02 00:00:00	\N	38000177		0	0	0		0	0	0	267729	0	745679	1154615		
28956	2394	40162522	1988-01-06	1988-01-06 00:00:00	1988-01-06	1988-01-06 00:00:00	\N	38000177		0	0	0		0	0	0	159215	0	857005	40162522		
54065	4492	19078461	1996-12-21	1996-12-21 00:00:00	1997-01-04	1997-01-04 00:00:00	1997-01-04	38000177		0	0	14		0	0	0	299095	0	310965	19078461		
3681	304	1127433	2010-04-21	2010-04-21 00:00:00	2010-04-28	2010-04-28 00:00:00	2010-04-28	38000177		0	0	7		0	0	0	20276	0	313782	1127433		
48674	4032	1127433	1979-01-31	1979-01-31 00:00:00	1979-02-07	1979-02-07 00:00:00	1979-02-07	38000177		0	0	7		0	0	0	268242	0	313782	1127433		
14165	1185	19059056	1939-08-16	1939-08-16 00:00:00	1939-08-30	1939-08-30 00:00:00	1939-08-30	38000177		0	0	14		0	0	0	78127	0	243670	19059056		
7557	636	19018935	1999-05-28	1999-05-28 00:00:00	1999-05-28	1999-05-28 00:00:00	\N	38000177		0	0	0		0	0	0	42125	0	197604	19018935		
893	19	40213227	2010-04-04	2010-04-04 00:00:00	2010-04-04	2010-04-04 00:00:00	2010-04-04	581452		0	0	0		0	0	0	1465	0	113	40213227		
59294	4927	19006318	1977-10-20	1977-10-20 00:00:00	1977-11-03	1977-11-03 00:00:00	1977-11-03	38000177		0	0	14		0	0	0	327488	0	105078	19006318		
143740	3159	40213160	1964-06-04	1964-06-04 00:00:00	1964-06-04	1964-06-04 00:00:00	1964-06-04	581452		0	0	0		0	0	0	210062	0	10	40213160		
63058	5239	1127433	1968-10-11	1968-10-11 00:00:00	1968-10-18	1968-10-18 00:00:00	1968-10-18	38000177		0	0	7		0	0	0	348547	0	313782	1127433		
12342	266	40213160	1966-08-08	1966-08-08 00:00:00	1966-08-08	1966-08-08 00:00:00	1966-08-08	581452		0	0	0		0	0	0	17738	0	10	40213160		
13502	1132	19059056	1963-04-12	1963-04-12 00:00:00	1963-06-18	1963-06-18 00:00:00	1963-06-18	38000177		0	0	67		0	0	0	74510	0	243670	19059056		
39768	3289	1127078	1957-12-29	1957-12-29 00:00:00	1958-01-12	1958-01-12 00:00:00	1958-01-12	38000177		0	0	14		0	0	0	218507	0	282464	1127078		
131740	2895	40213227	2000-01-02	2000-01-02 00:00:00	2000-01-02	2000-01-02 00:00:00	2000-01-02	581452		0	0	0		0	0	0	192711	0	113	40213227		
31488	2610	1118084	1992-06-17	1992-06-17 00:00:00	1992-06-17	1992-06-17 00:00:00	\N	38000177		0	0	0		0	0	0	172599	0	00025152531	44923712		
136987	3007	40213160	1966-08-31	1966-08-31 00:00:00	1966-08-31	1966-08-31 00:00:00	1966-08-31	581452		0	0	0		0	0	0	200591	0	10	40213160		
28592	2357	1127433	1953-07-31	1953-07-31 00:00:00	1953-08-14	1953-08-14 00:00:00	1953-08-14	38000177		0	0	14		0	0	0	157080	0	313782	1127433		
24233	1991	19075601	1997-11-03	1997-11-03 00:00:00	2011-02-21	2011-02-21 00:00:00	2011-02-21	38000177		0	0	4858		0	0	0	132571	0	309362	19075601		
95724	2098	40213160	1967-06-14	1967-06-14 00:00:00	1967-06-14	1967-06-14 00:00:00	1967-06-14	581452		0	0	0		0	0	0	139850	0	10	40213160		
46285	3834	19006318	1959-11-12	1959-11-12 00:00:00	1959-11-26	1959-11-26 00:00:00	1959-11-26	38000177		0	0	14		0	0	0	254555	0	105078	19006318		
39209	3240	1713671	1975-04-21	1975-04-21 00:00:00	1975-05-12	1975-05-12 00:00:00	1975-05-12	38000177		0	0	21		0	0	0	215343	0	562251	1713671		
51726	1132	40213227	2014-07-07	2014-07-07 00:00:00	2014-07-07	2014-07-07 00:00:00	2014-07-07	581452		0	0	0		0	0	0	74520	0	113	40213227		
39318	3248	19133873	1958-09-07	1958-09-07 00:00:00	1958-09-18	1958-09-18 00:00:00	1958-09-18	38000177		0	0	11		0	0	0	215844	0	834061	19133873		
28006	2318	782047	1969-03-09	1969-03-09 00:00:00	1969-03-09	1969-03-09 00:00:00	1969-03-09	38000177		0	0	0		0	0	0	154115	0	542347	782047		
37590	820	40213160	1965-01-28	1965-01-28 00:00:00	1965-01-28	1965-01-28 00:00:00	1965-01-28	581452		0	0	0		0	0	0	54365	0	10	40213160		
7425	160	40213160	1966-01-13	1966-01-13 00:00:00	1966-01-13	1966-01-13 00:00:00	1966-01-13	581452		0	0	0		0	0	0	\N	0	10	40213160		
239838	5264	40213260	2018-11-06	2018-11-06 00:00:00	2018-11-06	2018-11-06 00:00:00	2018-11-06	581452		0	0	0		0	0	0	350224	0	121	40213260		
44617	3694	19059056	1972-12-21	1972-12-21 00:00:00	1973-01-20	1973-01-20 00:00:00	1973-01-20	38000177		0	0	30		0	0	0	245561	0	243670	19059056		
78971	1727	40213198	2014-11-12	2014-11-12 00:00:00	2014-11-12	2014-11-12 00:00:00	2014-11-12	581452		0	0	0		0	0	0	115453	0	133	40213198		
157384	3464	40213160	1980-08-20	1980-08-20 00:00:00	1980-08-20	1980-08-20 00:00:00	1980-08-20	581452		0	0	0		0	0	0	229945	0	10	40213160		
48093	3987	40236824	2004-01-26	2004-01-26 00:00:00	2004-02-02	2004-02-02 00:00:00	2004-02-02	38000177		0	0	7		0	0	0	265066	0	1094107	40236824		
174445	3835	40213260	2015-09-19	2015-09-19 00:00:00	2015-09-19	2015-09-19 00:00:00	2015-09-19	581452		0	0	0		0	0	0	254666	0	121	40213260		
182895	4019	40213227	1995-08-01	1995-08-01 00:00:00	1995-08-01	1995-08-01 00:00:00	1995-08-01	581452		0	0	0		0	0	0	267123	0	113	40213227		
59857	4976	19006318	1952-10-09	1952-10-09 00:00:00	1952-11-06	1952-11-06 00:00:00	1952-11-06	38000177		0	0	28		0	0	0	331104	0	105078	19006318		
104616	2294	40213160	1961-05-05	1961-05-05 00:00:00	1961-05-05	1961-05-05 00:00:00	1961-05-05	581452		0	0	0		0	0	0	152682	0	10	40213160		
2538	57	40213306	1982-07-19	1982-07-19 00:00:00	1982-07-19	1982-07-19 00:00:00	1982-07-19	581452		0	0	0		0	0	0	3882	0	43	40213306		
137349	3014	40213160	1973-12-07	1973-12-07 00:00:00	1973-12-07	1973-12-07 00:00:00	1973-12-07	581452		0	0	0		0	0	0	201039	0	10	40213160		
31647	2622	40229134	1941-05-16	1941-05-16 00:00:00	1941-05-30	1941-05-30 00:00:00	1941-05-30	38000177		0	0	14		0	0	0	173471	0	1043400	40229134		
38218	3161	1127078	1957-09-11	1957-09-11 00:00:00	1957-10-09	1957-10-09 00:00:00	1957-10-09	38000177		0	0	28		0	0	0	210247	0	282464	1127078		
19116	1578	1127433	1999-08-22	1999-08-22 00:00:00	1999-11-20	1999-11-20 00:00:00	1999-11-20	38000177		0	0	90		0	0	0	105970	0	313782	1127433		
202691	4450	40213160	1972-06-17	1972-06-17 00:00:00	1972-06-17	1972-06-17 00:00:00	1972-06-17	581452		0	0	0		0	0	0	296095	0	10	40213160		
91365	2005	40213160	1974-04-20	1974-04-20 00:00:00	1974-04-20	1974-04-20 00:00:00	1974-04-20	581452		0	0	0		0	0	0	133536	0	10	40213160		
240979	5290	40213227	2004-11-12	2004-11-12 00:00:00	2004-11-12	2004-11-12 00:00:00	2004-11-12	581452		0	0	0		0	0	0	352007	0	113	40213227		
52855	4391	19133905	1983-09-19	1983-09-19 00:00:00	1983-09-30	1983-09-30 00:00:00	1983-09-30	38000177		0	0	11		0	0	0	291960	0	834102	19133905		
42851	3552	19006318	1958-10-19	1958-10-19 00:00:00	1958-11-02	1958-11-02 00:00:00	1958-11-02	38000177		0	0	14		0	0	0	235854	0	105078	19006318		
5008	418	19059056	1964-01-20	1964-01-20 00:00:00	1964-02-03	1964-02-03 00:00:00	1964-02-03	38000177		0	0	14		0	0	0	27637	0	243670	19059056		
214864	4712	40213227	2019-03-29	2019-03-29 00:00:00	2019-03-29	2019-03-29 00:00:00	2019-03-29	581452		0	0	0		0	0	0	313785	0	113	40213227		
21155	1743	19059056	1974-10-05	1974-10-05 00:00:00	1974-10-19	1974-10-19 00:00:00	1974-10-19	38000177		0	0	14		0	0	0	116508	0	243670	19059056		
54285	4513	1127433	1969-02-03	1969-02-03 00:00:00	1969-02-10	1969-02-10 00:00:00	1969-02-10	38000177		0	0	7		0	0	0	300580	0	313782	1127433		
77508	1695	40213306	1986-09-18	1986-09-18 00:00:00	1986-09-18	1986-09-18 00:00:00	1986-09-18	581452		0	0	0		0	0	0	113502	0	43	40213306		
54359	4520	19006318	1950-03-04	1950-03-04 00:00:00	1950-03-18	1950-03-18 00:00:00	1950-03-18	38000177		0	0	14		0	0	0	300878	0	105078	19006318		
56291	1232	40213160	1965-08-23	1965-08-23 00:00:00	1965-08-23	1965-08-23 00:00:00	1965-08-23	581452		0	0	0		0	0	0	81183	0	10	40213160		
108188	2372	40213296	2001-04-13	2001-04-13 00:00:00	2001-04-13	2001-04-13 00:00:00	2001-04-13	581452		0	0	0		0	0	0	157877	0	52	40213296		
67673	1480	40213227	1998-05-22	1998-05-22 00:00:00	1998-05-22	1998-05-22 00:00:00	1998-05-22	581452		0	0	0		0	0	0	98758	0	113	40213227		
55344	4595	1115171	2017-01-31	2017-01-31 00:00:00	2017-02-14	2017-02-14 00:00:00	2017-02-14	38000177		0	0	14		0	0	0	306180	0	849574	1115171		
8214	177	40213306	1989-02-05	1989-02-05 00:00:00	1989-02-05	1989-02-05 00:00:00	1989-02-05	581452		0	0	0		0	0	0	11950	0	43	40213306		
140527	3086	40213296	2008-10-01	2008-10-01 00:00:00	2008-10-01	2008-10-01 00:00:00	2008-10-01	581452		0	0	0		0	0	0	205485	0	52	40213296		
49061	4071	19078461	2003-06-24	2003-06-24 00:00:00	2003-07-08	2003-07-08 00:00:00	2003-07-08	38000177		0	0	14		0	0	0	270615	0	310965	19078461		
561	41	40169216	1975-06-02	1975-06-02 00:00:00	1975-06-02	1975-06-02 00:00:00	\N	38000177		0	0	0		0	0	0	2934	0	895994	40169216		
55669	4623	19059056	1938-03-28	1938-03-28 00:00:00	1938-05-02	1938-05-02 00:00:00	1938-05-02	38000177		0	0	35		0	0	0	308003	0	243670	19059056		
103558	2272	40213314	1981-02-07	1981-02-07 00:00:00	1981-02-07	1981-02-07 00:00:00	1981-02-07	581452		0	0	0		0	0	0	151062	0	49	40213314		
16498	1367	40236824	2002-06-04	2002-06-04 00:00:00	2002-06-11	2002-06-11 00:00:00	2002-06-11	38000177		0	0	7		0	0	0	90600	0	1094107	40236824		
21303	1752	1713671	2015-01-26	2015-01-26 00:00:00	2015-03-02	2015-03-02 00:00:00	2015-03-02	38000177		0	0	35		0	0	0	117123	0	562251	1713671		
48593	4026	40169216	1960-02-02	1960-02-02 00:00:00	1960-02-02	1960-02-02 00:00:00	\N	38000177		0	0	0		0	0	0	267729	0	895994	40169216		
28957	2394	19059056	1916-11-14	1916-11-14 00:00:00	1916-11-28	1916-11-28 00:00:00	1916-11-28	38000177		0	0	14		0	0	0	159124	0	243670	19059056		
54066	4492	1127433	1981-03-24	1981-03-24 00:00:00	1981-04-14	1981-04-14 00:00:00	1981-04-14	38000177		0	0	21		0	0	0	299092	0	313782	1127433		
3682	304	1127433	1968-10-01	1968-10-01 00:00:00	1968-11-05	1968-11-05 00:00:00	1968-11-05	38000177		0	0	35		0	0	0	20211	0	313782	1127433		
48675	4032	19133905	2007-06-22	2007-06-22 00:00:00	2007-07-04	2007-07-04 00:00:00	2007-07-04	38000177		0	0	12		0	0	0	268283	0	834102	19133905		
14166	1185	40220960	2018-09-23	2018-09-23 00:00:00	2018-09-23	2018-09-23 00:00:00	2018-09-23	38000177		0	0	0		0	0	0	78151	0	1804799	40220960		
7558	636	40163554	1999-05-28	1999-05-28 00:00:00	1999-05-28	1999-05-28 00:00:00	\N	38000177		0	0	0		0	0	0	42125	0	855332	40163554		
12184	263	40213227	2015-08-23	2015-08-23 00:00:00	2015-08-23	2015-08-23 00:00:00	2015-08-23	581452		0	0	0		0	0	0	17493	0	113	40213227		
59295	4927	40224805	1995-06-28	1995-06-28 00:00:00	1996-06-22	1996-06-22 00:00:00	1996-06-22	38000177		0	0	360		0	0	0	327447	0	1000126	40224805		
143742	3159	40213227	1993-07-29	1993-07-29 00:00:00	1993-07-29	1993-07-29 00:00:00	1993-07-29	581452		0	0	0		0	0	0	210068	0	113	40213227		
63059	5239	40229134	2004-09-23	2004-09-23 00:00:00	2004-10-07	2004-10-07 00:00:00	2004-10-07	38000177		0	0	14		0	0	0	348541	0	1043400	40229134		
12344	266	40213260	2016-05-02	2016-05-02 00:00:00	2016-05-02	2016-05-02 00:00:00	2016-05-02	581452		0	0	0		0	0	0	17636	0	121	40213260		
13503	1132	1127433	2002-01-27	2002-01-27 00:00:00	2002-02-03	2002-02-03 00:00:00	2002-02-03	38000177		0	0	7		0	0	0	74537	0	313782	1127433		
39769	3289	19006318	1957-12-29	1957-12-29 00:00:00	1958-01-12	1958-01-12 00:00:00	1958-01-12	38000177		0	0	14		0	0	0	218507	0	105078	19006318		
131741	2895	40213296	2000-01-02	2000-01-02 00:00:00	2000-01-02	2000-01-02 00:00:00	2000-01-02	581452		0	0	0		0	0	0	192711	0	52	40213296		
31489	2611	1115171	2016-08-27	2016-08-27 00:00:00	2016-09-17	2016-09-17 00:00:00	2016-09-17	38000177		0	0	21		0	0	0	172655	0	849574	1115171		
136991	3007	40213227	2017-05-31	2017-05-31 00:00:00	2017-05-31	2017-05-31 00:00:00	2017-05-31	581452		0	0	0		0	0	0	200611	0	113	40213227		
28593	2357	1127433	1973-05-02	1973-05-02 00:00:00	1973-05-09	1973-05-09 00:00:00	1973-05-09	38000177		0	0	7		0	0	0	157094	0	313782	1127433		
24234	1991	19073188	1988-01-14	1988-01-14 00:00:00	1988-01-28	1988-01-28 00:00:00	1988-01-28	38000177		0	0	14		0	0	0	132609	0	308192	19073188		
95729	2098	40213227	2004-07-14	2004-07-14 00:00:00	2004-07-14	2004-07-14 00:00:00	2004-07-14	581452		0	0	0		0	0	0	139859	0	113	40213227		
46286	3834	1713671	1957-07-11	1957-07-11 00:00:00	1957-07-18	1957-07-18 00:00:00	1957-07-18	38000177		0	0	7		0	0	0	254590	0	562251	1713671		
39210	3240	1127433	2010-09-09	2010-09-09 00:00:00	2010-09-16	2010-09-16 00:00:00	2010-09-16	38000177		0	0	7		0	0	0	215389	0	313782	1127433		
51728	1132	40213160	1956-04-09	1956-04-09 00:00:00	1956-04-09	1956-04-09 00:00:00	1956-04-09	581452		0	0	0		0	0	0	74523	0	10	40213160		
39319	3248	19059056	1948-02-12	1948-02-12 00:00:00	1948-02-26	1948-02-26 00:00:00	1948-02-26	38000177		0	0	14		0	0	0	215930	0	243670	19059056		
28007	2318	1127078	1964-11-16	1964-11-16 00:00:00	1964-12-21	1964-12-21 00:00:00	1964-12-21	38000177		0	0	35		0	0	0	154112	0	282464	1127078		
48868	1070	40213160	1977-10-13	1977-10-13 00:00:00	1977-10-13	1977-10-13 00:00:00	1977-10-13	581452		0	0	0		0	0	0	70086	0	10	40213160		
7430	160	40213227	2003-06-12	2003-06-12 00:00:00	2003-06-12	2003-06-12 00:00:00	2003-06-12	581452		0	0	0		0	0	0	10975	0	113	40213227		
239840	5264	40213160	1968-02-06	1968-02-06 00:00:00	1968-02-06	1968-02-06 00:00:00	1968-02-06	581452		0	0	0		0	0	0	350246	0	10	40213160		
44618	3694	1127078	1961-06-17	1961-06-17 00:00:00	1961-07-01	1961-07-01 00:00:00	1961-07-01	38000177		0	0	14		0	0	0	245482	0	282464	1127078		
122678	2697	40213227	2004-07-08	2004-07-08 00:00:00	2004-07-08	2004-07-08 00:00:00	2004-07-08	581452		0	0	0		0	0	0	178579	0	113	40213227		
157385	3464	40213314	1980-08-20	1980-08-20 00:00:00	1980-08-20	1980-08-20 00:00:00	1980-08-20	581452		0	0	0		0	0	0	229945	0	49	40213314		
48095	3987	1713671	2003-09-25	2003-09-25 00:00:00	2003-10-02	2003-10-02 00:00:00	2003-10-02	38000177		0	0	7		0	0	0	265043	0	562251	1713671		
174451	3835	40213260	2016-09-24	2016-09-24 00:00:00	2016-09-24	2016-09-24 00:00:00	2016-09-24	581452		0	0	0		0	0	0	254694	0	121	40213260		
192356	4226	40213160	1963-07-28	1963-07-28 00:00:00	1963-07-28	1963-07-28 00:00:00	1963-07-28	581452		0	0	0		0	0	0	280743	0	10	40213160		
59858	4976	19059056	1952-10-09	1952-10-09 00:00:00	1952-11-06	1952-11-06 00:00:00	1952-11-06	38000177		0	0	28		0	0	0	331104	0	243670	19059056		
104620	2294	40213160	1961-08-04	1961-08-04 00:00:00	1961-08-04	1961-08-04 00:00:00	1961-08-04	581452		0	0	0		0	0	0	152724	0	10	40213160		
2544	57	40213160	1961-11-27	1961-11-27 00:00:00	1961-11-27	1961-11-27 00:00:00	1961-11-27	581452		0	0	0		0	0	0	3848	0	10	40213160		
137353	3014	40213314	1977-06-04	1977-06-04 00:00:00	1977-06-04	1977-06-04 00:00:00	1977-06-04	581452		0	0	0		0	0	0	201009	0	49	40213314		
31648	2624	1115171	2018-12-26	2018-12-26 00:00:00	2019-01-09	2019-01-09 00:00:00	2019-01-09	38000177		0	0	14		0	0	0	173625	0	849574	1115171		
38219	3161	1124300	1989-10-23	1989-10-23 00:00:00	1989-10-23	1989-10-23 00:00:00	\N	38000177		0	0	0		0	0	0	210234	0	00781178901	45011828		
19117	1578	40162522	1999-08-22	1999-08-22 00:00:00	1999-08-22	1999-08-22 00:00:00	\N	38000177		0	0	0		0	0	0	105970	0	857005	40162522		
42243	3505	1127433	1993-02-16	1993-02-16 00:00:00	1993-03-09	1993-03-09 00:00:00	1993-03-09	38000177		0	0	21		0	0	0	232380	0	313782	1127433		
91367	2005	40213227	2015-05-16	2015-05-16 00:00:00	2015-05-16	2015-05-16 00:00:00	2015-05-16	581452		0	0	0		0	0	0	133543	0	113	40213227		
240981	5290	40213260	2006-06-09	2006-06-09 00:00:00	2006-06-09	2006-06-09 00:00:00	2006-06-09	581452		0	0	0		0	0	0	351902	0	121	40213260		
52856	4391	19133873	1955-07-06	1955-07-06 00:00:00	1955-07-16	1955-07-16 00:00:00	1955-07-16	38000177		0	0	10		0	0	0	292011	0	834061	19133873		
42852	3552	19059056	1958-10-19	1958-10-19 00:00:00	1958-11-02	1958-11-02 00:00:00	1958-11-02	38000177		0	0	14		0	0	0	235854	0	243670	19059056		
5009	418	19129655	1964-01-20	1964-01-20 00:00:00	1964-02-03	1964-02-03 00:00:00	1964-02-03	38000177		0	0	14		0	0	0	27637	0	789980	19129655		
238115	5228	40213227	2006-10-19	2006-10-19 00:00:00	2006-10-19	2006-10-19 00:00:00	2006-10-19	581452		0	0	0		0	0	0	347844	0	113	40213227		
21156	1744	19133905	1994-05-24	1994-05-24 00:00:00	1994-06-05	1994-06-05 00:00:00	1994-06-05	38000177		0	0	12		0	0	0	116613	0	834102	19133905		
54286	4513	19133905	1982-02-07	1982-02-07 00:00:00	1982-02-16	1982-02-16 00:00:00	1982-02-16	38000177		0	0	9		0	0	0	300545	0	834102	19133905		
77511	1695	40213227	1999-03-18	1999-03-18 00:00:00	1999-03-18	1999-03-18 00:00:00	1999-03-18	581452		0	0	0		0	0	0	113470	0	113	40213227		
54360	4520	19059056	1950-03-04	1950-03-04 00:00:00	1950-03-18	1950-03-18 00:00:00	1950-03-18	38000177		0	0	14		0	0	0	300878	0	243670	19059056		
56297	1232	40213160	1969-09-01	1969-09-01 00:00:00	1969-09-01	1969-09-01 00:00:00	1969-09-01	581452		0	0	0		0	0	0	81174	0	10	40213160		
108198	2372	40213306	1981-07-31	1981-07-31 00:00:00	1981-07-31	1981-07-31 00:00:00	1981-07-31	581452		0	0	0		0	0	0	157874	0	43	40213306		
67682	1480	40213306	1989-05-12	1989-05-12 00:00:00	1989-05-12	1989-05-12 00:00:00	1989-05-12	581452		0	0	0		0	0	0	98730	0	43	40213306		
55345	4595	19129655	1965-03-28	1965-03-28 00:00:00	1965-04-11	1965-04-11 00:00:00	1965-04-11	38000177		0	0	14		0	0	0	306173	0	789980	19129655		
8215	177	40213160	1967-01-01	1967-01-01 00:00:00	1967-01-01	1967-01-01 00:00:00	1967-01-01	581452		0	0	0		0	0	0	11963	0	10	40213160		
140533	3086	40213160	1973-09-05	1973-09-05 00:00:00	1973-09-05	1973-09-05 00:00:00	1973-09-05	581452		0	0	0		0	0	0	205455	0	10	40213160		
49062	4071	1127078	1961-04-18	1961-04-18 00:00:00	1961-05-23	1961-05-23 00:00:00	1961-05-23	38000177		0	0	35		0	0	0	270581	0	282464	1127078		
562	41	1154615	1975-06-02	1975-06-02 00:00:00	1975-06-02	1975-06-02 00:00:00	\N	38000177		0	0	0		0	0	0	2934	0	745679	1154615		
55670	4623	19133905	1968-02-05	1968-02-05 00:00:00	1968-02-16	1968-02-16 00:00:00	1968-02-16	38000177		0	0	11		0	0	0	307897	0	834102	19133905		
103561	2272	40213160	1980-03-08	1980-03-08 00:00:00	1980-03-08	1980-03-08 00:00:00	1980-03-08	581452		0	0	0		0	0	0	151008	0	10	40213160		
16499	1367	920300	2002-06-04	2002-06-04 00:00:00	2002-06-11	2002-06-11 00:00:00	2002-06-11	38000177		0	0	7		0	0	0	90600	0	311989	920300		
21304	1752	1127433	1993-06-07	1993-06-07 00:00:00	1993-06-21	1993-06-21 00:00:00	1993-06-21	38000177		0	0	14		0	0	0	117153	0	313782	1127433		
48594	4026	40229134	2013-06-05	2013-06-05 00:00:00	2013-06-19	2013-06-19 00:00:00	2013-06-19	38000177		0	0	14		0	0	0	267599	0	1043400	40229134		
28958	2394	1127433	1979-10-20	1979-10-20 00:00:00	1979-12-19	1979-12-19 00:00:00	1979-12-19	38000177		0	0	60		0	0	0	159214	0	313782	1127433		
54067	4492	19059056	1959-05-19	1959-05-19 00:00:00	1959-06-18	1959-06-18 00:00:00	1959-06-18	38000177		0	0	30		0	0	0	299047	0	243670	19059056		
3683	304	1127433	2018-05-26	2018-05-26 00:00:00	2018-06-09	2018-06-09 00:00:00	2018-06-09	38000177		0	0	14		0	0	0	20255	0	313782	1127433		
48676	4032	1127078	1953-04-16	1953-04-16 00:00:00	1953-04-30	1953-04-30 00:00:00	1953-04-30	38000177		0	0	14		0	0	0	268265	0	282464	1127078		
14167	1185	19075601	2018-09-23	2018-09-23 00:00:00	2018-09-23	2018-09-23 00:00:00	2018-09-23	38000177		0	0	0		0	0	0	78151	0	309362	19075601		
7559	636	1127433	2017-03-19	2017-03-19 00:00:00	2017-03-26	2017-03-26 00:00:00	2017-03-26	38000177		0	0	7		0	0	0	42158	0	313782	1127433		
12187	263	40213160	1955-05-29	1955-05-29 00:00:00	1955-05-29	1955-05-29 00:00:00	1955-05-29	581452		0	0	0		0	0	0	17474	0	10	40213160		
59296	4927	1713671	1982-08-01	1982-08-01 00:00:00	1982-08-15	1982-08-15 00:00:00	1982-08-15	38000177		0	0	14		0	0	0	327484	0	562251	1713671		
15389	1283	19059056	1962-11-25	1962-11-25 00:00:00	1962-12-23	1962-12-23 00:00:00	1962-12-23	38000177		0	0	28		0	0	0	84820	0	243670	19059056		
63060	5239	19059056	1966-07-22	1966-07-22 00:00:00	1966-08-05	1966-08-05 00:00:00	1966-08-05	38000177		0	0	14		0	0	0	348543	0	243670	19059056		
12348	266	40213227	1998-03-30	1998-03-30 00:00:00	1998-03-30	1998-03-30 00:00:00	1998-03-30	581452		0	0	0		0	0	0	17706	0	113	40213227		
13504	1132	1127433	1998-03-10	1998-03-10 00:00:00	1998-03-17	1998-03-17 00:00:00	1998-03-17	38000177		0	0	7		0	0	0	74494	0	313782	1127433		
39770	3289	1127433	1989-06-07	1989-06-07 00:00:00	1989-06-14	1989-06-14 00:00:00	1989-06-14	38000177		0	0	7		0	0	0	218530	0	313782	1127433		
131744	2895	40213296	1997-12-28	1997-12-28 00:00:00	1997-12-28	1997-12-28 00:00:00	1997-12-28	581452		0	0	0		0	0	0	192758	0	52	40213296		
31490	2611	19133905	1974-07-14	1974-07-14 00:00:00	1974-07-27	1974-07-27 00:00:00	1974-07-27	38000177		0	0	13		0	0	0	172645	0	834102	19133905		
136992	3007	40213260	2017-05-31	2017-05-31 00:00:00	2017-05-31	2017-05-31 00:00:00	2017-05-31	581452		0	0	0		0	0	0	200611	0	121	40213260		
28594	2357	1127433	1955-03-19	1955-03-19 00:00:00	1955-04-02	1955-04-02 00:00:00	1955-04-02	38000177		0	0	14		0	0	0	157091	0	313782	1127433		
24235	1991	40165015	1988-01-14	1988-01-14 00:00:00	1988-01-14	1988-01-14 00:00:00	\N	38000177		0	0	0		0	0	0	132609	0	861467	40165015		
95730	2098	40213296	2004-07-14	2004-07-14 00:00:00	2004-07-14	2004-07-14 00:00:00	2004-07-14	581452		0	0	0		0	0	0	139859	0	52	40213296		
46287	3834	19059056	1963-10-03	1963-10-03 00:00:00	1964-01-01	1964-01-01 00:00:00	1964-01-01	38000177		0	0	90		0	0	0	254587	0	243670	19059056		
39211	3240	1127433	1992-10-28	1992-10-28 00:00:00	1992-11-11	1992-11-11 00:00:00	1992-11-11	38000177		0	0	14		0	0	0	215346	0	313782	1127433		
51729	1133	40213160	1970-06-19	1970-06-19 00:00:00	1970-06-19	1970-06-19 00:00:00	1970-06-19	581452		0	0	0		0	0	0	74579	0	10	40213160		
39320	3248	19006318	1948-02-12	1948-02-12 00:00:00	1948-02-26	1948-02-26 00:00:00	1948-02-26	38000177		0	0	14		0	0	0	215930	0	105078	19006318		
28008	2318	19133905	1999-03-09	1999-03-09 00:00:00	1999-03-16	1999-03-16 00:00:00	1999-03-16	38000177		0	0	7		0	0	0	154095	0	834102	19133905		
48869	1070	40213314	1977-10-13	1977-10-13 00:00:00	1977-10-13	1977-10-13 00:00:00	1977-10-13	581452		0	0	0		0	0	0	70086	0	49	40213314		
7431	160	40213296	2003-06-12	2003-06-12 00:00:00	2003-06-12	2003-06-12 00:00:00	2003-06-12	581452		0	0	0		0	0	0	10975	0	52	40213296		
239845	5264	40213296	2007-11-06	2007-11-06 00:00:00	2007-11-06	2007-11-06 00:00:00	2007-11-06	581452		0	0	0		0	0	0	350241	0	52	40213296		
44619	3694	19129655	1961-06-17	1961-06-17 00:00:00	1961-07-01	1961-07-01 00:00:00	1961-07-01	38000177		0	0	14		0	0	0	245482	0	789980	19129655		
192224	4223	40213296	1997-08-08	1997-08-08 00:00:00	1997-08-08	1997-08-08 00:00:00	1997-08-08	581452		0	0	0		0	0	0	280398	0	52	40213296		
157388	3464	40213251	1985-04-24	1985-04-24 00:00:00	1985-04-24	1985-04-24 00:00:00	1985-04-24	581452		0	0	0		0	0	0	229992	0	21	40213251		
48096	3987	40163554	2016-03-05	2016-03-05 00:00:00	2016-03-05	2016-03-05 00:00:00	\N	38000177		0	0	0		0	0	0	265060	0	855332	40163554		
174453	3835	40213227	2016-09-24	2016-09-24 00:00:00	2016-09-24	2016-09-24 00:00:00	2016-09-24	581452		0	0	0		0	0	0	254694	0	113	40213227		
192358	4226	40213227	1995-12-17	1995-12-17 00:00:00	1995-12-17	1995-12-17 00:00:00	1995-12-17	581452		0	0	0		0	0	0	280748	0	113	40213227		
59859	4976	40162522	1952-10-09	1952-10-09 00:00:00	1952-10-09	1952-10-09 00:00:00	\N	38000177		0	0	0		0	0	0	331104	0	857005	40162522		
104623	2294	40213160	1965-11-05	1965-11-05 00:00:00	1965-11-05	1965-11-05 00:00:00	1965-11-05	581452		0	0	0		0	0	0	152739	0	10	40213160		
68520	1500	40213160	1962-10-22	1962-10-22 00:00:00	1962-10-22	1962-10-22 00:00:00	1962-10-22	581452		0	0	0		0	0	0	100087	0	10	40213160		
186646	4100	40213227	1992-12-16	1992-12-16 00:00:00	1992-12-16	1992-12-16 00:00:00	1992-12-16	581452		0	0	0		0	0	0	272403	0	113	40213227		
31649	2624	19059056	1972-08-10	1972-08-10 00:00:00	1972-08-24	1972-08-24 00:00:00	1972-08-24	38000177		0	0	14		0	0	0	173604	0	243670	19059056		
38220	3161	19006318	1951-06-15	1951-06-15 00:00:00	1951-06-29	1951-06-29 00:00:00	1951-06-29	38000177		0	0	14		0	0	0	210253	0	105078	19006318		
19118	1578	19133873	1952-01-11	1952-01-11 00:00:00	1952-01-18	1952-01-18 00:00:00	1952-01-18	38000177		0	0	7		0	0	0	105975	0	834061	19133873		
42244	3505	1127433	1946-02-20	1946-02-20 00:00:00	1946-02-27	1946-02-27 00:00:00	1946-02-27	38000177		0	0	7		0	0	0	232394	0	313782	1127433		
91368	2005	40213296	2015-05-16	2015-05-16 00:00:00	2015-05-16	2015-05-16 00:00:00	2015-05-16	581452		0	0	0		0	0	0	133543	0	52	40213296		
240986	5290	40213160	1955-10-14	1955-10-14 00:00:00	1955-10-14	1955-10-14 00:00:00	1955-10-14	581452		0	0	0		0	0	0	352014	0	10	40213160		
52857	4391	1127433	2012-09-18	2012-09-18 00:00:00	2012-10-18	2012-10-18 00:00:00	2012-10-18	38000177		0	0	30		0	0	0	291942	0	313782	1127433		
42853	3552	40229134	1961-04-24	1961-04-24 00:00:00	1961-05-08	1961-05-08 00:00:00	1961-05-08	38000177		0	0	14		0	0	0	235785	0	1043400	40229134		
5010	418	1713671	1973-04-22	1973-04-22 00:00:00	1973-04-29	1973-04-29 00:00:00	1973-04-29	38000177		0	0	7		0	0	0	27608	0	562251	1713671		
238130	5228	40213227	1996-08-22	1996-08-22 00:00:00	1996-08-22	1996-08-22 00:00:00	1996-08-22	581452		0	0	0		0	0	0	347772	0	113	40213227		
21157	1744	1115171	2010-06-02	2010-06-02 00:00:00	2010-08-01	2010-08-01 00:00:00	2010-08-01	38000177		0	0	60		0	0	0	116629	0	849574	1115171		
66153	1447	40213160	1962-07-12	1962-07-12 00:00:00	1962-07-12	1962-07-12 00:00:00	1962-07-12	581452		0	0	0		0	0	0	96492	0	10	40213160		
184340	4051	40213160	1974-04-24	1974-04-24 00:00:00	1974-04-24	1974-04-24 00:00:00	1974-04-24	581452		0	0	0		0	0	0	269286	0	10	40213160		
54361	4520	1713671	1955-03-13	1955-03-13 00:00:00	1955-03-20	1955-03-20 00:00:00	1955-03-20	38000177		0	0	7		0	0	0	300946	0	562251	1713671		
56303	1232	40213296	2004-12-20	2004-12-20 00:00:00	2004-12-20	2004-12-20 00:00:00	2004-12-20	581452		0	0	0		0	0	0	81214	0	52	40213296		
221945	4872	40213227	2005-12-27	2005-12-27 00:00:00	2005-12-27	2005-12-27 00:00:00	2005-12-27	581452		0	0	0		0	0	0	\N	0	113	40213227		
118188	2599	40213227	2000-12-30	2000-12-30 00:00:00	2000-12-30	2000-12-30 00:00:00	2000-12-30	581452		0	0	0		0	0	0	172002	0	113	40213227		
55346	4595	19059056	1965-03-28	1965-03-28 00:00:00	1965-04-11	1965-04-11 00:00:00	1965-04-11	38000177		0	0	14		0	0	0	306173	0	243670	19059056		
55375	4596	19073188	2013-06-22	2013-06-22 00:00:00	2013-07-06	2013-07-06 00:00:00	2013-07-06	38000177		0	0	14		0	0	0	306308	0	308192	19073188		
140539	3086	40213227	2010-10-06	2010-10-06 00:00:00	2010-10-06	2010-10-06 00:00:00	2010-10-06	581452		0	0	0		0	0	0	205467	0	113	40213227		
49065	4071	1127433	1986-02-11	1986-02-11 00:00:00	1986-03-04	1986-03-04 00:00:00	1986-03-04	38000177		0	0	21		0	0	0	270583	0	313782	1127433		
563	41	19006318	1978-05-30	1978-05-30 00:00:00	1978-06-13	1978-06-13 00:00:00	1978-06-13	38000177		0	0	14		0	0	0	2946	0	105078	19006318		
55671	4623	19133873	1943-09-22	1943-09-22 00:00:00	1943-10-05	1943-10-05 00:00:00	1943-10-05	38000177		0	0	13		0	0	0	307965	0	834061	19133873		
103562	2272	40213314	1980-03-08	1980-03-08 00:00:00	1980-03-08	1980-03-08 00:00:00	1980-03-08	581452		0	0	0		0	0	0	151008	0	49	40213314		
16500	1367	1127433	2006-06-25	2006-06-25 00:00:00	2006-07-02	2006-07-02 00:00:00	2006-07-02	38000177		0	0	7		0	0	0	90601	0	313782	1127433		
21305	1752	1118084	2016-03-10	2016-03-10 00:00:00	2016-03-10	2016-03-10 00:00:00	\N	38000177		0	0	0		0	0	0	117141	0	00025152531	44923712		
48595	4026	1127433	1970-07-22	1970-07-22 00:00:00	1970-08-21	1970-08-21 00:00:00	1970-08-21	38000177		0	0	30		0	0	0	267695	0	313782	1127433		
28959	2394	1127433	1988-01-06	1988-01-06 00:00:00	1988-03-06	1988-03-06 00:00:00	1988-03-06	38000177		0	0	60		0	0	0	159215	0	313782	1127433		
54068	4492	40231925	1959-05-19	1959-05-19 00:00:00	1959-05-19	1959-05-19 00:00:00	\N	38000177		0	0	0		0	0	0	299047	0	1049221	40231925		
3684	304	19133905	2018-12-27	2018-12-27 00:00:00	2019-01-03	2019-01-03 00:00:00	2019-01-03	38000177		0	0	7		0	0	0	20204	0	834102	19133905		
48677	4032	1127433	1985-08-21	1985-08-21 00:00:00	1985-09-04	1985-09-04 00:00:00	1985-09-04	38000177		0	0	14		0	0	0	268243	0	313782	1127433		
213898	4690	40213296	1997-10-11	1997-10-11 00:00:00	1997-10-11	1997-10-11 00:00:00	1997-10-11	581452		0	0	0		0	0	0	312512	0	52	40213296		
7560	636	40229134	1998-11-16	1998-11-16 00:00:00	1998-11-23	1998-11-23 00:00:00	1998-11-23	38000177		0	0	7		0	0	0	42104	0	1043400	40229134		
12190	263	40213296	1996-06-30	1996-06-30 00:00:00	1996-06-30	1996-06-30 00:00:00	1996-06-30	581452		0	0	0		0	0	0	17502	0	52	40213296		
59297	4927	1127433	2000-10-10	2000-10-10 00:00:00	2000-10-24	2000-10-24 00:00:00	2000-10-24	38000177		0	0	14		0	0	0	327479	0	313782	1127433		
15390	1283	19059056	1960-12-05	1960-12-05 00:00:00	1960-12-19	1960-12-19 00:00:00	1960-12-19	38000177		0	0	14		0	0	0	84801	0	243670	19059056		
63061	5239	19006318	1966-07-22	1966-07-22 00:00:00	1966-08-05	1966-08-05 00:00:00	1966-08-05	38000177		0	0	14		0	0	0	348543	0	105078	19006318		
12350	266	40213227	2017-05-08	2017-05-08 00:00:00	2017-05-08	2017-05-08 00:00:00	2017-05-08	581452		0	0	0		0	0	0	17720	0	113	40213227		
13505	1132	1118084	1993-09-11	1993-09-11 00:00:00	1993-09-11	1993-09-11 00:00:00	\N	38000177		0	0	0		0	0	0	74569	0	00025152531	44923712		
39771	3289	19059056	1961-06-24	1961-06-24 00:00:00	1961-07-15	1961-07-15 00:00:00	1961-07-15	38000177		0	0	21		0	0	0	218489	0	243670	19059056		
148180	3258	40213251	1986-05-14	1986-05-14 00:00:00	1986-05-14	1986-05-14 00:00:00	1986-05-14	581452		0	0	0		0	0	0	216618	0	21	40213251		
31491	2611	1118084	1990-06-29	1990-06-29 00:00:00	1990-06-29	1990-06-29 00:00:00	\N	38000177		0	0	0		0	0	0	172679	0	00025152531	44923712		
136997	3007	40213260	2016-05-25	2016-05-25 00:00:00	2016-05-25	2016-05-25 00:00:00	2016-05-25	581452		0	0	0		0	0	0	200597	0	121	40213260		
28595	2357	920300	1998-02-05	1998-02-05 00:00:00	1998-02-12	1998-02-12 00:00:00	1998-02-12	38000177		0	0	7		0	0	0	157068	0	311989	920300		
24236	1991	1127433	1988-01-14	1988-01-14 00:00:00	1988-01-28	1988-01-28 00:00:00	1988-01-28	38000177		0	0	14		0	0	0	132609	0	313782	1127433		
170996	3759	40213160	1965-01-17	1965-01-17 00:00:00	1965-01-17	1965-01-17 00:00:00	1965-01-17	581452		0	0	0		0	0	0	249977	0	10	40213160		
46288	3834	1124300	1994-06-27	1994-06-27 00:00:00	1994-06-27	1994-06-27 00:00:00	\N	38000177		0	0	0		0	0	0	254581	0	00781178901	45011828		
39212	3240	1124300	1981-08-07	1981-08-07 00:00:00	1981-08-07	1981-08-07 00:00:00	\N	38000177		0	0	0		0	0	0	215421	0	00781178901	45011828		
63023	1378	40213227	1995-06-27	1995-06-27 00:00:00	1995-06-27	1995-06-27 00:00:00	1995-06-27	581452		0	0	0		0	0	0	91347	0	113	40213227		
39321	3248	1118084	1983-04-20	1983-04-20 00:00:00	1983-04-20	1983-04-20 00:00:00	\N	38000177		0	0	0		0	0	0	215869	0	00025152531	44923712		
28009	2319	1124300	1990-02-24	1990-02-24 00:00:00	1990-02-24	1990-02-24 00:00:00	\N	38000177		0	0	0		0	0	0	154209	0	00781178901	45011828		
118558	2609	40213160	1958-08-08	1958-08-08 00:00:00	1958-08-08	1958-08-08 00:00:00	1958-08-08	581452		0	0	0		0	0	0	172500	0	10	40213160		
7433	160	40213160	1962-01-04	1962-01-04 00:00:00	1962-01-04	1962-01-04 00:00:00	1962-01-04	581452		0	0	0		0	0	0	10952	0	10	40213160		
239848	5264	40213227	1999-01-12	1999-01-12 00:00:00	1999-01-12	1999-01-12 00:00:00	1999-01-12	581452		0	0	0		0	0	0	350263	0	113	40213227		
44620	3694	1124300	1995-11-16	1995-11-16 00:00:00	1995-11-16	1995-11-16 00:00:00	\N	38000177		0	0	0		0	0	0	245516	0	00781178901	45011828		
192231	4223	40213160	1962-01-05	1962-01-05 00:00:00	1962-01-05	1962-01-05 00:00:00	1962-01-05	581452		0	0	0		0	0	0	280371	0	10	40213160		
157391	3464	40213160	1985-04-24	1985-04-24 00:00:00	1985-04-24	1985-04-24 00:00:00	1985-04-24	581452		0	0	0		0	0	0	229992	0	10	40213160		
48097	3987	19018935	2016-03-05	2016-03-05 00:00:00	2016-03-05	2016-03-05 00:00:00	\N	38000177		0	0	0		0	0	0	265060	0	197604	19018935		
174454	3835	40213306	1988-02-06	1988-02-06 00:00:00	1988-02-06	1988-02-06 00:00:00	1988-02-06	581452		0	0	0		0	0	0	254688	0	43	40213306		
192365	4226	40213227	2014-01-26	2014-01-26 00:00:00	2014-01-26	2014-01-26 00:00:00	2014-01-26	581452		0	0	0		0	0	0	280664	0	113	40213227		
59860	4976	1127433	1913-03-14	1913-03-14 00:00:00	1913-03-21	1913-03-21 00:00:00	1913-03-21	38000177		0	0	7		0	0	0	331068	0	313782	1127433		
104629	2294	40213306	1983-08-12	1983-08-12 00:00:00	1983-08-12	1983-08-12 00:00:00	1983-08-12	581452		0	0	0		0	0	0	152666	0	43	40213306		
68533	1500	40213227	1993-09-13	1993-09-13 00:00:00	1993-09-13	1993-09-13 00:00:00	1993-09-13	581452		0	0	0		0	0	0	100105	0	113	40213227		
186650	4100	40213227	2003-02-12	2003-02-12 00:00:00	2003-02-12	2003-02-12 00:00:00	2003-02-12	581452		0	0	0		0	0	0	272449	0	113	40213227		
31650	2624	19059056	1973-08-05	1973-08-05 00:00:00	1973-08-26	1973-08-26 00:00:00	1973-08-26	38000177		0	0	21		0	0	0	173623	0	243670	19059056		
38221	3161	19059056	1951-06-15	1951-06-15 00:00:00	1951-06-29	1951-06-29 00:00:00	1951-06-29	38000177		0	0	14		0	0	0	210253	0	243670	19059056		
19119	1578	1127078	1954-01-29	1954-01-29 00:00:00	1954-02-19	1954-02-19 00:00:00	1954-02-19	38000177		0	0	21		0	0	0	105969	0	282464	1127078		
42245	3505	1713671	2004-02-17	2004-02-17 00:00:00	2004-03-09	2004-03-09 00:00:00	2004-03-09	38000177		0	0	21		0	0	0	232385	0	562251	1713671		
91371	2005	40213160	1978-07-22	1978-07-22 00:00:00	1978-07-22	1978-07-22 00:00:00	1978-07-22	581452		0	0	0		0	0	0	133491	0	10	40213160		
240989	5290	40213227	2015-07-31	2015-07-31 00:00:00	2015-07-31	2015-07-31 00:00:00	2015-07-31	581452		0	0	0		0	0	0	351924	0	113	40213227		
52858	4391	19059056	1941-11-04	1941-11-04 00:00:00	1941-11-18	1941-11-18 00:00:00	1941-11-18	38000177		0	0	14		0	0	0	291948	0	243670	19059056		
42854	3552	1118084	1992-05-25	1992-05-25 00:00:00	1992-05-25	1992-05-25 00:00:00	\N	38000177		0	0	0		0	0	0	235833	0	00025152531	44923712		
5011	418	1127433	1990-10-01	1990-10-01 00:00:00	1990-10-08	1990-10-08 00:00:00	1990-10-08	38000177		0	0	7		0	0	0	27632	0	313782	1127433		
76078	1662	40213227	1996-03-01	1996-03-01 00:00:00	1996-03-01	1996-03-01 00:00:00	1996-03-01	581452		0	0	0		0	0	0	111762	0	113	40213227		
21158	1744	40165015	2010-06-02	2010-06-02 00:00:00	2010-06-02	2010-06-02 00:00:00	\N	38000177		0	0	0		0	0	0	116629	0	861467	40165015		
66165	1447	40213160	1957-11-07	1957-11-07 00:00:00	1957-11-07	1957-11-07 00:00:00	1957-11-07	581452		0	0	0		0	0	0	96556	0	10	40213160		
184342	4051	40213160	1974-09-25	1974-09-25 00:00:00	1974-09-25	1974-09-25 00:00:00	1974-09-25	581452		0	0	0		0	0	0	269236	0	10	40213160		
54362	4520	1127433	1972-01-13	1972-01-13 00:00:00	1972-01-20	1972-01-20 00:00:00	1972-01-20	38000177		0	0	7		0	0	0	300947	0	313782	1127433		
56306	1232	40213160	1965-05-24	1965-05-24 00:00:00	1965-05-24	1965-05-24 00:00:00	1965-05-24	581452		0	0	0		0	0	0	81225	0	10	40213160		
91034	1998	40213251	1986-08-30	1986-08-30 00:00:00	1986-08-30	1986-08-30 00:00:00	1986-08-30	581452		0	0	0		0	0	0	133009	0	21	40213251		
118189	2599	40213306	2000-12-30	2000-12-30 00:00:00	2000-12-30	2000-12-30 00:00:00	2000-12-30	581452		0	0	0		0	0	0	172002	0	43	40213306		
55347	4595	1127433	1974-08-09	1974-08-09 00:00:00	1974-11-06	1974-11-06 00:00:00	1974-11-06	38000177		0	0	89		0	0	0	306182	0	313782	1127433		
55376	4596	1127433	1962-11-09	1962-11-09 00:00:00	1962-11-16	1962-11-16 00:00:00	1962-11-16	38000177		0	0	7		0	0	0	306289	0	313782	1127433		
140540	3086	40213296	2010-10-06	2010-10-06 00:00:00	2010-10-06	2010-10-06 00:00:00	2010-10-06	581452		0	0	0		0	0	0	205467	0	52	40213296		
49066	4071	1127433	1969-12-07	1969-12-07 00:00:00	1970-02-05	1970-02-05 00:00:00	1970-02-05	38000177		0	0	60		0	0	0	270582	0	313782	1127433		
564	41	1127078	1978-05-30	1978-05-30 00:00:00	1978-06-13	1978-06-13 00:00:00	1978-06-13	38000177		0	0	14		0	0	0	2946	0	282464	1127078		
55672	4623	19133873	1931-06-06	1931-06-06 00:00:00	1931-06-14	1931-06-14 00:00:00	1931-06-14	38000177		0	0	8		0	0	0	307860	0	834061	19133873		
103563	2272	40213306	2002-10-26	2002-10-26 00:00:00	2002-10-26	2002-10-26 00:00:00	2002-10-26	581452		0	0	0		0	0	0	151077	0	43	40213306		
16501	1367	19128065	1982-04-11	1982-04-11 00:00:00	1983-04-06	1983-04-06 00:00:00	1983-04-06	38000177		0	0	360		0	0	0	90603	0	749882	19128065		
21306	1752	1713671	1996-11-19	1996-11-19 00:00:00	1996-12-10	1996-12-10 00:00:00	1996-12-10	38000177		0	0	21		0	0	0	117109	0	562251	1713671		
48596	4026	40162522	1970-07-22	1970-07-22 00:00:00	1970-07-22	1970-07-22 00:00:00	\N	38000177		0	0	0		0	0	0	267695	0	857005	40162522		
28960	2394	19059056	1955-06-23	1955-06-23 00:00:00	1955-07-28	1955-07-28 00:00:00	1955-07-28	38000177		0	0	35		0	0	0	159213	0	243670	19059056		
54069	4492	1118084	1987-09-10	1987-09-10 00:00:00	1987-09-10	1987-09-10 00:00:00	\N	38000177		0	0	0		0	0	0	299062	0	00025152531	44923712		
3685	304	1118084	1998-03-18	1998-03-18 00:00:00	1998-03-18	1998-03-18 00:00:00	\N	38000177		0	0	0		0	0	0	20251	0	00025152531	44923712		
48678	4032	19078461	2014-01-27	2014-01-27 00:00:00	2014-02-17	2014-02-17 00:00:00	2014-02-17	38000177		0	0	21		0	0	0	268214	0	310965	19078461		
213900	4690	40213227	1997-10-11	1997-10-11 00:00:00	1997-10-11	1997-10-11 00:00:00	1997-10-11	581452		0	0	0		0	0	0	312512	0	113	40213227		
7561	636	19078461	2018-01-04	2018-01-04 00:00:00	2018-04-04	2018-04-04 00:00:00	2018-04-04	38000177		0	0	90		0	0	0	42161	0	310965	19078461		
12193	263	40213227	1996-06-30	1996-06-30 00:00:00	1996-06-30	1996-06-30 00:00:00	1996-06-30	581452		0	0	0		0	0	0	17502	0	113	40213227		
59313	4929	1127433	1979-10-27	1979-10-27 00:00:00	1979-11-10	1979-11-10 00:00:00	1979-11-10	38000177		0	0	14		0	0	0	327671	0	313782	1127433		
15391	1283	19133873	1959-09-13	1959-09-13 00:00:00	1959-09-23	1959-09-23 00:00:00	1959-09-23	38000177		0	0	10		0	0	0	84795	0	834061	19133873		
63062	5240	19078461	1975-06-14	1975-06-14 00:00:00	1975-06-28	1975-06-28 00:00:00	1975-06-28	38000177		0	0	14		0	0	0	348609	0	310965	19078461		
12351	266	40213260	2017-05-08	2017-05-08 00:00:00	2017-05-08	2017-05-08 00:00:00	2017-05-08	581452		0	0	0		0	0	0	17720	0	121	40213260		
13506	1132	19059056	1957-04-13	1957-04-13 00:00:00	1957-04-27	1957-04-27 00:00:00	1957-04-27	38000177		0	0	14		0	0	0	74512	0	243670	19059056		
39773	3289	1118084	1995-09-29	1995-09-29 00:00:00	1995-09-29	1995-09-29 00:00:00	\N	38000177		0	0	0		0	0	0	218485	0	00025152531	44923712		
148183	3258	40213160	1986-05-14	1986-05-14 00:00:00	1986-05-14	1986-05-14 00:00:00	1986-05-14	581452		0	0	0		0	0	0	216618	0	10	40213160		
31492	2611	1127433	1961-07-04	1961-07-04 00:00:00	1961-07-18	1961-07-18 00:00:00	1961-07-18	38000177		0	0	14		0	0	0	172683	0	313782	1127433		
137004	3007	40213160	1967-02-01	1967-02-01 00:00:00	1967-02-01	1967-02-01 00:00:00	1967-02-01	581452		0	0	0		0	0	0	200592	0	10	40213160		
28596	2357	40236824	1998-02-05	1998-02-05 00:00:00	1998-02-12	1998-02-12 00:00:00	1998-02-12	38000177		0	0	7		0	0	0	157068	0	1094107	40236824		
34695	2865	1118084	2003-03-11	2003-03-11 00:00:00	2003-03-11	2003-03-11 00:00:00	\N	38000177		0	0	0		0	0	0	190600	0	00025152531	44923712		
171002	3759	40213296	2004-08-15	2004-08-15 00:00:00	2004-08-15	2004-08-15 00:00:00	2004-08-15	581452		0	0	0		0	0	0	249870	0	52	40213296		
46289	3834	1127433	2009-04-27	2009-04-27 00:00:00	2009-05-04	2009-05-04 00:00:00	2009-05-04	38000177		0	0	7		0	0	0	254606	0	313782	1127433		
39213	3240	1713671	1979-08-24	1979-08-24 00:00:00	1979-09-07	1979-09-07 00:00:00	1979-09-07	38000177		0	0	14		0	0	0	215412	0	562251	1713671		
63027	1378	40213227	2006-03-28	2006-03-28 00:00:00	2006-03-28	2006-03-28 00:00:00	2006-03-28	581452		0	0	0		0	0	0	91428	0	113	40213227		
39322	3248	19076374	2016-06-26	2016-06-26 00:00:00	2016-06-26	2016-06-26 00:00:00	2016-06-26	38000177		0	0	0		0	0	0	215881	0	309845	19076374		
28010	2319	1127433	1983-09-07	1983-09-07 00:00:00	1983-10-07	1983-10-07 00:00:00	1983-10-07	38000177		0	0	30		0	0	0	154136	0	313782	1127433		
118562	2609	40213260	2008-05-02	2008-05-02 00:00:00	2008-05-02	2008-05-02 00:00:00	2008-05-02	581452		0	0	0		0	0	0	172510	0	121	40213260		
7436	160	40213227	1993-01-28	1993-01-28 00:00:00	1993-01-28	1993-01-28 00:00:00	1993-01-28	581452		0	0	0		0	0	0	11020	0	113	40213227		
239850	5264	40213160	1968-04-09	1968-04-09 00:00:00	1968-04-09	1968-04-09 00:00:00	1968-04-09	581452		0	0	0		0	0	0	350230	0	10	40213160		
44621	3695	19078461	2015-11-14	2015-11-14 00:00:00	2015-12-05	2015-12-05 00:00:00	2015-12-05	38000177		0	0	21		0	0	0	245567	0	310965	19078461		
192234	4223	40213160	1957-10-04	1957-10-04 00:00:00	1957-10-04	1957-10-04 00:00:00	1957-10-04	581452		0	0	0		0	0	0	280430	0	10	40213160		
157392	3464	40213314	1981-07-22	1981-07-22 00:00:00	1981-07-22	1981-07-22 00:00:00	1981-07-22	581452		0	0	0		0	0	0	229989	0	49	40213314		
48098	3987	40171902	2016-03-05	2016-03-05 00:00:00	2016-03-05	2016-03-05 00:00:00	\N	38000177		0	0	0		0	0	0	265060	0	897718	40171902		
174459	3836	40213306	1997-11-21	1997-11-21 00:00:00	1997-11-21	1997-11-21 00:00:00	1997-11-21	581452		0	0	0		0	0	0	254731	0	43	40213306		
192366	4226	40213260	2014-01-26	2014-01-26 00:00:00	2014-01-26	2014-01-26 00:00:00	2014-01-26	581452		0	0	0		0	0	0	280664	0	121	40213260		
59861	4976	1127433	1982-09-21	1982-09-21 00:00:00	1982-10-05	1982-10-05 00:00:00	1982-10-05	38000177		0	0	14		0	0	0	331037	0	313782	1127433		
104631	2294	40213160	1961-03-03	1961-03-03 00:00:00	1961-03-03	1961-03-03 00:00:00	1961-03-03	581452		0	0	0		0	0	0	152723	0	10	40213160		
68535	1500	40213227	2004-02-23	2004-02-23 00:00:00	2004-02-23	2004-02-23 00:00:00	2004-02-23	581452		0	0	0		0	0	0	100095	0	113	40213227		
186655	4100	40213227	2013-04-10	2013-04-10 00:00:00	2013-04-10	2013-04-10 00:00:00	2013-04-10	581452		0	0	0		0	0	0	272409	0	113	40213227		
31651	2624	40229134	2007-03-11	2007-03-11 00:00:00	2007-03-18	2007-03-18 00:00:00	2007-03-18	38000177		0	0	7		0	0	0	173551	0	1043400	40229134		
38222	3161	1127433	1990-04-26	1990-04-26 00:00:00	1990-05-10	1990-05-10 00:00:00	1990-05-10	38000177		0	0	14		0	0	0	210214	0	313782	1127433		
19121	1578	1127433	1948-02-02	1948-02-02 00:00:00	1948-02-09	1948-02-09 00:00:00	1948-02-09	38000177		0	0	7		0	0	0	105973	0	313782	1127433		
42246	3505	19078461	2009-08-12	2009-08-12 00:00:00	2009-11-10	2009-11-10 00:00:00	2009-11-10	38000177		0	0	90		0	0	0	232382	0	310965	19078461		
91374	2005	40213296	2017-05-20	2017-05-20 00:00:00	2017-05-20	2017-05-20 00:00:00	2017-05-20	581452		0	0	0		0	0	0	133509	0	52	40213296		
241005	5290	40213160	1958-10-03	1958-10-03 00:00:00	1958-10-03	1958-10-03 00:00:00	1958-10-03	581452		0	0	0		0	0	0	351944	0	10	40213160		
52859	4391	19077572	2015-06-26	2015-06-26 00:00:00	2015-06-26	2015-06-26 00:00:00	\N	38000177		0	0	0		0	0	0	291958	0	310436	19077572		
42855	3552	1127433	2018-01-13	2018-01-13 00:00:00	2018-01-20	2018-01-20 00:00:00	2018-01-20	38000177		0	0	7		0	0	0	235852	0	313782	1127433		
5012	418	1127433	1999-04-26	1999-04-26 00:00:00	1999-05-10	1999-05-10 00:00:00	1999-05-10	38000177		0	0	14		0	0	0	27643	0	313782	1127433		
56543	1238	40213160	1956-02-14	1956-02-14 00:00:00	1956-02-14	1956-02-14 00:00:00	1956-02-14	581452		0	0	0		0	0	0	81564	0	10	40213160		
21159	1744	19078461	1990-07-12	1990-07-12 00:00:00	1990-08-02	1990-08-02 00:00:00	1990-08-02	38000177		0	0	21		0	0	0	116627	0	310965	19078461		
66171	1448	40213296	2013-12-11	2013-12-11 00:00:00	2013-12-11	2013-12-11 00:00:00	2013-12-11	581452		0	0	0		0	0	0	96583	0	52	40213296		
184349	4051	40213227	2005-01-19	2005-01-19 00:00:00	2005-01-19	2005-01-19 00:00:00	2005-01-19	581452		0	0	0		0	0	0	269282	0	113	40213227		
54363	4520	1713671	1946-11-02	1946-11-02 00:00:00	1946-11-16	1946-11-16 00:00:00	1946-11-16	38000177		0	0	14		0	0	0	300897	0	562251	1713671		
56308	1232	40213227	1998-07-27	1998-07-27 00:00:00	1998-07-27	1998-07-27 00:00:00	1998-07-27	581452		0	0	0		0	0	0	81205	0	113	40213227		
173991	3825	40213160	1958-08-22	1958-08-22 00:00:00	1958-08-22	1958-08-22 00:00:00	1958-08-22	581452		0	0	0		0	0	0	254098	0	10	40213160		
118190	2599	40213314	1978-05-06	1978-05-06 00:00:00	1978-05-06	1978-05-06 00:00:00	1978-05-06	581452		0	0	0		0	0	0	171948	0	49	40213314		
55348	4595	1127433	1976-03-02	1976-03-02 00:00:00	1976-03-16	1976-03-16 00:00:00	1976-03-16	38000177		0	0	14		0	0	0	306186	0	313782	1127433		
55414	4602	1713671	1996-12-11	1996-12-11 00:00:00	1996-12-25	1996-12-25 00:00:00	1996-12-25	38000177		0	0	14		0	0	0	306543	0	562251	1713671		
140543	3086	40213160	1969-06-04	1969-06-04 00:00:00	1969-06-04	1969-06-04 00:00:00	1969-06-04	581452		0	0	0		0	0	0	205473	0	10	40213160		
505	36	19008572	1978-06-06	1978-06-06 00:00:00	1978-06-27	1978-06-27 00:00:00	1978-06-27	38000177		0	0	21		0	0	0	2489	0	106258	19008572		
565	41	1127433	1999-03-22	1999-03-22 00:00:00	1999-04-05	1999-04-05 00:00:00	1999-04-05	38000177		0	0	14		0	0	0	2937	0	313782	1127433		
55673	4623	1127433	1937-11-30	1937-11-30 00:00:00	1937-12-14	1937-12-14 00:00:00	1937-12-14	38000177		0	0	14		0	0	0	308006	0	313782	1127433		
103565	2272	40213227	2002-10-26	2002-10-26 00:00:00	2002-10-26	2002-10-26 00:00:00	2002-10-26	581452		0	0	0		0	0	0	151077	0	113	40213227		
16502	1367	19133905	2000-05-17	2000-05-17 00:00:00	2000-05-24	2000-05-24 00:00:00	2000-05-24	38000177		0	0	7		0	0	0	90599	0	834102	19133905		
21307	1752	1127078	1979-10-17	1979-10-17 00:00:00	1979-10-30	1979-10-30 00:00:00	1979-10-30	38000177		0	0	13		0	0	0	117142	0	282464	1127078		
48597	4026	19078461	2009-10-07	2009-10-07 00:00:00	2009-11-11	2009-11-11 00:00:00	2009-11-11	38000177		0	0	35		0	0	0	267635	0	310965	19078461		
28961	2394	19133873	1919-01-23	1919-01-23 00:00:00	1919-02-02	1919-02-02 00:00:00	1919-02-02	38000177		0	0	10		0	0	0	159147	0	834061	19133873		
54070	4492	40229134	1992-02-06	1992-02-06 00:00:00	1992-02-20	1992-02-20 00:00:00	1992-02-20	38000177		0	0	14		0	0	0	299101	0	1043400	40229134		
3691	307	1127433	1983-08-05	1983-08-05 00:00:00	1983-08-26	1983-08-26 00:00:00	1983-08-26	38000177		0	0	21		0	0	0	20380	0	313782	1127433		
48679	4032	1127433	1961-01-18	1961-01-18 00:00:00	1961-04-18	1961-04-18 00:00:00	1961-04-18	38000177		0	0	90		0	0	0	268267	0	313782	1127433		
213902	4690	40213296	1996-06-15	1996-06-15 00:00:00	1996-06-15	1996-06-15 00:00:00	1996-06-15	581452		0	0	0		0	0	0	312489	0	52	40213296		
7562	636	40165015	2018-01-04	2018-01-04 00:00:00	2018-01-04	2018-01-04 00:00:00	\N	38000177		0	0	0		0	0	0	42161	0	861467	40165015		
12197	263	40213260	2006-07-02	2006-07-02 00:00:00	2006-07-02	2006-07-02 00:00:00	2006-07-02	581452		0	0	0		0	0	0	17503	0	121	40213260		
59314	4929	19128065	1976-12-07	1976-12-07 00:00:00	1977-12-02	1977-12-02 00:00:00	1977-12-02	38000177		0	0	360		0	0	0	327699	0	749882	19128065		
15392	1283	1124300	1998-06-24	1998-06-24 00:00:00	1998-06-24	1998-06-24 00:00:00	\N	38000177		0	0	0		0	0	0	84817	0	00781178901	45011828		
63063	5240	40165015	1979-04-13	1979-04-13 00:00:00	1979-04-13	1979-04-13 00:00:00	\N	38000177		0	0	0		0	0	0	348689	0	861467	40165015		
162360	3570	40213227	1992-02-23	1992-02-23 00:00:00	1992-02-23	1992-02-23 00:00:00	1992-02-23	581452		0	0	0		0	0	0	237249	0	113	40213227		
13507	1132	19006318	1957-04-13	1957-04-13 00:00:00	1957-04-27	1957-04-27 00:00:00	1957-04-27	38000177		0	0	14		0	0	0	74512	0	105078	19006318		
39774	3289	1127078	1960-10-18	1960-10-18 00:00:00	1960-11-01	1960-11-01 00:00:00	1960-11-01	38000177		0	0	14		0	0	0	218463	0	282464	1127078		
148185	3258	40213314	1981-11-11	1981-11-11 00:00:00	1981-11-11	1981-11-11 00:00:00	1981-11-11	581452		0	0	0		0	0	0	216630	0	49	40213314		
31493	2611	1713671	1987-06-25	1987-06-25 00:00:00	1987-07-16	1987-07-16 00:00:00	1987-07-16	38000177		0	0	21		0	0	0	172646	0	562251	1713671		
137010	3007	40213306	1989-02-22	1989-02-22 00:00:00	1989-02-22	1989-02-22 00:00:00	1989-02-22	581452		0	0	0		0	0	0	200649	0	43	40213306		
28597	2357	40173590	2009-02-24	2009-02-24 00:00:00	2009-02-24	2009-02-24 00:00:00	\N	38000177		0	0	0		0	0	0	157087	0	904419	40173590		
34696	2865	19073188	2003-03-24	2003-03-24 00:00:00	2003-04-07	2003-04-07 00:00:00	2003-04-07	38000177		0	0	14		0	0	0	190603	0	308192	19073188		
171003	3759	40213160	1964-11-15	1964-11-15 00:00:00	1964-11-15	1964-11-15 00:00:00	1964-11-15	581452		0	0	0		0	0	0	249861	0	10	40213160		
46290	3834	19133905	1989-12-21	1989-12-21 00:00:00	1989-12-31	1989-12-31 00:00:00	1989-12-31	38000177		0	0	10		0	0	0	254551	0	834102	19133905		
39214	3240	19059056	1969-05-06	1969-05-06 00:00:00	1969-05-20	1969-05-20 00:00:00	1969-05-20	38000177		0	0	14		0	0	0	215433	0	243670	19059056		
56845	4719	40229134	1953-01-28	1953-01-28 00:00:00	1953-02-11	1953-02-11 00:00:00	1953-02-11	38000177		0	0	14		0	0	0	314288	0	1043400	40229134		
39323	3248	1367571	2016-06-26	2016-06-26 00:00:00	2016-06-26	2016-06-26 00:00:00	2016-06-26	38000177		0	0	0		0	0	0	215881	0	314659	19080464		
28011	2319	40229134	1980-10-11	1980-10-11 00:00:00	1980-10-18	1980-10-18 00:00:00	1980-10-18	38000177		0	0	7		0	0	0	154164	0	1043400	40229134		
71134	1556	40213296	2015-11-26	2015-11-26 00:00:00	2015-11-26	2015-11-26 00:00:00	2015-11-26	581452		0	0	0		0	0	0	104166	0	52	40213296		
7439	160	40213227	2012-08-02	2012-08-02 00:00:00	2012-08-02	2012-08-02 00:00:00	2012-08-02	581452		0	0	0		0	0	0	10995	0	113	40213227		
239854	5265	40213306	1990-04-26	1990-04-26 00:00:00	1990-04-26	1990-04-26 00:00:00	1990-04-26	581452		0	0	0		0	0	0	350319	0	43	40213306		
44622	3695	19019979	1981-10-26	1981-10-26 00:00:00	1981-11-09	1981-11-09 00:00:00	1981-11-09	38000177		0	0	14		0	0	0	245593	0	198405	19019979		
192237	4223	40213227	2018-03-30	2018-03-30 00:00:00	2018-03-30	2018-03-30 00:00:00	2018-03-30	581452		0	0	0		0	0	0	280434	0	113	40213227		
157399	3464	40213160	1980-10-22	1980-10-22 00:00:00	1980-10-22	1980-10-22 00:00:00	1980-10-22	581452		0	0	0		0	0	0	229922	0	10	40213160		
62705	5213	1713671	2010-07-31	2010-07-31 00:00:00	2010-08-14	2010-08-14 00:00:00	2010-08-14	38000177		0	0	14		0	0	0	346767	0	562251	1713671		
55949	1226	40213160	1980-12-14	1980-12-14 00:00:00	1980-12-14	1980-12-14 00:00:00	1980-12-14	581452		0	0	0		0	0	0	80717	0	10	40213160		
192368	4226	40213227	2003-12-28	2003-12-28 00:00:00	2003-12-28	2003-12-28 00:00:00	2003-12-28	581452		0	0	0		0	0	0	280662	0	113	40213227		
59862	4976	19059056	1936-09-05	1936-09-05 00:00:00	1936-09-19	1936-09-19 00:00:00	1936-09-19	38000177		0	0	14		0	0	0	331102	0	243670	19059056		
104643	2294	40213296	2001-01-05	2001-01-05 00:00:00	2001-01-05	2001-01-05 00:00:00	2001-01-05	581452		0	0	0		0	0	0	152687	0	52	40213296		
68536	1500	40213296	2004-02-23	2004-02-23 00:00:00	2004-02-23	2004-02-23 00:00:00	2004-02-23	581452		0	0	0		0	0	0	100095	0	52	40213296		
186662	4101	40213160	1960-08-06	1960-08-06 00:00:00	1960-08-06	1960-08-06 00:00:00	1960-08-06	581452		0	0	0		0	0	0	272518	0	10	40213160		
31654	2624	920300	1991-02-05	1991-02-05 00:00:00	1991-02-12	1991-02-12 00:00:00	1991-02-12	38000177		0	0	7		0	0	0	173592	0	311989	920300		
38223	3161	40165015	1979-11-09	1979-11-09 00:00:00	1979-11-09	1979-11-09 00:00:00	\N	38000177		0	0	0		0	0	0	210204	0	861467	40165015		
19122	1578	19126352	2015-07-19	2015-07-19 00:00:00	2015-07-19	2015-07-19 00:00:00	\N	38000177		0	0	0		0	0	0	106036	0	705129	19126352		
42247	3505	1127433	1970-07-12	1970-07-12 00:00:00	1970-08-16	1970-08-16 00:00:00	1970-08-16	38000177		0	0	35		0	0	0	232379	0	313782	1127433		
91379	2005	40213314	1977-01-15	1977-01-15 00:00:00	1977-01-15	1977-01-15 00:00:00	1977-01-15	581452		0	0	0		0	0	0	133518	0	49	40213314		
209455	4593	40213160	1963-12-18	1963-12-18 00:00:00	1963-12-18	1963-12-18 00:00:00	1963-12-18	581452		0	0	0		0	0	0	306039	0	10	40213160		
52860	4392	40224805	1997-07-09	1997-07-09 00:00:00	1998-07-04	1998-07-04 00:00:00	1998-07-04	38000177		0	0	360		0	0	0	292073	0	1000126	40224805		
42856	3552	1127433	1978-03-21	1978-03-21 00:00:00	1978-03-28	1978-03-28 00:00:00	1978-03-28	38000177		0	0	7		0	0	0	235838	0	313782	1127433		
5013	418	1127433	1981-10-20	1981-10-20 00:00:00	1981-11-10	1981-11-10 00:00:00	1981-11-10	38000177		0	0	21		0	0	0	27663	0	313782	1127433		
56555	1238	40213260	2007-11-20	2007-11-20 00:00:00	2007-11-20	2007-11-20 00:00:00	2007-11-20	581452		0	0	0		0	0	0	81603	0	121	40213260		
21160	1744	19078461	2007-07-04	2007-07-04 00:00:00	2007-07-18	2007-07-18 00:00:00	2007-07-18	38000177		0	0	14		0	0	0	116628	0	310965	19078461		
66174	1448	40213227	1995-05-31	1995-05-31 00:00:00	1995-05-31	1995-05-31 00:00:00	1995-05-31	581452		0	0	0		0	0	0	96624	0	113	40213227		
184354	4051	40213160	1978-12-27	1978-12-27 00:00:00	1978-12-27	1978-12-27 00:00:00	1978-12-27	581452		0	0	0		0	0	0	269260	0	10	40213160		
54364	4520	1539411	1992-01-11	1992-01-11 00:00:00	1992-01-11	1992-01-11 00:00:00	\N	38000177		0	0	0		0	0	0	300935	0	312961	1539411		
56312	1232	40213160	1965-03-22	1965-03-22 00:00:00	1965-03-22	1965-03-22 00:00:00	1965-03-22	581452		0	0	0		0	0	0	81182	0	10	40213160		
173998	3825	40213227	2015-08-14	2015-08-14 00:00:00	2015-08-14	2015-08-14 00:00:00	2015-08-14	581452		0	0	0		0	0	0	254105	0	113	40213227		
118191	2599	40213160	1978-05-06	1978-05-06 00:00:00	1978-05-06	1978-05-06 00:00:00	1978-05-06	581452		0	0	0		0	0	0	171948	0	10	40213160		
55349	4595	40162522	1996-02-21	1996-02-21 00:00:00	1996-02-21	1996-02-21 00:00:00	\N	38000177		0	0	0		0	0	0	306147	0	857005	40162522		
55415	4602	19133873	1985-12-26	1985-12-26 00:00:00	1986-01-07	1986-01-07 00:00:00	1986-01-07	38000177		0	0	12		0	0	0	306532	0	834061	19133873		
140548	3086	40213260	2018-09-26	2018-09-26 00:00:00	2018-09-26	2018-09-26 00:00:00	2018-09-26	581452		0	0	0		0	0	0	205487	0	121	40213260		
506	36	1127433	1996-04-29	1996-04-29 00:00:00	1996-05-13	1996-05-13 00:00:00	1996-05-13	38000177		0	0	14		0	0	0	2540	0	313782	1127433		
566	41	1713671	1977-10-21	1977-10-21 00:00:00	1977-11-11	1977-11-11 00:00:00	1977-11-11	38000177		0	0	21		0	0	0	2978	0	562251	1713671		
55674	4623	19008572	1955-05-18	1955-05-18 00:00:00	1955-05-18	1955-05-18 00:00:00	\N	38000177		0	0	0		0	0	0	308008	0	106258	19008572		
103567	2272	40213227	2011-11-05	2011-11-05 00:00:00	2011-11-05	2011-11-05 00:00:00	2011-11-05	581452		0	0	0		0	0	0	151019	0	113	40213227		
16503	1367	19078461	1981-08-25	1981-08-25 00:00:00	1981-09-08	1981-09-08 00:00:00	1981-09-08	38000177		0	0	14		0	0	0	90596	0	310965	19078461		
21308	1752	19074843	1979-10-17	1979-10-17 00:00:00	1979-10-30	1979-10-30 00:00:00	1979-10-30	38000177		0	0	13		0	0	0	117142	0	309045	19074843		
48598	4026	1127433	1970-11-21	1970-11-21 00:00:00	1970-12-05	1970-12-05 00:00:00	1970-12-05	38000177		0	0	14		0	0	0	267721	0	313782	1127433		
28962	2394	1127433	1956-04-19	1956-04-19 00:00:00	1956-04-26	1956-04-26 00:00:00	1956-04-26	38000177		0	0	7		0	0	0	159149	0	313782	1127433		
54071	4492	40220960	1992-10-27	1992-10-27 00:00:00	1992-10-27	1992-10-27 00:00:00	1992-10-27	38000177		0	0	0		0	0	0	299101	0	1804799	40220960		
3692	307	40162522	1994-08-08	1994-08-08 00:00:00	1994-08-08	1994-08-08 00:00:00	\N	38000177		0	0	0		0	0	0	20397	0	857005	40162522		
48680	4032	1127433	1987-02-19	1987-02-19 00:00:00	1987-03-05	1987-03-05 00:00:00	1987-03-05	38000177		0	0	14		0	0	0	268272	0	313782	1127433		
225207	4945	40213260	2006-05-11	2006-05-11 00:00:00	2006-05-11	2006-05-11 00:00:00	2006-05-11	581452		0	0	0		0	0	0	328695	0	121	40213260		
7563	636	1127433	2013-07-14	2013-07-14 00:00:00	2013-07-28	2013-07-28 00:00:00	2013-07-28	38000177		0	0	14		0	0	0	42184	0	313782	1127433		
12199	263	40213227	2005-06-26	2005-06-26 00:00:00	2005-06-26	2005-06-26 00:00:00	2005-06-26	581452		0	0	0		0	0	0	17497	0	113	40213227		
59315	4929	1713671	1989-02-23	1989-02-23 00:00:00	1989-03-16	1989-03-16 00:00:00	1989-03-16	38000177		0	0	21		0	0	0	327697	0	562251	1713671		
15393	1283	19133873	1975-10-09	1975-10-09 00:00:00	1975-10-19	1975-10-19 00:00:00	1975-10-19	38000177		0	0	10		0	0	0	84827	0	834061	19133873		
63064	5240	1127433	1982-11-08	1982-11-08 00:00:00	1982-11-15	1982-11-15 00:00:00	1982-11-15	38000177		0	0	7		0	0	0	348642	0	313782	1127433		
162362	3570	40213198	2014-06-08	2014-06-08 00:00:00	2014-06-08	2014-06-08 00:00:00	2014-06-08	581452		0	0	0		0	0	0	237213	0	133	40213198		
13508	1132	40229134	1972-08-23	1972-08-23 00:00:00	1972-08-30	1972-08-30 00:00:00	1972-08-30	38000177		0	0	7		0	0	0	74491	0	1043400	40229134		
39775	3289	40229134	2007-04-04	2007-04-04 00:00:00	2007-04-11	2007-04-11 00:00:00	2007-04-11	38000177		0	0	7		0	0	0	218486	0	1043400	40229134		
148186	3258	40213160	1981-11-11	1981-11-11 00:00:00	1981-11-11	1981-11-11 00:00:00	1981-11-11	581452		0	0	0		0	0	0	216630	0	10	40213160		
31494	2611	40229134	1955-06-29	1955-06-29 00:00:00	1955-07-13	1955-07-13 00:00:00	1955-07-13	38000177		0	0	14		0	0	0	172700	0	1043400	40229134		
206375	4529	40213227	2014-11-23	2014-11-23 00:00:00	2014-11-23	2014-11-23 00:00:00	2014-11-23	581452		0	0	0		0	0	0	301602	0	113	40213227		
28598	2357	19059056	1952-07-04	1952-07-04 00:00:00	1952-07-25	1952-07-25 00:00:00	1952-07-25	38000177		0	0	21		0	0	0	157003	0	243670	19059056		
34697	2865	19078461	2003-03-24	2003-03-24 00:00:00	2003-04-07	2003-04-07 00:00:00	2003-04-07	38000177		0	0	14		0	0	0	190603	0	310965	19078461		
48315	1057	40213227	1992-12-24	1992-12-24 00:00:00	1992-12-24	1992-12-24 00:00:00	1992-12-24	581452		0	0	0		0	0	0	69317	0	113	40213227		
46291	3834	19133873	1965-07-27	1965-07-27 00:00:00	1965-08-04	1965-08-04 00:00:00	1965-08-04	38000177		0	0	8		0	0	0	254601	0	834061	19133873		
39215	3240	1127433	2000-02-05	2000-02-05 00:00:00	2000-02-26	2000-02-26 00:00:00	2000-02-26	38000177		0	0	21		0	0	0	215437	0	313782	1127433		
56846	4719	1127433	2009-10-22	2009-10-22 00:00:00	2009-10-29	2009-10-29 00:00:00	2009-10-29	38000177		0	0	7		0	0	0	314332	0	313782	1127433		
39324	3248	35605482	2016-06-26	2016-06-26 00:00:00	2016-06-26	2016-06-26 00:00:00	2016-06-26	38000177		0	0	0		0	0	0	215881	0	1740467	35605482		
28012	2319	1127433	1967-06-14	1967-06-14 00:00:00	1967-07-05	1967-07-05 00:00:00	1967-07-05	38000177		0	0	21		0	0	0	154134	0	313782	1127433		
71176	1558	40213160	1955-01-06	1955-01-06 00:00:00	1955-01-06	1955-01-06 00:00:00	1955-01-06	581452		0	0	0		0	0	0	104316	0	10	40213160		
7440	160	40213260	2012-08-02	2012-08-02 00:00:00	2012-08-02	2012-08-02 00:00:00	2012-08-02	581452		0	0	0		0	0	0	10995	0	121	40213260		
115631	2541	40213227	2017-05-15	2017-05-15 00:00:00	2017-05-15	2017-05-15 00:00:00	2017-05-15	581452		0	0	0		0	0	0	\N	0	113	40213227		
44623	3695	19073183	1981-10-26	1981-10-26 00:00:00	1981-11-09	1981-11-09 00:00:00	1981-11-09	38000177		0	0	14		0	0	0	245593	0	308182	19073183		
192245	4224	40213227	2017-02-08	2017-02-08 00:00:00	2017-02-08	2017-02-08 00:00:00	2017-02-08	581452		0	0	0		0	0	0	280568	0	113	40213227		
157400	3464	40213314	1980-10-22	1980-10-22 00:00:00	1980-10-22	1980-10-22 00:00:00	1980-10-22	581452		0	0	0		0	0	0	229922	0	49	40213314		
62706	5213	19059056	1941-03-02	1941-03-02 00:00:00	1941-03-16	1941-03-16 00:00:00	1941-03-16	38000177		0	0	14		0	0	0	346745	0	243670	19059056		
55951	1226	40213314	1980-09-14	1980-09-14 00:00:00	1980-09-14	1980-09-14 00:00:00	1980-09-14	581452		0	0	0		0	0	0	80667	0	49	40213314		
192369	4226	40213296	2003-12-28	2003-12-28 00:00:00	2003-12-28	2003-12-28 00:00:00	2003-12-28	581452		0	0	0		0	0	0	280662	0	52	40213296		
59863	4976	1713671	1994-04-24	1994-04-24 00:00:00	1994-05-15	1994-05-15 00:00:00	1994-05-15	38000177		0	0	21		0	0	0	331017	0	562251	1713671		
71719	1568	40213227	2003-09-07	2003-09-07 00:00:00	2003-09-07	2003-09-07 00:00:00	2003-09-07	581452		0	0	0		0	0	0	105213	0	113	40213227		
68537	1500	40213260	2013-05-13	2013-05-13 00:00:00	2013-05-13	2013-05-13 00:00:00	2013-05-13	581452		0	0	0		0	0	0	100082	0	121	40213260		
186665	4101	40213306	1983-01-22	1983-01-22 00:00:00	1983-01-22	1983-01-22 00:00:00	1983-01-22	581452		0	0	0		0	0	0	272544	0	43	40213306		
31655	2624	40236824	1991-02-05	1991-02-05 00:00:00	1991-02-12	1991-02-12 00:00:00	1991-02-12	38000177		0	0	7		0	0	0	173592	0	1094107	40236824		
38224	3161	19078461	1979-11-09	1979-11-09 00:00:00	1980-01-08	1980-01-08 00:00:00	1980-01-08	38000177		0	0	60		0	0	0	210204	0	310965	19078461		
19123	1578	1332419	2015-07-19	2015-07-19 00:00:00	2015-07-19	2015-07-19 00:00:00	\N	38000177		0	0	0		0	0	0	106036	0	197361	1332419		
42248	3505	46233710	1970-07-12	1970-07-12 00:00:00	1970-08-16	1970-08-16 00:00:00	1970-08-16	38000177		0	0	35		0	0	0	232379	0	1650142	46233710		
91390	2006	40213227	1997-11-14	1997-11-14 00:00:00	1997-11-14	1997-11-14 00:00:00	1997-11-14	581452		0	0	0		0	0	0	133553	0	113	40213227		
209457	4593	40213296	2006-10-26	2006-10-26 00:00:00	2006-10-26	2006-10-26 00:00:00	2006-10-26	581452		0	0	0		0	0	0	306025	0	52	40213296		
52861	4392	1118084	2018-03-06	2018-03-06 00:00:00	2018-03-06	2018-03-06 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00025152531	44923712		
42857	3553	1127433	1973-09-24	1973-09-24 00:00:00	1973-10-01	1973-10-01 00:00:00	1973-10-01	38000177		0	0	7		0	0	0	235925	0	313782	1127433		
5014	418	1713671	1962-05-09	1962-05-09 00:00:00	1962-05-23	1962-05-23 00:00:00	1962-05-23	38000177		0	0	14		0	0	0	27605	0	562251	1713671		
56559	1238	40213227	1997-11-18	1997-11-18 00:00:00	1997-11-18	1997-11-18 00:00:00	1997-11-18	581452		0	0	0		0	0	0	81559	0	113	40213227		
21161	1744	1127433	1999-01-09	1999-01-09 00:00:00	1999-01-23	1999-01-23 00:00:00	1999-01-23	38000177		0	0	14		0	0	0	116621	0	313782	1127433		
66175	1448	40213306	1995-05-31	1995-05-31 00:00:00	1995-05-31	1995-05-31 00:00:00	1995-05-31	581452		0	0	0		0	0	0	96624	0	43	40213306		
184363	4051	40213227	1995-11-29	1995-11-29 00:00:00	1995-11-29	1995-11-29 00:00:00	1995-11-29	581452		0	0	0		0	0	0	\N	0	113	40213227		
54365	4520	1713671	1990-01-07	1990-01-07 00:00:00	1990-01-28	1990-01-28 00:00:00	1990-01-28	38000177		0	0	21		0	0	0	300901	0	562251	1713671		
106817	2341	40213198	2017-05-25	2017-05-25 00:00:00	2017-05-25	2017-05-25 00:00:00	2017-05-25	581452		0	0	0		0	0	0	155836	0	133	40213198		
174005	3825	40213160	1955-02-18	1955-02-18 00:00:00	1955-02-18	1955-02-18 00:00:00	1955-02-18	581452		0	0	0		0	0	0	254064	0	10	40213160		
118193	2599	40213227	2010-01-09	2010-01-09 00:00:00	2010-01-09	2010-01-09 00:00:00	2010-01-09	581452		0	0	0		0	0	0	172005	0	113	40213227		
55350	4595	1713671	1967-06-23	1967-06-23 00:00:00	1967-07-14	1967-07-14 00:00:00	1967-07-14	38000177		0	0	21		0	0	0	306163	0	562251	1713671		
55416	4602	40229134	2015-07-16	2015-07-16 00:00:00	2015-07-30	2015-07-30 00:00:00	2015-07-30	38000177		0	0	14		0	0	0	306584	0	1043400	40229134		
140555	3086	40213227	2000-08-02	2000-08-02 00:00:00	2000-08-02	2000-08-02 00:00:00	2000-08-02	581452		0	0	0		0	0	0	205482	0	113	40213227		
507	36	19006318	1959-04-19	1959-04-19 00:00:00	1959-05-03	1959-05-03 00:00:00	1959-05-03	38000177		0	0	14		0	0	0	2544	0	105078	19006318		
567	41	40229134	1989-09-24	1989-09-24 00:00:00	1989-10-08	1989-10-08 00:00:00	1989-10-08	38000177		0	0	14		0	0	0	2940	0	1043400	40229134		
55675	4623	19059056	1970-12-10	1970-12-10 00:00:00	1970-12-31	1970-12-31 00:00:00	1970-12-31	38000177		0	0	21		0	0	0	308005	0	243670	19059056		
70074	1532	40213160	1978-03-08	1978-03-08 00:00:00	1978-03-08	1978-03-08 00:00:00	1978-03-08	581452		0	0	0		0	0	0	102581	0	10	40213160		
16504	1367	19073188	1981-08-25	1981-08-25 00:00:00	1981-09-08	1981-09-08 00:00:00	1981-09-08	38000177		0	0	14		0	0	0	90596	0	308192	19073188		
103622	2273	40213314	1984-03-28	1984-03-28 00:00:00	1984-03-28	1984-03-28 00:00:00	1984-03-28	581452		0	0	0		0	0	0	151119	0	49	40213314		
48599	4026	1118084	1998-02-05	1998-02-05 00:00:00	1998-02-05	1998-02-05 00:00:00	\N	38000177		0	0	0		0	0	0	267706	0	00025152531	44923712		
28963	2394	1127433	1987-05-27	1987-05-27 00:00:00	1987-06-10	1987-06-10 00:00:00	1987-06-10	38000177		0	0	14		0	0	0	159203	0	313782	1127433		
54072	4492	19133873	1948-02-28	1948-02-28 00:00:00	1948-03-12	1948-03-12 00:00:00	1948-03-12	38000177		0	0	13		0	0	0	299081	0	834061	19133873		
3693	307	19078461	1994-08-08	1994-08-08 00:00:00	1994-10-07	1994-10-07 00:00:00	1994-10-07	38000177		0	0	60		0	0	0	20397	0	310965	19078461		
48681	4032	1127433	2001-05-22	2001-05-22 00:00:00	2001-06-05	2001-06-05 00:00:00	2001-06-05	38000177		0	0	14		0	0	0	268281	0	313782	1127433		
225210	4945	40213296	1996-11-21	1996-11-21 00:00:00	1996-11-21	1996-11-21 00:00:00	1996-11-21	581452		0	0	0		0	0	0	328694	0	52	40213296		
7564	636	1713671	1993-05-26	1993-05-26 00:00:00	1993-06-09	1993-06-09 00:00:00	1993-06-09	38000177		0	0	14		0	0	0	42180	0	562251	1713671		
144821	3183	40213306	2004-12-05	2004-12-05 00:00:00	2004-12-05	2004-12-05 00:00:00	2004-12-05	581452		0	0	0		0	0	0	211952	0	43	40213306		
59316	4929	19133873	1968-02-15	1968-02-15 00:00:00	1968-02-26	1968-02-26 00:00:00	1968-02-26	38000177		0	0	11		0	0	0	327695	0	834061	19133873		
15394	1283	1127433	1993-11-08	1993-11-08 00:00:00	1993-11-22	1993-11-22 00:00:00	1993-11-22	38000177		0	0	14		0	0	0	84825	0	313782	1127433		
63065	5240	920334	1985-07-24	1985-07-24 00:00:00	1985-07-31	1985-07-31 00:00:00	1985-07-31	38000177		0	0	7		0	0	0	348694	0	311995	920334		
162367	3570	40213201	2015-06-14	2015-06-14 00:00:00	2015-06-14	2015-06-14 00:00:00	2015-06-14	581452		0	0	0		0	0	0	237246	0	33	40213201		
13509	1132	19059056	1968-09-19	1968-09-19 00:00:00	1968-11-18	1968-11-18 00:00:00	1968-11-18	38000177		0	0	60		0	0	0	74563	0	243670	19059056		
39776	3289	40165015	1968-01-12	1968-01-12 00:00:00	1968-01-12	1968-01-12 00:00:00	\N	38000177		0	0	0		0	0	0	218471	0	861467	40165015		
148192	3258	40213314	1982-08-11	1982-08-11 00:00:00	1982-08-11	1982-08-11 00:00:00	1982-08-11	581452		0	0	0		0	0	0	216607	0	49	40213314		
31495	2611	19133905	2002-03-15	2002-03-15 00:00:00	2002-03-28	2002-03-28 00:00:00	2002-03-28	38000177		0	0	13		0	0	0	172668	0	834102	19133905		
206376	4529	40213260	2014-11-23	2014-11-23 00:00:00	2014-11-23	2014-11-23 00:00:00	2014-11-23	581452		0	0	0		0	0	0	301602	0	121	40213260		
28599	2357	40231925	1952-07-04	1952-07-04 00:00:00	1952-07-04	1952-07-04 00:00:00	\N	38000177		0	0	0		0	0	0	157003	0	1049221	40231925		
34698	2865	1127078	1970-08-16	1970-08-16 00:00:00	1970-09-20	1970-09-20 00:00:00	1970-09-20	38000177		0	0	35		0	0	0	190571	0	282464	1127078		
48320	1057	40213296	2001-07-26	2001-07-26 00:00:00	2001-07-26	2001-07-26 00:00:00	2001-07-26	581452		0	0	0		0	0	0	69318	0	52	40213296		
46292	3834	19129655	1966-08-24	1966-08-24 00:00:00	1966-09-07	1966-09-07 00:00:00	1966-09-07	38000177		0	0	14		0	0	0	254556	0	789980	19129655		
39216	3240	19059056	1963-02-23	1963-02-23 00:00:00	1963-03-09	1963-03-09 00:00:00	1963-03-09	38000177		0	0	14		0	0	0	215431	0	243670	19059056		
56847	4719	19133905	1997-08-19	1997-08-19 00:00:00	1997-08-31	1997-08-31 00:00:00	1997-08-31	38000177		0	0	12		0	0	0	314330	0	834102	19133905		
39325	3248	35605482	2016-06-26	2016-06-26 00:00:00	2016-06-26	2016-06-26 00:00:00	2016-06-26	38000177		0	0	0		0	0	0	215881	0	1740467	35605482		
28013	2319	40232448	1952-03-06	1952-03-06 00:00:00	1952-03-06	1952-03-06 00:00:00	\N	38000177		0	0	0		0	0	0	154193	0	1049630	40232448		
232939	5118	40213227	2009-07-29	2009-07-29 00:00:00	2009-07-29	2009-07-29 00:00:00	2009-07-29	581452		0	0	0		0	0	0	340223	0	113	40213227		
7446	160	40213296	2001-08-02	2001-08-02 00:00:00	2001-08-02	2001-08-02 00:00:00	2001-08-02	581452		0	0	0		0	0	0	11013	0	52	40213296		
115632	2541	40213296	2017-05-15	2017-05-15 00:00:00	2017-05-15	2017-05-15 00:00:00	2017-05-15	581452		0	0	0		0	0	0	\N	0	52	40213296		
44624	3695	1115171	2010-04-09	2010-04-09 00:00:00	2010-05-14	2010-05-14 00:00:00	2010-05-14	38000177		0	0	35		0	0	0	245566	0	849574	1115171		
114753	2521	40213227	1992-02-03	1992-02-03 00:00:00	1992-02-03	1992-02-03 00:00:00	1992-02-03	581452		0	0	0		0	0	0	166779	0	113	40213227		
157408	3464	40213227	2002-12-11	2002-12-11 00:00:00	2002-12-11	2002-12-11 00:00:00	2002-12-11	581452		0	0	0		0	0	0	229929	0	113	40213227		
62707	5213	1127433	1975-03-04	1975-03-04 00:00:00	1975-03-18	1975-03-18 00:00:00	1975-03-18	38000177		0	0	14		0	0	0	346773	0	313782	1127433		
55952	1226	40213160	1980-09-14	1980-09-14 00:00:00	1980-09-14	1980-09-14 00:00:00	1980-09-14	581452		0	0	0		0	0	0	80667	0	10	40213160		
192371	4226	40213296	2006-01-01	2006-01-01 00:00:00	2006-01-01	2006-01-01 00:00:00	2006-01-01	581452		0	0	0		0	0	0	280709	0	52	40213296		
59864	4976	1127433	1987-01-10	1987-01-10 00:00:00	1987-01-24	1987-01-24 00:00:00	1987-01-24	38000177		0	0	14		0	0	0	330971	0	313782	1127433		
71722	1568	40213160	1957-08-11	1957-08-11 00:00:00	1957-08-11	1957-08-11 00:00:00	1957-08-11	581452		0	0	0		0	0	0	105175	0	10	40213160		
68539	1500	40213227	2013-05-13	2013-05-13 00:00:00	2013-05-13	2013-05-13 00:00:00	2013-05-13	581452		0	0	0		0	0	0	100082	0	113	40213227		
186670	4101	40213260	2010-02-27	2010-02-27 00:00:00	2010-02-27	2010-02-27 00:00:00	2010-02-27	581452		0	0	0		0	0	0	272548	0	121	40213260		
31656	2624	19128065	1984-12-15	1984-12-15 00:00:00	1985-12-10	1985-12-10 00:00:00	1985-12-10	38000177		0	0	360		0	0	0	173607	0	749882	19128065		
38225	3161	1127433	2018-03-22	2018-03-22 00:00:00	2018-03-29	2018-03-29 00:00:00	2018-03-29	38000177		0	0	7		0	0	0	210216	0	313782	1127433		
19124	1578	1539411	2015-07-19	2015-07-19 00:00:00	2015-07-19	2015-07-19 00:00:00	\N	38000177		0	0	0		0	0	0	106036	0	312961	1539411		
42249	3505	40165015	1970-07-12	1970-07-12 00:00:00	1970-07-12	1970-07-12 00:00:00	\N	38000177		0	0	0		0	0	0	232379	0	861467	40165015		
22546	1851	40229134	2001-01-15	2001-01-15 00:00:00	2001-01-22	2001-01-22 00:00:00	2001-01-22	38000177		0	0	7		0	0	0	123859	0	1043400	40229134		
209463	4593	40213260	2013-11-13	2013-11-13 00:00:00	2013-11-13	2013-11-13 00:00:00	2013-11-13	581452		0	0	0		0	0	0	306026	0	121	40213260		
52862	4392	1127433	2004-12-08	2004-12-08 00:00:00	2004-12-15	2004-12-15 00:00:00	2004-12-15	38000177		0	0	7		0	0	0	292061	0	313782	1127433		
42858	3553	1127433	1977-05-13	1977-05-13 00:00:00	1977-05-20	1977-05-20 00:00:00	1977-05-20	38000177		0	0	7		0	0	0	235926	0	313782	1127433		
5015	418	19059056	1967-09-13	1967-09-13 00:00:00	1967-12-12	1967-12-12 00:00:00	1967-12-12	38000177		0	0	90		0	0	0	27671	0	243670	19059056		
56560	1238	40213296	1997-11-18	1997-11-18 00:00:00	1997-11-18	1997-11-18 00:00:00	1997-11-18	581452		0	0	0		0	0	0	81559	0	52	40213296		
21162	1744	40229134	1999-08-10	1999-08-10 00:00:00	1999-08-24	1999-08-24 00:00:00	1999-08-24	38000177		0	0	14		0	0	0	116620	0	1043400	40229134		
66178	1448	40213160	1973-07-04	1973-07-04 00:00:00	1973-07-04	1973-07-04 00:00:00	1973-07-04	581452		0	0	0		0	0	0	96626	0	10	40213160		
184364	4051	40213306	1995-11-29	1995-11-29 00:00:00	1995-11-29	1995-11-29 00:00:00	1995-11-29	581452		0	0	0		0	0	0	\N	0	43	40213306		
54366	4520	19059056	1930-11-08	1930-11-08 00:00:00	1930-11-22	1930-11-22 00:00:00	1930-11-22	38000177		0	0	14		0	0	0	300877	0	243670	19059056		
106819	2342	40213314	1978-03-17	1978-03-17 00:00:00	1978-03-17	1978-03-17 00:00:00	1978-03-17	581452		0	0	0		0	0	0	155905	0	49	40213314		
174012	3825	40213260	2007-06-29	2007-06-29 00:00:00	2007-06-29	2007-06-29 00:00:00	2007-06-29	581452		0	0	0		0	0	0	254034	0	121	40213260		
118196	2599	40213296	2018-02-03	2018-02-03 00:00:00	2018-02-03	2018-02-03 00:00:00	2018-02-03	581452		0	0	0		0	0	0	171974	0	52	40213296		
55351	4595	1127433	1991-04-09	1991-04-09 00:00:00	1991-04-23	1991-04-23 00:00:00	1991-04-23	38000177		0	0	14		0	0	0	306188	0	313782	1127433		
55417	4602	1713671	1983-09-10	1983-09-10 00:00:00	1983-09-24	1983-09-24 00:00:00	1983-09-24	38000177		0	0	14		0	0	0	306552	0	562251	1713671		
140559	3086	40213160	1969-01-01	1969-01-01 00:00:00	1969-01-01	1969-01-01 00:00:00	1969-01-01	581452		0	0	0		0	0	0	205472	0	10	40213160		
508	36	19059056	1959-04-19	1959-04-19 00:00:00	1959-05-03	1959-05-03 00:00:00	1959-05-03	38000177		0	0	14		0	0	0	2544	0	243670	19059056		
568	41	19133873	1983-01-01	1983-01-01 00:00:00	1983-01-11	1983-01-11 00:00:00	1983-01-11	38000177		0	0	10		0	0	0	2923	0	834061	19133873		
55676	4623	1124300	1971-08-22	1971-08-22 00:00:00	1971-08-22	1971-08-22 00:00:00	\N	38000177		0	0	0		0	0	0	308005	0	00781178901	45011828		
70075	1532	40213314	1978-03-08	1978-03-08 00:00:00	1978-03-08	1978-03-08 00:00:00	1978-03-08	581452		0	0	0		0	0	0	102581	0	49	40213314		
89247	1956	40213227	2014-07-01	2014-07-01 00:00:00	2014-07-01	2014-07-01 00:00:00	2014-07-01	581452		0	0	0		0	0	0	130102	0	113	40213227		
103623	2273	40213160	1984-03-28	1984-03-28 00:00:00	1984-03-28	1984-03-28 00:00:00	1984-03-28	581452		0	0	0		0	0	0	151119	0	10	40213160		
48600	4026	19133873	1959-01-22	1959-01-22 00:00:00	1959-02-02	1959-02-02 00:00:00	1959-02-02	38000177		0	0	11		0	0	0	267728	0	834061	19133873		
28964	2395	19078461	1989-07-26	1989-07-26 00:00:00	1989-08-16	1989-08-16 00:00:00	1989-08-16	38000177		0	0	21		0	0	0	159240	0	310965	19078461		
54074	4492	1127078	1957-07-07	1957-07-07 00:00:00	1957-07-28	1957-07-28 00:00:00	1957-07-28	38000177		0	0	21		0	0	0	299046	0	282464	1127078		
3694	307	1713671	1979-11-02	1979-11-02 00:00:00	1979-11-09	1979-11-09 00:00:00	1979-11-09	38000177		0	0	7		0	0	0	20368	0	562251	1713671		
48682	4032	1127433	2010-12-23	2010-12-23 00:00:00	2011-01-13	2011-01-13 00:00:00	2011-01-13	38000177		0	0	21		0	0	0	268213	0	313782	1127433		
94261	2069	40213227	2003-02-23	2003-02-23 00:00:00	2003-02-23	2003-02-23 00:00:00	2003-02-23	581452		0	0	0		0	0	0	137643	0	113	40213227		
7565	636	19006318	1952-01-21	1952-01-21 00:00:00	1952-02-04	1952-02-04 00:00:00	1952-02-04	38000177		0	0	14		0	0	0	42149	0	105078	19006318		
144823	3183	40213314	1982-04-18	1982-04-18 00:00:00	1982-04-18	1982-04-18 00:00:00	1982-04-18	581452		0	0	0		0	0	0	211912	0	49	40213314		
59317	4929	19128065	1977-12-02	1977-12-02 00:00:00	1978-11-27	1978-11-27 00:00:00	1978-11-27	38000177		0	0	360		0	0	0	327700	0	749882	19128065		
15409	1285	1118084	1990-11-28	1990-11-28 00:00:00	1990-11-28	1990-11-28 00:00:00	\N	38000177		0	0	0		0	0	0	84938	0	00025152531	44923712		
63066	5240	19059056	1939-08-26	1939-08-26 00:00:00	1939-09-09	1939-09-09 00:00:00	1939-09-09	38000177		0	0	14		0	0	0	348617	0	243670	19059056		
162370	3570	40213160	1955-11-27	1955-11-27 00:00:00	1955-11-27	1955-11-27 00:00:00	1955-11-27	581452		0	0	0		0	0	0	237238	0	10	40213160		
13510	1132	1713671	1976-09-05	1976-09-05 00:00:00	1976-09-26	1976-09-26 00:00:00	1976-09-26	38000177		0	0	21		0	0	0	74507	0	562251	1713671		
39777	3289	1127433	1991-06-05	1991-06-05 00:00:00	1991-06-12	1991-06-12 00:00:00	1991-06-12	38000177		0	0	7		0	0	0	218536	0	313782	1127433		
148202	3258	40213227	2004-05-12	2004-05-12 00:00:00	2004-05-12	2004-05-12 00:00:00	2004-05-12	581452		0	0	0		0	0	0	216588	0	113	40213227		
31496	2611	19133905	2008-08-26	2008-08-26 00:00:00	2008-09-08	2008-09-08 00:00:00	2008-09-08	38000177		0	0	13		0	0	0	172669	0	834102	19133905		
206380	4529	40213227	1995-02-05	1995-02-05 00:00:00	1995-02-05	1995-02-05 00:00:00	1995-02-05	581452		0	0	0		0	0	0	301561	0	113	40213227		
28600	2357	19006318	1952-07-04	1952-07-04 00:00:00	1952-07-25	1952-07-25 00:00:00	1952-07-25	38000177		0	0	21		0	0	0	157003	0	105078	19006318		
34699	2865	1127078	1970-06-17	1970-06-17 00:00:00	1970-07-01	1970-07-01 00:00:00	1970-07-01	38000177		0	0	14		0	0	0	190579	0	282464	1127078		
48322	1057	40213160	1962-03-29	1962-03-29 00:00:00	1962-03-29	1962-03-29 00:00:00	1962-03-29	581452		0	0	0		0	0	0	69295	0	10	40213160		
46293	3834	1127078	1966-08-24	1966-08-24 00:00:00	1966-09-07	1966-09-07 00:00:00	1966-09-07	38000177		0	0	14		0	0	0	254556	0	282464	1127078		
39217	3240	40229134	2006-07-10	2006-07-10 00:00:00	2006-07-24	2006-07-24 00:00:00	2006-07-24	38000177		0	0	14		0	0	0	215349	0	1043400	40229134		
56848	4719	1127433	1966-07-05	1966-07-05 00:00:00	1966-07-12	1966-07-12 00:00:00	1966-07-12	38000177		0	0	7		0	0	0	314189	0	313782	1127433		
39326	3248	782047	2016-06-26	2016-06-26 00:00:00	2016-06-26	2016-06-26 00:00:00	2016-06-26	38000177		0	0	0		0	0	0	215881	0	542347	782047		
28014	2319	40174880	2015-01-29	2015-01-29 00:00:00	2015-01-29	2015-01-29 00:00:00	\N	38000177		0	0	0		0	0	0	154211	0	966222	40174880		
232940	5118	40213296	2009-07-29	2009-07-29 00:00:00	2009-07-29	2009-07-29 00:00:00	2009-07-29	581452		0	0	0		0	0	0	340223	0	52	40213296		
7448	160	40213306	1984-02-02	1984-02-02 00:00:00	1984-02-02	1984-02-02 00:00:00	1984-02-02	581452		0	0	0		0	0	0	10994	0	43	40213306		
126915	2792	40213227	2018-12-10	2018-12-10 00:00:00	2018-12-10	2018-12-10 00:00:00	2018-12-10	581452		0	0	0		0	0	0	185070	0	113	40213227		
44625	3695	40243436	2007-02-12	2007-02-12 00:00:00	2007-02-12	2007-02-12 00:00:00	2007-02-12	38000177		0	0	0		0	0	0	245606	0	1190795	40243436		
114756	2521	40213227	2009-08-31	2009-08-31 00:00:00	2009-08-31	2009-08-31 00:00:00	2009-08-31	581452		0	0	0		0	0	0	166694	0	113	40213227		
157409	3464	40213306	2002-12-11	2002-12-11 00:00:00	2002-12-11	2002-12-11 00:00:00	2002-12-11	581452		0	0	0		0	0	0	229929	0	43	40213306		
62708	5213	1127433	1991-09-23	1991-09-23 00:00:00	1991-10-07	1991-10-07 00:00:00	1991-10-07	38000177		0	0	14		0	0	0	346766	0	313782	1127433		
55957	1226	40213251	1984-03-11	1984-03-11 00:00:00	1984-03-11	1984-03-11 00:00:00	1984-03-11	581452		0	0	0		0	0	0	80675	0	21	40213251		
192385	4226	40213160	1967-07-02	1967-07-02 00:00:00	1967-07-02	1967-07-02 00:00:00	1967-07-02	581452		0	0	0		0	0	0	\N	0	10	40213160		
59865	4976	1127433	1981-06-05	1981-06-05 00:00:00	1981-06-19	1981-06-19 00:00:00	1981-06-19	38000177		0	0	14		0	0	0	330978	0	313782	1127433		
71735	1568	40213198	2017-11-26	2017-11-26 00:00:00	2017-11-26	2017-11-26 00:00:00	2017-11-26	581452		0	0	0		0	0	0	105193	0	133	40213198		
68544	1500	40213296	2002-02-18	2002-02-18 00:00:00	2002-02-18	2002-02-18 00:00:00	2002-02-18	581452		0	0	0		0	0	0	100115	0	52	40213296		
200472	4403	40213227	1996-06-22	1996-06-22 00:00:00	1996-06-22	1996-06-22 00:00:00	1996-06-22	581452		0	0	0		0	0	0	292691	0	113	40213227		
31657	2624	40236446	1975-01-02	1975-01-02 00:00:00	1977-06-09	1977-06-09 00:00:00	1977-06-09	38000177		0	0	889		0	0	0	173578	0	1091392	40236446		
38226	3161	1713671	1958-07-08	1958-07-08 00:00:00	1958-07-22	1958-07-22 00:00:00	1958-07-22	38000177		0	0	14		0	0	0	210212	0	562251	1713671		
19125	1578	19075601	2015-07-19	2015-07-19 00:00:00	2015-07-19	2015-07-19 00:00:00	\N	38000177		0	0	0		0	0	0	106036	0	309362	19075601		
42250	3505	1127433	2018-04-28	2018-04-28 00:00:00	2018-05-12	2018-05-12 00:00:00	2018-05-12	38000177		0	0	14		0	0	0	232415	0	313782	1127433		
22547	1851	19074679	1994-04-28	1994-04-28 00:00:00	1994-09-29	1994-09-29 00:00:00	1994-09-29	38000177		0	0	154		0	0	0	123824	0	308971	19074679		
209465	4593	40213227	2004-10-21	2004-10-21 00:00:00	2004-10-21	2004-10-21 00:00:00	2004-10-21	581452		0	0	0		0	0	0	306048	0	113	40213227		
52863	4392	1115171	1997-07-27	1997-07-27 00:00:00	1997-08-10	1997-08-10 00:00:00	1997-08-10	38000177		0	0	14		0	0	0	292084	0	849574	1115171		
42859	3553	19077572	2006-06-24	2006-06-24 00:00:00	2006-06-24	2006-06-24 00:00:00	\N	38000177		0	0	0		0	0	0	235918	0	310436	19077572		
5016	418	1127078	1959-08-28	1959-08-28 00:00:00	1959-09-25	1959-09-25 00:00:00	1959-09-25	38000177		0	0	28		0	0	0	27668	0	282464	1127078		
56562	1238	40213227	2006-11-14	2006-11-14 00:00:00	2006-11-14	2006-11-14 00:00:00	2006-11-14	581452		0	0	0		0	0	0	81593	0	113	40213227		
21163	1744	1713671	2011-05-13	2011-05-13 00:00:00	2011-06-03	2011-06-03 00:00:00	2011-06-03	38000177		0	0	21		0	0	0	116630	0	562251	1713671		
66183	1448	40213160	1973-09-05	1973-09-05 00:00:00	1973-09-05	1973-09-05 00:00:00	1973-09-05	581452		0	0	0		0	0	0	96616	0	10	40213160		
3970	86	40213227	2019-06-04	2019-06-04 00:00:00	2019-06-04	2019-06-04 00:00:00	2019-06-04	581452		0	0	0		0	0	0	5766	0	113	40213227		
54367	4520	19059056	1935-10-24	1935-10-24 00:00:00	1935-11-07	1935-11-07 00:00:00	1935-11-07	38000177		0	0	14		0	0	0	300889	0	243670	19059056		
106824	2342	40213314	1977-09-16	1977-09-16 00:00:00	1977-09-16	1977-09-16 00:00:00	1977-09-16	581452		0	0	0		0	0	0	155875	0	49	40213314		
174017	3825	40213160	1955-08-19	1955-08-19 00:00:00	1955-08-19	1955-08-19 00:00:00	1955-08-19	581452		0	0	0		0	0	0	254078	0	10	40213160		
118199	2599	40213160	1978-10-07	1978-10-07 00:00:00	1978-10-07	1978-10-07 00:00:00	1978-10-07	581452		0	0	0		0	0	0	171949	0	10	40213160		
55352	4595	1124300	2001-11-14	2001-11-14 00:00:00	2001-11-14	2001-11-14 00:00:00	\N	38000177		0	0	0		0	0	0	306215	0	00781178901	45011828		
55418	4602	1124300	2011-05-21	2011-05-21 00:00:00	2011-05-21	2011-05-21 00:00:00	\N	38000177		0	0	0		0	0	0	306580	0	00781178901	45011828		
140562	3086	40213160	1969-03-05	1969-03-05 00:00:00	1969-03-05	1969-03-05 00:00:00	1969-03-05	581452		0	0	0		0	0	0	205429	0	10	40213160		
509	36	1115171	2011-07-06	2011-07-06 00:00:00	2011-07-27	2011-07-27 00:00:00	2011-07-27	38000177		0	0	21		0	0	0	2612	0	849574	1115171		
569	41	1127433	1974-10-19	1974-10-19 00:00:00	1974-10-26	1974-10-26 00:00:00	1974-10-26	38000177		0	0	7		0	0	0	2901	0	313782	1127433		
55677	4623	19059056	1946-04-15	1946-04-15 00:00:00	1946-04-29	1946-04-29 00:00:00	1946-04-29	38000177		0	0	14		0	0	0	307979	0	243670	19059056		
70080	1532	40213227	1999-12-01	1999-12-01 00:00:00	1999-12-01	1999-12-01 00:00:00	1999-12-01	581452		0	0	0		0	0	0	102623	0	113	40213227		
89249	1956	40213227	1995-06-27	1995-06-27 00:00:00	1995-06-27	1995-06-27 00:00:00	1995-06-27	581452		0	0	0		0	0	0	130100	0	113	40213227		
103633	2273	40213160	1984-06-27	1984-06-27 00:00:00	1984-06-27	1984-06-27 00:00:00	1984-06-27	581452		0	0	0		0	0	0	151104	0	10	40213160		
48601	4026	19008572	1977-01-30	1977-01-30 00:00:00	1977-01-30	1977-01-30 00:00:00	\N	38000177		0	0	0		0	0	0	267723	0	106258	19008572		
28965	2395	19133873	1972-08-06	1972-08-06 00:00:00	1972-08-13	1972-08-13 00:00:00	1972-08-13	38000177		0	0	7		0	0	0	159243	0	834061	19133873		
54075	4492	1713671	1969-11-07	1969-11-07 00:00:00	1970-05-01	1970-05-01 00:00:00	1970-05-01	38000177		0	0	175		0	0	0	299099	0	562251	1713671		
3695	307	1127433	1990-08-03	1990-08-03 00:00:00	1990-08-24	1990-08-24 00:00:00	1990-08-24	38000177		0	0	21		0	0	0	20382	0	313782	1127433		
48683	4032	1127433	2002-11-03	2002-11-03 00:00:00	2002-11-10	2002-11-10 00:00:00	2002-11-10	38000177		0	0	7		0	0	0	268282	0	313782	1127433		
94265	2069	40213227	2013-04-22	2013-04-22 00:00:00	2013-04-22	2013-04-22 00:00:00	2013-04-22	581452		0	0	0		0	0	0	137626	0	113	40213227		
7566	636	1127078	1952-01-21	1952-01-21 00:00:00	1952-02-04	1952-02-04 00:00:00	1952-02-04	38000177		0	0	14		0	0	0	42149	0	282464	1127078		
144830	3183	40213160	1986-01-19	1986-01-19 00:00:00	1986-01-19	1986-01-19 00:00:00	1986-01-19	581452		0	0	0		0	0	0	211914	0	10	40213160		
59318	4929	1115171	2004-10-20	2004-10-20 00:00:00	2004-11-03	2004-11-03 00:00:00	2004-11-03	38000177		0	0	14		0	0	0	327673	0	849574	1115171		
15410	1285	40171902	2014-05-19	2014-05-19 00:00:00	2014-05-19	2014-05-19 00:00:00	\N	38000177		0	0	0		0	0	0	84966	0	897718	40171902		
63067	5240	19078461	1976-05-23	1976-05-23 00:00:00	1976-06-20	1976-06-20 00:00:00	1976-06-20	38000177		0	0	28		0	0	0	348610	0	310965	19078461		
162377	3571	40213227	2014-05-06	2014-05-06 00:00:00	2014-05-06	2014-05-06 00:00:00	2014-05-06	581452		0	0	0		0	0	0	237356	0	113	40213227		
13513	1132	1127433	2010-04-24	2010-04-24 00:00:00	2010-05-01	2010-05-01 00:00:00	2010-05-01	38000177		0	0	7		0	0	0	74495	0	313782	1127433		
39778	3289	19059056	1966-12-16	1966-12-16 00:00:00	1967-01-15	1967-01-15 00:00:00	1967-01-15	38000177		0	0	30		0	0	0	218490	0	243670	19059056		
148203	3258	40213306	2004-05-12	2004-05-12 00:00:00	2004-05-12	2004-05-12 00:00:00	2004-05-12	581452		0	0	0		0	0	0	216588	0	43	40213306		
31497	2611	19078461	1977-12-28	1977-12-28 00:00:00	1978-01-18	1978-01-18 00:00:00	1978-01-18	38000177		0	0	21		0	0	0	172654	0	310965	19078461		
206382	4529	40213160	1964-04-26	1964-04-26 00:00:00	1964-04-26	1964-04-26 00:00:00	1964-04-26	581452		0	0	0		0	0	0	301582	0	10	40213160		
28601	2357	19133905	1993-10-02	1993-10-02 00:00:00	1993-10-10	1993-10-10 00:00:00	1993-10-10	38000177		0	0	8		0	0	0	156982	0	834102	19133905		
34700	2865	46233988	1970-06-17	1970-06-17 00:00:00	1970-07-01	1970-07-01 00:00:00	1970-07-01	38000177		0	0	14		0	0	0	190579	0	1652673	46233988		
48325	1057	40213306	1983-09-22	1983-09-22 00:00:00	1983-09-22	1983-09-22 00:00:00	1983-09-22	581452		0	0	0		0	0	0	69305	0	43	40213306		
46294	3834	1713671	1971-10-13	1971-10-13 00:00:00	1972-02-02	1972-02-02 00:00:00	1972-02-02	38000177		0	0	112		0	0	0	254621	0	562251	1713671		
39218	3240	19078461	1976-08-11	1976-08-11 00:00:00	1976-09-08	1976-09-08 00:00:00	1976-09-08	38000177		0	0	28		0	0	0	215436	0	310965	19078461		
56849	4719	1551192	1940-09-01	1940-09-01 00:00:00	1940-09-01	1940-09-01 00:00:00	1940-09-01	38000177		0	0	0		0	0	0	314226	0	312617	1551192		
39327	3248	40220386	2016-06-26	2016-06-26 00:00:00	2016-06-26	2016-06-26 00:00:00	2016-06-26	38000177		0	0	0		0	0	0	215881	0	1808217	40220386		
28015	2319	19078461	1980-11-23	1980-11-23 00:00:00	1980-12-21	1980-12-21 00:00:00	1980-12-21	38000177		0	0	28		0	0	0	154135	0	310965	19078461		
232944	5118	40213306	1990-01-17	1990-01-17 00:00:00	1990-01-17	1990-01-17 00:00:00	1990-01-17	581452		0	0	0		0	0	0	340255	0	43	40213306		
194211	4268	40213160	1956-02-20	1956-02-20 00:00:00	1956-02-20	1956-02-20 00:00:00	1956-02-20	581452		0	0	0		0	0	0	283268	0	10	40213160		
126916	2792	40213160	1958-01-13	1958-01-13 00:00:00	1958-01-13	1958-01-13 00:00:00	1958-01-13	581452		0	0	0		0	0	0	184998	0	10	40213160		
44626	3695	46275916	2007-02-12	2007-02-12 00:00:00	2007-02-12	2007-02-12 00:00:00	2007-02-12	38000177		0	0	0		0	0	0	245606	0	1660014	46275916		
114766	2521	40213160	1955-12-19	1955-12-19 00:00:00	1955-12-19	1955-12-19 00:00:00	1955-12-19	581452		0	0	0		0	0	0	166706	0	10	40213160		
57997	4819	19133873	1967-08-14	1967-08-14 00:00:00	1967-08-23	1967-08-23 00:00:00	1967-08-23	38000177		0	0	9		0	0	0	320512	0	834061	19133873		
62709	5213	19059056	1942-09-14	1942-09-14 00:00:00	1942-09-28	1942-09-28 00:00:00	1942-09-28	38000177		0	0	14		0	0	0	346711	0	243670	19059056		
55959	1226	40213251	1985-03-17	1985-03-17 00:00:00	1985-03-17	1985-03-17 00:00:00	1985-03-17	581452		0	0	0		0	0	0	80670	0	21	40213251		
192387	4226	40213160	1963-04-28	1963-04-28 00:00:00	1963-04-28	1963-04-28 00:00:00	1963-04-28	581452		0	0	0		0	0	0	280645	0	10	40213160		
59866	4976	1118084	1953-12-22	1953-12-22 00:00:00	1953-12-22	1953-12-22 00:00:00	\N	38000177		0	0	0		0	0	0	331033	0	00025152531	44923712		
71739	1568	40213227	1994-09-11	1994-09-11 00:00:00	1994-09-11	1994-09-11 00:00:00	1994-09-11	581452		0	0	0		0	0	0	105152	0	113	40213227		
68551	1500	40213160	1962-05-21	1962-05-21 00:00:00	1962-05-21	1962-05-21 00:00:00	1962-05-21	581452		0	0	0		0	0	0	100086	0	10	40213160		
31601	2620	19128065	1978-11-03	1978-11-03 00:00:00	1979-10-29	1979-10-29 00:00:00	1979-10-29	38000177		0	0	360		0	0	0	173305	0	749882	19128065		
31658	2624	1713671	2006-02-16	2006-02-16 00:00:00	2006-02-23	2006-02-23 00:00:00	2006-02-23	38000177		0	0	7		0	0	0	173603	0	562251	1713671		
38227	3161	19006318	1953-03-14	1953-03-14 00:00:00	1953-03-28	1953-03-28 00:00:00	1953-03-28	38000177		0	0	14		0	0	0	210241	0	105078	19006318		
19126	1578	40229134	1950-09-27	1950-09-27 00:00:00	1950-10-11	1950-10-11 00:00:00	1950-10-11	38000177		0	0	14		0	0	0	106023	0	1043400	40229134		
42251	3505	1127433	1992-09-28	1992-09-28 00:00:00	1992-10-05	1992-10-05 00:00:00	1992-10-05	38000177		0	0	7		0	0	0	232453	0	313782	1127433		
22550	1852	19133873	1976-07-22	1976-07-22 00:00:00	1976-07-29	1976-07-29 00:00:00	1976-07-29	38000177		0	0	7		0	0	0	123950	0	834061	19133873		
209466	4593	40213296	2004-10-21	2004-10-21 00:00:00	2004-10-21	2004-10-21 00:00:00	2004-10-21	581452		0	0	0		0	0	0	306048	0	52	40213296		
52864	4392	1713671	2016-12-14	2016-12-14 00:00:00	2017-01-04	2017-01-04 00:00:00	2017-01-04	38000177		0	0	21		0	0	0	292062	0	562251	1713671		
42860	3553	19133873	1937-11-21	1937-11-21 00:00:00	1937-11-30	1937-11-30 00:00:00	1937-11-30	38000177		0	0	9		0	0	0	235868	0	834061	19133873		
5017	418	1127078	1961-05-17	1961-05-17 00:00:00	1961-08-15	1961-08-15 00:00:00	1961-08-15	38000177		0	0	90		0	0	0	27669	0	282464	1127078		
56564	1238	40213260	2006-11-14	2006-11-14 00:00:00	2006-11-14	2006-11-14 00:00:00	2006-11-14	581452		0	0	0		0	0	0	81593	0	121	40213260		
21164	1744	40229134	1980-05-06	1980-05-06 00:00:00	1980-05-13	1980-05-13 00:00:00	1980-05-13	38000177		0	0	7		0	0	0	116611	0	1043400	40229134		
66188	1448	40213227	2004-06-09	2004-06-09 00:00:00	2004-06-09	2004-06-09 00:00:00	2004-06-09	581452		0	0	0		0	0	0	96613	0	113	40213227		
3993	86	40213198	2013-04-30	2013-04-30 00:00:00	2013-04-30	2013-04-30 00:00:00	2013-04-30	581452		0	0	0		0	0	0	5814	0	133	40213198		
54368	4521	19133905	1991-01-17	1991-01-17 00:00:00	1991-01-24	1991-01-24 00:00:00	1991-01-24	38000177		0	0	7		0	0	0	301021	0	834102	19133905		
106830	2342	40213227	2006-10-13	2006-10-13 00:00:00	2006-10-13	2006-10-13 00:00:00	2006-10-13	581452		0	0	0		0	0	0	155883	0	113	40213227		
177102	3892	40213227	1993-09-18	1993-09-18 00:00:00	1993-09-18	1993-09-18 00:00:00	1993-09-18	581452		0	0	0		0	0	0	258815	0	113	40213227		
118204	2599	40213314	1979-04-07	1979-04-07 00:00:00	1979-04-07	1979-04-07 00:00:00	1979-04-07	581452		0	0	0		0	0	0	171963	0	49	40213314		
55353	4595	1127433	1996-02-14	1996-02-14 00:00:00	1996-03-22	1996-03-22 00:00:00	1996-03-22	38000177		0	0	37		0	0	0	306179	0	313782	1127433		
55419	4602	1127433	1996-04-30	1996-04-30 00:00:00	1996-05-07	1996-05-07 00:00:00	1996-05-07	38000177		0	0	7		0	0	0	306542	0	313782	1127433		
140564	3086	40213306	1991-07-24	1991-07-24 00:00:00	1991-07-24	1991-07-24 00:00:00	1991-07-24	581452		0	0	0		0	0	0	205479	0	43	40213306		
511	36	19008572	2015-07-08	2015-07-08 00:00:00	2015-07-29	2015-07-29 00:00:00	2015-07-29	38000177		0	0	21		0	0	0	2572	0	106258	19008572		
570	41	40232448	1977-06-15	1977-06-15 00:00:00	1977-06-15	1977-06-15 00:00:00	\N	38000177		0	0	0		0	0	0	2919	0	1049630	40232448		
55678	4623	19006318	1946-04-15	1946-04-15 00:00:00	1946-04-29	1946-04-29 00:00:00	1946-04-29	38000177		0	0	14		0	0	0	307979	0	105078	19006318		
70081	1532	40213306	1999-12-01	1999-12-01 00:00:00	1999-12-01	1999-12-01 00:00:00	1999-12-01	581452		0	0	0		0	0	0	102623	0	43	40213306		
89254	1956	40213160	1963-12-03	1963-12-03 00:00:00	1963-12-03	1963-12-03 00:00:00	1963-12-03	581452		0	0	0		0	0	0	130128	0	10	40213160		
114921	2525	40213160	1978-12-15	1978-12-15 00:00:00	1978-12-15	1978-12-15 00:00:00	1978-12-15	581452		0	0	0		0	0	0	166985	0	10	40213160		
48602	4026	19078461	1992-04-18	1992-04-18 00:00:00	1992-05-09	1992-05-09 00:00:00	1992-05-09	38000177		0	0	21		0	0	0	267633	0	310965	19078461		
28966	2395	1127078	1962-03-29	1962-03-29 00:00:00	1962-04-19	1962-04-19 00:00:00	1962-04-19	38000177		0	0	21		0	0	0	159236	0	282464	1127078		
54076	4492	19059056	1975-01-25	1975-01-25 00:00:00	1975-04-25	1975-04-25 00:00:00	1975-04-25	38000177		0	0	90		0	0	0	299091	0	243670	19059056		
3696	307	19078461	1981-08-17	1981-08-17 00:00:00	1981-09-14	1981-09-14 00:00:00	1981-09-14	38000177		0	0	28		0	0	0	20379	0	310965	19078461		
48684	4032	1127433	1960-02-23	1960-02-23 00:00:00	1960-03-24	1960-03-24 00:00:00	1960-03-24	38000177		0	0	30		0	0	0	268266	0	313782	1127433		
94268	2069	40213160	1956-07-02	1956-07-02 00:00:00	1956-07-02	1956-07-02 00:00:00	1956-07-02	581452		0	0	0		0	0	0	137635	0	10	40213160		
7567	636	1124300	1982-11-19	1982-11-19 00:00:00	1982-11-19	1982-11-19 00:00:00	\N	38000177		0	0	0		0	0	0	42160	0	00781178901	45011828		
144831	3183	40213251	1986-01-19	1986-01-19 00:00:00	1986-01-19	1986-01-19 00:00:00	1986-01-19	581452		0	0	0		0	0	0	211914	0	21	40213251		
59319	4929	1127433	1991-09-11	1991-09-11 00:00:00	1991-09-18	1991-09-18 00:00:00	1991-09-18	38000177		0	0	7		0	0	0	327689	0	313782	1127433		
15411	1285	19018935	2014-05-19	2014-05-19 00:00:00	2014-05-19	2014-05-19 00:00:00	\N	38000177		0	0	0		0	0	0	84966	0	197604	19018935		
63068	5240	40236824	1988-08-26	1988-08-26 00:00:00	1988-09-02	1988-09-02 00:00:00	1988-09-02	38000177		0	0	7		0	0	0	348653	0	1094107	40236824		
162378	3571	40213296	2014-05-06	2014-05-06 00:00:00	2014-05-06	2014-05-06 00:00:00	2014-05-06	581452		0	0	0		0	0	0	237356	0	52	40213296		
13514	1132	40236824	1984-06-09	1984-06-09 00:00:00	1984-06-16	1984-06-16 00:00:00	1984-06-16	38000177		0	0	7		0	0	0	74493	0	1094107	40236824		
39779	3290	1115171	1997-12-06	1997-12-06 00:00:00	1997-12-20	1997-12-20 00:00:00	1997-12-20	38000177		0	0	14		0	0	0	218619	0	849574	1115171		
148204	3258	40213251	1984-05-09	1984-05-09 00:00:00	1984-05-09	1984-05-09 00:00:00	1984-05-09	581452		0	0	0		0	0	0	216631	0	21	40213251		
31504	2613	19059056	1960-04-16	1960-04-16 00:00:00	1960-04-30	1960-04-30 00:00:00	1960-04-30	38000177		0	0	14		0	0	0	172776	0	243670	19059056		
206385	4529	40213227	2005-11-27	2005-11-27 00:00:00	2005-11-27	2005-11-27 00:00:00	2005-11-27	581452		0	0	0		0	0	0	301580	0	113	40213227		
28602	2357	19059056	1960-12-10	1960-12-10 00:00:00	1960-12-31	1960-12-31 00:00:00	1960-12-31	38000177		0	0	21		0	0	0	157004	0	243670	19059056		
34701	2865	1127078	1971-02-26	1971-02-26 00:00:00	1971-03-12	1971-03-12 00:00:00	1971-03-12	38000177		0	0	14		0	0	0	190580	0	282464	1127078		
48326	1057	40213160	1961-12-28	1961-12-28 00:00:00	1961-12-28	1961-12-28 00:00:00	1961-12-28	581452		0	0	0		0	0	0	69325	0	10	40213160		
46296	3835	1127433	2001-02-14	2001-02-14 00:00:00	2001-03-21	2001-03-21 00:00:00	2001-03-21	38000177		0	0	35		0	0	0	254663	0	313782	1127433		
39219	3240	19133905	1970-12-16	1970-12-16 00:00:00	1970-12-25	1970-12-25 00:00:00	1970-12-25	38000177		0	0	9		0	0	0	215352	0	834102	19133905		
56850	4719	19133905	1957-09-04	1957-09-04 00:00:00	1957-09-15	1957-09-15 00:00:00	1957-09-15	38000177		0	0	11		0	0	0	314188	0	834102	19133905		
39328	3248	19079524	2016-06-26	2016-06-26 00:00:00	2016-06-26	2016-06-26 00:00:00	2016-06-26	38000177		0	0	0		0	0	0	215881	0	313002	19079524		
28016	2319	1127433	1995-06-21	1995-06-21 00:00:00	1995-06-28	1995-06-28 00:00:00	1995-06-28	38000177		0	0	7		0	0	0	154210	0	313782	1127433		
232947	5119	40213306	1985-04-09	1985-04-09 00:00:00	1985-04-09	1985-04-09 00:00:00	1985-04-09	581452		0	0	0		0	0	0	340407	0	43	40213306		
194213	4268	40213160	1955-12-19	1955-12-19 00:00:00	1955-12-19	1955-12-19 00:00:00	1955-12-19	581452		0	0	0		0	0	0	283280	0	10	40213160		
126917	2792	40213227	1992-03-09	1992-03-09 00:00:00	1992-03-09	1992-03-09 00:00:00	1992-03-09	581452		0	0	0		0	0	0	185035	0	113	40213227		
44627	3695	1310034	2007-02-12	2007-02-12 00:00:00	2007-02-12	2007-02-12 00:00:00	2007-02-12	38000177		0	0	0		0	0	0	245606	0	834357	1310034		
114771	2521	40213198	2013-09-23	2013-09-23 00:00:00	2013-09-23	2013-09-23 00:00:00	2013-09-23	581452		0	0	0		0	0	0	166773	0	133	40213198		
57998	4819	19133873	1960-09-18	1960-09-18 00:00:00	1960-09-25	1960-09-25 00:00:00	1960-09-25	38000177		0	0	7		0	0	0	320509	0	834061	19133873		
62710	5213	1118084	1977-11-23	1977-11-23 00:00:00	1977-11-23	1977-11-23 00:00:00	\N	38000177		0	0	0		0	0	0	346759	0	00025152531	44923712		
55961	1226	40213160	1985-03-17	1985-03-17 00:00:00	1985-03-17	1985-03-17 00:00:00	1985-03-17	581452		0	0	0		0	0	0	80670	0	10	40213160		
192389	4226	40213260	2013-01-20	2013-01-20 00:00:00	2013-01-20	2013-01-20 00:00:00	2013-01-20	581452		0	0	0		0	0	0	280683	0	121	40213260		
59867	4976	19059056	1937-10-02	1937-10-02 00:00:00	1937-10-16	1937-10-16 00:00:00	1937-10-16	38000177		0	0	14		0	0	0	331060	0	243670	19059056		
71743	1568	40213227	2013-11-03	2013-11-03 00:00:00	2013-11-03	2013-11-03 00:00:00	2013-11-03	581452		0	0	0		0	0	0	105162	0	113	40213227		
68553	1500	40213306	1984-04-16	1984-04-16 00:00:00	1984-04-16	1984-04-16 00:00:00	1984-04-16	581452		0	0	0		0	0	0	100094	0	43	40213306		
31603	2620	1127433	1989-01-31	1989-01-31 00:00:00	1989-02-14	1989-02-14 00:00:00	1989-02-14	38000177		0	0	14		0	0	0	173253	0	313782	1127433		
31659	2624	1118084	2006-06-18	2006-06-18 00:00:00	2006-06-18	2006-06-18 00:00:00	\N	38000177		0	0	0		0	0	0	173603	0	00025152531	44923712		
38228	3161	1127078	1953-03-14	1953-03-14 00:00:00	1953-03-28	1953-03-28 00:00:00	1953-03-28	38000177		0	0	14		0	0	0	210241	0	282464	1127078		
19127	1578	1713671	1983-05-08	1983-05-08 00:00:00	1983-05-15	1983-05-15 00:00:00	1983-05-15	38000177		0	0	7		0	0	0	105990	0	562251	1713671		
42252	3505	19133905	2000-02-08	2000-02-08 00:00:00	2000-02-18	2000-02-18 00:00:00	2000-02-18	38000177		0	0	10		0	0	0	232482	0	834102	19133905		
22551	1852	19073188	2018-10-29	2018-10-29 00:00:00	2018-11-12	2018-11-12 00:00:00	2018-11-12	38000177		0	0	14		0	0	0	123921	0	308192	19073188		
209476	4593	40213306	1987-06-25	1987-06-25 00:00:00	1987-06-25	1987-06-25 00:00:00	1987-06-25	581452		0	0	0		0	0	0	306047	0	43	40213306		
52865	4392	1127433	2003-11-27	2003-11-27 00:00:00	2003-12-11	2003-12-11 00:00:00	2003-12-11	38000177		0	0	14		0	0	0	292050	0	313782	1127433		
217992	4784	40213227	1993-01-16	1993-01-16 00:00:00	1993-01-16	1993-01-16 00:00:00	1993-01-16	581452		0	0	0		0	0	0	318448	0	113	40213227		
5018	418	1115171	2004-06-26	2004-06-26 00:00:00	2004-08-25	2004-08-25 00:00:00	2004-08-25	38000177		0	0	60		0	0	0	27666	0	849574	1115171		
228622	5022	40213306	1990-09-17	1990-09-17 00:00:00	1990-09-17	1990-09-17 00:00:00	1990-09-17	581452		0	0	0		0	0	0	333640	0	43	40213306		
21165	1744	1118084	2010-08-06	2010-08-06 00:00:00	2010-08-06	2010-08-06 00:00:00	\N	38000177		0	0	0		0	0	0	116616	0	00025152531	44923712		
150364	3307	40213306	1988-10-21	1988-10-21 00:00:00	1988-10-21	1988-10-21 00:00:00	1988-10-21	581452		0	0	0		0	0	0	219610	0	43	40213306		
3999	86	40213227	2009-04-07	2009-04-07 00:00:00	2009-04-07	2009-04-07 00:00:00	2009-04-07	581452		0	0	0		0	0	0	5763	0	113	40213227		
54369	4521	19126352	1970-04-16	1970-04-16 00:00:00	1970-04-16	1970-04-16 00:00:00	\N	38000177		0	0	0		0	0	0	301078	0	705129	19126352		
106834	2342	40213160	1979-09-21	1979-09-21 00:00:00	1979-09-21	1979-09-21 00:00:00	1979-09-21	581452		0	0	0		0	0	0	155906	0	10	40213160		
177103	3892	40213160	1962-12-08	1962-12-08 00:00:00	1962-12-08	1962-12-08 00:00:00	1962-12-08	581452		0	0	0		0	0	0	258808	0	10	40213160		
118207	2599	40213251	1984-10-13	1984-10-13 00:00:00	1984-10-13	1984-10-13 00:00:00	1984-10-13	581452		0	0	0		0	0	0	171980	0	21	40213251		
55354	4596	1127433	2017-01-01	2017-01-01 00:00:00	2017-01-08	2017-01-08 00:00:00	2017-01-08	38000177		0	0	7		0	0	0	306305	0	313782	1127433		
55420	4602	40236446	1987-05-07	1987-05-07 00:00:00	1989-03-02	1989-03-02 00:00:00	1989-03-02	38000177		0	0	665		0	0	0	306549	0	1091392	40236446		
207234	4547	40213227	1999-12-19	1999-12-19 00:00:00	1999-12-19	1999-12-19 00:00:00	1999-12-19	581452		0	0	0		0	0	0	302896	0	113	40213227		
512	36	19134077	2015-07-08	2015-07-08 00:00:00	2015-07-29	2015-07-29 00:00:00	2015-07-29	38000177		0	0	21		0	0	0	2572	0	835900	19134077		
571	42	1127433	1937-09-07	1937-09-07 00:00:00	1937-09-14	1937-09-14 00:00:00	1937-09-14	38000177		0	0	7		0	0	0	3062	0	313782	1127433		
55679	4623	40229134	1986-08-26	1986-08-26 00:00:00	1986-09-09	1986-09-09 00:00:00	1986-09-09	38000177		0	0	14		0	0	0	307931	0	1043400	40229134		
70084	1532	40213227	2019-05-22	2019-05-22 00:00:00	2019-05-22	2019-05-22 00:00:00	2019-05-22	581452		0	0	0		0	0	0	102605	0	113	40213227		
89256	1956	40213260	2013-06-25	2013-06-25 00:00:00	2013-06-25	2013-06-25 00:00:00	2013-06-25	581452		0	0	0		0	0	0	130213	0	121	40213260		
114925	2525	40213296	2015-01-16	2015-01-16 00:00:00	2015-01-16	2015-01-16 00:00:00	2015-01-16	581452		0	0	0		0	0	0	166989	0	52	40213296		
48603	4026	40229134	1981-07-30	1981-07-30 00:00:00	1981-08-06	1981-08-06 00:00:00	1981-08-06	38000177		0	0	7		0	0	0	267734	0	1043400	40229134		
28967	2395	19059056	1973-01-21	1973-01-21 00:00:00	1973-04-21	1973-04-21 00:00:00	1973-04-21	38000177		0	0	90		0	0	0	159238	0	243670	19059056		
54077	4492	1713671	2005-09-29	2005-09-29 00:00:00	2005-10-20	2005-10-20 00:00:00	2005-10-20	38000177		0	0	21		0	0	0	299052	0	562251	1713671		
3697	307	1118084	2009-09-29	2009-09-29 00:00:00	2009-09-29	2009-09-29 00:00:00	\N	38000177		0	0	0		0	0	0	20364	0	00025152531	44923712		
48685	4032	40165015	1960-02-23	1960-02-23 00:00:00	1960-02-23	1960-02-23 00:00:00	\N	38000177		0	0	0		0	0	0	268266	0	861467	40165015		
94271	2069	40213201	2018-05-21	2018-05-21 00:00:00	2018-05-21	2018-05-21 00:00:00	2018-05-21	581452		0	0	0		0	0	0	137620	0	33	40213201		
7579	639	1713671	1979-10-06	1979-10-06 00:00:00	1979-10-27	1979-10-27 00:00:00	1979-10-27	38000177		0	0	21		0	0	0	42301	0	562251	1713671		
144838	3183	40213160	1981-10-18	1981-10-18 00:00:00	1981-10-18	1981-10-18 00:00:00	1981-10-18	581452		0	0	0		0	0	0	211944	0	10	40213160		
59320	4929	1124300	2002-07-24	2002-07-24 00:00:00	2002-07-24	2002-07-24 00:00:00	\N	38000177		0	0	0		0	0	0	327698	0	00781178901	45011828		
15412	1285	40163554	2014-05-19	2014-05-19 00:00:00	2014-05-19	2014-05-19 00:00:00	\N	38000177		0	0	0		0	0	0	84966	0	855332	40163554		
63069	5240	920300	1988-08-26	1988-08-26 00:00:00	1988-09-02	1988-09-02 00:00:00	1988-09-02	38000177		0	0	7		0	0	0	348653	0	311989	920300		
29214	2418	19019979	1976-04-21	1976-04-21 00:00:00	1976-05-26	1976-05-26 00:00:00	1976-05-26	38000177		0	0	35		0	0	0	160438	0	198405	19019979		
13515	1132	920300	1984-06-09	1984-06-09 00:00:00	1984-06-16	1984-06-16 00:00:00	1984-06-16	38000177		0	0	7		0	0	0	74493	0	311989	920300		
39780	3290	19133905	1998-06-26	1998-06-26 00:00:00	1998-07-04	1998-07-04 00:00:00	1998-07-04	38000177		0	0	8		0	0	0	218611	0	834102	19133905		
148206	3258	40213160	1982-02-10	1982-02-10 00:00:00	1982-02-10	1982-02-10 00:00:00	1982-02-10	581452		0	0	0		0	0	0	216570	0	10	40213160		
31505	2613	19006318	1960-04-16	1960-04-16 00:00:00	1960-04-30	1960-04-30 00:00:00	1960-04-30	38000177		0	0	14		0	0	0	172776	0	105078	19006318		
206386	4529	40213296	2005-11-27	2005-11-27 00:00:00	2005-11-27	2005-11-27 00:00:00	2005-11-27	581452		0	0	0		0	0	0	301580	0	52	40213296		
28603	2357	1118084	1973-12-26	1973-12-26 00:00:00	1973-12-26	1973-12-26 00:00:00	\N	38000177		0	0	0		0	0	0	157077	0	00025152531	44923712		
34702	2865	46233988	1971-02-26	1971-02-26 00:00:00	1971-03-12	1971-03-12 00:00:00	1971-03-12	38000177		0	0	14		0	0	0	190580	0	1652673	46233988		
48330	1057	40213227	2003-07-31	2003-07-31 00:00:00	2003-07-31	2003-07-31 00:00:00	2003-07-31	581452		0	0	0		0	0	0	69306	0	113	40213227		
46297	3835	1127433	1986-09-17	1986-09-17 00:00:00	1986-10-01	1986-10-01 00:00:00	1986-10-01	38000177		0	0	14		0	0	0	254662	0	313782	1127433		
39220	3240	19006318	1951-01-18	1951-01-18 00:00:00	1951-02-01	1951-02-01 00:00:00	1951-02-01	38000177		0	0	14		0	0	0	215351	0	105078	19006318		
56851	4719	19059056	1935-04-01	1935-04-01 00:00:00	1935-04-15	1935-04-15 00:00:00	1935-04-15	38000177		0	0	14		0	0	0	314201	0	243670	19059056		
39329	3248	42707627	2016-06-26	2016-06-26 00:00:00	2016-06-26	2016-06-26 00:00:00	2016-06-26	38000177		0	0	0		0	0	0	215881	0	1234995	42707627		
28017	2319	1127433	1971-06-11	1971-06-11 00:00:00	1971-06-18	1971-06-18 00:00:00	1971-06-18	38000177		0	0	7		0	0	0	154157	0	313782	1127433		
232958	5119	40213227	2013-05-14	2013-05-14 00:00:00	2013-05-14	2013-05-14 00:00:00	2013-05-14	581452		0	0	0		0	0	0	340409	0	113	40213227		
194215	4268	40213160	1960-08-22	1960-08-22 00:00:00	1960-08-22	1960-08-22 00:00:00	1960-08-22	581452		0	0	0		0	0	0	283222	0	10	40213160		
126920	2792	40213160	1958-03-17	1958-03-17 00:00:00	1958-03-17	1958-03-17 00:00:00	1958-03-17	581452		0	0	0		0	0	0	185061	0	10	40213160		
44628	3695	40229134	1987-03-31	1987-03-31 00:00:00	1987-04-14	1987-04-14 00:00:00	1987-04-14	38000177		0	0	14		0	0	0	245664	0	1043400	40229134		
114777	2521	40213227	1999-01-25	1999-01-25 00:00:00	1999-01-25	1999-01-25 00:00:00	1999-01-25	581452		0	0	0		0	0	0	166780	0	113	40213227		
57999	4819	1713671	1984-04-23	1984-04-23 00:00:00	1984-04-30	1984-04-30 00:00:00	1984-04-30	38000177		0	0	7		0	0	0	320586	0	562251	1713671		
62711	5213	1713671	1952-07-08	1952-07-08 00:00:00	1952-07-22	1952-07-22 00:00:00	1952-07-22	38000177		0	0	14		0	0	0	346738	0	562251	1713671		
55964	1226	40213314	1981-06-14	1981-06-14 00:00:00	1981-06-14	1981-06-14 00:00:00	1981-06-14	581452		0	0	0		0	0	0	80668	0	49	40213314		
192390	4226	40213160	1963-02-24	1963-02-24 00:00:00	1963-02-24	1963-02-24 00:00:00	1963-02-24	581452		0	0	0		0	0	0	280742	0	10	40213160		
59868	4976	40174880	1983-10-26	1983-10-26 00:00:00	1983-10-26	1983-10-26 00:00:00	\N	38000177		0	0	0		0	0	0	330937	0	966222	40174880		
71748	1569	40213227	2018-07-20	2018-07-20 00:00:00	2018-07-20	2018-07-20 00:00:00	2018-07-20	581452		0	0	0		0	0	0	105339	0	113	40213227		
79837	1746	40213160	1956-04-19	1956-04-19 00:00:00	1956-04-19	1956-04-19 00:00:00	1956-04-19	581452		0	0	0		0	0	0	116793	0	10	40213160		
31604	2620	1127078	1973-03-24	1973-03-24 00:00:00	1973-05-23	1973-05-23 00:00:00	1973-05-23	38000177		0	0	60		0	0	0	173270	0	282464	1127078		
31660	2624	1713671	1993-01-28	1993-01-28 00:00:00	1993-02-18	1993-02-18 00:00:00	1993-02-18	38000177		0	0	21		0	0	0	173577	0	562251	1713671		
38229	3161	19059056	1963-08-23	1963-08-23 00:00:00	1963-09-13	1963-09-13 00:00:00	1963-09-13	38000177		0	0	21		0	0	0	210249	0	243670	19059056		
19128	1578	1713671	1962-08-03	1962-08-03 00:00:00	1962-08-24	1962-08-24 00:00:00	1962-08-24	38000177		0	0	21		0	0	0	106024	0	562251	1713671		
42253	3505	1127433	1970-02-10	1970-02-10 00:00:00	1970-02-24	1970-02-24 00:00:00	1970-02-24	38000177		0	0	14		0	0	0	232439	0	313782	1127433		
22552	1852	1115171	2018-10-29	2018-10-29 00:00:00	2018-11-12	2018-11-12 00:00:00	2018-11-12	38000177		0	0	14		0	0	0	123921	0	849574	1115171		
209480	4593	40213306	1984-06-21	1984-06-21 00:00:00	1984-06-21	1984-06-21 00:00:00	1984-06-21	581452		0	0	0		0	0	0	306046	0	43	40213306		
52866	4392	1115171	2016-10-20	2016-10-20 00:00:00	2016-11-19	2016-11-19 00:00:00	2016-11-19	38000177		0	0	30		0	0	0	292048	0	849574	1115171		
218009	4784	40213201	2015-08-22	2015-08-22 00:00:00	2015-08-22	2015-08-22 00:00:00	2015-08-22	581452		0	0	0		0	0	0	318462	0	33	40213201		
5019	418	1127433	1999-09-07	1999-09-07 00:00:00	1999-09-21	1999-09-21 00:00:00	1999-09-21	38000177		0	0	14		0	0	0	27665	0	313782	1127433		
228628	5022	40213260	2018-01-01	2018-01-01 00:00:00	2018-01-01	2018-01-01 00:00:00	2018-01-01	581452		0	0	0		0	0	0	333711	0	121	40213260		
21166	1744	1127078	1981-09-27	1981-09-27 00:00:00	1981-10-27	1981-10-27 00:00:00	1981-10-27	38000177		0	0	30		0	0	0	116626	0	282464	1127078		
150374	3308	40213160	1955-02-07	1955-02-07 00:00:00	1955-02-07	1955-02-07 00:00:00	1955-02-07	581452		0	0	0		0	0	0	219670	0	10	40213160		
63573	5283	19019979	1978-04-07	1978-04-07 00:00:00	1978-04-21	1978-04-21 00:00:00	1978-04-21	38000177		0	0	14		0	0	0	351416	0	198405	19019979		
54370	4521	40223774	2001-10-01	2001-10-01 00:00:00	2001-10-01	2001-10-01 00:00:00	\N	38000177		0	0	0		0	0	0	301047	0	998582	40223774		
106835	2342	40213296	2017-01-27	2017-01-27 00:00:00	2017-01-27	2017-01-27 00:00:00	2017-01-27	581452		0	0	0		0	0	0	155909	0	52	40213296		
177104	3892	40213160	1962-10-06	1962-10-06 00:00:00	1962-10-06	1962-10-06 00:00:00	1962-10-06	581452		0	0	0		0	0	0	258793	0	10	40213160		
230543	5066	40213160	1967-12-16	1967-12-16 00:00:00	1967-12-16	1967-12-16 00:00:00	1967-12-16	581452		0	0	0		0	0	0	336759	0	10	40213160		
55355	4596	1118084	1979-01-27	1979-01-27 00:00:00	1979-01-27	1979-01-27 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00025152531	44923712		
17994	390	40213306	1998-02-04	1998-02-04 00:00:00	1998-02-04	1998-02-04 00:00:00	1998-02-04	581452		0	0	0		0	0	0	25640	0	43	40213306		
207250	4547	40213227	1992-11-08	1992-11-08 00:00:00	1992-11-08	1992-11-08 00:00:00	1992-11-08	581452		0	0	0		0	0	0	302873	0	113	40213227		
519	38	920300	2004-02-24	2004-02-24 00:00:00	2004-03-02	2004-03-02 00:00:00	2004-03-02	38000177		0	0	7		0	0	0	2727	0	311989	920300		
572	42	1127433	1980-06-21	1980-06-21 00:00:00	1980-06-28	1980-06-28 00:00:00	1980-06-28	38000177		0	0	7		0	0	0	2996	0	313782	1127433		
55686	4625	1127433	1981-11-13	1981-11-13 00:00:00	1981-12-04	1981-12-04 00:00:00	1981-12-04	38000177		0	0	21		0	0	0	308131	0	313782	1127433		
70085	1532	40213296	2019-05-22	2019-05-22 00:00:00	2019-05-22	2019-05-22 00:00:00	2019-05-22	581452		0	0	0		0	0	0	102605	0	52	40213296		
89264	1956	40213227	2006-05-16	2006-05-16 00:00:00	2006-05-16	2006-05-16 00:00:00	2006-05-16	581452		0	0	0		0	0	0	130211	0	113	40213227		
114927	2525	40213227	2005-05-27	2005-05-27 00:00:00	2005-05-27	2005-05-27 00:00:00	2005-05-27	581452		0	0	0		0	0	0	166963	0	113	40213227		
48604	4026	1713671	2008-01-19	2008-01-19 00:00:00	2008-02-02	2008-02-02 00:00:00	2008-02-02	38000177		0	0	14		0	0	0	267715	0	562251	1713671		
28968	2395	1127433	1990-06-01	1990-06-01 00:00:00	1990-06-15	1990-06-15 00:00:00	1990-06-15	38000177		0	0	14		0	0	0	159221	0	313782	1127433		
54078	4492	1127433	1959-06-09	1959-06-09 00:00:00	1959-06-23	1959-06-23 00:00:00	1959-06-23	38000177		0	0	14		0	0	0	299083	0	313782	1127433		
3698	307	19133873	1981-02-02	1981-02-02 00:00:00	1981-02-12	1981-02-12 00:00:00	1981-02-12	38000177		0	0	10		0	0	0	20333	0	834061	19133873		
48686	4033	40236446	1978-10-12	1978-10-12 00:00:00	1981-12-09	1981-12-09 00:00:00	1981-12-09	38000177		0	0	1154		0	0	0	268297	0	1091392	40236446		
237273	5210	40213296	2011-12-13	2011-12-13 00:00:00	2011-12-13	2011-12-13 00:00:00	2011-12-13	581452		0	0	0		0	0	0	346486	0	52	40213296		
7580	639	19006318	1954-03-29	1954-03-29 00:00:00	1954-04-12	1954-04-12 00:00:00	1954-04-12	38000177		0	0	14		0	0	0	42306	0	105078	19006318		
144841	3183	40213314	1981-05-17	1981-05-17 00:00:00	1981-05-17	1981-05-17 00:00:00	1981-05-17	581452		0	0	0		0	0	0	211901	0	49	40213314		
59321	4929	19133905	1994-01-12	1994-01-12 00:00:00	1994-01-19	1994-01-19 00:00:00	1994-01-19	38000177		0	0	7		0	0	0	327719	0	834102	19133905		
15413	1285	1127433	1996-04-27	1996-04-27 00:00:00	1996-06-26	1996-06-26 00:00:00	1996-06-26	38000177		0	0	60		0	0	0	84928	0	313782	1127433		
63070	5240	19059056	1969-06-19	1969-06-19 00:00:00	1969-07-17	1969-07-17 00:00:00	1969-07-17	38000177		0	0	28		0	0	0	348607	0	243670	19059056		
29215	2418	19019979	1975-12-23	1975-12-23 00:00:00	1976-01-06	1976-01-06 00:00:00	1976-01-06	38000177		0	0	14		0	0	0	160431	0	198405	19019979		
13516	1132	19074841	1983-03-04	1983-03-04 00:00:00	1983-03-18	1983-03-18 00:00:00	1983-03-18	38000177		0	0	14		0	0	0	74497	0	309043	19074841		
39781	3290	1127433	1990-01-10	1990-01-10 00:00:00	1990-01-24	1990-01-24 00:00:00	1990-01-24	38000177		0	0	14		0	0	0	218596	0	313782	1127433		
148210	3258	40213227	2012-08-29	2012-08-29 00:00:00	2012-08-29	2012-08-29 00:00:00	2012-08-29	581452		0	0	0		0	0	0	216599	0	113	40213227		
31506	2613	19059056	1958-11-23	1958-11-23 00:00:00	1958-12-07	1958-12-07 00:00:00	1958-12-07	38000177		0	0	14		0	0	0	172816	0	243670	19059056		
217672	4777	40213227	2009-05-19	2009-05-19 00:00:00	2009-05-19	2009-05-19 00:00:00	2009-05-19	581452		0	0	0		0	0	0	318130	0	113	40213227		
28604	2357	19133905	1981-01-24	1981-01-24 00:00:00	1981-02-03	1981-02-03 00:00:00	1981-02-03	38000177		0	0	10		0	0	0	157019	0	834102	19133905		
34703	2865	1127078	1974-01-20	1974-01-20 00:00:00	1974-02-03	1974-02-03 00:00:00	1974-02-03	38000177		0	0	14		0	0	0	190627	0	282464	1127078		
59612	1305	40213296	2004-07-15	2004-07-15 00:00:00	2004-07-15	2004-07-15 00:00:00	2004-07-15	581452		0	0	0		0	0	0	86154	0	52	40213296		
46298	3835	1118084	2004-08-29	2004-08-29 00:00:00	2004-08-29	2004-08-29 00:00:00	\N	38000177		0	0	0		0	0	0	254649	0	00025152531	44923712		
39221	3240	1127078	1951-01-18	1951-01-18 00:00:00	1951-02-01	1951-02-01 00:00:00	1951-02-01	38000177		0	0	14		0	0	0	215351	0	282464	1127078		
56852	4719	1127433	1969-06-06	1969-06-06 00:00:00	1969-06-20	1969-06-20 00:00:00	1969-06-20	38000177		0	0	14		0	0	0	314229	0	313782	1127433		
39330	3248	35605858	2016-06-26	2016-06-26 00:00:00	2016-06-26	2016-06-26 00:00:00	2016-06-26	38000177		0	0	0		0	0	0	215881	0	1732136	35605858		
28018	2319	1551192	1947-08-14	1947-08-14 00:00:00	1947-08-14	1947-08-14 00:00:00	1947-08-14	38000177		0	0	0		0	0	0	154131	0	312617	1551192		
232959	5119	40213260	2013-05-14	2013-05-14 00:00:00	2013-05-14	2013-05-14 00:00:00	2013-05-14	581452		0	0	0		0	0	0	340409	0	121	40213260		
205495	4509	40213227	2009-09-08	2009-09-08 00:00:00	2009-09-08	2009-09-08 00:00:00	2009-09-08	581452		0	0	0		0	0	0	300361	0	113	40213227		
126923	2792	40213260	2007-10-08	2007-10-08 00:00:00	2007-10-08	2007-10-08 00:00:00	2007-10-08	581452		0	0	0		0	0	0	185013	0	121	40213260		
44629	3695	42902245	1999-01-05	1999-01-05 00:00:00	1999-12-31	1999-12-31 00:00:00	1999-12-31	38000177		0	0	360		0	0	0	245676	0	1359133	42902245		
114782	2521	40213201	2014-09-29	2014-09-29 00:00:00	2014-09-29	2014-09-29 00:00:00	2014-09-29	581452		0	0	0		0	0	0	166728	0	33	40213201		
58000	4819	1124300	2003-03-30	2003-03-30 00:00:00	2003-03-30	2003-03-30 00:00:00	\N	38000177		0	0	0		0	0	0	320573	0	00781178901	45011828		
62712	5213	1127433	2003-11-11	2003-11-11 00:00:00	2003-11-18	2003-11-18 00:00:00	2003-11-18	38000177		0	0	7		0	0	0	346741	0	313782	1127433		
55976	1226	40213306	2002-10-20	2002-10-20 00:00:00	2002-10-20	2002-10-20 00:00:00	2002-10-20	581452		0	0	0		0	0	0	80704	0	43	40213306		
41380	902	40213227	1992-09-05	1992-09-05 00:00:00	1992-09-05	1992-09-05 00:00:00	1992-09-05	581452		0	0	0		0	0	0	60062	0	113	40213227		
59869	4976	40236824	1941-12-19	1941-12-19 00:00:00	1941-12-26	1941-12-26 00:00:00	1941-12-26	38000177		0	0	7		0	0	0	330967	0	1094107	40236824		
90504	1986	40213160	1984-10-30	1984-10-30 00:00:00	1984-10-30	1984-10-30 00:00:00	1984-10-30	581452		0	0	0		0	0	0	132219	0	10	40213160		
43770	954	40213306	1996-06-16	1996-06-16 00:00:00	1996-06-16	1996-06-16 00:00:00	1996-06-16	581452		0	0	0		0	0	0	63367	0	43	40213306		
31605	2620	1115171	2001-06-21	2001-06-21 00:00:00	2001-07-26	2001-07-26 00:00:00	2001-07-26	38000177		0	0	35		0	0	0	173255	0	849574	1115171		
31661	2624	1127433	2015-09-15	2015-09-15 00:00:00	2015-10-13	2015-10-13 00:00:00	2015-10-13	38000177		0	0	28		0	0	0	173624	0	313782	1127433		
38230	3161	1127433	1978-05-26	1978-05-26 00:00:00	1978-06-09	1978-06-09 00:00:00	1978-06-09	38000177		0	0	14		0	0	0	210251	0	313782	1127433		
19129	1578	40236824	1977-04-26	1977-04-26 00:00:00	1977-05-03	1977-05-03 00:00:00	1977-05-03	38000177		0	0	7		0	0	0	106025	0	1094107	40236824		
42254	3505	1124300	1975-11-13	1975-11-13 00:00:00	1975-11-13	1975-11-13 00:00:00	\N	38000177		0	0	0		0	0	0	232398	0	00781178901	45011828		
22553	1852	19019979	1977-04-26	1977-04-26 00:00:00	1977-05-10	1977-05-10 00:00:00	1977-05-10	38000177		0	0	14		0	0	0	123919	0	198405	19019979		
227675	4999	40213296	1997-08-24	1997-08-24 00:00:00	1997-08-24	1997-08-24 00:00:00	1997-08-24	581452		0	0	0		0	0	0	332504	0	52	40213296		
52867	4392	19019979	1991-01-02	1991-01-02 00:00:00	1991-01-30	1991-01-30 00:00:00	1991-01-30	38000177		0	0	28		0	0	0	292083	0	198405	19019979		
32643	2705	19078461	1998-03-08	1998-03-08 00:00:00	1998-03-22	1998-03-22 00:00:00	1998-03-22	38000177		0	0	14		0	0	0	179196	0	310965	19078461		
5020	418	19059056	1971-08-23	1971-08-23 00:00:00	1971-09-13	1971-09-13 00:00:00	1971-09-13	38000177		0	0	21		0	0	0	27672	0	243670	19059056		
228633	5022	40213160	1972-12-11	1972-12-11 00:00:00	1972-12-11	1972-12-11 00:00:00	1972-12-11	581452		0	0	0		0	0	0	333671	0	10	40213160		
21167	1744	1127433	1993-02-15	1993-02-15 00:00:00	1993-03-01	1993-03-01 00:00:00	1993-03-01	38000177		0	0	14		0	0	0	116618	0	313782	1127433		
158704	3494	40213306	1981-04-09	1981-04-09 00:00:00	1981-04-09	1981-04-09 00:00:00	1981-04-09	581452		0	0	0		0	0	0	231759	0	43	40213306		
63574	5283	40229134	1989-06-28	1989-06-28 00:00:00	1989-07-12	1989-07-12 00:00:00	1989-07-12	38000177		0	0	14		0	0	0	351425	0	1043400	40229134		
54371	4521	1713671	1922-01-19	1922-01-19 00:00:00	1922-02-09	1922-02-09 00:00:00	1922-02-09	38000177		0	0	21		0	0	0	301042	0	562251	1713671		
106837	2342	40213227	2017-01-27	2017-01-27 00:00:00	2017-01-27	2017-01-27 00:00:00	2017-01-27	581452		0	0	0		0	0	0	155909	0	113	40213227		
177108	3892	40213306	1984-09-08	1984-09-08 00:00:00	1984-09-08	1984-09-08 00:00:00	1984-09-08	581452		0	0	0		0	0	0	258807	0	43	40213306		
230545	5066	40213227	1998-06-20	1998-06-20 00:00:00	1998-06-20	1998-06-20 00:00:00	1998-06-20	581452		0	0	0		0	0	0	336781	0	113	40213227		
55356	4596	1713671	1957-11-11	1957-11-11 00:00:00	1957-12-02	1957-12-02 00:00:00	1957-12-02	38000177		0	0	21		0	0	0	306261	0	562251	1713671		
17996	390	40213227	1998-02-04	1998-02-04 00:00:00	1998-02-04	1998-02-04 00:00:00	1998-02-04	581452		0	0	0		0	0	0	25640	0	113	40213227		
18076	392	40213227	1998-02-13	1998-02-13 00:00:00	1998-02-13	1998-02-13 00:00:00	1998-02-13	581452		0	0	0		0	0	0	25733	0	113	40213227		
520	38	40236824	2004-02-24	2004-02-24 00:00:00	2004-03-02	2004-03-02 00:00:00	2004-03-02	38000177		0	0	7		0	0	0	2727	0	1094107	40236824		
573	42	1127433	2006-03-04	2006-03-04 00:00:00	2006-03-11	2006-03-11 00:00:00	2006-03-11	38000177		0	0	7		0	0	0	3136	0	313782	1127433		
55687	4625	1115171	2000-01-20	2000-01-20 00:00:00	2000-02-17	2000-02-17 00:00:00	2000-02-17	38000177		0	0	28		0	0	0	308089	0	849574	1115171		
11804	254	40213160	1955-07-22	1955-07-22 00:00:00	1955-07-22	1955-07-22 00:00:00	1955-07-22	581452		0	0	0		0	0	0	16942	0	10	40213160		
89265	1956	40213296	2006-05-16	2006-05-16 00:00:00	2006-05-16	2006-05-16 00:00:00	2006-05-16	581452		0	0	0		0	0	0	130211	0	52	40213296		
114929	2525	40213227	2015-01-16	2015-01-16 00:00:00	2015-01-16	2015-01-16 00:00:00	2015-01-16	581452		0	0	0		0	0	0	166989	0	113	40213227		
48605	4026	1150771	1977-02-07	1977-02-07 00:00:00	1977-02-07	1977-02-07 00:00:00	\N	38000177		0	0	0		0	0	0	267662	0	197378	1150771		
28969	2395	19059056	1964-06-07	1964-06-07 00:00:00	1964-06-21	1964-06-21 00:00:00	1964-06-21	38000177		0	0	14		0	0	0	159224	0	243670	19059056		
54079	4493	40229134	1995-06-05	1995-06-05 00:00:00	1995-06-12	1995-06-12 00:00:00	1995-06-12	38000177		0	0	7		0	0	0	299154	0	1043400	40229134		
3699	307	1127433	1987-10-04	1987-10-04 00:00:00	1987-10-18	1987-10-18 00:00:00	1987-10-18	38000177		0	0	14		0	0	0	20381	0	313782	1127433		
48687	4033	1127433	2003-09-17	2003-09-17 00:00:00	2003-10-01	2003-10-01 00:00:00	2003-10-01	38000177		0	0	14		0	0	0	268351	0	313782	1127433		
237281	5210	40213296	2013-12-17	2013-12-17 00:00:00	2013-12-17	2013-12-17 00:00:00	2013-12-17	581452		0	0	0		0	0	0	346505	0	52	40213296		
7581	639	1127078	1954-03-29	1954-03-29 00:00:00	1954-04-12	1954-04-12 00:00:00	1954-04-12	38000177		0	0	14		0	0	0	42306	0	282464	1127078		
144842	3183	40213160	1981-05-17	1981-05-17 00:00:00	1981-05-17	1981-05-17 00:00:00	1981-05-17	581452		0	0	0		0	0	0	211901	0	10	40213160		
59322	4929	1127433	1984-07-16	1984-07-16 00:00:00	1984-08-06	1984-08-06 00:00:00	1984-08-06	38000177		0	0	21		0	0	0	327672	0	313782	1127433		
15414	1285	1127078	1962-01-09	1962-01-09 00:00:00	1962-02-13	1962-02-13 00:00:00	1962-02-13	38000177		0	0	35		0	0	0	84924	0	282464	1127078		
63071	5240	40229134	1942-01-14	1942-01-14 00:00:00	1942-01-21	1942-01-21 00:00:00	1942-01-21	38000177		0	0	7		0	0	0	348711	0	1043400	40229134		
29216	2418	46233988	1975-12-23	1975-12-23 00:00:00	1976-01-06	1976-01-06 00:00:00	1976-01-06	38000177		0	0	14		0	0	0	160431	0	1652673	46233988		
188253	4134	40213198	2014-09-28	2014-09-28 00:00:00	2014-09-28	2014-09-28 00:00:00	2014-09-28	581452		0	0	0		0	0	0	274882	0	133	40213198		
39782	3290	1713671	2011-03-10	2011-03-10 00:00:00	2011-03-31	2011-03-31 00:00:00	2011-03-31	38000177		0	0	21		0	0	0	218575	0	562251	1713671		
231136	5079	40213306	1989-03-26	1989-03-26 00:00:00	1989-03-26	1989-03-26 00:00:00	1989-03-26	581452		0	0	0		0	0	0	337710	0	43	40213306		
31507	2613	1127433	1965-08-05	1965-08-05 00:00:00	1965-08-12	1965-08-12 00:00:00	1965-08-12	38000177		0	0	7		0	0	0	172746	0	313782	1127433		
217673	4777	40213260	2009-05-19	2009-05-19 00:00:00	2009-05-19	2009-05-19 00:00:00	2009-05-19	581452		0	0	0		0	0	0	318130	0	121	40213260		
28605	2357	19059056	1941-10-19	1941-10-19 00:00:00	1941-11-02	1941-11-02 00:00:00	1941-11-02	38000177		0	0	14		0	0	0	157039	0	243670	19059056		
34704	2865	19006318	1974-01-20	1974-01-20 00:00:00	1974-02-03	1974-02-03 00:00:00	1974-02-03	38000177		0	0	14		0	0	0	190627	0	105078	19006318		
59617	1305	40213160	1965-03-18	1965-03-18 00:00:00	1965-03-18	1965-03-18 00:00:00	1965-03-18	581452		0	0	0		0	0	0	86134	0	10	40213160		
46300	3835	40236824	2006-10-10	2006-10-10 00:00:00	2006-10-17	2006-10-17 00:00:00	2006-10-17	38000177		0	0	7		0	0	0	254637	0	1094107	40236824		
39222	3240	19006318	1948-06-28	1948-06-28 00:00:00	1948-07-12	1948-07-12 00:00:00	1948-07-12	38000177		0	0	14		0	0	0	215390	0	105078	19006318		
56853	4719	19059056	1992-06-19	1992-06-19 00:00:00	1992-07-03	1992-07-03 00:00:00	1992-07-03	38000177		0	0	14		0	0	0	314231	0	243670	19059056		
39331	3248	46275444	2016-06-26	2016-06-26 00:00:00	2016-06-26	2016-06-26 00:00:00	2016-06-26	38000177		0	0	0		0	0	0	215881	0	1659149	46275444		
28019	2319	1713671	1989-01-11	1989-01-11 00:00:00	1989-02-01	1989-02-01 00:00:00	1989-02-01	38000177		0	0	21		0	0	0	154182	0	562251	1713671		
232961	5119	40213160	1962-08-14	1962-08-14 00:00:00	1962-08-14	1962-08-14 00:00:00	1962-08-14	581452		0	0	0		0	0	0	340419	0	10	40213160		
205496	4509	40213296	2009-09-08	2009-09-08 00:00:00	2009-09-08	2009-09-08 00:00:00	2009-09-08	581452		0	0	0		0	0	0	300361	0	52	40213296		
126927	2792	40213296	1997-10-13	1997-10-13 00:00:00	1997-10-13	1997-10-13 00:00:00	1997-10-13	581452		0	0	0		0	0	0	185011	0	52	40213296		
44630	3695	1127078	1982-12-07	1982-12-07 00:00:00	1982-12-21	1982-12-21 00:00:00	1982-12-21	38000177		0	0	14		0	0	0	245642	0	282464	1127078		
39755	867	40213227	2000-05-23	2000-05-23 00:00:00	2000-05-23	2000-05-23 00:00:00	2000-05-23	581452		0	0	0		0	0	0	57565	0	113	40213227		
58001	4819	40229134	1993-12-03	1993-12-03 00:00:00	1993-12-17	1993-12-17 00:00:00	1993-12-17	38000177		0	0	14		0	0	0	320515	0	1043400	40229134		
62713	5213	1127433	1984-03-24	1984-03-24 00:00:00	1984-03-31	1984-03-31 00:00:00	1984-03-31	38000177		0	0	7		0	0	0	346708	0	313782	1127433		
55978	1226	40213227	2002-10-20	2002-10-20 00:00:00	2002-10-20	2002-10-20 00:00:00	2002-10-20	581452		0	0	0		0	0	0	80704	0	113	40213227		
41383	902	40213201	2017-06-24	2017-06-24 00:00:00	2017-06-24	2017-06-24 00:00:00	2017-06-24	581452		0	0	0		0	0	0	59995	0	33	40213201		
59870	4976	920300	1941-12-19	1941-12-19 00:00:00	1941-12-26	1941-12-26 00:00:00	1941-12-26	38000177		0	0	7		0	0	0	330967	0	311989	920300		
90506	1986	40213251	1984-10-30	1984-10-30 00:00:00	1984-10-30	1984-10-30 00:00:00	1984-10-30	581452		0	0	0		0	0	0	132219	0	21	40213251		
43775	954	40213227	1996-06-16	1996-06-16 00:00:00	1996-06-16	1996-06-16 00:00:00	1996-06-16	581452		0	0	0		0	0	0	63367	0	113	40213227		
31606	2620	40236824	2002-12-18	2002-12-18 00:00:00	2002-12-25	2002-12-25 00:00:00	2002-12-25	38000177		0	0	7		0	0	0	173311	0	1094107	40236824		
31663	2624	1127433	1993-08-26	1993-08-26 00:00:00	1993-09-09	1993-09-09 00:00:00	1993-09-09	38000177		0	0	14		0	0	0	173605	0	313782	1127433		
38231	3161	46233710	1967-05-11	1967-05-11 00:00:00	1967-05-25	1967-05-25 00:00:00	1967-05-25	38000177		0	0	14		0	0	0	210254	0	1650142	46233710		
19130	1578	920300	1977-04-26	1977-04-26 00:00:00	1977-05-03	1977-05-03 00:00:00	1977-05-03	38000177		0	0	7		0	0	0	106025	0	311989	920300		
42255	3505	19133905	1977-07-01	1977-07-01 00:00:00	1977-07-09	1977-07-09 00:00:00	1977-07-09	38000177		0	0	8		0	0	0	232399	0	834102	19133905		
22554	1852	40229134	2001-01-19	2001-01-19 00:00:00	2001-01-26	2001-01-26 00:00:00	2001-01-26	38000177		0	0	7		0	0	0	123969	0	1043400	40229134		
227685	4999	40213260	2006-11-19	2006-11-19 00:00:00	2006-11-19	2006-11-19 00:00:00	2006-11-19	581452		0	0	0		0	0	0	332476	0	121	40213260		
52868	4392	1115171	2001-09-18	2001-09-18 00:00:00	2001-10-09	2001-10-09 00:00:00	2001-10-09	38000177		0	0	21		0	0	0	292085	0	849574	1115171		
32644	2706	1115171	2000-08-06	2000-08-06 00:00:00	2000-08-27	2000-08-27 00:00:00	2000-08-27	38000177		0	0	21		0	0	0	179260	0	849574	1115171		
5021	418	19133905	1996-01-06	1996-01-06 00:00:00	1996-01-17	1996-01-17 00:00:00	1996-01-17	38000177		0	0	11		0	0	0	27600	0	834102	19133905		
228638	5022	40213296	2008-01-07	2008-01-07 00:00:00	2008-01-07	2008-01-07 00:00:00	2008-01-07	581452		0	0	0		0	0	0	333709	0	52	40213296		
21168	1744	1127433	2014-10-20	2014-10-20 00:00:00	2014-11-03	2014-11-03 00:00:00	2014-11-03	38000177		0	0	14		0	0	0	116631	0	313782	1127433		
158714	3494	40213160	1960-04-14	1960-04-14 00:00:00	1960-04-14	1960-04-14 00:00:00	1960-04-14	581452		0	0	0		0	0	0	231726	0	10	40213160		
63575	5283	19133873	1981-02-22	1981-02-22 00:00:00	1981-03-05	1981-03-05 00:00:00	1981-03-05	38000177		0	0	11		0	0	0	351411	0	834061	19133873		
54372	4521	19018935	2000-06-08	2000-06-08 00:00:00	2000-06-08	2000-06-08 00:00:00	\N	38000177		0	0	0		0	0	0	301035	0	197604	19018935		
106842	2342	40213296	2015-01-23	2015-01-23 00:00:00	2015-01-23	2015-01-23 00:00:00	2015-01-23	581452		0	0	0		0	0	0	155886	0	52	40213296		
177113	3892	40213227	2013-07-06	2013-07-06 00:00:00	2013-07-06	2013-07-06 00:00:00	2013-07-06	581452		0	0	0		0	0	0	258779	0	113	40213227		
230547	5066	40213160	1967-07-15	1967-07-15 00:00:00	1967-07-15	1967-07-15 00:00:00	1967-07-15	581452		0	0	0		0	0	0	336758	0	10	40213160		
55357	4596	1127433	2016-01-09	2016-01-09 00:00:00	2016-02-06	2016-02-06 00:00:00	2016-02-06	38000177		0	0	28		0	0	0	306271	0	313782	1127433		
18003	390	40213160	1979-11-07	1979-11-07 00:00:00	1979-11-07	1979-11-07 00:00:00	1979-11-07	581452		0	0	0		0	0	0	25636	0	10	40213160		
18077	392	40213306	1998-02-13	1998-02-13 00:00:00	1998-02-13	1998-02-13 00:00:00	1998-02-13	581452		0	0	0		0	0	0	25733	0	43	40213306		
521	38	1127433	2016-01-01	2016-01-01 00:00:00	2016-01-08	2016-01-08 00:00:00	2016-01-08	38000177		0	0	7		0	0	0	2709	0	313782	1127433		
574	42	1127433	1992-04-09	1992-04-09 00:00:00	1992-04-16	1992-04-16 00:00:00	1992-04-16	38000177		0	0	7		0	0	0	3069	0	313782	1127433		
55688	4625	1127433	1985-08-24	1985-08-24 00:00:00	1985-08-31	1985-08-31 00:00:00	1985-08-31	38000177		0	0	7		0	0	0	308133	0	313782	1127433		
55707	4626	1127433	1990-12-14	1990-12-14 00:00:00	1990-12-28	1990-12-28 00:00:00	1990-12-28	38000177		0	0	14		0	0	0	308234	0	313782	1127433		
30108	2497	40243436	2008-02-28	2008-02-28 00:00:00	2008-02-28	2008-02-28 00:00:00	2008-02-28	38000177		0	0	0		0	0	0	165316	0	1190795	40243436		
114932	2525	40213296	2017-01-20	2017-01-20 00:00:00	2017-01-20	2017-01-20 00:00:00	2017-01-20	581452		0	0	0		0	0	0	166974	0	52	40213296		
48606	4026	19059056	1962-09-25	1962-09-25 00:00:00	1962-10-09	1962-10-09 00:00:00	1962-10-09	38000177		0	0	14		0	0	0	267645	0	243670	19059056		
28970	2395	19129655	1964-06-07	1964-06-07 00:00:00	1964-06-21	1964-06-21 00:00:00	1964-06-21	38000177		0	0	14		0	0	0	159224	0	789980	19129655		
54080	4493	1118084	2017-01-29	2017-01-29 00:00:00	2017-01-29	2017-01-29 00:00:00	\N	38000177		0	0	0		0	0	0	299185	0	00025152531	44923712		
3700	307	19078461	1991-06-20	1991-06-20 00:00:00	1991-07-25	1991-07-25 00:00:00	1991-07-25	38000177		0	0	35		0	0	0	20383	0	310965	19078461		
48688	4033	19133873	1979-11-21	1979-11-21 00:00:00	1979-12-03	1979-12-03 00:00:00	1979-12-03	38000177		0	0	12		0	0	0	268316	0	834061	19133873		
237282	5210	40213306	1994-06-21	1994-06-21 00:00:00	1994-06-21	1994-06-21 00:00:00	1994-06-21	581452		0	0	0		0	0	0	346485	0	43	40213306		
7583	639	1127433	2008-02-16	2008-02-16 00:00:00	2008-02-23	2008-02-23 00:00:00	2008-02-23	38000177		0	0	7		0	0	0	42312	0	313782	1127433		
144843	3183	40213251	1984-01-15	1984-01-15 00:00:00	1984-01-15	1984-01-15 00:00:00	1984-01-15	581452		0	0	0		0	0	0	211946	0	21	40213251		
59324	4929	19059056	1965-11-25	1965-11-25 00:00:00	1965-12-09	1965-12-09 00:00:00	1965-12-09	38000177		0	0	14		0	0	0	327669	0	243670	19059056		
15415	1285	1713671	2016-10-08	2016-10-08 00:00:00	2016-10-29	2016-10-29 00:00:00	2016-10-29	38000177		0	0	21		0	0	0	84978	0	562251	1713671		
63072	5240	1713671	1970-08-21	1970-08-21 00:00:00	1970-10-09	1970-10-09 00:00:00	1970-10-09	38000177		0	0	49		0	0	0	348641	0	562251	1713671		
39675	3280	1127433	1982-12-02	1982-12-02 00:00:00	1982-12-30	1982-12-30 00:00:00	1982-12-30	38000177		0	0	28		0	0	0	218038	0	313782	1127433		
188263	4134	40213227	2010-09-05	2010-09-05 00:00:00	2010-09-05	2010-09-05 00:00:00	2010-09-05	581452		0	0	0		0	0	0	274841	0	113	40213227		
39783	3290	19133873	1979-09-09	1979-09-09 00:00:00	1979-09-22	1979-09-22 00:00:00	1979-09-22	38000177		0	0	13		0	0	0	218585	0	834061	19133873		
231138	5079	40213160	1970-12-27	1970-12-27 00:00:00	1970-12-27	1970-12-27 00:00:00	1970-12-27	581452		0	0	0		0	0	0	337692	0	10	40213160		
31508	2613	1127433	2001-01-27	2001-01-27 00:00:00	2001-02-10	2001-02-10 00:00:00	2001-02-10	38000177		0	0	14		0	0	0	172750	0	313782	1127433		
217680	4777	40213296	1998-11-17	1998-11-17 00:00:00	1998-11-17	1998-11-17 00:00:00	1998-11-17	581452		0	0	0		0	0	0	318128	0	52	40213296		
28606	2357	920300	1995-12-19	1995-12-19 00:00:00	1995-12-26	1995-12-26 00:00:00	1995-12-26	38000177		0	0	7		0	0	0	156983	0	311989	920300		
34705	2865	19133873	1969-01-25	1969-01-25 00:00:00	1969-02-01	1969-02-01 00:00:00	1969-02-01	38000177		0	0	7		0	0	0	190625	0	834061	19133873		
59618	1305	40213160	1969-06-19	1969-06-19 00:00:00	1969-06-19	1969-06-19 00:00:00	1969-06-19	581452		0	0	0		0	0	0	86146	0	10	40213160		
46301	3835	920300	2006-10-10	2006-10-10 00:00:00	2006-10-17	2006-10-17 00:00:00	2006-10-17	38000177		0	0	7		0	0	0	254637	0	311989	920300		
39223	3240	19059056	1948-06-28	1948-06-28 00:00:00	1948-07-12	1948-07-12 00:00:00	1948-07-12	38000177		0	0	14		0	0	0	215390	0	243670	19059056		
56854	4719	19059056	1944-10-10	1944-10-10 00:00:00	1944-11-14	1944-11-14 00:00:00	1944-11-14	38000177		0	0	35		0	0	0	314227	0	243670	19059056		
39332	3248	19016749	2016-06-26	2016-06-26 00:00:00	2016-06-26	2016-06-26 00:00:00	2016-06-26	38000177		0	0	0		0	0	0	215881	0	73032	19016749		
28020	2319	19006318	1948-11-06	1948-11-06 00:00:00	1948-11-20	1948-11-20 00:00:00	1948-11-20	38000177		0	0	14		0	0	0	154223	0	105078	19006318		
232962	5119	40213306	1985-01-01	1985-01-01 00:00:00	1985-01-01	1985-01-01 00:00:00	1985-01-01	581452		0	0	0		0	0	0	340296	0	43	40213306		
205498	4509	40213227	1999-04-20	1999-04-20 00:00:00	1999-04-20	1999-04-20 00:00:00	1999-04-20	581452		0	0	0		0	0	0	300396	0	113	40213227		
126935	2792	40213227	2008-10-13	2008-10-13 00:00:00	2008-10-13	2008-10-13 00:00:00	2008-10-13	581452		0	0	0		0	0	0	185057	0	113	40213227		
44631	3695	19073183	1982-12-07	1982-12-07 00:00:00	1982-12-21	1982-12-21 00:00:00	1982-12-21	38000177		0	0	14		0	0	0	245642	0	308182	19073183		
39780	867	40213201	1995-04-25	1995-04-25 00:00:00	1995-04-25	1995-04-25 00:00:00	1995-04-25	581452		0	0	0		0	0	0	57613	0	33	40213201		
58002	4819	1713671	2013-02-25	2013-02-25 00:00:00	2013-03-04	2013-03-04 00:00:00	2013-03-04	38000177		0	0	7		0	0	0	320517	0	562251	1713671		
62714	5213	1713671	1994-06-04	1994-06-04 00:00:00	1994-06-18	1994-06-18 00:00:00	1994-06-18	38000177		0	0	14		0	0	0	346709	0	562251	1713671		
55979	1226	40213314	1980-07-13	1980-07-13 00:00:00	1980-07-13	1980-07-13 00:00:00	1980-07-13	581452		0	0	0		0	0	0	80701	0	49	40213314		
41392	902	40213160	1955-08-06	1955-08-06 00:00:00	1955-08-06	1955-08-06 00:00:00	1955-08-06	581452		0	0	0		0	0	0	60025	0	10	40213160		
59871	4976	1551192	1931-07-06	1931-07-06 00:00:00	1931-07-06	1931-07-06 00:00:00	1931-07-06	38000177		0	0	0		0	0	0	331101	0	312617	1551192		
90511	1987	40213201	2009-11-13	2009-11-13 00:00:00	2009-11-13	2009-11-13 00:00:00	2009-11-13	581452		0	0	0		0	0	0	132328	0	33	40213201		
43777	954	40213160	1974-12-22	1974-12-22 00:00:00	1974-12-22	1974-12-22 00:00:00	1974-12-22	581452		0	0	0		0	0	0	63388	0	10	40213160		
31607	2620	920300	2002-12-18	2002-12-18 00:00:00	2002-12-25	2002-12-25 00:00:00	2002-12-25	38000177		0	0	7		0	0	0	173311	0	311989	920300		
31667	2626	1127433	1994-07-30	1994-07-30 00:00:00	1994-08-13	1994-08-13 00:00:00	1994-08-13	38000177		0	0	14		0	0	0	173713	0	313782	1127433		
38232	3161	19059056	1967-05-11	1967-05-11 00:00:00	1967-05-25	1967-05-25 00:00:00	1967-05-25	38000177		0	0	14		0	0	0	210254	0	243670	19059056		
19131	1578	1124300	1986-05-16	1986-05-16 00:00:00	1986-05-16	1986-05-16 00:00:00	\N	38000177		0	0	0		0	0	0	106008	0	00781178901	45011828		
42279	3508	1127433	1961-11-04	1961-11-04 00:00:00	1961-11-11	1961-11-11 00:00:00	1961-11-11	38000177		0	0	7		0	0	0	232632	0	313782	1127433		
22555	1852	40229134	1974-05-03	1974-05-03 00:00:00	1974-05-10	1974-05-10 00:00:00	1974-05-10	38000177		0	0	7		0	0	0	123893	0	1043400	40229134		
109793	2412	40213201	2016-08-26	2016-08-26 00:00:00	2016-08-26	2016-08-26 00:00:00	2016-08-26	581452		0	0	0		0	0	0	160092	0	33	40213201		
52869	4392	19128065	1996-07-14	1996-07-14 00:00:00	1997-07-09	1997-07-09 00:00:00	1997-07-09	38000177		0	0	360		0	0	0	292072	0	749882	19128065		
32645	2706	19078461	2001-08-22	2001-08-22 00:00:00	2001-09-05	2001-09-05 00:00:00	2001-09-05	38000177		0	0	14		0	0	0	179261	0	310965	19078461		
5022	418	1118084	1996-02-01	1996-02-01 00:00:00	1996-02-01	1996-02-01 00:00:00	\N	38000177		0	0	0		0	0	0	27600	0	00025152531	44923712		
228640	5022	40213160	1968-06-10	1968-06-10 00:00:00	1968-06-10	1968-06-10 00:00:00	1968-06-10	581452		0	0	0		0	0	0	333652	0	10	40213160		
21169	1745	19128022	2001-11-25	2001-11-25 00:00:00	2002-11-20	2002-11-20 00:00:00	2002-11-20	38000177		0	0	360		0	0	0	116691	0	749785	19128022		
158722	3494	40213160	1960-01-14	1960-01-14 00:00:00	1960-01-14	1960-01-14 00:00:00	1960-01-14	581452		0	0	0		0	0	0	231783	0	10	40213160		
63576	5283	19128065	1988-08-22	1988-08-22 00:00:00	1989-08-17	1989-08-17 00:00:00	1989-08-17	38000177		0	0	360		0	0	0	351431	0	749882	19128065		
54373	4521	40223768	2000-06-08	2000-06-08 00:00:00	2000-06-08	2000-06-08 00:00:00	\N	38000177		0	0	0		0	0	0	301035	0	997223	40223768		
106847	2342	40213160	1975-09-26	1975-09-26 00:00:00	1975-09-26	1975-09-26 00:00:00	1975-09-26	581452		0	0	0		0	0	0	155927	0	10	40213160		
177114	3892	40213260	2013-07-06	2013-07-06 00:00:00	2013-07-06	2013-07-06 00:00:00	2013-07-06	581452		0	0	0		0	0	0	258779	0	121	40213260		
241833	5309	40213227	2012-04-02	2012-04-02 00:00:00	2012-04-02	2012-04-02 00:00:00	2012-04-02	581452		0	0	0		0	0	0	353100	0	113	40213227		
55358	4596	40229134	1957-10-25	1957-10-25 00:00:00	1957-11-08	1957-11-08 00:00:00	1957-11-08	38000177		0	0	14		0	0	0	306254	0	1043400	40229134		
18005	390	40213306	1998-08-26	1998-08-26 00:00:00	1998-08-26	1998-08-26 00:00:00	1998-08-26	581452		0	0	0		0	0	0	25646	0	43	40213306		
8219	177	40213296	2006-05-01	2006-05-01 00:00:00	2006-05-01	2006-05-01 00:00:00	2006-05-01	581452		0	0	0		0	0	0	11979	0	52	40213296		
522	38	1127078	1967-10-27	1967-10-27 00:00:00	1967-11-17	1967-11-17 00:00:00	1967-11-17	38000177		0	0	21		0	0	0	2748	0	282464	1127078		
575	42	1127433	1989-05-16	1989-05-16 00:00:00	1989-05-23	1989-05-23 00:00:00	1989-05-23	38000177		0	0	7		0	0	0	3057	0	313782	1127433		
55689	4625	19133905	2015-12-28	2015-12-28 00:00:00	2016-01-04	2016-01-04 00:00:00	2016-01-04	38000177		0	0	7		0	0	0	308108	0	834102	19133905		
55708	4626	19008572	1997-11-07	1997-11-07 00:00:00	1997-11-07	1997-11-07 00:00:00	\N	38000177		0	0	0		0	0	0	308178	0	106258	19008572		
30109	2497	46275916	2008-02-28	2008-02-28 00:00:00	2008-02-28	2008-02-28 00:00:00	2008-02-28	38000177		0	0	0		0	0	0	165316	0	1660014	46275916		
114934	2525	40213160	1974-09-13	1974-09-13 00:00:00	1974-09-13	1974-09-13 00:00:00	1974-09-13	581452		0	0	0		0	0	0	166935	0	10	40213160		
48607	4026	19129655	1962-09-25	1962-09-25 00:00:00	1962-10-09	1962-10-09 00:00:00	1962-10-09	38000177		0	0	14		0	0	0	267645	0	789980	19129655		
28971	2395	1127433	2012-10-19	2012-10-19 00:00:00	2012-10-26	2012-10-26 00:00:00	2012-10-26	38000177		0	0	7		0	0	0	159268	0	313782	1127433		
54081	4493	1127078	1988-01-22	1988-01-22 00:00:00	1988-02-12	1988-02-12 00:00:00	1988-02-12	38000177		0	0	21		0	0	0	299160	0	282464	1127078		
3701	307	19059056	1979-10-27	1979-10-27 00:00:00	1979-11-10	1979-11-10 00:00:00	1979-11-10	38000177		0	0	14		0	0	0	20337	0	243670	19059056		
204411	4487	40213227	1992-10-16	1992-10-16 00:00:00	1992-10-16	1992-10-16 00:00:00	1992-10-16	581452		0	0	0		0	0	0	298772	0	113	40213227		
237285	5210	40213227	2013-12-17	2013-12-17 00:00:00	2013-12-17	2013-12-17 00:00:00	2013-12-17	581452		0	0	0		0	0	0	346505	0	113	40213227		
7584	639	1127433	1965-05-01	1965-05-01 00:00:00	1965-05-15	1965-05-15 00:00:00	1965-05-15	38000177		0	0	14		0	0	0	42310	0	313782	1127433		
179702	3950	40213160	1971-01-07	1971-01-07 00:00:00	1971-01-07	1971-01-07 00:00:00	1971-01-07	581452		0	0	0		0	0	0	262541	0	10	40213160		
59325	4929	19128065	1981-11-11	1981-11-11 00:00:00	1982-11-06	1982-11-06 00:00:00	1982-11-06	38000177		0	0	360		0	0	0	327701	0	749882	19128065		
15416	1285	19078461	1991-08-01	1991-08-01 00:00:00	1991-08-22	1991-08-22 00:00:00	1991-08-22	38000177		0	0	21		0	0	0	84927	0	310965	19078461		
63073	5240	40236824	1985-07-17	1985-07-17 00:00:00	1985-07-31	1985-07-31 00:00:00	1985-07-31	38000177		0	0	14		0	0	0	348693	0	1094107	40236824		
39676	3280	19059056	1967-09-17	1967-09-17 00:00:00	1967-10-08	1967-10-08 00:00:00	1967-10-08	38000177		0	0	21		0	0	0	218036	0	243670	19059056		
188265	4134	40213227	1993-07-18	1993-07-18 00:00:00	1993-07-18	1993-07-18 00:00:00	1993-07-18	581452		0	0	0		0	0	0	274902	0	113	40213227		
39784	3290	1713671	1971-07-28	1971-07-28 00:00:00	1971-08-04	1971-08-04 00:00:00	1971-08-04	38000177		0	0	7		0	0	0	218545	0	562251	1713671		
231140	5079	40213227	1998-04-05	1998-04-05 00:00:00	1998-04-05	1998-04-05 00:00:00	1998-04-05	581452		0	0	0		0	0	0	337726	0	113	40213227		
31509	2613	1127433	1967-06-15	1967-06-15 00:00:00	1967-06-22	1967-06-22 00:00:00	1967-06-22	38000177		0	0	7		0	0	0	172765	0	313782	1127433		
160822	3539	40213227	2012-09-07	2012-09-07 00:00:00	2012-09-07	2012-09-07 00:00:00	2012-09-07	581452		0	0	0		0	0	0	235071	0	113	40213227		
28607	2357	40236824	1995-12-19	1995-12-19 00:00:00	1995-12-26	1995-12-26 00:00:00	1995-12-26	38000177		0	0	7		0	0	0	156983	0	1094107	40236824		
34706	2866	40169281	2001-04-29	2001-04-29 00:00:00	2001-04-29	2001-04-29 00:00:00	\N	38000177		0	0	0		0	0	0	190676	0	896209	40169281		
59620	1305	40213160	1964-10-15	1964-10-15 00:00:00	1964-10-15	1964-10-15 00:00:00	1964-10-15	581452		0	0	0		0	0	0	86129	0	10	40213160		
46302	3835	1713671	1988-04-06	1988-04-06 00:00:00	1988-04-20	1988-04-20 00:00:00	1988-04-20	38000177		0	0	14		0	0	0	254643	0	562251	1713671		
39224	3241	1127078	1965-03-09	1965-03-09 00:00:00	1965-06-07	1965-06-07 00:00:00	1965-06-07	38000177		0	0	90		0	0	0	215439	0	282464	1127078		
56855	4719	19133905	2006-10-15	2006-10-15 00:00:00	2006-10-27	2006-10-27 00:00:00	2006-10-27	38000177		0	0	12		0	0	0	314195	0	834102	19133905		
39333	3248	19059056	1946-06-08	1946-06-08 00:00:00	1946-06-22	1946-06-22 00:00:00	1946-06-22	38000177		0	0	14		0	0	0	215927	0	243670	19059056		
28021	2319	19059056	1948-11-06	1948-11-06 00:00:00	1948-11-20	1948-11-20 00:00:00	1948-11-20	38000177		0	0	14		0	0	0	154223	0	243670	19059056		
232970	5119	40213160	1962-10-16	1962-10-16 00:00:00	1962-10-16	1962-10-16 00:00:00	1962-10-16	581452		0	0	0		0	0	0	340330	0	10	40213160		
205502	4509	40213306	1989-09-12	1989-09-12 00:00:00	1989-09-12	1989-09-12 00:00:00	1989-09-12	581452		0	0	0		0	0	0	300400	0	43	40213306		
99190	2172	40213160	1983-09-17	1983-09-17 00:00:00	1983-09-17	1983-09-17 00:00:00	1983-09-17	581452		0	0	0		0	0	0	144687	0	10	40213160		
44632	3695	1127433	1992-09-28	1992-09-28 00:00:00	1992-10-19	1992-10-19 00:00:00	1992-10-19	38000177		0	0	21		0	0	0	245604	0	313782	1127433		
39784	867	40213227	2010-07-20	2010-07-20 00:00:00	2010-07-20	2010-07-20 00:00:00	2010-07-20	581452		0	0	0		0	0	0	57569	0	113	40213227		
58003	4819	1127433	1988-01-23	1988-01-23 00:00:00	1988-02-06	1988-02-06 00:00:00	1988-02-06	38000177		0	0	14		0	0	0	320546	0	313782	1127433		
62715	5213	1127433	1942-11-23	1942-11-23 00:00:00	1942-11-30	1942-11-30 00:00:00	1942-11-30	38000177		0	0	7		0	0	0	346763	0	313782	1127433		
55980	1226	40213160	1980-07-13	1980-07-13 00:00:00	1980-07-13	1980-07-13 00:00:00	1980-07-13	581452		0	0	0		0	0	0	80701	0	10	40213160		
41394	902	40213227	2001-09-01	2001-09-01 00:00:00	2001-09-01	2001-09-01 00:00:00	2001-09-01	581452		0	0	0		0	0	0	60023	0	113	40213227		
59872	4976	19133905	1970-08-16	1970-08-16 00:00:00	1970-08-28	1970-08-28 00:00:00	1970-08-28	38000177		0	0	12		0	0	0	330976	0	834102	19133905		
90526	1987	40213198	2010-11-19	2010-11-19 00:00:00	2010-11-19	2010-11-19 00:00:00	2010-11-19	581452		0	0	0		0	0	0	132293	0	133	40213198		
43778	954	40213160	1974-09-22	1974-09-22 00:00:00	1974-09-22	1974-09-22 00:00:00	1974-09-22	581452		0	0	0		0	0	0	63397	0	10	40213160		
31608	2620	1127433	1992-11-05	1992-11-05 00:00:00	1993-02-03	1993-02-03 00:00:00	1993-02-03	38000177		0	0	90		0	0	0	173274	0	313782	1127433		
31668	2626	1115171	2018-05-07	2018-05-07 00:00:00	2018-05-21	2018-05-21 00:00:00	2018-05-21	38000177		0	0	14		0	0	0	173721	0	849574	1115171		
33640	733	40213227	1992-09-10	1992-09-10 00:00:00	1992-09-10	1992-09-10 00:00:00	1992-09-10	581452		0	0	0		0	0	0	48622	0	113	40213227		
19132	1578	1127433	2017-10-16	2017-10-16 00:00:00	2017-11-06	2017-11-06 00:00:00	2017-11-06	38000177		0	0	21		0	0	0	105971	0	313782	1127433		
42280	3508	1124300	1995-11-09	1995-11-09 00:00:00	1995-11-09	1995-11-09 00:00:00	\N	38000177		0	0	0		0	0	0	232649	0	00781178901	45011828		
22556	1852	1127433	2016-10-29	2016-10-29 00:00:00	2016-11-19	2016-11-19 00:00:00	2016-11-19	38000177		0	0	21		0	0	0	123948	0	313782	1127433		
109803	2412	40213160	1955-12-16	1955-12-16 00:00:00	1955-12-16	1955-12-16 00:00:00	1955-12-16	581452		0	0	0		0	0	0	160044	0	10	40213160		
52870	4392	1127433	2017-02-22	2017-02-22 00:00:00	2017-03-01	2017-03-01 00:00:00	2017-03-01	38000177		0	0	7		0	0	0	292052	0	313782	1127433		
32646	2706	1713671	2011-08-27	2011-08-27 00:00:00	2011-09-17	2011-09-17 00:00:00	2011-09-17	38000177		0	0	21		0	0	0	179293	0	562251	1713671		
5023	418	40229134	2016-04-03	2016-04-03 00:00:00	2016-04-17	2016-04-17 00:00:00	2016-04-17	38000177		0	0	14		0	0	0	27616	0	1043400	40229134		
228642	5022	40213160	1968-09-09	1968-09-09 00:00:00	1968-09-09	1968-09-09 00:00:00	1968-09-09	581452		0	0	0		0	0	0	333699	0	10	40213160		
21170	1745	19073183	1980-02-09	1980-02-09 00:00:00	1980-02-23	1980-02-23 00:00:00	1980-02-23	38000177		0	0	14		0	0	0	116696	0	308182	19073183		
158724	3494	40213227	1993-04-22	1993-04-22 00:00:00	1993-04-22	1993-04-22 00:00:00	1993-04-22	581452		0	0	0		0	0	0	231750	0	113	40213227		
63577	5283	1118084	2011-02-08	2011-02-08 00:00:00	2011-02-08	2011-02-08 00:00:00	\N	38000177		0	0	0		0	0	0	351459	0	00025152531	44923712		
54374	4521	40163554	2000-06-08	2000-06-08 00:00:00	2000-06-08	2000-06-08 00:00:00	\N	38000177		0	0	0		0	0	0	301035	0	855332	40163554		
106851	2342	40213160	1975-04-25	1975-04-25 00:00:00	1975-04-25	1975-04-25 00:00:00	1975-04-25	581452		0	0	0		0	0	0	155903	0	10	40213160		
177116	3892	40213160	1963-03-09	1963-03-09 00:00:00	1963-03-09	1963-03-09 00:00:00	1963-03-09	581452		0	0	0		0	0	0	258794	0	10	40213160		
241835	5309	40213198	2016-04-25	2016-04-25 00:00:00	2016-04-25	2016-04-25 00:00:00	2016-04-25	581452		0	0	0		0	0	0	353102	0	133	40213198		
55359	4596	1127433	1947-08-09	1947-08-09 00:00:00	1947-08-16	1947-08-16 00:00:00	1947-08-16	38000177		0	0	7		0	0	0	306252	0	313782	1127433		
18006	390	40213160	1975-05-14	1975-05-14 00:00:00	1975-05-14	1975-05-14 00:00:00	1975-05-14	581452		0	0	0		0	0	0	25619	0	10	40213160		
8223	177	40213227	2008-05-05	2008-05-05 00:00:00	2008-05-05	2008-05-05 00:00:00	2008-05-05	581452		0	0	0		0	0	0	11982	0	113	40213227		
523	38	1127433	1999-12-24	1999-12-24 00:00:00	2000-01-07	2000-01-07 00:00:00	2000-01-07	38000177		0	0	14		0	0	0	2735	0	313782	1127433		
576	42	19059056	1930-10-04	1930-10-04 00:00:00	1931-01-02	1931-01-02 00:00:00	1931-01-02	38000177		0	0	90		0	0	0	3111	0	243670	19059056		
55690	4625	19078461	1991-07-15	1991-07-15 00:00:00	1991-08-05	1991-08-05 00:00:00	1991-08-05	38000177		0	0	21		0	0	0	308132	0	310965	19078461		
55709	4626	19128022	1990-10-25	1990-10-25 00:00:00	1991-10-20	1991-10-20 00:00:00	1991-10-20	38000177		0	0	360		0	0	0	308197	0	749785	19128022		
30110	2497	1310034	2008-02-28	2008-02-28 00:00:00	2008-02-28	2008-02-28 00:00:00	2008-02-28	38000177		0	0	0		0	0	0	165316	0	834357	1310034		
114936	2525	40213306	1996-05-17	1996-05-17 00:00:00	1996-05-17	1996-05-17 00:00:00	1996-05-17	581452		0	0	0		0	0	0	166960	0	43	40213306		
48608	4026	19078461	1977-04-16	1977-04-16 00:00:00	1977-05-07	1977-05-07 00:00:00	1977-05-07	38000177		0	0	21		0	0	0	267630	0	310965	19078461		
28972	2395	19059056	1961-08-31	1961-08-31 00:00:00	1961-09-14	1961-09-14 00:00:00	1961-09-14	38000177		0	0	14		0	0	0	159270	0	243670	19059056		
54082	4493	1127433	1989-11-13	1989-11-13 00:00:00	1989-11-27	1989-11-27 00:00:00	1989-11-27	38000177		0	0	14		0	0	0	299162	0	313782	1127433		
3702	307	19074843	1979-10-27	1979-10-27 00:00:00	1979-11-10	1979-11-10 00:00:00	1979-11-10	38000177		0	0	14		0	0	0	20337	0	309045	19074843		
215697	4731	40213160	1972-02-08	1972-02-08 00:00:00	1972-02-08	1972-02-08 00:00:00	1972-02-08	581452		0	0	0		0	0	0	315183	0	10	40213160		
237290	5210	40213160	1972-03-14	1972-03-14 00:00:00	1972-03-14	1972-03-14 00:00:00	1972-03-14	581452		0	0	0		0	0	0	346455	0	10	40213160		
7585	639	19128065	1975-11-14	1975-11-14 00:00:00	1976-11-08	1976-11-08 00:00:00	1976-11-08	38000177		0	0	360		0	0	0	42307	0	749882	19128065		
190995	4197	40213306	2007-11-18	2007-11-18 00:00:00	2007-11-18	2007-11-18 00:00:00	2007-11-18	581452		0	0	0		0	0	0	278530	0	43	40213306		
59326	4929	1127078	1969-12-18	1969-12-18 00:00:00	1970-03-18	1970-03-18 00:00:00	1970-03-18	38000177		0	0	90		0	0	0	327670	0	282464	1127078		
15417	1285	40231925	1989-08-20	1989-08-20 00:00:00	1989-08-20	1989-08-20 00:00:00	\N	38000177		0	0	0		0	0	0	84926	0	1049221	40231925		
63074	5240	920300	1985-07-17	1985-07-17 00:00:00	1985-07-24	1985-07-24 00:00:00	1985-07-24	38000177		0	0	7		0	0	0	348693	0	311989	920300		
39677	3280	19059056	1952-10-07	1952-10-07 00:00:00	1952-11-04	1952-11-04 00:00:00	1952-11-04	38000177		0	0	28		0	0	0	218033	0	243670	19059056		
188281	4134	40213201	2015-10-04	2015-10-04 00:00:00	2015-10-04	2015-10-04 00:00:00	2015-10-04	581452		0	0	0		0	0	0	274907	0	33	40213201		
39785	3290	1127433	1991-01-07	1991-01-07 00:00:00	1991-02-11	1991-02-11 00:00:00	1991-02-11	38000177		0	0	35		0	0	0	218618	0	313782	1127433		
231142	5079	40213260	2016-12-18	2016-12-18 00:00:00	2016-12-18	2016-12-18 00:00:00	2016-12-18	581452		0	0	0		0	0	0	337702	0	121	40213260		
31510	2613	1118084	1996-09-14	1996-09-14 00:00:00	1996-09-14	1996-09-14 00:00:00	\N	38000177		0	0	0		0	0	0	172798	0	00025152531	44923712		
160825	3539	40213251	1985-11-22	1985-11-22 00:00:00	1985-11-22	1985-11-22 00:00:00	1985-11-22	581452		0	0	0		0	0	0	235063	0	21	40213251		
28608	2357	1713671	1985-01-24	1985-01-24 00:00:00	1985-01-31	1985-01-31 00:00:00	1985-01-31	38000177		0	0	7		0	0	0	157021	0	562251	1713671		
34707	2866	19133873	1970-01-29	1970-01-29 00:00:00	1970-02-09	1970-02-09 00:00:00	1970-02-09	38000177		0	0	11		0	0	0	190645	0	834061	19133873		
59625	1305	40213306	1986-09-18	1986-09-18 00:00:00	1986-09-18	1986-09-18 00:00:00	1986-09-18	581452		0	0	0		0	0	0	86165	0	43	40213306		
46303	3835	19059056	1966-08-14	1966-08-14 00:00:00	1966-09-11	1966-09-11 00:00:00	1966-09-11	38000177		0	0	28		0	0	0	254690	0	243670	19059056		
39226	3241	1713671	1973-08-23	1973-08-23 00:00:00	1973-09-06	1973-09-06 00:00:00	1973-09-06	38000177		0	0	14		0	0	0	215485	0	562251	1713671		
56856	4719	1124300	1972-05-11	1972-05-11 00:00:00	1972-05-11	1972-05-11 00:00:00	\N	38000177		0	0	0		0	0	0	314220	0	00781178901	45011828		
39334	3248	19059056	1946-07-08	1946-07-08 00:00:00	1946-07-22	1946-07-22 00:00:00	1946-07-22	38000177		0	0	14		0	0	0	215924	0	243670	19059056		
28022	2319	19006318	1949-08-20	1949-08-20 00:00:00	1949-09-03	1949-09-03 00:00:00	1949-09-03	38000177		0	0	14		0	0	0	154186	0	105078	19006318		
232980	5119	40213160	1967-04-18	1967-04-18 00:00:00	1967-04-18	1967-04-18 00:00:00	1967-04-18	581452		0	0	0		0	0	0	340332	0	10	40213160		
205507	4509	40213160	1972-05-02	1972-05-02 00:00:00	1972-05-02	1972-05-02 00:00:00	1972-05-02	581452		0	0	0		0	0	0	300356	0	10	40213160		
99194	2172	40213160	1979-06-16	1979-06-16 00:00:00	1979-06-16	1979-06-16 00:00:00	1979-06-16	581452		0	0	0		0	0	0	144696	0	10	40213160		
44633	3695	1127433	2008-11-30	2008-11-30 00:00:00	2008-12-14	2008-12-14 00:00:00	2008-12-14	38000177		0	0	14		0	0	0	245592	0	313782	1127433		
62606	5206	1118084	2017-10-26	2017-10-26 00:00:00	2017-10-26	2017-10-26 00:00:00	\N	38000177		0	0	0		0	0	0	346261	0	00025152531	44923712		
58004	4819	1713671	1998-03-15	1998-03-15 00:00:00	1998-03-29	1998-03-29 00:00:00	1998-03-29	38000177		0	0	14		0	0	0	320587	0	562251	1713671		
62716	5213	19078461	2007-03-14	2007-03-14 00:00:00	2007-04-11	2007-04-11 00:00:00	2007-04-11	38000177		0	0	28		0	0	0	346775	0	310965	19078461		
22032	479	40213227	2001-06-10	2001-06-10 00:00:00	2001-06-10	2001-06-10 00:00:00	2001-06-10	581452		0	0	0		0	0	0	31957	0	113	40213227		
41400	902	40213227	2012-05-26	2012-05-26 00:00:00	2012-05-26	2012-05-26 00:00:00	2012-05-26	581452		0	0	0		0	0	0	60064	0	113	40213227		
59873	4976	1127433	1950-12-05	1950-12-05 00:00:00	1950-12-19	1950-12-19 00:00:00	1950-12-19	38000177		0	0	14		0	0	0	331103	0	313782	1127433		
90537	1987	40213227	1994-08-19	1994-08-19 00:00:00	1994-08-19	1994-08-19 00:00:00	1994-08-19	581452		0	0	0		0	0	0	132323	0	113	40213227		
43781	954	40213314	1977-03-20	1977-03-20 00:00:00	1977-03-20	1977-03-20 00:00:00	1977-03-20	581452		0	0	0		0	0	0	63398	0	49	40213314		
31609	2620	40165015	1992-11-05	1992-11-05 00:00:00	1992-11-05	1992-11-05 00:00:00	\N	38000177		0	0	0		0	0	0	173274	0	861467	40165015		
31669	2626	19073188	2018-05-07	2018-05-07 00:00:00	2018-05-21	2018-05-21 00:00:00	2018-05-21	38000177		0	0	14		0	0	0	173721	0	308192	19073188		
44932	978	40213314	1977-07-22	1977-07-22 00:00:00	1977-07-22	1977-07-22 00:00:00	1977-07-22	581452		0	0	0		0	0	0	65158	0	49	40213314		
50607	4204	1127433	1972-04-20	1972-04-20 00:00:00	1972-05-11	1972-05-11 00:00:00	1972-05-11	38000177		0	0	21		0	0	0	279065	0	313782	1127433		
42281	3508	19006318	1957-10-24	1957-10-24 00:00:00	1957-11-07	1957-11-07 00:00:00	1957-11-07	38000177		0	0	14		0	0	0	232628	0	105078	19006318		
22557	1852	1713671	2012-11-02	2012-11-02 00:00:00	2012-11-23	2012-11-23 00:00:00	2012-11-23	38000177		0	0	21		0	0	0	123907	0	562251	1713671		
109805	2412	40213227	2011-07-29	2011-07-29 00:00:00	2011-07-29	2011-07-29 00:00:00	2011-07-29	581452		0	0	0		0	0	0	160067	0	113	40213227		
52871	4392	40231925	2005-09-18	2005-09-18 00:00:00	2005-09-18	2005-09-18 00:00:00	\N	38000177		0	0	0		0	0	0	292047	0	1049221	40231925		
32647	2706	1115171	2010-02-20	2010-02-20 00:00:00	2010-03-27	2010-03-27 00:00:00	2010-03-27	38000177		0	0	35		0	0	0	179297	0	849574	1115171		
5024	419	19059056	1924-12-23	1924-12-23 00:00:00	1925-01-13	1925-01-13 00:00:00	1925-01-13	38000177		0	0	21		0	0	0	27709	0	243670	19059056		
228644	5022	40213160	1968-04-08	1968-04-08 00:00:00	1968-04-08	1968-04-08 00:00:00	1968-04-08	581452		0	0	0		0	0	0	333698	0	10	40213160		
124937	2749	40213227	1994-04-06	1994-04-06 00:00:00	1994-04-06	1994-04-06 00:00:00	1994-04-06	581452		0	0	0		0	0	0	181809	0	113	40213227		
158727	3494	40213160	1959-11-12	1959-11-12 00:00:00	1959-11-12	1959-11-12 00:00:00	1959-11-12	581452		0	0	0		0	0	0	231725	0	10	40213160		
63578	5283	19133905	1996-08-17	1996-08-17 00:00:00	1996-08-29	1996-08-29 00:00:00	1996-08-29	38000177		0	0	12		0	0	0	351420	0	834102	19133905		
54375	4521	40171902	2000-06-08	2000-06-08 00:00:00	2000-06-08	2000-06-08 00:00:00	\N	38000177		0	0	0		0	0	0	301035	0	897718	40171902		
106853	2342	40213160	1975-06-27	1975-06-27 00:00:00	1975-06-27	1975-06-27 00:00:00	1975-06-27	581452		0	0	0		0	0	0	155914	0	10	40213160		
177128	3892	40213260	2012-06-30	2012-06-30 00:00:00	2012-06-30	2012-06-30 00:00:00	2012-06-30	581452		0	0	0		0	0	0	258818	0	121	40213260		
241852	5309	40213160	1955-10-31	1955-10-31 00:00:00	1955-10-31	1955-10-31 00:00:00	1955-10-31	581452		0	0	0		0	0	0	353135	0	10	40213160		
55360	4596	1127433	1983-12-07	1983-12-07 00:00:00	1983-12-28	1983-12-28 00:00:00	1983-12-28	38000177		0	0	21		0	0	0	306270	0	313782	1127433		
18007	390	40213296	2015-05-27	2015-05-27 00:00:00	2015-05-27	2015-05-27 00:00:00	2015-05-27	581452		0	0	0		0	0	0	25615	0	52	40213296		
8224	177	40213296	2008-05-05	2008-05-05 00:00:00	2008-05-05	2008-05-05 00:00:00	2008-05-05	581452		0	0	0		0	0	0	11982	0	52	40213296		
524	38	19006318	1966-10-02	1966-10-02 00:00:00	1966-10-16	1966-10-16 00:00:00	1966-10-16	38000177		0	0	14		0	0	0	2685	0	105078	19006318		
577	42	40220960	1993-10-19	1993-10-19 00:00:00	1993-10-19	1993-10-19 00:00:00	1993-10-19	38000177		0	0	0		0	0	0	3104	0	1804799	40220960		
55691	4625	40229134	2003-09-27	2003-09-27 00:00:00	2003-10-04	2003-10-04 00:00:00	2003-10-04	38000177		0	0	7		0	0	0	308116	0	1043400	40229134		
55710	4626	40229134	1994-12-08	1994-12-08 00:00:00	1994-12-22	1994-12-22 00:00:00	1994-12-22	38000177		0	0	14		0	0	0	308213	0	1043400	40229134		
30111	2497	1127433	1971-06-20	1971-06-20 00:00:00	1971-06-27	1971-06-27 00:00:00	1971-06-27	38000177		0	0	7		0	0	0	165329	0	313782	1127433		
114944	2525	40213160	1974-04-12	1974-04-12 00:00:00	1974-04-12	1974-04-12 00:00:00	1974-04-12	581452		0	0	0		0	0	0	166934	0	10	40213160		
48609	4026	19133905	2018-04-01	2018-04-01 00:00:00	2018-04-13	2018-04-13 00:00:00	2018-04-13	38000177		0	0	12		0	0	0	267601	0	834102	19133905		
28973	2395	1118084	1996-06-23	1996-06-23 00:00:00	1996-06-23	1996-06-23 00:00:00	\N	38000177		0	0	0		0	0	0	159232	0	00025152531	44923712		
54083	4493	1713671	2012-08-01	2012-08-01 00:00:00	2012-08-15	2012-08-15 00:00:00	2012-08-15	38000177		0	0	14		0	0	0	299143	0	562251	1713671		
3703	307	1127433	2019-03-03	2019-03-03 00:00:00	2019-03-17	2019-03-17 00:00:00	2019-03-17	38000177		0	0	14		0	0	0	20387	0	313782	1127433		
215703	4731	40213227	1994-04-12	1994-04-12 00:00:00	1994-04-12	1994-04-12 00:00:00	1994-04-12	581452		0	0	0		0	0	0	315170	0	113	40213227		
237293	5210	40213227	2003-07-01	2003-07-01 00:00:00	2003-07-01	2003-07-01 00:00:00	2003-07-01	581452		0	0	0		0	0	0	346493	0	113	40213227		
7586	639	1127433	2007-04-20	2007-04-20 00:00:00	2007-05-27	2007-05-27 00:00:00	2007-05-27	38000177		0	0	37		0	0	0	42244	0	313782	1127433		
190997	4197	40213227	2007-11-18	2007-11-18 00:00:00	2007-11-18	2007-11-18 00:00:00	2007-11-18	581452		0	0	0		0	0	0	278530	0	113	40213227		
59327	4929	19133873	1972-12-05	1972-12-05 00:00:00	1972-12-14	1972-12-14 00:00:00	1972-12-14	38000177		0	0	9		0	0	0	327688	0	834061	19133873		
15418	1285	1127433	1989-08-20	1989-08-20 00:00:00	1989-09-10	1989-09-10 00:00:00	1989-09-10	38000177		0	0	21		0	0	0	84926	0	313782	1127433		
32570	710	40213160	1965-11-16	1965-11-16 00:00:00	1965-11-16	1965-11-16 00:00:00	1965-11-16	581452		0	0	0		0	0	0	47029	0	10	40213160		
39678	3280	1118084	1986-12-18	1986-12-18 00:00:00	1986-12-18	1986-12-18 00:00:00	\N	38000177		0	0	0		0	0	0	217986	0	00025152531	44923712		
188283	4134	40213160	1955-06-19	1955-06-19 00:00:00	1955-06-19	1955-06-19 00:00:00	1955-06-19	581452		0	0	0		0	0	0	274837	0	10	40213160		
39786	3290	1118084	2004-06-12	2004-06-12 00:00:00	2004-06-12	2004-06-12 00:00:00	\N	38000177		0	0	0		0	0	0	218613	0	00025152531	44923712		
231153	5079	40213227	2009-11-29	2009-11-29 00:00:00	2009-11-29	2009-11-29 00:00:00	2009-11-29	581452		0	0	0		0	0	0	337696	0	113	40213227		
31511	2613	1127433	1957-10-01	1957-10-01 00:00:00	1957-10-15	1957-10-15 00:00:00	1957-10-15	38000177		0	0	14		0	0	0	172763	0	313782	1127433		
160827	3539	40213160	1985-11-22	1985-11-22 00:00:00	1985-11-22	1985-11-22 00:00:00	1985-11-22	581452		0	0	0		0	0	0	235063	0	10	40213160		
28609	2357	1127433	2012-11-26	2012-11-26 00:00:00	2013-02-24	2013-02-24 00:00:00	2013-02-24	38000177		0	0	90		0	0	0	157006	0	313782	1127433		
34708	2866	1713671	2010-04-27	2010-04-27 00:00:00	2010-05-04	2010-05-04 00:00:00	2010-05-04	38000177		0	0	7		0	0	0	190654	0	562251	1713671		
60945	5068	19133905	1956-09-14	1956-09-14 00:00:00	1956-09-23	1956-09-23 00:00:00	1956-09-23	38000177		0	0	9		0	0	0	336996	0	834102	19133905		
46304	3835	19133873	1967-12-10	1967-12-10 00:00:00	1967-12-17	1967-12-17 00:00:00	1967-12-17	38000177		0	0	7		0	0	0	254635	0	834061	19133873		
39227	3241	19133905	1980-09-29	1980-09-29 00:00:00	1980-10-11	1980-10-11 00:00:00	1980-10-11	38000177		0	0	12		0	0	0	215576	0	834102	19133905		
56857	4719	19073188	2003-06-06	2003-06-06 00:00:00	2003-06-20	2003-06-20 00:00:00	2003-06-20	38000177		0	0	14		0	0	0	314298	0	308192	19073188		
39335	3248	19006318	1946-07-08	1946-07-08 00:00:00	1946-07-22	1946-07-22 00:00:00	1946-07-22	38000177		0	0	14		0	0	0	215924	0	105078	19006318		
28023	2319	19059056	1949-08-20	1949-08-20 00:00:00	1949-09-03	1949-09-03 00:00:00	1949-09-03	38000177		0	0	14		0	0	0	154186	0	243670	19059056		
232982	5119	40213296	2004-10-12	2004-10-12 00:00:00	2004-10-12	2004-10-12 00:00:00	2004-10-12	581452		0	0	0		0	0	0	340338	0	52	40213296		
78020	1707	40213160	1971-01-18	1971-01-18 00:00:00	1971-01-18	1971-01-18 00:00:00	1971-01-18	581452		0	0	0		0	0	0	114136	0	10	40213160		
99200	2172	40213314	1979-01-13	1979-01-13 00:00:00	1979-01-13	1979-01-13 00:00:00	1979-01-13	581452		0	0	0		0	0	0	144695	0	49	40213314		
44634	3695	19112599	1981-06-13	1981-06-13 00:00:00	1981-06-13	1981-06-13 00:00:00	\N	38000177		0	0	0		0	0	0	245609	0	477045	19112599		
62607	5206	1127433	1993-06-14	1993-06-14 00:00:00	1993-06-28	1993-06-28 00:00:00	1993-06-28	38000177		0	0	14		0	0	0	346292	0	313782	1127433		
58005	4819	1127433	2002-08-20	2002-08-20 00:00:00	2002-09-03	2002-09-03 00:00:00	2002-09-03	38000177		0	0	14		0	0	0	320579	0	313782	1127433		
62717	5213	19078461	1981-11-11	1981-11-11 00:00:00	1981-11-25	1981-11-25 00:00:00	1981-11-25	38000177		0	0	14		0	0	0	346774	0	310965	19078461		
22047	479	40213227	1992-11-08	1992-11-08 00:00:00	1992-11-08	1992-11-08 00:00:00	1992-11-08	581452		0	0	0		0	0	0	31900	0	113	40213227		
82015	1791	40213160	1955-05-05	1955-05-05 00:00:00	1955-05-05	1955-05-05 00:00:00	1955-05-05	581452		0	0	0		0	0	0	120044	0	10	40213160		
59874	4976	1127433	1920-11-10	1920-11-10 00:00:00	1920-11-17	1920-11-17 00:00:00	1920-11-17	38000177		0	0	7		0	0	0	330986	0	313782	1127433		
90539	1987	40213227	2014-12-12	2014-12-12 00:00:00	2014-12-12	2014-12-12 00:00:00	2014-12-12	581452		0	0	0		0	0	0	132302	0	113	40213227		
43788	954	40213227	2005-06-26	2005-06-26 00:00:00	2005-06-26	2005-06-26 00:00:00	2005-06-26	581452		0	0	0		0	0	0	63414	0	113	40213227		
31610	2620	19059056	1988-09-01	1988-09-01 00:00:00	1988-09-22	1988-09-22 00:00:00	1988-09-22	38000177		0	0	21		0	0	0	173272	0	243670	19059056		
31670	2626	1127078	1966-07-03	1966-07-03 00:00:00	1966-07-17	1966-07-17 00:00:00	1966-07-17	38000177		0	0	14		0	0	0	173719	0	282464	1127078		
44934	978	40213160	1976-01-23	1976-01-23 00:00:00	1976-01-23	1976-01-23 00:00:00	1976-01-23	581452		0	0	0		0	0	0	65169	0	10	40213160		
50608	4205	19128065	1986-01-04	1986-01-04 00:00:00	1986-12-30	1986-12-30 00:00:00	1986-12-30	38000177		0	0	360		0	0	0	279210	0	749882	19128065		
42282	3508	1127078	1957-10-24	1957-10-24 00:00:00	1957-11-07	1957-11-07 00:00:00	1957-11-07	38000177		0	0	14		0	0	0	232628	0	282464	1127078		
22558	1852	19059056	1989-05-12	1989-05-12 00:00:00	1989-06-02	1989-06-02 00:00:00	1989-06-02	38000177		0	0	21		0	0	0	123946	0	243670	19059056		
109813	2412	40213198	2015-08-21	2015-08-21 00:00:00	2015-08-21	2015-08-21 00:00:00	2015-08-21	581452		0	0	0		0	0	0	160069	0	133	40213198		
52872	4392	19078461	2005-09-18	2005-09-18 00:00:00	2005-11-17	2005-11-17 00:00:00	2005-11-17	38000177		0	0	60		0	0	0	292047	0	310965	19078461		
32648	2706	1713671	1990-05-23	1990-05-23 00:00:00	1990-06-13	1990-06-13 00:00:00	1990-06-13	38000177		0	0	21		0	0	0	179292	0	562251	1713671		
5025	419	19059056	1913-10-17	1913-10-17 00:00:00	1913-10-31	1913-10-31 00:00:00	1913-10-31	38000177		0	0	14		0	0	0	27762	0	243670	19059056		
228646	5022	40213227	1999-09-27	1999-09-27 00:00:00	1999-09-27	1999-09-27 00:00:00	1999-09-27	581452		0	0	0		0	0	0	333706	0	113	40213227		
124940	2749	40213227	2002-01-02	2002-01-02 00:00:00	2002-01-02	2002-01-02 00:00:00	2002-01-02	581452		0	0	0		0	0	0	181804	0	113	40213227		
158420	3488	40213160	1955-07-29	1955-07-29 00:00:00	1955-07-29	1955-07-29 00:00:00	1955-07-29	581452		0	0	0		0	0	0	231420	0	10	40213160		
6450	140	40213160	1970-02-12	1970-02-12 00:00:00	1970-02-12	1970-02-12 00:00:00	1970-02-12	581452		0	0	0		0	0	0	9374	0	10	40213160		
54376	4521	40173590	2008-11-13	2008-11-13 00:00:00	2008-11-13	2008-11-13 00:00:00	\N	38000177		0	0	0		0	0	0	301028	0	904419	40173590		
106854	2342	40213314	1977-03-18	1977-03-18 00:00:00	1977-03-18	1977-03-18 00:00:00	1977-03-18	581452		0	0	0		0	0	0	155916	0	49	40213314		
177136	3893	40213227	2013-10-25	2013-10-25 00:00:00	2013-10-25	2013-10-25 00:00:00	2013-10-25	581452		0	0	0		0	0	0	258854	0	113	40213227		
241854	5309	40213227	2002-02-04	2002-02-04 00:00:00	2002-02-04	2002-02-04 00:00:00	2002-02-04	581452		0	0	0		0	0	0	353109	0	113	40213227		
55361	4596	40229134	1978-11-24	1978-11-24 00:00:00	1978-12-08	1978-12-08 00:00:00	1978-12-08	38000177		0	0	14		0	0	0	306263	0	1043400	40229134		
18009	390	40213314	1978-01-11	1978-01-11 00:00:00	1978-01-11	1978-01-11 00:00:00	1978-01-11	581452		0	0	0		0	0	0	25609	0	49	40213314		
8231	177	40213160	1966-08-01	1966-08-01 00:00:00	1966-08-01	1966-08-01 00:00:00	1966-08-01	581452		0	0	0		0	0	0	11962	0	10	40213160		
525	38	1127078	1966-10-02	1966-10-02 00:00:00	1966-10-16	1966-10-16 00:00:00	1966-10-16	38000177		0	0	14		0	0	0	2685	0	282464	1127078		
578	42	1713671	1980-08-10	1980-08-10 00:00:00	1980-08-17	1980-08-17 00:00:00	1980-08-17	38000177		0	0	7		0	0	0	3056	0	562251	1713671		
55692	4625	40229134	1976-10-23	1976-10-23 00:00:00	1976-10-30	1976-10-30 00:00:00	1976-10-30	38000177		0	0	7		0	0	0	308092	0	1043400	40229134		
55711	4626	1594382	1997-11-21	1997-11-21 00:00:00	1997-11-21	1997-11-21 00:00:00	\N	38000177		0	0	0		0	0	0	308259	0	1870230	1594382		
30112	2497	40229134	1964-01-20	1964-01-20 00:00:00	1964-01-27	1964-01-27 00:00:00	1964-01-27	38000177		0	0	7		0	0	0	165359	0	1043400	40229134		
21495	1766	1713671	2001-07-31	2001-07-31 00:00:00	2001-08-07	2001-08-07 00:00:00	2001-08-07	38000177		0	0	7		0	0	0	118148	0	562251	1713671		
48610	4026	1127433	2003-01-20	2003-01-20 00:00:00	2003-01-27	2003-01-27 00:00:00	2003-01-27	38000177		0	0	7		0	0	0	267713	0	313782	1127433		
28974	2395	19133873	1975-05-03	1975-05-03 00:00:00	1975-05-13	1975-05-13 00:00:00	1975-05-13	38000177		0	0	10		0	0	0	159219	0	834061	19133873		
54091	4496	19006318	1949-01-01	1949-01-01 00:00:00	1949-01-15	1949-01-15 00:00:00	1949-01-15	38000177		0	0	14		0	0	0	299258	0	105078	19006318		
3704	307	19078461	2004-12-13	2004-12-13 00:00:00	2005-01-12	2005-01-12 00:00:00	2005-01-12	38000177		0	0	30		0	0	0	20398	0	310965	19078461		
215704	4731	40213306	1994-04-12	1994-04-12 00:00:00	1994-04-12	1994-04-12 00:00:00	1994-04-12	581452		0	0	0		0	0	0	315170	0	43	40213306		
237295	5210	40213227	1993-12-28	1993-12-28 00:00:00	1993-12-28	1993-12-28 00:00:00	1993-12-28	581452		0	0	0		0	0	0	346504	0	113	40213227		
39633	3278	1127433	1988-08-20	1988-08-20 00:00:00	1988-09-03	1988-09-03 00:00:00	1988-09-03	38000177		0	0	14		0	0	0	217779	0	313782	1127433		
190998	4197	40213180	2007-11-18	2007-11-18 00:00:00	2007-11-18	2007-11-18 00:00:00	2007-11-18	581452		0	0	0		0	0	0	278530	0	114	40213180		
50184	4165	1713671	1946-03-20	1946-03-20 00:00:00	1946-03-27	1946-03-27 00:00:00	1946-03-27	38000177		0	0	7		0	0	0	276743	0	562251	1713671		
15419	1285	19074841	1989-08-20	1989-08-20 00:00:00	1989-09-10	1989-09-10 00:00:00	1989-09-10	38000177		0	0	21		0	0	0	84926	0	309043	19074841		
32571	710	40213160	1961-07-25	1961-07-25 00:00:00	1961-07-25	1961-07-25 00:00:00	1961-07-25	581452		0	0	0		0	0	0	47047	0	10	40213160		
39689	3283	1127078	1981-02-28	1981-02-28 00:00:00	1981-05-29	1981-05-29 00:00:00	1981-05-29	38000177		0	0	90		0	0	0	218106	0	282464	1127078		
188292	4134	40213227	2000-07-09	2000-07-09 00:00:00	2000-07-09	2000-07-09 00:00:00	2000-07-09	581452		0	0	0		0	0	0	274903	0	113	40213227		
39787	3290	1115171	2017-12-05	2017-12-05 00:00:00	2017-12-19	2017-12-19 00:00:00	2017-12-19	38000177		0	0	14		0	0	0	218621	0	849574	1115171		
231154	5079	40213296	2009-11-29	2009-11-29 00:00:00	2009-11-29	2009-11-29 00:00:00	2009-11-29	581452		0	0	0		0	0	0	337696	0	52	40213296		
31512	2613	19133873	1960-09-17	1960-09-17 00:00:00	1960-09-24	1960-09-24 00:00:00	1960-09-24	38000177		0	0	7		0	0	0	172752	0	834061	19133873		
160830	3539	40213314	1981-03-20	1981-03-20 00:00:00	1981-03-20	1981-03-20 00:00:00	1981-03-20	581452		0	0	0		0	0	0	235085	0	49	40213314		
28610	2357	1127433	1957-09-26	1957-09-26 00:00:00	1957-10-10	1957-10-10 00:00:00	1957-10-10	38000177		0	0	14		0	0	0	157093	0	313782	1127433		
159646	3514	40213160	1974-11-25	1974-11-25 00:00:00	1974-11-25	1974-11-25 00:00:00	1974-11-25	581452		0	0	0		0	0	0	233177	0	10	40213160		
60946	5068	1127433	2007-11-06	2007-11-06 00:00:00	2008-02-04	2008-02-04 00:00:00	2008-02-04	38000177		0	0	90		0	0	0	336993	0	313782	1127433		
46305	3835	19073188	1984-10-06	1984-10-06 00:00:00	1984-10-27	1984-10-27 00:00:00	1984-10-27	38000177		0	0	21		0	0	0	254661	0	308192	19073188		
39229	3241	40220960	1990-08-16	1990-08-16 00:00:00	1990-08-16	1990-08-16 00:00:00	1990-08-16	38000177		0	0	0		0	0	0	215469	0	1804799	40220960		
56858	4719	40165015	2003-06-06	2003-06-06 00:00:00	2003-06-06	2003-06-06 00:00:00	\N	38000177		0	0	0		0	0	0	314298	0	861467	40165015		
39336	3248	40229134	2004-02-29	2004-02-29 00:00:00	2004-03-07	2004-03-07 00:00:00	2004-03-07	38000177		0	0	7		0	0	0	215922	0	1043400	40229134		
28024	2319	1713671	1964-06-26	1964-06-26 00:00:00	1964-07-10	1964-07-10 00:00:00	1964-07-10	38000177		0	0	14		0	0	0	154161	0	562251	1713671		
232984	5119	40213227	2004-10-12	2004-10-12 00:00:00	2004-10-12	2004-10-12 00:00:00	2004-10-12	581452		0	0	0		0	0	0	340338	0	113	40213227		
78033	1707	40213296	2010-08-16	2010-08-16 00:00:00	2010-08-16	2010-08-16 00:00:00	2010-08-16	581452		0	0	0		0	0	0	114121	0	52	40213296		
99201	2172	40213160	1979-01-13	1979-01-13 00:00:00	1979-01-13	1979-01-13 00:00:00	1979-01-13	581452		0	0	0		0	0	0	144695	0	10	40213160		
44635	3695	1367571	1996-03-20	1996-03-20 00:00:00	1996-03-20	1996-03-20 00:00:00	1996-03-20	38000177		0	0	0		0	0	0	245605	0	314659	19080464		
62608	5206	19133873	1981-12-21	1981-12-21 00:00:00	1982-01-02	1982-01-02 00:00:00	1982-01-02	38000177		0	0	12		0	0	0	346290	0	834061	19133873		
58006	4819	1713671	1969-12-17	1969-12-17 00:00:00	1969-12-24	1969-12-24 00:00:00	1969-12-24	38000177		0	0	7		0	0	0	320583	0	562251	1713671		
62725	5215	19059056	1973-10-17	1973-10-17 00:00:00	1973-11-07	1973-11-07 00:00:00	1973-11-07	38000177		0	0	21		0	0	0	346839	0	243670	19059056		
96182	2109	40213160	1970-08-02	1970-08-02 00:00:00	1970-08-02	1970-08-02 00:00:00	1970-08-02	581452		0	0	0		0	0	0	140428	0	10	40213160		
82020	1791	40213227	1996-06-27	1996-06-27 00:00:00	1996-06-27	1996-06-27 00:00:00	1996-06-27	581452		0	0	0		0	0	0	120112	0	113	40213227		
36408	795	40213227	2018-01-03	2018-01-03 00:00:00	2018-01-03	2018-01-03 00:00:00	2018-01-03	581452		0	0	0		0	0	0	52772	0	113	40213227		
140309	3081	40213227	1997-01-29	1997-01-29 00:00:00	1997-01-29	1997-01-29 00:00:00	1997-01-29	581452		0	0	0		0	0	0	205148	0	113	40213227		
43794	954	40213160	1974-07-21	1974-07-21 00:00:00	1974-07-21	1974-07-21 00:00:00	1974-07-21	581452		0	0	0		0	0	0	63387	0	10	40213160		
31611	2620	1713671	2005-02-18	2005-02-18 00:00:00	2005-03-04	2005-03-04 00:00:00	2005-03-04	38000177		0	0	14		0	0	0	173304	0	562251	1713671		
31671	2626	19129655	1966-07-03	1966-07-03 00:00:00	1966-07-17	1966-07-17 00:00:00	1966-07-17	38000177		0	0	14		0	0	0	173719	0	789980	19129655		
155495	3422	40213306	1990-09-24	1990-09-24 00:00:00	1990-09-24	1990-09-24 00:00:00	1990-09-24	581452		0	0	0		0	0	0	226973	0	43	40213306		
50609	4205	19077344	1995-01-02	1995-01-02 00:00:00	1995-01-02	1995-01-02 00:00:00	\N	38000177		0	0	0		0	0	0	279207	0	310325	19077344		
42283	3508	19078461	2019-05-02	2019-05-02 00:00:00	2019-05-02	2019-05-02 00:00:00	\N	38000177		0	0	0		0	0	0	232693	0	310965	19078461		
22559	1852	1127433	2011-09-05	2011-09-05 00:00:00	2011-09-26	2011-09-26 00:00:00	2011-09-26	38000177		0	0	21		0	0	0	123947	0	313782	1127433		
109821	2412	40213227	2001-06-01	2001-06-01 00:00:00	2001-06-01	2001-06-01 00:00:00	2001-06-01	581452		0	0	0		0	0	0	160088	0	113	40213227		
52873	4393	19128065	2000-05-04	2000-05-04 00:00:00	2001-04-29	2001-04-29 00:00:00	2001-04-29	38000177		0	0	360		0	0	0	292130	0	749882	19128065		
32649	2706	1127078	1973-01-16	1973-01-16 00:00:00	1973-02-15	1973-02-15 00:00:00	1973-02-15	38000177		0	0	30		0	0	0	179257	0	282464	1127078		
5026	419	19133905	1941-06-17	1941-06-17 00:00:00	1941-06-29	1941-06-29 00:00:00	1941-06-29	38000177		0	0	12		0	0	0	27687	0	834102	19133905		
228647	5022	40213296	2010-01-11	2010-01-11 00:00:00	2010-01-11	2010-01-11 00:00:00	2010-01-11	581452		0	0	0		0	0	0	333693	0	52	40213296		
124941	2749	40213296	2002-01-02	2002-01-02 00:00:00	2002-01-02	2002-01-02 00:00:00	2002-01-02	581452		0	0	0		0	0	0	181804	0	52	40213296		
158424	3488	40213198	2019-05-03	2019-05-03 00:00:00	2019-05-03	2019-05-03 00:00:00	2019-05-03	581452		0	0	0		0	0	0	231402	0	133	40213198		
6458	140	40213296	2009-06-11	2009-06-11 00:00:00	2009-06-11	2009-06-11 00:00:00	2009-06-11	581452		0	0	0		0	0	0	9341	0	52	40213296		
54377	4521	1127433	1992-09-23	1992-09-23 00:00:00	1992-10-07	1992-10-07 00:00:00	1992-10-07	38000177		0	0	14		0	0	0	301014	0	313782	1127433		
106857	2342	40213227	1997-10-03	1997-10-03 00:00:00	1997-10-03	1997-10-03 00:00:00	1997-10-03	581452		0	0	0		0	0	0	155894	0	113	40213227		
177137	3893	40213296	2013-10-25	2013-10-25 00:00:00	2013-10-25	2013-10-25 00:00:00	2013-10-25	581452		0	0	0		0	0	0	258854	0	52	40213296		
201277	4419	40213160	1955-11-28	1955-11-28 00:00:00	1955-11-28	1955-11-28 00:00:00	1955-11-28	581452		0	0	0		0	0	0	293823	0	10	40213160		
55362	4596	40229134	1958-11-14	1958-11-14 00:00:00	1958-11-21	1958-11-21 00:00:00	1958-11-21	38000177		0	0	7		0	0	0	306288	0	1043400	40229134		
18012	390	40213160	1975-07-16	1975-07-16 00:00:00	1975-07-16	1975-07-16 00:00:00	1975-07-16	581452		0	0	0		0	0	0	25634	0	10	40213160		
8233	177	40213227	2017-05-01	2017-05-01 00:00:00	2017-05-01	2017-05-01 00:00:00	2017-05-01	581452		0	0	0		0	0	0	11952	0	113	40213227		
526	38	1118084	2006-05-20	2006-05-20 00:00:00	2006-05-20	2006-05-20 00:00:00	\N	38000177		0	0	0		0	0	0	2720	0	00025152531	44923712		
579	42	1127433	1938-11-10	1938-11-10 00:00:00	1938-11-24	1938-11-24 00:00:00	1938-11-24	38000177		0	0	14		0	0	0	2995	0	313782	1127433		
55693	4625	40162522	1975-03-29	1975-03-29 00:00:00	1975-03-29	1975-03-29 00:00:00	\N	38000177		0	0	0		0	0	0	308129	0	857005	40162522		
55712	4626	1107882	1997-11-21	1997-11-21 00:00:00	1997-11-21	1997-11-21 00:00:00	\N	38000177		0	0	0		0	0	0	308259	0	311372	1107882		
30113	2497	1127433	1983-09-24	1983-09-24 00:00:00	1983-10-08	1983-10-08 00:00:00	1983-10-08	38000177		0	0	14		0	0	0	165350	0	313782	1127433		
21496	1766	1127433	1961-05-09	1961-05-09 00:00:00	1961-05-16	1961-05-16 00:00:00	1961-05-16	38000177		0	0	7		0	0	0	118174	0	313782	1127433		
48611	4026	40169281	2013-02-10	2013-02-10 00:00:00	2013-02-10	2013-02-10 00:00:00	\N	38000177		0	0	0		0	0	0	267656	0	896209	40169281		
28975	2395	19059056	1966-01-28	1966-01-28 00:00:00	1966-04-28	1966-04-28 00:00:00	1966-04-28	38000177		0	0	90		0	0	0	159237	0	243670	19059056		
54092	4496	19059056	1949-01-01	1949-01-01 00:00:00	1949-01-15	1949-01-15 00:00:00	1949-01-15	38000177		0	0	14		0	0	0	299258	0	243670	19059056		
230272	5060	40213314	1977-03-07	1977-03-07 00:00:00	1977-03-07	1977-03-07 00:00:00	1977-03-07	581452		0	0	0		0	0	0	336426	0	49	40213314		
215706	4731	40213227	2003-04-22	2003-04-22 00:00:00	2003-04-22	2003-04-22 00:00:00	2003-04-22	581452		0	0	0		0	0	0	315223	0	113	40213227		
237296	5210	40213306	1993-12-28	1993-12-28 00:00:00	1993-12-28	1993-12-28 00:00:00	1993-12-28	581452		0	0	0		0	0	0	346504	0	43	40213306		
39634	3278	19078461	2015-10-07	2015-10-07 00:00:00	2015-10-21	2015-10-21 00:00:00	2015-10-21	38000177		0	0	14		0	0	0	217748	0	310965	19078461		
190999	4197	40213160	1986-05-25	1986-05-25 00:00:00	1986-05-25	1986-05-25 00:00:00	1986-05-25	581452		0	0	0		0	0	0	278495	0	10	40213160		
50185	4165	1127433	1981-10-20	1981-10-20 00:00:00	1981-12-19	1981-12-19 00:00:00	1981-12-19	38000177		0	0	60		0	0	0	276831	0	313782	1127433		
15420	1285	1127433	2014-03-08	2014-03-08 00:00:00	2014-03-22	2014-03-22 00:00:00	2014-03-22	38000177		0	0	14		0	0	0	84977	0	313782	1127433		
32576	710	40213306	1984-02-28	1984-02-28 00:00:00	1984-02-28	1984-02-28 00:00:00	1984-02-28	581452		0	0	0		0	0	0	47009	0	43	40213306		
39690	3283	920300	2005-08-03	2005-08-03 00:00:00	2005-08-10	2005-08-10 00:00:00	2005-08-10	38000177		0	0	7		0	0	0	218110	0	311989	920300		
107484	2356	40213160	1982-10-13	1982-10-13 00:00:00	1982-10-13	1982-10-13 00:00:00	1982-10-13	581452		0	0	0		0	0	0	156920	0	10	40213160		
39788	3290	1127433	1985-01-18	1985-01-18 00:00:00	1985-02-01	1985-02-01 00:00:00	1985-02-01	38000177		0	0	14		0	0	0	218609	0	313782	1127433		
231156	5079	40213296	2007-11-25	2007-11-25 00:00:00	2007-11-25	2007-11-25 00:00:00	2007-11-25	581452		0	0	0		0	0	0	337711	0	52	40213296		
31513	2613	1127433	1990-11-19	1990-11-19 00:00:00	1990-12-03	1990-12-03 00:00:00	1990-12-03	38000177		0	0	14		0	0	0	172768	0	313782	1127433		
160831	3539	40213160	1981-03-20	1981-03-20 00:00:00	1981-03-20	1981-03-20 00:00:00	1981-03-20	581452		0	0	0		0	0	0	235085	0	10	40213160		
28611	2357	1127433	2005-01-25	2005-01-25 00:00:00	2005-02-01	2005-02-01 00:00:00	2005-02-01	38000177		0	0	7		0	0	0	156962	0	313782	1127433		
159649	3514	40213314	1977-01-24	1977-01-24 00:00:00	1977-01-24	1977-01-24 00:00:00	1977-01-24	581452		0	0	0		0	0	0	233172	0	49	40213314		
60947	5068	1127433	1966-06-16	1966-06-16 00:00:00	1966-06-30	1966-06-30 00:00:00	1966-06-30	38000177		0	0	14		0	0	0	336990	0	313782	1127433		
46306	3835	1127433	1984-10-06	1984-10-06 00:00:00	1984-10-27	1984-10-27 00:00:00	1984-10-27	38000177		0	0	21		0	0	0	254661	0	313782	1127433		
39230	3241	1127433	1992-09-10	1992-09-10 00:00:00	1992-09-24	1992-09-24 00:00:00	1992-09-24	38000177		0	0	14		0	0	0	215507	0	313782	1127433		
56859	4719	19078461	2003-06-06	2003-06-06 00:00:00	2003-06-20	2003-06-20 00:00:00	2003-06-20	38000177		0	0	14		0	0	0	314298	0	310965	19078461		
39337	3249	19133905	2000-06-19	2000-06-19 00:00:00	2000-06-27	2000-06-27 00:00:00	2000-06-27	38000177		0	0	8		0	0	0	216013	0	834102	19133905		
28025	2319	1713671	1976-08-03	1976-08-03 00:00:00	1976-08-10	1976-08-10 00:00:00	1976-08-10	38000177		0	0	7		0	0	0	154217	0	562251	1713671		
240656	5283	40213160	1977-08-16	1977-08-16 00:00:00	1977-08-16	1977-08-16 00:00:00	1977-08-16	581452		0	0	0		0	0	0	351445	0	10	40213160		
78039	1707	40213160	1970-11-16	1970-11-16 00:00:00	1970-11-16	1970-11-16 00:00:00	1970-11-16	581452		0	0	0		0	0	0	114151	0	10	40213160		
99213	2173	40213201	1996-10-08	1996-10-08 00:00:00	1996-10-08	1996-10-08 00:00:00	1996-10-08	581452		0	0	0		0	0	0	144735	0	33	40213201		
44636	3695	19079524	1996-03-20	1996-03-20 00:00:00	1996-03-21	1996-03-21 00:00:00	1996-03-21	38000177		0	0	1		0	0	0	245605	0	313002	19079524		
62609	5206	19059056	1982-08-16	1982-08-16 00:00:00	1982-08-30	1982-08-30 00:00:00	1982-08-30	38000177		0	0	14		0	0	0	346252	0	243670	19059056		
58007	4819	40229134	1982-01-26	1982-01-26 00:00:00	1982-02-02	1982-02-02 00:00:00	1982-02-02	38000177		0	0	7		0	0	0	320513	0	1043400	40229134		
62726	5215	1127433	2000-01-08	2000-01-08 00:00:00	2000-01-22	2000-01-22 00:00:00	2000-01-22	38000177		0	0	14		0	0	0	346824	0	313782	1127433		
96191	2109	40213160	1974-11-03	1974-11-03 00:00:00	1974-11-03	1974-11-03 00:00:00	1974-11-03	581452		0	0	0		0	0	0	140414	0	10	40213160		
82021	1791	40213296	1996-06-27	1996-06-27 00:00:00	1996-06-27	1996-06-27 00:00:00	1996-06-27	581452		0	0	0		0	0	0	120112	0	52	40213296		
36425	795	40213201	2002-10-09	2002-10-09 00:00:00	2002-10-09	2002-10-09 00:00:00	2002-10-09	581452		0	0	0		0	0	0	52767	0	33	40213201		
140327	3081	40213227	2017-05-24	2017-05-24 00:00:00	2017-05-24	2017-05-24 00:00:00	2017-05-24	581452		0	0	0		0	0	0	205153	0	113	40213227		
43800	954	40213160	1978-12-31	1978-12-31 00:00:00	1978-12-31	1978-12-31 00:00:00	1978-12-31	581452		0	0	0		0	0	0	\N	0	10	40213160		
31612	2620	1127433	2015-11-09	2015-11-09 00:00:00	2015-11-23	2015-11-23 00:00:00	2015-11-23	38000177		0	0	14		0	0	0	173278	0	313782	1127433		
31672	2626	1127433	1974-03-08	1974-03-08 00:00:00	1974-03-15	1974-03-15 00:00:00	1974-03-15	38000177		0	0	7		0	0	0	173711	0	313782	1127433		
155496	3422	40213160	1967-05-29	1967-05-29 00:00:00	1967-05-29	1967-05-29 00:00:00	1967-05-29	581452		0	0	0		0	0	0	227006	0	10	40213160		
50610	4205	1713671	1982-11-16	1982-11-16 00:00:00	1982-12-07	1982-12-07 00:00:00	1982-12-07	38000177		0	0	21		0	0	0	279155	0	562251	1713671		
42284	3508	40165015	2019-05-02	2019-05-02 00:00:00	2019-05-02	2019-05-02 00:00:00	\N	38000177		0	0	0		0	0	0	232693	0	861467	40165015		
22560	1852	19133873	1978-05-24	1978-05-24 00:00:00	1978-06-06	1978-06-06 00:00:00	1978-06-06	38000177		0	0	13		0	0	0	123894	0	834061	19133873		
52793	4387	1713671	1994-09-28	1994-09-28 00:00:00	1994-10-05	1994-10-05 00:00:00	1994-10-05	38000177		0	0	7		0	0	0	291590	0	562251	1713671		
52874	4393	1713671	2004-05-07	2004-05-07 00:00:00	2004-05-28	2004-05-28 00:00:00	2004-05-28	38000177		0	0	21		0	0	0	292105	0	562251	1713671		
32650	2706	1127078	1964-07-02	1964-07-02 00:00:00	1964-07-16	1964-07-16 00:00:00	1964-07-16	38000177		0	0	14		0	0	0	179265	0	282464	1127078		
5027	419	1127433	1922-10-31	1922-10-31 00:00:00	1922-11-07	1922-11-07 00:00:00	1922-11-07	38000177		0	0	7		0	0	0	27750	0	313782	1127433		
228649	5022	40213227	2010-01-11	2010-01-11 00:00:00	2010-01-11	2010-01-11 00:00:00	2010-01-11	581452		0	0	0		0	0	0	333693	0	113	40213227		
136233	2991	40213160	1960-11-11	1960-11-11 00:00:00	1960-11-11	1960-11-11 00:00:00	1960-11-11	581452		0	0	0		0	0	0	199646	0	10	40213160		
158431	3488	40213160	1955-04-29	1955-04-29 00:00:00	1955-04-29	1955-04-29 00:00:00	1955-04-29	581452		0	0	0		0	0	0	231349	0	10	40213160		
6459	140	40213160	1969-11-13	1969-11-13 00:00:00	1969-11-13	1969-11-13 00:00:00	1969-11-13	581452		0	0	0		0	0	0	9347	0	10	40213160		
54378	4521	19075601	1997-05-22	1997-05-22 00:00:00	1997-05-22	1997-05-22 00:00:00	\N	38000177		0	0	0		0	0	0	301076	0	309362	19075601		
106858	2342	40213306	1997-10-03	1997-10-03 00:00:00	1997-10-03	1997-10-03 00:00:00	1997-10-03	581452		0	0	0		0	0	0	155894	0	43	40213306		
177138	3893	40213296	2011-10-21	2011-10-21 00:00:00	2011-10-21	2011-10-21 00:00:00	2011-10-21	581452		0	0	0		0	0	0	258875	0	52	40213296		
80654	1764	40213160	1959-12-10	1959-12-10 00:00:00	1959-12-10	1959-12-10 00:00:00	1959-12-10	581452		0	0	0		0	0	0	117985	0	10	40213160		
55363	4596	19059056	1971-03-24	1971-03-24 00:00:00	1971-04-14	1971-04-14 00:00:00	1971-04-14	38000177		0	0	21		0	0	0	306269	0	243670	19059056		
18014	390	40213160	1975-10-15	1975-10-15 00:00:00	1975-10-15	1975-10-15 00:00:00	1975-10-15	581452		0	0	0		0	0	0	25620	0	10	40213160		
8234	177	40213260	2017-05-01	2017-05-01 00:00:00	2017-05-01	2017-05-01 00:00:00	2017-05-01	581452		0	0	0		0	0	0	11952	0	121	40213260		
527	38	1127433	1966-08-05	1966-08-05 00:00:00	1966-08-19	1966-08-19 00:00:00	1966-08-19	38000177		0	0	14		0	0	0	2745	0	313782	1127433		
580	42	1713671	2008-02-22	2008-02-22 00:00:00	2008-02-29	2008-02-29 00:00:00	2008-02-29	38000177		0	0	7		0	0	0	3137	0	562251	1713671		
55694	4625	1127433	1975-03-29	1975-03-29 00:00:00	1975-06-27	1975-06-27 00:00:00	1975-06-27	38000177		0	0	90		0	0	0	308129	0	313782	1127433		
55713	4626	1127078	1977-02-25	1977-02-25 00:00:00	1977-03-11	1977-03-11 00:00:00	1977-03-11	38000177		0	0	14		0	0	0	308226	0	282464	1127078		
30114	2497	19006318	1963-03-24	1963-03-24 00:00:00	1963-04-07	1963-04-07 00:00:00	1963-04-07	38000177		0	0	14		0	0	0	165322	0	105078	19006318		
21497	1766	19133873	1958-10-10	1958-10-10 00:00:00	1958-10-19	1958-10-19 00:00:00	1958-10-19	38000177		0	0	9		0	0	0	118173	0	834061	19133873		
48612	4026	1713671	1960-07-19	1960-07-19 00:00:00	1960-08-09	1960-08-09 00:00:00	1960-08-09	38000177		0	0	21		0	0	0	267657	0	562251	1713671		
28976	2396	1124300	1961-08-30	1961-08-30 00:00:00	1961-08-30	1961-08-30 00:00:00	\N	38000177		0	0	0		0	0	0	159369	0	00781178901	45011828		
122042	2682	40213296	2014-07-25	2014-07-25 00:00:00	2014-07-25	2014-07-25 00:00:00	2014-07-25	581452		0	0	0		0	0	0	\N	0	52	40213296		
230274	5060	40213160	1977-03-07	1977-03-07 00:00:00	1977-03-07	1977-03-07 00:00:00	1977-03-07	581452		0	0	0		0	0	0	336426	0	10	40213160		
215710	4731	40213160	1972-07-11	1972-07-11 00:00:00	1972-07-11	1972-07-11 00:00:00	1972-07-11	581452		0	0	0		0	0	0	315184	0	10	40213160		
183312	4027	40213227	1997-05-10	1997-05-10 00:00:00	1997-05-10	1997-05-10 00:00:00	1997-05-10	581452		0	0	0		0	0	0	267916	0	113	40213227		
39635	3278	40165015	1977-02-02	1977-02-02 00:00:00	1977-02-02	1977-02-02 00:00:00	\N	38000177		0	0	0		0	0	0	217745	0	861467	40165015		
191006	4197	40213314	1986-11-23	1986-11-23 00:00:00	1986-11-23	1986-11-23 00:00:00	1986-11-23	581452		0	0	0		0	0	0	278505	0	49	40213314		
50186	4165	40231925	1981-10-20	1981-10-20 00:00:00	1981-10-20	1981-10-20 00:00:00	\N	38000177		0	0	0		0	0	0	276831	0	1049221	40231925		
15421	1285	1713671	1983-06-23	1983-06-23 00:00:00	1983-07-07	1983-07-07 00:00:00	1983-07-07	38000177		0	0	14		0	0	0	84933	0	562251	1713671		
43860	956	40213227	2007-05-09	2007-05-09 00:00:00	2007-05-09	2007-05-09 00:00:00	2007-05-09	581452		0	0	0		0	0	0	63499	0	113	40213227		
39691	3283	40236824	2005-08-03	2005-08-03 00:00:00	2005-08-17	2005-08-17 00:00:00	2005-08-17	38000177		0	0	14		0	0	0	218110	0	1094107	40236824		
107485	2356	40213314	1978-02-08	1978-02-08 00:00:00	1978-02-08	1978-02-08 00:00:00	1978-02-08	581452		0	0	0		0	0	0	156888	0	49	40213314		
39789	3290	1127433	1970-03-29	1970-03-29 00:00:00	1970-04-05	1970-04-05 00:00:00	1970-04-05	38000177		0	0	7		0	0	0	218548	0	313782	1127433		
231160	5079	40213160	1967-08-20	1967-08-20 00:00:00	1967-08-20	1967-08-20 00:00:00	1967-08-20	581452		0	0	0		0	0	0	337717	0	10	40213160		
31514	2613	1127433	1974-10-14	1974-10-14 00:00:00	1974-11-04	1974-11-04 00:00:00	1974-11-04	38000177		0	0	21		0	0	0	172817	0	313782	1127433		
14596	316	40213227	2019-04-23	2019-04-23 00:00:00	2019-04-23	2019-04-23 00:00:00	2019-04-23	581452		0	0	0		0	0	0	20971	0	113	40213227		
28612	2357	19133905	1977-07-30	1977-07-30 00:00:00	1977-08-10	1977-08-10 00:00:00	1977-08-10	38000177		0	0	11		0	0	0	156935	0	834102	19133905		
159651	3514	40213227	2005-10-24	2005-10-24 00:00:00	2005-10-24	2005-10-24 00:00:00	2005-10-24	581452		0	0	0		0	0	0	233207	0	113	40213227		
60948	5068	1127433	1975-07-19	1975-07-19 00:00:00	1975-08-02	1975-08-02 00:00:00	1975-08-02	38000177		0	0	14		0	0	0	336948	0	313782	1127433		
46307	3835	40162522	1984-10-06	1984-10-06 00:00:00	1984-10-06	1984-10-06 00:00:00	\N	38000177		0	0	0		0	0	0	254661	0	857005	40162522		
39231	3241	1127433	1976-09-07	1976-09-07 00:00:00	1976-10-12	1976-10-12 00:00:00	1976-10-12	38000177		0	0	35		0	0	0	215441	0	313782	1127433		
56860	4719	19078461	2013-12-24	2013-12-24 00:00:00	2014-01-07	2014-01-07 00:00:00	2014-01-07	38000177		0	0	14		0	0	0	314299	0	310965	19078461		
39338	3249	19059056	1957-08-13	1957-08-13 00:00:00	1957-08-27	1957-08-27 00:00:00	1957-08-27	38000177		0	0	14		0	0	0	216022	0	243670	19059056		
28028	2319	40173590	2017-10-14	2017-10-14 00:00:00	2017-10-14	2017-10-14 00:00:00	\N	38000177		0	0	0		0	0	0	154146	0	904419	40173590		
190735	4190	40213227	2004-06-13	2004-06-13 00:00:00	2004-06-13	2004-06-13 00:00:00	2004-06-13	581452		0	0	0		0	0	0	278108	0	113	40213227		
89330	1958	40213227	2013-03-26	2013-03-26 00:00:00	2013-03-26	2013-03-26 00:00:00	2013-03-26	581452		0	0	0		0	0	0	130287	0	113	40213227		
99229	2173	40213227	2001-11-06	2001-11-06 00:00:00	2001-11-06	2001-11-06 00:00:00	2001-11-06	581452		0	0	0		0	0	0	144767	0	113	40213227		
44637	3695	35605858	1996-03-20	1996-03-20 00:00:00	1996-03-20	1996-03-20 00:00:00	1996-03-20	38000177		0	0	0		0	0	0	245605	0	1732136	35605858		
62610	5206	19133905	1999-06-23	1999-06-23 00:00:00	1999-07-04	1999-07-04 00:00:00	1999-07-04	38000177		0	0	11		0	0	0	346258	0	834102	19133905		
58008	4819	1127433	1976-09-22	1976-09-22 00:00:00	1976-11-21	1976-11-21 00:00:00	1976-11-21	38000177		0	0	60		0	0	0	320545	0	313782	1127433		
62727	5215	1115171	2004-03-30	2004-03-30 00:00:00	2004-05-29	2004-05-29 00:00:00	2004-05-29	38000177		0	0	60		0	0	0	346922	0	849574	1115171		
96197	2109	40213227	2011-12-04	2011-12-04 00:00:00	2011-12-04	2011-12-04 00:00:00	2011-12-04	581452		0	0	0		0	0	0	140416	0	113	40213227		
82026	1791	40213260	2007-07-26	2007-07-26 00:00:00	2007-07-26	2007-07-26 00:00:00	2007-07-26	581452		0	0	0		0	0	0	120032	0	121	40213260		
36432	795	40213227	2007-11-07	2007-11-07 00:00:00	2007-11-07	2007-11-07 00:00:00	2007-11-07	581452		0	0	0		0	0	0	52786	0	113	40213227		
140335	3081	40213227	2007-03-28	2007-03-28 00:00:00	2007-03-28	2007-03-28 00:00:00	2007-03-28	581452		0	0	0		0	0	0	205110	0	113	40213227		
43802	954	40213296	2014-04-20	2014-04-20 00:00:00	2014-04-20	2014-04-20 00:00:00	2014-04-20	581452		0	0	0		0	0	0	63415	0	52	40213296		
31613	2621	40165015	1999-06-17	1999-06-17 00:00:00	1999-06-17	1999-06-17 00:00:00	\N	38000177		0	0	0		0	0	0	173403	0	861467	40165015		
31673	2626	1713671	1986-07-03	1986-07-03 00:00:00	1986-07-10	1986-07-10 00:00:00	1986-07-10	38000177		0	0	7		0	0	0	173731	0	562251	1713671		
155498	3422	40213296	2010-09-06	2010-09-06 00:00:00	2010-09-06	2010-09-06 00:00:00	2010-09-06	581452		0	0	0		0	0	0	226976	0	52	40213296		
50611	4205	1118084	2011-01-13	2011-01-13 00:00:00	2011-01-13	2011-01-13 00:00:00	\N	38000177		0	0	0		0	0	0	279251	0	00025152531	44923712		
42285	3508	1127433	1996-03-21	1996-03-21 00:00:00	1996-03-28	1996-03-28 00:00:00	1996-03-28	38000177		0	0	7		0	0	0	232625	0	313782	1127433		
22561	1852	19019979	1976-09-25	1976-09-25 00:00:00	1976-10-09	1976-10-09 00:00:00	1976-10-09	38000177		0	0	14		0	0	0	123867	0	198405	19019979		
52794	4387	1118084	2007-11-24	2007-11-24 00:00:00	2007-11-24	2007-11-24 00:00:00	\N	38000177		0	0	0		0	0	0	291617	0	00025152531	44923712		
52875	4393	1127078	1987-10-30	1987-10-30 00:00:00	1988-01-28	1988-01-28 00:00:00	1988-01-28	38000177		0	0	90		0	0	0	292101	0	282464	1127078		
32651	2706	19129655	1964-07-02	1964-07-02 00:00:00	1964-07-16	1964-07-16 00:00:00	1964-07-16	38000177		0	0	14		0	0	0	179265	0	789980	19129655		
5028	419	1127433	1943-02-22	1943-02-22 00:00:00	1943-03-01	1943-03-01 00:00:00	1943-03-01	38000177		0	0	7		0	0	0	27752	0	313782	1127433		
156505	3444	40213227	1999-12-06	1999-12-06 00:00:00	1999-12-06	1999-12-06 00:00:00	1999-12-06	581452		0	0	0		0	0	0	228572	0	113	40213227		
136241	2991	40213296	2003-05-09	2003-05-09 00:00:00	2003-05-09	2003-05-09 00:00:00	2003-05-09	581452		0	0	0		0	0	0	199656	0	52	40213296		
158432	3488	40213296	1996-01-26	1996-01-26 00:00:00	1996-01-26	1996-01-26 00:00:00	1996-01-26	581452		0	0	0		0	0	0	231397	0	52	40213296		
6468	141	40213160	1984-08-07	1984-08-07 00:00:00	1984-08-07	1984-08-07 00:00:00	1984-08-07	581452		0	0	0		0	0	0	9456	0	10	40213160		
195679	4299	40213160	1978-01-22	1978-01-22 00:00:00	1978-01-22	1978-01-22 00:00:00	1978-01-22	581452		0	0	0		0	0	0	285238	0	10	40213160		
201197	4418	40213227	2013-03-01	2013-03-01 00:00:00	2013-03-01	2013-03-01 00:00:00	2013-03-01	581452		0	0	0		0	0	0	293792	0	113	40213227		
177142	3893	40213306	1994-07-22	1994-07-22 00:00:00	1994-07-22	1994-07-22 00:00:00	1994-07-22	581452		0	0	0		0	0	0	258839	0	43	40213306		
80665	1764	40213160	1960-02-11	1960-02-11 00:00:00	1960-02-11	1960-02-11 00:00:00	1960-02-11	581452		0	0	0		0	0	0	117950	0	10	40213160		
55364	4596	1127433	1988-01-15	1988-01-15 00:00:00	1988-01-29	1988-01-29 00:00:00	1988-01-29	38000177		0	0	14		0	0	0	306322	0	313782	1127433		
18017	390	40213296	2017-05-31	2017-05-31 00:00:00	2017-05-31	2017-05-31 00:00:00	2017-05-31	581452		0	0	0		0	0	0	25611	0	52	40213296		
89068	1953	40213260	2006-09-11	2006-09-11 00:00:00	2006-09-11	2006-09-11 00:00:00	2006-09-11	581452		0	0	0		0	0	0	129893	0	121	40213260		
529	38	1713671	1973-09-30	1973-09-30 00:00:00	1973-10-14	1973-10-14 00:00:00	1973-10-14	38000177		0	0	14		0	0	0	2723	0	562251	1713671		
581	42	19059056	1922-01-28	1922-01-28 00:00:00	1922-02-18	1922-02-18 00:00:00	1922-02-18	38000177		0	0	21		0	0	0	3110	0	243670	19059056		
55695	4625	1127078	1964-01-28	1964-01-28 00:00:00	1964-02-11	1964-02-11 00:00:00	1964-02-11	38000177		0	0	14		0	0	0	308126	0	282464	1127078		
55714	4626	1127078	1981-08-28	1981-08-28 00:00:00	1981-09-11	1981-09-11 00:00:00	1981-09-11	38000177		0	0	14		0	0	0	308228	0	282464	1127078		
30115	2497	19059056	1963-03-24	1963-03-24 00:00:00	1963-04-07	1963-04-07 00:00:00	1963-04-07	38000177		0	0	14		0	0	0	165322	0	243670	19059056		
21498	1766	1713671	1970-02-10	1970-02-10 00:00:00	1970-03-03	1970-03-03 00:00:00	1970-03-03	38000177		0	0	21		0	0	0	118176	0	562251	1713671		
48613	4026	19059056	1960-10-12	1960-10-12 00:00:00	1960-10-26	1960-10-26 00:00:00	1960-10-26	38000177		0	0	14		0	0	0	267628	0	243670	19059056		
28977	2396	1332419	1994-03-02	1994-03-02 00:00:00	1994-03-02	1994-03-02 00:00:00	\N	38000177		0	0	0		0	0	0	159367	0	197361	1332419		
122047	2682	40213160	1974-02-22	1974-02-22 00:00:00	1974-02-22	1974-02-22 00:00:00	1974-02-22	581452		0	0	0		0	0	0	177761	0	10	40213160		
230278	5060	40213227	2003-06-09	2003-06-09 00:00:00	2003-06-09	2003-06-09 00:00:00	2003-06-09	581452		0	0	0		0	0	0	336433	0	113	40213227		
215715	4731	40213296	2011-11-08	2011-11-08 00:00:00	2011-11-08	2011-11-08 00:00:00	2011-11-08	581452		0	0	0		0	0	0	315172	0	52	40213296		
183313	4027	40213306	1997-05-10	1997-05-10 00:00:00	1997-05-10	1997-05-10 00:00:00	1997-05-10	581452		0	0	0		0	0	0	267916	0	43	40213306		
39636	3278	19078461	1977-02-02	1977-02-02 00:00:00	1977-03-04	1977-03-04 00:00:00	1977-03-04	38000177		0	0	30		0	0	0	217745	0	310965	19078461		
191007	4197	40213251	1986-11-23	1986-11-23 00:00:00	1986-11-23	1986-11-23 00:00:00	1986-11-23	581452		0	0	0		0	0	0	278505	0	21	40213251		
50187	4165	19059056	1917-12-13	1917-12-13 00:00:00	1918-01-03	1918-01-03 00:00:00	1918-01-03	38000177		0	0	21		0	0	0	276829	0	243670	19059056		
191089	4199	40213201	2004-08-05	2004-08-05 00:00:00	2004-08-05	2004-08-05 00:00:00	2004-08-05	581452		0	0	0		0	0	0	278636	0	33	40213201		
43862	956	40213201	2002-04-10	2002-04-10 00:00:00	2002-04-10	2002-04-10 00:00:00	2002-04-10	581452		0	0	0		0	0	0	63466	0	33	40213201		
39692	3283	19128065	1992-07-10	1992-07-10 00:00:00	1993-07-05	1993-07-05 00:00:00	1993-07-05	38000177		0	0	360		0	0	0	218128	0	749882	19128065		
107486	2356	40213160	1978-02-08	1978-02-08 00:00:00	1978-02-08	1978-02-08 00:00:00	1978-02-08	581452		0	0	0		0	0	0	156888	0	10	40213160		
39794	3293	1127433	1975-11-11	1975-11-11 00:00:00	1975-12-16	1975-12-16 00:00:00	1975-12-16	38000177		0	0	35		0	0	0	218666	0	313782	1127433		
231164	5079	40213227	2017-12-24	2017-12-24 00:00:00	2017-12-24	2017-12-24 00:00:00	2017-12-24	581452		0	0	0		0	0	0	337713	0	113	40213227		
31515	2613	19007333	2016-04-27	2016-04-27 00:00:00	2016-04-27	2016-04-27 00:00:00	\N	38000177		0	0	0		0	0	0	172751	0	105586	19007333		
14606	316	40213227	2009-06-02	2009-06-02 00:00:00	2009-06-02	2009-06-02 00:00:00	2009-06-02	581452		0	0	0		0	0	0	20950	0	113	40213227		
55460	1214	40213227	2011-09-15	2011-09-15 00:00:00	2011-09-15	2011-09-15 00:00:00	2011-09-15	581452		0	0	0		0	0	0	79943	0	113	40213227		
159655	3514	40213296	2014-08-25	2014-08-25 00:00:00	2014-08-25	2014-08-25 00:00:00	2014-08-25	581452		0	0	0		0	0	0	233194	0	52	40213296		
60949	5068	40220960	2009-07-11	2009-07-11 00:00:00	2009-07-11	2009-07-11 00:00:00	2009-07-11	38000177		0	0	0		0	0	0	336974	0	1804799	40220960		
46308	3836	1127433	2007-10-22	2007-10-22 00:00:00	2007-10-29	2007-10-29 00:00:00	2007-10-29	38000177		0	0	7		0	0	0	254709	0	313782	1127433		
39232	3241	1118084	1998-08-08	1998-08-08 00:00:00	1998-08-08	1998-08-08 00:00:00	\N	38000177		0	0	0		0	0	0	215512	0	00025152531	44923712		
56861	4719	1713671	1945-03-04	1945-03-04 00:00:00	1945-04-22	1945-04-22 00:00:00	1945-04-22	38000177		0	0	49		0	0	0	314233	0	562251	1713671		
39339	3249	19006318	1957-08-13	1957-08-13 00:00:00	1957-08-27	1957-08-27 00:00:00	1957-08-27	38000177		0	0	14		0	0	0	216022	0	105078	19006318		
28029	2319	1127433	1986-10-21	1986-10-21 00:00:00	1986-11-11	1986-11-11 00:00:00	1986-11-11	38000177		0	0	21		0	0	0	154137	0	313782	1127433		
190736	4190	40213296	2012-08-05	2012-08-05 00:00:00	2012-08-05	2012-08-05 00:00:00	2012-08-05	581452		0	0	0		0	0	0	278111	0	52	40213296		
89331	1958	40213296	2013-03-26	2013-03-26 00:00:00	2013-03-26	2013-03-26 00:00:00	2013-03-26	581452		0	0	0		0	0	0	130287	0	52	40213296		
81687	1785	40213296	1996-11-11	1996-11-11 00:00:00	1996-11-11	1996-11-11 00:00:00	1996-11-11	581452		0	0	0		0	0	0	119632	0	52	40213296		
44638	3695	42707627	1996-03-20	1996-03-20 00:00:00	1996-03-20	1996-03-20 00:00:00	1996-03-20	38000177		0	0	0		0	0	0	245605	0	1234995	42707627		
62611	5206	19073183	1980-07-27	1980-07-27 00:00:00	1980-08-10	1980-08-10 00:00:00	1980-08-10	38000177		0	0	14		0	0	0	346272	0	308182	19073183		
58009	4819	40231925	1976-09-22	1976-09-22 00:00:00	1976-09-22	1976-09-22 00:00:00	\N	38000177		0	0	0		0	0	0	320545	0	1049221	40231925		
62728	5215	1127433	1970-02-05	1970-02-05 00:00:00	1970-04-06	1970-04-06 00:00:00	1970-04-06	38000177		0	0	60		0	0	0	346838	0	313782	1127433		
96198	2109	40213296	2011-12-04	2011-12-04 00:00:00	2011-12-04	2011-12-04 00:00:00	2011-12-04	581452		0	0	0		0	0	0	140416	0	52	40213296		
134106	2944	40213260	2010-01-31	2010-01-31 00:00:00	2010-01-31	2010-01-31 00:00:00	2010-01-31	581452		0	0	0		0	0	0	196442	0	121	40213260		
36448	795	40213227	1998-08-12	1998-08-12 00:00:00	1998-08-12	1998-08-12 00:00:00	1998-08-12	581452		0	0	0		0	0	0	52783	0	113	40213227		
151619	3335	40213296	2012-04-01	2012-04-01 00:00:00	2012-04-01	2012-04-01 00:00:00	2012-04-01	581452		0	0	0		0	0	0	221262	0	52	40213296		
149880	3296	40213227	1998-04-24	1998-04-24 00:00:00	1998-04-24	1998-04-24 00:00:00	1998-04-24	581452		0	0	0		0	0	0	219080	0	113	40213227		
31614	2621	19059056	1983-07-08	1983-07-08 00:00:00	1983-07-29	1983-07-29 00:00:00	1983-07-29	38000177		0	0	21		0	0	0	173400	0	243670	19059056		
31674	2626	19133873	1968-11-03	1968-11-03 00:00:00	1968-11-15	1968-11-15 00:00:00	1968-11-15	38000177		0	0	12		0	0	0	173706	0	834061	19133873		
155501	3422	40213260	2016-12-19	2016-12-19 00:00:00	2016-12-19	2016-12-19 00:00:00	2016-12-19	581452		0	0	0		0	0	0	226969	0	121	40213260		
50612	4205	1127433	2003-04-26	2003-04-26 00:00:00	2003-05-10	2003-05-10 00:00:00	2003-05-10	38000177		0	0	14		0	0	0	279209	0	313782	1127433		
42286	3508	1127433	2013-03-10	2013-03-10 00:00:00	2013-03-17	2013-03-17 00:00:00	2013-03-17	38000177		0	0	7		0	0	0	232627	0	313782	1127433		
22562	1852	46233988	1976-09-25	1976-09-25 00:00:00	1976-10-09	1976-10-09 00:00:00	1976-10-09	38000177		0	0	14		0	0	0	123867	0	1652673	46233988		
52795	4387	19133905	1985-05-20	1985-05-20 00:00:00	1985-05-30	1985-05-30 00:00:00	1985-05-30	38000177		0	0	10		0	0	0	291608	0	834102	19133905		
52876	4393	40165015	2016-08-28	2016-08-28 00:00:00	2016-08-28	2016-08-28 00:00:00	\N	38000177		0	0	0		0	0	0	292102	0	861467	40165015		
32652	2706	19133873	1973-02-14	1973-02-14 00:00:00	1973-02-23	1973-02-23 00:00:00	1973-02-23	38000177		0	0	9		0	0	0	179289	0	834061	19133873		
5029	419	40220960	1994-07-31	1994-07-31 00:00:00	1994-07-31	1994-07-31 00:00:00	1994-07-31	38000177		0	0	0		0	0	0	27775	0	1804799	40220960		
156522	3444	40213227	1992-10-26	1992-10-26 00:00:00	1992-10-26	1992-10-26 00:00:00	1992-10-26	581452		0	0	0		0	0	0	228571	0	113	40213227		
136248	2991	40213260	2010-05-28	2010-05-28 00:00:00	2010-05-28	2010-05-28 00:00:00	2010-05-28	581452		0	0	0		0	0	0	199682	0	121	40213260		
158434	3488	40213227	1996-01-26	1996-01-26 00:00:00	1996-01-26	1996-01-26 00:00:00	1996-01-26	581452		0	0	0		0	0	0	231397	0	113	40213227		
6469	141	40213314	1984-08-07	1984-08-07 00:00:00	1984-08-07	1984-08-07 00:00:00	1984-08-07	581452		0	0	0		0	0	0	9456	0	49	40213314		
195684	4299	40213314	1977-01-16	1977-01-16 00:00:00	1977-01-16	1977-01-16 00:00:00	1977-01-16	581452		0	0	0		0	0	0	285289	0	49	40213314		
201198	4418	40213160	1956-07-06	1956-07-06 00:00:00	1956-07-06	1956-07-06 00:00:00	1956-07-06	581452		0	0	0		0	0	0	293727	0	10	40213160		
177146	3893	40213160	1972-03-24	1972-03-24 00:00:00	1972-03-24	1972-03-24 00:00:00	1972-03-24	581452		0	0	0		0	0	0	258863	0	10	40213160		
80668	1764	40213260	2009-09-03	2009-09-03 00:00:00	2009-09-03	2009-09-03 00:00:00	2009-09-03	581452		0	0	0		0	0	0	117960	0	121	40213260		
55365	4596	19133873	1951-11-09	1951-11-09 00:00:00	1951-11-17	1951-11-17 00:00:00	1951-11-17	38000177		0	0	8		0	0	0	306260	0	834061	19133873		
18019	390	40213227	2017-05-31	2017-05-31 00:00:00	2017-05-31	2017-05-31 00:00:00	2017-05-31	581452		0	0	0		0	0	0	25611	0	113	40213227		
89071	1953	40213160	1955-01-17	1955-01-17 00:00:00	1955-01-17	1955-01-17 00:00:00	1955-01-17	581452		0	0	0		0	0	0	129912	0	10	40213160		
530	38	1127433	1981-09-29	1981-09-29 00:00:00	1981-10-13	1981-10-13 00:00:00	1981-10-13	38000177		0	0	14		0	0	0	2725	0	313782	1127433		
582	42	19059056	1970-06-04	1970-06-04 00:00:00	1970-07-04	1970-07-04 00:00:00	1970-07-04	38000177		0	0	30		0	0	0	3106	0	243670	19059056		
55696	4625	1118084	2001-10-25	2001-10-25 00:00:00	2001-10-25	2001-10-25 00:00:00	\N	38000177		0	0	0		0	0	0	308140	0	00025152531	44923712		
55715	4626	46233988	1981-08-28	1981-08-28 00:00:00	1981-09-11	1981-09-11 00:00:00	1981-09-11	38000177		0	0	14		0	0	0	308228	0	1652673	46233988		
30116	2497	1118084	2006-06-06	2006-06-06 00:00:00	2006-06-06	2006-06-06 00:00:00	\N	38000177		0	0	0		0	0	0	165351	0	00025152531	44923712		
21499	1766	1713671	2001-02-08	2001-02-08 00:00:00	2001-02-22	2001-02-22 00:00:00	2001-02-22	38000177		0	0	14		0	0	0	118121	0	562251	1713671		
48614	4026	19059056	1973-04-07	1973-04-07 00:00:00	1973-06-06	1973-06-06 00:00:00	1973-06-06	38000177		0	0	60		0	0	0	267697	0	243670	19059056		
28978	2396	19075601	1997-03-19	1997-03-19 00:00:00	2000-11-08	2000-11-08 00:00:00	2000-11-08	38000177		0	0	1330		0	0	0	159319	0	309362	19075601		
122050	2682	40213160	1973-11-23	1973-11-23 00:00:00	1973-11-23	1973-11-23 00:00:00	1973-11-23	581452		0	0	0		0	0	0	177755	0	10	40213160		
230280	5060	40213306	1994-05-30	1994-05-30 00:00:00	1994-05-30	1994-05-30 00:00:00	1994-05-30	581452		0	0	0		0	0	0	336430	0	43	40213306		
215945	4736	40213296	2012-09-21	2012-09-21 00:00:00	2012-09-21	2012-09-21 00:00:00	2012-09-21	581452		0	0	0		0	0	0	315496	0	52	40213296		
183315	4027	40213160	1974-04-13	1974-04-13 00:00:00	1974-04-13	1974-04-13 00:00:00	1974-04-13	581452		0	0	0		0	0	0	267880	0	10	40213160		
39637	3278	19078461	2011-02-25	2011-02-25 00:00:00	2011-04-01	2011-04-01 00:00:00	2011-04-01	38000177		0	0	35		0	0	0	217747	0	310965	19078461		
191015	4197	40213251	1990-08-26	1990-08-26 00:00:00	1990-08-26	1990-08-26 00:00:00	1990-08-26	581452		0	0	0		0	0	0	278507	0	21	40213251		
50188	4165	46275916	1991-01-27	1991-01-27 00:00:00	1991-01-27	1991-01-27 00:00:00	1991-01-27	38000177		0	0	0		0	0	0	276828	0	1660014	46275916		
191103	4199	40213227	2009-09-03	2009-09-03 00:00:00	2009-09-03	2009-09-03 00:00:00	2009-09-03	581452		0	0	0		0	0	0	278665	0	113	40213227		
43887	956	40213227	2016-10-19	2016-10-19 00:00:00	2016-10-19	2016-10-19 00:00:00	2016-10-19	581452		0	0	0		0	0	0	63502	0	113	40213227		
39693	3283	1713671	1993-09-21	1993-09-21 00:00:00	1993-10-12	1993-10-12 00:00:00	1993-10-12	38000177		0	0	21		0	0	0	218138	0	562251	1713671		
107492	2356	40213227	2009-01-14	2009-01-14 00:00:00	2009-01-14	2009-01-14 00:00:00	2009-01-14	581452		0	0	0		0	0	0	156930	0	113	40213227		
39795	3293	19075001	1994-03-23	1994-03-23 00:00:00	1994-04-06	1994-04-06 00:00:00	1994-04-06	38000177		0	0	14		0	0	0	218712	0	309097	19075001		
231165	5079	40213260	2017-12-24	2017-12-24 00:00:00	2017-12-24	2017-12-24 00:00:00	2017-12-24	581452		0	0	0		0	0	0	337713	0	121	40213260		
31516	2613	19019273	2016-04-27	2016-04-27 00:00:00	2016-04-27	2016-04-27 00:00:00	\N	38000177		0	0	0		0	0	0	172751	0	198014	19019273		
14613	316	40213227	1998-12-01	1998-12-01 00:00:00	1998-12-01	1998-12-01 00:00:00	1998-12-01	581452		0	0	0		0	0	0	20977	0	113	40213227		
55467	1215	40213296	2012-04-14	2012-04-14 00:00:00	2012-04-14	2012-04-14 00:00:00	2012-04-14	581452		0	0	0		0	0	0	80036	0	52	40213296		
159659	3514	40213160	1979-07-30	1979-07-30 00:00:00	1979-07-30	1979-07-30 00:00:00	1979-07-30	581452		0	0	0		0	0	0	233192	0	10	40213160		
60950	5068	1539411	2008-11-22	2008-11-22 00:00:00	2008-11-22	2008-11-22 00:00:00	\N	38000177		0	0	0		0	0	0	336974	0	312961	1539411		
46309	3836	1713671	1994-02-12	1994-02-12 00:00:00	1994-02-26	1994-02-26 00:00:00	1994-02-26	38000177		0	0	14		0	0	0	254707	0	562251	1713671		
39233	3241	1713671	1977-11-22	1977-11-22 00:00:00	1977-11-29	1977-11-29 00:00:00	1977-11-29	38000177		0	0	7		0	0	0	215487	0	562251	1713671		
56862	4720	19128022	1992-06-01	1992-06-01 00:00:00	1993-05-27	1993-05-27 00:00:00	1993-05-27	38000177		0	0	360		0	0	0	314392	0	749785	19128022		
39340	3249	19078461	1988-07-01	1988-07-01 00:00:00	1988-07-15	1988-07-15 00:00:00	1988-07-15	38000177		0	0	14		0	0	0	215988	0	310965	19078461		
28030	2319	19133905	2001-12-25	2001-12-25 00:00:00	2002-01-01	2002-01-01 00:00:00	2002-01-01	38000177		0	0	7		0	0	0	154228	0	834102	19133905		
190740	4191	40213160	1957-11-22	1957-11-22 00:00:00	1957-11-22	1957-11-22 00:00:00	1957-11-22	581452		0	0	0		0	0	0	278139	0	10	40213160		
89333	1958	40213160	1972-04-04	1972-04-04 00:00:00	1972-04-04	1972-04-04 00:00:00	1972-04-04	581452		0	0	0		0	0	0	130289	0	10	40213160		
81690	1785	40213227	1996-11-11	1996-11-11 00:00:00	1996-11-11	1996-11-11 00:00:00	1996-11-11	581452		0	0	0		0	0	0	119632	0	113	40213227		
44639	3695	19016749	1996-03-20	1996-03-20 00:00:00	1996-03-20	1996-03-20 00:00:00	1996-03-20	38000177		0	0	0		0	0	0	245605	0	73032	19016749		
62612	5206	1127078	1980-07-27	1980-07-27 00:00:00	1980-08-10	1980-08-10 00:00:00	1980-08-10	38000177		0	0	14		0	0	0	346272	0	282464	1127078		
58010	4819	19059056	1963-11-30	1963-11-30 00:00:00	1963-12-14	1963-12-14 00:00:00	1963-12-14	38000177		0	0	14		0	0	0	320560	0	243670	19059056		
62729	5215	19133873	1943-08-28	1943-08-28 00:00:00	1943-09-04	1943-09-04 00:00:00	1943-09-04	38000177		0	0	7		0	0	0	346821	0	834061	19133873		
179725	3951	40213227	2005-04-30	2005-04-30 00:00:00	2005-04-30	2005-04-30 00:00:00	2005-04-30	581452		0	0	0		0	0	0	262638	0	113	40213227		
134122	2944	40213160	1960-05-08	1960-05-08 00:00:00	1960-05-08	1960-05-08 00:00:00	1960-05-08	581452		0	0	0		0	0	0	196414	0	10	40213160		
20349	442	40213227	2009-03-14	2009-03-14 00:00:00	2009-03-14	2009-03-14 00:00:00	2009-03-14	581452		0	0	0		0	0	0	29391	0	113	40213227		
151621	3335	40213227	1995-02-19	1995-02-19 00:00:00	1995-02-19	1995-02-19 00:00:00	1995-02-19	581452		0	0	0		0	0	0	221292	0	113	40213227		
149884	3296	40213227	2008-06-20	2008-06-20 00:00:00	2008-06-20	2008-06-20 00:00:00	2008-06-20	581452		0	0	0		0	0	0	219049	0	113	40213227		
31615	2621	1124300	1994-07-02	1994-07-02 00:00:00	1994-07-02	1994-07-02 00:00:00	\N	38000177		0	0	0		0	0	0	173334	0	00781178901	45011828		
31675	2626	1713671	1992-11-11	1992-11-11 00:00:00	1992-12-02	1992-12-02 00:00:00	1992-12-02	38000177		0	0	21		0	0	0	173732	0	562251	1713671		
155503	3422	40213296	2008-09-01	2008-09-01 00:00:00	2008-09-01	2008-09-01 00:00:00	2008-09-01	581452		0	0	0		0	0	0	226975	0	52	40213296		
50613	4205	19133873	1978-03-11	1978-03-11 00:00:00	1978-03-18	1978-03-18 00:00:00	1978-03-18	38000177		0	0	7		0	0	0	279164	0	834061	19133873		
42287	3508	19006318	1958-09-03	1958-09-03 00:00:00	1958-09-17	1958-09-17 00:00:00	1958-09-17	38000177		0	0	14		0	0	0	232633	0	105078	19006318		
22563	1852	1124300	2007-05-18	2007-05-18 00:00:00	2007-05-18	2007-05-18 00:00:00	\N	38000177		0	0	0		0	0	0	123941	0	00781178901	45011828		
52796	4388	19019979	1975-01-15	1975-01-15 00:00:00	1975-03-16	1975-03-16 00:00:00	1975-03-16	38000177		0	0	60		0	0	0	291638	0	198405	19019979		
52877	4393	1115171	2016-08-28	2016-08-28 00:00:00	2016-09-27	2016-09-27 00:00:00	2016-09-27	38000177		0	0	30		0	0	0	292102	0	849574	1115171		
32653	2706	19059056	1975-10-03	1975-10-03 00:00:00	1975-10-17	1975-10-17 00:00:00	1975-10-17	38000177		0	0	14		0	0	0	179258	0	243670	19059056		
5030	419	19059056	1915-06-09	1915-06-09 00:00:00	1915-06-30	1915-06-30 00:00:00	1915-06-30	38000177		0	0	21		0	0	0	27707	0	243670	19059056		
156537	3444	40213201	2005-01-03	2005-01-03 00:00:00	2005-01-03	2005-01-03 00:00:00	2005-01-03	581452		0	0	0		0	0	0	228626	0	33	40213201		
173013	3803	40213160	1960-12-21	1960-12-21 00:00:00	1960-12-21	1960-12-21 00:00:00	1960-12-21	581452		0	0	0		0	0	0	252761	0	10	40213160		
158438	3488	40213296	1997-08-29	1997-08-29 00:00:00	1997-08-29	1997-08-29 00:00:00	1997-08-29	581452		0	0	0		0	0	0	231398	0	52	40213296		
6471	141	40213227	2015-12-08	2015-12-08 00:00:00	2015-12-08	2015-12-08 00:00:00	2015-12-08	581452		0	0	0		0	0	0	9425	0	113	40213227		
195688	4299	40213160	1973-10-21	1973-10-21 00:00:00	1973-10-21	1973-10-21 00:00:00	1973-10-21	581452		0	0	0		0	0	0	285258	0	10	40213160		
201203	4418	40213201	2018-03-30	2018-03-30 00:00:00	2018-03-30	2018-03-30 00:00:00	2018-03-30	581452		0	0	0		0	0	0	293778	0	33	40213201		
158200	3483	40213160	1956-06-30	1956-06-30 00:00:00	1956-06-30	1956-06-30 00:00:00	1956-06-30	581452		0	0	0		0	0	0	231052	0	10	40213160		
80670	1764	40213296	2000-02-03	2000-02-03 00:00:00	2000-02-03	2000-02-03 00:00:00	2000-02-03	581452		0	0	0		0	0	0	117975	0	52	40213296		
55366	4596	40171902	2013-04-14	2013-04-14 00:00:00	2013-04-14	2013-04-14 00:00:00	\N	38000177		0	0	0		0	0	0	306282	0	897718	40171902		
89021	1952	40213260	2007-01-15	2007-01-15 00:00:00	2007-01-15	2007-01-15 00:00:00	2007-01-15	581452		0	0	0		0	0	0	129868	0	121	40213260		
89080	1953	40213260	2007-09-17	2007-09-17 00:00:00	2007-09-17	2007-09-17 00:00:00	2007-09-17	581452		0	0	0		0	0	0	129917	0	121	40213260		
538	40	19133905	1983-09-01	1983-09-01 00:00:00	1983-09-14	1983-09-14 00:00:00	1983-09-14	38000177		0	0	13		0	0	0	2870	0	834102	19133905		
583	42	1127433	1974-06-13	1974-06-13 00:00:00	1974-06-27	1974-06-27 00:00:00	1974-06-27	38000177		0	0	14		0	0	0	3107	0	313782	1127433		
55697	4625	19078461	1977-04-17	1977-04-17 00:00:00	1977-05-08	1977-05-08 00:00:00	1977-05-08	38000177		0	0	21		0	0	0	308130	0	310965	19078461		
55716	4626	19078461	2016-05-01	2016-05-01 00:00:00	2016-05-31	2016-05-31 00:00:00	2016-05-31	38000177		0	0	30		0	0	0	308211	0	310965	19078461		
30117	2497	1713671	2011-04-27	2011-04-27 00:00:00	2011-05-11	2011-05-11 00:00:00	2011-05-11	38000177		0	0	14		0	0	0	165353	0	562251	1713671		
21500	1766	1127078	1957-05-29	1957-05-29 00:00:00	1957-06-12	1957-06-12 00:00:00	1957-06-12	38000177		0	0	14		0	0	0	118127	0	282464	1127078		
39043	3226	19078461	1983-09-13	1983-09-13 00:00:00	1983-09-27	1983-09-27 00:00:00	1983-09-27	38000177		0	0	14		0	0	0	214498	0	310965	19078461		
28979	2396	1127433	1986-03-06	1986-03-06 00:00:00	1986-03-20	1986-03-20 00:00:00	1986-03-20	38000177		0	0	14		0	0	0	159346	0	313782	1127433		
58197	4835	1115171	2011-03-26	2011-03-26 00:00:00	2011-04-16	2011-04-16 00:00:00	2011-04-16	38000177		0	0	21		0	0	0	321636	0	849574	1115171		
230282	5060	40213227	1994-05-30	1994-05-30 00:00:00	1994-05-30	1994-05-30 00:00:00	1994-05-30	581452		0	0	0		0	0	0	336430	0	113	40213227		
189147	4153	40213227	2016-03-31	2016-03-31 00:00:00	2016-03-31	2016-03-31 00:00:00	2016-03-31	581452		0	0	0		0	0	0	276035	0	113	40213227		
183317	4027	40213227	2005-07-09	2005-07-09 00:00:00	2005-07-09	2005-07-09 00:00:00	2005-07-09	581452		0	0	0		0	0	0	267793	0	113	40213227		
39638	3278	19078461	1986-11-12	1986-11-12 00:00:00	1986-12-03	1986-12-03 00:00:00	1986-12-03	38000177		0	0	21		0	0	0	217746	0	310965	19078461		
191018	4197	40213160	1990-08-26	1990-08-26 00:00:00	1990-08-26	1990-08-26 00:00:00	1990-08-26	581452		0	0	0		0	0	0	278507	0	10	40213160		
50189	4165	40243436	1991-01-27	1991-01-27 00:00:00	1991-01-27	1991-01-27 00:00:00	1991-01-27	38000177		0	0	0		0	0	0	276828	0	1190795	40243436		
144891	3184	40213160	1961-11-09	1961-11-09 00:00:00	1961-11-09	1961-11-09 00:00:00	1961-11-09	581452		0	0	0		0	0	0	211965	0	10	40213160		
58503	1280	40213160	1955-06-08	1955-06-08 00:00:00	1955-06-08	1955-06-08 00:00:00	1955-06-08	581452		0	0	0		0	0	0	84622	0	10	40213160		
39694	3283	19073183	1980-07-03	1980-07-03 00:00:00	1980-07-17	1980-07-17 00:00:00	1980-07-17	38000177		0	0	14		0	0	0	218114	0	308182	19073183		
107498	2356	40213296	2017-12-27	2017-12-27 00:00:00	2017-12-27	2017-12-27 00:00:00	2017-12-27	581452		0	0	0		0	0	0	156915	0	52	40213296		
39796	3293	19078461	1994-03-23	1994-03-23 00:00:00	1994-04-06	1994-04-06 00:00:00	1994-04-06	38000177		0	0	14		0	0	0	218712	0	310965	19078461		
231168	5079	40213160	1967-03-19	1967-03-19 00:00:00	1967-03-19	1967-03-19 00:00:00	1967-03-19	581452		0	0	0		0	0	0	337716	0	10	40213160		
31517	2613	1713671	2016-05-13	2016-05-13 00:00:00	2016-05-27	2016-05-27 00:00:00	2016-05-27	38000177		0	0	14		0	0	0	172785	0	562251	1713671		
66985	1466	40213160	1968-08-13	1968-08-13 00:00:00	1968-08-13	1968-08-13 00:00:00	1968-08-13	581452		0	0	0		0	0	0	97608	0	10	40213160		
55470	1215	40213160	1972-12-16	1972-12-16 00:00:00	1972-12-16	1972-12-16 00:00:00	1972-12-16	581452		0	0	0		0	0	0	80014	0	10	40213160		
159662	3514	40213160	1975-01-27	1975-01-27 00:00:00	1975-01-27	1975-01-27 00:00:00	1975-01-27	581452		0	0	0		0	0	0	233218	0	10	40213160		
60951	5068	1332419	2008-11-22	2008-11-22 00:00:00	2008-11-22	2008-11-22 00:00:00	\N	38000177		0	0	0		0	0	0	336974	0	197361	1332419		
46310	3836	1127433	1981-02-12	1981-02-12 00:00:00	1981-02-19	1981-02-19 00:00:00	1981-02-19	38000177		0	0	7		0	0	0	254751	0	313782	1127433		
39234	3241	1127433	2013-08-02	2013-08-02 00:00:00	2013-08-09	2013-08-09 00:00:00	2013-08-09	38000177		0	0	7		0	0	0	215558	0	313782	1127433		
56863	4720	19019979	1987-04-19	1987-04-19 00:00:00	1987-05-10	1987-05-10 00:00:00	1987-05-10	38000177		0	0	21		0	0	0	314370	0	198405	19019979		
39341	3249	40229134	1962-09-17	1962-09-17 00:00:00	1962-09-24	1962-09-24 00:00:00	1962-09-24	38000177		0	0	7		0	0	0	215960	0	1043400	40229134		
28031	2319	19059056	1949-03-06	1949-03-06 00:00:00	1949-03-20	1949-03-20 00:00:00	1949-03-20	38000177		0	0	14		0	0	0	154132	0	243670	19059056		
190742	4191	40213260	2007-08-17	2007-08-17 00:00:00	2007-08-17	2007-08-17 00:00:00	2007-08-17	581452		0	0	0		0	0	0	278157	0	121	40213260		
89340	1958	40213296	2015-03-31	2015-03-31 00:00:00	2015-03-31	2015-03-31 00:00:00	2015-03-31	581452		0	0	0		0	0	0	130242	0	52	40213296		
81701	1785	40213260	2007-10-22	2007-10-22 00:00:00	2007-10-22	2007-10-22 00:00:00	2007-10-22	581452		0	0	0		0	0	0	119634	0	121	40213260		
44640	3695	782047	1996-03-20	1996-03-20 00:00:00	1996-03-20	1996-03-20 00:00:00	1996-03-20	38000177		0	0	0		0	0	0	245605	0	542347	782047		
62613	5206	1713671	1985-09-03	1985-09-03 00:00:00	1985-09-10	1985-09-10 00:00:00	1985-09-10	38000177		0	0	7		0	0	0	346269	0	562251	1713671		
58011	4819	19006318	1963-11-30	1963-11-30 00:00:00	1963-12-14	1963-12-14 00:00:00	1963-12-14	38000177		0	0	14		0	0	0	320560	0	105078	19006318		
62730	5215	19059056	1941-11-04	1941-11-04 00:00:00	1941-11-18	1941-11-18 00:00:00	1941-11-18	38000177		0	0	14		0	0	0	346827	0	243670	19059056		
219700	4822	40213227	1998-09-30	1998-09-30 00:00:00	1998-09-30	1998-09-30 00:00:00	1998-09-30	581452		0	0	0		0	0	0	320801	0	113	40213227		
134124	2944	40213227	1993-09-26	1993-09-26 00:00:00	1993-09-26	1993-09-26 00:00:00	1993-09-26	581452		0	0	0		0	0	0	196454	0	113	40213227		
20351	443	40213296	2010-12-27	2010-12-27 00:00:00	2010-12-27	2010-12-27 00:00:00	2010-12-27	581452		0	0	0		0	0	0	29441	0	52	40213296		
151622	3335	40213306	1995-02-19	1995-02-19 00:00:00	1995-02-19	1995-02-19 00:00:00	1995-02-19	581452		0	0	0		0	0	0	221292	0	43	40213306		
149886	3296	40213201	2003-05-23	2003-05-23 00:00:00	2003-05-23	2003-05-23 00:00:00	2003-05-23	581452		0	0	0		0	0	0	219057	0	33	40213201		
31616	2621	1127433	1984-07-12	1984-07-12 00:00:00	1984-07-26	1984-07-26 00:00:00	1984-07-26	38000177		0	0	14		0	0	0	173381	0	313782	1127433		
31676	2626	40229134	2018-08-15	2018-08-15 00:00:00	2018-08-22	2018-08-22 00:00:00	2018-08-22	38000177		0	0	7		0	0	0	173734	0	1043400	40229134		
155504	3422	40213227	2008-09-01	2008-09-01 00:00:00	2008-09-01	2008-09-01 00:00:00	2008-09-01	581452		0	0	0		0	0	0	226975	0	113	40213227		
50614	4205	1127433	2004-07-18	2004-07-18 00:00:00	2004-08-22	2004-08-22 00:00:00	2004-08-22	38000177		0	0	35		0	0	0	279235	0	313782	1127433		
42288	3508	19059056	1958-09-03	1958-09-03 00:00:00	1958-09-17	1958-09-17 00:00:00	1958-09-17	38000177		0	0	14		0	0	0	232633	0	243670	19059056		
22564	1852	19129655	1974-06-30	1974-06-30 00:00:00	1974-07-14	1974-07-14 00:00:00	1974-07-14	38000177		0	0	14		0	0	0	123918	0	789980	19129655		
52797	4388	19129655	1968-05-11	1968-05-11 00:00:00	1968-05-25	1968-05-25 00:00:00	1968-05-25	38000177		0	0	14		0	0	0	291633	0	789980	19129655		
52878	4393	1127433	2000-08-02	2000-08-02 00:00:00	2000-08-09	2000-08-09 00:00:00	2000-08-09	38000177		0	0	7		0	0	0	292088	0	313782	1127433		
32654	2706	1539411	2006-06-20	2006-06-20 00:00:00	2006-06-20	2006-06-20 00:00:00	\N	38000177		0	0	0		0	0	0	179305	0	312961	1539411		
5031	419	40231925	1964-09-15	1964-09-15 00:00:00	1964-09-15	1964-09-15 00:00:00	\N	38000177		0	0	0		0	0	0	27710	0	1049221	40231925		
151160	3325	40213296	2005-07-27	2005-07-27 00:00:00	2005-07-27	2005-07-27 00:00:00	2005-07-27	581452		0	0	0		0	0	0	220749	0	52	40213296		
173016	3804	40213227	1994-07-07	1994-07-07 00:00:00	1994-07-07	1994-07-07 00:00:00	1994-07-07	581452		0	0	0		0	0	0	252892	0	113	40213227		
158442	3488	40213227	2015-04-10	2015-04-10 00:00:00	2015-04-10	2015-04-10 00:00:00	2015-04-10	581452		0	0	0		0	0	0	231373	0	113	40213227		
6475	141	40213227	2006-11-28	2006-11-28 00:00:00	2006-11-28	2006-11-28 00:00:00	2006-11-28	581452		0	0	0		0	0	0	9422	0	113	40213227		
195693	4299	40213227	2014-06-01	2014-06-01 00:00:00	2014-06-01	2014-06-01 00:00:00	2014-06-01	581452		0	0	0		0	0	0	285269	0	113	40213227		
201208	4418	40213227	1992-10-30	1992-10-30 00:00:00	1992-10-30	1992-10-30 00:00:00	1992-10-30	581452		0	0	0		0	0	0	293731	0	113	40213227		
158203	3483	40213227	1995-02-04	1995-02-04 00:00:00	1995-02-04	1995-02-04 00:00:00	1995-02-04	581452		0	0	0		0	0	0	231027	0	113	40213227		
80681	1764	40213160	1960-05-12	1960-05-12 00:00:00	1960-05-12	1960-05-12 00:00:00	1960-05-12	581452		0	0	0		0	0	0	117986	0	10	40213160		
55367	4596	40163554	2013-04-14	2013-04-14 00:00:00	2013-04-14	2013-04-14 00:00:00	\N	38000177		0	0	0		0	0	0	306282	0	855332	40163554		
89034	1952	40213227	1996-01-08	1996-01-08 00:00:00	1996-01-08	1996-01-08 00:00:00	1996-01-08	581452		0	0	0		0	0	0	129798	0	113	40213227		
89082	1953	40213227	1997-08-11	1997-08-11 00:00:00	1997-08-11	1997-08-11 00:00:00	1997-08-11	581452		0	0	0		0	0	0	129879	0	113	40213227		
539	40	40220960	2006-11-29	2006-11-29 00:00:00	2006-11-29	2006-11-29 00:00:00	2006-11-29	38000177		0	0	0		0	0	0	2834	0	1804799	40220960		
584	42	19059056	1914-07-09	1914-07-09 00:00:00	1914-07-23	1914-07-23 00:00:00	1914-07-23	38000177		0	0	14		0	0	0	3138	0	243670	19059056		
55698	4625	19059056	1974-05-19	1974-05-19 00:00:00	1974-06-02	1974-06-02 00:00:00	1974-06-02	38000177		0	0	14		0	0	0	308128	0	243670	19059056		
55717	4626	40231925	2016-05-01	2016-05-01 00:00:00	2016-05-01	2016-05-01 00:00:00	\N	38000177		0	0	0		0	0	0	308211	0	1049221	40231925		
30118	2497	1127078	1969-07-20	1969-07-20 00:00:00	1969-08-10	1969-08-10 00:00:00	1969-08-10	38000177		0	0	21		0	0	0	165313	0	282464	1127078		
21501	1766	19006318	1957-05-29	1957-05-29 00:00:00	1957-06-12	1957-06-12 00:00:00	1957-06-12	38000177		0	0	14		0	0	0	118127	0	105078	19006318		
39044	3226	19074841	1983-09-13	1983-09-13 00:00:00	1983-09-27	1983-09-27 00:00:00	1983-09-27	38000177		0	0	14		0	0	0	214498	0	309043	19074841		
28980	2396	19078461	1997-10-19	1997-10-19 00:00:00	1997-12-18	1997-12-18 00:00:00	1997-12-18	38000177		0	0	60		0	0	0	159323	0	310965	19078461		
58198	4835	40231925	2011-03-26	2011-03-26 00:00:00	2011-03-26	2011-03-26 00:00:00	\N	38000177		0	0	0		0	0	0	321636	0	1049221	40231925		
230288	5060	40213160	1972-07-03	1972-07-03 00:00:00	1972-07-03	1972-07-03 00:00:00	1972-07-03	581452		0	0	0		0	0	0	336455	0	10	40213160		
189148	4153	40213260	2016-03-31	2016-03-31 00:00:00	2016-03-31	2016-03-31 00:00:00	2016-03-31	581452		0	0	0		0	0	0	276035	0	121	40213260		
183318	4027	40213160	1974-06-15	1974-06-15 00:00:00	1974-06-15	1974-06-15 00:00:00	1974-06-15	581452		0	0	0		0	0	0	267813	0	10	40213160		
39639	3278	19073188	2001-09-10	2001-09-10 00:00:00	2001-09-24	2001-09-24 00:00:00	2001-09-24	38000177		0	0	14		0	0	0	217787	0	308192	19073188		
129803	2853	40213260	2013-05-14	2013-05-14 00:00:00	2013-05-14	2013-05-14 00:00:00	2013-05-14	581452		0	0	0		0	0	0	189557	0	121	40213260		
50190	4165	1310034	1991-01-27	1991-01-27 00:00:00	1991-01-27	1991-01-27 00:00:00	1991-01-27	38000177		0	0	0		0	0	0	276828	0	834357	1310034		
144892	3184	40213296	2002-01-31	2002-01-31 00:00:00	2002-01-31	2002-01-31 00:00:00	2002-01-31	581452		0	0	0		0	0	0	211972	0	52	40213296		
58505	1280	40213160	1955-07-20	1955-07-20 00:00:00	1955-07-20	1955-07-20 00:00:00	1955-07-20	581452		0	0	0		0	0	0	84626	0	10	40213160		
39695	3283	1127078	1980-07-03	1980-07-03 00:00:00	1980-07-17	1980-07-17 00:00:00	1980-07-17	38000177		0	0	14		0	0	0	218114	0	282464	1127078		
107501	2356	40213160	1978-04-12	1978-04-12 00:00:00	1978-04-12	1978-04-12 00:00:00	1978-04-12	581452		0	0	0		0	0	0	156917	0	10	40213160		
39797	3293	1115171	2000-10-17	2000-10-17 00:00:00	2000-12-16	2000-12-16 00:00:00	2000-12-16	38000177		0	0	60		0	0	0	218696	0	849574	1115171		
231169	5079	40213160	1967-05-21	1967-05-21 00:00:00	1967-05-21	1967-05-21 00:00:00	1967-05-21	581452		0	0	0		0	0	0	337682	0	10	40213160		
31518	2613	1713671	1989-04-07	1989-04-07 00:00:00	1989-04-28	1989-04-28 00:00:00	1989-04-28	38000177		0	0	21		0	0	0	172749	0	562251	1713671		
66990	1466	40213306	1990-05-08	1990-05-08 00:00:00	1990-05-08	1990-05-08 00:00:00	1990-05-08	581452		0	0	0		0	0	0	97642	0	43	40213306		
55471	1215	40213160	1972-07-15	1972-07-15 00:00:00	1972-07-15	1972-07-15 00:00:00	1972-07-15	581452		0	0	0		0	0	0	80013	0	10	40213160		
159664	3514	40213160	1975-04-28	1975-04-28 00:00:00	1975-04-28	1975-04-28 00:00:00	1975-04-28	581452		0	0	0		0	0	0	233178	0	10	40213160		
60952	5068	19126352	2008-11-22	2008-11-22 00:00:00	2008-11-22	2008-11-22 00:00:00	\N	38000177		0	0	0		0	0	0	336974	0	705129	19126352		
46311	3836	40229134	2002-05-19	2002-05-19 00:00:00	2002-06-02	2002-06-02 00:00:00	2002-06-02	38000177		0	0	14		0	0	0	254723	0	1043400	40229134		
39235	3241	1127433	2003-10-11	2003-10-11 00:00:00	2003-10-25	2003-10-25 00:00:00	2003-10-25	38000177		0	0	14		0	0	0	215556	0	313782	1127433		
56864	4720	40229134	2009-11-07	2009-11-07 00:00:00	2009-11-14	2009-11-14 00:00:00	2009-11-14	38000177		0	0	7		0	0	0	314378	0	1043400	40229134		
39342	3249	1127078	1959-06-12	1959-06-12 00:00:00	1959-06-26	1959-06-26 00:00:00	1959-06-26	38000177		0	0	14		0	0	0	215970	0	282464	1127078		
28032	2319	1713671	1958-09-17	1958-09-17 00:00:00	1958-09-24	1958-09-24 00:00:00	1958-09-24	38000177		0	0	7		0	0	0	154194	0	562251	1713671		
190748	4191	40213160	1958-01-24	1958-01-24 00:00:00	1958-01-24	1958-01-24 00:00:00	1958-01-24	581452		0	0	0		0	0	0	278146	0	10	40213160		
52617	1150	40213227	1992-12-09	1992-12-09 00:00:00	1992-12-09	1992-12-09 00:00:00	1992-12-09	581452		0	0	0		0	0	0	76056	0	113	40213227		
81703	1785	40213260	2006-10-16	2006-10-16 00:00:00	2006-10-16	2006-10-16 00:00:00	2006-10-16	581452		0	0	0		0	0	0	119622	0	121	40213260		
44641	3695	40231925	1996-03-21	1996-03-21 00:00:00	1996-03-21	1996-03-21 00:00:00	\N	38000177		0	0	0		0	0	0	245605	0	1049221	40231925		
62614	5206	1127433	1980-11-25	1980-11-25 00:00:00	1980-12-09	1980-12-09 00:00:00	1980-12-09	38000177		0	0	14		0	0	0	346254	0	313782	1127433		
58012	4819	40229134	2015-11-03	2015-11-03 00:00:00	2015-11-10	2015-11-10 00:00:00	2015-11-10	38000177		0	0	7		0	0	0	320580	0	1043400	40229134		
62731	5215	1127433	1982-08-20	1982-08-20 00:00:00	1982-09-24	1982-09-24 00:00:00	1982-09-24	38000177		0	0	35		0	0	0	346841	0	313782	1127433		
219708	4822	40213201	2013-12-25	2013-12-25 00:00:00	2013-12-25	2013-12-25 00:00:00	2013-12-25	581452		0	0	0		0	0	0	320720	0	33	40213201		
134126	2944	40213160	1960-10-09	1960-10-09 00:00:00	1960-10-09	1960-10-09 00:00:00	1960-10-09	581452		0	0	0		0	0	0	196415	0	10	40213160		
20352	443	40213160	1973-11-26	1973-11-26 00:00:00	1973-11-26	1973-11-26 00:00:00	1973-11-26	581452		0	0	0		0	0	0	29459	0	10	40213160		
151623	3335	40213160	1972-09-03	1972-09-03 00:00:00	1972-09-03	1972-09-03 00:00:00	1972-09-03	581452		0	0	0		0	0	0	221254	0	10	40213160		
149905	3296	40213227	2018-06-29	2018-06-29 00:00:00	2018-06-29	2018-06-29 00:00:00	2018-06-29	581452		0	0	0		0	0	0	\N	0	113	40213227		
31617	2621	1115171	1999-06-10	1999-06-10 00:00:00	1999-08-16	1999-08-16 00:00:00	1999-08-16	38000177		0	0	67		0	0	0	173402	0	849574	1115171		
31677	2626	1127433	1991-08-04	1991-08-04 00:00:00	1991-09-03	1991-09-03 00:00:00	1991-09-03	38000177		0	0	30		0	0	0	173743	0	313782	1127433		
155505	3422	40213160	1967-03-27	1967-03-27 00:00:00	1967-03-27	1967-03-27 00:00:00	1967-03-27	581452		0	0	0		0	0	0	227017	0	10	40213160		
50615	4205	1713671	2000-12-26	2000-12-26 00:00:00	2001-01-16	2001-01-16 00:00:00	2001-01-16	38000177		0	0	21		0	0	0	279208	0	562251	1713671		
211901	4646	40213227	2004-10-26	2004-10-26 00:00:00	2004-10-26	2004-10-26 00:00:00	2004-10-26	581452		0	0	0		0	0	0	309840	0	113	40213227		
22565	1852	1127078	1974-06-30	1974-06-30 00:00:00	1974-07-14	1974-07-14 00:00:00	1974-07-14	38000177		0	0	14		0	0	0	123918	0	282464	1127078		
52798	4388	1127078	1970-04-01	1970-04-01 00:00:00	1970-05-06	1970-05-06 00:00:00	1970-05-06	38000177		0	0	35		0	0	0	291635	0	282464	1127078		
52879	4393	1127433	1995-10-20	1995-10-20 00:00:00	1995-10-27	1995-10-27 00:00:00	1995-10-27	38000177		0	0	7		0	0	0	292087	0	313782	1127433		
32655	2706	1332419	2006-06-20	2006-06-20 00:00:00	2006-06-20	2006-06-20 00:00:00	\N	38000177		0	0	0		0	0	0	179305	0	197361	1332419		
5032	419	19059056	1964-09-15	1964-09-15 00:00:00	1964-11-14	1964-11-14 00:00:00	1964-11-14	38000177		0	0	60		0	0	0	27710	0	243670	19059056		
151162	3325	40213227	2005-07-27	2005-07-27 00:00:00	2005-07-27	2005-07-27 00:00:00	2005-07-27	581452		0	0	0		0	0	0	220749	0	113	40213227		
173019	3804	40213227	2001-06-07	2001-06-07 00:00:00	2001-06-07	2001-06-07 00:00:00	2001-06-07	581452		0	0	0		0	0	0	\N	0	113	40213227		
158450	3488	40213227	2006-02-17	2006-02-17 00:00:00	2006-02-17	2006-02-17 00:00:00	2006-02-17	581452		0	0	0		0	0	0	231410	0	113	40213227		
6476	141	40213306	2006-11-28	2006-11-28 00:00:00	2006-11-28	2006-11-28 00:00:00	2006-11-28	581452		0	0	0		0	0	0	9422	0	43	40213306		
195694	4299	40213296	2014-06-01	2014-06-01 00:00:00	2014-06-01	2014-06-01 00:00:00	2014-06-01	581452		0	0	0		0	0	0	285269	0	52	40213296		
201214	4418	40213260	2006-01-20	2006-01-20 00:00:00	2006-01-20	2006-01-20 00:00:00	2006-01-20	581452		0	0	0		0	0	0	293700	0	121	40213260		
158204	3483	40213260	2006-07-01	2006-07-01 00:00:00	2006-07-01	2006-07-01 00:00:00	2006-07-01	581452		0	0	0		0	0	0	\N	0	121	40213260		
80686	1764	40213296	2002-02-07	2002-02-07 00:00:00	2002-02-07	2002-02-07 00:00:00	2002-02-07	581452		0	0	0		0	0	0	117966	0	52	40213296		
55368	4596	19018935	2013-04-14	2013-04-14 00:00:00	2013-04-14	2013-04-14 00:00:00	\N	38000177		0	0	0		0	0	0	306282	0	197604	19018935		
89035	1952	40213296	1996-01-08	1996-01-08 00:00:00	1996-01-08	1996-01-08 00:00:00	1996-01-08	581452		0	0	0		0	0	0	129798	0	52	40213296		
89083	1953	40213296	1997-08-11	1997-08-11 00:00:00	1997-08-11	1997-08-11 00:00:00	1997-08-11	581452		0	0	0		0	0	0	129879	0	52	40213296		
540	40	19075601	2006-11-29	2006-11-29 00:00:00	2006-11-29	2006-11-29 00:00:00	2006-11-29	38000177		0	0	0		0	0	0	2834	0	309362	19075601		
585	42	19059056	1935-09-08	1935-09-08 00:00:00	1935-10-06	1935-10-06 00:00:00	1935-10-06	38000177		0	0	28		0	0	0	3105	0	243670	19059056		
55699	4626	1127433	2007-01-05	2007-01-05 00:00:00	2007-01-12	2007-01-12 00:00:00	2007-01-12	38000177		0	0	7		0	0	0	308188	0	313782	1127433		
55724	4628	46233988	1969-06-26	1969-06-26 00:00:00	1969-07-10	1969-07-10 00:00:00	1969-07-10	38000177		0	0	14		0	0	0	308370	0	1652673	46233988		
30119	2497	1713671	1983-11-28	1983-11-28 00:00:00	1983-12-12	1983-12-12 00:00:00	1983-12-12	38000177		0	0	14		0	0	0	165330	0	562251	1713671		
21502	1766	1127433	1994-05-13	1994-05-13 00:00:00	1994-05-27	1994-05-27 00:00:00	1994-05-27	38000177		0	0	14		0	0	0	118177	0	313782	1127433		
39045	3226	19019979	1980-07-05	1980-07-05 00:00:00	1980-07-26	1980-07-26 00:00:00	1980-07-26	38000177		0	0	21		0	0	0	214448	0	198405	19019979		
28981	2396	1127433	1972-10-23	1972-10-23 00:00:00	1972-11-06	1972-11-06 00:00:00	1972-11-06	38000177		0	0	14		0	0	0	159384	0	313782	1127433		
58199	4835	19073188	2011-03-26	2011-03-26 00:00:00	2011-04-16	2011-04-16 00:00:00	2011-04-16	38000177		0	0	21		0	0	0	321636	0	308192	19073188		
222345	4881	40213201	2014-10-12	2014-10-12 00:00:00	2014-10-12	2014-10-12 00:00:00	2014-10-12	581452		0	0	0		0	0	0	324553	0	33	40213201		
189149	4153	40213160	1965-05-20	1965-05-20 00:00:00	1965-05-20	1965-05-20 00:00:00	1965-05-20	581452		0	0	0		0	0	0	276068	0	10	40213160		
183321	4027	40213296	2014-01-11	2014-01-11 00:00:00	2014-01-11	2014-01-11 00:00:00	2014-01-11	581452		0	0	0		0	0	0	267847	0	52	40213296		
39640	3278	1115171	2001-09-10	2001-09-10 00:00:00	2001-09-24	2001-09-24 00:00:00	2001-09-24	38000177		0	0	14		0	0	0	217787	0	849574	1115171		
129804	2853	40213227	2013-05-14	2013-05-14 00:00:00	2013-05-14	2013-05-14 00:00:00	2013-05-14	581452		0	0	0		0	0	0	189557	0	113	40213227		
50191	4165	19059056	1916-07-12	1916-07-12 00:00:00	1916-07-26	1916-07-26 00:00:00	1916-07-26	38000177		0	0	14		0	0	0	276756	0	243670	19059056		
144900	3184	40213227	2012-03-08	2012-03-08 00:00:00	2012-03-08	2012-03-08 00:00:00	2012-03-08	581452		0	0	0		0	0	0	211996	0	113	40213227		
58511	1280	40213201	2018-01-24	2018-01-24 00:00:00	2018-01-24	2018-01-24 00:00:00	2018-01-24	581452		0	0	0		0	0	0	84637	0	33	40213201		
39696	3283	920334	2005-08-10	2005-08-10 00:00:00	2005-08-17	2005-08-17 00:00:00	2005-08-17	38000177		0	0	7		0	0	0	218141	0	311995	920334		
107502	2356	40213314	1978-04-12	1978-04-12 00:00:00	1978-04-12	1978-04-12 00:00:00	1978-04-12	581452		0	0	0		0	0	0	156917	0	49	40213314		
39798	3293	19133905	1996-11-07	1996-11-07 00:00:00	1996-11-19	1996-11-19 00:00:00	1996-11-19	38000177		0	0	12		0	0	0	218734	0	834102	19133905		
216555	4753	40213160	1961-11-15	1961-11-15 00:00:00	1961-11-15	1961-11-15 00:00:00	1961-11-15	581452		0	0	0		0	0	0	316496	0	10	40213160		
59073	4909	19019979	1978-04-14	1978-04-14 00:00:00	1978-04-28	1978-04-28 00:00:00	1978-04-28	38000177		0	0	14		0	0	0	326247	0	198405	19019979		
66992	1466	40213296	2011-11-29	2011-11-29 00:00:00	2011-11-29	2011-11-29 00:00:00	2011-11-29	581452		0	0	0		0	0	0	97644	0	52	40213296		
55477	1215	40213227	2014-04-19	2014-04-19 00:00:00	2014-04-19	2014-04-19 00:00:00	2014-04-19	581452		0	0	0		0	0	0	80038	0	113	40213227		
159667	3514	40213227	2016-08-29	2016-08-29 00:00:00	2016-08-29	2016-08-29 00:00:00	2016-08-29	581452		0	0	0		0	0	0	233210	0	113	40213227		
60953	5068	19075601	2008-11-22	2008-11-22 00:00:00	2009-07-11	2009-07-11 00:00:00	2009-07-11	38000177		0	0	231		0	0	0	336974	0	309362	19075601		
46312	3836	1127433	1987-11-17	1987-11-17 00:00:00	1987-12-01	1987-12-01 00:00:00	1987-12-01	38000177		0	0	14		0	0	0	254737	0	313782	1127433		
39236	3241	1713671	1973-05-02	1973-05-02 00:00:00	1973-05-16	1973-05-16 00:00:00	1973-05-16	38000177		0	0	14		0	0	0	215450	0	562251	1713671		
56865	4720	1127078	1982-02-14	1982-02-14 00:00:00	1982-04-15	1982-04-15 00:00:00	1982-04-15	38000177		0	0	60		0	0	0	314369	0	282464	1127078		
49801	4131	1118084	2018-05-22	2018-05-22 00:00:00	2018-05-22	2018-05-22 00:00:00	\N	38000177		0	0	0		0	0	0	274676	0	00025152531	44923712		
28033	2320	1127433	2015-06-19	2015-06-19 00:00:00	2015-07-03	2015-07-03 00:00:00	2015-07-03	38000177		0	0	14		0	0	0	154288	0	313782	1127433		
190751	4191	40213227	1999-08-20	1999-08-20 00:00:00	1999-08-20	1999-08-20 00:00:00	1999-08-20	581452		0	0	0		0	0	0	278133	0	113	40213227		
193873	4260	40213227	2008-05-06	2008-05-06 00:00:00	2008-05-06	2008-05-06 00:00:00	2008-05-06	581452		0	0	0		0	0	0	282853	0	113	40213227		
81712	1785	40213160	1955-01-10	1955-01-10 00:00:00	1955-01-10	1955-01-10 00:00:00	1955-01-10	581452		0	0	0		0	0	0	119599	0	10	40213160		
44642	3695	46275444	1996-03-20	1996-03-20 00:00:00	1996-03-20	1996-03-20 00:00:00	1996-03-20	38000177		0	0	0		0	0	0	245605	0	1659149	46275444		
62615	5206	19073183	1986-05-11	1986-05-11 00:00:00	1986-06-01	1986-06-01 00:00:00	1986-06-01	38000177		0	0	21		0	0	0	346253	0	308182	19073183		
58013	4819	19133873	1970-02-10	1970-02-10 00:00:00	1970-02-17	1970-02-17 00:00:00	1970-02-17	38000177		0	0	7		0	0	0	320584	0	834061	19133873		
62732	5215	19059056	1941-04-08	1941-04-08 00:00:00	1941-07-07	1941-07-07 00:00:00	1941-07-07	38000177		0	0	90		0	0	0	346836	0	243670	19059056		
219717	4822	40213227	2019-06-26	2019-06-26 00:00:00	2019-06-26	2019-06-26 00:00:00	2019-06-26	581452		0	0	0		0	0	0	320775	0	113	40213227		
134129	2944	40213160	1960-07-10	1960-07-10 00:00:00	1960-07-10	1960-07-10 00:00:00	1960-07-10	581452		0	0	0		0	0	0	196430	0	10	40213160		
20355	443	40213227	2010-12-27	2010-12-27 00:00:00	2010-12-27	2010-12-27 00:00:00	2010-12-27	581452		0	0	0		0	0	0	29441	0	113	40213227		
51852	1135	40213296	2001-01-06	2001-01-06 00:00:00	2001-01-06	2001-01-06 00:00:00	2001-01-06	581452		0	0	0		0	0	0	74756	0	52	40213296		
221097	4852	40213198	2013-09-27	2013-09-27 00:00:00	2013-09-27	2013-09-27 00:00:00	2013-09-27	581452		0	0	0		0	0	0	322817	0	133	40213198		
31618	2621	19133905	1994-11-17	1994-11-17 00:00:00	1994-11-26	1994-11-26 00:00:00	1994-11-26	38000177		0	0	9		0	0	0	173340	0	834102	19133905		
31678	2626	19078461	1976-01-25	1976-01-25 00:00:00	1976-03-25	1976-03-25 00:00:00	1976-03-25	38000177		0	0	60		0	0	0	173742	0	310965	19078461		
155514	3422	40213227	1998-09-28	1998-09-28 00:00:00	1998-09-28	1998-09-28 00:00:00	1998-09-28	581452		0	0	0		0	0	0	226999	0	113	40213227		
50616	4206	1127433	1959-01-15	1959-01-15 00:00:00	1959-02-12	1959-02-12 00:00:00	1959-02-12	38000177		0	0	28		0	0	0	279301	0	313782	1127433		
211913	4646	40213198	2010-04-27	2010-04-27 00:00:00	2010-04-27	2010-04-27 00:00:00	2010-04-27	581452		0	0	0		0	0	0	309816	0	133	40213198		
33035	2740	1713671	1973-06-22	1973-06-22 00:00:00	1973-06-29	1973-06-29 00:00:00	1973-06-29	38000177		0	0	7		0	0	0	181271	0	562251	1713671		
52799	4388	1127433	1981-06-03	1981-06-03 00:00:00	1981-06-10	1981-06-10 00:00:00	1981-06-10	38000177		0	0	7		0	0	0	291736	0	313782	1127433		
52880	4393	19133873	1987-10-02	1987-10-02 00:00:00	1987-10-14	1987-10-14 00:00:00	1987-10-14	38000177		0	0	12		0	0	0	292103	0	834061	19133873		
32656	2706	1118084	2006-11-19	2006-11-19 00:00:00	2006-11-19	2006-11-19 00:00:00	\N	38000177		0	0	0		0	0	0	179305	0	00025152531	44923712		
147274	3238	40213227	2009-01-19	2009-01-19 00:00:00	2009-01-19	2009-01-19 00:00:00	2009-01-19	581452		0	0	0		0	0	0	215296	0	113	40213227		
151164	3325	40213260	2013-07-17	2013-07-17 00:00:00	2013-07-17	2013-07-17 00:00:00	2013-07-17	581452		0	0	0		0	0	0	220740	0	121	40213260		
173020	3804	40213296	2001-06-07	2001-06-07 00:00:00	2001-06-07	2001-06-07 00:00:00	2001-06-07	581452		0	0	0		0	0	0	\N	0	52	40213296		
158452	3488	40213260	2006-02-17	2006-02-17 00:00:00	2006-02-17	2006-02-17 00:00:00	2006-02-17	581452		0	0	0		0	0	0	231410	0	121	40213260		
6477	141	40213180	2006-11-28	2006-11-28 00:00:00	2006-11-28	2006-11-28 00:00:00	2006-11-28	581452		0	0	0		0	0	0	9422	0	114	40213180		
195695	4299	40213160	1973-05-20	1973-05-20 00:00:00	1973-05-20	1973-05-20 00:00:00	1973-05-20	581452		0	0	0		0	0	0	285287	0	10	40213160		
201225	4418	40213198	2017-03-24	2017-03-24 00:00:00	2017-03-24	2017-03-24 00:00:00	2017-03-24	581452		0	0	0		0	0	0	293702	0	133	40213198		
158205	3483	40213160	1955-07-02	1955-07-02 00:00:00	1955-07-02	1955-07-02 00:00:00	1955-07-02	581452		0	0	0		0	0	0	231068	0	10	40213160		
80687	1764	40213160	1964-07-09	1964-07-09 00:00:00	1964-07-09	1964-07-09 00:00:00	1964-07-09	581452		0	0	0		0	0	0	117987	0	10	40213160		
55369	4596	19059056	1951-10-16	1951-10-16 00:00:00	1951-11-13	1951-11-13 00:00:00	1951-11-13	38000177		0	0	28		0	0	0	306266	0	243670	19059056		
89039	1952	40213227	2016-03-07	2016-03-07 00:00:00	2016-03-07	2016-03-07 00:00:00	2016-03-07	581452		0	0	0		0	0	0	129802	0	113	40213227		
89086	1953	40213227	2005-09-05	2005-09-05 00:00:00	2005-09-05	2005-09-05 00:00:00	2005-09-05	581452		0	0	0		0	0	0	129916	0	113	40213227		
541	40	40231925	2018-06-14	2018-06-14 00:00:00	2018-06-14	2018-06-14 00:00:00	\N	38000177		0	0	0		0	0	0	2866	0	1049221	40231925		
586	42	1118084	1950-05-16	1950-05-16 00:00:00	1950-05-16	1950-05-16 00:00:00	\N	38000177		0	0	0		0	0	0	3015	0	00025152531	44923712		
55700	4626	1713671	1984-04-24	1984-04-24 00:00:00	1984-05-15	1984-05-15 00:00:00	1984-05-15	38000177		0	0	21		0	0	0	308212	0	562251	1713671		
55725	4628	1127078	1969-06-26	1969-06-26 00:00:00	1969-07-10	1969-07-10 00:00:00	1969-07-10	38000177		0	0	14		0	0	0	308370	0	282464	1127078		
30120	2497	40171902	2017-08-17	2017-08-17 00:00:00	2017-08-17	2017-08-17 00:00:00	\N	38000177		0	0	0		0	0	0	165301	0	897718	40171902		
21503	1766	40169281	1984-01-10	1984-01-10 00:00:00	1984-01-10	1984-01-10 00:00:00	\N	38000177		0	0	0		0	0	0	118157	0	896209	40169281		
39046	3226	1127433	1995-10-09	1995-10-09 00:00:00	1995-10-16	1995-10-16 00:00:00	1995-10-16	38000177		0	0	7		0	0	0	214456	0	313782	1127433		
28982	2396	19059056	1924-05-21	1924-05-21 00:00:00	1924-06-04	1924-06-04 00:00:00	1924-06-04	38000177		0	0	14		0	0	0	159301	0	243670	19059056		
58200	4835	19074841	1987-06-30	1987-06-30 00:00:00	1987-07-14	1987-07-14 00:00:00	1987-07-14	38000177		0	0	14		0	0	0	321657	0	309043	19074841		
222356	4881	40213198	2013-10-06	2013-10-06 00:00:00	2013-10-06	2013-10-06 00:00:00	2013-10-06	581452		0	0	0		0	0	0	324565	0	133	40213198		
189153	4153	40213260	2015-03-26	2015-03-26 00:00:00	2015-03-26	2015-03-26 00:00:00	2015-03-26	581452		0	0	0		0	0	0	276074	0	121	40213260		
183323	4027	40213314	1977-04-09	1977-04-09 00:00:00	1977-04-09	1977-04-09 00:00:00	1977-04-09	581452		0	0	0		0	0	0	267907	0	49	40213314		
39641	3279	1127433	1958-07-11	1958-07-11 00:00:00	1958-07-25	1958-07-25 00:00:00	1958-07-25	38000177		0	0	14		0	0	0	217895	0	313782	1127433		
124525	2739	40213260	2006-04-05	2006-04-05 00:00:00	2006-04-05	2006-04-05 00:00:00	2006-04-05	581452		0	0	0		0	0	0	181227	0	121	40213260		
50192	4165	40229134	1960-10-22	1960-10-22 00:00:00	1960-11-05	1960-11-05 00:00:00	1960-11-05	38000177		0	0	14		0	0	0	276748	0	1043400	40229134		
144901	3184	40213260	2012-03-08	2012-03-08 00:00:00	2012-03-08	2012-03-08 00:00:00	2012-03-08	581452		0	0	0		0	0	0	211996	0	121	40213260		
58515	1280	40213198	2017-01-18	2017-01-18 00:00:00	2017-01-18	2017-01-18 00:00:00	2017-01-18	581452		0	0	0		0	0	0	84594	0	133	40213198		
39697	3283	19073183	1981-10-15	1981-10-15 00:00:00	1981-10-29	1981-10-29 00:00:00	1981-10-29	38000177		0	0	14		0	0	0	218142	0	308182	19073183		
107504	2356	40213251	1984-10-24	1984-10-24 00:00:00	1984-10-24	1984-10-24 00:00:00	1984-10-24	581452		0	0	0		0	0	0	156921	0	21	40213251		
162432	3572	40213160	1956-11-28	1956-11-28 00:00:00	1956-11-28	1956-11-28 00:00:00	1956-11-28	581452		0	0	0		0	0	0	237485	0	10	40213160		
216565	4753	40213260	2011-06-08	2011-06-08 00:00:00	2011-06-08	2011-06-08 00:00:00	2011-06-08	581452		0	0	0		0	0	0	316588	0	121	40213260		
59074	4909	19006318	1978-04-14	1978-04-14 00:00:00	1978-04-28	1978-04-28 00:00:00	1978-04-28	38000177		0	0	14		0	0	0	326247	0	105078	19006318		
235168	5166	40213227	2003-04-15	2003-04-15 00:00:00	2003-04-15	2003-04-15 00:00:00	2003-04-15	581452		0	0	0		0	0	0	343429	0	113	40213227		
55478	1215	40213296	2014-04-19	2014-04-19 00:00:00	2014-04-19	2014-04-19 00:00:00	2014-04-19	581452		0	0	0		0	0	0	80038	0	52	40213296		
159668	3514	40213296	2016-08-29	2016-08-29 00:00:00	2016-08-29	2016-08-29 00:00:00	2016-08-29	581452		0	0	0		0	0	0	233210	0	52	40213296		
60954	5068	1127433	1983-08-29	1983-08-29 00:00:00	1983-09-05	1983-09-05 00:00:00	1983-09-05	38000177		0	0	7		0	0	0	336949	0	313782	1127433		
46313	3836	19129655	1978-05-10	1978-05-10 00:00:00	1978-05-24	1978-05-24 00:00:00	1978-05-24	38000177		0	0	14		0	0	0	254739	0	789980	19129655		
39237	3241	1127433	1966-02-04	1966-02-04 00:00:00	1966-02-18	1966-02-18 00:00:00	1966-02-18	38000177		0	0	14		0	0	0	215445	0	313782	1127433		
56866	4720	920300	2016-07-16	2016-07-16 00:00:00	2016-07-23	2016-07-23 00:00:00	2016-07-23	38000177		0	0	7		0	0	0	314375	0	311989	920300		
49802	4131	19078461	1989-04-04	1989-04-04 00:00:00	1989-05-02	1989-05-02 00:00:00	1989-05-02	38000177		0	0	28		0	0	0	274668	0	310965	19078461		
28034	2320	1127433	1954-05-01	1954-05-01 00:00:00	1954-06-30	1954-06-30 00:00:00	1954-06-30	38000177		0	0	60		0	0	0	154302	0	313782	1127433		
190752	4191	40213296	1999-08-20	1999-08-20 00:00:00	1999-08-20	1999-08-20 00:00:00	1999-08-20	581452		0	0	0		0	0	0	278133	0	52	40213296		
193880	4260	40213227	2018-10-30	2018-10-30 00:00:00	2018-10-30	2018-10-30 00:00:00	2018-10-30	581452		0	0	0		0	0	0	282851	0	113	40213227		
81715	1785	40213160	1959-09-14	1959-09-14 00:00:00	1959-09-14	1959-09-14 00:00:00	1959-09-14	581452		0	0	0		0	0	0	119584	0	10	40213160		
44643	3695	40220386	1996-03-20	1996-03-20 00:00:00	1996-03-20	1996-03-20 00:00:00	1996-03-20	38000177		0	0	0		0	0	0	245605	0	1808217	40220386		
62616	5206	1127078	1986-05-11	1986-05-11 00:00:00	1986-06-01	1986-06-01 00:00:00	1986-06-01	38000177		0	0	21		0	0	0	346253	0	282464	1127078		
58014	4819	19133873	1962-10-18	1962-10-18 00:00:00	1962-10-25	1962-10-25 00:00:00	1962-10-25	38000177		0	0	7		0	0	0	320510	0	834061	19133873		
62733	5215	1115171	2017-12-22	2017-12-22 00:00:00	2018-01-05	2018-01-05 00:00:00	2018-01-05	38000177		0	0	14		0	0	0	346924	0	849574	1115171		
219722	4822	40213227	2008-11-26	2008-11-26 00:00:00	2008-11-26	2008-11-26 00:00:00	2008-11-26	581452		0	0	0		0	0	0	320791	0	113	40213227		
563	12	40213160	1963-10-09	1963-10-09 00:00:00	1963-10-09	1963-10-09 00:00:00	1963-10-09	581452		0	0	0		0	0	0	1023	0	10	40213160		
20360	443	40213160	1969-08-26	1969-08-26 00:00:00	1969-08-26	1969-08-26 00:00:00	1969-08-26	581452		0	0	0		0	0	0	29480	0	10	40213160		
51854	1135	40213227	2001-01-06	2001-01-06 00:00:00	2001-01-06	2001-01-06 00:00:00	2001-01-06	581452		0	0	0		0	0	0	74756	0	113	40213227		
104655	2295	40213296	2013-02-12	2013-02-12 00:00:00	2013-02-12	2013-02-12 00:00:00	2013-02-12	581452		0	0	0		0	0	0	152783	0	52	40213296		
31619	2621	19133873	1957-12-04	1957-12-04 00:00:00	1957-12-17	1957-12-17 00:00:00	1957-12-17	38000177		0	0	13		0	0	0	173350	0	834061	19133873		
31679	2626	1127433	1981-11-07	1981-11-07 00:00:00	1981-11-14	1981-11-14 00:00:00	1981-11-14	38000177		0	0	7		0	0	0	173710	0	313782	1127433		
155516	3422	40213227	2017-12-25	2017-12-25 00:00:00	2017-12-25	2017-12-25 00:00:00	2017-12-25	581452		0	0	0		0	0	0	226978	0	113	40213227		
50617	4206	19133873	1955-06-08	1955-06-08 00:00:00	1955-06-17	1955-06-17 00:00:00	1955-06-17	38000177		0	0	9		0	0	0	279284	0	834061	19133873		
211930	4646	40213227	1995-01-31	1995-01-31 00:00:00	1995-01-31	1995-01-31 00:00:00	1995-01-31	581452		0	0	0		0	0	0	309801	0	113	40213227		
33036	2740	19128065	1984-11-26	1984-11-26 00:00:00	1985-11-21	1985-11-21 00:00:00	1985-11-21	38000177		0	0	360		0	0	0	181282	0	749882	19128065		
52800	4388	19133873	1967-05-02	1967-05-02 00:00:00	1967-05-09	1967-05-09 00:00:00	1967-05-09	38000177		0	0	7		0	0	0	291658	0	834061	19133873		
52881	4393	1118084	2019-03-01	2019-03-01 00:00:00	2019-03-01	2019-03-01 00:00:00	\N	38000177		0	0	0		0	0	0	292114	0	00025152531	44923712		
32657	2706	19075601	2006-06-20	2006-06-20 00:00:00	2006-06-20	2006-06-20 00:00:00	\N	38000177		0	0	0		0	0	0	179305	0	309362	19075601		
147275	3238	40213296	2009-01-19	2009-01-19 00:00:00	2009-01-19	2009-01-19 00:00:00	2009-01-19	581452		0	0	0		0	0	0	215296	0	52	40213296		
151169	3325	40213227	1994-08-31	1994-08-31 00:00:00	1994-08-31	1994-08-31 00:00:00	1994-08-31	581452		0	0	0		0	0	0	220735	0	113	40213227		
173021	3804	40213160	1960-03-10	1960-03-10 00:00:00	1960-03-10	1960-03-10 00:00:00	1960-03-10	581452		0	0	0		0	0	0	252834	0	10	40213160		
5133	430	1127433	1986-01-05	1986-01-05 00:00:00	1986-01-19	1986-01-19 00:00:00	1986-01-19	38000177		0	0	14		0	0	0	28458	0	313782	1127433		
6480	141	40213160	1984-11-06	1984-11-06 00:00:00	1984-11-06	1984-11-06 00:00:00	1984-11-06	581452		0	0	0		0	0	0	9470	0	10	40213160		
195697	4299	40213227	2006-05-21	2006-05-21 00:00:00	2006-05-21	2006-05-21 00:00:00	2006-05-21	581452		0	0	0		0	0	0	285274	0	113	40213227		
153488	3378	40213160	1962-06-30	1962-06-30 00:00:00	1962-06-30	1962-06-30 00:00:00	1962-06-30	581452		0	0	0		0	0	0	224142	0	10	40213160		
158220	3483	40213227	2014-08-23	2014-08-23 00:00:00	2014-08-23	2014-08-23 00:00:00	2014-08-23	581452		0	0	0		0	0	0	231029	0	113	40213227		
80690	1764	40213227	2002-02-07	2002-02-07 00:00:00	2002-02-07	2002-02-07 00:00:00	2002-02-07	581452		0	0	0		0	0	0	117966	0	113	40213227		
55370	4596	40231925	1951-10-16	1951-10-16 00:00:00	1951-10-16	1951-10-16 00:00:00	\N	38000177		0	0	0		0	0	0	306266	0	1049221	40231925		
89041	1952	40213160	1955-04-11	1955-04-11 00:00:00	1955-04-11	1955-04-11 00:00:00	1955-04-11	581452		0	0	0		0	0	0	129784	0	10	40213160		
89090	1953	40213227	2015-11-02	2015-11-02 00:00:00	2015-11-02	2015-11-02 00:00:00	2015-11-02	581452		0	0	0		0	0	0	129943	0	113	40213227		
542	40	19078461	2018-06-14	2018-06-14 00:00:00	2018-07-14	2018-07-14 00:00:00	2018-07-14	38000177		0	0	30		0	0	0	2866	0	310965	19078461		
587	42	40220960	1994-10-04	1994-10-04 00:00:00	1994-10-04	1994-10-04 00:00:00	1994-10-04	38000177		0	0	0		0	0	0	3108	0	1804799	40220960		
55701	4626	1118084	2009-11-09	2009-11-09 00:00:00	2009-11-09	2009-11-09 00:00:00	\N	38000177		0	0	0		0	0	0	308206	0	00025152531	44923712		
55726	4628	1127078	1979-03-06	1979-03-06 00:00:00	1979-04-10	1979-04-10 00:00:00	1979-04-10	38000177		0	0	35		0	0	0	308348	0	282464	1127078		
30121	2497	19018935	2017-08-17	2017-08-17 00:00:00	2017-08-17	2017-08-17 00:00:00	\N	38000177		0	0	0		0	0	0	165301	0	197604	19018935		
21519	1769	1713671	2011-03-28	2011-03-28 00:00:00	2011-04-11	2011-04-11 00:00:00	2011-04-11	38000177		0	0	14		0	0	0	118286	0	562251	1713671		
39047	3226	19133873	1971-01-09	1971-01-09 00:00:00	1971-01-19	1971-01-19 00:00:00	1971-01-19	38000177		0	0	10		0	0	0	214455	0	834061	19133873		
28983	2396	19078461	2000-09-03	2000-09-03 00:00:00	2000-10-03	2000-10-03 00:00:00	2000-10-03	38000177		0	0	30		0	0	0	159324	0	310965	19078461		
58201	4835	19078461	1987-06-30	1987-06-30 00:00:00	1987-07-14	1987-07-14 00:00:00	1987-07-14	38000177		0	0	14		0	0	0	321657	0	310965	19078461		
222362	4881	40213227	1992-07-26	1992-07-26 00:00:00	1992-07-26	1992-07-26 00:00:00	1992-07-26	581452		0	0	0		0	0	0	324548	0	113	40213227		
189157	4153	40213160	1965-10-21	1965-10-21 00:00:00	1965-10-21	1965-10-21 00:00:00	1965-10-21	581452		0	0	0		0	0	0	276069	0	10	40213160		
183324	4027	40213227	2016-01-16	2016-01-16 00:00:00	2016-01-16	2016-01-16 00:00:00	2016-01-16	581452		0	0	0		0	0	0	267796	0	113	40213227		
39642	3279	1118084	1993-05-11	1993-05-11 00:00:00	1993-05-11	1993-05-11 00:00:00	\N	38000177		0	0	0		0	0	0	217915	0	00025152531	44923712		
124538	2740	40213227	2010-09-14	2010-09-14 00:00:00	2010-09-14	2010-09-14 00:00:00	2010-09-14	581452		0	0	0		0	0	0	181317	0	113	40213227		
50193	4165	1118084	1950-06-28	1950-06-28 00:00:00	1950-06-28	1950-06-28 00:00:00	\N	38000177		0	0	0		0	0	0	276796	0	00025152531	44923712		
144905	3184	40213296	2001-03-08	2001-03-08 00:00:00	2001-03-08	2001-03-08 00:00:00	2001-03-08	581452		0	0	0		0	0	0	212024	0	52	40213296		
58525	1280	40213227	2012-12-26	2012-12-26 00:00:00	2012-12-26	2012-12-26 00:00:00	2012-12-26	581452		0	0	0		0	0	0	84613	0	113	40213227		
39698	3283	1127078	1981-10-15	1981-10-15 00:00:00	1981-10-29	1981-10-29 00:00:00	1981-10-29	38000177		0	0	14		0	0	0	218142	0	282464	1127078		
107509	2356	40213227	2000-01-05	2000-01-05 00:00:00	2000-01-05	2000-01-05 00:00:00	2000-01-05	581452		0	0	0		0	0	0	156924	0	113	40213227		
162434	3572	40213160	1961-03-01	1961-03-01 00:00:00	1961-03-01	1961-03-01 00:00:00	1961-03-01	581452		0	0	0		0	0	0	237504	0	10	40213160		
177330	3896	40213251	1984-09-28	1984-09-28 00:00:00	1984-09-28	1984-09-28 00:00:00	1984-09-28	581452		0	0	0		0	0	0	259162	0	21	40213251		
59075	4909	19128022	1992-05-27	1992-05-27 00:00:00	1993-05-22	1993-05-22 00:00:00	1993-05-22	38000177		0	0	360		0	0	0	326275	0	749785	19128022		
235172	5166	40213201	2018-06-05	2018-06-05 00:00:00	2018-06-05	2018-06-05 00:00:00	2018-06-05	581452		0	0	0		0	0	0	343433	0	33	40213201		
55487	1215	40213160	1972-09-16	1972-09-16 00:00:00	1972-09-16	1972-09-16 00:00:00	1972-09-16	581452		0	0	0		0	0	0	80056	0	10	40213160		
170948	3757	40213198	2010-09-01	2010-09-01 00:00:00	2010-09-01	2010-09-01 00:00:00	2010-09-01	581452		0	0	0		0	0	0	249800	0	133	40213198		
60955	5068	19059056	1933-10-07	1933-10-07 00:00:00	1933-10-21	1933-10-21 00:00:00	1933-10-21	38000177		0	0	14		0	0	0	336950	0	243670	19059056		
46314	3836	19019979	1978-05-10	1978-05-10 00:00:00	1978-05-24	1978-05-24 00:00:00	1978-05-24	38000177		0	0	14		0	0	0	254739	0	198405	19019979		
39238	3241	1713671	2002-08-02	2002-08-02 00:00:00	2002-08-09	2002-08-09 00:00:00	2002-08-09	38000177		0	0	7		0	0	0	215524	0	562251	1713671		
56867	4720	40236824	2016-07-16	2016-07-16 00:00:00	2016-07-23	2016-07-23 00:00:00	2016-07-23	38000177		0	0	7		0	0	0	314375	0	1094107	40236824		
49803	4131	1713671	2018-06-25	2018-06-25 00:00:00	2018-07-09	2018-07-09 00:00:00	2018-07-09	38000177		0	0	14		0	0	0	274721	0	562251	1713671		
28035	2320	19074679	1942-01-10	1942-01-10 00:00:00	1942-05-23	1942-05-23 00:00:00	1942-05-23	38000177		0	0	133		0	0	0	154259	0	308971	19074679		
190766	4191	40213296	1997-08-22	1997-08-22 00:00:00	1997-08-22	1997-08-22 00:00:00	1997-08-22	581452		0	0	0		0	0	0	278155	0	52	40213296		
193884	4260	40213227	1998-03-10	1998-03-10 00:00:00	1998-03-10	1998-03-10 00:00:00	1998-03-10	581452		0	0	0		0	0	0	282756	0	113	40213227		
81717	1785	40213227	2016-09-26	2016-09-26 00:00:00	2016-09-26	2016-09-26 00:00:00	2016-09-26	581452		0	0	0		0	0	0	119592	0	113	40213227		
44644	3695	35605482	1996-03-20	1996-03-20 00:00:00	1996-03-20	1996-03-20 00:00:00	1996-03-20	38000177		0	0	0		0	0	0	245605	0	1740467	35605482		
62617	5206	1713671	2006-12-27	2006-12-27 00:00:00	2007-01-17	2007-01-17 00:00:00	2007-01-17	38000177		0	0	21		0	0	0	346259	0	562251	1713671		
58016	4820	19059056	1966-01-28	1966-01-28 00:00:00	1966-02-18	1966-02-18 00:00:00	1966-02-18	38000177		0	0	21		0	0	0	320644	0	243670	19059056		
62734	5215	19073188	2017-12-22	2017-12-22 00:00:00	2018-01-05	2018-01-05 00:00:00	2018-01-05	38000177		0	0	14		0	0	0	346924	0	308192	19073188		
125866	2770	40213201	1997-04-19	1997-04-19 00:00:00	1997-04-19	1997-04-19 00:00:00	1997-04-19	581452		0	0	0		0	0	0	183410	0	33	40213201		
566	12	40213160	1963-05-08	1963-05-08 00:00:00	1963-05-08	1963-05-08 00:00:00	1963-05-08	581452		0	0	0		0	0	0	1022	0	10	40213160		
20364	443	40213306	1991-01-14	1991-01-14 00:00:00	1991-01-14	1991-01-14 00:00:00	1991-01-14	581452		0	0	0		0	0	0	29468	0	43	40213306		
51859	1135	40213227	1992-01-11	1992-01-11 00:00:00	1992-01-11	1992-01-11 00:00:00	1992-01-11	581452		0	0	0		0	0	0	74781	0	113	40213227		
104659	2295	40213306	1994-09-27	1994-09-27 00:00:00	1994-09-27	1994-09-27 00:00:00	1994-09-27	581452		0	0	0		0	0	0	\N	0	43	40213306		
31620	2621	19059056	1969-09-21	1969-09-21 00:00:00	1969-10-19	1969-10-19 00:00:00	1969-10-19	38000177		0	0	28		0	0	0	173399	0	243670	19059056		
31680	2626	1127078	1968-02-06	1968-02-06 00:00:00	1968-04-06	1968-04-06 00:00:00	1968-04-06	38000177		0	0	60		0	0	0	173741	0	282464	1127078		
155517	3422	40213260	2017-12-25	2017-12-25 00:00:00	2017-12-25	2017-12-25 00:00:00	2017-12-25	581452		0	0	0		0	0	0	226978	0	121	40213260		
50618	4206	40169281	1985-09-16	1985-09-16 00:00:00	1985-09-16	1985-09-16 00:00:00	\N	38000177		0	0	0		0	0	0	279341	0	896209	40169281		
148797	3272	40213160	1975-05-20	1975-05-20 00:00:00	1975-05-20	1975-05-20 00:00:00	1975-05-20	581452		0	0	0		0	0	0	217437	0	10	40213160		
33037	2740	19128065	1982-12-07	1982-12-07 00:00:00	1983-12-02	1983-12-02 00:00:00	1983-12-02	38000177		0	0	360		0	0	0	181281	0	749882	19128065		
52801	4388	1713671	1991-04-02	1991-04-02 00:00:00	1991-04-23	1991-04-23 00:00:00	1991-04-23	38000177		0	0	21		0	0	0	291738	0	562251	1713671		
52882	4393	1713671	2018-04-16	2018-04-16 00:00:00	2018-05-07	2018-05-07 00:00:00	2018-05-07	38000177		0	0	21		0	0	0	292115	0	562251	1713671		
32658	2706	19126352	2006-06-20	2006-06-20 00:00:00	2006-06-20	2006-06-20 00:00:00	\N	38000177		0	0	0		0	0	0	179305	0	705129	19126352		
147278	3238	40213227	1998-03-23	1998-03-23 00:00:00	1998-03-23	1998-03-23 00:00:00	1998-03-23	581452		0	0	0		0	0	0	215283	0	113	40213227		
151177	3325	40213160	1968-05-29	1968-05-29 00:00:00	1968-05-29	1968-05-29 00:00:00	1968-05-29	581452		0	0	0		0	0	0	220698	0	10	40213160		
173027	3804	40213227	2011-07-14	2011-07-14 00:00:00	2011-07-14	2011-07-14 00:00:00	2011-07-14	581452		0	0	0		0	0	0	252896	0	113	40213227		
5134	430	1115171	1997-12-05	1997-12-05 00:00:00	1998-01-04	1998-01-04 00:00:00	1998-01-04	38000177		0	0	30		0	0	0	28540	0	849574	1115171		
139951	3074	40213227	2002-08-14	2002-08-14 00:00:00	2002-08-14	2002-08-14 00:00:00	2002-08-14	581452		0	0	0		0	0	0	204548	0	113	40213227		
195700	4299	40213296	2016-06-05	2016-06-05 00:00:00	2016-06-05	2016-06-05 00:00:00	2016-06-05	581452		0	0	0		0	0	0	285244	0	52	40213296		
153492	3378	40213160	1958-03-29	1958-03-29 00:00:00	1958-03-29	1958-03-29 00:00:00	1958-03-29	581452		0	0	0		0	0	0	224135	0	10	40213160		
158222	3483	40213260	2006-02-11	2006-02-11 00:00:00	2006-02-11	2006-02-11 00:00:00	2006-02-11	581452		0	0	0		0	0	0	231080	0	121	40213260		
80698	1764	40213227	1992-12-31	1992-12-31 00:00:00	1992-12-31	1992-12-31 00:00:00	1992-12-31	581452		0	0	0		0	0	0	117974	0	113	40213227		
55371	4596	19006318	1951-10-16	1951-10-16 00:00:00	1951-11-13	1951-11-13 00:00:00	1951-11-13	38000177		0	0	28		0	0	0	306266	0	105078	19006318		
89045	1952	40213160	1959-07-13	1959-07-13 00:00:00	1959-07-13	1959-07-13 00:00:00	1959-07-13	581452		0	0	0		0	0	0	129852	0	10	40213160		
89097	1953	40213160	1959-07-06	1959-07-06 00:00:00	1959-07-06	1959-07-06 00:00:00	1959-07-06	581452		0	0	0		0	0	0	129875	0	10	40213160		
543	40	19078461	1994-11-19	1994-11-19 00:00:00	1994-12-03	1994-12-03 00:00:00	1994-12-03	38000177		0	0	14		0	0	0	2864	0	310965	19078461		
588	42	1127433	1999-11-17	1999-11-17 00:00:00	1999-11-24	1999-11-24 00:00:00	1999-11-24	38000177		0	0	7		0	0	0	3059	0	313782	1127433		
55702	4626	1127433	1982-01-31	1982-01-31 00:00:00	1982-02-07	1982-02-07 00:00:00	1982-02-07	38000177		0	0	7		0	0	0	308232	0	313782	1127433		
55727	4628	19008572	1986-10-08	1986-10-08 00:00:00	1986-10-08	1986-10-08 00:00:00	\N	38000177		0	0	0		0	0	0	308310	0	106258	19008572		
30122	2497	40163554	2017-08-17	2017-08-17 00:00:00	2017-08-17	2017-08-17 00:00:00	\N	38000177		0	0	0		0	0	0	165301	0	855332	40163554		
21520	1769	1124300	2011-09-06	2011-09-06 00:00:00	2011-09-06	2011-09-06 00:00:00	\N	38000177		0	0	0		0	0	0	118286	0	00781178901	45011828		
39048	3226	19078461	1995-03-01	1995-03-01 00:00:00	1995-04-05	1995-04-05 00:00:00	1995-04-05	38000177		0	0	35		0	0	0	214450	0	310965	19078461		
28984	2396	1127433	1967-09-19	1967-09-19 00:00:00	1967-10-03	1967-10-03 00:00:00	1967-10-03	38000177		0	0	14		0	0	0	159398	0	313782	1127433		
58202	4835	1713671	1983-06-19	1983-06-19 00:00:00	1983-07-03	1983-07-03 00:00:00	1983-07-03	38000177		0	0	14		0	0	0	321630	0	562251	1713671		
222371	4881	40213160	1955-07-03	1955-07-03 00:00:00	1955-07-03	1955-07-03 00:00:00	1955-07-03	581452		0	0	0		0	0	0	324575	0	10	40213160		
189159	4153	40213160	1965-07-22	1965-07-22 00:00:00	1965-07-22	1965-07-22 00:00:00	1965-07-22	581452		0	0	0		0	0	0	276043	0	10	40213160		
183325	4027	40213296	2016-01-16	2016-01-16 00:00:00	2016-01-16	2016-01-16 00:00:00	2016-01-16	581452		0	0	0		0	0	0	267796	0	52	40213296		
39643	3279	40236824	2015-10-25	2015-10-25 00:00:00	2015-11-01	2015-11-01 00:00:00	2015-11-01	38000177		0	0	7		0	0	0	217917	0	1094107	40236824		
124539	2740	40213296	2010-09-14	2010-09-14 00:00:00	2010-09-14	2010-09-14 00:00:00	2010-09-14	581452		0	0	0		0	0	0	181317	0	52	40213296		
50194	4165	19133905	1938-05-15	1938-05-15 00:00:00	1938-05-28	1938-05-28 00:00:00	1938-05-28	38000177		0	0	13		0	0	0	276740	0	834102	19133905		
144911	3184	40213160	1961-06-08	1961-06-08 00:00:00	1961-06-08	1961-06-08 00:00:00	1961-06-08	581452		0	0	0		0	0	0	212003	0	10	40213160		
58533	1281	40213160	1970-04-11	1970-04-11 00:00:00	1970-04-11	1970-04-11 00:00:00	1970-04-11	581452		0	0	0		0	0	0	84638	0	10	40213160		
39699	3283	40229134	2001-12-12	2001-12-12 00:00:00	2001-12-19	2001-12-19 00:00:00	2001-12-19	38000177		0	0	7		0	0	0	218111	0	1043400	40229134		
107510	2356	40213306	2000-01-05	2000-01-05 00:00:00	2000-01-05	2000-01-05 00:00:00	2000-01-05	581452		0	0	0		0	0	0	156924	0	43	40213306		
162446	3572	40213296	1998-04-01	1998-04-01 00:00:00	1998-04-01	1998-04-01 00:00:00	1998-04-01	581452		0	0	0		0	0	0	237458	0	52	40213296		
13563	1136	19078461	2013-02-03	2013-02-03 00:00:00	2013-05-04	2013-05-04 00:00:00	2013-05-04	38000177		0	0	90		0	0	0	74824	0	310965	19078461		
59076	4909	1127078	1976-03-20	1976-03-20 00:00:00	1976-04-03	1976-04-03 00:00:00	1976-04-03	38000177		0	0	14		0	0	0	326246	0	282464	1127078		
235173	5166	40213227	1994-04-19	1994-04-19 00:00:00	1994-04-19	1994-04-19 00:00:00	1994-04-19	581452		0	0	0		0	0	0	343449	0	113	40213227		
211067	4628	40213260	2018-09-30	2018-09-30 00:00:00	2018-09-30	2018-09-30 00:00:00	2018-09-30	581452		0	0	0		0	0	0	308337	0	121	40213260		
95653	2097	40213251	1984-09-29	1984-09-29 00:00:00	1984-09-29	1984-09-29 00:00:00	1984-09-29	581452		0	0	0		0	0	0	139815	0	21	40213251		
60956	5068	1127433	1969-10-26	1969-10-26 00:00:00	1969-11-09	1969-11-09 00:00:00	1969-11-09	38000177		0	0	14		0	0	0	336970	0	313782	1127433		
56774	4712	1124300	2005-10-01	2005-10-01 00:00:00	2005-10-01	2005-10-01 00:00:00	\N	38000177		0	0	0		0	0	0	313776	0	00781178901	45011828		
39240	3241	19059056	1970-02-11	1970-02-11 00:00:00	1970-04-12	1970-04-12 00:00:00	1970-04-12	38000177		0	0	60		0	0	0	215440	0	243670	19059056		
56868	4720	40229134	1989-08-30	1989-08-30 00:00:00	1989-09-13	1989-09-13 00:00:00	1989-09-13	38000177		0	0	14		0	0	0	314402	0	1043400	40229134		
49804	4131	19128022	1991-06-03	1991-06-03 00:00:00	1992-05-28	1992-05-28 00:00:00	1992-05-28	38000177		0	0	360		0	0	0	274716	0	749785	19128022		
28036	2320	19006318	1947-05-03	1947-05-03 00:00:00	1947-05-17	1947-05-17 00:00:00	1947-05-17	38000177		0	0	14		0	0	0	154293	0	105078	19006318		
190776	4191	40213160	1962-07-27	1962-07-27 00:00:00	1962-07-27	1962-07-27 00:00:00	1962-07-27	581452		0	0	0		0	0	0	278159	0	10	40213160		
232265	5103	40213201	2010-01-11	2010-01-11 00:00:00	2010-01-11	2010-01-11 00:00:00	2010-01-11	581452		0	0	0		0	0	0	339078	0	33	40213201		
81722	1785	40213160	1955-03-14	1955-03-14 00:00:00	1955-03-14	1955-03-14 00:00:00	1955-03-14	581452		0	0	0		0	0	0	119627	0	10	40213160		
44645	3695	35605482	1996-03-20	1996-03-20 00:00:00	1996-03-20	1996-03-20 00:00:00	1996-03-20	38000177		0	0	0		0	0	0	245605	0	1740467	35605482		
62618	5207	1127433	1967-01-15	1967-01-15 00:00:00	1967-01-22	1967-01-22 00:00:00	1967-01-22	38000177		0	0	7		0	0	0	346335	0	313782	1127433		
58017	4820	19059056	1956-11-20	1956-11-20 00:00:00	1956-12-04	1956-12-04 00:00:00	1956-12-04	38000177		0	0	14		0	0	0	320641	0	243670	19059056		
62735	5215	1127433	2008-07-29	2008-07-29 00:00:00	2008-08-05	2008-08-05 00:00:00	2008-08-05	38000177		0	0	7		0	0	0	346890	0	313782	1127433		
65136	1426	40213160	1955-08-16	1955-08-16 00:00:00	1955-08-16	1955-08-16 00:00:00	1955-08-16	581452		0	0	0		0	0	0	94857	0	10	40213160		
570	12	40213296	2003-11-12	2003-11-12 00:00:00	2003-11-12	2003-11-12 00:00:00	2003-11-12	581452		0	0	0		0	0	0	1078	0	52	40213296		
20370	443	40213160	1969-03-24	1969-03-24 00:00:00	1969-03-24	1969-03-24 00:00:00	1969-03-24	581452		0	0	0		0	0	0	29479	0	10	40213160		
51864	1135	40213227	2010-01-02	2010-01-02 00:00:00	2010-01-02	2010-01-02 00:00:00	2010-01-02	581452		0	0	0		0	0	0	74801	0	113	40213227		
104661	2295	40213227	1994-09-27	1994-09-27 00:00:00	1994-09-27	1994-09-27 00:00:00	1994-09-27	581452		0	0	0		0	0	0	\N	0	113	40213227		
31621	2621	19059056	1964-10-12	1964-10-12 00:00:00	1964-10-26	1964-10-26 00:00:00	1964-10-26	38000177		0	0	14		0	0	0	173397	0	243670	19059056		
31681	2626	1127433	2007-12-19	2007-12-19 00:00:00	2008-01-02	2008-01-02 00:00:00	2008-01-02	38000177		0	0	14		0	0	0	173682	0	313782	1127433		
155519	3422	40213306	1987-09-21	1987-09-21 00:00:00	1987-09-21	1987-09-21 00:00:00	1987-09-21	581452		0	0	0		0	0	0	226960	0	43	40213306		
50619	4206	40165015	1993-04-14	1993-04-14 00:00:00	1993-04-14	1993-04-14 00:00:00	\N	38000177		0	0	0		0	0	0	279326	0	861467	40165015		
148798	3272	40213227	2001-08-21	2001-08-21 00:00:00	2001-08-21	2001-08-21 00:00:00	2001-08-21	581452		0	0	0		0	0	0	217482	0	113	40213227		
33038	2740	1713671	2007-12-01	2007-12-01 00:00:00	2007-12-22	2007-12-22 00:00:00	2007-12-22	38000177		0	0	21		0	0	0	181308	0	562251	1713671		
52802	4388	19059056	1968-05-11	1968-05-11 00:00:00	1968-05-25	1968-05-25 00:00:00	1968-05-25	38000177		0	0	14		0	0	0	291634	0	243670	19059056		
52883	4393	1127433	2006-04-12	2006-04-12 00:00:00	2006-04-19	2006-04-19 00:00:00	2006-04-19	38000177		0	0	7		0	0	0	292089	0	313782	1127433		
32664	2708	1115171	2000-05-18	2000-05-18 00:00:00	2000-06-08	2000-06-08 00:00:00	2000-06-08	38000177		0	0	21		0	0	0	179434	0	849574	1115171		
147287	3238	40213227	2018-03-12	2018-03-12 00:00:00	2018-03-12	2018-03-12 00:00:00	2018-03-12	581452		0	0	0		0	0	0	215287	0	113	40213227		
151178	3325	40213160	1963-11-27	1963-11-27 00:00:00	1963-11-27	1963-11-27 00:00:00	1963-11-27	581452		0	0	0		0	0	0	220730	0	10	40213160		
173028	3804	40213260	2011-07-14	2011-07-14 00:00:00	2011-07-14	2011-07-14 00:00:00	2011-07-14	581452		0	0	0		0	0	0	252896	0	121	40213260		
5135	430	1127433	1973-03-11	1973-03-11 00:00:00	1973-04-15	1973-04-15 00:00:00	1973-04-15	38000177		0	0	35		0	0	0	28539	0	313782	1127433		
139957	3074	40213160	1955-08-10	1955-08-10 00:00:00	1955-08-10	1955-08-10 00:00:00	1955-08-10	581452		0	0	0		0	0	0	204588	0	10	40213160		
195705	4299	40213160	1973-07-22	1973-07-22 00:00:00	1973-07-22	1973-07-22 00:00:00	1973-07-22	581452		0	0	0		0	0	0	285280	0	10	40213160		
80563	1762	40213227	2002-01-31	2002-01-31 00:00:00	2002-01-31	2002-01-31 00:00:00	2002-01-31	581452		0	0	0		0	0	0	117821	0	113	40213227		
158225	3483	40213160	1955-12-31	1955-12-31 00:00:00	1955-12-31	1955-12-31 00:00:00	1955-12-31	581452		0	0	0		0	0	0	231101	0	10	40213160		
100979	2213	40213227	2003-04-16	2003-04-16 00:00:00	2003-04-16	2003-04-16 00:00:00	2003-04-16	581452		0	0	0		0	0	0	147404	0	113	40213227		
55372	4596	19059056	1954-07-30	1954-07-30 00:00:00	1954-08-20	1954-08-20 00:00:00	1954-08-20	38000177		0	0	21		0	0	0	306267	0	243670	19059056		
89048	1952	40213160	1955-01-10	1955-01-10 00:00:00	1955-01-10	1955-01-10 00:00:00	1955-01-10	581452		0	0	0		0	0	0	129827	0	10	40213160		
89099	1953	40213160	1955-04-18	1955-04-18 00:00:00	1955-04-18	1955-04-18 00:00:00	1955-04-18	581452		0	0	0		0	0	0	129932	0	10	40213160		
544	40	19059056	1961-03-17	1961-03-17 00:00:00	1961-04-14	1961-04-14 00:00:00	1961-04-14	38000177		0	0	28		0	0	0	2862	0	243670	19059056		
589	42	1127433	1953-06-19	1953-06-19 00:00:00	1953-07-03	1953-07-03 00:00:00	1953-07-03	38000177		0	0	14		0	0	0	3016	0	313782	1127433		
55703	4626	19128065	1989-10-30	1989-10-30 00:00:00	1990-10-25	1990-10-25 00:00:00	1990-10-25	38000177		0	0	360		0	0	0	308171	0	749882	19128065		
55728	4628	46233988	1970-05-05	1970-05-05 00:00:00	1970-05-19	1970-05-19 00:00:00	1970-05-19	38000177		0	0	14		0	0	0	308314	0	1652673	46233988		
30123	2497	1127078	1967-08-17	1967-08-17 00:00:00	1967-08-31	1967-08-31 00:00:00	1967-08-31	38000177		0	0	14		0	0	0	165354	0	282464	1127078		
21521	1769	1713671	2003-09-23	2003-09-23 00:00:00	2003-10-07	2003-10-07 00:00:00	2003-10-07	38000177		0	0	14		0	0	0	118301	0	562251	1713671		
39049	3226	40229134	1982-01-28	1982-01-28 00:00:00	1982-02-11	1982-02-11 00:00:00	1982-02-11	38000177		0	0	14		0	0	0	214494	0	1043400	40229134		
28985	2396	19059056	1921-11-21	1921-11-21 00:00:00	1921-12-05	1921-12-05 00:00:00	1921-12-05	38000177		0	0	14		0	0	0	159300	0	243670	19059056		
58203	4835	1118084	2010-04-10	2010-04-10 00:00:00	2010-04-10	2010-04-10 00:00:00	\N	38000177		0	0	0		0	0	0	321644	0	00025152531	44923712		
52356	1145	40213227	1992-01-29	1992-01-29 00:00:00	1992-01-29	1992-01-29 00:00:00	1992-01-29	581452		0	0	0		0	0	0	75613	0	113	40213227		
189161	4153	40213306	1987-02-19	1987-02-19 00:00:00	1987-02-19	1987-02-19 00:00:00	1987-02-19	581452		0	0	0		0	0	0	276072	0	43	40213306		
183329	4027	40213314	1977-10-08	1977-10-08 00:00:00	1977-10-08	1977-10-08 00:00:00	1977-10-08	581452		0	0	0		0	0	0	267816	0	49	40213314		
39644	3279	920300	2015-10-25	2015-10-25 00:00:00	2015-11-01	2015-11-01 00:00:00	2015-11-01	38000177		0	0	7		0	0	0	217917	0	311989	920300		
124543	2740	40213227	2000-06-20	2000-06-20 00:00:00	2000-06-20	2000-06-20 00:00:00	2000-06-20	581452		0	0	0		0	0	0	181303	0	113	40213227		
50195	4165	1127433	1912-03-15	1912-03-15 00:00:00	1912-03-29	1912-03-29 00:00:00	1912-03-29	38000177		0	0	14		0	0	0	276694	0	313782	1127433		
129912	2857	40213306	1986-10-29	1986-10-29 00:00:00	1986-10-29	1986-10-29 00:00:00	1986-10-29	581452		0	0	0		0	0	0	189705	0	43	40213306		
69814	1526	40213227	2014-01-09	2014-01-09 00:00:00	2014-01-09	2014-01-09 00:00:00	2014-01-09	581452		0	0	0		0	0	0	102047	0	113	40213227		
39700	3283	1118084	2016-05-25	2016-05-25 00:00:00	2016-05-25	2016-05-25 00:00:00	\N	38000177		0	0	0		0	0	0	218122	0	00025152531	44923712		
107512	2356	40213314	1979-01-10	1979-01-10 00:00:00	1979-01-10	1979-01-10 00:00:00	1979-01-10	581452		0	0	0		0	0	0	156918	0	49	40213314		
162448	3572	40213227	1998-04-01	1998-04-01 00:00:00	1998-04-01	1998-04-01 00:00:00	1998-04-01	581452		0	0	0		0	0	0	237458	0	113	40213227		
13564	1136	40231925	1984-11-02	1984-11-02 00:00:00	1984-11-02	1984-11-02 00:00:00	\N	38000177		0	0	0		0	0	0	74865	0	1049221	40231925		
59077	4909	19006318	1976-03-20	1976-03-20 00:00:00	1976-04-03	1976-04-03 00:00:00	1976-04-03	38000177		0	0	14		0	0	0	326246	0	105078	19006318		
235191	5166	40213160	1955-03-15	1955-03-15 00:00:00	1955-03-15	1955-03-15 00:00:00	1955-03-15	581452		0	0	0		0	0	0	343477	0	10	40213160		
118989	2617	40213160	1956-01-14	1956-01-14 00:00:00	1956-01-14	1956-01-14 00:00:00	1956-01-14	581452		0	0	0		0	0	0	173035	0	10	40213160		
95655	2097	40213160	1977-11-12	1977-11-12 00:00:00	1977-11-12	1977-11-12 00:00:00	1977-11-12	581452		0	0	0		0	0	0	139812	0	10	40213160		
60957	5068	1127433	1962-04-09	1962-04-09 00:00:00	1962-04-16	1962-04-16 00:00:00	1962-04-16	38000177		0	0	7		0	0	0	336969	0	313782	1127433		
56775	4712	1713671	2019-03-31	2019-03-31 00:00:00	2019-04-21	2019-04-21 00:00:00	2019-04-21	38000177		0	0	21		0	0	0	313790	0	562251	1713671		
39242	3241	1713671	1976-05-31	1976-05-31 00:00:00	1976-06-21	1976-06-21 00:00:00	1976-06-21	38000177		0	0	21		0	0	0	215486	0	562251	1713671		
56082	1228	40213314	1977-06-11	1977-06-11 00:00:00	1977-06-11	1977-06-11 00:00:00	1977-06-11	581452		0	0	0		0	0	0	80899	0	49	40213314		
9335	199	40213198	2010-02-10	2010-02-10 00:00:00	2010-02-10	2010-02-10 00:00:00	2010-02-10	581452		0	0	0		0	0	0	13730	0	133	40213198		
28037	2320	1127433	2001-08-23	2001-08-23 00:00:00	2001-08-30	2001-08-30 00:00:00	2001-08-30	38000177		0	0	7		0	0	0	154287	0	313782	1127433		
190779	4191	40213227	2008-08-22	2008-08-22 00:00:00	2008-08-22	2008-08-22 00:00:00	2008-08-22	581452		0	0	0		0	0	0	278134	0	113	40213227		
232266	5103	40213198	2010-01-11	2010-01-11 00:00:00	2010-01-11	2010-01-11 00:00:00	2010-01-11	581452		0	0	0		0	0	0	339078	0	133	40213198		
81724	1785	40213160	1955-06-13	1955-06-13 00:00:00	1955-06-13	1955-06-13 00:00:00	1955-06-13	581452		0	0	0		0	0	0	119600	0	10	40213160		
44646	3695	19078924	1996-03-20	1996-03-20 00:00:00	1996-03-20	1996-03-20 00:00:00	1996-03-20	38000177		0	0	0		0	0	0	245605	0	311700	19078924		
62620	5207	19078461	1980-12-05	1980-12-05 00:00:00	1980-12-26	1980-12-26 00:00:00	1980-12-26	38000177		0	0	21		0	0	0	346376	0	310965	19078461		
58018	4820	1124300	1995-10-07	1995-10-07 00:00:00	1995-10-07	1995-10-07 00:00:00	\N	38000177		0	0	0		0	0	0	320626	0	00781178901	45011828		
62736	5215	1713671	1958-12-13	1958-12-13 00:00:00	1958-12-27	1958-12-27 00:00:00	1958-12-27	38000177		0	0	14		0	0	0	346866	0	562251	1713671		
65148	1426	40213201	2018-06-12	2018-06-12 00:00:00	2018-06-12	2018-06-12 00:00:00	2018-06-12	581452		0	0	0		0	0	0	94845	0	33	40213201		
580	12	40213227	1995-11-01	1995-11-01 00:00:00	1995-11-01	1995-11-01 00:00:00	1995-11-01	581452		0	0	0		0	0	0	1077	0	113	40213227		
20374	443	40213260	2018-12-17	2018-12-17 00:00:00	2018-12-17	2018-12-17 00:00:00	2018-12-17	581452		0	0	0		0	0	0	29450	0	121	40213260		
51865	1135	40213260	2010-01-02	2010-01-02 00:00:00	2010-01-02	2010-01-02 00:00:00	2010-01-02	581452		0	0	0		0	0	0	74801	0	121	40213260		
104662	2295	40213160	1973-10-16	1973-10-16 00:00:00	1973-10-16	1973-10-16 00:00:00	1973-10-16	581452		0	0	0		0	0	0	152762	0	10	40213160		
31622	2621	1127433	2004-01-26	2004-01-26 00:00:00	2004-02-09	2004-02-09 00:00:00	2004-02-09	38000177		0	0	14		0	0	0	173394	0	313782	1127433		
31682	2626	19133905	2003-12-20	2003-12-20 00:00:00	2004-01-02	2004-01-02 00:00:00	2004-01-02	38000177		0	0	13		0	0	0	173716	0	834102	19133905		
215183	4719	40213227	2015-12-06	2015-12-06 00:00:00	2015-12-06	2015-12-06 00:00:00	2015-12-06	581452		0	0	0		0	0	0	314196	0	113	40213227		
50620	4206	19059056	1968-08-23	1968-08-23 00:00:00	1968-09-20	1968-09-20 00:00:00	1968-09-20	38000177		0	0	28		0	0	0	279331	0	243670	19059056		
148802	3272	40213306	1992-08-11	1992-08-11 00:00:00	1992-08-11	1992-08-11 00:00:00	1992-08-11	581452		0	0	0		0	0	0	217479	0	43	40213306		
33039	2740	19128022	1994-10-05	1994-10-05 00:00:00	1995-09-30	1995-09-30 00:00:00	1995-09-30	38000177		0	0	360		0	0	0	181311	0	749785	19128022		
52803	4388	1127078	1974-01-29	1974-01-29 00:00:00	1974-02-19	1974-02-19 00:00:00	1974-02-19	38000177		0	0	21		0	0	0	291637	0	282464	1127078		
52884	4393	19133873	1990-12-30	1990-12-30 00:00:00	1991-01-07	1991-01-07 00:00:00	1991-01-07	38000177		0	0	8		0	0	0	292116	0	834061	19133873		
32665	2708	1127433	1993-11-02	1993-11-02 00:00:00	1993-11-23	1993-11-23 00:00:00	1993-11-23	38000177		0	0	21		0	0	0	179432	0	313782	1127433		
147288	3238	40213260	2018-03-12	2018-03-12 00:00:00	2018-03-12	2018-03-12 00:00:00	2018-03-12	581452		0	0	0		0	0	0	215287	0	121	40213260		
151185	3325	40213296	2003-07-23	2003-07-23 00:00:00	2003-07-23	2003-07-23 00:00:00	2003-07-23	581452		0	0	0		0	0	0	220738	0	52	40213296		
173029	3804	40213160	1960-05-12	1960-05-12 00:00:00	1960-05-12	1960-05-12 00:00:00	1960-05-12	581452		0	0	0		0	0	0	252878	0	10	40213160		
5136	430	19133905	1965-05-23	1965-05-23 00:00:00	1965-06-05	1965-06-05 00:00:00	1965-06-05	38000177		0	0	13		0	0	0	28457	0	834102	19133905		
139973	3074	40213227	2012-06-27	2012-06-27 00:00:00	2012-06-27	2012-06-27 00:00:00	2012-06-27	581452		0	0	0		0	0	0	204551	0	113	40213227		
195708	4299	40213306	1995-06-25	1995-06-25 00:00:00	1995-06-25	1995-06-25 00:00:00	1995-06-25	581452		0	0	0		0	0	0	285251	0	43	40213306		
80594	1762	40213227	2012-03-29	2012-03-29 00:00:00	2012-03-29	2012-03-29 00:00:00	2012-03-29	581452		0	0	0		0	0	0	117811	0	113	40213227		
158229	3483	40213227	2004-01-31	2004-01-31 00:00:00	2004-01-31	2004-01-31 00:00:00	2004-01-31	581452		0	0	0		0	0	0	231036	0	113	40213227		
100980	2213	40213296	2003-04-16	2003-04-16 00:00:00	2003-04-16	2003-04-16 00:00:00	2003-04-16	581452		0	0	0		0	0	0	147404	0	52	40213296		
55373	4596	1127433	1957-06-18	1957-06-18 00:00:00	1957-06-25	1957-06-25 00:00:00	1957-06-25	38000177		0	0	7		0	0	0	306287	0	313782	1127433		
89055	1952	40213296	1996-01-22	1996-01-22 00:00:00	1996-01-22	1996-01-22 00:00:00	1996-01-22	581452		0	0	0		0	0	0	129807	0	52	40213296		
89100	1953	40213160	1955-07-18	1955-07-18 00:00:00	1955-07-18	1955-07-18 00:00:00	1955-07-18	581452		0	0	0		0	0	0	129873	0	10	40213160		
545	40	19059056	1952-11-29	1952-11-29 00:00:00	1952-12-13	1952-12-13 00:00:00	1952-12-13	38000177		0	0	14		0	0	0	2880	0	243670	19059056		
590	42	40229134	1985-02-03	1985-02-03 00:00:00	1985-02-17	1985-02-17 00:00:00	1985-02-17	38000177		0	0	14		0	0	0	3066	0	1043400	40229134		
55704	4626	40229134	2017-11-16	2017-11-16 00:00:00	2017-11-30	2017-11-30 00:00:00	2017-11-30	38000177		0	0	14		0	0	0	308170	0	1043400	40229134		
55729	4628	19059056	1970-05-05	1970-05-05 00:00:00	1970-05-19	1970-05-19 00:00:00	1970-05-19	38000177		0	0	14		0	0	0	308314	0	243670	19059056		
30124	2497	19129655	1967-08-17	1967-08-17 00:00:00	1967-08-31	1967-08-31 00:00:00	1967-08-31	38000177		0	0	14		0	0	0	165354	0	789980	19129655		
21522	1769	19128022	1992-08-31	1992-08-31 00:00:00	1993-08-26	1993-08-26 00:00:00	1993-08-26	38000177		0	0	360		0	0	0	118303	0	749785	19128022		
39050	3227	40162522	1986-02-26	1986-02-26 00:00:00	1986-02-26	1986-02-26 00:00:00	\N	38000177		0	0	0		0	0	0	214542	0	857005	40162522		
28986	2396	964261	1995-10-31	1995-10-31 00:00:00	1995-10-31	1995-10-31 00:00:00	\N	38000177		0	0	0		0	0	0	159375	0	2001499	964261		
58204	4835	1713671	1981-03-09	1981-03-09 00:00:00	1981-03-23	1981-03-23 00:00:00	1981-03-23	38000177		0	0	14		0	0	0	321654	0	562251	1713671		
52369	1145	40213227	2010-05-12	2010-05-12 00:00:00	2010-05-12	2010-05-12 00:00:00	2010-05-12	581452		0	0	0		0	0	0	75606	0	113	40213227		
189170	4153	40213227	2007-01-18	2007-01-18 00:00:00	2007-01-18	2007-01-18 00:00:00	2007-01-18	581452		0	0	0		0	0	0	276058	0	113	40213227		
183333	4027	40213160	1974-09-14	1974-09-14 00:00:00	1974-09-14	1974-09-14 00:00:00	1974-09-14	581452		0	0	0		0	0	0	267904	0	10	40213160		
39645	3279	1127433	2016-08-04	2016-08-04 00:00:00	2016-08-18	2016-08-18 00:00:00	2016-08-18	38000177		0	0	14		0	0	0	217918	0	313782	1127433		
124546	2740	40213160	1969-08-19	1969-08-19 00:00:00	1969-08-19	1969-08-19 00:00:00	1969-08-19	581452		0	0	0		0	0	0	181312	0	10	40213160		
50196	4165	19059056	1912-08-11	1912-08-11 00:00:00	1912-08-25	1912-08-25 00:00:00	1912-08-25	38000177		0	0	14		0	0	0	276725	0	243670	19059056		
129915	2857	40213160	1964-11-18	1964-11-18 00:00:00	1964-11-18	1964-11-18 00:00:00	1964-11-18	581452		0	0	0		0	0	0	189689	0	10	40213160		
69815	1526	40213296	2014-01-09	2014-01-09 00:00:00	2014-01-09	2014-01-09 00:00:00	2014-01-09	581452		0	0	0		0	0	0	102047	0	52	40213296		
39701	3283	40231925	2018-10-12	2018-10-12 00:00:00	2018-10-12	2018-10-12 00:00:00	\N	38000177		0	0	0		0	0	0	218108	0	1049221	40231925		
107517	2356	40213160	1978-07-12	1978-07-12 00:00:00	1978-07-12	1978-07-12 00:00:00	1978-07-12	581452		0	0	0		0	0	0	156872	0	10	40213160		
162453	3572	40213160	1956-08-29	1956-08-29 00:00:00	1956-08-29	1956-08-29 00:00:00	1956-08-29	581452		0	0	0		0	0	0	237467	0	10	40213160		
13565	1136	19078461	1984-11-02	1984-11-02 00:00:00	1985-01-31	1985-01-31 00:00:00	1985-01-31	38000177		0	0	90		0	0	0	74865	0	310965	19078461		
59078	4909	1127078	1977-06-05	1977-06-05 00:00:00	1977-07-10	1977-07-10 00:00:00	1977-07-10	38000177		0	0	35		0	0	0	326276	0	282464	1127078		
235201	5166	40213260	2006-05-02	2006-05-02 00:00:00	2006-05-02	2006-05-02 00:00:00	2006-05-02	581452		0	0	0		0	0	0	343489	0	121	40213260		
118996	2617	40213201	2018-09-29	2018-09-29 00:00:00	2018-09-29	2018-09-29 00:00:00	2018-09-29	581452		0	0	0		0	0	0	173050	0	33	40213201		
95658	2097	40213227	1999-04-03	1999-04-03 00:00:00	1999-04-03	1999-04-03 00:00:00	1999-04-03	581452		0	0	0		0	0	0	139787	0	113	40213227		
60958	5068	19133905	1984-12-02	1984-12-02 00:00:00	1984-12-10	1984-12-10 00:00:00	1984-12-10	38000177		0	0	8		0	0	0	336923	0	834102	19133905		
56776	4712	1127433	2013-02-28	2013-02-28 00:00:00	2013-03-07	2013-03-07 00:00:00	2013-03-07	38000177		0	0	7		0	0	0	313762	0	313782	1127433		
39243	3241	19059056	1987-03-19	1987-03-19 00:00:00	1987-04-18	1987-04-18 00:00:00	1987-04-18	38000177		0	0	30		0	0	0	215442	0	243670	19059056		
56088	1228	40213227	2006-04-08	2006-04-08 00:00:00	2006-04-08	2006-04-08 00:00:00	2006-04-08	581452		0	0	0		0	0	0	80872	0	113	40213227		
9337	199	40213227	2013-02-27	2013-02-27 00:00:00	2013-02-27	2013-02-27 00:00:00	2013-02-27	581452		0	0	0		0	0	0	13670	0	113	40213227		
28038	2320	1115171	2017-12-10	2017-12-10 00:00:00	2017-12-31	2017-12-31 00:00:00	2017-12-31	38000177		0	0	21		0	0	0	154304	0	849574	1115171		
190780	4191	40213260	2008-08-22	2008-08-22 00:00:00	2008-08-22	2008-08-22 00:00:00	2008-08-22	581452		0	0	0		0	0	0	278134	0	121	40213260		
232280	5104	40213160	1980-08-10	1980-08-10 00:00:00	1980-08-10	1980-08-10 00:00:00	1980-08-10	581452		0	0	0		0	0	0	339218	0	10	40213160		
240230	5274	40213227	1994-04-17	1994-04-17 00:00:00	1994-04-17	1994-04-17 00:00:00	1994-04-17	581452		0	0	0		0	0	0	350794	0	113	40213227		
44647	3695	1127433	2008-03-29	2008-03-29 00:00:00	2008-04-19	2008-04-19 00:00:00	2008-04-19	38000177		0	0	21		0	0	0	245607	0	313782	1127433		
62621	5207	1127433	2001-07-21	2001-07-21 00:00:00	2001-07-28	2001-07-28 00:00:00	2001-07-28	38000177		0	0	7		0	0	0	346349	0	313782	1127433		
58019	4820	40229134	1982-12-05	1982-12-05 00:00:00	1982-12-19	1982-12-19 00:00:00	1982-12-19	38000177		0	0	14		0	0	0	320668	0	1043400	40229134		
62737	5215	1115171	2008-08-06	2008-08-06 00:00:00	2008-09-10	2008-09-10 00:00:00	2008-09-10	38000177		0	0	35		0	0	0	346923	0	849574	1115171		
65149	1426	40213260	2006-04-04	2006-04-04 00:00:00	2006-04-04	2006-04-04 00:00:00	2006-04-04	581452		0	0	0		0	0	0	94796	0	121	40213260		
584	12	40213160	1963-07-10	1963-07-10 00:00:00	1963-07-10	1963-07-10 00:00:00	1963-07-10	581452		0	0	0		0	0	0	1007	0	10	40213160		
20377	443	40213227	2000-01-24	2000-01-24 00:00:00	2000-01-24	2000-01-24 00:00:00	2000-01-24	581452		0	0	0		0	0	0	29471	0	113	40213227		
51869	1135	40213160	1963-12-07	1963-12-07 00:00:00	1963-12-07	1963-12-07 00:00:00	1963-12-07	581452		0	0	0		0	0	0	74769	0	10	40213160		
104664	2295	40213314	1977-01-11	1977-01-11 00:00:00	1977-01-11	1977-01-11 00:00:00	1977-01-11	581452		0	0	0		0	0	0	152788	0	49	40213314		
31623	2621	19078461	1989-04-28	1989-04-28 00:00:00	1989-06-02	1989-06-02 00:00:00	1989-06-02	38000177		0	0	35		0	0	0	173401	0	310965	19078461		
31684	2626	1115171	2014-01-05	2014-01-05 00:00:00	2014-01-19	2014-01-19 00:00:00	2014-01-19	38000177		0	0	14		0	0	0	173744	0	849574	1115171		
215187	4719	40213227	2006-10-15	2006-10-15 00:00:00	2006-10-15	2006-10-15 00:00:00	2006-10-15	581452		0	0	0		0	0	0	314199	0	113	40213227		
50621	4206	40229134	1980-09-16	1980-09-16 00:00:00	1980-09-23	1980-09-23 00:00:00	1980-09-23	38000177		0	0	7		0	0	0	279298	0	1043400	40229134		
148803	3272	40213227	1992-08-11	1992-08-11 00:00:00	1992-08-11	1992-08-11 00:00:00	1992-08-11	581452		0	0	0		0	0	0	217479	0	113	40213227		
33040	2740	19128022	1990-10-26	1990-10-26 00:00:00	1991-10-21	1991-10-21 00:00:00	1991-10-21	38000177		0	0	360		0	0	0	181327	0	749785	19128022		
52804	4388	19133905	2000-04-04	2000-04-04 00:00:00	2000-04-15	2000-04-15 00:00:00	2000-04-15	38000177		0	0	11		0	0	0	291710	0	834102	19133905		
178305	3920	40213296	2014-09-06	2014-09-06 00:00:00	2014-09-06	2014-09-06 00:00:00	2014-09-06	581452		0	0	0		0	0	0	260683	0	52	40213296		
32666	2708	1124300	1988-10-16	1988-10-16 00:00:00	1988-10-16	1988-10-16 00:00:00	\N	38000177		0	0	0		0	0	0	179431	0	00781178901	45011828		
147289	3238	40213160	1967-08-07	1967-08-07 00:00:00	1967-08-07	1967-08-07 00:00:00	1967-08-07	581452		0	0	0		0	0	0	215306	0	10	40213160		
151188	3325	40213160	1963-09-25	1963-09-25 00:00:00	1963-09-25	1963-09-25 00:00:00	1963-09-25	581452		0	0	0		0	0	0	220702	0	10	40213160		
173041	3804	40213296	1999-12-09	1999-12-09 00:00:00	1999-12-09	1999-12-09 00:00:00	1999-12-09	581452		0	0	0		0	0	0	252893	0	52	40213296		
5137	430	40229134	1954-10-11	1954-10-11 00:00:00	1954-10-18	1954-10-18 00:00:00	1954-10-18	38000177		0	0	7		0	0	0	28431	0	1043400	40229134		
139977	3074	40213198	2016-07-20	2016-07-20 00:00:00	2016-07-20	2016-07-20 00:00:00	2016-07-20	581452		0	0	0		0	0	0	204608	0	133	40213198		
77514	1695	40213160	1966-04-07	1966-04-07 00:00:00	1966-04-07	1966-04-07 00:00:00	1966-04-07	581452		0	0	0		0	0	0	113496	0	10	40213160		
109036	2392	40213227	2007-07-13	2007-07-13 00:00:00	2007-07-13	2007-07-13 00:00:00	2007-07-13	581452		0	0	0		0	0	0	159065	0	113	40213227		
158231	3483	40213296	1997-02-08	1997-02-08 00:00:00	1997-02-08	1997-02-08 00:00:00	1997-02-08	581452		0	0	0		0	0	0	231035	0	52	40213296		
100983	2213	40213160	1962-03-28	1962-03-28 00:00:00	1962-03-28	1962-03-28 00:00:00	1962-03-28	581452		0	0	0		0	0	0	147380	0	10	40213160		
55374	4596	1115171	2013-06-22	2013-06-22 00:00:00	2013-07-06	2013-07-06 00:00:00	2013-07-06	38000177		0	0	14		0	0	0	306308	0	849574	1115171		
89065	1952	40213227	2006-01-09	2006-01-09 00:00:00	2006-01-09	2006-01-09 00:00:00	2006-01-09	581452		0	0	0		0	0	0	129856	0	113	40213227		
55421	4603	19059056	1959-12-13	1959-12-13 00:00:00	1959-12-27	1959-12-27 00:00:00	1959-12-27	38000177		0	0	14		0	0	0	306656	0	243670	19059056		
546	40	19078461	2003-08-18	2003-08-18 00:00:00	2003-09-01	2003-09-01 00:00:00	2003-09-01	38000177		0	0	14		0	0	0	2865	0	310965	19078461		
156626	3446	40213227	2005-10-03	2005-10-03 00:00:00	2005-10-03	2005-10-03 00:00:00	2005-10-03	581452		0	0	0		0	0	0	228879	0	113	40213227		
55705	4626	1127078	1979-06-30	1979-06-30 00:00:00	1979-07-14	1979-07-14 00:00:00	1979-07-14	38000177		0	0	14		0	0	0	308227	0	282464	1127078		
55730	4628	1118084	2004-09-05	2004-09-05 00:00:00	2004-09-05	2004-09-05 00:00:00	\N	38000177		0	0	0		0	0	0	308330	0	00025152531	44923712		
30125	2497	1127433	1990-04-22	1990-04-22 00:00:00	1990-05-13	1990-05-13 00:00:00	1990-05-13	38000177		0	0	21		0	0	0	165314	0	313782	1127433		
21523	1769	1713671	2003-03-05	2003-03-05 00:00:00	2003-03-19	2003-03-19 00:00:00	2003-03-19	38000177		0	0	14		0	0	0	118300	0	562251	1713671		
39051	3227	19059056	1986-02-26	1986-02-26 00:00:00	1986-04-27	1986-04-27 00:00:00	1986-04-27	38000177		0	0	60		0	0	0	214542	0	243670	19059056		
28987	2396	40220960	2000-11-08	2000-11-08 00:00:00	2000-11-08	2000-11-08 00:00:00	2000-11-08	38000177		0	0	0		0	0	0	159376	0	1804799	40220960		
58205	4835	1127433	2004-06-02	2004-06-02 00:00:00	2004-06-09	2004-06-09 00:00:00	2004-06-09	38000177		0	0	7		0	0	0	321639	0	313782	1127433		
52372	1146	40213260	2010-01-21	2010-01-21 00:00:00	2010-01-21	2010-01-21 00:00:00	2010-01-21	581452		0	0	0		0	0	0	75710	0	121	40213260		
189171	4153	40213296	2007-01-18	2007-01-18 00:00:00	2007-01-18	2007-01-18 00:00:00	2007-01-18	581452		0	0	0		0	0	0	276058	0	52	40213296		
174774	3843	40213260	2018-12-09	2018-12-09 00:00:00	2018-12-09	2018-12-09 00:00:00	2018-12-09	581452		0	0	0		0	0	0	255081	0	121	40213260		
39646	3279	1713671	1972-03-16	1972-03-16 00:00:00	1972-03-30	1972-03-30 00:00:00	1972-03-30	38000177		0	0	14		0	0	0	217897	0	562251	1713671		
124557	2740	40213160	1969-03-18	1969-03-18 00:00:00	1969-03-18	1969-03-18 00:00:00	1969-03-18	581452		0	0	0		0	0	0	181328	0	10	40213160		
50197	4165	19078461	1983-09-10	1983-09-10 00:00:00	1983-09-24	1983-09-24 00:00:00	1983-09-24	38000177		0	0	14		0	0	0	276826	0	310965	19078461		
129921	2857	40213227	1995-11-08	1995-11-08 00:00:00	1995-11-08	1995-11-08 00:00:00	1995-11-08	581452		0	0	0		0	0	0	189694	0	113	40213227		
48385	4010	1713671	2016-05-21	2016-05-21 00:00:00	2016-06-11	2016-06-11 00:00:00	2016-06-11	38000177		0	0	21		0	0	0	266464	0	562251	1713671		
39702	3283	19078461	2018-10-12	2018-10-12 00:00:00	2018-11-11	2018-11-11 00:00:00	2018-11-11	38000177		0	0	30		0	0	0	218108	0	310965	19078461		
71586	1565	40213227	2006-09-24	2006-09-24 00:00:00	2006-09-24	2006-09-24 00:00:00	2006-09-24	581452		0	0	0		0	0	0	104911	0	113	40213227		
162456	3572	40213227	2007-03-28	2007-03-28 00:00:00	2007-03-28	2007-03-28 00:00:00	2007-03-28	581452		0	0	0		0	0	0	237511	0	113	40213227		
13566	1136	1118084	2013-01-19	2013-01-19 00:00:00	2013-01-19	2013-01-19 00:00:00	\N	38000177		0	0	0		0	0	0	74863	0	00025152531	44923712		
59079	4909	1127433	2017-02-07	2017-02-07 00:00:00	2017-02-14	2017-02-14 00:00:00	2017-02-14	38000177		0	0	7		0	0	0	326259	0	313782	1127433		
55412	1214	40213227	2001-07-19	2001-07-19 00:00:00	2001-07-19	2001-07-19 00:00:00	2001-07-19	581452		0	0	0		0	0	0	79984	0	113	40213227		
119016	2617	40213227	2003-02-15	2003-02-15 00:00:00	2003-02-15	2003-02-15 00:00:00	2003-02-15	581452		0	0	0		0	0	0	173106	0	113	40213227		
95659	2097	40213306	1999-04-03	1999-04-03 00:00:00	1999-04-03	1999-04-03 00:00:00	1999-04-03	581452		0	0	0		0	0	0	139787	0	43	40213306		
60959	5068	1118084	1973-03-26	1973-03-26 00:00:00	1973-03-26	1973-03-26 00:00:00	\N	38000177		0	0	0		0	0	0	336942	0	00025152531	44923712		
44741	973	40213227	2005-11-14	2005-11-14 00:00:00	2005-11-14	2005-11-14 00:00:00	2005-11-14	581452		0	0	0		0	0	0	64853	0	113	40213227		
39244	3241	40165015	1987-03-19	1987-03-19 00:00:00	1987-03-19	1987-03-19 00:00:00	\N	38000177		0	0	0		0	0	0	215442	0	861467	40165015		
56092	1228	40213160	1979-06-16	1979-06-16 00:00:00	1979-06-16	1979-06-16 00:00:00	1979-06-16	581452		0	0	0		0	0	0	80889	0	10	40213160		
9373	199	40213201	2007-07-04	2007-07-04 00:00:00	2007-07-04	2007-07-04 00:00:00	2007-07-04	581452		0	0	0		0	0	0	13700	0	33	40213201		
28039	2320	1713671	1946-02-16	1946-02-16 00:00:00	1946-03-09	1946-03-09 00:00:00	1946-03-09	38000177		0	0	21		0	0	0	154284	0	562251	1713671		
28041	2320	1127433	1957-11-20	1957-11-20 00:00:00	1957-12-04	1957-12-04 00:00:00	1957-12-04	38000177		0	0	14		0	0	0	154279	0	313782	1127433		
232281	5104	40213251	1984-11-10	1984-11-10 00:00:00	1984-11-10	1984-11-10 00:00:00	1984-11-10	581452		0	0	0		0	0	0	339149	0	21	40213251		
240234	5274	40213160	1955-10-09	1955-10-09 00:00:00	1955-10-09	1955-10-09 00:00:00	1955-10-09	581452		0	0	0		0	0	0	350808	0	10	40213160		
44648	3695	19059056	1985-05-29	1985-05-29 00:00:00	1985-06-12	1985-06-12 00:00:00	1985-06-12	38000177		0	0	14		0	0	0	245613	0	243670	19059056		
62622	5207	1713671	1991-01-03	1991-01-03 00:00:00	1991-01-24	1991-01-24 00:00:00	1991-01-24	38000177		0	0	21		0	0	0	346378	0	562251	1713671		
58020	4820	19129655	1963-06-15	1963-06-15 00:00:00	1963-07-13	1963-07-13 00:00:00	1963-07-13	38000177		0	0	28		0	0	0	320643	0	789980	19129655		
62738	5215	1127433	2014-09-04	2014-09-04 00:00:00	2014-09-11	2014-09-11 00:00:00	2014-09-11	38000177		0	0	7		0	0	0	346826	0	313782	1127433		
76448	1669	40213306	1981-11-02	1981-11-02 00:00:00	1981-11-02	1981-11-02 00:00:00	1981-11-02	581452		0	0	0		0	0	0	112112	0	43	40213306		
585	12	40213260	2013-01-30	2013-01-30 00:00:00	2013-01-30	2013-01-30 00:00:00	2013-01-30	581452		0	0	0		0	0	0	1080	0	121	40213260		
20380	443	40213296	2008-12-22	2008-12-22 00:00:00	2008-12-22	2008-12-22 00:00:00	2008-12-22	581452		0	0	0		0	0	0	29473	0	52	40213296		
51871	1135	40213260	2008-12-27	2008-12-27 00:00:00	2008-12-27	2008-12-27 00:00:00	2008-12-27	581452		0	0	0		0	0	0	74785	0	121	40213260		
104667	2295	40213160	1973-05-15	1973-05-15 00:00:00	1973-05-15	1973-05-15 00:00:00	1973-05-15	581452		0	0	0		0	0	0	152785	0	10	40213160		
31624	2621	1713671	2009-03-20	2009-03-20 00:00:00	2009-04-03	2009-04-03 00:00:00	2009-04-03	38000177		0	0	14		0	0	0	173321	0	562251	1713671		
31685	2626	19059056	1965-04-22	1965-04-22 00:00:00	1965-05-06	1965-05-06 00:00:00	1965-05-06	38000177		0	0	14		0	0	0	173718	0	243670	19059056		
215220	4720	40213160	1981-06-02	1981-06-02 00:00:00	1981-06-02	1981-06-02 00:00:00	1981-06-02	581452		0	0	0		0	0	0	314355	0	10	40213160		
50622	4206	40229134	1961-03-07	1961-03-07 00:00:00	1961-03-21	1961-03-21 00:00:00	1961-03-21	38000177		0	0	14		0	0	0	279295	0	1043400	40229134		
38305	3170	1127078	1954-09-14	1954-09-14 00:00:00	1954-09-28	1954-09-28 00:00:00	1954-09-28	38000177		0	0	14		0	0	0	210708	0	282464	1127078		
33041	2740	1127433	2008-08-31	2008-08-31 00:00:00	2008-09-14	2008-09-14 00:00:00	2008-09-14	38000177		0	0	14		0	0	0	181273	0	313782	1127433		
52805	4388	1127433	2017-09-13	2017-09-13 00:00:00	2017-09-27	2017-09-27 00:00:00	2017-09-27	38000177		0	0	14		0	0	0	291632	0	313782	1127433		
178307	3920	40213227	2014-09-06	2014-09-06 00:00:00	2014-09-06	2014-09-06 00:00:00	2014-09-06	581452		0	0	0		0	0	0	260683	0	113	40213227		
32667	2708	19059056	1987-05-17	1987-05-17 00:00:00	1987-06-07	1987-06-07 00:00:00	1987-06-07	38000177		0	0	21		0	0	0	179431	0	243670	19059056		
147292	3238	40213296	2007-03-05	2007-03-05 00:00:00	2007-03-05	2007-03-05 00:00:00	2007-03-05	581452		0	0	0		0	0	0	215313	0	52	40213296		
160683	3536	40213160	1964-02-13	1964-02-13 00:00:00	1964-02-13	1964-02-13 00:00:00	1964-02-13	581452		0	0	0		0	0	0	234821	0	10	40213160		
173050	3804	40213306	1982-07-29	1982-07-29 00:00:00	1982-07-29	1982-07-29 00:00:00	1982-07-29	581452		0	0	0		0	0	0	252849	0	43	40213306		
5138	430	920300	1978-07-21	1978-07-21 00:00:00	1978-07-28	1978-07-28 00:00:00	1978-07-28	38000177		0	0	7		0	0	0	28517	0	311989	920300		
36977	806	40213296	1999-01-10	1999-01-10 00:00:00	1999-01-10	1999-01-10 00:00:00	1999-01-10	581452		0	0	0		0	0	0	53477	0	52	40213296		
77526	1695	40213227	2007-03-08	2007-03-08 00:00:00	2007-03-08	2007-03-08 00:00:00	2007-03-08	581452		0	0	0		0	0	0	113445	0	113	40213227		
89609	1966	40213160	1962-01-02	1962-01-02 00:00:00	1962-01-02	1962-01-02 00:00:00	1962-01-02	581452		0	0	0		0	0	0	130709	0	10	40213160		
183180	4024	40213227	2001-10-07	2001-10-07 00:00:00	2001-10-07	2001-10-07 00:00:00	2001-10-07	581452		0	0	0		0	0	0	267514	0	113	40213227		
100987	2213	40213160	1961-12-27	1961-12-27 00:00:00	1961-12-27	1961-12-27 00:00:00	1961-12-27	581452		0	0	0		0	0	0	147393	0	10	40213160		
8162	176	40213306	1986-08-27	1986-08-27 00:00:00	1986-08-27	1986-08-27 00:00:00	1986-08-27	581452		0	0	0		0	0	0	\N	0	43	40213306		
89066	1952	40213260	2006-01-09	2006-01-09 00:00:00	2006-01-09	2006-01-09 00:00:00	2006-01-09	581452		0	0	0		0	0	0	129856	0	121	40213260		
55422	4603	19006318	1959-12-13	1959-12-13 00:00:00	1959-12-27	1959-12-27 00:00:00	1959-12-27	38000177		0	0	14		0	0	0	306656	0	105078	19006318		
547	40	1127433	1964-12-28	1964-12-28 00:00:00	1965-01-04	1965-01-04 00:00:00	1965-01-04	38000177		0	0	7		0	0	0	2799	0	313782	1127433		
55644	4621	1713671	2018-01-08	2018-01-08 00:00:00	2018-01-15	2018-01-15 00:00:00	2018-01-15	38000177		0	0	7		0	0	0	307723	0	562251	1713671		
55706	4626	19073183	1979-06-30	1979-06-30 00:00:00	1979-07-14	1979-07-14 00:00:00	1979-07-14	38000177		0	0	14		0	0	0	308227	0	308182	19073183		
55731	4628	46233988	1971-10-31	1971-10-31 00:00:00	1971-11-14	1971-11-14 00:00:00	1971-11-14	38000177		0	0	14		0	0	0	308332	0	1652673	46233988		
30126	2497	1127433	2012-06-16	2012-06-16 00:00:00	2012-07-07	2012-07-07 00:00:00	2012-07-07	38000177		0	0	21		0	0	0	165317	0	313782	1127433		
21524	1769	40224805	1993-08-26	1993-08-26 00:00:00	1994-08-21	1994-08-21 00:00:00	1994-08-21	38000177		0	0	360		0	0	0	118304	0	1000126	40224805		
39052	3227	1127433	1976-01-22	1976-01-22 00:00:00	1976-02-05	1976-02-05 00:00:00	1976-02-05	38000177		0	0	14		0	0	0	214530	0	313782	1127433		
28988	2396	19059056	1941-04-27	1941-04-27 00:00:00	1941-05-11	1941-05-11 00:00:00	1941-05-11	38000177		0	0	14		0	0	0	159402	0	243670	19059056		
58214	4837	19018935	2008-11-18	2008-11-18 00:00:00	2008-11-18	2008-11-18 00:00:00	\N	38000177		0	0	0		0	0	0	321813	0	197604	19018935		
52374	1146	40213227	2010-01-21	2010-01-21 00:00:00	2010-01-21	2010-01-21 00:00:00	2010-01-21	581452		0	0	0		0	0	0	75710	0	113	40213227		
189176	4153	40213296	2009-01-22	2009-01-22 00:00:00	2009-01-22	2009-01-22 00:00:00	2009-01-22	581452		0	0	0		0	0	0	276034	0	52	40213296		
174777	3843	40213306	1991-04-28	1991-04-28 00:00:00	1991-04-28	1991-04-28 00:00:00	1991-04-28	581452		0	0	0		0	0	0	255110	0	43	40213306		
39647	3279	40231925	1972-10-23	1972-10-23 00:00:00	1972-10-23	1972-10-23 00:00:00	\N	38000177		0	0	0		0	0	0	217919	0	1049221	40231925		
124558	2740	40213160	1969-05-20	1969-05-20 00:00:00	1969-05-20	1969-05-20 00:00:00	1969-05-20	581452		0	0	0		0	0	0	181278	0	10	40213160		
50198	4165	1127433	1944-02-11	1944-02-11 00:00:00	1944-02-18	1944-02-18 00:00:00	1944-02-18	38000177		0	0	7		0	0	0	276741	0	313782	1127433		
129923	2857	40213260	2014-09-04	2014-09-04 00:00:00	2014-09-04	2014-09-04 00:00:00	2014-09-04	581452		0	0	0		0	0	0	189707	0	121	40213260		
48386	4010	1713671	2009-10-10	2009-10-10 00:00:00	2009-10-24	2009-10-24 00:00:00	2009-10-24	38000177		0	0	14		0	0	0	266517	0	562251	1713671		
39703	3283	1713671	2008-10-18	2008-10-18 00:00:00	2008-11-08	2008-11-08 00:00:00	2008-11-08	38000177		0	0	21		0	0	0	218103	0	562251	1713671		
71587	1565	40213296	2006-09-24	2006-09-24 00:00:00	2006-09-24	2006-09-24 00:00:00	2006-09-24	581452		0	0	0		0	0	0	104911	0	52	40213296		
162457	3572	40213260	2007-03-28	2007-03-28 00:00:00	2007-03-28	2007-03-28 00:00:00	2007-03-28	581452		0	0	0		0	0	0	237511	0	121	40213260		
13567	1136	1127433	2001-08-21	2001-08-21 00:00:00	2001-08-28	2001-08-28 00:00:00	2001-08-28	38000177		0	0	7		0	0	0	74868	0	313782	1127433		
59080	4909	19019979	1985-12-25	1985-12-25 00:00:00	1986-01-15	1986-01-15 00:00:00	1986-01-15	38000177		0	0	21		0	0	0	326277	0	198405	19019979		
55417	1214	40213227	1992-07-09	1992-07-09 00:00:00	1992-07-09	1992-07-09 00:00:00	1992-07-09	581452		0	0	0		0	0	0	79956	0	113	40213227		
119020	2617	40213160	1955-01-15	1955-01-15 00:00:00	1955-01-15	1955-01-15 00:00:00	1955-01-15	581452		0	0	0		0	0	0	173066	0	10	40213160		
95661	2097	40213227	2019-03-16	2019-03-16 00:00:00	2019-03-16	2019-03-16 00:00:00	2019-03-16	581452		0	0	0		0	0	0	139824	0	113	40213227		
178728	3929	40213227	1995-01-16	1995-01-16 00:00:00	1995-01-16	1995-01-16 00:00:00	1995-01-16	581452		0	0	0		0	0	0	261162	0	113	40213227		
44745	973	40213227	1995-09-18	1995-09-18 00:00:00	1995-09-18	1995-09-18 00:00:00	1995-09-18	581452		0	0	0		0	0	0	64824	0	113	40213227		
39245	3241	1713671	2019-06-10	2019-06-10 00:00:00	2019-06-10	2019-06-10 00:00:00	\N	38000177		0	0	0		0	0	0	215547	0	562251	1713671		
56098	1228	40213160	1975-03-15	1975-03-15 00:00:00	1975-03-15	1975-03-15 00:00:00	1975-03-15	581452		0	0	0		0	0	0	80905	0	10	40213160		
17468	377	40213296	2009-01-01	2009-01-01 00:00:00	2009-01-01	2009-01-01 00:00:00	2009-01-01	581452		0	0	0		0	0	0	25007	0	52	40213296		
28040	2320	1118084	1980-01-15	1980-01-15 00:00:00	1980-01-15	1980-01-15 00:00:00	\N	38000177		0	0	0		0	0	0	154331	0	00025152531	44923712		
28043	2320	1127433	1955-08-11	1955-08-11 00:00:00	1955-08-25	1955-08-25 00:00:00	1955-08-25	38000177		0	0	14		0	0	0	154278	0	313782	1127433		
232284	5104	40213160	1984-11-10	1984-11-10 00:00:00	1984-11-10	1984-11-10 00:00:00	1984-11-10	581452		0	0	0		0	0	0	339149	0	10	40213160		
240240	5274	40213227	2003-10-19	2003-10-19 00:00:00	2003-10-19	2003-10-19 00:00:00	2003-10-19	581452		0	0	0		0	0	0	350759	0	113	40213227		
44649	3695	19075001	1985-05-29	1985-05-29 00:00:00	1985-06-12	1985-06-12 00:00:00	1985-06-12	38000177		0	0	14		0	0	0	245613	0	309097	19075001		
62624	5207	19059056	1957-12-31	1957-12-31 00:00:00	1958-01-14	1958-01-14 00:00:00	1958-01-14	38000177		0	0	14		0	0	0	346310	0	243670	19059056		
58021	4820	19059056	1963-06-15	1963-06-15 00:00:00	1963-07-13	1963-07-13 00:00:00	1963-07-13	38000177		0	0	28		0	0	0	320643	0	243670	19059056		
62739	5215	19006318	1954-09-14	1954-09-14 00:00:00	1954-09-28	1954-09-28 00:00:00	1954-09-28	38000177		0	0	14		0	0	0	346882	0	105078	19006318		
76454	1670	40213296	2005-01-02	2005-01-02 00:00:00	2005-01-02	2005-01-02 00:00:00	2005-01-02	581452		0	0	0		0	0	0	112169	0	52	40213296		
203690	4472	40213201	2002-03-09	2002-03-09 00:00:00	2002-03-09	2002-03-09 00:00:00	2002-03-09	581452		0	0	0		0	0	0	297519	0	33	40213201		
20387	443	40213160	1969-05-27	1969-05-27 00:00:00	1969-05-27	1969-05-27 00:00:00	1969-05-27	581452		0	0	0		0	0	0	29437	0	10	40213160		
51872	1135	40213160	1959-04-04	1959-04-04 00:00:00	1959-04-04	1959-04-04 00:00:00	1959-04-04	581452		0	0	0		0	0	0	74744	0	10	40213160		
104668	2295	40213160	1978-01-17	1978-01-17 00:00:00	1978-01-17	1978-01-17 00:00:00	1978-01-17	581452		0	0	0		0	0	0	152800	0	10	40213160		
31625	2621	1127433	1966-11-03	1966-11-03 00:00:00	1966-11-10	1966-11-10 00:00:00	1966-11-10	38000177		0	0	7		0	0	0	173339	0	313782	1127433		
31686	2626	19006318	1965-04-22	1965-04-22 00:00:00	1965-05-06	1965-05-06 00:00:00	1965-05-06	38000177		0	0	14		0	0	0	173718	0	105078	19006318		
215224	4720	40213160	1976-08-24	1976-08-24 00:00:00	1976-08-24	1976-08-24 00:00:00	1976-08-24	581452		0	0	0		0	0	0	314380	0	10	40213160		
50623	4206	1124300	1984-06-12	1984-06-12 00:00:00	1984-06-12	1984-06-12 00:00:00	\N	38000177		0	0	0		0	0	0	279333	0	00781178901	45011828		
38306	3170	19006318	1954-09-14	1954-09-14 00:00:00	1954-09-28	1954-09-28 00:00:00	1954-09-28	38000177		0	0	14		0	0	0	210708	0	105078	19006318		
33042	2740	19078461	2016-02-02	2016-02-02 00:00:00	2016-02-16	2016-02-16 00:00:00	2016-02-16	38000177		0	0	14		0	0	0	181284	0	310965	19078461		
52806	4388	40162522	1996-10-28	1996-10-28 00:00:00	1996-10-28	1996-10-28 00:00:00	\N	38000177		0	0	0		0	0	0	291750	0	857005	40162522		
235554	5174	40213227	1998-04-02	1998-04-02 00:00:00	1998-04-02	1998-04-02 00:00:00	1998-04-02	581452		0	0	0		0	0	0	344006	0	113	40213227		
32668	2708	19006318	1954-09-05	1954-09-05 00:00:00	1954-09-19	1954-09-19 00:00:00	1954-09-19	38000177		0	0	14		0	0	0	179391	0	105078	19006318		
147298	3238	40213160	1967-06-05	1967-06-05 00:00:00	1967-06-05	1967-06-05 00:00:00	1967-06-05	581452		0	0	0		0	0	0	215300	0	10	40213160		
160686	3536	40213227	2005-11-17	2005-11-17 00:00:00	2005-11-17	2005-11-17 00:00:00	2005-11-17	581452		0	0	0		0	0	0	234870	0	113	40213227		
173054	3804	40213160	1960-08-11	1960-08-11 00:00:00	1960-08-11	1960-08-11 00:00:00	1960-08-11	581452		0	0	0		0	0	0	252835	0	10	40213160		
5139	430	40236824	1978-07-21	1978-07-21 00:00:00	1978-07-28	1978-07-28 00:00:00	1978-07-28	38000177		0	0	7		0	0	0	28517	0	1094107	40236824		
36979	806	40213227	1999-01-10	1999-01-10 00:00:00	1999-01-10	1999-01-10 00:00:00	1999-01-10	581452		0	0	0		0	0	0	53477	0	113	40213227		
77527	1695	40213296	2007-03-08	2007-03-08 00:00:00	2007-03-08	2007-03-08 00:00:00	2007-03-08	581452		0	0	0		0	0	0	113445	0	52	40213296		
89611	1966	40213296	2002-12-31	2002-12-31 00:00:00	2002-12-31	2002-12-31 00:00:00	2002-12-31	581452		0	0	0		0	0	0	130700	0	52	40213296		
183181	4024	40213306	2001-10-07	2001-10-07 00:00:00	2001-10-07	2001-10-07 00:00:00	2001-10-07	581452		0	0	0		0	0	0	267514	0	43	40213306		
100988	2213	40213160	1961-10-25	1961-10-25 00:00:00	1961-10-25	1961-10-25 00:00:00	1961-10-25	581452		0	0	0		0	0	0	147379	0	10	40213160		
8163	176	40213160	1969-02-12	1969-02-12 00:00:00	1969-02-12	1969-02-12 00:00:00	1969-02-12	581452		0	0	0		0	0	0	11939	0	10	40213160		
45280	3748	1127433	2012-11-15	2012-11-15 00:00:00	2012-12-13	2012-12-13 00:00:00	2012-12-13	38000177		0	0	28		0	0	0	249096	0	313782	1127433		
55423	4603	1115171	2014-03-19	2014-03-19 00:00:00	2014-04-09	2014-04-09 00:00:00	2014-04-09	38000177		0	0	21		0	0	0	306624	0	849574	1115171		
548	40	19006318	1961-03-31	1961-03-31 00:00:00	1961-04-14	1961-04-14 00:00:00	1961-04-14	38000177		0	0	14		0	0	0	2888	0	105078	19006318		
55645	4621	1127078	1978-01-17	1978-01-17 00:00:00	1978-01-31	1978-01-31 00:00:00	1978-01-31	38000177		0	0	14		0	0	0	307773	0	282464	1127078		
28281	2334	19077572	2018-08-02	2018-08-02 00:00:00	2018-08-02	2018-08-02 00:00:00	\N	38000177		0	0	0		0	0	0	155323	0	310436	19077572		
55732	4628	19059056	1971-10-31	1971-10-31 00:00:00	1971-11-14	1971-11-14 00:00:00	1971-11-14	38000177		0	0	14		0	0	0	308332	0	243670	19059056		
30127	2497	1127433	1988-08-23	1988-08-23 00:00:00	1988-08-30	1988-08-30 00:00:00	1988-08-30	38000177		0	0	7		0	0	0	165319	0	313782	1127433		
21525	1769	40229134	1978-06-07	1978-06-07 00:00:00	1978-06-21	1978-06-21 00:00:00	1978-06-21	38000177		0	0	14		0	0	0	118293	0	1043400	40229134		
39053	3227	1713671	1980-03-07	1980-03-07 00:00:00	1980-03-14	1980-03-14 00:00:00	1980-03-14	38000177		0	0	7		0	0	0	214528	0	562251	1713671		
28989	2396	1539411	1991-02-13	1991-02-13 00:00:00	1991-02-13	1991-02-13 00:00:00	\N	38000177		0	0	0		0	0	0	159332	0	312961	1539411		
58215	4837	40171902	2008-11-18	2008-11-18 00:00:00	2008-11-18	2008-11-18 00:00:00	\N	38000177		0	0	0		0	0	0	321813	0	897718	40171902		
3585	297	1127433	2010-02-12	2010-02-12 00:00:00	2010-02-19	2010-02-19 00:00:00	2010-02-19	38000177		0	0	7		0	0	0	19789	0	313782	1127433		
189178	4153	40213160	1970-01-22	1970-01-22 00:00:00	1970-01-22	1970-01-22 00:00:00	1970-01-22	581452		0	0	0		0	0	0	276047	0	10	40213160		
174782	3843	40213160	1969-05-18	1969-05-18 00:00:00	1969-05-18	1969-05-18 00:00:00	1969-05-18	581452		0	0	0		0	0	0	255079	0	10	40213160		
39648	3279	19059056	1972-10-23	1972-10-23 00:00:00	1972-12-22	1972-12-22 00:00:00	1972-12-22	38000177		0	0	60		0	0	0	217919	0	243670	19059056		
124563	2740	40213296	2012-09-18	2012-09-18 00:00:00	2012-09-18	2012-09-18 00:00:00	2012-09-18	581452		0	0	0		0	0	0	181306	0	52	40213296		
50199	4165	1713671	1945-12-30	1945-12-30 00:00:00	1946-01-13	1946-01-13 00:00:00	1946-01-13	38000177		0	0	14		0	0	0	276742	0	562251	1713671		
129927	2857	40213160	1964-06-18	1964-06-18 00:00:00	1964-06-18	1964-06-18 00:00:00	1964-06-18	581452		0	0	0		0	0	0	189688	0	10	40213160		
48387	4010	1127433	2018-04-30	2018-04-30 00:00:00	2018-05-30	2018-05-30 00:00:00	2018-05-30	38000177		0	0	30		0	0	0	266491	0	313782	1127433		
39704	3283	19019979	1987-11-24	1987-11-24 00:00:00	1988-02-22	1988-02-22 00:00:00	1988-02-22	38000177		0	0	90		0	0	0	218107	0	198405	19019979		
71593	1566	40213160	1968-02-10	1968-02-10 00:00:00	1968-02-10	1968-02-10 00:00:00	1968-02-10	581452		0	0	0		0	0	0	104999	0	10	40213160		
162458	3572	40213160	1956-06-27	1956-06-27 00:00:00	1956-06-27	1956-06-27 00:00:00	1956-06-27	581452		0	0	0		0	0	0	237484	0	10	40213160		
13568	1137	19075601	1998-06-26	1998-06-26 00:00:00	1998-06-26	1998-06-26 00:00:00	\N	38000177		0	0	0		0	0	0	74967	0	309362	19075601		
1617	36	40213160	1963-10-01	1963-10-01 00:00:00	1963-10-01	1963-10-01 00:00:00	1963-10-01	581452		0	0	0		0	0	0	2588	0	10	40213160		
55425	1214	40213201	2006-08-17	2006-08-17 00:00:00	2006-08-17	2006-08-17 00:00:00	2006-08-17	581452		0	0	0		0	0	0	79950	0	33	40213201		
119022	2617	40213227	1994-02-19	1994-02-19 00:00:00	1994-02-19	1994-02-19 00:00:00	1994-02-19	581452		0	0	0		0	0	0	173075	0	113	40213227		
95662	2097	40213296	2019-03-16	2019-03-16 00:00:00	2019-03-16	2019-03-16 00:00:00	2019-03-16	581452		0	0	0		0	0	0	139824	0	52	40213296		
178737	3929	40213260	2006-01-16	2006-01-16 00:00:00	2006-01-16	2006-01-16 00:00:00	2006-01-16	581452		0	0	0		0	0	0	261206	0	121	40213260		
130406	2865	40213227	2010-02-08	2010-02-08 00:00:00	2010-02-08	2010-02-08 00:00:00	2010-02-08	581452		0	0	0		0	0	0	190588	0	113	40213227		
39246	3242	19019979	1988-03-06	1988-03-06 00:00:00	1988-05-05	1988-05-05 00:00:00	1988-05-05	38000177		0	0	60		0	0	0	215643	0	198405	19019979		
56099	1229	40213227	2005-08-06	2005-08-06 00:00:00	2005-08-06	2005-08-06 00:00:00	2005-08-06	581452		0	0	0		0	0	0	\N	0	113	40213227		
17470	377	40213227	2018-02-08	2018-02-08 00:00:00	2018-02-08	2018-02-08 00:00:00	2018-02-08	581452		0	0	0		0	0	0	24975	0	113	40213227		
190698	4190	40213227	1995-06-04	1995-06-04 00:00:00	1995-06-04	1995-06-04 00:00:00	1995-06-04	581452		0	0	0		0	0	0	278092	0	113	40213227		
28044	2320	1127433	1976-08-03	1976-08-03 00:00:00	1976-08-17	1976-08-17 00:00:00	1976-08-17	38000177		0	0	14		0	0	0	154303	0	313782	1127433		
232285	5104	40213314	1980-03-08	1980-03-08 00:00:00	1980-03-08	1980-03-08 00:00:00	1980-03-08	581452		0	0	0		0	0	0	339217	0	49	40213314		
240244	5274	40213201	2019-01-13	2019-01-13 00:00:00	2019-01-13	2019-01-13 00:00:00	2019-01-13	581452		0	0	0		0	0	0	350811	0	33	40213201		
44650	3695	1124300	2013-11-17	2013-11-17 00:00:00	2013-11-17	2013-11-17 00:00:00	\N	38000177		0	0	0		0	0	0	245581	0	00781178901	45011828		
62625	5207	19006318	1957-12-31	1957-12-31 00:00:00	1958-01-14	1958-01-14 00:00:00	1958-01-14	38000177		0	0	14		0	0	0	346310	0	105078	19006318		
58022	4820	1713671	1981-05-23	1981-05-23 00:00:00	1981-06-13	1981-06-13 00:00:00	1981-06-13	38000177		0	0	21		0	0	0	320651	0	562251	1713671		
62740	5215	1127433	1954-09-14	1954-09-14 00:00:00	1954-09-28	1954-09-28 00:00:00	1954-09-28	38000177		0	0	14		0	0	0	346882	0	313782	1127433		
62743	5215	1124300	1982-03-19	1982-03-19 00:00:00	1982-03-19	1982-03-19 00:00:00	\N	38000177		0	0	0		0	0	0	346898	0	00781178901	45011828		
203698	4472	40213227	2007-04-07	2007-04-07 00:00:00	2007-04-07	2007-04-07 00:00:00	2007-04-07	581452		0	0	0		0	0	0	297551	0	113	40213227		
51994	1138	40213251	1984-01-05	1984-01-05 00:00:00	1984-01-05	1984-01-05 00:00:00	1984-01-05	581452		0	0	0		0	0	0	75010	0	21	40213251		
51875	1135	40213160	1959-09-05	1959-09-05 00:00:00	1959-09-05	1959-09-05 00:00:00	1959-09-05	581452		0	0	0		0	0	0	74788	0	10	40213160		
104679	2295	40213306	1995-04-11	1995-04-11 00:00:00	1995-04-11	1995-04-11 00:00:00	1995-04-11	581452		0	0	0		0	0	0	152805	0	43	40213306		
31626	2621	1127078	1966-09-16	1966-09-16 00:00:00	1966-10-07	1966-10-07 00:00:00	1966-10-07	38000177		0	0	21		0	0	0	173398	0	282464	1127078		
31687	2626	1118084	2000-03-09	2000-03-09 00:00:00	2000-03-09	2000-03-09 00:00:00	\N	38000177		0	0	0		0	0	0	173690	0	00025152531	44923712		
205687	4514	40213160	1976-01-30	1976-01-30 00:00:00	1976-01-30	1976-01-30 00:00:00	1976-01-30	581452		0	0	0		0	0	0	300614	0	10	40213160		
50624	4206	40229134	1973-01-29	1973-01-29 00:00:00	1973-02-12	1973-02-12 00:00:00	1973-02-12	38000177		0	0	14		0	0	0	279286	0	1043400	40229134		
38307	3170	40229134	1974-04-20	1974-04-20 00:00:00	1974-04-27	1974-04-27 00:00:00	1974-04-27	38000177		0	0	7		0	0	0	210743	0	1043400	40229134		
33043	2740	40229134	1975-11-05	1975-11-05 00:00:00	1975-11-12	1975-11-12 00:00:00	1975-11-12	38000177		0	0	7		0	0	0	181285	0	1043400	40229134		
52807	4388	40169216	1970-08-26	1970-08-26 00:00:00	1970-08-26	1970-08-26 00:00:00	\N	38000177		0	0	0		0	0	0	291686	0	895994	40169216		
49348	1081	40213160	1962-04-25	1962-04-25 00:00:00	1962-04-25	1962-04-25 00:00:00	1962-04-25	581452		0	0	0		0	0	0	70838	0	10	40213160		
32669	2708	1127078	1954-09-05	1954-09-05 00:00:00	1954-09-19	1954-09-19 00:00:00	1954-09-19	38000177		0	0	14		0	0	0	179391	0	282464	1127078		
147300	3238	40213260	2017-03-06	2017-03-06 00:00:00	2017-03-06	2017-03-06 00:00:00	2017-03-06	581452		0	0	0		0	0	0	215272	0	121	40213260		
160687	3536	40213296	2005-11-17	2005-11-17 00:00:00	2005-11-17	2005-11-17 00:00:00	2005-11-17	581452		0	0	0		0	0	0	234870	0	52	40213296		
42953	3561	40163554	1973-04-16	1973-04-16 00:00:00	1973-04-16	1973-04-16 00:00:00	\N	38000177		0	0	0		0	0	0	236440	0	855332	40163554		
5140	430	40229134	1949-12-15	1949-12-15 00:00:00	1949-12-29	1949-12-29 00:00:00	1949-12-29	38000177		0	0	14		0	0	0	28430	0	1043400	40229134		
36981	806	40213160	1957-06-09	1957-06-09 00:00:00	1957-06-09	1957-06-09 00:00:00	1957-06-09	581452		0	0	0		0	0	0	53484	0	10	40213160		
77529	1695	40213160	1970-12-10	1970-12-10 00:00:00	1970-12-10	1970-12-10 00:00:00	1970-12-10	581452		0	0	0		0	0	0	113455	0	10	40213160		
89613	1966	40213227	2002-12-31	2002-12-31 00:00:00	2002-12-31	2002-12-31 00:00:00	2002-12-31	581452		0	0	0		0	0	0	130700	0	113	40213227		
183184	4024	40213227	2012-05-13	2012-05-13 00:00:00	2012-05-13	2012-05-13 00:00:00	2012-05-13	581452		0	0	0		0	0	0	267567	0	113	40213227		
164862	3625	40213260	2006-08-01	2006-08-01 00:00:00	2006-08-01	2006-08-01 00:00:00	2006-08-01	581452		0	0	0		0	0	0	241070	0	121	40213260		
45231	3744	40162522	1994-12-24	1994-12-24 00:00:00	1994-12-24	1994-12-24 00:00:00	\N	38000177		0	0	0		0	0	0	248757	0	857005	40162522		
45281	3748	1127078	1987-11-27	1987-11-27 00:00:00	1987-12-27	1987-12-27 00:00:00	1987-12-27	38000177		0	0	30		0	0	0	249095	0	282464	1127078		
55424	4603	19059056	1940-09-23	1940-09-23 00:00:00	1940-10-28	1940-10-28 00:00:00	1940-10-28	38000177		0	0	35		0	0	0	306647	0	243670	19059056		
549	40	1118084	1993-07-12	1993-07-12 00:00:00	1993-07-12	1993-07-12 00:00:00	\N	38000177		0	0	0		0	0	0	2850	0	00025152531	44923712		
55646	4621	1115171	2005-05-30	2005-05-30 00:00:00	2005-06-27	2005-06-27 00:00:00	2005-06-27	38000177		0	0	28		0	0	0	307744	0	849574	1115171		
28282	2334	1713671	1965-11-16	1965-11-16 00:00:00	1965-11-30	1965-11-30 00:00:00	1965-11-30	38000177		0	0	14		0	0	0	155304	0	562251	1713671		
55733	4628	1115171	2016-08-23	2016-08-23 00:00:00	2016-09-13	2016-09-13 00:00:00	2016-09-13	38000177		0	0	21		0	0	0	308352	0	849574	1115171		
30128	2497	1115171	2004-06-28	2004-06-28 00:00:00	2004-09-26	2004-09-26 00:00:00	2004-09-26	38000177		0	0	90		0	0	0	165315	0	849574	1115171		
21526	1769	19128022	1989-09-16	1989-09-16 00:00:00	1990-09-11	1990-09-11 00:00:00	1990-09-11	38000177		0	0	360		0	0	0	118272	0	749785	19128022		
39054	3227	1127433	1990-04-26	1990-04-26 00:00:00	1990-05-03	1990-05-03 00:00:00	1990-05-03	38000177		0	0	7		0	0	0	214503	0	313782	1127433		
28990	2396	19059056	1954-10-14	1954-10-14 00:00:00	1954-11-04	1954-11-04 00:00:00	1954-11-04	38000177		0	0	21		0	0	0	159321	0	243670	19059056		
58216	4837	40163554	2008-11-18	2008-11-18 00:00:00	2008-11-18	2008-11-18 00:00:00	\N	38000177		0	0	0		0	0	0	321813	0	855332	40163554		
3586	297	1127433	1999-11-21	1999-11-21 00:00:00	1999-12-05	1999-12-05 00:00:00	1999-12-05	38000177		0	0	14		0	0	0	19771	0	313782	1127433		
12964	279	40213227	2002-12-06	2002-12-06 00:00:00	2002-12-06	2002-12-06 00:00:00	2002-12-06	581452		0	0	0		0	0	0	18577	0	113	40213227		
174785	3843	40213160	1973-11-18	1973-11-18 00:00:00	1973-11-18	1973-11-18 00:00:00	1973-11-18	581452		0	0	0		0	0	0	255105	0	10	40213160		
39649	3279	19133873	1966-08-29	1966-08-29 00:00:00	1966-09-11	1966-09-11 00:00:00	1966-09-11	38000177		0	0	13		0	0	0	217883	0	834061	19133873		
124564	2740	40213306	1991-06-11	1991-06-11 00:00:00	1991-06-11	1991-06-11 00:00:00	1991-06-11	581452		0	0	0		0	0	0	181323	0	43	40213306		
50200	4165	19059056	1913-01-27	1913-01-27 00:00:00	1913-02-10	1913-02-10 00:00:00	1913-02-10	38000177		0	0	14		0	0	0	276767	0	243670	19059056		
129934	2857	40213296	2004-03-17	2004-03-17 00:00:00	2004-03-17	2004-03-17 00:00:00	2004-03-17	581452		0	0	0		0	0	0	189696	0	52	40213296		
48388	4010	19128022	1996-04-05	1996-04-05 00:00:00	1997-03-31	1997-03-31 00:00:00	1997-03-31	38000177		0	0	360		0	0	0	266519	0	749785	19128022		
191159	4200	40213227	2010-06-30	2010-06-30 00:00:00	2010-06-30	2010-06-30 00:00:00	2010-06-30	581452		0	0	0		0	0	0	278798	0	113	40213227		
71596	1566	40213296	2007-11-10	2007-11-10 00:00:00	2007-11-10	2007-11-10 00:00:00	2007-11-10	581452		0	0	0		0	0	0	105020	0	52	40213296		
162460	3572	40213296	1996-03-27	1996-03-27 00:00:00	1996-03-27	1996-03-27 00:00:00	1996-03-27	581452		0	0	0		0	0	0	237491	0	52	40213296		
13569	1137	19077572	2007-10-19	2007-10-19 00:00:00	2007-10-19	2007-10-19 00:00:00	\N	38000177		0	0	0		0	0	0	74969	0	310436	19077572		
1622	36	40213227	2009-10-27	2009-10-27 00:00:00	2009-10-27	2009-10-27 00:00:00	2009-10-27	581452		0	0	0		0	0	0	2569	0	113	40213227		
1635	36	40213160	1959-06-30	1959-06-30 00:00:00	1959-06-30	1959-06-30 00:00:00	1959-06-30	581452		0	0	0		0	0	0	2546	0	10	40213160		
119025	2617	40213227	2013-08-31	2013-08-31 00:00:00	2013-08-31	2013-08-31 00:00:00	2013-08-31	581452		0	0	0		0	0	0	173079	0	113	40213227		
95665	2097	40213296	2017-03-11	2017-03-11 00:00:00	2017-03-11	2017-03-11 00:00:00	2017-03-11	581452		0	0	0		0	0	0	139796	0	52	40213296		
178746	3929	40213160	1956-04-09	1956-04-09 00:00:00	1956-04-09	1956-04-09 00:00:00	1956-04-09	581452		0	0	0		0	0	0	261176	0	10	40213160		
130407	2865	40213296	2010-02-08	2010-02-08 00:00:00	2010-02-08	2010-02-08 00:00:00	2010-02-08	581452		0	0	0		0	0	0	190588	0	52	40213296		
39247	3242	1118084	2015-11-25	2015-11-25 00:00:00	2015-11-25	2015-11-25 00:00:00	\N	38000177		0	0	0		0	0	0	215641	0	00025152531	44923712		
56109	1229	40213227	2015-11-14	2015-11-14 00:00:00	2015-11-14	2015-11-14 00:00:00	2015-11-14	581452		0	0	0		0	0	0	80999	0	113	40213227		
17471	377	40213260	2018-02-08	2018-02-08 00:00:00	2018-02-08	2018-02-08 00:00:00	2018-02-08	581452		0	0	0		0	0	0	24975	0	121	40213260		
190699	4190	40213306	1995-06-04	1995-06-04 00:00:00	1995-06-04	1995-06-04 00:00:00	1995-06-04	581452		0	0	0		0	0	0	278092	0	43	40213306		
28045	2320	19059056	1947-05-03	1947-05-03 00:00:00	1947-05-17	1947-05-17 00:00:00	1947-05-17	38000177		0	0	14		0	0	0	154293	0	243670	19059056		
232286	5104	40213160	1980-03-08	1980-03-08 00:00:00	1980-03-08	1980-03-08 00:00:00	1980-03-08	581452		0	0	0		0	0	0	339217	0	10	40213160		
240245	5274	40213160	1955-04-10	1955-04-10 00:00:00	1955-04-10	1955-04-10 00:00:00	1955-04-10	581452		0	0	0		0	0	0	350785	0	10	40213160		
44654	3697	40236824	1978-06-13	1978-06-13 00:00:00	1978-06-27	1978-06-27 00:00:00	1978-06-27	38000177		0	0	14		0	0	0	245801	0	1094107	40236824		
62626	5207	1127433	1969-03-03	1969-03-03 00:00:00	1969-04-07	1969-04-07 00:00:00	1969-04-07	38000177		0	0	35		0	0	0	346375	0	313782	1127433		
58023	4820	19073188	2003-07-17	2003-07-17 00:00:00	2003-07-31	2003-07-31 00:00:00	2003-07-31	38000177		0	0	14		0	0	0	320633	0	308192	19073188		
62741	5215	19078461	2002-05-12	2002-05-12 00:00:00	2002-06-09	2002-06-09 00:00:00	2002-06-09	38000177		0	0	28		0	0	0	346843	0	310965	19078461		
62744	5215	19006318	1978-07-14	1978-07-14 00:00:00	1978-08-11	1978-08-11 00:00:00	1978-08-11	38000177		0	0	28		0	0	0	346840	0	105078	19006318		
214984	4715	40213227	2011-11-15	2011-11-15 00:00:00	2011-11-15	2011-11-15 00:00:00	2011-11-15	581452		0	0	0		0	0	0	313965	0	113	40213227		
51997	1138	40213160	1980-07-10	1980-07-10 00:00:00	1980-07-10	1980-07-10 00:00:00	1980-07-10	581452		0	0	0		0	0	0	75001	0	10	40213160		
51882	1135	40213160	1959-06-06	1959-06-06 00:00:00	1959-06-06	1959-06-06 00:00:00	1959-06-06	581452		0	0	0		0	0	0	74767	0	10	40213160		
104684	2295	40213227	2015-02-17	2015-02-17 00:00:00	2015-02-17	2015-02-17 00:00:00	2015-02-17	581452		0	0	0		0	0	0	152771	0	113	40213227		
31627	2621	1127433	1986-01-29	1986-01-29 00:00:00	1986-02-12	1986-02-12 00:00:00	1986-02-12	38000177		0	0	14		0	0	0	173382	0	313782	1127433		
211759	4642	40213227	2003-12-02	2003-12-02 00:00:00	2003-12-02	2003-12-02 00:00:00	2003-12-02	581452		0	0	0		0	0	0	309447	0	113	40213227		
205689	4514	40213227	2008-06-06	2008-06-06 00:00:00	2008-06-06	2008-06-06 00:00:00	2008-06-06	581452		0	0	0		0	0	0	300706	0	113	40213227		
50626	4208	19077572	2008-04-08	2008-04-08 00:00:00	2008-04-08	2008-04-08 00:00:00	\N	38000177		0	0	0		0	0	0	279392	0	310436	19077572		
38308	3170	1127433	1972-12-18	1972-12-18 00:00:00	1972-12-25	1972-12-25 00:00:00	1972-12-25	38000177		0	0	7		0	0	0	210721	0	313782	1127433		
33044	2740	19133905	1988-03-28	1988-03-28 00:00:00	1988-04-10	1988-04-10 00:00:00	1988-04-10	38000177		0	0	13		0	0	0	181286	0	834102	19133905		
52808	4388	1154615	1970-08-26	1970-08-26 00:00:00	1970-08-26	1970-08-26 00:00:00	\N	38000177		0	0	0		0	0	0	291686	0	745679	1154615		
49355	1081	40213306	1984-05-23	1984-05-23 00:00:00	1984-05-23	1984-05-23 00:00:00	1984-05-23	581452		0	0	0		0	0	0	70870	0	43	40213306		
32670	2708	19078461	2010-02-16	2010-02-16 00:00:00	2010-03-02	2010-03-02 00:00:00	2010-03-02	38000177		0	0	14		0	0	0	179435	0	310965	19078461		
147305	3238	40213160	1967-11-06	1967-11-06 00:00:00	1967-11-06	1967-11-06 00:00:00	1967-11-06	581452		0	0	0		0	0	0	215263	0	10	40213160		
160690	3536	40213260	2014-04-24	2014-04-24 00:00:00	2014-04-24	2014-04-24 00:00:00	2014-04-24	581452		0	0	0		0	0	0	234891	0	121	40213260		
42954	3561	1127433	1930-09-23	1930-09-23 00:00:00	1930-09-30	1930-09-30 00:00:00	1930-09-30	38000177		0	0	7		0	0	0	236496	0	313782	1127433		
5141	430	1127433	2009-09-03	2009-09-03 00:00:00	2009-09-24	2009-09-24 00:00:00	2009-09-24	38000177		0	0	21		0	0	0	28543	0	313782	1127433		
36986	807	40213227	1992-11-17	1992-11-17 00:00:00	1992-11-17	1992-11-17 00:00:00	1992-11-17	581452		0	0	0		0	0	0	53550	0	113	40213227		
77535	1695	40213160	1966-09-08	1966-09-08 00:00:00	1966-09-08	1966-09-08 00:00:00	1966-09-08	581452		0	0	0		0	0	0	113461	0	10	40213160		
89623	1966	40213227	1994-12-20	1994-12-20 00:00:00	1994-12-20	1994-12-20 00:00:00	1994-12-20	581452		0	0	0		0	0	0	130698	0	113	40213227		
183186	4024	40213314	1979-05-06	1979-05-06 00:00:00	1979-05-06	1979-05-06 00:00:00	1979-05-06	581452		0	0	0		0	0	0	267575	0	49	40213314		
164867	3625	40213227	2014-09-16	2014-09-16 00:00:00	2014-09-16	2014-09-16 00:00:00	2014-09-16	581452		0	0	0		0	0	0	241073	0	113	40213227		
45232	3744	19006318	1975-07-14	1975-07-14 00:00:00	1975-07-28	1975-07-28 00:00:00	1975-07-28	38000177		0	0	14		0	0	0	248786	0	105078	19006318		
45282	3748	1713671	2004-11-04	2004-11-04 00:00:00	2004-11-25	2004-11-25 00:00:00	2004-11-25	38000177		0	0	21		0	0	0	249099	0	562251	1713671		
55425	4603	19133873	1931-05-18	1931-05-18 00:00:00	1931-05-26	1931-05-26 00:00:00	1931-05-26	38000177		0	0	8		0	0	0	306627	0	834061	19133873		
550	40	40229134	1985-05-29	1985-05-29 00:00:00	1985-06-12	1985-06-12 00:00:00	1985-06-12	38000177		0	0	14		0	0	0	2871	0	1043400	40229134		
55647	4621	1124300	2012-07-07	2012-07-07 00:00:00	2012-07-07	2012-07-07 00:00:00	\N	38000177		0	0	0		0	0	0	307767	0	00781178901	45011828		
28283	2334	19059056	1951-06-10	1951-06-10 00:00:00	1951-06-24	1951-06-24 00:00:00	1951-06-24	38000177		0	0	14		0	0	0	155340	0	243670	19059056		
55734	4628	19133873	1979-12-16	1979-12-16 00:00:00	1979-12-25	1979-12-25 00:00:00	1979-12-25	38000177		0	0	9		0	0	0	308354	0	834061	19133873		
30129	2498	19059056	1982-12-23	1982-12-23 00:00:00	1983-01-06	1983-01-06 00:00:00	1983-01-06	38000177		0	0	14		0	0	0	165401	0	243670	19059056		
21527	1769	1127078	1986-05-25	1986-05-25 00:00:00	1986-06-22	1986-06-22 00:00:00	1986-06-22	38000177		0	0	28		0	0	0	118284	0	282464	1127078		
39055	3227	19074841	1984-05-24	1984-05-24 00:00:00	1984-06-07	1984-06-07 00:00:00	1984-06-07	38000177		0	0	14		0	0	0	214533	0	309043	19074841		
38969	3221	40229134	2001-01-29	2001-01-29 00:00:00	2001-02-05	2001-02-05 00:00:00	2001-02-05	38000177		0	0	7		0	0	0	214110	0	1043400	40229134		
58217	4837	1127433	1979-01-15	1979-01-15 00:00:00	1979-01-29	1979-01-29 00:00:00	1979-01-29	38000177		0	0	14		0	0	0	321820	0	313782	1127433		
3588	297	19133905	1989-07-20	1989-07-20 00:00:00	1989-08-02	1989-08-02 00:00:00	1989-08-02	38000177		0	0	13		0	0	0	19779	0	834102	19133905		
12967	279	40213201	2018-11-23	2018-11-23 00:00:00	2018-11-23	2018-11-23 00:00:00	2018-11-23	581452		0	0	0		0	0	0	18591	0	33	40213201		
174788	3843	40213296	2009-05-24	2009-05-24 00:00:00	2009-05-24	2009-05-24 00:00:00	2009-05-24	581452		0	0	0		0	0	0	255102	0	52	40213296		
39650	3279	19006318	1955-07-25	1955-07-25 00:00:00	1955-08-08	1955-08-08 00:00:00	1955-08-08	38000177		0	0	14		0	0	0	217888	0	105078	19006318		
195537	4295	40213306	1992-06-24	1992-06-24 00:00:00	1992-06-24	1992-06-24 00:00:00	1992-06-24	581452		0	0	0		0	0	0	\N	0	43	40213306		
50201	4165	40229134	1932-01-15	1932-01-15 00:00:00	1932-01-29	1932-01-29 00:00:00	1932-01-29	38000177		0	0	14		0	0	0	276720	0	1043400	40229134		
129935	2857	40213160	1964-08-20	1964-08-20 00:00:00	1964-08-20	1964-08-20 00:00:00	1964-08-20	581452		0	0	0		0	0	0	189718	0	10	40213160		
48417	4013	40229134	1984-06-28	1984-06-28 00:00:00	1984-07-05	1984-07-05 00:00:00	1984-07-05	38000177		0	0	7		0	0	0	266647	0	1043400	40229134		
191160	4200	40213296	2010-06-30	2010-06-30 00:00:00	2010-06-30	2010-06-30 00:00:00	2010-06-30	581452		0	0	0		0	0	0	278798	0	52	40213296		
71600	1566	40213227	2000-09-09	2000-09-09 00:00:00	2000-09-09	2000-09-09 00:00:00	2000-09-09	581452		0	0	0		0	0	0	105007	0	113	40213227		
207084	4543	40213314	1980-11-15	1980-11-15 00:00:00	1980-11-15	1980-11-15 00:00:00	1980-11-15	581452		0	0	0		0	0	0	302610	0	49	40213314		
13571	1137	1127433	1959-03-15	1959-03-15 00:00:00	1959-03-22	1959-03-22 00:00:00	1959-03-22	38000177		0	0	7		0	0	0	74878	0	313782	1127433		
1623	36	40213260	2009-10-27	2009-10-27 00:00:00	2009-10-27	2009-10-27 00:00:00	2009-10-27	581452		0	0	0		0	0	0	2569	0	121	40213260		
1638	36	40213260	2008-10-21	2008-10-21 00:00:00	2008-10-21	2008-10-21 00:00:00	2008-10-21	581452		0	0	0		0	0	0	2596	0	121	40213260		
119029	2617	40213160	1955-07-16	1955-07-16 00:00:00	1955-07-16	1955-07-16 00:00:00	1955-07-16	581452		0	0	0		0	0	0	173087	0	10	40213160		
95670	2097	40213160	1982-02-13	1982-02-13 00:00:00	1982-02-13	1982-02-13 00:00:00	1982-02-13	581452		0	0	0		0	0	0	139822	0	10	40213160		
178751	3929	40213160	1955-10-10	1955-10-10 00:00:00	1955-10-10	1955-10-10 00:00:00	1955-10-10	581452		0	0	0		0	0	0	261214	0	10	40213160		
130409	2865	40213260	2018-01-29	2018-01-29 00:00:00	2018-01-29	2018-01-29 00:00:00	2018-01-29	581452		0	0	0		0	0	0	190576	0	121	40213260		
39248	3242	19133905	2014-09-13	2014-09-13 00:00:00	2014-09-25	2014-09-25 00:00:00	2014-09-25	38000177		0	0	12		0	0	0	215634	0	834102	19133905		
56114	1229	40213160	1955-04-23	1955-04-23 00:00:00	1955-04-23	1955-04-23 00:00:00	1955-04-23	581452		0	0	0		0	0	0	80987	0	10	40213160		
17476	377	40213227	1998-03-12	1998-03-12 00:00:00	1998-03-12	1998-03-12 00:00:00	1998-03-12	581452		0	0	0		0	0	0	25004	0	113	40213227		
190702	4190	40213160	1972-11-05	1972-11-05 00:00:00	1972-11-05	1972-11-05 00:00:00	1972-11-05	581452		0	0	0		0	0	0	278082	0	10	40213160		
28046	2320	40229134	1947-11-01	1947-11-01 00:00:00	1947-11-15	1947-11-15 00:00:00	1947-11-15	38000177		0	0	14		0	0	0	154277	0	1043400	40229134		
232287	5104	40213306	2002-10-13	2002-10-13 00:00:00	2002-10-13	2002-10-13 00:00:00	2002-10-13	581452		0	0	0		0	0	0	339173	0	43	40213306		
98981	2167	40213160	1983-02-23	1983-02-23 00:00:00	1983-02-23	1983-02-23 00:00:00	1983-02-23	581452		0	0	0		0	0	0	144370	0	10	40213160		
55114	4576	1127078	1955-12-03	1955-12-03 00:00:00	1955-12-17	1955-12-17 00:00:00	1955-12-17	38000177		0	0	14		0	0	0	304818	0	282464	1127078		
62627	5207	1127078	1960-09-05	1960-09-05 00:00:00	1960-09-19	1960-09-19 00:00:00	1960-09-19	38000177		0	0	14		0	0	0	346339	0	282464	1127078		
58024	4820	1127433	2003-07-17	2003-07-17 00:00:00	2003-07-31	2003-07-31 00:00:00	2003-07-31	38000177		0	0	14		0	0	0	320633	0	313782	1127433		
62742	5215	1713671	1960-11-22	1960-11-22 00:00:00	1960-12-13	1960-12-13 00:00:00	1960-12-13	38000177		0	0	21		0	0	0	346867	0	562251	1713671		
62745	5215	40165015	1978-07-14	1978-07-14 00:00:00	1978-07-14	1978-07-14 00:00:00	\N	38000177		0	0	0		0	0	0	346840	0	861467	40165015		
214994	4715	40213227	1992-08-19	1992-08-19 00:00:00	1992-08-19	1992-08-19 00:00:00	1992-08-19	581452		0	0	0		0	0	0	313974	0	113	40213227		
51998	1138	40213314	1980-07-10	1980-07-10 00:00:00	1980-07-10	1980-07-10 00:00:00	1980-07-10	581452		0	0	0		0	0	0	75001	0	49	40213314		
51884	1135	40213296	1999-01-02	1999-01-02 00:00:00	1999-01-02	1999-01-02 00:00:00	1999-01-02	581452		0	0	0		0	0	0	74783	0	52	40213296		
104685	2295	40213296	2015-02-17	2015-02-17 00:00:00	2015-02-17	2015-02-17 00:00:00	2015-02-17	581452		0	0	0		0	0	0	152771	0	52	40213296		
31628	2621	19133873	1961-01-03	1961-01-03 00:00:00	1961-01-11	1961-01-11 00:00:00	1961-01-11	38000177		0	0	8		0	0	0	173380	0	834061	19133873		
211761	4642	40213160	1955-05-03	1955-05-03 00:00:00	1955-05-03	1955-05-03 00:00:00	1955-05-03	581452		0	0	0		0	0	0	309486	0	10	40213160		
205691	4514	40213160	1975-08-29	1975-08-29 00:00:00	1975-08-29	1975-08-29 00:00:00	1975-08-29	581452		0	0	0		0	0	0	300611	0	10	40213160		
50627	4208	1127433	1972-10-08	1972-10-08 00:00:00	1972-10-22	1972-10-22 00:00:00	1972-10-22	38000177		0	0	14		0	0	0	279427	0	313782	1127433		
38311	3170	19059056	1958-06-13	1958-06-13 00:00:00	1958-06-27	1958-06-27 00:00:00	1958-06-27	38000177		0	0	14		0	0	0	210712	0	243670	19059056		
33045	2740	1127433	1996-10-14	1996-10-14 00:00:00	1997-01-12	1997-01-12 00:00:00	1997-01-12	38000177		0	0	90		0	0	0	181283	0	313782	1127433		
52809	4388	19129655	1970-09-15	1970-09-15 00:00:00	1970-09-29	1970-09-29 00:00:00	1970-09-29	38000177		0	0	14		0	0	0	291665	0	789980	19129655		
49360	1081	40213227	2012-08-22	2012-08-22 00:00:00	2012-08-22	2012-08-22 00:00:00	2012-08-22	581452		0	0	0		0	0	0	70897	0	113	40213227		
32671	2708	1127433	1983-08-03	1983-08-03 00:00:00	1983-08-10	1983-08-10 00:00:00	1983-08-10	38000177		0	0	7		0	0	0	179351	0	313782	1127433		
147308	3238	40213160	1972-02-07	1972-02-07 00:00:00	1972-02-07	1972-02-07 00:00:00	1972-02-07	581452		0	0	0		0	0	0	215310	0	10	40213160		
160708	3536	40213160	1964-07-16	1964-07-16 00:00:00	1964-07-16	1964-07-16 00:00:00	1964-07-16	581452		0	0	0		0	0	0	234822	0	10	40213160		
42955	3561	1127433	1949-02-12	1949-02-12 00:00:00	1949-02-19	1949-02-19 00:00:00	1949-02-19	38000177		0	0	7		0	0	0	236509	0	313782	1127433		
5142	430	19059056	1938-10-11	1938-10-11 00:00:00	1938-12-10	1938-12-10 00:00:00	1938-12-10	38000177		0	0	60		0	0	0	28537	0	243670	19059056		
37013	807	40213198	2016-03-01	2016-03-01 00:00:00	2016-03-01	2016-03-01 00:00:00	2016-03-01	581452		0	0	0		0	0	0	53600	0	133	40213198		
77538	1695	40213306	1989-09-21	1989-09-21 00:00:00	1989-09-21	1989-09-21 00:00:00	1989-09-21	581452		0	0	0		0	0	0	113503	0	43	40213306		
89628	1966	40213260	2012-01-24	2012-01-24 00:00:00	2012-01-24	2012-01-24 00:00:00	2012-01-24	581452		0	0	0		0	0	0	130690	0	121	40213260		
183187	4024	40213160	1979-05-06	1979-05-06 00:00:00	1979-05-06	1979-05-06 00:00:00	1979-05-06	581452		0	0	0		0	0	0	267575	0	10	40213160		
164871	3625	40213227	2004-07-20	2004-07-20 00:00:00	2004-07-20	2004-07-20 00:00:00	2004-07-20	581452		0	0	0		0	0	0	241069	0	113	40213227		
45233	3744	19059056	1975-07-14	1975-07-14 00:00:00	1975-07-28	1975-07-28 00:00:00	1975-07-28	38000177		0	0	14		0	0	0	248786	0	243670	19059056		
45283	3748	1127433	2008-08-09	2008-08-09 00:00:00	2008-08-16	2008-08-16 00:00:00	2008-08-16	38000177		0	0	7		0	0	0	249145	0	313782	1127433		
55426	4603	1127433	1972-04-14	1972-04-14 00:00:00	1972-04-28	1972-04-28 00:00:00	1972-04-28	38000177		0	0	14		0	0	0	306652	0	313782	1127433		
16809	1390	1713671	1976-12-07	1976-12-07 00:00:00	1976-12-21	1976-12-21 00:00:00	1976-12-21	38000177		0	0	14		0	0	0	92255	0	562251	1713671		
55648	4621	1713671	1978-07-21	1978-07-21 00:00:00	1978-07-28	1978-07-28 00:00:00	1978-07-28	38000177		0	0	7		0	0	0	307775	0	562251	1713671		
28284	2334	19059056	1936-02-29	1936-02-29 00:00:00	1936-03-14	1936-03-14 00:00:00	1936-03-14	38000177		0	0	14		0	0	0	155318	0	243670	19059056		
55735	4628	1150837	1986-10-24	1986-10-24 00:00:00	1986-10-24	1986-10-24 00:00:00	\N	38000177		0	0	0		0	0	0	308311	0	141918	1150837		
30130	2498	1127433	1995-08-29	1995-08-29 00:00:00	1995-09-26	1995-09-26 00:00:00	1995-09-26	38000177		0	0	28		0	0	0	165403	0	313782	1127433		
21528	1769	1127433	1989-03-10	1989-03-10 00:00:00	1989-03-24	1989-03-24 00:00:00	1989-03-24	38000177		0	0	14		0	0	0	118271	0	313782	1127433		
39056	3227	1127433	1984-05-24	1984-05-24 00:00:00	1984-06-07	1984-06-07 00:00:00	1984-06-07	38000177		0	0	14		0	0	0	214533	0	313782	1127433		
38970	3221	19059056	1965-05-21	1965-05-21 00:00:00	1965-06-04	1965-06-04 00:00:00	1965-06-04	38000177		0	0	14		0	0	0	214094	0	243670	19059056		
58218	4837	19133873	1956-08-15	1956-08-15 00:00:00	1956-08-25	1956-08-25 00:00:00	1956-08-25	38000177		0	0	10		0	0	0	321836	0	834061	19133873		
3591	297	1127433	2011-04-08	2011-04-08 00:00:00	2011-05-13	2011-05-13 00:00:00	2011-05-13	38000177		0	0	35		0	0	0	19840	0	313782	1127433		
13004	280	40213201	2004-12-10	2004-12-10 00:00:00	2004-12-10	2004-12-10 00:00:00	2004-12-10	581452		0	0	0		0	0	0	18697	0	33	40213201		
174790	3843	40213227	2011-05-29	2011-05-29 00:00:00	2011-05-29	2011-05-29 00:00:00	2011-05-29	581452		0	0	0		0	0	0	255091	0	113	40213227		
39651	3279	19059056	1955-07-25	1955-07-25 00:00:00	1955-08-08	1955-08-08 00:00:00	1955-08-08	38000177		0	0	14		0	0	0	217888	0	243670	19059056		
195540	4295	40213160	1971-12-29	1971-12-29 00:00:00	1971-12-29	1971-12-29 00:00:00	1971-12-29	581452		0	0	0		0	0	0	285047	0	10	40213160		
50202	4165	19078461	1990-08-18	1990-08-18 00:00:00	1990-11-16	1990-11-16 00:00:00	1990-11-16	38000177		0	0	90		0	0	0	276827	0	310965	19078461		
135923	2985	40213227	1994-12-10	1994-12-10 00:00:00	1994-12-10	1994-12-10 00:00:00	1994-12-10	581452		0	0	0		0	0	0	199260	0	113	40213227		
48418	4013	1127078	1980-04-25	1980-04-25 00:00:00	1980-05-09	1980-05-09 00:00:00	1980-05-09	38000177		0	0	14		0	0	0	266684	0	282464	1127078		
191166	4200	40213160	1968-09-25	1968-09-25 00:00:00	1968-09-25	1968-09-25 00:00:00	1968-09-25	581452		0	0	0		0	0	0	278753	0	10	40213160		
82881	1812	40213296	2003-07-21	2003-07-21 00:00:00	2003-07-21	2003-07-21 00:00:00	2003-07-21	581452		0	0	0		0	0	0	121276	0	52	40213296		
147354	3240	40213198	2011-09-21	2011-09-21 00:00:00	2011-09-21	2011-09-21 00:00:00	2011-09-21	581452		0	0	0		0	0	0	215418	0	133	40213198		
13572	1137	1127078	1952-08-09	1952-08-09 00:00:00	1952-08-30	1952-08-30 00:00:00	1952-08-30	38000177		0	0	21		0	0	0	74972	0	282464	1127078		
1631	36	40213296	2000-10-31	2000-10-31 00:00:00	2000-10-31	2000-10-31 00:00:00	2000-10-31	581452		0	0	0		0	0	0	2607	0	52	40213296		
1653	36	40213160	1959-03-31	1959-03-31 00:00:00	1959-03-31	1959-03-31 00:00:00	1959-03-31	581452		0	0	0		0	0	0	2565	0	10	40213160		
5593	469	19059056	1939-03-03	1939-03-03 00:00:00	1939-03-17	1939-03-17 00:00:00	1939-03-17	38000177		0	0	14		0	0	0	31264	0	243670	19059056		
95671	2097	40213314	1977-06-11	1977-06-11 00:00:00	1977-06-11	1977-06-11 00:00:00	1977-06-11	581452		0	0	0		0	0	0	139811	0	49	40213314		
178757	3929	40213160	1957-04-15	1957-04-15 00:00:00	1957-04-15	1957-04-15 00:00:00	1957-04-15	581452		0	0	0		0	0	0	261215	0	10	40213160		
130412	2866	40213160	1966-11-13	1966-11-13 00:00:00	1966-11-13	1966-11-13 00:00:00	1966-11-13	581452		0	0	0		0	0	0	190656	0	10	40213160		
39249	3242	1127433	2002-10-04	2002-10-04 00:00:00	2002-10-18	2002-10-18 00:00:00	2002-10-18	38000177		0	0	14		0	0	0	215620	0	313782	1127433		
141791	3115	40213227	1999-04-09	1999-04-09 00:00:00	1999-04-09	1999-04-09 00:00:00	1999-04-09	581452		0	0	0		0	0	0	207240	0	113	40213227		
57865	4807	40229134	2012-04-08	2012-04-08 00:00:00	2012-04-22	2012-04-22 00:00:00	2012-04-22	38000177		0	0	14		0	0	0	319888	0	1043400	40229134		
190711	4190	40213160	1973-01-07	1973-01-07 00:00:00	1973-01-07	1973-01-07 00:00:00	1973-01-07	581452		0	0	0		0	0	0	278100	0	10	40213160		
28047	2320	19059056	1945-03-14	1945-03-14 00:00:00	1945-04-18	1945-04-18 00:00:00	1945-04-18	38000177		0	0	35		0	0	0	154301	0	243670	19059056		
232289	5104	40213227	2002-10-13	2002-10-13 00:00:00	2002-10-13	2002-10-13 00:00:00	2002-10-13	581452		0	0	0		0	0	0	339173	0	113	40213227		
98985	2167	40213227	2009-09-09	2009-09-09 00:00:00	2009-09-09	2009-09-09 00:00:00	2009-09-09	581452		0	0	0		0	0	0	144386	0	113	40213227		
55115	4576	19006318	1955-12-03	1955-12-03 00:00:00	1955-12-17	1955-12-17 00:00:00	1955-12-17	38000177		0	0	14		0	0	0	304818	0	105078	19006318		
62628	5207	19128065	1981-11-05	1981-11-05 00:00:00	1982-10-31	1982-10-31 00:00:00	1982-10-31	38000177		0	0	360		0	0	0	346341	0	749882	19128065		
58025	4820	19059056	1961-06-11	1961-06-11 00:00:00	1961-06-25	1961-06-25 00:00:00	1961-06-25	38000177		0	0	14		0	0	0	320642	0	243670	19059056		
22327	484	40213227	2009-05-04	2009-05-04 00:00:00	2009-05-04	2009-05-04 00:00:00	2009-05-04	581452		0	0	0		0	0	0	32342	0	113	40213227		
62746	5215	19078461	1978-07-14	1978-07-14 00:00:00	1978-08-11	1978-08-11 00:00:00	1978-08-11	38000177		0	0	28		0	0	0	346840	0	310965	19078461		
214997	4715	40213198	2015-12-08	2015-12-08 00:00:00	2015-12-08	2015-12-08 00:00:00	2015-12-08	581452		0	0	0		0	0	0	313957	0	133	40213198		
51999	1138	40213160	1980-10-09	1980-10-09 00:00:00	1980-10-09	1980-10-09 00:00:00	1980-10-09	581452		0	0	0		0	0	0	75138	0	10	40213160		
51895	1136	40213227	1993-06-12	1993-06-12 00:00:00	1993-06-12	1993-06-12 00:00:00	1993-06-12	581452		0	0	0		0	0	0	74847	0	113	40213227		
104688	2295	40213227	2004-03-23	2004-03-23 00:00:00	2004-03-23	2004-03-23 00:00:00	2004-03-23	581452		0	0	0		0	0	0	152782	0	113	40213227		
31629	2621	1713671	1964-05-14	1964-05-14 00:00:00	1964-06-04	1964-06-04 00:00:00	1964-06-04	38000177		0	0	21		0	0	0	173332	0	562251	1713671		
211792	4643	40213227	1992-04-25	1992-04-25 00:00:00	1992-04-25	1992-04-25 00:00:00	1992-04-25	581452		0	0	0		0	0	0	309523	0	113	40213227		
205693	4514	40213314	1977-04-29	1977-04-29 00:00:00	1977-04-29	1977-04-29 00:00:00	1977-04-29	581452		0	0	0		0	0	0	300700	0	49	40213314		
50629	4208	19059056	1944-11-20	1944-11-20 00:00:00	1944-12-20	1944-12-20 00:00:00	1944-12-20	38000177		0	0	30		0	0	0	279425	0	243670	19059056		
38313	3170	1127078	1962-05-07	1962-05-07 00:00:00	1962-07-06	1962-07-06 00:00:00	1962-07-06	38000177		0	0	60		0	0	0	210713	0	282464	1127078		
33046	2740	1713671	2000-07-14	2000-07-14 00:00:00	2000-08-04	2000-08-04 00:00:00	2000-08-04	38000177		0	0	21		0	0	0	181307	0	562251	1713671		
52810	4388	19059056	1970-09-15	1970-09-15 00:00:00	1970-09-29	1970-09-29 00:00:00	1970-09-29	38000177		0	0	14		0	0	0	291665	0	243670	19059056		
49361	1081	40213260	2012-08-22	2012-08-22 00:00:00	2012-08-22	2012-08-22 00:00:00	2012-08-22	581452		0	0	0		0	0	0	70897	0	121	40213260		
32672	2708	1127433	1994-11-18	1994-11-18 00:00:00	1994-12-16	1994-12-16 00:00:00	1994-12-16	38000177		0	0	28		0	0	0	179433	0	313782	1127433		
147311	3238	40213306	1989-03-13	1989-03-13 00:00:00	1989-03-13	1989-03-13 00:00:00	1989-03-13	581452		0	0	0		0	0	0	215293	0	43	40213306		
160710	3536	40213160	1968-10-17	1968-10-17 00:00:00	1968-10-17	1968-10-17 00:00:00	1968-10-17	581452		0	0	0		0	0	0	234884	0	10	40213160		
42956	3561	1127433	1925-02-12	1925-02-12 00:00:00	1925-02-19	1925-02-19 00:00:00	1925-02-19	38000177		0	0	7		0	0	0	236498	0	313782	1127433		
5143	430	40174880	1990-06-05	1990-06-05 00:00:00	1990-06-05	1990-06-05 00:00:00	\N	38000177		0	0	0		0	0	0	28434	0	966222	40174880		
51513	1128	40213160	1969-01-03	1969-01-03 00:00:00	1969-01-03	1969-01-03 00:00:00	1969-01-03	581452		0	0	0		0	0	0	74337	0	10	40213160		
77539	1695	40213160	1966-06-09	1966-06-09 00:00:00	1966-06-09	1966-06-09 00:00:00	1966-06-09	581452		0	0	0		0	0	0	113451	0	10	40213160		
89631	1966	40213160	1961-08-01	1961-08-01 00:00:00	1961-08-01	1961-08-01 00:00:00	1961-08-01	581452		0	0	0		0	0	0	130708	0	10	40213160		
79374	1737	40213227	1993-04-02	1993-04-02 00:00:00	1993-04-02	1993-04-02 00:00:00	1993-04-02	581452		0	0	0		0	0	0	115986	0	113	40213227		
164873	3625	40213160	1955-06-21	1955-06-21 00:00:00	1955-06-21	1955-06-21 00:00:00	1955-06-21	581452		0	0	0		0	0	0	241089	0	10	40213160		
45234	3744	1124300	2004-12-09	2004-12-09 00:00:00	2004-12-09	2004-12-09 00:00:00	\N	38000177		0	0	0		0	0	0	248861	0	00781178901	45011828		
45284	3748	1118084	2015-10-30	2015-10-30 00:00:00	2015-10-30	2015-10-30 00:00:00	\N	38000177		0	0	0		0	0	0	249136	0	00025152531	44923712		
55427	4603	40165015	2004-09-07	2004-09-07 00:00:00	2004-09-07	2004-09-07 00:00:00	\N	38000177		0	0	0		0	0	0	306623	0	861467	40165015		
16810	1390	1127078	1967-10-21	1967-10-21 00:00:00	1967-11-11	1967-11-11 00:00:00	1967-11-11	38000177		0	0	21		0	0	0	92247	0	282464	1127078		
55649	4621	1127078	1978-11-30	1978-11-30 00:00:00	1978-12-14	1978-12-14 00:00:00	1978-12-14	38000177		0	0	14		0	0	0	307724	0	282464	1127078		
28308	2337	19128065	1983-06-11	1983-06-11 00:00:00	1984-06-05	1984-06-05 00:00:00	1984-06-05	38000177		0	0	360		0	0	0	155482	0	749882	19128065		
28327	2337	40236824	1985-08-26	1985-08-26 00:00:00	1985-09-02	1985-09-02 00:00:00	1985-09-02	38000177		0	0	7		0	0	0	155505	0	1094107	40236824		
30131	2498	19133873	1975-12-19	1975-12-19 00:00:00	1975-12-31	1975-12-31 00:00:00	1975-12-31	38000177		0	0	12		0	0	0	165384	0	834061	19133873		
21529	1769	19075001	1989-03-10	1989-03-10 00:00:00	1989-03-24	1989-03-24 00:00:00	1989-03-24	38000177		0	0	14		0	0	0	118271	0	309097	19075001		
39057	3227	19078461	1998-07-23	1998-07-23 00:00:00	1998-08-29	1998-08-29 00:00:00	1998-08-29	38000177		0	0	37		0	0	0	214543	0	310965	19078461		
38971	3221	19129655	1965-05-21	1965-05-21 00:00:00	1965-06-04	1965-06-04 00:00:00	1965-06-04	38000177		0	0	14		0	0	0	214094	0	789980	19129655		
58219	4837	1127433	2008-05-29	2008-05-29 00:00:00	2008-06-12	2008-06-12 00:00:00	2008-06-12	38000177		0	0	14		0	0	0	321839	0	313782	1127433		
3592	297	19078461	1986-07-13	1986-07-13 00:00:00	1986-08-17	1986-08-17 00:00:00	1986-08-17	38000177		0	0	35		0	0	0	19839	0	310965	19078461		
13005	280	40213227	1992-10-02	1992-10-02 00:00:00	1992-10-02	1992-10-02 00:00:00	1992-10-02	581452		0	0	0		0	0	0	18684	0	113	40213227		
174791	3843	40213296	2011-05-29	2011-05-29 00:00:00	2011-05-29	2011-05-29 00:00:00	2011-05-29	581452		0	0	0		0	0	0	255091	0	52	40213296		
39652	3279	1127433	1966-09-14	1966-09-14 00:00:00	1966-09-28	1966-09-28 00:00:00	1966-09-28	38000177		0	0	14		0	0	0	217884	0	313782	1127433		
195543	4295	40213227	1993-10-20	1993-10-20 00:00:00	1993-10-20	1993-10-20 00:00:00	1993-10-20	581452		0	0	0		0	0	0	285092	0	113	40213227		
50203	4165	19133873	1922-02-24	1922-02-24 00:00:00	1922-03-09	1922-03-09 00:00:00	1922-03-09	38000177		0	0	13		0	0	0	276719	0	834061	19133873		
135929	2985	40213296	2003-10-25	2003-10-25 00:00:00	2003-10-25	2003-10-25 00:00:00	2003-10-25	581452		0	0	0		0	0	0	199248	0	52	40213296		
48419	4013	46233988	1978-12-17	1978-12-17 00:00:00	1978-12-31	1978-12-31 00:00:00	1978-12-31	38000177		0	0	14		0	0	0	266633	0	1652673	46233988		
191168	4200	40213260	2019-06-26	2019-06-26 00:00:00	2019-06-26	2019-06-26 00:00:00	2019-06-26	581452		0	0	0		0	0	0	278799	0	121	40213260		
82889	1812	40213160	1960-07-04	1960-07-04 00:00:00	1960-07-04	1960-07-04 00:00:00	1960-07-04	581452		0	0	0		0	0	0	121261	0	10	40213160		
147370	3240	40213201	2012-09-26	2012-09-26 00:00:00	2012-09-26	2012-09-26 00:00:00	2012-09-26	581452		0	0	0		0	0	0	215340	0	33	40213201		
13573	1137	1127433	1975-06-01	1975-06-01 00:00:00	1975-06-15	1975-06-15 00:00:00	1975-06-15	38000177		0	0	14		0	0	0	74977	0	313782	1127433		
1633	36	40213227	2000-10-31	2000-10-31 00:00:00	2000-10-31	2000-10-31 00:00:00	2000-10-31	581452		0	0	0		0	0	0	2607	0	113	40213227		
1656	36	40213306	1982-01-12	1982-01-12 00:00:00	1982-01-12	1982-01-12 00:00:00	1982-01-12	581452		0	0	0		0	0	0	2577	0	43	40213306		
5594	469	40229134	2010-08-28	2010-08-28 00:00:00	2010-09-11	2010-09-11 00:00:00	2010-09-11	38000177		0	0	14		0	0	0	31254	0	1043400	40229134		
95672	2097	40213160	1977-06-11	1977-06-11 00:00:00	1977-06-11	1977-06-11 00:00:00	1977-06-11	581452		0	0	0		0	0	0	139811	0	10	40213160		
178766	3929	40213160	1955-04-11	1955-04-11 00:00:00	1955-04-11	1955-04-11 00:00:00	1955-04-11	581452		0	0	0		0	0	0	261193	0	10	40213160		
130413	2866	40213260	2017-08-13	2017-08-13 00:00:00	2017-08-13	2017-08-13 00:00:00	2017-08-13	581452		0	0	0		0	0	0	190694	0	121	40213260		
39250	3242	1713671	1986-12-05	1986-12-05 00:00:00	1986-12-26	1986-12-26 00:00:00	1986-12-26	38000177		0	0	21		0	0	0	215630	0	562251	1713671		
141795	3115	40213306	1990-03-30	1990-03-30 00:00:00	1990-03-30	1990-03-30 00:00:00	1990-03-30	581452		0	0	0		0	0	0	207237	0	43	40213306		
57866	4807	40229134	1981-01-03	1981-01-03 00:00:00	1981-01-17	1981-01-17 00:00:00	1981-01-17	38000177		0	0	14		0	0	0	319885	0	1043400	40229134		
190712	4190	40213296	2014-08-10	2014-08-10 00:00:00	2014-08-10	2014-08-10 00:00:00	2014-08-10	581452		0	0	0		0	0	0	278093	0	52	40213296		
28048	2320	1713671	2004-11-02	2004-11-02 00:00:00	2004-11-16	2004-11-16 00:00:00	2004-11-16	38000177		0	0	14		0	0	0	154257	0	562251	1713671		
232291	5104	40213314	1981-02-07	1981-02-07 00:00:00	1981-02-07	1981-02-07 00:00:00	1981-02-07	581452		0	0	0		0	0	0	339146	0	49	40213314		
110271	2423	40213260	2006-10-23	2006-10-23 00:00:00	2006-10-23	2006-10-23 00:00:00	2006-10-23	581452		0	0	0		0	0	0	160783	0	121	40213260		
55116	4576	1127433	1981-11-02	1981-11-02 00:00:00	1981-11-16	1981-11-16 00:00:00	1981-11-16	38000177		0	0	14		0	0	0	304851	0	313782	1127433		
62629	5207	19128065	1979-11-16	1979-11-16 00:00:00	1980-11-10	1980-11-10 00:00:00	1980-11-10	38000177		0	0	360		0	0	0	346384	0	749882	19128065		
58026	4820	19133905	1989-01-25	1989-01-25 00:00:00	1989-02-07	1989-02-07 00:00:00	1989-02-07	38000177		0	0	13		0	0	0	320669	0	834102	19133905		
22329	484	40213227	1992-01-27	1992-01-27 00:00:00	1992-01-27	1992-01-27 00:00:00	1992-01-27	581452		0	0	0		0	0	0	32358	0	113	40213227		
62747	5215	1127433	1944-02-23	1944-02-23 00:00:00	1944-03-01	1944-03-01 00:00:00	1944-03-01	38000177		0	0	7		0	0	0	346832	0	313782	1127433		
51216	1122	40213296	2012-01-02	2012-01-02 00:00:00	2012-01-02	2012-01-02 00:00:00	2012-01-02	581452		0	0	0		0	0	0	73919	0	52	40213296		
52006	1138	40213227	2011-11-03	2011-11-03 00:00:00	2011-11-03	2011-11-03 00:00:00	2011-11-03	581452		0	0	0		0	0	0	75018	0	113	40213227		
51896	1136	40213306	1993-06-12	1993-06-12 00:00:00	1993-06-12	1993-06-12 00:00:00	1993-06-12	581452		0	0	0		0	0	0	74847	0	43	40213306		
104689	2295	40213160	1973-07-17	1973-07-17 00:00:00	1973-07-17	1973-07-17 00:00:00	1973-07-17	581452		0	0	0		0	0	0	152797	0	10	40213160		
31630	2622	40229134	1991-08-04	1991-08-04 00:00:00	1991-08-18	1991-08-18 00:00:00	1991-08-18	38000177		0	0	14		0	0	0	173442	0	1043400	40229134		
33573	732	40213160	1972-07-20	1972-07-20 00:00:00	1972-07-20	1972-07-20 00:00:00	1972-07-20	581452		0	0	0		0	0	0	48546	0	10	40213160		
205698	4514	40213314	1978-04-28	1978-04-28 00:00:00	1978-04-28	1978-04-28 00:00:00	1978-04-28	581452		0	0	0		0	0	0	300601	0	49	40213314		
50630	4208	1127433	1984-07-21	1984-07-21 00:00:00	1984-08-11	1984-08-11 00:00:00	1984-08-11	38000177		0	0	21		0	0	0	279429	0	313782	1127433		
38314	3170	1713671	1953-06-30	1953-06-30 00:00:00	1953-07-21	1953-07-21 00:00:00	1953-07-21	38000177		0	0	21		0	0	0	210728	0	562251	1713671		
135148	2966	40213227	2012-11-17	2012-11-17 00:00:00	2012-11-17	2012-11-17 00:00:00	2012-11-17	581452		0	0	0		0	0	0	198036	0	113	40213227		
52811	4388	1118084	2007-12-28	2007-12-28 00:00:00	2007-12-28	2007-12-28 00:00:00	\N	38000177		0	0	0		0	0	0	291742	0	00025152531	44923712		
49364	1081	40213227	2004-02-25	2004-02-25 00:00:00	2004-02-25	2004-02-25 00:00:00	2004-02-25	581452		0	0	0		0	0	0	70871	0	113	40213227		
32673	2708	1127433	1959-07-12	1959-07-12 00:00:00	1959-07-26	1959-07-26 00:00:00	1959-07-26	38000177		0	0	14		0	0	0	179349	0	313782	1127433		
146999	3232	40213260	2014-09-22	2014-09-22 00:00:00	2014-09-22	2014-09-22 00:00:00	2014-09-22	581452		0	0	0		0	0	0	214814	0	121	40213260		
160713	3536	40213227	2015-04-30	2015-04-30 00:00:00	2015-04-30	2015-04-30 00:00:00	2015-04-30	581452		0	0	0		0	0	0	234872	0	113	40213227		
42957	3561	1127433	2002-06-13	2002-06-13 00:00:00	2002-06-27	2002-06-27 00:00:00	2002-06-27	38000177		0	0	14		0	0	0	236519	0	313782	1127433		
5144	430	19059056	1933-06-20	1933-06-20 00:00:00	1933-07-04	1933-07-04 00:00:00	1933-07-04	38000177		0	0	14		0	0	0	28477	0	243670	19059056		
51516	1128	40213227	1999-10-08	1999-10-08 00:00:00	1999-10-08	1999-10-08 00:00:00	1999-10-08	581452		0	0	0		0	0	0	74305	0	113	40213227		
4010	86	40213160	1955-08-09	1955-08-09 00:00:00	1955-08-09	1955-08-09 00:00:00	1955-08-09	581452		0	0	0		0	0	0	5801	0	10	40213160		
89636	1966	40213296	2005-01-04	2005-01-04 00:00:00	2005-01-04	2005-01-04 00:00:00	2005-01-04	581452		0	0	0		0	0	0	130719	0	52	40213296		
79379	1737	40213227	2003-02-21	2003-02-21 00:00:00	2003-02-21	2003-02-21 00:00:00	2003-02-21	581452		0	0	0		0	0	0	116074	0	113	40213227		
164876	3625	40213198	2018-10-09	2018-10-09 00:00:00	2018-10-09	2018-10-09 00:00:00	2018-10-09	581452		0	0	0		0	0	0	241105	0	133	40213198		
45235	3744	1127433	1979-09-18	1979-09-18 00:00:00	1979-10-02	1979-10-02 00:00:00	1979-10-02	38000177		0	0	14		0	0	0	248747	0	313782	1127433		
45285	3748	19019979	1983-02-20	1983-02-20 00:00:00	1983-03-06	1983-03-06 00:00:00	1983-03-06	38000177		0	0	14		0	0	0	249101	0	198405	19019979		
55428	4603	1127433	2004-09-07	2004-09-07 00:00:00	2004-10-07	2004-10-07 00:00:00	2004-10-07	38000177		0	0	30		0	0	0	306623	0	313782	1127433		
16811	1390	19078461	2013-12-21	2013-12-21 00:00:00	2014-03-21	2014-03-21 00:00:00	2014-03-21	38000177		0	0	90		0	0	0	92251	0	310965	19078461		
55650	4621	1127433	1989-09-30	1989-09-30 00:00:00	1989-10-21	1989-10-21 00:00:00	1989-10-21	38000177		0	0	21		0	0	0	307743	0	313782	1127433		
28309	2337	19128065	1980-06-26	1980-06-26 00:00:00	1981-06-21	1981-06-21 00:00:00	1981-06-21	38000177		0	0	360		0	0	0	155526	0	749882	19128065		
28328	2337	920300	1985-08-26	1985-08-26 00:00:00	1985-09-02	1985-09-02 00:00:00	1985-09-02	38000177		0	0	7		0	0	0	155505	0	311989	920300		
30132	2498	1127433	1992-01-22	1992-01-22 00:00:00	1992-02-05	1992-02-05 00:00:00	1992-02-05	38000177		0	0	14		0	0	0	165375	0	313782	1127433		
21530	1769	19128022	1994-08-21	1994-08-21 00:00:00	1995-08-16	1995-08-16 00:00:00	1995-08-16	38000177		0	0	360		0	0	0	118305	0	749785	19128022		
39058	3227	1118084	2004-10-04	2004-10-04 00:00:00	2004-10-04	2004-10-04 00:00:00	\N	38000177		0	0	0		0	0	0	214520	0	00025152531	44923712		
38972	3221	1127433	1977-02-07	1977-02-07 00:00:00	1977-02-14	1977-02-14 00:00:00	1977-02-14	38000177		0	0	7		0	0	0	214093	0	313782	1127433		
58220	4837	1127078	1952-02-17	1952-02-17 00:00:00	1952-03-02	1952-03-02 00:00:00	1952-03-02	38000177		0	0	14		0	0	0	321862	0	282464	1127078		
3593	297	1118084	1993-08-25	1993-08-25 00:00:00	1993-08-25	1993-08-25 00:00:00	\N	38000177		0	0	0		0	0	0	19806	0	00025152531	44923712		
49580	4113	1118084	1992-05-13	1992-05-13 00:00:00	1992-05-13	1992-05-13 00:00:00	\N	38000177		0	0	0		0	0	0	273460	0	00025152531	44923712		
174793	3844	40213201	2018-11-30	2018-11-30 00:00:00	2018-11-30	2018-11-30 00:00:00	2018-11-30	581452		0	0	0		0	0	0	255199	0	33	40213201		
39653	3279	40229134	1998-11-14	1998-11-14 00:00:00	1998-11-28	1998-11-28 00:00:00	1998-11-28	38000177		0	0	14		0	0	0	217869	0	1043400	40229134		
195544	4295	40213306	1993-10-20	1993-10-20 00:00:00	1993-10-20	1993-10-20 00:00:00	1993-10-20	581452		0	0	0		0	0	0	285092	0	43	40213306		
50204	4165	19059056	1925-09-23	1925-09-23 00:00:00	1925-10-14	1925-10-14 00:00:00	1925-10-14	38000177		0	0	21		0	0	0	276830	0	243670	19059056		
135938	2985	40213296	2005-10-29	2005-10-29 00:00:00	2005-10-29	2005-10-29 00:00:00	2005-10-29	581452		0	0	0		0	0	0	199234	0	52	40213296		
48420	4013	19019979	1978-12-17	1978-12-17 00:00:00	1978-12-31	1978-12-31 00:00:00	1978-12-31	38000177		0	0	14		0	0	0	266633	0	198405	19019979		
191170	4200	40213227	2019-06-26	2019-06-26 00:00:00	2019-06-26	2019-06-26 00:00:00	2019-06-26	581452		0	0	0		0	0	0	278799	0	113	40213227		
82892	1812	40213227	1993-07-05	1993-07-05 00:00:00	1993-07-05	1993-07-05 00:00:00	1993-07-05	581452		0	0	0		0	0	0	121284	0	113	40213227		
147392	3240	40213227	2017-10-25	2017-10-25 00:00:00	2017-10-25	2017-10-25 00:00:00	2017-10-25	581452		0	0	0		0	0	0	215386	0	113	40213227		
13574	1137	1539411	1991-09-20	1991-09-20 00:00:00	1991-09-20	1991-09-20 00:00:00	\N	38000177		0	0	0		0	0	0	74966	0	312961	1539411		
193447	4250	40213201	2012-02-25	2012-02-25 00:00:00	2012-02-25	2012-02-25 00:00:00	2012-02-25	581452		0	0	0		0	0	0	282240	0	33	40213201		
1659	36	40213160	1959-01-27	1959-01-27 00:00:00	1959-01-27	1959-01-27 00:00:00	1959-01-27	581452		0	0	0		0	0	0	2545	0	10	40213160		
5595	469	19059056	1937-04-04	1937-04-04 00:00:00	1937-04-18	1937-04-18 00:00:00	1937-04-18	38000177		0	0	14		0	0	0	31255	0	243670	19059056		
95674	2097	40213227	2008-04-12	2008-04-12 00:00:00	2008-04-12	2008-04-12 00:00:00	2008-04-12	581452		0	0	0		0	0	0	139759	0	113	40213227		
178768	3929	40213227	2004-01-05	2004-01-05 00:00:00	2004-01-05	2004-01-05 00:00:00	2004-01-05	581452		0	0	0		0	0	0	261183	0	113	40213227		
130415	2866	40213227	2017-08-13	2017-08-13 00:00:00	2017-08-13	2017-08-13 00:00:00	2017-08-13	581452		0	0	0		0	0	0	190694	0	113	40213227		
39251	3242	19133873	1989-07-03	1989-07-03 00:00:00	1989-07-14	1989-07-14 00:00:00	1989-07-14	38000177		0	0	11		0	0	0	215593	0	834061	19133873		
141797	3115	40213160	1971-09-24	1971-09-24 00:00:00	1971-09-24	1971-09-24 00:00:00	1971-09-24	581452		0	0	0		0	0	0	207232	0	10	40213160		
57867	4807	1127433	2005-02-22	2005-02-22 00:00:00	2005-03-08	2005-03-08 00:00:00	2005-03-08	38000177		0	0	14		0	0	0	319887	0	313782	1127433		
190714	4190	40213227	2014-08-10	2014-08-10 00:00:00	2014-08-10	2014-08-10 00:00:00	2014-08-10	581452		0	0	0		0	0	0	278093	0	113	40213227		
28049	2320	19133905	1997-01-19	1997-01-19 00:00:00	1997-02-01	1997-02-01 00:00:00	1997-02-01	38000177		0	0	13		0	0	0	154283	0	834102	19133905		
232302	5104	40213227	2011-10-23	2011-10-23 00:00:00	2011-10-23	2011-10-23 00:00:00	2011-10-23	581452		0	0	0		0	0	0	339176	0	113	40213227		
110282	2423	40213296	1996-10-28	1996-10-28 00:00:00	1996-10-28	1996-10-28 00:00:00	1996-10-28	581452		0	0	0		0	0	0	160781	0	52	40213296		
38637	3191	1127433	2016-07-03	2016-07-03 00:00:00	2016-07-17	2016-07-17 00:00:00	2016-07-17	38000177		0	0	14		0	0	0	212341	0	313782	1127433		
62630	5207	19059056	1960-05-19	1960-05-19 00:00:00	1960-08-17	1960-08-17 00:00:00	1960-08-17	38000177		0	0	90		0	0	0	346374	0	243670	19059056		
58028	4820	1115171	2002-08-08	2002-08-08 00:00:00	2002-08-22	2002-08-22 00:00:00	2002-08-22	38000177		0	0	14		0	0	0	320646	0	849574	1115171		
22333	484	40213227	1999-03-08	1999-03-08 00:00:00	1999-03-08	1999-03-08 00:00:00	1999-03-08	581452		0	0	0		0	0	0	32409	0	113	40213227		
62748	5215	46275916	1960-07-11	1960-07-11 00:00:00	1960-07-11	1960-07-11 00:00:00	1960-07-11	38000177		0	0	0		0	0	0	346837	0	1660014	46275916		
51218	1122	40213227	2012-01-02	2012-01-02 00:00:00	2012-01-02	2012-01-02 00:00:00	2012-01-02	581452		0	0	0		0	0	0	73919	0	113	40213227		
52008	1138	40213251	1985-01-10	1985-01-10 00:00:00	1985-01-10	1985-01-10 00:00:00	1985-01-10	581452		0	0	0		0	0	0	75004	0	21	40213251		
31702	691	40213296	2001-05-15	2001-05-15 00:00:00	2001-05-15	2001-05-15 00:00:00	2001-05-15	581452		0	0	0		0	0	0	45797	0	52	40213296		
90568	1987	40213227	2004-10-15	2004-10-15 00:00:00	2004-10-15	2004-10-15 00:00:00	2004-10-15	581452		0	0	0		0	0	0	132354	0	113	40213227		
31631	2622	19059056	1964-07-12	1964-07-12 00:00:00	1964-08-02	1964-08-02 00:00:00	1964-08-02	38000177		0	0	21		0	0	0	173408	0	243670	19059056		
33575	732	40213296	2012-04-19	2012-04-19 00:00:00	2012-04-19	2012-04-19 00:00:00	2012-04-19	581452		0	0	0		0	0	0	48594	0	52	40213296		
205701	4514	40213227	1997-07-25	1997-07-25 00:00:00	1997-07-25	1997-07-25 00:00:00	1997-07-25	581452		0	0	0		0	0	0	300648	0	113	40213227		
61090	5081	40229134	1964-11-04	1964-11-04 00:00:00	1964-11-18	1964-11-18 00:00:00	1964-11-18	38000177		0	0	14		0	0	0	337863	0	1043400	40229134		
38316	3170	1118084	1985-08-30	1985-08-30 00:00:00	1985-08-30	1985-08-30 00:00:00	\N	38000177		0	0	0		0	0	0	210763	0	00025152531	44923712		
135149	2966	40213260	2012-11-17	2012-11-17 00:00:00	2012-11-17	2012-11-17 00:00:00	2012-11-17	581452		0	0	0		0	0	0	198036	0	121	40213260		
52812	4388	1127078	1971-03-02	1971-03-02 00:00:00	1971-03-16	1971-03-16 00:00:00	1971-03-16	38000177		0	0	14		0	0	0	291636	0	282464	1127078		
49365	1081	40213296	2004-02-25	2004-02-25 00:00:00	2004-02-25	2004-02-25 00:00:00	2004-02-25	581452		0	0	0		0	0	0	70871	0	52	40213296		
32674	2708	40229134	1968-03-05	1968-03-05 00:00:00	1968-03-12	1968-03-12 00:00:00	1968-03-12	38000177		0	0	7		0	0	0	179417	0	1043400	40229134		
147001	3232	40213227	2014-09-22	2014-09-22 00:00:00	2014-09-22	2014-09-22 00:00:00	2014-09-22	581452		0	0	0		0	0	0	214814	0	113	40213227		
160714	3536	40213260	2015-04-30	2015-04-30 00:00:00	2015-04-30	2015-04-30 00:00:00	2015-04-30	581452		0	0	0		0	0	0	234872	0	121	40213260		
42958	3561	19133905	1983-03-14	1983-03-14 00:00:00	1983-03-26	1983-03-26 00:00:00	1983-03-26	38000177		0	0	12		0	0	0	236512	0	834102	19133905		
5145	430	40173590	2011-11-19	2011-11-19 00:00:00	2011-11-19	2011-11-19 00:00:00	\N	38000177		0	0	0		0	0	0	28547	0	904419	40173590		
51520	1128	40213306	1990-09-28	1990-09-28 00:00:00	1990-09-28	1990-09-28 00:00:00	1990-09-28	581452		0	0	0		0	0	0	74345	0	43	40213306		
4015	86	40213227	1999-02-08	1999-02-08 00:00:00	1999-02-08	1999-02-08 00:00:00	1999-02-08	581452		0	0	0		0	0	0	5822	0	113	40213227		
89638	1966	40213306	1983-11-15	1983-11-15 00:00:00	1983-11-15	1983-11-15 00:00:00	1983-11-15	581452		0	0	0		0	0	0	130732	0	43	40213306		
79411	1738	40213160	1973-05-13	1973-05-13 00:00:00	1973-05-13	1973-05-13 00:00:00	1973-05-13	581452		0	0	0		0	0	0	116120	0	10	40213160		
164879	3625	40213160	1958-06-24	1958-06-24 00:00:00	1958-06-24	1958-06-24 00:00:00	1958-06-24	581452		0	0	0		0	0	0	241068	0	10	40213160		
45236	3744	1127433	2009-10-27	2009-10-27 00:00:00	2009-11-03	2009-11-03 00:00:00	2009-11-03	38000177		0	0	7		0	0	0	248815	0	313782	1127433		
45286	3748	19073183	1983-02-20	1983-02-20 00:00:00	1983-03-06	1983-03-06 00:00:00	1983-03-06	38000177		0	0	14		0	0	0	249101	0	308182	19073183		
55429	4603	1127433	1931-02-14	1931-02-14 00:00:00	1931-02-21	1931-02-21 00:00:00	1931-02-21	38000177		0	0	7		0	0	0	306626	0	313782	1127433		
16812	1390	1127433	1980-03-07	1980-03-07 00:00:00	1980-04-04	1980-04-04 00:00:00	1980-04-04	38000177		0	0	28		0	0	0	92248	0	313782	1127433		
55651	4621	1127078	1978-04-17	1978-04-17 00:00:00	1978-05-01	1978-05-01 00:00:00	1978-05-01	38000177		0	0	14		0	0	0	307741	0	282464	1127078		
28310	2337	40229134	2004-07-08	2004-07-08 00:00:00	2004-07-15	2004-07-15 00:00:00	2004-07-15	38000177		0	0	7		0	0	0	155473	0	1043400	40229134		
28329	2337	19133873	1963-11-17	1963-11-17 00:00:00	1963-11-24	1963-11-24 00:00:00	1963-11-24	38000177		0	0	7		0	0	0	155535	0	834061	19133873		
30133	2498	1332419	2006-04-08	2006-04-08 00:00:00	2006-04-08	2006-04-08 00:00:00	\N	38000177		0	0	0		0	0	0	165420	0	197361	1332419		
21531	1769	40229134	2012-08-11	2012-08-11 00:00:00	2012-08-18	2012-08-18 00:00:00	2012-08-18	38000177		0	0	7		0	0	0	118302	0	1043400	40229134		
39059	3227	1127078	1974-11-26	1974-11-26 00:00:00	1974-12-10	1974-12-10 00:00:00	1974-12-10	38000177		0	0	14		0	0	0	214532	0	282464	1127078		
38973	3221	1127078	1966-03-17	1966-03-17 00:00:00	1966-04-16	1966-04-16 00:00:00	1966-04-16	38000177		0	0	30		0	0	0	214130	0	282464	1127078		
58221	4837	19006318	1952-02-17	1952-02-17 00:00:00	1952-03-02	1952-03-02 00:00:00	1952-03-02	38000177		0	0	14		0	0	0	321862	0	105078	19006318		
3594	297	40236824	1995-07-02	1995-07-02 00:00:00	1995-07-09	1995-07-09 00:00:00	1995-07-09	38000177		0	0	7		0	0	0	19770	0	1094107	40236824		
49581	4113	1127433	1972-02-04	1972-02-04 00:00:00	1972-02-18	1972-02-18 00:00:00	1972-02-18	38000177		0	0	14		0	0	0	273427	0	313782	1127433		
174805	3844	40213160	1956-02-03	1956-02-03 00:00:00	1956-02-03	1956-02-03 00:00:00	1956-02-03	581452		0	0	0		0	0	0	255139	0	10	40213160		
39654	3279	1127433	2010-02-06	2010-02-06 00:00:00	2010-02-20	2010-02-20 00:00:00	2010-02-20	38000177		0	0	14		0	0	0	217816	0	313782	1127433		
195546	4295	40213227	2002-10-30	2002-10-30 00:00:00	2002-10-30	2002-10-30 00:00:00	2002-10-30	581452		0	0	0		0	0	0	285095	0	113	40213227		
50205	4165	1127433	1992-02-08	1992-02-08 00:00:00	1992-02-15	1992-02-15 00:00:00	1992-02-15	38000177		0	0	7		0	0	0	276722	0	313782	1127433		
195622	4297	40213314	1977-12-17	1977-12-17 00:00:00	1977-12-17	1977-12-17 00:00:00	1977-12-17	581452		0	0	0		0	0	0	285169	0	49	40213314		
48421	4013	19128065	1988-11-13	1988-11-13 00:00:00	1989-11-08	1989-11-08 00:00:00	1989-11-08	38000177		0	0	360		0	0	0	266670	0	749882	19128065		
202477	4446	40213260	2010-06-29	2010-06-29 00:00:00	2010-06-29	2010-06-29 00:00:00	2010-06-29	581452		0	0	0		0	0	0	295645	0	121	40213260		
82895	1812	40213260	2011-10-03	2011-10-03 00:00:00	2011-10-03	2011-10-03 00:00:00	2011-10-03	581452		0	0	0		0	0	0	121280	0	121	40213260		
186906	4105	40213227	2019-04-27	2019-04-27 00:00:00	2019-04-27	2019-04-27 00:00:00	2019-04-27	581452		0	0	0		0	0	0	272729	0	113	40213227		
13575	1137	1118084	1991-10-24	1991-10-24 00:00:00	1991-10-24	1991-10-24 00:00:00	\N	38000177		0	0	0		0	0	0	74966	0	00025152531	44923712		
193454	4250	40213198	2011-02-19	2011-02-19 00:00:00	2011-02-19	2011-02-19 00:00:00	2011-02-19	581452		0	0	0		0	0	0	282271	0	133	40213198		
1664	36	40213296	1998-10-27	1998-10-27 00:00:00	1998-10-27	1998-10-27 00:00:00	1998-10-27	581452		0	0	0		0	0	0	2595	0	52	40213296		
5596	469	19059056	1937-06-07	1937-06-07 00:00:00	1937-06-21	1937-06-21 00:00:00	1937-06-21	38000177		0	0	14		0	0	0	31256	0	243670	19059056		
95675	2097	40213314	1977-08-13	1977-08-13 00:00:00	1977-08-13	1977-08-13 00:00:00	1977-08-13	581452		0	0	0		0	0	0	139766	0	49	40213314		
178996	3936	40213227	2019-05-13	2019-05-13 00:00:00	2019-05-13	2019-05-13 00:00:00	2019-05-13	581452		0	0	0		0	0	0	261583	0	113	40213227		
130422	2866	40213160	1971-07-18	1971-07-18 00:00:00	1971-07-18	1971-07-18 00:00:00	1971-07-18	581452		0	0	0		0	0	0	190632	0	10	40213160		
39252	3242	1713671	2013-07-08	2013-07-08 00:00:00	2013-07-22	2013-07-22 00:00:00	2013-07-22	38000177		0	0	14		0	0	0	215622	0	562251	1713671		
141799	3115	40213227	2009-01-30	2009-01-30 00:00:00	2009-01-30	2009-01-30 00:00:00	2009-01-30	581452		0	0	0		0	0	0	207270	0	113	40213227		
57870	4807	1118084	1981-03-10	1981-03-10 00:00:00	1981-03-10	1981-03-10 00:00:00	\N	38000177		0	0	0		0	0	0	319833	0	00025152531	44923712		
190720	4190	40213160	1977-07-10	1977-07-10 00:00:00	1977-07-10	1977-07-10 00:00:00	1977-07-10	581452		0	0	0		0	0	0	278103	0	10	40213160		
28050	2320	1713671	1962-08-10	1962-08-10 00:00:00	1962-08-24	1962-08-24 00:00:00	1962-08-24	38000177		0	0	14		0	0	0	154292	0	562251	1713671		
232127	5101	40213160	1957-09-07	1957-09-07 00:00:00	1957-09-07	1957-09-07 00:00:00	1957-09-07	581452		0	0	0		0	0	0	338954	0	10	40213160		
110283	2423	40213160	1957-07-01	1957-07-01 00:00:00	1957-07-01	1957-07-01 00:00:00	1957-07-01	581452		0	0	0		0	0	0	160743	0	10	40213160		
38638	3191	1713671	1995-04-30	1995-04-30 00:00:00	1995-05-14	1995-05-14 00:00:00	1995-05-14	38000177		0	0	14		0	0	0	212375	0	562251	1713671		
62631	5207	1127433	2017-02-06	2017-02-06 00:00:00	2017-02-20	2017-02-20 00:00:00	2017-02-20	38000177		0	0	14		0	0	0	346366	0	313782	1127433		
58029	4820	19133873	1961-05-30	1961-05-30 00:00:00	1961-06-06	1961-06-06 00:00:00	1961-06-06	38000177		0	0	7		0	0	0	320640	0	834061	19133873		
174370	3834	40213227	1997-07-27	1997-07-27 00:00:00	1997-07-27	1997-07-27 00:00:00	1997-07-27	581452		0	0	0		0	0	0	254597	0	113	40213227		
5555	120	40213314	1978-04-15	1978-04-15 00:00:00	1978-04-15	1978-04-15 00:00:00	1978-04-15	581452		0	0	0		0	0	0	7956	0	49	40213314		
51224	1122	40213227	1992-06-01	1992-06-01 00:00:00	1992-06-01	1992-06-01 00:00:00	1992-06-01	581452		0	0	0		0	0	0	\N	0	113	40213227		
52011	1138	40213160	1985-01-10	1985-01-10 00:00:00	1985-01-10	1985-01-10 00:00:00	1985-01-10	581452		0	0	0		0	0	0	75004	0	10	40213160		
31710	691	40213227	2019-04-09	2019-04-09 00:00:00	2019-04-09	2019-04-09 00:00:00	2019-04-09	581452		0	0	0		0	0	0	45817	0	113	40213227		
101854	2233	40213296	2012-02-07	2012-02-07 00:00:00	2012-02-07	2012-02-07 00:00:00	2012-02-07	581452		0	0	0		0	0	0	148574	0	52	40213296		
31632	2622	19133873	1942-12-17	1942-12-17 00:00:00	1942-12-27	1942-12-27 00:00:00	1942-12-27	38000177		0	0	10		0	0	0	173488	0	834061	19133873		
33581	733	40213227	2003-06-05	2003-06-05 00:00:00	2003-06-05	2003-06-05 00:00:00	2003-06-05	581452		0	0	0		0	0	0	48625	0	113	40213227		
205702	4514	40213306	1997-07-25	1997-07-25 00:00:00	1997-07-25	1997-07-25 00:00:00	1997-07-25	581452		0	0	0		0	0	0	300648	0	43	40213306		
61091	5081	19059056	1919-11-05	1919-11-05 00:00:00	1919-12-10	1919-12-10 00:00:00	1919-12-10	38000177		0	0	35		0	0	0	337897	0	243670	19059056		
38317	3170	40229134	1968-02-22	1968-02-22 00:00:00	1968-03-07	1968-03-07 00:00:00	1968-03-07	38000177		0	0	14		0	0	0	210732	0	1043400	40229134		
135154	2966	40213306	1984-01-14	1984-01-14 00:00:00	1984-01-14	1984-01-14 00:00:00	1984-01-14	581452		0	0	0		0	0	0	198073	0	43	40213306		
52813	4388	19133873	1975-02-28	1975-02-28 00:00:00	1975-03-10	1975-03-10 00:00:00	1975-03-10	38000177		0	0	10		0	0	0	291690	0	834061	19133873		
49372	1081	40213296	2002-02-20	2002-02-20 00:00:00	2002-02-20	2002-02-20 00:00:00	2002-02-20	581452		0	0	0		0	0	0	70898	0	52	40213296		
32675	2708	1713671	2009-11-21	2009-11-21 00:00:00	2009-12-05	2009-12-05 00:00:00	2009-12-05	38000177		0	0	14		0	0	0	179390	0	562251	1713671		
147005	3232	40213227	2005-09-26	2005-09-26 00:00:00	2005-09-26	2005-09-26 00:00:00	2005-09-26	581452		0	0	0		0	0	0	214813	0	113	40213227		
160715	3536	40213306	1986-02-13	1986-02-13 00:00:00	1986-02-13	1986-02-13 00:00:00	1986-02-13	581452		0	0	0		0	0	0	234811	0	43	40213306		
42959	3561	1118084	1943-11-09	1943-11-09 00:00:00	1943-11-09	1943-11-09 00:00:00	\N	38000177		0	0	0		0	0	0	236507	0	00025152531	44923712		
5146	430	1124300	1972-10-27	1972-10-27 00:00:00	1972-10-27	1972-10-27 00:00:00	\N	38000177		0	0	0		0	0	0	28433	0	00781178901	45011828		
51521	1128	40213160	1968-11-01	1968-11-01 00:00:00	1968-11-01	1968-11-01 00:00:00	1968-11-01	581452		0	0	0		0	0	0	74311	0	10	40213160		
4019	86	40213201	2014-05-06	2014-05-06 00:00:00	2014-05-06	2014-05-06 00:00:00	2014-05-06	581452		0	0	0		0	0	0	5824	0	33	40213201		
143337	3149	40213227	2002-02-25	2002-02-25 00:00:00	2002-02-25	2002-02-25 00:00:00	2002-02-25	581452		0	0	0		0	0	0	209519	0	113	40213227		
170173	3742	40213306	1993-09-24	1993-09-24 00:00:00	1993-09-24	1993-09-24 00:00:00	1993-09-24	581452		0	0	0		0	0	0	248662	0	43	40213306		
164884	3625	40213160	1955-12-20	1955-12-20 00:00:00	1955-12-20	1955-12-20 00:00:00	1955-12-20	581452		0	0	0		0	0	0	241046	0	10	40213160		
45237	3744	1127433	1994-12-17	1994-12-17 00:00:00	1995-02-22	1995-02-22 00:00:00	1995-02-22	38000177		0	0	67		0	0	0	248852	0	313782	1127433		
45287	3748	19133873	1992-10-22	1992-10-22 00:00:00	1992-11-01	1992-11-01 00:00:00	1992-11-01	38000177		0	0	10		0	0	0	249098	0	834061	19133873		
55430	4603	1127433	2018-01-18	2018-01-18 00:00:00	2018-03-19	2018-03-19 00:00:00	2018-03-19	38000177		0	0	60		0	0	0	306625	0	313782	1127433		
16813	1390	19133873	1981-04-22	1981-04-22 00:00:00	1981-05-05	1981-05-05 00:00:00	1981-05-05	38000177		0	0	13		0	0	0	92290	0	834061	19133873		
55652	4621	1127433	2006-06-22	2006-06-22 00:00:00	2006-07-06	2006-07-06 00:00:00	2006-07-06	38000177		0	0	14		0	0	0	307745	0	313782	1127433		
28312	2337	1115171	1999-12-23	1999-12-23 00:00:00	2000-01-06	2000-01-06 00:00:00	2000-01-06	38000177		0	0	14		0	0	0	155540	0	849574	1115171		
28330	2337	1127433	2011-02-28	2011-02-28 00:00:00	2011-03-14	2011-03-14 00:00:00	2011-03-14	38000177		0	0	14		0	0	0	155542	0	313782	1127433		
30134	2498	1539411	2006-04-08	2006-04-08 00:00:00	2006-04-08	2006-04-08 00:00:00	\N	38000177		0	0	0		0	0	0	165420	0	312961	1539411		
21532	1769	40229134	2007-12-21	2007-12-21 00:00:00	2008-01-04	2008-01-04 00:00:00	2008-01-04	38000177		0	0	14		0	0	0	118296	0	1043400	40229134		
39065	3229	1127433	2003-12-29	2003-12-29 00:00:00	2004-01-19	2004-01-19 00:00:00	2004-01-19	38000177		0	0	21		0	0	0	214638	0	313782	1127433		
38974	3221	19059056	1967-01-30	1967-01-30 00:00:00	1967-02-13	1967-02-13 00:00:00	1967-02-13	38000177		0	0	14		0	0	0	214113	0	243670	19059056		
58222	4837	19112599	1952-01-11	1952-01-11 00:00:00	1952-01-11	1952-01-11 00:00:00	\N	38000177		0	0	0		0	0	0	321819	0	477045	19112599		
3595	297	920300	1995-07-02	1995-07-02 00:00:00	1995-07-09	1995-07-09 00:00:00	1995-07-09	38000177		0	0	7		0	0	0	19770	0	311989	920300		
49582	4113	19133905	1984-05-05	1984-05-05 00:00:00	1984-05-13	1984-05-13 00:00:00	1984-05-13	38000177		0	0	8		0	0	0	273458	0	834102	19133905		
174814	3844	40213296	1996-09-13	1996-09-13 00:00:00	1996-09-13	1996-09-13 00:00:00	1996-09-13	581452		0	0	0		0	0	0	255171	0	52	40213296		
39655	3279	1127433	2010-07-28	2010-07-28 00:00:00	2010-08-04	2010-08-04 00:00:00	2010-08-04	38000177		0	0	7		0	0	0	217924	0	313782	1127433		
195547	4295	40213296	2011-09-28	2011-09-28 00:00:00	2011-09-28	2011-09-28 00:00:00	2011-09-28	581452		0	0	0		0	0	0	285098	0	52	40213296		
50212	4167	1127433	2016-01-12	2016-01-12 00:00:00	2016-01-19	2016-01-19 00:00:00	2016-01-19	38000177		0	0	7		0	0	0	276926	0	313782	1127433		
195626	4297	40213160	1973-09-15	1973-09-15 00:00:00	1973-09-15	1973-09-15 00:00:00	1973-09-15	581452		0	0	0		0	0	0	285204	0	10	40213160		
48422	4013	1118084	2015-04-26	2015-04-26 00:00:00	2015-04-26	2015-04-26 00:00:00	\N	38000177		0	0	0		0	0	0	266663	0	00025152531	44923712		
135987	2986	40213227	2006-02-21	2006-02-21 00:00:00	2006-02-21	2006-02-21 00:00:00	2006-02-21	581452		0	0	0		0	0	0	199295	0	113	40213227		
82897	1812	40213227	2011-10-03	2011-10-03 00:00:00	2011-10-03	2011-10-03 00:00:00	2011-10-03	581452		0	0	0		0	0	0	121280	0	113	40213227		
186911	4106	40213227	1995-06-30	1995-06-30 00:00:00	1995-06-30	1995-06-30 00:00:00	1995-06-30	581452		0	0	0		0	0	0	272791	0	113	40213227		
13576	1137	1127433	1956-11-18	1956-11-18 00:00:00	1956-11-25	1956-11-25 00:00:00	1956-11-25	38000177		0	0	7		0	0	0	74903	0	313782	1127433		
193457	4250	40213227	2016-03-19	2016-03-19 00:00:00	2016-03-19	2016-03-19 00:00:00	2016-03-19	581452		0	0	0		0	0	0	282322	0	113	40213227		
238783	5241	40213160	1962-12-04	1962-12-04 00:00:00	1962-12-04	1962-12-04 00:00:00	1962-12-04	581452		0	0	0		0	0	0	348775	0	10	40213160		
5597	469	1127433	1969-07-04	1969-07-04 00:00:00	1969-07-18	1969-07-18 00:00:00	1969-07-18	38000177		0	0	14		0	0	0	31364	0	313782	1127433		
95676	2097	40213160	1977-08-13	1977-08-13 00:00:00	1977-08-13	1977-08-13 00:00:00	1977-08-13	581452		0	0	0		0	0	0	139766	0	10	40213160		
178999	3936	40213160	1958-06-16	1958-06-16 00:00:00	1958-06-16	1958-06-16 00:00:00	1958-06-16	581452		0	0	0		0	0	0	261625	0	10	40213160		
130424	2866	40213227	1998-04-26	1998-04-26 00:00:00	1998-04-26	1998-04-26 00:00:00	1998-04-26	581452		0	0	0		0	0	0	190675	0	113	40213227		
39253	3242	1127433	1982-01-09	1982-01-09 00:00:00	1982-01-16	1982-01-16 00:00:00	1982-01-16	38000177		0	0	7		0	0	0	215616	0	313782	1127433		
141800	3115	40213296	2009-01-30	2009-01-30 00:00:00	2009-01-30	2009-01-30 00:00:00	2009-01-30	581452		0	0	0		0	0	0	207270	0	52	40213296		
57896	4811	1713671	2007-10-10	2007-10-10 00:00:00	2007-10-17	2007-10-17 00:00:00	2007-10-17	38000177		0	0	7		0	0	0	320067	0	562251	1713671		
190721	4190	40213314	1977-07-10	1977-07-10 00:00:00	1977-07-10	1977-07-10 00:00:00	1977-07-10	581452		0	0	0		0	0	0	278103	0	49	40213314		
38519	3181	19059056	1964-11-04	1964-11-04 00:00:00	1964-11-25	1964-11-25 00:00:00	1964-11-25	38000177		0	0	21		0	0	0	211654	0	243670	19059056		
232132	5101	40213260	2007-01-27	2007-01-27 00:00:00	2007-01-27	2007-01-27 00:00:00	2007-01-27	581452		0	0	0		0	0	0	339018	0	121	40213260		
110287	2423	40213160	1957-01-28	1957-01-28 00:00:00	1957-01-28	1957-01-28 00:00:00	1957-01-28	581452		0	0	0		0	0	0	160724	0	10	40213160		
38639	3191	1713671	1999-12-16	1999-12-16 00:00:00	1999-12-30	1999-12-30 00:00:00	1999-12-30	38000177		0	0	14		0	0	0	212347	0	562251	1713671		
62632	5207	19128065	1978-11-21	1978-11-21 00:00:00	1979-11-16	1979-11-16 00:00:00	1979-11-16	38000177		0	0	360		0	0	0	346383	0	749882	19128065		
58030	4820	1115171	2016-10-07	2016-10-07 00:00:00	2016-11-11	2016-11-11 00:00:00	2016-11-11	38000177		0	0	35		0	0	0	320617	0	849574	1115171		
174371	3834	40213296	1997-07-27	1997-07-27 00:00:00	1997-07-27	1997-07-27 00:00:00	1997-07-27	581452		0	0	0		0	0	0	254597	0	52	40213296		
5556	120	40213160	1978-04-15	1978-04-15 00:00:00	1978-04-15	1978-04-15 00:00:00	1978-04-15	581452		0	0	0		0	0	0	7956	0	10	40213160		
51225	1122	40213306	1992-06-01	1992-06-01 00:00:00	1992-06-01	1992-06-01 00:00:00	1992-06-01	581452		0	0	0		0	0	0	\N	0	43	40213306		
52015	1138	40213160	1980-05-08	1980-05-08 00:00:00	1980-05-08	1980-05-08 00:00:00	1980-05-08	581452		0	0	0		0	0	0	75137	0	10	40213160		
122109	2684	40213227	2002-05-19	2002-05-19 00:00:00	2002-05-19	2002-05-19 00:00:00	2002-05-19	581452		0	0	0		0	0	0	177840	0	113	40213227		
101856	2233	40213314	1977-01-11	1977-01-11 00:00:00	1977-01-11	1977-01-11 00:00:00	1977-01-11	581452		0	0	0		0	0	0	148570	0	49	40213314		
31633	2622	920300	1976-01-07	1976-01-07 00:00:00	1976-01-14	1976-01-14 00:00:00	1976-01-14	38000177		0	0	7		0	0	0	173439	0	311989	920300		
33589	733	40213198	2010-07-15	2010-07-15 00:00:00	2010-07-15	2010-07-15 00:00:00	2010-07-15	581452		0	0	0		0	0	0	48684	0	133	40213198		
205703	4514	40213296	2016-07-08	2016-07-08 00:00:00	2016-07-08	2016-07-08 00:00:00	2016-07-08	581452		0	0	0		0	0	0	300621	0	52	40213296		
61092	5081	19133905	1974-04-27	1974-04-27 00:00:00	1974-05-08	1974-05-08 00:00:00	1974-05-08	38000177		0	0	11		0	0	0	337911	0	834102	19133905		
38318	3170	1127433	1967-10-08	1967-10-08 00:00:00	1967-11-12	1967-11-12 00:00:00	1967-11-12	38000177		0	0	35		0	0	0	210714	0	313782	1127433		
135157	2966	40213260	2011-11-12	2011-11-12 00:00:00	2011-11-12	2011-11-12 00:00:00	2011-11-12	581452		0	0	0		0	0	0	198122	0	121	40213260		
52814	4388	1115171	1996-10-21	1996-10-21 00:00:00	1996-12-27	1996-12-27 00:00:00	1996-12-27	38000177		0	0	67		0	0	0	291643	0	849574	1115171		
49376	1081	40213227	1994-02-09	1994-02-09 00:00:00	1994-02-09	1994-02-09 00:00:00	1994-02-09	581452		0	0	0		0	0	0	70893	0	113	40213227		
32676	2708	40229134	1965-09-29	1965-09-29 00:00:00	1965-10-06	1965-10-06 00:00:00	1965-10-06	38000177		0	0	7		0	0	0	179360	0	1043400	40229134		
147006	3232	40213296	2005-09-26	2005-09-26 00:00:00	2005-09-26	2005-09-26 00:00:00	2005-09-26	581452		0	0	0		0	0	0	214813	0	52	40213296		
160719	3536	40213296	2003-11-13	2003-11-13 00:00:00	2003-11-13	2003-11-13 00:00:00	2003-11-13	581452		0	0	0		0	0	0	234865	0	52	40213296		
42960	3561	1127433	1967-04-02	1967-04-02 00:00:00	1967-05-02	1967-05-02 00:00:00	1967-05-02	38000177		0	0	30		0	0	0	236472	0	313782	1127433		
15616	1303	1127433	1977-02-18	1977-02-18 00:00:00	1977-02-25	1977-02-25 00:00:00	1977-02-25	38000177		0	0	7		0	0	0	86061	0	313782	1127433		
15640	1305	19059056	1964-12-06	1964-12-06 00:00:00	1964-12-20	1964-12-20 00:00:00	1964-12-20	38000177		0	0	14		0	0	0	86140	0	243670	19059056		
6491	141	40213251	1985-05-07	1985-05-07 00:00:00	1985-05-07	1985-05-07 00:00:00	1985-05-07	581452		0	0	0		0	0	0	9457	0	21	40213251		
143344	3149	40213227	1992-06-01	1992-06-01 00:00:00	1992-06-01	1992-06-01 00:00:00	1992-06-01	581452		0	0	0		0	0	0	209554	0	113	40213227		
170175	3742	40213227	2013-04-26	2013-04-26 00:00:00	2013-04-26	2013-04-26 00:00:00	2013-04-26	581452		0	0	0		0	0	0	248678	0	113	40213227		
164894	3625	40213227	1995-09-26	1995-09-26 00:00:00	1995-09-26	1995-09-26 00:00:00	1995-09-26	581452		0	0	0		0	0	0	241054	0	113	40213227		
45238	3744	1127433	1971-06-23	1971-06-23 00:00:00	1971-06-30	1971-06-30 00:00:00	1971-06-30	38000177		0	0	7		0	0	0	248790	0	313782	1127433		
45288	3748	1127433	2015-12-28	2015-12-28 00:00:00	2016-01-11	2016-01-11 00:00:00	2016-01-11	38000177		0	0	14		0	0	0	249097	0	313782	1127433		
55431	4603	1118084	1970-01-24	1970-01-24 00:00:00	1970-01-24	1970-01-24 00:00:00	\N	38000177		0	0	0		0	0	0	306620	0	00025152531	44923712		
16814	1390	1115171	2007-05-13	2007-05-13 00:00:00	2007-05-27	2007-05-27 00:00:00	2007-05-27	38000177		0	0	14		0	0	0	92250	0	849574	1115171		
55653	4621	46233988	1980-10-22	1980-10-22 00:00:00	1980-11-05	1980-11-05 00:00:00	1980-11-05	38000177		0	0	14		0	0	0	307774	0	1652673	46233988		
28313	2337	1127433	1978-01-28	1978-01-28 00:00:00	1978-02-25	1978-02-25 00:00:00	1978-02-25	38000177		0	0	28		0	0	0	155490	0	313782	1127433		
28341	2339	1127433	1995-01-24	1995-01-24 00:00:00	1995-02-14	1995-02-14 00:00:00	1995-02-14	38000177		0	0	21		0	0	0	155617	0	313782	1127433		
30135	2498	1124300	2007-11-18	2007-11-18 00:00:00	2007-11-18	2007-11-18 00:00:00	\N	38000177		0	0	0		0	0	0	165420	0	00781178901	45011828		
21533	1769	1713671	1982-10-30	1982-10-30 00:00:00	1982-11-13	1982-11-13 00:00:00	1982-11-13	38000177		0	0	14		0	0	0	118285	0	562251	1713671		
39066	3229	1115171	2014-11-22	2014-11-22 00:00:00	2014-12-13	2014-12-13 00:00:00	2014-12-13	38000177		0	0	21		0	0	0	214641	0	849574	1115171		
38975	3221	19006318	1967-01-30	1967-01-30 00:00:00	1967-02-13	1967-02-13 00:00:00	1967-02-13	38000177		0	0	14		0	0	0	214113	0	105078	19006318		
58223	4837	1127433	1964-02-15	1964-02-15 00:00:00	1964-02-29	1964-02-29 00:00:00	1964-02-29	38000177		0	0	14		0	0	0	321817	0	313782	1127433		
3596	297	1713671	2000-08-04	2000-08-04 00:00:00	2000-08-18	2000-08-18 00:00:00	2000-08-18	38000177		0	0	14		0	0	0	19772	0	562251	1713671		
49583	4113	19078461	1990-04-10	1990-04-10 00:00:00	1990-04-24	1990-04-24 00:00:00	1990-04-24	38000177		0	0	14		0	0	0	273387	0	310965	19078461		
174815	3844	40213160	1955-02-04	1955-02-04 00:00:00	1955-02-04	1955-02-04 00:00:00	1955-02-04	581452		0	0	0		0	0	0	255190	0	10	40213160		
39656	3279	19078461	1995-03-27	1995-03-27 00:00:00	1995-06-25	1995-06-25 00:00:00	1995-06-25	38000177		0	0	90		0	0	0	217921	0	310965	19078461		
195549	4295	40213160	1972-03-01	1972-03-01 00:00:00	1972-03-01	1972-03-01 00:00:00	1972-03-01	581452		0	0	0		0	0	0	285082	0	10	40213160		
50213	4167	19133873	1983-10-24	1983-10-24 00:00:00	1983-11-02	1983-11-02 00:00:00	1983-11-02	38000177		0	0	9		0	0	0	276908	0	834061	19133873		
195630	4297	40213160	1973-06-16	1973-06-16 00:00:00	1973-06-16	1973-06-16 00:00:00	1973-06-16	581452		0	0	0		0	0	0	285161	0	10	40213160		
48423	4013	40229134	1988-01-10	1988-01-10 00:00:00	1988-01-24	1988-01-24 00:00:00	1988-01-24	38000177		0	0	14		0	0	0	266667	0	1043400	40229134		
135996	2986	40213198	2010-03-16	2010-03-16 00:00:00	2010-03-16	2010-03-16 00:00:00	2010-03-16	581452		0	0	0		0	0	0	199316	0	133	40213198		
82905	1812	40213260	2010-09-27	2010-09-27 00:00:00	2010-09-27	2010-09-27 00:00:00	2010-09-27	581452		0	0	0		0	0	0	121291	0	121	40213260		
186940	4106	40213227	2005-08-26	2005-08-26 00:00:00	2005-08-26	2005-08-26 00:00:00	2005-08-26	581452		0	0	0		0	0	0	272807	0	113	40213227		
13577	1137	19128065	1974-07-25	1974-07-25 00:00:00	1975-07-20	1975-07-20 00:00:00	1975-07-20	38000177		0	0	360		0	0	0	74944	0	749882	19128065		
68994	1510	40213227	2000-11-12	2000-11-12 00:00:00	2000-11-12	2000-11-12 00:00:00	2000-11-12	581452		0	0	0		0	0	0	100824	0	113	40213227		
36159	789	40213227	2014-07-07	2014-07-07 00:00:00	2014-07-07	2014-07-07 00:00:00	2014-07-07	581452		0	0	0		0	0	0	52474	0	113	40213227		
5598	469	1127433	2004-10-20	2004-10-20 00:00:00	2004-10-27	2004-10-27 00:00:00	2004-10-27	38000177		0	0	7		0	0	0	31328	0	313782	1127433		
95678	2097	40213314	1978-05-13	1978-05-13 00:00:00	1978-05-13	1978-05-13 00:00:00	1978-05-13	581452		0	0	0		0	0	0	139821	0	49	40213314		
166752	3666	40213227	1994-09-01	1994-09-01 00:00:00	1994-09-01	1994-09-01 00:00:00	1994-09-01	581452		0	0	0		0	0	0	243889	0	113	40213227		
130431	2866	40213160	1967-04-16	1967-04-16 00:00:00	1967-04-16	1967-04-16 00:00:00	1967-04-16	581452		0	0	0		0	0	0	190657	0	10	40213160		
39254	3242	1127433	1988-04-24	1988-04-24 00:00:00	1988-05-08	1988-05-08 00:00:00	1988-05-08	38000177		0	0	14		0	0	0	215618	0	313782	1127433		
141803	3115	40213296	2007-01-26	2007-01-26 00:00:00	2007-01-26	2007-01-26 00:00:00	2007-01-26	581452		0	0	0		0	0	0	207273	0	52	40213296		
57897	4811	1713671	2012-07-01	2012-07-01 00:00:00	2012-07-08	2012-07-08 00:00:00	2012-07-08	38000177		0	0	7		0	0	0	320019	0	562251	1713671		
190726	4190	40213160	1973-04-08	1973-04-08 00:00:00	1973-04-08	1973-04-08 00:00:00	1973-04-08	581452		0	0	0		0	0	0	278083	0	10	40213160		
38520	3181	40169216	1953-09-20	1953-09-20 00:00:00	1953-09-20	1953-09-20 00:00:00	\N	38000177		0	0	0		0	0	0	211630	0	895994	40169216		
232145	5101	40213160	1957-04-06	1957-04-06 00:00:00	1957-04-06	1957-04-06 00:00:00	1957-04-06	581452		0	0	0		0	0	0	338968	0	10	40213160		
110290	2423	40213227	2017-12-25	2017-12-25 00:00:00	2017-12-25	2017-12-25 00:00:00	2017-12-25	581452		0	0	0		0	0	0	160779	0	113	40213227		
38640	3191	1713671	2017-10-26	2017-10-26 00:00:00	2017-11-16	2017-11-16 00:00:00	2017-11-16	38000177		0	0	21		0	0	0	212362	0	562251	1713671		
62633	5207	40236824	1980-02-20	1980-02-20 00:00:00	1980-03-05	1980-03-05 00:00:00	1980-03-05	38000177		0	0	14		0	0	0	346347	0	1094107	40236824		
39839	869	40213201	1983-02-18	1983-02-18 00:00:00	1983-02-18	1983-02-18 00:00:00	1983-02-18	581452		0	0	0		0	0	0	57699	0	33	40213201		
174376	3834	40213160	1956-03-25	1956-03-25 00:00:00	1956-03-25	1956-03-25 00:00:00	1956-03-25	581452		0	0	0		0	0	0	254569	0	10	40213160		
5558	120	40213251	1984-06-23	1984-06-23 00:00:00	1984-06-23	1984-06-23 00:00:00	1984-06-23	581452		0	0	0		0	0	0	7987	0	21	40213251		
51228	1122	40213160	1974-07-22	1974-07-22 00:00:00	1974-07-22	1974-07-22 00:00:00	1974-07-22	581452		0	0	0		0	0	0	73962	0	10	40213160		
52016	1138	40213314	1980-05-08	1980-05-08 00:00:00	1980-05-08	1980-05-08 00:00:00	1980-05-08	581452		0	0	0		0	0	0	75137	0	49	40213314		
122110	2684	40213296	2002-05-19	2002-05-19 00:00:00	2002-05-19	2002-05-19 00:00:00	2002-05-19	581452		0	0	0		0	0	0	177840	0	52	40213296		
101859	2233	40213160	1977-01-11	1977-01-11 00:00:00	1977-01-11	1977-01-11 00:00:00	1977-01-11	581452		0	0	0		0	0	0	148570	0	10	40213160		
31634	2622	40236824	1976-01-07	1976-01-07 00:00:00	1976-01-14	1976-01-14 00:00:00	1976-01-14	38000177		0	0	7		0	0	0	173439	0	1094107	40236824		
33597	733	40213201	2008-07-03	2008-07-03 00:00:00	2008-07-03	2008-07-03 00:00:00	2008-07-03	581452		0	0	0		0	0	0	48683	0	33	40213201		
205705	4514	40213227	2016-07-08	2016-07-08 00:00:00	2016-07-08	2016-07-08 00:00:00	2016-07-08	581452		0	0	0		0	0	0	300621	0	113	40213227		
61093	5081	1124300	1955-02-14	1955-02-14 00:00:00	1955-02-14	1955-02-14 00:00:00	\N	38000177		0	0	0		0	0	0	337846	0	00781178901	45011828		
38343	3172	1127433	1999-01-09	1999-01-09 00:00:00	1999-02-15	1999-02-15 00:00:00	1999-02-15	38000177		0	0	37		0	0	0	210821	0	313782	1127433		
135169	2966	40213160	1962-07-21	1962-07-21 00:00:00	1962-07-21	1962-07-21 00:00:00	1962-07-21	581452		0	0	0		0	0	0	198055	0	10	40213160		
52824	4390	1127433	1994-06-10	1994-06-10 00:00:00	1994-06-24	1994-06-24 00:00:00	1994-06-24	38000177		0	0	14		0	0	0	291829	0	313782	1127433		
15797	340	40213160	1958-08-20	1958-08-20 00:00:00	1958-08-20	1958-08-20 00:00:00	1958-08-20	581452		0	0	0		0	0	0	22674	0	10	40213160		
32677	2708	1127433	1993-02-07	1993-02-07 00:00:00	1993-02-14	1993-02-14 00:00:00	1993-02-14	38000177		0	0	7		0	0	0	179421	0	313782	1127433		
147015	3232	40213160	1964-02-24	1964-02-24 00:00:00	1964-02-24	1964-02-24 00:00:00	1964-02-24	581452		0	0	0		0	0	0	214861	0	10	40213160		
160720	3537	40213227	2003-07-06	2003-07-06 00:00:00	2003-07-06	2003-07-06 00:00:00	2003-07-06	581452		0	0	0		0	0	0	234903	0	113	40213227		
42961	3561	40231925	1967-04-02	1967-04-02 00:00:00	1967-04-02	1967-04-02 00:00:00	\N	38000177		0	0	0		0	0	0	236472	0	1049221	40231925		
15617	1303	40229134	1981-11-03	1981-11-03 00:00:00	1981-11-17	1981-11-17 00:00:00	1981-11-17	38000177		0	0	14		0	0	0	86062	0	1043400	40229134		
15641	1305	19129655	1964-12-06	1964-12-06 00:00:00	1964-12-20	1964-12-20 00:00:00	1964-12-20	38000177		0	0	14		0	0	0	86140	0	789980	19129655		
6493	141	40213314	1985-05-07	1985-05-07 00:00:00	1985-05-07	1985-05-07 00:00:00	1985-05-07	581452		0	0	0		0	0	0	9457	0	49	40213314		
147704	3248	40213198	2011-04-22	2011-04-22 00:00:00	2011-04-22	2011-04-22 00:00:00	2011-04-22	581452		0	0	0		0	0	0	215890	0	133	40213198		
170176	3742	40213296	2013-04-26	2013-04-26 00:00:00	2013-04-26	2013-04-26 00:00:00	2013-04-26	581452		0	0	0		0	0	0	248678	0	52	40213296		
147760	3249	40213160	1957-10-20	1957-10-20 00:00:00	1957-10-20	1957-10-20 00:00:00	1957-10-20	581452		0	0	0		0	0	0	216018	0	10	40213160		
45239	3744	1594382	2003-01-08	2003-01-08 00:00:00	2003-01-08	2003-01-08 00:00:00	\N	38000177		0	0	0		0	0	0	248741	0	1870230	1594382		
45289	3748	40229134	2009-06-14	2009-06-14 00:00:00	2009-06-21	2009-06-21 00:00:00	2009-06-21	38000177		0	0	7		0	0	0	249146	0	1043400	40229134		
55432	4603	19059056	1969-10-24	1969-10-24 00:00:00	1969-11-21	1969-11-21 00:00:00	1969-11-21	38000177		0	0	28		0	0	0	306620	0	243670	19059056		
16815	1391	46233710	1968-05-30	1968-05-30 00:00:00	1968-06-13	1968-06-13 00:00:00	1968-06-13	38000177		0	0	14		0	0	0	92403	0	1650142	46233710		
55654	4621	19019979	1980-10-22	1980-10-22 00:00:00	1980-11-05	1980-11-05 00:00:00	1980-11-05	38000177		0	0	14		0	0	0	307774	0	198405	19019979		
28315	2337	40220960	2002-10-01	2002-10-01 00:00:00	2002-10-01	2002-10-01 00:00:00	2002-10-01	38000177		0	0	0		0	0	0	155541	0	1804799	40220960		
28342	2339	1115171	2016-08-22	2016-08-22 00:00:00	2016-09-05	2016-09-05 00:00:00	2016-09-05	38000177		0	0	14		0	0	0	155618	0	849574	1115171		
30136	2498	19126352	2006-04-08	2006-04-08 00:00:00	2006-04-08	2006-04-08 00:00:00	\N	38000177		0	0	0		0	0	0	165420	0	705129	19126352		
21534	1770	40229134	1986-06-01	1986-06-01 00:00:00	1986-06-15	1986-06-15 00:00:00	1986-06-15	38000177		0	0	14		0	0	0	118400	0	1043400	40229134		
39067	3229	1127078	1984-03-13	1984-03-13 00:00:00	1984-03-27	1984-03-27 00:00:00	1984-03-27	38000177		0	0	14		0	0	0	214596	0	282464	1127078		
38976	3221	40229134	1977-04-16	1977-04-16 00:00:00	1977-04-30	1977-04-30 00:00:00	1977-04-30	38000177		0	0	14		0	0	0	214069	0	1043400	40229134		
58224	4837	1127433	1968-07-26	1968-07-26 00:00:00	1968-08-09	1968-08-09 00:00:00	1968-08-09	38000177		0	0	14		0	0	0	321803	0	313782	1127433		
3597	297	1713671	2018-11-26	2018-11-26 00:00:00	2018-12-17	2018-12-17 00:00:00	2018-12-17	38000177		0	0	21		0	0	0	19798	0	562251	1713671		
49584	4113	19078461	2008-10-14	2008-10-14 00:00:00	2008-10-28	2008-10-28 00:00:00	2008-10-28	38000177		0	0	14		0	0	0	273390	0	310965	19078461		
171530	3771	40213296	2007-04-10	2007-04-10 00:00:00	2007-04-10	2007-04-10 00:00:00	2007-04-10	581452		0	0	0		0	0	0	250609	0	52	40213296		
39657	3279	19006318	1956-05-03	1956-05-03 00:00:00	1956-05-17	1956-05-17 00:00:00	1956-05-17	38000177		0	0	14		0	0	0	217889	0	105078	19006318		
190021	4173	40213296	2003-12-10	2003-12-10 00:00:00	2003-12-10	2003-12-10 00:00:00	2003-12-10	581452		0	0	0		0	0	0	277321	0	52	40213296		
50214	4167	19078461	2016-08-15	2016-08-15 00:00:00	2016-09-19	2016-09-19 00:00:00	2016-09-19	38000177		0	0	35		0	0	0	277001	0	310965	19078461		
195635	4297	40213227	2004-03-27	2004-03-27 00:00:00	2004-03-27	2004-03-27 00:00:00	2004-03-27	581452		0	0	0		0	0	0	285210	0	113	40213227		
48424	4013	46233988	1975-11-12	1975-11-12 00:00:00	1975-11-26	1975-11-26 00:00:00	1975-11-26	38000177		0	0	14		0	0	0	266632	0	1652673	46233988		
136010	2986	40213201	2011-03-22	2011-03-22 00:00:00	2011-03-22	2011-03-22 00:00:00	2011-03-22	581452		0	0	0		0	0	0	199323	0	33	40213201		
2997	66	40213227	1993-06-11	1993-06-11 00:00:00	1993-06-11	1993-06-11 00:00:00	1993-06-11	581452		0	0	0		0	0	0	4503	0	113	40213227		
48108	1053	40213314	1977-02-18	1977-02-18 00:00:00	1977-02-18	1977-02-18 00:00:00	1977-02-18	581452		0	0	0		0	0	0	69053	0	49	40213314		
13578	1137	19059056	1993-09-02	1993-09-02 00:00:00	1993-09-23	1993-09-23 00:00:00	1993-09-23	38000177		0	0	21		0	0	0	74936	0	243670	19059056		
68995	1510	40213296	2000-11-12	2000-11-12 00:00:00	2000-11-12	2000-11-12 00:00:00	2000-11-12	581452		0	0	0		0	0	0	100824	0	52	40213296		
36160	789	40213296	2014-07-07	2014-07-07 00:00:00	2014-07-07	2014-07-07 00:00:00	2014-07-07	581452		0	0	0		0	0	0	52474	0	52	40213296		
5599	469	40231925	2014-12-19	2014-12-19 00:00:00	2014-12-19	2014-12-19 00:00:00	\N	38000177		0	0	0		0	0	0	31366	0	1049221	40231925		
50441	4191	1713671	1975-11-26	1975-11-26 00:00:00	1975-12-10	1975-12-10 00:00:00	1975-12-10	38000177		0	0	14		0	0	0	278164	0	562251	1713671		
166755	3666	40213160	1960-04-07	1960-04-07 00:00:00	1960-04-07	1960-04-07 00:00:00	1960-04-07	581452		0	0	0		0	0	0	243864	0	10	40213160		
130433	2866	40213260	2016-08-07	2016-08-07 00:00:00	2016-08-07	2016-08-07 00:00:00	2016-08-07	581452		0	0	0		0	0	0	190650	0	121	40213260		
123141	2706	40213160	1963-12-17	1963-12-17 00:00:00	1963-12-17	1963-12-17 00:00:00	1963-12-17	581452		0	0	0		0	0	0	179313	0	10	40213160		
141807	3115	40213160	1967-09-29	1967-09-29 00:00:00	1967-09-29	1967-09-29 00:00:00	1967-09-29	581452		0	0	0		0	0	0	207244	0	10	40213160		
57898	4811	1127433	2011-02-17	2011-02-17 00:00:00	2011-03-10	2011-03-10 00:00:00	2011-03-10	38000177		0	0	21		0	0	0	320053	0	313782	1127433		
84471	1847	40213201	1983-11-20	1983-11-20 00:00:00	1983-11-20	1983-11-20 00:00:00	1983-11-20	581452		0	0	0		0	0	0	123507	0	33	40213201		
38521	3181	1154615	1953-09-20	1953-09-20 00:00:00	1953-09-20	1953-09-20 00:00:00	\N	38000177		0	0	0		0	0	0	211630	0	745679	1154615		
232150	5101	40213296	1997-01-04	1997-01-04 00:00:00	1997-01-04	1997-01-04 00:00:00	1997-01-04	581452		0	0	0		0	0	0	338949	0	52	40213296		
110300	2423	40213160	1957-04-01	1957-04-01 00:00:00	1957-04-01	1957-04-01 00:00:00	1957-04-01	581452		0	0	0		0	0	0	160755	0	10	40213160		
38641	3191	19078461	1976-08-31	1976-08-31 00:00:00	1976-09-21	1976-09-21 00:00:00	1976-09-21	38000177		0	0	21		0	0	0	212388	0	310965	19078461		
62634	5207	920300	1980-02-20	1980-02-20 00:00:00	1980-02-27	1980-02-27 00:00:00	1980-02-27	38000177		0	0	7		0	0	0	346347	0	311989	920300		
8142	679	1713671	1980-07-04	1980-07-04 00:00:00	1980-07-18	1980-07-18 00:00:00	1980-07-18	38000177		0	0	14		0	0	0	44906	0	562251	1713671		
174378	3834	40213227	2006-07-23	2006-07-23 00:00:00	2006-07-23	2006-07-23 00:00:00	2006-07-23	581452		0	0	0		0	0	0	254618	0	113	40213227		
5561	120	40213227	2019-06-08	2019-06-08 00:00:00	2019-06-08	2019-06-08 00:00:00	2019-06-08	581452		0	0	0		0	0	0	7966	0	113	40213227		
51234	1122	40213296	2009-12-28	2009-12-28 00:00:00	2009-12-28	2009-12-28 00:00:00	2009-12-28	581452		0	0	0		0	0	0	73926	0	52	40213296		
71673	1567	40213160	1975-09-04	1975-09-04 00:00:00	1975-09-04	1975-09-04 00:00:00	1975-09-04	581452		0	0	0		0	0	0	105138	0	10	40213160		
122114	2684	40213260	2011-02-13	2011-02-13 00:00:00	2011-02-13	2011-02-13 00:00:00	2011-02-13	581452		0	0	0		0	0	0	177867	0	121	40213260		
101863	2233	40213227	1994-02-15	1994-02-15 00:00:00	1994-02-15	1994-02-15 00:00:00	1994-02-15	581452		0	0	0		0	0	0	148560	0	113	40213227		
31635	2622	1115171	2018-05-21	2018-05-21 00:00:00	2018-06-04	2018-06-04 00:00:00	2018-06-04	38000177		0	0	14		0	0	0	173406	0	849574	1115171		
33612	733	40213227	2013-08-01	2013-08-01 00:00:00	2013-08-01	2013-08-01 00:00:00	2013-08-01	581452		0	0	0		0	0	0	48657	0	113	40213227		
205709	4514	40213306	1999-05-28	1999-05-28 00:00:00	1999-05-28	1999-05-28 00:00:00	1999-05-28	581452		0	0	0		0	0	0	300649	0	43	40213306		
61094	5081	19059056	1969-05-10	1969-05-10 00:00:00	1969-05-31	1969-05-31 00:00:00	1969-05-31	38000177		0	0	21		0	0	0	337902	0	243670	19059056		
38344	3172	1127078	1982-12-20	1982-12-20 00:00:00	1983-01-03	1983-01-03 00:00:00	1983-01-03	38000177		0	0	14		0	0	0	210820	0	282464	1127078		
135171	2966	40213296	2001-11-17	2001-11-17 00:00:00	2001-11-17	2001-11-17 00:00:00	2001-11-17	581452		0	0	0		0	0	0	198120	0	52	40213296		
52825	4390	1124300	1994-10-15	1994-10-15 00:00:00	1994-10-15	1994-10-15 00:00:00	\N	38000177		0	0	0		0	0	0	291829	0	00781178901	45011828		
15800	340	40213160	1958-10-22	1958-10-22 00:00:00	1958-10-22	1958-10-22 00:00:00	1958-10-22	581452		0	0	0		0	0	0	22716	0	10	40213160		
32678	2708	1127433	1973-01-28	1973-01-28 00:00:00	1973-04-28	1973-04-28 00:00:00	1973-04-28	38000177		0	0	90		0	0	0	179429	0	313782	1127433		
147018	3232	40213160	1963-12-23	1963-12-23 00:00:00	1963-12-23	1963-12-23 00:00:00	1963-12-23	581452		0	0	0		0	0	0	214829	0	10	40213160		
160723	3537	40213296	2003-07-06	2003-07-06 00:00:00	2003-07-06	2003-07-06 00:00:00	2003-07-06	581452		0	0	0		0	0	0	234903	0	52	40213296		
42962	3561	1127433	2007-08-24	2007-08-24 00:00:00	2007-08-31	2007-08-31 00:00:00	2007-08-31	38000177		0	0	7		0	0	0	236488	0	313782	1127433		
15618	1303	1713671	2013-07-17	2013-07-17 00:00:00	2013-08-07	2013-08-07 00:00:00	2013-08-07	38000177		0	0	21		0	0	0	86027	0	562251	1713671		
15642	1305	1127433	1969-06-14	1969-06-14 00:00:00	1969-06-28	1969-06-28 00:00:00	1969-06-28	38000177		0	0	14		0	0	0	86124	0	313782	1127433		
6497	141	40213251	1988-09-27	1988-09-27 00:00:00	1988-09-27	1988-09-27 00:00:00	1988-09-27	581452		0	0	0		0	0	0	9478	0	21	40213251		
147707	3248	40213227	2007-03-30	2007-03-30 00:00:00	2007-03-30	2007-03-30 00:00:00	2007-03-30	581452		0	0	0		0	0	0	215888	0	113	40213227		
170183	3742	40213306	1992-10-16	1992-10-16 00:00:00	1992-10-16	1992-10-16 00:00:00	1992-10-16	581452		0	0	0		0	0	0	248677	0	43	40213306		
147767	3249	40213160	1957-12-22	1957-12-22 00:00:00	1957-12-22	1957-12-22 00:00:00	1957-12-22	581452		0	0	0		0	0	0	215953	0	10	40213160		
45240	3744	40223834	2003-01-08	2003-01-08 00:00:00	2003-01-08	2003-01-08 00:00:00	\N	38000177		0	0	0		0	0	0	248741	0	997501	40223834		
45305	3750	1127433	2003-11-24	2003-11-24 00:00:00	2003-12-01	2003-12-01 00:00:00	2003-12-01	38000177		0	0	7		0	0	0	249250	0	313782	1127433		
55433	4603	1127433	1959-07-21	1959-07-21 00:00:00	1959-08-18	1959-08-18 00:00:00	1959-08-18	38000177		0	0	28		0	0	0	306648	0	313782	1127433		
16816	1391	1127433	1968-05-30	1968-05-30 00:00:00	1968-06-13	1968-06-13 00:00:00	1968-06-13	38000177		0	0	14		0	0	0	92403	0	313782	1127433		
55655	4621	19115351	1976-07-26	1976-07-26 00:00:00	1976-10-18	1976-10-18 00:00:00	1976-10-18	38000177		0	0	84		0	0	0	307740	0	563026	19115351		
28316	2337	19075601	2002-10-01	2002-10-01 00:00:00	2002-10-01	2002-10-01 00:00:00	2002-10-01	38000177		0	0	0		0	0	0	155541	0	309362	19075601		
28343	2339	1551192	1983-05-27	1983-05-27 00:00:00	1983-05-27	1983-05-27 00:00:00	1983-05-27	38000177		0	0	0		0	0	0	155677	0	312617	1551192		
30137	2498	19075601	2006-04-08	2006-04-08 00:00:00	2006-04-08	2006-04-08 00:00:00	\N	38000177		0	0	0		0	0	0	165420	0	309362	19075601		
21535	1770	1118084	2014-12-19	2014-12-19 00:00:00	2014-12-19	2014-12-19 00:00:00	\N	38000177		0	0	0		0	0	0	118385	0	00025152531	44923712		
39068	3229	19073183	1984-03-13	1984-03-13 00:00:00	1984-03-27	1984-03-27 00:00:00	1984-03-27	38000177		0	0	14		0	0	0	214596	0	308182	19073183		
38977	3221	1127078	1974-09-01	1974-09-01 00:00:00	1974-09-15	1974-09-15 00:00:00	1974-09-15	38000177		0	0	14		0	0	0	214132	0	282464	1127078		
58225	4837	19006318	1968-07-26	1968-07-26 00:00:00	1968-08-09	1968-08-09 00:00:00	1968-08-09	38000177		0	0	14		0	0	0	321803	0	105078	19006318		
3598	298	40165015	2014-02-11	2014-02-11 00:00:00	2014-02-11	2014-02-11 00:00:00	\N	38000177		0	0	0		0	0	0	19915	0	861467	40165015		
49586	4113	1115171	2011-08-14	2011-08-14 00:00:00	2011-09-04	2011-09-04 00:00:00	2011-09-04	38000177		0	0	21		0	0	0	273391	0	849574	1115171		
171531	3771	40213160	1964-07-07	1964-07-07 00:00:00	1964-07-07	1964-07-07 00:00:00	1964-07-07	581452		0	0	0		0	0	0	250633	0	10	40213160		
39658	3279	19059056	1956-05-03	1956-05-03 00:00:00	1956-05-17	1956-05-17 00:00:00	1956-05-17	38000177		0	0	14		0	0	0	217889	0	243670	19059056		
190032	4173	40213306	1986-11-19	1986-11-19 00:00:00	1986-11-19	1986-11-19 00:00:00	1986-11-19	581452		0	0	0		0	0	0	277318	0	43	40213306		
50215	4167	19133873	1990-07-02	1990-07-02 00:00:00	1990-07-10	1990-07-10 00:00:00	1990-07-10	38000177		0	0	8		0	0	0	276923	0	834061	19133873		
14393	1209	46233988	1978-07-16	1978-07-16 00:00:00	1978-07-30	1978-07-30 00:00:00	1978-07-30	38000177		0	0	14		0	0	0	79424	0	1652673	46233988		
48425	4013	1127078	1975-11-12	1975-11-12 00:00:00	1975-11-26	1975-11-26 00:00:00	1975-11-26	38000177		0	0	14		0	0	0	266632	0	282464	1127078		
136017	2986	40213227	1995-10-17	1995-10-17 00:00:00	1995-10-17	1995-10-17 00:00:00	1995-10-17	581452		0	0	0		0	0	0	199312	0	113	40213227		
3009	66	40213160	1959-03-06	1959-03-06 00:00:00	1959-03-06	1959-03-06 00:00:00	1959-03-06	581452		0	0	0		0	0	0	4486	0	10	40213160		
48112	1053	40213296	2017-06-02	2017-06-02 00:00:00	2017-06-02	2017-06-02 00:00:00	2017-06-02	581452		0	0	0		0	0	0	\N	0	52	40213296		
13580	1137	1127433	2011-04-06	2011-04-06 00:00:00	2011-04-20	2011-04-20 00:00:00	2011-04-20	38000177		0	0	14		0	0	0	74910	0	313782	1127433		
69001	1510	40213160	1959-04-12	1959-04-12 00:00:00	1959-04-12	1959-04-12 00:00:00	1959-04-12	581452		0	0	0		0	0	0	100800	0	10	40213160		
199712	4387	40213306	1985-05-24	1985-05-24 00:00:00	1985-05-24	1985-05-24 00:00:00	1985-05-24	581452		0	0	0		0	0	0	291578	0	43	40213306		
5600	469	1127433	2014-12-19	2014-12-19 00:00:00	2015-03-19	2015-03-19 00:00:00	2015-03-19	38000177		0	0	90		0	0	0	31366	0	313782	1127433		
50442	4191	46275916	2013-07-26	2013-07-26 00:00:00	2013-07-26	2013-07-26 00:00:00	2013-07-26	38000177		0	0	0		0	0	0	278185	0	1660014	46275916		
166758	3666	40213227	2011-01-06	2011-01-06 00:00:00	2011-01-06	2011-01-06 00:00:00	2011-01-06	581452		0	0	0		0	0	0	243910	0	113	40213227		
130436	2866	40213227	2008-08-17	2008-08-17 00:00:00	2008-08-17	2008-08-17 00:00:00	2008-08-17	581452		0	0	0		0	0	0	190678	0	113	40213227		
123143	2706	40213160	1963-07-16	1963-07-16 00:00:00	1963-07-16	1963-07-16 00:00:00	1963-07-16	581452		0	0	0		0	0	0	179281	0	10	40213160		
141810	3115	40213260	2017-01-20	2017-01-20 00:00:00	2017-01-20	2017-01-20 00:00:00	2017-01-20	581452		0	0	0		0	0	0	207275	0	121	40213260		
57899	4811	1127433	1962-09-16	1962-09-16 00:00:00	1962-09-23	1962-09-23 00:00:00	1962-09-23	38000177		0	0	7		0	0	0	320016	0	313782	1127433		
109688	2409	40213160	1983-09-11	1983-09-11 00:00:00	1983-09-11	1983-09-11 00:00:00	1983-09-11	581452		0	0	0		0	0	0	159951	0	10	40213160		
38522	3181	40232448	1956-10-03	1956-10-03 00:00:00	1956-10-03	1956-10-03 00:00:00	\N	38000177		0	0	0		0	0	0	211719	0	1049630	40232448		
232151	5101	40213296	1998-01-03	1998-01-03 00:00:00	1998-01-03	1998-01-03 00:00:00	1998-01-03	581452		0	0	0		0	0	0	339008	0	52	40213296		
74503	1627	40213160	1956-04-07	1956-04-07 00:00:00	1956-04-07	1956-04-07 00:00:00	1956-04-07	581452		0	0	0		0	0	0	109380	0	10	40213160		
38642	3191	1713671	2001-02-28	2001-02-28 00:00:00	2001-03-07	2001-03-07 00:00:00	2001-03-07	38000177		0	0	7		0	0	0	212335	0	562251	1713671		
62635	5207	1127433	1997-09-13	1997-09-13 00:00:00	1997-09-27	1997-09-27 00:00:00	1997-09-27	38000177		0	0	14		0	0	0	346379	0	313782	1127433		
8143	679	40229134	2007-11-01	2007-11-01 00:00:00	2007-11-15	2007-11-15 00:00:00	2007-11-15	38000177		0	0	14		0	0	0	44956	0	1043400	40229134		
174380	3834	40213260	2006-07-23	2006-07-23 00:00:00	2006-07-23	2006-07-23 00:00:00	2006-07-23	581452		0	0	0		0	0	0	254618	0	121	40213260		
5562	120	40213296	2019-06-08	2019-06-08 00:00:00	2019-06-08	2019-06-08 00:00:00	2019-06-08	581452		0	0	0		0	0	0	7966	0	52	40213296		
51237	1122	40213227	2001-06-18	2001-06-18 00:00:00	2001-06-18	2001-06-18 00:00:00	2001-06-18	581452		0	0	0		0	0	0	73916	0	113	40213227		
71678	1567	40213314	1978-06-01	1978-06-01 00:00:00	1978-06-01	1978-06-01 00:00:00	1978-06-01	581452		0	0	0		0	0	0	105115	0	49	40213314		
122123	2684	40213260	2012-02-19	2012-02-19 00:00:00	2012-02-19	2012-02-19 00:00:00	2012-02-19	581452		0	0	0		0	0	0	177875	0	121	40213260		
101864	2233	40213306	1994-02-15	1994-02-15 00:00:00	1994-02-15	1994-02-15 00:00:00	1994-02-15	581452		0	0	0		0	0	0	148560	0	43	40213306		
31636	2622	1118084	1975-03-17	1975-03-17 00:00:00	1975-03-17	1975-03-17 00:00:00	\N	38000177		0	0	0		0	0	0	173467	0	00025152531	44923712		
27709	2292	19133873	1978-11-09	1978-11-09 00:00:00	1978-11-22	1978-11-22 00:00:00	1978-11-22	38000177		0	0	13		0	0	0	152631	0	834061	19133873		
205712	4514	40213160	1975-10-31	1975-10-31 00:00:00	1975-10-31	1975-10-31 00:00:00	1975-10-31	581452		0	0	0		0	0	0	300600	0	10	40213160		
61095	5081	1127433	1970-07-07	1970-07-07 00:00:00	1970-07-21	1970-07-21 00:00:00	1970-07-21	38000177		0	0	14		0	0	0	337850	0	313782	1127433		
38345	3172	19128022	1994-12-27	1994-12-27 00:00:00	1995-12-22	1995-12-22 00:00:00	1995-12-22	38000177		0	0	360		0	0	0	210838	0	749785	19128022		
135176	2966	40213160	1966-10-22	1966-10-22 00:00:00	1966-10-22	1966-10-22 00:00:00	1966-10-22	581452		0	0	0		0	0	0	198040	0	10	40213160		
52826	4390	19059056	1970-11-29	1970-11-29 00:00:00	1970-12-13	1970-12-13 00:00:00	1970-12-13	38000177		0	0	14		0	0	0	291835	0	243670	19059056		
15805	340	40213260	2008-05-14	2008-05-14 00:00:00	2008-05-14	2008-05-14 00:00:00	2008-05-14	581452		0	0	0		0	0	0	22739	0	121	40213260		
32679	2708	40162522	1973-01-28	1973-01-28 00:00:00	1973-01-28	1973-01-28 00:00:00	\N	38000177		0	0	0		0	0	0	179429	0	857005	40162522		
147020	3232	40213260	2013-09-16	2013-09-16 00:00:00	2013-09-16	2013-09-16 00:00:00	2013-09-16	581452		0	0	0		0	0	0	214826	0	121	40213260		
220921	4848	40213198	2017-10-15	2017-10-15 00:00:00	2017-10-15	2017-10-15 00:00:00	2017-10-15	581452		0	0	0		0	0	0	322544	0	133	40213198		
42963	3561	1713671	2007-03-15	2007-03-15 00:00:00	2007-03-22	2007-03-22 00:00:00	2007-03-22	38000177		0	0	7		0	0	0	236561	0	562251	1713671		
15619	1303	46233988	1977-04-18	1977-04-18 00:00:00	1977-05-02	1977-05-02 00:00:00	1977-05-02	38000177		0	0	14		0	0	0	86035	0	1652673	46233988		
15643	1305	19133873	1966-03-02	1966-03-02 00:00:00	1966-03-09	1966-03-09 00:00:00	1966-03-09	38000177		0	0	7		0	0	0	86109	0	834061	19133873		
6500	141	40213160	1988-09-27	1988-09-27 00:00:00	1988-09-27	1988-09-27 00:00:00	1988-09-27	581452		0	0	0		0	0	0	9478	0	10	40213160		
162666	3577	40213227	2012-03-05	2012-03-05 00:00:00	2012-03-05	2012-03-05 00:00:00	2012-03-05	581452		0	0	0		0	0	0	237835	0	113	40213227		
170184	3742	40213227	1992-10-16	1992-10-16 00:00:00	1992-10-16	1992-10-16 00:00:00	1992-10-16	581452		0	0	0		0	0	0	248677	0	113	40213227		
147772	3249	40213296	1997-07-20	1997-07-20 00:00:00	1997-07-20	1997-07-20 00:00:00	1997-07-20	581452		0	0	0		0	0	0	215982	0	52	40213296		
45241	3744	19059056	1971-05-22	1971-05-22 00:00:00	1971-06-05	1971-06-05 00:00:00	1971-06-05	38000177		0	0	14		0	0	0	248836	0	243670	19059056		
45307	3750	1127433	1993-04-29	1993-04-29 00:00:00	1993-05-20	1993-05-20 00:00:00	1993-05-20	38000177		0	0	21		0	0	0	249194	0	313782	1127433		
55434	4603	40173590	2010-10-28	2010-10-28 00:00:00	2010-10-28	2010-10-28 00:00:00	\N	38000177		0	0	0		0	0	0	306633	0	904419	40173590		
16817	1391	1127433	1961-02-02	1961-02-02 00:00:00	1961-02-16	1961-02-16 00:00:00	1961-02-16	38000177		0	0	14		0	0	0	92382	0	313782	1127433		
55656	4622	1713671	1983-03-08	1983-03-08 00:00:00	1983-03-22	1983-03-22 00:00:00	1983-03-22	38000177		0	0	14		0	0	0	307834	0	562251	1713671		
28317	2337	1127433	2001-12-26	2001-12-26 00:00:00	2002-01-16	2002-01-16 00:00:00	2002-01-16	38000177		0	0	21		0	0	0	155541	0	313782	1127433		
28344	2339	1118084	2006-04-01	2006-04-01 00:00:00	2006-04-01	2006-04-01 00:00:00	\N	38000177		0	0	0		0	0	0	155616	0	00025152531	44923712		
30138	2498	46233988	1973-03-31	1973-03-31 00:00:00	1973-04-14	1973-04-14 00:00:00	1973-04-14	38000177		0	0	14		0	0	0	165408	0	1652673	46233988		
21536	1770	1713671	2000-05-30	2000-05-30 00:00:00	2000-06-13	2000-06-13 00:00:00	2000-06-13	38000177		0	0	14		0	0	0	118345	0	562251	1713671		
39069	3229	1713671	1994-05-04	1994-05-04 00:00:00	1994-05-18	1994-05-18 00:00:00	1994-05-18	38000177		0	0	14		0	0	0	214621	0	562251	1713671		
38978	3221	19133873	1970-02-26	1970-02-26 00:00:00	1970-03-07	1970-03-07 00:00:00	1970-03-07	38000177		0	0	9		0	0	0	214071	0	834061	19133873		
58226	4837	1310034	2004-03-23	2004-03-23 00:00:00	2004-03-23	2004-03-23 00:00:00	2004-03-23	38000177		0	0	0		0	0	0	321870	0	834357	1310034		
3599	298	1127433	2014-02-11	2014-02-11 00:00:00	2014-03-04	2014-03-04 00:00:00	2014-03-04	38000177		0	0	21		0	0	0	19915	0	313782	1127433		
49587	4113	19129655	1961-07-20	1961-07-20 00:00:00	1961-08-03	1961-08-03 00:00:00	1961-08-03	38000177		0	0	14		0	0	0	273429	0	789980	19129655		
171537	3771	40213306	1986-07-29	1986-07-29 00:00:00	1986-07-29	1986-07-29 00:00:00	1986-07-29	581452		0	0	0		0	0	0	250595	0	43	40213306		
39659	3279	19059056	1974-08-14	1974-08-14 00:00:00	1974-10-13	1974-10-13 00:00:00	1974-10-13	38000177		0	0	60		0	0	0	217920	0	243670	19059056		
190034	4173	40213160	1964-04-22	1964-04-22 00:00:00	1964-04-22	1964-04-22 00:00:00	1964-04-22	581452		0	0	0		0	0	0	277335	0	10	40213160		
50216	4167	1127078	1981-05-21	1981-05-21 00:00:00	1981-06-04	1981-06-04 00:00:00	1981-06-04	38000177		0	0	14		0	0	0	276988	0	282464	1127078		
14394	1209	19133873	1991-05-13	1991-05-13 00:00:00	1991-05-24	1991-05-24 00:00:00	1991-05-24	38000177		0	0	11		0	0	0	79443	0	834061	19133873		
48426	4013	46233988	1977-07-18	1977-07-18 00:00:00	1977-08-01	1977-08-01 00:00:00	1977-08-01	38000177		0	0	14		0	0	0	266683	0	1652673	46233988		
136030	2986	40213227	2016-04-19	2016-04-19 00:00:00	2016-04-19	2016-04-19 00:00:00	2016-04-19	581452		0	0	0		0	0	0	199307	0	113	40213227		
3011	66	40213306	1981-05-29	1981-05-29 00:00:00	1981-05-29	1981-05-29 00:00:00	1981-05-29	581452		0	0	0		0	0	0	4468	0	43	40213306		
48114	1053	40213227	2017-06-02	2017-06-02 00:00:00	2017-06-02	2017-06-02 00:00:00	2017-06-02	581452		0	0	0		0	0	0	\N	0	113	40213227		
13581	1137	40229134	1974-07-27	1974-07-27 00:00:00	1974-08-03	1974-08-03 00:00:00	1974-08-03	38000177		0	0	7		0	0	0	74881	0	1043400	40229134		
69005	1510	40213306	1981-10-11	1981-10-11 00:00:00	1981-10-11	1981-10-11 00:00:00	1981-10-11	581452		0	0	0		0	0	0	100831	0	43	40213306		
199715	4387	40213227	1997-06-06	1997-06-06 00:00:00	1997-06-06	1997-06-06 00:00:00	1997-06-06	581452		0	0	0		0	0	0	291627	0	113	40213227		
5601	469	40229134	1955-07-02	1955-07-02 00:00:00	1955-07-09	1955-07-09 00:00:00	1955-07-09	38000177		0	0	7		0	0	0	31309	0	1043400	40229134		
50443	4191	40243436	2013-07-26	2013-07-26 00:00:00	2013-07-26	2013-07-26 00:00:00	2013-07-26	38000177		0	0	0		0	0	0	278185	0	1190795	40243436		
166759	3666	40213260	2011-01-06	2011-01-06 00:00:00	2011-01-06	2011-01-06 00:00:00	2011-01-06	581452		0	0	0		0	0	0	243910	0	121	40213260		
130437	2866	40213296	2008-08-17	2008-08-17 00:00:00	2008-08-17	2008-08-17 00:00:00	2008-08-17	581452		0	0	0		0	0	0	190678	0	52	40213296		
123148	2706	40213296	2006-06-20	2006-06-20 00:00:00	2006-06-20	2006-06-20 00:00:00	2006-06-20	581452		0	0	0		0	0	0	179305	0	52	40213296		
141811	3115	40213306	1987-05-08	1987-05-08 00:00:00	1987-05-08	1987-05-08 00:00:00	1987-05-08	581452		0	0	0		0	0	0	\N	0	43	40213306		
57900	4811	19006318	1964-07-22	1964-07-22 00:00:00	1964-08-05	1964-08-05 00:00:00	1964-08-05	38000177		0	0	14		0	0	0	320069	0	105078	19006318		
109695	2409	40213314	1979-03-11	1979-03-11 00:00:00	1979-03-11	1979-03-11 00:00:00	1979-03-11	581452		0	0	0		0	0	0	159947	0	49	40213314		
38523	3181	40169281	2001-06-22	2001-06-22 00:00:00	2001-06-22	2001-06-22 00:00:00	\N	38000177		0	0	0		0	0	0	211715	0	896209	40169281		
232154	5101	40213227	1998-01-03	1998-01-03 00:00:00	1998-01-03	1998-01-03 00:00:00	1998-01-03	581452		0	0	0		0	0	0	339008	0	113	40213227		
74521	1627	40213260	2006-11-25	2006-11-25 00:00:00	2006-11-25	2006-11-25 00:00:00	2006-11-25	581452		0	0	0		0	0	0	109360	0	121	40213260		
38648	3194	1127433	1974-08-24	1974-08-24 00:00:00	1974-08-31	1974-08-31 00:00:00	1974-08-31	38000177		0	0	7		0	0	0	212456	0	313782	1127433		
62636	5207	1118084	1995-03-22	1995-03-22 00:00:00	1995-03-22	1995-03-22 00:00:00	\N	38000177		0	0	0		0	0	0	346393	0	00025152531	44923712		
8144	679	19133873	1978-05-10	1978-05-10 00:00:00	1978-05-17	1978-05-17 00:00:00	1978-05-17	38000177		0	0	7		0	0	0	44937	0	834061	19133873		
174389	3834	40213260	2007-07-29	2007-07-29 00:00:00	2007-07-29	2007-07-29 00:00:00	2007-07-29	581452		0	0	0		0	0	0	254564	0	121	40213260		
5564	120	40213296	2018-01-13	2018-01-13 00:00:00	2018-01-13	2018-01-13 00:00:00	2018-01-13	581452		0	0	0		0	0	0	7965	0	52	40213296		
51241	1122	40213160	1970-04-27	1970-04-27 00:00:00	1970-04-27	1970-04-27 00:00:00	1970-04-27	581452		0	0	0		0	0	0	73894	0	10	40213160		
71683	1567	40213314	1977-06-02	1977-06-02 00:00:00	1977-06-02	1977-06-02 00:00:00	1977-06-02	581452		0	0	0		0	0	0	105086	0	49	40213314		
122126	2684	40213227	2012-02-19	2012-02-19 00:00:00	2012-02-19	2012-02-19 00:00:00	2012-02-19	581452		0	0	0		0	0	0	177875	0	113	40213227		
51898	1136	40213227	2013-06-22	2013-06-22 00:00:00	2013-06-22	2013-06-22 00:00:00	2013-06-22	581452		0	0	0		0	0	0	74854	0	113	40213227		
31637	2622	19059056	1931-10-04	1931-10-04 00:00:00	1931-10-18	1931-10-18 00:00:00	1931-10-18	38000177		0	0	14		0	0	0	173412	0	243670	19059056		
27710	2292	1127433	2007-02-05	2007-02-05 00:00:00	2007-02-19	2007-02-19 00:00:00	2007-02-19	38000177		0	0	14		0	0	0	152638	0	313782	1127433		
205720	4514	40213160	1980-05-02	1980-05-02 00:00:00	1980-05-02	1980-05-02 00:00:00	1980-05-02	581452		0	0	0		0	0	0	300702	0	10	40213160		
61096	5081	1127433	2004-11-19	2004-11-19 00:00:00	2004-12-19	2004-12-19 00:00:00	2004-12-19	38000177		0	0	30		0	0	0	337810	0	313782	1127433		
38346	3172	19128022	1997-12-11	1997-12-11 00:00:00	1998-12-06	1998-12-06 00:00:00	1998-12-06	38000177		0	0	360		0	0	0	210855	0	749785	19128022		
135177	2966	40213160	1962-02-17	1962-02-17 00:00:00	1962-02-17	1962-02-17 00:00:00	1962-02-17	581452		0	0	0		0	0	0	198054	0	10	40213160		
52827	4390	19129655	1970-11-29	1970-11-29 00:00:00	1970-12-13	1970-12-13 00:00:00	1970-12-13	38000177		0	0	14		0	0	0	291835	0	789980	19129655		
15807	340	40213296	1998-05-20	1998-05-20 00:00:00	1998-05-20	1998-05-20 00:00:00	1998-05-20	581452		0	0	0		0	0	0	22737	0	52	40213296		
32680	2709	1127433	2019-03-15	2019-03-15 00:00:00	2019-03-22	2019-03-22 00:00:00	2019-03-22	38000177		0	0	7		0	0	0	179496	0	313782	1127433		
138951	3053	40213251	1986-12-20	1986-12-20 00:00:00	1986-12-20	1986-12-20 00:00:00	1986-12-20	581452		0	0	0		0	0	0	203112	0	21	40213251		
220932	4848	40213227	2013-09-22	2013-09-22 00:00:00	2013-09-22	2013-09-22 00:00:00	2013-09-22	581452		0	0	0		0	0	0	322542	0	113	40213227		
42964	3561	40171902	1981-08-17	1981-08-17 00:00:00	1981-08-17	1981-08-17 00:00:00	\N	38000177		0	0	0		0	0	0	236466	0	897718	40171902		
15620	1303	1127078	1977-04-18	1977-04-18 00:00:00	1977-05-02	1977-05-02 00:00:00	1977-05-02	38000177		0	0	14		0	0	0	86035	0	282464	1127078		
15644	1305	1124300	2000-10-18	2000-10-18 00:00:00	2000-10-18	2000-10-18 00:00:00	\N	38000177		0	0	0		0	0	0	86139	0	00781178901	45011828		
6501	141	40213314	1984-06-05	1984-06-05 00:00:00	1984-06-05	1984-06-05 00:00:00	1984-06-05	581452		0	0	0		0	0	0	9431	0	49	40213314		
162667	3577	40213260	2012-03-05	2012-03-05 00:00:00	2012-03-05	2012-03-05 00:00:00	2012-03-05	581452		0	0	0		0	0	0	237835	0	121	40213260		
170188	3742	40213227	2002-10-04	2002-10-04 00:00:00	2002-10-04	2002-10-04 00:00:00	2002-10-04	581452		0	0	0		0	0	0	248665	0	113	40213227		
147779	3249	40213160	1962-06-24	1962-06-24 00:00:00	1962-06-24	1962-06-24 00:00:00	1962-06-24	581452		0	0	0		0	0	0	215997	0	10	40213160		
45242	3745	19059056	1932-03-01	1932-03-01 00:00:00	1932-04-05	1932-04-05 00:00:00	1932-04-05	38000177		0	0	35		0	0	0	248873	0	243670	19059056		
45308	3750	1118084	1993-11-10	1993-11-10 00:00:00	1993-11-10	1993-11-10 00:00:00	\N	38000177		0	0	0		0	0	0	249236	0	00025152531	44923712		
55435	4603	1127433	2000-11-22	2000-11-22 00:00:00	2000-12-27	2000-12-27 00:00:00	2000-12-27	38000177		0	0	35		0	0	0	306622	0	313782	1127433		
16818	1391	1118084	1962-09-13	1962-09-13 00:00:00	1962-09-13	1962-09-13 00:00:00	\N	38000177		0	0	0		0	0	0	92382	0	00025152531	44923712		
55657	4622	1713671	1999-10-13	1999-10-13 00:00:00	1999-11-03	1999-11-03 00:00:00	1999-11-03	38000177		0	0	21		0	0	0	307782	0	562251	1713671		
28318	2337	19128065	1981-06-21	1981-06-21 00:00:00	1982-06-16	1982-06-16 00:00:00	1982-06-16	38000177		0	0	360		0	0	0	155480	0	749882	19128065		
28345	2339	1127433	2013-11-16	2013-11-16 00:00:00	2013-11-23	2013-11-23 00:00:00	2013-11-23	38000177		0	0	7		0	0	0	155632	0	313782	1127433		
30139	2498	19059056	1973-03-31	1973-03-31 00:00:00	1973-04-14	1973-04-14 00:00:00	1973-04-14	38000177		0	0	14		0	0	0	165408	0	243670	19059056		
21537	1770	40236824	2010-07-11	2010-07-11 00:00:00	2010-07-18	2010-07-18 00:00:00	2010-07-18	38000177		0	0	7		0	0	0	118361	0	1094107	40236824		
39070	3229	19133873	1991-04-10	1991-04-10 00:00:00	1991-04-23	1991-04-23 00:00:00	1991-04-23	38000177		0	0	13		0	0	0	214591	0	834061	19133873		
38979	3221	19133905	1986-03-01	1986-03-01 00:00:00	1986-03-14	1986-03-14 00:00:00	1986-03-14	38000177		0	0	13		0	0	0	214109	0	834102	19133905		
58227	4837	40243436	2004-03-23	2004-03-23 00:00:00	2004-03-23	2004-03-23 00:00:00	2004-03-23	38000177		0	0	0		0	0	0	321870	0	1190795	40243436		
3600	298	19075001	2014-02-11	2014-02-11 00:00:00	2014-03-04	2014-03-04 00:00:00	2014-03-04	38000177		0	0	21		0	0	0	19915	0	309097	19075001		
49588	4113	1127078	1961-07-20	1961-07-20 00:00:00	1961-08-03	1961-08-03 00:00:00	1961-08-03	38000177		0	0	14		0	0	0	273429	0	282464	1127078		
171544	3771	40213260	2014-01-28	2014-01-28 00:00:00	2014-01-28	2014-01-28 00:00:00	2014-01-28	581452		0	0	0		0	0	0	250626	0	121	40213260		
39660	3279	1127078	1957-11-28	1957-11-28 00:00:00	1957-12-12	1957-12-12 00:00:00	1957-12-12	38000177		0	0	14		0	0	0	217870	0	282464	1127078		
190039	4173	40213227	1995-11-29	1995-11-29 00:00:00	1995-11-29	1995-11-29 00:00:00	1995-11-29	581452		0	0	0		0	0	0	277355	0	113	40213227		
50217	4167	19073183	1981-05-21	1981-05-21 00:00:00	1981-06-04	1981-06-04 00:00:00	1981-06-04	38000177		0	0	14		0	0	0	276988	0	308182	19073183		
14395	1209	40162522	2004-09-23	2004-09-23 00:00:00	2004-09-23	2004-09-23 00:00:00	\N	38000177		0	0	0		0	0	0	79459	0	857005	40162522		
48427	4013	1127078	1977-07-18	1977-07-18 00:00:00	1977-08-01	1977-08-01 00:00:00	1977-08-01	38000177		0	0	14		0	0	0	266683	0	282464	1127078		
175538	3859	40213227	2013-11-09	2013-11-09 00:00:00	2013-11-09	2013-11-09 00:00:00	2013-11-09	581452		0	0	0		0	0	0	256246	0	113	40213227		
3017	66	40213160	1963-06-07	1963-06-07 00:00:00	1963-06-07	1963-06-07 00:00:00	1963-06-07	581452		0	0	0		0	0	0	4496	0	10	40213160		
48116	1053	40213314	1977-05-20	1977-05-20 00:00:00	1977-05-20	1977-05-20 00:00:00	1977-05-20	581452		0	0	0		0	0	0	69032	0	49	40213314		
13584	1137	1713671	1984-09-07	1984-09-07 00:00:00	1984-09-14	1984-09-14 00:00:00	1984-09-14	38000177		0	0	7		0	0	0	74940	0	562251	1713671		
69010	1510	40213227	2009-11-08	2009-11-08 00:00:00	2009-11-08	2009-11-08 00:00:00	2009-11-08	581452		0	0	0		0	0	0	100838	0	113	40213227		
199718	4387	40213160	1964-11-27	1964-11-27 00:00:00	1964-11-27	1964-11-27 00:00:00	1964-11-27	581452		0	0	0		0	0	0	291573	0	10	40213160		
5602	469	19059056	1936-03-29	1936-03-29 00:00:00	1936-04-12	1936-04-12 00:00:00	1936-04-12	38000177		0	0	14		0	0	0	31330	0	243670	19059056		
50444	4191	1310034	2013-07-26	2013-07-26 00:00:00	2013-07-26	2013-07-26 00:00:00	2013-07-26	38000177		0	0	0		0	0	0	278185	0	834357	1310034		
17307	1435	19078461	2014-03-12	2014-03-12 00:00:00	2014-03-26	2014-03-26 00:00:00	2014-03-26	38000177		0	0	14		0	0	0	95579	0	310965	19078461		
130443	2866	40213296	2006-08-13	2006-08-13 00:00:00	2006-08-13	2006-08-13 00:00:00	2006-08-13	581452		0	0	0		0	0	0	190648	0	52	40213296		
123149	2706	40213160	1963-09-17	1963-09-17 00:00:00	1963-09-17	1963-09-17 00:00:00	1963-09-17	581452		0	0	0		0	0	0	179271	0	10	40213160		
134737	2957	40213227	2019-04-07	2019-04-07 00:00:00	2019-04-07	2019-04-07 00:00:00	2019-04-07	581452		0	0	0		0	0	0	197330	0	113	40213227		
57901	4811	19059056	1964-07-22	1964-07-22 00:00:00	1964-08-05	1964-08-05 00:00:00	1964-08-05	38000177		0	0	14		0	0	0	320069	0	243670	19059056		
109696	2409	40213160	1979-03-11	1979-03-11 00:00:00	1979-03-11	1979-03-11 00:00:00	1979-03-11	581452		0	0	0		0	0	0	159947	0	10	40213160		
38525	3181	19006318	1951-10-14	1951-10-14 00:00:00	1951-10-28	1951-10-28 00:00:00	1951-10-28	38000177		0	0	14		0	0	0	211776	0	105078	19006318		
232159	5101	40213227	2018-01-06	2018-01-06 00:00:00	2018-01-06	2018-01-06 00:00:00	2018-01-06	581452		0	0	0		0	0	0	338991	0	113	40213227		
74523	1627	40213227	1994-02-12	1994-02-12 00:00:00	1994-02-12	1994-02-12 00:00:00	1994-02-12	581452		0	0	0		0	0	0	109358	0	113	40213227		
38649	3194	19008572	1968-06-19	1968-06-19 00:00:00	1968-06-19	1968-06-19 00:00:00	\N	38000177		0	0	0		0	0	0	212490	0	106258	19008572		
62637	5207	920334	1980-02-27	1980-02-27 00:00:00	1980-03-05	1980-03-05 00:00:00	1980-03-05	38000177		0	0	7		0	0	0	346336	0	311995	920334		
8145	679	19133873	1984-10-27	1984-10-27 00:00:00	1984-11-09	1984-11-09 00:00:00	1984-11-09	38000177		0	0	13		0	0	0	44938	0	834061	19133873		
6969	587	19075001	1994-08-12	1994-08-12 00:00:00	1994-08-26	1994-08-26 00:00:00	1994-08-26	38000177		0	0	14		0	0	0	38872	0	309097	19075001		
182822	4017	40213227	1992-03-05	1992-03-05 00:00:00	1992-03-05	1992-03-05 00:00:00	1992-03-05	581452		0	0	0		0	0	0	267040	0	113	40213227		
51247	1122	40213306	1992-06-08	1992-06-08 00:00:00	1992-06-08	1992-06-08 00:00:00	1992-06-08	581452		0	0	0		0	0	0	73947	0	43	40213306		
71685	1567	40213227	2006-05-25	2006-05-25 00:00:00	2006-05-25	2006-05-25 00:00:00	2006-05-25	581452		0	0	0		0	0	0	105128	0	113	40213227		
122127	2684	40213160	1966-01-23	1966-01-23 00:00:00	1966-01-23	1966-01-23 00:00:00	1966-01-23	581452		0	0	0		0	0	0	177848	0	10	40213160		
51899	1136	40213296	2013-06-22	2013-06-22 00:00:00	2013-06-22	2013-06-22 00:00:00	2013-06-22	581452		0	0	0		0	0	0	74854	0	52	40213296		
31638	2622	920300	1971-12-06	1971-12-06 00:00:00	1971-12-13	1971-12-13 00:00:00	1971-12-13	38000177		0	0	7		0	0	0	173476	0	311989	920300		
27711	2292	19133873	1966-11-02	1966-11-02 00:00:00	1966-11-15	1966-11-15 00:00:00	1966-11-15	38000177		0	0	13		0	0	0	152612	0	834061	19133873		
62406	1365	40213227	2005-09-01	2005-09-01 00:00:00	2005-09-01	2005-09-01 00:00:00	2005-09-01	581452		0	0	0		0	0	0	90519	0	113	40213227		
61097	5081	40165015	2004-11-19	2004-11-19 00:00:00	2004-11-19	2004-11-19 00:00:00	\N	38000177		0	0	0		0	0	0	337810	0	861467	40165015		
48805	4045	19133905	2003-03-19	2003-03-19 00:00:00	2003-03-27	2003-03-27 00:00:00	2003-03-27	38000177		0	0	8		0	0	0	269041	0	834102	19133905		
135181	2966	40213227	1993-01-23	1993-01-23 00:00:00	1993-01-23	1993-01-23 00:00:00	1993-01-23	581452		0	0	0		0	0	0	198150	0	113	40213227		
52828	4390	40229134	2004-12-20	2004-12-20 00:00:00	2004-12-27	2004-12-27 00:00:00	2004-12-27	38000177		0	0	7		0	0	0	291927	0	1043400	40229134		
15828	341	40213160	1960-12-19	1960-12-19 00:00:00	1960-12-19	1960-12-19 00:00:00	1960-12-19	581452		0	0	0		0	0	0	22807	0	10	40213160		
32681	2709	1127433	2002-11-16	2002-11-16 00:00:00	2002-11-30	2002-11-30 00:00:00	2002-11-30	38000177		0	0	14		0	0	0	179443	0	313782	1127433		
138953	3053	40213160	1986-12-20	1986-12-20 00:00:00	1986-12-20	1986-12-20 00:00:00	1986-12-20	581452		0	0	0		0	0	0	203112	0	10	40213160		
220941	4848	40213201	2018-10-21	2018-10-21 00:00:00	2018-10-21	2018-10-21 00:00:00	2018-10-21	581452		0	0	0		0	0	0	322526	0	33	40213201		
42965	3561	1713671	1945-02-07	1945-02-07 00:00:00	1945-03-28	1945-03-28 00:00:00	1945-03-28	38000177		0	0	49		0	0	0	236500	0	562251	1713671		
15621	1303	19133905	2005-07-16	2005-07-16 00:00:00	2005-07-29	2005-07-29 00:00:00	2005-07-29	38000177		0	0	13		0	0	0	86063	0	834102	19133905		
15645	1305	19059056	1967-01-07	1967-01-07 00:00:00	1967-01-21	1967-01-21 00:00:00	1967-01-21	38000177		0	0	14		0	0	0	86133	0	243670	19059056		
6502	141	40213160	1984-06-05	1984-06-05 00:00:00	1984-06-05	1984-06-05 00:00:00	1984-06-05	581452		0	0	0		0	0	0	9431	0	10	40213160		
162670	3577	40213260	2011-02-28	2011-02-28 00:00:00	2011-02-28	2011-02-28 00:00:00	2011-02-28	581452		0	0	0		0	0	0	237809	0	121	40213260		
183511	4032	40213227	1998-06-23	1998-06-23 00:00:00	1998-06-23	1998-06-23 00:00:00	1998-06-23	581452		0	0	0		0	0	0	268256	0	113	40213227		
147782	3249	40213227	2018-09-16	2018-09-16 00:00:00	2018-09-16	2018-09-16 00:00:00	2018-09-16	581452		0	0	0		0	0	0	215986	0	113	40213227		
45243	3745	1551192	1931-03-07	1931-03-07 00:00:00	1931-03-07	1931-03-07 00:00:00	1931-03-07	38000177		0	0	0		0	0	0	248872	0	312617	1551192		
45309	3750	1127433	2012-01-11	2012-01-11 00:00:00	2012-03-11	2012-03-11 00:00:00	2012-03-11	38000177		0	0	60		0	0	0	249242	0	313782	1127433		
55436	4603	1713671	1990-08-18	1990-08-18 00:00:00	1990-08-25	1990-08-25 00:00:00	1990-08-25	38000177		0	0	7		0	0	0	306663	0	562251	1713671		
16819	1391	1127433	1954-01-25	1954-01-25 00:00:00	1954-02-01	1954-02-01 00:00:00	1954-02-01	38000177		0	0	7		0	0	0	92322	0	313782	1127433		
55658	4622	1127433	1996-01-15	1996-01-15 00:00:00	1996-01-29	1996-01-29 00:00:00	1996-01-29	38000177		0	0	14		0	0	0	307807	0	313782	1127433		
28319	2337	19078461	1990-02-22	1990-02-22 00:00:00	1990-03-15	1990-03-15 00:00:00	1990-03-15	38000177		0	0	21		0	0	0	155539	0	310965	19078461		
28346	2339	40165015	1984-12-17	1984-12-17 00:00:00	1984-12-17	1984-12-17 00:00:00	\N	38000177		0	0	0		0	0	0	155678	0	861467	40165015		
30140	2498	1127433	1986-10-17	1986-10-17 00:00:00	1986-11-14	1986-11-14 00:00:00	1986-11-14	38000177		0	0	28		0	0	0	165402	0	313782	1127433		
21538	1770	920300	2010-07-11	2010-07-11 00:00:00	2010-07-18	2010-07-18 00:00:00	2010-07-18	38000177		0	0	7		0	0	0	118361	0	311989	920300		
39071	3229	1118084	2019-04-14	2019-04-14 00:00:00	2019-04-14	2019-04-14 00:00:00	\N	38000177		0	0	0		0	0	0	214629	0	00025152531	44923712		
38980	3222	40220960	2012-10-30	2012-10-30 00:00:00	2012-10-30	2012-10-30 00:00:00	2012-10-30	38000177		0	0	0		0	0	0	214201	0	1804799	40220960		
58228	4837	46275916	2004-03-23	2004-03-23 00:00:00	2004-03-23	2004-03-23 00:00:00	2004-03-23	38000177		0	0	0		0	0	0	321870	0	1660014	46275916		
3601	298	1713671	2010-11-07	2010-11-07 00:00:00	2010-11-28	2010-11-28 00:00:00	2010-11-28	38000177		0	0	21		0	0	0	19921	0	562251	1713671		
49589	4113	1127078	1969-03-31	1969-03-31 00:00:00	1969-04-30	1969-04-30 00:00:00	1969-04-30	38000177		0	0	30		0	0	0	273386	0	282464	1127078		
171548	3771	40213160	1969-01-07	1969-01-07 00:00:00	1969-01-07	1969-01-07 00:00:00	1969-01-07	581452		0	0	0		0	0	0	250636	0	10	40213160		
39661	3279	19006318	1957-11-28	1957-11-28 00:00:00	1957-12-12	1957-12-12 00:00:00	1957-12-12	38000177		0	0	14		0	0	0	217870	0	105078	19006318		
190042	4173	40213227	2005-12-14	2005-12-14 00:00:00	2005-12-14	2005-12-14 00:00:00	2005-12-14	581452		0	0	0		0	0	0	277380	0	113	40213227		
50218	4167	1713671	1988-08-24	1988-08-24 00:00:00	1988-09-14	1988-09-14 00:00:00	1988-09-14	38000177		0	0	21		0	0	0	276981	0	562251	1713671		
14396	1209	1127078	1980-03-09	1980-03-09 00:00:00	1980-03-23	1980-03-23 00:00:00	1980-03-23	38000177		0	0	14		0	0	0	79445	0	282464	1127078		
48428	4013	1127433	2008-11-10	2008-11-10 00:00:00	2008-11-17	2008-11-17 00:00:00	2008-11-17	38000177		0	0	7		0	0	0	266664	0	313782	1127433		
175548	3859	40213227	1994-07-23	1994-07-23 00:00:00	1994-07-23	1994-07-23 00:00:00	1994-07-23	581452		0	0	0		0	0	0	256171	0	113	40213227		
3024	66	40213160	1958-10-03	1958-10-03 00:00:00	1958-10-03	1958-10-03 00:00:00	1958-10-03	581452		0	0	0		0	0	0	4485	0	10	40213160		
48120	1053	40213296	2018-02-02	2018-02-02 00:00:00	2018-02-02	2018-02-02 00:00:00	2018-02-02	581452		0	0	0		0	0	0	69021	0	52	40213296		
13585	1137	1127433	1988-10-09	1988-10-09 00:00:00	1988-11-06	1988-11-06 00:00:00	1988-11-06	38000177		0	0	28		0	0	0	74934	0	313782	1127433		
69011	1510	40213260	2009-11-08	2009-11-08 00:00:00	2009-11-08	2009-11-08 00:00:00	2009-11-08	581452		0	0	0		0	0	0	100838	0	121	40213260		
199728	4387	40213160	1965-04-30	1965-04-30 00:00:00	1965-04-30	1965-04-30 00:00:00	1965-04-30	581452		0	0	0		0	0	0	291592	0	10	40213160		
5603	469	1713671	1990-04-18	1990-04-18 00:00:00	1990-04-25	1990-04-25 00:00:00	1990-04-25	38000177		0	0	7		0	0	0	31326	0	562251	1713671		
50445	4191	19128065	1975-07-23	1975-07-23 00:00:00	1976-07-17	1976-07-17 00:00:00	1976-07-17	38000177		0	0	360		0	0	0	278176	0	749882	19128065		
17308	1435	1127433	1967-12-16	1967-12-16 00:00:00	1967-12-30	1967-12-30 00:00:00	1967-12-30	38000177		0	0	14		0	0	0	95558	0	313782	1127433		
130445	2866	40213160	1967-01-15	1967-01-15 00:00:00	1967-01-15	1967-01-15 00:00:00	1967-01-15	581452		0	0	0		0	0	0	190684	0	10	40213160		
134443	2951	40213160	1959-04-26	1959-04-26 00:00:00	1959-04-26	1959-04-26 00:00:00	1959-04-26	581452		0	0	0		0	0	0	197001	0	10	40213160		
134758	2957	40213201	2014-03-08	2014-03-08 00:00:00	2014-03-08	2014-03-08 00:00:00	2014-03-08	581452		0	0	0		0	0	0	197380	0	33	40213201		
57902	4811	1713671	1968-02-07	1968-02-07 00:00:00	1968-02-14	1968-02-14 00:00:00	1968-02-14	38000177		0	0	7		0	0	0	320065	0	562251	1713671		
109725	2411	40213227	1995-09-14	1995-09-14 00:00:00	1995-09-14	1995-09-14 00:00:00	1995-09-14	581452		0	0	0		0	0	0	160010	0	113	40213227		
38526	3181	1127078	1951-10-14	1951-10-14 00:00:00	1951-10-28	1951-10-28 00:00:00	1951-10-28	38000177		0	0	14		0	0	0	211776	0	282464	1127078		
146193	3215	40213314	1978-12-11	1978-12-11 00:00:00	1978-12-11	1978-12-11 00:00:00	1978-12-11	581452		0	0	0		0	0	0	213571	0	49	40213314		
227806	5001	40213296	2000-06-18	2000-06-18 00:00:00	2000-06-18	2000-06-18 00:00:00	2000-06-18	581452		0	0	0		0	0	0	\N	0	52	40213296		
38651	3194	40243436	1983-03-28	1983-03-28 00:00:00	1983-03-28	1983-03-28 00:00:00	1983-03-28	38000177		0	0	0		0	0	0	212460	0	1190795	40243436		
36063	787	40213227	2009-05-12	2009-05-12 00:00:00	2009-05-12	2009-05-12 00:00:00	2009-05-12	581452		0	0	0		0	0	0	52390	0	113	40213227		
8146	679	1118084	2009-02-12	2009-02-12 00:00:00	2009-02-12	2009-02-12 00:00:00	\N	38000177		0	0	0		0	0	0	44907	0	00025152531	44923712		
6970	587	19019979	1983-10-22	1983-10-22 00:00:00	1983-11-05	1983-11-05 00:00:00	1983-11-05	38000177		0	0	14		0	0	0	38867	0	198405	19019979		
182829	4017	40213227	2002-05-02	2002-05-02 00:00:00	2002-05-02	2002-05-02 00:00:00	2002-05-02	581452		0	0	0		0	0	0	266930	0	113	40213227		
51254	1122	40213160	1970-07-27	1970-07-27 00:00:00	1970-07-27	1970-07-27 00:00:00	1970-07-27	581452		0	0	0		0	0	0	73940	0	10	40213160		
71687	1568	40213160	1955-02-06	1955-02-06 00:00:00	1955-02-06	1955-02-06 00:00:00	1955-02-06	581452		0	0	0		0	0	0	105180	0	10	40213160		
122129	2684	40213160	1961-07-23	1961-07-23 00:00:00	1961-07-23	1961-07-23 00:00:00	1961-07-23	581452		0	0	0		0	0	0	177835	0	10	40213160		
51904	1136	40213160	1976-03-20	1976-03-20 00:00:00	1976-03-20	1976-03-20 00:00:00	1976-03-20	581452		0	0	0		0	0	0	74841	0	10	40213160		
31639	2622	40236824	1971-12-06	1971-12-06 00:00:00	1971-12-13	1971-12-13 00:00:00	1971-12-13	38000177		0	0	7		0	0	0	173476	0	1094107	40236824		
27712	2292	1127433	2009-01-16	2009-01-16 00:00:00	2009-01-30	2009-01-30 00:00:00	2009-01-30	38000177		0	0	14		0	0	0	152569	0	313782	1127433		
62407	1365	40213296	2005-09-01	2005-09-01 00:00:00	2005-09-01	2005-09-01 00:00:00	2005-09-01	581452		0	0	0		0	0	0	90519	0	52	40213296		
61098	5081	1127433	1975-01-30	1975-01-30 00:00:00	1975-02-20	1975-02-20 00:00:00	1975-02-20	38000177		0	0	21		0	0	0	337903	0	313782	1127433		
48806	4045	40229134	1988-02-25	1988-02-25 00:00:00	1988-03-03	1988-03-03 00:00:00	1988-03-03	38000177		0	0	7		0	0	0	269015	0	1043400	40229134		
161418	3552	40213227	2008-05-29	2008-05-29 00:00:00	2008-05-29	2008-05-29 00:00:00	2008-05-29	581452		0	0	0		0	0	0	235784	0	113	40213227		
52829	4390	1127433	2006-11-18	2006-11-18 00:00:00	2006-12-02	2006-12-02 00:00:00	2006-12-02	38000177		0	0	14		0	0	0	291921	0	313782	1127433		
15830	341	40213306	1982-09-13	1982-09-13 00:00:00	1982-09-13	1982-09-13 00:00:00	1982-09-13	581452		0	0	0		0	0	0	22745	0	43	40213306		
32682	2709	1713671	1958-03-27	1958-03-27 00:00:00	1958-04-10	1958-04-10 00:00:00	1958-04-10	38000177		0	0	14		0	0	0	179487	0	562251	1713671		
138956	3053	40213227	2004-03-13	2004-03-13 00:00:00	2004-03-13	2004-03-13 00:00:00	2004-03-13	581452		0	0	0		0	0	0	203136	0	113	40213227		
220946	4848	40213160	1955-08-21	1955-08-21 00:00:00	1955-08-21	1955-08-21 00:00:00	1955-08-21	581452		0	0	0		0	0	0	322506	0	10	40213160		
42966	3561	19059056	1979-04-29	1979-04-29 00:00:00	1979-05-20	1979-05-20 00:00:00	1979-05-20	38000177		0	0	21		0	0	0	236474	0	243670	19059056		
15622	1303	1118084	2012-03-05	2012-03-05 00:00:00	2012-03-05	2012-03-05 00:00:00	\N	38000177		0	0	0		0	0	0	86047	0	00025152531	44923712		
15646	1305	46233988	1967-01-07	1967-01-07 00:00:00	1967-01-21	1967-01-21 00:00:00	1967-01-21	38000177		0	0	14		0	0	0	86133	0	1652673	46233988		
37023	807	40213160	1955-12-27	1955-12-27 00:00:00	1955-12-27	1955-12-27 00:00:00	1955-12-27	581452		0	0	0		0	0	0	53617	0	10	40213160		
162672	3577	40213160	1961-11-06	1961-11-06 00:00:00	1961-11-06	1961-11-06 00:00:00	1961-11-06	581452		0	0	0		0	0	0	237805	0	10	40213160		
183528	4032	40213201	2013-08-06	2013-08-06 00:00:00	2013-08-06	2013-08-06 00:00:00	2013-08-06	581452		0	0	0		0	0	0	268289	0	33	40213201		
147791	3249	40213160	1958-03-23	1958-03-23 00:00:00	1958-03-23	1958-03-23 00:00:00	1958-03-23	581452		0	0	0		0	0	0	216019	0	10	40213160		
45244	3745	1127433	2003-12-03	2003-12-03 00:00:00	2003-12-17	2003-12-17 00:00:00	2003-12-17	38000177		0	0	14		0	0	0	248915	0	313782	1127433		
45310	3750	19059056	1960-12-18	1960-12-18 00:00:00	1961-01-01	1961-01-01 00:00:00	1961-01-01	38000177		0	0	14		0	0	0	249238	0	243670	19059056		
55437	4603	40229134	1962-05-10	1962-05-10 00:00:00	1962-05-24	1962-05-24 00:00:00	1962-05-24	38000177		0	0	14		0	0	0	306651	0	1043400	40229134		
16820	1391	19059056	1927-09-24	1927-09-24 00:00:00	1927-10-08	1927-10-08 00:00:00	1927-10-08	38000177		0	0	14		0	0	0	92327	0	243670	19059056		
55659	4622	19133873	1968-11-04	1968-11-04 00:00:00	1968-11-15	1968-11-15 00:00:00	1968-11-15	38000177		0	0	11		0	0	0	307814	0	834061	19133873		
28321	2337	1713671	2012-09-29	2012-09-29 00:00:00	2012-10-20	2012-10-20 00:00:00	2012-10-20	38000177		0	0	21		0	0	0	155538	0	562251	1713671		
28347	2339	1127433	1984-12-17	1984-12-17 00:00:00	1985-01-16	1985-01-16 00:00:00	1985-01-16	38000177		0	0	30		0	0	0	155678	0	313782	1127433		
30141	2498	19059056	1972-08-03	1972-08-03 00:00:00	1972-08-17	1972-08-17 00:00:00	1972-08-17	38000177		0	0	14		0	0	0	165400	0	243670	19059056		
21539	1770	1713671	2008-11-10	2008-11-10 00:00:00	2008-12-15	2008-12-15 00:00:00	2008-12-15	38000177		0	0	35		0	0	0	118344	0	562251	1713671		
39072	3230	19059056	1967-02-11	1967-02-11 00:00:00	1967-05-12	1967-05-12 00:00:00	1967-05-12	38000177		0	0	90		0	0	0	214644	0	243670	19059056		
38981	3222	19075601	2012-10-30	2012-10-30 00:00:00	2012-10-30	2012-10-30 00:00:00	2012-10-30	38000177		0	0	0		0	0	0	214201	0	309362	19075601		
58229	4837	19059056	1949-09-17	1949-09-17 00:00:00	1949-10-01	1949-10-01 00:00:00	1949-10-01	38000177		0	0	14		0	0	0	321867	0	243670	19059056		
3602	298	1115171	2010-06-18	2010-06-18 00:00:00	2010-07-02	2010-07-02 00:00:00	2010-07-02	38000177		0	0	14		0	0	0	19885	0	849574	1115171		
49590	4113	40231925	1997-01-24	1997-01-24 00:00:00	1997-01-24	1997-01-24 00:00:00	\N	38000177		0	0	0		0	0	0	273393	0	1049221	40231925		
171558	3772	40213306	1991-04-20	1991-04-20 00:00:00	1991-04-20	1991-04-20 00:00:00	1991-04-20	581452		0	0	0		0	0	0	250724	0	43	40213306		
39662	3280	40169281	2017-12-14	2017-12-14 00:00:00	2017-12-14	2017-12-14 00:00:00	\N	38000177		0	0	0		0	0	0	217994	0	896209	40169281		
190043	4173	40213296	2005-12-14	2005-12-14 00:00:00	2005-12-14	2005-12-14 00:00:00	2005-12-14	581452		0	0	0		0	0	0	277380	0	52	40213296		
50219	4167	1127433	2002-01-13	2002-01-13 00:00:00	2002-01-20	2002-01-20 00:00:00	2002-01-20	38000177		0	0	7		0	0	0	276925	0	313782	1127433		
14397	1209	19073183	1980-03-09	1980-03-09 00:00:00	1980-03-23	1980-03-23 00:00:00	1980-03-23	38000177		0	0	14		0	0	0	79445	0	308182	19073183		
48429	4014	1713671	1993-11-27	1993-11-27 00:00:00	1993-12-18	1993-12-18 00:00:00	1993-12-18	38000177		0	0	21		0	0	0	266783	0	562251	1713671		
175571	3860	40213160	1972-10-14	1972-10-14 00:00:00	1972-10-14	1972-10-14 00:00:00	1972-10-14	581452		0	0	0		0	0	0	256291	0	10	40213160		
3026	67	40213306	1992-08-16	1992-08-16 00:00:00	1992-08-16	1992-08-16 00:00:00	1992-08-16	581452		0	0	0		0	0	0	\N	0	43	40213306		
48127	1053	40213227	1998-01-09	1998-01-09 00:00:00	1998-01-09	1998-01-09 00:00:00	1998-01-09	581452		0	0	0		0	0	0	68997	0	113	40213227		
13586	1137	1127078	1957-01-06	1957-01-06 00:00:00	1957-04-06	1957-04-06 00:00:00	1957-04-06	38000177		0	0	90		0	0	0	74974	0	282464	1127078		
69014	1510	40213296	1998-11-08	1998-11-08 00:00:00	1998-11-08	1998-11-08 00:00:00	1998-11-08	581452		0	0	0		0	0	0	100854	0	52	40213296		
199730	4387	40213160	1965-01-29	1965-01-29 00:00:00	1965-01-29	1965-01-29 00:00:00	1965-01-29	581452		0	0	0		0	0	0	291572	0	10	40213160		
5604	469	40229134	1946-07-06	1946-07-06 00:00:00	1946-07-13	1946-07-13 00:00:00	1946-07-13	38000177		0	0	7		0	0	0	31273	0	1043400	40229134		
50446	4191	1713671	1959-04-07	1959-04-07 00:00:00	1959-05-19	1959-05-19 00:00:00	1959-05-19	38000177		0	0	42		0	0	0	278135	0	562251	1713671		
17309	1435	1713671	2010-09-03	2010-09-03 00:00:00	2010-09-24	2010-09-24 00:00:00	2010-09-24	38000177		0	0	21		0	0	0	95550	0	562251	1713671		
154537	3401	40213160	1963-07-28	1963-07-28 00:00:00	1963-07-28	1963-07-28 00:00:00	1963-07-28	581452		0	0	0		0	0	0	225585	0	10	40213160		
134455	2951	40213227	1993-06-13	1993-06-13 00:00:00	1993-06-13	1993-06-13 00:00:00	1993-06-13	581452		0	0	0		0	0	0	197025	0	113	40213227		
77868	1703	40213227	1993-02-24	1993-02-24 00:00:00	1993-02-24	1993-02-24 00:00:00	1993-02-24	581452		0	0	0		0	0	0	113943	0	113	40213227		
57903	4811	19059056	1965-12-26	1965-12-26 00:00:00	1966-03-26	1966-03-26 00:00:00	1966-03-26	38000177		0	0	90		0	0	0	320082	0	243670	19059056		
175693	3862	40213296	1996-02-07	1996-02-07 00:00:00	1996-02-07	1996-02-07 00:00:00	1996-02-07	581452		0	0	0		0	0	0	256445	0	52	40213296		
38527	3181	1127433	1982-04-25	1982-04-25 00:00:00	1982-05-16	1982-05-16 00:00:00	1982-05-16	38000177		0	0	21		0	0	0	211657	0	313782	1127433		
146198	3216	40213160	1955-03-01	1955-03-01 00:00:00	1955-03-01	1955-03-01 00:00:00	1955-03-01	581452		0	0	0		0	0	0	213718	0	10	40213160		
227810	5001	40213306	1981-10-25	1981-10-25 00:00:00	1981-10-25	1981-10-25 00:00:00	1981-10-25	581452		0	0	0		0	0	0	332679	0	43	40213306		
38652	3194	46275916	1983-03-28	1983-03-28 00:00:00	1983-03-28	1983-03-28 00:00:00	1983-03-28	38000177		0	0	0		0	0	0	212460	0	1660014	46275916		
36067	787	40213314	1977-09-06	1977-09-06 00:00:00	1977-09-06	1977-09-06 00:00:00	1977-09-06	581452		0	0	0		0	0	0	52369	0	49	40213314		
8147	679	40229134	2011-06-11	2011-06-11 00:00:00	2011-06-18	2011-06-18 00:00:00	2011-06-18	38000177		0	0	7		0	0	0	44940	0	1043400	40229134		
6971	587	19074843	1983-10-22	1983-10-22 00:00:00	1983-11-05	1983-11-05 00:00:00	1983-11-05	38000177		0	0	14		0	0	0	38867	0	309045	19074843		
182840	4018	40213160	1964-05-05	1964-05-05 00:00:00	1964-05-05	1964-05-05 00:00:00	1964-05-05	581452		0	0	0		0	0	0	267063	0	10	40213160		
169069	3718	40213160	1970-10-05	1970-10-05 00:00:00	1970-10-05	1970-10-05 00:00:00	1970-10-05	581452		0	0	0		0	0	0	247091	0	10	40213160		
71696	1568	40213296	1996-09-15	1996-09-15 00:00:00	1996-09-15	1996-09-15 00:00:00	1996-09-15	581452		0	0	0		0	0	0	105158	0	52	40213296		
122135	2684	40213306	1983-04-17	1983-04-17 00:00:00	1983-04-17	1983-04-17 00:00:00	1983-04-17	581452		0	0	0		0	0	0	177829	0	43	40213306		
51907	1136	40213227	2003-05-31	2003-05-31 00:00:00	2003-05-31	2003-05-31 00:00:00	2003-05-31	581452		0	0	0		0	0	0	\N	0	113	40213227		
31640	2622	920300	1982-02-23	1982-02-23 00:00:00	1982-03-02	1982-03-02 00:00:00	1982-03-02	38000177		0	0	7		0	0	0	173441	0	311989	920300		
27713	2292	19059056	1964-12-09	1964-12-09 00:00:00	1965-02-07	1965-02-07 00:00:00	1965-02-07	38000177		0	0	60		0	0	0	152594	0	243670	19059056		
62415	1365	40213160	1964-01-30	1964-01-30 00:00:00	1964-01-30	1964-01-30 00:00:00	1964-01-30	581452		0	0	0		0	0	0	90439	0	10	40213160		
61099	5081	40229134	1997-06-20	1997-06-20 00:00:00	1997-06-27	1997-06-27 00:00:00	1997-06-27	38000177		0	0	7		0	0	0	337860	0	1043400	40229134		
48807	4045	19006318	1974-08-15	1974-08-15 00:00:00	1974-08-29	1974-08-29 00:00:00	1974-08-29	38000177		0	0	14		0	0	0	268997	0	105078	19006318		
161419	3552	40213260	2008-05-29	2008-05-29 00:00:00	2008-05-29	2008-05-29 00:00:00	2008-05-29	581452		0	0	0		0	0	0	235784	0	121	40213260		
52830	4390	1127433	1973-02-13	1973-02-13 00:00:00	1973-03-06	1973-03-06 00:00:00	1973-03-06	38000177		0	0	21		0	0	0	291790	0	313782	1127433		
15835	341	40213160	1961-03-20	1961-03-20 00:00:00	1961-03-20	1961-03-20 00:00:00	1961-03-20	581452		0	0	0		0	0	0	22789	0	10	40213160		
32683	2709	1713671	2013-03-20	2013-03-20 00:00:00	2013-04-03	2013-04-03 00:00:00	2013-04-03	38000177		0	0	14		0	0	0	179490	0	562251	1713671		
138957	3053	40213306	2004-03-13	2004-03-13 00:00:00	2004-03-13	2004-03-13 00:00:00	2004-03-13	581452		0	0	0		0	0	0	203136	0	43	40213306		
220948	4848	40213160	1957-08-25	1957-08-25 00:00:00	1957-08-25	1957-08-25 00:00:00	1957-08-25	581452		0	0	0		0	0	0	322553	0	10	40213160		
42967	3561	19059056	1943-12-04	1943-12-04 00:00:00	1944-01-03	1944-01-03 00:00:00	1944-01-03	38000177		0	0	30		0	0	0	236470	0	243670	19059056		
15623	1303	19129655	1977-10-26	1977-10-26 00:00:00	1977-11-09	1977-11-09 00:00:00	1977-11-09	38000177		0	0	14		0	0	0	86038	0	789980	19129655		
15647	1305	1127078	1967-05-25	1967-05-25 00:00:00	1967-06-15	1967-06-15 00:00:00	1967-06-15	38000177		0	0	21		0	0	0	86107	0	282464	1127078		
37025	807	40213201	2017-03-07	2017-03-07 00:00:00	2017-03-07	2017-03-07 00:00:00	2017-03-07	581452		0	0	0		0	0	0	53592	0	33	40213201		
162676	3577	40213160	1961-06-05	1961-06-05 00:00:00	1961-06-05	1961-06-05 00:00:00	1961-06-05	581452		0	0	0		0	0	0	237775	0	10	40213160		
183532	4032	40213227	1992-04-07	1992-04-07 00:00:00	1992-04-07	1992-04-07 00:00:00	1992-04-07	581452		0	0	0		0	0	0	268255	0	113	40213227		
147796	3249	40213227	2008-07-20	2008-07-20 00:00:00	2008-07-20	2008-07-20 00:00:00	2008-07-20	581452		0	0	0		0	0	0	216003	0	113	40213227		
45245	3745	19059056	1930-06-10	1930-06-10 00:00:00	1930-06-24	1930-06-24 00:00:00	1930-06-24	38000177		0	0	14		0	0	0	248934	0	243670	19059056		
45311	3750	19006318	1960-12-18	1960-12-18 00:00:00	1961-01-01	1961-01-01 00:00:00	1961-01-01	38000177		0	0	14		0	0	0	249238	0	105078	19006318		
55438	4603	19078461	1982-04-17	1982-04-17 00:00:00	1982-05-01	1982-05-01 00:00:00	1982-05-01	38000177		0	0	14		0	0	0	306621	0	310965	19078461		
16821	1391	1713671	1980-10-09	1980-10-09 00:00:00	1980-10-30	1980-10-30 00:00:00	1980-10-30	38000177		0	0	21		0	0	0	92348	0	562251	1713671		
55660	4622	1127078	1957-09-17	1957-09-17 00:00:00	1957-10-01	1957-10-01 00:00:00	1957-10-01	38000177		0	0	14		0	0	0	307797	0	282464	1127078		
28322	2337	1127433	2016-09-11	2016-09-11 00:00:00	2016-09-18	2016-09-18 00:00:00	2016-09-18	38000177		0	0	7		0	0	0	155524	0	313782	1127433		
28348	2339	1713671	1988-02-24	1988-02-24 00:00:00	1988-03-09	1988-03-09 00:00:00	1988-03-09	38000177		0	0	14		0	0	0	155599	0	562251	1713671		
30142	2498	46233988	1976-05-31	1976-05-31 00:00:00	1976-06-14	1976-06-14 00:00:00	1976-06-14	38000177		0	0	14		0	0	0	165409	0	1652673	46233988		
21540	1770	1713671	1996-07-15	1996-07-15 00:00:00	1996-07-29	1996-07-29 00:00:00	1996-07-29	38000177		0	0	14		0	0	0	118339	0	562251	1713671		
39073	3230	19059056	1962-09-07	1962-09-07 00:00:00	1962-10-05	1962-10-05 00:00:00	1962-10-05	38000177		0	0	28		0	0	0	214643	0	243670	19059056		
38982	3222	19006318	1952-01-27	1952-01-27 00:00:00	1952-02-10	1952-02-10 00:00:00	1952-02-10	38000177		0	0	14		0	0	0	214178	0	105078	19006318		
58230	4837	19006318	1949-09-17	1949-09-17 00:00:00	1949-10-01	1949-10-01 00:00:00	1949-10-01	38000177		0	0	14		0	0	0	321867	0	105078	19006318		
3603	298	1115171	2000-12-16	2000-12-16 00:00:00	2001-01-06	2001-01-06 00:00:00	2001-01-06	38000177		0	0	21		0	0	0	19884	0	849574	1115171		
49591	4113	1127078	1964-06-04	1964-06-04 00:00:00	1964-06-25	1964-06-25 00:00:00	1964-06-25	38000177		0	0	21		0	0	0	273385	0	282464	1127078		
171562	3772	40213160	1969-05-24	1969-05-24 00:00:00	1969-05-24	1969-05-24 00:00:00	1969-05-24	581452		0	0	0		0	0	0	250766	0	10	40213160		
39663	3280	1127433	1974-02-15	1974-02-15 00:00:00	1974-03-01	1974-03-01 00:00:00	1974-03-01	38000177		0	0	14		0	0	0	218042	0	313782	1127433		
190048	4173	40213306	1986-01-15	1986-01-15 00:00:00	1986-01-15	1986-01-15 00:00:00	1986-01-15	581452		0	0	0		0	0	0	277379	0	43	40213306		
50220	4167	19112599	1979-06-28	1979-06-28 00:00:00	1979-06-28	1979-06-28 00:00:00	\N	38000177		0	0	0		0	0	0	276979	0	477045	19112599		
14398	1209	1118084	2014-01-17	2014-01-17 00:00:00	2014-01-17	2014-01-17 00:00:00	\N	38000177		0	0	0		0	0	0	79419	0	00025152531	44923712		
48430	4014	1713671	2008-12-22	2008-12-22 00:00:00	2009-01-12	2009-01-12 00:00:00	2009-01-12	38000177		0	0	21		0	0	0	266710	0	562251	1713671		
50048	1097	40213260	2019-03-28	2019-03-28 00:00:00	2019-03-28	2019-03-28 00:00:00	2019-03-28	581452		0	0	0		0	0	0	71996	0	121	40213260		
3028	67	40213227	1992-08-16	1992-08-16 00:00:00	1992-08-16	1992-08-16 00:00:00	1992-08-16	581452		0	0	0		0	0	0	\N	0	113	40213227		
48128	1053	40213306	1998-01-09	1998-01-09 00:00:00	1998-01-09	1998-01-09 00:00:00	1998-01-09	581452		0	0	0		0	0	0	68997	0	43	40213306		
13587	1137	1127433	1984-11-24	1984-11-24 00:00:00	1984-12-29	1984-12-29 00:00:00	1984-12-29	38000177		0	0	35		0	0	0	74978	0	313782	1127433		
69025	1510	40213160	1959-07-12	1959-07-12 00:00:00	1959-07-12	1959-07-12 00:00:00	1959-07-12	581452		0	0	0		0	0	0	100865	0	10	40213160		
199735	4387	40213260	2015-08-28	2015-08-28 00:00:00	2015-08-28	2015-08-28 00:00:00	2015-08-28	581452		0	0	0		0	0	0	291581	0	121	40213260		
5605	469	40236824	1976-01-06	1976-01-06 00:00:00	1976-01-13	1976-01-13 00:00:00	1976-01-13	38000177		0	0	7		0	0	0	31251	0	1094107	40236824		
60923	5067	40229134	2006-11-18	2006-11-18 00:00:00	2006-12-02	2006-12-02 00:00:00	2006-12-02	38000177		0	0	14		0	0	0	336856	0	1043400	40229134		
17310	1435	40236824	1987-03-30	1987-03-30 00:00:00	1987-04-06	1987-04-06 00:00:00	1987-04-06	38000177		0	0	7		0	0	0	95559	0	1094107	40236824		
154539	3401	40213160	1959-03-01	1959-03-01 00:00:00	1959-03-01	1959-03-01 00:00:00	1959-03-01	581452		0	0	0		0	0	0	225650	0	10	40213160		
134457	2951	40213160	1959-02-22	1959-02-22 00:00:00	1959-02-22	1959-02-22 00:00:00	1959-02-22	581452		0	0	0		0	0	0	197060	0	10	40213160		
200251	4398	40213160	1959-09-26	1959-09-26 00:00:00	1959-09-26	1959-09-26 00:00:00	1959-09-26	581452		0	0	0		0	0	0	292393	0	10	40213160		
57904	4811	1713671	1964-10-08	1964-10-08 00:00:00	1964-10-28	1964-10-28 00:00:00	1964-10-28	38000177		0	0	20		0	0	0	320064	0	562251	1713671		
175696	3862	40213160	1961-01-11	1961-01-11 00:00:00	1961-01-11	1961-01-11 00:00:00	1961-01-11	581452		0	0	0		0	0	0	256405	0	10	40213160		
38528	3181	40229134	1994-12-27	1994-12-27 00:00:00	1995-01-10	1995-01-10 00:00:00	1995-01-10	38000177		0	0	14		0	0	0	211676	0	1043400	40229134		
146199	3216	40213160	1959-06-02	1959-06-02 00:00:00	1959-06-02	1959-06-02 00:00:00	1959-06-02	581452		0	0	0		0	0	0	213695	0	10	40213160		
227815	5002	40213314	1977-03-18	1977-03-18 00:00:00	1977-03-18	1977-03-18 00:00:00	1977-03-18	581452		0	0	0		0	0	0	332734	0	49	40213314		
38653	3194	1310034	1983-03-28	1983-03-28 00:00:00	1983-03-28	1983-03-28 00:00:00	1983-03-28	38000177		0	0	0		0	0	0	212460	0	834357	1310034		
36071	787	40213160	1976-01-06	1976-01-06 00:00:00	1976-01-06	1976-01-06 00:00:00	1976-01-06	581452		0	0	0		0	0	0	52350	0	10	40213160		
8148	679	1127433	1996-08-01	1996-08-01 00:00:00	1996-08-15	1996-08-15 00:00:00	1996-08-15	38000177		0	0	14		0	0	0	44939	0	313782	1127433		
6972	587	19128065	1998-02-15	1998-02-15 00:00:00	1999-02-10	1999-02-10 00:00:00	1999-02-10	38000177		0	0	360		0	0	0	38892	0	749882	19128065		
182846	4018	40213296	2004-06-01	2004-06-01 00:00:00	2004-06-01	2004-06-01 00:00:00	2004-06-01	581452		0	0	0		0	0	0	267099	0	52	40213296		
169072	3718	40213306	1989-08-07	1989-08-07 00:00:00	1989-08-07	1989-08-07 00:00:00	1989-08-07	581452		0	0	0		0	0	0	247119	0	43	40213306		
71699	1568	40213160	1956-02-05	1956-02-05 00:00:00	1956-02-05	1956-02-05 00:00:00	1956-02-05	581452		0	0	0		0	0	0	105174	0	10	40213160		
122140	2684	40213296	2004-05-23	2004-05-23 00:00:00	2004-05-23	2004-05-23 00:00:00	2004-05-23	581452		0	0	0		0	0	0	177874	0	52	40213296		
63190	1382	40213314	1978-07-05	1978-07-05 00:00:00	1978-07-05	1978-07-05 00:00:00	1978-07-05	581452		0	0	0		0	0	0	91627	0	49	40213314		
31641	2622	40236824	1982-02-23	1982-02-23 00:00:00	1982-03-09	1982-03-09 00:00:00	1982-03-09	38000177		0	0	14		0	0	0	173441	0	1094107	40236824		
27714	2292	19006318	1966-08-31	1966-08-31 00:00:00	1966-09-14	1966-09-14 00:00:00	1966-09-14	38000177		0	0	14		0	0	0	152570	0	105078	19006318		
62418	1365	40213260	2014-04-17	2014-04-17 00:00:00	2014-04-17	2014-04-17 00:00:00	2014-04-17	581452		0	0	0		0	0	0	90452	0	121	40213260		
61100	5081	19059056	1939-03-21	1939-03-21 00:00:00	1939-04-04	1939-04-04 00:00:00	1939-04-04	38000177		0	0	14		0	0	0	337900	0	243670	19059056		
48808	4045	1127078	1974-08-15	1974-08-15 00:00:00	1974-08-29	1974-08-29 00:00:00	1974-08-29	38000177		0	0	14		0	0	0	268997	0	282464	1127078		
161422	3552	40213227	1998-04-30	1998-04-30 00:00:00	1998-04-30	1998-04-30 00:00:00	1998-04-30	581452		0	0	0		0	0	0	235819	0	113	40213227		
52831	4390	1127078	1963-07-28	1963-07-28 00:00:00	1963-08-11	1963-08-11 00:00:00	1963-08-11	38000177		0	0	14		0	0	0	291902	0	282464	1127078		
29729	2462	19075001	1997-09-29	1997-09-29 00:00:00	1997-11-03	1997-11-03 00:00:00	1997-11-03	38000177		0	0	35		0	0	0	163200	0	309097	19075001		
32684	2709	19133905	2008-03-14	2008-03-14 00:00:00	2008-03-21	2008-03-21 00:00:00	2008-03-21	38000177		0	0	7		0	0	0	179489	0	834102	19133905		
138966	3053	40213314	1983-03-19	1983-03-19 00:00:00	1983-03-19	1983-03-19 00:00:00	1983-03-19	581452		0	0	0		0	0	0	203111	0	49	40213314		
220952	4848	40213160	1955-02-20	1955-02-20 00:00:00	1955-02-20	1955-02-20 00:00:00	1955-02-20	581452		0	0	0		0	0	0	322514	0	10	40213160		
42968	3561	1115171	1997-09-12	1997-09-12 00:00:00	1997-09-26	1997-09-26 00:00:00	1997-09-26	38000177		0	0	14		0	0	0	236475	0	849574	1115171		
15624	1303	1127078	1977-10-26	1977-10-26 00:00:00	1977-11-09	1977-11-09 00:00:00	1977-11-09	38000177		0	0	14		0	0	0	86038	0	282464	1127078		
15648	1305	1127433	1976-05-02	1976-05-02 00:00:00	1976-05-16	1976-05-16 00:00:00	1976-05-16	38000177		0	0	14		0	0	0	86110	0	313782	1127433		
37028	807	40213227	2002-12-17	2002-12-17 00:00:00	2002-12-17	2002-12-17 00:00:00	2002-12-17	581452		0	0	0		0	0	0	53597	0	113	40213227		
162684	3577	40213160	1961-08-07	1961-08-07 00:00:00	1961-08-07	1961-08-07 00:00:00	1961-08-07	581452		0	0	0		0	0	0	237847	0	10	40213160		
183540	4032	40213198	2012-07-31	2012-07-31 00:00:00	2012-07-31	2012-07-31 00:00:00	2012-07-31	581452		0	0	0		0	0	0	268201	0	133	40213198		
147797	3249	40213260	2008-07-20	2008-07-20 00:00:00	2008-07-20	2008-07-20 00:00:00	2008-07-20	581452		0	0	0		0	0	0	216003	0	121	40213260		
45246	3745	40229134	1984-05-13	1984-05-13 00:00:00	1984-05-20	1984-05-20 00:00:00	1984-05-20	38000177		0	0	7		0	0	0	248956	0	1043400	40229134		
45312	3750	1127433	1977-08-22	1977-08-22 00:00:00	1977-09-05	1977-09-05 00:00:00	1977-09-05	38000177		0	0	14		0	0	0	249224	0	313782	1127433		
55439	4603	19133905	1970-05-17	1970-05-17 00:00:00	1970-05-30	1970-05-30 00:00:00	1970-05-30	38000177		0	0	13		0	0	0	306638	0	834102	19133905		
16822	1391	19133873	1936-02-09	1936-02-09 00:00:00	1936-02-18	1936-02-18 00:00:00	1936-02-18	38000177		0	0	9		0	0	0	92313	0	834061	19133873		
28235	2333	1154029	1978-05-19	1978-05-19 00:00:00	1978-05-19	1978-05-19 00:00:00	1978-05-19	38000177		0	0	0		0	0	0	155162	0	4337	1154029		
28323	2337	19133905	1998-12-05	1998-12-05 00:00:00	1998-12-17	1998-12-17 00:00:00	1998-12-17	38000177		0	0	12		0	0	0	155492	0	834102	19133905		
28349	2339	19112599	1977-09-11	1977-09-11 00:00:00	1977-09-11	1977-09-11 00:00:00	\N	38000177		0	0	0		0	0	0	155588	0	477045	19112599		
30143	2498	19059056	1976-05-31	1976-05-31 00:00:00	1976-06-14	1976-06-14 00:00:00	1976-06-14	38000177		0	0	14		0	0	0	165409	0	243670	19059056		
177660	3904	40213296	2019-02-28	2019-02-28 00:00:00	2019-02-28	2019-02-28 00:00:00	2019-02-28	581452		0	0	0		0	0	0	259609	0	52	40213296		
39074	3230	40229134	2018-04-02	2018-04-02 00:00:00	2018-04-16	2018-04-16 00:00:00	2018-04-16	38000177		0	0	14		0	0	0	214657	0	1043400	40229134		
38983	3222	19059056	1952-01-27	1952-01-27 00:00:00	1952-02-10	1952-02-10 00:00:00	1952-02-10	38000177		0	0	14		0	0	0	214178	0	243670	19059056		
58231	4837	1124300	1981-11-03	1981-11-03 00:00:00	1981-11-03	1981-11-03 00:00:00	\N	38000177		0	0	0		0	0	0	321863	0	00781178901	45011828		
3604	298	40229134	2004-11-11	2004-11-11 00:00:00	2004-11-18	2004-11-18 00:00:00	2004-11-18	38000177		0	0	7		0	0	0	19871	0	1043400	40229134		
49592	4113	1127433	1978-05-25	1978-05-25 00:00:00	1978-06-01	1978-06-01 00:00:00	1978-06-01	38000177		0	0	7		0	0	0	273456	0	313782	1127433		
171564	3772	40213160	1969-10-25	1969-10-25 00:00:00	1969-10-25	1969-10-25 00:00:00	1969-10-25	581452		0	0	0		0	0	0	250740	0	10	40213160		
39664	3280	19059056	1969-08-28	1969-08-28 00:00:00	1969-09-11	1969-09-11 00:00:00	1969-09-11	38000177		0	0	14		0	0	0	218037	0	243670	19059056		
190051	4173	40213260	2014-08-20	2014-08-20 00:00:00	2014-08-20	2014-08-20 00:00:00	2014-08-20	581452		0	0	0		0	0	0	277326	0	121	40213260		
50221	4167	40236446	1992-09-16	1992-09-16 00:00:00	1996-09-25	1996-09-25 00:00:00	1996-09-25	38000177		0	0	1470		0	0	0	276953	0	1091392	40236446		
14399	1209	1127078	1986-06-29	1986-06-29 00:00:00	1986-07-13	1986-07-13 00:00:00	1986-07-13	38000177		0	0	14		0	0	0	79425	0	282464	1127078		
17327	374	40213227	2002-05-09	2002-05-09 00:00:00	2002-05-09	2002-05-09 00:00:00	2002-05-09	581452		0	0	0		0	0	0	24809	0	113	40213227		
50049	1097	40213160	1969-07-03	1969-07-03 00:00:00	1969-07-03	1969-07-03 00:00:00	1969-07-03	581452		0	0	0		0	0	0	71974	0	10	40213160		
3031	67	40213160	1971-03-28	1971-03-28 00:00:00	1971-03-28	1971-03-28 00:00:00	1971-03-28	581452		0	0	0		0	0	0	4517	0	10	40213160		
48134	1053	40213160	1980-08-29	1980-08-29 00:00:00	1980-08-29	1980-08-29 00:00:00	1980-08-29	581452		0	0	0		0	0	0	69055	0	10	40213160		
13588	1137	1127433	2010-05-15	2010-05-15 00:00:00	2010-05-22	2010-05-22 00:00:00	2010-05-22	38000177		0	0	7		0	0	0	74886	0	313782	1127433		
69033	1510	40213227	1992-11-22	1992-11-22 00:00:00	1992-11-22	1992-11-22 00:00:00	1992-11-22	581452		0	0	0		0	0	0	100834	0	113	40213227		
199740	4387	40213227	2015-08-28	2015-08-28 00:00:00	2015-08-28	2015-08-28 00:00:00	2015-08-28	581452		0	0	0		0	0	0	291581	0	113	40213227		
5606	469	1118084	1977-02-02	1977-02-02 00:00:00	1977-02-02	1977-02-02 00:00:00	\N	38000177		0	0	0		0	0	0	31251	0	00025152531	44923712		
60924	5067	1127433	2002-04-27	2002-04-27 00:00:00	2002-05-11	2002-05-11 00:00:00	2002-05-11	38000177		0	0	14		0	0	0	336821	0	313782	1127433		
17311	1435	920300	1987-03-30	1987-03-30 00:00:00	1987-04-06	1987-04-06 00:00:00	1987-04-06	38000177		0	0	7		0	0	0	95559	0	311989	920300		
134640	2955	40213160	1970-04-14	1970-04-14 00:00:00	1970-04-14	1970-04-14 00:00:00	1970-04-14	581452		0	0	0		0	0	0	197253	0	10	40213160		
134458	2951	40213160	1963-09-01	1963-09-01 00:00:00	1963-09-01	1963-09-01 00:00:00	1963-09-01	581452		0	0	0		0	0	0	197063	0	10	40213160		
200262	4398	40213296	1999-04-24	1999-04-24 00:00:00	1999-04-24	1999-04-24 00:00:00	1999-04-24	581452		0	0	0		0	0	0	292425	0	52	40213296		
57905	4811	1127433	1994-03-13	1994-03-13 00:00:00	1994-04-18	1994-04-18 00:00:00	1994-04-18	38000177		0	0	36		0	0	0	320051	0	313782	1127433		
175699	3862	40213160	1956-07-11	1956-07-11 00:00:00	1956-07-11	1956-07-11 00:00:00	1956-07-11	581452		0	0	0		0	0	0	256382	0	10	40213160		
38529	3181	1115171	2001-05-27	2001-05-27 00:00:00	2001-06-17	2001-06-17 00:00:00	2001-06-17	38000177		0	0	21		0	0	0	211688	0	849574	1115171		
146210	3216	40213227	1996-07-02	1996-07-02 00:00:00	1996-07-02	1996-07-02 00:00:00	1996-07-02	581452		0	0	0		0	0	0	213761	0	113	40213227		
227818	5002	40213160	1981-03-20	1981-03-20 00:00:00	1981-03-20	1981-03-20 00:00:00	1981-03-20	581452		0	0	0		0	0	0	332731	0	10	40213160		
38654	3194	1127078	1954-05-04	1954-05-04 00:00:00	1954-05-18	1954-05-18 00:00:00	1954-05-18	38000177		0	0	14		0	0	0	212459	0	282464	1127078		
36073	787	40213227	1997-04-29	1997-04-29 00:00:00	1997-04-29	1997-04-29 00:00:00	1997-04-29	581452		0	0	0		0	0	0	52356	0	113	40213227		
8149	680	1713671	1994-11-07	1994-11-07 00:00:00	1994-11-21	1994-11-21 00:00:00	1994-11-21	38000177		0	0	14		0	0	0	45042	0	562251	1713671		
17431	1443	1127078	1981-06-03	1981-06-03 00:00:00	1981-06-17	1981-06-17 00:00:00	1981-06-17	38000177		0	0	14		0	0	0	96204	0	282464	1127078		
182849	4018	40213227	1996-05-21	1996-05-21 00:00:00	1996-05-21	1996-05-21 00:00:00	1996-05-21	581452		0	0	0		0	0	0	267083	0	113	40213227		
169081	3718	40213296	2005-10-31	2005-10-31 00:00:00	2005-10-31	2005-10-31 00:00:00	2005-10-31	581452		0	0	0		0	0	0	247126	0	52	40213296		
71704	1568	40213201	2018-12-02	2018-12-02 00:00:00	2018-12-02	2018-12-02 00:00:00	2018-12-02	581452		0	0	0		0	0	0	105217	0	33	40213201		
122142	2684	40213160	1961-05-21	1961-05-21 00:00:00	1961-05-21	1961-05-21 00:00:00	1961-05-21	581452		0	0	0		0	0	0	177863	0	10	40213160		
63194	1382	40213160	1982-04-07	1982-04-07 00:00:00	1982-04-07	1982-04-07 00:00:00	1982-04-07	581452		0	0	0		0	0	0	91618	0	10	40213160		
31642	2622	19133873	1945-06-15	1945-06-15 00:00:00	1945-06-28	1945-06-28 00:00:00	1945-06-28	38000177		0	0	13		0	0	0	173472	0	834061	19133873		
27715	2292	19059056	1966-08-31	1966-08-31 00:00:00	1966-09-14	1966-09-14 00:00:00	1966-09-14	38000177		0	0	14		0	0	0	152570	0	243670	19059056		
62428	1365	40213306	1986-02-27	1986-02-27 00:00:00	1986-02-27	1986-02-27 00:00:00	1986-02-27	581452		0	0	0		0	0	0	90447	0	43	40213306		
61101	5081	1127433	1915-12-28	1915-12-28 00:00:00	1916-01-04	1916-01-04 00:00:00	1916-01-04	38000177		0	0	7		0	0	0	337885	0	313782	1127433		
124213	2732	40213227	2000-10-19	2000-10-19 00:00:00	2000-10-19	2000-10-19 00:00:00	2000-10-19	581452		0	0	0		0	0	0	180908	0	113	40213227		
161423	3552	40213296	1998-04-30	1998-04-30 00:00:00	1998-04-30	1998-04-30 00:00:00	1998-04-30	581452		0	0	0		0	0	0	235819	0	52	40213296		
52832	4390	19129655	1963-07-28	1963-07-28 00:00:00	1963-08-11	1963-08-11 00:00:00	1963-08-11	38000177		0	0	14		0	0	0	291902	0	789980	19129655		
29730	2462	1127433	1989-09-19	1989-09-19 00:00:00	1989-10-03	1989-10-03 00:00:00	1989-10-03	38000177		0	0	14		0	0	0	163233	0	313782	1127433		
32685	2709	1713671	1975-04-04	1975-04-04 00:00:00	1975-04-25	1975-04-25 00:00:00	1975-04-25	38000177		0	0	21		0	0	0	179464	0	562251	1713671		
138971	3053	40213160	1982-04-17	1982-04-17 00:00:00	1982-04-17	1982-04-17 00:00:00	1982-04-17	581452		0	0	0		0	0	0	203130	0	10	40213160		
220956	4848	40213160	1956-02-19	1956-02-19 00:00:00	1956-02-19	1956-02-19 00:00:00	1956-02-19	581452		0	0	0		0	0	0	322570	0	10	40213160		
42969	3561	1127433	1977-07-15	1977-07-15 00:00:00	1977-07-22	1977-07-22 00:00:00	1977-07-22	38000177		0	0	7		0	0	0	236487	0	313782	1127433		
15625	1303	19133873	1976-08-23	1976-08-23 00:00:00	1976-09-03	1976-09-03 00:00:00	1976-09-03	38000177		0	0	11		0	0	0	86056	0	834061	19133873		
15649	1306	19078461	2019-04-11	2019-04-11 00:00:00	2019-05-11	2019-05-11 00:00:00	2019-05-11	38000177		0	0	30		0	0	0	86205	0	310965	19078461		
37036	807	40213227	2012-02-07	2012-02-07 00:00:00	2012-02-07	2012-02-07 00:00:00	2012-02-07	581452		0	0	0		0	0	0	53553	0	113	40213227		
162686	3577	40213160	1966-02-07	1966-02-07 00:00:00	1966-02-07	1966-02-07 00:00:00	1966-02-07	581452		0	0	0		0	0	0	237831	0	10	40213160		
183550	4032	40213227	2008-07-08	2008-07-08 00:00:00	2008-07-08	2008-07-08 00:00:00	2008-07-08	581452		0	0	0		0	0	0	268228	0	113	40213227		
243118	5337	40213227	2001-11-11	2001-11-11 00:00:00	2001-11-11	2001-11-11 00:00:00	2001-11-11	581452		0	0	0		0	0	0	355443	0	113	40213227		
45247	3745	19078461	2018-05-16	2018-05-16 00:00:00	2018-08-14	2018-08-14 00:00:00	2018-08-14	38000177		0	0	90		0	0	0	248880	0	310965	19078461		
45313	3750	19133905	1981-01-29	1981-01-29 00:00:00	1981-02-11	1981-02-11 00:00:00	1981-02-11	38000177		0	0	13		0	0	0	249226	0	834102	19133905		
55440	4604	40229134	1991-09-10	1991-09-10 00:00:00	1991-09-24	1991-09-24 00:00:00	1991-09-24	38000177		0	0	14		0	0	0	306748	0	1043400	40229134		
16823	1391	1115171	1999-04-14	1999-04-14 00:00:00	1999-04-28	1999-04-28 00:00:00	1999-04-28	38000177		0	0	14		0	0	0	92410	0	849574	1115171		
28236	2333	40231925	1978-05-20	1978-05-20 00:00:00	1978-05-20	1978-05-20 00:00:00	\N	38000177		0	0	0		0	0	0	155162	0	1049221	40231925		
28324	2337	1124300	2003-07-26	2003-07-26 00:00:00	2003-07-26	2003-07-26 00:00:00	\N	38000177		0	0	0		0	0	0	155502	0	00781178901	45011828		
28350	2340	40229134	1963-02-12	1963-02-12 00:00:00	1963-02-26	1963-02-26 00:00:00	1963-02-26	38000177		0	0	14		0	0	0	155764	0	1043400	40229134		
30144	2498	40165015	2018-08-26	2018-08-26 00:00:00	2018-08-26	2018-08-26 00:00:00	\N	38000177		0	0	0		0	0	0	165405	0	861467	40165015		
177665	3904	40213314	1980-05-01	1980-05-01 00:00:00	1980-05-01	1980-05-01 00:00:00	1980-05-01	581452		0	0	0		0	0	0	259600	0	49	40213314		
39075	3230	1127433	1993-03-05	1993-03-05 00:00:00	1993-03-19	1993-03-19 00:00:00	1993-03-19	38000177		0	0	14		0	0	0	214679	0	313782	1127433		
38984	3222	19059056	1956-04-19	1956-04-19 00:00:00	1956-05-03	1956-05-03 00:00:00	1956-05-03	38000177		0	0	14		0	0	0	214220	0	243670	19059056		
58232	4837	1127078	1954-07-16	1954-07-16 00:00:00	1954-07-30	1954-07-30 00:00:00	1954-07-30	38000177		0	0	14		0	0	0	321850	0	282464	1127078		
3605	298	1127433	1982-07-26	1982-07-26 00:00:00	1982-08-23	1982-08-23 00:00:00	1982-08-23	38000177		0	0	28		0	0	0	19883	0	313782	1127433		
49593	4113	1127433	2005-11-08	2005-11-08 00:00:00	2005-11-29	2005-11-29 00:00:00	2005-11-29	38000177		0	0	21		0	0	0	273389	0	313782	1127433		
171568	3772	40213227	2011-02-26	2011-02-26 00:00:00	2011-02-26	2011-02-26 00:00:00	2011-02-26	581452		0	0	0		0	0	0	250716	0	113	40213227		
39665	3280	19073188	2001-05-12	2001-05-12 00:00:00	2001-05-26	2001-05-26 00:00:00	2001-05-26	38000177		0	0	14		0	0	0	218045	0	308192	19073188		
14301	1201	1115171	1995-11-01	1995-11-01 00:00:00	1995-11-15	1995-11-15 00:00:00	1995-11-15	38000177		0	0	14		0	0	0	78981	0	849574	1115171		
50222	4167	19128022	1995-09-08	1995-09-08 00:00:00	1996-09-02	1996-09-02 00:00:00	1996-09-02	38000177		0	0	360		0	0	0	276989	0	749785	19128022		
14400	1209	19074843	1986-06-29	1986-06-29 00:00:00	1986-07-13	1986-07-13 00:00:00	1986-07-13	38000177		0	0	14		0	0	0	79425	0	309045	19074843		
17328	374	40213306	2002-05-09	2002-05-09 00:00:00	2002-05-09	2002-05-09 00:00:00	2002-05-09	581452		0	0	0		0	0	0	24809	0	43	40213306		
50050	1097	40213160	1974-03-07	1974-03-07 00:00:00	1974-03-07	1974-03-07 00:00:00	1974-03-07	581452		0	0	0		0	0	0	71978	0	10	40213160		
3040	67	40213160	1971-01-24	1971-01-24 00:00:00	1971-01-24	1971-01-24 00:00:00	1971-01-24	581452		0	0	0		0	0	0	4529	0	10	40213160		
48135	1053	40213314	1977-11-18	1977-11-18 00:00:00	1977-11-18	1977-11-18 00:00:00	1977-11-18	581452		0	0	0		0	0	0	69054	0	49	40213314		
13590	1137	19126352	1983-08-12	1983-08-12 00:00:00	1983-08-12	1983-08-12 00:00:00	\N	38000177		0	0	0		0	0	0	74923	0	705129	19126352		
171134	3761	40213160	1956-12-29	1956-12-29 00:00:00	1956-12-29	1956-12-29 00:00:00	1956-12-29	581452		0	0	0		0	0	0	250070	0	10	40213160		
199742	4387	40213306	1988-05-27	1988-05-27 00:00:00	1988-05-27	1988-05-27 00:00:00	1988-05-27	581452		0	0	0		0	0	0	291616	0	43	40213306		
5607	469	920300	1976-01-06	1976-01-06 00:00:00	1976-01-13	1976-01-13 00:00:00	1976-01-13	38000177		0	0	7		0	0	0	31251	0	311989	920300		
60925	5067	19128065	1991-05-14	1991-05-14 00:00:00	1992-05-08	1992-05-08 00:00:00	1992-05-08	38000177		0	0	360		0	0	0	336879	0	749882	19128065		
17312	1435	19078461	1994-02-09	1994-02-09 00:00:00	1994-02-23	1994-02-23 00:00:00	1994-02-23	38000177		0	0	14		0	0	0	95583	0	310965	19078461		
134649	2955	40213227	2001-01-23	2001-01-23 00:00:00	2001-01-23	2001-01-23 00:00:00	2001-01-23	581452		0	0	0		0	0	0	197221	0	113	40213227		
41113	895	40213227	2011-02-11	2011-02-11 00:00:00	2011-02-11	2011-02-11 00:00:00	2011-02-11	581452		0	0	0		0	0	0	59707	0	113	40213227		
200263	4398	40213160	1959-07-25	1959-07-25 00:00:00	1959-07-25	1959-07-25 00:00:00	1959-07-25	581452		0	0	0		0	0	0	292468	0	10	40213160		
57906	4811	40229134	2002-10-31	2002-10-31 00:00:00	2002-11-14	2002-11-14 00:00:00	2002-11-14	38000177		0	0	14		0	0	0	320076	0	1043400	40229134		
175703	3862	40213227	2017-04-05	2017-04-05 00:00:00	2017-04-05	2017-04-05 00:00:00	2017-04-05	581452		0	0	0		0	0	0	256449	0	113	40213227		
38530	3181	1127433	1977-11-06	1977-11-06 00:00:00	1977-11-20	1977-11-20 00:00:00	1977-11-20	38000177		0	0	14		0	0	0	211733	0	313782	1127433		
146211	3216	40213296	1996-07-02	1996-07-02 00:00:00	1996-07-02	1996-07-02 00:00:00	1996-07-02	581452		0	0	0		0	0	0	213761	0	52	40213296		
227822	5002	40213314	1977-06-17	1977-06-17 00:00:00	1977-06-17	1977-06-17 00:00:00	1977-06-17	581452		0	0	0		0	0	0	332728	0	49	40213314		
38655	3194	1127433	1980-11-29	1980-11-29 00:00:00	1980-12-06	1980-12-06 00:00:00	1980-12-06	38000177		0	0	7		0	0	0	212465	0	313782	1127433		
36074	787	40213306	1997-04-29	1997-04-29 00:00:00	1997-04-29	1997-04-29 00:00:00	1997-04-29	581452		0	0	0		0	0	0	52356	0	43	40213306		
8150	680	1127078	1969-08-23	1969-08-23 00:00:00	1969-09-06	1969-09-06 00:00:00	1969-09-06	38000177		0	0	14		0	0	0	45046	0	282464	1127078		
17432	1443	19078461	1993-07-19	1993-07-19 00:00:00	1993-08-23	1993-08-23 00:00:00	1993-08-23	38000177		0	0	35		0	0	0	96192	0	310965	19078461		
182851	4018	40213160	1964-08-04	1964-08-04 00:00:00	1964-08-04	1964-08-04 00:00:00	1964-08-04	581452		0	0	0		0	0	0	267070	0	10	40213160		
169086	3718	40213260	2016-10-31	2016-10-31 00:00:00	2016-10-31	2016-10-31 00:00:00	2016-10-31	581452		0	0	0		0	0	0	247148	0	121	40213260		
71708	1568	40213260	2006-09-24	2006-09-24 00:00:00	2006-09-24	2006-09-24 00:00:00	2006-09-24	581452		0	0	0		0	0	0	105196	0	121	40213260		
122145	2684	40213227	1994-05-08	1994-05-08 00:00:00	1994-05-08	1994-05-08 00:00:00	1994-05-08	581452		0	0	0		0	0	0	177853	0	113	40213227		
63202	1382	40213160	1978-01-04	1978-01-04 00:00:00	1978-01-04	1978-01-04 00:00:00	1978-01-04	581452		0	0	0		0	0	0	91648	0	10	40213160		
31643	2622	920334	1982-03-02	1982-03-02 00:00:00	1982-03-09	1982-03-09 00:00:00	1982-03-09	38000177		0	0	7		0	0	0	173489	0	311995	920334		
27716	2292	19133873	1971-03-27	1971-03-27 00:00:00	1971-04-04	1971-04-04 00:00:00	1971-04-04	38000177		0	0	8		0	0	0	152568	0	834061	19133873		
62436	1365	40213306	1985-10-24	1985-10-24 00:00:00	1985-10-24	1985-10-24 00:00:00	1985-10-24	581452		0	0	0		0	0	0	90473	0	43	40213306		
61102	5081	19078461	1989-08-10	1989-08-10 00:00:00	1989-09-09	1989-09-09 00:00:00	1989-09-09	38000177		0	0	30		0	0	0	337809	0	310965	19078461		
124225	2732	40213227	2011-08-18	2011-08-18 00:00:00	2011-08-18	2011-08-18 00:00:00	2011-08-18	581452		0	0	0		0	0	0	180839	0	113	40213227		
161439	3552	40213160	1957-02-21	1957-02-21 00:00:00	1957-02-21	1957-02-21 00:00:00	1957-02-21	581452		0	0	0		0	0	0	235775	0	10	40213160		
52833	4390	1127433	2001-05-29	2001-05-29 00:00:00	2001-07-03	2001-07-03 00:00:00	2001-07-03	38000177		0	0	35		0	0	0	291792	0	313782	1127433		
29731	2463	19059056	1970-03-06	1970-03-06 00:00:00	1970-06-04	1970-06-04 00:00:00	1970-06-04	38000177		0	0	90		0	0	0	163396	0	243670	19059056		
32686	2709	1127433	1984-03-03	1984-03-03 00:00:00	1984-06-01	1984-06-01 00:00:00	1984-06-01	38000177		0	0	90		0	0	0	179449	0	313782	1127433		
138972	3053	40213314	1982-04-17	1982-04-17 00:00:00	1982-04-17	1982-04-17 00:00:00	1982-04-17	581452		0	0	0		0	0	0	203130	0	49	40213314		
220959	4848	40213227	2003-09-21	2003-09-21 00:00:00	2003-09-21	2003-09-21 00:00:00	2003-09-21	581452		0	0	0		0	0	0	322546	0	113	40213227		
42970	3562	1127433	2005-11-06	2005-11-06 00:00:00	2005-11-27	2005-11-27 00:00:00	2005-11-27	38000177		0	0	21		0	0	0	236609	0	313782	1127433		
69148	1513	40213306	1991-04-28	1991-04-28 00:00:00	1991-04-28	1991-04-28 00:00:00	1991-04-28	581452		0	0	0		0	0	0	101100	0	43	40213306		
15650	1306	40231925	2019-04-11	2019-04-11 00:00:00	2019-04-11	2019-04-11 00:00:00	\N	38000177		0	0	0		0	0	0	86205	0	1049221	40231925		
48333	1057	40213227	2013-05-16	2013-05-16 00:00:00	2013-05-16	2013-05-16 00:00:00	2013-05-16	581452		0	0	0		0	0	0	69319	0	113	40213227		
162687	3577	40213296	2001-03-05	2001-03-05 00:00:00	2001-03-05	2001-03-05 00:00:00	2001-03-05	581452		0	0	0		0	0	0	237767	0	52	40213296		
78588	1719	40213260	2007-04-10	2007-04-10 00:00:00	2007-04-10	2007-04-10 00:00:00	2007-04-10	581452		0	0	0		0	0	0	114970	0	121	40213260		
243121	5337	40213160	1970-05-31	1970-05-31 00:00:00	1970-05-31	1970-05-31 00:00:00	1970-05-31	581452		0	0	0		0	0	0	355467	0	10	40213160		
45248	3745	1713671	1985-01-21	1985-01-21 00:00:00	1985-01-28	1985-01-28 00:00:00	1985-01-28	38000177		0	0	7		0	0	0	248919	0	562251	1713671		
45314	3750	19133905	2001-10-16	2001-10-16 00:00:00	2001-10-25	2001-10-25 00:00:00	2001-10-25	38000177		0	0	9		0	0	0	249228	0	834102	19133905		
55441	4604	1127433	2007-05-22	2007-05-22 00:00:00	2007-05-29	2007-05-29 00:00:00	2007-05-29	38000177		0	0	7		0	0	0	306763	0	313782	1127433		
16824	1391	19059056	1928-09-06	1928-09-06 00:00:00	1928-10-04	1928-10-04 00:00:00	1928-10-04	38000177		0	0	28		0	0	0	92390	0	243670	19059056		
28237	2333	35605858	1978-05-19	1978-05-19 00:00:00	1978-05-19	1978-05-19 00:00:00	1978-05-19	38000177		0	0	0		0	0	0	155162	0	1732136	35605858		
28326	2337	1127433	1993-09-08	1993-09-08 00:00:00	1993-09-15	1993-09-15 00:00:00	1993-09-15	38000177		0	0	7		0	0	0	155472	0	313782	1127433		
28351	2340	19059056	1966-07-26	1966-07-26 00:00:00	1966-10-24	1966-10-24 00:00:00	1966-10-24	38000177		0	0	90		0	0	0	155755	0	243670	19059056		
30145	2498	1115171	2018-08-26	2018-08-26 00:00:00	2018-09-25	2018-09-25 00:00:00	2018-09-25	38000177		0	0	30		0	0	0	165405	0	849574	1115171		
192498	4229	40213160	1956-06-02	1956-06-02 00:00:00	1956-06-02	1956-06-02 00:00:00	1956-06-02	581452		0	0	0		0	0	0	280896	0	10	40213160		
39076	3230	19059056	1961-08-22	1961-08-22 00:00:00	1961-09-12	1961-09-12 00:00:00	1961-09-12	38000177		0	0	21		0	0	0	214642	0	243670	19059056		
38985	3222	1127433	2011-01-03	2011-01-03 00:00:00	2011-01-10	2011-01-10 00:00:00	2011-01-10	38000177		0	0	7		0	0	0	214217	0	313782	1127433		
58233	4837	19059056	1963-02-06	1963-02-06 00:00:00	1963-02-20	1963-02-20 00:00:00	1963-02-20	38000177		0	0	14		0	0	0	321816	0	243670	19059056		
3606	298	1127433	1989-11-18	1989-11-18 00:00:00	1989-11-25	1989-11-25 00:00:00	1989-11-25	38000177		0	0	7		0	0	0	19918	0	313782	1127433		
49594	4113	19078461	1997-01-17	1997-01-17 00:00:00	1997-02-23	1997-02-23 00:00:00	1997-02-23	38000177		0	0	37		0	0	0	273388	0	310965	19078461		
171569	3772	40213296	2011-02-26	2011-02-26 00:00:00	2011-02-26	2011-02-26 00:00:00	2011-02-26	581452		0	0	0		0	0	0	250716	0	52	40213296		
39666	3280	1115171	2001-05-12	2001-05-12 00:00:00	2001-05-26	2001-05-26 00:00:00	2001-05-26	38000177		0	0	14		0	0	0	218045	0	849574	1115171		
14302	1201	1118084	2007-10-23	2007-10-23 00:00:00	2007-10-23	2007-10-23 00:00:00	\N	38000177		0	0	0		0	0	0	79006	0	00025152531	44923712		
50223	4167	19019979	1979-08-16	1979-08-16 00:00:00	1979-08-30	1979-08-30 00:00:00	1979-08-30	38000177		0	0	14		0	0	0	276928	0	198405	19019979		
14401	1209	1127078	1984-04-04	1984-04-04 00:00:00	1984-07-03	1984-07-03 00:00:00	1984-07-03	38000177		0	0	90		0	0	0	79456	0	282464	1127078		
17333	374	40213160	1980-07-17	1980-07-17 00:00:00	1980-07-17	1980-07-17 00:00:00	1980-07-17	581452		0	0	0		0	0	0	24803	0	10	40213160		
50054	1097	40213160	1969-09-04	1969-09-04 00:00:00	1969-09-04	1969-09-04 00:00:00	1969-09-04	581452		0	0	0		0	0	0	71971	0	10	40213160		
227324	4991	40213160	1976-04-24	1976-04-24 00:00:00	1976-04-24	1976-04-24 00:00:00	1976-04-24	581452		0	0	0		0	0	0	332047	0	10	40213160		
48137	1053	40213160	1976-07-09	1976-07-09 00:00:00	1976-07-09	1976-07-09 00:00:00	1976-07-09	581452		0	0	0		0	0	0	69031	0	10	40213160		
13591	1137	40222846	2009-02-10	2009-02-10 00:00:00	2009-02-10	2009-02-10 00:00:00	\N	38000177		0	0	0		0	0	0	74885	0	996740	40222846		
171137	3761	40213227	2017-06-24	2017-06-24 00:00:00	2017-06-24	2017-06-24 00:00:00	2017-06-24	581452		0	0	0		0	0	0	250113	0	113	40213227		
199747	4387	40213260	2014-08-22	2014-08-22 00:00:00	2014-08-22	2014-08-22 00:00:00	2014-08-22	581452		0	0	0		0	0	0	291584	0	121	40213260		
5608	469	40163554	2013-09-28	2013-09-28 00:00:00	2013-09-28	2013-09-28 00:00:00	\N	38000177		0	0	0		0	0	0	31312	0	855332	40163554		
60926	5067	1713671	1980-12-02	1980-12-02 00:00:00	1980-12-16	1980-12-16 00:00:00	1980-12-16	38000177		0	0	14		0	0	0	336851	0	562251	1713671		
17313	1435	1115171	1996-02-13	1996-02-13 00:00:00	1996-02-27	1996-02-27 00:00:00	1996-02-27	38000177		0	0	14		0	0	0	95584	0	849574	1115171		
134658	2955	40213160	1970-01-06	1970-01-06 00:00:00	1970-01-06	1970-01-06 00:00:00	1970-01-06	581452		0	0	0		0	0	0	197228	0	10	40213160		
41114	895	40213260	2011-02-11	2011-02-11 00:00:00	2011-02-11	2011-02-11 00:00:00	2011-02-11	581452		0	0	0		0	0	0	59707	0	121	40213260		
200265	4398	40213160	1959-12-26	1959-12-26 00:00:00	1959-12-26	1959-12-26 00:00:00	1959-12-26	581452		0	0	0		0	0	0	292456	0	10	40213160		
57907	4811	1127433	1979-01-27	1979-01-27 00:00:00	1979-02-10	1979-02-10 00:00:00	1979-02-10	38000177		0	0	14		0	0	0	320075	0	313782	1127433		
175708	3862	40213227	2007-02-07	2007-02-07 00:00:00	2007-02-07	2007-02-07 00:00:00	2007-02-07	581452		0	0	0		0	0	0	256422	0	113	40213227		
38531	3181	1115171	2018-11-15	2018-11-15 00:00:00	2019-02-13	2019-02-13 00:00:00	2019-02-13	38000177		0	0	90		0	0	0	211691	0	849574	1115171		
146212	3216	40213260	2007-07-10	2007-07-10 00:00:00	2007-07-10	2007-07-10 00:00:00	2007-07-10	581452		0	0	0		0	0	0	213729	0	121	40213260		
227828	5002	40213296	2016-04-15	2016-04-15 00:00:00	2016-04-15	2016-04-15 00:00:00	2016-04-15	581452		0	0	0		0	0	0	332702	0	52	40213296		
38656	3194	40229134	1968-01-02	1968-01-02 00:00:00	1968-01-09	1968-01-09 00:00:00	1968-01-09	38000177		0	0	7		0	0	0	212455	0	1043400	40229134		
36080	787	40213314	1977-03-08	1977-03-08 00:00:00	1977-03-08	1977-03-08 00:00:00	1977-03-08	581452		0	0	0		0	0	0	52377	0	49	40213314		
8151	680	19129655	1969-08-23	1969-08-23 00:00:00	1969-09-06	1969-09-06 00:00:00	1969-09-06	38000177		0	0	14		0	0	0	45046	0	789980	19129655		
17433	1443	1127078	1988-09-24	1988-09-24 00:00:00	1988-10-15	1988-10-15 00:00:00	1988-10-15	38000177		0	0	21		0	0	0	96190	0	282464	1127078		
182855	4018	40213160	1964-03-03	1964-03-03 00:00:00	1964-03-03	1964-03-03 00:00:00	1964-03-03	581452		0	0	0		0	0	0	267110	0	10	40213160		
169087	3718	40213227	2016-10-31	2016-10-31 00:00:00	2016-10-31	2016-10-31 00:00:00	2016-10-31	581452		0	0	0		0	0	0	247148	0	113	40213227		
71710	1568	40213160	1955-08-07	1955-08-07 00:00:00	1955-08-07	1955-08-07 00:00:00	1955-08-07	581452		0	0	0		0	0	0	105188	0	10	40213160		
195307	4289	40213198	2010-10-24	2010-10-24 00:00:00	2010-10-24	2010-10-24 00:00:00	2010-10-24	581452		0	0	0		0	0	0	284831	0	133	40213198		
63205	1382	40213314	1977-08-03	1977-08-03 00:00:00	1977-08-03	1977-08-03 00:00:00	1977-08-03	581452		0	0	0		0	0	0	91666	0	49	40213314		
31644	2622	1115171	1998-10-03	1998-10-03 00:00:00	1998-11-02	1998-11-02 00:00:00	1998-11-02	38000177		0	0	30		0	0	0	173404	0	849574	1115171		
27717	2292	1127433	1984-05-13	1984-05-13 00:00:00	1984-05-27	1984-05-27 00:00:00	1984-05-27	38000177		0	0	14		0	0	0	152565	0	313782	1127433		
62440	1365	40213296	2003-08-28	2003-08-28 00:00:00	2003-08-28	2003-08-28 00:00:00	2003-08-28	581452		0	0	0		0	0	0	90451	0	52	40213296		
61103	5081	40223774	2000-09-09	2000-09-09 00:00:00	2000-09-09	2000-09-09 00:00:00	\N	38000177		0	0	0		0	0	0	337834	0	998582	40223774		
124226	2732	40213296	2011-08-18	2011-08-18 00:00:00	2011-08-18	2011-08-18 00:00:00	2011-08-18	581452		0	0	0		0	0	0	180839	0	52	40213296		
161446	3552	40213160	1957-07-25	1957-07-25 00:00:00	1957-07-25	1957-07-25 00:00:00	1957-07-25	581452		0	0	0		0	0	0	235776	0	10	40213160		
52834	4390	19128065	1974-01-28	1974-01-28 00:00:00	1975-01-23	1975-01-23 00:00:00	1975-01-23	38000177		0	0	360		0	0	0	291903	0	749882	19128065		
29732	2463	1118084	2006-07-20	2006-07-20 00:00:00	2006-07-20	2006-07-20 00:00:00	\N	38000177		0	0	0		0	0	0	163346	0	00025152531	44923712		
32687	2709	1713671	1947-05-07	1947-05-07 00:00:00	1947-05-28	1947-05-28 00:00:00	1947-05-28	38000177		0	0	21		0	0	0	179441	0	562251	1713671		
138975	3053	40213227	2013-03-23	2013-03-23 00:00:00	2013-03-23	2013-03-23 00:00:00	2013-03-23	581452		0	0	0		0	0	0	203139	0	113	40213227		
220240	4834	40213160	1961-01-22	1961-01-22 00:00:00	1961-01-22	1961-01-22 00:00:00	1961-01-22	581452		0	0	0		0	0	0	321610	0	10	40213160		
42971	3562	1713671	1980-09-23	1980-09-23 00:00:00	1980-10-07	1980-10-07 00:00:00	1980-10-07	38000177		0	0	14		0	0	0	236615	0	562251	1713671		
69157	1513	40213160	1973-01-28	1973-01-28 00:00:00	1973-01-28	1973-01-28 00:00:00	1973-01-28	581452		0	0	0		0	0	0	101094	0	10	40213160		
15651	1306	19133873	1959-05-28	1959-05-28 00:00:00	1959-06-07	1959-06-07 00:00:00	1959-06-07	38000177		0	0	10		0	0	0	86238	0	834061	19133873		
48334	1057	40213260	2013-05-16	2013-05-16 00:00:00	2013-05-16	2013-05-16 00:00:00	2013-05-16	581452		0	0	0		0	0	0	69319	0	121	40213260		
162692	3577	40213227	1992-10-05	1992-10-05 00:00:00	1992-10-05	1992-10-05 00:00:00	1992-10-05	581452		0	0	0		0	0	0	237789	0	113	40213227		
78593	1719	40213227	2018-06-19	2018-06-19 00:00:00	2018-06-19	2018-06-19 00:00:00	2018-06-19	581452		0	0	0		0	0	0	114983	0	113	40213227		
243124	5337	40213227	1992-11-01	1992-11-01 00:00:00	1992-11-01	1992-11-01 00:00:00	1992-11-01	581452		0	0	0		0	0	0	355385	0	113	40213227		
45249	3745	1713671	1986-03-02	1986-03-02 00:00:00	1986-03-23	1986-03-23 00:00:00	1986-03-23	38000177		0	0	21		0	0	0	248920	0	562251	1713671		
45315	3750	19133873	1977-11-23	1977-11-23 00:00:00	1977-12-02	1977-12-02 00:00:00	1977-12-02	38000177		0	0	9		0	0	0	249225	0	834061	19133873		
55442	4604	19078461	2000-04-21	2000-04-21 00:00:00	2000-05-05	2000-05-05 00:00:00	2000-05-05	38000177		0	0	14		0	0	0	306760	0	310965	19078461		
16825	1391	19133873	1937-10-14	1937-10-14 00:00:00	1937-10-24	1937-10-24 00:00:00	1937-10-24	38000177		0	0	10		0	0	0	92318	0	834061	19133873		
28238	2333	19079524	1978-05-19	1978-05-19 00:00:00	1978-05-20	1978-05-20 00:00:00	1978-05-20	38000177		0	0	1		0	0	0	155162	0	313002	19079524		
113910	2503	40213227	2005-01-25	2005-01-25 00:00:00	2005-01-25	2005-01-25 00:00:00	2005-01-25	581452		0	0	0		0	0	0	165662	0	113	40213227		
28352	2340	1127078	1962-11-02	1962-11-02 00:00:00	1962-11-16	1962-11-16 00:00:00	1962-11-16	38000177		0	0	14		0	0	0	155747	0	282464	1127078		
30146	2498	1127433	1997-10-15	1997-10-15 00:00:00	1997-11-14	1997-11-14 00:00:00	1997-11-14	38000177		0	0	30		0	0	0	165404	0	313782	1127433		
192503	4229	40213201	2018-10-20	2018-10-20 00:00:00	2018-10-20	2018-10-20 00:00:00	2018-10-20	581452		0	0	0		0	0	0	280934	0	33	40213201		
39077	3230	19059056	1991-10-03	1991-10-03 00:00:00	1991-12-02	1991-12-02 00:00:00	1991-12-02	38000177		0	0	60		0	0	0	214645	0	243670	19059056		
38986	3222	1124300	1993-03-12	1993-03-12 00:00:00	1993-03-12	1993-03-12 00:00:00	\N	38000177		0	0	0		0	0	0	214208	0	00781178901	45011828		
58234	4837	40229134	2006-10-28	2006-10-28 00:00:00	2006-11-04	2006-11-04 00:00:00	2006-11-04	38000177		0	0	7		0	0	0	321824	0	1043400	40229134		
3607	298	1127433	2008-02-02	2008-02-02 00:00:00	2008-02-16	2008-02-16 00:00:00	2008-02-16	38000177		0	0	14		0	0	0	19920	0	313782	1127433		
49595	4113	1713671	1976-07-20	1976-07-20 00:00:00	1976-08-03	1976-08-03 00:00:00	1976-08-03	38000177		0	0	14		0	0	0	273428	0	562251	1713671		
139524	3065	40213306	1995-01-26	1995-01-26 00:00:00	1995-01-26	1995-01-26 00:00:00	1995-01-26	581452		0	0	0		0	0	0	204064	0	43	40213306		
39667	3280	19059056	1954-09-25	1954-09-25 00:00:00	1954-10-25	1954-10-25 00:00:00	1954-10-25	38000177		0	0	30		0	0	0	218034	0	243670	19059056		
14303	1201	1713671	1994-05-21	1994-05-21 00:00:00	1994-05-28	1994-05-28 00:00:00	1994-05-28	38000177		0	0	7		0	0	0	78983	0	562251	1713671		
50224	4167	19073183	1979-08-16	1979-08-16 00:00:00	1979-08-30	1979-08-30 00:00:00	1979-08-30	38000177		0	0	14		0	0	0	276928	0	308182	19073183		
14402	1209	19078461	1995-06-17	1995-06-17 00:00:00	1995-07-01	1995-07-01 00:00:00	1995-07-01	38000177		0	0	14		0	0	0	79437	0	310965	19078461		
17335	374	40213314	1980-02-14	1980-02-14 00:00:00	1980-02-14	1980-02-14 00:00:00	1980-02-14	581452		0	0	0		0	0	0	24802	0	49	40213314		
50058	1097	40213296	2009-04-02	2009-04-02 00:00:00	2009-04-02	2009-04-02 00:00:00	2009-04-02	581452		0	0	0		0	0	0	72023	0	52	40213296		
227327	4991	40213227	2013-07-20	2013-07-20 00:00:00	2013-07-20	2013-07-20 00:00:00	2013-07-20	581452		0	0	0		0	0	0	332045	0	113	40213227		
48142	1053	40213160	1976-08-20	1976-08-20 00:00:00	1976-08-20	1976-08-20 00:00:00	1976-08-20	581452		0	0	0		0	0	0	69013	0	10	40213160		
13592	1137	1332419	1995-09-29	1995-09-29 00:00:00	1995-09-29	1995-09-29 00:00:00	\N	38000177		0	0	0		0	0	0	74912	0	197361	1332419		
171139	3761	40213296	1996-06-22	1996-06-22 00:00:00	1996-06-22	1996-06-22 00:00:00	1996-06-22	581452		0	0	0		0	0	0	250091	0	52	40213296		
199748	4387	40213296	2005-06-17	2005-06-17 00:00:00	2005-06-17	2005-06-17 00:00:00	2005-06-17	581452		0	0	0		0	0	0	291579	0	52	40213296		
5609	469	19018935	2013-09-28	2013-09-28 00:00:00	2013-09-28	2013-09-28 00:00:00	\N	38000177		0	0	0		0	0	0	31312	0	197604	19018935		
60927	5067	40165015	1988-12-06	1988-12-06 00:00:00	1988-12-06	1988-12-06 00:00:00	\N	38000177		0	0	0		0	0	0	336817	0	861467	40165015		
17314	1435	1127433	2010-03-23	2010-03-23 00:00:00	2010-04-06	2010-04-06 00:00:00	2010-04-06	38000177		0	0	14		0	0	0	95587	0	313782	1127433		
134659	2955	40213160	1969-11-04	1969-11-04 00:00:00	1969-11-04	1969-11-04 00:00:00	1969-11-04	581452		0	0	0		0	0	0	197245	0	10	40213160		
41116	895	40213160	1960-05-13	1960-05-13 00:00:00	1960-05-13	1960-05-13 00:00:00	1960-05-13	581452		0	0	0		0	0	0	59677	0	10	40213160		
200273	4398	40213296	2001-04-28	2001-04-28 00:00:00	2001-04-28	2001-04-28 00:00:00	2001-04-28	581452		0	0	0		0	0	0	292412	0	52	40213296		
57908	4811	1127433	1992-04-09	1992-04-09 00:00:00	1992-04-23	1992-04-23 00:00:00	1992-04-23	38000177		0	0	14		0	0	0	320050	0	313782	1127433		
175710	3862	40213260	2007-02-07	2007-02-07 00:00:00	2007-02-07	2007-02-07 00:00:00	2007-02-07	581452		0	0	0		0	0	0	256422	0	121	40213260		
38532	3181	1713671	1989-12-10	1989-12-10 00:00:00	1989-12-31	1989-12-31 00:00:00	1989-12-31	38000177		0	0	21		0	0	0	211665	0	562251	1713671		
146215	3216	40213260	2006-07-04	2006-07-04 00:00:00	2006-07-04	2006-07-04 00:00:00	2006-07-04	581452		0	0	0		0	0	0	213752	0	121	40213260		
227835	5002	40213160	1976-09-17	1976-09-17 00:00:00	1976-09-17	1976-09-17 00:00:00	1976-09-17	581452		0	0	0		0	0	0	332727	0	10	40213160		
38657	3194	19133873	1957-02-27	1957-02-27 00:00:00	1957-03-09	1957-03-09 00:00:00	1957-03-09	38000177		0	0	10		0	0	0	212454	0	834061	19133873		
36084	787	40213160	1976-03-09	1976-03-09 00:00:00	1976-03-09	1976-03-09 00:00:00	1976-03-09	581452		0	0	0		0	0	0	52367	0	10	40213160		
8152	680	19133905	1991-06-20	1991-06-20 00:00:00	1991-07-01	1991-07-01 00:00:00	1991-07-01	38000177		0	0	11		0	0	0	45024	0	834102	19133905		
17434	1443	19078461	2001-05-13	2001-05-13 00:00:00	2001-06-03	2001-06-03 00:00:00	2001-06-03	38000177		0	0	21		0	0	0	96193	0	310965	19078461		
192304	4225	40213314	1979-07-12	1979-07-12 00:00:00	1979-07-12	1979-07-12 00:00:00	1979-07-12	581452		0	0	0		0	0	0	280624	0	49	40213314		
169091	3718	40213227	1997-02-17	1997-02-17 00:00:00	1997-02-17	1997-02-17 00:00:00	1997-02-17	581452		0	0	0		0	0	0	247123	0	113	40213227		
104558	2292	40213227	2015-02-13	2015-02-13 00:00:00	2015-02-13	2015-02-13 00:00:00	2015-02-13	581452		0	0	0		0	0	0	152580	0	113	40213227		
112263	2466	40213160	1980-03-01	1980-03-01 00:00:00	1980-03-01	1980-03-01 00:00:00	1980-03-01	581452		0	0	0		0	0	0	163492	0	10	40213160		
63206	1382	40213160	1977-08-03	1977-08-03 00:00:00	1977-08-03	1977-08-03 00:00:00	1977-08-03	581452		0	0	0		0	0	0	91666	0	10	40213160		
31645	2622	40165015	1998-10-03	1998-10-03 00:00:00	1998-10-03	1998-10-03 00:00:00	\N	38000177		0	0	0		0	0	0	173404	0	861467	40165015		
27718	2292	40169281	2013-02-01	2013-02-01 00:00:00	2013-02-01	2013-02-01 00:00:00	\N	38000177		0	0	0		0	0	0	152625	0	896209	40169281		
205217	4504	40213260	2017-04-01	2017-04-01 00:00:00	2017-04-01	2017-04-01 00:00:00	2017-04-01	581452		0	0	0		0	0	0	299962	0	121	40213260		
61104	5081	40243436	1935-05-17	1935-05-17 00:00:00	1935-05-17	1935-05-17 00:00:00	1935-05-17	38000177		0	0	0		0	0	0	337899	0	1190795	40243436		
135507	2975	40213160	1967-03-19	1967-03-19 00:00:00	1967-03-19	1967-03-19 00:00:00	1967-03-19	581452		0	0	0		0	0	0	198604	0	10	40213160		
161452	3552	40213296	2000-05-04	2000-05-04 00:00:00	2000-05-04	2000-05-04 00:00:00	2000-05-04	581452		0	0	0		0	0	0	235783	0	52	40213296		
52835	4390	19078461	2009-04-22	2009-04-22 00:00:00	2009-05-20	2009-05-20 00:00:00	2009-05-20	38000177		0	0	28		0	0	0	291937	0	310965	19078461		
29733	2463	1127433	2001-02-19	2001-02-19 00:00:00	2001-03-05	2001-03-05 00:00:00	2001-03-05	38000177		0	0	14		0	0	0	163345	0	313782	1127433		
32688	2709	1118084	1984-01-14	1984-01-14 00:00:00	1984-01-14	1984-01-14 00:00:00	\N	38000177		0	0	0		0	0	0	179546	0	00025152531	44923712		
138980	3053	40213160	1982-09-18	1982-09-18 00:00:00	1982-09-18	1982-09-18 00:00:00	1982-09-18	581452		0	0	0		0	0	0	203131	0	10	40213160		
220242	4834	40213296	2001-07-22	2001-07-22 00:00:00	2001-07-22	2001-07-22 00:00:00	2001-07-22	581452		0	0	0		0	0	0	321566	0	52	40213296		
42972	3562	1127433	1983-10-30	1983-10-30 00:00:00	1983-12-04	1983-12-04 00:00:00	1983-12-04	38000177		0	0	35		0	0	0	236607	0	313782	1127433		
69161	1513	40213260	2018-08-12	2018-08-12 00:00:00	2018-08-12	2018-08-12 00:00:00	2018-08-12	581452		0	0	0		0	0	0	101062	0	121	40213260		
15652	1306	1713671	1965-06-30	1965-06-30 00:00:00	1965-07-21	1965-07-21 00:00:00	1965-07-21	38000177		0	0	21		0	0	0	86167	0	562251	1713671		
48335	1057	40213296	2003-07-31	2003-07-31 00:00:00	2003-07-31	2003-07-31 00:00:00	2003-07-31	581452		0	0	0		0	0	0	69306	0	52	40213296		
162699	3578	40213296	2013-05-22	2013-05-22 00:00:00	2013-05-22	2013-05-22 00:00:00	2013-05-22	581452		0	0	0		0	0	0	237905	0	52	40213296		
78607	1719	40213160	1957-09-17	1957-09-17 00:00:00	1957-09-17	1957-09-17 00:00:00	1957-09-17	581452		0	0	0		0	0	0	114952	0	10	40213160		
243125	5337	40213306	1992-11-01	1992-11-01 00:00:00	1992-11-01	1992-11-01 00:00:00	1992-11-01	581452		0	0	0		0	0	0	355385	0	43	40213306		
45250	3745	19075001	2012-06-10	2012-06-10 00:00:00	2012-06-24	2012-06-24 00:00:00	2012-06-24	38000177		0	0	14		0	0	0	248916	0	309097	19075001		
45316	3750	1127433	1999-03-20	1999-03-20 00:00:00	1999-06-18	1999-06-18 00:00:00	1999-06-18	38000177		0	0	90		0	0	0	249241	0	313782	1127433		
55443	4604	1124300	2002-05-06	2002-05-06 00:00:00	2002-05-06	2002-05-06 00:00:00	\N	38000177		0	0	0		0	0	0	306749	0	00781178901	45011828		
16826	1391	1127433	1997-12-20	1997-12-20 00:00:00	1998-03-20	1998-03-20 00:00:00	1998-03-20	38000177		0	0	90		0	0	0	92409	0	313782	1127433		
28239	2333	35605482	1978-05-19	1978-05-19 00:00:00	1978-05-19	1978-05-19 00:00:00	1978-05-19	38000177		0	0	0		0	0	0	155162	0	1740467	35605482		
8990	752	1118084	1991-03-19	1991-03-19 00:00:00	1991-03-19	1991-03-19 00:00:00	\N	38000177		0	0	0		0	0	0	49714	0	00025152531	44923712		
28353	2340	19129655	1962-11-02	1962-11-02 00:00:00	1962-11-16	1962-11-16 00:00:00	1962-11-16	38000177		0	0	14		0	0	0	155747	0	789980	19129655		
79762	1745	40213227	2001-03-19	2001-03-19 00:00:00	2001-03-19	2001-03-19 00:00:00	2001-03-19	581452		0	0	0		0	0	0	116685	0	113	40213227		
192504	4229	40213227	2013-09-21	2013-09-21 00:00:00	2013-09-21	2013-09-21 00:00:00	2013-09-21	581452		0	0	0		0	0	0	280916	0	113	40213227		
39078	3230	1713671	2000-07-16	2000-07-16 00:00:00	2000-08-06	2000-08-06 00:00:00	2000-08-06	38000177		0	0	21		0	0	0	214671	0	562251	1713671		
38987	3222	1713671	1996-06-21	1996-06-21 00:00:00	1996-09-27	1996-09-27 00:00:00	1996-09-27	38000177		0	0	98		0	0	0	214162	0	562251	1713671		
107038	2346	40213227	2017-06-07	2017-06-07 00:00:00	2017-06-07	2017-06-07 00:00:00	2017-06-07	581452		0	0	0		0	0	0	156140	0	113	40213227		
3608	298	1127433	1967-02-24	1967-02-24 00:00:00	1967-03-10	1967-03-10 00:00:00	1967-03-10	38000177		0	0	14		0	0	0	19894	0	313782	1127433		
49596	4113	1127433	1958-07-08	1958-07-08 00:00:00	1958-07-15	1958-07-15 00:00:00	1958-07-15	38000177		0	0	7		0	0	0	273454	0	313782	1127433		
139527	3065	40213227	1995-01-26	1995-01-26 00:00:00	1995-01-26	1995-01-26 00:00:00	1995-01-26	581452		0	0	0		0	0	0	204064	0	113	40213227		
39668	3280	1713671	1971-07-04	1971-07-04 00:00:00	1971-07-18	1971-07-18 00:00:00	1971-07-18	38000177		0	0	14		0	0	0	218032	0	562251	1713671		
14304	1201	1127078	1979-03-09	1979-03-09 00:00:00	1979-03-30	1979-03-30 00:00:00	1979-03-30	38000177		0	0	21		0	0	0	78980	0	282464	1127078		
50225	4167	1127433	1992-12-06	1992-12-06 00:00:00	1992-12-13	1992-12-13 00:00:00	1992-12-13	38000177		0	0	7		0	0	0	276939	0	313782	1127433		
14403	1209	1127078	1978-01-06	1978-01-06 00:00:00	1978-01-20	1978-01-20 00:00:00	1978-01-20	38000177		0	0	14		0	0	0	79435	0	282464	1127078		
17336	374	40213160	1980-02-14	1980-02-14 00:00:00	1980-02-14	1980-02-14 00:00:00	1980-02-14	581452		0	0	0		0	0	0	24802	0	10	40213160		
50065	1097	40213227	2011-04-07	2011-04-07 00:00:00	2011-04-07	2011-04-07 00:00:00	2011-04-07	581452		0	0	0		0	0	0	72003	0	113	40213227		
227328	4991	40213296	2013-07-20	2013-07-20 00:00:00	2013-07-20	2013-07-20 00:00:00	2013-07-20	581452		0	0	0		0	0	0	332045	0	52	40213296		
50116	1098	40213296	1997-07-12	1997-07-12 00:00:00	1997-07-12	1997-07-12 00:00:00	1997-07-12	581452		0	0	0		0	0	0	72061	0	52	40213296		
13593	1137	1127433	1989-10-02	1989-10-02 00:00:00	1989-10-23	1989-10-23 00:00:00	1989-10-23	38000177		0	0	21		0	0	0	74935	0	313782	1127433		
223501	4907	40213227	2017-05-20	2017-05-20 00:00:00	2017-05-20	2017-05-20 00:00:00	2017-05-20	581452		0	0	0		0	0	0	326119	0	113	40213227		
199752	4387	40213227	2007-06-22	2007-06-22 00:00:00	2007-06-22	2007-06-22 00:00:00	2007-06-22	581452		0	0	0		0	0	0	291617	0	113	40213227		
5610	469	40171902	2013-09-28	2013-09-28 00:00:00	2013-09-28	2013-09-28 00:00:00	\N	38000177		0	0	0		0	0	0	31312	0	897718	40171902		
60928	5067	19078461	1988-12-06	1988-12-06 00:00:00	1989-02-04	1989-02-04 00:00:00	1989-02-04	38000177		0	0	60		0	0	0	336817	0	310965	19078461		
17315	1435	1713671	1996-05-14	1996-05-14 00:00:00	1996-06-04	1996-06-04 00:00:00	1996-06-04	38000177		0	0	21		0	0	0	95560	0	562251	1713671		
134662	2955	40213160	1974-07-16	1974-07-16 00:00:00	1974-07-16	1974-07-16 00:00:00	1974-07-16	581452		0	0	0		0	0	0	197233	0	10	40213160		
41118	895	40213260	2010-02-05	2010-02-05 00:00:00	2010-02-05	2010-02-05 00:00:00	2010-02-05	581452		0	0	0		0	0	0	59737	0	121	40213260		
200275	4398	40213227	2001-04-28	2001-04-28 00:00:00	2001-04-28	2001-04-28 00:00:00	2001-04-28	581452		0	0	0		0	0	0	292412	0	113	40213227		
57909	4811	1127433	2006-08-22	2006-08-22 00:00:00	2006-08-29	2006-08-29 00:00:00	2006-08-29	38000177		0	0	7		0	0	0	320018	0	313782	1127433		
175738	3864	40213306	1988-02-20	1988-02-20 00:00:00	1988-02-20	1988-02-20 00:00:00	1988-02-20	581452		0	0	0		0	0	0	256504	0	43	40213306		
38533	3181	19133905	1984-07-23	1984-07-23 00:00:00	1984-08-03	1984-08-03 00:00:00	1984-08-03	38000177		0	0	11		0	0	0	211663	0	834102	19133905		
146219	3216	40213160	1955-05-31	1955-05-31 00:00:00	1955-05-31	1955-05-31 00:00:00	1955-05-31	581452		0	0	0		0	0	0	213688	0	10	40213160		
227836	5002	40213160	1976-12-17	1976-12-17 00:00:00	1976-12-17	1976-12-17 00:00:00	1976-12-17	581452		0	0	0		0	0	0	332721	0	10	40213160		
38658	3194	19059056	1944-11-01	1944-11-01 00:00:00	1944-11-15	1944-11-15 00:00:00	1944-11-15	38000177		0	0	14		0	0	0	212491	0	243670	19059056		
36085	787	40213296	2017-05-23	2017-05-23 00:00:00	2017-05-23	2017-05-23 00:00:00	2017-05-23	581452		0	0	0		0	0	0	52383	0	52	40213296		
8153	680	1118084	2002-10-01	2002-10-01 00:00:00	2002-10-01	2002-10-01 00:00:00	\N	38000177		0	0	0		0	0	0	45064	0	00025152531	44923712		
17435	1443	19078461	2018-10-02	2018-10-02 00:00:00	2018-11-05	2018-11-05 00:00:00	2018-11-05	38000177		0	0	34		0	0	0	96194	0	310965	19078461		
192309	4225	40213296	2019-04-11	2019-04-11 00:00:00	2019-04-11	2019-04-11 00:00:00	2019-04-11	581452		0	0	0		0	0	0	280637	0	52	40213296		
169093	3718	40213260	2015-10-26	2015-10-26 00:00:00	2015-10-26	2015-10-26 00:00:00	2015-10-26	581452		0	0	0		0	0	0	247128	0	121	40213260		
104561	2292	40213160	1964-07-24	1964-07-24 00:00:00	1964-07-24	1964-07-24 00:00:00	1964-07-24	581452		0	0	0		0	0	0	152597	0	10	40213160		
112264	2466	40213314	1980-03-01	1980-03-01 00:00:00	1980-03-01	1980-03-01 00:00:00	1980-03-01	581452		0	0	0		0	0	0	163492	0	49	40213314		
63208	1382	40213296	2017-08-30	2017-08-30 00:00:00	2017-08-30	2017-08-30 00:00:00	2017-08-30	581452		0	0	0		0	0	0	91667	0	52	40213296		
31646	2622	19133905	1950-06-04	1950-06-04 00:00:00	1950-06-12	1950-06-12 00:00:00	1950-06-12	38000177		0	0	8		0	0	0	173473	0	834102	19133905		
27719	2292	1713671	2015-02-20	2015-02-20 00:00:00	2015-03-06	2015-03-06 00:00:00	2015-03-06	38000177		0	0	14		0	0	0	152626	0	562251	1713671		
205221	4504	40213227	2018-04-07	2018-04-07 00:00:00	2018-04-07	2018-04-07 00:00:00	2018-04-07	581452		0	0	0		0	0	0	299899	0	113	40213227		
61105	5081	46275916	1935-05-17	1935-05-17 00:00:00	1935-05-17	1935-05-17 00:00:00	1935-05-17	38000177		0	0	0		0	0	0	337899	0	1660014	46275916		
135519	2975	40213306	1984-06-10	1984-06-10 00:00:00	1984-06-10	1984-06-10 00:00:00	1984-06-10	581452		0	0	0		0	0	0	198637	0	43	40213306		
161453	3552	40213160	1961-05-04	1961-05-04 00:00:00	1961-05-04	1961-05-04 00:00:00	1961-05-04	581452		0	0	0		0	0	0	\N	0	10	40213160		
52836	4390	1127433	1985-09-13	1985-09-13 00:00:00	1985-09-27	1985-09-27 00:00:00	1985-09-27	38000177		0	0	14		0	0	0	291817	0	313782	1127433		
29734	2463	46233988	1971-06-29	1971-06-29 00:00:00	1971-07-13	1971-07-13 00:00:00	1971-07-13	38000177		0	0	14		0	0	0	163386	0	1652673	46233988		
214140	4696	40213160	1955-01-19	1955-01-19 00:00:00	1955-01-19	1955-01-19 00:00:00	1955-01-19	581452		0	0	0		0	0	0	312866	0	10	40213160		
138985	3053	40213314	1982-06-19	1982-06-19 00:00:00	1982-06-19	1982-06-19 00:00:00	1982-06-19	581452		0	0	0		0	0	0	203110	0	49	40213314		
220244	4834	40213227	2001-07-22	2001-07-22 00:00:00	2001-07-22	2001-07-22 00:00:00	2001-07-22	581452		0	0	0		0	0	0	321566	0	113	40213227		
42973	3562	1127078	1975-06-16	1975-06-16 00:00:00	1975-07-14	1975-07-14 00:00:00	1975-07-14	38000177		0	0	28		0	0	0	236606	0	282464	1127078		
69167	1513	40213160	1968-08-04	1968-08-04 00:00:00	1968-08-04	1968-08-04 00:00:00	1968-08-04	581452		0	0	0		0	0	0	\N	0	10	40213160		
15653	1306	19059056	1967-02-03	1967-02-03 00:00:00	1967-05-04	1967-05-04 00:00:00	1967-05-04	38000177		0	0	90		0	0	0	86248	0	243670	19059056		
48341	1057	40213160	1961-10-26	1961-10-26 00:00:00	1961-10-26	1961-10-26 00:00:00	1961-10-26	581452		0	0	0		0	0	0	69294	0	10	40213160		
158181	3483	40213198	2018-09-22	2018-09-22 00:00:00	2018-09-22	2018-09-22 00:00:00	2018-09-22	581452		0	0	0		0	0	0	231067	0	133	40213198		
78611	1720	40213251	1984-12-01	1984-12-01 00:00:00	1984-12-01	1984-12-01 00:00:00	1984-12-01	581452		0	0	0		0	0	0	115022	0	21	40213251		
243127	5337	40213160	1970-11-01	1970-11-01 00:00:00	1970-11-01	1970-11-01 00:00:00	1970-11-01	581452		0	0	0		0	0	0	355423	0	10	40213160		
45251	3745	19078461	2012-06-10	2012-06-10 00:00:00	2012-06-24	2012-06-24 00:00:00	2012-06-24	38000177		0	0	14		0	0	0	248916	0	310965	19078461		
45317	3750	40165015	1999-03-20	1999-03-20 00:00:00	1999-03-20	1999-03-20 00:00:00	\N	38000177		0	0	0		0	0	0	249241	0	861467	40165015		
55444	4604	1127433	2014-04-06	2014-04-06 00:00:00	2014-04-20	2014-04-20 00:00:00	2014-04-20	38000177		0	0	14		0	0	0	306729	0	313782	1127433		
16827	1391	1713671	1940-10-10	1940-10-10 00:00:00	1940-11-28	1940-11-28 00:00:00	1940-11-28	38000177		0	0	49		0	0	0	92319	0	562251	1713671		
28240	2333	35605482	1978-05-19	1978-05-19 00:00:00	1978-05-19	1978-05-19 00:00:00	1978-05-19	38000177		0	0	0		0	0	0	155162	0	1740467	35605482		
8991	752	1127433	1957-01-16	1957-01-16 00:00:00	1957-01-30	1957-01-30 00:00:00	1957-01-30	38000177		0	0	14		0	0	0	49653	0	313782	1127433		
28354	2340	1118084	1999-05-14	1999-05-14 00:00:00	1999-05-14	1999-05-14 00:00:00	\N	38000177		0	0	0		0	0	0	155717	0	00025152531	44923712		
79763	1745	40213306	2001-03-19	2001-03-19 00:00:00	2001-03-19	2001-03-19 00:00:00	2001-03-19	581452		0	0	0		0	0	0	116685	0	43	40213306		
192517	4229	40213160	1957-06-08	1957-06-08 00:00:00	1957-06-08	1957-06-08 00:00:00	1957-06-08	581452		0	0	0		0	0	0	280982	0	10	40213160		
39079	3230	19006318	1957-08-13	1957-08-13 00:00:00	1957-08-27	1957-08-27 00:00:00	1957-08-27	38000177		0	0	14		0	0	0	214688	0	105078	19006318		
38988	3222	1127078	1959-04-20	1959-04-20 00:00:00	1959-05-20	1959-05-20 00:00:00	1959-05-20	38000177		0	0	30		0	0	0	214154	0	282464	1127078		
107040	2346	40213198	2011-05-04	2011-05-04 00:00:00	2011-05-04	2011-05-04 00:00:00	2011-05-04	581452		0	0	0		0	0	0	156198	0	133	40213198		
3609	298	1127433	1996-07-18	1996-07-18 00:00:00	1996-07-25	1996-07-25 00:00:00	1996-07-25	38000177		0	0	7		0	0	0	19886	0	313782	1127433		
49597	4113	19059056	1963-04-11	1963-04-11 00:00:00	1963-04-25	1963-04-25 00:00:00	1963-04-25	38000177		0	0	14		0	0	0	273399	0	243670	19059056		
139528	3065	40213296	2012-05-17	2012-05-17 00:00:00	2012-05-17	2012-05-17 00:00:00	2012-05-17	581452		0	0	0		0	0	0	204041	0	52	40213296		
39669	3280	19133905	2000-07-26	2000-07-26 00:00:00	2000-08-05	2000-08-05 00:00:00	2000-08-05	38000177		0	0	10		0	0	0	217977	0	834102	19133905		
14305	1201	1127078	1976-01-24	1976-01-24 00:00:00	1976-02-07	1976-02-07 00:00:00	1976-02-07	38000177		0	0	14		0	0	0	79021	0	282464	1127078		
50226	4167	1127078	1979-10-15	1979-10-15 00:00:00	1979-10-29	1979-10-29 00:00:00	1979-10-29	38000177		0	0	14		0	0	0	276998	0	282464	1127078		
14404	1209	19129655	1978-01-06	1978-01-06 00:00:00	1978-01-20	1978-01-20 00:00:00	1978-01-20	38000177		0	0	14		0	0	0	79435	0	789980	19129655		
17338	374	40213160	1984-10-18	1984-10-18 00:00:00	1984-10-18	1984-10-18 00:00:00	1984-10-18	581452		0	0	0		0	0	0	24806	0	10	40213160		
50066	1097	40213296	2011-04-07	2011-04-07 00:00:00	2011-04-07	2011-04-07 00:00:00	2011-04-07	581452		0	0	0		0	0	0	72003	0	52	40213296		
238635	5239	40213227	1997-02-05	1997-02-05 00:00:00	1997-02-05	1997-02-05 00:00:00	1997-02-05	581452		0	0	0		0	0	0	348544	0	113	40213227		
50118	1098	40213227	1997-07-12	1997-07-12 00:00:00	1997-07-12	1997-07-12 00:00:00	1997-07-12	581452		0	0	0		0	0	0	72061	0	113	40213227		
13594	1138	1713671	1987-09-25	1987-09-25 00:00:00	1987-10-09	1987-10-09 00:00:00	1987-10-09	38000177		0	0	14		0	0	0	75069	0	562251	1713671		
223514	4907	40213201	2012-04-21	2012-04-21 00:00:00	2012-04-21	2012-04-21 00:00:00	2012-04-21	581452		0	0	0		0	0	0	326154	0	33	40213201		
199753	4387	40213296	2007-06-22	2007-06-22 00:00:00	2007-06-22	2007-06-22 00:00:00	2007-06-22	581452		0	0	0		0	0	0	291617	0	52	40213296		
5611	469	19059056	1938-03-06	1938-03-06 00:00:00	1938-03-20	1938-03-20 00:00:00	1938-03-20	38000177		0	0	14		0	0	0	31242	0	243670	19059056		
60929	5067	19059056	1983-10-13	1983-10-13 00:00:00	1983-10-27	1983-10-27 00:00:00	1983-10-27	38000177		0	0	14		0	0	0	336840	0	243670	19059056		
17316	1435	1127433	2008-11-20	2008-11-20 00:00:00	2008-11-27	2008-11-27 00:00:00	2008-11-27	38000177		0	0	7		0	0	0	95549	0	313782	1127433		
134666	2955	40213296	2011-04-26	2011-04-26 00:00:00	2011-04-26	2011-04-26 00:00:00	2011-04-26	581452		0	0	0		0	0	0	197214	0	52	40213296		
41124	895	40213160	1960-10-14	1960-10-14 00:00:00	1960-10-14	1960-10-14 00:00:00	1960-10-14	581452		0	0	0		0	0	0	59702	0	10	40213160		
200279	4398	40213227	1992-10-24	1992-10-24 00:00:00	1992-10-24	1992-10-24 00:00:00	1992-10-24	581452		0	0	0		0	0	0	292417	0	113	40213227		
57910	4811	1127078	1963-12-07	1963-12-07 00:00:00	1963-12-21	1963-12-21 00:00:00	1963-12-21	38000177		0	0	14		0	0	0	320026	0	282464	1127078		
117249	2577	40213160	1973-10-20	1973-10-20 00:00:00	1973-10-20	1973-10-20 00:00:00	1973-10-20	581452		0	0	0		0	0	0	170598	0	10	40213160		
38534	3181	1118084	1987-11-19	1987-11-19 00:00:00	1987-11-19	1987-11-19 00:00:00	\N	38000177		0	0	0		0	0	0	211624	0	00025152531	44923712		
146223	3216	40213160	1955-08-30	1955-08-30 00:00:00	1955-08-30	1955-08-30 00:00:00	1955-08-30	581452		0	0	0		0	0	0	213739	0	10	40213160		
227839	5002	40213251	1984-04-06	1984-04-06 00:00:00	1984-04-06	1984-04-06 00:00:00	1984-04-06	581452		0	0	0		0	0	0	332724	0	21	40213251		
38659	3194	1118084	1980-08-24	1980-08-24 00:00:00	1980-08-24	1980-08-24 00:00:00	\N	38000177		0	0	0		0	0	0	212497	0	00025152531	44923712		
36087	787	40213227	2017-05-23	2017-05-23 00:00:00	2017-05-23	2017-05-23 00:00:00	2017-05-23	581452		0	0	0		0	0	0	52383	0	113	40213227		
8154	680	19059056	1971-03-22	1971-03-22 00:00:00	1971-04-05	1971-04-05 00:00:00	1971-04-05	38000177		0	0	14		0	0	0	45091	0	243670	19059056		
17436	1443	1127433	1990-11-03	1990-11-03 00:00:00	1990-12-01	1990-12-01 00:00:00	1990-12-01	38000177		0	0	28		0	0	0	96191	0	313782	1127433		
192311	4225	40213251	1984-03-15	1984-03-15 00:00:00	1984-03-15	1984-03-15 00:00:00	1984-03-15	581452		0	0	0		0	0	0	280634	0	21	40213251		
169096	3718	40213306	1987-12-28	1987-12-28 00:00:00	1987-12-28	1987-12-28 00:00:00	1987-12-28	581452		0	0	0		0	0	0	247118	0	43	40213306		
104600	2294	40213227	1994-01-07	1994-01-07 00:00:00	1994-01-07	1994-01-07 00:00:00	1994-01-07	581452		0	0	0		0	0	0	152670	0	113	40213227		
33778	738	40213296	2018-07-10	2018-07-10 00:00:00	2018-07-10	2018-07-10 00:00:00	2018-07-10	581452		0	0	0		0	0	0	48886	0	52	40213296		
63209	1382	40213251	1984-04-18	1984-04-18 00:00:00	1984-04-18	1984-04-18 00:00:00	1984-04-18	581452		0	0	0		0	0	0	91619	0	21	40213251		
33542	732	40213160	1972-09-21	1972-09-21 00:00:00	1972-09-21	1972-09-21 00:00:00	1972-09-21	581452		0	0	0		0	0	0	48554	0	10	40213160		
27720	2292	1127433	1997-10-13	1997-10-13 00:00:00	1997-11-03	1997-11-03 00:00:00	1997-11-03	38000177		0	0	21		0	0	0	152636	0	313782	1127433		
205222	4504	40213260	2018-04-07	2018-04-07 00:00:00	2018-04-07	2018-04-07 00:00:00	2018-04-07	581452		0	0	0		0	0	0	299899	0	121	40213260		
61106	5081	40223768	1999-10-15	1999-10-15 00:00:00	1999-10-15	1999-10-15 00:00:00	\N	38000177		0	0	0		0	0	0	337896	0	997223	40223768		
135521	2975	40213160	1962-09-16	1962-09-16 00:00:00	1962-09-16	1962-09-16 00:00:00	1962-09-16	581452		0	0	0		0	0	0	198600	0	10	40213160		
161456	3552	40213227	2018-01-25	2018-01-25 00:00:00	2018-01-25	2018-01-25 00:00:00	2018-01-25	581452		0	0	0		0	0	0	235811	0	113	40213227		
52837	4390	1127433	1997-02-21	1997-02-21 00:00:00	1997-02-28	1997-02-28 00:00:00	1997-02-28	38000177		0	0	7		0	0	0	291919	0	313782	1127433		
29735	2463	19059056	1971-06-29	1971-06-29 00:00:00	1971-07-13	1971-07-13 00:00:00	1971-07-13	38000177		0	0	14		0	0	0	163386	0	243670	19059056		
214146	4696	40213227	1993-03-24	1993-03-24 00:00:00	1993-03-24	1993-03-24 00:00:00	1993-03-24	581452		0	0	0		0	0	0	312837	0	113	40213227		
138986	3053	40213160	1982-06-19	1982-06-19 00:00:00	1982-06-19	1982-06-19 00:00:00	1982-06-19	581452		0	0	0		0	0	0	203110	0	10	40213160		
220248	4834	40213160	1965-04-25	1965-04-25 00:00:00	1965-04-25	1965-04-25 00:00:00	1965-04-25	581452		0	0	0		0	0	0	321573	0	10	40213160		
42974	3562	1127078	1974-07-21	1974-07-21 00:00:00	1974-08-20	1974-08-20 00:00:00	1974-08-20	38000177		0	0	30		0	0	0	236605	0	282464	1127078		
69170	1513	40213296	2011-07-24	2011-07-24 00:00:00	2011-07-24	2011-07-24 00:00:00	2011-07-24	581452		0	0	0		0	0	0	101070	0	52	40213296		
15654	1306	19059056	1961-08-12	1961-08-12 00:00:00	1961-08-26	1961-08-26 00:00:00	1961-08-26	38000177		0	0	14		0	0	0	86197	0	243670	19059056		
51533	1128	40213260	2018-07-27	2018-07-27 00:00:00	2018-07-27	2018-07-27 00:00:00	2018-07-27	581452		0	0	0		0	0	0	74310	0	121	40213260		
158194	3483	40213160	1958-01-04	1958-01-04 00:00:00	1958-01-04	1958-01-04 00:00:00	1958-01-04	581452		0	0	0		0	0	0	231030	0	10	40213160		
78615	1720	40213314	1980-06-07	1980-06-07 00:00:00	1980-06-07	1980-06-07 00:00:00	1980-06-07	581452		0	0	0		0	0	0	115042	0	49	40213314		
243131	5337	40213227	2012-03-04	2012-03-04 00:00:00	2012-03-04	2012-03-04 00:00:00	2012-03-04	581452		0	0	0		0	0	0	355446	0	113	40213227		
45252	3745	19059056	1933-03-01	1933-03-01 00:00:00	1933-03-31	1933-03-31 00:00:00	1933-03-31	38000177		0	0	30		0	0	0	248874	0	243670	19059056		
55777	4631	19059056	1925-01-05	1925-01-05 00:00:00	1925-02-02	1925-02-02 00:00:00	1925-02-02	38000177		0	0	28		0	0	0	308552	0	243670	19059056		
55781	4631	19126352	2015-09-18	2015-09-18 00:00:00	2015-09-18	2015-09-18 00:00:00	\N	38000177		0	0	0		0	0	0	308680	0	705129	19126352		
16828	1391	19059056	1933-05-11	1933-05-11 00:00:00	1933-06-01	1933-06-01 00:00:00	1933-06-01	38000177		0	0	21		0	0	0	92391	0	243670	19059056		
28241	2333	40220386	1978-05-19	1978-05-19 00:00:00	1978-05-19	1978-05-19 00:00:00	1978-05-19	38000177		0	0	0		0	0	0	155162	0	1808217	40220386		
8992	752	1127078	1950-02-13	1950-02-13 00:00:00	1950-02-27	1950-02-27 00:00:00	1950-02-27	38000177		0	0	14		0	0	0	49706	0	282464	1127078		
28355	2340	19059056	1961-01-22	1961-01-22 00:00:00	1961-02-05	1961-02-05 00:00:00	1961-02-05	38000177		0	0	14		0	0	0	155746	0	243670	19059056		
79766	1745	40213251	1984-12-31	1984-12-31 00:00:00	1984-12-31	1984-12-31 00:00:00	1984-12-31	581452		0	0	0		0	0	0	116707	0	21	40213251		
192519	4229	40213227	2004-06-12	2004-06-12 00:00:00	2004-06-12	2004-06-12 00:00:00	2004-06-12	581452		0	0	0		0	0	0	280975	0	113	40213227		
39080	3230	19059056	1957-08-13	1957-08-13 00:00:00	1957-08-27	1957-08-27 00:00:00	1957-08-27	38000177		0	0	14		0	0	0	214688	0	243670	19059056		
38989	3222	1115171	2007-08-06	2007-08-06 00:00:00	2007-08-27	2007-08-27 00:00:00	2007-08-27	38000177		0	0	21		0	0	0	214157	0	849574	1115171		
118321	2602	40213227	2010-03-31	2010-03-31 00:00:00	2010-03-31	2010-03-31 00:00:00	2010-03-31	581452		0	0	0		0	0	0	172154	0	113	40213227		
3610	298	1127078	1954-12-24	1954-12-24 00:00:00	1955-01-14	1955-01-14 00:00:00	1955-01-14	38000177		0	0	21		0	0	0	19881	0	282464	1127078		
49598	4113	19006318	1963-04-11	1963-04-11 00:00:00	1963-04-25	1963-04-25 00:00:00	1963-04-25	38000177		0	0	14		0	0	0	273399	0	105078	19006318		
139536	3065	40213160	1972-10-19	1972-10-19 00:00:00	1972-10-19	1972-10-19 00:00:00	1972-10-19	581452		0	0	0		0	0	0	204047	0	10	40213160		
39670	3280	19006318	1957-03-15	1957-03-15 00:00:00	1957-03-29	1957-03-29 00:00:00	1957-03-29	38000177		0	0	14		0	0	0	218007	0	105078	19006318		
14306	1201	19129655	1976-01-24	1976-01-24 00:00:00	1976-02-07	1976-02-07 00:00:00	1976-02-07	38000177		0	0	14		0	0	0	79021	0	789980	19129655		
50227	4167	19074843	1979-10-15	1979-10-15 00:00:00	1979-10-29	1979-10-29 00:00:00	1979-10-29	38000177		0	0	14		0	0	0	276998	0	309045	19074843		
14405	1209	19078461	2004-09-16	2004-09-16 00:00:00	2004-10-23	2004-10-23 00:00:00	2004-10-23	38000177		0	0	37		0	0	0	79458	0	310965	19078461		
17340	374	40213251	1984-10-18	1984-10-18 00:00:00	1984-10-18	1984-10-18 00:00:00	1984-10-18	581452		0	0	0		0	0	0	24806	0	21	40213251		
48020	1051	40213160	1969-04-01	1969-04-01 00:00:00	1969-04-01	1969-04-01 00:00:00	1969-04-01	581452		0	0	0		0	0	0	\N	0	10	40213160		
238636	5239	40213160	1970-11-04	1970-11-04 00:00:00	1970-11-04	1970-11-04 00:00:00	1970-11-04	581452		0	0	0		0	0	0	348590	0	10	40213160		
155901	3432	40213160	1955-10-14	1955-10-14 00:00:00	1955-10-14	1955-10-14 00:00:00	1955-10-14	581452		0	0	0		0	0	0	227567	0	10	40213160		
13595	1138	19078461	2018-03-17	2018-03-17 00:00:00	2018-06-15	2018-06-15 00:00:00	2018-06-15	38000177		0	0	90		0	0	0	75132	0	310965	19078461		
223523	4907	40213227	1997-06-14	1997-06-14 00:00:00	1997-06-14	1997-06-14 00:00:00	1997-06-14	581452		0	0	0		0	0	0	326183	0	113	40213227		
199756	4387	40213160	1969-08-01	1969-08-01 00:00:00	1969-08-01	1969-08-01 00:00:00	1969-08-01	581452		0	0	0		0	0	0	291621	0	10	40213160		
5612	470	19059056	1955-11-07	1955-11-07 00:00:00	1955-11-21	1955-11-21 00:00:00	1955-11-21	38000177		0	0	14		0	0	0	31410	0	243670	19059056		
60930	5067	40229134	1990-07-30	1990-07-30 00:00:00	1990-08-13	1990-08-13 00:00:00	1990-08-13	38000177		0	0	14		0	0	0	336865	0	1043400	40229134		
17317	1435	19133873	1969-09-08	1969-09-08 00:00:00	1969-09-17	1969-09-17 00:00:00	1969-09-17	38000177		0	0	9		0	0	0	95539	0	834061	19133873		
134668	2955	40213227	2011-04-26	2011-04-26 00:00:00	2011-04-26	2011-04-26 00:00:00	2011-04-26	581452		0	0	0		0	0	0	197214	0	113	40213227		
41126	895	40213160	1960-07-15	1960-07-15 00:00:00	1960-07-15	1960-07-15 00:00:00	1960-07-15	581452		0	0	0		0	0	0	59686	0	10	40213160		
200286	4398	40213227	2010-04-24	2010-04-24 00:00:00	2010-04-24	2010-04-24 00:00:00	2010-04-24	581452		0	0	0		0	0	0	292441	0	113	40213227		
63033	1379	40213296	2000-02-19	2000-02-19 00:00:00	2000-02-19	2000-02-19 00:00:00	2000-02-19	581452		0	0	0		0	0	0	91469	0	52	40213296		
117251	2577	40213306	1996-02-10	1996-02-10 00:00:00	1996-02-10	1996-02-10 00:00:00	1996-02-10	581452		0	0	0		0	0	0	170665	0	43	40213306		
38535	3181	1127433	1966-12-25	1966-12-25 00:00:00	1967-01-01	1967-01-01 00:00:00	1967-01-01	38000177		0	0	7		0	0	0	211808	0	313782	1127433		
39350	859	40213260	2007-04-09	2007-04-09 00:00:00	2007-04-09	2007-04-09 00:00:00	2007-04-09	581452		0	0	0		0	0	0	56724	0	121	40213260		
227842	5002	40213227	2007-07-13	2007-07-13 00:00:00	2007-07-13	2007-07-13 00:00:00	2007-07-13	581452		0	0	0		0	0	0	332743	0	113	40213227		
38662	3194	19059056	1950-07-03	1950-07-03 00:00:00	1950-07-24	1950-07-24 00:00:00	1950-07-24	38000177		0	0	21		0	0	0	212458	0	243670	19059056		
36090	787	40213296	2019-05-28	2019-05-28 00:00:00	2019-05-28	2019-05-28 00:00:00	2019-05-28	581452		0	0	0		0	0	0	52391	0	52	40213296		
8155	680	1127433	2010-12-16	2010-12-16 00:00:00	2010-12-23	2010-12-23 00:00:00	2010-12-23	38000177		0	0	7		0	0	0	45077	0	313782	1127433		
17437	1443	1713671	1986-01-13	1986-01-13 00:00:00	1986-02-03	1986-02-03 00:00:00	1986-02-03	38000177		0	0	21		0	0	0	96202	0	562251	1713671		
192316	4225	40213314	1980-06-12	1980-06-12 00:00:00	1980-06-12	1980-06-12 00:00:00	1980-06-12	581452		0	0	0		0	0	0	280632	0	49	40213314		
169098	3718	40213160	1966-04-04	1966-04-04 00:00:00	1966-04-04	1966-04-04 00:00:00	1966-04-04	581452		0	0	0		0	0	0	247088	0	10	40213160		
104602	2294	40213227	2011-12-02	2011-12-02 00:00:00	2011-12-02	2011-12-02 00:00:00	2011-12-02	581452		0	0	0		0	0	0	152744	0	113	40213227		
33785	738	40213160	1983-06-14	1983-06-14 00:00:00	1983-06-14	1983-06-14 00:00:00	1983-06-14	581452		0	0	0		0	0	0	48875	0	10	40213160		
63212	1382	40213227	2000-03-01	2000-03-01 00:00:00	2000-03-01	2000-03-01 00:00:00	2000-03-01	581452		0	0	0		0	0	0	91640	0	113	40213227		
33544	732	40213227	1995-01-26	1995-01-26 00:00:00	1995-01-26	1995-01-26 00:00:00	1995-01-26	581452		0	0	0		0	0	0	48565	0	113	40213227		
27721	2294	19059056	1972-04-17	1972-04-17 00:00:00	1972-05-01	1972-05-01 00:00:00	1972-05-01	38000177		0	0	14		0	0	0	152748	0	243670	19059056		
205227	4504	40213227	2008-12-06	2008-12-06 00:00:00	2008-12-06	2008-12-06 00:00:00	2008-12-06	581452		0	0	0		0	0	0	299955	0	113	40213227		
61107	5081	19059056	1927-12-28	1927-12-28 00:00:00	1928-01-18	1928-01-18 00:00:00	1928-01-18	38000177		0	0	21		0	0	0	337898	0	243670	19059056		
135524	2975	40213160	1962-07-15	1962-07-15 00:00:00	1962-07-15	1962-07-15 00:00:00	1962-07-15	581452		0	0	0		0	0	0	198672	0	10	40213160		
127485	2804	40213227	2012-12-12	2012-12-12 00:00:00	2012-12-12	2012-12-12 00:00:00	2012-12-12	581452		0	0	0		0	0	0	185841	0	113	40213227		
52838	4390	19059056	1962-08-19	1962-08-19 00:00:00	1962-09-02	1962-09-02 00:00:00	1962-09-02	38000177		0	0	14		0	0	0	291896	0	243670	19059056		
29736	2463	1127078	1978-08-21	1978-08-21 00:00:00	1978-09-18	1978-09-18 00:00:00	1978-09-18	38000177		0	0	28		0	0	0	163397	0	282464	1127078		
44391	967	40213227	2013-11-23	2013-11-23 00:00:00	2013-11-23	2013-11-23 00:00:00	2013-11-23	581452		0	0	0		0	0	0	64336	0	113	40213227		
57747	1264	40213198	2012-11-16	2012-11-16 00:00:00	2012-11-16	2012-11-16 00:00:00	2012-11-16	581452		0	0	0		0	0	0	83292	0	133	40213198		
220256	4834	40213296	2003-07-27	2003-07-27 00:00:00	2003-07-27	2003-07-27 00:00:00	2003-07-27	581452		0	0	0		0	0	0	321588	0	52	40213296		
42975	3562	19133905	1997-02-04	1997-02-04 00:00:00	1997-02-11	1997-02-11 00:00:00	1997-02-11	38000177		0	0	7		0	0	0	236618	0	834102	19133905		
69178	1513	40213227	2000-05-07	2000-05-07 00:00:00	2000-05-07	2000-05-07 00:00:00	2000-05-07	581452		0	0	0		0	0	0	101057	0	113	40213227		
15655	1306	19129655	1961-08-12	1961-08-12 00:00:00	1961-08-26	1961-08-26 00:00:00	1961-08-26	38000177		0	0	14		0	0	0	86197	0	789980	19129655		
51542	1128	40213296	2010-08-06	2010-08-06 00:00:00	2010-08-06	2010-08-06 00:00:00	2010-08-06	581452		0	0	0		0	0	0	74360	0	52	40213296		
177060	3891	40213314	1984-02-01	1984-02-01 00:00:00	1984-02-01	1984-02-01 00:00:00	1984-02-01	581452		0	0	0		0	0	0	258661	0	49	40213314		
78617	1720	40213306	2002-02-23	2002-02-23 00:00:00	2002-02-23	2002-02-23 00:00:00	2002-02-23	581452		0	0	0		0	0	0	115027	0	43	40213306		
243132	5337	40213296	2010-02-28	2010-02-28 00:00:00	2010-02-28	2010-02-28 00:00:00	2010-02-28	581452		0	0	0		0	0	0	355492	0	52	40213296		
45253	3745	1127433	2013-04-07	2013-04-07 00:00:00	2013-05-12	2013-05-12 00:00:00	2013-05-12	38000177		0	0	35		0	0	0	248879	0	313782	1127433		
55778	4631	19059056	1921-12-24	1921-12-24 00:00:00	1922-01-21	1922-01-21 00:00:00	1922-01-21	38000177		0	0	28		0	0	0	308551	0	243670	19059056		
55782	4631	19075601	2015-09-18	2015-09-18 00:00:00	2015-09-18	2015-09-18 00:00:00	\N	38000177		0	0	0		0	0	0	308680	0	309362	19075601		
16829	1391	1713671	1931-12-03	1931-12-03 00:00:00	1931-12-10	1931-12-10 00:00:00	1931-12-10	38000177		0	0	7		0	0	0	92344	0	562251	1713671		
28242	2333	42707627	1978-05-19	1978-05-19 00:00:00	1978-05-19	1978-05-19 00:00:00	1978-05-19	38000177		0	0	0		0	0	0	155162	0	1234995	42707627		
8993	752	19006318	1950-02-13	1950-02-13 00:00:00	1950-02-27	1950-02-27 00:00:00	1950-02-27	38000177		0	0	14		0	0	0	49706	0	105078	19006318		
28356	2340	1127433	1999-06-11	1999-06-11 00:00:00	1999-06-18	1999-06-18 00:00:00	1999-06-18	38000177		0	0	7		0	0	0	155713	0	313782	1127433		
79770	1745	40213314	1980-03-24	1980-03-24 00:00:00	1980-03-24	1980-03-24 00:00:00	1980-03-24	581452		0	0	0		0	0	0	116661	0	49	40213314		
192522	4229	40213296	1996-05-11	1996-05-11 00:00:00	1996-05-11	1996-05-11 00:00:00	1996-05-11	581452		0	0	0		0	0	0	\N	0	52	40213296		
39081	3230	1127433	1987-11-05	1987-11-05 00:00:00	1987-11-12	1987-11-12 00:00:00	1987-11-12	38000177		0	0	7		0	0	0	214672	0	313782	1127433		
38990	3222	40229134	2017-05-19	2017-05-19 00:00:00	2017-05-26	2017-05-26 00:00:00	2017-05-26	38000177		0	0	7		0	0	0	214164	0	1043400	40229134		
118329	2602	40213201	2015-04-29	2015-04-29 00:00:00	2015-04-29	2015-04-29 00:00:00	2015-04-29	581452		0	0	0		0	0	0	172104	0	33	40213201		
3611	298	19133873	1952-10-08	1952-10-08 00:00:00	1952-10-20	1952-10-20 00:00:00	1952-10-20	38000177		0	0	12		0	0	0	19896	0	834061	19133873		
49600	4113	1127433	2007-01-01	2007-01-01 00:00:00	2007-01-15	2007-01-15 00:00:00	2007-01-15	38000177		0	0	14		0	0	0	273397	0	313782	1127433		
139541	3065	40213227	2014-05-22	2014-05-22 00:00:00	2014-05-22	2014-05-22 00:00:00	2014-05-22	581452		0	0	0		0	0	0	204055	0	113	40213227		
39671	3280	1127078	1957-03-15	1957-03-15 00:00:00	1957-03-29	1957-03-29 00:00:00	1957-03-29	38000177		0	0	14		0	0	0	218007	0	282464	1127078		
14307	1201	1127078	1977-04-11	1977-04-11 00:00:00	1977-04-25	1977-04-25 00:00:00	1977-04-25	38000177		0	0	14		0	0	0	79029	0	282464	1127078		
50228	4167	1118084	2015-11-30	2015-11-30 00:00:00	2015-11-30	2015-11-30 00:00:00	\N	38000177		0	0	0		0	0	0	276917	0	00025152531	44923712		
14410	1211	19133873	1978-01-22	1978-01-22 00:00:00	1978-01-29	1978-01-29 00:00:00	1978-01-29	38000177		0	0	7		0	0	0	79539	0	834061	19133873		
181918	3996	40213160	1969-04-22	1969-04-22 00:00:00	1969-04-22	1969-04-22 00:00:00	1969-04-22	581452		0	0	0		0	0	0	265690	0	10	40213160		
48023	1051	40213296	2005-08-16	2005-08-16 00:00:00	2005-08-16	2005-08-16 00:00:00	2005-08-16	581452		0	0	0		0	0	0	\N	0	52	40213296		
35916	784	40213160	1964-04-11	1964-04-11 00:00:00	1964-04-11	1964-04-11 00:00:00	1964-04-11	581452		0	0	0		0	0	0	52186	0	10	40213160		
155909	3432	40213198	2017-02-03	2017-02-03 00:00:00	2017-02-03	2017-02-03 00:00:00	2017-02-03	581452		0	0	0		0	0	0	227560	0	133	40213198		
13596	1138	40162522	2018-03-17	2018-03-17 00:00:00	2018-03-17	2018-03-17 00:00:00	\N	38000177		0	0	0		0	0	0	75132	0	857005	40162522		
223525	4907	40213198	2011-04-16	2011-04-16 00:00:00	2011-04-16	2011-04-16 00:00:00	2011-04-16	581452		0	0	0		0	0	0	326118	0	133	40213198		
118941	2616	40213227	2013-01-15	2013-01-15 00:00:00	2013-01-15	2013-01-15 00:00:00	2013-01-15	581452		0	0	0		0	0	0	172950	0	113	40213227		
5613	470	19006318	1955-11-07	1955-11-07 00:00:00	1955-11-21	1955-11-21 00:00:00	1955-11-21	38000177		0	0	14		0	0	0	31410	0	105078	19006318		
60931	5067	1127433	1976-12-20	1976-12-20 00:00:00	1977-01-03	1977-01-03 00:00:00	1977-01-03	38000177		0	0	14		0	0	0	336850	0	313782	1127433		
17318	1435	19059056	1968-07-11	1968-07-11 00:00:00	1968-10-09	1968-10-09 00:00:00	1968-10-09	38000177		0	0	90		0	0	0	95581	0	243670	19059056		
66466	1454	40213160	1976-08-20	1976-08-20 00:00:00	1976-08-20	1976-08-20 00:00:00	1976-08-20	581452		0	0	0		0	0	0	96998	0	10	40213160		
41131	895	40213296	2001-01-19	2001-01-19 00:00:00	2001-01-19	2001-01-19 00:00:00	2001-01-19	581452		0	0	0		0	0	0	59744	0	52	40213296		
200287	4398	40213260	2010-04-24	2010-04-24 00:00:00	2010-04-24	2010-04-24 00:00:00	2010-04-24	581452		0	0	0		0	0	0	292441	0	121	40213260		
63036	1379	40213160	1960-10-22	1960-10-22 00:00:00	1960-10-22	1960-10-22 00:00:00	1960-10-22	581452		0	0	0		0	0	0	91476	0	10	40213160		
117252	2577	40213227	1996-02-10	1996-02-10 00:00:00	1996-02-10	1996-02-10 00:00:00	1996-02-10	581452		0	0	0		0	0	0	170665	0	113	40213227		
38536	3181	1127433	1989-04-09	1989-04-09 00:00:00	1989-04-30	1989-04-30 00:00:00	1989-04-30	38000177		0	0	21		0	0	0	211687	0	313782	1127433		
39352	859	40213160	1957-06-10	1957-06-10 00:00:00	1957-06-10	1957-06-10 00:00:00	1957-06-10	581452		0	0	0		0	0	0	56800	0	10	40213160		
227844	5002	40213227	1998-07-03	1998-07-03 00:00:00	1998-07-03	1998-07-03 00:00:00	1998-07-03	581452		0	0	0		0	0	0	332697	0	113	40213227		
38663	3194	19126352	1971-01-11	1971-01-11 00:00:00	1971-01-11	1971-01-11 00:00:00	\N	38000177		0	0	0		0	0	0	212489	0	705129	19126352		
36092	787	40213160	1976-06-08	1976-06-08 00:00:00	1976-06-08	1976-06-08 00:00:00	1976-06-08	581452		0	0	0		0	0	0	52376	0	10	40213160		
8156	680	40231925	2012-07-24	2012-07-24 00:00:00	2012-07-24	2012-07-24 00:00:00	\N	38000177		0	0	0		0	0	0	45079	0	1049221	40231925		
17471	1446	1150771	1984-09-08	1984-09-08 00:00:00	1984-09-08	1984-09-08 00:00:00	\N	38000177		0	0	0		0	0	0	96389	0	197378	1150771		
192319	4225	40213227	2010-09-30	2010-09-30 00:00:00	2010-09-30	2010-09-30 00:00:00	2010-09-30	581452		0	0	0		0	0	0	280597	0	113	40213227		
169108	3718	40213160	1966-07-04	1966-07-04 00:00:00	1966-07-04	1966-07-04 00:00:00	1966-07-04	581452		0	0	0		0	0	0	247098	0	10	40213160		
104603	2294	40213260	2011-12-02	2011-12-02 00:00:00	2011-12-02	2011-12-02 00:00:00	2011-12-02	581452		0	0	0		0	0	0	152744	0	121	40213260		
33788	738	40213314	1978-10-10	1978-10-10 00:00:00	1978-10-10	1978-10-10 00:00:00	1978-10-10	581452		0	0	0		0	0	0	48905	0	49	40213314		
63213	1382	40213306	2000-03-01	2000-03-01 00:00:00	2000-03-01	2000-03-01 00:00:00	2000-03-01	581452		0	0	0		0	0	0	91640	0	43	40213306		
33545	732	40213306	1995-01-26	1995-01-26 00:00:00	1995-01-26	1995-01-26 00:00:00	1995-01-26	581452		0	0	0		0	0	0	48565	0	43	40213306		
27722	2294	19078461	1978-06-29	1978-06-29 00:00:00	1978-07-29	1978-07-29 00:00:00	1978-07-29	38000177		0	0	30		0	0	0	152750	0	310965	19078461		
205228	4504	40213296	2008-12-06	2008-12-06 00:00:00	2008-12-06	2008-12-06 00:00:00	2008-12-06	581452		0	0	0		0	0	0	299955	0	52	40213296		
61108	5081	1127433	1989-08-12	1989-08-12 00:00:00	1989-08-19	1989-08-19 00:00:00	1989-08-19	38000177		0	0	7		0	0	0	337858	0	313782	1127433		
135526	2975	40213306	1984-11-11	1984-11-11 00:00:00	1984-11-11	1984-11-11 00:00:00	1984-11-11	581452		0	0	0		0	0	0	198638	0	43	40213306		
127499	2804	40213201	2018-09-05	2018-09-05 00:00:00	2018-09-05	2018-09-05 00:00:00	2018-09-05	581452		0	0	0		0	0	0	185896	0	33	40213201		
235491	5172	40213227	2006-10-31	2006-10-31 00:00:00	2006-10-31	2006-10-31 00:00:00	2006-10-31	581452		0	0	0		0	0	0	343836	0	113	40213227		
29737	2463	1127078	1979-10-13	1979-10-13 00:00:00	1979-11-03	1979-11-03 00:00:00	1979-11-03	38000177		0	0	21		0	0	0	163398	0	282464	1127078		
55673	1219	40213201	2008-12-15	2008-12-15 00:00:00	2008-12-15	2008-12-15 00:00:00	2008-12-15	581452		0	0	0		0	0	0	80275	0	33	40213201		
57750	1264	40213227	2018-06-01	2018-06-01 00:00:00	2018-06-01	2018-06-01 00:00:00	2018-06-01	581452		0	0	0		0	0	0	83283	0	113	40213227		
220257	4834	40213160	1960-10-23	1960-10-23 00:00:00	1960-10-23	1960-10-23 00:00:00	1960-10-23	581452		0	0	0		0	0	0	321571	0	10	40213160		
42976	3562	1713671	1998-06-02	1998-06-02 00:00:00	1998-09-01	1998-09-01 00:00:00	1998-09-01	38000177		0	0	91		0	0	0	236592	0	562251	1713671		
69184	1513	40213160	1969-02-02	1969-02-02 00:00:00	1969-02-02	1969-02-02 00:00:00	1969-02-02	581452		0	0	0		0	0	0	101111	0	10	40213160		
15656	1306	920334	2008-10-24	2008-10-24 00:00:00	2008-10-31	2008-10-31 00:00:00	2008-10-31	38000177		0	0	7		0	0	0	86182	0	311995	920334		
51544	1128	40213227	2010-08-06	2010-08-06 00:00:00	2010-08-06	2010-08-06 00:00:00	2010-08-06	581452		0	0	0		0	0	0	74360	0	113	40213227		
177061	3891	40213251	1984-02-01	1984-02-01 00:00:00	1984-02-01	1984-02-01 00:00:00	1984-02-01	581452		0	0	0		0	0	0	258661	0	21	40213251		
78619	1720	40213227	2002-02-23	2002-02-23 00:00:00	2002-02-23	2002-02-23 00:00:00	2002-02-23	581452		0	0	0		0	0	0	115027	0	113	40213227		
243133	5337	40213296	2012-03-04	2012-03-04 00:00:00	2012-03-04	2012-03-04 00:00:00	2012-03-04	581452		0	0	0		0	0	0	355446	0	52	40213296		
45254	3745	1118084	1973-03-21	1973-03-21 00:00:00	1973-03-21	1973-03-21 00:00:00	\N	38000177		0	0	0		0	0	0	248914	0	00025152531	44923712		
55779	4631	1127433	1921-10-25	1921-10-25 00:00:00	1921-11-08	1921-11-08 00:00:00	1921-11-08	38000177		0	0	14		0	0	0	308563	0	313782	1127433		
55783	4631	1539411	2015-09-18	2015-09-18 00:00:00	2015-09-18	2015-09-18 00:00:00	\N	38000177		0	0	0		0	0	0	308680	0	312961	1539411		
16830	1391	1127433	1980-11-19	1980-11-19 00:00:00	1981-01-18	1981-01-18 00:00:00	1981-01-18	38000177		0	0	60		0	0	0	92309	0	313782	1127433		
28243	2333	46275444	1978-05-19	1978-05-19 00:00:00	1978-05-19	1978-05-19 00:00:00	1978-05-19	38000177		0	0	0		0	0	0	155162	0	1659149	46275444		
8994	752	19133905	1983-11-22	1983-11-22 00:00:00	1983-11-30	1983-11-30 00:00:00	1983-11-30	38000177		0	0	8		0	0	0	49678	0	834102	19133905		
28357	2340	19059056	1961-06-06	1961-06-06 00:00:00	1961-06-20	1961-06-20 00:00:00	1961-06-20	38000177		0	0	14		0	0	0	155736	0	243670	19059056		
79775	1745	40213160	1983-12-26	1983-12-26 00:00:00	1983-12-26	1983-12-26 00:00:00	1983-12-26	581452		0	0	0		0	0	0	116663	0	10	40213160		
192532	4229	40213296	1996-03-16	1996-03-16 00:00:00	1996-03-16	1996-03-16 00:00:00	1996-03-16	581452		0	0	0		0	0	0	280973	0	52	40213296		
39082	3230	19078461	2006-02-16	2006-02-16 00:00:00	2006-03-02	2006-03-02 00:00:00	2006-03-02	38000177		0	0	14		0	0	0	214646	0	310965	19078461		
38991	3222	40229134	1958-08-25	1958-08-25 00:00:00	1958-09-01	1958-09-01 00:00:00	1958-09-01	38000177		0	0	7		0	0	0	214213	0	1043400	40229134		
118335	2602	40213198	2014-04-23	2014-04-23 00:00:00	2014-04-23	2014-04-23 00:00:00	2014-04-23	581452		0	0	0		0	0	0	172090	0	133	40213198		
3612	298	1127433	1973-07-16	1973-07-16 00:00:00	1973-07-30	1973-07-30 00:00:00	1973-07-30	38000177		0	0	14		0	0	0	19946	0	313782	1127433		
135490	2975	40213160	1962-12-16	1962-12-16 00:00:00	1962-12-16	1962-12-16 00:00:00	1962-12-16	581452		0	0	0		0	0	0	198673	0	10	40213160		
139542	3065	40213296	2014-05-22	2014-05-22 00:00:00	2014-05-22	2014-05-22 00:00:00	2014-05-22	581452		0	0	0		0	0	0	204055	0	52	40213296		
39672	3280	1713671	1967-06-02	1967-06-02 00:00:00	1967-06-16	1967-06-16 00:00:00	1967-06-16	38000177		0	0	14		0	0	0	217975	0	562251	1713671		
14308	1201	46233988	1977-04-11	1977-04-11 00:00:00	1977-04-25	1977-04-25 00:00:00	1977-04-25	38000177		0	0	14		0	0	0	79029	0	1652673	46233988		
27414	597	40213227	2013-11-11	2013-11-11 00:00:00	2013-11-11	2013-11-11 00:00:00	2013-11-11	581452		0	0	0		0	0	0	39421	0	113	40213227		
14411	1211	19078461	2012-06-17	2012-06-17 00:00:00	2012-07-08	2012-07-08 00:00:00	2012-07-08	38000177		0	0	21		0	0	0	79578	0	310965	19078461		
181920	3997	40213306	1987-02-23	1987-02-23 00:00:00	1987-02-23	1987-02-23 00:00:00	1987-02-23	581452		0	0	0		0	0	0	265725	0	43	40213306		
48027	1051	40213160	1965-07-20	1965-07-20 00:00:00	1965-07-20	1965-07-20 00:00:00	1965-07-20	581452		0	0	0		0	0	0	68959	0	10	40213160		
35922	784	40213296	1999-07-17	1999-07-17 00:00:00	1999-07-17	1999-07-17 00:00:00	1999-07-17	581452		0	0	0		0	0	0	52193	0	52	40213296		
167187	3675	40213306	1989-09-11	1989-09-11 00:00:00	1989-09-11	1989-09-11 00:00:00	1989-09-11	581452		0	0	0		0	0	0	244416	0	43	40213306		
13597	1138	19073183	1982-08-18	1982-08-18 00:00:00	1982-09-01	1982-09-01 00:00:00	1982-09-01	38000177		0	0	14		0	0	0	75119	0	308182	19073183		
75908	1658	40213227	2003-03-31	2003-03-31 00:00:00	2003-03-31	2003-03-31 00:00:00	2003-03-31	581452		0	0	0		0	0	0	111290	0	113	40213227		
118944	2616	40213201	2018-02-13	2018-02-13 00:00:00	2018-02-13	2018-02-13 00:00:00	2018-02-13	581452		0	0	0		0	0	0	172992	0	33	40213201		
5614	470	19059056	1961-08-07	1961-08-07 00:00:00	1961-08-28	1961-08-28 00:00:00	1961-08-28	38000177		0	0	21		0	0	0	31390	0	243670	19059056		
60932	5067	40169216	1978-06-08	1978-06-08 00:00:00	1978-06-08	1978-06-08 00:00:00	\N	38000177		0	0	0		0	0	0	336888	0	895994	40169216		
17319	1435	40165015	2009-01-24	2009-01-24 00:00:00	2009-01-24	2009-01-24 00:00:00	\N	38000177		0	0	0		0	0	0	95586	0	861467	40165015		
66481	1454	40213227	2014-09-05	2014-09-05 00:00:00	2014-09-05	2014-09-05 00:00:00	2014-09-05	581452		0	0	0		0	0	0	97011	0	113	40213227		
41134	895	40213227	1993-01-08	1993-01-08 00:00:00	1993-01-08	1993-01-08 00:00:00	1993-01-08	581452		0	0	0		0	0	0	59743	0	113	40213227		
200292	4398	40213160	1964-02-22	1964-02-22 00:00:00	1964-02-22	1964-02-22 00:00:00	1964-02-22	581452		0	0	0		0	0	0	292397	0	10	40213160		
63039	1379	40213227	2003-02-15	2003-02-15 00:00:00	2003-02-15	2003-02-15 00:00:00	2003-02-15	581452		0	0	0		0	0	0	91522	0	113	40213227		
117258	2577	40213160	1978-01-28	1978-01-28 00:00:00	1978-01-28	1978-01-28 00:00:00	1978-01-28	581452		0	0	0		0	0	0	170602	0	10	40213160		
38537	3181	1551192	1959-05-06	1959-05-06 00:00:00	1959-05-06	1959-05-06 00:00:00	1959-05-06	38000177		0	0	0		0	0	0	211653	0	312617	1551192		
39355	859	40213296	2000-10-02	2000-10-02 00:00:00	2000-10-02	2000-10-02 00:00:00	2000-10-02	581452		0	0	0		0	0	0	56770	0	52	40213296		
227845	5002	40213306	1998-07-03	1998-07-03 00:00:00	1998-07-03	1998-07-03 00:00:00	1998-07-03	581452		0	0	0		0	0	0	332697	0	43	40213306		
38664	3195	40231925	2015-09-14	2015-09-14 00:00:00	2015-09-14	2015-09-14 00:00:00	\N	38000177		0	0	0		0	0	0	212562	0	1049221	40231925		
36095	787	40213314	1978-02-28	1978-02-28 00:00:00	1978-02-28	1978-02-28 00:00:00	1978-02-28	581452		0	0	0		0	0	0	\N	0	49	40213314		
8157	680	1127433	2012-07-17	2012-07-17 00:00:00	2012-08-23	2012-08-23 00:00:00	2012-08-23	38000177		0	0	37		0	0	0	45095	0	313782	1127433		
17472	1446	1713671	2001-03-30	2001-03-30 00:00:00	2001-04-06	2001-04-06 00:00:00	2001-04-06	38000177		0	0	7		0	0	0	96392	0	562251	1713671		
192320	4225	40213314	1979-09-13	1979-09-13 00:00:00	1979-09-13	1979-09-13 00:00:00	1979-09-13	581452		0	0	0		0	0	0	280631	0	49	40213314		
169110	3718	40213227	2007-11-05	2007-11-05 00:00:00	2007-11-05	2007-11-05 00:00:00	2007-11-05	581452		0	0	0		0	0	0	247121	0	113	40213227		
140279	3080	40213227	1992-12-17	1992-12-17 00:00:00	1992-12-17	1992-12-17 00:00:00	1992-12-17	581452		0	0	0		0	0	0	204999	0	113	40213227		
33789	738	40213160	1978-10-10	1978-10-10 00:00:00	1978-10-10	1978-10-10 00:00:00	1978-10-10	581452		0	0	0		0	0	0	48905	0	10	40213160		
34731	758	40213296	2016-05-29	2016-05-29 00:00:00	2016-05-29	2016-05-29 00:00:00	2016-05-29	581452		0	0	0		0	0	0	50354	0	52	40213296		
33549	732	40213160	1972-12-21	1972-12-21 00:00:00	1972-12-21	1972-12-21 00:00:00	1972-12-21	581452		0	0	0		0	0	0	48535	0	10	40213160		
38181	3159	1713671	1970-02-14	1970-02-14 00:00:00	1970-03-07	1970-03-07 00:00:00	1970-03-07	38000177		0	0	21		0	0	0	210023	0	562251	1713671		
205230	4504	40213160	1967-07-29	1967-07-29 00:00:00	1967-07-29	1967-07-29 00:00:00	1967-07-29	581452		0	0	0		0	0	0	299909	0	10	40213160		
61109	5081	1127433	1985-07-27	1985-07-27 00:00:00	1985-08-10	1985-08-10 00:00:00	1985-08-10	38000177		0	0	14		0	0	0	337904	0	313782	1127433		
135529	2975	40213227	1993-11-21	1993-11-21 00:00:00	1993-11-21	1993-11-21 00:00:00	1993-11-21	581452		0	0	0		0	0	0	198699	0	113	40213227		
127504	2804	40213160	1955-03-16	1955-03-16 00:00:00	1955-03-16	1955-03-16 00:00:00	1955-03-16	581452		0	0	0		0	0	0	185862	0	10	40213160		
235497	5172	40213227	1996-05-28	1996-05-28 00:00:00	1996-05-28	1996-05-28 00:00:00	1996-05-28	581452		0	0	0		0	0	0	343897	0	113	40213227		
29738	2463	19078461	2009-12-25	2009-12-25 00:00:00	2010-01-29	2010-01-29 00:00:00	2010-01-29	38000177		0	0	35		0	0	0	163400	0	310965	19078461		
55680	1219	40213227	2013-10-14	2013-10-14 00:00:00	2013-10-14	2013-10-14 00:00:00	2013-10-14	581452		0	0	0		0	0	0	80257	0	113	40213227		
57753	1264	40213201	2013-11-22	2013-11-22 00:00:00	2013-11-22	2013-11-22 00:00:00	2013-11-22	581452		0	0	0		0	0	0	83280	0	33	40213201		
239140	5249	40213227	2010-06-13	2010-06-13 00:00:00	2010-06-13	2010-06-13 00:00:00	2010-06-13	581452		0	0	0		0	0	0	349201	0	113	40213227		
42977	3562	1127433	1990-01-01	1990-01-01 00:00:00	1990-01-29	1990-01-29 00:00:00	1990-01-29	38000177		0	0	28		0	0	0	236608	0	313782	1127433		
69186	1513	40213160	1968-11-03	1968-11-03 00:00:00	1968-11-03	1968-11-03 00:00:00	1968-11-03	581452		0	0	0		0	0	0	101086	0	10	40213160		
15657	1306	40236824	2006-09-10	2006-09-10 00:00:00	2006-09-17	2006-09-17 00:00:00	2006-09-17	38000177		0	0	7		0	0	0	86223	0	1094107	40236824		
51547	1128	40213296	2008-08-01	2008-08-01 00:00:00	2008-08-01	2008-08-01 00:00:00	2008-08-01	581452		0	0	0		0	0	0	74308	0	52	40213296		
177066	3891	40213180	2007-09-05	2007-09-05 00:00:00	2007-09-05	2007-09-05 00:00:00	2007-09-05	581452		0	0	0		0	0	0	258732	0	114	40213180		
78623	1720	40213227	2011-03-05	2011-03-05 00:00:00	2011-03-05	2011-03-05 00:00:00	2011-03-05	581452		0	0	0		0	0	0	115058	0	113	40213227		
108202	2372	40213160	1959-12-11	1959-12-11 00:00:00	1959-12-11	1959-12-11 00:00:00	1959-12-11	581452		0	0	0		0	0	0	157818	0	10	40213160		
45255	3745	40231925	1997-03-02	1997-03-02 00:00:00	1997-03-02	1997-03-02 00:00:00	\N	38000177		0	0	0		0	0	0	248907	0	1049221	40231925		
55780	4631	19133873	1920-12-01	1920-12-01 00:00:00	1920-12-10	1920-12-10 00:00:00	1920-12-10	38000177		0	0	9		0	0	0	308570	0	834061	19133873		
55784	4631	1332419	2015-09-18	2015-09-18 00:00:00	2015-09-18	2015-09-18 00:00:00	\N	38000177		0	0	0		0	0	0	308680	0	197361	1332419		
16831	1391	40236824	1960-01-30	1960-01-30 00:00:00	1960-02-06	1960-02-06 00:00:00	1960-02-06	38000177		0	0	7		0	0	0	92347	0	1094107	40236824		
28244	2333	19078924	1978-05-19	1978-05-19 00:00:00	1978-05-19	1978-05-19 00:00:00	1978-05-19	38000177		0	0	0		0	0	0	155162	0	311700	19078924		
8995	752	1127433	2000-01-22	2000-01-22 00:00:00	2000-02-05	2000-02-05 00:00:00	2000-02-05	38000177		0	0	14		0	0	0	49642	0	313782	1127433		
28358	2340	19129655	1961-06-06	1961-06-06 00:00:00	1961-06-20	1961-06-20 00:00:00	1961-06-20	38000177		0	0	14		0	0	0	155736	0	789980	19129655		
79777	1745	40213314	1979-04-23	1979-04-23 00:00:00	1979-04-23	1979-04-23 00:00:00	1979-04-23	581452		0	0	0		0	0	0	116677	0	49	40213314		
116680	2564	40213227	1998-10-24	1998-10-24 00:00:00	1998-10-24	1998-10-24 00:00:00	1998-10-24	581452		0	0	0		0	0	0	169882	0	113	40213227		
39083	3230	1118084	1997-08-03	1997-08-03 00:00:00	1997-08-03	1997-08-03 00:00:00	\N	38000177		0	0	0		0	0	0	214715	0	00025152531	44923712		
38992	3222	40229134	2002-11-21	2002-11-21 00:00:00	2002-11-28	2002-11-28 00:00:00	2002-11-28	38000177		0	0	7		0	0	0	214140	0	1043400	40229134		
168196	3697	40213227	1993-10-02	1993-10-02 00:00:00	1993-10-02	1993-10-02 00:00:00	1993-10-02	581452		0	0	0		0	0	0	245762	0	113	40213227		
3613	298	19059056	1968-05-05	1968-05-05 00:00:00	1968-06-09	1968-06-09 00:00:00	1968-06-09	38000177		0	0	35		0	0	0	19882	0	243670	19059056		
58180	1273	40213201	2002-09-02	2002-09-02 00:00:00	2002-09-02	2002-09-02 00:00:00	2002-09-02	581452		0	0	0		0	0	0	84046	0	33	40213201		
139546	3065	40213160	1976-10-28	1976-10-28 00:00:00	1976-10-28	1976-10-28 00:00:00	1976-10-28	581452		0	0	0		0	0	0	204059	0	10	40213160		
39673	3280	40173590	2011-11-10	2011-11-10 00:00:00	2011-11-10	2011-11-10 00:00:00	\N	38000177		0	0	0		0	0	0	217974	0	904419	40173590		
14309	1201	1115171	2013-06-13	2013-06-13 00:00:00	2013-06-27	2013-06-27 00:00:00	2013-06-27	38000177		0	0	14		0	0	0	78982	0	849574	1115171		
27433	598	40213314	1977-02-25	1977-02-25 00:00:00	1977-02-25	1977-02-25 00:00:00	1977-02-25	581452		0	0	0		0	0	0	39507	0	49	40213314		
14412	1211	1154615	1966-10-29	1966-10-29 00:00:00	1966-10-29	1966-10-29 00:00:00	\N	38000177		0	0	0		0	0	0	79536	0	745679	1154615		
181925	3997	40213227	2018-08-06	2018-08-06 00:00:00	2018-08-06	2018-08-06 00:00:00	2018-08-06	581452		0	0	0		0	0	0	265709	0	113	40213227		
48029	1051	40213160	1965-05-18	1965-05-18 00:00:00	1965-05-18	1965-05-18 00:00:00	1965-05-18	581452		0	0	0		0	0	0	68958	0	10	40213160		
35926	784	40213160	1960-01-09	1960-01-09 00:00:00	1960-01-09	1960-01-09 00:00:00	1960-01-09	581452		0	0	0		0	0	0	52246	0	10	40213160		
167199	3676	40213296	2010-11-18	2010-11-18 00:00:00	2010-11-18	2010-11-18 00:00:00	2010-11-18	581452		0	0	0		0	0	0	244513	0	52	40213296		
13598	1138	1127078	1982-08-18	1982-08-18 00:00:00	1982-09-01	1982-09-01 00:00:00	1982-09-01	38000177		0	0	14		0	0	0	75119	0	282464	1127078		
62073	1356	40213296	2011-02-11	2011-02-11 00:00:00	2011-02-11	2011-02-11 00:00:00	2011-02-11	581452		0	0	0		0	0	0	89884	0	52	40213296		
118963	2616	40213160	1955-11-01	1955-11-01 00:00:00	1955-11-01	1955-11-01 00:00:00	1955-11-01	581452		0	0	0		0	0	0	172985	0	10	40213160		
5615	470	1127433	2009-04-29	2009-04-29 00:00:00	2009-05-06	2009-05-06 00:00:00	2009-05-06	38000177		0	0	7		0	0	0	31413	0	313782	1127433		
60933	5067	1154615	1978-06-08	1978-06-08 00:00:00	1978-06-08	1978-06-08 00:00:00	\N	38000177		0	0	0		0	0	0	336888	0	745679	1154615		
17320	1435	1127433	2009-01-24	2009-01-24 00:00:00	2009-04-24	2009-04-24 00:00:00	2009-04-24	38000177		0	0	90		0	0	0	95586	0	313782	1127433		
66482	1454	40213296	2014-09-05	2014-09-05 00:00:00	2014-09-05	2014-09-05 00:00:00	2014-09-05	581452		0	0	0		0	0	0	97011	0	52	40213296		
41143	895	40213306	1983-03-04	1983-03-04 00:00:00	1983-03-04	1983-03-04 00:00:00	1983-03-04	581452		0	0	0		0	0	0	59741	0	43	40213306		
56749	4707	1118084	2012-08-12	2012-08-12 00:00:00	2012-08-12	2012-08-12 00:00:00	\N	38000177		0	0	0		0	0	0	313569	0	00025152531	44923712		
63043	1379	40213306	1982-03-27	1982-03-27 00:00:00	1982-03-27	1982-03-27 00:00:00	1982-03-27	581452		0	0	0		0	0	0	91519	0	43	40213306		
117260	2577	40213227	2015-05-23	2015-05-23 00:00:00	2015-05-23	2015-05-23 00:00:00	2015-05-23	581452		0	0	0		0	0	0	170713	0	113	40213227		
95780	2100	40213227	1994-10-17	1994-10-17 00:00:00	1994-10-17	1994-10-17 00:00:00	1994-10-17	581452		0	0	0		0	0	0	139994	0	113	40213227		
39362	859	40213227	1998-09-28	1998-09-28 00:00:00	1998-09-28	1998-09-28 00:00:00	1998-09-28	581452		0	0	0		0	0	0	56778	0	113	40213227		
227847	5002	40213314	1977-09-16	1977-09-16 00:00:00	1977-09-16	1977-09-16 00:00:00	1977-09-16	581452		0	0	0		0	0	0	332706	0	49	40213314		
38665	3195	1118084	1984-10-09	1984-10-09 00:00:00	1984-10-09	1984-10-09 00:00:00	\N	38000177		0	0	0		0	0	0	212554	0	00025152531	44923712		
36101	787	40213160	1980-09-09	1980-09-09 00:00:00	1980-09-09	1980-09-09 00:00:00	1980-09-09	581452		0	0	0		0	0	0	52371	0	10	40213160		
8158	680	19059056	1968-08-20	1968-08-20 00:00:00	1968-09-03	1968-09-03 00:00:00	1968-09-03	38000177		0	0	14		0	0	0	45090	0	243670	19059056		
46393	3843	1115171	2007-11-19	2007-11-19 00:00:00	2007-12-10	2007-12-10 00:00:00	2007-12-10	38000177		0	0	21		0	0	0	255096	0	849574	1115171		
192321	4225	40213160	1979-09-13	1979-09-13 00:00:00	1979-09-13	1979-09-13 00:00:00	1979-09-13	581452		0	0	0		0	0	0	280631	0	10	40213160		
169111	3718	40213296	2007-11-05	2007-11-05 00:00:00	2007-11-05	2007-11-05 00:00:00	2007-11-05	581452		0	0	0		0	0	0	247121	0	52	40213296		
90468	1986	40213314	1980-04-29	1980-04-29 00:00:00	1980-04-29	1980-04-29 00:00:00	1980-04-29	581452		0	0	0		0	0	0	132215	0	49	40213314		
33791	738	40213227	2009-09-01	2009-09-01 00:00:00	2009-09-01	2009-09-01 00:00:00	2009-09-01	581452		0	0	0		0	0	0	48900	0	113	40213227		
34734	758	40213227	2014-05-25	2014-05-25 00:00:00	2014-05-25	2014-05-25 00:00:00	2014-05-25	581452		0	0	0		0	0	0	50323	0	113	40213227		
33553	732	40213227	2014-04-24	2014-04-24 00:00:00	2014-04-24	2014-04-24 00:00:00	2014-04-24	581452		0	0	0		0	0	0	48560	0	113	40213227		
38182	3159	19059056	1970-06-27	1970-06-27 00:00:00	1970-07-27	1970-07-27 00:00:00	1970-07-27	38000177		0	0	30		0	0	0	210080	0	243670	19059056		
205234	4504	40213296	2006-12-02	2006-12-02 00:00:00	2006-12-02	2006-12-02 00:00:00	2006-12-02	581452		0	0	0		0	0	0	299919	0	52	40213296		
61110	5081	19006318	1946-10-14	1946-10-14 00:00:00	1946-10-28	1946-10-28 00:00:00	1946-10-28	38000177		0	0	14		0	0	0	337836	0	105078	19006318		
135533	2975	40213260	2012-04-08	2012-04-08 00:00:00	2012-04-08	2012-04-08 00:00:00	2012-04-08	581452		0	0	0		0	0	0	198681	0	121	40213260		
127511	2804	40213227	1993-10-20	1993-10-20 00:00:00	1993-10-20	1993-10-20 00:00:00	1993-10-20	581452		0	0	0		0	0	0	185884	0	113	40213227		
49288	1079	40213296	2004-08-29	2004-08-29 00:00:00	2004-08-29	2004-08-29 00:00:00	2004-08-29	581452		0	0	0		0	0	0	70766	0	52	40213296		
29739	2463	19059056	1975-04-02	1975-04-02 00:00:00	1975-04-16	1975-04-16 00:00:00	1975-04-16	38000177		0	0	14		0	0	0	163333	0	243670	19059056		
218319	4791	40213227	2018-09-13	2018-09-13 00:00:00	2018-09-13	2018-09-13 00:00:00	2018-09-13	581452		0	0	0		0	0	0	318823	0	113	40213227		
57765	1264	40213227	2008-10-24	2008-10-24 00:00:00	2008-10-24	2008-10-24 00:00:00	2008-10-24	581452		0	0	0		0	0	0	83290	0	113	40213227		
63446	5272	1127433	2015-07-29	2015-07-29 00:00:00	2015-08-05	2015-08-05 00:00:00	2015-08-05	38000177		0	0	7		0	0	0	350658	0	313782	1127433		
42978	3562	1118084	2014-03-28	2014-03-28 00:00:00	2014-03-28	2014-03-28 00:00:00	\N	38000177		0	0	0		0	0	0	236613	0	00025152531	44923712		
219061	4807	40213227	2007-03-15	2007-03-15 00:00:00	2007-03-15	2007-03-15 00:00:00	2007-03-15	581452		0	0	0		0	0	0	319867	0	113	40213227		
15658	1306	920300	2006-09-10	2006-09-10 00:00:00	2006-09-17	2006-09-17 00:00:00	2006-09-17	38000177		0	0	7		0	0	0	86223	0	311989	920300		
51548	1128	40213160	1973-07-06	1973-07-06 00:00:00	1973-07-06	1973-07-06 00:00:00	1973-07-06	581452		0	0	0		0	0	0	74341	0	10	40213160		
177074	3891	40213227	2004-08-25	2004-08-25 00:00:00	2004-08-25	2004-08-25 00:00:00	2004-08-25	581452		0	0	0		0	0	0	\N	0	113	40213227		
78628	1720	40213314	1979-09-08	1979-09-08 00:00:00	1979-09-08	1979-09-08 00:00:00	1979-09-08	581452		0	0	0		0	0	0	115041	0	49	40213314		
108212	2372	40213160	1964-03-13	1964-03-13 00:00:00	1964-03-13	1964-03-13 00:00:00	1964-03-13	581452		0	0	0		0	0	0	157851	0	10	40213160		
45256	3745	40169281	1993-05-26	1993-05-26 00:00:00	1993-05-26	1993-05-26 00:00:00	\N	38000177		0	0	0		0	0	0	248891	0	896209	40169281		
161960	3562	40213260	2018-08-22	2018-08-22 00:00:00	2018-08-22	2018-08-22 00:00:00	2018-08-22	581452		0	0	0		0	0	0	236614	0	121	40213260		
55785	4631	1127433	1995-03-09	1995-03-09 00:00:00	1995-03-23	1995-03-23 00:00:00	1995-03-23	38000177		0	0	14		0	0	0	308558	0	313782	1127433		
16832	1391	920300	1960-01-30	1960-01-30 00:00:00	1960-02-06	1960-02-06 00:00:00	1960-02-06	38000177		0	0	7		0	0	0	92347	0	311989	920300		
28245	2333	782047	1978-05-19	1978-05-19 00:00:00	1978-05-19	1978-05-19 00:00:00	1978-05-19	38000177		0	0	0		0	0	0	155162	0	542347	782047		
8996	752	1127433	2014-02-27	2014-02-27 00:00:00	2014-03-06	2014-03-06 00:00:00	2014-03-06	38000177		0	0	7		0	0	0	49643	0	313782	1127433		
28359	2341	40163554	2002-03-28	2002-03-28 00:00:00	2002-03-28	2002-03-28 00:00:00	\N	38000177		0	0	0		0	0	0	155811	0	855332	40163554		
79778	1745	40213160	1979-04-23	1979-04-23 00:00:00	1979-04-23	1979-04-23 00:00:00	1979-04-23	581452		0	0	0		0	0	0	116677	0	10	40213160		
116681	2564	40213306	1998-10-24	1998-10-24 00:00:00	1998-10-24	1998-10-24 00:00:00	1998-10-24	581452		0	0	0		0	0	0	169882	0	43	40213306		
39084	3231	1127433	1996-08-09	1996-08-09 00:00:00	1996-08-16	1996-08-16 00:00:00	1996-08-16	38000177		0	0	7		0	0	0	214778	0	313782	1127433		
38993	3222	1127433	2015-06-10	2015-06-10 00:00:00	2015-06-24	2015-06-24 00:00:00	2015-06-24	38000177		0	0	14		0	0	0	214219	0	313782	1127433		
168198	3697	40213227	2002-03-30	2002-03-30 00:00:00	2002-03-30	2002-03-30 00:00:00	2002-03-30	581452		0	0	0		0	0	0	245763	0	113	40213227		
3614	298	1127078	1953-01-03	1953-01-03 00:00:00	1953-01-17	1953-01-17 00:00:00	1953-01-17	38000177		0	0	14		0	0	0	19923	0	282464	1127078		
58184	1273	40213227	1997-08-04	1997-08-04 00:00:00	1997-08-04	1997-08-04 00:00:00	1997-08-04	581452		0	0	0		0	0	0	84027	0	113	40213227		
139549	3065	40213227	2004-02-05	2004-02-05 00:00:00	2004-02-05	2004-02-05 00:00:00	2004-02-05	581452		0	0	0		0	0	0	204067	0	113	40213227		
39674	3280	19078461	1991-05-17	1991-05-17 00:00:00	1991-06-14	1991-06-14 00:00:00	1991-06-14	38000177		0	0	28		0	0	0	218039	0	310965	19078461		
14310	1201	40229134	2005-12-13	2005-12-13 00:00:00	2005-12-20	2005-12-20 00:00:00	2005-12-20	38000177		0	0	7		0	0	0	79020	0	1043400	40229134		
27435	598	40213296	2016-11-04	2016-11-04 00:00:00	2016-11-04	2016-11-04 00:00:00	2016-11-04	581452		0	0	0		0	0	0	39522	0	52	40213296		
14413	1211	40169216	1966-10-29	1966-10-29 00:00:00	1966-10-29	1966-10-29 00:00:00	\N	38000177		0	0	0		0	0	0	79536	0	895994	40169216		
181934	3997	40213227	2009-03-23	2009-03-23 00:00:00	2009-03-23	2009-03-23 00:00:00	2009-03-23	581452		0	0	0		0	0	0	265754	0	113	40213227		
48034	1051	40213296	2005-02-15	2005-02-15 00:00:00	2005-02-15	2005-02-15 00:00:00	2005-02-15	581452		0	0	0		0	0	0	68899	0	52	40213296		
51172	1120	40213227	2008-12-08	2008-12-08 00:00:00	2008-12-08	2008-12-08 00:00:00	2008-12-08	581452		0	0	0		0	0	0	73870	0	113	40213227		
167203	3676	40213160	1971-07-22	1971-07-22 00:00:00	1971-07-22	1971-07-22 00:00:00	1971-07-22	581452		0	0	0		0	0	0	244527	0	10	40213160		
13599	1138	19078461	2007-03-15	2007-03-15 00:00:00	2007-04-14	2007-04-14 00:00:00	2007-04-14	38000177		0	0	30		0	0	0	75131	0	310965	19078461		
62084	1356	40213160	1971-10-15	1971-10-15 00:00:00	1971-10-15	1971-10-15 00:00:00	1971-10-15	581452		0	0	0		0	0	0	89869	0	10	40213160		
118966	2616	40213296	1996-04-30	1996-04-30 00:00:00	1996-04-30	1996-04-30 00:00:00	1996-04-30	581452		0	0	0		0	0	0	172961	0	52	40213296		
5616	470	19059056	1967-03-30	1967-03-30 00:00:00	1967-04-13	1967-04-13 00:00:00	1967-04-13	38000177		0	0	14		0	0	0	31391	0	243670	19059056		
60934	5067	1127078	1977-04-17	1977-04-17 00:00:00	1977-05-08	1977-05-08 00:00:00	1977-05-08	38000177		0	0	21		0	0	0	336815	0	282464	1127078		
17321	1435	1713671	1996-10-08	1996-10-08 00:00:00	1996-10-29	1996-10-29 00:00:00	1996-10-29	38000177		0	0	21		0	0	0	95576	0	562251	1713671		
66485	1454	40213227	2004-08-20	2004-08-20 00:00:00	2004-08-20	2004-08-20 00:00:00	2004-08-20	581452		0	0	0		0	0	0	97002	0	113	40213227		
41146	895	40213296	2003-01-24	2003-01-24 00:00:00	2003-01-24	2003-01-24 00:00:00	2003-01-24	581452		0	0	0		0	0	0	59706	0	52	40213296		
56750	4707	1127433	1990-03-28	1990-03-28 00:00:00	1990-04-11	1990-04-11 00:00:00	1990-04-11	38000177		0	0	14		0	0	0	313595	0	313782	1127433		
63048	1379	40213260	2010-03-06	2010-03-06 00:00:00	2010-03-06	2010-03-06 00:00:00	2010-03-06	581452		0	0	0		0	0	0	91451	0	121	40213260		
117261	2577	40213296	2015-05-23	2015-05-23 00:00:00	2015-05-23	2015-05-23 00:00:00	2015-05-23	581452		0	0	0		0	0	0	170713	0	52	40213296		
95788	2100	40213227	2004-12-13	2004-12-13 00:00:00	2004-12-13	2004-12-13 00:00:00	2004-12-13	581452		0	0	0		0	0	0	139987	0	113	40213227		
39363	859	40213296	1998-09-28	1998-09-28 00:00:00	1998-09-28	1998-09-28 00:00:00	1998-09-28	581452		0	0	0		0	0	0	56778	0	52	40213296		
161638	3556	40213160	1979-03-26	1979-03-26 00:00:00	1979-03-26	1979-03-26 00:00:00	1979-03-26	581452		0	0	0		0	0	0	236107	0	10	40213160		
38666	3195	1127433	1968-02-13	1968-02-13 00:00:00	1968-02-20	1968-02-20 00:00:00	1968-02-20	38000177		0	0	7		0	0	0	212511	0	313782	1127433		
89467	1962	40213296	2004-04-14	2004-04-14 00:00:00	2004-04-14	2004-04-14 00:00:00	2004-04-14	581452		0	0	0		0	0	0	130524	0	52	40213296		
195272	4289	40213227	2003-09-14	2003-09-14 00:00:00	2003-09-14	2003-09-14 00:00:00	2003-09-14	581452		0	0	0		0	0	0	284823	0	113	40213227		
46394	3843	19133905	2000-03-08	2000-03-08 00:00:00	2000-03-18	2000-03-18 00:00:00	2000-03-18	38000177		0	0	10		0	0	0	255068	0	834102	19133905		
192325	4225	40213160	1979-12-13	1979-12-13 00:00:00	1979-12-13	1979-12-13 00:00:00	1979-12-13	581452		0	0	0		0	0	0	280618	0	10	40213160		
169114	3718	40213160	1966-01-31	1966-01-31 00:00:00	1966-01-31	1966-01-31 00:00:00	1966-01-31	581452		0	0	0		0	0	0	247111	0	10	40213160		
90469	1986	40213160	1980-04-29	1980-04-29 00:00:00	1980-04-29	1980-04-29 00:00:00	1980-04-29	581452		0	0	0		0	0	0	132215	0	10	40213160		
33792	738	40213314	1979-09-11	1979-09-11 00:00:00	1979-09-11	1979-09-11 00:00:00	1979-09-11	581452		0	0	0		0	0	0	48872	0	49	40213314		
34735	758	40213296	2014-05-25	2014-05-25 00:00:00	2014-05-25	2014-05-25 00:00:00	2014-05-25	581452		0	0	0		0	0	0	50323	0	52	40213296		
33554	732	40213296	2014-04-24	2014-04-24 00:00:00	2014-04-24	2014-04-24 00:00:00	2014-04-24	581452		0	0	0		0	0	0	48560	0	52	40213296		
38183	3159	40229134	2002-08-01	2002-08-01 00:00:00	2002-08-15	2002-08-15 00:00:00	2002-08-15	38000177		0	0	14		0	0	0	210076	0	1043400	40229134		
205247	4504	40213160	1971-08-14	1971-08-14 00:00:00	1971-08-14	1971-08-14 00:00:00	1971-08-14	581452		0	0	0		0	0	0	299925	0	10	40213160		
119105	2619	40213227	2009-11-20	2009-11-20 00:00:00	2009-11-20	2009-11-20 00:00:00	2009-11-20	581452		0	0	0		0	0	0	173196	0	113	40213227		
166849	3668	40213160	1976-05-09	1976-05-09 00:00:00	1976-05-09	1976-05-09 00:00:00	1976-05-09	581452		0	0	0		0	0	0	244035	0	10	40213160		
127513	2804	40213160	1955-09-14	1955-09-14 00:00:00	1955-09-14	1955-09-14 00:00:00	1955-09-14	581452		0	0	0		0	0	0	185819	0	10	40213160		
49290	1079	40213260	2011-09-18	2011-09-18 00:00:00	2011-09-18	2011-09-18 00:00:00	2011-09-18	581452		0	0	0		0	0	0	70783	0	121	40213260		
29741	2463	19059056	1972-03-14	1972-03-14 00:00:00	1972-03-28	1972-03-28 00:00:00	1972-03-28	38000177		0	0	14		0	0	0	163393	0	243670	19059056		
218320	4791	40213260	2018-09-13	2018-09-13 00:00:00	2018-09-13	2018-09-13 00:00:00	2018-09-13	581452		0	0	0		0	0	0	318823	0	121	40213260		
218015	4784	40213198	2014-08-16	2014-08-16 00:00:00	2014-08-16	2014-08-16 00:00:00	2014-08-16	581452		0	0	0		0	0	0	318435	0	133	40213198		
63447	5272	19133873	1921-01-12	1921-01-12 00:00:00	1921-01-20	1921-01-20 00:00:00	1921-01-20	38000177		0	0	8		0	0	0	350586	0	834061	19133873		
43251	3582	19133905	1997-01-08	1997-01-08 00:00:00	1997-01-19	1997-01-19 00:00:00	1997-01-19	38000177		0	0	11		0	0	0	238137	0	834102	19133905		
229438	5043	40213160	1978-11-24	1978-11-24 00:00:00	1978-11-24	1978-11-24 00:00:00	1978-11-24	581452		0	0	0		0	0	0	335125	0	10	40213160		
15659	1306	19059056	1962-04-09	1962-04-09 00:00:00	1962-04-30	1962-04-30 00:00:00	1962-04-30	38000177		0	0	21		0	0	0	86246	0	243670	19059056		
15698	1309	19078461	1989-12-09	1989-12-09 00:00:00	1989-12-23	1989-12-23 00:00:00	1989-12-23	38000177		0	0	14		0	0	0	86449	0	310965	19078461		
177075	3891	40213306	2004-08-25	2004-08-25 00:00:00	2004-08-25	2004-08-25 00:00:00	2004-08-25	581452		0	0	0		0	0	0	\N	0	43	40213306		
78629	1720	40213160	1979-09-08	1979-09-08 00:00:00	1979-09-08	1979-09-08 00:00:00	1979-09-08	581452		0	0	0		0	0	0	115041	0	10	40213160		
108217	2372	40213160	1959-09-11	1959-09-11 00:00:00	1959-09-11	1959-09-11 00:00:00	1959-09-11	581452		0	0	0		0	0	0	157847	0	10	40213160		
45257	3745	1713671	1969-07-04	1969-07-04 00:00:00	1969-07-25	1969-07-25 00:00:00	1969-07-25	38000177		0	0	21		0	0	0	248918	0	562251	1713671		
161963	3562	40213296	2008-12-10	2008-12-10 00:00:00	2008-12-10	2008-12-10 00:00:00	2008-12-10	581452		0	0	0		0	0	0	236627	0	52	40213296		
55786	4631	40229134	1913-10-09	1913-10-09 00:00:00	1913-10-16	1913-10-16 00:00:00	1913-10-16	38000177		0	0	7		0	0	0	308600	0	1043400	40229134		
16833	1391	19059056	1924-07-29	1924-07-29 00:00:00	1924-08-12	1924-08-12 00:00:00	1924-08-12	38000177		0	0	14		0	0	0	92331	0	243670	19059056		
28246	2333	1127433	1926-02-01	1926-02-01 00:00:00	1926-02-08	1926-02-08 00:00:00	1926-02-08	38000177		0	0	7		0	0	0	155257	0	313782	1127433		
8997	752	19059056	1949-04-28	1949-04-28 00:00:00	1949-05-12	1949-05-12 00:00:00	1949-05-12	38000177		0	0	14		0	0	0	49684	0	243670	19059056		
28360	2341	19018935	2002-03-28	2002-03-28 00:00:00	2002-03-28	2002-03-28 00:00:00	\N	38000177		0	0	0		0	0	0	155811	0	197604	19018935		
79782	1745	40213227	2010-03-29	2010-03-29 00:00:00	2010-03-29	2010-03-29 00:00:00	2010-03-29	581452		0	0	0		0	0	0	116705	0	113	40213227		
116684	2564	40213227	2008-08-30	2008-08-30 00:00:00	2008-08-30	2008-08-30 00:00:00	2008-08-30	581452		0	0	0		0	0	0	169864	0	113	40213227		
39085	3231	1713671	2012-02-04	2012-02-04 00:00:00	2012-02-25	2012-02-25 00:00:00	2012-02-25	38000177		0	0	21		0	0	0	214779	0	562251	1713671		
38994	3222	1127433	1959-04-30	1959-04-30 00:00:00	1959-05-14	1959-05-14 00:00:00	1959-05-14	38000177		0	0	14		0	0	0	214136	0	313782	1127433		
168220	3698	40213160	1955-10-04	1955-10-04 00:00:00	1955-10-04	1955-10-04 00:00:00	1955-10-04	581452		0	0	0		0	0	0	245890	0	10	40213160		
3615	298	19006318	1953-01-03	1953-01-03 00:00:00	1953-01-17	1953-01-17 00:00:00	1953-01-17	38000177		0	0	14		0	0	0	19923	0	105078	19006318		
58188	1273	40213227	2016-11-21	2016-11-21 00:00:00	2016-11-21	2016-11-21 00:00:00	2016-11-21	581452		0	0	0		0	0	0	84033	0	113	40213227		
139552	3065	40213160	1973-01-18	1973-01-18 00:00:00	1973-01-18	1973-01-18 00:00:00	1973-01-18	581452		0	0	0		0	0	0	204010	0	10	40213160		
50133	4160	1310034	1965-11-25	1965-11-25 00:00:00	1965-11-25	1965-11-25 00:00:00	1965-11-25	38000177		0	0	0		0	0	0	276447	0	834357	1310034		
14311	1202	1713671	2008-08-03	2008-08-03 00:00:00	2008-08-17	2008-08-17 00:00:00	2008-08-17	38000177		0	0	14		0	0	0	79045	0	562251	1713671		
27437	598	40213227	2016-11-04	2016-11-04 00:00:00	2016-11-04	2016-11-04 00:00:00	2016-11-04	581452		0	0	0		0	0	0	39522	0	113	40213227		
14414	1211	1713671	1993-06-13	1993-06-13 00:00:00	1993-07-04	1993-07-04 00:00:00	1993-07-04	38000177		0	0	21		0	0	0	79658	0	562251	1713671		
181935	3997	40213296	2009-03-23	2009-03-23 00:00:00	2009-03-23	2009-03-23 00:00:00	2009-03-23	581452		0	0	0		0	0	0	265754	0	52	40213296		
48040	1051	40213160	1965-10-19	1965-10-19 00:00:00	1965-10-19	1965-10-19 00:00:00	1965-10-19	581452		0	0	0		0	0	0	68912	0	10	40213160		
51173	1120	40213260	2008-12-08	2008-12-08 00:00:00	2008-12-08	2008-12-08 00:00:00	2008-12-08	581452		0	0	0		0	0	0	73870	0	121	40213260		
167212	3676	40213160	1975-10-23	1975-10-23 00:00:00	1975-10-23	1975-10-23 00:00:00	1975-10-23	581452		0	0	0		0	0	0	244495	0	10	40213160		
13600	1138	1127433	1993-12-20	1993-12-20 00:00:00	1994-01-03	1994-01-03 00:00:00	1994-01-03	38000177		0	0	14		0	0	0	75105	0	313782	1127433		
62088	1356	40213160	1971-07-16	1971-07-16 00:00:00	1971-07-16	1971-07-16 00:00:00	1971-07-16	581452		0	0	0		0	0	0	89946	0	10	40213160		
118972	2616	40213160	1955-05-03	1955-05-03 00:00:00	1955-05-03	1955-05-03 00:00:00	1955-05-03	581452		0	0	0		0	0	0	172997	0	10	40213160		
5617	470	1118084	1989-06-26	1989-06-26 00:00:00	1989-06-26	1989-06-26 00:00:00	\N	38000177		0	0	0		0	0	0	31402	0	00025152531	44923712		
60935	5067	1118084	2012-02-08	2012-02-08 00:00:00	2012-02-08	2012-02-08 00:00:00	\N	38000177		0	0	0		0	0	0	336869	0	00025152531	44923712		
17322	1435	1124300	2002-09-26	2002-09-26 00:00:00	2002-09-26	2002-09-26 00:00:00	\N	38000177		0	0	0		0	0	0	95585	0	00781178901	45011828		
66487	1454	40213306	1994-01-07	1994-01-07 00:00:00	1994-01-07	1994-01-07 00:00:00	1994-01-07	581452		0	0	0		0	0	0	96984	0	43	40213306		
41148	895	40213227	2003-01-24	2003-01-24 00:00:00	2003-01-24	2003-01-24 00:00:00	2003-01-24	581452		0	0	0		0	0	0	59706	0	113	40213227		
56751	4707	19073188	1990-03-28	1990-03-28 00:00:00	1990-04-11	1990-04-11 00:00:00	1990-04-11	38000177		0	0	14		0	0	0	313595	0	308192	19073188		
63050	1379	40213160	1960-05-21	1960-05-21 00:00:00	1960-05-21	1960-05-21 00:00:00	1960-05-21	581452		0	0	0		0	0	0	91475	0	10	40213160		
117266	2577	40213296	2013-05-18	2013-05-18 00:00:00	2013-05-18	2013-05-18 00:00:00	2013-05-18	581452		0	0	0		0	0	0	170697	0	52	40213296		
121005	2659	40213160	1975-03-05	1975-03-05 00:00:00	1975-03-05	1975-03-05 00:00:00	1975-03-05	581452		0	0	0		0	0	0	176138	0	10	40213160		
50659	1110	40213227	2005-09-05	2005-09-05 00:00:00	2005-09-05	2005-09-05 00:00:00	2005-09-05	581452		0	0	0		0	0	0	73085	0	113	40213227		
161642	3556	40213227	2000-09-18	2000-09-18 00:00:00	2000-09-18	2000-09-18 00:00:00	2000-09-18	581452		0	0	0		0	0	0	236140	0	113	40213227		
38667	3195	1127433	1990-03-19	1990-03-19 00:00:00	1990-04-02	1990-04-02 00:00:00	1990-04-02	38000177		0	0	14		0	0	0	212513	0	313782	1127433		
89470	1962	40213260	2014-04-09	2014-04-09 00:00:00	2014-04-09	2014-04-09 00:00:00	2014-04-09	581452		0	0	0		0	0	0	130526	0	121	40213260		
79025	1729	40213160	1978-05-17	1978-05-17 00:00:00	1978-05-17	1978-05-17 00:00:00	1978-05-17	581452		0	0	0		0	0	0	115647	0	10	40213160		
46395	3843	1127433	1998-05-24	1998-05-24 00:00:00	1998-06-07	1998-06-07 00:00:00	1998-06-07	38000177		0	0	14		0	0	0	255064	0	313782	1127433		
192330	4225	40213160	1983-11-17	1983-11-17 00:00:00	1983-11-17	1983-11-17 00:00:00	1983-11-17	581452		0	0	0		0	0	0	280592	0	10	40213160		
100895	2211	40213160	1972-02-27	1972-02-27 00:00:00	1972-02-27	1972-02-27 00:00:00	1972-02-27	581452		0	0	0		0	0	0	147339	0	10	40213160		
90473	1986	40213227	2011-02-01	2011-02-01 00:00:00	2011-02-01	2011-02-01 00:00:00	2011-02-01	581452		0	0	0		0	0	0	132223	0	113	40213227		
33794	738	40213227	2000-08-22	2000-08-22 00:00:00	2000-08-22	2000-08-22 00:00:00	2000-08-22	581452		0	0	0		0	0	0	48897	0	113	40213227		
34737	758	40213227	2006-05-14	2006-05-14 00:00:00	2006-05-14	2006-05-14 00:00:00	2006-05-14	581452		0	0	0		0	0	0	50335	0	113	40213227		
33558	732	40213314	1977-03-24	1977-03-24 00:00:00	1977-03-24	1977-03-24 00:00:00	1977-03-24	581452		0	0	0		0	0	0	48557	0	49	40213314		
38184	3159	40220960	2001-05-03	2001-05-03 00:00:00	2001-05-03	2001-05-03 00:00:00	2001-05-03	38000177		0	0	0		0	0	0	210030	0	1804799	40220960		
205255	4504	40213160	1967-04-29	1967-04-29 00:00:00	1967-04-29	1967-04-29 00:00:00	1967-04-29	581452		0	0	0		0	0	0	299945	0	10	40213160		
119115	2619	40213201	2005-10-28	2005-10-28 00:00:00	2005-10-28	2005-10-28 00:00:00	2005-10-28	581452		0	0	0		0	0	0	173194	0	33	40213201		
166851	3668	40213227	2006-09-17	2006-09-17 00:00:00	2006-09-17	2006-09-17 00:00:00	2006-09-17	581452		0	0	0		0	0	0	244062	0	113	40213227		
127514	2804	40213160	1956-09-19	1956-09-19 00:00:00	1956-09-19	1956-09-19 00:00:00	1956-09-19	581452		0	0	0		0	0	0	185874	0	10	40213160		
49293	1079	40213160	1961-06-25	1961-06-25 00:00:00	1961-06-25	1961-06-25 00:00:00	1961-06-25	581452		0	0	0		0	0	0	70772	0	10	40213160		
29742	2463	1127433	1999-01-04	1999-01-04 00:00:00	1999-01-18	1999-01-18 00:00:00	1999-01-18	38000177		0	0	14		0	0	0	163390	0	313782	1127433		
218322	4791	40213227	2008-08-14	2008-08-14 00:00:00	2008-08-14	2008-08-14 00:00:00	2008-08-14	581452		0	0	0		0	0	0	318821	0	113	40213227		
229301	5039	40213227	2016-04-26	2016-04-26 00:00:00	2016-04-26	2016-04-26 00:00:00	2016-04-26	581452		0	0	0		0	0	0	334906	0	113	40213227		
63448	5272	1127433	1972-01-04	1972-01-04 00:00:00	1972-01-18	1972-01-18 00:00:00	1972-01-18	38000177		0	0	14		0	0	0	350656	0	313782	1127433		
43252	3582	1124300	2001-07-30	2001-07-30 00:00:00	2001-07-30	2001-07-30 00:00:00	\N	38000177		0	0	0		0	0	0	238141	0	00781178901	45011828		
229442	5043	40213314	1977-11-18	1977-11-18 00:00:00	1977-11-18	1977-11-18 00:00:00	1977-11-18	581452		0	0	0		0	0	0	335143	0	49	40213314		
15660	1306	1127433	1970-03-29	1970-03-29 00:00:00	1970-04-05	1970-04-05 00:00:00	1970-04-05	38000177		0	0	7		0	0	0	86168	0	313782	1127433		
15699	1309	1713671	1980-09-24	1980-09-24 00:00:00	1980-10-15	1980-10-15 00:00:00	1980-10-15	38000177		0	0	21		0	0	0	86454	0	562251	1713671		
177081	3891	40213160	1983-08-03	1983-08-03 00:00:00	1983-08-03	1983-08-03 00:00:00	1983-08-03	581452		0	0	0		0	0	0	258646	0	10	40213160		
176007	3869	40213227	1992-10-24	1992-10-24 00:00:00	1992-10-24	1992-10-24 00:00:00	1992-10-24	581452		0	0	0		0	0	0	256840	0	113	40213227		
108220	2372	40213296	1999-04-09	1999-04-09 00:00:00	1999-04-09	1999-04-09 00:00:00	1999-04-09	581452		0	0	0		0	0	0	157856	0	52	40213296		
45258	3745	1115171	1997-02-23	1997-02-23 00:00:00	1997-04-01	1997-04-01 00:00:00	1997-04-01	38000177		0	0	37		0	0	0	248878	0	849574	1115171		
26363	2168	1127433	1987-03-19	1987-03-19 00:00:00	1987-03-26	1987-03-26 00:00:00	1987-03-26	38000177		0	0	7		0	0	0	144462	0	313782	1127433		
55787	4631	19133873	1921-03-14	1921-03-14 00:00:00	1921-03-23	1921-03-23 00:00:00	1921-03-23	38000177		0	0	9		0	0	0	308562	0	834061	19133873		
16834	1391	19133905	1951-09-14	1951-09-14 00:00:00	1951-09-27	1951-09-27 00:00:00	1951-09-27	38000177		0	0	13		0	0	0	92321	0	834102	19133905		
28247	2333	19059056	1925-11-23	1925-11-23 00:00:00	1925-12-07	1925-12-07 00:00:00	1925-12-07	38000177		0	0	14		0	0	0	155259	0	243670	19059056		
8998	752	1127433	1952-12-09	1952-12-09 00:00:00	1952-12-23	1952-12-23 00:00:00	1952-12-23	38000177		0	0	14		0	0	0	49701	0	313782	1127433		
28361	2341	40171902	2002-03-28	2002-03-28 00:00:00	2002-03-28	2002-03-28 00:00:00	\N	38000177		0	0	0		0	0	0	155811	0	897718	40171902		
79785	1745	40213160	1979-09-24	1979-09-24 00:00:00	1979-09-24	1979-09-24 00:00:00	1979-09-24	581452		0	0	0		0	0	0	116678	0	10	40213160		
116695	2564	40213227	2017-11-11	2017-11-11 00:00:00	2017-11-11	2017-11-11 00:00:00	2017-11-11	581452		0	0	0		0	0	0	169872	0	113	40213227		
39086	3231	1713671	2012-04-01	2012-04-01 00:00:00	2012-04-08	2012-04-08 00:00:00	2012-04-08	38000177		0	0	7		0	0	0	214760	0	562251	1713671		
38995	3223	19059056	1938-04-25	1938-04-25 00:00:00	1938-05-23	1938-05-23 00:00:00	1938-05-23	38000177		0	0	28		0	0	0	214309	0	243670	19059056		
168228	3698	40213227	2002-03-12	2002-03-12 00:00:00	2002-03-12	2002-03-12 00:00:00	2002-03-12	581452		0	0	0		0	0	0	245841	0	113	40213227		
3616	298	19126352	2019-02-12	2019-02-12 00:00:00	2019-02-12	2019-02-12 00:00:00	\N	38000177		0	0	0		0	0	0	19944	0	705129	19126352		
7965	665	1127433	2011-08-23	2011-08-23 00:00:00	2011-09-06	2011-09-06 00:00:00	2011-09-06	38000177		0	0	14		0	0	0	43975	0	313782	1127433		
126454	2781	40213227	2011-10-21	2011-10-21 00:00:00	2011-10-21	2011-10-21 00:00:00	2011-10-21	581452		0	0	0		0	0	0	184307	0	113	40213227		
50134	4160	19059056	1969-02-28	1969-02-28 00:00:00	1969-04-04	1969-04-04 00:00:00	1969-04-04	38000177		0	0	35		0	0	0	276448	0	243670	19059056		
14312	1202	1127433	1993-01-01	1993-01-01 00:00:00	1993-01-08	1993-01-08 00:00:00	1993-01-08	38000177		0	0	7		0	0	0	79066	0	313782	1127433		
27438	598	40213306	1996-11-22	1996-11-22 00:00:00	1996-11-22	1996-11-22 00:00:00	1996-11-22	581452		0	0	0		0	0	0	39520	0	43	40213306		
14415	1211	1127433	2004-04-02	2004-04-02 00:00:00	2004-04-16	2004-04-16 00:00:00	2004-04-16	38000177		0	0	14		0	0	0	79575	0	313782	1127433		
181939	3997	40213260	2016-11-21	2016-11-21 00:00:00	2016-11-21	2016-11-21 00:00:00	2016-11-21	581452		0	0	0		0	0	0	265708	0	121	40213260		
48043	1051	40213227	2016-02-16	2016-02-16 00:00:00	2016-02-16	2016-02-16 00:00:00	2016-02-16	581452		0	0	0		0	0	0	68895	0	113	40213227		
51175	1120	40213227	2019-02-04	2019-02-04 00:00:00	2019-02-04	2019-02-04 00:00:00	2019-02-04	581452		0	0	0		0	0	0	73809	0	113	40213227		
167218	3676	40213160	1971-02-18	1971-02-18 00:00:00	1971-02-18	1971-02-18 00:00:00	1971-02-18	581452		0	0	0		0	0	0	244526	0	10	40213160		
13601	1138	1127078	1984-02-09	1984-02-09 00:00:00	1984-03-15	1984-03-15 00:00:00	1984-03-15	38000177		0	0	35		0	0	0	75130	0	282464	1127078		
62089	1356	40213160	1971-05-14	1971-05-14 00:00:00	1971-05-14	1971-05-14 00:00:00	1971-05-14	581452		0	0	0		0	0	0	89868	0	10	40213160		
118975	2617	40213260	2006-03-04	2006-03-04 00:00:00	2006-03-04	2006-03-04 00:00:00	2006-03-04	581452		0	0	0		0	0	0	173047	0	121	40213260		
5618	470	19059056	1959-03-14	1959-03-14 00:00:00	1959-03-28	1959-03-28 00:00:00	1959-03-28	38000177		0	0	14		0	0	0	31422	0	243670	19059056		
60936	5067	40224805	1996-04-17	1996-04-17 00:00:00	1997-04-12	1997-04-12 00:00:00	1997-04-12	38000177		0	0	360		0	0	0	336892	0	1000126	40224805		
17323	1435	1127433	2002-05-26	2002-05-26 00:00:00	2002-06-30	2002-06-30 00:00:00	2002-06-30	38000177		0	0	35		0	0	0	95585	0	313782	1127433		
66489	1454	40213227	1994-01-07	1994-01-07 00:00:00	1994-01-07	1994-01-07 00:00:00	1994-01-07	581452		0	0	0		0	0	0	96984	0	113	40213227		
157969	3477	40213296	2001-06-26	2001-06-26 00:00:00	2001-06-26	2001-06-26 00:00:00	2001-06-26	581452		0	0	0		0	0	0	230684	0	52	40213296		
56752	4707	1127078	1975-03-30	1975-03-30 00:00:00	1975-04-13	1975-04-13 00:00:00	1975-04-13	38000177		0	0	14		0	0	0	313594	0	282464	1127078		
63056	1379	40213160	1960-07-23	1960-07-23 00:00:00	1960-07-23	1960-07-23 00:00:00	1960-07-23	581452		0	0	0		0	0	0	91464	0	10	40213160		
117268	2577	40213160	1973-08-18	1973-08-18 00:00:00	1973-08-18	1973-08-18 00:00:00	1973-08-18	581452		0	0	0		0	0	0	170643	0	10	40213160		
121012	2659	40213227	1997-04-30	1997-04-30 00:00:00	1997-04-30	1997-04-30 00:00:00	1997-04-30	581452		0	0	0		0	0	0	176170	0	113	40213227		
50660	1110	40213306	2005-09-05	2005-09-05 00:00:00	2005-09-05	2005-09-05 00:00:00	2005-09-05	581452		0	0	0		0	0	0	73085	0	43	40213306		
161643	3556	40213306	2000-09-18	2000-09-18 00:00:00	2000-09-18	2000-09-18 00:00:00	2000-09-18	581452		0	0	0		0	0	0	236140	0	43	40213306		
38668	3195	1127433	2006-10-21	2006-10-21 00:00:00	2006-11-04	2006-11-04 00:00:00	2006-11-04	38000177		0	0	14		0	0	0	212573	0	313782	1127433		
89471	1962	40213227	2006-04-19	2006-04-19 00:00:00	2006-04-19	2006-04-19 00:00:00	2006-04-19	581452		0	0	0		0	0	0	130522	0	113	40213227		
79027	1729	40213227	2008-10-22	2008-10-22 00:00:00	2008-10-22	2008-10-22 00:00:00	2008-10-22	581452		0	0	0		0	0	0	115641	0	113	40213227		
46396	3844	19078461	1985-09-03	1985-09-03 00:00:00	1985-09-24	1985-09-24 00:00:00	1985-09-24	38000177		0	0	21		0	0	0	255130	0	310965	19078461		
192342	4225	40213227	2001-09-20	2001-09-20 00:00:00	2001-09-20	2001-09-20 00:00:00	2001-09-20	581452		0	0	0		0	0	0	280608	0	113	40213227		
100897	2211	40213160	1971-09-26	1971-09-26 00:00:00	1971-09-26	1971-09-26 00:00:00	1971-09-26	581452		0	0	0		0	0	0	147338	0	10	40213160		
90475	1986	40213160	1980-07-29	1980-07-29 00:00:00	1980-07-29	1980-07-29 00:00:00	1980-07-29	581452		0	0	0		0	0	0	132269	0	10	40213160		
33795	738	40213306	2000-08-22	2000-08-22 00:00:00	2000-08-22	2000-08-22 00:00:00	2000-08-22	581452		0	0	0		0	0	0	48897	0	43	40213306		
34739	758	40213306	1996-09-01	1996-09-01 00:00:00	1996-09-01	1996-09-01 00:00:00	1996-09-01	581452		0	0	0		0	0	0	50352	0	43	40213306		
33560	732	40213160	1977-03-24	1977-03-24 00:00:00	1977-03-24	1977-03-24 00:00:00	1977-03-24	581452		0	0	0		0	0	0	48557	0	10	40213160		
38185	3159	1124300	2000-01-26	2000-01-26 00:00:00	2000-01-26	2000-01-26 00:00:00	\N	38000177		0	0	0		0	0	0	210030	0	00781178901	45011828		
32842	718	40213160	1966-08-06	1966-08-06 00:00:00	1966-08-06	1966-08-06 00:00:00	1966-08-06	581452		0	0	0		0	0	0	47444	0	10	40213160		
119128	2619	40213227	2000-09-29	2000-09-29 00:00:00	2000-09-29	2000-09-29 00:00:00	2000-09-29	581452		0	0	0		0	0	0	173246	0	113	40213227		
166852	3668	40213227	1997-09-28	1997-09-28 00:00:00	1997-09-28	1997-09-28 00:00:00	1997-09-28	581452		0	0	0		0	0	0	244026	0	113	40213227		
127520	2804	40213198	2017-01-04	2017-01-04 00:00:00	2017-01-04	2017-01-04 00:00:00	2017-01-04	581452		0	0	0		0	0	0	185889	0	133	40213198		
49295	1079	40213296	2002-08-25	2002-08-25 00:00:00	2002-08-25	2002-08-25 00:00:00	2002-08-25	581452		0	0	0		0	0	0	70727	0	52	40213296		
29743	2463	19133905	2004-05-30	2004-05-30 00:00:00	2004-06-10	2004-06-10 00:00:00	2004-06-10	38000177		0	0	11		0	0	0	163391	0	834102	19133905		
218323	4791	40213296	2008-08-14	2008-08-14 00:00:00	2008-08-14	2008-08-14 00:00:00	2008-08-14	581452		0	0	0		0	0	0	318821	0	52	40213296		
229302	5039	40213296	2016-04-26	2016-04-26 00:00:00	2016-04-26	2016-04-26 00:00:00	2016-04-26	581452		0	0	0		0	0	0	334906	0	52	40213296		
63449	5272	40229134	1949-04-29	1949-04-29 00:00:00	1949-05-13	1949-05-13 00:00:00	1949-05-13	38000177		0	0	14		0	0	0	350670	0	1043400	40229134		
43254	3582	1127433	1999-10-11	1999-10-11 00:00:00	1999-10-18	1999-10-18 00:00:00	1999-10-18	38000177		0	0	7		0	0	0	238138	0	313782	1127433		
229447	5043	40213227	1996-02-16	1996-02-16 00:00:00	1996-02-16	1996-02-16 00:00:00	1996-02-16	581452		0	0	0		0	0	0	335151	0	113	40213227		
15661	1306	1127433	1971-04-02	1971-04-02 00:00:00	1971-04-09	1971-04-09 00:00:00	1971-04-09	38000177		0	0	7		0	0	0	86169	0	313782	1127433		
15700	1309	1713671	1963-02-07	1963-02-07 00:00:00	1963-02-21	1963-02-21 00:00:00	1963-02-21	38000177		0	0	14		0	0	0	86517	0	562251	1713671		
177082	3891	40213314	1983-03-02	1983-03-02 00:00:00	1983-03-02	1983-03-02 00:00:00	1983-03-02	581452		0	0	0		0	0	0	258645	0	49	40213314		
240164	5272	40213227	1998-06-10	1998-06-10 00:00:00	1998-06-10	1998-06-10 00:00:00	1998-06-10	581452		0	0	0		0	0	0	350603	0	113	40213227		
108231	2373	40213260	2007-01-25	2007-01-25 00:00:00	2007-01-25	2007-01-25 00:00:00	2007-01-25	581452		0	0	0		0	0	0	157967	0	121	40213260		
45259	3745	1551192	1935-05-19	1935-05-19 00:00:00	1935-05-19	1935-05-19 00:00:00	1935-05-19	38000177		0	0	0		0	0	0	248876	0	312617	1551192		
26364	2168	40232448	1958-10-04	1958-10-04 00:00:00	1958-10-04	1958-10-04 00:00:00	\N	38000177		0	0	0		0	0	0	144534	0	1049630	40232448		
55788	4631	1713671	1950-02-15	1950-02-15 00:00:00	1950-03-01	1950-03-01 00:00:00	1950-03-01	38000177		0	0	14		0	0	0	308565	0	562251	1713671		
16835	1391	1713671	1930-09-27	1930-09-27 00:00:00	1930-10-04	1930-10-04 00:00:00	1930-10-04	38000177		0	0	7		0	0	0	92328	0	562251	1713671		
28248	2333	19018935	1990-04-17	1990-04-17 00:00:00	1990-04-17	1990-04-17 00:00:00	\N	38000177		0	0	0		0	0	0	155231	0	197604	19018935		
8999	752	1713671	1967-07-16	1967-07-16 00:00:00	1967-07-23	1967-07-23 00:00:00	1967-07-23	38000177		0	0	7		0	0	0	49677	0	562251	1713671		
28362	2341	1127433	1969-02-17	1969-02-17 00:00:00	1969-03-03	1969-03-03 00:00:00	1969-03-03	38000177		0	0	14		0	0	0	155802	0	313782	1127433		
79791	1746	40213227	1994-11-24	1994-11-24 00:00:00	1994-11-24	1994-11-24 00:00:00	1994-11-24	581452		0	0	0		0	0	0	116777	0	113	40213227		
116696	2564	40213296	2017-11-11	2017-11-11 00:00:00	2017-11-11	2017-11-11 00:00:00	2017-11-11	581452		0	0	0		0	0	0	169872	0	52	40213296		
39087	3231	1127433	1989-04-06	1989-04-06 00:00:00	1989-05-06	1989-05-06 00:00:00	1989-05-06	38000177		0	0	30		0	0	0	214794	0	313782	1127433		
38996	3223	1118084	1959-12-21	1959-12-21 00:00:00	1959-12-21	1959-12-21 00:00:00	\N	38000177		0	0	0		0	0	0	214325	0	00025152531	44923712		
168236	3698	40213227	1993-03-16	1993-03-16 00:00:00	1993-03-16	1993-03-16 00:00:00	1993-03-16	581452		0	0	0		0	0	0	245812	0	113	40213227		
3617	298	19075601	2019-02-12	2019-02-12 00:00:00	2019-02-12	2019-02-12 00:00:00	\N	38000177		0	0	0		0	0	0	19944	0	309362	19075601		
18427	1525	19128065	1985-06-16	1985-06-16 00:00:00	1986-06-11	1986-06-11 00:00:00	1986-06-11	38000177		0	0	360		0	0	0	102013	0	749882	19128065		
126456	2782	40213227	1992-07-29	1992-07-29 00:00:00	1992-07-29	1992-07-29 00:00:00	1992-07-29	581452		0	0	0		0	0	0	184376	0	113	40213227		
50135	4160	40229134	2004-05-13	2004-05-13 00:00:00	2004-05-27	2004-05-27 00:00:00	2004-05-27	38000177		0	0	14		0	0	0	276457	0	1043400	40229134		
14313	1202	40236824	2013-08-14	2013-08-14 00:00:00	2013-08-21	2013-08-21 00:00:00	2013-08-21	38000177		0	0	7		0	0	0	79068	0	1094107	40236824		
27441	598	40213227	1996-11-22	1996-11-22 00:00:00	1996-11-22	1996-11-22 00:00:00	1996-11-22	581452		0	0	0		0	0	0	39520	0	113	40213227		
14416	1211	1118084	2004-12-31	2004-12-31 00:00:00	2004-12-31	2004-12-31 00:00:00	\N	38000177		0	0	0		0	0	0	79575	0	00025152531	44923712		
181941	3997	40213160	1967-05-01	1967-05-01 00:00:00	1967-05-01	1967-05-01 00:00:00	1967-05-01	581452		0	0	0		0	0	0	265736	0	10	40213160		
48044	1051	40213260	2016-02-16	2016-02-16 00:00:00	2016-02-16	2016-02-16 00:00:00	2016-02-16	581452		0	0	0		0	0	0	68895	0	121	40213260		
51180	1120	40213227	1992-01-20	1992-01-20 00:00:00	1992-01-20	1992-01-20 00:00:00	1992-01-20	581452		0	0	0		0	0	0	73817	0	113	40213227		
167220	3676	40213160	1971-04-22	1971-04-22 00:00:00	1971-04-22	1971-04-22 00:00:00	1971-04-22	581452		0	0	0		0	0	0	244491	0	10	40213160		
13602	1138	19019979	1985-06-24	1985-06-24 00:00:00	1985-07-08	1985-07-08 00:00:00	1985-07-08	38000177		0	0	14		0	0	0	75007	0	198405	19019979		
62095	1356	40213227	2002-12-06	2002-12-06 00:00:00	2002-12-06	2002-12-06 00:00:00	2002-12-06	581452		0	0	0		0	0	0	89925	0	113	40213227		
118979	2617	40213198	2017-09-23	2017-09-23 00:00:00	2017-09-23	2017-09-23 00:00:00	2017-09-23	581452		0	0	0		0	0	0	173109	0	133	40213198		
5619	470	19006318	1959-03-14	1959-03-14 00:00:00	1959-03-28	1959-03-28 00:00:00	1959-03-28	38000177		0	0	14		0	0	0	31422	0	105078	19006318		
60937	5067	19133873	1974-08-04	1974-08-04 00:00:00	1974-08-14	1974-08-14 00:00:00	1974-08-14	38000177		0	0	10		0	0	0	336887	0	834061	19133873		
17324	1435	19059056	1984-05-18	1984-05-18 00:00:00	1984-06-01	1984-06-01 00:00:00	1984-06-01	38000177		0	0	14		0	0	0	95582	0	243670	19059056		
56657	4701	1127433	1991-02-01	1991-02-01 00:00:00	1991-02-15	1991-02-15 00:00:00	1991-02-15	38000177		0	0	14		0	0	0	313138	0	313782	1127433		
17551	379	40213160	1975-09-06	1975-09-06 00:00:00	1975-09-06	1975-09-06 00:00:00	1975-09-06	581452		0	0	0		0	0	0	25101	0	10	40213160		
56753	4707	46233988	1975-03-30	1975-03-30 00:00:00	1975-04-13	1975-04-13 00:00:00	1975-04-13	38000177		0	0	14		0	0	0	313594	0	1652673	46233988		
63058	1379	40213160	1964-12-19	1964-12-19 00:00:00	1964-12-19	1964-12-19 00:00:00	1964-12-19	581452		0	0	0		0	0	0	91487	0	10	40213160		
117274	2577	40213314	1977-01-22	1977-01-22 00:00:00	1977-01-22	1977-01-22 00:00:00	1977-01-22	581452		0	0	0		0	0	0	170645	0	49	40213314		
121013	2659	40213306	1997-04-30	1997-04-30 00:00:00	1997-04-30	1997-04-30 00:00:00	1997-04-30	581452		0	0	0		0	0	0	176170	0	43	40213306		
50661	1110	40213180	2005-09-05	2005-09-05 00:00:00	2005-09-05	2005-09-05 00:00:00	2005-09-05	581452		0	0	0		0	0	0	73085	0	114	40213180		
161648	3556	40213160	1983-06-27	1983-06-27 00:00:00	1983-06-27	1983-06-27 00:00:00	1983-06-27	581452		0	0	0		0	0	0	236136	0	10	40213160		
38669	3195	19074679	1953-11-21	1953-11-21 00:00:00	1954-06-12	1954-06-12 00:00:00	1954-06-12	38000177		0	0	203		0	0	0	212563	0	308971	19074679		
89472	1962	40213296	2006-04-19	2006-04-19 00:00:00	2006-04-19	2006-04-19 00:00:00	2006-04-19	581452		0	0	0		0	0	0	130522	0	52	40213296		
79030	1729	40213251	1984-08-29	1984-08-29 00:00:00	1984-08-29	1984-08-29 00:00:00	1984-08-29	581452		0	0	0		0	0	0	115662	0	21	40213251		
46397	3844	40229134	1981-04-01	1981-04-01 00:00:00	1981-04-08	1981-04-08 00:00:00	1981-04-08	38000177		0	0	7		0	0	0	255133	0	1043400	40229134		
192343	4225	40213306	2001-09-20	2001-09-20 00:00:00	2001-09-20	2001-09-20 00:00:00	2001-09-20	581452		0	0	0		0	0	0	280608	0	43	40213306		
100902	2211	40213296	2011-06-26	2011-06-26 00:00:00	2011-06-26	2011-06-26 00:00:00	2011-06-26	581452		0	0	0		0	0	0	147317	0	52	40213296		
90482	1986	40213314	1981-01-27	1981-01-27 00:00:00	1981-01-27	1981-01-27 00:00:00	1981-01-27	581452		0	0	0		0	0	0	132216	0	49	40213314		
33802	738	40213251	1984-06-19	1984-06-19 00:00:00	1984-06-19	1984-06-19 00:00:00	1984-06-19	581452		0	0	0		0	0	0	48908	0	21	40213251		
34742	758	40213160	1973-09-02	1973-09-02 00:00:00	1973-09-02	1973-09-02 00:00:00	1973-09-02	581452		0	0	0		0	0	0	50308	0	10	40213160		
33566	732	40213227	2003-10-02	2003-10-02 00:00:00	2003-10-02	2003-10-02 00:00:00	2003-10-02	581452		0	0	0		0	0	0	48540	0	113	40213227		
38186	3159	19075601	2001-05-03	2001-05-03 00:00:00	2001-05-03	2001-05-03 00:00:00	2001-05-03	38000177		0	0	0		0	0	0	210030	0	309362	19075601		
32844	718	40213227	2017-03-04	2017-03-04 00:00:00	2017-03-04	2017-03-04 00:00:00	2017-03-04	581452		0	0	0		0	0	0	47533	0	113	40213227		
119133	2620	40213160	1964-02-18	1964-02-18 00:00:00	1964-02-18	1964-02-18 00:00:00	1964-02-18	581452		0	0	0		0	0	0	173260	0	10	40213160		
166853	3668	40213306	1997-09-28	1997-09-28 00:00:00	1997-09-28	1997-09-28 00:00:00	1997-09-28	581452		0	0	0		0	0	0	244026	0	43	40213306		
135536	2975	40213227	2013-04-14	2013-04-14 00:00:00	2013-04-14	2013-04-14 00:00:00	2013-04-14	581452		0	0	0		0	0	0	198654	0	113	40213227		
49296	1079	40213227	2002-08-25	2002-08-25 00:00:00	2002-08-25	2002-08-25 00:00:00	2002-08-25	581452		0	0	0		0	0	0	70727	0	113	40213227		
29745	2463	19128065	1987-03-17	1987-03-17 00:00:00	1988-03-11	1988-03-11 00:00:00	1988-03-11	38000177		0	0	360		0	0	0	163336	0	749882	19128065		
218335	4792	40213160	1955-02-08	1955-02-08 00:00:00	1955-02-08	1955-02-08 00:00:00	1955-02-08	581452		0	0	0		0	0	0	318900	0	10	40213160		
229304	5039	40213227	1996-12-17	1996-12-17 00:00:00	1996-12-17	1996-12-17 00:00:00	1996-12-17	581452		0	0	0		0	0	0	334875	0	113	40213227		
63450	5272	19133905	1966-12-25	1966-12-25 00:00:00	1967-01-01	1967-01-01 00:00:00	1967-01-01	38000177		0	0	7		0	0	0	350673	0	834102	19133905		
43255	3582	19078461	2014-12-17	2014-12-17 00:00:00	2015-03-17	2015-03-17 00:00:00	2015-03-17	38000177		0	0	90		0	0	0	238126	0	310965	19078461		
229448	5043	40213306	1996-02-16	1996-02-16 00:00:00	1996-02-16	1996-02-16 00:00:00	1996-02-16	581452		0	0	0		0	0	0	335151	0	43	40213306		
15662	1306	40236824	2008-10-17	2008-10-17 00:00:00	2008-10-31	2008-10-31 00:00:00	2008-10-31	38000177		0	0	14		0	0	0	86195	0	1094107	40236824		
15701	1309	1127433	1970-08-25	1970-08-25 00:00:00	1970-09-01	1970-09-01 00:00:00	1970-09-01	38000177		0	0	7		0	0	0	86458	0	313782	1127433		
177083	3891	40213160	1983-03-02	1983-03-02 00:00:00	1983-03-02	1983-03-02 00:00:00	1983-03-02	581452		0	0	0		0	0	0	258645	0	10	40213160		
31450	685	40213160	1966-05-16	1966-05-16 00:00:00	1966-05-16	1966-05-16 00:00:00	1966-05-16	581452		0	0	0		0	0	0	45280	0	10	40213160		
108233	2373	40213227	2007-01-25	2007-01-25 00:00:00	2007-01-25	2007-01-25 00:00:00	2007-01-25	581452		0	0	0		0	0	0	157967	0	113	40213227		
45260	3745	40229134	1944-02-28	1944-02-28 00:00:00	1944-03-13	1944-03-13 00:00:00	1944-03-13	38000177		0	0	14		0	0	0	248909	0	1043400	40229134		
26365	2168	19059056	1963-12-02	1963-12-02 00:00:00	1963-12-16	1963-12-16 00:00:00	1963-12-16	38000177		0	0	14		0	0	0	144577	0	243670	19059056		
55789	4631	19133905	2009-09-08	2009-09-08 00:00:00	2009-09-17	2009-09-17 00:00:00	2009-09-17	38000177		0	0	9		0	0	0	308643	0	834102	19133905		
16836	1391	19059056	1947-03-20	1947-03-20 00:00:00	1947-04-17	1947-04-17 00:00:00	1947-04-17	38000177		0	0	28		0	0	0	92392	0	243670	19059056		
28249	2333	40171902	1990-04-17	1990-04-17 00:00:00	1990-04-17	1990-04-17 00:00:00	\N	38000177		0	0	0		0	0	0	155231	0	897718	40171902		
9000	752	1713671	1950-04-29	1950-04-29 00:00:00	1950-05-20	1950-05-20 00:00:00	1950-05-20	38000177		0	0	21		0	0	0	49716	0	562251	1713671		
28363	2341	1115171	2005-09-25	2005-09-25 00:00:00	2005-10-09	2005-10-09 00:00:00	2005-10-09	38000177		0	0	14		0	0	0	155806	0	849574	1115171		
79794	1746	40213160	1955-04-21	1955-04-21 00:00:00	1955-04-21	1955-04-21 00:00:00	1955-04-21	581452		0	0	0		0	0	0	116731	0	10	40213160		
116700	2564	40213314	1977-10-29	1977-10-29 00:00:00	1977-10-29	1977-10-29 00:00:00	1977-10-29	581452		0	0	0		0	0	0	169856	0	49	40213314		
39088	3231	40165015	1989-04-06	1989-04-06 00:00:00	1989-04-06	1989-04-06 00:00:00	\N	38000177		0	0	0		0	0	0	214794	0	861467	40165015		
38997	3223	40229134	1923-07-14	1923-07-14 00:00:00	1923-07-28	1923-07-28 00:00:00	1923-07-28	38000177		0	0	14		0	0	0	214258	0	1043400	40229134		
113022	2482	40213227	2006-04-13	2006-04-13 00:00:00	2006-04-13	2006-04-13 00:00:00	2006-04-13	581452		0	0	0		0	0	0	164443	0	113	40213227		
3618	298	1539411	2019-02-12	2019-02-12 00:00:00	2019-02-12	2019-02-12 00:00:00	\N	38000177		0	0	0		0	0	0	19944	0	312961	1539411		
18428	1525	1127078	1965-12-18	1965-12-18 00:00:00	1966-01-01	1966-01-01 00:00:00	1966-01-01	38000177		0	0	14		0	0	0	102025	0	282464	1127078		
126493	2782	40213227	2001-03-28	2001-03-28 00:00:00	2001-03-28	2001-03-28 00:00:00	2001-03-28	581452		0	0	0		0	0	0	184457	0	113	40213227		
21110	458	40213227	2005-07-03	2005-07-03 00:00:00	2005-07-03	2005-07-03 00:00:00	2005-07-03	581452		0	0	0		0	0	0	30661	0	113	40213227		
14314	1202	920300	2013-08-14	2013-08-14 00:00:00	2013-08-21	2013-08-21 00:00:00	2013-08-21	38000177		0	0	7		0	0	0	79068	0	311989	920300		
27442	598	40213160	1975-02-28	1975-02-28 00:00:00	1975-02-28	1975-02-28 00:00:00	1975-02-28	581452		0	0	0		0	0	0	39512	0	10	40213160		
14417	1211	19059056	1966-12-06	1966-12-06 00:00:00	1966-12-20	1966-12-20 00:00:00	1966-12-20	38000177		0	0	14		0	0	0	79564	0	243670	19059056		
181946	3997	40213306	1990-02-26	1990-02-26 00:00:00	1990-02-26	1990-02-26 00:00:00	1990-02-26	581452		0	0	0		0	0	0	265719	0	43	40213306		
155818	3430	40213260	2012-04-14	2012-04-14 00:00:00	2012-04-14	2012-04-14 00:00:00	2012-04-14	581452		0	0	0		0	0	0	227376	0	121	40213260		
51184	1120	40213227	1999-12-13	1999-12-13 00:00:00	1999-12-13	1999-12-13 00:00:00	1999-12-13	581452		0	0	0		0	0	0	73840	0	113	40213227		
169693	3731	40213227	2005-10-29	2005-10-29 00:00:00	2005-10-29	2005-10-29 00:00:00	2005-10-29	581452		0	0	0		0	0	0	247900	0	113	40213227		
13603	1138	1150837	1985-02-19	1985-02-19 00:00:00	1985-02-19	1985-02-19 00:00:00	\N	38000177		0	0	0		0	0	0	75038	0	141918	1150837		
62099	1356	40213306	1993-11-26	1993-11-26 00:00:00	1993-11-26	1993-11-26 00:00:00	1993-11-26	581452		0	0	0		0	0	0	89977	0	43	40213306		
118981	2617	40213160	1956-09-22	1956-09-22 00:00:00	1956-09-22	1956-09-22 00:00:00	1956-09-22	581452		0	0	0		0	0	0	173088	0	10	40213160		
5620	470	1127433	2013-01-27	2013-01-27 00:00:00	2013-02-10	2013-02-10 00:00:00	2013-02-10	38000177		0	0	14		0	0	0	31409	0	313782	1127433		
60938	5068	19059056	1987-10-08	1987-10-08 00:00:00	1987-10-22	1987-10-22 00:00:00	1987-10-22	38000177		0	0	14		0	0	0	336992	0	243670	19059056		
179183	3939	40213227	2015-04-12	2015-04-12 00:00:00	2015-04-12	2015-04-12 00:00:00	2015-04-12	581452		0	0	0		0	0	0	261832	0	113	40213227		
56658	4701	19059056	1973-12-22	1973-12-22 00:00:00	1974-01-05	1974-01-05 00:00:00	1974-01-05	38000177		0	0	14		0	0	0	313129	0	243670	19059056		
17553	379	40213227	2007-07-21	2007-07-21 00:00:00	2007-07-21	2007-07-21 00:00:00	2007-07-21	581452		0	0	0		0	0	0	25089	0	113	40213227		
56754	4707	1127433	1980-11-30	1980-11-30 00:00:00	1980-12-14	1980-12-14 00:00:00	1980-12-14	38000177		0	0	14		0	0	0	313580	0	313782	1127433		
63064	1379	40213296	2001-02-10	2001-02-10 00:00:00	2001-02-10	2001-02-10 00:00:00	2001-02-10	581452		0	0	0		0	0	0	91470	0	52	40213296		
117281	2578	40213227	2012-09-06	2012-09-06 00:00:00	2012-09-06	2012-09-06 00:00:00	2012-09-06	581452		0	0	0		0	0	0	170768	0	113	40213227		
121017	2659	40213227	2016-08-10	2016-08-10 00:00:00	2016-08-10	2016-08-10 00:00:00	2016-08-10	581452		0	0	0		0	0	0	176129	0	113	40213227		
50663	1110	40213306	2002-09-02	2002-09-02 00:00:00	2002-09-02	2002-09-02 00:00:00	2002-09-02	581452		0	0	0		0	0	0	73128	0	43	40213306		
161654	3556	40213296	2018-07-23	2018-07-23 00:00:00	2018-07-23	2018-07-23 00:00:00	2018-07-23	581452		0	0	0		0	0	0	236101	0	52	40213296		
38670	3195	19133873	1962-03-30	1962-03-30 00:00:00	1962-04-10	1962-04-10 00:00:00	1962-04-10	38000177		0	0	11		0	0	0	212515	0	834061	19133873		
205631	4513	40213296	2001-12-26	2001-12-26 00:00:00	2001-12-26	2001-12-26 00:00:00	2001-12-26	581452		0	0	0		0	0	0	300527	0	52	40213296		
79037	1729	40213227	1999-10-13	1999-10-13 00:00:00	1999-10-13	1999-10-13 00:00:00	1999-10-13	581452		0	0	0		0	0	0	115617	0	113	40213227		
46398	3844	40236446	1964-08-26	1964-08-26 00:00:00	1970-09-04	1970-09-04 00:00:00	1970-09-04	38000177		0	0	2200		0	0	0	255156	0	1091392	40236446		
192348	4226	40213306	1983-03-20	1983-03-20 00:00:00	1983-03-20	1983-03-20 00:00:00	1983-03-20	581452		0	0	0		0	0	0	280718	0	43	40213306		
100903	2211	40213160	1971-11-28	1971-11-28 00:00:00	1971-11-28	1971-11-28 00:00:00	1971-11-28	581452		0	0	0		0	0	0	147347	0	10	40213160		
90486	1986	40213227	2002-01-22	2002-01-22 00:00:00	2002-01-22	2002-01-22 00:00:00	2002-01-22	581452		0	0	0		0	0	0	132236	0	113	40213227		
33806	738	40213160	1978-12-12	1978-12-12 00:00:00	1978-12-12	1978-12-12 00:00:00	1978-12-12	581452		0	0	0		0	0	0	48882	0	10	40213160		
34747	758	40213160	1978-03-05	1978-03-05 00:00:00	1978-03-05	1978-03-05 00:00:00	1978-03-05	581452		0	0	0		0	0	0	50344	0	10	40213160		
203814	4474	40213160	1963-09-13	1963-09-13 00:00:00	1963-09-13	1963-09-13 00:00:00	1963-09-13	581452		0	0	0		0	0	0	297644	0	10	40213160		
38187	3159	40236824	2014-07-05	2014-07-05 00:00:00	2014-07-12	2014-07-12 00:00:00	2014-07-12	38000177		0	0	7		0	0	0	210027	0	1094107	40236824		
32845	718	40213260	2017-03-04	2017-03-04 00:00:00	2017-03-04	2017-03-04 00:00:00	2017-03-04	581452		0	0	0		0	0	0	47533	0	121	40213260		
119135	2620	40213260	2013-11-12	2013-11-12 00:00:00	2013-11-12	2013-11-12 00:00:00	2013-11-12	581452		0	0	0		0	0	0	173268	0	121	40213260		
166856	3668	40213160	1975-12-07	1975-12-07 00:00:00	1975-12-07	1975-12-07 00:00:00	1975-12-07	581452		0	0	0		0	0	0	244009	0	10	40213160		
135537	2975	40213260	2013-04-14	2013-04-14 00:00:00	2013-04-14	2013-04-14 00:00:00	2013-04-14	581452		0	0	0		0	0	0	198654	0	121	40213260		
4474	97	40213198	2010-07-12	2010-07-12 00:00:00	2010-07-12	2010-07-12 00:00:00	2010-07-12	581452		0	0	0		0	0	0	6630	0	133	40213198		
29756	2466	1118084	2018-11-24	2018-11-24 00:00:00	2018-11-24	2018-11-24 00:00:00	\N	38000177		0	0	0		0	0	0	163488	0	00025152531	44923712		
218347	4792	40213227	2012-02-21	2012-02-21 00:00:00	2012-02-21	2012-02-21 00:00:00	2012-02-21	581452		0	0	0		0	0	0	318896	0	113	40213227		
229305	5039	40213306	1996-12-17	1996-12-17 00:00:00	1996-12-17	1996-12-17 00:00:00	1996-12-17	581452		0	0	0		0	0	0	334875	0	43	40213306		
63451	5272	1127433	2013-02-17	2013-02-17 00:00:00	2013-03-03	2013-03-03 00:00:00	2013-03-03	38000177		0	0	14		0	0	0	350632	0	313782	1127433		
43256	3582	1127433	2017-02-14	2017-02-14 00:00:00	2017-02-28	2017-02-28 00:00:00	2017-02-28	38000177		0	0	14		0	0	0	238109	0	313782	1127433		
229451	5043	40213160	1974-08-23	1974-08-23 00:00:00	1974-08-23	1974-08-23 00:00:00	1974-08-23	581452		0	0	0		0	0	0	335141	0	10	40213160		
15663	1306	920300	2008-10-17	2008-10-17 00:00:00	2008-10-24	2008-10-24 00:00:00	2008-10-24	38000177		0	0	7		0	0	0	86195	0	311989	920300		
15703	1309	19133873	1964-05-13	1964-05-13 00:00:00	1964-05-21	1964-05-21 00:00:00	1964-05-21	38000177		0	0	8		0	0	0	86518	0	834061	19133873		
177087	3892	40213296	2002-07-06	2002-07-06 00:00:00	2002-07-06	2002-07-06 00:00:00	2002-07-06	581452		0	0	0		0	0	0	258816	0	52	40213296		
31461	686	40213227	2017-09-23	2017-09-23 00:00:00	2017-09-23	2017-09-23 00:00:00	2017-09-23	581452		0	0	0		0	0	0	45426	0	113	40213227		
108239	2373	40213227	2017-03-23	2017-03-23 00:00:00	2017-03-23	2017-03-23 00:00:00	2017-03-23	581452		0	0	0		0	0	0	157910	0	113	40213227		
45261	3746	1127433	1957-06-28	1957-06-28 00:00:00	1957-07-12	1957-07-12 00:00:00	1957-07-12	38000177		0	0	14		0	0	0	248992	0	313782	1127433		
26385	2172	1127078	1980-01-14	1980-01-14 00:00:00	1980-01-28	1980-01-28 00:00:00	1980-01-28	38000177		0	0	14		0	0	0	144670	0	282464	1127078		
55790	4631	19078461	1997-03-12	1997-03-12 00:00:00	1997-03-26	1997-03-26 00:00:00	1997-03-26	38000177		0	0	14		0	0	0	308559	0	310965	19078461		
5817	486	1124300	1999-03-14	1999-03-14 00:00:00	1999-03-14	1999-03-14 00:00:00	\N	38000177		0	0	0		0	0	0	32508	0	00781178901	45011828		
28250	2333	40163554	1990-04-17	1990-04-17 00:00:00	1990-04-17	1990-04-17 00:00:00	\N	38000177		0	0	0		0	0	0	155231	0	855332	40163554		
9001	752	19059056	1951-10-15	1951-10-15 00:00:00	1952-01-13	1952-01-13 00:00:00	1952-01-13	38000177		0	0	90		0	0	0	49639	0	243670	19059056		
28364	2341	1127433	2006-05-28	2006-05-28 00:00:00	2006-06-04	2006-06-04 00:00:00	2006-06-04	38000177		0	0	7		0	0	0	155817	0	313782	1127433		
79797	1746	40213227	2013-12-19	2013-12-19 00:00:00	2013-12-19	2013-12-19 00:00:00	2013-12-19	581452		0	0	0		0	0	0	116739	0	113	40213227		
116701	2564	40213160	1976-11-27	1976-11-27 00:00:00	1976-11-27	1976-11-27 00:00:00	1976-11-27	581452		0	0	0		0	0	0	169839	0	10	40213160		
3487	289	1713671	2005-02-19	2005-02-19 00:00:00	2005-03-12	2005-03-12 00:00:00	2005-03-12	38000177		0	0	21		0	0	0	19308	0	562251	1713671		
38998	3223	1713671	1953-08-30	1953-08-30 00:00:00	1953-09-20	1953-09-20 00:00:00	1953-09-20	38000177		0	0	21		0	0	0	214262	0	562251	1713671		
230187	5058	40213227	2018-03-11	2018-03-11 00:00:00	2018-03-11	2018-03-11 00:00:00	2018-03-11	581452		0	0	0		0	0	0	336297	0	113	40213227		
3619	298	1332419	2019-02-12	2019-02-12 00:00:00	2019-02-12	2019-02-12 00:00:00	\N	38000177		0	0	0		0	0	0	19944	0	197361	1332419		
18429	1525	19129655	1965-12-18	1965-12-18 00:00:00	1966-01-01	1966-01-01 00:00:00	1966-01-01	38000177		0	0	14		0	0	0	102025	0	789980	19129655		
136853	3004	40213227	2012-02-07	2012-02-07 00:00:00	2012-02-07	2012-02-07 00:00:00	2012-02-07	581452		0	0	0		0	0	0	200452	0	113	40213227		
21116	458	40213296	2013-07-14	2013-07-14 00:00:00	2013-07-14	2013-07-14 00:00:00	2013-07-14	581452		0	0	0		0	0	0	30663	0	52	40213296		
14315	1202	1127433	2019-05-23	2019-05-23 00:00:00	2019-06-06	2019-06-06 00:00:00	2019-06-06	38000177		0	0	14		0	0	0	79083	0	313782	1127433		
27443	598	40213160	1979-08-31	1979-08-31 00:00:00	1979-08-31	1979-08-31 00:00:00	1979-08-31	581452		0	0	0		0	0	0	39516	0	10	40213160		
14418	1211	19059056	1969-03-25	1969-03-25 00:00:00	1969-04-08	1969-04-08 00:00:00	1969-04-08	38000177		0	0	14		0	0	0	79546	0	243670	19059056		
181951	3997	40213260	2017-07-31	2017-07-31 00:00:00	2017-07-31	2017-07-31 00:00:00	2017-07-31	581452		0	0	0		0	0	0	265727	0	121	40213260		
155823	3430	40213160	1961-10-21	1961-10-21 00:00:00	1961-10-21	1961-10-21 00:00:00	1961-10-21	581452		0	0	0		0	0	0	227345	0	10	40213160		
51185	1120	40213296	1999-12-13	1999-12-13 00:00:00	1999-12-13	1999-12-13 00:00:00	1999-12-13	581452		0	0	0		0	0	0	73840	0	52	40213296		
169699	3731	40213227	2016-01-02	2016-01-02 00:00:00	2016-01-02	2016-01-02 00:00:00	2016-01-02	581452		0	0	0		0	0	0	247911	0	113	40213227		
13604	1138	1124300	2016-03-12	2016-03-12 00:00:00	2016-03-12	2016-03-12 00:00:00	\N	38000177		0	0	0		0	0	0	75136	0	00781178901	45011828		
62101	1356	40213227	1993-11-26	1993-11-26 00:00:00	1993-11-26	1993-11-26 00:00:00	1993-11-26	581452		0	0	0		0	0	0	89977	0	113	40213227		
6711	565	19133873	1963-02-24	1963-02-24 00:00:00	1963-03-08	1963-03-08 00:00:00	1963-03-08	38000177		0	0	12		0	0	0	37460	0	834061	19133873		
5621	470	19133873	1960-02-15	1960-02-15 00:00:00	1960-02-22	1960-02-22 00:00:00	1960-02-22	38000177		0	0	7		0	0	0	31412	0	834061	19133873		
60939	5068	19018935	2009-11-28	2009-11-28 00:00:00	2009-11-28	2009-11-28 00:00:00	\N	38000177		0	0	0		0	0	0	336939	0	197604	19018935		
179184	3939	40213296	2015-04-12	2015-04-12 00:00:00	2015-04-12	2015-04-12 00:00:00	2015-04-12	581452		0	0	0		0	0	0	261832	0	52	40213296		
56659	4701	19129655	1973-12-22	1973-12-22 00:00:00	1974-01-05	1974-01-05 00:00:00	1974-01-05	38000177		0	0	14		0	0	0	313129	0	789980	19129655		
17557	379	40213160	1975-07-05	1975-07-05 00:00:00	1975-07-05	1975-07-05 00:00:00	1975-07-05	581452		0	0	0		0	0	0	25110	0	10	40213160		
56755	4709	19059056	1961-11-15	1961-11-15 00:00:00	1961-11-29	1961-11-29 00:00:00	1961-11-29	38000177		0	0	14		0	0	0	313696	0	243670	19059056		
99813	2186	40213160	1973-10-18	1973-10-18 00:00:00	1973-10-18	1973-10-18 00:00:00	1973-10-18	581452		0	0	0		0	0	0	145790	0	10	40213160		
117282	2578	40213296	2012-09-06	2012-09-06 00:00:00	2012-09-06	2012-09-06 00:00:00	2012-09-06	581452		0	0	0		0	0	0	170768	0	52	40213296		
121018	2659	40213296	2016-08-10	2016-08-10 00:00:00	2016-08-10	2016-08-10 00:00:00	2016-08-10	581452		0	0	0		0	0	0	176129	0	52	40213296		
50670	1110	40213314	1982-06-21	1982-06-21 00:00:00	1982-06-21	1982-06-21 00:00:00	1982-06-21	581452		0	0	0		0	0	0	73044	0	49	40213314		
161656	3556	40213251	1984-07-02	1984-07-02 00:00:00	1984-07-02	1984-07-02 00:00:00	1984-07-02	581452		0	0	0		0	0	0	236110	0	21	40213251		
38671	3195	19059056	1951-02-10	1951-02-10 00:00:00	1951-02-24	1951-02-24 00:00:00	1951-02-24	38000177		0	0	14		0	0	0	212517	0	243670	19059056		
205633	4513	40213227	2003-12-31	2003-12-31 00:00:00	2003-12-31	2003-12-31 00:00:00	2003-12-31	581452		0	0	0		0	0	0	300537	0	113	40213227		
6421	140	40213227	1992-01-16	1992-01-16 00:00:00	1992-01-16	1992-01-16 00:00:00	1992-01-16	581452		0	0	0		0	0	0	9335	0	113	40213227		
46399	3844	19133905	1990-03-09	1990-03-09 00:00:00	1990-03-20	1990-03-20 00:00:00	1990-03-20	38000177		0	0	11		0	0	0	255153	0	834102	19133905		
32300	704	40213227	2017-05-17	2017-05-17 00:00:00	2017-05-17	2017-05-17 00:00:00	2017-05-17	581452		0	0	0		0	0	0	46594	0	113	40213227		
100905	2211	40213227	2002-09-01	2002-09-01 00:00:00	2002-09-01	2002-09-01 00:00:00	2002-09-01	581452		0	0	0		0	0	0	147314	0	113	40213227		
90487	1986	40213306	2002-01-22	2002-01-22 00:00:00	2002-01-22	2002-01-22 00:00:00	2002-01-22	581452		0	0	0		0	0	0	132236	0	43	40213306		
33807	738	40213314	1978-12-12	1978-12-12 00:00:00	1978-12-12	1978-12-12 00:00:00	1978-12-12	581452		0	0	0		0	0	0	48882	0	49	40213314		
34750	758	40213314	1977-02-27	1977-02-27 00:00:00	1977-02-27	1977-02-27 00:00:00	1977-02-27	581452		0	0	0		0	0	0	50320	0	49	40213314		
203817	4474	40213296	2003-06-13	2003-06-13 00:00:00	2003-06-13	2003-06-13 00:00:00	2003-06-13	581452		0	0	0		0	0	0	297628	0	52	40213296		
38188	3159	920300	2014-07-05	2014-07-05 00:00:00	2014-07-12	2014-07-12 00:00:00	2014-07-12	38000177		0	0	7		0	0	0	210027	0	311989	920300		
32847	718	40213260	2016-02-27	2016-02-27 00:00:00	2016-02-27	2016-02-27 00:00:00	2016-02-27	581452		0	0	0		0	0	0	47437	0	121	40213260		
119139	2620	40213227	2005-11-22	2005-11-22 00:00:00	2005-11-22	2005-11-22 00:00:00	2005-11-22	581452		0	0	0		0	0	0	173292	0	113	40213227		
166857	3668	40213314	1977-01-02	1977-01-02 00:00:00	1977-01-02	1977-01-02 00:00:00	1977-01-02	581452		0	0	0		0	0	0	244036	0	49	40213314		
135541	2976	40213160	1955-12-01	1955-12-01 00:00:00	1955-12-01	1955-12-01 00:00:00	1955-12-01	581452		0	0	0		0	0	0	198707	0	10	40213160		
4475	97	40213201	2010-07-12	2010-07-12 00:00:00	2010-07-12	2010-07-12 00:00:00	2010-07-12	581452		0	0	0		0	0	0	6630	0	33	40213201		
29757	2466	1127433	2000-06-14	2000-06-14 00:00:00	2000-06-28	2000-06-28 00:00:00	2000-06-28	38000177		0	0	14		0	0	0	163490	0	313782	1127433		
218348	4792	40213201	2016-12-06	2016-12-06 00:00:00	2016-12-06	2016-12-06 00:00:00	2016-12-06	581452		0	0	0		0	0	0	318889	0	33	40213201		
229309	5039	40213160	1979-07-03	1979-07-03 00:00:00	1979-07-03	1979-07-03 00:00:00	1979-07-03	581452		0	0	0		0	0	0	334902	0	10	40213160		
63452	5272	40229134	2016-11-13	2016-11-13 00:00:00	2016-11-20	2016-11-20 00:00:00	2016-11-20	38000177		0	0	7		0	0	0	350622	0	1043400	40229134		
43257	3582	1115171	2000-03-07	2000-03-07 00:00:00	2000-04-04	2000-04-04 00:00:00	2000-04-04	38000177		0	0	28		0	0	0	238123	0	849574	1115171		
229454	5043	40213296	2017-10-06	2017-10-06 00:00:00	2017-10-06	2017-10-06 00:00:00	2017-10-06	581452		0	0	0		0	0	0	335152	0	52	40213296		
15664	1306	1115171	2001-12-20	2001-12-20 00:00:00	2002-01-10	2002-01-10 00:00:00	2002-01-10	38000177		0	0	21		0	0	0	86203	0	849574	1115171		
15704	1309	19059056	1958-04-12	1958-04-12 00:00:00	1958-06-12	1958-06-12 00:00:00	1958-06-12	38000177		0	0	61		0	0	0	86447	0	243670	19059056		
177092	3892	40213227	2004-07-10	2004-07-10 00:00:00	2004-07-10	2004-07-10 00:00:00	2004-07-10	581452		0	0	0		0	0	0	258770	0	113	40213227		
31480	686	40213227	1996-10-19	1996-10-19 00:00:00	1996-10-19	1996-10-19 00:00:00	1996-10-19	581452		0	0	0		0	0	0	45416	0	113	40213227		
108244	2373	40213160	1956-04-26	1956-04-26 00:00:00	1956-04-26	1956-04-26 00:00:00	1956-04-26	581452		0	0	0		0	0	0	157943	0	10	40213160		
45262	3746	19006318	1957-06-28	1957-06-28 00:00:00	1957-07-12	1957-07-12 00:00:00	1957-07-12	38000177		0	0	14		0	0	0	248992	0	105078	19006318		
26386	2172	19073183	1980-01-14	1980-01-14 00:00:00	1980-01-28	1980-01-28 00:00:00	1980-01-28	38000177		0	0	14		0	0	0	144670	0	308182	19073183		
55791	4631	1118084	1953-09-17	1953-09-17 00:00:00	1953-09-17	1953-09-17 00:00:00	\N	38000177		0	0	0		0	0	0	308631	0	00025152531	44923712		
5818	486	40236824	1997-02-04	1997-02-04 00:00:00	1997-02-11	1997-02-11 00:00:00	1997-02-11	38000177		0	0	7		0	0	0	32481	0	1094107	40236824		
28251	2333	920334	1962-06-24	1962-06-24 00:00:00	1962-07-01	1962-07-01 00:00:00	1962-07-01	38000177		0	0	7		0	0	0	155189	0	311995	920334		
9002	752	40229134	1994-05-03	1994-05-03 00:00:00	1994-05-17	1994-05-17 00:00:00	1994-05-17	38000177		0	0	14		0	0	0	49734	0	1043400	40229134		
28365	2341	1127433	2010-02-23	2010-02-23 00:00:00	2010-03-02	2010-03-02 00:00:00	2010-03-02	38000177		0	0	7		0	0	0	155825	0	313782	1127433		
106582	2337	40213296	2004-07-13	2004-07-13 00:00:00	2004-07-13	2004-07-13 00:00:00	2004-07-13	581452		0	0	0		0	0	0	\N	0	52	40213296		
116704	2564	40213314	1977-04-30	1977-04-30 00:00:00	1977-04-30	1977-04-30 00:00:00	1977-04-30	581452		0	0	0		0	0	0	169840	0	49	40213314		
3488	289	19129655	1964-11-09	1964-11-09 00:00:00	1964-11-23	1964-11-23 00:00:00	1964-11-23	38000177		0	0	14		0	0	0	19285	0	789980	19129655		
38999	3223	1127433	1944-02-09	1944-02-09 00:00:00	1944-02-16	1944-02-16 00:00:00	1944-02-16	38000177		0	0	7		0	0	0	214323	0	313782	1127433		
241490	5301	40213227	2002-01-24	2002-01-24 00:00:00	2002-01-24	2002-01-24 00:00:00	2002-01-24	581452		0	0	0		0	0	0	352703	0	113	40213227		
3620	298	1127433	1959-03-05	1959-03-05 00:00:00	1959-03-19	1959-03-19 00:00:00	1959-03-19	38000177		0	0	14		0	0	0	19898	0	313782	1127433		
18430	1526	19128065	1994-11-09	1994-11-09 00:00:00	1995-11-04	1995-11-04 00:00:00	1995-11-04	38000177		0	0	360		0	0	0	102041	0	749882	19128065		
136863	3004	40213227	1993-07-20	1993-07-20 00:00:00	1993-07-20	1993-07-20 00:00:00	1993-07-20	581452		0	0	0		0	0	0	200424	0	113	40213227		
21117	458	40213314	1977-02-20	1977-02-20 00:00:00	1977-02-20	1977-02-20 00:00:00	1977-02-20	581452		0	0	0		0	0	0	30637	0	49	40213314		
14316	1202	1118084	2016-11-14	2016-11-14 00:00:00	2016-11-14	2016-11-14 00:00:00	\N	38000177		0	0	0		0	0	0	79082	0	00025152531	44923712		
27453	598	40213296	2014-09-26	2014-09-26 00:00:00	2014-09-26	2014-09-26 00:00:00	2014-09-26	581452		0	0	0		0	0	0	39492	0	52	40213296		
14419	1211	19129655	1969-03-25	1969-03-25 00:00:00	1969-04-08	1969-04-08 00:00:00	1969-04-08	38000177		0	0	14		0	0	0	79546	0	789980	19129655		
181953	3997	40213227	1999-03-08	1999-03-08 00:00:00	1999-03-08	1999-03-08 00:00:00	1999-03-08	581452		0	0	0		0	0	0	265760	0	113	40213227		
155828	3430	40213227	2013-04-20	2013-04-20 00:00:00	2013-04-20	2013-04-20 00:00:00	2013-04-20	581452		0	0	0		0	0	0	227337	0	113	40213227		
62490	1367	40213160	1965-10-08	1965-10-08 00:00:00	1965-10-08	1965-10-08 00:00:00	1965-10-08	581452		0	0	0		0	0	0	90635	0	10	40213160		
169700	3731	40213296	2016-01-02	2016-01-02 00:00:00	2016-01-02	2016-01-02 00:00:00	2016-01-02	581452		0	0	0		0	0	0	247911	0	52	40213296		
13605	1138	19133873	1981-07-26	1981-07-26 00:00:00	1981-08-08	1981-08-08 00:00:00	1981-08-08	38000177		0	0	13		0	0	0	75059	0	834061	19133873		
62102	1357	40213314	1977-04-29	1977-04-29 00:00:00	1977-04-29	1977-04-29 00:00:00	1977-04-29	581452		0	0	0		0	0	0	90027	0	49	40213314		
6712	565	1127078	1965-06-12	1965-06-12 00:00:00	1965-07-17	1965-07-17 00:00:00	1965-07-17	38000177		0	0	35		0	0	0	37448	0	282464	1127078		
5622	470	19059056	1958-03-09	1958-03-09 00:00:00	1958-03-23	1958-03-23 00:00:00	1958-03-23	38000177		0	0	14		0	0	0	31415	0	243670	19059056		
60940	5068	40163554	2009-11-28	2009-11-28 00:00:00	2009-11-28	2009-11-28 00:00:00	\N	38000177		0	0	0		0	0	0	336939	0	855332	40163554		
179186	3939	40213314	1977-06-26	1977-06-26 00:00:00	1977-06-26	1977-06-26 00:00:00	1977-06-26	581452		0	0	0		0	0	0	261836	0	49	40213314		
56660	4701	1713671	1974-07-14	1974-07-14 00:00:00	1974-07-28	1974-07-28 00:00:00	1974-07-28	38000177		0	0	14		0	0	0	313175	0	562251	1713671		
17561	380	40213160	1972-07-21	1972-07-21 00:00:00	1972-07-21	1972-07-21 00:00:00	1972-07-21	581452		0	0	0		0	0	0	25155	0	10	40213160		
56756	4709	19129655	1961-11-15	1961-11-15 00:00:00	1961-11-29	1961-11-29 00:00:00	1961-11-29	38000177		0	0	14		0	0	0	313696	0	789980	19129655		
99817	2186	40213296	2013-02-14	2013-02-14 00:00:00	2013-02-14	2013-02-14 00:00:00	2013-02-14	581452		0	0	0		0	0	0	145782	0	52	40213296		
37404	817	40213296	1999-05-27	1999-05-27 00:00:00	1999-05-27	1999-05-27 00:00:00	1999-05-27	581452		0	0	0		0	0	0	54177	0	52	40213296		
121019	2659	40213314	1978-05-31	1978-05-31 00:00:00	1978-05-31	1978-05-31 00:00:00	1978-05-31	581452		0	0	0		0	0	0	176166	0	49	40213314		
50671	1110	40213160	1982-06-21	1982-06-21 00:00:00	1982-06-21	1982-06-21 00:00:00	1982-06-21	581452		0	0	0		0	0	0	73044	0	10	40213160		
161658	3556	40213314	1978-12-25	1978-12-25 00:00:00	1978-12-25	1978-12-25 00:00:00	1978-12-25	581452		0	0	0		0	0	0	236132	0	49	40213314		
38672	3195	19006318	1951-02-10	1951-02-10 00:00:00	1951-02-24	1951-02-24 00:00:00	1951-02-24	38000177		0	0	14		0	0	0	212517	0	105078	19006318		
205634	4513	40213296	2003-12-31	2003-12-31 00:00:00	2003-12-31	2003-12-31 00:00:00	2003-12-31	581452		0	0	0		0	0	0	300537	0	52	40213296		
6422	140	40213306	1992-01-16	1992-01-16 00:00:00	1992-01-16	1992-01-16 00:00:00	1992-01-16	581452		0	0	0		0	0	0	9335	0	43	40213306		
46400	3844	1713671	1967-05-02	1967-05-02 00:00:00	1967-05-16	1967-05-16 00:00:00	1967-05-16	38000177		0	0	14		0	0	0	255131	0	562251	1713671		
32301	704	40213260	2017-05-17	2017-05-17 00:00:00	2017-05-17	2017-05-17 00:00:00	2017-05-17	581452		0	0	0		0	0	0	46594	0	121	40213260		
100916	2211	40213227	2013-06-30	2013-06-30 00:00:00	2013-06-30	2013-06-30 00:00:00	2013-06-30	581452		0	0	0		0	0	0	147286	0	113	40213227		
90489	1986	40213160	1980-02-26	1980-02-26 00:00:00	1980-02-26	1980-02-26 00:00:00	1980-02-26	581452		0	0	0		0	0	0	132268	0	10	40213160		
33811	738	40213306	2000-09-05	2000-09-05 00:00:00	2000-09-05	2000-09-05 00:00:00	2000-09-05	581452		0	0	0		0	0	0	\N	0	43	40213306		
34753	759	40213227	2006-03-08	2006-03-08 00:00:00	2006-03-08	2006-03-08 00:00:00	2006-03-08	581452		0	0	0		0	0	0	50442	0	113	40213227		
203819	4474	40213160	1963-11-15	1963-11-15 00:00:00	1963-11-15	1963-11-15 00:00:00	1963-11-15	581452		0	0	0		0	0	0	297683	0	10	40213160		
38189	3159	40229134	1971-05-25	1971-05-25 00:00:00	1971-06-08	1971-06-08 00:00:00	1971-06-08	38000177		0	0	14		0	0	0	210089	0	1043400	40229134		
32852	718	40213227	2008-03-08	2008-03-08 00:00:00	2008-03-08	2008-03-08 00:00:00	2008-03-08	581452		0	0	0		0	0	0	47522	0	113	40213227		
119140	2620	40213296	2005-11-22	2005-11-22 00:00:00	2005-11-22	2005-11-22 00:00:00	2005-11-22	581452		0	0	0		0	0	0	173292	0	52	40213296		
166861	3668	40213227	2017-09-10	2017-09-10 00:00:00	2017-09-10	2017-09-10 00:00:00	2017-09-10	581452		0	0	0		0	0	0	244054	0	113	40213227		
135547	2976	40213227	2016-07-28	2016-07-28 00:00:00	2016-07-28	2016-07-28 00:00:00	2016-07-28	581452		0	0	0		0	0	0	198766	0	113	40213227		
15757	339	40213314	1982-11-20	1982-11-20 00:00:00	1982-11-20	1982-11-20 00:00:00	1982-11-20	581452		0	0	0		0	0	0	22641	0	49	40213314		
29758	2466	19019979	1989-06-25	1989-06-25 00:00:00	1989-08-24	1989-08-24 00:00:00	1989-08-24	38000177		0	0	60		0	0	0	163499	0	198405	19019979		
218356	4792	40213227	2001-12-25	2001-12-25 00:00:00	2001-12-25	2001-12-25 00:00:00	2001-12-25	581452		0	0	0		0	0	0	318835	0	113	40213227		
229315	5039	40213314	1978-06-27	1978-06-27 00:00:00	1978-06-27	1978-06-27 00:00:00	1978-06-27	581452		0	0	0		0	0	0	334879	0	49	40213314		
63453	5272	1127433	1969-04-10	1969-04-10 00:00:00	1969-04-17	1969-04-17 00:00:00	1969-04-17	38000177		0	0	7		0	0	0	350655	0	313782	1127433		
43259	3582	19128065	1977-04-17	1977-04-17 00:00:00	1978-04-12	1978-04-12 00:00:00	1978-04-12	38000177		0	0	360		0	0	0	238112	0	749882	19128065		
229458	5043	40213227	2007-08-17	2007-08-17 00:00:00	2007-08-17	2007-08-17 00:00:00	2007-08-17	581452		0	0	0		0	0	0	335173	0	113	40213227		
15665	1306	1127433	1999-11-17	1999-11-17 00:00:00	1999-12-01	1999-12-01 00:00:00	1999-12-01	38000177		0	0	14		0	0	0	86193	0	313782	1127433		
15705	1309	1713671	1992-06-05	1992-06-05 00:00:00	1992-06-12	1992-06-12 00:00:00	1992-06-12	38000177		0	0	7		0	0	0	86486	0	562251	1713671		
177093	3892	40213296	2004-07-10	2004-07-10 00:00:00	2004-07-10	2004-07-10 00:00:00	2004-07-10	581452		0	0	0		0	0	0	258770	0	52	40213296		
31487	686	40213227	2007-07-28	2007-07-28 00:00:00	2007-07-28	2007-07-28 00:00:00	2007-07-28	581452		0	0	0		0	0	0	45369	0	113	40213227		
108246	2373	40213227	1998-06-25	1998-06-25 00:00:00	1998-06-25	1998-06-25 00:00:00	1998-06-25	581452		0	0	0		0	0	0	157937	0	113	40213227		
45263	3746	19059056	1970-01-12	1970-01-12 00:00:00	1970-02-16	1970-02-16 00:00:00	1970-02-16	38000177		0	0	35		0	0	0	249064	0	243670	19059056		
26387	2172	1124300	2012-07-20	2012-07-20 00:00:00	2012-07-20	2012-07-20 00:00:00	\N	38000177		0	0	0		0	0	0	144675	0	00781178901	45011828		
55792	4631	1115171	2013-05-01	2013-05-01 00:00:00	2013-05-22	2013-05-22 00:00:00	2013-05-22	38000177		0	0	21		0	0	0	308561	0	849574	1115171		
5819	486	920300	1997-02-04	1997-02-04 00:00:00	1997-02-11	1997-02-11 00:00:00	1997-02-11	38000177		0	0	7		0	0	0	32481	0	311989	920300		
28252	2333	40223774	2003-05-10	2003-05-10 00:00:00	2003-05-10	2003-05-10 00:00:00	\N	38000177		0	0	0		0	0	0	155258	0	998582	40223774		
9003	752	1127433	2008-10-10	2008-10-10 00:00:00	2008-10-24	2008-10-24 00:00:00	2008-10-24	38000177		0	0	14		0	0	0	49680	0	313782	1127433		
28366	2341	19133873	1962-06-28	1962-06-28 00:00:00	1962-07-06	1962-07-06 00:00:00	1962-07-06	38000177		0	0	8		0	0	0	155851	0	834061	19133873		
106586	2337	40213227	2004-07-20	2004-07-20 00:00:00	2004-07-20	2004-07-20 00:00:00	2004-07-20	581452		0	0	0		0	0	0	155476	0	113	40213227		
116705	2564	40213160	1977-04-30	1977-04-30 00:00:00	1977-04-30	1977-04-30 00:00:00	1977-04-30	581452		0	0	0		0	0	0	169840	0	10	40213160		
3489	289	1127078	1964-11-09	1964-11-09 00:00:00	1964-11-23	1964-11-23 00:00:00	1964-11-23	38000177		0	0	14		0	0	0	19285	0	282464	1127078		
39000	3223	1127433	1925-11-24	1925-11-24 00:00:00	1925-12-01	1925-12-01 00:00:00	1925-12-01	38000177		0	0	7		0	0	0	214259	0	313782	1127433		
241502	5301	40213201	1986-10-30	1986-10-30 00:00:00	1986-10-30	1986-10-30 00:00:00	1986-10-30	581452		0	0	0		0	0	0	352691	0	33	40213201		
3621	298	1713671	2013-06-22	2013-06-22 00:00:00	2013-07-13	2013-07-13 00:00:00	2013-07-13	38000177		0	0	21		0	0	0	19922	0	562251	1713671		
18431	1526	1713671	1977-05-09	1977-05-09 00:00:00	1977-05-23	1977-05-23 00:00:00	1977-05-23	38000177		0	0	14		0	0	0	102075	0	562251	1713671		
136866	3004	40213201	2017-03-07	2017-03-07 00:00:00	2017-03-07	2017-03-07 00:00:00	2017-03-07	581452		0	0	0		0	0	0	200430	0	33	40213201		
21120	458	40213160	1977-02-20	1977-02-20 00:00:00	1977-02-20	1977-02-20 00:00:00	1977-02-20	581452		0	0	0		0	0	0	30637	0	10	40213160		
14317	1202	19128022	1996-06-22	1996-06-22 00:00:00	1997-06-17	1997-06-17 00:00:00	1997-06-17	38000177		0	0	360		0	0	0	79050	0	749785	19128022		
200623	4406	40213227	1992-11-28	1992-11-28 00:00:00	1992-11-28	1992-11-28 00:00:00	1992-11-28	581452		0	0	0		0	0	0	292853	0	113	40213227		
14420	1211	1127433	1984-11-26	1984-11-26 00:00:00	1984-12-10	1984-12-10 00:00:00	1984-12-10	38000177		0	0	14		0	0	0	79543	0	313782	1127433		
181957	3997	40213296	2007-03-19	2007-03-19 00:00:00	2007-03-19	2007-03-19 00:00:00	2007-03-19	581452		0	0	0		0	0	0	265706	0	52	40213296		
155829	3430	40213260	2013-04-20	2013-04-20 00:00:00	2013-04-20	2013-04-20 00:00:00	2013-04-20	581452		0	0	0		0	0	0	227337	0	121	40213260		
141024	3096	40213260	2014-10-12	2014-10-12 00:00:00	2014-10-12	2014-10-12 00:00:00	2014-10-12	581452		0	0	0		0	0	0	206057	0	121	40213260		
169708	3731	40213314	1977-11-26	1977-11-26 00:00:00	1977-11-26	1977-11-26 00:00:00	1977-11-26	581452		0	0	0		0	0	0	247944	0	49	40213314		
62110	5168	1127433	1979-08-03	1979-08-03 00:00:00	1979-08-10	1979-08-10 00:00:00	1979-08-10	38000177		0	0	7		0	0	0	343650	0	313782	1127433		
62103	1357	40213314	1978-04-28	1978-04-28 00:00:00	1978-04-28	1978-04-28 00:00:00	1978-04-28	581452		0	0	0		0	0	0	89986	0	49	40213314		
6742	569	1127433	1976-04-08	1976-04-08 00:00:00	1976-07-07	1976-07-07 00:00:00	1976-07-07	38000177		0	0	90		0	0	0	37663	0	313782	1127433		
1710	38	40213160	1965-10-19	1965-10-19 00:00:00	1965-10-19	1965-10-19 00:00:00	1965-10-19	581452		0	0	0		0	0	0	2729	0	10	40213160		
60941	5068	19075601	2009-11-28	2009-11-28 00:00:00	2009-11-28	2009-11-28 00:00:00	\N	38000177		0	0	0		0	0	0	336939	0	309362	19075601		
94464	2073	40213160	1963-05-24	1963-05-24 00:00:00	1963-05-24	1963-05-24 00:00:00	1963-05-24	581452		0	0	0		0	0	0	137944	0	10	40213160		
56661	4701	1127433	1978-12-26	1978-12-26 00:00:00	1979-01-09	1979-01-09 00:00:00	1979-01-09	38000177		0	0	14		0	0	0	313176	0	313782	1127433		
17563	380	40213160	1972-02-18	1972-02-18 00:00:00	1972-02-18	1972-02-18 00:00:00	1972-02-18	581452		0	0	0		0	0	0	25119	0	10	40213160		
56757	4709	1127433	1983-03-31	1983-03-31 00:00:00	1983-04-21	1983-04-21 00:00:00	1983-04-21	38000177		0	0	21		0	0	0	313646	0	313782	1127433		
99822	2186	40213314	1977-01-13	1977-01-13 00:00:00	1977-01-13	1977-01-13 00:00:00	1977-01-13	581452		0	0	0		0	0	0	145792	0	49	40213314		
37408	817	40213227	1999-05-27	1999-05-27 00:00:00	1999-05-27	1999-05-27 00:00:00	1999-05-27	581452		0	0	0		0	0	0	54177	0	113	40213227		
121021	2659	40213296	2014-08-06	2014-08-06 00:00:00	2014-08-06	2014-08-06 00:00:00	2014-08-06	581452		0	0	0		0	0	0	176178	0	52	40213296		
89693	1967	40213160	1956-03-22	1956-03-22 00:00:00	1956-03-22	1956-03-22 00:00:00	1956-03-22	581452		0	0	0		0	0	0	130836	0	10	40213160		
161659	3556	40213160	1978-12-25	1978-12-25 00:00:00	1978-12-25	1978-12-25 00:00:00	1978-12-25	581452		0	0	0		0	0	0	236132	0	10	40213160		
38673	3195	1713671	2015-12-10	2015-12-10 00:00:00	2015-12-31	2015-12-31 00:00:00	2015-12-31	38000177		0	0	21		0	0	0	212545	0	562251	1713671		
205636	4513	40213160	1962-03-28	1962-03-28 00:00:00	1962-03-28	1962-03-28 00:00:00	1962-03-28	581452		0	0	0		0	0	0	300542	0	10	40213160		
6424	140	40213227	2001-01-25	2001-01-25 00:00:00	2001-01-25	2001-01-25 00:00:00	2001-01-25	581452		0	0	0		0	0	0	9338	0	113	40213227		
46401	3844	19059056	1965-02-22	1965-02-22 00:00:00	1965-03-22	1965-03-22 00:00:00	1965-03-22	38000177		0	0	28		0	0	0	255128	0	243670	19059056		
32305	704	40213227	2007-04-18	2007-04-18 00:00:00	2007-04-18	2007-04-18 00:00:00	2007-04-18	581452		0	0	0		0	0	0	46546	0	113	40213227		
100918	2211	40213296	2013-06-30	2013-06-30 00:00:00	2013-06-30	2013-06-30 00:00:00	2013-06-30	581452		0	0	0		0	0	0	147286	0	52	40213296		
90490	1986	40213314	1980-02-26	1980-02-26 00:00:00	1980-02-26	1980-02-26 00:00:00	1980-02-26	581452		0	0	0		0	0	0	132268	0	49	40213314		
33814	738	40213160	1979-03-13	1979-03-13 00:00:00	1979-03-13	1979-03-13 00:00:00	1979-03-13	581452		0	0	0		0	0	0	48906	0	10	40213160		
71778	1569	40213227	1997-11-07	1997-11-07 00:00:00	1997-11-07	1997-11-07 00:00:00	1997-11-07	581452		0	0	0		0	0	0	105288	0	113	40213227		
203825	4474	40213160	1964-02-14	1964-02-14 00:00:00	1964-02-14	1964-02-14 00:00:00	1964-02-14	581452		0	0	0		0	0	0	297645	0	10	40213160		
38191	3159	1127078	1959-10-23	1959-10-23 00:00:00	1959-11-06	1959-11-06 00:00:00	1959-11-06	38000177		0	0	14		0	0	0	210094	0	282464	1127078		
32853	718	40213296	2008-03-08	2008-03-08 00:00:00	2008-03-08	2008-03-08 00:00:00	2008-03-08	581452		0	0	0		0	0	0	47522	0	52	40213296		
119142	2620	40213160	1968-10-22	1968-10-22 00:00:00	1968-10-22	1968-10-22 00:00:00	1968-10-22	581452		0	0	0		0	0	0	173317	0	10	40213160		
166862	3668	40213296	2017-09-10	2017-09-10 00:00:00	2017-09-10	2017-09-10 00:00:00	2017-09-10	581452		0	0	0		0	0	0	244054	0	52	40213296		
135554	2976	40213160	1955-09-29	1955-09-29 00:00:00	1955-09-29	1955-09-29 00:00:00	1955-09-29	581452		0	0	0		0	0	0	198737	0	10	40213160		
15758	339	40213160	1982-11-20	1982-11-20 00:00:00	1982-11-20	1982-11-20 00:00:00	1982-11-20	581452		0	0	0		0	0	0	22641	0	10	40213160		
29759	2466	1127433	1993-07-04	1993-07-04 00:00:00	1993-10-02	1993-10-02 00:00:00	1993-10-02	38000177		0	0	90		0	0	0	163500	0	313782	1127433		
218363	4792	40213198	2015-12-01	2015-12-01 00:00:00	2015-12-01	2015-12-01 00:00:00	2015-12-01	581452		0	0	0		0	0	0	318921	0	133	40213198		
229318	5039	40213160	1975-04-01	1975-04-01 00:00:00	1975-04-01	1975-04-01 00:00:00	1975-04-01	581452		0	0	0		0	0	0	334878	0	10	40213160		
63454	5272	19133905	1957-05-24	1957-05-24 00:00:00	1957-05-31	1957-05-31 00:00:00	1957-05-31	38000177		0	0	7		0	0	0	350712	0	834102	19133905		
43260	3582	1127433	1989-09-01	1989-09-01 00:00:00	1989-10-01	1989-10-01 00:00:00	1989-10-01	38000177		0	0	30		0	0	0	238122	0	313782	1127433		
229463	5043	40213314	1977-05-20	1977-05-20 00:00:00	1977-05-20	1977-05-20 00:00:00	1977-05-20	581452		0	0	0		0	0	0	335124	0	49	40213314		
15666	1306	1127078	1966-01-09	1966-01-09 00:00:00	1966-04-09	1966-04-09 00:00:00	1966-04-09	38000177		0	0	90		0	0	0	86247	0	282464	1127078		
15706	1309	19078461	2018-07-25	2018-07-25 00:00:00	2018-08-08	2018-08-08 00:00:00	2018-08-08	38000177		0	0	14		0	0	0	86445	0	310965	19078461		
177095	3892	40213160	1967-06-17	1967-06-17 00:00:00	1967-06-17	1967-06-17 00:00:00	1967-06-17	581452		0	0	0		0	0	0	258788	0	10	40213160		
57869	1266	40213160	1971-11-15	1971-11-15 00:00:00	1971-11-15	1971-11-15 00:00:00	1971-11-15	581452		0	0	0		0	0	0	83449	0	10	40213160		
108247	2373	40213296	1998-06-25	1998-06-25 00:00:00	1998-06-25	1998-06-25 00:00:00	1998-06-25	581452		0	0	0		0	0	0	157937	0	52	40213296		
45264	3746	1118084	1987-02-11	1987-02-11 00:00:00	1987-02-11	1987-02-11 00:00:00	\N	38000177		0	0	0		0	0	0	249015	0	00025152531	44923712		
26388	2172	19019979	1980-08-12	1980-08-12 00:00:00	1980-08-26	1980-08-26 00:00:00	1980-08-26	38000177		0	0	14		0	0	0	144694	0	198405	19019979		
55793	4631	1127433	1984-08-12	1984-08-12 00:00:00	1984-09-02	1984-09-02 00:00:00	1984-09-02	38000177		0	0	21		0	0	0	308556	0	313782	1127433		
5820	486	40236824	1996-12-01	1996-12-01 00:00:00	1996-12-08	1996-12-08 00:00:00	1996-12-08	38000177		0	0	7		0	0	0	32461	0	1094107	40236824		
28253	2333	19059056	1948-02-17	1948-02-17 00:00:00	1948-03-16	1948-03-16 00:00:00	1948-03-16	38000177		0	0	28		0	0	0	155160	0	243670	19059056		
9004	752	1127433	1971-07-25	1971-07-25 00:00:00	1971-08-01	1971-08-01 00:00:00	1971-08-01	38000177		0	0	7		0	0	0	49717	0	313782	1127433		
28367	2341	1127433	1994-10-18	1994-10-18 00:00:00	1994-11-22	1994-11-22 00:00:00	1994-11-22	38000177		0	0	35		0	0	0	155804	0	313782	1127433		
106587	2337	40213160	1963-10-22	1963-10-22 00:00:00	1963-10-22	1963-10-22 00:00:00	1963-10-22	581452		0	0	0		0	0	0	155493	0	10	40213160		
116706	2564	40213251	1984-08-18	1984-08-18 00:00:00	1984-08-18	1984-08-18 00:00:00	1984-08-18	581452		0	0	0		0	0	0	169844	0	21	40213251		
3490	289	1127078	1970-09-15	1970-09-15 00:00:00	1970-12-13	1970-12-13 00:00:00	1970-12-13	38000177		0	0	89		0	0	0	19328	0	282464	1127078		
39001	3223	19059056	1929-02-11	1929-02-11 00:00:00	1929-03-13	1929-03-13 00:00:00	1929-03-13	38000177		0	0	30		0	0	0	214308	0	243670	19059056		
83522	1826	40213227	1992-06-30	1992-06-30 00:00:00	1992-06-30	1992-06-30 00:00:00	1992-06-30	581452		0	0	0		0	0	0	122029	0	113	40213227		
3622	298	1118084	1990-02-18	1990-02-18 00:00:00	1990-02-18	1990-02-18 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00025152531	44923712		
18432	1526	1115171	2007-09-04	2007-09-04 00:00:00	2007-09-25	2007-09-25 00:00:00	2007-09-25	38000177		0	0	21		0	0	0	102051	0	849574	1115171		
136877	3004	40213198	2016-03-01	2016-03-01 00:00:00	2016-03-01	2016-03-01 00:00:00	2016-03-01	581452		0	0	0		0	0	0	200442	0	133	40213198		
227332	4991	40213160	1971-12-18	1971-12-18 00:00:00	1971-12-18	1971-12-18 00:00:00	1971-12-18	581452		0	0	0		0	0	0	332035	0	10	40213160		
14318	1202	19128022	1997-06-17	1997-06-17 00:00:00	1998-06-12	1998-06-12 00:00:00	1998-06-12	38000177		0	0	360		0	0	0	79051	0	749785	19128022		
200631	4406	40213227	2003-01-25	2003-01-25 00:00:00	2003-01-25	2003-01-25 00:00:00	2003-01-25	581452		0	0	0		0	0	0	292877	0	113	40213227		
14421	1211	920334	2007-12-04	2007-12-04 00:00:00	2007-12-11	2007-12-11 00:00:00	2007-12-11	38000177		0	0	7		0	0	0	79581	0	311995	920334		
181958	3997	40213160	1967-02-27	1967-02-27 00:00:00	1967-02-27	1967-02-27 00:00:00	1967-02-27	581452		0	0	0		0	0	0	265710	0	10	40213160		
155834	3430	40213296	2003-03-22	2003-03-22 00:00:00	2003-03-22	2003-03-22 00:00:00	2003-03-22	581452		0	0	0		0	0	0	227335	0	52	40213296		
152334	3353	40213227	2006-01-21	2006-01-21 00:00:00	2006-01-21	2006-01-21 00:00:00	2006-01-21	581452		0	0	0		0	0	0	222374	0	113	40213227		
169711	3731	40213296	2013-12-28	2013-12-28 00:00:00	2013-12-28	2013-12-28 00:00:00	2013-12-28	581452		0	0	0		0	0	0	247902	0	52	40213296		
62111	5168	19059056	1973-04-27	1973-04-27 00:00:00	1973-05-11	1973-05-11 00:00:00	1973-05-11	38000177		0	0	14		0	0	0	343605	0	243670	19059056		
62106	1357	40213160	1975-09-05	1975-09-05 00:00:00	1975-09-05	1975-09-05 00:00:00	1975-09-05	581452		0	0	0		0	0	0	89982	0	10	40213160		
6743	569	40220960	1998-02-21	1998-02-21 00:00:00	1998-02-21	1998-02-21 00:00:00	1998-02-21	38000177		0	0	0		0	0	0	37710	0	1804799	40220960		
1717	38	40213227	2017-01-17	2017-01-17 00:00:00	2017-01-17	2017-01-17 00:00:00	2017-01-17	581452		0	0	0		0	0	0	2707	0	113	40213227		
60942	5068	40171902	2009-11-28	2009-11-28 00:00:00	2009-11-28	2009-11-28 00:00:00	\N	38000177		0	0	0		0	0	0	336939	0	897718	40171902		
94472	2073	40213260	2013-11-15	2013-11-15 00:00:00	2013-11-15	2013-11-15 00:00:00	2013-11-15	581452		0	0	0		0	0	0	137952	0	121	40213260		
56662	4701	1127078	1978-08-17	1978-08-17 00:00:00	1978-08-31	1978-08-31 00:00:00	1978-08-31	38000177		0	0	14		0	0	0	313169	0	282464	1127078		
17569	380	40213227	2003-01-24	2003-01-24 00:00:00	2003-01-24	2003-01-24 00:00:00	2003-01-24	581452		0	0	0		0	0	0	25168	0	113	40213227		
56758	4709	19059056	1956-06-06	1956-06-06 00:00:00	1956-06-20	1956-06-20 00:00:00	1956-06-20	38000177		0	0	14		0	0	0	313637	0	243670	19059056		
99826	2186	40213227	2004-04-15	2004-04-15 00:00:00	2004-04-15	2004-04-15 00:00:00	2004-04-15	581452		0	0	0		0	0	0	145786	0	113	40213227		
37410	817	40213160	1957-08-22	1957-08-22 00:00:00	1957-08-22	1957-08-22 00:00:00	1957-08-22	581452		0	0	0		0	0	0	54167	0	10	40213160		
121024	2659	40213314	1977-11-30	1977-11-30 00:00:00	1977-11-30	1977-11-30 00:00:00	1977-11-30	581452		0	0	0		0	0	0	176161	0	49	40213314		
89701	1967	40213160	1956-01-19	1956-01-19 00:00:00	1956-01-19	1956-01-19 00:00:00	1956-01-19	581452		0	0	0		0	0	0	130770	0	10	40213160		
161661	3556	40213160	1978-10-23	1978-10-23 00:00:00	1978-10-23	1978-10-23 00:00:00	1978-10-23	581452		0	0	0		0	0	0	236106	0	10	40213160		
38674	3195	1115171	2001-12-14	2001-12-14 00:00:00	2002-01-18	2002-01-18 00:00:00	2002-01-18	38000177		0	0	35		0	0	0	212592	0	849574	1115171		
205640	4513	40213306	1984-06-06	1984-06-06 00:00:00	1984-06-06	1984-06-06 00:00:00	1984-06-06	581452		0	0	0		0	0	0	300535	0	43	40213306		
6431	140	40213160	1969-09-11	1969-09-11 00:00:00	1969-09-11	1969-09-11 00:00:00	1969-09-11	581452		0	0	0		0	0	0	9373	0	10	40213160		
46402	3844	1713671	2017-08-19	2017-08-19 00:00:00	2017-08-26	2017-08-26 00:00:00	2017-08-26	38000177		0	0	7		0	0	0	255144	0	562251	1713671		
32306	704	40213296	2007-04-18	2007-04-18 00:00:00	2007-04-18	2007-04-18 00:00:00	2007-04-18	581452		0	0	0		0	0	0	46546	0	52	40213296		
100926	2211	40213160	1976-05-30	1976-05-30 00:00:00	1976-05-30	1976-05-30 00:00:00	1976-05-30	581452		0	0	0		0	0	0	147288	0	10	40213160		
51813	1134	40213227	1992-10-04	1992-10-04 00:00:00	1992-10-04	1992-10-04 00:00:00	1992-10-04	581452		0	0	0		0	0	0	74684	0	113	40213227		
133189	2925	40213160	1960-09-19	1960-09-19 00:00:00	1960-09-19	1960-09-19 00:00:00	1960-09-19	581452		0	0	0		0	0	0	194999	0	10	40213160		
11824	986	40229134	1968-03-23	1968-03-23 00:00:00	1968-04-06	1968-04-06 00:00:00	1968-04-06	38000177		0	0	14		0	0	0	65509	0	1043400	40229134		
203833	4475	40213227	2009-11-22	2009-11-22 00:00:00	2009-11-22	2009-11-22 00:00:00	2009-11-22	581452		0	0	0		0	0	0	297754	0	113	40213227		
38192	3159	19078461	1994-12-18	1994-12-18 00:00:00	1995-02-16	1995-02-16 00:00:00	1995-02-16	38000177		0	0	60		0	0	0	210081	0	310965	19078461		
32855	718	40213296	2006-03-04	2006-03-04 00:00:00	2006-03-04	2006-03-04 00:00:00	2006-03-04	581452		0	0	0		0	0	0	47435	0	52	40213296		
29499	2442	1127433	2012-06-24	2012-06-24 00:00:00	2012-07-08	2012-07-08 00:00:00	2012-07-08	38000177		0	0	14		0	0	0	162015	0	313782	1127433		
166867	3668	40213160	1980-07-06	1980-07-06 00:00:00	1980-07-06	1980-07-06 00:00:00	1980-07-06	581452		0	0	0		0	0	0	244056	0	10	40213160		
135564	2976	40213227	1997-07-03	1997-07-03 00:00:00	1997-07-03	1997-07-03 00:00:00	1997-07-03	581452		0	0	0		0	0	0	198762	0	113	40213227		
15761	339	40213227	2014-11-29	2014-11-29 00:00:00	2014-11-29	2014-11-29 00:00:00	2014-11-29	581452		0	0	0		0	0	0	22656	0	113	40213227		
29760	2466	40231925	1993-07-04	1993-07-04 00:00:00	1993-07-04	1993-07-04 00:00:00	\N	38000177		0	0	0		0	0	0	163500	0	1049221	40231925		
110840	2435	40213160	1977-10-21	1977-10-21 00:00:00	1977-10-21	1977-10-21 00:00:00	1977-10-21	581452		0	0	0		0	0	0	161428	0	10	40213160		
229320	5039	40213160	1974-12-31	1974-12-31 00:00:00	1974-12-31	1974-12-31 00:00:00	1974-12-31	581452		0	0	0		0	0	0	334898	0	10	40213160		
63455	5272	1127433	2009-01-04	2009-01-04 00:00:00	2009-01-11	2009-01-11 00:00:00	2009-01-11	38000177		0	0	7		0	0	0	350657	0	313782	1127433		
43261	3582	40231925	1989-09-01	1989-09-01 00:00:00	1989-09-01	1989-09-01 00:00:00	\N	38000177		0	0	0		0	0	0	238122	0	1049221	40231925		
229470	5043	40213160	1974-05-24	1974-05-24 00:00:00	1974-05-24	1974-05-24 00:00:00	1974-05-24	581452		0	0	0		0	0	0	335116	0	10	40213160		
15667	1306	19128065	1975-07-10	1975-07-10 00:00:00	1976-07-04	1976-07-04 00:00:00	1976-07-04	38000177		0	0	360		0	0	0	86198	0	749882	19128065		
15707	1309	1118084	1995-03-09	1995-03-09 00:00:00	1995-03-09	1995-03-09 00:00:00	\N	38000177		0	0	0		0	0	0	86466	0	00025152531	44923712		
176554	3881	40213260	2007-09-07	2007-09-07 00:00:00	2007-09-07	2007-09-07 00:00:00	2007-09-07	581452		0	0	0		0	0	0	257911	0	121	40213260		
57872	1266	40213306	1989-10-23	1989-10-23 00:00:00	1989-10-23	1989-10-23 00:00:00	1989-10-23	581452		0	0	0		0	0	0	83428	0	43	40213306		
91036	1998	40213160	1986-08-30	1986-08-30 00:00:00	1986-08-30	1986-08-30 00:00:00	1986-08-30	581452		0	0	0		0	0	0	133009	0	10	40213160		
45265	3746	40229134	1999-12-24	1999-12-24 00:00:00	2000-01-07	2000-01-07 00:00:00	2000-01-07	38000177		0	0	14		0	0	0	249031	0	1043400	40229134		
26389	2172	19073183	1980-08-12	1980-08-12 00:00:00	1980-08-26	1980-08-26 00:00:00	1980-08-26	38000177		0	0	14		0	0	0	144694	0	308182	19073183		
55794	4631	1127433	1936-04-01	1936-04-01 00:00:00	1936-04-08	1936-04-08 00:00:00	1936-04-08	38000177		0	0	7		0	0	0	308572	0	313782	1127433		
5821	486	920300	1996-12-01	1996-12-01 00:00:00	1996-12-08	1996-12-08 00:00:00	1996-12-08	38000177		0	0	7		0	0	0	32461	0	311989	920300		
28254	2333	19075601	2007-04-03	2007-04-03 00:00:00	2007-04-03	2007-04-03 00:00:00	2007-04-03	38000177		0	0	0		0	0	0	155219	0	309362	19075601		
9005	752	1713671	2001-01-20	2001-01-20 00:00:00	2001-02-03	2001-02-03 00:00:00	2001-02-03	38000177		0	0	14		0	0	0	49736	0	562251	1713671		
28368	2341	40165015	1994-10-18	1994-10-18 00:00:00	1994-10-18	1994-10-18 00:00:00	\N	38000177		0	0	0		0	0	0	155804	0	861467	40165015		
106589	2337	40213296	2003-07-22	2003-07-22 00:00:00	2003-07-22	2003-07-22 00:00:00	2003-07-22	581452		0	0	0		0	0	0	155502	0	52	40213296		
116708	2564	40213314	1977-01-29	1977-01-29 00:00:00	1977-01-29	1977-01-29 00:00:00	1977-01-29	581452		0	0	0		0	0	0	169855	0	49	40213314		
3491	289	19078461	2000-02-09	2000-02-09 00:00:00	2000-03-08	2000-03-08 00:00:00	2000-03-08	38000177		0	0	28		0	0	0	19330	0	310965	19078461		
39002	3223	40231925	1929-02-11	1929-02-11 00:00:00	1929-02-11	1929-02-11 00:00:00	\N	38000177		0	0	0		0	0	0	214308	0	1049221	40231925		
83525	1826	40213201	2004-03-09	2004-03-09 00:00:00	2004-03-09	2004-03-09 00:00:00	2004-03-09	581452		0	0	0		0	0	0	122076	0	33	40213201		
3623	298	1127078	1955-09-03	1955-09-03 00:00:00	1955-09-17	1955-09-17 00:00:00	1955-09-17	38000177		0	0	14		0	0	0	19873	0	282464	1127078		
18433	1526	46233988	1974-05-18	1974-05-18 00:00:00	1974-06-01	1974-06-01 00:00:00	1974-06-01	38000177		0	0	14		0	0	0	102086	0	1652673	46233988		
243371	5343	40213251	1987-12-13	1987-12-13 00:00:00	1987-12-13	1987-12-13 00:00:00	1987-12-13	581452		0	0	0		0	0	0	355951	0	21	40213251		
227336	4991	40213296	2011-07-16	2011-07-16 00:00:00	2011-07-16	2011-07-16 00:00:00	2011-07-16	581452		0	0	0		0	0	0	332014	0	52	40213296		
14319	1202	19078461	2012-07-18	2012-07-18 00:00:00	2012-08-22	2012-08-22 00:00:00	2012-08-22	38000177		0	0	35		0	0	0	79090	0	310965	19078461		
215473	4725	40213314	1977-11-21	1977-11-21 00:00:00	1977-11-21	1977-11-21 00:00:00	1977-11-21	581452		0	0	0		0	0	0	314945	0	49	40213314		
14422	1211	19078461	1980-10-07	1980-10-07 00:00:00	1980-10-21	1980-10-21 00:00:00	1980-10-21	38000177		0	0	14		0	0	0	79570	0	310965	19078461		
181961	3997	40213160	1967-05-29	1967-05-29 00:00:00	1967-05-29	1967-05-29 00:00:00	1967-05-29	581452		0	0	0		0	0	0	265773	0	10	40213160		
155837	3430	40213227	2003-03-22	2003-03-22 00:00:00	2003-03-22	2003-03-22 00:00:00	2003-03-22	581452		0	0	0		0	0	0	227335	0	113	40213227		
18144	393	40213296	1997-01-15	1997-01-15 00:00:00	1997-01-15	1997-01-15 00:00:00	1997-01-15	581452		0	0	0		0	0	0	25804	0	52	40213296		
169715	3731	40213160	1974-08-31	1974-08-31 00:00:00	1974-08-31	1974-08-31 00:00:00	1974-08-31	581452		0	0	0		0	0	0	247954	0	10	40213160		
62112	5168	1124300	2010-01-07	2010-01-07 00:00:00	2010-01-07	2010-01-07 00:00:00	\N	38000177		0	0	0		0	0	0	343623	0	00781178901	45011828		
62109	1357	40213296	2015-01-02	2015-01-02 00:00:00	2015-01-02	2015-01-02 00:00:00	2015-01-02	581452		0	0	0		0	0	0	89993	0	52	40213296		
6744	569	19075601	1998-02-21	1998-02-21 00:00:00	1998-02-21	1998-02-21 00:00:00	1998-02-21	38000177		0	0	0		0	0	0	37710	0	309362	19075601		
1720	38	40213306	1987-11-17	1987-11-17 00:00:00	1987-11-17	1987-11-17 00:00:00	1987-11-17	581452		0	0	0		0	0	0	2750	0	43	40213306		
60943	5068	19133873	1945-08-06	1945-08-06 00:00:00	1945-08-18	1945-08-18 00:00:00	1945-08-18	38000177		0	0	12		0	0	0	336915	0	834061	19133873		
94475	2073	40213160	1963-07-26	1963-07-26 00:00:00	1963-07-26	1963-07-26 00:00:00	1963-07-26	581452		0	0	0		0	0	0	137927	0	10	40213160		
56663	4701	19128065	1988-11-06	1988-11-06 00:00:00	1989-11-01	1989-11-01 00:00:00	1989-11-01	38000177		0	0	360		0	0	0	313130	0	749882	19128065		
17573	380	40213296	2011-11-18	2011-11-18 00:00:00	2011-11-18	2011-11-18 00:00:00	2011-11-18	581452		0	0	0		0	0	0	25134	0	52	40213296		
56759	4709	19006318	1956-06-06	1956-06-06 00:00:00	1956-06-20	1956-06-20 00:00:00	1956-06-20	38000177		0	0	14		0	0	0	313637	0	105078	19006318		
99831	2186	40213306	1995-04-06	1995-04-06 00:00:00	1995-04-06	1995-04-06 00:00:00	1995-04-06	581452		0	0	0		0	0	0	145755	0	43	40213306		
181732	3993	40213227	2018-01-29	2018-01-29 00:00:00	2018-01-29	2018-01-29 00:00:00	2018-01-29	581452		0	0	0		0	0	0	265532	0	113	40213227		
121025	2659	40213314	1977-06-01	1977-06-01 00:00:00	1977-06-01	1977-06-01 00:00:00	1977-06-01	581452		0	0	0		0	0	0	176140	0	49	40213314		
89706	1967	40213260	2006-10-19	2006-10-19 00:00:00	2006-10-19	2006-10-19 00:00:00	2006-10-19	581452		0	0	0		0	0	0	130874	0	121	40213260		
161662	3556	40213314	1978-10-23	1978-10-23 00:00:00	1978-10-23	1978-10-23 00:00:00	1978-10-23	581452		0	0	0		0	0	0	236106	0	49	40213314		
38675	3195	19078461	2015-09-07	2015-09-07 00:00:00	2015-11-13	2015-11-13 00:00:00	2015-11-13	38000177		0	0	67		0	0	0	212594	0	310965	19078461		
157612	3469	40213260	2006-10-25	2006-10-25 00:00:00	2006-10-25	2006-10-25 00:00:00	2006-10-25	581452		0	0	0		0	0	0	230237	0	121	40213260		
6432	140	40213160	1974-05-16	1974-05-16 00:00:00	1974-05-16	1974-05-16 00:00:00	1974-05-16	581452		0	0	0		0	0	0	9389	0	10	40213160		
46403	3844	40229134	1975-07-01	1975-07-01 00:00:00	1975-07-15	1975-07-15 00:00:00	1975-07-15	38000177		0	0	14		0	0	0	255132	0	1043400	40229134		
32308	704	40213160	1966-03-16	1966-03-16 00:00:00	1966-03-16	1966-03-16 00:00:00	1966-03-16	581452		0	0	0		0	0	0	46599	0	10	40213160		
100929	2211	40213227	1993-08-22	1993-08-22 00:00:00	1993-08-22	1993-08-22 00:00:00	1993-08-22	581452		0	0	0		0	0	0	147285	0	113	40213227		
51819	1134	40213227	2000-10-29	2000-10-29 00:00:00	2000-10-29	2000-10-29 00:00:00	2000-10-29	581452		0	0	0		0	0	0	74686	0	113	40213227		
133191	2925	40213160	1960-04-17	1960-04-17 00:00:00	1960-04-17	1960-04-17 00:00:00	1960-04-17	581452		0	0	0		0	0	0	194998	0	10	40213160		
11825	986	19133905	1967-05-23	1967-05-23 00:00:00	1967-06-04	1967-06-04 00:00:00	1967-06-04	38000177		0	0	12		0	0	0	65508	0	834102	19133905		
203842	4475	40213160	1979-01-28	1979-01-28 00:00:00	1979-01-28	1979-01-28 00:00:00	1979-01-28	581452		0	0	0		0	0	0	297741	0	10	40213160		
38193	3159	19006318	1963-11-12	1963-11-12 00:00:00	1963-11-26	1963-11-26 00:00:00	1963-11-26	38000177		0	0	14		0	0	0	210095	0	105078	19006318		
32857	718	40213160	1971-02-06	1971-02-06 00:00:00	1971-02-06	1971-02-06 00:00:00	1971-02-06	581452		0	0	0		0	0	0	47448	0	10	40213160		
29500	2442	19133873	1979-12-18	1979-12-18 00:00:00	1979-12-28	1979-12-28 00:00:00	1979-12-28	38000177		0	0	10		0	0	0	162010	0	834061	19133873		
166877	3668	40213296	2015-09-06	2015-09-06 00:00:00	2015-09-06	2015-09-06 00:00:00	2015-09-06	581452		0	0	0		0	0	0	244027	0	52	40213296		
135565	2976	40213296	1997-07-03	1997-07-03 00:00:00	1997-07-03	1997-07-03 00:00:00	1997-07-03	581452		0	0	0		0	0	0	198762	0	52	40213296		
15767	340	40213227	2009-05-20	2009-05-20 00:00:00	2009-05-20	2009-05-20 00:00:00	2009-05-20	581452		0	0	0		0	0	0	22728	0	113	40213227		
29761	2466	1127433	1996-08-17	1996-08-17 00:00:00	1996-09-07	1996-09-07 00:00:00	1996-09-07	38000177		0	0	21		0	0	0	163501	0	313782	1127433		
110850	2435	40213227	1995-11-03	1995-11-03 00:00:00	1995-11-03	1995-11-03 00:00:00	1995-11-03	581452		0	0	0		0	0	0	161445	0	113	40213227		
229322	5039	40213227	2005-12-27	2005-12-27 00:00:00	2005-12-27	2005-12-27 00:00:00	2005-12-27	581452		0	0	0		0	0	0	334907	0	113	40213227		
63456	5272	1127433	2001-03-22	2001-03-22 00:00:00	2001-04-05	2001-04-05 00:00:00	2001-04-05	38000177		0	0	14		0	0	0	350612	0	313782	1127433		
43262	3582	1127433	2011-12-03	2011-12-03 00:00:00	2012-02-01	2012-02-01 00:00:00	2012-02-01	38000177		0	0	60		0	0	0	238125	0	313782	1127433		
229472	5043	40213227	2015-10-02	2015-10-02 00:00:00	2015-10-02	2015-10-02 00:00:00	2015-10-02	581452		0	0	0		0	0	0	335175	0	113	40213227		
15668	1306	1127433	1980-06-29	1980-06-29 00:00:00	1980-07-13	1980-07-13 00:00:00	1980-07-13	38000177		0	0	14		0	0	0	86201	0	313782	1127433		
15708	1309	1127433	1987-09-17	1987-09-17 00:00:00	1987-09-24	1987-09-24 00:00:00	1987-09-24	38000177		0	0	7		0	0	0	86442	0	313782	1127433		
176557	3881	40213227	2006-09-01	2006-09-01 00:00:00	2006-09-01	2006-09-01 00:00:00	2006-09-01	581452		0	0	0		0	0	0	257942	0	113	40213227		
57873	1266	40213160	1967-04-17	1967-04-17 00:00:00	1967-04-17	1967-04-17 00:00:00	1967-04-17	581452		0	0	0		0	0	0	83472	0	10	40213160		
91039	1998	40213227	2003-11-22	2003-11-22 00:00:00	2003-11-22	2003-11-22 00:00:00	2003-11-22	581452		0	0	0		0	0	0	133026	0	113	40213227		
45266	3746	1713671	2005-10-17	2005-10-17 00:00:00	2005-11-07	2005-11-07 00:00:00	2005-11-07	38000177		0	0	21		0	0	0	249032	0	562251	1713671		
26390	2172	19019979	1981-05-11	1981-05-11 00:00:00	1981-05-25	1981-05-25 00:00:00	1981-05-25	38000177		0	0	14		0	0	0	144684	0	198405	19019979		
55795	4631	19059056	1929-10-09	1929-10-09 00:00:00	1929-12-08	1929-12-08 00:00:00	1929-12-08	38000177		0	0	60		0	0	0	308553	0	243670	19059056		
5822	487	1127433	1972-09-11	1972-09-11 00:00:00	1972-09-25	1972-09-25 00:00:00	1972-09-25	38000177		0	0	14		0	0	0	32567	0	313782	1127433		
28255	2333	40220960	2007-04-03	2007-04-03 00:00:00	2007-04-03	2007-04-03 00:00:00	2007-04-03	38000177		0	0	0		0	0	0	155219	0	1804799	40220960		
9006	752	1127433	1979-10-18	1979-10-18 00:00:00	1979-11-08	1979-11-08 00:00:00	1979-11-08	38000177		0	0	21		0	0	0	49641	0	313782	1127433		
28369	2341	19075001	1994-10-18	1994-10-18 00:00:00	1994-11-22	1994-11-22 00:00:00	1994-11-22	38000177		0	0	35		0	0	0	155804	0	309097	19075001		
35348	771	40213227	2000-12-20	2000-12-20 00:00:00	2000-12-20	2000-12-20 00:00:00	2000-12-20	581452		0	0	0		0	0	0	51213	0	113	40213227		
127987	2815	40213296	2006-04-07	2006-04-07 00:00:00	2006-04-07	2006-04-07 00:00:00	2006-04-07	581452		0	0	0		0	0	0	186553	0	52	40213296		
31196	2586	19112599	1973-07-20	1973-07-20 00:00:00	1973-07-20	1973-07-20 00:00:00	\N	38000177		0	0	0		0	0	0	171161	0	477045	19112599		
39003	3223	1127433	1981-06-06	1981-06-06 00:00:00	1981-06-20	1981-06-20 00:00:00	1981-06-20	38000177		0	0	14		0	0	0	214311	0	313782	1127433		
83527	1826	40213227	2019-03-19	2019-03-19 00:00:00	2019-03-19	2019-03-19 00:00:00	2019-03-19	581452		0	0	0		0	0	0	122080	0	113	40213227		
3624	298	19006318	1955-09-03	1955-09-03 00:00:00	1955-09-17	1955-09-17 00:00:00	1955-09-17	38000177		0	0	14		0	0	0	19873	0	105078	19006318		
18434	1526	1127078	1974-05-18	1974-05-18 00:00:00	1974-06-01	1974-06-01 00:00:00	1974-06-01	38000177		0	0	14		0	0	0	102086	0	282464	1127078		
243373	5343	40213160	1987-12-13	1987-12-13 00:00:00	1987-12-13	1987-12-13 00:00:00	1987-12-13	581452		0	0	0		0	0	0	355951	0	10	40213160		
227341	4992	40213227	2007-05-17	2007-05-17 00:00:00	2007-05-17	2007-05-17 00:00:00	2007-05-17	581452		0	0	0		0	0	0	332135	0	113	40213227		
14320	1202	42902245	2001-05-27	2001-05-27 00:00:00	2002-05-22	2002-05-22 00:00:00	2002-05-22	38000177		0	0	360		0	0	0	79075	0	1359133	42902245		
215476	4725	40213314	1977-05-23	1977-05-23 00:00:00	1977-05-23	1977-05-23 00:00:00	1977-05-23	581452		0	0	0		0	0	0	314916	0	49	40213314		
14423	1211	40229134	1967-01-07	1967-01-07 00:00:00	1967-01-14	1967-01-14 00:00:00	1967-01-14	38000177		0	0	7		0	0	0	79516	0	1043400	40229134		
57484	1258	40213160	1971-12-13	1971-12-13 00:00:00	1971-12-13	1971-12-13 00:00:00	1971-12-13	581452		0	0	0		0	0	0	82856	0	10	40213160		
155841	3430	40213306	1983-09-17	1983-09-17 00:00:00	1983-09-17	1983-09-17 00:00:00	1983-09-17	581452		0	0	0		0	0	0	227365	0	43	40213306		
18146	393	40213227	2019-01-09	2019-01-09 00:00:00	2019-01-09	2019-01-09 00:00:00	2019-01-09	581452		0	0	0		0	0	0	25788	0	113	40213227		
169718	3732	40213160	1955-10-23	1955-10-23 00:00:00	1955-10-23	1955-10-23 00:00:00	1955-10-23	581452		0	0	0		0	0	0	247958	0	10	40213160		
62113	5168	1127433	2011-05-27	2011-05-27 00:00:00	2011-06-17	2011-06-17 00:00:00	2011-06-17	38000177		0	0	21		0	0	0	343597	0	313782	1127433		
126725	2788	40213227	2009-05-31	2009-05-31 00:00:00	2009-05-31	2009-05-31 00:00:00	2009-05-31	581452		0	0	0		0	0	0	184743	0	113	40213227		
6745	569	19078461	1999-10-05	1999-10-05 00:00:00	1999-12-04	1999-12-04 00:00:00	1999-12-04	38000177		0	0	60		0	0	0	37722	0	310965	19078461		
1722	38	40213160	1969-08-19	1969-08-19 00:00:00	1969-08-19	1969-08-19 00:00:00	1969-08-19	581452		0	0	0		0	0	0	2686	0	10	40213160		
60944	5068	19059056	1936-09-10	1936-09-10 00:00:00	1936-09-24	1936-09-24 00:00:00	1936-09-24	38000177		0	0	14		0	0	0	336925	0	243670	19059056		
94476	2073	40213160	1963-10-25	1963-10-25 00:00:00	1963-10-25	1963-10-25 00:00:00	1963-10-25	581452		0	0	0		0	0	0	137945	0	10	40213160		
56691	4704	19128065	1982-12-06	1982-12-06 00:00:00	1983-12-01	1983-12-01 00:00:00	1983-12-01	38000177		0	0	360		0	0	0	313372	0	749882	19128065		
17574	380	40213227	1994-01-14	1994-01-14 00:00:00	1994-01-14	1994-01-14 00:00:00	1994-01-14	581452		0	0	0		0	0	0	25165	0	113	40213227		
56760	4709	1127433	1993-08-23	1993-08-23 00:00:00	1993-09-06	1993-09-06 00:00:00	1993-09-06	38000177		0	0	14		0	0	0	313701	0	313782	1127433		
99834	2186	40213227	1995-04-06	1995-04-06 00:00:00	1995-04-06	1995-04-06 00:00:00	1995-04-06	581452		0	0	0		0	0	0	145755	0	113	40213227		
151494	3332	40213227	1993-12-28	1993-12-28 00:00:00	1993-12-28	1993-12-28 00:00:00	1993-12-28	581452		0	0	0		0	0	0	221119	0	113	40213227		
201825	4432	40213260	2007-06-26	2007-06-26 00:00:00	2007-06-26	2007-06-26 00:00:00	2007-06-26	581452		0	0	0		0	0	0	294626	0	121	40213260		
89708	1967	40213227	2006-10-19	2006-10-19 00:00:00	2006-10-19	2006-10-19 00:00:00	2006-10-19	581452		0	0	0		0	0	0	130874	0	113	40213227		
56005	4649	1127433	1999-01-06	1999-01-06 00:00:00	1999-01-20	1999-01-20 00:00:00	1999-01-20	38000177		0	0	14		0	0	0	310009	0	313782	1127433		
38676	3195	19059056	1962-04-13	1962-04-13 00:00:00	1962-05-13	1962-05-13 00:00:00	1962-05-13	38000177		0	0	30		0	0	0	212591	0	243670	19059056		
157619	3469	40213296	1996-03-27	1996-03-27 00:00:00	1996-03-27	1996-03-27 00:00:00	1996-03-27	581452		0	0	0		0	0	0	230288	0	52	40213296		
6438	140	40213260	2019-06-06	2019-06-06 00:00:00	2019-06-06	2019-06-06 00:00:00	2019-06-06	581452		0	0	0		0	0	0	9368	0	121	40213260		
46404	3844	19059056	1970-03-26	1970-03-26 00:00:00	1970-06-24	1970-06-24 00:00:00	1970-06-24	38000177		0	0	90		0	0	0	255129	0	243670	19059056		
32311	704	40213160	1966-08-17	1966-08-17 00:00:00	1966-08-17	1966-08-17 00:00:00	1966-08-17	581452		0	0	0		0	0	0	46633	0	10	40213160		
100930	2211	40213306	1993-08-22	1993-08-22 00:00:00	1993-08-22	1993-08-22 00:00:00	1993-08-22	581452		0	0	0		0	0	0	147285	0	43	40213306		
51846	1135	40213306	1981-01-10	1981-01-10 00:00:00	1981-01-10	1981-01-10 00:00:00	1981-01-10	581452		0	0	0		0	0	0	74795	0	43	40213306		
133197	2925	40213160	1960-06-20	1960-06-20 00:00:00	1960-06-20	1960-06-20 00:00:00	1960-06-20	581452		0	0	0		0	0	0	195133	0	10	40213160		
11826	986	1127433	1965-06-18	1965-06-18 00:00:00	1965-07-02	1965-07-02 00:00:00	1965-07-02	38000177		0	0	14		0	0	0	65507	0	313782	1127433		
203849	4475	40213251	1984-05-07	1984-05-07 00:00:00	1984-05-07	1984-05-07 00:00:00	1984-05-07	581452		0	0	0		0	0	0	297719	0	21	40213251		
38194	3159	1127078	1963-11-12	1963-11-12 00:00:00	1963-11-26	1963-11-26 00:00:00	1963-11-26	38000177		0	0	14		0	0	0	210095	0	282464	1127078		
32869	718	40213160	1966-11-05	1966-11-05 00:00:00	1966-11-05	1966-11-05 00:00:00	1966-11-05	581452		0	0	0		0	0	0	47537	0	10	40213160		
29501	2442	1713671	1981-06-10	1981-06-10 00:00:00	1981-07-01	1981-07-01 00:00:00	1981-07-01	38000177		0	0	21		0	0	0	162011	0	562251	1713671		
166883	3668	40213314	1978-01-01	1978-01-01 00:00:00	1978-01-01	1978-01-01 00:00:00	1978-01-01	581452		0	0	0		0	0	0	244046	0	49	40213314		
135568	2976	40213260	2007-10-18	2007-10-18 00:00:00	2007-10-18	2007-10-18 00:00:00	2007-10-18	581452		0	0	0		0	0	0	198732	0	121	40213260		
15768	340	40213260	2009-05-20	2009-05-20 00:00:00	2009-05-20	2009-05-20 00:00:00	2009-05-20	581452		0	0	0		0	0	0	22728	0	121	40213260		
29762	2466	1127433	1979-10-17	1979-10-17 00:00:00	1979-10-30	1979-10-30 00:00:00	1979-10-30	38000177		0	0	13		0	0	0	163502	0	313782	1127433		
110851	2435	40213306	1995-11-03	1995-11-03 00:00:00	1995-11-03	1995-11-03 00:00:00	1995-11-03	581452		0	0	0		0	0	0	161445	0	43	40213306		
229323	5039	40213314	1977-06-28	1977-06-28 00:00:00	1977-06-28	1977-06-28 00:00:00	1977-06-28	581452		0	0	0		0	0	0	334869	0	49	40213314		
63457	5272	1118084	1952-05-31	1952-05-31 00:00:00	1952-05-31	1952-05-31 00:00:00	\N	38000177		0	0	0		0	0	0	350696	0	00025152531	44923712		
43263	3582	40169281	1996-06-02	1996-06-02 00:00:00	1996-06-02	1996-06-02 00:00:00	\N	38000177		0	0	0		0	0	0	238104	0	896209	40169281		
67133	1468	40213198	2015-06-03	2015-06-03 00:00:00	2015-06-03	2015-06-03 00:00:00	2015-06-03	581452		0	0	0		0	0	0	97794	0	133	40213198		
15669	1306	1118084	2001-01-14	2001-01-14 00:00:00	2001-01-14	2001-01-14 00:00:00	\N	38000177		0	0	0		0	0	0	86176	0	00025152531	44923712		
15709	1309	19074841	1984-04-25	1984-04-25 00:00:00	1984-05-10	1984-05-10 00:00:00	1984-05-10	38000177		0	0	15		0	0	0	86526	0	309043	19074841		
176558	3881	40213260	2006-09-01	2006-09-01 00:00:00	2006-09-01	2006-09-01 00:00:00	2006-09-01	581452		0	0	0		0	0	0	257942	0	121	40213260		
57887	1267	40213296	1996-05-23	1996-05-23 00:00:00	1996-05-23	1996-05-23 00:00:00	1996-05-23	581452		0	0	0		0	0	0	83575	0	52	40213296		
91041	1998	40213306	2003-11-22	2003-11-22 00:00:00	2003-11-22	2003-11-22 00:00:00	2003-11-22	581452		0	0	0		0	0	0	133026	0	43	40213306		
45267	3746	1127433	1945-01-04	1945-01-04 00:00:00	1945-01-18	1945-01-18 00:00:00	1945-01-18	38000177		0	0	14		0	0	0	248977	0	313782	1127433		
26391	2172	19073183	1981-05-11	1981-05-11 00:00:00	1981-05-25	1981-05-25 00:00:00	1981-05-25	38000177		0	0	14		0	0	0	144684	0	308182	19073183		
55796	4631	40162522	2002-06-28	2002-06-28 00:00:00	2002-06-28	2002-06-28 00:00:00	\N	38000177		0	0	0		0	0	0	308560	0	857005	40162522		
5823	487	1127078	1969-03-29	1969-03-29 00:00:00	1969-04-12	1969-04-12 00:00:00	1969-04-12	38000177		0	0	14		0	0	0	32601	0	282464	1127078		
28256	2333	19078461	1991-04-19	1991-04-19 00:00:00	1991-05-10	1991-05-10 00:00:00	1991-05-10	38000177		0	0	21		0	0	0	155164	0	310965	19078461		
9007	752	1127433	1997-10-20	1997-10-20 00:00:00	1997-11-03	1997-11-03 00:00:00	1997-11-03	38000177		0	0	14		0	0	0	49735	0	313782	1127433		
28371	2341	1115171	2014-05-25	2014-05-25 00:00:00	2014-06-29	2014-06-29 00:00:00	2014-06-29	38000177		0	0	35		0	0	0	155849	0	849574	1115171		
35349	771	40213296	2000-12-20	2000-12-20 00:00:00	2000-12-20	2000-12-20 00:00:00	2000-12-20	581452		0	0	0		0	0	0	51213	0	52	40213296		
128000	2815	40213160	1962-12-21	1962-12-21 00:00:00	1962-12-21	1962-12-21 00:00:00	1962-12-21	581452		0	0	0		0	0	0	186543	0	10	40213160		
31197	2586	1127433	2014-09-19	2014-09-19 00:00:00	2014-09-26	2014-09-26 00:00:00	2014-09-26	38000177		0	0	7		0	0	0	171177	0	313782	1127433		
39004	3223	19133905	1985-09-24	1985-09-24 00:00:00	1985-10-06	1985-10-06 00:00:00	1985-10-06	38000177		0	0	12		0	0	0	214315	0	834102	19133905		
230259	5060	40213160	1972-09-04	1972-09-04 00:00:00	1972-09-04	1972-09-04 00:00:00	1972-09-04	581452		0	0	0		0	0	0	336423	0	10	40213160		
3625	298	19129655	1974-09-30	1974-09-30 00:00:00	1974-10-14	1974-10-14 00:00:00	1974-10-14	38000177		0	0	14		0	0	0	19924	0	789980	19129655		
18435	1526	19128022	1995-11-04	1995-11-04 00:00:00	1996-10-29	1996-10-29 00:00:00	1996-10-29	38000177		0	0	360		0	0	0	102087	0	749785	19128022		
243377	5343	40213160	1983-09-11	1983-09-11 00:00:00	1983-09-11	1983-09-11 00:00:00	1983-09-11	581452		0	0	0		0	0	0	355841	0	10	40213160		
227342	4992	40213306	2007-05-17	2007-05-17 00:00:00	2007-05-17	2007-05-17 00:00:00	2007-05-17	581452		0	0	0		0	0	0	332135	0	43	40213306		
14321	1202	19128022	1998-06-12	1998-06-12 00:00:00	1999-06-07	1999-06-07 00:00:00	1999-06-07	38000177		0	0	360		0	0	0	79052	0	749785	19128022		
215480	4725	40213314	1977-02-28	1977-02-28 00:00:00	1977-02-28	1977-02-28 00:00:00	1977-02-28	581452		0	0	0		0	0	0	314898	0	49	40213314		
14424	1211	40229134	1992-01-31	1992-01-31 00:00:00	1992-02-07	1992-02-07 00:00:00	1992-02-07	38000177		0	0	7		0	0	0	79652	0	1043400	40229134		
57489	1258	40213296	2010-07-05	2010-07-05 00:00:00	2010-07-05	2010-07-05 00:00:00	2010-07-05	581452		0	0	0		0	0	0	82860	0	52	40213296		
155844	3430	40213160	1966-06-25	1966-06-25 00:00:00	1966-06-25	1966-06-25 00:00:00	1966-06-25	581452		0	0	0		0	0	0	227387	0	10	40213160		
18147	393	40213227	2008-10-15	2008-10-15 00:00:00	2008-10-15	2008-10-15 00:00:00	2008-10-15	581452		0	0	0		0	0	0	25785	0	113	40213227		
169721	3732	40213160	1960-06-26	1960-06-26 00:00:00	1960-06-26	1960-06-26 00:00:00	1960-06-26	581452		0	0	0		0	0	0	248020	0	10	40213160		
62114	5168	19133905	2000-04-20	2000-04-20 00:00:00	2000-05-01	2000-05-01 00:00:00	2000-05-01	38000177		0	0	11		0	0	0	343648	0	834102	19133905		
138010	3030	40213160	1982-01-26	1982-01-26 00:00:00	1982-01-26	1982-01-26 00:00:00	1982-01-26	581452		0	0	0		0	0	0	202006	0	10	40213160		
6746	569	1713671	1989-01-26	1989-01-26 00:00:00	1989-02-09	1989-02-09 00:00:00	1989-02-09	38000177		0	0	14		0	0	0	37695	0	562251	1713671		
36168	789	40213160	1972-10-02	1972-10-02 00:00:00	1972-10-02	1972-10-02 00:00:00	1972-10-02	581452		0	0	0		0	0	0	52487	0	10	40213160		
178692	3928	40213227	2002-02-10	2002-02-10 00:00:00	2002-02-10	2002-02-10 00:00:00	2002-02-10	581452		0	0	0		0	0	0	261109	0	113	40213227		
94479	2073	40213227	2014-11-21	2014-11-21 00:00:00	2014-11-21	2014-11-21 00:00:00	2014-11-21	581452		0	0	0		0	0	0	137904	0	113	40213227		
56692	4704	19078461	2010-09-21	2010-09-21 00:00:00	2010-10-26	2010-10-26 00:00:00	2010-10-26	38000177		0	0	35		0	0	0	313433	0	310965	19078461		
17575	380	40213306	1994-01-14	1994-01-14 00:00:00	1994-01-14	1994-01-14 00:00:00	1994-01-14	581452		0	0	0		0	0	0	25165	0	43	40213306		
56761	4709	1124300	1998-08-15	1998-08-15 00:00:00	1998-08-15	1998-08-15 00:00:00	\N	38000177		0	0	0		0	0	0	313657	0	00781178901	45011828		
99836	2186	40213160	1973-07-19	1973-07-19 00:00:00	1973-07-19	1973-07-19 00:00:00	1973-07-19	581452		0	0	0		0	0	0	145774	0	10	40213160		
151497	3332	40213296	2000-12-12	2000-12-12 00:00:00	2000-12-12	2000-12-12 00:00:00	2000-12-12	581452		0	0	0		0	0	0	221111	0	52	40213296		
201830	4432	40213227	2018-08-28	2018-08-28 00:00:00	2018-08-28	2018-08-28 00:00:00	2018-08-28	581452		0	0	0		0	0	0	294628	0	113	40213227		
89714	1967	40213227	2017-04-06	2017-04-06 00:00:00	2017-04-06	2017-04-06 00:00:00	2017-04-06	581452		0	0	0		0	0	0	130778	0	113	40213227		
56006	4649	19128022	1990-12-27	1990-12-27 00:00:00	1991-12-22	1991-12-22 00:00:00	1991-12-22	38000177		0	0	360		0	0	0	310000	0	749785	19128022		
38677	3195	1127433	2006-11-23	2006-11-23 00:00:00	2006-12-23	2006-12-23 00:00:00	2006-12-23	38000177		0	0	30		0	0	0	212593	0	313782	1127433		
157630	3470	40213296	1996-11-18	1996-11-18 00:00:00	1996-11-18	1996-11-18 00:00:00	1996-11-18	581452		0	0	0		0	0	0	230314	0	52	40213296		
6443	140	40213227	2011-06-16	2011-06-16 00:00:00	2011-06-16	2011-06-16 00:00:00	2011-06-16	581452		0	0	0		0	0	0	9342	0	113	40213227		
46405	3844	40162522	1970-03-26	1970-03-26 00:00:00	1970-03-26	1970-03-26 00:00:00	\N	38000177		0	0	0		0	0	0	255129	0	857005	40162522		
32318	704	40213296	2009-04-22	2009-04-22 00:00:00	2009-04-22	2009-04-22 00:00:00	2009-04-22	581452		0	0	0		0	0	0	46593	0	52	40213296		
126207	2776	40213314	1978-06-18	1978-06-18 00:00:00	1978-06-18	1978-06-18 00:00:00	1978-06-18	581452		0	0	0		0	0	0	183789	0	49	40213314		
184550	4055	40213227	2000-01-19	2000-01-19 00:00:00	2000-01-19	2000-01-19 00:00:00	2000-01-19	581452		0	0	0		0	0	0	269551	0	113	40213227		
133200	2925	40213160	1964-12-20	1964-12-20 00:00:00	1964-12-20	1964-12-20 00:00:00	1964-12-20	581452		0	0	0		0	0	0	195135	0	10	40213160		
11827	986	19133873	1926-11-20	1926-11-20 00:00:00	1926-11-29	1926-11-29 00:00:00	1926-11-29	38000177		0	0	9		0	0	0	65458	0	834061	19133873		
203851	4475	40213296	2018-05-28	2018-05-28 00:00:00	2018-05-28	2018-05-28 00:00:00	2018-05-28	581452		0	0	0		0	0	0	297749	0	52	40213296		
38195	3159	19128065	1981-05-10	1981-05-10 00:00:00	1982-05-05	1982-05-05 00:00:00	1982-05-05	38000177		0	0	360		0	0	0	210055	0	749882	19128065		
32872	718	40213306	1988-11-19	1988-11-19 00:00:00	1988-11-19	1988-11-19 00:00:00	1988-11-19	581452		0	0	0		0	0	0	47549	0	43	40213306		
29502	2442	1713671	2007-05-15	2007-05-15 00:00:00	2007-05-22	2007-05-22 00:00:00	2007-05-22	38000177		0	0	7		0	0	0	161992	0	562251	1713671		
166887	3668	40213314	1977-07-03	1977-07-03 00:00:00	1977-07-03	1977-07-03 00:00:00	1977-07-03	581452		0	0	0		0	0	0	244055	0	49	40213314		
135575	2976	40213160	1956-03-01	1956-03-01 00:00:00	1956-03-01	1956-03-01 00:00:00	1956-03-01	581452		0	0	0		0	0	0	198738	0	10	40213160		
15770	340	40213160	1959-01-21	1959-01-21 00:00:00	1959-01-21	1959-01-21 00:00:00	1959-01-21	581452		0	0	0		0	0	0	22675	0	10	40213160		
29763	2466	1127433	2004-04-26	2004-04-26 00:00:00	2004-05-03	2004-05-03 00:00:00	2004-05-03	38000177		0	0	7		0	0	0	163506	0	313782	1127433		
68074	1490	40213201	2004-01-01	2004-01-01 00:00:00	2004-01-01	2004-01-01 00:00:00	2004-01-01	581452		0	0	0		0	0	0	99333	0	33	40213201		
229327	5039	40213314	1977-12-27	1977-12-27 00:00:00	1977-12-27	1977-12-27 00:00:00	1977-12-27	581452		0	0	0		0	0	0	334901	0	49	40213314		
63468	5274	1127433	1999-12-18	1999-12-18 00:00:00	2000-01-01	2000-01-01 00:00:00	2000-01-01	38000177		0	0	14		0	0	0	350837	0	313782	1127433		
43264	3583	1127433	1985-10-07	1985-10-07 00:00:00	1985-11-11	1985-11-11 00:00:00	1985-11-11	38000177		0	0	35		0	0	0	238206	0	313782	1127433		
67147	1468	40213201	2016-06-08	2016-06-08 00:00:00	2016-06-08	2016-06-08 00:00:00	2016-06-08	581452		0	0	0		0	0	0	97847	0	33	40213201		
15670	1306	19059056	1968-05-28	1968-05-28 00:00:00	1968-07-02	1968-07-02 00:00:00	1968-07-02	38000177		0	0	35		0	0	0	86200	0	243670	19059056		
15710	1309	1127433	1984-04-25	1984-04-25 00:00:00	1984-05-10	1984-05-10 00:00:00	1984-05-10	38000177		0	0	15		0	0	0	86526	0	313782	1127433		
176564	3881	40213227	1998-01-23	1998-01-23 00:00:00	1998-01-23	1998-01-23 00:00:00	1998-01-23	581452		0	0	0		0	0	0	257908	0	113	40213227		
57888	1267	40213160	1955-10-27	1955-10-27 00:00:00	1955-10-27	1955-10-27 00:00:00	1955-10-27	581452		0	0	0		0	0	0	83570	0	10	40213160		
91043	1998	40213314	1982-11-27	1982-11-27 00:00:00	1982-11-27	1982-11-27 00:00:00	1982-11-27	581452		0	0	0		0	0	0	133006	0	49	40213314		
45268	3746	1127433	1985-04-14	1985-04-14 00:00:00	1985-04-28	1985-04-28 00:00:00	1985-04-28	38000177		0	0	14		0	0	0	248980	0	313782	1127433		
26392	2172	1127078	1979-09-02	1979-09-02 00:00:00	1979-09-16	1979-09-16 00:00:00	1979-09-16	38000177		0	0	14		0	0	0	144683	0	282464	1127078		
55797	4631	19078461	2002-06-28	2002-06-28 00:00:00	2002-09-26	2002-09-26 00:00:00	2002-09-26	38000177		0	0	90		0	0	0	308560	0	310965	19078461		
5824	487	19006318	1969-03-29	1969-03-29 00:00:00	1969-04-12	1969-04-12 00:00:00	1969-04-12	38000177		0	0	14		0	0	0	32601	0	105078	19006318		
28257	2333	40223768	2001-06-19	2001-06-19 00:00:00	2001-06-19	2001-06-19 00:00:00	\N	38000177		0	0	0		0	0	0	155252	0	997223	40223768		
9008	752	1713671	1994-02-14	1994-02-14 00:00:00	1994-02-28	1994-02-28 00:00:00	1994-02-28	38000177		0	0	14		0	0	0	49679	0	562251	1713671		
28372	2341	1118084	1986-01-03	1986-01-03 00:00:00	1986-01-03	1986-01-03 00:00:00	\N	38000177		0	0	0		0	0	0	155807	0	00025152531	44923712		
35353	771	40213296	1998-12-16	1998-12-16 00:00:00	1998-12-16	1998-12-16 00:00:00	1998-12-16	581452		0	0	0		0	0	0	51175	0	52	40213296		
163256	3592	40213306	1986-05-14	1986-05-14 00:00:00	1986-05-14	1986-05-14 00:00:00	1986-05-14	581452		0	0	0		0	0	0	238609	0	43	40213306		
31198	2586	1127433	1983-12-11	1983-12-11 00:00:00	1983-12-25	1983-12-25 00:00:00	1983-12-25	38000177		0	0	14		0	0	0	171144	0	313782	1127433		
39005	3223	1713671	1978-09-28	1978-09-28 00:00:00	1978-10-12	1978-10-12 00:00:00	1978-10-12	38000177		0	0	14		0	0	0	214249	0	562251	1713671		
230261	5060	40213227	2014-04-07	2014-04-07 00:00:00	2014-04-07	2014-04-07 00:00:00	2014-04-07	581452		0	0	0		0	0	0	336436	0	113	40213227		
3626	298	1127433	1974-09-30	1974-09-30 00:00:00	1974-10-14	1974-10-14 00:00:00	1974-10-14	38000177		0	0	14		0	0	0	19924	0	313782	1127433		
18436	1526	1713671	1979-09-18	1979-09-18 00:00:00	1979-10-09	1979-10-09 00:00:00	1979-10-09	38000177		0	0	21		0	0	0	102063	0	562251	1713671		
243388	5343	40213227	2005-11-20	2005-11-20 00:00:00	2005-11-20	2005-11-20 00:00:00	2005-11-20	581452		0	0	0		0	0	0	355853	0	113	40213227		
227343	4992	40213180	2007-05-17	2007-05-17 00:00:00	2007-05-17	2007-05-17 00:00:00	2007-05-17	581452		0	0	0		0	0	0	332135	0	114	40213180		
14331	1205	40229134	1975-07-20	1975-07-20 00:00:00	1975-08-03	1975-08-03 00:00:00	1975-08-03	38000177		0	0	14		0	0	0	79199	0	1043400	40229134		
215482	4725	40213160	1975-03-03	1975-03-03 00:00:00	1975-03-03	1975-03-03 00:00:00	1975-03-03	581452		0	0	0		0	0	0	314883	0	10	40213160		
14425	1211	40236824	2007-11-27	2007-11-27 00:00:00	2007-12-11	2007-12-11 00:00:00	2007-12-11	38000177		0	0	14		0	0	0	79664	0	1094107	40236824		
57493	1258	40213227	2000-06-19	2000-06-19 00:00:00	2000-06-19	2000-06-19 00:00:00	2000-06-19	581452		0	0	0		0	0	0	82911	0	113	40213227		
155846	3430	40213160	1961-12-23	1961-12-23 00:00:00	1961-12-23	1961-12-23 00:00:00	1961-12-23	581452		0	0	0		0	0	0	227383	0	10	40213160		
18149	393	40213260	2008-10-15	2008-10-15 00:00:00	2008-10-15	2008-10-15 00:00:00	2008-10-15	581452		0	0	0		0	0	0	25785	0	121	40213260		
169723	3732	40213296	1999-01-31	1999-01-31 00:00:00	1999-01-31	1999-01-31 00:00:00	1999-01-31	581452		0	0	0		0	0	0	248023	0	52	40213296		
62115	5168	1127078	1971-05-27	1971-05-27 00:00:00	1971-06-10	1971-06-10 00:00:00	1971-06-10	38000177		0	0	14		0	0	0	343638	0	282464	1127078		
138015	3030	40213160	1986-03-18	1986-03-18 00:00:00	1986-03-18	1986-03-18 00:00:00	1986-03-18	581452		0	0	0		0	0	0	202017	0	10	40213160		
6747	569	1127433	1956-06-10	1956-06-10 00:00:00	1956-06-17	1956-06-17 00:00:00	1956-06-17	38000177		0	0	7		0	0	0	37693	0	313782	1127433		
36170	789	40213227	2004-01-19	2004-01-19 00:00:00	2004-01-19	2004-01-19 00:00:00	2004-01-19	581452		0	0	0		0	0	0	52497	0	113	40213227		
178693	3928	40213306	2002-02-10	2002-02-10 00:00:00	2002-02-10	2002-02-10 00:00:00	2002-02-10	581452		0	0	0		0	0	0	261109	0	43	40213306		
94480	2073	40213260	2014-11-21	2014-11-21 00:00:00	2014-11-21	2014-11-21 00:00:00	2014-11-21	581452		0	0	0		0	0	0	137904	0	121	40213260		
56693	4704	19133873	1968-10-05	1968-10-05 00:00:00	1968-10-17	1968-10-17 00:00:00	1968-10-17	38000177		0	0	12		0	0	0	313392	0	834061	19133873		
17585	380	40213160	1976-10-22	1976-10-22 00:00:00	1976-10-22	1976-10-22 00:00:00	1976-10-22	581452		0	0	0		0	0	0	25142	0	10	40213160		
56762	4709	1127433	2000-11-20	2000-11-20 00:00:00	2000-12-04	2000-12-04 00:00:00	2000-12-04	38000177		0	0	14		0	0	0	313636	0	313782	1127433		
99838	2186	40213296	2015-06-11	2015-06-11 00:00:00	2015-06-11	2015-06-11 00:00:00	2015-06-11	581452		0	0	0		0	0	0	145789	0	52	40213296		
151501	3332	40213160	1961-08-15	1961-08-15 00:00:00	1961-08-15	1961-08-15 00:00:00	1961-08-15	581452		0	0	0		0	0	0	221103	0	10	40213160		
201838	4432	40213296	1997-07-01	1997-07-01 00:00:00	1997-07-01	1997-07-01 00:00:00	1997-07-01	581452		0	0	0		0	0	0	294624	0	52	40213296		
115582	2540	40213227	2018-04-10	2018-04-10 00:00:00	2018-04-10	2018-04-10 00:00:00	2018-04-10	581452		0	0	0		0	0	0	167902	0	113	40213227		
56007	4649	1127433	2010-05-03	2010-05-03 00:00:00	2010-05-17	2010-05-17 00:00:00	2010-05-17	38000177		0	0	14		0	0	0	310012	0	313782	1127433		
38678	3195	1127078	1951-10-29	1951-10-29 00:00:00	1951-11-12	1951-11-12 00:00:00	1951-11-12	38000177		0	0	14		0	0	0	212576	0	282464	1127078		
157632	3470	40213227	1996-11-18	1996-11-18 00:00:00	1996-11-18	1996-11-18 00:00:00	1996-11-18	581452		0	0	0		0	0	0	230314	0	113	40213227		
122705	2697	40213227	1994-06-23	1994-06-23 00:00:00	1994-06-23	1994-06-23 00:00:00	1994-06-23	581452		0	0	0		0	0	0	178593	0	113	40213227		
46406	3844	1118084	1991-02-06	1991-02-06 00:00:00	1991-02-06	1991-02-06 00:00:00	\N	38000177		0	0	0		0	0	0	255154	0	00025152531	44923712		
40618	885	40213160	1975-09-21	1975-09-21 00:00:00	1975-09-21	1975-09-21 00:00:00	1975-09-21	581452		0	0	0		0	0	0	58991	0	10	40213160		
126210	2776	40213160	1976-03-21	1976-03-21 00:00:00	1976-03-21	1976-03-21 00:00:00	1976-03-21	581452		0	0	0		0	0	0	183817	0	10	40213160		
184554	4055	40213296	2008-11-12	2008-11-12 00:00:00	2008-11-12	2008-11-12 00:00:00	2008-11-12	581452		0	0	0		0	0	0	269544	0	52	40213296		
133206	2925	40213296	2000-01-16	2000-01-16 00:00:00	2000-01-16	2000-01-16 00:00:00	2000-01-16	581452		0	0	0		0	0	0	195007	0	52	40213296		
11828	986	1127433	1932-02-09	1932-02-09 00:00:00	1932-02-16	1932-02-16 00:00:00	1932-02-16	38000177		0	0	7		0	0	0	65477	0	313782	1127433		
203853	4475	40213160	1983-05-02	1983-05-02 00:00:00	1983-05-02	1983-05-02 00:00:00	1983-05-02	581452		0	0	0		0	0	0	297761	0	10	40213160		
38196	3159	19133873	1975-07-03	1975-07-03 00:00:00	1975-07-15	1975-07-15 00:00:00	1975-07-15	38000177		0	0	12		0	0	0	210037	0	834061	19133873		
32875	718	40213227	1997-11-29	1997-11-29 00:00:00	1997-11-29	1997-11-29 00:00:00	1997-11-29	581452		0	0	0		0	0	0	47434	0	113	40213227		
29503	2442	19019979	1979-07-09	1979-07-09 00:00:00	1979-09-07	1979-09-07 00:00:00	1979-09-07	38000177		0	0	60		0	0	0	161957	0	198405	19019979		
166889	3668	40213160	1976-02-08	1976-02-08 00:00:00	1976-02-08	1976-02-08 00:00:00	1976-02-08	581452		0	0	0		0	0	0	244012	0	10	40213160		
202694	4450	40213160	1968-01-20	1968-01-20 00:00:00	1968-01-20	1968-01-20 00:00:00	1968-01-20	581452		0	0	0		0	0	0	296093	0	10	40213160		
15772	340	40213227	2000-05-24	2000-05-24 00:00:00	2000-05-24	2000-05-24 00:00:00	2000-05-24	581452		0	0	0		0	0	0	22698	0	113	40213227		
51152	4250	1713671	1966-05-14	1966-05-14 00:00:00	1966-05-21	1966-05-21 00:00:00	1966-05-21	38000177		0	0	7		0	0	0	282326	0	562251	1713671		
68076	1490	40213227	2009-01-29	2009-01-29 00:00:00	2009-01-29	2009-01-29 00:00:00	2009-01-29	581452		0	0	0		0	0	0	99388	0	113	40213227		
229333	5039	40213296	2018-05-01	2018-05-01 00:00:00	2018-05-01	2018-05-01 00:00:00	2018-05-01	581452		0	0	0		0	0	0	334910	0	52	40213296		
63469	5274	1118084	1989-11-13	1989-11-13 00:00:00	1989-11-13	1989-11-13 00:00:00	\N	38000177		0	0	0		0	0	0	350801	0	00025152531	44923712		
43265	3583	1551192	1975-07-05	1975-07-05 00:00:00	1975-07-05	1975-07-05 00:00:00	1975-07-05	38000177		0	0	0		0	0	0	238242	0	312617	1551192		
229821	5051	40213251	1984-11-15	1984-11-15 00:00:00	1984-11-15	1984-11-15 00:00:00	1984-11-15	581452		0	0	0		0	0	0	335938	0	21	40213251		
15671	1306	1127433	1983-05-16	1983-05-16 00:00:00	1983-05-30	1983-05-30 00:00:00	1983-05-30	38000177		0	0	14		0	0	0	86191	0	313782	1127433		
15711	1309	40229134	1957-02-18	1957-02-18 00:00:00	1957-03-04	1957-03-04 00:00:00	1957-03-04	38000177		0	0	14		0	0	0	86452	0	1043400	40229134		
176565	3881	40213296	1998-01-23	1998-01-23 00:00:00	1998-01-23	1998-01-23 00:00:00	1998-01-23	581452		0	0	0		0	0	0	257908	0	52	40213296		
57890	1267	40213227	2013-07-11	2013-07-11 00:00:00	2013-07-11	2013-07-11 00:00:00	2013-07-11	581452		0	0	0		0	0	0	83591	0	113	40213227		
91046	1998	40213160	1982-05-29	1982-05-29 00:00:00	1982-05-29	1982-05-29 00:00:00	1982-05-29	581452		0	0	0		0	0	0	133032	0	10	40213160		
45269	3746	19078461	2012-11-02	2012-11-02 00:00:00	2012-12-02	2012-12-02 00:00:00	2012-12-02	38000177		0	0	30		0	0	0	249066	0	310965	19078461		
26393	2172	19074843	1979-09-02	1979-09-02 00:00:00	1979-09-16	1979-09-16 00:00:00	1979-09-16	38000177		0	0	14		0	0	0	144683	0	309045	19074843		
55806	4633	19133905	1991-03-26	1991-03-26 00:00:00	1991-04-05	1991-04-05 00:00:00	1991-04-05	38000177		0	0	10		0	0	0	308741	0	834102	19133905		
45111	3733	1127078	1976-09-06	1976-09-06 00:00:00	1976-09-20	1976-09-20 00:00:00	1976-09-20	38000177		0	0	14		0	0	0	248027	0	282464	1127078		
28258	2334	1127433	1979-06-25	1979-06-25 00:00:00	1979-07-25	1979-07-25 00:00:00	1979-07-25	38000177		0	0	30		0	0	0	155344	0	313782	1127433		
9009	752	1127433	2014-05-07	2014-05-07 00:00:00	2014-05-21	2014-05-21 00:00:00	2014-05-21	38000177		0	0	14		0	0	0	49739	0	313782	1127433		
113914	2503	40213160	1973-07-31	1973-07-31 00:00:00	1973-07-31	1973-07-31 00:00:00	1973-07-31	581452		0	0	0		0	0	0	165747	0	10	40213160		
35356	771	40213227	2009-12-16	2009-12-16 00:00:00	2009-12-16	2009-12-16 00:00:00	2009-12-16	581452		0	0	0		0	0	0	51221	0	113	40213227		
163263	3592	40213160	1965-07-07	1965-07-07 00:00:00	1965-07-07	1965-07-07 00:00:00	1965-07-07	581452		0	0	0		0	0	0	238636	0	10	40213160		
31199	2586	1118084	2007-09-04	2007-09-04 00:00:00	2007-09-04	2007-09-04 00:00:00	\N	38000177		0	0	0		0	0	0	171138	0	00025152531	44923712		
39006	3223	19059056	1919-08-03	1919-08-03 00:00:00	1919-11-01	1919-11-01 00:00:00	1919-11-01	38000177		0	0	90		0	0	0	214307	0	243670	19059056		
230262	5060	40213296	2014-04-07	2014-04-07 00:00:00	2014-04-07	2014-04-07 00:00:00	2014-04-07	581452		0	0	0		0	0	0	336436	0	52	40213296		
3627	299	1127433	2019-01-12	2019-01-12 00:00:00	2019-01-19	2019-01-19 00:00:00	2019-01-19	38000177		0	0	7		0	0	0	19995	0	313782	1127433		
18437	1526	19133905	2018-12-03	2018-12-03 00:00:00	2018-12-14	2018-12-14 00:00:00	2018-12-14	38000177		0	0	11		0	0	0	102085	0	834102	19133905		
243389	5343	40213306	2005-11-20	2005-11-20 00:00:00	2005-11-20	2005-11-20 00:00:00	2005-11-20	581452		0	0	0		0	0	0	355853	0	43	40213306		
227345	4992	40213227	2016-05-26	2016-05-26 00:00:00	2016-05-26	2016-05-26 00:00:00	2016-05-26	581452		0	0	0		0	0	0	332138	0	113	40213227		
14333	1205	40236824	1981-11-26	1981-11-26 00:00:00	1981-12-03	1981-12-03 00:00:00	1981-12-03	38000177		0	0	7		0	0	0	79145	0	1094107	40236824		
215486	4725	40213227	2016-10-03	2016-10-03 00:00:00	2016-10-03	2016-10-03 00:00:00	2016-10-03	581452		0	0	0		0	0	0	314920	0	113	40213227		
14426	1211	920300	2007-11-27	2007-11-27 00:00:00	2007-12-04	2007-12-04 00:00:00	2007-12-04	38000177		0	0	7		0	0	0	79664	0	311989	920300		
57501	1258	40213260	2017-03-13	2017-03-13 00:00:00	2017-03-13	2017-03-13 00:00:00	2017-03-13	581452		0	0	0		0	0	0	82914	0	121	40213260		
158324	3486	40213227	1993-09-24	1993-09-24 00:00:00	1993-09-24	1993-09-24 00:00:00	1993-09-24	581452		0	0	0		0	0	0	231270	0	113	40213227		
18167	393	40213160	1961-08-16	1961-08-16 00:00:00	1961-08-16	1961-08-16 00:00:00	1961-08-16	581452		0	0	0		0	0	0	25777	0	10	40213160		
169725	3732	40213160	1955-12-25	1955-12-25 00:00:00	1955-12-25	1955-12-25 00:00:00	1955-12-25	581452		0	0	0		0	0	0	248017	0	10	40213160		
62116	5168	19129655	1971-05-27	1971-05-27 00:00:00	1971-06-10	1971-06-10 00:00:00	1971-06-10	38000177		0	0	14		0	0	0	343638	0	789980	19129655		
138016	3030	40213251	1986-03-18	1986-03-18 00:00:00	1986-03-18	1986-03-18 00:00:00	1986-03-18	581452		0	0	0		0	0	0	202017	0	21	40213251		
6748	569	1115171	2011-01-03	2011-01-03 00:00:00	2011-02-07	2011-02-07 00:00:00	2011-02-07	38000177		0	0	35		0	0	0	37725	0	849574	1115171		
36173	789	40213296	2012-07-02	2012-07-02 00:00:00	2012-07-02	2012-07-02 00:00:00	2012-07-02	581452		0	0	0		0	0	0	52502	0	52	40213296		
178696	3928	40213160	1980-03-16	1980-03-16 00:00:00	1980-03-16	1980-03-16 00:00:00	1980-03-16	581452		0	0	0		0	0	0	261117	0	10	40213160		
94481	2073	40213160	1968-01-26	1968-01-26 00:00:00	1968-01-26	1968-01-26 00:00:00	1968-01-26	581452		0	0	0		0	0	0	137931	0	10	40213160		
56694	4704	1127078	1968-02-06	1968-02-06 00:00:00	1968-02-20	1968-02-20 00:00:00	1968-02-20	38000177		0	0	14		0	0	0	313414	0	282464	1127078		
17588	380	40213160	1972-04-21	1972-04-21 00:00:00	1972-04-21	1972-04-21 00:00:00	1972-04-21	581452		0	0	0		0	0	0	25139	0	10	40213160		
56763	4709	1115171	2008-06-08	2008-06-08 00:00:00	2008-06-29	2008-06-29 00:00:00	2008-06-29	38000177		0	0	21		0	0	0	313647	0	849574	1115171		
99841	2186	40213227	2015-06-11	2015-06-11 00:00:00	2015-06-11	2015-06-11 00:00:00	2015-06-11	581452		0	0	0		0	0	0	145789	0	113	40213227		
151502	3332	40213227	2002-12-17	2002-12-17 00:00:00	2002-12-17	2002-12-17 00:00:00	2002-12-17	581452		0	0	0		0	0	0	221063	0	113	40213227		
201841	4432	40213160	1957-10-01	1957-10-01 00:00:00	1957-10-01	1957-10-01 00:00:00	1957-10-01	581452		0	0	0		0	0	0	294617	0	10	40213160		
12201	1024	1713671	2014-05-15	2014-05-15 00:00:00	2014-05-29	2014-05-29 00:00:00	2014-05-29	38000177		0	0	14		0	0	0	67472	0	562251	1713671		
56008	4649	1115171	2010-01-25	2010-01-25 00:00:00	2010-02-15	2010-02-15 00:00:00	2010-02-15	38000177		0	0	21		0	0	0	309992	0	849574	1115171		
49137	4078	19133873	1964-01-17	1964-01-17 00:00:00	1964-01-25	1964-01-25 00:00:00	1964-01-25	38000177		0	0	8		0	0	0	270976	0	834061	19133873		
157639	3470	40213198	2019-06-03	2019-06-03 00:00:00	2019-06-03	2019-06-03 00:00:00	2019-06-03	581452		0	0	0		0	0	0	230317	0	133	40213198		
122716	2697	40213201	1999-07-22	1999-07-22 00:00:00	1999-07-22	1999-07-22 00:00:00	1999-07-22	581452		0	0	0		0	0	0	178619	0	33	40213201		
25773	2119	19133873	1961-10-13	1961-10-13 00:00:00	1961-10-24	1961-10-24 00:00:00	1961-10-24	38000177		0	0	11		0	0	0	140998	0	834061	19133873		
40621	885	40213160	1980-03-23	1980-03-23 00:00:00	1980-03-23	1980-03-23 00:00:00	1980-03-23	581452		0	0	0		0	0	0	59024	0	10	40213160		
126215	2776	40213227	2007-07-08	2007-07-08 00:00:00	2007-07-08	2007-07-08 00:00:00	2007-07-08	581452		0	0	0		0	0	0	183849	0	113	40213227		
23360	507	40213227	2000-08-04	2000-08-04 00:00:00	2000-08-04	2000-08-04 00:00:00	2000-08-04	581452		0	0	0		0	0	0	33918	0	113	40213227		
133207	2925	40213306	1983-02-20	1983-02-20 00:00:00	1983-02-20	1983-02-20 00:00:00	1983-02-20	581452		0	0	0		0	0	0	\N	0	43	40213306		
11829	986	19059056	1918-10-18	1918-10-18 00:00:00	1918-11-01	1918-11-01 00:00:00	1918-11-01	38000177		0	0	14		0	0	0	65445	0	243670	19059056		
27663	2290	1713671	2013-04-08	2013-04-08 00:00:00	2013-04-29	2013-04-29 00:00:00	2013-04-29	38000177		0	0	21		0	0	0	152361	0	562251	1713671		
38198	3159	19128065	1983-04-30	1983-04-30 00:00:00	1984-04-24	1984-04-24 00:00:00	1984-04-24	38000177		0	0	360		0	0	0	210056	0	749882	19128065		
32878	718	40213160	1966-06-04	1966-06-04 00:00:00	1966-06-04	1966-06-04 00:00:00	1966-06-04	581452		0	0	0		0	0	0	47536	0	10	40213160		
29504	2442	1118084	2008-09-19	2008-09-19 00:00:00	2008-09-19	2008-09-19 00:00:00	\N	38000177		0	0	0		0	0	0	161993	0	00025152531	44923712		
235390	5170	40213260	2019-01-11	2019-01-11 00:00:00	2019-01-11	2019-01-11 00:00:00	2019-01-11	581452		0	0	0		0	0	0	343790	0	121	40213260		
202696	4450	40213160	1967-11-18	1967-11-18 00:00:00	1967-11-18	1967-11-18 00:00:00	1967-11-18	581452		0	0	0		0	0	0	296027	0	10	40213160		
15773	340	40213296	2000-05-24	2000-05-24 00:00:00	2000-05-24	2000-05-24 00:00:00	2000-05-24	581452		0	0	0		0	0	0	22698	0	52	40213296		
51153	4250	40236824	1964-03-29	1964-03-29 00:00:00	1964-04-12	1964-04-12 00:00:00	1964-04-12	38000177		0	0	14		0	0	0	282325	0	1094107	40236824		
68094	1490	40213227	1999-12-09	1999-12-09 00:00:00	1999-12-09	1999-12-09 00:00:00	1999-12-09	581452		0	0	0		0	0	0	99331	0	113	40213227		
218918	4804	40213251	1984-03-12	1984-03-12 00:00:00	1984-03-12	1984-03-12 00:00:00	1984-03-12	581452		0	0	0		0	0	0	319548	0	21	40213251		
63471	5274	1127433	1953-09-29	1953-09-29 00:00:00	1953-10-06	1953-10-06 00:00:00	1953-10-06	38000177		0	0	7		0	0	0	350767	0	313782	1127433		
43266	3583	1127433	1988-01-26	1988-01-26 00:00:00	1988-02-09	1988-02-09 00:00:00	1988-02-09	38000177		0	0	14		0	0	0	238260	0	313782	1127433		
229824	5051	40213160	1978-08-03	1978-08-03 00:00:00	1978-08-03	1978-08-03 00:00:00	1978-08-03	581452		0	0	0		0	0	0	335942	0	10	40213160		
214689	4707	40213314	1977-02-10	1977-02-10 00:00:00	1977-02-10	1977-02-10 00:00:00	1977-02-10	581452		0	0	0		0	0	0	313577	0	49	40213314		
15712	1309	40229134	2017-06-23	2017-06-23 00:00:00	2017-07-07	2017-07-07 00:00:00	2017-07-07	38000177		0	0	14		0	0	0	86525	0	1043400	40229134		
176570	3881	40213160	1956-05-04	1956-05-04 00:00:00	1956-05-04	1956-05-04 00:00:00	1956-05-04	581452		0	0	0		0	0	0	257936	0	10	40213160		
57897	1267	40213260	2006-06-01	2006-06-01 00:00:00	2006-06-01	2006-06-01 00:00:00	2006-06-01	581452		0	0	0		0	0	0	83547	0	121	40213260		
91051	1998	40213227	2015-01-24	2015-01-24 00:00:00	2015-01-24	2015-01-24 00:00:00	2015-01-24	581452		0	0	0		0	0	0	133000	0	113	40213227		
45270	3746	40173590	2014-06-12	2014-06-12 00:00:00	2014-06-12	2014-06-12 00:00:00	\N	38000177		0	0	0		0	0	0	249073	0	904419	40173590		
26394	2172	40229134	2004-01-25	2004-01-25 00:00:00	2004-02-08	2004-02-08 00:00:00	2004-02-08	38000177		0	0	14		0	0	0	144682	0	1043400	40229134		
55807	4633	19059056	1959-07-23	1959-07-23 00:00:00	1959-08-06	1959-08-06 00:00:00	1959-08-06	38000177		0	0	14		0	0	0	308796	0	243670	19059056		
45112	3733	19129655	1976-09-06	1976-09-06 00:00:00	1976-09-20	1976-09-20 00:00:00	1976-09-20	38000177		0	0	14		0	0	0	248027	0	789980	19129655		
28259	2334	1127433	1966-10-03	1966-10-03 00:00:00	1966-10-17	1966-10-17 00:00:00	1966-10-17	38000177		0	0	14		0	0	0	155342	0	313782	1127433		
9010	752	1310034	1979-02-04	1979-02-04 00:00:00	1979-02-04	1979-02-04 00:00:00	1979-02-04	38000177		0	0	0		0	0	0	49640	0	834357	1310034		
113916	2503	40213227	1995-04-25	1995-04-25 00:00:00	1995-04-25	1995-04-25 00:00:00	1995-04-25	581452		0	0	0		0	0	0	165706	0	113	40213227		
35357	771	40213260	2009-12-16	2009-12-16 00:00:00	2009-12-16	2009-12-16 00:00:00	2009-12-16	581452		0	0	0		0	0	0	51221	0	121	40213260		
192888	4238	40213227	1992-11-12	1992-11-12 00:00:00	1992-11-12	1992-11-12 00:00:00	1992-11-12	581452		0	0	0		0	0	0	281396	0	113	40213227		
31200	2586	19019979	1979-01-04	1979-01-04 00:00:00	1979-01-18	1979-01-18 00:00:00	1979-01-18	38000177		0	0	14		0	0	0	171221	0	198405	19019979		
39007	3223	19133905	1948-07-05	1948-07-05 00:00:00	1948-07-12	1948-07-12 00:00:00	1948-07-12	38000177		0	0	7		0	0	0	214240	0	834102	19133905		
230266	5060	40213160	1972-12-04	1972-12-04 00:00:00	1972-12-04	1972-12-04 00:00:00	1972-12-04	581452		0	0	0		0	0	0	336412	0	10	40213160		
3628	299	19133873	1967-04-09	1967-04-09 00:00:00	1967-04-17	1967-04-17 00:00:00	1967-04-17	38000177		0	0	8		0	0	0	20023	0	834061	19133873		
18438	1526	1127433	2005-09-30	2005-09-30 00:00:00	2005-10-14	2005-10-14 00:00:00	2005-10-14	38000177		0	0	14		0	0	0	102050	0	313782	1127433		
243390	5343	40213180	2005-11-20	2005-11-20 00:00:00	2005-11-20	2005-11-20 00:00:00	2005-11-20	581452		0	0	0		0	0	0	355853	0	114	40213180		
227347	4992	40213314	1985-10-24	1985-10-24 00:00:00	1985-10-24	1985-10-24 00:00:00	1985-10-24	581452		0	0	0		0	0	0	332092	0	49	40213314		
14334	1205	920300	1981-11-26	1981-11-26 00:00:00	1981-12-03	1981-12-03 00:00:00	1981-12-03	38000177		0	0	7		0	0	0	79145	0	311989	920300		
215487	4725	40213296	2016-10-03	2016-10-03 00:00:00	2016-10-03	2016-10-03 00:00:00	2016-10-03	581452		0	0	0		0	0	0	314920	0	52	40213296		
14427	1211	19078461	2009-07-19	2009-07-19 00:00:00	2009-08-02	2009-08-02 00:00:00	2009-08-02	38000177		0	0	14		0	0	0	79577	0	310965	19078461		
57509	1258	40213160	1967-11-20	1967-11-20 00:00:00	1967-11-20	1967-11-20 00:00:00	1967-11-20	581452		0	0	0		0	0	0	82853	0	10	40213160		
158330	3486	40213160	1960-09-02	1960-09-02 00:00:00	1960-09-02	1960-09-02 00:00:00	1960-09-02	581452		0	0	0		0	0	0	231196	0	10	40213160		
18176	394	40213201	1985-09-30	1985-09-30 00:00:00	1985-09-30	1985-09-30 00:00:00	1985-09-30	581452		0	0	0		0	0	0	25872	0	33	40213201		
169728	3732	40213260	2007-02-25	2007-02-25 00:00:00	2007-02-25	2007-02-25 00:00:00	2007-02-25	581452		0	0	0		0	0	0	247981	0	121	40213260		
62117	5168	1127433	2009-08-04	2009-08-04 00:00:00	2009-08-11	2009-08-11 00:00:00	2009-08-11	38000177		0	0	7		0	0	0	343610	0	313782	1127433		
138020	3030	40213227	2013-06-25	2013-06-25 00:00:00	2013-06-25	2013-06-25 00:00:00	2013-06-25	581452		0	0	0		0	0	0	201999	0	113	40213227		
6749	569	19059056	1939-09-24	1939-09-24 00:00:00	1939-10-29	1939-10-29 00:00:00	1939-10-29	38000177		0	0	35		0	0	0	37660	0	243670	19059056		
36175	789	40213306	1995-01-09	1995-01-09 00:00:00	1995-01-09	1995-01-09 00:00:00	1995-01-09	581452		0	0	0		0	0	0	52499	0	43	40213306		
178697	3928	40213314	1980-03-16	1980-03-16 00:00:00	1980-03-16	1980-03-16 00:00:00	1980-03-16	581452		0	0	0		0	0	0	261117	0	49	40213314		
94485	2073	40213227	2004-10-22	2004-10-22 00:00:00	2004-10-22	2004-10-22 00:00:00	2004-10-22	581452		0	0	0		0	0	0	137915	0	113	40213227		
56695	4704	19129655	1968-02-06	1968-02-06 00:00:00	1968-02-20	1968-02-20 00:00:00	1968-02-20	38000177		0	0	14		0	0	0	313414	0	789980	19129655		
17589	380	40213296	2013-11-22	2013-11-22 00:00:00	2013-11-22	2013-11-22 00:00:00	2013-11-22	581452		0	0	0		0	0	0	25171	0	52	40213296		
56764	4709	19059056	1962-03-07	1962-03-07 00:00:00	1962-03-21	1962-03-21 00:00:00	1962-03-21	38000177		0	0	14		0	0	0	313645	0	243670	19059056		
99842	2186	40213160	1973-05-17	1973-05-17 00:00:00	1973-05-17	1973-05-17 00:00:00	1973-05-17	581452		0	0	0		0	0	0	145841	0	10	40213160		
151503	3332	40213296	2002-12-17	2002-12-17 00:00:00	2002-12-17	2002-12-17 00:00:00	2002-12-17	581452		0	0	0		0	0	0	221063	0	52	40213296		
201842	4432	40213306	1981-09-15	1981-09-15 00:00:00	1981-09-15	1981-09-15 00:00:00	1981-09-15	581452		0	0	0		0	0	0	294578	0	43	40213306		
12202	1024	1127433	1987-07-21	1987-07-21 00:00:00	1987-08-04	1987-08-04 00:00:00	1987-08-04	38000177		0	0	14		0	0	0	67400	0	313782	1127433		
56009	4649	19128022	1989-01-06	1989-01-06 00:00:00	1990-01-01	1990-01-01 00:00:00	1990-01-01	38000177		0	0	360		0	0	0	309980	0	749785	19128022		
49138	4078	1127078	1957-01-12	1957-01-12 00:00:00	1957-01-26	1957-01-26 00:00:00	1957-01-26	38000177		0	0	14		0	0	0	271082	0	282464	1127078		
157643	3470	40213260	2007-03-19	2007-03-19 00:00:00	2007-03-19	2007-03-19 00:00:00	2007-03-19	581452		0	0	0		0	0	0	230376	0	121	40213260		
122721	2698	40213227	2005-05-25	2005-05-25 00:00:00	2005-05-25	2005-05-25 00:00:00	2005-05-25	581452		0	0	0		0	0	0	178677	0	113	40213227		
25774	2119	40229134	2017-12-12	2017-12-12 00:00:00	2017-12-19	2017-12-19 00:00:00	2017-12-19	38000177		0	0	7		0	0	0	140988	0	1043400	40229134		
40625	885	40213227	1997-06-01	1997-06-01 00:00:00	1997-06-01	1997-06-01 00:00:00	1997-06-01	581452		0	0	0		0	0	0	58996	0	113	40213227		
126224	2777	40213227	2011-04-08	2011-04-08 00:00:00	2011-04-08	2011-04-08 00:00:00	2011-04-08	581452		0	0	0		0	0	0	183912	0	113	40213227		
23368	507	40213227	2009-09-11	2009-09-11 00:00:00	2009-09-11	2009-09-11 00:00:00	2009-09-11	581452		0	0	0		0	0	0	33970	0	113	40213227		
133211	2925	40213227	2011-01-16	2011-01-16 00:00:00	2011-01-16	2011-01-16 00:00:00	2011-01-16	581452		0	0	0		0	0	0	195046	0	113	40213227		
11830	986	19059056	1924-09-07	1924-09-07 00:00:00	1924-10-05	1924-10-05 00:00:00	1924-10-05	38000177		0	0	28		0	0	0	65517	0	243670	19059056		
27664	2290	1127433	1972-10-05	1972-10-05 00:00:00	1972-12-04	1972-12-04 00:00:00	1972-12-04	38000177		0	0	60		0	0	0	152341	0	313782	1127433		
38212	3161	1713671	1995-01-27	1995-01-27 00:00:00	1995-02-10	1995-02-10 00:00:00	1995-02-10	38000177		0	0	14		0	0	0	210176	0	562251	1713671		
142670	3134	40213227	2013-03-21	2013-03-21 00:00:00	2013-03-21	2013-03-21 00:00:00	2013-03-21	581452		0	0	0		0	0	0	208593	0	113	40213227		
29505	2442	40169216	1973-06-27	1973-06-27 00:00:00	1973-06-27	1973-06-27 00:00:00	\N	38000177		0	0	0		0	0	0	162005	0	895994	40169216		
235393	5170	40213160	1969-06-06	1969-06-06 00:00:00	1969-06-06	1969-06-06 00:00:00	1969-06-06	581452		0	0	0		0	0	0	343800	0	10	40213160		
202697	4450	40213260	2017-08-12	2017-08-12 00:00:00	2017-08-12	2017-08-12 00:00:00	2017-08-12	581452		0	0	0		0	0	0	296055	0	121	40213260		
15778	340	40213227	1992-07-29	1992-07-29 00:00:00	1992-07-29	1992-07-29 00:00:00	1992-07-29	581452		0	0	0		0	0	0	22735	0	113	40213227		
51154	4250	920300	1964-03-29	1964-03-29 00:00:00	1964-04-05	1964-04-05 00:00:00	1964-04-05	38000177		0	0	7		0	0	0	282325	0	311989	920300		
68109	1490	40213227	2019-03-28	2019-03-28 00:00:00	2019-03-28	2019-03-28 00:00:00	2019-03-28	581452		0	0	0		0	0	0	99338	0	113	40213227		
218925	4805	40213227	1994-09-16	1994-09-16 00:00:00	1994-09-16	1994-09-16 00:00:00	1994-09-16	581452		0	0	0		0	0	0	319695	0	113	40213227		
63472	5274	1127433	1981-03-24	1981-03-24 00:00:00	1981-04-28	1981-04-28 00:00:00	1981-04-28	38000177		0	0	35		0	0	0	350843	0	313782	1127433		
43267	3583	1124300	2002-11-12	2002-11-12 00:00:00	2002-11-12	2002-11-12 00:00:00	\N	38000177		0	0	0		0	0	0	238179	0	00781178901	45011828		
122306	2688	40213160	1967-07-02	1967-07-02 00:00:00	1967-07-02	1967-07-02 00:00:00	1967-07-02	581452		0	0	0		0	0	0	178130	0	10	40213160		
214692	4707	40213306	1995-11-30	1995-11-30 00:00:00	1995-11-30	1995-11-30 00:00:00	1995-11-30	581452		0	0	0		0	0	0	313604	0	43	40213306		
15713	1309	1127433	2012-11-07	2012-11-07 00:00:00	2012-11-14	2012-11-14 00:00:00	2012-11-14	38000177		0	0	7		0	0	0	86487	0	313782	1127433		
176584	3881	40213160	1960-08-05	1960-08-05 00:00:00	1960-08-05	1960-08-05 00:00:00	1960-08-05	581452		0	0	0		0	0	0	257873	0	10	40213160		
57907	1267	40213160	1955-04-14	1955-04-14 00:00:00	1955-04-14	1955-04-14 00:00:00	1955-04-14	581452		0	0	0		0	0	0	83569	0	10	40213160		
91059	1998	40213251	1984-02-25	1984-02-25 00:00:00	1984-02-25	1984-02-25 00:00:00	1984-02-25	581452		0	0	0		0	0	0	133037	0	21	40213251		
45271	3746	40236446	1956-12-05	1956-12-05 00:00:00	1961-12-14	1961-12-14 00:00:00	1961-12-14	38000177		0	0	1835		0	0	0	249028	0	1091392	40236446		
36854	3047	40224805	1994-06-11	1994-06-11 00:00:00	1995-06-06	1995-06-06 00:00:00	1995-06-06	38000177		0	0	360		0	0	0	202724	0	1000126	40224805		
55808	4633	19006318	1959-07-23	1959-07-23 00:00:00	1959-08-06	1959-08-06 00:00:00	1959-08-06	38000177		0	0	14		0	0	0	308796	0	105078	19006318		
45113	3733	19074843	1981-04-08	1981-04-08 00:00:00	1981-04-22	1981-04-22 00:00:00	1981-04-22	38000177		0	0	14		0	0	0	248048	0	309045	19074843		
28260	2334	19075001	1996-10-23	1996-10-23 00:00:00	1996-11-27	1996-11-27 00:00:00	1996-11-27	38000177		0	0	35		0	0	0	155345	0	309097	19075001		
9011	752	40243436	1979-02-04	1979-02-04 00:00:00	1979-02-04	1979-02-04 00:00:00	1979-02-04	38000177		0	0	0		0	0	0	49640	0	1190795	40243436		
113917	2503	40213306	1995-04-25	1995-04-25 00:00:00	1995-04-25	1995-04-25 00:00:00	1995-04-25	581452		0	0	0		0	0	0	165706	0	43	40213306		
35367	771	40213260	2008-12-10	2008-12-10 00:00:00	2008-12-10	2008-12-10 00:00:00	2008-12-10	581452		0	0	0		0	0	0	51177	0	121	40213260		
192889	4238	40213260	2011-09-01	2011-09-01 00:00:00	2011-09-01	2011-09-01 00:00:00	2011-09-01	581452		0	0	0		0	0	0	281386	0	121	40213260		
31201	2586	19133873	1973-11-18	1973-11-18 00:00:00	1973-11-27	1973-11-27 00:00:00	1973-11-27	38000177		0	0	9		0	0	0	171162	0	834061	19133873		
39008	3223	1115171	1997-11-23	1997-11-23 00:00:00	1997-12-14	1997-12-14 00:00:00	1997-12-14	38000177		0	0	21		0	0	0	214312	0	849574	1115171		
230267	5060	40213296	2012-04-02	2012-04-02 00:00:00	2012-04-02	2012-04-02 00:00:00	2012-04-02	581452		0	0	0		0	0	0	336453	0	52	40213296		
3629	299	1124300	2000-07-22	2000-07-22 00:00:00	2000-07-22	2000-07-22 00:00:00	\N	38000177		0	0	0		0	0	0	19989	0	00781178901	45011828		
18439	1526	19128065	1988-12-10	1988-12-10 00:00:00	1989-12-05	1989-12-05 00:00:00	1989-12-05	38000177		0	0	360		0	0	0	102057	0	749882	19128065		
243395	5343	40213227	2014-08-24	2014-08-24 00:00:00	2014-08-24	2014-08-24 00:00:00	2014-08-24	581452		0	0	0		0	0	0	355854	0	113	40213227		
227348	4992	40213160	1985-10-24	1985-10-24 00:00:00	1985-10-24	1985-10-24 00:00:00	1985-10-24	581452		0	0	0		0	0	0	332092	0	10	40213160		
14335	1205	1127433	1964-12-26	1964-12-26 00:00:00	1965-01-09	1965-01-09 00:00:00	1965-01-09	38000177		0	0	14		0	0	0	79184	0	313782	1127433		
215494	4725	40213227	1997-03-03	1997-03-03 00:00:00	1997-03-03	1997-03-03 00:00:00	1997-03-03	581452		0	0	0		0	0	0	314949	0	113	40213227		
14428	1211	1713671	1998-04-12	1998-04-12 00:00:00	1998-05-03	1998-05-03 00:00:00	1998-05-03	38000177		0	0	21		0	0	0	79660	0	562251	1713671		
57512	1258	40213306	1989-09-25	1989-09-25 00:00:00	1989-09-25	1989-09-25 00:00:00	1989-09-25	581452		0	0	0		0	0	0	82908	0	43	40213306		
158333	3486	40213227	2011-02-11	2011-02-11 00:00:00	2011-02-11	2011-02-11 00:00:00	2011-02-11	581452		0	0	0		0	0	0	231223	0	113	40213227		
111143	2442	40213227	2012-07-02	2012-07-02 00:00:00	2012-07-02	2012-07-02 00:00:00	2012-07-02	581452		0	0	0		0	0	0	\N	0	113	40213227		
169730	3732	40213227	2007-02-25	2007-02-25 00:00:00	2007-02-25	2007-02-25 00:00:00	2007-02-25	581452		0	0	0		0	0	0	247981	0	113	40213227		
62118	5168	1713671	2015-11-21	2015-11-21 00:00:00	2015-12-05	2015-12-05 00:00:00	2015-12-05	38000177		0	0	14		0	0	0	343625	0	562251	1713671		
138027	3030	40213251	1984-01-24	1984-01-24 00:00:00	1984-01-24	1984-01-24 00:00:00	1984-01-24	581452		0	0	0		0	0	0	202016	0	21	40213251		
6750	569	1115171	2006-04-01	2006-04-01 00:00:00	2006-04-15	2006-04-15 00:00:00	2006-04-15	38000177		0	0	14		0	0	0	37723	0	849574	1115171		
36177	789	40213160	1972-12-04	1972-12-04 00:00:00	1972-12-04	1972-12-04 00:00:00	1972-12-04	581452		0	0	0		0	0	0	52478	0	10	40213160		
178701	3928	40213314	1981-02-15	1981-02-15 00:00:00	1981-02-15	1981-02-15 00:00:00	1981-02-15	581452		0	0	0		0	0	0	261124	0	49	40213314		
94486	2073	40213296	2004-10-22	2004-10-22 00:00:00	2004-10-22	2004-10-22 00:00:00	2004-10-22	581452		0	0	0		0	0	0	137915	0	52	40213296		
56696	4704	1127433	1972-01-17	1972-01-17 00:00:00	1972-01-24	1972-01-24 00:00:00	1972-01-24	38000177		0	0	7		0	0	0	313395	0	313782	1127433		
17591	380	40213227	2013-11-22	2013-11-22 00:00:00	2013-11-22	2013-11-22 00:00:00	2013-11-22	581452		0	0	0		0	0	0	25171	0	113	40213227		
56765	4709	1713671	1997-01-30	1997-01-30 00:00:00	1997-02-13	1997-02-13 00:00:00	1997-02-13	38000177		0	0	14		0	0	0	313702	0	562251	1713671		
56116	1229	40213260	2006-09-23	2006-09-23 00:00:00	2006-09-23	2006-09-23 00:00:00	2006-09-23	581452		0	0	0		0	0	0	80998	0	121	40213260		
151532	3334	40213227	2017-02-23	2017-02-23 00:00:00	2017-02-23	2017-02-23 00:00:00	2017-02-23	581452		0	0	0		0	0	0	221207	0	113	40213227		
201847	4432	40213160	1957-12-03	1957-12-03 00:00:00	1957-12-03	1957-12-03 00:00:00	1957-12-03	581452		0	0	0		0	0	0	294598	0	10	40213160		
12203	1024	1127433	1979-04-11	1979-04-11 00:00:00	1979-05-02	1979-05-02 00:00:00	1979-05-02	38000177		0	0	21		0	0	0	67437	0	313782	1127433		
56010	4649	19128065	1983-02-07	1983-02-07 00:00:00	1984-02-02	1984-02-02 00:00:00	1984-02-02	38000177		0	0	360		0	0	0	309998	0	749882	19128065		
49139	4078	1127078	1955-11-13	1955-11-13 00:00:00	1955-11-27	1955-11-27 00:00:00	1955-11-27	38000177		0	0	14		0	0	0	271072	0	282464	1127078		
157645	3470	40213160	1955-05-09	1955-05-09 00:00:00	1955-05-09	1955-05-09 00:00:00	1955-05-09	581452		0	0	0		0	0	0	230354	0	10	40213160		
122722	2698	40213306	2005-05-25	2005-05-25 00:00:00	2005-05-25	2005-05-25 00:00:00	2005-05-25	581452		0	0	0		0	0	0	178677	0	43	40213306		
25792	2122	1127433	2001-06-29	2001-06-29 00:00:00	2001-07-06	2001-07-06 00:00:00	2001-07-06	38000177		0	0	7		0	0	0	141218	0	313782	1127433		
40626	885	40213306	1997-06-01	1997-06-01 00:00:00	1997-06-01	1997-06-01 00:00:00	1997-06-01	581452		0	0	0		0	0	0	58996	0	43	40213306		
126225	2777	40213260	2011-04-08	2011-04-08 00:00:00	2011-04-08	2011-04-08 00:00:00	2011-04-08	581452		0	0	0		0	0	0	183912	0	121	40213260		
23380	507	40213201	2004-08-27	2004-08-27 00:00:00	2004-08-27	2004-08-27 00:00:00	2004-08-27	581452		0	0	0		0	0	0	33945	0	33	40213201		
133212	2925	40213260	2011-01-16	2011-01-16 00:00:00	2011-01-16	2011-01-16 00:00:00	2011-01-16	581452		0	0	0		0	0	0	195046	0	121	40213260		
11831	986	40229134	1971-09-24	1971-09-24 00:00:00	1971-10-01	1971-10-01 00:00:00	1971-10-01	38000177		0	0	7		0	0	0	65479	0	1043400	40229134		
27665	2290	19078461	1975-05-23	1975-05-23 00:00:00	1975-06-06	1975-06-06 00:00:00	1975-06-06	38000177		0	0	14		0	0	0	152320	0	310965	19078461		
203856	4475	40213227	2000-11-12	2000-11-12 00:00:00	2000-11-12	2000-11-12 00:00:00	2000-11-12	581452		0	0	0		0	0	0	297751	0	113	40213227		
128238	2821	40213227	2001-11-13	2001-11-13 00:00:00	2001-11-13	2001-11-13 00:00:00	2001-11-13	581452		0	0	0		0	0	0	186944	0	113	40213227		
29506	2442	1154615	1973-06-27	1973-06-27 00:00:00	1973-06-27	1973-06-27 00:00:00	\N	38000177		0	0	0		0	0	0	162005	0	745679	1154615		
235394	5170	40213160	1969-09-05	1969-09-05 00:00:00	1969-09-05	1969-09-05 00:00:00	1969-09-05	581452		0	0	0		0	0	0	343759	0	10	40213160		
202700	4450	40213296	2008-03-22	2008-03-22 00:00:00	2008-03-22	2008-03-22 00:00:00	2008-03-22	581452		0	0	0		0	0	0	296046	0	52	40213296		
15790	340	40213160	1963-04-24	1963-04-24 00:00:00	1963-04-24	1963-04-24 00:00:00	1963-04-24	581452		0	0	0		0	0	0	22720	0	10	40213160		
51155	4250	1115171	1996-11-14	1996-11-14 00:00:00	1996-12-12	1996-12-12 00:00:00	1996-12-12	38000177		0	0	28		0	0	0	282262	0	849574	1115171		
115418	2537	40213201	2014-01-19	2014-01-19 00:00:00	2014-01-19	2014-01-19 00:00:00	2014-01-19	581452		0	0	0		0	0	0	167785	0	33	40213201		
218928	4805	40213296	2002-05-03	2002-05-03 00:00:00	2002-05-03	2002-05-03 00:00:00	2002-05-03	581452		0	0	0		0	0	0	319709	0	52	40213296		
63473	5274	1127433	1966-02-22	1966-02-22 00:00:00	1966-03-22	1966-03-22 00:00:00	1966-03-22	38000177		0	0	28		0	0	0	350840	0	313782	1127433		
43268	3583	1551192	1971-11-20	1971-11-20 00:00:00	1971-11-20	1971-11-20 00:00:00	1971-11-20	38000177		0	0	0		0	0	0	238241	0	312617	1551192		
122313	2688	40213227	2013-11-24	2013-11-24 00:00:00	2013-11-24	2013-11-24 00:00:00	2013-11-24	581452		0	0	0		0	0	0	178109	0	113	40213227		
214694	4707	40213227	1995-11-30	1995-11-30 00:00:00	1995-11-30	1995-11-30 00:00:00	1995-11-30	581452		0	0	0		0	0	0	313604	0	113	40213227		
15714	1309	1127433	1993-09-11	1993-09-11 00:00:00	1993-09-18	1993-09-18 00:00:00	1993-09-18	38000177		0	0	7		0	0	0	86465	0	313782	1127433		
183152	4024	40213314	1979-07-08	1979-07-08 00:00:00	1979-07-08	1979-07-08 00:00:00	1979-07-08	581452		0	0	0		0	0	0	267541	0	49	40213314		
57908	1267	40213160	1957-05-02	1957-05-02 00:00:00	1957-05-02	1957-05-02 00:00:00	1957-05-02	581452		0	0	0		0	0	0	83526	0	10	40213160		
91062	1998	40213314	1982-02-27	1982-02-27 00:00:00	1982-02-27	1982-02-27 00:00:00	1982-02-27	581452		0	0	0		0	0	0	133005	0	49	40213314		
45272	3746	19059056	1947-10-19	1947-10-19 00:00:00	1947-11-09	1947-11-09 00:00:00	1947-11-09	38000177		0	0	21		0	0	0	249063	0	243670	19059056		
36855	3047	920300	2007-08-11	2007-08-11 00:00:00	2007-08-18	2007-08-18 00:00:00	2007-08-18	38000177		0	0	7		0	0	0	202723	0	311989	920300		
55809	4633	1127433	1974-01-05	1974-01-05 00:00:00	1974-03-13	1974-03-13 00:00:00	1974-03-13	38000177		0	0	67		0	0	0	308763	0	313782	1127433		
45114	3733	19019979	1981-04-08	1981-04-08 00:00:00	1981-04-22	1981-04-22 00:00:00	1981-04-22	38000177		0	0	14		0	0	0	248048	0	198405	19019979		
28261	2334	1115171	1996-10-23	1996-10-23 00:00:00	1996-11-27	1996-11-27 00:00:00	1996-11-27	38000177		0	0	35		0	0	0	155345	0	849574	1115171		
9012	752	46275916	1979-02-04	1979-02-04 00:00:00	1979-02-04	1979-02-04 00:00:00	1979-02-04	38000177		0	0	0		0	0	0	49640	0	1660014	46275916		
113920	2503	40213314	1977-01-25	1977-01-25 00:00:00	1977-01-25	1977-01-25 00:00:00	1977-01-25	581452		0	0	0		0	0	0	165658	0	49	40213314		
35370	771	40213160	1963-10-09	1963-10-09 00:00:00	1963-10-09	1963-10-09 00:00:00	1963-10-09	581452		0	0	0		0	0	0	51200	0	10	40213160		
192893	4238	40213306	1983-11-03	1983-11-03 00:00:00	1983-11-03	1983-11-03 00:00:00	1983-11-03	581452		0	0	0		0	0	0	281433	0	43	40213306		
31202	2586	19133873	1972-09-09	1972-09-09 00:00:00	1972-09-21	1972-09-21 00:00:00	1972-09-21	38000177		0	0	12		0	0	0	171206	0	834061	19133873		
39009	3223	1127433	1945-02-12	1945-02-12 00:00:00	1945-02-19	1945-02-19 00:00:00	1945-02-19	38000177		0	0	7		0	0	0	214324	0	313782	1127433		
184038	4044	40213260	2010-09-12	2010-09-12 00:00:00	2010-09-12	2010-09-12 00:00:00	2010-09-12	581452		0	0	0		0	0	0	268978	0	121	40213260		
3630	299	1713671	1971-02-11	1971-02-11 00:00:00	1971-03-04	1971-03-04 00:00:00	1971-03-04	38000177		0	0	21		0	0	0	20009	0	562251	1713671		
18440	1526	19133873	1979-09-23	1979-09-23 00:00:00	1979-10-03	1979-10-03 00:00:00	1979-10-03	38000177		0	0	10		0	0	0	102078	0	834061	19133873		
243400	5343	40213160	1983-04-10	1983-04-10 00:00:00	1983-04-10	1983-04-10 00:00:00	1983-04-10	581452		0	0	0		0	0	0	355847	0	10	40213160		
227349	4992	40213314	1986-07-24	1986-07-24 00:00:00	1986-07-24	1986-07-24 00:00:00	1986-07-24	581452		0	0	0		0	0	0	332159	0	49	40213314		
14336	1205	19128065	1977-09-27	1977-09-27 00:00:00	1978-09-22	1978-09-22 00:00:00	1978-09-22	38000177		0	0	360		0	0	0	79213	0	749882	19128065		
215495	4725	40213306	1997-03-03	1997-03-03 00:00:00	1997-03-03	1997-03-03 00:00:00	1997-03-03	581452		0	0	0		0	0	0	314949	0	43	40213306		
14429	1211	1127433	1990-04-02	1990-04-02 00:00:00	1990-04-16	1990-04-16 00:00:00	1990-04-16	38000177		0	0	14		0	0	0	79573	0	313782	1127433		
57515	1258	40213160	1967-08-21	1967-08-21 00:00:00	1967-08-21	1967-08-21 00:00:00	1967-08-21	581452		0	0	0		0	0	0	82868	0	10	40213160		
158334	3486	40213260	2011-02-11	2011-02-11 00:00:00	2011-02-11	2011-02-11 00:00:00	2011-02-11	581452		0	0	0		0	0	0	231223	0	121	40213260		
81111	1773	40213201	2017-09-24	2017-09-24 00:00:00	2017-09-24	2017-09-24 00:00:00	2017-09-24	581452		0	0	0		0	0	0	118522	0	33	40213201		
141360	3105	40213296	2012-02-06	2012-02-06 00:00:00	2012-02-06	2012-02-06 00:00:00	2012-02-06	581452		0	0	0		0	0	0	206530	0	52	40213296		
62119	5168	40229134	1973-05-17	1973-05-17 00:00:00	1973-05-24	1973-05-24 00:00:00	1973-05-24	38000177		0	0	7		0	0	0	343649	0	1043400	40229134		
138033	3030	40213160	1982-04-27	1982-04-27 00:00:00	1982-04-27	1982-04-27 00:00:00	1982-04-27	581452		0	0	0		0	0	0	202032	0	10	40213160		
6751	569	19059056	1915-02-11	1915-02-11 00:00:00	1915-02-25	1915-02-25 00:00:00	1915-02-25	38000177		0	0	14		0	0	0	37593	0	243670	19059056		
36180	789	40213160	1977-06-06	1977-06-06 00:00:00	1977-06-06	1977-06-06 00:00:00	1977-06-06	581452		0	0	0		0	0	0	52518	0	10	40213160		
178710	3928	40213227	2011-02-20	2011-02-20 00:00:00	2011-02-20	2011-02-20 00:00:00	2011-02-20	581452		0	0	0		0	0	0	261144	0	113	40213227		
94498	2073	40213296	2006-10-27	2006-10-27 00:00:00	2006-10-27	2006-10-27 00:00:00	2006-10-27	581452		0	0	0		0	0	0	137903	0	52	40213296		
56697	4704	1713671	1991-11-09	1991-11-09 00:00:00	1991-11-16	1991-11-16 00:00:00	1991-11-16	38000177		0	0	7		0	0	0	313419	0	562251	1713671		
26100	569	40213227	2003-05-17	2003-05-17 00:00:00	2003-05-17	2003-05-17 00:00:00	2003-05-17	581452		0	0	0		0	0	0	37605	0	113	40213227		
56766	4709	1127433	1984-09-09	1984-09-09 00:00:00	1984-09-23	1984-09-23 00:00:00	1984-09-23	38000177		0	0	14		0	0	0	313661	0	313782	1127433		
56122	1229	40213160	1955-07-23	1955-07-23 00:00:00	1955-07-23	1955-07-23 00:00:00	1955-07-23	581452		0	0	0		0	0	0	80962	0	10	40213160		
192766	4235	40213296	2019-05-30	2019-05-30 00:00:00	2019-05-30	2019-05-30 00:00:00	2019-05-30	581452		0	0	0		0	0	0	281197	0	52	40213296		
201849	4432	40213227	1999-07-06	1999-07-06 00:00:00	1999-07-06	1999-07-06 00:00:00	1999-07-06	581452		0	0	0		0	0	0	294580	0	113	40213227		
12204	1024	1127433	2012-08-16	2012-08-16 00:00:00	2012-09-15	2012-09-15 00:00:00	2012-09-15	38000177		0	0	30		0	0	0	67441	0	313782	1127433		
56011	4649	19059056	1978-08-22	1978-08-22 00:00:00	1978-09-05	1978-09-05 00:00:00	1978-09-05	38000177		0	0	14		0	0	0	309989	0	243670	19059056		
49140	4078	19006318	1955-11-13	1955-11-13 00:00:00	1955-11-27	1955-11-27 00:00:00	1955-11-27	38000177		0	0	14		0	0	0	271072	0	105078	19006318		
157649	3470	40213227	2015-05-11	2015-05-11 00:00:00	2015-05-11	2015-05-11 00:00:00	2015-05-11	581452		0	0	0		0	0	0	230378	0	113	40213227		
122723	2698	40213180	2005-05-25	2005-05-25 00:00:00	2005-05-25	2005-05-25 00:00:00	2005-05-25	581452		0	0	0		0	0	0	178677	0	114	40213180		
25793	2122	40229134	2011-07-15	2011-07-15 00:00:00	2011-07-29	2011-07-29 00:00:00	2011-07-29	38000177		0	0	14		0	0	0	141196	0	1043400	40229134		
40628	885	40213227	2006-06-11	2006-06-11 00:00:00	2006-06-11	2006-06-11 00:00:00	2006-06-11	581452		0	0	0		0	0	0	59011	0	113	40213227		
126234	2777	40213260	2010-04-02	2010-04-02 00:00:00	2010-04-02	2010-04-02 00:00:00	2010-04-02	581452		0	0	0		0	0	0	183921	0	121	40213260		
23382	507	40213227	1992-09-11	1992-09-11 00:00:00	1992-09-11	1992-09-11 00:00:00	1992-09-11	581452		0	0	0		0	0	0	33932	0	113	40213227		
133216	2925	40213227	1994-03-27	1994-03-27 00:00:00	1994-03-27	1994-03-27 00:00:00	1994-03-27	581452		0	0	0		0	0	0	195066	0	113	40213227		
11832	986	19059056	1919-12-12	1919-12-12 00:00:00	1920-01-02	1920-01-02 00:00:00	1920-01-02	38000177		0	0	21		0	0	0	65516	0	243670	19059056		
27666	2290	1115171	1999-08-13	1999-08-13 00:00:00	1999-09-03	1999-09-03 00:00:00	1999-09-03	38000177		0	0	21		0	0	0	152339	0	849574	1115171		
203857	4475	40213306	2000-11-12	2000-11-12 00:00:00	2000-11-12	2000-11-12 00:00:00	2000-11-12	581452		0	0	0		0	0	0	297751	0	43	40213306		
128242	2821	40213201	1986-12-02	1986-12-02 00:00:00	1986-12-02	1986-12-02 00:00:00	1986-12-02	581452		0	0	0		0	0	0	186901	0	33	40213201		
29507	2442	1127078	1982-06-23	1982-06-23 00:00:00	1982-07-14	1982-07-14 00:00:00	1982-07-14	38000177		0	0	21		0	0	0	161958	0	282464	1127078		
235400	5170	40213227	2011-01-07	2011-01-07 00:00:00	2011-01-07	2011-01-07 00:00:00	2011-01-07	581452		0	0	0		0	0	0	343785	0	113	40213227		
202707	4450	40213160	1968-04-20	1968-04-20 00:00:00	1968-04-20	1968-04-20 00:00:00	1968-04-20	581452		0	0	0		0	0	0	296028	0	10	40213160		
19225	1588	40229134	2010-09-03	2010-09-03 00:00:00	2010-09-10	2010-09-10 00:00:00	2010-09-10	38000177		0	0	7		0	0	0	106613	0	1043400	40229134		
51156	4250	1127433	1947-11-20	1947-11-20 00:00:00	1947-11-27	1947-11-27 00:00:00	1947-11-27	38000177		0	0	7		0	0	0	282285	0	313782	1127433		
115428	2537	40213160	1955-06-12	1955-06-12 00:00:00	1955-06-12	1955-06-12 00:00:00	1955-06-12	581452		0	0	0		0	0	0	167769	0	10	40213160		
218933	4805	40213227	2013-10-04	2013-10-04 00:00:00	2013-10-04	2013-10-04 00:00:00	2013-10-04	581452		0	0	0		0	0	0	319728	0	113	40213227		
63474	5274	40229134	1998-03-16	1998-03-16 00:00:00	1998-03-30	1998-03-30 00:00:00	1998-03-30	38000177		0	0	14		0	0	0	350836	0	1043400	40229134		
43269	3583	19078461	2018-12-23	2018-12-23 00:00:00	2019-03-23	2019-03-23 00:00:00	2019-03-23	38000177		0	0	90		0	0	0	238208	0	310965	19078461		
122314	2688	40213260	2013-11-24	2013-11-24 00:00:00	2013-11-24	2013-11-24 00:00:00	2013-11-24	581452		0	0	0		0	0	0	178109	0	121	40213260		
82253	1796	40213314	1979-07-11	1979-07-11 00:00:00	1979-07-11	1979-07-11 00:00:00	1979-07-11	581452		0	0	0		0	0	0	120404	0	49	40213314		
15715	1309	40231925	1994-03-22	1994-03-22 00:00:00	1994-03-22	1994-03-22 00:00:00	\N	38000177		0	0	0		0	0	0	86444	0	1049221	40231925		
183153	4024	40213160	1979-07-08	1979-07-08 00:00:00	1979-07-08	1979-07-08 00:00:00	1979-07-08	581452		0	0	0		0	0	0	267541	0	10	40213160		
42383	923	40213227	1993-02-17	1993-02-17 00:00:00	1993-02-17	1993-02-17 00:00:00	1993-02-17	581452		0	0	0		0	0	0	61497	0	113	40213227		
91063	1998	40213160	1982-02-27	1982-02-27 00:00:00	1982-02-27	1982-02-27 00:00:00	1982-02-27	581452		0	0	0		0	0	0	133005	0	10	40213160		
45273	3746	1713671	2014-09-29	2014-09-29 00:00:00	2014-10-13	2014-10-13 00:00:00	2014-10-13	38000177		0	0	14		0	0	0	249045	0	562251	1713671		
36856	3048	19128065	1991-04-26	1991-04-26 00:00:00	1992-04-20	1992-04-20 00:00:00	1992-04-20	38000177		0	0	360		0	0	0	202828	0	749882	19128065		
55810	4633	1115171	2017-08-10	2017-08-10 00:00:00	2017-08-31	2017-08-31 00:00:00	2017-08-31	38000177		0	0	21		0	0	0	308766	0	849574	1115171		
45115	3733	40229134	1984-04-28	1984-04-28 00:00:00	1984-05-12	1984-05-12 00:00:00	1984-05-12	38000177		0	0	14		0	0	0	248055	0	1043400	40229134		
28262	2334	19133873	1949-08-12	1949-08-12 00:00:00	1949-08-19	1949-08-19 00:00:00	1949-08-19	38000177		0	0	7		0	0	0	155286	0	834061	19133873		
9013	752	1127433	2017-12-01	2017-12-01 00:00:00	2017-12-15	2017-12-15 00:00:00	2017-12-15	38000177		0	0	14		0	0	0	49683	0	313782	1127433		
113926	2503	40213160	1973-05-29	1973-05-29 00:00:00	1973-05-29	1973-05-29 00:00:00	1973-05-29	581452		0	0	0		0	0	0	165722	0	10	40213160		
85896	1882	40213306	1991-06-01	1991-06-01 00:00:00	1991-06-01	1991-06-01 00:00:00	1991-06-01	581452		0	0	0		0	0	0	125547	0	43	40213306		
192901	4238	40213160	1962-05-10	1962-05-10 00:00:00	1962-05-10	1962-05-10 00:00:00	1962-05-10	581452		0	0	0		0	0	0	281369	0	10	40213160		
31203	2586	19019979	1980-01-13	1980-01-13 00:00:00	1980-02-10	1980-02-10 00:00:00	1980-02-10	38000177		0	0	28		0	0	0	171222	0	198405	19019979		
39010	3224	19133873	1971-09-05	1971-09-05 00:00:00	1971-09-16	1971-09-16 00:00:00	1971-09-16	38000177		0	0	11		0	0	0	214358	0	834061	19133873		
184040	4044	40213227	2010-09-12	2010-09-12 00:00:00	2010-09-12	2010-09-12 00:00:00	2010-09-12	581452		0	0	0		0	0	0	268978	0	113	40213227		
163542	3598	40213227	1995-04-02	1995-04-02 00:00:00	1995-04-02	1995-04-02 00:00:00	1995-04-02	581452		0	0	0		0	0	0	238989	0	113	40213227		
18441	1526	1713671	2009-09-26	2009-09-26 00:00:00	2009-10-10	2009-10-10 00:00:00	2009-10-10	38000177		0	0	14		0	0	0	102083	0	562251	1713671		
243403	5343	40213314	1983-04-10	1983-04-10 00:00:00	1983-04-10	1983-04-10 00:00:00	1983-04-10	581452		0	0	0		0	0	0	355847	0	49	40213314		
227351	4992	40213251	1986-07-24	1986-07-24 00:00:00	1986-07-24	1986-07-24 00:00:00	1986-07-24	581452		0	0	0		0	0	0	332159	0	21	40213251		
14337	1205	1127433	1974-08-04	1974-08-04 00:00:00	1974-09-01	1974-09-01 00:00:00	1974-09-01	38000177		0	0	28		0	0	0	79173	0	313782	1127433		
215500	4725	40213160	1975-06-02	1975-06-02 00:00:00	1975-06-02	1975-06-02 00:00:00	1975-06-02	581452		0	0	0		0	0	0	314943	0	10	40213160		
14430	1211	1127433	2013-08-02	2013-08-02 00:00:00	2013-09-06	2013-09-06 00:00:00	2013-09-06	38000177		0	0	35		0	0	0	79678	0	313782	1127433		
57517	1258	40213227	2008-06-30	2008-06-30 00:00:00	2008-06-30	2008-06-30 00:00:00	2008-06-30	581452		0	0	0		0	0	0	82913	0	113	40213227		
158345	3486	40213306	1982-04-30	1982-04-30 00:00:00	1982-04-30	1982-04-30 00:00:00	1982-04-30	581452		0	0	0		0	0	0	231269	0	43	40213306		
81123	1773	40213227	2003-07-06	2003-07-06 00:00:00	2003-07-06	2003-07-06 00:00:00	2003-07-06	581452		0	0	0		0	0	0	118618	0	113	40213227		
141362	3105	40213227	2012-02-06	2012-02-06 00:00:00	2012-02-06	2012-02-06 00:00:00	2012-02-06	581452		0	0	0		0	0	0	206530	0	113	40213227		
62120	5169	1127433	1984-11-25	1984-11-25 00:00:00	1984-12-09	1984-12-09 00:00:00	1984-12-09	38000177		0	0	14		0	0	0	343690	0	313782	1127433		
138037	3030	40213227	2004-06-15	2004-06-15 00:00:00	2004-06-15	2004-06-15 00:00:00	2004-06-15	581452		0	0	0		0	0	0	201996	0	113	40213227		
6752	569	1118084	1956-03-02	1956-03-02 00:00:00	1956-03-02	1956-03-02 00:00:00	\N	38000177		0	0	0		0	0	0	37677	0	00025152531	44923712		
36182	789	40213314	1977-06-06	1977-06-06 00:00:00	1977-06-06	1977-06-06 00:00:00	1977-06-06	581452		0	0	0		0	0	0	52518	0	49	40213314		
178714	3928	40213160	1984-11-18	1984-11-18 00:00:00	1984-11-18	1984-11-18 00:00:00	1984-11-18	581452		0	0	0		0	0	0	261126	0	10	40213160		
94500	2073	40213227	1996-10-11	1996-10-11 00:00:00	1996-10-11	1996-10-11 00:00:00	1996-10-11	581452		0	0	0		0	0	0	137912	0	113	40213227		
56698	4704	19128065	1983-12-01	1983-12-01 00:00:00	1984-11-25	1984-11-25 00:00:00	1984-11-25	38000177		0	0	360		0	0	0	313373	0	749882	19128065		
37417	817	40213160	1962-04-26	1962-04-26 00:00:00	1962-04-26	1962-04-26 00:00:00	1962-04-26	581452		0	0	0		0	0	0	54172	0	10	40213160		
228330	5015	40213160	1973-01-15	1973-01-15 00:00:00	1973-01-15	1973-01-15 00:00:00	1973-01-15	581452		0	0	0		0	0	0	333333	0	10	40213160		
56125	1229	40213260	2007-09-29	2007-09-29 00:00:00	2007-09-29	2007-09-29 00:00:00	2007-09-29	581452		0	0	0		0	0	0	80952	0	121	40213260		
192774	4235	40213314	1980-05-08	1980-05-08 00:00:00	1980-05-08	1980-05-08 00:00:00	1980-05-08	581452		0	0	0		0	0	0	281174	0	49	40213314		
201850	4432	40213296	1999-07-06	1999-07-06 00:00:00	1999-07-06	1999-07-06 00:00:00	1999-07-06	581452		0	0	0		0	0	0	294580	0	52	40213296		
12205	1024	1127433	1995-02-21	1995-02-21 00:00:00	1995-03-07	1995-03-07 00:00:00	1995-03-07	38000177		0	0	14		0	0	0	67475	0	313782	1127433		
56012	4649	1127433	2015-03-01	2015-03-01 00:00:00	2015-03-15	2015-03-15 00:00:00	2015-03-15	38000177		0	0	14		0	0	0	309978	0	313782	1127433		
128705	2830	40213314	1978-01-16	1978-01-16 00:00:00	1978-01-16	1978-01-16 00:00:00	1978-01-16	581452		0	0	0		0	0	0	187817	0	49	40213314		
193986	4261	40213227	1993-05-16	1993-05-16 00:00:00	1993-05-16	1993-05-16 00:00:00	1993-05-16	581452		0	0	0		0	0	0	282912	0	113	40213227		
122732	2698	40213160	1988-03-02	1988-03-02 00:00:00	1988-03-02	1988-03-02 00:00:00	1988-03-02	581452		0	0	0		0	0	0	178661	0	10	40213160		
25794	2122	19019979	1975-09-24	1975-09-24 00:00:00	1975-10-08	1975-10-08 00:00:00	1975-10-08	38000177		0	0	14		0	0	0	141214	0	198405	19019979		
40632	885	40213227	2017-04-23	2017-04-23 00:00:00	2017-04-23	2017-04-23 00:00:00	2017-04-23	581452		0	0	0		0	0	0	58979	0	113	40213227		
126246	2777	40213160	1960-07-08	1960-07-08 00:00:00	1960-07-08	1960-07-08 00:00:00	1960-07-08	581452		0	0	0		0	0	0	183957	0	10	40213160		
121870	2679	40213227	2014-04-11	2014-04-11 00:00:00	2014-04-11	2014-04-11 00:00:00	2014-04-11	581452		0	0	0		0	0	0	177480	0	113	40213227		
133224	2925	40213296	2002-01-20	2002-01-20 00:00:00	2002-01-20	2002-01-20 00:00:00	2002-01-20	581452		0	0	0		0	0	0	195068	0	52	40213296		
11833	986	1127433	1934-05-27	1934-05-27 00:00:00	1934-06-03	1934-06-03 00:00:00	1934-06-03	38000177		0	0	7		0	0	0	65447	0	313782	1127433		
27667	2290	1127433	1984-03-07	1984-03-07 00:00:00	1984-03-14	1984-03-14 00:00:00	1984-03-14	38000177		0	0	7		0	0	0	152358	0	313782	1127433		
203861	4475	40213160	1978-10-29	1978-10-29 00:00:00	1978-10-29	1978-10-29 00:00:00	1978-10-29	581452		0	0	0		0	0	0	297757	0	10	40213160		
128257	2821	40213227	1991-12-31	1991-12-31 00:00:00	1991-12-31	1991-12-31 00:00:00	1991-12-31	581452		0	0	0		0	0	0	186881	0	113	40213227		
29508	2442	1115171	1997-07-25	1997-07-25 00:00:00	1997-08-15	1997-08-15 00:00:00	1997-08-15	38000177		0	0	21		0	0	0	161961	0	849574	1115171		
235401	5170	40213296	2011-01-07	2011-01-07 00:00:00	2011-01-07	2011-01-07 00:00:00	2011-01-07	581452		0	0	0		0	0	0	343785	0	52	40213296		
202710	4450	40213227	2000-08-05	2000-08-05 00:00:00	2000-08-05	2000-08-05 00:00:00	2000-08-05	581452		0	0	0		0	0	0	296079	0	113	40213227		
19228	1588	1127433	2018-12-30	2018-12-30 00:00:00	2019-01-13	2019-01-13 00:00:00	2019-01-13	38000177		0	0	14		0	0	0	106568	0	313782	1127433		
51157	4250	19059056	1950-07-05	1950-07-05 00:00:00	1950-07-19	1950-07-19 00:00:00	1950-07-19	38000177		0	0	14		0	0	0	282247	0	243670	19059056		
115432	2537	40213227	1998-08-23	1998-08-23 00:00:00	1998-08-23	1998-08-23 00:00:00	1998-08-23	581452		0	0	0		0	0	0	167610	0	113	40213227		
218934	4805	40213260	2013-10-04	2013-10-04 00:00:00	2013-10-04	2013-10-04 00:00:00	2013-10-04	581452		0	0	0		0	0	0	319728	0	121	40213260		
63475	5274	19078461	2006-06-16	2006-06-16 00:00:00	2006-09-14	2006-09-14 00:00:00	2006-09-14	38000177		0	0	90		0	0	0	350844	0	310965	19078461		
43270	3583	1115171	2003-02-10	2003-02-10 00:00:00	2003-03-17	2003-03-17 00:00:00	2003-03-17	38000177		0	0	35		0	0	0	238207	0	849574	1115171		
122316	2688	40213227	2004-11-28	2004-11-28 00:00:00	2004-11-28	2004-11-28 00:00:00	2004-11-28	581452		0	0	0		0	0	0	178140	0	113	40213227		
82254	1796	40213160	1979-07-11	1979-07-11 00:00:00	1979-07-11	1979-07-11 00:00:00	1979-07-11	581452		0	0	0		0	0	0	120404	0	10	40213160		
15716	1309	35605858	1994-03-21	1994-03-21 00:00:00	1994-03-22	1994-03-22 00:00:00	1994-03-22	38000177		0	0	1		0	0	0	86444	0	1732136	35605858		
183155	4024	40213160	1979-10-07	1979-10-07 00:00:00	1979-10-07	1979-10-07 00:00:00	1979-10-07	581452		0	0	0		0	0	0	267576	0	10	40213160		
42390	923	40213160	1959-07-22	1959-07-22 00:00:00	1959-07-22	1959-07-22 00:00:00	1959-07-22	581452		0	0	0		0	0	0	61448	0	10	40213160		
91075	1998	40213314	1981-12-26	1981-12-26 00:00:00	1981-12-26	1981-12-26 00:00:00	1981-12-26	581452		0	0	0		0	0	0	133031	0	49	40213314		
45274	3746	40236824	1992-01-10	1992-01-10 00:00:00	1992-01-17	1992-01-17 00:00:00	1992-01-17	38000177		0	0	7		0	0	0	249030	0	1094107	40236824		
36857	3048	1713671	2015-02-28	2015-02-28 00:00:00	2015-05-09	2015-05-09 00:00:00	2015-05-09	38000177		0	0	70		0	0	0	202813	0	562251	1713671		
55811	4633	1115171	2014-10-11	2014-10-11 00:00:00	2014-10-25	2014-10-25 00:00:00	2014-10-25	38000177		0	0	14		0	0	0	308765	0	849574	1115171		
45116	3733	40229134	2003-04-10	2003-04-10 00:00:00	2003-04-24	2003-04-24 00:00:00	2003-04-24	38000177		0	0	14		0	0	0	248058	0	1043400	40229134		
28263	2334	19133873	1942-05-10	1942-05-10 00:00:00	1942-05-17	1942-05-17 00:00:00	1942-05-17	38000177		0	0	7		0	0	0	155285	0	834061	19133873		
9014	753	19133873	1976-02-26	1976-02-26 00:00:00	1976-03-08	1976-03-08 00:00:00	1976-03-08	38000177		0	0	11		0	0	0	49812	0	834061	19133873		
113928	2503	40213227	2015-03-03	2015-03-03 00:00:00	2015-03-03	2015-03-03 00:00:00	2015-03-03	581452		0	0	0		0	0	0	165729	0	113	40213227		
85901	1882	40213296	2008-10-25	2008-10-25 00:00:00	2008-10-25	2008-10-25 00:00:00	2008-10-25	581452		0	0	0		0	0	0	125548	0	52	40213296		
192903	4238	40213160	1962-02-08	1962-02-08 00:00:00	1962-02-08	1962-02-08 00:00:00	1962-02-08	581452		0	0	0		0	0	0	281376	0	10	40213160		
31204	2586	1713671	1995-06-28	1995-06-28 00:00:00	1995-07-12	1995-07-12 00:00:00	1995-07-12	38000177		0	0	14		0	0	0	171199	0	562251	1713671		
23257	505	40213160	1969-02-11	1969-02-11 00:00:00	1969-02-11	1969-02-11 00:00:00	1969-02-11	581452		0	0	0		0	0	0	33741	0	10	40213160		
184051	4044	40213160	1960-02-14	1960-02-14 00:00:00	1960-02-14	1960-02-14 00:00:00	1960-02-14	581452		0	0	0		0	0	0	268925	0	10	40213160		
163563	3598	40213198	2010-05-02	2010-05-02 00:00:00	2010-05-02	2010-05-02 00:00:00	2010-05-02	581452		0	0	0		0	0	0	238998	0	133	40213198		
18442	1526	1118084	2012-10-05	2012-10-05 00:00:00	2012-10-05	2012-10-05 00:00:00	\N	38000177		0	0	0		0	0	0	102054	0	00025152531	44923712		
243404	5343	40213314	1984-03-11	1984-03-11 00:00:00	1984-03-11	1984-03-11 00:00:00	1984-03-11	581452		0	0	0		0	0	0	355949	0	49	40213314		
227354	4992	40213251	1990-04-26	1990-04-26 00:00:00	1990-04-26	1990-04-26 00:00:00	1990-04-26	581452		0	0	0		0	0	0	332094	0	21	40213251		
14338	1205	1118084	2002-01-29	2002-01-29 00:00:00	2002-01-29	2002-01-29 00:00:00	\N	38000177		0	0	0		0	0	0	79171	0	00025152531	44923712		
215503	4725	40213296	2014-09-29	2014-09-29 00:00:00	2014-09-29	2014-09-29 00:00:00	2014-09-29	581452		0	0	0		0	0	0	314888	0	52	40213296		
14431	1211	19112599	1967-11-12	1967-11-12 00:00:00	1967-11-12	1967-11-12 00:00:00	\N	38000177		0	0	0		0	0	0	79556	0	477045	19112599		
57518	1258	40213296	2008-06-30	2008-06-30 00:00:00	2008-06-30	2008-06-30 00:00:00	2008-06-30	581452		0	0	0		0	0	0	82913	0	52	40213296		
158347	3486	40213160	1964-12-04	1964-12-04 00:00:00	1964-12-04	1964-12-04 00:00:00	1964-12-04	581452		0	0	0		0	0	0	231256	0	10	40213160		
81124	1773	40213160	1955-01-30	1955-01-30 00:00:00	1955-01-30	1955-01-30 00:00:00	1955-01-30	581452		0	0	0		0	0	0	118587	0	10	40213160		
141365	3105	40213227	1992-03-30	1992-03-30 00:00:00	1992-03-30	1992-03-30 00:00:00	1992-03-30	581452		0	0	0		0	0	0	206543	0	113	40213227		
62121	5169	40229134	1977-12-24	1977-12-24 00:00:00	1977-12-31	1977-12-31 00:00:00	1977-12-31	38000177		0	0	7		0	0	0	343730	0	1043400	40229134		
138038	3030	40213306	2004-06-15	2004-06-15 00:00:00	2004-06-15	2004-06-15 00:00:00	2004-06-15	581452		0	0	0		0	0	0	201996	0	43	40213306		
6753	569	40229134	1947-10-05	1947-10-05 00:00:00	1947-10-19	1947-10-19 00:00:00	1947-10-19	38000177		0	0	14		0	0	0	37692	0	1043400	40229134		
36191	789	40213306	1995-01-02	1995-01-02 00:00:00	1995-01-02	1995-01-02 00:00:00	1995-01-02	581452		0	0	0		0	0	0	\N	0	43	40213306		
178716	3928	40213251	1984-11-18	1984-11-18 00:00:00	1984-11-18	1984-11-18 00:00:00	1984-11-18	581452		0	0	0		0	0	0	261126	0	21	40213251		
25878	565	40213260	2007-07-25	2007-07-25 00:00:00	2007-07-25	2007-07-25 00:00:00	2007-07-25	581452		0	0	0		0	0	0	37458	0	121	40213260		
56699	4704	40229134	1982-01-03	1982-01-03 00:00:00	1982-01-10	1982-01-10 00:00:00	1982-01-10	38000177		0	0	7		0	0	0	313412	0	1043400	40229134		
37419	817	40213227	1992-03-12	1992-03-12 00:00:00	1992-03-12	1992-03-12 00:00:00	1992-03-12	581452		0	0	0		0	0	0	54154	0	113	40213227		
228333	5015	40213227	2000-02-28	2000-02-28 00:00:00	2000-02-28	2000-02-28 00:00:00	2000-02-28	581452		0	0	0		0	0	0	333394	0	113	40213227		
56131	1229	40213160	1955-01-22	1955-01-22 00:00:00	1955-01-22	1955-01-22 00:00:00	1955-01-22	581452		0	0	0		0	0	0	80936	0	10	40213160		
192776	4235	40213306	2001-07-05	2001-07-05 00:00:00	2001-07-05	2001-07-05 00:00:00	2001-07-05	581452		0	0	0		0	0	0	281223	0	43	40213306		
201865	4432	40213160	1958-03-04	1958-03-04 00:00:00	1958-03-04	1958-03-04 00:00:00	1958-03-04	581452		0	0	0		0	0	0	294569	0	10	40213160		
12206	1024	1127433	1981-12-17	1981-12-17 00:00:00	1981-12-24	1981-12-24 00:00:00	1981-12-24	38000177		0	0	7		0	0	0	67469	0	313782	1127433		
56013	4649	1127433	2004-05-11	2004-05-11 00:00:00	2004-05-18	2004-05-18 00:00:00	2004-05-18	38000177		0	0	7		0	0	0	309977	0	313782	1127433		
128706	2830	40213227	2006-07-24	2006-07-24 00:00:00	2006-07-24	2006-07-24 00:00:00	2006-07-24	581452		0	0	0		0	0	0	187800	0	113	40213227		
115755	2543	40213306	1987-09-13	1987-09-13 00:00:00	1987-09-13	1987-09-13 00:00:00	1987-09-13	581452		0	0	0		0	0	0	168269	0	43	40213306		
122733	2698	40213251	1988-03-02	1988-03-02 00:00:00	1988-03-02	1988-03-02 00:00:00	1988-03-02	581452		0	0	0		0	0	0	178661	0	21	40213251		
25795	2122	1115171	1995-03-11	1995-03-11 00:00:00	1995-04-01	1995-04-01 00:00:00	1995-04-01	38000177		0	0	21		0	0	0	141216	0	849574	1115171		
40633	885	40213296	2017-04-23	2017-04-23 00:00:00	2017-04-23	2017-04-23 00:00:00	2017-04-23	581452		0	0	0		0	0	0	58979	0	52	40213296		
126247	2777	40213296	2002-04-12	2002-04-12 00:00:00	2002-04-12	2002-04-12 00:00:00	2002-04-12	581452		0	0	0		0	0	0	183893	0	52	40213296		
121871	2679	40213296	2014-04-11	2014-04-11 00:00:00	2014-04-11	2014-04-11 00:00:00	2014-04-11	581452		0	0	0		0	0	0	177480	0	52	40213296		
86870	1905	40213160	1971-01-29	1971-01-29 00:00:00	1971-01-29	1971-01-29 00:00:00	1971-01-29	581452		0	0	0		0	0	0	126796	0	10	40213160		
11834	986	1118084	1951-11-04	1951-11-04 00:00:00	1951-11-04	1951-11-04 00:00:00	\N	38000177		0	0	0		0	0	0	65469	0	00025152531	44923712		
27668	2290	1127433	1993-10-28	1993-10-28 00:00:00	1993-11-11	1993-11-11 00:00:00	1993-11-11	38000177		0	0	14		0	0	0	152326	0	313782	1127433		
203862	4475	40213314	1978-10-29	1978-10-29 00:00:00	1978-10-29	1978-10-29 00:00:00	1978-10-29	581452		0	0	0		0	0	0	297757	0	49	40213314		
137776	3025	40213227	1997-06-02	1997-06-02 00:00:00	1997-06-02	1997-06-02 00:00:00	1997-06-02	581452		0	0	0		0	0	0	201653	0	113	40213227		
29509	2442	19133873	1978-05-30	1978-05-30 00:00:00	1978-06-08	1978-06-08 00:00:00	1978-06-08	38000177		0	0	9		0	0	0	161919	0	834061	19133873		
235405	5170	40213227	2000-03-10	2000-03-10 00:00:00	2000-03-10	2000-03-10 00:00:00	2000-03-10	581452		0	0	0		0	0	0	343779	0	113	40213227		
202718	4450	40213227	2018-08-18	2018-08-18 00:00:00	2018-08-18	2018-08-18 00:00:00	2018-08-18	581452		0	0	0		0	0	0	296083	0	113	40213227		
19229	1588	1713671	1985-08-11	1985-08-11 00:00:00	1985-08-18	1985-08-18 00:00:00	1985-08-18	38000177		0	0	7		0	0	0	106627	0	562251	1713671		
51158	4250	19006318	1950-07-05	1950-07-05 00:00:00	1950-07-19	1950-07-19 00:00:00	1950-07-19	38000177		0	0	14		0	0	0	282247	0	105078	19006318		
191590	4210	40213314	1978-03-11	1978-03-11 00:00:00	1978-03-11	1978-03-11 00:00:00	1978-03-11	581452		0	0	0		0	0	0	279567	0	49	40213314		
218937	4805	40213260	2012-09-28	2012-09-28 00:00:00	2012-09-28	2012-09-28 00:00:00	2012-09-28	581452		0	0	0		0	0	0	319682	0	121	40213260		
63477	5274	1127433	1976-03-29	1976-03-29 00:00:00	1976-04-19	1976-04-19 00:00:00	1976-04-19	38000177		0	0	21		0	0	0	350842	0	313782	1127433		
43271	3583	19059056	1971-01-24	1971-01-24 00:00:00	1971-02-07	1971-02-07 00:00:00	1971-02-07	38000177		0	0	14		0	0	0	238171	0	243670	19059056		
122317	2688	40213296	2004-11-28	2004-11-28 00:00:00	2004-11-28	2004-11-28 00:00:00	2004-11-28	581452		0	0	0		0	0	0	178140	0	52	40213296		
82257	1796	40213251	1984-03-14	1984-03-14 00:00:00	1984-03-14	1984-03-14 00:00:00	1984-03-14	581452		0	0	0		0	0	0	120436	0	21	40213251		
15717	1309	35605482	1994-03-21	1994-03-21 00:00:00	1994-03-21	1994-03-21 00:00:00	1994-03-21	38000177		0	0	0		0	0	0	86444	0	1740467	35605482		
183158	4024	40213160	1984-01-08	1984-01-08 00:00:00	1984-01-08	1984-01-08 00:00:00	1984-01-08	581452		0	0	0		0	0	0	267544	0	10	40213160		
42398	924	40213160	1968-05-12	1968-05-12 00:00:00	1968-05-12	1968-05-12 00:00:00	1968-05-12	581452		0	0	0		0	0	0	61523	0	10	40213160		
91076	1998	40213160	1981-12-26	1981-12-26 00:00:00	1981-12-26	1981-12-26 00:00:00	1981-12-26	581452		0	0	0		0	0	0	133031	0	10	40213160		
45275	3746	920300	1992-01-10	1992-01-10 00:00:00	1992-01-17	1992-01-17 00:00:00	1992-01-17	38000177		0	0	7		0	0	0	249030	0	311989	920300		
36858	3048	1118084	2008-08-24	2008-08-24 00:00:00	2008-08-24	2008-08-24 00:00:00	\N	38000177		0	0	0		0	0	0	202792	0	00025152531	44923712		
55812	4633	40229134	1991-08-03	1991-08-03 00:00:00	1991-08-10	1991-08-10 00:00:00	1991-08-10	38000177		0	0	7		0	0	0	308805	0	1043400	40229134		
45117	3733	1124300	2011-03-22	2011-03-22 00:00:00	2011-03-22	2011-03-22 00:00:00	\N	38000177		0	0	0		0	0	0	248052	0	00781178901	45011828		
28264	2334	19059056	1942-11-24	1942-11-24 00:00:00	1943-02-22	1943-02-22 00:00:00	1943-02-22	38000177		0	0	90		0	0	0	155339	0	243670	19059056		
9015	753	1124300	2005-08-05	2005-08-05 00:00:00	2005-08-05	2005-08-05 00:00:00	\N	38000177		0	0	0		0	0	0	49757	0	00781178901	45011828		
113929	2503	40213296	2015-03-03	2015-03-03 00:00:00	2015-03-03	2015-03-03 00:00:00	2015-03-03	581452		0	0	0		0	0	0	165729	0	52	40213296		
85905	1882	40213160	1969-01-18	1969-01-18 00:00:00	1969-01-18	1969-01-18 00:00:00	1969-01-18	581452		0	0	0		0	0	0	125520	0	10	40213160		
192907	4238	40213160	1966-08-11	1966-08-11 00:00:00	1966-08-11	1966-08-11 00:00:00	1966-08-11	581452		0	0	0		0	0	0	281380	0	10	40213160		
31208	2588	1127433	1985-09-16	1985-09-16 00:00:00	1985-09-30	1985-09-30 00:00:00	1985-09-30	38000177		0	0	14		0	0	0	171277	0	313782	1127433		
23261	505	40213306	1989-01-24	1989-01-24 00:00:00	1989-01-24	1989-01-24 00:00:00	1989-01-24	581452		0	0	0		0	0	0	33747	0	43	40213306		
184052	4044	40213260	2009-09-06	2009-09-06 00:00:00	2009-09-06	2009-09-06 00:00:00	2009-09-06	581452		0	0	0		0	0	0	268987	0	121	40213260		
163565	3598	40213201	2010-05-02	2010-05-02 00:00:00	2010-05-02	2010-05-02 00:00:00	2010-05-02	581452		0	0	0		0	0	0	238998	0	33	40213201		
18443	1526	19133873	1985-08-05	1985-08-05 00:00:00	1985-08-17	1985-08-17 00:00:00	1985-08-17	38000177		0	0	12		0	0	0	102082	0	834061	19133873		
243405	5343	40213251	1984-03-11	1984-03-11 00:00:00	1984-03-11	1984-03-11 00:00:00	1984-03-11	581452		0	0	0		0	0	0	355949	0	21	40213251		
200558	4405	40213160	1964-05-25	1964-05-25 00:00:00	1964-05-25	1964-05-25 00:00:00	1964-05-25	581452		0	0	0		0	0	0	292811	0	10	40213160		
14340	1205	19128065	1983-08-27	1983-08-27 00:00:00	1984-08-21	1984-08-21 00:00:00	1984-08-21	38000177		0	0	360		0	0	0	79216	0	749882	19128065		
146910	3230	40213227	2016-10-26	2016-10-26 00:00:00	2016-10-26	2016-10-26 00:00:00	2016-10-26	581452		0	0	0		0	0	0	214652	0	113	40213227		
63884	1397	40213296	2018-08-03	2018-08-03 00:00:00	2018-08-03	2018-08-03 00:00:00	2018-08-03	581452		0	0	0		0	0	0	92802	0	52	40213296		
57519	1259	40213160	1955-03-21	1955-03-21 00:00:00	1955-03-21	1955-03-21 00:00:00	1955-03-21	581452		0	0	0		0	0	0	82992	0	10	40213160		
158358	3486	40213160	1960-06-03	1960-06-03 00:00:00	1960-06-03	1960-06-03 00:00:00	1960-06-03	581452		0	0	0		0	0	0	231215	0	10	40213160		
81128	1773	40213160	1956-08-05	1956-08-05 00:00:00	1956-08-05	1956-08-05 00:00:00	1956-08-05	581452		0	0	0		0	0	0	118588	0	10	40213160		
141366	3105	40213306	1992-03-30	1992-03-30 00:00:00	1992-03-30	1992-03-30 00:00:00	1992-03-30	581452		0	0	0		0	0	0	206543	0	43	40213306		
62122	5169	1118084	1996-07-05	1996-07-05 00:00:00	1996-07-05	1996-07-05 00:00:00	\N	38000177		0	0	0		0	0	0	343703	0	00025152531	44923712		
138040	3030	40213314	1981-11-24	1981-11-24 00:00:00	1981-11-24	1981-11-24 00:00:00	1981-11-24	581452		0	0	0		0	0	0	202031	0	49	40213314		
6754	569	1127433	2012-03-31	2012-03-31 00:00:00	2012-04-07	2012-04-07 00:00:00	2012-04-07	38000177		0	0	7		0	0	0	37586	0	313782	1127433		
36192	789	40213227	1995-01-02	1995-01-02 00:00:00	1995-01-02	1995-01-02 00:00:00	1995-01-02	581452		0	0	0		0	0	0	\N	0	113	40213227		
178719	3928	40213314	1980-05-18	1980-05-18 00:00:00	1980-05-18	1980-05-18 00:00:00	1980-05-18	581452		0	0	0		0	0	0	261123	0	49	40213314		
25879	565	40213160	1958-01-01	1958-01-01 00:00:00	1958-01-01	1958-01-01 00:00:00	1958-01-01	581452		0	0	0		0	0	0	37420	0	10	40213160		
56700	4704	19059056	1970-04-15	1970-04-15 00:00:00	1970-04-29	1970-04-29 00:00:00	1970-04-29	38000177		0	0	14		0	0	0	313364	0	243670	19059056		
57773	4800	1127433	1983-02-07	1983-02-07 00:00:00	1983-02-28	1983-02-28 00:00:00	1983-02-28	38000177		0	0	21		0	0	0	319294	0	313782	1127433		
228343	5015	40213260	2018-02-05	2018-02-05 00:00:00	2018-02-05	2018-02-05 00:00:00	2018-02-05	581452		0	0	0		0	0	0	333372	0	121	40213260		
56141	1229	40213296	1996-06-08	1996-06-08 00:00:00	1996-06-08	1996-06-08 00:00:00	1996-06-08	581452		0	0	0		0	0	0	80996	0	52	40213296		
192778	4235	40213227	2001-07-05	2001-07-05 00:00:00	2001-07-05	2001-07-05 00:00:00	2001-07-05	581452		0	0	0		0	0	0	281223	0	113	40213227		
201867	4432	40213260	2008-07-01	2008-07-01 00:00:00	2008-07-01	2008-07-01 00:00:00	2008-07-01	581452		0	0	0		0	0	0	294607	0	121	40213260		
12207	1024	1127078	1952-02-02	1952-02-02 00:00:00	1952-03-03	1952-03-03 00:00:00	1952-03-03	38000177		0	0	30		0	0	0	67436	0	282464	1127078		
56014	4649	1127433	1984-05-06	1984-05-06 00:00:00	1984-06-05	1984-06-05 00:00:00	1984-06-05	38000177		0	0	30		0	0	0	309990	0	313782	1127433		
128709	2830	40213296	2015-01-05	2015-01-05 00:00:00	2015-01-05	2015-01-05 00:00:00	2015-01-05	581452		0	0	0		0	0	0	187720	0	52	40213296		
115758	2543	40213160	1969-09-28	1969-09-28 00:00:00	1969-09-28	1969-09-28 00:00:00	1969-09-28	581452		0	0	0		0	0	0	168261	0	10	40213160		
114794	2522	40213227	2010-01-01	2010-01-01 00:00:00	2010-01-01	2010-01-01 00:00:00	2010-01-01	581452		0	0	0		0	0	0	166844	0	113	40213227		
25796	2122	40229134	1991-05-02	1991-05-02 00:00:00	1991-05-16	1991-05-16 00:00:00	1991-05-16	38000177		0	0	14		0	0	0	141190	0	1043400	40229134		
51913	1136	40213296	2011-06-18	2011-06-18 00:00:00	2011-06-18	2011-06-18 00:00:00	2011-06-18	581452		0	0	0		0	0	0	74863	0	52	40213296		
126249	2777	40213227	2002-04-12	2002-04-12 00:00:00	2002-04-12	2002-04-12 00:00:00	2002-04-12	581452		0	0	0		0	0	0	183893	0	113	40213227		
121875	2679	40213227	2003-11-28	2003-11-28 00:00:00	2003-11-28	2003-11-28 00:00:00	2003-11-28	581452		0	0	0		0	0	0	177496	0	113	40213227		
86877	1905	40213227	2007-12-28	2007-12-28 00:00:00	2007-12-28	2007-12-28 00:00:00	2007-12-28	581452		0	0	0		0	0	0	126837	0	113	40213227		
11835	986	1127433	1977-07-02	1977-07-02 00:00:00	1977-07-09	1977-07-09 00:00:00	1977-07-09	38000177		0	0	7		0	0	0	65443	0	313782	1127433		
27669	2290	19133905	1984-05-14	1984-05-14 00:00:00	1984-05-25	1984-05-25 00:00:00	1984-05-25	38000177		0	0	11		0	0	0	152353	0	834102	19133905		
203867	4475	40213314	1979-07-30	1979-07-30 00:00:00	1979-07-30	1979-07-30 00:00:00	1979-07-30	581452		0	0	0		0	0	0	297758	0	49	40213314		
239894	5265	40213160	1973-02-01	1973-02-01 00:00:00	1973-02-01	1973-02-01 00:00:00	1973-02-01	581452		0	0	0		0	0	0	350325	0	10	40213160		
29510	2442	1127433	1975-07-31	1975-07-31 00:00:00	1975-08-07	1975-08-07 00:00:00	1975-08-07	38000177		0	0	7		0	0	0	162001	0	313782	1127433		
197390	4337	40213160	1966-04-15	1966-04-15 00:00:00	1966-04-15	1966-04-15 00:00:00	1966-04-15	581452		0	0	0		0	0	0	287628	0	10	40213160		
202719	4450	40213260	2018-08-18	2018-08-18 00:00:00	2018-08-18	2018-08-18 00:00:00	2018-08-18	581452		0	0	0		0	0	0	296083	0	121	40213260		
19230	1588	40229134	2015-07-05	2015-07-05 00:00:00	2015-07-12	2015-07-12 00:00:00	2015-07-12	38000177		0	0	7		0	0	0	106618	0	1043400	40229134		
51160	4250	1713671	2008-07-19	2008-07-19 00:00:00	2008-08-09	2008-08-09 00:00:00	2008-08-09	38000177		0	0	21		0	0	0	282307	0	562251	1713671		
191595	4210	40213160	1975-09-13	1975-09-13 00:00:00	1975-09-13	1975-09-13 00:00:00	1975-09-13	581452		0	0	0		0	0	0	279566	0	10	40213160		
55754	1222	40213260	2007-03-28	2007-03-28 00:00:00	2007-03-28	2007-03-28 00:00:00	2007-03-28	581452		0	0	0		0	0	0	80391	0	121	40213260		
63478	5274	1127078	1956-12-11	1956-12-11 00:00:00	1957-02-09	1957-02-09 00:00:00	1957-02-09	38000177		0	0	60		0	0	0	350838	0	282464	1127078		
43272	3583	46233988	1971-01-24	1971-01-24 00:00:00	1971-02-07	1971-02-07 00:00:00	1971-02-07	38000177		0	0	14		0	0	0	238171	0	1652673	46233988		
122318	2688	40213260	2012-11-18	2012-11-18 00:00:00	2012-11-18	2012-11-18 00:00:00	2012-11-18	581452		0	0	0		0	0	0	178160	0	121	40213260		
82260	1796	40213160	1984-03-14	1984-03-14 00:00:00	1984-03-14	1984-03-14 00:00:00	1984-03-14	581452		0	0	0		0	0	0	120436	0	10	40213160		
15718	1309	35605482	1994-03-22	1994-03-22 00:00:00	1994-03-22	1994-03-22 00:00:00	1994-03-22	38000177		0	0	0		0	0	0	86444	0	1740467	35605482		
183159	4024	40213251	1984-01-08	1984-01-08 00:00:00	1984-01-08	1984-01-08 00:00:00	1984-01-08	581452		0	0	0		0	0	0	267544	0	21	40213251		
42399	924	40213160	1963-10-06	1963-10-06 00:00:00	1963-10-06	1963-10-06 00:00:00	1963-10-06	581452		0	0	0		0	0	0	61519	0	10	40213160		
91077	1999	40213296	2017-09-29	2017-09-29 00:00:00	2017-09-29	2017-09-29 00:00:00	2017-09-29	581452		0	0	0		0	0	0	133056	0	52	40213296		
17948	388	40213160	1955-02-22	1955-02-22 00:00:00	1955-02-22	1955-02-22 00:00:00	1955-02-22	581452		0	0	0		0	0	0	25595	0	10	40213160		
36859	3048	19128065	1989-05-06	1989-05-06 00:00:00	1990-05-01	1990-05-01 00:00:00	1990-05-01	38000177		0	0	360		0	0	0	202821	0	749882	19128065		
55813	4633	19059056	1960-09-28	1960-09-28 00:00:00	1960-10-12	1960-10-12 00:00:00	1960-10-12	38000177		0	0	14		0	0	0	308742	0	243670	19059056		
45118	3733	19073183	1979-05-07	1979-05-07 00:00:00	1979-05-21	1979-05-21 00:00:00	1979-05-21	38000177		0	0	14		0	0	0	248076	0	308182	19073183		
28265	2334	1115171	2005-06-13	2005-06-13 00:00:00	2005-06-27	2005-06-27 00:00:00	2005-06-27	38000177		0	0	14		0	0	0	155346	0	849574	1115171		
9016	753	19133873	1973-04-27	1973-04-27 00:00:00	1973-05-08	1973-05-08 00:00:00	1973-05-08	38000177		0	0	11		0	0	0	49811	0	834061	19133873		
113933	2503	40213296	2013-02-26	2013-02-26 00:00:00	2013-02-26	2013-02-26 00:00:00	2013-02-26	581452		0	0	0		0	0	0	165771	0	52	40213296		
103578	2272	40213160	1980-08-09	1980-08-09 00:00:00	1980-08-09	1980-08-09 00:00:00	1980-08-09	581452		0	0	0		0	0	0	151009	0	10	40213160		
192909	4238	40213227	2003-09-11	2003-09-11 00:00:00	2003-09-11	2003-09-11 00:00:00	2003-09-11	581452		0	0	0		0	0	0	281415	0	113	40213227		
160523	3532	40213160	1970-12-20	1970-12-20 00:00:00	1970-12-20	1970-12-20 00:00:00	1970-12-20	581452		0	0	0		0	0	0	234609	0	10	40213160		
23266	505	40213160	1968-09-10	1968-09-10 00:00:00	1968-09-10	1968-09-10 00:00:00	1968-09-10	581452		0	0	0		0	0	0	33764	0	10	40213160		
184060	4044	40213306	1982-02-28	1982-02-28 00:00:00	1982-02-28	1982-02-28 00:00:00	1982-02-28	581452		0	0	0		0	0	0	268936	0	43	40213306		
163580	3598	40213227	2015-05-31	2015-05-31 00:00:00	2015-05-31	2015-05-31 00:00:00	2015-05-31	581452		0	0	0		0	0	0	238994	0	113	40213227		
18444	1526	19059056	1972-11-24	1972-11-24 00:00:00	1972-12-22	1972-12-22 00:00:00	1972-12-22	38000177		0	0	28		0	0	0	102048	0	243670	19059056		
34711	758	40213306	1996-02-18	1996-02-18 00:00:00	1996-02-18	1996-02-18 00:00:00	1996-02-18	581452		0	0	0		0	0	0	50351	0	43	40213306		
200559	4405	40213160	1964-07-27	1964-07-27 00:00:00	1964-07-27	1964-07-27 00:00:00	1964-07-27	581452		0	0	0		0	0	0	292792	0	10	40213160		
14342	1205	19059056	1961-03-15	1961-03-15 00:00:00	1961-03-29	1961-03-29 00:00:00	1961-03-29	38000177		0	0	14		0	0	0	79147	0	243670	19059056		
146914	3231	40213198	2013-08-15	2013-08-15 00:00:00	2013-08-15	2013-08-15 00:00:00	2013-08-15	581452		0	0	0		0	0	0	214758	0	133	40213198		
63886	1397	40213160	1977-07-29	1977-07-29 00:00:00	1977-07-29	1977-07-29 00:00:00	1977-07-29	581452		0	0	0		0	0	0	92779	0	10	40213160		
43073	3570	19059056	1966-12-06	1966-12-06 00:00:00	1966-12-27	1966-12-27 00:00:00	1966-12-27	38000177		0	0	21		0	0	0	237225	0	243670	19059056		
158363	3486	40213296	2003-01-17	2003-01-17 00:00:00	2003-01-17	2003-01-17 00:00:00	2003-01-17	581452		0	0	0		0	0	0	231222	0	52	40213296		
81134	1773	40213198	2016-09-18	2016-09-18 00:00:00	2016-09-18	2016-09-18 00:00:00	2016-09-18	581452		0	0	0		0	0	0	118621	0	133	40213198		
141372	3105	40213160	1975-01-06	1975-01-06 00:00:00	1975-01-06	1975-01-06 00:00:00	1975-01-06	581452		0	0	0		0	0	0	206524	0	10	40213160		
62123	5169	1713671	1983-10-26	1983-10-26 00:00:00	1983-11-09	1983-11-09 00:00:00	1983-11-09	38000177		0	0	14		0	0	0	343717	0	562251	1713671		
138041	3030	40213160	1981-11-24	1981-11-24 00:00:00	1981-11-24	1981-11-24 00:00:00	1981-11-24	581452		0	0	0		0	0	0	202031	0	10	40213160		
6755	569	19059056	1916-09-03	1916-09-03 00:00:00	1916-09-24	1916-09-24 00:00:00	1916-09-24	38000177		0	0	21		0	0	0	37659	0	243670	19059056		
6757	569	40236824	1935-05-26	1935-05-26 00:00:00	1935-06-02	1935-06-02 00:00:00	1935-06-02	38000177		0	0	7		0	0	0	37635	0	1094107	40236824		
178720	3928	40213160	1980-05-18	1980-05-18 00:00:00	1980-05-18	1980-05-18 00:00:00	1980-05-18	581452		0	0	0		0	0	0	261123	0	10	40213160		
25887	565	40213160	1958-04-02	1958-04-02 00:00:00	1958-04-02	1958-04-02 00:00:00	1958-04-02	581452		0	0	0		0	0	0	37409	0	10	40213160		
56701	4704	46233988	1970-04-15	1970-04-15 00:00:00	1970-04-29	1970-04-29 00:00:00	1970-04-29	38000177		0	0	14		0	0	0	313364	0	1652673	46233988		
57774	4800	19133873	1970-12-29	1970-12-29 00:00:00	1971-01-09	1971-01-09 00:00:00	1971-01-09	38000177		0	0	11		0	0	0	319322	0	834061	19133873		
228345	5015	40213227	2010-03-15	2010-03-15 00:00:00	2010-03-15	2010-03-15 00:00:00	2010-03-15	581452		0	0	0		0	0	0	333337	0	113	40213227		
56142	1229	40213227	1996-06-08	1996-06-08 00:00:00	1996-06-08	1996-06-08 00:00:00	1996-06-08	581452		0	0	0		0	0	0	80996	0	113	40213227		
192780	4235	40213314	1979-08-09	1979-08-09 00:00:00	1979-08-09	1979-08-09 00:00:00	1979-08-09	581452		0	0	0		0	0	0	281173	0	49	40213314		
201869	4432	40213227	2008-07-01	2008-07-01 00:00:00	2008-07-01	2008-07-01 00:00:00	2008-07-01	581452		0	0	0		0	0	0	294607	0	113	40213227		
12208	1024	19073188	2004-08-23	2004-08-23 00:00:00	2004-09-27	2004-09-27 00:00:00	2004-09-27	38000177		0	0	35		0	0	0	67440	0	308192	19073188		
56015	4649	46233988	1971-06-14	1971-06-14 00:00:00	1971-06-28	1971-06-28 00:00:00	1971-06-28	38000177		0	0	14		0	0	0	310014	0	1652673	46233988		
128710	2830	40213296	2017-01-09	2017-01-09 00:00:00	2017-01-09	2017-01-09 00:00:00	2017-01-09	581452		0	0	0		0	0	0	187781	0	52	40213296		
115763	2543	40213260	2014-10-19	2014-10-19 00:00:00	2014-10-19	2014-10-19 00:00:00	2014-10-19	581452		0	0	0		0	0	0	168218	0	121	40213260		
114795	2522	40213260	2010-01-01	2010-01-01 00:00:00	2010-01-01	2010-01-01 00:00:00	2010-01-01	581452		0	0	0		0	0	0	166844	0	121	40213260		
25797	2122	1127433	1982-03-09	1982-03-09 00:00:00	1982-03-16	1982-03-16 00:00:00	1982-03-16	38000177		0	0	7		0	0	0	141188	0	313782	1127433		
51916	1136	40213306	1995-06-03	1995-06-03 00:00:00	1995-06-03	1995-06-03 00:00:00	1995-06-03	581452		0	0	0		0	0	0	74832	0	43	40213306		
8251	687	40229134	1981-03-18	1981-03-18 00:00:00	1981-03-25	1981-03-25 00:00:00	1981-03-25	38000177		0	0	7		0	0	0	45575	0	1043400	40229134		
121878	2679	40213160	1972-07-07	1972-07-07 00:00:00	1972-07-07	1972-07-07 00:00:00	1972-07-07	581452		0	0	0		0	0	0	177470	0	10	40213160		
86878	1905	40213296	2007-12-28	2007-12-28 00:00:00	2007-12-28	2007-12-28 00:00:00	2007-12-28	581452		0	0	0		0	0	0	126837	0	52	40213296		
11837	987	1713671	2009-09-07	2009-09-07 00:00:00	2009-09-21	2009-09-21 00:00:00	2009-09-21	38000177		0	0	14		0	0	0	65563	0	562251	1713671		
27670	2290	1118084	1993-04-08	1993-04-08 00:00:00	1993-04-08	1993-04-08 00:00:00	\N	38000177		0	0	0		0	0	0	152315	0	00025152531	44923712		
203869	4475	40213314	1978-08-28	1978-08-28 00:00:00	1978-08-28	1978-08-28 00:00:00	1978-08-28	581452		0	0	0		0	0	0	297740	0	49	40213314		
191900	4217	40213160	1963-07-24	1963-07-24 00:00:00	1963-07-24	1963-07-24 00:00:00	1963-07-24	581452		0	0	0		0	0	0	279961	0	10	40213160		
29511	2442	1713671	1974-10-11	1974-10-11 00:00:00	1974-10-25	1974-10-25 00:00:00	1974-10-25	38000177		0	0	14		0	0	0	161918	0	562251	1713671		
197394	4337	40213227	2012-06-15	2012-06-15 00:00:00	2012-06-15	2012-06-15 00:00:00	2012-06-15	581452		0	0	0		0	0	0	287596	0	113	40213227		
202722	4450	40213306	1990-06-02	1990-06-02 00:00:00	1990-06-02	1990-06-02 00:00:00	1990-06-02	581452		0	0	0		0	0	0	296042	0	43	40213306		
19231	1588	19128065	1977-11-15	1977-11-15 00:00:00	1978-11-10	1978-11-10 00:00:00	1978-11-10	38000177		0	0	360		0	0	0	106630	0	749882	19128065		
51161	4250	1713671	1971-03-01	1971-03-01 00:00:00	1971-03-15	1971-03-15 00:00:00	1971-03-15	38000177		0	0	14		0	0	0	282286	0	562251	1713671		
191599	4210	40213227	1997-07-19	1997-07-19 00:00:00	1997-07-19	1997-07-19 00:00:00	1997-07-19	581452		0	0	0		0	0	0	279534	0	113	40213227		
68114	1491	40213296	2010-11-16	2010-11-16 00:00:00	2010-11-16	2010-11-16 00:00:00	2010-11-16	581452		0	0	0		0	0	0	99450	0	52	40213296		
60751	1328	40213198	2011-03-17	2011-03-17 00:00:00	2011-03-17	2011-03-17 00:00:00	2011-03-17	581452		0	0	0		0	0	0	88173	0	133	40213198		
43273	3583	19112599	1973-11-25	1973-11-25 00:00:00	1973-11-25	1973-11-25 00:00:00	\N	38000177		0	0	0		0	0	0	238240	0	477045	19112599		
122325	2688	40213306	1985-01-13	1985-01-13 00:00:00	1985-01-13	1985-01-13 00:00:00	1985-01-13	581452		0	0	0		0	0	0	178107	0	43	40213306		
117526	2583	40213160	1975-05-26	1975-05-26 00:00:00	1975-05-26	1975-05-26 00:00:00	1975-05-26	581452		0	0	0		0	0	0	171031	0	10	40213160		
15719	1309	19079524	1994-03-21	1994-03-21 00:00:00	1994-03-22	1994-03-22 00:00:00	1994-03-22	38000177		0	0	1		0	0	0	86444	0	313002	19079524		
183173	4024	40213314	1980-04-06	1980-04-06 00:00:00	1980-04-06	1980-04-06 00:00:00	1980-04-06	581452		0	0	0		0	0	0	267542	0	49	40213314		
42407	924	40213227	2005-01-08	2005-01-08 00:00:00	2005-01-08	2005-01-08 00:00:00	2005-01-08	581452		0	0	0		0	0	0	61536	0	113	40213227		
91080	1999	40213160	1978-06-02	1978-06-02 00:00:00	1978-06-02	1978-06-02 00:00:00	1978-06-02	581452		0	0	0		0	0	0	133045	0	10	40213160		
17949	388	40213160	1955-05-24	1955-05-24 00:00:00	1955-05-24	1955-05-24 00:00:00	1955-05-24	581452		0	0	0		0	0	0	25556	0	10	40213160		
36860	3048	19128065	1990-05-01	1990-05-01 00:00:00	1991-04-26	1991-04-26 00:00:00	1991-04-26	38000177		0	0	360		0	0	0	202827	0	749882	19128065		
55814	4633	19006318	1960-09-28	1960-09-28 00:00:00	1960-10-12	1960-10-12 00:00:00	1960-10-12	38000177		0	0	14		0	0	0	308742	0	105078	19006318		
45119	3733	1127078	1979-05-07	1979-05-07 00:00:00	1979-05-21	1979-05-21 00:00:00	1979-05-21	38000177		0	0	14		0	0	0	248076	0	282464	1127078		
28266	2334	40169281	1963-02-14	1963-02-14 00:00:00	1963-02-14	1963-02-14 00:00:00	\N	38000177		0	0	0		0	0	0	155368	0	896209	40169281		
9017	753	1127433	1978-10-14	1978-10-14 00:00:00	1978-10-21	1978-10-21 00:00:00	1978-10-21	38000177		0	0	7		0	0	0	49806	0	313782	1127433		
113937	2503	40213160	1978-01-31	1978-01-31 00:00:00	1978-01-31	1978-01-31 00:00:00	1978-01-31	581452		0	0	0		0	0	0	165766	0	10	40213160		
103585	2272	40213251	1984-11-10	1984-11-10 00:00:00	1984-11-10	1984-11-10 00:00:00	1984-11-10	581452		0	0	0		0	0	0	150994	0	21	40213251		
192910	4238	40213296	2003-09-11	2003-09-11 00:00:00	2003-09-11	2003-09-11 00:00:00	2003-09-11	581452		0	0	0		0	0	0	281415	0	52	40213296		
160527	3532	40213296	2010-07-18	2010-07-18 00:00:00	2010-07-18	2010-07-18 00:00:00	2010-07-18	581452		0	0	0		0	0	0	234616	0	52	40213296		
34561	755	40213201	2014-04-26	2014-04-26 00:00:00	2014-04-26	2014-04-26 00:00:00	2014-04-26	581452		0	0	0		0	0	0	50082	0	33	40213201		
184063	4044	40213227	1994-03-13	1994-03-13 00:00:00	1994-03-13	1994-03-13 00:00:00	1994-03-13	581452		0	0	0		0	0	0	268960	0	113	40213227		
213828	4689	40213160	1967-08-16	1967-08-16 00:00:00	1967-08-16	1967-08-16 00:00:00	1967-08-16	581452		0	0	0		0	0	0	312425	0	10	40213160		
18454	1528	1127433	1971-03-31	1971-03-31 00:00:00	1971-04-07	1971-04-07 00:00:00	1971-04-07	38000177		0	0	7		0	0	0	102244	0	313782	1127433		
34714	758	40213160	1973-12-02	1973-12-02 00:00:00	1973-12-02	1973-12-02 00:00:00	1973-12-02	581452		0	0	0		0	0	0	50304	0	10	40213160		
60034	1314	40213201	1996-10-19	1996-10-19 00:00:00	1996-10-19	1996-10-19 00:00:00	1996-10-19	581452		0	0	0		0	0	0	87029	0	33	40213201		
14343	1205	19006318	1961-03-15	1961-03-15 00:00:00	1961-03-29	1961-03-29 00:00:00	1961-03-29	38000177		0	0	14		0	0	0	79147	0	105078	19006318		
146928	3231	40213227	2009-07-23	2009-07-23 00:00:00	2009-07-23	2009-07-23 00:00:00	2009-07-23	581452		0	0	0		0	0	0	214811	0	113	40213227		
75182	1641	40213260	2006-10-04	2006-10-04 00:00:00	2006-10-04	2006-10-04 00:00:00	2006-10-04	581452		0	0	0		0	0	0	110150	0	121	40213260		
43075	3570	1127433	1957-01-16	1957-01-16 00:00:00	1957-01-23	1957-01-23 00:00:00	1957-01-23	38000177		0	0	7		0	0	0	237287	0	313782	1127433		
158367	3486	40213260	2010-02-05	2010-02-05 00:00:00	2010-02-05	2010-02-05 00:00:00	2010-02-05	581452		0	0	0		0	0	0	231287	0	121	40213260		
117822	2590	40213296	2004-12-21	2004-12-21 00:00:00	2004-12-21	2004-12-21 00:00:00	2004-12-21	581452		0	0	0		0	0	0	171372	0	52	40213296		
141380	3105	40213160	1970-07-06	1970-07-06 00:00:00	1970-07-06	1970-07-06 00:00:00	1970-07-06	581452		0	0	0		0	0	0	206512	0	10	40213160		
62124	5169	19059056	1954-06-26	1954-06-26 00:00:00	1954-07-17	1954-07-17 00:00:00	1954-07-17	38000177		0	0	21		0	0	0	343731	0	243670	19059056		
111865	2458	40213160	1970-11-01	1970-11-01 00:00:00	1970-11-01	1970-11-01 00:00:00	1970-11-01	581452		0	0	0		0	0	0	163000	0	10	40213160		
6756	569	1127433	1964-05-21	1964-05-21 00:00:00	1964-06-04	1964-06-04 00:00:00	1964-06-04	38000177		0	0	14		0	0	0	37694	0	313782	1127433		
6758	569	920300	1935-05-26	1935-05-26 00:00:00	1935-06-02	1935-06-02 00:00:00	1935-06-02	38000177		0	0	7		0	0	0	37635	0	311989	920300		
178725	3928	40213160	1980-08-17	1980-08-17 00:00:00	1980-08-17	1980-08-17 00:00:00	1980-08-17	581452		0	0	0		0	0	0	261139	0	10	40213160		
25889	565	40213227	2008-07-30	2008-07-30 00:00:00	2008-07-30	2008-07-30 00:00:00	2008-07-30	581452		0	0	0		0	0	0	37401	0	113	40213227		
56702	4704	1127433	2009-11-01	2009-11-01 00:00:00	2009-11-08	2009-11-08 00:00:00	2009-11-08	38000177		0	0	7		0	0	0	313363	0	313782	1127433		
57775	4800	19133873	1975-03-22	1975-03-22 00:00:00	1975-03-29	1975-03-29 00:00:00	1975-03-29	38000177		0	0	7		0	0	0	319328	0	834061	19133873		
228346	5015	40213296	2010-03-15	2010-03-15 00:00:00	2010-03-15	2010-03-15 00:00:00	2010-03-15	581452		0	0	0		0	0	0	333337	0	52	40213296		
56146	1229	40213160	1959-02-14	1959-02-14 00:00:00	1959-02-14	1959-02-14 00:00:00	1959-02-14	581452		0	0	0		0	0	0	80939	0	10	40213160		
192781	4235	40213160	1979-08-09	1979-08-09 00:00:00	1979-08-09	1979-08-09 00:00:00	1979-08-09	581452		0	0	0		0	0	0	281173	0	10	40213160		
175746	3864	40213160	1965-12-18	1965-12-18 00:00:00	1965-12-18	1965-12-18 00:00:00	1965-12-18	581452		0	0	0		0	0	0	256512	0	10	40213160		
12209	1024	1127433	2004-08-23	2004-08-23 00:00:00	2004-09-27	2004-09-27 00:00:00	2004-09-27	38000177		0	0	35		0	0	0	67440	0	313782	1127433		
56016	4649	19059056	1971-06-14	1971-06-14 00:00:00	1971-06-28	1971-06-28 00:00:00	1971-06-28	38000177		0	0	14		0	0	0	310014	0	243670	19059056		
128712	2830	40213227	2017-01-09	2017-01-09 00:00:00	2017-01-09	2017-01-09 00:00:00	2017-01-09	581452		0	0	0		0	0	0	187781	0	113	40213227		
115765	2543	40213227	2015-10-25	2015-10-25 00:00:00	2015-10-25	2015-10-25 00:00:00	2015-10-25	581452		0	0	0		0	0	0	168240	0	113	40213227		
114799	2522	40213227	1999-12-03	1999-12-03 00:00:00	1999-12-03	1999-12-03 00:00:00	1999-12-03	581452		0	0	0		0	0	0	166857	0	113	40213227		
25798	2122	1127433	2017-09-07	2017-09-07 00:00:00	2017-09-21	2017-09-21 00:00:00	2017-09-21	38000177		0	0	14		0	0	0	141197	0	313782	1127433		
51921	1136	40213160	1972-01-22	1972-01-22 00:00:00	1972-01-22	1972-01-22 00:00:00	1972-01-22	581452		0	0	0		0	0	0	74849	0	10	40213160		
8252	687	19059056	1968-06-28	1968-06-28 00:00:00	1968-07-12	1968-07-12 00:00:00	1968-07-12	38000177		0	0	14		0	0	0	45535	0	243670	19059056		
121882	2679	40213296	2012-04-06	2012-04-06 00:00:00	2012-04-06	2012-04-06 00:00:00	2012-04-06	581452		0	0	0		0	0	0	177513	0	52	40213296		
86882	1905	40213296	2010-01-01	2010-01-01 00:00:00	2010-01-01	2010-01-01 00:00:00	2010-01-01	581452		0	0	0		0	0	0	126784	0	52	40213296		
11838	987	19133905	1999-09-17	1999-09-17 00:00:00	1999-09-28	1999-09-28 00:00:00	1999-09-28	38000177		0	0	11		0	0	0	65601	0	834102	19133905		
27671	2290	1127433	1992-07-02	1992-07-02 00:00:00	1992-07-09	1992-07-09 00:00:00	1992-07-09	38000177		0	0	7		0	0	0	152315	0	313782	1127433		
203870	4475	40213160	1978-08-28	1978-08-28 00:00:00	1978-08-28	1978-08-28 00:00:00	1978-08-28	581452		0	0	0		0	0	0	297740	0	10	40213160		
191908	4217	40213260	2009-04-08	2009-04-08 00:00:00	2009-04-08	2009-04-08 00:00:00	2009-04-08	581452		0	0	0		0	0	0	279934	0	121	40213260		
29512	2443	1118084	1999-04-09	1999-04-09 00:00:00	1999-04-09	1999-04-09 00:00:00	\N	38000177		0	0	0		0	0	0	162057	0	00025152531	44923712		
197395	4337	40213260	2012-06-15	2012-06-15 00:00:00	2012-06-15	2012-06-15 00:00:00	2012-06-15	581452		0	0	0		0	0	0	287596	0	121	40213260		
202735	4450	40213227	2010-03-27	2010-03-27 00:00:00	2010-03-27	2010-03-27 00:00:00	2010-03-27	581452		0	0	0		0	0	0	296081	0	113	40213227		
19232	1588	1118084	2005-03-13	2005-03-13 00:00:00	2005-03-13	2005-03-13 00:00:00	\N	38000177		0	0	0		0	0	0	106573	0	00025152531	44923712		
51162	4250	1115171	2016-05-31	2016-05-31 00:00:00	2016-06-30	2016-06-30 00:00:00	2016-06-30	38000177		0	0	30		0	0	0	282265	0	849574	1115171		
75754	1655	40213160	1972-06-09	1972-06-09 00:00:00	1972-06-09	1972-06-09 00:00:00	1972-06-09	581452		0	0	0		0	0	0	111035	0	10	40213160		
68116	1491	40213227	2010-11-16	2010-11-16 00:00:00	2010-11-16	2010-11-16 00:00:00	2010-11-16	581452		0	0	0		0	0	0	99450	0	113	40213227		
60760	1328	40213227	1996-08-01	1996-08-01 00:00:00	1996-08-01	1996-08-01 00:00:00	1996-08-01	581452		0	0	0		0	0	0	88230	0	113	40213227		
146694	3226	40213160	1969-06-15	1969-06-15 00:00:00	1969-06-15	1969-06-15 00:00:00	1969-06-15	581452		0	0	0		0	0	0	214442	0	10	40213160		
122328	2688	40213160	1963-02-24	1963-02-24 00:00:00	1963-02-24	1963-02-24 00:00:00	1963-02-24	581452		0	0	0		0	0	0	178155	0	10	40213160		
117528	2583	40213296	2010-06-21	2010-06-21 00:00:00	2010-06-21	2010-06-21 00:00:00	2010-06-21	581452		0	0	0		0	0	0	171071	0	52	40213296		
15720	1309	46275444	1994-03-22	1994-03-22 00:00:00	1994-03-22	1994-03-22 00:00:00	1994-03-22	38000177		0	0	0		0	0	0	86444	0	1659149	46275444		
79324	1736	40213160	1970-01-15	1970-01-15 00:00:00	1970-01-15	1970-01-15 00:00:00	1970-01-15	581452		0	0	0		0	0	0	115926	0	10	40213160		
42408	924	40213296	2005-01-08	2005-01-08 00:00:00	2005-01-08	2005-01-08 00:00:00	2005-01-08	581452		0	0	0		0	0	0	61536	0	52	40213296		
174063	3827	40213227	2018-01-26	2018-01-26 00:00:00	2018-01-26	2018-01-26 00:00:00	2018-01-26	581452		0	0	0		0	0	0	254168	0	113	40213227		
17952	388	40213260	2007-07-17	2007-07-17 00:00:00	2007-07-17	2007-07-17 00:00:00	2007-07-17	581452		0	0	0		0	0	0	25549	0	121	40213260		
36861	3049	1127433	2005-10-18	2005-10-18 00:00:00	2005-11-22	2005-11-22 00:00:00	2005-11-22	38000177		0	0	35		0	0	0	202876	0	313782	1127433		
55815	4633	1127433	1965-06-05	1965-06-05 00:00:00	1965-06-19	1965-06-19 00:00:00	1965-06-19	38000177		0	0	14		0	0	0	308792	0	313782	1127433		
45120	3733	40224805	1992-10-22	1992-10-22 00:00:00	1993-10-17	1993-10-17 00:00:00	1993-10-17	38000177		0	0	360		0	0	0	248028	0	1000126	40224805		
28267	2334	40220960	2015-08-27	2015-08-27 00:00:00	2015-08-27	2015-08-27 00:00:00	2015-08-27	38000177		0	0	0		0	0	0	155365	0	1804799	40220960		
9018	753	1127433	2007-01-17	2007-01-17 00:00:00	2007-01-24	2007-01-24 00:00:00	2007-01-24	38000177		0	0	7		0	0	0	49746	0	313782	1127433		
113945	2503	40213160	1973-10-30	1973-10-30 00:00:00	1973-10-30	1973-10-30 00:00:00	1973-10-30	581452		0	0	0		0	0	0	165723	0	10	40213160		
103586	2272	40213160	1984-11-10	1984-11-10 00:00:00	1984-11-10	1984-11-10 00:00:00	1984-11-10	581452		0	0	0		0	0	0	150994	0	10	40213160		
192921	4238	40213160	1961-12-07	1961-12-07 00:00:00	1961-12-07	1961-12-07 00:00:00	1961-12-07	581452		0	0	0		0	0	0	281368	0	10	40213160		
160533	3533	40213160	1962-05-09	1962-05-09 00:00:00	1962-05-09	1962-05-09 00:00:00	1962-05-09	581452		0	0	0		0	0	0	234695	0	10	40213160		
163326	3593	40213227	2003-03-26	2003-03-26 00:00:00	2003-03-26	2003-03-26 00:00:00	2003-03-26	581452		0	0	0		0	0	0	238712	0	113	40213227		
184064	4044	40213160	1960-05-15	1960-05-15 00:00:00	1960-05-15	1960-05-15 00:00:00	1960-05-15	581452		0	0	0		0	0	0	268928	0	10	40213160		
213829	4689	40213160	1968-01-16	1968-01-16 00:00:00	1968-01-16	1968-01-16 00:00:00	1968-01-16	581452		0	0	0		0	0	0	312426	0	10	40213160		
18455	1528	1127433	2012-03-13	2012-03-13 00:00:00	2012-04-10	2012-04-10 00:00:00	2012-04-10	38000177		0	0	28		0	0	0	102243	0	313782	1127433		
34716	758	40213227	1996-02-18	1996-02-18 00:00:00	1996-02-18	1996-02-18 00:00:00	1996-02-18	581452		0	0	0		0	0	0	50351	0	113	40213227		
60057	1314	40213227	1992-09-26	1992-09-26 00:00:00	1992-09-26	1992-09-26 00:00:00	1992-09-26	581452		0	0	0		0	0	0	86962	0	113	40213227		
14344	1205	1127433	1976-07-22	1976-07-22 00:00:00	1976-08-21	1976-08-21 00:00:00	1976-08-21	38000177		0	0	30		0	0	0	79174	0	313782	1127433		
146951	3231	40213227	1998-10-22	1998-10-22 00:00:00	1998-10-22	1998-10-22 00:00:00	1998-10-22	581452		0	0	0		0	0	0	214810	0	113	40213227		
75185	1641	40213296	1996-10-02	1996-10-02 00:00:00	1996-10-02	1996-10-02 00:00:00	1996-10-02	581452		0	0	0		0	0	0	110130	0	52	40213296		
43076	3570	1713671	2017-05-20	2017-05-20 00:00:00	2017-06-10	2017-06-10 00:00:00	2017-06-10	38000177		0	0	21		0	0	0	237231	0	562251	1713671		
158368	3486	40213160	1960-04-01	1960-04-01 00:00:00	1960-04-01	1960-04-01 00:00:00	1960-04-01	581452		0	0	0		0	0	0	231195	0	10	40213160		
117824	2590	40213227	2004-12-21	2004-12-21 00:00:00	2004-12-21	2004-12-21 00:00:00	2004-12-21	581452		0	0	0		0	0	0	171372	0	113	40213227		
141382	3105	40213160	1970-05-04	1970-05-04 00:00:00	1970-05-04	1970-05-04 00:00:00	1970-05-04	581452		0	0	0		0	0	0	206532	0	10	40213160		
62125	5169	1127433	1997-01-20	1997-01-20 00:00:00	1997-02-03	1997-02-03 00:00:00	1997-02-03	38000177		0	0	14		0	0	0	343684	0	313782	1127433		
111869	2458	40213227	2002-05-12	2002-05-12 00:00:00	2002-05-12	2002-05-12 00:00:00	2002-05-12	581452		0	0	0		0	0	0	162996	0	113	40213227		
19328	421	40213227	1996-08-28	1996-08-28 00:00:00	1996-08-28	1996-08-28 00:00:00	1996-08-28	581452		0	0	0		0	0	0	27873	0	113	40213227		
6759	569	40220960	1998-05-30	1998-05-30 00:00:00	1998-05-30	1998-05-30 00:00:00	1998-05-30	38000177		0	0	0		0	0	0	37721	0	1804799	40220960		
242596	5325	40213227	1997-11-16	1997-11-16 00:00:00	1997-11-16	1997-11-16 00:00:00	1997-11-16	581452		0	0	0		0	0	0	354474	0	113	40213227		
25890	565	40213260	2008-07-30	2008-07-30 00:00:00	2008-07-30	2008-07-30 00:00:00	2008-07-30	581452		0	0	0		0	0	0	37401	0	121	40213260		
148431	3263	40213201	2011-02-22	2011-02-22 00:00:00	2011-02-22	2011-02-22 00:00:00	2011-02-22	581452		0	0	0		0	0	0	216940	0	33	40213201		
57776	4800	1127078	1974-11-07	1974-11-07 00:00:00	1974-11-21	1974-11-21 00:00:00	1974-11-21	38000177		0	0	14		0	0	0	319292	0	282464	1127078		
52719	4382	19128065	1978-10-24	1978-10-24 00:00:00	1979-10-19	1979-10-19 00:00:00	1979-10-19	38000177		0	0	360		0	0	0	291243	0	749882	19128065		
56869	4720	1127433	2012-12-29	2012-12-29 00:00:00	2013-01-19	2013-01-19 00:00:00	2013-01-19	38000177		0	0	21		0	0	0	314372	0	313782	1127433		
204064	4480	40213160	1961-07-11	1961-07-11 00:00:00	1961-07-11	1961-07-11 00:00:00	1961-07-11	581452		0	0	0		0	0	0	298128	0	10	40213160		
175753	3864	40213160	1969-11-22	1969-11-22 00:00:00	1969-11-22	1969-11-22 00:00:00	1969-11-22	581452		0	0	0		0	0	0	256532	0	10	40213160		
12210	1024	40162522	2004-08-23	2004-08-23 00:00:00	2004-08-23	2004-08-23 00:00:00	\N	38000177		0	0	0		0	0	0	67440	0	857005	40162522		
56017	4649	46233988	1970-02-05	1970-02-05 00:00:00	1970-02-19	1970-02-19 00:00:00	1970-02-19	38000177		0	0	14		0	0	0	310013	0	1652673	46233988		
48841	1070	40213160	1973-07-12	1973-07-12 00:00:00	1973-07-12	1973-07-12 00:00:00	1973-07-12	581452		0	0	0		0	0	0	70068	0	10	40213160		
115766	2543	40213260	2015-10-25	2015-10-25 00:00:00	2015-10-25	2015-10-25 00:00:00	2015-10-25	581452		0	0	0		0	0	0	168240	0	121	40213260		
114800	2522	40213296	1999-12-03	1999-12-03 00:00:00	1999-12-03	1999-12-03 00:00:00	1999-12-03	581452		0	0	0		0	0	0	166857	0	52	40213296		
25799	2122	1127078	1974-10-15	1974-10-15 00:00:00	1974-10-29	1974-10-29 00:00:00	1974-10-29	38000177		0	0	14		0	0	0	141213	0	282464	1127078		
51929	1136	40213160	1971-10-23	1971-10-23 00:00:00	1971-10-23	1971-10-23 00:00:00	1971-10-23	581452		0	0	0		0	0	0	74873	0	10	40213160		
8256	689	1115171	1995-04-14	1995-04-14 00:00:00	1995-05-12	1995-05-12 00:00:00	1995-05-12	38000177		0	0	28		0	0	0	45623	0	849574	1115171		
121891	2679	40213160	1977-03-11	1977-03-11 00:00:00	1977-03-11	1977-03-11 00:00:00	1977-03-11	581452		0	0	0		0	0	0	177482	0	10	40213160		
86883	1905	40213260	2018-01-26	2018-01-26 00:00:00	2018-01-26	2018-01-26 00:00:00	2018-01-26	581452		0	0	0		0	0	0	126839	0	121	40213260		
11839	987	19078461	2004-02-19	2004-02-19 00:00:00	2004-03-11	2004-03-11 00:00:00	2004-03-11	38000177		0	0	21		0	0	0	65579	0	310965	19078461		
27672	2290	19133905	1999-10-07	1999-10-07 00:00:00	1999-10-17	1999-10-17 00:00:00	1999-10-17	38000177		0	0	10		0	0	0	152359	0	834102	19133905		
203881	4476	40213296	2002-02-24	2002-02-24 00:00:00	2002-02-24	2002-02-24 00:00:00	2002-02-24	581452		0	0	0		0	0	0	297876	0	52	40213296		
191910	4217	40213306	1981-07-15	1981-07-15 00:00:00	1981-07-15	1981-07-15 00:00:00	1981-07-15	581452		0	0	0		0	0	0	279913	0	43	40213306		
29513	2443	19133905	1986-03-04	1986-03-04 00:00:00	1986-03-13	1986-03-13 00:00:00	1986-03-13	38000177		0	0	9		0	0	0	162073	0	834102	19133905		
197399	4338	40213296	2007-07-21	2007-07-21 00:00:00	2007-07-21	2007-07-21 00:00:00	2007-07-21	581452		0	0	0		0	0	0	287703	0	52	40213296		
202736	4450	40213296	2010-03-27	2010-03-27 00:00:00	2010-03-27	2010-03-27 00:00:00	2010-03-27	581452		0	0	0		0	0	0	296081	0	52	40213296		
19233	1588	19128065	1980-10-30	1980-10-30 00:00:00	1981-10-25	1981-10-25 00:00:00	1981-10-25	38000177		0	0	360		0	0	0	106635	0	749882	19128065		
51163	4250	1127433	1974-03-11	1974-03-11 00:00:00	1974-03-25	1974-03-25 00:00:00	1974-03-25	38000177		0	0	14		0	0	0	282291	0	313782	1127433		
75759	1655	40213296	2011-10-28	2011-10-28 00:00:00	2011-10-28	2011-10-28 00:00:00	2011-10-28	581452		0	0	0		0	0	0	111053	0	52	40213296		
68117	1491	40213160	1973-10-16	1973-10-16 00:00:00	1973-10-16	1973-10-16 00:00:00	1973-10-16	581452		0	0	0		0	0	0	99464	0	10	40213160		
60772	1328	40213227	2006-09-28	2006-09-28 00:00:00	2006-09-28	2006-09-28 00:00:00	2006-09-28	581452		0	0	0		0	0	0	88195	0	113	40213227		
146698	3226	40213160	1969-01-12	1969-01-12 00:00:00	1969-01-12	1969-01-12 00:00:00	1969-01-12	581452		0	0	0		0	0	0	214441	0	10	40213160		
122332	2688	40213160	1963-04-28	1963-04-28 00:00:00	1963-04-28	1963-04-28 00:00:00	1963-04-28	581452		0	0	0		0	0	0	178099	0	10	40213160		
117533	2583	40213160	1970-09-21	1970-09-21 00:00:00	1970-09-21	1970-09-21 00:00:00	1970-09-21	581452		0	0	0		0	0	0	171062	0	10	40213160		
93618	2054	40213160	1971-12-02	1971-12-02 00:00:00	1971-12-02	1971-12-02 00:00:00	1971-12-02	581452		0	0	0		0	0	0	136664	0	10	40213160		
79327	1736	40213306	1989-09-14	1989-09-14 00:00:00	1989-09-14	1989-09-14 00:00:00	1989-09-14	581452		0	0	0		0	0	0	115933	0	43	40213306		
42410	924	40213227	1996-12-28	1996-12-28 00:00:00	1996-12-28	1996-12-28 00:00:00	1996-12-28	581452		0	0	0		0	0	0	61564	0	113	40213227		
174065	3827	40213160	1957-03-01	1957-03-01 00:00:00	1957-03-01	1957-03-01 00:00:00	1957-03-01	581452		0	0	0		0	0	0	254169	0	10	40213160		
17960	388	40213296	1998-09-01	1998-09-01 00:00:00	1998-09-01	1998-09-01 00:00:00	1998-09-01	581452		0	0	0		0	0	0	25542	0	52	40213296		
36862	3049	1115171	2017-06-20	2017-06-20 00:00:00	2017-07-11	2017-07-11 00:00:00	2017-07-11	38000177		0	0	21		0	0	0	202878	0	849574	1115171		
55816	4633	40165015	1974-01-12	1974-01-12 00:00:00	1974-01-12	1974-01-12 00:00:00	\N	38000177		0	0	0		0	0	0	308767	0	861467	40165015		
45121	3733	19128065	1994-10-12	1994-10-12 00:00:00	1995-10-07	1995-10-07 00:00:00	1995-10-07	38000177		0	0	360		0	0	0	248079	0	749882	19128065		
28268	2334	19075601	2015-08-27	2015-08-27 00:00:00	2015-08-27	2015-08-27 00:00:00	2015-08-27	38000177		0	0	0		0	0	0	155365	0	309362	19075601		
9019	753	1115171	1997-08-31	1997-08-31 00:00:00	1997-09-14	1997-09-14 00:00:00	1997-09-14	38000177		0	0	14		0	0	0	49817	0	849574	1115171		
113948	2504	40213160	1955-04-04	1955-04-04 00:00:00	1955-04-04	1955-04-04 00:00:00	1955-04-04	581452		0	0	0		0	0	0	165785	0	10	40213160		
103588	2272	40213160	1980-05-10	1980-05-10 00:00:00	1980-05-10	1980-05-10 00:00:00	1980-05-10	581452		0	0	0		0	0	0	151032	0	10	40213160		
192930	4238	40213227	2012-09-06	2012-09-06 00:00:00	2012-09-06	2012-09-06 00:00:00	2012-09-06	581452		0	0	0		0	0	0	281427	0	113	40213227		
160537	3533	40213160	1962-03-07	1962-03-07 00:00:00	1962-03-07	1962-03-07 00:00:00	1962-03-07	581452		0	0	0		0	0	0	234659	0	10	40213160		
163332	3593	40213227	2013-05-22	2013-05-22 00:00:00	2013-05-22	2013-05-22 00:00:00	2013-05-22	581452		0	0	0		0	0	0	238663	0	113	40213227		
3653	300	19128065	1986-03-21	1986-03-21 00:00:00	1987-03-16	1987-03-16 00:00:00	1987-03-16	38000177		0	0	360		0	0	0	20057	0	749882	19128065		
213833	4689	40213260	2017-05-10	2017-05-10 00:00:00	2017-05-10	2017-05-10 00:00:00	2017-05-10	581452		0	0	0		0	0	0	312390	0	121	40213260		
18456	1528	19059056	1972-01-31	1972-01-31 00:00:00	1972-02-14	1972-02-14 00:00:00	1972-02-14	38000177		0	0	14		0	0	0	102239	0	243670	19059056		
34724	758	40213160	1973-07-01	1973-07-01 00:00:00	1973-07-01	1973-07-01 00:00:00	1973-07-01	581452		0	0	0		0	0	0	50303	0	10	40213160		
60072	1314	40213227	2012-01-14	2012-01-14 00:00:00	2012-01-14	2012-01-14 00:00:00	2012-01-14	581452		0	0	0		0	0	0	87014	0	113	40213227		
14346	1205	1127433	2016-10-06	2016-10-06 00:00:00	2016-10-13	2016-10-13 00:00:00	2016-10-13	38000177		0	0	7		0	0	0	79203	0	313782	1127433		
69656	1523	40213227	2007-04-17	2007-04-17 00:00:00	2007-04-17	2007-04-17 00:00:00	2007-04-17	581452		0	0	0		0	0	0	101862	0	113	40213227		
75187	1641	40213227	1996-10-02	1996-10-02 00:00:00	1996-10-02	1996-10-02 00:00:00	1996-10-02	581452		0	0	0		0	0	0	110130	0	113	40213227		
43077	3570	19059056	1953-03-14	1953-03-14 00:00:00	1953-03-28	1953-03-28 00:00:00	1953-03-28	38000177		0	0	14		0	0	0	237274	0	243670	19059056		
141276	3103	40213314	1978-08-23	1978-08-23 00:00:00	1978-08-23	1978-08-23 00:00:00	1978-08-23	581452		0	0	0		0	0	0	206443	0	49	40213314		
117826	2590	40213306	1984-12-18	1984-12-18 00:00:00	1984-12-18	1984-12-18 00:00:00	1984-12-18	581452		0	0	0		0	0	0	171382	0	43	40213306		
141387	3105	40213160	1970-10-05	1970-10-05 00:00:00	1970-10-05	1970-10-05 00:00:00	1970-10-05	581452		0	0	0		0	0	0	206533	0	10	40213160		
62126	5170	40236446	1979-12-25	1979-12-25 00:00:00	1987-01-02	1987-01-02 00:00:00	1987-01-02	38000177		0	0	2565		0	0	0	343765	0	1091392	40236446		
128541	2827	40213227	1992-11-10	1992-11-10 00:00:00	1992-11-10	1992-11-10 00:00:00	1992-11-10	581452		0	0	0		0	0	0	187530	0	113	40213227		
19331	421	40213296	2007-06-27	2007-06-27 00:00:00	2007-06-27	2007-06-27 00:00:00	2007-06-27	581452		0	0	0		0	0	0	27875	0	52	40213296		
6760	569	19075601	1998-05-30	1998-05-30 00:00:00	1998-05-30	1998-05-30 00:00:00	1998-05-30	38000177		0	0	0		0	0	0	37721	0	309362	19075601		
242598	5325	40213227	2007-01-07	2007-01-07 00:00:00	2007-01-07	2007-01-07 00:00:00	2007-01-07	581452		0	0	0		0	0	0	354476	0	113	40213227		
25901	565	40213227	2018-09-26	2018-09-26 00:00:00	2018-09-26	2018-09-26 00:00:00	2018-09-26	581452		0	0	0		0	0	0	37404	0	113	40213227		
148434	3263	40213198	2010-07-27	2010-07-27 00:00:00	2010-07-27	2010-07-27 00:00:00	2010-07-27	581452		0	0	0		0	0	0	216887	0	133	40213198		
57777	4800	19078461	1989-07-27	1989-07-27 00:00:00	1989-10-25	1989-10-25 00:00:00	1989-10-25	38000177		0	0	90		0	0	0	319296	0	310965	19078461		
52720	4382	19133905	1984-12-22	1984-12-22 00:00:00	1985-01-02	1985-01-02 00:00:00	1985-01-02	38000177		0	0	11		0	0	0	291251	0	834102	19133905		
56870	4720	1118084	2014-01-27	2014-01-27 00:00:00	2014-01-27	2014-01-27 00:00:00	\N	38000177		0	0	0		0	0	0	314372	0	00025152531	44923712		
204069	4480	40213227	1992-12-22	1992-12-22 00:00:00	1992-12-22	1992-12-22 00:00:00	1992-12-22	581452		0	0	0		0	0	0	298169	0	113	40213227		
175755	3864	40213227	2016-04-16	2016-04-16 00:00:00	2016-04-16	2016-04-16 00:00:00	2016-04-16	581452		0	0	0		0	0	0	256507	0	113	40213227		
12211	1024	1127433	1971-03-15	1971-03-15 00:00:00	1971-03-29	1971-03-29 00:00:00	1971-03-29	38000177		0	0	14		0	0	0	67468	0	313782	1127433		
56018	4649	1127078	1970-02-05	1970-02-05 00:00:00	1970-02-19	1970-02-19 00:00:00	1970-02-19	38000177		0	0	14		0	0	0	310013	0	282464	1127078		
48846	1070	40213227	2014-11-13	2014-11-13 00:00:00	2014-11-13	2014-11-13 00:00:00	2014-11-13	581452		0	0	0		0	0	0	70052	0	113	40213227		
115767	2543	40213160	1965-03-28	1965-03-28 00:00:00	1965-03-28	1965-03-28 00:00:00	1965-03-28	581452		0	0	0		0	0	0	168283	0	10	40213160		
114802	2522	40213160	1958-12-19	1958-12-19 00:00:00	1958-12-19	1958-12-19 00:00:00	1958-12-19	581452		0	0	0		0	0	0	166823	0	10	40213160		
25800	2122	19078461	1992-03-12	1992-03-12 00:00:00	1992-03-26	1992-03-26 00:00:00	1992-03-26	38000177		0	0	14		0	0	0	141215	0	310965	19078461		
51931	1136	40213160	1971-08-21	1971-08-21 00:00:00	1971-08-21	1971-08-21 00:00:00	1971-08-21	581452		0	0	0		0	0	0	74848	0	10	40213160		
8257	689	40224805	1997-02-12	1997-02-12 00:00:00	1998-02-07	1998-02-07 00:00:00	1998-02-07	38000177		0	0	360		0	0	0	45696	0	1000126	40224805		
121892	2679	40213314	1977-03-11	1977-03-11 00:00:00	1977-03-11	1977-03-11 00:00:00	1977-03-11	581452		0	0	0		0	0	0	177482	0	49	40213314		
86886	1905	40213227	2018-01-26	2018-01-26 00:00:00	2018-01-26	2018-01-26 00:00:00	2018-01-26	581452		0	0	0		0	0	0	126839	0	113	40213227		
11840	987	1127433	1984-01-13	1984-01-13 00:00:00	1984-01-20	1984-01-20 00:00:00	1984-01-20	38000177		0	0	7		0	0	0	65584	0	313782	1127433		
27673	2290	40229134	1998-06-19	1998-06-19 00:00:00	1998-07-03	1998-07-03 00:00:00	1998-07-03	38000177		0	0	14		0	0	0	152316	0	1043400	40229134		
215171	4719	40213227	1996-08-11	1996-08-11 00:00:00	1996-08-11	1996-08-11 00:00:00	1996-08-11	581452		0	0	0		0	0	0	314243	0	113	40213227		
191916	4217	40213160	1958-11-19	1958-11-19 00:00:00	1958-11-19	1958-11-19 00:00:00	1958-11-19	581452		0	0	0		0	0	0	280009	0	10	40213160		
29514	2443	1713671	1989-09-19	1989-09-19 00:00:00	1989-10-03	1989-10-03 00:00:00	1989-10-03	38000177		0	0	14		0	0	0	162039	0	562251	1713671		
197401	4338	40213227	2007-07-21	2007-07-21 00:00:00	2007-07-21	2007-07-21 00:00:00	2007-07-21	581452		0	0	0		0	0	0	287703	0	113	40213227		
52797	1155	40213160	1966-05-30	1966-05-30 00:00:00	1966-05-30	1966-05-30 00:00:00	1966-05-30	581452		0	0	0		0	0	0	76378	0	10	40213160		
19234	1588	19128065	1982-10-20	1982-10-20 00:00:00	1983-10-15	1983-10-15 00:00:00	1983-10-15	38000177		0	0	360		0	0	0	106591	0	749882	19128065		
51164	4250	1124300	1982-05-13	1982-05-13 00:00:00	1982-05-13	1982-05-13 00:00:00	\N	38000177		0	0	0		0	0	0	282260	0	00781178901	45011828		
75770	1656	40213160	1982-11-06	1982-11-06 00:00:00	1982-11-06	1982-11-06 00:00:00	1982-11-06	581452		0	0	0		0	0	0	111091	0	10	40213160		
68129	1491	40213296	2008-11-11	2008-11-11 00:00:00	2008-11-11	2008-11-11 00:00:00	2008-11-11	581452		0	0	0		0	0	0	99421	0	52	40213296		
60781	1328	40213201	2012-03-22	2012-03-22 00:00:00	2012-03-22	2012-03-22 00:00:00	2012-03-22	581452		0	0	0		0	0	0	88214	0	33	40213201		
146703	3226	40213227	2010-07-11	2010-07-11 00:00:00	2010-07-11	2010-07-11 00:00:00	2010-07-11	581452		0	0	0		0	0	0	214453	0	113	40213227		
122334	2688	40213296	2002-11-24	2002-11-24 00:00:00	2002-11-24	2002-11-24 00:00:00	2002-11-24	581452		0	0	0		0	0	0	178158	0	52	40213296		
117535	2583	40213160	1970-11-23	1970-11-23 00:00:00	1970-11-23	1970-11-23 00:00:00	1970-11-23	581452		0	0	0		0	0	0	171040	0	10	40213160		
122399	2690	40213160	1955-09-22	1955-09-22 00:00:00	1955-09-22	1955-09-22 00:00:00	1955-09-22	581452		0	0	0		0	0	0	178214	0	10	40213160		
79337	1736	40213260	2019-05-09	2019-05-09 00:00:00	2019-05-09	2019-05-09 00:00:00	2019-05-09	581452		0	0	0		0	0	0	115914	0	121	40213260		
42412	924	40213296	2007-01-13	2007-01-13 00:00:00	2007-01-13	2007-01-13 00:00:00	2007-01-13	581452		0	0	0		0	0	0	61515	0	52	40213296		
174068	3827	40213160	1957-05-03	1957-05-03 00:00:00	1957-05-03	1957-05-03 00:00:00	1957-05-03	581452		0	0	0		0	0	0	254179	0	10	40213160		
17975	390	40213314	1977-01-12	1977-01-12 00:00:00	1977-01-12	1977-01-12 00:00:00	1977-01-12	581452		0	0	0		0	0	0	25641	0	49	40213314		
36863	3049	1127433	1997-09-05	1997-09-05 00:00:00	1997-09-12	1997-09-12 00:00:00	1997-09-12	38000177		0	0	7		0	0	0	202848	0	313782	1127433		
55817	4633	19018935	2009-12-01	2009-12-01 00:00:00	2009-12-01	2009-12-01 00:00:00	\N	38000177		0	0	0		0	0	0	308816	0	197604	19018935		
45122	3734	1713671	1991-12-14	1991-12-14 00:00:00	1992-01-04	1992-01-04 00:00:00	1992-01-04	38000177		0	0	21		0	0	0	248128	0	562251	1713671		
28269	2334	40220960	2016-11-17	2016-11-17 00:00:00	2016-11-17	2016-11-17 00:00:00	2016-11-17	38000177		0	0	0		0	0	0	155347	0	1804799	40220960		
9020	753	19059056	1970-12-07	1970-12-07 00:00:00	1970-12-21	1970-12-21 00:00:00	1970-12-21	38000177		0	0	14		0	0	0	49776	0	243670	19059056		
113954	2504	40213227	2005-04-25	2005-04-25 00:00:00	2005-04-25	2005-04-25 00:00:00	2005-04-25	581452		0	0	0		0	0	0	165850	0	113	40213227		
103589	2272	40213314	1980-05-10	1980-05-10 00:00:00	1980-05-10	1980-05-10 00:00:00	1980-05-10	581452		0	0	0		0	0	0	151032	0	49	40213314		
192931	4238	40213260	2012-09-06	2012-09-06 00:00:00	2012-09-06	2012-09-06 00:00:00	2012-09-06	581452		0	0	0		0	0	0	281427	0	121	40213260		
160538	3533	40213260	2012-12-05	2012-12-05 00:00:00	2012-12-05	2012-12-05 00:00:00	2012-12-05	581452		0	0	0		0	0	0	234704	0	121	40213260		
163335	3593	40213160	1956-02-22	1956-02-22 00:00:00	1956-02-22	1956-02-22 00:00:00	1956-02-22	581452		0	0	0		0	0	0	238706	0	10	40213160		
3654	300	19128065	1991-02-23	1991-02-23 00:00:00	1992-02-18	1992-02-18 00:00:00	1992-02-18	38000177		0	0	360		0	0	0	20077	0	749882	19128065		
213838	4689	40213160	1967-10-18	1967-10-18 00:00:00	1967-10-18	1967-10-18 00:00:00	1967-10-18	581452		0	0	0		0	0	0	312412	0	10	40213160		
18457	1528	1127433	1970-05-12	1970-05-12 00:00:00	1970-05-26	1970-05-26 00:00:00	1970-05-26	38000177		0	0	14		0	0	0	102210	0	313782	1127433		
46005	1004	40213160	1963-06-20	1963-06-20 00:00:00	1963-06-20	1963-06-20 00:00:00	1963-06-20	581452		0	0	0		0	0	0	66362	0	10	40213160		
60076	1314	40213227	2001-11-17	2001-11-17 00:00:00	2001-11-17	2001-11-17 00:00:00	2001-11-17	581452		0	0	0		0	0	0	87000	0	113	40213227		
95037	2084	40213227	2003-10-29	2003-10-29 00:00:00	2003-10-29	2003-10-29 00:00:00	2003-10-29	581452		0	0	0		0	0	0	138859	0	113	40213227		
69657	1523	40213260	2007-04-17	2007-04-17 00:00:00	2007-04-17	2007-04-17 00:00:00	2007-04-17	581452		0	0	0		0	0	0	101862	0	121	40213260		
210837	4623	40213201	1995-10-31	1995-10-31 00:00:00	1995-10-31	1995-10-31 00:00:00	1995-10-31	581452		0	0	0		0	0	0	307920	0	33	40213201		
43078	3570	19006318	1953-03-14	1953-03-14 00:00:00	1953-03-28	1953-03-28 00:00:00	1953-03-28	38000177		0	0	14		0	0	0	237274	0	105078	19006318		
141282	3103	40213251	1984-06-06	1984-06-06 00:00:00	1984-06-06	1984-06-06 00:00:00	1984-06-06	581452		0	0	0		0	0	0	206411	0	21	40213251		
117827	2590	40213160	1963-01-22	1963-01-22 00:00:00	1963-01-22	1963-01-22 00:00:00	1963-01-22	581452		0	0	0		0	0	0	171421	0	10	40213160		
141396	3106	40213201	2017-01-30	2017-01-30 00:00:00	2017-01-30	2017-01-30 00:00:00	2017-01-30	581452		0	0	0		0	0	0	206585	0	33	40213201		
62127	5170	46233988	1973-09-02	1973-09-02 00:00:00	1973-09-16	1973-09-16 00:00:00	1973-09-16	38000177		0	0	14		0	0	0	343767	0	1652673	46233988		
128547	2827	40213201	1987-04-21	1987-04-21 00:00:00	1987-04-21	1987-04-21 00:00:00	1987-04-21	581452		0	0	0		0	0	0	187527	0	33	40213201		
189419	4159	40213227	2018-01-20	2018-01-20 00:00:00	2018-01-20	2018-01-20 00:00:00	2018-01-20	581452		0	0	0		0	0	0	276319	0	113	40213227		
6761	569	19133873	1922-01-07	1922-01-07 00:00:00	1922-01-18	1922-01-18 00:00:00	1922-01-18	38000177		0	0	11		0	0	0	37690	0	834061	19133873		
214066	4694	40213314	1982-10-17	1982-10-17 00:00:00	1982-10-17	1982-10-17 00:00:00	1982-10-17	581452		0	0	0		0	0	0	312662	0	49	40213314		
25903	565	40213296	1997-08-13	1997-08-13 00:00:00	1997-08-13	1997-08-13 00:00:00	1997-08-13	581452		0	0	0		0	0	0	37399	0	52	40213296		
148450	3263	40213227	2006-07-04	2006-07-04 00:00:00	2006-07-04	2006-07-04 00:00:00	2006-07-04	581452		0	0	0		0	0	0	216896	0	113	40213227		
57778	4800	1127433	2001-01-28	2001-01-28 00:00:00	2001-02-04	2001-02-04 00:00:00	2001-02-04	38000177		0	0	7		0	0	0	319299	0	313782	1127433		
52721	4382	1127433	1985-12-18	1985-12-18 00:00:00	1986-01-01	1986-01-01 00:00:00	1986-01-01	38000177		0	0	14		0	0	0	291169	0	313782	1127433		
56871	4720	19128022	1995-05-26	1995-05-26 00:00:00	1996-05-20	1996-05-20 00:00:00	1996-05-20	38000177		0	0	360		0	0	0	314393	0	749785	19128022		
204072	4480	40213160	1961-10-10	1961-10-10 00:00:00	1961-10-10	1961-10-10 00:00:00	1961-10-10	581452		0	0	0		0	0	0	298193	0	10	40213160		
175757	3864	40213260	2016-04-16	2016-04-16 00:00:00	2016-04-16	2016-04-16 00:00:00	2016-04-16	581452		0	0	0		0	0	0	256507	0	121	40213260		
12212	1024	1713671	1987-11-13	1987-11-13 00:00:00	1987-11-27	1987-11-27 00:00:00	1987-11-27	38000177		0	0	14		0	0	0	67443	0	562251	1713671		
56019	4649	40236824	2015-03-09	2015-03-09 00:00:00	2015-03-16	2015-03-16 00:00:00	2015-03-16	38000177		0	0	7		0	0	0	\N	0	1094107	40236824		
48847	1070	40213296	2014-11-13	2014-11-13 00:00:00	2014-11-13	2014-11-13 00:00:00	2014-11-13	581452		0	0	0		0	0	0	70052	0	52	40213296		
115772	2543	40213227	2006-10-29	2006-10-29 00:00:00	2006-10-29	2006-10-29 00:00:00	2006-10-29	581452		0	0	0		0	0	0	168275	0	113	40213227		
114809	2522	40213306	1982-11-12	1982-11-12 00:00:00	1982-11-12	1982-11-12 00:00:00	1982-11-12	581452		0	0	0		0	0	0	166854	0	43	40213306		
25801	2122	1118084	2013-08-01	2013-08-01 00:00:00	2013-08-01	2013-08-01 00:00:00	\N	38000177		0	0	0		0	0	0	141191	0	00025152531	44923712		
138412	3040	40213227	1993-12-16	1993-12-16 00:00:00	1993-12-16	1993-12-16 00:00:00	1993-12-16	581452		0	0	0		0	0	0	202396	0	113	40213227		
8258	689	19128022	2004-01-07	2004-01-07 00:00:00	2005-01-01	2005-01-01 00:00:00	2005-01-01	38000177		0	0	360		0	0	0	45676	0	749785	19128022		
121899	2679	40213160	1972-09-08	1972-09-08 00:00:00	1972-09-08	1972-09-08 00:00:00	1972-09-08	581452		0	0	0		0	0	0	177510	0	10	40213160		
86891	1905	40213160	1966-05-27	1966-05-27 00:00:00	1966-05-27	1966-05-27 00:00:00	1966-05-27	581452		0	0	0		0	0	0	126844	0	10	40213160		
11841	987	40173590	2013-10-27	2013-10-27 00:00:00	2013-10-27	2013-10-27 00:00:00	\N	38000177		0	0	0		0	0	0	65571	0	904419	40173590		
27674	2290	19059056	1969-01-24	1969-01-24 00:00:00	1969-02-23	1969-02-23 00:00:00	1969-02-23	38000177		0	0	30		0	0	0	152340	0	243670	19059056		
155440	3420	40213160	1965-01-05	1965-01-05 00:00:00	1965-01-05	1965-01-05 00:00:00	1965-01-05	581452		0	0	0		0	0	0	226917	0	10	40213160		
191917	4217	40213227	2010-04-14	2010-04-14 00:00:00	2010-04-14	2010-04-14 00:00:00	2010-04-14	581452		0	0	0		0	0	0	280002	0	113	40213227		
29515	2443	19133873	1975-06-04	1975-06-04 00:00:00	1975-06-17	1975-06-17 00:00:00	1975-06-17	38000177		0	0	13		0	0	0	162087	0	834061	19133873		
197404	4338	40213227	2016-07-16	2016-07-16 00:00:00	2016-07-16	2016-07-16 00:00:00	2016-07-16	581452		0	0	0		0	0	0	287662	0	113	40213227		
52802	1155	40213296	2007-10-29	2007-10-29 00:00:00	2007-10-29	2007-10-29 00:00:00	2007-10-29	581452		0	0	0		0	0	0	76385	0	52	40213296		
19235	1588	1127078	1961-08-31	1961-08-31 00:00:00	1961-09-14	1961-09-14 00:00:00	1961-09-14	38000177		0	0	14		0	0	0	106619	0	282464	1127078		
51165	4250	1127433	1980-07-03	1980-07-03 00:00:00	1980-07-10	1980-07-10 00:00:00	1980-07-10	38000177		0	0	7		0	0	0	282287	0	313782	1127433		
75771	1656	40213314	1979-02-03	1979-02-03 00:00:00	1979-02-03	1979-02-03 00:00:00	1979-02-03	581452		0	0	0		0	0	0	111139	0	49	40213314		
68132	1491	40213306	1991-02-12	1991-02-12 00:00:00	1991-02-12	1991-02-12 00:00:00	1991-02-12	581452		0	0	0		0	0	0	99445	0	43	40213306		
15931	343	40213227	2012-02-11	2012-02-11 00:00:00	2012-02-11	2012-02-11 00:00:00	2012-02-11	581452		0	0	0		0	0	0	22952	0	113	40213227		
146704	3226	40213296	2010-07-11	2010-07-11 00:00:00	2010-07-11	2010-07-11 00:00:00	2010-07-11	581452		0	0	0		0	0	0	214453	0	52	40213296		
122344	2688	40213227	1994-01-23	1994-01-23 00:00:00	1994-01-23	1994-01-23 00:00:00	1994-01-23	581452		0	0	0		0	0	0	178137	0	113	40213227		
117542	2583	40213227	2012-06-25	2012-06-25 00:00:00	2012-06-25	2012-06-25 00:00:00	2012-06-25	581452		0	0	0		0	0	0	171056	0	113	40213227		
122402	2690	40213227	1999-10-07	1999-10-07 00:00:00	1999-10-07	1999-10-07 00:00:00	1999-10-07	581452		0	0	0		0	0	0	178236	0	113	40213227		
79338	1736	40213160	1969-10-16	1969-10-16 00:00:00	1969-10-16	1969-10-16 00:00:00	1969-10-16	581452		0	0	0		0	0	0	115923	0	10	40213160		
42417	924	40213160	1964-03-07	1964-03-07 00:00:00	1964-03-07	1964-03-07 00:00:00	1964-03-07	581452		0	0	0		0	0	0	61520	0	10	40213160		
174072	3827	40213260	2007-11-30	2007-11-30 00:00:00	2007-11-30	2007-11-30 00:00:00	2007-11-30	581452		0	0	0		0	0	0	254216	0	121	40213260		
17978	390	40213227	2007-09-05	2007-09-05 00:00:00	2007-09-05	2007-09-05 00:00:00	2007-09-05	581452		0	0	0		0	0	0	25649	0	113	40213227		
36864	3049	1539411	1991-05-31	1991-05-31 00:00:00	1991-05-31	1991-05-31 00:00:00	\N	38000177		0	0	0		0	0	0	202842	0	312961	1539411		
55818	4633	40163554	2009-12-01	2009-12-01 00:00:00	2009-12-01	2009-12-01 00:00:00	\N	38000177		0	0	0		0	0	0	308816	0	855332	40163554		
45123	3734	1127433	1952-11-04	1952-11-04 00:00:00	1952-11-18	1952-11-18 00:00:00	1952-11-18	38000177		0	0	14		0	0	0	248094	0	313782	1127433		
28270	2334	19075601	2016-11-17	2016-11-17 00:00:00	2016-11-17	2016-11-17 00:00:00	2016-11-17	38000177		0	0	0		0	0	0	155347	0	309362	19075601		
9021	753	19129655	1970-12-07	1970-12-07 00:00:00	1970-12-21	1970-12-21 00:00:00	1970-12-21	38000177		0	0	14		0	0	0	49776	0	789980	19129655		
113957	2504	40213296	1997-11-10	1997-11-10 00:00:00	1997-11-10	1997-11-10 00:00:00	1997-11-10	581452		0	0	0		0	0	0	165776	0	52	40213296		
103598	2273	40213160	1988-09-28	1988-09-28 00:00:00	1988-09-28	1988-09-28 00:00:00	1988-09-28	581452		0	0	0		0	0	0	151123	0	10	40213160		
131175	2883	40213296	2007-04-18	2007-04-18 00:00:00	2007-04-18	2007-04-18 00:00:00	2007-04-18	581452		0	0	0		0	0	0	191765	0	52	40213296		
160541	3533	40213227	2012-12-05	2012-12-05 00:00:00	2012-12-05	2012-12-05 00:00:00	2012-12-05	581452		0	0	0		0	0	0	234704	0	113	40213227		
163336	3593	40213160	1957-02-27	1957-02-27 00:00:00	1957-02-27	1957-02-27 00:00:00	1957-02-27	581452		0	0	0		0	0	0	238654	0	10	40213160		
52294	1144	40213227	2012-07-22	2012-07-22 00:00:00	2012-07-22	2012-07-22 00:00:00	2012-07-22	581452		0	0	0		0	0	0	75483	0	113	40213227		
213841	4689	40213260	2018-05-16	2018-05-16 00:00:00	2018-05-16	2018-05-16 00:00:00	2018-05-16	581452		0	0	0		0	0	0	312403	0	121	40213260		
18458	1528	1118084	2001-11-14	2001-11-14 00:00:00	2001-11-14	2001-11-14 00:00:00	\N	38000177		0	0	0		0	0	0	102257	0	00025152531	44923712		
46009	1004	40213227	2013-12-05	2013-12-05 00:00:00	2013-12-05	2013-12-05 00:00:00	2013-12-05	581452		0	0	0		0	0	0	66354	0	113	40213227		
146822	3229	40213251	1984-05-18	1984-05-18 00:00:00	1984-05-18	1984-05-18 00:00:00	1984-05-18	581452		0	0	0		0	0	0	214613	0	21	40213251		
95038	2084	40213296	2003-10-29	2003-10-29 00:00:00	2003-10-29	2003-10-29 00:00:00	2003-10-29	581452		0	0	0		0	0	0	138859	0	52	40213296		
69658	1523	40213160	1961-03-21	1961-03-21 00:00:00	1961-03-21	1961-03-21 00:00:00	1961-03-21	581452		0	0	0		0	0	0	101891	0	10	40213160		
222140	4876	40213227	1994-12-31	1994-12-31 00:00:00	1994-12-31	1994-12-31 00:00:00	1994-12-31	581452		0	0	0		0	0	0	324277	0	113	40213227		
43079	3570	19059056	1950-09-26	1950-09-26 00:00:00	1950-10-31	1950-10-31 00:00:00	1950-10-31	38000177		0	0	35		0	0	0	237223	0	243670	19059056		
141285	3103	40213296	2017-07-05	2017-07-05 00:00:00	2017-07-05	2017-07-05 00:00:00	2017-07-05	581452		0	0	0		0	0	0	206438	0	52	40213296		
117830	2590	40213260	2012-10-16	2012-10-16 00:00:00	2012-10-16	2012-10-16 00:00:00	2012-10-16	581452		0	0	0		0	0	0	171402	0	121	40213260		
155194	3415	40213160	1966-04-16	1966-04-16 00:00:00	1966-04-16	1966-04-16 00:00:00	1966-04-16	581452		0	0	0		0	0	0	226504	0	10	40213160		
62128	5170	1127078	1973-09-02	1973-09-02 00:00:00	1973-09-16	1973-09-16 00:00:00	1973-09-16	38000177		0	0	14		0	0	0	343767	0	282464	1127078		
209073	4586	40213296	1999-01-24	1999-01-24 00:00:00	1999-01-24	1999-01-24 00:00:00	1999-01-24	581452		0	0	0		0	0	0	305458	0	52	40213296		
189421	4159	40213160	1956-07-07	1956-07-07 00:00:00	1956-07-07	1956-07-07 00:00:00	1956-07-07	581452		0	0	0		0	0	0	276387	0	10	40213160		
6762	569	40236824	1941-07-06	1941-07-06 00:00:00	1941-07-13	1941-07-13 00:00:00	1941-07-13	38000177		0	0	7		0	0	0	37582	0	1094107	40236824		
214069	4694	40213227	2013-03-17	2013-03-17 00:00:00	2013-03-17	2013-03-17 00:00:00	2013-03-17	581452		0	0	0		0	0	0	312701	0	113	40213227		
25910	565	40213227	1999-08-18	1999-08-18 00:00:00	1999-08-18	1999-08-18 00:00:00	1999-08-18	581452		0	0	0		0	0	0	37457	0	113	40213227		
87390	1917	40213160	1955-06-19	1955-06-19 00:00:00	1955-06-19	1955-06-19 00:00:00	1955-06-19	581452		0	0	0		0	0	0	127568	0	10	40213160		
57779	4800	19059056	1978-11-30	1978-11-30 00:00:00	1979-02-28	1979-02-28 00:00:00	1979-02-28	38000177		0	0	90		0	0	0	319293	0	243670	19059056		
52722	4382	1115171	2017-03-03	2017-03-03 00:00:00	2017-03-17	2017-03-17 00:00:00	2017-03-17	38000177		0	0	14		0	0	0	291175	0	849574	1115171		
56872	4720	19133873	1979-12-28	1979-12-28 00:00:00	1980-01-04	1980-01-04 00:00:00	1980-01-04	38000177		0	0	7		0	0	0	314401	0	834061	19133873		
204074	4480	40213296	2003-02-11	2003-02-11 00:00:00	2003-02-11	2003-02-11 00:00:00	2003-02-11	581452		0	0	0		0	0	0	298182	0	52	40213296		
175764	3864	40213227	2007-06-09	2007-06-09 00:00:00	2007-06-09	2007-06-09 00:00:00	2007-06-09	581452		0	0	0		0	0	0	256497	0	113	40213227		
12213	1024	1127433	1982-03-17	1982-03-17 00:00:00	1982-03-31	1982-03-31 00:00:00	1982-03-31	38000177		0	0	14		0	0	0	67438	0	313782	1127433		
56020	4649	1713671	1982-05-10	1982-05-10 00:00:00	1982-05-31	1982-05-31 00:00:00	1982-05-31	38000177		0	0	21		0	0	0	309993	0	562251	1713671		
48855	1070	40213296	2012-11-08	2012-11-08 00:00:00	2012-11-08	2012-11-08 00:00:00	2012-11-08	581452		0	0	0		0	0	0	70059	0	52	40213296		
115773	2543	40213296	2006-10-29	2006-10-29 00:00:00	2006-10-29	2006-10-29 00:00:00	2006-10-29	581452		0	0	0		0	0	0	168275	0	52	40213296		
114810	2522	40213160	1958-10-17	1958-10-17 00:00:00	1958-10-17	1958-10-17 00:00:00	1958-10-17	581452		0	0	0		0	0	0	166810	0	10	40213160		
25802	2122	19019979	1978-08-25	1978-08-25 00:00:00	1978-09-08	1978-09-08 00:00:00	1978-09-08	38000177		0	0	14		0	0	0	141176	0	198405	19019979		
138413	3040	40213306	1993-12-16	1993-12-16 00:00:00	1993-12-16	1993-12-16 00:00:00	1993-12-16	581452		0	0	0		0	0	0	202396	0	43	40213306		
8259	689	1118084	2017-08-01	2017-08-01 00:00:00	2017-08-01	2017-08-01 00:00:00	\N	38000177		0	0	0		0	0	0	45615	0	00025152531	44923712		
195293	4289	40213227	2013-11-10	2013-11-10 00:00:00	2013-11-10	2013-11-10 00:00:00	2013-11-10	581452		0	0	0		0	0	0	284818	0	113	40213227		
86893	1905	40213160	1966-07-29	1966-07-29 00:00:00	1966-07-29	1966-07-29 00:00:00	1966-07-29	581452		0	0	0		0	0	0	126793	0	10	40213160		
11842	987	1127433	2002-10-27	2002-10-27 00:00:00	2003-01-25	2003-01-25 00:00:00	2003-01-25	38000177		0	0	90		0	0	0	65523	0	313782	1127433		
27675	2290	1127433	1998-09-03	1998-09-03 00:00:00	1998-09-17	1998-09-17 00:00:00	1998-09-17	38000177		0	0	14		0	0	0	152338	0	313782	1127433		
155446	3420	40213227	2015-10-06	2015-10-06 00:00:00	2015-10-06	2015-10-06 00:00:00	2015-10-06	581452		0	0	0		0	0	0	226857	0	113	40213227		
191918	4217	40213260	2010-04-14	2010-04-14 00:00:00	2010-04-14	2010-04-14 00:00:00	2010-04-14	581452		0	0	0		0	0	0	280002	0	121	40213260		
29516	2443	19133873	1962-12-25	1962-12-25 00:00:00	1963-01-04	1963-01-04 00:00:00	1963-01-04	38000177		0	0	10		0	0	0	162085	0	834061	19133873		
197405	4338	40213260	2016-07-16	2016-07-16 00:00:00	2016-07-16	2016-07-16 00:00:00	2016-07-16	581452		0	0	0		0	0	0	287662	0	121	40213260		
216637	4754	40213306	1987-07-28	1987-07-28 00:00:00	1987-07-28	1987-07-28 00:00:00	1987-07-28	581452		0	0	0		0	0	0	316605	0	43	40213306		
19236	1588	19129655	1961-08-31	1961-08-31 00:00:00	1961-09-14	1961-09-14 00:00:00	1961-09-14	38000177		0	0	14		0	0	0	106619	0	789980	19129655		
51166	4250	19078461	2000-06-24	2000-06-24 00:00:00	2000-07-24	2000-07-24 00:00:00	2000-07-24	38000177		0	0	30		0	0	0	282263	0	310965	19078461		
75776	1656	40213227	2000-05-20	2000-05-20 00:00:00	2000-05-20	2000-05-20 00:00:00	2000-05-20	581452		0	0	0		0	0	0	111095	0	113	40213227		
68134	1491	40213227	2000-02-22	2000-02-22 00:00:00	2000-02-22	2000-02-22 00:00:00	2000-02-22	581452		0	0	0		0	0	0	99448	0	113	40213227		
29873	2476	1127433	1971-04-08	1971-04-08 00:00:00	1971-04-22	1971-04-22 00:00:00	1971-04-22	38000177		0	0	14		0	0	0	164100	0	313782	1127433		
146709	3226	40213306	1991-03-17	1991-03-17 00:00:00	1991-03-17	1991-03-17 00:00:00	1991-03-17	581452		0	0	0		0	0	0	214460	0	43	40213306		
214653	4707	40213227	2005-08-11	2005-08-11 00:00:00	2005-08-11	2005-08-11 00:00:00	2005-08-11	581452		0	0	0		0	0	0	313606	0	113	40213227		
117543	2583	40213296	2012-06-25	2012-06-25 00:00:00	2012-06-25	2012-06-25 00:00:00	2012-06-25	581452		0	0	0		0	0	0	171056	0	52	40213296		
122413	2690	40213227	1992-10-15	1992-10-15 00:00:00	1992-10-15	1992-10-15 00:00:00	1992-10-15	581452		0	0	0		0	0	0	178217	0	113	40213227		
79342	1736	40213160	1969-08-14	1969-08-14 00:00:00	1969-08-14	1969-08-14 00:00:00	1969-08-14	581452		0	0	0		0	0	0	115905	0	10	40213160		
104871	2300	40213160	1955-01-06	1955-01-06 00:00:00	1955-01-06	1955-01-06 00:00:00	1955-01-06	581452		0	0	0		0	0	0	153174	0	10	40213160		
174074	3827	40213227	2007-11-30	2007-11-30 00:00:00	2007-11-30	2007-11-30 00:00:00	2007-11-30	581452		0	0	0		0	0	0	254216	0	113	40213227		
17988	390	40213314	1977-07-13	1977-07-13 00:00:00	1977-07-13	1977-07-13 00:00:00	1977-07-13	581452		0	0	0		0	0	0	25625	0	49	40213314		
36865	3049	1332419	1994-11-25	1994-11-25 00:00:00	1994-11-25	1994-11-25 00:00:00	\N	38000177		0	0	0		0	0	0	202870	0	197361	1332419		
55819	4633	40171902	2009-12-01	2009-12-01 00:00:00	2009-12-01	2009-12-01 00:00:00	\N	38000177		0	0	0		0	0	0	308816	0	897718	40171902		
45124	3734	1713671	1960-05-09	1960-05-09 00:00:00	1960-05-23	1960-05-23 00:00:00	1960-05-23	38000177		0	0	14		0	0	0	248123	0	562251	1713671		
28271	2334	1124300	1971-07-05	1971-07-05 00:00:00	1971-07-05	1971-07-05 00:00:00	\N	38000177		0	0	0		0	0	0	155333	0	00781178901	45011828		
9022	753	40229134	1999-11-30	1999-11-30 00:00:00	1999-12-14	1999-12-14 00:00:00	1999-12-14	38000177		0	0	14		0	0	0	49796	0	1043400	40229134		
214338	4700	40213227	1992-11-03	1992-11-03 00:00:00	1992-11-03	1992-11-03 00:00:00	1992-11-03	581452		0	0	0		0	0	0	313104	0	113	40213227		
103599	2273	40213251	1988-09-28	1988-09-28 00:00:00	1988-09-28	1988-09-28 00:00:00	1988-09-28	581452		0	0	0		0	0	0	151123	0	21	40213251		
131176	2883	40213160	1964-08-05	1964-08-05 00:00:00	1964-08-05	1964-08-05 00:00:00	1964-08-05	581452		0	0	0		0	0	0	191776	0	10	40213160		
160544	3533	40213227	2004-06-09	2004-06-09 00:00:00	2004-06-09	2004-06-09 00:00:00	2004-06-09	581452		0	0	0		0	0	0	234674	0	113	40213227		
163341	3593	40213227	1994-03-30	1994-03-30 00:00:00	1994-03-30	1994-03-30 00:00:00	1994-03-30	581452		0	0	0		0	0	0	238647	0	113	40213227		
52295	1144	40213296	2012-07-22	2012-07-22 00:00:00	2012-07-22	2012-07-22 00:00:00	2012-07-22	581452		0	0	0		0	0	0	75483	0	52	40213296		
213842	4689	40213227	2018-05-16	2018-05-16 00:00:00	2018-05-16	2018-05-16 00:00:00	2018-05-16	581452		0	0	0		0	0	0	312403	0	113	40213227		
18459	1528	1127433	2004-05-26	2004-05-26 00:00:00	2004-06-09	2004-06-09 00:00:00	2004-06-09	38000177		0	0	14		0	0	0	102240	0	313782	1127433		
46010	1004	40213260	2013-12-05	2013-12-05 00:00:00	2013-12-05	2013-12-05 00:00:00	2013-12-05	581452		0	0	0		0	0	0	66354	0	121	40213260		
146823	3229	40213160	1984-05-18	1984-05-18 00:00:00	1984-05-18	1984-05-18 00:00:00	1984-05-18	581452		0	0	0		0	0	0	214613	0	10	40213160		
95042	2084	40213227	2013-11-27	2013-11-27 00:00:00	2013-11-27	2013-11-27 00:00:00	2013-11-27	581452		0	0	0		0	0	0	138861	0	113	40213227		
69672	1523	40213260	2006-04-11	2006-04-11 00:00:00	2006-04-11	2006-04-11 00:00:00	2006-04-11	581452		0	0	0		0	0	0	101846	0	121	40213260		
222143	4876	40213160	1972-10-28	1972-10-28 00:00:00	1972-10-28	1972-10-28 00:00:00	1972-10-28	581452		0	0	0		0	0	0	324267	0	10	40213160		
43080	3570	1127433	1952-04-19	1952-04-19 00:00:00	1952-04-26	1952-04-26 00:00:00	1952-04-26	38000177		0	0	7		0	0	0	237264	0	313782	1127433		
141288	3103	40213314	1977-09-21	1977-09-21 00:00:00	1977-09-21	1977-09-21 00:00:00	1977-09-21	581452		0	0	0		0	0	0	206421	0	49	40213314		
117845	2590	40213227	1993-12-28	1993-12-28 00:00:00	1993-12-28	1993-12-28 00:00:00	1993-12-28	581452		0	0	0		0	0	0	171385	0	113	40213227		
155196	3415	40213260	2016-08-13	2016-08-13 00:00:00	2016-08-13	2016-08-13 00:00:00	2016-08-13	581452		0	0	0		0	0	0	226542	0	121	40213260		
62129	5170	1127433	1983-04-02	1983-04-02 00:00:00	1983-07-01	1983-07-01 00:00:00	1983-07-01	38000177		0	0	90		0	0	0	343736	0	313782	1127433		
209074	4586	40213160	1957-04-07	1957-04-07 00:00:00	1957-04-07	1957-04-07 00:00:00	1957-04-07	581452		0	0	0		0	0	0	305509	0	10	40213160		
189423	4159	40213160	1956-05-05	1956-05-05 00:00:00	1956-05-05	1956-05-05 00:00:00	1956-05-05	581452		0	0	0		0	0	0	276353	0	10	40213160		
6763	569	920300	1941-07-06	1941-07-06 00:00:00	1941-07-13	1941-07-13 00:00:00	1941-07-13	38000177		0	0	7		0	0	0	37582	0	311989	920300		
214071	4694	40213251	1986-07-20	1986-07-20 00:00:00	1986-07-20	1986-07-20 00:00:00	1986-07-20	581452		0	0	0		0	0	0	312664	0	21	40213251		
25911	565	40213296	1999-08-18	1999-08-18 00:00:00	1999-08-18	1999-08-18 00:00:00	1999-08-18	581452		0	0	0		0	0	0	37457	0	52	40213296		
87406	1918	40213296	2012-06-09	2012-06-09 00:00:00	2012-06-09	2012-06-09 00:00:00	2012-06-09	581452		0	0	0		0	0	0	127611	0	52	40213296		
57780	4800	1127433	2005-11-29	2005-11-29 00:00:00	2005-12-27	2005-12-27 00:00:00	2005-12-27	38000177		0	0	28		0	0	0	319297	0	313782	1127433		
52723	4382	19128065	1976-11-03	1976-11-03 00:00:00	1977-10-29	1977-10-29 00:00:00	1977-10-29	38000177		0	0	360		0	0	0	291242	0	749882	19128065		
56873	4720	1127433	1977-11-22	1977-11-22 00:00:00	1977-11-29	1977-11-29 00:00:00	1977-11-29	38000177		0	0	7		0	0	0	314406	0	313782	1127433		
241423	5300	40213201	2007-03-30	2007-03-30 00:00:00	2007-03-30	2007-03-30 00:00:00	2007-03-30	581452		0	0	0		0	0	0	352598	0	33	40213201		
175765	3864	40213296	2007-06-09	2007-06-09 00:00:00	2007-06-09	2007-06-09 00:00:00	2007-06-09	581452		0	0	0		0	0	0	256497	0	52	40213296		
12214	1024	1118084	1983-01-05	1983-01-05 00:00:00	1983-01-05	1983-01-05 00:00:00	\N	38000177		0	0	0		0	0	0	67438	0	00025152531	44923712		
56021	4649	920300	2015-03-09	2015-03-09 00:00:00	2015-03-16	2015-03-16 00:00:00	2015-03-16	38000177		0	0	7		0	0	0	\N	0	311989	920300		
48857	1070	40213160	1973-04-12	1973-04-12 00:00:00	1973-04-12	1973-04-12 00:00:00	1973-04-12	581452		0	0	0		0	0	0	70082	0	10	40213160		
50769	1112	40213227	2004-11-28	2004-11-28 00:00:00	2004-11-28	2004-11-28 00:00:00	2004-11-28	581452		0	0	0		0	0	0	73202	0	113	40213227		
114820	2522	40213160	1959-03-20	1959-03-20 00:00:00	1959-03-20	1959-03-20 00:00:00	1959-03-20	581452		0	0	0		0	0	0	166811	0	10	40213160		
25803	2122	46233988	1978-08-25	1978-08-25 00:00:00	1978-09-08	1978-09-08 00:00:00	1978-09-08	38000177		0	0	14		0	0	0	141176	0	1652673	46233988		
138420	3040	40213314	1977-02-10	1977-02-10 00:00:00	1977-02-10	1977-02-10 00:00:00	1977-02-10	581452		0	0	0		0	0	0	202406	0	49	40213314		
8260	689	19128065	1999-02-02	1999-02-02 00:00:00	2000-01-28	2000-01-28 00:00:00	2000-01-28	38000177		0	0	360		0	0	0	45649	0	749882	19128065		
195304	4289	40213201	2008-10-12	2008-10-12 00:00:00	2008-10-12	2008-10-12 00:00:00	2008-10-12	581452		0	0	0		0	0	0	284830	0	33	40213201		
86895	1905	40213227	1999-12-17	1999-12-17 00:00:00	1999-12-17	1999-12-17 00:00:00	1999-12-17	581452		0	0	0		0	0	0	126803	0	113	40213227		
11844	987	40229134	1991-10-01	1991-10-01 00:00:00	1991-10-15	1991-10-15 00:00:00	1991-10-15	38000177		0	0	14		0	0	0	65600	0	1043400	40229134		
27676	2291	40236824	2010-10-26	2010-10-26 00:00:00	2010-11-02	2010-11-02 00:00:00	2010-11-02	38000177		0	0	7		0	0	0	152547	0	1094107	40236824		
155447	3420	40213260	2015-10-06	2015-10-06 00:00:00	2015-10-06	2015-10-06 00:00:00	2015-10-06	581452		0	0	0		0	0	0	226857	0	121	40213260		
191933	4217	40213227	1992-03-04	1992-03-04 00:00:00	1992-03-04	1992-03-04 00:00:00	1992-03-04	581452		0	0	0		0	0	0	280016	0	113	40213227		
29517	2443	1127433	1979-10-26	1979-10-26 00:00:00	1979-12-24	1979-12-24 00:00:00	1979-12-24	38000177		0	0	59		0	0	0	162034	0	313782	1127433		
197407	4338	40213227	1996-09-28	1996-09-28 00:00:00	1996-09-28	1996-09-28 00:00:00	1996-09-28	581452		0	0	0		0	0	0	287698	0	113	40213227		
216640	4754	40213260	2014-10-21	2014-10-21 00:00:00	2014-10-21	2014-10-21 00:00:00	2014-10-21	581452		0	0	0		0	0	0	316611	0	121	40213260		
19237	1588	1127433	1984-10-01	1984-10-01 00:00:00	1984-10-15	1984-10-15 00:00:00	1984-10-15	38000177		0	0	14		0	0	0	106633	0	313782	1127433		
51167	4250	19133873	1947-07-22	1947-07-22 00:00:00	1947-07-31	1947-07-31 00:00:00	1947-07-31	38000177		0	0	9		0	0	0	282332	0	834061	19133873		
75777	1656	40213306	2000-05-20	2000-05-20 00:00:00	2000-05-20	2000-05-20 00:00:00	2000-05-20	581452		0	0	0		0	0	0	111095	0	43	40213306		
68139	1491	40213160	1969-02-11	1969-02-11 00:00:00	1969-02-11	1969-02-11 00:00:00	1969-02-11	581452		0	0	0		0	0	0	99426	0	10	40213160		
29874	2476	1127433	1970-02-27	1970-02-27 00:00:00	1970-03-20	1970-03-20 00:00:00	1970-03-20	38000177		0	0	21		0	0	0	164116	0	313782	1127433		
146722	3226	40213296	2012-07-15	2012-07-15 00:00:00	2012-07-15	2012-07-15 00:00:00	2012-07-15	581452		0	0	0		0	0	0	214475	0	52	40213296		
214655	4707	40213314	1977-08-11	1977-08-11 00:00:00	1977-08-11	1977-08-11 00:00:00	1977-08-11	581452		0	0	0		0	0	0	313598	0	49	40213314		
117548	2583	40213227	1992-11-30	1992-11-30 00:00:00	1992-11-30	1992-11-30 00:00:00	1992-11-30	581452		0	0	0		0	0	0	171013	0	113	40213227		
133714	2936	40213296	2004-06-12	2004-06-12 00:00:00	2004-06-12	2004-06-12 00:00:00	2004-06-12	581452		0	0	0		0	0	0	195778	0	52	40213296		
158558	3490	40213201	2012-01-20	2012-01-20 00:00:00	2012-01-20	2012-01-20 00:00:00	2012-01-20	581452		0	0	0		0	0	0	231528	0	33	40213201		
132817	2917	40213227	2018-02-21	2018-02-21 00:00:00	2018-02-21	2018-02-21 00:00:00	2018-02-21	581452		0	0	0		0	0	0	194444	0	113	40213227		
177157	3893	40213306	1994-07-15	1994-07-15 00:00:00	1994-07-15	1994-07-15 00:00:00	1994-07-15	581452		0	0	0		0	0	0	\N	0	43	40213306		
88975	1951	40213306	2003-04-16	2003-04-16 00:00:00	2003-04-16	2003-04-16 00:00:00	2003-04-16	581452		0	0	0		0	0	0	\N	0	43	40213306		
36866	3049	1310034	1991-07-12	1991-07-12 00:00:00	1991-07-12	1991-07-12 00:00:00	1991-07-12	38000177		0	0	0		0	0	0	202875	0	834357	1310034		
55820	4633	1127433	1961-08-12	1961-08-12 00:00:00	1961-08-26	1961-08-26 00:00:00	1961-08-26	38000177		0	0	14		0	0	0	308746	0	313782	1127433		
45125	3734	1115171	2006-07-11	2006-07-11 00:00:00	2006-08-10	2006-08-10 00:00:00	2006-08-10	38000177		0	0	30		0	0	0	248174	0	849574	1115171		
28272	2334	1713671	1973-11-25	1973-11-25 00:00:00	1973-12-02	1973-12-02 00:00:00	1973-12-02	38000177		0	0	7		0	0	0	155305	0	562251	1713671		
9023	753	1713671	2006-09-23	2006-09-23 00:00:00	2006-09-30	2006-09-30 00:00:00	2006-09-30	38000177		0	0	7		0	0	0	49745	0	562251	1713671		
214344	4700	40213201	2018-03-13	2018-03-13 00:00:00	2018-03-13	2018-03-13 00:00:00	2018-03-13	581452		0	0	0		0	0	0	313120	0	33	40213201		
103600	2273	40213314	1984-12-26	1984-12-26 00:00:00	1984-12-26	1984-12-26 00:00:00	1984-12-26	581452		0	0	0		0	0	0	151120	0	49	40213314		
131177	2883	40213160	1964-06-03	1964-06-03 00:00:00	1964-06-03	1964-06-03 00:00:00	1964-06-03	581452		0	0	0		0	0	0	191771	0	10	40213160		
160545	3533	40213296	2004-06-09	2004-06-09 00:00:00	2004-06-09	2004-06-09 00:00:00	2004-06-09	581452		0	0	0		0	0	0	234674	0	52	40213296		
163346	3593	40213296	1996-04-03	1996-04-03 00:00:00	1996-04-03	1996-04-03 00:00:00	1996-04-03	581452		0	0	0		0	0	0	238711	0	52	40213296		
52296	1144	40213160	1971-02-14	1971-02-14 00:00:00	1971-02-14	1971-02-14 00:00:00	1971-02-14	581452		0	0	0		0	0	0	75530	0	10	40213160		
211576	4639	40213306	1992-04-24	1992-04-24 00:00:00	1992-04-24	1992-04-24 00:00:00	1992-04-24	581452		0	0	0		0	0	0	309242	0	43	40213306		
18460	1528	1115171	2007-02-24	2007-02-24 00:00:00	2007-05-25	2007-05-25 00:00:00	2007-05-25	38000177		0	0	90		0	0	0	102241	0	849574	1115171		
46016	1004	40213160	1967-09-21	1967-09-21 00:00:00	1967-09-21	1967-09-21 00:00:00	1967-09-21	581452		0	0	0		0	0	0	66389	0	10	40213160		
146830	3229	40213160	1980-02-15	1980-02-15 00:00:00	1980-02-15	1980-02-15 00:00:00	1980-02-15	581452		0	0	0		0	0	0	214624	0	10	40213160		
95043	2084	40213260	2013-11-27	2013-11-27 00:00:00	2013-11-27	2013-11-27 00:00:00	2013-11-27	581452		0	0	0		0	0	0	138861	0	121	40213260		
69677	1523	40213160	1956-12-18	1956-12-18 00:00:00	1956-12-18	1956-12-18 00:00:00	1956-12-18	581452		0	0	0		0	0	0	101827	0	10	40213160		
222144	4876	40213314	1977-04-30	1977-04-30 00:00:00	1977-04-30	1977-04-30 00:00:00	1977-04-30	581452		0	0	0		0	0	0	324269	0	49	40213314		
43081	3570	19133905	1968-03-09	1968-03-09 00:00:00	1968-03-21	1968-03-21 00:00:00	1968-03-21	38000177		0	0	12		0	0	0	237288	0	834102	19133905		
141289	3103	40213160	1977-09-21	1977-09-21 00:00:00	1977-09-21	1977-09-21 00:00:00	1977-09-21	581452		0	0	0		0	0	0	206421	0	10	40213160		
117847	2590	40213227	2013-10-22	2013-10-22 00:00:00	2013-10-22	2013-10-22 00:00:00	2013-10-22	581452		0	0	0		0	0	0	171378	0	113	40213227		
155198	3415	40213227	2016-08-13	2016-08-13 00:00:00	2016-08-13	2016-08-13 00:00:00	2016-08-13	581452		0	0	0		0	0	0	226542	0	113	40213227		
62130	5170	1118084	2004-12-08	2004-12-08 00:00:00	2004-12-08	2004-12-08 00:00:00	\N	38000177		0	0	0		0	0	0	343795	0	00025152531	44923712		
209089	4586	40213160	1957-02-03	1957-02-03 00:00:00	1957-02-03	1957-02-03 00:00:00	1957-02-03	581452		0	0	0		0	0	0	305489	0	10	40213160		
189425	4159	40213227	2007-11-24	2007-11-24 00:00:00	2007-11-24	2007-11-24 00:00:00	2007-11-24	581452		0	0	0		0	0	0	276359	0	113	40213227		
6764	569	1713671	2014-11-02	2014-11-02 00:00:00	2014-11-16	2014-11-16 00:00:00	2014-11-16	38000177		0	0	14		0	0	0	37591	0	562251	1713671		
214074	4694	40213160	1986-07-20	1986-07-20 00:00:00	1986-07-20	1986-07-20 00:00:00	1986-07-20	581452		0	0	0		0	0	0	312664	0	10	40213160		
98187	2150	40213160	1955-01-07	1955-01-07 00:00:00	1955-01-07	1955-01-07 00:00:00	1955-01-07	581452		0	0	0		0	0	0	\N	0	10	40213160		
87410	1918	40213160	1969-04-19	1969-04-19 00:00:00	1969-04-19	1969-04-19 00:00:00	1969-04-19	581452		0	0	0		0	0	0	127597	0	10	40213160		
57781	4800	1127433	1973-06-17	1973-06-17 00:00:00	1973-07-01	1973-07-01 00:00:00	1973-07-01	38000177		0	0	14		0	0	0	319327	0	313782	1127433		
52725	4382	40229134	1967-01-22	1967-01-22 00:00:00	1967-01-29	1967-01-29 00:00:00	1967-01-29	38000177		0	0	7		0	0	0	291178	0	1043400	40229134		
56874	4720	40229134	1993-03-12	1993-03-12 00:00:00	1993-03-26	1993-03-26 00:00:00	1993-03-26	38000177		0	0	14		0	0	0	314403	0	1043400	40229134		
241433	5300	40213227	2012-07-20	2012-07-20 00:00:00	2012-07-20	2012-07-20 00:00:00	2012-07-20	581452		0	0	0		0	0	0	352586	0	113	40213227		
175766	3864	40213160	1965-09-18	1965-09-18 00:00:00	1965-09-18	1965-09-18 00:00:00	1965-09-18	581452		0	0	0		0	0	0	256530	0	10	40213160		
12215	1024	1127433	1991-10-10	1991-10-10 00:00:00	1991-10-31	1991-10-31 00:00:00	1991-10-31	38000177		0	0	21		0	0	0	67439	0	313782	1127433		
56022	4649	1124300	2003-05-28	2003-05-28 00:00:00	2003-05-28	2003-05-28 00:00:00	\N	38000177		0	0	0		0	0	0	309991	0	00781178901	45011828		
48859	1070	40213227	2004-02-26	2004-02-26 00:00:00	2004-02-26	2004-02-26 00:00:00	2004-02-26	581452		0	0	0		0	0	0	70057	0	113	40213227		
50770	1112	40213296	2004-11-28	2004-11-28 00:00:00	2004-11-28	2004-11-28 00:00:00	2004-11-28	581452		0	0	0		0	0	0	73202	0	52	40213296		
114825	2522	40213260	2008-12-26	2008-12-26 00:00:00	2008-12-26	2008-12-26 00:00:00	2008-12-26	581452		0	0	0		0	0	0	166828	0	121	40213260		
25804	2122	1127433	1998-04-15	1998-04-15 00:00:00	1998-04-29	1998-04-29 00:00:00	1998-04-29	38000177		0	0	14		0	0	0	141217	0	313782	1127433		
138422	3040	40213160	1977-02-10	1977-02-10 00:00:00	1977-02-10	1977-02-10 00:00:00	1977-02-10	581452		0	0	0		0	0	0	202406	0	10	40213160		
8261	689	1713671	2005-08-07	2005-08-07 00:00:00	2005-11-20	2005-11-20 00:00:00	2005-11-20	38000177		0	0	105		0	0	0	45679	0	562251	1713671		
33732	736	40213160	1972-06-15	1972-06-15 00:00:00	1972-06-15	1972-06-15 00:00:00	1972-06-15	581452		0	0	0		0	0	0	48806	0	10	40213160		
86899	1905	40213306	1986-02-28	1986-02-28 00:00:00	1986-02-28	1986-02-28 00:00:00	1986-02-28	581452		0	0	0		0	0	0	126800	0	43	40213306		
11845	987	19128065	1974-07-21	1974-07-21 00:00:00	1975-07-16	1975-07-16 00:00:00	1975-07-16	38000177		0	0	360		0	0	0	65604	0	749882	19128065		
27677	2291	920300	2010-10-26	2010-10-26 00:00:00	2010-11-02	2010-11-02 00:00:00	2010-11-02	38000177		0	0	7		0	0	0	152547	0	311989	920300		
87970	1929	40213160	1955-04-28	1955-04-28 00:00:00	1955-04-28	1955-04-28 00:00:00	1955-04-28	581452		0	0	0		0	0	0	128427	0	10	40213160		
191935	4217	40213160	1959-01-21	1959-01-21 00:00:00	1959-01-21	1959-01-21 00:00:00	1959-01-21	581452		0	0	0		0	0	0	279982	0	10	40213160		
29518	2443	40231925	1979-10-26	1979-10-26 00:00:00	1979-10-26	1979-10-26 00:00:00	\N	38000177		0	0	0		0	0	0	162034	0	1049221	40231925		
197409	4338	40213160	1970-06-20	1970-06-20 00:00:00	1970-06-20	1970-06-20 00:00:00	1970-06-20	581452		0	0	0		0	0	0	287649	0	10	40213160		
216641	4754	40213160	1965-03-30	1965-03-30 00:00:00	1965-03-30	1965-03-30 00:00:00	1965-03-30	581452		0	0	0		0	0	0	316597	0	10	40213160		
19238	1588	19128065	1984-10-09	1984-10-09 00:00:00	1985-10-04	1985-10-04 00:00:00	1985-10-04	38000177		0	0	360		0	0	0	106593	0	749882	19128065		
51168	4250	19059056	1949-01-11	1949-01-11 00:00:00	1949-01-25	1949-01-25 00:00:00	1949-01-25	38000177		0	0	14		0	0	0	282261	0	243670	19059056		
75779	1656	40213251	1984-11-17	1984-11-17 00:00:00	1984-11-17	1984-11-17 00:00:00	1984-11-17	581452		0	0	0		0	0	0	111092	0	21	40213251		
68147	1491	40213160	1969-07-15	1969-07-15 00:00:00	1969-07-15	1969-07-15 00:00:00	1969-07-15	581452		0	0	0		0	0	0	99427	0	10	40213160		
29875	2476	1713671	2000-01-18	2000-01-18 00:00:00	2000-02-08	2000-02-08 00:00:00	2000-02-08	38000177		0	0	21		0	0	0	164072	0	562251	1713671		
146725	3226	40213160	1973-07-22	1973-07-22 00:00:00	1973-07-22	1973-07-22 00:00:00	1973-07-22	581452		0	0	0		0	0	0	214490	0	10	40213160		
214661	4707	40213296	2013-09-12	2013-09-12 00:00:00	2013-09-12	2013-09-12 00:00:00	2013-09-12	581452		0	0	0		0	0	0	313610	0	52	40213296		
117549	2583	40213306	1992-11-30	1992-11-30 00:00:00	1992-11-30	1992-11-30 00:00:00	1992-11-30	581452		0	0	0		0	0	0	171013	0	43	40213306		
214746	4709	40213160	1956-08-13	1956-08-13 00:00:00	1956-08-13	1956-08-13 00:00:00	1956-08-13	581452		0	0	0		0	0	0	313638	0	10	40213160		
158561	3490	40213227	2006-11-17	2006-11-17 00:00:00	2006-11-17	2006-11-17 00:00:00	2006-11-17	581452		0	0	0		0	0	0	231539	0	113	40213227		
144096	3167	40213296	2003-12-07	2003-12-07 00:00:00	2003-12-07	2003-12-07 00:00:00	2003-12-07	581452		0	0	0		0	0	0	210546	0	52	40213296		
177159	3893	40213227	1994-07-15	1994-07-15 00:00:00	1994-07-15	1994-07-15 00:00:00	1994-07-15	581452		0	0	0		0	0	0	\N	0	113	40213227		
88977	1951	40213227	2003-04-16	2003-04-16 00:00:00	2003-04-16	2003-04-16 00:00:00	2003-04-16	581452		0	0	0		0	0	0	\N	0	113	40213227		
162777	3579	40213306	1987-01-03	1987-01-03 00:00:00	1987-01-03	1987-01-03 00:00:00	1987-01-03	581452		0	0	0		0	0	0	237940	0	43	40213306		
55821	4633	1713671	1975-06-20	1975-06-20 00:00:00	1975-08-29	1975-08-29 00:00:00	1975-08-29	38000177		0	0	70		0	0	0	308802	0	562251	1713671		
45126	3734	1127433	1957-03-07	1957-03-07 00:00:00	1957-03-14	1957-03-14 00:00:00	1957-03-14	38000177		0	0	7		0	0	0	248095	0	313782	1127433		
28273	2334	1127433	1942-09-26	1942-09-26 00:00:00	1942-10-10	1942-10-10 00:00:00	1942-10-10	38000177		0	0	14		0	0	0	155313	0	313782	1127433		
9024	753	1713671	2019-01-21	2019-01-21 00:00:00	2019-02-04	2019-02-04 00:00:00	2019-02-04	38000177		0	0	14		0	0	0	49815	0	562251	1713671		
214352	4700	40213160	1955-04-26	1955-04-26 00:00:00	1955-04-26	1955-04-26 00:00:00	1955-04-26	581452		0	0	0		0	0	0	313061	0	10	40213160		
103601	2273	40213251	1984-12-26	1984-12-26 00:00:00	1984-12-26	1984-12-26 00:00:00	1984-12-26	581452		0	0	0		0	0	0	151120	0	21	40213251		
131186	2883	40213227	1997-04-02	1997-04-02 00:00:00	1997-04-02	1997-04-02 00:00:00	1997-04-02	581452		0	0	0		0	0	0	191757	0	113	40213227		
160551	3533	40213160	1962-08-08	1962-08-08 00:00:00	1962-08-08	1962-08-08 00:00:00	1962-08-08	581452		0	0	0		0	0	0	234682	0	10	40213160		
163349	3593	40213160	1955-02-23	1955-02-23 00:00:00	1955-02-23	1955-02-23 00:00:00	1955-02-23	581452		0	0	0		0	0	0	238723	0	10	40213160		
52301	1144	40213160	1975-03-23	1975-03-23 00:00:00	1975-03-23	1975-03-23 00:00:00	1975-03-23	581452		0	0	0		0	0	0	75522	0	10	40213160		
211577	4639	40213296	2012-03-02	2012-03-02 00:00:00	2012-03-02	2012-03-02 00:00:00	2012-03-02	581452		0	0	0		0	0	0	309222	0	52	40213296		
18461	1528	1713671	2018-10-14	2018-10-14 00:00:00	2018-10-28	2018-10-28 00:00:00	2018-10-28	38000177		0	0	14		0	0	0	102287	0	562251	1713671		
46018	1004	40213227	1996-01-04	1996-01-04 00:00:00	1996-01-04	1996-01-04 00:00:00	1996-01-04	581452		0	0	0		0	0	0	66395	0	113	40213227		
146833	3229	40213314	1979-09-14	1979-09-14 00:00:00	1979-09-14	1979-09-14 00:00:00	1979-09-14	581452		0	0	0		0	0	0	214623	0	49	40213314		
95046	2084	40213227	1993-12-22	1993-12-22 00:00:00	1993-12-22	1993-12-22 00:00:00	1993-12-22	581452		0	0	0		0	0	0	138821	0	113	40213227		
69681	1523	40213227	2017-06-13	2017-06-13 00:00:00	2017-06-13	2017-06-13 00:00:00	2017-06-13	581452		0	0	0		0	0	0	101849	0	113	40213227		
222146	4876	40213160	1977-04-30	1977-04-30 00:00:00	1977-04-30	1977-04-30 00:00:00	1977-04-30	581452		0	0	0		0	0	0	324269	0	10	40213160		
43082	3570	1118084	1988-06-08	1988-06-08 00:00:00	1988-06-08	1988-06-08 00:00:00	\N	38000177		0	0	0		0	0	0	237290	0	00025152531	44923712		
141296	3103	40213227	1999-12-28	1999-12-28 00:00:00	1999-12-28	1999-12-28 00:00:00	1999-12-28	581452		0	0	0		0	0	0	206428	0	113	40213227		
117848	2590	40213260	2013-10-22	2013-10-22 00:00:00	2013-10-22	2013-10-22 00:00:00	2013-10-22	581452		0	0	0		0	0	0	171378	0	121	40213260		
155202	3415	40213160	1970-07-18	1970-07-18 00:00:00	1970-07-18	1970-07-18 00:00:00	1970-07-18	581452		0	0	0		0	0	0	226556	0	10	40213160		
62131	5170	1713671	1988-09-26	1988-09-26 00:00:00	1988-10-10	1988-10-10 00:00:00	1988-10-10	38000177		0	0	14		0	0	0	343772	0	562251	1713671		
209093	4586	40213160	1961-10-08	1961-10-08 00:00:00	1961-10-08	1961-10-08 00:00:00	1961-10-08	581452		0	0	0		0	0	0	305474	0	10	40213160		
189426	4159	40213260	2007-11-24	2007-11-24 00:00:00	2007-11-24	2007-11-24 00:00:00	2007-11-24	581452		0	0	0		0	0	0	276359	0	121	40213260		
6765	569	19059056	1949-02-08	1949-02-08 00:00:00	1949-03-01	1949-03-01 00:00:00	1949-03-01	38000177		0	0	21		0	0	0	37661	0	243670	19059056		
214079	4694	40213227	2004-03-07	2004-03-07 00:00:00	2004-03-07	2004-03-07 00:00:00	2004-03-07	581452		0	0	0		0	0	0	312698	0	113	40213227		
98195	2150	40213227	2011-03-25	2011-03-25 00:00:00	2011-03-25	2011-03-25 00:00:00	2011-03-25	581452		0	0	0		0	0	0	143222	0	113	40213227		
87412	1918	40213227	2010-06-05	2010-06-05 00:00:00	2010-06-05	2010-06-05 00:00:00	2010-06-05	581452		0	0	0		0	0	0	127582	0	113	40213227		
57782	4800	1127433	1985-10-16	1985-10-16 00:00:00	1985-11-14	1985-11-14 00:00:00	1985-11-14	38000177		0	0	29		0	0	0	319295	0	313782	1127433		
52726	4382	1115171	2000-06-16	2000-06-16 00:00:00	2000-06-30	2000-06-30 00:00:00	2000-06-30	38000177		0	0	14		0	0	0	291171	0	849574	1115171		
56875	4720	1127433	1976-08-15	1976-08-15 00:00:00	1976-08-29	1976-08-29 00:00:00	1976-08-29	38000177		0	0	14		0	0	0	314400	0	313782	1127433		
241443	5300	40213227	2002-03-01	2002-03-01 00:00:00	2002-03-01	2002-03-01 00:00:00	2002-03-01	581452		0	0	0		0	0	0	352650	0	113	40213227		
175769	3864	40213160	1965-07-17	1965-07-17 00:00:00	1965-07-17	1965-07-17 00:00:00	1965-07-17	581452		0	0	0		0	0	0	256511	0	10	40213160		
12216	1024	19126352	2016-05-29	2016-05-29 00:00:00	2016-05-29	2016-05-29 00:00:00	\N	38000177		0	0	0		0	0	0	67432	0	705129	19126352		
56023	4649	1127433	2002-07-31	2002-07-31 00:00:00	2002-09-04	2002-09-04 00:00:00	2002-09-04	38000177		0	0	35		0	0	0	309991	0	313782	1127433		
60155	1316	40213227	1993-03-02	1993-03-02 00:00:00	1993-03-02	1993-03-02 00:00:00	1993-03-02	581452		0	0	0		0	0	0	87201	0	113	40213227		
50772	1112	40213306	1985-12-29	1985-12-29 00:00:00	1985-12-29	1985-12-29 00:00:00	1985-12-29	581452		0	0	0		0	0	0	73179	0	43	40213306		
114828	2522	40213296	2001-12-07	2001-12-07 00:00:00	2001-12-07	2001-12-07 00:00:00	2001-12-07	581452		0	0	0		0	0	0	166843	0	52	40213296		
25805	2123	1127433	2018-08-27	2018-08-27 00:00:00	2018-09-10	2018-09-10 00:00:00	2018-09-10	38000177		0	0	14		0	0	0	141315	0	313782	1127433		
138423	3040	40213160	1972-08-03	1972-08-03 00:00:00	1972-08-03	1972-08-03 00:00:00	1972-08-03	581452		0	0	0		0	0	0	202418	0	10	40213160		
8262	689	1127078	1983-08-15	1983-08-15 00:00:00	1983-08-29	1983-08-29 00:00:00	1983-08-29	38000177		0	0	14		0	0	0	45616	0	282464	1127078		
33734	736	40213160	1976-08-19	1976-08-19 00:00:00	1976-08-19	1976-08-19 00:00:00	1976-08-19	581452		0	0	0		0	0	0	\N	0	10	40213160		
86902	1905	40213306	1989-03-03	1989-03-03 00:00:00	1989-03-03	1989-03-03 00:00:00	1989-03-03	581452		0	0	0		0	0	0	126801	0	43	40213306		
11846	987	19059056	1954-06-26	1954-06-26 00:00:00	1954-07-10	1954-07-10 00:00:00	1954-07-10	38000177		0	0	14		0	0	0	65537	0	243670	19059056		
27678	2291	19128065	1987-08-03	1987-08-03 00:00:00	1988-07-28	1988-07-28 00:00:00	1988-07-28	38000177		0	0	360		0	0	0	152549	0	749882	19128065		
185977	4086	40213160	1973-03-07	1973-03-07 00:00:00	1973-03-07	1973-03-07 00:00:00	1973-03-07	581452		0	0	0		0	0	0	271601	0	10	40213160		
229509	5044	40213296	2014-11-26	2014-11-26 00:00:00	2014-11-26	2014-11-26 00:00:00	2014-11-26	581452		0	0	0		0	0	0	335183	0	52	40213296		
29519	2443	1127433	2009-09-05	2009-09-05 00:00:00	2009-09-12	2009-09-12 00:00:00	2009-09-12	38000177		0	0	7		0	0	0	162044	0	313782	1127433		
197414	4338	40213296	2005-07-16	2005-07-16 00:00:00	2005-07-16	2005-07-16 00:00:00	2005-07-16	581452		0	0	0		0	0	0	287701	0	52	40213296		
216642	4754	40213296	2007-07-03	2007-07-03 00:00:00	2007-07-03	2007-07-03 00:00:00	2007-07-03	581452		0	0	0		0	0	0	316610	0	52	40213296		
19239	1588	1713671	1989-11-01	1989-11-01 00:00:00	1989-11-22	1989-11-22 00:00:00	1989-11-22	38000177		0	0	21		0	0	0	106611	0	562251	1713671		
51169	4250	920334	1964-04-05	1964-04-05 00:00:00	1964-04-12	1964-04-12 00:00:00	1964-04-12	38000177		0	0	7		0	0	0	282336	0	311995	920334		
75787	1656	40213296	2018-01-27	2018-01-27 00:00:00	2018-01-27	2018-01-27 00:00:00	2018-01-27	581452		0	0	0		0	0	0	111097	0	52	40213296		
68150	1491	40213160	1969-04-15	1969-04-15 00:00:00	1969-04-15	1969-04-15 00:00:00	1969-04-15	581452		0	0	0		0	0	0	99460	0	10	40213160		
29876	2476	40229134	2010-06-30	2010-06-30 00:00:00	2010-07-07	2010-07-07 00:00:00	2010-07-07	38000177		0	0	7		0	0	0	164063	0	1043400	40229134		
146728	3226	40213227	2000-03-26	2000-03-26 00:00:00	2000-03-26	2000-03-26 00:00:00	2000-03-26	581452		0	0	0		0	0	0	214463	0	113	40213227		
214670	4707	40213227	2016-03-31	2016-03-31 00:00:00	2016-03-31	2016-03-31 00:00:00	2016-03-31	581452		0	0	0		0	0	0	313570	0	113	40213227		
117553	2583	40213227	2001-12-10	2001-12-10 00:00:00	2001-12-10	2001-12-10 00:00:00	2001-12-10	581452		0	0	0		0	0	0	171022	0	113	40213227		
214749	4709	40213260	2006-05-08	2006-05-08 00:00:00	2006-05-08	2006-05-08 00:00:00	2006-05-08	581452		0	0	0		0	0	0	313688	0	121	40213260		
158571	3490	40213227	2017-07-28	2017-07-28 00:00:00	2017-07-28	2017-07-28 00:00:00	2017-07-28	581452		0	0	0		0	0	0	231605	0	113	40213227		
144100	3167	40213160	1960-09-11	1960-09-11 00:00:00	1960-09-11	1960-09-11 00:00:00	1960-09-11	581452		0	0	0		0	0	0	210535	0	10	40213160		
177162	3893	40213160	1972-01-21	1972-01-21 00:00:00	1972-01-21	1972-01-21 00:00:00	1972-01-21	581452		0	0	0		0	0	0	258869	0	10	40213160		
88979	1951	40213314	1981-08-19	1981-08-19 00:00:00	1981-08-19	1981-08-19 00:00:00	1981-08-19	581452		0	0	0		0	0	0	129738	0	49	40213314		
162781	3579	40213160	1969-10-11	1969-10-11 00:00:00	1969-10-11	1969-10-11 00:00:00	1969-10-11	581452		0	0	0		0	0	0	237948	0	10	40213160		
55822	4633	1118084	1992-09-07	1992-09-07 00:00:00	1992-09-07	1992-09-07 00:00:00	\N	38000177		0	0	0		0	0	0	308768	0	00025152531	44923712		
45127	3734	40229134	1950-04-10	1950-04-10 00:00:00	1950-04-24	1950-04-24 00:00:00	1950-04-24	38000177		0	0	14		0	0	0	248121	0	1043400	40229134		
28274	2334	19059056	1964-08-14	1964-08-14 00:00:00	1964-10-13	1964-10-13 00:00:00	1964-10-13	38000177		0	0	60		0	0	0	155341	0	243670	19059056		
9025	753	19128065	1985-09-04	1985-09-04 00:00:00	1986-08-30	1986-08-30 00:00:00	1986-08-30	38000177		0	0	360		0	0	0	49748	0	749882	19128065		
214356	4700	40213227	2002-12-03	2002-12-03 00:00:00	2002-12-03	2002-12-03 00:00:00	2002-12-03	581452		0	0	0		0	0	0	313122	0	113	40213227		
103603	2273	40213314	1984-01-25	1984-01-25 00:00:00	1984-01-25	1984-01-25 00:00:00	1984-01-25	581452		0	0	0		0	0	0	151103	0	49	40213314		
131192	2883	40213227	2015-05-13	2015-05-13 00:00:00	2015-05-13	2015-05-13 00:00:00	2015-05-13	581452		0	0	0		0	0	0	191811	0	113	40213227		
160557	3533	40213296	2002-06-05	2002-06-05 00:00:00	2002-06-05	2002-06-05 00:00:00	2002-06-05	581452		0	0	0		0	0	0	234702	0	52	40213296		
163353	3593	40213260	2006-04-12	2006-04-12 00:00:00	2006-04-12	2006-04-12 00:00:00	2006-04-12	581452		0	0	0		0	0	0	238650	0	121	40213260		
52304	1144	40213306	1993-11-28	1993-11-28 00:00:00	1993-11-28	1993-11-28 00:00:00	1993-11-28	581452		0	0	0		0	0	0	75511	0	43	40213306		
128140	2818	40213296	2008-10-27	2008-10-27 00:00:00	2008-10-27	2008-10-27 00:00:00	2008-10-27	581452		0	0	0		0	0	0	186768	0	52	40213296		
18463	1528	19059056	1960-03-04	1960-03-04 00:00:00	1960-03-18	1960-03-18 00:00:00	1960-03-18	38000177		0	0	14		0	0	0	102288	0	243670	19059056		
25180	549	40213160	1956-06-20	1956-06-20 00:00:00	1956-06-20	1956-06-20 00:00:00	1956-06-20	581452		0	0	0		0	0	0	36410	0	10	40213160		
146835	3229	40213160	1979-09-14	1979-09-14 00:00:00	1979-09-14	1979-09-14 00:00:00	1979-09-14	581452		0	0	0		0	0	0	214623	0	10	40213160		
106331	2332	40213160	1961-12-30	1961-12-30 00:00:00	1961-12-30	1961-12-30 00:00:00	1961-12-30	581452		0	0	0		0	0	0	155105	0	10	40213160		
61370	1340	40213227	2002-12-15	2002-12-15 00:00:00	2002-12-15	2002-12-15 00:00:00	2002-12-15	581452		0	0	0		0	0	0	88836	0	113	40213227		
106407	2333	40213201	1987-03-31	1987-03-31 00:00:00	1987-03-31	1987-03-31 00:00:00	1987-03-31	581452		0	0	0		0	0	0	155249	0	33	40213201		
43083	3570	19059056	1961-10-03	1961-10-03 00:00:00	1961-12-02	1961-12-02 00:00:00	1961-12-02	38000177		0	0	60		0	0	0	237224	0	243670	19059056		
141297	3103	40213306	1999-12-28	1999-12-28 00:00:00	1999-12-28	1999-12-28 00:00:00	1999-12-28	581452		0	0	0		0	0	0	206428	0	43	40213306		
117851	2590	40213296	2002-12-17	2002-12-17 00:00:00	2002-12-17	2002-12-17 00:00:00	2002-12-17	581452		0	0	0		0	0	0	171377	0	52	40213296		
220127	4831	40213227	1994-12-29	1994-12-29 00:00:00	1994-12-29	1994-12-29 00:00:00	1994-12-29	581452		0	0	0		0	0	0	321467	0	113	40213227		
62132	5170	19128065	1987-11-28	1987-11-28 00:00:00	1988-11-22	1988-11-22 00:00:00	1988-11-22	38000177		0	0	360		0	0	0	343797	0	749882	19128065		
209096	4586	40213160	1957-07-07	1957-07-07 00:00:00	1957-07-07	1957-07-07 00:00:00	1957-07-07	581452		0	0	0		0	0	0	305490	0	10	40213160		
189429	4159	40213227	1997-02-08	1997-02-08 00:00:00	1997-02-08	1997-02-08 00:00:00	1997-02-08	581452		0	0	0		0	0	0	276315	0	113	40213227		
6766	569	1127433	1912-10-25	1912-10-25 00:00:00	1912-11-01	1912-11-01 00:00:00	1912-11-01	38000177		0	0	7		0	0	0	37689	0	313782	1127433		
214080	4694	40213306	2004-03-07	2004-03-07 00:00:00	2004-03-07	2004-03-07 00:00:00	2004-03-07	581452		0	0	0		0	0	0	312698	0	43	40213306		
98210	2151	40213201	1984-06-20	1984-06-20 00:00:00	1984-06-20	1984-06-20 00:00:00	1984-06-20	581452		0	0	0		0	0	0	143253	0	33	40213201		
87413	1918	40213296	2010-06-05	2010-06-05 00:00:00	2010-06-05	2010-06-05 00:00:00	2010-06-05	581452		0	0	0		0	0	0	127582	0	52	40213296		
57783	4800	40162522	1985-10-16	1985-10-16 00:00:00	1985-10-16	1985-10-16 00:00:00	\N	38000177		0	0	0		0	0	0	319295	0	857005	40162522		
52729	4382	1127433	1968-06-13	1968-06-13 00:00:00	1968-06-20	1968-06-20 00:00:00	1968-06-20	38000177		0	0	7		0	0	0	291180	0	313782	1127433		
56876	4720	19128065	1990-06-12	1990-06-12 00:00:00	1991-06-07	1991-06-07 00:00:00	1991-06-07	38000177		0	0	360		0	0	0	314391	0	749882	19128065		
241463	5300	40213227	1992-01-03	1992-01-03 00:00:00	1992-01-03	1992-01-03 00:00:00	1992-01-03	581452		0	0	0		0	0	0	352594	0	113	40213227		
175770	3864	40213296	2005-06-04	2005-06-04 00:00:00	2005-06-04	2005-06-04 00:00:00	2005-06-04	581452		0	0	0		0	0	0	256489	0	52	40213296		
12217	1024	19075601	2016-05-29	2016-05-29 00:00:00	2016-05-29	2016-05-29 00:00:00	\N	38000177		0	0	0		0	0	0	67432	0	309362	19075601		
56033	4653	1127433	2016-12-17	2016-12-17 00:00:00	2016-12-24	2016-12-24 00:00:00	2016-12-24	38000177		0	0	7		0	0	0	310171	0	313782	1127433		
60160	1316	40213198	2014-05-20	2014-05-20 00:00:00	2014-05-20	2014-05-20 00:00:00	2014-05-20	581452		0	0	0		0	0	0	87214	0	133	40213198		
50775	1112	40213260	2014-12-28	2014-12-28 00:00:00	2014-12-28	2014-12-28 00:00:00	2014-12-28	581452		0	0	0		0	0	0	73203	0	121	40213260		
36110	788	40213227	2001-11-28	2001-11-28 00:00:00	2001-11-28	2001-11-28 00:00:00	2001-11-28	581452		0	0	0		0	0	0	52450	0	113	40213227		
25806	2123	1127078	1959-05-30	1959-05-30 00:00:00	1959-08-28	1959-08-28 00:00:00	1959-08-28	38000177		0	0	90		0	0	0	141317	0	282464	1127078		
138425	3040	40213227	2005-12-29	2005-12-29 00:00:00	2005-12-29	2005-12-29 00:00:00	2005-12-29	581452		0	0	0		0	0	0	202414	0	113	40213227		
8263	689	19073183	1983-08-15	1983-08-15 00:00:00	1983-08-29	1983-08-29 00:00:00	1983-08-29	38000177		0	0	14		0	0	0	45616	0	308182	19073183		
33739	736	40213160	1972-09-14	1972-09-14 00:00:00	1972-09-14	1972-09-14 00:00:00	1972-09-14	581452		0	0	0		0	0	0	48823	0	10	40213160		
97419	2135	40213198	2013-11-25	2013-11-25 00:00:00	2013-11-25	2013-11-25 00:00:00	2013-11-25	581452		0	0	0		0	0	0	142169	0	133	40213198		
11847	987	19006318	1954-06-26	1954-06-26 00:00:00	1954-07-10	1954-07-10 00:00:00	1954-07-10	38000177		0	0	14		0	0	0	65537	0	105078	19006318		
27679	2291	1115171	1998-09-15	1998-09-15 00:00:00	1998-10-13	1998-10-13 00:00:00	1998-10-13	38000177		0	0	28		0	0	0	152487	0	849574	1115171		
205681	4514	40213296	2018-07-13	2018-07-13 00:00:00	2018-07-13	2018-07-13 00:00:00	2018-07-13	581452		0	0	0		0	0	0	300644	0	52	40213296		
229511	5044	40213160	1973-07-25	1973-07-25 00:00:00	1973-07-25	1973-07-25 00:00:00	1973-07-25	581452		0	0	0		0	0	0	335213	0	10	40213160		
29520	2443	19077572	2018-01-25	2018-01-25 00:00:00	2018-01-25	2018-01-25 00:00:00	\N	38000177		0	0	0		0	0	0	162032	0	310436	19077572		
197417	4338	40213160	1965-12-18	1965-12-18 00:00:00	1965-12-18	1965-12-18 00:00:00	1965-12-18	581452		0	0	0		0	0	0	287647	0	10	40213160		
216644	4754	40213227	2007-07-03	2007-07-03 00:00:00	2007-07-03	2007-07-03 00:00:00	2007-07-03	581452		0	0	0		0	0	0	316610	0	113	40213227		
19240	1588	19133873	1975-08-29	1975-08-29 00:00:00	1975-09-09	1975-09-09 00:00:00	1975-09-09	38000177		0	0	11		0	0	0	106643	0	834061	19133873		
51171	4250	40229134	1984-02-22	1984-02-22 00:00:00	1984-03-07	1984-03-07 00:00:00	1984-03-07	38000177		0	0	14		0	0	0	282242	0	1043400	40229134		
75788	1656	40213160	1978-05-06	1978-05-06 00:00:00	1978-05-06	1978-05-06 00:00:00	1978-05-06	581452		0	0	0		0	0	0	111138	0	10	40213160		
110886	2436	40213227	2004-01-10	2004-01-10 00:00:00	2004-01-10	2004-01-10 00:00:00	2004-01-10	581452		0	0	0		0	0	0	161480	0	113	40213227		
29877	2476	1127433	1978-08-05	1978-08-05 00:00:00	1978-08-19	1978-08-19 00:00:00	1978-08-19	38000177		0	0	14		0	0	0	164117	0	313782	1127433		
102920	2258	40213160	1956-07-26	1956-07-26 00:00:00	1956-07-26	1956-07-26 00:00:00	1956-07-26	581452		0	0	0		0	0	0	150081	0	10	40213160		
214674	4707	40213160	1974-05-16	1974-05-16 00:00:00	1974-05-16	1974-05-16 00:00:00	1974-05-16	581452		0	0	0		0	0	0	313558	0	10	40213160		
117559	2583	40213160	1971-02-22	1971-02-22 00:00:00	1971-02-22	1971-02-22 00:00:00	1971-02-22	581452		0	0	0		0	0	0	171063	0	10	40213160		
214752	4709	40213296	1998-05-18	1998-05-18 00:00:00	1998-05-18	1998-05-18 00:00:00	1998-05-18	581452		0	0	0		0	0	0	313657	0	52	40213296		
158577	3490	40213227	1996-09-20	1996-09-20 00:00:00	1996-09-20	1996-09-20 00:00:00	1996-09-20	581452		0	0	0		0	0	0	231569	0	113	40213227		
144109	3167	40213260	2010-12-26	2010-12-26 00:00:00	2010-12-26	2010-12-26 00:00:00	2010-12-26	581452		0	0	0		0	0	0	210568	0	121	40213260		
177168	3893	40213160	1972-06-23	1972-06-23 00:00:00	1972-06-23	1972-06-23 00:00:00	1972-06-23	581452		0	0	0		0	0	0	258870	0	10	40213160		
88980	1951	40213160	1981-08-19	1981-08-19 00:00:00	1981-08-19	1981-08-19 00:00:00	1981-08-19	581452		0	0	0		0	0	0	129738	0	10	40213160		
162782	3579	40213160	1965-02-06	1965-02-06 00:00:00	1965-02-06	1965-02-06 00:00:00	1965-02-06	581452		0	0	0		0	0	0	237909	0	10	40213160		
55823	4633	1713671	1994-02-27	1994-02-27 00:00:00	1994-03-20	1994-03-20 00:00:00	1994-03-20	38000177		0	0	21		0	0	0	308794	0	562251	1713671		
45128	3734	1124300	1986-02-28	1986-02-28 00:00:00	1986-02-28	1986-02-28 00:00:00	\N	38000177		0	0	0		0	0	0	248111	0	00781178901	45011828		
28275	2334	40231925	1964-08-14	1964-08-14 00:00:00	1964-08-14	1964-08-14 00:00:00	\N	38000177		0	0	0		0	0	0	155341	0	1049221	40231925		
9026	753	19128065	1981-09-20	1981-09-20 00:00:00	1982-09-15	1982-09-15 00:00:00	1982-09-15	38000177		0	0	360		0	0	0	49768	0	749882	19128065		
214369	4700	40213160	1956-05-01	1956-05-01 00:00:00	1956-05-01	1956-05-01 00:00:00	1956-05-01	581452		0	0	0		0	0	0	313097	0	10	40213160		
103604	2273	40213160	1984-01-25	1984-01-25 00:00:00	1984-01-25	1984-01-25 00:00:00	1984-01-25	581452		0	0	0		0	0	0	151103	0	10	40213160		
131193	2883	40213260	2014-05-07	2014-05-07 00:00:00	2014-05-07	2014-05-07 00:00:00	2014-05-07	581452		0	0	0		0	0	0	191805	0	121	40213260		
160558	3533	40213227	1993-02-10	1993-02-10 00:00:00	1993-02-10	1993-02-10 00:00:00	1993-02-10	581452		0	0	0		0	0	0	234692	0	113	40213227		
203884	4476	40213306	1985-02-17	1985-02-17 00:00:00	1985-02-17	1985-02-17 00:00:00	1985-02-17	581452		0	0	0		0	0	0	297885	0	43	40213306		
52305	1144	40213227	1992-10-25	1992-10-25 00:00:00	1992-10-25	1992-10-25 00:00:00	1992-10-25	581452		0	0	0		0	0	0	75509	0	113	40213227		
128144	2818	40213227	2010-11-01	2010-11-01 00:00:00	2010-11-01	2010-11-01 00:00:00	2010-11-01	581452		0	0	0		0	0	0	186785	0	113	40213227		
18464	1528	19006318	1960-03-04	1960-03-04 00:00:00	1960-03-18	1960-03-18 00:00:00	1960-03-18	38000177		0	0	14		0	0	0	102288	0	105078	19006318		
25186	549	40213227	2013-08-21	2013-08-21 00:00:00	2013-08-21	2013-08-21 00:00:00	2013-08-21	581452		0	0	0		0	0	0	36437	0	113	40213227		
146839	3229	40213296	2019-06-28	2019-06-28 00:00:00	2019-06-28	2019-06-28 00:00:00	2019-06-28	581452		0	0	0		0	0	0	214607	0	52	40213296		
106333	2332	40213227	2018-06-23	2018-06-23 00:00:00	2018-06-23	2018-06-23 00:00:00	2018-06-23	581452		0	0	0		0	0	0	155060	0	113	40213227		
41929	914	40213201	2011-08-29	2011-08-29 00:00:00	2011-08-29	2011-08-29 00:00:00	2011-08-29	581452		0	0	0		0	0	0	60712	0	33	40213201		
106422	2333	40213227	2001-06-19	2001-06-19 00:00:00	2001-06-19	2001-06-19 00:00:00	2001-06-19	581452		0	0	0		0	0	0	155252	0	113	40213227		
43084	3571	19112599	1975-09-13	1975-09-13 00:00:00	1975-09-13	1975-09-13 00:00:00	\N	38000177		0	0	0		0	0	0	237382	0	477045	19112599		
141300	3103	40213227	2009-01-06	2009-01-06 00:00:00	2009-01-06	2009-01-06 00:00:00	2009-01-06	581452		0	0	0		0	0	0	206435	0	113	40213227		
117853	2591	40213227	2013-03-20	2013-03-20 00:00:00	2013-03-20	2013-03-20 00:00:00	2013-03-20	581452		0	0	0		0	0	0	171525	0	113	40213227		
220132	4831	40213160	1966-04-07	1966-04-07 00:00:00	1966-04-07	1966-04-07 00:00:00	1966-04-07	581452		0	0	0		0	0	0	321456	0	10	40213160		
62133	5170	1127433	2015-12-23	2015-12-23 00:00:00	2016-01-06	2016-01-06 00:00:00	2016-01-06	38000177		0	0	14		0	0	0	343796	0	313782	1127433		
209098	4586	40213227	2007-11-04	2007-11-04 00:00:00	2007-11-04	2007-11-04 00:00:00	2007-11-04	581452		0	0	0		0	0	0	305459	0	113	40213227		
189430	4159	40213296	1997-02-08	1997-02-08 00:00:00	1997-02-08	1997-02-08 00:00:00	1997-02-08	581452		0	0	0		0	0	0	276315	0	52	40213296		
6767	569	19073188	2009-01-29	2009-01-29 00:00:00	2009-02-12	2009-02-12 00:00:00	2009-02-12	38000177		0	0	14		0	0	0	37724	0	308192	19073188		
6803	572	40229134	2008-09-26	2008-09-26 00:00:00	2008-10-10	2008-10-10 00:00:00	2008-10-10	38000177		0	0	14		0	0	0	37870	0	1043400	40229134		
98216	2151	40213227	1992-08-05	1992-08-05 00:00:00	1992-08-05	1992-08-05 00:00:00	1992-08-05	581452		0	0	0		0	0	0	143331	0	113	40213227		
87415	1918	40213160	1968-11-16	1968-11-16 00:00:00	1968-11-16	1968-11-16 00:00:00	1968-11-16	581452		0	0	0		0	0	0	127596	0	10	40213160		
57784	4800	1124300	2009-03-09	2009-03-09 00:00:00	2009-03-09	2009-03-09 00:00:00	\N	38000177		0	0	0		0	0	0	319353	0	00781178901	45011828		
52730	4382	40229134	2010-08-13	2010-08-13 00:00:00	2010-08-20	2010-08-20 00:00:00	2010-08-20	38000177		0	0	7		0	0	0	291257	0	1043400	40229134		
56877	4720	1115171	1999-04-07	1999-04-07 00:00:00	1999-05-12	1999-05-12 00:00:00	1999-05-12	38000177		0	0	35		0	0	0	314371	0	849574	1115171		
82447	1801	40213160	1959-07-01	1959-07-01 00:00:00	1959-07-01	1959-07-01 00:00:00	1959-07-01	581452		0	0	0		0	0	0	120772	0	10	40213160		
175773	3864	40213227	1997-03-01	1997-03-01 00:00:00	1997-03-01	1997-03-01 00:00:00	1997-03-01	581452		0	0	0		0	0	0	256486	0	113	40213227		
12218	1024	1332419	2016-05-29	2016-05-29 00:00:00	2016-05-29	2016-05-29 00:00:00	\N	38000177		0	0	0		0	0	0	67432	0	197361	1332419		
56034	4653	40229134	2011-06-28	2011-06-28 00:00:00	2011-07-12	2011-07-12 00:00:00	2011-07-12	38000177		0	0	14		0	0	0	310148	0	1043400	40229134		
45598	994	40213160	1964-07-01	1964-07-01 00:00:00	1964-07-01	1964-07-01 00:00:00	1964-07-01	581452		0	0	0		0	0	0	65912	0	10	40213160		
50777	1112	40213227	2014-12-28	2014-12-28 00:00:00	2014-12-28	2014-12-28 00:00:00	2014-12-28	581452		0	0	0		0	0	0	73203	0	113	40213227		
36115	788	40213160	1974-08-21	1974-08-21 00:00:00	1974-08-21	1974-08-21 00:00:00	1974-08-21	581452		0	0	0		0	0	0	52441	0	10	40213160		
25807	2123	19006318	1951-01-12	1951-01-12 00:00:00	1951-01-26	1951-01-26 00:00:00	1951-01-26	38000177		0	0	14		0	0	0	141254	0	105078	19006318		
138433	3040	40213296	2015-10-22	2015-10-22 00:00:00	2015-10-22	2015-10-22 00:00:00	2015-10-22	581452		0	0	0		0	0	0	202425	0	52	40213296		
8264	689	1713671	1987-12-21	1987-12-21 00:00:00	1987-12-28	1987-12-28 00:00:00	1987-12-28	38000177		0	0	7		0	0	0	45636	0	562251	1713671		
33746	736	40213227	2005-09-01	2005-09-01 00:00:00	2005-09-01	2005-09-01 00:00:00	2005-09-01	581452		0	0	0		0	0	0	48857	0	113	40213227		
97422	2135	40213201	2014-12-01	2014-12-01 00:00:00	2014-12-01	2014-12-01 00:00:00	2014-12-01	581452		0	0	0		0	0	0	142067	0	33	40213201		
11848	987	1713671	1972-08-09	1972-08-09 00:00:00	1972-08-16	1972-08-16 00:00:00	1972-08-16	38000177		0	0	7		0	0	0	65583	0	562251	1713671		
27680	2291	19128065	1982-08-29	1982-08-29 00:00:00	1983-08-24	1983-08-24 00:00:00	1983-08-24	38000177		0	0	360		0	0	0	152419	0	749882	19128065		
205685	4514	40213314	1977-10-28	1977-10-28 00:00:00	1977-10-28	1977-10-28 00:00:00	1977-10-28	581452		0	0	0		0	0	0	300666	0	49	40213314		
229518	5044	40213160	1973-02-21	1973-02-21 00:00:00	1973-02-21	1973-02-21 00:00:00	1973-02-21	581452		0	0	0		0	0	0	335212	0	10	40213160		
29521	2443	1127433	1989-12-11	1989-12-11 00:00:00	1989-12-18	1989-12-18 00:00:00	1989-12-18	38000177		0	0	7		0	0	0	162040	0	313782	1127433		
197426	4338	40213260	2015-07-11	2015-07-11 00:00:00	2015-07-11	2015-07-11 00:00:00	2015-07-11	581452		0	0	0		0	0	0	287666	0	121	40213260		
216656	4754	40213160	1969-09-30	1969-09-30 00:00:00	1969-09-30	1969-09-30 00:00:00	1969-09-30	581452		0	0	0		0	0	0	316600	0	10	40213160		
19241	1588	19128065	1983-10-15	1983-10-15 00:00:00	1984-10-09	1984-10-09 00:00:00	1984-10-09	38000177		0	0	360		0	0	0	106592	0	749882	19128065		
51172	4250	1115171	2015-04-07	2015-04-07 00:00:00	2015-07-06	2015-07-06 00:00:00	2015-07-06	38000177		0	0	90		0	0	0	282264	0	849574	1115171		
75789	1656	40213314	1978-05-06	1978-05-06 00:00:00	1978-05-06	1978-05-06 00:00:00	1978-05-06	581452		0	0	0		0	0	0	111138	0	49	40213314		
110901	2436	40213227	1993-11-13	1993-11-13 00:00:00	1993-11-13	1993-11-13 00:00:00	1993-11-13	581452		0	0	0		0	0	0	161621	0	113	40213227		
29878	2476	1127078	1958-09-23	1958-09-23 00:00:00	1958-10-28	1958-10-28 00:00:00	1958-10-28	38000177		0	0	35		0	0	0	164115	0	282464	1127078		
102922	2258	40213227	2018-02-01	2018-02-01 00:00:00	2018-02-01	2018-02-01 00:00:00	2018-02-01	581452		0	0	0		0	0	0	150040	0	113	40213227		
214676	4707	40213160	1974-02-14	1974-02-14 00:00:00	1974-02-14	1974-02-14 00:00:00	1974-02-14	581452		0	0	0		0	0	0	313585	0	10	40213160		
203062	4457	40213160	1984-01-17	1984-01-17 00:00:00	1984-01-17	1984-01-17 00:00:00	1984-01-17	581452		0	0	0		0	0	0	296625	0	10	40213160		
214754	4709	40213227	1998-05-18	1998-05-18 00:00:00	1998-05-18	1998-05-18 00:00:00	1998-05-18	581452		0	0	0		0	0	0	313657	0	113	40213227		
72557	1586	40213227	1992-09-06	1992-09-06 00:00:00	1992-09-06	1992-09-06 00:00:00	1992-09-06	581452		0	0	0		0	0	0	106480	0	113	40213227		
144112	3167	40213306	1982-08-15	1982-08-15 00:00:00	1982-08-15	1982-08-15 00:00:00	1982-08-15	581452		0	0	0		0	0	0	210557	0	43	40213306		
177173	3893	40213227	2003-08-01	2003-08-01 00:00:00	2003-08-01	2003-08-01 00:00:00	2003-08-01	581452		0	0	0		0	0	0	258842	0	113	40213227		
88984	1951	40213160	1986-04-23	1986-04-23 00:00:00	1986-04-23	1986-04-23 00:00:00	1986-04-23	581452		0	0	0		0	0	0	129721	0	10	40213160		
162789	3579	40213260	2014-11-01	2014-11-01 00:00:00	2014-11-01	2014-11-01 00:00:00	2014-11-01	581452		0	0	0		0	0	0	237932	0	121	40213260		
55824	4634	19078461	1989-09-17	1989-09-17 00:00:00	1989-10-01	1989-10-01 00:00:00	1989-10-01	38000177		0	0	14		0	0	0	308858	0	310965	19078461		
45129	3734	40236824	1987-08-19	1987-08-19 00:00:00	1987-08-26	1987-08-26 00:00:00	1987-08-26	38000177		0	0	7		0	0	0	248152	0	1094107	40236824		
28276	2334	1713671	1951-10-28	1951-10-28 00:00:00	1951-11-11	1951-11-11 00:00:00	1951-11-11	38000177		0	0	14		0	0	0	155314	0	562251	1713671		
9027	753	19059056	1968-08-19	1968-08-19 00:00:00	1968-09-02	1968-09-02 00:00:00	1968-09-02	38000177		0	0	14		0	0	0	49816	0	243670	19059056		
214372	4700	40213227	2013-02-12	2013-02-12 00:00:00	2013-02-12	2013-02-12 00:00:00	2013-02-12	581452		0	0	0		0	0	0	313082	0	113	40213227		
103612	2273	40213306	2006-08-30	2006-08-30 00:00:00	2006-08-30	2006-08-30 00:00:00	2006-08-30	581452		0	0	0		0	0	0	151127	0	43	40213306		
131194	2883	40213260	2015-05-13	2015-05-13 00:00:00	2015-05-13	2015-05-13 00:00:00	2015-05-13	581452		0	0	0		0	0	0	191811	0	121	40213260		
171843	3778	40213227	2007-02-04	2007-02-04 00:00:00	2007-02-04	2007-02-04 00:00:00	2007-02-04	581452		0	0	0		0	0	0	251093	0	113	40213227		
203886	4476	40213227	1995-06-11	1995-06-11 00:00:00	1995-06-11	1995-06-11 00:00:00	1995-06-11	581452		0	0	0		0	0	0	297873	0	113	40213227		
52306	1144	40213306	1992-10-25	1992-10-25 00:00:00	1992-10-25	1992-10-25 00:00:00	1992-10-25	581452		0	0	0		0	0	0	75509	0	43	40213306		
128145	2818	40213296	2010-11-01	2010-11-01 00:00:00	2010-11-01	2010-11-01 00:00:00	2010-11-01	581452		0	0	0		0	0	0	186785	0	52	40213296		
18465	1528	1127433	2009-05-14	2009-05-14 00:00:00	2009-05-28	2009-05-28 00:00:00	2009-05-28	38000177		0	0	14		0	0	0	102242	0	313782	1127433		
25187	549	40213160	1955-12-21	1955-12-21 00:00:00	1955-12-21	1955-12-21 00:00:00	1955-12-21	581452		0	0	0		0	0	0	36378	0	10	40213160		
146840	3229	40213314	1979-11-16	1979-11-16 00:00:00	1979-11-16	1979-11-16 00:00:00	1979-11-16	581452		0	0	0		0	0	0	214610	0	49	40213314		
106344	2332	40213160	1957-07-27	1957-07-27 00:00:00	1957-07-27	1957-07-27 00:00:00	1957-07-27	581452		0	0	0		0	0	0	155065	0	10	40213160		
41932	914	40213227	1996-06-03	1996-06-03 00:00:00	1996-06-03	1996-06-03 00:00:00	1996-06-03	581452		0	0	0		0	0	0	60757	0	113	40213227		
106441	2334	40213227	2007-05-31	2007-05-31 00:00:00	2007-05-31	2007-05-31 00:00:00	2007-05-31	581452		0	0	0		0	0	0	155279	0	113	40213227		
43085	3571	1118084	2007-02-01	2007-02-01 00:00:00	2007-02-01	2007-02-01 00:00:00	\N	38000177		0	0	0		0	0	0	237420	0	00025152531	44923712		
141306	3103	40213160	1978-02-21	1978-02-21 00:00:00	1978-02-21	1978-02-21 00:00:00	1978-02-21	581452		0	0	0		0	0	0	206422	0	10	40213160		
117855	2591	40213227	1993-01-20	1993-01-20 00:00:00	1993-01-20	1993-01-20 00:00:00	1993-01-20	581452		0	0	0		0	0	0	171520	0	113	40213227		
220137	4831	40213160	1961-08-03	1961-08-03 00:00:00	1961-08-03	1961-08-03 00:00:00	1961-08-03	581452		0	0	0		0	0	0	321421	0	10	40213160		
62134	5170	1115171	1997-08-28	1997-08-28 00:00:00	1997-10-02	1997-10-02 00:00:00	1997-10-02	38000177		0	0	35		0	0	0	343740	0	849574	1115171		
209099	4586	40213260	2007-11-04	2007-11-04 00:00:00	2007-11-04	2007-11-04 00:00:00	2007-11-04	581452		0	0	0		0	0	0	305459	0	121	40213260		
189434	4159	40213160	1956-10-06	1956-10-06 00:00:00	1956-10-06	1956-10-06 00:00:00	1956-10-06	581452		0	0	0		0	0	0	276325	0	10	40213160		
6768	569	1115171	2009-01-29	2009-01-29 00:00:00	2009-02-12	2009-02-12 00:00:00	2009-02-12	38000177		0	0	14		0	0	0	37724	0	849574	1115171		
6804	572	19133905	1975-01-29	1975-01-29 00:00:00	1975-02-06	1975-02-06 00:00:00	1975-02-06	38000177		0	0	8		0	0	0	37868	0	834102	19133905		
164210	3612	40213306	1982-07-04	1982-07-04 00:00:00	1982-07-04	1982-07-04 00:00:00	1982-07-04	581452		0	0	0		0	0	0	239953	0	43	40213306		
87421	1918	40213227	2001-02-03	2001-02-03 00:00:00	2001-02-03	2001-02-03 00:00:00	2001-02-03	581452		0	0	0		0	0	0	127610	0	113	40213227		
57785	4801	1124300	2002-08-10	2002-08-10 00:00:00	2002-08-10	2002-08-10 00:00:00	\N	38000177		0	0	0		0	0	0	319414	0	00781178901	45011828		
52731	4382	19128065	1974-11-14	1974-11-14 00:00:00	1975-11-09	1975-11-09 00:00:00	1975-11-09	38000177		0	0	360		0	0	0	291241	0	749882	19128065		
56890	4722	1115171	2009-07-29	2009-07-29 00:00:00	2009-08-12	2009-08-12 00:00:00	2009-08-12	38000177		0	0	14		0	0	0	314524	0	849574	1115171		
82457	1801	40213227	2005-07-27	2005-07-27 00:00:00	2005-07-27	2005-07-27 00:00:00	2005-07-27	581452		0	0	0		0	0	0	120793	0	113	40213227		
187061	4109	40213260	2016-04-05	2016-04-05 00:00:00	2016-04-05	2016-04-05 00:00:00	2016-04-05	581452		0	0	0		0	0	0	273223	0	121	40213260		
12219	1024	1539411	2016-05-29	2016-05-29 00:00:00	2016-05-29	2016-05-29 00:00:00	\N	38000177		0	0	0		0	0	0	67432	0	312961	1539411		
56035	4653	1127433	1993-07-04	1993-07-04 00:00:00	1993-07-18	1993-07-18 00:00:00	1993-07-18	38000177		0	0	14		0	0	0	310146	0	313782	1127433		
45600	994	40213306	1981-12-30	1981-12-30 00:00:00	1981-12-30	1981-12-30 00:00:00	1981-12-30	581452		0	0	0		0	0	0	65869	0	43	40213306		
50781	1113	40213227	1994-01-18	1994-01-18 00:00:00	1994-01-18	1994-01-18 00:00:00	1994-01-18	581452		0	0	0		0	0	0	73254	0	113	40213227		
36122	788	40213227	2011-12-14	2011-12-14 00:00:00	2011-12-14	2011-12-14 00:00:00	2011-12-14	581452		0	0	0		0	0	0	52430	0	113	40213227		
25808	2123	1127078	1951-01-12	1951-01-12 00:00:00	1951-01-26	1951-01-26 00:00:00	1951-01-26	38000177		0	0	14		0	0	0	141254	0	282464	1127078		
138436	3040	40213160	1972-06-01	1972-06-01 00:00:00	1972-06-01	1972-06-01 00:00:00	1972-06-01	581452		0	0	0		0	0	0	202389	0	10	40213160		
8265	689	42902245	2002-01-17	2002-01-17 00:00:00	2003-01-12	2003-01-12 00:00:00	2003-01-12	38000177		0	0	360		0	0	0	45642	0	1359133	42902245		
33751	736	40213160	1972-04-13	1972-04-13 00:00:00	1972-04-13	1972-04-13 00:00:00	1972-04-13	581452		0	0	0		0	0	0	48852	0	10	40213160		
97442	2135	40213227	1992-02-17	1992-02-17 00:00:00	1992-02-17	1992-02-17 00:00:00	1992-02-17	581452		0	0	0		0	0	0	142138	0	113	40213227		
11849	987	19059056	1988-08-06	1988-08-06 00:00:00	1988-09-10	1988-09-10 00:00:00	1988-09-10	38000177		0	0	35		0	0	0	65522	0	243670	19059056		
27681	2291	1713671	1997-07-05	1997-07-05 00:00:00	1997-07-26	1997-07-26 00:00:00	1997-07-26	38000177		0	0	21		0	0	0	152505	0	562251	1713671		
62394	1365	40213160	1964-04-30	1964-04-30 00:00:00	1964-04-30	1964-04-30 00:00:00	1964-04-30	581452		0	0	0		0	0	0	90509	0	10	40213160		
229523	5044	40213227	2004-01-28	2004-01-28 00:00:00	2004-01-28	2004-01-28 00:00:00	2004-01-28	581452		0	0	0		0	0	0	335204	0	113	40213227		
29522	2443	1713671	1965-09-12	1965-09-12 00:00:00	1965-09-19	1965-09-19 00:00:00	1965-09-19	38000177		0	0	7		0	0	0	162027	0	562251	1713671		
197428	4338	40213160	1965-10-16	1965-10-16 00:00:00	1965-10-16	1965-10-16 00:00:00	1965-10-16	581452		0	0	0		0	0	0	287676	0	10	40213160		
216667	4755	40213227	2016-01-15	2016-01-15 00:00:00	2016-01-15	2016-01-15 00:00:00	2016-01-15	581452		0	0	0		0	0	0	316752	0	113	40213227		
19242	1588	1127433	2004-01-17	2004-01-17 00:00:00	2004-01-24	2004-01-24 00:00:00	2004-01-24	38000177		0	0	7		0	0	0	106577	0	313782	1127433		
51173	4250	1127433	1988-08-26	1988-08-26 00:00:00	1988-09-02	1988-09-02 00:00:00	1988-09-02	38000177		0	0	7		0	0	0	282288	0	313782	1127433		
75794	1656	40213314	1978-03-04	1978-03-04 00:00:00	1978-03-04	1978-03-04 00:00:00	1978-03-04	581452		0	0	0		0	0	0	111077	0	49	40213314		
110918	2437	40213160	1962-01-15	1962-01-15 00:00:00	1962-01-15	1962-01-15 00:00:00	1962-01-15	581452		0	0	0		0	0	0	161659	0	10	40213160		
29879	2476	40229134	1966-07-15	1966-07-15 00:00:00	1966-07-29	1966-07-29 00:00:00	1966-07-29	38000177		0	0	14		0	0	0	164099	0	1043400	40229134		
114204	2509	40213227	2011-06-19	2011-06-19 00:00:00	2011-06-19	2011-06-19 00:00:00	2011-06-19	581452		0	0	0		0	0	0	166082	0	113	40213227		
214680	4707	40213160	1973-12-13	1973-12-13 00:00:00	1973-12-13	1973-12-13 00:00:00	1973-12-13	581452		0	0	0		0	0	0	313596	0	10	40213160		
203067	4459	40213306	1986-03-03	1986-03-03 00:00:00	1986-03-03	1986-03-03 00:00:00	1986-03-03	581452		0	0	0		0	0	0	296681	0	43	40213306		
214759	4709	40213160	1961-04-17	1961-04-17 00:00:00	1961-04-17	1961-04-17 00:00:00	1961-04-17	581452		0	0	0		0	0	0	313651	0	10	40213160		
72558	1586	40213201	2005-08-14	2005-08-14 00:00:00	2005-08-14	2005-08-14 00:00:00	2005-08-14	581452		0	0	0		0	0	0	106418	0	33	40213201		
144113	3167	40213160	1961-02-12	1961-02-12 00:00:00	1961-02-12	1961-02-12 00:00:00	1961-02-12	581452		0	0	0		0	0	0	210536	0	10	40213160		
177175	3893	40213160	1976-09-24	1976-09-24 00:00:00	1976-09-24	1976-09-24 00:00:00	1976-09-24	581452		0	0	0		0	0	0	258856	0	10	40213160		
88985	1951	40213251	1986-04-23	1986-04-23 00:00:00	1986-04-23	1986-04-23 00:00:00	1986-04-23	581452		0	0	0		0	0	0	129721	0	21	40213251		
162800	3580	40213160	1972-06-30	1972-06-30 00:00:00	1972-06-30	1972-06-30 00:00:00	1972-06-30	581452		0	0	0		0	0	0	238029	0	10	40213160		
55825	4634	1127433	1996-04-27	1996-04-27 00:00:00	1996-05-25	1996-05-25 00:00:00	1996-05-25	38000177		0	0	28		0	0	0	308859	0	313782	1127433		
45130	3734	920300	1987-08-19	1987-08-19 00:00:00	1987-08-26	1987-08-26 00:00:00	1987-08-26	38000177		0	0	7		0	0	0	248152	0	311989	920300		
28277	2334	1127433	1977-06-21	1977-06-21 00:00:00	1977-07-05	1977-07-05 00:00:00	1977-07-05	38000177		0	0	14		0	0	0	155343	0	313782	1127433		
9028	753	19128065	1982-09-15	1982-09-15 00:00:00	1983-09-10	1983-09-10 00:00:00	1983-09-10	38000177		0	0	360		0	0	0	49769	0	749882	19128065		
9035	754	19059056	1972-09-15	1972-09-15 00:00:00	1972-11-14	1972-11-14 00:00:00	1972-11-14	38000177		0	0	60		0	0	0	49824	0	243670	19059056		
103613	2273	40213180	2006-08-30	2006-08-30 00:00:00	2006-08-30	2006-08-30 00:00:00	2006-08-30	581452		0	0	0		0	0	0	151127	0	114	40213180		
131200	2883	40213160	1964-11-04	1964-11-04 00:00:00	1964-11-04	1964-11-04 00:00:00	1964-11-04	581452		0	0	0		0	0	0	191772	0	10	40213160		
171844	3778	40213296	2007-02-04	2007-02-04 00:00:00	2007-02-04	2007-02-04 00:00:00	2007-02-04	581452		0	0	0		0	0	0	251093	0	52	40213296		
203893	4476	40213227	2003-03-16	2003-03-16 00:00:00	2003-03-16	2003-03-16 00:00:00	2003-03-16	581452		0	0	0		0	0	0	297865	0	113	40213227		
52311	1145	40213227	2000-03-15	2000-03-15 00:00:00	2000-03-15	2000-03-15 00:00:00	2000-03-15	581452		0	0	0		0	0	0	75621	0	113	40213227		
128146	2818	40213227	2018-12-10	2018-12-10 00:00:00	2018-12-10	2018-12-10 00:00:00	2018-12-10	581452		0	0	0		0	0	0	186743	0	113	40213227		
18466	1528	19059056	1964-06-25	1964-06-25 00:00:00	1964-07-09	1964-07-09 00:00:00	1964-07-09	38000177		0	0	14		0	0	0	102214	0	243670	19059056		
25189	549	40213227	1994-06-01	1994-06-01 00:00:00	1994-06-01	1994-06-01 00:00:00	1994-06-01	581452		0	0	0		0	0	0	36388	0	113	40213227		
146841	3229	40213160	1979-11-16	1979-11-16 00:00:00	1979-11-16	1979-11-16 00:00:00	1979-11-16	581452		0	0	0		0	0	0	214610	0	10	40213160		
210745	4622	40213296	1998-12-03	1998-12-03 00:00:00	1998-12-03	1998-12-03 00:00:00	1998-12-03	581452		0	0	0		0	0	0	307836	0	52	40213296		
41946	914	40213198	2010-08-23	2010-08-23 00:00:00	2010-08-23	2010-08-23 00:00:00	2010-08-23	581452		0	0	0		0	0	0	60695	0	133	40213198		
186370	4094	40213160	1962-06-28	1962-06-28 00:00:00	1962-06-28	1962-06-28 00:00:00	1962-06-28	581452		0	0	0		0	0	0	272156	0	10	40213160		
43086	3571	1127433	2005-05-27	2005-05-27 00:00:00	2005-07-26	2005-07-26 00:00:00	2005-07-26	38000177		0	0	60		0	0	0	237439	0	313782	1127433		
141308	3103	40213160	1982-05-26	1982-05-26 00:00:00	1982-05-26	1982-05-26 00:00:00	1982-05-26	581452		0	0	0		0	0	0	206445	0	10	40213160		
115861	2545	40213227	2007-05-10	2007-05-10 00:00:00	2007-05-10	2007-05-10 00:00:00	2007-05-10	581452		0	0	0		0	0	0	168426	0	113	40213227		
220139	4831	40213296	2005-01-13	2005-01-13 00:00:00	2005-01-13	2005-01-13 00:00:00	2005-01-13	581452		0	0	0		0	0	0	321475	0	52	40213296		
62135	5170	19078461	1981-02-04	1981-02-04 00:00:00	1981-03-13	1981-03-13 00:00:00	1981-03-13	38000177		0	0	37		0	0	0	343735	0	310965	19078461		
209105	4586	40213227	2017-12-31	2017-12-31 00:00:00	2017-12-31	2017-12-31 00:00:00	2017-12-31	581452		0	0	0		0	0	0	305520	0	113	40213227		
189437	4159	40213160	1961-01-07	1961-01-07 00:00:00	1961-01-07	1961-01-07 00:00:00	1961-01-07	581452		0	0	0		0	0	0	276390	0	10	40213160		
6769	569	40162522	2009-01-29	2009-01-29 00:00:00	2009-01-29	2009-01-29 00:00:00	\N	38000177		0	0	0		0	0	0	37724	0	857005	40162522		
6805	572	19133873	1961-11-29	1961-11-29 00:00:00	1961-12-06	1961-12-06 00:00:00	1961-12-06	38000177		0	0	7		0	0	0	37871	0	834061	19133873		
164212	3612	40213160	1960-05-29	1960-05-29 00:00:00	1960-05-29	1960-05-29 00:00:00	1960-05-29	581452		0	0	0		0	0	0	239945	0	10	40213160		
91477	2007	40213314	1988-01-10	1988-01-10 00:00:00	1988-01-10	1988-01-10 00:00:00	1988-01-10	581452		0	0	0		0	0	0	133650	0	49	40213314		
57786	4801	1713671	2006-03-15	2006-03-15 00:00:00	2006-03-22	2006-03-22 00:00:00	2006-03-22	38000177		0	0	7		0	0	0	319378	0	562251	1713671		
52732	4382	1127078	1964-10-27	1964-10-27 00:00:00	1964-11-17	1964-11-17 00:00:00	1964-11-17	38000177		0	0	21		0	0	0	291167	0	282464	1127078		
56891	4722	19059056	1924-02-17	1924-02-17 00:00:00	1924-03-25	1924-03-25 00:00:00	1924-03-25	38000177		0	0	37		0	0	0	314610	0	243670	19059056		
82459	1801	40213227	2015-09-23	2015-09-23 00:00:00	2015-09-23	2015-09-23 00:00:00	2015-09-23	581452		0	0	0		0	0	0	120791	0	113	40213227		
117292	2578	40213160	1971-05-06	1971-05-06 00:00:00	1971-05-06	1971-05-06 00:00:00	1971-05-06	581452		0	0	0		0	0	0	170724	0	10	40213160		
12220	1024	19133905	1999-01-30	1999-01-30 00:00:00	1999-02-11	1999-02-11 00:00:00	1999-02-11	38000177		0	0	12		0	0	0	67476	0	834102	19133905		
56036	4653	1127078	1960-02-17	1960-02-17 00:00:00	1960-03-09	1960-03-09 00:00:00	1960-03-09	38000177		0	0	21		0	0	0	310137	0	282464	1127078		
45610	994	40213260	2009-07-22	2009-07-22 00:00:00	2009-07-22	2009-07-22 00:00:00	2009-07-22	581452		0	0	0		0	0	0	65904	0	121	40213260		
50782	1113	40213306	1994-01-18	1994-01-18 00:00:00	1994-01-18	1994-01-18 00:00:00	1994-01-18	581452		0	0	0		0	0	0	73254	0	43	40213306		
36123	788	40213296	2011-12-14	2011-12-14 00:00:00	2011-12-14	2011-12-14 00:00:00	2011-12-14	581452		0	0	0		0	0	0	52430	0	52	40213296		
25809	2123	40229134	1988-12-21	1988-12-21 00:00:00	1989-01-04	1989-01-04 00:00:00	1989-01-04	38000177		0	0	14		0	0	0	141310	0	1043400	40229134		
138440	3040	40213227	2013-10-17	2013-10-17 00:00:00	2013-10-17	2013-10-17 00:00:00	2013-10-17	581452		0	0	0		0	0	0	202385	0	113	40213227		
8266	689	1127433	2010-03-27	2010-03-27 00:00:00	2010-04-10	2010-04-10 00:00:00	2010-04-10	38000177		0	0	14		0	0	0	45694	0	313782	1127433		
33757	736	40213227	2013-09-12	2013-09-12 00:00:00	2013-09-12	2013-09-12 00:00:00	2013-09-12	581452		0	0	0		0	0	0	48822	0	113	40213227		
97449	2136	40213306	1990-08-04	1990-08-04 00:00:00	1990-08-04	1990-08-04 00:00:00	1990-08-04	581452		0	0	0		0	0	0	142308	0	43	40213306		
11850	987	1127433	2003-03-18	2003-03-18 00:00:00	2003-03-25	2003-03-25 00:00:00	2003-03-25	38000177		0	0	7		0	0	0	65585	0	313782	1127433		
27682	2291	1713671	1978-09-19	1978-09-19 00:00:00	1978-09-26	1978-09-26 00:00:00	1978-09-26	38000177		0	0	7		0	0	0	152450	0	562251	1713671		
62396	1365	40213227	2015-04-23	2015-04-23 00:00:00	2015-04-23	2015-04-23 00:00:00	2015-04-23	581452		0	0	0		0	0	0	90488	0	113	40213227		
229524	5045	40213160	1965-03-13	1965-03-13 00:00:00	1965-03-13	1965-03-13 00:00:00	1965-03-13	581452		0	0	0		0	0	0	335246	0	10	40213160		
29523	2443	1127433	2019-02-02	2019-02-02 00:00:00	2019-02-23	2019-02-23 00:00:00	2019-02-23	38000177		0	0	21		0	0	0	162036	0	313782	1127433		
198092	4352	40213227	2000-06-01	2000-06-01 00:00:00	2000-06-01	2000-06-01 00:00:00	2000-06-01	581452		0	0	0		0	0	0	288720	0	113	40213227		
216669	4755	40213227	1996-03-08	1996-03-08 00:00:00	1996-03-08	1996-03-08 00:00:00	1996-03-08	581452		0	0	0		0	0	0	316667	0	113	40213227		
19243	1588	920300	2011-12-16	2011-12-16 00:00:00	2011-12-23	2011-12-23 00:00:00	2011-12-23	38000177		0	0	7		0	0	0	106578	0	311989	920300		
61249	5096	1127433	1989-04-29	1989-04-29 00:00:00	1989-05-13	1989-05-13 00:00:00	1989-05-13	38000177		0	0	14		0	0	0	338584	0	313782	1127433		
75795	1656	40213160	1978-03-04	1978-03-04 00:00:00	1978-03-04	1978-03-04 00:00:00	1978-03-04	581452		0	0	0		0	0	0	111077	0	10	40213160		
110921	2437	40213260	2012-06-25	2012-06-25 00:00:00	2012-06-25	2012-06-25 00:00:00	2012-06-25	581452		0	0	0		0	0	0	161711	0	121	40213260		
29880	2476	1118084	1994-01-12	1994-01-12 00:00:00	1994-01-12	1994-01-12 00:00:00	\N	38000177		0	0	0		0	0	0	164054	0	00025152531	44923712		
114212	2509	40213160	1974-01-06	1974-01-06 00:00:00	1974-01-06	1974-01-06 00:00:00	1974-01-06	581452		0	0	0		0	0	0	166105	0	10	40213160		
214681	4707	40213296	2014-03-27	2014-03-27 00:00:00	2014-03-27	2014-03-27 00:00:00	2014-03-27	581452		0	0	0		0	0	0	313611	0	52	40213296		
203068	4459	40213160	1968-09-17	1968-09-17 00:00:00	1968-09-17	1968-09-17 00:00:00	1968-09-17	581452		0	0	0		0	0	0	296673	0	10	40213160		
214768	4709	40213296	1996-05-13	1996-05-13 00:00:00	1996-05-13	1996-05-13 00:00:00	1996-05-13	581452		0	0	0		0	0	0	313686	0	52	40213296		
72575	1586	40213227	2000-10-22	2000-10-22 00:00:00	2000-10-22	2000-10-22 00:00:00	2000-10-22	581452		0	0	0		0	0	0	106424	0	113	40213227		
72302	1579	40213260	2006-12-28	2006-12-28 00:00:00	2006-12-28	2006-12-28 00:00:00	2006-12-28	581452		0	0	0		0	0	0	106107	0	121	40213260		
169531	3728	40213306	1995-04-16	1995-04-16 00:00:00	1995-04-16	1995-04-16 00:00:00	1995-04-16	581452		0	0	0		0	0	0	247711	0	43	40213306		
88992	1951	40213160	1982-01-20	1982-01-20 00:00:00	1982-01-20	1982-01-20 00:00:00	1982-01-20	581452		0	0	0		0	0	0	129739	0	10	40213160		
162808	3580	40213160	1972-09-01	1972-09-01 00:00:00	1972-09-01	1972-09-01 00:00:00	1972-09-01	581452		0	0	0		0	0	0	237991	0	10	40213160		
55826	4634	1118084	1997-10-20	1997-10-20 00:00:00	1997-10-20	1997-10-20 00:00:00	\N	38000177		0	0	0		0	0	0	308859	0	00025152531	44923712		
45131	3734	1127433	1977-01-30	1977-01-30 00:00:00	1977-03-01	1977-03-01 00:00:00	1977-03-01	38000177		0	0	30		0	0	0	248172	0	313782	1127433		
28278	2334	40171902	2011-06-23	2011-06-23 00:00:00	2011-06-23	2011-06-23 00:00:00	\N	38000177		0	0	0		0	0	0	155281	0	897718	40171902		
9029	753	40229134	1973-02-25	1973-02-25 00:00:00	1973-03-04	1973-03-04 00:00:00	1973-03-04	38000177		0	0	7		0	0	0	49810	0	1043400	40229134		
9036	754	1118084	1973-08-05	1973-08-05 00:00:00	1973-08-05	1973-08-05 00:00:00	\N	38000177		0	0	0		0	0	0	49951	0	00025152531	44923712		
103615	2273	40213227	2006-08-30	2006-08-30 00:00:00	2006-08-30	2006-08-30 00:00:00	2006-08-30	581452		0	0	0		0	0	0	151127	0	113	40213227		
185656	4080	40213160	1966-02-08	1966-02-08 00:00:00	1966-02-08	1966-02-08 00:00:00	1966-02-08	581452		0	0	0		0	0	0	271213	0	10	40213160		
9160	195	40213227	1992-12-21	1992-12-21 00:00:00	1992-12-21	1992-12-21 00:00:00	1992-12-21	581452		0	0	0		0	0	0	13374	0	113	40213227		
203894	4476	40213296	2003-03-16	2003-03-16 00:00:00	2003-03-16	2003-03-16 00:00:00	2003-03-16	581452		0	0	0		0	0	0	297865	0	52	40213296		
52327	1145	40213201	2005-04-13	2005-04-13 00:00:00	2005-04-13	2005-04-13 00:00:00	2005-04-13	581452		0	0	0		0	0	0	75594	0	33	40213201		
128149	2818	40213260	2018-12-10	2018-12-10 00:00:00	2018-12-10	2018-12-10 00:00:00	2018-12-10	581452		0	0	0		0	0	0	186743	0	121	40213260		
18467	1528	19006318	1964-06-25	1964-06-25 00:00:00	1964-07-09	1964-07-09 00:00:00	1964-07-09	38000177		0	0	14		0	0	0	102214	0	105078	19006318		
25194	549	40213201	2018-10-03	2018-10-03 00:00:00	2018-10-03	2018-10-03 00:00:00	2018-10-03	581452		0	0	0		0	0	0	36361	0	33	40213201		
146842	3229	40213227	2011-06-17	2011-06-17 00:00:00	2011-06-17	2011-06-17 00:00:00	2011-06-17	581452		0	0	0		0	0	0	214588	0	113	40213227		
210749	4622	40213160	1956-07-05	1956-07-05 00:00:00	1956-07-05	1956-07-05 00:00:00	1956-07-05	581452		0	0	0		0	0	0	307842	0	10	40213160		
41955	915	40213260	2009-12-26	2009-12-26 00:00:00	2009-12-26	2009-12-26 00:00:00	2009-12-26	581452		0	0	0		0	0	0	60810	0	121	40213260		
186374	4094	40213227	2018-10-25	2018-10-25 00:00:00	2018-10-25	2018-10-25 00:00:00	2018-10-25	581452		0	0	0		0	0	0	272188	0	113	40213227		
43087	3571	40231925	2005-05-27	2005-05-27 00:00:00	2005-05-27	2005-05-27 00:00:00	\N	38000177		0	0	0		0	0	0	237439	0	1049221	40231925		
156073	3435	40213314	1977-04-02	1977-04-02 00:00:00	1977-04-02	1977-04-02 00:00:00	1977-04-02	581452		0	0	0		0	0	0	227817	0	49	40213314		
115868	2546	40213160	1975-09-05	1975-09-05 00:00:00	1975-09-05	1975-09-05 00:00:00	1975-09-05	581452		0	0	0		0	0	0	168499	0	10	40213160		
86638	1900	40213160	1964-06-15	1964-06-15 00:00:00	1964-06-15	1964-06-15 00:00:00	1964-06-15	581452		0	0	0		0	0	0	126510	0	10	40213160		
62136	5170	1127433	1991-03-12	1991-03-12 00:00:00	1991-04-02	1991-04-02 00:00:00	1991-04-02	38000177		0	0	21		0	0	0	343738	0	313782	1127433		
209107	4586	40213260	2006-10-29	2006-10-29 00:00:00	2006-10-29	2006-10-29 00:00:00	2006-10-29	581452		0	0	0		0	0	0	305518	0	121	40213260		
189443	4159	40213260	2006-11-18	2006-11-18 00:00:00	2006-11-18	2006-11-18 00:00:00	2006-11-18	581452		0	0	0		0	0	0	276317	0	121	40213260		
6778	571	1713671	2009-09-06	2009-09-06 00:00:00	2009-09-13	2009-09-13 00:00:00	2009-09-13	38000177		0	0	7		0	0	0	37810	0	562251	1713671		
6806	572	1127433	1976-11-21	1976-11-21 00:00:00	1977-01-20	1977-01-20 00:00:00	1977-01-20	38000177		0	0	60		0	0	0	37860	0	313782	1127433		
164213	3612	40213160	1960-03-27	1960-03-27 00:00:00	1960-03-27	1960-03-27 00:00:00	1960-03-27	581452		0	0	0		0	0	0	239975	0	10	40213160		
91478	2007	40213251	1988-01-10	1988-01-10 00:00:00	1988-01-10	1988-01-10 00:00:00	1988-01-10	581452		0	0	0		0	0	0	133650	0	21	40213251		
57787	4801	19073188	1997-01-14	1997-01-14 00:00:00	1997-01-28	1997-01-28 00:00:00	1997-01-28	38000177		0	0	14		0	0	0	319407	0	308192	19073188		
52733	4382	1118084	1994-05-03	1994-05-03 00:00:00	1994-05-03	1994-05-03 00:00:00	\N	38000177		0	0	0		0	0	0	291224	0	00025152531	44923712		
56892	4722	1127433	1941-02-23	1941-02-23 00:00:00	1941-03-02	1941-03-02 00:00:00	1941-03-02	38000177		0	0	7		0	0	0	314499	0	313782	1127433		
82462	1801	40213160	1955-06-29	1955-06-29 00:00:00	1955-06-29	1955-06-29 00:00:00	1955-06-29	581452		0	0	0		0	0	0	120719	0	10	40213160		
117294	2578	40213160	1975-07-17	1975-07-17 00:00:00	1975-07-17	1975-07-17 00:00:00	1975-07-17	581452		0	0	0		0	0	0	170726	0	10	40213160		
12221	1024	1127433	1955-07-17	1955-07-17 00:00:00	1955-07-31	1955-07-31 00:00:00	1955-07-31	38000177		0	0	14		0	0	0	67398	0	313782	1127433		
56037	4653	1713671	1982-12-19	1982-12-19 00:00:00	1983-01-09	1983-01-09 00:00:00	1983-01-09	38000177		0	0	21		0	0	0	310167	0	562251	1713671		
45611	994	40213160	1960-03-30	1960-03-30 00:00:00	1960-03-30	1960-03-30 00:00:00	1960-03-30	581452		0	0	0		0	0	0	65897	0	10	40213160		
50791	1113	40213160	1972-07-25	1972-07-25 00:00:00	1972-07-25	1972-07-25 00:00:00	1972-07-25	581452		0	0	0		0	0	0	73281	0	10	40213160		
36129	788	40213296	2009-12-09	2009-12-09 00:00:00	2009-12-09	2009-12-09 00:00:00	2009-12-09	581452		0	0	0		0	0	0	52451	0	52	40213296		
25810	2123	19006318	1953-12-20	1953-12-20 00:00:00	1954-01-03	1954-01-03 00:00:00	1954-01-03	38000177		0	0	14		0	0	0	141255	0	105078	19006318		
138441	3040	40213296	2013-10-17	2013-10-17 00:00:00	2013-10-17	2013-10-17 00:00:00	2013-10-17	581452		0	0	0		0	0	0	202385	0	52	40213296		
8267	689	42902245	1998-02-07	1998-02-07 00:00:00	1999-02-02	1999-02-02 00:00:00	1999-02-02	38000177		0	0	360		0	0	0	45698	0	1359133	42902245		
33758	736	40213296	2013-09-12	2013-09-12 00:00:00	2013-09-12	2013-09-12 00:00:00	2013-09-12	581452		0	0	0		0	0	0	48822	0	52	40213296		
97454	2136	40213160	1968-11-09	1968-11-09 00:00:00	1968-11-09	1968-11-09 00:00:00	1968-11-09	581452		0	0	0		0	0	0	142275	0	10	40213160		
11851	987	1127433	1959-08-12	1959-08-12 00:00:00	1959-08-19	1959-08-19 00:00:00	1959-08-19	38000177		0	0	7		0	0	0	65580	0	313782	1127433		
27683	2291	1127433	2018-12-19	2018-12-19 00:00:00	2018-12-26	2018-12-26 00:00:00	2018-12-26	38000177		0	0	7		0	0	0	152509	0	313782	1127433		
62397	1365	40213260	2015-04-23	2015-04-23 00:00:00	2015-04-23	2015-04-23 00:00:00	2015-04-23	581452		0	0	0		0	0	0	90488	0	121	40213260		
229525	5045	40213260	2010-04-03	2010-04-03 00:00:00	2010-04-03	2010-04-03 00:00:00	2010-04-03	581452		0	0	0		0	0	0	335228	0	121	40213260		
29524	2443	1127433	1963-10-22	1963-10-22 00:00:00	1963-10-28	1963-10-28 00:00:00	1963-10-28	38000177		0	0	6		0	0	0	162025	0	313782	1127433		
198098	4352	40213227	1992-05-07	1992-05-07 00:00:00	1992-05-07	1992-05-07 00:00:00	1992-05-07	581452		0	0	0		0	0	0	288694	0	113	40213227		
44258	964	40213160	1975-07-13	1975-07-13 00:00:00	1975-07-13	1975-07-13 00:00:00	1975-07-13	581452		0	0	0		0	0	0	64195	0	10	40213160		
19244	1588	40236824	2011-12-16	2011-12-16 00:00:00	2011-12-23	2011-12-23 00:00:00	2011-12-23	38000177		0	0	7		0	0	0	106578	0	1094107	40236824		
61250	5096	1127433	1985-01-30	1985-01-30 00:00:00	1985-02-13	1985-02-13 00:00:00	1985-02-13	38000177		0	0	14		0	0	0	338595	0	313782	1127433		
75798	1656	40213227	2009-05-30	2009-05-30 00:00:00	2009-05-30	2009-05-30 00:00:00	2009-05-30	581452		0	0	0		0	0	0	111086	0	113	40213227		
110928	2437	40213306	1983-10-10	1983-10-10 00:00:00	1983-10-10	1983-10-10 00:00:00	1983-10-10	581452		0	0	0		0	0	0	161707	0	43	40213306		
40339	3342	1713671	1947-09-29	1947-09-29 00:00:00	1947-10-20	1947-10-20 00:00:00	1947-10-20	38000177		0	0	21		0	0	0	221607	0	562251	1713671		
184254	4049	40213160	1961-12-12	1961-12-12 00:00:00	1961-12-12	1961-12-12 00:00:00	1961-12-12	581452		0	0	0		0	0	0	269134	0	10	40213160		
214686	4707	40213160	1978-08-17	1978-08-17 00:00:00	1978-08-17	1978-08-17 00:00:00	1978-08-17	581452		0	0	0		0	0	0	313588	0	10	40213160		
203071	4459	40213260	2014-10-28	2014-10-28 00:00:00	2014-10-28	2014-10-28 00:00:00	2014-10-28	581452		0	0	0		0	0	0	296687	0	121	40213260		
214774	4709	40213160	1956-10-15	1956-10-15 00:00:00	1956-10-15	1956-10-15 00:00:00	1956-10-15	581452		0	0	0		0	0	0	313672	0	10	40213160		
72588	1586	40213227	2010-09-12	2010-09-12 00:00:00	2010-09-12	2010-09-12 00:00:00	2010-09-12	581452		0	0	0		0	0	0	106460	0	113	40213227		
72304	1579	40213227	2006-12-28	2006-12-28 00:00:00	2006-12-28	2006-12-28 00:00:00	2006-12-28	581452		0	0	0		0	0	0	106107	0	113	40213227		
169537	3728	40213160	1972-09-24	1972-09-24 00:00:00	1972-09-24	1972-09-24 00:00:00	1972-09-24	581452		0	0	0		0	0	0	247724	0	10	40213160		
88995	1951	40213314	1982-07-21	1982-07-21 00:00:00	1982-07-21	1982-07-21 00:00:00	1982-07-21	581452		0	0	0		0	0	0	129758	0	49	40213314		
162816	3580	40213227	2006-03-10	2006-03-10 00:00:00	2006-03-10	2006-03-10 00:00:00	2006-03-10	581452		0	0	0		0	0	0	238026	0	113	40213227		
54489	1193	40213227	1992-10-15	1992-10-15 00:00:00	1992-10-15	1992-10-15 00:00:00	1992-10-15	581452		0	0	0		0	0	0	78591	0	113	40213227		
45132	3734	19059056	1949-07-12	1949-07-12 00:00:00	1949-07-26	1949-07-26 00:00:00	1949-07-26	38000177		0	0	14		0	0	0	248170	0	243670	19059056		
28279	2334	19018935	2011-06-23	2011-06-23 00:00:00	2011-06-23	2011-06-23 00:00:00	\N	38000177		0	0	0		0	0	0	155281	0	197604	19018935		
9030	753	1713671	1978-10-13	1978-10-13 00:00:00	1978-10-27	1978-10-27 00:00:00	1978-10-27	38000177		0	0	14		0	0	0	49774	0	562251	1713671		
9037	754	1115171	2008-04-09	2008-04-09 00:00:00	2008-05-09	2008-05-09 00:00:00	2008-05-09	38000177		0	0	30		0	0	0	49825	0	849574	1115171		
103620	2273	40213227	2015-09-09	2015-09-09 00:00:00	2015-09-09	2015-09-09 00:00:00	2015-09-09	581452		0	0	0		0	0	0	151130	0	113	40213227		
185662	4080	40213227	2016-06-07	2016-06-07 00:00:00	2016-06-07	2016-06-07 00:00:00	2016-06-07	581452		0	0	0		0	0	0	271165	0	113	40213227		
9165	195	40213296	2000-03-27	2000-03-27 00:00:00	2000-03-27	2000-03-27 00:00:00	2000-03-27	581452		0	0	0		0	0	0	13438	0	52	40213296		
203896	4476	40213227	2013-04-14	2013-04-14 00:00:00	2013-04-14	2013-04-14 00:00:00	2013-04-14	581452		0	0	0		0	0	0	297867	0	113	40213227		
3539	293	1127433	1975-01-20	1975-01-20 00:00:00	1975-02-03	1975-02-03 00:00:00	1975-02-03	38000177		0	0	14		0	0	0	19533	0	313782	1127433		
128157	2818	40213260	2017-12-04	2017-12-04 00:00:00	2017-12-04	2017-12-04 00:00:00	2017-12-04	581452		0	0	0		0	0	0	186770	0	121	40213260		
18468	1528	19133873	1973-01-11	1973-01-11 00:00:00	1973-01-23	1973-01-23 00:00:00	1973-01-23	38000177		0	0	12		0	0	0	102262	0	834061	19133873		
25197	549	40213296	1996-06-05	1996-06-05 00:00:00	1996-06-05	1996-06-05 00:00:00	1996-06-05	581452		0	0	0		0	0	0	36408	0	52	40213296		
146845	3229	40213314	1980-08-15	1980-08-15 00:00:00	1980-08-15	1980-08-15 00:00:00	1980-08-15	581452		0	0	0		0	0	0	214611	0	49	40213314		
210754	4622	40213160	1956-05-03	1956-05-03 00:00:00	1956-05-03	1956-05-03 00:00:00	1956-05-03	581452		0	0	0		0	0	0	307784	0	10	40213160		
41960	915	40213160	1960-06-04	1960-06-04 00:00:00	1960-06-04	1960-06-04 00:00:00	1960-06-04	581452		0	0	0		0	0	0	60817	0	10	40213160		
186376	4094	40213260	2007-09-13	2007-09-13 00:00:00	2007-09-13	2007-09-13 00:00:00	2007-09-13	581452		0	0	0		0	0	0	272135	0	121	40213260		
43088	3571	1127433	1980-10-07	1980-10-07 00:00:00	1980-10-14	1980-10-14 00:00:00	1980-10-14	38000177		0	0	7		0	0	0	237342	0	313782	1127433		
156081	3435	40213160	1976-01-03	1976-01-03 00:00:00	1976-01-03	1976-01-03 00:00:00	1976-01-03	581452		0	0	0		0	0	0	227825	0	10	40213160		
115871	2546	40213296	2017-01-20	2017-01-20 00:00:00	2017-01-20	2017-01-20 00:00:00	2017-01-20	581452		0	0	0		0	0	0	168517	0	52	40213296		
86641	1900	40213306	1986-12-08	1986-12-08 00:00:00	1986-12-08	1986-12-08 00:00:00	1986-12-08	581452		0	0	0		0	0	0	126453	0	43	40213306		
62137	5170	40231925	1981-02-11	1981-02-11 00:00:00	1981-02-11	1981-02-11 00:00:00	\N	38000177		0	0	0		0	0	0	343739	0	1049221	40231925		
209110	4587	40213227	2017-02-11	2017-02-11 00:00:00	2017-02-11	2017-02-11 00:00:00	2017-02-11	581452		0	0	0		0	0	0	305565	0	113	40213227		
189448	4159	40213296	1999-02-13	1999-02-13 00:00:00	1999-02-13	1999-02-13 00:00:00	1999-02-13	581452		0	0	0		0	0	0	276377	0	52	40213296		
6779	571	19059056	1968-02-09	1968-02-09 00:00:00	1968-05-09	1968-05-09 00:00:00	1968-05-09	38000177		0	0	90		0	0	0	37833	0	243670	19059056		
17265	1431	1118084	1989-01-09	1989-01-09 00:00:00	1989-01-09	1989-01-09 00:00:00	\N	38000177		0	0	0		0	0	0	95211	0	00025152531	44923712		
164218	3612	40213227	1994-07-03	1994-07-03 00:00:00	1994-07-03	1994-07-03 00:00:00	1994-07-03	581452		0	0	0		0	0	0	\N	0	113	40213227		
91481	2007	40213180	2009-02-15	2009-02-15 00:00:00	2009-02-15	2009-02-15 00:00:00	2009-02-15	581452		0	0	0		0	0	0	133659	0	114	40213180		
57788	4801	19078461	1997-01-14	1997-01-14 00:00:00	1997-01-28	1997-01-28 00:00:00	1997-01-28	38000177		0	0	14		0	0	0	319407	0	310965	19078461		
52734	4382	1127433	1955-08-17	1955-08-17 00:00:00	1955-08-31	1955-08-31 00:00:00	1955-08-31	38000177		0	0	14		0	0	0	291207	0	313782	1127433		
56893	4722	1713671	1991-03-11	1991-03-11 00:00:00	1991-07-22	1991-07-22 00:00:00	1991-07-22	38000177		0	0	133		0	0	0	314565	0	562251	1713671		
82473	1801	40213260	2006-08-02	2006-08-02 00:00:00	2006-08-02	2006-08-02 00:00:00	2006-08-02	581452		0	0	0		0	0	0	120776	0	121	40213260		
117298	2578	40213227	1992-10-08	1992-10-08 00:00:00	1992-10-08	1992-10-08 00:00:00	1992-10-08	581452		0	0	0		0	0	0	170747	0	113	40213227		
12222	1024	1713671	1995-09-25	1995-09-25 00:00:00	1995-10-16	1995-10-16 00:00:00	1995-10-16	38000177		0	0	21		0	0	0	67401	0	562251	1713671		
56038	4653	1713671	1972-09-17	1972-09-17 00:00:00	1972-10-08	1972-10-08 00:00:00	1972-10-08	38000177		0	0	21		0	0	0	310180	0	562251	1713671		
45613	994	40213160	1959-10-28	1959-10-28 00:00:00	1959-10-28	1959-10-28 00:00:00	1959-10-28	581452		0	0	0		0	0	0	65896	0	10	40213160		
50793	1113	40213227	2013-11-26	2013-11-26 00:00:00	2013-11-26	2013-11-26 00:00:00	2013-11-26	581452		0	0	0		0	0	0	73264	0	113	40213227		
36133	788	40213160	1970-02-18	1970-02-18 00:00:00	1970-02-18	1970-02-18 00:00:00	1970-02-18	581452		0	0	0		0	0	0	52437	0	10	40213160		
25811	2123	19059056	1953-12-20	1953-12-20 00:00:00	1954-01-03	1954-01-03 00:00:00	1954-01-03	38000177		0	0	14		0	0	0	141255	0	243670	19059056		
138444	3040	40213160	1972-11-02	1972-11-02 00:00:00	1972-11-02	1972-11-02 00:00:00	1972-11-02	581452		0	0	0		0	0	0	202374	0	10	40213160		
8268	689	1115171	1997-05-31	1997-05-31 00:00:00	1997-07-30	1997-07-30 00:00:00	1997-07-30	38000177		0	0	60		0	0	0	45624	0	849574	1115171		
33763	736	40213306	1994-08-11	1994-08-11 00:00:00	1994-08-11	1994-08-11 00:00:00	1994-08-11	581452		0	0	0		0	0	0	48819	0	43	40213306		
112930	2480	40213160	1956-02-08	1956-02-08 00:00:00	1956-02-08	1956-02-08 00:00:00	1956-02-08	581452		0	0	0		0	0	0	164336	0	10	40213160		
11852	987	1124300	1988-01-09	1988-01-09 00:00:00	1988-01-09	1988-01-09 00:00:00	\N	38000177		0	0	0		0	0	0	65546	0	00781178901	45011828		
27684	2291	1713671	2014-12-01	2014-12-01 00:00:00	2014-12-08	2014-12-08 00:00:00	2014-12-08	38000177		0	0	7		0	0	0	152428	0	562251	1713671		
62398	1365	40213160	1963-11-28	1963-11-28 00:00:00	1963-11-28	1963-11-28 00:00:00	1963-11-28	581452		0	0	0		0	0	0	90508	0	10	40213160		
229530	5045	40213296	2001-01-20	2001-01-20 00:00:00	2001-01-20	2001-01-20 00:00:00	2001-01-20	581452		0	0	0		0	0	0	335280	0	52	40213296		
29525	2443	40229134	1994-11-08	1994-11-08 00:00:00	1994-11-15	1994-11-15 00:00:00	1994-11-15	38000177		0	0	7		0	0	0	162042	0	1043400	40229134		
198104	4353	40213160	1967-01-15	1967-01-15 00:00:00	1967-01-15	1967-01-15 00:00:00	1967-01-15	581452		0	0	0		0	0	0	288842	0	10	40213160		
44259	964	40213227	1997-01-05	1997-01-05 00:00:00	1997-01-05	1997-01-05 00:00:00	1997-01-05	581452		0	0	0		0	0	0	64159	0	113	40213227		
19245	1588	1127433	1992-03-23	1992-03-23 00:00:00	1992-04-06	1992-04-06 00:00:00	1992-04-06	38000177		0	0	14		0	0	0	106634	0	313782	1127433		
61251	5096	1115171	2019-03-11	2019-03-11 00:00:00	2019-04-15	2019-04-15 00:00:00	2019-04-15	38000177		0	0	35		0	0	0	338614	0	849574	1115171		
52226	1143	40213296	2011-06-03	2011-06-03 00:00:00	2011-06-03	2011-06-03 00:00:00	2011-06-03	581452		0	0	0		0	0	0	75463	0	52	40213296		
110930	2437	40213160	1966-07-18	1966-07-18 00:00:00	1966-07-18	1966-07-18 00:00:00	1966-07-18	581452		0	0	0		0	0	0	161661	0	10	40213160		
40340	3342	1127433	1977-08-13	1977-08-13 00:00:00	1977-08-20	1977-08-20 00:00:00	1977-08-20	38000177		0	0	7		0	0	0	221609	0	313782	1127433		
184256	4049	40213260	2011-04-05	2011-04-05 00:00:00	2011-04-05	2011-04-05 00:00:00	2011-04-05	581452		0	0	0		0	0	0	269159	0	121	40213260		
79533	1740	40213227	2013-11-09	2013-11-09 00:00:00	2013-11-09	2013-11-09 00:00:00	2013-11-09	581452		0	0	0		0	0	0	116287	0	113	40213227		
203073	4459	40213227	2014-10-28	2014-10-28 00:00:00	2014-10-28	2014-10-28 00:00:00	2014-10-28	581452		0	0	0		0	0	0	296687	0	113	40213227		
214775	4709	40213160	1957-01-14	1957-01-14 00:00:00	1957-01-14	1957-01-14 00:00:00	1957-01-14	581452		0	0	0		0	0	0	313639	0	10	40213160		
172192	3786	40213227	2000-03-28	2000-03-28 00:00:00	2000-03-28	2000-03-28 00:00:00	2000-03-28	581452		0	0	0		0	0	0	251693	0	113	40213227		
72308	1579	40213260	2008-01-03	2008-01-03 00:00:00	2008-01-03	2008-01-03 00:00:00	2008-01-03	581452		0	0	0		0	0	0	106059	0	121	40213260		
169540	3728	40213160	1972-04-23	1972-04-23 00:00:00	1972-04-23	1972-04-23 00:00:00	1972-04-23	581452		0	0	0		0	0	0	247723	0	10	40213160		
89005	1951	40213227	2013-01-16	2013-01-16 00:00:00	2013-01-16	2013-01-16 00:00:00	2013-01-16	581452		0	0	0		0	0	0	129775	0	113	40213227		
162818	3580	40213160	1972-12-01	1972-12-01 00:00:00	1972-12-01	1972-12-01 00:00:00	1972-12-01	581452		0	0	0		0	0	0	237985	0	10	40213160		
54492	1193	40213160	1955-09-22	1955-09-22 00:00:00	1955-09-22	1955-09-22 00:00:00	1955-09-22	581452		0	0	0		0	0	0	78638	0	10	40213160		
45133	3734	40162522	1966-02-27	1966-02-27 00:00:00	1966-02-27	1966-02-27 00:00:00	\N	38000177		0	0	0		0	0	0	248171	0	857005	40162522		
28280	2334	40163554	2011-06-23	2011-06-23 00:00:00	2011-06-23	2011-06-23 00:00:00	\N	38000177		0	0	0		0	0	0	155281	0	855332	40163554		
9031	753	1127433	2009-11-11	2009-11-11 00:00:00	2009-11-18	2009-11-18 00:00:00	2009-11-18	38000177		0	0	7		0	0	0	49798	0	313782	1127433		
9038	754	19059056	1950-09-20	1950-09-20 00:00:00	1950-10-20	1950-10-20 00:00:00	1950-10-20	38000177		0	0	30		0	0	0	49820	0	243670	19059056		
23116	502	40213160	1955-01-08	1955-01-08 00:00:00	1955-01-08	1955-01-08 00:00:00	1955-01-08	581452		0	0	0		0	0	0	33639	0	10	40213160		
185663	4080	40213260	2015-06-02	2015-06-02 00:00:00	2015-06-02	2015-06-02 00:00:00	2015-06-02	581452		0	0	0		0	0	0	271194	0	121	40213260		
9167	195	40213227	2000-03-27	2000-03-27 00:00:00	2000-03-27	2000-03-27 00:00:00	2000-03-27	581452		0	0	0		0	0	0	13438	0	113	40213227		
203897	4476	40213260	2013-04-14	2013-04-14 00:00:00	2013-04-14	2013-04-14 00:00:00	2013-04-14	581452		0	0	0		0	0	0	297867	0	121	40213260		
3544	295	1713671	1987-04-14	1987-04-14 00:00:00	1987-05-05	1987-05-05 00:00:00	1987-05-05	38000177		0	0	21		0	0	0	19634	0	562251	1713671		
163422	3595	40213201	2016-02-11	2016-02-11 00:00:00	2016-02-11	2016-02-11 00:00:00	2016-02-11	581452		0	0	0		0	0	0	238821	0	33	40213201		
153957	3389	40213160	1963-08-12	1963-08-12 00:00:00	1963-08-12	1963-08-12 00:00:00	1963-08-12	581452		0	0	0		0	0	0	224811	0	10	40213160		
25206	549	40213260	2006-07-12	2006-07-12 00:00:00	2006-07-12	2006-07-12 00:00:00	2006-07-12	581452		0	0	0		0	0	0	36389	0	121	40213260		
146860	3230	40213160	1955-11-30	1955-11-30 00:00:00	1955-11-30	1955-11-30 00:00:00	1955-11-30	581452		0	0	0		0	0	0	214689	0	10	40213160		
210757	4622	40213260	2007-02-01	2007-02-01 00:00:00	2007-02-01	2007-02-01 00:00:00	2007-02-01	581452		0	0	0		0	0	0	307837	0	121	40213260		
41968	915	40213296	2000-01-01	2000-01-01 00:00:00	2000-01-01	2000-01-01 00:00:00	2000-01-01	581452		0	0	0		0	0	0	60808	0	52	40213296		
186378	4094	40213160	1957-12-19	1957-12-19 00:00:00	1957-12-19	1957-12-19 00:00:00	1957-12-19	581452		0	0	0		0	0	0	272128	0	10	40213160		
43089	3571	1551192	1972-12-17	1972-12-17 00:00:00	1972-12-17	1972-12-17 00:00:00	1972-12-17	38000177		0	0	0		0	0	0	237407	0	312617	1551192		
156083	3435	40213160	1980-04-05	1980-04-05 00:00:00	1980-04-05	1980-04-05 00:00:00	1980-04-05	581452		0	0	0		0	0	0	227819	0	10	40213160		
115873	2546	40213227	2017-01-20	2017-01-20 00:00:00	2017-01-20	2017-01-20 00:00:00	2017-01-20	581452		0	0	0		0	0	0	168517	0	113	40213227		
86645	1900	40213160	1968-09-16	1968-09-16 00:00:00	1968-09-16	1968-09-16 00:00:00	1968-09-16	581452		0	0	0		0	0	0	126467	0	10	40213160		
62138	5170	1127433	1990-03-26	1990-03-26 00:00:00	1990-04-16	1990-04-16 00:00:00	1990-04-16	38000177		0	0	21		0	0	0	343737	0	313782	1127433		
84229	1842	40213296	2007-06-22	2007-06-22 00:00:00	2007-06-22	2007-06-22 00:00:00	2007-06-22	581452		0	0	0		0	0	0	122979	0	52	40213296		
47350	1033	40213296	2011-08-11	2011-08-11 00:00:00	2011-08-11	2011-08-11 00:00:00	2011-08-11	581452		0	0	0		0	0	0	67998	0	52	40213296		
6780	571	40165015	1968-02-09	1968-02-09 00:00:00	1968-02-09	1968-02-09 00:00:00	\N	38000177		0	0	0		0	0	0	37833	0	861467	40165015		
17266	1431	1127433	2003-02-16	2003-02-16 00:00:00	2003-03-02	2003-03-02 00:00:00	2003-03-02	38000177		0	0	14		0	0	0	95253	0	313782	1127433		
164224	3612	40213306	1982-02-21	1982-02-21 00:00:00	1982-02-21	1982-02-21 00:00:00	1982-02-21	581452		0	0	0		0	0	0	239979	0	43	40213306		
91482	2007	40213306	2009-02-15	2009-02-15 00:00:00	2009-02-15	2009-02-15 00:00:00	2009-02-15	581452		0	0	0		0	0	0	133659	0	43	40213306		
57789	4801	19019979	1975-09-15	1975-09-15 00:00:00	1975-09-29	1975-09-29 00:00:00	1975-09-29	38000177		0	0	14		0	0	0	319381	0	198405	19019979		
52735	4382	19133905	1974-10-07	1974-10-07 00:00:00	1974-10-15	1974-10-15 00:00:00	1974-10-15	38000177		0	0	8		0	0	0	291181	0	834102	19133905		
56894	4722	1713671	2008-05-15	2008-05-15 00:00:00	2008-05-22	2008-05-22 00:00:00	2008-05-22	38000177		0	0	7		0	0	0	314522	0	562251	1713671		
82478	1801	40213160	1955-03-30	1955-03-30 00:00:00	1955-03-30	1955-03-30 00:00:00	1955-03-30	581452		0	0	0		0	0	0	120739	0	10	40213160		
117299	2578	40213306	1992-10-08	1992-10-08 00:00:00	1992-10-08	1992-10-08 00:00:00	1992-10-08	581452		0	0	0		0	0	0	170747	0	43	40213306		
12223	1024	1127433	1992-02-10	1992-02-10 00:00:00	1992-02-24	1992-02-24 00:00:00	1992-02-24	38000177		0	0	14		0	0	0	67444	0	313782	1127433		
240704	5284	40213160	1971-08-04	1971-08-04 00:00:00	1971-08-04	1971-08-04 00:00:00	1971-08-04	581452		0	0	0		0	0	0	351586	0	10	40213160		
43617	3615	19059056	1962-05-30	1962-05-30 00:00:00	1962-06-29	1962-06-29 00:00:00	1962-06-29	38000177		0	0	30		0	0	0	240217	0	243670	19059056		
50794	1113	40213296	2013-11-26	2013-11-26 00:00:00	2013-11-26	2013-11-26 00:00:00	2013-11-26	581452		0	0	0		0	0	0	73264	0	52	40213296		
36134	788	40213160	1969-12-17	1969-12-17 00:00:00	1969-12-17	1969-12-17 00:00:00	1969-12-17	581452		0	0	0		0	0	0	52398	0	10	40213160		
25812	2123	19133873	1952-01-08	1952-01-08 00:00:00	1952-01-17	1952-01-17 00:00:00	1952-01-17	38000177		0	0	9		0	0	0	141276	0	834061	19133873		
182353	4006	40213198	2014-03-18	2014-03-18 00:00:00	2014-03-18	2014-03-18 00:00:00	2014-03-18	581452		0	0	0		0	0	0	266180	0	133	40213198		
8269	689	19128022	1996-02-18	1996-02-18 00:00:00	1997-02-12	1997-02-12 00:00:00	1997-02-12	38000177		0	0	360		0	0	0	45695	0	749785	19128022		
33765	736	40213227	1994-08-11	1994-08-11 00:00:00	1994-08-11	1994-08-11 00:00:00	1994-08-11	581452		0	0	0		0	0	0	48819	0	113	40213227		
112934	2480	40213260	2007-11-14	2007-11-14 00:00:00	2007-11-14	2007-11-14 00:00:00	2007-11-14	581452		0	0	0		0	0	0	164329	0	121	40213260		
11853	987	1127433	1979-07-20	1979-07-20 00:00:00	1979-08-24	1979-08-24 00:00:00	1979-08-24	38000177		0	0	35		0	0	0	65521	0	313782	1127433		
27685	2291	19112599	1963-11-03	1963-11-03 00:00:00	1963-11-03	1963-11-03 00:00:00	\N	38000177		0	0	0		0	0	0	152534	0	477045	19112599		
62401	1365	40213160	1968-08-01	1968-08-01 00:00:00	1968-08-01	1968-08-01 00:00:00	1968-08-01	581452		0	0	0		0	0	0	90443	0	10	40213160		
229532	5045	40213160	1960-09-10	1960-09-10 00:00:00	1960-09-10	1960-09-10 00:00:00	1960-09-10	581452		0	0	0		0	0	0	335243	0	10	40213160		
29526	2443	19133905	1980-08-20	1980-08-20 00:00:00	1980-08-30	1980-08-30 00:00:00	1980-08-30	38000177		0	0	10		0	0	0	162038	0	834102	19133905		
198105	4353	40213296	2009-08-23	2009-08-23 00:00:00	2009-08-23	2009-08-23 00:00:00	2009-08-23	581452		0	0	0		0	0	0	288791	0	52	40213296		
44260	964	40213306	1997-01-05	1997-01-05 00:00:00	1997-01-05	1997-01-05 00:00:00	1997-01-05	581452		0	0	0		0	0	0	64159	0	43	40213306		
19246	1588	1713671	2010-07-20	2010-07-20 00:00:00	2010-07-27	2010-07-27 00:00:00	2010-07-27	38000177		0	0	7		0	0	0	106612	0	562251	1713671		
61252	5096	19128065	1987-03-09	1987-03-09 00:00:00	1988-03-03	1988-03-03 00:00:00	1988-03-03	38000177		0	0	360		0	0	0	338604	0	749882	19128065		
52230	1143	40213306	1992-02-14	1992-02-14 00:00:00	1992-02-14	1992-02-14 00:00:00	1992-02-14	581452		0	0	0		0	0	0	\N	0	43	40213306		
110931	2437	40213160	1961-11-13	1961-11-13 00:00:00	1961-11-13	1961-11-13 00:00:00	1961-11-13	581452		0	0	0		0	0	0	161696	0	10	40213160		
40341	3342	19059056	1923-07-24	1923-07-24 00:00:00	1923-08-14	1923-08-14 00:00:00	1923-08-14	38000177		0	0	21		0	0	0	221628	0	243670	19059056		
184269	4049	40213160	1961-07-11	1961-07-11 00:00:00	1961-07-11	1961-07-11 00:00:00	1961-07-11	581452		0	0	0		0	0	0	269133	0	10	40213160		
79540	1740	40213227	1994-09-10	1994-09-10 00:00:00	1994-09-10	1994-09-10 00:00:00	1994-09-10	581452		0	0	0		0	0	0	116282	0	113	40213227		
203075	4459	40213160	1964-01-27	1964-01-27 00:00:00	1964-01-27	1964-01-27 00:00:00	1964-01-27	581452		0	0	0		0	0	0	296712	0	10	40213160		
203110	4459	40213260	2013-10-22	2013-10-22 00:00:00	2013-10-22	2013-10-22 00:00:00	2013-10-22	581452		0	0	0		0	0	0	296703	0	121	40213260		
172193	3786	40213296	2000-03-28	2000-03-28 00:00:00	2000-03-28	2000-03-28 00:00:00	2000-03-28	581452		0	0	0		0	0	0	251693	0	52	40213296		
72314	1579	40213160	1955-04-07	1955-04-07 00:00:00	1955-04-07	1955-04-07 00:00:00	1955-04-07	581452		0	0	0		0	0	0	106072	0	10	40213160		
169546	3728	40213160	1976-12-26	1976-12-26 00:00:00	1976-12-26	1976-12-26 00:00:00	1976-12-26	581452		0	0	0		0	0	0	247748	0	10	40213160		
89016	1952	40213160	1955-07-11	1955-07-11 00:00:00	1955-07-11	1955-07-11 00:00:00	1955-07-11	581452		0	0	0		0	0	0	129818	0	10	40213160		
74310	1622	40213227	1995-11-20	1995-11-20 00:00:00	1995-11-20	1995-11-20 00:00:00	1995-11-20	581452		0	0	0		0	0	0	\N	0	113	40213227		
54497	1193	40213227	2000-06-29	2000-06-29 00:00:00	2000-06-29	2000-06-29 00:00:00	2000-06-29	581452		0	0	0		0	0	0	78593	0	113	40213227		
45134	3734	19059056	1966-02-27	1966-02-27 00:00:00	1966-05-28	1966-05-28 00:00:00	1966-05-28	38000177		0	0	90		0	0	0	248171	0	243670	19059056		
11687	250	40213314	1977-01-19	1977-01-19 00:00:00	1977-01-19	1977-01-19 00:00:00	1977-01-19	581452		0	0	0		0	0	0	16808	0	49	40213314		
9032	754	1127433	1950-08-12	1950-08-12 00:00:00	1950-08-26	1950-08-26 00:00:00	1950-08-26	38000177		0	0	14		0	0	0	49845	0	313782	1127433		
9039	754	40231925	1950-09-20	1950-09-20 00:00:00	1950-09-20	1950-09-20 00:00:00	\N	38000177		0	0	0		0	0	0	49820	0	1049221	40231925		
23145	502	40213227	2008-03-15	2008-03-15 00:00:00	2008-03-15	2008-03-15 00:00:00	2008-03-15	581452		0	0	0		0	0	0	33629	0	113	40213227		
185664	4080	40213260	2016-06-07	2016-06-07 00:00:00	2016-06-07	2016-06-07 00:00:00	2016-06-07	581452		0	0	0		0	0	0	271165	0	121	40213260		
9169	195	40213160	1963-02-25	1963-02-25 00:00:00	1963-02-25	1963-02-25 00:00:00	1963-02-25	581452		0	0	0		0	0	0	13370	0	10	40213160		
49788	1091	40213227	2007-11-29	2007-11-29 00:00:00	2007-11-29	2007-11-29 00:00:00	2007-11-29	581452		0	0	0		0	0	0	71715	0	113	40213227		
3546	295	1115171	2015-11-24	2015-11-24 00:00:00	2016-02-22	2016-02-22 00:00:00	2016-02-22	38000177		0	0	90		0	0	0	19645	0	849574	1115171		
163427	3595	40213160	1955-03-31	1955-03-31 00:00:00	1955-03-31	1955-03-31 00:00:00	1955-03-31	581452		0	0	0		0	0	0	238854	0	10	40213160		
153960	3389	40213160	1959-02-09	1959-02-09 00:00:00	1959-02-09	1959-02-09 00:00:00	1959-02-09	581452		0	0	0		0	0	0	224783	0	10	40213160		
197206	4333	40213160	1958-08-07	1958-08-07 00:00:00	1958-08-07	1958-08-07 00:00:00	1958-08-07	581452		0	0	0		0	0	0	287433	0	10	40213160		
61266	1339	40213296	2006-04-20	2006-04-20 00:00:00	2006-04-20	2006-04-20 00:00:00	2006-04-20	581452		0	0	0		0	0	0	88803	0	52	40213296		
210759	4622	40213227	2007-02-01	2007-02-01 00:00:00	2007-02-01	2007-02-01 00:00:00	2007-02-01	581452		0	0	0		0	0	0	307837	0	113	40213227		
41970	915	40213160	1960-04-02	1960-04-02 00:00:00	1960-04-02	1960-04-02 00:00:00	1960-04-02	581452		0	0	0		0	0	0	60846	0	10	40213160		
186380	4094	40213160	1958-02-20	1958-02-20 00:00:00	1958-02-20	1958-02-20 00:00:00	1958-02-20	581452		0	0	0		0	0	0	272120	0	10	40213160		
43090	3571	1127433	1983-10-20	1983-10-20 00:00:00	1984-01-18	1984-01-18 00:00:00	1984-01-18	38000177		0	0	90		0	0	0	237438	0	313782	1127433		
156087	3435	40213314	1978-04-01	1978-04-01 00:00:00	1978-04-01	1978-04-01 00:00:00	1978-04-01	581452		0	0	0		0	0	0	227803	0	49	40213314		
115875	2546	40213160	1975-12-05	1975-12-05 00:00:00	1975-12-05	1975-12-05 00:00:00	1975-12-05	581452		0	0	0		0	0	0	168470	0	10	40213160		
86650	1900	40213227	1995-12-18	1995-12-18 00:00:00	1995-12-18	1995-12-18 00:00:00	1995-12-18	581452		0	0	0		0	0	0	126491	0	113	40213227		
62140	5170	19128065	1985-12-08	1985-12-08 00:00:00	1986-12-03	1986-12-03 00:00:00	1986-12-03	38000177		0	0	360		0	0	0	343775	0	749882	19128065		
84231	1842	40213227	2007-06-22	2007-06-22 00:00:00	2007-06-22	2007-06-22 00:00:00	2007-06-22	581452		0	0	0		0	0	0	122979	0	113	40213227		
47352	1033	40213160	1972-04-13	1972-04-13 00:00:00	1972-04-13	1972-04-13 00:00:00	1972-04-13	581452		0	0	0		0	0	0	68015	0	10	40213160		
6781	571	1118084	1992-01-03	1992-01-03 00:00:00	1992-01-03	1992-01-03 00:00:00	\N	38000177		0	0	0		0	0	0	37806	0	00025152531	44923712		
17267	1431	19078461	2000-05-18	2000-05-18 00:00:00	2000-06-01	2000-06-01 00:00:00	2000-06-01	38000177		0	0	14		0	0	0	95252	0	310965	19078461		
164230	3612	40213160	1964-11-29	1964-11-29 00:00:00	1964-11-29	1964-11-29 00:00:00	1964-11-29	581452		0	0	0		0	0	0	239949	0	10	40213160		
91484	2007	40213227	2009-02-15	2009-02-15 00:00:00	2009-02-15	2009-02-15 00:00:00	2009-02-15	581452		0	0	0		0	0	0	133659	0	113	40213227		
57790	4801	19129655	1975-09-15	1975-09-15 00:00:00	1975-09-29	1975-09-29 00:00:00	1975-09-29	38000177		0	0	14		0	0	0	319381	0	789980	19129655		
52736	4383	19059056	1970-09-07	1970-09-07 00:00:00	1970-09-28	1970-09-28 00:00:00	1970-09-28	38000177		0	0	21		0	0	0	291334	0	243670	19059056		
56895	4722	1115171	1996-06-19	1996-06-19 00:00:00	1996-07-10	1996-07-10 00:00:00	1996-07-10	38000177		0	0	21		0	0	0	314615	0	849574	1115171		
212211	4653	40213227	1992-05-17	1992-05-17 00:00:00	1992-05-17	1992-05-17 00:00:00	1992-05-17	581452		0	0	0		0	0	0	310122	0	113	40213227		
117300	2578	40213160	1971-02-04	1971-02-04 00:00:00	1971-02-04	1971-02-04 00:00:00	1971-02-04	581452		0	0	0		0	0	0	170719	0	10	40213160		
12224	1025	1127433	1958-03-10	1958-03-10 00:00:00	1958-03-17	1958-03-17 00:00:00	1958-03-17	38000177		0	0	7		0	0	0	67541	0	313782	1127433		
240711	5284	40213296	2009-10-14	2009-10-14 00:00:00	2009-10-14	2009-10-14 00:00:00	2009-10-14	581452		0	0	0		0	0	0	351487	0	52	40213296		
43618	3615	40231925	1962-05-30	1962-05-30 00:00:00	1962-05-30	1962-05-30 00:00:00	\N	38000177		0	0	0		0	0	0	240217	0	1049221	40231925		
50799	1113	40213160	1976-10-26	1976-10-26 00:00:00	1976-10-26	1976-10-26 00:00:00	1976-10-26	581452		0	0	0		0	0	0	73268	0	10	40213160		
36138	788	40213306	1991-11-13	1991-11-13 00:00:00	1991-11-13	1991-11-13 00:00:00	1991-11-13	581452		0	0	0		0	0	0	52424	0	43	40213306		
25813	2123	19078461	1995-10-23	1995-10-23 00:00:00	1995-12-22	1995-12-22 00:00:00	1995-12-22	38000177		0	0	60		0	0	0	141320	0	310965	19078461		
182361	4006	40213227	2010-02-23	2010-02-23 00:00:00	2010-02-23	2010-02-23 00:00:00	2010-02-23	581452		0	0	0		0	0	0	266220	0	113	40213227		
8275	691	1713671	1985-11-18	1985-11-18 00:00:00	1985-11-25	1985-11-25 00:00:00	1985-11-25	38000177		0	0	7		0	0	0	45745	0	562251	1713671		
33772	736	40213296	2015-09-17	2015-09-17 00:00:00	2015-09-17	2015-09-17 00:00:00	2015-09-17	581452		0	0	0		0	0	0	48831	0	52	40213296		
112937	2481	40213296	2011-03-13	2011-03-13 00:00:00	2011-03-13	2011-03-13 00:00:00	2011-03-13	581452		0	0	0		0	0	0	164365	0	52	40213296		
11854	987	19074841	1979-07-20	1979-07-20 00:00:00	1979-08-24	1979-08-24 00:00:00	1979-08-24	38000177		0	0	35		0	0	0	65521	0	309043	19074841		
27686	2291	1127078	1971-02-18	1971-02-18 00:00:00	1971-04-26	1971-04-26 00:00:00	1971-04-26	38000177		0	0	67		0	0	0	152490	0	282464	1127078		
62403	1365	40213227	1995-03-09	1995-03-09 00:00:00	1995-03-09	1995-03-09 00:00:00	1995-03-09	581452		0	0	0		0	0	0	90450	0	113	40213227		
229538	5045	40213227	1993-01-09	1993-01-09 00:00:00	1993-01-09	1993-01-09 00:00:00	1993-01-09	581452		0	0	0		0	0	0	335255	0	113	40213227		
29527	2443	19059056	1965-05-12	1965-05-12 00:00:00	1965-05-26	1965-05-26 00:00:00	1965-05-26	38000177		0	0	14		0	0	0	162029	0	243670	19059056		
198113	4353	40213260	2017-09-17	2017-09-17 00:00:00	2017-09-17	2017-09-17 00:00:00	2017-09-17	581452		0	0	0		0	0	0	288792	0	121	40213260		
44263	964	40213227	2006-01-15	2006-01-15 00:00:00	2006-01-15	2006-01-15 00:00:00	2006-01-15	581452		0	0	0		0	0	0	64162	0	113	40213227		
19247	1588	1713671	1998-12-11	1998-12-11 00:00:00	1999-01-01	1999-01-01 00:00:00	1999-01-01	38000177		0	0	21		0	0	0	106644	0	562251	1713671		
61253	5096	1713671	1981-10-03	1981-10-03 00:00:00	1981-12-19	1981-12-19 00:00:00	1981-12-19	38000177		0	0	77		0	0	0	338578	0	562251	1713671		
52231	1143	40213306	1994-05-13	1994-05-13 00:00:00	1994-05-13	1994-05-13 00:00:00	1994-05-13	581452		0	0	0		0	0	0	75467	0	43	40213306		
203227	4462	40213160	1955-05-12	1955-05-12 00:00:00	1955-05-12	1955-05-12 00:00:00	1955-05-12	581452		0	0	0		0	0	0	296944	0	10	40213160		
40342	3342	1127433	1952-11-13	1952-11-13 00:00:00	1952-11-20	1952-11-20 00:00:00	1952-11-20	38000177		0	0	7		0	0	0	221666	0	313782	1127433		
184276	4049	40213160	1966-03-15	1966-03-15 00:00:00	1966-03-15	1966-03-15 00:00:00	1966-03-15	581452		0	0	0		0	0	0	269178	0	10	40213160		
79544	1740	40213160	1956-02-11	1956-02-11 00:00:00	1956-02-11	1956-02-11 00:00:00	1956-02-11	581452		0	0	0		0	0	0	116276	0	10	40213160		
203081	4459	40213160	1964-03-30	1964-03-30 00:00:00	1964-03-30	1964-03-30 00:00:00	1964-03-30	581452		0	0	0		0	0	0	296689	0	10	40213160		
203112	4459	40213227	2005-10-31	2005-10-31 00:00:00	2005-10-31	2005-10-31 00:00:00	2005-10-31	581452		0	0	0		0	0	0	296697	0	113	40213227		
172196	3786	40213306	1981-06-16	1981-06-16 00:00:00	1981-06-16	1981-06-16 00:00:00	1981-06-16	581452		0	0	0		0	0	0	251692	0	43	40213306		
49104	1076	40213160	1978-04-28	1978-04-28 00:00:00	1978-04-28	1978-04-28 00:00:00	1978-04-28	581452		0	0	0		0	0	0	70573	0	10	40213160		
169549	3728	40213227	2004-04-25	2004-04-25 00:00:00	2004-04-25	2004-04-25 00:00:00	2004-04-25	581452		0	0	0		0	0	0	247705	0	113	40213227		
161929	3562	40213160	1973-08-01	1973-08-01 00:00:00	1973-08-01	1973-08-01 00:00:00	1973-08-01	581452		0	0	0		0	0	0	236576	0	10	40213160		
74311	1622	40213306	1995-11-20	1995-11-20 00:00:00	1995-11-20	1995-11-20 00:00:00	1995-11-20	581452		0	0	0		0	0	0	\N	0	43	40213306		
36867	3049	46275916	1991-07-12	1991-07-12 00:00:00	1991-07-12	1991-07-12 00:00:00	1991-07-12	38000177		0	0	0		0	0	0	202875	0	1660014	46275916		
45135	3734	46233710	1978-03-26	1978-03-26 00:00:00	1978-04-09	1978-04-09 00:00:00	1978-04-09	38000177		0	0	14		0	0	0	248173	0	1650142	46233710		
113847	2501	40213227	1995-07-31	1995-07-31 00:00:00	1995-07-31	1995-07-31 00:00:00	1995-07-31	581452		0	0	0		0	0	0	165592	0	113	40213227		
9033	754	19059056	1938-02-20	1938-02-20 00:00:00	1938-03-06	1938-03-06 00:00:00	1938-03-06	38000177		0	0	14		0	0	0	49905	0	243670	19059056		
9040	754	19059056	1939-11-24	1939-11-24 00:00:00	1939-12-08	1939-12-08 00:00:00	1939-12-08	38000177		0	0	14		0	0	0	49924	0	243670	19059056		
70090	1532	40213314	1978-12-06	1978-12-06 00:00:00	1978-12-06	1978-12-06 00:00:00	1978-12-06	581452		0	0	0		0	0	0	102582	0	49	40213314		
185670	4080	40213296	2005-06-07	2005-06-07 00:00:00	2005-06-07	2005-06-07 00:00:00	2005-06-07	581452		0	0	0		0	0	0	271192	0	52	40213296		
9175	196	40213227	2005-10-22	2005-10-22 00:00:00	2005-10-22	2005-10-22 00:00:00	2005-10-22	581452		0	0	0		0	0	0	13496	0	113	40213227		
49789	1091	40213260	2007-11-29	2007-11-29 00:00:00	2007-11-29	2007-11-29 00:00:00	2007-11-29	581452		0	0	0		0	0	0	71715	0	121	40213260		
3548	295	40162522	2017-02-16	2017-02-16 00:00:00	2017-02-16	2017-02-16 00:00:00	\N	38000177		0	0	0		0	0	0	19646	0	857005	40162522		
174708	3841	40213296	2015-09-23	2015-09-23 00:00:00	2015-09-23	2015-09-23 00:00:00	2015-09-23	581452		0	0	0		0	0	0	255017	0	52	40213296		
77252	1689	40213227	2002-10-10	2002-10-10 00:00:00	2002-10-10	2002-10-10 00:00:00	2002-10-10	581452		0	0	0		0	0	0	113152	0	113	40213227		
197209	4333	40213160	1955-02-03	1955-02-03 00:00:00	1955-02-03	1955-02-03 00:00:00	1955-02-03	581452		0	0	0		0	0	0	287421	0	10	40213160		
61271	1339	40213227	2017-08-31	2017-08-31 00:00:00	2017-08-31	2017-08-31 00:00:00	2017-08-31	581452		0	0	0		0	0	0	88805	0	113	40213227		
210763	4622	40213260	2006-01-26	2006-01-26 00:00:00	2006-01-26	2006-01-26 00:00:00	2006-01-26	581452		0	0	0		0	0	0	307854	0	121	40213260		
41973	915	40213227	2002-01-05	2002-01-05 00:00:00	2002-01-05	2002-01-05 00:00:00	2002-01-05	581452		0	0	0		0	0	0	60796	0	113	40213227		
186382	4094	40213160	1958-05-22	1958-05-22 00:00:00	1958-05-22	1958-05-22 00:00:00	1958-05-22	581452		0	0	0		0	0	0	272153	0	10	40213160		
43091	3571	1713671	1979-03-07	1979-03-07 00:00:00	1979-03-28	1979-03-28 00:00:00	1979-03-28	38000177		0	0	21		0	0	0	237384	0	562251	1713671		
167373	3680	40213251	1984-03-13	1984-03-13 00:00:00	1984-03-13	1984-03-13 00:00:00	1984-03-13	581452		0	0	0		0	0	0	244732	0	21	40213251		
115877	2546	40213160	1980-03-07	1980-03-07 00:00:00	1980-03-07	1980-03-07 00:00:00	1980-03-07	581452		0	0	0		0	0	0	168503	0	10	40213160		
86652	1900	40213260	2013-10-07	2013-10-07 00:00:00	2013-10-07	2013-10-07 00:00:00	2013-10-07	581452		0	0	0		0	0	0	126521	0	121	40213260		
62141	5170	1127078	1980-03-20	1980-03-20 00:00:00	1980-04-10	1980-04-10 00:00:00	1980-04-10	38000177		0	0	21		0	0	0	343734	0	282464	1127078		
84236	1843	40213160	1981-11-25	1981-11-25 00:00:00	1981-11-25	1981-11-25 00:00:00	1981-11-25	581452		0	0	0		0	0	0	122999	0	10	40213160		
47355	1033	40213227	2002-11-07	2002-11-07 00:00:00	2002-11-07	2002-11-07 00:00:00	2002-11-07	581452		0	0	0		0	0	0	68006	0	113	40213227		
6782	571	1713671	1980-02-08	1980-02-08 00:00:00	1980-02-29	1980-02-29 00:00:00	1980-02-29	38000177		0	0	21		0	0	0	37772	0	562251	1713671		
17268	1431	1127433	2003-03-14	2003-03-14 00:00:00	2003-03-21	2003-03-21 00:00:00	2003-03-21	38000177		0	0	7		0	0	0	95305	0	313782	1127433		
129413	2845	40213201	2019-03-28	2019-03-28 00:00:00	2019-03-28	2019-03-28 00:00:00	2019-03-28	581452		0	0	0		0	0	0	188957	0	33	40213201		
91485	2007	40213160	1987-07-12	1987-07-12 00:00:00	1987-07-12	1987-07-12 00:00:00	1987-07-12	581452		0	0	0		0	0	0	133683	0	10	40213160		
57791	4801	19128065	1986-07-15	1986-07-15 00:00:00	1987-07-10	1987-07-10 00:00:00	1987-07-10	38000177		0	0	360		0	0	0	319382	0	749882	19128065		
52737	4383	1713671	1970-10-13	1970-10-13 00:00:00	1970-10-27	1970-10-27 00:00:00	1970-10-27	38000177		0	0	14		0	0	0	291305	0	562251	1713671		
56896	4722	1127433	1946-04-17	1946-04-17 00:00:00	1946-04-24	1946-04-24 00:00:00	1946-04-24	38000177		0	0	7		0	0	0	314563	0	313782	1127433		
212212	4653	40213160	1959-05-31	1959-05-31 00:00:00	1959-05-31	1959-05-31 00:00:00	1959-05-31	581452		0	0	0		0	0	0	310143	0	10	40213160		
117304	2578	40213296	2010-09-02	2010-09-02 00:00:00	2010-09-02	2010-09-02 00:00:00	2010-09-02	581452		0	0	0		0	0	0	170761	0	52	40213296		
12225	1025	19059056	1945-02-24	1945-02-24 00:00:00	1945-03-31	1945-03-31 00:00:00	1945-03-31	38000177		0	0	35		0	0	0	67581	0	243670	19059056		
240715	5284	40213227	2007-10-10	2007-10-10 00:00:00	2007-10-10	2007-10-10 00:00:00	2007-10-10	581452		0	0	0		0	0	0	351591	0	113	40213227		
43620	3615	40236824	1982-09-30	1982-09-30 00:00:00	1982-10-14	1982-10-14 00:00:00	1982-10-14	38000177		0	0	14		0	0	0	240202	0	1094107	40236824		
50800	1113	40213160	1972-04-25	1972-04-25 00:00:00	1972-04-25	1972-04-25 00:00:00	1972-04-25	581452		0	0	0		0	0	0	73232	0	10	40213160		
36146	788	40213160	1970-05-20	1970-05-20 00:00:00	1970-05-20	1970-05-20 00:00:00	1970-05-20	581452		0	0	0		0	0	0	52399	0	10	40213160		
25814	2123	40231925	1994-10-28	1994-10-28 00:00:00	1994-10-28	1994-10-28 00:00:00	\N	38000177		0	0	0		0	0	0	141239	0	1049221	40231925		
182367	4006	40213227	1999-12-28	1999-12-28 00:00:00	1999-12-28	1999-12-28 00:00:00	1999-12-28	581452		0	0	0		0	0	0	266206	0	113	40213227		
8276	691	1127433	1991-09-17	1991-09-17 00:00:00	1991-10-15	1991-10-15 00:00:00	1991-10-15	38000177		0	0	28		0	0	0	45787	0	313782	1127433		
100944	2213	40213260	2011-12-28	2011-12-28 00:00:00	2011-12-28	2011-12-28 00:00:00	2011-12-28	581452		0	0	0		0	0	0	147406	0	121	40213260		
112939	2481	40213227	2011-03-13	2011-03-13 00:00:00	2011-03-13	2011-03-13 00:00:00	2011-03-13	581452		0	0	0		0	0	0	164365	0	113	40213227		
11855	987	40165015	1965-10-26	1965-10-26 00:00:00	1965-10-26	1965-10-26 00:00:00	\N	38000177		0	0	0		0	0	0	65519	0	861467	40165015		
27687	2291	1127433	1989-05-21	1989-05-21 00:00:00	1989-06-04	1989-06-04 00:00:00	1989-06-04	38000177		0	0	14		0	0	0	152486	0	313782	1127433		
205183	4503	40213227	2007-02-20	2007-02-20 00:00:00	2007-02-20	2007-02-20 00:00:00	2007-02-20	581452		0	0	0		0	0	0	299825	0	113	40213227		
229541	5045	40213260	2011-04-09	2011-04-09 00:00:00	2011-04-09	2011-04-09 00:00:00	2011-04-09	581452		0	0	0		0	0	0	335259	0	121	40213260		
29528	2443	19129655	1965-05-12	1965-05-12 00:00:00	1965-05-26	1965-05-26 00:00:00	1965-05-26	38000177		0	0	14		0	0	0	162029	0	789980	19129655		
198115	4353	40213227	2017-09-17	2017-09-17 00:00:00	2017-09-17	2017-09-17 00:00:00	2017-09-17	581452		0	0	0		0	0	0	288792	0	113	40213227		
44266	964	40213160	1975-02-09	1975-02-09 00:00:00	1975-02-09	1975-02-09 00:00:00	1975-02-09	581452		0	0	0		0	0	0	64194	0	10	40213160		
19249	1590	40162522	2014-08-23	2014-08-23 00:00:00	2014-08-23	2014-08-23 00:00:00	\N	38000177		0	0	0		0	0	0	106721	0	857005	40162522		
61254	5096	19128065	1985-03-19	1985-03-19 00:00:00	1986-03-14	1986-03-14 00:00:00	1986-03-14	38000177		0	0	360		0	0	0	338587	0	749882	19128065		
52234	1143	40213227	1994-05-13	1994-05-13 00:00:00	1994-05-13	1994-05-13 00:00:00	1994-05-13	581452		0	0	0		0	0	0	75467	0	113	40213227		
203231	4462	40213296	1997-03-27	1997-03-27 00:00:00	1997-03-27	1997-03-27 00:00:00	1997-03-27	581452		0	0	0		0	0	0	296906	0	52	40213296		
40343	3342	1713671	1912-05-27	1912-05-27 00:00:00	1912-06-17	1912-06-17 00:00:00	1912-06-17	38000177		0	0	21		0	0	0	221570	0	562251	1713671		
184283	4049	40213306	1983-02-15	1983-02-15 00:00:00	1983-02-15	1983-02-15 00:00:00	1983-02-15	581452		0	0	0		0	0	0	269189	0	43	40213306		
79549	1740	40213227	2003-09-13	2003-09-13 00:00:00	2003-09-13	2003-09-13 00:00:00	2003-09-13	581452		0	0	0		0	0	0	116283	0	113	40213227		
203089	4459	40213227	1995-03-13	1995-03-13 00:00:00	1995-03-13	1995-03-13 00:00:00	1995-03-13	581452		0	0	0		0	0	0	296684	0	113	40213227		
203113	4459	40213296	2005-10-31	2005-10-31 00:00:00	2005-10-31	2005-10-31 00:00:00	2005-10-31	581452		0	0	0		0	0	0	296697	0	52	40213296		
78584	1719	40213160	1962-03-27	1962-03-27 00:00:00	1962-03-27	1962-03-27 00:00:00	1962-03-27	581452		0	0	0		0	0	0	114910	0	10	40213160		
49107	1076	40213160	1973-08-17	1973-08-17 00:00:00	1973-08-17	1973-08-17 00:00:00	1973-08-17	581452		0	0	0		0	0	0	70570	0	10	40213160		
169553	3728	40213296	2012-05-06	2012-05-06 00:00:00	2012-05-06	2012-05-06 00:00:00	2012-05-06	581452		0	0	0		0	0	0	247714	0	52	40213296		
161934	3562	40213160	1969-01-29	1969-01-29 00:00:00	1969-01-29	1969-01-29 00:00:00	1969-01-29	581452		0	0	0		0	0	0	236573	0	10	40213160		
74312	1622	40213306	1997-05-05	1997-05-05 00:00:00	1997-05-05	1997-05-05 00:00:00	1997-05-05	581452		0	0	0		0	0	0	108991	0	43	40213306		
36868	3049	40243436	1991-07-12	1991-07-12 00:00:00	1991-07-12	1991-07-12 00:00:00	1991-07-12	38000177		0	0	0		0	0	0	202875	0	1190795	40243436		
45136	3734	19059056	1978-03-26	1978-03-26 00:00:00	1978-04-09	1978-04-09 00:00:00	1978-04-09	38000177		0	0	14		0	0	0	248173	0	243670	19059056		
113850	2501	40213260	2012-12-03	2012-12-03 00:00:00	2012-12-03	2012-12-03 00:00:00	2012-12-03	581452		0	0	0		0	0	0	165583	0	121	40213260		
9034	754	1127433	1947-08-03	1947-08-03 00:00:00	1947-08-17	1947-08-17 00:00:00	1947-08-17	38000177		0	0	14		0	0	0	49844	0	313782	1127433		
9041	754	1127433	1952-07-11	1952-07-11 00:00:00	1952-08-10	1952-08-10 00:00:00	1952-08-10	38000177		0	0	30		0	0	0	49821	0	313782	1127433		
70093	1532	40213227	2008-12-10	2008-12-10 00:00:00	2008-12-10	2008-12-10 00:00:00	2008-12-10	581452		0	0	0		0	0	0	102632	0	113	40213227		
185677	4080	40213306	1988-02-02	1988-02-02 00:00:00	1988-02-02	1988-02-02 00:00:00	1988-02-02	581452		0	0	0		0	0	0	271188	0	43	40213306		
9176	196	40213160	1959-09-26	1959-09-26 00:00:00	1959-09-26	1959-09-26 00:00:00	1959-09-26	581452		0	0	0		0	0	0	13513	0	10	40213160		
49795	1091	40213160	1957-02-14	1957-02-14 00:00:00	1957-02-14	1957-02-14 00:00:00	1957-02-14	581452		0	0	0		0	0	0	71600	0	10	40213160		
3549	295	19078461	2017-02-16	2017-02-16 00:00:00	2017-05-17	2017-05-17 00:00:00	2017-05-17	38000177		0	0	90		0	0	0	19646	0	310965	19078461		
174712	3841	40213160	1976-09-08	1976-09-08 00:00:00	1976-09-08	1976-09-08 00:00:00	1976-09-08	581452		0	0	0		0	0	0	255001	0	10	40213160		
77263	1689	40213201	2007-11-08	2007-11-08 00:00:00	2007-11-08	2007-11-08 00:00:00	2007-11-08	581452		0	0	0		0	0	0	113054	0	33	40213201		
197216	4333	40213227	2014-10-30	2014-10-30 00:00:00	2014-10-30	2014-10-30 00:00:00	2014-10-30	581452		0	0	0		0	0	0	287407	0	113	40213227		
61272	1339	40213260	2017-08-31	2017-08-31 00:00:00	2017-08-31	2017-08-31 00:00:00	2017-08-31	581452		0	0	0		0	0	0	88805	0	121	40213260		
210779	4623	40213227	1992-10-13	1992-10-13 00:00:00	1992-10-13	1992-10-13 00:00:00	1992-10-13	581452		0	0	0		0	0	0	307891	0	113	40213227		
104387	2289	40213227	2000-11-07	2000-11-07 00:00:00	2000-11-07	2000-11-07 00:00:00	2000-11-07	581452		0	0	0		0	0	0	152310	0	113	40213227		
24783	2037	1127078	1966-02-13	1966-02-13 00:00:00	1966-03-13	1966-03-13 00:00:00	1966-03-13	38000177		0	0	28		0	0	0	135658	0	282464	1127078		
43092	3571	19008572	1986-12-08	1986-12-08 00:00:00	1986-12-22	1986-12-22 00:00:00	1986-12-22	38000177		0	0	14		0	0	0	237386	0	106258	19008572		
167376	3680	40213160	1984-03-13	1984-03-13 00:00:00	1984-03-13	1984-03-13 00:00:00	1984-03-13	581452		0	0	0		0	0	0	244732	0	10	40213160		
115883	2546	40213227	2009-01-09	2009-01-09 00:00:00	2009-01-09	2009-01-09 00:00:00	2009-01-09	581452		0	0	0		0	0	0	168527	0	113	40213227		
86661	1900	40213160	1964-03-16	1964-03-16 00:00:00	1964-03-16	1964-03-16 00:00:00	1964-03-16	581452		0	0	0		0	0	0	126461	0	10	40213160		
62142	5170	19128065	1988-11-22	1988-11-22 00:00:00	1989-11-17	1989-11-17 00:00:00	1989-11-17	38000177		0	0	360		0	0	0	343798	0	749882	19128065		
84238	1843	40213314	1981-11-25	1981-11-25 00:00:00	1981-11-25	1981-11-25 00:00:00	1981-11-25	581452		0	0	0		0	0	0	122999	0	49	40213314		
47362	1033	40213160	1971-11-11	1971-11-11 00:00:00	1971-11-11	1971-11-11 00:00:00	1971-11-11	581452		0	0	0		0	0	0	67992	0	10	40213160		
6783	571	1127433	1980-05-17	1980-05-17 00:00:00	1980-05-31	1980-05-31 00:00:00	1980-05-31	38000177		0	0	14		0	0	0	37773	0	313782	1127433		
17269	1431	1127433	1967-08-04	1967-08-04 00:00:00	1967-08-18	1967-08-18 00:00:00	1967-08-18	38000177		0	0	14		0	0	0	95263	0	313782	1127433		
140727	3090	40213227	2012-01-30	2012-01-30 00:00:00	2012-01-30	2012-01-30 00:00:00	2012-01-30	581452		0	0	0		0	0	0	205731	0	113	40213227		
78410	1716	40213227	2016-02-19	2016-02-19 00:00:00	2016-02-19	2016-02-19 00:00:00	2016-02-19	581452		0	0	0		0	0	0	114715	0	113	40213227		
57792	4801	19128022	1989-07-07	1989-07-07 00:00:00	1990-07-02	1990-07-02 00:00:00	1990-07-02	38000177		0	0	360		0	0	0	319360	0	749785	19128022		
52738	4383	1127078	1975-06-04	1975-06-04 00:00:00	1975-09-02	1975-09-02 00:00:00	1975-09-02	38000177		0	0	90		0	0	0	291335	0	282464	1127078		
56897	4722	1127433	1994-07-16	1994-07-16 00:00:00	1994-07-30	1994-07-30 00:00:00	1994-07-30	38000177		0	0	14		0	0	0	314614	0	313782	1127433		
212341	4655	40213160	1959-08-23	1959-08-23 00:00:00	1959-08-23	1959-08-23 00:00:00	1959-08-23	581452		0	0	0		0	0	0	310351	0	10	40213160		
117307	2578	40213160	1970-12-03	1970-12-03 00:00:00	1970-12-03	1970-12-03 00:00:00	1970-12-03	581452		0	0	0		0	0	0	170723	0	10	40213160		
12226	1025	19006318	1945-02-24	1945-02-24 00:00:00	1945-03-31	1945-03-31 00:00:00	1945-03-31	38000177		0	0	35		0	0	0	67581	0	105078	19006318		
240716	5284	40213296	2007-10-10	2007-10-10 00:00:00	2007-10-10	2007-10-10 00:00:00	2007-10-10	581452		0	0	0		0	0	0	351591	0	52	40213296		
43621	3615	920300	1982-09-30	1982-09-30 00:00:00	1982-10-07	1982-10-07 00:00:00	1982-10-07	38000177		0	0	7		0	0	0	240202	0	311989	920300		
50802	1113	40213296	2011-11-22	2011-11-22 00:00:00	2011-11-22	2011-11-22 00:00:00	2011-11-22	581452		0	0	0		0	0	0	73274	0	52	40213296		
36149	789	40213160	1973-03-05	1973-03-05 00:00:00	1973-03-05	1973-03-05 00:00:00	1973-03-05	581452		0	0	0		0	0	0	52488	0	10	40213160		
25815	2123	19078461	2002-05-19	2002-05-19 00:00:00	2002-08-17	2002-08-17 00:00:00	2002-08-17	38000177		0	0	90		0	0	0	141321	0	310965	19078461		
182375	4006	40213227	1993-05-11	1993-05-11 00:00:00	1993-05-11	1993-05-11 00:00:00	1993-05-11	581452		0	0	0		0	0	0	266176	0	113	40213227		
8277	691	19133873	1959-05-07	1959-05-07 00:00:00	1959-05-14	1959-05-14 00:00:00	1959-05-14	38000177		0	0	7		0	0	0	45783	0	834061	19133873		
100951	2213	40213296	2001-07-25	2001-07-25 00:00:00	2001-07-25	2001-07-25 00:00:00	2001-07-25	581452		0	0	0		0	0	0	147403	0	52	40213296		
112944	2481	40213296	2013-03-17	2013-03-17 00:00:00	2013-03-17	2013-03-17 00:00:00	2013-03-17	581452		0	0	0		0	0	0	164418	0	52	40213296		
11856	987	19059056	1965-10-26	1965-10-26 00:00:00	1966-01-24	1966-01-24 00:00:00	1966-01-24	38000177		0	0	90		0	0	0	65519	0	243670	19059056		
27688	2291	1127078	1964-01-26	1964-01-26 00:00:00	1964-02-09	1964-02-09 00:00:00	1964-02-09	38000177		0	0	14		0	0	0	152418	0	282464	1127078		
205186	4503	40213201	2002-01-22	2002-01-22 00:00:00	2002-01-22	2002-01-22 00:00:00	2002-01-22	581452		0	0	0		0	0	0	299843	0	33	40213201		
229543	5045	40213227	2011-04-09	2011-04-09 00:00:00	2011-04-09	2011-04-09 00:00:00	2011-04-09	581452		0	0	0		0	0	0	335259	0	113	40213227		
29529	2443	1713671	1995-06-12	1995-06-12 00:00:00	1995-09-25	1995-09-25 00:00:00	1995-09-25	38000177		0	0	105		0	0	0	162043	0	562251	1713671		
198119	4353	40213306	1988-10-09	1988-10-09 00:00:00	1988-10-09	1988-10-09 00:00:00	1988-10-09	581452		0	0	0		0	0	0	288830	0	43	40213306		
44267	964	40213314	1977-04-10	1977-04-10 00:00:00	1977-04-10	1977-04-10 00:00:00	1977-04-10	581452		0	0	0		0	0	0	64190	0	49	40213314		
19250	1590	19078461	2014-08-23	2014-08-23 00:00:00	2014-10-22	2014-10-22 00:00:00	2014-10-22	38000177		0	0	60		0	0	0	106721	0	310965	19078461		
221737	4867	40213227	1995-05-31	1995-05-31 00:00:00	1995-05-31	1995-05-31 00:00:00	1995-05-31	581452		0	0	0		0	0	0	323637	0	113	40213227		
52236	1143	40213227	2002-07-26	2002-07-26 00:00:00	2002-07-26	2002-07-26 00:00:00	2002-07-26	581452		0	0	0		0	0	0	75413	0	113	40213227		
203233	4462	40213227	1997-03-27	1997-03-27 00:00:00	1997-03-27	1997-03-27 00:00:00	1997-03-27	581452		0	0	0		0	0	0	296906	0	113	40213227		
40344	3342	19059056	1924-08-08	1924-08-08 00:00:00	1924-08-29	1924-08-29 00:00:00	1924-08-29	38000177		0	0	21		0	0	0	221629	0	243670	19059056		
184287	4049	40213160	1961-09-12	1961-09-12 00:00:00	1961-09-12	1961-09-12 00:00:00	1961-09-12	581452		0	0	0		0	0	0	269176	0	10	40213160		
79556	1740	40213260	2006-09-30	2006-09-30 00:00:00	2006-09-30	2006-09-30 00:00:00	2006-09-30	581452		0	0	0		0	0	0	116242	0	121	40213260		
203099	4459	40213296	2003-10-27	2003-10-27 00:00:00	2003-10-27	2003-10-27 00:00:00	2003-10-27	581452		0	0	0		0	0	0	296701	0	52	40213296		
203131	4460	40213227	1992-12-07	1992-12-07 00:00:00	1992-12-07	1992-12-07 00:00:00	1992-12-07	581452		0	0	0		0	0	0	296742	0	113	40213227		
78587	1719	40213160	1957-07-16	1957-07-16 00:00:00	1957-07-16	1957-07-16 00:00:00	1957-07-16	581452		0	0	0		0	0	0	114904	0	10	40213160		
49111	1076	40213314	1977-04-22	1977-04-22 00:00:00	1977-04-22	1977-04-22 00:00:00	1977-04-22	581452		0	0	0		0	0	0	70538	0	49	40213314		
169556	3728	40213160	1972-06-25	1972-06-25 00:00:00	1972-06-25	1972-06-25 00:00:00	1972-06-25	581452		0	0	0		0	0	0	247744	0	10	40213160		
161935	3562	40213296	2010-12-15	2010-12-15 00:00:00	2010-12-15	2010-12-15 00:00:00	2010-12-15	581452		0	0	0		0	0	0	236583	0	52	40213296		
74316	1622	40213160	1974-11-04	1974-11-04 00:00:00	1974-11-04	1974-11-04 00:00:00	1974-11-04	581452		0	0	0		0	0	0	109008	0	10	40213160		
36869	3049	1127433	2011-07-24	2011-07-24 00:00:00	2011-08-21	2011-08-21 00:00:00	2011-08-21	38000177		0	0	28		0	0	0	202877	0	313782	1127433		
45137	3734	19133905	1981-04-30	1981-04-30 00:00:00	1981-05-12	1981-05-12 00:00:00	1981-05-12	38000177		0	0	12		0	0	0	248097	0	834102	19133905		
113852	2501	40213227	2012-12-03	2012-12-03 00:00:00	2012-12-03	2012-12-03 00:00:00	2012-12-03	581452		0	0	0		0	0	0	165583	0	113	40213227		
214324	4700	40213198	2017-03-07	2017-03-07 00:00:00	2017-03-07	2017-03-07 00:00:00	2017-03-07	581452		0	0	0		0	0	0	313084	0	133	40213198		
9042	754	1713671	2009-05-31	2009-05-31 00:00:00	2010-02-28	2010-02-28 00:00:00	2010-02-28	38000177		0	0	273		0	0	0	49921	0	562251	1713671		
70103	1532	40213160	1978-06-07	1978-06-07 00:00:00	1978-06-07	1978-06-07 00:00:00	1978-06-07	581452		0	0	0		0	0	0	102626	0	10	40213160		
185678	4080	40213160	1965-11-09	1965-11-09 00:00:00	1965-11-09	1965-11-09 00:00:00	1965-11-09	581452		0	0	0		0	0	0	271182	0	10	40213160		
9182	196	40213260	2006-10-28	2006-10-28 00:00:00	2006-10-28	2006-10-28 00:00:00	2006-10-28	581452		0	0	0		0	0	0	13456	0	121	40213260		
49798	1091	40213296	1997-02-27	1997-02-27 00:00:00	1997-02-27	1997-02-27 00:00:00	1997-02-27	581452		0	0	0		0	0	0	71671	0	52	40213296		
3550	295	40229134	1973-12-07	1973-12-07 00:00:00	1973-12-21	1973-12-21 00:00:00	1973-12-21	38000177		0	0	14		0	0	0	19623	0	1043400	40229134		
174714	3841	40213160	1972-01-05	1972-01-05 00:00:00	1972-01-05	1972-01-05 00:00:00	1972-01-05	581452		0	0	0		0	0	0	255006	0	10	40213160		
77279	1689	40213227	1992-07-09	1992-07-09 00:00:00	1992-07-09	1992-07-09 00:00:00	1992-07-09	581452		0	0	0		0	0	0	113141	0	113	40213227		
197218	4333	40213296	1996-02-15	1996-02-15 00:00:00	1996-02-15	1996-02-15 00:00:00	1996-02-15	581452		0	0	0		0	0	0	287387	0	52	40213296		
61276	1339	40213306	1988-06-16	1988-06-16 00:00:00	1988-06-16	1988-06-16 00:00:00	1988-06-16	581452		0	0	0		0	0	0	88812	0	43	40213306		
210785	4623	40213227	2000-06-06	2000-06-06 00:00:00	2000-06-06	2000-06-06 00:00:00	2000-06-06	581452		0	0	0		0	0	0	307937	0	113	40213227		
104400	2290	40213160	1957-03-09	1957-03-09 00:00:00	1957-03-09	1957-03-09 00:00:00	1957-03-09	581452		0	0	0		0	0	0	152331	0	10	40213160		
24784	2037	19133873	1962-02-08	1962-02-08 00:00:00	1962-02-20	1962-02-20 00:00:00	1962-02-20	38000177		0	0	12		0	0	0	135624	0	834061	19133873		
43093	3571	1713671	1975-11-01	1975-11-01 00:00:00	1975-11-15	1975-11-15 00:00:00	1975-11-15	38000177		0	0	14		0	0	0	237409	0	562251	1713671		
167382	3680	40213306	1999-11-23	1999-11-23 00:00:00	1999-11-23	1999-11-23 00:00:00	1999-11-23	581452		0	0	0		0	0	0	\N	0	43	40213306		
212072	4649	40213160	1969-10-20	1969-10-20 00:00:00	1969-10-20	1969-10-20 00:00:00	1969-10-20	581452		0	0	0		0	0	0	310002	0	10	40213160		
86663	1900	40213227	2014-10-13	2014-10-13 00:00:00	2014-10-13	2014-10-13 00:00:00	2014-10-13	581452		0	0	0		0	0	0	126472	0	113	40213227		
62143	5170	19059056	1971-10-13	1971-10-13 00:00:00	1971-11-03	1971-11-03 00:00:00	1971-11-03	38000177		0	0	21		0	0	0	343733	0	243670	19059056		
84245	1843	40213314	1982-10-27	1982-10-27 00:00:00	1982-10-27	1982-10-27 00:00:00	1982-10-27	581452		0	0	0		0	0	0	123090	0	49	40213314		
94335	2070	40213160	1969-06-30	1969-06-30 00:00:00	1969-06-30	1969-06-30 00:00:00	1969-06-30	581452		0	0	0		0	0	0	137739	0	10	40213160		
6784	571	1713671	2013-04-06	2013-04-06 00:00:00	2013-04-13	2013-04-13 00:00:00	2013-04-13	38000177		0	0	7		0	0	0	37811	0	562251	1713671		
17270	1431	19006318	1967-08-04	1967-08-04 00:00:00	1967-08-18	1967-08-18 00:00:00	1967-08-18	38000177		0	0	14		0	0	0	95263	0	105078	19006318		
140728	3090	40213260	2011-01-24	2011-01-24 00:00:00	2011-01-24	2011-01-24 00:00:00	2011-01-24	581452		0	0	0		0	0	0	205715	0	121	40213260		
78419	1716	40213201	2011-01-21	2011-01-21 00:00:00	2011-01-21	2011-01-21 00:00:00	2011-01-21	581452		0	0	0		0	0	0	114696	0	33	40213201		
57793	4801	40229134	2013-03-04	2013-03-04 00:00:00	2013-03-18	2013-03-18 00:00:00	2013-03-18	38000177		0	0	14		0	0	0	319359	0	1043400	40229134		
52739	4383	1127433	1990-10-13	1990-10-13 00:00:00	1990-10-27	1990-10-27 00:00:00	1990-10-27	38000177		0	0	14		0	0	0	291357	0	313782	1127433		
56898	4722	1127433	1938-12-11	1938-12-11 00:00:00	1938-12-18	1938-12-18 00:00:00	1938-12-18	38000177		0	0	7		0	0	0	314588	0	313782	1127433		
212355	4656	40213227	1993-09-26	1993-09-26 00:00:00	1993-09-26	1993-09-26 00:00:00	1993-09-26	581452		0	0	0		0	0	0	310420	0	113	40213227		
117311	2578	40213227	2001-10-18	2001-10-18 00:00:00	2001-10-18	2001-10-18 00:00:00	2001-10-18	581452		0	0	0		0	0	0	170732	0	113	40213227		
12227	1025	1127433	1956-09-28	1956-09-28 00:00:00	1956-10-05	1956-10-05 00:00:00	1956-10-05	38000177		0	0	7		0	0	0	67570	0	313782	1127433		
240718	5284	40213227	2017-08-30	2017-08-30 00:00:00	2017-08-30	2017-08-30 00:00:00	2017-08-30	581452		0	0	0		0	0	0	351623	0	113	40213227		
43622	3615	1118084	1983-12-11	1983-12-11 00:00:00	1983-12-11	1983-12-11 00:00:00	\N	38000177		0	0	0		0	0	0	240162	0	00025152531	44923712		
101381	2222	40213260	2013-07-30	2013-07-30 00:00:00	2013-07-30	2013-07-30 00:00:00	2013-07-30	581452		0	0	0		0	0	0	147921	0	121	40213260		
36153	789	40213306	1993-01-25	1993-01-25 00:00:00	1993-01-25	1993-01-25 00:00:00	1993-01-25	581452		0	0	0		0	0	0	52473	0	43	40213306		
25816	2123	40173590	2009-06-19	2009-06-19 00:00:00	2009-06-19	2009-06-19 00:00:00	\N	38000177		0	0	0		0	0	0	141303	0	904419	40173590		
182381	4006	40213201	2015-03-24	2015-03-24 00:00:00	2015-03-24	2015-03-24 00:00:00	2015-03-24	581452		0	0	0		0	0	0	266158	0	33	40213201		
8278	691	1118084	1994-12-20	1994-12-20 00:00:00	1994-12-20	1994-12-20 00:00:00	\N	38000177		0	0	0		0	0	0	45795	0	00025152531	44923712		
112239	2466	40213306	2000-06-25	2000-06-25 00:00:00	2000-06-25	2000-06-25 00:00:00	2000-06-25	581452		0	0	0		0	0	0	163477	0	43	40213306		
112945	2481	40213160	1969-10-26	1969-10-26 00:00:00	1969-10-26	1969-10-26 00:00:00	1969-10-26	581452		0	0	0		0	0	0	164376	0	10	40213160		
31719	691	40213227	1999-05-11	1999-05-11 00:00:00	1999-05-11	1999-05-11 00:00:00	1999-05-11	581452		0	0	0		0	0	0	45772	0	113	40213227		
27689	2291	19129655	1964-01-26	1964-01-26 00:00:00	1964-02-09	1964-02-09 00:00:00	1964-02-09	38000177		0	0	14		0	0	0	152418	0	789980	19129655		
205198	4503	40213227	2017-04-18	2017-04-18 00:00:00	2017-04-18	2017-04-18 00:00:00	2017-04-18	581452		0	0	0		0	0	0	299848	0	113	40213227		
229547	5045	40213296	2003-01-25	2003-01-25 00:00:00	2003-01-25	2003-01-25 00:00:00	2003-01-25	581452		0	0	0		0	0	0	335240	0	52	40213296		
29530	2443	19075001	1992-08-18	1992-08-18 00:00:00	1992-09-22	1992-09-22 00:00:00	1992-09-22	38000177		0	0	35		0	0	0	162035	0	309097	19075001		
198121	4353	40213160	1967-04-16	1967-04-16 00:00:00	1967-04-16	1967-04-16 00:00:00	1967-04-16	581452		0	0	0		0	0	0	288767	0	10	40213160		
44271	964	40213314	1977-10-09	1977-10-09 00:00:00	1977-10-09	1977-10-09 00:00:00	1977-10-09	581452		0	0	0		0	0	0	64197	0	49	40213314		
19251	1590	40229134	1985-05-24	1985-05-24 00:00:00	1985-06-07	1985-06-07 00:00:00	1985-06-07	38000177		0	0	14		0	0	0	106701	0	1043400	40229134		
130569	2869	40213227	1992-11-03	1992-11-03 00:00:00	1992-11-03	1992-11-03 00:00:00	1992-11-03	581452		0	0	0		0	0	0	190906	0	113	40213227		
226742	4979	40213296	2018-08-03	2018-08-03 00:00:00	2018-08-03	2018-08-03 00:00:00	2018-08-03	581452		0	0	0		0	0	0	331269	0	52	40213296		
203242	4462	40213160	1960-01-14	1960-01-14 00:00:00	1960-01-14	1960-01-14 00:00:00	1960-01-14	581452		0	0	0		0	0	0	296886	0	10	40213160		
40345	3342	1127433	1997-02-01	1997-02-01 00:00:00	1997-02-08	1997-02-08 00:00:00	1997-02-08	38000177		0	0	7		0	0	0	221635	0	313782	1127433		
184288	4049	40213296	2001-04-10	2001-04-10 00:00:00	2001-04-10	2001-04-10 00:00:00	2001-04-10	581452		0	0	0		0	0	0	269157	0	52	40213296		
203015	4456	40213160	1969-02-23	1969-02-23 00:00:00	1969-02-23	1969-02-23 00:00:00	1969-02-23	581452		0	0	0		0	0	0	296568	0	10	40213160		
203106	4459	40213160	1964-06-30	1964-06-30 00:00:00	1964-06-30	1964-06-30 00:00:00	1964-06-30	581452		0	0	0		0	0	0	296713	0	10	40213160		
203147	4460	40213227	2002-01-28	2002-01-28 00:00:00	2002-01-28	2002-01-28 00:00:00	2002-01-28	581452		0	0	0		0	0	0	296796	0	113	40213227		
198701	4366	40213251	1985-10-01	1985-10-01 00:00:00	1985-10-01	1985-10-01 00:00:00	1985-10-01	581452		0	0	0		0	0	0	\N	0	21	40213251		
49116	1076	40213296	2013-05-17	2013-05-17 00:00:00	2013-05-17	2013-05-17 00:00:00	2013-05-17	581452		0	0	0		0	0	0	70584	0	52	40213296		
169559	3728	40213227	1994-03-20	1994-03-20 00:00:00	1994-03-20	1994-03-20 00:00:00	1994-03-20	581452		0	0	0		0	0	0	247710	0	113	40213227		
161937	3562	40213227	2010-12-15	2010-12-15 00:00:00	2010-12-15	2010-12-15 00:00:00	2010-12-15	581452		0	0	0		0	0	0	236583	0	113	40213227		
74336	1623	40213227	2001-01-12	2001-01-12 00:00:00	2001-01-12	2001-01-12 00:00:00	2001-01-12	581452		0	0	0		0	0	0	109066	0	113	40213227		
36870	3049	19126352	1980-03-28	1980-03-28 00:00:00	1986-12-05	1986-12-05 00:00:00	1986-12-05	38000177		0	0	2443		0	0	0	202861	0	705129	19126352		
45148	3736	46275916	2006-06-28	2006-06-28 00:00:00	2006-06-28	2006-06-28 00:00:00	2006-06-28	38000177		0	0	0		0	0	0	248300	0	1660014	46275916		
202979	4456	40213296	2004-12-26	2004-12-26 00:00:00	2004-12-26	2004-12-26 00:00:00	2004-12-26	581452		0	0	0		0	0	0	296612	0	52	40213296		
131432	2889	40213227	1994-04-03	1994-04-03 00:00:00	1994-04-03	1994-04-03 00:00:00	1994-04-03	581452		0	0	0		0	0	0	192187	0	113	40213227		
9043	754	19059056	1970-01-08	1970-01-08 00:00:00	1970-01-29	1970-01-29 00:00:00	1970-01-29	38000177		0	0	21		0	0	0	49823	0	243670	19059056		
70107	1532	40213251	1984-09-19	1984-09-19 00:00:00	1984-09-19	1984-09-19 00:00:00	1984-09-19	581452		0	0	0		0	0	0	102586	0	21	40213251		
185685	4080	40213227	1996-09-17	1996-09-17 00:00:00	1996-09-17	1996-09-17 00:00:00	1996-09-17	581452		0	0	0		0	0	0	271189	0	113	40213227		
9184	196	40213227	2015-10-17	2015-10-17 00:00:00	2015-10-17	2015-10-17 00:00:00	2015-10-17	581452		0	0	0		0	0	0	13498	0	113	40213227		
204260	4484	40213227	1993-09-23	1993-09-23 00:00:00	1993-09-23	1993-09-23 00:00:00	1993-09-23	581452		0	0	0		0	0	0	298516	0	113	40213227		
3552	295	19133873	1959-09-04	1959-09-04 00:00:00	1959-09-13	1959-09-13 00:00:00	1959-09-13	38000177		0	0	9		0	0	0	19621	0	834061	19133873		
174717	3841	40213296	2013-09-18	2013-09-18 00:00:00	2013-09-18	2013-09-18 00:00:00	2013-09-18	581452		0	0	0		0	0	0	255018	0	52	40213296		
77293	1689	40213227	2011-12-01	2011-12-01 00:00:00	2011-12-01	2011-12-01 00:00:00	2011-12-01	581452		0	0	0		0	0	0	113076	0	113	40213227		
219847	4826	40213227	1993-11-20	1993-11-20 00:00:00	1993-11-20	1993-11-20 00:00:00	1993-11-20	581452		0	0	0		0	0	0	320978	0	113	40213227		
61286	1339	40213160	1971-03-25	1971-03-25 00:00:00	1971-03-25	1971-03-25 00:00:00	1971-03-25	581452		0	0	0		0	0	0	88781	0	10	40213160		
175026	3849	40213227	2006-01-12	2006-01-12 00:00:00	2006-01-12	2006-01-12 00:00:00	2006-01-12	581452		0	0	0		0	0	0	255455	0	113	40213227		
104403	2290	40213227	2017-12-02	2017-12-02 00:00:00	2017-12-02	2017-12-02 00:00:00	2017-12-02	581452		0	0	0		0	0	0	152324	0	113	40213227		
24785	2037	19006318	1963-02-07	1963-02-07 00:00:00	1963-02-21	1963-02-21 00:00:00	1963-02-21	38000177		0	0	14		0	0	0	135682	0	105078	19006318		
43094	3571	19133873	1977-05-28	1977-05-28 00:00:00	1977-06-08	1977-06-08 00:00:00	1977-06-08	38000177		0	0	11		0	0	0	237378	0	834061	19133873		
167388	3680	40213227	2000-10-31	2000-10-31 00:00:00	2000-10-31	2000-10-31 00:00:00	2000-10-31	581452		0	0	0		0	0	0	\N	0	113	40213227		
212074	4649	40213296	2009-12-07	2009-12-07 00:00:00	2009-12-07	2009-12-07 00:00:00	2009-12-07	581452		0	0	0		0	0	0	310042	0	52	40213296		
86664	1900	40213260	2014-10-13	2014-10-13 00:00:00	2014-10-13	2014-10-13 00:00:00	2014-10-13	581452		0	0	0		0	0	0	126472	0	121	40213260		
62144	5170	1713671	2010-01-13	2010-01-13 00:00:00	2010-02-03	2010-02-03 00:00:00	2010-02-03	38000177		0	0	21		0	0	0	343766	0	562251	1713671		
84250	1843	40213227	2015-06-17	2015-06-17 00:00:00	2015-06-17	2015-06-17 00:00:00	2015-06-17	581452		0	0	0		0	0	0	123098	0	113	40213227		
94341	2070	40213227	1996-10-21	1996-10-21 00:00:00	1996-10-21	1996-10-21 00:00:00	1996-10-21	581452		0	0	0		0	0	0	137778	0	113	40213227		
6785	571	19059056	1958-06-10	1958-06-10 00:00:00	1958-07-01	1958-07-01 00:00:00	1958-07-01	38000177		0	0	21		0	0	0	37832	0	243670	19059056		
17271	1431	19006318	1954-07-28	1954-07-28 00:00:00	1954-08-11	1954-08-11 00:00:00	1954-08-11	38000177		0	0	14		0	0	0	95308	0	105078	19006318		
140729	3090	40213260	2012-01-30	2012-01-30 00:00:00	2012-01-30	2012-01-30 00:00:00	2012-01-30	581452		0	0	0		0	0	0	205731	0	121	40213260		
78453	1716	40213227	2005-12-23	2005-12-23 00:00:00	2005-12-23	2005-12-23 00:00:00	2005-12-23	581452		0	0	0		0	0	0	114639	0	113	40213227		
57794	4801	1127433	1988-08-24	1988-08-24 00:00:00	1988-08-31	1988-08-31 00:00:00	1988-08-31	38000177		0	0	7		0	0	0	319357	0	313782	1127433		
52740	4383	1127078	1969-09-12	1969-09-12 00:00:00	1969-09-26	1969-09-26 00:00:00	1969-09-26	38000177		0	0	14		0	0	0	291330	0	282464	1127078		
56899	4722	19059056	1918-04-19	1918-04-19 00:00:00	1918-05-19	1918-05-19 00:00:00	1918-05-19	38000177		0	0	30		0	0	0	314609	0	243670	19059056		
212357	4656	40213160	1955-08-28	1955-08-28 00:00:00	1955-08-28	1955-08-28 00:00:00	1955-08-28	581452		0	0	0		0	0	0	310489	0	10	40213160		
117321	2579	40213160	1956-03-25	1956-03-25 00:00:00	1956-03-25	1956-03-25 00:00:00	1956-03-25	581452		0	0	0		0	0	0	170798	0	10	40213160		
12228	1025	1118084	1974-04-05	1974-04-05 00:00:00	1974-04-05	1974-04-05 00:00:00	\N	38000177		0	0	0		0	0	0	67559	0	00025152531	44923712		
240719	5284	40213260	2017-08-30	2017-08-30 00:00:00	2017-08-30	2017-08-30 00:00:00	2017-08-30	581452		0	0	0		0	0	0	351623	0	121	40213260		
43623	3615	1127078	1960-09-02	1960-09-02 00:00:00	1960-10-07	1960-10-07 00:00:00	1960-10-07	38000177		0	0	35		0	0	0	240216	0	282464	1127078		
101385	2222	40213160	1963-06-04	1963-06-04 00:00:00	1963-06-04	1963-06-04 00:00:00	1963-06-04	581452		0	0	0		0	0	0	147893	0	10	40213160		
89480	1962	40213227	2015-04-15	2015-04-15 00:00:00	2015-04-15	2015-04-15 00:00:00	2015-04-15	581452		0	0	0		0	0	0	130473	0	113	40213227		
25817	2123	1127433	1991-07-25	1991-07-25 00:00:00	1991-08-08	1991-08-08 00:00:00	1991-08-08	38000177		0	0	14		0	0	0	141279	0	313782	1127433		
51733	1133	40213227	2016-07-15	2016-07-15 00:00:00	2016-07-15	2016-07-15 00:00:00	2016-07-15	581452		0	0	0		0	0	0	74615	0	113	40213227		
8279	691	19059056	1966-11-22	1966-11-22 00:00:00	1966-12-13	1966-12-13 00:00:00	1966-12-13	38000177		0	0	21		0	0	0	45785	0	243670	19059056		
112240	2466	40213160	1979-12-29	1979-12-29 00:00:00	1979-12-29	1979-12-29 00:00:00	1979-12-29	581452		0	0	0		0	0	0	163507	0	10	40213160		
124235	2732	40213160	1974-07-18	1974-07-18 00:00:00	1974-07-18	1974-07-18 00:00:00	1974-07-18	581452		0	0	0		0	0	0	180847	0	10	40213160		
31720	691	40213296	1999-05-11	1999-05-11 00:00:00	1999-05-11	1999-05-11 00:00:00	1999-05-11	581452		0	0	0		0	0	0	45772	0	52	40213296		
27690	2291	1124300	1997-05-22	1997-05-22 00:00:00	1997-05-22	1997-05-22 00:00:00	\N	38000177		0	0	0		0	0	0	152465	0	00781178901	45011828		
205210	4504	40213306	1989-11-11	1989-11-11 00:00:00	1989-11-11	1989-11-11 00:00:00	1989-11-11	581452		0	0	0		0	0	0	299917	0	43	40213306		
229550	5045	40213227	2003-01-25	2003-01-25 00:00:00	2003-01-25	2003-01-25 00:00:00	2003-01-25	581452		0	0	0		0	0	0	335240	0	113	40213227		
29531	2443	1127433	1992-08-18	1992-08-18 00:00:00	1992-09-22	1992-09-22 00:00:00	1992-09-22	38000177		0	0	35		0	0	0	162035	0	313782	1127433		
198128	4353	40213160	1971-07-18	1971-07-18 00:00:00	1971-07-18	1971-07-18 00:00:00	1971-07-18	581452		0	0	0		0	0	0	288846	0	10	40213160		
44277	964	40213160	1975-04-13	1975-04-13 00:00:00	1975-04-13	1975-04-13 00:00:00	1975-04-13	581452		0	0	0		0	0	0	64151	0	10	40213160		
19252	1590	1127078	1965-01-06	1965-01-06 00:00:00	1965-02-05	1965-02-05 00:00:00	1965-02-05	38000177		0	0	30		0	0	0	106672	0	282464	1127078		
130574	2869	40213201	2017-01-24	2017-01-24 00:00:00	2017-01-24	2017-01-24 00:00:00	2017-01-24	581452		0	0	0		0	0	0	190911	0	33	40213201		
226744	4979	40213227	2018-08-03	2018-08-03 00:00:00	2018-08-03	2018-08-03 00:00:00	2018-08-03	581452		0	0	0		0	0	0	331269	0	113	40213227		
203248	4462	40213227	2016-04-07	2016-04-07 00:00:00	2016-04-07	2016-04-07 00:00:00	2016-04-07	581452		0	0	0		0	0	0	296925	0	113	40213227		
40346	3342	40162522	2011-10-11	2011-10-11 00:00:00	2011-10-11	2011-10-11 00:00:00	\N	38000177		0	0	0		0	0	0	221569	0	857005	40162522		
184292	4049	40213227	2012-05-29	2012-05-29 00:00:00	2012-05-29	2012-05-29 00:00:00	2012-05-29	581452		0	0	0		0	0	0	269146	0	113	40213227		
203027	4457	40213160	1988-04-19	1988-04-19 00:00:00	1988-04-19	1988-04-19 00:00:00	1988-04-19	581452		0	0	0		0	0	0	296650	0	10	40213160		
229827	5051	40213227	2009-07-09	2009-07-09 00:00:00	2009-07-09	2009-07-09 00:00:00	2009-07-09	581452		0	0	0		0	0	0	335948	0	113	40213227		
203151	4460	40213227	2011-09-19	2011-09-19 00:00:00	2011-09-19	2011-09-19 00:00:00	2011-09-19	581452		0	0	0		0	0	0	296748	0	113	40213227		
198702	4366	40213160	1985-10-01	1985-10-01 00:00:00	1985-10-01	1985-10-01 00:00:00	1985-10-01	581452		0	0	0		0	0	0	\N	0	10	40213160		
49123	1076	40213160	1974-01-18	1974-01-18 00:00:00	1974-01-18	1974-01-18 00:00:00	1974-01-18	581452		0	0	0		0	0	0	70571	0	10	40213160		
169560	3728	40213306	1994-03-20	1994-03-20 00:00:00	1994-03-20	1994-03-20 00:00:00	1994-03-20	581452		0	0	0		0	0	0	247710	0	43	40213306		
161939	3562	40213160	1969-04-30	1969-04-30 00:00:00	1969-04-30	1969-04-30 00:00:00	1969-04-30	581452		0	0	0		0	0	0	236619	0	10	40213160		
74342	1623	40213227	2011-03-11	2011-03-11 00:00:00	2011-03-11	2011-03-11 00:00:00	2011-03-11	581452		0	0	0		0	0	0	109122	0	113	40213227		
36871	3049	1127433	1988-05-22	1988-05-22 00:00:00	1988-06-05	1988-06-05 00:00:00	1988-06-05	38000177		0	0	14		0	0	0	202854	0	313782	1127433		
45149	3736	1310034	2006-06-28	2006-06-28 00:00:00	2006-06-28	2006-06-28 00:00:00	2006-06-28	38000177		0	0	0		0	0	0	248300	0	834357	1310034		
202984	4456	40213227	2006-12-31	2006-12-31 00:00:00	2006-12-31	2006-12-31 00:00:00	2006-12-31	581452		0	0	0		0	0	0	296618	0	113	40213227		
131434	2889	40213160	1960-08-28	1960-08-28 00:00:00	1960-08-28	1960-08-28 00:00:00	1960-08-28	581452		0	0	0		0	0	0	192167	0	10	40213160		
9044	754	19133873	1952-01-11	1952-01-11 00:00:00	1952-01-19	1952-01-19 00:00:00	1952-01-19	38000177		0	0	8		0	0	0	49846	0	834061	19133873		
70111	1532	40213160	1982-09-08	1982-09-08 00:00:00	1982-09-08	1982-09-08 00:00:00	1982-09-08	581452		0	0	0		0	0	0	102585	0	10	40213160		
185690	4081	40213227	2016-10-31	2016-10-31 00:00:00	2016-10-31	2016-10-31 00:00:00	2016-10-31	581452		0	0	0		0	0	0	271302	0	113	40213227		
9196	196	40213260	2007-11-03	2007-11-03 00:00:00	2007-11-03	2007-11-03 00:00:00	2007-11-03	581452		0	0	0		0	0	0	13497	0	121	40213260		
204262	4484	40213160	1955-01-20	1955-01-20 00:00:00	1955-01-20	1955-01-20 00:00:00	1955-01-20	581452		0	0	0		0	0	0	298508	0	10	40213160		
3553	295	1127433	1990-04-02	1990-04-02 00:00:00	1990-04-09	1990-04-09 00:00:00	1990-04-09	38000177		0	0	7		0	0	0	19632	0	313782	1127433		
174719	3841	40213227	2013-09-18	2013-09-18 00:00:00	2013-09-18	2013-09-18 00:00:00	2013-09-18	581452		0	0	0		0	0	0	255018	0	113	40213227		
88179	1934	40213260	2010-01-30	2010-01-30 00:00:00	2010-01-30	2010-01-30 00:00:00	2010-01-30	581452		0	0	0		0	0	0	128665	0	121	40213260		
219862	4826	40213227	2002-06-15	2002-06-15 00:00:00	2002-06-15	2002-06-15 00:00:00	2002-06-15	581452		0	0	0		0	0	0	320954	0	113	40213227		
61288	1339	40213160	1966-09-22	1966-09-22 00:00:00	1966-09-22	1966-09-22 00:00:00	1966-09-22	581452		0	0	0		0	0	0	88794	0	10	40213160		
175027	3849	40213296	2006-01-12	2006-01-12 00:00:00	2006-01-12	2006-01-12 00:00:00	2006-01-12	581452		0	0	0		0	0	0	255455	0	52	40213296		
104409	2290	40213260	2006-09-30	2006-09-30 00:00:00	2006-09-30	2006-09-30 00:00:00	2006-09-30	581452		0	0	0		0	0	0	152351	0	121	40213260		
24786	2037	19059056	1963-02-07	1963-02-07 00:00:00	1963-02-21	1963-02-21 00:00:00	1963-02-21	38000177		0	0	14		0	0	0	135682	0	243670	19059056		
43095	3571	19008572	1977-05-05	1977-05-05 00:00:00	1977-05-26	1977-05-26 00:00:00	1977-05-26	38000177		0	0	21		0	0	0	237377	0	106258	19008572		
167389	3680	40213306	2000-10-31	2000-10-31 00:00:00	2000-10-31	2000-10-31 00:00:00	2000-10-31	581452		0	0	0		0	0	0	\N	0	43	40213306		
212079	4649	40213160	1969-05-19	1969-05-19 00:00:00	1969-05-19	1969-05-19 00:00:00	1969-05-19	581452		0	0	0		0	0	0	310001	0	10	40213160		
230584	5067	40213296	2017-05-14	2017-05-14 00:00:00	2017-05-14	2017-05-14 00:00:00	2017-05-14	581452		0	0	0		0	0	0	336861	0	52	40213296		
62147	5172	19059056	1959-07-08	1959-07-08 00:00:00	1959-07-22	1959-07-22 00:00:00	1959-07-22	38000177		0	0	14		0	0	0	343919	0	243670	19059056		
84251	1843	40213251	1984-01-25	1984-01-25 00:00:00	1984-01-25	1984-01-25 00:00:00	1984-01-25	581452		0	0	0		0	0	0	123075	0	21	40213251		
94345	2070	40213227	2015-11-02	2015-11-02 00:00:00	2015-11-02	2015-11-02 00:00:00	2015-11-02	581452		0	0	0		0	0	0	137652	0	113	40213227		
6786	571	40229134	2005-08-03	2005-08-03 00:00:00	2005-08-10	2005-08-10 00:00:00	2005-08-10	38000177		0	0	7		0	0	0	37844	0	1043400	40229134		
17272	1431	1127078	1954-07-28	1954-07-28 00:00:00	1954-08-11	1954-08-11 00:00:00	1954-08-11	38000177		0	0	14		0	0	0	95308	0	282464	1127078		
181253	3982	40213227	2010-11-05	2010-11-05 00:00:00	2010-11-05	2010-11-05 00:00:00	2010-11-05	581452		0	0	0		0	0	0	264662	0	113	40213227		
211189	4631	40213227	2004-09-03	2004-09-03 00:00:00	2004-09-03	2004-09-03 00:00:00	2004-09-03	581452		0	0	0		0	0	0	308676	0	113	40213227		
57795	4801	1713671	1980-10-09	1980-10-09 00:00:00	1980-10-16	1980-10-16 00:00:00	1980-10-16	38000177		0	0	7		0	0	0	319402	0	562251	1713671		
52741	4383	46233988	1969-09-12	1969-09-12 00:00:00	1969-09-26	1969-09-26 00:00:00	1969-09-26	38000177		0	0	14		0	0	0	291330	0	1652673	46233988		
56900	4722	1713671	1933-03-29	1933-03-29 00:00:00	1933-04-05	1933-04-05 00:00:00	1933-04-05	38000177		0	0	7		0	0	0	314498	0	562251	1713671		
212361	4656	40213227	2010-11-14	2010-11-14 00:00:00	2010-11-14	2010-11-14 00:00:00	2010-11-14	581452		0	0	0		0	0	0	310476	0	113	40213227		
117323	2579	40213160	1955-09-25	1955-09-25 00:00:00	1955-09-25	1955-09-25 00:00:00	1955-09-25	581452		0	0	0		0	0	0	170820	0	10	40213160		
12229	1025	19059056	1941-04-18	1941-04-18 00:00:00	1941-05-16	1941-05-16 00:00:00	1941-05-16	38000177		0	0	28		0	0	0	67580	0	243670	19059056		
240723	5284	40213227	1999-07-21	1999-07-21 00:00:00	1999-07-21	1999-07-21 00:00:00	1999-07-21	581452		0	0	0		0	0	0	351511	0	113	40213227		
43624	3615	1713671	1990-07-08	1990-07-08 00:00:00	1990-07-29	1990-07-29 00:00:00	1990-07-29	38000177		0	0	21		0	0	0	240244	0	562251	1713671		
18366	399	40213160	1959-09-20	1959-09-20 00:00:00	1959-09-20	1959-09-20 00:00:00	1959-09-20	581452		0	0	0		0	0	0	26145	0	10	40213160		
89481	1962	40213260	2015-04-15	2015-04-15 00:00:00	2015-04-15	2015-04-15 00:00:00	2015-04-15	581452		0	0	0		0	0	0	130473	0	121	40213260		
25818	2123	40236824	2007-05-20	2007-05-20 00:00:00	2007-05-27	2007-05-27 00:00:00	2007-05-27	38000177		0	0	7		0	0	0	141313	0	1094107	40236824		
51734	1133	40213260	2016-07-15	2016-07-15 00:00:00	2016-07-15	2016-07-15 00:00:00	2016-07-15	581452		0	0	0		0	0	0	74615	0	121	40213260		
8280	691	1127433	2008-01-25	2008-01-25 00:00:00	2008-02-08	2008-02-08 00:00:00	2008-02-08	38000177		0	0	14		0	0	0	45778	0	313782	1127433		
112241	2466	40213314	1979-12-29	1979-12-29 00:00:00	1979-12-29	1979-12-29 00:00:00	1979-12-29	581452		0	0	0		0	0	0	163507	0	49	40213314		
92385	2028	40213227	1997-01-15	1997-01-15 00:00:00	1997-01-15	1997-01-15 00:00:00	1997-01-15	581452		0	0	0		0	0	0	134942	0	113	40213227		
31725	691	40213160	1957-12-17	1957-12-17 00:00:00	1957-12-17	1957-12-17 00:00:00	1957-12-17	581452		0	0	0		0	0	0	45748	0	10	40213160		
27691	2291	1127433	1977-12-20	1977-12-20 00:00:00	1978-02-18	1978-02-18 00:00:00	1978-02-18	38000177		0	0	60		0	0	0	152493	0	313782	1127433		
205213	4504	40213227	1998-11-21	1998-11-21 00:00:00	1998-11-21	1998-11-21 00:00:00	1998-11-21	581452		0	0	0		0	0	0	299958	0	113	40213227		
229552	5045	40213160	1960-07-09	1960-07-09 00:00:00	1960-07-09	1960-07-09 00:00:00	1960-07-09	581452		0	0	0		0	0	0	335233	0	10	40213160		
29534	2444	40220960	2013-08-11	2013-08-11 00:00:00	2013-08-11	2013-08-11 00:00:00	2013-08-11	38000177		0	0	0		0	0	0	162130	0	1804799	40220960		
198131	4353	40213306	1990-05-27	1990-05-27 00:00:00	1990-05-27	1990-05-27 00:00:00	1990-05-27	581452		0	0	0		0	0	0	288773	0	43	40213306		
44285	964	40213314	1978-04-09	1978-04-09 00:00:00	1978-04-09	1978-04-09 00:00:00	1978-04-09	581452		0	0	0		0	0	0	64179	0	49	40213314		
19253	1590	1127433	2003-05-20	2003-05-20 00:00:00	2003-05-27	2003-05-27 00:00:00	2003-05-27	38000177		0	0	7		0	0	0	106687	0	313782	1127433		
130580	2869	40213227	2001-10-30	2001-10-30 00:00:00	2001-10-30	2001-10-30 00:00:00	2001-10-30	581452		0	0	0		0	0	0	190907	0	113	40213227		
226747	4979	40213227	2008-05-09	2008-05-09 00:00:00	2008-05-09	2008-05-09 00:00:00	2008-05-09	581452		0	0	0		0	0	0	331247	0	113	40213227		
203254	4462	40213160	1955-10-13	1955-10-13 00:00:00	1955-10-13	1955-10-13 00:00:00	1955-10-13	581452		0	0	0		0	0	0	296945	0	10	40213160		
40347	3342	1115171	2011-10-11	2011-10-11 00:00:00	2012-01-09	2012-01-09 00:00:00	2012-01-09	38000177		0	0	90		0	0	0	221569	0	849574	1115171		
184293	4049	40213260	2012-05-29	2012-05-29 00:00:00	2012-05-29	2012-05-29 00:00:00	2012-05-29	581452		0	0	0		0	0	0	269146	0	121	40213260		
203028	4457	40213251	1988-04-19	1988-04-19 00:00:00	1988-04-19	1988-04-19 00:00:00	1988-04-19	581452		0	0	0		0	0	0	296650	0	21	40213251		
229834	5051	40213306	1998-07-16	1998-07-16 00:00:00	1998-07-16	1998-07-16 00:00:00	1998-07-16	581452		0	0	0		0	0	0	\N	0	43	40213306		
230405	5063	40213227	2012-06-08	2012-06-08 00:00:00	2012-06-08	2012-06-08 00:00:00	2012-06-08	581452		0	0	0		0	0	0	336566	0	113	40213227		
198716	4366	40213160	1982-01-12	1982-01-12 00:00:00	1982-01-12	1982-01-12 00:00:00	1982-01-12	581452		0	0	0		0	0	0	289710	0	10	40213160		
49127	1076	40213306	1995-10-27	1995-10-27 00:00:00	1995-10-27	1995-10-27 00:00:00	1995-10-27	581452		0	0	0		0	0	0	70559	0	43	40213306		
169561	3728	40213296	2014-05-18	2014-05-18 00:00:00	2014-05-18	2014-05-18 00:00:00	2014-05-18	581452		0	0	0		0	0	0	247740	0	52	40213296		
161943	3562	40213160	1968-11-27	1968-11-27 00:00:00	1968-11-27	1968-11-27 00:00:00	1968-11-27	581452		0	0	0		0	0	0	236599	0	10	40213160		
74346	1623	40213160	1955-12-30	1955-12-30 00:00:00	1955-12-30	1955-12-30 00:00:00	1955-12-30	581452		0	0	0		0	0	0	109097	0	10	40213160		
36872	3049	19126352	1987-05-08	1987-05-08 00:00:00	1987-05-08	1987-05-08 00:00:00	\N	38000177		0	0	0		0	0	0	202840	0	705129	19126352		
45150	3736	40243436	2006-06-28	2006-06-28 00:00:00	2006-06-28	2006-06-28 00:00:00	2006-06-28	38000177		0	0	0		0	0	0	248300	0	1190795	40243436		
202985	4456	40213296	2006-12-31	2006-12-31 00:00:00	2006-12-31	2006-12-31 00:00:00	2006-12-31	581452		0	0	0		0	0	0	296618	0	52	40213296		
162195	3567	40213160	1972-06-08	1972-06-08 00:00:00	1972-06-08	1972-06-08 00:00:00	1972-06-08	581452		0	0	0		0	0	0	237028	0	10	40213160		
9045	754	920334	1989-09-23	1989-09-23 00:00:00	1989-09-30	1989-09-30 00:00:00	1989-09-30	38000177		0	0	7		0	0	0	49851	0	311995	920334		
70112	1532	40213314	1978-01-04	1978-01-04 00:00:00	1978-01-04	1978-01-04 00:00:00	1978-01-04	581452		0	0	0		0	0	0	102616	0	49	40213314		
185695	4081	40213160	1955-10-17	1955-10-17 00:00:00	1955-10-17	1955-10-17 00:00:00	1955-10-17	581452		0	0	0		0	0	0	271224	0	10	40213160		
9198	196	40213160	1955-03-26	1955-03-26 00:00:00	1955-03-26	1955-03-26 00:00:00	1955-03-26	581452		0	0	0		0	0	0	13523	0	10	40213160		
204263	4484	40213160	1956-07-26	1956-07-26 00:00:00	1956-07-26	1956-07-26 00:00:00	1956-07-26	581452		0	0	0		0	0	0	298452	0	10	40213160		
3554	295	1127078	1951-04-06	1951-04-06 00:00:00	1951-06-05	1951-06-05 00:00:00	1951-06-05	38000177		0	0	60		0	0	0	19643	0	282464	1127078		
174725	3841	40213160	1972-06-07	1972-06-07 00:00:00	1972-06-07	1972-06-07 00:00:00	1972-06-07	581452		0	0	0		0	0	0	255007	0	10	40213160		
88182	1934	40213227	1994-04-16	1994-04-16 00:00:00	1994-04-16	1994-04-16 00:00:00	1994-04-16	581452		0	0	0		0	0	0	128682	0	113	40213227		
34921	2883	19128065	1982-02-01	1982-02-01 00:00:00	1983-01-27	1983-01-27 00:00:00	1983-01-27	38000177		0	0	360		0	0	0	191783	0	749882	19128065		
61291	1339	40213227	1997-06-26	1997-06-26 00:00:00	1997-06-26	1997-06-26 00:00:00	1997-06-26	581452		0	0	0		0	0	0	88818	0	113	40213227		
175037	3849	40213260	2013-11-21	2013-11-21 00:00:00	2013-11-21	2013-11-21 00:00:00	2013-11-21	581452		0	0	0		0	0	0	255433	0	121	40213260		
104412	2290	40213296	2000-07-01	2000-07-01 00:00:00	2000-07-01	2000-07-01 00:00:00	2000-07-01	581452		0	0	0		0	0	0	152375	0	52	40213296		
24787	2037	1127433	1974-01-30	1974-01-30 00:00:00	1974-04-30	1974-04-30 00:00:00	1974-04-30	38000177		0	0	90		0	0	0	135659	0	313782	1127433		
43096	3571	1127433	2017-07-17	2017-07-17 00:00:00	2017-07-31	2017-07-31 00:00:00	2017-07-31	38000177		0	0	14		0	0	0	237316	0	313782	1127433		
167393	3680	40213227	2012-12-18	2012-12-18 00:00:00	2012-12-18	2012-12-18 00:00:00	2012-12-18	581452		0	0	0		0	0	0	244739	0	113	40213227		
212086	4649	40213306	1991-04-15	1991-04-15 00:00:00	1991-04-15	1991-04-15 00:00:00	1991-04-15	581452		0	0	0		0	0	0	310038	0	43	40213306		
230586	5067	40213227	2017-05-14	2017-05-14 00:00:00	2017-05-14	2017-05-14 00:00:00	2017-05-14	581452		0	0	0		0	0	0	336861	0	113	40213227		
62148	5172	1127433	1967-06-08	1967-06-08 00:00:00	1967-06-22	1967-06-22 00:00:00	1967-06-22	38000177		0	0	14		0	0	0	343852	0	313782	1127433		
84253	1843	40213314	1982-01-27	1982-01-27 00:00:00	1982-01-27	1982-01-27 00:00:00	1982-01-27	581452		0	0	0		0	0	0	123089	0	49	40213314		
94346	2070	40213260	2015-11-02	2015-11-02 00:00:00	2015-11-02	2015-11-02 00:00:00	2015-11-02	581452		0	0	0		0	0	0	137652	0	121	40213260		
6787	571	1127433	2014-05-27	2014-05-27 00:00:00	2014-06-03	2014-06-03 00:00:00	2014-06-03	38000177		0	0	7		0	0	0	37828	0	313782	1127433		
17273	1431	40229134	2019-03-21	2019-03-21 00:00:00	2019-04-04	2019-04-04 00:00:00	2019-04-04	38000177		0	0	14		0	0	0	95307	0	1043400	40229134		
181271	3984	40213160	1955-11-30	1955-11-30 00:00:00	1955-11-30	1955-11-30 00:00:00	1955-11-30	581452		0	0	0		0	0	0	264828	0	10	40213160		
211194	4631	40213227	1995-07-14	1995-07-14 00:00:00	1995-07-14	1995-07-14 00:00:00	1995-07-14	581452		0	0	0		0	0	0	308675	0	113	40213227		
57796	4801	19059056	1972-12-15	1972-12-15 00:00:00	1972-12-29	1972-12-29 00:00:00	1972-12-29	38000177		0	0	14		0	0	0	319406	0	243670	19059056		
52742	4383	19133873	1975-05-18	1975-05-18 00:00:00	1975-05-26	1975-05-26 00:00:00	1975-05-26	38000177		0	0	8		0	0	0	291338	0	834061	19133873		
56901	4722	1118084	1945-07-25	1945-07-25 00:00:00	1945-07-25	1945-07-25 00:00:00	\N	38000177		0	0	0		0	0	0	314589	0	00025152531	44923712		
209965	4604	40213306	1986-10-26	1986-10-26 00:00:00	1986-10-26	1986-10-26 00:00:00	1986-10-26	581452		0	0	0		0	0	0	306773	0	43	40213306		
48748	1068	40213160	1978-08-25	1978-08-25 00:00:00	1978-08-25	1978-08-25 00:00:00	1978-08-25	581452		0	0	0		0	0	0	69994	0	10	40213160		
12230	1025	1713671	2004-03-07	2004-03-07 00:00:00	2004-03-28	2004-03-28 00:00:00	2004-03-28	38000177		0	0	21		0	0	0	67572	0	562251	1713671		
240727	5284	40213260	2016-08-24	2016-08-24 00:00:00	2016-08-24	2016-08-24 00:00:00	2016-08-24	581452		0	0	0		0	0	0	351592	0	121	40213260		
43625	3615	1127433	1997-09-25	1997-09-25 00:00:00	1997-10-09	1997-10-09 00:00:00	1997-10-09	38000177		0	0	14		0	0	0	240180	0	313782	1127433		
18371	399	40213160	1955-12-11	1955-12-11 00:00:00	1955-12-11	1955-12-11 00:00:00	1955-12-11	581452		0	0	0		0	0	0	26143	0	10	40213160		
89482	1962	40213160	1964-09-16	1964-09-16 00:00:00	1964-09-16	1964-09-16 00:00:00	1964-09-16	581452		0	0	0		0	0	0	130484	0	10	40213160		
29761	648	40213227	2014-02-28	2014-02-28 00:00:00	2014-02-28	2014-02-28 00:00:00	2014-02-28	581452		0	0	0		0	0	0	42872	0	113	40213227		
51744	1133	40213260	2015-07-10	2015-07-10 00:00:00	2015-07-10	2015-07-10 00:00:00	2015-07-10	581452		0	0	0		0	0	0	74635	0	121	40213260		
8281	691	19133905	1999-09-30	1999-09-30 00:00:00	1999-10-08	1999-10-08 00:00:00	1999-10-08	38000177		0	0	8		0	0	0	45746	0	834102	19133905		
112248	2466	40213314	1980-11-29	1980-11-29 00:00:00	1980-11-29	1980-11-29 00:00:00	1980-11-29	581452		0	0	0		0	0	0	163493	0	49	40213314		
92415	2028	40213227	2007-01-17	2007-01-17 00:00:00	2007-01-17	2007-01-17 00:00:00	2007-01-17	581452		0	0	0		0	0	0	\N	0	113	40213227		
31729	691	40213160	1962-06-19	1962-06-19 00:00:00	1962-06-19	1962-06-19 00:00:00	1962-06-19	581452		0	0	0		0	0	0	45799	0	10	40213160		
27693	2291	1713671	1967-05-31	1967-05-31 00:00:00	1967-06-14	1967-06-14 00:00:00	1967-06-14	38000177		0	0	14		0	0	0	152449	0	562251	1713671		
205214	4504	40213160	1967-02-25	1967-02-25 00:00:00	1967-02-25	1967-02-25 00:00:00	1967-02-25	581452		0	0	0		0	0	0	299908	0	10	40213160		
228270	5013	40213227	2006-09-01	2006-09-01 00:00:00	2006-09-01	2006-09-01 00:00:00	2006-09-01	581452		0	0	0		0	0	0	333207	0	113	40213227		
187712	4123	40213306	1984-11-04	1984-11-04 00:00:00	1984-11-04	1984-11-04 00:00:00	1984-11-04	581452		0	0	0		0	0	0	274106	0	43	40213306		
215305	4722	40213227	2000-08-20	2000-08-20 00:00:00	2000-08-20	2000-08-20 00:00:00	2000-08-20	581452		0	0	0		0	0	0	314519	0	113	40213227		
44287	964	40213160	1979-10-14	1979-10-14 00:00:00	1979-10-14	1979-10-14 00:00:00	1979-10-14	581452		0	0	0		0	0	0	64154	0	10	40213160		
19254	1590	19059056	1965-12-02	1965-12-02 00:00:00	1965-12-23	1965-12-23 00:00:00	1965-12-23	38000177		0	0	21		0	0	0	106673	0	243670	19059056		
130582	2869	40213227	2011-12-27	2011-12-27 00:00:00	2011-12-27	2011-12-27 00:00:00	2011-12-27	581452		0	0	0		0	0	0	190831	0	113	40213227		
226749	4979	40213314	1976-12-31	1976-12-31 00:00:00	1976-12-31	1976-12-31 00:00:00	1976-12-31	581452		0	0	0		0	0	0	331283	0	49	40213314		
203258	4462	40213260	2006-02-09	2006-02-09 00:00:00	2006-02-09	2006-02-09 00:00:00	2006-02-09	581452		0	0	0		0	0	0	296879	0	121	40213260		
40348	3342	1713671	2002-11-09	2002-11-09 00:00:00	2003-03-08	2003-03-08 00:00:00	2003-03-08	38000177		0	0	119		0	0	0	221580	0	562251	1713671		
43737	3624	19059056	1948-08-04	1948-08-04 00:00:00	1948-08-18	1948-08-18 00:00:00	1948-08-18	38000177		0	0	14		0	0	0	240972	0	243670	19059056		
203030	4457	40213306	2005-07-12	2005-07-12 00:00:00	2005-07-12	2005-07-12 00:00:00	2005-07-12	581452		0	0	0		0	0	0	296654	0	43	40213306		
186147	4090	40213201	2008-06-23	2008-06-23 00:00:00	2008-06-23	2008-06-23 00:00:00	2008-06-23	581452		0	0	0		0	0	0	271876	0	33	40213201		
230421	5063	40213227	2002-12-20	2002-12-20 00:00:00	2002-12-20	2002-12-20 00:00:00	2002-12-20	581452		0	0	0		0	0	0	336603	0	113	40213227		
198718	4366	40213251	1984-01-03	1984-01-03 00:00:00	1984-01-03	1984-01-03 00:00:00	1984-01-03	581452		0	0	0		0	0	0	289655	0	21	40213251		
49129	1076	40213227	1995-10-27	1995-10-27 00:00:00	1995-10-27	1995-10-27 00:00:00	1995-10-27	581452		0	0	0		0	0	0	70559	0	113	40213227		
169563	3728	40213227	2014-05-18	2014-05-18 00:00:00	2014-05-18	2014-05-18 00:00:00	2014-05-18	581452		0	0	0		0	0	0	247740	0	113	40213227		
161945	3562	40213306	1990-10-24	1990-10-24 00:00:00	1990-10-24	1990-10-24 00:00:00	1990-10-24	581452		0	0	0		0	0	0	236586	0	43	40213306		
15509	334	40213201	2002-05-29	2002-05-29 00:00:00	2002-05-29	2002-05-29 00:00:00	2002-05-29	581452		0	0	0		0	0	0	22150	0	33	40213201		
36873	3049	19075601	1997-09-12	1997-09-12 00:00:00	1997-09-12	1997-09-12 00:00:00	\N	38000177		0	0	0		0	0	0	202871	0	309362	19075601		
45151	3736	19059056	1952-02-29	1952-02-29 00:00:00	1952-03-14	1952-03-14 00:00:00	1952-03-14	38000177		0	0	14		0	0	0	248322	0	243670	19059056		
162176	3567	40213306	1989-08-31	1989-08-31 00:00:00	1989-08-31	1989-08-31 00:00:00	1989-08-31	581452		0	0	0		0	0	0	237003	0	43	40213306		
162205	3567	40213296	2007-07-12	2007-07-12 00:00:00	2007-07-12	2007-07-12 00:00:00	2007-07-12	581452		0	0	0		0	0	0	237032	0	52	40213296		
9046	754	19059056	1943-02-06	1943-02-06 00:00:00	1943-02-20	1943-02-20 00:00:00	1943-02-20	38000177		0	0	14		0	0	0	49925	0	243670	19059056		
70113	1532	40213160	1978-01-04	1978-01-04 00:00:00	1978-01-04	1978-01-04 00:00:00	1978-01-04	581452		0	0	0		0	0	0	102616	0	10	40213160		
185697	4081	40213160	1956-03-19	1956-03-19 00:00:00	1956-03-19	1956-03-19 00:00:00	1956-03-19	581452		0	0	0		0	0	0	271266	0	10	40213160		
9200	196	40213160	1955-06-25	1955-06-25 00:00:00	1955-06-25	1955-06-25 00:00:00	1955-06-25	581452		0	0	0		0	0	0	13477	0	10	40213160		
204269	4484	40213260	2006-02-23	2006-02-23 00:00:00	2006-02-23	2006-02-23 00:00:00	2006-02-23	581452		0	0	0		0	0	0	298490	0	121	40213260		
3555	295	19133873	1964-03-21	1964-03-21 00:00:00	1964-04-03	1964-04-03 00:00:00	1964-04-03	38000177		0	0	13		0	0	0	19629	0	834061	19133873		
160179	3526	40213227	2011-07-05	2011-07-05 00:00:00	2011-07-05	2011-07-05 00:00:00	2011-07-05	581452		0	0	0		0	0	0	233932	0	113	40213227		
88191	1935	40213160	1969-01-14	1969-01-14 00:00:00	1969-01-14	1969-01-14 00:00:00	1969-01-14	581452		0	0	0		0	0	0	128730	0	10	40213160		
34922	2883	1118084	2002-06-06	2002-06-06 00:00:00	2002-06-06	2002-06-06 00:00:00	\N	38000177		0	0	0		0	0	0	191758	0	00025152531	44923712		
61292	1339	40213160	1966-07-21	1966-07-21 00:00:00	1966-07-21	1966-07-21 00:00:00	1966-07-21	581452		0	0	0		0	0	0	88775	0	10	40213160		
175039	3849	40213227	1995-12-28	1995-12-28 00:00:00	1995-12-28	1995-12-28 00:00:00	1995-12-28	581452		0	0	0		0	0	0	255391	0	113	40213227		
104414	2290	40213260	2007-10-06	2007-10-06 00:00:00	2007-10-06	2007-10-06 00:00:00	2007-10-06	581452		0	0	0		0	0	0	152397	0	121	40213260		
24788	2037	19133905	1980-10-01	1980-10-01 00:00:00	1980-10-08	1980-10-08 00:00:00	1980-10-08	38000177		0	0	7		0	0	0	135678	0	834102	19133905		
43097	3571	1127433	2001-04-04	2001-04-04 00:00:00	2001-04-11	2001-04-11 00:00:00	2001-04-11	38000177		0	0	7		0	0	0	237312	0	313782	1127433		
143825	3161	40213227	1994-05-11	1994-05-11 00:00:00	1994-05-11	1994-05-11 00:00:00	1994-05-11	581452		0	0	0		0	0	0	210195	0	113	40213227		
212088	4649	40213227	2001-06-25	2001-06-25 00:00:00	2001-06-25	2001-06-25 00:00:00	2001-06-25	581452		0	0	0		0	0	0	310026	0	113	40213227		
230591	5067	40213296	2015-05-10	2015-05-10 00:00:00	2015-05-10	2015-05-10 00:00:00	2015-05-10	581452		0	0	0		0	0	0	336825	0	52	40213296		
62149	5172	19006318	1957-01-23	1957-01-23 00:00:00	1957-02-06	1957-02-06 00:00:00	1957-02-06	38000177		0	0	14		0	0	0	343831	0	105078	19006318		
84254	1843	40213160	1982-01-27	1982-01-27 00:00:00	1982-01-27	1982-01-27 00:00:00	1982-01-27	581452		0	0	0		0	0	0	123089	0	10	40213160		
94348	2070	40213227	2007-09-17	2007-09-17 00:00:00	2007-09-17	2007-09-17 00:00:00	2007-09-17	581452		0	0	0		0	0	0	137753	0	113	40213227		
6788	572	1118084	1992-04-01	1992-04-01 00:00:00	1992-04-01	1992-04-01 00:00:00	\N	38000177		0	0	0		0	0	0	37887	0	00025152531	44923712		
17274	1432	1127433	1984-05-28	1984-05-28 00:00:00	1984-06-25	1984-06-25 00:00:00	1984-06-25	38000177		0	0	28		0	0	0	95407	0	313782	1127433		
181277	3984	40213160	1955-06-01	1955-06-01 00:00:00	1955-06-01	1955-06-01 00:00:00	1955-06-01	581452		0	0	0		0	0	0	264852	0	10	40213160		
46584	1018	40213227	1993-05-24	1993-05-24 00:00:00	1993-05-24	1993-05-24 00:00:00	1993-05-24	581452		0	0	0		0	0	0	67045	0	113	40213227		
57797	4801	1115171	2016-12-08	2016-12-08 00:00:00	2017-02-06	2017-02-06 00:00:00	2017-02-06	38000177		0	0	60		0	0	0	319401	0	849574	1115171		
52743	4383	1127433	1990-12-20	1990-12-20 00:00:00	1991-01-03	1991-01-03 00:00:00	1991-01-03	38000177		0	0	14		0	0	0	291307	0	313782	1127433		
56902	4722	1713671	1956-04-15	1956-04-15 00:00:00	1956-05-06	1956-05-06 00:00:00	1956-05-06	38000177		0	0	21		0	0	0	314487	0	562251	1713671		
221246	4855	40213296	2019-04-06	2019-04-06 00:00:00	2019-04-06	2019-04-06 00:00:00	2019-04-06	581452		0	0	0		0	0	0	323029	0	52	40213296		
152262	3352	40213296	2004-10-29	2004-10-29 00:00:00	2004-10-29	2004-10-29 00:00:00	2004-10-29	581452		0	0	0		0	0	0	222320	0	52	40213296		
12231	1025	19059056	1968-03-30	1968-03-30 00:00:00	1968-04-27	1968-04-27 00:00:00	1968-04-27	38000177		0	0	28		0	0	0	67584	0	243670	19059056		
240730	5284	40213160	1967-02-01	1967-02-01 00:00:00	1967-02-01	1967-02-01 00:00:00	1967-02-01	581452		0	0	0		0	0	0	351531	0	10	40213160		
43626	3615	920334	1982-10-07	1982-10-07 00:00:00	1982-10-14	1982-10-14 00:00:00	1982-10-14	38000177		0	0	7		0	0	0	240171	0	311995	920334		
18381	399	40213227	1997-12-07	1997-12-07 00:00:00	1997-12-07	1997-12-07 00:00:00	1997-12-07	581452		0	0	0		0	0	0	26192	0	113	40213227		
89489	1962	40213160	1964-12-16	1964-12-16 00:00:00	1964-12-16	1964-12-16 00:00:00	1964-12-16	581452		0	0	0		0	0	0	130494	0	10	40213160		
29765	649	40213260	2018-02-13	2018-02-13 00:00:00	2018-02-13	2018-02-13 00:00:00	2018-02-13	581452		0	0	0		0	0	0	42977	0	121	40213260		
51752	1133	40213227	1997-06-27	1997-06-27 00:00:00	1997-06-27	1997-06-27 00:00:00	1997-06-27	581452		0	0	0		0	0	0	74629	0	113	40213227		
8282	691	1127433	1992-09-09	1992-09-09 00:00:00	1992-09-23	1992-09-23 00:00:00	1992-09-23	38000177		0	0	14		0	0	0	45804	0	313782	1127433		
112259	2466	40213227	2003-06-29	2003-06-29 00:00:00	2003-06-29	2003-06-29 00:00:00	2003-06-29	581452		0	0	0		0	0	0	163483	0	113	40213227		
92424	2028	40213201	2012-04-11	2012-04-11 00:00:00	2012-04-11	2012-04-11 00:00:00	2012-04-11	581452		0	0	0		0	0	0	134968	0	33	40213201		
31733	691	40213260	2007-09-11	2007-09-11 00:00:00	2007-09-11	2007-09-11 00:00:00	2007-09-11	581452		0	0	0		0	0	0	45811	0	121	40213260		
27694	2291	19133873	1966-01-18	1966-01-18 00:00:00	1966-01-30	1966-01-30 00:00:00	1966-01-30	38000177		0	0	12		0	0	0	152448	0	834061	19133873		
168684	3708	40213296	2017-05-19	2017-05-19 00:00:00	2017-05-19	2017-05-19 00:00:00	2017-05-19	581452		0	0	0		0	0	0	246513	0	52	40213296		
228271	5013	40213296	2006-09-01	2006-09-01 00:00:00	2006-09-01	2006-09-01 00:00:00	2006-09-01	581452		0	0	0		0	0	0	333207	0	52	40213296		
187726	4123	40213227	2013-06-09	2013-06-09 00:00:00	2013-06-09	2013-06-09 00:00:00	2013-06-09	581452		0	0	0		0	0	0	274099	0	113	40213227		
73799	1611	40213160	1955-05-15	1955-05-15 00:00:00	1955-05-15	1955-05-15 00:00:00	1955-05-15	581452		0	0	0		0	0	0	108280	0	10	40213160		
44291	964	40213296	2014-11-09	2014-11-09 00:00:00	2014-11-09	2014-11-09 00:00:00	2014-11-09	581452		0	0	0		0	0	0	64167	0	52	40213296		
19255	1590	1124300	1999-02-07	1999-02-07 00:00:00	1999-02-07	1999-02-07 00:00:00	\N	38000177		0	0	0		0	0	0	106745	0	00781178901	45011828		
130584	2869	40213198	2016-01-19	2016-01-19 00:00:00	2016-01-19	2016-01-19 00:00:00	2016-01-19	581452		0	0	0		0	0	0	190860	0	133	40213198		
226750	4979	40213160	1976-12-31	1976-12-31 00:00:00	1976-12-31	1976-12-31 00:00:00	1976-12-31	581452		0	0	0		0	0	0	331283	0	10	40213160		
203260	4462	40213227	2006-02-09	2006-02-09 00:00:00	2006-02-09	2006-02-09 00:00:00	2006-02-09	581452		0	0	0		0	0	0	296879	0	113	40213227		
40349	3343	1127433	2001-03-30	2001-03-30 00:00:00	2001-04-06	2001-04-06 00:00:00	2001-04-06	38000177		0	0	7		0	0	0	221786	0	313782	1127433		
43738	3624	40162522	1981-02-12	1981-02-12 00:00:00	1981-02-12	1981-02-12 00:00:00	\N	38000177		0	0	0		0	0	0	241010	0	857005	40162522		
203031	4457	40213180	2005-07-12	2005-07-12 00:00:00	2005-07-12	2005-07-12 00:00:00	2005-07-12	581452		0	0	0		0	0	0	296654	0	114	40213180		
230380	5063	40213227	1992-04-10	1992-04-10 00:00:00	1992-04-10	1992-04-10 00:00:00	1992-04-10	581452		0	0	0		0	0	0	336558	0	113	40213227		
230424	5063	40213198	2010-01-29	2010-01-29 00:00:00	2010-01-29	2010-01-29 00:00:00	2010-01-29	581452		0	0	0		0	0	0	336564	0	133	40213198		
198722	4366	40213314	1981-10-13	1981-10-13 00:00:00	1981-10-13	1981-10-13 00:00:00	1981-10-13	581452		0	0	0		0	0	0	289599	0	49	40213314		
49132	1076	40213160	1973-10-19	1973-10-19 00:00:00	1973-10-19	1973-10-19 00:00:00	1973-10-19	581452		0	0	0		0	0	0	70528	0	10	40213160		
214530	4704	40213306	1988-04-16	1988-04-16 00:00:00	1988-04-16	1988-04-16 00:00:00	1988-04-16	581452		0	0	0		0	0	0	313389	0	43	40213306		
161947	3562	40213227	2001-08-22	2001-08-22 00:00:00	2001-08-22	2001-08-22 00:00:00	2001-08-22	581452		0	0	0		0	0	0	236589	0	113	40213227		
15515	334	40213227	2016-08-17	2016-08-17 00:00:00	2016-08-17	2016-08-17 00:00:00	2016-08-17	581452		0	0	0		0	0	0	22158	0	113	40213227		
36874	3049	19133768	1986-12-05	1986-12-05 00:00:00	1986-12-05	1986-12-05 00:00:00	1986-12-05	38000177		0	0	0		0	0	0	202874	0	833036	19133768		
45152	3736	19006318	1952-02-29	1952-02-29 00:00:00	1952-03-14	1952-03-14 00:00:00	1952-03-14	38000177		0	0	14		0	0	0	248322	0	105078	19006318		
162178	3567	40213227	2009-07-16	2009-07-16 00:00:00	2009-07-16	2009-07-16 00:00:00	2009-07-16	581452		0	0	0		0	0	0	237033	0	113	40213227		
162207	3567	40213160	1968-03-07	1968-03-07 00:00:00	1968-03-07	1968-03-07 00:00:00	1968-03-07	581452		0	0	0		0	0	0	237013	0	10	40213160		
9047	754	19059056	1945-01-14	1945-01-14 00:00:00	1945-02-18	1945-02-18 00:00:00	1945-02-18	38000177		0	0	35		0	0	0	49819	0	243670	19059056		
70120	1533	40213296	2011-01-04	2011-01-04 00:00:00	2011-01-04	2011-01-04 00:00:00	2011-01-04	581452		0	0	0		0	0	0	102682	0	52	40213296		
200116	4395	40213227	2018-05-11	2018-05-11 00:00:00	2018-05-11	2018-05-11 00:00:00	2018-05-11	581452		0	0	0		0	0	0	292284	0	113	40213227		
9827	209	40213198	2016-05-20	2016-05-20 00:00:00	2016-05-20	2016-05-20 00:00:00	2016-05-20	581452		0	0	0		0	0	0	14279	0	133	40213198		
204279	4484	40213227	2013-05-16	2013-05-16 00:00:00	2013-05-16	2013-05-16 00:00:00	2013-05-16	581452		0	0	0		0	0	0	298518	0	113	40213227		
3556	295	1127433	1984-04-12	1984-04-12 00:00:00	1984-05-10	1984-05-10 00:00:00	1984-05-10	38000177		0	0	28		0	0	0	19644	0	313782	1127433		
160194	3526	40213198	2015-01-13	2015-01-13 00:00:00	2015-01-13	2015-01-13 00:00:00	2015-01-13	581452		0	0	0		0	0	0	233976	0	133	40213198		
88194	1935	40213296	2004-02-17	2004-02-17 00:00:00	2004-02-17	2004-02-17 00:00:00	2004-02-17	581452		0	0	0		0	0	0	128721	0	52	40213296		
34945	2886	1127433	1985-08-03	1985-08-03 00:00:00	1985-08-10	1985-08-10 00:00:00	1985-08-10	38000177		0	0	7		0	0	0	191943	0	313782	1127433		
61294	1339	40213227	2008-04-24	2008-04-24 00:00:00	2008-04-24	2008-04-24 00:00:00	2008-04-24	581452		0	0	0		0	0	0	88813	0	113	40213227		
175041	3849	40213306	1986-12-18	1986-12-18 00:00:00	1986-12-18	1986-12-18 00:00:00	1986-12-18	581452		0	0	0		0	0	0	255425	0	43	40213306		
104416	2290	40213227	2007-10-06	2007-10-06 00:00:00	2007-10-06	2007-10-06 00:00:00	2007-10-06	581452		0	0	0		0	0	0	152397	0	113	40213227		
24789	2037	1127433	1970-07-23	1970-07-23 00:00:00	1970-08-06	1970-08-06 00:00:00	1970-08-06	38000177		0	0	14		0	0	0	135679	0	313782	1127433		
43098	3571	1713671	2004-11-18	2004-11-18 00:00:00	2004-12-02	2004-12-02 00:00:00	2004-12-02	38000177		0	0	14		0	0	0	237313	0	562251	1713671		
143837	3161	40213160	1955-04-20	1955-04-20 00:00:00	1955-04-20	1955-04-20 00:00:00	1955-04-20	581452		0	0	0		0	0	0	210180	0	10	40213160		
212097	4649	40213160	1974-01-21	1974-01-21 00:00:00	1974-01-21	1974-01-21 00:00:00	1974-01-21	581452		0	0	0		0	0	0	310020	0	10	40213160		
230592	5067	40213314	1977-05-08	1977-05-08 00:00:00	1977-05-08	1977-05-08 00:00:00	1977-05-08	581452		0	0	0		0	0	0	336895	0	49	40213314		
62150	5172	1127078	1957-01-23	1957-01-23 00:00:00	1957-02-06	1957-02-06 00:00:00	1957-02-06	38000177		0	0	14		0	0	0	343831	0	282464	1127078		
84257	1843	40213160	1982-04-28	1982-04-28 00:00:00	1982-04-28	1982-04-28 00:00:00	1982-04-28	581452		0	0	0		0	0	0	123000	0	10	40213160		
94349	2070	40213296	2007-09-17	2007-09-17 00:00:00	2007-09-17	2007-09-17 00:00:00	2007-09-17	581452		0	0	0		0	0	0	137753	0	52	40213296		
6790	572	19059056	1954-01-21	1954-01-21 00:00:00	1954-02-04	1954-02-04 00:00:00	1954-02-04	38000177		0	0	14		0	0	0	37878	0	243670	19059056		
17275	1432	1127433	1979-07-06	1979-07-06 00:00:00	1979-07-13	1979-07-13 00:00:00	1979-07-13	38000177		0	0	7		0	0	0	95415	0	313782	1127433		
181283	3984	40213227	2015-12-02	2015-12-02 00:00:00	2015-12-02	2015-12-02 00:00:00	2015-12-02	581452		0	0	0		0	0	0	264815	0	113	40213227		
46585	1018	40213306	1993-05-24	1993-05-24 00:00:00	1993-05-24	1993-05-24 00:00:00	1993-05-24	581452		0	0	0		0	0	0	67045	0	43	40213306		
57798	4801	1713671	2006-04-26	2006-04-26 00:00:00	2006-05-03	2006-05-03 00:00:00	2006-05-03	38000177		0	0	7		0	0	0	319379	0	562251	1713671		
52744	4383	1127433	2004-05-21	2004-05-21 00:00:00	2004-06-11	2004-06-11 00:00:00	2004-06-11	38000177		0	0	21		0	0	0	291359	0	313782	1127433		
56903	4722	1127433	1984-04-09	1984-04-09 00:00:00	1984-05-09	1984-05-09 00:00:00	1984-05-09	38000177		0	0	30		0	0	0	314613	0	313782	1127433		
221248	4855	40213227	2019-04-06	2019-04-06 00:00:00	2019-04-06	2019-04-06 00:00:00	2019-04-06	581452		0	0	0		0	0	0	323029	0	113	40213227		
152265	3352	40213160	1965-04-02	1965-04-02 00:00:00	1965-04-02	1965-04-02 00:00:00	1965-04-02	581452		0	0	0		0	0	0	222287	0	10	40213160		
12232	1025	40229134	1987-10-21	1987-10-21 00:00:00	1987-10-28	1987-10-28 00:00:00	1987-10-28	38000177		0	0	7		0	0	0	67510	0	1043400	40229134		
240733	5284	40213160	1967-05-03	1967-05-03 00:00:00	1967-05-03	1967-05-03 00:00:00	1967-05-03	581452		0	0	0		0	0	0	351622	0	10	40213160		
43627	3615	1127433	2007-11-21	2007-11-21 00:00:00	2007-12-19	2007-12-19 00:00:00	2007-12-19	38000177		0	0	28		0	0	0	240220	0	313782	1127433		
18382	399	40213296	1997-12-07	1997-12-07 00:00:00	1997-12-07	1997-12-07 00:00:00	1997-12-07	581452		0	0	0		0	0	0	26192	0	52	40213296		
89490	1962	40213160	1969-03-19	1969-03-19 00:00:00	1969-03-19	1969-03-19 00:00:00	1969-03-19	581452		0	0	0		0	0	0	130463	0	10	40213160		
29769	649	40213160	1968-07-23	1968-07-23 00:00:00	1968-07-23	1968-07-23 00:00:00	1968-07-23	581452		0	0	0		0	0	0	42982	0	10	40213160		
51753	1133	40213227	2007-11-09	2007-11-09 00:00:00	2007-11-09	2007-11-09 00:00:00	2007-11-09	581452		0	0	0		0	0	0	74641	0	113	40213227		
8283	691	19075001	1992-09-09	1992-09-09 00:00:00	1992-09-23	1992-09-23 00:00:00	1992-09-23	38000177		0	0	14		0	0	0	45804	0	309097	19075001		
112260	2466	40213306	2003-06-29	2003-06-29 00:00:00	2003-06-29	2003-06-29 00:00:00	2003-06-29	581452		0	0	0		0	0	0	163483	0	43	40213306		
22186	482	40213227	2003-05-29	2003-05-29 00:00:00	2003-05-29	2003-05-29 00:00:00	2003-05-29	581452		0	0	0		0	0	0	32211	0	113	40213227		
31734	691	40213160	1958-02-18	1958-02-18 00:00:00	1958-02-18	1958-02-18 00:00:00	1958-02-18	581452		0	0	0		0	0	0	45754	0	10	40213160		
27695	2291	40229134	2001-03-14	2001-03-14 00:00:00	2001-03-21	2001-03-21 00:00:00	2001-03-21	38000177		0	0	7		0	0	0	152417	0	1043400	40229134		
168685	3708	40213306	1999-11-12	1999-11-12 00:00:00	1999-11-12	1999-11-12 00:00:00	1999-11-12	581452		0	0	0		0	0	0	246581	0	43	40213306		
228298	5014	40213227	1993-12-07	1993-12-07 00:00:00	1993-12-07	1993-12-07 00:00:00	1993-12-07	581452		0	0	0		0	0	0	333233	0	113	40213227		
187727	4123	40213260	2013-06-09	2013-06-09 00:00:00	2013-06-09	2013-06-09 00:00:00	2013-06-09	581452		0	0	0		0	0	0	274099	0	121	40213260		
73806	1611	40213160	1955-11-13	1955-11-13 00:00:00	1955-11-13	1955-11-13 00:00:00	1955-11-13	581452		0	0	0		0	0	0	108325	0	10	40213160		
44294	964	40213296	2016-11-13	2016-11-13 00:00:00	2016-11-13	2016-11-13 00:00:00	2016-11-13	581452		0	0	0		0	0	0	64165	0	52	40213296		
19256	1590	1127433	1979-02-13	1979-02-13 00:00:00	1979-02-27	1979-02-27 00:00:00	1979-02-27	38000177		0	0	14		0	0	0	106674	0	313782	1127433		
130602	2869	40213160	1955-10-04	1955-10-04 00:00:00	1955-10-04	1955-10-04 00:00:00	1955-10-04	581452		0	0	0		0	0	0	190842	0	10	40213160		
226753	4979	40213160	1976-10-29	1976-10-29 00:00:00	1976-10-29	1976-10-29 00:00:00	1976-10-29	581452		0	0	0		0	0	0	331251	0	10	40213160		
203265	4462	40213160	1955-07-14	1955-07-14 00:00:00	1955-07-14	1955-07-14 00:00:00	1955-07-14	581452		0	0	0		0	0	0	296928	0	10	40213160		
40350	3343	40169216	1978-06-13	1978-06-13 00:00:00	1978-06-13	1978-06-13 00:00:00	\N	38000177		0	0	0		0	0	0	221805	0	895994	40169216		
43739	3624	19074841	1981-02-12	1981-02-12 00:00:00	1981-02-26	1981-02-26 00:00:00	1981-02-26	38000177		0	0	14		0	0	0	241010	0	309043	19074841		
203033	4457	40213227	2005-07-12	2005-07-12 00:00:00	2005-07-12	2005-07-12 00:00:00	2005-07-12	581452		0	0	0		0	0	0	296654	0	113	40213227		
230393	5063	40213201	2008-01-18	2008-01-18 00:00:00	2008-01-18	2008-01-18 00:00:00	2008-01-18	581452		0	0	0		0	0	0	336563	0	33	40213201		
57417	4763	19059056	1966-08-19	1966-08-19 00:00:00	1966-09-18	1966-09-18 00:00:00	1966-09-18	38000177		0	0	30		0	0	0	317454	0	243670	19059056		
198723	4366	40213160	1981-10-13	1981-10-13 00:00:00	1981-10-13	1981-10-13 00:00:00	1981-10-13	581452		0	0	0		0	0	0	289599	0	10	40213160		
49135	1076	40213227	2004-11-05	2004-11-05 00:00:00	2004-11-05	2004-11-05 00:00:00	2004-11-05	581452		0	0	0		0	0	0	70543	0	113	40213227		
214533	4704	40213227	2017-12-02	2017-12-02 00:00:00	2017-12-02	2017-12-02 00:00:00	2017-12-02	581452		0	0	0		0	0	0	313411	0	113	40213227		
43090	939	40213160	1965-03-23	1965-03-23 00:00:00	1965-03-23	1965-03-23 00:00:00	1965-03-23	581452		0	0	0		0	0	0	62445	0	10	40213160		
15521	335	40213227	1995-11-14	1995-11-14 00:00:00	1995-11-14	1995-11-14 00:00:00	1995-11-14	581452		0	0	0		0	0	0	22241	0	113	40213227		
36875	3049	1118084	2014-08-02	2014-08-02 00:00:00	2014-08-02	2014-08-02 00:00:00	\N	38000177		0	0	0		0	0	0	202890	0	00025152531	44923712		
58627	1283	40213160	1959-11-23	1959-11-23 00:00:00	1959-11-23	1959-11-23 00:00:00	1959-11-23	581452		0	0	0		0	0	0	84781	0	10	40213160		
162179	3567	40213296	2009-07-16	2009-07-16 00:00:00	2009-07-16	2009-07-16 00:00:00	2009-07-16	581452		0	0	0		0	0	0	237033	0	52	40213296		
162212	3567	40213160	1967-12-07	1967-12-07 00:00:00	1967-12-07	1967-12-07 00:00:00	1967-12-07	581452		0	0	0		0	0	0	237011	0	10	40213160		
9048	754	40236824	1989-09-16	1989-09-16 00:00:00	1989-09-30	1989-09-30 00:00:00	1989-09-30	38000177		0	0	14		0	0	0	49850	0	1094107	40236824		
70123	1533	40213227	2013-01-08	2013-01-08 00:00:00	2013-01-08	2013-01-08 00:00:00	2013-01-08	581452		0	0	0		0	0	0	102688	0	113	40213227		
200119	4395	40213227	1998-01-16	1998-01-16 00:00:00	1998-01-16	1998-01-16 00:00:00	1998-01-16	581452		0	0	0		0	0	0	292253	0	113	40213227		
9831	209	40213160	1956-02-03	1956-02-03 00:00:00	1956-02-03	1956-02-03 00:00:00	1956-02-03	581452		0	0	0		0	0	0	14218	0	10	40213160		
204282	4484	40213198	2017-06-08	2017-06-08 00:00:00	2017-06-08	2017-06-08 00:00:00	2017-06-08	581452		0	0	0		0	0	0	298520	0	133	40213198		
3557	295	1118084	1993-06-19	1993-06-19 00:00:00	1993-06-19	1993-06-19 00:00:00	\N	38000177		0	0	0		0	0	0	19602	0	00025152531	44923712		
160200	3526	40213227	1993-04-13	1993-04-13 00:00:00	1993-04-13	1993-04-13 00:00:00	1993-04-13	581452		0	0	0		0	0	0	233972	0	113	40213227		
88204	1935	40213260	2015-02-10	2015-02-10 00:00:00	2015-02-10	2015-02-10 00:00:00	2015-02-10	581452		0	0	0		0	0	0	128750	0	121	40213260		
34946	2886	19059056	1963-06-06	1963-06-06 00:00:00	1963-08-05	1963-08-05 00:00:00	1963-08-05	38000177		0	0	60		0	0	0	191967	0	243670	19059056		
61295	1339	40213296	2008-04-24	2008-04-24 00:00:00	2008-04-24	2008-04-24 00:00:00	2008-04-24	581452		0	0	0		0	0	0	88813	0	52	40213296		
175043	3849	40213296	2004-01-08	2004-01-08 00:00:00	2004-01-08	2004-01-08 00:00:00	2004-01-08	581452		0	0	0		0	0	0	255444	0	52	40213296		
104422	2290	40213160	1961-09-09	1961-09-09 00:00:00	1961-09-09	1961-09-09 00:00:00	1961-09-09	581452		0	0	0		0	0	0	152335	0	10	40213160		
24790	2037	19078461	2002-04-03	2002-04-03 00:00:00	2002-05-01	2002-05-01 00:00:00	2002-05-01	38000177		0	0	28		0	0	0	135660	0	310965	19078461		
43099	3572	1713671	1972-12-24	1972-12-24 00:00:00	1972-12-31	1972-12-31 00:00:00	1972-12-31	38000177		0	0	7		0	0	0	237493	0	562251	1713671		
156270	3439	40213227	2002-09-26	2002-09-26 00:00:00	2002-09-26	2002-09-26 00:00:00	2002-09-26	581452		0	0	0		0	0	0	228154	0	113	40213227		
212102	4649	40213260	2019-06-03	2019-06-03 00:00:00	2019-06-03	2019-06-03 00:00:00	2019-06-03	581452		0	0	0		0	0	0	310041	0	121	40213260		
230595	5067	40213160	1974-11-10	1974-11-10 00:00:00	1974-11-10	1974-11-10 00:00:00	1974-11-10	581452		0	0	0		0	0	0	336833	0	10	40213160		
62151	5172	19133905	1990-04-26	1990-04-26 00:00:00	1990-05-08	1990-05-08 00:00:00	1990-05-08	38000177		0	0	12		0	0	0	343880	0	834102	19133905		
84259	1843	40213227	2003-09-10	2003-09-10 00:00:00	2003-09-10	2003-09-10 00:00:00	2003-09-10	581452		0	0	0		0	0	0	123078	0	113	40213227		
94356	2070	40213260	2014-10-27	2014-10-27 00:00:00	2014-10-27	2014-10-27 00:00:00	2014-10-27	581452		0	0	0		0	0	0	137725	0	121	40213260		
6791	572	19006318	1954-01-21	1954-01-21 00:00:00	1954-02-04	1954-02-04 00:00:00	1954-02-04	38000177		0	0	14		0	0	0	37878	0	105078	19006318		
17276	1432	19059056	1963-10-18	1963-10-18 00:00:00	1963-11-01	1963-11-01 00:00:00	1963-11-01	38000177		0	0	14		0	0	0	95383	0	243670	19059056		
181290	3984	40213227	1996-09-18	1996-09-18 00:00:00	1996-09-18	1996-09-18 00:00:00	1996-09-18	581452		0	0	0		0	0	0	264835	0	113	40213227		
46594	1018	40213160	1971-09-20	1971-09-20 00:00:00	1971-09-20	1971-09-20 00:00:00	1971-09-20	581452		0	0	0		0	0	0	67021	0	10	40213160		
57799	4801	1127078	1983-03-23	1983-03-23 00:00:00	1983-06-21	1983-06-21 00:00:00	1983-06-21	38000177		0	0	90		0	0	0	319421	0	282464	1127078		
52745	4383	1713671	2002-09-23	2002-09-23 00:00:00	2002-10-07	2002-10-07 00:00:00	2002-10-07	38000177		0	0	14		0	0	0	291327	0	562251	1713671		
56904	4722	19078461	2012-10-14	2012-10-14 00:00:00	2013-01-12	2013-01-12 00:00:00	2013-01-12	38000177		0	0	90		0	0	0	314616	0	310965	19078461		
221250	4855	40213314	1977-12-17	1977-12-17 00:00:00	1977-12-17	1977-12-17 00:00:00	1977-12-17	581452		0	0	0		0	0	0	323009	0	49	40213314		
152269	3352	40213227	2006-11-03	2006-11-03 00:00:00	2006-11-03	2006-11-03 00:00:00	2006-11-03	581452		0	0	0		0	0	0	222267	0	113	40213227		
12233	1025	1127433	2018-03-20	2018-03-20 00:00:00	2018-04-03	2018-04-03 00:00:00	2018-04-03	38000177		0	0	14		0	0	0	67512	0	313782	1127433		
240740	5284	40213306	1989-03-08	1989-03-08 00:00:00	1989-03-08	1989-03-08 00:00:00	1989-03-08	581452		0	0	0		0	0	0	351503	0	43	40213306		
43628	3615	1127433	1970-07-13	1970-07-13 00:00:00	1970-07-20	1970-07-20 00:00:00	1970-07-20	38000177		0	0	7		0	0	0	240213	0	313782	1127433		
18394	399	40213296	1998-07-19	1998-07-19 00:00:00	1998-07-19	1998-07-19 00:00:00	1998-07-19	581452		0	0	0		0	0	0	26216	0	52	40213296		
89492	1962	40213227	1995-06-21	1995-06-21 00:00:00	1995-06-21	1995-06-21 00:00:00	1995-06-21	581452		0	0	0		0	0	0	130498	0	113	40213227		
29773	649	40213160	1968-10-22	1968-10-22 00:00:00	1968-10-22	1968-10-22 00:00:00	1968-10-22	581452		0	0	0		0	0	0	43012	0	10	40213160		
51754	1133	40213296	2007-11-09	2007-11-09 00:00:00	2007-11-09	2007-11-09 00:00:00	2007-11-09	581452		0	0	0		0	0	0	74641	0	52	40213296		
8284	691	1127433	2019-06-20	2019-06-20 00:00:00	2019-06-20	2019-06-20 00:00:00	\N	38000177		0	0	0		0	0	0	45788	0	313782	1127433		
97377	2134	40213227	1993-09-05	1993-09-05 00:00:00	1993-09-05	1993-09-05 00:00:00	1993-09-05	581452		0	0	0		0	0	0	141968	0	113	40213227		
22188	482	40213160	1970-04-02	1970-04-02 00:00:00	1970-04-02	1970-04-02 00:00:00	1970-04-02	581452		0	0	0		0	0	0	32201	0	10	40213160		
31742	691	40213160	1958-05-20	1958-05-20 00:00:00	1958-05-20	1958-05-20 00:00:00	1958-05-20	581452		0	0	0		0	0	0	45749	0	10	40213160		
27696	2291	1154615	1964-10-19	1964-10-19 00:00:00	1980-10-09	1980-10-09 00:00:00	1980-10-09	38000177		0	0	5834		0	0	0	152406	0	745679	1154615		
168689	3708	40213227	2019-05-24	2019-05-24 00:00:00	2019-05-24	2019-05-24 00:00:00	2019-05-24	581452		0	0	0		0	0	0	246584	0	113	40213227		
216214	4745	40213296	2016-10-19	2016-10-19 00:00:00	2016-10-19	2016-10-19 00:00:00	2016-10-19	581452		0	0	0		0	0	0	315980	0	52	40213296		
187729	4123	40213160	1961-10-01	1961-10-01 00:00:00	1961-10-01	1961-10-01 00:00:00	1961-10-01	581452		0	0	0		0	0	0	274122	0	10	40213160		
73810	1611	40213160	1957-05-19	1957-05-19 00:00:00	1957-05-19	1957-05-19 00:00:00	1957-05-19	581452		0	0	0		0	0	0	108326	0	10	40213160		
44296	964	40213227	2016-11-13	2016-11-13 00:00:00	2016-11-13	2016-11-13 00:00:00	2016-11-13	581452		0	0	0		0	0	0	64165	0	113	40213227		
29715	2461	1713671	1995-09-22	1995-09-22 00:00:00	1995-10-13	1995-10-13 00:00:00	1995-10-13	38000177		0	0	21		0	0	0	163145	0	562251	1713671		
40131	3321	1127078	1980-01-09	1980-01-09 00:00:00	1980-01-30	1980-01-30 00:00:00	1980-01-30	38000177		0	0	21		0	0	0	220499	0	282464	1127078		
226754	4979	40213160	1977-04-01	1977-04-01 00:00:00	1977-04-01	1977-04-01 00:00:00	1977-04-01	581452		0	0	0		0	0	0	331295	0	10	40213160		
203271	4462	40213260	2007-02-15	2007-02-15 00:00:00	2007-02-15	2007-02-15 00:00:00	2007-02-15	581452		0	0	0		0	0	0	296907	0	121	40213260		
40351	3343	1154615	1978-06-13	1978-06-13 00:00:00	1978-06-13	1978-06-13 00:00:00	\N	38000177		0	0	0		0	0	0	221805	0	745679	1154615		
43740	3624	1127433	1981-02-12	1981-02-12 00:00:00	1981-02-26	1981-02-26 00:00:00	1981-02-26	38000177		0	0	14		0	0	0	241010	0	313782	1127433		
203035	4457	40213314	1984-07-17	1984-07-17 00:00:00	1984-07-17	1984-07-17 00:00:00	1984-07-17	581452		0	0	0		0	0	0	296665	0	49	40213314		
57367	4759	1127433	1992-06-30	1992-06-30 00:00:00	1992-07-14	1992-07-14 00:00:00	1992-07-14	38000177		0	0	14		0	0	0	317120	0	313782	1127433		
57418	4763	1127433	1989-11-21	1989-11-21 00:00:00	1990-01-20	1990-01-20 00:00:00	1990-01-20	38000177		0	0	60		0	0	0	317457	0	313782	1127433		
198726	4366	40213160	1981-08-11	1981-08-11 00:00:00	1981-08-11	1981-08-11 00:00:00	1981-08-11	581452		0	0	0		0	0	0	289709	0	10	40213160		
49136	1076	40213296	2015-05-22	2015-05-22 00:00:00	2015-05-22	2015-05-22 00:00:00	2015-05-22	581452		0	0	0		0	0	0	70518	0	52	40213296		
214535	4704	40213260	2017-12-02	2017-12-02 00:00:00	2017-12-02	2017-12-02 00:00:00	2017-12-02	581452		0	0	0		0	0	0	313411	0	121	40213260		
43124	940	40213227	1993-12-02	1993-12-02 00:00:00	1993-12-02	1993-12-02 00:00:00	1993-12-02	581452		0	0	0		0	0	0	62531	0	113	40213227		
15533	335	40213160	1968-02-27	1968-02-27 00:00:00	1968-02-27	1968-02-27 00:00:00	1968-02-27	581452		0	0	0		0	0	0	22247	0	10	40213160		
36876	3049	1127433	1997-10-14	1997-10-14 00:00:00	1997-10-28	1997-10-28 00:00:00	1997-10-28	38000177		0	0	14		0	0	0	202849	0	313782	1127433		
58628	1283	40213160	1964-02-24	1964-02-24 00:00:00	1964-02-24	1964-02-24 00:00:00	1964-02-24	581452		0	0	0		0	0	0	84812	0	10	40213160		
162181	3567	40213227	1992-01-02	1992-01-02 00:00:00	1992-01-02	1992-01-02 00:00:00	1992-01-02	581452		0	0	0		0	0	0	237035	0	113	40213227		
162214	3567	40213227	2001-01-11	2001-01-11 00:00:00	2001-01-11	2001-01-11 00:00:00	2001-01-11	581452		0	0	0		0	0	0	237004	0	113	40213227		
9049	754	920300	1989-09-16	1989-09-16 00:00:00	1989-09-23	1989-09-23 00:00:00	1989-09-23	38000177		0	0	7		0	0	0	49850	0	311989	920300		
70124	1533	40213296	2013-01-08	2013-01-08 00:00:00	2013-01-08	2013-01-08 00:00:00	2013-01-08	581452		0	0	0		0	0	0	102688	0	52	40213296		
211422	4636	40213227	2017-10-17	2017-10-17 00:00:00	2017-10-17	2017-10-17 00:00:00	2017-10-17	581452		0	0	0		0	0	0	308965	0	113	40213227		
9838	209	40213227	2012-04-27	2012-04-27 00:00:00	2012-04-27	2012-04-27 00:00:00	2012-04-27	581452		0	0	0		0	0	0	14227	0	113	40213227		
204294	4484	40213201	2018-06-14	2018-06-14 00:00:00	2018-06-14	2018-06-14 00:00:00	2018-06-14	581452		0	0	0		0	0	0	298530	0	33	40213201		
3558	295	1127078	1953-05-25	1953-05-25 00:00:00	1953-06-08	1953-06-08 00:00:00	1953-06-08	38000177		0	0	14		0	0	0	19603	0	282464	1127078		
115083	2528	40213260	2019-03-27	2019-03-27 00:00:00	2019-03-27	2019-03-27 00:00:00	2019-03-27	581452		0	0	0		0	0	0	167092	0	121	40213260		
88206	1935	40213227	2015-02-10	2015-02-10 00:00:00	2015-02-10	2015-02-10 00:00:00	2015-02-10	581452		0	0	0		0	0	0	128750	0	113	40213227		
34947	2886	1127433	1983-11-26	1983-11-26 00:00:00	1983-12-10	1983-12-10 00:00:00	1983-12-10	38000177		0	0	14		0	0	0	191897	0	313782	1127433		
61299	1339	40213260	2016-08-25	2016-08-25 00:00:00	2016-08-25	2016-08-25 00:00:00	2016-08-25	581452		0	0	0		0	0	0	88787	0	121	40213260		
14227	1193	19059056	1955-08-09	1955-08-09 00:00:00	1955-09-13	1955-09-13 00:00:00	1955-09-13	38000177		0	0	35		0	0	0	78619	0	243670	19059056		
165417	3637	40213160	1959-10-27	1959-10-27 00:00:00	1959-10-27	1959-10-27 00:00:00	1959-10-27	581452		0	0	0		0	0	0	241928	0	10	40213160		
24791	2037	19133905	1982-08-01	1982-08-01 00:00:00	1982-08-14	1982-08-14 00:00:00	1982-08-14	38000177		0	0	13		0	0	0	135680	0	834102	19133905		
43100	3572	19073188	2010-01-01	2010-01-01 00:00:00	2010-01-15	2010-01-15 00:00:00	2010-01-15	38000177		0	0	14		0	0	0	237483	0	308192	19073188		
156280	3439	40213227	1994-09-01	1994-09-01 00:00:00	1994-09-01	1994-09-01 00:00:00	1994-09-01	581452		0	0	0		0	0	0	228153	0	113	40213227		
53390	1169	40213227	2017-10-09	2017-10-09 00:00:00	2017-10-09	2017-10-09 00:00:00	2017-10-09	581452		0	0	0		0	0	0	77027	0	113	40213227		
230604	5067	40213314	1978-05-07	1978-05-07 00:00:00	1978-05-07	1978-05-07 00:00:00	1978-05-07	581452		0	0	0		0	0	0	336886	0	49	40213314		
62152	5172	1118084	1980-03-15	1980-03-15 00:00:00	1980-03-15	1980-03-15 00:00:00	\N	38000177		0	0	0		0	0	0	343876	0	00025152531	44923712		
84260	1843	40213306	2003-09-10	2003-09-10 00:00:00	2003-09-10	2003-09-10 00:00:00	2003-09-10	581452		0	0	0		0	0	0	123078	0	43	40213306		
94357	2070	40213160	1965-04-05	1965-04-05 00:00:00	1965-04-05	1965-04-05 00:00:00	1965-04-05	581452		0	0	0		0	0	0	137772	0	10	40213160		
6793	572	1127078	1958-04-19	1958-04-19 00:00:00	1958-05-03	1958-05-03 00:00:00	1958-05-03	38000177		0	0	14		0	0	0	37907	0	282464	1127078		
17277	1432	19129655	1963-10-18	1963-10-18 00:00:00	1963-11-01	1963-11-01 00:00:00	1963-11-01	38000177		0	0	14		0	0	0	95383	0	789980	19129655		
181291	3984	40213296	1996-09-18	1996-09-18 00:00:00	1996-09-18	1996-09-18 00:00:00	1996-09-18	581452		0	0	0		0	0	0	264835	0	52	40213296		
46602	1018	40213227	2004-03-22	2004-03-22 00:00:00	2004-03-22	2004-03-22 00:00:00	2004-03-22	581452		0	0	0		0	0	0	67047	0	113	40213227		
57800	4801	19059056	1991-01-10	1991-01-10 00:00:00	1991-01-24	1991-01-24 00:00:00	1991-01-24	38000177		0	0	14		0	0	0	319422	0	243670	19059056		
52746	4383	1127433	1971-02-06	1971-02-06 00:00:00	1971-02-13	1971-02-13 00:00:00	1971-02-13	38000177		0	0	7		0	0	0	291337	0	313782	1127433		
56905	4722	40231925	1924-02-24	1924-02-24 00:00:00	1924-02-24	1924-02-24 00:00:00	\N	38000177		0	0	0		0	0	0	314540	0	1049221	40231925		
221251	4855	40213160	1977-12-17	1977-12-17 00:00:00	1977-12-17	1977-12-17 00:00:00	1977-12-17	581452		0	0	0		0	0	0	323009	0	10	40213160		
152270	3352	40213296	2006-11-03	2006-11-03 00:00:00	2006-11-03	2006-11-03 00:00:00	2006-11-03	581452		0	0	0		0	0	0	222267	0	52	40213296		
56448	4685	1118084	1971-11-20	1971-11-20 00:00:00	1971-11-20	1971-11-20 00:00:00	\N	38000177		0	0	0		0	0	0	312148	0	00025152531	44923712		
240744	5284	40213160	1966-11-30	1966-11-30 00:00:00	1966-11-30	1966-11-30 00:00:00	1966-11-30	581452		0	0	0		0	0	0	351621	0	10	40213160		
43629	3615	1127433	2006-10-06	2006-10-06 00:00:00	2006-10-27	2006-10-27 00:00:00	2006-10-27	38000177		0	0	21		0	0	0	240219	0	313782	1127433		
18396	399	40213227	2016-11-20	2016-11-20 00:00:00	2016-11-20	2016-11-20 00:00:00	2016-11-20	581452		0	0	0		0	0	0	26221	0	113	40213227		
157659	3470	40213260	2006-03-13	2006-03-13 00:00:00	2006-03-13	2006-03-13 00:00:00	2006-03-13	581452		0	0	0		0	0	0	230344	0	121	40213260		
60585	5039	1539411	2008-12-30	2008-12-30 00:00:00	2008-12-30	2008-12-30 00:00:00	\N	38000177		0	0	0		0	0	0	334908	0	312961	1539411		
51758	1133	40213160	1966-03-18	1966-03-18 00:00:00	1966-03-18	1966-03-18 00:00:00	1966-03-18	581452		0	0	0		0	0	0	74604	0	10	40213160		
8285	691	40165015	2019-06-20	2019-06-20 00:00:00	2019-06-20	2019-06-20 00:00:00	\N	38000177		0	0	0		0	0	0	45788	0	861467	40165015		
97389	2135	40213227	2009-11-02	2009-11-02 00:00:00	2009-11-02	2009-11-02 00:00:00	2009-11-02	581452		0	0	0		0	0	0	142060	0	113	40213227		
22190	482	40213160	1970-07-02	1970-07-02 00:00:00	1970-07-02	1970-07-02 00:00:00	1970-07-02	581452		0	0	0		0	0	0	32235	0	10	40213160		
31751	691	40213227	2009-02-10	2009-02-10 00:00:00	2009-02-10	2009-02-10 00:00:00	2009-02-10	581452		0	0	0		0	0	0	45798	0	113	40213227		
27697	2291	40169216	1964-10-19	1964-10-19 00:00:00	1980-10-09	1980-10-09 00:00:00	1980-10-09	38000177		0	0	5834		0	0	0	152406	0	895994	40169216		
168690	3708	40213296	2019-05-24	2019-05-24 00:00:00	2019-05-24	2019-05-24 00:00:00	2019-05-24	581452		0	0	0		0	0	0	246584	0	52	40213296		
216216	4745	40213227	2007-03-21	2007-03-21 00:00:00	2007-03-21	2007-03-21 00:00:00	2007-03-21	581452		0	0	0		0	0	0	315995	0	113	40213227		
187732	4123	40213160	1962-03-04	1962-03-04 00:00:00	1962-03-04	1962-03-04 00:00:00	1962-03-04	581452		0	0	0		0	0	0	274086	0	10	40213160		
73814	1611	40213160	1956-05-13	1956-05-13 00:00:00	1956-05-13	1956-05-13 00:00:00	1956-05-13	581452		0	0	0		0	0	0	108333	0	10	40213160		
99425	2177	40213260	2017-11-07	2017-11-07 00:00:00	2017-11-07	2017-11-07 00:00:00	2017-11-07	581452		0	0	0		0	0	0	145183	0	121	40213260		
29716	2461	1713671	2013-01-17	2013-01-17 00:00:00	2013-01-24	2013-01-24 00:00:00	2013-01-24	38000177		0	0	7		0	0	0	163184	0	562251	1713671		
40132	3321	1127433	1991-03-17	1991-03-17 00:00:00	1991-03-31	1991-03-31 00:00:00	1991-03-31	38000177		0	0	14		0	0	0	220501	0	313782	1127433		
226756	4979	40213314	1977-04-01	1977-04-01 00:00:00	1977-04-01	1977-04-01 00:00:00	1977-04-01	581452		0	0	0		0	0	0	331295	0	49	40213314		
115445	2537	40213227	2009-06-21	2009-06-21 00:00:00	2009-06-21	2009-06-21 00:00:00	2009-06-21	581452		0	0	0		0	0	0	167688	0	113	40213227		
40352	3343	1127433	1995-11-26	1995-11-26 00:00:00	1995-12-03	1995-12-03 00:00:00	1995-12-03	38000177		0	0	7		0	0	0	221765	0	313782	1127433		
43741	3624	1127078	1958-07-01	1958-07-01 00:00:00	1958-07-29	1958-07-29 00:00:00	1958-07-29	38000177		0	0	28		0	0	0	240941	0	282464	1127078		
203036	4457	40213251	1984-07-17	1984-07-17 00:00:00	1984-07-17	1984-07-17 00:00:00	1984-07-17	581452		0	0	0		0	0	0	296665	0	21	40213251		
57368	4759	19073183	1980-05-29	1980-05-29 00:00:00	1980-06-12	1980-06-12 00:00:00	1980-06-12	38000177		0	0	14		0	0	0	317064	0	308182	19073183		
57419	4763	1118084	1990-04-24	1990-04-24 00:00:00	1990-04-24	1990-04-24 00:00:00	\N	38000177		0	0	0		0	0	0	317457	0	00025152531	44923712		
198727	4366	40213314	1981-08-11	1981-08-11 00:00:00	1981-08-11	1981-08-11 00:00:00	1981-08-11	581452		0	0	0		0	0	0	289709	0	49	40213314		
49138	1076	40213227	2015-05-22	2015-05-22 00:00:00	2015-05-22	2015-05-22 00:00:00	2015-05-22	581452		0	0	0		0	0	0	70518	0	113	40213227		
214537	4704	40213160	1970-11-28	1970-11-28 00:00:00	1970-11-28	1970-11-28 00:00:00	1970-11-28	581452		0	0	0		0	0	0	313384	0	10	40213160		
26317	2165	1127433	1989-09-16	1989-09-16 00:00:00	1989-10-23	1989-10-23 00:00:00	1989-10-23	38000177		0	0	37		0	0	0	144206	0	313782	1127433		
15535	335	40213306	1986-04-01	1986-04-01 00:00:00	1986-04-01	1986-04-01 00:00:00	1986-04-01	581452		0	0	0		0	0	0	22287	0	43	40213306		
36910	3053	1127078	1982-11-05	1982-11-05 00:00:00	1982-11-19	1982-11-19 00:00:00	1982-11-19	38000177		0	0	14		0	0	0	203124	0	282464	1127078		
58631	1283	40213260	2010-03-22	2010-03-22 00:00:00	2010-03-22	2010-03-22 00:00:00	2010-03-22	581452		0	0	0		0	0	0	84806	0	121	40213260		
162184	3567	40213260	2018-07-05	2018-07-05 00:00:00	2018-07-05	2018-07-05 00:00:00	2018-07-05	581452		0	0	0		0	0	0	237006	0	121	40213260		
162227	3568	40213160	1974-05-09	1974-05-09 00:00:00	1974-05-09	1974-05-09 00:00:00	1974-05-09	581452		0	0	0		0	0	0	237091	0	10	40213160		
9050	755	1127433	1979-12-15	1979-12-15 00:00:00	1979-12-22	1979-12-22 00:00:00	1979-12-22	38000177		0	0	7		0	0	0	50063	0	313782	1127433		
70125	1533	40213160	1971-06-08	1971-06-08 00:00:00	1971-06-08	1971-06-08 00:00:00	1971-06-08	581452		0	0	0		0	0	0	102668	0	10	40213160		
211427	4636	40213201	2012-09-18	2012-09-18 00:00:00	2012-09-18	2012-09-18 00:00:00	2012-09-18	581452		0	0	0		0	0	0	308955	0	33	40213201		
9842	209	40213201	2017-05-26	2017-05-26 00:00:00	2017-05-26	2017-05-26 00:00:00	2017-05-26	581452		0	0	0		0	0	0	14255	0	33	40213201		
204300	4484	40213227	2003-02-06	2003-02-06 00:00:00	2003-02-06	2003-02-06 00:00:00	2003-02-06	581452		0	0	0		0	0	0	298526	0	113	40213227		
3559	295	19006318	1953-05-25	1953-05-25 00:00:00	1953-06-08	1953-06-08 00:00:00	1953-06-08	38000177		0	0	14		0	0	0	19603	0	105078	19006318		
115085	2528	40213227	1992-06-10	1992-06-10 00:00:00	1992-06-10	1992-06-10 00:00:00	1992-06-10	581452		0	0	0		0	0	0	167149	0	113	40213227		
88209	1935	40213160	1964-07-14	1964-07-14 00:00:00	1964-07-14	1964-07-14 00:00:00	1964-07-14	581452		0	0	0		0	0	0	128726	0	10	40213160		
34948	2886	19059056	1965-05-26	1965-05-26 00:00:00	1965-06-09	1965-06-09 00:00:00	1965-06-09	38000177		0	0	14		0	0	0	191968	0	243670	19059056		
61306	1339	40213160	1966-12-22	1966-12-22 00:00:00	1966-12-22	1966-12-22 00:00:00	1966-12-22	581452		0	0	0		0	0	0	88776	0	10	40213160		
14228	1193	1713671	2004-04-07	2004-04-07 00:00:00	2004-04-28	2004-04-28 00:00:00	2004-04-28	38000177		0	0	21		0	0	0	78633	0	562251	1713671		
165422	3637	40213160	1959-12-29	1959-12-29 00:00:00	1959-12-29	1959-12-29 00:00:00	1959-12-29	581452		0	0	0		0	0	0	241910	0	10	40213160		
24792	2037	19133905	2002-12-29	2002-12-29 00:00:00	2003-01-08	2003-01-08 00:00:00	2003-01-08	38000177		0	0	10		0	0	0	135638	0	834102	19133905		
43101	3572	19078461	2010-01-01	2010-01-01 00:00:00	2010-01-15	2010-01-15 00:00:00	2010-01-15	38000177		0	0	14		0	0	0	237483	0	310965	19078461		
156282	3439	40213198	2016-12-15	2016-12-15 00:00:00	2016-12-15	2016-12-15 00:00:00	2016-12-15	581452		0	0	0		0	0	0	228165	0	133	40213198		
53400	1169	40213201	2002-07-15	2002-07-15 00:00:00	2002-07-15	2002-07-15 00:00:00	2002-07-15	581452		0	0	0		0	0	0	77019	0	33	40213201		
230608	5068	40213227	2012-12-15	2012-12-15 00:00:00	2012-12-15	2012-12-15 00:00:00	2012-12-15	581452		0	0	0		0	0	0	336976	0	113	40213227		
6641	559	19133905	1992-04-03	1992-04-03 00:00:00	1992-04-16	1992-04-16 00:00:00	1992-04-16	38000177		0	0	13		0	0	0	37055	0	834102	19133905		
84270	1843	40213160	1986-07-30	1986-07-30 00:00:00	1986-07-30	1986-07-30 00:00:00	1986-07-30	581452		0	0	0		0	0	0	123093	0	10	40213160		
94365	2071	40213160	1970-05-27	1970-05-27 00:00:00	1970-05-27	1970-05-27 00:00:00	1970-05-27	581452		0	0	0		0	0	0	137810	0	10	40213160		
6794	572	19006318	1958-04-19	1958-04-19 00:00:00	1958-05-03	1958-05-03 00:00:00	1958-05-03	38000177		0	0	14		0	0	0	37907	0	105078	19006318		
17278	1432	1127433	1983-03-06	1983-03-06 00:00:00	1983-03-20	1983-03-20 00:00:00	1983-03-20	38000177		0	0	14		0	0	0	95370	0	313782	1127433		
140008	3076	40213227	2000-06-07	2000-06-07 00:00:00	2000-06-07	2000-06-07 00:00:00	2000-06-07	581452		0	0	0		0	0	0	204681	0	113	40213227		
46605	1018	40213160	1971-04-19	1971-04-19 00:00:00	1971-04-19	1971-04-19 00:00:00	1971-04-19	581452		0	0	0		0	0	0	67015	0	10	40213160		
57801	4802	19059056	1971-12-05	1971-12-05 00:00:00	1972-03-04	1972-03-04 00:00:00	1972-03-04	38000177		0	0	90		0	0	0	319437	0	243670	19059056		
52747	4383	1127433	2000-03-12	2000-03-12 00:00:00	2000-03-19	2000-03-19 00:00:00	2000-03-19	38000177		0	0	7		0	0	0	291326	0	313782	1127433		
56906	4722	19059056	1914-02-18	1914-02-18 00:00:00	1914-03-11	1914-03-11 00:00:00	1914-03-11	38000177		0	0	21		0	0	0	314551	0	243670	19059056		
221258	4855	40213227	1999-10-02	1999-10-02 00:00:00	1999-10-02	1999-10-02 00:00:00	1999-10-02	581452		0	0	0		0	0	0	323047	0	113	40213227		
152278	3352	40213227	1995-12-15	1995-12-15 00:00:00	1995-12-15	1995-12-15 00:00:00	1995-12-15	581452		0	0	0		0	0	0	222302	0	113	40213227		
56449	4685	19006318	1957-12-10	1957-12-10 00:00:00	1957-12-24	1957-12-24 00:00:00	1957-12-24	38000177		0	0	14		0	0	0	312133	0	105078	19006318		
240749	5285	40213227	1993-12-12	1993-12-12 00:00:00	1993-12-12	1993-12-12 00:00:00	1993-12-12	581452		0	0	0		0	0	0	351694	0	113	40213227		
43630	3616	1713671	1960-12-16	1960-12-16 00:00:00	1961-01-06	1961-01-06 00:00:00	1961-01-06	38000177		0	0	21		0	0	0	240316	0	562251	1713671		
18401	399	40213260	2007-09-30	2007-09-30 00:00:00	2007-09-30	2007-09-30 00:00:00	2007-09-30	581452		0	0	0		0	0	0	26208	0	121	40213260		
157661	3470	40213227	2005-03-07	2005-03-07 00:00:00	2005-03-07	2005-03-07 00:00:00	2005-03-07	581452		0	0	0		0	0	0	230375	0	113	40213227		
60586	5039	19126352	2008-12-30	2008-12-30 00:00:00	2008-12-30	2008-12-30 00:00:00	\N	38000177		0	0	0		0	0	0	334908	0	705129	19126352		
209632	4596	40213227	2010-03-28	2010-03-28 00:00:00	2010-03-28	2010-03-28 00:00:00	2010-03-28	581452		0	0	0		0	0	0	306248	0	113	40213227		
8286	691	19059056	1961-06-21	1961-06-21 00:00:00	1961-07-05	1961-07-05 00:00:00	1961-07-05	38000177		0	0	14		0	0	0	45779	0	243670	19059056		
97396	2135	40213227	1999-02-08	1999-02-08 00:00:00	1999-02-08	1999-02-08 00:00:00	1999-02-08	581452		0	0	0		0	0	0	142125	0	113	40213227		
22192	482	40213160	1974-10-03	1974-10-03 00:00:00	1974-10-03	1974-10-03 00:00:00	1974-10-03	581452		0	0	0		0	0	0	32225	0	10	40213160		
31752	691	40213260	2009-02-10	2009-02-10 00:00:00	2009-02-10	2009-02-10 00:00:00	2009-02-10	581452		0	0	0		0	0	0	45798	0	121	40213260		
27698	2291	1713671	1988-05-12	1988-05-12 00:00:00	1988-05-19	1988-05-19 00:00:00	1988-05-19	38000177		0	0	7		0	0	0	152538	0	562251	1713671		
168693	3708	40213160	1977-08-19	1977-08-19 00:00:00	1977-08-19	1977-08-19 00:00:00	1977-08-19	581452		0	0	0		0	0	0	246545	0	10	40213160		
216218	4745	40213227	2016-10-19	2016-10-19 00:00:00	2016-10-19	2016-10-19 00:00:00	2016-10-19	581452		0	0	0		0	0	0	315980	0	113	40213227		
187738	4123	40213160	1961-12-03	1961-12-03 00:00:00	1961-12-03	1961-12-03 00:00:00	1961-12-03	581452		0	0	0		0	0	0	274152	0	10	40213160		
205312	4505	40213227	2008-03-25	2008-03-25 00:00:00	2008-03-25	2008-03-25 00:00:00	2008-03-25	581452		0	0	0		0	0	0	300128	0	113	40213227		
99427	2177	40213227	2017-11-07	2017-11-07 00:00:00	2017-11-07	2017-11-07 00:00:00	2017-11-07	581452		0	0	0		0	0	0	145183	0	113	40213227		
29717	2462	19133873	1966-10-27	1966-10-27 00:00:00	1966-11-06	1966-11-06 00:00:00	1966-11-06	38000177		0	0	10		0	0	0	163318	0	834061	19133873		
40133	3321	1713671	2018-04-26	2018-04-26 00:00:00	2018-05-17	2018-05-17 00:00:00	2018-05-17	38000177		0	0	21		0	0	0	220504	0	562251	1713671		
226759	4979	40213251	1984-02-17	1984-02-17 00:00:00	1984-02-17	1984-02-17 00:00:00	1984-02-17	581452		0	0	0		0	0	0	331254	0	21	40213251		
115452	2537	40213227	1992-07-05	1992-07-05 00:00:00	1992-07-05	1992-07-05 00:00:00	1992-07-05	581452		0	0	0		0	0	0	167609	0	113	40213227		
40353	3343	1551192	1978-11-25	1978-11-25 00:00:00	1978-11-25	1978-11-25 00:00:00	1978-11-25	38000177		0	0	0		0	0	0	221860	0	312617	1551192		
43742	3624	19006318	1946-12-31	1946-12-31 00:00:00	1947-01-14	1947-01-14 00:00:00	1947-01-14	38000177		0	0	14		0	0	0	240971	0	105078	19006318		
203039	4457	40213227	2014-07-22	2014-07-22 00:00:00	2014-07-22	2014-07-22 00:00:00	2014-07-22	581452		0	0	0		0	0	0	296657	0	113	40213227		
57369	4759	1127078	1980-05-29	1980-05-29 00:00:00	1980-06-12	1980-06-12 00:00:00	1980-06-12	38000177		0	0	14		0	0	0	317064	0	282464	1127078		
57420	4763	1127433	2009-04-23	2009-04-23 00:00:00	2009-05-07	2009-05-07 00:00:00	2009-05-07	38000177		0	0	14		0	0	0	317380	0	313782	1127433		
198732	4366	40213227	2013-04-16	2013-04-16 00:00:00	2013-04-16	2013-04-16 00:00:00	2013-04-16	581452		0	0	0		0	0	0	289608	0	113	40213227		
66279	1450	40213160	1968-04-21	1968-04-21 00:00:00	1968-04-21	1968-04-21 00:00:00	1968-04-21	581452		0	0	0		0	0	0	96733	0	10	40213160		
214540	4704	40213160	1966-08-27	1966-08-27 00:00:00	1966-08-27	1966-08-27 00:00:00	1966-08-27	581452		0	0	0		0	0	0	313367	0	10	40213160		
26318	2165	40229134	1975-01-25	1975-01-25 00:00:00	1975-02-01	1975-02-01 00:00:00	1975-02-01	38000177		0	0	7		0	0	0	144243	0	1043400	40229134		
15537	335	40213260	2014-06-10	2014-06-10 00:00:00	2014-06-10	2014-06-10 00:00:00	2014-06-10	581452		0	0	0		0	0	0	22255	0	121	40213260		
36911	3053	1115171	1997-10-31	1997-10-31 00:00:00	1998-01-29	1998-01-29 00:00:00	1998-01-29	38000177		0	0	90		0	0	0	203107	0	849574	1115171		
58633	1283	40213227	2010-03-22	2010-03-22 00:00:00	2010-03-22	2010-03-22 00:00:00	2010-03-22	581452		0	0	0		0	0	0	84806	0	113	40213227		
162185	3567	40213227	2018-07-05	2018-07-05 00:00:00	2018-07-05	2018-07-05 00:00:00	2018-07-05	581452		0	0	0		0	0	0	237006	0	113	40213227		
162234	3568	40213160	1969-09-04	1969-09-04 00:00:00	1969-09-04	1969-09-04 00:00:00	1969-09-04	581452		0	0	0		0	0	0	237076	0	10	40213160		
9051	755	1115171	2010-12-27	2010-12-27 00:00:00	2011-01-10	2011-01-10 00:00:00	2011-01-10	38000177		0	0	14		0	0	0	50010	0	849574	1115171		
70129	1533	40213227	1993-03-02	1993-03-02 00:00:00	1993-03-02	1993-03-02 00:00:00	1993-03-02	581452		0	0	0		0	0	0	102683	0	113	40213227		
204441	4487	40213227	1999-09-24	1999-09-24 00:00:00	1999-09-24	1999-09-24 00:00:00	1999-09-24	581452		0	0	0		0	0	0	298755	0	113	40213227		
21124	459	40213227	2001-11-12	2001-11-12 00:00:00	2001-11-12	2001-11-12 00:00:00	2001-11-12	581452		0	0	0		0	0	0	30708	0	113	40213227		
7827	655	40236824	1989-02-18	1989-02-18 00:00:00	1989-02-25	1989-02-25 00:00:00	1989-02-25	38000177		0	0	7		0	0	0	43349	0	1094107	40236824		
3560	295	19133905	1975-08-06	1975-08-06 00:00:00	1975-08-18	1975-08-18 00:00:00	1975-08-18	38000177		0	0	12		0	0	0	19631	0	834102	19133905		
126377	2780	40213296	1996-01-24	1996-01-24 00:00:00	1996-01-24	1996-01-24 00:00:00	1996-01-24	581452		0	0	0		0	0	0	184262	0	52	40213296		
88213	1935	40213160	1964-10-13	1964-10-13 00:00:00	1964-10-13	1964-10-13 00:00:00	1964-10-13	581452		0	0	0		0	0	0	128746	0	10	40213160		
34949	2886	1118084	1983-04-22	1983-04-22 00:00:00	1983-04-22	1983-04-22 00:00:00	\N	38000177		0	0	0		0	0	0	191942	0	00025152531	44923712		
58275	1276	40213260	2008-03-14	2008-03-14 00:00:00	2008-03-14	2008-03-14 00:00:00	2008-03-14	581452		0	0	0		0	0	0	84212	0	121	40213260		
14229	1193	19133873	1953-03-12	1953-03-12 00:00:00	1953-03-25	1953-03-25 00:00:00	1953-03-25	38000177		0	0	13		0	0	0	78595	0	834061	19133873		
165430	3637	40213227	1994-05-31	1994-05-31 00:00:00	1994-05-31	1994-05-31 00:00:00	1994-05-31	581452		0	0	0		0	0	0	241917	0	113	40213227		
24793	2037	1118084	2000-05-20	2000-05-20 00:00:00	2000-05-20	2000-05-20 00:00:00	\N	38000177		0	0	0		0	0	0	135634	0	00025152531	44923712		
43102	3572	1118084	1993-08-29	1993-08-29 00:00:00	1993-08-29	1993-08-29 00:00:00	\N	38000177		0	0	0		0	0	0	237509	0	00025152531	44923712		
156290	3440	40213227	1993-03-16	1993-03-16 00:00:00	1993-03-16	1993-03-16 00:00:00	1993-03-16	581452		0	0	0		0	0	0	228287	0	113	40213227		
208042	4563	40213160	1964-05-22	1964-05-22 00:00:00	1964-05-22	1964-05-22 00:00:00	1964-05-22	581452		0	0	0		0	0	0	304110	0	10	40213160		
212865	4668	40213160	1955-09-20	1955-09-20 00:00:00	1955-09-20	1955-09-20 00:00:00	1955-09-20	581452		0	0	0		0	0	0	311094	0	10	40213160		
6663	563	19008572	1985-04-19	1985-04-19 00:00:00	1985-04-19	1985-04-19 00:00:00	\N	38000177		0	0	0		0	0	0	37197	0	106258	19008572		
84272	1843	40213251	1986-07-30	1986-07-30 00:00:00	1986-07-30	1986-07-30 00:00:00	1986-07-30	581452		0	0	0		0	0	0	123093	0	21	40213251		
14459	312	40213296	2012-01-30	2012-01-30 00:00:00	2012-01-30	2012-01-30 00:00:00	2012-01-30	581452		0	0	0		0	0	0	20680	0	52	40213296		
6795	572	1127078	1956-01-22	1956-01-22 00:00:00	1956-02-05	1956-02-05 00:00:00	1956-02-05	38000177		0	0	14		0	0	0	37873	0	282464	1127078		
17279	1432	1127433	2018-09-16	2018-09-16 00:00:00	2018-09-23	2018-09-23 00:00:00	2018-09-23	38000177		0	0	7		0	0	0	95382	0	313782	1127433		
140028	3076	40213198	2014-08-27	2014-08-27 00:00:00	2014-08-27	2014-08-27 00:00:00	2014-08-27	581452		0	0	0		0	0	0	204691	0	133	40213198		
46607	1018	40213227	2012-04-02	2012-04-02 00:00:00	2012-04-02	2012-04-02 00:00:00	2012-04-02	581452		0	0	0		0	0	0	67059	0	113	40213227		
57802	4802	1127433	1968-11-21	1968-11-21 00:00:00	1968-12-05	1968-12-05 00:00:00	1968-12-05	38000177		0	0	14		0	0	0	319423	0	313782	1127433		
52748	4383	19073188	2008-01-22	2008-01-22 00:00:00	2008-02-26	2008-02-26 00:00:00	2008-02-26	38000177		0	0	35		0	0	0	291360	0	308192	19073188		
56907	4722	1127433	1967-02-05	1967-02-05 00:00:00	1967-02-12	1967-02-12 00:00:00	1967-02-12	38000177		0	0	7		0	0	0	314575	0	313782	1127433		
221259	4855	40213306	1999-10-02	1999-10-02 00:00:00	1999-10-02	1999-10-02 00:00:00	1999-10-02	581452		0	0	0		0	0	0	323047	0	43	40213306		
152280	3352	40213227	2015-10-30	2015-10-30 00:00:00	2015-10-30	2015-10-30 00:00:00	2015-10-30	581452		0	0	0		0	0	0	222276	0	113	40213227		
56450	4685	1127433	1957-12-10	1957-12-10 00:00:00	1957-12-24	1957-12-24 00:00:00	1957-12-24	38000177		0	0	14		0	0	0	312133	0	313782	1127433		
177414	3899	40213227	2002-12-28	2002-12-28 00:00:00	2002-12-28	2002-12-28 00:00:00	2002-12-28	581452		0	0	0		0	0	0	259275	0	113	40213227		
43631	3616	1127433	2012-03-15	2012-03-15 00:00:00	2012-03-22	2012-03-22 00:00:00	2012-03-22	38000177		0	0	7		0	0	0	240303	0	313782	1127433		
153375	3376	40213160	1958-03-07	1958-03-07 00:00:00	1958-03-07	1958-03-07 00:00:00	1958-03-07	581452		0	0	0		0	0	0	223987	0	10	40213160		
157669	3470	40213160	1959-02-09	1959-02-09 00:00:00	1959-02-09	1959-02-09 00:00:00	1959-02-09	581452		0	0	0		0	0	0	230357	0	10	40213160		
60587	5039	19075601	2008-12-30	2008-12-30 00:00:00	2008-12-30	2008-12-30 00:00:00	\N	38000177		0	0	0		0	0	0	334908	0	309362	19075601		
209636	4596	40213227	2000-01-30	2000-01-30 00:00:00	2000-01-30	2000-01-30 00:00:00	2000-01-30	581452		0	0	0		0	0	0	306278	0	113	40213227		
8287	691	19006318	1961-06-21	1961-06-21 00:00:00	1961-07-05	1961-07-05 00:00:00	1961-07-05	38000177		0	0	14		0	0	0	45779	0	105078	19006318		
97410	2135	40213160	1955-01-24	1955-01-24 00:00:00	1955-01-24	1955-01-24 00:00:00	1955-01-24	581452		0	0	0		0	0	0	142118	0	10	40213160		
33474	730	40213296	1999-04-24	1999-04-24 00:00:00	1999-04-24	1999-04-24 00:00:00	1999-04-24	581452		0	0	0		0	0	0	48444	0	52	40213296		
122158	2685	40213227	1993-12-02	1993-12-02 00:00:00	1993-12-02	1993-12-02 00:00:00	1993-12-02	581452		0	0	0		0	0	0	177975	0	113	40213227		
27699	2291	19133905	2016-02-21	2016-02-21 00:00:00	2016-03-01	2016-03-01 00:00:00	2016-03-01	38000177		0	0	9		0	0	0	152507	0	834102	19133905		
168694	3708	40213314	1977-08-19	1977-08-19 00:00:00	1977-08-19	1977-08-19 00:00:00	1977-08-19	581452		0	0	0		0	0	0	246545	0	49	40213314		
216221	4745	40213296	2017-04-05	2017-04-05 00:00:00	2017-04-05	2017-04-05 00:00:00	2017-04-05	581452		0	0	0		0	0	0	315899	0	52	40213296		
187743	4123	40213227	1993-11-14	1993-11-14 00:00:00	1993-11-14	1993-11-14 00:00:00	1993-11-14	581452		0	0	0		0	0	0	274135	0	113	40213227		
216591	4753	40213227	2012-06-13	2012-06-13 00:00:00	2012-06-13	2012-06-13 00:00:00	2012-06-13	581452		0	0	0		0	0	0	316488	0	113	40213227		
99431	2177	40213227	2009-10-14	2009-10-14 00:00:00	2009-10-14	2009-10-14 00:00:00	2009-10-14	581452		0	0	0		0	0	0	145232	0	113	40213227		
29718	2462	19059056	1964-09-22	1964-09-22 00:00:00	1964-10-06	1964-10-06 00:00:00	1964-10-06	38000177		0	0	14		0	0	0	163277	0	243670	19059056		
40134	3321	19019979	1982-11-15	1982-11-15 00:00:00	1982-11-29	1982-11-29 00:00:00	1982-11-29	38000177		0	0	14		0	0	0	220500	0	198405	19019979		
226771	4979	40213160	1981-01-30	1981-01-30 00:00:00	1981-01-30	1981-01-30 00:00:00	1981-01-30	581452		0	0	0		0	0	0	331287	0	10	40213160		
126737	2788	40213296	2018-03-25	2018-03-25 00:00:00	2018-03-25	2018-03-25 00:00:00	2018-03-25	581452		0	0	0		0	0	0	184746	0	52	40213296		
40354	3343	19112599	1977-07-13	1977-07-13 00:00:00	1977-07-13	1977-07-13 00:00:00	\N	38000177		0	0	0		0	0	0	221770	0	477045	19112599		
43743	3624	19059056	1946-12-31	1946-12-31 00:00:00	1947-01-14	1947-01-14 00:00:00	1947-01-14	38000177		0	0	14		0	0	0	240971	0	243670	19059056		
203040	4457	40213314	1983-10-18	1983-10-18 00:00:00	1983-10-18	1983-10-18 00:00:00	1983-10-18	581452		0	0	0		0	0	0	296664	0	49	40213314		
57370	4759	19074679	2012-11-06	2012-11-06 00:00:00	2012-11-06	2012-11-06 00:00:00	\N	38000177		0	0	0		0	0	0	317068	0	308971	19074679		
57422	4763	19078461	1983-06-21	1983-06-21 00:00:00	1983-07-21	1983-07-21 00:00:00	1983-07-21	38000177		0	0	30		0	0	0	317455	0	310965	19078461		
198734	4366	40213314	1982-05-11	1982-05-11 00:00:00	1982-05-11	1982-05-11 00:00:00	1982-05-11	581452		0	0	0		0	0	0	289711	0	49	40213314		
66281	1450	40213227	2004-11-28	2004-11-28 00:00:00	2004-11-28	2004-11-28 00:00:00	2004-11-28	581452		0	0	0		0	0	0	96707	0	113	40213227		
214543	4704	40213296	2005-12-24	2005-12-24 00:00:00	2005-12-24	2005-12-24 00:00:00	2005-12-24	581452		0	0	0		0	0	0	313401	0	52	40213296		
26319	2165	19006318	1954-11-28	1954-11-28 00:00:00	1954-12-12	1954-12-12 00:00:00	1954-12-12	38000177		0	0	14		0	0	0	144197	0	105078	19006318		
15539	335	40213260	2013-06-18	2013-06-18 00:00:00	2013-06-18	2013-06-18 00:00:00	2013-06-18	581452		0	0	0		0	0	0	22290	0	121	40213260		
36912	3053	40162522	1997-10-31	1997-10-31 00:00:00	1997-10-31	1997-10-31 00:00:00	\N	38000177		0	0	0		0	0	0	203107	0	857005	40162522		
58643	1283	40213160	1959-08-24	1959-08-24 00:00:00	1959-08-24	1959-08-24 00:00:00	1959-08-24	581452		0	0	0		0	0	0	84831	0	10	40213160		
162188	3567	40213260	2017-06-29	2017-06-29 00:00:00	2017-06-29	2017-06-29 00:00:00	2017-06-29	581452		0	0	0		0	0	0	237034	0	121	40213260		
162236	3568	40213306	1991-07-11	1991-07-11 00:00:00	1991-07-11	1991-07-11 00:00:00	1991-07-11	581452		0	0	0		0	0	0	237122	0	43	40213306		
9052	755	40229134	2004-04-16	2004-04-16 00:00:00	2004-04-30	2004-04-30 00:00:00	2004-04-30	38000177		0	0	14		0	0	0	50068	0	1043400	40229134		
70130	1533	40213306	1993-03-02	1993-03-02 00:00:00	1993-03-02	1993-03-02 00:00:00	1993-03-02	581452		0	0	0		0	0	0	102683	0	43	40213306		
204457	4488	40213314	1977-06-10	1977-06-10 00:00:00	1977-06-10	1977-06-10 00:00:00	1977-06-10	581452		0	0	0		0	0	0	298835	0	49	40213314		
21125	459	40213160	1970-12-07	1970-12-07 00:00:00	1970-12-07	1970-12-07 00:00:00	1970-12-07	581452		0	0	0		0	0	0	30692	0	10	40213160		
7828	655	920300	1989-02-18	1989-02-18 00:00:00	1989-02-25	1989-02-25 00:00:00	1989-02-25	38000177		0	0	7		0	0	0	43349	0	311989	920300		
3561	295	1127433	1980-07-18	1980-07-18 00:00:00	1980-07-25	1980-07-25 00:00:00	1980-07-25	38000177		0	0	7		0	0	0	19592	0	313782	1127433		
126381	2780	40213160	1960-12-28	1960-12-28 00:00:00	1960-12-28	1960-12-28 00:00:00	1960-12-28	581452		0	0	0		0	0	0	184266	0	10	40213160		
88217	1935	40213306	1986-05-20	1986-05-20 00:00:00	1986-05-20	1986-05-20 00:00:00	1986-05-20	581452		0	0	0		0	0	0	128708	0	43	40213306		
34950	2886	40169216	1954-12-17	1954-12-17 00:00:00	1954-12-17	1954-12-17 00:00:00	\N	38000177		0	0	0		0	0	0	191891	0	895994	40169216		
58277	1276	40213227	2008-03-14	2008-03-14 00:00:00	2008-03-14	2008-03-14 00:00:00	2008-03-14	581452		0	0	0		0	0	0	84212	0	113	40213227		
14230	1193	1127433	1998-06-07	1998-06-07 00:00:00	1998-06-21	1998-06-21 00:00:00	1998-06-21	38000177		0	0	14		0	0	0	78632	0	313782	1127433		
165439	3637	40213227	2001-07-31	2001-07-31 00:00:00	2001-07-31	2001-07-31 00:00:00	2001-07-31	581452		0	0	0		0	0	0	241893	0	113	40213227		
24794	2037	19006318	1960-05-15	1960-05-15 00:00:00	1960-05-29	1960-05-29 00:00:00	1960-05-29	38000177		0	0	14		0	0	0	135639	0	105078	19006318		
43103	3572	1127433	2004-01-05	2004-01-05 00:00:00	2004-02-09	2004-02-09 00:00:00	2004-02-09	38000177		0	0	35		0	0	0	237445	0	313782	1127433		
156291	3440	40213227	2003-05-13	2003-05-13 00:00:00	2003-05-13	2003-05-13 00:00:00	2003-05-13	581452		0	0	0		0	0	0	228269	0	113	40213227		
208045	4563	40213160	1964-08-21	1964-08-21 00:00:00	1964-08-21	1964-08-21 00:00:00	1964-08-21	581452		0	0	0		0	0	0	304098	0	10	40213160		
212875	4668	40213227	2016-03-15	2016-03-15 00:00:00	2016-03-15	2016-03-15 00:00:00	2016-03-15	581452		0	0	0		0	0	0	311102	0	113	40213227		
6664	563	1713671	1964-08-16	1964-08-16 00:00:00	1964-08-30	1964-08-30 00:00:00	1964-08-30	38000177		0	0	14		0	0	0	37194	0	562251	1713671		
202627	4448	40213260	2007-05-03	2007-05-03 00:00:00	2007-05-03	2007-05-03 00:00:00	2007-05-03	581452		0	0	0		0	0	0	295866	0	121	40213260		
14464	312	40213160	1972-07-03	1972-07-03 00:00:00	1972-07-03	1972-07-03 00:00:00	1972-07-03	581452		0	0	0		0	0	0	20702	0	10	40213160		
6796	572	19006318	1956-01-22	1956-01-22 00:00:00	1956-02-05	1956-02-05 00:00:00	1956-02-05	38000177		0	0	14		0	0	0	37873	0	105078	19006318		
17280	1432	40229134	1972-06-04	1972-06-04 00:00:00	1972-06-11	1972-06-11 00:00:00	1972-06-11	38000177		0	0	7		0	0	0	95393	0	1043400	40229134		
185275	4071	40213227	2003-10-02	2003-10-02 00:00:00	2003-10-02	2003-10-02 00:00:00	2003-10-02	581452		0	0	0		0	0	0	270652	0	113	40213227		
46608	1018	40213296	2012-04-02	2012-04-02 00:00:00	2012-04-02	2012-04-02 00:00:00	2012-04-02	581452		0	0	0		0	0	0	67059	0	52	40213296		
57803	4802	40229134	2003-05-17	2003-05-17 00:00:00	2003-05-31	2003-05-31 00:00:00	2003-05-31	38000177		0	0	14		0	0	0	319455	0	1043400	40229134		
52749	4383	19078461	2008-01-22	2008-01-22 00:00:00	2008-02-26	2008-02-26 00:00:00	2008-02-26	38000177		0	0	35		0	0	0	291360	0	310965	19078461		
56908	4722	1713671	2011-07-11	2011-07-11 00:00:00	2011-08-01	2011-08-01 00:00:00	2011-08-01	38000177		0	0	21		0	0	0	314491	0	562251	1713671		
221265	4855	40213227	2011-03-26	2011-03-26 00:00:00	2011-03-26	2011-03-26 00:00:00	2011-03-26	581452		0	0	0		0	0	0	323028	0	113	40213227		
152281	3352	40213260	2015-10-30	2015-10-30 00:00:00	2015-10-30	2015-10-30 00:00:00	2015-10-30	581452		0	0	0		0	0	0	222276	0	121	40213260		
56451	4685	19059056	1955-06-08	1955-06-08 00:00:00	1955-07-06	1955-07-06 00:00:00	1955-07-06	38000177		0	0	28		0	0	0	312152	0	243670	19059056		
177415	3899	40213306	2002-12-28	2002-12-28 00:00:00	2002-12-28	2002-12-28 00:00:00	2002-12-28	581452		0	0	0		0	0	0	259275	0	43	40213306		
43632	3616	1124300	1991-09-05	1991-09-05 00:00:00	1991-09-05	1991-09-05 00:00:00	\N	38000177		0	0	0		0	0	0	240261	0	00781178901	45011828		
153381	3376	40213227	1995-11-17	1995-11-17 00:00:00	1995-11-17	1995-11-17 00:00:00	1995-11-17	581452		0	0	0		0	0	0	224021	0	113	40213227		
157675	3470	40213160	1955-02-07	1955-02-07 00:00:00	1955-02-07	1955-02-07 00:00:00	1955-02-07	581452		0	0	0		0	0	0	230307	0	10	40213160		
60588	5039	1127433	2019-02-11	2019-02-11 00:00:00	2019-02-25	2019-02-25 00:00:00	2019-02-25	38000177		0	0	14		0	0	0	334895	0	313782	1127433		
209641	4596	40213227	1992-12-20	1992-12-20 00:00:00	1992-12-20	1992-12-20 00:00:00	1992-12-20	581452		0	0	0		0	0	0	306219	0	113	40213227		
8288	691	40229134	1993-08-17	1993-08-17 00:00:00	1993-08-31	1993-08-31 00:00:00	1993-08-31	38000177		0	0	14		0	0	0	45780	0	1043400	40229134		
112887	2480	40213160	1956-07-11	1956-07-11 00:00:00	1956-07-11	1956-07-11 00:00:00	1956-07-11	581452		0	0	0		0	0	0	164337	0	10	40213160		
33476	730	40213227	1999-04-24	1999-04-24 00:00:00	1999-04-24	1999-04-24 00:00:00	1999-04-24	581452		0	0	0		0	0	0	48444	0	113	40213227		
122165	2685	40213227	2014-05-15	2014-05-15 00:00:00	2014-05-15	2014-05-15 00:00:00	2014-05-15	581452		0	0	0		0	0	0	177934	0	113	40213227		
27700	2292	19078461	2005-02-24	2005-02-24 00:00:00	2005-03-17	2005-03-17 00:00:00	2005-03-17	38000177		0	0	21		0	0	0	152637	0	310965	19078461		
168696	3708	40213251	1984-03-30	1984-03-30 00:00:00	1984-03-30	1984-03-30 00:00:00	1984-03-30	581452		0	0	0		0	0	0	246553	0	21	40213251		
216225	4745	40213160	1975-12-10	1975-12-10 00:00:00	1975-12-10	1975-12-10 00:00:00	1975-12-10	581452		0	0	0		0	0	0	316005	0	10	40213160		
187747	4123	40213160	1966-06-05	1966-06-05 00:00:00	1966-06-05	1966-06-05 00:00:00	1966-06-05	581452		0	0	0		0	0	0	274092	0	10	40213160		
216594	4753	40213227	1992-12-16	1992-12-16 00:00:00	1992-12-16	1992-12-16 00:00:00	1992-12-16	581452		0	0	0		0	0	0	316502	0	113	40213227		
99432	2177	40213296	2009-10-14	2009-10-14 00:00:00	2009-10-14	2009-10-14 00:00:00	2009-10-14	581452		0	0	0		0	0	0	145232	0	52	40213296		
29719	2462	19129655	1964-09-22	1964-09-22 00:00:00	1964-10-06	1964-10-06 00:00:00	1964-10-06	38000177		0	0	14		0	0	0	163277	0	789980	19129655		
40135	3321	1713671	2014-01-31	2014-01-31 00:00:00	2014-02-07	2014-02-07 00:00:00	2014-02-07	38000177		0	0	7		0	0	0	220503	0	562251	1713671		
226773	4979	40213296	2016-07-29	2016-07-29 00:00:00	2016-07-29	2016-07-29 00:00:00	2016-07-29	581452		0	0	0		0	0	0	331267	0	52	40213296		
126739	2788	40213251	1984-03-04	1984-03-04 00:00:00	1984-03-04	1984-03-04 00:00:00	1984-03-04	581452		0	0	0		0	0	0	184727	0	21	40213251		
40355	3343	1127433	2017-04-07	2017-04-07 00:00:00	2017-04-28	2017-04-28 00:00:00	2017-04-28	38000177		0	0	21		0	0	0	221701	0	313782	1127433		
43744	3624	19078461	1984-12-07	1984-12-07 00:00:00	1984-12-28	1984-12-28 00:00:00	1984-12-28	38000177		0	0	21		0	0	0	241011	0	310965	19078461		
203041	4457	40213160	1983-10-18	1983-10-18 00:00:00	1983-10-18	1983-10-18 00:00:00	1983-10-18	581452		0	0	0		0	0	0	296664	0	10	40213160		
57371	4759	19115351	2009-09-01	2009-09-01 00:00:00	2009-11-24	2009-11-24 00:00:00	2009-11-24	38000177		0	0	84		0	0	0	317086	0	563026	19115351		
57423	4763	19059056	1987-03-02	1987-03-02 00:00:00	1987-04-06	1987-04-06 00:00:00	1987-04-06	38000177		0	0	35		0	0	0	317456	0	243670	19059056		
198740	4366	40213227	2004-04-06	2004-04-06 00:00:00	2004-04-06	2004-04-06 00:00:00	2004-04-06	581452		0	0	0		0	0	0	289605	0	113	40213227		
66282	1450	40213296	2004-11-28	2004-11-28 00:00:00	2004-11-28	2004-11-28 00:00:00	2004-11-28	581452		0	0	0		0	0	0	96707	0	52	40213296		
214549	4704	40213227	1997-04-26	1997-04-26 00:00:00	1997-04-26	1997-04-26 00:00:00	1997-04-26	581452		0	0	0		0	0	0	313409	0	113	40213227		
26320	2165	1127078	1954-11-28	1954-11-28 00:00:00	1954-12-12	1954-12-12 00:00:00	1954-12-12	38000177		0	0	14		0	0	0	144197	0	282464	1127078		
15540	335	40213160	1963-09-24	1963-09-24 00:00:00	1963-09-24	1963-09-24 00:00:00	1963-09-24	581452		0	0	0		0	0	0	22283	0	10	40213160		
162823	3580	40213306	1994-10-07	1994-10-07 00:00:00	1994-10-07	1994-10-07 00:00:00	1994-10-07	581452		0	0	0		0	0	0	238019	0	43	40213306		
58646	1283	40213260	2009-03-16	2009-03-16 00:00:00	2009-03-16	2009-03-16 00:00:00	2009-03-16	581452		0	0	0		0	0	0	84777	0	121	40213260		
102212	2240	40213160	1962-03-06	1962-03-06 00:00:00	1962-03-06	1962-03-06 00:00:00	1962-03-06	581452		0	0	0		0	0	0	149125	0	10	40213160		
162237	3568	40213296	2011-06-09	2011-06-09 00:00:00	2011-06-09	2011-06-09 00:00:00	2011-06-09	581452		0	0	0		0	0	0	237086	0	52	40213296		
9053	755	40236824	1995-07-20	1995-07-20 00:00:00	1995-07-27	1995-07-27 00:00:00	1995-07-27	38000177		0	0	7		0	0	0	50064	0	1094107	40236824		
70133	1533	40213160	1975-12-09	1975-12-09 00:00:00	1975-12-09	1975-12-09 00:00:00	1975-12-09	581452		0	0	0		0	0	0	102671	0	10	40213160		
204464	4488	40213160	1976-06-11	1976-06-11 00:00:00	1976-06-11	1976-06-11 00:00:00	1976-06-11	581452		0	0	0		0	0	0	298782	0	10	40213160		
21136	459	40213227	1992-11-02	1992-11-02 00:00:00	1992-11-02	1992-11-02 00:00:00	1992-11-02	581452		0	0	0		0	0	0	30690	0	113	40213227		
7829	655	40220960	2013-03-30	2013-03-30 00:00:00	2013-03-30	2013-03-30 00:00:00	2013-03-30	38000177		0	0	0		0	0	0	43409	0	1804799	40220960		
3562	295	1127433	1984-10-04	1984-10-04 00:00:00	1984-10-18	1984-10-18 00:00:00	1984-10-18	38000177		0	0	14		0	0	0	19593	0	313782	1127433		
126384	2780	40213160	1956-04-25	1956-04-25 00:00:00	1956-04-25	1956-04-25 00:00:00	1956-04-25	581452		0	0	0		0	0	0	184212	0	10	40213160		
35917	2957	1713671	1989-08-13	1989-08-13 00:00:00	1989-08-20	1989-08-20 00:00:00	1989-08-20	38000177		0	0	7		0	0	0	197309	0	562251	1713671		
34951	2886	1154615	1954-12-17	1954-12-17 00:00:00	1954-12-17	1954-12-17 00:00:00	\N	38000177		0	0	0		0	0	0	191891	0	745679	1154615		
58278	1276	40213160	1957-11-15	1957-11-15 00:00:00	1957-11-15	1957-11-15 00:00:00	1957-11-15	581452		0	0	0		0	0	0	84173	0	10	40213160		
14231	1193	19078461	2000-02-11	2000-02-11 00:00:00	2000-03-03	2000-03-03 00:00:00	2000-03-03	38000177		0	0	21		0	0	0	78627	0	310965	19078461		
165440	3637	40213296	2001-07-31	2001-07-31 00:00:00	2001-07-31	2001-07-31 00:00:00	2001-07-31	581452		0	0	0		0	0	0	241893	0	52	40213296		
24795	2037	19059056	1960-05-15	1960-05-15 00:00:00	1960-05-29	1960-05-29 00:00:00	1960-05-29	38000177		0	0	14		0	0	0	135639	0	243670	19059056		
43104	3572	1713671	2005-01-11	2005-01-11 00:00:00	2005-01-18	2005-01-18 00:00:00	2005-01-18	38000177		0	0	7		0	0	0	237481	0	562251	1713671		
220035	4829	40213160	1972-03-17	1972-03-17 00:00:00	1972-03-17	1972-03-17 00:00:00	1972-03-17	581452		0	0	0		0	0	0	321327	0	10	40213160		
208046	4563	40213260	2013-12-13	2013-12-13 00:00:00	2013-12-13	2013-12-13 00:00:00	2013-12-13	581452		0	0	0		0	0	0	304070	0	121	40213260		
212880	4668	40213160	1955-06-21	1955-06-21 00:00:00	1955-06-21	1955-06-21 00:00:00	1955-06-21	581452		0	0	0		0	0	0	311039	0	10	40213160		
118884	2615	40213227	2009-04-26	2009-04-26 00:00:00	2009-04-26	2009-04-26 00:00:00	2009-04-26	581452		0	0	0		0	0	0	172935	0	113	40213227		
213909	4690	40213160	1956-09-15	1956-09-15 00:00:00	1956-09-15	1956-09-15 00:00:00	1956-09-15	581452		0	0	0		0	0	0	312460	0	10	40213160		
14466	312	40213227	1994-03-14	1994-03-14 00:00:00	1994-03-14	1994-03-14 00:00:00	1994-03-14	581452		0	0	0		0	0	0	20688	0	113	40213227		
6797	572	1115171	2001-02-13	2001-02-13 00:00:00	2001-03-20	2001-03-20 00:00:00	2001-03-20	38000177		0	0	35		0	0	0	37861	0	849574	1115171		
17281	1432	19059056	1963-08-19	1963-08-19 00:00:00	1963-09-16	1963-09-16 00:00:00	1963-09-16	38000177		0	0	28		0	0	0	95406	0	243670	19059056		
185287	4072	40213160	1975-05-17	1975-05-17 00:00:00	1975-05-17	1975-05-17 00:00:00	1975-05-17	581452		0	0	0		0	0	0	270700	0	10	40213160		
46616	1018	40213296	2014-04-07	2014-04-07 00:00:00	2014-04-07	2014-04-07 00:00:00	2014-04-07	581452		0	0	0		0	0	0	67065	0	52	40213296		
57804	4802	1127433	2003-12-17	2003-12-17 00:00:00	2004-01-07	2004-01-07 00:00:00	2004-01-07	38000177		0	0	21		0	0	0	319438	0	313782	1127433		
52750	4383	40231925	2008-01-22	2008-01-22 00:00:00	2008-01-22	2008-01-22 00:00:00	\N	38000177		0	0	0		0	0	0	291360	0	1049221	40231925		
56909	4722	19078461	2015-09-29	2015-09-29 00:00:00	2015-10-29	2015-10-29 00:00:00	2015-10-29	38000177		0	0	30		0	0	0	314617	0	310965	19078461		
221268	4855	40213160	1982-08-21	1982-08-21 00:00:00	1982-08-21	1982-08-21 00:00:00	1982-08-21	581452		0	0	0		0	0	0	323024	0	10	40213160		
152286	3352	40213160	1965-07-02	1965-07-02 00:00:00	1965-07-02	1965-07-02 00:00:00	1965-07-02	581452		0	0	0		0	0	0	222298	0	10	40213160		
56452	4685	19133873	1952-01-28	1952-01-28 00:00:00	1952-02-06	1952-02-06 00:00:00	1952-02-06	38000177		0	0	9		0	0	0	312138	0	834061	19133873		
177427	3899	40213306	2003-12-27	2003-12-27 00:00:00	2003-12-27	2003-12-27 00:00:00	2003-12-27	581452		0	0	0		0	0	0	259296	0	43	40213306		
43633	3616	19128065	1974-02-11	1974-02-11 00:00:00	1975-02-06	1975-02-06 00:00:00	1975-02-06	38000177		0	0	360		0	0	0	240304	0	749882	19128065		
153384	3376	40213160	1955-03-04	1955-03-04 00:00:00	1955-03-04	1955-03-04 00:00:00	1955-03-04	581452		0	0	0		0	0	0	223985	0	10	40213160		
157679	3470	40213160	1955-08-08	1955-08-08 00:00:00	1955-08-08	1955-08-08 00:00:00	1955-08-08	581452		0	0	0		0	0	0	230348	0	10	40213160		
60589	5039	1127433	2014-04-13	2014-04-13 00:00:00	2014-04-27	2014-04-27 00:00:00	2014-04-27	38000177		0	0	14		0	0	0	334858	0	313782	1127433		
93214	2046	40213227	2001-01-09	2001-01-09 00:00:00	2001-01-09	2001-01-09 00:00:00	2001-01-09	581452		0	0	0		0	0	0	136127	0	113	40213227		
8289	691	1127433	1958-12-06	1958-12-06 00:00:00	1958-12-20	1958-12-20 00:00:00	1958-12-20	38000177		0	0	14		0	0	0	45775	0	313782	1127433		
112891	2480	40213296	1996-06-19	1996-06-19 00:00:00	1996-06-19	1996-06-19 00:00:00	1996-06-19	581452		0	0	0		0	0	0	164352	0	52	40213296		
33477	730	40213160	1957-09-21	1957-09-21 00:00:00	1957-09-21	1957-09-21 00:00:00	1957-09-21	581452		0	0	0		0	0	0	48484	0	10	40213160		
122171	2685	40213227	2004-03-18	2004-03-18 00:00:00	2004-03-18	2004-03-18 00:00:00	2004-03-18	581452		0	0	0		0	0	0	177979	0	113	40213227		
27701	2292	1124300	2006-06-22	2006-06-22 00:00:00	2006-06-22	2006-06-22 00:00:00	\N	38000177		0	0	0		0	0	0	152624	0	00781178901	45011828		
168700	3708	40213227	2010-03-12	2010-03-12 00:00:00	2010-03-12	2010-03-12 00:00:00	2010-03-12	581452		0	0	0		0	0	0	246536	0	113	40213227		
216228	4745	40213314	1978-03-08	1978-03-08 00:00:00	1978-03-08	1978-03-08 00:00:00	1978-03-08	581452		0	0	0		0	0	0	315914	0	49	40213314		
187748	4123	40213296	2001-11-25	2001-11-25 00:00:00	2001-11-25	2001-11-25 00:00:00	2001-11-25	581452		0	0	0		0	0	0	274108	0	52	40213296		
216602	4753	40213160	1962-02-14	1962-02-14 00:00:00	1962-02-14	1962-02-14 00:00:00	1962-02-14	581452		0	0	0		0	0	0	316510	0	10	40213160		
99434	2177	40213160	1971-04-28	1971-04-28 00:00:00	1971-04-28	1971-04-28 00:00:00	1971-04-28	581452		0	0	0		0	0	0	145198	0	10	40213160		
29720	2462	1127433	2011-10-24	2011-10-24 00:00:00	2011-10-31	2011-10-31 00:00:00	2011-10-31	38000177		0	0	7		0	0	0	163308	0	313782	1127433		
40136	3321	19133873	1977-06-26	1977-06-26 00:00:00	1977-07-03	1977-07-03 00:00:00	1977-07-03	38000177		0	0	7		0	0	0	220524	0	834061	19133873		
226775	4979	40213314	1977-09-30	1977-09-30 00:00:00	1977-09-30	1977-09-30 00:00:00	1977-09-30	581452		0	0	0		0	0	0	331284	0	49	40213314		
126747	2788	40213227	2000-05-21	2000-05-21 00:00:00	2000-05-21	2000-05-21 00:00:00	2000-05-21	581452		0	0	0		0	0	0	184718	0	113	40213227		
40356	3343	1118084	2019-05-17	2019-05-17 00:00:00	2019-05-17	2019-05-17 00:00:00	\N	38000177		0	0	0		0	0	0	221802	0	00025152531	44923712		
43745	3624	1118084	1982-08-14	1982-08-14 00:00:00	1982-08-14	1982-08-14 00:00:00	\N	38000177		0	0	0		0	0	0	240993	0	00025152531	44923712		
203047	4457	40213314	1983-08-16	1983-08-16 00:00:00	1983-08-16	1983-08-16 00:00:00	1983-08-16	581452		0	0	0		0	0	0	296624	0	49	40213314		
57372	4760	1115171	2015-11-04	2015-11-04 00:00:00	2015-12-02	2015-12-02 00:00:00	2015-12-02	38000177		0	0	28		0	0	0	317200	0	849574	1115171		
57424	4763	19133873	1962-12-18	1962-12-18 00:00:00	1962-12-31	1962-12-31 00:00:00	1962-12-31	38000177		0	0	13		0	0	0	317414	0	834061	19133873		
198741	4366	40213306	2004-04-06	2004-04-06 00:00:00	2004-04-06	2004-04-06 00:00:00	2004-04-06	581452		0	0	0		0	0	0	289605	0	43	40213306		
66284	1450	40213160	1963-08-18	1963-08-18 00:00:00	1963-08-18	1963-08-18 00:00:00	1963-08-18	581452		0	0	0		0	0	0	96683	0	10	40213160		
214553	4704	40213160	1966-03-26	1966-03-26 00:00:00	1966-03-26	1966-03-26 00:00:00	1966-03-26	581452		0	0	0		0	0	0	313366	0	10	40213160		
26321	2165	1713671	1970-11-25	1970-11-25 00:00:00	1970-12-16	1970-12-16 00:00:00	1970-12-16	38000177		0	0	21		0	0	0	144226	0	562251	1713671		
15541	335	40213296	2005-11-29	2005-11-29 00:00:00	2005-11-29	2005-11-29 00:00:00	2005-11-29	581452		0	0	0		0	0	0	22258	0	52	40213296		
162826	3580	40213160	1976-10-22	1976-10-22 00:00:00	1976-10-22	1976-10-22 00:00:00	1976-10-22	581452		0	0	0		0	0	0	238031	0	10	40213160		
58648	1283	40213227	1994-01-17	1994-01-17 00:00:00	1994-01-17	1994-01-17 00:00:00	1994-01-17	581452		0	0	0		0	0	0	84816	0	113	40213227		
102213	2240	40213160	1957-12-03	1957-12-03 00:00:00	1957-12-03	1957-12-03 00:00:00	1957-12-03	581452		0	0	0		0	0	0	149097	0	10	40213160		
102280	2242	40213227	1998-08-08	1998-08-08 00:00:00	1998-08-08	1998-08-08 00:00:00	1998-08-08	581452		0	0	0		0	0	0	149278	0	113	40213227		
9054	755	920300	1995-07-20	1995-07-20 00:00:00	1995-07-27	1995-07-27 00:00:00	1995-07-27	38000177		0	0	7		0	0	0	50064	0	311989	920300		
55755	4630	1127433	1995-03-01	1995-03-01 00:00:00	1995-03-15	1995-03-15 00:00:00	1995-03-15	38000177		0	0	14		0	0	0	308483	0	313782	1127433		
204466	4488	40213160	1976-09-10	1976-09-10 00:00:00	1976-09-10	1976-09-10 00:00:00	1976-09-10	581452		0	0	0		0	0	0	298834	0	10	40213160		
21137	459	40213306	1992-11-02	1992-11-02 00:00:00	1992-11-02	1992-11-02 00:00:00	1992-11-02	581452		0	0	0		0	0	0	30690	0	43	40213306		
7830	655	19075601	2013-03-30	2013-03-30 00:00:00	2013-03-30	2013-03-30 00:00:00	2013-03-30	38000177		0	0	0		0	0	0	43409	0	309362	19075601		
3563	295	19133873	1951-12-03	1951-12-03 00:00:00	1951-12-13	1951-12-13 00:00:00	1951-12-13	38000177		0	0	10		0	0	0	19628	0	834061	19133873		
126392	2780	40213296	1998-01-28	1998-01-28 00:00:00	1998-01-28	1998-01-28 00:00:00	1998-01-28	581452		0	0	0		0	0	0	184250	0	52	40213296		
35918	2957	19133873	1958-02-20	1958-02-20 00:00:00	1958-03-01	1958-03-01 00:00:00	1958-03-01	38000177		0	0	9		0	0	0	197341	0	834061	19133873		
34952	2886	19006318	1953-02-15	1953-02-15 00:00:00	1953-03-01	1953-03-01 00:00:00	1953-03-01	38000177		0	0	14		0	0	0	191975	0	105078	19006318		
58281	1276	40213296	1997-03-14	1997-03-14 00:00:00	1997-03-14	1997-03-14 00:00:00	1997-03-14	581452		0	0	0		0	0	0	84160	0	52	40213296		
14232	1193	1127433	1976-01-29	1976-01-29 00:00:00	1976-02-28	1976-02-28 00:00:00	1976-02-28	38000177		0	0	30		0	0	0	78624	0	313782	1127433		
165443	3637	40213160	1964-06-30	1964-06-30 00:00:00	1964-06-30	1964-06-30 00:00:00	1964-06-30	581452		0	0	0		0	0	0	241912	0	10	40213160		
24796	2037	1713671	1995-10-23	1995-10-23 00:00:00	1995-11-13	1995-11-13 00:00:00	1995-11-13	38000177		0	0	21		0	0	0	135626	0	562251	1713671		
43105	3572	19059056	1959-02-23	1959-02-23 00:00:00	1959-03-09	1959-03-09 00:00:00	1959-03-09	38000177		0	0	14		0	0	0	237465	0	243670	19059056		
220043	4829	40213160	1972-08-18	1972-08-18 00:00:00	1972-08-18	1972-08-18 00:00:00	1972-08-18	581452		0	0	0		0	0	0	321336	0	10	40213160		
208050	4563	40213296	2003-12-19	2003-12-19 00:00:00	2003-12-19	2003-12-19 00:00:00	2003-12-19	581452		0	0	0		0	0	0	304068	0	52	40213296		
34257	2830	1118084	2007-12-22	2007-12-22 00:00:00	2007-12-22	2007-12-22 00:00:00	\N	38000177		0	0	0		0	0	0	187768	0	00025152531	44923712		
118890	2615	40213198	2013-05-19	2013-05-19 00:00:00	2013-05-19	2013-05-19 00:00:00	2013-05-19	581452		0	0	0		0	0	0	172937	0	133	40213198		
213911	4690	40213260	2006-11-04	2006-11-04 00:00:00	2006-11-04	2006-11-04 00:00:00	2006-11-04	581452		0	0	0		0	0	0	312479	0	121	40213260		
14468	312	40213306	1994-03-14	1994-03-14 00:00:00	1994-03-14	1994-03-14 00:00:00	1994-03-14	581452		0	0	0		0	0	0	20688	0	43	40213306		
6798	572	1127433	1961-10-12	1961-10-12 00:00:00	1961-10-26	1961-10-26 00:00:00	1961-10-26	38000177		0	0	14		0	0	0	37848	0	313782	1127433		
17282	1432	19078461	2005-04-06	2005-04-06 00:00:00	2005-04-27	2005-04-27 00:00:00	2005-04-27	38000177		0	0	21		0	0	0	95408	0	310965	19078461		
185294	4072	40213306	1996-11-09	1996-11-09 00:00:00	1996-11-09	1996-11-09 00:00:00	1996-11-09	581452		0	0	0		0	0	0	270716	0	43	40213306		
46617	1018	40213160	1975-12-22	1975-12-22 00:00:00	1975-12-22	1975-12-22 00:00:00	1975-12-22	581452		0	0	0		0	0	0	67029	0	10	40213160		
57805	4802	1118084	2005-06-20	2005-06-20 00:00:00	2005-06-20	2005-06-20 00:00:00	\N	38000177		0	0	0		0	0	0	319480	0	00025152531	44923712		
52751	4383	1118084	2008-06-24	2008-06-24 00:00:00	2008-06-24	2008-06-24 00:00:00	\N	38000177		0	0	0		0	0	0	291292	0	00025152531	44923712		
141817	3115	40213227	2018-01-26	2018-01-26 00:00:00	2018-01-26	2018-01-26 00:00:00	2018-01-26	581452		0	0	0		0	0	0	207236	0	113	40213227		
221279	4855	40213160	1978-05-20	1978-05-20 00:00:00	1978-05-20	1978-05-20 00:00:00	1978-05-20	581452		0	0	0		0	0	0	323000	0	10	40213160		
181757	3993	40213227	1998-08-10	1998-08-10 00:00:00	1998-08-10	1998-08-10 00:00:00	1998-08-10	581452		0	0	0		0	0	0	265516	0	113	40213227		
56453	4685	19078461	1975-01-22	1975-01-22 00:00:00	1975-04-22	1975-04-22 00:00:00	1975-04-22	38000177		0	0	90		0	0	0	312153	0	310965	19078461		
177433	3899	40213314	1981-03-07	1981-03-07 00:00:00	1981-03-07	1981-03-07 00:00:00	1981-03-07	581452		0	0	0		0	0	0	259283	0	49	40213314		
43634	3616	1127433	2019-06-01	2019-06-01 00:00:00	2019-06-15	2019-06-15 00:00:00	2019-06-15	38000177		0	0	14		0	0	0	240294	0	313782	1127433		
153387	3376	40213160	1955-09-02	1955-09-02 00:00:00	1955-09-02	1955-09-02 00:00:00	1955-09-02	581452		0	0	0		0	0	0	223948	0	10	40213160		
205649	4513	40213227	2012-12-26	2012-12-26 00:00:00	2012-12-26	2012-12-26 00:00:00	2012-12-26	581452		0	0	0		0	0	0	300575	0	113	40213227		
60590	5039	19129655	1977-01-19	1977-01-19 00:00:00	1977-02-02	1977-02-02 00:00:00	1977-02-02	38000177		0	0	14		0	0	0	334884	0	789980	19129655		
93221	2046	40213227	1992-11-24	1992-11-24 00:00:00	1992-11-24	1992-11-24 00:00:00	1992-11-24	581452		0	0	0		0	0	0	136137	0	113	40213227		
8290	691	19133905	1999-05-24	1999-05-24 00:00:00	1999-06-01	1999-06-01 00:00:00	1999-06-01	38000177		0	0	8		0	0	0	45777	0	834102	19133905		
112898	2480	40213160	1956-04-11	1956-04-11 00:00:00	1956-04-11	1956-04-11 00:00:00	1956-04-11	581452		0	0	0		0	0	0	164307	0	10	40213160		
203726	4472	40213227	1997-02-08	1997-02-08 00:00:00	1997-02-08	1997-02-08 00:00:00	1997-02-08	581452		0	0	0		0	0	0	297552	0	113	40213227		
122195	2685	40213198	2010-04-22	2010-04-22 00:00:00	2010-04-22	2010-04-22 00:00:00	2010-04-22	581452		0	0	0		0	0	0	177905	0	133	40213198		
27702	2292	1127433	1965-09-07	1965-09-07 00:00:00	1965-09-21	1965-09-21 00:00:00	1965-09-21	38000177		0	0	14		0	0	0	152611	0	313782	1127433		
168701	3708	40213314	1978-07-21	1978-07-21 00:00:00	1978-07-21	1978-07-21 00:00:00	1978-07-21	581452		0	0	0		0	0	0	246516	0	49	40213314		
3383	74	40213160	1972-04-12	1972-04-12 00:00:00	1972-04-12	1972-04-12 00:00:00	1972-04-12	581452		0	0	0		0	0	0	4972	0	10	40213160		
187752	4123	40213306	1983-08-28	1983-08-28 00:00:00	1983-08-28	1983-08-28 00:00:00	1983-08-28	581452		0	0	0		0	0	0	274105	0	43	40213306		
216605	4753	40213306	1985-02-27	1985-02-27 00:00:00	1985-02-27	1985-02-27 00:00:00	1985-02-27	581452		0	0	0		0	0	0	316506	0	43	40213306		
99438	2177	40213296	2007-10-10	2007-10-10 00:00:00	2007-10-10	2007-10-10 00:00:00	2007-10-10	581452		0	0	0		0	0	0	145181	0	52	40213296		
29721	2462	1713671	2009-08-17	2009-08-17 00:00:00	2009-09-07	2009-09-07 00:00:00	2009-09-07	38000177		0	0	21		0	0	0	163332	0	562251	1713671		
40137	3321	19073188	2014-04-10	2014-04-10 00:00:00	2014-04-24	2014-04-24 00:00:00	2014-04-24	38000177		0	0	14		0	0	0	220527	0	308192	19073188		
160259	3527	40213227	1992-08-13	1992-08-13 00:00:00	1992-08-13	1992-08-13 00:00:00	1992-08-13	581452		0	0	0		0	0	0	234125	0	113	40213227		
126748	2788	40213306	2000-05-21	2000-05-21 00:00:00	2000-05-21	2000-05-21 00:00:00	2000-05-21	581452		0	0	0		0	0	0	184718	0	43	40213306		
40357	3343	1551192	1993-04-11	1993-04-11 00:00:00	1993-04-11	1993-04-11 00:00:00	1993-04-11	38000177		0	0	0		0	0	0	221717	0	312617	1551192		
43746	3624	1115171	2011-06-01	2011-06-01 00:00:00	2011-06-22	2011-06-22 00:00:00	2011-06-22	38000177		0	0	21		0	0	0	241013	0	849574	1115171		
203048	4457	40213160	1983-08-16	1983-08-16 00:00:00	1983-08-16	1983-08-16 00:00:00	1983-08-16	581452		0	0	0		0	0	0	296624	0	10	40213160		
57373	4760	19073188	2015-11-04	2015-11-04 00:00:00	2015-12-02	2015-12-02 00:00:00	2015-12-02	38000177		0	0	28		0	0	0	317200	0	308192	19073188		
57425	4763	1127433	2003-08-15	2003-08-15 00:00:00	2003-08-22	2003-08-22 00:00:00	2003-08-22	38000177		0	0	7		0	0	0	317418	0	313782	1127433		
240132	5272	40213201	1983-03-16	1983-03-16 00:00:00	1983-03-16	1983-03-16 00:00:00	1983-03-16	581452		0	0	0		0	0	0	350598	0	33	40213201		
66289	1450	40213260	2013-12-22	2013-12-22 00:00:00	2013-12-22	2013-12-22 00:00:00	2013-12-22	581452		0	0	0		0	0	0	96752	0	121	40213260		
214557	4704	40213227	2007-12-29	2007-12-29 00:00:00	2007-12-29	2007-12-29 00:00:00	2007-12-29	581452		0	0	0		0	0	0	313397	0	113	40213227		
26322	2165	19006318	1959-07-17	1959-07-17 00:00:00	1959-07-31	1959-07-31 00:00:00	1959-07-31	38000177		0	0	14		0	0	0	144228	0	105078	19006318		
15543	335	40213227	2005-11-29	2005-11-29 00:00:00	2005-11-29	2005-11-29 00:00:00	2005-11-29	581452		0	0	0		0	0	0	22258	0	113	40213227		
162828	3580	40213227	1994-04-29	1994-04-29 00:00:00	1994-04-29	1994-04-29 00:00:00	1994-04-29	581452		0	0	0		0	0	0	237979	0	113	40213227		
58653	1283	40213296	1999-03-22	1999-03-22 00:00:00	1999-03-22	1999-03-22 00:00:00	1999-03-22	581452		0	0	0		0	0	0	84818	0	52	40213296		
102216	2240	40213160	1957-09-03	1957-09-03 00:00:00	1957-09-03	1957-09-03 00:00:00	1957-09-03	581452		0	0	0		0	0	0	149106	0	10	40213160		
136175	2989	40213160	1959-06-03	1959-06-03 00:00:00	1959-06-03	1959-06-03 00:00:00	1959-06-03	581452		0	0	0		0	0	0	199512	0	10	40213160		
9055	755	19133905	1975-06-02	1975-06-02 00:00:00	1975-06-10	1975-06-10 00:00:00	1975-06-10	38000177		0	0	8		0	0	0	50045	0	834102	19133905		
55756	4630	1127433	2002-11-14	2002-11-14 00:00:00	2002-11-21	2002-11-21 00:00:00	2002-11-21	38000177		0	0	7		0	0	0	308476	0	313782	1127433		
204467	4488	40213314	1977-03-11	1977-03-11 00:00:00	1977-03-11	1977-03-11 00:00:00	1977-03-11	581452		0	0	0		0	0	0	298783	0	49	40213314		
21141	459	40213296	2010-09-06	2010-09-06 00:00:00	2010-09-06	2010-09-06 00:00:00	2010-09-06	581452		0	0	0		0	0	0	30703	0	52	40213296		
7831	655	1127433	1975-05-24	1975-05-24 00:00:00	1975-05-31	1975-05-31 00:00:00	1975-05-31	38000177		0	0	7		0	0	0	43347	0	313782	1127433		
3582	297	1713671	2014-01-08	2014-01-08 00:00:00	2014-01-15	2014-01-15 00:00:00	2014-01-15	38000177		0	0	7		0	0	0	19797	0	562251	1713671		
126394	2780	40213227	1998-01-28	1998-01-28 00:00:00	1998-01-28	1998-01-28 00:00:00	1998-01-28	581452		0	0	0		0	0	0	184250	0	113	40213227		
35921	2957	40229134	2007-01-10	2007-01-10 00:00:00	2007-01-24	2007-01-24 00:00:00	2007-01-24	38000177		0	0	14		0	0	0	197357	0	1043400	40229134		
34953	2886	19059056	1953-02-15	1953-02-15 00:00:00	1953-03-01	1953-03-01 00:00:00	1953-03-01	38000177		0	0	14		0	0	0	191975	0	243670	19059056		
58287	1276	40213160	1957-06-14	1957-06-14 00:00:00	1957-06-14	1957-06-14 00:00:00	1957-06-14	581452		0	0	0		0	0	0	84199	0	10	40213160		
14233	1193	40165015	1976-01-29	1976-01-29 00:00:00	1976-01-29	1976-01-29 00:00:00	\N	38000177		0	0	0		0	0	0	78624	0	861467	40165015		
165453	3637	40213160	1960-03-29	1960-03-29 00:00:00	1960-03-29	1960-03-29 00:00:00	1960-03-29	581452		0	0	0		0	0	0	241929	0	10	40213160		
24821	2041	19006318	1964-04-25	1964-04-25 00:00:00	1964-05-09	1964-05-09 00:00:00	1964-05-09	38000177		0	0	14		0	0	0	135843	0	105078	19006318		
43106	3572	1713671	1958-01-15	1958-01-15 00:00:00	1958-01-22	1958-01-22 00:00:00	1958-01-22	38000177		0	0	7		0	0	0	237461	0	562251	1713671		
220044	4829	40213160	1972-05-19	1972-05-19 00:00:00	1972-05-19	1972-05-19 00:00:00	1972-05-19	581452		0	0	0		0	0	0	321348	0	10	40213160		
208052	4563	40213306	1986-08-22	1986-08-22 00:00:00	1986-08-22	1986-08-22 00:00:00	1986-08-22	581452		0	0	0		0	0	0	304083	0	43	40213306		
34267	2832	19073188	1988-10-11	1988-10-11 00:00:00	1988-10-25	1988-10-25 00:00:00	1988-10-25	38000177		0	0	14		0	0	0	188001	0	308192	19073188		
118894	2615	40213160	1955-11-06	1955-11-06 00:00:00	1955-11-06	1955-11-06 00:00:00	1955-11-06	581452		0	0	0		0	0	0	172861	0	10	40213160		
213921	4690	40213260	2007-11-10	2007-11-10 00:00:00	2007-11-10	2007-11-10 00:00:00	2007-11-10	581452		0	0	0		0	0	0	312514	0	121	40213260		
14471	312	40213160	1972-05-01	1972-05-01 00:00:00	1972-05-01	1972-05-01 00:00:00	1972-05-01	581452		0	0	0		0	0	0	20663	0	10	40213160		
6799	572	1127078	1959-03-02	1959-03-02 00:00:00	1959-03-16	1959-03-16 00:00:00	1959-03-16	38000177		0	0	14		0	0	0	37919	0	282464	1127078		
17283	1432	1127433	2012-08-29	2012-08-29 00:00:00	2012-09-05	2012-09-05 00:00:00	2012-09-05	38000177		0	0	7		0	0	0	95412	0	313782	1127433		
185295	4072	40213314	1977-02-12	1977-02-12 00:00:00	1977-02-12	1977-02-12 00:00:00	1977-02-12	581452		0	0	0		0	0	0	270681	0	49	40213314		
200894	4411	40213227	2006-08-07	2006-08-07 00:00:00	2006-08-07	2006-08-07 00:00:00	2006-08-07	581452		0	0	0		0	0	0	293254	0	113	40213227		
57806	4802	40229134	1970-03-23	1970-03-23 00:00:00	1970-03-30	1970-03-30 00:00:00	1970-03-30	38000177		0	0	7		0	0	0	319459	0	1043400	40229134		
52752	4383	40229134	1976-03-30	1976-03-30 00:00:00	1976-04-06	1976-04-06 00:00:00	1976-04-06	38000177		0	0	7		0	0	0	291324	0	1043400	40229134		
141818	3115	40213260	2018-01-26	2018-01-26 00:00:00	2018-01-26	2018-01-26 00:00:00	2018-01-26	581452		0	0	0		0	0	0	207236	0	121	40213260		
221280	4855	40213314	1978-02-18	1978-02-18 00:00:00	1978-02-18	1978-02-18 00:00:00	1978-02-18	581452		0	0	0		0	0	0	323033	0	49	40213314		
181777	3993	40213201	2003-09-08	2003-09-08 00:00:00	2003-09-08	2003-09-08 00:00:00	2003-09-08	581452		0	0	0		0	0	0	265439	0	33	40213201		
56454	4685	40231925	1975-01-22	1975-01-22 00:00:00	1975-01-22	1975-01-22 00:00:00	\N	38000177		0	0	0		0	0	0	312153	0	1049221	40231925		
177440	3899	40213314	1980-04-05	1980-04-05 00:00:00	1980-04-05	1980-04-05 00:00:00	1980-04-05	581452		0	0	0		0	0	0	259269	0	49	40213314		
43635	3616	19078461	1975-11-23	1975-11-23 00:00:00	1976-02-21	1976-02-21 00:00:00	1976-02-21	38000177		0	0	90		0	0	0	240291	0	310965	19078461		
153392	3376	40213198	2018-06-22	2018-06-22 00:00:00	2018-06-22	2018-06-22 00:00:00	2018-06-22	581452		0	0	0		0	0	0	223937	0	133	40213198		
205650	4513	40213260	2012-12-26	2012-12-26 00:00:00	2012-12-26	2012-12-26 00:00:00	2012-12-26	581452		0	0	0		0	0	0	300575	0	121	40213260		
4203	349	1713671	2012-09-11	2012-09-11 00:00:00	2012-10-02	2012-10-02 00:00:00	2012-10-02	38000177		0	0	21		0	0	0	23201	0	562251	1713671		
110711	2433	40213227	1995-01-22	1995-01-22 00:00:00	1995-01-22	1995-01-22 00:00:00	1995-01-22	581452		0	0	0		0	0	0	161295	0	113	40213227		
8291	691	1127433	1997-04-25	1997-04-25 00:00:00	1997-05-09	1997-05-09 00:00:00	1997-05-09	38000177		0	0	14		0	0	0	45784	0	313782	1127433		
112907	2480	40213227	2006-11-08	2006-11-08 00:00:00	2006-11-08	2006-11-08 00:00:00	2006-11-08	581452		0	0	0		0	0	0	164293	0	113	40213227		
203738	4473	40213227	2005-05-01	2005-05-01 00:00:00	2005-05-01	2005-05-01 00:00:00	2005-05-01	581452		0	0	0		0	0	0	297623	0	113	40213227		
151672	3337	40213160	1970-02-16	1970-02-16 00:00:00	1970-02-16	1970-02-16 00:00:00	1970-02-16	581452		0	0	0		0	0	0	221365	0	10	40213160		
27703	2292	1713671	1986-01-10	1986-01-10 00:00:00	1986-01-17	1986-01-17 00:00:00	1986-01-17	38000177		0	0	7		0	0	0	152566	0	562251	1713671		
168704	3708	40213227	1998-07-10	1998-07-10 00:00:00	1998-07-10	1998-07-10 00:00:00	1998-07-10	581452		0	0	0		0	0	0	\N	0	113	40213227		
93569	2053	40213227	1994-12-29	1994-12-29 00:00:00	1994-12-29	1994-12-29 00:00:00	1994-12-29	581452		0	0	0		0	0	0	136484	0	113	40213227		
19797	1627	40236824	1971-07-04	1971-07-04 00:00:00	1971-07-11	1971-07-11 00:00:00	1971-07-11	38000177		0	0	7		0	0	0	109353	0	1094107	40236824		
216610	4754	40213160	1965-06-29	1965-06-29 00:00:00	1965-06-29	1965-06-29 00:00:00	1965-06-29	581452		0	0	0		0	0	0	316593	0	10	40213160		
99439	2177	40213306	1989-08-09	1989-08-09 00:00:00	1989-08-09	1989-08-09 00:00:00	1989-08-09	581452		0	0	0		0	0	0	145225	0	43	40213306		
29722	2462	1124300	2002-02-10	2002-02-10 00:00:00	2002-02-10	2002-02-10 00:00:00	\N	38000177		0	0	0		0	0	0	163239	0	00781178901	45011828		
40138	3321	1115171	2014-04-10	2014-04-10 00:00:00	2014-04-24	2014-04-24 00:00:00	2014-04-24	38000177		0	0	14		0	0	0	220527	0	849574	1115171		
160261	3527	40213260	2012-07-19	2012-07-19 00:00:00	2012-07-19	2012-07-19 00:00:00	2012-07-19	581452		0	0	0		0	0	0	234070	0	121	40213260		
126750	2788	40213314	1979-05-27	1979-05-27 00:00:00	1979-05-27	1979-05-27 00:00:00	1979-05-27	581452		0	0	0		0	0	0	184710	0	49	40213314		
40358	3343	1551192	1977-07-01	1977-07-01 00:00:00	1977-07-01	1977-07-01 00:00:00	1977-07-01	38000177		0	0	0		0	0	0	221859	0	312617	1551192		
43747	3624	1115171	2008-05-26	2008-05-26 00:00:00	2008-06-16	2008-06-16 00:00:00	2008-06-16	38000177		0	0	21		0	0	0	241012	0	849574	1115171		
179952	3956	40213227	1996-03-10	1996-03-10 00:00:00	1996-03-10	1996-03-10 00:00:00	1996-03-10	581452		0	0	0		0	0	0	262923	0	113	40213227		
57374	4760	1713671	1955-08-29	1955-08-29 00:00:00	1955-09-12	1955-09-12 00:00:00	1955-09-12	38000177		0	0	14		0	0	0	317201	0	562251	1713671		
57426	4763	1713671	1960-07-03	1960-07-03 00:00:00	1960-07-17	1960-07-17 00:00:00	1960-07-17	38000177		0	0	14		0	0	0	317375	0	562251	1713671		
51014	4239	19059056	1951-09-10	1951-09-10 00:00:00	1951-10-08	1951-10-08 00:00:00	1951-10-08	38000177		0	0	28		0	0	0	281501	0	243670	19059056		
66297	1450	40213306	1985-05-26	1985-05-26 00:00:00	1985-05-26	1985-05-26 00:00:00	1985-05-26	581452		0	0	0		0	0	0	96703	0	43	40213306		
214558	4704	40213296	2007-12-29	2007-12-29 00:00:00	2007-12-29	2007-12-29 00:00:00	2007-12-29	581452		0	0	0		0	0	0	313397	0	52	40213296		
26323	2165	1127078	1959-07-17	1959-07-17 00:00:00	1959-07-31	1959-07-31 00:00:00	1959-07-31	38000177		0	0	14		0	0	0	144228	0	282464	1127078		
15546	335	40213227	2015-06-16	2015-06-16 00:00:00	2015-06-16	2015-06-16 00:00:00	2015-06-16	581452		0	0	0		0	0	0	22260	0	113	40213227		
162829	3580	40213306	1994-04-29	1994-04-29 00:00:00	1994-04-29	1994-04-29 00:00:00	1994-04-29	581452		0	0	0		0	0	0	237979	0	43	40213306		
58665	1283	40213306	1981-11-09	1981-11-09 00:00:00	1981-11-09	1981-11-09 00:00:00	1981-11-09	581452		0	0	0		0	0	0	84844	0	43	40213306		
102225	2240	40213160	1957-07-02	1957-07-02 00:00:00	1957-07-02	1957-07-02 00:00:00	1957-07-02	581452		0	0	0		0	0	0	149096	0	10	40213160		
136177	2989	40213227	2015-08-26	2015-08-26 00:00:00	2015-08-26	2015-08-26 00:00:00	2015-08-26	581452		0	0	0		0	0	0	199572	0	113	40213227		
9056	755	19078461	1981-07-02	1981-07-02 00:00:00	1981-08-01	1981-08-01 00:00:00	1981-08-01	38000177		0	0	30		0	0	0	50009	0	310965	19078461		
55757	4630	19059056	1966-10-10	1966-10-10 00:00:00	1966-10-31	1966-10-31 00:00:00	1966-10-31	38000177		0	0	21		0	0	0	308520	0	243670	19059056		
204470	4488	40213160	1976-04-09	1976-04-09 00:00:00	1976-04-09	1976-04-09 00:00:00	1976-04-09	581452		0	0	0		0	0	0	298833	0	10	40213160		
21147	459	40213160	1975-08-11	1975-08-11 00:00:00	1975-08-11	1975-08-11 00:00:00	1975-08-11	581452		0	0	0		0	0	0	30725	0	10	40213160		
7832	655	1118084	2003-06-19	2003-06-19 00:00:00	2003-06-19	2003-06-19 00:00:00	\N	38000177		0	0	0		0	0	0	43375	0	00025152531	44923712		
3583	297	1127433	1953-01-09	1953-01-09 00:00:00	1953-01-23	1953-01-23 00:00:00	1953-01-23	38000177		0	0	14		0	0	0	19786	0	313782	1127433		
126399	2780	40213260	2006-01-18	2006-01-18 00:00:00	2006-01-18	2006-01-18 00:00:00	2006-01-18	581452		0	0	0		0	0	0	184241	0	121	40213260		
35922	2957	40173590	2008-02-02	2008-02-02 00:00:00	2008-02-02	2008-02-02 00:00:00	\N	38000177		0	0	0		0	0	0	197327	0	904419	40173590		
34954	2886	1127433	1956-12-10	1956-12-10 00:00:00	1956-12-24	1956-12-24 00:00:00	1956-12-24	38000177		0	0	14		0	0	0	191958	0	313782	1127433		
58297	1276	40213296	1998-02-13	1998-02-13 00:00:00	1998-02-13	1998-02-13 00:00:00	1998-02-13	581452		0	0	0		0	0	0	84210	0	52	40213296		
14234	1193	1118084	1987-03-15	1987-03-15 00:00:00	1987-03-15	1987-03-15 00:00:00	\N	38000177		0	0	0		0	0	0	78643	0	00025152531	44923712		
165455	3637	40213306	1982-06-01	1982-06-01 00:00:00	1982-06-01	1982-06-01 00:00:00	1982-06-01	581452		0	0	0		0	0	0	241890	0	43	40213306		
24822	2041	19059056	1964-04-25	1964-04-25 00:00:00	1964-05-09	1964-05-09 00:00:00	1964-05-09	38000177		0	0	14		0	0	0	135843	0	243670	19059056		
43107	3572	1127433	1975-01-11	1975-01-11 00:00:00	1975-02-01	1975-02-01 00:00:00	1975-02-01	38000177		0	0	21		0	0	0	237442	0	313782	1127433		
220046	4829	40213296	2012-10-19	2012-10-19 00:00:00	2012-10-19	2012-10-19 00:00:00	2012-10-19	581452		0	0	0		0	0	0	321344	0	52	40213296		
61935	1353	40213227	2016-05-02	2016-05-02 00:00:00	2016-05-02	2016-05-02 00:00:00	2016-05-02	581452		0	0	0		0	0	0	89649	0	113	40213227		
34268	2832	1127433	1988-10-11	1988-10-11 00:00:00	1988-10-25	1988-10-25 00:00:00	1988-10-25	38000177		0	0	14		0	0	0	188001	0	313782	1127433		
19208	418	40213160	1957-12-30	1957-12-30 00:00:00	1957-12-30	1957-12-30 00:00:00	1957-12-30	581452		0	0	0		0	0	0	27644	0	10	40213160		
213923	4690	40213227	2007-11-10	2007-11-10 00:00:00	2007-11-10	2007-11-10 00:00:00	2007-11-10	581452		0	0	0		0	0	0	312514	0	113	40213227		
14483	312	40213160	1976-12-20	1976-12-20 00:00:00	1976-12-20	1976-12-20 00:00:00	1976-12-20	581452		0	0	0		0	0	0	20684	0	10	40213160		
6800	572	19006318	1959-03-02	1959-03-02 00:00:00	1959-03-16	1959-03-16 00:00:00	1959-03-16	38000177		0	0	14		0	0	0	37919	0	105078	19006318		
17284	1432	1118084	2005-01-30	2005-01-30 00:00:00	2005-01-30	2005-01-30 00:00:00	\N	38000177		0	0	0		0	0	0	95356	0	00025152531	44923712		
185298	4072	40213227	2007-02-03	2007-02-03 00:00:00	2007-02-03	2007-02-03 00:00:00	2007-02-03	581452		0	0	0		0	0	0	270708	0	113	40213227		
200904	4412	40213160	1964-01-10	1964-01-10 00:00:00	1964-01-10	1964-01-10 00:00:00	1964-01-10	581452		0	0	0		0	0	0	293318	0	10	40213160		
57810	4804	1127433	2006-09-16	2006-09-16 00:00:00	2006-09-23	2006-09-23 00:00:00	2006-09-23	38000177		0	0	7		0	0	0	319603	0	313782	1127433		
52753	4383	1127433	1992-07-18	1992-07-18 00:00:00	1992-08-22	1992-08-22 00:00:00	1992-08-22	38000177		0	0	35		0	0	0	291358	0	313782	1127433		
141821	3115	40213160	1967-06-30	1967-06-30 00:00:00	1967-06-30	1967-06-30 00:00:00	1967-06-30	581452		0	0	0		0	0	0	207215	0	10	40213160		
221281	4855	40213160	1978-02-18	1978-02-18 00:00:00	1978-02-18	1978-02-18 00:00:00	1978-02-18	581452		0	0	0		0	0	0	323033	0	10	40213160		
181781	3993	40213227	2008-10-06	2008-10-06 00:00:00	2008-10-06	2008-10-06 00:00:00	2008-10-06	581452		0	0	0		0	0	0	265528	0	113	40213227		
56455	4685	19133873	1944-08-21	1944-08-21 00:00:00	1944-09-03	1944-09-03 00:00:00	1944-09-03	38000177		0	0	13		0	0	0	312154	0	834061	19133873		
177441	3899	40213160	1980-04-05	1980-04-05 00:00:00	1980-04-05	1980-04-05 00:00:00	1980-04-05	581452		0	0	0		0	0	0	259269	0	10	40213160		
43636	3616	19006318	1960-05-15	1960-05-15 00:00:00	1960-05-29	1960-05-29 00:00:00	1960-05-29	38000177		0	0	14		0	0	0	240263	0	105078	19006318		
164687	3622	40213227	2014-04-02	2014-04-02 00:00:00	2014-04-02	2014-04-02 00:00:00	2014-04-02	581452		0	0	0		0	0	0	240766	0	113	40213227		
205655	4513	40213227	1993-06-16	1993-06-16 00:00:00	1993-06-16	1993-06-16 00:00:00	1993-06-16	581452		0	0	0		0	0	0	300560	0	113	40213227		
4204	349	1127433	1994-01-21	1994-01-21 00:00:00	1994-02-04	1994-02-04 00:00:00	1994-02-04	38000177		0	0	14		0	0	0	23207	0	313782	1127433		
110713	2433	40213296	1996-02-11	1996-02-11 00:00:00	1996-02-11	1996-02-11 00:00:00	1996-02-11	581452		0	0	0		0	0	0	\N	0	52	40213296		
8292	691	19059056	1971-07-20	1971-07-20 00:00:00	1971-08-03	1971-08-03 00:00:00	1971-08-03	38000177		0	0	14		0	0	0	45786	0	243670	19059056		
112908	2480	40213260	2006-11-08	2006-11-08 00:00:00	2006-11-08	2006-11-08 00:00:00	2006-11-08	581452		0	0	0		0	0	0	164293	0	121	40213260		
203743	4473	40213160	1971-10-31	1971-10-31 00:00:00	1971-10-31	1971-10-31 00:00:00	1971-10-31	581452		0	0	0		0	0	0	297568	0	10	40213160		
195366	4291	40213160	1974-08-02	1974-08-02 00:00:00	1974-08-02	1974-08-02 00:00:00	1974-08-02	581452		0	0	0		0	0	0	284885	0	10	40213160		
27704	2292	19078461	1979-02-24	1979-02-24 00:00:00	1979-03-24	1979-03-24 00:00:00	1979-03-24	38000177		0	0	28		0	0	0	152595	0	310965	19078461		
168705	3708	40213306	1998-07-10	1998-07-10 00:00:00	1998-07-10	1998-07-10 00:00:00	1998-07-10	581452		0	0	0		0	0	0	\N	0	43	40213306		
93571	2053	40213296	1997-08-14	1997-08-14 00:00:00	1997-08-14	1997-08-14 00:00:00	1997-08-14	581452		0	0	0		0	0	0	136567	0	52	40213296		
19798	1627	920300	1971-07-04	1971-07-04 00:00:00	1971-07-11	1971-07-11 00:00:00	1971-07-11	38000177		0	0	7		0	0	0	109353	0	311989	920300		
216615	4754	40213227	2015-10-27	2015-10-27 00:00:00	2015-10-27	2015-10-27 00:00:00	2015-10-27	581452		0	0	0		0	0	0	316635	0	113	40213227		
99441	2177	40213160	1967-01-31	1967-01-31 00:00:00	1967-01-31	1967-01-31 00:00:00	1967-01-31	581452		0	0	0		0	0	0	145217	0	10	40213160		
29723	2462	1127433	2008-06-11	2008-06-11 00:00:00	2008-06-18	2008-06-18 00:00:00	2008-06-18	38000177		0	0	7		0	0	0	163276	0	313782	1127433		
40170	3325	19133905	2007-10-29	2007-10-29 00:00:00	2007-11-08	2007-11-08 00:00:00	2007-11-08	38000177		0	0	10		0	0	0	220715	0	834102	19133905		
160263	3527	40213227	2012-07-19	2012-07-19 00:00:00	2012-07-19	2012-07-19 00:00:00	2012-07-19	581452		0	0	0		0	0	0	234070	0	113	40213227		
126756	2788	40213160	1983-02-27	1983-02-27 00:00:00	1983-02-27	1983-02-27 00:00:00	1983-02-27	581452		0	0	0		0	0	0	184713	0	10	40213160		
40359	3343	19078461	2016-03-08	2016-03-08 00:00:00	2016-04-12	2016-04-12 00:00:00	2016-04-12	38000177		0	0	35		0	0	0	221700	0	310965	19078461		
43748	3624	19059056	1963-11-30	1963-11-30 00:00:00	1963-12-14	1963-12-14 00:00:00	1963-12-14	38000177		0	0	14		0	0	0	240942	0	243670	19059056		
179984	3956	40213227	2006-05-07	2006-05-07 00:00:00	2006-05-07	2006-05-07 00:00:00	2006-05-07	581452		0	0	0		0	0	0	262959	0	113	40213227		
57375	4760	1127433	1969-05-18	1969-05-18 00:00:00	1969-07-17	1969-07-17 00:00:00	1969-07-17	38000177		0	0	60		0	0	0	317197	0	313782	1127433		
57427	4763	19059056	1951-06-18	1951-06-18 00:00:00	1951-07-09	1951-07-09 00:00:00	1951-07-09	38000177		0	0	21		0	0	0	317453	0	243670	19059056		
51015	4239	40236824	1980-10-22	1980-10-22 00:00:00	1980-10-29	1980-10-29 00:00:00	1980-10-29	38000177		0	0	7		0	0	0	281476	0	1094107	40236824		
66302	1450	40213227	1995-01-08	1995-01-08 00:00:00	1995-01-08	1995-01-08 00:00:00	1995-01-08	581452		0	0	0		0	0	0	96705	0	113	40213227		
214562	4705	40213160	1972-11-23	1972-11-23 00:00:00	1972-11-23	1972-11-23 00:00:00	1972-11-23	581452		0	0	0		0	0	0	313473	0	10	40213160		
26324	2165	1127433	1968-11-24	1968-11-24 00:00:00	1968-12-01	1968-12-01 00:00:00	1968-12-01	38000177		0	0	7		0	0	0	144220	0	313782	1127433		
15549	335	40213296	2003-11-25	2003-11-25 00:00:00	2003-11-25	2003-11-25 00:00:00	2003-11-25	581452		0	0	0		0	0	0	22288	0	52	40213296		
162831	3580	40213227	2014-03-21	2014-03-21 00:00:00	2014-03-21	2014-03-21 00:00:00	2014-03-21	581452		0	0	0		0	0	0	238022	0	113	40213227		
17731	1468	1539411	1991-07-10	1991-07-10 00:00:00	1991-07-10	1991-07-10 00:00:00	\N	38000177		0	0	0		0	0	0	97843	0	312961	1539411		
136120	2988	40213306	1984-11-25	1984-11-25 00:00:00	1984-11-25	1984-11-25 00:00:00	1984-11-25	581452		0	0	0		0	0	0	199452	0	43	40213306		
136184	2989	40213160	1955-08-31	1955-08-31 00:00:00	1955-08-31	1955-08-31 00:00:00	1955-08-31	581452		0	0	0		0	0	0	199510	0	10	40213160		
9057	755	19078461	2016-01-28	2016-01-28 00:00:00	2016-03-28	2016-03-28 00:00:00	2016-03-28	38000177		0	0	60		0	0	0	50012	0	310965	19078461		
55758	4630	1127078	1964-11-05	1964-11-05 00:00:00	1964-11-19	1964-11-19 00:00:00	1964-11-19	38000177		0	0	14		0	0	0	308518	0	282464	1127078		
204471	4488	40213296	2016-12-09	2016-12-09 00:00:00	2016-12-09	2016-12-09 00:00:00	2016-12-09	581452		0	0	0		0	0	0	298829	0	52	40213296		
148745	3270	40213306	1992-05-28	1992-05-28 00:00:00	1992-05-28	1992-05-28 00:00:00	1992-05-28	581452		0	0	0		0	0	0	217346	0	43	40213306		
7833	655	40229134	1979-04-10	1979-04-10 00:00:00	1979-04-17	1979-04-17 00:00:00	1979-04-17	38000177		0	0	7		0	0	0	43348	0	1043400	40229134		
3584	297	19133905	1970-10-27	1970-10-27 00:00:00	1970-11-07	1970-11-07 00:00:00	1970-11-07	38000177		0	0	11		0	0	0	19778	0	834102	19133905		
126402	2780	40213227	2017-04-12	2017-04-12 00:00:00	2017-04-12	2017-04-12 00:00:00	2017-04-12	581452		0	0	0		0	0	0	184253	0	113	40213227		
35923	2957	1713671	1953-08-15	1953-08-15 00:00:00	1953-08-29	1953-08-29 00:00:00	1953-08-29	38000177		0	0	14		0	0	0	197351	0	562251	1713671		
34955	2886	19006318	1952-08-02	1952-08-02 00:00:00	1952-08-16	1952-08-16 00:00:00	1952-08-16	38000177		0	0	14		0	0	0	191990	0	105078	19006318		
58300	1276	40213160	1957-08-16	1957-08-16 00:00:00	1957-08-16	1957-08-16 00:00:00	1957-08-16	581452		0	0	0		0	0	0	84270	0	10	40213160		
14235	1193	1127433	1968-01-20	1968-01-20 00:00:00	1968-02-03	1968-02-03 00:00:00	1968-02-03	38000177		0	0	14		0	0	0	78597	0	313782	1127433		
77082	1685	40213160	1980-09-14	1980-09-14 00:00:00	1980-09-14	1980-09-14 00:00:00	1980-09-14	581452		0	0	0		0	0	0	\N	0	10	40213160		
57113	1250	40213160	1955-02-28	1955-02-28 00:00:00	1955-02-28	1955-02-28 00:00:00	1955-02-28	581452		0	0	0		0	0	0	82380	0	10	40213160		
43108	3572	19059056	1969-10-02	1969-10-02 00:00:00	1969-10-16	1969-10-16 00:00:00	1969-10-16	38000177		0	0	14		0	0	0	237451	0	243670	19059056		
220048	4829	40213227	2003-11-14	2003-11-14 00:00:00	2003-11-14	2003-11-14 00:00:00	2003-11-14	581452		0	0	0		0	0	0	321308	0	113	40213227		
61937	1353	40213160	1955-08-08	1955-08-08 00:00:00	1955-08-08	1955-08-08 00:00:00	1955-08-08	581452		0	0	0		0	0	0	89671	0	10	40213160		
34269	2832	1107882	1994-03-05	1994-03-05 00:00:00	1994-03-05	1994-03-05 00:00:00	\N	38000177		0	0	0		0	0	0	187897	0	311372	1107882		
19212	418	40213160	1958-06-02	1958-06-02 00:00:00	1958-06-02	1958-06-02 00:00:00	1958-06-02	581452		0	0	0		0	0	0	27638	0	10	40213160		
213925	4690	40213227	2017-10-07	2017-10-07 00:00:00	2017-10-07	2017-10-07 00:00:00	2017-10-07	581452		0	0	0		0	0	0	312484	0	113	40213227		
14485	312	40213227	2014-02-03	2014-02-03 00:00:00	2014-02-03	2014-02-03 00:00:00	2014-02-03	581452		0	0	0		0	0	0	20669	0	113	40213227		
6801	572	1115171	2003-11-05	2003-11-05 00:00:00	2003-11-26	2003-11-26 00:00:00	2003-11-26	38000177		0	0	21		0	0	0	37862	0	849574	1115171		
17285	1433	1127433	1978-11-11	1978-11-11 00:00:00	1978-11-18	1978-11-18 00:00:00	1978-11-18	38000177		0	0	7		0	0	0	95427	0	313782	1127433		
185302	4072	40213314	1977-08-13	1977-08-13 00:00:00	1977-08-13	1977-08-13 00:00:00	1977-08-13	581452		0	0	0		0	0	0	270674	0	49	40213314		
200907	4412	40213260	2014-06-13	2014-06-13 00:00:00	2014-06-13	2014-06-13 00:00:00	2014-06-13	581452		0	0	0		0	0	0	293293	0	121	40213260		
57811	4804	1150771	1978-01-28	1978-01-28 00:00:00	1978-01-28	1978-01-28 00:00:00	\N	38000177		0	0	0		0	0	0	319658	0	197378	1150771		
52754	4383	19133873	1981-07-27	1981-07-27 00:00:00	1981-08-03	1981-08-03 00:00:00	1981-08-03	38000177		0	0	7		0	0	0	291339	0	834061	19133873		
141828	3115	40213160	1967-04-28	1967-04-28 00:00:00	1967-04-28	1967-04-28 00:00:00	1967-04-28	581452		0	0	0		0	0	0	207243	0	10	40213160		
221285	4855	40213251	1984-09-01	1984-09-01 00:00:00	1984-09-01	1984-09-01 00:00:00	1984-09-01	581452		0	0	0		0	0	0	323039	0	21	40213251		
151551	3334	40213227	1996-10-31	1996-10-31 00:00:00	1996-10-31	1996-10-31 00:00:00	1996-10-31	581452		0	0	0		0	0	0	221223	0	113	40213227		
56456	4685	40220960	1992-05-25	1992-05-25 00:00:00	1992-05-25	1992-05-25 00:00:00	1992-05-25	38000177		0	0	0		0	0	0	312117	0	1804799	40220960		
177444	3899	40213314	1980-06-07	1980-06-07 00:00:00	1980-06-07	1980-06-07 00:00:00	1980-06-07	581452		0	0	0		0	0	0	259282	0	49	40213314		
43637	3616	19059056	1960-05-15	1960-05-15 00:00:00	1960-05-29	1960-05-29 00:00:00	1960-05-29	38000177		0	0	14		0	0	0	240263	0	243670	19059056		
29911	652	40213260	2019-01-15	2019-01-15 00:00:00	2019-01-15	2019-01-15 00:00:00	2019-01-15	581452		0	0	0		0	0	0	43136	0	121	40213260		
205663	4513	40213160	1962-08-29	1962-08-29 00:00:00	1962-08-29	1962-08-29 00:00:00	1962-08-29	581452		0	0	0		0	0	0	300543	0	10	40213160		
4205	349	40173590	2018-04-28	2018-04-28 00:00:00	2018-04-28	2018-04-28 00:00:00	\N	38000177		0	0	0		0	0	0	23211	0	904419	40173590		
110716	2433	40213160	1955-12-18	1955-12-18 00:00:00	1955-12-18	1955-12-18 00:00:00	1955-12-18	581452		0	0	0		0	0	0	161317	0	10	40213160		
8293	691	1713671	2004-04-24	2004-04-24 00:00:00	2004-05-15	2004-05-15 00:00:00	2004-05-15	38000177		0	0	21		0	0	0	45747	0	562251	1713671		
112922	2480	40213227	1996-11-06	1996-11-06 00:00:00	1996-11-06	1996-11-06 00:00:00	1996-11-06	581452		0	0	0		0	0	0	\N	0	113	40213227		
18832	1556	19078461	1990-02-19	1990-02-19 00:00:00	1990-03-05	1990-03-05 00:00:00	1990-03-05	38000177		0	0	14		0	0	0	104149	0	310965	19078461		
195370	4291	40213160	1978-11-03	1978-11-03 00:00:00	1978-11-03	1978-11-03 00:00:00	1978-11-03	581452		0	0	0		0	0	0	284900	0	10	40213160		
27705	2292	1127433	1986-08-14	1986-08-14 00:00:00	1986-09-13	1986-09-13 00:00:00	1986-09-13	38000177		0	0	30		0	0	0	152634	0	313782	1127433		
168707	3708	40213306	1998-07-17	1998-07-17 00:00:00	1998-07-17	1998-07-17 00:00:00	1998-07-17	581452		0	0	0		0	0	0	\N	0	43	40213306		
93573	2053	40213160	1958-01-30	1958-01-30 00:00:00	1958-01-30	1958-01-30 00:00:00	1958-01-30	581452		0	0	0		0	0	0	136539	0	10	40213160		
19799	1627	1127433	1995-10-05	1995-10-05 00:00:00	1995-10-12	1995-10-12 00:00:00	1995-10-12	38000177		0	0	7		0	0	0	109337	0	313782	1127433		
216616	4754	40213260	2015-10-27	2015-10-27 00:00:00	2015-10-27	2015-10-27 00:00:00	2015-10-27	581452		0	0	0		0	0	0	316635	0	121	40213260		
99443	2177	40213160	1967-04-04	1967-04-04 00:00:00	1967-04-04	1967-04-04 00:00:00	1967-04-04	581452		0	0	0		0	0	0	145207	0	10	40213160		
29724	2462	1115171	2018-08-15	2018-08-15 00:00:00	2018-09-12	2018-09-12 00:00:00	2018-09-12	38000177		0	0	28		0	0	0	163201	0	849574	1115171		
40171	3325	19129655	1966-01-16	1966-01-16 00:00:00	1966-01-30	1966-01-30 00:00:00	1966-01-30	38000177		0	0	14		0	0	0	220726	0	789980	19129655		
160268	3527	40213296	2003-07-24	2003-07-24 00:00:00	2003-07-24	2003-07-24 00:00:00	2003-07-24	581452		0	0	0		0	0	0	234128	0	52	40213296		
75802	1656	40213160	1978-08-05	1978-08-05 00:00:00	1978-08-05	1978-08-05 00:00:00	1978-08-05	581452		0	0	0		0	0	0	111112	0	10	40213160		
51271	4260	1118084	1979-11-11	1979-11-11 00:00:00	1979-11-11	1979-11-11 00:00:00	\N	38000177		0	0	0		0	0	0	282777	0	00025152531	44923712		
43749	3624	40229134	1957-03-10	1957-03-10 00:00:00	1957-03-17	1957-03-17 00:00:00	1957-03-17	38000177		0	0	7		0	0	0	240991	0	1043400	40229134		
171740	3776	40213160	1978-05-13	1978-05-13 00:00:00	1978-05-13	1978-05-13 00:00:00	1978-05-13	581452		0	0	0		0	0	0	250997	0	10	40213160		
57376	4760	19133905	1979-07-08	1979-07-08 00:00:00	1979-07-19	1979-07-19 00:00:00	1979-07-19	38000177		0	0	11		0	0	0	317144	0	834102	19133905		
57428	4763	19006318	1955-09-09	1955-09-09 00:00:00	1955-09-23	1955-09-23 00:00:00	1955-09-23	38000177		0	0	14		0	0	0	317382	0	105078	19006318		
51016	4239	920300	1980-10-22	1980-10-22 00:00:00	1980-10-29	1980-10-29 00:00:00	1980-10-29	38000177		0	0	7		0	0	0	281476	0	311989	920300		
66306	1450	40213160	1964-01-19	1964-01-19 00:00:00	1964-01-19	1964-01-19 00:00:00	1964-01-19	581452		0	0	0		0	0	0	96684	0	10	40213160		
214565	4705	40213227	2014-06-26	2014-06-26 00:00:00	2014-06-26	2014-06-26 00:00:00	2014-06-26	581452		0	0	0		0	0	0	313465	0	113	40213227		
26325	2166	1118084	2000-12-24	2000-12-24 00:00:00	2000-12-24	2000-12-24 00:00:00	\N	38000177		0	0	0		0	0	0	144340	0	00025152531	44923712		
15550	335	40213160	1963-11-26	1963-11-26 00:00:00	1963-11-26	1963-11-26 00:00:00	1963-11-26	581452		0	0	0		0	0	0	22274	0	10	40213160		
162832	3580	40213296	2014-03-21	2014-03-21 00:00:00	2014-03-21	2014-03-21 00:00:00	2014-03-21	581452		0	0	0		0	0	0	238022	0	52	40213296		
17732	1468	1118084	1992-03-26	1992-03-26 00:00:00	1992-03-26	1992-03-26 00:00:00	\N	38000177		0	0	0		0	0	0	97843	0	00025152531	44923712		
136123	2988	40213160	1963-02-17	1963-02-17 00:00:00	1963-02-17	1963-02-17 00:00:00	1963-02-17	581452		0	0	0		0	0	0	199497	0	10	40213160		
206050	4522	40213160	1976-09-17	1976-09-17 00:00:00	1976-09-17	1976-09-17 00:00:00	1976-09-17	581452		0	0	0		0	0	0	301120	0	10	40213160		
9058	755	1118084	1991-08-08	1991-08-08 00:00:00	1991-08-08	1991-08-08 00:00:00	\N	38000177		0	0	0		0	0	0	50077	0	00025152531	44923712		
55759	4630	19059056	1965-09-15	1965-09-15 00:00:00	1965-11-14	1965-11-14 00:00:00	1965-11-14	38000177		0	0	60		0	0	0	308519	0	243670	19059056		
121435	2669	40213227	1998-12-16	1998-12-16 00:00:00	1998-12-16	1998-12-16 00:00:00	1998-12-16	581452		0	0	0		0	0	0	176773	0	113	40213227		
35439	774	40213227	2000-05-01	2000-05-01 00:00:00	2000-05-01	2000-05-01 00:00:00	2000-05-01	581452		0	0	0		0	0	0	51344	0	113	40213227		
7834	655	1127433	2000-04-29	2000-04-29 00:00:00	2000-05-13	2000-05-13 00:00:00	2000-05-13	38000177		0	0	14		0	0	0	43423	0	313782	1127433		
34230	747	40213306	1986-04-05	1986-04-05 00:00:00	1986-04-05	1986-04-05 00:00:00	1986-04-05	581452		0	0	0		0	0	0	49499	0	43	40213306		
125469	2760	40213160	1957-09-05	1957-09-05 00:00:00	1957-09-05	1957-09-05 00:00:00	1957-09-05	581452		0	0	0		0	0	0	182566	0	10	40213160		
35925	2957	1127433	1954-02-15	1954-02-15 00:00:00	1954-03-01	1954-03-01 00:00:00	1954-03-01	38000177		0	0	14		0	0	0	197305	0	313782	1127433		
34956	2886	1127078	1952-08-02	1952-08-02 00:00:00	1952-08-16	1952-08-16 00:00:00	1952-08-16	38000177		0	0	14		0	0	0	191990	0	282464	1127078		
58304	1276	40213160	1962-02-16	1962-02-16 00:00:00	1962-02-16	1962-02-16 00:00:00	1962-02-16	581452		0	0	0		0	0	0	84243	0	10	40213160		
14236	1193	1127433	1980-12-03	1980-12-03 00:00:00	1980-12-17	1980-12-17 00:00:00	1980-12-17	38000177		0	0	14		0	0	0	78625	0	313782	1127433		
77087	1685	40213314	1981-03-22	1981-03-22 00:00:00	1981-03-22	1981-03-22 00:00:00	1981-03-22	581452		0	0	0		0	0	0	112886	0	49	40213314		
57117	1250	40213160	1958-03-03	1958-03-03 00:00:00	1958-03-03	1958-03-03 00:00:00	1958-03-03	581452		0	0	0		0	0	0	82381	0	10	40213160		
43109	3572	46233710	1969-10-02	1969-10-02 00:00:00	1969-10-16	1969-10-16 00:00:00	1969-10-16	38000177		0	0	14		0	0	0	237451	0	1650142	46233710		
222210	4878	40213227	1996-08-31	1996-08-31 00:00:00	1996-08-31	1996-08-31 00:00:00	1996-08-31	581452		0	0	0		0	0	0	324374	0	113	40213227		
61938	1353	40213227	2006-03-06	2006-03-06 00:00:00	2006-03-06	2006-03-06 00:00:00	2006-03-06	581452		0	0	0		0	0	0	89693	0	113	40213227		
34270	2832	1594382	1994-03-05	1994-03-05 00:00:00	1994-03-05	1994-03-05 00:00:00	\N	38000177		0	0	0		0	0	0	187897	0	1870230	1594382		
19217	418	40213227	2019-04-29	2019-04-29 00:00:00	2019-04-29	2019-04-29 00:00:00	2019-04-29	581452		0	0	0		0	0	0	27631	0	113	40213227		
213926	4690	40213160	1961-05-20	1961-05-20 00:00:00	1961-05-20	1961-05-20 00:00:00	1961-05-20	581452		0	0	0		0	0	0	312532	0	10	40213160		
14486	312	40213296	2014-02-03	2014-02-03 00:00:00	2014-02-03	2014-02-03 00:00:00	2014-02-03	581452		0	0	0		0	0	0	20669	0	52	40213296		
6802	572	1713671	2007-04-06	2007-04-06 00:00:00	2007-04-13	2007-04-13 00:00:00	2007-04-13	38000177		0	0	7		0	0	0	37876	0	562251	1713671		
17286	1433	1127433	2004-01-09	2004-01-09 00:00:00	2004-01-16	2004-01-16 00:00:00	2004-01-16	38000177		0	0	7		0	0	0	95469	0	313782	1127433		
242957	5334	40213260	2015-02-25	2015-02-25 00:00:00	2015-02-25	2015-02-25 00:00:00	2015-02-25	581452		0	0	0		0	0	0	355190	0	121	40213260		
200908	4412	40213296	2003-08-08	2003-08-08 00:00:00	2003-08-08	2003-08-08 00:00:00	2003-08-08	581452		0	0	0		0	0	0	293291	0	52	40213296		
57812	4804	40169216	1997-03-23	1997-03-23 00:00:00	1997-03-23	1997-03-23 00:00:00	\N	38000177		0	0	0		0	0	0	319587	0	895994	40169216		
52755	4384	46233988	1968-02-11	1968-02-11 00:00:00	1968-02-25	1968-02-25 00:00:00	1968-02-25	38000177		0	0	14		0	0	0	291407	0	1652673	46233988		
141829	3115	40213306	1987-03-27	1987-03-27 00:00:00	1987-03-27	1987-03-27 00:00:00	1987-03-27	581452		0	0	0		0	0	0	207221	0	43	40213306		
196768	4324	40213160	1962-02-18	1962-02-18 00:00:00	1962-02-18	1962-02-18 00:00:00	1962-02-18	581452		0	0	0		0	0	0	286854	0	10	40213160		
151560	3334	40213201	2012-01-26	2012-01-26 00:00:00	2012-01-26	2012-01-26 00:00:00	2012-01-26	581452		0	0	0		0	0	0	221210	0	33	40213201		
56457	4685	1127433	1967-05-12	1967-05-12 00:00:00	1967-05-19	1967-05-19 00:00:00	1967-05-19	38000177		0	0	7		0	0	0	312106	0	313782	1127433		
177445	3899	40213160	1980-06-07	1980-06-07 00:00:00	1980-06-07	1980-06-07 00:00:00	1980-06-07	581452		0	0	0		0	0	0	259282	0	10	40213160		
43638	3616	1115171	2013-05-28	2013-05-28 00:00:00	2013-07-02	2013-07-02 00:00:00	2013-07-02	38000177		0	0	35		0	0	0	240293	0	849574	1115171		
29920	652	40213306	1991-02-12	1991-02-12 00:00:00	1991-02-12	1991-02-12 00:00:00	1991-02-12	581452		0	0	0		0	0	0	43160	0	43	40213306		
205666	4513	40213160	1962-05-30	1962-05-30 00:00:00	1962-05-30	1962-05-30 00:00:00	1962-05-30	581452		0	0	0		0	0	0	300567	0	10	40213160		
4206	349	19078461	2014-05-18	2014-05-18 00:00:00	2014-06-08	2014-06-08 00:00:00	2014-06-08	38000177		0	0	21		0	0	0	23240	0	310965	19078461		
110718	2433	40213160	1957-12-22	1957-12-22 00:00:00	1957-12-22	1957-12-22 00:00:00	1957-12-22	581452		0	0	0		0	0	0	161276	0	10	40213160		
127229	2798	40213260	2007-08-05	2007-08-05 00:00:00	2007-08-05	2007-08-05 00:00:00	2007-08-05	581452		0	0	0		0	0	0	185437	0	121	40213260		
112923	2480	40213296	1996-11-06	1996-11-06 00:00:00	1996-11-06	1996-11-06 00:00:00	1996-11-06	581452		0	0	0		0	0	0	\N	0	52	40213296		
18833	1556	19078461	2004-04-20	2004-04-20 00:00:00	2004-07-19	2004-07-19 00:00:00	2004-07-19	38000177		0	0	90		0	0	0	104150	0	310965	19078461		
195373	4291	40213296	2013-11-29	2013-11-29 00:00:00	2013-11-29	2013-11-29 00:00:00	2013-11-29	581452		0	0	0		0	0	0	284930	0	52	40213296		
27706	2292	1115171	2018-01-22	2018-01-22 00:00:00	2018-02-12	2018-02-12 00:00:00	2018-02-12	38000177		0	0	21		0	0	0	152633	0	849574	1115171		
168712	3708	40213160	1982-03-19	1982-03-19 00:00:00	1982-03-19	1982-03-19 00:00:00	1982-03-19	581452		0	0	0		0	0	0	246552	0	10	40213160		
93574	2053	40213160	1956-02-02	1956-02-02 00:00:00	1956-02-02	1956-02-02 00:00:00	1956-02-02	581452		0	0	0		0	0	0	136558	0	10	40213160		
19800	1627	40236824	1972-08-20	1972-08-20 00:00:00	1972-08-27	1972-08-27 00:00:00	1972-08-27	38000177		0	0	7		0	0	0	109365	0	1094107	40236824		
216620	4754	40213227	1997-08-26	1997-08-26 00:00:00	1997-08-26	1997-08-26 00:00:00	1997-08-26	581452		0	0	0		0	0	0	316608	0	113	40213227		
99446	2177	40213160	1967-07-05	1967-07-05 00:00:00	1967-07-05	1967-07-05 00:00:00	1967-07-05	581452		0	0	0		0	0	0	145218	0	10	40213160		
29725	2462	1127433	1966-01-17	1966-01-17 00:00:00	1966-01-24	1966-01-24 00:00:00	1966-01-24	38000177		0	0	7		0	0	0	163293	0	313782	1127433		
40172	3325	19059056	1966-01-16	1966-01-16 00:00:00	1966-01-30	1966-01-30 00:00:00	1966-01-30	38000177		0	0	14		0	0	0	220726	0	243670	19059056		
160270	3527	40213227	2003-07-24	2003-07-24 00:00:00	2003-07-24	2003-07-24 00:00:00	2003-07-24	581452		0	0	0		0	0	0	234128	0	113	40213227		
75840	1657	40213227	2015-04-29	2015-04-29 00:00:00	2015-04-29	2015-04-29 00:00:00	2015-04-29	581452		0	0	0		0	0	0	111220	0	113	40213227		
51272	4260	1127433	1976-12-15	1976-12-15 00:00:00	1976-12-22	1976-12-22 00:00:00	1976-12-22	38000177		0	0	7		0	0	0	282785	0	313782	1127433		
43750	3624	1127433	2001-03-22	2001-03-22 00:00:00	2001-03-29	2001-03-29 00:00:00	2001-03-29	38000177		0	0	7		0	0	0	240970	0	313782	1127433		
171741	3776	40213160	1973-09-08	1973-09-08 00:00:00	1973-09-08	1973-09-08 00:00:00	1973-09-08	581452		0	0	0		0	0	0	250961	0	10	40213160		
57377	4760	19133873	1968-09-06	1968-09-06 00:00:00	1968-09-17	1968-09-17 00:00:00	1968-09-17	38000177		0	0	11		0	0	0	317174	0	834061	19133873		
57429	4763	19059056	1955-09-09	1955-09-09 00:00:00	1955-09-23	1955-09-23 00:00:00	1955-09-23	38000177		0	0	14		0	0	0	317382	0	243670	19059056		
51017	4239	1127433	1971-11-20	1971-11-20 00:00:00	1971-12-04	1971-12-04 00:00:00	1971-12-04	38000177		0	0	14		0	0	0	281566	0	313782	1127433		
184521	4055	40213296	2010-11-17	2010-11-17 00:00:00	2010-11-17	2010-11-17 00:00:00	2010-11-17	581452		0	0	0		0	0	0	269565	0	52	40213296		
214566	4705	40213296	2014-06-26	2014-06-26 00:00:00	2014-06-26	2014-06-26 00:00:00	2014-06-26	581452		0	0	0		0	0	0	313465	0	52	40213296		
26326	2166	1127433	2006-01-27	2006-01-27 00:00:00	2006-02-17	2006-02-17 00:00:00	2006-02-17	38000177		0	0	21		0	0	0	144343	0	313782	1127433		
145179	3191	40213160	1958-06-05	1958-06-05 00:00:00	1958-06-05	1958-06-05 00:00:00	1958-06-05	581452		0	0	0		0	0	0	212343	0	10	40213160		
74358	1623	40213198	2015-04-03	2015-04-03 00:00:00	2015-04-03	2015-04-03 00:00:00	2015-04-03	581452		0	0	0		0	0	0	109124	0	133	40213198		
17733	1468	19133873	1956-02-13	1956-02-13 00:00:00	1956-02-23	1956-02-23 00:00:00	1956-02-23	38000177		0	0	10		0	0	0	97850	0	834061	19133873		
136127	2988	40213296	2002-06-16	2002-06-16 00:00:00	2002-06-16	2002-06-16 00:00:00	2002-06-16	581452		0	0	0		0	0	0	199454	0	52	40213296		
206052	4522	40213227	2007-11-16	2007-11-16 00:00:00	2007-11-16	2007-11-16 00:00:00	2007-11-16	581452		0	0	0		0	0	0	301102	0	113	40213227		
9059	755	19133873	1953-04-08	1953-04-08 00:00:00	1953-04-19	1953-04-19 00:00:00	1953-04-19	38000177		0	0	11		0	0	0	50091	0	834061	19133873		
55760	4630	1713671	1970-06-30	1970-06-30 00:00:00	1970-07-21	1970-07-21 00:00:00	1970-07-21	38000177		0	0	21		0	0	0	308506	0	562251	1713671		
121436	2669	40213306	1998-12-16	1998-12-16 00:00:00	1998-12-16	1998-12-16 00:00:00	1998-12-16	581452		0	0	0		0	0	0	176773	0	43	40213306		
46724	1021	40213227	2014-02-13	2014-02-13 00:00:00	2014-02-13	2014-02-13 00:00:00	2014-02-13	581452		0	0	0		0	0	0	67168	0	113	40213227		
7836	655	19128065	1975-11-28	1975-11-28 00:00:00	1976-11-22	1976-11-22 00:00:00	1976-11-22	38000177		0	0	360		0	0	0	43415	0	749882	19128065		
211030	4628	40213160	1969-03-09	1969-03-09 00:00:00	1969-03-09	1969-03-09 00:00:00	1969-03-09	581452		0	0	0		0	0	0	308334	0	10	40213160		
125471	2760	40213160	1962-03-08	1962-03-08 00:00:00	1962-03-08	1962-03-08 00:00:00	1962-03-08	581452		0	0	0		0	0	0	182569	0	10	40213160		
35926	2957	1127433	1981-11-30	1981-11-30 00:00:00	1981-12-14	1981-12-14 00:00:00	1981-12-14	38000177		0	0	14		0	0	0	197308	0	313782	1127433		
34957	2886	19073188	2001-11-27	2001-11-27 00:00:00	2002-01-01	2002-01-01 00:00:00	2002-01-01	38000177		0	0	35		0	0	0	192029	0	308192	19073188		
58313	1276	40213227	2000-02-18	2000-02-18 00:00:00	2000-02-18	2000-02-18 00:00:00	2000-02-18	581452		0	0	0		0	0	0	84215	0	113	40213227		
14237	1193	1127433	1964-03-20	1964-03-20 00:00:00	1964-04-17	1964-04-17 00:00:00	1964-04-17	38000177		0	0	28		0	0	0	78621	0	313782	1127433		
77100	1685	40213251	1984-12-23	1984-12-23 00:00:00	1984-12-23	1984-12-23 00:00:00	1984-12-23	581452		0	0	0		0	0	0	112889	0	21	40213251		
57121	1250	40213227	1995-06-19	1995-06-19 00:00:00	1995-06-19	1995-06-19 00:00:00	1995-06-19	581452		0	0	0		0	0	0	82370	0	113	40213227		
43110	3572	19133873	1970-12-04	1970-12-04 00:00:00	1970-12-13	1970-12-13 00:00:00	1970-12-13	38000177		0	0	9		0	0	0	237450	0	834061	19133873		
222211	4878	40213296	2006-09-16	2006-09-16 00:00:00	2006-09-16	2006-09-16 00:00:00	2006-09-16	581452		0	0	0		0	0	0	324422	0	52	40213296		
61939	1353	40213260	2006-03-06	2006-03-06 00:00:00	2006-03-06	2006-03-06 00:00:00	2006-03-06	581452		0	0	0		0	0	0	89693	0	121	40213260		
34271	2832	1124300	2000-06-25	2000-06-25 00:00:00	2000-06-25	2000-06-25 00:00:00	\N	38000177		0	0	0		0	0	0	187954	0	00781178901	45011828		
19223	418	40213296	1999-05-10	1999-05-10 00:00:00	1999-05-10	1999-05-10 00:00:00	1999-05-10	581452		0	0	0		0	0	0	\N	0	52	40213296		
213928	4690	40213160	1957-02-16	1957-02-16 00:00:00	1957-02-16	1957-02-16 00:00:00	1957-02-16	581452		0	0	0		0	0	0	312461	0	10	40213160		
73928	1613	40213296	1997-11-22	1997-11-22 00:00:00	1997-11-22	1997-11-22 00:00:00	1997-11-22	581452		0	0	0		0	0	0	108465	0	52	40213296		
189475	4160	40213160	1962-12-13	1962-12-13 00:00:00	1962-12-13	1962-12-13 00:00:00	1962-12-13	581452		0	0	0		0	0	0	276427	0	10	40213160		
17287	1433	40229134	1970-01-13	1970-01-13 00:00:00	1970-01-27	1970-01-27 00:00:00	1970-01-27	38000177		0	0	14		0	0	0	95491	0	1043400	40229134		
242959	5334	40213227	2015-02-25	2015-02-25 00:00:00	2015-02-25	2015-02-25 00:00:00	2015-02-25	581452		0	0	0		0	0	0	355190	0	113	40213227		
200912	4412	40213160	1964-04-10	1964-04-10 00:00:00	1964-04-10	1964-04-10 00:00:00	1964-04-10	581452		0	0	0		0	0	0	293392	0	10	40213160		
57813	4804	1154615	1997-03-23	1997-03-23 00:00:00	1997-03-23	1997-03-23 00:00:00	\N	38000177		0	0	0		0	0	0	319587	0	745679	1154615		
52756	4384	19059056	1968-02-11	1968-02-11 00:00:00	1968-02-25	1968-02-25 00:00:00	1968-02-25	38000177		0	0	14		0	0	0	291407	0	243670	19059056		
77890	1703	40213160	1955-06-08	1955-06-08 00:00:00	1955-06-08	1955-06-08 00:00:00	1955-06-08	581452		0	0	0		0	0	0	113934	0	10	40213160		
196772	4324	40213160	1966-05-22	1966-05-22 00:00:00	1966-05-22	1966-05-22 00:00:00	1966-05-22	581452		0	0	0		0	0	0	286871	0	10	40213160		
151565	3334	40213227	2006-12-28	2006-12-28 00:00:00	2006-12-28	2006-12-28 00:00:00	2006-12-28	581452		0	0	0		0	0	0	221192	0	113	40213227		
56458	4685	19133873	1949-04-28	1949-04-28 00:00:00	1949-05-10	1949-05-10 00:00:00	1949-05-10	38000177		0	0	12		0	0	0	312130	0	834061	19133873		
177448	3899	40213160	1980-09-06	1980-09-06 00:00:00	1980-09-06	1980-09-06 00:00:00	1980-09-06	581452		0	0	0		0	0	0	259270	0	10	40213160		
43639	3616	19078461	1997-10-28	1997-10-28 00:00:00	1997-11-18	1997-11-18 00:00:00	1997-11-18	38000177		0	0	21		0	0	0	240292	0	310965	19078461		
29925	652	40213227	2001-06-26	2001-06-26 00:00:00	2001-06-26	2001-06-26 00:00:00	2001-06-26	581452		0	0	0		0	0	0	43137	0	113	40213227		
205667	4513	40213260	2011-12-21	2011-12-21 00:00:00	2011-12-21	2011-12-21 00:00:00	2011-12-21	581452		0	0	0		0	0	0	300529	0	121	40213260		
4208	350	19075601	1997-11-14	1997-11-14 00:00:00	1997-11-14	1997-11-14 00:00:00	\N	38000177		0	0	0		0	0	0	23255	0	309362	19075601		
110721	2433	40213227	2004-01-18	2004-01-18 00:00:00	2004-01-18	2004-01-18 00:00:00	2004-01-18	581452		0	0	0		0	0	0	161296	0	113	40213227		
127232	2798	40213260	2006-07-30	2006-07-30 00:00:00	2006-07-30	2006-07-30 00:00:00	2006-07-30	581452		0	0	0		0	0	0	185370	0	121	40213260		
112926	2480	40213160	1960-10-12	1960-10-12 00:00:00	1960-10-12	1960-10-12 00:00:00	1960-10-12	581452		0	0	0		0	0	0	164309	0	10	40213160		
18834	1556	1713671	1982-02-09	1982-02-09 00:00:00	1982-03-30	1982-03-30 00:00:00	1982-03-30	38000177		0	0	49		0	0	0	104193	0	562251	1713671		
195381	4291	40213306	1996-02-16	1996-02-16 00:00:00	1996-02-16	1996-02-16 00:00:00	1996-02-16	581452		0	0	0		0	0	0	284891	0	43	40213306		
27707	2292	1127433	2001-12-26	2001-12-26 00:00:00	2002-01-09	2002-01-09 00:00:00	2002-01-09	38000177		0	0	14		0	0	0	152613	0	313782	1127433		
131304	2886	40213198	2016-04-11	2016-04-11 00:00:00	2016-04-11	2016-04-11 00:00:00	2016-04-11	581452		0	0	0		0	0	0	192024	0	133	40213198		
93579	2053	40213260	2006-07-20	2006-07-20 00:00:00	2006-07-20	2006-07-20 00:00:00	2006-07-20	581452		0	0	0		0	0	0	136470	0	121	40213260		
19801	1627	920300	1972-08-20	1972-08-20 00:00:00	1972-08-27	1972-08-27 00:00:00	1972-08-27	38000177		0	0	7		0	0	0	109365	0	311989	920300		
216627	4754	40213296	2005-06-28	2005-06-28 00:00:00	2005-06-28	2005-06-28 00:00:00	2005-06-28	581452		0	0	0		0	0	0	316609	0	52	40213296		
99455	2177	40213306	1990-09-19	1990-09-19 00:00:00	1990-09-19	1990-09-19 00:00:00	1990-09-19	581452		0	0	0		0	0	0	145174	0	43	40213306		
29726	2462	19008572	1988-10-12	1988-10-12 00:00:00	1988-10-12	1988-10-12 00:00:00	\N	38000177		0	0	0		0	0	0	163232	0	106258	19008572		
50631	4208	1310034	1981-04-07	1981-04-07 00:00:00	1981-04-07	1981-04-07 00:00:00	1981-04-07	38000177		0	0	0		0	0	0	279428	0	834357	1310034		
160275	3527	40213160	1962-03-22	1962-03-22 00:00:00	1962-03-22	1962-03-22 00:00:00	1962-03-22	581452		0	0	0		0	0	0	234142	0	10	40213160		
218367	4792	40213227	1992-03-31	1992-03-31 00:00:00	1992-03-31	1992-03-31 00:00:00	1992-03-31	581452		0	0	0		0	0	0	318906	0	113	40213227		
51273	4260	1713671	1984-09-26	1984-09-26 00:00:00	1984-10-10	1984-10-10 00:00:00	1984-10-10	38000177		0	0	14		0	0	0	282807	0	562251	1713671		
43751	3624	1713671	1989-06-23	1989-06-23 00:00:00	1989-07-07	1989-07-07 00:00:00	1989-07-07	38000177		0	0	14		0	0	0	240994	0	562251	1713671		
171745	3776	40213296	2013-06-08	2013-06-08 00:00:00	2013-06-08	2013-06-08 00:00:00	2013-06-08	581452		0	0	0		0	0	0	250969	0	52	40213296		
57378	4760	1127433	1985-06-28	1985-06-28 00:00:00	1985-07-12	1985-07-12 00:00:00	1985-07-12	38000177		0	0	14		0	0	0	317146	0	313782	1127433		
57430	4763	19006318	1953-01-08	1953-01-08 00:00:00	1953-01-22	1953-01-22 00:00:00	1953-01-22	38000177		0	0	14		0	0	0	317408	0	105078	19006318		
51018	4239	40229134	1957-01-22	1957-01-22 00:00:00	1957-02-05	1957-02-05 00:00:00	1957-02-05	38000177		0	0	14		0	0	0	281464	0	1043400	40229134		
184523	4055	40213227	2010-11-17	2010-11-17 00:00:00	2010-11-17	2010-11-17 00:00:00	2010-11-17	581452		0	0	0		0	0	0	269565	0	113	40213227		
214567	4705	40213296	2012-06-21	2012-06-21 00:00:00	2012-06-21	2012-06-21 00:00:00	2012-06-21	581452		0	0	0		0	0	0	313438	0	52	40213296		
26327	2166	19059056	1986-09-09	1986-09-09 00:00:00	1986-12-08	1986-12-08 00:00:00	1986-12-08	38000177		0	0	90		0	0	0	144342	0	243670	19059056		
145191	3191	40213227	1992-06-04	1992-06-04 00:00:00	1992-06-04	1992-06-04 00:00:00	1992-06-04	581452		0	0	0		0	0	0	\N	0	113	40213227		
74361	1623	40213227	1992-01-17	1992-01-17 00:00:00	1992-01-17	1992-01-17 00:00:00	1992-01-17	581452		0	0	0		0	0	0	109101	0	113	40213227		
17734	1468	19075601	1997-02-26	1997-02-26 00:00:00	1997-02-26	1997-02-26 00:00:00	\N	38000177		0	0	0		0	0	0	97870	0	309362	19075601		
136133	2989	40213160	1955-03-02	1955-03-02 00:00:00	1955-03-02	1955-03-02 00:00:00	1955-03-02	581452		0	0	0		0	0	0	199556	0	10	40213160		
206057	4522	40213160	1976-04-16	1976-04-16 00:00:00	1976-04-16	1976-04-16 00:00:00	1976-04-16	581452		0	0	0		0	0	0	301119	0	10	40213160		
9061	755	1713671	1998-01-04	1998-01-04 00:00:00	1998-01-18	1998-01-18 00:00:00	1998-01-18	38000177		0	0	14		0	0	0	50042	0	562251	1713671		
55761	4630	1127433	1982-08-08	1982-08-08 00:00:00	1982-08-29	1982-08-29 00:00:00	1982-08-29	38000177		0	0	21		0	0	0	308521	0	313782	1127433		
121438	2669	40213314	1977-05-18	1977-05-18 00:00:00	1977-05-18	1977-05-18 00:00:00	1977-05-18	581452		0	0	0		0	0	0	176767	0	49	40213314		
46730	1021	40213227	2003-12-18	2003-12-18 00:00:00	2003-12-18	2003-12-18 00:00:00	2003-12-18	581452		0	0	0		0	0	0	67147	0	113	40213227		
7837	655	1127433	1999-06-06	1999-06-06 00:00:00	1999-07-04	1999-07-04 00:00:00	1999-07-04	38000177		0	0	28		0	0	0	43422	0	313782	1127433		
211035	4628	40213160	1969-06-08	1969-06-08 00:00:00	1969-06-08	1969-06-08 00:00:00	1969-06-08	581452		0	0	0		0	0	0	308371	0	10	40213160		
125479	2760	40213296	2000-07-20	2000-07-20 00:00:00	2000-07-20	2000-07-20 00:00:00	2000-07-20	581452		0	0	0		0	0	0	182583	0	52	40213296		
35927	2957	1713671	1996-11-09	1996-11-09 00:00:00	1996-11-23	1996-11-23 00:00:00	1996-11-23	38000177		0	0	14		0	0	0	197356	0	562251	1713671		
34958	2886	1127433	2001-11-27	2001-11-27 00:00:00	2002-01-01	2002-01-01 00:00:00	2002-01-01	38000177		0	0	35		0	0	0	192029	0	313782	1127433		
76999	1683	40213160	1972-03-30	1972-03-30 00:00:00	1972-03-30	1972-03-30 00:00:00	1972-03-30	581452		0	0	0		0	0	0	112821	0	10	40213160		
14238	1193	1127433	1975-04-15	1975-04-15 00:00:00	1975-04-29	1975-04-29 00:00:00	1975-04-29	38000177		0	0	14		0	0	0	78641	0	313782	1127433		
77103	1685	40213160	1984-12-23	1984-12-23 00:00:00	1984-12-23	1984-12-23 00:00:00	1984-12-23	581452		0	0	0		0	0	0	112889	0	10	40213160		
57129	1250	40213296	1997-06-23	1997-06-23 00:00:00	1997-06-23	1997-06-23 00:00:00	1997-06-23	581452		0	0	0		0	0	0	82355	0	52	40213296		
43111	3572	19006318	1958-07-22	1958-07-22 00:00:00	1958-08-05	1958-08-05 00:00:00	1958-08-05	38000177		0	0	14		0	0	0	237482	0	105078	19006318		
222214	4878	40213160	1963-04-13	1963-04-13 00:00:00	1963-04-13	1963-04-13 00:00:00	1963-04-13	581452		0	0	0		0	0	0	324414	0	10	40213160		
61945	1353	40213160	1955-11-07	1955-11-07 00:00:00	1955-11-07	1955-11-07 00:00:00	1955-11-07	581452		0	0	0		0	0	0	89650	0	10	40213160		
34272	2832	40236824	2008-03-21	2008-03-21 00:00:00	2008-03-28	2008-03-28 00:00:00	2008-03-28	38000177		0	0	7		0	0	0	187936	0	1094107	40236824		
19233	418	40213296	1998-10-19	1998-10-19 00:00:00	1998-10-19	1998-10-19 00:00:00	1998-10-19	581452		0	0	0		0	0	0	27678	0	52	40213296		
213934	4691	40213306	1982-12-25	1982-12-25 00:00:00	1982-12-25	1982-12-25 00:00:00	1982-12-25	581452		0	0	0		0	0	0	312564	0	43	40213306		
73929	1613	40213160	1955-04-23	1955-04-23 00:00:00	1955-04-23	1955-04-23 00:00:00	1955-04-23	581452		0	0	0		0	0	0	108452	0	10	40213160		
189477	4160	40213160	1963-03-14	1963-03-14 00:00:00	1963-03-14	1963-03-14 00:00:00	1963-03-14	581452		0	0	0		0	0	0	276397	0	10	40213160		
17288	1433	1713671	1994-01-25	1994-01-25 00:00:00	1994-02-15	1994-02-15 00:00:00	1994-02-15	38000177		0	0	21		0	0	0	95428	0	562251	1713671		
242963	5334	40213306	1988-02-10	1988-02-10 00:00:00	1988-02-10	1988-02-10 00:00:00	1988-02-10	581452		0	0	0		0	0	0	355172	0	43	40213306		
200914	4412	40213296	2005-08-12	2005-08-12 00:00:00	2005-08-12	2005-08-12 00:00:00	2005-08-12	581452		0	0	0		0	0	0	293357	0	52	40213296		
57814	4804	40229134	1978-10-14	1978-10-14 00:00:00	1978-10-21	1978-10-21 00:00:00	1978-10-21	38000177		0	0	7		0	0	0	319615	0	1043400	40229134		
52757	4384	1127433	1999-10-01	1999-10-01 00:00:00	1999-10-22	1999-10-22 00:00:00	1999-10-22	38000177		0	0	21		0	0	0	291365	0	313782	1127433		
77893	1703	40213198	2014-05-07	2014-05-07 00:00:00	2014-05-07	2014-05-07 00:00:00	2014-05-07	581452		0	0	0		0	0	0	113851	0	133	40213198		
196774	4324	40213306	1981-09-06	1981-09-06 00:00:00	1981-09-06	1981-09-06 00:00:00	1981-09-06	581452		0	0	0		0	0	0	286817	0	43	40213306		
151580	3334	40213198	2011-01-20	2011-01-20 00:00:00	2011-01-20	2011-01-20 00:00:00	2011-01-20	581452		0	0	0		0	0	0	221185	0	133	40213198		
56459	4685	1127078	1950-07-13	1950-07-13 00:00:00	1950-08-03	1950-08-03 00:00:00	1950-08-03	38000177		0	0	21		0	0	0	312151	0	282464	1127078		
177449	3899	40213227	2012-12-22	2012-12-22 00:00:00	2012-12-22	2012-12-22 00:00:00	2012-12-22	581452		0	0	0		0	0	0	259276	0	113	40213227		
43640	3616	40236824	2004-03-29	2004-03-29 00:00:00	2004-04-05	2004-04-05 00:00:00	2004-04-05	38000177		0	0	7		0	0	0	240302	0	1094107	40236824		
29927	652	40213296	2011-12-27	2011-12-27 00:00:00	2011-12-27	2011-12-27 00:00:00	2011-12-27	581452		0	0	0		0	0	0	43198	0	52	40213296		
205669	4513	40213160	1966-03-09	1966-03-09 00:00:00	1966-03-09	1966-03-09 00:00:00	1966-03-09	581452		0	0	0		0	0	0	300521	0	10	40213160		
4209	350	1332419	1994-11-11	1994-11-11 00:00:00	1994-11-11	1994-11-11 00:00:00	\N	38000177		0	0	0		0	0	0	23254	0	197361	1332419		
110723	2433	40213201	2019-04-14	2019-04-14 00:00:00	2019-04-14	2019-04-14 00:00:00	2019-04-14	581452		0	0	0		0	0	0	161331	0	33	40213201		
127234	2798	40213296	1997-10-26	1997-10-26 00:00:00	1997-10-26	1997-10-26 00:00:00	1997-10-26	581452		0	0	0		0	0	0	185435	0	52	40213296		
125918	2770	40213227	2012-07-14	2012-07-14 00:00:00	2012-07-14	2012-07-14 00:00:00	2012-07-14	581452		0	0	0		0	0	0	183414	0	113	40213227		
18835	1556	19128065	1990-03-10	1990-03-10 00:00:00	1991-03-05	1991-03-05 00:00:00	1991-03-05	38000177		0	0	360		0	0	0	104251	0	749882	19128065		
195383	4291	40213227	1996-02-16	1996-02-16 00:00:00	1996-02-16	1996-02-16 00:00:00	1996-02-16	581452		0	0	0		0	0	0	284891	0	113	40213227		
27708	2292	1127433	1988-08-03	1988-08-03 00:00:00	1988-08-31	1988-08-31 00:00:00	1988-08-31	38000177		0	0	28		0	0	0	152635	0	313782	1127433		
131326	2886	40213227	2001-12-17	2001-12-17 00:00:00	2001-12-17	2001-12-17 00:00:00	2001-12-17	581452		0	0	0		0	0	0	191905	0	113	40213227		
93583	2053	40213160	1955-08-04	1955-08-04 00:00:00	1955-08-04	1955-08-04 00:00:00	1955-08-04	581452		0	0	0		0	0	0	136531	0	10	40213160		
19802	1627	40229134	1970-06-28	1970-06-28 00:00:00	1970-07-05	1970-07-05 00:00:00	1970-07-05	38000177		0	0	7		0	0	0	109330	0	1043400	40229134		
216629	4754	40213160	1965-01-26	1965-01-26 00:00:00	1965-01-26	1965-01-26 00:00:00	1965-01-26	581452		0	0	0		0	0	0	316618	0	10	40213160		
191774	4214	40213160	1973-08-07	1973-08-07 00:00:00	1973-08-07	1973-08-07 00:00:00	1973-08-07	581452		0	0	0		0	0	0	279804	0	10	40213160		
29727	2462	40231925	1997-09-29	1997-09-29 00:00:00	1997-09-29	1997-09-29 00:00:00	\N	38000177		0	0	0		0	0	0	163200	0	1049221	40231925		
50632	4208	40243436	1981-04-07	1981-04-07 00:00:00	1981-04-07	1981-04-07 00:00:00	1981-04-07	38000177		0	0	0		0	0	0	279428	0	1190795	40243436		
160280	3527	40213260	2011-07-14	2011-07-14 00:00:00	2011-07-14	2011-07-14 00:00:00	2011-07-14	581452		0	0	0		0	0	0	234044	0	121	40213260		
229670	5048	40213260	2009-04-03	2009-04-03 00:00:00	2009-04-03	2009-04-03 00:00:00	2009-04-03	581452		0	0	0		0	0	0	335524	0	121	40213260		
51274	4260	19006318	1945-11-19	1945-11-19 00:00:00	1945-12-10	1945-12-10 00:00:00	1945-12-10	38000177		0	0	21		0	0	0	282843	0	105078	19006318		
43752	3625	19078461	2011-08-26	2011-08-26 00:00:00	2011-09-16	2011-09-16 00:00:00	2011-09-16	38000177		0	0	21		0	0	0	241059	0	310965	19078461		
6063	507	1127433	1999-07-24	1999-07-24 00:00:00	1999-08-07	1999-08-07 00:00:00	1999-08-07	38000177		0	0	14		0	0	0	33900	0	313782	1127433		
57379	4760	19133873	1968-02-28	1968-02-28 00:00:00	1968-03-07	1968-03-07 00:00:00	1968-03-07	38000177		0	0	8		0	0	0	317203	0	834061	19133873		
57431	4763	1127078	1953-01-08	1953-01-08 00:00:00	1953-01-22	1953-01-22 00:00:00	1953-01-22	38000177		0	0	14		0	0	0	317408	0	282464	1127078		
51020	4239	19059056	1951-03-14	1951-03-14 00:00:00	1951-03-28	1951-03-28 00:00:00	1951-03-28	38000177		0	0	14		0	0	0	281491	0	243670	19059056		
184524	4055	40213160	1969-02-12	1969-02-12 00:00:00	1969-02-12	1969-02-12 00:00:00	1969-02-12	581452		0	0	0		0	0	0	269531	0	10	40213160		
226427	4972	40213160	1955-12-24	1955-12-24 00:00:00	1955-12-24	1955-12-24 00:00:00	1955-12-24	581452		0	0	0		0	0	0	330727	0	10	40213160		
26328	2166	40236824	1992-06-15	1992-06-15 00:00:00	1992-06-22	1992-06-22 00:00:00	1992-06-22	38000177		0	0	7		0	0	0	144284	0	1094107	40236824		
145192	3191	40213160	1958-01-02	1958-01-02 00:00:00	1958-01-02	1958-01-02 00:00:00	1958-01-02	581452		0	0	0		0	0	0	212342	0	10	40213160		
74366	1623	40213201	2016-04-08	2016-04-08 00:00:00	2016-04-08	2016-04-08 00:00:00	2016-04-08	581452		0	0	0		0	0	0	109070	0	33	40213201		
17735	1468	1332419	1995-07-19	1995-07-19 00:00:00	1995-07-19	1995-07-19 00:00:00	\N	38000177		0	0	0		0	0	0	97869	0	197361	1332419		
136145	2989	40213260	2006-07-05	2006-07-05 00:00:00	2006-07-05	2006-07-05 00:00:00	2006-07-05	581452		0	0	0		0	0	0	199525	0	121	40213260		
206058	4522	40213314	1977-03-18	1977-03-18 00:00:00	1977-03-18	1977-03-18 00:00:00	1977-03-18	581452		0	0	0		0	0	0	301131	0	49	40213314		
9062	755	19078461	1979-06-22	1979-06-22 00:00:00	1979-07-13	1979-07-13 00:00:00	1979-07-13	38000177		0	0	21		0	0	0	50008	0	310965	19078461		
55762	4630	1118084	1993-04-07	1993-04-07 00:00:00	1993-04-07	1993-04-07 00:00:00	\N	38000177		0	0	0		0	0	0	308500	0	00025152531	44923712		
121439	2669	40213160	1977-05-18	1977-05-18 00:00:00	1977-05-18	1977-05-18 00:00:00	1977-05-18	581452		0	0	0		0	0	0	176767	0	10	40213160		
46740	1021	40213160	1955-11-17	1955-11-17 00:00:00	1955-11-17	1955-11-17 00:00:00	1955-11-17	581452		0	0	0		0	0	0	67199	0	10	40213160		
7838	655	40229134	1991-12-12	1991-12-12 00:00:00	1991-12-19	1991-12-19 00:00:00	1991-12-19	38000177		0	0	7		0	0	0	43350	0	1043400	40229134		
211036	4628	40213160	1969-01-05	1969-01-05 00:00:00	1969-01-05	1969-01-05 00:00:00	1969-01-05	581452		0	0	0		0	0	0	308316	0	10	40213160		
136758	3002	40213160	1978-06-13	1978-06-13 00:00:00	1978-06-13	1978-06-13 00:00:00	1978-06-13	581452		0	0	0		0	0	0	200370	0	10	40213160		
35929	2957	1127433	1991-12-03	1991-12-03 00:00:00	1991-12-10	1991-12-10 00:00:00	1991-12-10	38000177		0	0	7		0	0	0	197355	0	313782	1127433		
34959	2886	40165015	2001-11-27	2001-11-27 00:00:00	2001-11-27	2001-11-27 00:00:00	\N	38000177		0	0	0		0	0	0	192029	0	861467	40165015		
77001	1683	40213160	1971-10-28	1971-10-28 00:00:00	1971-10-28	1971-10-28 00:00:00	1971-10-28	581452		0	0	0		0	0	0	112820	0	10	40213160		
14239	1193	19059056	1953-09-04	1953-09-04 00:00:00	1953-09-18	1953-09-18 00:00:00	1953-09-18	38000177		0	0	14		0	0	0	78618	0	243670	19059056		
77106	1685	40213160	1980-07-20	1980-07-20 00:00:00	1980-07-20	1980-07-20 00:00:00	1980-07-20	581452		0	0	0		0	0	0	112874	0	10	40213160		
57131	1250	40213160	1955-08-29	1955-08-29 00:00:00	1955-08-29	1955-08-29 00:00:00	1955-08-29	581452		0	0	0		0	0	0	82365	0	10	40213160		
43112	3572	1127078	1958-07-22	1958-07-22 00:00:00	1958-08-05	1958-08-05 00:00:00	1958-08-05	38000177		0	0	14		0	0	0	237482	0	282464	1127078		
222226	4878	40213227	2014-06-28	2014-06-28 00:00:00	2014-06-28	2014-06-28 00:00:00	2014-06-28	581452		0	0	0		0	0	0	324456	0	113	40213227		
61948	1353	40213160	1960-02-08	1960-02-08 00:00:00	1960-02-08	1960-02-08 00:00:00	1960-02-08	581452		0	0	0		0	0	0	89685	0	10	40213160		
34273	2832	920300	2008-03-21	2008-03-21 00:00:00	2008-03-28	2008-03-28 00:00:00	2008-03-28	38000177		0	0	7		0	0	0	187936	0	311989	920300		
19235	418	40213227	1998-10-19	1998-10-19 00:00:00	1998-10-19	1998-10-19 00:00:00	1998-10-19	581452		0	0	0		0	0	0	27678	0	113	40213227		
213936	4691	40213160	1961-01-14	1961-01-14 00:00:00	1961-01-14	1961-01-14 00:00:00	1961-01-14	581452		0	0	0		0	0	0	312542	0	10	40213160		
73931	1613	40213227	2005-12-17	2005-12-17 00:00:00	2005-12-17	2005-12-17 00:00:00	2005-12-17	581452		0	0	0		0	0	0	108475	0	113	40213227		
189484	4160	40213296	2004-05-20	2004-05-20 00:00:00	2004-05-20	2004-05-20 00:00:00	2004-05-20	581452		0	0	0		0	0	0	276408	0	52	40213296		
17289	1433	1118084	1995-08-18	1995-08-18 00:00:00	1995-08-18	1995-08-18 00:00:00	\N	38000177		0	0	0		0	0	0	95480	0	00025152531	44923712		
242968	5334	40213306	1986-03-12	1986-03-12 00:00:00	1986-03-12	1986-03-12 00:00:00	1986-03-12	581452		0	0	0		0	0	0	355186	0	43	40213306		
200916	4412	40213227	2005-08-12	2005-08-12 00:00:00	2005-08-12	2005-08-12 00:00:00	2005-08-12	581452		0	0	0		0	0	0	293357	0	113	40213227		
57815	4804	19128065	1997-02-14	1997-02-14 00:00:00	1998-02-09	1998-02-09 00:00:00	1998-02-09	38000177		0	0	360		0	0	0	319588	0	749882	19128065		
52758	4384	1551192	1968-09-08	1968-09-08 00:00:00	1968-09-08	1968-09-08 00:00:00	1968-09-08	38000177		0	0	0		0	0	0	291362	0	312617	1551192		
77899	1703	40213227	2010-04-14	2010-04-14 00:00:00	2010-04-14	2010-04-14 00:00:00	2010-04-14	581452		0	0	0		0	0	0	113944	0	113	40213227		
196781	4324	40213227	1993-09-19	1993-09-19 00:00:00	1993-09-19	1993-09-19 00:00:00	1993-09-19	581452		0	0	0		0	0	0	286807	0	113	40213227		
196816	4325	40213306	1986-05-27	1986-05-27 00:00:00	1986-05-27	1986-05-27 00:00:00	1986-05-27	581452		0	0	0		0	0	0	\N	0	43	40213306		
56462	4685	19059056	1940-04-01	1940-04-01 00:00:00	1940-04-15	1940-04-15 00:00:00	1940-04-15	38000177		0	0	14		0	0	0	312132	0	243670	19059056		
177456	3900	40213160	1968-03-12	1968-03-12 00:00:00	1968-03-12	1968-03-12 00:00:00	1968-03-12	581452		0	0	0		0	0	0	259300	0	10	40213160		
43641	3616	920300	2004-03-29	2004-03-29 00:00:00	2004-04-05	2004-04-05 00:00:00	2004-04-05	38000177		0	0	7		0	0	0	240302	0	311989	920300		
29932	652	40213160	1968-10-22	1968-10-22 00:00:00	1968-10-22	1968-10-22 00:00:00	1968-10-22	581452		0	0	0		0	0	0	43189	0	10	40213160		
216956	4760	40213160	1959-10-07	1959-10-07 00:00:00	1959-10-07	1959-10-07 00:00:00	1959-10-07	581452		0	0	0		0	0	0	317166	0	10	40213160		
4210	350	19078461	1984-02-23	1984-02-23 00:00:00	1984-03-29	1984-03-29 00:00:00	1984-03-29	38000177		0	0	35		0	0	0	23291	0	310965	19078461		
110726	2433	40213160	1955-06-19	1955-06-19 00:00:00	1955-06-19	1955-06-19 00:00:00	1955-06-19	581452		0	0	0		0	0	0	161286	0	10	40213160		
127238	2798	40213160	1955-03-20	1955-03-20 00:00:00	1955-03-20	1955-03-20 00:00:00	1955-03-20	581452		0	0	0		0	0	0	185451	0	10	40213160		
125921	2770	40213227	1993-01-30	1993-01-30 00:00:00	1993-01-30	1993-01-30 00:00:00	1993-01-30	581452		0	0	0		0	0	0	183374	0	113	40213227		
18836	1556	1127433	1989-01-04	1989-01-04 00:00:00	1989-01-25	1989-01-25 00:00:00	1989-01-25	38000177		0	0	21		0	0	0	104148	0	313782	1127433		
195384	4291	40213314	1977-04-29	1977-04-29 00:00:00	1977-04-29	1977-04-29 00:00:00	1977-04-29	581452		0	0	0		0	0	0	284899	0	49	40213314		
112756	2477	40213227	2016-12-25	2016-12-25 00:00:00	2016-12-25	2016-12-25 00:00:00	2016-12-25	581452		0	0	0		0	0	0	164148	0	113	40213227		
131340	2886	40213227	2012-03-19	2012-03-19 00:00:00	2012-03-19	2012-03-19 00:00:00	2012-03-19	581452		0	0	0		0	0	0	191899	0	113	40213227		
93593	2054	40213160	1972-03-02	1972-03-02 00:00:00	1972-03-02	1972-03-02 00:00:00	1972-03-02	581452		0	0	0		0	0	0	136580	0	10	40213160		
19803	1627	40236824	1977-10-12	1977-10-12 00:00:00	1977-10-19	1977-10-19 00:00:00	1977-10-19	38000177		0	0	7		0	0	0	109366	0	1094107	40236824		
99380	2176	40213227	1998-10-05	1998-10-05 00:00:00	1998-10-05	1998-10-05 00:00:00	1998-10-05	581452		0	0	0		0	0	0	145152	0	113	40213227		
191779	4214	40213296	2012-12-04	2012-12-04 00:00:00	2012-12-04	2012-12-04 00:00:00	2012-12-04	581452		0	0	0		0	0	0	279785	0	52	40213296		
29728	2462	19078461	1997-09-29	1997-09-29 00:00:00	1997-11-03	1997-11-03 00:00:00	1997-11-03	38000177		0	0	35		0	0	0	163200	0	310965	19078461		
50633	4208	46275916	1981-04-07	1981-04-07 00:00:00	1981-04-07	1981-04-07 00:00:00	1981-04-07	38000177		0	0	0		0	0	0	279428	0	1660014	46275916		
160296	3528	40213160	1959-07-13	1959-07-13 00:00:00	1959-07-13	1959-07-13 00:00:00	1959-07-13	581452		0	0	0		0	0	0	234195	0	10	40213160		
229675	5048	40213160	1959-07-03	1959-07-03 00:00:00	1959-07-03	1959-07-03 00:00:00	1959-07-03	581452		0	0	0		0	0	0	335448	0	10	40213160		
51275	4260	19059056	1945-11-19	1945-11-19 00:00:00	1945-12-10	1945-12-10 00:00:00	1945-12-10	38000177		0	0	21		0	0	0	282843	0	243670	19059056		
43753	3625	40171902	2012-09-04	2012-09-04 00:00:00	2012-09-04	2012-09-04 00:00:00	\N	38000177		0	0	0		0	0	0	241072	0	897718	40171902		
6064	507	19018935	1990-08-31	1990-08-31 00:00:00	1990-08-31	1990-08-31 00:00:00	\N	38000177		0	0	0		0	0	0	33931	0	197604	19018935		
57380	4760	19078461	2012-11-28	2012-11-28 00:00:00	2012-12-19	2012-12-19 00:00:00	2012-12-19	38000177		0	0	21		0	0	0	317199	0	310965	19078461		
57432	4763	19133873	1962-03-13	1962-03-13 00:00:00	1962-03-22	1962-03-22 00:00:00	1962-03-22	38000177		0	0	9		0	0	0	317458	0	834061	19133873		
51021	4239	19006318	1951-03-14	1951-03-14 00:00:00	1951-03-28	1951-03-28 00:00:00	1951-03-28	38000177		0	0	14		0	0	0	281491	0	105078	19006318		
184535	4055	40213160	1969-07-16	1969-07-16 00:00:00	1969-07-16	1969-07-16 00:00:00	1969-07-16	581452		0	0	0		0	0	0	269511	0	10	40213160		
226435	4972	40213227	2002-08-31	2002-08-31 00:00:00	2002-08-31	2002-08-31 00:00:00	2002-08-31	581452		0	0	0		0	0	0	330743	0	113	40213227		
26329	2166	920300	1992-06-15	1992-06-15 00:00:00	1992-06-22	1992-06-22 00:00:00	1992-06-22	38000177		0	0	7		0	0	0	144284	0	311989	920300		
145202	3191	40213227	2000-06-01	2000-06-01 00:00:00	2000-06-01	2000-06-01 00:00:00	2000-06-01	581452		0	0	0		0	0	0	212401	0	113	40213227		
202900	4454	40213227	1992-03-07	1992-03-07 00:00:00	1992-03-07	1992-03-07 00:00:00	1992-03-07	581452		0	0	0		0	0	0	296478	0	113	40213227		
17736	1468	1127433	1965-08-11	1965-08-11 00:00:00	1965-08-18	1965-08-18 00:00:00	1965-08-18	38000177		0	0	7		0	0	0	97852	0	313782	1127433		
136151	2989	40213227	2005-06-29	2005-06-29 00:00:00	2005-06-29	2005-06-29 00:00:00	2005-06-29	581452		0	0	0		0	0	0	199517	0	113	40213227		
206062	4522	40213296	2016-01-15	2016-01-15 00:00:00	2016-01-15	2016-01-15 00:00:00	2016-01-15	581452		0	0	0		0	0	0	301100	0	52	40213296		
9063	755	1115171	2013-02-28	2013-02-28 00:00:00	2013-03-14	2013-03-14 00:00:00	2013-03-14	38000177		0	0	14		0	0	0	50011	0	849574	1115171		
55764	4630	1127433	1959-03-09	1959-03-09 00:00:00	1959-03-23	1959-03-23 00:00:00	1959-03-23	38000177		0	0	14		0	0	0	308473	0	313782	1127433		
121442	2669	40213227	2018-04-11	2018-04-11 00:00:00	2018-04-11	2018-04-11 00:00:00	2018-04-11	581452		0	0	0		0	0	0	176798	0	113	40213227		
46743	1021	40213260	2005-12-29	2005-12-29 00:00:00	2005-12-29	2005-12-29 00:00:00	2005-12-29	581452		0	0	0		0	0	0	67148	0	121	40213260		
7839	655	1127078	1964-06-18	1964-06-18 00:00:00	1964-07-09	1964-07-09 00:00:00	1964-07-09	38000177		0	0	21		0	0	0	43421	0	282464	1127078		
211040	4628	40213306	1990-12-02	1990-12-02 00:00:00	1990-12-02	1990-12-02 00:00:00	1990-12-02	581452		0	0	0		0	0	0	308343	0	43	40213306		
136763	3002	40213160	1973-12-11	1973-12-11 00:00:00	1973-12-11	1973-12-11 00:00:00	1973-12-11	581452		0	0	0		0	0	0	200382	0	10	40213160		
35930	2957	1713671	1999-01-20	1999-01-20 00:00:00	1999-02-03	1999-02-03 00:00:00	1999-02-03	38000177		0	0	14		0	0	0	197302	0	562251	1713671		
34960	2886	1127433	1963-10-03	1963-10-03 00:00:00	1963-10-10	1963-10-10 00:00:00	1963-10-10	38000177		0	0	7		0	0	0	191944	0	313782	1127433		
77006	1683	40213227	2002-12-12	2002-12-12 00:00:00	2002-12-12	2002-12-12 00:00:00	2002-12-12	581452		0	0	0		0	0	0	112816	0	113	40213227		
14240	1193	19059056	1959-05-25	1959-05-25 00:00:00	1959-06-15	1959-06-15 00:00:00	1959-06-15	38000177		0	0	21		0	0	0	78620	0	243670	19059056		
77107	1685	40213314	1980-07-20	1980-07-20 00:00:00	1980-07-20	1980-07-20 00:00:00	1980-07-20	581452		0	0	0		0	0	0	112874	0	49	40213314		
57142	1250	40213160	1956-02-27	1956-02-27 00:00:00	1956-02-27	1956-02-27 00:00:00	1956-02-27	581452		0	0	0		0	0	0	82326	0	10	40213160		
43113	3572	1127433	2009-10-11	2009-10-11 00:00:00	2009-10-25	2009-10-25 00:00:00	2009-10-25	38000177		0	0	14		0	0	0	237463	0	313782	1127433		
222227	4878	40213260	2014-06-28	2014-06-28 00:00:00	2014-06-28	2014-06-28 00:00:00	2014-06-28	581452		0	0	0		0	0	0	324456	0	121	40213260		
61954	1353	40213296	1997-03-10	1997-03-10 00:00:00	1997-03-10	1997-03-10 00:00:00	1997-03-10	581452		0	0	0		0	0	0	89656	0	52	40213296		
34274	2832	1713671	1995-04-10	1995-04-10 00:00:00	1995-04-17	1995-04-17 00:00:00	1995-04-17	38000177		0	0	7		0	0	0	188007	0	562251	1713671		
19238	418	40213160	1958-03-03	1958-03-03 00:00:00	1958-03-03	1958-03-03 00:00:00	1958-03-03	581452		0	0	0		0	0	0	27603	0	10	40213160		
219457	4816	40213160	1982-04-19	1982-04-19 00:00:00	1982-04-19	1982-04-19 00:00:00	1982-04-19	581452		0	0	0		0	0	0	320406	0	10	40213160		
73938	1613	40213227	1995-11-18	1995-11-18 00:00:00	1995-11-18	1995-11-18 00:00:00	1995-11-18	581452		0	0	0		0	0	0	108473	0	113	40213227		
189486	4160	40213227	2004-05-20	2004-05-20 00:00:00	2004-05-20	2004-05-20 00:00:00	2004-05-20	581452		0	0	0		0	0	0	276408	0	113	40213227		
17290	1433	40229134	1975-05-28	1975-05-28 00:00:00	1975-06-11	1975-06-11 00:00:00	1975-06-11	38000177		0	0	14		0	0	0	95460	0	1043400	40229134		
242973	5334	40213227	2006-01-18	2006-01-18 00:00:00	2006-01-18	2006-01-18 00:00:00	2006-01-18	581452		0	0	0		0	0	0	355175	0	113	40213227		
200923	4412	40213160	1963-11-08	1963-11-08 00:00:00	1963-11-08	1963-11-08 00:00:00	1963-11-08	581452		0	0	0		0	0	0	293391	0	10	40213160		
57816	4804	1551192	1978-01-15	1978-01-15 00:00:00	1978-01-15	1978-01-15 00:00:00	1978-01-15	38000177		0	0	0		0	0	0	319590	0	312617	1551192		
52759	4384	1127433	2008-11-27	2008-11-27 00:00:00	2008-12-11	2008-12-11 00:00:00	2008-12-11	38000177		0	0	14		0	0	0	291402	0	313782	1127433		
200296	4398	40213260	2009-04-18	2009-04-18 00:00:00	2009-04-18	2009-04-18 00:00:00	2009-04-18	581452		0	0	0		0	0	0	292427	0	121	40213260		
196783	4324	40213306	1984-09-09	1984-09-09 00:00:00	1984-09-09	1984-09-09 00:00:00	1984-09-09	581452		0	0	0		0	0	0	286818	0	43	40213306		
196820	4325	40213227	2016-09-06	2016-09-06 00:00:00	2016-09-06	2016-09-06 00:00:00	2016-09-06	581452		0	0	0		0	0	0	286878	0	113	40213227		
56463	4685	19059056	1941-09-23	1941-09-23 00:00:00	1941-10-28	1941-10-28 00:00:00	1941-10-28	38000177		0	0	35		0	0	0	312150	0	243670	19059056		
219353	4814	40213227	1996-12-16	1996-12-16 00:00:00	1996-12-16	1996-12-16 00:00:00	1996-12-16	581452		0	0	0		0	0	0	320286	0	113	40213227		
43642	3616	19129655	1964-02-13	1964-02-13 00:00:00	1964-02-27	1964-02-27 00:00:00	1964-02-27	38000177		0	0	14		0	0	0	240264	0	789980	19129655		
29934	652	40213296	2009-12-22	2009-12-22 00:00:00	2009-12-22	2009-12-22 00:00:00	2009-12-22	581452		0	0	0		0	0	0	43139	0	52	40213296		
216962	4760	40213260	2007-11-14	2007-11-14 00:00:00	2007-11-14	2007-11-14 00:00:00	2007-11-14	581452		0	0	0		0	0	0	317161	0	121	40213260		
4211	350	1115171	1999-05-10	1999-05-10 00:00:00	1999-05-24	1999-05-24 00:00:00	1999-05-24	38000177		0	0	14		0	0	0	23294	0	849574	1115171		
110729	2433	40213160	1956-06-17	1956-06-17 00:00:00	1956-06-17	1956-06-17 00:00:00	1956-06-17	581452		0	0	0		0	0	0	161275	0	10	40213160		
127248	2798	40213227	1995-10-22	1995-10-22 00:00:00	1995-10-22	1995-10-22 00:00:00	1995-10-22	581452		0	0	0		0	0	0	185377	0	113	40213227		
125943	2771	40213227	2001-06-01	2001-06-01 00:00:00	2001-06-01	2001-06-01 00:00:00	2001-06-01	581452		0	0	0		0	0	0	183424	0	113	40213227		
18837	1556	1127433	2011-08-12	2011-08-12 00:00:00	2011-08-26	2011-08-26 00:00:00	2011-08-26	38000177		0	0	14		0	0	0	104151	0	313782	1127433		
195385	4291	40213160	1974-03-01	1974-03-01 00:00:00	1974-03-01	1974-03-01 00:00:00	1974-03-01	581452		0	0	0		0	0	0	284884	0	10	40213160		
112762	2477	40213160	1955-11-06	1955-11-06 00:00:00	1955-11-06	1955-11-06 00:00:00	1955-11-06	581452		0	0	0		0	0	0	164182	0	10	40213160		
131343	2886	40213160	1955-11-21	1955-11-21 00:00:00	1955-11-21	1955-11-21 00:00:00	1955-11-21	581452		0	0	0		0	0	0	192011	0	10	40213160		
93595	2054	40213296	2013-07-04	2013-07-04 00:00:00	2013-07-04	2013-07-04 00:00:00	2013-07-04	581452		0	0	0		0	0	0	136639	0	52	40213296		
19804	1627	920300	1977-10-12	1977-10-12 00:00:00	1977-10-19	1977-10-19 00:00:00	1977-10-19	38000177		0	0	7		0	0	0	109366	0	311989	920300		
99381	2176	40213160	1961-07-24	1961-07-24 00:00:00	1961-07-24	1961-07-24 00:00:00	1961-07-24	581452		0	0	0		0	0	0	145119	0	10	40213160		
191780	4214	40213160	1973-03-06	1973-03-06 00:00:00	1973-03-06	1973-03-06 00:00:00	1973-03-06	581452		0	0	0		0	0	0	279797	0	10	40213160		
40632	3370	1127078	1977-05-01	1977-05-01 00:00:00	1977-05-15	1977-05-15 00:00:00	1977-05-15	38000177		0	0	14		0	0	0	223488	0	282464	1127078		
153622	3381	40213296	2014-02-17	2014-02-17 00:00:00	2014-02-17	2014-02-17 00:00:00	2014-02-17	581452		0	0	0		0	0	0	224380	0	52	40213296		
168488	3703	40213160	1969-05-03	1969-05-03 00:00:00	1969-05-03	1969-05-03 00:00:00	1969-05-03	581452		0	0	0		0	0	0	246278	0	10	40213160		
229680	5048	40213296	2002-03-15	2002-03-15 00:00:00	2002-03-15	2002-03-15 00:00:00	2002-03-15	581452		0	0	0		0	0	0	335487	0	52	40213296		
51276	4260	40229134	1968-12-19	1968-12-19 00:00:00	1968-12-26	1968-12-26 00:00:00	1968-12-26	38000177		0	0	7		0	0	0	282755	0	1043400	40229134		
43754	3625	19018935	2012-09-04	2012-09-04 00:00:00	2012-09-04	2012-09-04 00:00:00	\N	38000177		0	0	0		0	0	0	241072	0	197604	19018935		
6065	507	40171902	1990-08-31	1990-08-31 00:00:00	1990-08-31	1990-08-31 00:00:00	\N	38000177		0	0	0		0	0	0	33931	0	897718	40171902		
57381	4760	19059056	1964-07-13	1964-07-13 00:00:00	1964-08-12	1964-08-12 00:00:00	1964-08-12	38000177		0	0	30		0	0	0	317195	0	243670	19059056		
57433	4764	19059056	1971-01-08	1971-01-08 00:00:00	1971-01-22	1971-01-22 00:00:00	1971-01-22	38000177		0	0	14		0	0	0	317504	0	243670	19059056		
51022	4239	1713671	1968-10-27	1968-10-27 00:00:00	1968-11-24	1968-11-24 00:00:00	1968-11-24	38000177		0	0	28		0	0	0	281469	0	562251	1713671		
184539	4055	40213160	1969-04-16	1969-04-16 00:00:00	1969-04-16	1969-04-16 00:00:00	1969-04-16	581452		0	0	0		0	0	0	269520	0	10	40213160		
176670	3884	40213296	2014-02-10	2014-02-10 00:00:00	2014-02-10	2014-02-10 00:00:00	2014-02-10	581452		0	0	0		0	0	0	258021	0	52	40213296		
26330	2166	1127433	1970-12-13	1970-12-13 00:00:00	1970-12-20	1970-12-20 00:00:00	1970-12-20	38000177		0	0	7		0	0	0	144286	0	313782	1127433		
145203	3191	40213296	2000-06-01	2000-06-01 00:00:00	2000-06-01	2000-06-01 00:00:00	2000-06-01	581452		0	0	0		0	0	0	212401	0	52	40213296		
202909	4454	40213227	2011-11-05	2011-11-05 00:00:00	2011-11-05	2011-11-05 00:00:00	2011-11-05	581452		0	0	0		0	0	0	296379	0	113	40213227		
17737	1468	19078461	1989-06-18	1989-06-18 00:00:00	1989-07-23	1989-07-23 00:00:00	1989-07-23	38000177		0	0	35		0	0	0	97875	0	310965	19078461		
136156	2989	40213160	1955-06-01	1955-06-01 00:00:00	1955-06-01	1955-06-01 00:00:00	1955-06-01	581452		0	0	0		0	0	0	199541	0	10	40213160		
206063	4522	40213251	1984-01-06	1984-01-06 00:00:00	1984-01-06	1984-01-06 00:00:00	1984-01-06	581452		0	0	0		0	0	0	301124	0	21	40213251		
9064	755	1713671	1965-07-21	1965-07-21 00:00:00	1965-08-04	1965-08-04 00:00:00	1965-08-04	38000177		0	0	14		0	0	0	50100	0	562251	1713671		
55765	4630	1127433	2009-09-17	2009-09-17 00:00:00	2009-10-01	2009-10-01 00:00:00	2009-10-01	38000177		0	0	14		0	0	0	308485	0	313782	1127433		
121443	2669	40213296	2018-04-11	2018-04-11 00:00:00	2018-04-11	2018-04-11 00:00:00	2018-04-11	581452		0	0	0		0	0	0	176798	0	52	40213296		
46747	1021	40213201	2019-03-14	2019-03-14 00:00:00	2019-03-14	2019-03-14 00:00:00	2019-03-14	581452		0	0	0		0	0	0	67152	0	33	40213201		
7840	655	1713671	1972-10-10	1972-10-10 00:00:00	1972-10-31	1972-10-31 00:00:00	1972-10-31	38000177		0	0	21		0	0	0	43399	0	562251	1713671		
222338	4881	40213227	2009-09-13	2009-09-13 00:00:00	2009-09-13	2009-09-13 00:00:00	2009-09-13	581452		0	0	0		0	0	0	324563	0	113	40213227		
136772	3002	40213227	1995-09-05	1995-09-05 00:00:00	1995-09-05	1995-09-05 00:00:00	1995-09-05	581452		0	0	0		0	0	0	200375	0	113	40213227		
35938	2959	1127433	1993-02-24	1993-02-24 00:00:00	1993-03-10	1993-03-10 00:00:00	1993-03-10	38000177		0	0	14		0	0	0	197538	0	313782	1127433		
34961	2886	1713671	1999-02-27	1999-02-27 00:00:00	1999-03-06	1999-03-06 00:00:00	1999-03-06	38000177		0	0	7		0	0	0	191916	0	562251	1713671		
77013	1683	40213160	1976-07-01	1976-07-01 00:00:00	1976-07-01	1976-07-01 00:00:00	1976-07-01	581452		0	0	0		0	0	0	112824	0	10	40213160		
14244	1194	19133873	1972-05-25	1972-05-25 00:00:00	1972-06-03	1972-06-03 00:00:00	1972-06-03	38000177		0	0	9		0	0	0	78727	0	834061	19133873		
77109	1685	40213227	2011-12-11	2011-12-11 00:00:00	2011-12-11	2011-12-11 00:00:00	2011-12-11	581452		0	0	0		0	0	0	112906	0	113	40213227		
57146	1250	40213227	2004-03-29	2004-03-29 00:00:00	2004-03-29	2004-03-29 00:00:00	2004-03-29	581452		0	0	0		0	0	0	82357	0	113	40213227		
43114	3572	19075601	2014-04-09	2014-04-09 00:00:00	2014-04-09	2014-04-09 00:00:00	2014-04-09	38000177		0	0	0		0	0	0	237477	0	309362	19075601		
222235	4878	40213160	1963-09-14	1963-09-14 00:00:00	1963-09-14	1963-09-14 00:00:00	1963-09-14	581452		0	0	0		0	0	0	324415	0	10	40213160		
61956	1353	40213227	1997-03-10	1997-03-10 00:00:00	1997-03-10	1997-03-10 00:00:00	1997-03-10	581452		0	0	0		0	0	0	89656	0	113	40213227		
34275	2832	19128065	1981-02-04	1981-02-04 00:00:00	1982-01-30	1982-01-30 00:00:00	1982-01-30	38000177		0	0	360		0	0	0	187911	0	749882	19128065		
178053	3913	40213227	1994-06-16	1994-06-16 00:00:00	1994-06-16	1994-06-16 00:00:00	1994-06-16	581452		0	0	0		0	0	0	260107	0	113	40213227		
219458	4816	40213314	1982-04-19	1982-04-19 00:00:00	1982-04-19	1982-04-19 00:00:00	1982-04-19	581452		0	0	0		0	0	0	320406	0	49	40213314		
163802	3603	40213296	2006-06-25	2006-06-25 00:00:00	2006-06-25	2006-06-25 00:00:00	2006-06-25	581452		0	0	0		0	0	0	239439	0	52	40213296		
189492	4160	40213306	1985-07-04	1985-07-04 00:00:00	1985-07-04	1985-07-04 00:00:00	1985-07-04	581452		0	0	0		0	0	0	276465	0	43	40213306		
17291	1433	920300	2019-02-13	2019-02-13 00:00:00	2019-02-20	2019-02-20 00:00:00	2019-02-20	38000177		0	0	7		0	0	0	95444	0	311989	920300		
242974	5334	40213296	2006-01-18	2006-01-18 00:00:00	2006-01-18	2006-01-18 00:00:00	2006-01-18	581452		0	0	0		0	0	0	355175	0	52	40213296		
66897	1464	40213227	1994-10-26	1994-10-26 00:00:00	1994-10-26	1994-10-26 00:00:00	1994-10-26	581452		0	0	0		0	0	0	97562	0	113	40213227		
57817	4804	19133873	1990-04-13	1990-04-13 00:00:00	1990-04-24	1990-04-24 00:00:00	1990-04-24	38000177		0	0	11		0	0	0	319565	0	834061	19133873		
52760	4384	19133905	1991-10-03	1991-10-03 00:00:00	1991-10-15	1991-10-15 00:00:00	1991-10-15	38000177		0	0	12		0	0	0	291419	0	834102	19133905		
211580	4639	40213227	1992-04-24	1992-04-24 00:00:00	1992-04-24	1992-04-24 00:00:00	1992-04-24	581452		0	0	0		0	0	0	309242	0	113	40213227		
196789	4324	40213260	2011-06-12	2011-06-12 00:00:00	2011-06-12	2011-06-12 00:00:00	2011-06-12	581452		0	0	0		0	0	0	286824	0	121	40213260		
196822	4325	40213260	2016-09-06	2016-09-06 00:00:00	2016-09-06	2016-09-06 00:00:00	2016-09-06	581452		0	0	0		0	0	0	286878	0	121	40213260		
56464	4685	19133873	1953-10-01	1953-10-01 00:00:00	1953-10-09	1953-10-09 00:00:00	1953-10-09	38000177		0	0	8		0	0	0	312101	0	834061	19133873		
219371	4814	40213201	2002-05-27	2002-05-27 00:00:00	2002-05-27	2002-05-27 00:00:00	2002-05-27	581452		0	0	0		0	0	0	320288	0	33	40213201		
43643	3616	19059056	1964-02-13	1964-02-13 00:00:00	1964-02-27	1964-02-27 00:00:00	1964-02-27	38000177		0	0	14		0	0	0	240264	0	243670	19059056		
29935	652	40213227	2009-12-22	2009-12-22 00:00:00	2009-12-22	2009-12-22 00:00:00	2009-12-22	581452		0	0	0		0	0	0	43139	0	113	40213227		
216965	4760	40213260	2006-11-08	2006-11-08 00:00:00	2006-11-08	2006-11-08 00:00:00	2006-11-08	581452		0	0	0		0	0	0	317205	0	121	40213260		
4212	350	1127078	1961-12-06	1961-12-06 00:00:00	1961-12-20	1961-12-20 00:00:00	1961-12-20	38000177		0	0	14		0	0	0	23327	0	282464	1127078		
173159	3807	40213227	1998-07-18	1998-07-18 00:00:00	1998-07-18	1998-07-18 00:00:00	1998-07-18	581452		0	0	0		0	0	0	252992	0	113	40213227		
127253	2798	40213160	1955-09-18	1955-09-18 00:00:00	1955-09-18	1955-09-18 00:00:00	1955-09-18	581452		0	0	0		0	0	0	185418	0	10	40213160		
125955	2771	40213227	1992-04-10	1992-04-10 00:00:00	1992-04-10	1992-04-10 00:00:00	1992-04-10	581452		0	0	0		0	0	0	183422	0	113	40213227		
18838	1556	1551192	1973-09-25	1973-09-25 00:00:00	1973-09-25	1973-09-25 00:00:00	1973-09-25	38000177		0	0	0		0	0	0	104147	0	312617	1551192		
195389	4291	40213314	1977-10-28	1977-10-28 00:00:00	1977-10-28	1977-10-28 00:00:00	1977-10-28	581452		0	0	0		0	0	0	284886	0	49	40213314		
112770	2477	40213260	2007-03-11	2007-03-11 00:00:00	2007-03-11	2007-03-11 00:00:00	2007-03-11	581452		0	0	0		0	0	0	164137	0	121	40213260		
137711	3023	40213160	1986-10-04	1986-10-04 00:00:00	1986-10-04	1986-10-04 00:00:00	1986-10-04	581452		0	0	0		0	0	0	201527	0	10	40213160		
93597	2054	40213227	2013-07-04	2013-07-04 00:00:00	2013-07-04	2013-07-04 00:00:00	2013-07-04	581452		0	0	0		0	0	0	136639	0	113	40213227		
19805	1627	1713671	1978-08-15	1978-08-15 00:00:00	1978-08-29	1978-08-29 00:00:00	1978-08-29	38000177		0	0	14		0	0	0	109367	0	562251	1713671		
99382	2176	40213296	1998-10-05	1998-10-05 00:00:00	1998-10-05	1998-10-05 00:00:00	1998-10-05	581452		0	0	0		0	0	0	145152	0	52	40213296		
191781	4214	40213160	1973-05-08	1973-05-08 00:00:00	1973-05-08	1973-05-08 00:00:00	1973-05-08	581452		0	0	0		0	0	0	279765	0	10	40213160		
40633	3370	19006318	1977-05-01	1977-05-01 00:00:00	1977-05-15	1977-05-15 00:00:00	1977-05-15	38000177		0	0	14		0	0	0	223488	0	105078	19006318		
153626	3381	40213160	1976-11-15	1976-11-15 00:00:00	1976-11-15	1976-11-15 00:00:00	1976-11-15	581452		0	0	0		0	0	0	224396	0	10	40213160		
168494	3703	40213227	2010-12-04	2010-12-04 00:00:00	2010-12-04	2010-12-04 00:00:00	2010-12-04	581452		0	0	0		0	0	0	246273	0	113	40213227		
191600	4210	40213306	1997-07-19	1997-07-19 00:00:00	1997-07-19	1997-07-19 00:00:00	1997-07-19	581452		0	0	0		0	0	0	279534	0	43	40213306		
51277	4260	19059056	1941-05-14	1941-05-14 00:00:00	1941-05-28	1941-05-28 00:00:00	1941-05-28	38000177		0	0	14		0	0	0	282839	0	243670	19059056		
43755	3625	40163554	2012-09-04	2012-09-04 00:00:00	2012-09-04	2012-09-04 00:00:00	\N	38000177		0	0	0		0	0	0	241072	0	855332	40163554		
6066	507	40163554	1990-08-31	1990-08-31 00:00:00	1990-08-31	1990-08-31 00:00:00	\N	38000177		0	0	0		0	0	0	33931	0	855332	40163554		
57382	4760	40229134	1974-12-08	1974-12-08 00:00:00	1974-12-22	1974-12-22 00:00:00	1974-12-22	38000177		0	0	14		0	0	0	317143	0	1043400	40229134		
57434	4764	19006318	1971-01-08	1971-01-08 00:00:00	1971-01-22	1971-01-22 00:00:00	1971-01-22	38000177		0	0	14		0	0	0	317504	0	105078	19006318		
51023	4239	19059056	1958-02-03	1958-02-03 00:00:00	1958-05-04	1958-05-04 00:00:00	1958-05-04	38000177		0	0	90		0	0	0	281502	0	243670	19059056		
184543	4055	40213160	1973-10-17	1973-10-17 00:00:00	1973-10-17	1973-10-17 00:00:00	1973-10-17	581452		0	0	0		0	0	0	269524	0	10	40213160		
176673	3884	40213227	2014-02-10	2014-02-10 00:00:00	2014-02-10	2014-02-10 00:00:00	2014-02-10	581452		0	0	0		0	0	0	258021	0	113	40213227		
26331	2166	40229134	2001-06-13	2001-06-13 00:00:00	2001-06-27	2001-06-27 00:00:00	2001-06-27	38000177		0	0	14		0	0	0	144291	0	1043400	40229134		
145209	3191	40213296	1998-05-28	1998-05-28 00:00:00	1998-05-28	1998-05-28 00:00:00	1998-05-28	581452		0	0	0		0	0	0	212369	0	52	40213296		
15567	335	40213160	1964-02-25	1964-02-25 00:00:00	1964-02-25	1964-02-25 00:00:00	1964-02-25	581452		0	0	0		0	0	0	22284	0	10	40213160		
17738	1468	1127078	1958-09-26	1958-09-26 00:00:00	1958-10-10	1958-10-10 00:00:00	1958-10-10	38000177		0	0	14		0	0	0	97887	0	282464	1127078		
136157	2989	40213296	1996-12-11	1996-12-11 00:00:00	1996-12-11	1996-12-11 00:00:00	1996-12-11	581452		0	0	0		0	0	0	199524	0	52	40213296		
206070	4523	40213314	1977-07-03	1977-07-03 00:00:00	1977-07-03	1977-07-03 00:00:00	1977-07-03	581452		0	0	0		0	0	0	301166	0	49	40213314		
9065	755	1127078	1950-07-19	1950-07-19 00:00:00	1950-08-23	1950-08-23 00:00:00	1950-08-23	38000177		0	0	35		0	0	0	50102	0	282464	1127078		
55766	4630	1127433	2012-01-15	2012-01-15 00:00:00	2012-01-22	2012-01-22 00:00:00	2012-01-22	38000177		0	0	7		0	0	0	308511	0	313782	1127433		
121444	2669	40213314	1977-03-16	1977-03-16 00:00:00	1977-03-16	1977-03-16 00:00:00	1977-03-16	581452		0	0	0		0	0	0	176790	0	49	40213314		
46752	1021	40213160	1956-05-17	1956-05-17 00:00:00	1956-05-17	1956-05-17 00:00:00	1956-05-17	581452		0	0	0		0	0	0	67175	0	10	40213160		
7841	655	40236824	1986-01-08	1986-01-08 00:00:00	1986-01-15	1986-01-15 00:00:00	1986-01-15	38000177		0	0	7		0	0	0	43366	0	1094107	40236824		
222341	4881	40213227	1999-07-18	1999-07-18 00:00:00	1999-07-18	1999-07-18 00:00:00	1999-07-18	581452		0	0	0		0	0	0	324549	0	113	40213227		
136773	3002	40213306	1995-09-05	1995-09-05 00:00:00	1995-09-05	1995-09-05 00:00:00	1995-09-05	581452		0	0	0		0	0	0	200375	0	43	40213306		
35939	2959	1124300	2009-12-27	2009-12-27 00:00:00	2009-12-27	2009-12-27 00:00:00	\N	38000177		0	0	0		0	0	0	197597	0	00781178901	45011828		
12975	1091	40229134	1973-12-25	1973-12-25 00:00:00	1974-01-08	1974-01-08 00:00:00	1974-01-08	38000177		0	0	14		0	0	0	71679	0	1043400	40229134		
77019	1683	40213227	1993-12-02	1993-12-02 00:00:00	1993-12-02	1993-12-02 00:00:00	1993-12-02	581452		0	0	0		0	0	0	112781	0	113	40213227		
14245	1194	19078461	1978-09-15	1978-09-15 00:00:00	1978-10-06	1978-10-06 00:00:00	1978-10-06	38000177		0	0	21		0	0	0	78687	0	310965	19078461		
77115	1685	40213227	2002-12-01	2002-12-01 00:00:00	2002-12-01	2002-12-01 00:00:00	2002-12-01	581452		0	0	0		0	0	0	112903	0	113	40213227		
114091	2507	40213260	2019-04-16	2019-04-16 00:00:00	2019-04-16	2019-04-16 00:00:00	2019-04-16	581452		0	0	0		0	0	0	165963	0	121	40213260		
43115	3572	40220960	2014-04-09	2014-04-09 00:00:00	2014-04-09	2014-04-09 00:00:00	2014-04-09	38000177		0	0	0		0	0	0	237477	0	1804799	40220960		
222237	4878	40213227	2004-09-11	2004-09-11 00:00:00	2004-09-11	2004-09-11 00:00:00	2004-09-11	581452		0	0	0		0	0	0	324327	0	113	40213227		
61962	1353	40213160	1955-06-06	1955-06-06 00:00:00	1955-06-06	1955-06-06 00:00:00	1955-06-06	581452		0	0	0		0	0	0	89633	0	10	40213160		
34276	2832	19128065	1979-02-11	1979-02-11 00:00:00	1980-02-06	1980-02-06 00:00:00	1980-02-06	38000177		0	0	360		0	0	0	187939	0	749882	19128065		
178054	3913	40213160	1963-06-27	1963-06-27 00:00:00	1963-06-27	1963-06-27 00:00:00	1963-06-27	581452		0	0	0		0	0	0	260101	0	10	40213160		
219464	4816	40213160	1982-02-15	1982-02-15 00:00:00	1982-02-15	1982-02-15 00:00:00	1982-02-15	581452		0	0	0		0	0	0	320443	0	10	40213160		
163803	3603	40213160	1966-05-15	1966-05-15 00:00:00	1966-05-15	1966-05-15 00:00:00	1966-05-15	581452		0	0	0		0	0	0	239324	0	10	40213160		
189501	4160	40213160	1967-04-06	1967-04-06 00:00:00	1967-04-06	1967-04-06 00:00:00	1967-04-06	581452		0	0	0		0	0	0	276400	0	10	40213160		
17292	1433	40236824	2019-02-13	2019-02-13 00:00:00	2019-02-20	2019-02-20 00:00:00	2019-02-20	38000177		0	0	7		0	0	0	95444	0	1094107	40236824		
242975	5334	40213160	1968-12-18	1968-12-18 00:00:00	1968-12-18	1968-12-18 00:00:00	1968-12-18	581452		0	0	0		0	0	0	355220	0	10	40213160		
204930	4498	40213314	1977-08-30	1977-08-30 00:00:00	1977-08-30	1977-08-30 00:00:00	1977-08-30	581452		0	0	0		0	0	0	299458	0	49	40213314		
57818	4804	19128022	1994-03-02	1994-03-02 00:00:00	1995-02-25	1995-02-25 00:00:00	1995-02-25	38000177		0	0	360		0	0	0	319647	0	749785	19128022		
52761	4384	1127078	1968-03-12	1968-03-12 00:00:00	1968-03-26	1968-03-26 00:00:00	1968-03-26	38000177		0	0	14		0	0	0	291361	0	282464	1127078		
211583	4639	40213227	2001-05-04	2001-05-04 00:00:00	2001-05-04	2001-05-04 00:00:00	2001-05-04	581452		0	0	0		0	0	0	309221	0	113	40213227		
196793	4324	40213296	2001-09-30	2001-09-30 00:00:00	2001-09-30	2001-09-30 00:00:00	2001-09-30	581452		0	0	0		0	0	0	286820	0	52	40213296		
196823	4325	40213160	1965-11-30	1965-11-30 00:00:00	1965-11-30	1965-11-30 00:00:00	1965-11-30	581452		0	0	0		0	0	0	286900	0	10	40213160		
56465	4685	920300	1974-10-12	1974-10-12 00:00:00	1974-10-19	1974-10-19 00:00:00	1974-10-19	38000177		0	0	7		0	0	0	312121	0	311989	920300		
96458	2115	40213160	1962-03-05	1962-03-05 00:00:00	1962-03-05	1962-03-05 00:00:00	1962-03-05	581452		0	0	0		0	0	0	140713	0	10	40213160		
43644	3618	1127433	1943-03-21	1943-03-21 00:00:00	1943-03-28	1943-03-28 00:00:00	1943-03-28	38000177		0	0	7		0	0	0	240425	0	313782	1127433		
29940	652	40213160	1968-05-21	1968-05-21 00:00:00	1968-05-21	1968-05-21 00:00:00	1968-05-21	581452		0	0	0		0	0	0	43146	0	10	40213160		
205324	4506	40213227	2015-02-26	2015-02-26 00:00:00	2015-02-26	2015-02-26 00:00:00	2015-02-26	581452		0	0	0		0	0	0	300202	0	113	40213227		
4213	350	19059056	1965-05-19	1965-05-19 00:00:00	1965-06-02	1965-06-02 00:00:00	1965-06-02	38000177		0	0	14		0	0	0	23289	0	243670	19059056		
173178	3807	40213227	2018-01-13	2018-01-13 00:00:00	2018-01-13	2018-01-13 00:00:00	2018-01-13	581452		0	0	0		0	0	0	253015	0	113	40213227		
127256	2798	40213227	2015-09-20	2015-09-20 00:00:00	2015-09-20	2015-09-20 00:00:00	2015-09-20	581452		0	0	0		0	0	0	185426	0	113	40213227		
81081	1773	40213227	1993-09-05	1993-09-05 00:00:00	1993-09-05	1993-09-05 00:00:00	1993-09-05	581452		0	0	0		0	0	0	118491	0	113	40213227		
18839	1556	1713671	1985-02-19	1985-02-19 00:00:00	1985-03-05	1985-03-05 00:00:00	1985-03-05	38000177		0	0	14		0	0	0	104225	0	562251	1713671		
195393	4291	40213296	2015-12-04	2015-12-04 00:00:00	2015-12-04	2015-12-04 00:00:00	2015-12-04	581452		0	0	0		0	0	0	284903	0	52	40213296		
87923	1929	40213160	1955-01-27	1955-01-27 00:00:00	1955-01-27	1955-01-27 00:00:00	1955-01-27	581452		0	0	0		0	0	0	128397	0	10	40213160		
137713	3023	40213251	1984-03-31	1984-03-31 00:00:00	1984-03-31	1984-03-31 00:00:00	1984-03-31	581452		0	0	0		0	0	0	201542	0	21	40213251		
93600	2054	40213296	2011-06-30	2011-06-30 00:00:00	2011-06-30	2011-06-30 00:00:00	2011-06-30	581452		0	0	0		0	0	0	136659	0	52	40213296		
19806	1627	1713671	2002-10-25	2002-10-25 00:00:00	2002-11-08	2002-11-08 00:00:00	2002-11-08	38000177		0	0	14		0	0	0	109369	0	562251	1713671		
99390	2176	40213227	2017-10-23	2017-10-23 00:00:00	2017-10-23	2017-10-23 00:00:00	2017-10-23	581452		0	0	0		0	0	0	145135	0	113	40213227		
191788	4214	40213227	2004-03-02	2004-03-02 00:00:00	2004-03-02	2004-03-02 00:00:00	2004-03-02	581452		0	0	0		0	0	0	279767	0	113	40213227		
40634	3370	1127433	2003-05-17	2003-05-17 00:00:00	2003-05-31	2003-05-31 00:00:00	2003-05-31	38000177		0	0	14		0	0	0	223403	0	313782	1127433		
153635	3382	40213160	1962-05-24	1962-05-24 00:00:00	1962-05-24	1962-05-24 00:00:00	1962-05-24	581452		0	0	0		0	0	0	224456	0	10	40213160		
168495	3703	40213296	2010-12-04	2010-12-04 00:00:00	2010-12-04	2010-12-04 00:00:00	2010-12-04	581452		0	0	0		0	0	0	246273	0	52	40213296		
191603	4210	40213160	1975-12-13	1975-12-13 00:00:00	1975-12-13	1975-12-13 00:00:00	1975-12-13	581452		0	0	0		0	0	0	279544	0	10	40213160		
51278	4260	19133905	1959-12-04	1959-12-04 00:00:00	1959-12-11	1959-12-11 00:00:00	1959-12-11	38000177		0	0	7		0	0	0	282754	0	834102	19133905		
43756	3625	1127078	1955-03-06	1955-03-06 00:00:00	1955-04-10	1955-04-10 00:00:00	1955-04-10	38000177		0	0	35		0	0	0	241055	0	282464	1127078		
6067	507	19059056	1943-06-24	1943-06-24 00:00:00	1943-07-08	1943-07-08 00:00:00	1943-07-08	38000177		0	0	14		0	0	0	33903	0	243670	19059056		
57383	4760	1118084	1995-03-06	1995-03-06 00:00:00	1995-03-06	1995-03-06 00:00:00	\N	38000177		0	0	0		0	0	0	317152	0	00025152531	44923712		
57435	4764	1713671	1999-06-17	1999-06-17 00:00:00	1999-07-08	1999-07-08 00:00:00	1999-07-08	38000177		0	0	21		0	0	0	317517	0	562251	1713671		
51024	4239	1127433	2001-09-22	2001-09-22 00:00:00	2001-10-13	2001-10-13 00:00:00	2001-10-13	38000177		0	0	21		0	0	0	281508	0	313782	1127433		
184546	4055	40213260	2019-01-16	2019-01-16 00:00:00	2019-01-16	2019-01-16 00:00:00	2019-01-16	581452		0	0	0		0	0	0	269567	0	121	40213260		
183226	4026	40213160	1958-10-05	1958-10-05 00:00:00	1958-10-05	1958-10-05 00:00:00	1958-10-05	581452		0	0	0		0	0	0	267749	0	10	40213160		
26332	2166	19133873	1978-05-26	1978-05-26 00:00:00	1978-06-05	1978-06-05 00:00:00	1978-06-05	38000177		0	0	10		0	0	0	144304	0	834061	19133873		
145212	3191	40213160	1958-03-06	1958-03-06 00:00:00	1958-03-06	1958-03-06 00:00:00	1958-03-06	581452		0	0	0		0	0	0	212393	0	10	40213160		
15571	335	40213306	1986-11-04	1986-11-04 00:00:00	1986-11-04	1986-11-04 00:00:00	1986-11-04	581452		0	0	0		0	0	0	22230	0	43	40213306		
28221	2333	40229134	1997-10-03	1997-10-03 00:00:00	1997-10-10	1997-10-10 00:00:00	1997-10-10	38000177		0	0	7		0	0	0	155207	0	1043400	40229134		
136159	2989	40213227	1996-12-11	1996-12-11 00:00:00	1996-12-11	1996-12-11 00:00:00	1996-12-11	581452		0	0	0		0	0	0	199524	0	113	40213227		
206071	4523	40213296	2016-01-31	2016-01-31 00:00:00	2016-01-31	2016-01-31 00:00:00	2016-01-31	581452		0	0	0		0	0	0	301151	0	52	40213296		
9066	755	40165015	1970-08-08	1970-08-08 00:00:00	1970-08-08	1970-08-08 00:00:00	\N	38000177		0	0	0		0	0	0	50007	0	861467	40165015		
55767	4630	40229134	1985-08-20	1985-08-20 00:00:00	1985-09-03	1985-09-03 00:00:00	1985-09-03	38000177		0	0	14		0	0	0	308509	0	1043400	40229134		
121445	2669	40213160	1977-03-16	1977-03-16 00:00:00	1977-03-16	1977-03-16 00:00:00	1977-03-16	581452		0	0	0		0	0	0	176790	0	10	40213160		
114949	2526	40213314	1977-11-28	1977-11-28 00:00:00	1977-11-28	1977-11-28 00:00:00	1977-11-28	581452		0	0	0		0	0	0	167011	0	49	40213314		
7842	655	920300	1986-01-08	1986-01-08 00:00:00	1986-01-15	1986-01-15 00:00:00	1986-01-15	38000177		0	0	7		0	0	0	43366	0	311989	920300		
224825	4935	40213296	2005-11-10	2005-11-10 00:00:00	2005-11-10	2005-11-10 00:00:00	2005-11-10	581452		0	0	0		0	0	0	328050	0	52	40213296		
136777	3002	40213160	1974-03-12	1974-03-12 00:00:00	1974-03-12	1974-03-12 00:00:00	1974-03-12	581452		0	0	0		0	0	0	200352	0	10	40213160		
35940	2959	1551192	1972-05-15	1972-05-15 00:00:00	1972-05-15	1972-05-15 00:00:00	1972-05-15	38000177		0	0	0		0	0	0	197601	0	312617	1551192		
12977	1091	40236824	1999-06-26	1999-06-26 00:00:00	1999-07-03	1999-07-03 00:00:00	1999-07-03	38000177		0	0	7		0	0	0	71627	0	1094107	40236824		
77020	1683	40213306	1993-12-02	1993-12-02 00:00:00	1993-12-02	1993-12-02 00:00:00	1993-12-02	581452		0	0	0		0	0	0	112781	0	43	40213306		
14246	1194	19133873	1963-11-15	1963-11-15 00:00:00	1963-11-25	1963-11-25 00:00:00	1963-11-25	38000177		0	0	10		0	0	0	78725	0	834061	19133873		
77116	1685	40213306	2002-12-01	2002-12-01 00:00:00	2002-12-01	2002-12-01 00:00:00	2002-12-01	581452		0	0	0		0	0	0	112903	0	43	40213306		
114093	2507	40213160	1967-08-08	1967-08-08 00:00:00	1967-08-08	1967-08-08 00:00:00	1967-08-08	581452		0	0	0		0	0	0	165981	0	10	40213160		
43116	3572	19059056	1956-11-16	1956-11-16 00:00:00	1956-11-30	1956-11-30 00:00:00	1956-11-30	38000177		0	0	14		0	0	0	237464	0	243670	19059056		
222238	4878	40213296	2004-09-11	2004-09-11 00:00:00	2004-09-11	2004-09-11 00:00:00	2004-09-11	581452		0	0	0		0	0	0	324327	0	52	40213296		
61964	1354	40213306	2000-10-13	2000-10-13 00:00:00	2000-10-13	2000-10-13 00:00:00	2000-10-13	581452		0	0	0		0	0	0	89713	0	43	40213306		
34277	2832	40165015	2003-04-26	2003-04-26 00:00:00	2003-04-26	2003-04-26 00:00:00	\N	38000177		0	0	0		0	0	0	187902	0	861467	40165015		
238956	5245	40213314	1977-06-05	1977-06-05 00:00:00	1977-06-05	1977-06-05 00:00:00	1977-06-05	581452		0	0	0		0	0	0	348997	0	49	40213314		
219465	4816	40213314	1982-02-15	1982-02-15 00:00:00	1982-02-15	1982-02-15 00:00:00	1982-02-15	581452		0	0	0		0	0	0	320443	0	49	40213314		
189268	4156	40213296	1996-10-28	1996-10-28 00:00:00	1996-10-28	1996-10-28 00:00:00	1996-10-28	581452		0	0	0		0	0	0	276208	0	52	40213296		
189502	4160	40213227	1994-05-26	1994-05-26 00:00:00	1994-05-26	1994-05-26 00:00:00	1994-05-26	581452		0	0	0		0	0	0	276446	0	113	40213227		
17293	1433	40229134	1980-07-12	1980-07-12 00:00:00	1980-07-26	1980-07-26 00:00:00	1980-07-26	38000177		0	0	14		0	0	0	95468	0	1043400	40229134		
242982	5334	40213227	1997-11-26	1997-11-26 00:00:00	1997-11-26	1997-11-26 00:00:00	1997-11-26	581452		0	0	0		0	0	0	355174	0	113	40213227		
204931	4498	40213160	1977-08-30	1977-08-30 00:00:00	1977-08-30	1977-08-30 00:00:00	1977-08-30	581452		0	0	0		0	0	0	299458	0	10	40213160		
17376	376	40213160	1961-10-05	1961-10-05 00:00:00	1961-10-05	1961-10-05 00:00:00	1961-10-05	581452		0	0	0		0	0	0	24927	0	10	40213160		
52762	4384	1713671	1975-09-04	1975-09-04 00:00:00	1975-09-18	1975-09-18 00:00:00	1975-09-18	38000177		0	0	14		0	0	0	291405	0	562251	1713671		
211589	4639	40213296	2010-02-26	2010-02-26 00:00:00	2010-02-26	2010-02-26 00:00:00	2010-02-26	581452		0	0	0		0	0	0	309219	0	52	40213296		
196794	4324	40213160	1961-09-17	1961-09-17 00:00:00	1961-09-17	1961-09-17 00:00:00	1961-09-17	581452		0	0	0		0	0	0	286853	0	10	40213160		
196829	4325	40213296	2008-07-01	2008-07-01 00:00:00	2008-07-01	2008-07-01 00:00:00	2008-07-01	581452		0	0	0		0	0	0	286908	0	52	40213296		
56466	4685	40236824	1974-10-12	1974-10-12 00:00:00	1974-10-19	1974-10-19 00:00:00	1974-10-19	38000177		0	0	7		0	0	0	312121	0	1094107	40236824		
96461	2115	40213296	2001-10-01	2001-10-01 00:00:00	2001-10-01	2001-10-01 00:00:00	2001-10-01	581452		0	0	0		0	0	0	140699	0	52	40213296		
43645	3618	19059056	1926-12-22	1926-12-22 00:00:00	1927-01-19	1927-01-19 00:00:00	1927-01-19	38000177		0	0	28		0	0	0	240396	0	243670	19059056		
29951	653	40213227	1994-11-25	1994-11-25 00:00:00	1994-11-25	1994-11-25 00:00:00	1994-11-25	581452		0	0	0		0	0	0	43238	0	113	40213227		
205327	4506	40213260	2006-01-05	2006-01-05 00:00:00	2006-01-05	2006-01-05 00:00:00	2006-01-05	581452		0	0	0		0	0	0	300232	0	121	40213260		
4214	350	19133873	1972-07-07	1972-07-07 00:00:00	1972-07-19	1972-07-19 00:00:00	1972-07-19	38000177		0	0	12		0	0	0	23299	0	834061	19133873		
86030	1885	40213296	2016-11-29	2016-11-29 00:00:00	2016-11-29	2016-11-29 00:00:00	2016-11-29	581452		0	0	0		0	0	0	125676	0	52	40213296		
205470	4509	40213160	1968-05-07	1968-05-07 00:00:00	1968-05-07	1968-05-07 00:00:00	1968-05-07	581452		0	0	0		0	0	0	300377	0	10	40213160		
81085	1773	40213227	2012-08-26	2012-08-26 00:00:00	2012-08-26	2012-08-26 00:00:00	2012-08-26	581452		0	0	0		0	0	0	118594	0	113	40213227		
18840	1556	43012754	1991-03-05	1991-03-05 00:00:00	1992-02-28	1992-02-28 00:00:00	1992-02-28	38000177		0	0	360		0	0	0	104252	0	1366343	43012754		
195395	4291	40213227	2015-12-04	2015-12-04 00:00:00	2015-12-04	2015-12-04 00:00:00	2015-12-04	581452		0	0	0		0	0	0	284903	0	113	40213227		
87927	1929	40213227	1996-01-25	1996-01-25 00:00:00	1996-01-25	1996-01-25 00:00:00	1996-01-25	581452		0	0	0		0	0	0	128447	0	113	40213227		
137714	3023	40213251	1986-10-04	1986-10-04 00:00:00	1986-10-04	1986-10-04 00:00:00	1986-10-04	581452		0	0	0		0	0	0	201527	0	21	40213251		
93602	2054	40213227	2003-03-06	2003-03-06 00:00:00	2003-03-06	2003-03-06 00:00:00	2003-03-06	581452		0	0	0		0	0	0	136620	0	113	40213227		
19807	1627	19133873	1965-04-26	1965-04-26 00:00:00	1965-05-08	1965-05-08 00:00:00	1965-05-08	38000177		0	0	12		0	0	0	109329	0	834061	19133873		
99395	2176	40213160	1957-04-29	1957-04-29 00:00:00	1957-04-29	1957-04-29 00:00:00	1957-04-29	581452		0	0	0		0	0	0	145164	0	10	40213160		
191792	4214	40213227	1995-02-21	1995-02-21 00:00:00	1995-02-21	1995-02-21 00:00:00	1995-02-21	581452		0	0	0		0	0	0	279814	0	113	40213227		
40635	3370	19078461	1990-10-09	1990-10-09 00:00:00	1990-10-30	1990-10-30 00:00:00	1990-10-30	38000177		0	0	21		0	0	0	223394	0	310965	19078461		
153644	3382	40213296	2005-10-27	2005-10-27 00:00:00	2005-10-27	2005-10-27 00:00:00	2005-10-27	581452		0	0	0		0	0	0	224409	0	52	40213296		
168498	3703	40213160	1969-03-01	1969-03-01 00:00:00	1969-03-01	1969-03-01 00:00:00	1969-03-01	581452		0	0	0		0	0	0	246193	0	10	40213160		
191607	4210	40213227	2017-04-15	2017-04-15 00:00:00	2017-04-15	2017-04-15 00:00:00	2017-04-15	581452		0	0	0		0	0	0	279532	0	113	40213227		
51279	4261	1127433	1974-01-29	1974-01-29 00:00:00	1974-02-19	1974-02-19 00:00:00	1974-02-19	38000177		0	0	21		0	0	0	282892	0	313782	1127433		
43757	3625	19133873	1965-10-18	1965-10-18 00:00:00	1965-10-30	1965-10-30 00:00:00	1965-10-30	38000177		0	0	12		0	0	0	241035	0	834061	19133873		
6068	507	1713671	1962-08-20	1962-08-20 00:00:00	1962-09-10	1962-09-10 00:00:00	1962-09-10	38000177		0	0	21		0	0	0	33967	0	562251	1713671		
57384	4760	1127433	1971-07-11	1971-07-11 00:00:00	1971-07-25	1971-07-25 00:00:00	1971-07-25	38000177		0	0	14		0	0	0	317175	0	313782	1127433		
57436	4764	1118084	2007-01-29	2007-01-29 00:00:00	2007-01-29	2007-01-29 00:00:00	\N	38000177		0	0	0		0	0	0	317497	0	00025152531	44923712		
51025	4239	40162522	1993-08-05	1993-08-05 00:00:00	1993-08-05	1993-08-05 00:00:00	\N	38000177		0	0	0		0	0	0	281510	0	857005	40162522		
51059	4241	19128022	1989-08-27	1989-08-27 00:00:00	1990-08-22	1990-08-22 00:00:00	1990-08-22	38000177		0	0	360		0	0	0	281731	0	749785	19128022		
183236	4026	40213227	1999-10-31	1999-10-31 00:00:00	1999-10-31	1999-10-31 00:00:00	1999-10-31	581452		0	0	0		0	0	0	267757	0	113	40213227		
26333	2166	19133873	1976-12-16	1976-12-16 00:00:00	1976-12-28	1976-12-28 00:00:00	1976-12-28	38000177		0	0	12		0	0	0	144289	0	834061	19133873		
145215	3191	40213160	1962-09-06	1962-09-06 00:00:00	1962-09-06	1962-09-06 00:00:00	1962-09-06	581452		0	0	0		0	0	0	212396	0	10	40213160		
59857	1310	40213227	1992-03-13	1992-03-13 00:00:00	1992-03-13	1992-03-13 00:00:00	1992-03-13	581452		0	0	0		0	0	0	86596	0	113	40213227		
28222	2333	40229134	1958-09-19	1958-09-19 00:00:00	1958-09-26	1958-09-26 00:00:00	1958-09-26	38000177		0	0	7		0	0	0	155202	0	1043400	40229134		
136162	2989	40213260	2007-07-11	2007-07-11 00:00:00	2007-07-11	2007-07-11 00:00:00	2007-07-11	581452		0	0	0		0	0	0	199539	0	121	40213260		
206073	4523	40213314	1977-01-02	1977-01-02 00:00:00	1977-01-02	1977-01-02 00:00:00	1977-01-02	581452		0	0	0		0	0	0	301178	0	49	40213314		
9067	755	19059056	1970-08-08	1970-08-08 00:00:00	1970-11-06	1970-11-06 00:00:00	1970-11-06	38000177		0	0	90		0	0	0	50007	0	243670	19059056		
55768	4630	40236824	1983-02-24	1983-02-24 00:00:00	1983-03-10	1983-03-10 00:00:00	1983-03-10	38000177		0	0	14		0	0	0	308480	0	1094107	40236824		
121449	2669	40213251	1984-10-10	1984-10-10 00:00:00	1984-10-10	1984-10-10 00:00:00	1984-10-10	581452		0	0	0		0	0	0	176824	0	21	40213251		
114959	2526	40213227	2017-01-02	2017-01-02 00:00:00	2017-01-02	2017-01-02 00:00:00	2017-01-02	581452		0	0	0		0	0	0	167002	0	113	40213227		
7843	656	1127433	2011-05-28	2011-05-28 00:00:00	2011-06-04	2011-06-04 00:00:00	2011-06-04	38000177		0	0	7		0	0	0	43474	0	313782	1127433		
128110	2818	40213227	2000-10-16	2000-10-16 00:00:00	2000-10-16	2000-10-16 00:00:00	2000-10-16	581452		0	0	0		0	0	0	186766	0	113	40213227		
136780	3002	40213160	1973-10-09	1973-10-09 00:00:00	1973-10-09	1973-10-09 00:00:00	1973-10-09	581452		0	0	0		0	0	0	200351	0	10	40213160		
35941	2959	1127433	2018-06-03	2018-06-03 00:00:00	2018-06-17	2018-06-17 00:00:00	2018-06-17	38000177		0	0	14		0	0	0	197584	0	313782	1127433		
12978	1091	920300	1999-06-26	1999-06-26 00:00:00	1999-07-03	1999-07-03 00:00:00	1999-07-03	38000177		0	0	7		0	0	0	71627	0	311989	920300		
77022	1683	40213160	1971-12-30	1971-12-30 00:00:00	1971-12-30	1971-12-30 00:00:00	1971-12-30	581452		0	0	0		0	0	0	112792	0	10	40213160		
14247	1194	19059056	1963-10-18	1963-10-18 00:00:00	1963-11-01	1963-11-01 00:00:00	1963-11-01	38000177		0	0	14		0	0	0	78692	0	243670	19059056		
77119	1685	40213314	1980-05-18	1980-05-18 00:00:00	1980-05-18	1980-05-18 00:00:00	1980-05-18	581452		0	0	0		0	0	0	112916	0	49	40213314		
114094	2507	40213160	1967-10-10	1967-10-10 00:00:00	1967-10-10	1967-10-10 00:00:00	1967-10-10	581452		0	0	0		0	0	0	165997	0	10	40213160		
43117	3572	19006318	1956-11-16	1956-11-16 00:00:00	1956-11-30	1956-11-30 00:00:00	1956-11-30	38000177		0	0	14		0	0	0	237464	0	105078	19006318		
56113	4657	19133873	1972-05-27	1972-05-27 00:00:00	1972-06-05	1972-06-05 00:00:00	1972-06-05	38000177		0	0	9		0	0	0	310503	0	834061	19133873		
61966	1354	40213227	2000-10-13	2000-10-13 00:00:00	2000-10-13	2000-10-13 00:00:00	2000-10-13	581452		0	0	0		0	0	0	89713	0	113	40213227		
34278	2832	1115171	2003-04-26	2003-04-26 00:00:00	2003-07-25	2003-07-25 00:00:00	2003-07-25	38000177		0	0	90		0	0	0	187902	0	849574	1115171		
238957	5245	40213160	1974-04-07	1974-04-07 00:00:00	1974-04-07	1974-04-07 00:00:00	1974-04-07	581452		0	0	0		0	0	0	348977	0	10	40213160		
219470	4816	40213227	2004-01-12	2004-01-12 00:00:00	2004-01-12	2004-01-12 00:00:00	2004-01-12	581452		0	0	0		0	0	0	320421	0	113	40213227		
189279	4156	40213227	1998-11-02	1998-11-02 00:00:00	1998-11-02	1998-11-02 00:00:00	1998-11-02	581452		0	0	0		0	0	0	276189	0	113	40213227		
189508	4160	40213260	2013-06-13	2013-06-13 00:00:00	2013-06-13	2013-06-13 00:00:00	2013-06-13	581452		0	0	0		0	0	0	276468	0	121	40213260		
17294	1433	1127433	1977-04-11	1977-04-11 00:00:00	1977-04-18	1977-04-18 00:00:00	1977-04-18	38000177		0	0	7		0	0	0	95461	0	313782	1127433		
242989	5334	40213160	1964-07-29	1964-07-29 00:00:00	1964-07-29	1964-07-29 00:00:00	1964-07-29	581452		0	0	0		0	0	0	355233	0	10	40213160		
204935	4498	40213160	1978-01-31	1978-01-31 00:00:00	1978-01-31	1978-01-31 00:00:00	1978-01-31	581452		0	0	0		0	0	0	299487	0	10	40213160		
17377	376	40213160	1962-01-04	1962-01-04 00:00:00	1962-01-04	1962-01-04 00:00:00	1962-01-04	581452		0	0	0		0	0	0	24889	0	10	40213160		
52763	4384	1118084	2005-08-25	2005-08-25 00:00:00	2005-08-25	2005-08-25 00:00:00	\N	38000177		0	0	0		0	0	0	291377	0	00025152531	44923712		
211600	4639	40213160	1970-10-30	1970-10-30 00:00:00	1970-10-30	1970-10-30 00:00:00	1970-10-30	581452		0	0	0		0	0	0	309204	0	10	40213160		
196795	4324	40213227	2003-10-05	2003-10-05 00:00:00	2003-10-05	2003-10-05 00:00:00	2003-10-05	581452		0	0	0		0	0	0	286875	0	113	40213227		
196831	4325	40213227	1996-09-10	1996-09-10 00:00:00	1996-09-10	1996-09-10 00:00:00	1996-09-10	581452		0	0	0		0	0	0	\N	0	113	40213227		
56467	4685	19078461	1974-09-24	1974-09-24 00:00:00	1974-10-08	1974-10-08 00:00:00	1974-10-08	38000177		0	0	14		0	0	0	312121	0	310965	19078461		
96464	2115	40213160	1966-09-05	1966-09-05 00:00:00	1966-09-05	1966-09-05 00:00:00	1966-09-05	581452		0	0	0		0	0	0	140742	0	10	40213160		
43646	3618	19059056	1913-07-05	1913-07-05 00:00:00	1913-07-19	1913-07-19 00:00:00	1913-07-19	38000177		0	0	14		0	0	0	240359	0	243670	19059056		
240306	5276	40213160	1958-04-27	1958-04-27 00:00:00	1958-04-27	1958-04-27 00:00:00	1958-04-27	581452		0	0	0		0	0	0	350881	0	10	40213160		
205328	4506	40213160	1955-06-02	1955-06-02 00:00:00	1955-06-02	1955-06-02 00:00:00	1955-06-02	581452		0	0	0		0	0	0	300193	0	10	40213160		
4215	350	19079524	1995-09-11	1995-09-11 00:00:00	1995-09-12	1995-09-12 00:00:00	1995-09-12	38000177		0	0	1		0	0	0	23293	0	313002	19079524		
86035	1885	40213314	1977-02-01	1977-02-01 00:00:00	1977-02-01	1977-02-01 00:00:00	1977-02-01	581452		0	0	0		0	0	0	125706	0	49	40213314		
205473	4509	40213296	2007-09-04	2007-09-04 00:00:00	2007-09-04	2007-09-04 00:00:00	2007-09-04	581452		0	0	0		0	0	0	300399	0	52	40213296		
92372	2027	40213160	1961-06-23	1961-06-23 00:00:00	1961-06-23	1961-06-23 00:00:00	1961-06-23	581452		0	0	0		0	0	0	134881	0	10	40213160		
18841	1556	1118084	2016-05-07	2016-05-07 00:00:00	2016-05-07	2016-05-07 00:00:00	\N	38000177		0	0	0		0	0	0	104166	0	00025152531	44923712		
112311	2468	40213227	1992-09-27	1992-09-27 00:00:00	1992-09-27	1992-09-27 00:00:00	1992-09-27	581452		0	0	0		0	0	0	163661	0	113	40213227		
87928	1929	40213296	1996-01-25	1996-01-25 00:00:00	1996-01-25	1996-01-25 00:00:00	1996-01-25	581452		0	0	0		0	0	0	128447	0	52	40213296		
137720	3023	40213227	2003-12-27	2003-12-27 00:00:00	2003-12-27	2003-12-27 00:00:00	2003-12-27	581452		0	0	0		0	0	0	201509	0	113	40213227		
12135	262	40213296	2006-08-14	2006-08-14 00:00:00	2006-08-14	2006-08-14 00:00:00	2006-08-14	581452		0	0	0		0	0	0	17392	0	52	40213296		
12807	1077	1127433	1999-08-14	1999-08-14 00:00:00	1999-08-28	1999-08-28 00:00:00	1999-08-28	38000177		0	0	14		0	0	0	70642	0	313782	1127433		
99400	2176	40213296	1996-09-30	1996-09-30 00:00:00	1996-09-30	1996-09-30 00:00:00	1996-09-30	581452		0	0	0		0	0	0	145131	0	52	40213296		
191793	4214	40213306	1995-02-21	1995-02-21 00:00:00	1995-02-21	1995-02-21 00:00:00	1995-02-21	581452		0	0	0		0	0	0	279814	0	43	40213306		
40636	3370	1551192	1977-01-31	1977-01-31 00:00:00	1977-01-31	1977-01-31 00:00:00	1977-01-31	38000177		0	0	0		0	0	0	223391	0	312617	1551192		
153652	3382	40213227	2003-10-23	2003-10-23 00:00:00	2003-10-23	2003-10-23 00:00:00	2003-10-23	581452		0	0	0		0	0	0	224433	0	113	40213227		
168503	3703	40213296	2008-11-29	2008-11-29 00:00:00	2008-11-29	2008-11-29 00:00:00	2008-11-29	581452		0	0	0		0	0	0	246312	0	52	40213296		
191608	4210	40213296	2017-04-15	2017-04-15 00:00:00	2017-04-15	2017-04-15 00:00:00	2017-04-15	581452		0	0	0		0	0	0	279532	0	52	40213296		
51280	4261	1115171	1999-11-19	1999-11-19 00:00:00	1999-12-10	1999-12-10 00:00:00	1999-12-10	38000177		0	0	21		0	0	0	282895	0	849574	1115171		
43758	3625	1127433	1979-10-20	1979-10-20 00:00:00	1979-11-03	1979-11-03 00:00:00	1979-11-03	38000177		0	0	14		0	0	0	241037	0	313782	1127433		
6069	507	19077572	2010-09-17	2010-09-17 00:00:00	2010-09-17	2010-09-17 00:00:00	\N	38000177		0	0	0		0	0	0	33959	0	310436	19077572		
57385	4760	1127433	1972-07-31	1972-07-31 00:00:00	1972-10-29	1972-10-29 00:00:00	1972-10-29	38000177		0	0	90		0	0	0	317198	0	313782	1127433		
229036	5031	40213201	1986-07-26	1986-07-26 00:00:00	1986-07-26	1986-07-26 00:00:00	1986-07-26	581452		0	0	0		0	0	0	334348	0	33	40213201		
51026	4239	1127433	1993-07-29	1993-07-29 00:00:00	1993-10-04	1993-10-04 00:00:00	1993-10-04	38000177		0	0	67		0	0	0	281507	0	313782	1127433		
51060	4241	40229134	1972-12-15	1972-12-15 00:00:00	1972-12-22	1972-12-22 00:00:00	1972-12-22	38000177		0	0	7		0	0	0	281751	0	1043400	40229134		
183237	4026	40213296	1999-10-31	1999-10-31 00:00:00	1999-10-31	1999-10-31 00:00:00	1999-10-31	581452		0	0	0		0	0	0	267757	0	52	40213296		
26335	2166	1127433	1990-04-10	1990-04-10 00:00:00	1990-04-24	1990-04-24 00:00:00	1990-04-24	38000177		0	0	14		0	0	0	144315	0	313782	1127433		
145219	3191	40213227	2018-11-15	2018-11-15 00:00:00	2018-11-15	2018-11-15 00:00:00	2018-11-15	581452		0	0	0		0	0	0	212392	0	113	40213227		
59877	1310	40213201	2006-06-02	2006-06-02 00:00:00	2006-06-02	2006-06-02 00:00:00	2006-06-02	581452		0	0	0		0	0	0	86531	0	33	40213201		
28223	2333	1118084	1957-04-13	1957-04-13 00:00:00	1957-04-13	1957-04-13 00:00:00	\N	38000177		0	0	0		0	0	0	155186	0	00025152531	44923712		
194737	4278	40213198	2015-11-20	2015-11-20 00:00:00	2015-11-20	2015-11-20 00:00:00	2015-11-20	581452		0	0	0		0	0	0	283868	0	133	40213198		
206078	4523	40213160	1981-01-04	1981-01-04 00:00:00	1981-01-04	1981-01-04 00:00:00	1981-01-04	581452		0	0	0		0	0	0	301160	0	10	40213160		
9068	755	1127433	2011-04-01	2011-04-01 00:00:00	2011-04-15	2011-04-15 00:00:00	2011-04-15	38000177		0	0	14		0	0	0	50057	0	313782	1127433		
55769	4630	920300	1983-02-24	1983-02-24 00:00:00	1983-03-03	1983-03-03 00:00:00	1983-03-03	38000177		0	0	7		0	0	0	308480	0	311989	920300		
121454	2669	40213160	1981-12-09	1981-12-09 00:00:00	1981-12-09	1981-12-09 00:00:00	1981-12-09	581452		0	0	0		0	0	0	176778	0	10	40213160		
114960	2526	40213296	2017-01-02	2017-01-02 00:00:00	2017-01-02	2017-01-02 00:00:00	2017-01-02	581452		0	0	0		0	0	0	167002	0	52	40213296		
7844	656	1713671	1966-10-22	1966-10-22 00:00:00	1966-11-12	1966-11-12 00:00:00	1966-11-12	38000177		0	0	21		0	0	0	43489	0	562251	1713671		
128114	2818	40213306	1990-10-08	1990-10-08 00:00:00	1990-10-08	1990-10-08 00:00:00	1990-10-08	581452		0	0	0		0	0	0	186782	0	43	40213306		
136783	3002	40213314	1977-06-07	1977-06-07 00:00:00	1977-06-07	1977-06-07 00:00:00	1977-06-07	581452		0	0	0		0	0	0	200360	0	49	40213314		
35942	2959	19078461	1986-09-29	1986-09-29 00:00:00	1986-12-28	1986-12-28 00:00:00	1986-12-28	38000177		0	0	90		0	0	0	197604	0	310965	19078461		
12979	1091	1118084	1997-12-14	1997-12-14 00:00:00	1997-12-14	1997-12-14 00:00:00	\N	38000177		0	0	0		0	0	0	71743	0	00025152531	44923712		
77023	1683	40213227	2013-08-01	2013-08-01 00:00:00	2013-08-01	2013-08-01 00:00:00	2013-08-01	581452		0	0	0		0	0	0	112785	0	113	40213227		
14248	1194	19129655	1963-10-18	1963-10-18 00:00:00	1963-11-01	1963-11-01 00:00:00	1963-11-01	38000177		0	0	14		0	0	0	78692	0	789980	19129655		
77120	1685	40213160	1980-05-18	1980-05-18 00:00:00	1980-05-18	1980-05-18 00:00:00	1980-05-18	581452		0	0	0		0	0	0	112916	0	10	40213160		
114101	2507	40213160	1968-01-09	1968-01-09 00:00:00	1968-01-09	1968-01-09 00:00:00	1968-01-09	581452		0	0	0		0	0	0	165982	0	10	40213160		
43118	3572	1127433	1980-02-05	1980-02-05 00:00:00	1980-03-11	1980-03-11 00:00:00	1980-03-11	38000177		0	0	35		0	0	0	237443	0	313782	1127433		
56114	4657	40236824	1990-12-22	1990-12-22 00:00:00	1991-01-05	1991-01-05 00:00:00	1991-01-05	38000177		0	0	14		0	0	0	310566	0	1094107	40236824		
61970	1354	40213227	2009-10-23	2009-10-23 00:00:00	2009-10-23	2009-10-23 00:00:00	2009-10-23	581452		0	0	0		0	0	0	89716	0	113	40213227		
34279	2832	1127433	2000-04-13	2000-04-13 00:00:00	2000-04-27	2000-04-27 00:00:00	2000-04-27	38000177		0	0	14		0	0	0	187935	0	313782	1127433		
238961	5245	40213227	1996-12-29	1996-12-29 00:00:00	1996-12-29	1996-12-29 00:00:00	1996-12-29	581452		0	0	0		0	0	0	349014	0	113	40213227		
219471	4816	40213306	2004-01-12	2004-01-12 00:00:00	2004-01-12	2004-01-12 00:00:00	2004-01-12	581452		0	0	0		0	0	0	320421	0	43	40213306		
189280	4156	40213296	1998-11-02	1998-11-02 00:00:00	1998-11-02	1998-11-02 00:00:00	1998-11-02	581452		0	0	0		0	0	0	276189	0	52	40213296		
94379	2071	40213227	2007-05-23	2007-05-23 00:00:00	2007-05-23	2007-05-23 00:00:00	2007-05-23	581452		0	0	0		0	0	0	137798	0	113	40213227		
17295	1433	1127433	1989-05-01	1989-05-01 00:00:00	1989-05-29	1989-05-29 00:00:00	1989-05-29	38000177		0	0	28		0	0	0	95490	0	313782	1127433		
242990	5334	40213296	2008-01-23	2008-01-23 00:00:00	2008-01-23	2008-01-23 00:00:00	2008-01-23	581452		0	0	0		0	0	0	355189	0	52	40213296		
204937	4498	40213227	2019-06-04	2019-06-04 00:00:00	2019-06-04	2019-06-04 00:00:00	2019-06-04	581452		0	0	0		0	0	0	299453	0	113	40213227		
17383	376	40213296	2001-05-03	2001-05-03 00:00:00	2001-05-03	2001-05-03 00:00:00	2001-05-03	581452		0	0	0		0	0	0	24883	0	52	40213296		
52764	4384	1127433	1982-01-12	1982-01-12 00:00:00	1982-01-26	1982-01-26 00:00:00	1982-01-26	38000177		0	0	14		0	0	0	291408	0	313782	1127433		
228353	5015	40213160	1968-10-14	1968-10-14 00:00:00	1968-10-14	1968-10-14 00:00:00	1968-10-14	581452		0	0	0		0	0	0	333364	0	10	40213160		
196796	4324	40213296	2003-10-05	2003-10-05 00:00:00	2003-10-05	2003-10-05 00:00:00	2003-10-05	581452		0	0	0		0	0	0	286875	0	52	40213296		
196835	4325	40213160	1965-08-31	1965-08-31 00:00:00	1965-08-31	1965-08-31 00:00:00	1965-08-31	581452		0	0	0		0	0	0	286889	0	10	40213160		
52009	4325	1713671	1970-11-18	1970-11-18 00:00:00	1970-12-09	1970-12-09 00:00:00	1970-12-09	38000177		0	0	21		0	0	0	286885	0	562251	1713671		
96466	2115	40213227	1992-12-28	1992-12-28 00:00:00	1992-12-28	1992-12-28 00:00:00	1992-12-28	581452		0	0	0		0	0	0	140735	0	113	40213227		
43647	3618	19059056	1936-01-02	1936-01-02 00:00:00	1936-01-23	1936-01-23 00:00:00	1936-01-23	38000177		0	0	21		0	0	0	240397	0	243670	19059056		
240310	5276	40213227	1992-03-01	1992-03-01 00:00:00	1992-03-01	1992-03-01 00:00:00	1992-03-01	581452		0	0	0		0	0	0	350893	0	113	40213227		
205332	4506	40213260	2007-01-11	2007-01-11 00:00:00	2007-01-11	2007-01-11 00:00:00	2007-01-11	581452		0	0	0		0	0	0	300154	0	121	40213260		
4216	350	782047	1995-09-11	1995-09-11 00:00:00	1995-09-11	1995-09-11 00:00:00	1995-09-11	38000177		0	0	0		0	0	0	23293	0	542347	782047		
121790	2677	40213160	1972-12-22	1972-12-22 00:00:00	1972-12-22	1972-12-22 00:00:00	1972-12-22	581452		0	0	0		0	0	0	177350	0	10	40213160		
205477	4509	40213227	2018-09-04	2018-09-04 00:00:00	2018-09-04	2018-09-04 00:00:00	2018-09-04	581452		0	0	0		0	0	0	300406	0	113	40213227		
92376	2028	40213227	2017-10-11	2017-10-11 00:00:00	2017-10-11	2017-10-11 00:00:00	2017-10-11	581452		0	0	0		0	0	0	135029	0	113	40213227		
18842	1556	19128065	1988-03-20	1988-03-20 00:00:00	1989-03-15	1989-03-15 00:00:00	1989-03-15	38000177		0	0	360		0	0	0	104250	0	749882	19128065		
112323	2468	40213201	2005-01-30	2005-01-30 00:00:00	2005-01-30	2005-01-30 00:00:00	2005-01-30	581452		0	0	0		0	0	0	163668	0	33	40213201		
87934	1929	40213296	1998-01-29	1998-01-29 00:00:00	1998-01-29	1998-01-29 00:00:00	1998-01-29	581452		0	0	0		0	0	0	128411	0	52	40213296		
137721	3023	40213306	2003-12-27	2003-12-27 00:00:00	2003-12-27	2003-12-27 00:00:00	2003-12-27	581452		0	0	0		0	0	0	201509	0	43	40213306		
12137	262	40213227	2006-08-14	2006-08-14 00:00:00	2006-08-14	2006-08-14 00:00:00	2006-08-14	581452		0	0	0		0	0	0	17392	0	113	40213227		
12812	1079	40236824	2010-04-04	2010-04-04 00:00:00	2010-04-18	2010-04-18 00:00:00	2010-04-18	38000177		0	0	14		0	0	0	70737	0	1094107	40236824		
99403	2176	40213160	1956-11-26	1956-11-26 00:00:00	1956-11-26	1956-11-26 00:00:00	1956-11-26	581452		0	0	0		0	0	0	145111	0	10	40213160		
191794	4214	40213314	1977-11-08	1977-11-08 00:00:00	1977-11-08	1977-11-08 00:00:00	1977-11-08	581452		0	0	0		0	0	0	279789	0	49	40213314		
40637	3370	1713671	1998-08-08	1998-08-08 00:00:00	1998-08-22	1998-08-22 00:00:00	1998-08-22	38000177		0	0	14		0	0	0	223482	0	562251	1713671		
153653	3382	40213160	1962-10-25	1962-10-25 00:00:00	1962-10-25	1962-10-25 00:00:00	1962-10-25	581452		0	0	0		0	0	0	224457	0	10	40213160		
203470	4467	40213160	1955-06-02	1955-06-02 00:00:00	1955-06-02	1955-06-02 00:00:00	1955-06-02	581452		0	0	0		0	0	0	297195	0	10	40213160		
191611	4210	40213296	2015-04-11	2015-04-11 00:00:00	2015-04-11	2015-04-11 00:00:00	2015-04-11	581452		0	0	0		0	0	0	279540	0	52	40213296		
51281	4261	1115171	1995-10-27	1995-10-27 00:00:00	1995-11-10	1995-11-10 00:00:00	1995-11-10	38000177		0	0	14		0	0	0	282894	0	849574	1115171		
43759	3625	40173590	2013-09-10	2013-09-10 00:00:00	2013-09-10	2013-09-10 00:00:00	\N	38000177		0	0	0		0	0	0	241115	0	904419	40173590		
6070	507	19133873	1949-01-27	1949-01-27 00:00:00	1949-02-09	1949-02-09 00:00:00	1949-02-09	38000177		0	0	13		0	0	0	33946	0	834061	19133873		
57386	4760	40162522	1972-07-31	1972-07-31 00:00:00	1972-07-31	1972-07-31 00:00:00	\N	38000177		0	0	0		0	0	0	317198	0	857005	40162522		
229042	5031	40213227	2001-10-20	2001-10-20 00:00:00	2001-10-20	2001-10-20 00:00:00	2001-10-20	581452		0	0	0		0	0	0	334367	0	113	40213227		
51027	4239	19059056	1954-06-17	1954-06-17 00:00:00	1954-07-01	1954-07-01 00:00:00	1954-07-01	38000177		0	0	14		0	0	0	281581	0	243670	19059056		
51061	4241	1127078	1976-05-02	1976-05-02 00:00:00	1976-05-16	1976-05-16 00:00:00	1976-05-16	38000177		0	0	14		0	0	0	281750	0	282464	1127078		
183246	4026	40213260	2008-02-17	2008-02-17 00:00:00	2008-02-17	2008-02-17 00:00:00	2008-02-17	581452		0	0	0		0	0	0	267719	0	121	40213260		
26336	2166	40229134	1970-01-08	1970-01-08 00:00:00	1970-01-15	1970-01-15 00:00:00	1970-01-15	38000177		0	0	7		0	0	0	144277	0	1043400	40229134		
202824	4452	40213227	1997-08-08	1997-08-08 00:00:00	1997-08-08	1997-08-08 00:00:00	1997-08-08	581452		0	0	0		0	0	0	296325	0	113	40213227		
59888	1310	40213227	2011-07-01	2011-07-01 00:00:00	2011-07-01	2011-07-01 00:00:00	2011-07-01	581452		0	0	0		0	0	0	86603	0	113	40213227		
28224	2333	40236824	1962-08-24	1962-08-24 00:00:00	1962-08-31	1962-08-31 00:00:00	1962-08-31	38000177		0	0	7		0	0	0	155241	0	1094107	40236824		
194743	4279	40213198	2015-07-03	2015-07-03 00:00:00	2015-07-03	2015-07-03 00:00:00	2015-07-03	581452		0	0	0		0	0	0	284089	0	133	40213198		
206080	4523	40213251	1984-01-22	1984-01-22 00:00:00	1984-01-22	1984-01-22 00:00:00	1984-01-22	581452		0	0	0		0	0	0	301169	0	21	40213251		
9069	755	1127433	1989-02-12	1989-02-12 00:00:00	1989-02-26	1989-02-26 00:00:00	1989-02-26	38000177		0	0	14		0	0	0	50040	0	313782	1127433		
55770	4630	1127433	1973-07-15	1973-07-15 00:00:00	1973-07-22	1973-07-22 00:00:00	1973-07-22	38000177		0	0	7		0	0	0	308436	0	313782	1127433		
121460	2669	40213314	1978-02-15	1978-02-15 00:00:00	1978-02-15	1978-02-15 00:00:00	1978-02-15	581452		0	0	0		0	0	0	176821	0	49	40213314		
114961	2526	40213306	1997-08-04	1997-08-04 00:00:00	1997-08-04	1997-08-04 00:00:00	1997-08-04	581452		0	0	0		0	0	0	167017	0	43	40213306		
7845	656	1127433	2012-05-24	2012-05-24 00:00:00	2012-06-07	2012-06-07 00:00:00	2012-06-07	38000177		0	0	14		0	0	0	43427	0	313782	1127433		
128118	2818	40213160	1968-08-12	1968-08-12 00:00:00	1968-08-12	1968-08-12 00:00:00	1968-08-12	581452		0	0	0		0	0	0	186725	0	10	40213160		
136786	3002	40213227	2004-09-14	2004-09-14 00:00:00	2004-09-14	2004-09-14 00:00:00	2004-09-14	581452		0	0	0		0	0	0	200378	0	113	40213227		
35943	2959	1310034	1997-10-07	1997-10-07 00:00:00	1997-10-07	1997-10-07 00:00:00	1997-10-07	38000177		0	0	0		0	0	0	197605	0	834357	1310034		
12980	1091	19133905	2007-11-20	2007-11-20 00:00:00	2007-12-01	2007-12-01 00:00:00	2007-12-01	38000177		0	0	11		0	0	0	71702	0	834102	19133905		
77024	1683	40213296	2013-08-01	2013-08-01 00:00:00	2013-08-01	2013-08-01 00:00:00	2013-08-01	581452		0	0	0		0	0	0	112785	0	52	40213296		
14249	1194	19059056	1962-08-10	1962-08-10 00:00:00	1962-08-24	1962-08-24 00:00:00	1962-08-24	38000177		0	0	14		0	0	0	78691	0	243670	19059056		
77126	1686	40213160	1961-08-27	1961-08-27 00:00:00	1961-08-27	1961-08-27 00:00:00	1961-08-27	581452		0	0	0		0	0	0	112939	0	10	40213160		
114102	2507	40213160	1972-04-11	1972-04-11 00:00:00	1972-04-11	1972-04-11 00:00:00	1972-04-11	581452		0	0	0		0	0	0	165939	0	10	40213160		
59377	4935	1118084	2003-08-01	2003-08-01 00:00:00	2003-08-01	2003-08-01 00:00:00	\N	38000177		0	0	0		0	0	0	328150	0	00025152531	44923712		
56115	4657	920300	1990-12-22	1990-12-22 00:00:00	1990-12-29	1990-12-29 00:00:00	1990-12-29	38000177		0	0	7		0	0	0	310566	0	311989	920300		
61971	1354	40213296	2018-04-13	2018-04-13 00:00:00	2018-04-13	2018-04-13 00:00:00	2018-04-13	581452		0	0	0		0	0	0	89720	0	52	40213296		
34280	2832	1713671	1986-11-30	1986-11-30 00:00:00	1986-12-21	1986-12-21 00:00:00	1986-12-21	38000177		0	0	21		0	0	0	187974	0	562251	1713671		
238962	5245	40213306	1996-12-29	1996-12-29 00:00:00	1996-12-29	1996-12-29 00:00:00	1996-12-29	581452		0	0	0		0	0	0	349014	0	43	40213306		
219475	4816	40213314	1983-01-17	1983-01-17 00:00:00	1983-01-17	1983-01-17 00:00:00	1983-01-17	581452		0	0	0		0	0	0	320407	0	49	40213314		
189284	4156	40213227	2007-07-02	2007-07-02 00:00:00	2007-07-02	2007-07-02 00:00:00	2007-07-02	581452		0	0	0		0	0	0	276187	0	113	40213227		
94380	2071	40213296	2007-05-23	2007-05-23 00:00:00	2007-05-23	2007-05-23 00:00:00	2007-05-23	581452		0	0	0		0	0	0	137798	0	52	40213296		
17302	1435	40229134	1980-10-27	1980-10-27 00:00:00	1980-11-10	1980-11-10 00:00:00	1980-11-10	38000177		0	0	14		0	0	0	95598	0	1043400	40229134		
242998	5334	40213260	2014-02-19	2014-02-19 00:00:00	2014-02-19	2014-02-19 00:00:00	2014-02-19	581452		0	0	0		0	0	0	355211	0	121	40213260		
204938	4498	40213296	2019-06-04	2019-06-04 00:00:00	2019-06-04	2019-06-04 00:00:00	2019-06-04	581452		0	0	0		0	0	0	299453	0	52	40213296		
17388	376	40213306	1983-12-08	1983-12-08 00:00:00	1983-12-08	1983-12-08 00:00:00	1983-12-08	581452		0	0	0		0	0	0	24933	0	43	40213306		
78510	1718	40213306	1989-04-22	1989-04-22 00:00:00	1989-04-22	1989-04-22 00:00:00	1989-04-22	581452		0	0	0		0	0	0	114841	0	43	40213306		
228355	5015	40213296	2008-03-10	2008-03-10 00:00:00	2008-03-10	2008-03-10 00:00:00	2008-03-10	581452		0	0	0		0	0	0	333395	0	52	40213296		
196799	4324	40213227	2012-06-17	2012-06-17 00:00:00	2012-06-17	2012-06-17 00:00:00	2012-06-17	581452		0	0	0		0	0	0	286877	0	113	40213227		
196836	4325	40213227	2006-06-27	2006-06-27 00:00:00	2006-06-27	2006-06-27 00:00:00	2006-06-27	581452		0	0	0		0	0	0	286945	0	113	40213227		
52010	4325	19059056	1971-10-18	1971-10-18 00:00:00	1971-11-01	1971-11-01 00:00:00	1971-11-01	38000177		0	0	14		0	0	0	286932	0	243670	19059056		
172395	3789	40213227	2015-08-13	2015-08-13 00:00:00	2015-08-13	2015-08-13 00:00:00	2015-08-13	581452		0	0	0		0	0	0	251919	0	113	40213227		
43648	3618	1127433	1916-08-20	1916-08-20 00:00:00	1916-08-27	1916-08-27 00:00:00	1916-08-27	38000177		0	0	7		0	0	0	240344	0	313782	1127433		
240312	5276	40213160	1958-06-29	1958-06-29 00:00:00	1958-06-29	1958-06-29 00:00:00	1958-06-29	581452		0	0	0		0	0	0	350916	0	10	40213160		
50810	1113	40213227	2003-01-28	2003-01-28 00:00:00	2003-01-28	2003-01-28 00:00:00	2003-01-28	581452		0	0	0		0	0	0	73296	0	113	40213227		
4217	350	19078924	1995-09-11	1995-09-11 00:00:00	1995-09-11	1995-09-11 00:00:00	1995-09-11	38000177		0	0	0		0	0	0	23293	0	311700	19078924		
121798	2677	40213227	2014-04-19	2014-04-19 00:00:00	2014-04-19	2014-04-19 00:00:00	2014-04-19	581452		0	0	0		0	0	0	177342	0	113	40213227		
205478	4509	40213260	2018-09-04	2018-09-04 00:00:00	2018-09-04	2018-09-04 00:00:00	2018-09-04	581452		0	0	0		0	0	0	300406	0	121	40213260		
200305	4398	40213306	1981-04-25	1981-04-25 00:00:00	1981-04-25	1981-04-25 00:00:00	1981-04-25	581452		0	0	0		0	0	0	292403	0	43	40213306		
18843	1556	1150771	1977-04-18	1977-04-18 00:00:00	1977-04-18	1977-04-18 00:00:00	\N	38000177		0	0	0		0	0	0	104271	0	197378	1150771		
112347	2468	40213227	1999-11-07	1999-11-07 00:00:00	1999-11-07	1999-11-07 00:00:00	1999-11-07	581452		0	0	0		0	0	0	163630	0	113	40213227		
87938	1929	40213227	2006-02-23	2006-02-23 00:00:00	2006-02-23	2006-02-23 00:00:00	2006-02-23	581452		0	0	0		0	0	0	128412	0	113	40213227		
137732	3023	40213314	1982-04-03	1982-04-03 00:00:00	1982-04-03	1982-04-03 00:00:00	1982-04-03	581452		0	0	0		0	0	0	201529	0	49	40213314		
12138	262	40213306	1987-07-06	1987-07-06 00:00:00	1987-07-06	1987-07-06 00:00:00	1987-07-06	581452		0	0	0		0	0	0	17383	0	43	40213306		
12813	1079	920300	2010-04-04	2010-04-04 00:00:00	2010-04-11	2010-04-11 00:00:00	2010-04-11	38000177		0	0	7		0	0	0	70737	0	311989	920300		
99420	2177	40213260	2016-11-02	2016-11-02 00:00:00	2016-11-02	2016-11-02 00:00:00	2016-11-02	581452		0	0	0		0	0	0	145203	0	121	40213260		
191797	4214	40213160	1977-11-08	1977-11-08 00:00:00	1977-11-08	1977-11-08 00:00:00	1977-11-08	581452		0	0	0		0	0	0	279789	0	10	40213160		
40638	3370	19019979	1977-06-14	1977-06-14 00:00:00	1977-06-28	1977-06-28 00:00:00	1977-06-28	38000177		0	0	14		0	0	0	223392	0	198405	19019979		
153654	3382	40213296	2003-10-23	2003-10-23 00:00:00	2003-10-23	2003-10-23 00:00:00	2003-10-23	581452		0	0	0		0	0	0	224433	0	52	40213296		
203480	4467	40213227	2013-01-17	2013-01-17 00:00:00	2013-01-17	2013-01-17 00:00:00	2013-01-17	581452		0	0	0		0	0	0	297221	0	113	40213227		
191613	4210	40213314	1977-03-12	1977-03-12 00:00:00	1977-03-12	1977-03-12 00:00:00	1977-03-12	581452		0	0	0		0	0	0	279555	0	49	40213314		
51282	4261	1713671	1977-10-30	1977-10-30 00:00:00	1977-11-06	1977-11-06 00:00:00	1977-11-06	38000177		0	0	7		0	0	0	282861	0	562251	1713671		
43760	3625	1118084	1997-07-18	1997-07-18 00:00:00	1997-07-18	1997-07-18 00:00:00	\N	38000177		0	0	0		0	0	0	241122	0	00025152531	44923712		
6071	507	19078461	1994-05-11	1994-05-11 00:00:00	1994-05-25	1994-05-25 00:00:00	1994-05-25	38000177		0	0	14		0	0	0	33958	0	310965	19078461		
57387	4760	19006318	1960-05-28	1960-05-28 00:00:00	1960-06-11	1960-06-11 00:00:00	1960-06-11	38000177		0	0	14		0	0	0	317126	0	105078	19006318		
229047	5031	40213227	2011-04-09	2011-04-09 00:00:00	2011-04-09	2011-04-09 00:00:00	2011-04-09	581452		0	0	0		0	0	0	334383	0	113	40213227		
51028	4239	19006318	1954-06-17	1954-06-17 00:00:00	1954-07-01	1954-07-01 00:00:00	1954-07-01	38000177		0	0	14		0	0	0	281581	0	105078	19006318		
51062	4241	19128065	1988-09-01	1988-09-01 00:00:00	1989-08-27	1989-08-27 00:00:00	1989-08-27	38000177		0	0	360		0	0	0	281730	0	749882	19128065		
183252	4026	40213160	1963-01-06	1963-01-06 00:00:00	1963-01-06	1963-01-06 00:00:00	1963-01-06	581452		0	0	0		0	0	0	267668	0	10	40213160		
26337	2166	19128065	1983-05-08	1983-05-08 00:00:00	1984-05-02	1984-05-02 00:00:00	1984-05-02	38000177		0	0	360		0	0	0	144307	0	749882	19128065		
202825	4452	40213296	1997-08-08	1997-08-08 00:00:00	1997-08-08	1997-08-08 00:00:00	1997-08-08	581452		0	0	0		0	0	0	296325	0	52	40213296		
105158	2307	40213227	2012-10-09	2012-10-09 00:00:00	2012-10-09	2012-10-09 00:00:00	2012-10-09	581452		0	0	0		0	0	0	153524	0	113	40213227		
28225	2333	920300	1962-08-24	1962-08-24 00:00:00	1962-08-31	1962-08-31 00:00:00	1962-08-31	38000177		0	0	7		0	0	0	155241	0	311989	920300		
194747	4279	40213160	1955-03-18	1955-03-18 00:00:00	1955-03-18	1955-03-18 00:00:00	1955-03-18	581452		0	0	0		0	0	0	284014	0	10	40213160		
206083	4523	40213160	1976-05-02	1976-05-02 00:00:00	1976-05-02	1976-05-02 00:00:00	1976-05-02	581452		0	0	0		0	0	0	301164	0	10	40213160		
9070	755	19133905	1975-12-08	1975-12-08 00:00:00	1975-12-15	1975-12-15 00:00:00	1975-12-15	38000177		0	0	7		0	0	0	50054	0	834102	19133905		
55771	4630	1127433	1993-11-29	1993-11-29 00:00:00	1993-12-13	1993-12-13 00:00:00	1993-12-13	38000177		0	0	14		0	0	0	308522	0	313782	1127433		
121466	2669	40213227	2007-12-26	2007-12-26 00:00:00	2007-12-26	2007-12-26 00:00:00	2007-12-26	581452		0	0	0		0	0	0	176795	0	113	40213227		
114963	2526	40213227	1997-08-04	1997-08-04 00:00:00	1997-08-04	1997-08-04 00:00:00	1997-08-04	581452		0	0	0		0	0	0	167017	0	113	40213227		
7846	656	1713671	1969-11-01	1969-11-01 00:00:00	1969-11-08	1969-11-08 00:00:00	1969-11-08	38000177		0	0	7		0	0	0	43442	0	562251	1713671		
128126	2818	40213160	1968-03-11	1968-03-11 00:00:00	1968-03-11	1968-03-11 00:00:00	1968-03-11	581452		0	0	0		0	0	0	186724	0	10	40213160		
197115	4331	40213314	1977-10-21	1977-10-21 00:00:00	1977-10-21	1977-10-21 00:00:00	1977-10-21	581452		0	0	0		0	0	0	287286	0	49	40213314		
35944	2959	40243436	1997-10-07	1997-10-07 00:00:00	1997-10-07	1997-10-07 00:00:00	1997-10-07	38000177		0	0	0		0	0	0	197605	0	1190795	40243436		
12982	1091	40232448	1961-06-27	1961-06-27 00:00:00	1961-06-27	1961-06-27 00:00:00	\N	38000177		0	0	0		0	0	0	71728	0	1049630	40232448		
77032	1683	40213296	2011-07-28	2011-07-28 00:00:00	2011-07-28	2011-07-28 00:00:00	2011-07-28	581452		0	0	0		0	0	0	112777	0	52	40213296		
14250	1194	19129655	1962-08-10	1962-08-10 00:00:00	1962-08-24	1962-08-24 00:00:00	1962-08-24	38000177		0	0	14		0	0	0	78691	0	789980	19129655		
53001	1159	40213314	1980-11-01	1980-11-01 00:00:00	1980-11-01	1980-11-01 00:00:00	1980-11-01	581452		0	0	0		0	0	0	76589	0	49	40213314		
114103	2507	40213306	1989-07-04	1989-07-04 00:00:00	1989-07-04	1989-07-04 00:00:00	1989-07-04	581452		0	0	0		0	0	0	165976	0	43	40213306		
59378	4935	19078461	1981-08-26	1981-08-26 00:00:00	1981-09-09	1981-09-09 00:00:00	1981-09-09	38000177		0	0	14		0	0	0	328154	0	310965	19078461		
56116	4657	1127433	1977-06-12	1977-06-12 00:00:00	1977-06-26	1977-06-26 00:00:00	1977-06-26	38000177		0	0	14		0	0	0	310550	0	313782	1127433		
61974	1354	40213314	1979-06-15	1979-06-15 00:00:00	1979-06-15	1979-06-15 00:00:00	1979-06-15	581452		0	0	0		0	0	0	89753	0	49	40213314		
34281	2832	19008572	1994-02-17	1994-02-17 00:00:00	1994-02-17	1994-02-17 00:00:00	\N	38000177		0	0	0		0	0	0	187896	0	106258	19008572		
238965	5245	40213160	1974-09-08	1974-09-08 00:00:00	1974-09-08	1974-09-08 00:00:00	1974-09-08	581452		0	0	0		0	0	0	348978	0	10	40213160		
173811	3822	40213201	2011-04-04	2011-04-04 00:00:00	2011-04-04	2011-04-04 00:00:00	2011-04-04	581452		0	0	0		0	0	0	253844	0	33	40213201		
189286	4156	40213260	2007-07-02	2007-07-02 00:00:00	2007-07-02	2007-07-02 00:00:00	2007-07-02	581452		0	0	0		0	0	0	276187	0	121	40213260		
94384	2071	40213306	1987-12-30	1987-12-30 00:00:00	1987-12-30	1987-12-30 00:00:00	1987-12-30	581452		0	0	0		0	0	0	137815	0	43	40213306		
17303	1435	19133873	1976-08-21	1976-08-21 00:00:00	1976-09-01	1976-09-01 00:00:00	1976-09-01	38000177		0	0	11		0	0	0	95547	0	834061	19133873		
243001	5334	40213160	1964-10-28	1964-10-28 00:00:00	1964-10-28	1964-10-28 00:00:00	1964-10-28	581452		0	0	0		0	0	0	355165	0	10	40213160		
204941	4498	40213160	1981-12-22	1981-12-22 00:00:00	1981-12-22	1981-12-22 00:00:00	1981-12-22	581452		0	0	0		0	0	0	299447	0	10	40213160		
17390	376	40213160	1961-08-03	1961-08-03 00:00:00	1961-08-03	1961-08-03 00:00:00	1961-08-03	581452		0	0	0		0	0	0	24888	0	10	40213160		
78512	1718	40213227	1998-05-02	1998-05-02 00:00:00	1998-05-02	1998-05-02 00:00:00	1998-05-02	581452		0	0	0		0	0	0	114819	0	113	40213227		
228365	5015	40213306	1991-02-18	1991-02-18 00:00:00	1991-02-18	1991-02-18 00:00:00	1991-02-18	581452		0	0	0		0	0	0	333391	0	43	40213306		
196800	4324	40213260	2012-06-17	2012-06-17 00:00:00	2012-06-17	2012-06-17 00:00:00	2012-06-17	581452		0	0	0		0	0	0	286877	0	121	40213260		
196837	4325	40213296	2006-06-27	2006-06-27 00:00:00	2006-06-27	2006-06-27 00:00:00	2006-06-27	581452		0	0	0		0	0	0	286945	0	52	40213296		
52011	4325	1713671	1974-03-05	1974-03-05 00:00:00	1974-03-12	1974-03-12 00:00:00	1974-03-12	38000177		0	0	7		0	0	0	286892	0	562251	1713671		
172399	3789	40213201	2010-07-15	2010-07-15 00:00:00	2010-07-15	2010-07-15 00:00:00	2010-07-15	581452		0	0	0		0	0	0	251868	0	33	40213201		
43649	3618	40236824	1931-02-12	1931-02-12 00:00:00	1931-02-19	1931-02-19 00:00:00	1931-02-19	38000177		0	0	7		0	0	0	240449	0	1094107	40236824		
240314	5276	40213227	2009-12-27	2009-12-27 00:00:00	2009-12-27	2009-12-27 00:00:00	2009-12-27	581452		0	0	0		0	0	0	350871	0	113	40213227		
50812	1113	40213160	1972-02-22	1972-02-22 00:00:00	1972-02-22	1972-02-22 00:00:00	1972-02-22	581452		0	0	0		0	0	0	73292	0	10	40213160		
4218	350	46275444	1995-09-11	1995-09-11 00:00:00	1995-09-11	1995-09-11 00:00:00	1995-09-11	38000177		0	0	0		0	0	0	23293	0	1659149	46275444		
121799	2677	40213296	2014-04-19	2014-04-19 00:00:00	2014-04-19	2014-04-19 00:00:00	2014-04-19	581452		0	0	0		0	0	0	177342	0	52	40213296		
205479	4509	40213160	1967-12-05	1967-12-05 00:00:00	1967-12-05	1967-12-05 00:00:00	1967-12-05	581452		0	0	0		0	0	0	300354	0	10	40213160		
22114	480	40213227	2018-10-17	2018-10-17 00:00:00	2018-10-17	2018-10-17 00:00:00	2018-10-17	581452		0	0	0		0	0	0	32069	0	113	40213227		
18844	1556	19133873	1981-12-02	1981-12-02 00:00:00	1981-12-14	1981-12-14 00:00:00	1981-12-14	38000177		0	0	12		0	0	0	104257	0	834061	19133873		
112354	2468	40213227	2010-02-28	2010-02-28 00:00:00	2010-02-28	2010-02-28 00:00:00	2010-02-28	581452		0	0	0		0	0	0	163650	0	113	40213227		
87939	1929	40213260	2006-02-23	2006-02-23 00:00:00	2006-02-23	2006-02-23 00:00:00	2006-02-23	581452		0	0	0		0	0	0	128412	0	121	40213260		
137733	3023	40213160	1982-04-03	1982-04-03 00:00:00	1982-04-03	1982-04-03 00:00:00	1982-04-03	581452		0	0	0		0	0	0	201529	0	10	40213160		
12144	262	40213160	1969-04-07	1969-04-07 00:00:00	1969-04-07	1969-04-07 00:00:00	1969-04-07	581452		0	0	0		0	0	0	17381	0	10	40213160		
12814	1079	1713671	2004-09-02	2004-09-02 00:00:00	2004-09-23	2004-09-23 00:00:00	2004-09-23	38000177		0	0	21		0	0	0	70731	0	562251	1713671		
99424	2177	40213227	1999-09-29	1999-09-29 00:00:00	1999-09-29	1999-09-29 00:00:00	1999-09-29	581452		0	0	0		0	0	0	145177	0	113	40213227		
191810	4214	40213296	2014-12-09	2014-12-09 00:00:00	2014-12-09	2014-12-09 00:00:00	2014-12-09	581452		0	0	0		0	0	0	279792	0	52	40213296		
40639	3370	19128065	1986-09-21	1986-09-21 00:00:00	1987-09-16	1987-09-16 00:00:00	1987-09-16	38000177		0	0	360		0	0	0	223407	0	749882	19128065		
153657	3382	40213306	1984-11-29	1984-11-29 00:00:00	1984-11-29	1984-11-29 00:00:00	1984-11-29	581452		0	0	0		0	0	0	224471	0	43	40213306		
203488	4467	40213201	2018-02-15	2018-02-15 00:00:00	2018-02-15	2018-02-15 00:00:00	2018-02-15	581452		0	0	0		0	0	0	297232	0	33	40213201		
191616	4210	40213314	1977-09-10	1977-09-10 00:00:00	1977-09-10	1977-09-10 00:00:00	1977-09-10	581452		0	0	0		0	0	0	279528	0	49	40213314		
51283	4261	40229134	1998-11-12	1998-11-12 00:00:00	1998-11-19	1998-11-19 00:00:00	1998-11-19	38000177		0	0	7		0	0	0	282942	0	1043400	40229134		
43761	3625	1127433	1991-09-10	1991-09-10 00:00:00	1991-09-24	1991-09-24 00:00:00	1991-09-24	38000177		0	0	14		0	0	0	241063	0	313782	1127433		
6072	507	40222846	2011-09-12	2011-09-12 00:00:00	2011-09-12	2011-09-12 00:00:00	\N	38000177		0	0	0		0	0	0	33950	0	996740	40222846		
57388	4760	19059056	1960-05-28	1960-05-28 00:00:00	1960-06-11	1960-06-11 00:00:00	1960-06-11	38000177		0	0	14		0	0	0	317126	0	243670	19059056		
197438	4338	40213306	1987-09-19	1987-09-19 00:00:00	1987-09-19	1987-09-19 00:00:00	1987-09-19	581452		0	0	0		0	0	0	287654	0	43	40213306		
51029	4239	1118084	1990-06-07	1990-06-07 00:00:00	1990-06-07	1990-06-07 00:00:00	\N	38000177		0	0	0		0	0	0	281534	0	00025152531	44923712		
51063	4241	1713671	1978-12-03	1978-12-03 00:00:00	1978-12-10	1978-12-10 00:00:00	1978-12-10	38000177		0	0	7		0	0	0	281753	0	562251	1713671		
183256	4026	40213227	1992-04-12	1992-04-12 00:00:00	1992-04-12	1992-04-12 00:00:00	1992-04-12	581452		0	0	0		0	0	0	267653	0	113	40213227		
26338	2166	19133905	2015-04-26	2015-04-26 00:00:00	2015-05-09	2015-05-09 00:00:00	2015-05-09	38000177		0	0	13		0	0	0	144318	0	834102	19133905		
202827	4452	40213160	1955-09-09	1955-09-09 00:00:00	1955-09-09	1955-09-09 00:00:00	1955-09-09	581452		0	0	0		0	0	0	296319	0	10	40213160		
105159	2307	40213260	2012-10-09	2012-10-09 00:00:00	2012-10-09	2012-10-09 00:00:00	2012-10-09	581452		0	0	0		0	0	0	153524	0	121	40213260		
28226	2333	1713671	1931-01-01	1931-01-01 00:00:00	1931-01-15	1931-01-15 00:00:00	1931-01-15	38000177		0	0	14		0	0	0	155188	0	562251	1713671		
206033	4522	40213160	1980-12-19	1980-12-19 00:00:00	1980-12-19	1980-12-19 00:00:00	1980-12-19	581452		0	0	0		0	0	0	301133	0	10	40213160		
206088	4523	40213227	2018-02-04	2018-02-04 00:00:00	2018-02-04	2018-02-04 00:00:00	2018-02-04	581452		0	0	0		0	0	0	301147	0	113	40213227		
9071	755	1713671	1978-02-24	1978-02-24 00:00:00	1978-03-17	1978-03-17 00:00:00	1978-03-17	38000177		0	0	21		0	0	0	50062	0	562251	1713671		
55772	4630	920334	1983-03-03	1983-03-03 00:00:00	1983-03-10	1983-03-10 00:00:00	1983-03-10	38000177		0	0	7		0	0	0	308481	0	311995	920334		
206533	4532	40213227	1992-03-21	1992-03-21 00:00:00	1992-03-21	1992-03-21 00:00:00	1992-03-21	581452		0	0	0		0	0	0	301949	0	113	40213227		
114966	2526	40213160	1975-03-31	1975-03-31 00:00:00	1975-03-31	1975-03-31 00:00:00	1975-03-31	581452		0	0	0		0	0	0	166994	0	10	40213160		
7847	656	1118084	2008-04-07	2008-04-07 00:00:00	2008-04-07	2008-04-07 00:00:00	\N	38000177		0	0	0		0	0	0	43457	0	00025152531	44923712		
128130	2818	40213160	1968-05-13	1968-05-13 00:00:00	1968-05-13	1968-05-13 00:00:00	1968-05-13	581452		0	0	0		0	0	0	186758	0	10	40213160		
197117	4331	40213306	1997-01-17	1997-01-17 00:00:00	1997-01-17	1997-01-17 00:00:00	1997-01-17	581452		0	0	0		0	0	0	287307	0	43	40213306		
35945	2959	46275916	1997-10-07	1997-10-07 00:00:00	1997-10-07	1997-10-07 00:00:00	1997-10-07	38000177		0	0	0		0	0	0	197605	0	1660014	46275916		
12983	1091	19133905	2017-02-26	2017-02-26 00:00:00	2017-03-08	2017-03-08 00:00:00	2017-03-08	38000177		0	0	10		0	0	0	71650	0	834102	19133905		
18526	1532	1127433	2006-03-02	2006-03-02 00:00:00	2006-03-16	2006-03-16 00:00:00	2006-03-16	38000177		0	0	14		0	0	0	102608	0	313782	1127433		
14251	1194	1127433	1999-03-30	1999-03-30 00:00:00	1999-04-13	1999-04-13 00:00:00	1999-04-13	38000177		0	0	14		0	0	0	78695	0	313782	1127433		
53002	1159	40213160	1980-11-01	1980-11-01 00:00:00	1980-11-01	1980-11-01 00:00:00	1980-11-01	581452		0	0	0		0	0	0	76589	0	10	40213160		
114106	2507	40213296	2007-10-23	2007-10-23 00:00:00	2007-10-23	2007-10-23 00:00:00	2007-10-23	581452		0	0	0		0	0	0	165960	0	52	40213296		
59379	4935	19008572	1985-09-27	1985-09-27 00:00:00	1985-09-27	1985-09-27 00:00:00	\N	38000177		0	0	0		0	0	0	328104	0	106258	19008572		
56117	4657	40231925	1995-06-13	1995-06-13 00:00:00	1995-06-13	1995-06-13 00:00:00	\N	38000177		0	0	0		0	0	0	310574	0	1049221	40231925		
61977	1354	40213251	1984-03-30	1984-03-30 00:00:00	1984-03-30	1984-03-30 00:00:00	1984-03-30	581452		0	0	0		0	0	0	89731	0	21	40213251		
34282	2833	40229134	1980-04-01	1980-04-01 00:00:00	1980-04-08	1980-04-08 00:00:00	1980-04-08	38000177		0	0	7		0	0	0	188037	0	1043400	40229134		
238684	5240	40213201	2005-12-27	2005-12-27 00:00:00	2005-12-27	2005-12-27 00:00:00	2005-12-27	581452		0	0	0		0	0	0	348687	0	33	40213201		
173819	3822	40213227	2016-05-02	2016-05-02 00:00:00	2016-05-02	2016-05-02 00:00:00	2016-05-02	581452		0	0	0		0	0	0	253906	0	113	40213227		
100006	2190	40213198	2015-08-03	2015-08-03 00:00:00	2015-08-03	2015-08-03 00:00:00	2015-08-03	581452		0	0	0		0	0	0	146033	0	133	40213198		
94386	2071	40213160	1966-02-23	1966-02-23 00:00:00	1966-02-23	1966-02-23 00:00:00	1966-02-23	581452		0	0	0		0	0	0	137816	0	10	40213160		
17304	1435	1127433	2016-09-11	2016-09-11 00:00:00	2016-09-18	2016-09-18 00:00:00	2016-09-18	38000177		0	0	7		0	0	0	95578	0	313782	1127433		
228032	5007	40213227	2016-07-17	2016-07-17 00:00:00	2016-07-17	2016-07-17 00:00:00	2016-07-17	581452		0	0	0		0	0	0	333021	0	113	40213227		
204943	4498	40213314	1977-11-01	1977-11-01 00:00:00	1977-11-01	1977-11-01 00:00:00	1977-11-01	581452		0	0	0		0	0	0	299441	0	49	40213314		
17398	376	40213260	2011-04-28	2011-04-28 00:00:00	2011-04-28	2011-04-28 00:00:00	2011-04-28	581452		0	0	0		0	0	0	24885	0	121	40213260		
78515	1718	40213160	1971-08-28	1971-08-28 00:00:00	1971-08-28	1971-08-28 00:00:00	1971-08-28	581452		0	0	0		0	0	0	114875	0	10	40213160		
228367	5015	40213160	1968-05-13	1968-05-13 00:00:00	1968-05-13	1968-05-13 00:00:00	1968-05-13	581452		0	0	0		0	0	0	333385	0	10	40213160		
196812	4325	40213306	1986-06-03	1986-06-03 00:00:00	1986-06-03	1986-06-03 00:00:00	1986-06-03	581452		0	0	0		0	0	0	286914	0	43	40213306		
196847	4325	40213160	1965-06-29	1965-06-29 00:00:00	1965-06-29	1965-06-29 00:00:00	1965-06-29	581452		0	0	0		0	0	0	286899	0	10	40213160		
52012	4325	19133873	1969-01-03	1969-01-03 00:00:00	1969-01-11	1969-01-11 00:00:00	1969-01-11	38000177		0	0	8		0	0	0	286884	0	834061	19133873		
172400	3789	40213198	2010-07-15	2010-07-15 00:00:00	2010-07-15	2010-07-15 00:00:00	2010-07-15	581452		0	0	0		0	0	0	251868	0	133	40213198		
43650	3618	920300	1931-02-12	1931-02-12 00:00:00	1931-02-19	1931-02-19 00:00:00	1931-02-19	38000177		0	0	7		0	0	0	240449	0	311989	920300		
240315	5276	40213260	2009-12-27	2009-12-27 00:00:00	2009-12-27	2009-12-27 00:00:00	2009-12-27	581452		0	0	0		0	0	0	350871	0	121	40213260		
62116	1357	40213160	1975-04-04	1975-04-04 00:00:00	1975-04-04	1975-04-04 00:00:00	1975-04-04	581452		0	0	0		0	0	0	89981	0	10	40213160		
4219	350	40162522	1995-09-12	1995-09-12 00:00:00	1995-09-12	1995-09-12 00:00:00	\N	38000177		0	0	0		0	0	0	23293	0	857005	40162522		
121804	2677	40213227	2003-09-06	2003-09-06 00:00:00	2003-09-06	2003-09-06 00:00:00	2003-09-06	581452		0	0	0		0	0	0	177386	0	113	40213227		
112879	2480	40213227	2016-11-02	2016-11-02 00:00:00	2016-11-02	2016-11-02 00:00:00	2016-11-02	581452		0	0	0		0	0	0	164295	0	113	40213227		
22125	480	40213227	1999-03-24	1999-03-24 00:00:00	1999-03-24	1999-03-24 00:00:00	1999-03-24	581452		0	0	0		0	0	0	32013	0	113	40213227		
18845	1556	1127433	1996-10-26	1996-10-26 00:00:00	1996-11-09	1996-11-09 00:00:00	1996-11-09	38000177		0	0	14		0	0	0	104156	0	313782	1127433		
133226	2925	40213227	2002-01-20	2002-01-20 00:00:00	2002-01-20	2002-01-20 00:00:00	2002-01-20	581452		0	0	0		0	0	0	195068	0	113	40213227		
87944	1929	40213260	2007-03-01	2007-03-01 00:00:00	2007-03-01	2007-03-01 00:00:00	2007-03-01	581452		0	0	0		0	0	0	128423	0	121	40213260		
137739	3023	40213227	2013-01-05	2013-01-05 00:00:00	2013-01-05	2013-01-05 00:00:00	2013-01-05	581452		0	0	0		0	0	0	201512	0	113	40213227		
12146	262	40213227	2015-08-10	2015-08-10 00:00:00	2015-08-10	2015-08-10 00:00:00	2015-08-10	581452		0	0	0		0	0	0	17377	0	113	40213227		
12815	1079	19078461	1988-01-25	1988-01-25 00:00:00	1988-02-15	1988-02-15 00:00:00	1988-02-15	38000177		0	0	21		0	0	0	70770	0	310965	19078461		
180098	3958	40213227	2002-08-25	2002-08-25 00:00:00	2002-08-25	2002-08-25 00:00:00	2002-08-25	581452		0	0	0		0	0	0	263169	0	113	40213227		
180168	3960	40213160	1963-01-19	1963-01-19 00:00:00	1963-01-19	1963-01-19 00:00:00	1963-01-19	581452		0	0	0		0	0	0	\N	0	10	40213160		
40640	3370	1127433	2005-05-04	2005-05-04 00:00:00	2005-05-18	2005-05-18 00:00:00	2005-05-18	38000177		0	0	14		0	0	0	223486	0	313782	1127433		
153659	3382	40213160	1962-07-26	1962-07-26 00:00:00	1962-07-26	1962-07-26 00:00:00	1962-07-26	581452		0	0	0		0	0	0	224465	0	10	40213160		
203491	4467	40213227	2002-07-04	2002-07-04 00:00:00	2002-07-04	2002-07-04 00:00:00	2002-07-04	581452		0	0	0		0	0	0	297170	0	113	40213227		
191617	4210	40213160	1975-07-12	1975-07-12 00:00:00	1975-07-12	1975-07-12 00:00:00	1975-07-12	581452		0	0	0		0	0	0	279543	0	10	40213160		
51284	4261	19133905	1995-11-03	1995-11-03 00:00:00	1995-11-15	1995-11-15 00:00:00	1995-11-15	38000177		0	0	12		0	0	0	282941	0	834102	19133905		
43762	3625	40174880	2010-06-30	2010-06-30 00:00:00	2010-06-30	2010-06-30 00:00:00	\N	38000177		0	0	0		0	0	0	241040	0	966222	40174880		
6073	507	1127433	1994-08-04	1994-08-04 00:00:00	1994-08-18	1994-08-18 00:00:00	1994-08-18	38000177		0	0	14		0	0	0	33978	0	313782	1127433		
57389	4760	19075601	2018-03-28	2018-03-28 00:00:00	2018-03-28	2018-03-28 00:00:00	2018-03-28	38000177		0	0	0		0	0	0	317165	0	309362	19075601		
197442	4338	40213160	1966-03-19	1966-03-19 00:00:00	1966-03-19	1966-03-19 00:00:00	1966-03-19	581452		0	0	0		0	0	0	287677	0	10	40213160		
51030	4239	40169216	1952-10-01	1952-10-01 00:00:00	1952-10-01	1952-10-01 00:00:00	\N	38000177		0	0	0		0	0	0	281536	0	895994	40169216		
51064	4241	1713671	1966-08-23	1966-08-23 00:00:00	1966-08-30	1966-08-30 00:00:00	1966-08-30	38000177		0	0	7		0	0	0	281699	0	562251	1713671		
183263	4026	40213160	1958-07-06	1958-07-06 00:00:00	1958-07-06	1958-07-06 00:00:00	1958-07-06	581452		0	0	0		0	0	0	267646	0	10	40213160		
26339	2167	1713671	1997-07-20	1997-07-20 00:00:00	1997-08-10	1997-08-10 00:00:00	1997-08-10	38000177		0	0	21		0	0	0	144348	0	562251	1713671		
202829	4452	40213260	2007-06-15	2007-06-15 00:00:00	2007-06-15	2007-06-15 00:00:00	2007-06-15	581452		0	0	0		0	0	0	296239	0	121	40213260		
105161	2307	40213160	1962-03-13	1962-03-13 00:00:00	1962-03-13	1962-03-13 00:00:00	1962-03-13	581452		0	0	0		0	0	0	153494	0	10	40213160		
28227	2333	1127433	1990-03-20	1990-03-20 00:00:00	1990-04-24	1990-04-24 00:00:00	1990-04-24	38000177		0	0	35		0	0	0	155163	0	313782	1127433		
206035	4522	40213314	1977-12-16	1977-12-16 00:00:00	1977-12-16	1977-12-16 00:00:00	1977-12-16	581452		0	0	0		0	0	0	301132	0	49	40213314		
206089	4523	40213296	2018-02-04	2018-02-04 00:00:00	2018-02-04	2018-02-04 00:00:00	2018-02-04	581452		0	0	0		0	0	0	301147	0	52	40213296		
9072	755	1127433	2018-10-14	2018-10-14 00:00:00	2019-01-12	2019-01-12 00:00:00	2019-01-12	38000177		0	0	90		0	0	0	50013	0	313782	1127433		
55773	4631	1127433	1918-12-21	1918-12-21 00:00:00	1918-12-28	1918-12-28 00:00:00	1918-12-28	38000177		0	0	7		0	0	0	308601	0	313782	1127433		
121693	2674	40213160	1971-08-06	1971-08-06 00:00:00	1971-08-06	1971-08-06 00:00:00	1971-08-06	581452		0	0	0		0	0	0	177209	0	10	40213160		
114970	2526	40213296	2014-12-29	2014-12-29 00:00:00	2014-12-29	2014-12-29 00:00:00	2014-12-29	581452		0	0	0		0	0	0	167024	0	52	40213296		
7848	656	1115171	1999-09-27	1999-09-27 00:00:00	1999-11-01	1999-11-01 00:00:00	1999-11-01	38000177		0	0	35		0	0	0	43425	0	849574	1115171		
128136	2818	40213160	1972-07-31	1972-07-31 00:00:00	1972-07-31	1972-07-31 00:00:00	1972-07-31	581452		0	0	0		0	0	0	186735	0	10	40213160		
197119	4331	40213227	1997-01-17	1997-01-17 00:00:00	1997-01-17	1997-01-17 00:00:00	1997-01-17	581452		0	0	0		0	0	0	287307	0	113	40213227		
35946	2959	1127078	1975-03-31	1975-03-31 00:00:00	1975-06-29	1975-06-29 00:00:00	1975-06-29	38000177		0	0	90		0	0	0	197602	0	282464	1127078		
12984	1091	40229134	1971-01-22	1971-01-22 00:00:00	1971-01-29	1971-01-29 00:00:00	1971-01-29	38000177		0	0	7		0	0	0	71675	0	1043400	40229134		
18527	1532	19019979	1981-01-01	1981-01-01 00:00:00	1981-01-15	1981-01-15 00:00:00	1981-01-15	38000177		0	0	14		0	0	0	102612	0	198405	19019979		
14252	1194	1127433	1995-07-09	1995-07-09 00:00:00	1995-10-07	1995-10-07 00:00:00	1995-10-07	38000177		0	0	90		0	0	0	78688	0	313782	1127433		
53004	1159	40213251	1985-07-06	1985-07-06 00:00:00	1985-07-06	1985-07-06 00:00:00	1985-07-06	581452		0	0	0		0	0	0	76566	0	21	40213251		
114120	2507	40213227	1998-07-14	1998-07-14 00:00:00	1998-07-14	1998-07-14 00:00:00	1998-07-14	581452		0	0	0		0	0	0	165989	0	113	40213227		
59380	4935	40232448	1985-10-11	1985-10-11 00:00:00	1985-10-11	1985-10-11 00:00:00	\N	38000177		0	0	0		0	0	0	328074	0	1049630	40232448		
56118	4657	1127433	2009-06-11	2009-06-11 00:00:00	2009-06-18	2009-06-18 00:00:00	2009-06-18	38000177		0	0	7		0	0	0	310517	0	313782	1127433		
4884	105	40213296	2005-06-17	2005-06-17 00:00:00	2005-06-17	2005-06-17 00:00:00	2005-06-17	581452		0	0	0		0	0	0	7119	0	52	40213296		
34283	2833	40222846	2009-02-12	2009-02-12 00:00:00	2009-02-12	2009-02-12 00:00:00	\N	38000177		0	0	0		0	0	0	188089	0	996740	40222846		
238689	5240	40213227	1992-10-13	1992-10-13 00:00:00	1992-10-13	1992-10-13 00:00:00	1992-10-13	581452		0	0	0		0	0	0	348684	0	113	40213227		
173825	3822	40213227	2006-03-06	2006-03-06 00:00:00	2006-03-06	2006-03-06 00:00:00	2006-03-06	581452		0	0	0		0	0	0	253829	0	113	40213227		
100020	2191	40213227	2012-04-29	2012-04-29 00:00:00	2012-04-29	2012-04-29 00:00:00	2012-04-29	581452		0	0	0		0	0	0	146085	0	113	40213227		
94388	2071	40213160	1965-09-22	1965-09-22 00:00:00	1965-09-22	1965-09-22 00:00:00	1965-09-22	581452		0	0	0		0	0	0	137824	0	10	40213160		
17305	1435	19133873	1975-11-17	1975-11-17 00:00:00	1975-11-24	1975-11-24 00:00:00	1975-11-24	38000177		0	0	7		0	0	0	95574	0	834061	19133873		
239327	5253	40213227	1997-12-20	1997-12-20 00:00:00	1997-12-20	1997-12-20 00:00:00	1997-12-20	581452		0	0	0		0	0	0	349537	0	113	40213227		
204944	4498	40213160	1977-11-01	1977-11-01 00:00:00	1977-11-01	1977-11-01 00:00:00	1977-11-01	581452		0	0	0		0	0	0	299441	0	10	40213160		
17407	376	40213227	2012-05-03	2012-05-03 00:00:00	2012-05-03	2012-05-03 00:00:00	2012-05-03	581452		0	0	0		0	0	0	24874	0	113	40213227		
78528	1718	40213160	1966-12-24	1966-12-24 00:00:00	1966-12-24	1966-12-24 00:00:00	1966-12-24	581452		0	0	0		0	0	0	114859	0	10	40213160		
228368	5015	40213227	2019-02-11	2019-02-11 00:00:00	2019-02-11	2019-02-11 00:00:00	2019-02-11	581452		0	0	0		0	0	0	333338	0	113	40213227		
232054	5099	40213227	2014-07-05	2014-07-05 00:00:00	2014-07-05	2014-07-05 00:00:00	2014-07-05	581452		0	0	0		0	0	0	338828	0	113	40213227		
196852	4325	40213260	2015-09-01	2015-09-01 00:00:00	2015-09-01	2015-09-01 00:00:00	2015-09-01	581452		0	0	0		0	0	0	286918	0	121	40213260		
52013	4325	1127433	2012-02-04	2012-02-04 00:00:00	2012-02-18	2012-02-18 00:00:00	2012-02-18	38000177		0	0	14		0	0	0	286927	0	313782	1127433		
172406	3789	40213227	2005-10-06	2005-10-06 00:00:00	2005-10-06	2005-10-06 00:00:00	2005-10-06	581452		0	0	0		0	0	0	251930	0	113	40213227		
43651	3618	1127433	1956-12-23	1956-12-23 00:00:00	1957-01-06	1957-01-06 00:00:00	1957-01-06	38000177		0	0	14		0	0	0	240450	0	313782	1127433		
240317	5276	40213296	1998-01-25	1998-01-25 00:00:00	1998-01-25	1998-01-25 00:00:00	1998-01-25	581452		0	0	0		0	0	0	350952	0	52	40213296		
62120	1357	40213160	1979-11-02	1979-11-02 00:00:00	1979-11-02	1979-11-02 00:00:00	1979-11-02	581452		0	0	0		0	0	0	90003	0	10	40213160		
4220	350	42707627	1995-09-11	1995-09-11 00:00:00	1995-09-11	1995-09-11 00:00:00	1995-09-11	38000177		0	0	0		0	0	0	23293	0	1234995	42707627		
121809	2677	40213296	2012-04-14	2012-04-14 00:00:00	2012-04-14	2012-04-14 00:00:00	2012-04-14	581452		0	0	0		0	0	0	177388	0	52	40213296		
217092	4763	40213227	2012-05-22	2012-05-22 00:00:00	2012-05-22	2012-05-22 00:00:00	2012-05-22	581452		0	0	0		0	0	0	317402	0	113	40213227		
76531	1672	40213227	1994-07-13	1994-07-13 00:00:00	1994-07-13	1994-07-13 00:00:00	1994-07-13	581452		0	0	0		0	0	0	112287	0	113	40213227		
43903	3637	40229134	1991-05-21	1991-05-21 00:00:00	1991-05-28	1991-05-28 00:00:00	1991-05-28	38000177		0	0	7		0	0	0	241922	0	1043400	40229134		
133231	2925	40213260	2010-01-10	2010-01-10 00:00:00	2010-01-10	2010-01-10 00:00:00	2010-01-10	581452		0	0	0		0	0	0	195123	0	121	40213260		
87949	1929	40213160	1955-07-28	1955-07-28 00:00:00	1955-07-28	1955-07-28 00:00:00	1955-07-28	581452		0	0	0		0	0	0	128468	0	10	40213160		
228245	5013	40213160	1969-08-01	1969-08-01 00:00:00	1969-08-01	1969-08-01 00:00:00	1969-08-01	581452		0	0	0		0	0	0	333213	0	10	40213160		
12148	262	40213260	2015-08-10	2015-08-10 00:00:00	2015-08-10	2015-08-10 00:00:00	2015-08-10	581452		0	0	0		0	0	0	17377	0	121	40213260		
12816	1079	40236824	2016-05-14	2016-05-14 00:00:00	2016-05-21	2016-05-21 00:00:00	2016-05-21	38000177		0	0	7		0	0	0	70717	0	1094107	40236824		
180100	3958	40213296	2002-08-25	2002-08-25 00:00:00	2002-08-25	2002-08-25 00:00:00	2002-08-25	581452		0	0	0		0	0	0	263169	0	52	40213296		
180179	3960	40213227	1992-04-25	1992-04-25 00:00:00	1992-04-25	1992-04-25 00:00:00	1992-04-25	581452		0	0	0		0	0	0	263285	0	113	40213227		
40641	3370	1127078	1984-06-21	1984-06-21 00:00:00	1984-07-12	1984-07-12 00:00:00	1984-07-12	38000177		0	0	21		0	0	0	223393	0	282464	1127078		
153662	3382	40213227	1995-10-12	1995-10-12 00:00:00	1995-10-12	1995-10-12 00:00:00	1995-10-12	581452		0	0	0		0	0	0	224422	0	113	40213227		
203497	4467	40213160	1956-06-07	1956-06-07 00:00:00	1956-06-07	1956-06-07 00:00:00	1956-06-07	581452		0	0	0		0	0	0	297214	0	10	40213160		
191620	4210	40213160	1980-03-15	1980-03-15 00:00:00	1980-03-15	1980-03-15 00:00:00	1980-03-15	581452		0	0	0		0	0	0	279557	0	10	40213160		
51285	4261	1127433	1983-03-14	1983-03-14 00:00:00	1983-03-21	1983-03-21 00:00:00	1983-03-21	38000177		0	0	7		0	0	0	282890	0	313782	1127433		
43763	3625	1127433	1964-10-15	1964-10-15 00:00:00	1964-10-29	1964-10-29 00:00:00	1964-10-29	38000177		0	0	14		0	0	0	241075	0	313782	1127433		
6074	507	1118084	1977-10-03	1977-10-03 00:00:00	1977-10-03	1977-10-03 00:00:00	\N	38000177		0	0	0		0	0	0	33914	0	00025152531	44923712		
57390	4760	40220960	2018-03-28	2018-03-28 00:00:00	2018-03-28	2018-03-28 00:00:00	2018-03-28	38000177		0	0	0		0	0	0	317165	0	1804799	40220960		
97152	2130	40213296	2001-05-03	2001-05-03 00:00:00	2001-05-03	2001-05-03 00:00:00	2001-05-03	581452		0	0	0		0	0	0	141689	0	52	40213296		
51031	4239	1154615	1952-10-01	1952-10-01 00:00:00	1952-10-01	1952-10-01 00:00:00	\N	38000177		0	0	0		0	0	0	281536	0	745679	1154615		
51065	4241	1127433	1987-12-26	1987-12-26 00:00:00	1988-01-09	1988-01-09 00:00:00	1988-01-09	38000177		0	0	14		0	0	0	281694	0	313782	1127433		
79414	1738	40213160	1969-01-26	1969-01-26 00:00:00	1969-01-26	1969-01-26 00:00:00	1969-01-26	581452		0	0	0		0	0	0	116140	0	10	40213160		
26340	2167	1127433	2018-02-27	2018-02-27 00:00:00	2018-04-03	2018-04-03 00:00:00	2018-04-03	38000177		0	0	35		0	0	0	144345	0	313782	1127433		
202839	4452	40213160	1956-02-10	1956-02-10 00:00:00	1956-02-10	1956-02-10 00:00:00	1956-02-10	581452		0	0	0		0	0	0	296320	0	10	40213160		
140391	3082	40213227	2016-08-10	2016-08-10 00:00:00	2016-08-10	2016-08-10 00:00:00	2016-08-10	581452		0	0	0		0	0	0	205234	0	113	40213227		
28228	2333	1713671	1971-09-21	1971-09-21 00:00:00	1971-10-12	1971-10-12 00:00:00	1971-10-12	38000177		0	0	21		0	0	0	155191	0	562251	1713671		
206039	4522	40213160	1976-06-18	1976-06-18 00:00:00	1976-06-18	1976-06-18 00:00:00	1976-06-18	581452		0	0	0		0	0	0	301130	0	10	40213160		
71986	1574	40213160	1959-03-13	1959-03-13 00:00:00	1959-03-13	1959-03-13 00:00:00	1959-03-13	581452		0	0	0		0	0	0	105650	0	10	40213160		
9073	755	19006318	1950-08-18	1950-08-18 00:00:00	1950-08-23	1950-08-23 00:00:00	1950-08-23	38000177		0	0	5		0	0	0	50025	0	105078	19006318		
55774	4631	1127433	1982-06-03	1982-06-03 00:00:00	1982-06-24	1982-06-24 00:00:00	1982-06-24	38000177		0	0	21		0	0	0	308555	0	313782	1127433		
121695	2675	40213296	2001-10-21	2001-10-21 00:00:00	2001-10-21	2001-10-21 00:00:00	2001-10-21	581452		0	0	0		0	0	0	177241	0	52	40213296		
114973	2526	40213160	1975-09-01	1975-09-01 00:00:00	1975-09-01	1975-09-01 00:00:00	1975-09-01	581452		0	0	0		0	0	0	167009	0	10	40213160		
7849	656	40165015	2011-03-31	2011-03-31 00:00:00	2011-03-31	2011-03-31 00:00:00	\N	38000177		0	0	0		0	0	0	43504	0	861467	40165015		
171894	3779	40213160	1975-03-15	1975-03-15 00:00:00	1975-03-15	1975-03-15 00:00:00	1975-03-15	581452		0	0	0		0	0	0	251119	0	10	40213160		
197121	4331	40213160	1975-07-25	1975-07-25 00:00:00	1975-07-25	1975-07-25 00:00:00	1975-07-25	581452		0	0	0		0	0	0	287284	0	10	40213160		
35947	2959	1115171	2005-01-22	2005-01-22 00:00:00	2005-02-05	2005-02-05 00:00:00	2005-02-05	38000177		0	0	14		0	0	0	197606	0	849574	1115171		
12985	1091	19128065	1978-04-23	1978-04-23 00:00:00	1979-04-18	1979-04-18 00:00:00	1979-04-18	38000177		0	0	360		0	0	0	71628	0	749882	19128065		
18528	1532	19074843	1981-01-01	1981-01-01 00:00:00	1981-01-15	1981-01-15 00:00:00	1981-01-15	38000177		0	0	14		0	0	0	102612	0	309045	19074843		
14253	1194	40162522	1995-07-09	1995-07-09 00:00:00	1995-07-09	1995-07-09 00:00:00	\N	38000177		0	0	0		0	0	0	78688	0	857005	40162522		
53005	1159	40213160	1985-07-06	1985-07-06 00:00:00	1985-07-06	1985-07-06 00:00:00	1985-07-06	581452		0	0	0		0	0	0	76566	0	10	40213160		
105701	2319	40213227	2018-08-18	2018-08-18 00:00:00	2018-08-18	2018-08-18 00:00:00	2018-08-18	581452		0	0	0		0	0	0	\N	0	113	40213227		
59381	4935	19075001	2008-06-11	2008-06-11 00:00:00	2008-06-25	2008-06-25 00:00:00	2008-06-25	38000177		0	0	14		0	0	0	328098	0	309097	19075001		
56120	4657	1713671	2001-09-08	2001-09-08 00:00:00	2001-09-22	2001-09-22 00:00:00	2001-09-22	38000177		0	0	14		0	0	0	310554	0	562251	1713671		
4887	105	40213160	1970-05-22	1970-05-22 00:00:00	1970-05-22	1970-05-22 00:00:00	1970-05-22	581452		0	0	0		0	0	0	7129	0	10	40213160		
34284	2833	19133873	1940-04-03	1940-04-03 00:00:00	1940-04-15	1940-04-15 00:00:00	1940-04-15	38000177		0	0	12		0	0	0	188087	0	834061	19133873		
82953	1813	40213314	1981-09-26	1981-09-26 00:00:00	1981-09-26	1981-09-26 00:00:00	1981-09-26	581452		0	0	0		0	0	0	121341	0	49	40213314		
50307	4176	19059056	1920-04-23	1920-04-23 00:00:00	1920-06-22	1920-06-22 00:00:00	1920-06-22	38000177		0	0	60		0	0	0	277541	0	243670	19059056		
100021	2191	40213296	2012-04-29	2012-04-29 00:00:00	2012-04-29	2012-04-29 00:00:00	2012-04-29	581452		0	0	0		0	0	0	146085	0	52	40213296		
94391	2071	40213227	1999-05-12	1999-05-12 00:00:00	1999-05-12	1999-05-12 00:00:00	1999-05-12	581452		0	0	0		0	0	0	137825	0	113	40213227		
17306	1435	19075001	2014-03-12	2014-03-12 00:00:00	2014-03-26	2014-03-26 00:00:00	2014-03-26	38000177		0	0	14		0	0	0	95579	0	309097	19075001		
239328	5253	40213296	1997-12-20	1997-12-20 00:00:00	1997-12-20	1997-12-20 00:00:00	1997-12-20	581452		0	0	0		0	0	0	349537	0	52	40213296		
204947	4498	40213251	1984-01-03	1984-01-03 00:00:00	1984-01-03	1984-01-03 00:00:00	1984-01-03	581452		0	0	0		0	0	0	299448	0	21	40213251		
17408	376	40213260	2012-05-03	2012-05-03 00:00:00	2012-05-03	2012-05-03 00:00:00	2012-05-03	581452		0	0	0		0	0	0	24874	0	121	40213260		
78530	1718	40213260	2016-11-05	2016-11-05 00:00:00	2016-11-05	2016-11-05 00:00:00	2016-11-05	581452		0	0	0		0	0	0	114830	0	121	40213260		
228369	5015	40213260	2019-02-11	2019-02-11 00:00:00	2019-02-11	2019-02-11 00:00:00	2019-02-11	581452		0	0	0		0	0	0	333338	0	121	40213260		
232060	5099	40213227	2004-05-08	2004-05-08 00:00:00	2004-05-08	2004-05-08 00:00:00	2004-05-08	581452		0	0	0		0	0	0	338856	0	113	40213227		
196853	4325	40213160	1970-01-20	1970-01-20 00:00:00	1970-01-20	1970-01-20 00:00:00	1970-01-20	581452		0	0	0		0	0	0	286939	0	10	40213160		
52014	4325	40229134	1972-09-14	1972-09-14 00:00:00	1972-09-21	1972-09-21 00:00:00	1972-09-21	38000177		0	0	7		0	0	0	286936	0	1043400	40229134		
172415	3790	40213260	2014-06-02	2014-06-02 00:00:00	2014-06-02	2014-06-02 00:00:00	2014-06-02	581452		0	0	0		0	0	0	251994	0	121	40213260		
43652	3618	1127433	1982-06-20	1982-06-20 00:00:00	1982-09-18	1982-09-18 00:00:00	1982-09-18	38000177		0	0	90		0	0	0	240343	0	313782	1127433		
240327	5276	40213160	1962-06-24	1962-06-24 00:00:00	1962-06-24	1962-06-24 00:00:00	1962-06-24	581452		0	0	0		0	0	0	\N	0	10	40213160		
62122	1357	40213306	1997-06-20	1997-06-20 00:00:00	1997-06-20	1997-06-20 00:00:00	1997-06-20	581452		0	0	0		0	0	0	90011	0	43	40213306		
4221	350	35605482	1995-09-11	1995-09-11 00:00:00	1995-09-11	1995-09-11 00:00:00	1995-09-11	38000177		0	0	0		0	0	0	23293	0	1740467	35605482		
9961	212	40213160	1975-03-01	1975-03-01 00:00:00	1975-03-01	1975-03-01 00:00:00	1975-03-01	581452		0	0	0		0	0	0	14457	0	10	40213160		
217100	4763	40213198	2016-06-14	2016-06-14 00:00:00	2016-06-14	2016-06-14 00:00:00	2016-06-14	581452		0	0	0		0	0	0	317434	0	133	40213198		
76540	1672	40213227	2004-11-17	2004-11-17 00:00:00	2004-11-17	2004-11-17 00:00:00	2004-11-17	581452		0	0	0		0	0	0	112275	0	113	40213227		
43904	3637	1127433	1973-04-09	1973-04-09 00:00:00	1973-04-16	1973-04-16 00:00:00	1973-04-16	38000177		0	0	7		0	0	0	241942	0	313782	1127433		
133235	2925	40213306	1982-03-14	1982-03-14 00:00:00	1982-03-14	1982-03-14 00:00:00	1982-03-14	581452		0	0	0		0	0	0	195055	0	43	40213306		
87950	1929	40213160	1959-07-30	1959-07-30 00:00:00	1959-07-30	1959-07-30 00:00:00	1959-07-30	581452		0	0	0		0	0	0	128405	0	10	40213160		
228251	5013	40213306	1987-06-19	1987-06-19 00:00:00	1987-06-19	1987-06-19 00:00:00	1987-06-19	581452		0	0	0		0	0	0	333180	0	43	40213306		
12149	262	40213160	1964-11-09	1964-11-09 00:00:00	1964-11-09	1964-11-09 00:00:00	1964-11-09	581452		0	0	0		0	0	0	17366	0	10	40213160		
12817	1079	920300	2016-05-14	2016-05-14 00:00:00	2016-05-21	2016-05-21 00:00:00	2016-05-21	38000177		0	0	7		0	0	0	70717	0	311989	920300		
180103	3958	40213306	1983-03-20	1983-03-20 00:00:00	1983-03-20	1983-03-20 00:00:00	1983-03-20	581452		0	0	0		0	0	0	263148	0	43	40213306		
180183	3960	40213306	1981-12-19	1981-12-19 00:00:00	1981-12-19	1981-12-19 00:00:00	1981-12-19	581452		0	0	0		0	0	0	263284	0	43	40213306		
40642	3370	1124300	2011-10-30	2011-10-30 00:00:00	2011-10-30	2011-10-30 00:00:00	\N	38000177		0	0	0		0	0	0	223465	0	00781178901	45011828		
153666	3382	40213160	1967-01-26	1967-01-26 00:00:00	1967-01-26	1967-01-26 00:00:00	1967-01-26	581452		0	0	0		0	0	0	224406	0	10	40213160		
64667	1415	40213227	2000-06-25	2000-06-25 00:00:00	2000-06-25	2000-06-25 00:00:00	2000-06-25	581452		0	0	0		0	0	0	94209	0	113	40213227		
191622	4210	40213227	2007-02-10	2007-02-10 00:00:00	2007-02-10	2007-02-10 00:00:00	2007-02-10	581452		0	0	0		0	0	0	279537	0	113	40213227		
51286	4261	19059056	1957-08-05	1957-08-05 00:00:00	1957-08-26	1957-08-26 00:00:00	1957-08-26	38000177		0	0	21		0	0	0	282891	0	243670	19059056		
43764	3625	19006318	1957-11-05	1957-11-05 00:00:00	1957-11-19	1957-11-19 00:00:00	1957-11-19	38000177		0	0	14		0	0	0	241077	0	105078	19006318		
6075	507	40229134	1944-01-21	1944-01-21 00:00:00	1944-01-28	1944-01-28 00:00:00	1944-01-28	38000177		0	0	7		0	0	0	33961	0	1043400	40229134		
57391	4760	19059056	1956-10-16	1956-10-16 00:00:00	1956-11-22	1956-11-22 00:00:00	1956-11-22	38000177		0	0	37		0	0	0	317194	0	243670	19059056		
97168	2130	40213160	1958-02-13	1958-02-13 00:00:00	1958-02-13	1958-02-13 00:00:00	1958-02-13	581452		0	0	0		0	0	0	141709	0	10	40213160		
51033	4239	19077572	2019-01-19	2019-01-19 00:00:00	2019-01-19	2019-01-19 00:00:00	\N	38000177		0	0	0		0	0	0	281490	0	310436	19077572		
51066	4241	19073188	1987-12-26	1987-12-26 00:00:00	1988-01-09	1988-01-09 00:00:00	1988-01-09	38000177		0	0	14		0	0	0	281694	0	308192	19073188		
79415	1738	40213160	1968-10-27	1968-10-27 00:00:00	1968-10-27	1968-10-27 00:00:00	1968-10-27	581452		0	0	0		0	0	0	116136	0	10	40213160		
26341	2167	1127078	1979-05-09	1979-05-09 00:00:00	1979-05-23	1979-05-23 00:00:00	1979-05-23	38000177		0	0	14		0	0	0	144366	0	282464	1127078		
202850	4452	40213160	1960-05-13	1960-05-13 00:00:00	1960-05-13	1960-05-13 00:00:00	1960-05-13	581452		0	0	0		0	0	0	296304	0	10	40213160		
140398	3083	40213198	2016-07-24	2016-07-24 00:00:00	2016-07-24	2016-07-24 00:00:00	2016-07-24	581452		0	0	0		0	0	0	205282	0	133	40213198		
28229	2333	1713671	1938-06-16	1938-06-16 00:00:00	1938-06-23	1938-06-23 00:00:00	1938-06-23	38000177		0	0	7		0	0	0	155200	0	562251	1713671		
206040	4522	40213314	1977-06-17	1977-06-17 00:00:00	1977-06-17	1977-06-17 00:00:00	1977-06-17	581452		0	0	0		0	0	0	301121	0	49	40213314		
71989	1574	40213296	1998-10-09	1998-10-09 00:00:00	1998-10-09	1998-10-09 00:00:00	1998-10-09	581452		0	0	0		0	0	0	105669	0	52	40213296		
9074	756	19059056	1966-08-29	1966-08-29 00:00:00	1966-09-12	1966-09-12 00:00:00	1966-09-12	38000177		0	0	14		0	0	0	50122	0	243670	19059056		
55775	4631	40229134	1939-10-21	1939-10-21 00:00:00	1939-11-04	1939-11-04 00:00:00	1939-11-04	38000177		0	0	14		0	0	0	308573	0	1043400	40229134		
121699	2675	40213227	2012-02-05	2012-02-05 00:00:00	2012-02-05	2012-02-05 00:00:00	2012-02-05	581452		0	0	0		0	0	0	177310	0	113	40213227		
114974	2526	40213314	1977-05-30	1977-05-30 00:00:00	1977-05-30	1977-05-30 00:00:00	1977-05-30	581452		0	0	0		0	0	0	166995	0	49	40213314		
7850	656	1115171	2011-03-31	2011-03-31 00:00:00	2011-04-30	2011-04-30 00:00:00	2011-04-30	38000177		0	0	30		0	0	0	43504	0	849574	1115171		
171897	3779	40213296	2010-04-10	2010-04-10 00:00:00	2010-04-10	2010-04-10 00:00:00	2010-04-10	581452		0	0	0		0	0	0	251163	0	52	40213296		
34613	756	40213296	2009-01-21	2009-01-21 00:00:00	2009-01-21	2009-01-21 00:00:00	2009-01-21	581452		0	0	0		0	0	0	50153	0	52	40213296		
35948	2959	40169216	1973-12-28	1973-12-28 00:00:00	1993-02-23	1993-02-23 00:00:00	1993-02-23	38000177		0	0	6997		0	0	0	197474	0	895994	40169216		
12987	1091	1127433	1966-05-18	1966-05-18 00:00:00	1966-05-25	1966-05-25 00:00:00	1966-05-25	38000177		0	0	7		0	0	0	71593	0	313782	1127433		
18529	1532	19128022	1993-09-14	1993-09-14 00:00:00	1994-09-09	1994-09-09 00:00:00	1994-09-09	38000177		0	0	360		0	0	0	102604	0	749785	19128022		
14254	1194	1127433	2003-06-30	2003-06-30 00:00:00	2003-07-14	2003-07-14 00:00:00	2003-07-14	38000177		0	0	14		0	0	0	78712	0	313782	1127433		
53010	1159	40213251	1983-12-31	1983-12-31 00:00:00	1983-12-31	1983-12-31 00:00:00	1983-12-31	581452		0	0	0		0	0	0	76565	0	21	40213251		
105704	2319	40213227	2008-04-05	2008-04-05 00:00:00	2008-04-05	2008-04-05 00:00:00	2008-04-05	581452		0	0	0		0	0	0	154206	0	113	40213227		
59382	4935	19078461	2008-06-11	2008-06-11 00:00:00	2008-06-25	2008-06-25 00:00:00	2008-06-25	38000177		0	0	14		0	0	0	328098	0	310965	19078461		
56121	4657	19133873	1973-01-02	1973-01-02 00:00:00	1973-01-10	1973-01-10 00:00:00	1973-01-10	38000177		0	0	8		0	0	0	310549	0	834061	19133873		
2045	161	19078461	1991-05-16	1991-05-16 00:00:00	1991-05-30	1991-05-30 00:00:00	1991-05-30	38000177		0	0	14		0	0	0	11033	0	310965	19078461		
34285	2833	1127433	1947-06-15	1947-06-15 00:00:00	1947-06-22	1947-06-22 00:00:00	1947-06-22	38000177		0	0	7		0	0	0	188034	0	313782	1127433		
82954	1813	40213160	1981-09-26	1981-09-26 00:00:00	1981-09-26	1981-09-26 00:00:00	1981-09-26	581452		0	0	0		0	0	0	121341	0	10	40213160		
50308	4176	40229134	1977-09-29	1977-09-29 00:00:00	1977-10-06	1977-10-06 00:00:00	1977-10-06	38000177		0	0	7		0	0	0	277492	0	1043400	40229134		
100026	2191	40213296	2010-04-25	2010-04-25 00:00:00	2010-04-25	2010-04-25 00:00:00	2010-04-25	581452		0	0	0		0	0	0	146126	0	52	40213296		
94399	2071	40213260	2017-06-21	2017-06-21 00:00:00	2017-06-21	2017-06-21 00:00:00	2017-06-21	581452		0	0	0		0	0	0	137787	0	121	40213260		
72909	1593	40213227	2016-02-25	2016-02-25 00:00:00	2016-02-25	2016-02-25 00:00:00	2016-02-25	581452		0	0	0		0	0	0	106917	0	113	40213227		
239335	5253	40213160	1956-08-18	1956-08-18 00:00:00	1956-08-18	1956-08-18 00:00:00	1956-08-18	581452		0	0	0		0	0	0	349487	0	10	40213160		
204950	4498	40213227	2011-05-24	2011-05-24 00:00:00	2011-05-24	2011-05-24 00:00:00	2011-05-24	581452		0	0	0		0	0	0	299498	0	113	40213227		
17409	376	40213227	2003-05-08	2003-05-08 00:00:00	2003-05-08	2003-05-08 00:00:00	2003-05-08	581452		0	0	0		0	0	0	24952	0	113	40213227		
78536	1718	40213160	1967-05-27	1967-05-27 00:00:00	1967-05-27	1967-05-27 00:00:00	1967-05-27	581452		0	0	0		0	0	0	114832	0	10	40213160		
228373	5015	40213160	1968-07-15	1968-07-15 00:00:00	1968-07-15	1968-07-15 00:00:00	1968-07-15	581452		0	0	0		0	0	0	333351	0	10	40213160		
232065	5099	40213198	2010-06-12	2010-06-12 00:00:00	2010-06-12	2010-06-12 00:00:00	2010-06-12	581452		0	0	0		0	0	0	338811	0	133	40213198		
204077	4480	40213227	2003-02-11	2003-02-11 00:00:00	2003-02-11	2003-02-11 00:00:00	2003-02-11	581452		0	0	0		0	0	0	298182	0	113	40213227		
52033	4328	40229134	1993-12-31	1993-12-31 00:00:00	1994-01-14	1994-01-14 00:00:00	1994-01-14	38000177		0	0	14		0	0	0	287015	0	1043400	40229134		
172418	3790	40213227	1995-05-01	1995-05-01 00:00:00	1995-05-01	1995-05-01 00:00:00	1995-05-01	581452		0	0	0		0	0	0	251977	0	113	40213227		
43653	3618	1713671	1991-02-20	1991-02-20 00:00:00	1991-03-13	1991-03-13 00:00:00	1991-03-13	38000177		0	0	21		0	0	0	240346	0	562251	1713671		
89839	1971	40213160	1969-08-22	1969-08-22 00:00:00	1969-08-22	1969-08-22 00:00:00	1969-08-22	581452		0	0	0		0	0	0	131117	0	10	40213160		
62124	1357	40213227	1997-06-20	1997-06-20 00:00:00	1997-06-20	1997-06-20 00:00:00	1997-06-20	581452		0	0	0		0	0	0	90011	0	113	40213227		
4222	350	35605482	1995-09-11	1995-09-11 00:00:00	1995-09-11	1995-09-11 00:00:00	1995-09-11	38000177		0	0	0		0	0	0	23293	0	1740467	35605482		
9977	212	40213296	2010-07-10	2010-07-10 00:00:00	2010-07-10	2010-07-10 00:00:00	2010-07-10	581452		0	0	0		0	0	0	14448	0	52	40213296		
62233	1359	40213201	1997-06-24	1997-06-24 00:00:00	1997-06-24	1997-06-24 00:00:00	1997-06-24	581452		0	0	0		0	0	0	90187	0	33	40213201		
76543	1672	40213160	1958-04-09	1958-04-09 00:00:00	1958-04-09	1958-04-09 00:00:00	1958-04-09	581452		0	0	0		0	0	0	112225	0	10	40213160		
43905	3637	1713671	1974-02-05	1974-02-05 00:00:00	1974-02-12	1974-02-12 00:00:00	1974-02-12	38000177		0	0	7		0	0	0	241943	0	562251	1713671		
133242	2926	40213251	1986-09-19	1986-09-19 00:00:00	1986-09-19	1986-09-19 00:00:00	1986-09-19	581452		0	0	0		0	0	0	195149	0	21	40213251		
87957	1929	40213227	2016-04-21	2016-04-21 00:00:00	2016-04-21	2016-04-21 00:00:00	2016-04-21	581452		0	0	0		0	0	0	128439	0	113	40213227		
228255	5013	40213160	1965-04-30	1965-04-30 00:00:00	1965-04-30	1965-04-30 00:00:00	1965-04-30	581452		0	0	0		0	0	0	333189	0	10	40213160		
12153	262	40213227	1996-07-15	1996-07-15 00:00:00	1996-07-15	1996-07-15 00:00:00	1996-07-15	581452		0	0	0		0	0	0	17357	0	113	40213227		
12818	1079	1713671	1983-05-30	1983-05-30 00:00:00	1983-06-06	1983-06-06 00:00:00	1983-06-06	38000177		0	0	7		0	0	0	70711	0	562251	1713671		
180108	3958	40213260	2010-08-15	2010-08-15 00:00:00	2010-08-15	2010-08-15 00:00:00	2010-08-15	581452		0	0	0		0	0	0	263196	0	121	40213260		
115280	2534	40213227	2003-10-07	2003-10-07 00:00:00	2003-10-07	2003-10-07 00:00:00	2003-10-07	581452		0	0	0		0	0	0	167373	0	113	40213227		
40643	3370	40229134	2019-04-20	2019-04-20 00:00:00	2019-05-04	2019-05-04 00:00:00	2019-05-04	38000177		0	0	14		0	0	0	223509	0	1043400	40229134		
49624	1086	40213227	2017-03-31	2017-03-31 00:00:00	2017-03-31	2017-03-31 00:00:00	2017-03-31	581452		0	0	0		0	0	0	71368	0	113	40213227		
64670	1415	40213306	1991-06-16	1991-06-16 00:00:00	1991-06-16	1991-06-16 00:00:00	1991-06-16	581452		0	0	0		0	0	0	94168	0	43	40213306		
52244	1143	40213160	1975-06-27	1975-06-27 00:00:00	1975-06-27	1975-06-27 00:00:00	1975-06-27	581452		0	0	0		0	0	0	75434	0	10	40213160		
51287	4261	40229134	1962-07-19	1962-07-19 00:00:00	1962-08-02	1962-08-02 00:00:00	1962-08-02	38000177		0	0	14		0	0	0	282860	0	1043400	40229134		
43765	3625	19059056	1957-11-05	1957-11-05 00:00:00	1957-11-19	1957-11-19 00:00:00	1957-11-19	38000177		0	0	14		0	0	0	241077	0	243670	19059056		
6076	507	19059056	1946-11-05	1946-11-05 00:00:00	1946-11-19	1946-11-19 00:00:00	1946-11-19	38000177		0	0	14		0	0	0	33956	0	243670	19059056		
57392	4760	1127433	1971-03-04	1971-03-04 00:00:00	1971-03-11	1971-03-11 00:00:00	1971-03-11	38000177		0	0	7		0	0	0	317142	0	313782	1127433		
97170	2130	40213160	1962-02-22	1962-02-22 00:00:00	1962-02-22	1962-02-22 00:00:00	1962-02-22	581452		0	0	0		0	0	0	141684	0	10	40213160		
51034	4239	1127433	1952-09-06	1952-09-06 00:00:00	1952-09-13	1952-09-13 00:00:00	1952-09-13	38000177		0	0	7		0	0	0	281513	0	313782	1127433		
51067	4241	19133873	1973-11-13	1973-11-13 00:00:00	1973-11-24	1973-11-24 00:00:00	1973-11-24	38000177		0	0	11		0	0	0	281692	0	834061	19133873		
79416	1738	40213227	2010-05-30	2010-05-30 00:00:00	2010-05-30	2010-05-30 00:00:00	2010-05-30	581452		0	0	0		0	0	0	116119	0	113	40213227		
26342	2167	19074843	1979-05-09	1979-05-09 00:00:00	1979-05-23	1979-05-23 00:00:00	1979-05-23	38000177		0	0	14		0	0	0	144366	0	309045	19074843		
59824	1309	40213160	1955-09-07	1955-09-07 00:00:00	1955-09-07	1955-09-07 00:00:00	1955-09-07	581452		0	0	0		0	0	0	86476	0	10	40213160		
140400	3083	40213227	2012-07-01	2012-07-01 00:00:00	2012-07-01	2012-07-01 00:00:00	2012-07-01	581452		0	0	0		0	0	0	205280	0	113	40213227		
28230	2333	40173590	2000-06-13	2000-06-13 00:00:00	2000-06-13	2000-06-13 00:00:00	\N	38000177		0	0	0		0	0	0	155177	0	904419	40173590		
206042	4522	40213227	2018-01-19	2018-01-19 00:00:00	2018-01-19	2018-01-19 00:00:00	2018-01-19	581452		0	0	0		0	0	0	301103	0	113	40213227		
71996	1574	40213260	2008-10-03	2008-10-03 00:00:00	2008-10-03	2008-10-03 00:00:00	2008-10-03	581452		0	0	0		0	0	0	105670	0	121	40213260		
9075	756	19006318	1966-08-29	1966-08-29 00:00:00	1966-09-12	1966-09-12 00:00:00	1966-09-12	38000177		0	0	14		0	0	0	50122	0	105078	19006318		
55776	4631	1127433	1978-03-27	1978-03-27 00:00:00	1978-04-03	1978-04-03 00:00:00	1978-04-03	38000177		0	0	7		0	0	0	308533	0	313782	1127433		
121700	2675	40213260	2012-02-05	2012-02-05 00:00:00	2012-02-05	2012-02-05 00:00:00	2012-02-05	581452		0	0	0		0	0	0	177310	0	121	40213260		
114978	2526	40213160	1979-12-03	1979-12-03 00:00:00	1979-12-03	1979-12-03 00:00:00	1979-12-03	581452		0	0	0		0	0	0	167015	0	10	40213160		
7851	656	1115171	2004-10-05	2004-10-05 00:00:00	2004-10-26	2004-10-26 00:00:00	2004-10-26	38000177		0	0	21		0	0	0	43426	0	849574	1115171		
171901	3779	40213160	1970-09-12	1970-09-12 00:00:00	1970-09-12	1970-09-12 00:00:00	1970-09-12	581452		0	0	0		0	0	0	251154	0	10	40213160		
34615	756	40213160	1965-11-10	1965-11-10 00:00:00	1965-11-10	1965-11-10 00:00:00	1965-11-10	581452		0	0	0		0	0	0	50144	0	10	40213160		
35949	2959	1154615	1973-12-28	1973-12-28 00:00:00	1993-02-23	1993-02-23 00:00:00	1993-02-23	38000177		0	0	6997		0	0	0	197474	0	745679	1154615		
12988	1091	1115171	2016-04-07	2016-04-07 00:00:00	2016-04-28	2016-04-28 00:00:00	2016-04-28	38000177		0	0	21		0	0	0	71727	0	849574	1115171		
18530	1532	19128022	1992-09-19	1992-09-19 00:00:00	1993-09-14	1993-09-14 00:00:00	1993-09-14	38000177		0	0	360		0	0	0	102603	0	749785	19128022		
14256	1194	1118084	2001-05-27	2001-05-27 00:00:00	2001-05-27	2001-05-27 00:00:00	\N	38000177		0	0	0		0	0	0	78675	0	00025152531	44923712		
53014	1159	40213227	2012-05-19	2012-05-19 00:00:00	2012-05-19	2012-05-19 00:00:00	2012-05-19	581452		0	0	0		0	0	0	76594	0	113	40213227		
105725	2320	40213227	2002-09-07	2002-09-07 00:00:00	2002-09-07	2002-09-07 00:00:00	2002-09-07	581452		0	0	0		0	0	0	154326	0	113	40213227		
59383	4935	1127433	1999-02-07	1999-02-07 00:00:00	1999-03-16	1999-03-16 00:00:00	1999-03-16	38000177		0	0	37		0	0	0	328156	0	313782	1127433		
56122	4657	1713671	1966-10-12	1966-10-12 00:00:00	1966-11-02	1966-11-02 00:00:00	1966-11-02	38000177		0	0	21		0	0	0	310559	0	562251	1713671		
2046	162	1127433	1964-11-06	1964-11-06 00:00:00	1964-11-20	1964-11-20 00:00:00	1964-11-20	38000177		0	0	14		0	0	0	11161	0	313782	1127433		
34286	2833	19077572	2008-02-18	2008-02-18 00:00:00	2008-02-18	2008-02-18 00:00:00	\N	38000177		0	0	0		0	0	0	188019	0	310436	19077572		
82955	1813	40213160	1982-02-27	1982-02-27 00:00:00	1982-02-27	1982-02-27 00:00:00	1982-02-27	581452		0	0	0		0	0	0	121342	0	10	40213160		
50309	4176	1124300	1952-05-20	1952-05-20 00:00:00	1952-05-20	1952-05-20 00:00:00	\N	38000177		0	0	0		0	0	0	277566	0	00781178901	45011828		
100027	2191	40213160	1970-07-26	1970-07-26 00:00:00	1970-07-26	1970-07-26 00:00:00	1970-07-26	581452		0	0	0		0	0	0	146115	0	10	40213160		
94401	2071	40213227	2017-06-21	2017-06-21 00:00:00	2017-06-21	2017-06-21 00:00:00	2017-06-21	581452		0	0	0		0	0	0	137787	0	113	40213227		
72936	1593	40213201	2000-11-30	2000-11-30 00:00:00	2000-11-30	2000-11-30 00:00:00	2000-11-30	581452		0	0	0		0	0	0	106838	0	33	40213201		
229913	5053	40213198	2010-11-28	2010-11-28 00:00:00	2010-11-28	2010-11-28 00:00:00	2010-11-28	581452		0	0	0		0	0	0	335975	0	133	40213198		
204952	4498	40213227	2000-03-28	2000-03-28 00:00:00	2000-03-28	2000-03-28 00:00:00	2000-03-28	581452		0	0	0		0	0	0	299496	0	113	40213227		
17410	376	40213296	2003-05-08	2003-05-08 00:00:00	2003-05-08	2003-05-08 00:00:00	2003-05-08	581452		0	0	0		0	0	0	24952	0	52	40213296		
78540	1718	40213227	2008-09-27	2008-09-27 00:00:00	2008-09-27	2008-09-27 00:00:00	2008-09-27	581452		0	0	0		0	0	0	114821	0	113	40213227		
228375	5015	40213306	1990-04-09	1990-04-09 00:00:00	1990-04-09	1990-04-09 00:00:00	1990-04-09	581452		0	0	0		0	0	0	333390	0	43	40213306		
232067	5099	40213227	1994-03-12	1994-03-12 00:00:00	1994-03-12	1994-03-12 00:00:00	1994-03-12	581452		0	0	0		0	0	0	338905	0	113	40213227		
204079	4480	40213160	1961-05-09	1961-05-09 00:00:00	1961-05-09	1961-05-09 00:00:00	1961-05-09	581452		0	0	0		0	0	0	298148	0	10	40213160		
52034	4328	1127433	2015-02-02	2015-02-02 00:00:00	2015-02-09	2015-02-09 00:00:00	2015-02-09	38000177		0	0	7		0	0	0	287019	0	313782	1127433		
172419	3790	40213160	1963-10-07	1963-10-07 00:00:00	1963-10-07	1963-10-07 00:00:00	1963-10-07	581452		0	0	0		0	0	0	252004	0	10	40213160		
43654	3618	19059056	1923-05-14	1923-05-14 00:00:00	1923-06-11	1923-06-11 00:00:00	1923-06-11	38000177		0	0	28		0	0	0	240395	0	243670	19059056		
89840	1971	40213160	1969-06-20	1969-06-20 00:00:00	1969-06-20	1969-06-20 00:00:00	1969-06-20	581452		0	0	0		0	0	0	131031	0	10	40213160		
62126	1357	40213227	2006-06-30	2006-06-30 00:00:00	2006-06-30	2006-06-30 00:00:00	2006-06-30	581452		0	0	0		0	0	0	90014	0	113	40213227		
4223	350	35605858	1995-09-11	1995-09-11 00:00:00	1995-09-11	1995-09-11 00:00:00	1995-09-11	38000177		0	0	0		0	0	0	23293	0	1732136	35605858		
9978	212	40213227	2012-07-14	2012-07-14 00:00:00	2012-07-14	2012-07-14 00:00:00	2012-07-14	581452		0	0	0		0	0	0	14460	0	113	40213227		
62244	1359	40213227	2002-03-12	2002-03-12 00:00:00	2002-03-12	2002-03-12 00:00:00	2002-03-12	581452		0	0	0		0	0	0	90189	0	113	40213227		
76544	1672	40213160	1955-10-05	1955-10-05 00:00:00	1955-10-05	1955-10-05 00:00:00	1955-10-05	581452		0	0	0		0	0	0	112234	0	10	40213160		
43906	3637	1713671	1990-01-25	1990-01-25 00:00:00	1990-02-08	1990-02-08 00:00:00	1990-02-08	38000177		0	0	14		0	0	0	241901	0	562251	1713671		
133244	2926	40213160	1986-09-19	1986-09-19 00:00:00	1986-09-19	1986-09-19 00:00:00	1986-09-19	581452		0	0	0		0	0	0	195149	0	10	40213160		
155397	3420	40213296	2005-10-25	2005-10-25 00:00:00	2005-10-25	2005-10-25 00:00:00	2005-10-25	581452		0	0	0		0	0	0	\N	0	52	40213296		
228260	5013	40213296	2004-08-27	2004-08-27 00:00:00	2004-08-27	2004-08-27 00:00:00	2004-08-27	581452		0	0	0		0	0	0	333217	0	52	40213296		
12157	262	40213160	1965-01-11	1965-01-11 00:00:00	1965-01-11	1965-01-11 00:00:00	1965-01-11	581452		0	0	0		0	0	0	17415	0	10	40213160		
12819	1079	1127433	1988-07-26	1988-07-26 00:00:00	1988-08-02	1988-08-02 00:00:00	1988-08-02	38000177		0	0	7		0	0	0	70736	0	313782	1127433		
180114	3958	40213296	2000-08-20	2000-08-20 00:00:00	2000-08-20	2000-08-20 00:00:00	2000-08-20	581452		0	0	0		0	0	0	263194	0	52	40213296		
115285	2534	40213314	1977-07-05	1977-07-05 00:00:00	1977-07-05	1977-07-05 00:00:00	1977-07-05	581452		0	0	0		0	0	0	167475	0	49	40213314		
40644	3370	19059056	1974-06-16	1974-06-16 00:00:00	1974-06-30	1974-06-30 00:00:00	1974-06-30	38000177		0	0	14		0	0	0	223390	0	243670	19059056		
49625	1086	40213260	2017-03-31	2017-03-31 00:00:00	2017-03-31	2017-03-31 00:00:00	2017-03-31	581452		0	0	0		0	0	0	71368	0	121	40213260		
831	66	40229134	1972-04-16	1972-04-16 00:00:00	1972-04-30	1972-04-30 00:00:00	1972-04-30	38000177		0	0	14		0	0	0	4475	0	1043400	40229134		
52245	1143	40213160	1971-11-05	1971-11-05 00:00:00	1971-11-05	1971-11-05 00:00:00	1971-11-05	581452		0	0	0		0	0	0	75430	0	10	40213160		
51288	4261	19018935	2010-01-24	2010-01-24 00:00:00	2010-01-24	2010-01-24 00:00:00	\N	38000177		0	0	0		0	0	0	282955	0	197604	19018935		
43766	3625	1127078	1954-11-20	1954-11-20 00:00:00	1954-12-04	1954-12-04 00:00:00	1954-12-04	38000177		0	0	14		0	0	0	241086	0	282464	1127078		
6091	510	1127433	1979-11-19	1979-11-19 00:00:00	1979-12-03	1979-12-03 00:00:00	1979-12-03	38000177		0	0	14		0	0	0	34109	0	313782	1127433		
57393	4760	19133873	1955-03-27	1955-03-27 00:00:00	1955-04-05	1955-04-05 00:00:00	1955-04-05	38000177		0	0	9		0	0	0	317171	0	834061	19133873		
97172	2130	40213227	2018-10-04	2018-10-04 00:00:00	2018-10-04	2018-10-04 00:00:00	2018-10-04	581452		0	0	0		0	0	0	141705	0	113	40213227		
51035	4239	1115171	2019-04-12	2019-04-12 00:00:00	2019-05-19	2019-05-19 00:00:00	2019-05-19	38000177		0	0	37		0	0	0	281553	0	849574	1115171		
51068	4241	1713671	1998-05-25	1998-05-25 00:00:00	1998-06-08	1998-06-08 00:00:00	1998-06-08	38000177		0	0	14		0	0	0	281703	0	562251	1713671		
79417	1738	40213296	2010-05-30	2010-05-30 00:00:00	2010-05-30	2010-05-30 00:00:00	2010-05-30	581452		0	0	0		0	0	0	116119	0	52	40213296		
26343	2167	19078461	1993-08-23	1993-08-23 00:00:00	1993-09-06	1993-09-06 00:00:00	1993-09-06	38000177		0	0	14		0	0	0	144344	0	310965	19078461		
59826	1309	40213160	1960-03-08	1960-03-08 00:00:00	1960-03-08	1960-03-08 00:00:00	1960-03-08	581452		0	0	0		0	0	0	86480	0	10	40213160		
140405	3083	40213201	2017-07-30	2017-07-30 00:00:00	2017-07-30	2017-07-30 00:00:00	2017-07-30	581452		0	0	0		0	0	0	205277	0	33	40213201		
28231	2333	40236824	1967-10-07	1967-10-07 00:00:00	1967-10-14	1967-10-14 00:00:00	1967-10-14	38000177		0	0	7		0	0	0	155204	0	1094107	40236824		
206043	4522	40213296	2018-01-19	2018-01-19 00:00:00	2018-01-19	2018-01-19 00:00:00	2018-01-19	581452		0	0	0		0	0	0	301103	0	52	40213296		
72000	1574	40213227	2009-10-09	2009-10-09 00:00:00	2009-10-09	2009-10-09 00:00:00	2009-10-09	581452		0	0	0		0	0	0	105656	0	113	40213227		
9076	756	1127433	1982-09-04	1982-09-04 00:00:00	1982-09-18	1982-09-18 00:00:00	1982-09-18	38000177		0	0	14		0	0	0	50173	0	313782	1127433		
9489	202	40213201	2004-10-30	2004-10-30 00:00:00	2004-10-30	2004-10-30 00:00:00	2004-10-30	581452		0	0	0		0	0	0	13881	0	33	40213201		
121703	2675	40213160	1961-07-09	1961-07-09 00:00:00	1961-07-09	1961-07-09 00:00:00	1961-07-09	581452		0	0	0		0	0	0	177279	0	10	40213160		
114982	2526	40213160	1975-06-02	1975-06-02 00:00:00	1975-06-02	1975-06-02 00:00:00	1975-06-02	581452		0	0	0		0	0	0	167029	0	10	40213160		
7852	656	19133873	1971-06-06	1971-06-06 00:00:00	1971-06-19	1971-06-19 00:00:00	1971-06-19	38000177		0	0	13		0	0	0	43433	0	834061	19133873		
171902	3779	40213160	1970-07-11	1970-07-11 00:00:00	1970-07-11	1970-07-11 00:00:00	1970-07-11	581452		0	0	0		0	0	0	251128	0	10	40213160		
34626	756	40213227	2007-01-17	2007-01-17 00:00:00	2007-01-17	2007-01-17 00:00:00	2007-01-17	581452		0	0	0		0	0	0	50167	0	113	40213227		
35950	2959	1551192	1977-09-17	1977-09-17 00:00:00	1977-09-17	1977-09-17 00:00:00	1977-09-17	38000177		0	0	0		0	0	0	197603	0	312617	1551192		
12989	1091	19133873	1967-09-23	1967-09-23 00:00:00	1967-10-02	1967-10-02 00:00:00	1967-10-02	38000177		0	0	9		0	0	0	71678	0	834061	19133873		
18531	1532	19128065	1998-08-19	1998-08-19 00:00:00	1999-08-14	1999-08-14 00:00:00	1999-08-14	38000177		0	0	360		0	0	0	102636	0	749882	19128065		
94327	2070	40213296	2005-09-12	2005-09-12 00:00:00	2005-09-12	2005-09-12 00:00:00	2005-09-12	581452		0	0	0		0	0	0	137723	0	52	40213296		
53016	1159	40213227	2001-12-01	2001-12-01 00:00:00	2001-12-01	2001-12-01 00:00:00	2001-12-01	581452		0	0	0		0	0	0	76550	0	113	40213227		
105730	2320	40213227	1992-10-17	1992-10-17 00:00:00	1992-10-17	1992-10-17 00:00:00	1992-10-17	581452		0	0	0		0	0	0	154256	0	113	40213227		
59384	4935	920300	1996-10-28	1996-10-28 00:00:00	1996-11-04	1996-11-04 00:00:00	1996-11-04	38000177		0	0	7		0	0	0	328124	0	311989	920300		
56123	4657	1127433	2010-07-15	2010-07-15 00:00:00	2010-07-29	2010-07-29 00:00:00	2010-07-29	38000177		0	0	14		0	0	0	310518	0	313782	1127433		
2047	162	1127433	2013-12-31	2013-12-31 00:00:00	2014-01-07	2014-01-07 00:00:00	2014-01-07	38000177		0	0	7		0	0	0	11096	0	313782	1127433		
34287	2833	1127433	1979-12-20	1979-12-20 00:00:00	1980-01-10	1980-01-10 00:00:00	1980-01-10	38000177		0	0	21		0	0	0	188075	0	313782	1127433		
82961	1813	40213251	1986-05-31	1986-05-31 00:00:00	1986-05-31	1986-05-31 00:00:00	1986-05-31	581452		0	0	0		0	0	0	121333	0	21	40213251		
50310	4176	1127433	1972-12-01	1972-12-01 00:00:00	1972-12-08	1972-12-08 00:00:00	1972-12-08	38000177		0	0	7		0	0	0	277445	0	313782	1127433		
100030	2191	40213160	1970-12-27	1970-12-27 00:00:00	1970-12-27	1970-12-27 00:00:00	1970-12-27	581452		0	0	0		0	0	0	146116	0	10	40213160		
94403	2071	40213260	2016-06-15	2016-06-15 00:00:00	2016-06-15	2016-06-15 00:00:00	2016-06-15	581452		0	0	0		0	0	0	137845	0	121	40213260		
198420	4359	40213198	2010-08-18	2010-08-18 00:00:00	2010-08-18	2010-08-18 00:00:00	2010-08-18	581452		0	0	0		0	0	0	289184	0	133	40213198		
229916	5053	40213227	2017-01-01	2017-01-01 00:00:00	2017-01-01	2017-01-01 00:00:00	2017-01-01	581452		0	0	0		0	0	0	335985	0	113	40213227		
204953	4498	40213306	2000-03-28	2000-03-28 00:00:00	2000-03-28	2000-03-28 00:00:00	2000-03-28	581452		0	0	0		0	0	0	299496	0	43	40213306		
99723	2184	40213160	1967-07-26	1967-07-26 00:00:00	1967-07-26	1967-07-26 00:00:00	1967-07-26	581452		0	0	0		0	0	0	145585	0	10	40213160		
78541	1718	40213296	2008-09-27	2008-09-27 00:00:00	2008-09-27	2008-09-27 00:00:00	2008-09-27	581452		0	0	0		0	0	0	114821	0	52	40213296		
159848	3518	40213160	1958-09-08	1958-09-08 00:00:00	1958-09-08	1958-09-08 00:00:00	1958-09-08	581452		0	0	0		0	0	0	233598	0	10	40213160		
232171	5101	40213160	1961-12-09	1961-12-09 00:00:00	1961-12-09	1961-12-09 00:00:00	1961-12-09	581452		0	0	0		0	0	0	338983	0	10	40213160		
204084	4480	40213296	2001-02-06	2001-02-06 00:00:00	2001-02-06	2001-02-06 00:00:00	2001-02-06	581452		0	0	0		0	0	0	298199	0	52	40213296		
52035	4328	19078461	2007-08-18	2007-08-18 00:00:00	2007-09-22	2007-09-22 00:00:00	2007-09-22	38000177		0	0	35		0	0	0	287017	0	310965	19078461		
93856	2060	40213296	2004-08-18	2004-08-18 00:00:00	2004-08-18	2004-08-18 00:00:00	2004-08-18	581452		0	0	0		0	0	0	137023	0	52	40213296		
43655	3618	1127433	1960-07-13	1960-07-13 00:00:00	1960-07-27	1960-07-27 00:00:00	1960-07-27	38000177		0	0	14		0	0	0	240451	0	313782	1127433		
89843	1971	40213296	2009-03-20	2009-03-20 00:00:00	2009-03-20	2009-03-20 00:00:00	2009-03-20	581452		0	0	0		0	0	0	131013	0	52	40213296		
62128	1357	40213314	1977-10-28	1977-10-28 00:00:00	1977-10-28	1977-10-28 00:00:00	1977-10-28	581452		0	0	0		0	0	0	90006	0	49	40213314		
4224	350	19016749	1995-09-11	1995-09-11 00:00:00	1995-09-11	1995-09-11 00:00:00	1995-09-11	38000177		0	0	0		0	0	0	23293	0	73032	19016749		
9979	212	40213296	2012-07-14	2012-07-14 00:00:00	2012-07-14	2012-07-14 00:00:00	2012-07-14	581452		0	0	0		0	0	0	14460	0	52	40213296		
62253	1360	40213160	1976-03-14	1976-03-14 00:00:00	1976-03-14	1976-03-14 00:00:00	1976-03-14	581452		0	0	0		0	0	0	90256	0	10	40213160		
107592	2358	40213160	1971-09-14	1971-09-14 00:00:00	1971-09-14	1971-09-14 00:00:00	1971-09-14	581452		0	0	0		0	0	0	157154	0	10	40213160		
43907	3637	19133873	1970-11-09	1970-11-09 00:00:00	1970-11-19	1970-11-19 00:00:00	1970-11-19	38000177		0	0	10		0	0	0	241921	0	834061	19133873		
133254	2926	40213160	1982-05-28	1982-05-28 00:00:00	1982-05-28	1982-05-28 00:00:00	1982-05-28	581452		0	0	0		0	0	0	195166	0	10	40213160		
155398	3420	40213227	2005-10-25	2005-10-25 00:00:00	2005-10-25	2005-10-25 00:00:00	2005-10-25	581452		0	0	0		0	0	0	\N	0	113	40213227		
228263	5013	40213227	1996-06-28	1996-06-28 00:00:00	1996-06-28	1996-06-28 00:00:00	1996-06-28	581452		0	0	0		0	0	0	333222	0	113	40213227		
40644	885	40213296	2015-04-19	2015-04-19 00:00:00	2015-04-19	2015-04-19 00:00:00	2015-04-19	581452		0	0	0		0	0	0	58977	0	52	40213296		
12820	1079	19059056	1962-02-12	1962-02-12 00:00:00	1962-02-26	1962-02-26 00:00:00	1962-02-26	38000177		0	0	14		0	0	0	70768	0	243670	19059056		
191720	4212	40213160	1970-04-10	1970-04-10 00:00:00	1970-04-10	1970-04-10 00:00:00	1970-04-10	581452		0	0	0		0	0	0	279667	0	10	40213160		
115287	2534	40213160	1977-07-05	1977-07-05 00:00:00	1977-07-05	1977-07-05 00:00:00	1977-07-05	581452		0	0	0		0	0	0	167475	0	10	40213160		
40645	3370	1713671	1975-02-18	1975-02-18 00:00:00	1975-02-25	1975-02-25 00:00:00	1975-02-25	38000177		0	0	7		0	0	0	223467	0	562251	1713671		
49628	1086	40213160	1966-02-18	1966-02-18 00:00:00	1966-02-18	1966-02-18 00:00:00	1966-02-18	581452		0	0	0		0	0	0	71324	0	10	40213160		
832	67	1118084	2011-08-29	2011-08-29 00:00:00	2011-08-29	2011-08-29 00:00:00	\N	38000177		0	0	0		0	0	0	4522	0	00025152531	44923712		
52249	1143	40213296	2012-12-07	2012-12-07 00:00:00	2012-12-07	2012-12-07 00:00:00	2012-12-07	581452		0	0	0		0	0	0	75469	0	52	40213296		
51289	4261	40171902	2010-01-24	2010-01-24 00:00:00	2010-01-24	2010-01-24 00:00:00	\N	38000177		0	0	0		0	0	0	282955	0	897718	40171902		
43767	3625	1127433	2000-07-03	2000-07-03 00:00:00	2000-07-24	2000-07-24 00:00:00	2000-07-24	38000177		0	0	21		0	0	0	241058	0	313782	1127433		
6092	510	46233988	1969-09-28	1969-09-28 00:00:00	1969-10-12	1969-10-12 00:00:00	1969-10-12	38000177		0	0	14		0	0	0	34095	0	1652673	46233988		
57394	4760	40229134	1986-07-21	1986-07-21 00:00:00	1986-07-28	1986-07-28 00:00:00	1986-07-28	38000177		0	0	7		0	0	0	317123	0	1043400	40229134		
97173	2130	40213160	1957-09-12	1957-09-12 00:00:00	1957-09-12	1957-09-12 00:00:00	1957-09-12	581452		0	0	0		0	0	0	141708	0	10	40213160		
51037	4240	1713671	1996-07-28	1996-07-28 00:00:00	1996-08-04	1996-08-04 00:00:00	1996-08-04	38000177		0	0	7		0	0	0	281636	0	562251	1713671		
51069	4241	19133905	2008-10-02	2008-10-02 00:00:00	2008-10-10	2008-10-10 00:00:00	2008-10-10	38000177		0	0	8		0	0	0	281758	0	834102	19133905		
79420	1738	40213227	2001-01-21	2001-01-21 00:00:00	2001-01-21	2001-01-21 00:00:00	2001-01-21	581452		0	0	0		0	0	0	116126	0	113	40213227		
26344	2167	1118084	2017-09-21	2017-09-21 00:00:00	2017-09-21	2017-09-21 00:00:00	\N	38000177		0	0	0		0	0	0	144388	0	00025152531	44923712		
59829	1309	40213260	2007-04-11	2007-04-11 00:00:00	2007-04-11	2007-04-11 00:00:00	2007-04-11	581452		0	0	0		0	0	0	86509	0	121	40213260		
140427	3083	40213227	2002-05-05	2002-05-05 00:00:00	2002-05-05	2002-05-05 00:00:00	2002-05-05	581452		0	0	0		0	0	0	205273	0	113	40213227		
28232	2333	920300	1967-10-07	1967-10-07 00:00:00	1967-10-14	1967-10-14 00:00:00	1967-10-14	38000177		0	0	7		0	0	0	155204	0	311989	920300		
206046	4522	40213227	1998-11-06	1998-11-06 00:00:00	1998-11-06	1998-11-06 00:00:00	1998-11-06	581452		0	0	0		0	0	0	301144	0	113	40213227		
72001	1574	40213260	2009-10-09	2009-10-09 00:00:00	2009-10-09	2009-10-09 00:00:00	2009-10-09	581452		0	0	0		0	0	0	105656	0	121	40213260		
9077	756	1127433	1973-08-23	1973-08-23 00:00:00	1973-08-30	1973-08-30 00:00:00	1973-08-30	38000177		0	0	7		0	0	0	50118	0	313782	1127433		
113963	2504	40213160	1956-04-02	1956-04-02 00:00:00	1956-04-02	1956-04-02 00:00:00	1956-04-02	581452		0	0	0		0	0	0	165809	0	10	40213160		
121712	2675	40213227	2003-10-26	2003-10-26 00:00:00	2003-10-26	2003-10-26 00:00:00	2003-10-26	581452		0	0	0		0	0	0	177237	0	113	40213227		
114988	2526	40213314	1978-05-29	1978-05-29 00:00:00	1978-05-29	1978-05-29 00:00:00	1978-05-29	581452		0	0	0		0	0	0	167035	0	49	40213314		
7853	656	1713671	1984-08-30	1984-08-30 00:00:00	1984-09-06	1984-09-06 00:00:00	1984-09-06	38000177		0	0	7		0	0	0	43493	0	562251	1713671		
171905	3779	40213160	1970-12-12	1970-12-12 00:00:00	1970-12-12	1970-12-12 00:00:00	1970-12-12	581452		0	0	0		0	0	0	251129	0	10	40213160		
34627	756	40213296	2007-01-17	2007-01-17 00:00:00	2007-01-17	2007-01-17 00:00:00	2007-01-17	581452		0	0	0		0	0	0	50167	0	52	40213296		
35951	2959	1127433	1977-08-19	1977-08-19 00:00:00	1977-08-26	1977-08-26 00:00:00	1977-08-26	38000177		0	0	7		0	0	0	197470	0	313782	1127433		
12990	1091	1127433	1998-07-27	1998-07-27 00:00:00	1998-08-10	1998-08-10 00:00:00	1998-08-10	38000177		0	0	14		0	0	0	71726	0	313782	1127433		
18532	1532	1713671	2004-10-11	2004-10-11 00:00:00	2004-10-25	2004-10-25 00:00:00	2004-10-25	38000177		0	0	14		0	0	0	102607	0	562251	1713671		
94329	2070	40213160	1965-02-01	1965-02-01 00:00:00	1965-02-01	1965-02-01 00:00:00	1965-02-01	581452		0	0	0		0	0	0	137660	0	10	40213160		
53017	1159	40213306	2001-12-01	2001-12-01 00:00:00	2001-12-01	2001-12-01 00:00:00	2001-12-01	581452		0	0	0		0	0	0	76550	0	43	40213306		
194775	4279	40213227	1992-04-17	1992-04-17 00:00:00	1992-04-17	1992-04-17 00:00:00	1992-04-17	581452		0	0	0		0	0	0	284018	0	113	40213227		
59385	4935	40236824	1996-10-28	1996-10-28 00:00:00	1996-11-04	1996-11-04 00:00:00	1996-11-04	38000177		0	0	7		0	0	0	328124	0	1094107	40236824		
56124	4657	19128065	1974-10-04	1974-10-04 00:00:00	1975-09-29	1975-09-29 00:00:00	1975-09-29	38000177		0	0	360		0	0	0	310493	0	749882	19128065		
2048	162	1115171	2005-10-31	2005-10-31 00:00:00	2005-11-14	2005-11-14 00:00:00	2005-11-14	38000177		0	0	14		0	0	0	11092	0	849574	1115171		
34288	2833	40229134	2011-08-28	2011-08-28 00:00:00	2011-09-04	2011-09-04 00:00:00	2011-09-04	38000177		0	0	7		0	0	0	188025	0	1043400	40229134		
82964	1813	40213160	1986-05-31	1986-05-31 00:00:00	1986-05-31	1986-05-31 00:00:00	1986-05-31	581452		0	0	0		0	0	0	121333	0	10	40213160		
50311	4176	1713671	1981-01-09	1981-01-09 00:00:00	1981-01-23	1981-01-23 00:00:00	1981-01-23	38000177		0	0	14		0	0	0	277529	0	562251	1713671		
100031	2191	40213160	1970-09-27	1970-09-27 00:00:00	1970-09-27	1970-09-27 00:00:00	1970-09-27	581452		0	0	0		0	0	0	146134	0	10	40213160		
94407	2071	40213160	1965-11-24	1965-11-24 00:00:00	1965-11-24	1965-11-24 00:00:00	1965-11-24	581452		0	0	0		0	0	0	137808	0	10	40213160		
198424	4359	40213227	1994-02-16	1994-02-16 00:00:00	1994-02-16	1994-02-16 00:00:00	1994-02-16	581452		0	0	0		0	0	0	289274	0	113	40213227		
229925	5053	40213227	2006-11-05	2006-11-05 00:00:00	2006-11-05	2006-11-05 00:00:00	2006-11-05	581452		0	0	0		0	0	0	335973	0	113	40213227		
200711	4408	40213314	1981-07-02	1981-07-02 00:00:00	1981-07-02	1981-07-02 00:00:00	1981-07-02	581452		0	0	0		0	0	0	293025	0	49	40213314		
99730	2184	40213160	1967-10-25	1967-10-25 00:00:00	1967-10-25	1967-10-25 00:00:00	1967-10-25	581452		0	0	0		0	0	0	145568	0	10	40213160		
78543	1718	40213160	1967-02-25	1967-02-25 00:00:00	1967-02-25	1967-02-25 00:00:00	1967-02-25	581452		0	0	0		0	0	0	114871	0	10	40213160		
159852	3518	40213160	1958-07-07	1958-07-07 00:00:00	1958-07-07	1958-07-07 00:00:00	1958-07-07	581452		0	0	0		0	0	0	233537	0	10	40213160		
26822	2210	19059056	1966-07-11	1966-07-11 00:00:00	1966-08-01	1966-08-01 00:00:00	1966-08-01	38000177		0	0	21		0	0	0	147197	0	243670	19059056		
204095	4480	40213160	1965-09-14	1965-09-14 00:00:00	1965-09-14	1965-09-14 00:00:00	1965-09-14	581452		0	0	0		0	0	0	298163	0	10	40213160		
52036	4328	1127433	2016-03-07	2016-03-07 00:00:00	2016-03-21	2016-03-21 00:00:00	2016-03-21	38000177		0	0	14		0	0	0	287020	0	313782	1127433		
93861	2060	40213160	1964-05-13	1964-05-13 00:00:00	1964-05-13	1964-05-13 00:00:00	1964-05-13	581452		0	0	0		0	0	0	137000	0	10	40213160		
43656	3618	1118084	1953-01-31	1953-01-31 00:00:00	1953-01-31	1953-01-31 00:00:00	\N	38000177		0	0	0		0	0	0	240447	0	00025152531	44923712		
89846	1971	40213160	1974-02-22	1974-02-22 00:00:00	1974-02-22	1974-02-22 00:00:00	1974-02-22	581452		0	0	0		0	0	0	131008	0	10	40213160		
164701	3622	40213227	1993-07-28	1993-07-28 00:00:00	1993-07-28	1993-07-28 00:00:00	1993-07-28	581452		0	0	0		0	0	0	\N	0	113	40213227		
4225	350	40220386	1995-09-11	1995-09-11 00:00:00	1995-09-11	1995-09-11 00:00:00	1995-09-11	38000177		0	0	0		0	0	0	23293	0	1808217	40220386		
9983	212	40213160	1970-08-29	1970-08-29 00:00:00	1970-08-29	1970-08-29 00:00:00	1970-08-29	581452		0	0	0		0	0	0	14453	0	10	40213160		
62254	1360	40213314	1977-07-31	1977-07-31 00:00:00	1977-07-31	1977-07-31 00:00:00	1977-07-31	581452		0	0	0		0	0	0	90258	0	49	40213314		
5660	123	40213227	2001-04-18	2001-04-18 00:00:00	2001-04-18	2001-04-18 00:00:00	2001-04-18	581452		0	0	0		0	0	0	8139	0	113	40213227		
43908	3638	1154615	1967-05-08	1967-05-08 00:00:00	1985-06-27	1985-06-27 00:00:00	1985-06-27	38000177		0	0	6625		0	0	0	241971	0	745679	1154615		
133255	2926	40213251	1984-02-24	1984-02-24 00:00:00	1984-02-24	1984-02-24 00:00:00	1984-02-24	581452		0	0	0		0	0	0	195153	0	21	40213251		
155401	3420	40213296	2004-10-05	2004-10-05 00:00:00	2004-10-05	2004-10-05 00:00:00	2004-10-05	581452		0	0	0		0	0	0	226901	0	52	40213296		
228267	5013	40213160	1964-11-27	1964-11-27 00:00:00	1964-11-27	1964-11-27 00:00:00	1964-11-27	581452		0	0	0		0	0	0	333188	0	10	40213160		
40654	885	40213314	1978-03-19	1978-03-19 00:00:00	1978-03-19	1978-03-19 00:00:00	1978-03-19	581452		0	0	0		0	0	0	58993	0	49	40213314		
12821	1079	19133873	1962-07-16	1962-07-16 00:00:00	1962-07-26	1962-07-26 00:00:00	1962-07-26	38000177		0	0	10		0	0	0	70746	0	834061	19133873		
32928	719	40213180	2005-06-10	2005-06-10 00:00:00	2005-06-10	2005-06-10 00:00:00	2005-06-10	581452		0	0	0		0	0	0	47582	0	114	40213180		
115292	2534	40213227	2014-01-28	2014-01-28 00:00:00	2014-01-28	2014-01-28 00:00:00	2014-01-28	581452		0	0	0		0	0	0	167473	0	113	40213227		
40646	3370	1127433	2015-01-14	2015-01-14 00:00:00	2015-01-28	2015-01-28 00:00:00	2015-01-28	38000177		0	0	14		0	0	0	223406	0	313782	1127433		
49643	1086	40213296	2009-03-06	2009-03-06 00:00:00	2009-03-06	2009-03-06 00:00:00	2009-03-06	581452		0	0	0		0	0	0	71381	0	52	40213296		
833	67	1127433	1988-10-07	1988-10-07 00:00:00	1988-10-21	1988-10-21 00:00:00	1988-10-21	38000177		0	0	14		0	0	0	4521	0	313782	1127433		
52252	1143	40213227	2012-12-07	2012-12-07 00:00:00	2012-12-07	2012-12-07 00:00:00	2012-12-07	581452		0	0	0		0	0	0	75469	0	113	40213227		
51290	4261	40163554	2010-01-24	2010-01-24 00:00:00	2010-01-24	2010-01-24 00:00:00	\N	38000177		0	0	0		0	0	0	282955	0	855332	40163554		
43768	3625	19059056	1968-07-21	1968-07-21 00:00:00	1968-08-20	1968-08-20 00:00:00	1968-08-20	38000177		0	0	30		0	0	0	241057	0	243670	19059056		
37646	821	40213198	2013-12-28	2013-12-28 00:00:00	2013-12-28	2013-12-28 00:00:00	2013-12-28	581452		0	0	0		0	0	0	54409	0	133	40213198		
57395	4761	1713671	2002-09-16	2002-09-16 00:00:00	2002-10-14	2002-10-14 00:00:00	2002-10-14	38000177		0	0	28		0	0	0	317289	0	562251	1713671		
97174	2130	40213160	1957-11-14	1957-11-14 00:00:00	1957-11-14	1957-11-14 00:00:00	1957-11-14	581452		0	0	0		0	0	0	141750	0	10	40213160		
51038	4240	19059056	1946-05-01	1946-05-01 00:00:00	1946-05-29	1946-05-29 00:00:00	1946-05-29	38000177		0	0	28		0	0	0	281591	0	243670	19059056		
51071	4241	1127433	1977-01-01	1977-01-01 00:00:00	1977-01-15	1977-01-15 00:00:00	1977-01-15	38000177		0	0	14		0	0	0	281752	0	313782	1127433		
79424	1738	40213160	1968-08-25	1968-08-25 00:00:00	1968-08-25	1968-08-25 00:00:00	1968-08-25	581452		0	0	0		0	0	0	116139	0	10	40213160		
26345	2167	40229134	1993-07-26	1993-07-26 00:00:00	1993-08-09	1993-08-09 00:00:00	1993-08-09	38000177		0	0	14		0	0	0	144346	0	1043400	40229134		
59831	1309	40213227	2006-04-05	2006-04-05 00:00:00	2006-04-05	2006-04-05 00:00:00	2006-04-05	581452		0	0	0		0	0	0	86498	0	113	40213227		
140431	3083	40213160	1956-04-15	1956-04-15 00:00:00	1956-04-15	1956-04-15 00:00:00	1956-04-15	581452		0	0	0		0	0	0	205343	0	10	40213160		
28233	2333	1127433	2001-07-21	2001-07-21 00:00:00	2001-08-25	2001-08-25 00:00:00	2001-08-25	38000177		0	0	35		0	0	0	155167	0	313782	1127433		
206047	4522	40213306	1998-11-06	1998-11-06 00:00:00	1998-11-06	1998-11-06 00:00:00	1998-11-06	581452		0	0	0		0	0	0	301144	0	43	40213306		
72005	1574	40213160	1963-09-13	1963-09-13 00:00:00	1963-09-13	1963-09-13 00:00:00	1963-09-13	581452		0	0	0		0	0	0	105653	0	10	40213160		
9078	756	40162522	1995-09-01	1995-09-01 00:00:00	1995-09-01	1995-09-01 00:00:00	\N	38000177		0	0	0		0	0	0	50106	0	857005	40162522		
113970	2504	40213198	2018-11-19	2018-11-19 00:00:00	2018-11-19	2018-11-19 00:00:00	2018-11-19	581452		0	0	0		0	0	0	165801	0	133	40213198		
121713	2675	40213296	2003-10-26	2003-10-26 00:00:00	2003-10-26	2003-10-26 00:00:00	2003-10-26	581452		0	0	0		0	0	0	177237	0	52	40213296		
28904	2389	19019979	1974-01-05	1974-01-05 00:00:00	1974-01-26	1974-01-26 00:00:00	1974-01-26	38000177		0	0	21		0	0	0	158840	0	198405	19019979		
7854	656	1713671	2004-08-28	2004-08-28 00:00:00	2004-09-04	2004-09-04 00:00:00	2004-09-04	38000177		0	0	7		0	0	0	43463	0	562251	1713671		
171910	3779	40213227	2001-11-17	2001-11-17 00:00:00	2001-11-17	2001-11-17 00:00:00	2001-11-17	581452		0	0	0		0	0	0	251160	0	113	40213227		
34633	756	40213160	1970-07-15	1970-07-15 00:00:00	1970-07-15	1970-07-15 00:00:00	1970-07-15	581452		0	0	0		0	0	0	50161	0	10	40213160		
35953	2960	1127078	1957-11-19	1957-11-19 00:00:00	1957-12-03	1957-12-03 00:00:00	1957-12-03	38000177		0	0	14		0	0	0	197695	0	282464	1127078		
12991	1091	1127433	1989-02-04	1989-02-04 00:00:00	1989-02-18	1989-02-18 00:00:00	1989-02-18	38000177		0	0	14		0	0	0	71681	0	313782	1127433		
18533	1532	1124300	2014-03-13	2014-03-13 00:00:00	2014-03-13	2014-03-13 00:00:00	\N	38000177		0	0	0		0	0	0	102599	0	00781178901	45011828		
105611	2318	40213160	1968-01-06	1968-01-06 00:00:00	1968-01-06	1968-01-06 00:00:00	1968-01-06	581452		0	0	0		0	0	0	154066	0	10	40213160		
53018	1159	40213160	1981-01-03	1981-01-03 00:00:00	1981-01-03	1981-01-03 00:00:00	1981-01-03	581452		0	0	0		0	0	0	76578	0	10	40213160		
194792	4279	40213201	2016-07-08	2016-07-08 00:00:00	2016-07-08	2016-07-08 00:00:00	2016-07-08	581452		0	0	0		0	0	0	284086	0	33	40213201		
50591	1108	40213160	1969-11-05	1969-11-05 00:00:00	1969-11-05	1969-11-05 00:00:00	1969-11-05	581452		0	0	0		0	0	0	72988	0	10	40213160		
56127	4660	19059056	1967-06-01	1967-06-01 00:00:00	1967-06-15	1967-06-15 00:00:00	1967-06-15	38000177		0	0	14		0	0	0	310651	0	243670	19059056		
2049	162	1713671	1998-08-13	1998-08-13 00:00:00	1998-08-20	1998-08-20 00:00:00	1998-08-20	38000177		0	0	7		0	0	0	11108	0	562251	1713671		
34289	2833	19129655	1977-08-04	1977-08-04 00:00:00	1977-08-18	1977-08-18 00:00:00	1977-08-18	38000177		0	0	14		0	0	0	188027	0	789980	19129655		
82965	1813	40213314	1982-08-28	1982-08-28 00:00:00	1982-08-28	1982-08-28 00:00:00	1982-08-28	581452		0	0	0		0	0	0	121332	0	49	40213314		
50312	4176	1127433	1979-01-01	1979-01-01 00:00:00	1979-01-15	1979-01-15 00:00:00	1979-01-15	38000177		0	0	14		0	0	0	277528	0	313782	1127433		
100035	2191	40213160	1975-03-30	1975-03-30 00:00:00	1975-03-30	1975-03-30 00:00:00	1975-03-30	581452		0	0	0		0	0	0	146096	0	10	40213160		
94412	2071	40213296	2009-05-27	2009-05-27 00:00:00	2009-05-27	2009-05-27 00:00:00	2009-05-27	581452		0	0	0		0	0	0	137786	0	52	40213296		
167859	3691	40213296	1997-02-07	1997-02-07 00:00:00	1997-02-07	1997-02-07 00:00:00	1997-02-07	581452		0	0	0		0	0	0	245315	0	52	40213296		
229931	5053	40213227	1996-03-24	1996-03-24 00:00:00	1996-03-24	1996-03-24 00:00:00	1996-03-24	581452		0	0	0		0	0	0	336058	0	113	40213227		
200712	4408	40213160	1981-07-02	1981-07-02 00:00:00	1981-07-02	1981-07-02 00:00:00	1981-07-02	581452		0	0	0		0	0	0	293025	0	10	40213160		
99731	2184	40213160	1972-01-26	1972-01-26 00:00:00	1972-01-26	1972-01-26 00:00:00	1972-01-26	581452		0	0	0		0	0	0	145605	0	10	40213160		
78544	1718	40213296	2006-09-23	2006-09-23 00:00:00	2006-09-23	2006-09-23 00:00:00	2006-09-23	581452		0	0	0		0	0	0	114865	0	52	40213296		
159853	3518	40213260	2009-04-06	2009-04-06 00:00:00	2009-04-06	2009-04-06 00:00:00	2009-04-06	581452		0	0	0		0	0	0	233609	0	121	40213260		
26823	2210	1713671	1950-08-28	1950-08-28 00:00:00	1950-09-18	1950-09-18 00:00:00	1950-09-18	38000177		0	0	21		0	0	0	147263	0	562251	1713671		
204099	4480	40213306	1983-12-13	1983-12-13 00:00:00	1983-12-13	1983-12-13 00:00:00	1983-12-13	581452		0	0	0		0	0	0	298157	0	43	40213306		
52038	4328	1127433	2003-08-06	2003-08-06 00:00:00	2003-08-20	2003-08-20 00:00:00	2003-08-20	38000177		0	0	14		0	0	0	287035	0	313782	1127433		
93862	2060	40213260	2013-12-04	2013-12-04 00:00:00	2013-12-04	2013-12-04 00:00:00	2013-12-04	581452		0	0	0		0	0	0	137030	0	121	40213260		
54117	4497	1127433	2013-11-06	2013-11-06 00:00:00	2013-11-13	2013-11-13 00:00:00	2013-11-13	38000177		0	0	7		0	0	0	299402	0	313782	1127433		
89851	1971	40213306	1991-05-17	1991-05-17 00:00:00	1991-05-17	1991-05-17 00:00:00	1991-05-17	581452		0	0	0		0	0	0	131016	0	43	40213306		
164732	3622	40213201	1988-08-24	1988-08-24 00:00:00	1988-08-24	1988-08-24 00:00:00	1988-08-24	581452		0	0	0		0	0	0	240761	0	33	40213201		
4226	350	1367571	1995-09-11	1995-09-11 00:00:00	1995-09-11	1995-09-11 00:00:00	1995-09-11	38000177		0	0	0		0	0	0	23293	0	314659	19080464		
9986	212	40213160	1970-06-27	1970-06-27 00:00:00	1970-06-27	1970-06-27 00:00:00	1970-06-27	581452		0	0	0		0	0	0	14454	0	10	40213160		
62256	1360	40213160	1976-01-11	1976-01-11 00:00:00	1976-01-11	1976-01-11 00:00:00	1976-01-11	581452		0	0	0		0	0	0	90270	0	10	40213160		
5671	123	40213227	2011-06-15	2011-06-15 00:00:00	2011-06-15	2011-06-15 00:00:00	2011-06-15	581452		0	0	0		0	0	0	8188	0	113	40213227		
43909	3638	40169216	1967-05-08	1967-05-08 00:00:00	1985-06-27	1985-06-27 00:00:00	1985-06-27	38000177		0	0	6625		0	0	0	241971	0	895994	40169216		
133257	2926	40213227	2003-12-19	2003-12-19 00:00:00	2003-12-19	2003-12-19 00:00:00	2003-12-19	581452		0	0	0		0	0	0	195159	0	113	40213227		
155404	3420	40213227	1996-04-30	1996-04-30 00:00:00	1996-04-30	1996-04-30 00:00:00	1996-04-30	581452		0	0	0		0	0	0	226853	0	113	40213227		
228268	5013	40213160	1965-01-29	1965-01-29 00:00:00	1965-01-29	1965-01-29 00:00:00	1965-01-29	581452		0	0	0		0	0	0	333184	0	10	40213160		
40656	885	40213160	1975-07-20	1975-07-20 00:00:00	1975-07-20	1975-07-20 00:00:00	1975-07-20	581452		0	0	0		0	0	0	58986	0	10	40213160		
12822	1079	19006318	1964-01-03	1964-01-03 00:00:00	1964-01-17	1964-01-17 00:00:00	1964-01-17	38000177		0	0	14		0	0	0	70734	0	105078	19006318		
32930	719	40213314	1982-01-22	1982-01-22 00:00:00	1982-01-22	1982-01-22 00:00:00	1982-01-22	581452		0	0	0		0	0	0	47595	0	49	40213314		
115293	2534	40213296	2014-01-28	2014-01-28 00:00:00	2014-01-28	2014-01-28 00:00:00	2014-01-28	581452		0	0	0		0	0	0	167473	0	52	40213296		
40647	3371	1127078	1983-12-01	1983-12-01 00:00:00	1983-12-29	1983-12-29 00:00:00	1983-12-29	38000177		0	0	28		0	0	0	223670	0	282464	1127078		
49650	1086	40213227	1999-02-19	1999-02-19 00:00:00	1999-02-19	1999-02-19 00:00:00	1999-02-19	581452		0	0	0		0	0	0	71335	0	113	40213227		
834	67	1127078	1976-01-04	1976-01-04 00:00:00	1976-01-18	1976-01-18 00:00:00	1976-01-18	38000177		0	0	14		0	0	0	4559	0	282464	1127078		
52258	1143	40213160	1972-02-04	1972-02-04 00:00:00	1972-02-04	1972-02-04 00:00:00	1972-02-04	581452		0	0	0		0	0	0	75452	0	10	40213160		
51291	4261	19059056	1927-03-16	1927-03-16 00:00:00	1927-03-30	1927-03-30 00:00:00	1927-03-30	38000177		0	0	14		0	0	0	282876	0	243670	19059056		
43769	3625	19059056	1954-06-09	1954-06-09 00:00:00	1954-06-23	1954-06-23 00:00:00	1954-06-23	38000177		0	0	14		0	0	0	241085	0	243670	19059056		
37652	821	40213227	2009-12-05	2009-12-05 00:00:00	2009-12-05	2009-12-05 00:00:00	2009-12-05	581452		0	0	0		0	0	0	54407	0	113	40213227		
57396	4761	1127433	2000-08-20	2000-08-20 00:00:00	2000-08-27	2000-08-27 00:00:00	2000-08-27	38000177		0	0	7		0	0	0	317323	0	313782	1127433		
97178	2131	40213198	2016-09-29	2016-09-29 00:00:00	2016-09-29	2016-09-29 00:00:00	2016-09-29	581452		0	0	0		0	0	0	141838	0	133	40213198		
51039	4240	1127433	1984-09-03	1984-09-03 00:00:00	1984-09-17	1984-09-17 00:00:00	1984-09-17	38000177		0	0	14		0	0	0	281675	0	313782	1127433		
51072	4241	19128065	1979-10-19	1979-10-19 00:00:00	1980-10-13	1980-10-13 00:00:00	1980-10-13	38000177		0	0	360		0	0	0	281759	0	749882	19128065		
79431	1738	40213306	1990-07-29	1990-07-29 00:00:00	1990-07-29	1990-07-29 00:00:00	1990-07-29	581452		0	0	0		0	0	0	116163	0	43	40213306		
26346	2167	1713671	2013-03-15	2013-03-15 00:00:00	2013-03-22	2013-03-22 00:00:00	2013-03-22	38000177		0	0	7		0	0	0	144350	0	562251	1713671		
59832	1309	40213260	2006-04-05	2006-04-05 00:00:00	2006-04-05	2006-04-05 00:00:00	2006-04-05	581452		0	0	0		0	0	0	86498	0	121	40213260		
140433	3083	40213227	1993-05-09	1993-05-09 00:00:00	1993-05-09	1993-05-09 00:00:00	1993-05-09	581452		0	0	0		0	0	0	205291	0	113	40213227		
28234	2333	1367571	1978-05-19	1978-05-19 00:00:00	1978-05-19	1978-05-19 00:00:00	1978-05-19	38000177		0	0	0		0	0	0	155162	0	314659	19080464		
60648	1325	40213306	1987-02-15	1987-02-15 00:00:00	1987-02-15	1987-02-15 00:00:00	1987-02-15	581452		0	0	0		0	0	0	87968	0	43	40213306		
142408	3128	40213227	1996-06-18	1996-06-18 00:00:00	1996-06-18	1996-06-18 00:00:00	1996-06-18	581452		0	0	0		0	0	0	208094	0	113	40213227		
9079	756	1118084	2001-02-06	2001-02-06 00:00:00	2001-02-06	2001-02-06 00:00:00	\N	38000177		0	0	0		0	0	0	50107	0	00025152531	44923712		
113974	2504	40213227	1995-11-06	1995-11-06 00:00:00	1995-11-06	1995-11-06 00:00:00	1995-11-06	581452		0	0	0		0	0	0	165848	0	113	40213227		
121716	2675	40213160	1961-05-07	1961-05-07 00:00:00	1961-05-07	1961-05-07 00:00:00	1961-05-07	581452		0	0	0		0	0	0	177246	0	10	40213160		
28905	2389	1127078	1975-12-17	1975-12-17 00:00:00	1976-01-16	1976-01-16 00:00:00	1976-01-16	38000177		0	0	30		0	0	0	158841	0	282464	1127078		
7855	656	40236446	1971-01-02	1971-01-02 00:00:00	1971-11-06	1971-11-06 00:00:00	1971-11-06	38000177		0	0	308		0	0	0	43443	0	1091392	40236446		
171912	3779	40213227	1992-11-07	1992-11-07 00:00:00	1992-11-07	1992-11-07 00:00:00	1992-11-07	581452		0	0	0		0	0	0	251135	0	113	40213227		
34635	756	40213160	1966-01-12	1966-01-12 00:00:00	1966-01-12	1966-01-12 00:00:00	1966-01-12	581452		0	0	0		0	0	0	50158	0	10	40213160		
35954	2960	19006318	1957-11-19	1957-11-19 00:00:00	1957-12-03	1957-12-03 00:00:00	1957-12-03	38000177		0	0	14		0	0	0	197695	0	105078	19006318		
12993	1091	19133905	1987-01-16	1987-01-16 00:00:00	1987-01-29	1987-01-29 00:00:00	1987-01-29	38000177		0	0	13		0	0	0	71596	0	834102	19133905		
18534	1532	1713671	2001-06-13	2001-06-13 00:00:00	2001-06-20	2001-06-20 00:00:00	2001-06-20	38000177		0	0	7		0	0	0	102598	0	562251	1713671		
105628	2318	40213306	1985-09-28	1985-09-28 00:00:00	1985-09-28	1985-09-28 00:00:00	1985-09-28	581452		0	0	0		0	0	0	154072	0	43	40213306		
53019	1159	40213314	1981-01-03	1981-01-03 00:00:00	1981-01-03	1981-01-03 00:00:00	1981-01-03	581452		0	0	0		0	0	0	76578	0	49	40213314		
194799	4279	40213227	2001-04-13	2001-04-13 00:00:00	2001-04-13	2001-04-13 00:00:00	2001-04-13	581452		0	0	0		0	0	0	284082	0	113	40213227		
50592	1108	40213296	2011-06-08	2011-06-08 00:00:00	2011-06-08	2011-06-08 00:00:00	2011-06-08	581452		0	0	0		0	0	0	72984	0	52	40213296		
56128	4660	1713671	1976-07-23	1976-07-23 00:00:00	1976-08-27	1976-08-27 00:00:00	1976-08-27	38000177		0	0	35		0	0	0	310606	0	562251	1713671		
2050	162	19059056	1940-07-14	1940-07-14 00:00:00	1940-07-28	1940-07-28 00:00:00	1940-07-28	38000177		0	0	14		0	0	0	11084	0	243670	19059056		
34290	2833	19078461	1977-08-04	1977-08-04 00:00:00	1977-08-18	1977-08-18 00:00:00	1977-08-18	38000177		0	0	14		0	0	0	188027	0	310965	19078461		
82969	1813	40213227	2013-05-04	2013-05-04 00:00:00	2013-05-04	2013-05-04 00:00:00	2013-05-04	581452		0	0	0		0	0	0	121313	0	113	40213227		
50313	4176	1127433	2010-02-02	2010-02-02 00:00:00	2010-02-09	2010-02-09 00:00:00	2010-02-09	38000177		0	0	7		0	0	0	277450	0	313782	1127433		
100039	2191	40213227	2002-03-31	2002-03-31 00:00:00	2002-03-31	2002-03-31 00:00:00	2002-03-31	581452		0	0	0		0	0	0	146123	0	113	40213227		
25781	563	40213160	1964-12-20	1964-12-20 00:00:00	1964-12-20	1964-12-20 00:00:00	1964-12-20	581452		0	0	0		0	0	0	37256	0	10	40213160		
167862	3691	40213260	2007-10-05	2007-10-05 00:00:00	2007-10-05	2007-10-05 00:00:00	2007-10-05	581452		0	0	0		0	0	0	245376	0	121	40213260		
229944	5053	40213201	2011-12-04	2011-12-04 00:00:00	2011-12-04	2011-12-04 00:00:00	2011-12-04	581452		0	0	0		0	0	0	336008	0	33	40213201		
200716	4408	40213251	1983-12-29	1983-12-29 00:00:00	1983-12-29	1983-12-29 00:00:00	1983-12-29	581452		0	0	0		0	0	0	293007	0	21	40213251		
99736	2184	40213296	2009-10-21	2009-10-21 00:00:00	2009-10-21	2009-10-21 00:00:00	2009-10-21	581452		0	0	0		0	0	0	145541	0	52	40213296		
41152	895	40213160	1965-01-15	1965-01-15 00:00:00	1965-01-15	1965-01-15 00:00:00	1965-01-15	581452		0	0	0		0	0	0	59690	0	10	40213160		
159855	3518	40213227	2009-04-06	2009-04-06 00:00:00	2009-04-06	2009-04-06 00:00:00	2009-04-06	581452		0	0	0		0	0	0	233609	0	113	40213227		
26824	2210	19059056	1943-08-20	1943-08-20 00:00:00	1943-11-18	1943-11-18 00:00:00	1943-11-18	38000177		0	0	90		0	0	0	147195	0	243670	19059056		
204107	4480	40213260	2011-02-01	2011-02-01 00:00:00	2011-02-01	2011-02-01 00:00:00	2011-02-01	581452		0	0	0		0	0	0	298201	0	121	40213260		
52039	4328	1118084	2009-07-13	2009-07-13 00:00:00	2009-07-13	2009-07-13 00:00:00	\N	38000177		0	0	0		0	0	0	287017	0	00025152531	44923712		
93864	2060	40213160	1964-08-12	1964-08-12 00:00:00	1964-08-12	1964-08-12 00:00:00	1964-08-12	581452		0	0	0		0	0	0	136981	0	10	40213160		
54118	4497	1124300	1992-11-05	1992-11-05 00:00:00	1992-11-05	1992-11-05 00:00:00	\N	38000177		0	0	0		0	0	0	299344	0	00781178901	45011828		
89854	1971	40213260	2019-03-15	2019-03-15 00:00:00	2019-03-15	2019-03-15 00:00:00	2019-03-15	581452		0	0	0		0	0	0	131015	0	121	40213260		
101159	2217	40213160	1980-03-07	1980-03-07 00:00:00	1980-03-07	1980-03-07 00:00:00	1980-03-07	581452		0	0	0		0	0	0	147633	0	10	40213160		
4228	350	1127433	2003-01-03	2003-01-03 00:00:00	2003-01-24	2003-01-24 00:00:00	2003-01-24	38000177		0	0	21		0	0	0	23295	0	313782	1127433		
9987	212	40213160	1970-11-28	1970-11-28 00:00:00	1970-11-28	1970-11-28 00:00:00	1970-11-28	581452		0	0	0		0	0	0	14455	0	10	40213160		
62257	1360	40213314	1977-01-30	1977-01-30 00:00:00	1977-01-30	1977-01-30 00:00:00	1977-01-30	581452		0	0	0		0	0	0	90235	0	49	40213314		
43857	3631	1127078	1981-03-31	1981-03-31 00:00:00	1981-04-30	1981-04-30 00:00:00	1981-04-30	38000177		0	0	30		0	0	0	241581	0	282464	1127078		
43910	3638	19133905	1999-10-29	1999-10-29 00:00:00	1999-11-10	1999-11-10 00:00:00	1999-11-10	38000177		0	0	12		0	0	0	241958	0	834102	19133905		
133258	2926	40213306	2003-12-19	2003-12-19 00:00:00	2003-12-19	2003-12-19 00:00:00	2003-12-19	581452		0	0	0		0	0	0	195159	0	43	40213306		
155411	3420	40213160	1969-09-09	1969-09-09 00:00:00	1969-09-09	1969-09-09 00:00:00	1969-09-09	581452		0	0	0		0	0	0	226860	0	10	40213160		
239862	5265	40213160	1968-08-01	1968-08-01 00:00:00	1968-08-01	1968-08-01 00:00:00	1968-08-01	581452		0	0	0		0	0	0	350321	0	10	40213160		
40662	886	40213314	1984-06-12	1984-06-12 00:00:00	1984-06-12	1984-06-12 00:00:00	1984-06-12	581452		0	0	0		0	0	0	59084	0	49	40213314		
12823	1079	1127078	1964-01-03	1964-01-03 00:00:00	1964-01-17	1964-01-17 00:00:00	1964-01-17	38000177		0	0	14		0	0	0	70734	0	282464	1127078		
142719	3135	40213260	2013-06-06	2013-06-06 00:00:00	2013-06-06	2013-06-06 00:00:00	2013-06-06	581452		0	0	0		0	0	0	208677	0	121	40213260		
115294	2534	40213160	1972-10-31	1972-10-31 00:00:00	1972-10-31	1972-10-31 00:00:00	1972-10-31	581452		0	0	0		0	0	0	167466	0	10	40213160		
40648	3371	1127078	1985-09-19	1985-09-19 00:00:00	1985-10-10	1985-10-10 00:00:00	1985-10-10	38000177		0	0	21		0	0	0	223671	0	282464	1127078		
49652	1086	40213306	1988-04-29	1988-04-29 00:00:00	1988-04-29	1988-04-29 00:00:00	1988-04-29	581452		0	0	0		0	0	0	71347	0	43	40213306		
835	67	46233988	1976-01-04	1976-01-04 00:00:00	1976-01-18	1976-01-18 00:00:00	1976-01-18	38000177		0	0	14		0	0	0	4559	0	1652673	46233988		
52261	1143	40213160	1971-09-03	1971-09-03 00:00:00	1971-09-03	1971-09-03 00:00:00	1971-09-03	581452		0	0	0		0	0	0	75451	0	10	40213160		
51292	4261	1127433	1998-03-14	1998-03-14 00:00:00	1998-03-21	1998-03-21 00:00:00	1998-03-21	38000177		0	0	7		0	0	0	282968	0	313782	1127433		
43770	3625	1713671	2010-10-20	2010-10-20 00:00:00	2010-11-03	2010-11-03 00:00:00	2010-11-03	38000177		0	0	14		0	0	0	241041	0	562251	1713671		
37664	822	40213296	2012-05-25	2012-05-25 00:00:00	2012-05-25	2012-05-25 00:00:00	2012-05-25	581452		0	0	0		0	0	0	54510	0	52	40213296		
57397	4761	1115171	2002-02-09	2002-02-09 00:00:00	2002-02-23	2002-02-23 00:00:00	2002-02-23	38000177		0	0	14		0	0	0	317238	0	849574	1115171		
97182	2131	40213201	2017-10-05	2017-10-05 00:00:00	2017-10-05	2017-10-05 00:00:00	2017-10-05	581452		0	0	0		0	0	0	141810	0	33	40213201		
51040	4240	19075001	1984-09-03	1984-09-03 00:00:00	1984-09-17	1984-09-17 00:00:00	1984-09-17	38000177		0	0	14		0	0	0	281675	0	309097	19075001		
51073	4241	1118084	2006-08-08	2006-08-08 00:00:00	2006-08-08	2006-08-08 00:00:00	\N	38000177		0	0	0		0	0	0	281736	0	00025152531	44923712		
79436	1738	40213260	2018-05-20	2018-05-20 00:00:00	2018-05-20	2018-05-20 00:00:00	2018-05-20	581452		0	0	0		0	0	0	116114	0	121	40213260		
26347	2168	40169216	1960-09-19	1960-09-19 00:00:00	1960-09-19	1960-09-19 00:00:00	\N	38000177		0	0	0		0	0	0	144485	0	895994	40169216		
59842	1310	40213227	2001-05-04	2001-05-04 00:00:00	2001-05-04	2001-05-04 00:00:00	2001-05-04	581452		0	0	0		0	0	0	86538	0	113	40213227		
45066	3730	19078461	2019-03-31	2019-03-31 00:00:00	2019-04-21	2019-04-21 00:00:00	2019-04-21	38000177		0	0	21		0	0	0	247810	0	310965	19078461		
11642	250	40213296	2016-02-24	2016-02-24 00:00:00	2016-02-24	2016-02-24 00:00:00	2016-02-24	581452		0	0	0		0	0	0	16795	0	52	40213296		
60650	1325	40213227	1996-05-19	1996-05-19 00:00:00	1996-05-19	1996-05-19 00:00:00	1996-05-19	581452		0	0	0		0	0	0	87946	0	113	40213227		
142409	3128	40213306	1996-06-18	1996-06-18 00:00:00	1996-06-18	1996-06-18 00:00:00	1996-06-18	581452		0	0	0		0	0	0	208094	0	43	40213306		
9080	756	1127433	1995-08-25	1995-08-25 00:00:00	1995-10-01	1995-10-01 00:00:00	1995-10-01	38000177		0	0	37		0	0	0	50104	0	313782	1127433		
113976	2504	40213260	2006-04-10	2006-04-10 00:00:00	2006-04-10	2006-04-10 00:00:00	2006-04-10	581452		0	0	0		0	0	0	\N	0	121	40213260		
13626	295	40213201	2015-09-16	2015-09-16 00:00:00	2015-09-16	2015-09-16 00:00:00	2015-09-16	581452		0	0	0		0	0	0	19648	0	33	40213201		
28907	2389	1127433	1996-06-11	1996-06-11 00:00:00	1996-06-18	1996-06-18 00:00:00	1996-06-18	38000177		0	0	7		0	0	0	158889	0	313782	1127433		
211486	4637	40213227	2005-06-27	2005-06-27 00:00:00	2005-06-27	2005-06-27 00:00:00	2005-06-27	581452		0	0	0		0	0	0	309076	0	113	40213227		
171913	3779	40213306	1992-11-07	1992-11-07 00:00:00	1992-11-07	1992-11-07 00:00:00	1992-11-07	581452		0	0	0		0	0	0	251135	0	43	40213306		
34636	756	40213160	1966-04-13	1966-04-13 00:00:00	1966-04-13	1966-04-13 00:00:00	1966-04-13	581452		0	0	0		0	0	0	50110	0	10	40213160		
35956	2960	1118084	1988-10-12	1988-10-12 00:00:00	1988-10-12	1988-10-12 00:00:00	\N	38000177		0	0	0		0	0	0	197632	0	00025152531	44923712		
12994	1091	1713671	2005-11-14	2005-11-14 00:00:00	2005-12-05	2005-12-05 00:00:00	2005-12-05	38000177		0	0	21		0	0	0	71701	0	562251	1713671		
18535	1532	19019979	1983-04-23	1983-04-23 00:00:00	1983-05-07	1983-05-07 00:00:00	1983-05-07	38000177		0	0	14		0	0	0	102613	0	198405	19019979		
105634	2318	40213260	2013-10-12	2013-10-12 00:00:00	2013-10-12	2013-10-12 00:00:00	2013-10-12	581452		0	0	0		0	0	0	154039	0	121	40213260		
29069	2406	40220960	1993-09-23	1993-09-23 00:00:00	1993-09-23	1993-09-23 00:00:00	1993-09-23	38000177		0	0	0		0	0	0	159858	0	1804799	40220960		
236458	5193	40213160	1961-05-04	1961-05-04 00:00:00	1961-05-04	1961-05-04 00:00:00	1961-05-04	581452		0	0	0		0	0	0	345204	0	10	40213160		
50594	1108	40213227	2011-06-08	2011-06-08 00:00:00	2011-06-08	2011-06-08 00:00:00	2011-06-08	581452		0	0	0		0	0	0	72984	0	113	40213227		
56129	4660	1127433	1967-08-02	1967-08-02 00:00:00	1967-08-16	1967-08-16 00:00:00	1967-08-16	38000177		0	0	14		0	0	0	310597	0	313782	1127433		
2051	162	1124300	1972-04-07	1972-04-07 00:00:00	1972-04-07	1972-04-07 00:00:00	\N	38000177		0	0	0		0	0	0	11136	0	00781178901	45011828		
34291	2833	1713671	2001-04-28	2001-04-28 00:00:00	2001-05-05	2001-05-05 00:00:00	2001-05-05	38000177		0	0	7		0	0	0	188038	0	562251	1713671		
82972	1813	40213251	1984-05-26	1984-05-26 00:00:00	1984-05-26	1984-05-26 00:00:00	1984-05-26	581452		0	0	0		0	0	0	121317	0	21	40213251		
50314	4176	19059056	1979-03-27	1979-03-27 00:00:00	1979-04-17	1979-04-17 00:00:00	1979-04-17	38000177		0	0	21		0	0	0	277544	0	243670	19059056		
100045	2191	40213306	1993-03-21	1993-03-21 00:00:00	1993-03-21	1993-03-21 00:00:00	1993-03-21	581452		0	0	0		0	0	0	146112	0	43	40213306		
25782	563	40213160	1964-07-19	1964-07-19 00:00:00	1964-07-19	1964-07-19 00:00:00	1964-07-19	581452		0	0	0		0	0	0	37255	0	10	40213160		
167866	3691	40213227	2005-09-02	2005-09-02 00:00:00	2005-09-02	2005-09-02 00:00:00	2005-09-02	581452		0	0	0		0	0	0	\N	0	113	40213227		
16128	1338	40229134	1992-05-24	1992-05-24 00:00:00	1992-05-31	1992-05-31 00:00:00	1992-05-31	38000177		0	0	7		0	0	0	88686	0	1043400	40229134		
200722	4408	40213251	1986-01-02	1986-01-02 00:00:00	1986-01-02	1986-01-02 00:00:00	1986-01-02	581452		0	0	0		0	0	0	293028	0	21	40213251		
99739	2184	40213160	1967-05-24	1967-05-24 00:00:00	1967-05-24	1967-05-24 00:00:00	1967-05-24	581452		0	0	0		0	0	0	145567	0	10	40213160		
52472	1148	40213296	1997-06-28	1997-06-28 00:00:00	1997-06-28	1997-06-28 00:00:00	1997-06-28	581452		0	0	0		0	0	0	75916	0	52	40213296		
159862	3518	40213160	1958-12-08	1958-12-08 00:00:00	1958-12-08	1958-12-08 00:00:00	1958-12-08	581452		0	0	0		0	0	0	233538	0	10	40213160		
26825	2210	1127433	1985-11-24	1985-11-24 00:00:00	1986-01-23	1986-01-23 00:00:00	1986-01-23	38000177		0	0	60		0	0	0	147200	0	313782	1127433		
204108	4480	40213227	2012-02-07	2012-02-07 00:00:00	2012-02-07	2012-02-07 00:00:00	2012-02-07	581452		0	0	0		0	0	0	298159	0	113	40213227		
52040	4328	1713671	2016-07-21	2016-07-21 00:00:00	2016-07-28	2016-07-28 00:00:00	2016-07-28	38000177		0	0	7		0	0	0	287036	0	562251	1713671		
93866	2060	40213306	1985-03-20	1985-03-20 00:00:00	1985-03-20	1985-03-20 00:00:00	1985-03-20	581452		0	0	0		0	0	0	137035	0	43	40213306		
54119	4497	1127433	2005-01-22	2005-01-22 00:00:00	2005-01-29	2005-01-29 00:00:00	2005-01-29	38000177		0	0	7		0	0	0	299398	0	313782	1127433		
89858	1971	40213227	2000-09-15	2000-09-15 00:00:00	2000-09-15	2000-09-15 00:00:00	2000-09-15	581452		0	0	0		0	0	0	131049	0	113	40213227		
101161	2217	40213251	1984-08-24	1984-08-24 00:00:00	1984-08-24	1984-08-24 00:00:00	1984-08-24	581452		0	0	0		0	0	0	147649	0	21	40213251		
4229	350	40236824	1982-10-21	1982-10-21 00:00:00	1982-11-04	1982-11-04 00:00:00	1982-11-04	38000177		0	0	14		0	0	0	23279	0	1094107	40236824		
9999	212	40213227	2002-06-29	2002-06-29 00:00:00	2002-06-29	2002-06-29 00:00:00	2002-06-29	581452		0	0	0		0	0	0	14473	0	113	40213227		
62268	1360	40213314	1978-01-29	1978-01-29 00:00:00	1978-01-29	1978-01-29 00:00:00	1978-01-29	581452		0	0	0		0	0	0	90272	0	49	40213314		
43858	3631	1713671	1980-11-03	1980-11-03 00:00:00	1980-11-17	1980-11-17 00:00:00	1980-11-17	38000177		0	0	14		0	0	0	241594	0	562251	1713671		
43911	3638	1127433	1987-07-09	1987-07-09 00:00:00	1987-07-30	1987-07-30 00:00:00	1987-07-30	38000177		0	0	21		0	0	0	241967	0	313782	1127433		
133267	2926	40213227	2012-12-28	2012-12-28 00:00:00	2012-12-28	2012-12-28 00:00:00	2012-12-28	581452		0	0	0		0	0	0	195162	0	113	40213227		
155420	3420	40213306	1987-02-24	1987-02-24 00:00:00	1987-02-24	1987-02-24 00:00:00	1987-02-24	581452		0	0	0		0	0	0	226898	0	43	40213306		
239866	5265	40213260	2018-12-27	2018-12-27 00:00:00	2018-12-27	2018-12-27 00:00:00	2018-12-27	581452		0	0	0		0	0	0	350273	0	121	40213260		
40663	886	40213251	1984-06-12	1984-06-12 00:00:00	1984-06-12	1984-06-12 00:00:00	1984-06-12	581452		0	0	0		0	0	0	59084	0	21	40213251		
12825	1079	40174880	2016-03-05	2016-03-05 00:00:00	2016-03-05	2016-03-05 00:00:00	\N	38000177		0	0	0		0	0	0	70716	0	966222	40174880		
142720	3135	40213160	1964-02-13	1964-02-13 00:00:00	1964-02-13	1964-02-13 00:00:00	1964-02-13	581452		0	0	0		0	0	0	208651	0	10	40213160		
115302	2534	40213160	1973-04-03	1973-04-03 00:00:00	1973-04-03	1973-04-03 00:00:00	1973-04-03	581452		0	0	0		0	0	0	167390	0	10	40213160		
40649	3371	19128022	1990-08-06	1990-08-06 00:00:00	1991-08-01	1991-08-01 00:00:00	1991-08-01	38000177		0	0	360		0	0	0	223561	0	749785	19128022		
175780	3864	40213260	2015-04-11	2015-04-11 00:00:00	2015-04-11	2015-04-11 00:00:00	2015-04-11	581452		0	0	0		0	0	0	256498	0	121	40213260		
836	67	1713671	2018-06-07	2018-06-07 00:00:00	2018-06-21	2018-06-21 00:00:00	2018-06-21	38000177		0	0	14		0	0	0	4523	0	562251	1713671		
52265	1144	40213296	2010-07-18	2010-07-18 00:00:00	2010-07-18	2010-07-18 00:00:00	2010-07-18	581452		0	0	0		0	0	0	75513	0	52	40213296		
51293	4261	1127433	1929-09-02	1929-09-02 00:00:00	1929-09-09	1929-09-09 00:00:00	1929-09-09	38000177		0	0	7		0	0	0	282862	0	313782	1127433		
43771	3625	1127433	1987-04-26	1987-04-26 00:00:00	1987-05-03	1987-05-03 00:00:00	1987-05-03	38000177		0	0	7		0	0	0	241062	0	313782	1127433		
37666	822	40213227	2012-05-25	2012-05-25 00:00:00	2012-05-25	2012-05-25 00:00:00	2012-05-25	581452		0	0	0		0	0	0	54510	0	113	40213227		
57398	4761	19019979	1981-09-27	1981-09-27 00:00:00	1981-10-11	1981-10-11 00:00:00	1981-10-11	38000177		0	0	14		0	0	0	317290	0	198405	19019979		
97190	2131	40213227	2012-09-27	2012-09-27 00:00:00	2012-09-27	2012-09-27 00:00:00	2012-09-27	581452		0	0	0		0	0	0	141822	0	113	40213227		
51041	4240	19126352	2010-11-08	2010-11-08 00:00:00	2010-11-08	2010-11-08 00:00:00	\N	38000177		0	0	0		0	0	0	281660	0	705129	19126352		
51074	4241	19059056	1967-10-03	1967-10-03 00:00:00	1967-10-17	1967-10-17 00:00:00	1967-10-17	38000177		0	0	14		0	0	0	281748	0	243670	19059056		
79439	1738	40213260	2019-05-26	2019-05-26 00:00:00	2019-05-26	2019-05-26 00:00:00	2019-05-26	581452		0	0	0		0	0	0	116128	0	121	40213260		
26348	2168	1154615	1960-09-19	1960-09-19 00:00:00	1960-09-19	1960-09-19 00:00:00	\N	38000177		0	0	0		0	0	0	144485	0	745679	1154615		
119931	2636	40213227	2011-04-22	2011-04-22 00:00:00	2011-04-22	2011-04-22 00:00:00	2011-04-22	581452		0	0	0		0	0	0	174461	0	113	40213227		
45067	3730	1127433	2007-01-24	2007-01-24 00:00:00	2007-02-07	2007-02-07 00:00:00	2007-02-07	38000177		0	0	14		0	0	0	247877	0	313782	1127433		
11644	250	40213227	2016-02-24	2016-02-24 00:00:00	2016-02-24	2016-02-24 00:00:00	2016-02-24	581452		0	0	0		0	0	0	16795	0	113	40213227		
60658	1325	40213296	2004-04-18	2004-04-18 00:00:00	2004-04-18	2004-04-18 00:00:00	2004-04-18	581452		0	0	0		0	0	0	88003	0	52	40213296		
142412	3129	40213227	2013-05-28	2013-05-28 00:00:00	2013-05-28	2013-05-28 00:00:00	2013-05-28	581452		0	0	0		0	0	0	208286	0	113	40213227		
131437	2889	40213160	1964-12-27	1964-12-27 00:00:00	1964-12-27	1964-12-27 00:00:00	1964-12-27	581452		0	0	0		0	0	0	192156	0	10	40213160		
113978	2504	40213160	1955-10-03	1955-10-03 00:00:00	1955-10-03	1955-10-03 00:00:00	1955-10-03	581452		0	0	0		0	0	0	165820	0	10	40213160		
13632	295	40213227	2010-08-18	2010-08-18 00:00:00	2010-08-18	2010-08-18 00:00:00	2010-08-18	581452		0	0	0		0	0	0	19567	0	113	40213227		
28908	2389	19078461	1992-12-31	1992-12-31 00:00:00	1993-01-28	1993-01-28 00:00:00	1993-01-28	38000177		0	0	28		0	0	0	158843	0	310965	19078461		
211491	4637	40213160	1974-07-01	1974-07-01 00:00:00	1974-07-01	1974-07-01 00:00:00	1974-07-01	581452		0	0	0		0	0	0	309019	0	10	40213160		
115038	2528	40213296	2009-01-21	2009-01-21 00:00:00	2009-01-21	2009-01-21 00:00:00	2009-01-21	581452		0	0	0		0	0	0	167091	0	52	40213296		
34640	756	40213260	2016-02-10	2016-02-10 00:00:00	2016-02-10	2016-02-10 00:00:00	2016-02-10	581452		0	0	0		0	0	0	50176	0	121	40213260		
35957	2960	1713671	1968-08-30	1968-08-30 00:00:00	1968-09-06	1968-09-06 00:00:00	1968-09-06	38000177		0	0	7		0	0	0	197630	0	562251	1713671		
12995	1091	40229134	1985-04-18	1985-04-18 00:00:00	1985-04-25	1985-04-25 00:00:00	1985-04-25	38000177		0	0	7		0	0	0	71680	0	1043400	40229134		
18536	1532	19073183	1983-04-23	1983-04-23 00:00:00	1983-05-07	1983-05-07 00:00:00	1983-05-07	38000177		0	0	14		0	0	0	102613	0	308182	19073183		
105638	2318	40213160	1963-05-04	1963-05-04 00:00:00	1963-05-04	1963-05-04 00:00:00	1963-05-04	581452		0	0	0		0	0	0	154104	0	10	40213160		
29070	2406	1127433	1954-09-07	1954-09-07 00:00:00	1954-09-21	1954-09-21 00:00:00	1954-09-21	38000177		0	0	14		0	0	0	159812	0	313782	1127433		
182991	4020	40213160	1956-08-09	1956-08-09 00:00:00	1956-08-09	1956-08-09 00:00:00	1956-08-09	581452		0	0	0		0	0	0	267200	0	10	40213160		
50600	1108	40213227	2003-05-28	2003-05-28 00:00:00	2003-05-28	2003-05-28 00:00:00	2003-05-28	581452		0	0	0		0	0	0	72950	0	113	40213227		
56130	4660	1127433	1989-07-19	1989-07-19 00:00:00	1989-08-23	1989-08-23 00:00:00	1989-08-23	38000177		0	0	35		0	0	0	310652	0	313782	1127433		
2052	162	40236824	1976-12-13	1976-12-13 00:00:00	1976-12-20	1976-12-20 00:00:00	1976-12-20	38000177		0	0	7		0	0	0	11095	0	1094107	40236824		
34292	2833	1713671	1959-09-13	1959-09-13 00:00:00	1959-09-27	1959-09-27 00:00:00	1959-09-27	38000177		0	0	14		0	0	0	188036	0	562251	1713671		
82974	1813	40213314	1981-11-28	1981-11-28 00:00:00	1981-11-28	1981-11-28 00:00:00	1981-11-28	581452		0	0	0		0	0	0	121331	0	49	40213314		
50315	4176	19059056	1927-11-13	1927-11-13 00:00:00	1927-11-27	1927-11-27 00:00:00	1927-11-27	38000177		0	0	14		0	0	0	277542	0	243670	19059056		
100048	2191	40213227	1993-03-21	1993-03-21 00:00:00	1993-03-21	1993-03-21 00:00:00	1993-03-21	581452		0	0	0		0	0	0	146112	0	113	40213227		
25791	563	40213296	2004-04-18	2004-04-18 00:00:00	2004-04-18	2004-04-18 00:00:00	2004-04-18	581452		0	0	0		0	0	0	37311	0	52	40213296		
167868	3691	40213160	1955-04-22	1955-04-22 00:00:00	1955-04-22	1955-04-22 00:00:00	1955-04-22	581452		0	0	0		0	0	0	245300	0	10	40213160		
16129	1338	1127433	2019-03-23	2019-03-23 00:00:00	2019-06-21	2019-06-21 00:00:00	2019-06-21	38000177		0	0	90		0	0	0	88765	0	313782	1127433		
200725	4408	40213160	1986-01-02	1986-01-02 00:00:00	1986-01-02	1986-01-02 00:00:00	1986-01-02	581452		0	0	0		0	0	0	293028	0	10	40213160		
99742	2185	40213227	1992-08-13	1992-08-13 00:00:00	1992-08-13	1992-08-13 00:00:00	1992-08-13	581452		0	0	0		0	0	0	145663	0	113	40213227		
46712	1021	40213160	1957-11-21	1957-11-21 00:00:00	1957-11-21	1957-11-21 00:00:00	1957-11-21	581452		0	0	0		0	0	0	67176	0	10	40213160		
159868	3518	40213227	2000-06-12	2000-06-12 00:00:00	2000-06-12	2000-06-12 00:00:00	2000-06-12	581452		0	0	0		0	0	0	233608	0	113	40213227		
26826	2210	1127433	2002-05-01	2002-05-01 00:00:00	2002-05-15	2002-05-15 00:00:00	2002-05-15	38000177		0	0	14		0	0	0	147272	0	313782	1127433		
204109	4480	40213260	2012-02-07	2012-02-07 00:00:00	2012-02-07	2012-02-07 00:00:00	2012-02-07	581452		0	0	0		0	0	0	298159	0	121	40213260		
52041	4328	920300	1998-07-12	1998-07-12 00:00:00	1998-07-19	1998-07-19 00:00:00	1998-07-19	38000177		0	0	7		0	0	0	287067	0	311989	920300		
93870	2060	40213160	1964-02-12	1964-02-12 00:00:00	1964-02-12	1964-02-12 00:00:00	1964-02-12	581452		0	0	0		0	0	0	\N	0	10	40213160		
54120	4497	19059056	1958-06-01	1958-06-01 00:00:00	1958-06-15	1958-06-15 00:00:00	1958-06-15	38000177		0	0	14		0	0	0	299386	0	243670	19059056		
101138	2217	40213306	2001-01-19	2001-01-19 00:00:00	2001-01-19	2001-01-19 00:00:00	2001-01-19	581452		0	0	0		0	0	0	147653	0	43	40213306		
101166	2217	40213160	1979-12-07	1979-12-07 00:00:00	1979-12-07	1979-12-07 00:00:00	1979-12-07	581452		0	0	0		0	0	0	147675	0	10	40213160		
4230	350	920300	1982-10-21	1982-10-21 00:00:00	1982-10-28	1982-10-28 00:00:00	1982-10-28	38000177		0	0	7		0	0	0	23279	0	311989	920300		
10001	213	40213160	1967-10-09	1967-10-09 00:00:00	1967-10-09	1967-10-09 00:00:00	1967-10-09	581452		0	0	0		0	0	0	14530	0	10	40213160		
62269	1360	40213227	2006-11-05	2006-11-05 00:00:00	2006-11-05	2006-11-05 00:00:00	2006-11-05	581452		0	0	0		0	0	0	90279	0	113	40213227		
43859	3631	1118084	2010-08-06	2010-08-06 00:00:00	2010-08-06	2010-08-06 00:00:00	\N	38000177		0	0	0		0	0	0	241578	0	00025152531	44923712		
43912	3638	1127433	2014-07-27	2014-07-27 00:00:00	2014-08-10	2014-08-10 00:00:00	2014-08-10	38000177		0	0	14		0	0	0	241992	0	313782	1127433		
86911	1905	40213160	1966-10-28	1966-10-28 00:00:00	1966-10-28	1966-10-28 00:00:00	1966-10-28	581452		0	0	0		0	0	0	126823	0	10	40213160		
155424	3420	40213160	1965-06-08	1965-06-08 00:00:00	1965-06-08	1965-06-08 00:00:00	1965-06-08	581452		0	0	0		0	0	0	226918	0	10	40213160		
239875	5265	40213160	1968-05-30	1968-05-30 00:00:00	1968-05-30	1968-05-30 00:00:00	1968-05-30	581452		0	0	0		0	0	0	350306	0	10	40213160		
40667	886	40213227	2015-03-24	2015-03-24 00:00:00	2015-03-24	2015-03-24 00:00:00	2015-03-24	581452		0	0	0		0	0	0	59053	0	113	40213227		
12826	1079	19133873	1970-10-15	1970-10-15 00:00:00	1970-10-27	1970-10-27 00:00:00	1970-10-27	38000177		0	0	12		0	0	0	70757	0	834061	19133873		
142724	3135	40213306	1984-06-21	1984-06-21 00:00:00	1984-06-21	1984-06-21 00:00:00	1984-06-21	581452		0	0	0		0	0	0	208716	0	43	40213306		
64350	1408	40213201	2010-02-22	2010-02-22 00:00:00	2010-02-22	2010-02-22 00:00:00	2010-02-22	581452		0	0	0		0	0	0	93679	0	33	40213201		
40650	3371	46233988	1977-10-17	1977-10-17 00:00:00	1977-10-31	1977-10-31 00:00:00	1977-10-31	38000177		0	0	14		0	0	0	223634	0	1652673	46233988		
175793	3865	40213227	2007-07-05	2007-07-05 00:00:00	2007-07-05	2007-07-05 00:00:00	2007-07-05	581452		0	0	0		0	0	0	256538	0	113	40213227		
47842	3967	19078461	1998-11-13	1998-11-13 00:00:00	1998-12-04	1998-12-04 00:00:00	1998-12-04	38000177		0	0	21		0	0	0	263746	0	310965	19078461		
63549	1390	40213160	1966-09-08	1966-09-08 00:00:00	1966-09-08	1966-09-08 00:00:00	1966-09-08	581452		0	0	0		0	0	0	92293	0	10	40213160		
51294	4261	19133873	1928-08-10	1928-08-10 00:00:00	1928-08-17	1928-08-17 00:00:00	1928-08-17	38000177		0	0	7		0	0	0	282971	0	834061	19133873		
43772	3625	1127078	1960-01-14	1960-01-14 00:00:00	1960-02-04	1960-02-04 00:00:00	1960-02-04	38000177		0	0	21		0	0	0	241056	0	282464	1127078		
37676	822	40213227	1992-07-24	1992-07-24 00:00:00	1992-07-24	1992-07-24 00:00:00	1992-07-24	581452		0	0	0		0	0	0	54474	0	113	40213227		
57399	4761	19073183	1981-09-27	1981-09-27 00:00:00	1981-10-11	1981-10-11 00:00:00	1981-10-11	38000177		0	0	14		0	0	0	317290	0	308182	19073183		
180045	3957	40213296	1996-12-19	1996-12-19 00:00:00	1996-12-19	1996-12-19 00:00:00	1996-12-19	581452		0	0	0		0	0	0	263068	0	52	40213296		
51042	4240	19075601	2010-11-08	2010-11-08 00:00:00	2010-11-08	2010-11-08 00:00:00	\N	38000177		0	0	0		0	0	0	281660	0	309362	19075601		
51075	4241	1713671	1998-07-16	1998-07-16 00:00:00	1998-10-01	1998-10-01 00:00:00	1998-10-01	38000177		0	0	77		0	0	0	281757	0	562251	1713671		
79443	1738	40213227	2019-05-26	2019-05-26 00:00:00	2019-05-26	2019-05-26 00:00:00	2019-05-26	581452		0	0	0		0	0	0	116128	0	113	40213227		
26349	2168	1713671	1991-08-11	1991-08-11 00:00:00	1991-08-18	1991-08-18 00:00:00	1991-08-18	38000177		0	0	7		0	0	0	144540	0	562251	1713671		
119932	2636	40213260	2011-04-22	2011-04-22 00:00:00	2011-04-22	2011-04-22 00:00:00	2011-04-22	581452		0	0	0		0	0	0	174461	0	121	40213260		
45068	3730	40165015	2002-07-23	2002-07-23 00:00:00	2002-07-23	2002-07-23 00:00:00	\N	38000177		0	0	0		0	0	0	247808	0	861467	40165015		
11646	250	40213306	1998-02-04	1998-02-04 00:00:00	1998-02-04	1998-02-04 00:00:00	1998-02-04	581452		0	0	0		0	0	0	16790	0	43	40213306		
60660	1325	40213260	2014-11-23	2014-11-23 00:00:00	2014-11-23	2014-11-23 00:00:00	2014-11-23	581452		0	0	0		0	0	0	87934	0	121	40213260		
142413	3129	40213296	2013-05-28	2013-05-28 00:00:00	2013-05-28	2013-05-28 00:00:00	2013-05-28	581452		0	0	0		0	0	0	208286	0	52	40213296		
131440	2889	40213160	1960-11-27	1960-11-27 00:00:00	1960-11-27	1960-11-27 00:00:00	1960-11-27	581452		0	0	0		0	0	0	192179	0	10	40213160		
113988	2504	40213160	1958-10-06	1958-10-06 00:00:00	1958-10-06	1958-10-06 00:00:00	1958-10-06	581452		0	0	0		0	0	0	165833	0	10	40213160		
13647	295	40213227	2000-06-21	2000-06-21 00:00:00	2000-06-21	2000-06-21 00:00:00	2000-06-21	581452		0	0	0		0	0	0	19575	0	113	40213227		
28909	2389	1118084	2008-08-09	2008-08-09 00:00:00	2008-08-09	2008-08-09 00:00:00	\N	38000177		0	0	0		0	0	0	158847	0	00025152531	44923712		
211494	4637	40213160	1974-04-29	1974-04-29 00:00:00	1974-04-29	1974-04-29 00:00:00	1974-04-29	581452		0	0	0		0	0	0	309069	0	10	40213160		
115045	2528	40213160	1968-06-26	1968-06-26 00:00:00	1968-06-26	1968-06-26 00:00:00	1968-06-26	581452		0	0	0		0	0	0	167142	0	10	40213160		
34643	756	40213306	1988-05-04	1988-05-04 00:00:00	1988-05-04	1988-05-04 00:00:00	1988-05-04	581452		0	0	0		0	0	0	50152	0	43	40213306		
35958	2960	1127433	1996-02-10	1996-02-10 00:00:00	1996-03-02	1996-03-02 00:00:00	1996-03-02	38000177		0	0	21		0	0	0	197609	0	313782	1127433		
12996	1091	19128065	1976-05-03	1976-05-03 00:00:00	1977-04-28	1977-04-28 00:00:00	1977-04-28	38000177		0	0	360		0	0	0	71653	0	749882	19128065		
18537	1532	19059056	1986-04-14	1986-04-14 00:00:00	1986-07-13	1986-07-13 00:00:00	1986-07-13	38000177		0	0	90		0	0	0	102596	0	243670	19059056		
105641	2318	40213160	1963-10-05	1963-10-05 00:00:00	1963-10-05	1963-10-05 00:00:00	1963-10-05	581452		0	0	0		0	0	0	154105	0	10	40213160		
29071	2406	40229134	1965-10-05	1965-10-05 00:00:00	1965-10-19	1965-10-19 00:00:00	1965-10-19	38000177		0	0	14		0	0	0	159831	0	1043400	40229134		
183001	4021	40213260	2007-01-24	2007-01-24 00:00:00	2007-01-24	2007-01-24 00:00:00	2007-01-24	581452		0	0	0		0	0	0	267343	0	121	40213260		
234458	5151	40213260	2006-12-01	2006-12-01 00:00:00	2006-12-01	2006-12-01 00:00:00	2006-12-01	581452		0	0	0		0	0	0	342573	0	121	40213260		
56131	4660	1118084	1998-08-12	1998-08-12 00:00:00	1998-08-12	1998-08-12 00:00:00	\N	38000177		0	0	0		0	0	0	310653	0	00025152531	44923712		
2053	162	920300	1976-12-13	1976-12-13 00:00:00	1976-12-20	1976-12-20 00:00:00	1976-12-20	38000177		0	0	7		0	0	0	11095	0	311989	920300		
34293	2833	19059056	1975-12-13	1975-12-13 00:00:00	1976-01-10	1976-01-10 00:00:00	1976-01-10	38000177		0	0	28		0	0	0	188074	0	243670	19059056		
82975	1813	40213160	1981-11-28	1981-11-28 00:00:00	1981-11-28	1981-11-28 00:00:00	1981-11-28	581452		0	0	0		0	0	0	121331	0	10	40213160		
50316	4176	1127433	2010-07-03	2010-07-03 00:00:00	2010-07-17	2010-07-17 00:00:00	2010-07-17	38000177		0	0	14		0	0	0	277546	0	313782	1127433		
129278	2843	40213227	1993-04-08	1993-04-08 00:00:00	1993-04-08	1993-04-08 00:00:00	1993-04-08	581452		0	0	0		0	0	0	188751	0	113	40213227		
25799	563	40213227	1995-06-25	1995-06-25 00:00:00	1995-06-25	1995-06-25 00:00:00	1995-06-25	581452		0	0	0		0	0	0	37236	0	113	40213227		
167871	3691	40213160	1959-07-24	1959-07-24 00:00:00	1959-07-24	1959-07-24 00:00:00	1959-07-24	581452		0	0	0		0	0	0	245310	0	10	40213160		
16130	1338	19133873	1946-10-25	1946-10-25 00:00:00	1946-11-06	1946-11-06 00:00:00	1946-11-06	38000177		0	0	12		0	0	0	88682	0	834061	19133873		
200729	4408	40213160	1981-10-01	1981-10-01 00:00:00	1981-10-01	1981-10-01 00:00:00	1981-10-01	581452		0	0	0		0	0	0	293005	0	10	40213160		
99746	2185	40213201	2006-11-01	2006-11-01 00:00:00	2006-11-01	2006-11-01 00:00:00	2006-11-01	581452		0	0	0		0	0	0	145716	0	33	40213201		
46715	1021	40213198	2018-03-08	2018-03-08 00:00:00	2018-03-08	2018-03-08 00:00:00	2018-03-08	581452		0	0	0		0	0	0	67188	0	133	40213198		
159869	3518	40213296	2000-06-12	2000-06-12 00:00:00	2000-06-12	2000-06-12 00:00:00	2000-06-12	581452		0	0	0		0	0	0	233608	0	52	40213296		
26827	2210	40229134	1951-01-21	1951-01-21 00:00:00	1951-02-04	1951-02-04 00:00:00	1951-02-04	38000177		0	0	14		0	0	0	147236	0	1043400	40229134		
232119	5101	40213260	2008-02-02	2008-02-02 00:00:00	2008-02-02	2008-02-02 00:00:00	2008-02-02	581452		0	0	0		0	0	0	339010	0	121	40213260		
52042	4328	40236824	1998-07-12	1998-07-12 00:00:00	1998-07-19	1998-07-19 00:00:00	1998-07-19	38000177		0	0	7		0	0	0	287067	0	1094107	40236824		
93872	2060	40213227	2014-12-10	2014-12-10 00:00:00	2014-12-10	2014-12-10 00:00:00	2014-12-10	581452		0	0	0		0	0	0	137025	0	113	40213227		
18681	1542	19133905	1984-10-16	1984-10-16 00:00:00	1984-10-29	1984-10-29 00:00:00	1984-10-29	38000177		0	0	13		0	0	0	103308	0	834102	19133905		
101140	2217	40213227	2001-01-12	2001-01-12 00:00:00	2001-01-12	2001-01-12 00:00:00	2001-01-12	581452		0	0	0		0	0	0	\N	0	113	40213227		
101167	2217	40213314	1979-12-07	1979-12-07 00:00:00	1979-12-07	1979-12-07 00:00:00	1979-12-07	581452		0	0	0		0	0	0	147675	0	49	40213314		
4231	350	1713671	2006-06-06	2006-06-06 00:00:00	2006-06-27	2006-06-27 00:00:00	2006-06-27	38000177		0	0	21		0	0	0	23302	0	562251	1713671		
10004	213	40213160	1972-04-10	1972-04-10 00:00:00	1972-04-10	1972-04-10 00:00:00	1972-04-10	581452		0	0	0		0	0	0	14537	0	10	40213160		
164840	3624	40213227	2008-05-08	2008-05-08 00:00:00	2008-05-08	2008-05-08 00:00:00	2008-05-08	581452		0	0	0		0	0	0	241032	0	113	40213227		
43860	3631	19078461	2006-04-19	2006-04-19 00:00:00	2006-05-03	2006-05-03 00:00:00	2006-05-03	38000177		0	0	14		0	0	0	241582	0	310965	19078461		
43913	3638	1713671	1997-11-12	1997-11-12 00:00:00	1997-11-19	1997-11-19 00:00:00	1997-11-19	38000177		0	0	7		0	0	0	241957	0	562251	1713671		
86913	1905	40213260	2017-01-20	2017-01-20 00:00:00	2017-01-20	2017-01-20 00:00:00	2017-01-20	581452		0	0	0		0	0	0	126829	0	121	40213260		
155427	3420	40213260	2014-09-30	2014-09-30 00:00:00	2014-09-30	2014-09-30 00:00:00	2014-09-30	581452		0	0	0		0	0	0	226907	0	121	40213260		
239878	5265	40213227	2009-09-03	2009-09-03 00:00:00	2009-09-03	2009-09-03 00:00:00	2009-09-03	581452		0	0	0		0	0	0	350311	0	113	40213227		
40669	886	40213314	1983-07-12	1983-07-12 00:00:00	1983-07-12	1983-07-12 00:00:00	1983-07-12	581452		0	0	0		0	0	0	59089	0	49	40213314		
12827	1079	1118084	1993-11-26	1993-11-26 00:00:00	1993-11-26	1993-11-26 00:00:00	\N	38000177		0	0	0		0	0	0	70781	0	00025152531	44923712		
142729	3135	40213160	1963-11-14	1963-11-14 00:00:00	1963-11-14	1963-11-14 00:00:00	1963-11-14	581452		0	0	0		0	0	0	208689	0	10	40213160		
64351	1408	40213198	2010-02-22	2010-02-22 00:00:00	2010-02-22	2010-02-22 00:00:00	2010-02-22	581452		0	0	0		0	0	0	93679	0	133	40213198		
40651	3371	19019979	1977-10-17	1977-10-17 00:00:00	1977-10-31	1977-10-31 00:00:00	1977-10-31	38000177		0	0	14		0	0	0	223634	0	198405	19019979		
175794	3865	40213260	2007-07-05	2007-07-05 00:00:00	2007-07-05	2007-07-05 00:00:00	2007-07-05	581452		0	0	0		0	0	0	256538	0	121	40213260		
47843	3967	1127433	1980-01-18	1980-01-18 00:00:00	1980-01-25	1980-01-25 00:00:00	1980-01-25	38000177		0	0	7		0	0	0	263764	0	313782	1127433		
63558	1390	40213227	2008-01-10	2008-01-10 00:00:00	2008-01-10	2008-01-10 00:00:00	2008-01-10	581452		0	0	0		0	0	0	92283	0	113	40213227		
233139	5123	40213160	1980-02-04	1980-02-04 00:00:00	1980-02-04	1980-02-04 00:00:00	1980-02-04	581452		0	0	0		0	0	0	340648	0	10	40213160		
43773	3626	19128022	1993-02-21	1993-02-21 00:00:00	1994-02-16	1994-02-16 00:00:00	1994-02-16	38000177		0	0	360		0	0	0	241152	0	749785	19128022		
37677	822	40213306	1992-07-24	1992-07-24 00:00:00	1992-07-24	1992-07-24 00:00:00	1992-07-24	581452		0	0	0		0	0	0	54474	0	43	40213306		
57400	4761	1127433	1986-08-03	1986-08-03 00:00:00	1986-08-17	1986-08-17 00:00:00	1986-08-17	38000177		0	0	14		0	0	0	317258	0	313782	1127433		
180047	3957	40213160	1955-12-29	1955-12-29 00:00:00	1955-12-29	1955-12-29 00:00:00	1955-12-29	581452		0	0	0		0	0	0	263052	0	10	40213160		
51043	4240	1539411	2010-11-08	2010-11-08 00:00:00	2010-11-08	2010-11-08 00:00:00	\N	38000177		0	0	0		0	0	0	281660	0	312961	1539411		
51077	4241	1127433	1996-02-07	1996-02-07 00:00:00	1996-02-21	1996-02-21 00:00:00	1996-02-21	38000177		0	0	14		0	0	0	281754	0	313782	1127433		
79448	1738	40213296	2008-05-25	2008-05-25 00:00:00	2008-05-25	2008-05-25 00:00:00	2008-05-25	581452		0	0	0		0	0	0	116112	0	52	40213296		
26350	2168	1118084	1989-10-25	1989-10-25 00:00:00	1989-10-25	1989-10-25 00:00:00	\N	38000177		0	0	0		0	0	0	144427	0	00025152531	44923712		
119942	2636	40213160	1960-12-23	1960-12-23 00:00:00	1960-12-23	1960-12-23 00:00:00	1960-12-23	581452		0	0	0		0	0	0	174436	0	10	40213160		
45069	3730	1115171	2002-07-23	2002-07-23 00:00:00	2002-10-21	2002-10-21 00:00:00	2002-10-21	38000177		0	0	90		0	0	0	247808	0	849574	1115171		
11650	250	40213227	1998-02-04	1998-02-04 00:00:00	1998-02-04	1998-02-04 00:00:00	1998-02-04	581452		0	0	0		0	0	0	16790	0	113	40213227		
60662	1325	40213227	2006-04-23	2006-04-23 00:00:00	2006-04-23	2006-04-23 00:00:00	2006-04-23	581452		0	0	0		0	0	0	87932	0	113	40213227		
142418	3129	40213296	2011-05-24	2011-05-24 00:00:00	2011-05-24	2011-05-24 00:00:00	2011-05-24	581452		0	0	0		0	0	0	208267	0	52	40213296		
131445	2889	40213296	2000-03-26	2000-03-26 00:00:00	2000-03-26	2000-03-26 00:00:00	2000-03-26	581452		0	0	0		0	0	0	192136	0	52	40213296		
113993	2504	40213227	2015-06-22	2015-06-22 00:00:00	2015-06-22	2015-06-22 00:00:00	2015-06-22	581452		0	0	0		0	0	0	165779	0	113	40213227		
13654	295	40213160	1955-06-01	1955-06-01 00:00:00	1955-06-01	1955-06-01 00:00:00	1955-06-01	581452		0	0	0		0	0	0	19607	0	10	40213160		
28910	2389	40229134	1990-11-08	1990-11-08 00:00:00	1990-11-22	1990-11-22 00:00:00	1990-11-22	38000177		0	0	14		0	0	0	158837	0	1043400	40229134		
211501	4637	40213160	1979-01-01	1979-01-01 00:00:00	1979-01-01	1979-01-01 00:00:00	1979-01-01	581452		0	0	0		0	0	0	309062	0	10	40213160		
115047	2528	40213260	2018-03-21	2018-03-21 00:00:00	2018-03-21	2018-03-21 00:00:00	2018-03-21	581452		0	0	0		0	0	0	167137	0	121	40213260		
34646	756	40213227	2017-02-15	2017-02-15 00:00:00	2017-02-15	2017-02-15 00:00:00	2017-02-15	581452		0	0	0		0	0	0	50169	0	113	40213227		
35959	2960	19133873	1969-05-06	1969-05-06 00:00:00	1969-05-13	1969-05-13 00:00:00	1969-05-13	38000177		0	0	7		0	0	0	197612	0	834061	19133873		
12997	1091	1713671	2016-09-15	2016-09-15 00:00:00	2016-09-29	2016-09-29 00:00:00	2016-09-29	38000177		0	0	14		0	0	0	71649	0	562251	1713671		
18538	1532	40229134	2010-04-06	2010-04-06 00:00:00	2010-04-20	2010-04-20 00:00:00	2010-04-20	38000177		0	0	14		0	0	0	102635	0	1043400	40229134		
105644	2318	40213227	1994-10-08	1994-10-08 00:00:00	1994-10-08	1994-10-08 00:00:00	1994-10-08	581452		0	0	0		0	0	0	154075	0	113	40213227		
29072	2406	1127433	1981-01-30	1981-01-30 00:00:00	1981-02-13	1981-02-13 00:00:00	1981-02-13	38000177		0	0	14		0	0	0	159842	0	313782	1127433		
183004	4021	40213227	1997-01-22	1997-01-22 00:00:00	1997-01-22	1997-01-22 00:00:00	1997-01-22	581452		0	0	0		0	0	0	267364	0	113	40213227		
234464	5151	40213160	1957-07-12	1957-07-12 00:00:00	1957-07-12	1957-07-12 00:00:00	1957-07-12	581452		0	0	0		0	0	0	342539	0	10	40213160		
56132	4660	1127433	1989-01-02	1989-01-02 00:00:00	1989-01-16	1989-01-16 00:00:00	1989-01-16	38000177		0	0	14		0	0	0	310608	0	313782	1127433		
2054	162	40173590	2009-10-20	2009-10-20 00:00:00	2009-10-20	2009-10-20 00:00:00	\N	38000177		0	0	0		0	0	0	11146	0	904419	40173590		
34294	2833	1118084	1977-05-21	1977-05-21 00:00:00	1977-05-21	1977-05-21 00:00:00	\N	38000177		0	0	0		0	0	0	188074	0	00025152531	44923712		
82978	1813	40213227	2003-12-20	2003-12-20 00:00:00	2003-12-20	2003-12-20 00:00:00	2003-12-20	581452		0	0	0		0	0	0	121338	0	113	40213227		
50317	4176	19059056	1942-12-08	1942-12-08 00:00:00	1943-01-05	1943-01-05 00:00:00	1943-01-05	38000177		0	0	28		0	0	0	277543	0	243670	19059056		
129284	2843	40213160	1959-01-15	1959-01-15 00:00:00	1959-01-15	1959-01-15 00:00:00	1959-01-15	581452		0	0	0		0	0	0	188768	0	10	40213160		
25800	563	40213160	1964-09-20	1964-09-20 00:00:00	1964-09-20	1964-09-20 00:00:00	1964-09-20	581452		0	0	0		0	0	0	37211	0	10	40213160		
167878	3691	40213260	2006-09-29	2006-09-29 00:00:00	2006-09-29	2006-09-29 00:00:00	2006-09-29	581452		0	0	0		0	0	0	245294	0	121	40213260		
16131	1338	19006318	1948-04-08	1948-04-08 00:00:00	1948-04-22	1948-04-22 00:00:00	1948-04-22	38000177		0	0	14		0	0	0	88701	0	105078	19006318		
200734	4408	40213160	1981-04-30	1981-04-30 00:00:00	1981-04-30	1981-04-30 00:00:00	1981-04-30	581452		0	0	0		0	0	0	293031	0	10	40213160		
99764	2185	40213227	2011-11-30	2011-11-30 00:00:00	2011-11-30	2011-11-30 00:00:00	2011-11-30	581452		0	0	0		0	0	0	145631	0	113	40213227		
46718	1021	40213296	1996-12-26	1996-12-26 00:00:00	1996-12-26	1996-12-26 00:00:00	1996-12-26	581452		0	0	0		0	0	0	67146	0	52	40213296		
159872	3518	40213260	2008-03-31	2008-03-31 00:00:00	2008-03-31	2008-03-31 00:00:00	2008-03-31	581452		0	0	0		0	0	0	233564	0	121	40213260		
26828	2210	19133905	1978-12-26	1978-12-26 00:00:00	1979-01-06	1979-01-06 00:00:00	1979-01-06	38000177		0	0	11		0	0	0	147265	0	834102	19133905		
232120	5101	40213160	1957-06-08	1957-06-08 00:00:00	1957-06-08	1957-06-08 00:00:00	1957-06-08	581452		0	0	0		0	0	0	338980	0	10	40213160		
52043	4328	19078461	1995-06-22	1995-06-22 00:00:00	1995-09-20	1995-09-20 00:00:00	1995-09-20	38000177		0	0	90		0	0	0	287016	0	310965	19078461		
93873	2060	40213260	2014-12-10	2014-12-10 00:00:00	2014-12-10	2014-12-10 00:00:00	2014-12-10	581452		0	0	0		0	0	0	137025	0	121	40213260		
18682	1542	19059056	1966-06-22	1966-06-22 00:00:00	1966-07-06	1966-07-06 00:00:00	1966-07-06	38000177		0	0	14		0	0	0	103310	0	243670	19059056		
101141	2217	40213306	2001-01-12	2001-01-12 00:00:00	2001-01-12	2001-01-12 00:00:00	2001-01-12	581452		0	0	0		0	0	0	\N	0	43	40213306		
101173	2217	40213160	1983-08-19	1983-08-19 00:00:00	1983-08-19	1983-08-19 00:00:00	1983-08-19	581452		0	0	0		0	0	0	147642	0	10	40213160		
4233	350	920334	1982-10-28	1982-10-28 00:00:00	1982-11-04	1982-11-04 00:00:00	1982-11-04	38000177		0	0	7		0	0	0	23330	0	311995	920334		
188956	4149	40213160	1970-11-27	1970-11-27 00:00:00	1970-11-27	1970-11-27 00:00:00	1970-11-27	581452		0	0	0		0	0	0	275718	0	10	40213160		
164846	3624	40213198	2012-05-31	2012-05-31 00:00:00	2012-05-31	2012-05-31 00:00:00	2012-05-31	581452		0	0	0		0	0	0	240969	0	133	40213198		
43863	3633	1713671	2001-01-13	2001-01-13 00:00:00	2001-01-20	2001-01-20 00:00:00	2001-01-20	38000177		0	0	7		0	0	0	241683	0	562251	1713671		
43914	3638	40229134	2013-02-19	2013-02-19 00:00:00	2013-03-05	2013-03-05 00:00:00	2013-03-05	38000177		0	0	14		0	0	0	241946	0	1043400	40229134		
86920	1906	40213227	2011-11-19	2011-11-19 00:00:00	2011-11-19	2011-11-19 00:00:00	2011-11-19	581452		0	0	0		0	0	0	126894	0	113	40213227		
155431	3420	40213160	1965-03-09	1965-03-09 00:00:00	1965-03-09	1965-03-09 00:00:00	1965-03-09	581452		0	0	0		0	0	0	226879	0	10	40213160		
239879	5265	40213296	2009-09-03	2009-09-03 00:00:00	2009-09-03	2009-09-03 00:00:00	2009-09-03	581452		0	0	0		0	0	0	350311	0	52	40213296		
40670	886	40213160	1983-07-12	1983-07-12 00:00:00	1983-07-12	1983-07-12 00:00:00	1983-07-12	581452		0	0	0		0	0	0	59089	0	10	40213160		
12829	1079	920334	2010-04-11	2010-04-11 00:00:00	2010-04-18	2010-04-18 00:00:00	2010-04-18	38000177		0	0	7		0	0	0	70732	0	311995	920334		
142735	3135	40213296	2003-06-12	2003-06-12 00:00:00	2003-06-12	2003-06-12 00:00:00	2003-06-12	581452		0	0	0		0	0	0	208674	0	52	40213296		
64370	1408	40213227	1994-11-21	1994-11-21 00:00:00	1994-11-21	1994-11-21 00:00:00	1994-11-21	581452		0	0	0		0	0	0	93645	0	113	40213227		
40652	3371	40232448	1976-03-23	1976-03-23 00:00:00	1976-03-23	1976-03-23 00:00:00	\N	38000177		0	0	0		0	0	0	223598	0	1049630	40232448		
175796	3865	40213160	1957-03-07	1957-03-07 00:00:00	1957-03-07	1957-03-07 00:00:00	1957-03-07	581452		0	0	0		0	0	0	256620	0	10	40213160		
47844	3967	19128065	1979-04-02	1979-04-02 00:00:00	1980-03-27	1980-03-27 00:00:00	1980-03-27	38000177		0	0	360		0	0	0	263778	0	749882	19128065		
63559	1390	40213296	2008-01-10	2008-01-10 00:00:00	2008-01-10	2008-01-10 00:00:00	2008-01-10	581452		0	0	0		0	0	0	92283	0	52	40213296		
233142	5123	40213227	2001-06-25	2001-06-25 00:00:00	2001-06-25	2001-06-25 00:00:00	2001-06-25	581452		0	0	0		0	0	0	340673	0	113	40213227		
43774	3626	1127433	1988-08-06	1988-08-06 00:00:00	1988-08-27	1988-08-27 00:00:00	1988-08-27	38000177		0	0	21		0	0	0	241124	0	313782	1127433		
117631	2586	40213160	1968-10-06	1968-10-06 00:00:00	1968-10-06	1968-10-06 00:00:00	1968-10-06	581452		0	0	0		0	0	0	171178	0	10	40213160		
57401	4761	1118084	2018-12-12	2018-12-12 00:00:00	2018-12-12	2018-12-12 00:00:00	\N	38000177		0	0	0		0	0	0	317322	0	00025152531	44923712		
180049	3957	40213227	2007-09-13	2007-09-13 00:00:00	2007-09-13	2007-09-13 00:00:00	2007-09-13	581452		0	0	0		0	0	0	263104	0	113	40213227		
51044	4240	1332419	2010-11-08	2010-11-08 00:00:00	2010-11-08	2010-11-08 00:00:00	\N	38000177		0	0	0		0	0	0	281660	0	197361	1332419		
51078	4241	1713671	1986-01-10	1986-01-10 00:00:00	1986-01-24	1986-01-24 00:00:00	1986-01-24	38000177		0	0	14		0	0	0	281729	0	562251	1713671		
79456	1739	40213160	1973-03-22	1973-03-22 00:00:00	1973-03-22	1973-03-22 00:00:00	1973-03-22	581452		0	0	0		0	0	0	116187	0	10	40213160		
26351	2168	19059056	1964-11-10	1964-11-10 00:00:00	1964-12-15	1964-12-15 00:00:00	1964-12-15	38000177		0	0	35		0	0	0	144578	0	243670	19059056		
119944	2636	40213160	1960-09-23	1960-09-23 00:00:00	1960-09-23	1960-09-23 00:00:00	1960-09-23	581452		0	0	0		0	0	0	174473	0	10	40213160		
45070	3730	40243436	1994-07-28	1994-07-28 00:00:00	1994-07-28	1994-07-28 00:00:00	1994-07-28	38000177		0	0	0		0	0	0	247807	0	1190795	40243436		
11652	250	40213227	2005-08-31	2005-08-31 00:00:00	2005-08-31	2005-08-31 00:00:00	2005-08-31	581452		0	0	0		0	0	0	16800	0	113	40213227		
60663	1325	40213296	2006-04-23	2006-04-23 00:00:00	2006-04-23	2006-04-23 00:00:00	2006-04-23	581452		0	0	0		0	0	0	87932	0	52	40213296		
142421	3129	40213160	1971-08-24	1971-08-24 00:00:00	1971-08-24	1971-08-24 00:00:00	1971-08-24	581452		0	0	0		0	0	0	208292	0	10	40213160		
131447	2889	40213260	2010-10-10	2010-10-10 00:00:00	2010-10-10	2010-10-10 00:00:00	2010-10-10	581452		0	0	0		0	0	0	192139	0	121	40213260		
113995	2504	40213260	2006-05-01	2006-05-01 00:00:00	2006-05-01	2006-05-01 00:00:00	2006-05-01	581452		0	0	0		0	0	0	165797	0	121	40213260		
172629	3795	40213296	2014-10-21	2014-10-21 00:00:00	2014-10-21	2014-10-21 00:00:00	2014-10-21	581452		0	0	0		0	0	0	252324	0	52	40213296		
28911	2389	19078461	1992-02-21	1992-02-21 00:00:00	1992-03-06	1992-03-06 00:00:00	1992-03-06	38000177		0	0	14		0	0	0	158842	0	310965	19078461		
211503	4637	40213296	2016-06-20	2016-06-20 00:00:00	2016-06-20	2016-06-20 00:00:00	2016-06-20	581452		0	0	0		0	0	0	309054	0	52	40213296		
115056	2528	40213227	2001-01-10	2001-01-10 00:00:00	2001-01-10	2001-01-10 00:00:00	2001-01-10	581452		0	0	0		0	0	0	167152	0	113	40213227		
34647	756	40213260	2017-02-15	2017-02-15 00:00:00	2017-02-15	2017-02-15 00:00:00	2017-02-15	581452		0	0	0		0	0	0	50169	0	121	40213260		
35962	2960	1127433	1958-10-16	1958-10-16 00:00:00	1958-10-23	1958-10-23 00:00:00	1958-10-23	38000177		0	0	7		0	0	0	197662	0	313782	1127433		
12998	1092	1127433	1960-03-11	1960-03-11 00:00:00	1960-03-25	1960-03-25 00:00:00	1960-03-25	38000177		0	0	14		0	0	0	71783	0	313782	1127433		
18539	1532	1127433	2014-05-04	2014-05-04 00:00:00	2014-05-18	2014-05-18 00:00:00	2014-05-18	38000177		0	0	14		0	0	0	102610	0	313782	1127433		
105646	2318	40213160	1963-07-06	1963-07-06 00:00:00	1963-07-06	1963-07-06 00:00:00	1963-07-06	581452		0	0	0		0	0	0	154062	0	10	40213160		
29073	2406	1127433	1958-01-20	1958-01-20 00:00:00	1958-02-17	1958-02-17 00:00:00	1958-02-17	38000177		0	0	28		0	0	0	159827	0	313782	1127433		
183005	4021	40213296	1997-01-22	1997-01-22 00:00:00	1997-01-22	1997-01-22 00:00:00	1997-01-22	581452		0	0	0		0	0	0	267364	0	52	40213296		
234467	5151	40213227	2018-02-02	2018-02-02 00:00:00	2018-02-02	2018-02-02 00:00:00	2018-02-02	581452		0	0	0		0	0	0	342561	0	113	40213227		
56133	4660	1713671	1964-03-24	1964-03-24 00:00:00	1964-04-07	1964-04-07 00:00:00	1964-04-07	38000177		0	0	14		0	0	0	310662	0	562251	1713671		
2055	162	1713671	1957-10-20	1957-10-20 00:00:00	1957-11-10	1957-11-10 00:00:00	1957-11-10	38000177		0	0	21		0	0	0	11160	0	562251	1713671		
34295	2834	1127433	1985-01-12	1985-01-12 00:00:00	1985-02-02	1985-02-02 00:00:00	1985-02-02	38000177		0	0	21		0	0	0	188164	0	313782	1127433		
82979	1813	40213306	2003-12-20	2003-12-20 00:00:00	2003-12-20	2003-12-20 00:00:00	2003-12-20	581452		0	0	0		0	0	0	121338	0	43	40213306		
50318	4176	19059056	1918-10-01	1918-10-01 00:00:00	1918-10-15	1918-10-15 00:00:00	1918-10-15	38000177		0	0	14		0	0	0	277501	0	243670	19059056		
129294	2843	40213160	1962-12-27	1962-12-27 00:00:00	1962-12-27	1962-12-27 00:00:00	1962-12-27	581452		0	0	0		0	0	0	188720	0	10	40213160		
25802	563	40213306	1986-06-15	1986-06-15 00:00:00	1986-06-15	1986-06-15 00:00:00	1986-06-15	581452		0	0	0		0	0	0	37243	0	43	40213306		
167888	3691	40213160	1955-07-22	1955-07-22 00:00:00	1955-07-22	1955-07-22 00:00:00	1955-07-22	581452		0	0	0		0	0	0	245366	0	10	40213160		
16132	1338	19059056	1948-04-08	1948-04-08 00:00:00	1948-04-22	1948-04-22 00:00:00	1948-04-22	38000177		0	0	14		0	0	0	88701	0	243670	19059056		
200735	4408	40213314	1981-04-30	1981-04-30 00:00:00	1981-04-30	1981-04-30 00:00:00	1981-04-30	581452		0	0	0		0	0	0	293031	0	49	40213314		
51659	1131	40213160	1966-01-19	1966-01-19 00:00:00	1966-01-19	1966-01-19 00:00:00	1966-01-19	581452		0	0	0		0	0	0	74428	0	10	40213160		
175356	3856	40213227	2005-08-31	2005-08-31 00:00:00	2005-08-31	2005-08-31 00:00:00	2005-08-31	581452		0	0	0		0	0	0	255932	0	113	40213227		
159874	3518	40213306	1981-01-26	1981-01-26 00:00:00	1981-01-26	1981-01-26 00:00:00	1981-01-26	581452		0	0	0		0	0	0	233605	0	43	40213306		
26829	2210	40229134	2016-05-10	2016-05-10 00:00:00	2016-05-24	2016-05-24 00:00:00	2016-05-24	38000177		0	0	14		0	0	0	147219	0	1043400	40229134		
232123	5101	40213227	2008-02-02	2008-02-02 00:00:00	2008-02-02	2008-02-02 00:00:00	2008-02-02	581452		0	0	0		0	0	0	339010	0	113	40213227		
52044	4328	1127078	1976-02-02	1976-02-02 00:00:00	1976-02-16	1976-02-16 00:00:00	1976-02-16	38000177		0	0	14		0	0	0	287038	0	282464	1127078		
93884	2060	40213227	1997-01-29	1997-01-29 00:00:00	1997-01-29	1997-01-29 00:00:00	1997-01-29	581452		0	0	0		0	0	0	137051	0	113	40213227		
18683	1542	19006318	1966-06-22	1966-06-22 00:00:00	1966-07-06	1966-07-06 00:00:00	1966-07-06	38000177		0	0	14		0	0	0	103310	0	105078	19006318		
101147	2217	40213314	1979-10-05	1979-10-05 00:00:00	1979-10-05	1979-10-05 00:00:00	1979-10-05	581452		0	0	0		0	0	0	147632	0	49	40213314		
101181	2218	40213227	2011-06-21	2011-06-21 00:00:00	2011-06-21	2011-06-21 00:00:00	2011-06-21	581452		0	0	0		0	0	0	147718	0	113	40213227		
4234	350	1539411	1991-11-08	1991-11-08 00:00:00	1991-11-08	1991-11-08 00:00:00	\N	38000177		0	0	0		0	0	0	23322	0	312961	1539411		
188962	4149	40213227	2007-06-22	2007-06-22 00:00:00	2007-06-22	2007-06-22 00:00:00	2007-06-22	581452		0	0	0		0	0	0	275758	0	113	40213227		
164850	3624	40213201	2013-06-06	2013-06-06 00:00:00	2013-06-06	2013-06-06 00:00:00	2013-06-06	581452		0	0	0		0	0	0	240952	0	33	40213201		
43864	3633	1124300	2017-05-02	2017-05-02 00:00:00	2017-05-02	2017-05-02 00:00:00	\N	38000177		0	0	0		0	0	0	241648	0	00781178901	45011828		
43915	3638	19078461	1976-04-23	1976-04-23 00:00:00	1976-05-07	1976-05-07 00:00:00	1976-05-07	38000177		0	0	14		0	0	0	241966	0	310965	19078461		
86921	1906	40213260	2011-11-19	2011-11-19 00:00:00	2011-11-19	2011-11-19 00:00:00	2011-11-19	581452		0	0	0		0	0	0	126894	0	121	40213260		
185925	4085	40213306	1981-07-18	1981-07-18 00:00:00	1981-07-18	1981-07-18 00:00:00	1981-07-18	581452		0	0	0		0	0	0	271449	0	43	40213306		
239881	5265	40213227	1999-05-06	1999-05-06 00:00:00	1999-05-06	1999-05-06 00:00:00	1999-05-06	581452		0	0	0		0	0	0	350308	0	113	40213227		
40674	886	40213160	1983-09-13	1983-09-13 00:00:00	1983-09-13	1983-09-13 00:00:00	1983-09-13	581452		0	0	0		0	0	0	59083	0	10	40213160		
12830	1079	19078461	2002-04-02	2002-04-02 00:00:00	2002-04-23	2002-04-23 00:00:00	2002-04-23	38000177		0	0	21		0	0	0	70771	0	310965	19078461		
142736	3135	40213160	1968-05-16	1968-05-16 00:00:00	1968-05-16	1968-05-16 00:00:00	1968-05-16	581452		0	0	0		0	0	0	208692	0	10	40213160		
157093	3457	40213227	1998-07-03	1998-07-03 00:00:00	1998-07-03	1998-07-03 00:00:00	1998-07-03	581452		0	0	0		0	0	0	229390	0	113	40213227		
40653	3371	19128065	1995-07-11	1995-07-11 00:00:00	1996-07-05	1996-07-05 00:00:00	1996-07-05	38000177		0	0	360		0	0	0	223638	0	749882	19128065		
175807	3865	40213296	1999-05-27	1999-05-27 00:00:00	1999-05-27	1999-05-27 00:00:00	1999-05-27	581452		0	0	0		0	0	0	256571	0	52	40213296		
47845	3967	1118084	2003-12-07	2003-12-07 00:00:00	2003-12-07	2003-12-07 00:00:00	\N	38000177		0	0	0		0	0	0	263747	0	00025152531	44923712		
23543	1937	1127433	1977-07-13	1977-07-13 00:00:00	1977-09-18	1977-09-18 00:00:00	1977-09-18	38000177		0	0	67		0	0	0	128905	0	313782	1127433		
233143	5123	40213306	2001-06-25	2001-06-25 00:00:00	2001-06-25	2001-06-25 00:00:00	2001-06-25	581452		0	0	0		0	0	0	340673	0	43	40213306		
43775	3626	1127078	1979-03-18	1979-03-18 00:00:00	1979-04-01	1979-04-01 00:00:00	1979-04-01	38000177		0	0	14		0	0	0	241133	0	282464	1127078		
117632	2586	40213296	2009-08-16	2009-08-16 00:00:00	2009-08-16	2009-08-16 00:00:00	2009-08-16	581452		0	0	0		0	0	0	171220	0	52	40213296		
57402	4761	19133873	1989-03-23	1989-03-23 00:00:00	1989-04-03	1989-04-03 00:00:00	1989-04-03	38000177		0	0	11		0	0	0	317213	0	834061	19133873		
180051	3957	40213260	2006-08-31	2006-08-31 00:00:00	2006-08-31	2006-08-31 00:00:00	2006-08-31	581452		0	0	0		0	0	0	\N	0	121	40213260		
51045	4240	1127433	1964-07-23	1964-07-23 00:00:00	1964-08-06	1964-08-06 00:00:00	1964-08-06	38000177		0	0	14		0	0	0	281689	0	313782	1127433		
51079	4241	1713671	1986-08-30	1986-08-30 00:00:00	1986-09-20	1986-09-20 00:00:00	1986-09-20	38000177		0	0	21		0	0	0	281738	0	562251	1713671		
79458	1739	40213160	1968-07-18	1968-07-18 00:00:00	1968-07-18	1968-07-18 00:00:00	1968-07-18	581452		0	0	0		0	0	0	116203	0	10	40213160		
26352	2168	19059056	1962-06-14	1962-06-14 00:00:00	1962-06-28	1962-06-28 00:00:00	1962-06-28	38000177		0	0	14		0	0	0	144441	0	243670	19059056		
119948	2636	40213160	1960-07-22	1960-07-22 00:00:00	1960-07-22	1960-07-22 00:00:00	1960-07-22	581452		0	0	0		0	0	0	174435	0	10	40213160		
45071	3730	46275916	1994-07-28	1994-07-28 00:00:00	1994-07-28	1994-07-28 00:00:00	1994-07-28	38000177		0	0	0		0	0	0	247807	0	1660014	46275916		
11657	250	40213160	1979-01-24	1979-01-24 00:00:00	1979-01-24	1979-01-24 00:00:00	1979-01-24	581452		0	0	0		0	0	0	16831	0	10	40213160		
60671	1325	40213227	2015-11-29	2015-11-29 00:00:00	2015-11-29	2015-11-29 00:00:00	2015-11-29	581452		0	0	0		0	0	0	87949	0	113	40213227		
142425	3129	40213227	2004-11-23	2004-11-23 00:00:00	2004-11-23	2004-11-23 00:00:00	2004-11-23	581452		0	0	0		0	0	0	208245	0	113	40213227		
131452	2889	40213227	2002-03-31	2002-03-31 00:00:00	2002-03-31	2002-03-31 00:00:00	2002-03-31	581452		0	0	0		0	0	0	192162	0	113	40213227		
214380	4701	40213160	1971-05-07	1971-05-07 00:00:00	1971-05-07	1971-05-07 00:00:00	1971-05-07	581452		0	0	0		0	0	0	313141	0	10	40213160		
172631	3795	40213227	2014-10-21	2014-10-21 00:00:00	2014-10-21	2014-10-21 00:00:00	2014-10-21	581452		0	0	0		0	0	0	252324	0	113	40213227		
28913	2389	19133873	1979-06-10	1979-06-10 00:00:00	1979-06-22	1979-06-22 00:00:00	1979-06-22	38000177		0	0	12		0	0	0	158834	0	834061	19133873		
211505	4637	40213227	2016-06-20	2016-06-20 00:00:00	2016-06-20	2016-06-20 00:00:00	2016-06-20	581452		0	0	0		0	0	0	309054	0	113	40213227		
115058	2528	40213160	1968-11-27	1968-11-27 00:00:00	1968-11-27	1968-11-27 00:00:00	1968-11-27	581452		0	0	0		0	0	0	167143	0	10	40213160		
34652	756	40213227	1997-05-14	1997-05-14 00:00:00	1997-05-14	1997-05-14 00:00:00	1997-05-14	581452		0	0	0		0	0	0	50166	0	113	40213227		
57487	4771	40231925	1984-08-05	1984-08-05 00:00:00	1984-08-05	1984-08-05 00:00:00	\N	38000177		0	0	0		0	0	0	317773	0	1049221	40231925		
12999	1092	1127433	2000-11-29	2000-11-29 00:00:00	2001-02-27	2001-02-27 00:00:00	2001-02-27	38000177		0	0	90		0	0	0	71801	0	313782	1127433		
18540	1532	1127078	1980-08-13	1980-08-13 00:00:00	1980-08-27	1980-08-27 00:00:00	1980-08-27	38000177		0	0	14		0	0	0	102579	0	282464	1127078		
236329	5190	40213260	2007-08-03	2007-08-03 00:00:00	2007-08-03	2007-08-03 00:00:00	2007-08-03	581452		0	0	0		0	0	0	344987	0	121	40213260		
29074	2406	1118084	1979-04-20	1979-04-20 00:00:00	1979-04-20	1979-04-20 00:00:00	\N	38000177		0	0	0		0	0	0	159851	0	00025152531	44923712		
183007	4021	40213160	1959-12-23	1959-12-23 00:00:00	1959-12-23	1959-12-23 00:00:00	1959-12-23	581452		0	0	0		0	0	0	267329	0	10	40213160		
234478	5151	40213160	1961-10-13	1961-10-13 00:00:00	1961-10-13	1961-10-13 00:00:00	1961-10-13	581452		0	0	0		0	0	0	342524	0	10	40213160		
56134	4660	1127433	1995-11-24	1995-11-24 00:00:00	1995-12-08	1995-12-08 00:00:00	1995-12-08	38000177		0	0	14		0	0	0	310599	0	313782	1127433		
2056	162	1115171	2007-09-05	2007-09-05 00:00:00	2007-09-26	2007-09-26 00:00:00	2007-09-26	38000177		0	0	21		0	0	0	11093	0	849574	1115171		
34296	2834	1127433	1990-06-26	1990-06-26 00:00:00	1990-07-03	1990-07-03 00:00:00	1990-07-03	38000177		0	0	7		0	0	0	188188	0	313782	1127433		
82998	1814	40213227	2001-12-15	2001-12-15 00:00:00	2001-12-15	2001-12-15 00:00:00	2001-12-15	581452		0	0	0		0	0	0	121365	0	113	40213227		
50319	4176	40229134	1923-07-09	1923-07-09 00:00:00	1923-07-23	1923-07-23 00:00:00	1923-07-23	38000177		0	0	14		0	0	0	277525	0	1043400	40229134		
129299	2843	40213260	2009-10-29	2009-10-29 00:00:00	2009-10-29	2009-10-29 00:00:00	2009-10-29	581452		0	0	0		0	0	0	188800	0	121	40213260		
25805	563	40213160	1969-03-23	1969-03-23 00:00:00	1969-03-23	1969-03-23 00:00:00	1969-03-23	581452		0	0	0		0	0	0	37247	0	10	40213160		
179180	3939	40213314	1977-12-25	1977-12-25 00:00:00	1977-12-25	1977-12-25 00:00:00	1977-12-25	581452		0	0	0		0	0	0	261823	0	49	40213314		
16133	1338	19006318	1947-04-19	1947-04-19 00:00:00	1947-05-03	1947-05-03 00:00:00	1947-05-03	38000177		0	0	14		0	0	0	88745	0	105078	19006318		
200743	4408	40213227	2003-03-27	2003-03-27 00:00:00	2003-03-27	2003-03-27 00:00:00	2003-03-27	581452		0	0	0		0	0	0	293037	0	113	40213227		
51662	1131	40213160	1970-07-22	1970-07-22 00:00:00	1970-07-22	1970-07-22 00:00:00	1970-07-22	581452		0	0	0		0	0	0	74486	0	10	40213160		
16532	357	40213160	1955-06-22	1955-06-22 00:00:00	1955-06-22	1955-06-22 00:00:00	1955-06-22	581452		0	0	0		0	0	0	23702	0	10	40213160		
159879	3518	40213296	1998-06-08	1998-06-08 00:00:00	1998-06-08	1998-06-08 00:00:00	1998-06-08	581452		0	0	0		0	0	0	233576	0	52	40213296		
26830	2210	1127433	1982-09-08	1982-09-08 00:00:00	1982-09-15	1982-09-15 00:00:00	1982-09-15	38000177		0	0	7		0	0	0	147215	0	313782	1127433		
82480	1801	40213260	2007-08-08	2007-08-08 00:00:00	2007-08-08	2007-08-08 00:00:00	2007-08-08	581452		0	0	0		0	0	0	120779	0	121	40213260		
52045	4329	1127433	2018-03-15	2018-03-15 00:00:00	2018-03-22	2018-03-22 00:00:00	2018-03-22	38000177		0	0	7		0	0	0	287074	0	313782	1127433		
93887	2060	40213306	1984-09-26	1984-09-26 00:00:00	1984-09-26	1984-09-26 00:00:00	1984-09-26	581452		0	0	0		0	0	0	137048	0	43	40213306		
18684	1542	1127433	2007-11-03	2007-11-03 00:00:00	2007-12-03	2007-12-03 00:00:00	2007-12-03	38000177		0	0	30		0	0	0	103306	0	313782	1127433		
101148	2217	40213160	1979-10-05	1979-10-05 00:00:00	1979-10-05	1979-10-05 00:00:00	1979-10-05	581452		0	0	0		0	0	0	147632	0	10	40213160		
101189	2218	40213160	1979-01-30	1979-01-30 00:00:00	1979-01-30	1979-01-30 00:00:00	1979-01-30	581452		0	0	0		0	0	0	147743	0	10	40213160		
4235	350	19126352	1991-11-08	1991-11-08 00:00:00	1991-11-08	1991-11-08 00:00:00	\N	38000177		0	0	0		0	0	0	23322	0	705129	19126352		
188963	4149	40213296	2007-06-22	2007-06-22 00:00:00	2007-06-22	2007-06-22 00:00:00	2007-06-22	581452		0	0	0		0	0	0	275758	0	52	40213296		
101297	2220	40213201	2009-02-18	2009-02-18 00:00:00	2009-02-18	2009-02-18 00:00:00	2009-02-18	581452		0	0	0		0	0	0	147782	0	33	40213201		
43865	3633	1127078	1973-09-20	1973-09-20 00:00:00	1973-10-04	1973-10-04 00:00:00	1973-10-04	38000177		0	0	14		0	0	0	241685	0	282464	1127078		
43916	3638	19133873	1977-05-15	1977-05-15 00:00:00	1977-05-24	1977-05-24 00:00:00	1977-05-24	38000177		0	0	9		0	0	0	241986	0	834061	19133873		
86934	1906	40213227	2003-07-06	2003-07-06 00:00:00	2003-07-06	2003-07-06 00:00:00	2003-07-06	581452		0	0	0		0	0	0	126893	0	113	40213227		
185935	4085	40213160	1963-09-14	1963-09-14 00:00:00	1963-09-14	1963-09-14 00:00:00	1963-09-14	581452		0	0	0		0	0	0	271446	0	10	40213160		
239884	5265	40213260	2018-09-27	2018-09-27 00:00:00	2018-09-27	2018-09-27 00:00:00	2018-09-27	581452		0	0	0		0	0	0	350293	0	121	40213260		
40675	886	40213314	1983-09-13	1983-09-13 00:00:00	1983-09-13	1983-09-13 00:00:00	1983-09-13	581452		0	0	0		0	0	0	59083	0	49	40213314		
12831	1079	1127433	1983-02-06	1983-02-06 00:00:00	1983-02-20	1983-02-20 00:00:00	1983-02-20	38000177		0	0	14		0	0	0	70769	0	313782	1127433		
142738	3135	40213160	1963-09-12	1963-09-12 00:00:00	1963-09-12	1963-09-12 00:00:00	1963-09-12	581452		0	0	0		0	0	0	208698	0	10	40213160		
157107	3457	40213201	1983-04-08	1983-04-08 00:00:00	1983-04-08	1983-04-08 00:00:00	1983-04-08	581452		0	0	0		0	0	0	229394	0	33	40213201		
40654	3371	19129144	2004-05-24	2004-05-24 00:00:00	2005-05-19	2005-05-19 00:00:00	2005-05-19	38000177		0	0	360		0	0	0	223654	0	757594	19129144		
175809	3865	40213227	1999-05-27	1999-05-27 00:00:00	1999-05-27	1999-05-27 00:00:00	1999-05-27	581452		0	0	0		0	0	0	256571	0	113	40213227		
47846	3967	1127433	2009-07-23	2009-07-23 00:00:00	2009-08-06	2009-08-06 00:00:00	2009-08-06	38000177		0	0	14		0	0	0	263772	0	313782	1127433		
23545	1937	19133873	1966-08-10	1966-08-10 00:00:00	1966-08-19	1966-08-19 00:00:00	1966-08-19	38000177		0	0	9		0	0	0	128845	0	834061	19133873		
233152	5123	40213251	1984-05-07	1984-05-07 00:00:00	1984-05-07	1984-05-07 00:00:00	1984-05-07	581452		0	0	0		0	0	0	340678	0	21	40213251		
43776	3626	19074843	1979-03-18	1979-03-18 00:00:00	1979-04-01	1979-04-01 00:00:00	1979-04-01	38000177		0	0	14		0	0	0	241133	0	309045	19074843		
117634	2586	40213227	2009-08-16	2009-08-16 00:00:00	2009-08-16	2009-08-16 00:00:00	2009-08-16	581452		0	0	0		0	0	0	171220	0	113	40213227		
57403	4761	40165015	1998-01-01	1998-01-01 00:00:00	1998-01-01	1998-01-01 00:00:00	\N	38000177		0	0	0		0	0	0	317237	0	861467	40165015		
180059	3957	40213160	1956-03-01	1956-03-01 00:00:00	1956-03-01	1956-03-01 00:00:00	1956-03-01	581452		0	0	0		0	0	0	263124	0	10	40213160		
51046	4240	40229134	1963-04-29	1963-04-29 00:00:00	1963-05-13	1963-05-13 00:00:00	1963-05-13	38000177		0	0	14		0	0	0	281626	0	1043400	40229134		
51086	4243	46233988	1972-06-15	1972-06-15 00:00:00	1972-06-29	1972-06-29 00:00:00	1972-06-29	38000177		0	0	14		0	0	0	281853	0	1652673	46233988		
170192	3742	40213296	2011-04-22	2011-04-22 00:00:00	2011-04-22	2011-04-22 00:00:00	2011-04-22	581452		0	0	0		0	0	0	248650	0	52	40213296		
26353	2168	19129655	1962-06-14	1962-06-14 00:00:00	1962-06-28	1962-06-28 00:00:00	1962-06-28	38000177		0	0	14		0	0	0	144441	0	789980	19129655		
119952	2636	40213260	2010-04-16	2010-04-16 00:00:00	2010-04-16	2010-04-16 00:00:00	2010-04-16	581452		0	0	0		0	0	0	174453	0	121	40213260		
45072	3730	1310034	1994-07-28	1994-07-28 00:00:00	1994-07-28	1994-07-28 00:00:00	1994-07-28	38000177		0	0	0		0	0	0	247807	0	834357	1310034		
11660	250	40213314	1978-01-18	1978-01-18 00:00:00	1978-01-18	1978-01-18 00:00:00	1978-01-18	581452		0	0	0		0	0	0	16788	0	49	40213314		
60672	1325	40213260	2015-11-29	2015-11-29 00:00:00	2015-11-29	2015-11-29 00:00:00	2015-11-29	581452		0	0	0		0	0	0	87949	0	121	40213260		
142429	3129	40213160	1976-04-27	1976-04-27 00:00:00	1976-04-27	1976-04-27 00:00:00	1976-04-27	581452		0	0	0		0	0	0	208263	0	10	40213160		
131453	2889	40213296	2002-03-31	2002-03-31 00:00:00	2002-03-31	2002-03-31 00:00:00	2002-03-31	581452		0	0	0		0	0	0	192162	0	52	40213296		
214386	4701	40213227	2012-12-07	2012-12-07 00:00:00	2012-12-07	2012-12-07 00:00:00	2012-12-07	581452		0	0	0		0	0	0	313182	0	113	40213227		
172634	3795	40213296	2016-10-25	2016-10-25 00:00:00	2016-10-25	2016-10-25 00:00:00	2016-10-25	581452		0	0	0		0	0	0	252333	0	52	40213296		
28927	2392	1127433	1942-12-31	1942-12-31 00:00:00	1943-01-14	1943-01-14 00:00:00	1943-01-14	38000177		0	0	14		0	0	0	159025	0	313782	1127433		
211509	4637	40213314	1977-06-27	1977-06-27 00:00:00	1977-06-27	1977-06-27 00:00:00	1977-06-27	581452		0	0	0		0	0	0	309042	0	49	40213314		
115070	2528	40213160	1973-02-28	1973-02-28 00:00:00	1973-02-28	1973-02-28 00:00:00	1973-02-28	581452		0	0	0		0	0	0	167097	0	10	40213160		
125138	2752	40213160	1956-02-26	1956-02-26 00:00:00	1956-02-26	1956-02-26 00:00:00	1956-02-26	581452		0	0	0		0	0	0	182096	0	10	40213160		
57488	4771	19006318	1958-08-24	1958-08-24 00:00:00	1958-09-07	1958-09-07 00:00:00	1958-09-07	38000177		0	0	14		0	0	0	317762	0	105078	19006318		
13000	1092	1127433	1997-03-13	1997-03-13 00:00:00	1997-05-19	1997-05-19 00:00:00	1997-05-19	38000177		0	0	67		0	0	0	71800	0	313782	1127433		
18541	1532	19073183	1980-08-13	1980-08-13 00:00:00	1980-08-27	1980-08-27 00:00:00	1980-08-27	38000177		0	0	14		0	0	0	102579	0	308182	19073183		
236338	5190	40213227	2008-08-08	2008-08-08 00:00:00	2008-08-08	2008-08-08 00:00:00	2008-08-08	581452		0	0	0		0	0	0	345021	0	113	40213227		
29075	2406	19006318	1946-02-22	1946-02-22 00:00:00	1946-03-08	1946-03-08 00:00:00	1946-03-08	38000177		0	0	14		0	0	0	159852	0	105078	19006318		
183010	4021	40213160	1955-04-20	1955-04-20 00:00:00	1955-04-20	1955-04-20 00:00:00	1955-04-20	581452		0	0	0		0	0	0	267318	0	10	40213160		
234482	5151	40213160	1957-02-08	1957-02-08 00:00:00	1957-02-08	1957-02-08 00:00:00	1957-02-08	581452		0	0	0		0	0	0	342584	0	10	40213160		
56135	4660	1713671	2005-06-24	2005-06-24 00:00:00	2005-07-15	2005-07-15 00:00:00	2005-07-15	38000177		0	0	21		0	0	0	310661	0	562251	1713671		
2057	162	40229134	1984-06-15	1984-06-15 00:00:00	1984-06-22	1984-06-22 00:00:00	1984-06-22	38000177		0	0	7		0	0	0	11165	0	1043400	40229134		
34297	2834	40229134	1980-07-03	1980-07-03 00:00:00	1980-07-17	1980-07-17 00:00:00	1980-07-17	38000177		0	0	14		0	0	0	188187	0	1043400	40229134		
47270	1032	40213160	1955-03-20	1955-03-20 00:00:00	1955-03-20	1955-03-20 00:00:00	1955-03-20	581452		0	0	0		0	0	0	67961	0	10	40213160		
50320	4176	1127433	1945-03-07	1945-03-07 00:00:00	1945-03-14	1945-03-14 00:00:00	1945-03-14	38000177		0	0	7		0	0	0	277444	0	313782	1127433		
129301	2843	40213227	2009-10-29	2009-10-29 00:00:00	2009-10-29	2009-10-29 00:00:00	2009-10-29	581452		0	0	0		0	0	0	188800	0	113	40213227		
25816	564	40213227	2007-07-26	2007-07-26 00:00:00	2007-07-26	2007-07-26 00:00:00	2007-07-26	581452		0	0	0		0	0	0	37382	0	113	40213227		
25835	564	40213160	1956-06-28	1956-06-28 00:00:00	1956-06-28	1956-06-28 00:00:00	1956-06-28	581452		0	0	0		0	0	0	37363	0	10	40213160		
16134	1338	19059056	1947-04-19	1947-04-19 00:00:00	1947-05-03	1947-05-03 00:00:00	1947-05-03	38000177		0	0	14		0	0	0	88745	0	243670	19059056		
200744	4408	40213306	2003-03-27	2003-03-27 00:00:00	2003-03-27	2003-03-27 00:00:00	2003-03-27	581452		0	0	0		0	0	0	293037	0	43	40213306		
51664	1131	40213306	1988-02-03	1988-02-03 00:00:00	1988-02-03	1988-02-03 00:00:00	1988-02-03	581452		0	0	0		0	0	0	74483	0	43	40213306		
16539	357	40213260	2007-10-31	2007-10-31 00:00:00	2007-10-31	2007-10-31 00:00:00	2007-10-31	581452		0	0	0		0	0	0	23721	0	121	40213260		
78548	1718	40213227	2017-11-11	2017-11-11 00:00:00	2017-11-11	2017-11-11 00:00:00	2017-11-11	581452		0	0	0		0	0	0	114823	0	113	40213227		
26831	2210	19059056	1937-09-20	1937-09-20 00:00:00	1937-10-04	1937-10-04 00:00:00	1937-10-04	38000177		0	0	14		0	0	0	147256	0	243670	19059056		
82483	1801	40213227	1996-07-31	1996-07-31 00:00:00	1996-07-31	1996-07-31 00:00:00	1996-07-31	581452		0	0	0		0	0	0	120775	0	113	40213227		
52046	4329	1127433	2013-12-19	2013-12-19 00:00:00	2013-12-26	2013-12-26 00:00:00	2013-12-26	38000177		0	0	7		0	0	0	287125	0	313782	1127433		
28021	609	40213227	1999-02-23	1999-02-23 00:00:00	1999-02-23	1999-02-23 00:00:00	1999-02-23	581452		0	0	0		0	0	0	40452	0	113	40213227		
18685	1542	19059056	1992-11-16	1992-11-16 00:00:00	1992-12-21	1992-12-21 00:00:00	1992-12-21	38000177		0	0	35		0	0	0	103305	0	243670	19059056		
101150	2217	40213314	1980-09-05	1980-09-05 00:00:00	1980-09-05	1980-09-05 00:00:00	1980-09-05	581452		0	0	0		0	0	0	147676	0	49	40213314		
101190	2218	40213314	1978-08-29	1978-08-29 00:00:00	1978-08-29	1978-08-29 00:00:00	1978-08-29	581452		0	0	0		0	0	0	147721	0	49	40213314		
4236	350	1118084	2004-08-22	2004-08-22 00:00:00	2004-08-22	2004-08-22 00:00:00	\N	38000177		0	0	0		0	0	0	23278	0	00025152531	44923712		
10455	870	1127433	1979-02-10	1979-02-10 00:00:00	1979-03-17	1979-03-17 00:00:00	1979-03-17	38000177		0	0	35		0	0	0	57893	0	313782	1127433		
101301	2220	40213198	2010-02-24	2010-02-24 00:00:00	2010-02-24	2010-02-24 00:00:00	2010-02-24	581452		0	0	0		0	0	0	147797	0	133	40213198		
43866	3633	1127078	1975-02-12	1975-02-12 00:00:00	1975-02-26	1975-02-26 00:00:00	1975-02-26	38000177		0	0	14		0	0	0	241651	0	282464	1127078		
43917	3638	1124300	2002-12-13	2002-12-13 00:00:00	2002-12-13	2002-12-13 00:00:00	\N	38000177		0	0	0		0	0	0	241997	0	00781178901	45011828		
86935	1906	40213296	2003-07-06	2003-07-06 00:00:00	2003-07-06	2003-07-06 00:00:00	2003-07-06	581452		0	0	0		0	0	0	126893	0	52	40213296		
185938	4085	40213227	1992-06-27	1992-06-27 00:00:00	1992-06-27	1992-06-27 00:00:00	1992-06-27	581452		0	0	0		0	0	0	271453	0	113	40213227		
239888	5265	40213296	2011-09-08	2011-09-08 00:00:00	2011-09-08	2011-09-08 00:00:00	2011-09-08	581452		0	0	0		0	0	0	350269	0	52	40213296		
40684	886	40213160	1983-12-13	1983-12-13 00:00:00	1983-12-13	1983-12-13 00:00:00	1983-12-13	581452		0	0	0		0	0	0	59097	0	10	40213160		
12832	1079	1127433	2004-12-07	2004-12-07 00:00:00	2004-12-14	2004-12-14 00:00:00	2004-12-14	38000177		0	0	7		0	0	0	70714	0	313782	1127433		
142746	3135	40213227	1996-09-26	1996-09-26 00:00:00	1996-09-26	1996-09-26 00:00:00	1996-09-26	581452		0	0	0		0	0	0	208662	0	113	40213227		
192050	4220	40213198	2010-07-20	2010-07-20 00:00:00	2010-07-20	2010-07-20 00:00:00	2010-07-20	581452		0	0	0		0	0	0	280172	0	133	40213198		
40655	3371	40224805	2005-05-19	2005-05-19 00:00:00	2006-05-14	2006-05-14 00:00:00	2006-05-14	38000177		0	0	360		0	0	0	223655	0	1000126	40224805		
175813	3865	40213160	1956-10-04	1956-10-04 00:00:00	1956-10-04	1956-10-04 00:00:00	1956-10-04	581452		0	0	0		0	0	0	256619	0	10	40213160		
47847	3967	19128065	1975-04-23	1975-04-23 00:00:00	1976-04-17	1976-04-17 00:00:00	1976-04-17	38000177		0	0	360		0	0	0	263773	0	749882	19128065		
23546	1937	40229134	2015-04-06	2015-04-06 00:00:00	2015-04-13	2015-04-13 00:00:00	2015-04-13	38000177		0	0	7		0	0	0	128879	0	1043400	40229134		
233153	5123	40213160	1984-05-07	1984-05-07 00:00:00	1984-05-07	1984-05-07 00:00:00	1984-05-07	581452		0	0	0		0	0	0	340678	0	10	40213160		
43777	3626	19128065	1990-03-09	1990-03-09 00:00:00	1991-03-04	1991-03-04 00:00:00	1991-03-04	38000177		0	0	360		0	0	0	241150	0	749882	19128065		
117639	2586	40213306	1991-02-24	1991-02-24 00:00:00	1991-02-24	1991-02-24 00:00:00	1991-02-24	581452		0	0	0		0	0	0	171134	0	43	40213306		
57404	4761	1115171	1998-01-01	1998-01-01 00:00:00	1998-01-31	1998-01-31 00:00:00	1998-01-31	38000177		0	0	30		0	0	0	317237	0	849574	1115171		
180067	3958	40213160	1965-07-25	1965-07-25 00:00:00	1965-07-25	1965-07-25 00:00:00	1965-07-25	581452		0	0	0		0	0	0	263163	0	10	40213160		
51047	4240	1713671	1971-08-26	1971-08-26 00:00:00	1971-09-02	1971-09-02 00:00:00	1971-09-02	38000177		0	0	7		0	0	0	281634	0	562251	1713671		
51087	4243	1127078	1972-06-15	1972-06-15 00:00:00	1972-06-29	1972-06-29 00:00:00	1972-06-29	38000177		0	0	14		0	0	0	281853	0	282464	1127078		
170194	3742	40213160	1971-04-23	1971-04-23 00:00:00	1971-04-23	1971-04-23 00:00:00	1971-04-23	581452		0	0	0		0	0	0	248643	0	10	40213160		
26354	2168	1127433	2016-07-06	2016-07-06 00:00:00	2016-07-27	2016-07-27 00:00:00	2016-07-27	38000177		0	0	21		0	0	0	144517	0	313782	1127433		
240513	5279	40213201	2012-04-29	2012-04-29 00:00:00	2012-04-29	2012-04-29 00:00:00	2012-04-29	581452		0	0	0		0	0	0	351218	0	33	40213201		
45074	3730	1713671	1965-10-04	1965-10-04 00:00:00	1965-10-18	1965-10-18 00:00:00	1965-10-18	38000177		0	0	14		0	0	0	247855	0	562251	1713671		
11664	250	40213314	1977-07-20	1977-07-20 00:00:00	1977-07-20	1977-07-20 00:00:00	1977-07-20	581452		0	0	0		0	0	0	16830	0	49	40213314		
60676	1325	40213160	1969-01-12	1969-01-12 00:00:00	1969-01-12	1969-01-12 00:00:00	1969-01-12	581452		0	0	0		0	0	0	87940	0	10	40213160		
142433	3129	40213306	1993-07-20	1993-07-20 00:00:00	1993-07-20	1993-07-20 00:00:00	1993-07-20	581452		0	0	0		0	0	0	208272	0	43	40213306		
131458	2889	40213227	2011-10-16	2011-10-16 00:00:00	2011-10-16	2011-10-16 00:00:00	2011-10-16	581452		0	0	0		0	0	0	192163	0	113	40213227		
214387	4701	40213296	2012-12-07	2012-12-07 00:00:00	2012-12-07	2012-12-07 00:00:00	2012-12-07	581452		0	0	0		0	0	0	313182	0	52	40213296		
172636	3795	40213160	1973-07-24	1973-07-24 00:00:00	1973-07-24	1973-07-24 00:00:00	1973-07-24	581452		0	0	0		0	0	0	252336	0	10	40213160		
28928	2392	1127433	1957-02-13	1957-02-13 00:00:00	1957-02-27	1957-02-27 00:00:00	1957-02-27	38000177		0	0	14		0	0	0	159020	0	313782	1127433		
211510	4637	40213306	1996-06-17	1996-06-17 00:00:00	1996-06-17	1996-06-17 00:00:00	1996-06-17	581452		0	0	0		0	0	0	309057	0	43	40213306		
115072	2528	40213296	2010-08-04	2010-08-04 00:00:00	2010-08-04	2010-08-04 00:00:00	2010-08-04	581452		0	0	0		0	0	0	\N	0	52	40213296		
210477	4615	40213227	2016-11-02	2016-11-02 00:00:00	2016-11-02	2016-11-02 00:00:00	2016-11-02	581452		0	0	0		0	0	0	307442	0	113	40213227		
57489	4771	19059056	1958-08-24	1958-08-24 00:00:00	1958-09-07	1958-09-07 00:00:00	1958-09-07	38000177		0	0	14		0	0	0	317762	0	243670	19059056		
13001	1092	1127433	1981-01-10	1981-01-10 00:00:00	1981-01-17	1981-01-17 00:00:00	1981-01-17	38000177		0	0	7		0	0	0	71751	0	313782	1127433		
18542	1533	1713671	1991-02-16	1991-02-16 00:00:00	1991-03-02	1991-03-02 00:00:00	1991-03-02	38000177		0	0	14		0	0	0	102694	0	562251	1713671		
236339	5190	40213260	2008-08-08	2008-08-08 00:00:00	2008-08-08	2008-08-08 00:00:00	2008-08-08	581452		0	0	0		0	0	0	345021	0	121	40213260		
29076	2406	19059056	1946-02-22	1946-02-22 00:00:00	1946-03-08	1946-03-08 00:00:00	1946-03-08	38000177		0	0	14		0	0	0	159852	0	243670	19059056		
183025	4021	40213160	1955-06-22	1955-06-22 00:00:00	1955-06-22	1955-06-22 00:00:00	1955-06-22	581452		0	0	0		0	0	0	267327	0	10	40213160		
234485	5151	40213296	1999-11-12	1999-11-12 00:00:00	1999-11-12	1999-11-12 00:00:00	1999-11-12	581452		0	0	0		0	0	0	342570	0	52	40213296		
56136	4660	19133873	1968-07-26	1968-07-26 00:00:00	1968-08-06	1968-08-06 00:00:00	1968-08-06	38000177		0	0	11		0	0	0	310657	0	834061	19133873		
2058	162	1127433	2001-06-25	2001-06-25 00:00:00	2001-07-02	2001-07-02 00:00:00	2001-07-02	38000177		0	0	7		0	0	0	11166	0	313782	1127433		
34298	2834	19075601	1997-08-16	1997-08-16 00:00:00	1999-12-04	1999-12-04 00:00:00	1999-12-04	38000177		0	0	840		0	0	0	188122	0	309362	19075601		
47272	1032	40213227	2003-09-28	2003-09-28 00:00:00	2003-09-28	2003-09-28 00:00:00	2003-09-28	581452		0	0	0		0	0	0	67888	0	113	40213227		
50321	4176	40229134	1983-05-01	1983-05-01 00:00:00	1983-05-15	1983-05-15 00:00:00	1983-05-15	38000177		0	0	14		0	0	0	277530	0	1043400	40229134		
129305	2843	40213306	1981-03-26	1981-03-26 00:00:00	1981-03-26	1981-03-26 00:00:00	1981-03-26	581452		0	0	0		0	0	0	188725	0	43	40213306		
25817	564	40213260	2007-07-26	2007-07-26 00:00:00	2007-07-26	2007-07-26 00:00:00	2007-07-26	581452		0	0	0		0	0	0	37382	0	121	40213260		
25840	564	40213296	1998-11-05	1998-11-05 00:00:00	1998-11-05	1998-11-05 00:00:00	1998-11-05	581452		0	0	0		0	0	0	37319	0	52	40213296		
16135	1338	19133873	1959-02-03	1959-02-03 00:00:00	1959-02-15	1959-02-15 00:00:00	1959-02-15	38000177		0	0	12		0	0	0	88717	0	834061	19133873		
200746	4408	40213227	2012-04-05	2012-04-05 00:00:00	2012-04-05	2012-04-05 00:00:00	2012-04-05	581452		0	0	0		0	0	0	293013	0	113	40213227		
51667	1131	40213160	1966-04-20	1966-04-20 00:00:00	1966-04-20	1966-04-20 00:00:00	1966-04-20	581452		0	0	0		0	0	0	74455	0	10	40213160		
16542	357	40213160	1959-07-01	1959-07-01 00:00:00	1959-07-01	1959-07-01 00:00:00	1959-07-01	581452		0	0	0		0	0	0	23679	0	10	40213160		
78549	1718	40213260	2017-11-11	2017-11-11 00:00:00	2017-11-11	2017-11-11 00:00:00	2017-11-11	581452		0	0	0		0	0	0	114823	0	121	40213260		
26832	2210	19133905	2016-06-21	2016-06-21 00:00:00	2016-07-03	2016-07-03 00:00:00	2016-07-03	38000177		0	0	12		0	0	0	147220	0	834102	19133905		
82484	1801	40213296	1996-07-31	1996-07-31 00:00:00	1996-07-31	1996-07-31 00:00:00	1996-07-31	581452		0	0	0		0	0	0	120775	0	52	40213296		
52047	4329	1124300	2010-11-10	2010-11-10 00:00:00	2010-11-10	2010-11-10 00:00:00	\N	38000177		0	0	0		0	0	0	287102	0	00781178901	45011828		
28023	610	40213160	1962-12-06	1962-12-06 00:00:00	1962-12-06	1962-12-06 00:00:00	1962-12-06	581452		0	0	0		0	0	0	40543	0	10	40213160		
18686	1542	1127433	2012-10-13	2012-10-13 00:00:00	2012-10-27	2012-10-27 00:00:00	2012-10-27	38000177		0	0	14		0	0	0	103323	0	313782	1127433		
18820	408	40213296	2002-07-03	2002-07-03 00:00:00	2002-07-03	2002-07-03 00:00:00	2002-07-03	581452		0	0	0		0	0	0	26984	0	52	40213296		
101191	2218	40213160	1978-08-29	1978-08-29 00:00:00	1978-08-29	1978-08-29 00:00:00	1978-08-29	581452		0	0	0		0	0	0	147721	0	10	40213160		
4237	350	19133905	1994-03-03	1994-03-03 00:00:00	1994-03-11	1994-03-11 00:00:00	1994-03-11	38000177		0	0	8		0	0	0	23326	0	834102	19133905		
10456	871	40236824	2014-02-17	2014-02-17 00:00:00	2014-02-24	2014-02-24 00:00:00	2014-02-24	38000177		0	0	7		0	0	0	57927	0	1094107	40236824		
51954	1137	40213227	1993-09-24	1993-09-24 00:00:00	1993-09-24	1993-09-24 00:00:00	1993-09-24	581452		0	0	0		0	0	0	74929	0	113	40213227		
43867	3633	1713671	1984-06-24	1984-06-24 00:00:00	1984-07-15	1984-07-15 00:00:00	1984-07-15	38000177		0	0	21		0	0	0	241682	0	562251	1713671		
43918	3638	1127433	2001-01-17	2001-01-17 00:00:00	2001-02-16	2001-02-16 00:00:00	2001-02-16	38000177		0	0	30		0	0	0	241968	0	313782	1127433		
86938	1906	40213260	2010-11-13	2010-11-13 00:00:00	2010-11-13	2010-11-13 00:00:00	2010-11-13	581452		0	0	0		0	0	0	126906	0	121	40213260		
185940	4085	40213296	2001-05-12	2001-05-12 00:00:00	2001-05-12	2001-05-12 00:00:00	2001-05-12	581452		0	0	0		0	0	0	271549	0	52	40213296		
239890	5265	40213160	1968-10-31	1968-10-31 00:00:00	1968-10-31	1968-10-31 00:00:00	1968-10-31	581452		0	0	0		0	0	0	350307	0	10	40213160		
40688	886	40213251	1988-03-15	1988-03-15 00:00:00	1988-03-15	1988-03-15 00:00:00	1988-03-15	581452		0	0	0		0	0	0	59087	0	21	40213251		
12845	1081	19133873	1962-09-14	1962-09-14 00:00:00	1962-09-27	1962-09-27 00:00:00	1962-09-27	38000177		0	0	13		0	0	0	70861	0	834061	19133873		
142756	3135	40213306	1987-06-25	1987-06-25 00:00:00	1987-06-25	1987-06-25 00:00:00	1987-06-25	581452		0	0	0		0	0	0	208717	0	43	40213306		
192054	4220	40213227	2003-06-10	2003-06-10 00:00:00	2003-06-10	2003-06-10 00:00:00	2003-06-10	581452		0	0	0		0	0	0	280246	0	113	40213227		
40656	3371	19128022	1994-07-16	1994-07-16 00:00:00	1995-07-11	1995-07-11 00:00:00	1995-07-11	38000177		0	0	360		0	0	0	223637	0	749785	19128022		
175818	3865	40213296	1997-05-22	1997-05-22 00:00:00	1997-05-22	1997-05-22 00:00:00	1997-05-22	581452		0	0	0		0	0	0	256551	0	52	40213296		
47848	3967	1127433	1978-08-16	1978-08-16 00:00:00	1978-08-30	1978-08-30 00:00:00	1978-08-30	38000177		0	0	14		0	0	0	263744	0	313782	1127433		
23547	1937	920300	2009-07-12	2009-07-12 00:00:00	2009-07-19	2009-07-19 00:00:00	2009-07-19	38000177		0	0	7		0	0	0	128908	0	311989	920300		
233158	5123	40213306	2002-04-22	2002-04-22 00:00:00	2002-04-22	2002-04-22 00:00:00	2002-04-22	581452		0	0	0		0	0	0	340669	0	43	40213306		
43778	3626	1127433	2012-04-04	2012-04-04 00:00:00	2012-04-18	2012-04-18 00:00:00	2012-04-18	38000177		0	0	14		0	0	0	241125	0	313782	1127433		
117640	2586	40213160	1969-03-09	1969-03-09 00:00:00	1969-03-09	1969-03-09 00:00:00	1969-03-09	581452		0	0	0		0	0	0	171179	0	10	40213160		
57405	4761	1150771	1984-05-25	1984-05-25 00:00:00	1984-05-25	1984-05-25 00:00:00	\N	38000177		0	0	0		0	0	0	317222	0	197378	1150771		
180074	3958	40213160	1961-04-23	1961-04-23 00:00:00	1961-04-23	1961-04-23 00:00:00	1961-04-23	581452		0	0	0		0	0	0	263203	0	10	40213160		
51048	4240	1118084	1985-12-02	1985-12-02 00:00:00	1985-12-02	1985-12-02 00:00:00	\N	38000177		0	0	0		0	0	0	281601	0	00025152531	44923712		
51088	4243	1127433	1989-12-26	1989-12-26 00:00:00	1990-01-09	1990-01-09 00:00:00	1990-01-09	38000177		0	0	14		0	0	0	281850	0	313782	1127433		
170197	3742	40213160	1970-11-20	1970-11-20 00:00:00	1970-11-20	1970-11-20 00:00:00	1970-11-20	581452		0	0	0		0	0	0	248642	0	10	40213160		
26355	2168	1127433	1995-09-12	1995-09-12 00:00:00	1995-09-26	1995-09-26 00:00:00	1995-09-26	38000177		0	0	14		0	0	0	144437	0	313782	1127433		
240521	5279	40213227	2017-05-28	2017-05-28 00:00:00	2017-05-28	2017-05-28 00:00:00	2017-05-28	581452		0	0	0		0	0	0	351142	0	113	40213227		
45076	3730	19006318	1954-09-28	1954-09-28 00:00:00	1954-10-12	1954-10-12 00:00:00	1954-10-12	38000177		0	0	14		0	0	0	247879	0	105078	19006318		
11666	250	40213160	1974-07-24	1974-07-24 00:00:00	1974-07-24	1974-07-24 00:00:00	1974-07-24	581452		0	0	0		0	0	0	16827	0	10	40213160		
71960	1572	40213227	1994-06-03	1994-06-03 00:00:00	1994-06-03	1994-06-03 00:00:00	1994-06-03	581452		0	0	0		0	0	0	105591	0	113	40213227		
142435	3129	40213227	1993-07-20	1993-07-20 00:00:00	1993-07-20	1993-07-20 00:00:00	1993-07-20	581452		0	0	0		0	0	0	208272	0	113	40213227		
131462	2889	40213160	1960-06-26	1960-06-26 00:00:00	1960-06-26	1960-06-26 00:00:00	1960-06-26	581452		0	0	0		0	0	0	192178	0	10	40213160		
214389	4701	40213227	2002-11-29	2002-11-29 00:00:00	2002-11-29	2002-11-29 00:00:00	2002-11-29	581452		0	0	0		0	0	0	313189	0	113	40213227		
172637	3795	40213314	1977-01-18	1977-01-18 00:00:00	1977-01-18	1977-01-18 00:00:00	1977-01-18	581452		0	0	0		0	0	0	252329	0	49	40213314		
28929	2392	19059056	1940-07-02	1940-07-02 00:00:00	1940-07-23	1940-07-23 00:00:00	1940-07-23	38000177		0	0	21		0	0	0	159010	0	243670	19059056		
211512	4637	40213227	1996-06-17	1996-06-17 00:00:00	1996-06-17	1996-06-17 00:00:00	1996-06-17	581452		0	0	0		0	0	0	309057	0	113	40213227		
115074	2528	40213227	2010-08-04	2010-08-04 00:00:00	2010-08-04	2010-08-04 00:00:00	2010-08-04	581452		0	0	0		0	0	0	\N	0	113	40213227		
210480	4615	40213160	1960-03-30	1960-03-30 00:00:00	1960-03-30	1960-03-30 00:00:00	1960-03-30	581452		0	0	0		0	0	0	307402	0	10	40213160		
57490	4771	19133873	1962-07-15	1962-07-15 00:00:00	1962-07-28	1962-07-28 00:00:00	1962-07-28	38000177		0	0	13		0	0	0	317774	0	834061	19133873		
13002	1092	1127433	1982-12-22	1982-12-22 00:00:00	1983-01-05	1983-01-05 00:00:00	1983-01-05	38000177		0	0	14		0	0	0	71798	0	313782	1127433		
18543	1533	1127433	1983-10-24	1983-10-24 00:00:00	1983-10-31	1983-10-31 00:00:00	1983-10-31	38000177		0	0	7		0	0	0	102658	0	313782	1127433		
236344	5190	40213160	1957-05-10	1957-05-10 00:00:00	1957-05-10	1957-05-10 00:00:00	1957-05-10	581452		0	0	0		0	0	0	345034	0	10	40213160		
29077	2406	40229134	1991-03-02	1991-03-02 00:00:00	1991-03-09	1991-03-09 00:00:00	1991-03-09	38000177		0	0	7		0	0	0	159806	0	1043400	40229134		
183035	4021	40213160	1955-09-21	1955-09-21 00:00:00	1955-09-21	1955-09-21 00:00:00	1955-09-21	581452		0	0	0		0	0	0	267319	0	10	40213160		
234488	5151	40213227	2007-12-07	2007-12-07 00:00:00	2007-12-07	2007-12-07 00:00:00	2007-12-07	581452		0	0	0		0	0	0	342531	0	113	40213227		
56137	4661	1127433	2016-08-29	2016-08-29 00:00:00	2016-09-12	2016-09-12 00:00:00	2016-09-12	38000177		0	0	14		0	0	0	310685	0	313782	1127433		
2059	162	19129655	1978-03-14	1978-03-14 00:00:00	1978-03-28	1978-03-28 00:00:00	1978-03-28	38000177		0	0	14		0	0	0	11167	0	789980	19129655		
34299	2834	1127433	1964-06-02	1964-06-02 00:00:00	1964-06-09	1964-06-09 00:00:00	1964-06-09	38000177		0	0	7		0	0	0	188189	0	313782	1127433		
47274	1032	40213160	1956-09-23	1956-09-23 00:00:00	1956-09-23	1956-09-23 00:00:00	1956-09-23	581452		0	0	0		0	0	0	67877	0	10	40213160		
50322	4176	40220960	2003-10-23	2003-10-23 00:00:00	2003-10-23	2003-10-23 00:00:00	2003-10-23	38000177		0	0	0		0	0	0	277487	0	1804799	40220960		
129310	2843	40213296	2002-01-24	2002-01-24 00:00:00	2002-01-24	2002-01-24 00:00:00	2002-01-24	581452		0	0	0		0	0	0	188772	0	52	40213296		
25825	564	40213160	1960-09-29	1960-09-29 00:00:00	1960-09-29	1960-09-29 00:00:00	1960-09-29	581452		0	0	0		0	0	0	37374	0	10	40213160		
25844	564	40213160	1956-01-26	1956-01-26 00:00:00	1956-01-26	1956-01-26 00:00:00	1956-01-26	581452		0	0	0		0	0	0	37385	0	10	40213160		
16136	1338	1115171	2007-11-30	2007-11-30 00:00:00	2007-12-21	2007-12-21 00:00:00	2007-12-21	38000177		0	0	21		0	0	0	88764	0	849574	1115171		
200747	4408	40213314	1982-04-01	1982-04-01 00:00:00	1982-04-01	1982-04-01 00:00:00	1982-04-01	581452		0	0	0		0	0	0	293026	0	49	40213314		
51673	1132	40213260	2006-05-22	2006-05-22 00:00:00	2006-05-22	2006-05-22 00:00:00	2006-05-22	581452		0	0	0		0	0	0	74549	0	121	40213260		
16546	357	40213160	1955-01-19	1955-01-19 00:00:00	1955-01-19	1955-01-19 00:00:00	1955-01-19	581452		0	0	0		0	0	0	23701	0	10	40213160		
78555	1719	40213160	1957-12-17	1957-12-17 00:00:00	1957-12-17	1957-12-17 00:00:00	1957-12-17	581452		0	0	0		0	0	0	114905	0	10	40213160		
26833	2210	1713671	1937-12-25	1937-12-25 00:00:00	1938-01-15	1938-01-15 00:00:00	1938-01-15	38000177		0	0	21		0	0	0	147234	0	562251	1713671		
82492	1801	40213160	1955-09-28	1955-09-28 00:00:00	1955-09-28	1955-09-28 00:00:00	1955-09-28	581452		0	0	0		0	0	0	120759	0	10	40213160		
52048	4329	19078461	1991-09-20	1991-09-20 00:00:00	1991-12-18	1991-12-18 00:00:00	1991-12-18	38000177		0	0	89		0	0	0	287105	0	310965	19078461		
28025	610	40213227	2005-02-17	2005-02-17 00:00:00	2005-02-17	2005-02-17 00:00:00	2005-02-17	581452		0	0	0		0	0	0	40563	0	113	40213227		
18687	1542	1127433	1986-12-27	1986-12-27 00:00:00	1987-01-10	1987-01-10 00:00:00	1987-01-10	38000177		0	0	14		0	0	0	103339	0	313782	1127433		
18822	408	40213260	2011-06-08	2011-06-08 00:00:00	2011-06-08	2011-06-08 00:00:00	2011-06-08	581452		0	0	0		0	0	0	\N	0	121	40213260		
101194	2218	40213160	1983-05-03	1983-05-03 00:00:00	1983-05-03	1983-05-03 00:00:00	1983-05-03	581452		0	0	0		0	0	0	147713	0	10	40213160		
4238	350	1127433	2008-11-01	2008-11-01 00:00:00	2008-11-08	2008-11-08 00:00:00	2008-11-08	38000177		0	0	7		0	0	0	23259	0	313782	1127433		
10457	871	920300	2014-02-17	2014-02-17 00:00:00	2014-02-24	2014-02-24 00:00:00	2014-02-24	38000177		0	0	7		0	0	0	57927	0	311989	920300		
51958	1137	40213227	2002-09-20	2002-09-20 00:00:00	2002-09-20	2002-09-20 00:00:00	2002-09-20	581452		0	0	0		0	0	0	74931	0	113	40213227		
43868	3633	19133873	1982-06-08	1982-06-08 00:00:00	1982-06-15	1982-06-15 00:00:00	1982-06-15	38000177		0	0	7		0	0	0	241679	0	834061	19133873		
43919	3638	1127078	1968-06-04	1968-06-04 00:00:00	1968-06-18	1968-06-18 00:00:00	1968-06-18	38000177		0	0	14		0	0	0	241998	0	282464	1127078		
86941	1906	40213306	1981-03-28	1981-03-28 00:00:00	1981-03-28	1981-03-28 00:00:00	1981-03-28	581452		0	0	0		0	0	0	\N	0	43	40213306		
185942	4085	40213227	2001-05-12	2001-05-12 00:00:00	2001-05-12	2001-05-12 00:00:00	2001-05-12	581452		0	0	0		0	0	0	271549	0	113	40213227		
191891	4217	40213227	2000-03-15	2000-03-15 00:00:00	2000-03-15	2000-03-15 00:00:00	2000-03-15	581452		0	0	0		0	0	0	279919	0	113	40213227		
83318	1821	40213227	1998-10-11	1998-10-11 00:00:00	1998-10-11	1998-10-11 00:00:00	1998-10-11	581452		0	0	0		0	0	0	121822	0	113	40213227		
12846	1081	19133905	2003-07-01	2003-07-01 00:00:00	2003-07-09	2003-07-09 00:00:00	2003-07-09	38000177		0	0	8		0	0	0	70837	0	834102	19133905		
157025	3455	40213160	1970-02-02	1970-02-02 00:00:00	1970-02-02	1970-02-02 00:00:00	1970-02-02	581452		0	0	0		0	0	0	229211	0	10	40213160		
192064	4220	40213201	2008-07-08	2008-07-08 00:00:00	2008-07-08	2008-07-08 00:00:00	2008-07-08	581452		0	0	0		0	0	0	280171	0	33	40213201		
40657	3371	1118084	2011-04-23	2011-04-23 00:00:00	2011-04-23	2011-04-23 00:00:00	\N	38000177		0	0	0		0	0	0	223666	0	00025152531	44923712		
175821	3865	40213260	2006-06-29	2006-06-29 00:00:00	2006-06-29	2006-06-29 00:00:00	2006-06-29	581452		0	0	0		0	0	0	256572	0	121	40213260		
47849	3967	19073188	2008-04-26	2008-04-26 00:00:00	2008-05-10	2008-05-10 00:00:00	2008-05-10	38000177		0	0	14		0	0	0	263714	0	308192	19073188		
23548	1937	40236824	2009-07-12	2009-07-12 00:00:00	2009-07-19	2009-07-19 00:00:00	2009-07-19	38000177		0	0	7		0	0	0	128908	0	1094107	40236824		
95317	2090	40213227	2009-05-27	2009-05-27 00:00:00	2009-05-27	2009-05-27 00:00:00	2009-05-27	581452		0	0	0		0	0	0	139419	0	113	40213227		
43779	3626	19019979	1977-02-05	1977-02-05 00:00:00	1977-02-19	1977-02-19 00:00:00	1977-02-19	38000177		0	0	14		0	0	0	241132	0	198405	19019979		
117643	2586	40213296	2011-08-21	2011-08-21 00:00:00	2011-08-21	2011-08-21 00:00:00	2011-08-21	581452		0	0	0		0	0	0	171135	0	52	40213296		
57406	4761	1127078	1983-11-16	1983-11-16 00:00:00	1984-02-14	1984-02-14 00:00:00	1984-02-14	38000177		0	0	90		0	0	0	317235	0	282464	1127078		
23873	1966	1127078	1965-07-03	1965-07-03 00:00:00	1965-07-17	1965-07-17 00:00:00	1965-07-17	38000177		0	0	14		0	0	0	130707	0	282464	1127078		
51049	4240	1127433	1981-11-21	1981-11-21 00:00:00	1981-12-05	1981-12-05 00:00:00	1981-12-05	38000177		0	0	14		0	0	0	281593	0	313782	1127433		
51089	4243	1127433	2015-05-11	2015-05-11 00:00:00	2015-05-18	2015-05-18 00:00:00	2015-05-18	38000177		0	0	7		0	0	0	281861	0	313782	1127433		
170204	3742	40213160	1975-07-25	1975-07-25 00:00:00	1975-07-25	1975-07-25 00:00:00	1975-07-25	581452		0	0	0		0	0	0	248688	0	10	40213160		
26356	2168	19059056	1959-07-30	1959-07-30 00:00:00	1959-09-28	1959-09-28 00:00:00	1959-09-28	38000177		0	0	60		0	0	0	144573	0	243670	19059056		
140355	3082	40213260	2015-08-05	2015-08-05 00:00:00	2015-08-05	2015-08-05 00:00:00	2015-08-05	581452		0	0	0		0	0	0	205215	0	121	40213260		
45077	3730	19059056	1954-09-28	1954-09-28 00:00:00	1954-10-12	1954-10-12 00:00:00	1954-10-12	38000177		0	0	14		0	0	0	247879	0	243670	19059056		
11672	250	40213160	1974-10-23	1974-10-23 00:00:00	1974-10-23	1974-10-23 00:00:00	1974-10-23	581452		0	0	0		0	0	0	16787	0	10	40213160		
142367	3128	40213296	2015-08-04	2015-08-04 00:00:00	2015-08-04	2015-08-04 00:00:00	2015-08-04	581452		0	0	0		0	0	0	208123	0	52	40213296		
142451	3129	40213160	1972-01-25	1972-01-25 00:00:00	1972-01-25	1972-01-25 00:00:00	1972-01-25	581452		0	0	0		0	0	0	208237	0	10	40213160		
131469	2889	40213260	2010-03-21	2010-03-21 00:00:00	2010-03-21	2010-03-21 00:00:00	2010-03-21	581452		0	0	0		0	0	0	192138	0	121	40213260		
214394	4701	40213160	1975-06-13	1975-06-13 00:00:00	1975-06-13	1975-06-13 00:00:00	1975-06-13	581452		0	0	0		0	0	0	\N	0	10	40213160		
172649	3795	40213227	1995-04-18	1995-04-18 00:00:00	1995-04-18	1995-04-18 00:00:00	1995-04-18	581452		0	0	0		0	0	0	252346	0	113	40213227		
28930	2392	19059056	1937-09-02	1937-09-02 00:00:00	1937-09-16	1937-09-16 00:00:00	1937-09-16	38000177		0	0	14		0	0	0	159009	0	243670	19059056		
142539	3132	40213160	1963-12-15	1963-12-15 00:00:00	1963-12-15	1963-12-15 00:00:00	1963-12-15	581452		0	0	0		0	0	0	208405	0	10	40213160		
115077	2528	40213306	1990-07-11	1990-07-11 00:00:00	1990-07-11	1990-07-11 00:00:00	1990-07-11	581452		0	0	0		0	0	0	167118	0	43	40213306		
210488	4615	40213260	2007-09-12	2007-09-12 00:00:00	2007-09-12	2007-09-12 00:00:00	2007-09-12	581452		0	0	0		0	0	0	307417	0	121	40213260		
57491	4771	1127433	1971-06-17	1971-06-17 00:00:00	1971-07-15	1971-07-15 00:00:00	1971-07-15	38000177		0	0	28		0	0	0	317772	0	313782	1127433		
13003	1092	1127433	2017-05-04	2017-05-04 00:00:00	2017-05-18	2017-05-18 00:00:00	2017-05-18	38000177		0	0	14		0	0	0	71802	0	313782	1127433		
18544	1533	1127433	2016-09-29	2016-09-29 00:00:00	2016-10-06	2016-10-06 00:00:00	2016-10-06	38000177		0	0	7		0	0	0	102662	0	313782	1127433		
236353	5190	40213160	1961-11-10	1961-11-10 00:00:00	1961-11-10	1961-11-10 00:00:00	1961-11-10	581452		0	0	0		0	0	0	345000	0	10	40213160		
29078	2406	1127433	1949-01-08	1949-01-08 00:00:00	1949-01-15	1949-01-15 00:00:00	1949-01-15	38000177		0	0	7		0	0	0	159829	0	313782	1127433		
186239	4091	40213160	1968-08-04	1968-08-04 00:00:00	1968-08-04	1968-08-04 00:00:00	1968-08-04	581452		0	0	0		0	0	0	271996	0	10	40213160		
234489	5151	40213260	2007-12-07	2007-12-07 00:00:00	2007-12-07	2007-12-07 00:00:00	2007-12-07	581452		0	0	0		0	0	0	342531	0	121	40213260		
56138	4661	1118084	2018-02-21	2018-02-21 00:00:00	2018-02-21	2018-02-21 00:00:00	\N	38000177		0	0	0		0	0	0	310685	0	00025152531	44923712		
2060	162	19078461	1978-03-14	1978-03-14 00:00:00	1978-03-28	1978-03-28 00:00:00	1978-03-28	38000177		0	0	14		0	0	0	11167	0	310965	19078461		
34300	2834	40229134	1970-06-10	1970-06-10 00:00:00	1970-06-24	1970-06-24 00:00:00	1970-06-24	38000177		0	0	14		0	0	0	188186	0	1043400	40229134		
47296	1032	40213201	2017-12-17	2017-12-17 00:00:00	2017-12-17	2017-12-17 00:00:00	2017-12-17	581452		0	0	0		0	0	0	67897	0	33	40213201		
50323	4176	19075601	2003-10-23	2003-10-23 00:00:00	2003-10-23	2003-10-23 00:00:00	2003-10-23	38000177		0	0	0		0	0	0	277487	0	309362	19075601		
129315	2844	40213198	2013-06-03	2013-06-03 00:00:00	2013-06-03	2013-06-03 00:00:00	2013-06-03	581452		0	0	0		0	0	0	188878	0	133	40213198		
92630	2033	40213160	1956-05-01	1956-05-01 00:00:00	1956-05-01	1956-05-01 00:00:00	1956-05-01	581452		0	0	0		0	0	0	135301	0	10	40213160		
25850	564	40213296	1996-10-31	1996-10-31 00:00:00	1996-10-31	1996-10-31 00:00:00	1996-10-31	581452		0	0	0		0	0	0	37379	0	52	40213296		
16137	1338	19006318	1956-07-06	1956-07-06 00:00:00	1956-07-20	1956-07-20 00:00:00	1956-07-20	38000177		0	0	14		0	0	0	88702	0	105078	19006318		
172250	3787	40213227	2003-03-15	2003-03-15 00:00:00	2003-03-15	2003-03-15 00:00:00	2003-03-15	581452		0	0	0		0	0	0	251746	0	113	40213227		
51676	1132	40213160	1958-04-14	1958-04-14 00:00:00	1958-04-14	1958-04-14 00:00:00	1958-04-14	581452		0	0	0		0	0	0	74557	0	10	40213160		
16557	358	40213227	1992-04-07	1992-04-07 00:00:00	1992-04-07	1992-04-07 00:00:00	1992-04-07	581452		0	0	0		0	0	0	23840	0	113	40213227		
78560	1719	40213296	1997-04-15	1997-04-15 00:00:00	1997-04-15	1997-04-15 00:00:00	1997-04-15	581452		0	0	0		0	0	0	114968	0	52	40213296		
26834	2210	1713671	1948-03-28	1948-03-28 00:00:00	1948-04-04	1948-04-04 00:00:00	1948-04-04	38000177		0	0	7		0	0	0	147262	0	562251	1713671		
232227	5103	40213227	2015-02-09	2015-02-09 00:00:00	2015-02-09	2015-02-09 00:00:00	2015-02-09	581452		0	0	0		0	0	0	339058	0	113	40213227		
52049	4329	920300	2008-05-10	2008-05-10 00:00:00	2008-05-17	2008-05-17 00:00:00	2008-05-17	38000177		0	0	7		0	0	0	287123	0	311989	920300		
28027	610	40213296	2005-02-17	2005-02-17 00:00:00	2005-02-17	2005-02-17 00:00:00	2005-02-17	581452		0	0	0		0	0	0	40563	0	52	40213296		
18688	1543	1127433	1971-07-21	1971-07-21 00:00:00	1971-07-28	1971-07-28 00:00:00	1971-07-28	38000177		0	0	7		0	0	0	103376	0	313782	1127433		
18827	408	40213306	1983-06-29	1983-06-29 00:00:00	1983-06-29	1983-06-29 00:00:00	1983-06-29	581452		0	0	0		0	0	0	27003	0	43	40213306		
240344	5276	40213260	2008-12-21	2008-12-21 00:00:00	2008-12-21	2008-12-21 00:00:00	2008-12-21	581452		0	0	0		0	0	0	350954	0	121	40213260		
4239	350	19059056	1970-11-03	1970-11-03 00:00:00	1971-02-01	1971-02-01 00:00:00	1971-02-01	38000177		0	0	90		0	0	0	23290	0	243670	19059056		
10458	871	1127433	2001-09-03	2001-09-03 00:00:00	2001-09-10	2001-09-10 00:00:00	2001-09-10	38000177		0	0	7		0	0	0	57933	0	313782	1127433		
51965	1137	40213160	1956-08-24	1956-08-24 00:00:00	1956-08-24	1956-08-24 00:00:00	1956-08-24	581452		0	0	0		0	0	0	74901	0	10	40213160		
43869	3633	19019979	1979-10-03	1979-10-03 00:00:00	1980-01-01	1980-01-01 00:00:00	1980-01-01	38000177		0	0	90		0	0	0	241652	0	198405	19019979		
43920	3638	19129655	1968-06-04	1968-06-04 00:00:00	1968-06-18	1968-06-18 00:00:00	1968-06-18	38000177		0	0	14		0	0	0	241998	0	789980	19129655		
86943	1906	40213160	1961-02-18	1961-02-18 00:00:00	1961-02-18	1961-02-18 00:00:00	1961-02-18	581452		0	0	0		0	0	0	126914	0	10	40213160		
185945	4085	40213260	2008-10-04	2008-10-04 00:00:00	2008-10-04	2008-10-04 00:00:00	2008-10-04	581452		0	0	0		0	0	0	271550	0	121	40213260		
191892	4217	40213296	2000-03-15	2000-03-15 00:00:00	2000-03-15	2000-03-15 00:00:00	2000-03-15	581452		0	0	0		0	0	0	279919	0	52	40213296		
83320	1821	40213227	2019-03-10	2019-03-10 00:00:00	2019-03-10	2019-03-10 00:00:00	2019-03-10	581452		0	0	0		0	0	0	121872	0	113	40213227		
12848	1081	19133905	2018-04-25	2018-04-25 00:00:00	2018-05-07	2018-05-07 00:00:00	2018-05-07	38000177		0	0	12		0	0	0	70847	0	834102	19133905		
157029	3455	40213227	1994-03-28	1994-03-28 00:00:00	1994-03-28	1994-03-28 00:00:00	1994-03-28	581452		0	0	0		0	0	0	229222	0	113	40213227		
49307	4090	19075601	2015-08-03	2015-08-03 00:00:00	2015-08-03	2015-08-03 00:00:00	\N	38000177		0	0	0		0	0	0	271869	0	309362	19075601		
40658	3371	1127433	1999-08-11	1999-08-11 00:00:00	1999-08-18	1999-08-18 00:00:00	1999-08-18	38000177		0	0	7		0	0	0	223570	0	313782	1127433		
141768	3114	40213201	2012-12-19	2012-12-19 00:00:00	2012-12-19	2012-12-19 00:00:00	2012-12-19	581452		0	0	0		0	0	0	207175	0	33	40213201		
47850	3967	19078461	2008-04-26	2008-04-26 00:00:00	2008-05-10	2008-05-10 00:00:00	2008-05-10	38000177		0	0	14		0	0	0	263714	0	310965	19078461		
23549	1937	19059056	1968-10-14	1968-10-14 00:00:00	1968-11-13	1968-11-13 00:00:00	1968-11-13	38000177		0	0	30		0	0	0	128903	0	243670	19059056		
95318	2090	40213296	2009-05-27	2009-05-27 00:00:00	2009-05-27	2009-05-27 00:00:00	2009-05-27	581452		0	0	0		0	0	0	139419	0	52	40213296		
43780	3626	46233988	1977-02-05	1977-02-05 00:00:00	1977-02-19	1977-02-19 00:00:00	1977-02-19	38000177		0	0	14		0	0	0	241132	0	1652673	46233988		
131890	2898	40213160	1983-12-27	1983-12-27 00:00:00	1983-12-27	1983-12-27 00:00:00	1983-12-27	581452		0	0	0		0	0	0	193019	0	10	40213160		
57407	4761	1127433	1989-12-31	1989-12-31 00:00:00	1990-01-14	1990-01-14 00:00:00	1990-01-14	38000177		0	0	14		0	0	0	317214	0	313782	1127433		
23874	1966	19006318	1966-10-02	1966-10-02 00:00:00	1966-10-16	1966-10-16 00:00:00	1966-10-16	38000177		0	0	14		0	0	0	130705	0	105078	19006318		
51050	4240	1127433	1981-05-26	1981-05-26 00:00:00	1981-06-09	1981-06-09 00:00:00	1981-06-09	38000177		0	0	14		0	0	0	281627	0	313782	1127433		
51090	4243	46233988	1969-02-12	1969-02-12 00:00:00	1969-02-26	1969-02-26 00:00:00	1969-02-26	38000177		0	0	14		0	0	0	281831	0	1652673	46233988		
170208	3742	40213160	1971-01-22	1971-01-22 00:00:00	1971-01-22	1971-01-22 00:00:00	1971-01-22	581452		0	0	0		0	0	0	248672	0	10	40213160		
26357	2168	19133905	1980-08-19	1980-08-19 00:00:00	1980-08-28	1980-08-28 00:00:00	1980-08-28	38000177		0	0	9		0	0	0	144409	0	834102	19133905		
140358	3082	40213227	2007-08-15	2007-08-15 00:00:00	2007-08-15	2007-08-15 00:00:00	2007-08-15	581452		0	0	0		0	0	0	205221	0	113	40213227		
45078	3730	1127433	1980-04-14	1980-04-14 00:00:00	1980-05-19	1980-05-19 00:00:00	1980-05-19	38000177		0	0	35		0	0	0	247806	0	313782	1127433		
11674	250	40213160	1974-05-22	1974-05-22 00:00:00	1974-05-22	1974-05-22 00:00:00	1974-05-22	581452		0	0	0		0	0	0	16786	0	10	40213160		
142369	3128	40213227	2015-08-04	2015-08-04 00:00:00	2015-08-04	2015-08-04 00:00:00	2015-08-04	581452		0	0	0		0	0	0	208123	0	113	40213227		
79199	1733	40213306	2004-03-17	2004-03-17 00:00:00	2004-03-17	2004-03-17 00:00:00	2004-03-17	581452		0	0	0		0	0	0	115853	0	43	40213306		
131477	2889	40213306	1982-03-21	1982-03-21 00:00:00	1982-03-21	1982-03-21 00:00:00	1982-03-21	581452		0	0	0		0	0	0	192159	0	43	40213306		
214397	4701	40213296	2010-12-03	2010-12-03 00:00:00	2010-12-03	2010-12-03 00:00:00	2010-12-03	581452		0	0	0		0	0	0	313197	0	52	40213296		
172650	3795	40213306	1995-04-18	1995-04-18 00:00:00	1995-04-18	1995-04-18 00:00:00	1995-04-18	581452		0	0	0		0	0	0	252346	0	43	40213306		
28931	2392	1127433	1942-09-17	1942-09-17 00:00:00	1942-10-01	1942-10-01 00:00:00	1942-10-01	38000177		0	0	14		0	0	0	159039	0	313782	1127433		
142551	3132	40213227	2014-07-13	2014-07-13 00:00:00	2014-07-13	2014-07-13 00:00:00	2014-07-13	581452		0	0	0		0	0	0	208419	0	113	40213227		
115079	2528	40213160	1968-08-28	1968-08-28 00:00:00	1968-08-28	1968-08-28 00:00:00	1968-08-28	581452		0	0	0		0	0	0	167093	0	10	40213160		
221784	4867	40213227	2005-08-17	2005-08-17 00:00:00	2005-08-17	2005-08-17 00:00:00	2005-08-17	581452		0	0	0		0	0	0	323650	0	113	40213227		
57492	4771	1713671	2006-06-28	2006-06-28 00:00:00	2006-07-12	2006-07-12 00:00:00	2006-07-12	38000177		0	0	14		0	0	0	317767	0	562251	1713671		
13004	1092	1127433	1972-07-19	1972-07-19 00:00:00	1972-08-16	1972-08-16 00:00:00	1972-08-16	38000177		0	0	28		0	0	0	71797	0	313782	1127433		
18545	1533	19128022	1989-11-29	1989-11-29 00:00:00	1990-11-24	1990-11-24 00:00:00	1990-11-24	38000177		0	0	360		0	0	0	102663	0	749785	19128022		
236357	5190	40213160	1957-03-08	1957-03-08 00:00:00	1957-03-08	1957-03-08 00:00:00	1957-03-08	581452		0	0	0		0	0	0	345008	0	10	40213160		
29079	2406	19006318	1947-04-11	1947-04-11 00:00:00	1947-04-25	1947-04-25 00:00:00	1947-04-25	38000177		0	0	14		0	0	0	159845	0	105078	19006318		
186243	4091	40213306	1990-01-28	1990-01-28 00:00:00	1990-01-28	1990-01-28 00:00:00	1990-01-28	581452		0	0	0		0	0	0	271980	0	43	40213306		
173466	3814	40213227	2007-01-28	2007-01-28 00:00:00	2007-01-28	2007-01-28 00:00:00	2007-01-28	581452		0	0	0		0	0	0	253386	0	113	40213227		
56139	4661	1713671	2012-12-02	2012-12-02 00:00:00	2012-12-09	2012-12-09 00:00:00	2012-12-09	38000177		0	0	7		0	0	0	310687	0	562251	1713671		
2061	162	1713671	1945-11-09	1945-11-09 00:00:00	1945-11-16	1945-11-16 00:00:00	1945-11-16	38000177		0	0	7		0	0	0	11094	0	562251	1713671		
34301	2834	1332419	1994-07-30	1994-07-30 00:00:00	1994-07-30	1994-07-30 00:00:00	\N	38000177		0	0	0		0	0	0	188177	0	197361	1332419		
14370	310	40213227	2011-01-22	2011-01-22 00:00:00	2011-01-22	2011-01-22 00:00:00	2011-01-22	581452		0	0	0		0	0	0	20581	0	113	40213227		
218468	4795	40213160	1970-10-14	1970-10-14 00:00:00	1970-10-14	1970-10-14 00:00:00	1970-10-14	581452		0	0	0		0	0	0	319016	0	10	40213160		
146459	3221	40213160	1967-09-16	1967-09-16 00:00:00	1967-09-16	1967-09-16 00:00:00	1967-09-16	581452		0	0	0		0	0	0	214053	0	10	40213160		
92640	2033	40213227	2002-05-28	2002-05-28 00:00:00	2002-05-28	2002-05-28 00:00:00	2002-05-28	581452		0	0	0		0	0	0	135308	0	113	40213227		
25852	564	40213227	1996-10-31	1996-10-31 00:00:00	1996-10-31	1996-10-31 00:00:00	1996-10-31	581452		0	0	0		0	0	0	37379	0	113	40213227		
16138	1338	19059056	1956-07-06	1956-07-06 00:00:00	1956-07-20	1956-07-20 00:00:00	1956-07-20	38000177		0	0	14		0	0	0	88702	0	243670	19059056		
172251	3787	40213296	2003-03-15	2003-03-15 00:00:00	2003-03-15	2003-03-15 00:00:00	2003-03-15	581452		0	0	0		0	0	0	251746	0	52	40213296		
51681	1132	40213160	1955-10-10	1955-10-10 00:00:00	1955-10-10	1955-10-10 00:00:00	1955-10-10	581452		0	0	0		0	0	0	74501	0	10	40213160		
236085	5185	40213227	2017-05-01	2017-05-01 00:00:00	2017-05-01	2017-05-01 00:00:00	2017-05-01	581452		0	0	0		0	0	0	344658	0	113	40213227		
78570	1719	40213227	2008-04-15	2008-04-15 00:00:00	2008-04-15	2008-04-15 00:00:00	2008-04-15	581452		0	0	0		0	0	0	114891	0	113	40213227		
26835	2210	1118084	1974-05-04	1974-05-04 00:00:00	1974-05-04	1974-05-04 00:00:00	\N	38000177		0	0	0		0	0	0	147238	0	00025152531	44923712		
232234	5103	40213227	2004-12-13	2004-12-13 00:00:00	2004-12-13	2004-12-13 00:00:00	2004-12-13	581452		0	0	0		0	0	0	339138	0	113	40213227		
52050	4329	40236824	2008-05-10	2008-05-10 00:00:00	2008-05-24	2008-05-24 00:00:00	2008-05-24	38000177		0	0	14		0	0	0	287123	0	1094107	40236824		
28028	610	40213160	1963-02-07	1963-02-07 00:00:00	1963-02-07	1963-02-07 00:00:00	1963-02-07	581452		0	0	0		0	0	0	40570	0	10	40213160		
18689	1543	19059056	1946-06-21	1946-06-21 00:00:00	1946-09-19	1946-09-19 00:00:00	1946-09-19	38000177		0	0	90		0	0	0	103421	0	243670	19059056		
18839	408	40213160	1961-09-13	1961-09-13 00:00:00	1961-09-13	1961-09-13 00:00:00	1961-09-13	581452		0	0	0		0	0	0	26970	0	10	40213160		
240350	5276	40213227	1999-11-28	1999-11-28 00:00:00	1999-11-28	1999-11-28 00:00:00	1999-11-28	581452		0	0	0		0	0	0	350869	0	113	40213227		
4240	351	1713671	1984-08-03	1984-08-03 00:00:00	1984-08-24	1984-08-24 00:00:00	1984-08-24	38000177		0	0	21		0	0	0	23410	0	562251	1713671		
20917	1724	1127433	2015-06-30	2015-06-30 00:00:00	2015-07-14	2015-07-14 00:00:00	2015-07-14	38000177		0	0	14		0	0	0	115326	0	313782	1127433		
51968	1137	40213160	1955-02-18	1955-02-18 00:00:00	1955-02-18	1955-02-18 00:00:00	1955-02-18	581452		0	0	0		0	0	0	74900	0	10	40213160		
43870	3634	1124300	2007-03-31	2007-03-31 00:00:00	2007-03-31	2007-03-31 00:00:00	\N	38000177		0	0	0		0	0	0	241725	0	00781178901	45011828		
43921	3638	1127433	1988-09-19	1988-09-19 00:00:00	1988-09-26	1988-09-26 00:00:00	1988-09-26	38000177		0	0	7		0	0	0	241990	0	313782	1127433		
86947	1906	40213296	2001-07-01	2001-07-01 00:00:00	2001-07-01	2001-07-01 00:00:00	2001-07-01	581452		0	0	0		0	0	0	126901	0	52	40213296		
185947	4085	40213160	1959-01-10	1959-01-10 00:00:00	1959-01-10	1959-01-10 00:00:00	1959-01-10	581452		0	0	0		0	0	0	271459	0	10	40213160		
191897	4217	40213296	2002-03-20	2002-03-20 00:00:00	2002-03-20	2002-03-20 00:00:00	2002-03-20	581452		0	0	0		0	0	0	279987	0	52	40213296		
83335	1821	40213227	2008-10-19	2008-10-19 00:00:00	2008-10-19	2008-10-19 00:00:00	2008-10-19	581452		0	0	0		0	0	0	121870	0	113	40213227		
12849	1081	1124300	2001-03-24	2001-03-24 00:00:00	2001-03-24	2001-03-24 00:00:00	\N	38000177		0	0	0		0	0	0	70895	0	00781178901	45011828		
149127	3279	40213227	2015-12-01	2015-12-01 00:00:00	2015-12-01	2015-12-01 00:00:00	2015-12-01	581452		0	0	0		0	0	0	217859	0	113	40213227		
49308	4090	1539411	2015-08-03	2015-08-03 00:00:00	2015-08-03	2015-08-03 00:00:00	\N	38000177		0	0	0		0	0	0	271869	0	312961	1539411		
40659	3371	19133873	1988-12-11	1988-12-11 00:00:00	1988-12-21	1988-12-21 00:00:00	1988-12-21	38000177		0	0	10		0	0	0	223606	0	834061	19133873		
153064	3370	40213227	2015-01-25	2015-01-25 00:00:00	2015-01-25	2015-01-25 00:00:00	2015-01-25	581452		0	0	0		0	0	0	223448	0	113	40213227		
47851	3967	40236824	2000-06-03	2000-06-03 00:00:00	2000-06-10	2000-06-10 00:00:00	2000-06-10	38000177		0	0	7		0	0	0	263742	0	1094107	40236824		
23550	1937	1127433	1979-07-10	1979-07-10 00:00:00	1979-07-31	1979-07-31 00:00:00	1979-07-31	38000177		0	0	21		0	0	0	128906	0	313782	1127433		
95327	2090	40213296	2007-05-23	2007-05-23 00:00:00	2007-05-23	2007-05-23 00:00:00	2007-05-23	581452		0	0	0		0	0	0	139359	0	52	40213296		
43781	3626	19128065	1991-03-04	1991-03-04 00:00:00	1992-02-27	1992-02-27 00:00:00	1992-02-27	38000177		0	0	360		0	0	0	241151	0	749882	19128065		
131899	2898	40213296	2019-01-22	2019-01-22 00:00:00	2019-01-22	2019-01-22 00:00:00	2019-01-22	581452		0	0	0		0	0	0	193030	0	52	40213296		
57408	4761	1127433	2014-06-19	2014-06-19 00:00:00	2014-06-26	2014-06-26 00:00:00	2014-06-26	38000177		0	0	7		0	0	0	317325	0	313782	1127433		
23875	1966	19059056	1966-10-02	1966-10-02 00:00:00	1966-10-16	1966-10-16 00:00:00	1966-10-16	38000177		0	0	14		0	0	0	130705	0	243670	19059056		
51051	4240	1127433	1973-03-10	1973-03-10 00:00:00	1973-03-24	1973-03-24 00:00:00	1973-03-24	38000177		0	0	14		0	0	0	281635	0	313782	1127433		
51091	4243	19059056	1969-02-12	1969-02-12 00:00:00	1969-02-26	1969-02-26 00:00:00	1969-02-26	38000177		0	0	14		0	0	0	281831	0	243670	19059056		
170220	3743	40213314	1978-10-22	1978-10-22 00:00:00	1978-10-22	1978-10-22 00:00:00	1978-10-22	581452		0	0	0		0	0	0	248720	0	49	40213314		
26358	2168	1127078	1962-10-17	1962-10-17 00:00:00	1962-11-07	1962-11-07 00:00:00	1962-11-07	38000177		0	0	21		0	0	0	144576	0	282464	1127078		
140359	3082	40213296	2007-08-15	2007-08-15 00:00:00	2007-08-15	2007-08-15 00:00:00	2007-08-15	581452		0	0	0		0	0	0	205221	0	52	40213296		
45079	3730	19073188	2011-06-06	2011-06-06 00:00:00	2011-07-11	2011-07-11 00:00:00	2011-07-11	38000177		0	0	35		0	0	0	247809	0	308192	19073188		
11679	250	40213306	1995-02-01	1995-02-01 00:00:00	1995-02-01	1995-02-01 00:00:00	1995-02-01	581452		0	0	0		0	0	0	16813	0	43	40213306		
142370	3128	40213160	1974-01-01	1974-01-01 00:00:00	1974-01-01	1974-01-01 00:00:00	1974-01-01	581452		0	0	0		0	0	0	208178	0	10	40213160		
79204	1733	40213227	2013-03-27	2013-03-27 00:00:00	2013-03-27	2013-03-27 00:00:00	2013-03-27	581452		0	0	0		0	0	0	115856	0	113	40213227		
131480	2890	40213160	1962-03-16	1962-03-16 00:00:00	1962-03-16	1962-03-16 00:00:00	1962-03-16	581452		0	0	0		0	0	0	192252	0	10	40213160		
214407	4701	40213227	1993-11-19	1993-11-19 00:00:00	1993-11-19	1993-11-19 00:00:00	1993-11-19	581452		0	0	0		0	0	0	313146	0	113	40213227		
172652	3795	40213160	1973-10-23	1973-10-23 00:00:00	1973-10-23	1973-10-23 00:00:00	1973-10-23	581452		0	0	0		0	0	0	252316	0	10	40213160		
28932	2392	19018935	1997-05-16	1997-05-16 00:00:00	1997-05-16	1997-05-16 00:00:00	\N	38000177		0	0	0		0	0	0	158971	0	197604	19018935		
142552	3132	40213260	2014-07-13	2014-07-13 00:00:00	2014-07-13	2014-07-13 00:00:00	2014-07-13	581452		0	0	0		0	0	0	208419	0	121	40213260		
115082	2528	40213227	2019-03-27	2019-03-27 00:00:00	2019-03-27	2019-03-27 00:00:00	2019-03-27	581452		0	0	0		0	0	0	167092	0	113	40213227		
217651	4776	40213160	1960-07-24	1960-07-24 00:00:00	1960-07-24	1960-07-24 00:00:00	1960-07-24	581452		0	0	0		0	0	0	318000	0	10	40213160		
57493	4771	1713671	1957-07-08	1957-07-08 00:00:00	1957-07-22	1957-07-22 00:00:00	1957-07-22	38000177		0	0	14		0	0	0	317736	0	562251	1713671		
13005	1092	1127078	1960-04-30	1960-04-30 00:00:00	1960-05-14	1960-05-14 00:00:00	1960-05-14	38000177		0	0	14		0	0	0	71759	0	282464	1127078		
18546	1533	19073188	2009-03-09	2009-03-09 00:00:00	2009-04-13	2009-04-13 00:00:00	2009-04-13	38000177		0	0	35		0	0	0	102691	0	308192	19073188		
236360	5190	40213296	1996-12-06	1996-12-06 00:00:00	1996-12-06	1996-12-06 00:00:00	1996-12-06	581452		0	0	0		0	0	0	345037	0	52	40213296		
29080	2406	19059056	1947-04-11	1947-04-11 00:00:00	1947-04-25	1947-04-25 00:00:00	1947-04-25	38000177		0	0	14		0	0	0	159845	0	243670	19059056		
186250	4091	40213296	2007-12-16	2007-12-16 00:00:00	2007-12-16	2007-12-16 00:00:00	2007-12-16	581452		0	0	0		0	0	0	272002	0	52	40213296		
173468	3814	40213227	1997-11-30	1997-11-30 00:00:00	1997-11-30	1997-11-30 00:00:00	1997-11-30	581452		0	0	0		0	0	0	253369	0	113	40213227		
56140	4661	1713671	1979-03-09	1979-03-09 00:00:00	1979-03-23	1979-03-23 00:00:00	1979-03-23	38000177		0	0	14		0	0	0	310668	0	562251	1713671		
2062	162	1713671	1964-08-13	1964-08-13 00:00:00	1964-08-20	1964-08-20 00:00:00	1964-08-20	38000177		0	0	7		0	0	0	11106	0	562251	1713671		
34302	2834	19059056	1938-11-30	1938-11-30 00:00:00	1938-12-14	1938-12-14 00:00:00	1938-12-14	38000177		0	0	14		0	0	0	188167	0	243670	19059056		
14385	310	40213227	2000-11-25	2000-11-25 00:00:00	2000-11-25	2000-11-25 00:00:00	2000-11-25	581452		0	0	0		0	0	0	20556	0	113	40213227		
218469	4795	40213260	2015-11-04	2015-11-04 00:00:00	2015-11-04	2015-11-04 00:00:00	2015-11-04	581452		0	0	0		0	0	0	319057	0	121	40213260		
146460	3221	40213160	1963-09-07	1963-09-07 00:00:00	1963-09-07	1963-09-07 00:00:00	1963-09-07	581452		0	0	0		0	0	0	214100	0	10	40213160		
92647	2033	40213160	1955-04-26	1955-04-26 00:00:00	1955-04-26	1955-04-26 00:00:00	1955-04-26	581452		0	0	0		0	0	0	135358	0	10	40213160		
25860	564	40213260	2006-07-20	2006-07-20 00:00:00	2006-07-20	2006-07-20 00:00:00	2006-07-20	581452		0	0	0		0	0	0	37357	0	121	40213260		
16139	1338	1118084	1978-08-09	1978-08-09 00:00:00	1978-08-09	1978-08-09 00:00:00	\N	38000177		0	0	0		0	0	0	88734	0	00025152531	44923712		
172255	3787	40213260	2012-04-07	2012-04-07 00:00:00	2012-04-07	2012-04-07 00:00:00	2012-04-07	581452		0	0	0		0	0	0	251770	0	121	40213260		
51691	1132	40213296	1997-05-19	1997-05-19 00:00:00	1997-05-19	1997-05-19 00:00:00	1997-05-19	581452		0	0	0		0	0	0	74545	0	52	40213296		
236090	5185	40213201	2001-10-22	2001-10-22 00:00:00	2001-10-22	2001-10-22 00:00:00	2001-10-22	581452		0	0	0		0	0	0	344621	0	33	40213201		
78571	1719	40213260	2008-04-15	2008-04-15 00:00:00	2008-04-15	2008-04-15 00:00:00	2008-04-15	581452		0	0	0		0	0	0	114891	0	121	40213260		
26836	2210	1713671	1973-05-07	1973-05-07 00:00:00	1973-05-14	1973-05-14 00:00:00	1973-05-14	38000177		0	0	7		0	0	0	147238	0	562251	1713671		
232237	5103	40213227	1994-10-17	1994-10-17 00:00:00	1994-10-17	1994-10-17 00:00:00	1994-10-17	581452		0	0	0		0	0	0	339076	0	113	40213227		
52051	4329	40224805	1994-03-19	1994-03-19 00:00:00	1995-03-14	1995-03-14 00:00:00	1995-03-14	38000177		0	0	360		0	0	0	287150	0	1000126	40224805		
28045	610	40213160	1963-05-09	1963-05-09 00:00:00	1963-05-09	1963-05-09 00:00:00	1963-05-09	581452		0	0	0		0	0	0	40544	0	10	40213160		
18690	1543	1539411	1991-09-08	1991-09-08 00:00:00	1991-09-08	1991-09-08 00:00:00	\N	38000177		0	0	0		0	0	0	103398	0	312961	1539411		
18852	409	40213201	2017-01-06	2017-01-06 00:00:00	2017-01-06	2017-01-06 00:00:00	2017-01-06	581452		0	0	0		0	0	0	27061	0	33	40213201		
240351	5276	40213296	1999-11-28	1999-11-28 00:00:00	1999-11-28	1999-11-28 00:00:00	1999-11-28	581452		0	0	0		0	0	0	350869	0	52	40213296		
4241	351	19128022	1996-10-30	1996-10-30 00:00:00	1997-10-25	1997-10-25 00:00:00	1997-10-25	38000177		0	0	360		0	0	0	23396	0	749785	19128022		
20918	1724	1713671	1979-09-26	1979-09-26 00:00:00	1979-10-17	1979-10-17 00:00:00	1979-10-17	38000177		0	0	21		0	0	0	115242	0	562251	1713671		
51970	1137	40213160	1955-08-19	1955-08-19 00:00:00	1955-08-19	1955-08-19 00:00:00	1955-08-19	581452		0	0	0		0	0	0	74961	0	10	40213160		
43871	3634	1115171	2000-11-12	2000-11-12 00:00:00	2000-11-26	2000-11-26 00:00:00	2000-11-26	38000177		0	0	14		0	0	0	241744	0	849574	1115171		
43924	3639	1713671	1948-12-26	1948-12-26 00:00:00	1949-01-09	1949-01-09 00:00:00	1949-01-09	38000177		0	0	14		0	0	0	242060	0	562251	1713671		
97458	2136	40213227	2010-06-12	2010-06-12 00:00:00	2010-06-12	2010-06-12 00:00:00	2010-06-12	581452		0	0	0		0	0	0	142288	0	113	40213227		
185952	4086	40213160	1973-05-10	1973-05-10 00:00:00	1973-05-10	1973-05-10 00:00:00	1973-05-10	581452		0	0	0		0	0	0	271563	0	10	40213160		
218188	4788	40213227	2007-02-04	2007-02-04 00:00:00	2007-02-04	2007-02-04 00:00:00	2007-02-04	581452		0	0	0		0	0	0	318657	0	113	40213227		
78815	1724	40213227	2011-06-06	2011-06-06 00:00:00	2011-06-06	2011-06-06 00:00:00	2011-06-06	581452		0	0	0		0	0	0	115309	0	113	40213227		
12851	1081	1127433	1977-12-09	1977-12-09 00:00:00	1977-12-23	1977-12-23 00:00:00	1977-12-23	38000177		0	0	14		0	0	0	70862	0	313782	1127433		
149134	3280	40213160	1955-07-21	1955-07-21 00:00:00	1955-07-21	1955-07-21 00:00:00	1955-07-21	581452		0	0	0		0	0	0	218023	0	10	40213160		
49309	4090	1332419	2015-08-03	2015-08-03 00:00:00	2015-08-03	2015-08-03 00:00:00	\N	38000177		0	0	0		0	0	0	271869	0	197361	1332419		
40660	3371	19073183	1979-04-15	1979-04-15 00:00:00	1979-04-29	1979-04-29 00:00:00	1979-04-29	38000177		0	0	14		0	0	0	223651	0	308182	19073183		
153065	3370	40213296	2015-01-25	2015-01-25 00:00:00	2015-01-25	2015-01-25 00:00:00	2015-01-25	581452		0	0	0		0	0	0	223448	0	52	40213296		
47852	3967	920300	2000-06-03	2000-06-03 00:00:00	2000-06-10	2000-06-10 00:00:00	2000-06-10	38000177		0	0	7		0	0	0	263742	0	311989	920300		
23551	1937	40229134	1980-12-12	1980-12-12 00:00:00	1980-12-26	1980-12-26 00:00:00	1980-12-26	38000177		0	0	14		0	0	0	128873	0	1043400	40229134		
95332	2090	40213306	1988-08-03	1988-08-03 00:00:00	1988-08-03	1988-08-03 00:00:00	1988-08-03	581452		0	0	0		0	0	0	139417	0	43	40213306		
43782	3626	1713671	2014-03-17	2014-03-17 00:00:00	2014-03-31	2014-03-31 00:00:00	2014-03-31	38000177		0	0	14		0	0	0	241140	0	562251	1713671		
131904	2898	40213227	2001-11-20	2001-11-20 00:00:00	2001-11-20	2001-11-20 00:00:00	2001-11-20	581452		0	0	0		0	0	0	193027	0	113	40213227		
57409	4761	19059056	1989-11-14	1989-11-14 00:00:00	1989-12-14	1989-12-14 00:00:00	1989-12-14	38000177		0	0	30		0	0	0	317236	0	243670	19059056		
23876	1966	1127433	2013-07-12	2013-07-12 00:00:00	2013-07-26	2013-07-26 00:00:00	2013-07-26	38000177		0	0	14		0	0	0	130673	0	313782	1127433		
51052	4240	19077572	2018-12-24	2018-12-24 00:00:00	2018-12-24	2018-12-24 00:00:00	\N	38000177		0	0	0		0	0	0	281589	0	310436	19077572		
51092	4243	1118084	2007-09-26	2007-09-26 00:00:00	2007-09-26	2007-09-26 00:00:00	\N	38000177		0	0	0		0	0	0	281812	0	00025152531	44923712		
170226	3743	40213227	2008-11-30	2008-11-30 00:00:00	2008-11-30	2008-11-30 00:00:00	2008-11-30	581452		0	0	0		0	0	0	248730	0	113	40213227		
26359	2168	1713671	1976-03-31	1976-03-31 00:00:00	1976-04-21	1976-04-21 00:00:00	1976-04-21	38000177		0	0	21		0	0	0	144457	0	562251	1713671		
140363	3082	40213227	1997-05-28	1997-05-28 00:00:00	1997-05-28	1997-05-28 00:00:00	1997-05-28	581452		0	0	0		0	0	0	205218	0	113	40213227		
45080	3730	1127433	2011-06-06	2011-06-06 00:00:00	2011-07-11	2011-07-11 00:00:00	2011-07-11	38000177		0	0	35		0	0	0	247809	0	313782	1127433		
11685	250	40213296	2014-02-19	2014-02-19 00:00:00	2014-02-19	2014-02-19 00:00:00	2014-02-19	581452		0	0	0		0	0	0	16815	0	52	40213296		
142374	3128	40213160	1978-07-04	1978-07-04 00:00:00	1978-07-04	1978-07-04 00:00:00	1978-07-04	581452		0	0	0		0	0	0	208180	0	10	40213160		
79205	1733	40213314	1981-07-29	1981-07-29 00:00:00	1981-07-29	1981-07-29 00:00:00	1981-07-29	581452		0	0	0		0	0	0	115816	0	49	40213314		
162239	3568	40213227	2011-06-09	2011-06-09 00:00:00	2011-06-09	2011-06-09 00:00:00	2011-06-09	581452		0	0	0		0	0	0	237086	0	113	40213227		
214408	4701	40213306	1993-11-19	1993-11-19 00:00:00	1993-11-19	1993-11-19 00:00:00	1993-11-19	581452		0	0	0		0	0	0	313146	0	43	40213306		
230055	5056	40213227	2009-11-19	2009-11-19 00:00:00	2009-11-19	2009-11-19 00:00:00	2009-11-19	581452		0	0	0		0	0	0	336195	0	113	40213227		
28933	2392	40163554	1997-05-16	1997-05-16 00:00:00	1997-05-16	1997-05-16 00:00:00	\N	38000177		0	0	0		0	0	0	158971	0	855332	40163554		
142562	3132	40213306	1985-10-20	1985-10-20 00:00:00	1985-10-20	1985-10-20 00:00:00	1985-10-20	581452		0	0	0		0	0	0	208424	0	43	40213306		
125454	2760	40213160	1957-07-04	1957-07-04 00:00:00	1957-07-04	1957-07-04 00:00:00	1957-07-04	581452		0	0	0		0	0	0	182601	0	10	40213160		
217654	4776	40213160	1960-09-25	1960-09-25 00:00:00	1960-09-25	1960-09-25 00:00:00	1960-09-25	581452		0	0	0		0	0	0	318008	0	10	40213160		
57494	4771	40236824	1981-03-25	1981-03-25 00:00:00	1981-04-08	1981-04-08 00:00:00	1981-04-08	38000177		0	0	14		0	0	0	317775	0	1094107	40236824		
13006	1092	1118084	1992-10-20	1992-10-20 00:00:00	1992-10-20	1992-10-20 00:00:00	\N	38000177		0	0	0		0	0	0	71778	0	00025152531	44923712		
18547	1533	40165015	2009-03-09	2009-03-09 00:00:00	2009-03-09	2009-03-09 00:00:00	\N	38000177		0	0	0		0	0	0	102691	0	861467	40165015		
236366	5190	40213160	1957-08-09	1957-08-09 00:00:00	1957-08-09	1957-08-09 00:00:00	1957-08-09	581452		0	0	0		0	0	0	345046	0	10	40213160		
29081	2406	40243436	1961-05-11	1961-05-11 00:00:00	1961-05-11	1961-05-11 00:00:00	1961-05-11	38000177		0	0	0		0	0	0	159828	0	1190795	40243436		
186253	4091	40213160	1968-03-03	1968-03-03 00:00:00	1968-03-03	1968-03-03 00:00:00	1968-03-03	581452		0	0	0		0	0	0	271995	0	10	40213160		
173469	3814	40213306	1997-11-30	1997-11-30 00:00:00	1997-11-30	1997-11-30 00:00:00	1997-11-30	581452		0	0	0		0	0	0	253369	0	43	40213306		
56141	4661	19019979	1983-06-10	1983-06-10 00:00:00	1983-06-24	1983-06-24 00:00:00	1983-06-24	38000177		0	0	14		0	0	0	310684	0	198405	19019979		
2063	162	1127433	1979-07-29	1979-07-29 00:00:00	1979-08-05	1979-08-05 00:00:00	1979-08-05	38000177		0	0	7		0	0	0	11162	0	313782	1127433		
7467	624	19078461	2011-07-17	2011-07-17 00:00:00	2011-09-15	2011-09-15 00:00:00	2011-09-15	38000177		0	0	60		0	0	0	41695	0	310965	19078461		
14399	310	40213198	2015-02-14	2015-02-14 00:00:00	2015-02-14	2015-02-14 00:00:00	2015-02-14	581452		0	0	0		0	0	0	20578	0	133	40213198		
218471	4795	40213160	1966-04-13	1966-04-13 00:00:00	1966-04-13	1966-04-13 00:00:00	1966-04-13	581452		0	0	0		0	0	0	319040	0	10	40213160		
146462	3221	40213227	2014-06-07	2014-06-07 00:00:00	2014-06-07	2014-06-07 00:00:00	2014-06-07	581452		0	0	0		0	0	0	214078	0	113	40213227		
189292	4156	40213227	2017-08-28	2017-08-28 00:00:00	2017-08-28	2017-08-28 00:00:00	2017-08-28	581452		0	0	0		0	0	0	276195	0	113	40213227		
25863	564	40213160	1956-03-29	1956-03-29 00:00:00	1956-03-29	1956-03-29 00:00:00	1956-03-29	581452		0	0	0		0	0	0	37370	0	10	40213160		
16140	1338	1127433	2004-10-22	2004-10-22 00:00:00	2004-10-29	2004-10-29 00:00:00	2004-10-29	38000177		0	0	7		0	0	0	88691	0	313782	1127433		
172258	3787	40213227	1995-03-04	1995-03-04 00:00:00	1995-03-04	1995-03-04 00:00:00	1995-03-04	581452		0	0	0		0	0	0	251749	0	113	40213227		
51701	1132	40213160	1955-04-11	1955-04-11 00:00:00	1955-04-11	1955-04-11 00:00:00	1955-04-11	581452		0	0	0		0	0	0	74555	0	10	40213160		
236096	5185	40213227	2006-11-20	2006-11-20 00:00:00	2006-11-20	2006-11-20 00:00:00	2006-11-20	581452		0	0	0		0	0	0	344630	0	113	40213227		
78573	1719	40213227	1999-04-20	1999-04-20 00:00:00	1999-04-20	1999-04-20 00:00:00	1999-04-20	581452		0	0	0		0	0	0	114940	0	113	40213227		
26837	2210	1127433	1958-06-02	1958-06-02 00:00:00	1958-06-23	1958-06-23 00:00:00	1958-06-23	38000177		0	0	21		0	0	0	147196	0	313782	1127433		
34182	747	40213296	2006-07-29	2006-07-29 00:00:00	2006-07-29	2006-07-29 00:00:00	2006-07-29	581452		0	0	0		0	0	0	49465	0	52	40213296		
52052	4329	1127433	1981-10-16	1981-10-16 00:00:00	1981-10-29	1981-10-29 00:00:00	1981-10-29	38000177		0	0	13		0	0	0	287120	0	313782	1127433		
28049	610	40213296	2003-02-13	2003-02-13 00:00:00	2003-02-13	2003-02-13 00:00:00	2003-02-13	581452		0	0	0		0	0	0	40622	0	52	40213296		
18691	1543	1332419	1994-09-25	1994-09-25 00:00:00	1994-09-25	1994-09-25 00:00:00	\N	38000177		0	0	0		0	0	0	103389	0	197361	1332419		
18859	409	40213227	1992-10-16	1992-10-16 00:00:00	1992-10-16	1992-10-16 00:00:00	1992-10-16	581452		0	0	0		0	0	0	27127	0	113	40213227		
240353	5276	40213160	1958-09-28	1958-09-28 00:00:00	1958-09-28	1958-09-28 00:00:00	1958-09-28	581452		0	0	0		0	0	0	350882	0	10	40213160		
4242	351	40229134	2017-11-17	2017-11-17 00:00:00	2017-12-01	2017-12-01 00:00:00	2017-12-01	38000177		0	0	14		0	0	0	23416	0	1043400	40229134		
20919	1724	1124300	1992-11-15	1992-11-15 00:00:00	1992-11-15	1992-11-15 00:00:00	\N	38000177		0	0	0		0	0	0	115313	0	00781178901	45011828		
51977	1137	40213227	2012-11-16	2012-11-16 00:00:00	2012-11-16	2012-11-16 00:00:00	2012-11-16	581452		0	0	0		0	0	0	74915	0	113	40213227		
43872	3634	19133905	1995-07-13	1995-07-13 00:00:00	1995-07-25	1995-07-25 00:00:00	1995-07-25	38000177		0	0	12		0	0	0	241733	0	834102	19133905		
43925	3639	40229134	2002-09-06	2002-09-06 00:00:00	2002-09-20	2002-09-20 00:00:00	2002-09-20	38000177		0	0	14		0	0	0	242172	0	1043400	40229134		
97459	2136	40213296	2010-06-12	2010-06-12 00:00:00	2010-06-12	2010-06-12 00:00:00	2010-06-12	581452		0	0	0		0	0	0	142288	0	52	40213296		
185955	4086	40213160	1977-11-09	1977-11-09 00:00:00	1977-11-09	1977-11-09 00:00:00	1977-11-09	581452		0	0	0		0	0	0	271586	0	10	40213160		
218190	4788	40213314	1977-10-30	1977-10-30 00:00:00	1977-10-30	1977-10-30 00:00:00	1977-10-30	581452		0	0	0		0	0	0	318682	0	49	40213314		
78830	1724	40213227	2001-04-09	2001-04-09 00:00:00	2001-04-09	2001-04-09 00:00:00	2001-04-09	581452		0	0	0		0	0	0	115315	0	113	40213227		
12852	1081	1127433	1985-01-19	1985-01-19 00:00:00	1985-02-02	1985-02-02 00:00:00	1985-02-02	38000177		0	0	14		0	0	0	70844	0	313782	1127433		
149138	3280	40213198	2016-09-15	2016-09-15 00:00:00	2016-09-15	2016-09-15 00:00:00	2016-09-15	581452		0	0	0		0	0	0	\N	0	133	40213198		
49310	4090	19059056	1944-07-10	1944-07-10 00:00:00	1944-07-24	1944-07-24 00:00:00	1944-07-24	38000177		0	0	14		0	0	0	271859	0	243670	19059056		
40661	3371	19059056	1979-04-15	1979-04-15 00:00:00	1979-04-29	1979-04-29 00:00:00	1979-04-29	38000177		0	0	14		0	0	0	223651	0	243670	19059056		
153068	3370	40213160	1977-09-04	1977-09-04 00:00:00	1977-09-04	1977-09-04 00:00:00	1977-09-04	581452		0	0	0		0	0	0	223515	0	10	40213160		
47853	3967	1127433	2018-06-17	2018-06-17 00:00:00	2018-07-01	2018-07-01 00:00:00	2018-07-01	38000177		0	0	14		0	0	0	263776	0	313782	1127433		
23552	1937	19059056	1969-12-08	1969-12-08 00:00:00	1969-12-22	1969-12-22 00:00:00	1969-12-22	38000177		0	0	14		0	0	0	128904	0	243670	19059056		
95333	2090	40213160	1966-11-09	1966-11-09 00:00:00	1966-11-09	1966-11-09 00:00:00	1966-11-09	581452		0	0	0		0	0	0	139362	0	10	40213160		
66099	1446	40213180	2006-01-03	2006-01-03 00:00:00	2006-01-03	2006-01-03 00:00:00	2006-01-03	581452		0	0	0		0	0	0	96413	0	114	40213180		
131905	2898	40213306	2001-11-20	2001-11-20 00:00:00	2001-11-20	2001-11-20 00:00:00	2001-11-20	581452		0	0	0		0	0	0	193027	0	43	40213306		
57410	4761	1115171	2008-03-23	2008-03-23 00:00:00	2008-04-13	2008-04-13 00:00:00	2008-04-13	38000177		0	0	21		0	0	0	317240	0	849574	1115171		
23877	1966	1124300	2000-04-05	2000-04-05 00:00:00	2000-04-05	2000-04-05 00:00:00	\N	38000177		0	0	0		0	0	0	130699	0	00781178901	45011828		
51053	4240	19059056	1943-06-11	1943-06-11 00:00:00	1943-07-16	1943-07-16 00:00:00	1943-07-16	38000177		0	0	35		0	0	0	281590	0	243670	19059056		
51093	4243	1127433	1993-11-06	1993-11-06 00:00:00	1993-11-20	1993-11-20 00:00:00	1993-11-20	38000177		0	0	14		0	0	0	281851	0	313782	1127433		
170228	3743	40213160	1978-04-23	1978-04-23 00:00:00	1978-04-23	1978-04-23 00:00:00	1978-04-23	581452		0	0	0		0	0	0	248699	0	10	40213160		
26360	2168	1127433	1988-10-10	1988-10-10 00:00:00	1988-10-31	1988-10-31 00:00:00	1988-10-31	38000177		0	0	21		0	0	0	144584	0	313782	1127433		
140365	3082	40213306	1989-03-15	1989-03-15 00:00:00	1989-03-15	1989-03-15 00:00:00	1989-03-15	581452		0	0	0		0	0	0	205217	0	43	40213306		
45081	3730	40236824	2005-05-29	2005-05-29 00:00:00	2005-06-05	2005-06-05 00:00:00	2005-06-05	38000177		0	0	7		0	0	0	247848	0	1094107	40236824		
202930	4454	40213227	2001-04-28	2001-04-28 00:00:00	2001-04-28	2001-04-28 00:00:00	2001-04-28	581452		0	0	0		0	0	0	296376	0	113	40213227		
142376	3128	40213314	1977-06-21	1977-06-21 00:00:00	1977-06-21	1977-06-21 00:00:00	1977-06-21	581452		0	0	0		0	0	0	\N	0	49	40213314		
79206	1733	40213160	1981-07-29	1981-07-29 00:00:00	1981-07-29	1981-07-29 00:00:00	1981-07-29	581452		0	0	0		0	0	0	115816	0	10	40213160		
162245	3568	40213160	1969-11-06	1969-11-06 00:00:00	1969-11-06	1969-11-06 00:00:00	1969-11-06	581452		0	0	0		0	0	0	237088	0	10	40213160		
214411	4701	40213306	1991-02-08	1991-02-08 00:00:00	1991-02-08	1991-02-08 00:00:00	1991-02-08	581452		0	0	0		0	0	0	\N	0	43	40213306		
230059	5056	40213201	2004-10-21	2004-10-21 00:00:00	2004-10-21	2004-10-21 00:00:00	2004-10-21	581452		0	0	0		0	0	0	336135	0	33	40213201		
28934	2392	40171902	1997-05-16	1997-05-16 00:00:00	1997-05-16	1997-05-16 00:00:00	\N	38000177		0	0	0		0	0	0	158971	0	897718	40171902		
142564	3132	40213227	1994-10-30	1994-10-30 00:00:00	1994-10-30	1994-10-30 00:00:00	1994-10-30	581452		0	0	0		0	0	0	208439	0	113	40213227		
125456	2760	40213227	2018-10-11	2018-10-11 00:00:00	2018-10-11	2018-10-11 00:00:00	2018-10-11	581452		0	0	0		0	0	0	182587	0	113	40213227		
217658	4776	40213296	2004-01-18	2004-01-18 00:00:00	2004-01-18	2004-01-18 00:00:00	2004-01-18	581452		0	0	0		0	0	0	318037	0	52	40213296		
57495	4771	920300	1981-03-25	1981-03-25 00:00:00	1981-04-01	1981-04-01 00:00:00	1981-04-01	38000177		0	0	7		0	0	0	317775	0	311989	920300		
13007	1092	1713671	1994-01-13	1994-01-13 00:00:00	1994-01-27	1994-01-27 00:00:00	1994-01-27	38000177		0	0	14		0	0	0	71753	0	562251	1713671		
18548	1533	1115171	2009-03-09	2009-03-09 00:00:00	2009-04-13	2009-04-13 00:00:00	2009-04-13	38000177		0	0	35		0	0	0	102691	0	849574	1115171		
236371	5191	40213306	1993-01-28	1993-01-28 00:00:00	1993-01-28	1993-01-28 00:00:00	1993-01-28	581452		0	0	0		0	0	0	\N	0	43	40213306		
29082	2406	46275916	1961-05-11	1961-05-11 00:00:00	1961-05-11	1961-05-11 00:00:00	1961-05-11	38000177		0	0	0		0	0	0	159828	0	1660014	46275916		
186264	4092	40213227	2004-08-26	2004-08-26 00:00:00	2004-08-26	2004-08-26 00:00:00	2004-08-26	581452		0	0	0		0	0	0	272069	0	113	40213227		
173473	3814	40213227	2016-09-18	2016-09-18 00:00:00	2016-09-18	2016-09-18 00:00:00	2016-09-18	581452		0	0	0		0	0	0	253370	0	113	40213227		
56142	4661	19074843	1979-11-28	1979-11-28 00:00:00	1979-12-12	1979-12-12 00:00:00	1979-12-12	38000177		0	0	14		0	0	0	310688	0	309045	19074843		
2064	163	1127433	1975-07-12	1975-07-12 00:00:00	1975-07-26	1975-07-26 00:00:00	1975-07-26	38000177		0	0	14		0	0	0	11224	0	313782	1127433		
7468	624	40165015	2011-07-17	2011-07-17 00:00:00	2011-07-17	2011-07-17 00:00:00	\N	38000177		0	0	0		0	0	0	41695	0	861467	40165015		
14402	311	40213160	1982-07-06	1982-07-06 00:00:00	1982-07-06	1982-07-06 00:00:00	1982-07-06	581452		0	0	0		0	0	0	20612	0	10	40213160		
218476	4795	40213227	2016-11-09	2016-11-09 00:00:00	2016-11-09	2016-11-09 00:00:00	2016-11-09	581452		0	0	0		0	0	0	319034	0	113	40213227		
146463	3221	40213260	2014-06-07	2014-06-07 00:00:00	2014-06-07	2014-06-07 00:00:00	2014-06-07	581452		0	0	0		0	0	0	214078	0	121	40213260		
189294	4156	40213160	1956-10-01	1956-10-01 00:00:00	1956-10-01	1956-10-01 00:00:00	1956-10-01	581452		0	0	0		0	0	0	276213	0	10	40213160		
25868	564	40213227	2017-09-21	2017-09-21 00:00:00	2017-09-21	2017-09-21 00:00:00	2017-09-21	581452		0	0	0		0	0	0	37360	0	113	40213227		
16141	1338	1713671	2002-02-24	2002-02-24 00:00:00	2002-03-10	2002-03-10 00:00:00	2002-03-10	38000177		0	0	14		0	0	0	88690	0	562251	1713671		
172260	3787	40213260	2013-04-13	2013-04-13 00:00:00	2013-04-13	2013-04-13 00:00:00	2013-04-13	581452		0	0	0		0	0	0	251748	0	121	40213260		
56777	4712	1127433	2007-05-25	2007-05-25 00:00:00	2007-06-01	2007-06-01 00:00:00	2007-06-01	38000177		0	0	7		0	0	0	313787	0	313782	1127433		
7061	153	40213227	2014-10-09	2014-10-09 00:00:00	2014-10-09	2014-10-09 00:00:00	2014-10-09	581452		0	0	0		0	0	0	10331	0	113	40213227		
78574	1719	40213296	1999-04-20	1999-04-20 00:00:00	1999-04-20	1999-04-20 00:00:00	1999-04-20	581452		0	0	0		0	0	0	114940	0	52	40213296		
26838	2210	1127433	1943-03-25	1943-03-25 00:00:00	1943-04-01	1943-04-01 00:00:00	1943-04-01	38000177		0	0	7		0	0	0	147165	0	313782	1127433		
34185	747	40213227	2006-07-29	2006-07-29 00:00:00	2006-07-29	2006-07-29 00:00:00	2006-07-29	581452		0	0	0		0	0	0	49465	0	113	40213227		
52053	4329	19128065	1995-03-14	1995-03-14 00:00:00	1996-03-08	1996-03-08 00:00:00	1996-03-08	38000177		0	0	360		0	0	0	287152	0	749882	19128065		
28054	610	40213260	2012-08-30	2012-08-30 00:00:00	2012-08-30	2012-08-30 00:00:00	2012-08-30	581452		0	0	0		0	0	0	40623	0	121	40213260		
18692	1543	1124300	1981-03-29	1981-03-29 00:00:00	1981-03-29	1981-03-29 00:00:00	\N	38000177		0	0	0		0	0	0	103396	0	00781178901	45011828		
56600	4696	19073188	1989-08-12	1989-08-12 00:00:00	1989-08-26	1989-08-26 00:00:00	1989-08-26	38000177		0	0	14		0	0	0	312861	0	308192	19073188		
240363	5277	40213296	1998-08-12	1998-08-12 00:00:00	1998-08-12	1998-08-12 00:00:00	1998-08-12	581452		0	0	0		0	0	0	350978	0	52	40213296		
4243	351	19133873	1986-04-04	1986-04-04 00:00:00	1986-04-13	1986-04-13 00:00:00	1986-04-13	38000177		0	0	9		0	0	0	23340	0	834061	19133873		
20920	1724	19133905	2013-04-29	2013-04-29 00:00:00	2013-05-08	2013-05-08 00:00:00	2013-05-08	38000177		0	0	9		0	0	0	115281	0	834102	19133905		
138453	3041	40213160	1977-06-09	1977-06-09 00:00:00	1977-06-09	1977-06-09 00:00:00	1977-06-09	581452		0	0	0		0	0	0	202478	0	10	40213160		
43873	3634	1127078	1974-05-03	1974-05-03 00:00:00	1974-05-17	1974-05-17 00:00:00	1974-05-17	38000177		0	0	14		0	0	0	241707	0	282464	1127078		
43926	3639	19059056	1924-05-31	1924-05-31 00:00:00	1924-06-14	1924-06-14 00:00:00	1924-06-14	38000177		0	0	14		0	0	0	242040	0	243670	19059056		
97461	2136	40213227	2019-06-08	2019-06-08 00:00:00	2019-06-08	2019-06-08 00:00:00	2019-06-08	581452		0	0	0		0	0	0	142313	0	113	40213227		
185956	4086	40213314	1977-11-09	1977-11-09 00:00:00	1977-11-09	1977-11-09 00:00:00	1977-11-09	581452		0	0	0		0	0	0	271586	0	49	40213314		
218194	4788	40213160	1980-11-02	1980-11-02 00:00:00	1980-11-02	1980-11-02 00:00:00	1980-11-02	581452		0	0	0		0	0	0	318683	0	10	40213160		
78838	1724	40213227	1993-09-27	1993-09-27 00:00:00	1993-09-27	1993-09-27 00:00:00	1993-09-27	581452		0	0	0		0	0	0	115306	0	113	40213227		
2711	219	1127433	1985-06-18	1985-06-18 00:00:00	1985-07-18	1985-07-18 00:00:00	1985-07-18	38000177		0	0	30		0	0	0	14756	0	313782	1127433		
149144	3280	40213160	1955-01-20	1955-01-20 00:00:00	1955-01-20	1955-01-20 00:00:00	1955-01-20	581452		0	0	0		0	0	0	218048	0	10	40213160		
49311	4090	19059056	1944-10-27	1944-10-27 00:00:00	1944-11-10	1944-11-10 00:00:00	1944-11-10	38000177		0	0	14		0	0	0	271860	0	243670	19059056		
40662	3371	19129144	2003-05-30	2003-05-30 00:00:00	2004-05-24	2004-05-24 00:00:00	2004-05-24	38000177		0	0	360		0	0	0	223582	0	757594	19129144		
153070	3370	40213314	1977-09-04	1977-09-04 00:00:00	1977-09-04	1977-09-04 00:00:00	1977-09-04	581452		0	0	0		0	0	0	223515	0	49	40213314		
47854	3967	1127078	1965-09-02	1965-09-02 00:00:00	1965-09-16	1965-09-16 00:00:00	1965-09-16	38000177		0	0	14		0	0	0	263777	0	282464	1127078		
34031	2813	1127433	2002-08-10	2002-08-10 00:00:00	2002-08-24	2002-08-24 00:00:00	2002-08-24	38000177		0	0	14		0	0	0	186433	0	313782	1127433		
95334	2090	40213260	2016-07-06	2016-07-06 00:00:00	2016-07-06	2016-07-06 00:00:00	2016-07-06	581452		0	0	0		0	0	0	139420	0	121	40213260		
66100	1446	40213306	2006-01-03	2006-01-03 00:00:00	2006-01-03	2006-01-03 00:00:00	2006-01-03	581452		0	0	0		0	0	0	96413	0	43	40213306		
131907	2898	40213160	1979-09-25	1979-09-25 00:00:00	1979-09-25	1979-09-25 00:00:00	1979-09-25	581452		0	0	0		0	0	0	192977	0	10	40213160		
97125	2130	40213296	1999-05-27	1999-05-27 00:00:00	1999-05-27	1999-05-27 00:00:00	1999-05-27	581452		0	0	0		0	0	0	141688	0	52	40213296		
23878	1966	1127433	2019-04-20	2019-04-20 00:00:00	2019-05-04	2019-05-04 00:00:00	2019-05-04	38000177		0	0	14		0	0	0	130741	0	313782	1127433		
51054	4240	1115171	2010-10-04	2010-10-04 00:00:00	2010-12-03	2010-12-03 00:00:00	2010-12-03	38000177		0	0	60		0	0	0	281594	0	849574	1115171		
51094	4243	1713671	1999-05-31	1999-05-31 00:00:00	1999-06-14	1999-06-14 00:00:00	1999-06-14	38000177		0	0	14		0	0	0	281827	0	562251	1713671		
169923	3736	40213201	2017-10-25	2017-10-25 00:00:00	2017-10-25	2017-10-25 00:00:00	2017-10-25	581452		0	0	0		0	0	0	248353	0	33	40213201		
26361	2168	19059056	1960-08-23	1960-08-23 00:00:00	1960-09-27	1960-09-27 00:00:00	1960-09-27	38000177		0	0	35		0	0	0	144574	0	243670	19059056		
140368	3082	40213160	1965-11-10	1965-11-10 00:00:00	1965-11-10	1965-11-10 00:00:00	1965-11-10	581452		0	0	0		0	0	0	205205	0	10	40213160		
45082	3730	920300	2005-05-29	2005-05-29 00:00:00	2005-06-05	2005-06-05 00:00:00	2005-06-05	38000177		0	0	7		0	0	0	247848	0	311989	920300		
202939	4454	40213201	1985-12-14	1985-12-14 00:00:00	1985-12-14	1985-12-14 00:00:00	1985-12-14	581452		0	0	0		0	0	0	\N	0	33	40213201		
142377	3128	40213314	1977-06-28	1977-06-28 00:00:00	1977-06-28	1977-06-28 00:00:00	1977-06-28	581452		0	0	0		0	0	0	208090	0	49	40213314		
79208	1733	40213306	2001-03-14	2001-03-14 00:00:00	2001-03-14	2001-03-14 00:00:00	2001-03-14	581452		0	0	0		0	0	0	115852	0	43	40213306		
162253	3568	40213160	1970-02-05	1970-02-05 00:00:00	1970-02-05	1970-02-05 00:00:00	1970-02-05	581452		0	0	0		0	0	0	237077	0	10	40213160		
214414	4701	40213160	1971-03-05	1971-03-05 00:00:00	1971-03-05	1971-03-05 00:00:00	1971-03-05	581452		0	0	0		0	0	0	313167	0	10	40213160		
230069	5056	40213227	1999-04-22	1999-04-22 00:00:00	1999-04-22	1999-04-22 00:00:00	1999-04-22	581452		0	0	0		0	0	0	336166	0	113	40213227		
28935	2392	40229134	1960-01-22	1960-01-22 00:00:00	1960-01-29	1960-01-29 00:00:00	1960-01-29	38000177		0	0	7		0	0	0	159021	0	1043400	40229134		
142565	3132	40213160	1967-07-23	1967-07-23 00:00:00	1967-07-23	1967-07-23 00:00:00	1967-07-23	581452		0	0	0		0	0	0	208435	0	10	40213160		
125457	2760	40213260	2007-08-09	2007-08-09 00:00:00	2007-08-09	2007-08-09 00:00:00	2007-08-09	581452		0	0	0		0	0	0	182610	0	121	40213260		
217664	4776	40213160	1965-02-28	1965-02-28 00:00:00	1965-02-28	1965-02-28 00:00:00	1965-02-28	581452		0	0	0		0	0	0	\N	0	10	40213160		
57497	4771	19133873	1956-12-05	1956-12-05 00:00:00	1956-12-12	1956-12-12 00:00:00	1956-12-12	38000177		0	0	7		0	0	0	317755	0	834061	19133873		
13008	1092	19059056	1962-08-04	1962-08-04 00:00:00	1962-09-10	1962-09-10 00:00:00	1962-09-10	38000177		0	0	37		0	0	0	71796	0	243670	19059056		
18549	1533	40229134	2013-07-22	2013-07-22 00:00:00	2013-08-05	2013-08-05 00:00:00	2013-08-05	38000177		0	0	14		0	0	0	102649	0	1043400	40229134		
236373	5191	40213227	2002-11-14	2002-11-14 00:00:00	2002-11-14	2002-11-14 00:00:00	2002-11-14	581452		0	0	0		0	0	0	345085	0	113	40213227		
29083	2406	19133905	1975-05-30	1975-05-30 00:00:00	1975-06-10	1975-06-10 00:00:00	1975-06-10	38000177		0	0	11		0	0	0	159841	0	834102	19133905		
186265	4092	40213296	2015-04-23	2015-04-23 00:00:00	2015-04-23	2015-04-23 00:00:00	2015-04-23	581452		0	0	0		0	0	0	272043	0	52	40213296		
173474	3814	40213296	2016-09-18	2016-09-18 00:00:00	2016-09-18	2016-09-18 00:00:00	2016-09-18	581452		0	0	0		0	0	0	253370	0	52	40213296		
56143	4661	1127078	1979-11-28	1979-11-28 00:00:00	1979-12-12	1979-12-12 00:00:00	1979-12-12	38000177		0	0	14		0	0	0	310688	0	282464	1127078		
2065	163	40236824	2001-07-20	2001-07-20 00:00:00	2001-07-27	2001-07-27 00:00:00	2001-07-27	38000177		0	0	7		0	0	0	11178	0	1094107	40236824		
7469	624	1127433	1957-01-30	1957-01-30 00:00:00	1957-03-31	1957-03-31 00:00:00	1957-03-31	38000177		0	0	60		0	0	0	41689	0	313782	1127433		
14408	311	40213314	1977-11-01	1977-11-01 00:00:00	1977-11-01	1977-11-01 00:00:00	1977-11-01	581452		0	0	0		0	0	0	20638	0	49	40213314		
218477	4795	40213260	2016-11-09	2016-11-09 00:00:00	2016-11-09	2016-11-09 00:00:00	2016-11-09	581452		0	0	0		0	0	0	319034	0	121	40213260		
146465	3221	40213296	2005-06-25	2005-06-25 00:00:00	2005-06-25	2005-06-25 00:00:00	2005-06-25	581452		0	0	0		0	0	0	214107	0	52	40213296		
189297	4156	40213160	1957-03-04	1957-03-04 00:00:00	1957-03-04	1957-03-04 00:00:00	1957-03-04	581452		0	0	0		0	0	0	276164	0	10	40213160		
25870	565	40213160	1962-06-20	1962-06-20 00:00:00	1962-06-20	1962-06-20 00:00:00	1962-06-20	581452		0	0	0		0	0	0	37428	0	10	40213160		
16142	1338	1127433	1997-02-22	1997-02-22 00:00:00	1997-03-01	1997-03-01 00:00:00	1997-03-01	38000177		0	0	7		0	0	0	88688	0	313782	1127433		
172264	3787	40213227	2013-04-13	2013-04-13 00:00:00	2013-04-13	2013-04-13 00:00:00	2013-04-13	581452		0	0	0		0	0	0	251748	0	113	40213227		
56778	4712	19133873	1979-03-18	1979-03-18 00:00:00	1979-03-25	1979-03-25 00:00:00	1979-03-25	38000177		0	0	7		0	0	0	313746	0	834061	19133873		
7065	153	40213201	2009-09-10	2009-09-10 00:00:00	2009-09-10	2009-09-10 00:00:00	2009-09-10	581452		0	0	0		0	0	0	10357	0	33	40213201		
89859	1971	40213160	1969-11-21	1969-11-21 00:00:00	1969-11-21	1969-11-21 00:00:00	1969-11-21	581452		0	0	0		0	0	0	131032	0	10	40213160		
26839	2210	1713671	1985-10-15	1985-10-15 00:00:00	1985-10-29	1985-10-29 00:00:00	1985-10-29	38000177		0	0	14		0	0	0	147253	0	562251	1713671		
45471	992	40213198	2018-11-04	2018-11-04 00:00:00	2018-11-04	2018-11-04 00:00:00	2018-11-04	581452		0	0	0		0	0	0	65744	0	133	40213198		
52054	4329	40162522	2014-10-26	2014-10-26 00:00:00	2014-10-26	2014-10-26 00:00:00	\N	38000177		0	0	0		0	0	0	287103	0	857005	40162522		
28056	610	40213306	1985-01-17	1985-01-17 00:00:00	1985-01-17	1985-01-17 00:00:00	1985-01-17	581452		0	0	0		0	0	0	40611	0	43	40213306		
18693	1543	1713671	1988-09-12	1988-09-12 00:00:00	1988-09-26	1988-09-26 00:00:00	1988-09-26	38000177		0	0	14		0	0	0	103377	0	562251	1713671		
56601	4696	1127433	1989-08-12	1989-08-12 00:00:00	1989-08-26	1989-08-26 00:00:00	1989-08-26	38000177		0	0	14		0	0	0	312861	0	313782	1127433		
240377	5277	40213227	2016-07-06	2016-07-06 00:00:00	2016-07-06	2016-07-06 00:00:00	2016-07-06	581452		0	0	0		0	0	0	351019	0	113	40213227		
4244	351	40224805	2001-10-04	2001-10-04 00:00:00	2002-09-29	2002-09-29 00:00:00	2002-09-29	38000177		0	0	360		0	0	0	23364	0	1000126	40224805		
20921	1724	19133873	1952-08-29	1952-08-29 00:00:00	1952-09-08	1952-09-08 00:00:00	1952-09-08	38000177		0	0	10		0	0	0	115246	0	834061	19133873		
138454	3041	40213314	1977-06-09	1977-06-09 00:00:00	1977-06-09	1977-06-09 00:00:00	1977-06-09	581452		0	0	0		0	0	0	202478	0	49	40213314		
43874	3634	46233988	1974-05-03	1974-05-03 00:00:00	1974-05-17	1974-05-17 00:00:00	1974-05-17	38000177		0	0	14		0	0	0	241707	0	1652673	46233988		
43927	3639	1127433	1995-08-15	1995-08-15 00:00:00	1995-08-29	1995-08-29 00:00:00	1995-08-29	38000177		0	0	14		0	0	0	242034	0	313782	1127433		
97462	2136	40213260	2019-06-08	2019-06-08 00:00:00	2019-06-08	2019-06-08 00:00:00	2019-06-08	581452		0	0	0		0	0	0	142313	0	121	40213260		
185960	4086	40213296	2014-12-17	2014-12-17 00:00:00	2014-12-17	2014-12-17 00:00:00	2014-12-17	581452		0	0	0		0	0	0	271611	0	52	40213296		
218198	4788	40213227	2017-12-03	2017-12-03 00:00:00	2017-12-03	2017-12-03 00:00:00	2017-12-03	581452		0	0	0		0	0	0	318686	0	113	40213227		
130249	2863	40213160	1962-05-24	1962-05-24 00:00:00	1962-05-24	1962-05-24 00:00:00	1962-05-24	581452		0	0	0		0	0	0	190332	0	10	40213160		
2712	219	1127078	1979-07-15	1979-07-15 00:00:00	1979-08-19	1979-08-19 00:00:00	1979-08-19	38000177		0	0	35		0	0	0	14755	0	282464	1127078		
149153	3280	40213227	1993-09-23	1993-09-23 00:00:00	1993-09-23	1993-09-23 00:00:00	1993-09-23	581452		0	0	0		0	0	0	217971	0	113	40213227		
49312	4091	19059056	1970-09-11	1970-09-11 00:00:00	1970-09-25	1970-09-25 00:00:00	1970-09-25	38000177		0	0	14		0	0	0	271990	0	243670	19059056		
40663	3371	1127078	1979-08-19	1979-08-19 00:00:00	1979-09-02	1979-09-02 00:00:00	1979-09-02	38000177		0	0	14		0	0	0	223635	0	282464	1127078		
153072	3370	40213160	1972-12-31	1972-12-31 00:00:00	1972-12-31	1972-12-31 00:00:00	1972-12-31	581452		0	0	0		0	0	0	223474	0	10	40213160		
47855	3967	19006318	1965-09-02	1965-09-02 00:00:00	1965-09-16	1965-09-16 00:00:00	1965-09-16	38000177		0	0	14		0	0	0	263777	0	105078	19006318		
34032	2813	1118084	1967-11-01	1967-11-01 00:00:00	1967-11-01	1967-11-01 00:00:00	\N	38000177		0	0	0		0	0	0	186451	0	00025152531	44923712		
95340	2090	40213227	2017-07-12	2017-07-12 00:00:00	2017-07-12	2017-07-12 00:00:00	2017-07-12	581452		0	0	0		0	0	0	139399	0	113	40213227		
66101	1446	40213251	1985-01-08	1985-01-08 00:00:00	1985-01-08	1985-01-08 00:00:00	1985-01-08	581452		0	0	0		0	0	0	96406	0	21	40213251		
131909	2898	40213314	1979-04-24	1979-04-24 00:00:00	1979-04-24	1979-04-24 00:00:00	1979-04-24	581452		0	0	0		0	0	0	193064	0	49	40213314		
97127	2130	40213227	1999-05-27	1999-05-27 00:00:00	1999-05-27	1999-05-27 00:00:00	1999-05-27	581452		0	0	0		0	0	0	141688	0	113	40213227		
23879	1966	19059056	1984-05-08	1984-05-08 00:00:00	1984-05-22	1984-05-22 00:00:00	1984-05-22	38000177		0	0	14		0	0	0	130736	0	243670	19059056		
51055	4240	40165015	2010-10-04	2010-10-04 00:00:00	2010-10-04	2010-10-04 00:00:00	\N	38000177		0	0	0		0	0	0	281594	0	861467	40165015		
51095	4243	19006318	1969-12-23	1969-12-23 00:00:00	1970-01-06	1970-01-06 00:00:00	1970-01-06	38000177		0	0	14		0	0	0	281844	0	105078	19006318		
169926	3736	40213227	2001-12-12	2001-12-12 00:00:00	2001-12-12	2001-12-12 00:00:00	2001-12-12	581452		0	0	0		0	0	0	248284	0	113	40213227		
26362	2168	1127433	1967-01-20	1967-01-20 00:00:00	1967-02-03	1967-02-03 00:00:00	1967-02-03	38000177		0	0	14		0	0	0	144486	0	313782	1127433		
140371	3082	40213296	2005-08-10	2005-08-10 00:00:00	2005-08-10	2005-08-10 00:00:00	2005-08-10	581452		0	0	0		0	0	0	205193	0	52	40213296		
45083	3730	1713671	2004-10-03	2004-10-03 00:00:00	2004-10-10	2004-10-10 00:00:00	2004-10-10	38000177		0	0	7		0	0	0	247875	0	562251	1713671		
136075	2987	40213160	1972-10-02	1972-10-02 00:00:00	1972-10-02	1972-10-02 00:00:00	1972-10-02	581452		0	0	0		0	0	0	199396	0	10	40213160		
142378	3128	40213160	1973-10-30	1973-10-30 00:00:00	1973-10-30	1973-10-30 00:00:00	1973-10-30	581452		0	0	0		0	0	0	208133	0	10	40213160		
79215	1733	40213251	1984-01-25	1984-01-25 00:00:00	1984-01-25	1984-01-25 00:00:00	1984-01-25	581452		0	0	0		0	0	0	115817	0	21	40213251		
162256	3568	40213227	2000-07-20	2000-07-20 00:00:00	2000-07-20	2000-07-20 00:00:00	2000-07-20	581452		0	0	0		0	0	0	237062	0	113	40213227		
214416	4701	40213160	1971-08-06	1971-08-06 00:00:00	1971-08-06	1971-08-06 00:00:00	1971-08-06	581452		0	0	0		0	0	0	313168	0	10	40213160		
230082	5056	40213227	1992-03-12	1992-03-12 00:00:00	1992-03-12	1992-03-12 00:00:00	1992-03-12	581452		0	0	0		0	0	0	336208	0	113	40213227		
28936	2392	19059056	1916-11-30	1916-11-30 00:00:00	1916-12-30	1916-12-30 00:00:00	1916-12-30	38000177		0	0	30		0	0	0	159007	0	243670	19059056		
142568	3132	40213260	2013-07-07	2013-07-07 00:00:00	2013-07-07	2013-07-07 00:00:00	2013-07-07	581452		0	0	0		0	0	0	208427	0	121	40213260		
125462	2760	40213227	1998-07-16	1998-07-16 00:00:00	1998-07-16	1998-07-16 00:00:00	1998-07-16	581452		0	0	0		0	0	0	182596	0	113	40213227		
208466	4572	40213160	1976-04-20	1976-04-20 00:00:00	1976-04-20	1976-04-20 00:00:00	1976-04-20	581452		0	0	0		0	0	0	304640	0	10	40213160		
57498	4771	1124300	1994-09-29	1994-09-29 00:00:00	1994-09-29	1994-09-29 00:00:00	\N	38000177		0	0	0		0	0	0	317782	0	00781178901	45011828		
13009	1092	1127433	1958-04-29	1958-04-29 00:00:00	1958-05-13	1958-05-13 00:00:00	1958-05-13	38000177		0	0	14		0	0	0	71754	0	313782	1127433		
18551	1533	19133905	2014-08-27	2014-08-27 00:00:00	2014-09-03	2014-09-03 00:00:00	2014-09-03	38000177		0	0	7		0	0	0	102647	0	834102	19133905		
171628	3773	40213160	1958-08-08	1958-08-08 00:00:00	1958-08-08	1958-08-08 00:00:00	1958-08-08	581452		0	0	0		0	0	0	250827	0	10	40213160		
29087	2409	1124300	2018-10-06	2018-10-06 00:00:00	2018-10-06	2018-10-06 00:00:00	\N	38000177		0	0	0		0	0	0	159935	0	00781178901	45011828		
186266	4092	40213227	2015-04-23	2015-04-23 00:00:00	2015-04-23	2015-04-23 00:00:00	2015-04-23	581452		0	0	0		0	0	0	272043	0	113	40213227		
173478	3814	40213296	2018-09-23	2018-09-23 00:00:00	2018-09-23	2018-09-23 00:00:00	2018-09-23	581452		0	0	0		0	0	0	253326	0	52	40213296		
56144	4662	19133873	1953-08-23	1953-08-23 00:00:00	1953-09-05	1953-09-05 00:00:00	1953-09-05	38000177		0	0	13		0	0	0	310728	0	834061	19133873		
2066	163	920300	2001-07-20	2001-07-20 00:00:00	2001-07-27	2001-07-27 00:00:00	2001-07-27	38000177		0	0	7		0	0	0	11178	0	311989	920300		
7470	624	1127433	2014-08-30	2014-08-30 00:00:00	2014-09-20	2014-09-20 00:00:00	2014-09-20	38000177		0	0	21		0	0	0	41696	0	313782	1127433		
14409	311	40213160	1977-11-01	1977-11-01 00:00:00	1977-11-01	1977-11-01 00:00:00	1977-11-01	581452		0	0	0		0	0	0	20638	0	10	40213160		
218481	4795	40213160	1966-07-13	1966-07-13 00:00:00	1966-07-13	1966-07-13 00:00:00	1966-07-13	581452		0	0	0		0	0	0	318996	0	10	40213160		
146467	3221	40213227	2005-06-25	2005-06-25 00:00:00	2005-06-25	2005-06-25 00:00:00	2005-06-25	581452		0	0	0		0	0	0	214107	0	113	40213227		
189302	4156	40213160	1961-06-05	1961-06-05 00:00:00	1961-06-05	1961-06-05 00:00:00	1961-06-05	581452		0	0	0		0	0	0	276202	0	10	40213160		
25872	565	40213160	1957-10-30	1957-10-30 00:00:00	1957-10-30	1957-10-30 00:00:00	1957-10-30	581452		0	0	0		0	0	0	37408	0	10	40213160		
16143	1338	920300	1974-11-07	1974-11-07 00:00:00	1974-11-14	1974-11-14 00:00:00	1974-11-14	38000177		0	0	7		0	0	0	88699	0	311989	920300		
172266	3787	40213306	1984-10-20	1984-10-20 00:00:00	1984-10-20	1984-10-20 00:00:00	1984-10-20	581452		0	0	0		0	0	0	251745	0	43	40213306		
56779	4712	19078461	2017-05-01	2017-05-01 00:00:00	2017-05-15	2017-05-15 00:00:00	2017-05-15	38000177		0	0	14		0	0	0	313796	0	310965	19078461		
7079	153	40213227	1994-06-16	1994-06-16 00:00:00	1994-06-16	1994-06-16 00:00:00	1994-06-16	581452		0	0	0		0	0	0	10423	0	113	40213227		
89863	1971	40213227	1993-07-09	1993-07-09 00:00:00	1993-07-09	1993-07-09 00:00:00	1993-07-09	581452		0	0	0		0	0	0	131017	0	113	40213227		
26840	2210	19078461	2014-12-22	2014-12-22 00:00:00	2015-01-05	2015-01-05 00:00:00	2015-01-05	38000177		0	0	14		0	0	0	147201	0	310965	19078461		
45475	992	40213296	1997-07-27	1997-07-27 00:00:00	1997-07-27	1997-07-27 00:00:00	1997-07-27	581452		0	0	0		0	0	0	65731	0	52	40213296		
49897	4139	19128065	1987-10-18	1987-10-18 00:00:00	1988-10-12	1988-10-12 00:00:00	1988-10-12	38000177		0	0	360		0	0	0	275159	0	749882	19128065		
28063	610	40213160	1967-08-31	1967-08-31 00:00:00	1967-08-31	1967-08-31 00:00:00	1967-08-31	581452		0	0	0		0	0	0	40597	0	10	40213160		
18694	1543	19126352	1986-08-24	1986-08-24 00:00:00	1994-10-23	1994-10-23 00:00:00	1994-10-23	38000177		0	0	2982		0	0	0	103397	0	705129	19126352		
56602	4696	19133873	1953-02-02	1953-02-02 00:00:00	1953-02-11	1953-02-11 00:00:00	1953-02-11	38000177		0	0	9		0	0	0	312820	0	834061	19133873		
240384	5277	40213227	1997-10-08	1997-10-08 00:00:00	1997-10-08	1997-10-08 00:00:00	1997-10-08	581452		0	0	0		0	0	0	351001	0	113	40213227		
4245	351	1127433	1991-11-26	1991-11-26 00:00:00	1991-12-10	1991-12-10 00:00:00	1991-12-10	38000177		0	0	14		0	0	0	23406	0	313782	1127433		
20922	1724	19059056	1957-03-02	1957-03-02 00:00:00	1957-03-30	1957-03-30 00:00:00	1957-03-30	38000177		0	0	28		0	0	0	115263	0	243670	19059056		
138467	3041	40213251	1984-02-23	1984-02-23 00:00:00	1984-02-23	1984-02-23 00:00:00	1984-02-23	581452		0	0	0		0	0	0	202496	0	21	40213251		
43875	3634	19078461	1982-04-21	1982-04-21 00:00:00	1982-07-20	1982-07-20 00:00:00	1982-07-20	38000177		0	0	90		0	0	0	241743	0	310965	19078461		
43928	3639	40229134	1954-06-03	1954-06-03 00:00:00	1954-06-17	1954-06-17 00:00:00	1954-06-17	38000177		0	0	14		0	0	0	242061	0	1043400	40229134		
97463	2136	40213160	1968-09-07	1968-09-07 00:00:00	1968-09-07	1968-09-07 00:00:00	1968-09-07	581452		0	0	0		0	0	0	142254	0	10	40213160		
185962	4086	40213227	2014-12-17	2014-12-17 00:00:00	2014-12-17	2014-12-17 00:00:00	2014-12-17	581452		0	0	0		0	0	0	271611	0	113	40213227		
218199	4788	40213296	2017-12-03	2017-12-03 00:00:00	2017-12-03	2017-12-03 00:00:00	2017-12-03	581452		0	0	0		0	0	0	318686	0	52	40213296		
130255	2863	40213227	2003-09-25	2003-09-25 00:00:00	2003-09-25	2003-09-25 00:00:00	2003-09-25	581452		0	0	0		0	0	0	190364	0	113	40213227		
2713	219	1127433	1987-08-07	1987-08-07 00:00:00	1987-09-11	1987-09-11 00:00:00	1987-09-11	38000177		0	0	35		0	0	0	14757	0	313782	1127433		
149160	3280	40213227	2002-09-19	2002-09-19 00:00:00	2002-09-19	2002-09-19 00:00:00	2002-09-19	581452		0	0	0		0	0	0	217989	0	113	40213227		
49314	4091	1127433	1999-05-22	1999-05-22 00:00:00	1999-05-29	1999-05-29 00:00:00	1999-05-29	38000177		0	0	7		0	0	0	271969	0	313782	1127433		
40664	3371	19019979	1982-12-06	1982-12-06 00:00:00	1983-01-05	1983-01-05 00:00:00	1983-01-05	38000177		0	0	30		0	0	0	223669	0	198405	19019979		
199170	4375	40213201	1994-04-17	1994-04-17 00:00:00	1994-04-17	1994-04-17 00:00:00	1994-04-17	581452		0	0	0		0	0	0	290674	0	33	40213201		
47856	3968	1127433	1968-08-28	1968-08-28 00:00:00	1968-09-04	1968-09-04 00:00:00	1968-09-04	38000177		0	0	7		0	0	0	263833	0	313782	1127433		
34033	2813	1713671	1937-01-08	1937-01-08 00:00:00	1937-01-15	1937-01-15 00:00:00	1937-01-15	38000177		0	0	7		0	0	0	186429	0	562251	1713671		
95341	2090	40213260	2017-07-12	2017-07-12 00:00:00	2017-07-12	2017-07-12 00:00:00	2017-07-12	581452		0	0	0		0	0	0	139399	0	121	40213260		
66103	1446	40213314	1985-01-08	1985-01-08 00:00:00	1985-01-08	1985-01-08 00:00:00	1985-01-08	581452		0	0	0		0	0	0	96406	0	49	40213314		
131910	2898	40213160	1979-04-24	1979-04-24 00:00:00	1979-04-24	1979-04-24 00:00:00	1979-04-24	581452		0	0	0		0	0	0	193064	0	10	40213160		
97135	2130	40213260	2007-08-02	2007-08-02 00:00:00	2007-08-02	2007-08-02 00:00:00	2007-08-02	581452		0	0	0		0	0	0	141702	0	121	40213260		
23880	1966	40231925	2010-05-07	2010-05-07 00:00:00	2010-05-07	2010-05-07 00:00:00	\N	38000177		0	0	0		0	0	0	130734	0	1049221	40231925		
51056	4241	19059056	1965-10-22	1965-10-22 00:00:00	1965-11-12	1965-11-12 00:00:00	1965-11-12	38000177		0	0	21		0	0	0	281747	0	243670	19059056		
51096	4243	19059056	1969-12-23	1969-12-23 00:00:00	1970-01-06	1970-01-06 00:00:00	1970-01-06	38000177		0	0	14		0	0	0	281844	0	243670	19059056		
169931	3736	40213227	1992-12-16	1992-12-16 00:00:00	1992-12-16	1992-12-16 00:00:00	1992-12-16	581452		0	0	0		0	0	0	248294	0	113	40213227		
162737	3578	40213160	1973-04-11	1973-04-11 00:00:00	1973-04-11	1973-04-11 00:00:00	1973-04-11	581452		0	0	0		0	0	0	237898	0	10	40213160		
140377	3082	40213160	1966-01-12	1966-01-12 00:00:00	1966-01-12	1966-01-12 00:00:00	1966-01-12	581452		0	0	0		0	0	0	205196	0	10	40213160		
45084	3730	40236824	2002-04-28	2002-04-28 00:00:00	2002-05-05	2002-05-05 00:00:00	2002-05-05	38000177		0	0	7		0	0	0	247867	0	1094107	40236824		
136079	2988	40213160	1962-09-16	1962-09-16 00:00:00	1962-09-16	1962-09-16 00:00:00	1962-09-16	581452		0	0	0		0	0	0	199496	0	10	40213160		
142383	3128	40213314	1977-06-14	1977-06-14 00:00:00	1977-06-14	1977-06-14 00:00:00	1977-06-14	581452		0	0	0		0	0	0	\N	0	49	40213314		
79220	1733	40213314	1982-04-28	1982-04-28 00:00:00	1982-04-28	1982-04-28 00:00:00	1982-04-28	581452		0	0	0		0	0	0	115840	0	49	40213314		
162258	3568	40213296	2009-06-04	2009-06-04 00:00:00	2009-06-04	2009-06-04 00:00:00	2009-06-04	581452		0	0	0		0	0	0	237072	0	52	40213296		
28373	2341	1713671	2012-12-25	2012-12-25 00:00:00	2013-04-30	2013-04-30 00:00:00	2013-04-30	38000177		0	0	126		0	0	0	155820	0	562251	1713671		
109442	2402	40213160	1981-08-24	1981-08-24 00:00:00	1981-08-24	1981-08-24 00:00:00	1981-08-24	581452		0	0	0		0	0	0	159643	0	10	40213160		
28937	2392	1127433	2011-03-24	2011-03-24 00:00:00	2011-03-31	2011-03-31 00:00:00	2011-03-31	38000177		0	0	7		0	0	0	159104	0	313782	1127433		
142575	3132	40213296	2003-07-13	2003-07-13 00:00:00	2003-07-13	2003-07-13 00:00:00	2003-07-13	581452		0	0	0		0	0	0	208383	0	52	40213296		
125463	2760	40213296	1998-07-16	1998-07-16 00:00:00	1998-07-16	1998-07-16 00:00:00	1998-07-16	581452		0	0	0		0	0	0	182596	0	52	40213296		
208468	4572	40213314	1977-04-19	1977-04-19 00:00:00	1977-04-19	1977-04-19 00:00:00	1977-04-19	581452		0	0	0		0	0	0	304613	0	49	40213314		
57505	4773	19133905	1987-01-28	1987-01-28 00:00:00	1987-02-06	1987-02-06 00:00:00	1987-02-06	38000177		0	0	9		0	0	0	317849	0	834102	19133905		
13010	1092	19078461	1993-07-11	1993-07-11 00:00:00	1993-08-01	1993-08-01 00:00:00	1993-08-01	38000177		0	0	21		0	0	0	71799	0	310965	19078461		
18552	1533	19128065	1986-12-15	1986-12-15 00:00:00	1987-12-10	1987-12-10 00:00:00	1987-12-10	38000177		0	0	360		0	0	0	102637	0	749882	19128065		
171631	3773	40213160	1958-10-10	1958-10-10 00:00:00	1958-10-10	1958-10-10 00:00:00	1958-10-10	581452		0	0	0		0	0	0	250770	0	10	40213160		
29088	2409	40229134	2013-06-27	2013-06-27 00:00:00	2013-07-04	2013-07-04 00:00:00	2013-07-04	38000177		0	0	7		0	0	0	159897	0	1043400	40229134		
186271	4092	40213160	1978-05-18	1978-05-18 00:00:00	1978-05-18	1978-05-18 00:00:00	1978-05-18	581452		0	0	0		0	0	0	272059	0	10	40213160		
173481	3814	40213160	1975-08-10	1975-08-10 00:00:00	1975-08-10	1975-08-10 00:00:00	1975-08-10	581452		0	0	0		0	0	0	253394	0	10	40213160		
56145	4662	1713671	1958-08-30	1958-08-30 00:00:00	1958-09-20	1958-09-20 00:00:00	1958-09-20	38000177		0	0	21		0	0	0	310738	0	562251	1713671		
2067	163	19059056	1968-04-18	1968-04-18 00:00:00	1968-05-02	1968-05-02 00:00:00	1968-05-02	38000177		0	0	14		0	0	0	11180	0	243670	19059056		
17937	1486	19006318	1960-01-15	1960-01-15 00:00:00	1960-01-29	1960-01-29 00:00:00	1960-01-29	38000177		0	0	14		0	0	0	99101	0	105078	19006318		
152393	3355	40213296	2002-10-11	2002-10-11 00:00:00	2002-10-11	2002-10-11 00:00:00	2002-10-11	581452		0	0	0		0	0	0	222473	0	52	40213296		
218494	4795	40213306	1988-01-20	1988-01-20 00:00:00	1988-01-20	1988-01-20 00:00:00	1988-01-20	581452		0	0	0		0	0	0	319032	0	43	40213306		
146473	3221	40213227	1995-06-10	1995-06-10 00:00:00	1995-06-10	1995-06-10 00:00:00	1995-06-10	581452		0	0	0		0	0	0	214056	0	113	40213227		
189311	4156	40213160	1956-12-03	1956-12-03 00:00:00	1956-12-03	1956-12-03 00:00:00	1956-12-03	581452		0	0	0		0	0	0	276198	0	10	40213160		
98127	2149	40213296	1999-04-24	1999-04-24 00:00:00	1999-04-24	1999-04-24 00:00:00	1999-04-24	581452		0	0	0		0	0	0	143115	0	52	40213296		
16144	1338	40236824	1974-11-07	1974-11-07 00:00:00	1974-11-14	1974-11-14 00:00:00	1974-11-14	38000177		0	0	7		0	0	0	88699	0	1094107	40236824		
172269	3787	40213160	1962-02-17	1962-02-17 00:00:00	1962-02-17	1962-02-17 00:00:00	1962-02-17	581452		0	0	0		0	0	0	251791	0	10	40213160		
56780	4712	1713671	1972-10-03	1972-10-03 00:00:00	1972-10-17	1972-10-17 00:00:00	1972-10-17	38000177		0	0	14		0	0	0	313767	0	562251	1713671		
217419	4771	40213227	2014-09-13	2014-09-13 00:00:00	2014-09-13	2014-09-13 00:00:00	2014-09-13	581452		0	0	0		0	0	0	317789	0	113	40213227		
89867	1971	40213227	2011-03-25	2011-03-25 00:00:00	2011-03-25	2011-03-25 00:00:00	2011-03-25	581452		0	0	0		0	0	0	131019	0	113	40213227		
26841	2210	40229134	1954-01-05	1954-01-05 00:00:00	1954-01-12	1954-01-12 00:00:00	1954-01-12	38000177		0	0	7		0	0	0	147167	0	1043400	40229134		
45481	992	40213160	1955-07-31	1955-07-31 00:00:00	1955-07-31	1955-07-31 00:00:00	1955-07-31	581452		0	0	0		0	0	0	65791	0	10	40213160		
49922	4142	1713671	2009-06-06	2009-06-06 00:00:00	2009-06-13	2009-06-13 00:00:00	2009-06-13	38000177		0	0	7		0	0	0	275326	0	562251	1713671		
202105	4437	40213227	2002-06-19	2002-06-19 00:00:00	2002-06-19	2002-06-19 00:00:00	2002-06-19	581452		0	0	0		0	0	0	294900	0	113	40213227		
18695	1543	1127433	1957-03-25	1957-03-25 00:00:00	1957-05-24	1957-05-24 00:00:00	1957-05-24	38000177		0	0	60		0	0	0	103422	0	313782	1127433		
56605	4696	19059056	1955-01-22	1955-01-22 00:00:00	1955-02-05	1955-02-05 00:00:00	1955-02-05	38000177		0	0	14		0	0	0	312834	0	243670	19059056		
240385	5277	40213296	1997-10-08	1997-10-08 00:00:00	1997-10-08	1997-10-08 00:00:00	1997-10-08	581452		0	0	0		0	0	0	351001	0	52	40213296		
4246	351	1127433	1982-10-05	1982-10-05 00:00:00	1982-10-12	1982-10-12 00:00:00	1982-10-12	38000177		0	0	7		0	0	0	23409	0	313782	1127433		
20923	1724	1127433	1995-07-23	1995-07-23 00:00:00	1995-08-06	1995-08-06 00:00:00	1995-08-06	38000177		0	0	14		0	0	0	115266	0	313782	1127433		
138474	3041	40213227	2018-11-29	2018-11-29 00:00:00	2018-11-29	2018-11-29 00:00:00	2018-11-29	581452		0	0	0		0	0	0	202469	0	113	40213227		
43876	3634	1127433	2008-04-06	2008-04-06 00:00:00	2008-04-20	2008-04-20 00:00:00	2008-04-20	38000177		0	0	14		0	0	0	241698	0	313782	1127433		
43929	3639	1713671	1982-05-19	1982-05-19 00:00:00	1982-06-09	1982-06-09 00:00:00	1982-06-09	38000177		0	0	21		0	0	0	242032	0	562251	1713671		
97468	2136	40213160	1969-02-08	1969-02-08 00:00:00	1969-02-08	1969-02-08 00:00:00	1969-02-08	581452		0	0	0		0	0	0	142296	0	10	40213160		
185967	4086	40213227	1995-05-25	1995-05-25 00:00:00	1995-05-25	1995-05-25 00:00:00	1995-05-25	581452		0	0	0		0	0	0	271591	0	113	40213227		
218200	4788	40213160	1976-05-02	1976-05-02 00:00:00	1976-05-02	1976-05-02 00:00:00	1976-05-02	581452		0	0	0		0	0	0	318680	0	10	40213160		
130256	2863	40213296	2003-09-25	2003-09-25 00:00:00	2003-09-25	2003-09-25 00:00:00	2003-09-25	581452		0	0	0		0	0	0	190364	0	52	40213296		
2715	219	1127433	1975-10-06	1975-10-06 00:00:00	1975-10-20	1975-10-20 00:00:00	1975-10-20	38000177		0	0	14		0	0	0	14733	0	313782	1127433		
239986	5268	40213160	1970-06-07	1970-06-07 00:00:00	1970-06-07	1970-06-07 00:00:00	1970-06-07	581452		0	0	0		0	0	0	350521	0	10	40213160		
49315	4091	40243436	2017-09-10	2017-09-10 00:00:00	2017-09-10	2017-09-10 00:00:00	2017-09-10	38000177		0	0	0		0	0	0	271945	0	1190795	40243436		
40665	3371	1127078	1977-07-05	1977-07-05 00:00:00	1977-07-19	1977-07-19 00:00:00	1977-07-19	38000177		0	0	14		0	0	0	223650	0	282464	1127078		
199197	4376	40213227	2001-11-06	2001-11-06 00:00:00	2001-11-06	2001-11-06 00:00:00	2001-11-06	581452		0	0	0		0	0	0	290836	0	113	40213227		
47857	3968	19018935	2006-03-31	2006-03-31 00:00:00	2006-03-31	2006-03-31 00:00:00	\N	38000177		0	0	0		0	0	0	263800	0	197604	19018935		
34034	2813	19078461	2015-07-18	2015-07-18 00:00:00	2015-09-16	2015-09-16 00:00:00	2015-09-16	38000177		0	0	60		0	0	0	186417	0	310965	19078461		
95344	2090	40213227	1997-08-13	1997-08-13 00:00:00	1997-08-13	1997-08-13 00:00:00	1997-08-13	581452		0	0	0		0	0	0	139358	0	113	40213227		
66106	1446	40213160	1984-07-10	1984-07-10 00:00:00	1984-07-10	1984-07-10 00:00:00	1984-07-10	581452		0	0	0		0	0	0	96369	0	10	40213160		
131912	2898	40213251	1984-01-31	1984-01-31 00:00:00	1984-01-31	1984-01-31 00:00:00	1984-01-31	581452		0	0	0		0	0	0	193020	0	21	40213251		
97140	2130	40213260	2008-08-07	2008-08-07 00:00:00	2008-08-07	2008-08-07 00:00:00	2008-08-07	581452		0	0	0		0	0	0	141758	0	121	40213260		
23881	1966	19133905	1992-09-19	1992-09-19 00:00:00	1992-10-02	1992-10-02 00:00:00	1992-10-02	38000177		0	0	13		0	0	0	130717	0	834102	19133905		
51057	4241	19078461	1985-02-28	1985-02-28 00:00:00	1985-03-21	1985-03-21 00:00:00	1985-03-21	38000177		0	0	21		0	0	0	281698	0	310965	19078461		
51097	4243	1127433	1987-02-08	1987-02-08 00:00:00	1987-02-22	1987-02-22 00:00:00	1987-02-22	38000177		0	0	14		0	0	0	281802	0	313782	1127433		
169953	3736	40213227	2012-02-08	2012-02-08 00:00:00	2012-02-08	2012-02-08 00:00:00	2012-02-08	581452		0	0	0		0	0	0	248340	0	113	40213227		
162745	3579	40213160	1965-04-10	1965-04-10 00:00:00	1965-04-10	1965-04-10 00:00:00	1965-04-10	581452		0	0	0		0	0	0	237944	0	10	40213160		
140382	3082	40213160	1970-07-15	1970-07-15 00:00:00	1970-07-15	1970-07-15 00:00:00	1970-07-15	581452		0	0	0		0	0	0	205200	0	10	40213160		
45085	3730	920300	2002-04-28	2002-04-28 00:00:00	2002-05-05	2002-05-05 00:00:00	2002-05-05	38000177		0	0	7		0	0	0	247867	0	311989	920300		
136083	2988	40213260	2012-10-21	2012-10-21 00:00:00	2012-10-21	2012-10-21 00:00:00	2012-10-21	581452		0	0	0		0	0	0	199449	0	121	40213260		
142392	3128	40213296	2013-07-30	2013-07-30 00:00:00	2013-07-30	2013-07-30 00:00:00	2013-07-30	581452		0	0	0		0	0	0	208112	0	52	40213296		
79226	1733	40213160	1986-01-29	1986-01-29 00:00:00	1986-01-29	1986-01-29 00:00:00	1986-01-29	581452		0	0	0		0	0	0	115822	0	10	40213160		
162260	3568	40213260	2019-05-30	2019-05-30 00:00:00	2019-05-30	2019-05-30 00:00:00	2019-05-30	581452		0	0	0		0	0	0	237074	0	121	40213260		
28375	2341	19128065	1976-01-31	1976-01-31 00:00:00	1977-01-25	1977-01-25 00:00:00	1977-01-25	38000177		0	0	360		0	0	0	155841	0	749882	19128065		
109445	2402	40213160	1976-12-20	1976-12-20 00:00:00	1976-12-20	1976-12-20 00:00:00	1976-12-20	581452		0	0	0		0	0	0	159703	0	10	40213160		
28938	2392	1127433	1974-06-16	1974-06-16 00:00:00	1974-07-07	1974-07-07 00:00:00	1974-07-07	38000177		0	0	21		0	0	0	159012	0	313782	1127433		
142577	3132	40213227	2005-07-17	2005-07-17 00:00:00	2005-07-17	2005-07-17 00:00:00	2005-07-17	581452		0	0	0		0	0	0	208441	0	113	40213227		
197084	4331	40213160	1979-10-26	1979-10-26 00:00:00	1979-10-26	1979-10-26 00:00:00	1979-10-26	581452		0	0	0		0	0	0	287312	0	10	40213160		
208469	4572	40213306	1998-03-31	1998-03-31 00:00:00	1998-03-31	1998-03-31 00:00:00	1998-03-31	581452		0	0	0		0	0	0	304630	0	43	40213306		
57506	4773	19133873	1960-04-21	1960-04-21 00:00:00	1960-05-03	1960-05-03 00:00:00	1960-05-03	38000177		0	0	12		0	0	0	317845	0	834061	19133873		
13011	1092	1127433	2009-09-05	2009-09-05 00:00:00	2009-09-12	2009-09-12 00:00:00	2009-09-12	38000177		0	0	7		0	0	0	71822	0	313782	1127433		
18553	1533	19078461	2017-08-29	2017-08-29 00:00:00	2017-09-19	2017-09-19 00:00:00	2017-09-19	38000177		0	0	21		0	0	0	102692	0	310965	19078461		
171633	3773	40213260	2008-07-04	2008-07-04 00:00:00	2008-07-04	2008-07-04 00:00:00	2008-07-04	581452		0	0	0		0	0	0	250793	0	121	40213260		
29089	2409	19128022	1994-09-24	1994-09-24 00:00:00	1995-09-19	1995-09-19 00:00:00	1995-09-19	38000177		0	0	360		0	0	0	159954	0	749785	19128022		
186277	4092	40213160	1973-11-15	1973-11-15 00:00:00	1973-11-15	1973-11-15 00:00:00	1973-11-15	581452		0	0	0		0	0	0	272057	0	10	40213160		
173482	3814	40213314	1978-02-26	1978-02-26 00:00:00	1978-02-26	1978-02-26 00:00:00	1978-02-26	581452		0	0	0		0	0	0	253379	0	49	40213314		
56146	4662	19133873	1958-01-16	1958-01-16 00:00:00	1958-01-29	1958-01-29 00:00:00	1958-01-29	38000177		0	0	13		0	0	0	310785	0	834061	19133873		
2068	163	46233988	1968-04-18	1968-04-18 00:00:00	1968-05-02	1968-05-02 00:00:00	1968-05-02	38000177		0	0	14		0	0	0	11180	0	1652673	46233988		
17938	1486	1127078	1960-01-15	1960-01-15 00:00:00	1960-01-29	1960-01-29 00:00:00	1960-01-29	38000177		0	0	14		0	0	0	99101	0	282464	1127078		
152396	3355	40213160	1963-01-11	1963-01-11 00:00:00	1963-01-11	1963-01-11 00:00:00	1963-01-11	581452		0	0	0		0	0	0	222515	0	10	40213160		
218496	4795	40213296	2007-11-14	2007-11-14 00:00:00	2007-11-14	2007-11-14 00:00:00	2007-11-14	581452		0	0	0		0	0	0	319049	0	52	40213296		
146478	3221	40213160	1963-11-09	1963-11-09 00:00:00	1963-11-09	1963-11-09 00:00:00	1963-11-09	581452		0	0	0		0	0	0	214096	0	10	40213160		
189314	4156	40213260	2006-06-26	2006-06-26 00:00:00	2006-06-26	2006-06-26 00:00:00	2006-06-26	581452		0	0	0		0	0	0	276210	0	121	40213260		
98132	2149	40213260	2010-01-23	2010-01-23 00:00:00	2010-01-23	2010-01-23 00:00:00	2010-01-23	581452		0	0	0		0	0	0	\N	0	121	40213260		
16145	1339	1118084	2006-03-20	2006-03-20 00:00:00	2006-03-20	2006-03-20 00:00:00	\N	38000177		0	0	0		0	0	0	88824	0	00025152531	44923712		
172275	3787	40213296	2005-03-19	2005-03-19 00:00:00	2005-03-19	2005-03-19 00:00:00	2005-03-19	581452		0	0	0		0	0	0	251762	0	52	40213296		
56781	4712	19018935	2017-03-17	2017-03-17 00:00:00	2017-03-17	2017-03-17 00:00:00	\N	38000177		0	0	0		0	0	0	313784	0	197604	19018935		
217424	4771	40213160	1956-01-28	1956-01-28 00:00:00	1956-01-28	1956-01-28 00:00:00	1956-01-28	581452		0	0	0		0	0	0	317777	0	10	40213160		
89868	1971	40213296	2011-03-25	2011-03-25 00:00:00	2011-03-25	2011-03-25 00:00:00	2011-03-25	581452		0	0	0		0	0	0	131019	0	52	40213296		
26842	2210	1127433	1975-03-17	1975-03-17 00:00:00	1975-04-21	1975-04-21 00:00:00	1975-04-21	38000177		0	0	35		0	0	0	147199	0	313782	1127433		
45483	992	40213227	1995-07-23	1995-07-23 00:00:00	1995-07-23	1995-07-23 00:00:00	1995-07-23	581452		0	0	0		0	0	0	65739	0	113	40213227		
49923	4142	19078461	2013-12-14	2013-12-14 00:00:00	2013-12-28	2013-12-28 00:00:00	2013-12-28	38000177		0	0	14		0	0	0	275292	0	310965	19078461		
96975	2127	40213260	2010-09-04	2010-09-04 00:00:00	2010-09-04	2010-09-04 00:00:00	2010-09-04	581452		0	0	0		0	0	0	141484	0	121	40213260		
18696	1543	19133768	1994-10-23	1994-10-23 00:00:00	1994-10-23	1994-10-23 00:00:00	1994-10-23	38000177		0	0	0		0	0	0	103423	0	833036	19133768		
56606	4696	1127433	1958-12-31	1958-12-31 00:00:00	1959-01-14	1959-01-14 00:00:00	1959-01-14	38000177		0	0	14		0	0	0	312833	0	313782	1127433		
18874	409	40213227	2001-10-12	2001-10-12 00:00:00	2001-10-12	2001-10-12 00:00:00	2001-10-12	581452		0	0	0		0	0	0	27056	0	113	40213227		
4247	351	1127078	1985-10-18	1985-10-18 00:00:00	1985-11-01	1985-11-01 00:00:00	1985-11-01	38000177		0	0	14		0	0	0	23421	0	282464	1127078		
20924	1724	1127433	1975-02-20	1975-02-20 00:00:00	1975-03-06	1975-03-06 00:00:00	1975-03-06	38000177		0	0	14		0	0	0	115298	0	313782	1127433		
138475	3041	40213296	2018-11-29	2018-11-29 00:00:00	2018-11-29	2018-11-29 00:00:00	2018-11-29	581452		0	0	0		0	0	0	202469	0	52	40213296		
43877	3634	40231925	2002-10-17	2002-10-17 00:00:00	2002-10-17	2002-10-17 00:00:00	\N	38000177		0	0	0		0	0	0	241745	0	1049221	40231925		
43930	3639	40229134	1929-03-07	1929-03-07 00:00:00	1929-03-21	1929-03-21 00:00:00	1929-03-21	38000177		0	0	14		0	0	0	242027	0	1043400	40229134		
97470	2136	40213260	2018-06-02	2018-06-02 00:00:00	2018-06-02	2018-06-02 00:00:00	2018-06-02	581452		0	0	0		0	0	0	142240	0	121	40213260		
185968	4086	40213306	1995-05-25	1995-05-25 00:00:00	1995-05-25	1995-05-25 00:00:00	1995-05-25	581452		0	0	0		0	0	0	271591	0	43	40213306		
218201	4788	40213314	1977-05-01	1977-05-01 00:00:00	1977-05-01	1977-05-01 00:00:00	1977-05-01	581452		0	0	0		0	0	0	318652	0	49	40213314		
130258	2863	40213306	1983-12-29	1983-12-29 00:00:00	1983-12-29	1983-12-29 00:00:00	1983-12-29	581452		0	0	0		0	0	0	190363	0	43	40213306		
2716	219	1127433	1991-11-27	1991-11-27 00:00:00	1991-12-11	1991-12-11 00:00:00	1991-12-11	38000177		0	0	14		0	0	0	14727	0	313782	1127433		
239988	5268	40213160	1965-10-03	1965-10-03 00:00:00	1965-10-03	1965-10-03 00:00:00	1965-10-03	581452		0	0	0		0	0	0	350530	0	10	40213160		
49316	4091	46275916	2017-09-10	2017-09-10 00:00:00	2017-09-10	2017-09-10 00:00:00	2017-09-10	38000177		0	0	0		0	0	0	271945	0	1660014	46275916		
40666	3371	46233988	1977-07-05	1977-07-05 00:00:00	1977-07-19	1977-07-19 00:00:00	1977-07-19	38000177		0	0	14		0	0	0	223650	0	1652673	46233988		
199200	4376	40213227	1992-09-15	1992-09-15 00:00:00	1992-09-15	1992-09-15 00:00:00	1992-09-15	581452		0	0	0		0	0	0	290801	0	113	40213227		
47858	3968	40163554	2006-03-31	2006-03-31 00:00:00	2006-03-31	2006-03-31 00:00:00	\N	38000177		0	0	0		0	0	0	263800	0	855332	40163554		
34035	2813	1115171	1994-02-17	1994-02-17 00:00:00	1994-03-10	1994-03-10 00:00:00	1994-03-10	38000177		0	0	21		0	0	0	186416	0	849574	1115171		
95352	2090	40213160	1971-05-12	1971-05-12 00:00:00	1971-05-12	1971-05-12 00:00:00	1971-05-12	581452		0	0	0		0	0	0	139365	0	10	40213160		
66109	1446	40213160	1984-04-10	1984-04-10 00:00:00	1984-04-10	1984-04-10 00:00:00	1984-04-10	581452		0	0	0		0	0	0	96405	0	10	40213160		
131916	2898	40213314	1979-06-26	1979-06-26 00:00:00	1979-06-26	1979-06-26 00:00:00	1979-06-26	581452		0	0	0		0	0	0	193015	0	49	40213314		
97143	2130	40213227	2008-08-07	2008-08-07 00:00:00	2008-08-07	2008-08-07 00:00:00	2008-08-07	581452		0	0	0		0	0	0	141758	0	113	40213227		
23882	1966	1127433	2016-07-20	2016-07-20 00:00:00	2016-07-27	2016-07-27 00:00:00	2016-07-27	38000177		0	0	7		0	0	0	130706	0	313782	1127433		
51058	4241	1713671	1970-07-18	1970-07-18 00:00:00	1970-08-08	1970-08-08 00:00:00	1970-08-08	38000177		0	0	21		0	0	0	281728	0	562251	1713671		
51098	4243	1713671	1983-10-22	1983-10-22 00:00:00	1983-11-12	1983-11-12 00:00:00	1983-11-12	38000177		0	0	21		0	0	0	281849	0	562251	1713671		
169958	3736	40213198	2016-10-19	2016-10-19 00:00:00	2016-10-19	2016-10-19 00:00:00	2016-10-19	581452		0	0	0		0	0	0	248298	0	133	40213198		
162747	3579	40213160	1965-07-10	1965-07-10 00:00:00	1965-07-10	1965-07-10 00:00:00	1965-07-10	581452		0	0	0		0	0	0	237910	0	10	40213160		
140383	3082	40213160	1966-04-13	1966-04-13 00:00:00	1966-04-13	1966-04-13 00:00:00	1966-04-13	581452		0	0	0		0	0	0	205206	0	10	40213160		
45086	3730	1118084	1989-08-10	1989-08-10 00:00:00	1989-08-10	1989-08-10 00:00:00	\N	38000177		0	0	0		0	0	0	247819	0	00025152531	44923712		
136098	2988	40213160	1962-11-18	1962-11-18 00:00:00	1962-11-18	1962-11-18 00:00:00	1962-11-18	581452		0	0	0		0	0	0	199474	0	10	40213160		
142397	3128	40213160	1974-04-02	1974-04-02 00:00:00	1974-04-02	1974-04-02 00:00:00	1974-04-02	581452		0	0	0		0	0	0	208134	0	10	40213160		
79228	1733	40213251	1986-01-29	1986-01-29 00:00:00	1986-01-29	1986-01-29 00:00:00	1986-01-29	581452		0	0	0		0	0	0	115822	0	21	40213251		
162264	3569	40213296	1998-11-10	1998-11-10 00:00:00	1998-11-10	1998-11-10 00:00:00	1998-11-10	581452		0	0	0		0	0	0	237123	0	52	40213296		
28377	2341	920300	1977-04-17	1977-04-17 00:00:00	1977-04-24	1977-04-24 00:00:00	1977-04-24	38000177		0	0	7		0	0	0	155848	0	311989	920300		
109449	2402	40213227	2018-04-16	2018-04-16 00:00:00	2018-04-16	2018-04-16 00:00:00	2018-04-16	581452		0	0	0		0	0	0	159649	0	113	40213227		
28939	2392	40229134	1958-07-23	1958-07-23 00:00:00	1958-07-30	1958-07-30 00:00:00	1958-07-30	38000177		0	0	7		0	0	0	159027	0	1043400	40229134		
142578	3132	40213296	2005-07-17	2005-07-17 00:00:00	2005-07-17	2005-07-17 00:00:00	2005-07-17	581452		0	0	0		0	0	0	208441	0	52	40213296		
197087	4331	40213160	1975-04-25	1975-04-25 00:00:00	1975-04-25	1975-04-25 00:00:00	1975-04-25	581452		0	0	0		0	0	0	287308	0	10	40213160		
208471	4572	40213227	1998-03-31	1998-03-31 00:00:00	1998-03-31	1998-03-31 00:00:00	1998-03-31	581452		0	0	0		0	0	0	304630	0	113	40213227		
57507	4773	1713671	2015-11-25	2015-11-25 00:00:00	2015-12-09	2015-12-09 00:00:00	2015-12-09	38000177		0	0	14		0	0	0	317854	0	562251	1713671		
13012	1092	19006318	1955-09-10	1955-09-10 00:00:00	1955-09-24	1955-09-24 00:00:00	1955-09-24	38000177		0	0	14		0	0	0	71758	0	105078	19006318		
18554	1533	1118084	2009-09-10	2009-09-10 00:00:00	2009-09-10	2009-09-10 00:00:00	\N	38000177		0	0	0		0	0	0	102695	0	00025152531	44923712		
171641	3773	40213296	2001-07-27	2001-07-27 00:00:00	2001-07-27	2001-07-27 00:00:00	2001-07-27	581452		0	0	0		0	0	0	250836	0	52	40213296		
29090	2409	1127078	1986-07-21	1986-07-21 00:00:00	1986-10-19	1986-10-19 00:00:00	1986-10-19	38000177		0	0	90		0	0	0	159942	0	282464	1127078		
186279	4092	40213227	1995-08-17	1995-08-17 00:00:00	1995-08-17	1995-08-17 00:00:00	1995-08-17	581452		0	0	0		0	0	0	272030	0	113	40213227		
173484	3814	40213160	1975-05-11	1975-05-11 00:00:00	1975-05-11	1975-05-11 00:00:00	1975-05-11	581452		0	0	0		0	0	0	253376	0	10	40213160		
56147	4662	1713671	1995-10-04	1995-10-04 00:00:00	1995-10-25	1995-10-25 00:00:00	1995-10-25	38000177		0	0	21		0	0	0	310797	0	562251	1713671		
2069	163	1127078	1973-03-23	1973-03-23 00:00:00	1973-04-06	1973-04-06 00:00:00	1973-04-06	38000177		0	0	14		0	0	0	11238	0	282464	1127078		
17939	1486	920334	1995-08-14	1995-08-14 00:00:00	1995-08-21	1995-08-21 00:00:00	1995-08-21	38000177		0	0	7		0	0	0	99077	0	311995	920334		
152411	3355	40213306	1984-12-07	1984-12-07 00:00:00	1984-12-07	1984-12-07 00:00:00	1984-12-07	581452		0	0	0		0	0	0	222460	0	43	40213306		
147446	3241	40213306	1983-05-12	1983-05-12 00:00:00	1983-05-12	1983-05-12 00:00:00	1983-05-12	581452		0	0	0		0	0	0	215577	0	43	40213306		
146480	3221	40213260	2013-06-01	2013-06-01 00:00:00	2013-06-01	2013-06-01 00:00:00	2013-06-01	581452		0	0	0		0	0	0	214127	0	121	40213260		
163808	3603	40213160	1970-12-27	1970-12-27 00:00:00	1970-12-27	1970-12-27 00:00:00	1970-12-27	581452		0	0	0		0	0	0	239336	0	10	40213160		
98133	2149	40213160	1959-07-25	1959-07-25 00:00:00	1959-07-25	1959-07-25 00:00:00	1959-07-25	581452		0	0	0		0	0	0	143067	0	10	40213160		
16146	1339	19059056	1973-05-12	1973-05-12 00:00:00	1973-08-10	1973-08-10 00:00:00	1973-08-10	38000177		0	0	90		0	0	0	88819	0	243670	19059056		
172276	3787	40213160	1962-04-21	1962-04-21 00:00:00	1962-04-21	1962-04-21 00:00:00	1962-04-21	581452		0	0	0		0	0	0	251777	0	10	40213160		
56782	4712	40163554	2017-03-17	2017-03-17 00:00:00	2017-03-17	2017-03-17 00:00:00	\N	38000177		0	0	0		0	0	0	313784	0	855332	40163554		
217436	4771	40213198	2018-10-06	2018-10-06 00:00:00	2018-10-06	2018-10-06 00:00:00	2018-10-06	581452		0	0	0		0	0	0	317744	0	133	40213198		
175368	3856	40213160	1974-01-09	1974-01-09 00:00:00	1974-01-09	1974-01-09 00:00:00	1974-01-09	581452		0	0	0		0	0	0	255910	0	10	40213160		
26843	2211	1127433	2001-08-16	2001-08-16 00:00:00	2001-08-23	2001-08-23 00:00:00	2001-08-23	38000177		0	0	7		0	0	0	147329	0	313782	1127433		
45487	992	40213260	2006-08-27	2006-08-27 00:00:00	2006-08-27	2006-08-27 00:00:00	2006-08-27	581452		0	0	0		0	0	0	65816	0	121	40213260		
49924	4142	1713671	1993-02-17	1993-02-17 00:00:00	1993-03-10	1993-03-10 00:00:00	1993-03-10	38000177		0	0	21		0	0	0	275304	0	562251	1713671		
96978	2127	40213160	1961-05-13	1961-05-13 00:00:00	1961-05-13	1961-05-13 00:00:00	1961-05-13	581452		0	0	0		0	0	0	141459	0	10	40213160		
18697	1543	40229134	1941-06-19	1941-06-19 00:00:00	1941-06-26	1941-06-26 00:00:00	1941-06-26	38000177		0	0	7		0	0	0	103417	0	1043400	40229134		
23043	1900	1127433	1980-01-04	1980-01-04 00:00:00	1980-01-11	1980-01-11 00:00:00	1980-01-11	38000177		0	0	7		0	0	0	126475	0	313782	1127433		
18876	409	40213160	1955-09-16	1955-09-16 00:00:00	1955-09-16	1955-09-16 00:00:00	1955-09-16	581452		0	0	0		0	0	0	27025	0	10	40213160		
4248	351	42902245	2000-10-09	2000-10-09 00:00:00	2001-10-04	2001-10-04 00:00:00	2001-10-04	38000177		0	0	360		0	0	0	23362	0	1359133	42902245		
20949	1727	19059056	1952-03-14	1952-03-14 00:00:00	1952-04-04	1952-04-04 00:00:00	1952-04-04	38000177		0	0	21		0	0	0	115413	0	243670	19059056		
8795	733	19133873	1944-09-19	1944-09-19 00:00:00	1944-09-30	1944-09-30 00:00:00	1944-09-30	38000177		0	0	11		0	0	0	48651	0	834061	19133873		
43878	3634	19078461	2002-10-17	2002-10-17 00:00:00	2003-01-15	2003-01-15 00:00:00	2003-01-15	38000177		0	0	90		0	0	0	241745	0	310965	19078461		
43931	3639	1127433	1960-09-29	1960-09-29 00:00:00	1960-10-06	1960-10-06 00:00:00	1960-10-06	38000177		0	0	7		0	0	0	242063	0	313782	1127433		
97475	2136	40213160	1973-05-12	1973-05-12 00:00:00	1973-05-12	1973-05-12 00:00:00	1973-05-12	581452		0	0	0		0	0	0	142279	0	10	40213160		
194325	4270	40213227	2018-01-23	2018-01-23 00:00:00	2018-01-23	2018-01-23 00:00:00	2018-01-23	581452		0	0	0		0	0	0	283415	0	113	40213227		
229481	5044	40213227	1995-01-18	1995-01-18 00:00:00	1995-01-18	1995-01-18 00:00:00	1995-01-18	581452		0	0	0		0	0	0	335187	0	113	40213227		
130265	2863	40213160	1961-12-21	1961-12-21 00:00:00	1961-12-21	1961-12-21 00:00:00	1961-12-21	581452		0	0	0		0	0	0	190331	0	10	40213160		
2717	219	1127433	1968-08-28	1968-08-28 00:00:00	1968-09-11	1968-09-11 00:00:00	1968-09-11	38000177		0	0	14		0	0	0	14766	0	313782	1127433		
239995	5268	40213227	2007-07-15	2007-07-15 00:00:00	2007-07-15	2007-07-15 00:00:00	2007-07-15	581452		0	0	0		0	0	0	350488	0	113	40213227		
49317	4091	1310034	2017-09-10	2017-09-10 00:00:00	2017-09-10	2017-09-10 00:00:00	2017-09-10	38000177		0	0	0		0	0	0	271945	0	834357	1310034		
40667	3371	19019979	1981-04-21	1981-04-21 00:00:00	1981-05-05	1981-05-05 00:00:00	1981-05-05	38000177		0	0	14		0	0	0	223636	0	198405	19019979		
6545	550	40229134	1975-12-14	1975-12-14 00:00:00	1975-12-28	1975-12-28 00:00:00	1975-12-28	38000177		0	0	14		0	0	0	36518	0	1043400	40229134		
47859	3968	40171902	2006-03-31	2006-03-31 00:00:00	2006-03-31	2006-03-31 00:00:00	\N	38000177		0	0	0		0	0	0	263800	0	897718	40171902		
34036	2813	19059056	1961-09-26	1961-09-26 00:00:00	1961-10-10	1961-10-10 00:00:00	1961-10-10	38000177		0	0	14		0	0	0	186370	0	243670	19059056		
141979	3119	40213160	1975-02-24	1975-02-24 00:00:00	1975-02-24	1975-02-24 00:00:00	1975-02-24	581452		0	0	0		0	0	0	207568	0	10	40213160		
66110	1446	40213314	1984-04-10	1984-04-10 00:00:00	1984-04-10	1984-04-10 00:00:00	1984-04-10	581452		0	0	0		0	0	0	96405	0	49	40213314		
131917	2898	40213160	1979-06-26	1979-06-26 00:00:00	1979-06-26	1979-06-26 00:00:00	1979-06-26	581452		0	0	0		0	0	0	193015	0	10	40213160		
179993	3956	40213201	1984-01-01	1984-01-01 00:00:00	1984-01-01	1984-01-01 00:00:00	1984-01-01	581452		0	0	0		0	0	0	262921	0	33	40213201		
23883	1966	1127433	1990-12-22	1990-12-22 00:00:00	1991-01-12	1991-01-12 00:00:00	1991-01-12	38000177		0	0	21		0	0	0	130738	0	313782	1127433		
7139	600	40236824	1985-01-27	1985-01-27 00:00:00	1985-02-03	1985-02-03 00:00:00	1985-02-03	38000177		0	0	7		0	0	0	39628	0	1094107	40236824		
54432	4525	1124300	2007-08-04	2007-08-04 00:00:00	2007-08-04	2007-08-04 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00781178901	45011828		
72659	1588	40213296	2001-06-17	2001-06-17 00:00:00	2001-06-17	2001-06-17 00:00:00	2001-06-17	581452		0	0	0		0	0	0	106607	0	52	40213296		
162750	3579	40213296	2004-11-06	2004-11-06 00:00:00	2004-11-06	2004-11-06 00:00:00	2004-11-06	581452		0	0	0		0	0	0	237930	0	52	40213296		
140386	3082	40213306	1987-10-07	1987-10-07 00:00:00	1987-10-07	1987-10-07 00:00:00	1987-10-07	581452		0	0	0		0	0	0	205213	0	43	40213306		
45087	3731	1118084	2008-03-03	2008-03-03 00:00:00	2008-03-03	2008-03-03 00:00:00	\N	38000177		0	0	0		0	0	0	247887	0	00025152531	44923712		
136101	2988	40213160	1967-05-21	1967-05-21 00:00:00	1967-05-21	1967-05-21 00:00:00	1967-05-21	581452		0	0	0		0	0	0	199434	0	10	40213160		
142403	3128	40213227	2005-06-28	2005-06-28 00:00:00	2005-06-28	2005-06-28 00:00:00	2005-06-28	581452		0	0	0		0	0	0	208082	0	113	40213227		
79232	1733	40213227	2002-04-17	2002-04-17 00:00:00	2002-04-17	2002-04-17 00:00:00	2002-04-17	581452		0	0	0		0	0	0	\N	0	113	40213227		
162277	3569	40213227	1993-02-16	1993-02-16 00:00:00	1993-02-16	1993-02-16 00:00:00	1993-02-16	581452		0	0	0		0	0	0	237177	0	113	40213227		
28378	2341	40236824	1977-04-17	1977-04-17 00:00:00	1977-04-24	1977-04-24 00:00:00	1977-04-24	38000177		0	0	7		0	0	0	155848	0	1094107	40236824		
109450	2402	40213296	2018-04-16	2018-04-16 00:00:00	2018-04-16	2018-04-16 00:00:00	2018-04-16	581452		0	0	0		0	0	0	159649	0	52	40213296		
28940	2392	1127433	2019-02-17	2019-02-17 00:00:00	2019-03-03	2019-03-03 00:00:00	2019-03-03	38000177		0	0	14		0	0	0	159046	0	313782	1127433		
142580	3132	40213160	1964-03-15	1964-03-15 00:00:00	1964-03-15	1964-03-15 00:00:00	1964-03-15	581452		0	0	0		0	0	0	208412	0	10	40213160		
197091	4331	40213314	1977-04-22	1977-04-22 00:00:00	1977-04-22	1977-04-22 00:00:00	1977-04-22	581452		0	0	0		0	0	0	287331	0	49	40213314		
203952	4477	40213306	1986-01-23	1986-01-23 00:00:00	1986-01-23	1986-01-23 00:00:00	1986-01-23	581452		0	0	0		0	0	0	297920	0	43	40213306		
57508	4773	1124300	1997-03-30	1997-03-30 00:00:00	1997-03-30	1997-03-30 00:00:00	\N	38000177		0	0	0		0	0	0	317917	0	00781178901	45011828		
13013	1092	19059056	1955-09-10	1955-09-10 00:00:00	1955-09-24	1955-09-24 00:00:00	1955-09-24	38000177		0	0	14		0	0	0	71758	0	243670	19059056		
18555	1535	40229134	1986-10-28	1986-10-28 00:00:00	1986-11-11	1986-11-11 00:00:00	1986-11-11	38000177		0	0	14		0	0	0	102708	0	1043400	40229134		
182941	4020	40213160	1956-06-07	1956-06-07 00:00:00	1956-06-07	1956-06-07 00:00:00	1956-06-07	581452		0	0	0		0	0	0	267210	0	10	40213160		
29091	2409	19133905	2017-04-10	2017-04-10 00:00:00	2017-04-22	2017-04-22 00:00:00	2017-04-22	38000177		0	0	12		0	0	0	159937	0	834102	19133905		
186280	4092	40213306	1995-08-17	1995-08-17 00:00:00	1995-08-17	1995-08-17 00:00:00	1995-08-17	581452		0	0	0		0	0	0	272030	0	43	40213306		
173489	3814	40213160	1979-09-02	1979-09-02 00:00:00	1979-09-02	1979-09-02 00:00:00	1979-09-02	581452		0	0	0		0	0	0	253396	0	10	40213160		
56148	4662	19059056	1953-04-21	1953-04-21 00:00:00	1953-05-05	1953-05-05 00:00:00	1953-05-05	38000177		0	0	14		0	0	0	310770	0	243670	19059056		
2070	163	1127078	1975-04-26	1975-04-26 00:00:00	1975-07-25	1975-07-25 00:00:00	1975-07-25	38000177		0	0	90		0	0	0	11234	0	282464	1127078		
17940	1486	1127433	2001-03-11	2001-03-11 00:00:00	2001-03-18	2001-03-18 00:00:00	2001-03-18	38000177		0	0	7		0	0	0	99055	0	313782	1127433		
152412	3355	40213160	1963-03-15	1963-03-15 00:00:00	1963-03-15	1963-03-15 00:00:00	1963-03-15	581452		0	0	0		0	0	0	222522	0	10	40213160		
147448	3241	40213160	1966-02-10	1966-02-10 00:00:00	1966-02-10	1966-02-10 00:00:00	1966-02-10	581452		0	0	0		0	0	0	\N	0	10	40213160		
146486	3221	40213160	1964-02-08	1964-02-08 00:00:00	1964-02-08	1964-02-08 00:00:00	1964-02-08	581452		0	0	0		0	0	0	214101	0	10	40213160		
163811	3603	40213227	1997-03-16	1997-03-16 00:00:00	1997-03-16	1997-03-16 00:00:00	1997-03-16	581452		0	0	0		0	0	0	239309	0	113	40213227		
98136	2149	40213227	1993-08-14	1993-08-14 00:00:00	1993-08-14	1993-08-14 00:00:00	1993-08-14	581452		0	0	0		0	0	0	143113	0	113	40213227		
16147	1339	1127078	1977-08-19	1977-08-19 00:00:00	1977-09-09	1977-09-09 00:00:00	1977-09-09	38000177		0	0	21		0	0	0	88820	0	282464	1127078		
172280	3787	40213160	1966-10-22	1966-10-22 00:00:00	1966-10-22	1966-10-22 00:00:00	1966-10-22	581452		0	0	0		0	0	0	251780	0	10	40213160		
56783	4712	40171902	2017-03-17	2017-03-17 00:00:00	2017-03-17	2017-03-17 00:00:00	\N	38000177		0	0	0		0	0	0	313784	0	897718	40171902		
217440	4771	40213160	1957-12-21	1957-12-21 00:00:00	1957-12-21	1957-12-21 00:00:00	1957-12-21	581452		0	0	0		0	0	0	317793	0	10	40213160		
175371	3856	40213227	2015-10-14	2015-10-14 00:00:00	2015-10-14	2015-10-14 00:00:00	2015-10-14	581452		0	0	0		0	0	0	255948	0	113	40213227		
26844	2211	1127433	1997-02-03	1997-02-03 00:00:00	1997-03-05	1997-03-05 00:00:00	1997-03-05	38000177		0	0	30		0	0	0	147320	0	313782	1127433		
45489	992	40213227	2014-10-12	2014-10-12 00:00:00	2014-10-12	2014-10-12 00:00:00	2014-10-12	581452		0	0	0		0	0	0	65805	0	113	40213227		
49925	4142	1118084	2019-01-21	2019-01-21 00:00:00	2019-01-21	2019-01-21 00:00:00	\N	38000177		0	0	0		0	0	0	275318	0	00025152531	44923712		
96982	2127	40213227	1992-01-11	1992-01-11 00:00:00	1992-01-11	1992-01-11 00:00:00	1992-01-11	581452		0	0	0		0	0	0	141474	0	113	40213227		
18714	1545	1127433	1992-12-30	1992-12-30 00:00:00	1993-01-27	1993-01-27 00:00:00	1993-01-27	38000177		0	0	28		0	0	0	103509	0	313782	1127433		
23044	1900	19133873	1966-09-10	1966-09-10 00:00:00	1966-09-19	1966-09-19 00:00:00	1966-09-19	38000177		0	0	9		0	0	0	126462	0	834061	19133873		
18885	409	40213198	2016-01-01	2016-01-01 00:00:00	2016-01-01	2016-01-01 00:00:00	2016-01-01	581452		0	0	0		0	0	0	27041	0	133	40213198		
347	28	1127078	1979-11-30	1979-11-30 00:00:00	1979-12-14	1979-12-14 00:00:00	1979-12-14	38000177		0	0	14		0	0	0	1958	0	282464	1127078		
20950	1727	19078461	1991-06-10	1991-06-10 00:00:00	1991-07-01	1991-07-01 00:00:00	1991-07-01	38000177		0	0	21		0	0	0	115473	0	310965	19078461		
8796	733	1713671	1961-04-29	1961-04-29 00:00:00	1961-05-06	1961-05-06 00:00:00	1961-05-06	38000177		0	0	7		0	0	0	48659	0	562251	1713671		
43880	3636	1127078	1981-12-24	1981-12-24 00:00:00	1982-01-23	1982-01-23 00:00:00	1982-01-23	38000177		0	0	30		0	0	0	241832	0	282464	1127078		
43932	3639	19059056	1961-02-16	1961-02-16 00:00:00	1961-03-09	1961-03-09 00:00:00	1961-03-09	38000177		0	0	21		0	0	0	242121	0	243670	19059056		
97481	2136	40213296	2008-06-07	2008-06-07 00:00:00	2008-06-07	2008-06-07 00:00:00	2008-06-07	581452		0	0	0		0	0	0	142238	0	52	40213296		
194326	4270	40213260	2018-01-23	2018-01-23 00:00:00	2018-01-23	2018-01-23 00:00:00	2018-01-23	581452		0	0	0		0	0	0	283415	0	121	40213260		
229482	5044	40213306	1995-01-18	1995-01-18 00:00:00	1995-01-18	1995-01-18 00:00:00	1995-01-18	581452		0	0	0		0	0	0	335187	0	43	40213306		
130270	2863	40213160	1966-08-25	1966-08-25 00:00:00	1966-08-25	1966-08-25 00:00:00	1966-08-25	581452		0	0	0		0	0	0	190402	0	10	40213160		
2718	219	19074679	1975-05-24	1975-05-24 00:00:00	1975-08-02	1975-08-02 00:00:00	1975-08-02	38000177		0	0	70		0	0	0	14751	0	308971	19074679		
239996	5268	40213296	2007-07-15	2007-07-15 00:00:00	2007-07-15	2007-07-15 00:00:00	2007-07-15	581452		0	0	0		0	0	0	350488	0	52	40213296		
49318	4091	1118084	2009-05-29	2009-05-29 00:00:00	2009-05-29	2009-05-29 00:00:00	\N	38000177		0	0	0		0	0	0	272002	0	00025152531	44923712		
40668	3371	19078461	1996-08-13	1996-08-13 00:00:00	1996-09-03	1996-09-03 00:00:00	1996-09-03	38000177		0	0	21		0	0	0	223672	0	310965	19078461		
6546	550	1118084	1956-07-02	1956-07-02 00:00:00	1956-07-02	1956-07-02 00:00:00	\N	38000177		0	0	0		0	0	0	36452	0	00025152531	44923712		
47860	3968	1713671	1921-07-03	1921-07-03 00:00:00	1921-07-10	1921-07-10 00:00:00	1921-07-10	38000177		0	0	7		0	0	0	263894	0	562251	1713671		
34037	2813	19129655	1961-09-26	1961-09-26 00:00:00	1961-10-10	1961-10-10 00:00:00	1961-10-10	38000177		0	0	14		0	0	0	186370	0	789980	19129655		
141982	3119	40213314	1977-05-23	1977-05-23 00:00:00	1977-05-23	1977-05-23 00:00:00	1977-05-23	581452		0	0	0		0	0	0	207549	0	49	40213314		
66120	1447	40213227	1999-02-25	1999-02-25 00:00:00	1999-02-25	1999-02-25 00:00:00	1999-02-25	581452		0	0	0		0	0	0	96532	0	113	40213227		
34137	2822	1127433	1980-06-01	1980-06-01 00:00:00	1980-06-08	1980-06-08 00:00:00	1980-06-08	38000177		0	0	7		0	0	0	187034	0	313782	1127433		
180002	3957	40213160	1960-09-01	1960-09-01 00:00:00	1960-09-01	1960-09-01 00:00:00	1960-09-01	581452		0	0	0		0	0	0	263128	0	10	40213160		
23884	1966	1127433	1978-10-24	1978-10-24 00:00:00	1978-11-07	1978-11-07 00:00:00	1978-11-07	38000177		0	0	14		0	0	0	130704	0	313782	1127433		
7140	600	40243436	1997-02-19	1997-02-19 00:00:00	1997-02-19	1997-02-19 00:00:00	1997-02-19	38000177		0	0	0		0	0	0	39649	0	1190795	40243436		
54433	4525	1127433	2007-05-23	2007-05-23 00:00:00	2007-05-30	2007-05-30 00:00:00	2007-05-30	38000177		0	0	7		0	0	0	301289	0	313782	1127433		
72661	1588	40213160	1961-08-13	1961-08-13 00:00:00	1961-08-13	1961-08-13 00:00:00	1961-08-13	581452		0	0	0		0	0	0	106621	0	10	40213160		
162752	3579	40213227	1996-03-02	1996-03-02 00:00:00	1996-03-02	1996-03-02 00:00:00	1996-03-02	581452		0	0	0		0	0	0	237942	0	113	40213227		
140389	3082	40213260	2016-08-10	2016-08-10 00:00:00	2016-08-10	2016-08-10 00:00:00	2016-08-10	581452		0	0	0		0	0	0	205234	0	121	40213260		
45088	3731	1127433	1999-10-16	1999-10-16 00:00:00	1999-10-23	1999-10-23 00:00:00	1999-10-23	38000177		0	0	7		0	0	0	247917	0	313782	1127433		
136104	2988	40213227	2013-10-27	2013-10-27 00:00:00	2013-10-27	2013-10-27 00:00:00	2013-10-27	581452		0	0	0		0	0	0	199458	0	113	40213227		
69418	1518	40213260	2006-07-28	2006-07-28 00:00:00	2006-07-28	2006-07-28 00:00:00	2006-07-28	581452		0	0	0		0	0	0	101569	0	121	40213260		
79233	1733	40213306	2002-04-17	2002-04-17 00:00:00	2002-04-17	2002-04-17 00:00:00	2002-04-17	581452		0	0	0		0	0	0	\N	0	43	40213306		
162283	3569	40213260	2009-10-20	2009-10-20 00:00:00	2009-10-20	2009-10-20 00:00:00	2009-10-20	581452		0	0	0		0	0	0	237125	0	121	40213260		
28379	2341	19133873	1961-05-21	1961-05-21 00:00:00	1961-06-02	1961-06-02 00:00:00	1961-06-02	38000177		0	0	12		0	0	0	155785	0	834061	19133873		
109452	2402	40213314	1977-02-21	1977-02-21 00:00:00	1977-02-21	1977-02-21 00:00:00	1977-02-21	581452		0	0	0		0	0	0	159641	0	49	40213314		
28941	2392	1127433	2013-09-25	2013-09-25 00:00:00	2013-10-09	2013-10-09 00:00:00	2013-10-09	38000177		0	0	14		0	0	0	159092	0	313782	1127433		
204563	4491	40213201	2012-08-12	2012-08-12 00:00:00	2012-08-12	2012-08-12 00:00:00	2012-08-12	581452		0	0	0		0	0	0	299010	0	33	40213201		
197097	4331	40213160	1975-02-21	1975-02-21 00:00:00	1975-02-21	1975-02-21 00:00:00	1975-02-21	581452		0	0	0		0	0	0	287330	0	10	40213160		
203956	4477	40213227	2014-11-27	2014-11-27 00:00:00	2014-11-27	2014-11-27 00:00:00	2014-11-27	581452		0	0	0		0	0	0	297930	0	113	40213227		
57509	4773	1713671	1992-10-06	1992-10-06 00:00:00	1992-10-27	1992-10-27 00:00:00	1992-10-27	38000177		0	0	21		0	0	0	317905	0	562251	1713671		
13014	1092	19133873	1967-01-06	1967-01-06 00:00:00	1967-01-17	1967-01-17 00:00:00	1967-01-17	38000177		0	0	11		0	0	0	71815	0	834061	19133873		
18556	1535	19073188	1999-12-26	1999-12-26 00:00:00	2000-01-09	2000-01-09 00:00:00	2000-01-09	38000177		0	0	14		0	0	0	102705	0	308192	19073188		
186173	4090	40213227	2013-07-22	2013-07-22 00:00:00	2013-07-22	2013-07-22 00:00:00	2013-07-22	581452		0	0	0		0	0	0	271931	0	113	40213227		
29092	2409	1127078	1989-07-05	1989-07-05 00:00:00	1989-07-19	1989-07-19 00:00:00	1989-07-19	38000177		0	0	14		0	0	0	159943	0	282464	1127078		
137913	3028	40213260	2009-04-23	2009-04-23 00:00:00	2009-04-23	2009-04-23 00:00:00	2009-04-23	581452		0	0	0		0	0	0	201876	0	121	40213260		
173490	3814	40213314	1977-05-08	1977-05-08 00:00:00	1977-05-08	1977-05-08 00:00:00	1977-05-08	581452		0	0	0		0	0	0	253331	0	49	40213314		
56149	4662	19059056	1966-12-23	1966-12-23 00:00:00	1967-01-13	1967-01-13 00:00:00	1967-01-13	38000177		0	0	21		0	0	0	310772	0	243670	19059056		
2071	163	1127433	2001-04-28	2001-04-28 00:00:00	2001-05-12	2001-05-12 00:00:00	2001-05-12	38000177		0	0	14		0	0	0	11197	0	313782	1127433		
17941	1486	1127433	2007-06-16	2007-06-16 00:00:00	2007-06-23	2007-06-23 00:00:00	2007-06-23	38000177		0	0	7		0	0	0	99152	0	313782	1127433		
152416	3355	40213260	2012-10-05	2012-10-05 00:00:00	2012-10-05	2012-10-05 00:00:00	2012-10-05	581452		0	0	0		0	0	0	222475	0	121	40213260		
147460	3242	40213314	1980-08-23	1980-08-23 00:00:00	1980-08-23	1980-08-23 00:00:00	1980-08-23	581452		0	0	0		0	0	0	215594	0	49	40213314		
146502	3222	40213198	2016-06-21	2016-06-21 00:00:00	2016-06-21	2016-06-21 00:00:00	2016-06-21	581452		0	0	0		0	0	0	214168	0	133	40213198		
163816	3603	40213306	1989-07-16	1989-07-16 00:00:00	1989-07-16	1989-07-16 00:00:00	1989-07-16	581452		0	0	0		0	0	0	239308	0	43	40213306		
98139	2149	40213296	2001-04-28	2001-04-28 00:00:00	2001-04-28	2001-04-28 00:00:00	2001-04-28	581452		0	0	0		0	0	0	143091	0	52	40213296		
16148	1339	19133873	1968-05-04	1968-05-04 00:00:00	1968-05-17	1968-05-17 00:00:00	1968-05-17	38000177		0	0	13		0	0	0	88800	0	834061	19133873		
147961	3253	40213160	1970-08-25	1970-08-25 00:00:00	1970-08-25	1970-08-25 00:00:00	1970-08-25	581452		0	0	0		0	0	0	216282	0	10	40213160		
56784	4712	1127433	1988-03-04	1988-03-04 00:00:00	1988-03-18	1988-03-18 00:00:00	1988-03-18	38000177		0	0	14		0	0	0	313756	0	313782	1127433		
236526	5194	40213227	2017-03-23	2017-03-23 00:00:00	2017-03-23	2017-03-23 00:00:00	2017-03-23	581452		0	0	0		0	0	0	345381	0	113	40213227		
175372	3856	40213296	2015-10-14	2015-10-14 00:00:00	2015-10-14	2015-10-14 00:00:00	2015-10-14	581452		0	0	0		0	0	0	255948	0	52	40213296		
26845	2211	1118084	2007-01-27	2007-01-27 00:00:00	2007-01-27	2007-01-27 00:00:00	\N	38000177		0	0	0		0	0	0	147315	0	00025152531	44923712		
45497	992	40213160	1958-03-30	1958-03-30 00:00:00	1958-03-30	1958-03-30 00:00:00	1958-03-30	581452		0	0	0		0	0	0	65783	0	10	40213160		
49926	4142	1127433	2000-07-05	2000-07-05 00:00:00	2000-07-12	2000-07-12 00:00:00	2000-07-12	38000177		0	0	7		0	0	0	275337	0	313782	1127433		
96990	2127	40213160	1961-02-11	1961-02-11 00:00:00	1961-02-11	1961-02-11 00:00:00	1961-02-11	581452		0	0	0		0	0	0	141440	0	10	40213160		
18715	1545	40236446	1981-12-03	1981-12-03 00:00:00	1986-12-12	1986-12-12 00:00:00	1986-12-12	38000177		0	0	1835		0	0	0	103539	0	1091392	40236446		
23045	1900	19133873	1980-08-27	1980-08-27 00:00:00	1980-09-04	1980-09-04 00:00:00	1980-09-04	38000177		0	0	8		0	0	0	126451	0	834061	19133873		
18895	409	40213227	2011-12-09	2011-12-09 00:00:00	2011-12-09	2011-12-09 00:00:00	2011-12-09	581452		0	0	0		0	0	0	27070	0	113	40213227		
348	28	19073183	1979-11-30	1979-11-30 00:00:00	1979-12-14	1979-12-14 00:00:00	1979-12-14	38000177		0	0	14		0	0	0	1958	0	308182	19073183		
20951	1727	40162522	1977-02-22	1977-02-22 00:00:00	1977-02-22	1977-02-22 00:00:00	\N	38000177		0	0	0		0	0	0	115481	0	857005	40162522		
8797	733	40165015	1959-08-29	1959-08-29 00:00:00	1959-08-29	1959-08-29 00:00:00	\N	38000177		0	0	0		0	0	0	48597	0	861467	40165015		
43881	3636	1127433	1997-10-13	1997-10-13 00:00:00	1997-10-27	1997-10-27 00:00:00	1997-10-27	38000177		0	0	14		0	0	0	241866	0	313782	1127433		
43933	3639	1118084	1957-01-18	1957-01-18 00:00:00	1957-01-18	1957-01-18 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00025152531	44923712		
97484	2136	40213227	1999-08-14	1999-08-14 00:00:00	1999-08-14	1999-08-14 00:00:00	1999-08-14	581452		0	0	0		0	0	0	142311	0	113	40213227		
194331	4270	40213227	2009-01-27	2009-01-27 00:00:00	2009-01-27	2009-01-27 00:00:00	2009-01-27	581452		0	0	0		0	0	0	283414	0	113	40213227		
229490	5044	40213306	1993-05-26	1993-05-26 00:00:00	1993-05-26	1993-05-26 00:00:00	1993-05-26	581452		0	0	0		0	0	0	\N	0	43	40213306		
130273	2863	40213227	1993-04-01	1993-04-01 00:00:00	1993-04-01	1993-04-01 00:00:00	1993-04-01	581452		0	0	0		0	0	0	190393	0	113	40213227		
2719	219	19074679	1977-03-26	1977-03-26 00:00:00	1979-06-30	1979-06-30 00:00:00	1979-06-30	38000177		0	0	826		0	0	0	14753	0	308971	19074679		
239999	5268	40213296	2005-07-10	2005-07-10 00:00:00	2005-07-10	2005-07-10 00:00:00	2005-07-10	581452		0	0	0		0	0	0	350538	0	52	40213296		
49319	4091	19078461	2015-03-31	2015-03-31 00:00:00	2015-04-21	2015-04-21 00:00:00	2015-04-21	38000177		0	0	21		0	0	0	271944	0	310965	19078461		
40669	3371	19128065	1997-06-30	1997-06-30 00:00:00	1998-06-25	1998-06-25 00:00:00	1998-06-25	38000177		0	0	360		0	0	0	223652	0	749882	19128065		
6547	550	1127433	1966-08-23	1966-08-23 00:00:00	1966-09-06	1966-09-06 00:00:00	1966-09-06	38000177		0	0	14		0	0	0	36439	0	313782	1127433		
47861	3968	1127433	1954-01-03	1954-01-03 00:00:00	1954-02-02	1954-02-02 00:00:00	1954-02-02	38000177		0	0	30		0	0	0	263905	0	313782	1127433		
34038	2813	19059056	1937-09-09	1937-09-09 00:00:00	1937-09-23	1937-09-23 00:00:00	1937-09-23	38000177		0	0	14		0	0	0	186412	0	243670	19059056		
141985	3119	40213227	2016-06-27	2016-06-27 00:00:00	2016-06-27	2016-06-27 00:00:00	2016-06-27	581452		0	0	0		0	0	0	207582	0	113	40213227		
66121	1447	40213296	1999-02-25	1999-02-25 00:00:00	1999-02-25	1999-02-25 00:00:00	1999-02-25	581452		0	0	0		0	0	0	96532	0	52	40213296		
34138	2822	19059056	1983-07-06	1983-07-06 00:00:00	1983-07-27	1983-07-27 00:00:00	1983-07-27	38000177		0	0	21		0	0	0	187030	0	243670	19059056		
180011	3957	40213260	2006-01-12	2006-01-12 00:00:00	2006-01-12	2006-01-12 00:00:00	2006-01-12	581452		0	0	0		0	0	0	263117	0	121	40213260		
23885	1966	19133873	1973-04-25	1973-04-25 00:00:00	1973-05-02	1973-05-02 00:00:00	1973-05-02	38000177		0	0	7		0	0	0	130671	0	834061	19133873		
7141	600	1310034	1997-02-19	1997-02-19 00:00:00	1997-02-19	1997-02-19 00:00:00	1997-02-19	38000177		0	0	0		0	0	0	39649	0	834357	1310034		
54434	4525	1713671	1986-08-24	1986-08-24 00:00:00	1986-08-31	1986-08-31 00:00:00	1986-08-31	38000177		0	0	7		0	0	0	301301	0	562251	1713671		
183558	4032	40213227	2018-09-04	2018-09-04 00:00:00	2018-09-04	2018-09-04 00:00:00	2018-09-04	581452		0	0	0		0	0	0	268286	0	113	40213227		
162756	3579	40213296	2006-11-11	2006-11-11 00:00:00	2006-11-11	2006-11-11 00:00:00	2006-11-11	581452		0	0	0		0	0	0	237936	0	52	40213296		
45045	3728	1127433	2012-05-03	2012-05-03 00:00:00	2012-05-17	2012-05-17 00:00:00	2012-05-17	38000177		0	0	14		0	0	0	247719	0	313782	1127433		
45089	3731	1127433	1978-10-28	1978-10-28 00:00:00	1978-11-04	1978-11-04 00:00:00	1978-11-04	38000177		0	0	7		0	0	0	247913	0	313782	1127433		
136105	2988	40213260	2013-10-27	2013-10-27 00:00:00	2013-10-27	2013-10-27 00:00:00	2013-10-27	581452		0	0	0		0	0	0	199458	0	121	40213260		
69431	1518	40213198	2019-06-28	2019-06-28 00:00:00	2019-06-28	2019-06-28 00:00:00	2019-06-28	581452		0	0	0		0	0	0	101561	0	133	40213198		
80751	1766	40213201	2019-04-02	2019-04-02 00:00:00	2019-04-02	2019-04-02 00:00:00	2019-04-02	581452		0	0	0		0	0	0	118199	0	33	40213201		
102297	2242	40213227	2008-10-04	2008-10-04 00:00:00	2008-10-04	2008-10-04 00:00:00	2008-10-04	581452		0	0	0		0	0	0	149290	0	113	40213227		
28380	2341	1127433	2008-03-26	2008-03-26 00:00:00	2008-04-02	2008-04-02 00:00:00	2008-04-02	38000177		0	0	7		0	0	0	155819	0	313782	1127433		
109453	2402	40213160	1977-02-21	1977-02-21 00:00:00	1977-02-21	1977-02-21 00:00:00	1977-02-21	581452		0	0	0		0	0	0	159641	0	10	40213160		
28942	2392	19059056	1926-05-12	1926-05-12 00:00:00	1926-06-02	1926-06-02 00:00:00	1926-06-02	38000177		0	0	21		0	0	0	159008	0	243670	19059056		
132822	2917	40213227	2007-12-26	2007-12-26 00:00:00	2007-12-26	2007-12-26 00:00:00	2007-12-26	581452		0	0	0		0	0	0	194508	0	113	40213227		
197102	4331	40213227	2006-01-27	2006-01-27 00:00:00	2006-01-27	2006-01-27 00:00:00	2006-01-27	581452		0	0	0		0	0	0	287296	0	113	40213227		
203957	4477	40213260	2014-11-27	2014-11-27 00:00:00	2014-11-27	2014-11-27 00:00:00	2014-11-27	581452		0	0	0		0	0	0	297930	0	121	40213260		
57510	4773	19059056	1964-09-24	1964-09-24 00:00:00	1964-10-29	1964-10-29 00:00:00	1964-10-29	38000177		0	0	35		0	0	0	317890	0	243670	19059056		
13015	1092	40231925	1997-03-20	1997-03-20 00:00:00	1997-03-20	1997-03-20 00:00:00	\N	38000177		0	0	0		0	0	0	71835	0	1049221	40231925		
18557	1535	1115171	1999-12-26	1999-12-26 00:00:00	2000-01-09	2000-01-09 00:00:00	2000-01-09	38000177		0	0	14		0	0	0	102705	0	849574	1115171		
186180	4090	40213198	2010-07-05	2010-07-05 00:00:00	2010-07-05	2010-07-05 00:00:00	2010-07-05	581452		0	0	0		0	0	0	271877	0	133	40213198		
29093	2409	1127433	2008-06-14	2008-06-14 00:00:00	2008-06-21	2008-06-21 00:00:00	2008-06-21	38000177		0	0	7		0	0	0	159903	0	313782	1127433		
137920	3028	40213296	1999-04-29	1999-04-29 00:00:00	1999-04-29	1999-04-29 00:00:00	1999-04-29	581452		0	0	0		0	0	0	201874	0	52	40213296		
173491	3814	40213314	1977-08-28	1977-08-28 00:00:00	1977-08-28	1977-08-28 00:00:00	1977-08-28	581452		0	0	0		0	0	0	253321	0	49	40213314		
56150	4662	1127433	2003-12-27	2003-12-27 00:00:00	2004-01-03	2004-01-03 00:00:00	2004-01-03	38000177		0	0	7		0	0	0	310734	0	313782	1127433		
2072	163	1127433	1980-02-02	1980-02-02 00:00:00	1980-02-16	1980-02-16 00:00:00	1980-02-16	38000177		0	0	14		0	0	0	11215	0	313782	1127433		
17942	1486	1310034	2001-12-23	2001-12-23 00:00:00	2001-12-23	2001-12-23 00:00:00	2001-12-23	38000177		0	0	0		0	0	0	99029	0	834357	1310034		
152422	3355	40213227	1993-12-17	1993-12-17 00:00:00	1993-12-17	1993-12-17 00:00:00	1993-12-17	581452		0	0	0		0	0	0	222501	0	113	40213227		
147461	3242	40213160	1980-08-23	1980-08-23 00:00:00	1980-08-23	1980-08-23 00:00:00	1980-08-23	581452		0	0	0		0	0	0	215594	0	10	40213160		
223538	4907	40213227	2007-08-11	2007-08-11 00:00:00	2007-08-11	2007-08-11 00:00:00	2007-08-11	581452		0	0	0		0	0	0	326152	0	113	40213227		
163822	3603	40213260	2016-02-07	2016-02-07 00:00:00	2016-02-07	2016-02-07 00:00:00	2016-02-07	581452		0	0	0		0	0	0	239342	0	121	40213260		
98141	2149	40213227	2001-04-28	2001-04-28 00:00:00	2001-04-28	2001-04-28 00:00:00	2001-04-28	581452		0	0	0		0	0	0	143091	0	113	40213227		
16149	1339	1127078	1970-04-23	1970-04-23 00:00:00	1970-05-28	1970-05-28 00:00:00	1970-05-28	38000177		0	0	35		0	0	0	88789	0	282464	1127078		
147967	3253	40213160	1971-01-26	1971-01-26 00:00:00	1971-01-26	1971-01-26 00:00:00	1971-01-26	581452		0	0	0		0	0	0	216306	0	10	40213160		
56785	4713	1127078	1970-12-12	1970-12-12 00:00:00	1971-01-11	1971-01-11 00:00:00	1971-01-11	38000177		0	0	30		0	0	0	313861	0	282464	1127078		
236532	5194	40213198	2011-02-17	2011-02-17 00:00:00	2011-02-17	2011-02-17 00:00:00	2011-02-17	581452		0	0	0		0	0	0	345335	0	133	40213198		
175376	3856	40213160	1974-03-13	1974-03-13 00:00:00	1974-03-13	1974-03-13 00:00:00	1974-03-13	581452		0	0	0		0	0	0	255924	0	10	40213160		
26846	2211	40236446	1985-06-16	1985-06-16 00:00:00	1986-10-19	1986-10-19 00:00:00	1986-10-19	38000177		0	0	490		0	0	0	147322	0	1091392	40236446		
45500	992	40213160	1955-01-30	1955-01-30 00:00:00	1955-01-30	1955-01-30 00:00:00	1955-01-30	581452		0	0	0		0	0	0	65754	0	10	40213160		
49927	4142	1127433	1998-12-12	1998-12-12 00:00:00	1999-01-02	1999-01-02 00:00:00	1999-01-02	38000177		0	0	21		0	0	0	275291	0	313782	1127433		
96997	2127	40213227	2011-09-10	2011-09-10 00:00:00	2011-09-10	2011-09-10 00:00:00	2011-09-10	581452		0	0	0		0	0	0	141506	0	113	40213227		
18716	1545	1115171	2000-12-16	2000-12-16 00:00:00	2001-02-14	2001-02-14 00:00:00	2001-02-14	38000177		0	0	60		0	0	0	103511	0	849574	1115171		
23046	1900	1713671	2003-01-21	2003-01-21 00:00:00	2003-01-28	2003-01-28 00:00:00	2003-01-28	38000177		0	0	7		0	0	0	126455	0	562251	1713671		
60357	1320	40213201	2001-07-19	2001-07-19 00:00:00	2001-07-19	2001-07-19 00:00:00	2001-07-19	581452		0	0	0		0	0	0	87541	0	33	40213201		
349	28	1124300	2015-05-10	2015-05-10 00:00:00	2015-05-10	2015-05-10 00:00:00	\N	38000177		0	0	0		0	0	0	1995	0	00781178901	45011828		
20952	1727	19059056	1977-02-22	1977-02-22 00:00:00	1977-03-24	1977-03-24 00:00:00	1977-03-24	38000177		0	0	30		0	0	0	115481	0	243670	19059056		
8798	733	19059056	1959-08-29	1959-08-29 00:00:00	1959-11-27	1959-11-27 00:00:00	1959-11-27	38000177		0	0	90		0	0	0	48597	0	243670	19059056		
43883	3636	1127433	2010-02-10	2010-02-10 00:00:00	2010-02-17	2010-02-17 00:00:00	2010-02-17	38000177		0	0	7		0	0	0	241841	0	313782	1127433		
43934	3639	1127433	1994-03-15	1994-03-15 00:00:00	1994-03-22	1994-03-22 00:00:00	1994-03-22	38000177		0	0	7		0	0	0	242160	0	313782	1127433		
92431	2028	40213198	2011-04-06	2011-04-06 00:00:00	2011-04-06	2011-04-06 00:00:00	2011-04-06	581452		0	0	0		0	0	0	134961	0	133	40213198		
194332	4270	40213296	2009-01-27	2009-01-27 00:00:00	2009-01-27	2009-01-27 00:00:00	2009-01-27	581452		0	0	0		0	0	0	283414	0	52	40213296		
229492	5044	40213314	1977-10-26	1977-10-26 00:00:00	1977-10-26	1977-10-26 00:00:00	1977-10-26	581452		0	0	0		0	0	0	335225	0	49	40213314		
130278	2863	40213227	2012-12-13	2012-12-13 00:00:00	2012-12-13	2012-12-13 00:00:00	2012-12-13	581452		0	0	0		0	0	0	190366	0	113	40213227		
2720	219	19074679	1974-03-29	1974-03-29 00:00:00	1974-06-07	1974-06-07 00:00:00	1974-06-07	38000177		0	0	70		0	0	0	14749	0	308971	19074679		
240002	5268	40213260	2015-06-28	2015-06-28 00:00:00	2015-06-28	2015-06-28 00:00:00	2015-06-28	581452		0	0	0		0	0	0	350489	0	121	40213260		
49320	4091	1127433	2012-09-28	2012-09-28 00:00:00	2012-10-12	2012-10-12 00:00:00	2012-10-12	38000177		0	0	14		0	0	0	271943	0	313782	1127433		
40670	3371	19128065	2001-06-09	2001-06-09 00:00:00	2002-06-04	2002-06-04 00:00:00	2002-06-04	38000177		0	0	360		0	0	0	223653	0	749882	19128065		
6554	552	1127078	1962-01-23	1962-01-23 00:00:00	1962-03-24	1962-03-24 00:00:00	1962-03-24	38000177		0	0	60		0	0	0	36594	0	282464	1127078		
47862	3968	19133905	1985-05-02	1985-05-02 00:00:00	1985-05-15	1985-05-15 00:00:00	1985-05-15	38000177		0	0	13		0	0	0	263839	0	834102	19133905		
86197	1889	40213314	1984-01-26	1984-01-26 00:00:00	1984-01-26	1984-01-26 00:00:00	1984-01-26	581452		0	0	0		0	0	0	125940	0	49	40213314		
141986	3119	40213296	2016-06-27	2016-06-27 00:00:00	2016-06-27	2016-06-27 00:00:00	2016-06-27	581452		0	0	0		0	0	0	207582	0	52	40213296		
66122	1447	40213296	2001-03-01	2001-03-01 00:00:00	2001-03-01	2001-03-01 00:00:00	2001-03-01	581452		0	0	0		0	0	0	96514	0	52	40213296		
34139	2822	1127433	1996-09-30	1996-09-30 00:00:00	1996-10-14	1996-10-14 00:00:00	1996-10-14	38000177		0	0	14		0	0	0	186997	0	313782	1127433		
180019	3957	40213227	1996-10-03	1996-10-03 00:00:00	1996-10-03	1996-10-03 00:00:00	1996-10-03	581452		0	0	0		0	0	0	\N	0	113	40213227		
23886	1966	40236824	1992-05-31	1992-05-31 00:00:00	1992-06-07	1992-06-07 00:00:00	1992-06-07	38000177		0	0	7		0	0	0	130716	0	1094107	40236824		
7142	600	46275916	1997-02-19	1997-02-19 00:00:00	1997-02-19	1997-02-19 00:00:00	1997-02-19	38000177		0	0	0		0	0	0	39649	0	1660014	46275916		
54435	4525	19059056	1973-06-03	1973-06-03 00:00:00	1973-06-24	1973-06-24 00:00:00	1973-06-24	38000177		0	0	21		0	0	0	301266	0	243670	19059056		
183566	4032	40213160	1955-06-14	1955-06-14 00:00:00	1955-06-14	1955-06-14 00:00:00	1955-06-14	581452		0	0	0		0	0	0	268205	0	10	40213160		
162758	3579	40213227	2006-11-11	2006-11-11 00:00:00	2006-11-11	2006-11-11 00:00:00	2006-11-11	581452		0	0	0		0	0	0	237936	0	113	40213227		
45046	3728	19059056	1984-09-09	1984-09-09 00:00:00	1984-09-23	1984-09-23 00:00:00	1984-09-23	38000177		0	0	14		0	0	0	247751	0	243670	19059056		
45090	3731	19078461	1991-05-20	1991-05-20 00:00:00	1991-08-18	1991-08-18 00:00:00	1991-08-18	38000177		0	0	90		0	0	0	247938	0	310965	19078461		
136107	2988	40213227	2004-10-31	2004-10-31 00:00:00	2004-10-31	2004-10-31 00:00:00	2004-10-31	581452		0	0	0		0	0	0	199477	0	113	40213227		
69438	1518	40213227	2015-06-05	2015-06-05 00:00:00	2015-06-05	2015-06-05 00:00:00	2015-06-05	581452		0	0	0		0	0	0	101559	0	113	40213227		
80753	1766	40213160	1955-05-31	1955-05-31 00:00:00	1955-05-31	1955-05-31 00:00:00	1955-05-31	581452		0	0	0		0	0	0	118152	0	10	40213160		
102320	2242	40213201	1993-07-10	1993-07-10 00:00:00	1993-07-10	1993-07-10 00:00:00	1993-07-10	581452		0	0	0		0	0	0	149294	0	33	40213201		
28382	2341	19006318	1953-09-18	1953-09-18 00:00:00	1953-10-02	1953-10-02 00:00:00	1953-10-02	38000177		0	0	14		0	0	0	155840	0	105078	19006318		
187824	4125	40213227	1998-12-15	1998-12-15 00:00:00	1998-12-15	1998-12-15 00:00:00	1998-12-15	581452		0	0	0		0	0	0	274269	0	113	40213227		
28943	2392	1127433	1954-10-08	1954-10-08 00:00:00	1954-10-29	1954-10-29 00:00:00	1954-10-29	38000177		0	0	21		0	0	0	159011	0	313782	1127433		
132835	2917	40213227	1997-10-29	1997-10-29 00:00:00	1997-10-29	1997-10-29 00:00:00	1997-10-29	581452		0	0	0		0	0	0	194518	0	113	40213227		
197107	4331	40213227	2016-11-25	2016-11-25 00:00:00	2016-11-25	2016-11-25 00:00:00	2016-11-25	581452		0	0	0		0	0	0	287297	0	113	40213227		
203958	4477	40213296	2003-11-27	2003-11-27 00:00:00	2003-11-27	2003-11-27 00:00:00	2003-11-27	581452		0	0	0		0	0	0	297975	0	52	40213296		
57511	4773	19006318	1964-09-24	1964-09-24 00:00:00	1964-10-29	1964-10-29 00:00:00	1964-10-29	38000177		0	0	35		0	0	0	317890	0	105078	19006318		
13016	1092	19133873	1959-08-21	1959-08-21 00:00:00	1959-08-29	1959-08-29 00:00:00	1959-08-29	38000177		0	0	8		0	0	0	71755	0	834061	19133873		
18558	1535	1127433	1995-11-21	1995-11-21 00:00:00	1995-11-28	1995-11-28 00:00:00	1995-11-28	38000177		0	0	7		0	0	0	102701	0	313782	1127433		
186187	4090	40213227	1993-03-29	1993-03-29 00:00:00	1993-03-29	1993-03-29 00:00:00	1993-03-29	581452		0	0	0		0	0	0	271865	0	113	40213227		
29094	2409	1127433	1993-11-12	1993-11-12 00:00:00	1993-11-26	1993-11-26 00:00:00	1993-11-26	38000177		0	0	14		0	0	0	159901	0	313782	1127433		
137926	3028	40213227	1993-07-29	1993-07-29 00:00:00	1993-07-29	1993-07-29 00:00:00	1993-07-29	581452		0	0	0		0	0	0	201867	0	113	40213227		
65393	1431	40213201	2016-01-02	2016-01-02 00:00:00	2016-01-02	2016-01-02 00:00:00	2016-01-02	581452		0	0	0		0	0	0	95236	0	33	40213201		
56151	4662	1124300	1994-06-10	1994-06-10 00:00:00	1994-06-10	1994-06-10 00:00:00	\N	38000177		0	0	0		0	0	0	310793	0	00781178901	45011828		
2073	163	19074841	1980-02-02	1980-02-02 00:00:00	1980-02-16	1980-02-16 00:00:00	1980-02-16	38000177		0	0	14		0	0	0	11215	0	309043	19074841		
17943	1486	46275916	2001-12-23	2001-12-23 00:00:00	2001-12-23	2001-12-23 00:00:00	2001-12-23	38000177		0	0	0		0	0	0	99029	0	1660014	46275916		
152424	3355	40213160	1967-09-15	1967-09-15 00:00:00	1967-09-15	1967-09-15 00:00:00	1967-09-15	581452		0	0	0		0	0	0	222525	0	10	40213160		
147464	3242	40213227	2002-07-13	2002-07-13 00:00:00	2002-07-13	2002-07-13 00:00:00	2002-07-13	581452		0	0	0		0	0	0	215605	0	113	40213227		
185046	4067	40213160	1971-12-04	1971-12-04 00:00:00	1971-12-04	1971-12-04 00:00:00	1971-12-04	581452		0	0	0		0	0	0	270253	0	10	40213160		
163825	3603	40213306	1986-07-13	1986-07-13 00:00:00	1986-07-13	1986-07-13 00:00:00	1986-07-13	581452		0	0	0		0	0	0	239307	0	43	40213306		
98151	2150	40213227	1992-01-31	1992-01-31 00:00:00	1992-01-31	1992-01-31 00:00:00	1992-01-31	581452		0	0	0		0	0	0	143227	0	113	40213227		
16150	1339	1127078	1968-12-29	1968-12-29 00:00:00	1969-03-29	1969-03-29 00:00:00	1969-03-29	38000177		0	0	90		0	0	0	88788	0	282464	1127078		
147982	3253	40213227	1992-07-21	1992-07-21 00:00:00	1992-07-21	1992-07-21 00:00:00	1992-07-21	581452		0	0	0		0	0	0	216353	0	113	40213227		
56786	4713	19129655	1970-11-12	1970-11-12 00:00:00	1970-11-26	1970-11-26 00:00:00	1970-11-26	38000177		0	0	14		0	0	0	313853	0	789980	19129655		
236536	5194	40213227	1997-02-13	1997-02-13 00:00:00	1997-02-13	1997-02-13 00:00:00	1997-02-13	581452		0	0	0		0	0	0	345279	0	113	40213227		
175378	3856	40213227	1996-08-21	1996-08-21 00:00:00	1996-08-21	1996-08-21 00:00:00	1996-08-21	581452		0	0	0		0	0	0	255929	0	113	40213227		
26847	2211	1127078	1973-04-10	1973-04-10 00:00:00	1973-06-09	1973-06-09 00:00:00	1973-06-09	38000177		0	0	60		0	0	0	147319	0	282464	1127078		
45990	1004	40213296	2002-10-17	2002-10-17 00:00:00	2002-10-17	2002-10-17 00:00:00	2002-10-17	581452		0	0	0		0	0	0	66340	0	52	40213296		
49928	4142	19133873	1992-10-28	1992-10-28 00:00:00	1992-11-04	1992-11-04 00:00:00	1992-11-04	38000177		0	0	7		0	0	0	275320	0	834061	19133873		
96998	2127	40213260	2011-09-10	2011-09-10 00:00:00	2011-09-10	2011-09-10 00:00:00	2011-09-10	581452		0	0	0		0	0	0	141506	0	121	40213260		
18717	1545	1124300	2006-05-16	2006-05-16 00:00:00	2006-05-16	2006-05-16 00:00:00	\N	38000177		0	0	0		0	0	0	103533	0	00781178901	45011828		
23051	1902	19006318	1946-11-12	1946-11-12 00:00:00	1946-11-26	1946-11-26 00:00:00	1946-11-26	38000177		0	0	14		0	0	0	126595	0	105078	19006318		
60364	1320	40213227	2015-10-08	2015-10-08 00:00:00	2015-10-08	2015-10-08 00:00:00	2015-10-08	581452		0	0	0		0	0	0	87534	0	113	40213227		
350	28	19059056	1991-06-30	1991-06-30 00:00:00	1991-07-21	1991-07-21 00:00:00	1991-07-21	38000177		0	0	21		0	0	0	1992	0	243670	19059056		
20953	1727	40169281	2000-04-06	2000-04-06 00:00:00	2000-04-06	2000-04-06 00:00:00	\N	38000177		0	0	0		0	0	0	115427	0	896209	40169281		
19257	1590	40229134	2006-10-23	2006-10-23 00:00:00	2006-11-05	2006-11-05 00:00:00	2006-11-05	38000177		0	0	13		0	0	0	106711	0	1043400	40229134		
43884	3636	40229134	1993-11-17	1993-11-17 00:00:00	1993-12-01	1993-12-01 00:00:00	1993-12-01	38000177		0	0	14		0	0	0	241780	0	1043400	40229134		
43935	3639	40223768	2001-01-13	2001-01-13 00:00:00	2001-01-13	2001-01-13 00:00:00	\N	38000177		0	0	0		0	0	0	242045	0	997223	40223768		
179889	3955	40213227	2017-05-06	2017-05-06 00:00:00	2017-05-06	2017-05-06 00:00:00	2017-05-06	581452		0	0	0		0	0	0	262857	0	113	40213227		
194334	4270	40213227	1998-01-27	1998-01-27 00:00:00	1998-01-27	1998-01-27 00:00:00	1998-01-27	581452		0	0	0		0	0	0	283406	0	113	40213227		
229494	5044	40213160	1977-10-26	1977-10-26 00:00:00	1977-10-26	1977-10-26 00:00:00	1977-10-26	581452		0	0	0		0	0	0	335225	0	10	40213160		
130279	2863	40213260	2012-12-13	2012-12-13 00:00:00	2012-12-13	2012-12-13 00:00:00	2012-12-13	581452		0	0	0		0	0	0	190366	0	121	40213260		
2721	219	40169216	1971-04-06	1971-04-06 00:00:00	1971-04-06	1971-04-06 00:00:00	\N	38000177		0	0	0		0	0	0	14767	0	895994	40169216		
240017	5268	40213260	2016-07-03	2016-07-03 00:00:00	2016-07-03	2016-07-03 00:00:00	2016-07-03	581452		0	0	0		0	0	0	350499	0	121	40213260		
49321	4091	1713671	2010-12-22	2010-12-22 00:00:00	2011-01-12	2011-01-12 00:00:00	2011-01-12	38000177		0	0	21		0	0	0	271949	0	562251	1713671		
51129	4247	19019979	1983-05-18	1983-05-18 00:00:00	1983-06-01	1983-06-01 00:00:00	1983-06-01	38000177		0	0	14		0	0	0	282000	0	198405	19019979		
6557	552	1127433	1991-08-31	1991-08-31 00:00:00	1991-09-14	1991-09-14 00:00:00	1991-09-14	38000177		0	0	14		0	0	0	36583	0	313782	1127433		
47863	3968	19059056	1936-10-29	1936-10-29 00:00:00	1936-11-19	1936-11-19 00:00:00	1936-11-19	38000177		0	0	21		0	0	0	263902	0	243670	19059056		
86198	1889	40213251	1984-01-26	1984-01-26 00:00:00	1984-01-26	1984-01-26 00:00:00	1984-01-26	581452		0	0	0		0	0	0	125940	0	21	40213251		
141990	3119	40213160	1974-09-23	1974-09-23 00:00:00	1974-09-23	1974-09-23 00:00:00	1974-09-23	581452		0	0	0		0	0	0	207567	0	10	40213160		
66125	1447	40213260	2009-01-22	2009-01-22 00:00:00	2009-01-22	2009-01-22 00:00:00	2009-01-22	581452		0	0	0		0	0	0	96500	0	121	40213260		
34140	2822	19006318	1976-12-18	1976-12-18 00:00:00	1977-01-01	1977-01-01 00:00:00	1977-01-01	38000177		0	0	14		0	0	0	186989	0	105078	19006318		
180020	3957	40213296	1996-10-03	1996-10-03 00:00:00	1996-10-03	1996-10-03 00:00:00	1996-10-03	581452		0	0	0		0	0	0	\N	0	52	40213296		
23887	1966	920300	1992-05-31	1992-05-31 00:00:00	1992-06-07	1992-06-07 00:00:00	1992-06-07	38000177		0	0	7		0	0	0	130716	0	311989	920300		
7143	600	1127433	2018-07-16	2018-07-16 00:00:00	2018-09-21	2018-09-21 00:00:00	2018-09-21	38000177		0	0	67		0	0	0	39652	0	313782	1127433		
54436	4525	1127433	2012-04-30	2012-04-30 00:00:00	2012-05-21	2012-05-21 00:00:00	2012-05-21	38000177		0	0	21		0	0	0	301267	0	313782	1127433		
183574	4033	40213296	2013-10-08	2013-10-08 00:00:00	2013-10-08	2013-10-08 00:00:00	2013-10-08	581452		0	0	0		0	0	0	268323	0	52	40213296		
162759	3579	40213227	2015-11-07	2015-11-07 00:00:00	2015-11-07	2015-11-07 00:00:00	2015-11-07	581452		0	0	0		0	0	0	237918	0	113	40213227		
45047	3728	1127433	1995-04-13	1995-04-13 00:00:00	1995-05-04	1995-05-04 00:00:00	1995-05-04	38000177		0	0	21		0	0	0	247696	0	313782	1127433		
45091	3731	1127433	2011-08-22	2011-08-22 00:00:00	2011-09-05	2011-09-05 00:00:00	2011-09-05	38000177		0	0	14		0	0	0	247918	0	313782	1127433		
136108	2988	40213296	2004-10-31	2004-10-31 00:00:00	2004-10-31	2004-10-31 00:00:00	2004-10-31	581452		0	0	0		0	0	0	199477	0	52	40213296		
69443	1518	40213160	1958-06-20	1958-06-20 00:00:00	1958-06-20	1958-06-20 00:00:00	1958-06-20	581452		0	0	0		0	0	0	101508	0	10	40213160		
80757	1766	40213227	2003-09-09	2003-09-09 00:00:00	2003-09-09	2003-09-09 00:00:00	2003-09-09	581452		0	0	0		0	0	0	118163	0	113	40213227		
102322	2242	40213227	2018-12-01	2018-12-01 00:00:00	2018-12-01	2018-12-01 00:00:00	2018-12-01	581452		0	0	0		0	0	0	149208	0	113	40213227		
28383	2341	1127078	1953-09-18	1953-09-18 00:00:00	1953-10-02	1953-10-02 00:00:00	1953-10-02	38000177		0	0	14		0	0	0	155840	0	282464	1127078		
187826	4125	40213227	2018-09-25	2018-09-25 00:00:00	2018-09-25	2018-09-25 00:00:00	2018-09-25	581452		0	0	0		0	0	0	274259	0	113	40213227		
28944	2392	40169281	1954-10-15	1954-10-15 00:00:00	1954-10-15	1954-10-15 00:00:00	\N	38000177		0	0	0		0	0	0	158999	0	896209	40169281		
217892	4781	40213160	1982-06-11	1982-06-11 00:00:00	1982-06-11	1982-06-11 00:00:00	1982-06-11	581452		0	0	0		0	0	0	318282	0	10	40213160		
197108	4331	40213296	2016-11-25	2016-11-25 00:00:00	2016-11-25	2016-11-25 00:00:00	2016-11-25	581452		0	0	0		0	0	0	287297	0	52	40213296		
204356	4485	40213198	2015-11-12	2015-11-12 00:00:00	2015-11-12	2015-11-12 00:00:00	2015-11-12	581452		0	0	0		0	0	0	298561	0	133	40213198		
57512	4773	1127433	2009-06-04	2009-06-04 00:00:00	2009-06-18	2009-06-18 00:00:00	2009-06-18	38000177		0	0	14		0	0	0	317852	0	313782	1127433		
49731	4125	1127433	1992-06-14	1992-06-14 00:00:00	1992-07-14	1992-07-14 00:00:00	1992-07-14	38000177		0	0	30		0	0	0	274215	0	313782	1127433		
18559	1535	1713671	1979-10-30	1979-10-30 00:00:00	1979-11-06	1979-11-06 00:00:00	1979-11-06	38000177		0	0	7		0	0	0	102759	0	562251	1713671		
139605	3067	40213227	2001-12-11	2001-12-11 00:00:00	2001-12-11	2001-12-11 00:00:00	2001-12-11	581452		0	0	0		0	0	0	204151	0	113	40213227		
29095	2409	40236824	2007-11-04	2007-11-04 00:00:00	2007-11-11	2007-11-11 00:00:00	2007-11-11	38000177		0	0	7		0	0	0	159902	0	1094107	40236824		
137937	3028	40213160	1959-12-31	1959-12-31 00:00:00	1959-12-31	1959-12-31 00:00:00	1959-12-31	581452		0	0	0		0	0	0	201882	0	10	40213160		
65423	1431	40213227	2010-12-04	2010-12-04 00:00:00	2010-12-04	2010-12-04 00:00:00	2010-12-04	581452		0	0	0		0	0	0	95232	0	113	40213227		
56152	4662	19059528	1989-07-27	1989-07-27 00:00:00	1989-07-27	1989-07-27 00:00:00	1989-07-27	38000177		0	0	0		0	0	0	310773	0	480	19059528		
2074	163	40236824	2007-08-19	2007-08-19 00:00:00	2007-08-26	2007-08-26 00:00:00	2007-08-26	38000177		0	0	7		0	0	0	11192	0	1094107	40236824		
17944	1486	40243436	2001-12-23	2001-12-23 00:00:00	2001-12-23	2001-12-23 00:00:00	2001-12-23	38000177		0	0	0		0	0	0	99029	0	1190795	40243436		
152430	3355	40213160	1963-06-14	1963-06-14 00:00:00	1963-06-14	1963-06-14 00:00:00	1963-06-14	581452		0	0	0		0	0	0	222497	0	10	40213160		
147465	3242	40213306	2002-07-13	2002-07-13 00:00:00	2002-07-13	2002-07-13 00:00:00	2002-07-13	581452		0	0	0		0	0	0	215605	0	43	40213306		
185055	4067	40213160	1971-09-04	1971-09-04 00:00:00	1971-09-04	1971-09-04 00:00:00	1971-09-04	581452		0	0	0		0	0	0	270209	0	10	40213160		
163830	3603	40213160	1966-07-17	1966-07-17 00:00:00	1966-07-17	1966-07-17 00:00:00	1966-07-17	581452		0	0	0		0	0	0	239371	0	10	40213160		
98154	2150	40213198	2015-04-17	2015-04-17 00:00:00	2015-04-17	2015-04-17 00:00:00	2015-04-17	581452		0	0	0		0	0	0	143185	0	133	40213198		
16151	1339	40229134	2018-07-16	2018-07-16 00:00:00	2018-07-23	2018-07-23 00:00:00	2018-07-23	38000177		0	0	7		0	0	0	88825	0	1043400	40229134		
147983	3253	40213306	1992-07-21	1992-07-21 00:00:00	1992-07-21	1992-07-21 00:00:00	1992-07-21	581452		0	0	0		0	0	0	216353	0	43	40213306		
56787	4713	1127078	1970-11-12	1970-11-12 00:00:00	1970-11-26	1970-11-26 00:00:00	1970-11-26	38000177		0	0	14		0	0	0	313853	0	282464	1127078		
236543	5194	40213227	2007-04-12	2007-04-12 00:00:00	2007-04-12	2007-04-12 00:00:00	2007-04-12	581452		0	0	0		0	0	0	345347	0	113	40213227		
175379	3856	40213306	1996-08-21	1996-08-21 00:00:00	1996-08-21	1996-08-21 00:00:00	1996-08-21	581452		0	0	0		0	0	0	255929	0	43	40213306		
26848	2211	1127433	1984-03-15	1984-03-15 00:00:00	1984-03-22	1984-03-22 00:00:00	1984-03-22	38000177		0	0	7		0	0	0	147323	0	313782	1127433		
45994	1004	40213296	2003-11-06	2003-11-06 00:00:00	2003-11-06	2003-11-06 00:00:00	2003-11-06	581452		0	0	0		0	0	0	66352	0	52	40213296		
49929	4142	40229134	2003-08-28	2003-08-28 00:00:00	2003-09-11	2003-09-11 00:00:00	2003-09-11	38000177		0	0	14		0	0	0	275321	0	1043400	40229134		
97000	2127	40213160	1965-08-14	1965-08-14 00:00:00	1965-08-14	1965-08-14 00:00:00	1965-08-14	581452		0	0	0		0	0	0	141444	0	10	40213160		
18718	1545	46233988	1974-10-06	1974-10-06 00:00:00	1974-10-20	1974-10-20 00:00:00	1974-10-20	38000177		0	0	14		0	0	0	103505	0	1652673	46233988		
23052	1902	19059056	1946-11-12	1946-11-12 00:00:00	1946-11-26	1946-11-26 00:00:00	1946-11-26	38000177		0	0	14		0	0	0	126595	0	243670	19059056		
60371	1320	40213227	1996-06-20	1996-06-20 00:00:00	1996-06-20	1996-06-20 00:00:00	1996-06-20	581452		0	0	0		0	0	0	87579	0	113	40213227		
366	30	40236824	1999-09-05	1999-09-05 00:00:00	1999-09-12	1999-09-12 00:00:00	1999-09-12	38000177		0	0	7		0	0	0	2105	0	1094107	40236824		
20954	1727	40236824	2000-04-11	2000-04-11 00:00:00	2000-04-18	2000-04-18 00:00:00	2000-04-18	38000177		0	0	7		0	0	0	115427	0	1094107	40236824		
19277	1593	1127433	1957-02-24	1957-02-24 00:00:00	1957-03-26	1957-03-26 00:00:00	1957-03-26	38000177		0	0	30		0	0	0	106843	0	313782	1127433		
43885	3636	1713671	1984-04-20	1984-04-20 00:00:00	1984-05-11	1984-05-11 00:00:00	1984-05-11	38000177		0	0	21		0	0	0	241797	0	562251	1713671		
43936	3639	1127433	1964-10-17	1964-10-17 00:00:00	1964-10-31	1964-10-31 00:00:00	1964-10-31	38000177		0	0	14		0	0	0	242126	0	313782	1127433		
191176	4200	40213160	1969-02-26	1969-02-26 00:00:00	1969-02-26	1969-02-26 00:00:00	1969-02-26	581452		0	0	0		0	0	0	278754	0	10	40213160		
194336	4270	40213260	2017-01-17	2017-01-17 00:00:00	2017-01-17	2017-01-17 00:00:00	2017-01-17	581452		0	0	0		0	0	0	283410	0	121	40213260		
229498	5044	40213296	2012-11-21	2012-11-21 00:00:00	2012-11-21	2012-11-21 00:00:00	2012-11-21	581452		0	0	0		0	0	0	335207	0	52	40213296		
130284	2863	40213296	2001-09-20	2001-09-20 00:00:00	2001-09-20	2001-09-20 00:00:00	2001-09-20	581452		0	0	0		0	0	0	190387	0	52	40213296		
2722	219	1154615	1971-04-06	1971-04-06 00:00:00	1971-04-06	1971-04-06 00:00:00	\N	38000177		0	0	0		0	0	0	14767	0	745679	1154615		
240019	5268	40213227	2016-07-03	2016-07-03 00:00:00	2016-07-03	2016-07-03 00:00:00	2016-07-03	581452		0	0	0		0	0	0	350499	0	113	40213227		
49322	4091	19133873	1974-04-07	1974-04-07 00:00:00	1974-04-18	1974-04-18 00:00:00	1974-04-18	38000177		0	0	11		0	0	0	271946	0	834061	19133873		
51130	4247	19074843	1983-05-18	1983-05-18 00:00:00	1983-06-01	1983-06-01 00:00:00	1983-06-01	38000177		0	0	14		0	0	0	282000	0	309045	19074843		
6558	552	40229134	1969-07-17	1969-07-17 00:00:00	1969-07-31	1969-07-31 00:00:00	1969-07-31	38000177		0	0	14		0	0	0	36623	0	1043400	40229134		
47864	3968	40229134	1913-10-01	1913-10-01 00:00:00	1913-10-15	1913-10-15 00:00:00	1913-10-15	38000177		0	0	14		0	0	0	263789	0	1043400	40229134		
86201	1889	40213160	1983-07-28	1983-07-28 00:00:00	1983-07-28	1983-07-28 00:00:00	1983-07-28	581452		0	0	0		0	0	0	125926	0	10	40213160		
142002	3119	40213160	1979-05-28	1979-05-28 00:00:00	1979-05-28	1979-05-28 00:00:00	1979-05-28	581452		0	0	0		0	0	0	207545	0	10	40213160		
66128	1447	40213227	2009-01-22	2009-01-22 00:00:00	2009-01-22	2009-01-22 00:00:00	2009-01-22	581452		0	0	0		0	0	0	96500	0	113	40213227		
34141	2822	1127078	1976-12-18	1976-12-18 00:00:00	1977-01-01	1977-01-01 00:00:00	1977-01-01	38000177		0	0	14		0	0	0	186989	0	282464	1127078		
180026	3957	40213227	2016-11-03	2016-11-03 00:00:00	2016-11-03	2016-11-03 00:00:00	2016-11-03	581452		0	0	0		0	0	0	263105	0	113	40213227		
23888	1966	1115171	2003-06-08	2003-06-08 00:00:00	2003-07-06	2003-07-06 00:00:00	2003-07-06	38000177		0	0	28		0	0	0	130739	0	849574	1115171		
7144	600	1127433	1984-09-09	1984-09-09 00:00:00	1984-09-30	1984-09-30 00:00:00	1984-09-30	38000177		0	0	21		0	0	0	39647	0	313782	1127433		
54437	4525	1127433	1969-01-26	1969-01-26 00:00:00	1969-02-09	1969-02-09 00:00:00	1969-02-09	38000177		0	0	14		0	0	0	301268	0	313782	1127433		
183577	4033	40213227	2000-12-25	2000-12-25 00:00:00	2000-12-25	2000-12-25 00:00:00	2000-12-25	581452		0	0	0		0	0	0	268322	0	113	40213227		
162760	3579	40213260	2015-11-07	2015-11-07 00:00:00	2015-11-07	2015-11-07 00:00:00	2015-11-07	581452		0	0	0		0	0	0	237918	0	121	40213260		
45048	3728	1118084	2011-01-21	2011-01-21 00:00:00	2011-01-21	2011-01-21 00:00:00	\N	38000177		0	0	0		0	0	0	247754	0	00025152531	44923712		
45092	3731	1127433	1988-04-14	1988-04-14 00:00:00	1988-05-05	1988-05-05 00:00:00	1988-05-05	38000177		0	0	21		0	0	0	247936	0	313782	1127433		
136117	2988	40213227	1993-12-05	1993-12-05 00:00:00	1993-12-05	1993-12-05 00:00:00	1993-12-05	581452		0	0	0		0	0	0	199463	0	113	40213227		
140627	3088	40213227	1992-11-20	1992-11-20 00:00:00	1992-11-20	1992-11-20 00:00:00	1992-11-20	581452		0	0	0		0	0	0	205649	0	113	40213227		
80758	1766	40213160	1957-06-04	1957-06-04 00:00:00	1957-06-04	1957-06-04 00:00:00	1957-06-04	581452		0	0	0		0	0	0	118153	0	10	40213160		
102327	2243	40213260	2016-01-22	2016-01-22 00:00:00	2016-01-22	2016-01-22 00:00:00	2016-01-22	581452		0	0	0		0	0	0	149342	0	121	40213260		
28384	2341	19006318	1955-12-21	1955-12-21 00:00:00	1956-01-04	1956-01-04 00:00:00	1956-01-04	38000177		0	0	14		0	0	0	155863	0	105078	19006318		
187827	4125	40213260	2018-09-25	2018-09-25 00:00:00	2018-09-25	2018-09-25 00:00:00	2018-09-25	581452		0	0	0		0	0	0	274259	0	121	40213260		
37201	812	40213260	2013-08-03	2013-08-03 00:00:00	2013-08-03	2013-08-03 00:00:00	2013-08-03	581452		0	0	0		0	0	0	53873	0	121	40213260		
217897	4782	40213160	1981-01-06	1981-01-06 00:00:00	1981-01-06	1981-01-06 00:00:00	1981-01-06	581452		0	0	0		0	0	0	318336	0	10	40213160		
197111	4331	40213314	1978-04-21	1978-04-21 00:00:00	1978-04-21	1978-04-21 00:00:00	1978-04-21	581452		0	0	0		0	0	0	287311	0	49	40213314		
204360	4485	40213227	2011-10-20	2011-10-20 00:00:00	2011-10-20	2011-10-20 00:00:00	2011-10-20	581452		0	0	0		0	0	0	298557	0	113	40213227		
57513	4773	19059056	1964-05-27	1964-05-27 00:00:00	1964-06-10	1964-06-10 00:00:00	1964-06-10	38000177		0	0	14		0	0	0	317872	0	243670	19059056		
49732	4125	19133873	1976-07-04	1976-07-04 00:00:00	1976-07-12	1976-07-12 00:00:00	1976-07-12	38000177		0	0	8		0	0	0	274229	0	834061	19133873		
18560	1535	1127078	1978-05-03	1978-05-03 00:00:00	1978-05-17	1978-05-17 00:00:00	1978-05-17	38000177		0	0	14		0	0	0	102757	0	282464	1127078		
139617	3067	40213227	1991-12-31	1991-12-31 00:00:00	1991-12-31	1991-12-31 00:00:00	1991-12-31	581452		0	0	0		0	0	0	204169	0	113	40213227		
29096	2409	920300	2007-11-04	2007-11-04 00:00:00	2007-11-11	2007-11-11 00:00:00	2007-11-11	38000177		0	0	7		0	0	0	159902	0	311989	920300		
137940	3028	40213306	1981-07-16	1981-07-16 00:00:00	1981-07-16	1981-07-16 00:00:00	1981-07-16	581452		0	0	0		0	0	0	201924	0	43	40213306		
65426	1431	40213198	2014-12-27	2014-12-27 00:00:00	2014-12-27	2014-12-27 00:00:00	2014-12-27	581452		0	0	0		0	0	0	95329	0	133	40213198		
56153	4662	19057271	1989-07-27	1989-07-27 00:00:00	1989-07-27	1989-07-27 00:00:00	1989-07-27	38000177		0	0	0		0	0	0	310773	0	238100	19057271		
2075	163	920300	2007-08-19	2007-08-19 00:00:00	2007-08-26	2007-08-26 00:00:00	2007-08-26	38000177		0	0	7		0	0	0	11192	0	311989	920300		
17945	1486	40232448	1960-07-29	1960-07-29 00:00:00	1960-07-29	1960-07-29 00:00:00	\N	38000177		0	0	0		0	0	0	99041	0	1049630	40232448		
152434	3355	40213227	2013-10-11	2013-10-11 00:00:00	2013-10-11	2013-10-11 00:00:00	2013-10-11	581452		0	0	0		0	0	0	222529	0	113	40213227		
147469	3242	40213306	2002-10-12	2002-10-12 00:00:00	2002-10-12	2002-10-12 00:00:00	2002-10-12	581452		0	0	0		0	0	0	215610	0	43	40213306		
209271	4590	40213227	2017-01-16	2017-01-16 00:00:00	2017-01-16	2017-01-16 00:00:00	2017-01-16	581452		0	0	0		0	0	0	305816	0	113	40213227		
163832	3603	40213296	2008-06-29	2008-06-29 00:00:00	2008-06-29	2008-06-29 00:00:00	2008-06-29	581452		0	0	0		0	0	0	239341	0	52	40213296		
98159	2150	40213201	2016-04-22	2016-04-22 00:00:00	2016-04-22	2016-04-22 00:00:00	2016-04-22	581452		0	0	0		0	0	0	143232	0	33	40213201		
16152	1339	40229134	2001-05-12	2001-05-12 00:00:00	2001-05-19	2001-05-19 00:00:00	2001-05-19	38000177		0	0	7		0	0	0	88791	0	1043400	40229134		
147985	3253	40213296	2010-05-25	2010-05-25 00:00:00	2010-05-25	2010-05-25 00:00:00	2010-05-25	581452		0	0	0		0	0	0	216286	0	52	40213296		
56788	4713	40229134	1978-09-02	1978-09-02 00:00:00	1978-09-16	1978-09-16 00:00:00	1978-09-16	38000177		0	0	14		0	0	0	313828	0	1043400	40229134		
76404	1669	40213160	1959-05-11	1959-05-11 00:00:00	1959-05-11	1959-05-11 00:00:00	1959-05-11	581452		0	0	0		0	0	0	112073	0	10	40213160		
175380	3856	40213160	1974-06-12	1974-06-12 00:00:00	1974-06-12	1974-06-12 00:00:00	1974-06-12	581452		0	0	0		0	0	0	255911	0	10	40213160		
26849	2213	1127433	1975-07-07	1975-07-07 00:00:00	1975-07-14	1975-07-14 00:00:00	1975-07-14	38000177		0	0	7		0	0	0	147359	0	313782	1127433		
45995	1004	40213227	2003-11-06	2003-11-06 00:00:00	2003-11-06	2003-11-06 00:00:00	2003-11-06	581452		0	0	0		0	0	0	66352	0	113	40213227		
49930	4142	1115171	2015-10-19	2015-10-19 00:00:00	2015-11-09	2015-11-09 00:00:00	2015-11-09	38000177		0	0	21		0	0	0	275293	0	849574	1115171		
97002	2127	40213306	1983-01-01	1983-01-01 00:00:00	1983-01-01	1983-01-01 00:00:00	1983-01-01	581452		0	0	0		0	0	0	141471	0	43	40213306		
18719	1545	19019979	1974-10-06	1974-10-06 00:00:00	1974-10-20	1974-10-20 00:00:00	1974-10-20	38000177		0	0	14		0	0	0	103505	0	198405	19019979		
23053	1902	1713671	1995-01-20	1995-01-20 00:00:00	1995-02-10	1995-02-10 00:00:00	1995-02-10	38000177		0	0	21		0	0	0	126615	0	562251	1713671		
60388	1320	40213227	2006-08-17	2006-08-17 00:00:00	2006-08-17	2006-08-17 00:00:00	2006-08-17	581452		0	0	0		0	0	0	87509	0	113	40213227		
367	30	920300	1999-09-05	1999-09-05 00:00:00	1999-09-12	1999-09-12 00:00:00	1999-09-12	38000177		0	0	7		0	0	0	2105	0	311989	920300		
20955	1727	920300	2000-04-11	2000-04-11 00:00:00	2000-04-18	2000-04-18 00:00:00	2000-04-18	38000177		0	0	7		0	0	0	115427	0	311989	920300		
19278	1593	40229134	1976-08-03	1976-08-03 00:00:00	1976-08-10	1976-08-10 00:00:00	1976-08-10	38000177		0	0	7		0	0	0	106826	0	1043400	40229134		
43886	3636	40229134	2006-05-03	2006-05-03 00:00:00	2006-05-17	2006-05-17 00:00:00	2006-05-17	38000177		0	0	14		0	0	0	241783	0	1043400	40229134		
43937	3639	19133905	1958-11-08	1958-11-08 00:00:00	1958-11-15	1958-11-15 00:00:00	1958-11-15	38000177		0	0	7		0	0	0	242029	0	834102	19133905		
191177	4200	40213160	1973-05-30	1973-05-30 00:00:00	1973-05-30	1973-05-30 00:00:00	1973-05-30	581452		0	0	0		0	0	0	278793	0	10	40213160		
194341	4270	40213160	1971-12-28	1971-12-28 00:00:00	1971-12-28	1971-12-28 00:00:00	1971-12-28	581452		0	0	0		0	0	0	283431	0	10	40213160		
229501	5044	40213160	1973-04-25	1973-04-25 00:00:00	1973-04-25	1973-04-25 00:00:00	1973-04-25	581452		0	0	0		0	0	0	335221	0	10	40213160		
130288	2863	40213260	2011-12-08	2011-12-08 00:00:00	2011-12-08	2011-12-08 00:00:00	2011-12-08	581452		0	0	0		0	0	0	190397	0	121	40213260		
2723	219	1118084	2005-11-01	2005-11-01 00:00:00	2005-11-01	2005-11-01 00:00:00	\N	38000177		0	0	0		0	0	0	14791	0	00025152531	44923712		
240021	5268	40213160	1965-12-05	1965-12-05 00:00:00	1965-12-05	1965-12-05 00:00:00	1965-12-05	581452		0	0	0		0	0	0	350517	0	10	40213160		
49323	4091	1127433	1982-02-24	1982-02-24 00:00:00	1982-03-10	1982-03-10 00:00:00	1982-03-10	38000177		0	0	14		0	0	0	271942	0	313782	1127433		
61219	5094	40162522	1991-09-25	1991-09-25 00:00:00	1991-09-25	1991-09-25 00:00:00	\N	38000177		0	0	0		0	0	0	338493	0	857005	40162522		
6559	552	19133873	1955-04-15	1955-04-15 00:00:00	1955-04-22	1955-04-22 00:00:00	1955-04-22	38000177		0	0	7		0	0	0	36641	0	834061	19133873		
47865	3968	1713671	1948-05-02	1948-05-02 00:00:00	1948-05-16	1948-05-16 00:00:00	1948-05-16	38000177		0	0	14		0	0	0	263831	0	562251	1713671		
86205	1889	40213180	2005-01-20	2005-01-20 00:00:00	2005-01-20	2005-01-20 00:00:00	2005-01-20	581452		0	0	0		0	0	0	125921	0	114	40213180		
50762	4217	19133905	1983-04-14	1983-04-14 00:00:00	1983-04-23	1983-04-23 00:00:00	1983-04-23	38000177		0	0	9		0	0	0	279968	0	834102	19133905		
66130	1447	40213260	2008-03-20	2008-03-20 00:00:00	2008-03-20	2008-03-20 00:00:00	2008-03-20	581452		0	0	0		0	0	0	96499	0	121	40213260		
34142	2822	1127433	1990-09-16	1990-09-16 00:00:00	1990-09-30	1990-09-30 00:00:00	1990-09-30	38000177		0	0	14		0	0	0	186986	0	313782	1127433		
180038	3957	40213160	1956-05-31	1956-05-31 00:00:00	1956-05-31	1956-05-31 00:00:00	1956-05-31	581452		0	0	0		0	0	0	263108	0	10	40213160		
23889	1967	920300	1980-11-08	1980-11-08 00:00:00	1980-11-15	1980-11-15 00:00:00	1980-11-15	38000177		0	0	7		0	0	0	130746	0	311989	920300		
7145	601	1127078	1980-09-15	1980-09-15 00:00:00	1980-09-29	1980-09-29 00:00:00	1980-09-29	38000177		0	0	14		0	0	0	39683	0	282464	1127078		
54438	4525	19133873	1974-02-01	1974-02-01 00:00:00	1974-02-09	1974-02-09 00:00:00	1974-02-09	38000177		0	0	8		0	0	0	301270	0	834061	19133873		
183584	4033	40213296	2011-10-04	2011-10-04 00:00:00	2011-10-04	2011-10-04 00:00:00	2011-10-04	581452		0	0	0		0	0	0	268334	0	52	40213296		
63004	1378	40213201	2010-10-12	2010-10-12 00:00:00	2010-10-12	2010-10-12 00:00:00	2010-10-12	581452		0	0	0		0	0	0	91442	0	33	40213201		
45049	3728	1127433	2005-11-19	2005-11-19 00:00:00	2005-11-26	2005-11-26 00:00:00	2005-11-26	38000177		0	0	7		0	0	0	247741	0	313782	1127433		
45093	3731	19078461	1989-03-31	1989-03-31 00:00:00	1989-04-30	1989-04-30 00:00:00	1989-04-30	38000177		0	0	30		0	0	0	247937	0	310965	19078461		
116337	2556	40213296	2007-12-31	2007-12-31 00:00:00	2007-12-31	2007-12-31 00:00:00	2007-12-31	581452		0	0	0		0	0	0	169404	0	52	40213296		
140654	3088	40213201	2006-02-03	2006-02-03 00:00:00	2006-02-03	2006-02-03 00:00:00	2006-02-03	581452		0	0	0		0	0	0	205652	0	33	40213201		
80762	1766	40213198	2017-11-28	2017-11-28 00:00:00	2017-11-28	2017-11-28 00:00:00	2017-11-28	581452		0	0	0		0	0	0	118170	0	133	40213198		
102335	2243	40213160	1966-04-29	1966-04-29 00:00:00	1966-04-29	1966-04-29 00:00:00	1966-04-29	581452		0	0	0		0	0	0	149313	0	10	40213160		
28385	2341	1127078	1955-12-21	1955-12-21 00:00:00	1956-01-04	1956-01-04 00:00:00	1956-01-04	38000177		0	0	14		0	0	0	155863	0	282464	1127078		
187830	4125	40213160	1967-12-26	1967-12-26 00:00:00	1967-12-26	1967-12-26 00:00:00	1967-12-26	581452		0	0	0		0	0	0	274249	0	10	40213160		
37203	812	40213296	2006-07-15	2006-07-15 00:00:00	2006-07-15	2006-07-15 00:00:00	2006-07-15	581452		0	0	0		0	0	0	53844	0	52	40213296		
217899	4782	40213227	2014-03-18	2014-03-18 00:00:00	2014-03-18	2014-03-18 00:00:00	2014-03-18	581452		0	0	0		0	0	0	318347	0	113	40213227		
197112	4331	40213296	2014-11-21	2014-11-21 00:00:00	2014-11-21	2014-11-21 00:00:00	2014-11-21	581452		0	0	0		0	0	0	287316	0	52	40213296		
189141	4153	40213227	1996-02-29	1996-02-29 00:00:00	1996-02-29	1996-02-29 00:00:00	1996-02-29	581452		0	0	0		0	0	0	276012	0	113	40213227		
57514	4773	1127433	1977-12-26	1977-12-26 00:00:00	1978-01-02	1978-01-02 00:00:00	1978-01-02	38000177		0	0	7		0	0	0	317904	0	313782	1127433		
49733	4125	1713671	1985-11-15	1985-11-15 00:00:00	1985-11-22	1985-11-22 00:00:00	1985-11-22	38000177		0	0	7		0	0	0	274262	0	562251	1713671		
154047	3391	40213160	1982-09-28	1982-09-28 00:00:00	1982-09-28	1982-09-28 00:00:00	1982-09-28	581452		0	0	0		0	0	0	224873	0	10	40213160		
137834	3026	40213227	2006-01-29	2006-01-29 00:00:00	2006-01-29	2006-01-29 00:00:00	2006-01-29	581452		0	0	0		0	0	0	201734	0	113	40213227		
29097	2409	40236824	2013-12-16	2013-12-16 00:00:00	2013-12-23	2013-12-23 00:00:00	2013-12-23	38000177		0	0	7		0	0	0	159898	0	1094107	40236824		
137941	3028	40213296	2001-05-03	2001-05-03 00:00:00	2001-05-03	2001-05-03 00:00:00	2001-05-03	581452		0	0	0		0	0	0	201927	0	52	40213296		
146244	3216	40213227	2005-06-28	2005-06-28 00:00:00	2005-06-28	2005-06-28 00:00:00	2005-06-28	581452		0	0	0		0	0	0	213728	0	113	40213227		
56154	4662	19079524	1989-07-27	1989-07-27 00:00:00	1989-07-28	1989-07-28 00:00:00	1989-07-28	38000177		0	0	1		0	0	0	310773	0	313002	19079524		
2076	163	1127433	1984-04-29	1984-04-29 00:00:00	1984-05-20	1984-05-20 00:00:00	1984-05-20	38000177		0	0	21		0	0	0	11236	0	313782	1127433		
17946	1486	19006318	1960-05-24	1960-05-24 00:00:00	1960-06-07	1960-06-07 00:00:00	1960-06-07	38000177		0	0	14		0	0	0	99153	0	105078	19006318		
53715	4466	1713671	2005-01-10	2005-01-10 00:00:00	2005-01-31	2005-01-31 00:00:00	2005-01-31	38000177		0	0	21		0	0	0	297098	0	562251	1713671		
147477	3242	40213314	1980-10-25	1980-10-25 00:00:00	1980-10-25	1980-10-25 00:00:00	1980-10-25	581452		0	0	0		0	0	0	215597	0	49	40213314		
209272	4590	40213160	1956-02-20	1956-02-20 00:00:00	1956-02-20	1956-02-20 00:00:00	1956-02-20	581452		0	0	0		0	0	0	305867	0	10	40213160		
163834	3603	40213227	2008-06-29	2008-06-29 00:00:00	2008-06-29	2008-06-29 00:00:00	2008-06-29	581452		0	0	0		0	0	0	239341	0	113	40213227		
98165	2150	40213227	2001-01-26	2001-01-26 00:00:00	2001-01-26	2001-01-26 00:00:00	2001-01-26	581452		0	0	0		0	0	0	143228	0	113	40213227		
16153	1339	1115171	1999-04-17	1999-04-17 00:00:00	1999-05-08	1999-05-08 00:00:00	1999-05-08	38000177		0	0	21		0	0	0	88821	0	849574	1115171		
147987	3253	40213227	2012-05-29	2012-05-29 00:00:00	2012-05-29	2012-05-29 00:00:00	2012-05-29	581452		0	0	0		0	0	0	216357	0	113	40213227		
56789	4713	40236446	1975-01-05	1975-01-05 00:00:00	1984-01-13	1984-01-13 00:00:00	1984-01-13	38000177		0	0	3295		0	0	0	313827	0	1091392	40236446		
76416	1669	40213296	2002-02-25	2002-02-25 00:00:00	2002-02-25	2002-02-25 00:00:00	2002-02-25	581452		0	0	0		0	0	0	112116	0	52	40213296		
175382	3856	40213314	1977-01-04	1977-01-04 00:00:00	1977-01-04	1977-01-04 00:00:00	1977-01-04	581452		0	0	0		0	0	0	255914	0	49	40213314		
26850	2213	1127433	2011-12-16	2011-12-16 00:00:00	2011-12-23	2011-12-23 00:00:00	2011-12-23	38000177		0	0	7		0	0	0	147378	0	313782	1127433		
45999	1004	40213306	1985-03-28	1985-03-28 00:00:00	1985-03-28	1985-03-28 00:00:00	1985-03-28	581452		0	0	0		0	0	0	66392	0	43	40213306		
49931	4142	1713671	1999-04-16	1999-04-16 00:00:00	1999-04-23	1999-04-23 00:00:00	1999-04-23	38000177		0	0	7		0	0	0	275305	0	562251	1713671		
97010	2127	40213296	2001-03-03	2001-03-03 00:00:00	2001-03-03	2001-03-03 00:00:00	2001-03-03	581452		0	0	0		0	0	0	141504	0	52	40213296		
18720	1545	1127433	2018-06-27	2018-06-27 00:00:00	2018-07-04	2018-07-04 00:00:00	2018-07-04	38000177		0	0	7		0	0	0	103523	0	313782	1127433		
23054	1902	1713671	1986-06-07	1986-06-07 00:00:00	1986-06-28	1986-06-28 00:00:00	1986-06-28	38000177		0	0	21		0	0	0	126614	0	562251	1713671		
5291	443	1127433	1984-03-02	1984-03-02 00:00:00	1984-04-01	1984-04-01 00:00:00	1984-04-01	38000177		0	0	30		0	0	0	29426	0	313782	1127433		
368	30	1127078	1980-06-14	1980-06-14 00:00:00	1980-07-05	1980-07-05 00:00:00	1980-07-05	38000177		0	0	21		0	0	0	2075	0	282464	1127078		
20956	1727	1127078	1950-07-24	1950-07-24 00:00:00	1950-08-07	1950-08-07 00:00:00	1950-08-07	38000177		0	0	14		0	0	0	115487	0	282464	1127078		
19279	1593	19133873	1944-10-03	1944-10-03 00:00:00	1944-10-13	1944-10-13 00:00:00	1944-10-13	38000177		0	0	10		0	0	0	106859	0	834061	19133873		
43887	3636	1118084	2010-10-23	2010-10-23 00:00:00	2010-10-23	2010-10-23 00:00:00	\N	38000177		0	0	0		0	0	0	241810	0	00025152531	44923712		
43938	3639	40229134	1978-03-01	1978-03-01 00:00:00	1978-03-08	1978-03-08 00:00:00	1978-03-08	38000177		0	0	7		0	0	0	242169	0	1043400	40229134		
137300	3013	40213227	2001-09-04	2001-09-04 00:00:00	2001-09-04	2001-09-04 00:00:00	2001-09-04	581452		0	0	0		0	0	0	200929	0	113	40213227		
194345	4270	40213296	2007-01-23	2007-01-23 00:00:00	2007-01-23	2007-01-23 00:00:00	2007-01-23	581452		0	0	0		0	0	0	283381	0	52	40213296		
229505	5044	40213227	2014-11-26	2014-11-26 00:00:00	2014-11-26	2014-11-26 00:00:00	2014-11-26	581452		0	0	0		0	0	0	335183	0	113	40213227		
221243	4855	40213314	1978-11-18	1978-11-18 00:00:00	1978-11-18	1978-11-18 00:00:00	1978-11-18	581452		0	0	0		0	0	0	323034	0	49	40213314		
2724	219	1127078	1974-11-24	1974-11-24 00:00:00	1974-12-08	1974-12-08 00:00:00	1974-12-08	38000177		0	0	14		0	0	0	14750	0	282464	1127078		
240023	5268	40213227	1997-06-29	1997-06-29 00:00:00	1997-06-29	1997-06-29 00:00:00	1997-06-29	581452		0	0	0		0	0	0	350495	0	113	40213227		
49324	4091	1127433	1970-05-16	1970-05-16 00:00:00	1970-05-30	1970-05-30 00:00:00	1970-05-30	38000177		0	0	14		0	0	0	271985	0	313782	1127433		
61220	5094	19059056	1991-09-25	1991-09-25 00:00:00	1991-11-24	1991-11-24 00:00:00	1991-11-24	38000177		0	0	60		0	0	0	338493	0	243670	19059056		
6560	552	920300	1982-10-14	1982-10-14 00:00:00	1982-10-21	1982-10-21 00:00:00	1982-10-21	38000177		0	0	7		0	0	0	36582	0	311989	920300		
47866	3968	1118084	1950-07-18	1950-07-18 00:00:00	1950-07-18	1950-07-18 00:00:00	\N	38000177		0	0	0		0	0	0	263831	0	00025152531	44923712		
86206	1889	40213306	2005-01-20	2005-01-20 00:00:00	2005-01-20	2005-01-20 00:00:00	2005-01-20	581452		0	0	0		0	0	0	125921	0	43	40213306		
50763	4217	19112599	1962-09-02	1962-09-02 00:00:00	1962-09-02	1962-09-02 00:00:00	\N	38000177		0	0	0		0	0	0	279920	0	477045	19112599		
66132	1447	40213160	1958-01-09	1958-01-09 00:00:00	1958-01-09	1958-01-09 00:00:00	1958-01-09	581452		0	0	0		0	0	0	96489	0	10	40213160		
34143	2822	1118084	2011-11-30	2011-11-30 00:00:00	2011-11-30	2011-11-30 00:00:00	\N	38000177		0	0	0		0	0	0	187026	0	00025152531	44923712		
23827	1960	40229134	1955-09-27	1955-09-27 00:00:00	1955-10-11	1955-10-11 00:00:00	1955-10-11	38000177		0	0	14		0	0	0	130373	0	1043400	40229134		
23890	1967	40236824	1980-11-08	1980-11-08 00:00:00	1980-11-15	1980-11-15 00:00:00	1980-11-15	38000177		0	0	7		0	0	0	130746	0	1094107	40236824		
7146	601	19133905	2007-06-21	2007-06-21 00:00:00	2007-07-04	2007-07-04 00:00:00	2007-07-04	38000177		0	0	13		0	0	0	39742	0	834102	19133905		
54439	4525	19133905	2013-11-06	2013-11-06 00:00:00	2013-11-19	2013-11-19 00:00:00	2013-11-19	38000177		0	0	13		0	0	0	301263	0	834102	19133905		
183587	4033	40213227	2011-10-04	2011-10-04 00:00:00	2011-10-04	2011-10-04 00:00:00	2011-10-04	581452		0	0	0		0	0	0	268334	0	113	40213227		
63005	1378	40213198	2010-10-12	2010-10-12 00:00:00	2010-10-12	2010-10-12 00:00:00	2010-10-12	581452		0	0	0		0	0	0	91442	0	133	40213198		
45051	3728	1127433	2007-07-30	2007-07-30 00:00:00	2007-09-28	2007-09-28 00:00:00	2007-09-28	38000177		0	0	60		0	0	0	247697	0	313782	1127433		
45094	3731	19133873	1976-09-11	1976-09-11 00:00:00	1976-09-22	1976-09-22 00:00:00	1976-09-22	38000177		0	0	11		0	0	0	247912	0	834061	19133873		
116343	2556	40213227	2018-12-31	2018-12-31 00:00:00	2018-12-31	2018-12-31 00:00:00	2018-12-31	581452		0	0	0		0	0	0	169376	0	113	40213227		
140660	3088	40213227	2001-01-05	2001-01-05 00:00:00	2001-01-05	2001-01-05 00:00:00	2001-01-05	581452		0	0	0		0	0	0	205678	0	113	40213227		
80764	1766	40213260	2006-09-26	2006-09-26 00:00:00	2006-09-26	2006-09-26 00:00:00	2006-09-26	581452		0	0	0		0	0	0	118168	0	121	40213260		
147497	3242	40213160	1981-01-24	1981-01-24 00:00:00	1981-01-24	1981-01-24 00:00:00	1981-01-24	581452		0	0	0		0	0	0	215623	0	10	40213160		
28386	2341	19059056	1967-01-08	1967-01-08 00:00:00	1967-01-29	1967-01-29 00:00:00	1967-01-29	38000177		0	0	21		0	0	0	155801	0	243670	19059056		
187834	4125	40213306	1989-12-05	1989-12-05 00:00:00	1989-12-05	1989-12-05 00:00:00	1989-12-05	581452		0	0	0		0	0	0	274241	0	43	40213306		
37206	812	40213160	1963-12-21	1963-12-21 00:00:00	1963-12-21	1963-12-21 00:00:00	1963-12-21	581452		0	0	0		0	0	0	53879	0	10	40213160		
217900	4782	40213160	1985-04-09	1985-04-09 00:00:00	1985-04-09	1985-04-09 00:00:00	1985-04-09	581452		0	0	0		0	0	0	318355	0	10	40213160		
34570	755	40213160	1955-04-23	1955-04-23 00:00:00	1955-04-23	1955-04-23 00:00:00	1955-04-23	581452		0	0	0		0	0	0	50035	0	10	40213160		
49527	4109	1127433	1978-09-19	1978-09-19 00:00:00	1978-10-10	1978-10-10 00:00:00	1978-10-10	38000177		0	0	21		0	0	0	273073	0	313782	1127433		
57515	4773	1127433	1989-01-21	1989-01-21 00:00:00	1989-02-11	1989-02-11 00:00:00	1989-02-11	38000177		0	0	21		0	0	0	317891	0	313782	1127433		
49734	4125	1310034	1988-10-25	1988-10-25 00:00:00	1988-10-25	1988-10-25 00:00:00	1988-10-25	38000177		0	0	0		0	0	0	274214	0	834357	1310034		
154048	3391	40213314	1982-09-28	1982-09-28 00:00:00	1982-09-28	1982-09-28 00:00:00	1982-09-28	581452		0	0	0		0	0	0	224873	0	49	40213314		
137835	3026	40213260	2006-01-29	2006-01-29 00:00:00	2006-01-29	2006-01-29 00:00:00	2006-01-29	581452		0	0	0		0	0	0	201734	0	121	40213260		
29098	2409	920300	2013-12-16	2013-12-16 00:00:00	2013-12-23	2013-12-23 00:00:00	2013-12-23	38000177		0	0	7		0	0	0	159898	0	311989	920300		
137943	3028	40213227	2001-05-03	2001-05-03 00:00:00	2001-05-03	2001-05-03 00:00:00	2001-05-03	581452		0	0	0		0	0	0	201927	0	113	40213227		
146245	3216	40213227	2015-08-25	2015-08-25 00:00:00	2015-08-25	2015-08-25 00:00:00	2015-08-25	581452		0	0	0		0	0	0	213749	0	113	40213227		
56155	4662	1367571	1989-07-27	1989-07-27 00:00:00	1989-07-27	1989-07-27 00:00:00	1989-07-27	38000177		0	0	0		0	0	0	310773	0	314659	19080464		
2077	163	40229134	2006-09-02	2006-09-02 00:00:00	2006-09-16	2006-09-16 00:00:00	2006-09-16	38000177		0	0	14		0	0	0	11214	0	1043400	40229134		
17947	1486	1127078	1960-05-24	1960-05-24 00:00:00	1960-06-07	1960-06-07 00:00:00	1960-06-07	38000177		0	0	14		0	0	0	99153	0	282464	1127078		
53716	4466	1127433	1983-03-04	1983-03-04 00:00:00	1983-03-18	1983-03-18 00:00:00	1983-03-18	38000177		0	0	14		0	0	0	297153	0	313782	1127433		
147478	3242	40213160	1980-10-25	1980-10-25 00:00:00	1980-10-25	1980-10-25 00:00:00	1980-10-25	581452		0	0	0		0	0	0	215597	0	10	40213160		
209276	4590	40213160	1956-07-23	1956-07-23 00:00:00	1956-07-23	1956-07-23 00:00:00	1956-07-23	581452		0	0	0		0	0	0	305868	0	10	40213160		
163841	3603	40213160	1966-10-16	1966-10-16 00:00:00	1966-10-16	1966-10-16 00:00:00	1966-10-16	581452		0	0	0		0	0	0	239325	0	10	40213160		
152864	3365	40213160	1964-10-23	1964-10-23 00:00:00	1964-10-23	1964-10-23 00:00:00	1964-10-23	581452		0	0	0		0	0	0	223158	0	10	40213160		
16154	1340	40236824	1948-08-17	1948-08-17 00:00:00	1948-08-24	1948-08-24 00:00:00	1948-08-24	38000177		0	0	7		0	0	0	88940	0	1094107	40236824		
147988	3253	40213296	2012-05-29	2012-05-29 00:00:00	2012-05-29	2012-05-29 00:00:00	2012-05-29	581452		0	0	0		0	0	0	216357	0	52	40213296		
56790	4713	40229134	2000-02-12	2000-02-12 00:00:00	2000-02-26	2000-02-26 00:00:00	2000-02-26	38000177		0	0	14		0	0	0	313850	0	1043400	40229134		
76418	1669	40213160	1964-01-13	1964-01-13 00:00:00	1964-01-13	1964-01-13 00:00:00	1964-01-13	581452		0	0	0		0	0	0	112058	0	10	40213160		
175383	3856	40213160	1978-07-12	1978-07-12 00:00:00	1978-07-12	1978-07-12 00:00:00	1978-07-12	581452		0	0	0		0	0	0	255915	0	10	40213160		
26851	2213	1118084	1995-08-05	1995-08-05 00:00:00	1995-08-05	1995-08-05 00:00:00	\N	38000177		0	0	0		0	0	0	147400	0	00025152531	44923712		
46002	1004	40213260	2012-11-29	2012-11-29 00:00:00	2012-11-29	2012-11-29 00:00:00	2012-11-29	581452		0	0	0		0	0	0	66371	0	121	40213260		
49932	4143	19128065	1981-08-25	1981-08-25 00:00:00	1982-08-20	1982-08-20 00:00:00	1982-08-20	38000177		0	0	360		0	0	0	275372	0	749882	19128065		
201660	4428	40213198	2015-02-19	2015-02-19 00:00:00	2015-02-19	2015-02-19 00:00:00	2015-02-19	581452		0	0	0		0	0	0	294365	0	133	40213198		
18721	1545	1127433	2013-06-25	2013-06-25 00:00:00	2013-07-23	2013-07-23 00:00:00	2013-07-23	38000177		0	0	28		0	0	0	103513	0	313782	1127433		
23055	1902	19078461	2000-06-01	2000-06-01 00:00:00	2000-06-29	2000-06-29 00:00:00	2000-06-29	38000177		0	0	28		0	0	0	126625	0	310965	19078461		
5292	443	19133873	1979-09-24	1979-09-24 00:00:00	1979-10-03	1979-10-03 00:00:00	1979-10-03	38000177		0	0	9		0	0	0	29434	0	834061	19133873		
369	30	1127433	2018-04-23	2018-04-23 00:00:00	2018-04-30	2018-04-30 00:00:00	2018-04-30	38000177		0	0	7		0	0	0	2114	0	313782	1127433		
20957	1727	19006318	1950-07-24	1950-07-24 00:00:00	1950-08-07	1950-08-07 00:00:00	1950-08-07	38000177		0	0	14		0	0	0	115487	0	105078	19006318		
19280	1593	19133873	1946-11-03	1946-11-03 00:00:00	1946-11-15	1946-11-15 00:00:00	1946-11-15	38000177		0	0	12		0	0	0	106940	0	834061	19133873		
43888	3636	1127433	1993-04-25	1993-04-25 00:00:00	1993-05-23	1993-05-23 00:00:00	1993-05-23	38000177		0	0	28		0	0	0	241833	0	313782	1127433		
43939	3639	1713671	1984-07-07	1984-07-07 00:00:00	1984-07-28	1984-07-28 00:00:00	1984-07-28	38000177		0	0	21		0	0	0	242066	0	562251	1713671		
137303	3013	40213201	2017-07-04	2017-07-04 00:00:00	2017-07-04	2017-07-04 00:00:00	2017-07-04	581452		0	0	0		0	0	0	200983	0	33	40213201		
194349	4270	40213160	1967-09-26	1967-09-26 00:00:00	1967-09-26	1967-09-26 00:00:00	1967-09-26	581452		0	0	0		0	0	0	283402	0	10	40213160		
223976	4917	40213314	1982-05-31	1982-05-31 00:00:00	1982-05-31	1982-05-31 00:00:00	1982-05-31	581452		0	0	0		0	0	0	326761	0	49	40213314		
150044	3300	40213160	1983-01-13	1983-01-13 00:00:00	1983-01-13	1983-01-13 00:00:00	1983-01-13	581452		0	0	0		0	0	0	219242	0	10	40213160		
2726	219	19115351	1975-10-25	1975-10-25 00:00:00	1977-12-24	1977-12-24 00:00:00	1977-12-24	38000177		0	0	791		0	0	0	14721	0	563026	19115351		
240025	5268	40213160	1966-03-06	1966-03-06 00:00:00	1966-03-06	1966-03-06 00:00:00	1966-03-06	581452		0	0	0		0	0	0	350531	0	10	40213160		
49325	4091	19133873	1980-03-04	1980-03-04 00:00:00	1980-03-11	1980-03-11 00:00:00	1980-03-11	38000177		0	0	7		0	0	0	271987	0	834061	19133873		
61221	5094	1127078	1981-11-11	1981-11-11 00:00:00	1981-12-16	1981-12-16 00:00:00	1981-12-16	38000177		0	0	35		0	0	0	338492	0	282464	1127078		
6561	552	40236824	1982-10-14	1982-10-14 00:00:00	1982-10-21	1982-10-21 00:00:00	1982-10-21	38000177		0	0	7		0	0	0	36582	0	1094107	40236824		
47867	3968	1127433	1952-02-29	1952-02-29 00:00:00	1952-03-14	1952-03-14 00:00:00	1952-03-14	38000177		0	0	14		0	0	0	263904	0	313782	1127433		
86208	1889	40213227	2005-01-20	2005-01-20 00:00:00	2005-01-20	2005-01-20 00:00:00	2005-01-20	581452		0	0	0		0	0	0	125921	0	113	40213227		
50764	4217	19059056	1965-10-05	1965-10-05 00:00:00	1965-10-19	1965-10-19 00:00:00	1965-10-19	38000177		0	0	14		0	0	0	279908	0	243670	19059056		
66140	1447	40213227	2019-03-21	2019-03-21 00:00:00	2019-03-21	2019-03-21 00:00:00	2019-03-21	581452		0	0	0		0	0	0	96516	0	113	40213227		
34144	2822	1127078	1977-11-13	1977-11-13 00:00:00	1977-12-04	1977-12-04 00:00:00	1977-12-04	38000177		0	0	21		0	0	0	187029	0	282464	1127078		
23834	1962	19133873	1972-08-05	1972-08-05 00:00:00	1972-08-14	1972-08-14 00:00:00	1972-08-14	38000177		0	0	9		0	0	0	130456	0	834061	19133873		
23891	1967	19059056	1956-09-07	1956-09-07 00:00:00	1956-11-06	1956-11-06 00:00:00	1956-11-06	38000177		0	0	60		0	0	0	130742	0	243670	19059056		
7147	601	1127078	1979-01-03	1979-01-03 00:00:00	1979-01-24	1979-01-24 00:00:00	1979-01-24	38000177		0	0	21		0	0	0	39682	0	282464	1127078		
54440	4525	19133873	1984-05-19	1984-05-19 00:00:00	1984-05-28	1984-05-28 00:00:00	1984-05-28	38000177		0	0	9		0	0	0	301298	0	834061	19133873		
183589	4033	40213160	1970-03-23	1970-03-23 00:00:00	1970-03-23	1970-03-23 00:00:00	1970-03-23	581452		0	0	0		0	0	0	268325	0	10	40213160		
74290	1622	40213160	1979-04-23	1979-04-23 00:00:00	1979-04-23	1979-04-23 00:00:00	1979-04-23	581452		0	0	0		0	0	0	109019	0	10	40213160		
45052	3728	1127433	1987-08-09	1987-08-09 00:00:00	1987-08-23	1987-08-23 00:00:00	1987-08-23	38000177		0	0	14		0	0	0	247752	0	313782	1127433		
45095	3731	19059056	1984-07-27	1984-07-27 00:00:00	1984-09-02	1984-09-02 00:00:00	1984-09-02	38000177		0	0	37		0	0	0	247955	0	243670	19059056		
116344	2556	40213260	2018-12-31	2018-12-31 00:00:00	2018-12-31	2018-12-31 00:00:00	2018-12-31	581452		0	0	0		0	0	0	169376	0	121	40213260		
4767	102	40213227	2014-07-06	2014-07-06 00:00:00	2014-07-06	2014-07-06 00:00:00	2014-07-06	581452		0	0	0		0	0	0	6995	0	113	40213227		
80783	1766	40213160	1956-05-29	1956-05-29 00:00:00	1956-05-29	1956-05-29 00:00:00	1956-05-29	581452		0	0	0		0	0	0	118130	0	10	40213160		
206096	4523	40213227	2007-08-19	2007-08-19 00:00:00	2007-08-19	2007-08-19 00:00:00	2007-08-19	581452		0	0	0		0	0	0	301191	0	113	40213227		
38845	3212	42707627	2018-07-21	2018-07-21 00:00:00	2018-07-21	2018-07-21 00:00:00	2018-07-21	38000177		0	0	0		0	0	0	213430	0	1234995	42707627		
187848	4125	40213227	2009-09-29	2009-09-29 00:00:00	2009-09-29	2009-09-29 00:00:00	2009-09-29	581452		0	0	0		0	0	0	274228	0	113	40213227		
37213	812	40213227	2004-10-16	2004-10-16 00:00:00	2004-10-16	2004-10-16 00:00:00	2004-10-16	581452		0	0	0		0	0	0	53870	0	113	40213227		
217901	4782	40213251	1985-04-09	1985-04-09 00:00:00	1985-04-09	1985-04-09 00:00:00	1985-04-09	581452		0	0	0		0	0	0	318355	0	21	40213251		
34577	755	40213227	1999-03-20	1999-03-20 00:00:00	1999-03-20	1999-03-20 00:00:00	1999-03-20	581452		0	0	0		0	0	0	50094	0	113	40213227		
49528	4109	1127433	1973-05-19	1973-05-19 00:00:00	1973-05-26	1973-05-26 00:00:00	1973-05-26	38000177		0	0	7		0	0	0	273101	0	313782	1127433		
57516	4773	1127433	1963-10-02	1963-10-02 00:00:00	1963-10-09	1963-10-09 00:00:00	1963-10-09	38000177		0	0	7		0	0	0	317903	0	313782	1127433		
49735	4125	40243436	1988-10-25	1988-10-25 00:00:00	1988-10-25	1988-10-25 00:00:00	1988-10-25	38000177		0	0	0		0	0	0	274214	0	1190795	40243436		
154050	3391	40213227	2014-07-29	2014-07-29 00:00:00	2014-07-29	2014-07-29 00:00:00	2014-07-29	581452		0	0	0		0	0	0	224887	0	113	40213227		
137845	3026	40213260	2007-02-04	2007-02-04 00:00:00	2007-02-04	2007-02-04 00:00:00	2007-02-04	581452		0	0	0		0	0	0	201725	0	121	40213260		
29099	2409	1127433	2002-12-16	2002-12-16 00:00:00	2002-12-23	2002-12-23 00:00:00	2002-12-23	38000177		0	0	7		0	0	0	159896	0	313782	1127433		
137945	3028	40213227	2010-04-29	2010-04-29 00:00:00	2010-04-29	2010-04-29 00:00:00	2010-04-29	581452		0	0	0		0	0	0	201870	0	113	40213227		
146253	3217	40213227	2014-09-02	2014-09-02 00:00:00	2014-09-02	2014-09-02 00:00:00	2014-09-02	581452		0	0	0		0	0	0	213799	0	113	40213227		
56156	4662	40220386	1989-07-27	1989-07-27 00:00:00	1989-07-27	1989-07-27 00:00:00	1989-07-27	38000177		0	0	0		0	0	0	310773	0	1808217	40220386		
2078	163	1118084	2010-04-03	2010-04-03 00:00:00	2010-04-03	2010-04-03 00:00:00	\N	38000177		0	0	0		0	0	0	11212	0	00025152531	44923712		
17948	1486	19059056	1970-08-20	1970-08-20 00:00:00	1970-09-03	1970-09-03 00:00:00	1970-09-03	38000177		0	0	14		0	0	0	99028	0	243670	19059056		
53717	4467	40231925	1979-10-21	1979-10-21 00:00:00	1979-10-21	1979-10-21 00:00:00	\N	38000177		0	0	0		0	0	0	297164	0	1049221	40231925		
147480	3242	40213227	2011-10-22	2011-10-22 00:00:00	2011-10-22	2011-10-22 00:00:00	2011-10-22	581452		0	0	0		0	0	0	215640	0	113	40213227		
209280	4590	40213260	2007-11-26	2007-11-26 00:00:00	2007-11-26	2007-11-26 00:00:00	2007-11-26	581452		0	0	0		0	0	0	305830	0	121	40213260		
163847	3603	40213260	2017-02-12	2017-02-12 00:00:00	2017-02-12	2017-02-12 00:00:00	2017-02-12	581452		0	0	0		0	0	0	239317	0	121	40213260		
152865	3365	40213160	1964-12-25	1964-12-25 00:00:00	1964-12-25	1964-12-25 00:00:00	1964-12-25	581452		0	0	0		0	0	0	223181	0	10	40213160		
16155	1340	920300	1948-08-17	1948-08-17 00:00:00	1948-08-24	1948-08-24 00:00:00	1948-08-24	38000177		0	0	7		0	0	0	88940	0	311989	920300		
147990	3253	40213160	1970-10-27	1970-10-27 00:00:00	1970-10-27	1970-10-27 00:00:00	1970-10-27	581452		0	0	0		0	0	0	216269	0	10	40213160		
56791	4713	1127433	1986-07-05	1986-07-05 00:00:00	1986-07-26	1986-07-26 00:00:00	1986-07-26	38000177		0	0	21		0	0	0	313864	0	313782	1127433		
76422	1669	40213227	2010-03-22	2010-03-22 00:00:00	2010-03-22	2010-03-22 00:00:00	2010-03-22	581452		0	0	0		0	0	0	112081	0	113	40213227		
175388	3856	40213296	2013-10-09	2013-10-09 00:00:00	2013-10-09	2013-10-09 00:00:00	2013-10-09	581452		0	0	0		0	0	0	255904	0	52	40213296		
26852	2213	19008572	1991-07-21	1991-07-21 00:00:00	1991-07-21	1991-07-21 00:00:00	\N	38000177		0	0	0		0	0	0	147357	0	106258	19008572		
7362	159	40213227	2005-04-12	2005-04-12 00:00:00	2005-04-12	2005-04-12 00:00:00	2005-04-12	581452		0	0	0		0	0	0	10914	0	113	40213227		
49934	4143	1127433	1991-04-26	1991-04-26 00:00:00	1991-05-10	1991-05-10 00:00:00	1991-05-10	38000177		0	0	14		0	0	0	275380	0	313782	1127433		
201675	4428	40213227	2000-11-30	2000-11-30 00:00:00	2000-11-30	2000-11-30 00:00:00	2000-11-30	581452		0	0	0		0	0	0	294408	0	113	40213227		
18722	1545	1127433	2012-08-15	2012-08-15 00:00:00	2012-08-29	2012-08-29 00:00:00	2012-08-29	38000177		0	0	14		0	0	0	103512	0	313782	1127433		
23056	1902	1127433	1966-01-03	1966-01-03 00:00:00	1966-01-17	1966-01-17 00:00:00	1966-01-17	38000177		0	0	14		0	0	0	126637	0	313782	1127433		
5293	443	1713671	1971-09-11	1971-09-11 00:00:00	1971-10-02	1971-10-02 00:00:00	1971-10-02	38000177		0	0	21		0	0	0	29461	0	562251	1713671		
370	30	19059056	1972-07-05	1972-07-05 00:00:00	1972-07-26	1972-07-26 00:00:00	1972-07-26	38000177		0	0	21		0	0	0	2123	0	243670	19059056		
20958	1727	40220386	1982-03-25	1982-03-25 00:00:00	1982-03-25	1982-03-25 00:00:00	1982-03-25	38000177		0	0	0		0	0	0	115482	0	1808217	40220386		
19281	1593	1127433	1976-02-04	1976-02-04 00:00:00	1976-02-18	1976-02-18 00:00:00	1976-02-18	38000177		0	0	14		0	0	0	106828	0	313782	1127433		
43889	3636	19128022	1989-07-02	1989-07-02 00:00:00	1990-06-27	1990-06-27 00:00:00	1990-06-27	38000177		0	0	360		0	0	0	241860	0	749785	19128022		
43940	3639	19018935	2004-01-31	2004-01-31 00:00:00	2004-01-31	2004-01-31 00:00:00	\N	38000177		0	0	0		0	0	0	242079	0	197604	19018935		
137308	3013	40213160	1955-08-09	1955-08-09 00:00:00	1955-08-09	1955-08-09 00:00:00	1955-08-09	581452		0	0	0		0	0	0	200902	0	10	40213160		
194354	4270	40213306	1989-01-17	1989-01-17 00:00:00	1989-01-17	1989-01-17 00:00:00	1989-01-17	581452		0	0	0		0	0	0	283380	0	43	40213306		
223977	4917	40213160	1982-05-31	1982-05-31 00:00:00	1982-05-31	1982-05-31 00:00:00	1982-05-31	581452		0	0	0		0	0	0	326761	0	10	40213160		
150053	3300	40213227	2014-08-07	2014-08-07 00:00:00	2014-08-07	2014-08-07 00:00:00	2014-08-07	581452		0	0	0		0	0	0	219215	0	113	40213227		
2727	220	40224805	1998-08-18	1998-08-18 00:00:00	1999-08-13	1999-08-13 00:00:00	1999-08-13	38000177		0	0	360		0	0	0	14797	0	1000126	40224805		
240027	5268	40213306	1988-06-19	1988-06-19 00:00:00	1988-06-19	1988-06-19 00:00:00	1988-06-19	581452		0	0	0		0	0	0	350537	0	43	40213306		
49326	4091	920300	1988-01-03	1988-01-03 00:00:00	1988-01-10	1988-01-10 00:00:00	1988-01-10	38000177		0	0	7		0	0	0	271988	0	311989	920300		
61222	5094	1118084	2017-12-07	2017-12-07 00:00:00	2017-12-07	2017-12-07 00:00:00	\N	38000177		0	0	0		0	0	0	338465	0	00025152531	44923712		
6562	552	1713671	1975-04-02	1975-04-02 00:00:00	1975-07-02	1975-07-02 00:00:00	1975-07-02	38000177		0	0	91		0	0	0	36581	0	562251	1713671		
47868	3968	19133873	1923-04-12	1923-04-12 00:00:00	1923-04-24	1923-04-24 00:00:00	1923-04-24	38000177		0	0	12		0	0	0	263790	0	834061	19133873		
86213	1889	40213314	1983-04-28	1983-04-28 00:00:00	1983-04-28	1983-04-28 00:00:00	1983-04-28	581452		0	0	0		0	0	0	125939	0	49	40213314		
50765	4217	19078461	1987-09-10	1987-09-10 00:00:00	1987-09-24	1987-09-24 00:00:00	1987-09-24	38000177		0	0	14		0	0	0	280008	0	310965	19078461		
66142	1447	40213160	1958-04-10	1958-04-10 00:00:00	1958-04-10	1958-04-10 00:00:00	1958-04-10	581452		0	0	0		0	0	0	96436	0	10	40213160		
34172	2825	19059056	1991-03-02	1991-03-02 00:00:00	1991-05-31	1991-05-31 00:00:00	1991-05-31	38000177		0	0	90		0	0	0	187332	0	243670	19059056		
23835	1962	1713671	2015-08-26	2015-08-26 00:00:00	2015-09-16	2015-09-16 00:00:00	2015-09-16	38000177		0	0	21		0	0	0	130483	0	562251	1713671		
23893	1967	1118084	1994-02-20	1994-02-20 00:00:00	1994-02-20	1994-02-20 00:00:00	\N	38000177		0	0	0		0	0	0	130834	0	00025152531	44923712		
7148	601	1118084	2010-06-24	2010-06-24 00:00:00	2010-06-24	2010-06-24 00:00:00	\N	38000177		0	0	0		0	0	0	39679	0	00025152531	44923712		
54441	4525	46233988	1969-10-22	1969-10-22 00:00:00	1969-11-05	1969-11-05 00:00:00	1969-11-05	38000177		0	0	14		0	0	0	301273	0	1652673	46233988		
183595	4033	40213160	1970-06-23	1970-06-23 00:00:00	1970-06-23	1970-06-23 00:00:00	1970-06-23	581452		0	0	0		0	0	0	268375	0	10	40213160		
74292	1622	40213314	1978-04-17	1978-04-17 00:00:00	1978-04-17	1978-04-17 00:00:00	1978-04-17	581452		0	0	0		0	0	0	108985	0	49	40213314		
45053	3728	1713671	1988-01-07	1988-01-07 00:00:00	1988-01-14	1988-01-14 00:00:00	1988-01-14	38000177		0	0	7		0	0	0	247728	0	562251	1713671		
45096	3731	1127433	2016-09-15	2016-09-15 00:00:00	2016-09-22	2016-09-22 00:00:00	2016-09-22	38000177		0	0	7		0	0	0	247919	0	313782	1127433		
116350	2556	40213160	1972-12-04	1972-12-04 00:00:00	1972-12-04	1972-12-04 00:00:00	1972-12-04	581452		0	0	0		0	0	0	169410	0	10	40213160		
4770	102	40213160	1973-03-04	1973-03-04 00:00:00	1973-03-04	1973-03-04 00:00:00	1973-03-04	581452		0	0	0		0	0	0	6976	0	10	40213160		
80786	1766	40213227	2013-11-05	2013-11-05 00:00:00	2013-11-05	2013-11-05 00:00:00	2013-11-05	581452		0	0	0		0	0	0	118185	0	113	40213227		
206098	4523	40213314	1977-04-03	1977-04-03 00:00:00	1977-04-03	1977-04-03 00:00:00	1977-04-03	581452		0	0	0		0	0	0	301208	0	49	40213314		
38846	3212	40231925	2018-07-21	2018-07-21 00:00:00	2018-07-21	2018-07-21 00:00:00	\N	38000177		0	0	0		0	0	0	213430	0	1049221	40231925		
187849	4125	40213296	2009-09-29	2009-09-29 00:00:00	2009-09-29	2009-09-29 00:00:00	2009-09-29	581452		0	0	0		0	0	0	274228	0	52	40213296		
37214	812	40213296	2004-10-16	2004-10-16 00:00:00	2004-10-16	2004-10-16 00:00:00	2004-10-16	581452		0	0	0		0	0	0	53870	0	52	40213296		
217904	4782	40213314	1980-08-05	1980-08-05 00:00:00	1980-08-05	1980-08-05 00:00:00	1980-08-05	581452		0	0	0		0	0	0	318335	0	49	40213314		
34587	755	40213227	2009-05-23	2009-05-23 00:00:00	2009-05-23	2009-05-23 00:00:00	2009-05-23	581452		0	0	0		0	0	0	50080	0	113	40213227		
49529	4109	1127433	1991-12-31	1991-12-31 00:00:00	1992-02-04	1992-02-04 00:00:00	1992-02-04	38000177		0	0	35		0	0	0	273224	0	313782	1127433		
57517	4773	19133873	1961-04-02	1961-04-02 00:00:00	1961-04-10	1961-04-10 00:00:00	1961-04-10	38000177		0	0	8		0	0	0	317902	0	834061	19133873		
49736	4125	46275916	1988-10-25	1988-10-25 00:00:00	1988-10-25	1988-10-25 00:00:00	1988-10-25	38000177		0	0	0		0	0	0	274214	0	1660014	46275916		
154053	3391	40213314	1983-08-30	1983-08-30 00:00:00	1983-08-30	1983-08-30 00:00:00	1983-08-30	581452		0	0	0		0	0	0	224891	0	49	40213314		
148224	3259	40213306	1988-09-09	1988-09-09 00:00:00	1988-09-09	1988-09-09 00:00:00	1988-09-09	581452		0	0	0		0	0	0	216661	0	43	40213306		
29100	2409	40165015	2011-01-25	2011-01-25 00:00:00	2011-01-25	2011-01-25 00:00:00	\N	38000177		0	0	0		0	0	0	159944	0	861467	40165015		
137946	3028	40213260	2010-04-29	2010-04-29 00:00:00	2010-04-29	2010-04-29 00:00:00	2010-04-29	581452		0	0	0		0	0	0	201870	0	121	40213260		
146255	3217	40213251	1988-03-29	1988-03-29 00:00:00	1988-03-29	1988-03-29 00:00:00	1988-03-29	581452		0	0	0		0	0	0	213776	0	21	40213251		
56157	4662	782047	1989-07-27	1989-07-27 00:00:00	1989-07-27	1989-07-27 00:00:00	1989-07-27	38000177		0	0	0		0	0	0	310773	0	542347	782047		
2079	163	19078461	1999-08-30	1999-08-30 00:00:00	1999-09-13	1999-09-13 00:00:00	1999-09-13	38000177		0	0	14		0	0	0	11237	0	310965	19078461		
17949	1486	19128065	1976-05-30	1976-05-30 00:00:00	1977-05-25	1977-05-25 00:00:00	1977-05-25	38000177		0	0	360		0	0	0	99103	0	749882	19128065		
53718	4467	19078461	1979-10-21	1979-10-21 00:00:00	1979-12-20	1979-12-20 00:00:00	1979-12-20	38000177		0	0	60		0	0	0	297164	0	310965	19078461		
147482	3242	40213251	1985-01-19	1985-01-19 00:00:00	1985-01-19	1985-01-19 00:00:00	1985-01-19	581452		0	0	0		0	0	0	215606	0	21	40213251		
209285	4590	40213227	2006-11-20	2006-11-20 00:00:00	2006-11-20	2006-11-20 00:00:00	2006-11-20	581452		0	0	0		0	0	0	305826	0	113	40213227		
163849	3603	40213227	2017-02-12	2017-02-12 00:00:00	2017-02-12	2017-02-12 00:00:00	2017-02-12	581452		0	0	0		0	0	0	239317	0	113	40213227		
164158	3610	40213201	2011-01-22	2011-01-22 00:00:00	2011-01-22	2011-01-22 00:00:00	2011-01-22	581452		0	0	0		0	0	0	239806	0	33	40213201		
16156	1340	1127433	1919-05-01	1919-05-01 00:00:00	1919-05-15	1919-05-15 00:00:00	1919-05-15	38000177		0	0	14		0	0	0	88922	0	313782	1127433		
147993	3253	40213160	1975-04-29	1975-04-29 00:00:00	1975-04-29	1975-04-29 00:00:00	1975-04-29	581452		0	0	0		0	0	0	216272	0	10	40213160		
56792	4713	1124300	2010-08-14	2010-08-14 00:00:00	2010-08-14	2010-08-14 00:00:00	\N	38000177		0	0	0		0	0	0	313843	0	00781178901	45011828		
76423	1669	40213260	2010-03-22	2010-03-22 00:00:00	2010-03-22	2010-03-22 00:00:00	2010-03-22	581452		0	0	0		0	0	0	112081	0	121	40213260		
175393	3856	40213314	1977-07-06	1977-07-06 00:00:00	1977-07-06	1977-07-06 00:00:00	1977-07-06	581452		0	0	0		0	0	0	255941	0	49	40213314		
26853	2213	19059056	1974-06-26	1974-06-26 00:00:00	1974-09-24	1974-09-24 00:00:00	1974-09-24	38000177		0	0	90		0	0	0	147425	0	243670	19059056		
7364	159	40213260	2007-04-24	2007-04-24 00:00:00	2007-04-24	2007-04-24 00:00:00	2007-04-24	581452		0	0	0		0	0	0	10915	0	121	40213260		
49935	4143	19078461	1996-06-27	1996-06-27 00:00:00	1996-07-11	1996-07-11 00:00:00	1996-07-11	38000177		0	0	14		0	0	0	275404	0	310965	19078461		
201678	4428	40213227	2011-01-27	2011-01-27 00:00:00	2011-01-27	2011-01-27 00:00:00	2011-01-27	581452		0	0	0		0	0	0	294348	0	113	40213227		
18723	1545	1127433	2017-04-03	2017-04-03 00:00:00	2017-04-17	2017-04-17 00:00:00	2017-04-17	38000177		0	0	14		0	0	0	103514	0	313782	1127433		
23057	1902	1713671	2011-11-30	2011-11-30 00:00:00	2011-12-07	2011-12-07 00:00:00	2011-12-07	38000177		0	0	7		0	0	0	126592	0	562251	1713671		
5294	443	1124300	2005-09-29	2005-09-29 00:00:00	2005-09-29	2005-09-29 00:00:00	\N	38000177		0	0	0		0	0	0	29477	0	00781178901	45011828		
371	30	19128065	1984-08-11	1984-08-11 00:00:00	1985-08-06	1985-08-06 00:00:00	1985-08-06	38000177		0	0	360		0	0	0	2100	0	749882	19128065		
183890	4040	40213306	1998-03-02	1998-03-02 00:00:00	1998-03-02	1998-03-02 00:00:00	1998-03-02	581452		0	0	0		0	0	0	268682	0	43	40213306		
19282	1593	19129655	1976-02-04	1976-02-04 00:00:00	1976-02-18	1976-02-18 00:00:00	1976-02-18	38000177		0	0	14		0	0	0	106828	0	789980	19129655		
43890	3636	1127433	2002-07-22	2002-07-22 00:00:00	2002-08-05	2002-08-05 00:00:00	2002-08-05	38000177		0	0	14		0	0	0	241840	0	313782	1127433		
43941	3639	40171902	2004-01-31	2004-01-31 00:00:00	2004-01-31	2004-01-31 00:00:00	\N	38000177		0	0	0		0	0	0	242079	0	897718	40171902		
137315	3014	40213160	1973-10-06	1973-10-06 00:00:00	1973-10-06	1973-10-06 00:00:00	1973-10-06	581452		0	0	0		0	0	0	200992	0	10	40213160		
194357	4270	40213160	1967-06-27	1967-06-27 00:00:00	1967-06-27	1967-06-27 00:00:00	1967-06-27	581452		0	0	0		0	0	0	283427	0	10	40213160		
223979	4917	40213160	1982-11-01	1982-11-01 00:00:00	1982-11-01	1982-11-01 00:00:00	1982-11-01	581452		0	0	0		0	0	0	326762	0	10	40213160		
150056	3300	40213227	2004-11-25	2004-11-25 00:00:00	2004-11-25	2004-11-25 00:00:00	2004-11-25	581452		0	0	0		0	0	0	219205	0	113	40213227		
2728	220	1127433	1984-11-21	1984-11-21 00:00:00	1984-11-28	1984-11-28 00:00:00	1984-11-28	38000177		0	0	7		0	0	0	14863	0	313782	1127433		
229601	5046	40213160	1958-06-24	1958-06-24 00:00:00	1958-06-24	1958-06-24 00:00:00	1958-06-24	581452		0	0	0		0	0	0	335326	0	10	40213160		
49327	4091	40236824	1988-01-03	1988-01-03 00:00:00	1988-01-10	1988-01-10 00:00:00	1988-01-10	38000177		0	0	7		0	0	0	271988	0	1094107	40236824		
61223	5094	40223834	1999-05-19	1999-05-19 00:00:00	1999-05-19	1999-05-19 00:00:00	\N	38000177		0	0	0		0	0	0	338442	0	997501	40223834		
6563	552	19059056	1954-10-21	1954-10-21 00:00:00	1954-11-04	1954-11-04 00:00:00	1954-11-04	38000177		0	0	14		0	0	0	36626	0	243670	19059056		
47869	3968	1115171	2018-05-25	2018-05-25 00:00:00	2018-08-23	2018-08-23 00:00:00	2018-08-23	38000177		0	0	90		0	0	0	263865	0	849574	1115171		
86214	1889	40213160	1983-04-28	1983-04-28 00:00:00	1983-04-28	1983-04-28 00:00:00	1983-04-28	581452		0	0	0		0	0	0	125939	0	10	40213160		
50766	4217	19073188	1987-09-10	1987-09-10 00:00:00	1987-09-24	1987-09-24 00:00:00	1987-09-24	38000177		0	0	14		0	0	0	280008	0	308192	19073188		
139076	3056	40213227	2018-01-12	2018-01-12 00:00:00	2018-01-12	2018-01-12 00:00:00	2018-01-12	581452		0	0	0		0	0	0	203332	0	113	40213227		
34173	2825	1713671	1968-11-27	1968-11-27 00:00:00	1968-12-11	1968-12-11 00:00:00	1968-12-11	38000177		0	0	14		0	0	0	187338	0	562251	1713671		
23836	1962	1127433	1998-04-06	1998-04-06 00:00:00	1998-05-04	1998-05-04 00:00:00	1998-05-04	38000177		0	0	28		0	0	0	130480	0	313782	1127433		
23894	1967	19133873	1971-06-03	1971-06-03 00:00:00	1971-06-15	1971-06-15 00:00:00	1971-06-15	38000177		0	0	12		0	0	0	130782	0	834061	19133873		
7149	601	19059056	1972-08-02	1972-08-02 00:00:00	1972-08-16	1972-08-16 00:00:00	1972-08-16	38000177		0	0	14		0	0	0	39743	0	243670	19059056		
54442	4525	1127078	1969-10-22	1969-10-22 00:00:00	1969-11-05	1969-11-05 00:00:00	1969-11-05	38000177		0	0	14		0	0	0	301273	0	282464	1127078		
183598	4033	40213160	1974-09-24	1974-09-24 00:00:00	1974-09-24	1974-09-24 00:00:00	1974-09-24	581452		0	0	0		0	0	0	268329	0	10	40213160		
74294	1622	40213160	1974-09-02	1974-09-02 00:00:00	1974-09-02	1974-09-02 00:00:00	1974-09-02	581452		0	0	0		0	0	0	109017	0	10	40213160		
45054	3728	1713671	1995-04-12	1995-04-12 00:00:00	1995-04-26	1995-04-26 00:00:00	1995-04-26	38000177		0	0	14		0	0	0	247717	0	562251	1713671		
45097	3731	19075001	1990-01-09	1990-01-09 00:00:00	1990-01-23	1990-01-23 00:00:00	1990-01-23	38000177		0	0	14		0	0	0	247921	0	309097	19075001		
194690	4278	40213227	2002-09-06	2002-09-06 00:00:00	2002-09-06	2002-09-06 00:00:00	2002-09-06	581452		0	0	0		0	0	0	283864	0	113	40213227		
4773	102	40213227	2003-09-07	2003-09-07 00:00:00	2003-09-07	2003-09-07 00:00:00	2003-09-07	581452		0	0	0		0	0	0	6989	0	113	40213227		
4813	103	40213227	1999-09-12	1999-09-12 00:00:00	1999-09-12	1999-09-12 00:00:00	1999-09-12	581452		0	0	0		0	0	0	7020	0	113	40213227		
206102	4523	40213160	1976-10-03	1976-10-03 00:00:00	1976-10-03	1976-10-03 00:00:00	1976-10-03	581452		0	0	0		0	0	0	301165	0	10	40213160		
38847	3212	35605858	2018-07-21	2018-07-21 00:00:00	2018-07-21	2018-07-21 00:00:00	2018-07-21	38000177		0	0	0		0	0	0	213430	0	1732136	35605858		
187852	4125	40213160	1968-05-28	1968-05-28 00:00:00	1968-05-28	1968-05-28 00:00:00	1968-05-28	581452		0	0	0		0	0	0	274220	0	10	40213160		
37225	812	40213160	1968-06-22	1968-06-22 00:00:00	1968-06-22	1968-06-22 00:00:00	1968-06-22	581452		0	0	0		0	0	0	53883	0	10	40213160		
217905	4782	40213160	1980-08-05	1980-08-05 00:00:00	1980-08-05	1980-08-05 00:00:00	1980-08-05	581452		0	0	0		0	0	0	318335	0	10	40213160		
34599	755	40213198	2013-04-20	2013-04-20 00:00:00	2013-04-20	2013-04-20 00:00:00	2013-04-20	581452		0	0	0		0	0	0	50006	0	133	40213198		
49530	4109	19059056	1967-02-01	1967-02-01 00:00:00	1967-02-15	1967-02-15 00:00:00	1967-02-15	38000177		0	0	14		0	0	0	273181	0	243670	19059056		
57518	4773	1713671	1966-06-26	1966-06-26 00:00:00	1966-07-17	1966-07-17 00:00:00	1966-07-17	38000177		0	0	21		0	0	0	317892	0	562251	1713671		
49737	4125	1127078	1969-07-10	1969-07-10 00:00:00	1969-07-24	1969-07-24 00:00:00	1969-07-24	38000177		0	0	14		0	0	0	274211	0	282464	1127078		
154065	3392	40213160	1967-09-09	1967-09-09 00:00:00	1967-09-09	1967-09-09 00:00:00	1967-09-09	581452		0	0	0		0	0	0	224937	0	10	40213160		
148226	3259	40213160	1966-04-08	1966-04-08 00:00:00	1966-04-08	1966-04-08 00:00:00	1966-04-08	581452		0	0	0		0	0	0	216690	0	10	40213160		
29101	2409	19078461	2011-01-25	2011-01-25 00:00:00	2011-04-25	2011-04-25 00:00:00	2011-04-25	38000177		0	0	90		0	0	0	159944	0	310965	19078461		
137949	3028	40213160	1959-10-01	1959-10-01 00:00:00	1959-10-01	1959-10-01 00:00:00	1959-10-01	581452		0	0	0		0	0	0	201917	0	10	40213160		
146258	3217	40213160	1988-03-29	1988-03-29 00:00:00	1988-03-29	1988-03-29 00:00:00	1988-03-29	581452		0	0	0		0	0	0	213776	0	10	40213160		
56158	4662	46275444	1989-07-27	1989-07-27 00:00:00	1989-07-27	1989-07-27 00:00:00	1989-07-27	38000177		0	0	0		0	0	0	310773	0	1659149	46275444		
2080	163	19059056	1979-06-04	1979-06-04 00:00:00	1979-06-25	1979-06-25 00:00:00	1979-06-25	38000177		0	0	21		0	0	0	11235	0	243670	19059056		
17950	1486	40236824	1995-08-07	1995-08-07 00:00:00	1995-08-21	1995-08-21 00:00:00	1995-08-21	38000177		0	0	14		0	0	0	99023	0	1094107	40236824		
53719	4467	1127433	1991-05-03	1991-05-03 00:00:00	1991-05-17	1991-05-17 00:00:00	1991-05-17	38000177		0	0	14		0	0	0	297185	0	313782	1127433		
147485	3242	40213160	1985-01-19	1985-01-19 00:00:00	1985-01-19	1985-01-19 00:00:00	1985-01-19	581452		0	0	0		0	0	0	215606	0	10	40213160		
209286	4590	40213260	2006-11-20	2006-11-20 00:00:00	2006-11-20	2006-11-20 00:00:00	2006-11-20	581452		0	0	0		0	0	0	305826	0	121	40213260		
100060	2192	40213160	1955-09-01	1955-09-01 00:00:00	1955-09-01	1955-09-01 00:00:00	1955-09-01	581452		0	0	0		0	0	0	146177	0	10	40213160		
164160	3610	40213198	2010-01-16	2010-01-16 00:00:00	2010-01-16	2010-01-16 00:00:00	2010-01-16	581452		0	0	0		0	0	0	239828	0	133	40213198		
16157	1340	1127433	1975-03-01	1975-03-01 00:00:00	1975-03-22	1975-03-22 00:00:00	1975-03-22	38000177		0	0	21		0	0	0	88845	0	313782	1127433		
80503	1761	40213198	2018-01-21	2018-01-21 00:00:00	2018-01-21	2018-01-21 00:00:00	2018-01-21	581452		0	0	0		0	0	0	117797	0	133	40213198		
56793	4713	1127433	1982-08-11	1982-08-11 00:00:00	1982-08-25	1982-08-25 00:00:00	1982-08-25	38000177		0	0	14		0	0	0	313863	0	313782	1127433		
76426	1669	40213227	2000-02-21	2000-02-21 00:00:00	2000-02-21	2000-02-21 00:00:00	2000-02-21	581452		0	0	0		0	0	0	112079	0	113	40213227		
58042	1271	40213160	1971-09-12	1971-09-12 00:00:00	1971-09-12	1971-09-12 00:00:00	1971-09-12	581452		0	0	0		0	0	0	83847	0	10	40213160		
26854	2213	40231925	1974-06-26	1974-06-26 00:00:00	1974-06-26	1974-06-26 00:00:00	\N	38000177		0	0	0		0	0	0	147425	0	1049221	40231925		
7366	159	40213160	1955-12-27	1955-12-27 00:00:00	1955-12-27	1955-12-27 00:00:00	1955-12-27	581452		0	0	0		0	0	0	10879	0	10	40213160		
49936	4143	19059056	1968-11-08	1968-11-08 00:00:00	1968-11-22	1968-11-22 00:00:00	1968-11-22	38000177		0	0	14		0	0	0	275382	0	243670	19059056		
201682	4428	40213227	1992-06-19	1992-06-19 00:00:00	1992-06-19	1992-06-19 00:00:00	1992-06-19	581452		0	0	0		0	0	0	294381	0	113	40213227		
18724	1545	1127433	1996-09-12	1996-09-12 00:00:00	1996-09-19	1996-09-19 00:00:00	1996-09-19	38000177		0	0	7		0	0	0	103521	0	313782	1127433		
23058	1902	19006318	1949-09-20	1949-09-20 00:00:00	1949-10-04	1949-10-04 00:00:00	1949-10-04	38000177		0	0	14		0	0	0	126596	0	105078	19006318		
5295	443	19078461	1985-03-27	1985-03-27 00:00:00	1985-04-24	1985-04-24 00:00:00	1985-04-24	38000177		0	0	28		0	0	0	29427	0	310965	19078461		
372	30	1115171	2002-05-11	2002-05-11 00:00:00	2002-06-08	2002-06-08 00:00:00	2002-06-08	38000177		0	0	28		0	0	0	2077	0	849574	1115171		
183892	4040	40213227	1998-03-02	1998-03-02 00:00:00	1998-03-02	1998-03-02 00:00:00	1998-03-02	581452		0	0	0		0	0	0	268682	0	113	40213227		
19283	1593	1713671	1983-06-22	1983-06-22 00:00:00	1983-07-06	1983-07-06 00:00:00	1983-07-06	38000177		0	0	14		0	0	0	106890	0	562251	1713671		
43891	3636	1713671	1986-05-08	1986-05-08 00:00:00	1986-05-29	1986-05-29 00:00:00	1986-05-29	38000177		0	0	21		0	0	0	241779	0	562251	1713671		
43942	3639	40163554	2004-01-31	2004-01-31 00:00:00	2004-01-31	2004-01-31 00:00:00	\N	38000177		0	0	0		0	0	0	242079	0	855332	40163554		
137319	3014	40213227	2006-04-08	2006-04-08 00:00:00	2006-04-08	2006-04-08 00:00:00	2006-04-08	581452		0	0	0		0	0	0	201033	0	113	40213227		
194360	4270	40213160	1967-04-25	1967-04-25 00:00:00	1967-04-25	1967-04-25 00:00:00	1967-04-25	581452		0	0	0		0	0	0	283442	0	10	40213160		
223983	4917	40213227	2005-02-28	2005-02-28 00:00:00	2005-02-28	2005-02-28 00:00:00	2005-02-28	581452		0	0	0		0	0	0	326725	0	113	40213227		
150057	3300	40213306	2004-11-25	2004-11-25 00:00:00	2004-11-25	2004-11-25 00:00:00	2004-11-25	581452		0	0	0		0	0	0	219205	0	43	40213306		
2729	220	19019979	1982-10-31	1982-10-31 00:00:00	1982-11-14	1982-11-14 00:00:00	1982-11-14	38000177		0	0	14		0	0	0	14795	0	198405	19019979		
229605	5046	40213260	2008-01-14	2008-01-14 00:00:00	2008-01-14	2008-01-14 00:00:00	2008-01-14	581452		0	0	0		0	0	0	335316	0	121	40213260		
49328	4091	40229134	1994-03-08	1994-03-08 00:00:00	1994-03-15	1994-03-15 00:00:00	1994-03-15	38000177		0	0	7		0	0	0	271952	0	1043400	40229134		
61224	5094	1594382	1999-05-19	1999-05-19 00:00:00	1999-05-19	1999-05-19 00:00:00	\N	38000177		0	0	0		0	0	0	338442	0	1870230	1594382		
6564	552	19006318	1954-10-21	1954-10-21 00:00:00	1954-11-04	1954-11-04 00:00:00	1954-11-04	38000177		0	0	14		0	0	0	36626	0	105078	19006318		
47870	3968	1713671	1966-12-06	1966-12-06 00:00:00	1966-12-27	1966-12-27 00:00:00	1966-12-27	38000177		0	0	21		0	0	0	263835	0	562251	1713671		
86221	1889	40213314	1983-02-24	1983-02-24 00:00:00	1983-02-24	1983-02-24 00:00:00	1983-02-24	581452		0	0	0		0	0	0	125925	0	49	40213314		
50767	4217	1713671	2007-03-16	2007-03-16 00:00:00	2007-03-30	2007-03-30 00:00:00	2007-03-30	38000177		0	0	14		0	0	0	279981	0	562251	1713671		
139077	3056	40213160	1961-12-08	1961-12-08 00:00:00	1961-12-08	1961-12-08 00:00:00	1961-12-08	581452		0	0	0		0	0	0	203243	0	10	40213160		
34174	2825	1127433	1993-06-19	1993-06-19 00:00:00	1993-07-10	1993-07-10 00:00:00	1993-07-10	38000177		0	0	21		0	0	0	187333	0	313782	1127433		
23837	1962	1127433	2019-01-22	2019-01-22 00:00:00	2019-01-29	2019-01-29 00:00:00	2019-01-29	38000177		0	0	7		0	0	0	130502	0	313782	1127433		
23895	1967	19078461	1985-10-17	1985-10-17 00:00:00	1985-11-07	1985-11-07 00:00:00	1985-11-07	38000177		0	0	21		0	0	0	130891	0	310965	19078461		
7150	601	19006318	1972-08-02	1972-08-02 00:00:00	1972-08-16	1972-08-16 00:00:00	1972-08-16	38000177		0	0	14		0	0	0	39743	0	105078	19006318		
54443	4525	19133905	1990-02-27	1990-02-27 00:00:00	1990-03-10	1990-03-10 00:00:00	1990-03-10	38000177		0	0	11		0	0	0	301261	0	834102	19133905		
78640	1720	40213160	1979-12-08	1979-12-08 00:00:00	1979-12-08	1979-12-08 00:00:00	1979-12-08	581452		0	0	0		0	0	0	115011	0	10	40213160		
74299	1622	40213314	1977-05-02	1977-05-02 00:00:00	1977-05-02	1977-05-02 00:00:00	1977-05-02	581452		0	0	0		0	0	0	108968	0	49	40213314		
149744	3294	40213227	1993-11-02	1993-11-02 00:00:00	1993-11-02	1993-11-02 00:00:00	1993-11-02	581452		0	0	0		0	0	0	218787	0	113	40213227		
45098	3731	19059056	1990-01-09	1990-01-09 00:00:00	1990-01-23	1990-01-23 00:00:00	1990-01-23	38000177		0	0	14		0	0	0	247921	0	243670	19059056		
194693	4278	40213227	2011-10-28	2011-10-28 00:00:00	2011-10-28	2011-10-28 00:00:00	2011-10-28	581452		0	0	0		0	0	0	283866	0	113	40213227		
4784	103	40213160	1967-09-03	1967-09-03 00:00:00	1967-09-03	1967-09-03 00:00:00	1967-09-03	581452		0	0	0		0	0	0	7036	0	10	40213160		
4816	103	40213160	1972-05-07	1972-05-07 00:00:00	1972-05-07	1972-05-07 00:00:00	1972-05-07	581452		0	0	0		0	0	0	7028	0	10	40213160		
206104	4523	40213306	1998-03-29	1998-03-29 00:00:00	1998-03-29	1998-03-29 00:00:00	1998-03-29	581452		0	0	0		0	0	0	301146	0	43	40213306		
38848	3212	19016749	2018-07-21	2018-07-21 00:00:00	2018-07-21	2018-07-21 00:00:00	2018-07-21	38000177		0	0	0		0	0	0	213430	0	73032	19016749		
101609	2228	40213227	2008-04-26	2008-04-26 00:00:00	2008-04-26	2008-04-26 00:00:00	2008-04-26	581452		0	0	0		0	0	0	148236	0	113	40213227		
81457	1780	40213306	1988-03-15	1988-03-15 00:00:00	1988-03-15	1988-03-15 00:00:00	1988-03-15	581452		0	0	0		0	0	0	119129	0	43	40213306		
217908	4782	40213180	2005-03-08	2005-03-08 00:00:00	2005-03-08	2005-03-08 00:00:00	2005-03-08	581452		0	0	0		0	0	0	318311	0	114	40213180		
34601	755	40213227	2019-05-25	2019-05-25 00:00:00	2019-05-25	2019-05-25 00:00:00	2019-05-25	581452		0	0	0		0	0	0	50099	0	113	40213227		
49531	4109	40229134	1988-09-17	1988-09-17 00:00:00	1988-09-24	1988-09-24 00:00:00	1988-09-24	38000177		0	0	7		0	0	0	273104	0	1043400	40229134		
150630	3313	40213160	1959-08-21	1959-08-21 00:00:00	1959-08-21	1959-08-21 00:00:00	1959-08-21	581452		0	0	0		0	0	0	220043	0	10	40213160		
49738	4125	1124300	2006-11-28	2006-11-28 00:00:00	2006-11-28	2006-11-28 00:00:00	\N	38000177		0	0	0		0	0	0	274271	0	00781178901	45011828		
154071	3392	40213227	1998-02-14	1998-02-14 00:00:00	1998-02-14	1998-02-14 00:00:00	1998-02-14	581452		0	0	0		0	0	0	224944	0	113	40213227		
148230	3259	40213160	1969-12-19	1969-12-19 00:00:00	1969-12-19	1969-12-19 00:00:00	1969-12-19	581452		0	0	0		0	0	0	\N	0	10	40213160		
29105	2411	1127433	1993-01-01	1993-01-01 00:00:00	1993-02-05	1993-02-05 00:00:00	1993-02-05	38000177		0	0	35		0	0	0	160003	0	313782	1127433		
150973	3320	40213160	1964-05-03	1964-05-03 00:00:00	1964-05-03	1964-05-03 00:00:00	1964-05-03	581452		0	0	0		0	0	0	220449	0	10	40213160		
146260	3217	40213306	2005-08-23	2005-08-23 00:00:00	2005-08-23	2005-08-23 00:00:00	2005-08-23	581452		0	0	0		0	0	0	213796	0	43	40213306		
7375	615	1118084	1941-12-05	1941-12-05 00:00:00	1941-12-05	1941-12-05 00:00:00	\N	38000177		0	0	0		0	0	0	40873	0	00025152531	44923712		
2081	163	1713671	1989-01-29	1989-01-29 00:00:00	1989-02-05	1989-02-05 00:00:00	1989-02-05	38000177		0	0	7		0	0	0	11196	0	562251	1713671		
17951	1486	920300	1995-08-07	1995-08-07 00:00:00	1995-08-14	1995-08-14 00:00:00	1995-08-14	38000177		0	0	7		0	0	0	99023	0	311989	920300		
53720	4467	1127433	2016-01-10	2016-01-10 00:00:00	2016-01-31	2016-01-31 00:00:00	2016-01-31	38000177		0	0	21		0	0	0	297166	0	313782	1127433		
147489	3242	40213251	1984-01-14	1984-01-14 00:00:00	1984-01-14	1984-01-14 00:00:00	1984-01-14	581452		0	0	0		0	0	0	215600	0	21	40213251		
73419	1604	40213260	2007-07-19	2007-07-19 00:00:00	2007-07-19	2007-07-19 00:00:00	2007-07-19	581452		0	0	0		0	0	0	107637	0	121	40213260		
111359	2447	40213314	1981-10-28	1981-10-28 00:00:00	1981-10-28	1981-10-28 00:00:00	1981-10-28	581452		0	0	0		0	0	0	162298	0	49	40213314		
129370	2844	40213227	1992-09-28	1992-09-28 00:00:00	1992-09-28	1992-09-28 00:00:00	1992-09-28	581452		0	0	0		0	0	0	188894	0	113	40213227		
16158	1340	19059056	1912-10-22	1912-10-22 00:00:00	1912-11-05	1912-11-05 00:00:00	1912-11-05	38000177		0	0	14		0	0	0	88976	0	243670	19059056		
80512	1761	40213227	2013-12-29	2013-12-29 00:00:00	2013-12-29	2013-12-29 00:00:00	2013-12-29	581452		0	0	0		0	0	0	117784	0	113	40213227		
56794	4715	1118084	1995-01-14	1995-01-14 00:00:00	1995-01-14	1995-01-14 00:00:00	\N	38000177		0	0	0		0	0	0	313915	0	00025152531	44923712		
76427	1669	40213296	2000-02-21	2000-02-21 00:00:00	2000-02-21	2000-02-21 00:00:00	2000-02-21	581452		0	0	0		0	0	0	112079	0	52	40213296		
16589	358	40213227	2001-05-29	2001-05-29 00:00:00	2001-05-29	2001-05-29 00:00:00	2001-05-29	581452		0	0	0		0	0	0	23816	0	113	40213227		
26855	2213	1127433	2003-04-05	2003-04-05 00:00:00	2003-04-12	2003-04-12 00:00:00	2003-04-12	38000177		0	0	7		0	0	0	147390	0	313782	1127433		
7376	159	40213160	1958-12-16	1958-12-16 00:00:00	1958-12-16	1958-12-16 00:00:00	1958-12-16	581452		0	0	0		0	0	0	10868	0	10	40213160		
49937	4143	19006318	1968-11-08	1968-11-08 00:00:00	1968-11-22	1968-11-22 00:00:00	1968-11-22	38000177		0	0	14		0	0	0	275382	0	105078	19006318		
201688	4428	40213201	2016-02-25	2016-02-25 00:00:00	2016-02-25	2016-02-25 00:00:00	2016-02-25	581452		0	0	0		0	0	0	294387	0	33	40213201		
18725	1545	1127078	1970-09-27	1970-09-27 00:00:00	1970-11-26	1970-11-26 00:00:00	1970-11-26	38000177		0	0	60		0	0	0	103508	0	282464	1127078		
23059	1902	19059056	1949-09-20	1949-09-20 00:00:00	1949-10-04	1949-10-04 00:00:00	1949-10-04	38000177		0	0	14		0	0	0	126596	0	243670	19059056		
5296	443	46233988	1970-01-10	1970-01-10 00:00:00	1970-01-24	1970-01-24 00:00:00	1970-01-24	38000177		0	0	14		0	0	0	29453	0	1652673	46233988		
373	30	40232448	1973-09-04	1973-09-04 00:00:00	1973-09-04	1973-09-04 00:00:00	\N	38000177		0	0	0		0	0	0	2044	0	1049630	40232448		
183897	4040	40213314	1977-04-18	1977-04-18 00:00:00	1977-04-18	1977-04-18 00:00:00	1977-04-18	581452		0	0	0		0	0	0	268695	0	49	40213314		
19284	1593	1713671	1975-02-24	1975-02-24 00:00:00	1975-03-10	1975-03-10 00:00:00	1975-03-10	38000177		0	0	14		0	0	0	106851	0	562251	1713671		
43892	3636	1127078	1973-10-07	1973-10-07 00:00:00	1973-10-21	1973-10-21 00:00:00	1973-10-21	38000177		0	0	14		0	0	0	241843	0	282464	1127078		
43943	3639	40222846	2004-05-27	2004-05-27 00:00:00	2004-05-27	2004-05-27 00:00:00	\N	38000177		0	0	0		0	0	0	242067	0	996740	40222846		
137321	3014	40213160	1974-03-09	1974-03-09 00:00:00	1974-03-09	1974-03-09 00:00:00	1974-03-09	581452		0	0	0		0	0	0	201020	0	10	40213160		
62332	1361	40213227	1992-09-21	1992-09-21 00:00:00	1992-09-21	1992-09-21 00:00:00	1992-09-21	581452		0	0	0		0	0	0	90295	0	113	40213227		
223984	4917	40213180	2005-02-28	2005-02-28 00:00:00	2005-02-28	2005-02-28 00:00:00	2005-02-28	581452		0	0	0		0	0	0	326725	0	114	40213180		
150059	3300	40213251	1984-05-10	1984-05-10 00:00:00	1984-05-10	1984-05-10 00:00:00	1984-05-10	581452		0	0	0		0	0	0	219253	0	21	40213251		
2730	220	19073183	1982-10-31	1982-10-31 00:00:00	1982-11-14	1982-11-14 00:00:00	1982-11-14	38000177		0	0	14		0	0	0	14795	0	308182	19073183		
229610	5046	40213160	1958-09-23	1958-09-23 00:00:00	1958-09-23	1958-09-23 00:00:00	1958-09-23	581452		0	0	0		0	0	0	335348	0	10	40213160		
49329	4091	1127433	1990-11-09	1990-11-09 00:00:00	1990-11-23	1990-11-23 00:00:00	1990-11-23	38000177		0	0	14		0	0	0	271948	0	313782	1127433		
61225	5094	1127433	2006-06-05	2006-06-05 00:00:00	2006-06-12	2006-06-12 00:00:00	2006-06-12	38000177		0	0	7		0	0	0	338458	0	313782	1127433		
6565	552	1115171	2015-06-05	2015-06-05 00:00:00	2015-09-03	2015-09-03 00:00:00	2015-09-03	38000177		0	0	90		0	0	0	36614	0	849574	1115171		
47871	3968	1713671	1931-09-23	1931-09-23 00:00:00	1931-10-14	1931-10-14 00:00:00	1931-10-14	38000177		0	0	21		0	0	0	263826	0	562251	1713671		
86222	1889	40213160	1983-02-24	1983-02-24 00:00:00	1983-02-24	1983-02-24 00:00:00	1983-02-24	581452		0	0	0		0	0	0	125925	0	10	40213160		
50768	4217	1127433	1976-06-11	1976-06-11 00:00:00	1976-06-25	1976-06-25 00:00:00	1976-06-25	38000177		0	0	14		0	0	0	279975	0	313782	1127433		
69106	1512	40213296	2017-11-29	2017-11-29 00:00:00	2017-11-29	2017-11-29 00:00:00	2017-11-29	581452		0	0	0		0	0	0	100951	0	52	40213296		
34175	2825	1127433	1970-04-30	1970-04-30 00:00:00	1970-05-07	1970-05-07 00:00:00	1970-05-07	38000177		0	0	7		0	0	0	187229	0	313782	1127433		
23838	1962	1127433	1987-02-05	1987-02-05 00:00:00	1987-02-19	1987-02-19 00:00:00	1987-02-19	38000177		0	0	14		0	0	0	130478	0	313782	1127433		
23896	1967	19059056	1960-11-15	1960-11-15 00:00:00	1960-11-29	1960-11-29 00:00:00	1960-11-29	38000177		0	0	14		0	0	0	130805	0	243670	19059056		
7151	601	1115171	1996-08-20	1996-08-20 00:00:00	1996-09-17	1996-09-17 00:00:00	1996-09-17	38000177		0	0	28		0	0	0	39685	0	849574	1115171		
54444	4525	1713671	1985-10-30	1985-10-30 00:00:00	1985-11-20	1985-11-20 00:00:00	1985-11-20	38000177		0	0	21		0	0	0	301259	0	562251	1713671		
78647	1720	40213314	1979-07-07	1979-07-07 00:00:00	1979-07-07	1979-07-07 00:00:00	1979-07-07	581452		0	0	0		0	0	0	115033	0	49	40213314		
74301	1622	40213296	2014-06-02	2014-06-02 00:00:00	2014-06-02	2014-06-02 00:00:00	2014-06-02	581452		0	0	0		0	0	0	108994	0	52	40213296		
149745	3294	40213201	2016-08-30	2016-08-30 00:00:00	2016-08-30	2016-08-30 00:00:00	2016-08-30	581452		0	0	0		0	0	0	218871	0	33	40213201		
45099	3731	1127078	1974-06-20	1974-06-20 00:00:00	1974-07-04	1974-07-04 00:00:00	1974-07-04	38000177		0	0	14		0	0	0	247920	0	282464	1127078		
194700	4278	40213201	2016-11-25	2016-11-25 00:00:00	2016-11-25	2016-11-25 00:00:00	2016-11-25	581452		0	0	0		0	0	0	283851	0	33	40213201		
4791	103	40213227	2009-09-27	2009-09-27 00:00:00	2009-09-27	2009-09-27 00:00:00	2009-09-27	581452		0	0	0		0	0	0	7081	0	113	40213227		
16111	347	40213227	2002-11-10	2002-11-10 00:00:00	2002-11-10	2002-11-10 00:00:00	2002-11-10	581452		0	0	0		0	0	0	23109	0	113	40213227		
206106	4523	40213227	1998-03-29	1998-03-29 00:00:00	1998-03-29	1998-03-29 00:00:00	1998-03-29	581452		0	0	0		0	0	0	301146	0	113	40213227		
38849	3212	40220386	2018-07-21	2018-07-21 00:00:00	2018-07-21	2018-07-21 00:00:00	2018-07-21	38000177		0	0	0		0	0	0	213430	0	1808217	40220386		
101620	2228	40213198	2012-05-19	2012-05-19 00:00:00	2012-05-19	2012-05-19 00:00:00	2012-05-19	581452		0	0	0		0	0	0	148238	0	133	40213198		
81460	1780	40213160	1965-09-21	1965-09-21 00:00:00	1965-09-21	1965-09-21 00:00:00	1965-09-21	581452		0	0	0		0	0	0	119098	0	10	40213160		
217911	4782	40213314	1981-07-07	1981-07-07 00:00:00	1981-07-07	1981-07-07 00:00:00	1981-07-07	581452		0	0	0		0	0	0	318352	0	49	40213314		
231950	5097	40213160	1967-10-02	1967-10-02 00:00:00	1967-10-02	1967-10-02 00:00:00	1967-10-02	581452		0	0	0		0	0	0	338747	0	10	40213160		
49532	4109	40229134	2015-03-21	2015-03-21 00:00:00	2015-04-04	2015-04-04 00:00:00	2015-04-04	38000177		0	0	14		0	0	0	273117	0	1043400	40229134		
150633	3313	40213227	2016-06-24	2016-06-24 00:00:00	2016-06-24	2016-06-24 00:00:00	2016-06-24	581452		0	0	0		0	0	0	219993	0	113	40213227		
49742	4127	1115171	2011-11-03	2011-11-03 00:00:00	2011-12-01	2011-12-01 00:00:00	2011-12-01	38000177		0	0	28		0	0	0	274344	0	849574	1115171		
154080	3392	40213306	1989-02-04	1989-02-04 00:00:00	1989-02-04	1989-02-04 00:00:00	1989-02-04	581452		0	0	0		0	0	0	224952	0	43	40213306		
148232	3259	40213296	2005-11-04	2005-11-04 00:00:00	2005-11-04	2005-11-04 00:00:00	2005-11-04	581452		0	0	0		0	0	0	216639	0	52	40213296		
29106	2411	19075001	1993-01-01	1993-01-01 00:00:00	1993-02-05	1993-02-05 00:00:00	1993-02-05	38000177		0	0	35		0	0	0	160003	0	309097	19075001		
150974	3320	40213227	1995-01-08	1995-01-08 00:00:00	1995-01-08	1995-01-08 00:00:00	1995-01-08	581452		0	0	0		0	0	0	220465	0	113	40213227		
146261	3217	40213180	2005-08-23	2005-08-23 00:00:00	2005-08-23	2005-08-23 00:00:00	2005-08-23	581452		0	0	0		0	0	0	213796	0	114	40213180		
7376	615	1127433	1914-01-03	1914-01-03 00:00:00	1914-01-17	1914-01-17 00:00:00	1914-01-17	38000177		0	0	14		0	0	0	41002	0	313782	1127433		
2083	164	1127433	1979-11-22	1979-11-22 00:00:00	1979-11-29	1979-11-29 00:00:00	1979-11-29	38000177		0	0	7		0	0	0	11285	0	313782	1127433		
17952	1486	1118084	1991-07-16	1991-07-16 00:00:00	1991-07-16	1991-07-16 00:00:00	\N	38000177		0	0	0		0	0	0	99034	0	00025152531	44923712		
53721	4467	1127433	1966-08-27	1966-08-27 00:00:00	1966-09-24	1966-09-24 00:00:00	1966-09-24	38000177		0	0	28		0	0	0	297162	0	313782	1127433		
147491	3242	40213314	1981-07-25	1981-07-25 00:00:00	1981-07-25	1981-07-25 00:00:00	1981-07-25	581452		0	0	0		0	0	0	215598	0	49	40213314		
73427	1604	40213227	1995-07-13	1995-07-13 00:00:00	1995-07-13	1995-07-13 00:00:00	1995-07-13	581452		0	0	0		0	0	0	107633	0	113	40213227		
111361	2447	40213314	1980-11-26	1980-11-26 00:00:00	1980-11-26	1980-11-26 00:00:00	1980-11-26	581452		0	0	0		0	0	0	162305	0	49	40213314		
129378	2845	40213160	1956-03-08	1956-03-08 00:00:00	1956-03-08	1956-03-08 00:00:00	1956-03-08	581452		0	0	0		0	0	0	188914	0	10	40213160		
16159	1340	1713671	1931-03-28	1931-03-28 00:00:00	1931-04-18	1931-04-18 00:00:00	1931-04-18	38000177		0	0	21		0	0	0	88905	0	562251	1713671		
80516	1761	40213227	2003-11-02	2003-11-02 00:00:00	2003-11-02	2003-11-02 00:00:00	2003-11-02	581452		0	0	0		0	0	0	117777	0	113	40213227		
56796	4715	19133905	1983-12-26	1983-12-26 00:00:00	1984-01-08	1984-01-08 00:00:00	1984-01-08	38000177		0	0	13		0	0	0	313958	0	834102	19133905		
76433	1669	40213160	1959-10-12	1959-10-12 00:00:00	1959-10-12	1959-10-12 00:00:00	1959-10-12	581452		0	0	0		0	0	0	112097	0	10	40213160		
16596	358	40213227	2011-04-12	2011-04-12 00:00:00	2011-04-12	2011-04-12 00:00:00	2011-04-12	581452		0	0	0		0	0	0	23864	0	113	40213227		
26856	2213	19133905	1987-03-19	1987-03-19 00:00:00	1987-03-29	1987-03-29 00:00:00	1987-03-29	38000177		0	0	10		0	0	0	147377	0	834102	19133905		
7378	159	40213296	1997-08-26	1997-08-26 00:00:00	1997-08-26	1997-08-26 00:00:00	1997-08-26	581452		0	0	0		0	0	0	10885	0	52	40213296		
49940	4143	19133905	1997-04-05	1997-04-05 00:00:00	1997-04-13	1997-04-13 00:00:00	1997-04-13	38000177		0	0	8		0	0	0	275370	0	834102	19133905		
213200	4675	40213227	1992-10-25	1992-10-25 00:00:00	1992-10-25	1992-10-25 00:00:00	1992-10-25	581452		0	0	0		0	0	0	311528	0	113	40213227		
37457	3096	19018935	2011-10-02	2011-10-02 00:00:00	2011-10-02	2011-10-02 00:00:00	\N	38000177		0	0	0		0	0	0	206066	0	197604	19018935		
23060	1902	1127433	2012-01-29	2012-01-29 00:00:00	2012-02-12	2012-02-12 00:00:00	2012-02-12	38000177		0	0	14		0	0	0	126649	0	313782	1127433		
5297	443	19059056	1970-01-10	1970-01-10 00:00:00	1970-01-24	1970-01-24 00:00:00	1970-01-24	38000177		0	0	14		0	0	0	29453	0	243670	19059056		
374	30	19008572	1976-10-29	1976-10-29 00:00:00	1976-11-19	1976-11-19 00:00:00	1976-11-19	38000177		0	0	21		0	0	0	2065	0	106258	19008572		
183904	4040	40213227	2007-03-12	2007-03-12 00:00:00	2007-03-12	2007-03-12 00:00:00	2007-03-12	581452		0	0	0		0	0	0	268670	0	113	40213227		
19285	1593	1118084	1975-08-17	1975-08-17 00:00:00	1975-08-17	1975-08-17 00:00:00	\N	38000177		0	0	0		0	0	0	106851	0	00025152531	44923712		
43893	3636	1127433	1979-03-12	1979-03-12 00:00:00	1979-03-26	1979-03-26 00:00:00	1979-03-26	38000177		0	0	14		0	0	0	241804	0	313782	1127433		
43944	3639	19075601	2007-07-07	2007-07-07 00:00:00	2007-07-07	2007-07-07 00:00:00	\N	38000177		0	0	0		0	0	0	242080	0	309362	19075601		
137324	3014	40213296	2014-04-19	2014-04-19 00:00:00	2014-04-19	2014-04-19 00:00:00	2014-04-19	581452		0	0	0		0	0	0	201015	0	52	40213296		
62347	1361	40213227	2000-11-06	2000-11-06 00:00:00	2000-11-06	2000-11-06 00:00:00	2000-11-06	581452		0	0	0		0	0	0	90319	0	113	40213227		
223985	4917	40213306	2005-02-28	2005-02-28 00:00:00	2005-02-28	2005-02-28 00:00:00	2005-02-28	581452		0	0	0		0	0	0	326725	0	43	40213306		
150073	3301	40213227	1992-04-28	1992-04-28 00:00:00	1992-04-28	1992-04-28 00:00:00	1992-04-28	581452		0	0	0		0	0	0	219350	0	113	40213227		
2731	220	19133873	1985-08-17	1985-08-17 00:00:00	1985-08-24	1985-08-24 00:00:00	1985-08-24	38000177		0	0	7		0	0	0	14812	0	834061	19133873		
229620	5046	40213160	1958-04-21	1958-04-21 00:00:00	1958-04-21	1958-04-21 00:00:00	1958-04-21	581452		0	0	0		0	0	0	335367	0	10	40213160		
49330	4091	1127078	1978-04-02	1978-04-02 00:00:00	1978-04-16	1978-04-16 00:00:00	1978-04-16	38000177		0	0	14		0	0	0	271941	0	282464	1127078		
61226	5094	19008572	1999-05-04	1999-05-04 00:00:00	1999-05-04	1999-05-04 00:00:00	\N	38000177		0	0	0		0	0	0	338446	0	106258	19008572		
6566	552	19059056	1952-03-16	1952-03-16 00:00:00	1952-03-30	1952-03-30 00:00:00	1952-03-30	38000177		0	0	14		0	0	0	36650	0	243670	19059056		
47872	3968	46233710	1977-07-01	1977-07-01 00:00:00	1977-07-29	1977-07-29 00:00:00	1977-07-29	38000177		0	0	28		0	0	0	263906	0	1650142	46233710		
23905	1967	1127433	1969-01-02	1969-01-02 00:00:00	1969-01-16	1969-01-16 00:00:00	1969-01-16	38000177		0	0	14		0	0	0	130889	0	313782	1127433		
50769	4217	40165015	1991-07-05	1991-07-05 00:00:00	1991-07-05	1991-07-05 00:00:00	\N	38000177		0	0	0		0	0	0	279909	0	861467	40165015		
69108	1512	40213314	1977-05-18	1977-05-18 00:00:00	1977-05-18	1977-05-18 00:00:00	1977-05-18	581452		0	0	0		0	0	0	100989	0	49	40213314		
34176	2825	19059056	1927-09-12	1927-09-12 00:00:00	1927-09-26	1927-09-26 00:00:00	1927-09-26	38000177		0	0	14		0	0	0	187312	0	243670	19059056		
23839	1962	19059056	1967-01-23	1967-01-23 00:00:00	1967-02-06	1967-02-06 00:00:00	1967-02-06	38000177		0	0	14		0	0	0	130476	0	243670	19059056		
23897	1967	19006318	1960-11-15	1960-11-15 00:00:00	1960-11-29	1960-11-29 00:00:00	1960-11-29	38000177		0	0	14		0	0	0	130805	0	105078	19006318		
7152	601	19078461	2008-12-13	2008-12-13 00:00:00	2009-01-03	2009-01-03 00:00:00	2009-01-03	38000177		0	0	21		0	0	0	39687	0	310965	19078461		
54445	4526	1713671	1980-10-10	1980-10-10 00:00:00	1980-10-24	1980-10-24 00:00:00	1980-10-24	38000177		0	0	14		0	0	0	301322	0	562251	1713671		
78648	1720	40213160	1979-07-07	1979-07-07 00:00:00	1979-07-07	1979-07-07 00:00:00	1979-07-07	581452		0	0	0		0	0	0	115033	0	10	40213160		
74308	1622	40213227	2005-06-27	2005-06-27 00:00:00	2005-06-27	2005-06-27 00:00:00	2005-06-27	581452		0	0	0		0	0	0	108939	0	113	40213227		
149764	3294	40213160	1955-10-04	1955-10-04 00:00:00	1955-10-04	1955-10-04 00:00:00	1955-10-04	581452		0	0	0		0	0	0	218837	0	10	40213160		
45100	3731	46233988	1974-06-20	1974-06-20 00:00:00	1974-07-04	1974-07-04 00:00:00	1974-07-04	38000177		0	0	14		0	0	0	247920	0	1652673	46233988		
194713	4278	40213227	1992-01-10	1992-01-10 00:00:00	1992-01-10	1992-01-10 00:00:00	1992-01-10	581452		0	0	0		0	0	0	283926	0	113	40213227		
4792	103	40213296	2009-09-27	2009-09-27 00:00:00	2009-09-27	2009-09-27 00:00:00	2009-09-27	581452		0	0	0		0	0	0	7081	0	52	40213296		
16114	347	40213227	2010-11-21	2010-11-21 00:00:00	2010-11-21	2010-11-21 00:00:00	2010-11-21	581452		0	0	0		0	0	0	23111	0	113	40213227		
206108	4523	40213306	1998-12-06	1998-12-06 00:00:00	1998-12-06	1998-12-06 00:00:00	1998-12-06	581452		0	0	0		0	0	0	301171	0	43	40213306		
38850	3212	46275444	2018-07-21	2018-07-21 00:00:00	2018-07-21	2018-07-21 00:00:00	2018-07-21	38000177		0	0	0		0	0	0	213430	0	1659149	46275444		
101644	2228	40213201	2013-05-25	2013-05-25 00:00:00	2013-05-25	2013-05-25 00:00:00	2013-05-25	581452		0	0	0		0	0	0	148262	0	33	40213201		
81469	1780	40213260	2015-06-16	2015-06-16 00:00:00	2015-06-16	2015-06-16 00:00:00	2015-06-16	581452		0	0	0		0	0	0	119115	0	121	40213260		
217913	4782	40213314	1980-10-07	1980-10-07 00:00:00	1980-10-07	1980-10-07 00:00:00	1980-10-07	581452		0	0	0		0	0	0	318351	0	49	40213314		
231956	5097	40213227	1999-06-21	1999-06-21 00:00:00	1999-06-21	1999-06-21 00:00:00	1999-06-21	581452		0	0	0		0	0	0	338672	0	113	40213227		
49534	4109	40169216	1967-12-08	1967-12-08 00:00:00	1967-12-08	1967-12-08 00:00:00	\N	38000177		0	0	0		0	0	0	273154	0	895994	40169216		
150638	3313	40213160	1955-04-29	1955-04-29 00:00:00	1955-04-29	1955-04-29 00:00:00	1955-04-29	581452		0	0	0		0	0	0	219999	0	10	40213160		
49743	4127	19075601	2012-04-01	2012-04-01 00:00:00	2012-04-01	2012-04-01 00:00:00	2012-04-01	38000177		0	0	0		0	0	0	274344	0	309362	19075601		
154081	3392	40213260	2017-07-08	2017-07-08 00:00:00	2017-07-08	2017-07-08 00:00:00	2017-07-08	581452		0	0	0		0	0	0	224987	0	121	40213260		
148242	3259	40213160	1966-07-08	1966-07-08 00:00:00	1966-07-08	1966-07-08 00:00:00	1966-07-08	581452		0	0	0		0	0	0	216667	0	10	40213160		
29107	2411	40162522	1993-01-01	1993-01-01 00:00:00	1993-01-01	1993-01-01 00:00:00	\N	38000177		0	0	0		0	0	0	160003	0	857005	40162522		
150978	3320	40213160	1964-02-02	1964-02-02 00:00:00	1964-02-02	1964-02-02 00:00:00	1964-02-02	581452		0	0	0		0	0	0	220489	0	10	40213160		
146264	3217	40213227	2005-08-23	2005-08-23 00:00:00	2005-08-23	2005-08-23 00:00:00	2005-08-23	581452		0	0	0		0	0	0	213796	0	113	40213227		
7377	615	40229134	1920-07-16	1920-07-16 00:00:00	1920-07-30	1920-07-30 00:00:00	1920-07-30	38000177		0	0	14		0	0	0	40933	0	1043400	40229134		
2084	164	1127078	1971-04-26	1971-04-26 00:00:00	1971-05-10	1971-05-10 00:00:00	1971-05-10	38000177		0	0	14		0	0	0	11306	0	282464	1127078		
56205	4666	19128065	1991-06-04	1991-06-04 00:00:00	1992-05-29	1992-05-29 00:00:00	1992-05-29	38000177		0	0	360		0	0	0	310934	0	749882	19128065		
53722	4467	19059056	1959-02-07	1959-02-07 00:00:00	1959-03-07	1959-03-07 00:00:00	1959-03-07	38000177		0	0	28		0	0	0	297161	0	243670	19059056		
186998	4107	40213160	1971-10-18	1971-10-18 00:00:00	1971-10-18	1971-10-18 00:00:00	1971-10-18	581452		0	0	0		0	0	0	272875	0	10	40213160		
73429	1604	40213227	2005-07-07	2005-07-07 00:00:00	2005-07-07	2005-07-07 00:00:00	2005-07-07	581452		0	0	0		0	0	0	107636	0	113	40213227		
111362	2447	40213160	1980-11-26	1980-11-26 00:00:00	1980-11-26	1980-11-26 00:00:00	1980-11-26	581452		0	0	0		0	0	0	162305	0	10	40213160		
129382	2845	40213296	1997-01-02	1997-01-02 00:00:00	1997-01-02	1997-01-02 00:00:00	1997-01-02	581452		0	0	0		0	0	0	188923	0	52	40213296		
16160	1340	1127433	1985-09-30	1985-09-30 00:00:00	1985-10-28	1985-10-28 00:00:00	1985-10-28	38000177		0	0	28		0	0	0	88847	0	313782	1127433		
80517	1761	40213160	1956-01-29	1956-01-29 00:00:00	1956-01-29	1956-01-29 00:00:00	1956-01-29	581452		0	0	0		0	0	0	117793	0	10	40213160		
56797	4715	1127433	1996-07-14	1996-07-14 00:00:00	1996-07-28	1996-07-28 00:00:00	1996-07-28	38000177		0	0	14		0	0	0	313933	0	313782	1127433		
87711	1924	40213296	2013-06-14	2013-06-14 00:00:00	2013-06-14	2013-06-14 00:00:00	2013-06-14	581452		0	0	0		0	0	0	128051	0	52	40213296		
16605	358	40213201	2006-06-27	2006-06-27 00:00:00	2006-06-27	2006-06-27 00:00:00	2006-06-27	581452		0	0	0		0	0	0	23805	0	33	40213201		
26857	2213	19059056	1972-05-23	1972-05-23 00:00:00	1972-06-06	1972-06-06 00:00:00	1972-06-06	38000177		0	0	14		0	0	0	147424	0	243670	19059056		
7387	159	40213260	2006-04-18	2006-04-18 00:00:00	2006-04-18	2006-04-18 00:00:00	2006-04-18	581452		0	0	0		0	0	0	10932	0	121	40213260		
49941	4143	1118084	2000-12-03	2000-12-03 00:00:00	2000-12-03	2000-12-03 00:00:00	\N	38000177		0	0	0		0	0	0	275355	0	00025152531	44923712		
213233	4675	40213227	2002-12-22	2002-12-22 00:00:00	2002-12-22	2002-12-22 00:00:00	2002-12-22	581452		0	0	0		0	0	0	311517	0	113	40213227		
37458	3096	1713671	1987-10-12	1987-10-12 00:00:00	1987-10-19	1987-10-19 00:00:00	1987-10-19	38000177		0	0	7		0	0	0	206051	0	562251	1713671		
23061	1902	1713671	1964-03-12	1964-03-12 00:00:00	1964-03-26	1964-03-26 00:00:00	1964-03-26	38000177		0	0	14		0	0	0	126636	0	562251	1713671		
5298	443	19078461	1983-02-01	1983-02-01 00:00:00	1983-03-08	1983-03-08 00:00:00	1983-03-08	38000177		0	0	35		0	0	0	29425	0	310965	19078461		
375	30	40229134	2013-12-07	2013-12-07 00:00:00	2013-12-14	2013-12-14 00:00:00	2013-12-14	38000177		0	0	7		0	0	0	2049	0	1043400	40229134		
239314	5253	40213160	1956-03-17	1956-03-17 00:00:00	1956-03-17	1956-03-17 00:00:00	1956-03-17	581452		0	0	0		0	0	0	349486	0	10	40213160		
19286	1593	19059056	1945-03-17	1945-03-17 00:00:00	1945-04-14	1945-04-14 00:00:00	1945-04-14	38000177		0	0	28		0	0	0	106840	0	243670	19059056		
43894	3636	1127433	2017-03-18	2017-03-18 00:00:00	2017-04-08	2017-04-08 00:00:00	2017-04-08	38000177		0	0	21		0	0	0	241835	0	313782	1127433		
43945	3639	19126352	2007-07-07	2007-07-07 00:00:00	2007-07-07	2007-07-07 00:00:00	\N	38000177		0	0	0		0	0	0	242080	0	705129	19126352		
176291	3876	40213306	1988-02-29	1988-02-29 00:00:00	1988-02-29	1988-02-29 00:00:00	1988-02-29	581452		0	0	0		0	0	0	257534	0	43	40213306		
62349	1361	40213227	2010-09-20	2010-09-20 00:00:00	2010-09-20	2010-09-20 00:00:00	2010-09-20	581452		0	0	0		0	0	0	90331	0	113	40213227		
223992	4917	40213160	1987-02-02	1987-02-02 00:00:00	1987-02-02	1987-02-02 00:00:00	1987-02-02	581452		0	0	0		0	0	0	326720	0	10	40213160		
150085	3301	40213227	2009-08-04	2009-08-04 00:00:00	2009-08-04	2009-08-04 00:00:00	2009-08-04	581452		0	0	0		0	0	0	219364	0	113	40213227		
2732	220	1118084	2019-05-15	2019-05-15 00:00:00	2019-05-15	2019-05-15 00:00:00	\N	38000177		0	0	0		0	0	0	14842	0	00025152531	44923712		
229623	5046	40213227	1992-03-02	1992-03-02 00:00:00	1992-03-02	1992-03-02 00:00:00	1992-03-02	581452		0	0	0		0	0	0	335310	0	113	40213227		
49331	4092	19128065	1989-05-24	1989-05-24 00:00:00	1990-05-19	1990-05-19 00:00:00	1990-05-19	38000177		0	0	360		0	0	0	272051	0	749882	19128065		
61227	5094	19133905	2006-10-18	2006-10-18 00:00:00	2006-10-30	2006-10-30 00:00:00	2006-10-30	38000177		0	0	12		0	0	0	338459	0	834102	19133905		
6567	552	19006318	1952-03-16	1952-03-16 00:00:00	1952-03-30	1952-03-30 00:00:00	1952-03-30	38000177		0	0	14		0	0	0	36650	0	105078	19006318		
47873	3968	1127433	1977-07-01	1977-07-01 00:00:00	1977-07-29	1977-07-29 00:00:00	1977-07-29	38000177		0	0	28		0	0	0	263906	0	313782	1127433		
23927	1971	19059056	1973-09-14	1973-09-14 00:00:00	1973-09-28	1973-09-28 00:00:00	1973-09-28	38000177		0	0	14		0	0	0	131030	0	243670	19059056		
50770	4217	1127433	1991-07-05	1991-07-05 00:00:00	1991-09-03	1991-09-03 00:00:00	1991-09-03	38000177		0	0	60		0	0	0	279909	0	313782	1127433		
69110	1512	40213306	1996-06-12	1996-06-12 00:00:00	1996-06-12	1996-06-12 00:00:00	1996-06-12	581452		0	0	0		0	0	0	100992	0	43	40213306		
34177	2825	19059056	1946-03-09	1946-03-09 00:00:00	1946-04-13	1946-04-13 00:00:00	1946-04-13	38000177		0	0	35		0	0	0	187330	0	243670	19059056		
23840	1962	19133873	1966-10-28	1966-10-28 00:00:00	1966-11-04	1966-11-04 00:00:00	1966-11-04	38000177		0	0	7		0	0	0	130455	0	834061	19133873		
23898	1967	1127433	2001-12-12	2001-12-12 00:00:00	2001-12-19	2001-12-19 00:00:00	2001-12-19	38000177		0	0	7		0	0	0	130828	0	313782	1127433		
7153	601	19019979	1974-10-21	1974-10-21 00:00:00	1974-11-25	1974-11-25 00:00:00	1974-11-25	38000177		0	0	35		0	0	0	39681	0	198405	19019979		
54446	4526	19133873	1954-08-07	1954-08-07 00:00:00	1954-08-17	1954-08-17 00:00:00	1954-08-17	38000177		0	0	10		0	0	0	301326	0	834061	19133873		
78652	1720	40213160	1983-11-26	1983-11-26 00:00:00	1983-11-26	1983-11-26 00:00:00	1983-11-26	581452		0	0	0		0	0	0	115015	0	10	40213160		
15471	334	40213227	2006-06-21	2006-06-21 00:00:00	2006-06-21	2006-06-21 00:00:00	2006-06-21	581452		0	0	0		0	0	0	22173	0	113	40213227		
149767	3294	40213198	2014-10-21	2014-10-21 00:00:00	2014-10-21	2014-10-21 00:00:00	2014-10-21	581452		0	0	0		0	0	0	218833	0	133	40213198		
45101	3732	1118084	1993-12-24	1993-12-24 00:00:00	1993-12-24	1993-12-24 00:00:00	\N	38000177		0	0	0		0	0	0	248014	0	00025152531	44923712		
194722	4278	40213160	1955-09-30	1955-09-30 00:00:00	1955-09-30	1955-09-30 00:00:00	1955-09-30	581452		0	0	0		0	0	0	283914	0	10	40213160		
4794	103	40213260	2017-05-28	2017-05-28 00:00:00	2017-05-28	2017-05-28 00:00:00	2017-05-28	581452		0	0	0		0	0	0	7059	0	121	40213260		
16115	347	40213296	2010-11-21	2010-11-21 00:00:00	2010-11-21	2010-11-21 00:00:00	2010-11-21	581452		0	0	0		0	0	0	23111	0	52	40213296		
206112	4523	40213160	1976-07-04	1976-07-04 00:00:00	1976-07-04	1976-07-04 00:00:00	1976-07-04	581452		0	0	0		0	0	0	301207	0	10	40213160		
38851	3212	19078924	2018-07-21	2018-07-21 00:00:00	2018-07-21	2018-07-21 00:00:00	2018-07-21	38000177		0	0	0		0	0	0	213430	0	311700	19078924		
121904	2679	40213227	1994-11-18	1994-11-18 00:00:00	1994-11-18	1994-11-18 00:00:00	1994-11-18	581452		0	0	0		0	0	0	177489	0	113	40213227		
81475	1781	40213227	2012-12-11	2012-12-11 00:00:00	2012-12-11	2012-12-11 00:00:00	2012-12-11	581452		0	0	0		0	0	0	119275	0	113	40213227		
217914	4782	40213160	1980-10-07	1980-10-07 00:00:00	1980-10-07	1980-10-07 00:00:00	1980-10-07	581452		0	0	0		0	0	0	318351	0	10	40213160		
231966	5097	40213296	2007-07-02	2007-07-02 00:00:00	2007-07-02	2007-07-02 00:00:00	2007-07-02	581452		0	0	0		0	0	0	338654	0	52	40213296		
49535	4109	1154615	1967-12-08	1967-12-08 00:00:00	1967-12-08	1967-12-08 00:00:00	\N	38000177		0	0	0		0	0	0	273154	0	745679	1154615		
150658	3314	40213160	1963-02-15	1963-02-15 00:00:00	1963-02-15	1963-02-15 00:00:00	1963-02-15	581452		0	0	0		0	0	0	220123	0	10	40213160		
49744	4127	40220960	2012-04-01	2012-04-01 00:00:00	2012-04-01	2012-04-01 00:00:00	2012-04-01	38000177		0	0	0		0	0	0	274344	0	1804799	40220960		
154087	3392	40213227	2009-01-10	2009-01-10 00:00:00	2009-01-10	2009-01-10 00:00:00	2009-01-10	581452		0	0	0		0	0	0	224986	0	113	40213227		
148244	3259	40213260	2015-10-30	2015-10-30 00:00:00	2015-10-30	2015-10-30 00:00:00	2015-10-30	581452		0	0	0		0	0	0	216641	0	121	40213260		
29108	2411	19059056	1965-05-28	1965-05-28 00:00:00	1965-06-11	1965-06-11 00:00:00	1965-06-11	38000177		0	0	14		0	0	0	159971	0	243670	19059056		
150982	3320	40213227	2014-08-31	2014-08-31 00:00:00	2014-08-31	2014-08-31 00:00:00	2014-08-31	581452		0	0	0		0	0	0	220468	0	113	40213227		
146265	3217	40213314	1983-12-13	1983-12-13 00:00:00	1983-12-13	1983-12-13 00:00:00	1983-12-13	581452		0	0	0		0	0	0	213806	0	49	40213314		
7378	615	1127433	1991-05-06	1991-05-06 00:00:00	1991-05-20	1991-05-20 00:00:00	1991-05-20	38000177		0	0	14		0	0	0	41043	0	313782	1127433		
2085	164	46233988	1971-04-26	1971-04-26 00:00:00	1971-05-10	1971-05-10 00:00:00	1971-05-10	38000177		0	0	14		0	0	0	11306	0	1652673	46233988		
56206	4666	19128065	1988-06-19	1988-06-19 00:00:00	1989-06-14	1989-06-14 00:00:00	1989-06-14	38000177		0	0	360		0	0	0	310959	0	749882	19128065		
53723	4467	19006318	1957-04-27	1957-04-27 00:00:00	1957-05-11	1957-05-11 00:00:00	1957-05-11	38000177		0	0	14		0	0	0	297245	0	105078	19006318		
187003	4107	40213306	1991-05-20	1991-05-20 00:00:00	1991-05-20	1991-05-20 00:00:00	1991-05-20	581452		0	0	0		0	0	0	272886	0	43	40213306		
73436	1604	40213296	1997-03-06	1997-03-06 00:00:00	1997-03-06	1997-03-06 00:00:00	1997-03-06	581452		0	0	0		0	0	0	107651	0	52	40213296		
111366	2447	40213251	1984-01-25	1984-01-25 00:00:00	1984-01-25	1984-01-25 00:00:00	1984-01-25	581452		0	0	0		0	0	0	162300	0	21	40213251		
129391	2845	40213160	1957-09-12	1957-09-12 00:00:00	1957-09-12	1957-09-12 00:00:00	1957-09-12	581452		0	0	0		0	0	0	188915	0	10	40213160		
16161	1340	1127433	1916-06-04	1916-06-04 00:00:00	1916-06-18	1916-06-18 00:00:00	1916-06-18	38000177		0	0	14		0	0	0	88934	0	313782	1127433		
80528	1761	40213201	2019-01-27	2019-01-27 00:00:00	2019-01-27	2019-01-27 00:00:00	2019-01-27	581452		0	0	0		0	0	0	117707	0	33	40213201		
56798	4715	1127433	2004-09-27	2004-09-27 00:00:00	2004-10-04	2004-10-04 00:00:00	2004-10-04	38000177		0	0	7		0	0	0	313898	0	313782	1127433		
87713	1924	40213227	2013-06-14	2013-06-14 00:00:00	2013-06-14	2013-06-14 00:00:00	2013-06-14	581452		0	0	0		0	0	0	128051	0	113	40213227		
78276	1713	40213296	2014-05-07	2014-05-07 00:00:00	2014-05-07	2014-05-07 00:00:00	2014-05-07	581452		0	0	0		0	0	0	114460	0	52	40213296		
26858	2213	1713671	2008-11-28	2008-11-28 00:00:00	2008-12-05	2008-12-05 00:00:00	2008-12-05	38000177		0	0	7		0	0	0	147407	0	562251	1713671		
7392	159	40213160	1955-06-28	1955-06-28 00:00:00	1955-06-28	1955-06-28 00:00:00	1955-06-28	581452		0	0	0		0	0	0	10907	0	10	40213160		
49942	4143	1127078	1963-04-22	1963-04-22 00:00:00	1963-05-06	1963-05-06 00:00:00	1963-05-06	38000177		0	0	14		0	0	0	275381	0	282464	1127078		
118613	2610	40213160	1958-03-14	1958-03-14 00:00:00	1958-03-14	1958-03-14 00:00:00	1958-03-14	581452		0	0	0		0	0	0	172621	0	10	40213160		
37459	3096	1124300	1997-07-31	1997-07-31 00:00:00	1997-07-31	1997-07-31 00:00:00	\N	38000177		0	0	0		0	0	0	206047	0	00781178901	45011828		
23062	1902	19059056	1958-01-13	1958-01-13 00:00:00	1958-02-12	1958-02-12 00:00:00	1958-02-12	38000177		0	0	30		0	0	0	126623	0	243670	19059056		
5308	445	40229134	1931-03-13	1931-03-13 00:00:00	1931-03-27	1931-03-27 00:00:00	1931-03-27	38000177		0	0	14		0	0	0	29555	0	1043400	40229134		
376	30	1127078	1977-08-29	1977-08-29 00:00:00	1977-09-28	1977-09-28 00:00:00	1977-09-28	38000177		0	0	30		0	0	0	2125	0	282464	1127078		
239321	5253	40213227	2006-12-16	2006-12-16 00:00:00	2006-12-16	2006-12-16 00:00:00	2006-12-16	581452		0	0	0		0	0	0	349512	0	113	40213227		
19287	1593	19059056	1964-12-28	1964-12-28 00:00:00	1965-01-11	1965-01-11 00:00:00	1965-01-11	38000177		0	0	14		0	0	0	106845	0	243670	19059056		
43895	3637	1127433	1989-03-15	1989-03-15 00:00:00	1989-03-29	1989-03-29 00:00:00	1989-03-29	38000177		0	0	14		0	0	0	241886	0	313782	1127433		
43946	3639	1539411	2007-07-07	2007-07-07 00:00:00	2007-07-07	2007-07-07 00:00:00	\N	38000177		0	0	0		0	0	0	242080	0	312961	1539411		
43949	3639	1713671	1999-02-11	1999-02-11 00:00:00	1999-02-18	1999-02-18 00:00:00	1999-02-18	38000177		0	0	7		0	0	0	242035	0	562251	1713671		
62355	1361	40213201	2005-12-05	2005-12-05 00:00:00	2005-12-05	2005-12-05 00:00:00	2005-12-05	581452		0	0	0		0	0	0	90299	0	33	40213201		
223993	4917	40213251	1987-02-02	1987-02-02 00:00:00	1987-02-02	1987-02-02 00:00:00	1987-02-02	581452		0	0	0		0	0	0	326720	0	21	40213251		
150089	3301	40213201	2004-07-06	2004-07-06 00:00:00	2004-07-06	2004-07-06 00:00:00	2004-07-06	581452		0	0	0		0	0	0	219299	0	33	40213201		
2733	220	42902245	2000-08-07	2000-08-07 00:00:00	2001-08-02	2001-08-02 00:00:00	2001-08-02	38000177		0	0	360		0	0	0	14826	0	1359133	42902245		
229626	5046	40213296	1998-01-19	1998-01-19 00:00:00	1998-01-19	1998-01-19 00:00:00	1998-01-19	581452		0	0	0		0	0	0	335361	0	52	40213296		
49333	4092	40229134	1987-09-24	1987-09-24 00:00:00	1987-10-08	1987-10-08 00:00:00	1987-10-08	38000177		0	0	14		0	0	0	272055	0	1043400	40229134		
61228	5094	1127433	2000-12-06	2000-12-06 00:00:00	2001-01-03	2001-01-03 00:00:00	2001-01-03	38000177		0	0	28		0	0	0	338494	0	313782	1127433		
6568	552	1124300	1986-05-27	1986-05-27 00:00:00	1986-05-27	1986-05-27 00:00:00	\N	38000177		0	0	0		0	0	0	36574	0	00781178901	45011828		
47874	3968	40162522	1977-07-01	1977-07-01 00:00:00	1977-07-01	1977-07-01 00:00:00	\N	38000177		0	0	0		0	0	0	263906	0	857005	40162522		
23928	1971	19129655	1973-09-14	1973-09-14 00:00:00	1973-09-28	1973-09-28 00:00:00	1973-09-28	38000177		0	0	14		0	0	0	131030	0	789980	19129655		
50772	4217	1118084	2001-04-19	2001-04-19 00:00:00	2001-04-19	2001-04-19 00:00:00	\N	38000177		0	0	0		0	0	0	279955	0	00025152531	44923712		
69112	1512	40213227	1996-06-12	1996-06-12 00:00:00	1996-06-12	1996-06-12 00:00:00	1996-06-12	581452		0	0	0		0	0	0	100992	0	113	40213227		
34178	2825	1124300	1964-03-06	1964-03-06 00:00:00	1964-03-06	1964-03-06 00:00:00	\N	38000177		0	0	0		0	0	0	187246	0	00781178901	45011828		
23841	1962	1127433	1979-06-03	1979-06-03 00:00:00	1979-06-17	1979-06-17 00:00:00	1979-06-17	38000177		0	0	14		0	0	0	130477	0	313782	1127433		
23899	1967	1127433	2016-03-17	2016-03-17 00:00:00	2016-03-31	2016-03-31 00:00:00	2016-03-31	38000177		0	0	14		0	0	0	130829	0	313782	1127433		
7154	601	1127433	1985-06-05	1985-06-05 00:00:00	1985-06-19	1985-06-19 00:00:00	1985-06-19	38000177		0	0	14		0	0	0	39684	0	313782	1127433		
54447	4526	1127433	1989-02-04	1989-02-04 00:00:00	1989-02-18	1989-02-18 00:00:00	1989-02-18	38000177		0	0	14		0	0	0	301380	0	313782	1127433		
176064	3871	40213306	1984-10-03	1984-10-03 00:00:00	1984-10-03	1984-10-03 00:00:00	1984-10-03	581452		0	0	0		0	0	0	257031	0	43	40213306		
15497	334	40213227	1997-04-30	1997-04-30 00:00:00	1997-04-30	1997-04-30 00:00:00	1997-04-30	581452		0	0	0		0	0	0	22209	0	113	40213227		
130945	2878	40213227	2012-01-08	2012-01-08 00:00:00	2012-01-08	2012-01-08 00:00:00	2012-01-08	581452		0	0	0		0	0	0	191421	0	113	40213227		
45102	3732	19078461	1985-06-09	1985-06-09 00:00:00	1985-06-23	1985-06-23 00:00:00	1985-06-23	38000177		0	0	14		0	0	0	247984	0	310965	19078461		
60632	1325	40213160	1964-09-20	1964-09-20 00:00:00	1964-09-20	1964-09-20 00:00:00	1964-09-20	581452		0	0	0		0	0	0	87990	0	10	40213160		
4795	103	40213227	2018-06-03	2018-06-03 00:00:00	2018-06-03	2018-06-03 00:00:00	2018-06-03	581452		0	0	0		0	0	0	7083	0	113	40213227		
16120	348	40213227	2017-08-07	2017-08-07 00:00:00	2017-08-07	2017-08-07 00:00:00	2017-08-07	581452		0	0	0		0	0	0	23165	0	113	40213227		
72021	1574	40213160	1959-06-12	1959-06-12 00:00:00	1959-06-12	1959-06-12 00:00:00	1959-06-12	581452		0	0	0		0	0	0	105672	0	10	40213160		
38852	3212	782047	2018-07-21	2018-07-21 00:00:00	2018-07-21	2018-07-21 00:00:00	2018-07-21	38000177		0	0	0		0	0	0	213430	0	542347	782047		
121905	2679	40213306	1994-11-18	1994-11-18 00:00:00	1994-11-18	1994-11-18 00:00:00	1994-11-18	581452		0	0	0		0	0	0	177489	0	43	40213306		
81478	1781	40213227	1993-04-06	1993-04-06 00:00:00	1993-04-06	1993-04-06 00:00:00	1993-04-06	581452		0	0	0		0	0	0	119281	0	113	40213227		
217927	4782	40213251	1984-04-03	1984-04-03 00:00:00	1984-04-03	1984-04-03 00:00:00	1984-04-03	581452		0	0	0		0	0	0	318337	0	21	40213251		
13763	297	40213201	2017-10-15	2017-10-15 00:00:00	2017-10-15	2017-10-15 00:00:00	2017-10-15	581452		0	0	0		0	0	0	19838	0	33	40213201		
49536	4109	40236824	2008-02-10	2008-02-10 00:00:00	2008-02-17	2008-02-17 00:00:00	2008-02-17	38000177		0	0	7		0	0	0	273172	0	1094107	40236824		
150661	3314	40213260	2012-09-08	2012-09-08 00:00:00	2012-09-08	2012-09-08 00:00:00	2012-09-08	581452		0	0	0		0	0	0	220111	0	121	40213260		
49746	4127	1127078	1951-08-28	1951-08-28 00:00:00	1951-10-02	1951-10-02 00:00:00	1951-10-02	38000177		0	0	35		0	0	0	274311	0	282464	1127078		
154088	3392	40213296	2009-01-10	2009-01-10 00:00:00	2009-01-10	2009-01-10 00:00:00	2009-01-10	581452		0	0	0		0	0	0	224986	0	52	40213296		
148246	3259	40213227	2016-11-04	2016-11-04 00:00:00	2016-11-04	2016-11-04 00:00:00	2016-11-04	581452		0	0	0		0	0	0	216682	0	113	40213227		
29109	2411	1127433	1999-10-02	1999-10-02 00:00:00	1999-10-23	1999-10-23 00:00:00	1999-10-23	38000177		0	0	21		0	0	0	160004	0	313782	1127433		
150983	3320	40213260	2014-08-31	2014-08-31 00:00:00	2014-08-31	2014-08-31 00:00:00	2014-08-31	581452		0	0	0		0	0	0	220468	0	121	40213260		
146266	3217	40213160	1983-12-13	1983-12-13 00:00:00	1983-12-13	1983-12-13 00:00:00	1983-12-13	581452		0	0	0		0	0	0	213806	0	10	40213160		
7379	616	1118084	2000-12-08	2000-12-08 00:00:00	2000-12-08	2000-12-08 00:00:00	\N	38000177		0	0	0		0	0	0	41137	0	00025152531	44923712		
2086	164	19128065	1987-11-19	1987-11-19 00:00:00	1988-11-13	1988-11-13 00:00:00	1988-11-13	38000177		0	0	360		0	0	0	11264	0	749882	19128065		
56207	4666	1713671	1993-05-19	1993-05-19 00:00:00	1993-05-26	1993-05-26 00:00:00	1993-05-26	38000177		0	0	7		0	0	0	310949	0	562251	1713671		
53724	4467	19059056	1957-04-27	1957-04-27 00:00:00	1957-05-11	1957-05-11 00:00:00	1957-05-11	38000177		0	0	14		0	0	0	297245	0	243670	19059056		
187008	4107	40213296	2014-01-13	2014-01-13 00:00:00	2014-01-13	2014-01-13 00:00:00	2014-01-13	581452		0	0	0		0	0	0	272888	0	52	40213296		
73439	1604	40213160	1955-10-06	1955-10-06 00:00:00	1955-10-06	1955-10-06 00:00:00	1955-10-06	581452		0	0	0		0	0	0	107661	0	10	40213160		
111372	2447	40213227	2002-09-25	2002-09-25 00:00:00	2002-09-25	2002-09-25 00:00:00	2002-09-25	581452		0	0	0		0	0	0	162326	0	113	40213227		
129396	2845	40213198	2018-03-22	2018-03-22 00:00:00	2018-03-22	2018-03-22 00:00:00	2018-03-22	581452		0	0	0		0	0	0	188938	0	133	40213198		
16162	1340	19059056	1926-12-08	1926-12-08 00:00:00	1926-12-22	1926-12-22 00:00:00	1926-12-22	38000177		0	0	14		0	0	0	88842	0	243670	19059056		
80541	1762	40213227	1992-03-05	1992-03-05 00:00:00	1992-03-05	1992-03-05 00:00:00	1992-03-05	581452		0	0	0		0	0	0	117823	0	113	40213227		
56799	4715	1713671	2016-03-30	2016-03-30 00:00:00	2016-04-06	2016-04-06 00:00:00	2016-04-06	38000177		0	0	7		0	0	0	313929	0	562251	1713671		
87721	1924	40213227	2003-04-11	2003-04-11 00:00:00	2003-04-11	2003-04-11 00:00:00	2003-04-11	581452		0	0	0		0	0	0	128056	0	113	40213227		
78278	1713	40213227	2014-05-07	2014-05-07 00:00:00	2014-05-07	2014-05-07 00:00:00	2014-05-07	581452		0	0	0		0	0	0	114460	0	113	40213227		
26859	2213	1127433	1980-11-15	1980-11-15 00:00:00	1980-11-22	1980-11-22 00:00:00	1980-11-22	38000177		0	0	7		0	0	0	147355	0	313782	1127433		
7403	159	40213227	1996-01-30	1996-01-30 00:00:00	1996-01-30	1996-01-30 00:00:00	1996-01-30	581452		0	0	0		0	0	0	10872	0	113	40213227		
48914	1072	40213160	1965-07-28	1965-07-28 00:00:00	1965-07-28	1965-07-28 00:00:00	1965-07-28	581452		0	0	0		0	0	0	70230	0	10	40213160		
118617	2610	40213160	1957-10-12	1957-10-12 00:00:00	1957-10-12	1957-10-12 00:00:00	1957-10-12	581452		0	0	0		0	0	0	172620	0	10	40213160		
37460	3096	19128065	1986-11-01	1986-11-01 00:00:00	1987-10-27	1987-10-27 00:00:00	1987-10-27	38000177		0	0	360		0	0	0	206098	0	749882	19128065		
23063	1902	40162522	1958-01-13	1958-01-13 00:00:00	1958-01-13	1958-01-13 00:00:00	\N	38000177		0	0	0		0	0	0	126623	0	857005	40162522		
5309	445	1713671	1922-12-18	1922-12-18 00:00:00	1923-01-08	1923-01-08 00:00:00	1923-01-08	38000177		0	0	21		0	0	0	29553	0	562251	1713671		
377	30	19059056	1975-06-11	1975-06-11 00:00:00	1975-08-10	1975-08-10 00:00:00	1975-08-10	38000177		0	0	60		0	0	0	2124	0	243670	19059056		
239322	5253	40213260	2006-12-16	2006-12-16 00:00:00	2006-12-16	2006-12-16 00:00:00	2006-12-16	581452		0	0	0		0	0	0	349512	0	121	40213260		
19288	1593	40236824	1981-10-31	1981-10-31 00:00:00	1981-11-07	1981-11-07 00:00:00	1981-11-07	38000177		0	0	7		0	0	0	106852	0	1094107	40236824		
43896	3637	1713671	2014-05-25	2014-05-25 00:00:00	2014-06-08	2014-06-08 00:00:00	2014-06-08	38000177		0	0	14		0	0	0	241926	0	562251	1713671		
43947	3639	1332419	2007-07-07	2007-07-07 00:00:00	2007-07-07	2007-07-07 00:00:00	\N	38000177		0	0	0		0	0	0	242080	0	197361	1332419		
43950	3639	1127433	1998-06-27	1998-06-27 00:00:00	1998-07-04	1998-07-04 00:00:00	1998-07-04	38000177		0	0	7		0	0	0	242161	0	313782	1127433		
168638	3707	40213296	2012-09-17	2012-09-17 00:00:00	2012-09-17	2012-09-17 00:00:00	2012-09-17	581452		0	0	0		0	0	0	246458	0	52	40213296		
223995	4917	40213251	1984-01-30	1984-01-30 00:00:00	1984-01-30	1984-01-30 00:00:00	1984-01-30	581452		0	0	0		0	0	0	326718	0	21	40213251		
85056	1861	40213251	1984-05-05	1984-05-05 00:00:00	1984-05-05	1984-05-05 00:00:00	1984-05-05	581452		0	0	0		0	0	0	124457	0	21	40213251		
2734	220	19019979	1985-03-19	1985-03-19 00:00:00	1985-04-09	1985-04-09 00:00:00	1985-04-09	38000177		0	0	21		0	0	0	14836	0	198405	19019979		
229628	5046	40213160	1962-12-24	1962-12-24 00:00:00	1962-12-24	1962-12-24 00:00:00	1962-12-24	581452		0	0	0		0	0	0	335331	0	10	40213160		
49334	4092	1127433	1989-07-15	1989-07-15 00:00:00	1989-07-29	1989-07-29 00:00:00	1989-07-29	38000177		0	0	14		0	0	0	272021	0	313782	1127433		
61229	5094	19128022	1995-04-12	1995-04-12 00:00:00	1996-04-06	1996-04-06 00:00:00	1996-04-06	38000177		0	0	360		0	0	0	338460	0	749785	19128022		
6569	552	1713671	1962-04-18	1962-04-18 00:00:00	1962-05-09	1962-05-09 00:00:00	1962-05-09	38000177		0	0	21		0	0	0	36567	0	562251	1713671		
47875	3968	1127433	1944-02-04	1944-02-04 00:00:00	1944-02-11	1944-02-11 00:00:00	1944-02-11	38000177		0	0	7		0	0	0	263897	0	313782	1127433		
23929	1971	19133873	1971-04-07	1971-04-07 00:00:00	1971-04-17	1971-04-17 00:00:00	1971-04-17	38000177		0	0	10		0	0	0	131020	0	834061	19133873		
165064	3629	40213227	2006-11-27	2006-11-27 00:00:00	2006-11-27	2006-11-27 00:00:00	2006-11-27	581452		0	0	0		0	0	0	241453	0	113	40213227		
69114	1512	40213314	1977-11-16	1977-11-16 00:00:00	1977-11-16	1977-11-16 00:00:00	1977-11-16	581452		0	0	0		0	0	0	100981	0	49	40213314		
34179	2825	1127433	2007-12-24	2007-12-24 00:00:00	2008-01-23	2008-01-23 00:00:00	2008-01-23	38000177		0	0	30		0	0	0	187334	0	313782	1127433		
23842	1962	19128065	1981-03-20	1981-03-20 00:00:00	1982-03-15	1982-03-15 00:00:00	1982-03-15	38000177		0	0	360		0	0	0	130504	0	749882	19128065		
23900	1967	19059056	1983-11-29	1983-11-29 00:00:00	1983-12-27	1983-12-27 00:00:00	1983-12-27	38000177		0	0	28		0	0	0	130890	0	243670	19059056		
7155	601	1713671	1996-01-04	1996-01-04 00:00:00	1996-01-11	1996-01-11 00:00:00	1996-01-11	38000177		0	0	7		0	0	0	39756	0	562251	1713671		
54448	4526	1127433	1987-08-12	1987-08-12 00:00:00	1987-11-10	1987-11-10 00:00:00	1987-11-10	38000177		0	0	90		0	0	0	301374	0	313782	1127433		
176073	3871	40213260	2012-09-12	2012-09-12 00:00:00	2012-09-12	2012-09-12 00:00:00	2012-09-12	581452		0	0	0		0	0	0	257056	0	121	40213260		
133862	2939	40213227	2004-06-15	2004-06-15 00:00:00	2004-06-15	2004-06-15 00:00:00	2004-06-15	581452		0	0	0		0	0	0	195966	0	113	40213227		
130947	2878	40213160	1981-02-01	1981-02-01 00:00:00	1981-02-01	1981-02-01 00:00:00	1981-02-01	581452		0	0	0		0	0	0	191435	0	10	40213160		
45103	3732	1127433	2015-11-09	2015-11-09 00:00:00	2015-12-16	2015-12-16 00:00:00	2015-12-16	38000177		0	0	37		0	0	0	247988	0	313782	1127433		
60641	1325	40213160	1964-07-19	1964-07-19 00:00:00	1964-07-19	1964-07-19 00:00:00	1964-07-19	581452		0	0	0		0	0	0	87976	0	10	40213160		
4796	103	40213260	2018-06-03	2018-06-03 00:00:00	2018-06-03	2018-06-03 00:00:00	2018-06-03	581452		0	0	0		0	0	0	7083	0	121	40213260		
16121	348	40213296	2017-08-07	2017-08-07 00:00:00	2017-08-07	2017-08-07 00:00:00	2017-08-07	581452		0	0	0		0	0	0	23165	0	52	40213296		
72031	1574	40213227	2000-10-13	2000-10-13 00:00:00	2000-10-13	2000-10-13 00:00:00	2000-10-13	581452		0	0	0		0	0	0	105689	0	113	40213227		
38853	3212	1127078	1986-08-31	1986-08-31 00:00:00	1986-10-05	1986-10-05 00:00:00	1986-10-05	38000177		0	0	35		0	0	0	213427	0	282464	1127078		
121910	2679	40213160	1972-12-08	1972-12-08 00:00:00	1972-12-08	1972-12-08 00:00:00	1972-12-08	581452		0	0	0		0	0	0	177471	0	10	40213160		
81493	1781	40213201	2007-08-07	2007-08-07 00:00:00	2007-08-07	2007-08-07 00:00:00	2007-08-07	581452		0	0	0		0	0	0	119217	0	33	40213201		
217932	4782	40213306	2004-05-25	2004-05-25 00:00:00	2004-05-25	2004-05-25 00:00:00	2004-05-25	581452		0	0	0		0	0	0	318343	0	43	40213306		
13766	297	40213227	2002-06-23	2002-06-23 00:00:00	2002-06-23	2002-06-23 00:00:00	2002-06-23	581452		0	0	0		0	0	0	19822	0	113	40213227		
49537	4109	920300	2008-02-10	2008-02-10 00:00:00	2008-02-17	2008-02-17 00:00:00	2008-02-17	38000177		0	0	7		0	0	0	273172	0	311989	920300		
150668	3314	40213160	1962-12-14	1962-12-14 00:00:00	1962-12-14	1962-12-14 00:00:00	1962-12-14	581452		0	0	0		0	0	0	220070	0	10	40213160		
49747	4127	1127078	1957-06-02	1957-06-02 00:00:00	1957-07-07	1957-07-07 00:00:00	1957-07-07	38000177		0	0	35		0	0	0	274340	0	282464	1127078		
93010	2041	40213296	2006-03-07	2006-03-07 00:00:00	2006-03-07	2006-03-07 00:00:00	2006-03-07	581452		0	0	0		0	0	0	135806	0	52	40213296		
148247	3259	40213260	2016-11-04	2016-11-04 00:00:00	2016-11-04	2016-11-04 00:00:00	2016-11-04	581452		0	0	0		0	0	0	216682	0	121	40213260		
29110	2411	1118084	2001-05-14	2001-05-14 00:00:00	2001-05-14	2001-05-14 00:00:00	\N	38000177		0	0	0		0	0	0	160004	0	00025152531	44923712		
150988	3321	40213227	2008-04-07	2008-04-07 00:00:00	2008-04-07	2008-04-07 00:00:00	2008-04-07	581452		0	0	0		0	0	0	220536	0	113	40213227		
146274	3217	40213306	2006-06-20	2006-06-20 00:00:00	2006-06-20	2006-06-20 00:00:00	2006-06-20	581452		0	0	0		0	0	0	\N	0	43	40213306		
7380	616	1127078	1969-07-09	1969-07-09 00:00:00	1969-08-13	1969-08-13 00:00:00	1969-08-13	38000177		0	0	35		0	0	0	41087	0	282464	1127078		
2087	164	40229134	1986-07-27	1986-07-27 00:00:00	1986-08-10	1986-08-10 00:00:00	1986-08-10	38000177		0	0	14		0	0	0	11287	0	1043400	40229134		
56208	4666	46233988	1978-04-03	1978-04-03 00:00:00	1978-04-17	1978-04-17 00:00:00	1978-04-17	38000177		0	0	14		0	0	0	310920	0	1652673	46233988		
53725	4467	40236824	1987-07-26	1987-07-26 00:00:00	1987-08-02	1987-08-02 00:00:00	1987-08-02	38000177		0	0	7		0	0	0	297204	0	1094107	40236824		
187009	4107	40213227	2014-01-13	2014-01-13 00:00:00	2014-01-13	2014-01-13 00:00:00	2014-01-13	581452		0	0	0		0	0	0	272888	0	113	40213227		
31527	2615	19078461	1992-03-15	1992-03-15 00:00:00	1992-06-13	1992-06-13 00:00:00	1992-06-13	38000177		0	0	90		0	0	0	172939	0	310965	19078461		
127361	2801	40213227	1993-06-18	1993-06-18 00:00:00	1993-06-18	1993-06-18 00:00:00	1993-06-18	581452		0	0	0		0	0	0	185601	0	113	40213227		
129399	2845	40213227	2013-12-05	2013-12-05 00:00:00	2013-12-05	2013-12-05 00:00:00	2013-12-05	581452		0	0	0		0	0	0	188936	0	113	40213227		
16163	1340	19059056	1916-05-19	1916-05-19 00:00:00	1916-06-02	1916-06-02 00:00:00	1916-06-02	38000177		0	0	14		0	0	0	88927	0	243670	19059056		
182639	4013	40213227	2006-06-04	2006-06-04 00:00:00	2006-06-04	2006-06-04 00:00:00	2006-06-04	581452		0	0	0		0	0	0	266661	0	113	40213227		
56800	4715	1115171	2008-09-03	2008-09-03 00:00:00	2008-09-17	2008-09-17 00:00:00	2008-09-17	38000177		0	0	14		0	0	0	313923	0	849574	1115171		
172369	3789	40213227	1996-01-18	1996-01-18 00:00:00	1996-01-18	1996-01-18 00:00:00	1996-01-18	581452		0	0	0		0	0	0	251909	0	113	40213227		
78283	1713	40213227	2003-04-23	2003-04-23 00:00:00	2003-04-23	2003-04-23 00:00:00	2003-04-23	581452		0	0	0		0	0	0	114458	0	113	40213227		
26860	2213	1594382	1991-08-01	1991-08-01 00:00:00	1991-08-01	1991-08-01 00:00:00	\N	38000177		0	0	0		0	0	0	147361	0	1870230	1594382		
7404	159	40213296	1996-01-30	1996-01-30 00:00:00	1996-01-30	1996-01-30 00:00:00	1996-01-30	581452		0	0	0		0	0	0	10872	0	52	40213296		
48921	1072	40213306	1982-10-20	1982-10-20 00:00:00	1982-10-20	1982-10-20 00:00:00	1982-10-20	581452		0	0	0		0	0	0	70298	0	43	40213306		
118635	2610	40213227	2019-01-11	2019-01-11 00:00:00	2019-01-11	2019-01-11 00:00:00	2019-01-11	581452		0	0	0		0	0	0	172582	0	113	40213227		
37461	3096	19059056	1968-09-26	1968-09-26 00:00:00	1968-12-25	1968-12-25 00:00:00	1968-12-25	38000177		0	0	90		0	0	0	206036	0	243670	19059056		
23064	1902	1118084	1985-09-03	1985-09-03 00:00:00	1985-09-03	1985-09-03 00:00:00	\N	38000177		0	0	0		0	0	0	126638	0	00025152531	44923712		
5310	445	1127433	1947-09-13	1947-09-13 00:00:00	1947-09-27	1947-09-27 00:00:00	1947-09-27	38000177		0	0	14		0	0	0	29602	0	313782	1127433		
378	30	1127433	2004-11-28	2004-11-28 00:00:00	2004-12-05	2004-12-05 00:00:00	2004-12-05	38000177		0	0	7		0	0	0	2130	0	313782	1127433		
119252	2622	40213227	1992-08-15	1992-08-15 00:00:00	1992-08-15	1992-08-15 00:00:00	1992-08-15	581452		0	0	0		0	0	0	173458	0	113	40213227		
19289	1593	920300	1981-10-31	1981-10-31 00:00:00	1981-11-07	1981-11-07 00:00:00	1981-11-07	38000177		0	0	7		0	0	0	106852	0	311989	920300		
43897	3637	19129655	1964-11-21	1964-11-21 00:00:00	1964-12-05	1964-12-05 00:00:00	1964-12-05	38000177		0	0	14		0	0	0	241927	0	789980	19129655		
43948	3639	19059056	1931-12-21	1931-12-21 00:00:00	1932-02-19	1932-02-19 00:00:00	1932-02-19	38000177		0	0	60		0	0	0	242120	0	243670	19059056		
43951	3639	1127433	1999-12-27	1999-12-27 00:00:00	2000-01-10	2000-01-10 00:00:00	2000-01-10	38000177		0	0	14		0	0	0	242171	0	313782	1127433		
168640	3707	40213160	1969-12-08	1969-12-08 00:00:00	1969-12-08	1969-12-08 00:00:00	1969-12-08	581452		0	0	0		0	0	0	246431	0	10	40213160		
224003	4917	40213306	2002-02-25	2002-02-25 00:00:00	2002-02-25	2002-02-25 00:00:00	2002-02-25	581452		0	0	0		0	0	0	326746	0	43	40213306		
85058	1861	40213227	2013-02-09	2013-02-09 00:00:00	2013-02-09	2013-02-09 00:00:00	2013-02-09	581452		0	0	0		0	0	0	124451	0	113	40213227		
2735	220	1127078	1993-02-11	1993-02-11 00:00:00	1993-02-25	1993-02-25 00:00:00	1993-02-25	38000177		0	0	14		0	0	0	14796	0	282464	1127078		
227595	4998	40213227	2006-09-08	2006-09-08 00:00:00	2006-09-08	2006-09-08 00:00:00	2006-09-08	581452		0	0	0		0	0	0	332352	0	113	40213227		
49335	4092	19133905	1996-08-08	1996-08-08 00:00:00	1996-08-18	1996-08-18 00:00:00	1996-08-18	38000177		0	0	10		0	0	0	272045	0	834102	19133905		
61230	5095	40229134	1985-06-20	1985-06-20 00:00:00	1985-07-04	1985-07-04 00:00:00	1985-07-04	38000177		0	0	14		0	0	0	338548	0	1043400	40229134		
6570	552	1713671	1952-05-17	1952-05-17 00:00:00	1952-05-31	1952-05-31 00:00:00	1952-05-31	38000177		0	0	14		0	0	0	36640	0	562251	1713671		
47876	3968	1127433	2003-06-13	2003-06-13 00:00:00	2003-09-11	2003-09-11 00:00:00	2003-09-11	38000177		0	0	90		0	0	0	263907	0	313782	1127433		
23930	1971	46233988	1972-04-27	1972-04-27 00:00:00	1972-05-11	1972-05-11 00:00:00	1972-05-11	38000177		0	0	14		0	0	0	131114	0	1652673	46233988		
165065	3629	40213260	2006-11-27	2006-11-27 00:00:00	2006-11-27	2006-11-27 00:00:00	2006-11-27	581452		0	0	0		0	0	0	241453	0	121	40213260		
69116	1512	40213227	2005-12-07	2005-12-07 00:00:00	2005-12-07	2005-12-07 00:00:00	2005-12-07	581452		0	0	0		0	0	0	100984	0	113	40213227		
34180	2825	1127433	1991-10-16	1991-10-16 00:00:00	1991-10-30	1991-10-30 00:00:00	1991-10-30	38000177		0	0	14		0	0	0	187285	0	313782	1127433		
23843	1962	1124300	1999-02-19	1999-02-19 00:00:00	1999-02-19	1999-02-19 00:00:00	\N	38000177		0	0	0		0	0	0	130499	0	00781178901	45011828		
23901	1967	19078461	2006-09-18	2006-09-18 00:00:00	2006-10-18	2006-10-18 00:00:00	2006-10-18	38000177		0	0	30		0	0	0	130892	0	310965	19078461		
7156	601	1127433	2017-03-10	2017-03-10 00:00:00	2017-03-24	2017-03-24 00:00:00	2017-03-24	38000177		0	0	14		0	0	0	39695	0	313782	1127433		
8056	173	40213227	1999-08-08	1999-08-08 00:00:00	1999-08-08	1999-08-08 00:00:00	1999-08-08	581452		0	0	0		0	0	0	11760	0	113	40213227		
176077	3871	40213160	1963-05-22	1963-05-22 00:00:00	1963-05-22	1963-05-22 00:00:00	1963-05-22	581452		0	0	0		0	0	0	257061	0	10	40213160		
133868	2939	40213227	2014-08-12	2014-08-12 00:00:00	2014-08-12	2014-08-12 00:00:00	2014-08-12	581452		0	0	0		0	0	0	195975	0	113	40213227		
130948	2878	40213314	1981-02-01	1981-02-01 00:00:00	1981-02-01	1981-02-01 00:00:00	1981-02-01	581452		0	0	0		0	0	0	191435	0	49	40213314		
45104	3732	19059056	1958-04-02	1958-04-02 00:00:00	1958-07-01	1958-07-01 00:00:00	1958-07-01	38000177		0	0	90		0	0	0	247983	0	243670	19059056		
60643	1325	40213160	1964-12-20	1964-12-20 00:00:00	1964-12-20	1964-12-20 00:00:00	1964-12-20	581452		0	0	0		0	0	0	87953	0	10	40213160		
4801	103	40213306	1989-11-05	1989-11-05 00:00:00	1989-11-05	1989-11-05 00:00:00	1989-11-05	581452		0	0	0		0	0	0	7054	0	43	40213306		
16123	348	40213227	1997-12-29	1997-12-29 00:00:00	1997-12-29	1997-12-29 00:00:00	1997-12-29	581452		0	0	0		0	0	0	23148	0	113	40213227		
72032	1574	40213296	2000-10-13	2000-10-13 00:00:00	2000-10-13	2000-10-13 00:00:00	2000-10-13	581452		0	0	0		0	0	0	105689	0	52	40213296		
38854	3212	1127433	1988-07-09	1988-07-09 00:00:00	1988-07-16	1988-07-16 00:00:00	1988-07-16	38000177		0	0	7		0	0	0	213431	0	313782	1127433		
121911	2680	40213306	1993-10-21	1993-10-21 00:00:00	1993-10-21	1993-10-21 00:00:00	1993-10-21	581452		0	0	0		0	0	0	177578	0	43	40213306		
81498	1781	40213227	2002-08-13	2002-08-13 00:00:00	2002-08-13	2002-08-13 00:00:00	2002-08-13	581452		0	0	0		0	0	0	119282	0	113	40213227		
217934	4782	40213227	2002-07-16	2002-07-16 00:00:00	2002-07-16	2002-07-16 00:00:00	2002-07-16	581452		0	0	0		0	0	0	318378	0	113	40213227		
13767	297	40213227	2013-03-10	2013-03-10 00:00:00	2013-03-10	2013-03-10 00:00:00	2013-03-10	581452		0	0	0		0	0	0	19826	0	113	40213227		
49538	4109	40236824	2004-12-24	2004-12-24 00:00:00	2004-12-31	2004-12-31 00:00:00	2004-12-31	38000177		0	0	7		0	0	0	273079	0	1094107	40236824		
150670	3314	40213296	2006-08-19	2006-08-19 00:00:00	2006-08-19	2006-08-19 00:00:00	2006-08-19	581452		0	0	0		0	0	0	220126	0	52	40213296		
49748	4127	1127433	1973-06-24	1973-06-24 00:00:00	1973-07-01	1973-07-01 00:00:00	1973-07-01	38000177		0	0	7		0	0	0	274371	0	313782	1127433		
93012	2041	40213227	2006-03-07	2006-03-07 00:00:00	2006-03-07	2006-03-07 00:00:00	2006-03-07	581452		0	0	0		0	0	0	135806	0	113	40213227		
46069	1005	40213306	1990-09-11	1990-09-11 00:00:00	1990-09-11	1990-09-11 00:00:00	1990-09-11	581452		0	0	0		0	0	0	66455	0	43	40213306		
196581	4319	40213160	1978-03-15	1978-03-15 00:00:00	1978-03-15	1978-03-15 00:00:00	1978-03-15	581452		0	0	0		0	0	0	286617	0	10	40213160		
150990	3321	40213160	1982-01-04	1982-01-04 00:00:00	1982-01-04	1982-01-04 00:00:00	1982-01-04	581452		0	0	0		0	0	0	220546	0	10	40213160		
146275	3217	40213314	1984-09-11	1984-09-11 00:00:00	1984-09-11	1984-09-11 00:00:00	1984-09-11	581452		0	0	0		0	0	0	213807	0	49	40213314		
7381	616	19133905	1977-08-11	1977-08-11 00:00:00	1977-08-23	1977-08-23 00:00:00	1977-08-23	38000177		0	0	12		0	0	0	41112	0	834102	19133905		
2088	164	1115171	2018-09-25	2018-09-25 00:00:00	2018-10-09	2018-10-09 00:00:00	2018-10-09	38000177		0	0	14		0	0	0	11281	0	849574	1115171		
56209	4666	19019979	1978-04-03	1978-04-03 00:00:00	1978-04-17	1978-04-17 00:00:00	1978-04-17	38000177		0	0	14		0	0	0	310920	0	198405	19019979		
53726	4467	920300	1987-07-26	1987-07-26 00:00:00	1987-08-02	1987-08-02 00:00:00	1987-08-02	38000177		0	0	7		0	0	0	297204	0	311989	920300		
187014	4107	40213160	1976-01-19	1976-01-19 00:00:00	1976-01-19	1976-01-19 00:00:00	1976-01-19	581452		0	0	0		0	0	0	272900	0	10	40213160		
31528	2615	1127433	2010-05-10	2010-05-10 00:00:00	2010-05-24	2010-05-24 00:00:00	2010-05-24	38000177		0	0	14		0	0	0	172940	0	313782	1127433		
127376	2801	40213201	1988-05-20	1988-05-20 00:00:00	1988-05-20	1988-05-20 00:00:00	1988-05-20	581452		0	0	0		0	0	0	185599	0	33	40213201		
129402	2845	40213260	2006-10-26	2006-10-26 00:00:00	2006-10-26	2006-10-26 00:00:00	2006-10-26	581452		0	0	0		0	0	0	188978	0	121	40213260		
16164	1340	1713671	1912-12-29	1912-12-29 00:00:00	1913-08-31	1913-08-31 00:00:00	1913-08-31	38000177		0	0	245		0	0	0	88876	0	562251	1713671		
182644	4013	40213314	1977-04-24	1977-04-24 00:00:00	1977-04-24	1977-04-24 00:00:00	1977-04-24	581452		0	0	0		0	0	0	266672	0	49	40213314		
56801	4715	19133905	2017-09-05	2017-09-05 00:00:00	2017-09-13	2017-09-13 00:00:00	2017-09-13	38000177		0	0	8		0	0	0	313900	0	834102	19133905		
183659	4035	40213296	2012-03-27	2012-03-27 00:00:00	2012-03-27	2012-03-27 00:00:00	2012-03-27	581452		0	0	0		0	0	0	268478	0	52	40213296		
78287	1713	40213160	1976-09-15	1976-09-15 00:00:00	1976-09-15	1976-09-15 00:00:00	1976-09-15	581452		0	0	0		0	0	0	114443	0	10	40213160		
36794	3040	40229134	2010-07-01	2010-07-01 00:00:00	2010-07-08	2010-07-08 00:00:00	2010-07-08	38000177		0	0	7		0	0	0	202404	0	1043400	40229134		
134251	2947	40213296	2016-06-01	2016-06-01 00:00:00	2016-06-01	2016-06-01 00:00:00	2016-06-01	581452		0	0	0		0	0	0	196724	0	52	40213296		
48927	1072	40213160	1961-04-26	1961-04-26 00:00:00	1961-04-26	1961-04-26 00:00:00	1961-04-26	581452		0	0	0		0	0	0	70291	0	10	40213160		
118639	2610	40213227	2008-07-12	2008-07-12 00:00:00	2008-07-12	2008-07-12 00:00:00	2008-07-12	581452		0	0	0		0	0	0	172577	0	113	40213227		
37462	3096	1127433	1997-08-27	1997-08-27 00:00:00	1997-09-03	1997-09-03 00:00:00	1997-09-03	38000177		0	0	7		0	0	0	206052	0	313782	1127433		
23065	1903	40229134	1978-06-11	1978-06-11 00:00:00	1978-06-18	1978-06-18 00:00:00	1978-06-18	38000177		0	0	7		0	0	0	126672	0	1043400	40229134		
5311	445	1127433	1950-12-23	1950-12-23 00:00:00	1950-12-30	1950-12-30 00:00:00	1950-12-30	38000177		0	0	7		0	0	0	29604	0	313782	1127433		
379	30	1551192	1971-02-11	1971-02-11 00:00:00	1971-02-11	1971-02-11 00:00:00	1971-02-11	38000177		0	0	0		0	0	0	2122	0	312617	1551192		
119261	2622	40213227	2002-10-12	2002-10-12 00:00:00	2002-10-12	2002-10-12 00:00:00	2002-10-12	581452		0	0	0		0	0	0	173487	0	113	40213227		
19290	1593	19059056	1961-12-30	1961-12-30 00:00:00	1962-01-13	1962-01-13 00:00:00	1962-01-13	38000177		0	0	14		0	0	0	106844	0	243670	19059056		
43898	3637	1127078	1964-11-21	1964-11-21 00:00:00	1964-12-05	1964-12-05 00:00:00	1964-12-05	38000177		0	0	14		0	0	0	241927	0	282464	1127078		
176201	3874	40213227	2013-07-03	2013-07-03 00:00:00	2013-07-03	2013-07-03 00:00:00	2013-07-03	581452		0	0	0		0	0	0	257283	0	113	40213227		
43952	3639	1713671	2004-10-28	2004-10-28 00:00:00	2005-06-23	2005-06-23 00:00:00	2005-06-23	38000177		0	0	238		0	0	0	242110	0	562251	1713671		
168642	3707	40213160	1970-03-09	1970-03-09 00:00:00	1970-03-09	1970-03-09 00:00:00	1970-03-09	581452		0	0	0		0	0	0	246448	0	10	40213160		
224006	4917	40213314	1983-05-02	1983-05-02 00:00:00	1983-05-02	1983-05-02 00:00:00	1983-05-02	581452		0	0	0		0	0	0	326717	0	49	40213314		
85059	1861	40213160	1982-08-07	1982-08-07 00:00:00	1982-08-07	1982-08-07 00:00:00	1982-08-07	581452		0	0	0		0	0	0	124441	0	10	40213160		
2736	220	19073183	1993-02-11	1993-02-11 00:00:00	1993-02-25	1993-02-25 00:00:00	1993-02-25	38000177		0	0	14		0	0	0	14796	0	308182	19073183		
227596	4998	40213296	2006-09-08	2006-09-08 00:00:00	2006-09-08	2006-09-08 00:00:00	2006-09-08	581452		0	0	0		0	0	0	332352	0	52	40213296		
49336	4092	1127433	1986-12-26	1986-12-26 00:00:00	1987-01-25	1987-01-25 00:00:00	1987-01-25	38000177		0	0	30		0	0	0	272072	0	313782	1127433		
61231	5095	1127078	1965-12-30	1965-12-30 00:00:00	1966-01-13	1966-01-13 00:00:00	1966-01-13	38000177		0	0	14		0	0	0	338550	0	282464	1127078		
6571	552	19059056	1966-01-02	1966-01-02 00:00:00	1966-01-23	1966-01-23 00:00:00	1966-01-23	38000177		0	0	21		0	0	0	36612	0	243670	19059056		
47877	3968	1127433	2019-01-27	2019-01-27 00:00:00	2019-02-10	2019-02-10 00:00:00	2019-02-10	38000177		0	0	14		0	0	0	263857	0	313782	1127433		
23931	1971	19059056	1972-04-27	1972-04-27 00:00:00	1972-05-11	1972-05-11 00:00:00	1972-05-11	38000177		0	0	14		0	0	0	131114	0	243670	19059056		
165066	3629	40213160	1956-04-30	1956-04-30 00:00:00	1956-04-30	1956-04-30 00:00:00	1956-04-30	581452		0	0	0		0	0	0	241493	0	10	40213160		
69120	1512	40213314	1978-05-17	1978-05-17 00:00:00	1978-05-17	1978-05-17 00:00:00	1978-05-17	581452		0	0	0		0	0	0	101002	0	49	40213314		
34181	2825	1127433	1975-09-08	1975-09-08 00:00:00	1975-09-22	1975-09-22 00:00:00	1975-09-22	38000177		0	0	14		0	0	0	187331	0	313782	1127433		
23844	1962	19133873	1968-06-13	1968-06-13 00:00:00	1968-06-23	1968-06-23 00:00:00	1968-06-23	38000177		0	0	10		0	0	0	130508	0	834061	19133873		
23902	1967	1713671	1959-06-01	1959-06-01 00:00:00	1959-06-15	1959-06-15 00:00:00	1959-06-15	38000177		0	0	14		0	0	0	130865	0	562251	1713671		
38721	844	40213160	1971-02-27	1971-02-27 00:00:00	1971-02-27	1971-02-27 00:00:00	1971-02-27	581452		0	0	0		0	0	0	55929	0	10	40213160		
8059	173	40213160	1968-12-01	1968-12-01 00:00:00	1968-12-01	1968-12-01 00:00:00	1968-12-01	581452		0	0	0		0	0	0	11753	0	10	40213160		
176082	3871	40213296	2002-09-18	2002-09-18 00:00:00	2002-09-18	2002-09-18 00:00:00	2002-09-18	581452		0	0	0		0	0	0	257053	0	52	40213296		
145171	3191	40213227	2009-01-15	2009-01-15 00:00:00	2009-01-15	2009-01-15 00:00:00	2009-01-15	581452		0	0	0		0	0	0	212372	0	113	40213227		
130952	2878	40213160	1981-05-03	1981-05-03 00:00:00	1981-05-03	1981-05-03 00:00:00	1981-05-03	581452		0	0	0		0	0	0	191422	0	10	40213160		
45105	3732	40220960	2016-09-18	2016-09-18 00:00:00	2016-09-18	2016-09-18 00:00:00	2016-09-18	38000177		0	0	0		0	0	0	247982	0	1804799	40220960		
69377	1517	40213227	2009-03-02	2009-03-02 00:00:00	2009-03-02	2009-03-02 00:00:00	2009-03-02	581452		0	0	0		0	0	0	101407	0	113	40213227		
4802	103	40213296	2007-09-23	2007-09-23 00:00:00	2007-09-23	2007-09-23 00:00:00	2007-09-23	581452		0	0	0		0	0	0	7066	0	52	40213296		
16124	348	40213306	1997-12-29	1997-12-29 00:00:00	1997-12-29	1997-12-29 00:00:00	1997-12-29	581452		0	0	0		0	0	0	23148	0	43	40213306		
72033	1574	40213160	1959-01-09	1959-01-09 00:00:00	1959-01-09	1959-01-09 00:00:00	1959-01-09	581452		0	0	0		0	0	0	105700	0	10	40213160		
38855	3212	1127433	2000-12-10	2000-12-10 00:00:00	2000-12-24	2000-12-24 00:00:00	2000-12-24	38000177		0	0	14		0	0	0	213432	0	313782	1127433		
121914	2680	40213160	1972-11-16	1972-11-16 00:00:00	1972-11-16	1972-11-16 00:00:00	1972-11-16	581452		0	0	0		0	0	0	177567	0	10	40213160		
73105	1597	40213227	2005-10-01	2005-10-01 00:00:00	2005-10-01	2005-10-01 00:00:00	2005-10-01	581452		0	0	0		0	0	0	107192	0	113	40213227		
217935	4782	40213306	2002-07-16	2002-07-16 00:00:00	2002-07-16	2002-07-16 00:00:00	2002-07-16	581452		0	0	0		0	0	0	318378	0	43	40213306		
13773	297	40213227	1993-06-27	1993-06-27 00:00:00	1993-06-27	1993-06-27 00:00:00	1993-06-27	581452		0	0	0		0	0	0	19806	0	113	40213227		
49539	4109	920300	2004-12-24	2004-12-24 00:00:00	2004-12-31	2004-12-31 00:00:00	2004-12-31	38000177		0	0	7		0	0	0	273079	0	311989	920300		
150672	3314	40213306	1985-05-25	1985-05-25 00:00:00	1985-05-25	1985-05-25 00:00:00	1985-05-25	581452		0	0	0		0	0	0	220083	0	43	40213306		
49749	4127	19059056	1948-07-23	1948-07-23 00:00:00	1948-08-13	1948-08-13 00:00:00	1948-08-13	38000177		0	0	21		0	0	0	274310	0	243670	19059056		
93019	2041	40213227	1995-08-29	1995-08-29 00:00:00	1995-08-29	1995-08-29 00:00:00	1995-08-29	581452		0	0	0		0	0	0	135803	0	113	40213227		
46071	1005	40213160	1967-08-01	1967-08-01 00:00:00	1967-08-01	1967-08-01 00:00:00	1967-08-01	581452		0	0	0		0	0	0	66419	0	10	40213160		
196582	4319	40213314	1978-03-15	1978-03-15 00:00:00	1978-03-15	1978-03-15 00:00:00	1978-03-15	581452		0	0	0		0	0	0	286617	0	49	40213314		
150992	3321	40213251	1984-01-16	1984-01-16 00:00:00	1984-01-16	1984-01-16 00:00:00	1984-01-16	581452		0	0	0		0	0	0	220547	0	21	40213251		
146276	3217	40213251	1984-09-11	1984-09-11 00:00:00	1984-09-11	1984-09-11 00:00:00	1984-09-11	581452		0	0	0		0	0	0	213807	0	21	40213251		
7382	616	1127433	1983-03-03	1983-03-03 00:00:00	1983-03-24	1983-03-24 00:00:00	1983-03-24	38000177		0	0	21		0	0	0	41089	0	313782	1127433		
2089	164	19059056	1967-12-24	1967-12-24 00:00:00	1968-01-07	1968-01-07 00:00:00	1968-01-07	38000177		0	0	14		0	0	0	11290	0	243670	19059056		
56210	4666	1127078	1976-11-09	1976-11-09 00:00:00	1976-12-14	1976-12-14 00:00:00	1976-12-14	38000177		0	0	35		0	0	0	310943	0	282464	1127078		
53727	4467	1124300	1987-07-09	1987-07-09 00:00:00	1987-07-09	1987-07-09 00:00:00	\N	38000177		0	0	0		0	0	0	297204	0	00781178901	45011828		
167268	3678	40213160	1977-08-01	1977-08-01 00:00:00	1977-08-01	1977-08-01 00:00:00	1977-08-01	581452		0	0	0		0	0	0	244612	0	10	40213160		
31529	2615	1127433	1961-04-28	1961-04-28 00:00:00	1961-05-05	1961-05-05 00:00:00	1961-05-05	38000177		0	0	7		0	0	0	172926	0	313782	1127433		
122975	2703	40213296	2014-03-09	2014-03-09 00:00:00	2014-03-09	2014-03-09 00:00:00	2014-03-09	581452		0	0	0		0	0	0	179096	0	52	40213296		
209339	4591	40213160	1955-02-24	1955-02-24 00:00:00	1955-02-24	1955-02-24 00:00:00	1955-02-24	581452		0	0	0		0	0	0	305921	0	10	40213160		
16165	1340	1127433	1955-04-26	1955-04-26 00:00:00	1955-05-10	1955-05-10 00:00:00	1955-05-10	38000177		0	0	14		0	0	0	88941	0	313782	1127433		
182647	4014	40213160	1972-11-05	1972-11-05 00:00:00	1972-11-05	1972-11-05 00:00:00	1972-11-05	581452		0	0	0		0	0	0	266716	0	10	40213160		
56802	4715	1127433	1985-01-07	1985-01-07 00:00:00	1985-01-14	1985-01-14 00:00:00	1985-01-14	38000177		0	0	7		0	0	0	313928	0	313782	1127433		
183660	4035	40213160	1972-08-29	1972-08-29 00:00:00	1972-08-29	1972-08-29 00:00:00	1972-08-29	581452		0	0	0		0	0	0	268495	0	10	40213160		
78299	1713	40213160	1972-03-15	1972-03-15 00:00:00	1972-03-15	1972-03-15 00:00:00	1972-03-15	581452		0	0	0		0	0	0	114440	0	10	40213160		
36795	3040	1127433	1985-06-17	1985-06-17 00:00:00	1985-07-01	1985-07-01 00:00:00	1985-07-01	38000177		0	0	14		0	0	0	202373	0	313782	1127433		
134255	2947	40213227	1996-09-04	1996-09-04 00:00:00	1996-09-04	1996-09-04 00:00:00	1996-09-04	581452		0	0	0		0	0	0	196691	0	113	40213227		
71182	1558	40213160	1955-07-07	1955-07-07 00:00:00	1955-07-07	1955-07-07 00:00:00	1955-07-07	581452		0	0	0		0	0	0	104358	0	10	40213160		
118640	2610	40213260	2008-07-12	2008-07-12 00:00:00	2008-07-12	2008-07-12 00:00:00	2008-07-12	581452		0	0	0		0	0	0	172577	0	121	40213260		
37463	3096	19059056	1965-04-28	1965-04-28 00:00:00	1965-05-12	1965-05-12 00:00:00	1965-05-12	38000177		0	0	14		0	0	0	206103	0	243670	19059056		
23066	1903	19115351	1976-04-20	1976-04-20 00:00:00	1977-01-11	1977-01-11 00:00:00	1977-01-11	38000177		0	0	266		0	0	0	126659	0	563026	19115351		
5312	445	19059056	1951-08-05	1951-08-05 00:00:00	1951-08-19	1951-08-19 00:00:00	1951-08-19	38000177		0	0	14		0	0	0	29638	0	243670	19059056		
380	30	19129655	1974-11-09	1974-11-09 00:00:00	1974-11-23	1974-11-23 00:00:00	1974-11-23	38000177		0	0	14		0	0	0	2116	0	789980	19129655		
105356	2311	40213260	2011-02-05	2011-02-05 00:00:00	2011-02-05	2011-02-05 00:00:00	2011-02-05	581452		0	0	0		0	0	0	153761	0	121	40213260		
19291	1593	19133873	1935-06-12	1935-06-12 00:00:00	1935-06-21	1935-06-21 00:00:00	1935-06-21	38000177		0	0	9		0	0	0	106823	0	834061	19133873		
43899	3637	1118084	2001-01-21	2001-01-21 00:00:00	2001-01-21	2001-01-21 00:00:00	\N	38000177		0	0	0		0	0	0	241883	0	00025152531	44923712		
176205	3874	40213306	2004-06-23	2004-06-23 00:00:00	2004-06-23	2004-06-23 00:00:00	2004-06-23	581452		0	0	0		0	0	0	257303	0	43	40213306		
43953	3639	19059056	1980-12-24	1980-12-24 00:00:00	1981-01-07	1981-01-07 00:00:00	1981-01-07	38000177		0	0	14		0	0	0	242123	0	243670	19059056		
168649	3707	40213227	2000-11-13	2000-11-13 00:00:00	2000-11-13	2000-11-13 00:00:00	2000-11-13	581452		0	0	0		0	0	0	246445	0	113	40213227		
224010	4917	40213227	2014-03-10	2014-03-10 00:00:00	2014-03-10	2014-03-10 00:00:00	2014-03-10	581452		0	0	0		0	0	0	326728	0	113	40213227		
85070	1861	40213314	1982-03-06	1982-03-06 00:00:00	1982-03-06	1982-03-06 00:00:00	1982-03-06	581452		0	0	0		0	0	0	124456	0	49	40213314		
2737	220	1713671	1988-02-09	1988-02-09 00:00:00	1988-02-16	1988-02-16 00:00:00	1988-02-16	38000177		0	0	7		0	0	0	14813	0	562251	1713671		
227604	4998	40213160	1965-01-15	1965-01-15 00:00:00	1965-01-15	1965-01-15 00:00:00	1965-01-15	581452		0	0	0		0	0	0	332408	0	10	40213160		
49337	4092	40162522	1986-12-26	1986-12-26 00:00:00	1986-12-26	1986-12-26 00:00:00	\N	38000177		0	0	0		0	0	0	272072	0	857005	40162522		
61232	5095	19129655	1965-12-30	1965-12-30 00:00:00	1966-01-13	1966-01-13 00:00:00	1966-01-13	38000177		0	0	14		0	0	0	338550	0	789980	19129655		
6572	552	19133873	1954-02-08	1954-02-08 00:00:00	1954-02-18	1954-02-18 00:00:00	1954-02-18	38000177		0	0	10		0	0	0	36564	0	834061	19133873		
47878	3968	19133873	1923-11-24	1923-11-24 00:00:00	1923-12-05	1923-12-05 00:00:00	1923-12-05	38000177		0	0	11		0	0	0	263895	0	834061	19133873		
23932	1971	1127433	1981-05-12	1981-05-12 00:00:00	1981-05-19	1981-05-19 00:00:00	1981-05-19	38000177		0	0	7		0	0	0	131066	0	313782	1127433		
165071	3629	40213160	1960-10-31	1960-10-31 00:00:00	1960-10-31	1960-10-31 00:00:00	1960-10-31	581452		0	0	0		0	0	0	241436	0	10	40213160		
69123	1512	40213227	2015-11-25	2015-11-25 00:00:00	2015-11-25	2015-11-25 00:00:00	2015-11-25	581452		0	0	0		0	0	0	100950	0	113	40213227		
34182	2825	19059056	1927-03-16	1927-03-16 00:00:00	1927-04-13	1927-04-13 00:00:00	1927-04-13	38000177		0	0	28		0	0	0	187258	0	243670	19059056		
23845	1962	1127433	1992-09-20	1992-09-20 00:00:00	1992-10-04	1992-10-04 00:00:00	1992-10-04	38000177		0	0	14		0	0	0	130479	0	313782	1127433		
23903	1967	1551192	1960-07-18	1960-07-18 00:00:00	1960-07-18	1960-07-18 00:00:00	1960-07-18	38000177		0	0	0		0	0	0	130888	0	312617	1551192		
38724	844	40213306	1989-06-24	1989-06-24 00:00:00	1989-06-24	1989-06-24 00:00:00	1989-06-24	581452		0	0	0		0	0	0	55908	0	43	40213306		
8064	173	40213260	2018-08-05	2018-08-05 00:00:00	2018-08-05	2018-08-05 00:00:00	2018-08-05	581452		0	0	0		0	0	0	11752	0	121	40213260		
176084	3871	40213227	1993-10-13	1993-10-13 00:00:00	1993-10-13	1993-10-13 00:00:00	1993-10-13	581452		0	0	0		0	0	0	257012	0	113	40213227		
145174	3191	40213260	2007-09-27	2007-09-27 00:00:00	2007-09-27	2007-09-27 00:00:00	2007-09-27	581452		0	0	0		0	0	0	212371	0	121	40213260		
130957	2878	40213251	1985-08-04	1985-08-04 00:00:00	1985-08-04	1985-08-04 00:00:00	1985-08-04	581452		0	0	0		0	0	0	191437	0	21	40213251		
45106	3732	19075601	2016-09-18	2016-09-18 00:00:00	2016-09-18	2016-09-18 00:00:00	2016-09-18	38000177		0	0	0		0	0	0	247982	0	309362	19075601		
69389	1518	40213296	1997-01-31	1997-01-31 00:00:00	1997-01-31	1997-01-31 00:00:00	1997-01-31	581452		0	0	0		0	0	0	\N	0	52	40213296		
4806	103	40213160	1968-02-04	1968-02-04 00:00:00	1968-02-04	1968-02-04 00:00:00	1968-02-04	581452		0	0	0		0	0	0	7037	0	10	40213160		
16131	348	40213296	2015-08-03	2015-08-03 00:00:00	2015-08-03	2015-08-03 00:00:00	2015-08-03	581452		0	0	0		0	0	0	23154	0	52	40213296		
72034	1574	40213227	1992-11-20	1992-11-20 00:00:00	1992-11-20	1992-11-20 00:00:00	1992-11-20	581452		0	0	0		0	0	0	105668	0	113	40213227		
38856	3212	1127433	1992-11-08	1992-11-08 00:00:00	1992-11-22	1992-11-22 00:00:00	1992-11-22	38000177		0	0	14		0	0	0	213417	0	313782	1127433		
121918	2680	40213306	1993-10-07	1993-10-07 00:00:00	1993-10-07	1993-10-07 00:00:00	1993-10-07	581452		0	0	0		0	0	0	177537	0	43	40213306		
73113	1598	40213160	1963-01-21	1963-01-21 00:00:00	1963-01-21	1963-01-21 00:00:00	1963-01-21	581452		0	0	0		0	0	0	107215	0	10	40213160		
135327	2970	40213306	1988-04-01	1988-04-01 00:00:00	1988-04-01	1988-04-01 00:00:00	1988-04-01	581452		0	0	0		0	0	0	198352	0	43	40213306		
113807	2501	40213260	2011-11-28	2011-11-28 00:00:00	2011-11-28	2011-11-28 00:00:00	2011-11-28	581452		0	0	0		0	0	0	165572	0	121	40213260		
49540	4109	19073188	2013-08-05	2013-08-05 00:00:00	2013-08-19	2013-08-19 00:00:00	2013-08-19	38000177		0	0	14		0	0	0	273062	0	308192	19073188		
112076	2462	40213160	1962-03-18	1962-03-18 00:00:00	1962-03-18	1962-03-18 00:00:00	1962-03-18	581452		0	0	0		0	0	0	163205	0	10	40213160		
49751	4127	19059056	1949-04-19	1949-04-19 00:00:00	1949-05-03	1949-05-03 00:00:00	1949-05-03	38000177		0	0	14		0	0	0	274336	0	243670	19059056		
93035	2041	40213260	2014-02-25	2014-02-25 00:00:00	2014-02-25	2014-02-25 00:00:00	2014-02-25	581452		0	0	0		0	0	0	135830	0	121	40213260		
46075	1005	40213260	2017-11-14	2017-11-14 00:00:00	2017-11-14	2017-11-14 00:00:00	2017-11-14	581452		0	0	0		0	0	0	66412	0	121	40213260		
196584	4319	40213251	1984-11-28	1984-11-28 00:00:00	1984-11-28	1984-11-28 00:00:00	1984-11-28	581452		0	0	0		0	0	0	286598	0	21	40213251		
150995	3321	40213314	1977-05-02	1977-05-02 00:00:00	1977-05-02	1977-05-02 00:00:00	1977-05-02	581452		0	0	0		0	0	0	220514	0	49	40213314		
105745	2320	40213227	2012-12-22	2012-12-22 00:00:00	2012-12-22	2012-12-22 00:00:00	2012-12-22	581452		0	0	0		0	0	0	154327	0	113	40213227		
7383	616	19006318	1961-06-21	1961-06-21 00:00:00	1961-07-05	1961-07-05 00:00:00	1961-07-05	38000177		0	0	14		0	0	0	41127	0	105078	19006318		
2090	164	46233988	1967-12-24	1967-12-24 00:00:00	1968-01-07	1968-01-07 00:00:00	1968-01-07	38000177		0	0	14		0	0	0	11290	0	1652673	46233988		
56211	4666	19128022	1994-05-19	1994-05-19 00:00:00	1995-05-14	1995-05-14 00:00:00	1995-05-14	38000177		0	0	360		0	0	0	310936	0	749785	19128022		
53728	4467	19128065	1974-05-08	1974-05-08 00:00:00	1975-05-03	1975-05-03 00:00:00	1975-05-03	38000177		0	0	360		0	0	0	297209	0	749882	19128065		
167275	3678	40213251	1984-04-16	1984-04-16 00:00:00	1984-04-16	1984-04-16 00:00:00	1984-04-16	581452		0	0	0		0	0	0	244573	0	21	40213251		
31530	2615	1713671	1963-01-23	1963-01-23 00:00:00	1963-02-06	1963-02-06 00:00:00	1963-02-06	38000177		0	0	14		0	0	0	172848	0	562251	1713671		
122980	2703	40213227	2016-03-13	2016-03-13 00:00:00	2016-03-13	2016-03-13 00:00:00	2016-03-13	581452		0	0	0		0	0	0	179079	0	113	40213227		
209349	4591	40213160	1956-02-23	1956-02-23 00:00:00	1956-02-23	1956-02-23 00:00:00	1956-02-23	581452		0	0	0		0	0	0	305954	0	10	40213160		
16166	1340	19059056	1927-12-17	1927-12-17 00:00:00	1928-01-07	1928-01-07 00:00:00	1928-01-07	38000177		0	0	21		0	0	0	88843	0	243670	19059056		
182650	4014	40213260	2017-11-26	2017-11-26 00:00:00	2017-11-26	2017-11-26 00:00:00	2017-11-26	581452		0	0	0		0	0	0	266760	0	121	40213260		
56804	4715	1127078	1955-11-10	1955-11-10 00:00:00	1955-11-24	1955-11-24 00:00:00	1955-11-24	38000177		0	0	14		0	0	0	313960	0	282464	1127078		
159352	3508	40213260	2008-04-30	2008-04-30 00:00:00	2008-04-30	2008-04-30 00:00:00	2008-04-30	581452		0	0	0		0	0	0	232682	0	121	40213260		
78305	1713	40213160	1972-06-14	1972-06-14 00:00:00	1972-06-14	1972-06-14 00:00:00	1972-06-14	581452		0	0	0		0	0	0	114481	0	10	40213160		
36796	3040	1118084	2010-09-27	2010-09-27 00:00:00	2010-09-27	2010-09-27 00:00:00	\N	38000177		0	0	0		0	0	0	202410	0	00025152531	44923712		
134256	2947	40213306	1996-09-04	1996-09-04 00:00:00	1996-09-04	1996-09-04 00:00:00	1996-09-04	581452		0	0	0		0	0	0	196691	0	43	40213306		
71190	1558	40213227	2016-04-28	2016-04-28 00:00:00	2016-04-28	2016-04-28 00:00:00	2016-04-28	581452		0	0	0		0	0	0	104357	0	113	40213227		
118644	2610	40213296	1999-07-17	1999-07-17 00:00:00	1999-07-17	1999-07-17 00:00:00	1999-07-17	581452		0	0	0		0	0	0	172601	0	52	40213296		
37464	3096	19129655	1965-04-28	1965-04-28 00:00:00	1965-05-12	1965-05-12 00:00:00	1965-05-12	38000177		0	0	14		0	0	0	206103	0	789980	19129655		
23067	1903	1118084	2005-02-28	2005-02-28 00:00:00	2005-02-28	2005-02-28 00:00:00	\N	38000177		0	0	0		0	0	0	126677	0	00025152531	44923712		
15779	1313	1127433	1993-12-22	1993-12-22 00:00:00	1993-12-29	1993-12-29 00:00:00	1993-12-29	38000177		0	0	7		0	0	0	86918	0	313782	1127433		
381	30	1127078	1974-11-09	1974-11-09 00:00:00	1974-11-23	1974-11-23 00:00:00	1974-11-23	38000177		0	0	14		0	0	0	2116	0	282464	1127078		
105366	2311	40213160	1960-05-07	1960-05-07 00:00:00	1960-05-07	1960-05-07 00:00:00	1960-05-07	581452		0	0	0		0	0	0	153758	0	10	40213160		
19292	1593	1127433	2014-09-22	2014-09-22 00:00:00	2014-09-29	2014-09-29 00:00:00	2014-09-29	38000177		0	0	7		0	0	0	106893	0	313782	1127433		
43900	3637	1127433	2018-08-04	2018-08-04 00:00:00	2018-08-18	2018-08-18 00:00:00	2018-08-18	38000177		0	0	14		0	0	0	241944	0	313782	1127433		
176207	3874	40213227	2004-06-23	2004-06-23 00:00:00	2004-06-23	2004-06-23 00:00:00	2004-06-23	581452		0	0	0		0	0	0	257303	0	113	40213227		
43961	3641	1713671	1993-08-12	1993-08-12 00:00:00	1993-08-19	1993-08-19 00:00:00	1993-08-19	38000177		0	0	7		0	0	0	242270	0	562251	1713671		
168654	3707	40213160	1974-06-10	1974-06-10 00:00:00	1974-06-10	1974-06-10 00:00:00	1974-06-10	581452		0	0	0		0	0	0	246434	0	10	40213160		
224015	4917	40213314	1982-08-02	1982-08-02 00:00:00	1982-08-02	1982-08-02 00:00:00	1982-08-02	581452		0	0	0		0	0	0	326741	0	49	40213314		
85071	1861	40213160	1982-03-06	1982-03-06 00:00:00	1982-03-06	1982-03-06 00:00:00	1982-03-06	581452		0	0	0		0	0	0	124456	0	10	40213160		
2738	220	40229134	1993-07-20	1993-07-20 00:00:00	1993-08-03	1993-08-03 00:00:00	1993-08-03	38000177		0	0	14		0	0	0	14853	0	1043400	40229134		
227608	4998	40213260	2014-10-10	2014-10-10 00:00:00	2014-10-10	2014-10-10 00:00:00	2014-10-10	581452		0	0	0		0	0	0	332345	0	121	40213260		
49338	4092	1127433	2018-04-09	2018-04-09 00:00:00	2018-04-16	2018-04-16 00:00:00	2018-04-16	38000177		0	0	7		0	0	0	272049	0	313782	1127433		
61233	5095	1118084	2002-09-17	2002-09-17 00:00:00	2002-09-17	2002-09-17 00:00:00	\N	38000177		0	0	0		0	0	0	338544	0	00025152531	44923712		
30439	2522	1127433	1970-06-23	1970-06-23 00:00:00	1970-06-30	1970-06-30 00:00:00	1970-06-30	38000177		0	0	7		0	0	0	166799	0	313782	1127433		
47879	3968	1127433	1965-02-19	1965-02-19 00:00:00	1965-02-26	1965-02-26 00:00:00	1965-02-26	38000177		0	0	7		0	0	0	263899	0	313782	1127433		
23933	1971	920300	1993-04-08	1993-04-08 00:00:00	1993-04-15	1993-04-15 00:00:00	1993-04-15	38000177		0	0	7		0	0	0	131044	0	311989	920300		
165078	3629	40213227	2017-04-17	2017-04-17 00:00:00	2017-04-17	2017-04-17 00:00:00	2017-04-17	581452		0	0	0		0	0	0	241432	0	113	40213227		
69124	1512	40213296	2015-11-25	2015-11-25 00:00:00	2015-11-25	2015-11-25 00:00:00	2015-11-25	581452		0	0	0		0	0	0	100950	0	52	40213296		
24039	1977	40171902	2012-05-31	2012-05-31 00:00:00	2012-05-31	2012-05-31 00:00:00	\N	38000177		0	0	0		0	0	0	131568	0	897718	40171902		
23846	1962	19128065	1980-03-25	1980-03-25 00:00:00	1981-03-20	1981-03-20 00:00:00	1981-03-20	38000177		0	0	360		0	0	0	130503	0	749882	19128065		
23904	1967	40232448	1958-11-02	1958-11-02 00:00:00	1958-11-02	1958-11-02 00:00:00	\N	38000177		0	0	0		0	0	0	130864	0	1049630	40232448		
38726	844	40213227	2017-04-29	2017-04-29 00:00:00	2017-04-29	2017-04-29 00:00:00	2017-04-29	581452		0	0	0		0	0	0	55948	0	113	40213227		
129107	2839	40213314	1977-01-31	1977-01-31 00:00:00	1977-01-31	1977-01-31 00:00:00	1977-01-31	581452		0	0	0		0	0	0	188569	0	49	40213314		
176089	3871	40213160	1963-02-20	1963-02-20 00:00:00	1963-02-20	1963-02-20 00:00:00	1963-02-20	581452		0	0	0		0	0	0	257024	0	10	40213160		
226201	4967	40213160	1962-01-01	1962-01-01 00:00:00	1962-01-01	1962-01-01 00:00:00	1962-01-01	581452		0	0	0		0	0	0	330152	0	10	40213160		
130958	2878	40213160	1985-08-04	1985-08-04 00:00:00	1985-08-04	1985-08-04 00:00:00	1985-08-04	581452		0	0	0		0	0	0	191437	0	10	40213160		
45107	3732	19078461	1999-01-09	1999-01-09 00:00:00	1999-02-06	1999-02-06 00:00:00	1999-02-06	38000177		0	0	28		0	0	0	247986	0	310965	19078461		
69391	1518	40213160	1956-06-15	1956-06-15 00:00:00	1956-06-15	1956-06-15 00:00:00	1956-06-15	581452		0	0	0		0	0	0	101547	0	10	40213160		
4807	103	40213160	1967-11-05	1967-11-05 00:00:00	1967-11-05	1967-11-05 00:00:00	1967-11-05	581452		0	0	0		0	0	0	7026	0	10	40213160		
16133	348	40213314	1977-01-03	1977-01-03 00:00:00	1977-01-03	1977-01-03 00:00:00	1977-01-03	581452		0	0	0		0	0	0	23126	0	49	40213314		
142452	3129	40213160	1971-10-26	1971-10-26 00:00:00	1971-10-26	1971-10-26 00:00:00	1971-10-26	581452		0	0	0		0	0	0	208253	0	10	40213160		
38857	3212	40236446	1992-07-25	1992-07-25 00:00:00	1999-08-03	1999-08-03 00:00:00	1999-08-03	38000177		0	0	2565		0	0	0	213402	0	1091392	40236446		
121920	2680	40213296	2015-11-19	2015-11-19 00:00:00	2015-11-19	2015-11-19 00:00:00	2015-11-19	581452		0	0	0		0	0	0	177538	0	52	40213296		
73115	1598	40213160	1958-04-28	1958-04-28 00:00:00	1958-04-28	1958-04-28 00:00:00	1958-04-28	581452		0	0	0		0	0	0	107212	0	10	40213160		
135329	2970	40213160	1965-12-24	1965-12-24 00:00:00	1965-12-24	1965-12-24 00:00:00	1965-12-24	581452		0	0	0		0	0	0	198303	0	10	40213160		
113813	2501	40213160	1966-11-07	1966-11-07 00:00:00	1966-11-07	1966-11-07 00:00:00	1966-11-07	581452		0	0	0		0	0	0	165585	0	10	40213160		
49541	4109	1115171	2013-08-05	2013-08-05 00:00:00	2013-08-19	2013-08-19 00:00:00	2013-08-19	38000177		0	0	14		0	0	0	273062	0	849574	1115171		
112082	2462	40213306	1983-12-11	1983-12-11 00:00:00	1983-12-11	1983-12-11 00:00:00	1983-12-11	581452		0	0	0		0	0	0	163316	0	43	40213306		
49752	4127	19006318	1949-04-19	1949-04-19 00:00:00	1949-05-03	1949-05-03 00:00:00	1949-05-03	38000177		0	0	14		0	0	0	274336	0	105078	19006318		
93039	2041	40213296	2004-03-02	2004-03-02 00:00:00	2004-03-02	2004-03-02 00:00:00	2004-03-02	581452		0	0	0		0	0	0	135828	0	52	40213296		
46078	1005	40213160	1967-10-31	1967-10-31 00:00:00	1967-10-31	1967-10-31 00:00:00	1967-10-31	581452		0	0	0		0	0	0	66463	0	10	40213160		
196594	4319	40213160	1982-11-17	1982-11-17 00:00:00	1982-11-17	1982-11-17 00:00:00	1982-11-17	581452		0	0	0		0	0	0	286597	0	10	40213160		
150996	3321	40213160	1977-05-02	1977-05-02 00:00:00	1977-05-02	1977-05-02 00:00:00	1977-05-02	581452		0	0	0		0	0	0	220514	0	10	40213160		
105768	2320	40213201	2007-11-24	2007-11-24 00:00:00	2007-11-24	2007-11-24 00:00:00	2007-11-24	581452		0	0	0		0	0	0	154321	0	33	40213201		
7384	616	19059056	1961-06-21	1961-06-21 00:00:00	1961-07-05	1961-07-05 00:00:00	1961-07-05	38000177		0	0	14		0	0	0	41127	0	243670	19059056		
63933	5312	40169281	1977-01-03	1977-01-03 00:00:00	1977-01-03	1977-01-03 00:00:00	\N	38000177		0	0	0		0	0	0	353263	0	896209	40169281		
56212	4666	1115171	2015-08-22	2015-08-22 00:00:00	2015-09-05	2015-09-05 00:00:00	2015-09-05	38000177		0	0	14		0	0	0	310945	0	849574	1115171		
53729	4467	19128065	1975-05-03	1975-05-03 00:00:00	1976-04-27	1976-04-27 00:00:00	1976-04-27	38000177		0	0	360		0	0	0	297210	0	749882	19128065		
167278	3678	40213227	2018-02-26	2018-02-26 00:00:00	2018-02-26	2018-02-26 00:00:00	2018-02-26	581452		0	0	0		0	0	0	244577	0	113	40213227		
31531	2615	1127433	1987-05-04	1987-05-04 00:00:00	1987-07-10	1987-07-10 00:00:00	1987-07-10	38000177		0	0	67		0	0	0	172919	0	313782	1127433		
122981	2703	40213296	2016-03-13	2016-03-13 00:00:00	2016-03-13	2016-03-13 00:00:00	2016-03-13	581452		0	0	0		0	0	0	179079	0	52	40213296		
209352	4591	40213260	2006-04-13	2006-04-13 00:00:00	2006-04-13	2006-04-13 00:00:00	2006-04-13	581452		0	0	0		0	0	0	305963	0	121	40213260		
16167	1340	19059056	1980-01-25	1980-01-25 00:00:00	1980-02-29	1980-02-29 00:00:00	1980-02-29	38000177		0	0	35		0	0	0	88846	0	243670	19059056		
182654	4014	40213306	1990-05-13	1990-05-13 00:00:00	1990-05-13	1990-05-13 00:00:00	1990-05-13	581452		0	0	0		0	0	0	266775	0	43	40213306		
56805	4715	19006318	1955-11-10	1955-11-10 00:00:00	1955-11-24	1955-11-24 00:00:00	1955-11-24	38000177		0	0	14		0	0	0	313960	0	105078	19006318		
159354	3508	40213227	2008-04-30	2008-04-30 00:00:00	2008-04-30	2008-04-30 00:00:00	2008-04-30	581452		0	0	0		0	0	0	232682	0	113	40213227		
78307	1713	40213296	2012-05-02	2012-05-02 00:00:00	2012-05-02	2012-05-02 00:00:00	2012-05-02	581452		0	0	0		0	0	0	114494	0	52	40213296		
36797	3040	1127433	1987-04-24	1987-04-24 00:00:00	1987-05-01	1987-05-01 00:00:00	1987-05-01	38000177		0	0	7		0	0	0	202402	0	313782	1127433		
134259	2947	40213160	1979-05-02	1979-05-02 00:00:00	1979-05-02	1979-05-02 00:00:00	1979-05-02	581452		0	0	0		0	0	0	196729	0	10	40213160		
71195	1558	40213227	1996-02-01	1996-02-01 00:00:00	1996-02-01	1996-02-01 00:00:00	1996-02-01	581452		0	0	0		0	0	0	104324	0	113	40213227		
118646	2610	40213227	1999-07-17	1999-07-17 00:00:00	1999-07-17	1999-07-17 00:00:00	1999-07-17	581452		0	0	0		0	0	0	172601	0	113	40213227		
37465	3096	19059056	1970-12-15	1970-12-15 00:00:00	1971-02-13	1971-02-13 00:00:00	1971-02-13	38000177		0	0	60		0	0	0	206037	0	243670	19059056		
23068	1903	1127433	1971-03-05	1971-03-05 00:00:00	1971-03-19	1971-03-19 00:00:00	1971-03-19	38000177		0	0	14		0	0	0	126699	0	313782	1127433		
15780	1313	1713671	2004-04-03	2004-04-03 00:00:00	2004-04-17	2004-04-17 00:00:00	2004-04-17	38000177		0	0	14		0	0	0	86896	0	562251	1713671		
382	30	1118084	2009-03-23	2009-03-23 00:00:00	2009-03-23	2009-03-23 00:00:00	\N	38000177		0	0	0		0	0	0	2047	0	00025152531	44923712		
105370	2311	40213160	1960-07-09	1960-07-09 00:00:00	1960-07-09	1960-07-09 00:00:00	1960-07-09	581452		0	0	0		0	0	0	153707	0	10	40213160		
19293	1593	19075601	2009-10-01	2009-10-01 00:00:00	2009-10-01	2009-10-01 00:00:00	2009-10-01	38000177		0	0	0		0	0	0	106939	0	309362	19075601		
43901	3637	1713671	1971-07-10	1971-07-10 00:00:00	1971-07-24	1971-07-24 00:00:00	1971-07-24	38000177		0	0	14		0	0	0	241941	0	562251	1713671		
176211	3874	40213314	1983-03-02	1983-03-02 00:00:00	1983-03-02	1983-03-02 00:00:00	1983-03-02	581452		0	0	0		0	0	0	257231	0	49	40213314		
43962	3641	1713671	1976-05-29	1976-05-29 00:00:00	1976-06-05	1976-06-05 00:00:00	1976-06-05	38000177		0	0	7		0	0	0	242331	0	562251	1713671		
168658	3707	40213160	1969-10-06	1969-10-06 00:00:00	1969-10-06	1969-10-06 00:00:00	1969-10-06	581452		0	0	0		0	0	0	246468	0	10	40213160		
224016	4917	40213160	1982-08-02	1982-08-02 00:00:00	1982-08-02	1982-08-02 00:00:00	1982-08-02	581452		0	0	0		0	0	0	326741	0	10	40213160		
85073	1861	40213251	1986-11-08	1986-11-08 00:00:00	1986-11-08	1986-11-08 00:00:00	1986-11-08	581452		0	0	0		0	0	0	124433	0	21	40213251		
2739	220	1127078	1986-12-17	1986-12-17 00:00:00	1986-12-31	1986-12-31 00:00:00	1986-12-31	38000177		0	0	14		0	0	0	14816	0	282464	1127078		
227614	4998	40213306	1987-06-05	1987-06-05 00:00:00	1987-06-05	1987-06-05 00:00:00	1987-06-05	581452		0	0	0		0	0	0	332348	0	43	40213306		
49339	4092	19128022	1991-05-14	1991-05-14 00:00:00	1992-05-08	1992-05-08 00:00:00	1992-05-08	38000177		0	0	360		0	0	0	272053	0	749785	19128022		
61234	5095	19059056	1979-01-31	1979-01-31 00:00:00	1979-02-21	1979-02-21 00:00:00	1979-02-21	38000177		0	0	21		0	0	0	338498	0	243670	19059056		
30440	2522	19128065	1977-06-11	1977-06-11 00:00:00	1978-06-06	1978-06-06 00:00:00	1978-06-06	38000177		0	0	360		0	0	0	166833	0	749882	19128065		
47880	3968	46275916	1928-02-03	1928-02-03 00:00:00	1928-02-03	1928-02-03 00:00:00	1928-02-03	38000177		0	0	0		0	0	0	263901	0	1660014	46275916		
23934	1971	40236824	1993-04-08	1993-04-08 00:00:00	1993-04-22	1993-04-22 00:00:00	1993-04-22	38000177		0	0	14		0	0	0	131044	0	1094107	40236824		
61043	1334	40213227	2011-03-06	2011-03-06 00:00:00	2011-03-06	2011-03-06 00:00:00	2011-03-06	581452		0	0	0		0	0	0	88527	0	113	40213227		
69131	1512	40213160	1979-05-23	1979-05-23 00:00:00	1979-05-23	1979-05-23 00:00:00	1979-05-23	581452		0	0	0		0	0	0	100970	0	10	40213160		
24040	1977	19018935	2012-05-31	2012-05-31 00:00:00	2012-05-31	2012-05-31 00:00:00	\N	38000177		0	0	0		0	0	0	131568	0	197604	19018935		
23847	1962	1713671	2003-04-25	2003-04-25 00:00:00	2003-05-16	2003-05-16 00:00:00	2003-05-16	38000177		0	0	21		0	0	0	130491	0	562251	1713671		
34363	2839	19078461	1984-06-17	1984-06-17 00:00:00	1984-07-08	1984-07-08 00:00:00	1984-07-08	38000177		0	0	21		0	0	0	188551	0	310965	19078461		
38727	844	40213260	2017-04-29	2017-04-29 00:00:00	2017-04-29	2017-04-29 00:00:00	2017-04-29	581452		0	0	0		0	0	0	55948	0	121	40213260		
233798	5138	40213314	1978-05-12	1978-05-12 00:00:00	1978-05-12	1978-05-12 00:00:00	1978-05-12	581452		0	0	0		0	0	0	341479	0	49	40213314		
240215	5274	40213198	2018-01-07	2018-01-07 00:00:00	2018-01-07	2018-01-07 00:00:00	2018-01-07	581452		0	0	0		0	0	0	350832	0	133	40213198		
226207	4967	40213227	1992-07-20	1992-07-20 00:00:00	1992-07-20	1992-07-20 00:00:00	1992-07-20	581452		0	0	0		0	0	0	330173	0	113	40213227		
130964	2878	40213306	2002-12-29	2002-12-29 00:00:00	2002-12-29	2002-12-29 00:00:00	2002-12-29	581452		0	0	0		0	0	0	191418	0	43	40213306		
45108	3732	40231925	2015-11-16	2015-11-16 00:00:00	2015-11-16	2015-11-16 00:00:00	\N	38000177		0	0	0		0	0	0	247996	0	1049221	40231925		
69394	1518	40213160	1955-12-16	1955-12-16 00:00:00	1955-12-16	1955-12-16 00:00:00	1955-12-16	581452		0	0	0		0	0	0	101500	0	10	40213160		
207364	4550	40213160	1963-02-17	1963-02-17 00:00:00	1963-02-17	1963-02-17 00:00:00	1963-02-17	581452		0	0	0		0	0	0	303174	0	10	40213160		
16135	348	40213160	1975-11-03	1975-11-03 00:00:00	1975-11-03	1975-11-03 00:00:00	1975-11-03	581452		0	0	0		0	0	0	23147	0	10	40213160		
79240	1733	40213160	1981-10-28	1981-10-28 00:00:00	1981-10-28	1981-10-28 00:00:00	1981-10-28	581452		0	0	0		0	0	0	115845	0	10	40213160		
38858	3212	1127433	1987-05-30	1987-05-30 00:00:00	1987-06-13	1987-06-13 00:00:00	1987-06-13	38000177		0	0	14		0	0	0	213449	0	313782	1127433		
15644	337	40213227	2001-10-03	2001-10-03 00:00:00	2001-10-03	2001-10-03 00:00:00	2001-10-03	581452		0	0	0		0	0	0	22432	0	113	40213227		
73118	1598	40213296	2001-06-11	2001-06-11 00:00:00	2001-06-11	2001-06-11 00:00:00	2001-06-11	581452		0	0	0		0	0	0	107280	0	52	40213296		
135333	2970	40213227	1997-04-11	1997-04-11 00:00:00	1997-04-11	1997-04-11 00:00:00	1997-04-11	581452		0	0	0		0	0	0	198276	0	113	40213227		
113819	2501	40213227	2003-12-08	2003-12-08 00:00:00	2003-12-08	2003-12-08 00:00:00	2003-12-08	581452		0	0	0		0	0	0	165549	0	113	40213227		
49542	4109	19129655	1965-05-30	1965-05-30 00:00:00	1965-06-13	1965-06-13 00:00:00	1965-06-13	38000177		0	0	14		0	0	0	273118	0	789980	19129655		
112090	2462	40213296	2003-10-19	2003-10-19 00:00:00	2003-10-19	2003-10-19 00:00:00	2003-10-19	581452		0	0	0		0	0	0	163306	0	52	40213296		
49754	4127	1127433	1965-11-22	1965-11-22 00:00:00	1965-12-06	1965-12-06 00:00:00	1965-12-06	38000177		0	0	14		0	0	0	274338	0	313782	1127433		
93042	2041	40213227	2015-03-03	2015-03-03 00:00:00	2015-03-03	2015-03-03 00:00:00	2015-03-03	581452		0	0	0		0	0	0	135795	0	113	40213227		
46084	1005	40213160	1971-11-09	1971-11-09 00:00:00	1971-11-09	1971-11-09 00:00:00	1971-11-09	581452		0	0	0		0	0	0	66438	0	10	40213160		
196603	4320	40213227	2012-04-08	2012-04-08 00:00:00	2012-04-08	2012-04-08 00:00:00	2012-04-08	581452		0	0	0		0	0	0	286696	0	113	40213227		
151000	3321	40213227	2019-02-04	2019-02-04 00:00:00	2019-02-04	2019-02-04 00:00:00	2019-02-04	581452		0	0	0		0	0	0	220540	0	113	40213227		
186281	4092	40213314	1977-05-12	1977-05-12 00:00:00	1977-05-12	1977-05-12 00:00:00	1977-05-12	581452		0	0	0		0	0	0	272063	0	49	40213314		
7385	616	40229134	2003-07-12	2003-07-12 00:00:00	2003-07-26	2003-07-26 00:00:00	2003-07-26	38000177		0	0	14		0	0	0	41071	0	1043400	40229134		
63934	5312	40229134	2005-04-24	2005-04-24 00:00:00	2005-05-01	2005-05-01 00:00:00	2005-05-01	38000177		0	0	7		0	0	0	353272	0	1043400	40229134		
56213	4666	1124300	2015-04-09	2015-04-09 00:00:00	2015-04-09	2015-04-09 00:00:00	\N	38000177		0	0	0		0	0	0	310967	0	00781178901	45011828		
53732	4467	1127078	1956-05-02	1956-05-02 00:00:00	1956-05-23	1956-05-23 00:00:00	1956-05-23	38000177		0	0	21		0	0	0	297160	0	282464	1127078		
167279	3678	40213296	2018-02-26	2018-02-26 00:00:00	2018-02-26	2018-02-26 00:00:00	2018-02-26	581452		0	0	0		0	0	0	244577	0	52	40213296		
31532	2615	1713671	2006-03-19	2006-03-19 00:00:00	2006-04-02	2006-04-02 00:00:00	2006-04-02	38000177		0	0	14		0	0	0	172855	0	562251	1713671		
122984	2703	40213227	2005-04-17	2005-04-17 00:00:00	2005-04-17	2005-04-17 00:00:00	2005-04-17	581452		0	0	0		0	0	0	179064	0	113	40213227		
209368	4591	40213227	2014-05-29	2014-05-29 00:00:00	2014-05-29	2014-05-29 00:00:00	2014-05-29	581452		0	0	0		0	0	0	305967	0	113	40213227		
16168	1340	1118084	1952-01-31	1952-01-31 00:00:00	1952-01-31	1952-01-31 00:00:00	\N	38000177		0	0	0		0	0	0	88885	0	00025152531	44923712		
182661	4014	40213160	1968-08-04	1968-08-04 00:00:00	1968-08-04	1968-08-04 00:00:00	1968-08-04	581452		0	0	0		0	0	0	266812	0	10	40213160		
56806	4715	1127433	1970-01-26	1970-01-26 00:00:00	1970-02-02	1970-02-02 00:00:00	1970-02-02	38000177		0	0	7		0	0	0	313896	0	313782	1127433		
159356	3508	40213227	2018-06-27	2018-06-27 00:00:00	2018-06-27	2018-06-27 00:00:00	2018-06-27	581452		0	0	0		0	0	0	232665	0	113	40213227		
78310	1713	40213227	1994-02-23	1994-02-23 00:00:00	1994-02-23	1994-02-23 00:00:00	1994-02-23	581452		0	0	0		0	0	0	114448	0	113	40213227		
36798	3040	40229134	2011-10-02	2011-10-02 00:00:00	2011-10-09	2011-10-09 00:00:00	2011-10-09	38000177		0	0	7		0	0	0	202371	0	1043400	40229134		
134264	2947	40213160	1974-08-28	1974-08-28 00:00:00	1974-08-28	1974-08-28 00:00:00	1974-08-28	581452		0	0	0		0	0	0	196717	0	10	40213160		
71196	1558	40213296	1996-02-01	1996-02-01 00:00:00	1996-02-01	1996-02-01 00:00:00	1996-02-01	581452		0	0	0		0	0	0	104324	0	52	40213296		
118650	2610	40213160	1962-06-16	1962-06-16 00:00:00	1962-06-16	1962-06-16 00:00:00	1962-06-16	581452		0	0	0		0	0	0	172557	0	10	40213160		
37466	3096	19128065	1978-12-13	1978-12-13 00:00:00	1979-12-08	1979-12-08 00:00:00	1979-12-08	38000177		0	0	360		0	0	0	206105	0	749882	19128065		
23069	1903	19078461	2014-01-29	2014-01-29 00:00:00	2014-02-26	2014-02-26 00:00:00	2014-02-26	38000177		0	0	28		0	0	0	126668	0	310965	19078461		
15781	1313	1118084	2011-08-03	2011-08-03 00:00:00	2011-08-03	2011-08-03 00:00:00	\N	38000177		0	0	0		0	0	0	86924	0	00025152531	44923712		
383	30	19128065	1986-08-01	1986-08-01 00:00:00	1987-07-27	1987-07-27 00:00:00	1987-07-27	38000177		0	0	360		0	0	0	2117	0	749882	19128065		
80966	1770	40213314	1978-11-19	1978-11-19 00:00:00	1978-11-19	1978-11-19 00:00:00	1978-11-19	581452		0	0	0		0	0	0	118348	0	49	40213314		
19294	1593	40220960	2009-10-01	2009-10-01 00:00:00	2009-10-01	2009-10-01 00:00:00	2009-10-01	38000177		0	0	0		0	0	0	106939	0	1804799	40220960		
43902	3637	1127433	2009-01-24	2009-01-24 00:00:00	2009-02-07	2009-02-07 00:00:00	2009-02-07	38000177		0	0	14		0	0	0	241925	0	313782	1127433		
176220	3874	40213160	1982-09-01	1982-09-01 00:00:00	1982-09-01	1982-09-01 00:00:00	1982-09-01	581452		0	0	0		0	0	0	257247	0	10	40213160		
43963	3641	1713671	1984-07-31	1984-07-31 00:00:00	1984-08-21	1984-08-21 00:00:00	1984-08-21	38000177		0	0	21		0	0	0	242332	0	562251	1713671		
168661	3707	40213306	1991-11-04	1991-11-04 00:00:00	1991-11-04	1991-11-04 00:00:00	1991-11-04	581452		0	0	0		0	0	0	246442	0	43	40213306		
238505	5236	40213227	2013-03-20	2013-03-20 00:00:00	2013-03-20	2013-03-20 00:00:00	2013-03-20	581452		0	0	0		0	0	0	348390	0	113	40213227		
85075	1861	40213160	1986-11-08	1986-11-08 00:00:00	1986-11-08	1986-11-08 00:00:00	1986-11-08	581452		0	0	0		0	0	0	124433	0	10	40213160		
2740	220	19075001	1986-12-17	1986-12-17 00:00:00	1986-12-31	1986-12-31 00:00:00	1986-12-31	38000177		0	0	14		0	0	0	14816	0	309097	19075001		
227621	4998	40213296	2008-04-18	2008-04-18 00:00:00	2008-04-18	2008-04-18 00:00:00	2008-04-18	581452		0	0	0		0	0	0	\N	0	52	40213296		
49340	4092	1713671	1991-10-02	1991-10-02 00:00:00	1991-10-16	1991-10-16 00:00:00	1991-10-16	38000177		0	0	14		0	0	0	272035	0	562251	1713671		
61235	5095	19075601	2007-01-15	2007-01-15 00:00:00	2007-01-15	2007-01-15 00:00:00	2007-01-15	38000177		0	0	0		0	0	0	338519	0	309362	19075601		
30444	2524	19059056	1951-09-20	1951-09-20 00:00:00	1951-10-04	1951-10-04 00:00:00	1951-10-04	38000177		0	0	14		0	0	0	166877	0	243670	19059056		
47881	3968	40243436	1928-02-03	1928-02-03 00:00:00	1928-02-03	1928-02-03 00:00:00	1928-02-03	38000177		0	0	0		0	0	0	263901	0	1190795	40243436		
23936	1971	1118084	2012-02-17	2012-02-17 00:00:00	2012-02-17	2012-02-17 00:00:00	\N	38000177		0	0	0		0	0	0	131019	0	00025152531	44923712		
61044	1334	40213296	2011-03-06	2011-03-06 00:00:00	2011-03-06	2011-03-06 00:00:00	2011-03-06	581452		0	0	0		0	0	0	88527	0	52	40213296		
69134	1512	40213160	1974-09-18	1974-09-18 00:00:00	1974-09-18	1974-09-18 00:00:00	1974-09-18	581452		0	0	0		0	0	0	101013	0	10	40213160		
24041	1977	40163554	2012-05-31	2012-05-31 00:00:00	2012-05-31	2012-05-31 00:00:00	\N	38000177		0	0	0		0	0	0	131568	0	855332	40163554		
23848	1962	19128065	1978-04-05	1978-04-05 00:00:00	1979-03-31	1979-03-31 00:00:00	1979-03-31	38000177		0	0	360		0	0	0	130492	0	749882	19128065		
34364	2839	1127433	2017-08-14	2017-08-14 00:00:00	2017-08-28	2017-08-28 00:00:00	2017-08-28	38000177		0	0	14		0	0	0	188552	0	313782	1127433		
16643	1379	46275916	1987-09-05	1987-09-05 00:00:00	1987-09-05	1987-09-05 00:00:00	1987-09-05	38000177		0	0	0		0	0	0	91516	0	1660014	46275916		
233799	5138	40213160	1978-05-12	1978-05-12 00:00:00	1978-05-12	1978-05-12 00:00:00	1978-05-12	581452		0	0	0		0	0	0	341479	0	10	40213160		
240217	5274	40213296	1996-04-21	1996-04-21 00:00:00	1996-04-21	1996-04-21 00:00:00	1996-04-21	581452		0	0	0		0	0	0	350774	0	52	40213296		
191504	4208	40213227	2010-04-20	2010-04-20 00:00:00	2010-04-20	2010-04-20 00:00:00	2010-04-20	581452		0	0	0		0	0	0	279388	0	113	40213227		
130966	2878	40213227	2002-12-29	2002-12-29 00:00:00	2002-12-29	2002-12-29 00:00:00	2002-12-29	581452		0	0	0		0	0	0	191418	0	113	40213227		
45109	3732	1115171	1997-12-17	1997-12-17 00:00:00	1998-01-14	1998-01-14 00:00:00	1998-01-14	38000177		0	0	28		0	0	0	247985	0	849574	1115171		
69400	1518	40213227	1995-07-21	1995-07-21 00:00:00	1995-07-21	1995-07-21 00:00:00	1995-07-21	581452		0	0	0		0	0	0	101556	0	113	40213227		
207368	4550	40213227	2004-09-19	2004-09-19 00:00:00	2004-09-19	2004-09-19 00:00:00	2004-09-19	581452		0	0	0		0	0	0	303244	0	113	40213227		
132114	2902	40213201	2013-04-12	2013-04-12 00:00:00	2013-04-12	2013-04-12 00:00:00	2013-04-12	581452		0	0	0		0	0	0	193405	0	33	40213201		
79242	1733	40213314	1981-05-27	1981-05-27 00:00:00	1981-05-27	1981-05-27 00:00:00	1981-05-27	581452		0	0	0		0	0	0	115844	0	49	40213314		
38859	3212	1127433	2009-04-30	2009-04-30 00:00:00	2009-05-14	2009-05-14 00:00:00	2009-05-14	38000177		0	0	14		0	0	0	213404	0	313782	1127433		
15645	337	40213296	2001-10-03	2001-10-03 00:00:00	2001-10-03	2001-10-03 00:00:00	2001-10-03	581452		0	0	0		0	0	0	22432	0	52	40213296		
73123	1598	40213160	1958-06-30	1958-06-30 00:00:00	1958-06-30	1958-06-30 00:00:00	1958-06-30	581452		0	0	0		0	0	0	107240	0	10	40213160		
13733	297	40213160	1956-05-27	1956-05-27 00:00:00	1956-05-27	1956-05-27 00:00:00	1956-05-27	581452		0	0	0		0	0	0	19831	0	10	40213160		
113820	2501	40213296	2003-12-08	2003-12-08 00:00:00	2003-12-08	2003-12-08 00:00:00	2003-12-08	581452		0	0	0		0	0	0	165549	0	52	40213296		
49543	4109	19059056	1965-05-30	1965-05-30 00:00:00	1965-06-13	1965-06-13 00:00:00	1965-06-13	38000177		0	0	14		0	0	0	273118	0	243670	19059056		
112092	2462	40213227	2003-10-19	2003-10-19 00:00:00	2003-10-19	2003-10-19 00:00:00	2003-10-19	581452		0	0	0		0	0	0	163306	0	113	40213227		
49755	4127	1127433	1976-07-05	1976-07-05 00:00:00	1976-07-19	1976-07-19 00:00:00	1976-07-19	38000177		0	0	14		0	0	0	274339	0	313782	1127433		
93043	2041	40213260	2015-03-03	2015-03-03 00:00:00	2015-03-03	2015-03-03 00:00:00	2015-03-03	581452		0	0	0		0	0	0	135795	0	121	40213260		
46088	1005	40213227	2008-10-21	2008-10-21 00:00:00	2008-10-21	2008-10-21 00:00:00	2008-10-21	581452		0	0	0		0	0	0	66449	0	113	40213227		
196604	4320	40213296	2012-04-08	2012-04-08 00:00:00	2012-04-08	2012-04-08 00:00:00	2012-04-08	581452		0	0	0		0	0	0	286696	0	52	40213296		
151001	3321	40213296	2019-02-04	2019-02-04 00:00:00	2019-02-04	2019-02-04 00:00:00	2019-02-04	581452		0	0	0		0	0	0	220540	0	52	40213296		
186292	4092	40213160	1973-09-13	1973-09-13 00:00:00	1973-09-13	1973-09-13 00:00:00	1973-09-13	581452		0	0	0		0	0	0	272036	0	10	40213160		
7386	616	1127433	2004-07-01	2004-07-01 00:00:00	2004-07-22	2004-07-22 00:00:00	2004-07-22	38000177		0	0	21		0	0	0	41090	0	313782	1127433		
63935	5312	19059056	1971-08-30	1971-08-30 00:00:00	1971-09-13	1971-09-13 00:00:00	1971-09-13	38000177		0	0	14		0	0	0	353229	0	243670	19059056		
56214	4666	1127078	1981-02-03	1981-02-03 00:00:00	1981-02-17	1981-02-17 00:00:00	1981-02-17	38000177		0	0	14		0	0	0	310957	0	282464	1127078		
53734	4467	1127433	1980-07-26	1980-07-26 00:00:00	1980-08-09	1980-08-09 00:00:00	1980-08-09	38000177		0	0	14		0	0	0	297242	0	313782	1127433		
167280	3678	40213160	1981-06-29	1981-06-29 00:00:00	1981-06-29	1981-06-29 00:00:00	1981-06-29	581452		0	0	0		0	0	0	244572	0	10	40213160		
31533	2615	1127078	1956-02-02	1956-02-02 00:00:00	1956-02-16	1956-02-16 00:00:00	1956-02-16	38000177		0	0	14		0	0	0	172917	0	282464	1127078		
122987	2703	40213160	1974-08-11	1974-08-11 00:00:00	1974-08-11	1974-08-11 00:00:00	1974-08-11	581452		0	0	0		0	0	0	179070	0	10	40213160		
209371	4591	40213160	1955-08-25	1955-08-25 00:00:00	1955-08-25	1955-08-25 00:00:00	1955-08-25	581452		0	0	0		0	0	0	305947	0	10	40213160		
16169	1340	1127433	1986-09-09	1986-09-09 00:00:00	1986-09-23	1986-09-23 00:00:00	1986-09-23	38000177		0	0	14		0	0	0	88958	0	313782	1127433		
182663	4014	40213260	2018-12-02	2018-12-02 00:00:00	2018-12-02	2018-12-02 00:00:00	2018-12-02	581452		0	0	0		0	0	0	266781	0	121	40213260		
56053	1228	40213296	2016-07-02	2016-07-02 00:00:00	2016-07-02	2016-07-02 00:00:00	2016-07-02	581452		0	0	0		0	0	0	\N	0	52	40213296		
159362	3508	40213160	1961-11-08	1961-11-08 00:00:00	1961-11-08	1961-11-08 00:00:00	1961-11-08	581452		0	0	0		0	0	0	232643	0	10	40213160		
78311	1713	40213306	1994-02-23	1994-02-23 00:00:00	1994-02-23	1994-02-23 00:00:00	1994-02-23	581452		0	0	0		0	0	0	114448	0	43	40213306		
36799	3040	1127078	1976-08-31	1976-08-31 00:00:00	1976-11-29	1976-11-29 00:00:00	1976-11-29	38000177		0	0	90		0	0	0	202412	0	282464	1127078		
134265	2947	40213160	1974-10-29	1974-10-29 00:00:00	1974-10-29	1974-10-29 00:00:00	1974-10-29	581452		0	0	0		0	0	0	196708	0	10	40213160		
71198	1558	40213260	2006-04-13	2006-04-13 00:00:00	2006-04-13	2006-04-13 00:00:00	2006-04-13	581452		0	0	0		0	0	0	\N	0	121	40213260		
118654	2610	40213160	1957-12-13	1957-12-13 00:00:00	1957-12-13	1957-12-13 00:00:00	1957-12-13	581452		0	0	0		0	0	0	172613	0	10	40213160		
37467	3096	19059056	1968-08-12	1968-08-12 00:00:00	1968-08-26	1968-08-26 00:00:00	1968-08-26	38000177		0	0	14		0	0	0	206104	0	243670	19059056		
23070	1903	19059056	1973-07-21	1973-07-21 00:00:00	1973-08-11	1973-08-11 00:00:00	1973-08-11	38000177		0	0	21		0	0	0	126663	0	243670	19059056		
15782	1314	1127433	1955-04-06	1955-04-06 00:00:00	1955-05-04	1955-05-04 00:00:00	1955-05-04	38000177		0	0	28		0	0	0	87034	0	313782	1127433		
384	30	19059056	1972-04-06	1972-04-06 00:00:00	1972-04-20	1972-04-20 00:00:00	1972-04-20	38000177		0	0	14		0	0	0	2115	0	243670	19059056		
80967	1770	40213160	1978-11-19	1978-11-19 00:00:00	1978-11-19	1978-11-19 00:00:00	1978-11-19	581452		0	0	0		0	0	0	118348	0	10	40213160		
19295	1593	1713671	1945-11-17	1945-11-17 00:00:00	1945-12-01	1945-12-01 00:00:00	1945-12-01	38000177		0	0	14		0	0	0	106824	0	562251	1713671		
18759	1550	1127433	1993-05-07	1993-05-07 00:00:00	1993-05-14	1993-05-14 00:00:00	1993-05-14	38000177		0	0	7		0	0	0	103805	0	313782	1127433		
176225	3874	40213314	1982-06-02	1982-06-02 00:00:00	1982-06-02	1982-06-02 00:00:00	1982-06-02	581452		0	0	0		0	0	0	257230	0	49	40213314		
43964	3641	1713671	1959-05-30	1959-05-30 00:00:00	1959-06-20	1959-06-20 00:00:00	1959-06-20	38000177		0	0	21		0	0	0	242337	0	562251	1713671		
168665	3708	40213160	1978-01-20	1978-01-20 00:00:00	1978-01-20	1978-01-20 00:00:00	1978-01-20	581452		0	0	0		0	0	0	246575	0	10	40213160		
238507	5236	40213296	2011-03-16	2011-03-16 00:00:00	2011-03-16	2011-03-16 00:00:00	2011-03-16	581452		0	0	0		0	0	0	348415	0	52	40213296		
85077	1861	40213306	2004-01-31	2004-01-31 00:00:00	2004-01-31	2004-01-31 00:00:00	2004-01-31	581452		0	0	0		0	0	0	124448	0	43	40213306		
2741	220	40229134	2019-01-11	2019-01-11 00:00:00	2019-01-25	2019-01-25 00:00:00	2019-01-25	38000177		0	0	14		0	0	0	14809	0	1043400	40229134		
227624	4998	40213227	2016-04-01	2016-04-01 00:00:00	2016-04-01	2016-04-01 00:00:00	2016-04-01	581452		0	0	0		0	0	0	332354	0	113	40213227		
49341	4092	1127078	1976-11-18	1976-11-18 00:00:00	1976-12-02	1976-12-02 00:00:00	1976-12-02	38000177		0	0	14		0	0	0	272023	0	282464	1127078		
61236	5095	40220960	2007-01-15	2007-01-15 00:00:00	2007-01-15	2007-01-15 00:00:00	2007-01-15	38000177		0	0	0		0	0	0	338519	0	1804799	40220960		
30445	2524	19006318	1951-09-20	1951-09-20 00:00:00	1951-10-04	1951-10-04 00:00:00	1951-10-04	38000177		0	0	14		0	0	0	166877	0	105078	19006318		
47882	3968	1127433	2007-05-21	2007-05-21 00:00:00	2007-05-28	2007-05-28 00:00:00	2007-05-28	38000177		0	0	7		0	0	0	263855	0	313782	1127433		
23937	1971	1713671	2017-12-22	2017-12-22 00:00:00	2018-01-12	2018-01-12 00:00:00	2018-01-12	38000177		0	0	21		0	0	0	131029	0	562251	1713671		
61046	1334	40213160	1969-06-01	1969-06-01 00:00:00	1969-06-01	1969-06-01 00:00:00	1969-06-01	581452		0	0	0		0	0	0	88496	0	10	40213160		
69138	1512	40213160	1975-02-19	1975-02-19 00:00:00	1975-02-19	1975-02-19 00:00:00	1975-02-19	581452		0	0	0		0	0	0	100987	0	10	40213160		
24042	1977	1127433	2007-04-13	2007-04-13 00:00:00	2007-04-27	2007-04-27 00:00:00	2007-04-27	38000177		0	0	14		0	0	0	131603	0	313782	1127433		
23849	1962	1713671	2009-10-29	2009-10-29 00:00:00	2009-11-26	2009-11-26 00:00:00	2009-11-26	38000177		0	0	28		0	0	0	130482	0	562251	1713671		
34365	2839	1127433	1987-08-16	1987-08-16 00:00:00	1987-08-30	1987-08-30 00:00:00	1987-08-30	38000177		0	0	14		0	0	0	188526	0	313782	1127433		
16644	1379	1127433	1973-02-06	1973-02-06 00:00:00	1973-02-13	1973-02-13 00:00:00	1973-02-13	38000177		0	0	7		0	0	0	91493	0	313782	1127433		
233802	5138	40213227	2000-03-17	2000-03-17 00:00:00	2000-03-17	2000-03-17 00:00:00	2000-03-17	581452		0	0	0		0	0	0	341467	0	113	40213227		
42351	3513	1127433	1974-04-10	1974-04-10 00:00:00	1974-04-17	1974-04-17 00:00:00	1974-04-17	38000177		0	0	7		0	0	0	233124	0	313782	1127433		
191522	4208	40213201	2005-03-22	2005-03-22 00:00:00	2005-03-22	2005-03-22 00:00:00	2005-03-22	581452		0	0	0		0	0	0	279407	0	33	40213201		
130970	2878	40213314	1981-11-01	1981-11-01 00:00:00	1981-11-01	1981-11-01 00:00:00	1981-11-01	581452		0	0	0		0	0	0	191436	0	49	40213314		
45110	3733	1127078	1980-07-17	1980-07-17 00:00:00	1980-08-21	1980-08-21 00:00:00	1980-08-21	38000177		0	0	35		0	0	0	248074	0	282464	1127078		
69404	1518	40213160	1955-06-17	1955-06-17 00:00:00	1955-06-17	1955-06-17 00:00:00	1955-06-17	581452		0	0	0		0	0	0	101506	0	10	40213160		
207369	4550	40213296	2004-09-19	2004-09-19 00:00:00	2004-09-19	2004-09-19 00:00:00	2004-09-19	581452		0	0	0		0	0	0	303244	0	52	40213296		
132118	2902	40213227	2008-03-14	2008-03-14 00:00:00	2008-03-14	2008-03-14 00:00:00	2008-03-14	581452		0	0	0		0	0	0	193398	0	113	40213227		
79243	1733	40213160	1981-05-27	1981-05-27 00:00:00	1981-05-27	1981-05-27 00:00:00	1981-05-27	581452		0	0	0		0	0	0	115844	0	10	40213160		
38860	3212	40229134	1995-09-18	1995-09-18 00:00:00	1995-10-02	1995-10-02 00:00:00	1995-10-02	38000177		0	0	14		0	0	0	213418	0	1043400	40229134		
15654	337	40213306	1981-11-25	1981-11-25 00:00:00	1981-11-25	1981-11-25 00:00:00	1981-11-25	581452		0	0	0		0	0	0	22444	0	43	40213306		
73130	1598	40213227	1992-08-31	1992-08-31 00:00:00	1992-08-31	1992-08-31 00:00:00	1992-08-31	581452		0	0	0		0	0	0	107233	0	113	40213227		
13735	297	40213198	2016-10-09	2016-10-09 00:00:00	2016-10-09	2016-10-09 00:00:00	2016-10-09	581452		0	0	0		0	0	0	19810	0	133	40213198		
113823	2501	40213160	1962-03-05	1962-03-05 00:00:00	1962-03-05	1962-03-05 00:00:00	1962-03-05	581452		0	0	0		0	0	0	165542	0	10	40213160		
49544	4109	19008572	2018-08-29	2018-08-29 00:00:00	2018-09-19	2018-09-19 00:00:00	2018-09-19	38000177		0	0	21		0	0	0	273084	0	106258	19008572		
112094	2462	40213227	2012-10-14	2012-10-14 00:00:00	2012-10-14	2012-10-14 00:00:00	2012-10-14	581452		0	0	0		0	0	0	163213	0	113	40213227		
49756	4127	1115171	1994-03-16	1994-03-16 00:00:00	1994-04-06	1994-04-06 00:00:00	1994-04-06	38000177		0	0	21		0	0	0	274343	0	849574	1115171		
93044	2041	40213160	1964-08-04	1964-08-04 00:00:00	1964-08-04	1964-08-04 00:00:00	1964-08-04	581452		0	0	0		0	0	0	135815	0	10	40213160		
46089	1005	40213296	2008-10-21	2008-10-21 00:00:00	2008-10-21	2008-10-21 00:00:00	2008-10-21	581452		0	0	0		0	0	0	66449	0	52	40213296		
196606	4320	40213160	1970-12-06	1970-12-06 00:00:00	1970-12-06	1970-12-06 00:00:00	1970-12-06	581452		0	0	0		0	0	0	286688	0	10	40213160		
151004	3321	40213227	1999-03-29	1999-03-29 00:00:00	1999-03-29	1999-03-29 00:00:00	1999-03-29	581452		0	0	0		0	0	0	220550	0	113	40213227		
186294	4092	40213296	2017-04-27	2017-04-27 00:00:00	2017-04-27	2017-04-27 00:00:00	2017-04-27	581452		0	0	0		0	0	0	272070	0	52	40213296		
7387	616	1127433	2012-11-14	2012-11-14 00:00:00	2012-11-21	2012-11-21 00:00:00	2012-11-21	38000177		0	0	7		0	0	0	41072	0	313782	1127433		
63936	5312	1118084	1973-06-14	1973-06-14 00:00:00	1973-06-14	1973-06-14 00:00:00	\N	38000177		0	0	0		0	0	0	353229	0	00025152531	44923712		
56215	4666	19019979	1978-11-04	1978-11-04 00:00:00	1979-01-03	1979-01-03 00:00:00	1979-01-03	38000177		0	0	60		0	0	0	310944	0	198405	19019979		
53735	4467	19059056	1973-02-19	1973-02-19 00:00:00	1973-03-26	1973-03-26 00:00:00	1973-03-26	38000177		0	0	35		0	0	0	297163	0	243670	19059056		
167284	3678	40213314	1978-01-30	1978-01-30 00:00:00	1978-01-30	1978-01-30 00:00:00	1978-01-30	581452		0	0	0		0	0	0	244586	0	49	40213314		
31534	2615	1127433	1953-10-16	1953-10-16 00:00:00	1953-10-30	1953-10-30 00:00:00	1953-10-30	38000177		0	0	14		0	0	0	172902	0	313782	1127433		
122990	2703	40213314	1977-02-06	1977-02-06 00:00:00	1977-02-06	1977-02-06 00:00:00	1977-02-06	581452		0	0	0		0	0	0	179101	0	49	40213314		
209377	4591	40213227	2004-04-01	2004-04-01 00:00:00	2004-04-01	2004-04-01 00:00:00	2004-04-01	581452		0	0	0		0	0	0	305962	0	113	40213227		
16170	1340	1127433	1948-03-09	1948-03-09 00:00:00	1948-03-23	1948-03-23 00:00:00	1948-03-23	38000177		0	0	14		0	0	0	88955	0	313782	1127433		
182665	4014	40213227	2018-12-02	2018-12-02 00:00:00	2018-12-02	2018-12-02 00:00:00	2018-12-02	581452		0	0	0		0	0	0	266781	0	113	40213227		
56055	1228	40213227	2016-07-02	2016-07-02 00:00:00	2016-07-02	2016-07-02 00:00:00	2016-07-02	581452		0	0	0		0	0	0	\N	0	113	40213227		
159364	3508	40213227	1998-04-01	1998-04-01 00:00:00	1998-04-01	1998-04-01 00:00:00	1998-04-01	581452		0	0	0		0	0	0	232669	0	113	40213227		
78317	1713	40213160	1972-01-12	1972-01-12 00:00:00	1972-01-12	1972-01-12 00:00:00	1972-01-12	581452		0	0	0		0	0	0	114473	0	10	40213160		
36800	3040	1713671	1988-05-26	1988-05-26 00:00:00	1988-06-02	1988-06-02 00:00:00	1988-06-02	38000177		0	0	7		0	0	0	202403	0	562251	1713671		
134266	2947	40213314	1977-10-26	1977-10-26 00:00:00	1977-10-26	1977-10-26 00:00:00	1977-10-26	581452		0	0	0		0	0	0	196728	0	49	40213314		
71206	1558	40213296	1998-02-05	1998-02-05 00:00:00	1998-02-05	1998-02-05 00:00:00	1998-02-05	581452		0	0	0		0	0	0	104365	0	52	40213296		
118657	2610	40213296	1997-07-12	1997-07-12 00:00:00	1997-07-12	1997-07-12 00:00:00	1997-07-12	581452		0	0	0		0	0	0	172575	0	52	40213296		
37468	3096	46233988	1968-08-12	1968-08-12 00:00:00	1968-08-26	1968-08-26 00:00:00	1968-08-26	38000177		0	0	14		0	0	0	206104	0	1652673	46233988		
23071	1903	1115171	2019-01-01	2019-01-01 00:00:00	2019-01-22	2019-01-22 00:00:00	2019-01-22	38000177		0	0	21		0	0	0	126735	0	849574	1115171		
15783	1314	19059056	1980-05-22	1980-05-22 00:00:00	1980-06-12	1980-06-12 00:00:00	1980-06-12	38000177		0	0	21		0	0	0	87035	0	243670	19059056		
33267	2757	1713671	2014-09-27	2014-09-27 00:00:00	2014-10-18	2014-10-18 00:00:00	2014-10-18	38000177		0	0	21		0	0	0	182349	0	562251	1713671		
201172	4418	40213160	1955-07-01	1955-07-01 00:00:00	1955-07-01	1955-07-01 00:00:00	1955-07-01	581452		0	0	0		0	0	0	293757	0	10	40213160		
19296	1593	19059056	1938-02-11	1938-02-11 00:00:00	1938-02-25	1938-02-25 00:00:00	1938-02-25	38000177		0	0	14		0	0	0	106867	0	243670	19059056		
18760	1550	40169281	1999-10-23	1999-10-23 00:00:00	1999-10-23	1999-10-23 00:00:00	\N	38000177		0	0	0		0	0	0	103787	0	896209	40169281		
176226	3874	40213160	1982-06-02	1982-06-02 00:00:00	1982-06-02	1982-06-02 00:00:00	1982-06-02	581452		0	0	0		0	0	0	257230	0	10	40213160		
43965	3641	1118084	1957-12-10	1957-12-10 00:00:00	1957-12-10	1957-12-10 00:00:00	\N	38000177		0	0	0		0	0	0	242246	0	00025152531	44923712		
168667	3708	40213160	1977-10-21	1977-10-21 00:00:00	1977-10-21	1977-10-21 00:00:00	1977-10-21	581452		0	0	0		0	0	0	246515	0	10	40213160		
238508	5236	40213296	2013-03-20	2013-03-20 00:00:00	2013-03-20	2013-03-20 00:00:00	2013-03-20	581452		0	0	0		0	0	0	348390	0	52	40213296		
85079	1861	40213227	2004-01-31	2004-01-31 00:00:00	2004-01-31	2004-01-31 00:00:00	2004-01-31	581452		0	0	0		0	0	0	124448	0	113	40213227		
2742	220	1127433	1998-06-15	1998-06-15 00:00:00	1998-06-29	1998-06-29 00:00:00	1998-06-29	38000177		0	0	14		0	0	0	14814	0	313782	1127433		
227625	4998	40213260	2016-04-01	2016-04-01 00:00:00	2016-04-01	2016-04-01 00:00:00	2016-04-01	581452		0	0	0		0	0	0	332354	0	121	40213260		
49342	4092	46233988	1976-11-18	1976-11-18 00:00:00	1976-12-02	1976-12-02 00:00:00	1976-12-02	38000177		0	0	14		0	0	0	272023	0	1652673	46233988		
61237	5095	1127433	1978-03-09	1978-03-09 00:00:00	1978-04-06	1978-04-06 00:00:00	1978-04-06	38000177		0	0	28		0	0	0	338497	0	313782	1127433		
30446	2524	1118084	1987-03-26	1987-03-26 00:00:00	1987-03-26	1987-03-26 00:00:00	\N	38000177		0	0	0		0	0	0	166928	0	00025152531	44923712		
16293	1352	1713671	1976-10-03	1976-10-03 00:00:00	1976-10-24	1976-10-24 00:00:00	1976-10-24	38000177		0	0	21		0	0	0	89537	0	562251	1713671		
23938	1971	1127433	1997-09-06	1997-09-06 00:00:00	1997-09-20	1997-09-20 00:00:00	1997-09-20	38000177		0	0	14		0	0	0	131112	0	313782	1127433		
61053	1334	40213160	1969-11-02	1969-11-02 00:00:00	1969-11-02	1969-11-02 00:00:00	1969-11-02	581452		0	0	0		0	0	0	88497	0	10	40213160		
69142	1512	40213160	1974-11-20	1974-11-20 00:00:00	1974-11-20	1974-11-20 00:00:00	1974-11-20	581452		0	0	0		0	0	0	100967	0	10	40213160		
24043	1977	19075601	1997-03-06	1997-03-06 00:00:00	1997-03-06	1997-03-06 00:00:00	\N	38000177		0	0	0		0	0	0	131564	0	309362	19075601		
23850	1962	1127433	2005-03-28	2005-03-28 00:00:00	2005-05-27	2005-05-27 00:00:00	2005-05-27	38000177		0	0	60		0	0	0	130481	0	313782	1127433		
34366	2839	19075001	1987-08-16	1987-08-16 00:00:00	1987-08-30	1987-08-30 00:00:00	1987-08-30	38000177		0	0	14		0	0	0	188526	0	309097	19075001		
16645	1379	1127078	1962-10-30	1962-10-30 00:00:00	1962-11-29	1962-11-29 00:00:00	1962-11-29	38000177		0	0	30		0	0	0	91509	0	282464	1127078		
233803	5138	40213306	2000-03-17	2000-03-17 00:00:00	2000-03-17	2000-03-17 00:00:00	2000-03-17	581452		0	0	0		0	0	0	341467	0	43	40213306		
42352	3513	1127433	1985-02-09	1985-02-09 00:00:00	1985-02-23	1985-02-23 00:00:00	1985-02-23	38000177		0	0	14		0	0	0	233117	0	313782	1127433		
191524	4208	40213227	2000-02-22	2000-02-22 00:00:00	2000-02-22	2000-02-22 00:00:00	2000-02-22	581452		0	0	0		0	0	0	279371	0	113	40213227		
130974	2878	40213251	1984-01-29	1984-01-29 00:00:00	1984-01-29	1984-01-29 00:00:00	1984-01-29	581452		0	0	0		0	0	0	191457	0	21	40213251		
149780	3294	40213227	2000-10-24	2000-10-24 00:00:00	2000-10-24	2000-10-24 00:00:00	2000-10-24	581452		0	0	0		0	0	0	218788	0	113	40213227		
69412	1518	40213227	2004-07-16	2004-07-16 00:00:00	2004-07-16	2004-07-16 00:00:00	2004-07-16	581452		0	0	0		0	0	0	101568	0	113	40213227		
207371	4550	40213160	1967-08-20	1967-08-20 00:00:00	1967-08-20	1967-08-20 00:00:00	1967-08-20	581452		0	0	0		0	0	0	303239	0	10	40213160		
132127	2903	40213227	2005-12-04	2005-12-04 00:00:00	2005-12-04	2005-12-04 00:00:00	2005-12-04	581452		0	0	0		0	0	0	193457	0	113	40213227		
18690	406	40213160	1956-01-24	1956-01-24 00:00:00	1956-01-24	1956-01-24 00:00:00	1956-01-24	581452		0	0	0		0	0	0	26730	0	10	40213160		
38861	3212	19128022	1999-07-04	1999-07-04 00:00:00	2000-06-28	2000-06-28 00:00:00	2000-06-28	38000177		0	0	360		0	0	0	213433	0	749785	19128022		
15659	337	40213296	1999-09-29	1999-09-29 00:00:00	1999-09-29	1999-09-29 00:00:00	1999-09-29	581452		0	0	0		0	0	0	22466	0	52	40213296		
73137	1598	40213227	1999-06-07	1999-06-07 00:00:00	1999-06-07	1999-06-07 00:00:00	1999-06-07	581452		0	0	0		0	0	0	107235	0	113	40213227		
13758	297	40213160	1955-05-22	1955-05-22 00:00:00	1955-05-22	1955-05-22 00:00:00	1955-05-22	581452		0	0	0		0	0	0	19803	0	10	40213160		
113825	2501	40213296	2001-12-03	2001-12-03 00:00:00	2001-12-03	2001-12-03 00:00:00	2001-12-03	581452		0	0	0		0	0	0	165570	0	52	40213296		
49545	4109	19134077	2018-08-29	2018-08-29 00:00:00	2018-09-19	2018-09-19 00:00:00	2018-09-19	38000177		0	0	21		0	0	0	273084	0	835900	19134077		
112095	2462	40213260	2012-10-14	2012-10-14 00:00:00	2012-10-14	2012-10-14 00:00:00	2012-10-14	581452		0	0	0		0	0	0	163213	0	121	40213260		
49758	4127	1127433	2005-09-27	2005-09-27 00:00:00	2005-10-11	2005-10-11 00:00:00	2005-10-11	38000177		0	0	14		0	0	0	274346	0	313782	1127433		
88644	1945	40213160	1975-11-08	1975-11-08 00:00:00	1975-11-08	1975-11-08 00:00:00	1975-11-08	581452		0	0	0		0	0	0	129250	0	10	40213160		
208599	4576	40213260	2007-07-25	2007-07-25 00:00:00	2007-07-25	2007-07-25 00:00:00	2007-07-25	581452		0	0	0		0	0	0	304840	0	121	40213260		
196611	4320	40213227	1992-03-29	1992-03-29 00:00:00	1992-03-29	1992-03-29 00:00:00	1992-03-29	581452		0	0	0		0	0	0	286649	0	113	40213227		
151005	3321	40213306	1999-03-29	1999-03-29 00:00:00	1999-03-29	1999-03-29 00:00:00	1999-03-29	581452		0	0	0		0	0	0	220550	0	43	40213306		
186299	4092	40213160	1974-02-14	1974-02-14 00:00:00	1974-02-14	1974-02-14 00:00:00	1974-02-14	581452		0	0	0		0	0	0	272037	0	10	40213160		
7388	616	19059056	1959-11-29	1959-11-29 00:00:00	1960-02-27	1960-02-27 00:00:00	1960-02-27	38000177		0	0	90		0	0	0	41085	0	243670	19059056		
63938	5312	19059056	1943-05-22	1943-05-22 00:00:00	1943-06-05	1943-06-05 00:00:00	1943-06-05	38000177		0	0	14		0	0	0	353297	0	243670	19059056		
56216	4666	19128022	1993-05-24	1993-05-24 00:00:00	1994-05-19	1994-05-19 00:00:00	1994-05-19	38000177		0	0	360		0	0	0	310935	0	749785	19128022		
53736	4467	1713671	1989-10-04	1989-10-04 00:00:00	1989-10-25	1989-10-25 00:00:00	1989-10-25	38000177		0	0	21		0	0	0	297213	0	562251	1713671		
167290	3678	40213227	2008-07-07	2008-07-07 00:00:00	2008-07-07	2008-07-07 00:00:00	2008-07-07	581452		0	0	0		0	0	0	244599	0	113	40213227		
31535	2615	1127433	1993-01-28	1993-01-28 00:00:00	1993-02-11	1993-02-11 00:00:00	1993-02-11	38000177		0	0	14		0	0	0	172929	0	313782	1127433		
122996	2704	40213160	1972-01-22	1972-01-22 00:00:00	1972-01-22	1972-01-22 00:00:00	1972-01-22	581452		0	0	0		0	0	0	179120	0	10	40213160		
209379	4591	40213160	1957-08-29	1957-08-29 00:00:00	1957-08-29	1957-08-29 00:00:00	1957-08-29	581452		0	0	0		0	0	0	305913	0	10	40213160		
16171	1340	19078461	2014-04-29	2014-04-29 00:00:00	2014-05-29	2014-05-29 00:00:00	2014-05-29	38000177		0	0	30		0	0	0	88841	0	310965	19078461		
182666	4014	40213160	1968-05-05	1968-05-05 00:00:00	1968-05-05	1968-05-05 00:00:00	1968-05-05	581452		0	0	0		0	0	0	266712	0	10	40213160		
56056	1228	40213160	1974-12-14	1974-12-14 00:00:00	1974-12-14	1974-12-14 00:00:00	1974-12-14	581452		0	0	0		0	0	0	80885	0	10	40213160		
159365	3508	40213296	1998-04-01	1998-04-01 00:00:00	1998-04-01	1998-04-01 00:00:00	1998-04-01	581452		0	0	0		0	0	0	232669	0	52	40213296		
87726	1924	40213227	1994-04-01	1994-04-01 00:00:00	1994-04-01	1994-04-01 00:00:00	1994-04-01	581452		0	0	0		0	0	0	128048	0	113	40213227		
36801	3040	1713671	1972-10-27	1972-10-27 00:00:00	1972-11-03	1972-11-03 00:00:00	1972-11-03	38000177		0	0	7		0	0	0	202399	0	562251	1713671		
134268	2947	40213227	2005-09-14	2005-09-14 00:00:00	2005-09-14	2005-09-14 00:00:00	2005-09-14	581452		0	0	0		0	0	0	196694	0	113	40213227		
71212	1558	40213260	2006-03-02	2006-03-02 00:00:00	2006-03-02	2006-03-02 00:00:00	2006-03-02	581452		0	0	0		0	0	0	104366	0	121	40213260		
121096	2661	40213296	2006-09-22	2006-09-22 00:00:00	2006-09-22	2006-09-22 00:00:00	2006-09-22	581452		0	0	0		0	0	0	176344	0	52	40213296		
37469	3096	40231925	2011-01-14	2011-01-14 00:00:00	2011-01-14	2011-01-14 00:00:00	\N	38000177		0	0	0		0	0	0	206078	0	1049221	40231925		
23072	1903	1127433	1995-09-14	1995-09-14 00:00:00	1995-09-28	1995-09-28 00:00:00	1995-09-28	38000177		0	0	14		0	0	0	126657	0	313782	1127433		
15784	1314	1127433	1977-07-01	1977-07-01 00:00:00	1977-07-15	1977-07-15 00:00:00	1977-07-15	38000177		0	0	14		0	0	0	87008	0	313782	1127433		
33268	2757	40220960	2017-01-20	2017-01-20 00:00:00	2017-01-20	2017-01-20 00:00:00	2017-01-20	38000177		0	0	0		0	0	0	182378	0	1804799	40220960		
39534	863	40213227	2003-06-05	2003-06-05 00:00:00	2003-06-05	2003-06-05 00:00:00	2003-06-05	581452		0	0	0		0	0	0	57188	0	113	40213227		
19297	1593	19059056	1944-01-09	1944-01-09 00:00:00	1944-01-23	1944-01-23 00:00:00	1944-01-23	38000177		0	0	14		0	0	0	106901	0	243670	19059056		
18762	1550	1127433	2007-12-03	2007-12-03 00:00:00	2007-12-17	2007-12-17 00:00:00	2007-12-17	38000177		0	0	14		0	0	0	103751	0	313782	1127433		
176233	3875	40213260	2008-09-27	2008-09-27 00:00:00	2008-09-27	2008-09-27 00:00:00	2008-09-27	581452		0	0	0		0	0	0	257409	0	121	40213260		
43966	3641	19133905	1978-02-07	1978-02-07 00:00:00	1978-02-14	1978-02-14 00:00:00	1978-02-14	38000177		0	0	7		0	0	0	242338	0	834102	19133905		
168668	3708	40213314	1977-10-21	1977-10-21 00:00:00	1977-10-21	1977-10-21 00:00:00	1977-10-21	581452		0	0	0		0	0	0	246515	0	49	40213314		
238511	5236	40213160	1971-08-18	1971-08-18 00:00:00	1971-08-18	1971-08-18 00:00:00	1971-08-18	581452		0	0	0		0	0	0	348409	0	10	40213160		
105609	2318	40213227	2005-02-05	2005-02-05 00:00:00	2005-02-05	2005-02-05 00:00:00	2005-02-05	581452		0	0	0		0	0	0	154101	0	113	40213227		
2743	220	1127078	1991-12-04	1991-12-04 00:00:00	1991-12-25	1991-12-25 00:00:00	1991-12-25	38000177		0	0	21		0	0	0	14837	0	282464	1127078		
226599	4975	40213260	2009-07-16	2009-07-16 00:00:00	2009-07-16	2009-07-16 00:00:00	2009-07-16	581452		0	0	0		0	0	0	330865	0	121	40213260		
49343	4092	19128065	1988-05-29	1988-05-29 00:00:00	1989-05-24	1989-05-24 00:00:00	1989-05-24	38000177		0	0	360		0	0	0	272050	0	749882	19128065		
61238	5095	19006318	1978-03-09	1978-03-09 00:00:00	1978-04-06	1978-04-06 00:00:00	1978-04-06	38000177		0	0	28		0	0	0	338497	0	105078	19006318		
30447	2524	1713671	1975-12-20	1975-12-20 00:00:00	1976-01-10	1976-01-10 00:00:00	1976-01-10	38000177		0	0	21		0	0	0	166902	0	562251	1713671		
16294	1352	1127433	1959-12-07	1959-12-07 00:00:00	1959-12-14	1959-12-14 00:00:00	1959-12-14	38000177		0	0	7		0	0	0	89590	0	313782	1127433		
23939	1971	920334	1993-04-15	1993-04-15 00:00:00	1993-04-22	1993-04-22 00:00:00	1993-04-22	38000177		0	0	7		0	0	0	130997	0	311995	920334		
61060	1334	40213160	1969-08-03	1969-08-03 00:00:00	1969-08-03	1969-08-03 00:00:00	1969-08-03	581452		0	0	0		0	0	0	88511	0	10	40213160		
69143	1513	40213296	2009-07-19	2009-07-19 00:00:00	2009-07-19	2009-07-19 00:00:00	2009-07-19	581452		0	0	0		0	0	0	101124	0	52	40213296		
24044	1977	1127433	1931-01-29	1931-01-29 00:00:00	1931-02-12	1931-02-12 00:00:00	1931-02-12	38000177		0	0	14		0	0	0	131506	0	313782	1127433		
23854	1964	1118084	2000-08-10	2000-08-10 00:00:00	2000-08-10	2000-08-10 00:00:00	\N	38000177		0	0	0		0	0	0	130595	0	00025152531	44923712		
34367	2839	19128065	1988-02-07	1988-02-07 00:00:00	1989-02-01	1989-02-01 00:00:00	1989-02-01	38000177		0	0	360		0	0	0	188563	0	749882	19128065		
16646	1379	40229134	2001-02-03	2001-02-03 00:00:00	2001-02-17	2001-02-17 00:00:00	2001-02-17	38000177		0	0	14		0	0	0	91459	0	1043400	40229134		
233808	5138	40213314	1978-03-10	1978-03-10 00:00:00	1978-03-10	1978-03-10 00:00:00	1978-03-10	581452		0	0	0		0	0	0	341493	0	49	40213314		
42353	3513	1127433	2016-07-08	2016-07-08 00:00:00	2016-07-29	2016-07-29 00:00:00	2016-07-29	38000177		0	0	21		0	0	0	233120	0	313782	1127433		
191530	4208	40213227	1992-12-15	1992-12-15 00:00:00	1992-12-15	1992-12-15 00:00:00	1992-12-15	581452		0	0	0		0	0	0	279457	0	113	40213227		
242781	5329	40213227	1994-09-28	1994-09-28 00:00:00	1994-09-28	1994-09-28 00:00:00	1994-09-28	581452		0	0	0		0	0	0	354771	0	113	40213227		
149796	3294	40213227	2011-10-04	2011-10-04 00:00:00	2011-10-04	2011-10-04 00:00:00	2011-10-04	581452		0	0	0		0	0	0	218793	0	113	40213227		
140581	3087	40213227	1992-07-22	1992-07-22 00:00:00	1992-07-22	1992-07-22 00:00:00	1992-07-22	581452		0	0	0		0	0	0	205581	0	113	40213227		
207373	4550	40213227	1993-11-21	1993-11-21 00:00:00	1993-11-21	1993-11-21 00:00:00	1993-11-21	581452		0	0	0		0	0	0	303183	0	113	40213227		
132128	2903	40213296	2005-12-04	2005-12-04 00:00:00	2005-12-04	2005-12-04 00:00:00	2005-12-04	581452		0	0	0		0	0	0	193457	0	52	40213296		
18691	406	40213160	1957-01-29	1957-01-29 00:00:00	1957-01-29	1957-01-29 00:00:00	1957-01-29	581452		0	0	0		0	0	0	26860	0	10	40213160		
38862	3212	40229134	1991-09-30	1991-09-30 00:00:00	1991-10-14	1991-10-14 00:00:00	1991-10-14	38000177		0	0	14		0	0	0	213401	0	1043400	40229134		
15667	337	40213160	1964-09-02	1964-09-02 00:00:00	1964-09-02	1964-09-02 00:00:00	1964-09-02	581452		0	0	0		0	0	0	22406	0	10	40213160		
73138	1598	40213296	1999-06-07	1999-06-07 00:00:00	1999-06-07	1999-06-07 00:00:00	1999-06-07	581452		0	0	0		0	0	0	107235	0	52	40213296		
172701	3796	40213260	2017-11-14	2017-11-14 00:00:00	2017-11-14	2017-11-14 00:00:00	2017-11-14	581452		0	0	0		0	0	0	252363	0	121	40213260		
113829	2501	40213306	1984-01-30	1984-01-30 00:00:00	1984-01-30	1984-01-30 00:00:00	1984-01-30	581452		0	0	0		0	0	0	165568	0	43	40213306		
49546	4109	1713671	1966-10-01	1966-10-01 00:00:00	1966-10-15	1966-10-15 00:00:00	1966-10-15	38000177		0	0	14		0	0	0	273126	0	562251	1713671		
112101	2463	40213160	1969-07-17	1969-07-17 00:00:00	1969-07-17	1969-07-17 00:00:00	1969-07-17	581452		0	0	0		0	0	0	163355	0	10	40213160		
49759	4127	1124300	1988-02-04	1988-02-04 00:00:00	1988-02-04	1988-02-04 00:00:00	\N	38000177		0	0	0		0	0	0	274386	0	00781178901	45011828		
88653	1945	40213160	1971-08-08	1971-08-08 00:00:00	1971-08-08	1971-08-08 00:00:00	1971-08-08	581452		0	0	0		0	0	0	129246	0	10	40213160		
208601	4576	40213160	1955-07-06	1955-07-06 00:00:00	1955-07-06	1955-07-06 00:00:00	1955-07-06	581452		0	0	0		0	0	0	304804	0	10	40213160		
196612	4320	40213306	1992-03-29	1992-03-29 00:00:00	1992-03-29	1992-03-29 00:00:00	1992-03-29	581452		0	0	0		0	0	0	286649	0	43	40213306		
151012	3321	40213296	2017-01-30	2017-01-30 00:00:00	2017-01-30	2017-01-30 00:00:00	2017-01-30	581452		0	0	0		0	0	0	220538	0	52	40213296		
151016	3321	40213160	1977-10-03	1977-10-03 00:00:00	1977-10-03	1977-10-03 00:00:00	1977-10-03	581452		0	0	0		0	0	0	220515	0	10	40213160		
3465	287	1713671	2018-05-15	2018-05-15 00:00:00	2018-05-29	2018-05-29 00:00:00	2018-05-29	38000177		0	0	14		0	0	0	19192	0	562251	1713671		
63939	5312	1713671	1944-07-07	1944-07-07 00:00:00	1944-07-14	1944-07-14 00:00:00	1944-07-14	38000177		0	0	7		0	0	0	353281	0	562251	1713671		
56217	4666	1127433	1984-03-03	1984-03-03 00:00:00	1984-03-10	1984-03-10 00:00:00	1984-03-10	38000177		0	0	7		0	0	0	310948	0	313782	1127433		
53751	4470	1127433	2003-02-15	2003-02-15 00:00:00	2003-03-01	2003-03-01 00:00:00	2003-03-01	38000177		0	0	14		0	0	0	297381	0	313782	1127433		
167292	3678	40213306	1999-06-28	1999-06-28 00:00:00	1999-06-28	1999-06-28 00:00:00	1999-06-28	581452		0	0	0		0	0	0	244617	0	43	40213306		
31536	2615	40165015	1987-05-11	1987-05-11 00:00:00	1987-05-11	1987-05-11 00:00:00	\N	38000177		0	0	0		0	0	0	172938	0	861467	40165015		
188394	4137	40213227	1992-04-22	1992-04-22 00:00:00	1992-04-22	1992-04-22 00:00:00	1992-04-22	581452		0	0	0		0	0	0	275028	0	113	40213227		
128671	2830	40213160	1974-11-18	1974-11-18 00:00:00	1974-11-18	1974-11-18 00:00:00	1974-11-18	581452		0	0	0		0	0	0	187775	0	10	40213160		
16172	1340	1713671	1914-10-31	1914-10-31 00:00:00	1914-11-14	1914-11-14 00:00:00	1914-11-14	38000177		0	0	14		0	0	0	88933	0	562251	1713671		
182675	4014	40213296	2007-12-02	2007-12-02 00:00:00	2007-12-02	2007-12-02 00:00:00	2007-12-02	581452		0	0	0		0	0	0	266758	0	52	40213296		
56057	1228	40213314	1977-12-10	1977-12-10 00:00:00	1977-12-10	1977-12-10 00:00:00	1977-12-10	581452		0	0	0		0	0	0	80888	0	49	40213314		
216329	4748	40213198	2010-03-26	2010-03-26 00:00:00	2010-03-26	2010-03-26 00:00:00	2010-03-26	581452		0	0	0		0	0	0	316176	0	133	40213198		
87727	1924	40213306	1994-04-01	1994-04-01 00:00:00	1994-04-01	1994-04-01 00:00:00	1994-04-01	581452		0	0	0		0	0	0	128048	0	43	40213306		
36802	3040	1713671	1973-08-26	1973-08-26 00:00:00	1973-09-02	1973-09-02 00:00:00	1973-09-02	38000177		0	0	7		0	0	0	202364	0	562251	1713671		
134274	2947	40213314	1977-04-27	1977-04-27 00:00:00	1977-04-27	1977-04-27 00:00:00	1977-04-27	581452		0	0	0		0	0	0	196710	0	49	40213314		
71214	1558	40213227	2006-03-02	2006-03-02 00:00:00	2006-03-02	2006-03-02 00:00:00	2006-03-02	581452		0	0	0		0	0	0	104366	0	113	40213227		
121100	2661	40213160	1964-12-18	1964-12-18 00:00:00	1964-12-18	1964-12-18 00:00:00	1964-12-18	581452		0	0	0		0	0	0	176336	0	10	40213160		
37470	3096	19078461	2011-01-14	2011-01-14 00:00:00	2011-02-13	2011-02-13 00:00:00	2011-02-13	38000177		0	0	30		0	0	0	206078	0	310965	19078461		
23073	1903	19115351	1979-06-26	1979-06-26 00:00:00	1979-09-18	1979-09-18 00:00:00	1979-09-18	38000177		0	0	84		0	0	0	126691	0	563026	19115351		
15785	1314	1118084	1966-08-25	1966-08-25 00:00:00	1966-08-25	1966-08-25 00:00:00	\N	38000177		0	0	0		0	0	0	87047	0	00025152531	44923712		
33269	2757	19075601	2017-01-20	2017-01-20 00:00:00	2017-01-20	2017-01-20 00:00:00	2017-01-20	38000177		0	0	0		0	0	0	182378	0	309362	19075601		
39544	863	40213227	2013-08-01	2013-08-01 00:00:00	2013-08-01	2013-08-01 00:00:00	2013-08-01	581452		0	0	0		0	0	0	57198	0	113	40213227		
19298	1593	19059056	1936-10-30	1936-10-30 00:00:00	1936-11-13	1936-11-13 00:00:00	1936-11-13	38000177		0	0	14		0	0	0	106866	0	243670	19059056		
18763	1550	1713671	2014-11-13	2014-11-13 00:00:00	2014-12-04	2014-12-04 00:00:00	2014-12-04	38000177		0	0	21		0	0	0	103807	0	562251	1713671		
176240	3875	40213260	2009-10-03	2009-10-03 00:00:00	2009-10-03	2009-10-03 00:00:00	2009-10-03	581452		0	0	0		0	0	0	257375	0	121	40213260		
43967	3641	19059056	1947-06-27	1947-06-27 00:00:00	1947-07-18	1947-07-18 00:00:00	1947-07-18	38000177		0	0	21		0	0	0	242312	0	243670	19059056		
205168	4503	40213227	1997-07-15	1997-07-15 00:00:00	1997-07-15	1997-07-15 00:00:00	1997-07-15	581452		0	0	0		0	0	0	299842	0	113	40213227		
238519	5236	40213160	1976-02-18	1976-02-18 00:00:00	1976-02-18	1976-02-18 00:00:00	1976-02-18	581452		0	0	0		0	0	0	348429	0	10	40213160		
105610	2318	40213296	2005-02-05	2005-02-05 00:00:00	2005-02-05	2005-02-05 00:00:00	2005-02-05	581452		0	0	0		0	0	0	154101	0	52	40213296		
2744	220	1127433	1990-01-12	1990-01-12 00:00:00	1990-01-26	1990-01-26 00:00:00	1990-01-26	38000177		0	0	14		0	0	0	14864	0	313782	1127433		
226614	4976	40213227	1994-04-26	1994-04-26 00:00:00	1994-04-26	1994-04-26 00:00:00	1994-04-26	581452		0	0	0		0	0	0	\N	0	113	40213227		
49344	4092	1118084	2015-02-12	2015-02-12 00:00:00	2015-02-12	2015-02-12 00:00:00	\N	38000177		0	0	0		0	0	0	272033	0	00025152531	44923712		
61239	5095	40165015	1978-03-09	1978-03-09 00:00:00	1978-03-09	1978-03-09 00:00:00	\N	38000177		0	0	0		0	0	0	338497	0	861467	40165015		
30448	2524	1127078	1950-08-12	1950-08-12 00:00:00	1950-08-26	1950-08-26 00:00:00	1950-08-26	38000177		0	0	14		0	0	0	166905	0	282464	1127078		
16295	1352	1713671	1983-09-26	1983-09-26 00:00:00	1983-10-10	1983-10-10 00:00:00	1983-10-10	38000177		0	0	14		0	0	0	89592	0	562251	1713671		
23940	1971	1127433	1981-08-08	1981-08-08 00:00:00	1981-08-22	1981-08-22 00:00:00	1981-08-22	38000177		0	0	14		0	0	0	131063	0	313782	1127433		
61067	1334	40213296	2009-03-01	2009-03-01 00:00:00	2009-03-01	2009-03-01 00:00:00	2009-03-01	581452		0	0	0		0	0	0	88517	0	52	40213296		
69145	1513	40213227	2009-07-19	2009-07-19 00:00:00	2009-07-19	2009-07-19 00:00:00	2009-07-19	581452		0	0	0		0	0	0	101124	0	113	40213227		
24045	1977	1118084	1952-04-20	1952-04-20 00:00:00	1952-04-20	1952-04-20 00:00:00	\N	38000177		0	0	0		0	0	0	131476	0	00025152531	44923712		
23855	1964	40229134	2013-08-13	2013-08-13 00:00:00	2013-08-20	2013-08-20 00:00:00	2013-08-20	38000177		0	0	7		0	0	0	130566	0	1043400	40229134		
34368	2839	1127433	2012-11-06	2012-11-06 00:00:00	2012-11-13	2012-11-13 00:00:00	2012-11-13	38000177		0	0	7		0	0	0	188521	0	313782	1127433		
16647	1379	19059056	1968-08-29	1968-08-29 00:00:00	1968-09-19	1968-09-19 00:00:00	1968-09-19	38000177		0	0	21		0	0	0	91510	0	243670	19059056		
233809	5138	40213160	1978-03-10	1978-03-10 00:00:00	1978-03-10	1978-03-10 00:00:00	1978-03-10	581452		0	0	0		0	0	0	341493	0	10	40213160		
42354	3513	1127078	1979-08-10	1979-08-10 00:00:00	1979-10-09	1979-10-09 00:00:00	1979-10-09	38000177		0	0	60		0	0	0	233116	0	282464	1127078		
202813	4452	40213227	2016-08-05	2016-08-05 00:00:00	2016-08-05	2016-08-05 00:00:00	2016-08-05	581452		0	0	0		0	0	0	296329	0	113	40213227		
137601	3020	40213260	2008-01-09	2008-01-09 00:00:00	2008-01-09	2008-01-09 00:00:00	2008-01-09	581452		0	0	0		0	0	0	201408	0	121	40213260		
149816	3295	40213198	2010-04-12	2010-04-12 00:00:00	2010-04-12	2010-04-12 00:00:00	2010-04-12	581452		0	0	0		0	0	0	218908	0	133	40213198		
140611	3087	40213227	1999-11-17	1999-11-17 00:00:00	1999-11-17	1999-11-17 00:00:00	1999-11-17	581452		0	0	0		0	0	0	205550	0	113	40213227		
207376	4550	40213160	1963-05-19	1963-05-19 00:00:00	1963-05-19	1963-05-19 00:00:00	1963-05-19	581452		0	0	0		0	0	0	303273	0	10	40213160		
132132	2903	40213160	1963-12-22	1963-12-22 00:00:00	1963-12-22	1963-12-22 00:00:00	1963-12-22	581452		0	0	0		0	0	0	193444	0	10	40213160		
18696	406	40213227	2003-02-25	2003-02-25 00:00:00	2003-02-25	2003-02-25 00:00:00	2003-02-25	581452		0	0	0		0	0	0	26866	0	113	40213227		
38863	3212	40236824	2016-09-02	2016-09-02 00:00:00	2016-09-09	2016-09-09 00:00:00	2016-09-09	38000177		0	0	7		0	0	0	213450	0	1094107	40236824		
15671	337	40213260	2009-09-23	2009-09-23 00:00:00	2009-09-23	2009-09-23 00:00:00	2009-09-23	581452		0	0	0		0	0	0	22468	0	121	40213260		
4512	97	40213227	2005-06-13	2005-06-13 00:00:00	2005-06-13	2005-06-13 00:00:00	2005-06-13	581452		0	0	0		0	0	0	6638	0	113	40213227		
172703	3796	40213227	1999-06-01	1999-06-01 00:00:00	1999-06-01	1999-06-01 00:00:00	1999-06-01	581452		0	0	0		0	0	0	252406	0	113	40213227		
113833	2501	40213160	1962-08-06	1962-08-06 00:00:00	1962-08-06	1962-08-06 00:00:00	1962-08-06	581452		0	0	0		0	0	0	165543	0	10	40213160		
49547	4109	1118084	2002-02-10	2002-02-10 00:00:00	2002-02-10	2002-02-10 00:00:00	\N	38000177		0	0	0		0	0	0	273191	0	00025152531	44923712		
112106	2463	40213160	1969-12-18	1969-12-18 00:00:00	1969-12-18	1969-12-18 00:00:00	1969-12-18	581452		0	0	0		0	0	0	163356	0	10	40213160		
49760	4127	1127433	1985-08-09	1985-08-09 00:00:00	1985-08-30	1985-08-30 00:00:00	1985-08-30	38000177		0	0	21		0	0	0	274342	0	313782	1127433		
88658	1945	40213160	1971-03-06	1971-03-06 00:00:00	1971-03-06	1971-03-06 00:00:00	1971-03-06	581452		0	0	0		0	0	0	129245	0	10	40213160		
208604	4576	40213227	2006-07-19	2006-07-19 00:00:00	2006-07-19	2006-07-19 00:00:00	2006-07-19	581452		0	0	0		0	0	0	304826	0	113	40213227		
196619	4320	40213160	1970-09-06	1970-09-06 00:00:00	1970-09-06	1970-09-06 00:00:00	1970-09-06	581452		0	0	0		0	0	0	286636	0	10	40213160		
148301	3260	40213227	2011-04-09	2011-04-09 00:00:00	2011-04-09	2011-04-09 00:00:00	2011-04-09	581452		0	0	0		0	0	0	216768	0	113	40213227		
151022	3321	40213160	1977-07-04	1977-07-04 00:00:00	1977-07-04	1977-07-04 00:00:00	1977-07-04	581452		0	0	0		0	0	0	220542	0	10	40213160		
3466	287	1127433	2002-05-07	2002-05-07 00:00:00	2002-05-21	2002-05-21 00:00:00	2002-05-21	38000177		0	0	14		0	0	0	19207	0	313782	1127433		
63940	5312	19059056	1942-09-10	1942-09-10 00:00:00	1942-10-01	1942-10-01 00:00:00	1942-10-01	38000177		0	0	21		0	0	0	353228	0	243670	19059056		
56218	4666	1713671	1993-08-29	1993-08-29 00:00:00	1993-09-19	1993-09-19 00:00:00	1993-09-19	38000177		0	0	21		0	0	0	310932	0	562251	1713671		
53752	4470	1127433	2011-03-29	2011-03-29 00:00:00	2011-04-12	2011-04-12 00:00:00	2011-04-12	38000177		0	0	14		0	0	0	297363	0	313782	1127433		
167293	3678	40213227	1999-06-28	1999-06-28 00:00:00	1999-06-28	1999-06-28 00:00:00	1999-06-28	581452		0	0	0		0	0	0	244617	0	113	40213227		
31537	2615	1118084	1987-01-25	1987-01-25 00:00:00	1987-01-25	1987-01-25 00:00:00	\N	38000177		0	0	0		0	0	0	172928	0	00025152531	44923712		
188406	4137	40213227	2003-02-05	2003-02-05 00:00:00	2003-02-05	2003-02-05 00:00:00	2003-02-05	581452		0	0	0		0	0	0	275042	0	113	40213227		
128678	2830	40213314	1977-07-18	1977-07-18 00:00:00	1977-07-18	1977-07-18 00:00:00	1977-07-18	581452		0	0	0		0	0	0	187712	0	49	40213314		
50001	4149	1127433	1999-06-03	1999-06-03 00:00:00	1999-06-10	1999-06-10 00:00:00	1999-06-10	38000177		0	0	7		0	0	0	275712	0	313782	1127433		
34755	2869	40229134	1970-03-04	1970-03-04 00:00:00	1970-03-11	1970-03-11 00:00:00	1970-03-11	38000177		0	0	7		0	0	0	190889	0	1043400	40229134		
56058	1228	40213306	1996-12-21	1996-12-21 00:00:00	1996-12-21	1996-12-21 00:00:00	1996-12-21	581452		0	0	0		0	0	0	80865	0	43	40213306		
216337	4748	40213227	2006-03-03	2006-03-03 00:00:00	2006-03-03	2006-03-03 00:00:00	2006-03-03	581452		0	0	0		0	0	0	316174	0	113	40213227		
87731	1925	40213227	2006-02-04	2006-02-04 00:00:00	2006-02-04	2006-02-04 00:00:00	2006-02-04	581452		0	0	0		0	0	0	128092	0	113	40213227		
36803	3041	1713671	2017-04-22	2017-04-22 00:00:00	2017-05-13	2017-05-13 00:00:00	2017-05-13	38000177		0	0	21		0	0	0	202509	0	562251	1713671		
169428	3725	40213160	1968-11-14	1968-11-14 00:00:00	1968-11-14	1968-11-14 00:00:00	1968-11-14	581452		0	0	0		0	0	0	247568	0	10	40213160		
71216	1558	40213198	2019-05-16	2019-05-16 00:00:00	2019-05-16	2019-05-16 00:00:00	2019-05-16	581452		0	0	0		0	0	0	104342	0	133	40213198		
121102	2661	40213227	1996-09-06	1996-09-06 00:00:00	1996-09-06	1996-09-06 00:00:00	1996-09-06	581452		0	0	0		0	0	0	176227	0	113	40213227		
37471	3096	19059056	1964-10-17	1964-10-17 00:00:00	1964-10-31	1964-10-31 00:00:00	1964-10-31	38000177		0	0	14		0	0	0	206102	0	243670	19059056		
23074	1903	1713671	2009-10-14	2009-10-14 00:00:00	2009-11-04	2009-11-04 00:00:00	2009-11-04	38000177		0	0	21		0	0	0	126708	0	562251	1713671		
15786	1314	45892894	2018-05-11	2018-05-11 00:00:00	2018-05-11	2018-05-11 00:00:00	\N	38000177		0	0	0		0	0	0	87054	0	1599803	45892894		
33270	2757	19059056	1976-02-15	1976-02-15 00:00:00	1976-04-15	1976-04-15 00:00:00	1976-04-15	38000177		0	0	60		0	0	0	182335	0	243670	19059056		
39546	863	40213201	1988-03-10	1988-03-10 00:00:00	1988-03-10	1988-03-10 00:00:00	1988-03-10	581452		0	0	0		0	0	0	57136	0	33	40213201		
239596	5259	40213227	2009-11-02	2009-11-02 00:00:00	2009-11-02	2009-11-02 00:00:00	2009-11-02	581452		0	0	0		0	0	0	350007	0	113	40213227		
18764	1550	1127433	2015-03-11	2015-03-11 00:00:00	2015-04-15	2015-04-15 00:00:00	2015-04-15	38000177		0	0	35		0	0	0	103774	0	313782	1127433		
176242	3875	40213227	2009-10-03	2009-10-03 00:00:00	2009-10-03	2009-10-03 00:00:00	2009-10-03	581452		0	0	0		0	0	0	257375	0	113	40213227		
43968	3641	19133905	1943-11-18	1943-11-18 00:00:00	1943-11-27	1943-11-27 00:00:00	1943-11-27	38000177		0	0	9		0	0	0	242323	0	834102	19133905		
180259	3961	40213296	2013-02-12	2013-02-12 00:00:00	2013-02-12	2013-02-12 00:00:00	2013-02-12	581452		0	0	0		0	0	0	263347	0	52	40213296		
238524	5236	40213227	1993-05-12	1993-05-12 00:00:00	1993-05-12	1993-05-12 00:00:00	1993-05-12	581452		0	0	0		0	0	0	348387	0	113	40213227		
116929	2570	40213201	2002-03-14	2002-03-14 00:00:00	2002-03-14	2002-03-14 00:00:00	2002-03-14	581452		0	0	0		0	0	0	170221	0	33	40213201		
2745	220	19128065	1997-08-23	1997-08-23 00:00:00	1998-08-18	1998-08-18 00:00:00	1998-08-18	38000177		0	0	360		0	0	0	14810	0	749882	19128065		
237892	5222	40213227	2009-03-12	2009-03-12 00:00:00	2009-03-12	2009-03-12 00:00:00	2009-03-12	581452		0	0	0		0	0	0	347423	0	113	40213227		
49345	4092	19128065	1990-05-19	1990-05-19 00:00:00	1991-05-14	1991-05-14 00:00:00	1991-05-14	38000177		0	0	360		0	0	0	272052	0	749882	19128065		
61240	5095	1713671	1991-08-19	1991-08-19 00:00:00	1991-09-09	1991-09-09 00:00:00	1991-09-09	38000177		0	0	21		0	0	0	338523	0	562251	1713671		
30449	2524	19006318	1950-08-12	1950-08-12 00:00:00	1950-08-26	1950-08-26 00:00:00	1950-08-26	38000177		0	0	14		0	0	0	166905	0	105078	19006318		
16296	1352	1127433	1959-08-12	1959-08-12 00:00:00	1959-08-19	1959-08-19 00:00:00	1959-08-19	38000177		0	0	7		0	0	0	89534	0	313782	1127433		
23941	1971	920300	1996-06-01	1996-06-01 00:00:00	1996-06-08	1996-06-08 00:00:00	1996-06-08	38000177		0	0	7		0	0	0	131003	0	311989	920300		
61070	1334	40213160	1974-02-03	1974-02-03 00:00:00	1974-02-03	1974-02-03 00:00:00	1974-02-03	581452		0	0	0		0	0	0	88489	0	10	40213160		
5101	426	1118084	2011-01-22	2011-01-22 00:00:00	2011-01-22	2011-01-22 00:00:00	\N	38000177		0	0	0		0	0	0	28273	0	00025152531	44923712		
24059	1980	1127433	1972-10-12	1972-10-12 00:00:00	1972-10-19	1972-10-19 00:00:00	1972-10-19	38000177		0	0	7		0	0	0	131849	0	313782	1127433		
23856	1964	1127433	1997-08-22	1997-08-22 00:00:00	1997-09-05	1997-09-05 00:00:00	1997-09-05	38000177		0	0	14		0	0	0	130564	0	313782	1127433		
34369	2839	1118084	2006-08-06	2006-08-06 00:00:00	2006-08-06	2006-08-06 00:00:00	\N	38000177		0	0	0		0	0	0	188559	0	00025152531	44923712		
16648	1379	19073188	1979-04-04	1979-04-04 00:00:00	1979-04-18	1979-04-18 00:00:00	1979-04-18	38000177		0	0	14		0	0	0	91498	0	308192	19073188		
233813	5138	40213160	1978-08-11	1978-08-11 00:00:00	1978-08-11	1978-08-11 00:00:00	1978-08-11	581452		0	0	0		0	0	0	341494	0	10	40213160		
42355	3513	1115171	2007-02-12	2007-02-12 00:00:00	2007-02-26	2007-02-26 00:00:00	2007-02-26	38000177		0	0	14		0	0	0	233119	0	849574	1115171		
59788	1309	40213160	1955-12-06	1955-12-06 00:00:00	1955-12-06	1955-12-06 00:00:00	1955-12-06	581452		0	0	0		0	0	0	86528	0	10	40213160		
137603	3020	40213227	2008-01-09	2008-01-09 00:00:00	2008-01-09	2008-01-09 00:00:00	2008-01-09	581452		0	0	0		0	0	0	201408	0	113	40213227		
149821	3295	40213227	2014-05-05	2014-05-05 00:00:00	2014-05-05	2014-05-05 00:00:00	2014-05-05	581452		0	0	0		0	0	0	218910	0	113	40213227		
140613	3087	40213227	2010-01-13	2010-01-13 00:00:00	2010-01-13	2010-01-13 00:00:00	2010-01-13	581452		0	0	0		0	0	0	205547	0	113	40213227		
5282	115	40213160	1960-07-10	1960-07-10 00:00:00	1960-07-10	1960-07-10 00:00:00	1960-07-10	581452		0	0	0		0	0	0	7580	0	10	40213160		
132136	2903	40213160	1964-02-23	1964-02-23 00:00:00	1964-02-23	1964-02-23 00:00:00	1964-02-23	581452		0	0	0		0	0	0	193472	0	10	40213160		
18702	406	40213296	1996-03-05	1996-03-05 00:00:00	1996-03-05	1996-03-05 00:00:00	1996-03-05	581452		0	0	0		0	0	0	26865	0	52	40213296		
38864	3212	1118084	2018-05-10	2018-05-10 00:00:00	2018-05-10	2018-05-10 00:00:00	\N	38000177		0	0	0		0	0	0	213450	0	00025152531	44923712		
15678	338	40213260	2017-04-19	2017-04-19 00:00:00	2017-04-19	2017-04-19 00:00:00	2017-04-19	581452		0	0	0		0	0	0	22519	0	121	40213260		
4526	97	40213227	2014-08-04	2014-08-04 00:00:00	2014-08-04	2014-08-04 00:00:00	2014-08-04	581452		0	0	0		0	0	0	6632	0	113	40213227		
172710	3796	40213160	1972-10-24	1972-10-24 00:00:00	1972-10-24	1972-10-24 00:00:00	1972-10-24	581452		0	0	0		0	0	0	252385	0	10	40213160		
113839	2501	40213160	1962-05-07	1962-05-07 00:00:00	1962-05-07	1962-05-07 00:00:00	1962-05-07	581452		0	0	0		0	0	0	165535	0	10	40213160		
215898	4735	40213160	1973-06-14	1973-06-14 00:00:00	1973-06-14	1973-06-14 00:00:00	1973-06-14	581452		0	0	0		0	0	0	315417	0	10	40213160		
112112	2463	40213260	2019-04-11	2019-04-11 00:00:00	2019-04-11	2019-04-11 00:00:00	2019-04-11	581452		0	0	0		0	0	0	163381	0	121	40213260		
49768	4129	19059056	1988-08-24	1988-08-24 00:00:00	1988-10-23	1988-10-23 00:00:00	1988-10-23	38000177		0	0	60		0	0	0	274462	0	243670	19059056		
88661	1945	40213296	2014-11-08	2014-11-08 00:00:00	2014-11-08	2014-11-08 00:00:00	2014-11-08	581452		0	0	0		0	0	0	129228	0	52	40213296		
208605	4576	40213260	2006-07-19	2006-07-19 00:00:00	2006-07-19	2006-07-19 00:00:00	2006-07-19	581452		0	0	0		0	0	0	304826	0	121	40213260		
88720	1946	40213227	1997-10-04	1997-10-04 00:00:00	1997-10-04	1997-10-04 00:00:00	1997-10-04	581452		0	0	0		0	0	0	129379	0	113	40213227		
148302	3260	40213260	2011-04-09	2011-04-09 00:00:00	2011-04-09	2011-04-09 00:00:00	2011-04-09	581452		0	0	0		0	0	0	216768	0	121	40213260		
151023	3321	40213314	1977-07-04	1977-07-04 00:00:00	1977-07-04	1977-07-04 00:00:00	1977-07-04	581452		0	0	0		0	0	0	220542	0	49	40213314		
3467	287	19133873	1978-01-04	1978-01-04 00:00:00	1978-01-17	1978-01-17 00:00:00	1978-01-17	38000177		0	0	13		0	0	0	19177	0	834061	19133873		
63941	5312	40229134	1998-12-04	1998-12-04 00:00:00	1998-12-18	1998-12-18 00:00:00	1998-12-18	38000177		0	0	14		0	0	0	353294	0	1043400	40229134		
56220	4666	1115171	2016-09-29	2016-09-29 00:00:00	2016-10-20	2016-10-20 00:00:00	2016-10-20	38000177		0	0	21		0	0	0	310946	0	849574	1115171		
53753	4470	1127433	2017-08-09	2017-08-09 00:00:00	2017-08-16	2017-08-16 00:00:00	2017-08-16	38000177		0	0	7		0	0	0	297393	0	313782	1127433		
167302	3678	40213314	1977-05-02	1977-05-02 00:00:00	1977-05-02	1977-05-02 00:00:00	1977-05-02	581452		0	0	0		0	0	0	244585	0	49	40213314		
31538	2615	40229134	1979-12-29	1979-12-29 00:00:00	1980-01-05	1980-01-05 00:00:00	1980-01-05	38000177		0	0	7		0	0	0	172896	0	1043400	40229134		
188408	4137	40213296	2003-02-05	2003-02-05 00:00:00	2003-02-05	2003-02-05 00:00:00	2003-02-05	581452		0	0	0		0	0	0	275042	0	52	40213296		
128682	2830	40213160	1975-04-21	1975-04-21 00:00:00	1975-04-21	1975-04-21 00:00:00	1975-04-21	581452		0	0	0		0	0	0	187776	0	10	40213160		
50002	4149	19078461	2006-04-26	2006-04-26 00:00:00	2006-05-10	2006-05-10 00:00:00	2006-05-10	38000177		0	0	14		0	0	0	275760	0	310965	19078461		
34756	2869	1124300	1989-02-06	1989-02-06 00:00:00	1989-02-06	1989-02-06 00:00:00	\N	38000177		0	0	0		0	0	0	190854	0	00781178901	45011828		
56060	1228	40213227	1996-12-21	1996-12-21 00:00:00	1996-12-21	1996-12-21 00:00:00	1996-12-21	581452		0	0	0		0	0	0	80865	0	113	40213227		
91868	2016	40213251	1985-11-19	1985-11-19 00:00:00	1985-11-19	1985-11-19 00:00:00	1985-11-19	581452		0	0	0		0	0	0	134101	0	21	40213251		
87752	1925	40213201	2011-03-05	2011-03-05 00:00:00	2011-03-05	2011-03-05 00:00:00	2011-03-05	581452		0	0	0		0	0	0	128106	0	33	40213201		
36804	3041	1118084	2018-04-12	2018-04-12 00:00:00	2018-04-12	2018-04-12 00:00:00	\N	38000177		0	0	0		0	0	0	202509	0	00025152531	44923712		
169433	3725	40213227	1999-05-20	1999-05-20 00:00:00	1999-05-20	1999-05-20 00:00:00	1999-05-20	581452		0	0	0		0	0	0	247557	0	113	40213227		
71220	1558	40213160	1959-04-09	1959-04-09 00:00:00	1959-04-09	1959-04-09 00:00:00	1959-04-09	581452		0	0	0		0	0	0	104360	0	10	40213160		
121104	2661	40213260	2014-09-12	2014-09-12 00:00:00	2014-09-12	2014-09-12 00:00:00	2014-09-12	581452		0	0	0		0	0	0	176230	0	121	40213260		
37472	3096	19006318	1964-10-17	1964-10-17 00:00:00	1964-10-31	1964-10-31 00:00:00	1964-10-31	38000177		0	0	14		0	0	0	206102	0	105078	19006318		
33533	2776	19075001	1991-07-21	1991-07-21 00:00:00	1991-08-04	1991-08-04 00:00:00	1991-08-04	38000177		0	0	14		0	0	0	183794	0	309097	19075001		
15787	1314	1713671	1952-12-04	1952-12-04 00:00:00	1952-12-18	1952-12-18 00:00:00	1952-12-18	38000177		0	0	14		0	0	0	87017	0	562251	1713671		
33271	2757	1127078	1978-03-06	1978-03-06 00:00:00	1978-06-04	1978-06-04 00:00:00	1978-06-04	38000177		0	0	90		0	0	0	182336	0	282464	1127078		
119763	2633	40213227	1998-10-22	1998-10-22 00:00:00	1998-10-22	1998-10-22 00:00:00	1998-10-22	581452		0	0	0		0	0	0	174214	0	113	40213227		
239597	5259	40213260	2009-11-02	2009-11-02 00:00:00	2009-11-02	2009-11-02 00:00:00	2009-11-02	581452		0	0	0		0	0	0	350007	0	121	40213260		
18765	1550	1127433	1981-02-07	1981-02-07 00:00:00	1981-05-08	1981-05-08 00:00:00	1981-05-08	38000177		0	0	90		0	0	0	103802	0	313782	1127433		
5691	123	40213227	1992-04-22	1992-04-22 00:00:00	1992-04-22	1992-04-22 00:00:00	1992-04-22	581452		0	0	0		0	0	0	8170	0	113	40213227		
43969	3641	19078461	1987-01-03	1987-01-03 00:00:00	1987-01-31	1987-01-31 00:00:00	1987-01-31	38000177		0	0	28		0	0	0	242314	0	310965	19078461		
180261	3961	40213227	1995-04-18	1995-04-18 00:00:00	1995-04-18	1995-04-18 00:00:00	1995-04-18	581452		0	0	0		0	0	0	263381	0	113	40213227		
238525	5236	40213306	1993-05-12	1993-05-12 00:00:00	1993-05-12	1993-05-12 00:00:00	1993-05-12	581452		0	0	0		0	0	0	348387	0	43	40213306		
116931	2570	40213227	2016-12-08	2016-12-08 00:00:00	2016-12-08	2016-12-08 00:00:00	2016-12-08	581452		0	0	0		0	0	0	170190	0	113	40213227		
2746	220	19133873	1997-07-08	1997-07-08 00:00:00	1997-07-16	1997-07-16 00:00:00	1997-07-16	38000177		0	0	8		0	0	0	14855	0	834061	19133873		
237902	5223	40213160	1968-06-29	1968-06-29 00:00:00	1968-06-29	1968-06-29 00:00:00	1968-06-29	581452		0	0	0		0	0	0	347601	0	10	40213160		
49346	4092	19133873	1982-07-08	1982-07-08 00:00:00	1982-07-21	1982-07-21 00:00:00	1982-07-21	38000177		0	0	13		0	0	0	272020	0	834061	19133873		
61241	5095	19059056	1977-01-22	1977-01-22 00:00:00	1977-02-12	1977-02-12 00:00:00	1977-02-12	38000177		0	0	21		0	0	0	338496	0	243670	19059056		
30450	2525	19128022	1989-12-21	1989-12-21 00:00:00	1990-12-16	1990-12-16 00:00:00	1990-12-16	38000177		0	0	360		0	0	0	166933	0	749785	19128022		
16297	1352	1713671	1999-08-10	1999-08-10 00:00:00	1999-08-31	1999-08-31 00:00:00	1999-08-31	38000177		0	0	21		0	0	0	89539	0	562251	1713671		
23942	1971	40236824	1996-06-01	1996-06-01 00:00:00	1996-06-08	1996-06-08 00:00:00	1996-06-08	38000177		0	0	7		0	0	0	131003	0	1094107	40236824		
61073	1334	40213306	1991-04-28	1991-04-28 00:00:00	1991-04-28	1991-04-28 00:00:00	1991-04-28	581452		0	0	0		0	0	0	88503	0	43	40213306		
5102	426	1127078	1966-02-12	1966-02-12 00:00:00	1966-02-26	1966-02-26 00:00:00	1966-02-26	38000177		0	0	14		0	0	0	28279	0	282464	1127078		
24061	1980	1124300	2013-06-22	2013-06-22 00:00:00	2013-06-22	2013-06-22 00:00:00	\N	38000177		0	0	0		0	0	0	131778	0	00781178901	45011828		
23857	1964	1115171	2009-04-25	2009-04-25 00:00:00	2009-05-23	2009-05-23 00:00:00	2009-05-23	38000177		0	0	28		0	0	0	130553	0	849574	1115171		
34372	2841	19059056	1950-04-22	1950-04-22 00:00:00	1950-05-20	1950-05-20 00:00:00	1950-05-20	38000177		0	0	28		0	0	0	188631	0	243670	19059056		
16649	1379	1127433	1979-04-04	1979-04-04 00:00:00	1979-04-18	1979-04-18 00:00:00	1979-04-18	38000177		0	0	14		0	0	0	91498	0	313782	1127433		
233816	5138	40213160	1982-11-12	1982-11-12 00:00:00	1982-11-12	1982-11-12 00:00:00	1982-11-12	581452		0	0	0		0	0	0	341483	0	10	40213160		
42356	3513	1118084	2007-12-01	2007-12-01 00:00:00	2007-12-01	2007-12-01 00:00:00	\N	38000177		0	0	0		0	0	0	233119	0	00025152531	44923712		
59790	1309	40213227	2016-12-13	2016-12-13 00:00:00	2016-12-13	2016-12-13 00:00:00	2016-12-13	581452		0	0	0		0	0	0	86515	0	113	40213227		
137606	3020	40213160	1957-06-12	1957-06-12 00:00:00	1957-06-12	1957-06-12 00:00:00	1957-06-12	581452		0	0	0		0	0	0	201421	0	10	40213160		
242834	5331	40213306	1984-08-15	1984-08-15 00:00:00	1984-08-15	1984-08-15 00:00:00	1984-08-15	581452		0	0	0		0	0	0	354957	0	43	40213306		
140615	3087	40213201	2004-12-15	2004-12-15 00:00:00	2004-12-15	2004-12-15 00:00:00	2004-12-15	581452		0	0	0		0	0	0	205488	0	33	40213201		
5286	115	40213306	1983-11-13	1983-11-13 00:00:00	1983-11-13	1983-11-13 00:00:00	1983-11-13	581452		0	0	0		0	0	0	7588	0	43	40213306		
132138	2903	40213227	1995-04-02	1995-04-02 00:00:00	1995-04-02	1995-04-02 00:00:00	1995-04-02	581452		0	0	0		0	0	0	193478	0	113	40213227		
80788	1766	40213296	1996-05-28	1996-05-28 00:00:00	1996-05-28	1996-05-28 00:00:00	1996-05-28	581452		0	0	0		0	0	0	118143	0	52	40213296		
38865	3212	920300	2016-09-02	2016-09-02 00:00:00	2016-09-09	2016-09-09 00:00:00	2016-09-09	38000177		0	0	7		0	0	0	213450	0	311989	920300		
15682	338	40213306	1990-01-17	1990-01-17 00:00:00	1990-01-17	1990-01-17 00:00:00	1990-01-17	581452		0	0	0		0	0	0	22485	0	43	40213306		
125329	2757	40213227	2004-04-09	2004-04-09 00:00:00	2004-04-09	2004-04-09 00:00:00	2004-04-09	581452		0	0	0		0	0	0	182358	0	113	40213227		
172713	3796	40213160	1968-02-20	1968-02-20 00:00:00	1968-02-20	1968-02-20 00:00:00	1968-02-20	581452		0	0	0		0	0	0	252395	0	10	40213160		
210440	4615	40213260	2006-09-06	2006-09-06 00:00:00	2006-09-06	2006-09-06 00:00:00	2006-09-06	581452		0	0	0		0	0	0	307448	0	121	40213260		
215902	4735	40213160	1977-12-15	1977-12-15 00:00:00	1977-12-15	1977-12-15 00:00:00	1977-12-15	581452		0	0	0		0	0	0	315421	0	10	40213160		
112116	2463	40213296	2011-04-21	2011-04-21 00:00:00	2011-04-21	2011-04-21 00:00:00	2011-04-21	581452		0	0	0		0	0	0	163351	0	52	40213296		
49769	4129	1124300	1983-10-05	1983-10-05 00:00:00	1983-10-05	1983-10-05 00:00:00	\N	38000177		0	0	0		0	0	0	274447	0	00781178901	45011828		
99553	2180	40213296	2018-10-06	2018-10-06 00:00:00	2018-10-06	2018-10-06 00:00:00	2018-10-06	581452		0	0	0		0	0	0	145426	0	52	40213296		
208606	4576	40213160	1959-05-13	1959-05-13 00:00:00	1959-05-13	1959-05-13 00:00:00	1959-05-13	581452		0	0	0		0	0	0	304807	0	10	40213160		
88740	1946	40213227	2017-01-21	2017-01-21 00:00:00	2017-01-21	2017-01-21 00:00:00	2017-01-21	581452		0	0	0		0	0	0	129345	0	113	40213227		
148309	3260	40213160	1965-03-13	1965-03-13 00:00:00	1965-03-13	1965-03-13 00:00:00	1965-03-13	581452		0	0	0		0	0	0	216717	0	10	40213160		
151027	3321	40213314	1978-04-03	1978-04-03 00:00:00	1978-04-03	1978-04-03 00:00:00	1978-04-03	581452		0	0	0		0	0	0	220543	0	49	40213314		
3468	287	1127078	1977-10-06	1977-10-06 00:00:00	1977-10-20	1977-10-20 00:00:00	1977-10-20	38000177		0	0	14		0	0	0	19184	0	282464	1127078		
63942	5312	19059056	1987-06-21	1987-06-21 00:00:00	1987-07-19	1987-07-19 00:00:00	1987-07-19	38000177		0	0	28		0	0	0	353230	0	243670	19059056		
56238	4668	1115171	1998-06-01	1998-06-01 00:00:00	1998-06-15	1998-06-15 00:00:00	1998-06-15	38000177		0	0	14		0	0	0	311087	0	849574	1115171		
53754	4470	1127433	2007-04-24	2007-04-24 00:00:00	2007-05-01	2007-05-01 00:00:00	2007-05-01	38000177		0	0	7		0	0	0	297392	0	313782	1127433		
167303	3678	40213160	1977-05-02	1977-05-02 00:00:00	1977-05-02	1977-05-02 00:00:00	1977-05-02	581452		0	0	0		0	0	0	244585	0	10	40213160		
31539	2615	1713671	2010-02-16	2010-02-16 00:00:00	2010-02-23	2010-02-23 00:00:00	2010-02-23	38000177		0	0	7		0	0	0	172856	0	562251	1713671		
188410	4137	40213306	1983-04-13	1983-04-13 00:00:00	1983-04-13	1983-04-13 00:00:00	1983-04-13	581452		0	0	0		0	0	0	275015	0	43	40213306		
128690	2830	40213160	1979-07-23	1979-07-23 00:00:00	1979-07-23	1979-07-23 00:00:00	1979-07-23	581452		0	0	0		0	0	0	187713	0	10	40213160		
50003	4149	19129655	1966-03-27	1966-03-27 00:00:00	1966-04-10	1966-04-10 00:00:00	1966-04-10	38000177		0	0	14		0	0	0	275747	0	789980	19129655		
34757	2869	19059056	1954-10-24	1954-10-24 00:00:00	1954-12-30	1954-12-30 00:00:00	1954-12-30	38000177		0	0	67		0	0	0	190822	0	243670	19059056		
56062	1228	40213314	1978-06-10	1978-06-10 00:00:00	1978-06-10	1978-06-10 00:00:00	1978-06-10	581452		0	0	0		0	0	0	80907	0	49	40213314		
91871	2016	40213160	1985-11-19	1985-11-19 00:00:00	1985-11-19	1985-11-19 00:00:00	1985-11-19	581452		0	0	0		0	0	0	134101	0	10	40213160		
87767	1925	40213227	1996-07-27	1996-07-27 00:00:00	1996-07-27	1996-07-27 00:00:00	1996-07-27	581452		0	0	0		0	0	0	128102	0	113	40213227		
36805	3041	1551192	2005-08-04	2005-08-04 00:00:00	2005-08-04	2005-08-04 00:00:00	2005-08-04	38000177		0	0	0		0	0	0	202491	0	312617	1551192		
169438	3725	40213306	1990-05-10	1990-05-10 00:00:00	1990-05-10	1990-05-10 00:00:00	1990-05-10	581452		0	0	0		0	0	0	247548	0	43	40213306		
37365	3087	1310034	2001-02-28	2001-02-28 00:00:00	2001-02-28	2001-02-28 00:00:00	2001-02-28	38000177		0	0	0		0	0	0	205557	0	834357	1310034		
121111	2661	40213227	2015-09-18	2015-09-18 00:00:00	2015-09-18	2015-09-18 00:00:00	2015-09-18	581452		0	0	0		0	0	0	176310	0	113	40213227		
37473	3096	1127433	1979-08-30	1979-08-30 00:00:00	1979-11-28	1979-11-28 00:00:00	1979-11-28	38000177		0	0	90		0	0	0	206038	0	313782	1127433		
33534	2776	1713671	2002-11-01	2002-11-01 00:00:00	2002-11-15	2002-11-15 00:00:00	2002-11-15	38000177		0	0	14		0	0	0	183768	0	562251	1713671		
15788	1314	1713671	1953-09-22	1953-09-22 00:00:00	1953-10-13	1953-10-13 00:00:00	1953-10-13	38000177		0	0	21		0	0	0	87018	0	562251	1713671		
33272	2757	19019979	1974-02-27	1974-02-27 00:00:00	1974-03-27	1974-03-27 00:00:00	1974-03-27	38000177		0	0	28		0	0	0	182334	0	198405	19019979		
119776	2633	40213227	2009-01-08	2009-01-08 00:00:00	2009-01-08	2009-01-08 00:00:00	2009-01-08	581452		0	0	0		0	0	0	174216	0	113	40213227		
239602	5259	40213296	1999-09-20	1999-09-20 00:00:00	1999-09-20	1999-09-20 00:00:00	1999-09-20	581452		0	0	0		0	0	0	349951	0	52	40213296		
18766	1550	19133873	1972-05-29	1972-05-29 00:00:00	1972-06-05	1972-06-05 00:00:00	1972-06-05	38000177		0	0	7		0	0	0	103801	0	834061	19133873		
5694	123	40213160	1955-03-23	1955-03-23 00:00:00	1955-03-23	1955-03-23 00:00:00	1955-03-23	581452		0	0	0		0	0	0	8163	0	10	40213160		
43970	3641	1713671	1923-08-27	1923-08-27 00:00:00	1923-09-03	1923-09-03 00:00:00	1923-09-03	38000177		0	0	7		0	0	0	242329	0	562251	1713671		
180262	3961	40213306	1995-04-18	1995-04-18 00:00:00	1995-04-18	1995-04-18 00:00:00	1995-04-18	581452		0	0	0		0	0	0	263381	0	43	40213306		
238532	5236	40213160	1971-11-17	1971-11-17 00:00:00	1971-11-17	1971-11-17 00:00:00	1971-11-17	581452		0	0	0		0	0	0	348440	0	10	40213160		
91711	2013	40213296	1998-03-28	1998-03-28 00:00:00	1998-03-28	1998-03-28 00:00:00	1998-03-28	581452		0	0	0		0	0	0	133970	0	52	40213296		
2749	222	920334	2008-09-30	2008-09-30 00:00:00	2008-10-07	2008-10-07 00:00:00	2008-10-07	38000177		0	0	7		0	0	0	14885	0	311995	920334		
237904	5223	40213160	1968-09-28	1968-09-28 00:00:00	1968-09-28	1968-09-28 00:00:00	1968-09-28	581452		0	0	0		0	0	0	347578	0	10	40213160		
49347	4092	19128022	1992-05-08	1992-05-08 00:00:00	1993-05-03	1993-05-03 00:00:00	1993-05-03	38000177		0	0	360		0	0	0	272008	0	749785	19128022		
61242	5095	1127078	1970-12-04	1970-12-04 00:00:00	1970-12-25	1970-12-25 00:00:00	1970-12-25	38000177		0	0	21		0	0	0	338495	0	282464	1127078		
30451	2525	19019979	1976-01-24	1976-01-24 00:00:00	1976-02-14	1976-02-14 00:00:00	1976-02-14	38000177		0	0	21		0	0	0	166975	0	198405	19019979		
16298	1352	35605858	1976-07-29	1976-07-29 00:00:00	1976-07-29	1976-07-29 00:00:00	1976-07-29	38000177		0	0	0		0	0	0	89606	0	1732136	35605858		
23943	1971	1127433	1984-04-08	1984-04-08 00:00:00	1984-04-22	1984-04-22 00:00:00	1984-04-22	38000177		0	0	14		0	0	0	131064	0	313782	1127433		
61077	1334	40213260	2019-02-24	2019-02-24 00:00:00	2019-02-24	2019-02-24 00:00:00	2019-02-24	581452		0	0	0		0	0	0	88494	0	121	40213260		
5103	426	19006318	1966-02-12	1966-02-12 00:00:00	1966-02-26	1966-02-26 00:00:00	1966-02-26	38000177		0	0	14		0	0	0	28279	0	105078	19006318		
24062	1980	19078461	2014-05-31	2014-05-31 00:00:00	2014-06-14	2014-06-14 00:00:00	2014-06-14	38000177		0	0	14		0	0	0	131809	0	310965	19078461		
23858	1964	1127078	1966-07-05	1966-07-05 00:00:00	1966-08-09	1966-08-09 00:00:00	1966-08-09	38000177		0	0	35		0	0	0	130552	0	282464	1127078		
34373	2841	19006318	1950-04-22	1950-04-22 00:00:00	1950-05-20	1950-05-20 00:00:00	1950-05-20	38000177		0	0	28		0	0	0	188631	0	105078	19006318		
16650	1379	40169281	2000-02-19	2000-02-19 00:00:00	2000-02-19	2000-02-19 00:00:00	\N	38000177		0	0	0		0	0	0	91469	0	896209	40169281		
233819	5138	40213314	1979-02-09	1979-02-09 00:00:00	1979-02-09	1979-02-09 00:00:00	1979-02-09	581452		0	0	0		0	0	0	341480	0	49	40213314		
42357	3513	1713671	2016-04-07	2016-04-07 00:00:00	2016-04-21	2016-04-21 00:00:00	2016-04-21	38000177		0	0	14		0	0	0	233159	0	562251	1713671		
59792	1309	40213227	1997-10-01	1997-10-01 00:00:00	1997-10-01	1997-10-01 00:00:00	1997-10-01	581452		0	0	0		0	0	0	86484	0	113	40213227		
137610	3020	40213260	2007-01-03	2007-01-03 00:00:00	2007-01-03	2007-01-03 00:00:00	2007-01-03	581452		0	0	0		0	0	0	201431	0	121	40213260		
242836	5331	40213160	1964-01-08	1964-01-08 00:00:00	1964-01-08	1964-01-08 00:00:00	1964-01-08	581452		0	0	0		0	0	0	354963	0	10	40213160		
225983	4963	40213227	1995-07-17	1995-07-17 00:00:00	1995-07-17	1995-07-17 00:00:00	1995-07-17	581452		0	0	0		0	0	0	329923	0	113	40213227		
5288	115	40213160	1960-04-10	1960-04-10 00:00:00	1960-04-10	1960-04-10 00:00:00	1960-04-10	581452		0	0	0		0	0	0	7617	0	10	40213160		
132145	2903	40213160	1964-05-24	1964-05-24 00:00:00	1964-05-24	1964-05-24 00:00:00	1964-05-24	581452		0	0	0		0	0	0	193445	0	10	40213160		
80795	1766	40213227	1994-04-26	1994-04-26 00:00:00	1994-04-26	1994-04-26 00:00:00	1994-04-26	581452		0	0	0		0	0	0	118182	0	113	40213227		
38866	3212	19078461	2006-10-25	2006-10-25 00:00:00	2006-11-22	2006-11-22 00:00:00	2006-11-22	38000177		0	0	28		0	0	0	213429	0	310965	19078461		
15684	338	40213160	1967-12-27	1967-12-27 00:00:00	1967-12-27	1967-12-27 00:00:00	1967-12-27	581452		0	0	0		0	0	0	22551	0	10	40213160		
125336	2758	40213201	2006-11-24	2006-11-24 00:00:00	2006-11-24	2006-11-24 00:00:00	2006-11-24	581452		0	0	0		0	0	0	182430	0	33	40213201		
172717	3796	40213296	2009-11-24	2009-11-24 00:00:00	2009-11-24	2009-11-24 00:00:00	2009-11-24	581452		0	0	0		0	0	0	252389	0	52	40213296		
210442	4615	40213227	2006-09-06	2006-09-06 00:00:00	2006-09-06	2006-09-06 00:00:00	2006-09-06	581452		0	0	0		0	0	0	307448	0	113	40213227		
215903	4735	40213314	1977-12-15	1977-12-15 00:00:00	1977-12-15	1977-12-15 00:00:00	1977-12-15	581452		0	0	0		0	0	0	315421	0	49	40213314		
112118	2463	40213227	2011-04-21	2011-04-21 00:00:00	2011-04-21	2011-04-21 00:00:00	2011-04-21	581452		0	0	0		0	0	0	163351	0	113	40213227		
49770	4129	19133873	1955-03-05	1955-03-05 00:00:00	1955-03-15	1955-03-15 00:00:00	1955-03-15	38000177		0	0	10		0	0	0	274444	0	834061	19133873		
99563	2180	40213314	1979-01-06	1979-01-06 00:00:00	1979-01-06	1979-01-06 00:00:00	1979-01-06	581452		0	0	0		0	0	0	145396	0	49	40213314		
208609	4576	40213296	1996-06-19	1996-06-19 00:00:00	1996-06-19	1996-06-19 00:00:00	1996-06-19	581452		0	0	0		0	0	0	304794	0	52	40213296		
88742	1946	40213201	1992-09-05	1992-09-05 00:00:00	1992-09-05	1992-09-05 00:00:00	1992-09-05	581452		0	0	0		0	0	0	129375	0	33	40213201		
148314	3260	40213227	2002-03-30	2002-03-30 00:00:00	2002-03-30	2002-03-30 00:00:00	2002-03-30	581452		0	0	0		0	0	0	216767	0	113	40213227		
72765	1590	40213260	2010-04-04	2010-04-04 00:00:00	2010-04-04	2010-04-04 00:00:00	2010-04-04	581452		0	0	0		0	0	0	106703	0	121	40213260		
3469	287	46233988	1977-10-06	1977-10-06 00:00:00	1977-10-20	1977-10-20 00:00:00	1977-10-20	38000177		0	0	14		0	0	0	19184	0	1652673	46233988		
63943	5312	40229134	1961-05-04	1961-05-04 00:00:00	1961-05-11	1961-05-11 00:00:00	1961-05-11	38000177		0	0	7		0	0	0	353248	0	1043400	40229134		
56239	4668	1713671	1995-01-20	1995-01-20 00:00:00	1995-01-27	1995-01-27 00:00:00	1995-01-27	38000177		0	0	7		0	0	0	311105	0	562251	1713671		
53755	4470	1713671	1996-04-05	1996-04-05 00:00:00	1996-04-19	1996-04-19 00:00:00	1996-04-19	38000177		0	0	14		0	0	0	297377	0	562251	1713671		
169786	3733	40213160	1976-07-20	1976-07-20 00:00:00	1976-07-20	1976-07-20 00:00:00	1976-07-20	581452		0	0	0		0	0	0	248082	0	10	40213160		
31540	2616	1118084	1987-12-08	1987-12-08 00:00:00	1987-12-08	1987-12-08 00:00:00	\N	38000177		0	0	0		0	0	0	173020	0	00025152531	44923712		
188416	4137	40213296	2001-01-31	2001-01-31 00:00:00	2001-01-31	2001-01-31 00:00:00	2001-01-31	581452		0	0	0		0	0	0	275017	0	52	40213296		
128693	2830	40213306	1997-07-14	1997-07-14 00:00:00	1997-07-14	1997-07-14 00:00:00	1997-07-14	581452		0	0	0		0	0	0	187718	0	43	40213306		
50004	4149	1127078	1966-03-27	1966-03-27 00:00:00	1966-04-10	1966-04-10 00:00:00	1966-04-10	38000177		0	0	14		0	0	0	275747	0	282464	1127078		
34758	2869	19059056	1960-07-31	1960-07-31 00:00:00	1960-08-30	1960-08-30 00:00:00	1960-08-30	38000177		0	0	30		0	0	0	190823	0	243670	19059056		
56066	1228	40213160	1974-10-12	1974-10-12 00:00:00	1974-10-12	1974-10-12 00:00:00	1974-10-12	581452		0	0	0		0	0	0	80933	0	10	40213160		
91875	2016	40213227	2012-06-19	2012-06-19 00:00:00	2012-06-19	2012-06-19 00:00:00	2012-06-19	581452		0	0	0		0	0	0	134140	0	113	40213227		
183666	4035	40213160	1972-06-27	1972-06-27 00:00:00	1972-06-27	1972-06-27 00:00:00	1972-06-27	581452		0	0	0		0	0	0	268483	0	10	40213160		
36806	3041	1713671	2013-02-23	2013-02-23 00:00:00	2013-03-09	2013-03-09 00:00:00	2013-03-09	38000177		0	0	14		0	0	0	202475	0	562251	1713671		
145886	3208	40213227	1999-03-26	1999-03-26 00:00:00	1999-03-26	1999-03-26 00:00:00	1999-03-26	581452		0	0	0		0	0	0	213243	0	113	40213227		
37366	3087	46275916	2001-02-28	2001-02-28 00:00:00	2001-02-28	2001-02-28 00:00:00	2001-02-28	38000177		0	0	0		0	0	0	205557	0	1660014	46275916		
121112	2661	40213260	2015-09-18	2015-09-18 00:00:00	2015-09-18	2015-09-18 00:00:00	2015-09-18	581452		0	0	0		0	0	0	176310	0	121	40213260		
37474	3096	1115171	2016-04-08	2016-04-08 00:00:00	2016-07-07	2016-07-07 00:00:00	2016-07-07	38000177		0	0	90		0	0	0	206080	0	849574	1115171		
33535	2776	19133873	1989-04-01	1989-04-01 00:00:00	1989-04-12	1989-04-12 00:00:00	1989-04-12	38000177		0	0	11		0	0	0	183854	0	834061	19133873		
15789	1314	1713671	2013-09-08	2013-09-08 00:00:00	2013-09-22	2013-09-22 00:00:00	2013-09-22	38000177		0	0	14		0	0	0	87052	0	562251	1713671		
33273	2757	1118084	2007-07-14	2007-07-14 00:00:00	2007-07-14	2007-07-14 00:00:00	\N	38000177		0	0	0		0	0	0	182355	0	00025152531	44923712		
119784	2633	40213227	2019-03-07	2019-03-07 00:00:00	2019-03-07	2019-03-07 00:00:00	2019-03-07	581452		0	0	0		0	0	0	174244	0	113	40213227		
239605	5259	40213160	1963-10-07	1963-10-07 00:00:00	1963-10-07	1963-10-07 00:00:00	1963-10-07	581452		0	0	0		0	0	0	349958	0	10	40213160		
18767	1550	19133873	1981-12-18	1981-12-18 00:00:00	1981-12-25	1981-12-25 00:00:00	1981-12-25	38000177		0	0	7		0	0	0	103756	0	834061	19133873		
5710	124	40213227	2017-03-28	2017-03-28 00:00:00	2017-03-28	2017-03-28 00:00:00	2017-03-28	581452		0	0	0		0	0	0	8274	0	113	40213227		
43971	3641	1127433	1979-04-01	1979-04-01 00:00:00	1979-04-15	1979-04-15 00:00:00	1979-04-15	38000177		0	0	14		0	0	0	242313	0	313782	1127433		
180272	3962	40213227	2013-02-22	2013-02-22 00:00:00	2013-02-22	2013-02-22 00:00:00	2013-02-22	581452		0	0	0		0	0	0	263409	0	113	40213227		
238539	5236	40213227	2002-05-22	2002-05-22 00:00:00	2002-05-22	2002-05-22 00:00:00	2002-05-22	581452		0	0	0		0	0	0	348414	0	113	40213227		
91713	2013	40213227	1998-03-28	1998-03-28 00:00:00	1998-03-28	1998-03-28 00:00:00	1998-03-28	581452		0	0	0		0	0	0	133970	0	113	40213227		
2750	222	19059056	1958-05-10	1958-05-10 00:00:00	1958-06-09	1958-06-09 00:00:00	1958-06-09	38000177		0	0	30		0	0	0	14931	0	243670	19059056		
237908	5223	40213260	2018-01-20	2018-01-20 00:00:00	2018-01-20	2018-01-20 00:00:00	2018-01-20	581452		0	0	0		0	0	0	347557	0	121	40213260		
32219	2672	1127433	1995-12-12	1995-12-12 00:00:00	1995-12-26	1995-12-26 00:00:00	1995-12-26	38000177		0	0	14		0	0	0	176941	0	313782	1127433		
61243	5095	1127433	2016-05-02	2016-05-02 00:00:00	2016-05-09	2016-05-09 00:00:00	2016-05-09	38000177		0	0	7		0	0	0	338549	0	313782	1127433		
30452	2525	1713671	2006-05-29	2006-05-29 00:00:00	2006-06-05	2006-06-05 00:00:00	2006-06-05	38000177		0	0	7		0	0	0	166944	0	562251	1713671		
16299	1352	19023423	1976-07-29	1976-07-29 00:00:00	1976-07-29	1976-07-29 00:00:00	1976-07-29	38000177		0	0	0		0	0	0	89606	0	200252	19023423		
23944	1971	19019979	1974-04-23	1974-04-23 00:00:00	1974-05-07	1974-05-07 00:00:00	1974-05-07	38000177		0	0	14		0	0	0	131116	0	198405	19019979		
61079	1335	40213160	1979-02-26	1979-02-26 00:00:00	1979-02-26	1979-02-26 00:00:00	1979-02-26	581452		0	0	0		0	0	0	88583	0	10	40213160		
5104	426	19059056	1969-09-02	1969-09-02 00:00:00	1969-09-16	1969-09-16 00:00:00	1969-09-16	38000177		0	0	14		0	0	0	28258	0	243670	19059056		
24063	1980	19133873	1976-11-19	1976-11-19 00:00:00	1976-11-28	1976-11-28 00:00:00	1976-11-28	38000177		0	0	9		0	0	0	131825	0	834061	19133873		
23859	1965	1713671	1995-03-11	1995-03-11 00:00:00	1995-03-25	1995-03-25 00:00:00	1995-03-25	38000177		0	0	14		0	0	0	130642	0	562251	1713671		
34374	2841	1127433	1986-10-06	1986-10-06 00:00:00	1986-12-05	1986-12-05 00:00:00	1986-12-05	38000177		0	0	60		0	0	0	188635	0	313782	1127433		
16651	1379	1127433	1986-07-31	1986-07-31 00:00:00	1986-09-04	1986-09-04 00:00:00	1986-09-04	38000177		0	0	35		0	0	0	91514	0	313782	1127433		
233826	5138	40213296	2017-12-08	2017-12-08 00:00:00	2017-12-08	2017-12-08 00:00:00	2017-12-08	581452		0	0	0		0	0	0	341473	0	52	40213296		
42358	3513	920300	2010-06-01	2010-06-01 00:00:00	2010-06-08	2010-06-08 00:00:00	2010-06-08	38000177		0	0	7		0	0	0	233157	0	311989	920300		
59793	1309	40213296	1997-10-01	1997-10-01 00:00:00	1997-10-01	1997-10-01 00:00:00	1997-10-01	581452		0	0	0		0	0	0	86484	0	52	40213296		
137617	3020	40213227	1999-01-13	1999-01-13 00:00:00	1999-01-13	1999-01-13 00:00:00	1999-01-13	581452		0	0	0		0	0	0	201375	0	113	40213227		
242838	5331	40213260	2013-07-31	2013-07-31 00:00:00	2013-07-31	2013-07-31 00:00:00	2013-07-31	581452		0	0	0		0	0	0	354943	0	121	40213260		
225984	4963	40213306	1995-07-17	1995-07-17 00:00:00	1995-07-17	1995-07-17 00:00:00	1995-07-17	581452		0	0	0		0	0	0	329923	0	43	40213306		
5298	115	40213160	1960-02-07	1960-02-07 00:00:00	1960-02-07	1960-02-07 00:00:00	1960-02-07	581452		0	0	0		0	0	0	7604	0	10	40213160		
132149	2903	40213260	2014-03-30	2014-03-30 00:00:00	2014-03-30	2014-03-30 00:00:00	2014-03-30	581452		0	0	0		0	0	0	193462	0	121	40213260		
80803	1766	40213160	1955-11-29	1955-11-29 00:00:00	1955-11-29	1955-11-29 00:00:00	1955-11-29	581452		0	0	0		0	0	0	118189	0	10	40213160		
38874	3214	19019979	1975-06-12	1975-06-12 00:00:00	1975-06-26	1975-06-26 00:00:00	1975-06-26	38000177		0	0	14		0	0	0	213539	0	198405	19019979		
106882	2343	40213160	1956-09-22	1956-09-22 00:00:00	1956-09-22	1956-09-22 00:00:00	1956-09-22	581452		0	0	0		0	0	0	155956	0	10	40213160		
125340	2758	40213227	1992-09-04	1992-09-04 00:00:00	1992-09-04	1992-09-04 00:00:00	1992-09-04	581452		0	0	0		0	0	0	182391	0	113	40213227		
172719	3796	40213227	2009-11-24	2009-11-24 00:00:00	2009-11-24	2009-11-24 00:00:00	2009-11-24	581452		0	0	0		0	0	0	252389	0	113	40213227		
210445	4615	40213160	1955-09-28	1955-09-28 00:00:00	1955-09-28	1955-09-28 00:00:00	1955-09-28	581452		0	0	0		0	0	0	307398	0	10	40213160		
215907	4736	40213160	1973-04-27	1973-04-27 00:00:00	1973-04-27	1973-04-27 00:00:00	1973-04-27	581452		0	0	0		0	0	0	315517	0	10	40213160		
103664	2274	40213227	2008-09-07	2008-09-07 00:00:00	2008-09-07	2008-09-07 00:00:00	2008-09-07	581452		0	0	0		0	0	0	151230	0	113	40213227		
49771	4129	1713671	2013-06-07	2013-06-07 00:00:00	2013-06-14	2013-06-14 00:00:00	2013-06-14	38000177		0	0	7		0	0	0	274522	0	562251	1713671		
99564	2180	40213160	1979-01-06	1979-01-06 00:00:00	1979-01-06	1979-01-06 00:00:00	1979-01-06	581452		0	0	0		0	0	0	145396	0	10	40213160		
208611	4576	40213227	1996-06-19	1996-06-19 00:00:00	1996-06-19	1996-06-19 00:00:00	1996-06-19	581452		0	0	0		0	0	0	304794	0	113	40213227		
46559	3856	19059056	1979-07-22	1979-07-22 00:00:00	1979-08-05	1979-08-05 00:00:00	1979-08-05	38000177		0	0	14		0	0	0	255893	0	243670	19059056		
148315	3260	40213296	2002-03-30	2002-03-30 00:00:00	2002-03-30	2002-03-30 00:00:00	2002-03-30	581452		0	0	0		0	0	0	216767	0	52	40213296		
219184	4811	40213227	2013-07-09	2013-07-09 00:00:00	2013-07-09	2013-07-09 00:00:00	2013-07-09	581452		0	0	0		0	0	0	320079	0	113	40213227		
3470	287	1127433	1976-10-13	1976-10-13 00:00:00	1976-10-20	1976-10-20 00:00:00	1976-10-20	38000177		0	0	7		0	0	0	19187	0	313782	1127433		
63944	5312	19078461	2004-12-16	2004-12-16 00:00:00	2005-01-06	2005-01-06 00:00:00	2005-01-06	38000177		0	0	21		0	0	0	353231	0	310965	19078461		
56240	4668	1127433	2003-10-07	2003-10-07 00:00:00	2003-10-21	2003-10-21 00:00:00	2003-10-21	38000177		0	0	14		0	0	0	311036	0	313782	1127433		
53756	4470	1127078	1973-06-10	1973-06-10 00:00:00	1973-06-24	1973-06-24 00:00:00	1973-06-24	38000177		0	0	14		0	0	0	297365	0	282464	1127078		
169789	3733	40213314	1977-04-19	1977-04-19 00:00:00	1977-04-19	1977-04-19 00:00:00	1977-04-19	581452		0	0	0		0	0	0	248089	0	49	40213314		
41999	3481	1310034	2001-05-12	2001-05-12 00:00:00	2001-05-12	2001-05-12 00:00:00	2001-05-12	38000177		0	0	0		0	0	0	230885	0	834357	1310034		
188420	4137	40213160	1961-07-05	1961-07-05 00:00:00	1961-07-05	1961-07-05 00:00:00	1961-07-05	581452		0	0	0		0	0	0	275009	0	10	40213160		
128695	2830	40213227	1997-07-14	1997-07-14 00:00:00	1997-07-14	1997-07-14 00:00:00	1997-07-14	581452		0	0	0		0	0	0	187718	0	113	40213227		
50005	4149	1118084	2002-08-05	2002-08-05 00:00:00	2002-08-05	2002-08-05 00:00:00	\N	38000177		0	0	0		0	0	0	275727	0	00025152531	44923712		
34759	2869	40163554	2009-12-15	2009-12-15 00:00:00	2009-12-15	2009-12-15 00:00:00	\N	38000177		0	0	0		0	0	0	190830	0	855332	40163554		
56069	1228	40213296	2016-07-09	2016-07-09 00:00:00	2016-07-09	2016-07-09 00:00:00	2016-07-09	581452		0	0	0		0	0	0	80914	0	52	40213296		
91883	2016	40213314	1981-03-17	1981-03-17 00:00:00	1981-03-17	1981-03-17 00:00:00	1981-03-17	581452		0	0	0		0	0	0	134112	0	49	40213314		
183669	4035	40213227	2014-04-01	2014-04-01 00:00:00	2014-04-01	2014-04-01 00:00:00	2014-04-01	581452		0	0	0		0	0	0	268456	0	113	40213227		
36807	3041	1127078	1987-02-09	1987-02-09 00:00:00	1987-03-09	1987-03-09 00:00:00	1987-03-09	38000177		0	0	28		0	0	0	202462	0	282464	1127078		
145889	3208	40213160	1968-06-21	1968-06-21 00:00:00	1968-06-21	1968-06-21 00:00:00	1968-06-21	581452		0	0	0		0	0	0	213268	0	10	40213160		
37367	3087	40243436	2001-02-28	2001-02-28 00:00:00	2001-02-28	2001-02-28 00:00:00	2001-02-28	38000177		0	0	0		0	0	0	205557	0	1190795	40243436		
121121	2661	40213160	1965-02-19	1965-02-19 00:00:00	1965-02-19	1965-02-19 00:00:00	1965-02-19	581452		0	0	0		0	0	0	176314	0	10	40213160		
37476	3096	1713671	2003-04-26	2003-04-26 00:00:00	2003-05-17	2003-05-17 00:00:00	2003-05-17	38000177		0	0	21		0	0	0	206070	0	562251	1713671		
33536	2776	19008572	2005-07-13	2005-07-13 00:00:00	2005-07-13	2005-07-13 00:00:00	\N	38000177		0	0	0		0	0	0	183856	0	106258	19008572		
15790	1314	1127433	1970-12-14	1970-12-14 00:00:00	1970-12-21	1970-12-21 00:00:00	1970-12-21	38000177		0	0	7		0	0	0	87037	0	313782	1127433		
33274	2757	1713671	1982-05-29	1982-05-29 00:00:00	1982-06-19	1982-06-19 00:00:00	1982-06-19	38000177		0	0	21		0	0	0	182352	0	562251	1713671		
119787	2633	40213198	2013-01-31	2013-01-31 00:00:00	2013-01-31	2013-01-31 00:00:00	2013-01-31	581452		0	0	0		0	0	0	174226	0	133	40213198		
239610	5259	40213260	2008-10-27	2008-10-27 00:00:00	2008-10-27	2008-10-27 00:00:00	2008-10-27	581452		0	0	0		0	0	0	350013	0	121	40213260		
18768	1550	1124300	2004-08-25	2004-08-25 00:00:00	2004-08-25	2004-08-25 00:00:00	\N	38000177		0	0	0		0	0	0	103779	0	00781178901	45011828		
5711	124	40213314	1984-06-12	1984-06-12 00:00:00	1984-06-12	1984-06-12 00:00:00	1984-06-12	581452		0	0	0		0	0	0	8260	0	49	40213314		
43972	3641	1713671	2007-03-05	2007-03-05 00:00:00	2007-03-19	2007-03-19 00:00:00	2007-03-19	38000177		0	0	14		0	0	0	242342	0	562251	1713671		
180277	3962	40213198	2017-03-17	2017-03-17 00:00:00	2017-03-17	2017-03-17 00:00:00	2017-03-17	581452		0	0	0		0	0	0	263411	0	133	40213198		
216194	4745	40213160	1980-03-12	1980-03-12 00:00:00	1980-03-12	1980-03-12 00:00:00	1980-03-12	581452		0	0	0		0	0	0	315944	0	10	40213160		
91718	2013	40213260	2006-03-18	2006-03-18 00:00:00	2006-03-18	2006-03-18 00:00:00	2006-03-18	581452		0	0	0		0	0	0	133997	0	121	40213260		
2752	222	40165015	2003-09-14	2003-09-14 00:00:00	2003-09-14	2003-09-14 00:00:00	\N	38000177		0	0	0		0	0	0	14888	0	861467	40165015		
237910	5223	40213160	1968-04-27	1968-04-27 00:00:00	1968-04-27	1968-04-27 00:00:00	1968-04-27	581452		0	0	0		0	0	0	347533	0	10	40213160		
32220	2672	1127433	1978-07-13	1978-07-13 00:00:00	1978-07-20	1978-07-20 00:00:00	1978-07-20	38000177		0	0	7		0	0	0	177025	0	313782	1127433		
61244	5095	1127433	2012-11-27	2012-11-27 00:00:00	2012-12-11	2012-12-11 00:00:00	2012-12-11	38000177		0	0	14		0	0	0	338520	0	313782	1127433		
30453	2525	1124300	2017-12-09	2017-12-09 00:00:00	2017-12-09	2017-12-09 00:00:00	\N	38000177		0	0	0		0	0	0	166974	0	00781178901	45011828		
16300	1352	35605482	1976-07-29	1976-07-29 00:00:00	1976-07-29	1976-07-29 00:00:00	1976-07-29	38000177		0	0	0		0	0	0	89606	0	1740467	35605482		
23945	1971	19006318	1974-04-23	1974-04-23 00:00:00	1974-05-07	1974-05-07 00:00:00	1974-05-07	38000177		0	0	14		0	0	0	131116	0	105078	19006318		
61080	1335	40213160	1979-07-30	1979-07-30 00:00:00	1979-07-30	1979-07-30 00:00:00	1979-07-30	581452		0	0	0		0	0	0	88584	0	10	40213160		
5105	426	46233988	1969-09-02	1969-09-02 00:00:00	1969-09-16	1969-09-16 00:00:00	1969-09-16	38000177		0	0	14		0	0	0	28258	0	1652673	46233988		
24064	1980	40229134	1984-08-31	1984-08-31 00:00:00	1984-09-14	1984-09-14 00:00:00	1984-09-14	38000177		0	0	14		0	0	0	131879	0	1043400	40229134		
23860	1965	1127433	1986-04-20	1986-04-20 00:00:00	1986-05-11	1986-05-11 00:00:00	1986-05-11	38000177		0	0	21		0	0	0	130668	0	313782	1127433		
34375	2841	40162522	1981-11-01	1981-11-01 00:00:00	1981-11-01	1981-11-01 00:00:00	\N	38000177		0	0	0		0	0	0	188633	0	857005	40162522		
16656	1381	1127078	1982-07-12	1982-07-12 00:00:00	1982-07-26	1982-07-26 00:00:00	1982-07-26	38000177		0	0	14		0	0	0	91585	0	282464	1127078		
233830	5138	40213227	2009-03-27	2009-03-27 00:00:00	2009-03-27	2009-03-27 00:00:00	2009-03-27	581452		0	0	0		0	0	0	341470	0	113	40213227		
42359	3513	40236824	2010-06-01	2010-06-01 00:00:00	2010-06-08	2010-06-08 00:00:00	2010-06-08	38000177		0	0	7		0	0	0	233157	0	1094107	40236824		
59797	1309	40213160	1955-07-06	1955-07-06 00:00:00	1955-07-06	1955-07-06 00:00:00	1955-07-06	581452		0	0	0		0	0	0	86527	0	10	40213160		
137618	3020	40213296	1999-01-13	1999-01-13 00:00:00	1999-01-13	1999-01-13 00:00:00	1999-01-13	581452		0	0	0		0	0	0	201375	0	52	40213296		
242842	5331	40213160	1968-07-10	1968-07-10 00:00:00	1968-07-10	1968-07-10 00:00:00	1968-07-10	581452		0	0	0		0	0	0	354966	0	10	40213160		
225991	4963	40213296	2013-05-20	2013-05-20 00:00:00	2013-05-20	2013-05-20 00:00:00	2013-05-20	581452		0	0	0		0	0	0	329958	0	52	40213296		
5301	115	40213260	2010-08-01	2010-08-01 00:00:00	2010-08-01	2010-08-01 00:00:00	2010-08-01	581452		0	0	0		0	0	0	7599	0	121	40213260		
132154	2903	40213227	2015-04-05	2015-04-05 00:00:00	2015-04-05	2015-04-05 00:00:00	2015-04-05	581452		0	0	0		0	0	0	193459	0	113	40213227		
207442	4551	40213251	1984-09-26	1984-09-26 00:00:00	1984-09-26	1984-09-26 00:00:00	1984-09-26	581452		0	0	0		0	0	0	303294	0	21	40213251		
38875	3214	19129655	1975-06-12	1975-06-12 00:00:00	1975-06-26	1975-06-26 00:00:00	1975-06-26	38000177		0	0	14		0	0	0	213539	0	789980	19129655		
106886	2343	40213160	1956-04-21	1956-04-21 00:00:00	1956-04-21	1956-04-21 00:00:00	1956-04-21	581452		0	0	0		0	0	0	155955	0	10	40213160		
125356	2758	40213227	2011-12-23	2011-12-23 00:00:00	2011-12-23	2011-12-23 00:00:00	2011-12-23	581452		0	0	0		0	0	0	182420	0	113	40213227		
109502	2404	40213160	1966-03-13	1966-03-13 00:00:00	1966-03-13	1966-03-13 00:00:00	1966-03-13	581452		0	0	0		0	0	0	159718	0	10	40213160		
210447	4615	40213160	1955-12-28	1955-12-28 00:00:00	1955-12-28	1955-12-28 00:00:00	1955-12-28	581452		0	0	0		0	0	0	307461	0	10	40213160		
215910	4736	40213306	1994-10-07	1994-10-07 00:00:00	1994-10-07	1994-10-07 00:00:00	1994-10-07	581452		0	0	0		0	0	0	315498	0	43	40213306		
103666	2274	40213227	1997-11-16	1997-11-16 00:00:00	1997-11-16	1997-11-16 00:00:00	1997-11-16	581452		0	0	0		0	0	0	151153	0	113	40213227		
49774	4129	19133873	1950-11-14	1950-11-14 00:00:00	1950-11-23	1950-11-23 00:00:00	1950-11-23	38000177		0	0	9		0	0	0	274452	0	834061	19133873		
99566	2180	40213227	2010-06-05	2010-06-05 00:00:00	2010-06-05	2010-06-05 00:00:00	2010-06-05	581452		0	0	0		0	0	0	145434	0	113	40213227		
208616	4576	40213160	1955-04-06	1955-04-06 00:00:00	1955-04-06	1955-04-06 00:00:00	1955-04-06	581452		0	0	0		0	0	0	304777	0	10	40213160		
46560	3856	19074843	1979-07-22	1979-07-22 00:00:00	1979-08-05	1979-08-05 00:00:00	1979-08-05	38000177		0	0	14		0	0	0	255893	0	309045	19074843		
148318	3260	40213260	2010-04-03	2010-04-03 00:00:00	2010-04-03	2010-04-03 00:00:00	2010-04-03	581452		0	0	0		0	0	0	216739	0	121	40213260		
219185	4811	40213260	2013-07-09	2013-07-09 00:00:00	2013-07-09	2013-07-09 00:00:00	2013-07-09	581452		0	0	0		0	0	0	320079	0	121	40213260		
3477	289	19059056	1962-11-12	1962-11-12 00:00:00	1962-11-26	1962-11-26 00:00:00	1962-11-26	38000177		0	0	14		0	0	0	19262	0	243670	19059056		
63945	5312	19133873	1950-07-16	1950-07-16 00:00:00	1950-07-29	1950-07-29 00:00:00	1950-07-29	38000177		0	0	13		0	0	0	353292	0	834061	19133873		
56241	4668	1713671	2004-09-06	2004-09-06 00:00:00	2004-09-20	2004-09-20 00:00:00	2004-09-20	38000177		0	0	14		0	0	0	311080	0	562251	1713671		
53757	4470	46233988	1973-06-10	1973-06-10 00:00:00	1973-06-24	1973-06-24 00:00:00	1973-06-24	38000177		0	0	14		0	0	0	297365	0	1652673	46233988		
169792	3733	40213160	1980-10-21	1980-10-21 00:00:00	1980-10-21	1980-10-21 00:00:00	1980-10-21	581452		0	0	0		0	0	0	248085	0	10	40213160		
42000	3481	19059056	1986-03-05	1986-03-05 00:00:00	1986-04-09	1986-04-09 00:00:00	1986-04-09	38000177		0	0	35		0	0	0	230873	0	243670	19059056		
188423	4137	40213260	2011-04-27	2011-04-27 00:00:00	2011-04-27	2011-04-27 00:00:00	2011-04-27	581452		0	0	0		0	0	0	275032	0	121	40213260		
128699	2830	40213160	1975-01-20	1975-01-20 00:00:00	1975-01-20	1975-01-20 00:00:00	1975-01-20	581452		0	0	0		0	0	0	187774	0	10	40213160		
50006	4149	19059056	1970-11-12	1970-11-12 00:00:00	1970-11-26	1970-11-26 00:00:00	1970-11-26	38000177		0	0	14		0	0	0	275742	0	243670	19059056		
34760	2869	19018935	2009-12-15	2009-12-15 00:00:00	2009-12-15	2009-12-15 00:00:00	\N	38000177		0	0	0		0	0	0	190830	0	197604	19018935		
130452	2866	40213306	1989-04-16	1989-04-16 00:00:00	1989-04-16	1989-04-16 00:00:00	1989-04-16	581452		0	0	0		0	0	0	190692	0	43	40213306		
91884	2016	40213160	1981-03-17	1981-03-17 00:00:00	1981-03-17	1981-03-17 00:00:00	1981-03-17	581452		0	0	0		0	0	0	134112	0	10	40213160		
183670	4035	40213296	2014-04-01	2014-04-01 00:00:00	2014-04-01	2014-04-01 00:00:00	2014-04-01	581452		0	0	0		0	0	0	268456	0	52	40213296		
36808	3041	1150771	1978-08-06	1978-08-06 00:00:00	1978-08-06	1978-08-06 00:00:00	\N	38000177		0	0	0		0	0	0	202463	0	197378	1150771		
145901	3208	40213260	2018-01-12	2018-01-12 00:00:00	2018-01-12	2018-01-12 00:00:00	2018-01-12	581452		0	0	0		0	0	0	213265	0	121	40213260		
37368	3087	40165015	1996-07-15	1996-07-15 00:00:00	1996-07-15	1996-07-15 00:00:00	\N	38000177		0	0	0		0	0	0	205556	0	861467	40165015		
121124	2661	40213296	2004-09-17	2004-09-17 00:00:00	2004-09-17	2004-09-17 00:00:00	2004-09-17	581452		0	0	0		0	0	0	176343	0	52	40213296		
37477	3096	1127433	2015-02-22	2015-02-22 00:00:00	2015-03-15	2015-03-15 00:00:00	2015-03-15	38000177		0	0	21		0	0	0	206079	0	313782	1127433		
33537	2776	1127433	1987-03-01	1987-03-01 00:00:00	1987-03-08	1987-03-08 00:00:00	1987-03-08	38000177		0	0	7		0	0	0	183774	0	313782	1127433		
15791	1314	19133905	1977-01-01	1977-01-01 00:00:00	1977-01-12	1977-01-12 00:00:00	1977-01-12	38000177		0	0	11		0	0	0	86988	0	834102	19133905		
33275	2758	1713671	2006-01-14	2006-01-14 00:00:00	2006-01-28	2006-01-28 00:00:00	2006-01-28	38000177		0	0	14		0	0	0	182438	0	562251	1713671		
119795	2633	40213201	2014-02-06	2014-02-06 00:00:00	2014-02-06	2014-02-06 00:00:00	2014-02-06	581452		0	0	0		0	0	0	174191	0	33	40213201		
239615	5259	40213227	1993-01-18	1993-01-18 00:00:00	1993-01-18	1993-01-18 00:00:00	1993-01-18	581452		0	0	0		0	0	0	349950	0	113	40213227		
18769	1551	19078461	1982-10-02	1982-10-02 00:00:00	1982-10-16	1982-10-16 00:00:00	1982-10-16	38000177		0	0	14		0	0	0	103884	0	310965	19078461		
5712	124	40213160	1984-06-12	1984-06-12 00:00:00	1984-06-12	1984-06-12 00:00:00	1984-06-12	581452		0	0	0		0	0	0	8260	0	10	40213160		
43973	3641	19059056	1946-06-27	1946-06-27 00:00:00	1946-08-01	1946-08-01 00:00:00	1946-08-01	38000177		0	0	35		0	0	0	242311	0	243670	19059056		
180281	3962	40213160	1956-04-27	1956-04-27 00:00:00	1956-04-27	1956-04-27 00:00:00	1956-04-27	581452		0	0	0		0	0	0	263456	0	10	40213160		
216202	4745	40213160	1975-07-09	1975-07-09 00:00:00	1975-07-09	1975-07-09 00:00:00	1975-07-09	581452		0	0	0		0	0	0	316004	0	10	40213160		
91721	2013	40213160	1961-02-25	1961-02-25 00:00:00	1961-02-25	1961-02-25 00:00:00	1961-02-25	581452		0	0	0		0	0	0	133966	0	10	40213160		
2753	222	40236824	2008-09-23	2008-09-23 00:00:00	2008-10-07	2008-10-07 00:00:00	2008-10-07	38000177		0	0	14		0	0	0	14952	0	1094107	40236824		
237913	5223	40213160	1972-11-04	1972-11-04 00:00:00	1972-11-04	1972-11-04 00:00:00	1972-11-04	581452		0	0	0		0	0	0	347536	0	10	40213160		
32221	2672	1118084	1995-03-05	1995-03-05 00:00:00	1995-03-05	1995-03-05 00:00:00	\N	38000177		0	0	0		0	0	0	176996	0	00025152531	44923712		
61245	5096	19075001	2001-02-14	2001-02-14 00:00:00	2001-02-28	2001-02-28 00:00:00	2001-02-28	38000177		0	0	14		0	0	0	338606	0	309097	19075001		
30454	2525	1127433	2009-12-26	2009-12-26 00:00:00	2010-01-09	2010-01-09 00:00:00	2010-01-09	38000177		0	0	14		0	0	0	166977	0	313782	1127433		
16301	1352	35605482	1976-07-29	1976-07-29 00:00:00	1976-07-29	1976-07-29 00:00:00	1976-07-29	38000177		0	0	0		0	0	0	89606	0	1740467	35605482		
23946	1971	1551192	1979-11-17	1979-11-17 00:00:00	1979-11-17	1979-11-17 00:00:00	1979-11-17	38000177		0	0	0		0	0	0	131062	0	312617	1551192		
61081	1335	40213314	1979-02-26	1979-02-26 00:00:00	1979-02-26	1979-02-26 00:00:00	1979-02-26	581452		0	0	0		0	0	0	88583	0	49	40213314		
5106	426	19133873	1975-05-06	1975-05-06 00:00:00	1975-05-13	1975-05-13 00:00:00	1975-05-13	38000177		0	0	7		0	0	0	28265	0	834061	19133873		
24065	1980	1115171	2005-04-04	2005-04-04 00:00:00	2005-04-18	2005-04-18 00:00:00	2005-04-18	38000177		0	0	14		0	0	0	131807	0	849574	1115171		
23861	1965	1127433	1982-04-12	1982-04-12 00:00:00	1982-04-19	1982-04-19 00:00:00	1982-04-19	38000177		0	0	7		0	0	0	130614	0	313782	1127433		
34376	2841	1127433	1981-11-01	1981-11-01 00:00:00	1981-12-31	1981-12-31 00:00:00	1981-12-31	38000177		0	0	60		0	0	0	188633	0	313782	1127433		
16657	1381	1713671	2001-12-16	2001-12-16 00:00:00	2001-12-30	2001-12-30 00:00:00	2001-12-30	38000177		0	0	14		0	0	0	91580	0	562251	1713671		
233833	5138	40213251	1984-11-23	1984-11-23 00:00:00	1984-11-23	1984-11-23 00:00:00	1984-11-23	581452		0	0	0		0	0	0	341499	0	21	40213251		
42360	3513	19129655	1976-07-26	1976-07-26 00:00:00	1976-08-09	1976-08-09 00:00:00	1976-08-09	38000177		0	0	14		0	0	0	233105	0	789980	19129655		
93759	2058	40213160	1971-10-06	1971-10-06 00:00:00	1971-10-06	1971-10-06 00:00:00	1971-10-06	581452		0	0	0		0	0	0	136898	0	10	40213160		
137627	3020	40213160	1957-04-10	1957-04-10 00:00:00	1957-04-10	1957-04-10 00:00:00	1957-04-10	581452		0	0	0		0	0	0	201413	0	10	40213160		
242847	5331	40213160	1963-11-06	1963-11-06 00:00:00	1963-11-06	1963-11-06 00:00:00	1963-11-06	581452		0	0	0		0	0	0	354928	0	10	40213160		
225992	4963	40213160	1973-10-22	1973-10-22 00:00:00	1973-10-22	1973-10-22 00:00:00	1973-10-22	581452		0	0	0		0	0	0	329880	0	10	40213160		
5306	115	40213227	2001-07-08	2001-07-08 00:00:00	2001-07-08	2001-07-08 00:00:00	2001-07-08	581452		0	0	0		0	0	0	7586	0	113	40213227		
132155	2903	40213260	2015-04-05	2015-04-05 00:00:00	2015-04-05	2015-04-05 00:00:00	2015-04-05	581452		0	0	0		0	0	0	193459	0	121	40213260		
207447	4551	40213160	1981-09-09	1981-09-09 00:00:00	1981-09-09	1981-09-09 00:00:00	1981-09-09	581452		0	0	0		0	0	0	303312	0	10	40213160		
38876	3214	1127078	1976-03-25	1976-03-25 00:00:00	1976-04-22	1976-04-22 00:00:00	1976-04-22	38000177		0	0	28		0	0	0	213493	0	282464	1127078		
106888	2343	40213160	1960-12-24	1960-12-24 00:00:00	1960-12-24	1960-12-24 00:00:00	1960-12-24	581452		0	0	0		0	0	0	155976	0	10	40213160		
225751	4957	40213227	2013-10-19	2013-10-19 00:00:00	2013-10-19	2013-10-19 00:00:00	2013-10-19	581452		0	0	0		0	0	0	329563	0	113	40213227		
109504	2404	40213306	1989-04-23	1989-04-23 00:00:00	1989-04-23	1989-04-23 00:00:00	1989-04-23	581452		0	0	0		0	0	0	159731	0	43	40213306		
210451	4615	40213296	1996-04-17	1996-04-17 00:00:00	1996-04-17	1996-04-17 00:00:00	1996-04-17	581452		0	0	0		0	0	0	307389	0	52	40213296		
215912	4736	40213227	1994-10-07	1994-10-07 00:00:00	1994-10-07	1994-10-07 00:00:00	1994-10-07	581452		0	0	0		0	0	0	315498	0	113	40213227		
103683	2274	40213198	2012-09-30	2012-09-30 00:00:00	2012-09-30	2012-09-30 00:00:00	2012-09-30	581452		0	0	0		0	0	0	151165	0	133	40213198		
49775	4129	1127433	1992-04-05	1992-04-05 00:00:00	1992-04-26	1992-04-26 00:00:00	1992-04-26	38000177		0	0	21		0	0	0	274463	0	313782	1127433		
99568	2180	40213160	1979-06-09	1979-06-09 00:00:00	1979-06-09	1979-06-09 00:00:00	1979-06-09	581452		0	0	0		0	0	0	145412	0	10	40213160		
13065	1098	1124300	1996-09-10	1996-09-10 00:00:00	1996-09-10	1996-09-10 00:00:00	\N	38000177		0	0	0		0	0	0	72035	0	00781178901	45011828		
46561	3856	40236824	1998-10-23	1998-10-23 00:00:00	1998-10-29	1998-10-29 00:00:00	1998-10-29	38000177		0	0	6		0	0	0	255892	0	1094107	40236824		
57466	1257	40213160	1973-02-03	1973-02-03 00:00:00	1973-02-03	1973-02-03 00:00:00	1973-02-03	581452		0	0	0		0	0	0	82789	0	10	40213160		
219196	4811	40213227	1993-07-27	1993-07-27 00:00:00	1993-07-27	1993-07-27 00:00:00	1993-07-27	581452		0	0	0		0	0	0	320063	0	113	40213227		
3478	289	19006318	1962-11-12	1962-11-12 00:00:00	1962-11-26	1962-11-26 00:00:00	1962-11-26	38000177		0	0	14		0	0	0	19262	0	105078	19006318		
63946	5312	19059056	1939-09-26	1939-09-26 00:00:00	1939-10-10	1939-10-10 00:00:00	1939-10-10	38000177		0	0	14		0	0	0	353296	0	243670	19059056		
56242	4668	1713671	2001-11-28	2001-11-28 00:00:00	2001-12-12	2001-12-12 00:00:00	2001-12-12	38000177		0	0	14		0	0	0	311035	0	562251	1713671		
53758	4470	1118084	2012-09-20	2012-09-20 00:00:00	2012-09-20	2012-09-20 00:00:00	\N	38000177		0	0	0		0	0	0	297339	0	00025152531	44923712		
169795	3733	40213314	1977-01-18	1977-01-18 00:00:00	1977-01-18	1977-01-18 00:00:00	1977-01-18	581452		0	0	0		0	0	0	248083	0	49	40213314		
42001	3481	19059056	1981-04-09	1981-04-09 00:00:00	1981-04-30	1981-04-30 00:00:00	1981-04-30	38000177		0	0	21		0	0	0	230872	0	243670	19059056		
188427	4137	40213227	2012-02-01	2012-02-01 00:00:00	2012-02-01	2012-02-01 00:00:00	2012-02-01	581452		0	0	0		0	0	0	275026	0	113	40213227		
128700	2830	40213314	1977-01-17	1977-01-17 00:00:00	1977-01-17	1977-01-17 00:00:00	1977-01-17	581452		0	0	0		0	0	0	187757	0	49	40213314		
50007	4149	19129655	1970-11-12	1970-11-12 00:00:00	1970-11-26	1970-11-26 00:00:00	1970-11-26	38000177		0	0	14		0	0	0	275742	0	789980	19129655		
34761	2869	40171902	2009-12-15	2009-12-15 00:00:00	2009-12-15	2009-12-15 00:00:00	\N	38000177		0	0	0		0	0	0	190830	0	897718	40171902		
130462	2867	40213227	2009-10-20	2009-10-20 00:00:00	2009-10-20	2009-10-20 00:00:00	2009-10-20	581452		0	0	0		0	0	0	190721	0	113	40213227		
91891	2017	40213296	2009-09-01	2009-09-01 00:00:00	2009-09-01	2009-09-01 00:00:00	2009-09-01	581452		0	0	0		0	0	0	134204	0	52	40213296		
183675	4035	40213160	1972-11-28	1972-11-28 00:00:00	1972-11-28	1972-11-28 00:00:00	1972-11-28	581452		0	0	0		0	0	0	268471	0	10	40213160		
36809	3041	1713671	1981-08-04	1981-08-04 00:00:00	1981-10-27	1981-10-27 00:00:00	1981-10-27	38000177		0	0	84		0	0	0	202485	0	562251	1713671		
387	9	40213251	1984-07-05	1984-07-05 00:00:00	1984-07-05	1984-07-05 00:00:00	1984-07-05	581452		0	0	0		0	0	0	715	0	21	40213251		
37369	3087	1115171	1996-07-15	1996-07-15 00:00:00	1996-10-13	1996-10-13 00:00:00	1996-10-13	38000177		0	0	90		0	0	0	205556	0	849574	1115171		
121125	2662	40213160	1978-10-06	1978-10-06 00:00:00	1978-10-06	1978-10-06 00:00:00	1978-10-06	581452		0	0	0		0	0	0	176435	0	10	40213160		
37480	3098	19078461	2019-06-23	2019-06-23 00:00:00	2019-06-23	2019-06-23 00:00:00	\N	38000177		0	0	0		0	0	0	206195	0	310965	19078461		
33538	2776	19078461	2013-02-23	2013-02-23 00:00:00	2013-03-16	2013-03-16 00:00:00	2013-03-16	38000177		0	0	21		0	0	0	183859	0	310965	19078461		
15792	1314	19133873	1936-04-28	1936-04-28 00:00:00	1936-05-09	1936-05-09 00:00:00	1936-05-09	38000177		0	0	11		0	0	0	87020	0	834061	19133873		
33276	2758	1127433	1996-01-08	1996-01-08 00:00:00	1996-01-22	1996-01-22 00:00:00	1996-01-22	38000177		0	0	14		0	0	0	182481	0	313782	1127433		
130127	2860	40213227	1993-06-11	1993-06-11 00:00:00	1993-06-11	1993-06-11 00:00:00	1993-06-11	581452		0	0	0		0	0	0	190087	0	113	40213227		
239618	5259	40213160	1959-04-06	1959-04-06 00:00:00	1959-04-06	1959-04-06 00:00:00	1959-04-06	581452		0	0	0		0	0	0	349956	0	10	40213160		
18770	1551	1713671	2009-05-30	2009-05-30 00:00:00	2009-06-06	2009-06-06 00:00:00	2009-06-06	38000177		0	0	7		0	0	0	103835	0	562251	1713671		
5717	124	40213251	1989-02-13	1989-02-13 00:00:00	1989-02-13	1989-02-13 00:00:00	1989-02-13	581452		0	0	0		0	0	0	8236	0	21	40213251		
43974	3641	19059056	1924-08-30	1924-08-30 00:00:00	1924-09-20	1924-09-20 00:00:00	1924-09-20	38000177		0	0	21		0	0	0	242310	0	243670	19059056		
180287	3962	40213160	1955-04-22	1955-04-22 00:00:00	1955-04-22	1955-04-22 00:00:00	1955-04-22	581452		0	0	0		0	0	0	263419	0	10	40213160		
216204	4745	40213160	1975-09-10	1975-09-10 00:00:00	1975-09-10	1975-09-10 00:00:00	1975-09-10	581452		0	0	0		0	0	0	315913	0	10	40213160		
91725	2013	40213227	2007-03-24	2007-03-24 00:00:00	2007-03-24	2007-03-24 00:00:00	2007-03-24	581452		0	0	0		0	0	0	133978	0	113	40213227		
2754	222	920300	2008-09-23	2008-09-23 00:00:00	2008-09-30	2008-09-30 00:00:00	2008-09-30	38000177		0	0	7		0	0	0	14952	0	311989	920300		
37947	828	40213227	2004-02-10	2004-02-10 00:00:00	2004-02-10	2004-02-10 00:00:00	2004-02-10	581452		0	0	0		0	0	0	54876	0	113	40213227		
32223	2672	1713671	1975-03-20	1975-03-20 00:00:00	1975-03-27	1975-03-27 00:00:00	1975-03-27	38000177		0	0	7		0	0	0	177014	0	562251	1713671		
61246	5096	1115171	2001-02-14	2001-02-14 00:00:00	2001-02-28	2001-02-28 00:00:00	2001-02-28	38000177		0	0	14		0	0	0	338606	0	849574	1115171		
30455	2525	1713671	1996-08-06	1996-08-06 00:00:00	1996-08-13	1996-08-13 00:00:00	1996-08-13	38000177		0	0	7		0	0	0	166943	0	562251	1713671		
16302	1352	19079524	1976-07-29	1976-07-29 00:00:00	1976-07-30	1976-07-30 00:00:00	1976-07-30	38000177		0	0	1		0	0	0	89606	0	313002	19079524		
10578	882	40220960	2016-12-10	2016-12-10 00:00:00	2016-12-10	2016-12-10 00:00:00	2016-12-10	38000177		0	0	0		0	0	0	58720	0	1804799	40220960		
9705	812	1118084	2004-12-14	2004-12-14 00:00:00	2004-12-14	2004-12-14 00:00:00	\N	38000177		0	0	0		0	0	0	53870	0	00025152531	44923712		
5107	426	1127433	1981-03-26	1981-03-26 00:00:00	1981-04-09	1981-04-09 00:00:00	1981-04-09	38000177		0	0	14		0	0	0	28275	0	313782	1127433		
24066	1980	40229134	1975-07-07	1975-07-07 00:00:00	1975-07-21	1975-07-21 00:00:00	1975-07-21	38000177		0	0	14		0	0	0	131823	0	1043400	40229134		
23862	1965	1118084	2010-04-09	2010-04-09 00:00:00	2010-04-09	2010-04-09 00:00:00	\N	38000177		0	0	0		0	0	0	130646	0	00025152531	44923712		
226305	4970	40213201	1989-10-25	1989-10-25 00:00:00	1989-10-25	1989-10-25 00:00:00	1989-10-25	581452		0	0	0		0	0	0	330393	0	33	40213201		
16658	1381	1127433	2017-04-25	2017-04-25 00:00:00	2017-05-02	2017-05-02 00:00:00	2017-05-02	38000177		0	0	7		0	0	0	91584	0	313782	1127433		
8799	733	1124300	1980-05-07	1980-05-07 00:00:00	1980-05-07	1980-05-07 00:00:00	\N	38000177		0	0	0		0	0	0	48608	0	00781178901	45011828		
42361	3513	19019979	1976-07-26	1976-07-26 00:00:00	1976-08-09	1976-08-09 00:00:00	1976-08-09	38000177		0	0	14		0	0	0	233105	0	198405	19019979		
93762	2058	40213160	1967-04-05	1967-04-05 00:00:00	1967-04-05	1967-04-05 00:00:00	1967-04-05	581452		0	0	0		0	0	0	136895	0	10	40213160		
137629	3020	40213160	1957-09-11	1957-09-11 00:00:00	1957-09-11	1957-09-11 00:00:00	1957-09-11	581452		0	0	0		0	0	0	201414	0	10	40213160		
242848	5331	40213160	1964-04-08	1964-04-08 00:00:00	1964-04-08	1964-04-08 00:00:00	1964-04-08	581452		0	0	0		0	0	0	354950	0	10	40213160		
112436	2470	40213227	2000-01-17	2000-01-17 00:00:00	2000-01-17	2000-01-17 00:00:00	2000-01-17	581452		0	0	0		0	0	0	163802	0	113	40213227		
5307	115	40213296	2001-07-08	2001-07-08 00:00:00	2001-07-08	2001-07-08 00:00:00	2001-07-08	581452		0	0	0		0	0	0	7586	0	52	40213296		
132158	2903	40213296	2003-09-21	2003-09-21 00:00:00	2003-09-21	2003-09-21 00:00:00	2003-09-21	581452		0	0	0		0	0	0	193454	0	52	40213296		
218746	4801	40213160	1976-07-03	1976-07-03 00:00:00	1976-07-03	1976-07-03 00:00:00	1976-07-03	581452		0	0	0		0	0	0	319371	0	10	40213160		
162289	3569	40213160	1959-02-10	1959-02-10 00:00:00	1959-02-10	1959-02-10 00:00:00	1959-02-10	581452		0	0	0		0	0	0	237169	0	10	40213160		
106891	2343	40213160	1956-06-23	1956-06-23 00:00:00	1956-06-23	1956-06-23 00:00:00	1956-06-23	581452		0	0	0		0	0	0	155974	0	10	40213160		
225752	4957	40213296	2013-10-19	2013-10-19 00:00:00	2013-10-19	2013-10-19 00:00:00	2013-10-19	581452		0	0	0		0	0	0	329563	0	52	40213296		
109507	2404	40213227	2016-12-11	2016-12-11 00:00:00	2016-12-11	2016-12-11 00:00:00	2016-12-11	581452		0	0	0		0	0	0	159781	0	113	40213227		
210457	4615	40213160	1955-07-27	1955-07-27 00:00:00	1955-07-27	1955-07-27 00:00:00	1955-07-27	581452		0	0	0		0	0	0	307460	0	10	40213160		
215920	4736	40213227	2014-09-26	2014-09-26 00:00:00	2014-09-26	2014-09-26 00:00:00	2014-09-26	581452		0	0	0		0	0	0	315501	0	113	40213227		
103686	2274	40213227	2018-07-22	2018-07-22 00:00:00	2018-07-22	2018-07-22 00:00:00	2018-07-22	581452		0	0	0		0	0	0	151179	0	113	40213227		
49776	4130	19112599	1966-12-10	1966-12-10 00:00:00	1966-12-10	1966-12-10 00:00:00	\N	38000177		0	0	0		0	0	0	274558	0	477045	19112599		
99570	2180	40213251	1984-09-15	1984-09-15 00:00:00	1984-09-15	1984-09-15 00:00:00	1984-09-15	581452		0	0	0		0	0	0	145427	0	21	40213251		
13066	1098	1127433	2011-10-13	2011-10-13 00:00:00	2011-11-03	2011-11-03 00:00:00	2011-11-03	38000177		0	0	21		0	0	0	72031	0	313782	1127433		
46562	3856	920300	1998-10-23	1998-10-23 00:00:00	1998-10-29	1998-10-29 00:00:00	1998-10-29	38000177		0	0	6		0	0	0	255892	0	311989	920300		
57468	1257	40213160	1973-04-07	1973-04-07 00:00:00	1973-04-07	1973-04-07 00:00:00	1973-04-07	581452		0	0	0		0	0	0	82832	0	10	40213160		
219200	4811	40213160	1962-12-24	1962-12-24 00:00:00	1962-12-24	1962-12-24 00:00:00	1962-12-24	581452		0	0	0		0	0	0	320030	0	10	40213160		
3479	289	1127433	2014-08-19	2014-08-19 00:00:00	2014-08-26	2014-08-26 00:00:00	2014-08-26	38000177		0	0	7		0	0	0	19310	0	313782	1127433		
63947	5312	40173590	1998-12-14	1998-12-14 00:00:00	1998-12-14	1998-12-14 00:00:00	\N	38000177		0	0	0		0	0	0	353233	0	904419	40173590		
56243	4668	40231925	1987-06-29	1987-06-29 00:00:00	1987-06-29	1987-06-29 00:00:00	\N	38000177		0	0	0		0	0	0	311069	0	1049221	40231925		
53759	4470	1127433	1996-11-30	1996-11-30 00:00:00	1996-12-07	1996-12-07 00:00:00	1996-12-07	38000177		0	0	7		0	0	0	297391	0	313782	1127433		
169797	3733	40213160	1976-04-20	1976-04-20 00:00:00	1976-04-20	1976-04-20 00:00:00	1976-04-20	581452		0	0	0		0	0	0	248064	0	10	40213160		
42002	3481	1115171	2007-07-02	2007-07-02 00:00:00	2007-07-16	2007-07-16 00:00:00	2007-07-16	38000177		0	0	14		0	0	0	230887	0	849574	1115171		
188428	4137	40213260	2012-02-01	2012-02-01 00:00:00	2012-02-01	2012-02-01 00:00:00	2012-02-01	581452		0	0	0		0	0	0	275026	0	121	40213260		
181200	3982	40213201	2005-01-07	2005-01-07 00:00:00	2005-01-07	2005-01-07 00:00:00	2005-01-07	581452		0	0	0		0	0	0	264673	0	33	40213201		
50008	4149	19078461	2007-06-04	2007-06-04 00:00:00	2007-06-25	2007-06-25 00:00:00	2007-06-25	38000177		0	0	21		0	0	0	275761	0	310965	19078461		
34762	2869	1127078	1962-09-19	1962-09-19 00:00:00	1962-10-19	1962-10-19 00:00:00	1962-10-19	38000177		0	0	30		0	0	0	190824	0	282464	1127078		
130472	2867	40213160	1979-04-24	1979-04-24 00:00:00	1979-04-24	1979-04-24 00:00:00	1979-04-24	581452		0	0	0		0	0	0	190706	0	10	40213160		
91893	2017	40213227	2001-06-12	2001-06-12 00:00:00	2001-06-12	2001-06-12 00:00:00	2001-06-12	581452		0	0	0		0	0	0	134184	0	113	40213227		
183678	4035	40213227	2003-06-03	2003-06-03 00:00:00	2003-06-03	2003-06-03 00:00:00	2003-06-03	581452		0	0	0		0	0	0	268455	0	113	40213227		
36819	3044	1118084	2007-09-29	2007-09-29 00:00:00	2007-09-29	2007-09-29 00:00:00	\N	38000177		0	0	0		0	0	0	202642	0	00025152531	44923712		
403	9	40213314	1979-09-27	1979-09-27 00:00:00	1979-09-27	1979-09-27 00:00:00	1979-09-27	581452		0	0	0		0	0	0	853	0	49	40213314		
37370	3087	19133873	1943-05-05	1943-05-05 00:00:00	1943-05-16	1943-05-16 00:00:00	1943-05-16	38000177		0	0	11		0	0	0	205560	0	834061	19133873		
121126	2662	40213314	1978-10-06	1978-10-06 00:00:00	1978-10-06	1978-10-06 00:00:00	1978-10-06	581452		0	0	0		0	0	0	176435	0	49	40213314		
37481	3098	40165015	2019-06-23	2019-06-23 00:00:00	2019-06-23	2019-06-23 00:00:00	\N	38000177		0	0	0		0	0	0	206195	0	861467	40165015		
33539	2776	19129655	1978-05-28	1978-05-28 00:00:00	1978-06-11	1978-06-11 00:00:00	1978-06-11	38000177		0	0	14		0	0	0	183793	0	789980	19129655		
15793	1314	19126352	2012-01-14	2012-01-14 00:00:00	2012-01-14	2012-01-14 00:00:00	\N	38000177		0	0	0		0	0	0	87014	0	705129	19126352		
33277	2758	19059056	1943-12-02	1943-12-02 00:00:00	1943-12-23	1943-12-23 00:00:00	1943-12-23	38000177		0	0	21		0	0	0	182455	0	243670	19059056		
141414	3106	40213227	1992-07-20	1992-07-20 00:00:00	1992-07-20	1992-07-20 00:00:00	1992-07-20	581452		0	0	0		0	0	0	206562	0	113	40213227		
239620	5259	40213160	1959-02-02	1959-02-02 00:00:00	1959-02-02	1959-02-02 00:00:00	1959-02-02	581452		0	0	0		0	0	0	349973	0	10	40213160		
18771	1551	1127433	1979-08-19	1979-08-19 00:00:00	1979-11-17	1979-11-17 00:00:00	1979-11-17	38000177		0	0	90		0	0	0	103883	0	313782	1127433		
5720	124	40213160	1989-02-13	1989-02-13 00:00:00	1989-02-13	1989-02-13 00:00:00	1989-02-13	581452		0	0	0		0	0	0	8236	0	10	40213160		
43975	3641	40165015	1992-11-30	1992-11-30 00:00:00	1992-11-30	1992-11-30 00:00:00	\N	38000177		0	0	0		0	0	0	242315	0	861467	40165015		
180289	3962	40213201	2018-03-23	2018-03-23 00:00:00	2018-03-23	2018-03-23 00:00:00	2018-03-23	581452		0	0	0		0	0	0	263400	0	33	40213201		
216206	4745	40213314	1977-09-07	1977-09-07 00:00:00	1977-09-07	1977-09-07 00:00:00	1977-09-07	581452		0	0	0		0	0	0	315975	0	49	40213314		
91727	2013	40213260	2007-03-24	2007-03-24 00:00:00	2007-03-24	2007-03-24 00:00:00	2007-03-24	581452		0	0	0		0	0	0	133978	0	121	40213260		
142169	3123	40213227	2018-10-24	2018-10-24 00:00:00	2018-10-24	2018-10-24 00:00:00	2018-10-24	581452		0	0	0		0	0	0	207845	0	113	40213227		
61111	5081	19059056	1946-10-14	1946-10-14 00:00:00	1946-10-28	1946-10-28 00:00:00	1946-10-28	38000177		0	0	14		0	0	0	337836	0	243670	19059056		
32224	2672	1127433	1980-04-12	1980-04-12 00:00:00	1980-04-26	1980-04-26 00:00:00	1980-04-26	38000177		0	0	14		0	0	0	177026	0	313782	1127433		
61247	5096	1127433	2000-09-02	2000-09-02 00:00:00	2000-09-16	2000-09-16 00:00:00	2000-09-16	38000177		0	0	14		0	0	0	338579	0	313782	1127433		
30456	2525	19128065	1988-01-01	1988-01-01 00:00:00	1988-12-26	1988-12-26 00:00:00	1988-12-26	38000177		0	0	360		0	0	0	166945	0	749882	19128065		
16303	1352	46275444	1976-07-29	1976-07-29 00:00:00	1976-07-29	1976-07-29 00:00:00	1976-07-29	38000177		0	0	0		0	0	0	89606	0	1659149	46275444		
10579	882	19075601	2016-12-10	2016-12-10 00:00:00	2016-12-10	2016-12-10 00:00:00	2016-12-10	38000177		0	0	0		0	0	0	58720	0	309362	19075601		
9706	812	1713671	1978-08-26	1978-08-26 00:00:00	1978-09-02	1978-09-02 00:00:00	1978-09-02	38000177		0	0	7		0	0	0	53834	0	562251	1713671		
5108	426	1713671	1990-06-14	1990-06-14 00:00:00	1990-07-05	1990-07-05 00:00:00	1990-07-05	38000177		0	0	21		0	0	0	28276	0	562251	1713671		
24067	1980	1127433	1985-03-22	1985-03-22 00:00:00	1985-04-05	1985-04-05 00:00:00	1985-04-05	38000177		0	0	14		0	0	0	131880	0	313782	1127433		
23863	1965	1127078	1976-01-13	1976-01-13 00:00:00	1976-01-27	1976-01-27 00:00:00	1976-01-27	38000177		0	0	14		0	0	0	130655	0	282464	1127078		
226310	4970	40213227	1994-11-23	1994-11-23 00:00:00	1994-11-23	1994-11-23 00:00:00	1994-11-23	581452		0	0	0		0	0	0	330487	0	113	40213227		
16659	1381	19133905	2016-08-21	2016-08-21 00:00:00	2016-09-02	2016-09-02 00:00:00	2016-09-02	38000177		0	0	12		0	0	0	91583	0	834102	19133905		
8800	733	19133873	1944-12-31	1944-12-31 00:00:00	1945-01-08	1945-01-08 00:00:00	1945-01-08	38000177		0	0	8		0	0	0	48652	0	834061	19133873		
42362	3513	1127433	1991-02-18	1991-02-18 00:00:00	1991-02-25	1991-02-25 00:00:00	1991-02-25	38000177		0	0	7		0	0	0	233130	0	313782	1127433		
93766	2058	40213160	1967-02-01	1967-02-01 00:00:00	1967-02-01	1967-02-01 00:00:00	1967-02-01	581452		0	0	0		0	0	0	136916	0	10	40213160		
124705	2743	40213227	2002-04-17	2002-04-17 00:00:00	2002-04-17	2002-04-17 00:00:00	2002-04-17	581452		0	0	0		0	0	0	181486	0	113	40213227		
242850	5331	40213227	2005-08-10	2005-08-10 00:00:00	2005-08-10	2005-08-10 00:00:00	2005-08-10	581452		0	0	0		0	0	0	354946	0	113	40213227		
112438	2470	40213296	2000-01-17	2000-01-17 00:00:00	2000-01-17	2000-01-17 00:00:00	2000-01-17	581452		0	0	0		0	0	0	163802	0	52	40213296		
5309	115	40213160	1964-10-11	1964-10-11 00:00:00	1964-10-11	1964-10-11 00:00:00	1964-10-11	581452		0	0	0		0	0	0	7640	0	10	40213160		
140681	3088	40213227	2011-03-04	2011-03-04 00:00:00	2011-03-04	2011-03-04 00:00:00	2011-03-04	581452		0	0	0		0	0	0	205671	0	113	40213227		
218750	4801	40213227	2002-10-05	2002-10-05 00:00:00	2002-10-05	2002-10-05 00:00:00	2002-10-05	581452		0	0	0		0	0	0	319415	0	113	40213227		
162290	3569	40213160	1963-10-15	1963-10-15 00:00:00	1963-10-15	1963-10-15 00:00:00	1963-10-15	581452		0	0	0		0	0	0	237146	0	10	40213160		
106900	2343	40213260	2006-01-14	2006-01-14 00:00:00	2006-01-14	2006-01-14 00:00:00	2006-01-14	581452		0	0	0		0	0	0	155943	0	121	40213260		
225753	4957	40213160	1972-06-10	1972-06-10 00:00:00	1972-06-10	1972-06-10 00:00:00	1972-06-10	581452		0	0	0		0	0	0	329525	0	10	40213160		
109508	2404	40213260	2016-12-11	2016-12-11 00:00:00	2016-12-11	2016-12-11 00:00:00	2016-12-11	581452		0	0	0		0	0	0	159781	0	121	40213260		
210461	4615	40213296	1998-02-04	1998-02-04 00:00:00	1998-02-04	1998-02-04 00:00:00	1998-02-04	581452		0	0	0		0	0	0	307390	0	52	40213296		
215921	4736	40213296	2014-09-26	2014-09-26 00:00:00	2014-09-26	2014-09-26 00:00:00	2014-09-26	581452		0	0	0		0	0	0	315501	0	52	40213296		
103692	2274	40213201	2013-06-02	2013-06-02 00:00:00	2013-06-02	2013-06-02 00:00:00	2013-06-02	581452		0	0	0		0	0	0	151176	0	33	40213201		
56417	4680	1127433	1995-01-24	1995-01-24 00:00:00	1995-02-23	1995-02-23 00:00:00	1995-02-23	38000177		0	0	30		0	0	0	311952	0	313782	1127433		
99576	2180	40213227	2001-05-26	2001-05-26 00:00:00	2001-05-26	2001-05-26 00:00:00	2001-05-26	581452		0	0	0		0	0	0	145431	0	113	40213227		
13067	1098	19078461	2016-11-06	2016-11-06 00:00:00	2016-11-27	2016-11-27 00:00:00	2016-11-27	38000177		0	0	21		0	0	0	72032	0	310965	19078461		
46563	3857	40229134	1972-05-25	1972-05-25 00:00:00	1972-06-08	1972-06-08 00:00:00	1972-06-08	38000177		0	0	14		0	0	0	255982	0	1043400	40229134		
57472	1258	40213160	1967-06-19	1967-06-19 00:00:00	1967-06-19	1967-06-19 00:00:00	1967-06-19	581452		0	0	0		0	0	0	82852	0	10	40213160		
219201	4811	40213160	1962-07-24	1962-07-24 00:00:00	1962-07-24	1962-07-24 00:00:00	1962-07-24	581452		0	0	0		0	0	0	320070	0	10	40213160		
3481	289	1127078	1961-01-04	1961-01-04 00:00:00	1961-01-18	1961-01-18 00:00:00	1961-01-18	38000177		0	0	14		0	0	0	19312	0	282464	1127078		
63948	5312	1127433	1961-12-09	1961-12-09 00:00:00	1961-12-16	1961-12-16 00:00:00	1961-12-16	38000177		0	0	7		0	0	0	353249	0	313782	1127433		
56245	4668	1127433	1985-06-02	1985-06-02 00:00:00	1985-08-31	1985-08-31 00:00:00	1985-08-31	38000177		0	0	90		0	0	0	311085	0	313782	1127433		
53760	4470	19059056	1992-05-23	1992-05-23 00:00:00	1992-06-13	1992-06-13 00:00:00	1992-06-13	38000177		0	0	21		0	0	0	297387	0	243670	19059056		
169809	3733	40213227	2017-11-21	2017-11-21 00:00:00	2017-11-21	2017-11-21 00:00:00	2017-11-21	581452		0	0	0		0	0	0	248066	0	113	40213227		
42003	3481	19075601	1999-07-03	1999-07-03 00:00:00	2015-04-04	2015-04-04 00:00:00	2015-04-04	38000177		0	0	5754		0	0	0	230879	0	309362	19075601		
129334	2844	40213227	1999-03-15	1999-03-15 00:00:00	1999-03-15	1999-03-15 00:00:00	1999-03-15	581452		0	0	0		0	0	0	188886	0	113	40213227		
181243	3982	40213227	1992-10-30	1992-10-30 00:00:00	1992-10-30	1992-10-30 00:00:00	1992-10-30	581452		0	0	0		0	0	0	264681	0	113	40213227		
50009	4149	19133905	2005-06-25	2005-06-25 00:00:00	2005-07-03	2005-07-03 00:00:00	2005-07-03	38000177		0	0	8		0	0	0	275713	0	834102	19133905		
34763	2869	19059056	1974-03-04	1974-03-04 00:00:00	1974-03-25	1974-03-25 00:00:00	1974-03-25	38000177		0	0	21		0	0	0	190826	0	243670	19059056		
130475	2867	40213296	2018-08-21	2018-08-21 00:00:00	2018-08-21	2018-08-21 00:00:00	2018-08-21	581452		0	0	0		0	0	0	190718	0	52	40213296		
91895	2017	40213296	2011-09-06	2011-09-06 00:00:00	2011-09-06	2011-09-06 00:00:00	2011-09-06	581452		0	0	0		0	0	0	134180	0	52	40213296		
183680	4035	40213227	1994-05-24	1994-05-24 00:00:00	1994-05-24	1994-05-24 00:00:00	1994-05-24	581452		0	0	0		0	0	0	268452	0	113	40213227		
36820	3044	19133905	2017-01-30	2017-01-30 00:00:00	2017-02-09	2017-02-09 00:00:00	2017-02-09	38000177		0	0	10		0	0	0	202643	0	834102	19133905		
407	9	40213160	1983-06-30	1983-06-30 00:00:00	1983-06-30	1983-06-30 00:00:00	1983-06-30	581452		0	0	0		0	0	0	727	0	10	40213160		
37371	3087	19059056	1941-02-13	1941-02-13 00:00:00	1941-02-27	1941-02-27 00:00:00	1941-02-27	38000177		0	0	14		0	0	0	205522	0	243670	19059056		
121129	2662	40213227	2009-12-03	2009-12-03 00:00:00	2009-12-03	2009-12-03 00:00:00	2009-12-03	581452		0	0	0		0	0	0	176428	0	113	40213227		
37482	3098	19078461	2009-01-02	2009-01-02 00:00:00	2009-01-16	2009-01-16 00:00:00	2009-01-16	38000177		0	0	14		0	0	0	206194	0	310965	19078461		
33540	2776	1127078	1978-05-28	1978-05-28 00:00:00	1978-06-11	1978-06-11 00:00:00	1978-06-11	38000177		0	0	14		0	0	0	183793	0	282464	1127078		
15794	1314	19075601	2012-01-14	2012-01-14 00:00:00	2012-01-14	2012-01-14 00:00:00	\N	38000177		0	0	0		0	0	0	87014	0	309362	19075601		
33278	2758	1127433	1978-06-22	1978-06-22 00:00:00	1978-07-06	1978-07-06 00:00:00	1978-07-06	38000177		0	0	14		0	0	0	182456	0	313782	1127433		
141418	3106	40213227	2012-06-18	2012-06-18 00:00:00	2012-06-18	2012-06-18 00:00:00	2012-06-18	581452		0	0	0		0	0	0	206584	0	113	40213227		
239623	5259	40213160	1959-07-06	1959-07-06 00:00:00	1959-07-06	1959-07-06 00:00:00	1959-07-06	581452		0	0	0		0	0	0	349974	0	10	40213160		
18772	1551	1127433	1996-12-05	1996-12-05 00:00:00	1996-12-19	1996-12-19 00:00:00	1996-12-19	38000177		0	0	14		0	0	0	103868	0	313782	1127433		
5727	124	40213180	2007-02-19	2007-02-19 00:00:00	2007-02-19	2007-02-19 00:00:00	2007-02-19	581452		0	0	0		0	0	0	8342	0	114	40213180		
43976	3641	1127433	1992-11-30	1992-11-30 00:00:00	1993-02-28	1993-02-28 00:00:00	1993-02-28	38000177		0	0	90		0	0	0	242315	0	313782	1127433		
180294	3962	40213227	2002-12-27	2002-12-27 00:00:00	2002-12-27	2002-12-27 00:00:00	2002-12-27	581452		0	0	0		0	0	0	263393	0	113	40213227		
216208	4745	40213227	1998-03-11	1998-03-11 00:00:00	1998-03-11	1998-03-11 00:00:00	1998-03-11	581452		0	0	0		0	0	0	315918	0	113	40213227		
91740	2013	40213227	2017-05-20	2017-05-20 00:00:00	2017-05-20	2017-05-20 00:00:00	2017-05-20	581452		0	0	0		0	0	0	133999	0	113	40213227		
142170	3123	40213296	2018-10-24	2018-10-24 00:00:00	2018-10-24	2018-10-24 00:00:00	2018-10-24	581452		0	0	0		0	0	0	207845	0	52	40213296		
61112	5081	19059056	1951-05-01	1951-05-01 00:00:00	1951-05-15	1951-05-15 00:00:00	1951-05-15	38000177		0	0	14		0	0	0	337901	0	243670	19059056		
32226	2672	19059056	1956-05-28	1956-05-28 00:00:00	1956-06-11	1956-06-11 00:00:00	1956-06-11	38000177		0	0	14		0	0	0	176943	0	243670	19059056		
61248	5096	19059056	1972-11-12	1972-11-12 00:00:00	1972-11-26	1972-11-26 00:00:00	1972-11-26	38000177		0	0	14		0	0	0	338615	0	243670	19059056		
30457	2525	1127433	1996-05-09	1996-05-09 00:00:00	1996-05-23	1996-05-23 00:00:00	1996-05-23	38000177		0	0	14		0	0	0	166953	0	313782	1127433		
16304	1352	40169281	1995-08-20	1995-08-20 00:00:00	1995-08-20	1995-08-20 00:00:00	\N	38000177		0	0	0		0	0	0	89586	0	896209	40169281		
10580	882	19006318	1946-10-25	1946-10-25 00:00:00	1946-11-08	1946-11-08 00:00:00	1946-11-08	38000177		0	0	14		0	0	0	58679	0	105078	19006318		
9707	812	1127078	1970-01-07	1970-01-07 00:00:00	1970-01-21	1970-01-21 00:00:00	1970-01-21	38000177		0	0	14		0	0	0	53887	0	282464	1127078		
5109	426	19133873	1967-12-05	1967-12-05 00:00:00	1967-12-15	1967-12-15 00:00:00	1967-12-15	38000177		0	0	10		0	0	0	28257	0	834061	19133873		
24068	1980	40229134	2006-01-23	2006-01-23 00:00:00	2006-02-06	2006-02-06 00:00:00	2006-02-06	38000177		0	0	14		0	0	0	131832	0	1043400	40229134		
23864	1965	46233988	1976-01-13	1976-01-13 00:00:00	1976-01-27	1976-01-27 00:00:00	1976-01-27	38000177		0	0	14		0	0	0	130655	0	1652673	46233988		
126103	2774	40213227	2012-03-16	2012-03-16 00:00:00	2012-03-16	2012-03-16 00:00:00	2012-03-16	581452		0	0	0		0	0	0	183737	0	113	40213227		
16660	1381	1713671	2010-08-08	2010-08-08 00:00:00	2010-08-29	2010-08-29 00:00:00	2010-08-29	38000177		0	0	21		0	0	0	91588	0	562251	1713671		
8801	733	1127433	1999-05-04	1999-05-04 00:00:00	1999-05-11	1999-05-11 00:00:00	1999-05-11	38000177		0	0	7		0	0	0	48617	0	313782	1127433		
167	12	1127433	1974-10-08	1974-10-08 00:00:00	1974-10-15	1974-10-15 00:00:00	1974-10-15	38000177		0	0	7		0	0	0	1041	0	313782	1127433		
93770	2058	40213227	2008-11-05	2008-11-05 00:00:00	2008-11-05	2008-11-05 00:00:00	2008-11-05	581452		0	0	0		0	0	0	136914	0	113	40213227		
124706	2743	40213296	2002-04-17	2002-04-17 00:00:00	2002-04-17	2002-04-17 00:00:00	2002-04-17	581452		0	0	0		0	0	0	181486	0	52	40213296		
242851	5331	40213296	2005-08-10	2005-08-10 00:00:00	2005-08-10	2005-08-10 00:00:00	2005-08-10	581452		0	0	0		0	0	0	354946	0	52	40213296		
112449	2470	40213160	1959-08-24	1959-08-24 00:00:00	1959-08-24	1959-08-24 00:00:00	1959-08-24	581452		0	0	0		0	0	0	163806	0	10	40213160		
5313	115	40213227	1992-11-22	1992-11-22 00:00:00	1992-11-22	1992-11-22 00:00:00	1992-11-22	581452		0	0	0		0	0	0	7610	0	113	40213227		
207396	4550	40213296	2002-09-15	2002-09-15 00:00:00	2002-09-15	2002-09-15 00:00:00	2002-09-15	581452		0	0	0		0	0	0	303186	0	52	40213296		
218756	4801	40213306	1993-09-25	1993-09-25 00:00:00	1993-09-25	1993-09-25 00:00:00	1993-09-25	581452		0	0	0		0	0	0	319412	0	43	40213306		
162293	3569	40213306	1981-02-03	1981-02-03 00:00:00	1981-02-03	1981-02-03 00:00:00	1981-02-03	581452		0	0	0		0	0	0	237196	0	43	40213306		
106903	2343	40213227	2007-01-20	2007-01-20 00:00:00	2007-01-20	2007-01-20 00:00:00	2007-01-20	581452		0	0	0		0	0	0	155996	0	113	40213227		
225761	4957	40213160	1976-09-11	1976-09-11 00:00:00	1976-09-11	1976-09-11 00:00:00	1976-09-11	581452		0	0	0		0	0	0	329549	0	10	40213160		
109513	2404	40213160	1970-11-15	1970-11-15 00:00:00	1970-11-15	1970-11-15 00:00:00	1970-11-15	581452		0	0	0		0	0	0	159741	0	10	40213160		
210463	4615	40213227	1998-02-04	1998-02-04 00:00:00	1998-02-04	1998-02-04 00:00:00	1998-02-04	581452		0	0	0		0	0	0	307390	0	113	40213227		
215925	4736	40213227	2003-10-17	2003-10-17 00:00:00	2003-10-17	2003-10-17 00:00:00	2003-10-17	581452		0	0	0		0	0	0	315493	0	113	40213227		
132931	2919	40213227	1993-09-04	1993-09-04 00:00:00	1993-09-04	1993-09-04 00:00:00	1993-09-04	581452		0	0	0		0	0	0	194623	0	113	40213227		
56419	4680	1127433	1987-05-15	1987-05-15 00:00:00	1987-07-14	1987-07-14 00:00:00	1987-07-14	38000177		0	0	60		0	0	0	311950	0	313782	1127433		
99577	2180	40213306	2001-05-26	2001-05-26 00:00:00	2001-05-26	2001-05-26 00:00:00	2001-05-26	581452		0	0	0		0	0	0	145431	0	43	40213306		
13068	1098	19059056	1975-02-19	1975-02-19 00:00:00	1975-03-05	1975-03-05 00:00:00	1975-03-05	38000177		0	0	14		0	0	0	72029	0	243670	19059056		
46565	3857	1127433	2015-07-09	2015-07-09 00:00:00	2015-07-16	2015-07-16 00:00:00	2015-07-16	38000177		0	0	7		0	0	0	256007	0	313782	1127433		
57480	1258	40213227	2018-03-19	2018-03-19 00:00:00	2018-03-19	2018-03-19 00:00:00	2018-03-19	581452		0	0	0		0	0	0	82874	0	113	40213227		
219203	4811	40213160	1967-03-27	1967-03-27 00:00:00	1967-03-27	1967-03-27 00:00:00	1967-03-27	581452		0	0	0		0	0	0	320086	0	10	40213160		
3482	289	19006318	1961-01-04	1961-01-04 00:00:00	1961-01-18	1961-01-18 00:00:00	1961-01-18	38000177		0	0	14		0	0	0	19312	0	105078	19006318		
63949	5312	19133905	1995-01-14	1995-01-14 00:00:00	1995-01-22	1995-01-22 00:00:00	1995-01-22	38000177		0	0	8		0	0	0	353270	0	834102	19133905		
56246	4668	1127078	1958-07-13	1958-07-13 00:00:00	1958-07-27	1958-07-27 00:00:00	1958-07-27	38000177		0	0	14		0	0	0	311038	0	282464	1127078		
62537	1368	40213160	1956-06-27	1956-06-27 00:00:00	1956-06-27	1956-06-27 00:00:00	1956-06-27	581452		0	0	0		0	0	0	90667	0	10	40213160		
169810	3733	40213296	2017-11-21	2017-11-21 00:00:00	2017-11-21	2017-11-21 00:00:00	2017-11-21	581452		0	0	0		0	0	0	248066	0	52	40213296		
42004	3481	1118084	2014-06-05	2014-06-05 00:00:00	2014-06-05	2014-06-05 00:00:00	\N	38000177		0	0	0		0	0	0	230845	0	00025152531	44923712		
129347	2844	40213201	2014-06-09	2014-06-09 00:00:00	2014-06-09	2014-06-09 00:00:00	2014-06-09	581452		0	0	0		0	0	0	188891	0	33	40213201		
181245	3982	40213227	1999-12-10	1999-12-10 00:00:00	1999-12-10	1999-12-10 00:00:00	1999-12-10	581452		0	0	0		0	0	0	264682	0	113	40213227		
50010	4149	19133873	1973-11-16	1973-11-16 00:00:00	1973-11-27	1973-11-27 00:00:00	1973-11-27	38000177		0	0	11		0	0	0	275740	0	834061	19133873		
34764	2869	1127078	1953-11-07	1953-11-07 00:00:00	1953-11-21	1953-11-21 00:00:00	1953-11-21	38000177		0	0	14		0	0	0	190895	0	282464	1127078		
130477	2867	40213160	1978-11-21	1978-11-21 00:00:00	1978-11-21	1978-11-21 00:00:00	1978-11-21	581452		0	0	0		0	0	0	190727	0	10	40213160		
91897	2017	40213227	2011-09-06	2011-09-06 00:00:00	2011-09-06	2011-09-06 00:00:00	2011-09-06	581452		0	0	0		0	0	0	134180	0	113	40213227		
183681	4035	40213306	1994-05-24	1994-05-24 00:00:00	1994-05-24	1994-05-24 00:00:00	1994-05-24	581452		0	0	0		0	0	0	268452	0	43	40213306		
36821	3044	46233988	1971-01-23	1971-01-23 00:00:00	1971-02-06	1971-02-06 00:00:00	1971-02-06	38000177		0	0	14		0	0	0	202606	0	1652673	46233988		
412	9	40213296	2018-10-25	2018-10-25 00:00:00	2018-10-25	2018-10-25 00:00:00	2018-10-25	581452		0	0	0		0	0	0	733	0	52	40213296		
37372	3087	1118084	1976-04-05	1976-04-05 00:00:00	1976-04-05	1976-04-05 00:00:00	\N	38000177		0	0	0		0	0	0	205597	0	00025152531	44923712		
121134	2662	40213160	1979-01-04	1979-01-04 00:00:00	1979-01-04	1979-01-04 00:00:00	1979-01-04	581452		0	0	0		0	0	0	176412	0	10	40213160		
37483	3098	19128065	1974-09-08	1974-09-08 00:00:00	1975-09-03	1975-09-03 00:00:00	1975-09-03	38000177		0	0	360		0	0	0	206166	0	749882	19128065		
33541	2776	19074843	1982-01-28	1982-01-28 00:00:00	1982-02-11	1982-02-11 00:00:00	1982-02-11	38000177		0	0	14		0	0	0	183815	0	309045	19074843		
24957	545	40213160	1976-09-04	1976-09-04 00:00:00	1976-09-04	1976-09-04 00:00:00	1976-09-04	581452		0	0	0		0	0	0	36113	0	10	40213160		
33279	2758	19133873	1947-01-27	1947-01-27 00:00:00	1947-02-06	1947-02-06 00:00:00	1947-02-06	38000177		0	0	10		0	0	0	182400	0	834061	19133873		
141420	3106	40213227	2001-07-16	2001-07-16 00:00:00	2001-07-16	2001-07-16 00:00:00	2001-07-16	581452		0	0	0		0	0	0	206563	0	113	40213227		
239630	5259	40213306	1981-01-05	1981-01-05 00:00:00	1981-01-05	1981-01-05 00:00:00	1981-01-05	581452		0	0	0		0	0	0	349989	0	43	40213306		
18773	1551	19075601	2018-03-12	2018-03-12 00:00:00	2018-03-12	2018-03-12 00:00:00	\N	38000177		0	0	0		0	0	0	103865	0	309362	19075601		
26437	2175	1332419	2000-11-09	2000-11-09 00:00:00	2000-11-09	2000-11-09 00:00:00	\N	38000177		0	0	0		0	0	0	145084	0	197361	1332419		
43977	3641	19059056	1915-08-18	1915-08-18 00:00:00	1915-09-17	1915-09-17 00:00:00	1915-09-17	38000177		0	0	30		0	0	0	242309	0	243670	19059056		
180304	3962	40213227	1992-11-27	1992-11-27 00:00:00	1992-11-27	1992-11-27 00:00:00	1992-11-27	581452		0	0	0		0	0	0	263472	0	113	40213227		
216209	4745	40213306	1998-03-11	1998-03-11 00:00:00	1998-03-11	1998-03-11 00:00:00	1998-03-11	581452		0	0	0		0	0	0	315918	0	43	40213306		
91745	2013	40213160	1956-11-24	1956-11-24 00:00:00	1956-11-24	1956-11-24 00:00:00	1956-11-24	581452		0	0	0		0	0	0	133943	0	10	40213160		
142171	3123	40213160	1977-12-14	1977-12-14 00:00:00	1977-12-14	1977-12-14 00:00:00	1977-12-14	581452		0	0	0		0	0	0	207826	0	10	40213160		
61113	5081	1127433	1986-09-04	1986-09-04 00:00:00	1986-09-25	1986-09-25 00:00:00	1986-09-25	38000177		0	0	21		0	0	0	337905	0	313782	1127433		
32227	2672	19006318	1956-05-28	1956-05-28 00:00:00	1956-06-11	1956-06-11 00:00:00	1956-06-11	38000177		0	0	14		0	0	0	176943	0	105078	19006318		
130521	2868	40213160	1963-03-20	1963-03-20 00:00:00	1963-03-20	1963-03-20 00:00:00	1963-03-20	581452		0	0	0		0	0	0	190767	0	10	40213160		
30458	2525	1713671	1986-08-09	1986-08-09 00:00:00	1986-08-23	1986-08-23 00:00:00	1986-08-23	38000177		0	0	14		0	0	0	166942	0	562251	1713671		
16306	1352	19133873	1947-04-05	1947-04-05 00:00:00	1947-04-14	1947-04-14 00:00:00	1947-04-14	38000177		0	0	9		0	0	0	89533	0	834061	19133873		
10581	882	19059056	1946-10-25	1946-10-25 00:00:00	1946-11-08	1946-11-08 00:00:00	1946-11-08	38000177		0	0	14		0	0	0	58679	0	243670	19059056		
9708	812	1127433	1979-09-01	1979-09-01 00:00:00	1979-10-31	1979-10-31 00:00:00	1979-10-31	38000177		0	0	60		0	0	0	53888	0	313782	1127433		
5110	426	1127433	2015-12-05	2015-12-05 00:00:00	2015-12-12	2015-12-12 00:00:00	2015-12-12	38000177		0	0	7		0	0	0	28288	0	313782	1127433		
24069	1980	19019979	1983-04-16	1983-04-16 00:00:00	1983-04-30	1983-04-30 00:00:00	1983-04-30	38000177		0	0	14		0	0	0	131805	0	198405	19019979		
23865	1965	1127078	1980-07-13	1980-07-13 00:00:00	1980-07-27	1980-07-27 00:00:00	1980-07-27	38000177		0	0	14		0	0	0	130619	0	282464	1127078		
126106	2774	40213201	2007-02-16	2007-02-16 00:00:00	2007-02-16	2007-02-16 00:00:00	2007-02-16	581452		0	0	0		0	0	0	183652	0	33	40213201		
16661	1381	1127078	1982-02-12	1982-02-12 00:00:00	1982-03-14	1982-03-14 00:00:00	1982-03-14	38000177		0	0	30		0	0	0	91563	0	282464	1127078		
8802	733	19078461	2003-09-05	2003-09-05 00:00:00	2003-11-11	2003-11-11 00:00:00	2003-11-11	38000177		0	0	67		0	0	0	48643	0	310965	19078461		
168	12	1127078	1964-08-22	1964-08-22 00:00:00	1964-09-05	1964-09-05 00:00:00	1964-09-05	38000177		0	0	14		0	0	0	1059	0	282464	1127078		
93771	2058	40213296	2008-11-05	2008-11-05 00:00:00	2008-11-05	2008-11-05 00:00:00	2008-11-05	581452		0	0	0		0	0	0	136914	0	52	40213296		
124710	2743	40213296	2000-04-12	2000-04-12 00:00:00	2000-04-12	2000-04-12 00:00:00	2000-04-12	581452		0	0	0		0	0	0	181479	0	52	40213296		
242863	5331	40213260	2014-08-06	2014-08-06 00:00:00	2014-08-06	2014-08-06 00:00:00	2014-08-06	581452		0	0	0		0	0	0	354914	0	121	40213260		
112451	2470	40213160	1959-05-25	1959-05-25 00:00:00	1959-05-25	1959-05-25 00:00:00	1959-05-25	581452		0	0	0		0	0	0	163785	0	10	40213160		
5317	115	40213296	1999-11-07	1999-11-07 00:00:00	1999-11-07	1999-11-07 00:00:00	1999-11-07	581452		0	0	0		0	0	0	7591	0	52	40213296		
207398	4550	40213306	1984-11-11	1984-11-11 00:00:00	1984-11-11	1984-11-11 00:00:00	1984-11-11	581452		0	0	0		0	0	0	303161	0	43	40213306		
218758	4801	40213227	1993-09-25	1993-09-25 00:00:00	1993-09-25	1993-09-25 00:00:00	1993-09-25	581452		0	0	0		0	0	0	319412	0	113	40213227		
162298	3569	40213227	2000-11-14	2000-11-14 00:00:00	2000-11-14	2000-11-14 00:00:00	2000-11-14	581452		0	0	0		0	0	0	237141	0	113	40213227		
106904	2343	40213260	2007-01-20	2007-01-20 00:00:00	2007-01-20	2007-01-20 00:00:00	2007-01-20	581452		0	0	0		0	0	0	155996	0	121	40213260		
225764	4957	40213160	1972-01-08	1972-01-08 00:00:00	1972-01-08	1972-01-08 00:00:00	1972-01-08	581452		0	0	0		0	0	0	329517	0	10	40213160		
109515	2404	40213227	2008-05-18	2008-05-18 00:00:00	2008-05-18	2008-05-18 00:00:00	2008-05-18	581452		0	0	0		0	0	0	159747	0	113	40213227		
217617	4776	40213160	1960-12-25	1960-12-25 00:00:00	1960-12-25	1960-12-25 00:00:00	1960-12-25	581452		0	0	0		0	0	0	318001	0	10	40213160		
215928	4736	40213160	1972-12-22	1972-12-22 00:00:00	1972-12-22	1972-12-22 00:00:00	1972-12-22	581452		0	0	0		0	0	0	315480	0	10	40213160		
132934	2919	40213227	2010-10-23	2010-10-23 00:00:00	2010-10-23	2010-10-23 00:00:00	2010-10-23	581452		0	0	0		0	0	0	194626	0	113	40213227		
56420	4680	19059056	1910-06-11	1910-06-11 00:00:00	1910-06-25	1910-06-25 00:00:00	1910-06-25	38000177		0	0	14		0	0	0	311883	0	243670	19059056		
99583	2180	40213160	1979-03-10	1979-03-10 00:00:00	1979-03-10	1979-03-10 00:00:00	1979-03-10	581452		0	0	0		0	0	0	145410	0	10	40213160		
13069	1098	1127433	1980-06-11	1980-06-11 00:00:00	1980-06-25	1980-06-25 00:00:00	1980-06-25	38000177		0	0	14		0	0	0	72026	0	313782	1127433		
46566	3857	19133873	1954-10-11	1954-10-11 00:00:00	1954-10-21	1954-10-21 00:00:00	1954-10-21	38000177		0	0	10		0	0	0	255979	0	834061	19133873		
57481	1258	40213260	2018-03-19	2018-03-19 00:00:00	2018-03-19	2018-03-19 00:00:00	2018-03-19	581452		0	0	0		0	0	0	82874	0	121	40213260		
219208	4811	40213227	2003-07-08	2003-07-08 00:00:00	2003-07-08	2003-07-08 00:00:00	2003-07-08	581452		0	0	0		0	0	0	320036	0	113	40213227		
3483	289	1127433	2010-10-17	2010-10-17 00:00:00	2010-10-31	2010-10-31 00:00:00	2010-10-31	38000177		0	0	14		0	0	0	19283	0	313782	1127433		
63950	5312	19133905	1961-07-13	1961-07-13 00:00:00	1961-07-26	1961-07-26 00:00:00	1961-07-26	38000177		0	0	13		0	0	0	353283	0	834102	19133905		
56247	4668	19006318	1958-07-13	1958-07-13 00:00:00	1958-07-27	1958-07-27 00:00:00	1958-07-27	38000177		0	0	14		0	0	0	311038	0	105078	19006318		
62542	1368	40213227	1998-10-07	1998-10-07 00:00:00	1998-10-07	1998-10-07 00:00:00	1998-10-07	581452		0	0	0		0	0	0	90702	0	113	40213227		
169821	3734	40213227	1992-08-01	1992-08-01 00:00:00	1992-08-01	1992-08-01 00:00:00	1992-08-01	581452		0	0	0		0	0	0	248104	0	113	40213227		
42005	3481	1545959	2015-04-04	2015-04-04 00:00:00	2015-04-04	2015-04-04 00:00:00	2015-04-04	38000177		0	0	0		0	0	0	230888	0	259255	1545959		
129352	2844	40213160	1955-03-07	1955-03-07 00:00:00	1955-03-07	1955-03-07 00:00:00	1955-03-07	581452		0	0	0		0	0	0	188854	0	10	40213160		
173965	3825	40213296	1996-06-21	1996-06-21 00:00:00	1996-06-21	1996-06-21 00:00:00	1996-06-21	581452		0	0	0		0	0	0	254087	0	52	40213296		
50011	4149	19059056	1968-06-22	1968-06-22 00:00:00	1968-07-06	1968-07-06 00:00:00	1968-07-06	38000177		0	0	14		0	0	0	275715	0	243670	19059056		
34765	2869	19006318	1953-11-07	1953-11-07 00:00:00	1953-11-21	1953-11-21 00:00:00	1953-11-21	38000177		0	0	14		0	0	0	190895	0	105078	19006318		
130478	2867	40213314	1978-11-21	1978-11-21 00:00:00	1978-11-21	1978-11-21 00:00:00	1978-11-21	581452		0	0	0		0	0	0	190727	0	49	40213314		
91901	2017	40213160	1969-11-04	1969-11-04 00:00:00	1969-11-04	1969-11-04 00:00:00	1969-11-04	581452		0	0	0		0	0	0	134169	0	10	40213160		
183688	4035	40213314	1977-03-01	1977-03-01 00:00:00	1977-03-01	1977-03-01 00:00:00	1977-03-01	581452		0	0	0		0	0	0	268448	0	49	40213314		
36822	3044	19059056	1971-01-23	1971-01-23 00:00:00	1971-02-06	1971-02-06 00:00:00	1971-02-06	38000177		0	0	14		0	0	0	202606	0	243670	19059056		
413	9	40213314	1978-12-28	1978-12-28 00:00:00	1978-12-28	1978-12-28 00:00:00	1978-12-28	581452		0	0	0		0	0	0	852	0	49	40213314		
37373	3087	1127433	1993-10-08	1993-10-08 00:00:00	1993-10-15	1993-10-15 00:00:00	1993-10-15	38000177		0	0	7		0	0	0	205505	0	313782	1127433		
121138	2662	40213296	2018-04-27	2018-04-27 00:00:00	2018-04-27	2018-04-27 00:00:00	2018-04-27	581452		0	0	0		0	0	0	176418	0	52	40213296		
37485	3098	1127433	2016-06-11	2016-06-11 00:00:00	2016-06-18	2016-06-18 00:00:00	2016-06-18	38000177		0	0	7		0	0	0	206199	0	313782	1127433		
33542	2776	1127078	1982-01-28	1982-01-28 00:00:00	1982-02-11	1982-02-11 00:00:00	1982-02-11	38000177		0	0	14		0	0	0	183815	0	282464	1127078		
24967	545	40213227	2013-10-19	2013-10-19 00:00:00	2013-10-19	2013-10-19 00:00:00	2013-10-19	581452		0	0	0		0	0	0	36099	0	113	40213227		
33280	2758	19133905	2012-05-21	2012-05-21 00:00:00	2012-06-03	2012-06-03 00:00:00	2012-06-03	38000177		0	0	13		0	0	0	182405	0	834102	19133905		
141434	3106	40213160	1955-06-20	1955-06-20 00:00:00	1955-06-20	1955-06-20 00:00:00	1955-06-20	581452		0	0	0		0	0	0	206558	0	10	40213160		
8987	192	40213227	2011-02-16	2011-02-16 00:00:00	2011-02-16	2011-02-16 00:00:00	2011-02-16	581452		0	0	0		0	0	0	13202	0	113	40213227		
18774	1551	1332419	2018-03-12	2018-03-12 00:00:00	2018-03-12	2018-03-12 00:00:00	\N	38000177		0	0	0		0	0	0	103865	0	197361	1332419		
26438	2175	1539411	2000-11-09	2000-11-09 00:00:00	2000-11-09	2000-11-09 00:00:00	\N	38000177		0	0	0		0	0	0	145084	0	312961	1539411		
43978	3641	1127433	2000-06-24	2000-06-24 00:00:00	2000-07-08	2000-07-08 00:00:00	2000-07-08	38000177		0	0	14		0	0	0	242341	0	313782	1127433		
218165	4788	40213160	1976-08-01	1976-08-01 00:00:00	1976-08-01	1976-08-01 00:00:00	1976-08-01	581452		0	0	0		0	0	0	318651	0	10	40213160		
216210	4745	40213314	1977-03-09	1977-03-09 00:00:00	1977-03-09	1977-03-09 00:00:00	1977-03-09	581452		0	0	0		0	0	0	315942	0	49	40213314		
91748	2013	40213296	1996-03-23	1996-03-23 00:00:00	1996-03-23	1996-03-23 00:00:00	1996-03-23	581452		0	0	0		0	0	0	133995	0	52	40213296		
142172	3123	40213314	1977-12-14	1977-12-14 00:00:00	1977-12-14	1977-12-14 00:00:00	1977-12-14	581452		0	0	0		0	0	0	207826	0	49	40213314		
61114	5081	1127433	1947-09-19	1947-09-19 00:00:00	1947-10-03	1947-10-03 00:00:00	1947-10-03	38000177		0	0	14		0	0	0	337879	0	313782	1127433		
32228	2672	1713671	2012-11-03	2012-11-03 00:00:00	2012-11-10	2012-11-10 00:00:00	2012-11-10	38000177		0	0	7		0	0	0	176892	0	562251	1713671		
130528	2868	40213160	1963-01-16	1963-01-16 00:00:00	1963-01-16	1963-01-16 00:00:00	1963-01-16	581452		0	0	0		0	0	0	190814	0	10	40213160		
30459	2525	1713671	2011-12-11	2011-12-11 00:00:00	2011-12-18	2011-12-18 00:00:00	2011-12-18	38000177		0	0	7		0	0	0	166954	0	562251	1713671		
16307	1352	19059056	1970-07-29	1970-07-29 00:00:00	1970-08-26	1970-08-26 00:00:00	1970-08-26	38000177		0	0	28		0	0	0	89605	0	243670	19059056		
10582	882	1124300	1987-12-03	1987-12-03 00:00:00	1987-12-03	1987-12-03 00:00:00	\N	38000177		0	0	0		0	0	0	58729	0	00781178901	45011828		
9709	812	40231925	1979-09-01	1979-09-01 00:00:00	1979-09-01	1979-09-01 00:00:00	\N	38000177		0	0	0		0	0	0	53888	0	1049221	40231925		
5111	426	1127433	1988-01-08	1988-01-08 00:00:00	1988-01-15	1988-01-15 00:00:00	1988-01-15	38000177		0	0	7		0	0	0	28267	0	313782	1127433		
24070	1980	19128065	1986-09-07	1986-09-07 00:00:00	1987-09-02	1987-09-02 00:00:00	1987-09-02	38000177		0	0	360		0	0	0	131794	0	749882	19128065		
23866	1965	46233988	1980-07-13	1980-07-13 00:00:00	1980-07-27	1980-07-27 00:00:00	1980-07-27	38000177		0	0	14		0	0	0	130619	0	1652673	46233988		
126131	2774	40213227	1992-04-03	1992-04-03 00:00:00	1992-04-03	1992-04-03 00:00:00	1992-04-03	581452		0	0	0		0	0	0	183731	0	113	40213227		
16662	1381	40169281	2009-08-15	2009-08-15 00:00:00	2009-08-15	2009-08-15 00:00:00	\N	38000177		0	0	0		0	0	0	91574	0	896209	40169281		
30903	2559	19006318	1960-06-16	1960-06-16 00:00:00	1960-06-30	1960-06-30 00:00:00	1960-06-30	38000177		0	0	14		0	0	0	169633	0	105078	19006318		
169	12	19129655	1964-08-22	1964-08-22 00:00:00	1964-09-05	1964-09-05 00:00:00	1964-09-05	38000177		0	0	14		0	0	0	1059	0	789980	19129655		
93775	2058	40213227	2017-11-01	2017-11-01 00:00:00	2017-11-01	2017-11-01 00:00:00	2017-11-01	581452		0	0	0		0	0	0	136827	0	113	40213227		
137119	3010	40213160	1968-12-25	1968-12-25 00:00:00	1968-12-25	1968-12-25 00:00:00	1968-12-25	581452		0	0	0		0	0	0	200748	0	10	40213160		
242865	5331	40213227	2014-08-06	2014-08-06 00:00:00	2014-08-06	2014-08-06 00:00:00	2014-08-06	581452		0	0	0		0	0	0	354914	0	113	40213227		
112454	2470	40213260	2008-12-15	2008-12-15 00:00:00	2008-12-15	2008-12-15 00:00:00	2008-12-15	581452		0	0	0		0	0	0	163803	0	121	40213260		
173407	3813	40213160	1972-03-18	1972-03-18 00:00:00	1972-03-18	1972-03-18 00:00:00	1972-03-18	581452		0	0	0		0	0	0	253304	0	10	40213160		
207401	4550	40213160	1962-12-16	1962-12-16 00:00:00	1962-12-16	1962-12-16 00:00:00	1962-12-16	581452		0	0	0		0	0	0	303272	0	10	40213160		
218762	4801	40213296	2011-07-30	2011-07-30 00:00:00	2011-07-30	2011-07-30 00:00:00	2011-07-30	581452		0	0	0		0	0	0	319418	0	52	40213296		
162299	3569	40213296	2000-11-14	2000-11-14 00:00:00	2000-11-14	2000-11-14 00:00:00	2000-11-14	581452		0	0	0		0	0	0	237141	0	52	40213296		
106912	2343	40213227	1998-01-24	1998-01-24 00:00:00	1998-01-24	1998-01-24 00:00:00	1998-01-24	581452		0	0	0		0	0	0	155969	0	113	40213227		
225769	4957	40213160	1972-03-11	1972-03-11 00:00:00	1972-03-11	1972-03-11 00:00:00	1972-03-11	581452		0	0	0		0	0	0	329546	0	10	40213160		
109516	2404	40213296	2008-05-18	2008-05-18 00:00:00	2008-05-18	2008-05-18 00:00:00	2008-05-18	581452		0	0	0		0	0	0	159747	0	52	40213296		
217624	4776	40213306	1981-12-20	1981-12-20 00:00:00	1981-12-20	1981-12-20 00:00:00	1981-12-20	581452		0	0	0		0	0	0	318036	0	43	40213306		
215934	4736	40213160	1973-01-26	1973-01-26 00:00:00	1973-01-26	1973-01-26 00:00:00	1973-01-26	581452		0	0	0		0	0	0	315527	0	10	40213160		
132946	2919	40213227	2000-08-26	2000-08-26 00:00:00	2000-08-26	2000-08-26 00:00:00	2000-08-26	581452		0	0	0		0	0	0	194571	0	113	40213227		
56421	4680	19059056	1957-04-10	1957-04-10 00:00:00	1957-04-24	1957-04-24 00:00:00	1957-04-24	38000177		0	0	14		0	0	0	311945	0	243670	19059056		
99584	2180	40213314	1979-03-10	1979-03-10 00:00:00	1979-03-10	1979-03-10 00:00:00	1979-03-10	581452		0	0	0		0	0	0	145410	0	49	40213314		
13070	1098	46233710	1969-01-17	1969-01-17 00:00:00	1969-01-31	1969-01-31 00:00:00	1969-01-31	38000177		0	0	14		0	0	0	72038	0	1650142	46233710		
46567	3857	19059056	1956-07-20	1956-07-20 00:00:00	1956-08-17	1956-08-17 00:00:00	1956-08-17	38000177		0	0	28		0	0	0	256034	0	243670	19059056		
36644	800	40213227	2005-06-05	2005-06-05 00:00:00	2005-06-05	2005-06-05 00:00:00	2005-06-05	581452		0	0	0		0	0	0	53105	0	113	40213227		
219209	4811	40213296	2003-07-08	2003-07-08 00:00:00	2003-07-08	2003-07-08 00:00:00	2003-07-08	581452		0	0	0		0	0	0	320036	0	52	40213296		
3485	289	19133905	2005-08-13	2005-08-13 00:00:00	2005-08-23	2005-08-23 00:00:00	2005-08-23	38000177		0	0	10		0	0	0	19295	0	834102	19133905		
63966	5314	19006318	1954-11-16	1954-11-16 00:00:00	1954-11-30	1954-11-30 00:00:00	1954-11-30	38000177		0	0	14		0	0	0	353414	0	105078	19006318		
56248	4668	1310034	2011-04-26	2011-04-26 00:00:00	2011-04-26	2011-04-26 00:00:00	2011-04-26	38000177		0	0	0		0	0	0	311088	0	834357	1310034		
62543	1368	40213296	1998-10-07	1998-10-07 00:00:00	1998-10-07	1998-10-07 00:00:00	1998-10-07	581452		0	0	0		0	0	0	90702	0	52	40213296		
152730	3362	40213160	1957-05-29	1957-05-29 00:00:00	1957-05-29	1957-05-29 00:00:00	1957-05-29	581452		0	0	0		0	0	0	222888	0	10	40213160		
42006	3481	19133768	2015-04-04	2015-04-04 00:00:00	2015-04-04	2015-04-04 00:00:00	2015-04-04	38000177		0	0	0		0	0	0	230888	0	833036	19133768		
129360	2844	40213227	2009-05-11	2009-05-11 00:00:00	2009-05-11	2009-05-11 00:00:00	2009-05-11	581452		0	0	0		0	0	0	188876	0	113	40213227		
173971	3825	40213227	1996-06-21	1996-06-21 00:00:00	1996-06-21	1996-06-21 00:00:00	1996-06-21	581452		0	0	0		0	0	0	254087	0	113	40213227		
50012	4149	46233988	1968-06-22	1968-06-22 00:00:00	1968-07-06	1968-07-06 00:00:00	1968-07-06	38000177		0	0	14		0	0	0	275715	0	1652673	46233988		
34776	2871	1713671	2013-02-12	2013-02-12 00:00:00	2013-02-26	2013-02-26 00:00:00	2013-02-26	38000177		0	0	14		0	0	0	191158	0	562251	1713671		
130481	2867	40213314	1979-10-23	1979-10-23 00:00:00	1979-10-23	1979-10-23 00:00:00	1979-10-23	581452		0	0	0		0	0	0	190733	0	49	40213314		
91906	2017	40213227	1992-06-02	1992-06-02 00:00:00	1992-06-02	1992-06-02 00:00:00	1992-06-02	581452		0	0	0		0	0	0	134181	0	113	40213227		
183690	4035	40213160	1977-03-01	1977-03-01 00:00:00	1977-03-01	1977-03-01 00:00:00	1977-03-01	581452		0	0	0		0	0	0	268448	0	10	40213160		
36823	3044	19133873	1977-10-21	1977-10-21 00:00:00	1977-11-03	1977-11-03 00:00:00	1977-11-03	38000177		0	0	13		0	0	0	202604	0	834061	19133873		
414	9	40213160	1978-12-28	1978-12-28 00:00:00	1978-12-28	1978-12-28 00:00:00	1978-12-28	581452		0	0	0		0	0	0	852	0	10	40213160		
37374	3087	1127433	1966-11-25	1966-11-25 00:00:00	1966-12-02	1966-12-02 00:00:00	1966-12-02	38000177		0	0	7		0	0	0	205531	0	313782	1127433		
121140	2662	40213314	1979-07-06	1979-07-06 00:00:00	1979-07-06	1979-07-06 00:00:00	1979-07-06	581452		0	0	0		0	0	0	176436	0	49	40213314		
37486	3098	1713671	1984-06-08	1984-06-08 00:00:00	1984-06-22	1984-06-22 00:00:00	1984-06-22	38000177		0	0	14		0	0	0	206196	0	562251	1713671		
33543	2776	1107882	2005-07-26	2005-07-26 00:00:00	2005-07-26	2005-07-26 00:00:00	\N	38000177		0	0	0		0	0	0	183776	0	311372	1107882		
24968	545	40213296	2013-10-19	2013-10-19 00:00:00	2013-10-19	2013-10-19 00:00:00	2013-10-19	581452		0	0	0		0	0	0	36099	0	52	40213296		
33281	2758	1118084	1980-06-09	1980-06-09 00:00:00	1980-06-09	1980-06-09 00:00:00	\N	38000177		0	0	0		0	0	0	182489	0	00025152531	44923712		
107374	2352	40213306	1992-10-26	1992-10-26 00:00:00	1992-10-26	1992-10-26 00:00:00	1992-10-26	581452		0	0	0		0	0	0	156682	0	43	40213306		
8993	192	40213227	2000-12-20	2000-12-20 00:00:00	2000-12-20	2000-12-20 00:00:00	2000-12-20	581452		0	0	0		0	0	0	13178	0	113	40213227		
18775	1551	19126352	2018-03-12	2018-03-12 00:00:00	2018-03-12	2018-03-12 00:00:00	\N	38000177		0	0	0		0	0	0	103865	0	705129	19126352		
26439	2175	1594382	2009-02-17	2009-02-17 00:00:00	2009-02-17	2009-02-17 00:00:00	\N	38000177		0	0	0		0	0	0	145012	0	1870230	1594382		
43979	3641	40229134	2002-01-03	2002-01-03 00:00:00	2002-01-10	2002-01-10 00:00:00	2002-01-10	38000177		0	0	7		0	0	0	242334	0	1043400	40229134		
218166	4788	40213160	1976-02-29	1976-02-29 00:00:00	1976-02-29	1976-02-29 00:00:00	1976-02-29	581452		0	0	0		0	0	0	318661	0	10	40213160		
37800	825	40213296	2014-05-03	2014-05-03 00:00:00	2014-05-03	2014-05-03 00:00:00	2014-05-03	581452		0	0	0		0	0	0	54678	0	52	40213296		
91754	2013	40213160	1956-06-23	1956-06-23 00:00:00	1956-06-23	1956-06-23 00:00:00	1956-06-23	581452		0	0	0		0	0	0	133930	0	10	40213160		
142177	3123	40213160	1982-03-03	1982-03-03 00:00:00	1982-03-03	1982-03-03 00:00:00	1982-03-03	581452		0	0	0		0	0	0	207857	0	10	40213160		
61128	5083	19073188	1993-08-20	1993-08-20 00:00:00	1993-09-10	1993-09-10 00:00:00	1993-09-10	38000177		0	0	21		0	0	0	337991	0	308192	19073188		
32229	2672	19059056	1972-02-18	1972-02-18 00:00:00	1972-03-10	1972-03-10 00:00:00	1972-03-10	38000177		0	0	21		0	0	0	176981	0	243670	19059056		
130529	2868	40213306	1984-12-12	1984-12-12 00:00:00	1984-12-12	1984-12-12 00:00:00	1984-12-12	581452		0	0	0		0	0	0	190755	0	43	40213306		
30460	2525	1127078	1982-04-22	1982-04-22 00:00:00	1982-05-06	1982-05-06 00:00:00	1982-05-06	38000177		0	0	14		0	0	0	166956	0	282464	1127078		
16308	1352	19133905	1972-07-13	1972-07-13 00:00:00	1972-07-21	1972-07-21 00:00:00	1972-07-21	38000177		0	0	8		0	0	0	89560	0	834102	19133905		
10583	882	1127433	1987-10-18	1987-10-18 00:00:00	1987-10-25	1987-10-25 00:00:00	1987-10-25	38000177		0	0	7		0	0	0	58729	0	313782	1127433		
9710	812	1127433	1988-09-30	1988-09-30 00:00:00	1988-10-07	1988-10-07 00:00:00	1988-10-07	38000177		0	0	7		0	0	0	53848	0	313782	1127433		
147095	3234	40213227	1998-11-02	1998-11-02 00:00:00	1998-11-02	1998-11-02 00:00:00	1998-11-02	581452		0	0	0		0	0	0	214966	0	113	40213227		
34529	2853	1127078	1962-08-26	1962-08-26 00:00:00	1962-09-25	1962-09-25 00:00:00	1962-09-25	38000177		0	0	30		0	0	0	189542	0	282464	1127078		
23867	1965	19133873	1974-05-26	1974-05-26 00:00:00	1974-06-02	1974-06-02 00:00:00	1974-06-02	38000177		0	0	7		0	0	0	130651	0	834061	19133873		
126133	2774	40213227	2002-01-18	2002-01-18 00:00:00	2002-01-18	2002-01-18 00:00:00	2002-01-18	581452		0	0	0		0	0	0	183717	0	113	40213227		
16663	1381	1127433	1993-11-11	1993-11-11 00:00:00	1994-02-09	1994-02-09 00:00:00	1994-02-09	38000177		0	0	90		0	0	0	91565	0	313782	1127433		
30904	2559	1127078	1960-06-16	1960-06-16 00:00:00	1960-06-30	1960-06-30 00:00:00	1960-06-30	38000177		0	0	14		0	0	0	169633	0	282464	1127078		
170	12	19128065	1982-12-26	1982-12-26 00:00:00	1983-12-21	1983-12-21 00:00:00	1983-12-21	38000177		0	0	360		0	0	0	1062	0	749882	19128065		
93776	2058	40213260	2017-11-01	2017-11-01 00:00:00	2017-11-01	2017-11-01 00:00:00	2017-11-01	581452		0	0	0		0	0	0	136827	0	121	40213260		
137121	3010	40213227	1995-03-29	1995-03-29 00:00:00	1995-03-29	1995-03-29 00:00:00	1995-03-29	581452		0	0	0		0	0	0	200744	0	113	40213227		
242866	5331	40213227	1995-11-01	1995-11-01 00:00:00	1995-11-01	1995-11-01 00:00:00	1995-11-01	581452		0	0	0		0	0	0	354945	0	113	40213227		
112461	2470	40213227	1993-03-01	1993-03-01 00:00:00	1993-03-01	1993-03-01 00:00:00	1993-03-01	581452		0	0	0		0	0	0	163799	0	113	40213227		
173412	3813	40213160	1976-09-18	1976-09-18 00:00:00	1976-09-18	1976-09-18 00:00:00	1976-09-18	581452		0	0	0		0	0	0	253308	0	10	40213160		
207403	4550	40213227	2013-09-15	2013-09-15 00:00:00	2013-09-15	2013-09-15 00:00:00	2013-09-15	581452		0	0	0		0	0	0	303214	0	113	40213227		
16138	348	40213160	1980-07-07	1980-07-07 00:00:00	1980-07-07	1980-07-07 00:00:00	1980-07-07	581452		0	0	0		0	0	0	23166	0	10	40213160		
162303	3569	40213227	2010-10-26	2010-10-26 00:00:00	2010-10-26	2010-10-26 00:00:00	2010-10-26	581452		0	0	0		0	0	0	237135	0	113	40213227		
106913	2343	40213296	1998-01-24	1998-01-24 00:00:00	1998-01-24	1998-01-24 00:00:00	1998-01-24	581452		0	0	0		0	0	0	155969	0	52	40213296		
225780	4957	40213306	1993-11-06	1993-11-06 00:00:00	1993-11-06	1993-11-06 00:00:00	1993-11-06	581452		0	0	0		0	0	0	329565	0	43	40213306		
109523	2404	40213160	1966-05-15	1966-05-15 00:00:00	1966-05-15	1966-05-15 00:00:00	1966-05-15	581452		0	0	0		0	0	0	159775	0	10	40213160		
217631	4776	40213260	2010-04-18	2010-04-18 00:00:00	2010-04-18	2010-04-18 00:00:00	2010-04-18	581452		0	0	0		0	0	0	318028	0	121	40213260		
215935	4736	40213160	1977-08-05	1977-08-05 00:00:00	1977-08-05	1977-08-05 00:00:00	1977-08-05	581452		0	0	0		0	0	0	315531	0	10	40213160		
132955	2919	40213198	2014-11-29	2014-11-29 00:00:00	2014-11-29	2014-11-29 00:00:00	2014-11-29	581452		0	0	0		0	0	0	194637	0	133	40213198		
56422	4680	1713671	1980-05-09	1980-05-09 00:00:00	1980-05-30	1980-05-30 00:00:00	1980-05-30	38000177		0	0	21		0	0	0	311887	0	562251	1713671		
36009	2965	19059056	1987-09-06	1987-09-06 00:00:00	1987-10-06	1987-10-06 00:00:00	1987-10-06	38000177		0	0	30		0	0	0	197985	0	243670	19059056		
13071	1098	19059056	1969-01-17	1969-01-17 00:00:00	1969-01-31	1969-01-31 00:00:00	1969-01-31	38000177		0	0	14		0	0	0	72038	0	243670	19059056		
46568	3857	19059056	1945-12-24	1945-12-24 00:00:00	1946-01-07	1946-01-07 00:00:00	1946-01-07	38000177		0	0	14		0	0	0	255984	0	243670	19059056		
36648	800	40213296	1996-06-09	1996-06-09 00:00:00	1996-06-09	1996-06-09 00:00:00	1996-06-09	581452		0	0	0		0	0	0	53104	0	52	40213296		
219211	4811	40213296	2002-11-11	2002-11-11 00:00:00	2002-11-11	2002-11-11 00:00:00	2002-11-11	581452		0	0	0		0	0	0	\N	0	52	40213296		
3486	289	1118084	1992-12-22	1992-12-22 00:00:00	1992-12-22	1992-12-22 00:00:00	\N	38000177		0	0	0		0	0	0	19307	0	00025152531	44923712		
63967	5314	19059056	1954-11-16	1954-11-16 00:00:00	1954-11-30	1954-11-30 00:00:00	1954-11-30	38000177		0	0	14		0	0	0	353414	0	243670	19059056		
56249	4668	40243436	2011-04-26	2011-04-26 00:00:00	2011-04-26	2011-04-26 00:00:00	2011-04-26	38000177		0	0	0		0	0	0	311088	0	1190795	40243436		
62546	1368	40213227	2017-05-24	2017-05-24 00:00:00	2017-05-24	2017-05-24 00:00:00	2017-05-24	581452		0	0	0		0	0	0	90686	0	113	40213227		
152735	3362	40213160	1957-09-25	1957-09-25 00:00:00	1957-09-25	1957-09-25 00:00:00	1957-09-25	581452		0	0	0		0	0	0	222889	0	10	40213160		
42016	3483	1127433	2015-06-04	2015-06-04 00:00:00	2015-06-18	2015-06-18 00:00:00	2015-06-18	38000177		0	0	14		0	0	0	231043	0	313782	1127433		
146505	3222	40213227	2012-03-06	2012-03-06 00:00:00	2012-03-06	2012-03-06 00:00:00	2012-03-06	581452		0	0	0		0	0	0	214201	0	113	40213227		
173974	3825	40213260	2006-06-23	2006-06-23 00:00:00	2006-06-23	2006-06-23 00:00:00	2006-06-23	581452		0	0	0		0	0	0	254104	0	121	40213260		
14472	1214	1713671	1964-03-26	1964-03-26 00:00:00	1964-04-09	1964-04-09 00:00:00	1964-04-09	38000177		0	0	14		0	0	0	79998	0	562251	1713671		
34777	2871	1713671	1976-06-23	1976-06-23 00:00:00	1976-06-30	1976-06-30 00:00:00	1976-06-30	38000177		0	0	7		0	0	0	191154	0	562251	1713671		
130482	2867	40213306	2000-10-17	2000-10-17 00:00:00	2000-10-17	2000-10-17 00:00:00	2000-10-17	581452		0	0	0		0	0	0	190711	0	43	40213306		
91907	2017	40213306	1992-06-02	1992-06-02 00:00:00	1992-06-02	1992-06-02 00:00:00	1992-06-02	581452		0	0	0		0	0	0	134181	0	43	40213306		
159373	3508	40213260	2007-04-25	2007-04-25 00:00:00	2007-04-25	2007-04-25 00:00:00	2007-04-25	581452		0	0	0		0	0	0	232688	0	121	40213260		
36824	3044	1115171	2013-09-30	2013-09-30 00:00:00	2013-11-04	2013-11-04 00:00:00	2013-11-04	38000177		0	0	35		0	0	0	202624	0	849574	1115171		
416	9	40213227	2001-05-17	2001-05-17 00:00:00	2001-05-17	2001-05-17 00:00:00	2001-05-17	581452		0	0	0		0	0	0	823	0	113	40213227		
37375	3088	1127433	1947-12-30	1947-12-30 00:00:00	1948-01-06	1948-01-06 00:00:00	1948-01-06	38000177		0	0	7		0	0	0	205640	0	313782	1127433		
233044	5121	40213160	1964-09-25	1964-09-25 00:00:00	1964-09-25	1964-09-25 00:00:00	1964-09-25	581452		0	0	0		0	0	0	340514	0	10	40213160		
37487	3098	1118084	1995-12-02	1995-12-02 00:00:00	1995-12-02	1995-12-02 00:00:00	\N	38000177		0	0	0		0	0	0	206193	0	00025152531	44923712		
33544	2776	1594382	2005-07-26	2005-07-26 00:00:00	2005-07-26	2005-07-26 00:00:00	\N	38000177		0	0	0		0	0	0	183776	0	1870230	1594382		
24969	545	40213160	1972-01-15	1972-01-15 00:00:00	1972-01-15	1972-01-15 00:00:00	1972-01-15	581452		0	0	0		0	0	0	36110	0	10	40213160		
33282	2758	19059056	1940-08-28	1940-08-28 00:00:00	1940-09-11	1940-09-11 00:00:00	1940-09-11	38000177		0	0	14		0	0	0	182407	0	243670	19059056		
107376	2352	40213227	1992-10-26	1992-10-26 00:00:00	1992-10-26	1992-10-26 00:00:00	1992-10-26	581452		0	0	0		0	0	0	156682	0	113	40213227		
8999	192	40213201	2006-01-18	2006-01-18 00:00:00	2006-01-18	2006-01-18 00:00:00	2006-01-18	581452		0	0	0		0	0	0	13199	0	33	40213201		
18776	1551	1539411	2018-03-12	2018-03-12 00:00:00	2018-03-12	2018-03-12 00:00:00	\N	38000177		0	0	0		0	0	0	103865	0	312961	1539411		
26440	2175	40223834	2009-02-17	2009-02-17 00:00:00	2009-02-17	2009-02-17 00:00:00	\N	38000177		0	0	0		0	0	0	145012	0	997501	40223834		
54449	4526	40162522	1987-08-12	1987-08-12 00:00:00	1987-08-12	1987-08-12 00:00:00	\N	38000177		0	0	0		0	0	0	301374	0	857005	40162522		
218168	4788	40213314	1977-01-30	1977-01-30 00:00:00	1977-01-30	1977-01-30 00:00:00	1977-01-30	581452		0	0	0		0	0	0	318681	0	49	40213314		
37801	825	40213160	1971-02-20	1971-02-20 00:00:00	1971-02-20	1971-02-20 00:00:00	1971-02-20	581452		0	0	0		0	0	0	54669	0	10	40213160		
161283	3549	40213160	1958-02-11	1958-02-11 00:00:00	1958-02-11	1958-02-11 00:00:00	1958-02-11	581452		0	0	0		0	0	0	235644	0	10	40213160		
142181	3123	40213227	1999-12-01	1999-12-01 00:00:00	1999-12-01	1999-12-01 00:00:00	1999-12-01	581452		0	0	0		0	0	0	207843	0	113	40213227		
61129	5083	40165015	1993-08-20	1993-08-20 00:00:00	1993-08-20	1993-08-20 00:00:00	\N	38000177		0	0	0		0	0	0	337991	0	861467	40165015		
32230	2672	19133873	1953-07-15	1953-07-15 00:00:00	1953-07-23	1953-07-23 00:00:00	1953-07-23	38000177		0	0	8		0	0	0	176882	0	834061	19133873		
130535	2868	40213227	1993-12-22	1993-12-22 00:00:00	1993-12-22	1993-12-22 00:00:00	1993-12-22	581452		0	0	0		0	0	0	190758	0	113	40213227		
30461	2525	19073183	1982-04-22	1982-04-22 00:00:00	1982-05-06	1982-05-06 00:00:00	1982-05-06	38000177		0	0	14		0	0	0	166956	0	308182	19073183		
16310	1352	40243436	1984-11-25	1984-11-25 00:00:00	1984-11-25	1984-11-25 00:00:00	1984-11-25	38000177		0	0	0		0	0	0	89607	0	1190795	40243436		
10584	882	40162522	2013-06-27	2013-06-27 00:00:00	2013-06-27	2013-06-27 00:00:00	\N	38000177		0	0	0		0	0	0	58762	0	857005	40162522		
9711	812	1127433	2006-07-06	2006-07-06 00:00:00	2006-07-13	2006-07-13 00:00:00	2006-07-13	38000177		0	0	7		0	0	0	53864	0	313782	1127433		
147106	3234	40213227	1992-07-28	1992-07-28 00:00:00	1992-07-28	1992-07-28 00:00:00	1992-07-28	581452		0	0	0		0	0	0	214941	0	113	40213227		
34530	2853	19133873	1965-07-10	1965-07-10 00:00:00	1965-07-23	1965-07-23 00:00:00	1965-07-23	38000177		0	0	13		0	0	0	189504	0	834061	19133873		
23868	1965	1127433	1988-06-11	1988-06-11 00:00:00	1988-06-25	1988-06-25 00:00:00	1988-06-25	38000177		0	0	14		0	0	0	130640	0	313782	1127433		
119438	2626	40213227	2005-07-12	2005-07-12 00:00:00	2005-07-12	2005-07-12 00:00:00	2005-07-12	581452		0	0	0		0	0	0	173680	0	113	40213227		
16664	1381	1127078	1983-12-04	1983-12-04 00:00:00	1984-02-02	1984-02-02 00:00:00	1984-02-02	38000177		0	0	60		0	0	0	91564	0	282464	1127078		
30905	2559	19006318	1961-07-18	1961-07-18 00:00:00	1961-08-01	1961-08-01 00:00:00	1961-08-01	38000177		0	0	14		0	0	0	169653	0	105078	19006318		
171	12	19059056	1967-10-23	1967-10-23 00:00:00	1967-11-06	1967-11-06 00:00:00	1967-11-06	38000177		0	0	14		0	0	0	1060	0	243670	19059056		
93786	2058	40213296	2006-11-01	2006-11-01 00:00:00	2006-11-01	2006-11-01 00:00:00	2006-11-01	581452		0	0	0		0	0	0	136839	0	52	40213296		
137126	3010	40213227	2015-02-25	2015-02-25 00:00:00	2015-02-25	2015-02-25 00:00:00	2015-02-25	581452		0	0	0		0	0	0	200792	0	113	40213227		
148931	3275	40213160	1965-03-20	1965-03-20 00:00:00	1965-03-20	1965-03-20 00:00:00	1965-03-20	581452		0	0	0		0	0	0	217595	0	10	40213160		
112467	2470	40213296	1998-12-21	1998-12-21 00:00:00	1998-12-21	1998-12-21 00:00:00	1998-12-21	581452		0	0	0		0	0	0	163801	0	52	40213296		
36959	3057	19059056	1938-07-28	1938-07-28 00:00:00	1938-08-11	1938-08-11 00:00:00	1938-08-11	38000177		0	0	14		0	0	0	203356	0	243670	19059056		
207404	4550	40213260	2013-09-15	2013-09-15 00:00:00	2013-09-15	2013-09-15 00:00:00	2013-09-15	581452		0	0	0		0	0	0	303214	0	121	40213260		
16144	348	40213314	1978-01-02	1978-01-02 00:00:00	1978-01-02	1978-01-02 00:00:00	1978-01-02	581452		0	0	0		0	0	0	23135	0	49	40213314		
162304	3569	40213260	2010-10-26	2010-10-26 00:00:00	2010-10-26	2010-10-26 00:00:00	2010-10-26	581452		0	0	0		0	0	0	237135	0	121	40213260		
106917	2343	40213296	1996-01-20	1996-01-20 00:00:00	1996-01-20	1996-01-20 00:00:00	1996-01-20	581452		0	0	0		0	0	0	155941	0	52	40213296		
225782	4957	40213227	1993-11-06	1993-11-06 00:00:00	1993-11-06	1993-11-06 00:00:00	1993-11-06	581452		0	0	0		0	0	0	329565	0	113	40213227		
109524	2404	40213160	1966-08-14	1966-08-14 00:00:00	1966-08-14	1966-08-14 00:00:00	1966-08-14	581452		0	0	0		0	0	0	159719	0	10	40213160		
217636	4776	40213227	2002-01-13	2002-01-13 00:00:00	2002-01-13	2002-01-13 00:00:00	2002-01-13	581452		0	0	0		0	0	0	318027	0	113	40213227		
215936	4736	40213314	1977-08-05	1977-08-05 00:00:00	1977-08-05	1977-08-05 00:00:00	1977-08-05	581452		0	0	0		0	0	0	315531	0	49	40213314		
42587	929	40213227	1992-12-14	1992-12-14 00:00:00	1992-12-14	1992-12-14 00:00:00	1992-12-14	581452		0	0	0		0	0	0	61769	0	113	40213227		
56423	4680	19059056	1944-12-30	1944-12-30 00:00:00	1945-01-13	1945-01-13 00:00:00	1945-01-13	38000177		0	0	14		0	0	0	311941	0	243670	19059056		
36010	2965	40231925	1987-09-06	1987-09-06 00:00:00	1987-09-06	1987-09-06 00:00:00	\N	38000177		0	0	0		0	0	0	197985	0	1049221	40231925		
13072	1098	1127433	1999-11-30	1999-11-30 00:00:00	1999-12-07	1999-12-07 00:00:00	1999-12-07	38000177		0	0	7		0	0	0	72084	0	313782	1127433		
46569	3857	19006318	1945-12-24	1945-12-24 00:00:00	1946-01-07	1946-01-07 00:00:00	1946-01-07	38000177		0	0	14		0	0	0	255984	0	105078	19006318		
36650	800	40213227	1996-06-09	1996-06-09 00:00:00	1996-06-09	1996-06-09 00:00:00	1996-06-09	581452		0	0	0		0	0	0	53104	0	113	40213227		
100349	2199	40213227	2001-09-23	2001-09-23 00:00:00	2001-09-23	2001-09-23 00:00:00	2001-09-23	581452		0	0	0		0	0	0	146576	0	113	40213227		
13956	1169	1127433	1944-09-09	1944-09-09 00:00:00	1944-09-23	1944-09-23 00:00:00	1944-09-23	38000177		0	0	14		0	0	0	76958	0	313782	1127433		
63968	5314	19059056	1951-11-19	1951-11-19 00:00:00	1951-12-03	1951-12-03 00:00:00	1951-12-03	38000177		0	0	14		0	0	0	353367	0	243670	19059056		
56250	4668	46275916	2011-04-26	2011-04-26 00:00:00	2011-04-26	2011-04-26 00:00:00	2011-04-26	38000177		0	0	0		0	0	0	311088	0	1660014	46275916		
62554	1368	40213296	1996-10-02	1996-10-02 00:00:00	1996-10-02	1996-10-02 00:00:00	1996-10-02	581452		0	0	0		0	0	0	90671	0	52	40213296		
152740	3362	40213260	2007-11-28	2007-11-28 00:00:00	2007-11-28	2007-11-28 00:00:00	2007-11-28	581452		0	0	0		0	0	0	222924	0	121	40213260		
42017	3483	1115171	1996-11-09	1996-11-09 00:00:00	1996-12-14	1996-12-14 00:00:00	1996-12-14	38000177		0	0	35		0	0	0	231119	0	849574	1115171		
146509	3222	40213160	1955-12-13	1955-12-13 00:00:00	1955-12-13	1955-12-13 00:00:00	1955-12-13	581452		0	0	0		0	0	0	214192	0	10	40213160		
173976	3825	40213227	2005-06-17	2005-06-17 00:00:00	2005-06-17	2005-06-17 00:00:00	2005-06-17	581452		0	0	0		0	0	0	254033	0	113	40213227		
14473	1214	1127433	1987-02-11	1987-02-11 00:00:00	1987-02-25	1987-02-25 00:00:00	1987-02-25	38000177		0	0	14		0	0	0	79988	0	313782	1127433		
34778	2871	19006318	1952-05-16	1952-05-16 00:00:00	1952-05-30	1952-05-30 00:00:00	1952-05-30	38000177		0	0	14		0	0	0	191159	0	105078	19006318		
130484	2867	40213227	2000-10-17	2000-10-17 00:00:00	2000-10-17	2000-10-17 00:00:00	2000-10-17	581452		0	0	0		0	0	0	190711	0	113	40213227		
91912	2017	40213160	1970-01-06	1970-01-06 00:00:00	1970-01-06	1970-01-06 00:00:00	1970-01-06	581452		0	0	0		0	0	0	134192	0	10	40213160		
159377	3508	40213160	1957-05-08	1957-05-08 00:00:00	1957-05-08	1957-05-08 00:00:00	1957-05-08	581452		0	0	0		0	0	0	232630	0	10	40213160		
36825	3044	19073188	2012-10-07	2012-10-07 00:00:00	2012-11-04	2012-11-04 00:00:00	2012-11-04	38000177		0	0	28		0	0	0	202623	0	308192	19073188		
417	9	40213306	2001-05-17	2001-05-17 00:00:00	2001-05-17	2001-05-17 00:00:00	2001-05-17	581452		0	0	0		0	0	0	823	0	43	40213306		
37376	3088	19133873	1940-05-12	1940-05-12 00:00:00	1940-05-23	1940-05-23 00:00:00	1940-05-23	38000177		0	0	11		0	0	0	205683	0	834061	19133873		
233049	5121	40213306	1986-08-22	1986-08-22 00:00:00	1986-08-22	1986-08-22 00:00:00	1986-08-22	581452		0	0	0		0	0	0	340466	0	43	40213306		
37488	3098	1115171	1994-07-15	1994-07-15 00:00:00	1994-08-19	1994-08-19 00:00:00	1994-08-19	38000177		0	0	35		0	0	0	206193	0	849574	1115171		
33545	2776	1124300	2014-01-14	2014-01-14 00:00:00	2014-01-14	2014-01-14 00:00:00	\N	38000177		0	0	0		0	0	0	183851	0	00781178901	45011828		
24976	545	40213160	1972-06-17	1972-06-17 00:00:00	1972-06-17	1972-06-17 00:00:00	1972-06-17	581452		0	0	0		0	0	0	36026	0	10	40213160		
33283	2758	19018935	2005-11-18	2005-11-18 00:00:00	2005-11-18	2005-11-18 00:00:00	\N	38000177		0	0	0		0	0	0	182395	0	197604	19018935		
118681	2611	40213198	2016-09-22	2016-09-22 00:00:00	2016-09-22	2016-09-22 00:00:00	2016-09-22	581452		0	0	0		0	0	0	172652	0	133	40213198		
9012	192	40213227	1992-11-04	1992-11-04 00:00:00	1992-11-04	1992-11-04 00:00:00	1992-11-04	581452		0	0	0		0	0	0	13195	0	113	40213227		
18777	1551	1124300	1998-08-24	1998-08-24 00:00:00	1998-08-24	1998-08-24 00:00:00	\N	38000177		0	0	0		0	0	0	103862	0	00781178901	45011828		
26441	2175	1127078	1981-01-02	1981-01-02 00:00:00	1981-03-03	1981-03-03 00:00:00	1981-03-03	38000177		0	0	60		0	0	0	145067	0	282464	1127078		
54450	4526	19133905	2006-06-26	2006-06-26 00:00:00	2006-07-09	2006-07-09 00:00:00	2006-07-09	38000177		0	0	13		0	0	0	301333	0	834102	19133905		
218178	4788	40213227	1998-01-25	1998-01-25 00:00:00	1998-01-25	1998-01-25 00:00:00	1998-01-25	581452		0	0	0		0	0	0	318696	0	113	40213227		
37803	825	40213160	1971-03-20	1971-03-20 00:00:00	1971-03-20	1971-03-20 00:00:00	1971-03-20	581452		0	0	0		0	0	0	54682	0	10	40213160		
161286	3549	40213227	1999-08-31	1999-08-31 00:00:00	1999-08-31	1999-08-31 00:00:00	1999-08-31	581452		0	0	0		0	0	0	235689	0	113	40213227		
142182	3123	40213306	1999-12-01	1999-12-01 00:00:00	1999-12-01	1999-12-01 00:00:00	1999-12-01	581452		0	0	0		0	0	0	207843	0	43	40213306		
61130	5083	1127433	1993-08-20	1993-08-20 00:00:00	1993-09-10	1993-09-10 00:00:00	1993-09-10	38000177		0	0	21		0	0	0	337991	0	313782	1127433		
32231	2672	19078461	2005-08-12	2005-08-12 00:00:00	2005-09-02	2005-09-02 00:00:00	2005-09-02	38000177		0	0	21		0	0	0	176984	0	310965	19078461		
130539	2868	40213260	2012-10-10	2012-10-10 00:00:00	2012-10-10	2012-10-10 00:00:00	2012-10-10	581452		0	0	0		0	0	0	190785	0	121	40213260		
30462	2526	46233988	1976-08-14	1976-08-14 00:00:00	1976-08-28	1976-08-28 00:00:00	1976-08-28	38000177		0	0	14		0	0	0	167031	0	1652673	46233988		
16311	1352	1310034	1984-11-25	1984-11-25 00:00:00	1984-11-25	1984-11-25 00:00:00	1984-11-25	38000177		0	0	0		0	0	0	89607	0	834357	1310034		
10585	882	40229134	2018-09-03	2018-09-03 00:00:00	2018-09-17	2018-09-17 00:00:00	2018-09-17	38000177		0	0	14		0	0	0	58761	0	1043400	40229134		
9712	812	19133873	1973-10-30	1973-10-30 00:00:00	1973-11-08	1973-11-08 00:00:00	1973-11-08	38000177		0	0	9		0	0	0	53833	0	834061	19133873		
219012	4807	40213198	2010-04-01	2010-04-01 00:00:00	2010-04-01	2010-04-01 00:00:00	2010-04-01	581452		0	0	0		0	0	0	319880	0	133	40213198		
34531	2853	19133873	1964-08-29	1964-08-29 00:00:00	1964-09-09	1964-09-09 00:00:00	1964-09-09	38000177		0	0	11		0	0	0	189503	0	834061	19133873		
23869	1966	19059056	1968-04-18	1968-04-18 00:00:00	1968-05-02	1968-05-02 00:00:00	1968-05-02	38000177		0	0	14		0	0	0	130735	0	243670	19059056		
119439	2626	40213296	2005-07-12	2005-07-12 00:00:00	2005-07-12	2005-07-12 00:00:00	2005-07-12	581452		0	0	0		0	0	0	173680	0	52	40213296		
16665	1381	40229134	2009-08-14	2009-08-14 00:00:00	2009-08-28	2009-08-28 00:00:00	2009-08-28	38000177		0	0	14		0	0	0	91586	0	1043400	40229134		
30906	2559	1127433	1988-10-05	1988-10-05 00:00:00	1988-11-09	1988-11-09 00:00:00	1988-11-09	38000177		0	0	35		0	0	0	169520	0	313782	1127433		
172	12	46233988	1967-10-23	1967-10-23 00:00:00	1967-11-06	1967-11-06 00:00:00	1967-11-06	38000177		0	0	14		0	0	0	1060	0	1652673	46233988		
93788	2058	40213260	2016-10-26	2016-10-26 00:00:00	2016-10-26	2016-10-26 00:00:00	2016-10-26	581452		0	0	0		0	0	0	136923	0	121	40213260		
137127	3010	40213260	2015-02-25	2015-02-25 00:00:00	2015-02-25	2015-02-25 00:00:00	2015-02-25	581452		0	0	0		0	0	0	200792	0	121	40213260		
124763	2745	40213227	2004-07-11	2004-07-11 00:00:00	2004-07-11	2004-07-11 00:00:00	2004-07-11	581452		0	0	0		0	0	0	181601	0	113	40213227		
4736	102	40213296	2012-07-01	2012-07-01 00:00:00	2012-07-01	2012-07-01 00:00:00	2012-07-01	581452		0	0	0		0	0	0	6997	0	52	40213296		
36960	3057	1127433	1966-12-28	1966-12-28 00:00:00	1967-03-28	1967-03-28 00:00:00	1967-03-28	38000177		0	0	90		0	0	0	203385	0	313782	1127433		
207406	4550	40213260	2012-09-09	2012-09-09 00:00:00	2012-09-09	2012-09-09 00:00:00	2012-09-09	581452		0	0	0		0	0	0	303188	0	121	40213260		
16149	348	40213314	1977-07-04	1977-07-04 00:00:00	1977-07-04	1977-07-04 00:00:00	1977-07-04	581452		0	0	0		0	0	0	23123	0	49	40213314		
162310	3569	40213160	1959-04-14	1959-04-14 00:00:00	1959-04-14	1959-04-14 00:00:00	1959-04-14	581452		0	0	0		0	0	0	237166	0	10	40213160		
106921	2344	40213227	1998-03-09	1998-03-09 00:00:00	1998-03-09	1998-03-09 00:00:00	1998-03-09	581452		0	0	0		0	0	0	156033	0	113	40213227		
225784	4957	40213296	2011-10-15	2011-10-15 00:00:00	2011-10-15	2011-10-15 00:00:00	2011-10-15	581452		0	0	0		0	0	0	329569	0	52	40213296		
109529	2404	40213260	2015-12-06	2015-12-06 00:00:00	2015-12-06	2015-12-06 00:00:00	2015-12-06	581452		0	0	0		0	0	0	159734	0	121	40213260		
217637	4776	40213296	2002-01-13	2002-01-13 00:00:00	2002-01-13	2002-01-13 00:00:00	2002-01-13	581452		0	0	0		0	0	0	318027	0	52	40213296		
12917	279	40213260	2005-12-23	2005-12-23 00:00:00	2005-12-23	2005-12-23 00:00:00	2005-12-23	581452		0	0	0		0	0	0	18581	0	121	40213260		
123407	2711	40213201	2016-11-07	2016-11-07 00:00:00	2016-11-07	2016-11-07 00:00:00	2016-11-07	581452		0	0	0		0	0	0	179617	0	33	40213201		
56424	4682	1127433	2005-04-02	2005-04-02 00:00:00	2005-04-09	2005-04-09 00:00:00	2005-04-09	38000177		0	0	7		0	0	0	312035	0	313782	1127433		
36011	2965	1127078	1972-04-28	1972-04-28 00:00:00	1972-05-12	1972-05-12 00:00:00	1972-05-12	38000177		0	0	14		0	0	0	197977	0	282464	1127078		
13075	1098	19059056	1961-09-09	1961-09-09 00:00:00	1961-09-30	1961-09-30 00:00:00	1961-09-30	38000177		0	0	21		0	0	0	72028	0	243670	19059056		
46570	3857	1118084	1978-01-15	1978-01-15 00:00:00	1978-01-15	1978-01-15 00:00:00	\N	38000177		0	0	0		0	0	0	256044	0	00025152531	44923712		
36657	800	40213160	1955-05-08	1955-05-08 00:00:00	1955-05-08	1955-05-08 00:00:00	1955-05-08	581452		0	0	0		0	0	0	53155	0	10	40213160		
100353	2199	40213160	1980-03-30	1980-03-30 00:00:00	1980-03-30	1980-03-30 00:00:00	1980-03-30	581452		0	0	0		0	0	0	146552	0	10	40213160		
13957	1169	1713671	1979-08-05	1979-08-05 00:00:00	1979-08-26	1979-08-26 00:00:00	1979-08-26	38000177		0	0	21		0	0	0	77030	0	562251	1713671		
63969	5314	1713671	1989-02-12	1989-02-12 00:00:00	1989-03-05	1989-03-05 00:00:00	1989-03-05	38000177		0	0	21		0	0	0	353409	0	562251	1713671		
14015	1173	1127433	1989-08-06	1989-08-06 00:00:00	1989-08-20	1989-08-20 00:00:00	1989-08-20	38000177		0	0	14		0	0	0	77268	0	313782	1127433		
62565	1368	40213260	2006-03-22	2006-03-22 00:00:00	2006-03-22	2006-03-22 00:00:00	2006-03-22	581452		0	0	0		0	0	0	90673	0	121	40213260		
152748	3362	40213296	1997-02-26	1997-02-26 00:00:00	1997-02-26	1997-02-26 00:00:00	1997-02-26	581452		0	0	0		0	0	0	222922	0	52	40213296		
42018	3483	1127433	1965-10-20	1965-10-20 00:00:00	1965-10-27	1965-10-27 00:00:00	1965-10-27	38000177		0	0	7		0	0	0	231059	0	313782	1127433		
146527	3222	40213227	2002-01-08	2002-01-08 00:00:00	2002-01-08	2002-01-08 00:00:00	2002-01-08	581452		0	0	0		0	0	0	214170	0	113	40213227		
173980	3825	40213160	1955-05-20	1955-05-20 00:00:00	1955-05-20	1955-05-20 00:00:00	1955-05-20	581452		0	0	0		0	0	0	254043	0	10	40213160		
14474	1214	1118084	1978-01-07	1978-01-07 00:00:00	1978-01-07	1978-01-07 00:00:00	\N	38000177		0	0	0		0	0	0	79979	0	00025152531	44923712		
34779	2871	1127078	1952-05-16	1952-05-16 00:00:00	1952-05-30	1952-05-30 00:00:00	1952-05-30	38000177		0	0	14		0	0	0	191159	0	282464	1127078		
130485	2867	40213160	1983-07-26	1983-07-26 00:00:00	1983-07-26	1983-07-26 00:00:00	1983-07-26	581452		0	0	0		0	0	0	190736	0	10	40213160		
34848	2878	1127433	1999-12-14	1999-12-14 00:00:00	1999-12-21	1999-12-21 00:00:00	1999-12-21	38000177		0	0	7		0	0	0	191432	0	313782	1127433		
159382	3508	40213160	1957-08-07	1957-08-07 00:00:00	1957-08-07	1957-08-07 00:00:00	1957-08-07	581452		0	0	0		0	0	0	232654	0	10	40213160		
36826	3044	19078461	2012-10-07	2012-10-07 00:00:00	2012-11-04	2012-11-04 00:00:00	2012-11-04	38000177		0	0	28		0	0	0	202623	0	310965	19078461		
418	9	40213160	1978-10-26	1978-10-26 00:00:00	1978-10-26	1978-10-26 00:00:00	1978-10-26	581452		0	0	0		0	0	0	712	0	10	40213160		
37377	3088	19077572	2017-02-10	2017-02-10 00:00:00	2017-02-10	2017-02-10 00:00:00	\N	38000177		0	0	0		0	0	0	205682	0	310436	19077572		
233050	5121	40213160	1965-02-26	1965-02-26 00:00:00	1965-02-26	1965-02-26 00:00:00	1965-02-26	581452		0	0	0		0	0	0	340515	0	10	40213160		
37489	3098	40229134	1973-12-04	1973-12-04 00:00:00	1973-12-18	1973-12-18 00:00:00	1973-12-18	38000177		0	0	14		0	0	0	206148	0	1043400	40229134		
33546	2776	1713671	2016-01-04	2016-01-04 00:00:00	2016-01-11	2016-01-11 00:00:00	2016-01-11	38000177		0	0	7		0	0	0	183812	0	562251	1713671		
24978	545	40213160	1972-03-18	1972-03-18 00:00:00	1972-03-18	1972-03-18 00:00:00	1972-03-18	581452		0	0	0		0	0	0	36084	0	10	40213160		
33284	2758	40163554	2005-11-18	2005-11-18 00:00:00	2005-11-18	2005-11-18 00:00:00	\N	38000177		0	0	0		0	0	0	182395	0	855332	40163554		
118689	2611	40213227	1993-05-20	1993-05-20 00:00:00	1993-05-20	1993-05-20 00:00:00	1993-05-20	581452		0	0	0		0	0	0	172662	0	113	40213227		
15887	1318	19059056	1948-06-13	1948-06-13 00:00:00	1948-07-11	1948-07-11 00:00:00	1948-07-11	38000177		0	0	28		0	0	0	87397	0	243670	19059056		
18778	1551	1713671	1958-09-15	1958-09-15 00:00:00	1958-09-22	1958-09-22 00:00:00	1958-09-22	38000177		0	0	7		0	0	0	103848	0	562251	1713671		
26442	2175	19078461	1990-07-14	1990-07-14 00:00:00	1990-08-04	1990-08-04 00:00:00	1990-08-04	38000177		0	0	21		0	0	0	145068	0	310965	19078461		
54451	4526	19078461	2012-05-02	2012-05-02 00:00:00	2012-06-06	2012-06-06 00:00:00	2012-06-06	38000177		0	0	35		0	0	0	301375	0	310965	19078461		
218179	4788	40213306	1998-01-25	1998-01-25 00:00:00	1998-01-25	1998-01-25 00:00:00	1998-01-25	581452		0	0	0		0	0	0	318696	0	43	40213306		
37807	825	40213160	1975-04-26	1975-04-26 00:00:00	1975-04-26	1975-04-26 00:00:00	1975-04-26	581452		0	0	0		0	0	0	54685	0	10	40213160		
161287	3549	40213296	1999-08-31	1999-08-31 00:00:00	1999-08-31	1999-08-31 00:00:00	1999-08-31	581452		0	0	0		0	0	0	235689	0	52	40213296		
38776	3207	1127078	1960-10-01	1960-10-01 00:00:00	1960-12-30	1960-12-30 00:00:00	1960-12-30	38000177		0	0	90		0	0	0	213203	0	282464	1127078		
61131	5083	19133905	1988-03-25	1988-03-25 00:00:00	1988-04-06	1988-04-06 00:00:00	1988-04-06	38000177		0	0	12		0	0	0	338024	0	834102	19133905		
32232	2673	19128022	1991-02-04	1991-02-04 00:00:00	1992-01-30	1992-01-30 00:00:00	1992-01-30	38000177		0	0	360		0	0	0	177053	0	749785	19128022		
130541	2868	40213227	2013-10-16	2013-10-16 00:00:00	2013-10-16	2013-10-16 00:00:00	2013-10-16	581452		0	0	0		0	0	0	190761	0	113	40213227		
30463	2526	19019979	1976-08-14	1976-08-14 00:00:00	1976-08-28	1976-08-28 00:00:00	1976-08-28	38000177		0	0	14		0	0	0	167031	0	198405	19019979		
16312	1352	46275916	1984-11-25	1984-11-25 00:00:00	1984-11-25	1984-11-25 00:00:00	1984-11-25	38000177		0	0	0		0	0	0	89607	0	1660014	46275916		
10586	882	1127433	2002-02-13	2002-02-13 00:00:00	2002-03-20	2002-03-20 00:00:00	2002-03-20	38000177		0	0	35		0	0	0	58722	0	313782	1127433		
9713	812	1127433	1983-08-11	1983-08-11 00:00:00	1983-08-25	1983-08-25 00:00:00	1983-08-25	38000177		0	0	14		0	0	0	53889	0	313782	1127433		
219024	4807	40213227	2016-05-05	2016-05-05 00:00:00	2016-05-05	2016-05-05 00:00:00	2016-05-05	581452		0	0	0		0	0	0	319869	0	113	40213227		
34532	2853	1713671	2008-06-18	2008-06-18 00:00:00	2008-07-02	2008-07-02 00:00:00	2008-07-02	38000177		0	0	14		0	0	0	189514	0	562251	1713671		
23870	1966	1127433	1990-01-21	1990-01-21 00:00:00	1990-02-25	1990-02-25 00:00:00	1990-02-25	38000177		0	0	35		0	0	0	130737	0	313782	1127433		
119441	2626	40213227	1994-07-19	1994-07-19 00:00:00	1994-07-19	1994-07-19 00:00:00	1994-07-19	581452		0	0	0		0	0	0	173695	0	113	40213227		
16666	1381	1127433	1990-01-03	1990-01-03 00:00:00	1990-01-10	1990-01-10 00:00:00	1990-01-10	38000177		0	0	7		0	0	0	91567	0	313782	1127433		
30907	2559	19078461	2012-05-07	2012-05-07 00:00:00	2012-05-21	2012-05-21 00:00:00	2012-05-21	38000177		0	0	14		0	0	0	169521	0	310965	19078461		
173	12	1118084	2008-04-08	2008-04-08 00:00:00	2008-04-08	2008-04-08 00:00:00	\N	38000177		0	0	0		0	0	0	1039	0	00025152531	44923712		
93790	2058	40213227	1997-12-31	1997-12-31 00:00:00	1997-12-31	1997-12-31 00:00:00	1997-12-31	581452		0	0	0		0	0	0	136908	0	113	40213227		
137131	3010	40213227	2005-01-26	2005-01-26 00:00:00	2005-01-26	2005-01-26 00:00:00	2005-01-26	581452		0	0	0		0	0	0	200790	0	113	40213227		
136043	2987	40213314	1977-05-02	1977-05-02 00:00:00	1977-05-02	1977-05-02 00:00:00	1977-05-02	581452		0	0	0		0	0	0	199381	0	49	40213314		
4745	102	40213227	1994-08-28	1994-08-28 00:00:00	1994-08-28	1994-08-28 00:00:00	1994-08-28	581452		0	0	0		0	0	0	6992	0	113	40213227		
36961	3057	19059056	1941-05-30	1941-05-30 00:00:00	1941-06-13	1941-06-13 00:00:00	1941-06-13	38000177		0	0	14		0	0	0	203366	0	243670	19059056		
207410	4551	40213296	2017-02-01	2017-02-01 00:00:00	2017-02-01	2017-02-01 00:00:00	2017-02-01	581452		0	0	0		0	0	0	303325	0	52	40213296		
16151	348	40213160	1976-01-05	1976-01-05 00:00:00	1976-01-05	1976-01-05 00:00:00	1976-01-05	581452		0	0	0		0	0	0	23157	0	10	40213160		
162313	3569	40213160	1959-07-14	1959-07-14 00:00:00	1959-07-14	1959-07-14 00:00:00	1959-07-14	581452		0	0	0		0	0	0	237170	0	10	40213160		
106922	2344	40213160	1966-06-20	1966-06-20 00:00:00	1966-06-20	1966-06-20 00:00:00	1966-06-20	581452		0	0	0		0	0	0	156054	0	10	40213160		
225787	4957	40213227	2002-11-16	2002-11-16 00:00:00	2002-11-16	2002-11-16 00:00:00	2002-11-16	581452		0	0	0		0	0	0	329568	0	113	40213227		
187917	4127	40213198	2012-09-23	2012-09-23 00:00:00	2012-09-23	2012-09-23 00:00:00	2012-09-23	581452		0	0	0		0	0	0	274369	0	133	40213198		
217643	4776	40213227	1994-01-02	1994-01-02 00:00:00	1994-01-02	1994-01-02 00:00:00	1994-01-02	581452		0	0	0		0	0	0	318018	0	113	40213227		
12930	279	40213160	1956-11-09	1956-11-09 00:00:00	1956-11-09	1956-11-09 00:00:00	1956-11-09	581452		0	0	0		0	0	0	18663	0	10	40213160		
123420	2712	40213306	1986-07-29	1986-07-29 00:00:00	1986-07-29	1986-07-29 00:00:00	1986-07-29	581452		0	0	0		0	0	0	179853	0	43	40213306		
56425	4682	19128022	1997-08-22	1997-08-22 00:00:00	1998-08-17	1998-08-17 00:00:00	1998-08-17	38000177		0	0	360		0	0	0	312038	0	749785	19128022		
36012	2965	19128022	1990-01-19	1990-01-19 00:00:00	1991-01-14	1991-01-14 00:00:00	1991-01-14	38000177		0	0	360		0	0	0	197978	0	749785	19128022		
13076	1098	1127433	1982-02-26	1982-02-26 00:00:00	1982-03-19	1982-03-19 00:00:00	1982-03-19	38000177		0	0	21		0	0	0	72030	0	313782	1127433		
46572	3857	40169281	1972-03-14	1972-03-14 00:00:00	1972-03-14	1972-03-14 00:00:00	\N	38000177		0	0	0		0	0	0	256054	0	896209	40169281		
36662	800	40213160	1959-05-10	1959-05-10 00:00:00	1959-05-10	1959-05-10 00:00:00	1959-05-10	581452		0	0	0		0	0	0	53096	0	10	40213160		
100359	2199	40213251	1984-07-01	1984-07-01 00:00:00	1984-07-01	1984-07-01 00:00:00	1984-07-01	581452		0	0	0		0	0	0	146572	0	21	40213251		
13958	1169	19126352	2014-09-22	2014-09-22 00:00:00	2018-08-20	2018-08-20 00:00:00	2018-08-20	38000177		0	0	1428		0	0	0	77060	0	705129	19126352		
1052	86	19078461	2001-04-20	2001-04-20 00:00:00	2001-05-11	2001-05-11 00:00:00	2001-05-11	38000177		0	0	21		0	0	0	5793	0	310965	19078461		
14016	1173	1127433	1987-06-12	1987-06-12 00:00:00	1987-07-03	1987-07-03 00:00:00	1987-07-03	38000177		0	0	21		0	0	0	77276	0	313782	1127433		
62572	1368	40213160	1961-03-01	1961-03-01 00:00:00	1961-03-01	1961-03-01 00:00:00	1961-03-01	581452		0	0	0		0	0	0	90732	0	10	40213160		
152752	3363	40213160	1955-02-04	1955-02-04 00:00:00	1955-02-04	1955-02-04 00:00:00	1955-02-04	581452		0	0	0		0	0	0	222962	0	10	40213160		
42019	3483	1713671	1970-05-05	1970-05-05 00:00:00	1970-05-26	1970-05-26 00:00:00	1970-05-26	38000177		0	0	21		0	0	0	231061	0	562251	1713671		
146540	3222	40213227	1993-01-12	1993-01-12 00:00:00	1993-01-12	1993-01-12 00:00:00	1993-01-12	581452		0	0	0		0	0	0	214208	0	113	40213227		
70889	1551	40213160	1961-11-27	1961-11-27 00:00:00	1961-11-27	1961-11-27 00:00:00	1961-11-27	581452		0	0	0		0	0	0	103813	0	10	40213160		
14475	1214	1127433	1944-02-07	1944-02-07 00:00:00	1944-02-14	1944-02-14 00:00:00	1944-02-14	38000177		0	0	7		0	0	0	79946	0	313782	1127433		
34780	2871	1713671	1951-06-18	1951-06-18 00:00:00	1951-06-25	1951-06-25 00:00:00	1951-06-25	38000177		0	0	7		0	0	0	191062	0	562251	1713671		
130489	2867	40213314	1979-01-23	1979-01-23 00:00:00	1979-01-23	1979-01-23 00:00:00	1979-01-23	581452		0	0	0		0	0	0	190732	0	49	40213314		
34849	2878	19078461	1994-06-01	1994-06-01 00:00:00	1994-06-22	1994-06-22 00:00:00	1994-06-22	38000177		0	0	21		0	0	0	191451	0	310965	19078461		
159395	3508	40213160	1957-03-06	1957-03-06 00:00:00	1957-03-06	1957-03-06 00:00:00	1957-03-06	581452		0	0	0		0	0	0	232653	0	10	40213160		
36827	3044	40162522	2012-10-07	2012-10-07 00:00:00	2012-10-07	2012-10-07 00:00:00	\N	38000177		0	0	0		0	0	0	202623	0	857005	40162522		
419	9	40213314	1978-10-26	1978-10-26 00:00:00	1978-10-26	1978-10-26 00:00:00	1978-10-26	581452		0	0	0		0	0	0	712	0	49	40213314		
37378	3088	1124300	1980-08-21	1980-08-21 00:00:00	1980-08-21	1980-08-21 00:00:00	\N	38000177		0	0	0		0	0	0	205618	0	00781178901	45011828		
233058	5121	40213296	2007-11-23	2007-11-23 00:00:00	2007-11-23	2007-11-23 00:00:00	2007-11-23	581452		0	0	0		0	0	0	340458	0	52	40213296		
37491	3098	1127433	1991-07-21	1991-07-21 00:00:00	1991-08-04	1991-08-04 00:00:00	1991-08-04	38000177		0	0	14		0	0	0	206205	0	313782	1127433		
8841	189	40213227	2000-05-21	2000-05-21 00:00:00	2000-05-21	2000-05-21 00:00:00	2000-05-21	581452		0	0	0		0	0	0	12847	0	113	40213227		
24983	545	40213306	1994-07-30	1994-07-30 00:00:00	1994-07-30	1994-07-30 00:00:00	1994-07-30	581452		0	0	0		0	0	0	36127	0	43	40213306		
33285	2758	40171902	2005-11-18	2005-11-18 00:00:00	2005-11-18	2005-11-18 00:00:00	\N	38000177		0	0	0		0	0	0	182395	0	897718	40171902		
230854	5073	40213227	1996-06-15	1996-06-15 00:00:00	1996-06-15	1996-06-15 00:00:00	1996-06-15	581452		0	0	0		0	0	0	337178	0	113	40213227		
15893	1320	40173590	1995-06-15	1995-06-15 00:00:00	1995-06-15	1995-06-15 00:00:00	\N	38000177		0	0	0		0	0	0	87506	0	904419	40173590		
18779	1551	1127433	2008-09-20	2008-09-20 00:00:00	2008-10-11	2008-10-11 00:00:00	2008-10-11	38000177		0	0	21		0	0	0	103886	0	313782	1127433		
26443	2175	1127433	2003-04-16	2003-04-16 00:00:00	2003-04-23	2003-04-23 00:00:00	2003-04-23	38000177		0	0	7		0	0	0	144981	0	313782	1127433		
54452	4526	19073188	2012-05-02	2012-05-02 00:00:00	2012-06-06	2012-06-06 00:00:00	2012-06-06	38000177		0	0	35		0	0	0	301375	0	308192	19073188		
218181	4788	40213296	2015-11-29	2015-11-29 00:00:00	2015-11-29	2015-11-29 00:00:00	2015-11-29	581452		0	0	0		0	0	0	318691	0	52	40213296		
37815	825	40213160	1970-12-19	1970-12-19 00:00:00	1970-12-19	1970-12-19 00:00:00	1970-12-19	581452		0	0	0		0	0	0	54631	0	10	40213160		
161288	3549	40213296	1997-08-26	1997-08-26 00:00:00	1997-08-26	1997-08-26 00:00:00	1997-08-26	581452		0	0	0		0	0	0	235650	0	52	40213296		
38777	3207	19129655	1962-10-12	1962-10-12 00:00:00	1962-10-26	1962-10-26 00:00:00	1962-10-26	38000177		0	0	14		0	0	0	213184	0	789980	19129655		
61132	5083	1118084	1984-01-27	1984-01-27 00:00:00	1984-01-27	1984-01-27 00:00:00	\N	38000177		0	0	0		0	0	0	338005	0	00025152531	44923712		
32233	2673	1127433	2017-07-07	2017-07-07 00:00:00	2017-08-11	2017-08-11 00:00:00	2017-08-11	38000177		0	0	35		0	0	0	177101	0	313782	1127433		
130542	2868	40213260	2013-10-16	2013-10-16 00:00:00	2013-10-16	2013-10-16 00:00:00	2013-10-16	581452		0	0	0		0	0	0	190761	0	121	40213260		
30464	2526	1127433	1996-06-30	1996-06-30 00:00:00	1996-09-05	1996-09-05 00:00:00	1996-09-05	38000177		0	0	67		0	0	0	167003	0	313782	1127433		
16313	1352	1118084	1989-09-07	1989-09-07 00:00:00	1989-09-07	1989-09-07 00:00:00	\N	38000177		0	0	0		0	0	0	89617	0	00025152531	44923712		
10587	882	19133905	1971-01-24	1971-01-24 00:00:00	1971-02-05	1971-02-05 00:00:00	1971-02-05	38000177		0	0	12		0	0	0	58758	0	834102	19133905		
9714	812	1127433	1996-09-26	1996-09-26 00:00:00	1996-10-10	1996-10-10 00:00:00	1996-10-10	38000177		0	0	14		0	0	0	53855	0	313782	1127433		
219026	4807	40213227	1996-08-29	1996-08-29 00:00:00	1996-08-29	1996-08-29 00:00:00	1996-08-29	581452		0	0	0		0	0	0	319814	0	113	40213227		
34533	2853	40229134	1995-03-24	1995-03-24 00:00:00	1995-04-07	1995-04-07 00:00:00	1995-04-07	38000177		0	0	14		0	0	0	189533	0	1043400	40229134		
23871	1966	1115171	2010-04-30	2010-04-30 00:00:00	2010-07-06	2010-07-06 00:00:00	2010-07-06	38000177		0	0	67		0	0	0	130740	0	849574	1115171		
119444	2626	40213160	1963-10-08	1963-10-08 00:00:00	1963-10-08	1963-10-08 00:00:00	1963-10-08	581452		0	0	0		0	0	0	173672	0	10	40213160		
16667	1381	1118084	2018-11-10	2018-11-10 00:00:00	2018-11-10	2018-11-10 00:00:00	\N	38000177		0	0	0		0	0	0	91589	0	00025152531	44923712		
30908	2559	1127433	1980-02-19	1980-02-19 00:00:00	1980-02-26	1980-02-26 00:00:00	1980-02-26	38000177		0	0	7		0	0	0	169593	0	313782	1127433		
175	12	1127433	1974-08-01	1974-08-01 00:00:00	1974-08-08	1974-08-08 00:00:00	1974-08-08	38000177		0	0	7		0	0	0	1029	0	313782	1127433		
93793	2058	40213306	1988-12-21	1988-12-21 00:00:00	1988-12-21	1988-12-21 00:00:00	1988-12-21	581452		0	0	0		0	0	0	136866	0	43	40213306		
137132	3010	40213296	2005-01-26	2005-01-26 00:00:00	2005-01-26	2005-01-26 00:00:00	2005-01-26	581452		0	0	0		0	0	0	200790	0	52	40213296		
136045	2987	40213160	1977-05-02	1977-05-02 00:00:00	1977-05-02	1977-05-02 00:00:00	1977-05-02	581452		0	0	0		0	0	0	199381	0	10	40213160		
4746	102	40213306	1994-08-28	1994-08-28 00:00:00	1994-08-28	1994-08-28 00:00:00	1994-08-28	581452		0	0	0		0	0	0	6992	0	43	40213306		
36962	3057	1127433	1979-11-10	1979-11-10 00:00:00	1979-11-17	1979-11-17 00:00:00	1979-11-17	38000177		0	0	7		0	0	0	203363	0	313782	1127433		
207412	4551	40213227	1999-06-16	1999-06-16 00:00:00	1999-06-16	1999-06-16 00:00:00	1999-06-16	581452		0	0	0		0	0	0	303318	0	113	40213227		
16155	348	40213160	1976-04-05	1976-04-05 00:00:00	1976-04-05	1976-04-05 00:00:00	1976-04-05	581452		0	0	0		0	0	0	23125	0	10	40213160		
162329	3570	40213227	2010-05-16	2010-05-16 00:00:00	2010-05-16	2010-05-16 00:00:00	2010-05-16	581452		0	0	0		0	0	0	237211	0	113	40213227		
106923	2344	40213306	1989-02-27	1989-02-27 00:00:00	1989-02-27	1989-02-27 00:00:00	1989-02-27	581452		0	0	0		0	0	0	156042	0	43	40213306		
38923	3216	19078461	1974-02-12	1974-02-12 00:00:00	1974-03-19	1974-03-19 00:00:00	1974-03-19	38000177		0	0	35		0	0	0	213708	0	310965	19078461		
187923	4127	40213227	1998-07-05	1998-07-05 00:00:00	1998-07-05	1998-07-05 00:00:00	1998-07-05	581452		0	0	0		0	0	0	274388	0	113	40213227		
217646	4776	40213260	2011-04-24	2011-04-24 00:00:00	2011-04-24	2011-04-24 00:00:00	2011-04-24	581452		0	0	0		0	0	0	318053	0	121	40213260		
12938	279	40213198	2017-11-17	2017-11-17 00:00:00	2017-11-17	2017-11-17 00:00:00	2017-11-17	581452		0	0	0		0	0	0	18586	0	133	40213198		
123421	2712	40213160	1964-04-07	1964-04-07 00:00:00	1964-04-07	1964-04-07 00:00:00	1964-04-07	581452		0	0	0		0	0	0	179823	0	10	40213160		
56426	4682	1127078	1981-02-07	1981-02-07 00:00:00	1981-02-21	1981-02-21 00:00:00	1981-02-21	38000177		0	0	14		0	0	0	312001	0	282464	1127078		
36013	2965	19019979	1978-03-13	1978-03-13 00:00:00	1978-03-27	1978-03-27 00:00:00	1978-03-27	38000177		0	0	14		0	0	0	197984	0	198405	19019979		
13079	1098	1127433	1956-11-05	1956-11-05 00:00:00	1956-11-12	1956-11-12 00:00:00	1956-11-12	38000177		0	0	7		0	0	0	72041	0	313782	1127433		
46573	3857	19059056	1944-11-29	1944-11-29 00:00:00	1944-12-20	1944-12-20 00:00:00	1944-12-20	38000177		0	0	21		0	0	0	256033	0	243670	19059056		
36664	800	40213227	2015-08-02	2015-08-02 00:00:00	2015-08-02	2015-08-02 00:00:00	2015-08-02	581452		0	0	0		0	0	0	53162	0	113	40213227		
100361	2199	40213160	1984-07-01	1984-07-01 00:00:00	1984-07-01	1984-07-01 00:00:00	1984-07-01	581452		0	0	0		0	0	0	146572	0	10	40213160		
13959	1169	19075601	2014-09-22	2014-09-22 00:00:00	2018-08-20	2018-08-20 00:00:00	2018-08-20	38000177		0	0	1428		0	0	0	77060	0	309362	19075601		
1053	86	19133905	1995-11-29	1995-11-29 00:00:00	1995-12-07	1995-12-07 00:00:00	1995-12-07	38000177		0	0	8		0	0	0	5796	0	834102	19133905		
14017	1173	19059056	1946-06-03	1946-06-03 00:00:00	1946-06-17	1946-06-17 00:00:00	1946-06-17	38000177		0	0	14		0	0	0	77212	0	243670	19059056		
62577	1368	40213160	1956-08-29	1956-08-29 00:00:00	1956-08-29	1956-08-29 00:00:00	1956-08-29	581452		0	0	0		0	0	0	90723	0	10	40213160		
152755	3363	40213227	2002-03-08	2002-03-08 00:00:00	2002-03-08	2002-03-08 00:00:00	2002-03-08	581452		0	0	0		0	0	0	222968	0	113	40213227		
42020	3483	19133873	1963-11-29	1963-11-29 00:00:00	1963-12-07	1963-12-07 00:00:00	1963-12-07	38000177		0	0	8		0	0	0	231077	0	834061	19133873		
146542	3222	40213201	2017-05-30	2017-05-30 00:00:00	2017-05-30	2017-05-30 00:00:00	2017-05-30	581452		0	0	0		0	0	0	\N	0	33	40213201		
70893	1551	40213260	2008-01-14	2008-01-14 00:00:00	2008-01-14	2008-01-14 00:00:00	2008-01-14	581452		0	0	0		0	0	0	103820	0	121	40213260		
14476	1214	1127433	1978-05-31	1978-05-31 00:00:00	1978-06-14	1978-06-14 00:00:00	1978-06-14	38000177		0	0	14		0	0	0	79991	0	313782	1127433		
34781	2871	19078461	2017-03-15	2017-03-15 00:00:00	2017-04-14	2017-04-14 00:00:00	2017-04-14	38000177		0	0	30		0	0	0	191095	0	310965	19078461		
130490	2867	40213160	1979-01-23	1979-01-23 00:00:00	1979-01-23	1979-01-23 00:00:00	1979-01-23	581452		0	0	0		0	0	0	190732	0	10	40213160		
34850	2878	19133873	1986-08-08	1986-08-08 00:00:00	1986-08-16	1986-08-16 00:00:00	1986-08-16	38000177		0	0	8		0	0	0	191452	0	834061	19133873		
159397	3508	40213296	2000-04-05	2000-04-05 00:00:00	2000-04-05	2000-04-05 00:00:00	2000-04-05	581452		0	0	0		0	0	0	232681	0	52	40213296		
36828	3044	1115171	1998-02-09	1998-02-09 00:00:00	1998-02-23	1998-02-23 00:00:00	1998-02-23	38000177		0	0	14		0	0	0	202622	0	849574	1115171		
426	9	40213227	2010-05-27	2010-05-27 00:00:00	2010-05-27	2010-05-27 00:00:00	2010-05-27	581452		0	0	0		0	0	0	747	0	113	40213227		
37379	3088	45892894	2017-12-07	2017-12-07 00:00:00	2017-12-07	2017-12-07 00:00:00	\N	38000177		0	0	0		0	0	0	205612	0	1599803	45892894		
3768	81	40213227	2007-04-11	2007-04-11 00:00:00	2007-04-11	2007-04-11 00:00:00	2007-04-11	581452		0	0	0		0	0	0	5534	0	113	40213227		
37492	3098	40229134	2012-02-09	2012-02-09 00:00:00	2012-02-23	2012-02-23 00:00:00	2012-02-23	38000177		0	0	14		0	0	0	206198	0	1043400	40229134		
8842	189	40213296	2000-05-21	2000-05-21 00:00:00	2000-05-21	2000-05-21 00:00:00	2000-05-21	581452		0	0	0		0	0	0	12847	0	52	40213296		
24984	545	40213227	1994-07-30	1994-07-30 00:00:00	1994-07-30	1994-07-30 00:00:00	1994-07-30	581452		0	0	0		0	0	0	36127	0	113	40213227		
33286	2758	19059056	1942-07-06	1942-07-06 00:00:00	1942-07-20	1942-07-20 00:00:00	1942-07-20	38000177		0	0	14		0	0	0	182439	0	243670	19059056		
230877	5073	40213227	2006-08-12	2006-08-12 00:00:00	2006-08-12	2006-08-12 00:00:00	2006-08-12	581452		0	0	0		0	0	0	337217	0	113	40213227		
15894	1320	45892894	2017-09-08	2017-09-08 00:00:00	2017-09-08	2017-09-08 00:00:00	\N	38000177		0	0	0		0	0	0	87485	0	1599803	45892894		
18780	1551	1127433	1958-07-12	1958-07-12 00:00:00	1958-07-19	1958-07-19 00:00:00	1958-07-19	38000177		0	0	7		0	0	0	103851	0	313782	1127433		
26444	2175	19128065	1992-01-15	1992-01-15 00:00:00	1993-01-09	1993-01-09 00:00:00	1993-01-09	38000177		0	0	360		0	0	0	144986	0	749882	19128065		
44281	3666	1127433	1971-10-30	1971-10-30 00:00:00	1971-11-06	1971-11-06 00:00:00	1971-11-06	38000177		0	0	7		0	0	0	243880	0	313782	1127433		
32760	715	40213306	2006-02-07	2006-02-07 00:00:00	2006-02-07	2006-02-07 00:00:00	2006-02-07	581452		0	0	0		0	0	0	47309	0	43	40213306		
37817	825	40213227	2003-09-13	2003-09-13 00:00:00	2003-09-13	2003-09-13 00:00:00	2003-09-13	581452		0	0	0		0	0	0	54677	0	113	40213227		
161296	3549	40213227	2008-06-10	2008-06-10 00:00:00	2008-06-10	2008-06-10 00:00:00	2008-06-10	581452		0	0	0		0	0	0	235636	0	113	40213227		
38778	3207	1127078	1962-10-12	1962-10-12 00:00:00	1962-10-26	1962-10-26 00:00:00	1962-10-26	38000177		0	0	14		0	0	0	213184	0	282464	1127078		
61133	5083	19133905	1973-12-14	1973-12-14 00:00:00	1973-12-24	1973-12-24 00:00:00	1973-12-24	38000177		0	0	10		0	0	0	338023	0	834102	19133905		
32234	2673	1124300	2016-08-16	2016-08-16 00:00:00	2016-08-16	2016-08-16 00:00:00	\N	38000177		0	0	0		0	0	0	177063	0	00781178901	45011828		
130544	2868	40213227	2004-10-20	2004-10-20 00:00:00	2004-10-20	2004-10-20 00:00:00	2004-10-20	581452		0	0	0		0	0	0	190804	0	113	40213227		
30465	2526	19078461	2004-05-17	2004-05-17 00:00:00	2004-05-31	2004-05-31 00:00:00	2004-05-31	38000177		0	0	14		0	0	0	167006	0	310965	19078461		
16314	1353	1118084	1992-11-05	1992-11-05 00:00:00	1992-11-05	1992-11-05 00:00:00	\N	38000177		0	0	0		0	0	0	89644	0	00025152531	44923712		
10588	882	40229134	1975-03-17	1975-03-17 00:00:00	1975-03-24	1975-03-24 00:00:00	1975-03-24	38000177		0	0	7		0	0	0	58726	0	1043400	40229134		
9723	814	19128065	1995-07-04	1995-07-04 00:00:00	1996-06-28	1996-06-28 00:00:00	1996-06-28	38000177		0	0	360		0	0	0	53980	0	749882	19128065		
219029	4807	40213201	2011-04-07	2011-04-07 00:00:00	2011-04-07	2011-04-07 00:00:00	2011-04-07	581452		0	0	0		0	0	0	319817	0	33	40213201		
34534	2853	1118084	1999-06-13	1999-06-13 00:00:00	1999-06-13	1999-06-13 00:00:00	\N	38000177		0	0	0		0	0	0	189552	0	00025152531	44923712		
23872	1966	19129655	1965-07-03	1965-07-03 00:00:00	1965-07-17	1965-07-17 00:00:00	1965-07-17	38000177		0	0	14		0	0	0	130707	0	789980	19129655		
119457	2626	40213296	2003-07-08	2003-07-08 00:00:00	2003-07-08	2003-07-08 00:00:00	2003-07-08	581452		0	0	0		0	0	0	173691	0	52	40213296		
16668	1382	1115171	2019-05-17	2019-05-17 00:00:00	2019-06-07	2019-06-07 00:00:00	2019-06-07	38000177		0	0	21		0	0	0	91653	0	849574	1115171		
30909	2559	1127433	1970-02-21	1970-02-21 00:00:00	1970-03-07	1970-03-07 00:00:00	1970-03-07	38000177		0	0	14		0	0	0	169604	0	313782	1127433		
176	12	1713671	1997-01-16	1997-01-16 00:00:00	1997-01-30	1997-01-30 00:00:00	1997-01-30	38000177		0	0	14		0	0	0	1020	0	562251	1713671		
129025	2837	40213306	1988-08-17	1988-08-17 00:00:00	1988-08-17	1988-08-17 00:00:00	1988-08-17	581452		0	0	0		0	0	0	188429	0	43	40213306		
137134	3010	40213306	1986-03-19	1986-03-19 00:00:00	1986-03-19	1986-03-19 00:00:00	1986-03-19	581452		0	0	0		0	0	0	200760	0	43	40213306		
136050	2987	40213160	1972-12-04	1972-12-04 00:00:00	1972-12-04	1972-12-04 00:00:00	1972-12-04	581452		0	0	0		0	0	0	199374	0	10	40213160		
4752	102	40213160	1972-10-01	1972-10-01 00:00:00	1972-10-01	1972-10-01 00:00:00	1972-10-01	581452		0	0	0		0	0	0	6975	0	10	40213160		
36963	3057	19133873	1942-03-08	1942-03-08 00:00:00	1942-03-15	1942-03-15 00:00:00	1942-03-15	38000177		0	0	7		0	0	0	203353	0	834061	19133873		
207413	4551	40213306	1999-06-16	1999-06-16 00:00:00	1999-06-16	1999-06-16 00:00:00	1999-06-16	581452		0	0	0		0	0	0	303318	0	43	40213306		
16160	348	40213227	2007-01-08	2007-01-08 00:00:00	2007-01-08	2007-01-08 00:00:00	2007-01-08	581452		0	0	0		0	0	0	23151	0	113	40213227		
131482	2890	40213296	2004-08-06	2004-08-06 00:00:00	2004-08-06	2004-08-06 00:00:00	2004-08-06	581452		0	0	0		0	0	0	192245	0	52	40213296		
231808	5094	40213160	1978-10-09	1978-10-09 00:00:00	1978-10-09	1978-10-09 00:00:00	1978-10-09	581452		0	0	0		0	0	0	338450	0	10	40213160		
38924	3216	1713671	2017-11-17	2017-11-17 00:00:00	2017-12-01	2017-12-01 00:00:00	2017-12-01	38000177		0	0	14		0	0	0	213734	0	562251	1713671		
187926	4127	40213201	2013-09-29	2013-09-29 00:00:00	2013-09-29	2013-09-29 00:00:00	2013-09-29	581452		0	0	0		0	0	0	274392	0	33	40213201		
217648	4776	40213227	2011-04-24	2011-04-24 00:00:00	2011-04-24	2011-04-24 00:00:00	2011-04-24	581452		0	0	0		0	0	0	318053	0	113	40213227		
12943	279	40213160	1955-05-06	1955-05-06 00:00:00	1955-05-06	1955-05-06 00:00:00	1955-05-06	581452		0	0	0		0	0	0	18662	0	10	40213160		
123425	2712	40213160	1964-06-09	1964-06-09 00:00:00	1964-06-09	1964-06-09 00:00:00	1964-06-09	581452		0	0	0		0	0	0	179878	0	10	40213160		
56427	4682	19074843	1981-02-07	1981-02-07 00:00:00	1981-02-21	1981-02-21 00:00:00	1981-02-21	38000177		0	0	14		0	0	0	312001	0	309045	19074843		
36015	2965	19128065	1985-02-14	1985-02-14 00:00:00	1986-02-09	1986-02-09 00:00:00	1986-02-09	38000177		0	0	360		0	0	0	198016	0	749882	19128065		
13080	1098	19129655	1961-03-13	1961-03-13 00:00:00	1961-03-27	1961-03-27 00:00:00	1961-03-27	38000177		0	0	14		0	0	0	72045	0	789980	19129655		
46574	3857	19059056	1960-03-29	1960-03-29 00:00:00	1960-04-26	1960-04-26 00:00:00	1960-04-26	38000177		0	0	28		0	0	0	256035	0	243670	19059056		
36666	800	40213160	1955-08-07	1955-08-07 00:00:00	1955-08-07	1955-08-07 00:00:00	1955-08-07	581452		0	0	0		0	0	0	53115	0	10	40213160		
100363	2199	40213314	1979-12-30	1979-12-30 00:00:00	1979-12-30	1979-12-30 00:00:00	1979-12-30	581452		0	0	0		0	0	0	146594	0	49	40213314		
13960	1169	1539411	2014-09-22	2014-09-22 00:00:00	2014-09-22	2014-09-22 00:00:00	\N	38000177		0	0	0		0	0	0	77060	0	312961	1539411		
1054	86	1713671	1967-05-22	1967-05-22 00:00:00	1967-06-05	1967-06-05 00:00:00	1967-06-05	38000177		0	0	14		0	0	0	5828	0	562251	1713671		
14018	1173	19006318	1946-06-03	1946-06-03 00:00:00	1946-06-17	1946-06-17 00:00:00	1946-06-17	38000177		0	0	14		0	0	0	77212	0	105078	19006318		
99919	2189	40213160	1980-10-12	1980-10-12 00:00:00	1980-10-12	1980-10-12 00:00:00	1980-10-12	581452		0	0	0		0	0	0	145922	0	10	40213160		
152758	3363	40213201	2017-06-02	2017-06-02 00:00:00	2017-06-02	2017-06-02 00:00:00	2017-06-02	581452		0	0	0		0	0	0	222947	0	33	40213201		
42021	3483	1713671	1956-03-07	1956-03-07 00:00:00	1956-03-28	1956-03-28 00:00:00	1956-03-28	38000177		0	0	21		0	0	0	231090	0	562251	1713671		
185063	4067	40213160	1976-03-06	1976-03-06 00:00:00	1976-03-06	1976-03-06 00:00:00	1976-03-06	581452		0	0	0		0	0	0	270243	0	10	40213160		
70895	1551	40213227	2008-01-14	2008-01-14 00:00:00	2008-01-14	2008-01-14 00:00:00	2008-01-14	581452		0	0	0		0	0	0	103820	0	113	40213227		
14477	1214	19059056	1968-09-15	1968-09-15 00:00:00	1968-10-06	1968-10-06 00:00:00	1968-10-06	38000177		0	0	21		0	0	0	80005	0	243670	19059056		
34782	2871	40162522	2017-03-15	2017-03-15 00:00:00	2017-03-15	2017-03-15 00:00:00	\N	38000177		0	0	0		0	0	0	191095	0	857005	40162522		
130491	2867	40213251	1984-07-31	1984-07-31 00:00:00	1984-07-31	1984-07-31 00:00:00	1984-07-31	581452		0	0	0		0	0	0	190708	0	21	40213251		
34851	2878	1127433	2000-07-20	2000-07-20 00:00:00	2000-08-03	2000-08-03 00:00:00	2000-08-03	38000177		0	0	14		0	0	0	191433	0	313782	1127433		
159407	3509	40213227	1993-01-22	1993-01-22 00:00:00	1993-01-22	1993-01-22 00:00:00	1993-01-22	581452		0	0	0		0	0	0	232727	0	113	40213227		
36829	3044	19059056	1969-07-20	1969-07-20 00:00:00	1969-08-03	1969-08-03 00:00:00	1969-08-03	38000177		0	0	14		0	0	0	202605	0	243670	19059056		
111181	2442	40213160	1975-08-11	1975-08-11 00:00:00	1975-08-11	1975-08-11 00:00:00	1975-08-11	581452		0	0	0		0	0	0	161950	0	10	40213160		
37380	3088	1127433	1964-08-11	1964-08-11 00:00:00	1964-08-25	1964-08-25 00:00:00	1964-08-25	38000177		0	0	14		0	0	0	205610	0	313782	1127433		
3769	81	40213260	2007-04-11	2007-04-11 00:00:00	2007-04-11	2007-04-11 00:00:00	2007-04-11	581452		0	0	0		0	0	0	5534	0	121	40213260		
37493	3100	1713671	1995-05-08	1995-05-08 00:00:00	1995-05-29	1995-05-29 00:00:00	1995-05-29	38000177		0	0	21		0	0	0	206275	0	562251	1713671		
8846	189	40213227	1992-07-19	1992-07-19 00:00:00	1992-07-19	1992-07-19 00:00:00	1992-07-19	581452		0	0	0		0	0	0	12868	0	113	40213227		
24990	545	40213296	2011-10-15	2011-10-15 00:00:00	2011-10-15	2011-10-15 00:00:00	2011-10-15	581452		0	0	0		0	0	0	36132	0	52	40213296		
33287	2758	40229134	2012-02-07	2012-02-07 00:00:00	2012-02-21	2012-02-21 00:00:00	2012-02-21	38000177		0	0	14		0	0	0	182490	0	1043400	40229134		
204615	4491	40213227	1997-01-19	1997-01-19 00:00:00	1997-01-19	1997-01-19 00:00:00	1997-01-19	581452		0	0	0		0	0	0	299030	0	113	40213227		
15895	1320	19059056	1947-09-21	1947-09-21 00:00:00	1947-10-12	1947-10-12 00:00:00	1947-10-12	38000177		0	0	21		0	0	0	87474	0	243670	19059056		
18781	1551	1127433	1990-04-07	1990-04-07 00:00:00	1990-04-28	1990-04-28 00:00:00	1990-04-28	38000177		0	0	21		0	0	0	103885	0	313782	1127433		
26445	2175	40236824	1992-03-06	1992-03-06 00:00:00	1992-03-13	1992-03-13 00:00:00	1992-03-13	38000177		0	0	7		0	0	0	145083	0	1094107	40236824		
44282	3666	1118084	2000-11-05	2000-11-05 00:00:00	2000-11-05	2000-11-05 00:00:00	\N	38000177		0	0	0		0	0	0	243929	0	00025152531	44923712		
32761	715	40213180	2006-02-07	2006-02-07 00:00:00	2006-02-07	2006-02-07 00:00:00	2006-02-07	581452		0	0	0		0	0	0	47309	0	114	40213180		
233538	5132	40213160	1967-01-16	1967-01-16 00:00:00	1967-01-16	1967-01-16 00:00:00	1967-01-16	581452		0	0	0		0	0	0	341161	0	10	40213160		
161297	3549	40213260	2008-06-10	2008-06-10 00:00:00	2008-06-10	2008-06-10 00:00:00	2008-06-10	581452		0	0	0		0	0	0	235636	0	121	40213260		
38779	3207	19078461	1990-07-01	1990-07-01 00:00:00	1990-07-29	1990-07-29 00:00:00	1990-07-29	38000177		0	0	28		0	0	0	213205	0	310965	19078461		
61134	5083	19078461	1995-06-02	1995-06-02 00:00:00	1995-07-02	1995-07-02 00:00:00	1995-07-02	38000177		0	0	30		0	0	0	337992	0	310965	19078461		
32235	2673	1713671	1979-06-06	1979-06-06 00:00:00	1979-06-13	1979-06-13 00:00:00	1979-06-13	38000177		0	0	7		0	0	0	177112	0	562251	1713671		
130545	2868	40213296	2004-10-20	2004-10-20 00:00:00	2004-10-20	2004-10-20 00:00:00	2004-10-20	581452		0	0	0		0	0	0	190804	0	52	40213296		
30466	2526	40165015	1996-07-07	1996-07-07 00:00:00	1996-07-07	1996-07-07 00:00:00	\N	38000177		0	0	0		0	0	0	167005	0	861467	40165015		
16315	1353	1127433	2017-04-18	2017-04-18 00:00:00	2017-04-25	2017-04-25 00:00:00	2017-04-25	38000177		0	0	7		0	0	0	89664	0	313782	1127433		
10589	882	19133873	1957-06-07	1957-06-07 00:00:00	1957-06-16	1957-06-16 00:00:00	1957-06-16	38000177		0	0	9		0	0	0	58675	0	834061	19133873		
9724	814	1127433	1995-12-21	1995-12-21 00:00:00	1996-03-20	1996-03-20 00:00:00	1996-03-20	38000177		0	0	90		0	0	0	53979	0	313782	1127433		
229382	5041	40213160	1975-11-04	1975-11-04 00:00:00	1975-11-04	1975-11-04 00:00:00	1975-11-04	581452		0	0	0		0	0	0	334933	0	10	40213160		
34535	2853	1127433	1973-04-13	1973-04-13 00:00:00	1973-04-20	1973-04-20 00:00:00	1973-04-20	38000177		0	0	7		0	0	0	189505	0	313782	1127433		
214972	4715	40213201	2016-12-13	2016-12-13 00:00:00	2016-12-13	2016-12-13 00:00:00	2016-12-13	581452		0	0	0		0	0	0	313920	0	33	40213201		
119460	2626	40213160	1964-03-10	1964-03-10 00:00:00	1964-03-10	1964-03-10 00:00:00	1964-03-10	581452		0	0	0		0	0	0	173673	0	10	40213160		
16669	1382	1127433	1987-12-25	1987-12-25 00:00:00	1988-01-08	1988-01-08 00:00:00	1988-01-08	38000177		0	0	14		0	0	0	91651	0	313782	1127433		
30910	2559	1118084	1990-03-29	1990-03-29 00:00:00	1990-03-29	1990-03-29 00:00:00	\N	38000177		0	0	0		0	0	0	169527	0	00025152531	44923712		
177	12	19059056	1988-01-10	1988-01-10 00:00:00	1988-02-14	1988-02-14 00:00:00	1988-02-14	38000177		0	0	35		0	0	0	1013	0	243670	19059056		
129028	2837	40213296	2008-10-22	2008-10-22 00:00:00	2008-10-22	2008-10-22 00:00:00	2008-10-22	581452		0	0	0		0	0	0	188448	0	52	40213296		
137136	3010	40213296	2007-01-31	2007-01-31 00:00:00	2007-01-31	2007-01-31 00:00:00	2007-01-31	581452		0	0	0		0	0	0	200762	0	52	40213296		
136053	2987	40213306	1995-07-24	1995-07-24 00:00:00	1995-07-24	1995-07-24 00:00:00	1995-07-24	581452		0	0	0		0	0	0	199386	0	43	40213306		
4755	102	40213314	1977-06-05	1977-06-05 00:00:00	1977-06-05	1977-06-05 00:00:00	1977-06-05	581452		0	0	0		0	0	0	7002	0	49	40213314		
36964	3057	19078461	1978-06-28	1978-06-28 00:00:00	1978-07-26	1978-07-26 00:00:00	1978-07-26	38000177		0	0	28		0	0	0	203386	0	310965	19078461		
207417	4551	40213160	1977-05-04	1977-05-04 00:00:00	1977-05-04	1977-05-04 00:00:00	1977-05-04	581452		0	0	0		0	0	0	303333	0	10	40213160		
16165	349	40213160	1958-02-08	1958-02-08 00:00:00	1958-02-08	1958-02-08 00:00:00	1958-02-08	581452		0	0	0		0	0	0	23232	0	10	40213160		
131485	2890	40213227	2004-08-06	2004-08-06 00:00:00	2004-08-06	2004-08-06 00:00:00	2004-08-06	581452		0	0	0		0	0	0	192245	0	113	40213227		
231815	5094	40213227	2000-07-03	2000-07-03 00:00:00	2000-07-03	2000-07-03 00:00:00	2000-07-03	581452		0	0	0		0	0	0	338487	0	113	40213227		
38925	3216	40229134	2002-06-13	2002-06-13 00:00:00	2002-06-27	2002-06-27 00:00:00	2002-06-27	38000177		0	0	14		0	0	0	213712	0	1043400	40229134		
187932	4127	40213160	1955-06-26	1955-06-26 00:00:00	1955-06-26	1955-06-26 00:00:00	1955-06-26	581452		0	0	0		0	0	0	274353	0	10	40213160		
208413	4571	40213296	1996-01-13	1996-01-13 00:00:00	1996-01-13	1996-01-13 00:00:00	1996-01-13	581452		0	0	0		0	0	0	304587	0	52	40213296		
12944	279	40213160	1955-11-04	1955-11-04 00:00:00	1955-11-04	1955-11-04 00:00:00	1955-11-04	581452		0	0	0		0	0	0	18598	0	10	40213160		
123435	2712	40213160	1968-12-10	1968-12-10 00:00:00	1968-12-10	1968-12-10 00:00:00	1968-12-10	581452		0	0	0		0	0	0	179865	0	10	40213160		
56428	4682	1115171	2008-11-10	2008-11-10 00:00:00	2008-11-24	2008-11-24 00:00:00	2008-11-24	38000177		0	0	14		0	0	0	312044	0	849574	1115171		
36016	2965	1127078	1971-04-30	1971-04-30 00:00:00	1971-05-14	1971-05-14 00:00:00	1971-05-14	38000177		0	0	14		0	0	0	197903	0	282464	1127078		
13081	1098	19059056	1961-03-13	1961-03-13 00:00:00	1961-03-27	1961-03-27 00:00:00	1961-03-27	38000177		0	0	14		0	0	0	72045	0	243670	19059056		
46579	3857	1127433	1997-03-22	1997-03-22 00:00:00	1997-04-05	1997-04-05 00:00:00	1997-04-05	38000177		0	0	14		0	0	0	256005	0	313782	1127433		
36675	800	40213160	1955-02-06	1955-02-06 00:00:00	1955-02-06	1955-02-06 00:00:00	1955-02-06	581452		0	0	0		0	0	0	53143	0	10	40213160		
100364	2199	40213160	1979-12-30	1979-12-30 00:00:00	1979-12-30	1979-12-30 00:00:00	1979-12-30	581452		0	0	0		0	0	0	146594	0	10	40213160		
13961	1169	1332419	2014-09-22	2014-09-22 00:00:00	2014-09-22	2014-09-22 00:00:00	\N	38000177		0	0	0		0	0	0	77060	0	197361	1332419		
1055	86	1127078	1952-04-03	1952-04-03 00:00:00	1952-05-02	1952-05-02 00:00:00	1952-05-02	38000177		0	0	29		0	0	0	5790	0	282464	1127078		
14020	1173	1127433	1993-02-01	1993-02-01 00:00:00	1993-02-22	1993-02-22 00:00:00	1993-02-22	38000177		0	0	21		0	0	0	77236	0	313782	1127433		
99920	2189	40213251	1984-01-08	1984-01-08 00:00:00	1984-01-08	1984-01-08 00:00:00	1984-01-08	581452		0	0	0		0	0	0	145966	0	21	40213251		
178851	3932	40213160	1973-09-03	1973-09-03 00:00:00	1973-09-03	1973-09-03 00:00:00	1973-09-03	581452		0	0	0		0	0	0	261363	0	10	40213160		
42022	3483	46233710	1978-02-26	1978-02-26 00:00:00	1978-03-19	1978-03-19 00:00:00	1978-03-19	38000177		0	0	21		0	0	0	231118	0	1650142	46233710		
185065	4067	40213227	2002-06-08	2002-06-08 00:00:00	2002-06-08	2002-06-08 00:00:00	2002-06-08	581452		0	0	0		0	0	0	270214	0	113	40213227		
70899	1551	40213227	1998-12-21	1998-12-21 00:00:00	1998-12-21	1998-12-21 00:00:00	1998-12-21	581452		0	0	0		0	0	0	103877	0	113	40213227		
14478	1214	19059056	1942-03-28	1942-03-28 00:00:00	1942-04-11	1942-04-11 00:00:00	1942-04-11	38000177		0	0	14		0	0	0	79891	0	243670	19059056		
34783	2871	19133873	1955-09-19	1955-09-19 00:00:00	1955-10-01	1955-10-01 00:00:00	1955-10-01	38000177		0	0	12		0	0	0	191119	0	834061	19133873		
154592	3403	40213296	2009-04-06	2009-04-06 00:00:00	2009-04-06	2009-04-06 00:00:00	2009-04-06	581452		0	0	0		0	0	0	225765	0	52	40213296		
34852	2878	1127078	1984-03-06	1984-03-06 00:00:00	1984-03-27	1984-03-27 00:00:00	1984-03-27	38000177		0	0	21		0	0	0	191470	0	282464	1127078		
216347	4748	40213227	2016-04-29	2016-04-29 00:00:00	2016-04-29	2016-04-29 00:00:00	2016-04-29	581452		0	0	0		0	0	0	316168	0	113	40213227		
36830	3044	19006318	1969-07-20	1969-07-20 00:00:00	1969-08-03	1969-08-03 00:00:00	1969-08-03	38000177		0	0	14		0	0	0	202605	0	105078	19006318		
111184	2442	40213227	2003-03-10	2003-03-10 00:00:00	2003-03-10	2003-03-10 00:00:00	2003-03-10	581452		0	0	0		0	0	0	161980	0	113	40213227		
37381	3088	1127433	1970-03-16	1970-03-16 00:00:00	1970-04-06	1970-04-06 00:00:00	1970-04-06	38000177		0	0	21		0	0	0	205637	0	313782	1127433		
3774	82	40213227	1992-06-02	1992-06-02 00:00:00	1992-06-02	1992-06-02 00:00:00	1992-06-02	581452		0	0	0		0	0	0	5596	0	113	40213227		
37494	3100	40229134	1990-06-11	1990-06-11 00:00:00	1990-06-18	1990-06-18 00:00:00	1990-06-18	38000177		0	0	7		0	0	0	206218	0	1043400	40229134		
8851	189	40213160	1958-08-17	1958-08-17 00:00:00	1958-08-17	1958-08-17 00:00:00	1958-08-17	581452		0	0	0		0	0	0	12899	0	10	40213160		
8657	723	1115171	2013-12-21	2013-12-21 00:00:00	2014-02-19	2014-02-19 00:00:00	2014-02-19	38000177		0	0	60		0	0	0	47822	0	849574	1115171		
33288	2758	19059056	1941-12-21	1941-12-21 00:00:00	1942-01-11	1942-01-11 00:00:00	1942-01-11	38000177		0	0	21		0	0	0	182454	0	243670	19059056		
204631	4492	40213227	2018-01-02	2018-01-02 00:00:00	2018-01-02	2018-01-02 00:00:00	2018-01-02	581452		0	0	0		0	0	0	299044	0	113	40213227		
15896	1320	1127433	1971-10-06	1971-10-06 00:00:00	1971-10-13	1971-10-13 00:00:00	1971-10-13	38000177		0	0	7		0	0	0	87480	0	313782	1127433		
18782	1551	1127433	2001-12-07	2001-12-07 00:00:00	2001-12-21	2001-12-21 00:00:00	2001-12-21	38000177		0	0	14		0	0	0	103834	0	313782	1127433		
26446	2175	920300	1992-03-06	1992-03-06 00:00:00	1992-03-13	1992-03-13 00:00:00	1992-03-13	38000177		0	0	7		0	0	0	145083	0	311989	920300		
44283	3666	1127078	1962-09-16	1962-09-16 00:00:00	1962-09-30	1962-09-30 00:00:00	1962-09-30	38000177		0	0	14		0	0	0	243863	0	282464	1127078		
32763	715	40213227	2006-02-07	2006-02-07 00:00:00	2006-02-07	2006-02-07 00:00:00	2006-02-07	581452		0	0	0		0	0	0	47309	0	113	40213227		
233545	5132	40213160	1967-04-17	1967-04-17 00:00:00	1967-04-17	1967-04-17 00:00:00	1967-04-17	581452		0	0	0		0	0	0	341113	0	10	40213160		
161299	3549	40213160	1957-09-10	1957-09-10 00:00:00	1957-09-10	1957-09-10 00:00:00	1957-09-10	581452		0	0	0		0	0	0	235643	0	10	40213160		
38780	3207	19059056	1963-08-12	1963-08-12 00:00:00	1963-08-26	1963-08-26 00:00:00	1963-08-26	38000177		0	0	14		0	0	0	213176	0	243670	19059056		
61135	5083	19078461	2011-06-08	2011-06-08 00:00:00	2011-06-22	2011-06-22 00:00:00	2011-06-22	38000177		0	0	14		0	0	0	338031	0	310965	19078461		
32236	2673	1127433	2007-10-30	2007-10-30 00:00:00	2007-11-13	2007-11-13 00:00:00	2007-11-13	38000177		0	0	14		0	0	0	177051	0	313782	1127433		
83868	1834	40213227	2017-06-04	2017-06-04 00:00:00	2017-06-04	2017-06-04 00:00:00	2017-06-04	581452		0	0	0		0	0	0	122500	0	113	40213227		
30467	2526	1127433	2014-04-23	2014-04-23 00:00:00	2014-05-21	2014-05-21 00:00:00	2014-05-21	38000177		0	0	28		0	0	0	167008	0	313782	1127433		
16316	1353	1127433	1986-05-05	1986-05-05 00:00:00	1986-05-26	1986-05-26 00:00:00	1986-05-26	38000177		0	0	21		0	0	0	89643	0	313782	1127433		
10590	882	1127433	1993-11-06	1993-11-06 00:00:00	1993-11-27	1993-11-27 00:00:00	1993-11-27	38000177		0	0	21		0	0	0	58721	0	313782	1127433		
9725	814	1127433	2003-04-15	2003-04-15 00:00:00	2003-04-22	2003-04-22 00:00:00	2003-04-22	38000177		0	0	7		0	0	0	53973	0	313782	1127433		
55804	1222	40213227	2014-09-10	2014-09-10 00:00:00	2014-09-10	2014-09-10 00:00:00	2014-09-10	581452		0	0	0		0	0	0	80426	0	113	40213227		
34536	2853	1713671	1983-05-10	1983-05-10 00:00:00	1983-05-31	1983-05-31 00:00:00	1983-05-31	38000177		0	0	21		0	0	0	189522	0	562251	1713671		
113154	2485	40213227	1994-09-21	1994-09-21 00:00:00	1994-09-21	1994-09-21 00:00:00	1994-09-21	581452		0	0	0		0	0	0	164699	0	113	40213227		
119465	2626	40213306	1985-09-03	1985-09-03 00:00:00	1985-09-03	1985-09-03 00:00:00	1985-09-03	581452		0	0	0		0	0	0	173679	0	43	40213306		
16670	1382	19078461	1994-08-26	1994-08-26 00:00:00	1994-10-25	1994-10-25 00:00:00	1994-10-25	38000177		0	0	60		0	0	0	91652	0	310965	19078461		
30911	2559	19129655	1962-10-05	1962-10-05 00:00:00	1962-10-19	1962-10-19 00:00:00	1962-10-19	38000177		0	0	14		0	0	0	169654	0	789980	19129655		
178	12	19059056	1986-11-16	1986-11-16 00:00:00	1986-12-16	1986-12-16 00:00:00	1986-12-16	38000177		0	0	30		0	0	0	997	0	243670	19059056		
129030	2837	40213227	2008-10-22	2008-10-22 00:00:00	2008-10-22	2008-10-22 00:00:00	2008-10-22	581452		0	0	0		0	0	0	188448	0	113	40213227		
62365	5191	1127433	1998-03-06	1998-03-06 00:00:00	1998-03-20	1998-03-20 00:00:00	1998-03-20	38000177		0	0	14		0	0	0	345089	0	313782	1127433		
136055	2987	40213227	1995-07-24	1995-07-24 00:00:00	1995-07-24	1995-07-24 00:00:00	1995-07-24	581452		0	0	0		0	0	0	199386	0	113	40213227		
4756	102	40213160	1977-06-05	1977-06-05 00:00:00	1977-06-05	1977-06-05 00:00:00	1977-06-05	581452		0	0	0		0	0	0	7002	0	10	40213160		
36965	3057	19133873	1949-01-08	1949-01-08 00:00:00	1949-01-15	1949-01-15 00:00:00	1949-01-15	38000177		0	0	7		0	0	0	203334	0	834061	19133873		
207418	4551	40213314	1977-05-04	1977-05-04 00:00:00	1977-05-04	1977-05-04 00:00:00	1977-05-04	581452		0	0	0		0	0	0	303333	0	49	40213314		
16169	349	40213260	2008-03-01	2008-03-01 00:00:00	2008-03-01	2008-03-01 00:00:00	2008-03-01	581452		0	0	0		0	0	0	23237	0	121	40213260		
131492	2890	40213227	1994-07-22	1994-07-22 00:00:00	1994-07-22	1994-07-22 00:00:00	1994-07-22	581452		0	0	0		0	0	0	192218	0	113	40213227		
231816	5094	40213306	2000-07-03	2000-07-03 00:00:00	2000-07-03	2000-07-03 00:00:00	2000-07-03	581452		0	0	0		0	0	0	338487	0	43	40213306		
38926	3216	1127078	1963-07-26	1963-07-26 00:00:00	1963-08-09	1963-08-09 00:00:00	1963-08-09	38000177		0	0	14		0	0	0	213707	0	282464	1127078		
112981	2482	40213160	1975-05-22	1975-05-22 00:00:00	1975-05-22	1975-05-22 00:00:00	1975-05-22	581452		0	0	0		0	0	0	164434	0	10	40213160		
208416	4571	40213160	1959-06-06	1959-06-06 00:00:00	1959-06-06	1959-06-06 00:00:00	1959-06-06	581452		0	0	0		0	0	0	304581	0	10	40213160		
12947	279	40213227	1993-06-18	1993-06-18 00:00:00	1993-06-18	1993-06-18 00:00:00	1993-06-18	581452		0	0	0		0	0	0	18609	0	113	40213227		
123438	2712	40213227	2015-01-06	2015-01-06 00:00:00	2015-01-06	2015-01-06 00:00:00	2015-01-06	581452		0	0	0		0	0	0	179841	0	113	40213227		
56429	4682	19133873	1996-02-21	1996-02-21 00:00:00	1996-03-01	1996-03-01 00:00:00	1996-03-01	38000177		0	0	9		0	0	0	312023	0	834061	19133873		
36017	2965	19112599	1972-03-15	1972-03-15 00:00:00	1972-03-15	1972-03-15 00:00:00	\N	38000177		0	0	0		0	0	0	197965	0	477045	19112599		
13082	1098	920300	1998-01-14	1998-01-14 00:00:00	1998-01-21	1998-01-21 00:00:00	1998-01-21	38000177		0	0	7		0	0	0	72042	0	311989	920300		
46580	3857	40229134	1960-06-10	1960-06-10 00:00:00	1960-06-17	1960-06-17 00:00:00	1960-06-17	38000177		0	0	7		0	0	0	256029	0	1043400	40229134		
36678	800	40213260	2007-06-17	2007-06-17 00:00:00	2007-06-17	2007-06-17 00:00:00	2007-06-17	581452		0	0	0		0	0	0	53138	0	121	40213260		
100366	2199	40213314	1980-09-28	1980-09-28 00:00:00	1980-09-28	1980-09-28 00:00:00	1980-09-28	581452		0	0	0		0	0	0	146595	0	49	40213314		
13962	1169	19059056	1936-10-08	1936-10-08 00:00:00	1936-10-29	1936-10-29 00:00:00	1936-10-29	38000177		0	0	21		0	0	0	76983	0	243670	19059056		
1056	86	1127433	1965-11-10	1965-11-10 00:00:00	1965-11-24	1965-11-24 00:00:00	1965-11-24	38000177		0	0	14		0	0	0	5792	0	313782	1127433		
14021	1173	1713671	1991-08-16	1991-08-16 00:00:00	1991-08-30	1991-08-30 00:00:00	1991-08-30	38000177		0	0	14		0	0	0	77247	0	562251	1713671		
99927	2189	40213314	1981-04-05	1981-04-05 00:00:00	1981-04-05	1981-04-05 00:00:00	1981-04-05	581452		0	0	0		0	0	0	\N	0	49	40213314		
155262	3417	40213227	2000-09-09	2000-09-09 00:00:00	2000-09-09	2000-09-09 00:00:00	2000-09-09	581452		0	0	0		0	0	0	226664	0	113	40213227		
42023	3483	40165015	1978-02-26	1978-02-26 00:00:00	1978-02-26	1978-02-26 00:00:00	\N	38000177		0	0	0		0	0	0	231118	0	861467	40165015		
185068	4067	40213227	1993-05-29	1993-05-29 00:00:00	1993-05-29	1993-05-29 00:00:00	1993-05-29	581452		0	0	0		0	0	0	270211	0	113	40213227		
70900	1551	40213296	1998-12-21	1998-12-21 00:00:00	1998-12-21	1998-12-21 00:00:00	1998-12-21	581452		0	0	0		0	0	0	103877	0	52	40213296		
14479	1214	19133905	1967-09-19	1967-09-19 00:00:00	1967-09-29	1967-09-29 00:00:00	1967-09-29	38000177		0	0	10		0	0	0	79999	0	834102	19133905		
34784	2871	1713671	1960-08-22	1960-08-22 00:00:00	1960-09-05	1960-09-05 00:00:00	1960-09-05	38000177		0	0	14		0	0	0	191110	0	562251	1713671		
154598	3403	40213160	1969-07-07	1969-07-07 00:00:00	1969-07-07	1969-07-07 00:00:00	1969-07-07	581452		0	0	0		0	0	0	225747	0	10	40213160		
34853	2878	19128065	1997-08-05	1997-08-05 00:00:00	1998-07-31	1998-07-31 00:00:00	1998-07-31	38000177		0	0	360		0	0	0	191467	0	749882	19128065		
216349	4748	40213201	2011-04-01	2011-04-01 00:00:00	2011-04-01	2011-04-01 00:00:00	2011-04-01	581452		0	0	0		0	0	0	316128	0	33	40213201		
36831	3044	1127078	1974-08-23	1974-08-23 00:00:00	1974-09-13	1974-09-13 00:00:00	1974-09-13	38000177		0	0	21		0	0	0	202621	0	282464	1127078		
111187	2443	40213296	2005-10-14	2005-10-14 00:00:00	2005-10-14	2005-10-14 00:00:00	2005-10-14	581452		0	0	0		0	0	0	162081	0	52	40213296		
37382	3088	19133873	1950-08-02	1950-08-02 00:00:00	1950-08-15	1950-08-15 00:00:00	1950-08-15	38000177		0	0	13		0	0	0	205641	0	834061	19133873		
234048	5143	40213160	1959-08-19	1959-08-19 00:00:00	1959-08-19	1959-08-19 00:00:00	1959-08-19	581452		0	0	0		0	0	0	341833	0	10	40213160		
37495	3100	1115171	2007-04-17	2007-04-17 00:00:00	2007-05-08	2007-05-08 00:00:00	2007-05-08	38000177		0	0	21		0	0	0	206236	0	849574	1115171		
8859	189	40213260	2008-08-10	2008-08-10 00:00:00	2008-08-10	2008-08-10 00:00:00	2008-08-10	581452		0	0	0		0	0	0	12860	0	121	40213260		
8658	723	19133905	2011-08-17	2011-08-17 00:00:00	2011-08-29	2011-08-29 00:00:00	2011-08-29	38000177		0	0	12		0	0	0	47845	0	834102	19133905		
33289	2758	1127078	1950-09-24	1950-09-24 00:00:00	1950-10-08	1950-10-08 00:00:00	1950-10-08	38000177		0	0	14		0	0	0	182409	0	282464	1127078		
204638	4492	40213227	1998-03-03	1998-03-03 00:00:00	1998-03-03	1998-03-03 00:00:00	1998-03-03	581452		0	0	0		0	0	0	299065	0	113	40213227		
15897	1320	1713671	2000-04-03	2000-04-03 00:00:00	2000-04-24	2000-04-24 00:00:00	2000-04-24	38000177		0	0	21		0	0	0	87581	0	562251	1713671		
18783	1551	1713671	1983-10-17	1983-10-17 00:00:00	1983-11-07	1983-11-07 00:00:00	1983-11-07	38000177		0	0	21		0	0	0	103866	0	562251	1713671		
26447	2175	19008572	2009-01-31	2009-01-31 00:00:00	2009-01-31	2009-01-31 00:00:00	\N	38000177		0	0	0		0	0	0	145071	0	106258	19008572		
44284	3666	1127078	1965-08-31	1965-08-31 00:00:00	1965-09-21	1965-09-21 00:00:00	1965-09-21	38000177		0	0	21		0	0	0	243866	0	282464	1127078		
131295	2886	40213201	2017-04-17	2017-04-17 00:00:00	2017-04-17	2017-04-17 00:00:00	2017-04-17	581452		0	0	0		0	0	0	192009	0	33	40213201		
233549	5132	40213160	1966-11-14	1966-11-14 00:00:00	1966-11-14	1966-11-14 00:00:00	1966-11-14	581452		0	0	0		0	0	0	341112	0	10	40213160		
161300	3549	40213260	2007-06-05	2007-06-05 00:00:00	2007-06-05	2007-06-05 00:00:00	2007-06-05	581452		0	0	0		0	0	0	235652	0	121	40213260		
38781	3207	19006318	1963-08-12	1963-08-12 00:00:00	1963-08-26	1963-08-26 00:00:00	1963-08-26	38000177		0	0	14		0	0	0	213176	0	105078	19006318		
61136	5083	1127433	2013-06-11	2013-06-11 00:00:00	2013-07-02	2013-07-02 00:00:00	2013-07-02	38000177		0	0	21		0	0	0	338032	0	313782	1127433		
32237	2673	19128022	1995-01-14	1995-01-14 00:00:00	1996-01-09	1996-01-09 00:00:00	1996-01-09	38000177		0	0	360		0	0	0	177104	0	749785	19128022		
83875	1834	40213198	2011-07-03	2011-07-03 00:00:00	2011-07-03	2011-07-03 00:00:00	2011-07-03	581452		0	0	0		0	0	0	122499	0	133	40213198		
30468	2526	1115171	2000-07-16	2000-07-16 00:00:00	2000-08-06	2000-08-06 00:00:00	2000-08-06	38000177		0	0	21		0	0	0	167004	0	849574	1115171		
16317	1353	19133905	1980-12-26	1980-12-26 00:00:00	1981-01-08	1981-01-08 00:00:00	1981-01-08	38000177		0	0	13		0	0	0	89660	0	834102	19133905		
10591	882	1127433	2013-06-20	2013-06-20 00:00:00	2013-08-26	2013-08-26 00:00:00	2013-08-26	38000177		0	0	67		0	0	0	58723	0	313782	1127433		
9726	814	1713671	1994-03-17	1994-03-17 00:00:00	1994-03-24	1994-03-24 00:00:00	1994-03-24	38000177		0	0	7		0	0	0	53971	0	562251	1713671		
55805	1222	40213160	1956-02-01	1956-02-01 00:00:00	1956-02-01	1956-02-01 00:00:00	1956-02-01	581452		0	0	0		0	0	0	80408	0	10	40213160		
975	79	1713671	1981-11-23	1981-11-23 00:00:00	1981-11-30	1981-11-30 00:00:00	1981-11-30	38000177		0	0	7		0	0	0	5281	0	562251	1713671		
113160	2486	40213160	1974-06-28	1974-06-28 00:00:00	1974-06-28	1974-06-28 00:00:00	1974-06-28	581452		0	0	0		0	0	0	164745	0	10	40213160		
119468	2626	40213160	1963-12-10	1963-12-10 00:00:00	1963-12-10	1963-12-10 00:00:00	1963-12-10	581452		0	0	0		0	0	0	173683	0	10	40213160		
16671	1382	1127433	1985-06-16	1985-06-16 00:00:00	1985-06-30	1985-06-30 00:00:00	1985-06-30	38000177		0	0	14		0	0	0	91616	0	313782	1127433		
30912	2559	19059056	1962-10-05	1962-10-05 00:00:00	1962-10-19	1962-10-19 00:00:00	1962-10-19	38000177		0	0	14		0	0	0	169654	0	243670	19059056		
179	12	19133873	1972-05-13	1972-05-13 00:00:00	1972-05-22	1972-05-22 00:00:00	1972-05-22	38000177		0	0	9		0	0	0	1028	0	834061	19133873		
129034	2837	40213227	1998-09-30	1998-09-30 00:00:00	1998-09-30	1998-09-30 00:00:00	1998-09-30	581452		0	0	0		0	0	0	\N	0	113	40213227		
62366	5191	1127078	1973-10-03	1973-10-03 00:00:00	1973-11-07	1973-11-07 00:00:00	1973-11-07	38000177		0	0	35		0	0	0	345060	0	282464	1127078		
136056	2987	40213227	2004-08-02	2004-08-02 00:00:00	2004-08-02	2004-08-02 00:00:00	2004-08-02	581452		0	0	0		0	0	0	199389	0	113	40213227		
4761	102	40213160	1972-12-03	1972-12-03 00:00:00	1972-12-03	1972-12-03 00:00:00	1972-12-03	581452		0	0	0		0	0	0	6965	0	10	40213160		
36966	3057	19059056	1950-10-12	1950-10-12 00:00:00	1950-10-26	1950-10-26 00:00:00	1950-10-26	38000177		0	0	14		0	0	0	203367	0	243670	19059056		
207421	4551	40213314	1978-04-05	1978-04-05 00:00:00	1978-04-05	1978-04-05 00:00:00	1978-04-05	581452		0	0	0		0	0	0	303309	0	49	40213314		
16173	349	40213227	1999-02-06	1999-02-06 00:00:00	1999-02-06	1999-02-06 00:00:00	1999-02-06	581452		0	0	0		0	0	0	23208	0	113	40213227		
131500	2890	40213160	1966-11-18	1966-11-18 00:00:00	1966-11-18	1966-11-18 00:00:00	1966-11-18	581452		0	0	0		0	0	0	192251	0	10	40213160		
231821	5095	40213306	1985-07-01	1985-07-01 00:00:00	1985-07-01	1985-07-01 00:00:00	1985-07-01	581452		0	0	0		0	0	0	338510	0	43	40213306		
38927	3216	1127433	1963-10-22	1963-10-22 00:00:00	1963-11-05	1963-11-05 00:00:00	1963-11-05	38000177		0	0	14		0	0	0	213743	0	313782	1127433		
112983	2482	40213160	1974-12-19	1974-12-19 00:00:00	1974-12-19	1974-12-19 00:00:00	1974-12-19	581452		0	0	0		0	0	0	164433	0	10	40213160		
208421	4571	40213296	1998-01-17	1998-01-17 00:00:00	1998-01-17	1998-01-17 00:00:00	1998-01-17	581452		0	0	0		0	0	0	304577	0	52	40213296		
49850	1092	40213227	2005-10-21	2005-10-21 00:00:00	2005-10-21	2005-10-21 00:00:00	2005-10-21	581452		0	0	0		0	0	0	71786	0	113	40213227		
123439	2712	40213260	2015-01-06	2015-01-06 00:00:00	2015-01-06	2015-01-06 00:00:00	2015-01-06	581452		0	0	0		0	0	0	179841	0	121	40213260		
56430	4682	1115171	2000-09-09	2000-09-09 00:00:00	2000-09-23	2000-09-23 00:00:00	2000-09-23	38000177		0	0	14		0	0	0	312043	0	849574	1115171		
36018	2965	1115171	2012-05-27	2012-05-27 00:00:00	2012-06-24	2012-06-24 00:00:00	2012-06-24	38000177		0	0	28		0	0	0	197987	0	849574	1115171		
13083	1098	40236824	1998-01-14	1998-01-14 00:00:00	1998-01-21	1998-01-21 00:00:00	1998-01-21	38000177		0	0	7		0	0	0	72042	0	1094107	40236824		
46591	3859	40165015	1995-10-23	1995-10-23 00:00:00	1995-10-23	1995-10-23 00:00:00	\N	38000177		0	0	0		0	0	0	256267	0	861467	40165015		
136673	3000	40213227	1992-05-01	1992-05-01 00:00:00	1992-05-01	1992-05-01 00:00:00	1992-05-01	581452		0	0	0		0	0	0	200225	0	113	40213227		
100370	2199	40213314	1979-10-28	1979-10-28 00:00:00	1979-10-28	1979-10-28 00:00:00	1979-10-28	581452		0	0	0		0	0	0	146551	0	49	40213314		
13963	1169	1545959	2018-08-20	2018-08-20 00:00:00	2018-08-20	2018-08-20 00:00:00	2018-08-20	38000177		0	0	0		0	0	0	76991	0	259255	1545959		
1057	86	1332419	2013-04-30	2013-04-30 00:00:00	2013-04-30	2013-04-30 00:00:00	\N	38000177		0	0	0		0	0	0	5814	0	197361	1332419		
14022	1173	1127433	1994-08-27	1994-08-27 00:00:00	1994-09-03	1994-09-03 00:00:00	1994-09-03	38000177		0	0	7		0	0	0	77269	0	313782	1127433		
99930	2189	40213314	1980-07-13	1980-07-13 00:00:00	1980-07-13	1980-07-13 00:00:00	1980-07-13	581452		0	0	0		0	0	0	145948	0	49	40213314		
155291	3418	40213227	1995-07-30	1995-07-30 00:00:00	1995-07-30	1995-07-30 00:00:00	1995-07-30	581452		0	0	0		0	0	0	226791	0	113	40213227		
42024	3483	1127433	1978-02-26	1978-02-26 00:00:00	1978-03-19	1978-03-19 00:00:00	1978-03-19	38000177		0	0	21		0	0	0	231118	0	313782	1127433		
185069	4067	40213306	1993-05-29	1993-05-29 00:00:00	1993-05-29	1993-05-29 00:00:00	1993-05-29	581452		0	0	0		0	0	0	270211	0	43	40213306		
70909	1551	40213160	1957-08-26	1957-08-26 00:00:00	1957-08-26	1957-08-26 00:00:00	1957-08-26	581452		0	0	0		0	0	0	103838	0	10	40213160		
14480	1214	19059056	1940-03-27	1940-03-27 00:00:00	1940-04-10	1940-04-10 00:00:00	1940-04-10	38000177		0	0	14		0	0	0	79928	0	243670	19059056		
34785	2871	19059056	1951-06-09	1951-06-09 00:00:00	1951-06-23	1951-06-23 00:00:00	1951-06-23	38000177		0	0	14		0	0	0	191147	0	243670	19059056		
154599	3403	40213160	1974-03-11	1974-03-11 00:00:00	1974-03-11	1974-03-11 00:00:00	1974-03-11	581452		0	0	0		0	0	0	225718	0	10	40213160		
34854	2878	1713671	2004-05-24	2004-05-24 00:00:00	2004-06-07	2004-06-07 00:00:00	2004-06-07	38000177		0	0	14		0	0	0	191442	0	562251	1713671		
216357	4748	40213227	1995-10-13	1995-10-13 00:00:00	1995-10-13	1995-10-13 00:00:00	1995-10-13	581452		0	0	0		0	0	0	316171	0	113	40213227		
36838	3047	1118084	2017-10-28	2017-10-28 00:00:00	2017-10-28	2017-10-28 00:00:00	\N	38000177		0	0	0		0	0	0	202751	0	00025152531	44923712		
111189	2443	40213227	2003-10-10	2003-10-10 00:00:00	2003-10-10	2003-10-10 00:00:00	2003-10-10	581452		0	0	0		0	0	0	162088	0	113	40213227		
37383	3088	1127433	1993-03-04	1993-03-04 00:00:00	1993-03-25	1993-03-25 00:00:00	1993-03-25	38000177		0	0	21		0	0	0	205639	0	313782	1127433		
234053	5143	40213227	2000-12-20	2000-12-20 00:00:00	2000-12-20	2000-12-20 00:00:00	2000-12-20	581452		0	0	0		0	0	0	341798	0	113	40213227		
37496	3100	1127433	1959-12-22	1959-12-22 00:00:00	1959-12-29	1959-12-29 00:00:00	1959-12-29	38000177		0	0	7		0	0	0	206217	0	313782	1127433		
8861	189	40213160	1963-04-21	1963-04-21 00:00:00	1963-04-21	1963-04-21 00:00:00	1963-04-21	581452		0	0	0		0	0	0	12843	0	10	40213160		
8659	723	1118084	2005-01-18	2005-01-18 00:00:00	2005-01-18	2005-01-18 00:00:00	\N	38000177		0	0	0		0	0	0	47842	0	00025152531	44923712		
33290	2758	19133873	1947-03-12	1947-03-12 00:00:00	1947-03-25	1947-03-25 00:00:00	1947-03-25	38000177		0	0	13		0	0	0	182475	0	834061	19133873		
204641	4492	40213201	2012-09-25	2012-09-25 00:00:00	2012-09-25	2012-09-25 00:00:00	2012-09-25	581452		0	0	0		0	0	0	299042	0	33	40213201		
15898	1320	19059056	1937-02-15	1937-02-15 00:00:00	1937-03-01	1937-03-01 00:00:00	1937-03-01	38000177		0	0	14		0	0	0	87487	0	243670	19059056		
18797	1553	1127433	1982-10-03	1982-10-03 00:00:00	1982-10-17	1982-10-17 00:00:00	1982-10-17	38000177		0	0	14		0	0	0	103978	0	313782	1127433		
26448	2175	1713671	1977-07-29	1977-07-29 00:00:00	1977-08-12	1977-08-12 00:00:00	1977-08-12	38000177		0	0	14		0	0	0	144980	0	562251	1713671		
44285	3666	19078461	1979-10-08	1979-10-08 00:00:00	1979-10-29	1979-10-29 00:00:00	1979-10-29	38000177		0	0	21		0	0	0	243868	0	310965	19078461		
131300	2886	40213227	1993-02-01	1993-02-01 00:00:00	1993-02-01	1993-02-01 00:00:00	1993-02-01	581452		0	0	0		0	0	0	191904	0	113	40213227		
233551	5132	40213227	1998-03-30	1998-03-30 00:00:00	1998-03-30	1998-03-30 00:00:00	1998-03-30	581452		0	0	0		0	0	0	341146	0	113	40213227		
161307	3549	40213227	2018-08-07	2018-08-07 00:00:00	2018-08-07	2018-08-07 00:00:00	2018-08-07	581452		0	0	0		0	0	0	235654	0	113	40213227		
38782	3207	1713671	1984-01-31	1984-01-31 00:00:00	1984-02-14	1984-02-14 00:00:00	1984-02-14	38000177		0	0	14		0	0	0	213208	0	562251	1713671		
61137	5083	1127433	1970-04-21	1970-04-21 00:00:00	1970-05-05	1970-05-05 00:00:00	1970-05-05	38000177		0	0	14		0	0	0	338022	0	313782	1127433		
32238	2673	19128022	1993-01-24	1993-01-24 00:00:00	1994-01-19	1994-01-19 00:00:00	1994-01-19	38000177		0	0	360		0	0	0	177054	0	749785	19128022		
83880	1834	40213227	2007-06-10	2007-06-10 00:00:00	2007-06-10	2007-06-10 00:00:00	2007-06-10	581452		0	0	0		0	0	0	122511	0	113	40213227		
30469	2526	1124300	2012-12-28	2012-12-28 00:00:00	2012-12-28	2012-12-28 00:00:00	\N	38000177		0	0	0		0	0	0	167023	0	00781178901	45011828		
16318	1353	1713671	1985-10-21	1985-10-21 00:00:00	1985-11-11	1985-11-11 00:00:00	1985-11-11	38000177		0	0	21		0	0	0	89632	0	562251	1713671		
10592	882	1713671	1970-12-31	1970-12-31 00:00:00	1971-01-21	1971-01-21 00:00:00	1971-01-21	38000177		0	0	21		0	0	0	58677	0	562251	1713671		
9727	814	1118084	2019-05-24	2019-05-24 00:00:00	2019-05-24	2019-05-24 00:00:00	\N	38000177		0	0	0		0	0	0	53970	0	00025152531	44923712		
55814	1223	40213227	2002-03-15	2002-03-15 00:00:00	2002-03-15	2002-03-15 00:00:00	2002-03-15	581452		0	0	0		0	0	0	80492	0	113	40213227		
976	79	19059056	1949-08-25	1949-08-25 00:00:00	1949-09-08	1949-09-08 00:00:00	1949-09-08	38000177		0	0	14		0	0	0	5287	0	243670	19059056		
113161	2486	40213160	1974-11-29	1974-11-29 00:00:00	1974-11-29	1974-11-29 00:00:00	1974-11-29	581452		0	0	0		0	0	0	164759	0	10	40213160		
119472	2626	40213160	1968-06-11	1968-06-11 00:00:00	1968-06-11	1968-06-11 00:00:00	1968-06-11	581452		0	0	0		0	0	0	173740	0	10	40213160		
16672	1382	1127078	1979-07-16	1979-07-16 00:00:00	1979-07-30	1979-07-30 00:00:00	1979-07-30	38000177		0	0	14		0	0	0	91646	0	282464	1127078		
30913	2559	1127433	1986-03-13	1986-03-13 00:00:00	1986-03-20	1986-03-20 00:00:00	1986-03-20	38000177		0	0	7		0	0	0	169594	0	313782	1127433		
180	12	19133905	1995-10-22	1995-10-22 00:00:00	1995-10-29	1995-10-29 00:00:00	1995-10-29	38000177		0	0	7		0	0	0	1017	0	834102	19133905		
129037	2837	40213227	2017-08-09	2017-08-09 00:00:00	2017-08-09	2017-08-09 00:00:00	2017-08-09	581452		0	0	0		0	0	0	188450	0	113	40213227		
62367	5191	1713671	2006-04-26	2006-04-26 00:00:00	2006-08-02	2006-08-02 00:00:00	2006-08-02	38000177		0	0	98		0	0	0	345121	0	562251	1713671		
136059	2987	40213296	2012-08-13	2012-08-13 00:00:00	2012-08-13	2012-08-13 00:00:00	2012-08-13	581452		0	0	0		0	0	0	199409	0	52	40213296		
4765	102	40213296	2014-07-06	2014-07-06 00:00:00	2014-07-06	2014-07-06 00:00:00	2014-07-06	581452		0	0	0		0	0	0	6995	0	52	40213296		
36967	3057	19006318	1950-10-12	1950-10-12 00:00:00	1950-10-26	1950-10-26 00:00:00	1950-10-26	38000177		0	0	14		0	0	0	203367	0	105078	19006318		
207423	4551	40213160	1977-10-05	1977-10-05 00:00:00	1977-10-05	1977-10-05 00:00:00	1977-10-05	581452		0	0	0		0	0	0	303334	0	10	40213160		
16174	349	40213296	1999-02-06	1999-02-06 00:00:00	1999-02-06	1999-02-06 00:00:00	1999-02-06	581452		0	0	0		0	0	0	23208	0	52	40213296		
131508	2890	40213306	1985-01-18	1985-01-18 00:00:00	1985-01-18	1985-01-18 00:00:00	1985-01-18	581452		0	0	0		0	0	0	\N	0	43	40213306		
231828	5095	40213296	2005-07-25	2005-07-25 00:00:00	2005-07-25	2005-07-25 00:00:00	2005-07-25	581452		0	0	0		0	0	0	338538	0	52	40213296		
38928	3216	1118084	1995-10-30	1995-10-30 00:00:00	1995-10-30	1995-10-30 00:00:00	\N	38000177		0	0	0		0	0	0	213732	0	00025152531	44923712		
112985	2482	40213306	1997-04-03	1997-04-03 00:00:00	1997-04-03	1997-04-03 00:00:00	1997-04-03	581452		0	0	0		0	0	0	164452	0	43	40213306		
208423	4571	40213260	2007-07-14	2007-07-14 00:00:00	2007-07-14	2007-07-14 00:00:00	2007-07-14	581452		0	0	0		0	0	0	304589	0	121	40213260		
49856	1092	40213160	1955-06-24	1955-06-24 00:00:00	1955-06-24	1955-06-24 00:00:00	1955-06-24	581452		0	0	0		0	0	0	71825	0	10	40213160		
123441	2712	40213260	2013-12-31	2013-12-31 00:00:00	2013-12-31	2013-12-31 00:00:00	2013-12-31	581452		0	0	0		0	0	0	179870	0	121	40213260		
56431	4682	19128022	1995-09-02	1995-09-02 00:00:00	1996-08-27	1996-08-27 00:00:00	1996-08-27	38000177		0	0	360		0	0	0	312036	0	749785	19128022		
36019	2965	19059056	1971-02-18	1971-02-18 00:00:00	1971-04-19	1971-04-19 00:00:00	1971-04-19	38000177		0	0	60		0	0	0	197983	0	243670	19059056		
13084	1098	19133873	1962-11-14	1962-11-14 00:00:00	1962-11-21	1962-11-21 00:00:00	1962-11-21	38000177		0	0	7		0	0	0	72066	0	834061	19133873		
46592	3859	1127433	1995-10-23	1995-10-23 00:00:00	1996-01-21	1996-01-21 00:00:00	1996-01-21	38000177		0	0	90		0	0	0	256267	0	313782	1127433		
136680	3000	40213160	1955-04-08	1955-04-08 00:00:00	1955-04-08	1955-04-08 00:00:00	1955-04-08	581452		0	0	0		0	0	0	200158	0	10	40213160		
100371	2199	40213160	1979-10-28	1979-10-28 00:00:00	1979-10-28	1979-10-28 00:00:00	1979-10-28	581452		0	0	0		0	0	0	146551	0	10	40213160		
13964	1169	19133768	2018-08-20	2018-08-20 00:00:00	2018-08-20	2018-08-20 00:00:00	2018-08-20	38000177		0	0	0		0	0	0	76991	0	833036	19133768		
1058	86	1539411	2013-04-30	2013-04-30 00:00:00	2013-04-30	2013-04-30 00:00:00	\N	38000177		0	0	0		0	0	0	5814	0	312961	1539411		
14023	1173	19059056	1959-05-17	1959-05-17 00:00:00	1959-05-31	1959-05-31 00:00:00	1959-05-31	38000177		0	0	14		0	0	0	77249	0	243670	19059056		
99931	2189	40213160	1980-07-13	1980-07-13 00:00:00	1980-07-13	1980-07-13 00:00:00	1980-07-13	581452		0	0	0		0	0	0	145948	0	10	40213160		
155298	3418	40213227	2015-02-08	2015-02-08 00:00:00	2015-02-08	2015-02-08 00:00:00	2015-02-08	581452		0	0	0		0	0	0	226786	0	113	40213227		
42025	3483	1713671	2001-03-04	2001-03-04 00:00:00	2001-03-11	2001-03-11 00:00:00	2001-03-11	38000177		0	0	7		0	0	0	231064	0	562251	1713671		
185071	4067	40213296	2011-04-02	2011-04-02 00:00:00	2011-04-02	2011-04-02 00:00:00	2011-04-02	581452		0	0	0		0	0	0	270217	0	52	40213296		
242919	5333	40213160	1955-06-19	1955-06-19 00:00:00	1955-06-19	1955-06-19 00:00:00	1955-06-19	581452		0	0	0		0	0	0	355097	0	10	40213160		
14481	1214	1127433	1954-02-17	1954-02-17 00:00:00	1954-03-03	1954-03-03 00:00:00	1954-03-03	38000177		0	0	14		0	0	0	79947	0	313782	1127433		
34786	2871	1127433	1959-07-29	1959-07-29 00:00:00	1959-08-12	1959-08-12 00:00:00	1959-08-12	38000177		0	0	14		0	0	0	191063	0	313782	1127433		
154602	3403	40213227	2011-04-11	2011-04-11 00:00:00	2011-04-11	2011-04-11 00:00:00	2011-04-11	581452		0	0	0		0	0	0	225758	0	113	40213227		
34855	2878	19073183	1982-05-16	1982-05-16 00:00:00	1982-05-30	1982-05-30 00:00:00	1982-05-30	38000177		0	0	14		0	0	0	191465	0	308182	19073183		
216389	4749	40213227	2004-01-03	2004-01-03 00:00:00	2004-01-03	2004-01-03 00:00:00	2004-01-03	581452		0	0	0		0	0	0	316277	0	113	40213227		
59079	1292	40213198	2016-07-05	2016-07-05 00:00:00	2016-07-05	2016-07-05 00:00:00	2016-07-05	581452		0	0	0		0	0	0	85429	0	133	40213198		
111190	2443	40213296	2003-10-10	2003-10-10 00:00:00	2003-10-10	2003-10-10 00:00:00	2003-10-10	581452		0	0	0		0	0	0	162088	0	52	40213296		
37384	3088	19133905	1960-09-08	1960-09-08 00:00:00	1960-09-15	1960-09-15 00:00:00	1960-09-15	38000177		0	0	7		0	0	0	205609	0	834102	19133905		
234054	5143	40213296	2000-12-20	2000-12-20 00:00:00	2000-12-20	2000-12-20 00:00:00	2000-12-20	581452		0	0	0		0	0	0	341798	0	52	40213296		
37497	3100	1127433	1964-09-10	1964-09-10 00:00:00	1964-09-24	1964-09-24 00:00:00	1964-09-24	38000177		0	0	14		0	0	0	206243	0	313782	1127433		
8863	189	40213160	1958-10-19	1958-10-19 00:00:00	1958-10-19	1958-10-19 00:00:00	1958-10-19	581452		0	0	0		0	0	0	12841	0	10	40213160		
8660	723	1127433	2017-08-12	2017-08-12 00:00:00	2017-08-26	2017-08-26 00:00:00	2017-08-26	38000177		0	0	14		0	0	0	47825	0	313782	1127433		
33300	2760	19059056	1959-11-13	1959-11-13 00:00:00	1959-11-27	1959-11-27 00:00:00	1959-11-27	38000177		0	0	14		0	0	0	182562	0	243670	19059056		
204655	4492	40213198	2012-05-22	2012-05-22 00:00:00	2012-05-22	2012-05-22 00:00:00	2012-05-22	581452		0	0	0		0	0	0	299128	0	133	40213198		
15899	1320	1127433	1946-05-31	1946-05-31 00:00:00	1946-06-07	1946-06-07 00:00:00	1946-06-07	38000177		0	0	7		0	0	0	87556	0	313782	1127433		
18798	1553	1127078	1967-12-05	1967-12-05 00:00:00	1967-12-19	1967-12-19 00:00:00	1967-12-19	38000177		0	0	14		0	0	0	103974	0	282464	1127078		
26449	2175	1127433	2019-02-03	2019-02-03 00:00:00	2019-02-17	2019-02-17 00:00:00	2019-02-17	38000177		0	0	14		0	0	0	145070	0	313782	1127433		
44286	3667	19133873	1977-09-15	1977-09-15 00:00:00	1977-09-27	1977-09-27 00:00:00	1977-09-27	38000177		0	0	12		0	0	0	243945	0	834061	19133873		
137667	3022	40213314	1977-04-01	1977-04-01 00:00:00	1977-04-01	1977-04-01 00:00:00	1977-04-01	581452		0	0	0		0	0	0	201488	0	49	40213314		
233553	5132	40213306	1989-03-20	1989-03-20 00:00:00	1989-03-20	1989-03-20 00:00:00	1989-03-20	581452		0	0	0		0	0	0	341156	0	43	40213306		
161312	3549	40213160	1957-11-12	1957-11-12 00:00:00	1957-11-12	1957-11-12 00:00:00	1957-11-12	581452		0	0	0		0	0	0	235670	0	10	40213160		
38783	3207	1713671	1965-10-03	1965-10-03 00:00:00	1965-10-17	1965-10-17 00:00:00	1965-10-17	38000177		0	0	14		0	0	0	213213	0	562251	1713671		
61138	5083	1127433	1992-08-20	1992-08-20 00:00:00	1992-09-24	1992-09-24 00:00:00	1992-09-24	38000177		0	0	35		0	0	0	337990	0	313782	1127433		
32239	2673	40236824	2014-03-12	2014-03-12 00:00:00	2014-03-19	2014-03-19 00:00:00	2014-03-19	38000177		0	0	7		0	0	0	177062	0	1094107	40236824		
83885	1834	40213227	1998-01-04	1998-01-04 00:00:00	1998-01-04	1998-01-04 00:00:00	1998-01-04	581452		0	0	0		0	0	0	122466	0	113	40213227		
30470	2526	1713671	2002-06-04	2002-06-04 00:00:00	2002-06-11	2002-06-11 00:00:00	2002-06-11	38000177		0	0	7		0	0	0	166993	0	562251	1713671		
16319	1353	19059056	1960-06-01	1960-06-01 00:00:00	1960-06-15	1960-06-15 00:00:00	1960-06-15	38000177		0	0	14		0	0	0	89672	0	243670	19059056		
10593	882	19006318	1945-04-22	1945-04-22 00:00:00	1945-05-06	1945-05-06 00:00:00	1945-05-06	38000177		0	0	14		0	0	0	58749	0	105078	19006318		
9728	814	1127078	1984-12-18	1984-12-18 00:00:00	1985-01-01	1985-01-01 00:00:00	1985-01-01	38000177		0	0	14		0	0	0	53997	0	282464	1127078		
55816	1223	40213227	2012-05-11	2012-05-11 00:00:00	2012-05-11	2012-05-11 00:00:00	2012-05-11	581452		0	0	0		0	0	0	80504	0	113	40213227		
977	79	19006318	1949-08-25	1949-08-25 00:00:00	1949-09-08	1949-09-08 00:00:00	1949-09-08	38000177		0	0	14		0	0	0	5287	0	105078	19006318		
113164	2486	40213314	1978-02-24	1978-02-24 00:00:00	1978-02-24	1978-02-24 00:00:00	1978-02-24	581452		0	0	0		0	0	0	164747	0	49	40213314		
113196	2486	40213296	2016-04-01	2016-04-01 00:00:00	2016-04-01	2016-04-01 00:00:00	2016-04-01	581452		0	0	0		0	0	0	164723	0	52	40213296		
16673	1382	19074843	1979-07-16	1979-07-16 00:00:00	1979-07-30	1979-07-30 00:00:00	1979-07-30	38000177		0	0	14		0	0	0	91646	0	309045	19074843		
30914	2559	1127433	1960-12-02	1960-12-02 00:00:00	1960-12-09	1960-12-09 00:00:00	1960-12-09	38000177		0	0	7		0	0	0	169523	0	313782	1127433		
181	12	1127433	1986-10-23	1986-10-23 00:00:00	1986-10-30	1986-10-30 00:00:00	1986-10-30	38000177		0	0	7		0	0	0	1019	0	313782	1127433		
129038	2837	40213260	2017-08-09	2017-08-09 00:00:00	2017-08-09	2017-08-09 00:00:00	2017-08-09	581452		0	0	0		0	0	0	188450	0	121	40213260		
25585	2103	19059056	1973-06-19	1973-06-19 00:00:00	1973-07-03	1973-07-03 00:00:00	1973-07-03	38000177		0	0	14		0	0	0	140154	0	243670	19059056		
136060	2987	40213227	2014-08-18	2014-08-18 00:00:00	2014-08-18	2014-08-18 00:00:00	2014-08-18	581452		0	0	0		0	0	0	199367	0	113	40213227		
207307	4548	40213227	2015-06-30	2015-06-30 00:00:00	2015-06-30	2015-06-30 00:00:00	2015-06-30	581452		0	0	0		0	0	0	303081	0	113	40213227		
36968	3057	40220960	2016-10-24	2016-10-24 00:00:00	2016-10-24	2016-10-24 00:00:00	2016-10-24	38000177		0	0	0		0	0	0	203431	0	1804799	40220960		
207429	4551	40213227	2008-06-25	2008-06-25 00:00:00	2008-06-25	2008-06-25 00:00:00	2008-06-25	581452		0	0	0		0	0	0	303322	0	113	40213227		
16179	349	40213160	1958-05-10	1958-05-10 00:00:00	1958-05-10	1958-05-10 00:00:00	1958-05-10	581452		0	0	0		0	0	0	23184	0	10	40213160		
131511	2890	40213260	2011-12-09	2011-12-09 00:00:00	2011-12-09	2011-12-09 00:00:00	2011-12-09	581452		0	0	0		0	0	0	192261	0	121	40213260		
231839	5095	40213160	1965-09-13	1965-09-13 00:00:00	1965-09-13	1965-09-13 00:00:00	1965-09-13	581452		0	0	0		0	0	0	338552	0	10	40213160		
38929	3217	19133873	1997-04-18	1997-04-18 00:00:00	1997-04-27	1997-04-27 00:00:00	1997-04-27	38000177		0	0	9		0	0	0	213765	0	834061	19133873		
112990	2482	40213296	2018-07-19	2018-07-19 00:00:00	2018-07-19	2018-07-19 00:00:00	2018-07-19	581452		0	0	0		0	0	0	164476	0	52	40213296		
208426	4571	40213160	1955-09-03	1955-09-03 00:00:00	1955-09-03	1955-09-03 00:00:00	1955-09-03	581452		0	0	0		0	0	0	304565	0	10	40213160		
49859	1092	40213160	1955-03-25	1955-03-25 00:00:00	1955-03-25	1955-03-25 00:00:00	1955-03-25	581452		0	0	0		0	0	0	71803	0	10	40213160		
123449	2712	40213227	1995-08-08	1995-08-08 00:00:00	1995-08-08	1995-08-08 00:00:00	1995-08-08	581452		0	0	0		0	0	0	179838	0	113	40213227		
56432	4682	19128022	1998-08-17	1998-08-17 00:00:00	1999-08-12	1999-08-12 00:00:00	1999-08-12	38000177		0	0	360		0	0	0	312039	0	749785	19128022		
36020	2965	1118084	2003-09-03	2003-09-03 00:00:00	2003-09-03	2003-09-03 00:00:00	\N	38000177		0	0	0		0	0	0	197932	0	00025152531	44923712		
13085	1099	1127433	1968-05-05	1968-05-05 00:00:00	1968-05-12	1968-05-12 00:00:00	1968-05-12	38000177		0	0	7		0	0	0	72108	0	313782	1127433		
46593	3859	1127433	1973-06-01	1973-06-01 00:00:00	1973-06-15	1973-06-15 00:00:00	1973-06-15	38000177		0	0	14		0	0	0	256243	0	313782	1127433		
136703	3001	40213227	1998-02-24	1998-02-24 00:00:00	1998-02-24	1998-02-24 00:00:00	1998-02-24	581452		0	0	0		0	0	0	200254	0	113	40213227		
100386	2199	40213227	2010-10-03	2010-10-03 00:00:00	2010-10-03	2010-10-03 00:00:00	2010-10-03	581452		0	0	0		0	0	0	146585	0	113	40213227		
13965	1169	1127433	1944-04-13	1944-04-13 00:00:00	1944-04-20	1944-04-20 00:00:00	1944-04-20	38000177		0	0	7		0	0	0	77029	0	313782	1127433		
1059	86	19126352	2013-04-30	2013-04-30 00:00:00	2013-04-30	2013-04-30 00:00:00	\N	38000177		0	0	0		0	0	0	5814	0	705129	19126352		
14024	1173	19006318	1959-05-17	1959-05-17 00:00:00	1959-05-31	1959-05-31 00:00:00	1959-05-31	38000177		0	0	14		0	0	0	77249	0	105078	19006318		
99934	2189	40213251	1985-01-13	1985-01-13 00:00:00	1985-01-13	1985-01-13 00:00:00	1985-01-13	581452		0	0	0		0	0	0	145951	0	21	40213251		
156444	3442	40213260	2010-06-13	2010-06-13 00:00:00	2010-06-13	2010-06-13 00:00:00	2010-06-13	581452		0	0	0		0	0	0	228426	0	121	40213260		
42026	3483	19059056	1953-11-20	1953-11-20 00:00:00	1953-12-04	1953-12-04 00:00:00	1953-12-04	38000177		0	0	14		0	0	0	231116	0	243670	19059056		
185077	4067	40213227	2012-08-25	2012-08-25 00:00:00	2012-08-25	2012-08-25 00:00:00	2012-08-25	581452		0	0	0		0	0	0	270218	0	113	40213227		
242930	5333	40213227	2000-08-06	2000-08-06 00:00:00	2000-08-06	2000-08-06 00:00:00	2000-08-06	581452		0	0	0		0	0	0	355115	0	113	40213227		
14482	1214	19078461	2012-05-14	2012-05-14 00:00:00	2012-06-04	2012-06-04 00:00:00	2012-06-04	38000177		0	0	21		0	0	0	79990	0	310965	19078461		
34787	2871	1713671	1956-02-07	1956-02-07 00:00:00	1956-02-14	1956-02-14 00:00:00	1956-02-14	38000177		0	0	7		0	0	0	191120	0	562251	1713671		
154603	3403	40213296	2011-04-11	2011-04-11 00:00:00	2011-04-11	2011-04-11 00:00:00	2011-04-11	581452		0	0	0		0	0	0	225758	0	52	40213296		
34856	2878	1127078	1982-05-16	1982-05-16 00:00:00	1982-05-30	1982-05-30 00:00:00	1982-05-30	38000177		0	0	14		0	0	0	191465	0	282464	1127078		
85008	1860	40213160	1959-02-02	1959-02-02 00:00:00	1959-02-02	1959-02-02 00:00:00	1959-02-02	581452		0	0	0		0	0	0	124385	0	10	40213160		
59081	1292	40213201	2017-07-11	2017-07-11 00:00:00	2017-07-11	2017-07-11 00:00:00	2017-07-11	581452		0	0	0		0	0	0	85410	0	33	40213201		
111203	2443	40213160	1962-09-07	1962-09-07 00:00:00	1962-09-07	1962-09-07 00:00:00	1962-09-07	581452		0	0	0		0	0	0	162063	0	10	40213160		
37385	3088	19059056	1978-10-21	1978-10-21 00:00:00	1978-11-18	1978-11-18 00:00:00	1978-11-18	38000177		0	0	28		0	0	0	205638	0	243670	19059056		
234056	5143	40213306	1981-07-01	1981-07-01 00:00:00	1981-07-01	1981-07-01 00:00:00	1981-07-01	581452		0	0	0		0	0	0	341876	0	43	40213306		
37498	3100	1713671	2009-10-19	2009-10-19 00:00:00	2009-11-09	2009-11-09 00:00:00	2009-11-09	38000177		0	0	21		0	0	0	206277	0	562251	1713671		
8873	190	40213227	2001-12-11	2001-12-11 00:00:00	2001-12-11	2001-12-11 00:00:00	2001-12-11	581452		0	0	0		0	0	0	12957	0	113	40213227		
8662	723	19059056	1961-10-06	1961-10-06 00:00:00	1961-10-20	1961-10-20 00:00:00	1961-10-20	38000177		0	0	14		0	0	0	47803	0	243670	19059056		
33301	2760	1118084	2001-05-31	2001-05-31 00:00:00	2001-05-31	2001-05-31 00:00:00	\N	38000177		0	0	0		0	0	0	182583	0	00025152531	44923712		
198626	4364	40213227	1993-01-10	1993-01-10 00:00:00	1993-01-10	1993-01-10 00:00:00	1993-01-10	581452		0	0	0		0	0	0	289472	0	113	40213227		
15900	1320	40162522	1998-09-12	1998-09-12 00:00:00	1998-09-12	1998-09-12 00:00:00	\N	38000177		0	0	0		0	0	0	87477	0	857005	40162522		
18799	1553	40229134	1969-03-30	1969-03-30 00:00:00	1969-04-06	1969-04-06 00:00:00	1969-04-06	38000177		0	0	7		0	0	0	103991	0	1043400	40229134		
26450	2175	1118084	2013-08-07	2013-08-07 00:00:00	2013-08-07	2013-08-07 00:00:00	\N	38000177		0	0	0		0	0	0	144972	0	00025152531	44923712		
44287	3667	1127078	1974-10-23	1974-10-23 00:00:00	1974-11-13	1974-11-13 00:00:00	1974-11-13	38000177		0	0	21		0	0	0	243976	0	282464	1127078		
137670	3022	40213160	1977-04-01	1977-04-01 00:00:00	1977-04-01	1977-04-01 00:00:00	1977-04-01	581452		0	0	0		0	0	0	201488	0	10	40213160		
233556	5132	40213296	2008-08-18	2008-08-18 00:00:00	2008-08-18	2008-08-18 00:00:00	2008-08-18	581452		0	0	0		0	0	0	341126	0	52	40213296		
161320	3549	40213160	1962-05-15	1962-05-15 00:00:00	1962-05-15	1962-05-15 00:00:00	1962-05-15	581452		0	0	0		0	0	0	235697	0	10	40213160		
38784	3207	1127433	1968-07-22	1968-07-22 00:00:00	1968-08-05	1968-08-05 00:00:00	1968-08-05	38000177		0	0	14		0	0	0	213191	0	313782	1127433		
61139	5083	19059056	1949-08-22	1949-08-22 00:00:00	1949-09-05	1949-09-05 00:00:00	1949-09-05	38000177		0	0	14		0	0	0	337989	0	243670	19059056		
32240	2673	920300	2014-03-12	2014-03-12 00:00:00	2014-03-19	2014-03-19 00:00:00	2014-03-19	38000177		0	0	7		0	0	0	177062	0	311989	920300		
40085	3315	1127433	1962-10-30	1962-10-30 00:00:00	1962-11-13	1962-11-13 00:00:00	1962-11-13	38000177		0	0	14		0	0	0	220167	0	313782	1127433		
30471	2526	46233988	1977-04-28	1977-04-28 00:00:00	1977-05-12	1977-05-12 00:00:00	1977-05-12	38000177		0	0	14		0	0	0	167032	0	1652673	46233988		
16320	1353	1127433	1968-08-09	1968-08-09 00:00:00	1968-11-07	1968-11-07 00:00:00	1968-11-07	38000177		0	0	90		0	0	0	89640	0	313782	1127433		
10594	882	19059056	1945-04-22	1945-04-22 00:00:00	1945-05-06	1945-05-06 00:00:00	1945-05-06	38000177		0	0	14		0	0	0	58749	0	243670	19059056		
9729	814	920300	2011-08-13	2011-08-13 00:00:00	2011-08-20	2011-08-20 00:00:00	2011-08-20	38000177		0	0	7		0	0	0	53992	0	311989	920300		
55828	1223	40213160	1956-02-17	1956-02-17 00:00:00	1956-02-17	1956-02-17 00:00:00	1956-02-17	581452		0	0	0		0	0	0	80485	0	10	40213160		
978	80	1115171	2018-03-14	2018-03-14 00:00:00	2018-04-11	2018-04-11 00:00:00	2018-04-11	38000177		0	0	28		0	0	0	5435	0	849574	1115171		
113170	2486	40213227	2005-07-08	2005-07-08 00:00:00	2005-07-08	2005-07-08 00:00:00	2005-07-08	581452		0	0	0		0	0	0	164720	0	113	40213227		
113198	2486	40213227	2016-04-01	2016-04-01 00:00:00	2016-04-01	2016-04-01 00:00:00	2016-04-01	581452		0	0	0		0	0	0	164723	0	113	40213227		
16674	1382	1127433	2003-08-04	2003-08-04 00:00:00	2003-08-11	2003-08-11 00:00:00	2003-08-11	38000177		0	0	7		0	0	0	91645	0	313782	1127433		
30915	2559	1127433	2014-01-11	2014-01-11 00:00:00	2014-02-01	2014-02-01 00:00:00	2014-02-01	38000177		0	0	21		0	0	0	169522	0	313782	1127433		
182	12	40236824	2002-03-06	2002-03-06 00:00:00	2002-03-13	2002-03-13 00:00:00	2002-03-13	38000177		0	0	7		0	0	0	1056	0	1094107	40236824		
129044	2837	40213160	1966-11-09	1966-11-09 00:00:00	1966-11-09	1966-11-09 00:00:00	1966-11-09	581452		0	0	0		0	0	0	188465	0	10	40213160		
25586	2103	19129655	1973-06-19	1973-06-19 00:00:00	1973-07-03	1973-07-03 00:00:00	1973-07-03	38000177		0	0	14		0	0	0	140154	0	789980	19129655		
136061	2987	40213296	2014-08-18	2014-08-18 00:00:00	2014-08-18	2014-08-18 00:00:00	2014-08-18	581452		0	0	0		0	0	0	199367	0	52	40213296		
207310	4548	40213160	1984-06-26	1984-06-26 00:00:00	1984-06-26	1984-06-26 00:00:00	1984-06-26	581452		0	0	0		0	0	0	303013	0	10	40213160		
36969	3057	19075601	2016-10-24	2016-10-24 00:00:00	2016-10-24	2016-10-24 00:00:00	2016-10-24	38000177		0	0	0		0	0	0	203431	0	309362	19075601		
207431	4551	40213314	1977-07-06	1977-07-06 00:00:00	1977-07-06	1977-07-06 00:00:00	1977-07-06	581452		0	0	0		0	0	0	303313	0	49	40213314		
132162	2903	40213160	1968-06-16	1968-06-16 00:00:00	1968-06-16	1968-06-16 00:00:00	1968-06-16	581452		0	0	0		0	0	0	193417	0	10	40213160		
131512	2890	40213306	1982-10-08	1982-10-08 00:00:00	1982-10-08	1982-10-08 00:00:00	1982-10-08	581452		0	0	0		0	0	0	192241	0	43	40213306		
231842	5095	40213260	2015-12-14	2015-12-14 00:00:00	2015-12-14	2015-12-14 00:00:00	2015-12-14	581452		0	0	0		0	0	0	338514	0	121	40213260		
38930	3217	40229134	2006-06-09	2006-06-09 00:00:00	2006-06-16	2006-06-16 00:00:00	2006-06-16	38000177		0	0	7		0	0	0	213781	0	1043400	40229134		
112991	2482	40213314	1977-06-16	1977-06-16 00:00:00	1977-06-16	1977-06-16 00:00:00	1977-06-16	581452		0	0	0		0	0	0	164471	0	49	40213314		
208440	4571	40213160	1955-03-05	1955-03-05 00:00:00	1955-03-05	1955-03-05 00:00:00	1955-03-05	581452		0	0	0		0	0	0	304597	0	10	40213160		
49862	1092	40213227	2016-04-29	2016-04-29 00:00:00	2016-04-29	2016-04-29 00:00:00	2016-04-29	581452		0	0	0		0	0	0	71789	0	113	40213227		
144478	3176	40213160	1976-11-13	1976-11-13 00:00:00	1976-11-13	1976-11-13 00:00:00	1976-11-13	581452		0	0	0		0	0	0	211192	0	10	40213160		
56433	4682	1713671	1984-01-28	1984-01-28 00:00:00	1984-02-18	1984-02-18 00:00:00	1984-02-18	38000177		0	0	21		0	0	0	312022	0	562251	1713671		
36021	2965	1127078	1970-06-23	1970-06-23 00:00:00	1970-07-07	1970-07-07 00:00:00	1970-07-07	38000177		0	0	14		0	0	0	197976	0	282464	1127078		
13086	1099	1127433	2005-09-06	2005-09-06 00:00:00	2005-09-20	2005-09-20 00:00:00	2005-09-20	38000177		0	0	14		0	0	0	72143	0	313782	1127433		
46594	3859	1124300	1957-11-26	1957-11-26 00:00:00	1957-11-26	1957-11-26 00:00:00	\N	38000177		0	0	0		0	0	0	256249	0	00781178901	45011828		
136713	3001	40213227	2008-02-26	2008-02-26 00:00:00	2008-02-26	2008-02-26 00:00:00	2008-02-26	581452		0	0	0		0	0	0	200312	0	113	40213227		
12331	266	40213160	1966-10-10	1966-10-10 00:00:00	1966-10-10	1966-10-10 00:00:00	1966-10-10	581452		0	0	0		0	0	0	17687	0	10	40213160		
13966	1169	1124300	1975-12-23	1975-12-23 00:00:00	1975-12-23	1975-12-23 00:00:00	\N	38000177		0	0	0		0	0	0	76961	0	00781178901	45011828		
1060	86	19075601	2013-04-30	2013-04-30 00:00:00	2013-04-30	2013-04-30 00:00:00	\N	38000177		0	0	0		0	0	0	5814	0	309362	19075601		
14025	1173	1124300	1986-01-19	1986-01-19 00:00:00	1986-01-19	1986-01-19 00:00:00	\N	38000177		0	0	0		0	0	0	77259	0	00781178901	45011828		
99936	2189	40213160	1985-01-13	1985-01-13 00:00:00	1985-01-13	1985-01-13 00:00:00	1985-01-13	581452		0	0	0		0	0	0	145951	0	10	40213160		
167752	3689	40213227	2001-02-04	2001-02-04 00:00:00	2001-02-04	2001-02-04 00:00:00	2001-02-04	581452		0	0	0		0	0	0	245171	0	113	40213227		
42027	3483	1124300	1988-12-31	1988-12-31 00:00:00	1988-12-31	1988-12-31 00:00:00	\N	38000177		0	0	0		0	0	0	231004	0	00781178901	45011828		
185078	4067	40213296	2012-08-25	2012-08-25 00:00:00	2012-08-25	2012-08-25 00:00:00	2012-08-25	581452		0	0	0		0	0	0	270218	0	52	40213296		
242952	5333	40213227	1993-09-05	1993-09-05 00:00:00	1993-09-05	1993-09-05 00:00:00	1993-09-05	581452		0	0	0		0	0	0	355123	0	113	40213227		
14483	1214	19133905	2018-04-05	2018-04-05 00:00:00	2018-04-15	2018-04-15 00:00:00	2018-04-15	38000177		0	0	10		0	0	0	79927	0	834102	19133905		
34788	2871	1713671	2007-11-27	2007-11-27 00:00:00	2007-12-04	2007-12-04 00:00:00	2007-12-04	38000177		0	0	7		0	0	0	191083	0	562251	1713671		
154606	3403	40213306	1991-06-03	1991-06-03 00:00:00	1991-06-03	1991-06-03 00:00:00	1991-06-03	581452		0	0	0		0	0	0	225759	0	43	40213306		
34857	2878	1713671	1997-01-06	1997-01-06 00:00:00	1997-01-13	1997-01-13 00:00:00	1997-01-13	38000177		0	0	7		0	0	0	191461	0	562251	1713671		
85015	1860	40213160	1959-07-06	1959-07-06 00:00:00	1959-07-06	1959-07-06 00:00:00	1959-07-06	581452		0	0	0		0	0	0	124386	0	10	40213160		
59087	1292	40213227	2012-06-12	2012-06-12 00:00:00	2012-06-12	2012-06-12 00:00:00	2012-06-12	581452		0	0	0		0	0	0	85407	0	113	40213227		
111208	2443	40213306	1984-01-26	1984-01-26 00:00:00	1984-01-26	1984-01-26 00:00:00	1984-01-26	581452		0	0	0		0	0	0	162099	0	43	40213306		
37386	3088	964261	1999-03-30	1999-03-30 00:00:00	1999-03-30	1999-03-30 00:00:00	\N	38000177		0	0	0		0	0	0	205619	0	2001499	964261		
234058	5143	40213160	1963-11-20	1963-11-20 00:00:00	1963-11-20	1963-11-20 00:00:00	1963-11-20	581452		0	0	0		0	0	0	341808	0	10	40213160		
37499	3100	1127078	1951-10-03	1951-10-03 00:00:00	1951-10-24	1951-10-24 00:00:00	1951-10-24	38000177		0	0	21		0	0	0	206240	0	282464	1127078		
55117	4576	1127433	1983-06-02	1983-06-02 00:00:00	1983-06-16	1983-06-16 00:00:00	1983-06-16	38000177		0	0	14		0	0	0	304771	0	313782	1127433		
8663	723	1127433	1990-09-02	1990-09-02 00:00:00	1990-09-23	1990-09-23 00:00:00	1990-09-23	38000177		0	0	21		0	0	0	47806	0	313782	1127433		
33302	2760	1713671	1963-07-04	1963-07-04 00:00:00	1963-07-18	1963-07-18 00:00:00	1963-07-18	38000177		0	0	14		0	0	0	182549	0	562251	1713671		
198639	4364	40213201	2017-07-30	2017-07-30 00:00:00	2017-07-30	2017-07-30 00:00:00	2017-07-30	581452		0	0	0		0	0	0	289479	0	33	40213201		
15901	1320	19078461	1998-09-12	1998-09-12 00:00:00	1998-11-11	1998-11-11 00:00:00	1998-11-11	38000177		0	0	60		0	0	0	87477	0	310965	19078461		
18800	1553	1124300	2011-05-18	2011-05-18 00:00:00	2011-05-18	2011-05-18 00:00:00	\N	38000177		0	0	0		0	0	0	103964	0	00781178901	45011828		
26452	2176	1127078	1962-04-20	1962-04-20 00:00:00	1962-05-04	1962-05-04 00:00:00	1962-05-04	38000177		0	0	14		0	0	0	145086	0	282464	1127078		
44288	3667	1115171	2010-01-22	2010-01-22 00:00:00	2010-02-12	2010-02-12 00:00:00	2010-02-12	38000177		0	0	21		0	0	0	243979	0	849574	1115171		
137671	3022	40213160	1972-08-11	1972-08-11 00:00:00	1972-08-11	1972-08-11 00:00:00	1972-08-11	581452		0	0	0		0	0	0	201494	0	10	40213160		
233558	5132	40213227	2008-08-18	2008-08-18 00:00:00	2008-08-18	2008-08-18 00:00:00	2008-08-18	581452		0	0	0		0	0	0	341126	0	113	40213227		
55175	1209	40213306	2000-06-29	2000-06-29 00:00:00	2000-06-29	2000-06-29 00:00:00	2000-06-29	581452		0	0	0		0	0	0	79452	0	43	40213306		
38785	3207	1124300	1995-08-19	1995-08-19 00:00:00	1995-08-19	1995-08-19 00:00:00	\N	38000177		0	0	0		0	0	0	213206	0	00781178901	45011828		
61140	5083	19059056	1948-09-12	1948-09-12 00:00:00	1948-09-26	1948-09-26 00:00:00	1948-09-26	38000177		0	0	14		0	0	0	337988	0	243670	19059056		
32241	2673	19078461	2009-03-21	2009-03-21 00:00:00	2009-05-20	2009-05-20 00:00:00	2009-05-20	38000177		0	0	60		0	0	0	177100	0	310965	19078461		
40086	3315	1127433	1977-07-16	1977-07-16 00:00:00	1977-08-06	1977-08-06 00:00:00	1977-08-06	38000177		0	0	21		0	0	0	220130	0	313782	1127433		
30472	2526	19059056	1977-04-28	1977-04-28 00:00:00	1977-05-12	1977-05-12 00:00:00	1977-05-12	38000177		0	0	14		0	0	0	167032	0	243670	19059056		
16321	1353	19059056	1969-11-02	1969-11-02 00:00:00	1969-11-30	1969-11-30 00:00:00	1969-11-30	38000177		0	0	28		0	0	0	89641	0	243670	19059056		
10595	882	1713671	1987-05-23	1987-05-23 00:00:00	1987-06-13	1987-06-13 00:00:00	1987-06-13	38000177		0	0	21		0	0	0	58728	0	562251	1713671		
9730	814	40236824	2011-08-13	2011-08-13 00:00:00	2011-08-20	2011-08-20 00:00:00	2011-08-20	38000177		0	0	7		0	0	0	53992	0	1094107	40236824		
55844	1223	40213198	2016-06-03	2016-06-03 00:00:00	2016-06-03	2016-06-03 00:00:00	2016-06-03	581452		0	0	0		0	0	0	80509	0	133	40213198		
979	80	19133873	1950-03-20	1950-03-20 00:00:00	1950-03-29	1950-03-29 00:00:00	1950-03-29	38000177		0	0	9		0	0	0	5462	0	834061	19133873		
113174	2486	40213296	2014-03-28	2014-03-28 00:00:00	2014-03-28	2014-03-28 00:00:00	2014-03-28	581452		0	0	0		0	0	0	164711	0	52	40213296		
113199	2486	40213314	1977-02-25	1977-02-25 00:00:00	1977-02-25	1977-02-25 00:00:00	1977-02-25	581452		0	0	0		0	0	0	164733	0	49	40213314		
16675	1382	40229134	2019-06-19	2019-06-19 00:00:00	2019-06-19	2019-06-19 00:00:00	\N	38000177		0	0	0		0	0	0	91624	0	1043400	40229134		
30916	2559	1713671	1987-11-04	1987-11-04 00:00:00	1987-11-18	1987-11-18 00:00:00	1987-11-18	38000177		0	0	14		0	0	0	169595	0	562251	1713671		
183	12	920300	2002-03-06	2002-03-06 00:00:00	2002-03-13	2002-03-13 00:00:00	2002-03-13	38000177		0	0	7		0	0	0	1056	0	311989	920300		
129047	2837	40213160	1967-04-12	1967-04-12 00:00:00	1967-04-12	1967-04-12 00:00:00	1967-04-12	581452		0	0	0		0	0	0	188466	0	10	40213160		
25587	2103	19019979	1975-11-08	1975-11-08 00:00:00	1975-11-22	1975-11-22 00:00:00	1975-11-22	38000177		0	0	14		0	0	0	140166	0	198405	19019979		
136069	2987	40213160	1973-03-05	1973-03-05 00:00:00	1973-03-05	1973-03-05 00:00:00	1973-03-05	581452		0	0	0		0	0	0	199414	0	10	40213160		
120748	2654	40213227	2005-09-15	2005-09-15 00:00:00	2005-09-15	2005-09-15 00:00:00	2005-09-15	581452		0	0	0		0	0	0	175672	0	113	40213227		
36970	3057	1118084	1973-06-14	1973-06-14 00:00:00	1973-06-14	1973-06-14 00:00:00	\N	38000177		0	0	0		0	0	0	203349	0	00025152531	44923712		
207432	4551	40213160	1977-07-06	1977-07-06 00:00:00	1977-07-06	1977-07-06 00:00:00	1977-07-06	581452		0	0	0		0	0	0	303313	0	10	40213160		
132167	2903	40213306	1986-03-23	1986-03-23 00:00:00	1986-03-23	1986-03-23 00:00:00	1986-03-23	581452		0	0	0		0	0	0	193452	0	43	40213306		
131515	2890	40213296	2002-08-02	2002-08-02 00:00:00	2002-08-02	2002-08-02 00:00:00	2002-08-02	581452		0	0	0		0	0	0	192244	0	52	40213296		
231849	5095	40213160	1965-04-12	1965-04-12 00:00:00	1965-04-12	1965-04-12 00:00:00	1965-04-12	581452		0	0	0		0	0	0	338551	0	10	40213160		
38931	3217	1127433	1995-12-24	1995-12-24 00:00:00	1995-12-31	1995-12-31 00:00:00	1995-12-31	38000177		0	0	7		0	0	0	213791	0	313782	1127433		
112996	2482	40213227	1996-09-12	1996-09-12 00:00:00	1996-09-12	1996-09-12 00:00:00	1996-09-12	581452		0	0	0		0	0	0	164465	0	113	40213227		
208441	4572	40213314	1977-10-18	1977-10-18 00:00:00	1977-10-18	1977-10-18 00:00:00	1977-10-18	581452		0	0	0		0	0	0	304643	0	49	40213314		
49875	1092	40213160	1955-01-21	1955-01-21 00:00:00	1955-01-21	1955-01-21 00:00:00	1955-01-21	581452		0	0	0		0	0	0	71824	0	10	40213160		
144480	3176	40213227	1994-11-26	1994-11-26 00:00:00	1994-11-26	1994-11-26 00:00:00	1994-11-26	581452		0	0	0		0	0	0	211171	0	113	40213227		
56434	4682	1127433	1993-04-10	1993-04-10 00:00:00	1993-04-24	1993-04-24 00:00:00	1993-04-24	38000177		0	0	14		0	0	0	312005	0	313782	1127433		
36022	2965	46233988	1970-06-23	1970-06-23 00:00:00	1970-07-07	1970-07-07 00:00:00	1970-07-07	38000177		0	0	14		0	0	0	197976	0	1652673	46233988		
13087	1099	19078461	1979-09-09	1979-09-09 00:00:00	1979-10-14	1979-10-14 00:00:00	1979-10-14	38000177		0	0	35		0	0	0	72158	0	310965	19078461		
46595	3859	1713671	1926-12-03	1926-12-03 00:00:00	1926-12-17	1926-12-17 00:00:00	1926-12-17	38000177		0	0	14		0	0	0	256241	0	562251	1713671		
136717	3001	40213227	2018-12-11	2018-12-11 00:00:00	2018-12-11	2018-12-11 00:00:00	2018-12-11	581452		0	0	0		0	0	0	200297	0	113	40213227		
29157	2414	1713671	1985-06-19	1985-06-19 00:00:00	1985-07-03	1985-07-03 00:00:00	1985-07-03	38000177		0	0	14		0	0	0	160278	0	562251	1713671		
13967	1169	40236824	1989-11-04	1989-11-04 00:00:00	1989-11-18	1989-11-18 00:00:00	1989-11-18	38000177		0	0	14		0	0	0	76962	0	1094107	40236824		
1061	86	19078461	2014-12-28	2014-12-28 00:00:00	2015-01-25	2015-01-25 00:00:00	2015-01-25	38000177		0	0	28		0	0	0	5767	0	310965	19078461		
14026	1173	19059056	1949-03-19	1949-03-19 00:00:00	1949-04-18	1949-04-18 00:00:00	1949-04-18	38000177		0	0	30		0	0	0	77274	0	243670	19059056		
99941	2189	40213227	2002-04-07	2002-04-07 00:00:00	2002-04-07	2002-04-07 00:00:00	2002-04-07	581452		0	0	0		0	0	0	145913	0	113	40213227		
167762	3689	40213227	1992-02-09	1992-02-09 00:00:00	1992-02-09	1992-02-09 00:00:00	1992-02-09	581452		0	0	0		0	0	0	245194	0	113	40213227		
42028	3483	19078461	2018-07-22	2018-07-22 00:00:00	2018-08-26	2018-08-26 00:00:00	2018-08-26	38000177		0	0	35		0	0	0	231120	0	310965	19078461		
185086	4067	40213160	1971-07-03	1971-07-03 00:00:00	1971-07-03	1971-07-03 00:00:00	1971-07-03	581452		0	0	0		0	0	0	270252	0	10	40213160		
5623	471	1115171	2017-09-10	2017-09-10 00:00:00	2017-10-01	2017-10-01 00:00:00	2017-10-01	38000177		0	0	21		0	0	0	31464	0	849574	1115171		
14484	1214	1713671	1955-03-14	1955-03-14 00:00:00	1955-03-21	1955-03-21 00:00:00	1955-03-21	38000177		0	0	7		0	0	0	79996	0	562251	1713671		
34789	2871	1124300	1996-07-12	1996-07-12 00:00:00	1996-07-12	1996-07-12 00:00:00	\N	38000177		0	0	0		0	0	0	191103	0	00781178901	45011828		
154611	3403	40213160	1969-09-08	1969-09-08 00:00:00	1969-09-08	1969-09-08 00:00:00	1969-09-08	581452		0	0	0		0	0	0	225735	0	10	40213160		
34858	2878	19128022	1995-08-16	1995-08-16 00:00:00	1996-08-10	1996-08-10 00:00:00	1996-08-10	38000177		0	0	360		0	0	0	191466	0	749785	19128022		
85018	1860	40213160	1959-04-06	1959-04-06 00:00:00	1959-04-06	1959-04-06 00:00:00	1959-04-06	581452		0	0	0		0	0	0	124380	0	10	40213160		
59089	1292	40213227	2001-08-21	2001-08-21 00:00:00	2001-08-21	2001-08-21 00:00:00	2001-08-21	581452		0	0	0		0	0	0	85393	0	113	40213227		
111217	2443	40213160	1966-11-03	1966-11-03 00:00:00	1966-11-03	1966-11-03 00:00:00	1966-11-03	581452		0	0	0		0	0	0	162048	0	10	40213160		
37387	3088	1127433	1963-06-07	1963-06-07 00:00:00	1963-06-21	1963-06-21 00:00:00	1963-06-21	38000177		0	0	14		0	0	0	205636	0	313782	1127433		
234069	5143	40213296	1998-12-16	1998-12-16 00:00:00	1998-12-16	1998-12-16 00:00:00	1998-12-16	581452		0	0	0		0	0	0	341877	0	52	40213296		
37500	3100	1127078	1952-03-31	1952-03-31 00:00:00	1952-04-14	1952-04-14 00:00:00	1952-04-14	38000177		0	0	14		0	0	0	206219	0	282464	1127078		
55118	4576	1127078	1962-02-15	1962-02-15 00:00:00	1962-04-16	1962-04-16 00:00:00	1962-04-16	38000177		0	0	60		0	0	0	304850	0	282464	1127078		
8664	723	1127078	1966-12-23	1966-12-23 00:00:00	1967-03-23	1967-03-23 00:00:00	1967-03-23	38000177		0	0	90		0	0	0	47804	0	282464	1127078		
33303	2760	19059056	1971-10-09	1971-10-09 00:00:00	1971-11-06	1971-11-06 00:00:00	1971-11-06	38000177		0	0	28		0	0	0	182588	0	243670	19059056		
198643	4364	40213227	2002-01-06	2002-01-06 00:00:00	2002-01-06	2002-01-06 00:00:00	2002-01-06	581452		0	0	0		0	0	0	289473	0	113	40213227		
15902	1320	1713671	2018-03-29	2018-03-29 00:00:00	2018-04-05	2018-04-05 00:00:00	2018-04-05	38000177		0	0	7		0	0	0	87486	0	562251	1713671		
176191	3874	40213251	1984-05-30	1984-05-30 00:00:00	1984-05-30	1984-05-30 00:00:00	1984-05-30	581452		0	0	0		0	0	0	257297	0	21	40213251		
26453	2176	19133905	1975-02-19	1975-02-19 00:00:00	1975-03-01	1975-03-01 00:00:00	1975-03-01	38000177		0	0	10		0	0	0	145158	0	834102	19133905		
44289	3667	19059056	1972-05-15	1972-05-15 00:00:00	1972-05-29	1972-05-29 00:00:00	1972-05-29	38000177		0	0	14		0	0	0	243938	0	243670	19059056		
137680	3022	40213227	2014-02-28	2014-02-28 00:00:00	2014-02-28	2014-02-28 00:00:00	2014-02-28	581452		0	0	0		0	0	0	201505	0	113	40213227		
8537	711	35605858	1967-01-29	1967-01-29 00:00:00	1967-01-29	1967-01-29 00:00:00	1967-01-29	38000177		0	0	0		0	0	0	47196	0	1732136	35605858		
55177	1209	40213227	2000-06-29	2000-06-29 00:00:00	2000-06-29	2000-06-29 00:00:00	2000-06-29	581452		0	0	0		0	0	0	79452	0	113	40213227		
38786	3207	46275916	1994-12-01	1994-12-01 00:00:00	1994-12-01	1994-12-01 00:00:00	1994-12-01	38000177		0	0	0		0	0	0	213206	0	1660014	46275916		
61141	5083	1713671	1975-06-15	1975-06-15 00:00:00	1975-09-07	1975-09-07 00:00:00	1975-09-07	38000177		0	0	84		0	0	0	338013	0	562251	1713671		
32242	2673	40162522	2009-03-21	2009-03-21 00:00:00	2009-03-21	2009-03-21 00:00:00	\N	38000177		0	0	0		0	0	0	177100	0	857005	40162522		
40118	3320	1127433	2015-06-30	2015-06-30 00:00:00	2015-07-07	2015-07-07 00:00:00	2015-07-07	38000177		0	0	7		0	0	0	220447	0	313782	1127433		
30473	2526	1115171	2012-04-19	2012-04-19 00:00:00	2012-05-03	2012-05-03 00:00:00	2012-05-03	38000177		0	0	14		0	0	0	167007	0	849574	1115171		
16322	1353	40229134	1985-06-12	1985-06-12 00:00:00	1985-06-19	1985-06-19 00:00:00	1985-06-19	38000177		0	0	7		0	0	0	89661	0	1043400	40229134		
10596	882	1115171	2015-05-18	2015-05-18 00:00:00	2015-07-24	2015-07-24 00:00:00	2015-07-24	38000177		0	0	67		0	0	0	58724	0	849574	1115171		
9731	814	19128065	1997-06-23	1997-06-23 00:00:00	1998-06-18	1998-06-18 00:00:00	1998-06-18	38000177		0	0	360		0	0	0	53981	0	749882	19128065		
55846	1223	40213160	1955-02-11	1955-02-11 00:00:00	1955-02-11	1955-02-11 00:00:00	1955-02-11	581452		0	0	0		0	0	0	80479	0	10	40213160		
980	80	1127433	2008-06-03	2008-06-03 00:00:00	2008-06-17	2008-06-17 00:00:00	2008-06-17	38000177		0	0	14		0	0	0	5413	0	313782	1127433		
113177	2486	40213306	1997-01-03	1997-01-03 00:00:00	1997-01-03	1997-01-03 00:00:00	1997-01-03	581452		0	0	0		0	0	0	164729	0	43	40213306		
113217	2487	40213260	2006-01-15	2006-01-15 00:00:00	2006-01-15	2006-01-15 00:00:00	2006-01-15	581452		0	0	0		0	0	0	164830	0	121	40213260		
16676	1382	1127433	2002-08-02	2002-08-02 00:00:00	2002-08-09	2002-08-09 00:00:00	2002-08-09	38000177		0	0	7		0	0	0	91664	0	313782	1127433		
30917	2559	19059056	1961-07-18	1961-07-18 00:00:00	1961-08-01	1961-08-01 00:00:00	1961-08-01	38000177		0	0	14		0	0	0	169653	0	243670	19059056		
184	12	1115171	1997-02-26	1997-02-26 00:00:00	1997-03-19	1997-03-19 00:00:00	1997-03-19	38000177		0	0	21		0	0	0	1014	0	849574	1115171		
129054	2837	40213160	1971-07-14	1971-07-14 00:00:00	1971-07-14	1971-07-14 00:00:00	1971-07-14	581452		0	0	0		0	0	0	188483	0	10	40213160		
25588	2103	1127433	1978-02-13	1978-02-13 00:00:00	1978-02-20	1978-02-20 00:00:00	1978-02-20	38000177		0	0	7		0	0	0	140135	0	313782	1127433		
137146	3010	40213160	1964-04-22	1964-04-22 00:00:00	1964-04-22	1964-04-22 00:00:00	1964-04-22	581452		0	0	0		0	0	0	200735	0	10	40213160		
120774	2654	40213227	1995-07-20	1995-07-20 00:00:00	1995-07-20	1995-07-20 00:00:00	1995-07-20	581452		0	0	0		0	0	0	175743	0	113	40213227		
36978	3059	1127433	2013-05-15	2013-05-15 00:00:00	2013-05-29	2013-05-29 00:00:00	2013-05-29	38000177		0	0	14		0	0	0	203514	0	313782	1127433		
207437	4551	40213227	2019-02-06	2019-02-06 00:00:00	2019-02-06	2019-02-06 00:00:00	2019-02-06	581452		0	0	0		0	0	0	303320	0	113	40213227		
132185	2904	40213160	1970-08-26	1970-08-26 00:00:00	1970-08-26	1970-08-26 00:00:00	1970-08-26	581452		0	0	0		0	0	0	193487	0	10	40213160		
131516	2890	40213260	2012-12-14	2012-12-14 00:00:00	2012-12-14	2012-12-14 00:00:00	2012-12-14	581452		0	0	0		0	0	0	192246	0	121	40213260		
231850	5095	40213227	2007-07-30	2007-07-30 00:00:00	2007-07-30	2007-07-30 00:00:00	2007-07-30	581452		0	0	0		0	0	0	338512	0	113	40213227		
38932	3217	1124300	2018-10-14	2018-10-14 00:00:00	2018-10-14	2018-10-14 00:00:00	\N	38000177		0	0	0		0	0	0	213800	0	00781178901	45011828		
112997	2482	40213306	1996-09-12	1996-09-12 00:00:00	1996-09-12	1996-09-12 00:00:00	1996-09-12	581452		0	0	0		0	0	0	164465	0	43	40213306		
208444	4572	40213160	1976-06-22	1976-06-22 00:00:00	1976-06-22	1976-06-22 00:00:00	1976-06-22	581452		0	0	0		0	0	0	304648	0	10	40213160		
49880	1092	40213260	2007-11-02	2007-11-02 00:00:00	2007-11-02	2007-11-02 00:00:00	2007-11-02	581452		0	0	0		0	0	0	71787	0	121	40213260		
144481	3176	40213306	1994-11-26	1994-11-26 00:00:00	1994-11-26	1994-11-26 00:00:00	1994-11-26	581452		0	0	0		0	0	0	211171	0	43	40213306		
56435	4682	1118084	2011-11-02	2011-11-02 00:00:00	2011-11-02	2011-11-02 00:00:00	\N	38000177		0	0	0		0	0	0	311991	0	00025152531	44923712		
46481	3851	1127433	1918-12-22	1918-12-22 00:00:00	1918-12-29	1918-12-29 00:00:00	1918-12-29	38000177		0	0	7		0	0	0	255573	0	313782	1127433		
13088	1099	19078461	2018-10-24	2018-10-24 00:00:00	2018-11-07	2018-11-07 00:00:00	2018-11-07	38000177		0	0	14		0	0	0	72161	0	310965	19078461		
46596	3859	1127433	1971-09-24	1971-09-24 00:00:00	1971-10-08	1971-10-08 00:00:00	1971-10-08	38000177		0	0	14		0	0	0	256208	0	313782	1127433		
208666	4577	40213314	1983-12-17	1983-12-17 00:00:00	1983-12-17	1983-12-17 00:00:00	1983-12-17	581452		0	0	0		0	0	0	304910	0	49	40213314		
29158	2414	19059056	1970-09-12	1970-09-12 00:00:00	1970-10-17	1970-10-17 00:00:00	1970-10-17	38000177		0	0	35		0	0	0	160250	0	243670	19059056		
13968	1169	920300	1989-11-04	1989-11-04 00:00:00	1989-11-11	1989-11-11 00:00:00	1989-11-11	38000177		0	0	7		0	0	0	76962	0	311989	920300		
1062	86	19059056	1961-03-15	1961-03-15 00:00:00	1961-04-05	1961-04-05 00:00:00	1961-04-05	38000177		0	0	21		0	0	0	5791	0	243670	19059056		
14027	1174	1713671	1976-11-03	1976-11-03 00:00:00	1976-12-01	1976-12-01 00:00:00	1976-12-01	38000177		0	0	28		0	0	0	77305	0	562251	1713671		
99942	2189	40213306	2002-04-07	2002-04-07 00:00:00	2002-04-07	2002-04-07 00:00:00	2002-04-07	581452		0	0	0		0	0	0	145913	0	43	40213306		
167765	3689	40213227	2011-04-04	2011-04-04 00:00:00	2011-04-04	2011-04-04 00:00:00	2011-04-04	581452		0	0	0		0	0	0	245243	0	113	40213227		
42029	3483	40229134	2006-06-25	2006-06-25 00:00:00	2006-07-09	2006-07-09 00:00:00	2006-07-09	38000177		0	0	14		0	0	0	231089	0	1043400	40229134		
209299	4590	40213296	1998-01-05	1998-01-05 00:00:00	1998-01-05	1998-01-05 00:00:00	1998-01-05	581452		0	0	0		0	0	0	305829	0	52	40213296		
5624	471	1118084	2016-12-16	2016-12-16 00:00:00	2016-12-16	2016-12-16 00:00:00	\N	38000177		0	0	0		0	0	0	31478	0	00025152531	44923712		
14485	1214	1127433	1969-10-01	1969-10-01 00:00:00	1969-10-22	1969-10-22 00:00:00	1969-10-22	38000177		0	0	21		0	0	0	80006	0	313782	1127433		
34790	2871	1713671	1963-12-26	1963-12-26 00:00:00	1964-01-02	1964-01-02 00:00:00	1964-01-02	38000177		0	0	7		0	0	0	191165	0	562251	1713671		
154612	3403	40213160	1969-12-08	1969-12-08 00:00:00	1969-12-08	1969-12-08 00:00:00	1969-12-08	581452		0	0	0		0	0	0	225748	0	10	40213160		
34859	2878	19133873	1986-10-16	1986-10-16 00:00:00	1986-10-29	1986-10-29 00:00:00	1986-10-29	38000177		0	0	13		0	0	0	191459	0	834061	19133873		
85020	1860	40213227	1992-08-10	1992-08-10 00:00:00	1992-08-10	1992-08-10 00:00:00	1992-08-10	581452		0	0	0		0	0	0	\N	0	113	40213227		
24560	534	40213227	2001-01-01	2001-01-01 00:00:00	2001-01-01	2001-01-01 00:00:00	2001-01-01	581452		0	0	0		0	0	0	35540	0	113	40213227		
111219	2443	40213227	2013-11-07	2013-11-07 00:00:00	2013-11-07	2013-11-07 00:00:00	2013-11-07	581452		0	0	0		0	0	0	162090	0	113	40213227		
37390	3090	40229134	1978-04-11	1978-04-11 00:00:00	1978-04-25	1978-04-25 00:00:00	1978-04-25	38000177		0	0	14		0	0	0	205728	0	1043400	40229134		
181837	3995	40213160	1971-05-22	1971-05-22 00:00:00	1971-05-22	1971-05-22 00:00:00	1971-05-22	581452		0	0	0		0	0	0	265618	0	10	40213160		
37501	3100	19006318	1952-03-31	1952-03-31 00:00:00	1952-04-14	1952-04-14 00:00:00	1952-04-14	38000177		0	0	14		0	0	0	206219	0	105078	19006318		
55119	4576	1127433	1956-03-30	1956-03-30 00:00:00	1956-04-13	1956-04-13 00:00:00	1956-04-13	38000177		0	0	14		0	0	0	304784	0	313782	1127433		
8665	723	1127433	1969-07-28	1969-07-28 00:00:00	1969-08-04	1969-08-04 00:00:00	1969-08-04	38000177		0	0	7		0	0	0	47823	0	313782	1127433		
33304	2760	1713671	1985-09-04	1985-09-04 00:00:00	1985-09-11	1985-09-11 00:00:00	1985-09-11	38000177		0	0	7		0	0	0	182536	0	562251	1713671		
198647	4364	40213227	2012-07-01	2012-07-01 00:00:00	2012-07-01	2012-07-01 00:00:00	2012-07-01	581452		0	0	0		0	0	0	289483	0	113	40213227		
15903	1320	19059056	1939-10-09	1939-10-09 00:00:00	1939-10-23	1939-10-23 00:00:00	1939-10-23	38000177		0	0	14		0	0	0	87494	0	243670	19059056		
176192	3874	40213251	1986-06-18	1986-06-18 00:00:00	1986-06-18	1986-06-18 00:00:00	1986-06-18	581452		0	0	0		0	0	0	257293	0	21	40213251		
26454	2176	1127433	2007-01-26	2007-01-26 00:00:00	2007-02-09	2007-02-09 00:00:00	2007-02-09	38000177		0	0	14		0	0	0	145139	0	313782	1127433		
44290	3667	46233988	1972-05-15	1972-05-15 00:00:00	1972-05-29	1972-05-29 00:00:00	1972-05-29	38000177		0	0	14		0	0	0	243938	0	1652673	46233988		
137681	3022	40213296	2014-02-28	2014-02-28 00:00:00	2014-02-28	2014-02-28 00:00:00	2014-02-28	581452		0	0	0		0	0	0	201505	0	52	40213296		
8538	711	19016749	1967-01-29	1967-01-29 00:00:00	1967-01-29	1967-01-29 00:00:00	1967-01-29	38000177		0	0	0		0	0	0	47196	0	73032	19016749		
55187	1209	40213314	1978-11-16	1978-11-16 00:00:00	1978-11-16	1978-11-16 00:00:00	1978-11-16	581452		0	0	0		0	0	0	79428	0	49	40213314		
38787	3207	1310034	1994-12-01	1994-12-01 00:00:00	1994-12-01	1994-12-01 00:00:00	1994-12-01	38000177		0	0	0		0	0	0	213206	0	834357	1310034		
61144	5085	1118084	2013-11-14	2013-11-14 00:00:00	2013-11-14	2013-11-14 00:00:00	\N	38000177		0	0	0		0	0	0	338115	0	00025152531	44923712		
32243	2673	1150771	1982-02-27	1982-02-27 00:00:00	1982-02-27	1982-02-27 00:00:00	\N	38000177		0	0	0		0	0	0	177113	0	197378	1150771		
40119	3320	19133873	1974-10-28	1974-10-28 00:00:00	1974-11-04	1974-11-04 00:00:00	1974-11-04	38000177		0	0	7		0	0	0	220458	0	834061	19133873		
30484	2528	1127433	1991-10-16	1991-10-16 00:00:00	1991-10-30	1991-10-30 00:00:00	1991-10-30	38000177		0	0	14		0	0	0	167141	0	313782	1127433		
16323	1353	19059056	1964-09-08	1964-09-08 00:00:00	1964-09-29	1964-09-29 00:00:00	1964-09-29	38000177		0	0	21		0	0	0	89639	0	243670	19059056		
10597	883	19059056	1970-01-29	1970-01-29 00:00:00	1970-02-28	1970-02-28 00:00:00	1970-02-28	38000177		0	0	30		0	0	0	58778	0	243670	19059056		
9744	817	1127433	1971-11-01	1971-11-01 00:00:00	1971-11-08	1971-11-08 00:00:00	1971-11-08	38000177		0	0	7		0	0	0	54091	0	313782	1127433		
126811	2790	40213260	2006-03-02	2006-03-02 00:00:00	2006-03-02	2006-03-02 00:00:00	2006-03-02	581452		0	0	0		0	0	0	184933	0	121	40213260		
981	80	19133905	1986-08-29	1986-08-29 00:00:00	1986-09-09	1986-09-09 00:00:00	1986-09-09	38000177		0	0	11		0	0	0	5382	0	834102	19133905		
113179	2486	40213227	1997-01-03	1997-01-03 00:00:00	1997-01-03	1997-01-03 00:00:00	1997-01-03	581452		0	0	0		0	0	0	164729	0	113	40213227		
113223	2487	40213201	2019-02-24	2019-02-24 00:00:00	2019-02-24	2019-02-24 00:00:00	2019-02-24	581452		0	0	0		0	0	0	164775	0	33	40213201		
16677	1382	1124300	2014-07-07	2014-07-07 00:00:00	2014-07-07	2014-07-07 00:00:00	\N	38000177		0	0	0		0	0	0	91614	0	00781178901	45011828		
30918	2559	19006318	1958-07-15	1958-07-15 00:00:00	1958-07-29	1958-07-29 00:00:00	1958-07-29	38000177		0	0	14		0	0	0	169615	0	105078	19006318		
186	12	19059056	1970-08-27	1970-08-27 00:00:00	1970-09-10	1970-09-10 00:00:00	1970-09-10	38000177		0	0	14		0	0	0	1006	0	243670	19059056		
140341	3081	40213198	2011-04-20	2011-04-20 00:00:00	2011-04-20	2011-04-20 00:00:00	2011-04-20	581452		0	0	0		0	0	0	205094	0	133	40213198		
25589	2103	1127433	1982-03-03	1982-03-03 00:00:00	1982-03-17	1982-03-17 00:00:00	1982-03-17	38000177		0	0	14		0	0	0	140161	0	313782	1127433		
137155	3010	40213160	1964-06-24	1964-06-24 00:00:00	1964-06-24	1964-06-24 00:00:00	1964-06-24	581452		0	0	0		0	0	0	200776	0	10	40213160		
120778	2654	40213227	2015-03-19	2015-03-19 00:00:00	2015-03-19	2015-03-19 00:00:00	2015-03-19	581452		0	0	0		0	0	0	175750	0	113	40213227		
36979	3059	1713671	2005-08-12	2005-08-12 00:00:00	2005-08-19	2005-08-19 00:00:00	2005-08-19	38000177		0	0	7		0	0	0	203482	0	562251	1713671		
207438	4551	40213296	2019-02-06	2019-02-06 00:00:00	2019-02-06	2019-02-06 00:00:00	2019-02-06	581452		0	0	0		0	0	0	303320	0	52	40213296		
132188	2904	40213160	1970-10-28	1970-10-28 00:00:00	1970-10-28	1970-10-28 00:00:00	1970-10-28	581452		0	0	0		0	0	0	193506	0	10	40213160		
131518	2890	40213227	2012-12-14	2012-12-14 00:00:00	2012-12-14	2012-12-14 00:00:00	2012-12-14	581452		0	0	0		0	0	0	192246	0	113	40213227		
231851	5095	40213296	2007-07-30	2007-07-30 00:00:00	2007-07-30	2007-07-30 00:00:00	2007-07-30	581452		0	0	0		0	0	0	338512	0	52	40213296		
38933	3217	1127433	1999-07-28	1999-07-28 00:00:00	1999-08-11	1999-08-11 00:00:00	1999-08-11	38000177		0	0	14		0	0	0	213803	0	313782	1127433		
113000	2482	40213160	1979-06-21	1979-06-21 00:00:00	1979-06-21	1979-06-21 00:00:00	1979-06-21	581452		0	0	0		0	0	0	164438	0	10	40213160		
208448	4572	40213314	1977-01-18	1977-01-18 00:00:00	1977-01-18	1977-01-18 00:00:00	1977-01-18	581452		0	0	0		0	0	0	304642	0	49	40213314		
49882	1092	40213227	1996-10-25	1996-10-25 00:00:00	1996-10-25	1996-10-25 00:00:00	1996-10-25	581452		0	0	0		0	0	0	71770	0	113	40213227		
144482	3176	40213160	1972-03-11	1972-03-11 00:00:00	1972-03-11	1972-03-11 00:00:00	1972-03-11	581452		0	0	0		0	0	0	211224	0	10	40213160		
56436	4682	1115171	2009-12-19	2009-12-19 00:00:00	2010-01-02	2010-01-02 00:00:00	2010-01-02	38000177		0	0	14		0	0	0	312045	0	849574	1115171		
46482	3851	19059056	1924-07-08	1924-07-08 00:00:00	1924-07-22	1924-07-22 00:00:00	1924-07-22	38000177		0	0	14		0	0	0	255499	0	243670	19059056		
13089	1099	1118084	1990-07-27	1990-07-27 00:00:00	1990-07-27	1990-07-27 00:00:00	\N	38000177		0	0	0		0	0	0	72245	0	00025152531	44923712		
46597	3859	1127433	1931-03-10	1931-03-10 00:00:00	1931-03-24	1931-03-24 00:00:00	1931-03-24	38000177		0	0	14		0	0	0	256242	0	313782	1127433		
208667	4577	40213160	1983-12-17	1983-12-17 00:00:00	1983-12-17	1983-12-17 00:00:00	1983-12-17	581452		0	0	0		0	0	0	304910	0	10	40213160		
29159	2414	1545959	2000-04-27	2000-04-27 00:00:00	2000-04-27	2000-04-27 00:00:00	2000-04-27	38000177		0	0	0		0	0	0	160253	0	259255	1545959		
23707	1950	920300	1966-10-23	1966-10-23 00:00:00	1966-10-30	1966-10-30 00:00:00	1966-10-30	38000177		0	0	7		0	0	0	129624	0	311989	920300		
1063	86	19133873	1953-05-03	1953-05-03 00:00:00	1953-05-15	1953-05-15 00:00:00	1953-05-15	38000177		0	0	12		0	0	0	5769	0	834061	19133873		
14028	1174	1127433	1951-09-15	1951-09-15 00:00:00	1951-09-22	1951-09-22 00:00:00	1951-09-22	38000177		0	0	7		0	0	0	77327	0	313782	1127433		
99945	2189	40213227	2013-04-28	2013-04-28 00:00:00	2013-04-28	2013-04-28 00:00:00	2013-04-28	581452		0	0	0		0	0	0	145917	0	113	40213227		
231496	5086	40213160	1970-03-05	1970-03-05 00:00:00	1970-03-05	1970-03-05 00:00:00	1970-03-05	581452		0	0	0		0	0	0	338187	0	10	40213160		
42030	3483	19059056	1955-10-11	1955-10-11 00:00:00	1955-10-25	1955-10-25 00:00:00	1955-10-25	38000177		0	0	14		0	0	0	231114	0	243670	19059056		
209301	4590	40213227	1998-01-05	1998-01-05 00:00:00	1998-01-05	1998-01-05 00:00:00	1998-01-05	581452		0	0	0		0	0	0	305829	0	113	40213227		
5625	471	40229134	1997-10-28	1997-10-28 00:00:00	1997-11-11	1997-11-11 00:00:00	1997-11-11	38000177		0	0	14		0	0	0	31481	0	1043400	40229134		
14486	1214	19059056	1945-10-27	1945-10-27 00:00:00	1945-11-17	1945-11-17 00:00:00	1945-11-17	38000177		0	0	21		0	0	0	80002	0	243670	19059056		
34791	2871	19059056	1960-11-18	1960-11-18 00:00:00	1961-01-17	1961-01-17 00:00:00	1961-01-17	38000177		0	0	60		0	0	0	191093	0	243670	19059056		
154621	3403	40213260	2019-04-01	2019-04-01 00:00:00	2019-04-01	2019-04-01 00:00:00	2019-04-01	581452		0	0	0		0	0	0	225767	0	121	40213260		
34860	2878	19059056	1993-07-08	1993-07-08 00:00:00	1993-08-05	1993-08-05 00:00:00	1993-08-05	38000177		0	0	28		0	0	0	191450	0	243670	19059056		
85023	1860	40213306	1980-12-29	1980-12-29 00:00:00	1980-12-29	1980-12-29 00:00:00	1980-12-29	581452		0	0	0		0	0	0	124400	0	43	40213306		
24561	534	40213306	2001-01-01	2001-01-01 00:00:00	2001-01-01	2001-01-01 00:00:00	2001-01-01	581452		0	0	0		0	0	0	35540	0	43	40213306		
111220	2443	40213260	2013-11-07	2013-11-07 00:00:00	2013-11-07	2013-11-07 00:00:00	2013-11-07	581452		0	0	0		0	0	0	162090	0	121	40213260		
37391	3090	19133905	2002-07-31	2002-07-31 00:00:00	2002-08-07	2002-08-07 00:00:00	2002-08-07	38000177		0	0	7		0	0	0	205756	0	834102	19133905		
181840	3995	40213160	1971-07-24	1971-07-24 00:00:00	1971-07-24	1971-07-24 00:00:00	1971-07-24	581452		0	0	0		0	0	0	265602	0	10	40213160		
37502	3100	1713671	1987-03-07	1987-03-07 00:00:00	1987-03-14	1987-03-14 00:00:00	1987-03-14	38000177		0	0	7		0	0	0	206244	0	562251	1713671		
55120	4576	19128065	1983-08-06	1983-08-06 00:00:00	1984-07-31	1984-07-31 00:00:00	1984-07-31	38000177		0	0	360		0	0	0	304803	0	749882	19128065		
8667	723	40236824	1997-12-03	1997-12-03 00:00:00	1997-12-10	1997-12-10 00:00:00	1997-12-10	38000177		0	0	7		0	0	0	47834	0	1094107	40236824		
33305	2760	19133873	1971-10-30	1971-10-30 00:00:00	1971-11-07	1971-11-07 00:00:00	1971-11-07	38000177		0	0	8		0	0	0	182533	0	834061	19133873		
198653	4365	40213160	1955-06-27	1955-06-27 00:00:00	1955-06-27	1955-06-27 00:00:00	1955-06-27	581452		0	0	0		0	0	0	289544	0	10	40213160		
15904	1320	19059056	1939-02-26	1939-02-26 00:00:00	1939-03-12	1939-03-12 00:00:00	1939-03-12	38000177		0	0	14		0	0	0	87493	0	243670	19059056		
176194	3874	40213160	1986-06-18	1986-06-18 00:00:00	1986-06-18	1986-06-18 00:00:00	1986-06-18	581452		0	0	0		0	0	0	257293	0	10	40213160		
26455	2176	19006318	1960-08-13	1960-08-13 00:00:00	1960-08-27	1960-08-27 00:00:00	1960-08-27	38000177		0	0	14		0	0	0	145163	0	105078	19006318		
44291	3667	1127433	2007-10-05	2007-10-05 00:00:00	2007-10-19	2007-10-19 00:00:00	2007-10-19	38000177		0	0	14		0	0	0	243956	0	313782	1127433		
137683	3022	40213160	1973-01-12	1973-01-12 00:00:00	1973-01-12	1973-01-12 00:00:00	1973-01-12	581452		0	0	0		0	0	0	201495	0	10	40213160		
8539	711	40220386	1967-01-29	1967-01-29 00:00:00	1967-01-29	1967-01-29 00:00:00	1967-01-29	38000177		0	0	0		0	0	0	47196	0	1808217	40220386		
55194	1209	40213160	1982-08-19	1982-08-19 00:00:00	1982-08-19	1982-08-19 00:00:00	1982-08-19	581452		0	0	0		0	0	0	79412	0	10	40213160		
38788	3207	40243436	1994-12-01	1994-12-01 00:00:00	1994-12-01	1994-12-01 00:00:00	1994-12-01	38000177		0	0	0		0	0	0	213206	0	1190795	40243436		
61145	5085	19078461	2003-05-21	2003-05-21 00:00:00	2003-06-11	2003-06-11 00:00:00	2003-06-11	38000177		0	0	21		0	0	0	338098	0	310965	19078461		
32244	2674	1115171	1996-08-09	1996-08-09 00:00:00	1996-08-23	1996-08-23 00:00:00	1996-08-23	38000177		0	0	14		0	0	0	177218	0	849574	1115171		
40120	3320	1127433	1967-03-09	1967-03-09 00:00:00	1967-03-23	1967-03-23 00:00:00	1967-03-23	38000177		0	0	14		0	0	0	220436	0	313782	1127433		
39929	870	40213160	1964-11-17	1964-11-17 00:00:00	1964-11-17	1964-11-17 00:00:00	1964-11-17	581452		0	0	0		0	0	0	57820	0	10	40213160		
16324	1354	1713671	1984-07-04	1984-07-04 00:00:00	1984-07-11	1984-07-11 00:00:00	1984-07-11	38000177		0	0	7		0	0	0	89725	0	562251	1713671		
10598	883	19059056	1965-11-21	1965-11-21 00:00:00	1965-12-05	1965-12-05 00:00:00	1965-12-05	38000177		0	0	14		0	0	0	58816	0	243670	19059056		
17163	1425	19133873	1945-11-04	1945-11-04 00:00:00	1945-11-16	1945-11-16 00:00:00	1945-11-16	38000177		0	0	12		0	0	0	94783	0	834061	19133873		
126816	2790	40213160	1957-07-04	1957-07-04 00:00:00	1957-07-04	1957-07-04 00:00:00	1957-07-04	581452		0	0	0		0	0	0	184905	0	10	40213160		
982	80	1713671	1950-03-24	1950-03-24 00:00:00	1950-04-07	1950-04-07 00:00:00	1950-04-07	38000177		0	0	14		0	0	0	5438	0	562251	1713671		
113185	2486	40213160	1974-08-30	1974-08-30 00:00:00	1974-08-30	1974-08-30 00:00:00	1974-08-30	581452		0	0	0		0	0	0	164756	0	10	40213160		
113232	2487	40213227	1994-03-13	1994-03-13 00:00:00	1994-03-13	1994-03-13 00:00:00	1994-03-13	581452		0	0	0		0	0	0	164798	0	113	40213227		
16678	1382	19133873	1992-12-05	1992-12-05 00:00:00	1992-12-15	1992-12-15 00:00:00	1992-12-15	38000177		0	0	10		0	0	0	91644	0	834061	19133873		
30919	2559	19059056	1958-07-15	1958-07-15 00:00:00	1958-07-29	1958-07-29 00:00:00	1958-07-29	38000177		0	0	14		0	0	0	169615	0	243670	19059056		
187	12	1713671	1996-03-24	1996-03-24 00:00:00	1996-04-14	1996-04-14 00:00:00	1996-04-14	38000177		0	0	21		0	0	0	1003	0	562251	1713671		
140344	3081	40213201	2012-04-25	2012-04-25 00:00:00	2012-04-25	2012-04-25 00:00:00	2012-04-25	581452		0	0	0		0	0	0	205177	0	33	40213201		
25590	2103	1127078	1972-07-12	1972-07-12 00:00:00	1972-07-26	1972-07-26 00:00:00	1972-07-26	38000177		0	0	14		0	0	0	140139	0	282464	1127078		
137158	3010	40213160	1964-09-23	1964-09-23 00:00:00	1964-09-23	1964-09-23 00:00:00	1964-09-23	581452		0	0	0		0	0	0	200736	0	10	40213160		
237885	5222	40213227	1999-01-14	1999-01-14 00:00:00	1999-01-14	1999-01-14 00:00:00	1999-01-14	581452		0	0	0		0	0	0	347528	0	113	40213227		
36980	3059	40231925	2008-09-17	2008-09-17 00:00:00	2008-09-17	2008-09-17 00:00:00	\N	38000177		0	0	0		0	0	0	203512	0	1049221	40231925		
5324	115	40213260	2011-08-07	2011-08-07 00:00:00	2011-08-07	2011-08-07 00:00:00	2011-08-07	581452		0	0	0		0	0	0	7620	0	121	40213260		
132193	2904	40213296	2010-05-26	2010-05-26 00:00:00	2010-05-26	2010-05-26 00:00:00	2010-05-26	581452		0	0	0		0	0	0	193510	0	52	40213296		
131525	2890	40213306	1982-07-02	1982-07-02 00:00:00	1982-07-02	1982-07-02 00:00:00	1982-07-02	581452		0	0	0		0	0	0	192259	0	43	40213306		
231853	5095	40213227	2016-05-09	2016-05-09 00:00:00	2016-05-09	2016-05-09 00:00:00	2016-05-09	581452		0	0	0		0	0	0	338559	0	113	40213227		
38934	3217	19133873	1993-07-27	1993-07-27 00:00:00	1993-08-03	1993-08-03 00:00:00	1993-08-03	38000177		0	0	7		0	0	0	213790	0	834061	19133873		
113004	2482	40213227	2016-07-14	2016-07-14 00:00:00	2016-07-14	2016-07-14 00:00:00	2016-07-14	581452		0	0	0		0	0	0	164458	0	113	40213227		
208450	4572	40213227	2007-04-10	2007-04-10 00:00:00	2007-04-10	2007-04-10 00:00:00	2007-04-10	581452		0	0	0		0	0	0	304633	0	113	40213227		
49883	1092	40213296	1996-10-25	1996-10-25 00:00:00	1996-10-25	1996-10-25 00:00:00	1996-10-25	581452		0	0	0		0	0	0	71770	0	52	40213296		
144490	3176	40213227	2003-12-06	2003-12-06 00:00:00	2003-12-06	2003-12-06 00:00:00	2003-12-06	581452		0	0	0		0	0	0	211118	0	113	40213227		
56437	4682	19128065	1996-08-27	1996-08-27 00:00:00	1997-08-22	1997-08-22 00:00:00	1997-08-22	38000177		0	0	360		0	0	0	312037	0	749882	19128065		
46483	3851	19059056	1963-09-02	1963-09-02 00:00:00	1963-10-07	1963-10-07 00:00:00	1963-10-07	38000177		0	0	35		0	0	0	255593	0	243670	19059056		
13090	1099	19133905	1979-03-23	1979-03-23 00:00:00	1979-04-02	1979-04-02 00:00:00	1979-04-02	38000177		0	0	10		0	0	0	72242	0	834102	19133905		
46598	3859	1713671	1954-02-05	1954-02-05 00:00:00	1954-02-19	1954-02-19 00:00:00	1954-02-19	38000177		0	0	14		0	0	0	256158	0	562251	1713671		
208669	4577	40213306	2005-09-10	2005-09-10 00:00:00	2005-09-10	2005-09-10 00:00:00	2005-09-10	581452		0	0	0		0	0	0	304899	0	43	40213306		
29160	2414	19133768	2000-04-27	2000-04-27 00:00:00	2000-04-27	2000-04-27 00:00:00	2000-04-27	38000177		0	0	0		0	0	0	160253	0	833036	19133768		
23708	1950	40236824	1966-10-23	1966-10-23 00:00:00	1966-10-30	1966-10-30 00:00:00	1966-10-30	38000177		0	0	7		0	0	0	129624	0	1094107	40236824		
1064	86	1127433	1957-02-23	1957-02-23 00:00:00	1957-03-02	1957-03-02 00:00:00	1957-03-02	38000177		0	0	7		0	0	0	5804	0	313782	1127433		
14029	1174	19059056	1943-07-27	1943-07-27 00:00:00	1943-08-10	1943-08-10 00:00:00	1943-08-10	38000177		0	0	14		0	0	0	77366	0	243670	19059056		
99951	2189	40213314	1980-05-11	1980-05-11 00:00:00	1980-05-11	1980-05-11 00:00:00	1980-05-11	581452		0	0	0		0	0	0	145936	0	49	40213314		
231500	5086	40213306	1991-11-28	1991-11-28 00:00:00	1991-11-28	1991-11-28 00:00:00	1991-11-28	581452		0	0	0		0	0	0	338172	0	43	40213306		
63877	5306	1115171	2013-01-22	2013-01-22 00:00:00	2013-02-19	2013-02-19 00:00:00	2013-02-19	38000177		0	0	28		0	0	0	352985	0	849574	1115171		
209311	4590	40213160	1956-04-23	1956-04-23 00:00:00	1956-04-23	1956-04-23 00:00:00	1956-04-23	581452		0	0	0		0	0	0	305852	0	10	40213160		
5626	471	1127078	1992-03-27	1992-03-27 00:00:00	1992-04-24	1992-04-24 00:00:00	1992-04-24	38000177		0	0	28		0	0	0	31463	0	282464	1127078		
14489	1214	1127433	1979-04-03	1979-04-03 00:00:00	1979-04-24	1979-04-24 00:00:00	1979-04-24	38000177		0	0	21		0	0	0	80007	0	313782	1127433		
34792	2871	19059056	1967-07-15	1967-07-15 00:00:00	1967-08-05	1967-08-05 00:00:00	1967-08-05	38000177		0	0	21		0	0	0	191094	0	243670	19059056		
154625	3403	40213227	2000-06-12	2000-06-12 00:00:00	2000-06-12	2000-06-12 00:00:00	2000-06-12	581452		0	0	0		0	0	0	225762	0	113	40213227		
45319	3750	1127433	1974-02-25	1974-02-25 00:00:00	1974-03-11	1974-03-11 00:00:00	1974-03-11	38000177		0	0	14		0	0	0	249259	0	313782	1127433		
91914	2017	40213160	1974-03-05	1974-03-05 00:00:00	1974-03-05	1974-03-05 00:00:00	1974-03-05	581452		0	0	0		0	0	0	134199	0	10	40213160		
24563	534	40213314	1978-09-26	1978-09-26 00:00:00	1978-09-26	1978-09-26 00:00:00	1978-09-26	581452		0	0	0		0	0	0	35534	0	49	40213314		
111224	2443	40213160	1962-06-08	1962-06-08 00:00:00	1962-06-08	1962-06-08 00:00:00	1962-06-08	581452		0	0	0		0	0	0	162045	0	10	40213160		
37392	3090	1127433	2006-02-07	2006-02-07 00:00:00	2006-02-21	2006-02-21 00:00:00	2006-02-21	38000177		0	0	14		0	0	0	205750	0	313782	1127433		
181847	3995	40213227	2012-05-19	2012-05-19 00:00:00	2012-05-19	2012-05-19 00:00:00	2012-05-19	581452		0	0	0		0	0	0	265634	0	113	40213227		
163699	3601	40213227	2011-06-24	2011-06-24 00:00:00	2011-06-24	2011-06-24 00:00:00	2011-06-24	581452		0	0	0		0	0	0	239131	0	113	40213227		
55121	4576	40229134	1988-05-03	1988-05-03 00:00:00	1988-05-17	1988-05-17 00:00:00	1988-05-17	38000177		0	0	14		0	0	0	304787	0	1043400	40229134		
8668	723	920300	1997-12-03	1997-12-03 00:00:00	1997-12-10	1997-12-10 00:00:00	1997-12-10	38000177		0	0	7		0	0	0	47834	0	311989	920300		
33306	2760	1713671	1978-01-30	1978-01-30 00:00:00	1978-02-20	1978-02-20 00:00:00	1978-02-20	38000177		0	0	21		0	0	0	182556	0	562251	1713671		
215688	4731	40213227	2013-11-12	2013-11-12 00:00:00	2013-11-12	2013-11-12 00:00:00	2013-11-12	581452		0	0	0		0	0	0	315189	0	113	40213227		
15905	1320	1127433	1993-08-09	1993-08-09 00:00:00	1993-10-08	1993-10-08 00:00:00	1993-10-08	38000177		0	0	60		0	0	0	87476	0	313782	1127433		
176197	3874	40213160	1982-03-31	1982-03-31 00:00:00	1982-03-31	1982-03-31 00:00:00	1982-03-31	581452		0	0	0		0	0	0	257246	0	10	40213160		
26456	2176	19059056	1960-08-13	1960-08-13 00:00:00	1960-08-27	1960-08-27 00:00:00	1960-08-27	38000177		0	0	14		0	0	0	145163	0	243670	19059056		
44292	3667	40229134	2012-12-04	2012-12-04 00:00:00	2012-12-18	2012-12-18 00:00:00	2012-12-18	38000177		0	0	14		0	0	0	243949	0	1043400	40229134		
137693	3022	40213227	2006-02-17	2006-02-17 00:00:00	2006-02-17	2006-02-17 00:00:00	2006-02-17	581452		0	0	0		0	0	0	201473	0	113	40213227		
8540	711	35605482	1967-01-29	1967-01-29 00:00:00	1967-01-29	1967-01-29 00:00:00	1967-01-29	38000177		0	0	0		0	0	0	47196	0	1740467	35605482		
55195	1209	40213251	1984-08-30	1984-08-30 00:00:00	1984-08-30	1984-08-30 00:00:00	1984-08-30	581452		0	0	0		0	0	0	79413	0	21	40213251		
38789	3207	19133873	1971-02-09	1971-02-09 00:00:00	1971-02-22	1971-02-22 00:00:00	1971-02-22	38000177		0	0	13		0	0	0	213147	0	834061	19133873		
61146	5085	19133873	1977-04-11	1977-04-11 00:00:00	1977-04-18	1977-04-18 00:00:00	1977-04-18	38000177		0	0	7		0	0	0	338118	0	834061	19133873		
32245	2674	1127433	1987-01-01	1987-01-01 00:00:00	1987-01-15	1987-01-15 00:00:00	1987-01-15	38000177		0	0	14		0	0	0	177183	0	313782	1127433		
40121	3320	19133873	1977-04-23	1977-04-23 00:00:00	1977-05-04	1977-05-04 00:00:00	1977-05-04	38000177		0	0	11		0	0	0	220485	0	834061	19133873		
39931	870	40213296	1999-12-14	1999-12-14 00:00:00	1999-12-14	1999-12-14 00:00:00	1999-12-14	581452		0	0	0		0	0	0	57826	0	52	40213296		
16325	1354	19059056	1980-01-27	1980-01-27 00:00:00	1980-02-17	1980-02-17 00:00:00	1980-02-17	38000177		0	0	21		0	0	0	89760	0	243670	19059056		
10599	883	19006318	1965-11-21	1965-11-21 00:00:00	1965-12-05	1965-12-05 00:00:00	1965-12-05	38000177		0	0	14		0	0	0	58816	0	105078	19006318		
17164	1425	1713671	1995-12-09	1995-12-09 00:00:00	1995-12-30	1995-12-30 00:00:00	1995-12-30	38000177		0	0	21		0	0	0	94769	0	562251	1713671		
126820	2790	40213198	2018-05-10	2018-05-10 00:00:00	2018-05-10	2018-05-10 00:00:00	2018-05-10	581452		0	0	0		0	0	0	184861	0	133	40213198		
983	80	1713671	1959-05-23	1959-05-23 00:00:00	1959-05-30	1959-05-30 00:00:00	1959-05-30	38000177		0	0	7		0	0	0	5464	0	562251	1713671		
113191	2486	40213160	1978-10-06	1978-10-06 00:00:00	1978-10-06	1978-10-06 00:00:00	1978-10-06	581452		0	0	0		0	0	0	164734	0	10	40213160		
113239	2487	40213198	2018-02-18	2018-02-18 00:00:00	2018-02-18	2018-02-18 00:00:00	2018-02-18	581452		0	0	0		0	0	0	164801	0	133	40213198		
16679	1382	1127078	1982-04-20	1982-04-20 00:00:00	1982-05-04	1982-05-04 00:00:00	1982-05-04	38000177		0	0	14		0	0	0	91647	0	282464	1127078		
30921	2561	19133905	2018-03-06	2018-03-06 00:00:00	2018-03-15	2018-03-15 00:00:00	2018-03-15	38000177		0	0	9		0	0	0	169674	0	834102	19133905		
203	16	1713671	1986-09-29	1986-09-29 00:00:00	1986-10-20	1986-10-20 00:00:00	1986-10-20	38000177		0	0	21		0	0	0	1230	0	562251	1713671		
240480	5279	40213227	2007-04-01	2007-04-01 00:00:00	2007-04-01	2007-04-01 00:00:00	2007-04-01	581452		0	0	0		0	0	0	351159	0	113	40213227		
25591	2103	46233988	1972-07-12	1972-07-12 00:00:00	1972-07-26	1972-07-26 00:00:00	1972-07-26	38000177		0	0	14		0	0	0	140139	0	1652673	46233988		
137160	3010	40213260	2014-02-19	2014-02-19 00:00:00	2014-02-19	2014-02-19 00:00:00	2014-02-19	581452		0	0	0		0	0	0	200747	0	121	40213260		
5235	114	40213227	2014-01-27	2014-01-27 00:00:00	2014-01-27	2014-01-27 00:00:00	2014-01-27	581452		0	0	0		0	0	0	7562	0	113	40213227		
36981	3059	19078461	2008-09-17	2008-09-17 00:00:00	2008-10-17	2008-10-17 00:00:00	2008-10-17	38000177		0	0	30		0	0	0	203512	0	310965	19078461		
5326	115	40213227	2011-08-07	2011-08-07 00:00:00	2011-08-07	2011-08-07 00:00:00	2011-08-07	581452		0	0	0		0	0	0	7620	0	113	40213227		
132198	2904	40213227	1992-07-22	1992-07-22 00:00:00	1992-07-22	1992-07-22 00:00:00	1992-07-22	581452		0	0	0		0	0	0	193531	0	113	40213227		
9081	756	19059056	1972-12-25	1972-12-25 00:00:00	1973-01-24	1973-01-24 00:00:00	1973-01-24	38000177		0	0	30		0	0	0	50171	0	243670	19059056		
199016	4372	40213306	2001-02-15	2001-02-15 00:00:00	2001-02-15	2001-02-15 00:00:00	2001-02-15	581452		0	0	0		0	0	0	290279	0	43	40213306		
38935	3217	1127433	1993-08-13	1993-08-13 00:00:00	1993-08-27	1993-08-27 00:00:00	1993-08-27	38000177		0	0	14		0	0	0	213802	0	313782	1127433		
113005	2482	40213296	2016-07-14	2016-07-14 00:00:00	2016-07-14	2016-07-14 00:00:00	2016-07-14	581452		0	0	0		0	0	0	164458	0	52	40213296		
208453	4572	40213296	2016-06-28	2016-06-28 00:00:00	2016-06-28	2016-06-28 00:00:00	2016-06-28	581452		0	0	0		0	0	0	304634	0	52	40213296		
49889	1092	40213260	2006-10-27	2006-10-27 00:00:00	2006-10-27	2006-10-27 00:00:00	2006-10-27	581452		0	0	0		0	0	0	71795	0	121	40213260		
144507	3177	40213201	1983-11-30	1983-11-30 00:00:00	1983-11-30	1983-11-30 00:00:00	1983-11-30	581452		0	0	0		0	0	0	211259	0	33	40213201		
56438	4682	1127433	2001-05-10	2001-05-10 00:00:00	2001-05-24	2001-05-24 00:00:00	2001-05-24	38000177		0	0	14		0	0	0	312024	0	313782	1127433		
46484	3851	920334	1931-06-17	1931-06-17 00:00:00	1931-06-24	1931-06-24 00:00:00	1931-06-24	38000177		0	0	7		0	0	0	255575	0	311995	920334		
13091	1099	19059056	1983-08-24	1983-08-24 00:00:00	1983-09-14	1983-09-14 00:00:00	1983-09-14	38000177		0	0	21		0	0	0	72159	0	243670	19059056		
46599	3859	1127433	1949-08-25	1949-08-25 00:00:00	1949-09-08	1949-09-08 00:00:00	1949-09-08	38000177		0	0	14		0	0	0	256205	0	313782	1127433		
208671	4577	40213227	2005-09-10	2005-09-10 00:00:00	2005-09-10	2005-09-10 00:00:00	2005-09-10	581452		0	0	0		0	0	0	304899	0	113	40213227		
29161	2414	1127433	1982-03-07	1982-03-07 00:00:00	1982-03-14	1982-03-14 00:00:00	1982-03-14	38000177		0	0	7		0	0	0	160224	0	313782	1127433		
23709	1950	1713671	1973-06-18	1973-06-18 00:00:00	1973-07-09	1973-07-09 00:00:00	1973-07-09	38000177		0	0	21		0	0	0	129698	0	562251	1713671		
1065	86	1124300	1988-09-02	1988-09-02 00:00:00	1988-09-02	1988-09-02 00:00:00	\N	38000177		0	0	0		0	0	0	5841	0	00781178901	45011828		
14030	1174	19059056	1944-04-17	1944-04-17 00:00:00	1944-05-01	1944-05-01 00:00:00	1944-05-01	38000177		0	0	14		0	0	0	77349	0	243670	19059056		
99952	2189	40213160	1980-05-11	1980-05-11 00:00:00	1980-05-11	1980-05-11 00:00:00	1980-05-11	581452		0	0	0		0	0	0	145936	0	10	40213160		
86732	1902	40213227	2005-01-30	2005-01-30 00:00:00	2005-01-30	2005-01-30 00:00:00	2005-01-30	581452		0	0	0		0	0	0	126573	0	113	40213227		
63878	5306	19073188	2013-01-22	2013-01-22 00:00:00	2013-02-19	2013-02-19 00:00:00	2013-02-19	38000177		0	0	28		0	0	0	352985	0	308192	19073188		
209314	4590	40213160	1960-10-24	1960-10-24 00:00:00	1960-10-24	1960-10-24 00:00:00	1960-10-24	581452		0	0	0		0	0	0	305854	0	10	40213160		
5627	471	40243436	1990-04-06	1990-04-06 00:00:00	1990-04-06	1990-04-06 00:00:00	1990-04-06	38000177		0	0	0		0	0	0	31462	0	1190795	40243436		
14490	1214	1127433	1993-05-19	1993-05-19 00:00:00	1993-06-02	1993-06-02 00:00:00	1993-06-02	38000177		0	0	14		0	0	0	79906	0	313782	1127433		
34793	2872	1332419	1994-03-22	1994-03-22 00:00:00	1994-03-22	1994-03-22 00:00:00	\N	38000177		0	0	0		0	0	0	191213	0	197361	1332419		
134708	2957	40213198	2013-03-02	2013-03-02 00:00:00	2013-03-02	2013-03-02 00:00:00	2013-03-02	581452		0	0	0		0	0	0	197304	0	133	40213198		
45320	3750	46233710	1974-02-25	1974-02-25 00:00:00	1974-03-11	1974-03-11 00:00:00	1974-03-11	38000177		0	0	14		0	0	0	249259	0	1650142	46233710		
91928	2017	40213160	1970-04-07	1970-04-07 00:00:00	1970-04-07	1970-04-07 00:00:00	1970-04-07	581452		0	0	0		0	0	0	134170	0	10	40213160		
24564	534	40213160	1978-09-26	1978-09-26 00:00:00	1978-09-26	1978-09-26 00:00:00	1978-09-26	581452		0	0	0		0	0	0	35534	0	10	40213160		
63130	1381	40213227	2000-08-05	2000-08-05 00:00:00	2000-08-05	2000-08-05 00:00:00	2000-08-05	581452		0	0	0		0	0	0	91571	0	113	40213227		
37393	3090	1124300	2001-02-02	2001-02-02 00:00:00	2001-02-02	2001-02-02 00:00:00	\N	38000177		0	0	0		0	0	0	205742	0	00781178901	45011828		
181848	3995	40213296	2012-05-19	2012-05-19 00:00:00	2012-05-19	2012-05-19 00:00:00	2012-05-19	581452		0	0	0		0	0	0	265634	0	52	40213296		
163700	3601	40213260	2011-06-24	2011-06-24 00:00:00	2011-06-24	2011-06-24 00:00:00	2011-06-24	581452		0	0	0		0	0	0	239131	0	121	40213260		
55122	4577	1713671	1987-12-21	1987-12-21 00:00:00	1988-01-04	1988-01-04 00:00:00	1988-01-04	38000177		0	0	14		0	0	0	304886	0	562251	1713671		
8669	723	1127433	1984-10-19	1984-10-19 00:00:00	1984-11-02	1984-11-02 00:00:00	1984-11-02	38000177		0	0	14		0	0	0	47805	0	313782	1127433		
665	49	19059056	1980-02-26	1980-02-26 00:00:00	1980-05-26	1980-05-26 00:00:00	1980-05-26	38000177		0	0	90		0	0	0	3525	0	243670	19059056		
215689	4731	40213296	2013-11-12	2013-11-12 00:00:00	2013-11-12	2013-11-12 00:00:00	2013-11-12	581452		0	0	0		0	0	0	315189	0	52	40213296		
15906	1320	40229134	1992-01-20	1992-01-20 00:00:00	1992-01-27	1992-01-27 00:00:00	1992-01-27	38000177		0	0	7		0	0	0	87516	0	1043400	40229134		
176198	3874	40213314	1982-03-31	1982-03-31 00:00:00	1982-03-31	1982-03-31 00:00:00	1982-03-31	581452		0	0	0		0	0	0	257246	0	49	40213314		
26457	2176	19059056	1957-07-16	1957-07-16 00:00:00	1957-08-06	1957-08-06 00:00:00	1957-08-06	38000177		0	0	21		0	0	0	145096	0	243670	19059056		
44293	3667	1127433	1978-03-16	1978-03-16 00:00:00	1978-03-30	1978-03-30 00:00:00	1978-03-30	38000177		0	0	14		0	0	0	243965	0	313782	1127433		
137696	3022	40213160	1972-10-13	1972-10-13 00:00:00	1972-10-13	1972-10-13 00:00:00	1972-10-13	581452		0	0	0		0	0	0	201484	0	10	40213160		
8541	711	35605482	1967-01-29	1967-01-29 00:00:00	1967-01-29	1967-01-29 00:00:00	1967-01-29	38000177		0	0	0		0	0	0	47196	0	1740467	35605482		
55197	1209	40213314	1977-12-15	1977-12-15 00:00:00	1977-12-15	1977-12-15 00:00:00	1977-12-15	581452		0	0	0		0	0	0	79438	0	49	40213314		
38790	3207	19078461	1982-11-05	1982-11-05 00:00:00	1982-12-10	1982-12-10 00:00:00	1982-12-10	38000177		0	0	35		0	0	0	213204	0	310965	19078461		
61147	5085	19019979	1976-12-08	1976-12-08 00:00:00	1976-12-22	1976-12-22 00:00:00	1976-12-22	38000177		0	0	14		0	0	0	338116	0	198405	19019979		
32246	2674	1713671	2003-06-28	2003-06-28 00:00:00	2003-07-26	2003-07-26 00:00:00	2003-07-26	38000177		0	0	28		0	0	0	177206	0	562251	1713671		
40122	3320	1127433	1970-02-13	1970-02-13 00:00:00	1970-02-20	1970-02-20 00:00:00	1970-02-20	38000177		0	0	7		0	0	0	220443	0	313782	1127433		
39934	870	40213160	1960-03-15	1960-03-15 00:00:00	1960-03-15	1960-03-15 00:00:00	1960-03-15	581452		0	0	0		0	0	0	57856	0	10	40213160		
16326	1354	40229134	2013-12-06	2013-12-06 00:00:00	2013-12-13	2013-12-13 00:00:00	2013-12-13	38000177		0	0	7		0	0	0	89765	0	1043400	40229134		
10600	883	19133873	1969-09-14	1969-09-14 00:00:00	1969-09-23	1969-09-23 00:00:00	1969-09-23	38000177		0	0	9		0	0	0	58791	0	834061	19133873		
17165	1425	19078461	1987-09-29	1987-09-29 00:00:00	1987-10-27	1987-10-27 00:00:00	1987-10-27	38000177		0	0	28		0	0	0	94733	0	310965	19078461		
126830	2790	40213227	2004-02-19	2004-02-19 00:00:00	2004-02-19	2004-02-19 00:00:00	2004-02-19	581452		0	0	0		0	0	0	184932	0	113	40213227		
984	80	40229134	1953-02-24	1953-02-24 00:00:00	1953-03-10	1953-03-10 00:00:00	1953-03-10	38000177		0	0	14		0	0	0	5380	0	1043400	40229134		
113193	2486	40213314	1977-08-26	1977-08-26 00:00:00	1977-08-26	1977-08-26 00:00:00	1977-08-26	581452		0	0	0		0	0	0	164706	0	49	40213314		
138229	3035	40213227	2014-12-26	2014-12-26 00:00:00	2014-12-26	2014-12-26 00:00:00	2014-12-26	581452		0	0	0		0	0	0	202169	0	113	40213227		
16680	1382	19073183	1982-04-20	1982-04-20 00:00:00	1982-05-04	1982-05-04 00:00:00	1982-05-04	38000177		0	0	14		0	0	0	91647	0	308182	19073183		
30922	2561	19128065	1990-10-24	1990-10-24 00:00:00	1991-10-19	1991-10-19 00:00:00	1991-10-19	38000177		0	0	360		0	0	0	169715	0	749882	19128065		
204	16	1713671	1985-08-05	1985-08-05 00:00:00	1985-08-26	1985-08-26 00:00:00	1985-08-26	38000177		0	0	21		0	0	0	1260	0	562251	1713671		
240488	5279	40213227	1997-02-02	1997-02-02 00:00:00	1997-02-02	1997-02-02 00:00:00	1997-02-02	581452		0	0	0		0	0	0	351214	0	113	40213227		
25592	2103	19128065	1988-04-29	1988-04-29 00:00:00	1989-04-24	1989-04-24 00:00:00	1989-04-24	38000177		0	0	360		0	0	0	140168	0	749882	19128065		
137164	3011	40213314	1977-06-14	1977-06-14 00:00:00	1977-06-14	1977-06-14 00:00:00	1977-06-14	581452		0	0	0		0	0	0	200843	0	49	40213314		
5236	114	40213296	2014-01-27	2014-01-27 00:00:00	2014-01-27	2014-01-27 00:00:00	2014-01-27	581452		0	0	0		0	0	0	7562	0	52	40213296		
36982	3059	1127078	1972-07-07	1972-07-07 00:00:00	1972-07-21	1972-07-21 00:00:00	1972-07-21	38000177		0	0	14		0	0	0	203485	0	282464	1127078		
5349	116	40213201	1993-10-24	1993-10-24 00:00:00	1993-10-24	1993-10-24 00:00:00	1993-10-24	581452		0	0	0		0	0	0	7699	0	33	40213201		
132199	2904	40213306	1992-07-22	1992-07-22 00:00:00	1992-07-22	1992-07-22 00:00:00	1992-07-22	581452		0	0	0		0	0	0	193531	0	43	40213306		
9082	756	1115171	1996-08-26	1996-08-26 00:00:00	1996-09-23	1996-09-23 00:00:00	1996-09-23	38000177		0	0	28		0	0	0	50105	0	849574	1115171		
199022	4373	40213160	1980-12-16	1980-12-16 00:00:00	1980-12-16	1980-12-16 00:00:00	1980-12-16	581452		0	0	0		0	0	0	290335	0	10	40213160		
38936	3217	1115171	1998-05-08	1998-05-08 00:00:00	1998-05-29	1998-05-29 00:00:00	1998-05-29	38000177		0	0	21		0	0	0	213810	0	849574	1115171		
113009	2482	40213160	1975-02-20	1975-02-20 00:00:00	1975-02-20	1975-02-20 00:00:00	1975-02-20	581452		0	0	0		0	0	0	164461	0	10	40213160		
208455	4572	40213227	2018-07-03	2018-07-03 00:00:00	2018-07-03	2018-07-03 00:00:00	2018-07-03	581452		0	0	0		0	0	0	304620	0	113	40213227		
65575	1435	40213160	1966-01-29	1966-01-29 00:00:00	1966-01-29	1966-01-29 00:00:00	1966-01-29	581452		0	0	0		0	0	0	95604	0	10	40213160		
4701	392	1127433	2019-01-31	2019-01-31 00:00:00	2019-02-14	2019-02-14 00:00:00	2019-02-14	38000177		0	0	14		0	0	0	25718	0	313782	1127433		
56439	4682	40229134	1992-05-11	1992-05-11 00:00:00	1992-05-25	1992-05-25 00:00:00	1992-05-25	38000177		0	0	14		0	0	0	312004	0	1043400	40229134		
46485	3851	1713671	1989-11-08	1989-11-08 00:00:00	1989-11-15	1989-11-15 00:00:00	1989-11-15	38000177		0	0	7		0	0	0	255511	0	562251	1713671		
13092	1099	1127433	1963-07-23	1963-07-23 00:00:00	1963-07-30	1963-07-30 00:00:00	1963-07-30	38000177		0	0	7		0	0	0	72106	0	313782	1127433		
46600	3859	40169281	1988-09-17	1988-09-17 00:00:00	1988-09-17	1988-09-17 00:00:00	\N	38000177		0	0	0		0	0	0	256169	0	896209	40169281		
208672	4577	40213180	2005-09-10	2005-09-10 00:00:00	2005-09-10	2005-09-10 00:00:00	2005-09-10	581452		0	0	0		0	0	0	304899	0	114	40213180		
29162	2414	920300	1984-06-12	1984-06-12 00:00:00	1984-06-19	1984-06-19 00:00:00	1984-06-19	38000177		0	0	7		0	0	0	160276	0	311989	920300		
23710	1950	1713671	1989-07-06	1989-07-06 00:00:00	1989-07-20	1989-07-20 00:00:00	1989-07-20	38000177		0	0	14		0	0	0	129627	0	562251	1713671		
1066	86	19133905	1990-03-14	1990-03-14 00:00:00	1990-03-27	1990-03-27 00:00:00	1990-03-27	38000177		0	0	13		0	0	0	5795	0	834102	19133905		
14032	1174	1115171	2003-01-31	2003-01-31 00:00:00	2003-02-21	2003-02-21 00:00:00	2003-02-21	38000177		0	0	21		0	0	0	77374	0	849574	1115171		
81224	1776	40213227	1998-09-12	1998-09-12 00:00:00	1998-09-12	1998-09-12 00:00:00	1998-09-12	581452		0	0	0		0	0	0	118890	0	113	40213227		
86752	1902	40213227	2015-02-22	2015-02-22 00:00:00	2015-02-22	2015-02-22 00:00:00	2015-02-22	581452		0	0	0		0	0	0	126586	0	113	40213227		
63880	5306	1127078	1973-05-17	1973-05-17 00:00:00	1973-05-31	1973-05-31 00:00:00	1973-05-31	38000177		0	0	14		0	0	0	352961	0	282464	1127078		
209318	4590	40213296	1996-01-01	1996-01-01 00:00:00	1996-01-01	1996-01-01 00:00:00	1996-01-01	581452		0	0	0		0	0	0	305820	0	52	40213296		
5628	471	46275916	1990-04-06	1990-04-06 00:00:00	1990-04-06	1990-04-06 00:00:00	1990-04-06	38000177		0	0	0		0	0	0	31462	0	1660014	46275916		
14491	1214	1713671	2018-12-17	2018-12-17 00:00:00	2018-12-31	2018-12-31 00:00:00	2018-12-31	38000177		0	0	14		0	0	0	79890	0	562251	1713671		
34794	2872	19059056	1968-04-07	1968-04-07 00:00:00	1968-04-21	1968-04-21 00:00:00	1968-04-21	38000177		0	0	14		0	0	0	191204	0	243670	19059056		
134717	2957	40213160	1955-05-01	1955-05-01 00:00:00	1955-05-01	1955-05-01 00:00:00	1955-05-01	581452		0	0	0		0	0	0	197311	0	10	40213160		
45321	3750	19059056	1961-09-28	1961-09-28 00:00:00	1961-10-12	1961-10-12 00:00:00	1961-10-12	38000177		0	0	14		0	0	0	249217	0	243670	19059056		
45351	3752	40236824	1996-01-07	1996-01-07 00:00:00	1996-01-14	1996-01-14 00:00:00	1996-01-14	38000177		0	0	7		0	0	0	249308	0	1094107	40236824		
24567	534	40213160	1979-02-26	1979-02-26 00:00:00	1979-02-26	1979-02-26 00:00:00	1979-02-26	581452		0	0	0		0	0	0	35546	0	10	40213160		
63131	1381	40213306	2000-08-05	2000-08-05 00:00:00	2000-08-05	2000-08-05 00:00:00	2000-08-05	581452		0	0	0		0	0	0	91571	0	43	40213306		
37394	3090	1115171	2003-05-25	2003-05-25 00:00:00	2003-06-15	2003-06-15 00:00:00	2003-06-15	38000177		0	0	21		0	0	0	205773	0	849574	1115171		
181852	3995	40213227	2004-05-08	2004-05-08 00:00:00	2004-05-08	2004-05-08 00:00:00	2004-05-08	581452		0	0	0		0	0	0	265584	0	113	40213227		
6342	533	19059056	1971-04-16	1971-04-16 00:00:00	1971-05-07	1971-05-07 00:00:00	1971-05-07	38000177		0	0	21		0	0	0	35368	0	243670	19059056		
55123	4577	40162522	2002-04-07	2002-04-07 00:00:00	2002-04-07	2002-04-07 00:00:00	\N	38000177		0	0	0		0	0	0	304868	0	857005	40162522		
8696	726	1127433	2013-05-23	2013-05-23 00:00:00	2013-06-06	2013-06-06 00:00:00	2013-06-06	38000177		0	0	14		0	0	0	48088	0	313782	1127433		
666	49	1127078	1983-04-09	1983-04-09 00:00:00	1983-05-07	1983-05-07 00:00:00	1983-05-07	38000177		0	0	28		0	0	0	3527	0	282464	1127078		
215694	4731	40213160	1976-10-12	1976-10-12 00:00:00	1976-10-12	1976-10-12 00:00:00	1976-10-12	581452		0	0	0		0	0	0	315200	0	10	40213160		
15907	1320	19078461	2006-03-04	2006-03-04 00:00:00	2006-04-03	2006-04-03 00:00:00	2006-04-03	38000177		0	0	30		0	0	0	87478	0	310965	19078461		
477	36	19059056	1964-10-19	1964-10-19 00:00:00	1964-11-02	1964-11-02 00:00:00	1964-11-02	38000177		0	0	14		0	0	0	2613	0	243670	19059056		
26458	2176	1713671	2000-06-01	2000-06-01 00:00:00	2000-06-15	2000-06-15 00:00:00	2000-06-15	38000177		0	0	14		0	0	0	145161	0	562251	1713671		
44294	3667	19133873	1968-07-06	1968-07-06 00:00:00	1968-07-19	1968-07-19 00:00:00	1968-07-19	38000177		0	0	13		0	0	0	243934	0	834061	19133873		
137698	3023	40213314	1982-01-30	1982-01-30 00:00:00	1982-01-30	1982-01-30 00:00:00	1982-01-30	581452		0	0	0		0	0	0	201515	0	49	40213314		
8542	711	40231925	1967-01-30	1967-01-30 00:00:00	1967-01-30	1967-01-30 00:00:00	\N	38000177		0	0	0		0	0	0	47196	0	1049221	40231925		
55198	1209	40213160	1977-12-15	1977-12-15 00:00:00	1977-12-15	1977-12-15 00:00:00	1977-12-15	581452		0	0	0		0	0	0	79438	0	10	40213160		
38791	3207	19006318	1961-06-28	1961-06-28 00:00:00	1961-07-12	1961-07-12 00:00:00	1961-07-12	38000177		0	0	14		0	0	0	213127	0	105078	19006318		
61148	5085	19129655	1976-12-08	1976-12-08 00:00:00	1976-12-22	1976-12-22 00:00:00	1976-12-22	38000177		0	0	14		0	0	0	338116	0	789980	19129655		
32247	2674	1127433	2006-12-29	2006-12-29 00:00:00	2007-01-26	2007-01-26 00:00:00	2007-01-26	38000177		0	0	28		0	0	0	177229	0	313782	1127433		
40123	3320	19133905	2012-10-01	2012-10-01 00:00:00	2012-10-13	2012-10-13 00:00:00	2012-10-13	38000177		0	0	12		0	0	0	220446	0	834102	19133905		
39936	870	40213227	2001-01-30	2001-01-30 00:00:00	2001-01-30	2001-01-30 00:00:00	2001-01-30	581452		0	0	0		0	0	0	57850	0	113	40213227		
16327	1354	1127433	1982-03-12	1982-03-12 00:00:00	1982-03-19	1982-03-19 00:00:00	1982-03-19	38000177		0	0	7		0	0	0	89745	0	313782	1127433		
10602	883	1127433	1986-03-20	1986-03-20 00:00:00	1986-03-27	1986-03-27 00:00:00	1986-03-27	38000177		0	0	7		0	0	0	58814	0	313782	1127433		
17166	1425	1118084	1977-01-04	1977-01-04 00:00:00	1977-01-04	1977-01-04 00:00:00	\N	38000177		0	0	0		0	0	0	94743	0	00025152531	44923712		
126835	2790	40213296	1996-01-25	1996-01-25 00:00:00	1996-01-25	1996-01-25 00:00:00	1996-01-25	581452		0	0	0		0	0	0	184930	0	52	40213296		
985	80	19059056	1938-08-01	1938-08-01 00:00:00	1938-08-22	1938-08-22 00:00:00	1938-08-22	38000177		0	0	21		0	0	0	5432	0	243670	19059056		
119424	2626	40213260	2013-07-02	2013-07-02 00:00:00	2013-07-02	2013-07-02 00:00:00	2013-07-02	581452		0	0	0		0	0	0	173727	0	121	40213260		
138230	3035	40213260	2014-12-26	2014-12-26 00:00:00	2014-12-26	2014-12-26 00:00:00	2014-12-26	581452		0	0	0		0	0	0	202169	0	121	40213260		
31767	2633	1127433	2018-02-19	2018-02-19 00:00:00	2018-05-20	2018-05-20 00:00:00	2018-05-20	38000177		0	0	90		0	0	0	174229	0	313782	1127433		
30923	2561	19129655	1976-11-26	1976-11-26 00:00:00	1976-12-10	1976-12-10 00:00:00	1976-12-10	38000177		0	0	14		0	0	0	169727	0	789980	19129655		
205	16	19059056	1975-05-25	1975-05-25 00:00:00	1975-06-08	1975-06-08 00:00:00	1975-06-08	38000177		0	0	14		0	0	0	1162	0	243670	19059056		
240510	5279	40213198	2011-04-24	2011-04-24 00:00:00	2011-04-24	2011-04-24 00:00:00	2011-04-24	581452		0	0	0		0	0	0	351192	0	133	40213198		
25593	2103	19078461	1991-06-17	1991-06-17 00:00:00	1991-08-16	1991-08-16 00:00:00	1991-08-16	38000177		0	0	60		0	0	0	140123	0	310965	19078461		
137167	3011	40213227	2016-05-24	2016-05-24 00:00:00	2016-05-24	2016-05-24 00:00:00	2016-05-24	581452		0	0	0		0	0	0	200805	0	113	40213227		
5251	114	40213160	1976-10-18	1976-10-18 00:00:00	1976-10-18	1976-10-18 00:00:00	1976-10-18	581452		0	0	0		0	0	0	7540	0	10	40213160		
36983	3059	19059056	1975-03-13	1975-03-13 00:00:00	1975-03-27	1975-03-27 00:00:00	1975-03-27	38000177		0	0	14		0	0	0	203477	0	243670	19059056		
5354	116	40213227	1997-11-16	1997-11-16 00:00:00	1997-11-16	1997-11-16 00:00:00	1997-11-16	581452		0	0	0		0	0	0	7753	0	113	40213227		
132201	2904	40213160	1971-01-27	1971-01-27 00:00:00	1971-01-27	1971-01-27 00:00:00	1971-01-27	581452		0	0	0		0	0	0	193522	0	10	40213160		
9083	756	1713671	2013-08-14	2013-08-14 00:00:00	2013-08-28	2013-08-28 00:00:00	2013-08-28	38000177		0	0	14		0	0	0	50108	0	562251	1713671		
199023	4373	40213251	1984-01-03	1984-01-03 00:00:00	1984-01-03	1984-01-03 00:00:00	1984-01-03	581452		0	0	0		0	0	0	290443	0	21	40213251		
38937	3217	1127078	1992-01-19	1992-01-19 00:00:00	1992-02-09	1992-02-09 00:00:00	1992-02-09	38000177		0	0	21		0	0	0	213809	0	282464	1127078		
113015	2482	40213314	1977-12-15	1977-12-15 00:00:00	1977-12-15	1977-12-15 00:00:00	1977-12-15	581452		0	0	0		0	0	0	164437	0	49	40213314		
208456	4572	40213296	2018-07-03	2018-07-03 00:00:00	2018-07-03	2018-07-03 00:00:00	2018-07-03	581452		0	0	0		0	0	0	304620	0	52	40213296		
65576	1435	40213160	1961-05-27	1961-05-27 00:00:00	1961-05-27	1961-05-27 00:00:00	1961-05-27	581452		0	0	0		0	0	0	95551	0	10	40213160		
4702	393	1118084	1997-07-13	1997-07-13 00:00:00	1997-07-13	1997-07-13 00:00:00	\N	38000177		0	0	0		0	0	0	25804	0	00025152531	44923712		
56440	4682	1127078	1984-03-23	1984-03-23 00:00:00	1984-04-06	1984-04-06 00:00:00	1984-04-06	38000177		0	0	14		0	0	0	312042	0	282464	1127078		
46486	3851	19075601	1997-08-04	1997-08-04 00:00:00	1997-08-04	1997-08-04 00:00:00	\N	38000177		0	0	0		0	0	0	255527	0	309362	19075601		
13093	1099	19059056	1957-06-28	1957-06-28 00:00:00	1957-07-12	1957-07-12 00:00:00	1957-07-12	38000177		0	0	14		0	0	0	72144	0	243670	19059056		
46601	3859	1127433	1993-07-08	1993-07-08 00:00:00	1993-07-22	1993-07-22 00:00:00	1993-07-22	38000177		0	0	14		0	0	0	256210	0	313782	1127433		
208673	4577	40213306	2007-07-21	2007-07-21 00:00:00	2007-07-21	2007-07-21 00:00:00	2007-07-21	581452		0	0	0		0	0	0	304900	0	43	40213306		
29163	2414	40236824	1984-06-12	1984-06-12 00:00:00	1984-06-19	1984-06-19 00:00:00	1984-06-19	38000177		0	0	7		0	0	0	160276	0	1094107	40236824		
23711	1950	1127433	2017-02-03	2017-02-03 00:00:00	2017-02-10	2017-02-10 00:00:00	2017-02-10	38000177		0	0	7		0	0	0	129632	0	313782	1127433		
1067	86	1127433	1952-07-05	1952-07-05 00:00:00	1952-07-19	1952-07-19 00:00:00	1952-07-19	38000177		0	0	14		0	0	0	5768	0	313782	1127433		
14033	1174	19059056	1941-11-03	1941-11-03 00:00:00	1941-11-24	1941-11-24 00:00:00	1941-11-24	38000177		0	0	21		0	0	0	77371	0	243670	19059056		
122494	2692	40213160	1955-11-14	1955-11-14 00:00:00	1955-11-14	1955-11-14 00:00:00	1955-11-14	581452		0	0	0		0	0	0	178320	0	10	40213160		
86755	1902	40213198	2010-02-28	2010-02-28 00:00:00	2010-02-28	2010-02-28 00:00:00	2010-02-28	581452		0	0	0		0	0	0	126606	0	133	40213198		
63881	5306	19006318	1973-05-17	1973-05-17 00:00:00	1973-05-31	1973-05-31 00:00:00	1973-05-31	38000177		0	0	14		0	0	0	352961	0	105078	19006318		
209323	4591	40213201	2019-06-27	2019-06-27 00:00:00	2019-06-27	2019-06-27 00:00:00	2019-06-27	581452		0	0	0		0	0	0	305943	0	33	40213201		
5629	471	1310034	1990-04-06	1990-04-06 00:00:00	1990-04-06	1990-04-06 00:00:00	1990-04-06	38000177		0	0	0		0	0	0	31462	0	834357	1310034		
14493	1214	19133873	1941-03-26	1941-03-26 00:00:00	1941-04-04	1941-04-04 00:00:00	1941-04-04	38000177		0	0	9		0	0	0	79974	0	834061	19133873		
34795	2872	19133768	1999-08-17	1999-08-17 00:00:00	1999-08-17	1999-08-17 00:00:00	1999-08-17	38000177		0	0	0		0	0	0	191227	0	833036	19133768		
134721	2957	40213227	1998-05-10	1998-05-10 00:00:00	1998-05-10	1998-05-10 00:00:00	1998-05-10	581452		0	0	0		0	0	0	197368	0	113	40213227		
45322	3750	19006318	1961-09-28	1961-09-28 00:00:00	1961-10-12	1961-10-12 00:00:00	1961-10-12	38000177		0	0	14		0	0	0	249217	0	105078	19006318		
45353	3752	1713671	1995-03-05	1995-03-05 00:00:00	1995-03-12	1995-03-12 00:00:00	1995-03-12	38000177		0	0	7		0	0	0	249307	0	562251	1713671		
24569	534	40213314	1979-08-28	1979-08-28 00:00:00	1979-08-28	1979-08-28 00:00:00	1979-08-28	581452		0	0	0		0	0	0	35576	0	49	40213314		
63134	1381	40213251	1984-05-19	1984-05-19 00:00:00	1984-05-19	1984-05-19 00:00:00	1984-05-19	581452		0	0	0		0	0	0	91559	0	21	40213251		
37395	3090	1127433	2005-03-06	2005-03-06 00:00:00	2005-03-13	2005-03-13 00:00:00	2005-03-13	38000177		0	0	7		0	0	0	205709	0	313782	1127433		
181857	3995	40213227	1993-04-17	1993-04-17 00:00:00	1993-04-17	1993-04-17 00:00:00	1993-04-17	581452		0	0	0		0	0	0	265630	0	113	40213227		
6343	533	1127433	1980-03-30	1980-03-30 00:00:00	1980-04-06	1980-04-06 00:00:00	1980-04-06	38000177		0	0	7		0	0	0	35426	0	313782	1127433		
55124	4577	1124300	2019-03-17	2019-03-17 00:00:00	2019-03-17	2019-03-17 00:00:00	\N	38000177		0	0	0		0	0	0	304889	0	00781178901	45011828		
8698	726	1713671	1982-05-25	1982-05-25 00:00:00	1982-06-01	1982-06-01 00:00:00	1982-06-01	38000177		0	0	7		0	0	0	48111	0	562251	1713671		
22877	1882	1127078	1971-09-24	1971-09-24 00:00:00	1971-12-23	1971-12-23 00:00:00	1971-12-23	38000177		0	0	90		0	0	0	125565	0	282464	1127078		
132620	2913	40213227	2007-05-19	2007-05-19 00:00:00	2007-05-19	2007-05-19 00:00:00	2007-05-19	581452		0	0	0		0	0	0	194088	0	113	40213227		
15908	1320	1118084	1973-08-15	1973-08-15 00:00:00	1973-08-15	1973-08-15 00:00:00	\N	38000177		0	0	0		0	0	0	87481	0	00025152531	44923712		
478	36	19008572	1993-05-26	1993-05-26 00:00:00	1993-06-16	1993-06-16 00:00:00	1993-06-16	38000177		0	0	21		0	0	0	2560	0	106258	19008572		
26459	2176	1118084	2000-06-30	2000-06-30 00:00:00	2000-06-30	2000-06-30 00:00:00	\N	38000177		0	0	0		0	0	0	145161	0	00025152531	44923712		
44295	3667	1127078	1977-09-28	1977-09-28 00:00:00	1977-10-12	1977-10-12 00:00:00	1977-10-12	38000177		0	0	14		0	0	0	243977	0	282464	1127078		
137699	3023	40213160	1982-01-30	1982-01-30 00:00:00	1982-01-30	1982-01-30 00:00:00	1982-01-30	581452		0	0	0		0	0	0	201515	0	10	40213160		
8543	711	42707627	1967-01-29	1967-01-29 00:00:00	1967-01-29	1967-01-29 00:00:00	1967-01-29	38000177		0	0	0		0	0	0	47196	0	1234995	42707627		
55205	1209	40213160	1978-05-18	1978-05-18 00:00:00	1978-05-18	1978-05-18 00:00:00	1978-05-18	581452		0	0	0		0	0	0	79439	0	10	40213160		
38792	3207	1127078	1961-06-28	1961-06-28 00:00:00	1961-07-12	1961-07-12 00:00:00	1961-07-12	38000177		0	0	14		0	0	0	213127	0	282464	1127078		
61149	5086	19059056	1970-08-21	1970-08-21 00:00:00	1970-09-04	1970-09-04 00:00:00	1970-09-04	38000177		0	0	14		0	0	0	338141	0	243670	19059056		
32248	2674	19133873	1973-02-14	1973-02-14 00:00:00	1973-02-25	1973-02-25 00:00:00	1973-02-25	38000177		0	0	11		0	0	0	177211	0	834061	19133873		
40124	3320	1127433	2000-12-10	2000-12-10 00:00:00	2000-12-24	2000-12-24 00:00:00	2000-12-24	38000177		0	0	14		0	0	0	220486	0	313782	1127433		
39937	870	40213296	2001-01-30	2001-01-30 00:00:00	2001-01-30	2001-01-30 00:00:00	2001-01-30	581452		0	0	0		0	0	0	57850	0	52	40213296		
16328	1354	1713671	1989-12-15	1989-12-15 00:00:00	1989-12-22	1989-12-22 00:00:00	1989-12-22	38000177		0	0	7		0	0	0	89758	0	562251	1713671		
10603	883	40229134	1987-01-24	1987-01-24 00:00:00	1987-01-31	1987-01-31 00:00:00	1987-01-31	38000177		0	0	7		0	0	0	58810	0	1043400	40229134		
17167	1425	40229134	1961-10-23	1961-10-23 00:00:00	1961-11-06	1961-11-06 00:00:00	1961-11-06	38000177		0	0	14		0	0	0	94734	0	1043400	40229134		
126842	2790	40213227	2014-04-17	2014-04-17 00:00:00	2014-04-17	2014-04-17 00:00:00	2014-04-17	581452		0	0	0		0	0	0	184921	0	113	40213227		
986	80	19133873	1951-03-25	1951-03-25 00:00:00	1951-04-06	1951-04-06 00:00:00	1951-04-06	38000177		0	0	12		0	0	0	5439	0	834061	19133873		
119429	2626	40213227	2014-07-08	2014-07-08 00:00:00	2014-07-08	2014-07-08 00:00:00	2014-07-08	581452		0	0	0		0	0	0	173698	0	113	40213227		
138234	3035	40213227	2006-10-13	2006-10-13 00:00:00	2006-10-13	2006-10-13 00:00:00	2006-10-13	581452		0	0	0		0	0	0	202219	0	113	40213227		
31768	2633	1118084	1981-08-28	1981-08-28 00:00:00	1981-08-28	1981-08-28 00:00:00	\N	38000177		0	0	0		0	0	0	174254	0	00025152531	44923712		
30924	2561	1127078	1976-11-26	1976-11-26 00:00:00	1976-12-10	1976-12-10 00:00:00	1976-12-10	38000177		0	0	14		0	0	0	169727	0	282464	1127078		
206	16	1127433	1994-01-01	1994-01-01 00:00:00	1994-01-08	1994-01-08 00:00:00	1994-01-08	38000177		0	0	7		0	0	0	1202	0	313782	1127433		
34524	2853	1127433	1988-06-02	1988-06-02 00:00:00	1988-06-09	1988-06-09 00:00:00	1988-06-09	38000177		0	0	7		0	0	0	189512	0	313782	1127433		
25594	2103	40165015	1991-06-17	1991-06-17 00:00:00	1991-06-17	1991-06-17 00:00:00	\N	38000177		0	0	0		0	0	0	140123	0	861467	40165015		
137168	3011	40213296	2016-05-24	2016-05-24 00:00:00	2016-05-24	2016-05-24 00:00:00	2016-05-24	581452		0	0	0		0	0	0	200805	0	52	40213296		
5259	114	40213227	2003-10-20	2003-10-20 00:00:00	2003-10-20	2003-10-20 00:00:00	2003-10-20	581452		0	0	0		0	0	0	7548	0	113	40213227		
36984	3059	19129655	1975-03-13	1975-03-13 00:00:00	1975-03-27	1975-03-27 00:00:00	1975-03-27	38000177		0	0	14		0	0	0	203477	0	789980	19129655		
218649	4799	40213160	1958-07-26	1958-07-26 00:00:00	1958-07-26	1958-07-26 00:00:00	1958-07-26	581452		0	0	0		0	0	0	319286	0	10	40213160		
132204	2904	40213227	2012-05-30	2012-05-30 00:00:00	2012-05-30	2012-05-30 00:00:00	2012-05-30	581452		0	0	0		0	0	0	193490	0	113	40213227		
9084	756	46233988	1968-04-04	1968-04-04 00:00:00	1968-04-18	1968-04-18 00:00:00	1968-04-18	38000177		0	0	14		0	0	0	50143	0	1652673	46233988		
199027	4373	40213160	1976-09-14	1976-09-14 00:00:00	1976-09-14	1976-09-14 00:00:00	1976-09-14	581452		0	0	0		0	0	0	290440	0	10	40213160		
38938	3218	1713671	1993-04-18	1993-04-18 00:00:00	1993-05-02	1993-05-02 00:00:00	1993-05-02	38000177		0	0	14		0	0	0	213834	0	562251	1713671		
113016	2482	40213314	1978-06-15	1978-06-15 00:00:00	1978-06-15	1978-06-15 00:00:00	1978-06-15	581452		0	0	0		0	0	0	164447	0	49	40213314		
208458	4572	40213160	1980-05-13	1980-05-13 00:00:00	1980-05-13	1980-05-13 00:00:00	1980-05-13	581452		0	0	0		0	0	0	304645	0	10	40213160		
65578	1435	40213306	1983-03-05	1983-03-05 00:00:00	1983-03-05	1983-03-05 00:00:00	1983-03-05	581452		0	0	0		0	0	0	95526	0	43	40213306		
4704	393	1713671	2004-01-18	2004-01-18 00:00:00	2004-02-01	2004-02-01 00:00:00	2004-02-01	38000177		0	0	14		0	0	0	25775	0	562251	1713671		
10204	217	40213160	1980-03-18	1980-03-18 00:00:00	1980-03-18	1980-03-18 00:00:00	1980-03-18	581452		0	0	0		0	0	0	14658	0	10	40213160		
46487	3851	19126352	1992-07-06	1992-07-06 00:00:00	1992-07-06	1992-07-06 00:00:00	\N	38000177		0	0	0		0	0	0	255607	0	705129	19126352		
13094	1099	19006318	1957-06-28	1957-06-28 00:00:00	1957-07-12	1957-07-12 00:00:00	1957-07-12	38000177		0	0	14		0	0	0	72144	0	105078	19006318		
46602	3859	40171902	2016-04-16	2016-04-16 00:00:00	2016-04-16	2016-04-16 00:00:00	\N	38000177		0	0	0		0	0	0	256182	0	897718	40171902		
208676	4577	40213227	2016-07-30	2016-07-30 00:00:00	2016-07-30	2016-07-30 00:00:00	2016-07-30	581452		0	0	0		0	0	0	304903	0	113	40213227		
29164	2414	19059056	1929-06-05	1929-06-05 00:00:00	1929-06-19	1929-06-19 00:00:00	1929-06-19	38000177		0	0	14		0	0	0	160248	0	243670	19059056		
23712	1950	19059056	1944-11-15	1944-11-15 00:00:00	1944-11-29	1944-11-29 00:00:00	1944-11-29	38000177		0	0	14		0	0	0	129670	0	243670	19059056		
1068	86	1127433	1977-12-14	1977-12-14 00:00:00	1977-12-28	1977-12-28 00:00:00	1977-12-28	38000177		0	0	14		0	0	0	5805	0	313782	1127433		
14034	1174	1118084	1974-01-25	1974-01-25 00:00:00	1974-01-25	1974-01-25 00:00:00	\N	38000177		0	0	0		0	0	0	77328	0	00025152531	44923712		
122503	2693	40213160	1963-09-24	1963-09-24 00:00:00	1963-09-24	1963-09-24 00:00:00	1963-09-24	581452		0	0	0		0	0	0	178398	0	10	40213160		
86756	1902	40213201	2010-02-28	2010-02-28 00:00:00	2010-02-28	2010-02-28 00:00:00	2010-02-28	581452		0	0	0		0	0	0	126606	0	33	40213201		
63882	5306	19128065	1986-12-26	1986-12-26 00:00:00	1987-12-21	1987-12-21 00:00:00	1987-12-21	38000177		0	0	360		0	0	0	352952	0	749882	19128065		
209325	4591	40213198	2018-06-21	2018-06-21 00:00:00	2018-06-21	2018-06-21 00:00:00	2018-06-21	581452		0	0	0		0	0	0	305904	0	133	40213198		
5630	472	19008572	1998-01-30	1998-01-30 00:00:00	1998-01-30	1998-01-30 00:00:00	\N	38000177		0	0	0		0	0	0	31536	0	106258	19008572		
14494	1214	19059056	1955-12-23	1955-12-23 00:00:00	1956-01-22	1956-01-22 00:00:00	1956-01-22	38000177		0	0	30		0	0	0	80004	0	243670	19059056		
34796	2872	1545959	1999-08-17	1999-08-17 00:00:00	1999-08-17	1999-08-17 00:00:00	1999-08-17	38000177		0	0	0		0	0	0	191227	0	259255	1545959		
134727	2957	40213227	2009-02-07	2009-02-07 00:00:00	2009-02-07	2009-02-07 00:00:00	2009-02-07	581452		0	0	0		0	0	0	197369	0	113	40213227		
45323	3750	40229134	1987-11-13	1987-11-13 00:00:00	1987-11-27	1987-11-27 00:00:00	1987-11-27	38000177		0	0	14		0	0	0	249245	0	1043400	40229134		
45361	3754	1713671	1966-01-18	1966-01-18 00:00:00	1966-01-25	1966-01-25 00:00:00	1966-01-25	38000177		0	0	7		0	0	0	249442	0	562251	1713671		
24571	534	40213160	1983-05-31	1983-05-31 00:00:00	1983-05-31	1983-05-31 00:00:00	1983-05-31	581452		0	0	0		0	0	0	35579	0	10	40213160		
63138	1381	40213314	1978-09-09	1978-09-09 00:00:00	1978-09-09	1978-09-09 00:00:00	1978-09-09	581452		0	0	0		0	0	0	91590	0	49	40213314		
37396	3090	1127433	1989-10-28	1989-10-28 00:00:00	1989-11-11	1989-11-11 00:00:00	1989-11-11	38000177		0	0	14		0	0	0	205755	0	313782	1127433		
181858	3995	40213306	1993-04-17	1993-04-17 00:00:00	1993-04-17	1993-04-17 00:00:00	1993-04-17	581452		0	0	0		0	0	0	265630	0	43	40213306		
6344	533	40232448	1966-08-21	1966-08-21 00:00:00	1966-08-21	1966-08-21 00:00:00	\N	38000177		0	0	0		0	0	0	35425	0	1049630	40232448		
55125	4577	1127433	1992-03-24	1992-03-24 00:00:00	1992-04-07	1992-04-07 00:00:00	1992-04-07	38000177		0	0	14		0	0	0	304905	0	313782	1127433		
8699	726	40229134	1988-06-24	1988-06-24 00:00:00	1988-07-01	1988-07-01 00:00:00	1988-07-01	38000177		0	0	7		0	0	0	48076	0	1043400	40229134		
22878	1882	1127433	1985-11-27	1985-11-27 00:00:00	1985-12-11	1985-12-11 00:00:00	1985-12-11	38000177		0	0	14		0	0	0	125480	0	313782	1127433		
132625	2913	40213201	2012-06-16	2012-06-16 00:00:00	2012-06-16	2012-06-16 00:00:00	2012-06-16	581452		0	0	0		0	0	0	194121	0	33	40213201		
15909	1320	1713671	1953-12-01	1953-12-01 00:00:00	1953-12-22	1953-12-22 00:00:00	1953-12-22	38000177		0	0	21		0	0	0	87557	0	562251	1713671		
479	36	1118084	1993-05-30	1993-05-30 00:00:00	1993-05-30	1993-05-30 00:00:00	\N	38000177		0	0	0		0	0	0	2560	0	00025152531	44923712		
26460	2176	19059056	1957-09-14	1957-09-14 00:00:00	1957-09-28	1957-09-28 00:00:00	1957-09-28	38000177		0	0	14		0	0	0	145109	0	243670	19059056		
44296	3667	19133873	1976-04-11	1976-04-11 00:00:00	1976-04-21	1976-04-21 00:00:00	1976-04-21	38000177		0	0	10		0	0	0	243936	0	834061	19133873		
137703	3023	40213160	1982-07-03	1982-07-03 00:00:00	1982-07-03	1982-07-03 00:00:00	1982-07-03	581452		0	0	0		0	0	0	201516	0	10	40213160		
8544	711	46275444	1967-01-29	1967-01-29 00:00:00	1967-01-29	1967-01-29 00:00:00	1967-01-29	38000177		0	0	0		0	0	0	47196	0	1659149	46275444		
55207	1209	40213227	2009-07-09	2009-07-09 00:00:00	2009-07-09	2009-07-09 00:00:00	2009-07-09	581452		0	0	0		0	0	0	79455	0	113	40213227		
38793	3208	19019979	1975-10-02	1975-10-02 00:00:00	1975-11-01	1975-11-01 00:00:00	1975-11-01	38000177		0	0	30		0	0	0	213245	0	198405	19019979		
61150	5086	19129655	1970-08-21	1970-08-21 00:00:00	1970-09-04	1970-09-04 00:00:00	1970-09-04	38000177		0	0	14		0	0	0	338141	0	789980	19129655		
32249	2674	1127433	1983-03-01	1983-03-01 00:00:00	1983-03-08	1983-03-08 00:00:00	1983-03-08	38000177		0	0	7		0	0	0	177225	0	313782	1127433		
40125	3320	1127433	1978-02-07	1978-02-07 00:00:00	1978-02-21	1978-02-21 00:00:00	1978-02-21	38000177		0	0	14		0	0	0	220478	0	313782	1127433		
39949	870	40213160	1960-05-17	1960-05-17 00:00:00	1960-05-17	1960-05-17 00:00:00	1960-05-17	581452		0	0	0		0	0	0	57889	0	10	40213160		
16329	1354	1127433	1981-07-29	1981-07-29 00:00:00	1981-08-12	1981-08-12 00:00:00	1981-08-12	38000177		0	0	14		0	0	0	89724	0	313782	1127433		
10604	883	19128065	1978-05-27	1978-05-27 00:00:00	1979-05-22	1979-05-22 00:00:00	1979-05-22	38000177		0	0	360		0	0	0	58796	0	749882	19128065		
17168	1425	1713671	2018-04-09	2018-04-09 00:00:00	2018-04-23	2018-04-23 00:00:00	2018-04-23	38000177		0	0	14		0	0	0	94736	0	562251	1713671		
126843	2790	40213160	1955-12-29	1955-12-29 00:00:00	1955-12-29	1955-12-29 00:00:00	1955-12-29	581452		0	0	0		0	0	0	184924	0	10	40213160		
987	80	1127433	1937-07-09	1937-07-09 00:00:00	1937-07-16	1937-07-16 00:00:00	1937-07-16	38000177		0	0	7		0	0	0	5460	0	313782	1127433		
119430	2626	40213260	2014-07-08	2014-07-08 00:00:00	2014-07-08	2014-07-08 00:00:00	2014-07-08	581452		0	0	0		0	0	0	173698	0	121	40213260		
138235	3035	40213296	2006-10-13	2006-10-13 00:00:00	2006-10-13	2006-10-13 00:00:00	2006-10-13	581452		0	0	0		0	0	0	202219	0	52	40213296		
31769	2633	1127433	1991-11-24	1991-11-24 00:00:00	1991-12-08	1991-12-08 00:00:00	1991-12-08	38000177		0	0	14		0	0	0	174228	0	313782	1127433		
30925	2561	1713671	1997-10-17	1997-10-17 00:00:00	1997-10-31	1997-10-31 00:00:00	1997-10-31	38000177		0	0	14		0	0	0	169672	0	562251	1713671		
207	16	46233988	1972-04-10	1972-04-10 00:00:00	1972-04-24	1972-04-24 00:00:00	1972-04-24	38000177		0	0	14		0	0	0	1196	0	1652673	46233988		
34525	2853	1713671	2009-03-06	2009-03-06 00:00:00	2009-03-20	2009-03-20 00:00:00	2009-03-20	38000177		0	0	14		0	0	0	189534	0	562251	1713671		
25595	2103	19128065	1991-04-14	1991-04-14 00:00:00	1992-04-08	1992-04-08 00:00:00	1992-04-08	38000177		0	0	360		0	0	0	140140	0	749882	19128065		
137169	3011	40213160	1974-10-15	1974-10-15 00:00:00	1974-10-15	1974-10-15 00:00:00	1974-10-15	581452		0	0	0		0	0	0	200840	0	10	40213160		
5262	114	40213160	1972-11-20	1972-11-20 00:00:00	1972-11-20	1972-11-20 00:00:00	1972-11-20	581452		0	0	0		0	0	0	7521	0	10	40213160		
36985	3059	1713671	2001-11-04	2001-11-04 00:00:00	2001-11-25	2001-11-25 00:00:00	2001-11-25	38000177		0	0	21		0	0	0	203494	0	562251	1713671		
218650	4799	40213160	1958-04-26	1958-04-26 00:00:00	1958-04-26	1958-04-26 00:00:00	1958-04-26	581452		0	0	0		0	0	0	319269	0	10	40213160		
132205	2904	40213296	2012-05-30	2012-05-30 00:00:00	2012-05-30	2012-05-30 00:00:00	2012-05-30	581452		0	0	0		0	0	0	193490	0	52	40213296		
9085	756	1127078	1968-04-04	1968-04-04 00:00:00	1968-04-18	1968-04-18 00:00:00	1968-04-18	38000177		0	0	14		0	0	0	50143	0	282464	1127078		
199032	4373	40213314	1977-06-14	1977-06-14 00:00:00	1977-06-14	1977-06-14 00:00:00	1977-06-14	581452		0	0	0		0	0	0	290441	0	49	40213314		
38939	3218	1115171	1994-01-03	1994-01-03 00:00:00	1994-04-03	1994-04-03 00:00:00	1994-04-03	38000177		0	0	90		0	0	0	213812	0	849574	1115171		
230156	5058	40213227	2009-01-18	2009-01-18 00:00:00	2009-01-18	2009-01-18 00:00:00	2009-01-18	581452		0	0	0		0	0	0	336364	0	113	40213227		
24340	2002	19078461	2019-02-14	2019-02-14 00:00:00	2019-03-14	2019-03-14 00:00:00	2019-03-14	38000177		0	0	28		0	0	0	133365	0	310965	19078461		
65587	1435	40213227	1992-03-14	1992-03-14 00:00:00	1992-03-14	1992-03-14 00:00:00	1992-03-14	581452		0	0	0		0	0	0	95529	0	113	40213227		
4705	393	1127433	1976-08-01	1976-08-01 00:00:00	1976-08-15	1976-08-15 00:00:00	1976-08-15	38000177		0	0	14		0	0	0	25762	0	313782	1127433		
10210	217	40213160	1975-12-16	1975-12-16 00:00:00	1975-12-16	1975-12-16 00:00:00	1975-12-16	581452		0	0	0		0	0	0	14654	0	10	40213160		
46488	3851	1539411	1992-07-06	1992-07-06 00:00:00	1992-07-06	1992-07-06 00:00:00	\N	38000177		0	0	0		0	0	0	255607	0	312961	1539411		
13095	1099	19059056	1953-01-07	1953-01-07 00:00:00	1953-01-21	1953-01-21 00:00:00	1953-01-21	38000177		0	0	14		0	0	0	72190	0	243670	19059056		
46603	3859	40163554	2016-04-16	2016-04-16 00:00:00	2016-04-16	2016-04-16 00:00:00	\N	38000177		0	0	0		0	0	0	256182	0	855332	40163554		
208679	4577	40213160	1988-06-18	1988-06-18 00:00:00	1988-06-18	1988-06-18 00:00:00	1988-06-18	581452		0	0	0		0	0	0	304863	0	10	40213160		
29165	2414	19075601	1997-09-04	1997-09-04 00:00:00	2000-04-27	2000-04-27 00:00:00	2000-04-27	38000177		0	0	966		0	0	0	160246	0	309362	19075601		
23713	1950	19133873	1952-10-10	1952-10-10 00:00:00	1952-10-22	1952-10-22 00:00:00	1952-10-22	38000177		0	0	12		0	0	0	129645	0	834061	19133873		
1090	90	1713671	1965-01-21	1965-01-21 00:00:00	1965-02-18	1965-02-18 00:00:00	1965-02-18	38000177		0	0	28		0	0	0	6005	0	562251	1713671		
14035	1174	40162522	1963-03-02	1963-03-02 00:00:00	1963-03-02	1963-03-02 00:00:00	\N	38000177		0	0	0		0	0	0	77329	0	857005	40162522		
122507	2693	40213160	1959-01-20	1959-01-20 00:00:00	1959-01-20	1959-01-20 00:00:00	1959-01-20	581452		0	0	0		0	0	0	178379	0	10	40213160		
212958	4670	40213160	1955-03-09	1955-03-09 00:00:00	1955-03-09	1955-03-09 00:00:00	1955-03-09	581452		0	0	0		0	0	0	311234	0	10	40213160		
63883	5306	964261	1989-01-14	1989-01-14 00:00:00	1989-01-14	1989-01-14 00:00:00	\N	38000177		0	0	0		0	0	0	352949	0	2001499	964261		
209331	4591	40213227	1993-10-28	1993-10-28 00:00:00	1993-10-28	1993-10-28 00:00:00	1993-10-28	581452		0	0	0		0	0	0	305960	0	113	40213227		
5631	472	1115171	2003-06-16	2003-06-16 00:00:00	2003-08-15	2003-08-15 00:00:00	2003-08-15	38000177		0	0	60		0	0	0	31547	0	849574	1115171		
14495	1214	40229134	1985-06-06	1985-06-06 00:00:00	1985-06-20	1985-06-20 00:00:00	1985-06-20	38000177		0	0	14		0	0	0	79900	0	1043400	40229134		
34797	2872	19059056	1954-10-27	1954-10-27 00:00:00	1954-11-17	1954-11-17 00:00:00	1954-11-17	38000177		0	0	21		0	0	0	191203	0	243670	19059056		
76394	1669	40213160	1959-07-13	1959-07-13 00:00:00	1959-07-13	1959-07-13 00:00:00	1959-07-13	581452		0	0	0		0	0	0	112095	0	10	40213160		
45330	3752	19128065	1978-11-02	1978-11-02 00:00:00	1979-10-28	1979-10-28 00:00:00	1979-10-28	38000177		0	0	360		0	0	0	249357	0	749882	19128065		
45362	3754	19128065	1976-12-12	1976-12-12 00:00:00	1977-12-07	1977-12-07 00:00:00	1977-12-07	38000177		0	0	360		0	0	0	249545	0	749882	19128065		
104246	2286	40213227	2008-09-08	2008-09-08 00:00:00	2008-09-08	2008-09-08 00:00:00	2008-09-08	581452		0	0	0		0	0	0	152087	0	113	40213227		
63139	1381	40213160	1978-09-09	1978-09-09 00:00:00	1978-09-09	1978-09-09 00:00:00	1978-09-09	581452		0	0	0		0	0	0	91590	0	10	40213160		
37397	3090	40229134	1961-09-21	1961-09-21 00:00:00	1961-10-05	1961-10-05 00:00:00	1961-10-05	38000177		0	0	14		0	0	0	205705	0	1043400	40229134		
181861	3995	40213160	1976-01-24	1976-01-24 00:00:00	1976-01-24	1976-01-24 00:00:00	1976-01-24	581452		0	0	0		0	0	0	265625	0	10	40213160		
6345	533	1127433	1979-07-24	1979-07-24 00:00:00	1979-08-23	1979-08-23 00:00:00	1979-08-23	38000177		0	0	30		0	0	0	35369	0	313782	1127433		
55126	4577	19074843	1985-06-06	1985-06-06 00:00:00	1985-06-20	1985-06-20 00:00:00	1985-06-20	38000177		0	0	14		0	0	0	304891	0	309045	19074843		
8700	726	19128065	1977-07-05	1977-07-05 00:00:00	1978-06-30	1978-06-30 00:00:00	1978-06-30	38000177		0	0	360		0	0	0	48067	0	749882	19128065		
22879	1882	1713671	2007-07-09	2007-07-09 00:00:00	2007-07-16	2007-07-16 00:00:00	2007-07-16	38000177		0	0	7		0	0	0	125510	0	562251	1713671		
132635	2913	40213227	1997-03-01	1997-03-01 00:00:00	1997-03-01	1997-03-01 00:00:00	1997-03-01	581452		0	0	0		0	0	0	194137	0	113	40213227		
15910	1320	19059056	1959-10-09	1959-10-09 00:00:00	1959-11-06	1959-11-06 00:00:00	1959-11-06	38000177		0	0	28		0	0	0	87475	0	243670	19059056		
480	36	19134077	1993-05-26	1993-05-26 00:00:00	1993-06-16	1993-06-16 00:00:00	1993-06-16	38000177		0	0	21		0	0	0	2560	0	835900	19134077		
26462	2176	19133905	1991-09-13	1991-09-13 00:00:00	1991-09-20	1991-09-20 00:00:00	1991-09-20	38000177		0	0	7		0	0	0	145107	0	834102	19133905		
44297	3667	1124300	2007-01-22	2007-01-22 00:00:00	2007-01-22	2007-01-22 00:00:00	\N	38000177		0	0	0		0	0	0	243970	0	00781178901	45011828		
137706	3023	40213314	1983-01-01	1983-01-01 00:00:00	1983-01-01	1983-01-01 00:00:00	1983-01-01	581452		0	0	0		0	0	0	201524	0	49	40213314		
8545	711	1713671	1994-03-21	1994-03-21 00:00:00	1994-03-28	1994-03-28 00:00:00	1994-03-28	38000177		0	0	7		0	0	0	47068	0	562251	1713671		
55208	1209	40213314	1978-02-16	1978-02-16 00:00:00	1978-02-16	1978-02-16 00:00:00	1978-02-16	581452		0	0	0		0	0	0	79427	0	49	40213314		
38794	3208	1118084	2011-04-21	2011-04-21 00:00:00	2011-04-21	2011-04-21 00:00:00	\N	38000177		0	0	0		0	0	0	213282	0	00025152531	44923712		
61151	5086	1127078	1970-10-20	1970-10-20 00:00:00	1970-11-10	1970-11-10 00:00:00	1970-11-10	38000177		0	0	21		0	0	0	338198	0	282464	1127078		
32250	2674	1127433	2007-03-23	2007-03-23 00:00:00	2007-03-30	2007-03-30 00:00:00	2007-03-30	38000177		0	0	7		0	0	0	177205	0	313782	1127433		
40126	3320	1118084	1999-02-02	1999-02-02 00:00:00	1999-02-02	1999-02-02 00:00:00	\N	38000177		0	0	0		0	0	0	220445	0	00025152531	44923712		
39952	870	40213227	2010-12-14	2010-12-14 00:00:00	2010-12-14	2010-12-14 00:00:00	2010-12-14	581452		0	0	0		0	0	0	57877	0	113	40213227		
16330	1354	1127433	2018-02-22	2018-02-22 00:00:00	2018-03-01	2018-03-01 00:00:00	2018-03-01	38000177		0	0	7		0	0	0	89766	0	313782	1127433		
10606	883	1127433	1975-09-30	1975-09-30 00:00:00	1975-10-14	1975-10-14 00:00:00	1975-10-14	38000177		0	0	14		0	0	0	58779	0	313782	1127433		
17169	1425	40165015	1954-06-24	1954-06-24 00:00:00	1954-06-24	1954-06-24 00:00:00	\N	38000177		0	0	0		0	0	0	94795	0	861467	40165015		
126850	2790	40213227	1994-01-20	1994-01-20 00:00:00	1994-01-20	1994-01-20 00:00:00	1994-01-20	581452		0	0	0		0	0	0	184863	0	113	40213227		
988	80	1127433	2018-04-03	2018-04-03 00:00:00	2018-04-10	2018-04-10 00:00:00	2018-04-10	38000177		0	0	7		0	0	0	5465	0	313782	1127433		
20295	1666	1124300	1976-11-14	1976-11-14 00:00:00	1976-11-14	1976-11-14 00:00:00	\N	38000177		0	0	0		0	0	0	111865	0	00781178901	45011828		
138237	3035	40213296	2004-10-08	2004-10-08 00:00:00	2004-10-08	2004-10-08 00:00:00	2004-10-08	581452		0	0	0		0	0	0	202201	0	52	40213296		
31770	2633	19059056	1951-01-19	1951-01-19 00:00:00	1951-02-02	1951-02-02 00:00:00	1951-02-02	38000177		0	0	14		0	0	0	174247	0	243670	19059056		
30926	2561	1127078	1981-08-02	1981-08-02 00:00:00	1981-08-23	1981-08-23 00:00:00	1981-08-23	38000177		0	0	21		0	0	0	169701	0	282464	1127078		
208	16	19059056	1972-04-10	1972-04-10 00:00:00	1972-04-24	1972-04-24 00:00:00	1972-04-24	38000177		0	0	14		0	0	0	1196	0	243670	19059056		
34526	2853	40229134	1964-08-16	1964-08-16 00:00:00	1964-08-30	1964-08-30 00:00:00	1964-08-30	38000177		0	0	14		0	0	0	189544	0	1043400	40229134		
25596	2103	40236824	2009-05-31	2009-05-31 00:00:00	2009-06-07	2009-06-07 00:00:00	2009-06-07	38000177		0	0	7		0	0	0	140163	0	1094107	40236824		
137172	3011	40213314	1977-12-13	1977-12-13 00:00:00	1977-12-13	1977-12-13 00:00:00	1977-12-13	581452		0	0	0		0	0	0	200836	0	49	40213314		
5263	114	40213160	1972-08-21	1972-08-21 00:00:00	1972-08-21	1972-08-21 00:00:00	1972-08-21	581452		0	0	0		0	0	0	7532	0	10	40213160		
36986	3059	1127078	1978-05-07	1978-05-07 00:00:00	1978-05-28	1978-05-28 00:00:00	1978-05-28	38000177		0	0	21		0	0	0	203532	0	282464	1127078		
218657	4799	40213227	1992-04-18	1992-04-18 00:00:00	1992-04-18	1992-04-18 00:00:00	1992-04-18	581452		0	0	0		0	0	0	319237	0	113	40213227		
218683	4799	40213160	1962-10-27	1962-10-27 00:00:00	1962-10-27	1962-10-27 00:00:00	1962-10-27	581452		0	0	0		0	0	0	319253	0	10	40213160		
9086	756	1127078	1974-02-18	1974-02-18 00:00:00	1974-05-19	1974-05-19 00:00:00	1974-05-19	38000177		0	0	90		0	0	0	50172	0	282464	1127078		
199034	4373	40213160	1976-04-13	1976-04-13 00:00:00	1976-04-13	1976-04-13 00:00:00	1976-04-13	581452		0	0	0		0	0	0	290399	0	10	40213160		
38940	3218	19006318	1957-10-23	1957-10-23 00:00:00	1957-11-06	1957-11-06 00:00:00	1957-11-06	38000177		0	0	14		0	0	0	213879	0	105078	19006318		
230171	5058	40213227	1998-11-22	1998-11-22 00:00:00	1998-11-22	1998-11-22 00:00:00	1998-11-22	581452		0	0	0		0	0	0	336268	0	113	40213227		
24341	2002	1127078	1982-07-02	1982-07-02 00:00:00	1982-08-06	1982-08-06 00:00:00	1982-08-06	38000177		0	0	35		0	0	0	133379	0	282464	1127078		
65592	1435	40213160	1961-10-28	1961-10-28 00:00:00	1961-10-28	1961-10-28 00:00:00	1961-10-28	581452		0	0	0		0	0	0	95552	0	10	40213160		
4706	393	1713671	2017-09-28	2017-09-28 00:00:00	2017-10-19	2017-10-19 00:00:00	2017-10-19	38000177		0	0	21		0	0	0	25811	0	562251	1713671		
51346	4268	19128065	1982-07-02	1982-07-02 00:00:00	1983-06-27	1983-06-27 00:00:00	1983-06-27	38000177		0	0	360		0	0	0	283251	0	749882	19128065		
46489	3851	19059056	1927-10-04	1927-10-04 00:00:00	1927-11-10	1927-11-10 00:00:00	1927-11-10	38000177		0	0	37		0	0	0	255592	0	243670	19059056		
13096	1099	19006318	1953-01-07	1953-01-07 00:00:00	1953-01-21	1953-01-21 00:00:00	1953-01-21	38000177		0	0	14		0	0	0	72190	0	105078	19006318		
46604	3859	19018935	2016-04-16	2016-04-16 00:00:00	2016-04-16	2016-04-16 00:00:00	\N	38000177		0	0	0		0	0	0	256182	0	197604	19018935		
208681	4577	40213251	1988-06-18	1988-06-18 00:00:00	1988-06-18	1988-06-18 00:00:00	1988-06-18	581452		0	0	0		0	0	0	304863	0	21	40213251		
29166	2414	40229134	1981-10-29	1981-10-29 00:00:00	1981-11-05	1981-11-05 00:00:00	1981-11-05	38000177		0	0	7		0	0	0	160223	0	1043400	40229134		
23714	1950	1124300	1978-12-17	1978-12-17 00:00:00	1978-12-17	1978-12-17 00:00:00	\N	38000177		0	0	0		0	0	0	129625	0	00781178901	45011828		
1091	90	1127433	1987-06-06	1987-06-06 00:00:00	1987-06-20	1987-06-20 00:00:00	1987-06-20	38000177		0	0	14		0	0	0	6049	0	313782	1127433		
14036	1174	1713671	1952-06-15	1952-06-15 00:00:00	1952-06-29	1952-06-29 00:00:00	1952-06-29	38000177		0	0	14		0	0	0	77390	0	562251	1713671		
18240	395	40213227	1994-03-15	1994-03-15 00:00:00	1994-03-15	1994-03-15 00:00:00	1994-03-15	581452		0	0	0		0	0	0	25967	0	113	40213227		
212959	4670	40213227	1995-07-19	1995-07-19 00:00:00	1995-07-19	1995-07-19 00:00:00	1995-07-19	581452		0	0	0		0	0	0	311143	0	113	40213227		
63884	5306	19133873	1983-12-03	1983-12-03 00:00:00	1983-12-14	1983-12-14 00:00:00	1983-12-14	38000177		0	0	11		0	0	0	352923	0	834061	19133873		
88266	1936	40213227	2018-06-22	2018-06-22 00:00:00	2018-06-22	2018-06-22 00:00:00	2018-06-22	581452		0	0	0		0	0	0	128783	0	113	40213227		
5632	472	1594382	1998-02-10	1998-02-10 00:00:00	1998-02-10	1998-02-10 00:00:00	\N	38000177		0	0	0		0	0	0	31515	0	1870230	1594382		
14496	1214	19059056	1947-10-08	1947-10-08 00:00:00	1947-11-05	1947-11-05 00:00:00	1947-11-05	38000177		0	0	28		0	0	0	80003	0	243670	19059056		
34798	2872	1127433	1988-01-03	1988-01-03 00:00:00	1988-01-10	1988-01-10 00:00:00	1988-01-10	38000177		0	0	7		0	0	0	191201	0	313782	1127433		
76397	1669	40213260	2009-03-16	2009-03-16 00:00:00	2009-03-16	2009-03-16 00:00:00	2009-03-16	581452		0	0	0		0	0	0	112088	0	121	40213260		
45331	3752	19128065	1976-11-12	1976-11-12 00:00:00	1977-11-07	1977-11-07 00:00:00	1977-11-07	38000177		0	0	360		0	0	0	249346	0	749882	19128065		
45363	3754	1713671	2011-01-18	2011-01-18 00:00:00	2011-02-01	2011-02-01 00:00:00	2011-02-01	38000177		0	0	14		0	0	0	249555	0	562251	1713671		
104249	2286	40213260	2007-09-03	2007-09-03 00:00:00	2007-09-03	2007-09-03 00:00:00	2007-09-03	581452		0	0	0		0	0	0	152044	0	121	40213260		
63142	1381	40213296	2019-05-11	2019-05-11 00:00:00	2019-05-11	2019-05-11 00:00:00	2019-05-11	581452		0	0	0		0	0	0	91603	0	52	40213296		
37398	3090	1127433	1980-09-10	1980-09-10 00:00:00	1980-10-01	1980-10-01 00:00:00	1980-10-01	38000177		0	0	21		0	0	0	205727	0	313782	1127433		
181864	3995	40213296	2014-05-24	2014-05-24 00:00:00	2014-05-24	2014-05-24 00:00:00	2014-05-24	581452		0	0	0		0	0	0	265611	0	52	40213296		
6346	533	1127433	1988-08-05	1988-08-05 00:00:00	1988-08-19	1988-08-19 00:00:00	1988-08-19	38000177		0	0	14		0	0	0	35370	0	313782	1127433		
55127	4577	19019979	1985-06-06	1985-06-06 00:00:00	1985-06-20	1985-06-20 00:00:00	1985-06-20	38000177		0	0	14		0	0	0	304891	0	198405	19019979		
8701	726	1713671	1986-12-12	1986-12-12 00:00:00	1986-12-19	1986-12-19 00:00:00	1986-12-19	38000177		0	0	7		0	0	0	48087	0	562251	1713671		
22880	1882	1118084	2004-07-22	2004-07-22 00:00:00	2004-07-22	2004-07-22 00:00:00	\N	38000177		0	0	0		0	0	0	125530	0	00025152531	44923712		
132639	2913	40213227	2017-07-15	2017-07-15 00:00:00	2017-07-15	2017-07-15 00:00:00	2017-07-15	581452		0	0	0		0	0	0	194120	0	113	40213227		
15911	1320	19077572	2016-10-13	2016-10-13 00:00:00	2016-10-13	2016-10-13 00:00:00	\N	38000177		0	0	0		0	0	0	87525	0	310436	19077572		
481	36	1713671	1972-09-19	1972-09-19 00:00:00	1972-10-03	1972-10-03 00:00:00	1972-10-03	38000177		0	0	14		0	0	0	2506	0	562251	1713671		
26464	2176	1127433	1994-12-25	1994-12-25 00:00:00	1995-01-29	1995-01-29 00:00:00	1995-01-29	38000177		0	0	35		0	0	0	145138	0	313782	1127433		
44298	3667	1127433	1985-11-14	1985-11-14 00:00:00	1985-11-21	1985-11-21 00:00:00	1985-11-21	38000177		0	0	7		0	0	0	243946	0	313782	1127433		
215154	4719	40213201	2001-09-16	2001-09-16 00:00:00	2001-09-16	2001-09-16 00:00:00	2001-09-16	581452		0	0	0		0	0	0	314211	0	33	40213201		
8546	711	19078461	1990-01-01	1990-01-01 00:00:00	1990-03-02	1990-03-02 00:00:00	1990-03-02	38000177		0	0	60		0	0	0	47199	0	310965	19078461		
55209	1209	40213160	1978-02-16	1978-02-16 00:00:00	1978-02-16	1978-02-16 00:00:00	1978-02-16	581452		0	0	0		0	0	0	79427	0	10	40213160		
38795	3208	19128065	1984-12-23	1984-12-23 00:00:00	1985-12-18	1985-12-18 00:00:00	1985-12-18	38000177		0	0	360		0	0	0	213275	0	749882	19128065		
61152	5086	1127078	1971-05-02	1971-05-02 00:00:00	1971-05-16	1971-05-16 00:00:00	1971-05-16	38000177		0	0	14		0	0	0	338184	0	282464	1127078		
32251	2674	1118084	2013-07-01	2013-07-01 00:00:00	2013-07-01	2013-07-01 00:00:00	\N	38000177		0	0	0		0	0	0	177181	0	00025152531	44923712		
40127	3321	40229134	2013-02-16	2013-02-16 00:00:00	2013-02-23	2013-02-23 00:00:00	2013-02-23	38000177		0	0	7		0	0	0	220496	0	1043400	40229134		
39953	870	40213260	2010-12-14	2010-12-14 00:00:00	2010-12-14	2010-12-14 00:00:00	2010-12-14	581452		0	0	0		0	0	0	57877	0	121	40213260		
16331	1354	40229134	1980-06-26	1980-06-26 00:00:00	1980-07-03	1980-07-03 00:00:00	1980-07-03	38000177		0	0	7		0	0	0	89723	0	1043400	40229134		
10607	883	40229134	1968-05-11	1968-05-11 00:00:00	1968-05-18	1968-05-18 00:00:00	1968-05-18	38000177		0	0	7		0	0	0	58792	0	1043400	40229134		
17170	1425	19059056	1938-06-13	1938-06-13 00:00:00	1938-06-27	1938-06-27 00:00:00	1938-06-27	38000177		0	0	14		0	0	0	94722	0	243670	19059056		
126855	2790	40213201	2019-05-16	2019-05-16 00:00:00	2019-05-16	2019-05-16 00:00:00	2019-05-16	581452		0	0	0		0	0	0	184937	0	33	40213201		
989	80	1118084	1974-09-16	1974-09-16 00:00:00	1974-09-16	1974-09-16 00:00:00	\N	38000177		0	0	0		0	0	0	5404	0	00025152531	44923712		
20296	1666	19133905	1994-06-07	1994-06-07 00:00:00	1994-06-17	1994-06-17 00:00:00	1994-06-17	38000177		0	0	10		0	0	0	111945	0	834102	19133905		
138242	3035	40213160	1964-03-27	1964-03-27 00:00:00	1964-03-27	1964-03-27 00:00:00	1964-03-27	581452		0	0	0		0	0	0	202176	0	10	40213160		
31771	2633	19006318	1951-01-19	1951-01-19 00:00:00	1951-02-02	1951-02-02 00:00:00	1951-02-02	38000177		0	0	14		0	0	0	174247	0	105078	19006318		
30927	2561	1127078	1980-10-14	1980-10-14 00:00:00	1980-10-28	1980-10-28 00:00:00	1980-10-28	38000177		0	0	14		0	0	0	169708	0	282464	1127078		
210	16	1713671	1987-04-25	1987-04-25 00:00:00	1987-05-16	1987-05-16 00:00:00	1987-05-16	38000177		0	0	21		0	0	0	1240	0	562251	1713671		
34527	2853	1127433	1982-07-03	1982-07-03 00:00:00	1982-07-24	1982-07-24 00:00:00	1982-07-24	38000177		0	0	21		0	0	0	189581	0	313782	1127433		
25597	2103	1118084	2010-09-21	2010-09-21 00:00:00	2010-09-21	2010-09-21 00:00:00	\N	38000177		0	0	0		0	0	0	140163	0	00025152531	44923712		
137181	3011	40213314	1978-06-13	1978-06-13 00:00:00	1978-06-13	1978-06-13 00:00:00	1978-06-13	581452		0	0	0		0	0	0	200828	0	49	40213314		
5266	114	40213306	1994-10-10	1994-10-10 00:00:00	1994-10-10	1994-10-10 00:00:00	1994-10-10	581452		0	0	0		0	0	0	7545	0	43	40213306		
36987	3059	1127433	1978-01-09	1978-01-09 00:00:00	1978-01-16	1978-01-16 00:00:00	1978-01-16	38000177		0	0	7		0	0	0	203473	0	313782	1127433		
218662	4799	40213260	2007-11-17	2007-11-17 00:00:00	2007-11-17	2007-11-17 00:00:00	2007-11-17	581452		0	0	0		0	0	0	319261	0	121	40213260		
218690	4799	40213160	1958-02-22	1958-02-22 00:00:00	1958-02-22	1958-02-22 00:00:00	1958-02-22	581452		0	0	0		0	0	0	319275	0	10	40213160		
9087	756	1127433	1981-04-01	1981-04-01 00:00:00	1981-04-08	1981-04-08 00:00:00	1981-04-08	38000177		0	0	7		0	0	0	50131	0	313782	1127433		
199036	4373	40213314	1977-12-13	1977-12-13 00:00:00	1977-12-13	1977-12-13 00:00:00	1977-12-13	581452		0	0	0		0	0	0	290334	0	49	40213314		
38941	3218	1127078	1957-10-23	1957-10-23 00:00:00	1957-11-06	1957-11-06 00:00:00	1957-11-06	38000177		0	0	14		0	0	0	213879	0	282464	1127078		
230180	5058	40213201	2003-12-21	2003-12-21 00:00:00	2003-12-21	2003-12-21 00:00:00	2003-12-21	581452		0	0	0		0	0	0	336324	0	33	40213201		
24342	2002	1127433	1996-02-09	1996-02-09 00:00:00	1996-02-16	1996-02-16 00:00:00	1996-02-16	38000177		0	0	7		0	0	0	133374	0	313782	1127433		
65595	1435	40213260	2011-04-09	2011-04-09 00:00:00	2011-04-09	2011-04-09 00:00:00	2011-04-09	581452		0	0	0		0	0	0	95540	0	121	40213260		
4708	393	40229134	1967-01-28	1967-01-28 00:00:00	1967-02-11	1967-02-11 00:00:00	1967-02-11	38000177		0	0	14		0	0	0	25761	0	1043400	40229134		
51347	4268	40229134	2011-12-12	2011-12-12 00:00:00	2011-12-19	2011-12-19 00:00:00	2011-12-19	38000177		0	0	7		0	0	0	283243	0	1043400	40229134		
46490	3851	40229134	1962-11-05	1962-11-05 00:00:00	1962-11-12	1962-11-12 00:00:00	1962-11-12	38000177		0	0	7		0	0	0	255601	0	1043400	40229134		
13097	1099	1127433	2007-05-23	2007-05-23 00:00:00	2007-06-06	2007-06-06 00:00:00	2007-06-06	38000177		0	0	14		0	0	0	72189	0	313782	1127433		
162088	3565	40213198	2010-12-11	2010-12-11 00:00:00	2010-12-11	2010-12-11 00:00:00	2010-12-11	581452		0	0	0		0	0	0	236764	0	133	40213198		
208685	4577	40213160	1983-10-15	1983-10-15 00:00:00	1983-10-15	1983-10-15 00:00:00	1983-10-15	581452		0	0	0		0	0	0	304862	0	10	40213160		
29167	2414	1118084	1957-04-14	1957-04-14 00:00:00	1957-04-14	1957-04-14 00:00:00	\N	38000177		0	0	0		0	0	0	160179	0	00025152531	44923712		
23715	1951	19074843	1982-10-05	1982-10-05 00:00:00	1982-10-19	1982-10-19 00:00:00	1982-10-19	38000177		0	0	14		0	0	0	129755	0	309045	19074843		
1092	90	19128065	1981-01-17	1981-01-17 00:00:00	1982-01-12	1982-01-12 00:00:00	1982-01-12	38000177		0	0	360		0	0	0	6051	0	749882	19128065		
14037	1174	1713671	2016-05-05	2016-05-05 00:00:00	2016-05-12	2016-05-12 00:00:00	2016-05-12	38000177		0	0	7		0	0	0	77348	0	562251	1713671		
18247	395	40213160	1960-07-26	1960-07-26 00:00:00	1960-07-26	1960-07-26 00:00:00	1960-07-26	581452		0	0	0		0	0	0	25992	0	10	40213160		
212965	4670	40213260	2006-08-23	2006-08-23 00:00:00	2006-08-23	2006-08-23 00:00:00	2006-08-23	581452		0	0	0		0	0	0	311223	0	121	40213260		
63897	5309	920300	1977-02-25	1977-02-25 00:00:00	1977-03-04	1977-03-04 00:00:00	1977-03-04	38000177		0	0	7		0	0	0	353062	0	311989	920300		
88272	1936	40213198	2012-05-18	2012-05-18 00:00:00	2012-05-18	2012-05-18 00:00:00	2012-05-18	581452		0	0	0		0	0	0	128781	0	133	40213198		
5633	472	40223834	1998-02-10	1998-02-10 00:00:00	1998-02-10	1998-02-10 00:00:00	\N	38000177		0	0	0		0	0	0	31515	0	997501	40223834		
14497	1215	1713671	1976-10-11	1976-10-11 00:00:00	1976-10-18	1976-10-18 00:00:00	1976-10-18	38000177		0	0	7		0	0	0	80024	0	562251	1713671		
34799	2872	40243436	1971-09-07	1971-09-07 00:00:00	1971-09-07	1971-09-07 00:00:00	1971-09-07	38000177		0	0	0		0	0	0	191205	0	1190795	40243436		
76402	1669	40213227	1993-11-15	1993-11-15 00:00:00	1993-11-15	1993-11-15 00:00:00	1993-11-15	581452		0	0	0		0	0	0	112114	0	113	40213227		
45332	3752	19128065	1979-10-28	1979-10-28 00:00:00	1980-10-22	1980-10-22 00:00:00	1980-10-22	38000177		0	0	360		0	0	0	249358	0	749882	19128065		
45364	3754	1127078	1968-03-24	1968-03-24 00:00:00	1968-04-21	1968-04-21 00:00:00	1968-04-21	38000177		0	0	28		0	0	0	249512	0	282464	1127078		
104265	2287	40213227	1992-03-13	1992-03-13 00:00:00	1992-03-13	1992-03-13 00:00:00	1992-03-13	581452		0	0	0		0	0	0	152182	0	113	40213227		
63146	1381	40213314	1978-11-11	1978-11-11 00:00:00	1978-11-11	1978-11-11 00:00:00	1978-11-11	581452		0	0	0		0	0	0	91596	0	49	40213314		
37399	3090	1127433	1994-11-17	1994-11-17 00:00:00	1994-12-08	1994-12-08 00:00:00	1994-12-08	38000177		0	0	21		0	0	0	205772	0	313782	1127433		
211755	4642	40213160	1957-11-05	1957-11-05 00:00:00	1957-11-05	1957-11-05 00:00:00	1957-11-05	581452		0	0	0		0	0	0	309461	0	10	40213160		
6347	533	920300	1991-08-31	1991-08-31 00:00:00	1991-09-07	1991-09-07 00:00:00	1991-09-07	38000177		0	0	7		0	0	0	35406	0	311989	920300		
55128	4577	19059056	1988-04-04	1988-04-04 00:00:00	1988-04-18	1988-04-18 00:00:00	1988-04-18	38000177		0	0	14		0	0	0	304909	0	243670	19059056		
8702	726	19059056	1969-02-07	1969-02-07 00:00:00	1969-05-08	1969-05-08 00:00:00	1969-05-08	38000177		0	0	90		0	0	0	48092	0	243670	19059056		
22881	1882	40165015	2015-04-09	2015-04-09 00:00:00	2015-04-09	2015-04-09 00:00:00	\N	38000177		0	0	0		0	0	0	125569	0	861467	40165015		
234187	5145	40213227	2007-06-30	2007-06-30 00:00:00	2007-06-30	2007-06-30 00:00:00	2007-06-30	581452		0	0	0		0	0	0	342057	0	113	40213227		
15912	1320	19078461	2019-05-25	2019-05-25 00:00:00	2019-06-15	2019-06-15 00:00:00	2019-06-15	38000177		0	0	21		0	0	0	87479	0	310965	19078461		
482	36	19128065	1977-09-21	1977-09-21 00:00:00	1978-09-16	1978-09-16 00:00:00	1978-09-16	38000177		0	0	360		0	0	0	2574	0	749882	19128065		
26465	2176	19128065	1975-07-22	1975-07-22 00:00:00	1976-07-16	1976-07-16 00:00:00	1976-07-16	38000177		0	0	360		0	0	0	145112	0	749882	19128065		
44299	3667	1127433	1985-02-02	1985-02-02 00:00:00	1985-02-16	1985-02-16 00:00:00	1985-02-16	38000177		0	0	14		0	0	0	243983	0	313782	1127433		
226452	4972	40213227	1992-08-01	1992-08-01 00:00:00	1992-08-01	1992-08-01 00:00:00	1992-08-01	581452		0	0	0		0	0	0	330737	0	113	40213227		
8547	711	1713671	1987-08-26	1987-08-26 00:00:00	1987-09-16	1987-09-16 00:00:00	1987-09-16	38000177		0	0	21		0	0	0	47166	0	562251	1713671		
63495	1389	40213296	1997-03-15	1997-03-15 00:00:00	1997-03-15	1997-03-15 00:00:00	1997-03-15	581452		0	0	0		0	0	0	92200	0	52	40213296		
38796	3208	1115171	2001-03-08	2001-03-08 00:00:00	2001-03-29	2001-03-29 00:00:00	2001-03-29	38000177		0	0	21		0	0	0	213248	0	849574	1115171		
61154	5086	19133873	1974-07-18	1974-07-18 00:00:00	1974-07-29	1974-07-29 00:00:00	1974-07-29	38000177		0	0	11		0	0	0	338157	0	834061	19133873		
32252	2674	1127433	1989-02-03	1989-02-03 00:00:00	1989-02-10	1989-02-10 00:00:00	1989-02-10	38000177		0	0	7		0	0	0	177226	0	313782	1127433		
40128	3321	1118084	2011-06-30	2011-06-30 00:00:00	2011-06-30	2011-06-30 00:00:00	\N	38000177		0	0	0		0	0	0	220513	0	00025152531	44923712		
39960	871	40213306	1988-12-20	1988-12-20 00:00:00	1988-12-20	1988-12-20 00:00:00	1988-12-20	581452		0	0	0		0	0	0	57938	0	43	40213306		
16332	1354	1127078	1986-06-24	1986-06-24 00:00:00	1986-07-08	1986-07-08 00:00:00	1986-07-08	38000177		0	0	14		0	0	0	89750	0	282464	1127078		
10608	883	40236824	2006-07-17	2006-07-17 00:00:00	2006-07-24	2006-07-24 00:00:00	2006-07-24	38000177		0	0	7		0	0	0	58774	0	1094107	40236824		
17171	1425	19059056	1937-01-19	1937-01-19 00:00:00	1937-02-02	1937-02-02 00:00:00	1937-02-02	38000177		0	0	14		0	0	0	94770	0	243670	19059056		
79490	1739	40213160	1968-12-19	1968-12-19 00:00:00	1968-12-19	1968-12-19 00:00:00	1968-12-19	581452		0	0	0		0	0	0	116223	0	10	40213160		
990	80	1127433	2013-12-29	2013-12-29 00:00:00	2014-01-12	2014-01-12 00:00:00	2014-01-12	38000177		0	0	14		0	0	0	5441	0	313782	1127433		
20297	1666	1713671	1994-05-17	1994-05-17 00:00:00	1994-05-31	1994-05-31 00:00:00	1994-05-31	38000177		0	0	14		0	0	0	111914	0	562251	1713671		
138243	3035	40213160	1968-11-29	1968-11-29 00:00:00	1968-11-29	1968-11-29 00:00:00	1968-11-29	581452		0	0	0		0	0	0	202221	0	10	40213160		
31772	2633	1127078	1950-03-16	1950-03-16 00:00:00	1950-03-30	1950-03-30 00:00:00	1950-03-30	38000177		0	0	14		0	0	0	174265	0	282464	1127078		
30928	2561	19074843	1980-10-14	1980-10-14 00:00:00	1980-10-28	1980-10-28 00:00:00	1980-10-28	38000177		0	0	14		0	0	0	169708	0	309045	19074843		
64158	5328	920300	1969-11-24	1969-11-24 00:00:00	1969-12-01	1969-12-01 00:00:00	1969-12-01	38000177		0	0	7		0	0	0	354620	0	311989	920300		
34528	2853	19078461	1980-05-23	1980-05-23 00:00:00	1980-06-13	1980-06-13 00:00:00	1980-06-13	38000177		0	0	21		0	0	0	189580	0	310965	19078461		
25598	2103	920300	2009-05-31	2009-05-31 00:00:00	2009-06-07	2009-06-07 00:00:00	2009-06-07	38000177		0	0	7		0	0	0	140163	0	311989	920300		
137185	3011	40213160	1974-12-17	1974-12-17 00:00:00	1974-12-17	1974-12-17 00:00:00	1974-12-17	581452		0	0	0		0	0	0	200817	0	10	40213160		
5268	114	40213227	1994-10-10	1994-10-10 00:00:00	1994-10-10	1994-10-10 00:00:00	1994-10-10	581452		0	0	0		0	0	0	7545	0	113	40213227		
36988	3059	1118084	2012-11-29	2012-11-29 00:00:00	2012-11-29	2012-11-29 00:00:00	\N	38000177		0	0	0		0	0	0	203513	0	00025152531	44923712		
218665	4799	40213227	2019-01-19	2019-01-19 00:00:00	2019-01-19	2019-01-19 00:00:00	2019-01-19	581452		0	0	0		0	0	0	319223	0	113	40213227		
218692	4799	40213296	1997-11-22	1997-11-22 00:00:00	1997-11-22	1997-11-22 00:00:00	1997-11-22	581452		0	0	0		0	0	0	319259	0	52	40213296		
9088	756	19073188	1985-04-12	1985-04-12 00:00:00	1985-04-26	1985-04-26 00:00:00	1985-04-26	38000177		0	0	14		0	0	0	50109	0	308192	19073188		
199038	4373	40213296	2016-01-12	2016-01-12 00:00:00	2016-01-12	2016-01-12 00:00:00	2016-01-12	581452		0	0	0		0	0	0	290446	0	52	40213296		
38942	3218	1127078	1966-01-09	1966-01-09 00:00:00	1966-01-30	1966-01-30 00:00:00	1966-01-30	38000177		0	0	21		0	0	0	213811	0	282464	1127078		
122008	2682	40213160	1978-03-17	1978-03-17 00:00:00	1978-03-17	1978-03-17 00:00:00	1978-03-17	581452		0	0	0		0	0	0	177728	0	10	40213160		
24343	2002	19019979	1986-05-24	1986-05-24 00:00:00	1986-07-23	1986-07-23 00:00:00	1986-07-23	38000177		0	0	60		0	0	0	133381	0	198405	19019979		
65600	1435	40213260	2012-04-14	2012-04-14 00:00:00	2012-04-14	2012-04-14 00:00:00	2012-04-14	581452		0	0	0		0	0	0	95533	0	121	40213260		
4709	393	1127433	1962-08-13	1962-08-13 00:00:00	1962-08-20	1962-08-20 00:00:00	1962-08-20	38000177		0	0	7		0	0	0	25760	0	313782	1127433		
51348	4268	1127433	1996-04-25	1996-04-25 00:00:00	1996-05-02	1996-05-02 00:00:00	1996-05-02	38000177		0	0	7		0	0	0	283278	0	313782	1127433		
46491	3851	40231925	1927-10-11	1927-10-11 00:00:00	1927-10-11	1927-10-11 00:00:00	\N	38000177		0	0	0		0	0	0	255559	0	1049221	40231925		
13098	1099	19059056	1969-06-12	1969-06-12 00:00:00	1969-07-03	1969-07-03 00:00:00	1969-07-03	38000177		0	0	21		0	0	0	72157	0	243670	19059056		
162097	3565	40213227	2016-01-09	2016-01-09 00:00:00	2016-01-09	2016-01-09 00:00:00	2016-01-09	581452		0	0	0		0	0	0	236773	0	113	40213227		
208686	4577	40213251	1984-09-15	1984-09-15 00:00:00	1984-09-15	1984-09-15 00:00:00	1984-09-15	581452		0	0	0		0	0	0	304875	0	21	40213251		
29168	2414	920300	1980-05-01	1980-05-01 00:00:00	1980-05-08	1980-05-08 00:00:00	1980-05-08	38000177		0	0	7		0	0	0	160222	0	311989	920300		
23716	1951	1127078	1982-10-05	1982-10-05 00:00:00	1982-10-19	1982-10-19 00:00:00	1982-10-19	38000177		0	0	14		0	0	0	129755	0	282464	1127078		
1093	90	1127433	1978-08-26	1978-08-26 00:00:00	1978-09-30	1978-09-30 00:00:00	1978-09-30	38000177		0	0	35		0	0	0	5998	0	313782	1127433		
14038	1174	19059056	1963-02-23	1963-02-23 00:00:00	1963-05-02	1963-05-02 00:00:00	1963-05-02	38000177		0	0	68		0	0	0	77373	0	243670	19059056		
18249	395	40213260	2010-02-16	2010-02-16 00:00:00	2010-02-16	2010-02-16 00:00:00	2010-02-16	581452		0	0	0		0	0	0	25940	0	121	40213260		
212970	4670	40213160	1959-03-11	1959-03-11 00:00:00	1959-03-11	1959-03-11 00:00:00	1959-03-11	581452		0	0	0		0	0	0	311182	0	10	40213160		
63898	5309	40236824	1977-02-25	1977-02-25 00:00:00	1977-03-04	1977-03-04 00:00:00	1977-03-04	38000177		0	0	7		0	0	0	353062	0	1094107	40236824		
88275	1936	40213227	1998-02-27	1998-02-27 00:00:00	1998-02-27	1998-02-27 00:00:00	1998-02-27	581452		0	0	0		0	0	0	128767	0	113	40213227		
5634	472	1124300	2018-10-06	2018-10-06 00:00:00	2018-10-06	2018-10-06 00:00:00	\N	38000177		0	0	0		0	0	0	31528	0	00781178901	45011828		
14498	1215	1115171	2001-12-16	2001-12-16 00:00:00	2002-01-06	2002-01-06 00:00:00	2002-01-06	38000177		0	0	21		0	0	0	80041	0	849574	1115171		
34800	2872	1310034	1971-09-07	1971-09-07 00:00:00	1971-09-07	1971-09-07 00:00:00	1971-09-07	38000177		0	0	0		0	0	0	191205	0	834357	1310034		
56703	4704	1118084	2010-07-25	2010-07-25 00:00:00	2010-07-25	2010-07-25 00:00:00	\N	38000177		0	0	0		0	0	0	313363	0	00025152531	44923712		
45334	3752	19059056	1959-08-04	1959-08-04 00:00:00	1959-09-03	1959-09-03 00:00:00	1959-09-03	38000177		0	0	30		0	0	0	249363	0	243670	19059056		
45365	3754	1127078	1964-12-24	1964-12-24 00:00:00	1965-01-07	1965-01-07 00:00:00	1965-01-07	38000177		0	0	14		0	0	0	249557	0	282464	1127078		
104271	2287	40213201	2006-06-02	2006-06-02 00:00:00	2006-06-02	2006-06-02 00:00:00	2006-06-02	581452		0	0	0		0	0	0	152147	0	33	40213201		
63147	1381	40213160	1978-11-11	1978-11-11 00:00:00	1978-11-11	1978-11-11 00:00:00	1978-11-11	581452		0	0	0		0	0	0	91596	0	10	40213160		
13500	292	40213296	2015-12-19	2015-12-19 00:00:00	2015-12-19	2015-12-19 00:00:00	2015-12-19	581452		0	0	0		0	0	0	19451	0	52	40213296		
187110	4109	40213160	1965-03-09	1965-03-09 00:00:00	1965-03-09	1965-03-09 00:00:00	1965-03-09	581452		0	0	0		0	0	0	273147	0	10	40213160		
6348	533	40236824	1991-08-31	1991-08-31 00:00:00	1991-09-07	1991-09-07 00:00:00	1991-09-07	38000177		0	0	7		0	0	0	35406	0	1094107	40236824		
55129	4577	19073183	1988-04-04	1988-04-04 00:00:00	1988-04-18	1988-04-18 00:00:00	1988-04-18	38000177		0	0	14		0	0	0	304909	0	308182	19073183		
49187	4081	19126352	2016-10-31	2016-10-31 00:00:00	2016-10-31	2016-10-31 00:00:00	\N	38000177		0	0	0		0	0	0	271302	0	705129	19126352		
22882	1882	1127433	2015-04-09	2015-04-09 00:00:00	2015-05-09	2015-05-09 00:00:00	2015-05-09	38000177		0	0	30		0	0	0	125569	0	313782	1127433		
234188	5145	40213260	2007-06-30	2007-06-30 00:00:00	2007-06-30	2007-06-30 00:00:00	2007-06-30	581452		0	0	0		0	0	0	342057	0	121	40213260		
15913	1320	1127433	1990-05-06	1990-05-06 00:00:00	1990-05-20	1990-05-20 00:00:00	1990-05-20	38000177		0	0	14		0	0	0	87515	0	313782	1127433		
483	36	19008572	1968-09-08	1968-09-08 00:00:00	1968-09-22	1968-09-22 00:00:00	1968-09-22	38000177		0	0	14		0	0	0	2513	0	106258	19008572		
26466	2176	19059056	1966-07-20	1966-07-20 00:00:00	1966-08-24	1966-08-24 00:00:00	1966-08-24	38000177		0	0	35		0	0	0	145136	0	243670	19059056		
44300	3667	1115171	2000-02-14	2000-02-14 00:00:00	2000-04-14	2000-04-14 00:00:00	2000-04-14	38000177		0	0	60		0	0	0	243978	0	849574	1115171		
180570	3968	40213227	1995-01-27	1995-01-27 00:00:00	1995-01-27	1995-01-27 00:00:00	1995-01-27	581452		0	0	0		0	0	0	263798	0	113	40213227		
8548	711	19059056	1955-05-30	1955-05-30 00:00:00	1955-06-13	1955-06-13 00:00:00	1955-06-13	38000177		0	0	14		0	0	0	47069	0	243670	19059056		
63497	1389	40213227	1997-03-15	1997-03-15 00:00:00	1997-03-15	1997-03-15 00:00:00	1997-03-15	581452		0	0	0		0	0	0	92200	0	113	40213227		
38797	3208	1127433	1997-01-11	1997-01-11 00:00:00	1997-01-25	1997-01-25 00:00:00	1997-01-25	38000177		0	0	14		0	0	0	213272	0	313782	1127433		
61155	5086	1124300	2010-02-27	2010-02-27 00:00:00	2010-02-27	2010-02-27 00:00:00	\N	38000177		0	0	0		0	0	0	338180	0	00781178901	45011828		
32253	2674	1127433	1971-05-25	1971-05-25 00:00:00	1971-06-01	1971-06-01 00:00:00	1971-06-01	38000177		0	0	7		0	0	0	177182	0	313782	1127433		
40129	3321	1127433	2013-05-11	2013-05-11 00:00:00	2013-07-10	2013-07-10 00:00:00	2013-07-10	38000177		0	0	60		0	0	0	220539	0	313782	1127433		
39966	871	40213160	1966-06-28	1966-06-28 00:00:00	1966-06-28	1966-06-28 00:00:00	1966-06-28	581452		0	0	0		0	0	0	57936	0	10	40213160		
16333	1354	1713671	1993-03-15	1993-03-15 00:00:00	1993-03-29	1993-03-29 00:00:00	1993-03-29	38000177		0	0	14		0	0	0	89759	0	562251	1713671		
10609	883	920300	2006-07-17	2006-07-17 00:00:00	2006-07-24	2006-07-24 00:00:00	2006-07-24	38000177		0	0	7		0	0	0	58774	0	311989	920300		
17172	1425	19059056	1939-10-20	1939-10-20 00:00:00	1939-11-03	1939-11-03 00:00:00	1939-11-03	38000177		0	0	14		0	0	0	94747	0	243670	19059056		
79493	1739	40213296	2008-04-17	2008-04-17 00:00:00	2008-04-17	2008-04-17 00:00:00	2008-04-17	581452		0	0	0		0	0	0	116198	0	52	40213296		
991	80	1127433	1988-09-12	1988-09-12 00:00:00	1988-10-17	1988-10-17 00:00:00	1988-10-17	38000177		0	0	35		0	0	0	5434	0	313782	1127433		
20298	1666	19059056	1935-06-03	1935-06-03 00:00:00	1935-06-17	1935-06-17 00:00:00	1935-06-17	38000177		0	0	14		0	0	0	111935	0	243670	19059056		
138249	3035	40213160	1964-08-28	1964-08-28 00:00:00	1964-08-28	1964-08-28 00:00:00	1964-08-28	581452		0	0	0		0	0	0	202177	0	10	40213160		
31773	2633	19006318	1950-03-16	1950-03-16 00:00:00	1950-03-30	1950-03-30 00:00:00	1950-03-30	38000177		0	0	14		0	0	0	174265	0	105078	19006318		
30929	2561	1118084	2017-08-08	2017-08-08 00:00:00	2017-08-08	2017-08-08 00:00:00	\N	38000177		0	0	0		0	0	0	169699	0	00025152531	44923712		
64159	5328	40236824	1969-11-24	1969-11-24 00:00:00	1969-12-01	1969-12-01 00:00:00	1969-12-01	38000177		0	0	7		0	0	0	354620	0	1094107	40236824		
44987	3721	1127078	1964-03-14	1964-03-14 00:00:00	1964-03-28	1964-03-28 00:00:00	1964-03-28	38000177		0	0	14		0	0	0	247391	0	282464	1127078		
25599	2103	19078461	2002-08-18	2002-08-18 00:00:00	2002-09-08	2002-09-08 00:00:00	2002-09-08	38000177		0	0	21		0	0	0	140124	0	310965	19078461		
137189	3011	40213160	1975-03-18	1975-03-18 00:00:00	1975-03-18	1975-03-18 00:00:00	1975-03-18	581452		0	0	0		0	0	0	200841	0	10	40213160		
5271	114	40213296	2014-06-02	2014-06-02 00:00:00	2014-06-02	2014-06-02 00:00:00	2014-06-02	581452		0	0	0		0	0	0	7538	0	52	40213296		
36989	3059	19078461	2012-06-28	2012-06-28 00:00:00	2012-07-19	2012-07-19 00:00:00	2012-07-19	38000177		0	0	21		0	0	0	203513	0	310965	19078461		
218672	4799	40213227	1999-11-27	1999-11-27 00:00:00	1999-11-27	1999-11-27 00:00:00	1999-11-27	581452		0	0	0		0	0	0	319238	0	113	40213227		
218698	4799	40213227	2008-11-22	2008-11-22 00:00:00	2008-11-22	2008-11-22 00:00:00	2008-11-22	581452		0	0	0		0	0	0	319249	0	113	40213227		
9089	756	1127433	1985-04-12	1985-04-12 00:00:00	1985-04-26	1985-04-26 00:00:00	1985-04-26	38000177		0	0	14		0	0	0	50109	0	313782	1127433		
199040	4373	40213160	1976-06-15	1976-06-15 00:00:00	1976-06-15	1976-06-15 00:00:00	1976-06-15	581452		0	0	0		0	0	0	290332	0	10	40213160		
38943	3218	1713671	1992-03-27	1992-03-27 00:00:00	1992-04-17	1992-04-17 00:00:00	1992-04-17	38000177		0	0	21		0	0	0	213824	0	562251	1713671		
15731	339	40213314	1983-01-22	1983-01-22 00:00:00	1983-01-22	1983-01-22 00:00:00	1983-01-22	581452		0	0	0		0	0	0	22644	0	49	40213314		
24344	2002	1127433	1980-05-17	1980-05-17 00:00:00	1980-05-31	1980-05-31 00:00:00	1980-05-31	38000177		0	0	14		0	0	0	133324	0	313782	1127433		
65602	1435	40213227	2012-04-14	2012-04-14 00:00:00	2012-04-14	2012-04-14 00:00:00	2012-04-14	581452		0	0	0		0	0	0	95533	0	113	40213227		
4710	393	1127433	1998-09-06	1998-09-06 00:00:00	1998-09-20	1998-09-20 00:00:00	1998-09-20	38000177		0	0	14		0	0	0	25774	0	313782	1127433		
51349	4268	1127433	1980-01-25	1980-01-25 00:00:00	1980-02-08	1980-02-08 00:00:00	1980-02-08	38000177		0	0	14		0	0	0	283211	0	313782	1127433		
46492	3851	19059056	1913-11-05	1913-11-05 00:00:00	1913-11-19	1913-11-19 00:00:00	1913-11-19	38000177		0	0	14		0	0	0	255498	0	243670	19059056		
13099	1099	46233710	1977-05-09	1977-05-09 00:00:00	1977-05-23	1977-05-23 00:00:00	1977-05-23	38000177		0	0	14		0	0	0	72191	0	1650142	46233710		
162111	3565	40213227	2005-11-12	2005-11-12 00:00:00	2005-11-12	2005-11-12 00:00:00	2005-11-12	581452		0	0	0		0	0	0	236758	0	113	40213227		
208687	4577	40213314	1983-10-15	1983-10-15 00:00:00	1983-10-15	1983-10-15 00:00:00	1983-10-15	581452		0	0	0		0	0	0	304862	0	49	40213314		
29169	2414	40236824	1980-05-01	1980-05-01 00:00:00	1980-05-08	1980-05-08 00:00:00	1980-05-08	38000177		0	0	7		0	0	0	160222	0	1094107	40236824		
23717	1951	19133873	1991-04-25	1991-04-25 00:00:00	1991-05-08	1991-05-08 00:00:00	1991-05-08	38000177		0	0	13		0	0	0	129776	0	834061	19133873		
1094	90	1115171	2009-06-10	2009-06-10 00:00:00	2009-06-24	2009-06-24 00:00:00	2009-06-24	38000177		0	0	14		0	0	0	6000	0	849574	1115171		
14039	1174	1127433	2016-05-29	2016-05-29 00:00:00	2016-06-12	2016-06-12 00:00:00	2016-06-12	38000177		0	0	14		0	0	0	77365	0	313782	1127433		
18252	395	40213160	1960-05-24	1960-05-24 00:00:00	1960-05-24	1960-05-24 00:00:00	1960-05-24	581452		0	0	0		0	0	0	25933	0	10	40213160		
24593	2025	1127433	1979-09-01	1979-09-01 00:00:00	1979-10-31	1979-10-31 00:00:00	1979-10-31	38000177		0	0	60		0	0	0	134742	0	313782	1127433		
63899	5309	19059056	1962-01-22	1962-01-22 00:00:00	1962-03-23	1962-03-23 00:00:00	1962-03-23	38000177		0	0	60		0	0	0	353145	0	243670	19059056		
88279	1936	40213227	2008-04-25	2008-04-25 00:00:00	2008-04-25	2008-04-25 00:00:00	2008-04-25	581452		0	0	0		0	0	0	128824	0	113	40213227		
5635	472	19133873	1983-12-16	1983-12-16 00:00:00	1983-12-25	1983-12-25 00:00:00	1983-12-25	38000177		0	0	9		0	0	0	31513	0	834061	19133873		
14499	1215	1115171	1998-09-19	1998-09-19 00:00:00	1998-11-18	1998-11-18 00:00:00	1998-11-18	38000177		0	0	60		0	0	0	80039	0	849574	1115171		
199805	4388	40213160	1971-07-31	1971-07-31 00:00:00	1971-07-31	1971-07-31 00:00:00	1971-07-31	581452		0	0	0		0	0	0	291733	0	10	40213160		
56704	4704	1127433	1998-04-13	1998-04-13 00:00:00	1998-04-27	1998-04-27 00:00:00	1998-04-27	38000177		0	0	14		0	0	0	313432	0	313782	1127433		
45335	3752	1127078	1959-06-05	1959-06-05 00:00:00	1959-06-19	1959-06-19 00:00:00	1959-06-19	38000177		0	0	14		0	0	0	249323	0	282464	1127078		
45366	3754	19133905	1990-03-03	1990-03-03 00:00:00	1990-03-14	1990-03-14 00:00:00	1990-03-14	38000177		0	0	11		0	0	0	249446	0	834102	19133905		
104288	2287	40213227	2011-07-01	2011-07-01 00:00:00	2011-07-01	2011-07-01 00:00:00	2011-07-01	581452		0	0	0		0	0	0	152191	0	113	40213227		
63150	1381	40213160	1983-05-14	1983-05-14 00:00:00	1983-05-14	1983-05-14 00:00:00	1983-05-14	581452		0	0	0		0	0	0	91598	0	10	40213160		
13502	292	40213314	1977-02-19	1977-02-19 00:00:00	1977-02-19	1977-02-19 00:00:00	1977-02-19	581452		0	0	0		0	0	0	19473	0	49	40213314		
187119	4109	40213160	1965-05-11	1965-05-11 00:00:00	1965-05-11	1965-05-11 00:00:00	1965-05-11	581452		0	0	0		0	0	0	273129	0	10	40213160		
6349	533	1713671	2000-07-01	2000-07-01 00:00:00	2000-07-22	2000-07-22 00:00:00	2000-07-22	38000177		0	0	21		0	0	0	35489	0	562251	1713671		
55130	4577	1127078	1983-08-08	1983-08-08 00:00:00	1983-08-22	1983-08-22 00:00:00	1983-08-22	38000177		0	0	14		0	0	0	304890	0	282464	1127078		
49188	4081	19075601	2016-10-31	2016-10-31 00:00:00	2016-10-31	2016-10-31 00:00:00	\N	38000177		0	0	0		0	0	0	271302	0	309362	19075601		
22883	1882	19059056	1969-09-04	1969-09-04 00:00:00	1969-09-18	1969-09-18 00:00:00	1969-09-18	38000177		0	0	14		0	0	0	125493	0	243670	19059056		
234214	5146	40213227	2018-07-09	2018-07-09 00:00:00	2018-07-09	2018-07-09 00:00:00	2018-07-09	581452		0	0	0		0	0	0	342096	0	113	40213227		
15914	1320	1127433	1985-10-11	1985-10-11 00:00:00	1985-10-18	1985-10-18 00:00:00	1985-10-18	38000177		0	0	7		0	0	0	87483	0	313782	1127433		
484	36	19078461	2001-03-23	2001-03-23 00:00:00	2001-04-29	2001-04-29 00:00:00	2001-04-29	38000177		0	0	37		0	0	0	2611	0	310965	19078461		
26467	2176	1127433	1959-01-08	1959-01-08 00:00:00	1959-01-22	1959-01-22 00:00:00	1959-01-22	38000177		0	0	14		0	0	0	145122	0	313782	1127433		
44301	3667	40236824	2000-07-31	2000-07-31 00:00:00	2000-08-07	2000-08-07 00:00:00	2000-08-07	38000177		0	0	7		0	0	0	243985	0	1094107	40236824		
180573	3968	40213227	2005-03-25	2005-03-25 00:00:00	2005-03-25	2005-03-25 00:00:00	2005-03-25	581452		0	0	0		0	0	0	263872	0	113	40213227		
8549	711	19006318	1955-05-30	1955-05-30 00:00:00	1955-06-13	1955-06-13 00:00:00	1955-06-13	38000177		0	0	14		0	0	0	47069	0	105078	19006318		
63503	1389	40213160	1955-08-13	1955-08-13 00:00:00	1955-08-13	1955-08-13 00:00:00	1955-08-13	581452		0	0	0		0	0	0	92183	0	10	40213160		
38798	3208	1127433	1986-04-07	1986-04-07 00:00:00	1986-05-12	1986-05-12 00:00:00	1986-05-12	38000177		0	0	35		0	0	0	213246	0	313782	1127433		
61156	5086	19078461	2003-02-20	2003-02-20 00:00:00	2003-03-27	2003-03-27 00:00:00	2003-03-27	38000177		0	0	35		0	0	0	338200	0	310965	19078461		
32254	2675	1115171	1996-10-20	1996-10-20 00:00:00	1996-11-10	1996-11-10 00:00:00	1996-11-10	38000177		0	0	21		0	0	0	177235	0	849574	1115171		
40130	3321	40162522	2013-05-11	2013-05-11 00:00:00	2013-05-11	2013-05-11 00:00:00	\N	38000177		0	0	0		0	0	0	220539	0	857005	40162522		
39969	871	40213227	2008-01-29	2008-01-29 00:00:00	2008-01-29	2008-01-29 00:00:00	2008-01-29	581452		0	0	0		0	0	0	57953	0	113	40213227		
16334	1354	1127433	1998-04-18	1998-04-18 00:00:00	1998-05-02	1998-05-02 00:00:00	1998-05-02	38000177		0	0	14		0	0	0	89747	0	313782	1127433		
10610	883	19078461	2008-03-24	2008-03-24 00:00:00	2008-04-07	2008-04-07 00:00:00	2008-04-07	38000177		0	0	14		0	0	0	58780	0	310965	19078461		
17173	1425	40229134	1996-04-17	1996-04-17 00:00:00	1996-04-24	1996-04-24 00:00:00	1996-04-24	38000177		0	0	7		0	0	0	94746	0	1043400	40229134		
79497	1739	40213227	1999-04-22	1999-04-22 00:00:00	1999-04-22	1999-04-22 00:00:00	1999-04-22	581452		0	0	0		0	0	0	116196	0	113	40213227		
992	80	1713671	1955-04-18	1955-04-18 00:00:00	1955-05-09	1955-05-09 00:00:00	1955-05-09	38000177		0	0	21		0	0	0	5399	0	562251	1713671		
20299	1666	19059056	1940-02-07	1940-02-07 00:00:00	1940-02-28	1940-02-28 00:00:00	1940-02-28	38000177		0	0	21		0	0	0	111875	0	243670	19059056		
106773	2341	40213227	2013-05-02	2013-05-02 00:00:00	2013-05-02	2013-05-02 00:00:00	2013-05-02	581452		0	0	0		0	0	0	155799	0	113	40213227		
31774	2633	19133873	1957-08-28	1957-08-28 00:00:00	1957-09-09	1957-09-09 00:00:00	1957-09-09	38000177		0	0	12		0	0	0	174193	0	834061	19133873		
30930	2561	1115171	1998-03-27	1998-03-27 00:00:00	1998-04-10	1998-04-10 00:00:00	1998-04-10	38000177		0	0	14		0	0	0	169702	0	849574	1115171		
64160	5328	1124300	1945-04-08	1945-04-08 00:00:00	1945-04-08	1945-04-08 00:00:00	\N	38000177		0	0	0		0	0	0	354727	0	00781178901	45011828		
44988	3721	19006318	1964-03-14	1964-03-14 00:00:00	1964-03-28	1964-03-28 00:00:00	1964-03-28	38000177		0	0	14		0	0	0	247391	0	105078	19006318		
25600	2103	19133905	2015-04-01	2015-04-01 00:00:00	2015-04-09	2015-04-09 00:00:00	2015-04-09	38000177		0	0	8		0	0	0	140138	0	834102	19133905		
120729	2654	40213201	2010-10-14	2010-10-14 00:00:00	2010-10-14	2010-10-14 00:00:00	2010-10-14	581452		0	0	0		0	0	0	175700	0	33	40213201		
5277	115	40213306	1981-12-13	1981-12-13 00:00:00	1981-12-13	1981-12-13 00:00:00	1981-12-13	581452		0	0	0		0	0	0	7644	0	43	40213306		
36990	3060	40229134	1968-02-25	1968-02-25 00:00:00	1968-03-03	1968-03-03 00:00:00	1968-03-03	38000177		0	0	7		0	0	0	203609	0	1043400	40229134		
218673	4799	40213296	1999-11-27	1999-11-27 00:00:00	1999-11-27	1999-11-27 00:00:00	1999-11-27	581452		0	0	0		0	0	0	319238	0	52	40213296		
218699	4799	40213260	2008-11-22	2008-11-22 00:00:00	2008-11-22	2008-11-22 00:00:00	2008-11-22	581452		0	0	0		0	0	0	319249	0	121	40213260		
9090	756	19128065	1981-07-21	1981-07-21 00:00:00	1982-07-16	1982-07-16 00:00:00	1982-07-16	38000177		0	0	360		0	0	0	50123	0	749882	19128065		
199042	4373	40213314	1977-03-15	1977-03-15 00:00:00	1977-03-15	1977-03-15 00:00:00	1977-03-15	581452		0	0	0		0	0	0	290333	0	49	40213314		
38944	3218	1124300	1992-10-04	1992-10-04 00:00:00	1992-10-04	1992-10-04 00:00:00	\N	38000177		0	0	0		0	0	0	213824	0	00781178901	45011828		
15732	339	40213160	1983-01-22	1983-01-22 00:00:00	1983-01-22	1983-01-22 00:00:00	1983-01-22	581452		0	0	0		0	0	0	22644	0	10	40213160		
24345	2002	1127433	2010-04-19	2010-04-19 00:00:00	2010-04-26	2010-04-26 00:00:00	2010-04-26	38000177		0	0	7		0	0	0	133376	0	313782	1127433		
7919	662	1127433	1976-01-01	1976-01-01 00:00:00	1976-01-15	1976-01-15 00:00:00	1976-01-15	38000177		0	0	14		0	0	0	43697	0	313782	1127433		
4711	394	1124300	1957-06-10	1957-06-10 00:00:00	1957-06-10	1957-06-10 00:00:00	\N	38000177		0	0	0		0	0	0	25848	0	00781178901	45011828		
51350	4268	1127433	1971-01-30	1971-01-30 00:00:00	1971-02-13	1971-02-13 00:00:00	1971-02-13	38000177		0	0	14		0	0	0	283218	0	313782	1127433		
46493	3851	19059056	1913-05-20	1913-05-20 00:00:00	1913-06-03	1913-06-03 00:00:00	1913-06-03	38000177		0	0	14		0	0	0	255565	0	243670	19059056		
13100	1099	1127433	1977-05-09	1977-05-09 00:00:00	1977-05-23	1977-05-23 00:00:00	1977-05-23	38000177		0	0	14		0	0	0	72191	0	313782	1127433		
162117	3566	40213198	2016-08-29	2016-08-29 00:00:00	2016-08-29	2016-08-29 00:00:00	2016-08-29	581452		0	0	0		0	0	0	236931	0	133	40213198		
208688	4577	40213314	1984-09-15	1984-09-15 00:00:00	1984-09-15	1984-09-15 00:00:00	1984-09-15	581452		0	0	0		0	0	0	304875	0	49	40213314		
29170	2414	19059056	1924-01-03	1924-01-03 00:00:00	1924-01-17	1924-01-17 00:00:00	1924-01-17	38000177		0	0	14		0	0	0	160229	0	243670	19059056		
23718	1951	1115171	2015-04-11	2015-04-11 00:00:00	2015-07-10	2015-07-10 00:00:00	2015-07-10	38000177		0	0	90		0	0	0	129773	0	849574	1115171		
38910	850	40213198	2012-05-15	2012-05-15 00:00:00	2012-05-15	2012-05-15 00:00:00	2012-05-15	581452		0	0	0		0	0	0	56205	0	133	40213198		
14040	1174	40236824	1967-02-07	1967-02-07 00:00:00	1967-02-14	1967-02-14 00:00:00	1967-02-14	38000177		0	0	7		0	0	0	77304	0	1094107	40236824		
18255	395	40213296	2000-02-22	2000-02-22 00:00:00	2000-02-22	2000-02-22 00:00:00	2000-02-22	581452		0	0	0		0	0	0	25983	0	52	40213296		
24594	2025	40171902	1981-12-26	1981-12-26 00:00:00	1981-12-26	1981-12-26 00:00:00	\N	38000177		0	0	0		0	0	0	134675	0	897718	40171902		
63900	5309	1332419	1995-05-01	1995-05-01 00:00:00	1995-05-01	1995-05-01 00:00:00	\N	38000177		0	0	0		0	0	0	353108	0	197361	1332419		
88297	1936	40213160	1955-02-18	1955-02-18 00:00:00	1955-02-18	1955-02-18 00:00:00	1955-02-18	581452		0	0	0		0	0	0	128797	0	10	40213160		
5636	472	19074841	1992-06-29	1992-06-29 00:00:00	1992-07-13	1992-07-13 00:00:00	1992-07-13	38000177		0	0	14		0	0	0	31546	0	309043	19074841		
14500	1215	40231925	1998-09-19	1998-09-19 00:00:00	1998-09-19	1998-09-19 00:00:00	\N	38000177		0	0	0		0	0	0	80039	0	1049221	40231925		
199810	4388	40213296	2010-05-15	2010-05-15 00:00:00	2010-05-15	2010-05-15 00:00:00	2010-05-15	581452		0	0	0		0	0	0	291682	0	52	40213296		
56705	4704	40236824	2000-01-04	2000-01-04 00:00:00	2000-01-18	2000-01-18 00:00:00	2000-01-18	38000177		0	0	14		0	0	0	313420	0	1094107	40236824		
45336	3752	19006318	1959-06-05	1959-06-05 00:00:00	1959-06-19	1959-06-19 00:00:00	1959-06-19	38000177		0	0	14		0	0	0	249323	0	105078	19006318		
45367	3754	1713671	1995-12-31	1995-12-31 00:00:00	1996-01-14	1996-01-14 00:00:00	1996-01-14	38000177		0	0	14		0	0	0	249462	0	562251	1713671		
70267	1537	40213260	2007-06-20	2007-06-20 00:00:00	2007-06-20	2007-06-20 00:00:00	2007-06-20	581452		0	0	0		0	0	0	102872	0	121	40213260		
63152	1381	40213160	1979-02-10	1979-02-10 00:00:00	1979-02-10	1979-02-10 00:00:00	1979-02-10	581452		0	0	0		0	0	0	91591	0	10	40213160		
13504	292	40213160	1976-03-20	1976-03-20 00:00:00	1976-03-20	1976-03-20 00:00:00	1976-03-20	581452		0	0	0		0	0	0	19434	0	10	40213160		
204176	4482	40213198	2015-09-26	2015-09-26 00:00:00	2015-09-26	2015-09-26 00:00:00	2015-09-26	581452		0	0	0		0	0	0	298420	0	133	40213198		
6350	533	19059056	1963-06-27	1963-06-27 00:00:00	1963-08-26	1963-08-26 00:00:00	1963-08-26	38000177		0	0	60		0	0	0	35367	0	243670	19059056		
55131	4577	19073183	1983-08-08	1983-08-08 00:00:00	1983-08-22	1983-08-22 00:00:00	1983-08-22	38000177		0	0	14		0	0	0	304890	0	308182	19073183		
49189	4081	1539411	2016-10-31	2016-10-31 00:00:00	2016-10-31	2016-10-31 00:00:00	\N	38000177		0	0	0		0	0	0	271302	0	312961	1539411		
22884	1882	46233988	1969-09-04	1969-09-04 00:00:00	1969-09-18	1969-09-18 00:00:00	1969-09-18	38000177		0	0	14		0	0	0	125493	0	1652673	46233988		
234221	5146	40213198	2011-10-31	2011-10-31 00:00:00	2011-10-31	2011-10-31 00:00:00	2011-10-31	581452		0	0	0		0	0	0	342125	0	133	40213198		
15915	1321	1127078	1960-05-27	1960-05-27 00:00:00	1960-06-17	1960-06-17 00:00:00	1960-06-17	38000177		0	0	21		0	0	0	87679	0	282464	1127078		
485	36	1713671	1969-05-04	1969-05-04 00:00:00	1969-05-18	1969-05-18 00:00:00	1969-05-18	38000177		0	0	14		0	0	0	2505	0	562251	1713671		
26468	2177	1127433	1971-04-16	1971-04-16 00:00:00	1971-04-23	1971-04-23 00:00:00	1971-04-23	38000177		0	0	7		0	0	0	145187	0	313782	1127433		
44302	3667	920300	2000-07-31	2000-07-31 00:00:00	2000-08-07	2000-08-07 00:00:00	2000-08-07	38000177		0	0	7		0	0	0	243985	0	311989	920300		
216900	4759	40213160	1977-07-26	1977-07-26 00:00:00	1977-07-26	1977-07-26 00:00:00	1977-07-26	581452		0	0	0		0	0	0	317042	0	10	40213160		
8550	711	1118084	1991-06-30	1991-06-30 00:00:00	1991-06-30	1991-06-30 00:00:00	\N	38000177		0	0	0		0	0	0	47149	0	00025152531	44923712		
63505	1389	40213160	1955-06-11	1955-06-11 00:00:00	1955-06-11	1955-06-11 00:00:00	1955-06-11	581452		0	0	0		0	0	0	92153	0	10	40213160		
38799	3208	1539411	2008-01-18	2008-01-18 00:00:00	2008-01-18	2008-01-18 00:00:00	\N	38000177		0	0	0		0	0	0	213281	0	312961	1539411		
4378	94	40213227	1993-07-23	1993-07-23 00:00:00	1993-07-23	1993-07-23 00:00:00	1993-07-23	581452		0	0	0		0	0	0	6332	0	113	40213227		
32255	2675	1127078	1966-01-22	1966-01-22 00:00:00	1966-02-05	1966-02-05 00:00:00	1966-02-05	38000177		0	0	14		0	0	0	177302	0	282464	1127078		
199122	4375	40213227	1999-05-16	1999-05-16 00:00:00	1999-05-16	1999-05-16 00:00:00	1999-05-16	581452		0	0	0		0	0	0	290595	0	113	40213227		
39970	871	40213296	2008-01-29	2008-01-29 00:00:00	2008-01-29	2008-01-29 00:00:00	2008-01-29	581452		0	0	0		0	0	0	57953	0	52	40213296		
16335	1354	1713671	2009-11-23	2009-11-23 00:00:00	2009-11-30	2009-11-30 00:00:00	2009-11-30	38000177		0	0	7		0	0	0	89728	0	562251	1713671		
10611	883	40229134	2008-06-28	2008-06-28 00:00:00	2008-07-05	2008-07-05 00:00:00	2008-07-05	38000177		0	0	7		0	0	0	58777	0	1043400	40229134		
17174	1425	40229134	1946-08-01	1946-08-01 00:00:00	1946-08-15	1946-08-15 00:00:00	1946-08-15	38000177		0	0	14		0	0	0	94768	0	1043400	40229134		
79506	1740	40213198	2017-12-02	2017-12-02 00:00:00	2017-12-02	2017-12-02 00:00:00	2017-12-02	581452		0	0	0		0	0	0	116289	0	133	40213198		
993	80	1127433	1975-10-16	1975-10-16 00:00:00	1975-10-23	1975-10-23 00:00:00	1975-10-23	38000177		0	0	7		0	0	0	5440	0	313782	1127433		
20300	1666	19133873	1944-11-01	1944-11-01 00:00:00	1944-11-10	1944-11-10 00:00:00	1944-11-10	38000177		0	0	9		0	0	0	111932	0	834061	19133873		
106780	2341	40213160	1957-01-03	1957-01-03 00:00:00	1957-01-03	1957-01-03 00:00:00	1957-01-03	581452		0	0	0		0	0	0	155779	0	10	40213160		
31775	2633	19059056	1948-05-13	1948-05-13 00:00:00	1948-05-27	1948-05-27 00:00:00	1948-05-27	38000177		0	0	14		0	0	0	174264	0	243670	19059056		
30931	2561	19128022	1994-10-03	1994-10-03 00:00:00	1995-09-28	1995-09-28 00:00:00	1995-09-28	38000177		0	0	360		0	0	0	169716	0	749785	19128022		
64161	5328	920300	1966-10-09	1966-10-09 00:00:00	1966-10-16	1966-10-16 00:00:00	1966-10-16	38000177		0	0	7		0	0	0	354708	0	311989	920300		
44989	3721	40229134	1968-11-28	1968-11-28 00:00:00	1968-12-12	1968-12-12 00:00:00	1968-12-12	38000177		0	0	14		0	0	0	247350	0	1043400	40229134		
25601	2103	19019979	1975-02-27	1975-02-27 00:00:00	1975-05-28	1975-05-28 00:00:00	1975-05-28	38000177		0	0	90		0	0	0	140121	0	198405	19019979		
120730	2654	40213198	2010-10-14	2010-10-14 00:00:00	2010-10-14	2010-10-14 00:00:00	2010-10-14	581452		0	0	0		0	0	0	175700	0	133	40213198		
159229	3505	40213227	1998-06-05	1998-06-05 00:00:00	1998-06-05	1998-06-05 00:00:00	1998-06-05	581452		0	0	0		0	0	0	232431	0	113	40213227		
36991	3060	19059056	1945-09-05	1945-09-05 00:00:00	1945-10-12	1945-10-12 00:00:00	1945-10-12	38000177		0	0	37		0	0	0	203626	0	243670	19059056		
170595	3750	40213160	1960-07-02	1960-07-02 00:00:00	1960-07-02	1960-07-02 00:00:00	1960-07-02	581452		0	0	0		0	0	0	249240	0	10	40213160		
218704	4800	40213160	1975-07-04	1975-07-04 00:00:00	1975-07-04	1975-07-04 00:00:00	1975-07-04	581452		0	0	0		0	0	0	319313	0	10	40213160		
9091	756	1127433	2005-01-04	2005-01-04 00:00:00	2005-01-11	2005-01-11 00:00:00	2005-01-11	38000177		0	0	7		0	0	0	50156	0	313782	1127433		
199045	4373	40213227	1998-04-14	1998-04-14 00:00:00	1998-04-14	1998-04-14 00:00:00	1998-04-14	581452		0	0	0		0	0	0	290432	0	113	40213227		
38945	3218	1127433	1997-03-18	1997-03-18 00:00:00	1997-04-01	1997-04-01 00:00:00	1997-04-01	38000177		0	0	14		0	0	0	213813	0	313782	1127433		
15736	339	40213306	2002-11-16	2002-11-16 00:00:00	2002-11-16	2002-11-16 00:00:00	2002-11-16	581452		0	0	0		0	0	0	22652	0	43	40213306		
24346	2002	1127433	2002-08-02	2002-08-02 00:00:00	2002-08-09	2002-08-09 00:00:00	2002-08-09	38000177		0	0	7		0	0	0	133342	0	313782	1127433		
7920	662	19059056	1971-04-27	1971-04-27 00:00:00	1971-05-25	1971-05-25 00:00:00	1971-05-25	38000177		0	0	28		0	0	0	43750	0	243670	19059056		
4712	394	40229134	1982-01-22	1982-01-22 00:00:00	1982-01-29	1982-01-29 00:00:00	1982-01-29	38000177		0	0	7		0	0	0	25897	0	1043400	40229134		
51351	4268	1127433	1994-12-21	1994-12-21 00:00:00	1995-01-18	1995-01-18 00:00:00	1995-01-18	38000177		0	0	28		0	0	0	283212	0	313782	1127433		
46494	3851	46275916	1985-10-14	1985-10-14 00:00:00	1985-10-14	1985-10-14 00:00:00	1985-10-14	38000177		0	0	0		0	0	0	255594	0	1660014	46275916		
13101	1099	1127433	1990-02-09	1990-02-09 00:00:00	1990-02-23	1990-02-23 00:00:00	1990-02-23	38000177		0	0	14		0	0	0	72160	0	313782	1127433		
162121	3566	40213227	2002-07-29	2002-07-29 00:00:00	2002-07-29	2002-07-29 00:00:00	2002-07-29	581452		0	0	0		0	0	0	236946	0	113	40213227		
208699	4577	40213160	1984-03-17	1984-03-17 00:00:00	1984-03-17	1984-03-17 00:00:00	1984-03-17	581452		0	0	0		0	0	0	304880	0	10	40213160		
29171	2414	1127433	1978-07-25	1978-07-25 00:00:00	1978-08-08	1978-08-08 00:00:00	1978-08-08	38000177		0	0	14		0	0	0	160221	0	313782	1127433		
23719	1951	19059056	1985-10-19	1985-10-19 00:00:00	1985-11-09	1985-11-09 00:00:00	1985-11-09	38000177		0	0	21		0	0	0	129718	0	243670	19059056		
38919	850	40213160	1955-02-15	1955-02-15 00:00:00	1955-02-15	1955-02-15 00:00:00	1955-02-15	581452		0	0	0		0	0	0	56211	0	10	40213160		
14041	1174	920300	1967-02-07	1967-02-07 00:00:00	1967-02-14	1967-02-14 00:00:00	1967-02-14	38000177		0	0	7		0	0	0	77304	0	311989	920300		
29543	644	40213314	1977-03-30	1977-03-30 00:00:00	1977-03-30	1977-03-30 00:00:00	1977-03-30	581452		0	0	0		0	0	0	42651	0	49	40213314		
24595	2025	19133873	1920-08-18	1920-08-18 00:00:00	1920-08-28	1920-08-28 00:00:00	1920-08-28	38000177		0	0	10		0	0	0	134747	0	834061	19133873		
63902	5309	40229134	1954-04-14	1954-04-14 00:00:00	1954-04-21	1954-04-21 00:00:00	1954-04-21	38000177		0	0	7		0	0	0	353086	0	1043400	40229134		
88302	1937	40213160	1963-08-20	1963-08-20 00:00:00	1963-08-20	1963-08-20 00:00:00	1963-08-20	581452		0	0	0		0	0	0	128892	0	10	40213160		
5637	472	19078461	1992-06-29	1992-06-29 00:00:00	1992-07-13	1992-07-13 00:00:00	1992-07-13	38000177		0	0	14		0	0	0	31546	0	310965	19078461		
14501	1215	19078461	1999-12-13	1999-12-13 00:00:00	1999-12-27	1999-12-27 00:00:00	1999-12-27	38000177		0	0	14		0	0	0	80040	0	310965	19078461		
30830	2554	19008572	1964-07-31	1964-07-31 00:00:00	1964-07-31	1964-07-31 00:00:00	\N	38000177		0	0	0		0	0	0	169261	0	106258	19008572		
56706	4704	920300	2000-01-04	2000-01-04 00:00:00	2000-01-11	2000-01-11 00:00:00	2000-01-11	38000177		0	0	7		0	0	0	313420	0	311989	920300		
45337	3752	19078461	1997-12-26	1997-12-26 00:00:00	1998-03-26	1998-03-26 00:00:00	1998-03-26	38000177		0	0	90		0	0	0	249365	0	310965	19078461		
45368	3754	1115171	2019-05-15	2019-05-15 00:00:00	2019-05-29	2019-05-29 00:00:00	2019-05-29	38000177		0	0	14		0	0	0	249554	0	849574	1115171		
70269	1537	40213227	2007-06-20	2007-06-20 00:00:00	2007-06-20	2007-06-20 00:00:00	2007-06-20	581452		0	0	0		0	0	0	102872	0	113	40213227		
63156	1381	40213227	2009-08-15	2009-08-15 00:00:00	2009-08-15	2009-08-15 00:00:00	2009-08-15	581452		0	0	0		0	0	0	91574	0	113	40213227		
13507	292	40213160	1976-08-21	1976-08-21 00:00:00	1976-08-21	1976-08-21 00:00:00	1976-08-21	581452		0	0	0		0	0	0	19435	0	10	40213160		
204180	4482	40213227	2011-09-03	2011-09-03 00:00:00	2011-09-03	2011-09-03 00:00:00	2011-09-03	581452		0	0	0		0	0	0	298336	0	113	40213227		
6351	533	19059056	1968-02-01	1968-02-01 00:00:00	1968-02-15	1968-02-15 00:00:00	1968-02-15	38000177		0	0	14		0	0	0	35448	0	243670	19059056		
55132	4577	1127433	2017-05-03	2017-05-03 00:00:00	2017-05-10	2017-05-10 00:00:00	2017-05-10	38000177		0	0	7		0	0	0	304908	0	313782	1127433		
49190	4081	1332419	2016-10-31	2016-10-31 00:00:00	2016-10-31	2016-10-31 00:00:00	\N	38000177		0	0	0		0	0	0	271302	0	197361	1332419		
22885	1882	1115171	1999-03-06	1999-03-06 00:00:00	1999-03-20	1999-03-20 00:00:00	1999-03-20	38000177		0	0	14		0	0	0	125567	0	849574	1115171		
234539	5152	40213227	2001-03-25	2001-03-25 00:00:00	2001-03-25	2001-03-25 00:00:00	2001-03-25	581452		0	0	0		0	0	0	342635	0	113	40213227		
15916	1321	19133905	2007-06-22	2007-06-22 00:00:00	2007-06-29	2007-06-29 00:00:00	2007-06-29	38000177		0	0	7		0	0	0	87641	0	834102	19133905		
486	36	19133873	1959-11-18	1959-11-18 00:00:00	1959-11-29	1959-11-29 00:00:00	1959-11-29	38000177		0	0	11		0	0	0	2512	0	834061	19133873		
26469	2177	19078461	1982-10-02	1982-10-02 00:00:00	1982-10-31	1982-10-31 00:00:00	1982-10-31	38000177		0	0	29		0	0	0	145184	0	310965	19078461		
44303	3667	19128065	1981-07-07	1981-07-07 00:00:00	1982-07-02	1982-07-02 00:00:00	1982-07-02	38000177		0	0	360		0	0	0	243958	0	749882	19128065		
216905	4759	40213251	1984-09-04	1984-09-04 00:00:00	1984-09-04	1984-09-04 00:00:00	1984-09-04	581452		0	0	0		0	0	0	317051	0	21	40213251		
8551	711	1127433	2002-03-29	2002-03-29 00:00:00	2002-04-26	2002-04-26 00:00:00	2002-04-26	38000177		0	0	28		0	0	0	47200	0	313782	1127433		
63519	1389	40213227	2016-11-12	2016-11-12 00:00:00	2016-11-12	2016-11-12 00:00:00	2016-11-12	581452		0	0	0		0	0	0	92177	0	113	40213227		
38800	3208	1332419	2008-01-18	2008-01-18 00:00:00	2008-01-18	2008-01-18 00:00:00	\N	38000177		0	0	0		0	0	0	213281	0	197361	1332419		
4386	95	40213160	1962-08-09	1962-08-09 00:00:00	1962-08-09	1962-08-09 00:00:00	1962-08-09	581452		0	0	0		0	0	0	6421	0	10	40213160		
32256	2675	19129655	1966-01-22	1966-01-22 00:00:00	1966-02-05	1966-02-05 00:00:00	1966-02-05	38000177		0	0	14		0	0	0	177302	0	789980	19129655		
199136	4375	40213227	2009-07-12	2009-07-12 00:00:00	2009-07-12	2009-07-12 00:00:00	2009-07-12	581452		0	0	0		0	0	0	290648	0	113	40213227		
8759	188	40213160	1963-02-24	1963-02-24 00:00:00	1963-02-24	1963-02-24 00:00:00	1963-02-24	581452		0	0	0		0	0	0	12789	0	10	40213160		
16336	1354	19078461	1995-05-29	1995-05-29 00:00:00	1995-06-28	1995-06-28 00:00:00	1995-06-28	38000177		0	0	30		0	0	0	89761	0	310965	19078461		
10612	883	1124300	2003-02-25	2003-02-25 00:00:00	2003-02-25	2003-02-25 00:00:00	\N	38000177		0	0	0		0	0	0	58809	0	00781178901	45011828		
17175	1425	1127433	1954-06-17	1954-06-17 00:00:00	1954-08-23	1954-08-23 00:00:00	1954-08-23	38000177		0	0	67		0	0	0	94731	0	313782	1127433		
79509	1740	40213201	2018-12-08	2018-12-08 00:00:00	2018-12-08	2018-12-08 00:00:00	2018-12-08	581452		0	0	0		0	0	0	116232	0	33	40213201		
994	80	19059056	1953-12-31	1953-12-31 00:00:00	1954-01-14	1954-01-14 00:00:00	1954-01-14	38000177		0	0	14		0	0	0	5433	0	243670	19059056		
20301	1666	19059056	1982-06-22	1982-06-22 00:00:00	1982-08-21	1982-08-21 00:00:00	1982-08-21	38000177		0	0	60		0	0	0	111879	0	243670	19059056		
106782	2341	40213227	2003-04-03	2003-04-03 00:00:00	2003-04-03	2003-04-03 00:00:00	2003-04-03	581452		0	0	0		0	0	0	155794	0	113	40213227		
31798	2636	1118084	2002-04-25	2002-04-25 00:00:00	2002-04-25	2002-04-25 00:00:00	\N	38000177		0	0	0		0	0	0	174481	0	00025152531	44923712		
30932	2561	40229134	2014-04-22	2014-04-22 00:00:00	2014-05-06	2014-05-06 00:00:00	2014-05-06	38000177		0	0	14		0	0	0	169726	0	1043400	40229134		
64162	5328	40236824	1966-10-09	1966-10-09 00:00:00	1966-10-16	1966-10-16 00:00:00	1966-10-16	38000177		0	0	7		0	0	0	354708	0	1094107	40236824		
44990	3721	19128065	1978-11-06	1978-11-06 00:00:00	1979-11-01	1979-11-01 00:00:00	1979-11-01	38000177		0	0	360		0	0	0	247374	0	749882	19128065		
25602	2103	19128065	1987-05-05	1987-05-05 00:00:00	1988-04-29	1988-04-29 00:00:00	1988-04-29	38000177		0	0	360		0	0	0	140167	0	749882	19128065		
62411	5194	1127433	2009-01-27	2009-01-27 00:00:00	2009-02-03	2009-02-03 00:00:00	2009-02-03	38000177		0	0	7		0	0	0	345351	0	313782	1127433		
159260	3505	40213201	2003-03-07	2003-03-07 00:00:00	2003-03-07	2003-03-07 00:00:00	2003-03-07	581452		0	0	0		0	0	0	232495	0	33	40213201		
36992	3060	1713671	2017-01-19	2017-01-19 00:00:00	2017-01-26	2017-01-26 00:00:00	2017-01-26	38000177		0	0	7		0	0	0	203642	0	562251	1713671		
170599	3750	40213160	1965-01-02	1965-01-02 00:00:00	1965-01-02	1965-01-02 00:00:00	1965-01-02	581452		0	0	0		0	0	0	249263	0	10	40213160		
218709	4800	40213227	2012-11-02	2012-11-02 00:00:00	2012-11-02	2012-11-02 00:00:00	2012-11-02	581452		0	0	0		0	0	0	319320	0	113	40213227		
9092	756	19059056	1992-10-25	1992-10-25 00:00:00	1992-11-08	1992-11-08 00:00:00	1992-11-08	38000177		0	0	14		0	0	0	50103	0	243670	19059056		
199046	4373	40213306	1998-04-14	1998-04-14 00:00:00	1998-04-14	1998-04-14 00:00:00	1998-04-14	581452		0	0	0		0	0	0	290432	0	43	40213306		
38946	3218	1127433	1973-09-30	1973-09-30 00:00:00	1973-10-07	1973-10-07 00:00:00	1973-10-07	38000177		0	0	7		0	0	0	213860	0	313782	1127433		
15740	339	40213160	1983-04-23	1983-04-23 00:00:00	1983-04-23	1983-04-23 00:00:00	1983-04-23	581452		0	0	0		0	0	0	22642	0	10	40213160		
24347	2002	1118084	2013-03-23	2013-03-23 00:00:00	2013-03-23	2013-03-23 00:00:00	\N	38000177		0	0	0		0	0	0	133377	0	00025152531	44923712		
7921	662	19129655	1971-04-27	1971-04-27 00:00:00	1971-05-25	1971-05-25 00:00:00	1971-05-25	38000177		0	0	28		0	0	0	43750	0	789980	19129655		
4713	394	19075601	1997-02-03	1997-02-03 00:00:00	1997-12-29	1997-12-29 00:00:00	1997-12-29	38000177		0	0	329		0	0	0	\N	0	309362	19075601		
51352	4268	19128065	1979-07-18	1979-07-18 00:00:00	1980-07-12	1980-07-12 00:00:00	1980-07-12	38000177		0	0	360		0	0	0	283249	0	749882	19128065		
46495	3851	40243436	1985-10-14	1985-10-14 00:00:00	1985-10-14	1985-10-14 00:00:00	1985-10-14	38000177		0	0	0		0	0	0	255594	0	1190795	40243436		
13102	1099	40229134	1955-02-27	1955-02-27 00:00:00	1955-03-06	1955-03-06 00:00:00	1955-03-06	38000177		0	0	7		0	0	0	72172	0	1043400	40229134		
162126	3566	40213227	1993-08-02	1993-08-02 00:00:00	1993-08-02	1993-08-02 00:00:00	1993-08-02	581452		0	0	0		0	0	0	236860	0	113	40213227		
208708	4578	40213160	1969-05-04	1969-05-04 00:00:00	1969-05-04	1969-05-04 00:00:00	1969-05-04	581452		0	0	0		0	0	0	304930	0	10	40213160		
29172	2414	1127433	1919-05-31	1919-05-31 00:00:00	1919-06-14	1919-06-14 00:00:00	1919-06-14	38000177		0	0	14		0	0	0	160273	0	313782	1127433		
23720	1951	1127433	2003-04-10	2003-04-10 00:00:00	2003-04-24	2003-04-24 00:00:00	2003-04-24	38000177		0	0	14		0	0	0	129737	0	313782	1127433		
21820	474	40213160	1970-08-23	1970-08-23 00:00:00	1970-08-23	1970-08-23 00:00:00	1970-08-23	581452		0	0	0		0	0	0	31612	0	10	40213160		
14042	1174	19133873	1946-03-28	1946-03-28 00:00:00	1946-04-05	1946-04-05 00:00:00	1946-04-05	38000177		0	0	8		0	0	0	77341	0	834061	19133873		
29544	644	40213160	1976-06-30	1976-06-30 00:00:00	1976-06-30	1976-06-30 00:00:00	1976-06-30	581452		0	0	0		0	0	0	42650	0	10	40213160		
24596	2025	1127433	1972-10-29	1972-10-29 00:00:00	1972-11-05	1972-11-05 00:00:00	1972-11-05	38000177		0	0	7		0	0	0	134668	0	313782	1127433		
63903	5309	19059056	1955-08-06	1955-08-06 00:00:00	1955-09-12	1955-09-12 00:00:00	1955-09-12	38000177		0	0	37		0	0	0	353143	0	243670	19059056		
88303	1937	40213160	1963-10-22	1963-10-22 00:00:00	1963-10-22	1963-10-22 00:00:00	1963-10-22	581452		0	0	0		0	0	0	128910	0	10	40213160		
5638	472	40162522	1992-06-29	1992-06-29 00:00:00	1992-06-29	1992-06-29 00:00:00	\N	38000177		0	0	0		0	0	0	31546	0	857005	40162522		
14502	1215	19129655	1975-04-23	1975-04-23 00:00:00	1975-05-07	1975-05-07 00:00:00	1975-05-07	38000177		0	0	14		0	0	0	80028	0	789980	19129655		
30831	2554	1127433	1979-08-09	1979-08-09 00:00:00	1979-08-23	1979-08-23 00:00:00	1979-08-23	38000177		0	0	14		0	0	0	169218	0	313782	1127433		
56707	4704	19059056	1969-01-01	1969-01-01 00:00:00	1969-01-15	1969-01-15 00:00:00	1969-01-15	38000177		0	0	14		0	0	0	313430	0	243670	19059056		
45338	3752	1127078	1962-11-05	1962-11-05 00:00:00	1962-11-19	1962-11-19 00:00:00	1962-11-19	38000177		0	0	14		0	0	0	249356	0	282464	1127078		
45369	3754	19128065	1981-11-16	1981-11-16 00:00:00	1982-11-11	1982-11-11 00:00:00	1982-11-11	38000177		0	0	360		0	0	0	249547	0	749882	19128065		
70278	1537	40213160	1961-04-26	1961-04-26 00:00:00	1961-04-26	1961-04-26 00:00:00	1961-04-26	581452		0	0	0		0	0	0	102911	0	10	40213160		
63159	1381	40213314	1979-08-11	1979-08-11 00:00:00	1979-08-11	1979-08-11 00:00:00	1979-08-11	581452		0	0	0		0	0	0	91597	0	49	40213314		
13509	292	40213160	1976-05-22	1976-05-22 00:00:00	1976-05-22	1976-05-22 00:00:00	1976-05-22	581452		0	0	0		0	0	0	19472	0	10	40213160		
204182	4482	40213201	2016-10-01	2016-10-01 00:00:00	2016-10-01	2016-10-01 00:00:00	2016-10-01	581452		0	0	0		0	0	0	298345	0	33	40213201		
6352	533	19129655	1968-02-01	1968-02-01 00:00:00	1968-02-15	1968-02-15 00:00:00	1968-02-15	38000177		0	0	14		0	0	0	35448	0	789980	19129655		
55133	4577	19133873	1996-05-15	1996-05-15 00:00:00	1996-05-27	1996-05-27 00:00:00	1996-05-27	38000177		0	0	12		0	0	0	304859	0	834061	19133873		
49191	4081	1127433	1968-02-04	1968-02-04 00:00:00	1968-02-11	1968-02-11 00:00:00	1968-02-11	38000177		0	0	7		0	0	0	271253	0	313782	1127433		
22886	1882	40229134	1973-02-17	1973-02-17 00:00:00	1973-03-03	1973-03-03 00:00:00	1973-03-03	38000177		0	0	14		0	0	0	125587	0	1043400	40229134		
234546	5152	40213227	2012-02-12	2012-02-12 00:00:00	2012-02-12	2012-02-12 00:00:00	2012-02-12	581452		0	0	0		0	0	0	342599	0	113	40213227		
15917	1321	19078461	2000-11-10	2000-11-10 00:00:00	2000-12-15	2000-12-15 00:00:00	2000-12-15	38000177		0	0	35		0	0	0	87601	0	310965	19078461		
487	36	19008572	2011-02-07	2011-02-07 00:00:00	2011-02-28	2011-02-28 00:00:00	2011-02-28	38000177		0	0	21		0	0	0	2634	0	106258	19008572		
26470	2177	19078461	2002-09-17	2002-09-17 00:00:00	2002-10-15	2002-10-15 00:00:00	2002-10-15	38000177		0	0	28		0	0	0	145185	0	310965	19078461		
44304	3667	1127078	1972-03-16	1972-03-16 00:00:00	1972-04-06	1972-04-06 00:00:00	1972-04-06	38000177		0	0	21		0	0	0	243975	0	282464	1127078		
216910	4759	40213296	2017-09-12	2017-09-12 00:00:00	2017-09-12	2017-09-12 00:00:00	2017-09-12	581452		0	0	0		0	0	0	317078	0	52	40213296		
8552	711	40229134	1983-04-05	1983-04-05 00:00:00	1983-04-12	1983-04-12 00:00:00	1983-04-12	38000177		0	0	7		0	0	0	47194	0	1043400	40229134		
63529	1389	40213227	2006-03-11	2006-03-11 00:00:00	2006-03-11	2006-03-11 00:00:00	2006-03-11	581452		0	0	0		0	0	0	92161	0	113	40213227		
38801	3208	19075601	2008-01-18	2008-01-18 00:00:00	2008-01-18	2008-01-18 00:00:00	\N	38000177		0	0	0		0	0	0	213281	0	309362	19075601		
4391	95	40213160	1958-02-06	1958-02-06 00:00:00	1958-02-06	1958-02-06 00:00:00	1958-02-06	581452		0	0	0		0	0	0	6402	0	10	40213160		
32257	2675	19075601	2012-08-19	2012-08-19 00:00:00	2012-08-19	2012-08-19 00:00:00	2012-08-19	38000177		0	0	0		0	0	0	177310	0	309362	19075601		
199155	4375	40213227	1992-04-05	1992-04-05 00:00:00	1992-04-05	1992-04-05 00:00:00	1992-04-05	581452		0	0	0		0	0	0	290593	0	113	40213227		
8765	188	40213306	1985-01-20	1985-01-20 00:00:00	1985-01-20	1985-01-20 00:00:00	1985-01-20	581452		0	0	0		0	0	0	12820	0	43	40213306		
16337	1354	40162522	1995-05-29	1995-05-29 00:00:00	1995-05-29	1995-05-29 00:00:00	\N	38000177		0	0	0		0	0	0	89761	0	857005	40162522		
10613	883	40236824	2007-08-30	2007-08-30 00:00:00	2007-09-06	2007-09-06 00:00:00	2007-09-06	38000177		0	0	7		0	0	0	58776	0	1094107	40236824		
17176	1425	19059056	1947-08-09	1947-08-09 00:00:00	1947-08-23	1947-08-23 00:00:00	1947-08-23	38000177		0	0	14		0	0	0	94723	0	243670	19059056		
79511	1740	40213160	1955-08-13	1955-08-13 00:00:00	1955-08-13	1955-08-13 00:00:00	1955-08-13	581452		0	0	0		0	0	0	116301	0	10	40213160		
995	81	1713671	1983-02-16	1983-02-16 00:00:00	1983-03-02	1983-03-02 00:00:00	1983-03-02	38000177		0	0	14		0	0	0	5488	0	562251	1713671		
20302	1666	40229134	1948-08-25	1948-08-25 00:00:00	1948-09-01	1948-09-01 00:00:00	1948-09-01	38000177		0	0	7		0	0	0	111943	0	1043400	40229134		
106784	2341	40213227	1994-04-07	1994-04-07 00:00:00	1994-04-07	1994-04-07 00:00:00	1994-04-07	581452		0	0	0		0	0	0	155832	0	113	40213227		
31799	2636	1127433	1973-09-06	1973-09-06 00:00:00	1973-09-13	1973-09-13 00:00:00	1973-09-13	38000177		0	0	7		0	0	0	174485	0	313782	1127433		
30933	2561	19078461	2014-02-16	2014-02-16 00:00:00	2014-03-02	2014-03-02 00:00:00	2014-03-02	38000177		0	0	14		0	0	0	169675	0	310965	19078461		
64163	5328	19059056	1910-02-26	1910-02-26 00:00:00	1910-03-12	1910-03-12 00:00:00	1910-03-12	38000177		0	0	14		0	0	0	354716	0	243670	19059056		
44991	3721	40236824	1994-12-14	1994-12-14 00:00:00	1994-12-21	1994-12-21 00:00:00	1994-12-21	38000177		0	0	7		0	0	0	247327	0	1094107	40236824		
25603	2103	19059056	1972-11-17	1972-11-17 00:00:00	1972-12-01	1972-12-01 00:00:00	1972-12-01	38000177		0	0	14		0	0	0	140165	0	243670	19059056		
62412	5194	1551192	1953-04-10	1953-04-10 00:00:00	1953-04-10	1953-04-10 00:00:00	1953-04-10	38000177		0	0	0		0	0	0	345404	0	312617	1551192		
207273	4548	40213314	1984-12-25	1984-12-25 00:00:00	1984-12-25	1984-12-25 00:00:00	1984-12-25	581452		0	0	0		0	0	0	302995	0	49	40213314		
36993	3060	1127433	2000-08-19	2000-08-19 00:00:00	2000-09-02	2000-09-02 00:00:00	2000-09-02	38000177		0	0	14		0	0	0	203659	0	313782	1127433		
170602	3750	40213160	1960-10-01	1960-10-01 00:00:00	1960-10-01	1960-10-01 00:00:00	1960-10-01	581452		0	0	0		0	0	0	249261	0	10	40213160		
218710	4800	40213296	2012-11-02	2012-11-02 00:00:00	2012-11-02	2012-11-02 00:00:00	2012-11-02	581452		0	0	0		0	0	0	319320	0	52	40213296		
9093	757	19133873	1926-05-05	1926-05-05 00:00:00	1926-05-15	1926-05-15 00:00:00	1926-05-15	38000177		0	0	10		0	0	0	50234	0	834061	19133873		
199047	4373	40213296	2018-01-16	2018-01-16 00:00:00	2018-01-16	2018-01-16 00:00:00	2018-01-16	581452		0	0	0		0	0	0	290340	0	52	40213296		
38947	3218	19006318	1960-10-21	1960-10-21 00:00:00	1960-11-04	1960-11-04 00:00:00	1960-11-04	38000177		0	0	14		0	0	0	213817	0	105078	19006318		
15744	339	40213314	1983-10-22	1983-10-22 00:00:00	1983-10-22	1983-10-22 00:00:00	1983-10-22	581452		0	0	0		0	0	0	22645	0	49	40213314		
24348	2002	1127078	1983-08-01	1983-08-01 00:00:00	1983-10-07	1983-10-07 00:00:00	1983-10-07	38000177		0	0	67		0	0	0	133380	0	282464	1127078		
7922	662	1127433	1977-09-13	1977-09-13 00:00:00	1977-09-27	1977-09-27 00:00:00	1977-09-27	38000177		0	0	14		0	0	0	43745	0	313782	1127433		
4714	394	19126352	1989-10-23	1989-10-23 00:00:00	1997-12-29	1997-12-29 00:00:00	1997-12-29	38000177		0	0	2989		0	0	0	25866	0	705129	19126352		
51353	4268	40229134	1968-07-16	1968-07-16 00:00:00	1968-07-30	1968-07-30 00:00:00	1968-07-30	38000177		0	0	14		0	0	0	283244	0	1043400	40229134		
46496	3851	1310034	1985-10-14	1985-10-14 00:00:00	1985-10-14	1985-10-14 00:00:00	1985-10-14	38000177		0	0	0		0	0	0	255594	0	834357	1310034		
13103	1100	1127433	2010-11-15	2010-11-15 00:00:00	2010-12-22	2010-12-22 00:00:00	2010-12-22	38000177		0	0	37		0	0	0	72276	0	313782	1127433		
162131	3566	40213160	1955-06-27	1955-06-27 00:00:00	1955-06-27	1955-06-27 00:00:00	1955-06-27	581452		0	0	0		0	0	0	236862	0	10	40213160		
208710	4578	40213306	1987-03-15	1987-03-15 00:00:00	1987-03-15	1987-03-15 00:00:00	1987-03-15	581452		0	0	0		0	0	0	304981	0	43	40213306		
29173	2414	19059056	1933-04-29	1933-04-29 00:00:00	1933-07-28	1933-07-28 00:00:00	1933-07-28	38000177		0	0	90		0	0	0	160249	0	243670	19059056		
23721	1951	1127433	1995-11-27	1995-11-27 00:00:00	1995-12-11	1995-12-11 00:00:00	1995-12-11	38000177		0	0	14		0	0	0	129751	0	313782	1127433		
21824	474	40213227	2001-01-28	2001-01-28 00:00:00	2001-01-28	2001-01-28 00:00:00	2001-01-28	581452		0	0	0		0	0	0	31636	0	113	40213227		
14043	1174	1127433	1957-09-02	1957-09-02 00:00:00	1957-09-23	1957-09-23 00:00:00	1957-09-23	38000177		0	0	21		0	0	0	77372	0	313782	1127433		
29545	644	40213160	1976-03-31	1976-03-31 00:00:00	1976-03-31	1976-03-31 00:00:00	1976-03-31	581452		0	0	0		0	0	0	42625	0	10	40213160		
24597	2025	40220960	2007-07-21	2007-07-21 00:00:00	2007-07-21	2007-07-21 00:00:00	2007-07-21	38000177		0	0	0		0	0	0	134648	0	1804799	40220960		
63904	5309	1115171	2018-06-16	2018-06-16 00:00:00	2018-09-14	2018-09-14 00:00:00	2018-09-14	38000177		0	0	90		0	0	0	353149	0	849574	1115171		
73443	1604	40213160	1958-10-09	1958-10-09 00:00:00	1958-10-09	1958-10-09 00:00:00	1958-10-09	581452		0	0	0		0	0	0	107663	0	10	40213160		
5639	472	40229134	1979-04-10	1979-04-10 00:00:00	1979-04-17	1979-04-17 00:00:00	1979-04-17	38000177		0	0	7		0	0	0	31535	0	1043400	40229134		
14503	1215	19019979	1975-04-23	1975-04-23 00:00:00	1975-05-07	1975-05-07 00:00:00	1975-05-07	38000177		0	0	14		0	0	0	80028	0	198405	19019979		
30832	2554	1127433	1942-06-20	1942-06-20 00:00:00	1942-07-04	1942-07-04 00:00:00	1942-07-04	38000177		0	0	14		0	0	0	169167	0	313782	1127433		
56708	4704	920334	2000-01-11	2000-01-11 00:00:00	2000-01-18	2000-01-18 00:00:00	2000-01-18	38000177		0	0	7		0	0	0	313421	0	311995	920334		
45339	3752	920300	1996-03-19	1996-03-19 00:00:00	1996-03-26	1996-03-26 00:00:00	1996-03-26	38000177		0	0	7		0	0	0	249321	0	311989	920300		
45370	3754	40162522	2017-05-25	2017-05-25 00:00:00	2017-05-25	2017-05-25 00:00:00	\N	38000177		0	0	0		0	0	0	249514	0	857005	40162522		
70304	1538	40213227	1992-03-16	1992-03-16 00:00:00	1992-03-16	1992-03-16 00:00:00	1992-03-16	581452		0	0	0		0	0	0	102942	0	113	40213227		
180758	3972	40213296	1999-01-31	1999-01-31 00:00:00	1999-01-31	1999-01-31 00:00:00	1999-01-31	581452		0	0	0		0	0	0	264153	0	52	40213296		
13512	292	40213314	1977-05-21	1977-05-21 00:00:00	1977-05-21	1977-05-21 00:00:00	1977-05-21	581452		0	0	0		0	0	0	19464	0	49	40213314		
204193	4482	40213227	2002-05-25	2002-05-25 00:00:00	2002-05-25	2002-05-25 00:00:00	2002-05-25	581452		0	0	0		0	0	0	298409	0	113	40213227		
6353	533	1115171	1997-02-03	1997-02-03 00:00:00	1997-03-03	1997-03-03 00:00:00	1997-03-03	38000177		0	0	28		0	0	0	35371	0	849574	1115171		
55134	4577	1127078	1986-01-13	1986-01-13 00:00:00	1986-01-27	1986-01-27 00:00:00	1986-01-27	38000177		0	0	14		0	0	0	304861	0	282464	1127078		
49192	4081	1124300	1999-04-21	1999-04-21 00:00:00	1999-04-21	1999-04-21 00:00:00	\N	38000177		0	0	0		0	0	0	271263	0	00781178901	45011828		
22887	1882	40232448	1970-08-31	1970-08-31 00:00:00	1970-08-31	1970-08-31 00:00:00	\N	38000177		0	0	0		0	0	0	125533	0	1049630	40232448		
234547	5152	40213296	2012-02-12	2012-02-12 00:00:00	2012-02-12	2012-02-12 00:00:00	2012-02-12	581452		0	0	0		0	0	0	342599	0	52	40213296		
15918	1321	1118084	2002-02-06	2002-02-06 00:00:00	2002-02-06	2002-02-06 00:00:00	\N	38000177		0	0	0		0	0	0	87601	0	00025152531	44923712		
488	36	19134077	2011-02-07	2011-02-07 00:00:00	2011-02-28	2011-02-28 00:00:00	2011-02-28	38000177		0	0	21		0	0	0	2634	0	835900	19134077		
26471	2177	1127433	1990-09-12	1990-09-12 00:00:00	1990-09-19	1990-09-19 00:00:00	1990-09-19	38000177		0	0	7		0	0	0	145189	0	313782	1127433		
44306	3668	40229134	1976-09-26	1976-09-26 00:00:00	1976-10-03	1976-10-03 00:00:00	1976-10-03	38000177		0	0	7		0	0	0	244014	0	1043400	40229134		
216912	4759	40213314	1978-01-24	1978-01-24 00:00:00	1978-01-24	1978-01-24 00:00:00	1978-01-24	581452		0	0	0		0	0	0	317112	0	49	40213314		
8553	712	1124300	2013-07-15	2013-07-15 00:00:00	2013-07-15	2013-07-15 00:00:00	\N	38000177		0	0	0		0	0	0	47256	0	00781178901	45011828		
63530	1389	40213260	2006-03-11	2006-03-11 00:00:00	2006-03-11	2006-03-11 00:00:00	2006-03-11	581452		0	0	0		0	0	0	92161	0	121	40213260		
38802	3208	19126352	2008-01-18	2008-01-18 00:00:00	2008-01-18	2008-01-18 00:00:00	\N	38000177		0	0	0		0	0	0	213281	0	705129	19126352		
4393	95	40213160	1957-12-05	1957-12-05 00:00:00	1957-12-05	1957-12-05 00:00:00	1957-12-05	581452		0	0	0		0	0	0	6431	0	10	40213160		
32258	2675	40220960	2012-08-19	2012-08-19 00:00:00	2012-08-19	2012-08-19 00:00:00	2012-08-19	38000177		0	0	0		0	0	0	177310	0	1804799	40220960		
153585	3381	40213227	2003-02-17	2003-02-17 00:00:00	2003-02-17	2003-02-17 00:00:00	2003-02-17	581452		0	0	0		0	0	0	224374	0	113	40213227		
8768	188	40213306	1986-04-06	1986-04-06 00:00:00	1986-04-06	1986-04-06 00:00:00	1986-04-06	581452		0	0	0		0	0	0	\N	0	43	40213306		
16338	1354	1124300	2019-06-16	2019-06-16 00:00:00	2019-06-16	2019-06-16 00:00:00	\N	38000177		0	0	0		0	0	0	89720	0	00781178901	45011828		
10614	883	920300	2007-08-30	2007-08-30 00:00:00	2007-09-06	2007-09-06 00:00:00	2007-09-06	38000177		0	0	7		0	0	0	58776	0	311989	920300		
17177	1426	1127433	1978-11-22	1978-11-22 00:00:00	1978-12-06	1978-12-06 00:00:00	1978-12-06	38000177		0	0	14		0	0	0	94880	0	313782	1127433		
79514	1740	40213160	1957-08-17	1957-08-17 00:00:00	1957-08-17	1957-08-17 00:00:00	1957-08-17	581452		0	0	0		0	0	0	116277	0	10	40213160		
996	81	19059056	1963-09-11	1963-09-11 00:00:00	1963-12-10	1963-12-10 00:00:00	1963-12-10	38000177		0	0	90		0	0	0	5507	0	243670	19059056		
20303	1666	1127433	1977-01-28	1977-01-28 00:00:00	1977-02-18	1977-02-18 00:00:00	1977-02-18	38000177		0	0	21		0	0	0	111878	0	313782	1127433		
106795	2341	40213160	1955-06-30	1955-06-30 00:00:00	1955-06-30	1955-06-30 00:00:00	1955-06-30	581452		0	0	0		0	0	0	155843	0	10	40213160		
31800	2636	1127433	2015-12-12	2015-12-12 00:00:00	2015-12-19	2015-12-19 00:00:00	2015-12-19	38000177		0	0	7		0	0	0	174416	0	313782	1127433		
30934	2561	19073188	2014-02-16	2014-02-16 00:00:00	2014-03-02	2014-03-02 00:00:00	2014-03-02	38000177		0	0	14		0	0	0	169675	0	308192	19073188		
64164	5328	1713671	1921-10-31	1921-10-31 00:00:00	1921-11-14	1921-11-14 00:00:00	1921-11-14	38000177		0	0	14		0	0	0	354594	0	562251	1713671		
44992	3721	920300	1994-12-14	1994-12-14 00:00:00	1994-12-21	1994-12-21 00:00:00	1994-12-21	38000177		0	0	7		0	0	0	247327	0	311989	920300		
25604	2103	46233988	1972-11-17	1972-11-17 00:00:00	1972-12-01	1972-12-01 00:00:00	1972-12-01	38000177		0	0	14		0	0	0	140165	0	1652673	46233988		
62413	5194	1713671	1990-01-30	1990-01-30 00:00:00	1990-02-06	1990-02-06 00:00:00	1990-02-06	38000177		0	0	7		0	0	0	345321	0	562251	1713671		
207274	4548	40213251	1984-12-25	1984-12-25 00:00:00	1984-12-25	1984-12-25 00:00:00	1984-12-25	581452		0	0	0		0	0	0	302995	0	21	40213251		
36994	3060	1118084	1961-02-08	1961-02-08 00:00:00	1961-02-08	1961-02-08 00:00:00	\N	38000177		0	0	0		0	0	0	203620	0	00025152531	44923712		
170604	3750	40213160	1960-04-30	1960-04-30 00:00:00	1960-04-30	1960-04-30 00:00:00	1960-04-30	581452		0	0	0		0	0	0	249260	0	10	40213160		
218714	4800	40213296	2010-10-29	2010-10-29 00:00:00	2010-10-29	2010-10-29 00:00:00	2010-10-29	581452		0	0	0		0	0	0	319306	0	52	40213296		
9094	757	1713671	1934-02-03	1934-02-03 00:00:00	1934-02-10	1934-02-10 00:00:00	1934-02-10	38000177		0	0	7		0	0	0	50236	0	562251	1713671		
40868	890	40213227	2001-06-08	2001-06-08 00:00:00	2001-06-08	2001-06-08 00:00:00	2001-06-08	581452		0	0	0		0	0	0	59291	0	113	40213227		
38948	3218	19059056	1960-10-21	1960-10-21 00:00:00	1960-11-04	1960-11-04 00:00:00	1960-11-04	38000177		0	0	14		0	0	0	213817	0	243670	19059056		
15748	339	40213227	2005-11-19	2005-11-19 00:00:00	2005-11-19	2005-11-19 00:00:00	2005-11-19	581452		0	0	0		0	0	0	22653	0	113	40213227		
24349	2002	1127433	1995-05-07	1995-05-07 00:00:00	1995-05-21	1995-05-21 00:00:00	1995-05-21	38000177		0	0	14		0	0	0	133382	0	313782	1127433		
7923	662	46233710	1977-09-13	1977-09-13 00:00:00	1977-09-27	1977-09-27 00:00:00	1977-09-27	38000177		0	0	14		0	0	0	43745	0	1650142	46233710		
4715	394	1127433	1962-11-14	1962-11-14 00:00:00	1962-11-21	1962-11-21 00:00:00	1962-11-21	38000177		0	0	7		0	0	0	25887	0	313782	1127433		
51354	4268	1127433	1963-02-04	1963-02-04 00:00:00	1963-02-11	1963-02-11 00:00:00	1963-02-11	38000177		0	0	7		0	0	0	283216	0	313782	1127433		
46497	3851	836659	1994-07-18	1994-07-18 00:00:00	1994-07-18	1994-07-18 00:00:00	\N	38000177		0	0	0		0	0	0	255522	0	313185	836659		
13104	1100	1127433	1996-03-03	1996-03-03 00:00:00	1996-05-02	1996-05-02 00:00:00	1996-05-02	38000177		0	0	60		0	0	0	72274	0	313782	1127433		
123538	2715	40213306	1988-06-02	1988-06-02 00:00:00	1988-06-02	1988-06-02 00:00:00	1988-06-02	581452		0	0	0		0	0	0	180053	0	43	40213306		
23624	1945	46233988	1971-05-28	1971-05-28 00:00:00	1971-06-11	1971-06-11 00:00:00	1971-06-11	38000177		0	0	14		0	0	0	129229	0	1652673	46233988		
29174	2414	40231925	1933-04-29	1933-04-29 00:00:00	1933-04-29	1933-04-29 00:00:00	\N	38000177		0	0	0		0	0	0	160249	0	1049221	40231925		
23722	1951	1118084	2013-10-27	2013-10-27 00:00:00	2013-10-27	2013-10-27 00:00:00	\N	38000177		0	0	0		0	0	0	129775	0	00025152531	44923712		
13388	289	40213260	2009-03-17	2009-03-17 00:00:00	2009-03-17	2009-03-17 00:00:00	2009-03-17	581452		0	0	0		0	0	0	19292	0	121	40213260		
14044	1175	19133905	1965-04-01	1965-04-01 00:00:00	1965-04-09	1965-04-09 00:00:00	1965-04-09	38000177		0	0	8		0	0	0	77431	0	834102	19133905		
29551	644	40213314	1976-12-29	1976-12-29 00:00:00	1976-12-29	1976-12-29 00:00:00	1976-12-29	581452		0	0	0		0	0	0	42626	0	49	40213314		
24598	2025	19075601	2007-07-21	2007-07-21 00:00:00	2007-07-21	2007-07-21 00:00:00	2007-07-21	38000177		0	0	0		0	0	0	134648	0	309362	19075601		
63905	5309	1127433	1974-08-23	1974-08-23 00:00:00	1974-09-06	1974-09-06 00:00:00	1974-09-06	38000177		0	0	14		0	0	0	353115	0	313782	1127433		
73444	1604	40213160	1955-04-07	1955-04-07 00:00:00	1955-04-07	1955-04-07 00:00:00	1955-04-07	581452		0	0	0		0	0	0	107619	0	10	40213160		
16103	1335	1115171	1998-05-28	1998-05-28 00:00:00	1998-06-18	1998-06-18 00:00:00	1998-06-18	38000177		0	0	21		0	0	0	88555	0	849574	1115171		
14504	1215	40220960	1993-05-08	1993-05-08 00:00:00	1993-05-08	1993-05-08 00:00:00	1993-05-08	38000177		0	0	0		0	0	0	80045	0	1804799	40220960		
30833	2554	1127433	1933-12-26	1933-12-26 00:00:00	1934-01-02	1934-01-02 00:00:00	1934-01-02	38000177		0	0	7		0	0	0	169260	0	313782	1127433		
56709	4704	19128065	1986-11-15	1986-11-15 00:00:00	1987-11-10	1987-11-10 00:00:00	1987-11-10	38000177		0	0	360		0	0	0	313416	0	749882	19128065		
45340	3752	40236824	1996-03-19	1996-03-19 00:00:00	1996-03-26	1996-03-26 00:00:00	1996-03-26	38000177		0	0	7		0	0	0	249321	0	1094107	40236824		
45371	3754	40229134	1995-11-25	1995-11-25 00:00:00	1995-12-02	1995-12-02 00:00:00	1995-12-02	38000177		0	0	7		0	0	0	249500	0	1043400	40229134		
150227	3304	40213260	2013-06-05	2013-06-05 00:00:00	2013-06-05	2013-06-05 00:00:00	2013-06-05	581452		0	0	0		0	0	0	219437	0	121	40213260		
180763	3972	40213160	1959-06-21	1959-06-21 00:00:00	1959-06-21	1959-06-21 00:00:00	1959-06-21	581452		0	0	0		0	0	0	264099	0	10	40213160		
13517	292	40213227	2017-11-04	2017-11-04 00:00:00	2017-11-04	2017-11-04 00:00:00	2017-11-04	581452		0	0	0		0	0	0	19457	0	113	40213227		
204202	4482	40213160	1955-04-23	1955-04-23 00:00:00	1955-04-23	1955-04-23 00:00:00	1955-04-23	581452		0	0	0		0	0	0	298349	0	10	40213160		
6354	533	1118084	2003-11-14	2003-11-14 00:00:00	2003-11-14	2003-11-14 00:00:00	\N	38000177		0	0	0		0	0	0	35497	0	00025152531	44923712		
55135	4577	19073183	1986-01-13	1986-01-13 00:00:00	1986-01-27	1986-01-27 00:00:00	1986-01-27	38000177		0	0	14		0	0	0	304861	0	308182	19073183		
49203	4084	19059056	1962-12-13	1962-12-13 00:00:00	1962-12-27	1962-12-27 00:00:00	1962-12-27	38000177		0	0	14		0	0	0	271413	0	243670	19059056		
22888	1882	19128065	1984-07-27	1984-07-27 00:00:00	1985-07-22	1985-07-22 00:00:00	1985-07-22	38000177		0	0	360		0	0	0	125511	0	749882	19128065		
234550	5152	40213160	1970-06-14	1970-06-14 00:00:00	1970-06-14	1970-06-14 00:00:00	1970-06-14	581452		0	0	0		0	0	0	342621	0	10	40213160		
15919	1321	19078461	2007-11-09	2007-11-09 00:00:00	2007-12-14	2007-12-14 00:00:00	2007-12-14	38000177		0	0	35		0	0	0	87602	0	310965	19078461		
489	36	1127433	2012-06-04	2012-06-04 00:00:00	2012-06-11	2012-06-11 00:00:00	2012-06-11	38000177		0	0	7		0	0	0	2543	0	313782	1127433		
26472	2177	1713671	2012-01-11	2012-01-11 00:00:00	2012-01-18	2012-01-18 00:00:00	2012-01-18	38000177		0	0	7		0	0	0	145190	0	562251	1713671		
44307	3668	1127433	1993-06-27	1993-06-27 00:00:00	1993-07-11	1993-07-11 00:00:00	1993-07-11	38000177		0	0	14		0	0	0	244031	0	313782	1127433		
216919	4759	40213306	1997-07-15	1997-07-15 00:00:00	1997-07-15	1997-07-15 00:00:00	1997-07-15	581452		0	0	0		0	0	0	317083	0	43	40213306		
8554	712	1115171	2018-04-20	2018-04-20 00:00:00	2018-05-04	2018-05-04 00:00:00	2018-05-04	38000177		0	0	14		0	0	0	47269	0	849574	1115171		
116078	2550	40213160	1983-09-25	1983-09-25 00:00:00	1983-09-25	1983-09-25 00:00:00	1983-09-25	581452		0	0	0		0	0	0	168797	0	10	40213160		
21892	476	40213160	1968-02-24	1968-02-24 00:00:00	1968-02-24	1968-02-24 00:00:00	1968-02-24	581452		0	0	0		0	0	0	31711	0	10	40213160		
4395	95	40213296	2001-04-05	2001-04-05 00:00:00	2001-04-05	2001-04-05 00:00:00	2001-04-05	581452		0	0	0		0	0	0	6449	0	52	40213296		
32259	2675	1127433	2005-12-29	2005-12-29 00:00:00	2006-01-12	2006-01-12 00:00:00	2006-01-12	38000177		0	0	14		0	0	0	177282	0	313782	1127433		
153590	3381	40213160	1972-08-14	1972-08-14 00:00:00	1972-08-14	1972-08-14 00:00:00	1972-08-14	581452		0	0	0		0	0	0	224386	0	10	40213160		
8769	188	40213160	1963-07-28	1963-07-28 00:00:00	1963-07-28	1963-07-28 00:00:00	1963-07-28	581452		0	0	0		0	0	0	12790	0	10	40213160		
58276	4843	1118084	1997-11-28	1997-11-28 00:00:00	1997-11-28	1997-11-28 00:00:00	\N	38000177		0	0	0		0	0	0	322153	0	00025152531	44923712		
10615	883	19133873	1969-04-07	1969-04-07 00:00:00	1969-04-15	1969-04-15 00:00:00	1969-04-15	38000177		0	0	8		0	0	0	58793	0	834061	19133873		
17178	1426	19078461	2007-10-08	2007-10-08 00:00:00	2008-01-06	2008-01-06 00:00:00	2008-01-06	38000177		0	0	90		0	0	0	94876	0	310965	19078461		
79517	1740	40213296	1996-09-14	1996-09-14 00:00:00	1996-09-14	1996-09-14 00:00:00	1996-09-14	581452		0	0	0		0	0	0	116250	0	52	40213296		
11455	954	19128022	1990-03-31	1990-03-31 00:00:00	1991-03-26	1991-03-26 00:00:00	1991-03-26	38000177		0	0	360		0	0	0	63373	0	749785	19128022		
20304	1666	19059056	1941-11-19	1941-11-19 00:00:00	1941-12-19	1941-12-19 00:00:00	1941-12-19	38000177		0	0	30		0	0	0	111876	0	243670	19059056		
106799	2341	40213201	2018-05-31	2018-05-31 00:00:00	2018-05-31	2018-05-31 00:00:00	2018-05-31	581452		0	0	0		0	0	0	155834	0	33	40213201		
31801	2636	19078461	2013-04-26	2013-04-26 00:00:00	2013-05-31	2013-05-31 00:00:00	2013-05-31	38000177		0	0	35		0	0	0	174420	0	310965	19078461		
30935	2561	1127433	1984-03-21	1984-03-21 00:00:00	1984-04-04	1984-04-04 00:00:00	1984-04-04	38000177		0	0	14		0	0	0	169706	0	313782	1127433		
64165	5328	19133873	1923-05-07	1923-05-07 00:00:00	1923-05-18	1923-05-18 00:00:00	1923-05-18	38000177		0	0	11		0	0	0	354622	0	834061	19133873		
44993	3721	19128065	1981-10-21	1981-10-21 00:00:00	1982-10-16	1982-10-16 00:00:00	1982-10-16	38000177		0	0	360		0	0	0	247375	0	749882	19128065		
25605	2103	1127078	1982-11-17	1982-11-17 00:00:00	1982-12-01	1982-12-01 00:00:00	1982-12-01	38000177		0	0	14		0	0	0	140122	0	282464	1127078		
62415	5194	1127078	1952-01-16	1952-01-16 00:00:00	1952-02-20	1952-02-20 00:00:00	1952-02-20	38000177		0	0	35		0	0	0	345403	0	282464	1127078		
162878	3582	40213296	1997-01-12	1997-01-12 00:00:00	1997-01-12	1997-01-12 00:00:00	1997-01-12	581452		0	0	0		0	0	0	\N	0	52	40213296		
36995	3060	40229134	1925-06-24	1925-06-24 00:00:00	1925-07-01	1925-07-01 00:00:00	1925-07-01	38000177		0	0	7		0	0	0	203554	0	1043400	40229134		
173418	3813	40213306	1995-08-12	1995-08-12 00:00:00	1995-08-12	1995-08-12 00:00:00	1995-08-12	581452		0	0	0		0	0	0	253289	0	43	40213306		
218719	4800	40213227	2003-09-05	2003-09-05 00:00:00	2003-09-05	2003-09-05 00:00:00	2003-09-05	581452		0	0	0		0	0	0	319339	0	113	40213227		
9095	757	1127433	1974-02-24	1974-02-24 00:00:00	1974-03-17	1974-03-17 00:00:00	1974-03-17	38000177		0	0	21		0	0	0	50287	0	313782	1127433		
40869	890	40213296	2001-06-08	2001-06-08 00:00:00	2001-06-08	2001-06-08 00:00:00	2001-06-08	581452		0	0	0		0	0	0	59291	0	52	40213296		
38949	3219	19133873	1983-05-04	1983-05-04 00:00:00	1983-05-16	1983-05-16 00:00:00	1983-05-16	38000177		0	0	12		0	0	0	213887	0	834061	19133873		
15749	339	40213306	2005-11-19	2005-11-19 00:00:00	2005-11-19	2005-11-19 00:00:00	2005-11-19	581452		0	0	0		0	0	0	22653	0	43	40213306		
24350	2002	19019979	1976-04-06	1976-04-06 00:00:00	1976-05-04	1976-05-04 00:00:00	1976-05-04	38000177		0	0	28		0	0	0	133378	0	198405	19019979		
7924	662	19078461	1992-10-01	1992-10-01 00:00:00	1992-11-04	1992-11-04 00:00:00	1992-11-04	38000177		0	0	34		0	0	0	43751	0	310965	19078461		
4716	394	1713671	1956-01-27	1956-01-27 00:00:00	1956-02-10	1956-02-10 00:00:00	1956-02-10	38000177		0	0	14		0	0	0	25837	0	562251	1713671		
51355	4268	1127433	1970-04-26	1970-04-26 00:00:00	1970-07-02	1970-07-02 00:00:00	1970-07-02	38000177		0	0	67		0	0	0	283209	0	313782	1127433		
46498	3851	1332419	1994-07-18	1994-07-18 00:00:00	1994-07-18	1994-07-18 00:00:00	\N	38000177		0	0	0		0	0	0	255522	0	197361	1332419		
13105	1100	1127433	2004-02-20	2004-02-20 00:00:00	2004-04-20	2004-04-20 00:00:00	2004-04-20	38000177		0	0	60		0	0	0	72275	0	313782	1127433		
123541	2715	40213227	2008-01-24	2008-01-24 00:00:00	2008-01-24	2008-01-24 00:00:00	2008-01-24	581452		0	0	0		0	0	0	180092	0	113	40213227		
23625	1945	19059056	1971-05-28	1971-05-28 00:00:00	1971-06-11	1971-06-11 00:00:00	1971-06-11	38000177		0	0	14		0	0	0	129229	0	243670	19059056		
29175	2414	19133905	1964-11-23	1964-11-23 00:00:00	1964-12-04	1964-12-04 00:00:00	1964-12-04	38000177		0	0	11		0	0	0	160169	0	834102	19133905		
23723	1951	1127078	1987-02-25	1987-02-25 00:00:00	1987-03-11	1987-03-11 00:00:00	1987-03-11	38000177		0	0	14		0	0	0	129726	0	282464	1127078		
13398	289	40213227	2010-03-23	2010-03-23 00:00:00	2010-03-23	2010-03-23 00:00:00	2010-03-23	581452		0	0	0		0	0	0	19302	0	113	40213227		
14045	1175	1118084	1974-05-06	1974-05-06 00:00:00	1974-05-06	1974-05-06 00:00:00	\N	38000177		0	0	0		0	0	0	77565	0	00025152531	44923712		
177883	3909	40213160	1966-03-25	1966-03-25 00:00:00	1966-03-25	1966-03-25 00:00:00	1966-03-25	581452		0	0	0		0	0	0	259848	0	10	40213160		
24599	2025	19133905	2017-08-10	2017-08-10 00:00:00	2017-08-17	2017-08-17 00:00:00	2017-08-17	38000177		0	0	7		0	0	0	134702	0	834102	19133905		
63906	5309	1127433	1966-04-20	1966-04-20 00:00:00	1966-05-04	1966-05-04 00:00:00	1966-05-04	38000177		0	0	14		0	0	0	353056	0	313782	1127433		
73450	1604	40213227	2015-09-03	2015-09-03 00:00:00	2015-09-03	2015-09-03 00:00:00	2015-09-03	581452		0	0	0		0	0	0	107647	0	113	40213227		
16104	1335	1713671	2007-06-27	2007-06-27 00:00:00	2007-07-04	2007-07-04 00:00:00	2007-07-04	38000177		0	0	7		0	0	0	88563	0	562251	1713671		
14505	1215	1127433	1975-11-20	1975-11-20 00:00:00	1975-12-04	1975-12-04 00:00:00	1975-12-04	38000177		0	0	14		0	0	0	80053	0	313782	1127433		
30834	2554	19059056	1944-11-05	1944-11-05 00:00:00	1944-11-19	1944-11-19 00:00:00	1944-11-19	38000177		0	0	14		0	0	0	169129	0	243670	19059056		
56710	4704	1127433	1982-09-04	1982-09-04 00:00:00	1982-11-03	1982-11-03 00:00:00	1982-11-03	38000177		0	0	60		0	0	0	313431	0	313782	1127433		
45341	3752	1118084	1997-11-17	1997-11-17 00:00:00	1997-11-17	1997-11-17 00:00:00	\N	38000177		0	0	0		0	0	0	249321	0	00025152531	44923712		
45372	3754	1713671	1964-05-01	1964-05-01 00:00:00	1964-05-22	1964-05-22 00:00:00	1964-05-22	38000177		0	0	21		0	0	0	249440	0	562251	1713671		
150230	3304	40213306	1984-10-24	1984-10-24 00:00:00	1984-10-24	1984-10-24 00:00:00	1984-10-24	581452		0	0	0		0	0	0	\N	0	43	40213306		
180764	3972	40213306	1982-01-10	1982-01-10 00:00:00	1982-01-10	1982-01-10 00:00:00	1982-01-10	581452		0	0	0		0	0	0	264151	0	43	40213306		
13518	292	40213296	2017-11-04	2017-11-04 00:00:00	2017-11-04	2017-11-04 00:00:00	2017-11-04	581452		0	0	0		0	0	0	19457	0	52	40213296		
221413	4859	40213260	2007-05-13	2007-05-13 00:00:00	2007-05-13	2007-05-13 00:00:00	2007-05-13	581452		0	0	0		0	0	0	323284	0	121	40213260		
6355	533	19133905	1984-05-08	1984-05-08 00:00:00	1984-05-17	1984-05-17 00:00:00	1984-05-17	38000177		0	0	9		0	0	0	35427	0	834102	19133905		
55136	4577	1127433	2002-03-31	2002-03-31 00:00:00	2002-06-06	2002-06-06 00:00:00	2002-06-06	38000177		0	0	67		0	0	0	304857	0	313782	1127433		
49204	4084	19129655	1962-12-13	1962-12-13 00:00:00	1962-12-27	1962-12-27 00:00:00	1962-12-27	38000177		0	0	14		0	0	0	271413	0	789980	19129655		
22889	1882	19078461	2010-06-20	2010-06-20 00:00:00	2010-07-04	2010-07-04 00:00:00	2010-07-04	38000177		0	0	14		0	0	0	125568	0	310965	19078461		
234563	5153	40213198	2010-03-24	2010-03-24 00:00:00	2010-03-24	2010-03-24 00:00:00	2010-03-24	581452		0	0	0		0	0	0	342663	0	133	40213198		
15920	1321	19078461	2016-12-26	2016-12-26 00:00:00	2017-01-09	2017-01-09 00:00:00	2017-01-09	38000177		0	0	14		0	0	0	87603	0	310965	19078461		
490	36	40236824	2014-11-17	2014-11-17 00:00:00	2014-11-24	2014-11-24 00:00:00	2014-11-24	38000177		0	0	7		0	0	0	2563	0	1094107	40236824		
26473	2177	19129655	1969-03-13	1969-03-13 00:00:00	1969-03-27	1969-03-27 00:00:00	1969-03-27	38000177		0	0	14		0	0	0	145206	0	789980	19129655		
44308	3668	19128022	1989-08-27	1989-08-27 00:00:00	1990-08-22	1990-08-22 00:00:00	1990-08-22	38000177		0	0	360		0	0	0	244043	0	749785	19128022		
216921	4759	40213314	1977-04-26	1977-04-26 00:00:00	1977-04-26	1977-04-26 00:00:00	1977-04-26	581452		0	0	0		0	0	0	317111	0	49	40213314		
8555	712	46233988	1977-01-25	1977-01-25 00:00:00	1977-02-08	1977-02-08 00:00:00	1977-02-08	38000177		0	0	14		0	0	0	47227	0	1652673	46233988		
116086	2550	40213314	1983-06-26	1983-06-26 00:00:00	1983-06-26	1983-06-26 00:00:00	1983-06-26	581452		0	0	0		0	0	0	168811	0	49	40213314		
70432	1540	40213160	1959-04-06	1959-04-06 00:00:00	1959-04-06	1959-04-06 00:00:00	1959-04-06	581452		0	0	0		0	0	0	103220	0	10	40213160		
4397	95	40213260	2008-04-24	2008-04-24 00:00:00	2008-04-24	2008-04-24 00:00:00	2008-04-24	581452		0	0	0		0	0	0	6413	0	121	40213260		
32260	2675	1127078	1963-02-18	1963-02-18 00:00:00	1963-03-04	1963-03-04 00:00:00	1963-03-04	38000177		0	0	14		0	0	0	177245	0	282464	1127078		
153592	3381	40213306	1994-02-07	1994-02-07 00:00:00	1994-02-07	1994-02-07 00:00:00	1994-02-07	581452		0	0	0		0	0	0	224348	0	43	40213306		
20061	437	40213201	2012-05-15	2012-05-15 00:00:00	2012-05-15	2012-05-15 00:00:00	2012-05-15	581452		0	0	0		0	0	0	29047	0	33	40213201		
58277	4843	19133905	2001-02-18	2001-02-18 00:00:00	2001-02-27	2001-02-27 00:00:00	2001-02-27	38000177		0	0	9		0	0	0	322154	0	834102	19133905		
10618	884	1127078	1982-09-17	1982-09-17 00:00:00	1982-10-22	1982-10-22 00:00:00	1982-10-22	38000177		0	0	35		0	0	0	58928	0	282464	1127078		
17179	1426	1127078	1954-04-30	1954-04-30 00:00:00	1954-05-14	1954-05-14 00:00:00	1954-05-14	38000177		0	0	14		0	0	0	94811	0	282464	1127078		
79519	1740	40213160	1955-02-12	1955-02-12 00:00:00	1955-02-12	1955-02-12 00:00:00	1955-02-12	581452		0	0	0		0	0	0	116269	0	10	40213160		
11456	954	40236824	1997-05-13	1997-05-13 00:00:00	1997-05-20	1997-05-20 00:00:00	1997-05-20	38000177		0	0	7		0	0	0	63377	0	1094107	40236824		
20305	1666	1127433	1971-02-10	1971-02-10 00:00:00	1971-02-24	1971-02-24 00:00:00	1971-02-24	38000177		0	0	14		0	0	0	111912	0	313782	1127433		
106805	2341	40213160	1955-12-29	1955-12-29 00:00:00	1955-12-29	1955-12-29 00:00:00	1955-12-29	581452		0	0	0		0	0	0	155854	0	10	40213160		
31802	2636	1332419	1997-07-04	1997-07-04 00:00:00	1997-07-04	1997-07-04 00:00:00	\N	38000177		0	0	0		0	0	0	174450	0	197361	1332419		
30936	2561	1713671	1999-11-27	1999-11-27 00:00:00	1999-12-18	1999-12-18 00:00:00	1999-12-18	38000177		0	0	21		0	0	0	169722	0	562251	1713671		
64166	5328	1127433	2002-11-18	2002-11-18 00:00:00	2002-11-25	2002-11-25 00:00:00	2002-11-25	38000177		0	0	7		0	0	0	354713	0	313782	1127433		
44994	3721	1713671	1975-09-19	1975-09-19 00:00:00	1975-09-26	1975-09-26 00:00:00	1975-09-26	38000177		0	0	7		0	0	0	247332	0	562251	1713671		
25606	2103	19133905	2015-09-07	2015-09-07 00:00:00	2015-09-14	2015-09-14 00:00:00	2015-09-14	38000177		0	0	7		0	0	0	140164	0	834102	19133905		
62416	5195	1127433	1993-09-01	1993-09-01 00:00:00	1993-09-15	1993-09-15 00:00:00	1993-09-15	38000177		0	0	14		0	0	0	345446	0	313782	1127433		
162885	3582	40213160	1961-05-07	1961-05-07 00:00:00	1961-05-07	1961-05-07 00:00:00	1961-05-07	581452		0	0	0		0	0	0	238117	0	10	40213160		
36996	3060	40229134	1928-07-23	1928-07-23 00:00:00	1928-08-06	1928-08-06 00:00:00	1928-08-06	38000177		0	0	14		0	0	0	203568	0	1043400	40229134		
173422	3813	40213160	1972-01-15	1972-01-15 00:00:00	1972-01-15	1972-01-15 00:00:00	1972-01-15	581452		0	0	0		0	0	0	253265	0	10	40213160		
218721	4800	40213160	1971-04-08	1971-04-08 00:00:00	1971-04-08	1971-04-08 00:00:00	1971-04-08	581452		0	0	0		0	0	0	319300	0	10	40213160		
9096	757	1127433	1990-05-21	1990-05-21 00:00:00	1990-05-28	1990-05-28 00:00:00	1990-05-28	38000177		0	0	7		0	0	0	50183	0	313782	1127433		
40878	890	40213160	1959-09-04	1959-09-04 00:00:00	1959-09-04	1959-09-04 00:00:00	1959-09-04	581452		0	0	0		0	0	0	59348	0	10	40213160		
38950	3219	40229134	2018-12-11	2018-12-11 00:00:00	2018-12-18	2018-12-18 00:00:00	2018-12-18	38000177		0	0	7		0	0	0	213894	0	1043400	40229134		
15750	339	40213180	2005-11-19	2005-11-19 00:00:00	2005-11-19	2005-11-19 00:00:00	2005-11-19	581452		0	0	0		0	0	0	22653	0	114	40213180		
24351	2002	19073188	2007-10-21	2007-10-21 00:00:00	2007-11-04	2007-11-04 00:00:00	2007-11-04	38000177		0	0	14		0	0	0	133335	0	308192	19073188		
7925	662	19133873	1964-01-07	1964-01-07 00:00:00	1964-01-20	1964-01-20 00:00:00	1964-01-20	38000177		0	0	13		0	0	0	43749	0	834061	19133873		
4717	394	1539411	1991-11-04	1991-11-04 00:00:00	1991-11-04	1991-11-04 00:00:00	\N	38000177		0	0	0		0	0	0	25867	0	312961	1539411		
51356	4268	1713671	1993-12-17	1993-12-17 00:00:00	1993-12-31	1993-12-31 00:00:00	1993-12-31	38000177		0	0	14		0	0	0	283267	0	562251	1713671		
46499	3851	1713671	1952-07-03	1952-07-03 00:00:00	1952-07-24	1952-07-24 00:00:00	1952-07-24	38000177		0	0	21		0	0	0	255610	0	562251	1713671		
13106	1100	40162522	2004-02-20	2004-02-20 00:00:00	2004-02-20	2004-02-20 00:00:00	\N	38000177		0	0	0		0	0	0	72275	0	857005	40162522		
123542	2715	40213296	2008-01-24	2008-01-24 00:00:00	2008-01-24	2008-01-24 00:00:00	2008-01-24	581452		0	0	0		0	0	0	180092	0	52	40213296		
23626	1945	1127433	1985-01-13	1985-01-13 00:00:00	1985-02-03	1985-02-03 00:00:00	1985-02-03	38000177		0	0	21		0	0	0	129242	0	313782	1127433		
29176	2414	836659	1996-08-29	1996-08-29 00:00:00	1996-08-29	1996-08-29 00:00:00	\N	38000177		0	0	0		0	0	0	160264	0	313185	836659		
23724	1951	19073183	1987-02-25	1987-02-25 00:00:00	1987-03-11	1987-03-11 00:00:00	1987-03-11	38000177		0	0	14		0	0	0	129726	0	308182	19073183		
13399	289	40213260	2010-03-23	2010-03-23 00:00:00	2010-03-23	2010-03-23 00:00:00	2010-03-23	581452		0	0	0		0	0	0	19302	0	121	40213260		
14046	1175	19059056	1945-12-29	1945-12-29 00:00:00	1946-01-19	1946-01-19 00:00:00	1946-01-19	38000177		0	0	21		0	0	0	77418	0	243670	19059056		
177887	3909	40213260	2012-12-28	2012-12-28 00:00:00	2012-12-28	2012-12-28 00:00:00	2012-12-28	581452		0	0	0		0	0	0	259837	0	121	40213260		
24600	2025	19133873	1910-11-29	1910-11-29 00:00:00	1910-12-10	1910-12-10 00:00:00	1910-12-10	38000177		0	0	11		0	0	0	134691	0	834061	19133873		
63907	5309	1127433	1989-04-07	1989-04-07 00:00:00	1989-04-21	1989-04-21 00:00:00	1989-04-21	38000177		0	0	14		0	0	0	353074	0	313782	1127433		
73454	1604	40213260	2006-07-13	2006-07-13 00:00:00	2006-07-13	2006-07-13 00:00:00	2006-07-13	581452		0	0	0		0	0	0	107599	0	121	40213260		
16105	1335	1127078	1987-12-03	1987-12-03 00:00:00	1987-12-17	1987-12-17 00:00:00	1987-12-17	38000177		0	0	14		0	0	0	88553	0	282464	1127078		
14506	1215	1124300	2009-04-19	2009-04-19 00:00:00	2009-04-19	2009-04-19 00:00:00	\N	38000177		0	0	0		0	0	0	80060	0	00781178901	45011828		
30835	2554	19059056	1939-05-18	1939-05-18 00:00:00	1939-06-01	1939-06-01 00:00:00	1939-06-01	38000177		0	0	14		0	0	0	169230	0	243670	19059056		
56711	4705	1127433	1973-03-14	1973-03-14 00:00:00	1973-03-28	1973-03-28 00:00:00	1973-03-28	38000177		0	0	14		0	0	0	313484	0	313782	1127433		
45344	3752	1115171	2002-10-01	2002-10-01 00:00:00	2002-10-29	2002-10-29 00:00:00	2002-10-29	38000177		0	0	28		0	0	0	249366	0	849574	1115171		
45373	3754	19059056	1961-09-22	1961-09-22 00:00:00	1961-10-27	1961-10-27 00:00:00	1961-10-27	38000177		0	0	35		0	0	0	249511	0	243670	19059056		
150232	3304	40213227	2014-06-11	2014-06-11 00:00:00	2014-06-11	2014-06-11 00:00:00	2014-06-11	581452		0	0	0		0	0	0	219422	0	113	40213227		
180771	3972	40213160	1959-09-20	1959-09-20 00:00:00	1959-09-20	1959-09-20 00:00:00	1959-09-20	581452		0	0	0		0	0	0	264121	0	10	40213160		
13520	292	40213227	1998-04-04	1998-04-04 00:00:00	1998-04-04	1998-04-04 00:00:00	1998-04-04	581452		0	0	0		0	0	0	19449	0	113	40213227		
221415	4859	40213227	2005-05-01	2005-05-01 00:00:00	2005-05-01	2005-05-01 00:00:00	2005-05-01	581452		0	0	0		0	0	0	323266	0	113	40213227		
6356	533	40229134	1981-05-29	1981-05-29 00:00:00	1981-06-12	1981-06-12 00:00:00	1981-06-12	38000177		0	0	14		0	0	0	35398	0	1043400	40229134		
55137	4578	19059056	1973-06-04	1973-06-04 00:00:00	1973-07-04	1973-07-04 00:00:00	1973-07-04	38000177		0	0	30		0	0	0	304987	0	243670	19059056		
49205	4084	19078461	1978-06-22	1978-06-22 00:00:00	1978-07-13	1978-07-13 00:00:00	1978-07-13	38000177		0	0	21		0	0	0	271436	0	310965	19078461		
22890	1882	19059056	1972-12-17	1972-12-17 00:00:00	1973-01-21	1973-01-21 00:00:00	1973-01-21	38000177		0	0	35		0	0	0	125566	0	243670	19059056		
213157	4674	40213227	2010-08-31	2010-08-31 00:00:00	2010-08-31	2010-08-31 00:00:00	2010-08-31	581452		0	0	0		0	0	0	311365	0	113	40213227		
15921	1321	1713671	1987-09-20	1987-09-20 00:00:00	1987-10-11	1987-10-11 00:00:00	1987-10-11	38000177		0	0	21		0	0	0	87610	0	562251	1713671		
491	36	920300	2014-11-17	2014-11-17 00:00:00	2014-11-24	2014-11-24 00:00:00	2014-11-24	38000177		0	0	7		0	0	0	2563	0	311989	920300		
26474	2177	1127078	1969-03-13	1969-03-13 00:00:00	1969-03-27	1969-03-27 00:00:00	1969-03-27	38000177		0	0	14		0	0	0	145206	0	282464	1127078		
44309	3668	1115171	1996-04-26	1996-04-26 00:00:00	1996-05-24	1996-05-24 00:00:00	1996-05-24	38000177		0	0	28		0	0	0	244032	0	849574	1115171		
216922	4759	40213160	1977-04-26	1977-04-26 00:00:00	1977-04-26	1977-04-26 00:00:00	1977-04-26	581452		0	0	0		0	0	0	317111	0	10	40213160		
8556	712	1127078	1977-01-25	1977-01-25 00:00:00	1977-02-08	1977-02-08 00:00:00	1977-02-08	38000177		0	0	14		0	0	0	47227	0	282464	1127078		
116087	2550	40213160	1983-06-26	1983-06-26 00:00:00	1983-06-26	1983-06-26 00:00:00	1983-06-26	581452		0	0	0		0	0	0	168811	0	10	40213160		
70435	1540	40213227	2000-12-25	2000-12-25 00:00:00	2000-12-25	2000-12-25 00:00:00	2000-12-25	581452		0	0	0		0	0	0	103208	0	113	40213227		
4412	95	40213227	1999-04-01	1999-04-01 00:00:00	1999-04-01	1999-04-01 00:00:00	1999-04-01	581452		0	0	0		0	0	0	6444	0	113	40213227		
32261	2675	19129655	1963-02-18	1963-02-18 00:00:00	1963-03-04	1963-03-04 00:00:00	1963-03-04	38000177		0	0	14		0	0	0	177245	0	789980	19129655		
153594	3381	40213227	1994-02-07	1994-02-07 00:00:00	1994-02-07	1994-02-07 00:00:00	1994-02-07	581452		0	0	0		0	0	0	224348	0	113	40213227		
20065	437	40213198	2011-05-10	2011-05-10 00:00:00	2011-05-10	2011-05-10 00:00:00	2011-05-10	581452		0	0	0		0	0	0	28972	0	133	40213198		
58278	4843	1127433	1963-03-18	1963-03-18 00:00:00	1963-03-25	1963-03-25 00:00:00	1963-03-25	38000177		0	0	7		0	0	0	322148	0	313782	1127433		
10619	884	1127433	2006-07-11	2006-07-11 00:00:00	2006-07-25	2006-07-25 00:00:00	2006-07-25	38000177		0	0	14		0	0	0	58919	0	313782	1127433		
17180	1426	19006318	1954-04-30	1954-04-30 00:00:00	1954-05-14	1954-05-14 00:00:00	1954-05-14	38000177		0	0	14		0	0	0	94811	0	105078	19006318		
122271	2686	40213160	1955-08-28	1955-08-28 00:00:00	1955-08-28	1955-08-28 00:00:00	1955-08-28	581452		0	0	0		0	0	0	178057	0	10	40213160		
11457	954	920300	1997-05-13	1997-05-13 00:00:00	1997-05-20	1997-05-20 00:00:00	1997-05-20	38000177		0	0	7		0	0	0	63377	0	311989	920300		
20306	1666	19078461	2018-08-24	2018-08-24 00:00:00	2018-09-28	2018-09-28 00:00:00	2018-09-28	38000177		0	0	35		0	0	0	111882	0	310965	19078461		
106807	2341	40213260	2006-04-20	2006-04-20 00:00:00	2006-04-20	2006-04-20 00:00:00	2006-04-20	581452		0	0	0		0	0	0	155813	0	121	40213260		
31803	2636	19075601	1997-07-04	1997-07-04 00:00:00	2019-03-08	2019-03-08 00:00:00	2019-03-08	38000177		0	0	7917		0	0	0	174450	0	309362	19075601		
6581	143	40213227	2006-11-12	2006-11-12 00:00:00	2006-11-12	2006-11-12 00:00:00	2006-11-12	581452		0	0	0		0	0	0	9605	0	113	40213227		
64167	5328	1127433	1975-03-11	1975-03-11 00:00:00	1975-04-01	1975-04-01 00:00:00	1975-04-01	38000177		0	0	21		0	0	0	354590	0	313782	1127433		
44995	3721	19133873	1971-09-16	1971-09-16 00:00:00	1971-09-25	1971-09-25 00:00:00	1971-09-25	38000177		0	0	9		0	0	0	247351	0	834061	19133873		
61661	5132	19133873	1972-12-24	1972-12-24 00:00:00	1973-01-02	1973-01-02 00:00:00	1973-01-02	38000177		0	0	9		0	0	0	341108	0	834061	19133873		
19428	1602	1127078	1972-03-19	1972-03-19 00:00:00	1972-04-18	1972-04-18 00:00:00	1972-04-18	38000177		0	0	30		0	0	0	107521	0	282464	1127078		
162889	3582	40213227	2018-02-25	2018-02-25 00:00:00	2018-02-25	2018-02-25 00:00:00	2018-02-25	581452		0	0	0		0	0	0	238135	0	113	40213227		
36997	3060	1127433	1994-03-18	1994-03-18 00:00:00	1994-03-25	1994-03-25 00:00:00	1994-03-25	38000177		0	0	7		0	0	0	203658	0	313782	1127433		
173426	3813	40213227	2002-11-16	2002-11-16 00:00:00	2002-11-16	2002-11-16 00:00:00	2002-11-16	581452		0	0	0		0	0	0	253276	0	113	40213227		
170642	3752	40213296	1997-12-18	1997-12-18 00:00:00	1997-12-18	1997-12-18 00:00:00	1997-12-18	581452		0	0	0		0	0	0	249373	0	52	40213296		
9097	757	1127433	1978-09-22	1978-09-22 00:00:00	1978-10-06	1978-10-06 00:00:00	1978-10-06	38000177		0	0	14		0	0	0	50288	0	313782	1127433		
40883	890	40213306	1981-07-31	1981-07-31 00:00:00	1981-07-31	1981-07-31 00:00:00	1981-07-31	581452		0	0	0		0	0	0	59355	0	43	40213306		
38951	3219	40229134	1994-05-16	1994-05-16 00:00:00	1994-05-30	1994-05-30 00:00:00	1994-05-30	38000177		0	0	14		0	0	0	213909	0	1043400	40229134		
15751	339	40213251	1984-01-21	1984-01-21 00:00:00	1984-01-21	1984-01-21 00:00:00	1984-01-21	581452		0	0	0		0	0	0	22657	0	21	40213251		
24352	2002	1127433	2007-10-21	2007-10-21 00:00:00	2007-11-04	2007-11-04 00:00:00	2007-11-04	38000177		0	0	14		0	0	0	133335	0	313782	1127433		
7926	662	19059056	1963-05-21	1963-05-21 00:00:00	1963-06-04	1963-06-04 00:00:00	1963-06-04	38000177		0	0	14		0	0	0	43735	0	243670	19059056		
4718	394	1127433	1997-01-28	1997-01-28 00:00:00	1997-02-04	1997-02-04 00:00:00	1997-02-04	38000177		0	0	7		0	0	0	25839	0	313782	1127433		
51358	4268	1127433	1969-09-28	1969-09-28 00:00:00	1969-10-05	1969-10-05 00:00:00	1969-10-05	38000177		0	0	7		0	0	0	283217	0	313782	1127433		
46500	3851	1127433	1969-02-17	1969-02-17 00:00:00	1969-03-03	1969-03-03 00:00:00	1969-03-03	38000177		0	0	14		0	0	0	255563	0	313782	1127433		
13107	1100	1713671	2009-05-20	2009-05-20 00:00:00	2009-05-27	2009-05-27 00:00:00	2009-05-27	38000177		0	0	7		0	0	0	72280	0	562251	1713671		
123543	2715	40213160	1966-04-21	1966-04-21 00:00:00	1966-04-21	1966-04-21 00:00:00	1966-04-21	581452		0	0	0		0	0	0	180017	0	10	40213160		
23627	1945	1127078	1972-08-02	1972-08-02 00:00:00	1972-08-16	1972-08-16 00:00:00	1972-08-16	38000177		0	0	14		0	0	0	129214	0	282464	1127078		
29177	2414	19126352	1991-08-01	1991-08-01 00:00:00	1994-05-26	1994-05-26 00:00:00	1994-05-26	38000177		0	0	1029		0	0	0	160271	0	705129	19126352		
23725	1951	1115171	2018-01-25	2018-01-25 00:00:00	2018-03-01	2018-03-01 00:00:00	2018-03-01	38000177		0	0	35		0	0	0	129774	0	849574	1115171		
13402	289	40213296	2001-03-26	2001-03-26 00:00:00	2001-03-26	2001-03-26 00:00:00	2001-03-26	581452		0	0	0		0	0	0	19257	0	52	40213296		
14047	1175	1127433	2009-04-19	2009-04-19 00:00:00	2009-05-03	2009-05-03 00:00:00	2009-05-03	38000177		0	0	14		0	0	0	77529	0	313782	1127433		
177889	3909	40213227	2012-12-28	2012-12-28 00:00:00	2012-12-28	2012-12-28 00:00:00	2012-12-28	581452		0	0	0		0	0	0	259837	0	113	40213227		
24601	2025	19059056	1943-06-06	1943-06-06 00:00:00	1943-06-27	1943-06-27 00:00:00	1943-06-27	38000177		0	0	21		0	0	0	134664	0	243670	19059056		
63908	5309	19059056	1967-10-28	1967-10-28 00:00:00	1968-01-26	1968-01-26 00:00:00	1968-01-26	38000177		0	0	90		0	0	0	353147	0	243670	19059056		
73456	1604	40213160	1955-01-06	1955-01-06 00:00:00	1955-01-06	1955-01-06 00:00:00	1955-01-06	581452		0	0	0		0	0	0	107660	0	10	40213160		
16106	1335	19059056	1979-11-15	1979-11-15 00:00:00	1979-11-29	1979-11-29 00:00:00	1979-11-29	38000177		0	0	14		0	0	0	88576	0	243670	19059056		
14507	1216	40169281	2015-01-13	2015-01-13 00:00:00	2015-01-13	2015-01-13 00:00:00	\N	38000177		0	0	0		0	0	0	80109	0	896209	40169281		
30836	2554	1713671	1988-09-28	1988-09-28 00:00:00	1988-10-05	1988-10-05 00:00:00	1988-10-05	38000177		0	0	7		0	0	0	169220	0	562251	1713671		
56712	4705	1127433	2007-04-13	2007-04-13 00:00:00	2007-05-18	2007-05-18 00:00:00	2007-05-18	38000177		0	0	35		0	0	0	313435	0	313782	1127433		
45346	3752	1127078	1960-04-17	1960-04-17 00:00:00	1960-05-01	1960-05-01 00:00:00	1960-05-01	38000177		0	0	14		0	0	0	249355	0	282464	1127078		
45374	3754	19078461	1986-07-16	1986-07-16 00:00:00	1986-07-30	1986-07-30 00:00:00	1986-07-30	38000177		0	0	14		0	0	0	249513	0	310965	19078461		
150234	3304	40213260	2014-06-11	2014-06-11 00:00:00	2014-06-11	2014-06-11 00:00:00	2014-06-11	581452		0	0	0		0	0	0	219422	0	121	40213260		
180773	3972	40213260	2009-01-11	2009-01-11 00:00:00	2009-01-11	2009-01-11 00:00:00	2009-01-11	581452		0	0	0		0	0	0	264131	0	121	40213260		
13521	292	40213306	1998-04-04	1998-04-04 00:00:00	1998-04-04	1998-04-04 00:00:00	1998-04-04	581452		0	0	0		0	0	0	19449	0	43	40213306		
221418	4859	40213160	1955-08-28	1955-08-28 00:00:00	1955-08-28	1955-08-28 00:00:00	1955-08-28	581452		0	0	0		0	0	0	\N	0	10	40213160		
6357	534	19128065	1997-05-25	1997-05-25 00:00:00	1998-05-20	1998-05-20 00:00:00	1998-05-20	38000177		0	0	360		0	0	0	35571	0	749882	19128065		
55138	4578	1127078	1967-04-09	1967-04-09 00:00:00	1967-04-23	1967-04-23 00:00:00	1967-04-23	38000177		0	0	14		0	0	0	304922	0	282464	1127078		
49206	4084	19059056	1976-08-01	1976-08-01 00:00:00	1976-08-31	1976-08-31 00:00:00	1976-08-31	38000177		0	0	30		0	0	0	271435	0	243670	19059056		
22891	1882	1127433	1987-06-13	1987-06-13 00:00:00	1987-06-20	1987-06-20 00:00:00	1987-06-20	38000177		0	0	7		0	0	0	125481	0	313782	1127433		
213158	4674	40213296	2010-08-31	2010-08-31 00:00:00	2010-08-31	2010-08-31 00:00:00	2010-08-31	581452		0	0	0		0	0	0	311365	0	52	40213296		
15922	1321	1713671	2017-07-24	2017-07-24 00:00:00	2017-07-31	2017-07-31 00:00:00	2017-07-31	38000177		0	0	7		0	0	0	87643	0	562251	1713671		
492	36	1127433	1966-07-12	1966-07-12 00:00:00	1966-07-26	1966-07-26 00:00:00	1966-07-26	38000177		0	0	14		0	0	0	2486	0	313782	1127433		
26475	2177	1124300	2005-06-03	2005-06-03 00:00:00	2005-06-03	2005-06-03 00:00:00	\N	38000177		0	0	0		0	0	0	145178	0	00781178901	45011828		
44310	3668	19078461	2018-01-16	2018-01-16 00:00:00	2018-02-13	2018-02-13 00:00:00	2018-02-13	38000177		0	0	28		0	0	0	244024	0	310965	19078461		
216924	4759	40213227	2000-07-18	2000-07-18 00:00:00	2000-07-18	2000-07-18 00:00:00	2000-07-18	581452		0	0	0		0	0	0	317084	0	113	40213227		
8557	712	1713671	1978-09-21	1978-09-21 00:00:00	1978-09-28	1978-09-28 00:00:00	1978-09-28	38000177		0	0	7		0	0	0	47243	0	562251	1713671		
116090	2551	40213160	1958-11-27	1958-11-27 00:00:00	1958-11-27	1958-11-27 00:00:00	1958-11-27	581452		0	0	0		0	0	0	168900	0	10	40213160		
70436	1540	40213296	2000-12-25	2000-12-25 00:00:00	2000-12-25	2000-12-25 00:00:00	2000-12-25	581452		0	0	0		0	0	0	103208	0	52	40213296		
4413	95	40213296	1999-04-01	1999-04-01 00:00:00	1999-04-01	1999-04-01 00:00:00	1999-04-01	581452		0	0	0		0	0	0	6444	0	52	40213296		
32262	2675	40229134	2013-12-13	2013-12-13 00:00:00	2013-12-20	2013-12-20 00:00:00	2013-12-20	38000177		0	0	7		0	0	0	177274	0	1043400	40229134		
153596	3381	40213296	2012-02-13	2012-02-13 00:00:00	2012-02-13	2012-02-13 00:00:00	2012-02-13	581452		0	0	0		0	0	0	224358	0	52	40213296		
20067	437	40213227	1997-02-18	1997-02-18 00:00:00	1997-02-18	1997-02-18 00:00:00	1997-02-18	581452		0	0	0		0	0	0	29039	0	113	40213227		
58279	4843	1127433	1984-05-05	1984-05-05 00:00:00	1984-05-19	1984-05-19 00:00:00	1984-05-19	38000177		0	0	14		0	0	0	322159	0	313782	1127433		
10620	884	19019979	1979-04-29	1979-04-29 00:00:00	1979-05-13	1979-05-13 00:00:00	1979-05-13	38000177		0	0	14		0	0	0	58920	0	198405	19019979		
17181	1426	1127433	1984-07-19	1984-07-19 00:00:00	1984-08-09	1984-08-09 00:00:00	1984-08-09	38000177		0	0	21		0	0	0	94874	0	313782	1127433		
122299	2688	40213160	1963-07-28	1963-07-28 00:00:00	1963-07-28	1963-07-28 00:00:00	1963-07-28	581452		0	0	0		0	0	0	178102	0	10	40213160		
11458	954	1127433	1978-12-21	1978-12-21 00:00:00	1978-12-28	1978-12-28 00:00:00	1978-12-28	38000177		0	0	7		0	0	0	63369	0	313782	1127433		
20307	1666	19078461	2015-08-19	2015-08-19 00:00:00	2015-09-09	2015-09-09 00:00:00	2015-09-09	38000177		0	0	21		0	0	0	111881	0	310965	19078461		
51677	4295	1127433	1999-10-20	1999-10-20 00:00:00	1999-10-27	1999-10-27 00:00:00	1999-10-27	38000177		0	0	7		0	0	0	285073	0	313782	1127433		
31804	2636	1539411	1997-07-04	1997-07-04 00:00:00	1997-07-04	1997-07-04 00:00:00	\N	38000177		0	0	0		0	0	0	174450	0	312961	1539411		
6582	143	40213296	2006-11-12	2006-11-12 00:00:00	2006-11-12	2006-11-12 00:00:00	2006-11-12	581452		0	0	0		0	0	0	9605	0	52	40213296		
64168	5328	1127433	1934-03-01	1934-03-01 00:00:00	1934-03-08	1934-03-08 00:00:00	1934-03-08	38000177		0	0	7		0	0	0	354704	0	313782	1127433		
45006	3725	19133905	2016-03-20	2016-03-20 00:00:00	2016-04-01	2016-04-01 00:00:00	2016-04-01	38000177		0	0	12		0	0	0	247567	0	834102	19133905		
61662	5132	1127433	1970-05-21	1970-05-21 00:00:00	1970-05-28	1970-05-28 00:00:00	1970-05-28	38000177		0	0	7		0	0	0	341107	0	313782	1127433		
19429	1602	1127433	2013-04-18	2013-04-18 00:00:00	2013-05-23	2013-05-23 00:00:00	2013-05-23	38000177		0	0	35		0	0	0	107526	0	313782	1127433		
174169	3830	40213160	1981-11-22	1981-11-22 00:00:00	1981-11-22	1981-11-22 00:00:00	1981-11-22	581452		0	0	0		0	0	0	254323	0	10	40213160		
36998	3060	19059056	1926-12-14	1926-12-14 00:00:00	1926-12-28	1926-12-28 00:00:00	1926-12-28	38000177		0	0	14		0	0	0	203670	0	243670	19059056		
173435	3813	40213227	2012-10-13	2012-10-13 00:00:00	2012-10-13	2012-10-13 00:00:00	2012-10-13	581452		0	0	0		0	0	0	253292	0	113	40213227		
170644	3752	40213227	2008-12-18	2008-12-18 00:00:00	2008-12-18	2008-12-18 00:00:00	2008-12-18	581452		0	0	0		0	0	0	249349	0	113	40213227		
9098	757	40229134	1935-05-24	1935-05-24 00:00:00	1935-06-07	1935-06-07 00:00:00	1935-06-07	38000177		0	0	14		0	0	0	50182	0	1043400	40229134		
40888	890	40213160	1964-05-08	1964-05-08 00:00:00	1964-05-08	1964-05-08 00:00:00	1964-05-08	581452		0	0	0		0	0	0	59360	0	10	40213160		
38952	3219	1127078	1990-08-24	1990-08-24 00:00:00	1990-09-28	1990-09-28 00:00:00	1990-09-28	38000177		0	0	35		0	0	0	213929	0	282464	1127078		
27032	588	40213251	1984-05-30	1984-05-30 00:00:00	1984-05-30	1984-05-30 00:00:00	1984-05-30	581452		0	0	0		0	0	0	38946	0	21	40213251		
24355	2004	1127433	1988-08-05	1988-08-05 00:00:00	1988-08-12	1988-08-12 00:00:00	1988-08-12	38000177		0	0	7		0	0	0	133449	0	313782	1127433		
7927	662	19129655	1963-05-21	1963-05-21 00:00:00	1963-06-04	1963-06-04 00:00:00	1963-06-04	38000177		0	0	14		0	0	0	43735	0	789980	19129655		
4719	394	1545959	1997-12-29	1997-12-29 00:00:00	1997-12-29	1997-12-29 00:00:00	1997-12-29	38000177		0	0	0		0	0	0	25915	0	259255	1545959		
51359	4268	1713671	1985-07-10	1985-07-10 00:00:00	1985-07-31	1985-07-31 00:00:00	1985-07-31	38000177		0	0	21		0	0	0	283277	0	562251	1713671		
46501	3852	1127433	1965-11-25	1965-11-25 00:00:00	1965-12-09	1965-12-09 00:00:00	1965-12-09	38000177		0	0	14		0	0	0	255628	0	313782	1127433		
13108	1100	1127433	2011-11-17	2011-11-17 00:00:00	2011-12-08	2011-12-08 00:00:00	2011-12-08	38000177		0	0	21		0	0	0	72277	0	313782	1127433		
123549	2715	40213160	1970-12-31	1970-12-31 00:00:00	1970-12-31	1970-12-31 00:00:00	1970-12-31	581452		0	0	0		0	0	0	180021	0	10	40213160		
23628	1945	19006318	1972-08-02	1972-08-02 00:00:00	1972-08-16	1972-08-16 00:00:00	1972-08-16	38000177		0	0	14		0	0	0	129214	0	105078	19006318		
29178	2414	1539411	1991-08-01	1991-08-01 00:00:00	1991-08-01	1991-08-01 00:00:00	\N	38000177		0	0	0		0	0	0	160271	0	312961	1539411		
23726	1951	1713671	1993-06-04	1993-06-04 00:00:00	1993-07-02	1993-07-02 00:00:00	1993-07-02	38000177		0	0	28		0	0	0	129749	0	562251	1713671		
13404	289	40213227	2001-03-26	2001-03-26 00:00:00	2001-03-26	2001-03-26 00:00:00	2001-03-26	581452		0	0	0		0	0	0	19257	0	113	40213227		
14048	1175	19059056	1943-06-02	1943-06-02 00:00:00	1943-06-16	1943-06-16 00:00:00	1943-06-16	38000177		0	0	14		0	0	0	77543	0	243670	19059056		
177891	3909	40213160	1962-04-27	1962-04-27 00:00:00	1962-04-27	1962-04-27 00:00:00	1962-04-27	581452		0	0	0		0	0	0	259834	0	10	40213160		
24602	2025	1127433	2012-04-21	2012-04-21 00:00:00	2012-04-28	2012-04-28 00:00:00	2012-04-28	38000177		0	0	7		0	0	0	134725	0	313782	1127433		
63909	5309	40162522	1967-10-28	1967-10-28 00:00:00	1967-10-28	1967-10-28 00:00:00	\N	38000177		0	0	0		0	0	0	353147	0	857005	40162522		
73469	1605	40213227	2017-10-22	2017-10-22 00:00:00	2017-10-22	2017-10-22 00:00:00	2017-10-22	581452		0	0	0		0	0	0	107709	0	113	40213227		
16107	1335	19074843	1979-11-15	1979-11-15 00:00:00	1979-11-29	1979-11-29 00:00:00	1979-11-29	38000177		0	0	14		0	0	0	88576	0	309045	19074843		
14508	1216	19128065	1988-06-29	1988-06-29 00:00:00	1989-06-24	1989-06-24 00:00:00	1989-06-24	38000177		0	0	360		0	0	0	80112	0	749882	19128065		
30837	2554	19059056	1936-06-11	1936-06-11 00:00:00	1936-06-25	1936-06-25 00:00:00	1936-06-25	38000177		0	0	14		0	0	0	169128	0	243670	19059056		
56713	4705	19128065	1992-05-11	1992-05-11 00:00:00	1993-05-06	1993-05-06 00:00:00	1993-05-06	38000177		0	0	360		0	0	0	313455	0	749882	19128065		
45347	3752	19006318	1960-04-17	1960-04-17 00:00:00	1960-05-01	1960-05-01 00:00:00	1960-05-01	38000177		0	0	14		0	0	0	249355	0	105078	19006318		
45375	3754	1713671	1971-03-19	1971-03-19 00:00:00	1971-04-02	1971-04-02 00:00:00	1971-04-02	38000177		0	0	14		0	0	0	249443	0	562251	1713671		
150247	3304	40213160	1963-04-17	1963-04-17 00:00:00	1963-04-17	1963-04-17 00:00:00	1963-04-17	581452		0	0	0		0	0	0	219456	0	10	40213160		
180777	3973	40213296	2009-08-06	2009-08-06 00:00:00	2009-08-06	2009-08-06 00:00:00	2009-08-06	581452		0	0	0		0	0	0	264212	0	52	40213296		
13523	292	40213306	1996-07-27	1996-07-27 00:00:00	1996-07-27	1996-07-27 00:00:00	1996-07-27	581452		0	0	0		0	0	0	\N	0	43	40213306		
221422	4859	40213296	1996-05-05	1996-05-05 00:00:00	1996-05-05	1996-05-05 00:00:00	1996-05-05	581452		0	0	0		0	0	0	323201	0	52	40213296		
6358	534	40236824	1996-07-21	1996-07-21 00:00:00	1996-07-28	1996-07-28 00:00:00	1996-07-28	38000177		0	0	7		0	0	0	35514	0	1094107	40236824		
55139	4578	1713671	1980-03-03	1980-03-03 00:00:00	1980-03-10	1980-03-10 00:00:00	1980-03-10	38000177		0	0	7		0	0	0	304978	0	562251	1713671		
49207	4084	1310034	2010-10-03	2010-10-03 00:00:00	2010-10-03	2010-10-03 00:00:00	2010-10-03	38000177		0	0	0		0	0	0	271438	0	834357	1310034		
22905	1885	1127078	1977-08-28	1977-08-28 00:00:00	1977-09-11	1977-09-11 00:00:00	1977-09-11	38000177		0	0	14		0	0	0	125701	0	282464	1127078		
213159	4674	40213306	1990-11-20	1990-11-20 00:00:00	1990-11-20	1990-11-20 00:00:00	1990-11-20	581452		0	0	0		0	0	0	311412	0	43	40213306		
15923	1321	40229134	1965-02-01	1965-02-01 00:00:00	1965-02-08	1965-02-08 00:00:00	1965-02-08	38000177		0	0	7		0	0	0	87657	0	1043400	40229134		
493	36	1127078	1961-10-17	1961-10-17 00:00:00	1961-10-31	1961-10-31 00:00:00	1961-10-31	38000177		0	0	14		0	0	0	2564	0	282464	1127078		
26476	2177	1127433	1969-07-13	1969-07-13 00:00:00	1969-07-27	1969-07-27 00:00:00	1969-07-27	38000177		0	0	14		0	0	0	145214	0	313782	1127433		
44311	3668	1127078	1975-09-30	1975-09-30 00:00:00	1975-10-14	1975-10-14 00:00:00	1975-10-14	38000177		0	0	14		0	0	0	244008	0	282464	1127078		
216925	4759	40213306	2000-07-18	2000-07-18 00:00:00	2000-07-18	2000-07-18 00:00:00	2000-07-18	581452		0	0	0		0	0	0	317084	0	43	40213306		
8558	712	19133873	1977-08-25	1977-08-25 00:00:00	1977-09-04	1977-09-04 00:00:00	1977-09-04	38000177		0	0	10		0	0	0	47242	0	834061	19133873		
116098	2551	40213296	1999-01-28	1999-01-28 00:00:00	1999-01-28	1999-01-28 00:00:00	1999-01-28	581452		0	0	0		0	0	0	168861	0	52	40213296		
130299	2863	40213160	1962-02-22	1962-02-22 00:00:00	1962-02-22	1962-02-22 00:00:00	1962-02-22	581452		0	0	0		0	0	0	190417	0	10	40213160		
4421	95	40213160	1958-05-08	1958-05-08 00:00:00	1958-05-08	1958-05-08 00:00:00	1958-05-08	581452		0	0	0		0	0	0	6460	0	10	40213160		
32263	2675	1127078	1964-09-10	1964-09-10 00:00:00	1964-09-24	1964-09-24 00:00:00	1964-09-24	38000177		0	0	14		0	0	0	177231	0	282464	1127078		
153605	3381	40213160	1972-03-13	1972-03-13 00:00:00	1972-03-13	1972-03-13 00:00:00	1972-03-13	581452		0	0	0		0	0	0	224340	0	10	40213160		
74270	1622	40213227	2017-04-17	2017-04-17 00:00:00	2017-04-17	2017-04-17 00:00:00	2017-04-17	581452		0	0	0		0	0	0	108942	0	113	40213227		
58280	4843	40229134	2009-06-13	2009-06-13 00:00:00	2009-06-20	2009-06-20 00:00:00	2009-06-20	38000177		0	0	7		0	0	0	322118	0	1043400	40229134		
33912	741	40213227	2007-04-27	2007-04-27 00:00:00	2007-04-27	2007-04-27 00:00:00	2007-04-27	581452		0	0	0		0	0	0	49047	0	113	40213227		
17182	1426	19078461	2009-09-27	2009-09-27 00:00:00	2009-10-18	2009-10-18 00:00:00	2009-10-18	38000177		0	0	21		0	0	0	94877	0	310965	19078461		
191693	4212	40213160	1970-07-10	1970-07-10 00:00:00	1970-07-10	1970-07-10 00:00:00	1970-07-10	581452		0	0	0		0	0	0	279628	0	10	40213160		
11459	954	19074843	1981-09-21	1981-09-21 00:00:00	1981-10-05	1981-10-05 00:00:00	1981-10-05	38000177		0	0	14		0	0	0	63372	0	309045	19074843		
20328	1669	1118084	1998-10-15	1998-10-15 00:00:00	1998-10-15	1998-10-15 00:00:00	\N	38000177		0	0	0		0	0	0	112053	0	00025152531	44923712		
51678	4295	19019979	1975-10-01	1975-10-01 00:00:00	1975-10-15	1975-10-15 00:00:00	1975-10-15	38000177		0	0	14		0	0	0	285046	0	198405	19019979		
31805	2636	19126352	1997-07-04	1997-07-04 00:00:00	2019-03-08	2019-03-08 00:00:00	2019-03-08	38000177		0	0	7917		0	0	0	174450	0	705129	19126352		
6588	143	40213160	1965-07-11	1965-07-11 00:00:00	1965-07-11	1965-07-11 00:00:00	1965-07-11	581452		0	0	0		0	0	0	9588	0	10	40213160		
64169	5328	1127433	1988-09-05	1988-09-05 00:00:00	1988-09-12	1988-09-12 00:00:00	1988-09-12	38000177		0	0	7		0	0	0	354711	0	313782	1127433		
45007	3725	1127078	1972-06-05	1972-06-05 00:00:00	1972-08-04	1972-08-04 00:00:00	1972-08-04	38000177		0	0	60		0	0	0	247590	0	282464	1127078		
61663	5132	19078461	2019-06-06	2019-06-06 00:00:00	2019-06-06	2019-06-06 00:00:00	\N	38000177		0	0	0		0	0	0	341172	0	310965	19078461		
19430	1602	1124300	2001-11-23	2001-11-23 00:00:00	2001-11-23	2001-11-23 00:00:00	\N	38000177		0	0	0		0	0	0	107505	0	00781178901	45011828		
174170	3830	40213314	1981-11-22	1981-11-22 00:00:00	1981-11-22	1981-11-22 00:00:00	1981-11-22	581452		0	0	0		0	0	0	254323	0	49	40213314		
36999	3060	1127433	1994-08-26	1994-08-26 00:00:00	1994-09-25	1994-09-25 00:00:00	1994-09-25	38000177		0	0	30		0	0	0	203627	0	313782	1127433		
173436	3813	40213296	2012-10-13	2012-10-13 00:00:00	2012-10-13	2012-10-13 00:00:00	2012-10-13	581452		0	0	0		0	0	0	253292	0	52	40213296		
170645	3752	40213260	2008-12-18	2008-12-18 00:00:00	2008-12-18	2008-12-18 00:00:00	2008-12-18	581452		0	0	0		0	0	0	249349	0	121	40213260		
9099	757	19018935	1976-01-11	1976-01-11 00:00:00	1976-01-11	1976-01-11 00:00:00	\N	38000177		0	0	0		0	0	0	50264	0	197604	19018935		
40889	890	40213260	2009-05-29	2009-05-29 00:00:00	2009-05-29	2009-05-29 00:00:00	2009-05-29	581452		0	0	0		0	0	0	59284	0	121	40213260		
38953	3219	1713671	2003-02-09	2003-02-09 00:00:00	2003-03-02	2003-03-02 00:00:00	2003-03-02	38000177		0	0	21		0	0	0	213912	0	562251	1713671		
218906	4804	40213227	1999-05-24	1999-05-24 00:00:00	1999-05-24	1999-05-24 00:00:00	1999-05-24	581452		0	0	0		0	0	0	319655	0	113	40213227		
24356	2004	40229134	1984-05-25	1984-05-25 00:00:00	1984-06-01	1984-06-01 00:00:00	1984-06-01	38000177		0	0	7		0	0	0	133448	0	1043400	40229134		
7928	662	19075601	2012-10-03	2012-10-03 00:00:00	2012-10-03	2012-10-03 00:00:00	\N	38000177		0	0	0		0	0	0	43762	0	309362	19075601		
4720	394	19133768	1997-12-29	1997-12-29 00:00:00	1997-12-29	1997-12-29 00:00:00	1997-12-29	38000177		0	0	0		0	0	0	25915	0	833036	19133768		
51360	4268	1127433	1993-05-26	1993-05-26 00:00:00	1993-06-09	1993-06-09 00:00:00	1993-06-09	38000177		0	0	14		0	0	0	283246	0	313782	1127433		
46502	3852	40229134	1997-01-02	1997-01-02 00:00:00	1997-01-16	1997-01-16 00:00:00	1997-01-16	38000177		0	0	14		0	0	0	255756	0	1043400	40229134		
13109	1100	1118084	2019-05-08	2019-05-08 00:00:00	2019-05-08	2019-05-08 00:00:00	\N	38000177		0	0	0		0	0	0	72260	0	00025152531	44923712		
123551	2715	40213296	2006-01-19	2006-01-19 00:00:00	2006-01-19	2006-01-19 00:00:00	2006-01-19	581452		0	0	0		0	0	0	180072	0	52	40213296		
23629	1945	19133905	2007-10-22	2007-10-22 00:00:00	2007-11-01	2007-11-01 00:00:00	2007-11-01	38000177		0	0	10		0	0	0	129208	0	834102	19133905		
29179	2414	1713671	1984-11-22	1984-11-22 00:00:00	1984-12-13	1984-12-13 00:00:00	1984-12-13	38000177		0	0	21		0	0	0	160277	0	562251	1713671		
23727	1951	19078461	2012-01-22	2012-01-22 00:00:00	2012-02-26	2012-02-26 00:00:00	2012-02-26	38000177		0	0	35		0	0	0	129772	0	310965	19078461		
57201	4748	19059056	1984-10-25	1984-10-25 00:00:00	1984-12-24	1984-12-24 00:00:00	1984-12-24	38000177		0	0	60		0	0	0	316221	0	243670	19059056		
14049	1175	19073188	1981-07-14	1981-07-14 00:00:00	1981-07-28	1981-07-28 00:00:00	1981-07-28	38000177		0	0	14		0	0	0	77532	0	308192	19073188		
177894	3909	40213227	2002-12-20	2002-12-20 00:00:00	2002-12-20	2002-12-20 00:00:00	2002-12-20	581452		0	0	0		0	0	0	259865	0	113	40213227		
24603	2025	40220960	2009-05-30	2009-05-30 00:00:00	2009-05-30	2009-05-30 00:00:00	2009-05-30	38000177		0	0	0		0	0	0	134745	0	1804799	40220960		
63910	5309	1127433	1986-04-21	1986-04-21 00:00:00	1986-05-05	1986-05-05 00:00:00	1986-05-05	38000177		0	0	14		0	0	0	353148	0	313782	1127433		
73471	1605	40213227	2007-08-26	2007-08-26 00:00:00	2007-08-26	2007-08-26 00:00:00	2007-08-26	581452		0	0	0		0	0	0	107690	0	113	40213227		
16108	1335	19128065	1992-11-16	1992-11-16 00:00:00	1993-11-11	1993-11-11 00:00:00	1993-11-11	38000177		0	0	360		0	0	0	88594	0	749882	19128065		
14509	1216	1127433	1993-11-20	1993-11-20 00:00:00	1993-12-25	1993-12-25 00:00:00	1993-12-25	38000177		0	0	35		0	0	0	80070	0	313782	1127433		
30838	2554	40229134	1973-12-29	1973-12-29 00:00:00	1974-01-05	1974-01-05 00:00:00	1974-01-05	38000177		0	0	7		0	0	0	169266	0	1043400	40229134		
56714	4705	1127078	1975-11-27	1975-11-27 00:00:00	1975-12-27	1975-12-27 00:00:00	1975-12-27	38000177		0	0	30		0	0	0	313434	0	282464	1127078		
45348	3752	19128065	1980-10-22	1980-10-22 00:00:00	1981-10-17	1981-10-17 00:00:00	1981-10-17	38000177		0	0	360		0	0	0	249359	0	749882	19128065		
45376	3754	1713671	1963-06-20	1963-06-20 00:00:00	1963-06-27	1963-06-27 00:00:00	1963-06-27	38000177		0	0	7		0	0	0	249502	0	562251	1713671		
150248	3304	40213160	1963-06-19	1963-06-19 00:00:00	1963-06-19	1963-06-19 00:00:00	1963-06-19	581452		0	0	0		0	0	0	219474	0	10	40213160		
180779	3973	40213227	2009-08-06	2009-08-06 00:00:00	2009-08-06	2009-08-06 00:00:00	2009-08-06	581452		0	0	0		0	0	0	264212	0	113	40213227		
13527	292	40213160	1980-11-22	1980-11-22 00:00:00	1980-11-22	1980-11-22 00:00:00	1980-11-22	581452		0	0	0		0	0	0	19476	0	10	40213160		
223596	4909	40213160	1975-09-22	1975-09-22 00:00:00	1975-09-22	1975-09-22 00:00:00	1975-09-22	581452		0	0	0		0	0	0	326227	0	10	40213160		
6359	534	920300	1996-07-21	1996-07-21 00:00:00	1996-07-28	1996-07-28 00:00:00	1996-07-28	38000177		0	0	7		0	0	0	35514	0	311989	920300		
55140	4578	19059056	1967-01-09	1967-01-09 00:00:00	1967-02-06	1967-02-06 00:00:00	1967-02-06	38000177		0	0	28		0	0	0	304986	0	243670	19059056		
49208	4084	40243436	2010-10-03	2010-10-03 00:00:00	2010-10-03	2010-10-03 00:00:00	2010-10-03	38000177		0	0	0		0	0	0	271438	0	1190795	40243436		
22906	1885	46233988	1977-08-28	1977-08-28 00:00:00	1977-09-11	1977-09-11 00:00:00	1977-09-11	38000177		0	0	14		0	0	0	125701	0	1652673	46233988		
213163	4674	40213160	1973-07-31	1973-07-31 00:00:00	1973-07-31	1973-07-31 00:00:00	1973-07-31	581452		0	0	0		0	0	0	311400	0	10	40213160		
15924	1321	40229134	1978-05-22	1978-05-22 00:00:00	1978-06-05	1978-06-05 00:00:00	1978-06-05	38000177		0	0	14		0	0	0	87653	0	1043400	40229134		
494	36	19129655	1961-10-17	1961-10-17 00:00:00	1961-10-31	1961-10-31 00:00:00	1961-10-31	38000177		0	0	14		0	0	0	2564	0	789980	19129655		
26477	2177	1713671	1993-02-04	1993-02-04 00:00:00	1993-02-11	1993-02-11 00:00:00	1993-02-11	38000177		0	0	7		0	0	0	145192	0	562251	1713671		
44312	3668	46233988	1975-09-30	1975-09-30 00:00:00	1975-10-14	1975-10-14 00:00:00	1975-10-14	38000177		0	0	14		0	0	0	244008	0	1652673	46233988		
216927	4759	40213227	2009-09-01	2009-09-01 00:00:00	2009-09-01	2009-09-01 00:00:00	2009-09-01	581452		0	0	0		0	0	0	317086	0	113	40213227		
8559	712	1713671	1983-10-10	1983-10-10 00:00:00	1983-10-31	1983-10-31 00:00:00	1983-10-31	38000177		0	0	21		0	0	0	47221	0	562251	1713671		
116104	2551	40213160	1963-08-01	1963-08-01 00:00:00	1963-08-01	1963-08-01 00:00:00	1963-08-01	581452		0	0	0		0	0	0	168871	0	10	40213160		
130304	2864	40213227	2000-11-16	2000-11-16 00:00:00	2000-11-16	2000-11-16 00:00:00	2000-11-16	581452		0	0	0		0	0	0	190458	0	113	40213227		
19133	1578	1115171	2018-11-01	2018-11-01 00:00:00	2019-01-30	2019-01-30 00:00:00	2019-01-30	38000177		0	0	90		0	0	0	105972	0	849574	1115171		
32264	2675	1127433	1993-09-25	1993-09-25 00:00:00	1993-10-02	1993-10-02 00:00:00	1993-10-02	38000177		0	0	7		0	0	0	177270	0	313782	1127433		
153618	3381	40213160	1972-05-15	1972-05-15 00:00:00	1972-05-15	1972-05-15 00:00:00	1972-05-15	581452		0	0	0		0	0	0	224392	0	10	40213160		
74271	1622	40213296	2015-04-13	2015-04-13 00:00:00	2015-04-13	2015-04-13 00:00:00	2015-04-13	581452		0	0	0		0	0	0	109005	0	52	40213296		
58281	4843	19006318	1964-02-10	1964-02-10 00:00:00	1964-02-24	1964-02-24 00:00:00	1964-02-24	38000177		0	0	14		0	0	0	322120	0	105078	19006318		
33916	741	40213314	1978-05-05	1978-05-05 00:00:00	1978-05-05	1978-05-05 00:00:00	1978-05-05	581452		0	0	0		0	0	0	49079	0	49	40213314		
17183	1426	19059056	1958-02-27	1958-02-27 00:00:00	1958-03-13	1958-03-13 00:00:00	1958-03-13	38000177		0	0	14		0	0	0	94833	0	243670	19059056		
191695	4212	40213160	1970-02-06	1970-02-06 00:00:00	1970-02-06	1970-02-06 00:00:00	1970-02-06	581452		0	0	0		0	0	0	279627	0	10	40213160		
11460	954	1127078	1981-09-21	1981-09-21 00:00:00	1981-10-05	1981-10-05 00:00:00	1981-10-05	38000177		0	0	14		0	0	0	63372	0	282464	1127078		
20329	1669	40169281	2000-02-21	2000-02-21 00:00:00	2000-02-21	2000-02-21 00:00:00	\N	38000177		0	0	0		0	0	0	112079	0	896209	40169281		
51679	4295	19006318	1975-10-01	1975-10-01 00:00:00	1975-10-15	1975-10-15 00:00:00	1975-10-15	38000177		0	0	14		0	0	0	285046	0	105078	19006318		
31806	2636	40229134	2014-11-15	2014-11-15 00:00:00	2014-11-29	2014-11-29 00:00:00	2014-11-29	38000177		0	0	14		0	0	0	174489	0	1043400	40229134		
6600	144	40213160	1975-03-28	1975-03-28 00:00:00	1975-03-28	1975-03-28 00:00:00	1975-03-28	581452		0	0	0		0	0	0	9667	0	10	40213160		
64170	5328	19059056	1914-05-06	1914-05-06 00:00:00	1914-06-03	1914-06-03 00:00:00	1914-06-03	38000177		0	0	28		0	0	0	354586	0	243670	19059056		
45008	3725	19078461	1981-09-16	1981-09-16 00:00:00	1981-12-15	1981-12-15 00:00:00	1981-12-15	38000177		0	0	90		0	0	0	247576	0	310965	19078461		
61664	5132	1127433	1991-09-26	1991-09-26 00:00:00	1991-10-31	1991-10-31 00:00:00	1991-10-31	38000177		0	0	35		0	0	0	341169	0	313782	1127433		
19431	1602	1127078	1971-04-10	1971-04-10 00:00:00	1971-04-24	1971-04-24 00:00:00	1971-04-24	38000177		0	0	14		0	0	0	107520	0	282464	1127078		
174173	3830	40213314	1982-10-25	1982-10-25 00:00:00	1982-10-25	1982-10-25 00:00:00	1982-10-25	581452		0	0	0		0	0	0	254304	0	49	40213314		
37000	3060	40165015	1945-09-12	1945-09-12 00:00:00	1945-09-12	1945-09-12 00:00:00	\N	38000177		0	0	0		0	0	0	203625	0	861467	40165015		
173438	3813	40213160	1972-06-17	1972-06-17 00:00:00	1972-06-17	1972-06-17 00:00:00	1972-06-17	581452		0	0	0		0	0	0	253282	0	10	40213160		
170646	3752	40213160	1958-05-22	1958-05-22 00:00:00	1958-05-22	1958-05-22 00:00:00	1958-05-22	581452		0	0	0		0	0	0	249324	0	10	40213160		
9100	757	40163554	1976-01-11	1976-01-11 00:00:00	1976-01-11	1976-01-11 00:00:00	\N	38000177		0	0	0		0	0	0	50264	0	855332	40163554		
40893	890	40213160	1959-11-06	1959-11-06 00:00:00	1959-11-06	1959-11-06 00:00:00	1959-11-06	581452		0	0	0		0	0	0	59357	0	10	40213160		
38954	3219	1115171	2005-11-08	2005-11-08 00:00:00	2006-02-06	2006-02-06 00:00:00	2006-02-06	38000177		0	0	90		0	0	0	213931	0	849574	1115171		
218907	4804	40213306	1999-05-24	1999-05-24 00:00:00	1999-05-24	1999-05-24 00:00:00	1999-05-24	581452		0	0	0		0	0	0	319655	0	43	40213306		
24357	2004	1713671	1990-02-25	1990-02-25 00:00:00	1990-03-04	1990-03-04 00:00:00	1990-03-04	38000177		0	0	7		0	0	0	133442	0	562251	1713671		
7929	662	19126352	2012-10-03	2012-10-03 00:00:00	2012-10-03	2012-10-03 00:00:00	\N	38000177		0	0	0		0	0	0	43762	0	705129	19126352		
4721	394	1127433	1953-03-10	1953-03-10 00:00:00	1953-03-24	1953-03-24 00:00:00	1953-03-24	38000177		0	0	14		0	0	0	25894	0	313782	1127433		
51361	4269	19078461	2006-07-07	2006-07-07 00:00:00	2006-09-05	2006-09-05 00:00:00	2006-09-05	38000177		0	0	60		0	0	0	283354	0	310965	19078461		
46504	3852	1713671	1982-12-18	1982-12-18 00:00:00	1983-01-01	1983-01-01 00:00:00	1983-01-01	38000177		0	0	14		0	0	0	255636	0	562251	1713671		
13110	1100	19078461	1995-04-24	1995-04-24 00:00:00	1995-05-08	1995-05-08 00:00:00	1995-05-08	38000177		0	0	14		0	0	0	72273	0	310965	19078461		
123557	2715	40213260	2016-01-14	2016-01-14 00:00:00	2016-01-14	2016-01-14 00:00:00	2016-01-14	581452		0	0	0		0	0	0	180074	0	121	40213260		
23630	1945	1713671	1995-02-19	1995-02-19 00:00:00	1995-03-12	1995-03-12 00:00:00	1995-03-12	38000177		0	0	21		0	0	0	129203	0	562251	1713671		
29180	2414	40229134	1944-10-31	1944-10-31 00:00:00	1944-11-07	1944-11-07 00:00:00	1944-11-07	38000177		0	0	7		0	0	0	160215	0	1043400	40229134		
23728	1951	19078461	1993-05-31	1993-05-31 00:00:00	1993-07-30	1993-07-30 00:00:00	1993-07-30	38000177		0	0	60		0	0	0	129771	0	310965	19078461		
57202	4748	19059056	1946-08-27	1946-08-27 00:00:00	1946-11-25	1946-11-25 00:00:00	1946-11-25	38000177		0	0	90		0	0	0	316139	0	243670	19059056		
14050	1175	19078461	1981-07-14	1981-07-14 00:00:00	1981-07-28	1981-07-28 00:00:00	1981-07-28	38000177		0	0	14		0	0	0	77532	0	310965	19078461		
177895	3909	40213296	2002-12-20	2002-12-20 00:00:00	2002-12-20	2002-12-20 00:00:00	2002-12-20	581452		0	0	0		0	0	0	259865	0	52	40213296		
24604	2025	19075601	2009-05-30	2009-05-30 00:00:00	2009-05-30	2009-05-30 00:00:00	2009-05-30	38000177		0	0	0		0	0	0	134745	0	309362	19075601		
224548	4929	40213306	1984-01-28	1984-01-28 00:00:00	1984-01-28	1984-01-28 00:00:00	1984-01-28	581452		0	0	0		0	0	0	327711	0	43	40213306		
123237	2708	40213160	1959-05-18	1959-05-18 00:00:00	1959-05-18	1959-05-18 00:00:00	1959-05-18	581452		0	0	0		0	0	0	179369	0	10	40213160		
16109	1335	1124300	2017-06-28	2017-06-28 00:00:00	2017-06-28	2017-06-28 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00781178901	45011828		
14510	1216	1124300	2012-05-09	2012-05-09 00:00:00	2012-05-09	2012-05-09 00:00:00	\N	38000177		0	0	0		0	0	0	80085	0	00781178901	45011828		
30839	2554	19078461	2015-12-26	2015-12-26 00:00:00	2016-03-25	2016-03-25 00:00:00	2016-03-25	38000177		0	0	90		0	0	0	169199	0	310965	19078461		
56715	4705	1713671	2019-06-21	2019-06-21 00:00:00	2019-06-21	2019-06-21 00:00:00	\N	38000177		0	0	0		0	0	0	313471	0	562251	1713671		
45349	3752	1127078	1963-07-14	1963-07-14 00:00:00	1963-07-28	1963-07-28 00:00:00	1963-07-28	38000177		0	0	14		0	0	0	249364	0	282464	1127078		
45377	3754	1118084	2005-03-10	2005-03-10 00:00:00	2005-03-10	2005-03-10 00:00:00	\N	38000177		0	0	0		0	0	0	249551	0	00025152531	44923712		
33002	2736	1127433	2019-05-16	2019-05-16 00:00:00	2019-06-06	2019-06-06 00:00:00	2019-06-06	38000177		0	0	21		0	0	0	181079	0	313782	1127433		
180780	3973	40213160	1969-01-02	1969-01-02 00:00:00	1969-01-02	1969-01-02 00:00:00	1969-01-02	581452		0	0	0		0	0	0	264207	0	10	40213160		
13529	292	40213314	1977-11-19	1977-11-19 00:00:00	1977-11-19	1977-11-19 00:00:00	1977-11-19	581452		0	0	0		0	0	0	19474	0	49	40213314		
223598	4909	40213296	2015-06-22	2015-06-22 00:00:00	2015-06-22	2015-06-22 00:00:00	2015-06-22	581452		0	0	0		0	0	0	326272	0	52	40213296		
6360	534	1713671	1982-04-10	1982-04-10 00:00:00	1982-05-02	1982-05-02 00:00:00	1982-05-02	38000177		0	0	22		0	0	0	35591	0	562251	1713671		
55141	4578	19078461	1981-10-20	1981-10-20 00:00:00	1981-11-10	1981-11-10 00:00:00	1981-11-10	38000177		0	0	21		0	0	0	305003	0	310965	19078461		
49209	4084	46275916	2010-10-03	2010-10-03 00:00:00	2010-10-03	2010-10-03 00:00:00	2010-10-03	38000177		0	0	0		0	0	0	271438	0	1660014	46275916		
22907	1885	1127078	1976-02-12	1976-02-12 00:00:00	1976-02-26	1976-02-26 00:00:00	1976-02-26	38000177		0	0	14		0	0	0	125723	0	282464	1127078		
213170	4674	40213160	1969-01-28	1969-01-28 00:00:00	1969-01-28	1969-01-28 00:00:00	1969-01-28	581452		0	0	0		0	0	0	311370	0	10	40213160		
15925	1321	1127433	1999-11-02	1999-11-02 00:00:00	1999-11-16	1999-11-16 00:00:00	1999-11-16	38000177		0	0	14		0	0	0	87600	0	313782	1127433		
495	36	19018935	2018-01-09	2018-01-09 00:00:00	2018-01-09	2018-01-09 00:00:00	\N	38000177		0	0	0		0	0	0	2600	0	197604	19018935		
26478	2177	19059056	1971-05-17	1971-05-17 00:00:00	1971-05-31	1971-05-31 00:00:00	1971-05-31	38000177		0	0	14		0	0	0	145216	0	243670	19059056		
44313	3668	19078461	2001-08-26	2001-08-26 00:00:00	2001-09-23	2001-09-23 00:00:00	2001-09-23	38000177		0	0	28		0	0	0	244021	0	310965	19078461		
216932	4759	40213160	1981-08-18	1981-08-18 00:00:00	1981-08-18	1981-08-18 00:00:00	1981-08-18	581452		0	0	0		0	0	0	317106	0	10	40213160		
8560	712	19133873	1990-07-13	1990-07-13 00:00:00	1990-07-26	1990-07-26 00:00:00	1990-07-26	38000177		0	0	13		0	0	0	47224	0	834061	19133873		
101960	2235	40213160	1955-11-09	1955-11-09 00:00:00	1955-11-09	1955-11-09 00:00:00	1955-11-09	581452		0	0	0		0	0	0	148642	0	10	40213160		
150122	3301	40213227	1999-06-08	1999-06-08 00:00:00	1999-06-08	1999-06-08 00:00:00	1999-06-08	581452		0	0	0		0	0	0	219351	0	113	40213227		
19134	1579	1127078	1965-06-26	1965-06-26 00:00:00	1965-07-10	1965-07-10 00:00:00	1965-07-10	38000177		0	0	14		0	0	0	106103	0	282464	1127078		
85194	1864	40213296	2007-12-14	2007-12-14 00:00:00	2007-12-14	2007-12-14 00:00:00	2007-12-14	581452		0	0	0		0	0	0	124534	0	52	40213296		
153621	3381	40213227	2014-02-17	2014-02-17 00:00:00	2014-02-17	2014-02-17 00:00:00	2014-02-17	581452		0	0	0		0	0	0	224380	0	113	40213227		
74279	1622	40213160	1975-02-03	1975-02-03 00:00:00	1975-02-03	1975-02-03 00:00:00	1975-02-03	581452		0	0	0		0	0	0	108966	0	10	40213160		
58282	4843	1127078	1964-02-10	1964-02-10 00:00:00	1964-02-24	1964-02-24 00:00:00	1964-02-24	38000177		0	0	14		0	0	0	322120	0	282464	1127078		
33917	741	40213314	1977-11-04	1977-11-04 00:00:00	1977-11-04	1977-11-04 00:00:00	1977-11-04	581452		0	0	0		0	0	0	49087	0	49	40213314		
17184	1426	1118084	1986-09-19	1986-09-19 00:00:00	1986-09-19	1986-09-19 00:00:00	\N	38000177		0	0	0		0	0	0	94864	0	00025152531	44923712		
191698	4212	40213227	2001-02-16	2001-02-16 00:00:00	2001-02-16	2001-02-16 00:00:00	2001-02-16	581452		0	0	0		0	0	0	279634	0	113	40213227		
11461	954	19129655	1974-05-14	1974-05-14 00:00:00	1974-05-28	1974-05-28 00:00:00	1974-05-28	38000177		0	0	14		0	0	0	63385	0	789980	19129655		
20330	1669	19059056	1965-01-22	1965-01-22 00:00:00	1965-04-22	1965-04-22 00:00:00	1965-04-22	38000177		0	0	90		0	0	0	112069	0	243670	19059056		
51680	4295	1127078	1976-12-25	1976-12-25 00:00:00	1977-01-08	1977-01-08 00:00:00	1977-01-08	38000177		0	0	14		0	0	0	285080	0	282464	1127078		
31807	2636	40229134	2011-11-11	2011-11-11 00:00:00	2011-11-18	2011-11-18 00:00:00	2011-11-18	38000177		0	0	7		0	0	0	174468	0	1043400	40229134		
6605	144	40213227	2006-03-31	2006-03-31 00:00:00	2006-03-31	2006-03-31 00:00:00	2006-03-31	581452		0	0	0		0	0	0	9616	0	113	40213227		
64171	5328	40229134	1974-08-13	1974-08-13 00:00:00	1974-08-27	1974-08-27 00:00:00	1974-08-27	38000177		0	0	14		0	0	0	354624	0	1043400	40229134		
45009	3725	1118084	2006-11-13	2006-11-13 00:00:00	2006-11-13	2006-11-13 00:00:00	\N	38000177		0	0	0		0	0	0	247585	0	00025152531	44923712		
61665	5132	19133873	1968-11-28	1968-11-28 00:00:00	1968-12-11	1968-12-11 00:00:00	1968-12-11	38000177		0	0	13		0	0	0	341128	0	834061	19133873		
19432	1602	19078461	2006-05-25	2006-05-25 00:00:00	2006-07-24	2006-07-24 00:00:00	2006-07-24	38000177		0	0	60		0	0	0	107525	0	310965	19078461		
174176	3830	40213227	2013-07-01	2013-07-01 00:00:00	2013-07-01	2013-07-01 00:00:00	2013-07-01	581452		0	0	0		0	0	0	254319	0	113	40213227		
37001	3060	1713671	1964-08-20	1964-08-20 00:00:00	1964-09-10	1964-09-10 00:00:00	1964-09-10	38000177		0	0	21		0	0	0	203572	0	562251	1713671		
173441	3813	40213227	1993-12-11	1993-12-11 00:00:00	1993-12-11	1993-12-11 00:00:00	1993-12-11	581452		0	0	0		0	0	0	253262	0	113	40213227		
170647	3752	40213160	1958-03-20	1958-03-20 00:00:00	1958-03-20	1958-03-20 00:00:00	1958-03-20	581452		0	0	0		0	0	0	249314	0	10	40213160		
9101	757	1118084	1949-11-14	1949-11-14 00:00:00	1949-11-14	1949-11-14 00:00:00	\N	38000177		0	0	0		0	0	0	50285	0	00025152531	44923712		
40894	890	40213296	1999-06-04	1999-06-04 00:00:00	1999-06-04	1999-06-04 00:00:00	1999-06-04	581452		0	0	0		0	0	0	59283	0	52	40213296		
38955	3219	19133873	1986-12-28	1986-12-28 00:00:00	1987-01-10	1987-01-10 00:00:00	1987-01-10	38000177		0	0	13		0	0	0	213918	0	834061	19133873		
218912	4804	40213314	1978-05-29	1978-05-29 00:00:00	1978-05-29	1978-05-29 00:00:00	1978-05-29	581452		0	0	0		0	0	0	319649	0	49	40213314		
24358	2004	46233988	1972-02-26	1972-02-26 00:00:00	1972-03-11	1972-03-11 00:00:00	1972-03-11	38000177		0	0	14		0	0	0	133454	0	1652673	46233988		
7933	664	1127433	2007-05-20	2007-05-20 00:00:00	2007-06-03	2007-06-03 00:00:00	2007-06-03	38000177		0	0	14		0	0	0	43891	0	313782	1127433		
4722	394	19126352	1978-06-05	1978-06-05 00:00:00	1989-03-27	1989-03-27 00:00:00	1989-03-27	38000177		0	0	3948		0	0	0	25853	0	705129	19126352		
51362	4269	1124300	2007-06-11	2007-06-11 00:00:00	2007-06-11	2007-06-11 00:00:00	\N	38000177		0	0	0		0	0	0	283354	0	00781178901	45011828		
46505	3852	19008572	1970-10-12	1970-10-12 00:00:00	1970-10-12	1970-10-12 00:00:00	\N	38000177		0	0	0		0	0	0	255635	0	106258	19008572		
35013	2892	19078461	1990-12-22	1990-12-22 00:00:00	1991-01-12	1991-01-12 00:00:00	1991-01-12	38000177		0	0	21		0	0	0	192416	0	310965	19078461		
85	2	40213227	2001-07-31	2001-07-31 00:00:00	2001-07-31	2001-07-31 00:00:00	2001-07-31	581452		0	0	0		0	0	0	89	0	113	40213227		
23631	1945	19059056	1983-09-09	1983-09-09 00:00:00	1983-09-23	1983-09-23 00:00:00	1983-09-23	38000177		0	0	14		0	0	0	129215	0	243670	19059056		
191128	4199	40213227	1992-05-21	1992-05-21 00:00:00	1992-05-21	1992-05-21 00:00:00	1992-05-21	581452		0	0	0		0	0	0	278716	0	113	40213227		
23729	1951	1713671	2015-12-22	2015-12-22 00:00:00	2016-01-05	2016-01-05 00:00:00	2016-01-05	38000177		0	0	14		0	0	0	129762	0	562251	1713671		
57203	4748	1127433	2004-04-04	2004-04-04 00:00:00	2004-04-11	2004-04-11 00:00:00	2004-04-11	38000177		0	0	7		0	0	0	316144	0	313782	1127433		
14051	1175	1127433	1979-06-25	1979-06-25 00:00:00	1979-07-09	1979-07-09 00:00:00	1979-07-09	38000177		0	0	14		0	0	0	77420	0	313782	1127433		
115954	2548	40213227	2017-02-05	2017-02-05 00:00:00	2017-02-05	2017-02-05 00:00:00	2017-02-05	581452		0	0	0		0	0	0	168724	0	113	40213227		
24605	2025	19059056	1918-09-01	1918-09-01 00:00:00	1918-09-15	1918-09-15 00:00:00	1918-09-15	38000177		0	0	14		0	0	0	134662	0	243670	19059056		
224551	4929	40213160	1962-03-24	1962-03-24 00:00:00	1962-03-24	1962-03-24 00:00:00	1962-03-24	581452		0	0	0		0	0	0	327721	0	10	40213160		
123241	2708	40213227	1995-10-23	1995-10-23 00:00:00	1995-10-23	1995-10-23 00:00:00	1995-10-23	581452		0	0	0		0	0	0	179425	0	113	40213227		
16110	1335	19133873	1984-12-15	1984-12-15 00:00:00	1984-12-27	1984-12-27 00:00:00	1984-12-27	38000177		0	0	12		0	0	0	88562	0	834061	19133873		
14511	1216	1127433	2005-12-18	2005-12-18 00:00:00	2005-12-25	2005-12-25 00:00:00	2005-12-25	38000177		0	0	7		0	0	0	80099	0	313782	1127433		
30840	2554	40173590	2003-12-25	2003-12-25 00:00:00	2003-12-25	2003-12-25 00:00:00	\N	38000177		0	0	0		0	0	0	169107	0	904419	40173590		
56716	4705	19128065	1989-05-27	1989-05-27 00:00:00	1990-05-22	1990-05-22 00:00:00	1990-05-22	38000177		0	0	360		0	0	0	313482	0	749882	19128065		
45350	3752	920300	1996-01-07	1996-01-07 00:00:00	1996-01-14	1996-01-14 00:00:00	1996-01-14	38000177		0	0	7		0	0	0	249308	0	311989	920300		
45378	3754	19128065	1978-12-02	1978-12-02 00:00:00	1979-11-27	1979-11-27 00:00:00	1979-11-27	38000177		0	0	360		0	0	0	249546	0	749882	19128065		
33003	2736	1118084	2015-07-11	2015-07-11 00:00:00	2015-07-11	2015-07-11 00:00:00	\N	38000177		0	0	0		0	0	0	181149	0	00025152531	44923712		
180782	3973	40213160	1968-10-31	1968-10-31 00:00:00	1968-10-31	1968-10-31 00:00:00	1968-10-31	581452		0	0	0		0	0	0	264182	0	10	40213160		
44521	3686	1118084	2009-10-30	2009-10-30 00:00:00	2009-10-30	2009-10-30 00:00:00	\N	38000177		0	0	0		0	0	0	245027	0	00025152531	44923712		
223604	4909	40213160	1980-05-26	1980-05-26 00:00:00	1980-05-26	1980-05-26 00:00:00	1980-05-26	581452		0	0	0		0	0	0	326268	0	10	40213160		
6361	534	19059056	1983-09-09	1983-09-09 00:00:00	1983-09-23	1983-09-23 00:00:00	1983-09-23	38000177		0	0	14		0	0	0	35582	0	243670	19059056		
55142	4578	19128065	1979-05-16	1979-05-16 00:00:00	1980-05-10	1980-05-10 00:00:00	1980-05-10	38000177		0	0	360		0	0	0	304951	0	749882	19128065		
49210	4084	19078461	1994-08-18	1994-08-18 00:00:00	1994-09-17	1994-09-17 00:00:00	1994-09-17	38000177		0	0	30		0	0	0	271437	0	310965	19078461		
22908	1885	46233988	1976-02-12	1976-02-12 00:00:00	1976-02-26	1976-02-26 00:00:00	1976-02-26	38000177		0	0	14		0	0	0	125723	0	1652673	46233988		
213172	4674	40213227	1999-11-30	1999-11-30 00:00:00	1999-11-30	1999-11-30 00:00:00	1999-11-30	581452		0	0	0		0	0	0	311362	0	113	40213227		
15926	1321	1127433	2015-12-11	2015-12-11 00:00:00	2015-12-18	2015-12-18 00:00:00	2015-12-18	38000177		0	0	7		0	0	0	87642	0	313782	1127433		
496	36	40171902	2018-01-09	2018-01-09 00:00:00	2018-01-09	2018-01-09 00:00:00	\N	38000177		0	0	0		0	0	0	2600	0	897718	40171902		
26479	2177	19006318	1971-05-17	1971-05-17 00:00:00	1971-05-31	1971-05-31 00:00:00	1971-05-31	38000177		0	0	14		0	0	0	145216	0	105078	19006318		
44314	3668	19078461	2008-08-17	2008-08-17 00:00:00	2008-09-07	2008-09-07 00:00:00	2008-09-07	38000177		0	0	21		0	0	0	244022	0	310965	19078461		
238465	5234	40213227	1998-04-29	1998-04-29 00:00:00	1998-04-29	1998-04-29 00:00:00	1998-04-29	581452		0	0	0		0	0	0	348208	0	113	40213227		
8561	712	1713671	2010-03-17	2010-03-17 00:00:00	2010-04-07	2010-04-07 00:00:00	2010-04-07	38000177		0	0	21		0	0	0	47225	0	562251	1713671		
101964	2235	40213160	1956-11-14	1956-11-14 00:00:00	1956-11-14	1956-11-14 00:00:00	1956-11-14	581452		0	0	0		0	0	0	148685	0	10	40213160		
7950	171	40213227	2010-03-15	2010-03-15 00:00:00	2010-03-15	2010-03-15 00:00:00	2010-03-15	581452		0	0	0		0	0	0	11606	0	113	40213227		
19135	1579	40229134	1974-08-18	1974-08-18 00:00:00	1974-09-01	1974-09-01 00:00:00	1974-09-01	38000177		0	0	14		0	0	0	106088	0	1043400	40229134		
85196	1864	40213227	2007-12-14	2007-12-14 00:00:00	2007-12-14	2007-12-14 00:00:00	2007-12-14	581452		0	0	0		0	0	0	124534	0	113	40213227		
49589	1085	40213160	1965-04-10	1965-04-10 00:00:00	1965-04-10	1965-04-10 00:00:00	1965-04-10	581452		0	0	0		0	0	0	71291	0	10	40213160		
74281	1622	40213314	1977-10-31	1977-10-31 00:00:00	1977-10-31	1977-10-31 00:00:00	1977-10-31	581452		0	0	0		0	0	0	108948	0	49	40213314		
58283	4843	19133873	1965-09-04	1965-09-04 00:00:00	1965-09-13	1965-09-13 00:00:00	1965-09-13	38000177		0	0	9		0	0	0	322157	0	834061	19133873		
33923	741	40213160	1979-11-09	1979-11-09 00:00:00	1979-11-09	1979-11-09 00:00:00	1979-11-09	581452		0	0	0		0	0	0	49080	0	10	40213160		
17185	1426	1127433	2013-10-27	2013-10-27 00:00:00	2013-11-17	2013-11-17 00:00:00	2013-11-17	38000177		0	0	21		0	0	0	94878	0	313782	1127433		
202987	4456	40213306	1987-03-22	1987-03-22 00:00:00	1987-03-22	1987-03-22 00:00:00	1987-03-22	581452		0	0	0		0	0	0	296596	0	43	40213306		
11462	954	1127078	1974-05-14	1974-05-14 00:00:00	1974-05-28	1974-05-28 00:00:00	1974-05-28	38000177		0	0	14		0	0	0	63385	0	282464	1127078		
20331	1669	1713671	1960-02-05	1960-02-05 00:00:00	1960-02-19	1960-02-19 00:00:00	1960-02-19	38000177		0	0	14		0	0	0	112050	0	562251	1713671		
51681	4295	46233988	1976-12-25	1976-12-25 00:00:00	1977-01-08	1977-01-08 00:00:00	1977-01-08	38000177		0	0	14		0	0	0	285080	0	1652673	46233988		
31808	2636	40232448	1963-05-06	1963-05-06 00:00:00	1963-05-06	1963-05-06 00:00:00	\N	38000177		0	0	0		0	0	0	174465	0	1049630	40232448		
6606	144	40213314	1977-11-25	1977-11-25 00:00:00	1977-11-25	1977-11-25 00:00:00	1977-11-25	581452		0	0	0		0	0	0	9626	0	49	40213314		
64172	5328	1713671	1941-12-23	1941-12-23 00:00:00	1941-12-30	1941-12-30 00:00:00	1941-12-30	38000177		0	0	7		0	0	0	354623	0	562251	1713671		
45010	3725	1713671	2007-01-14	2007-01-14 00:00:00	2007-01-21	2007-01-21 00:00:00	2007-01-21	38000177		0	0	7		0	0	0	247561	0	562251	1713671		
61666	5132	1124300	2003-06-15	2003-06-15 00:00:00	2003-06-15	2003-06-15 00:00:00	\N	38000177		0	0	0		0	0	0	341131	0	00781178901	45011828		
19433	1602	1127433	1975-06-13	1975-06-13 00:00:00	1975-06-27	1975-06-27 00:00:00	1975-06-27	38000177		0	0	14		0	0	0	107560	0	313782	1127433		
174178	3830	40213251	1984-03-18	1984-03-18 00:00:00	1984-03-18	1984-03-18 00:00:00	1984-03-18	581452		0	0	0		0	0	0	254305	0	21	40213251		
37002	3060	1115171	2010-03-19	2010-03-19 00:00:00	2010-04-09	2010-04-09 00:00:00	2010-04-09	38000177		0	0	21		0	0	0	203630	0	849574	1115171		
173442	3813	40213306	1993-12-11	1993-12-11 00:00:00	1993-12-11	1993-12-11 00:00:00	1993-12-11	581452		0	0	0		0	0	0	253262	0	43	40213306		
170649	3752	40213227	1999-12-23	1999-12-23 00:00:00	1999-12-23	1999-12-23 00:00:00	1999-12-23	581452		0	0	0		0	0	0	249337	0	113	40213227		
9102	757	40236824	1941-12-13	1941-12-13 00:00:00	1941-12-20	1941-12-20 00:00:00	1941-12-20	38000177		0	0	7		0	0	0	50237	0	1094107	40236824		
210886	4625	40213296	2002-05-29	2002-05-29 00:00:00	2002-05-29	2002-05-29 00:00:00	2002-05-29	581452		0	0	0		0	0	0	308104	0	52	40213296		
38956	3219	1127433	1985-05-24	1985-05-24 00:00:00	1985-05-31	1985-05-31 00:00:00	1985-05-31	38000177		0	0	7		0	0	0	213908	0	313782	1127433		
218916	4804	40213227	2010-10-18	2010-10-18 00:00:00	2010-10-18	2010-10-18 00:00:00	2010-10-18	581452		0	0	0		0	0	0	319554	0	113	40213227		
24359	2004	19059056	1972-02-26	1972-02-26 00:00:00	1972-03-11	1972-03-11 00:00:00	1972-03-11	38000177		0	0	14		0	0	0	133454	0	243670	19059056		
7934	664	1127433	2005-04-09	2005-04-09 00:00:00	2005-06-08	2005-06-08 00:00:00	2005-06-08	38000177		0	0	60		0	0	0	43904	0	313782	1127433		
4723	394	1332419	1994-11-21	1994-11-21 00:00:00	1994-11-21	1994-11-21 00:00:00	\N	38000177		0	0	0		0	0	0	25929	0	197361	1332419		
51363	4269	1115171	2013-12-27	2013-12-27 00:00:00	2014-01-31	2014-01-31 00:00:00	2014-01-31	38000177		0	0	35		0	0	0	283355	0	849574	1115171		
46506	3852	1713671	2005-04-19	2005-04-19 00:00:00	2005-05-10	2005-05-10 00:00:00	2005-05-10	38000177		0	0	21		0	0	0	255710	0	562251	1713671		
35014	2892	19078461	2014-03-03	2014-03-03 00:00:00	2014-03-17	2014-03-17 00:00:00	2014-03-17	38000177		0	0	14		0	0	0	192418	0	310965	19078461		
98	2	40213227	1992-10-13	1992-10-13 00:00:00	1992-10-13	1992-10-13 00:00:00	1992-10-13	581452		0	0	0		0	0	0	87	0	113	40213227		
23632	1945	19073188	1983-09-09	1983-09-09 00:00:00	1983-09-23	1983-09-23 00:00:00	1983-09-23	38000177		0	0	14		0	0	0	129215	0	308192	19073188		
191136	4199	40213227	1999-07-08	1999-07-08 00:00:00	1999-07-08	1999-07-08 00:00:00	1999-07-08	581452		0	0	0		0	0	0	278649	0	113	40213227		
23730	1952	1127078	1962-01-22	1962-01-22 00:00:00	1962-02-19	1962-02-19 00:00:00	1962-02-19	38000177		0	0	28		0	0	0	129786	0	282464	1127078		
57204	4748	40229134	1959-03-23	1959-03-23 00:00:00	1959-04-06	1959-04-06 00:00:00	1959-04-06	38000177		0	0	14		0	0	0	316157	0	1043400	40229134		
14052	1175	19059056	1942-07-01	1942-07-01 00:00:00	1942-07-15	1942-07-15 00:00:00	1942-07-15	38000177		0	0	14		0	0	0	77552	0	243670	19059056		
115955	2548	40213260	2017-02-05	2017-02-05 00:00:00	2017-02-05	2017-02-05 00:00:00	2017-02-05	581452		0	0	0		0	0	0	168724	0	121	40213260		
24606	2025	19059056	1963-04-02	1963-04-02 00:00:00	1963-04-23	1963-04-23 00:00:00	1963-04-23	38000177		0	0	21		0	0	0	134738	0	243670	19059056		
224553	4929	40213260	2012-12-22	2012-12-22 00:00:00	2012-12-22	2012-12-22 00:00:00	2012-12-22	581452		0	0	0		0	0	0	327717	0	121	40213260		
123258	2709	40213227	2000-03-14	2000-03-14 00:00:00	2000-03-14	2000-03-14 00:00:00	2000-03-14	581452		0	0	0		0	0	0	179453	0	113	40213227		
16111	1335	1127078	1990-09-02	1990-09-02 00:00:00	1990-10-07	1990-10-07 00:00:00	1990-10-07	38000177		0	0	35		0	0	0	88554	0	282464	1127078		
14512	1216	19059056	1973-03-10	1973-03-10 00:00:00	1973-04-09	1973-04-09 00:00:00	1973-04-09	38000177		0	0	30		0	0	0	80068	0	243670	19059056		
30841	2554	1127433	1991-07-22	1991-07-22 00:00:00	1991-07-29	1991-07-29 00:00:00	1991-07-29	38000177		0	0	7		0	0	0	169153	0	313782	1127433		
56717	4705	1127433	1984-11-28	1984-11-28 00:00:00	1984-12-05	1984-12-05 00:00:00	1984-12-05	38000177		0	0	7		0	0	0	313476	0	313782	1127433		
199893	4390	40213306	1981-08-07	1981-08-07 00:00:00	1981-08-07	1981-08-07 00:00:00	1981-08-07	581452		0	0	0		0	0	0	291830	0	43	40213306		
45379	3754	19133873	1966-06-28	1966-06-28 00:00:00	1966-07-10	1966-07-10 00:00:00	1966-07-10	38000177		0	0	12		0	0	0	249421	0	834061	19133873		
33004	2736	1127433	1982-08-04	1982-08-04 00:00:00	1982-08-18	1982-08-18 00:00:00	1982-08-18	38000177		0	0	14		0	0	0	181130	0	313782	1127433		
180786	3973	40213160	1969-04-03	1969-04-03 00:00:00	1969-04-03	1969-04-03 00:00:00	1969-04-03	581452		0	0	0		0	0	0	264183	0	10	40213160		
44522	3686	1713671	1983-05-13	1983-05-13 00:00:00	1983-05-20	1983-05-20 00:00:00	1983-05-20	38000177		0	0	7		0	0	0	245028	0	562251	1713671		
223607	4909	40213314	1977-05-23	1977-05-23 00:00:00	1977-05-23	1977-05-23 00:00:00	1977-05-23	581452		0	0	0		0	0	0	326262	0	49	40213314		
6362	534	19073183	1983-09-09	1983-09-09 00:00:00	1983-09-23	1983-09-23 00:00:00	1983-09-23	38000177		0	0	14		0	0	0	35582	0	308182	19073183		
55143	4578	19128065	1982-04-30	1982-04-30 00:00:00	1983-04-25	1983-04-25 00:00:00	1983-04-25	38000177		0	0	360		0	0	0	304925	0	749882	19128065		
49211	4084	1124300	1996-11-29	1996-11-29 00:00:00	1996-11-29	1996-11-29 00:00:00	\N	38000177		0	0	0		0	0	0	271430	0	00781178901	45011828		
33367	2765	19075601	2018-05-22	2018-05-22 00:00:00	2018-05-22	2018-05-22 00:00:00	2018-05-22	38000177		0	0	0		0	0	0	182886	0	309362	19075601		
213176	4674	40213296	2008-08-26	2008-08-26 00:00:00	2008-08-26	2008-08-26 00:00:00	2008-08-26	581452		0	0	0		0	0	0	311376	0	52	40213296		
15927	1321	19059056	1961-07-12	1961-07-12 00:00:00	1961-08-09	1961-08-09 00:00:00	1961-08-09	38000177		0	0	28		0	0	0	87597	0	243670	19059056		
497	36	40163554	2018-01-09	2018-01-09 00:00:00	2018-01-09	2018-01-09 00:00:00	\N	38000177		0	0	0		0	0	0	2600	0	855332	40163554		
16008	1328	1713671	1967-06-25	1967-06-25 00:00:00	1967-07-09	1967-07-09 00:00:00	1967-07-09	38000177		0	0	14		0	0	0	88192	0	562251	1713671		
44315	3668	1118084	2013-12-04	2013-12-04 00:00:00	2013-12-04	2013-12-04 00:00:00	\N	38000177		0	0	0		0	0	0	244007	0	00025152531	44923712		
238468	5234	40213201	2003-07-02	2003-07-02 00:00:00	2003-07-02	2003-07-02 00:00:00	2003-07-02	581452		0	0	0		0	0	0	348209	0	33	40213201		
8562	712	1115171	2003-08-07	2003-08-07 00:00:00	2003-10-06	2003-10-06 00:00:00	2003-10-06	38000177		0	0	60		0	0	0	47267	0	849574	1115171		
34857	760	40213260	2014-11-26	2014-11-26 00:00:00	2014-11-26	2014-11-26 00:00:00	2014-11-26	581452		0	0	0		0	0	0	50493	0	121	40213260		
7951	171	40213296	2010-03-15	2010-03-15 00:00:00	2010-03-15	2010-03-15 00:00:00	2010-03-15	581452		0	0	0		0	0	0	11606	0	52	40213296		
19136	1579	19075601	2017-02-23	2017-02-23 00:00:00	2017-02-23	2017-02-23 00:00:00	\N	38000177		0	0	0		0	0	0	106043	0	309362	19075601		
96488	2116	40213160	1955-03-14	1955-03-14 00:00:00	1955-03-14	1955-03-14 00:00:00	1955-03-14	581452		0	0	0		0	0	0	140811	0	10	40213160		
49594	1085	40213306	1987-03-21	1987-03-21 00:00:00	1987-03-21	1987-03-21 00:00:00	1987-03-21	581452		0	0	0		0	0	0	71281	0	43	40213306		
85565	1874	40213296	2016-12-31	2016-12-31 00:00:00	2016-12-31	2016-12-31 00:00:00	2016-12-31	581452		0	0	0		0	0	0	125146	0	52	40213296		
58284	4843	19059056	1974-06-17	1974-06-17 00:00:00	1974-08-16	1974-08-16 00:00:00	1974-08-16	38000177		0	0	60		0	0	0	322106	0	243670	19059056		
33927	741	40213296	2017-05-12	2017-05-12 00:00:00	2017-05-12	2017-05-12 00:00:00	2017-05-12	581452		0	0	0		0	0	0	49066	0	52	40213296		
17186	1426	1713671	1963-11-14	1963-11-14 00:00:00	1963-11-21	1963-11-21 00:00:00	1963-11-21	38000177		0	0	7		0	0	0	94816	0	562251	1713671		
202990	4456	40213160	1965-01-31	1965-01-31 00:00:00	1965-01-31	1965-01-31 00:00:00	1965-01-31	581452		0	0	0		0	0	0	296556	0	10	40213160		
11463	954	19133873	1978-03-06	1978-03-06 00:00:00	1978-03-14	1978-03-14 00:00:00	1978-03-14	38000177		0	0	8		0	0	0	63380	0	834061	19133873		
20332	1669	1539411	1996-11-18	1996-11-18 00:00:00	1996-11-18	1996-11-18 00:00:00	\N	38000177		0	0	0		0	0	0	112115	0	312961	1539411		
51682	4295	1713671	1997-08-17	1997-08-17 00:00:00	1997-08-31	1997-08-31 00:00:00	1997-08-31	38000177		0	0	14		0	0	0	285072	0	562251	1713671		
31809	2636	1127433	2018-07-04	2018-07-04 00:00:00	2018-07-18	2018-07-18 00:00:00	2018-07-18	38000177		0	0	14		0	0	0	174421	0	313782	1127433		
6615	144	40213296	2014-12-26	2014-12-26 00:00:00	2014-12-26	2014-12-26 00:00:00	2014-12-26	581452		0	0	0		0	0	0	9660	0	52	40213296		
64173	5328	19133905	2019-06-17	2019-06-17 00:00:00	2019-06-17	2019-06-17 00:00:00	\N	38000177		0	0	0		0	0	0	354612	0	834102	19133905		
45011	3725	1115171	1998-07-19	1998-07-19 00:00:00	1998-08-23	1998-08-23 00:00:00	1998-08-23	38000177		0	0	35		0	0	0	247577	0	849574	1115171		
61667	5132	1115171	2014-05-03	2014-05-03 00:00:00	2014-06-02	2014-06-02 00:00:00	2014-06-02	38000177		0	0	30		0	0	0	341170	0	849574	1115171		
19434	1602	19006318	1975-06-13	1975-06-13 00:00:00	1975-06-27	1975-06-27 00:00:00	1975-06-27	38000177		0	0	14		0	0	0	107560	0	105078	19006318		
174184	3830	40213251	1986-03-23	1986-03-23 00:00:00	1986-03-23	1986-03-23 00:00:00	1986-03-23	581452		0	0	0		0	0	0	254287	0	21	40213251		
37003	3060	1127433	1932-12-16	1932-12-16 00:00:00	1932-12-23	1932-12-23 00:00:00	1932-12-23	38000177		0	0	7		0	0	0	203570	0	313782	1127433		
173447	3813	40213296	2011-10-15	2011-10-15 00:00:00	2011-10-15	2011-10-15 00:00:00	2011-10-15	581452		0	0	0		0	0	0	253279	0	52	40213296		
170650	3752	40213296	1999-12-23	1999-12-23 00:00:00	1999-12-23	1999-12-23 00:00:00	1999-12-23	581452		0	0	0		0	0	0	249337	0	52	40213296		
9103	757	920300	1941-12-13	1941-12-13 00:00:00	1941-12-20	1941-12-20 00:00:00	1941-12-20	38000177		0	0	7		0	0	0	50237	0	311989	920300		
210888	4625	40213227	2002-05-29	2002-05-29 00:00:00	2002-05-29	2002-05-29 00:00:00	2002-05-29	581452		0	0	0		0	0	0	308104	0	113	40213227		
38957	3219	1127433	1997-09-15	1997-09-15 00:00:00	1997-09-29	1997-09-29 00:00:00	1997-09-29	38000177		0	0	14		0	0	0	213911	0	313782	1127433		
231902	5096	40213160	1972-04-06	1972-04-06 00:00:00	1972-04-06	1972-04-06 00:00:00	1972-04-06	581452		0	0	0		0	0	0	338599	0	10	40213160		
24360	2004	1127433	1987-01-08	1987-01-08 00:00:00	1987-02-12	1987-02-12 00:00:00	1987-02-12	38000177		0	0	35		0	0	0	133463	0	313782	1127433		
7935	664	19008572	2010-07-15	2010-07-15 00:00:00	2010-07-15	2010-07-15 00:00:00	\N	38000177		0	0	0		0	0	0	43804	0	106258	19008572		
4724	394	19059056	1922-03-21	1922-03-21 00:00:00	1922-06-19	1922-06-19 00:00:00	1922-06-19	38000177		0	0	90		0	0	0	25926	0	243670	19059056		
51365	4269	19129655	1968-05-31	1968-05-31 00:00:00	1968-06-14	1968-06-14 00:00:00	1968-06-14	38000177		0	0	14		0	0	0	283326	0	789980	19129655		
46507	3852	40243436	2008-03-31	2008-03-31 00:00:00	2008-03-31	2008-03-31 00:00:00	2008-03-31	38000177		0	0	0		0	0	0	255634	0	1190795	40243436		
35015	2892	1713671	1986-06-21	1986-06-21 00:00:00	1986-07-05	1986-07-05 00:00:00	1986-07-05	38000177		0	0	14		0	0	0	192424	0	562251	1713671		
103	2	40213201	1986-09-09	1986-09-09 00:00:00	1986-09-09	1986-09-09 00:00:00	1986-09-09	581452		0	0	0		0	0	0	193	0	33	40213201		
23633	1945	1127078	1972-11-17	1972-11-17 00:00:00	1973-01-16	1973-01-16 00:00:00	1973-01-16	38000177		0	0	60		0	0	0	129241	0	282464	1127078		
191142	4200	40213227	1999-09-01	1999-09-01 00:00:00	1999-09-01	1999-09-01 00:00:00	1999-09-01	581452		0	0	0		0	0	0	278815	0	113	40213227		
23731	1952	1118084	1989-01-10	1989-01-10 00:00:00	1989-01-10	1989-01-10 00:00:00	\N	38000177		0	0	0		0	0	0	129865	0	00025152531	44923712		
57205	4749	1115171	2014-02-18	2014-02-18 00:00:00	2014-03-27	2014-03-27 00:00:00	2014-03-27	38000177		0	0	37		0	0	0	316225	0	849574	1115171		
14053	1175	1127433	1953-09-20	1953-09-20 00:00:00	1953-09-27	1953-09-27 00:00:00	1953-09-27	38000177		0	0	7		0	0	0	77415	0	313782	1127433		
115956	2548	40213160	1966-01-09	1966-01-09 00:00:00	1966-01-09	1966-01-09 00:00:00	1966-01-09	581452		0	0	0		0	0	0	168713	0	10	40213160		
24607	2025	1127433	2013-10-03	2013-10-03 00:00:00	2013-10-17	2013-10-17 00:00:00	2013-10-17	38000177		0	0	14		0	0	0	134726	0	313782	1127433		
224555	4929	40213227	2012-12-22	2012-12-22 00:00:00	2012-12-22	2012-12-22 00:00:00	2012-12-22	581452		0	0	0		0	0	0	327717	0	113	40213227		
123265	2709	40213227	2011-01-11	2011-01-11 00:00:00	2011-01-11	2011-01-11 00:00:00	2011-01-11	581452		0	0	0		0	0	0	179482	0	113	40213227		
16112	1335	1127433	1981-07-08	1981-07-08 00:00:00	1981-07-15	1981-07-15 00:00:00	1981-07-15	38000177		0	0	7		0	0	0	88604	0	313782	1127433		
15086	326	40213296	2010-06-07	2010-06-07 00:00:00	2010-06-07	2010-06-07 00:00:00	2010-06-07	581452		0	0	0		0	0	0	21538	0	52	40213296		
30842	2554	1127433	1950-08-27	1950-08-27 00:00:00	1950-09-17	1950-09-17 00:00:00	1950-09-17	38000177		0	0	21		0	0	0	169197	0	313782	1127433		
56718	4705	19128065	1991-05-17	1991-05-17 00:00:00	1992-05-11	1992-05-11 00:00:00	1992-05-11	38000177		0	0	360		0	0	0	313483	0	749882	19128065		
199895	4390	40213227	2000-10-06	2000-10-06 00:00:00	2000-10-06	2000-10-06 00:00:00	2000-10-06	581452		0	0	0		0	0	0	291934	0	113	40213227		
45381	3754	19133873	1970-11-18	1970-11-18 00:00:00	1970-11-26	1970-11-26 00:00:00	1970-11-26	38000177		0	0	8		0	0	0	249487	0	834061	19133873		
33005	2736	19074841	1982-08-04	1982-08-04 00:00:00	1982-08-18	1982-08-18 00:00:00	1982-08-18	38000177		0	0	14		0	0	0	181130	0	309043	19074841		
180788	3973	40213306	1990-12-27	1990-12-27 00:00:00	1990-12-27	1990-12-27 00:00:00	1990-12-27	581452		0	0	0		0	0	0	264196	0	43	40213306		
44523	3686	1127433	1972-09-25	1972-09-25 00:00:00	1972-10-09	1972-10-09 00:00:00	1972-10-09	38000177		0	0	14		0	0	0	245065	0	313782	1127433		
223614	4909	40213227	1997-08-18	1997-08-18 00:00:00	1997-08-18	1997-08-18 00:00:00	1997-08-18	581452		0	0	0		0	0	0	326235	0	113	40213227		
6363	534	19128065	1998-05-20	1998-05-20 00:00:00	1999-05-15	1999-05-15 00:00:00	1999-05-15	38000177		0	0	360		0	0	0	35572	0	749882	19128065		
55144	4578	1118084	2000-04-05	2000-04-05 00:00:00	2000-04-05	2000-04-05 00:00:00	\N	38000177		0	0	0		0	0	0	304963	0	00025152531	44923712		
49212	4084	1127078	1973-03-20	1973-03-20 00:00:00	1973-06-18	1973-06-18 00:00:00	1973-06-18	38000177		0	0	90		0	0	0	271434	0	282464	1127078		
33368	2765	40220960	2018-05-22	2018-05-22 00:00:00	2018-05-22	2018-05-22 00:00:00	2018-05-22	38000177		0	0	0		0	0	0	182886	0	1804799	40220960		
213179	4674	40213160	1968-11-26	1968-11-26 00:00:00	1968-11-26	1968-11-26 00:00:00	1968-11-26	581452		0	0	0		0	0	0	311420	0	10	40213160		
15928	1321	19006318	1961-07-12	1961-07-12 00:00:00	1961-08-09	1961-08-09 00:00:00	1961-08-09	38000177		0	0	28		0	0	0	87597	0	105078	19006318		
498	36	1127433	1988-10-26	1988-10-26 00:00:00	1988-11-09	1988-11-09 00:00:00	1988-11-09	38000177		0	0	14		0	0	0	2490	0	313782	1127433		
16009	1328	1127433	2013-01-31	2013-01-31 00:00:00	2013-02-28	2013-02-28 00:00:00	2013-02-28	38000177		0	0	28		0	0	0	88159	0	313782	1127433		
44316	3668	19073188	1991-12-13	1991-12-13 00:00:00	1991-12-27	1991-12-27 00:00:00	1991-12-27	38000177		0	0	14		0	0	0	244044	0	308192	19073188		
238503	5236	40213160	1971-06-16	1971-06-16 00:00:00	1971-06-16	1971-06-16 00:00:00	1971-06-16	581452		0	0	0		0	0	0	348439	0	10	40213160		
8563	712	40231925	2003-08-07	2003-08-07 00:00:00	2003-08-07	2003-08-07 00:00:00	\N	38000177		0	0	0		0	0	0	47267	0	1049221	40231925		
34860	760	40213296	2004-12-01	2004-12-01 00:00:00	2004-12-01	2004-12-01 00:00:00	2004-12-01	581452		0	0	0		0	0	0	50491	0	52	40213296		
7954	171	40213296	2008-03-10	2008-03-10 00:00:00	2008-03-10	2008-03-10 00:00:00	2008-03-10	581452		0	0	0		0	0	0	11636	0	52	40213296		
19137	1579	19126352	2017-02-23	2017-02-23 00:00:00	2017-02-23	2017-02-23 00:00:00	\N	38000177		0	0	0		0	0	0	106043	0	705129	19126352		
96493	2116	40213227	2000-05-15	2000-05-15 00:00:00	2000-05-15	2000-05-15 00:00:00	2000-05-15	581452		0	0	0		0	0	0	140782	0	113	40213227		
49596	1085	40213227	1996-03-30	1996-03-30 00:00:00	1996-03-30	1996-03-30 00:00:00	1996-03-30	581452		0	0	0		0	0	0	71305	0	113	40213227		
85570	1874	40213296	2014-12-27	2014-12-27 00:00:00	2014-12-27	2014-12-27 00:00:00	2014-12-27	581452		0	0	0		0	0	0	125140	0	52	40213296		
58285	4843	40165015	1974-06-17	1974-06-17 00:00:00	1974-06-17	1974-06-17 00:00:00	\N	38000177		0	0	0		0	0	0	322106	0	861467	40165015		
33929	741	40213227	2017-05-12	2017-05-12 00:00:00	2017-05-12	2017-05-12 00:00:00	2017-05-12	581452		0	0	0		0	0	0	49066	0	113	40213227		
51374	1125	40213160	1955-09-02	1955-09-02 00:00:00	1955-09-02	1955-09-02 00:00:00	1955-09-02	581452		0	0	0		0	0	0	74165	0	10	40213160		
202997	4456	40213227	2016-05-01	2016-05-01 00:00:00	2016-05-01	2016-05-01 00:00:00	2016-05-01	581452		0	0	0		0	0	0	296606	0	113	40213227		
11468	956	19059056	1944-12-14	1944-12-14 00:00:00	1945-01-04	1945-01-04 00:00:00	1945-01-04	38000177		0	0	21		0	0	0	63549	0	243670	19059056		
20333	1669	1332419	1996-11-18	1996-11-18 00:00:00	1996-11-18	1996-11-18 00:00:00	\N	38000177		0	0	0		0	0	0	112115	0	197361	1332419		
51683	4295	1127433	1973-07-14	1973-07-14 00:00:00	1973-07-28	1973-07-28 00:00:00	1973-07-28	38000177		0	0	14		0	0	0	285044	0	313782	1127433		
31810	2636	19133768	2019-03-08	2019-03-08 00:00:00	2019-03-08	2019-03-08 00:00:00	2019-03-08	38000177		0	0	0		0	0	0	174490	0	833036	19133768		
6619	144	40213306	1997-03-21	1997-03-21 00:00:00	1997-03-21	1997-03-21 00:00:00	1997-03-21	581452		0	0	0		0	0	0	9654	0	43	40213306		
64174	5328	19078461	1995-09-13	1995-09-13 00:00:00	1995-09-27	1995-09-27 00:00:00	1995-09-27	38000177		0	0	14		0	0	0	354591	0	310965	19078461		
45012	3725	19059056	1970-09-23	1970-09-23 00:00:00	1970-10-14	1970-10-14 00:00:00	1970-10-14	38000177		0	0	21		0	0	0	247589	0	243670	19059056		
61668	5132	1127433	2009-10-01	2009-10-01 00:00:00	2009-10-08	2009-10-08 00:00:00	2009-10-08	38000177		0	0	7		0	0	0	341132	0	313782	1127433		
19435	1602	19078461	1995-09-15	1995-09-15 00:00:00	1995-10-06	1995-10-06 00:00:00	1995-10-06	38000177		0	0	21		0	0	0	107522	0	310965	19078461		
174186	3830	40213160	1986-03-23	1986-03-23 00:00:00	1986-03-23	1986-03-23 00:00:00	1986-03-23	581452		0	0	0		0	0	0	254287	0	10	40213160		
37004	3060	19075601	2003-01-25	2003-01-25 00:00:00	2003-01-25	2003-01-25 00:00:00	2003-01-25	38000177		0	0	0		0	0	0	203629	0	309362	19075601		
71299	1560	40213201	2001-04-16	2001-04-16 00:00:00	2001-04-16	2001-04-16 00:00:00	2001-04-16	581452		0	0	0		0	0	0	104479	0	33	40213201		
170655	3752	40213227	1992-02-27	1992-02-27 00:00:00	1992-02-27	1992-02-27 00:00:00	1992-02-27	581452		0	0	0		0	0	0	249330	0	113	40213227		
9104	757	40171902	1981-02-08	1981-02-08 00:00:00	1981-02-08	1981-02-08 00:00:00	\N	38000177		0	0	0		0	0	0	50270	0	897718	40171902		
210893	4625	40213296	2000-05-24	2000-05-24 00:00:00	2000-05-24	2000-05-24 00:00:00	2000-05-24	581452		0	0	0		0	0	0	308140	0	52	40213296		
38958	3219	1118084	2018-04-24	2018-04-24 00:00:00	2018-04-24	2018-04-24 00:00:00	\N	38000177		0	0	0		0	0	0	213892	0	00025152531	44923712		
231910	5096	40213296	2009-12-10	2009-12-10 00:00:00	2009-12-10	2009-12-10 00:00:00	2009-12-10	581452		0	0	0		0	0	0	338576	0	52	40213296		
24361	2004	1127433	2002-01-06	2002-01-06 00:00:00	2002-01-13	2002-01-13 00:00:00	2002-01-13	38000177		0	0	7		0	0	0	133476	0	313782	1127433		
7936	664	42902245	1998-06-24	1998-06-24 00:00:00	1999-06-19	1999-06-19 00:00:00	1999-06-19	38000177		0	0	360		0	0	0	43861	0	1359133	42902245		
4725	394	19133768	1989-03-27	1989-03-27 00:00:00	1989-03-27	1989-03-27 00:00:00	1989-03-27	38000177		0	0	0		0	0	0	25914	0	833036	19133768		
51366	4269	1127078	1968-05-31	1968-05-31 00:00:00	1968-06-14	1968-06-14 00:00:00	1968-06-14	38000177		0	0	14		0	0	0	283326	0	282464	1127078		
46508	3852	1310034	2008-03-31	2008-03-31 00:00:00	2008-03-31	2008-03-31 00:00:00	2008-03-31	38000177		0	0	0		0	0	0	255634	0	834357	1310034		
35016	2892	1713671	2006-12-01	2006-12-01 00:00:00	2006-12-22	2006-12-22 00:00:00	2006-12-22	38000177		0	0	21		0	0	0	192402	0	562251	1713671		
115138	2530	40213306	1986-05-18	1986-05-18 00:00:00	1986-05-18	1986-05-18 00:00:00	1986-05-18	581452		0	0	0		0	0	0	167228	0	43	40213306		
23634	1945	1118084	2007-06-08	2007-06-08 00:00:00	2007-06-08	2007-06-08 00:00:00	\N	38000177		0	0	0		0	0	0	129207	0	00025152531	44923712		
191144	4200	40213296	2008-06-25	2008-06-25 00:00:00	2008-06-25	2008-06-25 00:00:00	2008-06-25	581452		0	0	0		0	0	0	278789	0	52	40213296		
23732	1952	920300	2006-09-03	2006-09-03 00:00:00	2006-09-10	2006-09-10 00:00:00	2006-09-10	38000177		0	0	7		0	0	0	129780	0	311989	920300		
57206	4749	1118084	2011-05-25	2011-05-25 00:00:00	2011-05-25	2011-05-25 00:00:00	\N	38000177		0	0	0		0	0	0	316279	0	00025152531	44923712		
14054	1175	19059056	1967-02-28	1967-02-28 00:00:00	1967-04-29	1967-04-29 00:00:00	1967-04-29	38000177		0	0	60		0	0	0	77419	0	243670	19059056		
115966	2548	40213160	1970-08-09	1970-08-09 00:00:00	1970-08-09	1970-08-09 00:00:00	1970-08-09	581452		0	0	0		0	0	0	168685	0	10	40213160		
24608	2025	1127433	1984-07-06	1984-07-06 00:00:00	1984-08-03	1984-08-03 00:00:00	1984-08-03	38000177		0	0	28		0	0	0	134743	0	313782	1127433		
69039	1510	40213160	1959-02-08	1959-02-08 00:00:00	1959-02-08	1959-02-08 00:00:00	1959-02-08	581452		0	0	0		0	0	0	100864	0	10	40213160		
42031	3483	19059056	1970-05-09	1970-05-09 00:00:00	1970-07-08	1970-07-08 00:00:00	1970-07-08	38000177		0	0	60		0	0	0	231117	0	243670	19059056		
16113	1335	19128022	1997-10-21	1997-10-21 00:00:00	1998-10-16	1998-10-16 00:00:00	1998-10-16	38000177		0	0	360		0	0	0	88596	0	749785	19128022		
15092	326	40213227	1993-03-08	1993-03-08 00:00:00	1993-03-08	1993-03-08 00:00:00	1993-03-08	581452		0	0	0		0	0	0	21567	0	113	40213227		
30843	2554	40236824	1967-08-18	1967-08-18 00:00:00	1967-08-25	1967-08-25 00:00:00	1967-08-25	38000177		0	0	7		0	0	0	169263	0	1094107	40236824		
56719	4705	1713671	1990-03-17	1990-03-17 00:00:00	1990-04-07	1990-04-07 00:00:00	1990-04-07	38000177		0	0	21		0	0	0	313487	0	562251	1713671		
199896	4390	40213296	2000-10-06	2000-10-06 00:00:00	2000-10-06	2000-10-06 00:00:00	2000-10-06	581452		0	0	0		0	0	0	291934	0	52	40213296		
45382	3754	19133873	1965-05-25	1965-05-25 00:00:00	1965-06-01	1965-06-01 00:00:00	1965-06-01	38000177		0	0	7		0	0	0	249441	0	834061	19133873		
33006	2736	1713671	2000-04-27	2000-04-27 00:00:00	2000-05-18	2000-05-18 00:00:00	2000-05-18	38000177		0	0	21		0	0	0	181105	0	562251	1713671		
192073	4220	40213227	1993-04-13	1993-04-13 00:00:00	1993-04-13	1993-04-13 00:00:00	1993-04-13	581452		0	0	0		0	0	0	280241	0	113	40213227		
44524	3686	19078461	2016-10-01	2016-10-01 00:00:00	2016-10-29	2016-10-29 00:00:00	2016-10-29	38000177		0	0	28		0	0	0	245055	0	310965	19078461		
223615	4909	40213306	1997-08-18	1997-08-18 00:00:00	1997-08-18	1997-08-18 00:00:00	1997-08-18	581452		0	0	0		0	0	0	326235	0	43	40213306		
6364	534	1713671	1978-08-27	1978-08-27 00:00:00	1978-09-10	1978-09-10 00:00:00	1978-09-10	38000177		0	0	14		0	0	0	35526	0	562251	1713671		
55145	4578	1127433	1998-06-05	1998-06-05 00:00:00	1998-06-19	1998-06-19 00:00:00	1998-06-19	38000177		0	0	14		0	0	0	304948	0	313782	1127433		
49213	4084	1713671	1980-09-29	1980-09-29 00:00:00	1980-10-06	1980-10-06 00:00:00	1980-10-06	38000177		0	0	7		0	0	0	271400	0	562251	1713671		
33369	2765	1127433	1998-01-31	1998-01-31 00:00:00	1998-02-14	1998-02-14 00:00:00	1998-02-14	38000177		0	0	14		0	0	0	182894	0	313782	1127433		
224467	4927	40213227	2010-06-04	2010-06-04 00:00:00	2010-06-04	2010-06-04 00:00:00	2010-06-04	581452		0	0	0		0	0	0	327461	0	113	40213227		
15929	1321	40229134	2000-10-15	2000-10-15 00:00:00	2000-10-29	2000-10-29 00:00:00	2000-10-29	38000177		0	0	14		0	0	0	87674	0	1043400	40229134		
10957	914	19059056	1948-08-10	1948-08-10 00:00:00	1948-08-24	1948-08-24 00:00:00	1948-08-24	38000177		0	0	14		0	0	0	60745	0	243670	19059056		
16011	1328	1127433	1976-02-26	1976-02-26 00:00:00	1976-04-26	1976-04-26 00:00:00	1976-04-26	38000177		0	0	60		0	0	0	88210	0	313782	1127433		
44317	3668	19078461	1991-12-13	1991-12-13 00:00:00	1991-12-27	1991-12-27 00:00:00	1991-12-27	38000177		0	0	14		0	0	0	244044	0	310965	19078461		
223934	4916	40213227	2019-06-28	2019-06-28 00:00:00	2019-06-28	2019-06-28 00:00:00	2019-06-28	581452		0	0	0		0	0	0	326713	0	113	40213227		
8564	712	1127433	2011-07-27	2011-07-27 00:00:00	2011-08-03	2011-08-03 00:00:00	2011-08-03	38000177		0	0	7		0	0	0	47217	0	313782	1127433		
34861	761	40213314	1980-02-22	1980-02-22 00:00:00	1980-02-22	1980-02-22 00:00:00	1980-02-22	581452		0	0	0		0	0	0	50603	0	49	40213314		
7957	171	40213160	1973-02-18	1973-02-18 00:00:00	1973-02-18	1973-02-18 00:00:00	1973-02-18	581452		0	0	0		0	0	0	11589	0	10	40213160		
19138	1579	1332419	2017-02-23	2017-02-23 00:00:00	2017-02-23	2017-02-23 00:00:00	\N	38000177		0	0	0		0	0	0	106043	0	197361	1332419		
96510	2116	40213198	2015-02-02	2015-02-02 00:00:00	2015-02-02	2015-02-02 00:00:00	2015-02-02	581452		0	0	0		0	0	0	140784	0	133	40213198		
49599	1085	40213227	2006-09-02	2006-09-02 00:00:00	2006-09-02	2006-09-02 00:00:00	2006-09-02	581452		0	0	0		0	0	0	71286	0	113	40213227		
85572	1874	40213227	2014-12-27	2014-12-27 00:00:00	2014-12-27	2014-12-27 00:00:00	2014-12-27	581452		0	0	0		0	0	0	125140	0	113	40213227		
58286	4843	19133905	1981-12-22	1981-12-22 00:00:00	1981-12-29	1981-12-29 00:00:00	1981-12-29	38000177		0	0	7		0	0	0	322150	0	834102	19133905		
33933	741	40213160	1975-03-07	1975-03-07 00:00:00	1975-03-07	1975-03-07 00:00:00	1975-03-07	581452		0	0	0		0	0	0	49056	0	10	40213160		
51380	1125	40213227	2012-04-06	2012-04-06 00:00:00	2012-04-06	2012-04-06 00:00:00	2012-04-06	581452		0	0	0		0	0	0	74162	0	113	40213227		
202998	4456	40213260	2016-05-01	2016-05-01 00:00:00	2016-05-01	2016-05-01 00:00:00	2016-05-01	581452		0	0	0		0	0	0	296606	0	121	40213260		
11469	956	1127433	1949-08-29	1949-08-29 00:00:00	1949-09-12	1949-09-12 00:00:00	1949-09-12	38000177		0	0	14		0	0	0	63491	0	313782	1127433		
20334	1669	19126352	1996-11-18	1996-11-18 00:00:00	1996-11-18	1996-11-18 00:00:00	\N	38000177		0	0	0		0	0	0	112115	0	705129	19126352		
51684	4295	1118084	2007-09-28	2007-09-28 00:00:00	2007-09-28	2007-09-28 00:00:00	\N	38000177		0	0	0		0	0	0	285096	0	00025152531	44923712		
31811	2636	1545959	2019-03-08	2019-03-08 00:00:00	2019-03-08	2019-03-08 00:00:00	2019-03-08	38000177		0	0	0		0	0	0	174490	0	259255	1545959		
6621	144	40213227	1997-03-21	1997-03-21 00:00:00	1997-03-21	1997-03-21 00:00:00	1997-03-21	581452		0	0	0		0	0	0	9654	0	113	40213227		
64175	5328	1127433	1939-02-03	1939-02-03 00:00:00	1939-02-17	1939-02-17 00:00:00	1939-02-17	38000177		0	0	14		0	0	0	354706	0	313782	1127433		
197610	4342	40213160	1958-03-14	1958-03-14 00:00:00	1958-03-14	1958-03-14 00:00:00	1958-03-14	581452		0	0	0		0	0	0	287852	0	10	40213160		
61669	5132	19128065	1984-07-14	1984-07-14 00:00:00	1985-07-09	1985-07-09 00:00:00	1985-07-09	38000177		0	0	360		0	0	0	341149	0	749882	19128065		
19436	1602	40165015	2001-06-20	2001-06-20 00:00:00	2001-06-20	2001-06-20 00:00:00	\N	38000177		0	0	0		0	0	0	107524	0	861467	40165015		
174188	3830	40213227	2004-06-21	2004-06-21 00:00:00	2004-06-21	2004-06-21 00:00:00	2004-06-21	581452		0	0	0		0	0	0	254316	0	113	40213227		
26948	587	40213296	2018-05-30	2018-05-30 00:00:00	2018-05-30	2018-05-30 00:00:00	2018-05-30	581452		0	0	0		0	0	0	38878	0	52	40213296		
37005	3060	1115171	2002-09-13	2002-09-13 00:00:00	2002-09-27	2002-09-27 00:00:00	2002-09-27	38000177		0	0	14		0	0	0	203629	0	849574	1115171		
170656	3752	40213160	1958-08-21	1958-08-21 00:00:00	1958-08-21	1958-08-21 00:00:00	1958-08-21	581452		0	0	0		0	0	0	249315	0	10	40213160		
9105	757	19133873	1928-05-07	1928-05-07 00:00:00	1928-05-14	1928-05-14 00:00:00	1928-05-14	38000177		0	0	7		0	0	0	50235	0	834061	19133873		
210898	4625	40213260	2010-10-27	2010-10-27 00:00:00	2010-10-27	2010-10-27 00:00:00	2010-10-27	581452		0	0	0		0	0	0	308142	0	121	40213260		
38959	3219	40162522	1996-08-27	1996-08-27 00:00:00	1996-08-27	1996-08-27 00:00:00	\N	38000177		0	0	0		0	0	0	213930	0	857005	40162522		
231912	5096	40213227	2009-12-10	2009-12-10 00:00:00	2009-12-10	2009-12-10 00:00:00	2009-12-10	581452		0	0	0		0	0	0	338576	0	113	40213227		
24362	2004	19073188	2014-02-28	2014-02-28 00:00:00	2014-03-14	2014-03-14 00:00:00	2014-03-14	38000177		0	0	14		0	0	0	133455	0	308192	19073188		
7937	664	19078461	1997-10-30	1997-10-30 00:00:00	1997-11-13	1997-11-13 00:00:00	1997-11-13	38000177		0	0	14		0	0	0	43823	0	310965	19078461		
4726	394	19059056	1938-07-25	1938-07-25 00:00:00	1938-08-08	1938-08-08 00:00:00	1938-08-08	38000177		0	0	14		0	0	0	25913	0	243670	19059056		
51367	4269	19078461	1981-04-14	1981-04-14 00:00:00	1981-05-05	1981-05-05 00:00:00	1981-05-05	38000177		0	0	21		0	0	0	283352	0	310965	19078461		
46509	3852	46275916	2008-03-31	2008-03-31 00:00:00	2008-03-31	2008-03-31 00:00:00	2008-03-31	38000177		0	0	0		0	0	0	255634	0	1660014	46275916		
35017	2892	1118084	2007-06-08	2007-06-08 00:00:00	2007-06-08	2007-06-08 00:00:00	\N	38000177		0	0	0		0	0	0	192402	0	00025152531	44923712		
115144	2530	40213296	2007-09-09	2007-09-09 00:00:00	2007-09-09	2007-09-09 00:00:00	2007-09-09	581452		0	0	0		0	0	0	167242	0	52	40213296		
23635	1946	1127433	1975-01-29	1975-01-29 00:00:00	1975-02-19	1975-02-19 00:00:00	1975-02-19	38000177		0	0	21		0	0	0	129276	0	313782	1127433		
191147	4200	40213160	1968-11-27	1968-11-27 00:00:00	1968-11-27	1968-11-27 00:00:00	1968-11-27	581452		0	0	0		0	0	0	278786	0	10	40213160		
23733	1952	40236824	2006-09-03	2006-09-03 00:00:00	2006-09-10	2006-09-10 00:00:00	2006-09-10	38000177		0	0	7		0	0	0	129780	0	1094107	40236824		
57207	4749	19073183	1979-11-14	1979-11-14 00:00:00	1979-11-28	1979-11-28 00:00:00	1979-11-28	38000177		0	0	14		0	0	0	316228	0	308182	19073183		
14055	1175	19133873	1949-01-15	1949-01-15 00:00:00	1949-01-24	1949-01-24 00:00:00	1949-01-24	38000177		0	0	9		0	0	0	77546	0	834061	19133873		
115967	2548	40213160	1966-03-13	1966-03-13 00:00:00	1966-03-13	1966-03-13 00:00:00	1966-03-13	581452		0	0	0		0	0	0	168697	0	10	40213160		
24609	2025	1713671	1942-12-29	1942-12-29 00:00:00	1943-01-19	1943-01-19 00:00:00	1943-01-19	38000177		0	0	21		0	0	0	134750	0	562251	1713671		
69044	1510	40213260	2008-11-02	2008-11-02 00:00:00	2008-11-02	2008-11-02 00:00:00	2008-11-02	581452		0	0	0		0	0	0	100855	0	121	40213260		
42039	3486	40165015	1991-09-04	1991-09-04 00:00:00	1991-09-04	1991-09-04 00:00:00	\N	38000177		0	0	0		0	0	0	231298	0	861467	40165015		
16114	1335	1127433	2008-03-27	2008-03-27 00:00:00	2008-04-10	2008-04-10 00:00:00	2008-04-10	38000177		0	0	14		0	0	0	88559	0	313782	1127433		
15093	326	40213306	1993-03-08	1993-03-08 00:00:00	1993-03-08	1993-03-08 00:00:00	1993-03-08	581452		0	0	0		0	0	0	21567	0	43	40213306		
30844	2554	920300	1967-08-18	1967-08-18 00:00:00	1967-08-25	1967-08-25 00:00:00	1967-08-25	38000177		0	0	7		0	0	0	169263	0	311989	920300		
56720	4705	19059056	1976-08-23	1976-08-23 00:00:00	1976-09-06	1976-09-06 00:00:00	1976-09-06	38000177		0	0	14		0	0	0	313454	0	243670	19059056		
199900	4390	40213160	1959-05-15	1959-05-15 00:00:00	1959-05-15	1959-05-15 00:00:00	1959-05-15	581452		0	0	0		0	0	0	291904	0	10	40213160		
45383	3754	19059056	1961-04-25	1961-04-25 00:00:00	1961-05-09	1961-05-09 00:00:00	1961-05-09	38000177		0	0	14		0	0	0	249542	0	243670	19059056		
33007	2736	19059056	1970-05-03	1970-05-03 00:00:00	1970-05-17	1970-05-17 00:00:00	1970-05-17	38000177		0	0	14		0	0	0	181106	0	243670	19059056		
67490	1476	40213227	1995-09-21	1995-09-21 00:00:00	1995-09-21	1995-09-21 00:00:00	1995-09-21	581452		0	0	0		0	0	0	98337	0	113	40213227		
44525	3686	19133873	1980-01-17	1980-01-17 00:00:00	1980-01-26	1980-01-26 00:00:00	1980-01-26	38000177		0	0	9		0	0	0	245066	0	834061	19133873		
223618	4909	40213227	2017-02-13	2017-02-13 00:00:00	2017-02-13	2017-02-13 00:00:00	2017-02-13	581452		0	0	0		0	0	0	326244	0	113	40213227		
6365	534	19128065	1992-06-16	1992-06-16 00:00:00	1993-06-11	1993-06-11 00:00:00	1993-06-11	38000177		0	0	360		0	0	0	35507	0	749882	19128065		
55146	4578	1127433	1998-09-19	1998-09-19 00:00:00	1998-10-03	1998-10-03 00:00:00	1998-10-03	38000177		0	0	14		0	0	0	304949	0	313782	1127433		
49214	4084	1127433	1971-08-29	1971-08-29 00:00:00	1971-09-12	1971-09-12 00:00:00	1971-09-12	38000177		0	0	14		0	0	0	271419	0	313782	1127433		
33370	2765	1713671	1935-09-20	1935-09-20 00:00:00	1935-10-11	1935-10-11 00:00:00	1935-10-11	38000177		0	0	21		0	0	0	182904	0	562251	1713671		
224473	4927	40213314	1977-12-30	1977-12-30 00:00:00	1977-12-30	1977-12-30 00:00:00	1977-12-30	581452		0	0	0		0	0	0	327504	0	49	40213314		
15930	1321	19059056	1987-04-25	1987-04-25 00:00:00	1987-05-09	1987-05-09 00:00:00	1987-05-09	38000177		0	0	14		0	0	0	87598	0	243670	19059056		
10958	914	19006318	1948-08-10	1948-08-10 00:00:00	1948-08-24	1948-08-24 00:00:00	1948-08-24	38000177		0	0	14		0	0	0	60745	0	105078	19006318		
16012	1328	1118084	1989-05-01	1989-05-01 00:00:00	1989-05-01	1989-05-01 00:00:00	\N	38000177		0	0	0		0	0	0	88163	0	00025152531	44923712		
44318	3668	19059056	1992-07-02	1992-07-02 00:00:00	1992-08-31	1992-08-31 00:00:00	1992-08-31	38000177		0	0	60		0	0	0	244030	0	243670	19059056		
223935	4916	40213296	2019-06-28	2019-06-28 00:00:00	2019-06-28	2019-06-28 00:00:00	2019-06-28	581452		0	0	0		0	0	0	326713	0	52	40213296		
8565	712	19133873	1989-04-05	1989-04-05 00:00:00	1989-04-16	1989-04-16 00:00:00	1989-04-16	38000177		0	0	11		0	0	0	47231	0	834061	19133873		
34863	761	40213314	1979-03-23	1979-03-23 00:00:00	1979-03-23	1979-03-23 00:00:00	1979-03-23	581452		0	0	0		0	0	0	50616	0	49	40213314		
7962	171	40213260	2018-03-12	2018-03-12 00:00:00	2018-03-12	2018-03-12 00:00:00	2018-03-12	581452		0	0	0		0	0	0	11594	0	121	40213260		
19139	1579	1539411	2017-02-23	2017-02-23 00:00:00	2017-02-23	2017-02-23 00:00:00	\N	38000177		0	0	0		0	0	0	106043	0	312961	1539411		
22047	1812	1713671	2015-06-13	2015-06-13 00:00:00	2015-06-27	2015-06-27 00:00:00	2015-06-27	38000177		0	0	14		0	0	0	121267	0	562251	1713671		
49600	1085	40213296	2006-09-02	2006-09-02 00:00:00	2006-09-02	2006-09-02 00:00:00	2006-09-02	581452		0	0	0		0	0	0	71286	0	52	40213296		
85579	1874	40213227	2006-12-16	2006-12-16 00:00:00	2006-12-16	2006-12-16 00:00:00	2006-12-16	581452		0	0	0		0	0	0	125148	0	113	40213227		
58287	4843	1713671	1980-02-21	1980-02-21 00:00:00	1980-03-13	1980-03-13 00:00:00	1980-03-13	38000177		0	0	21		0	0	0	322114	0	562251	1713671		
26224	571	40213160	1955-08-08	1955-08-08 00:00:00	1955-08-08	1955-08-08 00:00:00	1955-08-08	581452		0	0	0		0	0	0	37845	0	10	40213160		
107985	2366	40213160	1970-08-24	1970-08-24 00:00:00	1970-08-24	1970-08-24 00:00:00	1970-08-24	581452		0	0	0		0	0	0	157543	0	10	40213160		
203000	4456	40213160	1964-11-01	1964-11-01 00:00:00	1964-11-01	1964-11-01 00:00:00	1964-11-01	581452		0	0	0		0	0	0	296584	0	10	40213160		
11470	956	1127433	1956-02-18	1956-02-18 00:00:00	1956-03-24	1956-03-24 00:00:00	1956-03-24	38000177		0	0	35		0	0	0	63554	0	313782	1127433		
20335	1669	40162522	1998-03-30	1998-03-30 00:00:00	1998-03-30	1998-03-30 00:00:00	\N	38000177		0	0	0		0	0	0	112070	0	857005	40162522		
51685	4295	1127433	2017-03-02	2017-03-02 00:00:00	2017-03-09	2017-03-09 00:00:00	2017-03-09	38000177		0	0	7		0	0	0	285063	0	313782	1127433		
31812	2636	1127433	1975-06-26	1975-06-26 00:00:00	1975-07-31	1975-07-31 00:00:00	1975-07-31	38000177		0	0	35		0	0	0	174418	0	313782	1127433		
9795	820	1127433	1991-05-01	1991-05-01 00:00:00	1991-05-08	1991-05-08 00:00:00	1991-05-08	38000177		0	0	7		0	0	0	54327	0	313782	1127433		
64176	5328	40229134	1981-09-19	1981-09-19 00:00:00	1981-10-03	1981-10-03 00:00:00	1981-10-03	38000177		0	0	14		0	0	0	354607	0	1043400	40229134		
197614	4342	40213160	1957-10-11	1957-10-11 00:00:00	1957-10-11	1957-10-11 00:00:00	1957-10-11	581452		0	0	0		0	0	0	287851	0	10	40213160		
61670	5132	19059056	1973-03-04	1973-03-04 00:00:00	1973-06-02	1973-06-02 00:00:00	1973-06-02	38000177		0	0	90		0	0	0	341105	0	243670	19059056		
19437	1602	19078461	2001-06-20	2001-06-20 00:00:00	2001-07-20	2001-07-20 00:00:00	2001-07-20	38000177		0	0	30		0	0	0	107524	0	310965	19078461		
174189	3830	40213306	2004-06-21	2004-06-21 00:00:00	2004-06-21	2004-06-21 00:00:00	2004-06-21	581452		0	0	0		0	0	0	254316	0	43	40213306		
26953	587	40213314	1979-05-30	1979-05-30 00:00:00	1979-05-30	1979-05-30 00:00:00	1979-05-30	581452		0	0	0		0	0	0	38880	0	49	40213314		
37006	3060	40220960	2003-01-25	2003-01-25 00:00:00	2003-01-25	2003-01-25 00:00:00	2003-01-25	38000177		0	0	0		0	0	0	203629	0	1804799	40220960		
170659	3752	40213227	2019-02-14	2019-02-14 00:00:00	2019-02-14	2019-02-14 00:00:00	2019-02-14	581452		0	0	0		0	0	0	249376	0	113	40213227		
9106	757	40236824	1944-01-14	1944-01-14 00:00:00	1944-01-21	1944-01-21 00:00:00	1944-01-21	38000177		0	0	7		0	0	0	50188	0	1094107	40236824		
210905	4625	40213227	1994-09-14	1994-09-14 00:00:00	1994-09-14	1994-09-14 00:00:00	1994-09-14	581452		0	0	0		0	0	0	308138	0	113	40213227		
38960	3219	1127433	1996-08-27	1996-08-27 00:00:00	1996-09-26	1996-09-26 00:00:00	1996-09-26	38000177		0	0	30		0	0	0	213930	0	313782	1127433		
231913	5096	40213260	2018-04-19	2018-04-19 00:00:00	2018-04-19	2018-04-19 00:00:00	2018-04-19	581452		0	0	0		0	0	0	338593	0	121	40213260		
24363	2004	19078461	2014-02-28	2014-02-28 00:00:00	2014-03-14	2014-03-14 00:00:00	2014-03-14	38000177		0	0	14		0	0	0	133455	0	310965	19078461		
7938	664	1124300	2016-12-17	2016-12-17 00:00:00	2016-12-17	2016-12-17 00:00:00	\N	38000177		0	0	0		0	0	0	43817	0	00781178901	45011828		
4727	395	1127433	1982-02-22	1982-02-22 00:00:00	1982-03-08	1982-03-08 00:00:00	1982-03-08	38000177		0	0	14		0	0	0	25953	0	313782	1127433		
51368	4269	40229134	2010-03-23	2010-03-23 00:00:00	2010-03-30	2010-03-30 00:00:00	2010-03-30	38000177		0	0	7		0	0	0	283368	0	1043400	40229134		
46510	3852	1127433	1982-09-20	1982-09-20 00:00:00	1982-10-04	1982-10-04 00:00:00	1982-10-04	38000177		0	0	14		0	0	0	255615	0	313782	1127433		
35018	2892	1115171	2002-09-11	2002-09-11 00:00:00	2002-10-02	2002-10-02 00:00:00	2002-10-02	38000177		0	0	21		0	0	0	192417	0	849574	1115171		
115146	2530	40213160	1968-10-13	1968-10-13 00:00:00	1968-10-13	1968-10-13 00:00:00	1968-10-13	581452		0	0	0		0	0	0	167251	0	10	40213160		
23636	1946	1127433	1942-10-30	1942-10-30 00:00:00	1942-11-13	1942-11-13 00:00:00	1942-11-13	38000177		0	0	14		0	0	0	129315	0	313782	1127433		
191153	4200	40213306	1990-08-22	1990-08-22 00:00:00	1990-08-22	1990-08-22 00:00:00	1990-08-22	581452		0	0	0		0	0	0	278797	0	43	40213306		
23734	1952	40173590	2015-03-02	2015-03-02 00:00:00	2015-03-02	2015-03-02 00:00:00	\N	38000177		0	0	0		0	0	0	129811	0	904419	40173590		
57208	4749	1127078	1979-11-14	1979-11-14 00:00:00	1979-11-28	1979-11-28 00:00:00	1979-11-28	38000177		0	0	14		0	0	0	316228	0	282464	1127078		
14056	1175	19059056	1941-04-24	1941-04-24 00:00:00	1941-05-08	1941-05-08 00:00:00	1941-05-08	38000177		0	0	14		0	0	0	77531	0	243670	19059056		
115971	2548	40213296	2005-10-09	2005-10-09 00:00:00	2005-10-09	2005-10-09 00:00:00	2005-10-09	581452		0	0	0		0	0	0	168689	0	52	40213296		
24610	2025	19059056	1948-01-02	1948-01-02 00:00:00	1948-01-16	1948-01-16 00:00:00	1948-01-16	38000177		0	0	14		0	0	0	134665	0	243670	19059056		
69045	1510	40213160	1963-10-13	1963-10-13 00:00:00	1963-10-13	1963-10-13 00:00:00	1963-10-13	581452		0	0	0		0	0	0	100804	0	10	40213160		
42040	3486	1127433	1991-09-04	1991-09-04 00:00:00	1991-11-03	1991-11-03 00:00:00	1991-11-03	38000177		0	0	60		0	0	0	231298	0	313782	1127433		
16115	1335	19078461	2003-12-19	2003-12-19 00:00:00	2004-01-02	2004-01-02 00:00:00	2004-01-02	38000177		0	0	14		0	0	0	88556	0	310965	19078461		
15100	326	40213160	1974-12-09	1974-12-09 00:00:00	1974-12-09	1974-12-09 00:00:00	1974-12-09	581452		0	0	0		0	0	0	21522	0	10	40213160		
30845	2554	1118084	1968-02-09	1968-02-09 00:00:00	1968-02-09	1968-02-09 00:00:00	\N	38000177		0	0	0		0	0	0	169263	0	00025152531	44923712		
56721	4705	46233988	1976-08-23	1976-08-23 00:00:00	1976-09-06	1976-09-06 00:00:00	1976-09-06	38000177		0	0	14		0	0	0	313454	0	1652673	46233988		
199906	4390	40213160	1959-10-16	1959-10-16 00:00:00	1959-10-16	1959-10-16 00:00:00	1959-10-16	581452		0	0	0		0	0	0	291905	0	10	40213160		
45384	3754	19006318	1961-04-25	1961-04-25 00:00:00	1961-05-09	1961-05-09 00:00:00	1961-05-09	38000177		0	0	14		0	0	0	249542	0	105078	19006318		
33008	2736	19006318	1970-05-03	1970-05-03 00:00:00	1970-05-17	1970-05-17 00:00:00	1970-05-17	38000177		0	0	14		0	0	0	181106	0	105078	19006318		
67504	1476	40213227	2005-12-08	2005-12-08 00:00:00	2005-12-08	2005-12-08 00:00:00	2005-12-08	581452		0	0	0		0	0	0	98474	0	113	40213227		
44526	3686	1127433	2013-02-15	2013-02-15 00:00:00	2013-03-01	2013-03-01 00:00:00	2013-03-01	38000177		0	0	14		0	0	0	245086	0	313782	1127433		
223619	4909	40213296	2017-02-13	2017-02-13 00:00:00	2017-02-13	2017-02-13 00:00:00	2017-02-13	581452		0	0	0		0	0	0	326244	0	52	40213296		
6366	534	19128022	2000-05-09	2000-05-09 00:00:00	2001-05-04	2001-05-04 00:00:00	2001-05-04	38000177		0	0	360		0	0	0	35573	0	749785	19128022		
55147	4578	1713671	1964-09-30	1964-09-30 00:00:00	1964-10-14	1964-10-14 00:00:00	1964-10-14	38000177		0	0	14		0	0	0	304916	0	562251	1713671		
49215	4084	40229134	1987-01-26	1987-01-26 00:00:00	1987-02-09	1987-02-09 00:00:00	1987-02-09	38000177		0	0	14		0	0	0	271405	0	1043400	40229134		
33371	2765	1127433	1984-06-10	1984-06-10 00:00:00	1984-06-24	1984-06-24 00:00:00	1984-06-24	38000177		0	0	14		0	0	0	182919	0	313782	1127433		
224474	4927	40213160	1977-12-30	1977-12-30 00:00:00	1977-12-30	1977-12-30 00:00:00	1977-12-30	581452		0	0	0		0	0	0	327504	0	10	40213160		
15931	1321	40229134	1968-01-26	1968-01-26 00:00:00	1968-02-09	1968-02-09 00:00:00	1968-02-09	38000177		0	0	14		0	0	0	87650	0	1043400	40229134		
10959	914	19078461	2016-08-02	2016-08-02 00:00:00	2016-08-23	2016-08-23 00:00:00	2016-08-23	38000177		0	0	21		0	0	0	60783	0	310965	19078461		
16013	1328	19006318	1947-08-29	1947-08-29 00:00:00	1947-09-12	1947-09-12 00:00:00	1947-09-12	38000177		0	0	14		0	0	0	88137	0	105078	19006318		
44319	3668	40162522	1992-07-02	1992-07-02 00:00:00	1992-07-02	1992-07-02 00:00:00	\N	38000177		0	0	0		0	0	0	244030	0	857005	40162522		
223941	4916	40213227	2011-06-17	2011-06-17 00:00:00	2011-06-17	2011-06-17 00:00:00	2011-06-17	581452		0	0	0		0	0	0	326711	0	113	40213227		
8566	712	40229134	2018-12-25	2018-12-25 00:00:00	2019-01-01	2019-01-01 00:00:00	2019-01-01	38000177		0	0	7		0	0	0	47233	0	1043400	40229134		
34864	761	40213160	1979-03-23	1979-03-23 00:00:00	1979-03-23	1979-03-23 00:00:00	1979-03-23	581452		0	0	0		0	0	0	50616	0	10	40213160		
7967	171	40213306	1988-05-30	1988-05-30 00:00:00	1988-05-30	1988-05-30 00:00:00	1988-05-30	581452		0	0	0		0	0	0	11633	0	43	40213306		
19140	1579	1118084	1988-03-11	1988-03-11 00:00:00	1988-03-11	1988-03-11 00:00:00	\N	38000177		0	0	0		0	0	0	106070	0	00025152531	44923712		
22048	1812	40229134	2005-09-02	2005-09-02 00:00:00	2005-09-16	2005-09-16 00:00:00	2005-09-16	38000177		0	0	14		0	0	0	121294	0	1043400	40229134		
49603	1086	40213260	2016-03-25	2016-03-25 00:00:00	2016-03-25	2016-03-25 00:00:00	2016-03-25	581452		0	0	0		0	0	0	71365	0	121	40213260		
85586	1874	40213160	1974-07-20	1974-07-20 00:00:00	1974-07-20	1974-07-20 00:00:00	1974-07-20	581452		0	0	0		0	0	0	125110	0	10	40213160		
58288	4843	1127433	1988-08-13	1988-08-13 00:00:00	1988-08-20	1988-08-20 00:00:00	1988-08-20	38000177		0	0	7		0	0	0	322152	0	313782	1127433		
26229	571	40213227	2016-06-13	2016-06-13 00:00:00	2016-06-13	2016-06-13 00:00:00	2016-06-13	581452		0	0	0		0	0	0	37777	0	113	40213227		
107988	2367	40213314	1978-03-21	1978-03-21 00:00:00	1978-03-21	1978-03-21 00:00:00	1978-03-21	581452		0	0	0		0	0	0	\N	0	49	40213314		
203008	4456	40213260	2015-04-26	2015-04-26 00:00:00	2015-04-26	2015-04-26 00:00:00	2015-04-26	581452		0	0	0		0	0	0	296562	0	121	40213260		
11471	956	19133873	1941-11-04	1941-11-04 00:00:00	1941-11-14	1941-11-14 00:00:00	1941-11-14	38000177		0	0	10		0	0	0	63504	0	834061	19133873		
20336	1669	1115171	1998-03-30	1998-03-30 00:00:00	1998-05-29	1998-05-29 00:00:00	1998-05-29	38000177		0	0	60		0	0	0	112070	0	849574	1115171		
51686	4295	40229134	1992-06-18	1992-06-18 00:00:00	1992-07-02	1992-07-02 00:00:00	1992-07-02	38000177		0	0	14		0	0	0	285071	0	1043400	40229134		
53595	4454	1127433	1950-02-15	1950-02-15 00:00:00	1950-04-16	1950-04-16 00:00:00	1950-04-16	38000177		0	0	60		0	0	0	296498	0	313782	1127433		
9796	820	19129655	1970-03-12	1970-03-12 00:00:00	1970-03-26	1970-03-26 00:00:00	1970-03-26	38000177		0	0	14		0	0	0	54357	0	789980	19129655		
64177	5328	19133905	1954-08-04	1954-08-04 00:00:00	1954-08-14	1954-08-14 00:00:00	1954-08-14	38000177		0	0	10		0	0	0	354707	0	834102	19133905		
197616	4342	40213227	2018-11-09	2018-11-09 00:00:00	2018-11-09	2018-11-09 00:00:00	2018-11-09	581452		0	0	0		0	0	0	287873	0	113	40213227		
61671	5132	19128065	1982-07-25	1982-07-25 00:00:00	1983-07-20	1983-07-20 00:00:00	1983-07-20	38000177		0	0	360		0	0	0	341139	0	749882	19128065		
19438	1602	40229134	1969-09-04	1969-09-04 00:00:00	1969-09-18	1969-09-18 00:00:00	1969-09-18	38000177		0	0	14		0	0	0	107539	0	1043400	40229134		
173325	3811	40213227	2011-10-27	2011-10-27 00:00:00	2011-10-27	2011-10-27 00:00:00	2011-10-27	581452		0	0	0		0	0	0	253194	0	113	40213227		
26956	587	40213227	2010-05-19	2010-05-19 00:00:00	2010-05-19	2010-05-19 00:00:00	2010-05-19	581452		0	0	0		0	0	0	38908	0	113	40213227		
37007	3060	1127433	1991-11-21	1991-11-21 00:00:00	1991-11-28	1991-11-28 00:00:00	1991-11-28	38000177		0	0	7		0	0	0	203657	0	313782	1127433		
170675	3752	40213260	2007-12-13	2007-12-13 00:00:00	2007-12-13	2007-12-13 00:00:00	2007-12-13	581452		0	0	0		0	0	0	249374	0	121	40213260		
9107	757	920300	1944-01-14	1944-01-14 00:00:00	1944-01-21	1944-01-21 00:00:00	1944-01-21	38000177		0	0	7		0	0	0	50188	0	311989	920300		
210908	4625	40213260	2011-11-02	2011-11-02 00:00:00	2011-11-02	2011-11-02 00:00:00	2011-11-02	581452		0	0	0		0	0	0	308123	0	121	40213260		
38965	3221	1127433	1967-09-09	1967-09-09 00:00:00	1967-09-23	1967-09-23 00:00:00	1967-09-23	38000177		0	0	14		0	0	0	214061	0	313782	1127433		
231914	5096	40213227	2018-04-19	2018-04-19 00:00:00	2018-04-19	2018-04-19 00:00:00	2018-04-19	581452		0	0	0		0	0	0	338593	0	113	40213227		
24364	2004	1127433	2005-11-13	2005-11-13 00:00:00	2005-11-27	2005-11-27 00:00:00	2005-11-27	38000177		0	0	14		0	0	0	133438	0	313782	1127433		
7939	664	19075001	1986-02-27	1986-02-27 00:00:00	1986-03-13	1986-03-13 00:00:00	1986-03-13	38000177		0	0	14		0	0	0	43832	0	309097	19075001		
4728	395	19074679	1972-02-13	1972-02-13 00:00:00	1972-08-27	1972-08-27 00:00:00	1972-08-27	38000177		0	0	196		0	0	0	25938	0	308971	19074679		
51369	4269	19128065	1988-03-27	1988-03-27 00:00:00	1989-03-22	1989-03-22 00:00:00	1989-03-22	38000177		0	0	360		0	0	0	283306	0	749882	19128065		
46511	3852	19006318	1953-08-28	1953-08-28 00:00:00	1953-09-11	1953-09-11 00:00:00	1953-09-11	38000177		0	0	14		0	0	0	255618	0	105078	19006318		
35019	2892	1127078	1974-11-03	1974-11-03 00:00:00	1974-11-17	1974-11-17 00:00:00	1974-11-17	38000177		0	0	14		0	0	0	192403	0	282464	1127078		
115148	2530	40213260	2014-09-28	2014-09-28 00:00:00	2014-09-28	2014-09-28 00:00:00	2014-09-28	581452		0	0	0		0	0	0	167261	0	121	40213260		
23637	1946	19133873	1936-09-13	1936-09-13 00:00:00	1936-09-25	1936-09-25 00:00:00	1936-09-25	38000177		0	0	12		0	0	0	129358	0	834061	19133873		
191157	4200	40213260	2018-06-20	2018-06-20 00:00:00	2018-06-20	2018-06-20 00:00:00	2018-06-20	581452		0	0	0		0	0	0	278791	0	121	40213260		
23736	1952	1127078	1959-09-05	1959-09-05 00:00:00	1959-09-19	1959-09-19 00:00:00	1959-09-19	38000177		0	0	14		0	0	0	129839	0	282464	1127078		
57209	4749	19078461	1999-08-01	1999-08-01 00:00:00	1999-10-07	1999-10-07 00:00:00	1999-10-07	38000177		0	0	67		0	0	0	316223	0	310965	19078461		
14057	1175	19133873	1942-07-20	1942-07-20 00:00:00	1942-08-02	1942-08-02 00:00:00	1942-08-02	38000177		0	0	13		0	0	0	77544	0	834061	19133873		
115977	2548	40213227	1997-05-18	1997-05-18 00:00:00	1997-05-18	1997-05-18 00:00:00	1997-05-18	581452		0	0	0		0	0	0	168717	0	113	40213227		
10049	213	40213160	1967-08-07	1967-08-07 00:00:00	1967-08-07	1967-08-07 00:00:00	1967-08-07	581452		0	0	0		0	0	0	14516	0	10	40213160		
69061	1511	40213260	2015-04-26	2015-04-26 00:00:00	2015-04-26	2015-04-26 00:00:00	2015-04-26	581452		0	0	0		0	0	0	100875	0	121	40213260		
42042	3486	19133873	1964-01-17	1964-01-17 00:00:00	1964-01-26	1964-01-26 00:00:00	1964-01-26	38000177		0	0	9		0	0	0	231226	0	834061	19133873		
39467	3260	1127433	1989-10-07	1989-10-07 00:00:00	1989-10-21	1989-10-21 00:00:00	1989-10-21	38000177		0	0	14		0	0	0	216705	0	313782	1127433		
15110	326	40213160	1970-11-09	1970-11-09 00:00:00	1970-11-09	1970-11-09 00:00:00	1970-11-09	581452		0	0	0		0	0	0	21520	0	10	40213160		
30846	2554	19059056	1965-12-27	1965-12-27 00:00:00	1966-01-17	1966-01-17 00:00:00	1966-01-17	38000177		0	0	21		0	0	0	169198	0	243670	19059056		
56722	4705	1118084	2009-03-23	2009-03-23 00:00:00	2009-03-23	2009-03-23 00:00:00	\N	38000177		0	0	0		0	0	0	313469	0	00025152531	44923712		
199911	4390	40213227	1993-08-20	1993-08-20 00:00:00	1993-08-20	1993-08-20 00:00:00	1993-08-20	581452		0	0	0		0	0	0	291855	0	113	40213227		
45849	3795	1124300	2010-05-25	2010-05-25 00:00:00	2010-05-25	2010-05-25 00:00:00	\N	38000177		0	0	0		0	0	0	252351	0	00781178901	45011828		
33009	2736	1127078	1974-06-24	1974-06-24 00:00:00	1974-07-08	1974-07-08 00:00:00	1974-07-08	38000177		0	0	14		0	0	0	181107	0	282464	1127078		
67508	1476	40213198	2009-12-31	2009-12-31 00:00:00	2009-12-31	2009-12-31 00:00:00	2009-12-31	581452		0	0	0		0	0	0	98340	0	133	40213198		
44527	3686	40229134	1991-11-29	1991-11-29 00:00:00	1991-12-06	1991-12-06 00:00:00	1991-12-06	38000177		0	0	7		0	0	0	245085	0	1043400	40229134		
223620	4909	40213314	1977-11-21	1977-11-21 00:00:00	1977-11-21	1977-11-21 00:00:00	1977-11-21	581452		0	0	0		0	0	0	326249	0	49	40213314		
6367	534	1118084	2014-10-29	2014-10-29 00:00:00	2014-10-29	2014-10-29 00:00:00	\N	38000177		0	0	0		0	0	0	35604	0	00025152531	44923712		
55148	4578	1127433	1970-11-21	1970-11-21 00:00:00	1970-11-28	1970-11-28 00:00:00	1970-11-28	38000177		0	0	7		0	0	0	304919	0	313782	1127433		
49216	4085	19133873	1969-09-08	1969-09-08 00:00:00	1969-09-19	1969-09-19 00:00:00	1969-09-19	38000177		0	0	11		0	0	0	271493	0	834061	19133873		
33372	2765	19059056	1937-06-05	1937-06-05 00:00:00	1937-06-19	1937-06-19 00:00:00	1937-06-19	38000177		0	0	14		0	0	0	183003	0	243670	19059056		
224702	4933	40213296	2010-03-11	2010-03-11 00:00:00	2010-03-11	2010-03-11 00:00:00	2010-03-11	581452		0	0	0		0	0	0	327986	0	52	40213296		
15932	1321	1127078	1962-10-14	1962-10-14 00:00:00	1962-10-28	1962-10-28 00:00:00	1962-10-28	38000177		0	0	14		0	0	0	87605	0	282464	1127078		
10960	914	19133873	1945-11-27	1945-11-27 00:00:00	1945-12-06	1945-12-06 00:00:00	1945-12-06	38000177		0	0	9		0	0	0	60754	0	834061	19133873		
16014	1328	19059056	1947-08-29	1947-08-29 00:00:00	1947-09-12	1947-09-12 00:00:00	1947-09-12	38000177		0	0	14		0	0	0	88137	0	243670	19059056		
44320	3668	40236824	2006-10-08	2006-10-08 00:00:00	2006-10-15	2006-10-15 00:00:00	2006-10-15	38000177		0	0	7		0	0	0	244062	0	1094107	40236824		
223942	4916	40213314	1977-11-04	1977-11-04 00:00:00	1977-11-04	1977-11-04 00:00:00	1977-11-04	581452		0	0	0		0	0	0	326677	0	49	40213314		
8567	712	46275916	2011-04-14	2011-04-14 00:00:00	2011-04-14	2011-04-14 00:00:00	2011-04-14	38000177		0	0	0		0	0	0	47268	0	1660014	46275916		
34866	761	40213160	1982-12-17	1982-12-17 00:00:00	1982-12-17	1982-12-17 00:00:00	1982-12-17	581452		0	0	0		0	0	0	\N	0	10	40213160		
7969	171	40213306	1991-06-03	1991-06-03 00:00:00	1991-06-03	1991-06-03 00:00:00	1991-06-03	581452		0	0	0		0	0	0	11615	0	43	40213306		
19141	1579	1713671	1993-08-11	1993-08-11 00:00:00	1993-08-25	1993-08-25 00:00:00	1993-08-25	38000177		0	0	14		0	0	0	106085	0	562251	1713671		
22049	1812	1118084	2003-10-04	2003-10-04 00:00:00	2003-10-04	2003-10-04 00:00:00	\N	38000177		0	0	0		0	0	0	121276	0	00025152531	44923712		
49605	1086	40213160	1970-05-22	1970-05-22 00:00:00	1970-05-22	1970-05-22 00:00:00	1970-05-22	581452		0	0	0		0	0	0	71343	0	10	40213160		
85588	1874	40213160	1974-02-16	1974-02-16 00:00:00	1974-02-16	1974-02-16 00:00:00	1974-02-16	581452		0	0	0		0	0	0	125109	0	10	40213160		
58289	4843	19078461	1980-05-16	1980-05-16 00:00:00	1980-06-13	1980-06-13 00:00:00	1980-06-13	38000177		0	0	28		0	0	0	322108	0	310965	19078461		
26236	572	40213160	1955-09-30	1955-09-30 00:00:00	1955-09-30	1955-09-30 00:00:00	1955-09-30	581452		0	0	0		0	0	0	37851	0	10	40213160		
107995	2367	40213314	1977-10-04	1977-10-04 00:00:00	1977-10-04	1977-10-04 00:00:00	1977-10-04	581452		0	0	0		0	0	0	157596	0	49	40213314		
203011	4456	40213227	1996-03-31	1996-03-31 00:00:00	1996-03-31	1996-03-31 00:00:00	1996-03-31	581452		0	0	0		0	0	0	296603	0	113	40213227		
11472	956	19059056	1950-08-29	1950-08-29 00:00:00	1950-09-12	1950-09-12 00:00:00	1950-09-12	38000177		0	0	14		0	0	0	63544	0	243670	19059056		
20337	1669	19075601	1998-02-09	1998-02-09 00:00:00	1998-02-09	1998-02-09 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	309362	19075601		
51701	4297	19133873	1975-04-08	1975-04-08 00:00:00	1975-04-16	1975-04-16 00:00:00	1975-04-16	38000177		0	0	8		0	0	0	285184	0	834061	19133873		
53596	4454	40162522	1950-02-15	1950-02-15 00:00:00	1950-02-15	1950-02-15 00:00:00	\N	38000177		0	0	0		0	0	0	296498	0	857005	40162522		
9797	820	19059056	1970-03-12	1970-03-12 00:00:00	1970-03-26	1970-03-26 00:00:00	1970-03-26	38000177		0	0	14		0	0	0	54357	0	243670	19059056		
64178	5328	40229134	1929-01-18	1929-01-18 00:00:00	1929-01-25	1929-01-25 00:00:00	1929-01-25	38000177		0	0	7		0	0	0	354618	0	1043400	40229134		
130899	2876	40213306	1986-07-31	1986-07-31 00:00:00	1986-07-31	1986-07-31 00:00:00	1986-07-31	581452		0	0	0		0	0	0	191339	0	43	40213306		
61673	5132	19133873	1974-02-28	1974-02-28 00:00:00	1974-03-08	1974-03-08 00:00:00	1974-03-08	38000177		0	0	8		0	0	0	341109	0	834061	19133873		
19439	1602	19059056	1967-05-26	1967-05-26 00:00:00	1967-06-30	1967-06-30 00:00:00	1967-06-30	38000177		0	0	35		0	0	0	107519	0	243670	19059056		
173330	3811	40213227	1992-12-17	1992-12-17 00:00:00	1992-12-17	1992-12-17 00:00:00	1992-12-17	581452		0	0	0		0	0	0	253136	0	113	40213227		
26958	587	40213160	1978-06-28	1978-06-28 00:00:00	1978-06-28	1978-06-28 00:00:00	1978-06-28	581452		0	0	0		0	0	0	38894	0	10	40213160		
37008	3060	1127433	2012-03-29	2012-03-29 00:00:00	2012-04-28	2012-04-28 00:00:00	2012-04-28	38000177		0	0	30		0	0	0	203631	0	313782	1127433		
16648	359	40213306	2000-07-15	2000-07-15 00:00:00	2000-07-15	2000-07-15 00:00:00	2000-07-15	581452		0	0	0		0	0	0	23920	0	43	40213306		
9108	757	1127433	1988-10-13	1988-10-13 00:00:00	1988-11-17	1988-11-17 00:00:00	1988-11-17	38000177		0	0	35		0	0	0	50289	0	313782	1127433		
210910	4625	40213227	2011-11-02	2011-11-02 00:00:00	2011-11-02	2011-11-02 00:00:00	2011-11-02	581452		0	0	0		0	0	0	308123	0	113	40213227		
38966	3221	1124300	2000-06-11	2000-06-11 00:00:00	2000-06-11	2000-06-11 00:00:00	\N	38000177		0	0	0		0	0	0	214057	0	00781178901	45011828		
231917	5096	40213160	1967-09-21	1967-09-21 00:00:00	1967-09-21	1967-09-21 00:00:00	1967-09-21	581452		0	0	0		0	0	0	338564	0	10	40213160		
24365	2004	1118084	2005-12-09	2005-12-09 00:00:00	2005-12-09	2005-12-09 00:00:00	\N	38000177		0	0	0		0	0	0	133438	0	00025152531	44923712		
7940	664	19059056	1986-02-27	1986-02-27 00:00:00	1986-03-13	1986-03-13 00:00:00	1986-03-13	38000177		0	0	14		0	0	0	43832	0	243670	19059056		
4729	395	19059056	1961-11-07	1961-11-07 00:00:00	1961-11-21	1961-11-21 00:00:00	1961-11-21	38000177		0	0	14		0	0	0	25991	0	243670	19059056		
51370	4269	1127078	1975-02-24	1975-02-24 00:00:00	1975-03-17	1975-03-17 00:00:00	1975-03-17	38000177		0	0	21		0	0	0	283350	0	282464	1127078		
46512	3852	1127078	1953-08-28	1953-08-28 00:00:00	1953-09-11	1953-09-11 00:00:00	1953-09-11	38000177		0	0	14		0	0	0	255618	0	282464	1127078		
35020	2892	19006318	1974-11-03	1974-11-03 00:00:00	1974-11-17	1974-11-17 00:00:00	1974-11-17	38000177		0	0	14		0	0	0	192403	0	105078	19006318		
115150	2530	40213227	2005-09-04	2005-09-04 00:00:00	2005-09-04	2005-09-04 00:00:00	2005-09-04	581452		0	0	0		0	0	0	167207	0	113	40213227		
23638	1946	1118084	1963-01-06	1963-01-06 00:00:00	1963-01-06	1963-01-06 00:00:00	\N	38000177		0	0	0		0	0	0	129339	0	00025152531	44923712		
135940	2985	40213227	2005-10-29	2005-10-29 00:00:00	2005-10-29	2005-10-29 00:00:00	2005-10-29	581452		0	0	0		0	0	0	199234	0	113	40213227		
23737	1952	19006318	1959-09-05	1959-09-05 00:00:00	1959-09-19	1959-09-19 00:00:00	1959-09-19	38000177		0	0	14		0	0	0	129839	0	105078	19006318		
57210	4749	40165015	1999-08-08	1999-08-08 00:00:00	1999-08-08	1999-08-08 00:00:00	\N	38000177		0	0	0		0	0	0	316226	0	861467	40165015		
14058	1175	1127433	1981-05-16	1981-05-16 00:00:00	1981-05-30	1981-05-30 00:00:00	1981-05-30	38000177		0	0	14		0	0	0	77409	0	313782	1127433		
117905	2591	40213201	1997-12-24	1997-12-24 00:00:00	1997-12-24	1997-12-24 00:00:00	1997-12-24	581452		0	0	0		0	0	0	171443	0	33	40213201		
62492	5199	40236824	2011-02-10	2011-02-10 00:00:00	2011-02-17	2011-02-17 00:00:00	2011-02-17	38000177		0	0	7		0	0	0	345790	0	1094107	40236824		
69062	1511	40213160	1965-10-03	1965-10-03 00:00:00	1965-10-03	1965-10-03 00:00:00	1965-10-03	581452		0	0	0		0	0	0	100880	0	10	40213160		
42043	3486	19078461	2012-04-16	2012-04-16 00:00:00	2012-07-15	2012-07-15 00:00:00	2012-07-15	38000177		0	0	90		0	0	0	231299	0	310965	19078461		
39468	3260	19059056	1968-11-05	1968-11-05 00:00:00	1968-11-26	1968-11-26 00:00:00	1968-11-26	38000177		0	0	21		0	0	0	216749	0	243670	19059056		
15112	326	40213160	1970-09-07	1970-09-07 00:00:00	1970-09-07	1970-09-07 00:00:00	1970-09-07	581452		0	0	0		0	0	0	21544	0	10	40213160		
30847	2554	1713671	2016-04-01	2016-04-01 00:00:00	2016-04-22	2016-04-22 00:00:00	2016-04-22	38000177		0	0	21		0	0	0	169224	0	562251	1713671		
56723	4705	1127433	1997-07-14	1997-07-14 00:00:00	1997-07-28	1997-07-28 00:00:00	1997-07-28	38000177		0	0	14		0	0	0	313479	0	313782	1127433		
199913	4390	40213296	1999-03-05	1999-03-05 00:00:00	1999-03-05	1999-03-05 00:00:00	1999-03-05	581452		0	0	0		0	0	0	291933	0	52	40213296		
45850	3796	1713671	1982-03-16	1982-03-16 00:00:00	1982-03-23	1982-03-23 00:00:00	1982-03-23	38000177		0	0	7		0	0	0	252379	0	562251	1713671		
33010	2736	19006318	1974-06-24	1974-06-24 00:00:00	1974-07-08	1974-07-08 00:00:00	1974-07-08	38000177		0	0	14		0	0	0	181107	0	105078	19006318		
67516	1476	40213201	2011-01-06	2011-01-06 00:00:00	2011-01-06	2011-01-06 00:00:00	2011-01-06	581452		0	0	0		0	0	0	98523	0	33	40213201		
44528	3686	1127433	2000-12-26	2000-12-26 00:00:00	2001-01-23	2001-01-23 00:00:00	2001-01-23	38000177		0	0	28		0	0	0	245053	0	313782	1127433		
223625	4909	40213160	1976-02-23	1976-02-23 00:00:00	1976-02-23	1976-02-23 00:00:00	1976-02-23	581452		0	0	0		0	0	0	326228	0	10	40213160		
6368	534	19073183	1980-02-09	1980-02-09 00:00:00	1980-02-23	1980-02-23 00:00:00	1980-02-23	38000177		0	0	14		0	0	0	35581	0	308182	19073183		
55149	4578	19128065	1987-04-04	1987-04-04 00:00:00	1988-03-29	1988-03-29 00:00:00	1988-03-29	38000177		0	0	360		0	0	0	304923	0	749882	19128065		
49217	4085	40229134	2014-05-20	2014-05-20 00:00:00	2014-05-27	2014-05-27 00:00:00	2014-05-27	38000177		0	0	7		0	0	0	271542	0	1043400	40229134		
33373	2765	19077572	2016-12-27	2016-12-27 00:00:00	2016-12-27	2016-12-27 00:00:00	\N	38000177		0	0	0		0	0	0	182837	0	310436	19077572		
224708	4933	40213227	2012-03-15	2012-03-15 00:00:00	2012-03-15	2012-03-15 00:00:00	2012-03-15	581452		0	0	0		0	0	0	327963	0	113	40213227		
5466	457	40165015	1998-07-11	1998-07-11 00:00:00	1998-07-11	1998-07-11 00:00:00	\N	38000177		0	0	0		0	0	0	30580	0	861467	40165015		
10961	914	19059056	1947-01-18	1947-01-18 00:00:00	1947-02-01	1947-02-01 00:00:00	1947-02-01	38000177		0	0	14		0	0	0	60729	0	243670	19059056		
16015	1328	19006318	1945-12-23	1945-12-23 00:00:00	1946-01-06	1946-01-06 00:00:00	1946-01-06	38000177		0	0	14		0	0	0	88225	0	105078	19006318		
44321	3668	920300	2006-10-08	2006-10-08 00:00:00	2006-10-15	2006-10-15 00:00:00	2006-10-15	38000177		0	0	7		0	0	0	244062	0	311989	920300		
223943	4916	40213160	1977-11-04	1977-11-04 00:00:00	1977-11-04	1977-11-04 00:00:00	1977-11-04	581452		0	0	0		0	0	0	326677	0	10	40213160		
8568	712	1310034	2011-04-14	2011-04-14 00:00:00	2011-04-14	2011-04-14 00:00:00	2011-04-14	38000177		0	0	0		0	0	0	47268	0	834357	1310034		
34872	761	40213314	1979-05-25	1979-05-25 00:00:00	1979-05-25	1979-05-25 00:00:00	1979-05-25	581452		0	0	0		0	0	0	50602	0	49	40213314		
54591	4534	19006318	1949-06-20	1949-06-20 00:00:00	1949-07-04	1949-07-04 00:00:00	1949-07-04	38000177		0	0	14		0	0	0	302049	0	105078	19006318		
19142	1579	19059056	1959-08-06	1959-08-06 00:00:00	1959-08-27	1959-08-27 00:00:00	1959-08-27	38000177		0	0	21		0	0	0	106101	0	243670	19059056		
22050	1812	40229134	1973-01-21	1973-01-21 00:00:00	1973-02-04	1973-02-04 00:00:00	1973-02-04	38000177		0	0	14		0	0	0	121246	0	1043400	40229134		
49607	1086	40213160	1965-09-17	1965-09-17 00:00:00	1965-09-17	1965-09-17 00:00:00	1965-09-17	581452		0	0	0		0	0	0	71323	0	10	40213160		
85589	1874	40213314	1977-10-15	1977-10-15 00:00:00	1977-10-15	1977-10-15 00:00:00	1977-10-15	581452		0	0	0		0	0	0	125137	0	49	40213314		
58290	4843	1127433	1984-06-22	1984-06-22 00:00:00	1984-09-20	1984-09-20 00:00:00	1984-09-20	38000177		0	0	90		0	0	0	322109	0	313782	1127433		
26238	572	40213198	2018-11-30	2018-11-30 00:00:00	2018-11-30	2018-11-30 00:00:00	2018-11-30	581452		0	0	0		0	0	0	37867	0	133	40213198		
107997	2367	40213160	1975-04-08	1975-04-08 00:00:00	1975-04-08	1975-04-08 00:00:00	1975-04-08	581452		0	0	0		0	0	0	157565	0	10	40213160		
203012	4456	40213160	1964-08-30	1964-08-30 00:00:00	1964-08-30	1964-08-30 00:00:00	1964-08-30	581452		0	0	0		0	0	0	296555	0	10	40213160		
11473	956	19006318	1950-08-29	1950-08-29 00:00:00	1950-09-12	1950-09-12 00:00:00	1950-09-12	38000177		0	0	14		0	0	0	63544	0	105078	19006318		
20338	1669	1127433	2012-05-15	2012-05-15 00:00:00	2012-06-12	2012-06-12 00:00:00	2012-06-12	38000177		0	0	28		0	0	0	112071	0	313782	1127433		
51702	4297	19128022	1992-12-02	1992-12-02 00:00:00	1993-11-27	1993-11-27 00:00:00	1993-11-27	38000177		0	0	360		0	0	0	285192	0	749785	19128022		
53597	4454	1127433	1969-09-03	1969-09-03 00:00:00	1969-09-17	1969-09-17 00:00:00	1969-09-17	38000177		0	0	14		0	0	0	296500	0	313782	1127433		
9798	820	19006318	1967-02-05	1967-02-05 00:00:00	1967-02-19	1967-02-19 00:00:00	1967-02-19	38000177		0	0	14		0	0	0	54356	0	105078	19006318		
64179	5328	40173590	2000-01-26	2000-01-26 00:00:00	2000-01-26	2000-01-26 00:00:00	\N	38000177		0	0	0		0	0	0	354600	0	904419	40173590		
130901	2876	40213160	1968-09-19	1968-09-19 00:00:00	1968-09-19	1968-09-19 00:00:00	1968-09-19	581452		0	0	0		0	0	0	191348	0	10	40213160		
61674	5132	1127433	2011-06-01	2011-06-01 00:00:00	2011-06-15	2011-06-15 00:00:00	2011-06-15	38000177		0	0	14		0	0	0	341137	0	313782	1127433		
19440	1602	19078461	2000-08-10	2000-08-10 00:00:00	2000-08-24	2000-08-24 00:00:00	2000-08-24	38000177		0	0	14		0	0	0	107523	0	310965	19078461		
173355	3811	40213227	2001-08-30	2001-08-30 00:00:00	2001-08-30	2001-08-30 00:00:00	2001-08-30	581452		0	0	0		0	0	0	253124	0	113	40213227		
26959	587	40213314	1978-06-28	1978-06-28 00:00:00	1978-06-28	1978-06-28 00:00:00	1978-06-28	581452		0	0	0		0	0	0	38894	0	49	40213314		
37009	3060	1713671	1966-05-07	1966-05-07 00:00:00	1966-05-21	1966-05-21 00:00:00	1966-05-21	38000177		0	0	14		0	0	0	203607	0	562251	1713671		
71316	1560	40213227	1996-03-18	1996-03-18 00:00:00	1996-03-18	1996-03-18 00:00:00	1996-03-18	581452		0	0	0		0	0	0	104496	0	113	40213227		
9109	757	1127433	1940-10-09	1940-10-09 00:00:00	1940-10-23	1940-10-23 00:00:00	1940-10-23	38000177		0	0	14		0	0	0	50207	0	313782	1127433		
210917	4625	40213160	1960-10-26	1960-10-26 00:00:00	1960-10-26	1960-10-26 00:00:00	1960-10-26	581452		0	0	0		0	0	0	308093	0	10	40213160		
38967	3221	19078461	1992-07-12	1992-07-12 00:00:00	1992-08-16	1992-08-16 00:00:00	1992-08-16	38000177		0	0	35		0	0	0	214133	0	310965	19078461		
231921	5097	40213160	1968-03-04	1968-03-04 00:00:00	1968-03-04	1968-03-04 00:00:00	1968-03-04	581452		0	0	0		0	0	0	338748	0	10	40213160		
24366	2004	1127433	1989-12-28	1989-12-28 00:00:00	1990-01-11	1990-01-11 00:00:00	1990-01-11	38000177		0	0	14		0	0	0	133464	0	313782	1127433		
7941	664	40223834	2010-07-27	2010-07-27 00:00:00	2010-07-27	2010-07-27 00:00:00	\N	38000177		0	0	0		0	0	0	43821	0	997501	40223834		
4730	395	19006318	1964-11-08	1964-11-08 00:00:00	1964-11-22	1964-11-22 00:00:00	1964-11-22	38000177		0	0	14		0	0	0	25977	0	105078	19006318		
51371	4269	19059056	1970-06-28	1970-06-28 00:00:00	1970-07-12	1970-07-12 00:00:00	1970-07-12	38000177		0	0	14		0	0	0	283327	0	243670	19059056		
185228	4071	40213260	2006-10-19	2006-10-19 00:00:00	2006-10-19	2006-10-19 00:00:00	2006-10-19	581452		0	0	0		0	0	0	270604	0	121	40213260		
35021	2892	40229134	1975-06-18	1975-06-18 00:00:00	1975-06-25	1975-06-25 00:00:00	1975-06-25	38000177		0	0	7		0	0	0	192394	0	1043400	40229134		
115151	2530	40213296	2005-09-04	2005-09-04 00:00:00	2005-09-04	2005-09-04 00:00:00	2005-09-04	581452		0	0	0		0	0	0	167207	0	52	40213296		
23639	1946	1127433	2017-10-20	2017-10-20 00:00:00	2017-10-27	2017-10-27 00:00:00	2017-10-27	38000177		0	0	7		0	0	0	129264	0	313782	1127433		
135942	2985	40213160	1964-06-27	1964-06-27 00:00:00	1964-06-27	1964-06-27 00:00:00	1964-06-27	581452		0	0	0		0	0	0	199240	0	10	40213160		
23738	1952	19059056	1991-03-24	1991-03-24 00:00:00	1991-04-21	1991-04-21 00:00:00	1991-04-21	38000177		0	0	28		0	0	0	129789	0	243670	19059056		
57211	4749	19133873	1983-12-09	1983-12-09 00:00:00	1983-12-22	1983-12-22 00:00:00	1983-12-22	38000177		0	0	13		0	0	0	316247	0	834061	19133873		
14059	1175	1127433	2018-11-11	2018-11-11 00:00:00	2018-12-02	2018-12-02 00:00:00	2018-12-02	38000177		0	0	21		0	0	0	77481	0	313782	1127433		
176972	3889	40213227	2019-04-07	2019-04-07 00:00:00	2019-04-07	2019-04-07 00:00:00	2019-04-07	581452		0	0	0		0	0	0	258527	0	113	40213227		
62493	5199	920300	2011-02-10	2011-02-10 00:00:00	2011-02-17	2011-02-17 00:00:00	2011-02-17	38000177		0	0	7		0	0	0	345790	0	311989	920300		
69065	1511	40213160	1965-08-01	1965-08-01 00:00:00	1965-08-01	1965-08-01 00:00:00	1965-08-01	581452		0	0	0		0	0	0	100903	0	10	40213160		
42044	3486	1127433	1969-08-05	1969-08-05 00:00:00	1969-08-12	1969-08-12 00:00:00	1969-08-12	38000177		0	0	7		0	0	0	231201	0	313782	1127433		
39469	3260	1713671	1977-09-16	1977-09-16 00:00:00	1977-09-30	1977-09-30 00:00:00	1977-09-30	38000177		0	0	14		0	0	0	216720	0	562251	1713671		
15115	326	40213227	2012-06-11	2012-06-11 00:00:00	2012-06-11	2012-06-11 00:00:00	2012-06-11	581452		0	0	0		0	0	0	21540	0	113	40213227		
30848	2554	19133873	1940-02-08	1940-02-08 00:00:00	1940-02-20	1940-02-20 00:00:00	1940-02-20	38000177		0	0	12		0	0	0	169134	0	834061	19133873		
56724	4705	40236824	2010-07-13	2010-07-13 00:00:00	2010-07-20	2010-07-20 00:00:00	2010-07-20	38000177		0	0	7		0	0	0	313481	0	1094107	40236824		
199918	4391	40213227	1992-02-14	1992-02-14 00:00:00	1992-02-14	1992-02-14 00:00:00	1992-02-14	581452		0	0	0		0	0	0	291978	0	113	40213227		
45851	3796	40229134	1986-05-03	1986-05-03 00:00:00	1986-05-17	1986-05-17 00:00:00	1986-05-17	38000177		0	0	14		0	0	0	252411	0	1043400	40229134		
33019	2739	1124300	1992-03-28	1992-03-28 00:00:00	1992-03-28	1992-03-28 00:00:00	\N	38000177		0	0	0		0	0	0	181225	0	00781178901	45011828		
141910	3117	40213227	2015-08-12	2015-08-12 00:00:00	2015-08-12	2015-08-12 00:00:00	2015-08-12	581452		0	0	0		0	0	0	207356	0	113	40213227		
44542	3689	40229134	1975-03-10	1975-03-10 00:00:00	1975-03-24	1975-03-24 00:00:00	1975-03-24	38000177		0	0	14		0	0	0	245229	0	1043400	40229134		
223794	4913	40213160	1969-10-22	1969-10-22 00:00:00	1969-10-22	1969-10-22 00:00:00	1969-10-22	581452		0	0	0		0	0	0	326540	0	10	40213160		
6369	534	19019979	1980-02-09	1980-02-09 00:00:00	1980-02-23	1980-02-23 00:00:00	1980-02-23	38000177		0	0	14		0	0	0	35581	0	198405	19019979		
55150	4578	19059056	1979-02-03	1979-02-03 00:00:00	1979-05-04	1979-05-04 00:00:00	1979-05-04	38000177		0	0	90		0	0	0	304988	0	243670	19059056		
49218	4085	1127078	1966-05-18	1966-05-18 00:00:00	1966-06-01	1966-06-01 00:00:00	1966-06-01	38000177		0	0	14		0	0	0	271458	0	282464	1127078		
33374	2765	1127433	1994-08-17	1994-08-17 00:00:00	1994-08-31	1994-08-31 00:00:00	1994-08-31	38000177		0	0	14		0	0	0	182998	0	313782	1127433		
224709	4933	40213296	2012-03-15	2012-03-15 00:00:00	2012-03-15	2012-03-15 00:00:00	2012-03-15	581452		0	0	0		0	0	0	327963	0	52	40213296		
5467	457	19078461	2009-05-14	2009-05-14 00:00:00	2009-07-13	2009-07-13 00:00:00	2009-07-13	38000177		0	0	60		0	0	0	30594	0	310965	19078461		
10962	914	19078461	2004-01-24	2004-01-24 00:00:00	2004-02-07	2004-02-07 00:00:00	2004-02-07	38000177		0	0	14		0	0	0	60731	0	310965	19078461		
16016	1328	19059056	1945-12-23	1945-12-23 00:00:00	1946-01-06	1946-01-06 00:00:00	1946-01-06	38000177		0	0	14		0	0	0	88225	0	243670	19059056		
44322	3668	40229134	2000-08-30	2000-08-30 00:00:00	2000-09-06	2000-09-06 00:00:00	2000-09-06	38000177		0	0	7		0	0	0	244006	0	1043400	40229134		
223945	4916	40213160	1978-04-07	1978-04-07 00:00:00	1978-04-07	1978-04-07 00:00:00	1978-04-07	581452		0	0	0		0	0	0	326678	0	10	40213160		
8569	712	40243436	2011-04-14	2011-04-14 00:00:00	2011-04-14	2011-04-14 00:00:00	2011-04-14	38000177		0	0	0		0	0	0	47268	0	1190795	40243436		
34873	761	40213160	1979-05-25	1979-05-25 00:00:00	1979-05-25	1979-05-25 00:00:00	1979-05-25	581452		0	0	0		0	0	0	50602	0	10	40213160		
54592	4534	19059056	1949-06-20	1949-06-20 00:00:00	1949-07-04	1949-07-04 00:00:00	1949-07-04	38000177		0	0	14		0	0	0	302049	0	243670	19059056		
19143	1579	1713671	2007-02-21	2007-02-21 00:00:00	2007-03-07	2007-03-07 00:00:00	2007-03-07	38000177		0	0	14		0	0	0	106086	0	562251	1713671		
22051	1812	1127433	1984-06-12	1984-06-12 00:00:00	1984-06-19	1984-06-19 00:00:00	1984-06-19	38000177		0	0	7		0	0	0	121255	0	313782	1127433		
49608	1086	40213160	1965-11-19	1965-11-19 00:00:00	1965-11-19	1965-11-19 00:00:00	1965-11-19	581452		0	0	0		0	0	0	71341	0	10	40213160		
85591	1874	40213160	1974-04-20	1974-04-20 00:00:00	1974-04-20	1974-04-20 00:00:00	1974-04-20	581452		0	0	0		0	0	0	125124	0	10	40213160		
58291	4844	1713671	2005-03-28	2005-03-28 00:00:00	2005-04-04	2005-04-04 00:00:00	2005-04-04	38000177		0	0	7		0	0	0	322305	0	562251	1713671		
26243	572	40213227	2004-10-29	2004-10-29 00:00:00	2004-10-29	2004-10-29 00:00:00	2004-10-29	581452		0	0	0		0	0	0	37865	0	113	40213227		
108008	2367	40213160	1979-10-09	1979-10-09 00:00:00	1979-10-09	1979-10-09 00:00:00	1979-10-09	581452		0	0	0		0	0	0	157567	0	10	40213160		
179901	3955	40213296	1998-02-14	1998-02-14 00:00:00	1998-02-14	1998-02-14 00:00:00	1998-02-14	581452		0	0	0		0	0	0	262855	0	52	40213296		
11474	956	920300	1980-06-24	1980-06-24 00:00:00	1980-07-01	1980-07-01 00:00:00	1980-07-01	38000177		0	0	7		0	0	0	63444	0	311989	920300		
20339	1669	19059056	1964-02-06	1964-02-06 00:00:00	1964-02-20	1964-02-20 00:00:00	1964-02-20	38000177		0	0	14		0	0	0	112093	0	243670	19059056		
51703	4297	1713671	1983-10-20	1983-10-20 00:00:00	1983-11-10	1983-11-10 00:00:00	1983-11-10	38000177		0	0	21		0	0	0	285187	0	562251	1713671		
53598	4454	1127433	2015-12-21	2015-12-21 00:00:00	2015-12-28	2015-12-28 00:00:00	2015-12-28	38000177		0	0	7		0	0	0	296419	0	313782	1127433		
9799	820	1127078	1967-02-05	1967-02-05 00:00:00	1967-02-19	1967-02-19 00:00:00	1967-02-19	38000177		0	0	14		0	0	0	54356	0	282464	1127078		
64180	5328	1127433	1962-01-27	1962-01-27 00:00:00	1962-02-17	1962-02-17 00:00:00	1962-02-17	38000177		0	0	21		0	0	0	354589	0	313782	1127433		
130942	2878	40213314	1980-11-30	1980-11-30 00:00:00	1980-11-30	1980-11-30 00:00:00	1980-11-30	581452		0	0	0		0	0	0	191468	0	49	40213314		
61675	5132	19128065	1981-07-30	1981-07-30 00:00:00	1982-07-25	1982-07-25 00:00:00	1982-07-25	38000177		0	0	360		0	0	0	341138	0	749882	19128065		
19441	1602	40229134	1967-10-25	1967-10-25 00:00:00	1967-11-08	1967-11-08 00:00:00	1967-11-08	38000177		0	0	14		0	0	0	107527	0	1043400	40229134		
173367	3811	40213201	1987-04-16	1987-04-16 00:00:00	1987-04-16	1987-04-16 00:00:00	1987-04-16	581452		0	0	0		0	0	0	253182	0	33	40213201		
26961	587	40213314	1978-08-30	1978-08-30 00:00:00	1978-08-30	1978-08-30 00:00:00	1978-08-30	581452		0	0	0		0	0	0	38879	0	49	40213314		
37010	3060	1115171	1998-06-06	1998-06-06 00:00:00	1998-09-04	1998-09-04 00:00:00	1998-09-04	38000177		0	0	90		0	0	0	203628	0	849574	1115171		
71325	1560	40213227	2016-07-11	2016-07-11 00:00:00	2016-07-11	2016-07-11 00:00:00	2016-07-11	581452		0	0	0		0	0	0	104533	0	113	40213227		
9110	757	19059056	1940-10-22	1940-10-22 00:00:00	1940-11-19	1940-11-19 00:00:00	1940-11-19	38000177		0	0	28		0	0	0	50286	0	243670	19059056		
210922	4625	40213160	1960-08-24	1960-08-24 00:00:00	1960-08-24	1960-08-24 00:00:00	1960-08-24	581452		0	0	0		0	0	0	308117	0	10	40213160		
38968	3221	40236446	1970-05-30	1970-05-30 00:00:00	1972-01-08	1972-01-08 00:00:00	1972-01-08	38000177		0	0	588		0	0	0	214072	0	1091392	40236446		
231927	5097	40213260	2018-02-12	2018-02-12 00:00:00	2018-02-12	2018-02-12 00:00:00	2018-02-12	581452		0	0	0		0	0	0	338656	0	121	40213260		
24367	2004	19128065	1985-05-28	1985-05-28 00:00:00	1986-05-23	1986-05-23 00:00:00	1986-05-23	38000177		0	0	360		0	0	0	133444	0	749882	19128065		
7942	664	1594382	2010-07-27	2010-07-27 00:00:00	2010-07-27	2010-07-27 00:00:00	\N	38000177		0	0	0		0	0	0	43821	0	1870230	1594382		
4731	395	19059056	1964-11-08	1964-11-08 00:00:00	1964-11-22	1964-11-22 00:00:00	1964-11-22	38000177		0	0	14		0	0	0	25977	0	243670	19059056		
51372	4269	46233988	1970-06-28	1970-06-28 00:00:00	1970-07-12	1970-07-12 00:00:00	1970-07-12	38000177		0	0	14		0	0	0	283327	0	1652673	46233988		
185231	4071	40213201	2018-12-27	2018-12-27 00:00:00	2018-12-27	2018-12-27 00:00:00	2018-12-27	581452		0	0	0		0	0	0	270657	0	33	40213201		
35022	2892	19019979	1974-09-19	1974-09-19 00:00:00	1974-10-17	1974-10-17 00:00:00	1974-10-17	38000177		0	0	28		0	0	0	192415	0	198405	19019979		
115153	2530	40213160	1964-08-02	1964-08-02 00:00:00	1964-08-02	1964-08-02 00:00:00	1964-08-02	581452		0	0	0		0	0	0	167236	0	10	40213160		
23640	1946	1127433	2008-10-23	2008-10-23 00:00:00	2008-11-22	2008-11-22 00:00:00	2008-11-22	38000177		0	0	30		0	0	0	129278	0	313782	1127433		
135954	2985	40213160	1964-03-28	1964-03-28 00:00:00	1964-03-28	1964-03-28 00:00:00	1964-03-28	581452		0	0	0		0	0	0	199197	0	10	40213160		
34200	2827	19133873	1923-01-21	1923-01-21 00:00:00	1923-02-03	1923-02-03 00:00:00	1923-02-03	38000177		0	0	13		0	0	0	187440	0	834061	19133873		
57212	4749	1127433	1978-07-23	1978-07-23 00:00:00	1978-08-06	1978-08-06 00:00:00	1978-08-06	38000177		0	0	14		0	0	0	316237	0	313782	1127433		
14060	1175	19075001	2018-11-11	2018-11-11 00:00:00	2018-12-02	2018-12-02 00:00:00	2018-12-02	38000177		0	0	21		0	0	0	77481	0	309097	19075001		
176978	3889	40213227	1998-11-15	1998-11-15 00:00:00	1998-11-15	1998-11-15 00:00:00	1998-11-15	581452		0	0	0		0	0	0	258521	0	113	40213227		
62494	5199	19128065	1981-12-12	1981-12-12 00:00:00	1982-12-07	1982-12-07 00:00:00	1982-12-07	38000177		0	0	360		0	0	0	345737	0	749882	19128065		
69066	1511	40213306	1987-04-26	1987-04-26 00:00:00	1987-04-26	1987-04-26 00:00:00	1987-04-26	581452		0	0	0		0	0	0	100898	0	43	40213306		
42045	3486	1127433	1988-02-24	1988-02-24 00:00:00	1988-03-02	1988-03-02 00:00:00	1988-03-02	38000177		0	0	7		0	0	0	231239	0	313782	1127433		
39470	3260	1127433	1983-09-09	1983-09-09 00:00:00	1983-09-23	1983-09-23 00:00:00	1983-09-23	38000177		0	0	14		0	0	0	216750	0	313782	1127433		
15116	326	40213296	2012-06-11	2012-06-11 00:00:00	2012-06-11	2012-06-11 00:00:00	2012-06-11	581452		0	0	0		0	0	0	21540	0	52	40213296		
30849	2554	1713671	1959-07-25	1959-07-25 00:00:00	1959-08-01	1959-08-01 00:00:00	1959-08-01	38000177		0	0	7		0	0	0	169213	0	562251	1713671		
56725	4705	920300	2010-07-13	2010-07-13 00:00:00	2010-07-20	2010-07-20 00:00:00	2010-07-20	38000177		0	0	7		0	0	0	313481	0	311989	920300		
199925	4391	40213227	2002-04-12	2002-04-12 00:00:00	2002-04-12	2002-04-12 00:00:00	2002-04-12	581452		0	0	0		0	0	0	291955	0	113	40213227		
45852	3796	40229134	2016-09-07	2016-09-07 00:00:00	2016-09-14	2016-09-14 00:00:00	2016-09-14	38000177		0	0	7		0	0	0	252371	0	1043400	40229134		
33020	2739	19059056	1957-03-20	1957-03-20 00:00:00	1957-04-03	1957-04-03 00:00:00	1957-04-03	38000177		0	0	14		0	0	0	181191	0	243670	19059056		
141911	3117	40213296	2015-08-12	2015-08-12 00:00:00	2015-08-12	2015-08-12 00:00:00	2015-08-12	581452		0	0	0		0	0	0	207356	0	52	40213296		
44543	3689	1127433	1956-07-28	1956-07-28 00:00:00	1956-08-04	1956-08-04 00:00:00	1956-08-04	38000177		0	0	7		0	0	0	245234	0	313782	1127433		
223796	4913	40213296	2010-01-27	2010-01-27 00:00:00	2010-01-27	2010-01-27 00:00:00	2010-01-27	581452		0	0	0		0	0	0	326529	0	52	40213296		
8799	188	40213227	1994-01-30	1994-01-30 00:00:00	1994-01-30	1994-01-30 00:00:00	1994-01-30	581452		0	0	0		0	0	0	12807	0	113	40213227		
55151	4578	40231925	1979-02-03	1979-02-03 00:00:00	1979-02-03	1979-02-03 00:00:00	\N	38000177		0	0	0		0	0	0	304988	0	1049221	40231925		
49219	4085	19059056	1960-02-10	1960-02-10 00:00:00	1960-02-24	1960-02-24 00:00:00	1960-02-24	38000177		0	0	14		0	0	0	271523	0	243670	19059056		
33375	2765	19075601	2016-09-20	2016-09-20 00:00:00	2016-09-20	2016-09-20 00:00:00	2016-09-20	38000177		0	0	0		0	0	0	182896	0	309362	19075601		
224714	4933	40213306	1992-09-10	1992-09-10 00:00:00	1992-09-10	1992-09-10 00:00:00	1992-09-10	581452		0	0	0		0	0	0	327984	0	43	40213306		
5468	457	1127433	2003-03-01	2003-03-01 00:00:00	2003-03-15	2003-03-15 00:00:00	2003-03-15	38000177		0	0	14		0	0	0	30558	0	313782	1127433		
10963	914	1118084	1989-03-08	1989-03-08 00:00:00	1989-03-08	1989-03-08 00:00:00	\N	38000177		0	0	0		0	0	0	60701	0	00025152531	44923712		
16017	1328	1127433	1987-12-25	1987-12-25 00:00:00	1988-01-01	1988-01-01 00:00:00	1988-01-01	38000177		0	0	7		0	0	0	88162	0	313782	1127433		
54781	4550	1127078	1971-03-26	1971-03-26 00:00:00	1971-04-25	1971-04-25 00:00:00	1971-04-25	38000177		0	0	30		0	0	0	303200	0	282464	1127078		
223953	4916	40213160	1982-07-09	1982-07-09 00:00:00	1982-07-09	1982-07-09 00:00:00	1982-07-09	581452		0	0	0		0	0	0	326695	0	10	40213160		
8574	715	19128065	1998-02-06	1998-02-06 00:00:00	1999-02-01	1999-02-01 00:00:00	1999-02-01	38000177		0	0	360		0	0	0	47292	0	749882	19128065		
34881	761	40213251	1984-07-06	1984-07-06 00:00:00	1984-07-06	1984-07-06 00:00:00	1984-07-06	581452		0	0	0		0	0	0	50588	0	21	40213251		
54593	4534	40229134	1995-01-05	1995-01-05 00:00:00	1995-01-12	1995-01-12 00:00:00	1995-01-12	38000177		0	0	7		0	0	0	302023	0	1043400	40229134		
19144	1579	1127433	2013-05-29	2013-05-29 00:00:00	2013-07-03	2013-07-03 00:00:00	2013-07-03	38000177		0	0	35		0	0	0	106104	0	313782	1127433		
22052	1812	1127433	1992-05-09	1992-05-09 00:00:00	1992-05-23	1992-05-23 00:00:00	1992-05-23	38000177		0	0	14		0	0	0	121256	0	313782	1127433		
49610	1086	40213306	1988-12-02	1988-12-02 00:00:00	1988-12-02	1988-12-02 00:00:00	1988-12-02	581452		0	0	0		0	0	0	71363	0	43	40213306		
37337	3084	46275916	2015-10-21	2015-10-21 00:00:00	2015-10-21	2015-10-21 00:00:00	2015-10-21	38000177		0	0	0		0	0	0	205356	0	1660014	46275916		
58292	4844	1127078	1965-12-05	1965-12-05 00:00:00	1966-02-03	1966-02-03 00:00:00	1966-02-03	38000177		0	0	60		0	0	0	322279	0	282464	1127078		
26257	572	40213296	1997-11-07	1997-11-07 00:00:00	1997-11-07	1997-11-07 00:00:00	1997-11-07	581452		0	0	0		0	0	0	37864	0	52	40213296		
108010	2367	40213160	1975-02-04	1975-02-04 00:00:00	1975-02-04	1975-02-04 00:00:00	1975-02-04	581452		0	0	0		0	0	0	157593	0	10	40213160		
179903	3955	40213227	1998-02-14	1998-02-14 00:00:00	1998-02-14	1998-02-14 00:00:00	1998-02-14	581452		0	0	0		0	0	0	262855	0	113	40213227		
11475	956	40236824	1980-06-24	1980-06-24 00:00:00	1980-07-01	1980-07-01 00:00:00	1980-07-01	38000177		0	0	7		0	0	0	63444	0	1094107	40236824		
20340	1669	19129655	1964-02-06	1964-02-06 00:00:00	1964-02-20	1964-02-20 00:00:00	1964-02-20	38000177		0	0	14		0	0	0	112093	0	789980	19129655		
51704	4297	1367571	1991-02-19	1991-02-19 00:00:00	1991-02-19	1991-02-19 00:00:00	1991-02-19	38000177		0	0	0		0	0	0	285178	0	314659	19080464		
53599	4454	19059056	1955-12-16	1955-12-16 00:00:00	1956-01-15	1956-01-15 00:00:00	1956-01-15	38000177		0	0	30		0	0	0	296499	0	243670	19059056		
9800	820	19133905	1999-06-09	1999-06-09 00:00:00	1999-06-18	1999-06-18 00:00:00	1999-06-18	38000177		0	0	9		0	0	0	54352	0	834102	19133905		
64181	5328	40229134	1975-12-26	1975-12-26 00:00:00	1976-01-09	1976-01-09 00:00:00	1976-01-09	38000177		0	0	14		0	0	0	354710	0	1043400	40229134		
130943	2878	40213160	1980-11-30	1980-11-30 00:00:00	1980-11-30	1980-11-30 00:00:00	1980-11-30	581452		0	0	0		0	0	0	191468	0	10	40213160		
61676	5132	40165015	1979-09-29	1979-09-29 00:00:00	1979-09-29	1979-09-29 00:00:00	\N	38000177		0	0	0		0	0	0	341106	0	861467	40165015		
19444	1604	1118084	1991-02-07	1991-02-07 00:00:00	1991-02-07	1991-02-07 00:00:00	\N	38000177		0	0	0		0	0	0	107649	0	00025152531	44923712		
105179	2307	40213306	1983-12-06	1983-12-06 00:00:00	1983-12-06	1983-12-06 00:00:00	1983-12-06	581452		0	0	0		0	0	0	153555	0	43	40213306		
26962	587	40213160	1978-08-30	1978-08-30 00:00:00	1978-08-30	1978-08-30 00:00:00	1978-08-30	581452		0	0	0		0	0	0	38879	0	10	40213160		
37011	3060	40229134	1987-03-09	1987-03-09 00:00:00	1987-03-16	1987-03-16 00:00:00	1987-03-16	38000177		0	0	7		0	0	0	203544	0	1043400	40229134		
71339	1560	40213227	2006-05-15	2006-05-15 00:00:00	2006-05-15	2006-05-15 00:00:00	2006-05-15	581452		0	0	0		0	0	0	104445	0	113	40213227		
9111	758	19133873	1985-05-23	1985-05-23 00:00:00	1985-06-04	1985-06-04 00:00:00	1985-06-04	38000177		0	0	12		0	0	0	50300	0	834061	19133873		
210924	4625	40213306	1982-07-21	1982-07-21 00:00:00	1982-07-21	1982-07-21 00:00:00	1982-07-21	581452		0	0	0		0	0	0	308099	0	43	40213306		
19667	1618	19128022	1991-04-22	1991-04-22 00:00:00	1992-04-16	1992-04-16 00:00:00	1992-04-16	38000177		0	0	360		0	0	0	108813	0	749785	19128022		
231929	5097	40213227	2009-01-19	2009-01-19 00:00:00	2009-01-19	2009-01-19 00:00:00	2009-01-19	581452		0	0	0		0	0	0	338727	0	113	40213227		
24368	2005	1127078	1974-05-08	1974-05-08 00:00:00	1974-05-22	1974-05-22 00:00:00	1974-05-22	38000177		0	0	14		0	0	0	133482	0	282464	1127078		
7943	664	19059056	1988-11-29	1988-11-29 00:00:00	1989-01-03	1989-01-03 00:00:00	1989-01-03	38000177		0	0	35		0	0	0	43902	0	243670	19059056		
4732	395	1118084	1998-04-27	1998-04-27 00:00:00	1998-04-27	1998-04-27 00:00:00	\N	38000177		0	0	0		0	0	0	25932	0	00025152531	44923712		
51373	4269	1127433	1988-02-28	1988-02-28 00:00:00	1988-03-13	1988-03-13 00:00:00	1988-03-13	38000177		0	0	14		0	0	0	283353	0	313782	1127433		
185236	4071	40213160	1957-09-12	1957-09-12 00:00:00	1957-09-12	1957-09-12 00:00:00	1957-09-12	581452		0	0	0		0	0	0	270648	0	10	40213160		
35023	2892	19133873	1979-05-12	1979-05-12 00:00:00	1979-05-24	1979-05-24 00:00:00	1979-05-24	38000177		0	0	12		0	0	0	192411	0	834061	19133873		
115155	2530	40213260	2015-10-04	2015-10-04 00:00:00	2015-10-04	2015-10-04 00:00:00	2015-10-04	581452		0	0	0		0	0	0	167243	0	121	40213260		
23641	1946	1713671	1958-08-31	1958-08-31 00:00:00	1958-09-07	1958-09-07 00:00:00	1958-09-07	38000177		0	0	7		0	0	0	129318	0	562251	1713671		
135956	2985	40213160	1964-01-25	1964-01-25 00:00:00	1964-01-25	1964-01-25 00:00:00	1964-01-25	581452		0	0	0		0	0	0	199239	0	10	40213160		
34201	2827	1713671	1980-09-01	1980-09-01 00:00:00	1980-09-08	1980-09-08 00:00:00	1980-09-08	38000177		0	0	7		0	0	0	187496	0	562251	1713671		
57213	4749	1127433	1994-04-08	1994-04-08 00:00:00	1994-04-22	1994-04-22 00:00:00	1994-04-22	38000177		0	0	14		0	0	0	316251	0	313782	1127433		
3177	69	40213227	2004-12-15	2004-12-15 00:00:00	2004-12-15	2004-12-15 00:00:00	2004-12-15	581452		0	0	0		0	0	0	4678	0	113	40213227		
176981	3890	40213227	2013-12-31	2013-12-31 00:00:00	2013-12-31	2013-12-31 00:00:00	2013-12-31	581452		0	0	0		0	0	0	258579	0	113	40213227		
62495	5199	19059056	1971-01-29	1971-01-29 00:00:00	1971-02-12	1971-02-12 00:00:00	1971-02-12	38000177		0	0	14		0	0	0	345724	0	243670	19059056		
69076	1511	40213227	2016-05-01	2016-05-01 00:00:00	2016-05-01	2016-05-01 00:00:00	2016-05-01	581452		0	0	0		0	0	0	100911	0	113	40213227		
42046	3486	1127433	1988-09-21	1988-09-21 00:00:00	1988-10-19	1988-10-19 00:00:00	1988-10-19	38000177		0	0	28		0	0	0	231297	0	313782	1127433		
39471	3260	1127078	1964-11-28	1964-11-28 00:00:00	1964-12-26	1964-12-26 00:00:00	1964-12-26	38000177		0	0	28		0	0	0	216748	0	282464	1127078		
15121	326	40213160	1971-02-08	1971-02-08 00:00:00	1971-02-08	1971-02-08 00:00:00	1971-02-08	581452		0	0	0		0	0	0	21545	0	10	40213160		
30850	2554	1713671	1969-05-30	1969-05-30 00:00:00	1969-06-13	1969-06-13 00:00:00	1969-06-13	38000177		0	0	14		0	0	0	169265	0	562251	1713671		
56726	4705	1127433	1979-05-22	1979-05-22 00:00:00	1979-05-29	1979-05-29 00:00:00	1979-05-29	38000177		0	0	7		0	0	0	313466	0	313782	1127433		
171111	3761	40213260	2006-04-22	2006-04-22 00:00:00	2006-04-22	2006-04-22 00:00:00	2006-04-22	581452		0	0	0		0	0	0	250111	0	121	40213260		
45853	3796	1127433	1973-09-14	1973-09-14 00:00:00	1973-09-28	1973-09-28 00:00:00	1973-09-28	38000177		0	0	14		0	0	0	252354	0	313782	1127433		
12023	1004	1115171	2016-09-27	2016-09-27 00:00:00	2016-10-11	2016-10-11 00:00:00	2016-10-11	38000177		0	0	14		0	0	0	66339	0	849574	1115171		
141912	3117	40213160	1973-11-07	1973-11-07 00:00:00	1973-11-07	1973-11-07 00:00:00	1973-11-07	581452		0	0	0		0	0	0	207357	0	10	40213160		
44544	3689	1713671	1978-04-09	1978-04-09 00:00:00	1978-04-16	1978-04-16 00:00:00	1978-04-16	38000177		0	0	7		0	0	0	245217	0	562251	1713671		
223800	4913	40213296	2010-01-13	2010-01-13 00:00:00	2010-01-13	2010-01-13 00:00:00	2010-01-13	581452		0	0	0		0	0	0	326553	0	52	40213296		
8810	188	40213260	2013-04-21	2013-04-21 00:00:00	2013-04-21	2013-04-21 00:00:00	2013-04-21	581452		0	0	0		0	0	0	12800	0	121	40213260		
55152	4578	1127433	2008-08-25	2008-08-25 00:00:00	2008-09-08	2008-09-08 00:00:00	2008-09-08	38000177		0	0	14		0	0	0	304967	0	313782	1127433		
49220	4085	19006318	1960-02-10	1960-02-10 00:00:00	1960-02-24	1960-02-24 00:00:00	1960-02-24	38000177		0	0	14		0	0	0	271523	0	105078	19006318		
33376	2765	40220960	2016-09-20	2016-09-20 00:00:00	2016-09-20	2016-09-20 00:00:00	2016-09-20	38000177		0	0	0		0	0	0	182896	0	1804799	40220960		
224716	4933	40213227	1992-09-10	1992-09-10 00:00:00	1992-09-10	1992-09-10 00:00:00	1992-09-10	581452		0	0	0		0	0	0	327984	0	113	40213227		
5469	457	1127078	1958-08-07	1958-08-07 00:00:00	1958-10-06	1958-10-06 00:00:00	1958-10-06	38000177		0	0	60		0	0	0	30590	0	282464	1127078		
10964	914	1115171	2013-05-20	2013-05-20 00:00:00	2013-07-19	2013-07-19 00:00:00	2013-07-19	38000177		0	0	60		0	0	0	60732	0	849574	1115171		
16018	1328	19006318	1946-09-01	1946-09-01 00:00:00	1946-09-15	1946-09-15 00:00:00	1946-09-15	38000177		0	0	14		0	0	0	88145	0	105078	19006318		
54782	4550	19059056	1968-02-23	1968-02-23 00:00:00	1968-03-08	1968-03-08 00:00:00	1968-03-08	38000177		0	0	14		0	0	0	303271	0	243670	19059056		
223962	4916	40213227	1999-10-01	1999-10-01 00:00:00	1999-10-01	1999-10-01 00:00:00	1999-10-01	581452		0	0	0		0	0	0	326706	0	113	40213227		
8575	715	1127078	1986-06-29	1986-06-29 00:00:00	1986-07-13	1986-07-13 00:00:00	1986-07-13	38000177		0	0	14		0	0	0	47335	0	282464	1127078		
34893	761	40213160	1979-08-24	1979-08-24 00:00:00	1979-08-24	1979-08-24 00:00:00	1979-08-24	581452		0	0	0		0	0	0	50533	0	10	40213160		
54594	4534	1713671	2008-06-10	2008-06-10 00:00:00	2008-06-24	2008-06-24 00:00:00	2008-06-24	38000177		0	0	14		0	0	0	302045	0	562251	1713671		
19145	1579	19075601	1999-04-29	1999-04-29 00:00:00	1999-04-29	1999-04-29 00:00:00	1999-04-29	38000177		0	0	0		0	0	0	106071	0	309362	19075601		
22053	1813	40229134	1987-07-20	1987-07-20 00:00:00	1987-08-03	1987-08-03 00:00:00	1987-08-03	38000177		0	0	14		0	0	0	121340	0	1043400	40229134		
49614	1086	40213227	2007-03-02	2007-03-02 00:00:00	2007-03-02	2007-03-02 00:00:00	2007-03-02	581452		0	0	0		0	0	0	71348	0	113	40213227		
37338	3084	19128022	1995-10-30	1995-10-30 00:00:00	1996-10-24	1996-10-24 00:00:00	1996-10-24	38000177		0	0	360		0	0	0	205371	0	749785	19128022		
58293	4844	1127433	2013-07-26	2013-07-26 00:00:00	2013-08-09	2013-08-09 00:00:00	2013-08-09	38000177		0	0	14		0	0	0	322307	0	313782	1127433		
106191	2329	40213227	2004-09-21	2004-09-21 00:00:00	2004-09-21	2004-09-21 00:00:00	2004-09-21	581452		0	0	0		0	0	0	154957	0	113	40213227		
108013	2367	40213314	1977-04-05	1977-04-05 00:00:00	1977-04-05	1977-04-05 00:00:00	1977-04-05	581452		0	0	0		0	0	0	157556	0	49	40213314		
179912	3955	40213160	1956-10-13	1956-10-13 00:00:00	1956-10-13	1956-10-13 00:00:00	1956-10-13	581452		0	0	0		0	0	0	262832	0	10	40213160		
11476	956	19059056	1948-01-19	1948-01-19 00:00:00	1948-04-18	1948-04-18 00:00:00	1948-04-18	38000177		0	0	90		0	0	0	63550	0	243670	19059056		
53516	4450	1127078	1970-03-16	1970-03-16 00:00:00	1970-03-30	1970-03-30 00:00:00	1970-03-30	38000177		0	0	14		0	0	0	296052	0	282464	1127078		
51705	4297	35605482	1991-02-19	1991-02-19 00:00:00	1991-02-19	1991-02-19 00:00:00	1991-02-19	38000177		0	0	0		0	0	0	285178	0	1740467	35605482		
53600	4454	1127433	1931-12-30	1931-12-30 00:00:00	1932-01-06	1932-01-06 00:00:00	1932-01-06	38000177		0	0	7		0	0	0	296464	0	313782	1127433		
9801	820	1713671	2000-05-26	2000-05-26 00:00:00	2000-06-09	2000-06-09 00:00:00	2000-06-09	38000177		0	0	14		0	0	0	54359	0	562251	1713671		
64182	5328	1127433	1993-12-17	1993-12-17 00:00:00	1993-12-24	1993-12-24 00:00:00	1993-12-24	38000177		0	0	7		0	0	0	354712	0	313782	1127433		
149700	3293	40213227	1993-05-15	1993-05-15 00:00:00	1993-05-15	1993-05-15 00:00:00	1993-05-15	581452		0	0	0		0	0	0	218753	0	113	40213227		
61677	5132	1127433	1979-09-29	1979-09-29 00:00:00	1979-10-29	1979-10-29 00:00:00	1979-10-29	38000177		0	0	30		0	0	0	341106	0	313782	1127433		
19445	1604	19133873	1953-11-30	1953-11-30 00:00:00	1953-12-09	1953-12-09 00:00:00	1953-12-09	38000177		0	0	9		0	0	0	107623	0	834061	19133873		
105181	2307	40213260	2011-10-04	2011-10-04 00:00:00	2011-10-04	2011-10-04 00:00:00	2011-10-04	581452		0	0	0		0	0	0	153544	0	121	40213260		
120622	2651	40213201	2013-09-18	2013-09-18 00:00:00	2013-09-18	2013-09-18 00:00:00	2013-09-18	581452		0	0	0		0	0	0	175412	0	33	40213201		
47477	3936	19006318	1958-08-07	1958-08-07 00:00:00	1958-08-21	1958-08-21 00:00:00	1958-08-21	38000177		0	0	14		0	0	0	261644	0	105078	19006318		
47509	3939	1127433	1993-05-12	1993-05-12 00:00:00	1993-05-26	1993-05-26 00:00:00	1993-05-26	38000177		0	0	14		0	0	0	261817	0	313782	1127433		
9112	758	1127433	2006-05-03	2006-05-03 00:00:00	2006-05-10	2006-05-10 00:00:00	2006-05-10	38000177		0	0	7		0	0	0	50338	0	313782	1127433		
197000	4329	40213160	1982-10-31	1982-10-31 00:00:00	1982-10-31	1982-10-31 00:00:00	1982-10-31	581452		0	0	0		0	0	0	287136	0	10	40213160		
19668	1618	19075601	1999-03-03	1999-03-03 00:00:00	2006-04-12	2006-04-12 00:00:00	2006-04-12	38000177		0	0	2597		0	0	0	108805	0	309362	19075601		
231930	5097	40213296	2009-01-19	2009-01-19 00:00:00	2009-01-19	2009-01-19 00:00:00	2009-01-19	581452		0	0	0		0	0	0	338727	0	52	40213296		
24369	2005	46233988	1974-05-08	1974-05-08 00:00:00	1974-05-22	1974-05-22 00:00:00	1974-05-22	38000177		0	0	14		0	0	0	133482	0	1652673	46233988		
7944	664	1127433	2006-07-03	2006-07-03 00:00:00	2006-07-24	2006-07-24 00:00:00	2006-07-24	38000177		0	0	21		0	0	0	43890	0	313782	1127433		
4733	395	19059056	1964-12-21	1964-12-21 00:00:00	1965-01-11	1965-01-11 00:00:00	1965-01-11	38000177		0	0	21		0	0	0	25937	0	243670	19059056		
51374	4270	1127433	1995-09-22	1995-09-22 00:00:00	1995-10-06	1995-10-06 00:00:00	1995-10-06	38000177		0	0	14		0	0	0	283438	0	313782	1127433		
185239	4071	40213160	1955-09-08	1955-09-08 00:00:00	1955-09-08	1955-09-08 00:00:00	1955-09-08	581452		0	0	0		0	0	0	270571	0	10	40213160		
35024	2892	1127433	1978-06-10	1978-06-10 00:00:00	1978-06-17	1978-06-17 00:00:00	1978-06-17	38000177		0	0	7		0	0	0	192419	0	313782	1127433		
115156	2530	40213227	2015-10-04	2015-10-04 00:00:00	2015-10-04	2015-10-04 00:00:00	2015-10-04	581452		0	0	0		0	0	0	167243	0	113	40213227		
23642	1946	1127433	1974-11-08	1974-11-08 00:00:00	1974-11-15	1974-11-15 00:00:00	1974-11-15	38000177		0	0	7		0	0	0	129334	0	313782	1127433		
135959	2985	40213227	2014-10-25	2014-10-25 00:00:00	2014-10-25	2014-10-25 00:00:00	2014-10-25	581452		0	0	0		0	0	0	199194	0	113	40213227		
34202	2827	1127433	1945-07-21	1945-07-21 00:00:00	1945-08-04	1945-08-04 00:00:00	1945-08-04	38000177		0	0	14		0	0	0	187469	0	313782	1127433		
57214	4749	19073188	1994-04-08	1994-04-08 00:00:00	1994-04-22	1994-04-22 00:00:00	1994-04-22	38000177		0	0	14		0	0	0	316251	0	308192	19073188		
3179	70	40213198	2014-01-12	2014-01-12 00:00:00	2014-01-12	2014-01-12 00:00:00	2014-01-12	581452		0	0	0		0	0	0	4806	0	133	40213198		
176988	3890	40213198	2018-01-23	2018-01-23 00:00:00	2018-01-23	2018-01-23 00:00:00	2018-01-23	581452		0	0	0		0	0	0	258610	0	133	40213198		
62496	5199	1127433	1978-05-15	1978-05-15 00:00:00	1978-05-22	1978-05-22 00:00:00	1978-05-22	38000177		0	0	7		0	0	0	345772	0	313782	1127433		
69077	1511	40213260	2016-05-01	2016-05-01 00:00:00	2016-05-01	2016-05-01 00:00:00	2016-05-01	581452		0	0	0		0	0	0	100911	0	121	40213260		
42047	3486	1127433	1974-12-06	1974-12-06 00:00:00	1975-01-03	1975-01-03 00:00:00	1975-01-03	38000177		0	0	28		0	0	0	231295	0	313782	1127433		
39472	3260	1115171	1996-09-14	1996-09-14 00:00:00	1996-10-05	1996-10-05 00:00:00	1996-10-05	38000177		0	0	21		0	0	0	216751	0	849574	1115171		
15126	326	40213227	2002-03-18	2002-03-18 00:00:00	2002-03-18	2002-03-18 00:00:00	2002-03-18	581452		0	0	0		0	0	0	21557	0	113	40213227		
30851	2554	19075601	1999-12-02	1999-12-02 00:00:00	1999-12-02	1999-12-02 00:00:00	\N	38000177		0	0	0		0	0	0	169105	0	309362	19075601		
56727	4705	19128022	1993-05-06	1993-05-06 00:00:00	1994-05-01	1994-05-01 00:00:00	1994-05-01	38000177		0	0	360		0	0	0	313456	0	749785	19128022		
171119	3761	40213160	1956-09-29	1956-09-29 00:00:00	1956-09-29	1956-09-29 00:00:00	1956-09-29	581452		0	0	0		0	0	0	250100	0	10	40213160		
45854	3796	1127433	2006-08-10	2006-08-10 00:00:00	2006-08-31	2006-08-31 00:00:00	2006-08-31	38000177		0	0	21		0	0	0	252359	0	313782	1127433		
12024	1004	19133873	1964-07-06	1964-07-06 00:00:00	1964-07-16	1964-07-16 00:00:00	1964-07-16	38000177		0	0	10		0	0	0	66357	0	834061	19133873		
141914	3117	40213160	1978-07-12	1978-07-12 00:00:00	1978-07-12	1978-07-12 00:00:00	1978-07-12	581452		0	0	0		0	0	0	207395	0	10	40213160		
44545	3689	1127433	1959-09-10	1959-09-10 00:00:00	1959-09-17	1959-09-17 00:00:00	1959-09-17	38000177		0	0	7		0	0	0	245209	0	313782	1127433		
103067	2260	40213198	2010-09-19	2010-09-19 00:00:00	2010-09-19	2010-09-19 00:00:00	2010-09-19	581452		0	0	0		0	0	0	150192	0	133	40213198		
8826	189	40213227	2009-08-16	2009-08-16 00:00:00	2009-08-16	2009-08-16 00:00:00	2009-08-16	581452		0	0	0		0	0	0	12849	0	113	40213227		
55154	4578	1713671	2019-02-21	2019-02-21 00:00:00	2019-02-28	2019-02-28 00:00:00	2019-02-28	38000177		0	0	7		0	0	0	304964	0	562251	1713671		
49221	4085	1127078	1966-03-26	1966-03-26 00:00:00	1966-04-25	1966-04-25 00:00:00	1966-04-25	38000177		0	0	30		0	0	0	271439	0	282464	1127078		
33377	2765	40229134	1989-04-07	1989-04-07 00:00:00	1989-04-14	1989-04-14 00:00:00	1989-04-14	38000177		0	0	7		0	0	0	182942	0	1043400	40229134		
224719	4933	40213160	1970-08-13	1970-08-13 00:00:00	1970-08-13	1970-08-13 00:00:00	1970-08-13	581452		0	0	0		0	0	0	327979	0	10	40213160		
5470	457	40236824	2009-09-10	2009-09-10 00:00:00	2009-09-17	2009-09-17 00:00:00	2009-09-17	38000177		0	0	7		0	0	0	30605	0	1094107	40236824		
10965	914	40229134	2006-07-09	2006-07-09 00:00:00	2006-07-16	2006-07-16 00:00:00	2006-07-16	38000177		0	0	7		0	0	0	60774	0	1043400	40229134		
16019	1328	19059056	1946-09-01	1946-09-01 00:00:00	1946-09-15	1946-09-15 00:00:00	1946-09-15	38000177		0	0	14		0	0	0	88145	0	243670	19059056		
54783	4550	1713671	1974-03-14	1974-03-14 00:00:00	1974-04-04	1974-04-04 00:00:00	1974-04-04	38000177		0	0	21		0	0	0	303203	0	562251	1713671		
223963	4916	40213306	1999-10-01	1999-10-01 00:00:00	1999-10-01	1999-10-01 00:00:00	1999-10-01	581452		0	0	0		0	0	0	326706	0	43	40213306		
8576	715	19073183	1986-06-29	1986-06-29 00:00:00	1986-07-13	1986-07-13 00:00:00	1986-07-13	38000177		0	0	14		0	0	0	47335	0	308182	19073183		
34895	761	40213306	2001-06-08	2001-06-08 00:00:00	2001-06-08	2001-06-08 00:00:00	2001-06-08	581452		0	0	0		0	0	0	50558	0	43	40213306		
54595	4534	19126352	2005-03-02	2005-03-02 00:00:00	2011-11-30	2011-11-30 00:00:00	2011-11-30	38000177		0	0	2464		0	0	0	302032	0	705129	19126352		
19146	1579	40220960	1999-04-29	1999-04-29 00:00:00	1999-04-29	1999-04-29 00:00:00	1999-04-29	38000177		0	0	0		0	0	0	106071	0	1804799	40220960		
22054	1813	1127433	1990-10-09	1990-10-09 00:00:00	1990-10-16	1990-10-16 00:00:00	1990-10-16	38000177		0	0	7		0	0	0	121343	0	313782	1127433		
49615	1086	40213296	2007-03-02	2007-03-02 00:00:00	2007-03-02	2007-03-02 00:00:00	2007-03-02	581452		0	0	0		0	0	0	71348	0	52	40213296		
37339	3084	19078461	2006-10-13	2006-10-13 00:00:00	2006-12-12	2006-12-12 00:00:00	2006-12-12	38000177		0	0	60		0	0	0	205355	0	310965	19078461		
58294	4844	1127433	1976-05-14	1976-05-14 00:00:00	1976-05-21	1976-05-21 00:00:00	1976-05-21	38000177		0	0	7		0	0	0	322286	0	313782	1127433		
106192	2329	40213160	1971-06-22	1971-06-22 00:00:00	1971-06-22	1971-06-22 00:00:00	1971-06-22	581452		0	0	0		0	0	0	154949	0	10	40213160		
108017	2367	40213296	2015-10-20	2015-10-20 00:00:00	2015-10-20	2015-10-20 00:00:00	2015-10-20	581452		0	0	0		0	0	0	157570	0	52	40213296		
179915	3955	40213160	1956-07-14	1956-07-14 00:00:00	1956-07-14	1956-07-14 00:00:00	1956-07-14	581452		0	0	0		0	0	0	262862	0	10	40213160		
11477	956	1127433	2014-09-28	2014-09-28 00:00:00	2014-10-05	2014-10-05 00:00:00	2014-10-05	38000177		0	0	7		0	0	0	63446	0	313782	1127433		
53517	4450	1127078	1976-11-22	1976-11-22 00:00:00	1977-01-21	1977-01-21 00:00:00	1977-01-21	38000177		0	0	60		0	0	0	296084	0	282464	1127078		
51706	4297	35605482	1991-02-19	1991-02-19 00:00:00	1991-02-19	1991-02-19 00:00:00	1991-02-19	38000177		0	0	0		0	0	0	285178	0	1740467	35605482		
53601	4454	19075601	2004-05-15	2004-05-15 00:00:00	2004-05-15	2004-05-15 00:00:00	\N	38000177		0	0	0		0	0	0	296432	0	309362	19075601		
9802	820	19073188	1982-06-17	1982-06-17 00:00:00	1982-07-01	1982-07-01 00:00:00	1982-07-01	38000177		0	0	14		0	0	0	54363	0	308192	19073188		
64183	5328	19059056	1913-08-21	1913-08-21 00:00:00	1913-09-04	1913-09-04 00:00:00	1913-09-04	38000177		0	0	14		0	0	0	354717	0	243670	19059056		
149711	3293	40213227	2003-11-08	2003-11-08 00:00:00	2003-11-08	2003-11-08 00:00:00	2003-11-08	581452		0	0	0		0	0	0	218730	0	113	40213227		
50180	1099	40213160	1955-03-05	1955-03-05 00:00:00	1955-03-05	1955-03-05 00:00:00	1955-03-05	581452		0	0	0		0	0	0	\N	0	10	40213160		
19446	1604	1713671	1967-09-11	1967-09-11 00:00:00	1967-10-02	1967-10-02 00:00:00	1967-10-02	38000177		0	0	21		0	0	0	107613	0	562251	1713671		
105183	2307	40213227	2003-10-14	2003-10-14 00:00:00	2003-10-14	2003-10-14 00:00:00	2003-10-14	581452		0	0	0		0	0	0	153523	0	113	40213227		
120631	2651	40213198	2012-09-12	2012-09-12 00:00:00	2012-09-12	2012-09-12 00:00:00	2012-09-12	581452		0	0	0		0	0	0	175482	0	133	40213198		
47478	3936	1124300	1997-12-15	1997-12-15 00:00:00	1997-12-15	1997-12-15 00:00:00	\N	38000177		0	0	0		0	0	0	261604	0	00781178901	45011828		
47510	3939	19133873	1982-12-22	1982-12-22 00:00:00	1982-12-30	1982-12-30 00:00:00	1982-12-30	38000177		0	0	8		0	0	0	261813	0	834061	19133873		
9113	758	1118084	2012-10-31	2012-10-31 00:00:00	2012-10-31	2012-10-31 00:00:00	\N	38000177		0	0	0		0	0	0	50337	0	00025152531	44923712		
197003	4329	40213251	1984-11-11	1984-11-11 00:00:00	1984-11-11	1984-11-11 00:00:00	1984-11-11	581452		0	0	0		0	0	0	287137	0	21	40213251		
19669	1618	19126352	1999-03-03	1999-03-03 00:00:00	2006-04-12	2006-04-12 00:00:00	2006-04-12	38000177		0	0	2597		0	0	0	108805	0	705129	19126352		
231935	5097	40213160	1967-12-04	1967-12-04 00:00:00	1967-12-04	1967-12-04 00:00:00	1967-12-04	581452		0	0	0		0	0	0	338739	0	10	40213160		
24370	2005	1118084	2010-01-14	2010-01-14 00:00:00	2010-01-14	2010-01-14 00:00:00	\N	38000177		0	0	0		0	0	0	133500	0	00025152531	44923712		
7945	664	19128022	1995-07-06	1995-07-06 00:00:00	1996-06-30	1996-06-30 00:00:00	1996-06-30	38000177		0	0	360		0	0	0	43833	0	749785	19128022		
4734	395	19115351	1973-03-13	1973-03-13 00:00:00	1973-09-04	1973-09-04 00:00:00	1973-09-04	38000177		0	0	175		0	0	0	25981	0	563026	19115351		
51375	4270	1713671	2015-11-22	2015-11-22 00:00:00	2015-12-06	2015-12-06 00:00:00	2015-12-06	38000177		0	0	14		0	0	0	283425	0	562251	1713671		
185241	4071	40213227	1994-09-08	1994-09-08 00:00:00	1994-09-08	1994-09-08 00:00:00	1994-09-08	581452		0	0	0		0	0	0	270601	0	113	40213227		
35025	2893	1127433	1956-05-15	1956-05-15 00:00:00	1956-07-14	1956-07-14 00:00:00	1956-07-14	38000177		0	0	60		0	0	0	192518	0	313782	1127433		
115160	2530	40213160	1964-10-04	1964-10-04 00:00:00	1964-10-04	1964-10-04 00:00:00	1964-10-04	581452		0	0	0		0	0	0	167268	0	10	40213160		
23643	1946	40163554	2014-01-04	2014-01-04 00:00:00	2014-01-04	2014-01-04 00:00:00	\N	38000177		0	0	0		0	0	0	129354	0	855332	40163554		
135960	2985	40213260	2014-10-25	2014-10-25 00:00:00	2014-10-25	2014-10-25 00:00:00	2014-10-25	581452		0	0	0		0	0	0	199194	0	121	40213260		
34203	2827	1713671	1985-08-22	1985-08-22 00:00:00	1985-08-29	1985-08-29 00:00:00	1985-08-29	38000177		0	0	7		0	0	0	187471	0	562251	1713671		
57215	4749	19133905	2008-11-25	2008-11-25 00:00:00	2008-12-05	2008-12-05 00:00:00	2008-12-05	38000177		0	0	10		0	0	0	316240	0	834102	19133905		
3186	70	40213201	2015-01-18	2015-01-18 00:00:00	2015-01-18	2015-01-18 00:00:00	2015-01-18	581452		0	0	0		0	0	0	4760	0	33	40213201		
176996	3890	40213260	2006-11-21	2006-11-21 00:00:00	2006-11-21	2006-11-21 00:00:00	2006-11-21	581452		0	0	0		0	0	0	258608	0	121	40213260		
62497	5199	19115351	1976-10-12	1976-10-12 00:00:00	1977-03-01	1977-03-01 00:00:00	1977-03-01	38000177		0	0	140		0	0	0	345798	0	563026	19115351		
69080	1511	40213227	1996-05-05	1996-05-05 00:00:00	1996-05-05	1996-05-05 00:00:00	1996-05-05	581452		0	0	0		0	0	0	100907	0	113	40213227		
42048	3486	1118084	2000-12-24	2000-12-24 00:00:00	2000-12-24	2000-12-24 00:00:00	\N	38000177		0	0	0		0	0	0	231264	0	00025152531	44923712		
39499	3263	1127433	1962-04-23	1962-04-23 00:00:00	1962-05-07	1962-05-07 00:00:00	1962-05-07	38000177		0	0	14		0	0	0	216907	0	313782	1127433		
19059	1574	1713671	1972-06-18	1972-06-18 00:00:00	1972-12-17	1972-12-17 00:00:00	1972-12-17	38000177		0	0	182		0	0	0	105661	0	562251	1713671		
30852	2554	19126352	1999-12-02	1999-12-02 00:00:00	1999-12-02	1999-12-02 00:00:00	\N	38000177		0	0	0		0	0	0	169105	0	705129	19126352		
56728	4705	1127078	1982-05-27	1982-05-27 00:00:00	1982-06-10	1982-06-10 00:00:00	1982-06-10	38000177		0	0	14		0	0	0	313472	0	282464	1127078		
171123	3761	40213227	2007-04-28	2007-04-28 00:00:00	2007-04-28	2007-04-28 00:00:00	2007-04-28	581452		0	0	0		0	0	0	250092	0	113	40213227		
45855	3796	1118084	2007-05-23	2007-05-23 00:00:00	2007-05-23	2007-05-23 00:00:00	\N	38000177		0	0	0		0	0	0	252359	0	00025152531	44923712		
12025	1004	19059056	1965-06-27	1965-06-27 00:00:00	1965-07-11	1965-07-11 00:00:00	1965-07-11	38000177		0	0	14		0	0	0	66360	0	243670	19059056		
141932	3118	40213160	1955-09-25	1955-09-25 00:00:00	1955-09-25	1955-09-25 00:00:00	1955-09-25	581452		0	0	0		0	0	0	207490	0	10	40213160		
44546	3689	19059056	1984-09-28	1984-09-28 00:00:00	1984-10-26	1984-10-26 00:00:00	1984-10-26	38000177		0	0	28		0	0	0	245226	0	243670	19059056		
103069	2260	40213227	2003-08-10	2003-08-10 00:00:00	2003-08-10	2003-08-10 00:00:00	2003-08-10	581452		0	0	0		0	0	0	150209	0	113	40213227		
8827	189	40213260	2009-08-16	2009-08-16 00:00:00	2009-08-16	2009-08-16 00:00:00	2009-08-16	581452		0	0	0		0	0	0	12849	0	121	40213260		
55155	4579	19006318	1969-10-01	1969-10-01 00:00:00	1969-10-15	1969-10-15 00:00:00	1969-10-15	38000177		0	0	14		0	0	0	305011	0	105078	19006318		
49222	4085	40229134	1994-04-21	1994-04-21 00:00:00	1994-04-28	1994-04-28 00:00:00	1994-04-28	38000177		0	0	7		0	0	0	271499	0	1043400	40229134		
33378	2765	40169281	2006-10-31	2006-10-31 00:00:00	2006-10-31	2006-10-31 00:00:00	\N	38000177		0	0	0		0	0	0	182833	0	896209	40169281		
224725	4933	40213160	1975-02-13	1975-02-13 00:00:00	1975-02-13	1975-02-13 00:00:00	1975-02-13	581452		0	0	0		0	0	0	327945	0	10	40213160		
5471	457	920300	2009-09-10	2009-09-10 00:00:00	2009-09-17	2009-09-17 00:00:00	2009-09-17	38000177		0	0	7		0	0	0	30605	0	311989	920300		
10966	915	19133905	2010-06-28	2010-06-28 00:00:00	2010-07-06	2010-07-06 00:00:00	2010-07-06	38000177		0	0	8		0	0	0	60828	0	834102	19133905		
16020	1328	19078461	2014-03-25	2014-03-25 00:00:00	2014-04-15	2014-04-15 00:00:00	2014-04-15	38000177		0	0	21		0	0	0	88160	0	310965	19078461		
54784	4550	1713671	1974-10-07	1974-10-07 00:00:00	1974-10-21	1974-10-21 00:00:00	1974-10-21	38000177		0	0	14		0	0	0	303178	0	562251	1713671		
223967	4916	40213160	1978-01-06	1978-01-06 00:00:00	1978-01-06	1978-01-06 00:00:00	1978-01-06	581452		0	0	0		0	0	0	326693	0	10	40213160		
8577	715	1127433	1992-11-26	1992-11-26 00:00:00	1992-12-10	1992-12-10 00:00:00	1992-12-10	38000177		0	0	14		0	0	0	47290	0	313782	1127433		
34896	761	40213227	2001-06-08	2001-06-08 00:00:00	2001-06-08	2001-06-08 00:00:00	2001-06-08	581452		0	0	0		0	0	0	50558	0	113	40213227		
54596	4534	19075601	2005-03-02	2005-03-02 00:00:00	2011-11-30	2011-11-30 00:00:00	2011-11-30	38000177		0	0	2464		0	0	0	302032	0	309362	19075601		
19147	1579	19059056	1964-04-02	1964-04-02 00:00:00	1964-07-01	1964-07-01 00:00:00	1964-07-01	38000177		0	0	90		0	0	0	106102	0	243670	19059056		
22055	1813	19019979	1986-07-24	1986-07-24 00:00:00	1986-10-22	1986-10-22 00:00:00	1986-10-22	38000177		0	0	90		0	0	0	121309	0	198405	19019979		
164462	3616	40213227	1992-03-24	1992-03-24 00:00:00	1992-03-24	1992-03-24 00:00:00	1992-03-24	581452		0	0	0		0	0	0	240284	0	113	40213227		
37340	3084	40165015	2006-10-13	2006-10-13 00:00:00	2006-10-13	2006-10-13 00:00:00	\N	38000177		0	0	0		0	0	0	205355	0	861467	40165015		
58295	4844	1127433	1994-06-25	1994-06-25 00:00:00	1994-07-09	1994-07-09 00:00:00	1994-07-09	38000177		0	0	14		0	0	0	322217	0	313782	1127433		
106194	2329	40213227	2013-01-22	2013-01-22 00:00:00	2013-01-22	2013-01-22 00:00:00	2013-01-22	581452		0	0	0		0	0	0	154921	0	113	40213227		
108019	2367	40213160	1975-07-08	1975-07-08 00:00:00	1975-07-08	1975-07-08 00:00:00	1975-07-08	581452		0	0	0		0	0	0	157594	0	10	40213160		
179921	3955	40213160	1961-01-14	1961-01-14 00:00:00	1961-01-14	1961-01-14 00:00:00	1961-01-14	581452		0	0	0		0	0	0	262866	0	10	40213160		
11478	956	40173590	2006-05-03	2006-05-03 00:00:00	2006-05-03	2006-05-03 00:00:00	\N	38000177		0	0	0		0	0	0	63525	0	904419	40173590		
53518	4450	46233988	1969-02-13	1969-02-13 00:00:00	1969-02-27	1969-02-27 00:00:00	1969-02-27	38000177		0	0	14		0	0	0	296039	0	1652673	46233988		
51707	4297	40231925	1991-02-20	1991-02-20 00:00:00	1991-02-20	1991-02-20 00:00:00	\N	38000177		0	0	0		0	0	0	285178	0	1049221	40231925		
53602	4454	19126352	2004-05-15	2004-05-15 00:00:00	2004-05-15	2004-05-15 00:00:00	\N	38000177		0	0	0		0	0	0	296432	0	705129	19126352		
9803	820	19078461	1982-06-17	1982-06-17 00:00:00	1982-07-01	1982-07-01 00:00:00	1982-07-01	38000177		0	0	14		0	0	0	54363	0	310965	19078461		
64184	5328	1127433	1955-02-03	1955-02-03 00:00:00	1955-05-04	1955-05-04 00:00:00	1955-05-04	38000177		0	0	90		0	0	0	354588	0	313782	1127433		
242732	5329	40213198	2010-12-22	2010-12-22 00:00:00	2010-12-22	2010-12-22 00:00:00	2010-12-22	581452		0	0	0		0	0	0	354738	0	133	40213198		
50196	1099	40213160	1955-03-12	1955-03-12 00:00:00	1955-03-12	1955-03-12 00:00:00	1955-03-12	581452		0	0	0		0	0	0	72125	0	10	40213160		
19447	1604	40229134	1990-06-18	1990-06-18 00:00:00	1990-07-02	1990-07-02 00:00:00	1990-07-02	38000177		0	0	14		0	0	0	107616	0	1043400	40229134		
105184	2307	40213296	2003-10-14	2003-10-14 00:00:00	2003-10-14	2003-10-14 00:00:00	2003-10-14	581452		0	0	0		0	0	0	153523	0	52	40213296		
131929	2898	40213227	2010-11-30	2010-11-30 00:00:00	2010-11-30	2010-11-30 00:00:00	2010-11-30	581452		0	0	0		0	0	0	193023	0	113	40213227		
47479	3936	19133873	1968-11-23	1968-11-23 00:00:00	1968-12-02	1968-12-02 00:00:00	1968-12-02	38000177		0	0	9		0	0	0	261605	0	834061	19133873		
47511	3939	1713671	1987-07-22	1987-07-22 00:00:00	1987-08-12	1987-08-12 00:00:00	1987-08-12	38000177		0	0	21		0	0	0	261863	0	562251	1713671		
9114	758	1127433	1988-12-01	1988-12-01 00:00:00	1988-12-15	1988-12-15 00:00:00	1988-12-15	38000177		0	0	14		0	0	0	50355	0	313782	1127433		
197010	4329	40213227	2001-01-28	2001-01-28 00:00:00	2001-01-28	2001-01-28 00:00:00	2001-01-28	581452		0	0	0		0	0	0	287099	0	113	40213227		
19670	1618	1332419	1999-03-03	1999-03-03 00:00:00	1999-03-03	1999-03-03 00:00:00	\N	38000177		0	0	0		0	0	0	108805	0	197361	1332419		
231936	5097	40213306	1990-06-11	1990-06-11 00:00:00	1990-06-11	1990-06-11 00:00:00	1990-06-11	581452		0	0	0		0	0	0	338669	0	43	40213306		
2377	190	1127433	1979-03-02	1979-03-02 00:00:00	1979-03-16	1979-03-16 00:00:00	1979-03-16	38000177		0	0	14		0	0	0	12964	0	313782	1127433		
7946	664	1127433	1987-09-07	1987-09-07 00:00:00	1987-09-14	1987-09-14 00:00:00	1987-09-14	38000177		0	0	7		0	0	0	43802	0	313782	1127433		
4735	395	19133905	1983-12-16	1983-12-16 00:00:00	1983-12-26	1983-12-26 00:00:00	1983-12-26	38000177		0	0	10		0	0	0	25954	0	834102	19133905		
51376	4270	1127078	1978-03-15	1978-03-15 00:00:00	1978-03-29	1978-03-29 00:00:00	1978-03-29	38000177		0	0	14		0	0	0	283441	0	282464	1127078		
185249	4071	40213198	2017-12-21	2017-12-21 00:00:00	2017-12-21	2017-12-21 00:00:00	2017-12-21	581452		0	0	0		0	0	0	270606	0	133	40213198		
35026	2893	1124300	1985-08-05	1985-08-05 00:00:00	1985-08-05	1985-08-05 00:00:00	\N	38000177		0	0	0		0	0	0	192482	0	00781178901	45011828		
115164	2530	40213160	1965-01-03	1965-01-03 00:00:00	1965-01-03	1965-01-03 00:00:00	1965-01-03	581452		0	0	0		0	0	0	167257	0	10	40213160		
23644	1946	19018935	2014-01-04	2014-01-04 00:00:00	2014-01-04	2014-01-04 00:00:00	\N	38000177		0	0	0		0	0	0	129354	0	197604	19018935		
135962	2985	40213160	1968-09-28	1968-09-28 00:00:00	1968-09-28	1968-09-28 00:00:00	1968-09-28	581452		0	0	0		0	0	0	199201	0	10	40213160		
34204	2827	1124300	1958-04-08	1958-04-08 00:00:00	1958-04-08	1958-04-08 00:00:00	\N	38000177		0	0	0		0	0	0	187494	0	00781178901	45011828		
57216	4749	1713671	2011-07-22	2011-07-22 00:00:00	2011-07-29	2011-07-29 00:00:00	2011-07-29	38000177		0	0	7		0	0	0	316227	0	562251	1713671		
3203	70	40213227	1993-02-21	1993-02-21 00:00:00	1993-02-21	1993-02-21 00:00:00	1993-02-21	581452		0	0	0		0	0	0	4755	0	113	40213227		
177003	3890	40213201	2019-01-15	2019-01-15 00:00:00	2019-01-15	2019-01-15 00:00:00	2019-01-15	581452		0	0	0		0	0	0	258611	0	33	40213201		
62499	5199	1127433	2005-06-06	2005-06-06 00:00:00	2005-06-20	2005-06-20 00:00:00	2005-06-20	38000177		0	0	14		0	0	0	345782	0	313782	1127433		
69082	1511	40213227	2007-05-06	2007-05-06 00:00:00	2007-05-06	2007-05-06 00:00:00	2007-05-06	581452		0	0	0		0	0	0	100892	0	113	40213227		
42049	3486	1127433	1995-12-30	1995-12-30 00:00:00	1996-01-13	1996-01-13 00:00:00	1996-01-13	38000177		0	0	14		0	0	0	231292	0	313782	1127433		
39500	3263	46275916	2007-09-11	2007-09-11 00:00:00	2007-09-11	2007-09-11 00:00:00	2007-09-11	38000177		0	0	0		0	0	0	216903	0	1660014	46275916		
19060	1574	1118084	2000-12-11	2000-12-11 00:00:00	2000-12-11	2000-12-11 00:00:00	\N	38000177		0	0	0		0	0	0	105689	0	00025152531	44923712		
30853	2554	1539411	1999-12-02	1999-12-02 00:00:00	1999-12-02	1999-12-02 00:00:00	\N	38000177		0	0	0		0	0	0	169105	0	312961	1539411		
56729	4705	19073183	1982-05-27	1982-05-27 00:00:00	1982-06-10	1982-06-10 00:00:00	1982-06-10	38000177		0	0	14		0	0	0	313472	0	308182	19073183		
171124	3761	40213260	2007-04-28	2007-04-28 00:00:00	2007-04-28	2007-04-28 00:00:00	2007-04-28	581452		0	0	0		0	0	0	250092	0	121	40213260		
45856	3796	40229134	2010-08-18	2010-08-18 00:00:00	2010-09-01	2010-09-01 00:00:00	2010-09-01	38000177		0	0	14		0	0	0	252412	0	1043400	40229134		
12026	1004	19129655	1965-06-27	1965-06-27 00:00:00	1965-07-11	1965-07-11 00:00:00	1965-07-11	38000177		0	0	14		0	0	0	66360	0	789980	19129655		
141943	3118	40213227	1999-12-12	1999-12-12 00:00:00	1999-12-12	1999-12-12 00:00:00	1999-12-12	581452		0	0	0		0	0	0	207453	0	113	40213227		
44548	3689	19059056	1963-11-17	1963-11-17 00:00:00	1964-01-16	1964-01-16 00:00:00	1964-01-16	38000177		0	0	60		0	0	0	245225	0	243670	19059056		
103071	2260	40213227	1993-06-13	1993-06-13 00:00:00	1993-06-13	1993-06-13 00:00:00	1993-06-13	581452		0	0	0		0	0	0	150227	0	113	40213227		
8830	189	40213160	1959-01-18	1959-01-18 00:00:00	1959-01-18	1959-01-18 00:00:00	1959-01-18	581452		0	0	0		0	0	0	12900	0	10	40213160		
55156	4579	19059056	1969-10-01	1969-10-01 00:00:00	1969-10-15	1969-10-15 00:00:00	1969-10-15	38000177		0	0	14		0	0	0	305011	0	243670	19059056		
49223	4085	1127078	1961-11-02	1961-11-02 00:00:00	1961-11-16	1961-11-16 00:00:00	1961-11-16	38000177		0	0	14		0	0	0	271457	0	282464	1127078		
33379	2765	1127433	1978-07-18	1978-07-18 00:00:00	1978-08-01	1978-08-01 00:00:00	1978-08-01	38000177		0	0	14		0	0	0	182878	0	313782	1127433		
224729	4933	40213227	2001-09-20	2001-09-20 00:00:00	2001-09-20	2001-09-20 00:00:00	2001-09-20	581452		0	0	0		0	0	0	327950	0	113	40213227		
5472	457	1127433	1998-07-04	1998-07-04 00:00:00	1998-08-10	1998-08-10 00:00:00	1998-08-10	38000177		0	0	37		0	0	0	30593	0	313782	1127433		
10967	915	19078461	2000-04-24	2000-04-24 00:00:00	2000-05-08	2000-05-08 00:00:00	2000-05-08	38000177		0	0	14		0	0	0	60786	0	310965	19078461		
16023	1328	19133905	1973-04-11	1973-04-11 00:00:00	1973-04-23	1973-04-23 00:00:00	1973-04-23	38000177		0	0	12		0	0	0	88193	0	834102	19133905		
26504	2180	1127078	1989-04-05	1989-04-05 00:00:00	1989-04-19	1989-04-19 00:00:00	1989-04-19	38000177		0	0	14		0	0	0	145419	0	282464	1127078		
223968	4916	40213314	1978-01-06	1978-01-06 00:00:00	1978-01-06	1978-01-06 00:00:00	1978-01-06	581452		0	0	0		0	0	0	326693	0	49	40213314		
8578	715	19133873	1997-10-11	1997-10-11 00:00:00	1997-10-23	1997-10-23 00:00:00	1997-10-23	38000177		0	0	12		0	0	0	47291	0	834061	19133873		
63315	1385	40213296	2000-05-19	2000-05-19 00:00:00	2000-05-19	2000-05-19 00:00:00	2000-05-19	581452		0	0	0		0	0	0	91859	0	52	40213296		
54597	4534	1332419	2005-03-02	2005-03-02 00:00:00	2005-03-02	2005-03-02 00:00:00	\N	38000177		0	0	0		0	0	0	302032	0	197361	1332419		
19148	1579	19133905	1989-03-10	1989-03-10 00:00:00	1989-03-20	1989-03-20 00:00:00	1989-03-20	38000177		0	0	10		0	0	0	106089	0	834102	19133905		
22056	1813	19133905	2007-09-03	2007-09-03 00:00:00	2007-09-16	2007-09-16 00:00:00	2007-09-16	38000177		0	0	13		0	0	0	121347	0	834102	19133905		
164465	3616	40213160	1958-06-03	1958-06-03 00:00:00	1958-06-03	1958-06-03 00:00:00	1958-06-03	581452		0	0	0		0	0	0	240300	0	10	40213160		
37341	3084	19019979	1978-04-22	1978-04-22 00:00:00	1978-05-06	1978-05-06 00:00:00	1978-05-06	38000177		0	0	14		0	0	0	205401	0	198405	19019979		
58296	4844	1551192	1975-03-12	1975-03-12 00:00:00	1975-03-12	1975-03-12 00:00:00	1975-03-12	38000177		0	0	0		0	0	0	322281	0	312617	1551192		
106195	2329	40213296	2013-01-22	2013-01-22 00:00:00	2013-01-22	2013-01-22 00:00:00	2013-01-22	581452		0	0	0		0	0	0	154921	0	52	40213296		
108022	2367	40213227	2017-10-24	2017-10-24 00:00:00	2017-10-24	2017-10-24 00:00:00	2017-10-24	581452		0	0	0		0	0	0	157563	0	113	40213227		
179925	3955	40213260	2007-02-10	2007-02-10 00:00:00	2007-02-10	2007-02-10 00:00:00	2007-02-10	581452		0	0	0		0	0	0	262881	0	121	40213260		
4323	358	1127433	1957-03-27	1957-03-27 00:00:00	1957-04-03	1957-04-03 00:00:00	1957-04-03	38000177		0	0	7		0	0	0	23807	0	313782	1127433		
53519	4450	1127078	1969-02-13	1969-02-13 00:00:00	1969-02-27	1969-02-27 00:00:00	1969-02-27	38000177		0	0	14		0	0	0	296039	0	282464	1127078		
51708	4297	35605858	1991-02-19	1991-02-19 00:00:00	1991-02-19	1991-02-19 00:00:00	1991-02-19	38000177		0	0	0		0	0	0	285178	0	1732136	35605858		
53603	4454	1332419	2004-05-15	2004-05-15 00:00:00	2004-05-15	2004-05-15 00:00:00	\N	38000177		0	0	0		0	0	0	296432	0	197361	1332419		
9804	821	40229134	1968-08-08	1968-08-08 00:00:00	1968-08-15	1968-08-15 00:00:00	1968-08-15	38000177		0	0	7		0	0	0	54398	0	1043400	40229134		
64185	5328	1127433	1969-05-03	1969-05-03 00:00:00	1969-05-10	1969-05-10 00:00:00	1969-05-10	38000177		0	0	7		0	0	0	354709	0	313782	1127433		
242734	5329	40213227	2004-11-24	2004-11-24 00:00:00	2004-11-24	2004-11-24 00:00:00	2004-11-24	581452		0	0	0		0	0	0	354816	0	113	40213227		
50197	1100	40213160	1987-09-09	1987-09-09 00:00:00	1987-09-09	1987-09-09 00:00:00	1987-09-09	581452		0	0	0		0	0	0	72298	0	10	40213160		
19448	1604	1713671	1978-11-10	1978-11-10 00:00:00	1978-11-17	1978-11-17 00:00:00	1978-11-17	38000177		0	0	7		0	0	0	107614	0	562251	1713671		
105187	2307	40213296	2001-10-09	2001-10-09 00:00:00	2001-10-09	2001-10-09 00:00:00	2001-10-09	581452		0	0	0		0	0	0	153521	0	52	40213296		
131931	2898	40213314	1980-03-25	1980-03-25 00:00:00	1980-03-25	1980-03-25 00:00:00	1980-03-25	581452		0	0	0		0	0	0	193016	0	49	40213314		
47480	3936	19006318	1959-01-16	1959-01-16 00:00:00	1959-01-30	1959-01-30 00:00:00	1959-01-30	38000177		0	0	14		0	0	0	261610	0	105078	19006318		
47512	3939	1118084	2011-12-02	2011-12-02 00:00:00	2011-12-02	2011-12-02 00:00:00	\N	38000177		0	0	0		0	0	0	261849	0	00025152531	44923712		
9115	758	19129655	1977-03-29	1977-03-29 00:00:00	1977-04-12	1977-04-12 00:00:00	1977-04-12	38000177		0	0	14		0	0	0	50302	0	789980	19129655		
197011	4329	40213306	2001-01-28	2001-01-28 00:00:00	2001-01-28	2001-01-28 00:00:00	2001-01-28	581452		0	0	0		0	0	0	287099	0	43	40213306		
19671	1618	1539411	1999-03-03	1999-03-03 00:00:00	1999-03-03	1999-03-03 00:00:00	\N	38000177		0	0	0		0	0	0	108805	0	312961	1539411		
231940	5097	40213227	2019-02-18	2019-02-18 00:00:00	2019-02-18	2019-02-18 00:00:00	2019-02-18	581452		0	0	0		0	0	0	338729	0	113	40213227		
2378	190	19077572	2010-01-26	2010-01-26 00:00:00	2010-01-26	2010-01-26 00:00:00	\N	38000177		0	0	0		0	0	0	12931	0	310436	19077572		
7947	664	19073183	1983-11-26	1983-11-26 00:00:00	1983-12-10	1983-12-10 00:00:00	1983-12-10	38000177		0	0	14		0	0	0	43860	0	308182	19073183		
4736	395	1713671	1993-08-27	1993-08-27 00:00:00	1993-09-10	1993-09-10 00:00:00	1993-09-10	38000177		0	0	14		0	0	0	25989	0	562251	1713671		
51377	4270	46233988	1978-03-15	1978-03-15 00:00:00	1978-03-29	1978-03-29 00:00:00	1978-03-29	38000177		0	0	14		0	0	0	283441	0	1652673	46233988		
185251	4071	40213160	1955-03-10	1955-03-10 00:00:00	1955-03-10	1955-03-10 00:00:00	1955-03-10	581452		0	0	0		0	0	0	270594	0	10	40213160		
3321	273	1551192	1981-04-15	1981-04-15 00:00:00	1981-04-15	1981-04-15 00:00:00	1981-04-15	38000177		0	0	0		0	0	0	18286	0	312617	1551192		
115169	2530	40213227	1997-08-24	1997-08-24 00:00:00	1997-08-24	1997-08-24 00:00:00	1997-08-24	581452		0	0	0		0	0	0	167266	0	113	40213227		
23645	1946	40171902	2014-01-04	2014-01-04 00:00:00	2014-01-04	2014-01-04 00:00:00	\N	38000177		0	0	0		0	0	0	129354	0	897718	40171902		
135965	2985	40213306	1985-12-14	1985-12-14 00:00:00	1985-12-14	1985-12-14 00:00:00	1985-12-14	581452		0	0	0		0	0	0	199246	0	43	40213306		
34205	2827	920300	1968-06-27	1968-06-27 00:00:00	1968-07-04	1968-07-04 00:00:00	1968-07-04	38000177		0	0	7		0	0	0	187508	0	311989	920300		
57217	4749	1713671	1979-11-23	1979-11-23 00:00:00	1979-12-14	1979-12-14 00:00:00	1979-12-14	38000177		0	0	21		0	0	0	316238	0	562251	1713671		
51935	4319	19078461	2014-05-28	2014-05-28 00:00:00	2014-07-27	2014-07-27 00:00:00	2014-07-27	38000177		0	0	60		0	0	0	286586	0	310965	19078461		
177010	3890	40213160	1957-07-02	1957-07-02 00:00:00	1957-07-02	1957-07-02 00:00:00	1957-07-02	581452		0	0	0		0	0	0	258617	0	10	40213160		
62500	5199	19078461	1975-01-20	1975-01-20 00:00:00	1975-02-17	1975-02-17 00:00:00	1975-02-17	38000177		0	0	28		0	0	0	345721	0	310965	19078461		
193486	4250	40213227	1996-11-30	1996-11-30 00:00:00	1996-11-30	1996-11-30 00:00:00	1996-11-30	581452		0	0	0		0	0	0	282236	0	113	40213227		
42050	3486	40229134	1994-04-01	1994-04-01 00:00:00	1994-04-08	1994-04-08 00:00:00	1994-04-08	38000177		0	0	7		0	0	0	231191	0	1043400	40229134		
39501	3263	1310034	2007-09-11	2007-09-11 00:00:00	2007-09-11	2007-09-11 00:00:00	2007-09-11	38000177		0	0	0		0	0	0	216903	0	834357	1310034		
19061	1574	1127433	1986-10-04	1986-10-04 00:00:00	1986-11-08	1986-11-08 00:00:00	1986-11-08	38000177		0	0	35		0	0	0	105708	0	313782	1127433		
30854	2554	1332419	1999-12-02	1999-12-02 00:00:00	1999-12-02	1999-12-02 00:00:00	\N	38000177		0	0	0		0	0	0	169105	0	197361	1332419		
56730	4705	1127433	1983-01-09	1983-01-09 00:00:00	1983-01-23	1983-01-23 00:00:00	1983-01-23	38000177		0	0	14		0	0	0	313490	0	313782	1127433		
107108	2347	40213227	2002-02-25	2002-02-25 00:00:00	2002-02-25	2002-02-25 00:00:00	2002-02-25	581452		0	0	0		0	0	0	156246	0	113	40213227		
45857	3796	19078461	2018-12-26	2018-12-26 00:00:00	2019-01-16	2019-01-16 00:00:00	2019-01-16	38000177		0	0	21		0	0	0	252361	0	310965	19078461		
12027	1004	1127433	1970-12-30	1970-12-30 00:00:00	1971-01-06	1971-01-06 00:00:00	1971-01-06	38000177		0	0	7		0	0	0	66358	0	313782	1127433		
166066	3650	40213201	1993-05-07	1993-05-07 00:00:00	1993-05-07	1993-05-07 00:00:00	1993-05-07	581452		0	0	0		0	0	0	242917	0	33	40213201		
44549	3689	19133905	1988-10-19	1988-10-19 00:00:00	1988-10-26	1988-10-26 00:00:00	1988-10-26	38000177		0	0	7		0	0	0	245219	0	834102	19133905		
103077	2261	40213296	2005-11-15	2005-11-15 00:00:00	2005-11-15	2005-11-15 00:00:00	2005-11-15	581452		0	0	0		0	0	0	150326	0	52	40213296		
8834	189	40213296	1998-05-17	1998-05-17 00:00:00	1998-05-17	1998-05-17 00:00:00	1998-05-17	581452		0	0	0		0	0	0	12871	0	52	40213296		
55157	4579	40229134	1976-11-12	1976-11-12 00:00:00	1976-11-19	1976-11-19 00:00:00	1976-11-19	38000177		0	0	7		0	0	0	305072	0	1043400	40229134		
49224	4085	19006318	1961-11-02	1961-11-02 00:00:00	1961-11-16	1961-11-16 00:00:00	1961-11-16	38000177		0	0	14		0	0	0	271457	0	105078	19006318		
33380	2765	1127433	1960-02-24	1960-02-24 00:00:00	1960-03-23	1960-03-23 00:00:00	1960-03-23	38000177		0	0	28		0	0	0	182890	0	313782	1127433		
224731	4933	40213160	1970-11-12	1970-11-12 00:00:00	1970-11-12	1970-11-12 00:00:00	1970-11-12	581452		0	0	0		0	0	0	327956	0	10	40213160		
5473	457	19078461	1996-09-07	1996-09-07 00:00:00	1996-10-12	1996-10-12 00:00:00	1996-10-12	38000177		0	0	35		0	0	0	30592	0	310965	19078461		
10968	915	1713671	1964-08-10	1964-08-10 00:00:00	1964-08-24	1964-08-24 00:00:00	1964-08-24	38000177		0	0	14		0	0	0	60834	0	562251	1713671		
16024	1328	1127433	2008-02-17	2008-02-17 00:00:00	2008-02-24	2008-02-24 00:00:00	2008-02-24	38000177		0	0	7		0	0	0	88223	0	313782	1127433		
26505	2180	1124300	2017-08-06	2017-08-06 00:00:00	2017-08-06	2017-08-06 00:00:00	\N	38000177		0	0	0		0	0	0	145436	0	00781178901	45011828		
223971	4916	40213314	1978-10-06	1978-10-06 00:00:00	1978-10-06	1978-10-06 00:00:00	1978-10-06	581452		0	0	0		0	0	0	326694	0	49	40213314		
8579	715	1127433	2002-09-03	2002-09-03 00:00:00	2002-09-17	2002-09-17 00:00:00	2002-09-17	38000177		0	0	14		0	0	0	47301	0	313782	1127433		
63321	1385	40213227	1994-07-29	1994-07-29 00:00:00	1994-07-29	1994-07-29 00:00:00	1994-07-29	581452		0	0	0		0	0	0	91858	0	113	40213227		
54598	4534	1539411	2005-03-02	2005-03-02 00:00:00	2005-03-02	2005-03-02 00:00:00	\N	38000177		0	0	0		0	0	0	302032	0	312961	1539411		
19149	1579	1127433	2000-11-30	2000-11-30 00:00:00	2000-12-07	2000-12-07 00:00:00	2000-12-07	38000177		0	0	7		0	0	0	106092	0	313782	1127433		
22057	1813	1127433	2016-03-18	2016-03-18 00:00:00	2016-04-17	2016-04-17 00:00:00	2016-04-17	38000177		0	0	30		0	0	0	121310	0	313782	1127433		
141732	3114	40213227	1997-09-24	1997-09-24 00:00:00	1997-09-24	1997-09-24 00:00:00	1997-09-24	581452		0	0	0		0	0	0	207170	0	113	40213227		
37342	3084	19128022	1991-11-20	1991-11-20 00:00:00	1992-11-14	1992-11-14 00:00:00	1992-11-14	38000177		0	0	360		0	0	0	205369	0	749785	19128022		
58297	4844	1127433	1993-10-19	1993-10-19 00:00:00	1993-10-26	1993-10-26 00:00:00	1993-10-26	38000177		0	0	7		0	0	0	322266	0	313782	1127433		
106197	2329	40213296	2011-01-18	2011-01-18 00:00:00	2011-01-18	2011-01-18 00:00:00	2011-01-18	581452		0	0	0		0	0	0	154944	0	52	40213296		
41060	3407	40236824	1985-02-22	1985-02-22 00:00:00	1985-03-01	1985-03-01 00:00:00	1985-03-01	38000177		0	0	7		0	0	0	225960	0	1094107	40236824		
179927	3955	40213227	2007-02-10	2007-02-10 00:00:00	2007-02-10	2007-02-10 00:00:00	2007-02-10	581452		0	0	0		0	0	0	262881	0	113	40213227		
4324	358	19133905	2009-03-23	2009-03-23 00:00:00	2009-04-03	2009-04-03 00:00:00	2009-04-03	38000177		0	0	11		0	0	0	23854	0	834102	19133905		
53520	4450	19133873	1982-06-28	1982-06-28 00:00:00	1982-07-09	1982-07-09 00:00:00	1982-07-09	38000177		0	0	11		0	0	0	296092	0	834061	19133873		
51709	4297	19016749	1991-02-19	1991-02-19 00:00:00	1991-02-19	1991-02-19 00:00:00	1991-02-19	38000177		0	0	0		0	0	0	285178	0	73032	19016749		
53615	4456	19133905	1999-11-03	1999-11-03 00:00:00	1999-11-11	1999-11-11 00:00:00	1999-11-11	38000177		0	0	8		0	0	0	296576	0	834102	19133905		
9805	821	19059056	1951-08-26	1951-08-26 00:00:00	1951-09-09	1951-09-09 00:00:00	1951-09-09	38000177		0	0	14		0	0	0	54402	0	243670	19059056		
64186	5328	19059056	1921-07-26	1921-07-26 00:00:00	1921-08-30	1921-08-30 00:00:00	1921-08-30	38000177		0	0	35		0	0	0	354587	0	243670	19059056		
242749	5329	40213201	2009-09-02	2009-09-02 00:00:00	2009-09-02	2009-09-02 00:00:00	2009-09-02	581452		0	0	0		0	0	0	354775	0	33	40213201		
50201	1100	40213251	1987-09-09	1987-09-09 00:00:00	1987-09-09	1987-09-09 00:00:00	1987-09-09	581452		0	0	0		0	0	0	72298	0	21	40213251		
19449	1604	1127433	1977-04-01	1977-04-01 00:00:00	1977-05-06	1977-05-06 00:00:00	1977-05-06	38000177		0	0	35		0	0	0	107606	0	313782	1127433		
105190	2307	40213227	1992-12-15	1992-12-15 00:00:00	1992-12-15	1992-12-15 00:00:00	1992-12-15	581452		0	0	0		0	0	0	153517	0	113	40213227		
131934	2899	40213160	1955-08-11	1955-08-11 00:00:00	1955-08-11	1955-08-11 00:00:00	1955-08-11	581452		0	0	0		0	0	0	193123	0	10	40213160		
47481	3936	19059056	1960-02-28	1960-02-28 00:00:00	1960-03-13	1960-03-13 00:00:00	1960-03-13	38000177		0	0	14		0	0	0	261630	0	243670	19059056		
47513	3939	1713671	1979-07-21	1979-07-21 00:00:00	1979-08-04	1979-08-04 00:00:00	1979-08-04	38000177		0	0	14		0	0	0	261811	0	562251	1713671		
9116	758	19019979	1977-03-29	1977-03-29 00:00:00	1977-04-12	1977-04-12 00:00:00	1977-04-12	38000177		0	0	14		0	0	0	50302	0	198405	19019979		
197017	4329	40213160	1978-12-10	1978-12-10 00:00:00	1978-12-10	1978-12-10 00:00:00	1978-12-10	581452		0	0	0		0	0	0	287139	0	10	40213160		
19672	1618	1118084	2013-05-21	2013-05-21 00:00:00	2013-05-21	2013-05-21 00:00:00	\N	38000177		0	0	0		0	0	0	108811	0	00025152531	44923712		
231941	5097	40213260	2019-02-18	2019-02-18 00:00:00	2019-02-18	2019-02-18 00:00:00	2019-02-18	581452		0	0	0		0	0	0	338729	0	121	40213260		
2379	190	19078461	2011-01-07	2011-01-07 00:00:00	2011-01-21	2011-01-21 00:00:00	2011-01-21	38000177		0	0	14		0	0	0	13000	0	310965	19078461		
7948	664	1127078	1983-11-26	1983-11-26 00:00:00	1983-12-10	1983-12-10 00:00:00	1983-12-10	38000177		0	0	14		0	0	0	43860	0	282464	1127078		
27161	592	40213227	2012-09-28	2012-09-28 00:00:00	2012-09-28	2012-09-28 00:00:00	2012-09-28	581452		0	0	0		0	0	0	39142	0	113	40213227		
51378	4270	1118084	2005-06-26	2005-06-26 00:00:00	2005-06-26	2005-06-26 00:00:00	\N	38000177		0	0	0		0	0	0	283401	0	00025152531	44923712		
57580	4781	1127433	2007-05-17	2007-05-17 00:00:00	2007-08-15	2007-08-15 00:00:00	2007-08-15	38000177		0	0	90		0	0	0	318276	0	313782	1127433		
3322	273	40232448	1976-09-25	1976-09-25 00:00:00	1976-09-25	1976-09-25 00:00:00	\N	38000177		0	0	0		0	0	0	18193	0	1049630	40232448		
144392	3174	40213160	1985-11-22	1985-11-22 00:00:00	1985-11-22	1985-11-22 00:00:00	1985-11-22	581452		0	0	0		0	0	0	210965	0	10	40213160		
23646	1946	19059056	1935-02-07	1935-02-07 00:00:00	1935-02-28	1935-02-28 00:00:00	1935-02-28	38000177		0	0	21		0	0	0	129275	0	243670	19059056		
135968	2985	40213260	2013-10-19	2013-10-19 00:00:00	2013-10-19	2013-10-19 00:00:00	2013-10-19	581452		0	0	0		0	0	0	199225	0	121	40213260		
34206	2827	40236824	1968-06-27	1968-06-27 00:00:00	1968-07-11	1968-07-11 00:00:00	1968-07-11	38000177		0	0	14		0	0	0	187508	0	1094107	40236824		
57218	4749	1127433	2007-03-29	2007-03-29 00:00:00	2007-04-26	2007-04-26 00:00:00	2007-04-26	38000177		0	0	28		0	0	0	316224	0	313782	1127433		
51936	4319	19073183	1982-12-11	1982-12-11 00:00:00	1982-12-25	1982-12-25 00:00:00	1982-12-25	38000177		0	0	14		0	0	0	286615	0	308182	19073183		
135090	2965	40213296	2013-09-09	2013-09-09 00:00:00	2013-09-09	2013-09-09 00:00:00	2013-09-09	581452		0	0	0		0	0	0	197934	0	52	40213296		
62501	5199	19128065	1976-01-13	1976-01-13 00:00:00	1977-01-07	1977-01-07 00:00:00	1977-01-07	38000177		0	0	360		0	0	0	345783	0	749882	19128065		
193494	4250	40213227	2007-01-27	2007-01-27 00:00:00	2007-01-27	2007-01-27 00:00:00	2007-01-27	581452		0	0	0		0	0	0	282321	0	113	40213227		
42051	3486	19128065	1979-11-20	1979-11-20 00:00:00	1980-11-14	1980-11-14 00:00:00	1980-11-14	38000177		0	0	360		0	0	0	231294	0	749882	19128065		
39502	3263	40243436	2007-09-11	2007-09-11 00:00:00	2007-09-11	2007-09-11 00:00:00	2007-09-11	38000177		0	0	0		0	0	0	216903	0	1190795	40243436		
19062	1574	40229134	2017-09-26	2017-09-26 00:00:00	2017-10-10	2017-10-10 00:00:00	2017-10-10	38000177		0	0	14		0	0	0	105648	0	1043400	40229134		
30855	2554	19059056	1940-07-07	1940-07-07 00:00:00	1940-07-21	1940-07-21 00:00:00	1940-07-21	38000177		0	0	14		0	0	0	169225	0	243670	19059056		
56743	4707	1127433	2018-07-12	2018-07-12 00:00:00	2018-09-10	2018-09-10 00:00:00	2018-09-10	38000177		0	0	60		0	0	0	313555	0	313782	1127433		
107115	2347	40213260	2019-03-11	2019-03-11 00:00:00	2019-03-11	2019-03-11 00:00:00	2019-03-11	581452		0	0	0		0	0	0	156249	0	121	40213260		
45858	3796	1115171	2003-08-26	2003-08-26 00:00:00	2003-11-24	2003-11-24 00:00:00	2003-11-24	38000177		0	0	90		0	0	0	252358	0	849574	1115171		
12028	1004	1118084	2001-01-19	2001-01-19 00:00:00	2001-01-19	2001-01-19 00:00:00	\N	38000177		0	0	0		0	0	0	66396	0	00025152531	44923712		
166082	3650	40213227	2018-03-23	2018-03-23 00:00:00	2018-03-23	2018-03-23 00:00:00	2018-03-23	581452		0	0	0		0	0	0	242927	0	113	40213227		
44550	3689	1127433	1963-07-23	1963-07-23 00:00:00	1963-08-06	1963-08-06 00:00:00	1963-08-06	38000177		0	0	14		0	0	0	245228	0	313782	1127433		
103079	2261	40213227	2005-11-15	2005-11-15 00:00:00	2005-11-15	2005-11-15 00:00:00	2005-11-15	581452		0	0	0		0	0	0	150326	0	113	40213227		
84762	1854	40213160	1971-04-13	1971-04-13 00:00:00	1971-04-13	1971-04-13 00:00:00	1971-04-13	581452		0	0	0		0	0	0	124096	0	10	40213160		
55158	4579	1115171	2009-01-04	2009-01-04 00:00:00	2009-02-08	2009-02-08 00:00:00	2009-02-08	38000177		0	0	35		0	0	0	305006	0	849574	1115171		
49225	4085	40229134	2006-08-25	2006-08-25 00:00:00	2006-09-01	2006-09-01 00:00:00	2006-09-01	38000177		0	0	7		0	0	0	271454	0	1043400	40229134		
33593	2780	1127078	1956-02-17	1956-02-17 00:00:00	1956-03-02	1956-03-02 00:00:00	1956-03-02	38000177		0	0	14		0	0	0	184228	0	282464	1127078		
224734	4933	40213160	1970-06-11	1970-06-11 00:00:00	1970-06-11	1970-06-11 00:00:00	1970-06-11	581452		0	0	0		0	0	0	327955	0	10	40213160		
5474	457	19078461	1989-03-27	1989-03-27 00:00:00	1989-04-17	1989-04-17 00:00:00	1989-04-17	38000177		0	0	21		0	0	0	30591	0	310965	19078461		
10969	915	19059056	1965-05-28	1965-05-28 00:00:00	1965-06-11	1965-06-11 00:00:00	1965-06-11	38000177		0	0	14		0	0	0	60843	0	243670	19059056		
16025	1328	19078461	1995-02-21	1995-02-21 00:00:00	1995-03-07	1995-03-07 00:00:00	1995-03-07	38000177		0	0	14		0	0	0	88158	0	310965	19078461		
26506	2180	1127433	1985-02-26	1985-02-26 00:00:00	1985-03-12	1985-03-12 00:00:00	1985-03-12	38000177		0	0	14		0	0	0	145394	0	313782	1127433		
26456	576	40213227	2008-08-20	2008-08-20 00:00:00	2008-08-20	2008-08-20 00:00:00	2008-08-20	581452		0	0	0		0	0	0	38081	0	113	40213227		
8580	715	1713671	2000-11-10	2000-11-10 00:00:00	2000-11-17	2000-11-17 00:00:00	2000-11-17	38000177		0	0	7		0	0	0	47324	0	562251	1713671		
63323	1385	40213160	1961-01-20	1961-01-20 00:00:00	1961-01-20	1961-01-20 00:00:00	1961-01-20	581452		0	0	0		0	0	0	91846	0	10	40213160		
54599	4534	40165015	1996-05-21	1996-05-21 00:00:00	1996-05-21	1996-05-21 00:00:00	\N	38000177		0	0	0		0	0	0	302077	0	861467	40165015		
19150	1579	1713671	2008-05-05	2008-05-05 00:00:00	2008-05-12	2008-05-12 00:00:00	2008-05-12	38000177		0	0	7		0	0	0	106055	0	562251	1713671		
22058	1813	19133905	2002-06-04	2002-06-04 00:00:00	2002-06-16	2002-06-16 00:00:00	2002-06-16	38000177		0	0	12		0	0	0	121350	0	834102	19133905		
141748	3114	40213198	2011-12-14	2011-12-14 00:00:00	2011-12-14	2011-12-14 00:00:00	2011-12-14	581452		0	0	0		0	0	0	207178	0	133	40213198		
37343	3084	1127433	1982-03-03	1982-03-03 00:00:00	1982-03-17	1982-03-17 00:00:00	1982-03-17	38000177		0	0	14		0	0	0	205366	0	313782	1127433		
58298	4844	1551192	1959-09-24	1959-09-24 00:00:00	1959-09-24	1959-09-24 00:00:00	1959-09-24	38000177		0	0	0		0	0	0	322277	0	312617	1551192		
106202	2329	40213160	1971-09-21	1971-09-21 00:00:00	1971-09-21	1971-09-21 00:00:00	1971-09-21	581452		0	0	0		0	0	0	154934	0	10	40213160		
41061	3407	920300	1985-02-22	1985-02-22 00:00:00	1985-03-01	1985-03-01 00:00:00	1985-03-01	38000177		0	0	7		0	0	0	225960	0	311989	920300		
179936	3955	40213160	1956-05-12	1956-05-12 00:00:00	1956-05-12	1956-05-12 00:00:00	1956-05-12	581452		0	0	0		0	0	0	262831	0	10	40213160		
4325	358	19075601	2012-07-31	2012-07-31 00:00:00	2012-07-31	2012-07-31 00:00:00	2012-07-31	38000177		0	0	0		0	0	0	23860	0	309362	19075601		
53521	4450	1713671	1973-11-23	1973-11-23 00:00:00	1973-12-07	1973-12-07 00:00:00	1973-12-07	38000177		0	0	14		0	0	0	296067	0	562251	1713671		
51710	4297	42707627	1991-02-19	1991-02-19 00:00:00	1991-02-19	1991-02-19 00:00:00	1991-02-19	38000177		0	0	0		0	0	0	285178	0	1234995	42707627		
53616	4456	1124300	1998-03-07	1998-03-07 00:00:00	1998-03-07	1998-03-07 00:00:00	\N	38000177		0	0	0		0	0	0	296603	0	00781178901	45011828		
9806	821	19006318	1951-08-26	1951-08-26 00:00:00	1951-09-09	1951-09-09 00:00:00	1951-09-09	38000177		0	0	14		0	0	0	54402	0	105078	19006318		
64187	5329	1115171	2001-09-01	2001-09-01 00:00:00	2001-09-15	2001-09-15 00:00:00	2001-09-15	38000177		0	0	14		0	0	0	354834	0	849574	1115171		
242752	5329	40213227	2014-06-04	2014-06-04 00:00:00	2014-06-04	2014-06-04 00:00:00	2014-06-04	581452		0	0	0		0	0	0	354739	0	113	40213227		
50205	1100	40213251	1984-03-07	1984-03-07 00:00:00	1984-03-07	1984-03-07 00:00:00	1984-03-07	581452		0	0	0		0	0	0	72282	0	21	40213251		
19450	1604	1127078	1955-06-21	1955-06-21 00:00:00	1955-07-05	1955-07-05 00:00:00	1955-07-05	38000177		0	0	14		0	0	0	107610	0	282464	1127078		
105197	2307	40213160	1962-06-12	1962-06-12 00:00:00	1962-06-12	1962-06-12 00:00:00	1962-06-12	581452		0	0	0		0	0	0	153547	0	10	40213160		
105246	2309	40213227	2005-04-01	2005-04-01 00:00:00	2005-04-01	2005-04-01 00:00:00	2005-04-01	581452		0	0	0		0	0	0	153644	0	113	40213227		
47482	3936	1713671	2010-09-27	2010-09-27 00:00:00	2010-10-11	2010-10-11 00:00:00	2010-10-11	38000177		0	0	14		0	0	0	261622	0	562251	1713671		
47514	3939	46233988	1976-05-09	1976-05-09 00:00:00	1976-05-23	1976-05-23 00:00:00	1976-05-23	38000177		0	0	14		0	0	0	261868	0	1652673	46233988		
9117	758	1127433	2000-07-12	2000-07-12 00:00:00	2000-07-19	2000-07-19 00:00:00	2000-07-19	38000177		0	0	7		0	0	0	50314	0	313782	1127433		
197031	4330	40213198	2011-03-19	2011-03-19 00:00:00	2011-03-19	2011-03-19 00:00:00	2011-03-19	581452		0	0	0		0	0	0	287281	0	133	40213198		
19673	1618	19075601	2008-03-12	2008-03-12 00:00:00	2008-03-12	2008-03-12 00:00:00	\N	38000177		0	0	0		0	0	0	108808	0	309362	19075601		
231942	5097	40213160	1972-06-05	1972-06-05 00:00:00	1972-06-05	1972-06-05 00:00:00	1972-06-05	581452		0	0	0		0	0	0	338641	0	10	40213160		
2380	190	1115171	1997-09-19	1997-09-19 00:00:00	1997-10-17	1997-10-17 00:00:00	1997-10-17	38000177		0	0	28		0	0	0	12999	0	849574	1115171		
7949	664	1713671	2011-11-18	2011-11-18 00:00:00	2011-12-09	2011-12-09 00:00:00	2011-12-09	38000177		0	0	21		0	0	0	43905	0	562251	1713671		
27162	592	40213296	2012-09-28	2012-09-28 00:00:00	2012-09-28	2012-09-28 00:00:00	2012-09-28	581452		0	0	0		0	0	0	39142	0	52	40213296		
51379	4270	1127433	1980-12-06	1980-12-06 00:00:00	1980-12-13	1980-12-13 00:00:00	1980-12-13	38000177		0	0	7		0	0	0	283448	0	313782	1127433		
57581	4781	19133873	1987-03-09	1987-03-09 00:00:00	1987-03-20	1987-03-20 00:00:00	1987-03-20	38000177		0	0	11		0	0	0	318291	0	834061	19133873		
60281	5013	19059056	1966-07-12	1966-07-12 00:00:00	1966-08-02	1966-08-02 00:00:00	1966-08-02	38000177		0	0	21		0	0	0	333198	0	243670	19059056		
144396	3174	40213314	1981-05-22	1981-05-22 00:00:00	1981-05-22	1981-05-22 00:00:00	1981-05-22	581452		0	0	0		0	0	0	210961	0	49	40213314		
23647	1946	19133905	1977-09-20	1977-09-20 00:00:00	1977-10-01	1977-10-01 00:00:00	1977-10-01	38000177		0	0	11		0	0	0	129279	0	834102	19133905		
175506	3859	40213227	2004-09-18	2004-09-18 00:00:00	2004-09-18	2004-09-18 00:00:00	2004-09-18	581452		0	0	0		0	0	0	256240	0	113	40213227		
34207	2827	40163554	2000-12-26	2000-12-26 00:00:00	2000-12-26	2000-12-26 00:00:00	\N	38000177		0	0	0		0	0	0	187456	0	855332	40163554		
57219	4750	19006318	1964-04-04	1964-04-04 00:00:00	1964-04-18	1964-04-18 00:00:00	1964-04-18	38000177		0	0	14		0	0	0	316403	0	105078	19006318		
51937	4319	1127078	1982-12-11	1982-12-11 00:00:00	1982-12-25	1982-12-25 00:00:00	1982-12-25	38000177		0	0	14		0	0	0	286615	0	282464	1127078		
135093	2965	40213160	1970-08-03	1970-08-03 00:00:00	1970-08-03	1970-08-03 00:00:00	1970-08-03	581452		0	0	0		0	0	0	198021	0	10	40213160		
62503	5199	19074679	1978-10-24	1978-10-24 00:00:00	1979-01-30	1979-01-30 00:00:00	1979-01-30	38000177		0	0	98		0	0	0	345726	0	308971	19074679		
39376	3253	19128065	1992-04-03	1992-04-03 00:00:00	1993-03-29	1993-03-29 00:00:00	1993-03-29	38000177		0	0	360		0	0	0	216299	0	749882	19128065		
42052	3486	19128065	1980-11-14	1980-11-14 00:00:00	1981-11-09	1981-11-09 00:00:00	1981-11-09	38000177		0	0	360		0	0	0	231213	0	749882	19128065		
39503	3263	40229134	2011-02-15	2011-02-15 00:00:00	2011-02-22	2011-02-22 00:00:00	2011-02-22	38000177		0	0	7		0	0	0	216943	0	1043400	40229134		
19063	1574	19059056	1972-05-22	1972-05-22 00:00:00	1972-06-19	1972-06-19 00:00:00	1972-06-19	38000177		0	0	28		0	0	0	105705	0	243670	19059056		
30856	2555	1127078	1955-09-04	1955-09-04 00:00:00	1955-09-18	1955-09-18 00:00:00	1955-09-18	38000177		0	0	14		0	0	0	169347	0	282464	1127078		
56744	4707	40165015	2018-07-12	2018-07-12 00:00:00	2018-07-12	2018-07-12 00:00:00	\N	38000177		0	0	0		0	0	0	313555	0	861467	40165015		
107118	2347	40213160	1969-08-11	1969-08-11 00:00:00	1969-08-11	1969-08-11 00:00:00	1969-08-11	581452		0	0	0		0	0	0	156229	0	10	40213160		
45859	3796	19126352	2018-11-20	2018-11-20 00:00:00	2018-11-20	2018-11-20 00:00:00	\N	38000177		0	0	0		0	0	0	252366	0	705129	19126352		
12029	1004	1127433	1997-05-27	1997-05-27 00:00:00	1997-06-10	1997-06-10 00:00:00	1997-06-10	38000177		0	0	14		0	0	0	66377	0	313782	1127433		
166084	3651	40213160	1960-05-05	1960-05-05 00:00:00	1960-05-05	1960-05-05 00:00:00	1960-05-05	581452		0	0	0		0	0	0	243056	0	10	40213160		
44552	3689	1118084	1987-05-11	1987-05-11 00:00:00	1987-05-11	1987-05-11 00:00:00	\N	38000177		0	0	0		0	0	0	245193	0	00025152531	44923712		
232306	5104	40213160	1980-05-11	1980-05-11 00:00:00	1980-05-11	1980-05-11 00:00:00	1980-05-11	581452		0	0	0		0	0	0	339145	0	10	40213160		
521	11	40213160	1957-11-05	1957-11-05 00:00:00	1957-11-05	1957-11-05 00:00:00	1957-11-05	581452		0	0	0		0	0	0	917	0	10	40213160		
55159	4579	40229134	1982-07-18	1982-07-18 00:00:00	1982-08-01	1982-08-01 00:00:00	1982-08-01	38000177		0	0	14		0	0	0	305008	0	1043400	40229134		
49226	4085	19059056	1959-09-29	1959-09-29 00:00:00	1959-10-13	1959-10-13 00:00:00	1959-10-13	38000177		0	0	14		0	0	0	271543	0	243670	19059056		
33594	2780	19133873	1958-12-30	1958-12-30 00:00:00	1959-01-11	1959-01-11 00:00:00	1959-01-11	38000177		0	0	12		0	0	0	184219	0	834061	19133873		
17473	1446	42902245	2002-10-02	2002-10-02 00:00:00	2003-09-27	2003-09-27 00:00:00	2003-09-27	38000177		0	0	360		0	0	0	96380	0	1359133	42902245		
5475	457	1118084	1986-03-28	1986-03-28 00:00:00	1986-03-28	1986-03-28 00:00:00	\N	38000177		0	0	0		0	0	0	30582	0	00025152531	44923712		
10970	915	19129655	1965-05-28	1965-05-28 00:00:00	1965-06-11	1965-06-11 00:00:00	1965-06-11	38000177		0	0	14		0	0	0	60843	0	789980	19129655		
16026	1328	40236824	1999-08-07	1999-08-07 00:00:00	1999-08-14	1999-08-14 00:00:00	1999-08-14	38000177		0	0	7		0	0	0	88189	0	1094107	40236824		
26507	2180	1127433	2010-12-25	2010-12-25 00:00:00	2011-01-15	2011-01-15 00:00:00	2011-01-15	38000177		0	0	21		0	0	0	145420	0	313782	1127433		
26457	576	40213296	2008-08-20	2008-08-20 00:00:00	2008-08-20	2008-08-20 00:00:00	2008-08-20	581452		0	0	0		0	0	0	38081	0	52	40213296		
8581	715	1127433	2008-06-17	2008-06-17 00:00:00	2008-07-01	2008-07-01 00:00:00	2008-07-01	38000177		0	0	14		0	0	0	47302	0	313782	1127433		
63326	1385	40213160	1960-10-21	1960-10-21 00:00:00	1960-10-21	1960-10-21 00:00:00	1960-10-21	581452		0	0	0		0	0	0	91792	0	10	40213160		
54600	4534	1127433	1996-05-21	1996-05-21 00:00:00	1996-07-20	1996-07-20 00:00:00	1996-07-20	38000177		0	0	60		0	0	0	302077	0	313782	1127433		
19171	1585	1713671	2015-05-14	2015-05-14 00:00:00	2015-06-04	2015-06-04 00:00:00	2015-06-04	38000177		0	0	21		0	0	0	106276	0	562251	1713671		
22059	1813	1118084	2016-10-29	2016-10-29 00:00:00	2016-10-29	2016-10-29 00:00:00	\N	38000177		0	0	0		0	0	0	121314	0	00025152531	44923712		
141754	3114	40213227	2007-11-21	2007-11-21 00:00:00	2007-11-21	2007-11-21 00:00:00	2007-11-21	581452		0	0	0		0	0	0	207165	0	113	40213227		
37348	3086	1127433	1987-01-30	1987-01-30 00:00:00	1987-02-06	1987-02-06 00:00:00	1987-02-06	38000177		0	0	7		0	0	0	205468	0	313782	1127433		
58299	4844	1551192	1973-10-17	1973-10-17 00:00:00	1973-10-17	1973-10-17 00:00:00	1973-10-17	38000177		0	0	0		0	0	0	322280	0	312617	1551192		
106205	2329	40213306	1993-03-16	1993-03-16 00:00:00	1993-03-16	1993-03-16 00:00:00	1993-03-16	581452		0	0	0		0	0	0	154909	0	43	40213306		
41062	3407	1127433	2006-05-30	2006-05-30 00:00:00	2006-06-20	2006-06-20 00:00:00	2006-06-20	38000177		0	0	21		0	0	0	225978	0	313782	1127433		
63632	1391	40213227	1995-02-07	1995-02-07 00:00:00	1995-02-07	1995-02-07 00:00:00	1995-02-07	581452		0	0	0		0	0	0	\N	0	113	40213227		
4326	358	40220960	2012-07-31	2012-07-31 00:00:00	2012-07-31	2012-07-31 00:00:00	2012-07-31	38000177		0	0	0		0	0	0	23860	0	1804799	40220960		
53522	4450	1127433	2000-08-28	2000-08-28 00:00:00	2000-09-04	2000-09-04 00:00:00	2000-09-04	38000177		0	0	7		0	0	0	296070	0	313782	1127433		
51711	4297	46275444	1991-02-19	1991-02-19 00:00:00	1991-02-19	1991-02-19 00:00:00	1991-02-19	38000177		0	0	0		0	0	0	285178	0	1659149	46275444		
53617	4456	1127433	2003-04-30	2003-04-30 00:00:00	2003-05-14	2003-05-14 00:00:00	2003-05-14	38000177		0	0	14		0	0	0	296566	0	313782	1127433		
9807	821	1713671	1966-10-10	1966-10-10 00:00:00	1966-10-24	1966-10-24 00:00:00	1966-10-24	38000177		0	0	14		0	0	0	54427	0	562251	1713671		
64188	5329	40236824	1996-02-09	1996-02-09 00:00:00	1996-02-16	1996-02-16 00:00:00	1996-02-16	38000177		0	0	7		0	0	0	354759	0	1094107	40236824		
137558	3019	40213296	2017-05-10	2017-05-10 00:00:00	2017-05-10	2017-05-10 00:00:00	2017-05-10	581452		0	0	0		0	0	0	201362	0	52	40213296		
50211	1100	40213160	1983-06-08	1983-06-08 00:00:00	1983-06-08	1983-06-08 00:00:00	1983-06-08	581452		0	0	0		0	0	0	72281	0	10	40213160		
19451	1604	19006318	1955-06-21	1955-06-21 00:00:00	1955-07-05	1955-07-05 00:00:00	1955-07-05	38000177		0	0	14		0	0	0	107610	0	105078	19006318		
105199	2307	40213160	1966-09-13	1966-09-13 00:00:00	1966-09-13	1966-09-13 00:00:00	1966-09-13	581452		0	0	0		0	0	0	153539	0	10	40213160		
105248	2309	40213306	1995-06-02	1995-06-02 00:00:00	1995-06-02	1995-06-02 00:00:00	1995-06-02	581452		0	0	0		0	0	0	153675	0	43	40213306		
47483	3936	1115171	2006-11-28	2006-11-28 00:00:00	2007-01-27	2007-01-27 00:00:00	2007-01-27	38000177		0	0	60		0	0	0	261632	0	849574	1115171		
47515	3939	19019979	1976-05-09	1976-05-09 00:00:00	1976-05-23	1976-05-23 00:00:00	1976-05-23	38000177		0	0	14		0	0	0	261868	0	198405	19019979		
9118	758	1115171	2000-07-15	2000-07-15 00:00:00	2000-08-05	2000-08-05 00:00:00	2000-08-05	38000177		0	0	21		0	0	0	50357	0	849574	1115171		
197041	4330	40213227	1996-12-28	1996-12-28 00:00:00	1996-12-28	1996-12-28 00:00:00	1996-12-28	581452		0	0	0		0	0	0	287275	0	113	40213227		
19674	1618	19126352	2008-03-12	2008-03-12 00:00:00	2008-03-12	2008-03-12 00:00:00	\N	38000177		0	0	0		0	0	0	108808	0	705129	19126352		
107017	2346	40213227	1997-02-12	1997-02-12 00:00:00	1997-02-12	1997-02-12 00:00:00	1997-02-12	581452		0	0	0		0	0	0	156143	0	113	40213227		
2381	190	19059056	1936-02-07	1936-02-07 00:00:00	1936-05-07	1936-05-07 00:00:00	1936-05-07	38000177		0	0	90		0	0	0	12909	0	243670	19059056		
7950	664	19073183	1986-10-17	1986-10-17 00:00:00	1986-10-31	1986-10-31 00:00:00	1986-10-31	38000177		0	0	14		0	0	0	43901	0	308182	19073183		
27166	592	40213296	2010-09-24	2010-09-24 00:00:00	2010-09-24	2010-09-24 00:00:00	2010-09-24	581452		0	0	0		0	0	0	39126	0	52	40213296		
51380	4270	19059056	1970-07-30	1970-07-30 00:00:00	1970-08-13	1970-08-13 00:00:00	1970-08-13	38000177		0	0	14		0	0	0	283440	0	243670	19059056		
57582	4781	1115171	1997-11-07	1997-11-07 00:00:00	1997-11-21	1997-11-21 00:00:00	1997-11-21	38000177		0	0	14		0	0	0	318257	0	849574	1115171		
60282	5013	1539411	2010-09-10	2010-09-10 00:00:00	2010-09-10	2010-09-10 00:00:00	\N	38000177		0	0	0		0	0	0	333181	0	312961	1539411		
144397	3174	40213160	1981-05-22	1981-05-22 00:00:00	1981-05-22	1981-05-22 00:00:00	1981-05-22	581452		0	0	0		0	0	0	210961	0	10	40213160		
23648	1946	1127433	1953-12-19	1953-12-19 00:00:00	1953-12-26	1953-12-26 00:00:00	1953-12-26	38000177		0	0	7		0	0	0	129316	0	313782	1127433		
175521	3859	40213201	1988-09-17	1988-09-17 00:00:00	1988-09-17	1988-09-17 00:00:00	1988-09-17	581452		0	0	0		0	0	0	256169	0	33	40213201		
34208	2827	19018935	2000-12-26	2000-12-26 00:00:00	2000-12-26	2000-12-26 00:00:00	\N	38000177		0	0	0		0	0	0	187456	0	197604	19018935		
57220	4750	1127078	1964-04-04	1964-04-04 00:00:00	1964-04-18	1964-04-18 00:00:00	1964-04-18	38000177		0	0	14		0	0	0	316403	0	282464	1127078		
51938	4319	1118084	2012-07-21	2012-07-21 00:00:00	2012-07-21	2012-07-21 00:00:00	\N	38000177		0	0	0		0	0	0	286627	0	00025152531	44923712		
135103	2965	40213227	2011-09-05	2011-09-05 00:00:00	2011-09-05	2011-09-05 00:00:00	2011-09-05	581452		0	0	0		0	0	0	198000	0	113	40213227		
62504	5199	19059056	1966-08-23	1966-08-23 00:00:00	1966-09-06	1966-09-06 00:00:00	1966-09-06	38000177		0	0	14		0	0	0	345736	0	243670	19059056		
39377	3253	1713671	1974-03-06	1974-03-06 00:00:00	1974-03-20	1974-03-20 00:00:00	1974-03-20	38000177		0	0	14		0	0	0	216344	0	562251	1713671		
42054	3486	1713671	1965-09-03	1965-09-03 00:00:00	1965-09-24	1965-09-24 00:00:00	1965-09-24	38000177		0	0	21		0	0	0	231227	0	562251	1713671		
39504	3263	1127433	2018-01-18	2018-01-18 00:00:00	2018-02-17	2018-02-17 00:00:00	2018-02-17	38000177		0	0	30		0	0	0	216905	0	313782	1127433		
19064	1574	1713671	2014-01-20	2014-01-20 00:00:00	2014-01-27	2014-01-27 00:00:00	2014-01-27	38000177		0	0	7		0	0	0	105699	0	562251	1713671		
30857	2555	19006318	1955-09-04	1955-09-04 00:00:00	1955-09-18	1955-09-18 00:00:00	1955-09-18	38000177		0	0	14		0	0	0	169347	0	105078	19006318		
56745	4707	1127433	1999-07-28	1999-07-28 00:00:00	1999-08-04	1999-08-04 00:00:00	1999-08-04	38000177		0	0	7		0	0	0	313592	0	313782	1127433		
221534	4861	40213227	2017-09-19	2017-09-19 00:00:00	2017-09-19	2017-09-19 00:00:00	2017-09-19	581452		0	0	0		0	0	0	\N	0	113	40213227		
45860	3796	1332419	2018-11-20	2018-11-20 00:00:00	2018-11-20	2018-11-20 00:00:00	\N	38000177		0	0	0		0	0	0	252366	0	197361	1332419		
12031	1005	19128065	1987-01-17	1987-01-17 00:00:00	1988-01-12	1988-01-12 00:00:00	1988-01-12	38000177		0	0	360		0	0	0	66428	0	749882	19128065		
166089	3651	40213296	2000-09-28	2000-09-28 00:00:00	2000-09-28	2000-09-28 00:00:00	2000-09-28	581452		0	0	0		0	0	0	243031	0	52	40213296		
44553	3689	40229134	2014-07-10	2014-07-10 00:00:00	2014-07-17	2014-07-17 00:00:00	2014-07-17	38000177		0	0	7		0	0	0	245221	0	1043400	40229134		
232307	5104	40213314	1980-05-11	1980-05-11 00:00:00	1980-05-11	1980-05-11 00:00:00	1980-05-11	581452		0	0	0		0	0	0	339145	0	49	40213314		
527	11	40213201	2019-05-07	2019-05-07 00:00:00	2019-05-07	2019-05-07 00:00:00	2019-05-07	581452		0	0	0		0	0	0	969	0	33	40213201		
55160	4579	1127433	1985-09-18	1985-09-18 00:00:00	1985-09-25	1985-09-25 00:00:00	1985-09-25	38000177		0	0	7		0	0	0	305028	0	313782	1127433		
49227	4085	19006318	1959-09-29	1959-09-29 00:00:00	1959-10-13	1959-10-13 00:00:00	1959-10-13	38000177		0	0	14		0	0	0	271543	0	105078	19006318		
33595	2780	19078461	1997-07-11	1997-07-11 00:00:00	1997-07-25	1997-07-25 00:00:00	1997-07-25	38000177		0	0	14		0	0	0	184247	0	310965	19078461		
17474	1446	19059056	1984-09-08	1984-09-08 00:00:00	1984-09-22	1984-09-22 00:00:00	1984-09-22	38000177		0	0	14		0	0	0	96389	0	243670	19059056		
5476	457	1713671	2003-02-24	2003-02-24 00:00:00	2003-03-17	2003-03-17 00:00:00	2003-03-17	38000177		0	0	21		0	0	0	30555	0	562251	1713671		
10971	915	19078461	2018-03-19	2018-03-19 00:00:00	2018-04-02	2018-04-02 00:00:00	2018-04-02	38000177		0	0	14		0	0	0	60788	0	310965	19078461		
16027	1328	920300	1999-08-07	1999-08-07 00:00:00	1999-08-14	1999-08-14 00:00:00	1999-08-14	38000177		0	0	7		0	0	0	88189	0	311989	920300		
26508	2180	1713671	2003-06-30	2003-06-30 00:00:00	2003-07-21	2003-07-21 00:00:00	2003-07-21	38000177		0	0	21		0	0	0	145402	0	562251	1713671		
26461	576	40213260	2016-10-19	2016-10-19 00:00:00	2016-10-19	2016-10-19 00:00:00	2016-10-19	581452		0	0	0		0	0	0	38111	0	121	40213260		
8582	715	1118084	2017-06-26	2017-06-26 00:00:00	2017-06-26	2017-06-26 00:00:00	\N	38000177		0	0	0		0	0	0	47326	0	00025152531	44923712		
63330	1385	40213296	2002-05-24	2002-05-24 00:00:00	2002-05-24	2002-05-24 00:00:00	2002-05-24	581452		0	0	0		0	0	0	91869	0	52	40213296		
54601	4534	1713671	1994-04-02	1994-04-02 00:00:00	1994-04-16	1994-04-16 00:00:00	1994-04-16	38000177		0	0	14		0	0	0	302044	0	562251	1713671		
19172	1585	1713671	1963-10-21	1963-10-21 00:00:00	1963-11-25	1963-11-25 00:00:00	1963-11-25	38000177		0	0	35		0	0	0	106272	0	562251	1713671		
22060	1813	1127433	2007-04-21	2007-04-21 00:00:00	2007-05-05	2007-05-05 00:00:00	2007-05-05	38000177		0	0	14		0	0	0	121346	0	313782	1127433		
141755	3114	40213227	2018-01-17	2018-01-17 00:00:00	2018-01-17	2018-01-17 00:00:00	2018-01-17	581452		0	0	0		0	0	0	207154	0	113	40213227		
37349	3086	19078461	1982-11-11	1982-11-11 00:00:00	1982-11-25	1982-11-25 00:00:00	1982-11-25	38000177		0	0	14		0	0	0	205441	0	310965	19078461		
58300	4844	1127078	1960-04-21	1960-04-21 00:00:00	1960-05-05	1960-05-05 00:00:00	1960-05-05	38000177		0	0	14		0	0	0	322268	0	282464	1127078		
106207	2329	40213227	1993-03-16	1993-03-16 00:00:00	1993-03-16	1993-03-16 00:00:00	1993-03-16	581452		0	0	0		0	0	0	154909	0	113	40213227		
41063	3407	1713671	2013-07-26	2013-07-26 00:00:00	2013-08-09	2013-08-09 00:00:00	2013-08-09	38000177		0	0	14		0	0	0	225954	0	562251	1713671		
63636	1391	40213201	1990-10-02	1990-10-02 00:00:00	1990-10-02	1990-10-02 00:00:00	1990-10-02	581452		0	0	0		0	0	0	92306	0	33	40213201		
4327	358	19133905	1988-08-16	1988-08-16 00:00:00	1988-08-26	1988-08-26 00:00:00	1988-08-26	38000177		0	0	10		0	0	0	23791	0	834102	19133905		
53523	4450	1127433	1968-07-09	1968-07-09 00:00:00	1968-07-16	1968-07-16 00:00:00	1968-07-16	38000177		0	0	7		0	0	0	296089	0	313782	1127433		
51712	4297	19079524	1991-02-19	1991-02-19 00:00:00	1991-02-20	1991-02-20 00:00:00	1991-02-20	38000177		0	0	1		0	0	0	285178	0	313002	19079524		
53618	4456	1127433	1971-06-11	1971-06-11 00:00:00	1971-06-18	1971-06-18 00:00:00	1971-06-18	38000177		0	0	7		0	0	0	296565	0	313782	1127433		
9808	821	1713671	1955-01-15	1955-01-15 00:00:00	1955-01-22	1955-01-22 00:00:00	1955-01-22	38000177		0	0	7		0	0	0	54378	0	562251	1713671		
64189	5329	920300	1996-02-09	1996-02-09 00:00:00	1996-02-16	1996-02-16 00:00:00	1996-02-16	38000177		0	0	7		0	0	0	354759	0	311989	920300		
137561	3019	40213160	1978-01-11	1978-01-11 00:00:00	1978-01-11	1978-01-11 00:00:00	1978-01-11	581452		0	0	0		0	0	0	201320	0	10	40213160		
50213	1100	40213160	1983-03-09	1983-03-09 00:00:00	1983-03-09	1983-03-09 00:00:00	1983-03-09	581452		0	0	0		0	0	0	72295	0	10	40213160		
19452	1604	40229134	1997-02-27	1997-02-27 00:00:00	1997-03-13	1997-03-13 00:00:00	1997-03-13	38000177		0	0	14		0	0	0	107608	0	1043400	40229134		
105204	2307	40213160	1962-01-09	1962-01-09 00:00:00	1962-01-09	1962-01-09 00:00:00	1962-01-09	581452		0	0	0		0	0	0	153505	0	10	40213160		
105250	2309	40213227	1995-06-02	1995-06-02 00:00:00	1995-06-02	1995-06-02 00:00:00	1995-06-02	581452		0	0	0		0	0	0	153675	0	113	40213227		
47484	3936	19059056	1959-01-16	1959-01-16 00:00:00	1959-01-30	1959-01-30 00:00:00	1959-01-30	38000177		0	0	14		0	0	0	261610	0	243670	19059056		
47516	3939	19133873	1978-08-01	1978-08-01 00:00:00	1978-08-13	1978-08-13 00:00:00	1978-08-13	38000177		0	0	12		0	0	0	261862	0	834061	19133873		
9119	758	1127433	1996-08-23	1996-08-23 00:00:00	1996-09-06	1996-09-06 00:00:00	1996-09-06	38000177		0	0	14		0	0	0	50315	0	313782	1127433		
224250	4923	40213160	1969-06-24	1969-06-24 00:00:00	1969-06-24	1969-06-24 00:00:00	1969-06-24	581452		0	0	0		0	0	0	327108	0	10	40213160		
19675	1618	1545959	2006-04-12	2006-04-12 00:00:00	2006-04-12	2006-04-12 00:00:00	2006-04-12	38000177		0	0	0		0	0	0	108786	0	259255	1545959		
213540	4682	40213227	2001-05-20	2001-05-20 00:00:00	2001-05-20	2001-05-20 00:00:00	2001-05-20	581452		0	0	0		0	0	0	\N	0	113	40213227		
2382	190	1127433	1954-11-29	1954-11-29 00:00:00	1955-01-28	1955-01-28 00:00:00	1955-01-28	38000177		0	0	60		0	0	0	12910	0	313782	1127433		
7951	664	19019979	1986-10-17	1986-10-17 00:00:00	1986-10-31	1986-10-31 00:00:00	1986-10-31	38000177		0	0	14		0	0	0	43901	0	198405	19019979		
27169	592	40213160	1970-05-08	1970-05-08 00:00:00	1970-05-08	1970-05-08 00:00:00	1970-05-08	581452		0	0	0		0	0	0	39090	0	10	40213160		
51381	4270	19006318	1970-07-30	1970-07-30 00:00:00	1970-08-13	1970-08-13 00:00:00	1970-08-13	38000177		0	0	14		0	0	0	283440	0	105078	19006318		
57583	4781	19075001	1997-11-07	1997-11-07 00:00:00	1997-11-21	1997-11-21 00:00:00	1997-11-21	38000177		0	0	14		0	0	0	318257	0	309097	19075001		
60283	5013	1332419	2010-09-10	2010-09-10 00:00:00	2010-09-10	2010-09-10 00:00:00	\N	38000177		0	0	0		0	0	0	333181	0	197361	1332419		
144412	3175	40213160	1955-05-03	1955-05-03 00:00:00	1955-05-03	1955-05-03 00:00:00	1955-05-03	581452		0	0	0		0	0	0	211041	0	10	40213160		
23649	1946	1115171	1997-05-24	1997-05-24 00:00:00	1997-06-23	1997-06-23 00:00:00	1997-06-23	38000177		0	0	30		0	0	0	129277	0	849574	1115171		
36693	800	40213260	2006-06-11	2006-06-11 00:00:00	2006-06-11	2006-06-11 00:00:00	2006-06-11	581452		0	0	0		0	0	0	53151	0	121	40213260		
34209	2827	40171902	2000-12-26	2000-12-26 00:00:00	2000-12-26	2000-12-26 00:00:00	\N	38000177		0	0	0		0	0	0	187456	0	897718	40171902		
57222	4750	19128065	1979-03-27	1979-03-27 00:00:00	1980-03-21	1980-03-21 00:00:00	1980-03-21	38000177		0	0	360		0	0	0	316307	0	749882	19128065		
51939	4319	19078461	1997-12-18	1997-12-18 00:00:00	1998-01-08	1998-01-08 00:00:00	1998-01-08	38000177		0	0	21		0	0	0	286584	0	310965	19078461		
135104	2965	40213296	2011-09-05	2011-09-05 00:00:00	2011-09-05	2011-09-05 00:00:00	2011-09-05	581452		0	0	0		0	0	0	198000	0	52	40213296		
62506	5199	1118084	2001-03-27	2001-03-27 00:00:00	2001-03-27	2001-03-27 00:00:00	\N	38000177		0	0	0		0	0	0	345749	0	00025152531	44923712		
39378	3253	1713671	1987-01-23	1987-01-23 00:00:00	1987-01-30	1987-01-30 00:00:00	1987-01-30	38000177		0	0	7		0	0	0	216289	0	562251	1713671		
42055	3486	1127433	1971-03-06	1971-03-06 00:00:00	1971-03-20	1971-03-20 00:00:00	1971-03-20	38000177		0	0	14		0	0	0	231254	0	313782	1127433		
39505	3263	1127433	2004-06-13	2004-06-13 00:00:00	2004-06-20	2004-06-20 00:00:00	2004-06-20	38000177		0	0	7		0	0	0	216963	0	313782	1127433		
19065	1574	1127433	2002-08-08	2002-08-08 00:00:00	2002-08-15	2002-08-15 00:00:00	2002-08-15	38000177		0	0	7		0	0	0	105666	0	313782	1127433		
30858	2555	19059056	1969-04-28	1969-04-28 00:00:00	1969-05-19	1969-05-19 00:00:00	1969-05-19	38000177		0	0	21		0	0	0	169312	0	243670	19059056		
56746	4707	1127433	2014-03-20	2014-03-20 00:00:00	2014-03-27	2014-03-27 00:00:00	2014-03-27	38000177		0	0	7		0	0	0	313581	0	313782	1127433		
221561	4861	40213201	2012-06-19	2012-06-19 00:00:00	2012-06-19	2012-06-19 00:00:00	2012-06-19	581452		0	0	0		0	0	0	323351	0	33	40213201		
45861	3796	19075601	2018-11-20	2018-11-20 00:00:00	2018-11-20	2018-11-20 00:00:00	\N	38000177		0	0	0		0	0	0	252366	0	309362	19075601		
12032	1005	1124300	2007-07-01	2007-07-01 00:00:00	2007-07-01	2007-07-01 00:00:00	\N	38000177		0	0	0		0	0	0	66410	0	00781178901	45011828		
146149	3214	40213227	2003-05-06	2003-05-06 00:00:00	2003-05-06	2003-05-06 00:00:00	2003-05-06	581452		0	0	0		0	0	0	213519	0	113	40213227		
44554	3689	19133873	1961-12-01	1961-12-01 00:00:00	1961-12-10	1961-12-10 00:00:00	1961-12-10	38000177		0	0	9		0	0	0	245227	0	834061	19133873		
53633	1174	40213227	1992-01-25	1992-01-25 00:00:00	1992-01-25	1992-01-25 00:00:00	1992-01-25	581452		0	0	0		0	0	0	77314	0	113	40213227		
532	11	40213198	2018-05-01	2018-05-01 00:00:00	2018-05-01	2018-05-01 00:00:00	2018-05-01	581452		0	0	0		0	0	0	942	0	133	40213198		
55161	4579	19133873	1973-04-15	1973-04-15 00:00:00	1973-04-24	1973-04-24 00:00:00	1973-04-24	38000177		0	0	9		0	0	0	305023	0	834061	19133873		
49228	4085	1127433	1971-05-25	1971-05-25 00:00:00	1971-06-01	1971-06-01 00:00:00	1971-06-01	38000177		0	0	7		0	0	0	271498	0	313782	1127433		
33596	2780	19006318	1956-12-21	1956-12-21 00:00:00	1957-01-04	1957-01-04 00:00:00	1957-01-04	38000177		0	0	14		0	0	0	184229	0	105078	19006318		
17475	1446	1127078	1984-03-30	1984-03-30 00:00:00	1984-04-13	1984-04-13 00:00:00	1984-04-13	38000177		0	0	14		0	0	0	96379	0	282464	1127078		
5477	457	19006318	1969-08-09	1969-08-09 00:00:00	1969-08-23	1969-08-23 00:00:00	1969-08-23	38000177		0	0	14		0	0	0	30535	0	105078	19006318		
10972	915	19006318	1971-10-11	1971-10-11 00:00:00	1971-10-25	1971-10-25 00:00:00	1971-10-25	38000177		0	0	14		0	0	0	60844	0	105078	19006318		
16028	1328	19059056	1948-04-11	1948-04-11 00:00:00	1948-07-10	1948-07-10 00:00:00	1948-07-10	38000177		0	0	90		0	0	0	88207	0	243670	19059056		
26509	2180	1713671	1991-04-15	1991-04-15 00:00:00	1991-05-06	1991-05-06 00:00:00	1991-05-06	38000177		0	0	21		0	0	0	145407	0	562251	1713671		
26465	576	40213160	1966-12-07	1966-12-07 00:00:00	1966-12-07	1966-12-07 00:00:00	1966-12-07	581452		0	0	0		0	0	0	38115	0	10	40213160		
29941	2481	46233988	1972-05-05	1972-05-05 00:00:00	1972-05-19	1972-05-19 00:00:00	1972-05-19	38000177		0	0	14		0	0	0	164392	0	1652673	46233988		
63332	1385	40213227	2002-05-24	2002-05-24 00:00:00	2002-05-24	2002-05-24 00:00:00	2002-05-24	581452		0	0	0		0	0	0	91869	0	113	40213227		
225997	4963	40213160	1978-04-24	1978-04-24 00:00:00	1978-04-24	1978-04-24 00:00:00	1978-04-24	581452		0	0	0		0	0	0	329883	0	10	40213160		
19173	1585	1127433	1939-05-08	1939-05-08 00:00:00	1939-05-15	1939-05-15 00:00:00	1939-05-15	38000177		0	0	7		0	0	0	106254	0	313782	1127433		
22061	1813	19073183	1984-09-23	1984-09-23 00:00:00	1984-10-07	1984-10-07 00:00:00	1984-10-07	38000177		0	0	14		0	0	0	121349	0	308182	19073183		
232675	5113	40213260	2019-03-16	2019-03-16 00:00:00	2019-03-16	2019-03-16 00:00:00	2019-03-16	581452		0	0	0		0	0	0	339676	0	121	40213260		
37350	3086	1127433	1980-05-27	1980-05-27 00:00:00	1980-06-03	1980-06-03 00:00:00	1980-06-03	38000177		0	0	7		0	0	0	205435	0	313782	1127433		
58301	4844	19006318	1960-04-21	1960-04-21 00:00:00	1960-05-05	1960-05-05 00:00:00	1960-05-05	38000177		0	0	14		0	0	0	322268	0	105078	19006318		
106221	2329	40213160	1971-04-20	1971-04-20 00:00:00	1971-04-20	1971-04-20 00:00:00	1971-04-20	581452		0	0	0		0	0	0	154933	0	10	40213160		
41064	3407	1127433	1999-07-15	1999-07-15 00:00:00	1999-08-05	1999-08-05 00:00:00	1999-08-05	38000177		0	0	21		0	0	0	225977	0	313782	1127433		
26311	573	40213296	1999-11-27	1999-11-27 00:00:00	1999-11-27	1999-11-27 00:00:00	1999-11-27	581452		0	0	0		0	0	0	37937	0	52	40213296		
4328	358	19059056	1944-12-29	1944-12-29 00:00:00	1945-01-12	1945-01-12 00:00:00	1945-01-12	38000177		0	0	14		0	0	0	23779	0	243670	19059056		
53524	4450	19059056	1967-12-10	1967-12-10 00:00:00	1967-12-24	1967-12-24 00:00:00	1967-12-24	38000177		0	0	14		0	0	0	296075	0	243670	19059056		
51713	4297	40220386	1991-02-19	1991-02-19 00:00:00	1991-02-19	1991-02-19 00:00:00	1991-02-19	38000177		0	0	0		0	0	0	285178	0	1808217	40220386		
64077	5322	40229134	1964-02-24	1964-02-24 00:00:00	1964-03-09	1964-03-09 00:00:00	1964-03-09	38000177		0	0	14		0	0	0	354270	0	1043400	40229134		
9809	821	1127433	1978-04-18	1978-04-18 00:00:00	1978-07-17	1978-07-17 00:00:00	1978-07-17	38000177		0	0	90		0	0	0	54396	0	313782	1127433		
64190	5329	1713671	1957-07-28	1957-07-28 00:00:00	1957-08-04	1957-08-04 00:00:00	1957-08-04	38000177		0	0	7		0	0	0	354743	0	562251	1713671		
137566	3019	40213296	2019-05-15	2019-05-15 00:00:00	2019-05-15	2019-05-15 00:00:00	2019-05-15	581452		0	0	0		0	0	0	201327	0	52	40213296		
50214	1100	40213314	1983-03-09	1983-03-09 00:00:00	1983-03-09	1983-03-09 00:00:00	1983-03-09	581452		0	0	0		0	0	0	72295	0	49	40213314		
19453	1604	19059056	1973-04-15	1973-04-15 00:00:00	1973-05-22	1973-05-22 00:00:00	1973-05-22	38000177		0	0	37		0	0	0	107605	0	243670	19059056		
36913	3053	42902245	1999-12-16	1999-12-16 00:00:00	2000-12-10	2000-12-10 00:00:00	2000-12-10	38000177		0	0	360		0	0	0	203105	0	1359133	42902245		
116536	2561	40213227	2008-12-10	2008-12-10 00:00:00	2008-12-10	2008-12-10 00:00:00	2008-12-10	581452		0	0	0		0	0	0	169688	0	113	40213227		
47485	3936	19133905	1991-05-27	1991-05-27 00:00:00	1991-06-08	1991-06-08 00:00:00	1991-06-08	38000177		0	0	12		0	0	0	261618	0	834102	19133905		
47517	3939	1127433	2013-03-29	2013-03-29 00:00:00	2013-04-12	2013-04-12 00:00:00	2013-04-12	38000177		0	0	14		0	0	0	261843	0	313782	1127433		
9120	758	1127078	1977-02-02	1977-02-02 00:00:00	1977-02-16	1977-02-16 00:00:00	1977-02-16	38000177		0	0	14		0	0	0	50307	0	282464	1127078		
224257	4923	40213160	1973-09-25	1973-09-25 00:00:00	1973-09-25	1973-09-25 00:00:00	1973-09-25	581452		0	0	0		0	0	0	327103	0	10	40213160		
19676	1618	19133768	2006-04-12	2006-04-12 00:00:00	2006-04-12	2006-04-12 00:00:00	2006-04-12	38000177		0	0	0		0	0	0	108786	0	833036	19133768		
213541	4682	40213306	2001-05-20	2001-05-20 00:00:00	2001-05-20	2001-05-20 00:00:00	2001-05-20	581452		0	0	0		0	0	0	\N	0	43	40213306		
2383	191	40229134	1981-11-29	1981-11-29 00:00:00	1981-12-06	1981-12-06 00:00:00	1981-12-06	38000177		0	0	7		0	0	0	13067	0	1043400	40229134		
7952	665	1713671	2006-07-05	2006-07-05 00:00:00	2006-07-19	2006-07-19 00:00:00	2006-07-19	38000177		0	0	14		0	0	0	43942	0	562251	1713671		
27171	592	40213227	1992-10-30	1992-10-30 00:00:00	1992-10-30	1992-10-30 00:00:00	1992-10-30	581452		0	0	0		0	0	0	39099	0	113	40213227		
51382	4270	1127433	1994-01-06	1994-01-06 00:00:00	1994-01-13	1994-01-13 00:00:00	1994-01-13	38000177		0	0	7		0	0	0	283437	0	313782	1127433		
57584	4781	40229134	2013-09-15	2013-09-15 00:00:00	2013-09-22	2013-09-22 00:00:00	2013-09-22	38000177		0	0	7		0	0	0	318302	0	1043400	40229134		
60284	5013	19075601	2010-09-10	2010-09-10 00:00:00	2013-05-31	2013-05-31 00:00:00	2013-05-31	38000177		0	0	994		0	0	0	333181	0	309362	19075601		
144416	3175	40213160	1955-02-01	1955-02-01 00:00:00	1955-02-01	1955-02-01 00:00:00	1955-02-01	581452		0	0	0		0	0	0	211010	0	10	40213160		
23650	1946	40162522	1997-05-24	1997-05-24 00:00:00	1997-05-24	1997-05-24 00:00:00	\N	38000177		0	0	0		0	0	0	129277	0	857005	40162522		
155763	3428	40213160	1971-05-12	1971-05-12 00:00:00	1971-05-12	1971-05-12 00:00:00	1971-05-12	581452		0	0	0		0	0	0	227309	0	10	40213160		
34210	2827	920334	1968-07-04	1968-07-04 00:00:00	1968-07-11	1968-07-11 00:00:00	1968-07-11	38000177		0	0	7		0	0	0	187445	0	311995	920334		
57224	4750	19075601	2019-02-13	2019-02-13 00:00:00	2019-02-13	2019-02-13 00:00:00	2019-02-13	38000177		0	0	0		0	0	0	316380	0	309362	19075601		
51940	4319	1127078	1986-04-15	1986-04-15 00:00:00	1986-05-20	1986-05-20 00:00:00	1986-05-20	38000177		0	0	35		0	0	0	286582	0	282464	1127078		
135112	2965	40213227	2003-08-25	2003-08-25 00:00:00	2003-08-25	2003-08-25 00:00:00	2003-08-25	581452		0	0	0		0	0	0	197932	0	113	40213227		
62507	5199	1127078	1973-01-02	1973-01-02 00:00:00	1973-01-30	1973-01-30 00:00:00	1973-01-30	38000177		0	0	28		0	0	0	345725	0	282464	1127078		
39379	3253	19008572	2001-03-10	2001-03-10 00:00:00	2001-03-31	2001-03-31 00:00:00	2001-03-31	38000177		0	0	21		0	0	0	216367	0	106258	19008572		
42064	3488	1127433	2000-01-19	2000-01-19 00:00:00	2000-01-26	2000-01-26 00:00:00	2000-01-26	38000177		0	0	7		0	0	0	231416	0	313782	1127433		
39506	3263	19133905	1985-04-23	1985-04-23 00:00:00	1985-05-03	1985-05-03 00:00:00	1985-05-03	38000177		0	0	10		0	0	0	216878	0	834102	19133905		
19066	1574	19133873	1970-03-25	1970-03-25 00:00:00	1970-04-07	1970-04-07 00:00:00	1970-04-07	38000177		0	0	13		0	0	0	105660	0	834061	19133873		
30859	2555	1124300	1990-11-13	1990-11-13 00:00:00	1990-11-13	1990-11-13 00:00:00	\N	38000177		0	0	0		0	0	0	169278	0	00781178901	45011828		
56747	4707	40229134	1986-04-12	1986-04-12 00:00:00	1986-04-26	1986-04-26 00:00:00	1986-04-26	38000177		0	0	14		0	0	0	313572	0	1043400	40229134		
221566	4861	40213227	1997-06-10	1997-06-10 00:00:00	1997-06-10	1997-06-10 00:00:00	1997-06-10	581452		0	0	0		0	0	0	323347	0	113	40213227		
45862	3796	1539411	2018-11-20	2018-11-20 00:00:00	2018-11-20	2018-11-20 00:00:00	\N	38000177		0	0	0		0	0	0	252366	0	312961	1539411		
12033	1005	19128065	1988-01-12	1988-01-12 00:00:00	1989-01-06	1989-01-06 00:00:00	1989-01-06	38000177		0	0	360		0	0	0	66442	0	749882	19128065		
146152	3215	40213227	2000-03-27	2000-03-27 00:00:00	2000-03-27	2000-03-27 00:00:00	2000-03-27	581452		0	0	0		0	0	0	213636	0	113	40213227		
44556	3689	40171902	2011-04-04	2011-04-04 00:00:00	2011-04-04	2011-04-04 00:00:00	\N	38000177		0	0	0		0	0	0	245243	0	897718	40171902		
162910	3582	40213227	1998-06-07	1998-06-07 00:00:00	1998-06-07	1998-06-07 00:00:00	1998-06-07	581452		0	0	0		0	0	0	238131	0	113	40213227		
537	12	40213306	1985-10-30	1985-10-30 00:00:00	1985-10-30	1985-10-30 00:00:00	1985-10-30	581452		0	0	0		0	0	0	1075	0	43	40213306		
55162	4579	1127433	2001-02-28	2001-02-28 00:00:00	2001-03-14	2001-03-14 00:00:00	2001-03-14	38000177		0	0	14		0	0	0	305030	0	313782	1127433		
49229	4085	1127433	1976-10-03	1976-10-03 00:00:00	1976-10-10	1976-10-10 00:00:00	1976-10-10	38000177		0	0	7		0	0	0	271540	0	313782	1127433		
33597	2780	1127078	1956-12-21	1956-12-21 00:00:00	1957-01-04	1957-01-04 00:00:00	1957-01-04	38000177		0	0	14		0	0	0	184229	0	282464	1127078		
17476	1446	19074843	1984-03-30	1984-03-30 00:00:00	1984-04-13	1984-04-13 00:00:00	1984-04-13	38000177		0	0	14		0	0	0	96379	0	309045	19074843		
5478	457	1127433	1969-08-09	1969-08-09 00:00:00	1969-08-23	1969-08-23 00:00:00	1969-08-23	38000177		0	0	14		0	0	0	30535	0	313782	1127433		
10973	915	19059056	1971-10-11	1971-10-11 00:00:00	1971-10-25	1971-10-25 00:00:00	1971-10-25	38000177		0	0	14		0	0	0	60844	0	243670	19059056		
16029	1328	19133905	1993-02-22	1993-02-22 00:00:00	1993-03-06	1993-03-06 00:00:00	1993-03-06	38000177		0	0	12		0	0	0	88136	0	834102	19133905		
26510	2180	1713671	2013-11-17	2013-11-17 00:00:00	2013-11-24	2013-11-24 00:00:00	2013-11-24	38000177		0	0	7		0	0	0	145408	0	562251	1713671		
61018	1333	40213227	2016-04-17	2016-04-17 00:00:00	2016-04-17	2016-04-17 00:00:00	2016-04-17	581452		0	0	0		0	0	0	88449	0	113	40213227		
29942	2481	1127433	1997-07-21	1997-07-21 00:00:00	1997-08-11	1997-08-11 00:00:00	1997-08-11	38000177		0	0	21		0	0	0	164389	0	313782	1127433		
63336	1385	40213227	2011-05-20	2011-05-20 00:00:00	2011-05-20	2011-05-20 00:00:00	2011-05-20	581452		0	0	0		0	0	0	91809	0	113	40213227		
225999	4963	40213227	2015-05-25	2015-05-25 00:00:00	2015-05-25	2015-05-25 00:00:00	2015-05-25	581452		0	0	0		0	0	0	329928	0	113	40213227		
19174	1585	1127433	1957-03-26	1957-03-26 00:00:00	1957-04-02	1957-04-02 00:00:00	1957-04-02	38000177		0	0	7		0	0	0	106257	0	313782	1127433		
22062	1813	19059056	1984-09-23	1984-09-23 00:00:00	1984-10-07	1984-10-07 00:00:00	1984-10-07	38000177		0	0	14		0	0	0	121349	0	243670	19059056		
232678	5113	40213306	1991-05-18	1991-05-18 00:00:00	1991-05-18	1991-05-18 00:00:00	1991-05-18	581452		0	0	0		0	0	0	339689	0	43	40213306		
47822	3966	19059056	1974-05-02	1974-05-02 00:00:00	1974-05-16	1974-05-16 00:00:00	1974-05-16	38000177		0	0	14		0	0	0	263662	0	243670	19059056		
58302	4844	1127433	1990-01-12	1990-01-12 00:00:00	1990-01-19	1990-01-19 00:00:00	1990-01-19	38000177		0	0	7		0	0	0	322178	0	313782	1127433		
106222	2330	40213160	1975-12-29	1975-12-29 00:00:00	1975-12-29	1975-12-29 00:00:00	1975-12-29	581452		0	0	0		0	0	0	154989	0	10	40213160		
41065	3407	1127078	1964-06-18	1964-06-18 00:00:00	1964-07-02	1964-07-02 00:00:00	1964-07-02	38000177		0	0	14		0	0	0	225984	0	282464	1127078		
37594	820	40213227	1995-08-17	1995-08-17 00:00:00	1995-08-17	1995-08-17 00:00:00	1995-08-17	581452		0	0	0		0	0	0	54320	0	113	40213227		
4329	358	1713671	1943-08-16	1943-08-16 00:00:00	1943-09-06	1943-09-06 00:00:00	1943-09-06	38000177		0	0	21		0	0	0	23845	0	562251	1713671		
53525	4450	19129655	1967-12-10	1967-12-10 00:00:00	1967-12-24	1967-12-24 00:00:00	1967-12-24	38000177		0	0	14		0	0	0	296075	0	789980	19129655		
51714	4297	19078924	1991-02-19	1991-02-19 00:00:00	1991-02-19	1991-02-19 00:00:00	1991-02-19	38000177		0	0	0		0	0	0	285178	0	311700	19078924		
64078	5322	1713671	1967-03-14	1967-03-14 00:00:00	1967-03-21	1967-03-21 00:00:00	1967-03-21	38000177		0	0	7		0	0	0	354211	0	562251	1713671		
9810	821	1127433	1969-08-12	1969-08-12 00:00:00	1969-09-02	1969-09-02 00:00:00	1969-09-02	38000177		0	0	21		0	0	0	54395	0	313782	1127433		
6187	518	1118084	2007-05-12	2007-05-12 00:00:00	2007-05-12	2007-05-12 00:00:00	\N	38000177		0	0	0		0	0	0	34647	0	00025152531	44923712		
137568	3019	40213227	2019-05-15	2019-05-15 00:00:00	2019-05-15	2019-05-15 00:00:00	2019-05-15	581452		0	0	0		0	0	0	201327	0	113	40213227		
50215	1100	40213314	1983-12-07	1983-12-07 00:00:00	1983-12-07	1983-12-07 00:00:00	1983-12-07	581452		0	0	0		0	0	0	72296	0	49	40213314		
19454	1604	40169281	1999-06-17	1999-06-17 00:00:00	1999-06-17	1999-06-17 00:00:00	\N	38000177		0	0	0		0	0	0	107597	0	896209	40169281		
36914	3053	42902245	2000-12-10	2000-12-10 00:00:00	2001-12-05	2001-12-05 00:00:00	2001-12-05	38000177		0	0	360		0	0	0	203106	0	1359133	42902245		
116537	2561	40213160	1977-07-06	1977-07-06 00:00:00	1977-07-06	1977-07-06 00:00:00	1977-07-06	581452		0	0	0		0	0	0	169729	0	10	40213160		
47495	3938	1127433	1926-07-06	1926-07-06 00:00:00	1926-07-13	1926-07-13 00:00:00	1926-07-13	38000177		0	0	7		0	0	0	261770	0	313782	1127433		
47543	3941	1115171	2017-02-07	2017-02-07 00:00:00	2017-02-28	2017-02-28 00:00:00	2017-02-28	38000177		0	0	21		0	0	0	261997	0	849574	1115171		
9121	758	46233988	1977-02-02	1977-02-02 00:00:00	1977-02-16	1977-02-16 00:00:00	1977-02-16	38000177		0	0	14		0	0	0	50307	0	1652673	46233988		
224263	4923	40213227	2000-01-18	2000-01-18 00:00:00	2000-01-18	2000-01-18 00:00:00	2000-01-18	581452		0	0	0		0	0	0	327084	0	113	40213227		
113705	2498	40213296	2013-07-20	2013-07-20 00:00:00	2013-07-20	2013-07-20 00:00:00	2013-07-20	581452		0	0	0		0	0	0	165383	0	52	40213296		
213543	4682	40213160	1984-08-26	1984-08-26 00:00:00	1984-08-26	1984-08-26 00:00:00	1984-08-26	581452		0	0	0		0	0	0	312011	0	10	40213160		
2384	191	19059056	1924-02-11	1924-02-11 00:00:00	1924-03-12	1924-03-12 00:00:00	1924-03-12	38000177		0	0	30		0	0	0	13036	0	243670	19059056		
7953	665	1127433	1986-08-17	1986-08-17 00:00:00	1986-09-21	1986-09-21 00:00:00	1986-09-21	38000177		0	0	35		0	0	0	43938	0	313782	1127433		
27172	592	40213306	1992-10-30	1992-10-30 00:00:00	1992-10-30	1992-10-30 00:00:00	1992-10-30	581452		0	0	0		0	0	0	39099	0	43	40213306		
51383	4270	40165015	1992-01-07	1992-01-07 00:00:00	1992-01-07	1992-01-07 00:00:00	\N	38000177		0	0	0		0	0	0	283393	0	861467	40165015		
57585	4781	40229134	1998-12-03	1998-12-03 00:00:00	1998-12-10	1998-12-10 00:00:00	1998-12-10	38000177		0	0	7		0	0	0	318293	0	1043400	40229134		
60285	5013	1118084	2005-08-01	2005-08-01 00:00:00	2005-08-01	2005-08-01 00:00:00	\N	38000177		0	0	0		0	0	0	333217	0	00025152531	44923712		
144420	3175	40213227	1994-12-06	1994-12-06 00:00:00	1994-12-06	1994-12-06 00:00:00	1994-12-06	581452		0	0	0		0	0	0	211078	0	113	40213227		
23651	1946	40229134	1985-07-21	1985-07-21 00:00:00	1985-08-04	1985-08-04 00:00:00	1985-08-04	38000177		0	0	14		0	0	0	129274	0	1043400	40229134		
155767	3428	40213160	1967-02-08	1967-02-08 00:00:00	1967-02-08	1967-02-08 00:00:00	1967-02-08	581452		0	0	0		0	0	0	227291	0	10	40213160		
51843	4309	1713671	1968-05-27	1968-05-27 00:00:00	1968-06-03	1968-06-03 00:00:00	1968-06-03	38000177		0	0	7		0	0	0	285886	0	562251	1713671		
57225	4750	40220960	2019-02-13	2019-02-13 00:00:00	2019-02-13	2019-02-13 00:00:00	2019-02-13	38000177		0	0	0		0	0	0	316380	0	1804799	40220960		
51941	4319	1115171	2013-04-19	2013-04-19 00:00:00	2013-05-03	2013-05-03 00:00:00	2013-05-03	38000177		0	0	14		0	0	0	286585	0	849574	1115171		
135115	2965	40213306	1990-05-07	1990-05-07 00:00:00	1990-05-07	1990-05-07 00:00:00	1990-05-07	581452		0	0	0		0	0	0	198007	0	43	40213306		
62508	5199	1115171	2011-06-08	2011-06-08 00:00:00	2011-09-06	2011-09-06 00:00:00	2011-09-06	38000177		0	0	90		0	0	0	345723	0	849574	1115171		
39380	3253	19134077	2001-03-10	2001-03-10 00:00:00	2001-03-31	2001-03-31 00:00:00	2001-03-31	38000177		0	0	21		0	0	0	216367	0	835900	19134077		
42065	3488	1127433	1960-04-20	1960-04-20 00:00:00	1960-05-04	1960-05-04 00:00:00	1960-05-04	38000177		0	0	14		0	0	0	231340	0	313782	1127433		
39507	3263	19078461	2011-06-03	2011-06-03 00:00:00	2011-06-24	2011-06-24 00:00:00	2011-06-24	38000177		0	0	21		0	0	0	216904	0	310965	19078461		
19067	1574	19133873	1965-11-26	1965-11-26 00:00:00	1965-12-06	1965-12-06 00:00:00	1965-12-06	38000177		0	0	10		0	0	0	105693	0	834061	19133873		
30860	2555	1127078	1950-06-07	1950-06-07 00:00:00	1950-06-21	1950-06-21 00:00:00	1950-06-21	38000177		0	0	14		0	0	0	169344	0	282464	1127078		
56748	4707	19059056	1977-03-19	1977-03-19 00:00:00	1977-06-17	1977-06-17 00:00:00	1977-06-17	38000177		0	0	90		0	0	0	313554	0	243670	19059056		
221568	4861	40213198	2011-06-14	2011-06-14 00:00:00	2011-06-14	2011-06-14 00:00:00	2011-06-14	581452		0	0	0		0	0	0	323401	0	133	40213198		
45863	3796	1713671	1970-12-25	1970-12-25 00:00:00	1971-01-08	1971-01-08 00:00:00	1971-01-08	38000177		0	0	14		0	0	0	252368	0	562251	1713671		
12034	1005	40169216	1970-02-27	1970-02-27 00:00:00	1986-07-22	1986-07-22 00:00:00	1986-07-22	38000177		0	0	5989		0	0	0	66404	0	895994	40169216		
146153	3215	40213306	2000-03-27	2000-03-27 00:00:00	2000-03-27	2000-03-27 00:00:00	2000-03-27	581452		0	0	0		0	0	0	213636	0	43	40213306		
44557	3689	19018935	2011-04-04	2011-04-04 00:00:00	2011-04-04	2011-04-04 00:00:00	\N	38000177		0	0	0		0	0	0	245243	0	197604	19018935		
162913	3582	40213260	2006-05-28	2006-05-28 00:00:00	2006-05-28	2006-05-28 00:00:00	2006-05-28	581452		0	0	0		0	0	0	238162	0	121	40213260		
11823	254	40213227	1993-12-03	1993-12-03 00:00:00	1993-12-03	1993-12-03 00:00:00	1993-12-03	581452		0	0	0		0	0	0	16915	0	113	40213227		
49405	1082	40213296	1997-08-30	1997-08-30 00:00:00	1997-08-30	1997-08-30 00:00:00	1997-08-30	581452		0	0	0		0	0	0	71015	0	52	40213296		
49230	4085	1713671	1994-01-07	1994-01-07 00:00:00	1994-01-14	1994-01-14 00:00:00	1994-01-14	38000177		0	0	7		0	0	0	271521	0	562251	1713671		
33598	2780	1127433	2014-10-24	2014-10-24 00:00:00	2014-11-14	2014-11-14 00:00:00	2014-11-14	38000177		0	0	21		0	0	0	184232	0	313782	1127433		
17477	1446	19075001	1985-06-06	1985-06-06 00:00:00	1985-06-20	1985-06-20 00:00:00	1985-06-20	38000177		0	0	14		0	0	0	96397	0	309097	19075001		
15937	1322	1118084	1958-09-01	1958-09-01 00:00:00	1958-09-01	1958-09-01 00:00:00	\N	38000177		0	0	0		0	0	0	87741	0	00025152531	44923712		
10974	915	1127433	1973-08-23	1973-08-23 00:00:00	1973-09-06	1973-09-06 00:00:00	1973-09-06	38000177		0	0	14		0	0	0	60861	0	313782	1127433		
16030	1328	19059056	1969-04-19	1969-04-19 00:00:00	1969-05-03	1969-05-03 00:00:00	1969-05-03	38000177		0	0	14		0	0	0	88209	0	243670	19059056		
26525	2184	46233988	1969-02-16	1969-02-16 00:00:00	1969-03-02	1969-03-02 00:00:00	1969-03-02	38000177		0	0	14		0	0	0	145598	0	1652673	46233988		
61026	1333	40213160	1955-03-13	1955-03-13 00:00:00	1955-03-13	1955-03-13 00:00:00	1955-03-13	581452		0	0	0		0	0	0	88423	0	10	40213160		
29943	2481	1127433	1978-10-03	1978-10-03 00:00:00	1978-10-17	1978-10-17 00:00:00	1978-10-17	38000177		0	0	14		0	0	0	164368	0	313782	1127433		
63337	1385	40213260	2011-05-20	2011-05-20 00:00:00	2011-05-20	2011-05-20 00:00:00	2011-05-20	581452		0	0	0		0	0	0	91809	0	121	40213260		
226000	4963	40213296	2015-05-25	2015-05-25 00:00:00	2015-05-25	2015-05-25 00:00:00	2015-05-25	581452		0	0	0		0	0	0	329928	0	52	40213296		
19175	1585	40229134	1959-10-20	1959-10-20 00:00:00	1959-11-03	1959-11-03 00:00:00	1959-11-03	38000177		0	0	14		0	0	0	106270	0	1043400	40229134		
22063	1813	1127433	1990-02-02	1990-02-02 00:00:00	1990-02-09	1990-02-09 00:00:00	1990-02-09	38000177		0	0	7		0	0	0	121308	0	313782	1127433		
232681	5113	40213160	1974-02-23	1974-02-23 00:00:00	1974-02-23	1974-02-23 00:00:00	1974-02-23	581452		0	0	0		0	0	0	339731	0	10	40213160		
47823	3966	19128065	1987-10-31	1987-10-31 00:00:00	1988-10-25	1988-10-25 00:00:00	1988-10-25	38000177		0	0	360		0	0	0	263688	0	749882	19128065		
58303	4844	1713671	1978-08-24	1978-08-24 00:00:00	1978-09-14	1978-09-14 00:00:00	1978-09-14	38000177		0	0	21		0	0	0	322228	0	562251	1713671		
106223	2330	40213296	2015-07-27	2015-07-27 00:00:00	2015-07-27	2015-07-27 00:00:00	2015-07-27	581452		0	0	0		0	0	0	154976	0	52	40213296		
41066	3407	19129655	1964-06-18	1964-06-18 00:00:00	1964-07-02	1964-07-02 00:00:00	1964-07-02	38000177		0	0	14		0	0	0	225984	0	789980	19129655		
37600	820	40213296	2005-01-20	2005-01-20 00:00:00	2005-01-20	2005-01-20 00:00:00	2005-01-20	581452		0	0	0		0	0	0	54300	0	52	40213296		
4330	359	1127433	1988-01-08	1988-01-08 00:00:00	1988-01-22	1988-01-22 00:00:00	1988-01-22	38000177		0	0	14		0	0	0	23889	0	313782	1127433		
53526	4450	19078461	2015-04-16	2015-04-16 00:00:00	2015-05-16	2015-05-16 00:00:00	2015-05-16	38000177		0	0	30		0	0	0	296086	0	310965	19078461		
51715	4297	782047	1991-02-19	1991-02-19 00:00:00	1991-02-19	1991-02-19 00:00:00	1991-02-19	38000177		0	0	0		0	0	0	285178	0	542347	782047		
64079	5322	19059056	1962-02-02	1962-02-02 00:00:00	1962-03-02	1962-03-02 00:00:00	1962-03-02	38000177		0	0	28		0	0	0	354086	0	243670	19059056		
9811	821	19059056	1960-06-09	1960-06-09 00:00:00	1960-06-30	1960-06-30 00:00:00	1960-06-30	38000177		0	0	21		0	0	0	54394	0	243670	19059056		
6188	518	19006318	1974-04-01	1974-04-01 00:00:00	1974-04-15	1974-04-15 00:00:00	1974-04-15	38000177		0	0	14		0	0	0	34601	0	105078	19006318		
137569	3019	40213314	1977-10-12	1977-10-12 00:00:00	1977-10-12	1977-10-12 00:00:00	1977-10-12	581452		0	0	0		0	0	0	201356	0	49	40213314		
50219	1100	40213314	1983-01-05	1983-01-05 00:00:00	1983-01-05	1983-01-05 00:00:00	1983-01-05	581452		0	0	0		0	0	0	72262	0	49	40213314		
19455	1604	1127433	2018-12-27	2018-12-27 00:00:00	2019-01-26	2019-01-26 00:00:00	2019-01-26	38000177		0	0	30		0	0	0	107607	0	313782	1127433		
36915	3053	19128022	1997-12-26	1997-12-26 00:00:00	1998-12-21	1998-12-21 00:00:00	1998-12-21	38000177		0	0	360		0	0	0	203104	0	749785	19128022		
116539	2561	40213314	1977-04-06	1977-04-06 00:00:00	1977-04-06	1977-04-06 00:00:00	1977-04-06	581452		0	0	0		0	0	0	169676	0	49	40213314		
47496	3938	40236824	1938-04-26	1938-04-26 00:00:00	1938-05-10	1938-05-10 00:00:00	1938-05-10	38000177		0	0	14		0	0	0	261702	0	1094107	40236824		
47544	3941	920300	1992-02-10	1992-02-10 00:00:00	1992-02-17	1992-02-17 00:00:00	1992-02-17	38000177		0	0	7		0	0	0	262039	0	311989	920300		
9122	758	19019979	1974-03-20	1974-03-20 00:00:00	1974-05-19	1974-05-19 00:00:00	1974-05-19	38000177		0	0	60		0	0	0	50297	0	198405	19019979		
224266	4923	40213296	2008-10-14	2008-10-14 00:00:00	2008-10-14	2008-10-14 00:00:00	2008-10-14	581452		0	0	0		0	0	0	327146	0	52	40213296		
113707	2498	40213227	2013-07-20	2013-07-20 00:00:00	2013-07-20	2013-07-20 00:00:00	2013-07-20	581452		0	0	0		0	0	0	165383	0	113	40213227		
213544	4682	40213251	1984-08-26	1984-08-26 00:00:00	1984-08-26	1984-08-26 00:00:00	1984-08-26	581452		0	0	0		0	0	0	312011	0	21	40213251		
2385	191	1713671	1997-10-13	1997-10-13 00:00:00	1997-10-20	1997-10-20 00:00:00	1997-10-20	38000177		0	0	7		0	0	0	13026	0	562251	1713671		
7954	665	40162522	1993-01-08	1993-01-08 00:00:00	1993-01-08	1993-01-08 00:00:00	\N	38000177		0	0	0		0	0	0	43940	0	857005	40162522		
27173	592	40213227	2002-09-13	2002-09-13 00:00:00	2002-09-13	2002-09-13 00:00:00	2002-09-13	581452		0	0	0		0	0	0	39107	0	113	40213227		
39598	3275	19059056	1985-10-25	1985-10-25 00:00:00	1985-11-08	1985-11-08 00:00:00	1985-11-08	38000177		0	0	14		0	0	0	217603	0	243670	19059056		
57586	4781	1115171	1998-10-03	1998-10-03 00:00:00	1998-10-31	1998-10-31 00:00:00	1998-10-31	38000177		0	0	28		0	0	0	318274	0	849574	1115171		
60286	5014	40231925	1936-01-11	1936-01-11 00:00:00	1936-01-11	1936-01-11 00:00:00	\N	38000177		0	0	0		0	0	0	333251	0	1049221	40231925		
144424	3175	40213160	1958-11-04	1958-11-04 00:00:00	1958-11-04	1958-11-04 00:00:00	1958-11-04	581452		0	0	0		0	0	0	211012	0	10	40213160		
23652	1946	19059056	1930-01-04	1930-01-04 00:00:00	1930-01-18	1930-01-18 00:00:00	1930-01-18	38000177		0	0	14		0	0	0	129313	0	243670	19059056		
155769	3428	40213160	1966-08-31	1966-08-31 00:00:00	1966-08-31	1966-08-31 00:00:00	1966-08-31	581452		0	0	0		0	0	0	227269	0	10	40213160		
51844	4309	19133905	1990-12-12	1990-12-12 00:00:00	1990-12-22	1990-12-22 00:00:00	1990-12-22	38000177		0	0	10		0	0	0	285888	0	834102	19133905		
57226	4750	19128065	1983-03-06	1983-03-06 00:00:00	1984-02-29	1984-02-29 00:00:00	1984-02-29	38000177		0	0	360		0	0	0	316299	0	749882	19128065		
51942	4319	40169281	2002-12-25	2002-12-25 00:00:00	2002-12-25	2002-12-25 00:00:00	\N	38000177		0	0	0		0	0	0	286589	0	896209	40169281		
135118	2965	40213160	1975-02-03	1975-02-03 00:00:00	1975-02-03	1975-02-03 00:00:00	1975-02-03	581452		0	0	0		0	0	0	198025	0	10	40213160		
62509	5199	1127433	1963-10-09	1963-10-09 00:00:00	1963-10-23	1963-10-23 00:00:00	1963-10-23	38000177		0	0	14		0	0	0	345771	0	313782	1127433		
39381	3253	1713671	1983-11-27	1983-11-27 00:00:00	1983-12-04	1983-12-04 00:00:00	1983-12-04	38000177		0	0	7		0	0	0	216324	0	562251	1713671		
42066	3488	1127433	1990-06-13	1990-06-13 00:00:00	1990-07-04	1990-07-04 00:00:00	1990-07-04	38000177		0	0	21		0	0	0	231357	0	313782	1127433		
39508	3263	19078461	2002-11-03	2002-11-03 00:00:00	2002-11-17	2002-11-17 00:00:00	2002-11-17	38000177		0	0	14		0	0	0	216902	0	310965	19078461		
19080	1576	40231925	1982-02-20	1982-02-20 00:00:00	1982-02-20	1982-02-20 00:00:00	\N	38000177		0	0	0		0	0	0	105774	0	1049221	40231925		
30861	2555	19006318	1950-06-07	1950-06-07 00:00:00	1950-06-21	1950-06-21 00:00:00	1950-06-21	38000177		0	0	14		0	0	0	169344	0	105078	19006318		
78456	1716	40213198	2010-01-15	2010-01-15 00:00:00	2010-01-15	2010-01-15 00:00:00	2010-01-15	581452		0	0	0		0	0	0	114641	0	133	40213198		
231053	5077	40213160	1965-11-24	1965-11-24 00:00:00	1965-11-24	1965-11-24 00:00:00	1965-11-24	581452		0	0	0		0	0	0	337477	0	10	40213160		
45864	3796	1127433	1986-05-22	1986-05-22 00:00:00	1986-06-05	1986-06-05 00:00:00	1986-06-05	38000177		0	0	14		0	0	0	252356	0	313782	1127433		
12035	1005	1154615	1970-02-27	1970-02-27 00:00:00	1986-07-22	1986-07-22 00:00:00	1986-07-22	38000177		0	0	5989		0	0	0	66404	0	745679	1154615		
146154	3215	40213160	1978-01-09	1978-01-09 00:00:00	1978-01-09	1978-01-09 00:00:00	1978-01-09	581452		0	0	0		0	0	0	213582	0	10	40213160		
44558	3689	40163554	2011-04-04	2011-04-04 00:00:00	2011-04-04	2011-04-04 00:00:00	\N	38000177		0	0	0		0	0	0	245243	0	855332	40163554		
162916	3582	40213227	2007-06-03	2007-06-03 00:00:00	2007-06-03	2007-06-03 00:00:00	2007-06-03	581452		0	0	0		0	0	0	238132	0	113	40213227		
11831	254	40213227	2001-10-19	2001-10-19 00:00:00	2001-10-19	2001-10-19 00:00:00	2001-10-19	581452		0	0	0		0	0	0	16954	0	113	40213227		
49407	1082	40213227	1997-08-30	1997-08-30 00:00:00	1997-08-30	1997-08-30 00:00:00	1997-08-30	581452		0	0	0		0	0	0	71015	0	113	40213227		
49231	4085	1124300	1998-03-13	1998-03-13 00:00:00	1998-03-13	1998-03-13 00:00:00	\N	38000177		0	0	0		0	0	0	271541	0	00781178901	45011828		
33599	2780	1127433	2008-02-07	2008-02-07 00:00:00	2008-02-14	2008-02-14 00:00:00	2008-02-14	38000177		0	0	7		0	0	0	184237	0	313782	1127433		
17478	1446	19019979	1985-06-06	1985-06-06 00:00:00	1985-06-20	1985-06-20 00:00:00	1985-06-20	38000177		0	0	14		0	0	0	96397	0	198405	19019979		
15938	1322	1713671	1946-07-07	1946-07-07 00:00:00	1946-07-14	1946-07-14 00:00:00	1946-07-14	38000177		0	0	7		0	0	0	87793	0	562251	1713671		
10975	915	1127433	2012-08-03	2012-08-03 00:00:00	2012-08-17	2012-08-17 00:00:00	2012-08-17	38000177		0	0	14		0	0	0	60787	0	313782	1127433		
16031	1328	19078461	1980-12-31	1980-12-31 00:00:00	1981-02-04	1981-02-04 00:00:00	1981-02-04	38000177		0	0	35		0	0	0	88157	0	310965	19078461		
26526	2184	19059056	1969-02-16	1969-02-16 00:00:00	1969-03-02	1969-03-02 00:00:00	1969-03-02	38000177		0	0	14		0	0	0	145598	0	243670	19059056		
61030	1333	40213260	2007-02-25	2007-02-25 00:00:00	2007-02-25	2007-02-25 00:00:00	2007-02-25	581452		0	0	0		0	0	0	88448	0	121	40213260		
29944	2481	1713671	1990-02-07	1990-02-07 00:00:00	1990-02-28	1990-02-28 00:00:00	1990-02-28	38000177		0	0	21		0	0	0	164407	0	562251	1713671		
63342	1385	40213260	2010-05-14	2010-05-14 00:00:00	2010-05-14	2010-05-14 00:00:00	2010-05-14	581452		0	0	0		0	0	0	91860	0	121	40213260		
226006	4963	40213314	1977-04-18	1977-04-18 00:00:00	1977-04-18	1977-04-18 00:00:00	1977-04-18	581452		0	0	0		0	0	0	329892	0	49	40213314		
19176	1585	19059056	1969-09-15	1969-09-15 00:00:00	1969-10-06	1969-10-06 00:00:00	1969-10-06	38000177		0	0	21		0	0	0	106349	0	243670	19059056		
22064	1813	19073183	1984-04-05	1984-04-05 00:00:00	1984-04-19	1984-04-19 00:00:00	1984-04-19	38000177		0	0	14		0	0	0	121351	0	308182	19073183		
232684	5113	40213227	2011-03-26	2011-03-26 00:00:00	2011-03-26	2011-03-26 00:00:00	2011-03-26	581452		0	0	0		0	0	0	339696	0	113	40213227		
47824	3966	19128065	1988-10-25	1988-10-25 00:00:00	1989-10-20	1989-10-20 00:00:00	1989-10-20	38000177		0	0	360		0	0	0	263689	0	749882	19128065		
58304	4844	1127078	1960-02-21	1960-02-21 00:00:00	1960-03-06	1960-03-06 00:00:00	1960-03-06	38000177		0	0	14		0	0	0	322278	0	282464	1127078		
106226	2330	40213314	1978-06-26	1978-06-26 00:00:00	1978-06-26	1978-06-26 00:00:00	1978-06-26	581452		0	0	0		0	0	0	154990	0	49	40213314		
41067	3407	1713671	2002-02-05	2002-02-05 00:00:00	2002-02-19	2002-02-19 00:00:00	2002-02-19	38000177		0	0	14		0	0	0	225934	0	562251	1713671		
37602	820	40213260	2014-05-22	2014-05-22 00:00:00	2014-05-22	2014-05-22 00:00:00	2014-05-22	581452		0	0	0		0	0	0	54302	0	121	40213260		
4331	359	1118084	2014-10-28	2014-10-28 00:00:00	2014-10-28	2014-10-28 00:00:00	\N	38000177		0	0	0		0	0	0	23924	0	00025152531	44923712		
53527	4450	40162522	2015-04-16	2015-04-16 00:00:00	2015-04-16	2015-04-16 00:00:00	\N	38000177		0	0	0		0	0	0	296086	0	857005	40162522		
51716	4297	40236824	2019-02-09	2019-02-09 00:00:00	2019-02-16	2019-02-16 00:00:00	2019-02-16	38000177		0	0	7		0	0	0	285198	0	1094107	40236824		
64080	5322	1713671	2014-06-28	2014-06-28 00:00:00	2014-07-12	2014-07-12 00:00:00	2014-07-12	38000177		0	0	14		0	0	0	354157	0	562251	1713671		
9812	821	1127433	2008-11-15	2008-11-15 00:00:00	2008-11-29	2008-11-29 00:00:00	2008-11-29	38000177		0	0	14		0	0	0	54382	0	313782	1127433		
6189	518	19059056	1974-04-01	1974-04-01 00:00:00	1974-04-15	1974-04-15 00:00:00	1974-04-15	38000177		0	0	14		0	0	0	34601	0	243670	19059056		
137570	3019	40213160	1977-10-12	1977-10-12 00:00:00	1977-10-12	1977-10-12 00:00:00	1977-10-12	581452		0	0	0		0	0	0	201356	0	10	40213160		
50220	1100	40213160	1983-01-05	1983-01-05 00:00:00	1983-01-05	1983-01-05 00:00:00	1983-01-05	581452		0	0	0		0	0	0	72262	0	10	40213160		
19456	1604	19059056	1958-12-08	1958-12-08 00:00:00	1958-12-22	1958-12-22 00:00:00	1958-12-22	38000177		0	0	14		0	0	0	107611	0	243670	19059056		
36916	3053	1118084	2018-07-24	2018-07-24 00:00:00	2018-07-24	2018-07-24 00:00:00	\N	38000177		0	0	0		0	0	0	203129	0	00025152531	44923712		
116540	2561	40213160	1977-04-06	1977-04-06 00:00:00	1977-04-06	1977-04-06 00:00:00	1977-04-06	581452		0	0	0		0	0	0	169676	0	10	40213160		
47497	3938	920300	1938-04-26	1938-04-26 00:00:00	1938-05-03	1938-05-03 00:00:00	1938-05-03	38000177		0	0	7		0	0	0	261702	0	311989	920300		
47545	3941	40236824	1992-02-10	1992-02-10 00:00:00	1992-02-17	1992-02-17 00:00:00	1992-02-17	38000177		0	0	7		0	0	0	262039	0	1094107	40236824		
9123	758	40229134	2000-05-04	2000-05-04 00:00:00	2000-05-11	2000-05-11 00:00:00	2000-05-11	38000177		0	0	7		0	0	0	50316	0	1043400	40229134		
224270	4923	40213296	2010-10-19	2010-10-19 00:00:00	2010-10-19	2010-10-19 00:00:00	2010-10-19	581452		0	0	0		0	0	0	327105	0	52	40213296		
113713	2498	40213160	1971-12-18	1971-12-18 00:00:00	1971-12-18	1971-12-18 00:00:00	1971-12-18	581452		0	0	0		0	0	0	165378	0	10	40213160		
167178	3675	40213160	1967-09-25	1967-09-25 00:00:00	1967-09-25	1967-09-25 00:00:00	1967-09-25	581452		0	0	0		0	0	0	244438	0	10	40213160		
2386	191	40223768	1997-10-14	1997-10-14 00:00:00	1997-10-14	1997-10-14 00:00:00	\N	38000177		0	0	0		0	0	0	13026	0	997223	40223768		
7955	665	19073188	1993-01-08	1993-01-08 00:00:00	1993-01-22	1993-01-22 00:00:00	1993-01-22	38000177		0	0	14		0	0	0	43940	0	308192	19073188		
27175	592	40213160	1970-03-06	1970-03-06 00:00:00	1970-03-06	1970-03-06 00:00:00	1970-03-06	581452		0	0	0		0	0	0	39119	0	10	40213160		
39599	3275	40236824	1997-05-01	1997-05-01 00:00:00	1997-05-08	1997-05-08 00:00:00	1997-05-08	38000177		0	0	7		0	0	0	217611	0	1094107	40236824		
57587	4781	1118084	2018-05-16	2018-05-16 00:00:00	2018-05-16	2018-05-16 00:00:00	\N	38000177		0	0	0		0	0	0	318279	0	00025152531	44923712		
60287	5014	19059056	1936-01-11	1936-01-11 00:00:00	1936-02-01	1936-02-01 00:00:00	1936-02-01	38000177		0	0	21		0	0	0	333251	0	243670	19059056		
144429	3175	40213260	2006-02-21	2006-02-21 00:00:00	2006-02-21	2006-02-21 00:00:00	2006-02-21	581452		0	0	0		0	0	0	211058	0	121	40213260		
23653	1946	1713671	1960-01-06	1960-01-06 00:00:00	1960-01-13	1960-01-13 00:00:00	1960-01-13	38000177		0	0	7		0	0	0	129272	0	562251	1713671		
155774	3428	40213260	2016-05-25	2016-05-25 00:00:00	2016-05-25	2016-05-25 00:00:00	2016-05-25	581452		0	0	0		0	0	0	227284	0	121	40213260		
51845	4309	1713671	1961-07-03	1961-07-03 00:00:00	1961-07-24	1961-07-24 00:00:00	1961-07-24	38000177		0	0	21		0	0	0	285893	0	562251	1713671		
57227	4750	1118084	2000-05-15	2000-05-15 00:00:00	2000-05-15	2000-05-15 00:00:00	\N	38000177		0	0	0		0	0	0	316296	0	00025152531	44923712		
51943	4320	35605858	1970-05-14	1970-05-14 00:00:00	1970-05-14	1970-05-14 00:00:00	1970-05-14	38000177		0	0	0		0	0	0	286692	0	1732136	35605858		
135123	2965	40213227	1992-09-28	1992-09-28 00:00:00	1992-09-28	1992-09-28 00:00:00	1992-09-28	581452		0	0	0		0	0	0	197940	0	113	40213227		
62510	5199	40229134	2010-01-27	2010-01-27 00:00:00	2010-02-10	2010-02-10 00:00:00	2010-02-10	38000177		0	0	14		0	0	0	345775	0	1043400	40229134		
39382	3253	19128065	1991-04-09	1991-04-09 00:00:00	1992-04-03	1992-04-03 00:00:00	1992-04-03	38000177		0	0	360		0	0	0	216252	0	749882	19128065		
42067	3488	1127433	1990-04-05	1990-04-05 00:00:00	1990-04-12	1990-04-12 00:00:00	1990-04-12	38000177		0	0	7		0	0	0	231417	0	313782	1127433		
3968	331	1713671	1937-06-27	1937-06-27 00:00:00	1937-07-18	1937-07-18 00:00:00	1937-07-18	38000177		0	0	21		0	0	0	21814	0	562251	1713671		
19081	1576	19073188	1982-02-20	1982-02-20 00:00:00	1982-03-27	1982-03-27 00:00:00	1982-03-27	38000177		0	0	35		0	0	0	105774	0	308192	19073188		
30862	2555	19133873	1958-02-26	1958-02-26 00:00:00	1958-03-06	1958-03-06 00:00:00	1958-03-06	38000177		0	0	8		0	0	0	169320	0	834061	19133873		
78462	1716	40213227	1995-10-27	1995-10-27 00:00:00	1995-10-27	1995-10-27 00:00:00	1995-10-27	581452		0	0	0		0	0	0	114664	0	113	40213227		
231054	5077	40213160	1970-02-25	1970-02-25 00:00:00	1970-02-25	1970-02-25 00:00:00	1970-02-25	581452		0	0	0		0	0	0	337456	0	10	40213160		
45865	3796	19059056	1971-12-23	1971-12-23 00:00:00	1972-01-06	1972-01-06 00:00:00	1972-01-06	38000177		0	0	14		0	0	0	252355	0	243670	19059056		
12036	1005	40165015	1989-03-04	1989-03-04 00:00:00	1989-03-04	1989-03-04 00:00:00	\N	38000177		0	0	0		0	0	0	66407	0	861467	40165015		
146155	3215	40213314	1978-01-09	1978-01-09 00:00:00	1978-01-09	1978-01-09 00:00:00	1978-01-09	581452		0	0	0		0	0	0	213582	0	49	40213314		
44565	3691	1118084	1991-01-16	1991-01-16 00:00:00	1991-01-16	1991-01-16 00:00:00	\N	38000177		0	0	0		0	0	0	245342	0	00025152531	44923712		
162917	3582	40213260	2007-06-03	2007-06-03 00:00:00	2007-06-03	2007-06-03 00:00:00	2007-06-03	581452		0	0	0		0	0	0	238132	0	121	40213260		
22202	482	40213296	2013-05-02	2013-05-02 00:00:00	2013-05-02	2013-05-02 00:00:00	2013-05-02	581452		0	0	0		0	0	0	32242	0	52	40213296		
49416	1082	40213227	2007-01-06	2007-01-06 00:00:00	2007-01-06	2007-01-06 00:00:00	2007-01-06	581452		0	0	0		0	0	0	70920	0	113	40213227		
49232	4085	19133905	1997-09-04	1997-09-04 00:00:00	1997-09-13	1997-09-13 00:00:00	1997-09-13	38000177		0	0	9		0	0	0	271541	0	834102	19133905		
33600	2780	40229134	1993-12-13	1993-12-13 00:00:00	1993-12-20	1993-12-20 00:00:00	1993-12-20	38000177		0	0	7		0	0	0	184209	0	1043400	40229134		
17479	1446	1124300	2017-08-09	2017-08-09 00:00:00	2017-08-09	2017-08-09 00:00:00	\N	38000177		0	0	0		0	0	0	96396	0	00781178901	45011828		
15939	1322	40173590	2003-08-13	2003-08-13 00:00:00	2003-08-13	2003-08-13 00:00:00	\N	38000177		0	0	0		0	0	0	87686	0	904419	40173590		
10976	915	1127433	2010-01-27	2010-01-27 00:00:00	2010-02-10	2010-02-10 00:00:00	2010-02-10	38000177		0	0	14		0	0	0	60866	0	313782	1127433		
16032	1328	19133905	2010-04-08	2010-04-08 00:00:00	2010-04-18	2010-04-18 00:00:00	2010-04-18	38000177		0	0	10		0	0	0	88224	0	834102	19133905		
26527	2184	19133873	1973-01-15	1973-01-15 00:00:00	1973-01-23	1973-01-23 00:00:00	1973-01-23	38000177		0	0	8		0	0	0	145594	0	834061	19133873		
61032	1333	40213160	1955-06-12	1955-06-12 00:00:00	1955-06-12	1955-06-12 00:00:00	1955-06-12	581452		0	0	0		0	0	0	88469	0	10	40213160		
29945	2481	1124300	2004-09-24	2004-09-24 00:00:00	2004-09-24	2004-09-24 00:00:00	\N	38000177		0	0	0		0	0	0	164417	0	00781178901	45011828		
63355	1385	40213160	1960-08-19	1960-08-19 00:00:00	1960-08-19	1960-08-19 00:00:00	1960-08-19	581452		0	0	0		0	0	0	91845	0	10	40213160		
226009	4963	40213227	2004-07-26	2004-07-26 00:00:00	2004-07-26	2004-07-26 00:00:00	2004-07-26	581452		0	0	0		0	0	0	329926	0	113	40213227		
19177	1585	19133873	1942-09-30	1942-09-30 00:00:00	1942-10-08	1942-10-08 00:00:00	1942-10-08	38000177		0	0	8		0	0	0	106298	0	834061	19133873		
22065	1813	1127078	1984-04-05	1984-04-05 00:00:00	1984-04-19	1984-04-19 00:00:00	1984-04-19	38000177		0	0	14		0	0	0	121351	0	282464	1127078		
232685	5113	40213296	2011-03-26	2011-03-26 00:00:00	2011-03-26	2011-03-26 00:00:00	2011-03-26	581452		0	0	0		0	0	0	339696	0	52	40213296		
47825	3966	1713671	2001-06-02	2001-06-02 00:00:00	2001-06-09	2001-06-09 00:00:00	2001-06-09	38000177		0	0	7		0	0	0	263706	0	562251	1713671		
58305	4844	40229134	1970-05-30	1970-05-30 00:00:00	1970-06-13	1970-06-13 00:00:00	1970-06-13	38000177		0	0	14		0	0	0	322200	0	1043400	40229134		
106230	2330	40213160	1975-10-27	1975-10-27 00:00:00	1975-10-27	1975-10-27 00:00:00	1975-10-27	581452		0	0	0		0	0	0	154960	0	10	40213160		
41068	3407	1118084	2005-08-02	2005-08-02 00:00:00	2005-08-02	2005-08-02 00:00:00	\N	38000177		0	0	0		0	0	0	225966	0	00025152531	44923712		
37607	821	40213201	2015-01-03	2015-01-03 00:00:00	2015-01-03	2015-01-03 00:00:00	2015-01-03	581452		0	0	0		0	0	0	54393	0	33	40213201		
4332	359	1127433	1992-06-05	1992-06-05 00:00:00	1992-06-19	1992-06-19 00:00:00	1992-06-19	38000177		0	0	14		0	0	0	23909	0	313782	1127433		
53528	4450	1127433	2008-01-09	2008-01-09 00:00:00	2008-01-23	2008-01-23 00:00:00	2008-01-23	38000177		0	0	14		0	0	0	296085	0	313782	1127433		
51717	4297	920300	2019-02-09	2019-02-09 00:00:00	2019-02-16	2019-02-16 00:00:00	2019-02-16	38000177		0	0	7		0	0	0	285198	0	311989	920300		
64081	5322	19008572	1958-04-03	1958-04-03 00:00:00	1958-04-17	1958-04-17 00:00:00	1958-04-17	38000177		0	0	14		0	0	0	354267	0	106258	19008572		
9813	821	1118084	1985-01-24	1985-01-24 00:00:00	1985-01-24	1985-01-24 00:00:00	\N	38000177		0	0	0		0	0	0	54372	0	00025152531	44923712		
6190	518	19133873	1982-05-14	1982-05-14 00:00:00	1982-05-22	1982-05-22 00:00:00	1982-05-22	38000177		0	0	8		0	0	0	34613	0	834061	19133873		
137575	3020	40213296	1997-01-08	1997-01-08 00:00:00	1997-01-08	1997-01-08 00:00:00	1997-01-08	581452		0	0	0		0	0	0	201401	0	52	40213296		
8915	743	40231925	1991-11-08	1991-11-08 00:00:00	1991-11-08	1991-11-08 00:00:00	\N	38000177		0	0	0		0	0	0	49243	0	1049221	40231925		
19457	1604	19006318	1958-12-08	1958-12-08 00:00:00	1958-12-22	1958-12-22 00:00:00	1958-12-22	38000177		0	0	14		0	0	0	107611	0	105078	19006318		
36917	3053	40236824	2014-02-03	2014-02-03 00:00:00	2014-02-17	2014-02-17 00:00:00	2014-02-17	38000177		0	0	14		0	0	0	203096	0	1094107	40236824		
140488	3084	40213160	1978-08-02	1978-08-02 00:00:00	1978-08-02	1978-08-02 00:00:00	1978-08-02	581452		0	0	0		0	0	0	205387	0	10	40213160		
47498	3938	920334	1938-05-03	1938-05-03 00:00:00	1938-05-10	1938-05-10 00:00:00	1938-05-10	38000177		0	0	7		0	0	0	261703	0	311995	920334		
47548	3941	1127433	1963-12-19	1963-12-19 00:00:00	1964-01-02	1964-01-02 00:00:00	1964-01-02	38000177		0	0	14		0	0	0	261998	0	313782	1127433		
9124	759	19133905	1980-08-22	1980-08-22 00:00:00	1980-09-02	1980-09-02 00:00:00	1980-09-02	38000177		0	0	11		0	0	0	50445	0	834102	19133905		
224272	4923	40213227	2010-10-19	2010-10-19 00:00:00	2010-10-19	2010-10-19 00:00:00	2010-10-19	581452		0	0	0		0	0	0	327105	0	113	40213227		
147627	3246	40213314	1980-03-31	1980-03-31 00:00:00	1980-03-31	1980-03-31 00:00:00	1980-03-31	581452		0	0	0		0	0	0	215807	0	49	40213314		
167182	3675	40213227	1998-09-21	1998-09-21 00:00:00	1998-09-21	1998-09-21 00:00:00	1998-09-21	581452		0	0	0		0	0	0	244468	0	113	40213227		
2387	191	40236824	1958-06-19	1958-06-19 00:00:00	1958-06-26	1958-06-26 00:00:00	1958-06-26	38000177		0	0	7		0	0	0	13022	0	1094107	40236824		
7956	665	1127433	1993-01-08	1993-01-08 00:00:00	1993-01-22	1993-01-22 00:00:00	1993-01-22	38000177		0	0	14		0	0	0	43940	0	313782	1127433		
27181	592	40213306	1993-09-03	1993-09-03 00:00:00	1993-09-03	1993-09-03 00:00:00	1993-09-03	581452		0	0	0		0	0	0	39124	0	43	40213306		
39600	3275	920300	1997-05-01	1997-05-01 00:00:00	1997-05-08	1997-05-08 00:00:00	1997-05-08	38000177		0	0	7		0	0	0	217611	0	311989	920300		
57588	4782	40229134	2004-05-18	2004-05-18 00:00:00	2004-05-25	2004-05-25 00:00:00	2004-05-25	38000177		0	0	7		0	0	0	318366	0	1043400	40229134		
60288	5014	19133873	1921-09-11	1921-09-11 00:00:00	1921-09-19	1921-09-19 00:00:00	1921-09-19	38000177		0	0	8		0	0	0	333234	0	834061	19133873		
144430	3175	40213160	1955-11-01	1955-11-01 00:00:00	1955-11-01	1955-11-01 00:00:00	1955-11-01	581452		0	0	0		0	0	0	211011	0	10	40213160		
23654	1946	1713671	1927-10-24	1927-10-24 00:00:00	1927-11-14	1927-11-14 00:00:00	1927-11-14	38000177		0	0	21		0	0	0	129314	0	562251	1713671		
155778	3428	40213227	1997-10-01	1997-10-01 00:00:00	1997-10-01	1997-10-01 00:00:00	1997-10-01	581452		0	0	0		0	0	0	227275	0	113	40213227		
51857	4312	19008572	1971-07-19	1971-07-19 00:00:00	1971-08-02	1971-08-02 00:00:00	1971-08-02	38000177		0	0	14		0	0	0	286141	0	106258	19008572		
57228	4750	40232448	1968-04-29	1968-04-29 00:00:00	1968-04-29	1968-04-29 00:00:00	\N	38000177		0	0	0		0	0	0	316357	0	1049630	40232448		
51944	4320	19078924	1970-05-14	1970-05-14 00:00:00	1970-05-14	1970-05-14 00:00:00	1970-05-14	38000177		0	0	0		0	0	0	286692	0	311700	19078924		
135124	2965	40213306	1992-09-28	1992-09-28 00:00:00	1992-09-28	1992-09-28 00:00:00	1992-09-28	581452		0	0	0		0	0	0	197940	0	43	40213306		
62511	5199	19128065	1987-11-11	1987-11-11 00:00:00	1988-11-05	1988-11-05 00:00:00	1988-11-05	38000177		0	0	360		0	0	0	345792	0	749882	19128065		
39383	3253	19008572	1989-08-17	1989-08-17 00:00:00	1989-09-07	1989-09-07 00:00:00	1989-09-07	38000177		0	0	21		0	0	0	216372	0	106258	19008572		
42068	3488	40169281	1991-08-02	1991-08-02 00:00:00	1991-08-02	1991-08-02 00:00:00	\N	38000177		0	0	0		0	0	0	231343	0	896209	40169281		
3969	331	19059056	1948-08-28	1948-08-28 00:00:00	1948-10-02	1948-10-02 00:00:00	1948-10-02	38000177		0	0	35		0	0	0	21809	0	243670	19059056		
19082	1576	1127433	1982-02-20	1982-02-20 00:00:00	1982-03-27	1982-03-27 00:00:00	1982-03-27	38000177		0	0	35		0	0	0	105774	0	313782	1127433		
35253	2906	19059056	1929-12-26	1929-12-26 00:00:00	1930-01-09	1930-01-09 00:00:00	1930-01-09	38000177		0	0	14		0	0	0	193628	0	243670	19059056		
87436	1918	40213160	1969-01-18	1969-01-18 00:00:00	1969-01-18	1969-01-18 00:00:00	1969-01-18	581452		0	0	0		0	0	0	127621	0	10	40213160		
231067	5077	40213227	1997-08-06	1997-08-06 00:00:00	1997-08-06	1997-08-06 00:00:00	1997-08-06	581452		0	0	0		0	0	0	337437	0	113	40213227		
45866	3796	19078461	1992-10-31	1992-10-31 00:00:00	1992-11-21	1992-11-21 00:00:00	1992-11-21	38000177		0	0	21		0	0	0	252357	0	310965	19078461		
12037	1005	1127433	2008-10-15	2008-10-15 00:00:00	2008-10-22	2008-10-22 00:00:00	2008-10-22	38000177		0	0	7		0	0	0	66440	0	313782	1127433		
146160	3215	40213160	1978-06-12	1978-06-12 00:00:00	1978-06-12	1978-06-12 00:00:00	1978-06-12	581452		0	0	0		0	0	0	213583	0	10	40213160		
44566	3691	1127433	2011-06-23	2011-06-23 00:00:00	2011-09-21	2011-09-21 00:00:00	2011-09-21	38000177		0	0	90		0	0	0	245331	0	313782	1127433		
162920	3582	40213160	1956-09-02	1956-09-02 00:00:00	1956-09-02	1956-09-02 00:00:00	1956-09-02	581452		0	0	0		0	0	0	238152	0	10	40213160		
22203	482	40213160	1970-01-29	1970-01-29 00:00:00	1970-01-29	1970-01-29 00:00:00	1970-01-29	581452		0	0	0		0	0	0	32234	0	10	40213160		
49417	1082	40213260	2007-01-06	2007-01-06 00:00:00	2007-01-06	2007-01-06 00:00:00	2007-01-06	581452		0	0	0		0	0	0	70920	0	121	40213260		
60219	1317	40213160	1955-04-15	1955-04-15 00:00:00	1955-04-15	1955-04-15 00:00:00	1955-04-15	581452		0	0	0		0	0	0	87269	0	10	40213160		
33601	2780	19006318	1960-04-10	1960-04-10 00:00:00	1960-04-24	1960-04-24 00:00:00	1960-04-24	38000177		0	0	14		0	0	0	184238	0	105078	19006318		
17480	1446	1127433	2003-10-17	2003-10-17 00:00:00	2003-11-21	2003-11-21 00:00:00	2003-11-21	38000177		0	0	35		0	0	0	96376	0	313782	1127433		
15940	1322	19133873	1937-06-18	1937-06-18 00:00:00	1937-06-25	1937-06-25 00:00:00	1937-06-25	38000177		0	0	7		0	0	0	87791	0	834061	19133873		
10977	915	1118084	1995-08-04	1995-08-04 00:00:00	1995-08-04	1995-08-04 00:00:00	\N	38000177		0	0	0		0	0	0	60795	0	00025152531	44923712		
16033	1328	1127433	1980-11-16	1980-11-16 00:00:00	1980-11-30	1980-11-30 00:00:00	1980-11-30	38000177		0	0	14		0	0	0	88222	0	313782	1127433		
26528	2184	1127433	1993-05-27	1993-05-27 00:00:00	1993-06-17	1993-06-17 00:00:00	1993-06-17	38000177		0	0	21		0	0	0	145588	0	313782	1127433		
61039	1334	40213227	2000-05-07	2000-05-07 00:00:00	2000-05-07	2000-05-07 00:00:00	2000-05-07	581452		0	0	0		0	0	0	88514	0	113	40213227		
29946	2481	1713671	2007-12-21	2007-12-21 00:00:00	2008-01-11	2008-01-11 00:00:00	2008-01-11	38000177		0	0	21		0	0	0	164409	0	562251	1713671		
221491	4860	40213314	1979-03-09	1979-03-09 00:00:00	1979-03-09	1979-03-09 00:00:00	1979-03-09	581452		0	0	0		0	0	0	323325	0	49	40213314		
226010	4963	40213160	1973-08-20	1973-08-20 00:00:00	1973-08-20	1973-08-20 00:00:00	1973-08-20	581452		0	0	0		0	0	0	329890	0	10	40213160		
19178	1585	1127433	1953-12-30	1953-12-30 00:00:00	1954-01-13	1954-01-13 00:00:00	1954-01-13	38000177		0	0	14		0	0	0	106256	0	313782	1127433		
22066	1814	1127433	1991-05-30	1991-05-30 00:00:00	1991-06-06	1991-06-06 00:00:00	1991-06-06	38000177		0	0	7		0	0	0	121442	0	313782	1127433		
232688	5113	40213160	1969-08-23	1969-08-23 00:00:00	1969-08-23	1969-08-23 00:00:00	1969-08-23	581452		0	0	0		0	0	0	339682	0	10	40213160		
47826	3966	1124300	2003-05-20	2003-05-20 00:00:00	2003-05-20	2003-05-20 00:00:00	\N	38000177		0	0	0		0	0	0	263706	0	00781178901	45011828		
58306	4844	1551192	1978-03-27	1978-03-27 00:00:00	1978-03-27	1978-03-27 00:00:00	1978-03-27	38000177		0	0	0		0	0	0	322282	0	312617	1551192		
131748	2895	40213160	1962-02-18	1962-02-18 00:00:00	1962-02-18	1962-02-18 00:00:00	1962-02-18	581452		0	0	0		0	0	0	192724	0	10	40213160		
41069	3407	19133873	1966-11-09	1966-11-09 00:00:00	1966-11-19	1966-11-19 00:00:00	1966-11-19	38000177		0	0	10		0	0	0	225980	0	834061	19133873		
37615	821	40213227	1993-03-27	1993-03-27 00:00:00	1993-03-27	1993-03-27 00:00:00	1993-03-27	581452		0	0	0		0	0	0	54434	0	113	40213227		
4333	359	19133873	1990-06-12	1990-06-12 00:00:00	1990-06-23	1990-06-23 00:00:00	1990-06-23	38000177		0	0	11		0	0	0	23874	0	834061	19133873		
53529	4450	19133873	1975-12-11	1975-12-11 00:00:00	1975-12-21	1975-12-21 00:00:00	1975-12-21	38000177		0	0	10		0	0	0	296091	0	834061	19133873		
51718	4297	40229134	1977-12-13	1977-12-13 00:00:00	1977-12-27	1977-12-27 00:00:00	1977-12-27	38000177		0	0	14		0	0	0	285185	0	1043400	40229134		
64082	5322	1127433	2014-03-18	2014-03-18 00:00:00	2014-05-17	2014-05-17 00:00:00	2014-05-17	38000177		0	0	60		0	0	0	354264	0	313782	1127433		
9814	821	19133873	1956-11-30	1956-11-30 00:00:00	1956-12-09	1956-12-09 00:00:00	1956-12-09	38000177		0	0	9		0	0	0	54379	0	834061	19133873		
6191	518	46233988	1971-01-26	1971-01-26 00:00:00	1971-02-09	1971-02-09 00:00:00	1971-02-09	38000177		0	0	14		0	0	0	34596	0	1652673	46233988		
137582	3020	40213160	1961-12-13	1961-12-13 00:00:00	1961-12-13	1961-12-13 00:00:00	1961-12-13	581452		0	0	0		0	0	0	201425	0	10	40213160		
8916	744	19006318	1954-09-01	1954-09-01 00:00:00	1954-09-15	1954-09-15 00:00:00	1954-09-15	38000177		0	0	14		0	0	0	49315	0	105078	19006318		
19458	1604	19059056	1957-10-25	1957-10-25 00:00:00	1957-11-08	1957-11-08 00:00:00	1957-11-08	38000177		0	0	14		0	0	0	107656	0	243670	19059056		
36918	3053	920300	2014-02-03	2014-02-03 00:00:00	2014-02-10	2014-02-10 00:00:00	2014-02-10	38000177		0	0	7		0	0	0	203096	0	311989	920300		
140493	3084	40213227	2009-04-15	2009-04-15 00:00:00	2009-04-15	2009-04-15 00:00:00	2009-04-15	581452		0	0	0		0	0	0	205379	0	113	40213227		
47499	3938	19059056	1969-07-11	1969-07-11 00:00:00	1969-07-25	1969-07-25 00:00:00	1969-07-25	38000177		0	0	14		0	0	0	261742	0	243670	19059056		
47549	3941	1118084	1999-08-01	1999-08-01 00:00:00	1999-08-01	1999-08-01 00:00:00	\N	38000177		0	0	0		0	0	0	262017	0	00025152531	44923712		
9125	759	1127433	1948-12-14	1948-12-14 00:00:00	1948-12-21	1948-12-21 00:00:00	1948-12-21	38000177		0	0	7		0	0	0	50372	0	313782	1127433		
224277	4923	40213160	1969-03-25	1969-03-25 00:00:00	1969-03-25	1969-03-25 00:00:00	1969-03-25	581452		0	0	0		0	0	0	327100	0	10	40213160		
147628	3246	40213160	1980-03-31	1980-03-31 00:00:00	1980-03-31	1980-03-31 00:00:00	1980-03-31	581452		0	0	0		0	0	0	215807	0	10	40213160		
52273	1144	40213227	2002-07-07	2002-07-07 00:00:00	2002-07-07	2002-07-07 00:00:00	2002-07-07	581452		0	0	0		0	0	0	75494	0	113	40213227		
2388	191	1124300	1960-04-07	1960-04-07 00:00:00	1960-04-07	1960-04-07 00:00:00	\N	38000177		0	0	0		0	0	0	13022	0	00781178901	45011828		
7957	665	1118084	1993-08-10	1993-08-10 00:00:00	1993-08-10	1993-08-10 00:00:00	\N	38000177		0	0	0		0	0	0	43992	0	00025152531	44923712		
120916	2657	40213306	1988-02-13	1988-02-13 00:00:00	1988-02-13	1988-02-13 00:00:00	1988-02-13	581452		0	0	0		0	0	0	175970	0	43	40213306		
39601	3275	40236824	2003-06-17	2003-06-17 00:00:00	2003-06-24	2003-06-24 00:00:00	2003-06-24	38000177		0	0	7		0	0	0	217649	0	1094107	40236824		
57589	4782	19133905	2018-03-17	2018-03-17 00:00:00	2018-03-24	2018-03-24 00:00:00	2018-03-24	38000177		0	0	7		0	0	0	318324	0	834102	19133905		
60289	5014	19059056	1943-02-24	1943-02-24 00:00:00	1943-05-02	1943-05-02 00:00:00	1943-05-02	38000177		0	0	67		0	0	0	333253	0	243670	19059056		
144435	3175	40213260	2007-02-27	2007-02-27 00:00:00	2007-02-27	2007-02-27 00:00:00	2007-02-27	581452		0	0	0		0	0	0	211073	0	121	40213260		
23655	1947	19059056	1956-05-22	1956-05-22 00:00:00	1956-08-20	1956-08-20 00:00:00	1956-08-20	38000177		0	0	90		0	0	0	129465	0	243670	19059056		
155786	3428	40213306	1988-09-21	1988-09-21 00:00:00	1988-09-21	1988-09-21 00:00:00	1988-09-21	581452		0	0	0		0	0	0	227297	0	43	40213306		
51858	4312	40229134	1994-04-02	1994-04-02 00:00:00	1994-04-16	1994-04-16 00:00:00	1994-04-16	38000177		0	0	14		0	0	0	286171	0	1043400	40229134		
57229	4750	40236824	1997-04-30	1997-04-30 00:00:00	1997-05-07	1997-05-07 00:00:00	1997-05-07	38000177		0	0	7		0	0	0	316367	0	1094107	40236824		
51945	4320	19079524	1970-05-14	1970-05-14 00:00:00	1970-05-15	1970-05-15 00:00:00	1970-05-15	38000177		0	0	1		0	0	0	286692	0	313002	19079524		
135127	2965	40213160	1970-06-01	1970-06-01 00:00:00	1970-06-01	1970-06-01 00:00:00	1970-06-01	581452		0	0	0		0	0	0	197979	0	10	40213160		
62512	5199	1127433	1974-08-21	1974-08-21 00:00:00	1974-09-04	1974-09-04 00:00:00	1974-09-04	38000177		0	0	14		0	0	0	345779	0	313782	1127433		
39384	3253	19134077	1989-08-17	1989-08-17 00:00:00	1989-09-07	1989-09-07 00:00:00	1989-09-07	38000177		0	0	21		0	0	0	216372	0	835900	19134077		
42069	3488	1124300	1992-05-30	1992-05-30 00:00:00	1992-05-30	1992-05-30 00:00:00	\N	38000177		0	0	0		0	0	0	231343	0	00781178901	45011828		
3970	331	40229134	2004-03-27	2004-03-27 00:00:00	2004-04-03	2004-04-03 00:00:00	2004-04-03	38000177		0	0	7		0	0	0	21824	0	1043400	40229134		
19083	1576	1713671	1986-03-01	1986-03-01 00:00:00	1986-03-22	1986-03-22 00:00:00	1986-03-22	38000177		0	0	21		0	0	0	105802	0	562251	1713671		
35254	2906	19133905	1962-10-04	1962-10-04 00:00:00	1962-10-16	1962-10-16 00:00:00	1962-10-16	38000177		0	0	12		0	0	0	193616	0	834102	19133905		
87437	1918	40213260	2018-08-11	2018-08-11 00:00:00	2018-08-11	2018-08-11 00:00:00	2018-08-11	581452		0	0	0		0	0	0	127661	0	121	40213260		
231069	5077	40213227	2016-06-08	2016-06-08 00:00:00	2016-06-08	2016-06-08 00:00:00	2016-06-08	581452		0	0	0		0	0	0	337464	0	113	40213227		
45867	3796	1115171	2019-02-28	2019-02-28 00:00:00	2019-03-14	2019-03-14 00:00:00	2019-03-14	38000177		0	0	14		0	0	0	252414	0	849574	1115171		
12038	1005	19078461	1989-02-25	1989-02-25 00:00:00	1989-05-03	1989-05-03 00:00:00	1989-05-03	38000177		0	0	67		0	0	0	66473	0	310965	19078461		
146168	3215	40213296	2017-10-09	2017-10-09 00:00:00	2017-10-09	2017-10-09 00:00:00	2017-10-09	581452		0	0	0		0	0	0	213628	0	52	40213296		
38546	3183	1127433	1982-05-06	1982-05-06 00:00:00	1982-05-13	1982-05-13 00:00:00	1982-05-13	38000177		0	0	7		0	0	0	211929	0	313782	1127433		
162929	3582	40213160	1957-02-03	1957-02-03 00:00:00	1957-02-03	1957-02-03 00:00:00	1957-02-03	581452		0	0	0		0	0	0	238154	0	10	40213160		
22205	482	40213227	1994-05-19	1994-05-19 00:00:00	1994-05-19	1994-05-19 00:00:00	1994-05-19	581452		0	0	0		0	0	0	32208	0	113	40213227		
22224	482	40213227	2011-04-28	2011-04-28 00:00:00	2011-04-28	2011-04-28 00:00:00	2011-04-28	581452		0	0	0		0	0	0	32246	0	113	40213227		
60224	1317	40213160	1956-10-19	1956-10-19 00:00:00	1956-10-19	1956-10-19 00:00:00	1956-10-19	581452		0	0	0		0	0	0	87270	0	10	40213160		
33602	2780	19059056	1960-04-10	1960-04-10 00:00:00	1960-04-24	1960-04-24 00:00:00	1960-04-24	38000177		0	0	14		0	0	0	184238	0	243670	19059056		
17481	1446	19078461	2008-09-25	2008-09-25 00:00:00	2008-10-16	2008-10-16 00:00:00	2008-10-16	38000177		0	0	21		0	0	0	96378	0	310965	19078461		
15941	1322	1127433	1989-05-17	1989-05-17 00:00:00	1989-05-24	1989-05-24 00:00:00	1989-05-24	38000177		0	0	7		0	0	0	87720	0	313782	1127433		
10978	915	1713671	1987-07-27	1987-07-27 00:00:00	1987-08-17	1987-08-17 00:00:00	1987-08-17	38000177		0	0	21		0	0	0	60841	0	562251	1713671		
16034	1328	1127078	1953-04-15	1953-04-15 00:00:00	1953-05-13	1953-05-13 00:00:00	1953-05-13	38000177		0	0	28		0	0	0	88208	0	282464	1127078		
16053	1332	19126352	1999-08-04	1999-08-04 00:00:00	2019-01-02	2019-01-02 00:00:00	2019-01-02	38000177		0	0	7091		0	0	0	88397	0	705129	19126352		
233522	5132	40213227	2017-08-14	2017-08-14 00:00:00	2017-08-14	2017-08-14 00:00:00	2017-08-14	581452		0	0	0		0	0	0	341136	0	113	40213227		
29947	2481	19073188	2012-07-25	2012-07-25 00:00:00	2012-08-08	2012-08-08 00:00:00	2012-08-08	38000177		0	0	14		0	0	0	164375	0	308192	19073188		
221492	4860	40213160	1979-03-09	1979-03-09 00:00:00	1979-03-09	1979-03-09 00:00:00	1979-03-09	581452		0	0	0		0	0	0	323325	0	10	40213160		
226014	4963	40213160	1974-01-21	1974-01-21 00:00:00	1974-01-21	1974-01-21 00:00:00	1974-01-21	581452		0	0	0		0	0	0	329910	0	10	40213160		
40550	3362	19133873	1965-06-26	1965-06-26 00:00:00	1965-07-04	1965-07-04 00:00:00	1965-07-04	38000177		0	0	8		0	0	0	222882	0	834061	19133873		
22067	1814	19059056	1941-09-12	1941-09-12 00:00:00	1941-09-26	1941-09-26 00:00:00	1941-09-26	38000177		0	0	14		0	0	0	121419	0	243670	19059056		
232690	5113	40213227	2000-05-27	2000-05-27 00:00:00	2000-05-27	2000-05-27 00:00:00	2000-05-27	581452		0	0	0		0	0	0	339694	0	113	40213227		
47827	3966	19128065	1991-10-10	1991-10-10 00:00:00	1992-10-04	1992-10-04 00:00:00	1992-10-04	38000177		0	0	360		0	0	0	263654	0	749882	19128065		
58307	4844	1713671	1994-01-07	1994-01-07 00:00:00	1994-01-14	1994-01-14 00:00:00	1994-01-14	38000177		0	0	7		0	0	0	322297	0	562251	1713671		
131751	2895	40213260	2007-12-23	2007-12-23 00:00:00	2007-12-23	2007-12-23 00:00:00	2007-12-23	581452		0	0	0		0	0	0	192760	0	121	40213260		
41070	3407	1115171	2010-04-30	2010-04-30 00:00:00	2010-05-21	2010-05-21 00:00:00	2010-05-21	38000177		0	0	21		0	0	0	225979	0	849574	1115171		
37618	821	40213227	1999-06-19	1999-06-19 00:00:00	1999-06-19	1999-06-19 00:00:00	1999-06-19	581452		0	0	0		0	0	0	54435	0	113	40213227		
4334	359	1127078	1983-09-21	1983-09-21 00:00:00	1983-10-19	1983-10-19 00:00:00	1983-10-19	38000177		0	0	28		0	0	0	23882	0	282464	1127078		
53530	4450	1713671	1999-10-16	1999-10-16 00:00:00	1999-10-23	1999-10-23 00:00:00	1999-10-23	38000177		0	0	7		0	0	0	296050	0	562251	1713671		
51719	4297	1713671	1999-06-01	1999-06-01 00:00:00	1999-06-22	1999-06-22 00:00:00	1999-06-22	38000177		0	0	21		0	0	0	285196	0	562251	1713671		
64083	5322	19133905	2009-07-14	2009-07-14 00:00:00	2009-07-24	2009-07-24 00:00:00	2009-07-24	38000177		0	0	10		0	0	0	354130	0	834102	19133905		
9815	821	1127433	1967-02-22	1967-02-22 00:00:00	1967-03-08	1967-03-08 00:00:00	1967-03-08	38000177		0	0	14		0	0	0	54397	0	313782	1127433		
6192	518	19059056	1971-01-26	1971-01-26 00:00:00	1971-02-09	1971-02-09 00:00:00	1971-02-09	38000177		0	0	14		0	0	0	34596	0	243670	19059056		
137597	3020	40213227	2018-03-07	2018-03-07 00:00:00	2018-03-07	2018-03-07 00:00:00	2018-03-07	581452		0	0	0		0	0	0	201389	0	113	40213227		
8917	744	19059056	1954-09-01	1954-09-01 00:00:00	1954-09-15	1954-09-15 00:00:00	1954-09-15	38000177		0	0	14		0	0	0	49315	0	243670	19059056		
19459	1604	19059056	1959-09-28	1959-09-28 00:00:00	1959-10-26	1959-10-26 00:00:00	1959-10-26	38000177		0	0	28		0	0	0	107604	0	243670	19059056		
36919	3053	1713671	2018-12-21	2018-12-21 00:00:00	2018-12-28	2018-12-28 00:00:00	2018-12-28	38000177		0	0	7		0	0	0	203115	0	562251	1713671		
151795	3339	40213260	2010-10-12	2010-10-12 00:00:00	2010-10-12	2010-10-12 00:00:00	2010-10-12	581452		0	0	0		0	0	0	221481	0	121	40213260		
47500	3938	46233710	1969-07-11	1969-07-11 00:00:00	1969-07-25	1969-07-25 00:00:00	1969-07-25	38000177		0	0	14		0	0	0	261742	0	1650142	46233710		
47550	3941	1127433	1986-05-31	1986-05-31 00:00:00	1986-06-14	1986-06-14 00:00:00	1986-06-14	38000177		0	0	14		0	0	0	262060	0	313782	1127433		
9126	759	1127433	1957-10-07	1957-10-07 00:00:00	1957-10-21	1957-10-21 00:00:00	1957-10-21	38000177		0	0	14		0	0	0	50433	0	313782	1127433		
224280	4923	40213160	1969-01-14	1969-01-14 00:00:00	1969-01-14	1969-01-14 00:00:00	1969-01-14	581452		0	0	0		0	0	0	327106	0	10	40213160		
147636	3246	40213251	1984-10-01	1984-10-01 00:00:00	1984-10-01	1984-10-01 00:00:00	1984-10-01	581452		0	0	0		0	0	0	215785	0	21	40213251		
52276	1144	40213160	1970-11-15	1970-11-15 00:00:00	1970-11-15	1970-11-15 00:00:00	1970-11-15	581452		0	0	0		0	0	0	75504	0	10	40213160		
2389	191	920300	1958-06-19	1958-06-19 00:00:00	1958-06-26	1958-06-26 00:00:00	1958-06-26	38000177		0	0	7		0	0	0	13022	0	311989	920300		
7958	665	1127433	1995-08-02	1995-08-02 00:00:00	1995-08-16	1995-08-16 00:00:00	1995-08-16	38000177		0	0	14		0	0	0	43980	0	313782	1127433		
120922	2657	40213296	2006-06-17	2006-06-17 00:00:00	2006-06-17	2006-06-17 00:00:00	2006-06-17	581452		0	0	0		0	0	0	175972	0	52	40213296		
39602	3275	920300	2003-06-17	2003-06-17 00:00:00	2003-06-24	2003-06-24 00:00:00	2003-06-24	38000177		0	0	7		0	0	0	217649	0	311989	920300		
57590	4782	1118084	2017-09-07	2017-09-07 00:00:00	2017-09-07	2017-09-07 00:00:00	\N	38000177		0	0	0		0	0	0	318348	0	00025152531	44923712		
60290	5014	1713671	1930-06-20	1930-06-20 00:00:00	1930-07-11	1930-07-11 00:00:00	1930-07-11	38000177		0	0	21		0	0	0	333235	0	562251	1713671		
164121	3610	40213227	2016-02-20	2016-02-20 00:00:00	2016-02-20	2016-02-20 00:00:00	2016-02-20	581452		0	0	0		0	0	0	239841	0	113	40213227		
23656	1947	1713671	1970-09-21	1970-09-21 00:00:00	1970-10-05	1970-10-05 00:00:00	1970-10-05	38000177		0	0	14		0	0	0	129393	0	562251	1713671		
129942	2857	40213296	2005-08-11	2005-08-11 00:00:00	2005-08-11	2005-08-11 00:00:00	2005-08-11	581452		0	0	0		0	0	0	189697	0	52	40213296		
51859	4312	19128065	1974-09-14	1974-09-14 00:00:00	1975-09-09	1975-09-09 00:00:00	1975-09-09	38000177		0	0	360		0	0	0	286183	0	749882	19128065		
57230	4750	920300	1997-04-30	1997-04-30 00:00:00	1997-05-07	1997-05-07 00:00:00	1997-05-07	38000177		0	0	7		0	0	0	316367	0	311989	920300		
51946	4320	1367571	1970-05-14	1970-05-14 00:00:00	1970-05-14	1970-05-14 00:00:00	1970-05-14	38000177		0	0	0		0	0	0	286692	0	314659	19080464		
135134	2965	40213160	1970-11-02	1970-11-02 00:00:00	1970-11-02	1970-11-02 00:00:00	1970-11-02	581452		0	0	0		0	0	0	197980	0	10	40213160		
62513	5199	19128065	1984-11-26	1984-11-26 00:00:00	1985-11-21	1985-11-21 00:00:00	1985-11-21	38000177		0	0	360		0	0	0	345738	0	749882	19128065		
39385	3253	1127078	1980-04-26	1980-04-26 00:00:00	1980-05-26	1980-05-26 00:00:00	1980-05-26	38000177		0	0	30		0	0	0	216242	0	282464	1127078		
42070	3488	19059056	1957-06-18	1957-06-18 00:00:00	1957-07-02	1957-07-02 00:00:00	1957-07-02	38000177		0	0	14		0	0	0	231387	0	243670	19059056		
3971	331	1127433	2006-11-20	2006-11-20 00:00:00	2006-12-04	2006-12-04 00:00:00	2006-12-04	38000177		0	0	14		0	0	0	21784	0	313782	1127433		
19084	1576	19133873	1980-03-19	1980-03-19 00:00:00	1980-03-27	1980-03-27 00:00:00	1980-03-27	38000177		0	0	8		0	0	0	105818	0	834061	19133873		
35255	2906	1713671	1925-12-08	1925-12-08 00:00:00	1925-12-22	1925-12-22 00:00:00	1925-12-22	38000177		0	0	14		0	0	0	193688	0	562251	1713671		
87445	1918	40213306	1991-06-01	1991-06-01 00:00:00	1991-06-01	1991-06-01 00:00:00	1991-06-01	581452		0	0	0		0	0	0	127639	0	43	40213306		
231070	5077	40213260	2016-06-08	2016-06-08 00:00:00	2016-06-08	2016-06-08 00:00:00	2016-06-08	581452		0	0	0		0	0	0	337464	0	121	40213260		
45868	3796	19073188	2019-02-28	2019-02-28 00:00:00	2019-03-14	2019-03-14 00:00:00	2019-03-14	38000177		0	0	14		0	0	0	252414	0	308192	19073188		
12039	1005	19133873	1969-09-09	1969-09-09 00:00:00	1969-09-18	1969-09-18 00:00:00	1969-09-18	38000177		0	0	9		0	0	0	66424	0	834061	19133873		
146169	3215	40213306	1997-11-03	1997-11-03 00:00:00	1997-11-03	1997-11-03 00:00:00	1997-11-03	581452		0	0	0		0	0	0	213683	0	43	40213306		
38547	3183	19133873	1992-05-27	1992-05-27 00:00:00	1992-06-09	1992-06-09 00:00:00	1992-06-09	38000177		0	0	13		0	0	0	211931	0	834061	19133873		
162933	3582	40213296	1996-06-02	1996-06-02 00:00:00	1996-06-02	1996-06-02 00:00:00	1996-06-02	581452		0	0	0		0	0	0	238104	0	52	40213296		
22215	482	40213306	1991-05-16	1991-05-16 00:00:00	1991-05-16	1991-05-16 00:00:00	1991-05-16	581452		0	0	0		0	0	0	32207	0	43	40213306		
29217	2418	1127433	2018-06-02	2018-06-02 00:00:00	2018-06-09	2018-06-09 00:00:00	2018-06-09	38000177		0	0	7		0	0	0	160446	0	313782	1127433		
60228	1317	40213227	2002-11-15	2002-11-15 00:00:00	2002-11-15	2002-11-15 00:00:00	2002-11-15	581452		0	0	0		0	0	0	87309	0	113	40213227		
33603	2780	1118084	2001-09-23	2001-09-23 00:00:00	2001-09-23	2001-09-23 00:00:00	\N	38000177		0	0	0		0	0	0	184222	0	00025152531	44923712		
17482	1446	42902245	2003-09-27	2003-09-27 00:00:00	2004-09-21	2004-09-21 00:00:00	2004-09-21	38000177		0	0	360		0	0	0	96381	0	1359133	42902245		
15942	1322	1127433	1996-12-02	1996-12-02 00:00:00	1996-12-23	1996-12-23 00:00:00	1996-12-23	38000177		0	0	21		0	0	0	87739	0	313782	1127433		
10979	915	19133905	2015-08-24	2015-08-24 00:00:00	2015-09-05	2015-09-05 00:00:00	2015-09-05	38000177		0	0	12		0	0	0	60829	0	834102	19133905		
16035	1328	19075601	2019-06-13	2019-06-13 00:00:00	2019-06-13	2019-06-13 00:00:00	2019-06-13	38000177		0	0	0		0	0	0	88175	0	309362	19075601		
16054	1332	1539411	1999-08-04	1999-08-04 00:00:00	1999-08-04	1999-08-04 00:00:00	\N	38000177		0	0	0		0	0	0	88397	0	312961	1539411		
233523	5132	40213260	2017-08-14	2017-08-14 00:00:00	2017-08-14	2017-08-14 00:00:00	2017-08-14	581452		0	0	0		0	0	0	341136	0	121	40213260		
29948	2481	1115171	2012-07-25	2012-07-25 00:00:00	2012-08-08	2012-08-08 00:00:00	2012-08-08	38000177		0	0	14		0	0	0	164375	0	849574	1115171		
221494	4860	40213296	2018-10-05	2018-10-05 00:00:00	2018-10-05	2018-10-05 00:00:00	2018-10-05	581452		0	0	0		0	0	0	323337	0	52	40213296		
54677	4543	1118084	2017-10-13	2017-10-13 00:00:00	2017-10-13	2017-10-13 00:00:00	\N	38000177		0	0	0		0	0	0	302616	0	00025152531	44923712		
40551	3362	1127433	1966-09-02	1966-09-02 00:00:00	1966-09-09	1966-09-09 00:00:00	1966-09-09	38000177		0	0	7		0	0	0	222854	0	313782	1127433		
22068	1814	1127433	2000-05-05	2000-05-05 00:00:00	2000-06-02	2000-06-02 00:00:00	2000-06-02	38000177		0	0	28		0	0	0	121431	0	313782	1127433		
232695	5113	40213160	1969-06-21	1969-06-21 00:00:00	1969-06-21	1969-06-21 00:00:00	1969-06-21	581452		0	0	0		0	0	0	339710	0	10	40213160		
47828	3966	19128065	1981-12-01	1981-12-01 00:00:00	1982-11-26	1982-11-26 00:00:00	1982-11-26	38000177		0	0	360		0	0	0	263639	0	749882	19128065		
58308	4844	1127433	2011-11-09	2011-11-09 00:00:00	2011-11-30	2011-11-30 00:00:00	2011-11-30	38000177		0	0	21		0	0	0	322284	0	313782	1127433		
131758	2895	40213227	1992-09-06	1992-09-06 00:00:00	1992-09-06	1992-09-06 00:00:00	1992-09-06	581452		0	0	0		0	0	0	192709	0	113	40213227		
41071	3408	1713671	1988-12-14	1988-12-14 00:00:00	1989-01-04	1989-01-04 00:00:00	1989-01-04	38000177		0	0	21		0	0	0	225997	0	562251	1713671		
37620	821	40213160	1955-06-04	1955-06-04 00:00:00	1955-06-04	1955-06-04 00:00:00	1955-06-04	581452		0	0	0		0	0	0	54444	0	10	40213160		
4335	359	19133873	1982-07-13	1982-07-13 00:00:00	1982-07-23	1982-07-23 00:00:00	1982-07-23	38000177		0	0	10		0	0	0	23887	0	834061	19133873		
53531	4450	1124300	2008-12-19	2008-12-19 00:00:00	2008-12-19	2008-12-19 00:00:00	\N	38000177		0	0	0		0	0	0	296072	0	00781178901	45011828		
51720	4297	1127078	1978-09-07	1978-09-07 00:00:00	1978-11-06	1978-11-06 00:00:00	1978-11-06	38000177		0	0	60		0	0	0	285175	0	282464	1127078		
64084	5322	19059056	1985-11-26	1985-11-26 00:00:00	1985-12-17	1985-12-17 00:00:00	1985-12-17	38000177		0	0	21		0	0	0	354090	0	243670	19059056		
9816	821	40229134	1953-07-18	1953-07-18 00:00:00	1953-07-25	1953-07-25 00:00:00	1953-07-25	38000177		0	0	7		0	0	0	54377	0	1043400	40229134		
6193	518	19078461	1995-10-17	1995-10-17 00:00:00	1995-10-31	1995-10-31 00:00:00	1995-10-31	38000177		0	0	14		0	0	0	34594	0	310965	19078461		
124666	2743	40213160	1960-07-13	1960-07-13 00:00:00	1960-07-13	1960-07-13 00:00:00	1960-07-13	581452		0	0	0		0	0	0	181503	0	10	40213160		
8918	744	1127433	1996-07-22	1996-07-22 00:00:00	1996-08-05	1996-08-05 00:00:00	1996-08-05	38000177		0	0	14		0	0	0	49355	0	313782	1127433		
19460	1604	40165015	1973-04-22	1973-04-22 00:00:00	1973-04-22	1973-04-22 00:00:00	\N	38000177		0	0	0		0	0	0	107603	0	861467	40165015		
36920	3053	920334	2014-02-10	2014-02-10 00:00:00	2014-02-17	2014-02-17 00:00:00	2014-02-17	38000177		0	0	7		0	0	0	203103	0	311995	920334		
591	42	19133905	1985-05-25	1985-05-25 00:00:00	1985-06-01	1985-06-01 00:00:00	1985-06-01	38000177		0	0	7		0	0	0	2998	0	834102	19133905		
47501	3938	1713671	1977-10-09	1977-10-09 00:00:00	1977-10-16	1977-10-16 00:00:00	1977-10-16	38000177		0	0	7		0	0	0	261721	0	562251	1713671		
47551	3941	1127433	1964-10-30	1964-10-30 00:00:00	1964-11-13	1964-11-13 00:00:00	1964-11-13	38000177		0	0	14		0	0	0	262045	0	313782	1127433		
102339	2243	40213160	1971-01-01	1971-01-01 00:00:00	1971-01-01	1971-01-01 00:00:00	1971-01-01	581452		0	0	0		0	0	0	149347	0	10	40213160		
224284	4923	40213306	1991-01-08	1991-01-08 00:00:00	1991-01-08	1991-01-08 00:00:00	1991-01-08	581452		0	0	0		0	0	0	327081	0	43	40213306		
147639	3246	40213160	1984-10-01	1984-10-01 00:00:00	1984-10-01	1984-10-01 00:00:00	1984-10-01	581452		0	0	0		0	0	0	215785	0	10	40213160		
52280	1144	40213160	1970-09-13	1970-09-13 00:00:00	1970-09-13	1970-09-13 00:00:00	1970-09-13	581452		0	0	0		0	0	0	75529	0	10	40213160		
2390	191	1127433	2002-03-09	2002-03-09 00:00:00	2002-03-16	2002-03-16 00:00:00	2002-03-16	38000177		0	0	7		0	0	0	13143	0	313782	1127433		
7959	665	1713671	1988-11-12	1988-11-12 00:00:00	1988-11-19	1988-11-19 00:00:00	1988-11-19	38000177		0	0	7		0	0	0	43991	0	562251	1713671		
120925	2657	40213160	1966-04-16	1966-04-16 00:00:00	1966-04-16	1966-04-16 00:00:00	1966-04-16	581452		0	0	0		0	0	0	175941	0	10	40213160		
39603	3275	1713671	1960-06-13	1960-06-13 00:00:00	1960-07-04	1960-07-04 00:00:00	1960-07-04	38000177		0	0	21		0	0	0	217626	0	562251	1713671		
57591	4782	40224805	2004-03-04	2004-03-04 00:00:00	2005-02-27	2005-02-27 00:00:00	2005-02-27	38000177		0	0	360		0	0	0	318325	0	1000126	40224805		
60291	5014	1713671	1932-10-05	1932-10-05 00:00:00	1932-10-26	1932-10-26 00:00:00	1932-10-26	38000177		0	0	21		0	0	0	333248	0	562251	1713671		
164125	3610	40213227	2005-12-24	2005-12-24 00:00:00	2005-12-24	2005-12-24 00:00:00	2005-12-24	581452		0	0	0		0	0	0	239821	0	113	40213227		
23657	1947	1713671	1949-04-21	1949-04-21 00:00:00	1949-04-28	1949-04-28 00:00:00	1949-04-28	38000177		0	0	7		0	0	0	129422	0	562251	1713671		
129944	2857	40213227	2005-08-11	2005-08-11 00:00:00	2005-08-11	2005-08-11 00:00:00	2005-08-11	581452		0	0	0		0	0	0	189697	0	113	40213227		
51860	4312	19133873	1963-08-28	1963-08-28 00:00:00	1963-09-10	1963-09-10 00:00:00	1963-09-10	38000177		0	0	13		0	0	0	286109	0	834061	19133873		
57231	4750	1127433	1977-09-25	1977-09-25 00:00:00	1977-10-02	1977-10-02 00:00:00	1977-10-02	38000177		0	0	7		0	0	0	316355	0	313782	1127433		
51947	4320	40220386	1970-05-14	1970-05-14 00:00:00	1970-05-14	1970-05-14 00:00:00	1970-05-14	38000177		0	0	0		0	0	0	286692	0	1808217	40220386		
135135	2966	40213160	1962-04-21	1962-04-21 00:00:00	1962-04-21	1962-04-21 00:00:00	1962-04-21	581452		0	0	0		0	0	0	198153	0	10	40213160		
62514	5199	19115351	1977-10-18	1977-10-18 00:00:00	1978-04-04	1978-04-04 00:00:00	1978-04-04	38000177		0	0	168		0	0	0	345735	0	563026	19115351		
39386	3253	19133873	1972-04-09	1972-04-09 00:00:00	1972-04-22	1972-04-22 00:00:00	1972-04-22	38000177		0	0	13		0	0	0	216329	0	834061	19133873		
42071	3488	19006318	1957-06-18	1957-06-18 00:00:00	1957-07-02	1957-07-02 00:00:00	1957-07-02	38000177		0	0	14		0	0	0	231387	0	105078	19006318		
3972	331	1115171	2002-06-19	2002-06-19 00:00:00	2002-07-24	2002-07-24 00:00:00	2002-07-24	38000177		0	0	35		0	0	0	21812	0	849574	1115171		
19085	1576	1118084	2007-04-15	2007-04-15 00:00:00	2007-04-15	2007-04-15 00:00:00	\N	38000177		0	0	0		0	0	0	105778	0	00025152531	44923712		
35256	2906	1127433	1958-11-13	1958-11-13 00:00:00	1958-12-18	1958-12-18 00:00:00	1958-12-18	38000177		0	0	35		0	0	0	193723	0	313782	1127433		
87450	1918	40213160	1973-07-21	1973-07-21 00:00:00	1973-07-21	1973-07-21 00:00:00	1973-07-21	581452		0	0	0		0	0	0	127605	0	10	40213160		
231073	5077	40213296	2005-08-17	2005-08-17 00:00:00	2005-08-17	2005-08-17 00:00:00	2005-08-17	581452		0	0	0		0	0	0	337475	0	52	40213296		
45869	3796	46233988	1968-11-08	1968-11-08 00:00:00	1968-11-22	1968-11-22 00:00:00	1968-11-22	38000177		0	0	14		0	0	0	252394	0	1652673	46233988		
12040	1005	19128065	1982-02-12	1982-02-12 00:00:00	1983-02-07	1983-02-07 00:00:00	1983-02-07	38000177		0	0	360		0	0	0	66427	0	749882	19128065		
146172	3215	40213227	2009-04-06	2009-04-06 00:00:00	2009-04-06	2009-04-06 00:00:00	2009-04-06	581452		0	0	0		0	0	0	213639	0	113	40213227		
38548	3183	1127433	1998-02-11	1998-02-11 00:00:00	1998-02-25	1998-02-25 00:00:00	1998-02-25	38000177		0	0	14		0	0	0	211933	0	313782	1127433		
162936	3583	40213160	1969-07-15	1969-07-15 00:00:00	1969-07-15	1969-07-15 00:00:00	1969-07-15	581452		0	0	0		0	0	0	238228	0	10	40213160		
22222	482	40213296	2011-04-28	2011-04-28 00:00:00	2011-04-28	2011-04-28 00:00:00	2011-04-28	581452		0	0	0		0	0	0	32246	0	52	40213296		
29218	2418	1127078	1979-02-10	1979-02-10 00:00:00	1979-02-24	1979-02-24 00:00:00	1979-02-24	38000177		0	0	14		0	0	0	160439	0	282464	1127078		
60233	1317	40213227	2013-01-11	2013-01-11 00:00:00	2013-01-11	2013-01-11 00:00:00	2013-01-11	581452		0	0	0		0	0	0	87302	0	113	40213227		
33604	2781	19133873	1990-04-22	1990-04-22 00:00:00	1990-04-30	1990-04-30 00:00:00	1990-04-30	38000177		0	0	8		0	0	0	184297	0	834061	19133873		
17483	1447	1127433	2017-07-22	2017-07-22 00:00:00	2017-08-26	2017-08-26 00:00:00	2017-08-26	38000177		0	0	35		0	0	0	96523	0	313782	1127433		
15943	1322	1713671	1960-04-30	1960-04-30 00:00:00	1960-05-21	1960-05-21 00:00:00	1960-05-21	38000177		0	0	21		0	0	0	87789	0	562251	1713671		
773	63	19059056	1973-12-05	1973-12-05 00:00:00	1974-01-04	1974-01-04 00:00:00	1974-01-04	38000177		0	0	30		0	0	0	4297	0	243670	19059056		
16036	1328	40220960	2019-06-13	2019-06-13 00:00:00	2019-06-13	2019-06-13 00:00:00	2019-06-13	38000177		0	0	0		0	0	0	88175	0	1804799	40220960		
16055	1332	19075601	1999-08-04	1999-08-04 00:00:00	2019-01-02	2019-01-02 00:00:00	2019-01-02	38000177		0	0	7091		0	0	0	88397	0	309362	19075601		
233524	5132	40213260	2016-08-08	2016-08-08 00:00:00	2016-08-08	2016-08-08 00:00:00	2016-08-08	581452		0	0	0		0	0	0	341145	0	121	40213260		
29949	2481	1115171	2012-08-22	2012-08-22 00:00:00	2012-10-21	2012-10-21 00:00:00	2012-10-21	38000177		0	0	60		0	0	0	164390	0	849574	1115171		
221502	4860	40213227	2010-01-01	2010-01-01 00:00:00	2010-01-01	2010-01-01 00:00:00	2010-01-01	581452		0	0	0		0	0	0	323311	0	113	40213227		
54678	4543	40224805	1994-08-30	1994-08-30 00:00:00	1995-08-25	1995-08-25 00:00:00	1995-08-25	38000177		0	0	360		0	0	0	302608	0	1000126	40224805		
40552	3362	19133905	1984-01-17	1984-01-17 00:00:00	1984-01-25	1984-01-25 00:00:00	1984-01-25	38000177		0	0	8		0	0	0	222928	0	834102	19133905		
22069	1814	19059056	1953-07-11	1953-07-11 00:00:00	1953-09-09	1953-09-09 00:00:00	1953-09-09	38000177		0	0	60		0	0	0	121429	0	243670	19059056		
90295	1982	40213201	1987-08-27	1987-08-27 00:00:00	1987-08-27	1987-08-27 00:00:00	1987-08-27	581452		0	0	0		0	0	0	132048	0	33	40213201		
47829	3966	1127078	1977-06-29	1977-06-29 00:00:00	1977-07-13	1977-07-13 00:00:00	1977-07-13	38000177		0	0	14		0	0	0	263663	0	282464	1127078		
58309	4844	1713671	1978-06-05	1978-06-05 00:00:00	1978-06-19	1978-06-19 00:00:00	1978-06-19	38000177		0	0	14		0	0	0	322287	0	562251	1713671		
131770	2895	40213260	2008-12-28	2008-12-28 00:00:00	2008-12-28	2008-12-28 00:00:00	2008-12-28	581452		0	0	0		0	0	0	192729	0	121	40213260		
41072	3408	1127433	1997-01-13	1997-01-13 00:00:00	1997-01-20	1997-01-20 00:00:00	1997-01-20	38000177		0	0	7		0	0	0	226007	0	313782	1127433		
106315	2332	40213227	1999-05-01	1999-05-01 00:00:00	1999-05-01	1999-05-01 00:00:00	1999-05-01	581452		0	0	0		0	0	0	155118	0	113	40213227		
4336	359	1713671	2006-03-31	2006-03-31 00:00:00	2006-04-07	2006-04-07 00:00:00	2006-04-07	38000177		0	0	7		0	0	0	23878	0	562251	1713671		
53532	4451	19133905	1976-07-03	1976-07-03 00:00:00	1976-07-15	1976-07-15 00:00:00	1976-07-15	38000177		0	0	12		0	0	0	296165	0	834102	19133905		
51721	4297	40229134	2008-01-28	2008-01-28 00:00:00	2008-02-04	2008-02-04 00:00:00	2008-02-04	38000177		0	0	7		0	0	0	285159	0	1043400	40229134		
64085	5322	19059056	1949-08-28	1949-08-28 00:00:00	1949-09-11	1949-09-11 00:00:00	1949-09-11	38000177		0	0	14		0	0	0	354204	0	243670	19059056		
9817	822	19133873	1973-11-26	1973-11-26 00:00:00	1973-12-03	1973-12-03 00:00:00	1973-12-03	38000177		0	0	7		0	0	0	54458	0	834061	19133873		
6194	518	1127433	2013-07-28	2013-07-28 00:00:00	2013-08-27	2013-08-27 00:00:00	2013-08-27	38000177		0	0	30		0	0	0	34595	0	313782	1127433		
124667	2743	40213260	2011-04-13	2011-04-13 00:00:00	2011-04-13	2011-04-13 00:00:00	2011-04-13	581452		0	0	0		0	0	0	181459	0	121	40213260		
8919	744	1127433	2017-08-29	2017-08-29 00:00:00	2017-09-19	2017-09-19 00:00:00	2017-09-19	38000177		0	0	21		0	0	0	49358	0	313782	1127433		
19461	1605	19078461	1984-03-23	1984-03-23 00:00:00	1984-04-27	1984-04-27 00:00:00	1984-04-27	38000177		0	0	35		0	0	0	107748	0	310965	19078461		
36921	3053	1115171	2009-03-02	2009-03-02 00:00:00	2009-03-16	2009-03-16 00:00:00	2009-03-16	38000177		0	0	14		0	0	0	203108	0	849574	1115171		
592	43	1118084	1997-03-22	1997-03-22 00:00:00	1997-03-22	1997-03-22 00:00:00	\N	38000177		0	0	0		0	0	0	3184	0	00025152531	44923712		
47502	3938	1127433	1984-09-20	1984-09-20 00:00:00	1984-10-18	1984-10-18 00:00:00	1984-10-18	38000177		0	0	28		0	0	0	261809	0	313782	1127433		
47552	3941	1713671	1983-06-26	1983-06-26 00:00:00	1983-07-10	1983-07-10 00:00:00	1983-07-10	38000177		0	0	14		0	0	0	262059	0	562251	1713671		
102346	2243	40213227	1998-01-30	1998-01-30 00:00:00	1998-01-30	1998-01-30 00:00:00	1998-01-30	581452		0	0	0		0	0	0	149355	0	113	40213227		
224286	4923	40213260	2018-10-09	2018-10-09 00:00:00	2018-10-09	2018-10-09 00:00:00	2018-10-09	581452		0	0	0		0	0	0	327148	0	121	40213260		
147641	3246	40213227	2002-07-01	2002-07-01 00:00:00	2002-07-01	2002-07-01 00:00:00	2002-07-01	581452		0	0	0		0	0	0	215797	0	113	40213227		
52282	1144	40213306	1992-11-01	1992-11-01 00:00:00	1992-11-01	1992-11-01 00:00:00	1992-11-01	581452		0	0	0		0	0	0	75510	0	43	40213306		
2391	191	40229134	1968-09-30	1968-09-30 00:00:00	1968-10-07	1968-10-07 00:00:00	1968-10-07	38000177		0	0	7		0	0	0	13073	0	1043400	40229134		
7960	665	1127078	1966-12-30	1966-12-30 00:00:00	1967-03-30	1967-03-30 00:00:00	1967-03-30	38000177		0	0	90		0	0	0	43937	0	282464	1127078		
120933	2657	40213260	2017-01-14	2017-01-14 00:00:00	2017-01-14	2017-01-14 00:00:00	2017-01-14	581452		0	0	0		0	0	0	175963	0	121	40213260		
39604	3275	40229134	2002-06-01	2002-06-01 00:00:00	2002-06-15	2002-06-15 00:00:00	2002-06-15	38000177		0	0	14		0	0	0	217631	0	1043400	40229134		
57592	4782	1127433	1995-06-12	1995-06-12 00:00:00	1995-06-26	1995-06-26 00:00:00	1995-06-26	38000177		0	0	14		0	0	0	318316	0	313782	1127433		
60292	5014	1127433	1915-11-29	1915-11-29 00:00:00	1915-12-06	1915-12-06 00:00:00	1915-12-06	38000177		0	0	7		0	0	0	333311	0	313782	1127433		
175434	3857	40213201	2010-09-14	2010-09-14 00:00:00	2010-09-14	2010-09-14 00:00:00	2010-09-14	581452		0	0	0		0	0	0	255965	0	33	40213201		
23658	1947	40229134	1995-05-16	1995-05-16 00:00:00	1995-05-30	1995-05-30 00:00:00	1995-05-30	38000177		0	0	14		0	0	0	129404	0	1043400	40229134		
129949	2857	40213306	1984-12-05	1984-12-05 00:00:00	1984-12-05	1984-12-05 00:00:00	1984-12-05	581452		0	0	0		0	0	0	\N	0	43	40213306		
51861	4312	19008572	1966-11-23	1966-11-23 00:00:00	1966-12-07	1966-12-07 00:00:00	1966-12-07	38000177		0	0	14		0	0	0	286135	0	106258	19008572		
57232	4750	19078461	2014-04-12	2014-04-12 00:00:00	2014-05-17	2014-05-17 00:00:00	2014-05-17	38000177		0	0	35		0	0	0	316317	0	310965	19078461		
51948	4320	782047	1970-05-14	1970-05-14 00:00:00	1970-05-14	1970-05-14 00:00:00	1970-05-14	38000177		0	0	0		0	0	0	286692	0	542347	782047		
208136	4565	40213227	2007-03-27	2007-03-27 00:00:00	2007-03-27	2007-03-27 00:00:00	2007-03-27	581452		0	0	0		0	0	0	304173	0	113	40213227		
62515	5199	40229134	1999-01-08	1999-01-08 00:00:00	1999-01-22	1999-01-22 00:00:00	1999-01-22	38000177		0	0	14		0	0	0	345769	0	1043400	40229134		
39387	3253	19128022	1996-03-13	1996-03-13 00:00:00	1997-03-08	1997-03-08 00:00:00	1997-03-08	38000177		0	0	360		0	0	0	216395	0	749785	19128022		
42072	3488	1127433	1978-05-12	1978-05-12 00:00:00	1978-06-16	1978-06-16 00:00:00	1978-06-16	38000177		0	0	35		0	0	0	231356	0	313782	1127433		
3973	331	19059056	1942-09-22	1942-09-22 00:00:00	1942-10-29	1942-10-29 00:00:00	1942-10-29	38000177		0	0	37		0	0	0	21807	0	243670	19059056		
19086	1576	1127433	2009-11-27	2009-11-27 00:00:00	2009-12-04	2009-12-04 00:00:00	2009-12-04	38000177		0	0	7		0	0	0	105803	0	313782	1127433		
35257	2906	40229134	1977-03-24	1977-03-24 00:00:00	1977-04-07	1977-04-07 00:00:00	1977-04-07	38000177		0	0	14		0	0	0	193747	0	1043400	40229134		
16500	357	40213227	2005-10-19	2005-10-19 00:00:00	2005-10-19	2005-10-19 00:00:00	2005-10-19	581452		0	0	0		0	0	0	23720	0	113	40213227		
231077	5077	40213306	1987-05-13	1987-05-13 00:00:00	1987-05-13	1987-05-13 00:00:00	1987-05-13	581452		0	0	0		0	0	0	337484	0	43	40213306		
45870	3796	1127078	1968-11-08	1968-11-08 00:00:00	1968-11-22	1968-11-22 00:00:00	1968-11-22	38000177		0	0	14		0	0	0	252394	0	282464	1127078		
12041	1005	1713671	2004-07-12	2004-07-12 00:00:00	2004-08-09	2004-08-09 00:00:00	2004-08-09	38000177		0	0	28		0	0	0	66426	0	562251	1713671		
146173	3215	40213251	1984-10-22	1984-10-22 00:00:00	1984-10-22	1984-10-22 00:00:00	1984-10-22	581452		0	0	0		0	0	0	213608	0	21	40213251		
38549	3183	19059056	1988-05-02	1988-05-02 00:00:00	1988-06-01	1988-06-01 00:00:00	1988-06-01	38000177		0	0	30		0	0	0	211926	0	243670	19059056		
162938	3583	40213160	1969-02-11	1969-02-11 00:00:00	1969-02-11	1969-02-11 00:00:00	1969-02-11	581452		0	0	0		0	0	0	238227	0	10	40213160		
10562	225	40213227	2016-09-26	2016-09-26 00:00:00	2016-09-26	2016-09-26 00:00:00	2016-09-26	581452		0	0	0		0	0	0	15137	0	113	40213227		
29219	2418	1118084	2009-06-17	2009-06-17 00:00:00	2009-06-17	2009-06-17 00:00:00	\N	38000177		0	0	0		0	0	0	160477	0	00025152531	44923712		
60240	1317	40213227	1994-05-20	1994-05-20 00:00:00	1994-05-20	1994-05-20 00:00:00	1994-05-20	581452		0	0	0		0	0	0	87307	0	113	40213227		
33605	2781	1127078	1988-10-12	1988-10-12 00:00:00	1988-10-26	1988-10-26 00:00:00	1988-10-26	38000177		0	0	14		0	0	0	184329	0	282464	1127078		
17484	1447	1118084	1996-01-09	1996-01-09 00:00:00	1996-01-09	1996-01-09 00:00:00	\N	38000177		0	0	0		0	0	0	96525	0	00025152531	44923712		
15944	1322	1127433	1963-05-09	1963-05-09 00:00:00	1963-05-30	1963-05-30 00:00:00	1963-05-30	38000177		0	0	21		0	0	0	87783	0	313782	1127433		
774	63	40162522	1973-12-05	1973-12-05 00:00:00	1973-12-05	1973-12-05 00:00:00	\N	38000177		0	0	0		0	0	0	4297	0	857005	40162522		
16037	1328	1127433	1966-11-05	1966-11-05 00:00:00	1966-11-12	1966-11-12 00:00:00	1966-11-12	38000177		0	0	7		0	0	0	88177	0	313782	1127433		
16056	1332	40231925	1979-12-05	1979-12-05 00:00:00	1979-12-05	1979-12-05 00:00:00	\N	38000177		0	0	0		0	0	0	88381	0	1049221	40231925		
233531	5132	40213296	2006-08-14	2006-08-14 00:00:00	2006-08-14	2006-08-14 00:00:00	2006-08-14	581452		0	0	0		0	0	0	341144	0	52	40213296		
29950	2481	1713671	1984-10-10	1984-10-10 00:00:00	1984-10-31	1984-10-31 00:00:00	1984-10-31	38000177		0	0	21		0	0	0	164391	0	562251	1713671		
221503	4860	40213314	1979-12-07	1979-12-07 00:00:00	1979-12-07	1979-12-07 00:00:00	1979-12-07	581452		0	0	0		0	0	0	323326	0	49	40213314		
54679	4543	1713671	2018-05-06	2018-05-06 00:00:00	2018-05-20	2018-05-20 00:00:00	2018-05-20	38000177		0	0	14		0	0	0	302606	0	562251	1713671		
40553	3362	19059056	1986-12-11	1986-12-11 00:00:00	1986-12-25	1986-12-25 00:00:00	1986-12-25	38000177		0	0	14		0	0	0	222892	0	243670	19059056		
22070	1814	40165015	1953-07-11	1953-07-11 00:00:00	1953-07-11	1953-07-11 00:00:00	\N	38000177		0	0	0		0	0	0	121429	0	861467	40165015		
90308	1982	40213227	2002-12-26	2002-12-26 00:00:00	2002-12-26	2002-12-26 00:00:00	2002-12-26	581452		0	0	0		0	0	0	131968	0	113	40213227		
47830	3966	19128065	1983-11-21	1983-11-21 00:00:00	1984-11-15	1984-11-15 00:00:00	1984-11-15	38000177		0	0	360		0	0	0	263641	0	749882	19128065		
58310	4844	1127433	2000-09-16	2000-09-16 00:00:00	2000-09-30	2000-09-30 00:00:00	2000-09-30	38000177		0	0	14		0	0	0	322322	0	313782	1127433		
131774	2895	40213227	2008-12-28	2008-12-28 00:00:00	2008-12-28	2008-12-28 00:00:00	2008-12-28	581452		0	0	0		0	0	0	192729	0	113	40213227		
41073	3408	46233988	1971-10-25	1971-10-25 00:00:00	1971-11-08	1971-11-08 00:00:00	1971-11-08	38000177		0	0	14		0	0	0	226001	0	1652673	46233988		
106316	2332	40213296	1999-05-01	1999-05-01 00:00:00	1999-05-01	1999-05-01 00:00:00	1999-05-01	581452		0	0	0		0	0	0	155118	0	52	40213296		
4337	359	1127433	1986-09-06	1986-09-06 00:00:00	1986-09-13	1986-09-13 00:00:00	1986-09-13	38000177		0	0	7		0	0	0	23888	0	313782	1127433		
53533	4451	19059056	1954-06-26	1954-06-26 00:00:00	1954-07-10	1954-07-10 00:00:00	1954-07-10	38000177		0	0	14		0	0	0	296137	0	243670	19059056		
51722	4297	19129655	1974-10-28	1974-10-28 00:00:00	1974-11-11	1974-11-11 00:00:00	1974-11-11	38000177		0	0	14		0	0	0	285190	0	789980	19129655		
64086	5322	19006318	1949-08-28	1949-08-28 00:00:00	1949-09-11	1949-09-11 00:00:00	1949-09-11	38000177		0	0	14		0	0	0	354204	0	105078	19006318		
9818	822	1127433	1988-02-10	1988-02-10 00:00:00	1988-03-09	1988-03-09 00:00:00	1988-03-09	38000177		0	0	28		0	0	0	54497	0	313782	1127433		
6195	518	1127433	2015-03-07	2015-03-07 00:00:00	2015-03-21	2015-03-21 00:00:00	2015-03-21	38000177		0	0	14		0	0	0	34590	0	313782	1127433		
124670	2743	40213227	2011-04-13	2011-04-13 00:00:00	2011-04-13	2011-04-13 00:00:00	2011-04-13	581452		0	0	0		0	0	0	181459	0	113	40213227		
8920	744	19059056	1972-04-12	1972-04-12 00:00:00	1972-05-03	1972-05-03 00:00:00	1972-05-03	38000177		0	0	21		0	0	0	49352	0	243670	19059056		
19462	1605	19059056	1948-12-13	1948-12-13 00:00:00	1948-12-27	1948-12-27 00:00:00	1948-12-27	38000177		0	0	14		0	0	0	107746	0	243670	19059056		
36922	3053	40236824	2015-03-25	2015-03-25 00:00:00	2015-04-01	2015-04-01 00:00:00	2015-04-01	38000177		0	0	7		0	0	0	203128	0	1094107	40236824		
593	43	19078461	1994-11-12	1994-11-12 00:00:00	1994-12-03	1994-12-03 00:00:00	1994-12-03	38000177		0	0	21		0	0	0	3156	0	310965	19078461		
47503	3938	1127433	1929-11-14	1929-11-14 00:00:00	1929-11-21	1929-11-21 00:00:00	1929-11-21	38000177		0	0	7		0	0	0	261701	0	313782	1127433		
47553	3941	1127433	1969-06-20	1969-06-20 00:00:00	1969-06-27	1969-06-27 00:00:00	1969-06-27	38000177		0	0	7		0	0	0	262058	0	313782	1127433		
102348	2243	40213296	2006-02-10	2006-02-10 00:00:00	2006-02-10	2006-02-10 00:00:00	2006-02-10	581452		0	0	0		0	0	0	149326	0	52	40213296		
43453	3603	1713671	1969-08-30	1969-08-30 00:00:00	1969-09-13	1969-09-13 00:00:00	1969-09-13	38000177		0	0	14		0	0	0	239441	0	562251	1713671		
147643	3246	40213227	2012-05-28	2012-05-28 00:00:00	2012-05-28	2012-05-28 00:00:00	2012-05-28	581452		0	0	0		0	0	0	215825	0	113	40213227		
210385	4613	40213160	1966-10-30	1966-10-30 00:00:00	1966-10-30	1966-10-30 00:00:00	1966-10-30	581452		0	0	0		0	0	0	307242	0	10	40213160		
2392	191	1127433	1983-10-06	1983-10-06 00:00:00	1983-10-27	1983-10-27 00:00:00	1983-10-27	38000177		0	0	21		0	0	0	13040	0	313782	1127433		
7961	665	40229134	2006-07-31	2006-07-31 00:00:00	2006-08-07	2006-08-07 00:00:00	2006-08-07	38000177		0	0	7		0	0	0	43982	0	1043400	40229134		
120934	2657	40213227	2017-01-14	2017-01-14 00:00:00	2017-01-14	2017-01-14 00:00:00	2017-01-14	581452		0	0	0		0	0	0	175963	0	113	40213227		
39606	3275	19128065	1976-03-26	1976-03-26 00:00:00	1977-03-21	1977-03-21 00:00:00	1977-03-21	38000177		0	0	360		0	0	0	217585	0	749882	19128065		
57593	4782	1519937	2008-02-12	2008-02-12 00:00:00	2009-02-06	2009-02-06 00:00:00	2009-02-06	38000177		0	0	360		0	0	0	318330	0	389221	1519937		
60293	5014	19133873	1916-09-24	1916-09-24 00:00:00	1916-10-05	1916-10-05 00:00:00	1916-10-05	38000177		0	0	11		0	0	0	333247	0	834061	19133873		
175435	3857	40213198	2010-09-14	2010-09-14 00:00:00	2010-09-14	2010-09-14 00:00:00	2010-09-14	581452		0	0	0		0	0	0	255965	0	133	40213198		
23660	1947	40165015	1976-04-07	1976-04-07 00:00:00	1976-04-07	1976-04-07 00:00:00	\N	38000177		0	0	0		0	0	0	129466	0	861467	40165015		
129953	2857	40213160	1969-02-19	1969-02-19 00:00:00	1969-02-19	1969-02-19 00:00:00	1969-02-19	581452		0	0	0		0	0	0	189721	0	10	40213160		
51862	4312	1551192	1978-06-10	1978-06-10 00:00:00	1978-06-10	1978-06-10 00:00:00	1978-06-10	38000177		0	0	0		0	0	0	286123	0	312617	1551192		
57242	4753	1127078	1970-02-20	1970-02-20 00:00:00	1970-03-06	1970-03-06 00:00:00	1970-03-06	38000177		0	0	14		0	0	0	316574	0	282464	1127078		
51949	4320	42707627	1970-05-14	1970-05-14 00:00:00	1970-05-14	1970-05-14 00:00:00	1970-05-14	38000177		0	0	0		0	0	0	286692	0	1234995	42707627		
208144	4565	40213227	2016-11-22	2016-11-22 00:00:00	2016-11-22	2016-11-22 00:00:00	2016-11-22	581452		0	0	0		0	0	0	304177	0	113	40213227		
62516	5200	1150771	1982-09-04	1982-09-04 00:00:00	1982-09-04	1982-09-04 00:00:00	\N	38000177		0	0	0		0	0	0	345935	0	197378	1150771		
39389	3253	19008572	2005-04-15	2005-04-15 00:00:00	2005-05-06	2005-05-06 00:00:00	2005-05-06	38000177		0	0	21		0	0	0	216294	0	106258	19008572		
42073	3488	1127078	1959-10-14	1959-10-14 00:00:00	1959-10-28	1959-10-28 00:00:00	1959-10-28	38000177		0	0	14		0	0	0	231388	0	282464	1127078		
3974	331	40229134	1999-12-31	1999-12-31 00:00:00	2000-01-14	2000-01-14 00:00:00	2000-01-14	38000177		0	0	14		0	0	0	21783	0	1043400	40229134		
19087	1576	19128065	1984-09-24	1984-09-24 00:00:00	1985-09-19	1985-09-19 00:00:00	1985-09-19	38000177		0	0	360		0	0	0	105785	0	749882	19128065		
35258	2906	920300	1979-05-14	1979-05-14 00:00:00	1979-05-21	1979-05-21 00:00:00	1979-05-21	38000177		0	0	7		0	0	0	193738	0	311989	920300		
16504	357	40213227	2015-12-16	2015-12-16 00:00:00	2015-12-16	2015-12-16 00:00:00	2015-12-16	581452		0	0	0		0	0	0	23776	0	113	40213227		
190148	4176	40213201	1984-05-17	1984-05-17 00:00:00	1984-05-17	1984-05-17 00:00:00	1984-05-17	581452		0	0	0		0	0	0	277538	0	33	40213201		
45871	3796	1127433	2019-03-11	2019-03-11 00:00:00	2019-03-18	2019-03-18 00:00:00	2019-03-18	38000177		0	0	7		0	0	0	252380	0	313782	1127433		
1639	129	1118084	2014-03-21	2014-03-21 00:00:00	2014-03-21	2014-03-21 00:00:00	\N	38000177		0	0	0		0	0	0	8669	0	00025152531	44923712		
146181	3215	40213160	1981-10-05	1981-10-05 00:00:00	1981-10-05	1981-10-05 00:00:00	1981-10-05	581452		0	0	0		0	0	0	213586	0	10	40213160		
38550	3183	1127433	1999-07-04	1999-07-04 00:00:00	1999-09-02	1999-09-02 00:00:00	1999-09-02	38000177		0	0	60		0	0	0	211918	0	313782	1127433		
162944	3583	40213296	2012-04-10	2012-04-10 00:00:00	2012-04-10	2012-04-10 00:00:00	2012-04-10	581452		0	0	0		0	0	0	238199	0	52	40213296		
10563	225	40213260	2016-09-26	2016-09-26 00:00:00	2016-09-26	2016-09-26 00:00:00	2016-09-26	581452		0	0	0		0	0	0	15137	0	121	40213260		
29220	2418	1127433	1989-05-14	1989-05-14 00:00:00	1989-05-28	1989-05-28 00:00:00	1989-05-28	38000177		0	0	14		0	0	0	160421	0	313782	1127433		
60251	1318	40213227	1992-03-31	1992-03-31 00:00:00	1992-03-31	1992-03-31 00:00:00	1992-03-31	581452		0	0	0		0	0	0	87380	0	113	40213227		
33606	2781	1127433	1985-05-02	1985-05-02 00:00:00	1985-05-09	1985-05-09 00:00:00	1985-05-09	38000177		0	0	7		0	0	0	184291	0	313782	1127433		
17485	1447	19078461	2019-05-18	2019-05-18 00:00:00	2019-06-01	2019-06-01 00:00:00	2019-06-01	38000177		0	0	14		0	0	0	96524	0	310965	19078461		
15945	1322	19133905	2014-07-30	2014-07-30 00:00:00	2014-08-12	2014-08-12 00:00:00	2014-08-12	38000177		0	0	13		0	0	0	87775	0	834102	19133905		
775	63	19133873	1960-11-18	1960-11-18 00:00:00	1960-11-30	1960-11-30 00:00:00	1960-11-30	38000177		0	0	12		0	0	0	4300	0	834061	19133873		
16038	1328	40169281	1983-12-08	1983-12-08 00:00:00	1983-12-08	1983-12-08 00:00:00	\N	38000177		0	0	0		0	0	0	88228	0	896209	40169281		
16057	1332	1118084	1979-12-10	1979-12-10 00:00:00	1979-12-10	1979-12-10 00:00:00	\N	38000177		0	0	0		0	0	0	88381	0	00025152531	44923712		
233536	5132	40213160	1971-06-07	1971-06-07 00:00:00	1971-06-07	1971-06-07 00:00:00	1971-06-07	581452		0	0	0		0	0	0	341121	0	10	40213160		
29951	2481	19078461	1984-06-01	1984-06-01 00:00:00	1984-06-29	1984-06-29 00:00:00	1984-06-29	38000177		0	0	28		0	0	0	164388	0	310965	19078461		
221508	4860	40213160	1979-01-05	1979-01-05 00:00:00	1979-01-05	1979-01-05 00:00:00	1979-01-05	581452		0	0	0		0	0	0	323300	0	10	40213160		
54680	4543	1127433	1984-04-16	1984-04-16 00:00:00	1984-04-30	1984-04-30 00:00:00	1984-04-30	38000177		0	0	14		0	0	0	302603	0	313782	1127433		
40554	3362	1713671	1971-12-23	1971-12-23 00:00:00	1972-01-13	1972-01-13 00:00:00	1972-01-13	38000177		0	0	21		0	0	0	222883	0	562251	1713671		
22071	1814	19008572	1971-04-23	1971-04-23 00:00:00	1971-04-23	1971-04-23 00:00:00	\N	38000177		0	0	0		0	0	0	121382	0	106258	19008572		
90317	1982	40213227	1992-10-29	1992-10-29 00:00:00	1992-10-29	1992-10-29 00:00:00	1992-10-29	581452		0	0	0		0	0	0	132065	0	113	40213227		
47831	3966	40236824	2017-01-08	2017-01-08 00:00:00	2017-01-15	2017-01-15 00:00:00	2017-01-15	38000177		0	0	7		0	0	0	263710	0	1094107	40236824		
58311	4844	1124300	2001-01-06	2001-01-06 00:00:00	2001-01-06	2001-01-06 00:00:00	\N	38000177		0	0	0		0	0	0	322322	0	00781178901	45011828		
131778	2895	40213160	1958-06-01	1958-06-01 00:00:00	1958-06-01	1958-06-01 00:00:00	1958-06-01	581452		0	0	0		0	0	0	192743	0	10	40213160		
41074	3408	19059056	1971-10-25	1971-10-25 00:00:00	1971-11-08	1971-11-08 00:00:00	1971-11-08	38000177		0	0	14		0	0	0	226001	0	243670	19059056		
106321	2332	40213160	1958-01-04	1958-01-04 00:00:00	1958-01-04	1958-01-04 00:00:00	1958-01-04	581452		0	0	0		0	0	0	155066	0	10	40213160		
4354	362	19059056	1989-10-06	1989-10-06 00:00:00	1989-11-03	1989-11-03 00:00:00	1989-11-03	38000177		0	0	28		0	0	0	24052	0	243670	19059056		
53534	4451	19006318	1954-06-26	1954-06-26 00:00:00	1954-07-10	1954-07-10 00:00:00	1954-07-10	38000177		0	0	14		0	0	0	296137	0	105078	19006318		
56239	1231	40213201	2005-05-05	2005-05-05 00:00:00	2005-05-05	2005-05-05 00:00:00	2005-05-05	581452		0	0	0		0	0	0	81162	0	33	40213201		
64087	5322	1127433	1989-04-21	1989-04-21 00:00:00	1989-04-28	1989-04-28 00:00:00	1989-04-28	38000177		0	0	7		0	0	0	354124	0	313782	1127433		
15401	332	40213306	1985-10-11	1985-10-11 00:00:00	1985-10-11	1985-10-11 00:00:00	1985-10-11	581452		0	0	0		0	0	0	21953	0	43	40213306		
6196	518	19129655	1973-01-27	1973-01-27 00:00:00	1973-02-10	1973-02-10 00:00:00	1973-02-10	38000177		0	0	14		0	0	0	34620	0	789980	19129655		
124676	2743	40213260	2010-04-07	2010-04-07 00:00:00	2010-04-07	2010-04-07 00:00:00	2010-04-07	581452		0	0	0		0	0	0	181481	0	121	40213260		
8921	744	19133905	2009-11-03	2009-11-03 00:00:00	2009-11-10	2009-11-10 00:00:00	2009-11-10	38000177		0	0	7		0	0	0	49350	0	834102	19133905		
19463	1605	19059056	1937-11-03	1937-11-03 00:00:00	1937-11-17	1937-11-17 00:00:00	1937-11-17	38000177		0	0	14		0	0	0	107681	0	243670	19059056		
36923	3053	920300	2015-03-25	2015-03-25 00:00:00	2015-04-01	2015-04-01 00:00:00	2015-04-01	38000177		0	0	7		0	0	0	203128	0	311989	920300		
594	43	19059056	1987-03-10	1987-03-10 00:00:00	1987-04-09	1987-04-09 00:00:00	1987-04-09	38000177		0	0	30		0	0	0	3154	0	243670	19059056		
47504	3938	1127433	1915-01-26	1915-01-26 00:00:00	1915-02-02	1915-02-02 00:00:00	1915-02-02	38000177		0	0	7		0	0	0	261772	0	313782	1127433		
47554	3941	1713671	1982-01-20	1982-01-20 00:00:00	1982-01-27	1982-01-27 00:00:00	1982-01-27	38000177		0	0	7		0	0	0	261999	0	562251	1713671		
102352	2243	40213227	2017-01-27	2017-01-27 00:00:00	2017-01-27	2017-01-27 00:00:00	2017-01-27	581452		0	0	0		0	0	0	149359	0	113	40213227		
43454	3603	40169216	1969-02-12	1969-02-12 00:00:00	1986-07-13	1986-07-13 00:00:00	1986-07-13	38000177		0	0	6360		0	0	0	239374	0	895994	40169216		
147644	3246	40213306	2002-07-01	2002-07-01 00:00:00	2002-07-01	2002-07-01 00:00:00	2002-07-01	581452		0	0	0		0	0	0	215797	0	43	40213306		
210389	4613	40213227	1999-02-28	1999-02-28 00:00:00	1999-02-28	1999-02-28 00:00:00	1999-02-28	581452		0	0	0		0	0	0	307328	0	113	40213227		
2393	191	40229134	1946-04-17	1946-04-17 00:00:00	1946-05-01	1946-05-01 00:00:00	1946-05-01	38000177		0	0	14		0	0	0	13062	0	1043400	40229134		
7962	665	1713671	2013-06-02	2013-06-02 00:00:00	2013-06-23	2013-06-23 00:00:00	2013-06-23	38000177		0	0	21		0	0	0	43995	0	562251	1713671		
88796	1947	40213201	2015-07-26	2015-07-26 00:00:00	2015-07-26	2015-07-26 00:00:00	2015-07-26	581452		0	0	0		0	0	0	129440	0	33	40213201		
39607	3275	19059056	1973-09-28	1973-09-28 00:00:00	1973-11-27	1973-11-27 00:00:00	1973-11-27	38000177		0	0	60		0	0	0	217602	0	243670	19059056		
57594	4782	1127433	1998-07-16	1998-07-16 00:00:00	1998-07-23	1998-07-23 00:00:00	1998-07-23	38000177		0	0	7		0	0	0	318365	0	313782	1127433		
60294	5014	19133873	1927-11-20	1927-11-20 00:00:00	1927-12-03	1927-12-03 00:00:00	1927-12-03	38000177		0	0	13		0	0	0	333259	0	834061	19133873		
134866	2960	40213227	2006-02-09	2006-02-09 00:00:00	2006-02-09	2006-02-09 00:00:00	2006-02-09	581452		0	0	0		0	0	0	197668	0	113	40213227		
45563	3771	19133873	1981-04-13	1981-04-13 00:00:00	1981-04-21	1981-04-21 00:00:00	1981-04-21	38000177		0	0	8		0	0	0	250632	0	834061	19133873		
129954	2857	40213260	2015-09-10	2015-09-10 00:00:00	2015-09-10	2015-09-10 00:00:00	2015-09-10	581452		0	0	0		0	0	0	189735	0	121	40213260		
51863	4312	1713671	1989-12-20	1989-12-20 00:00:00	1989-12-27	1989-12-27 00:00:00	1989-12-27	38000177		0	0	7		0	0	0	286145	0	562251	1713671		
57243	4753	19128065	1980-05-08	1980-05-08 00:00:00	1981-05-03	1981-05-03 00:00:00	1981-05-03	38000177		0	0	360		0	0	0	316521	0	749882	19128065		
51950	4320	46275444	1970-05-14	1970-05-14 00:00:00	1970-05-14	1970-05-14 00:00:00	1970-05-14	38000177		0	0	0		0	0	0	286692	0	1659149	46275444		
184921	4064	40213160	1960-08-15	1960-08-15 00:00:00	1960-08-15	1960-08-15 00:00:00	1960-08-15	581452		0	0	0		0	0	0	270032	0	10	40213160		
62517	5200	1118084	1989-01-25	1989-01-25 00:00:00	1989-01-25	1989-01-25 00:00:00	\N	38000177		0	0	0		0	0	0	345924	0	00025152531	44923712		
39390	3253	19134077	2005-04-15	2005-04-15 00:00:00	2005-05-06	2005-05-06 00:00:00	2005-05-06	38000177		0	0	21		0	0	0	216294	0	835900	19134077		
42074	3488	19059056	1954-04-20	1954-04-20 00:00:00	1954-05-04	1954-05-04 00:00:00	1954-05-04	38000177		0	0	14		0	0	0	231345	0	243670	19059056		
3975	331	19059056	1936-10-23	1936-10-23 00:00:00	1936-11-06	1936-11-06 00:00:00	1936-11-06	38000177		0	0	14		0	0	0	21786	0	243670	19059056		
19088	1576	1127433	1983-12-17	1983-12-17 00:00:00	1984-02-15	1984-02-15 00:00:00	1984-02-15	38000177		0	0	60		0	0	0	105775	0	313782	1127433		
35259	2906	40236824	1979-05-14	1979-05-14 00:00:00	1979-05-21	1979-05-21 00:00:00	1979-05-21	38000177		0	0	7		0	0	0	193738	0	1094107	40236824		
16505	357	40213296	1996-10-23	1996-10-23 00:00:00	1996-10-23	1996-10-23 00:00:00	1996-10-23	581452		0	0	0		0	0	0	23749	0	52	40213296		
190153	4176	40213227	1999-08-12	1999-08-12 00:00:00	1999-08-12	1999-08-12 00:00:00	1999-08-12	581452		0	0	0		0	0	0	277485	0	113	40213227		
45891	3799	19059056	1972-09-18	1972-09-18 00:00:00	1972-10-02	1972-10-02 00:00:00	1972-10-02	38000177		0	0	14		0	0	0	252534	0	243670	19059056		
1640	129	1127078	1983-04-23	1983-04-23 00:00:00	1983-05-14	1983-05-14 00:00:00	1983-05-14	38000177		0	0	21		0	0	0	8704	0	282464	1127078		
146186	3215	40213160	1978-03-13	1978-03-13 00:00:00	1978-03-13	1978-03-13 00:00:00	1978-03-13	581452		0	0	0		0	0	0	213570	0	10	40213160		
38551	3183	40231925	1999-07-04	1999-07-04 00:00:00	1999-07-04	1999-07-04 00:00:00	\N	38000177		0	0	0		0	0	0	211918	0	1049221	40231925		
162946	3583	40213227	2002-03-26	2002-03-26 00:00:00	2002-03-26	2002-03-26 00:00:00	2002-03-26	581452		0	0	0		0	0	0	238179	0	113	40213227		
10566	225	40213296	2005-01-10	2005-01-10 00:00:00	2005-01-10	2005-01-10 00:00:00	2005-01-10	581452		0	0	0		0	0	0	15236	0	52	40213296		
29221	2418	40236824	1998-09-22	1998-09-22 00:00:00	1998-09-29	1998-09-29 00:00:00	1998-09-29	38000177		0	0	7		0	0	0	160443	0	1094107	40236824		
60255	1318	40213227	1999-06-22	1999-06-22 00:00:00	1999-06-22	1999-06-22 00:00:00	1999-06-22	581452		0	0	0		0	0	0	87391	0	113	40213227		
33607	2781	1127433	2014-01-18	2014-01-18 00:00:00	2014-01-25	2014-01-25 00:00:00	2014-01-25	38000177		0	0	7		0	0	0	184315	0	313782	1127433		
17486	1447	920300	2009-08-31	2009-08-31 00:00:00	2009-09-07	2009-09-07 00:00:00	2009-09-07	38000177		0	0	7		0	0	0	96486	0	311989	920300		
15946	1322	19075601	2019-01-30	2019-01-30 00:00:00	2019-01-30	2019-01-30 00:00:00	2019-01-30	38000177		0	0	0		0	0	0	87724	0	309362	19075601		
776	63	1127433	1995-11-01	1995-11-01 00:00:00	1995-11-15	1995-11-15 00:00:00	1995-11-15	38000177		0	0	14		0	0	0	4283	0	313782	1127433		
16049	1332	1713671	2002-08-09	2002-08-09 00:00:00	2002-08-16	2002-08-16 00:00:00	2002-08-16	38000177		0	0	7		0	0	0	88348	0	562251	1713671		
16058	1332	1127433	1979-12-05	1979-12-05 00:00:00	1980-01-04	1980-01-04 00:00:00	1980-01-04	38000177		0	0	30		0	0	0	88381	0	313782	1127433		
8492	709	1124300	1988-07-13	1988-07-13 00:00:00	1988-07-13	1988-07-13 00:00:00	\N	38000177		0	0	0		0	0	0	46927	0	00781178901	45011828		
29952	2482	1127433	1975-09-08	1975-09-08 00:00:00	1975-09-22	1975-09-22 00:00:00	1975-09-22	38000177		0	0	14		0	0	0	164422	0	313782	1127433		
221509	4860	40213314	1979-01-05	1979-01-05 00:00:00	1979-01-05	1979-01-05 00:00:00	1979-01-05	581452		0	0	0		0	0	0	323300	0	49	40213314		
54681	4543	1127078	1984-07-13	1984-07-13 00:00:00	1984-08-03	1984-08-03 00:00:00	1984-08-03	38000177		0	0	21		0	0	0	302640	0	282464	1127078		
40555	3362	1127433	1981-09-10	1981-09-10 00:00:00	1981-10-08	1981-10-08 00:00:00	1981-10-08	38000177		0	0	28		0	0	0	222891	0	313782	1127433		
22072	1814	1118084	1981-10-22	1981-10-22 00:00:00	1981-10-22	1981-10-22 00:00:00	\N	38000177		0	0	0		0	0	0	121392	0	00025152531	44923712		
19371	421	40213260	2016-06-22	2016-06-22 00:00:00	2016-06-22	2016-06-22 00:00:00	2016-06-22	581452		0	0	0		0	0	0	27869	0	121	40213260		
47832	3966	920300	2017-01-08	2017-01-08 00:00:00	2017-01-15	2017-01-15 00:00:00	2017-01-15	38000177		0	0	7		0	0	0	263710	0	311989	920300		
58312	4844	19059056	1981-05-15	1981-05-15 00:00:00	1981-06-19	1981-06-19 00:00:00	1981-06-19	38000177		0	0	35		0	0	0	322283	0	243670	19059056		
131783	2895	40213160	1958-08-31	1958-08-31 00:00:00	1958-08-31	1958-08-31 00:00:00	1958-08-31	581452		0	0	0		0	0	0	192697	0	10	40213160		
41075	3408	1115171	1998-05-04	1998-05-04 00:00:00	1998-05-18	1998-05-18 00:00:00	1998-05-18	38000177		0	0	14		0	0	0	226021	0	849574	1115171		
34091	2818	40229134	2004-04-30	2004-04-30 00:00:00	2004-05-14	2004-05-14 00:00:00	2004-05-14	38000177		0	0	14		0	0	0	186721	0	1043400	40229134		
4355	362	19073183	1982-07-15	1982-07-15 00:00:00	1982-07-29	1982-07-29 00:00:00	1982-07-29	38000177		0	0	14		0	0	0	24056	0	308182	19073183		
53535	4451	19078461	1976-04-01	1976-04-01 00:00:00	1976-05-01	1976-05-01 00:00:00	1976-05-01	38000177		0	0	30		0	0	0	296138	0	310965	19078461		
56244	1231	40213227	2000-04-06	2000-04-06 00:00:00	2000-04-06	2000-04-06 00:00:00	2000-04-06	581452		0	0	0		0	0	0	81064	0	113	40213227		
64088	5322	19133905	1994-02-18	1994-02-18 00:00:00	1994-03-02	1994-03-02 00:00:00	1994-03-02	38000177		0	0	12		0	0	0	354140	0	834102	19133905		
15403	332	40213260	2013-06-14	2013-06-14 00:00:00	2013-06-14	2013-06-14 00:00:00	2013-06-14	581452		0	0	0		0	0	0	22002	0	121	40213260		
6197	518	19059056	1973-01-27	1973-01-27 00:00:00	1973-02-10	1973-02-10 00:00:00	1973-02-10	38000177		0	0	14		0	0	0	34620	0	243670	19059056		
124681	2743	40213160	1965-03-10	1965-03-10 00:00:00	1965-03-10	1965-03-10 00:00:00	1965-03-10	581452		0	0	0		0	0	0	181496	0	10	40213160		
8922	744	1127433	1983-12-07	1983-12-07 00:00:00	1983-12-28	1983-12-28 00:00:00	1983-12-28	38000177		0	0	21		0	0	0	49354	0	313782	1127433		
19464	1605	1127433	1958-06-08	1958-06-08 00:00:00	1958-07-08	1958-07-08 00:00:00	1958-07-08	38000177		0	0	30		0	0	0	107747	0	313782	1127433		
36940	3056	1127433	1991-01-26	1991-01-26 00:00:00	1991-02-02	1991-02-02 00:00:00	1991-02-02	38000177		0	0	7		0	0	0	203291	0	313782	1127433		
595	43	19133873	1961-02-11	1961-02-11 00:00:00	1961-02-18	1961-02-18 00:00:00	1961-02-18	38000177		0	0	7		0	0	0	3190	0	834061	19133873		
47505	3938	1124300	1949-06-06	1949-06-06 00:00:00	1949-06-06	1949-06-06 00:00:00	\N	38000177		0	0	0		0	0	0	261750	0	00781178901	45011828		
131989	2899	40213227	2010-10-28	2010-10-28 00:00:00	2010-10-28	2010-10-28 00:00:00	2010-10-28	581452		0	0	0		0	0	0	193193	0	113	40213227		
102353	2243	40213260	2017-01-27	2017-01-27 00:00:00	2017-01-27	2017-01-27 00:00:00	2017-01-27	581452		0	0	0		0	0	0	149359	0	121	40213260		
43455	3603	1154615	1969-02-12	1969-02-12 00:00:00	1986-07-13	1986-07-13 00:00:00	1986-07-13	38000177		0	0	6360		0	0	0	239374	0	745679	1154615		
147646	3246	40213306	2002-10-21	2002-10-21 00:00:00	2002-10-21	2002-10-21 00:00:00	2002-10-21	581452		0	0	0		0	0	0	\N	0	43	40213306		
210975	4626	40213160	1976-04-12	1976-04-12 00:00:00	1976-04-12	1976-04-12 00:00:00	1976-04-12	581452		0	0	0		0	0	0	308254	0	10	40213160		
2394	191	19059056	1929-09-12	1929-09-12 00:00:00	1929-11-18	1929-11-18 00:00:00	1929-11-18	38000177		0	0	67		0	0	0	13038	0	243670	19059056		
7963	665	1713671	1964-07-08	1964-07-08 00:00:00	1964-07-15	1964-07-15 00:00:00	1964-07-15	38000177		0	0	7		0	0	0	43941	0	562251	1713671		
88799	1947	40213160	1955-07-10	1955-07-10 00:00:00	1955-07-10	1955-07-10 00:00:00	1955-07-10	581452		0	0	0		0	0	0	129409	0	10	40213160		
39609	3275	40229134	1996-10-21	1996-10-21 00:00:00	1996-11-04	1996-11-04 00:00:00	1996-11-04	38000177		0	0	14		0	0	0	217610	0	1043400	40229134		
57595	4782	19128065	2000-03-25	2000-03-25 00:00:00	2001-03-20	2001-03-20 00:00:00	2001-03-20	38000177		0	0	360		0	0	0	318308	0	749882	19128065		
60295	5014	1127433	1949-05-05	1949-05-05 00:00:00	1949-05-19	1949-05-19 00:00:00	1949-05-19	38000177		0	0	14		0	0	0	333262	0	313782	1127433		
134869	2960	40213260	2007-02-15	2007-02-15 00:00:00	2007-02-15	2007-02-15 00:00:00	2007-02-15	581452		0	0	0		0	0	0	197651	0	121	40213260		
45564	3771	1713671	1967-06-18	1967-06-18 00:00:00	1967-06-25	1967-06-25 00:00:00	1967-06-25	38000177		0	0	7		0	0	0	250631	0	562251	1713671		
156028	3434	40213227	2009-06-04	2009-06-04 00:00:00	2009-06-04	2009-06-04 00:00:00	2009-06-04	581452		0	0	0		0	0	0	227722	0	113	40213227		
51864	4312	19006318	1959-12-15	1959-12-15 00:00:00	1959-12-29	1959-12-29 00:00:00	1959-12-29	38000177		0	0	14		0	0	0	286056	0	105078	19006318		
57244	4753	1127433	1973-04-24	1973-04-24 00:00:00	1973-05-08	1973-05-08 00:00:00	1973-05-08	38000177		0	0	14		0	0	0	316550	0	313782	1127433		
51951	4320	35605482	1970-05-14	1970-05-14 00:00:00	1970-05-14	1970-05-14 00:00:00	1970-05-14	38000177		0	0	0		0	0	0	286692	0	1740467	35605482		
184923	4064	40213260	2010-11-08	2010-11-08 00:00:00	2010-11-08	2010-11-08 00:00:00	2010-11-08	581452		0	0	0		0	0	0	270027	0	121	40213260		
62518	5200	19078461	1974-05-21	1974-05-21 00:00:00	1974-06-11	1974-06-11 00:00:00	1974-06-11	38000177		0	0	21		0	0	0	345939	0	310965	19078461		
39391	3253	1124300	2005-12-31	2005-12-31 00:00:00	2005-12-31	2005-12-31 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00781178901	45011828		
42075	3488	19006318	1954-04-20	1954-04-20 00:00:00	1954-05-04	1954-05-04 00:00:00	1954-05-04	38000177		0	0	14		0	0	0	231345	0	105078	19006318		
3976	331	19059056	1956-03-24	1956-03-24 00:00:00	1956-04-21	1956-04-21 00:00:00	1956-04-21	38000177		0	0	28		0	0	0	21810	0	243670	19059056		
19089	1576	19128065	1982-10-05	1982-10-05 00:00:00	1983-09-30	1983-09-30 00:00:00	1983-09-30	38000177		0	0	360		0	0	0	105784	0	749882	19128065		
35260	2906	19059056	1929-01-23	1929-01-23 00:00:00	1929-03-24	1929-03-24 00:00:00	1929-03-24	38000177		0	0	60		0	0	0	193667	0	243670	19059056		
16507	357	40213227	1996-10-23	1996-10-23 00:00:00	1996-10-23	1996-10-23 00:00:00	1996-10-23	581452		0	0	0		0	0	0	23749	0	113	40213227		
190185	4176	40213227	2009-10-08	2009-10-08 00:00:00	2009-10-08	2009-10-08 00:00:00	2009-10-08	581452		0	0	0		0	0	0	277500	0	113	40213227		
45892	3799	19133873	1978-03-22	1978-03-22 00:00:00	1978-03-29	1978-03-29 00:00:00	1978-03-29	38000177		0	0	7		0	0	0	252571	0	834061	19133873		
1641	129	19059056	1989-02-11	1989-02-11 00:00:00	1989-03-04	1989-03-04 00:00:00	1989-03-04	38000177		0	0	21		0	0	0	8705	0	243670	19059056		
146187	3215	40213314	1978-03-13	1978-03-13 00:00:00	1978-03-13	1978-03-13 00:00:00	1978-03-13	581452		0	0	0		0	0	0	213570	0	49	40213314		
38552	3183	19073183	1983-04-29	1983-04-29 00:00:00	1983-05-13	1983-05-13 00:00:00	1983-05-13	38000177		0	0	14		0	0	0	211900	0	308182	19073183		
162953	3583	40213160	1973-10-16	1973-10-16 00:00:00	1973-10-16	1973-10-16 00:00:00	1973-10-16	581452		0	0	0		0	0	0	238200	0	10	40213160		
10575	225	40213260	2015-09-21	2015-09-21 00:00:00	2015-09-21	2015-09-21 00:00:00	2015-09-21	581452		0	0	0		0	0	0	15168	0	121	40213260		
29222	2418	920300	1998-09-22	1998-09-22 00:00:00	1998-09-29	1998-09-29 00:00:00	1998-09-29	38000177		0	0	7		0	0	0	160443	0	311989	920300		
5319	445	19059056	1917-06-22	1917-06-22 00:00:00	1917-07-06	1917-07-06 00:00:00	1917-07-06	38000177		0	0	14		0	0	0	29594	0	243670	19059056		
33608	2781	1127433	1996-01-18	1996-01-18 00:00:00	1996-02-01	1996-02-01 00:00:00	1996-02-01	38000177		0	0	14		0	0	0	184330	0	313782	1127433		
17487	1447	40236824	2009-08-31	2009-08-31 00:00:00	2009-09-07	2009-09-07 00:00:00	2009-09-07	38000177		0	0	7		0	0	0	96486	0	1094107	40236824		
15947	1322	40220960	2019-01-30	2019-01-30 00:00:00	2019-01-30	2019-01-30 00:00:00	2019-01-30	38000177		0	0	0		0	0	0	87724	0	1804799	40220960		
777	63	1713671	1995-11-20	1995-11-20 00:00:00	1995-11-27	1995-11-27 00:00:00	1995-11-27	38000177		0	0	7		0	0	0	4239	0	562251	1713671		
16050	1332	40229134	1970-05-12	1970-05-12 00:00:00	1970-05-19	1970-05-19 00:00:00	1970-05-19	38000177		0	0	7		0	0	0	88366	0	1043400	40229134		
16059	1332	1127433	1984-07-11	1984-07-11 00:00:00	1984-08-01	1984-08-01 00:00:00	1984-08-01	38000177		0	0	21		0	0	0	88382	0	313782	1127433		
8493	709	40229134	1953-04-14	1953-04-14 00:00:00	1953-04-21	1953-04-21 00:00:00	1953-04-21	38000177		0	0	7		0	0	0	46959	0	1043400	40229134		
29953	2482	40165015	1995-03-03	1995-03-03 00:00:00	1995-03-03	1995-03-03 00:00:00	\N	38000177		0	0	0		0	0	0	164454	0	861467	40165015		
22411	1843	1713671	1992-11-02	1992-11-02 00:00:00	1992-11-09	1992-11-09 00:00:00	1992-11-09	38000177		0	0	7		0	0	0	123057	0	562251	1713671		
54682	4543	19133873	1988-08-23	1988-08-23 00:00:00	1988-09-02	1988-09-02 00:00:00	1988-09-02	38000177		0	0	10		0	0	0	302622	0	834061	19133873		
40556	3362	1127433	2010-12-10	2010-12-10 00:00:00	2011-01-07	2011-01-07 00:00:00	2011-01-07	38000177		0	0	28		0	0	0	222894	0	313782	1127433		
22073	1814	1713671	2000-10-11	2000-10-11 00:00:00	2000-11-01	2000-11-01 00:00:00	2000-11-01	38000177		0	0	21		0	0	0	121443	0	562251	1713671		
19373	421	40213227	2016-06-22	2016-06-22 00:00:00	2016-06-22	2016-06-22 00:00:00	2016-06-22	581452		0	0	0		0	0	0	27869	0	113	40213227		
47833	3966	19128065	1986-11-05	1986-11-05 00:00:00	1987-10-31	1987-10-31 00:00:00	1987-10-31	38000177		0	0	360		0	0	0	263687	0	749882	19128065		
58313	4844	40229134	2001-09-12	2001-09-12 00:00:00	2001-09-19	2001-09-19 00:00:00	2001-09-19	38000177		0	0	7		0	0	0	322218	0	1043400	40229134		
131792	2896	40213160	1969-11-30	1969-11-30 00:00:00	1969-11-30	1969-11-30 00:00:00	1969-11-30	581452		0	0	0		0	0	0	192824	0	10	40213160		
41076	3408	19133905	1992-08-30	1992-08-30 00:00:00	1992-09-11	1992-09-11 00:00:00	1992-09-11	38000177		0	0	12		0	0	0	226033	0	834102	19133905		
34092	2818	1127078	1969-11-23	1969-11-23 00:00:00	1969-12-28	1969-12-28 00:00:00	1969-12-28	38000177		0	0	35		0	0	0	186726	0	282464	1127078		
4356	362	19019979	1982-07-15	1982-07-15 00:00:00	1982-07-29	1982-07-29 00:00:00	1982-07-29	38000177		0	0	14		0	0	0	24056	0	198405	19019979		
53536	4451	1713671	1984-09-05	1984-09-05 00:00:00	1984-09-26	1984-09-26 00:00:00	1984-09-26	38000177		0	0	21		0	0	0	296132	0	562251	1713671		
97874	2145	40213227	2014-12-27	2014-12-27 00:00:00	2014-12-27	2014-12-27 00:00:00	2014-12-27	581452		0	0	0		0	0	0	142828	0	113	40213227		
64089	5322	40169216	1951-01-28	1951-01-28 00:00:00	1951-01-28	1951-01-28 00:00:00	\N	38000177		0	0	0		0	0	0	354266	0	895994	40169216		
15411	332	40213227	2014-06-20	2014-06-20 00:00:00	2014-06-20	2014-06-20 00:00:00	2014-06-20	581452		0	0	0		0	0	0	21955	0	113	40213227		
6198	518	1127078	1974-10-02	1974-10-02 00:00:00	1974-10-16	1974-10-16 00:00:00	1974-10-16	38000177		0	0	14		0	0	0	34616	0	282464	1127078		
124686	2743	40213160	1960-12-14	1960-12-14 00:00:00	1960-12-14	1960-12-14 00:00:00	1960-12-14	581452		0	0	0		0	0	0	181443	0	10	40213160		
8923	744	1713671	2015-04-08	2015-04-08 00:00:00	2015-04-15	2015-04-15 00:00:00	2015-04-15	38000177		0	0	7		0	0	0	49331	0	562251	1713671		
2995	244	19059056	1938-02-09	1938-02-09 00:00:00	1938-02-23	1938-02-23 00:00:00	1938-02-23	38000177		0	0	14		0	0	0	16359	0	243670	19059056		
36941	3056	1154615	1960-01-04	1960-01-04 00:00:00	1960-01-04	1960-01-04 00:00:00	\N	38000177		0	0	0		0	0	0	203235	0	745679	1154615		
596	43	1127433	1978-12-23	1978-12-23 00:00:00	1979-01-06	1979-01-06 00:00:00	1979-01-06	38000177		0	0	14		0	0	0	3159	0	313782	1127433		
47506	3938	40229134	1956-02-04	1956-02-04 00:00:00	1956-02-11	1956-02-11 00:00:00	1956-02-11	38000177		0	0	7		0	0	0	261720	0	1043400	40229134		
181121	3980	40213160	1975-07-06	1975-07-06 00:00:00	1975-07-06	1975-07-06 00:00:00	1975-07-06	581452		0	0	0		0	0	0	264567	0	10	40213160		
102358	2243	40213160	1966-07-01	1966-07-01 00:00:00	1966-07-01	1966-07-01 00:00:00	1966-07-01	581452		0	0	0		0	0	0	149376	0	10	40213160		
43456	3603	1127433	1974-06-14	1974-06-14 00:00:00	1974-06-21	1974-06-21 00:00:00	1974-06-21	38000177		0	0	7		0	0	0	239361	0	313782	1127433		
147649	3246	40213160	1980-06-30	1980-06-30 00:00:00	1980-06-30	1980-06-30 00:00:00	1980-06-30	581452		0	0	0		0	0	0	215768	0	10	40213160		
210978	4626	40213296	2015-11-09	2015-11-09 00:00:00	2015-11-09	2015-11-09 00:00:00	2015-11-09	581452		0	0	0		0	0	0	308195	0	52	40213296		
2395	191	1713671	1931-03-10	1931-03-10 00:00:00	1931-03-17	1931-03-17 00:00:00	1931-03-17	38000177		0	0	7		0	0	0	13061	0	562251	1713671		
7964	665	19059056	1992-02-22	1992-02-22 00:00:00	1992-03-14	1992-03-14 00:00:00	1992-03-14	38000177		0	0	21		0	0	0	43939	0	243670	19059056		
59211	4922	1127433	2007-08-01	2007-08-01 00:00:00	2007-08-08	2007-08-08 00:00:00	2007-08-08	38000177		0	0	7		0	0	0	327078	0	313782	1127433		
39610	3275	1127433	1993-04-02	1993-04-02 00:00:00	1993-04-09	1993-04-09 00:00:00	1993-04-09	38000177		0	0	7		0	0	0	217609	0	313782	1127433		
57596	4782	42902245	2001-03-20	2001-03-20 00:00:00	2002-03-15	2002-03-15 00:00:00	2002-03-15	38000177		0	0	360		0	0	0	318309	0	1359133	42902245		
60296	5014	19059056	1953-09-06	1953-09-06 00:00:00	1953-10-11	1953-10-11 00:00:00	1953-10-11	38000177		0	0	35		0	0	0	333254	0	243670	19059056		
134880	2960	40213227	2016-04-07	2016-04-07 00:00:00	2016-04-07	2016-04-07 00:00:00	2016-04-07	581452		0	0	0		0	0	0	197686	0	113	40213227		
45565	3772	1127078	1980-07-17	1980-07-17 00:00:00	1980-09-15	1980-09-15 00:00:00	1980-09-15	38000177		0	0	60		0	0	0	250671	0	282464	1127078		
156036	3434	40213160	1955-04-14	1955-04-14 00:00:00	1955-04-14	1955-04-14 00:00:00	1955-04-14	581452		0	0	0		0	0	0	227712	0	10	40213160		
51865	4312	1127078	1959-12-15	1959-12-15 00:00:00	1959-12-29	1959-12-29 00:00:00	1959-12-29	38000177		0	0	14		0	0	0	286056	0	282464	1127078		
57245	4753	19128065	1982-04-28	1982-04-28 00:00:00	1983-04-23	1983-04-23 00:00:00	1983-04-23	38000177		0	0	360		0	0	0	316522	0	749882	19128065		
51952	4320	35605482	1970-05-14	1970-05-14 00:00:00	1970-05-14	1970-05-14 00:00:00	1970-05-14	38000177		0	0	0		0	0	0	286692	0	1740467	35605482		
184930	4064	40213160	1960-10-17	1960-10-17 00:00:00	1960-10-17	1960-10-17 00:00:00	1960-10-17	581452		0	0	0		0	0	0	270095	0	10	40213160		
62519	5200	19006318	1960-06-21	1960-06-21 00:00:00	1960-07-05	1960-07-05 00:00:00	1960-07-05	38000177		0	0	14		0	0	0	345814	0	105078	19006318		
39393	3253	19073188	2018-08-05	2018-08-05 00:00:00	2018-08-19	2018-08-19 00:00:00	2018-08-19	38000177		0	0	14		0	0	0	216247	0	308192	19073188		
42076	3488	19059056	1967-12-08	1967-12-08 00:00:00	1968-01-05	1968-01-05 00:00:00	1968-01-05	38000177		0	0	28		0	0	0	231355	0	243670	19059056		
3977	331	1118084	1974-11-08	1974-11-08 00:00:00	1974-11-08	1974-11-08 00:00:00	\N	38000177		0	0	0		0	0	0	21787	0	00025152531	44923712		
19090	1577	19078461	2013-12-16	2013-12-16 00:00:00	2014-01-06	2014-01-06 00:00:00	2014-01-06	38000177		0	0	21		0	0	0	105933	0	310965	19078461		
35261	2906	19059056	1936-08-14	1936-08-14 00:00:00	1936-08-28	1936-08-28 00:00:00	1936-08-28	38000177		0	0	14		0	0	0	193719	0	243670	19059056		
16508	357	40213160	1955-03-23	1955-03-23 00:00:00	1955-03-23	1955-03-23 00:00:00	1955-03-23	581452		0	0	0		0	0	0	23732	0	10	40213160		
178131	3916	40213296	2019-04-10	2019-04-10 00:00:00	2019-04-10	2019-04-10 00:00:00	2019-04-10	581452		0	0	0		0	0	0	\N	0	52	40213296		
45893	3799	1118084	2006-04-08	2006-04-08 00:00:00	2006-04-08	2006-04-08 00:00:00	\N	38000177		0	0	0		0	0	0	252543	0	00025152531	44923712		
1642	129	1713671	2010-08-30	2010-08-30 00:00:00	2010-10-04	2010-10-04 00:00:00	2010-10-04	38000177		0	0	35		0	0	0	8714	0	562251	1713671		
52569	1150	40213160	1955-12-21	1955-12-21 00:00:00	1955-12-21	1955-12-21 00:00:00	1955-12-21	581452		0	0	0		0	0	0	76010	0	10	40213160		
38553	3183	19019979	1983-04-29	1983-04-29 00:00:00	1983-05-13	1983-05-13 00:00:00	1983-05-13	38000177		0	0	14		0	0	0	211900	0	198405	19019979		
44474	969	40213160	1983-04-17	1983-04-17 00:00:00	1983-04-17	1983-04-17 00:00:00	1983-04-17	581452		0	0	0		0	0	0	64427	0	10	40213160		
10580	225	40213160	1965-06-14	1965-06-14 00:00:00	1965-06-14	1965-06-14 00:00:00	1965-06-14	581452		0	0	0		0	0	0	15252	0	10	40213160		
29223	2418	19128065	1992-08-05	1992-08-05 00:00:00	1993-07-31	1993-07-31 00:00:00	1993-07-31	38000177		0	0	360		0	0	0	160447	0	749882	19128065		
5357	449	1127433	1981-07-23	1981-07-23 00:00:00	1981-08-06	1981-08-06 00:00:00	1981-08-06	38000177		0	0	14		0	0	0	29874	0	313782	1127433		
33609	2781	1713671	2013-02-07	2013-02-07 00:00:00	2013-02-21	2013-02-21 00:00:00	2013-02-21	38000177		0	0	14		0	0	0	184319	0	562251	1713671		
17488	1447	1551192	1970-08-23	1970-08-23 00:00:00	1970-08-23	1970-08-23 00:00:00	1970-08-23	38000177		0	0	0		0	0	0	96481	0	312617	1551192		
15948	1322	1713671	1933-04-16	1933-04-16 00:00:00	1933-05-07	1933-05-07 00:00:00	1933-05-07	38000177		0	0	21		0	0	0	87734	0	562251	1713671		
778	63	1115171	2008-02-19	2008-02-19 00:00:00	2008-05-20	2008-05-20 00:00:00	2008-05-20	38000177		0	0	91		0	0	0	4299	0	849574	1115171		
16051	1332	1115171	2002-12-25	2002-12-25 00:00:00	2003-01-08	2003-01-08 00:00:00	2003-01-08	38000177		0	0	14		0	0	0	88383	0	849574	1115171		
16060	1332	1127078	1950-12-22	1950-12-22 00:00:00	1951-01-05	1951-01-05 00:00:00	1951-01-05	38000177		0	0	14		0	0	0	88316	0	282464	1127078		
8494	709	1127433	1987-06-05	1987-06-05 00:00:00	1987-06-19	1987-06-19 00:00:00	1987-06-19	38000177		0	0	14		0	0	0	46931	0	313782	1127433		
29954	2482	1115171	1995-03-03	1995-03-03 00:00:00	1995-05-02	1995-05-02 00:00:00	1995-05-02	38000177		0	0	60		0	0	0	164454	0	849574	1115171		
22412	1843	42902245	2004-06-29	2004-06-29 00:00:00	2005-06-24	2005-06-24 00:00:00	2005-06-24	38000177		0	0	360		0	0	0	123069	0	1359133	42902245		
54683	4543	42902245	1998-08-09	1998-08-09 00:00:00	1999-08-04	1999-08-04 00:00:00	1999-08-04	38000177		0	0	360		0	0	0	302627	0	1359133	42902245		
40557	3362	1713671	1967-04-18	1967-04-18 00:00:00	1967-05-09	1967-05-09 00:00:00	1967-05-09	38000177		0	0	21		0	0	0	222855	0	562251	1713671		
22074	1814	1115171	2009-12-12	2009-12-12 00:00:00	2010-02-10	2010-02-10 00:00:00	2010-02-10	38000177		0	0	60		0	0	0	121432	0	849574	1115171		
19375	422	40213306	1981-05-16	1981-05-16 00:00:00	1981-05-16	1981-05-16 00:00:00	1981-05-16	581452		0	0	0		0	0	0	27938	0	43	40213306		
47834	3966	1127433	2005-10-18	2005-10-18 00:00:00	2005-10-25	2005-10-25 00:00:00	2005-10-25	38000177		0	0	7		0	0	0	263635	0	313782	1127433		
237522	5215	40213201	2006-08-07	2006-08-07 00:00:00	2006-08-07	2006-08-07 00:00:00	2006-08-07	581452		0	0	0		0	0	0	\N	0	33	40213201		
131793	2896	40213160	1974-03-03	1974-03-03 00:00:00	1974-03-03	1974-03-03 00:00:00	1974-03-03	581452		0	0	0		0	0	0	192882	0	10	40213160		
41077	3408	1127433	2010-01-06	2010-01-06 00:00:00	2010-01-27	2010-01-27 00:00:00	2010-01-27	38000177		0	0	21		0	0	0	226023	0	313782	1127433		
34093	2818	1127433	1997-10-01	1997-10-01 00:00:00	1997-10-15	1997-10-15 00:00:00	1997-10-15	38000177		0	0	14		0	0	0	186756	0	313782	1127433		
4357	362	19133905	2009-10-09	2009-10-09 00:00:00	2009-10-22	2009-10-22 00:00:00	2009-10-22	38000177		0	0	13		0	0	0	24019	0	834102	19133905		
53537	4451	1713671	1961-07-28	1961-07-28 00:00:00	1961-08-11	1961-08-11 00:00:00	1961-08-11	38000177		0	0	14		0	0	0	296178	0	562251	1713671		
97875	2145	40213160	1964-03-28	1964-03-28 00:00:00	1964-03-28	1964-03-28 00:00:00	1964-03-28	581452		0	0	0		0	0	0	142794	0	10	40213160		
64090	5322	1154615	1951-01-28	1951-01-28 00:00:00	1951-01-28	1951-01-28 00:00:00	\N	38000177		0	0	0		0	0	0	354266	0	745679	1154615		
15412	332	40213260	2014-06-20	2014-06-20 00:00:00	2014-06-20	2014-06-20 00:00:00	2014-06-20	581452		0	0	0		0	0	0	21955	0	121	40213260		
6199	518	1127078	1977-04-24	1977-04-24 00:00:00	1977-05-24	1977-05-24 00:00:00	1977-05-24	38000177		0	0	30		0	0	0	34592	0	282464	1127078		
124690	2743	40213227	1994-06-15	1994-06-15 00:00:00	1994-06-15	1994-06-15 00:00:00	1994-06-15	581452		0	0	0		0	0	0	181484	0	113	40213227		
8924	744	19006318	1957-11-18	1957-11-18 00:00:00	1957-12-02	1957-12-02 00:00:00	1957-12-02	38000177		0	0	14		0	0	0	49365	0	105078	19006318		
2996	244	1127433	1923-06-23	1923-06-23 00:00:00	1923-06-30	1923-06-30 00:00:00	1923-06-30	38000177		0	0	7		0	0	0	16293	0	313782	1127433		
36942	3056	40169216	1960-01-04	1960-01-04 00:00:00	1960-01-04	1960-01-04 00:00:00	\N	38000177		0	0	0		0	0	0	203235	0	895994	40169216		
19511	1606	1124300	1989-05-12	1989-05-12 00:00:00	1989-05-12	1989-05-12 00:00:00	\N	38000177		0	0	0		0	0	0	107837	0	00781178901	45011828		
47507	3939	1127433	2008-09-28	2008-09-28 00:00:00	2008-10-05	2008-10-05 00:00:00	2008-10-05	38000177		0	0	7		0	0	0	261866	0	313782	1127433		
181124	3980	40213314	1978-04-02	1978-04-02 00:00:00	1978-04-02	1978-04-02 00:00:00	1978-04-02	581452		0	0	0		0	0	0	264570	0	49	40213314		
102361	2243	40213160	1966-09-30	1966-09-30 00:00:00	1966-09-30	1966-09-30 00:00:00	1966-09-30	581452		0	0	0		0	0	0	149314	0	10	40213160		
43457	3603	1127433	2017-06-08	2017-06-08 00:00:00	2017-06-22	2017-06-22 00:00:00	2017-06-22	38000177		0	0	14		0	0	0	239394	0	313782	1127433		
147658	3246	40213160	1980-01-28	1980-01-28 00:00:00	1980-01-28	1980-01-28 00:00:00	1980-01-28	581452		0	0	0		0	0	0	215767	0	10	40213160		
210983	4626	40213227	2007-01-01	2007-01-01 00:00:00	2007-01-01	2007-01-01 00:00:00	2007-01-01	581452		0	0	0		0	0	0	308209	0	113	40213227		
2396	191	1115171	1994-05-07	1994-05-07 00:00:00	1994-08-05	1994-08-05 00:00:00	1994-08-05	38000177		0	0	90		0	0	0	13042	0	849574	1115171		
46879	1024	40213227	2013-06-16	2013-06-16 00:00:00	2013-06-16	2013-06-16 00:00:00	2013-06-16	581452		0	0	0		0	0	0	67491	0	113	40213227		
59212	4922	1127433	1983-11-27	1983-11-27 00:00:00	1983-12-04	1983-12-04 00:00:00	1983-12-04	38000177		0	0	7		0	0	0	327023	0	313782	1127433		
39611	3275	1127433	1973-10-30	1973-10-30 00:00:00	1973-11-06	1973-11-06 00:00:00	1973-11-06	38000177		0	0	7		0	0	0	217629	0	313782	1127433		
57597	4782	19133905	2006-03-11	2006-03-11 00:00:00	2006-03-19	2006-03-19 00:00:00	2006-03-19	38000177		0	0	8		0	0	0	318367	0	834102	19133905		
60297	5014	19059056	1938-02-20	1938-02-20 00:00:00	1938-03-22	1938-03-22 00:00:00	1938-03-22	38000177		0	0	30		0	0	0	333252	0	243670	19059056		
134894	2960	40213160	1955-10-13	1955-10-13 00:00:00	1955-10-13	1955-10-13 00:00:00	1955-10-13	581452		0	0	0		0	0	0	197689	0	10	40213160		
45567	3772	1118084	2007-10-29	2007-10-29 00:00:00	2007-10-29	2007-10-29 00:00:00	\N	38000177		0	0	0		0	0	0	250761	0	00025152531	44923712		
156042	3434	40213198	2013-06-27	2013-06-27 00:00:00	2013-06-27	2013-06-27 00:00:00	2013-06-27	581452		0	0	0		0	0	0	227743	0	133	40213198		
51866	4312	1551192	1961-02-08	1961-02-08 00:00:00	1961-02-08	1961-02-08 00:00:00	1961-02-08	38000177		0	0	0		0	0	0	286132	0	312617	1551192		
57246	4753	1713671	1989-10-24	1989-10-24 00:00:00	1989-10-31	1989-10-31 00:00:00	1989-10-31	38000177		0	0	7		0	0	0	316571	0	562251	1713671		
51953	4320	19016749	1970-05-14	1970-05-14 00:00:00	1970-05-14	1970-05-14 00:00:00	1970-05-14	38000177		0	0	0		0	0	0	286692	0	73032	19016749		
184935	4064	40213160	1965-04-19	1965-04-19 00:00:00	1965-04-19	1965-04-19 00:00:00	1965-04-19	581452		0	0	0		0	0	0	270054	0	10	40213160		
62520	5200	1127078	1960-06-21	1960-06-21 00:00:00	1960-07-05	1960-07-05 00:00:00	1960-07-05	38000177		0	0	14		0	0	0	345814	0	282464	1127078		
39394	3253	19078461	2018-08-05	2018-08-05 00:00:00	2018-08-19	2018-08-19 00:00:00	2018-08-19	38000177		0	0	14		0	0	0	216247	0	310965	19078461		
40237	877	40213314	1978-07-11	1978-07-11 00:00:00	1978-07-11	1978-07-11 00:00:00	1978-07-11	581452		0	0	0		0	0	0	58389	0	49	40213314		
3978	331	40165015	1997-04-19	1997-04-19 00:00:00	1997-04-19	1997-04-19 00:00:00	\N	38000177		0	0	0		0	0	0	21811	0	861467	40165015		
29549	2445	1713671	1962-06-18	1962-06-18 00:00:00	1962-07-09	1962-07-09 00:00:00	1962-07-09	38000177		0	0	21		0	0	0	162188	0	562251	1713671		
35262	2906	19059056	1971-03-15	1971-03-15 00:00:00	1971-03-29	1971-03-29 00:00:00	1971-03-29	38000177		0	0	14		0	0	0	193724	0	243670	19059056		
16513	357	40213260	2006-10-25	2006-10-25 00:00:00	2006-10-25	2006-10-25 00:00:00	2006-10-25	581452		0	0	0		0	0	0	23775	0	121	40213260		
178137	3916	40213227	2001-08-08	2001-08-08 00:00:00	2001-08-08	2001-08-08 00:00:00	2001-08-08	581452		0	0	0		0	0	0	260289	0	113	40213227		
45894	3799	19129655	1976-02-13	1976-02-13 00:00:00	1976-02-27	1976-02-27 00:00:00	1976-02-27	38000177		0	0	14		0	0	0	252535	0	789980	19129655		
1643	129	1127433	1994-08-25	1994-08-25 00:00:00	1994-09-08	1994-09-08 00:00:00	1994-09-08	38000177		0	0	14		0	0	0	8707	0	313782	1127433		
52586	1150	40213201	2016-07-13	2016-07-13 00:00:00	2016-07-13	2016-07-13 00:00:00	2016-07-13	581452		0	0	0		0	0	0	76059	0	33	40213201		
38554	3183	1551192	1981-08-07	1981-08-07 00:00:00	1981-08-07	1981-08-07 00:00:00	1981-08-07	38000177		0	0	0		0	0	0	211925	0	312617	1551192		
134361	2949	40213201	2016-10-25	2016-10-25 00:00:00	2016-10-25	2016-10-25 00:00:00	2016-10-25	581452		0	0	0		0	0	0	196824	0	33	40213201		
53684	1175	40213227	1992-08-09	1992-08-09 00:00:00	1992-08-09	1992-08-09 00:00:00	1992-08-09	581452		0	0	0		0	0	0	77468	0	113	40213227		
29224	2418	1127078	1981-09-09	1981-09-09 00:00:00	1981-12-08	1981-12-08 00:00:00	1981-12-08	38000177		0	0	90		0	0	0	160441	0	282464	1127078		
5358	449	46233710	1976-03-03	1976-03-03 00:00:00	1976-03-17	1976-03-17 00:00:00	1976-03-17	38000177		0	0	14		0	0	0	29953	0	1650142	46233710		
33610	2781	1124300	2016-12-29	2016-12-29 00:00:00	2016-12-29	2016-12-29 00:00:00	\N	38000177		0	0	0		0	0	0	184320	0	00781178901	45011828		
17489	1447	19059056	1972-06-27	1972-06-27 00:00:00	1972-07-27	1972-07-27 00:00:00	1972-07-27	38000177		0	0	30		0	0	0	96482	0	243670	19059056		
15949	1322	1127433	1940-07-18	1940-07-18 00:00:00	1940-07-25	1940-07-25 00:00:00	1940-07-25	38000177		0	0	7		0	0	0	87785	0	313782	1127433		
779	63	19059056	1978-03-31	1978-03-31 00:00:00	1978-04-14	1978-04-14 00:00:00	1978-04-14	38000177		0	0	14		0	0	0	4306	0	243670	19059056		
16052	1332	1332419	1999-08-04	1999-08-04 00:00:00	1999-08-04	1999-08-04 00:00:00	\N	38000177		0	0	0		0	0	0	88397	0	197361	1332419		
16061	1332	1127433	1970-08-14	1970-08-14 00:00:00	1970-09-04	1970-09-04 00:00:00	1970-09-04	38000177		0	0	21		0	0	0	88318	0	313782	1127433		
8495	709	40229134	1973-11-24	1973-11-24 00:00:00	1973-12-08	1973-12-08 00:00:00	1973-12-08	38000177		0	0	14		0	0	0	46964	0	1043400	40229134		
29955	2482	1127078	1976-07-03	1976-07-03 00:00:00	1976-09-01	1976-09-01 00:00:00	1976-09-01	38000177		0	0	60		0	0	0	164477	0	282464	1127078		
22413	1843	19019979	1985-06-13	1985-06-13 00:00:00	1985-06-27	1985-06-27 00:00:00	1985-06-27	38000177		0	0	14		0	0	0	123009	0	198405	19019979		
54684	4543	42902245	1999-08-04	1999-08-04 00:00:00	2000-07-29	2000-07-29 00:00:00	2000-07-29	38000177		0	0	360		0	0	0	302629	0	1359133	42902245		
40558	3362	19133905	1979-05-23	1979-05-23 00:00:00	1979-06-02	1979-06-02 00:00:00	1979-06-02	38000177		0	0	10		0	0	0	222927	0	834102	19133905		
22075	1814	1127433	1964-08-21	1964-08-21 00:00:00	1964-09-04	1964-09-04 00:00:00	1964-09-04	38000177		0	0	14		0	0	0	121425	0	313782	1127433		
19378	422	40213260	2009-01-10	2009-01-10 00:00:00	2009-01-10	2009-01-10 00:00:00	2009-01-10	581452		0	0	0		0	0	0	27960	0	121	40213260		
47835	3967	40236824	2004-07-16	2004-07-16 00:00:00	2004-07-23	2004-07-23 00:00:00	2004-07-23	38000177		0	0	7		0	0	0	263769	0	1094107	40236824		
106029	2326	40213227	1993-02-18	1993-02-18 00:00:00	1993-02-18	1993-02-18 00:00:00	1993-02-18	581452		0	0	0		0	0	0	154697	0	113	40213227		
42861	3553	19133905	1984-08-13	1984-08-13 00:00:00	1984-08-25	1984-08-25 00:00:00	1984-08-25	38000177		0	0	12		0	0	0	235876	0	834102	19133905		
41078	3408	1118084	2008-10-15	2008-10-15 00:00:00	2008-10-15	2008-10-15 00:00:00	\N	38000177		0	0	0		0	0	0	226047	0	00025152531	44923712		
34094	2818	46233988	1971-08-04	1971-08-04 00:00:00	1971-08-18	1971-08-18 00:00:00	1971-08-18	38000177		0	0	14		0	0	0	186757	0	1652673	46233988		
4358	362	19133873	1991-10-30	1991-10-30 00:00:00	1991-11-12	1991-11-12 00:00:00	1991-11-12	38000177		0	0	13		0	0	0	24024	0	834061	19133873		
53538	4451	1118084	1992-08-20	1992-08-20 00:00:00	1992-08-20	1992-08-20 00:00:00	\N	38000177		0	0	0		0	0	0	296123	0	00025152531	44923712		
97876	2145	40213260	2014-12-27	2014-12-27 00:00:00	2014-12-27	2014-12-27 00:00:00	2014-12-27	581452		0	0	0		0	0	0	142828	0	121	40213260		
53881	4477	19059056	1964-09-16	1964-09-16 00:00:00	1964-10-14	1964-10-14 00:00:00	1964-10-14	38000177		0	0	28		0	0	0	297910	0	243670	19059056		
15413	332	40213160	1963-11-22	1963-11-22 00:00:00	1963-11-22	1963-11-22 00:00:00	1963-11-22	581452		0	0	0		0	0	0	21951	0	10	40213160		
6201	518	1713671	1982-09-25	1982-09-25 00:00:00	1982-10-09	1982-10-09 00:00:00	1982-10-09	38000177		0	0	14		0	0	0	34588	0	562251	1713671		
124694	2743	40213160	1960-09-14	1960-09-14 00:00:00	1960-09-14	1960-09-14 00:00:00	1960-09-14	581452		0	0	0		0	0	0	181465	0	10	40213160		
8925	744	19059056	1957-11-18	1957-11-18 00:00:00	1957-12-02	1957-12-02 00:00:00	1957-12-02	38000177		0	0	14		0	0	0	49365	0	243670	19059056		
2997	244	19133905	1949-10-27	1949-10-27 00:00:00	1949-11-09	1949-11-09 00:00:00	1949-11-09	38000177		0	0	13		0	0	0	16295	0	834102	19133905		
36943	3056	40229134	1983-08-03	1983-08-03 00:00:00	1983-08-17	1983-08-17 00:00:00	1983-08-17	38000177		0	0	14		0	0	0	203229	0	1043400	40229134		
19522	1608	1127433	1979-04-22	1979-04-22 00:00:00	1979-06-21	1979-06-21 00:00:00	1979-06-21	38000177		0	0	60		0	0	0	108015	0	313782	1127433		
47508	3939	1713671	2017-03-28	2017-03-28 00:00:00	2017-04-04	2017-04-04 00:00:00	2017-04-04	38000177		0	0	7		0	0	0	261867	0	562251	1713671		
181126	3980	40213160	1979-10-07	1979-10-07 00:00:00	1979-10-07	1979-10-07 00:00:00	1979-10-07	581452		0	0	0		0	0	0	264571	0	10	40213160		
102366	2243	40213296	2008-02-15	2008-02-15 00:00:00	2008-02-15	2008-02-15 00:00:00	2008-02-15	581452		0	0	0		0	0	0	149341	0	52	40213296		
43458	3603	1127433	2009-07-26	2009-07-26 00:00:00	2009-08-02	2009-08-02 00:00:00	2009-08-02	38000177		0	0	7		0	0	0	239369	0	313782	1127433		
147659	3246	40213314	1980-01-28	1980-01-28 00:00:00	1980-01-28	1980-01-28 00:00:00	1980-01-28	581452		0	0	0		0	0	0	215767	0	49	40213314		
208379	4570	40213227	1991-12-28	1991-12-28 00:00:00	1991-12-28	1991-12-28 00:00:00	1991-12-28	581452		0	0	0		0	0	0	304478	0	113	40213227		
2397	191	19133873	1924-12-24	1924-12-24 00:00:00	1925-01-06	1925-01-06 00:00:00	1925-01-06	38000177		0	0	13		0	0	0	13055	0	834061	19133873		
142631	3133	40213160	1956-10-31	1956-10-31 00:00:00	1956-10-31	1956-10-31 00:00:00	1956-10-31	581452		0	0	0		0	0	0	208481	0	10	40213160		
59213	4922	40231925	2013-11-16	2013-11-16 00:00:00	2013-11-16	2013-11-16 00:00:00	\N	38000177		0	0	0		0	0	0	327052	0	1049221	40231925		
39612	3275	1118084	1992-02-21	1992-02-21 00:00:00	1992-02-21	1992-02-21 00:00:00	\N	38000177		0	0	0		0	0	0	217644	0	00025152531	44923712		
57598	4782	19128065	1995-04-21	1995-04-21 00:00:00	1996-04-15	1996-04-15 00:00:00	1996-04-15	38000177		0	0	360		0	0	0	318317	0	749882	19128065		
60298	5014	1127433	1925-10-29	1925-10-29 00:00:00	1925-11-05	1925-11-05 00:00:00	1925-11-05	38000177		0	0	7		0	0	0	333258	0	313782	1127433		
134901	2960	40213160	1955-07-14	1955-07-14 00:00:00	1955-07-14	1955-07-14 00:00:00	1955-07-14	581452		0	0	0		0	0	0	197657	0	10	40213160		
45569	3772	1551192	1983-01-03	1983-01-03 00:00:00	1983-01-03	1983-01-03 00:00:00	1983-01-03	38000177		0	0	0		0	0	0	250672	0	312617	1551192		
156051	3434	40213227	1992-05-07	1992-05-07 00:00:00	1992-05-07	1992-05-07 00:00:00	1992-05-07	581452		0	0	0		0	0	0	227763	0	113	40213227		
51867	4312	1127433	2005-09-02	2005-09-02 00:00:00	2005-09-16	2005-09-16 00:00:00	2005-09-16	38000177		0	0	14		0	0	0	286060	0	313782	1127433		
11559	248	40213160	1972-11-07	1972-11-07 00:00:00	1972-11-07	1972-11-07 00:00:00	1972-11-07	581452		0	0	0		0	0	0	16683	0	10	40213160		
51954	4320	1124300	2010-02-07	2010-02-07 00:00:00	2010-02-07	2010-02-07 00:00:00	\N	38000177		0	0	0		0	0	0	286654	0	00781178901	45011828		
184936	4064	40213160	1961-01-16	1961-01-16 00:00:00	1961-01-16	1961-01-16 00:00:00	1961-01-16	581452		0	0	0		0	0	0	270033	0	10	40213160		
62521	5200	1127433	1972-07-02	1972-07-02 00:00:00	1972-07-30	1972-07-30 00:00:00	1972-07-30	38000177		0	0	28		0	0	0	345938	0	313782	1127433		
39395	3253	19112599	1972-06-08	1972-06-08 00:00:00	1972-06-08	1972-06-08 00:00:00	\N	38000177		0	0	0		0	0	0	216320	0	477045	19112599		
40243	877	40213314	1977-08-09	1977-08-09 00:00:00	1977-08-09	1977-08-09 00:00:00	1977-08-09	581452		0	0	0		0	0	0	58368	0	49	40213314		
3979	331	782047	1997-04-18	1997-04-18 00:00:00	1997-04-18	1997-04-18 00:00:00	1997-04-18	38000177		0	0	0		0	0	0	21811	0	542347	782047		
29550	2445	1118084	1964-03-12	1964-03-12 00:00:00	1964-03-12	1964-03-12 00:00:00	\N	38000177		0	0	0		0	0	0	162188	0	00025152531	44923712		
35263	2906	19059056	1941-05-25	1941-05-25 00:00:00	1941-06-15	1941-06-15 00:00:00	1941-06-15	38000177		0	0	21		0	0	0	193721	0	243670	19059056		
66909	1464	40213160	1960-03-09	1960-03-09 00:00:00	1960-03-09	1960-03-09 00:00:00	1960-03-09	581452		0	0	0		0	0	0	97515	0	10	40213160		
178138	3916	40213306	2001-08-08	2001-08-08 00:00:00	2001-08-08	2001-08-08 00:00:00	2001-08-08	581452		0	0	0		0	0	0	260289	0	43	40213306		
29701	2460	1124300	2018-02-16	2018-02-16 00:00:00	2018-02-16	2018-02-16 00:00:00	\N	38000177		0	0	0		0	0	0	163115	0	00781178901	45011828		
1644	129	46233988	1975-08-03	1975-08-03 00:00:00	1975-08-17	1975-08-17 00:00:00	1975-08-17	38000177		0	0	14		0	0	0	8715	0	1652673	46233988		
52589	1150	40213198	2015-07-08	2015-07-08 00:00:00	2015-07-08	2015-07-08 00:00:00	2015-07-08	581452		0	0	0		0	0	0	76074	0	133	40213198		
38555	3183	1127433	2017-05-30	2017-05-30 00:00:00	2017-06-29	2017-06-29 00:00:00	2017-06-29	38000177		0	0	30		0	0	0	211919	0	313782	1127433		
134362	2949	40213198	2015-10-20	2015-10-20 00:00:00	2015-10-20	2015-10-20 00:00:00	2015-10-20	581452		0	0	0		0	0	0	196795	0	133	40213198		
53695	1175	40213227	2002-01-13	2002-01-13 00:00:00	2002-01-13	2002-01-13 00:00:00	2002-01-13	581452		0	0	0		0	0	0	77484	0	113	40213227		
29225	2418	19019979	1980-10-16	1980-10-16 00:00:00	1980-11-13	1980-11-13 00:00:00	1980-11-13	38000177		0	0	28		0	0	0	160440	0	198405	19019979		
5359	449	19059056	1976-03-03	1976-03-03 00:00:00	1976-03-17	1976-03-17 00:00:00	1976-03-17	38000177		0	0	14		0	0	0	29953	0	243670	19059056		
33611	2781	1713671	1989-04-22	1989-04-22 00:00:00	1989-05-06	1989-05-06 00:00:00	1989-05-06	38000177		0	0	14		0	0	0	184314	0	562251	1713671		
17490	1447	1127433	1988-09-18	1988-09-18 00:00:00	1988-10-02	1988-10-02 00:00:00	1988-10-02	38000177		0	0	14		0	0	0	96428	0	313782	1127433		
15950	1322	1127433	2007-06-20	2007-06-20 00:00:00	2007-06-27	2007-06-27 00:00:00	2007-06-27	38000177		0	0	7		0	0	0	87744	0	313782	1127433		
780	63	46233710	1978-03-31	1978-03-31 00:00:00	1978-04-14	1978-04-14 00:00:00	1978-04-14	38000177		0	0	14		0	0	0	4306	0	1650142	46233710		
10981	915	1127433	1969-08-06	1969-08-06 00:00:00	1969-08-13	1969-08-13 00:00:00	1969-08-13	38000177		0	0	7		0	0	0	60860	0	313782	1127433		
16062	1332	1713671	1976-06-14	1976-06-14 00:00:00	1976-06-21	1976-06-21 00:00:00	1976-06-21	38000177		0	0	7		0	0	0	88347	0	562251	1713671		
8496	709	1127433	1977-09-16	1977-09-16 00:00:00	1977-09-23	1977-09-23 00:00:00	1977-09-23	38000177		0	0	7		0	0	0	46925	0	313782	1127433		
29956	2482	19128022	1989-09-03	1989-09-03 00:00:00	1990-08-29	1990-08-29 00:00:00	1990-08-29	38000177		0	0	360		0	0	0	164468	0	749785	19128022		
22414	1843	1118084	2016-10-29	2016-10-29 00:00:00	2016-10-29	2016-10-29 00:00:00	\N	38000177		0	0	0		0	0	0	123098	0	00025152531	44923712		
54685	4543	1127433	2001-06-05	2001-06-05 00:00:00	2001-06-26	2001-06-26 00:00:00	2001-06-26	38000177		0	0	21		0	0	0	302642	0	313782	1127433		
40559	3362	1127078	1960-04-05	1960-04-05 00:00:00	1960-05-03	1960-05-03 00:00:00	1960-05-03	38000177		0	0	28		0	0	0	222890	0	282464	1127078		
22076	1814	19059056	1945-02-07	1945-02-07 00:00:00	1945-02-21	1945-02-21 00:00:00	1945-02-21	38000177		0	0	14		0	0	0	121412	0	243670	19059056		
19382	422	40213227	1993-02-27	1993-02-27 00:00:00	1993-02-27	1993-02-27 00:00:00	1993-02-27	581452		0	0	0		0	0	0	27903	0	113	40213227		
47836	3967	920300	2004-07-16	2004-07-16 00:00:00	2004-07-23	2004-07-23 00:00:00	2004-07-23	38000177		0	0	7		0	0	0	263769	0	311989	920300		
106035	2326	40213227	2012-04-12	2012-04-12 00:00:00	2012-04-12	2012-04-12 00:00:00	2012-04-12	581452		0	0	0		0	0	0	154691	0	113	40213227		
42862	3553	1127433	1990-03-05	1990-03-05 00:00:00	1990-03-19	1990-03-19 00:00:00	1990-03-19	38000177		0	0	14		0	0	0	235893	0	313782	1127433		
41079	3408	19078461	1984-02-19	1984-02-19 00:00:00	1984-03-18	1984-03-18 00:00:00	1984-03-18	38000177		0	0	28		0	0	0	226020	0	310965	19078461		
34095	2818	1127078	1971-08-04	1971-08-04 00:00:00	1971-08-18	1971-08-18 00:00:00	1971-08-18	38000177		0	0	14		0	0	0	186757	0	282464	1127078		
4359	362	1118084	2017-08-05	2017-08-05 00:00:00	2017-08-05	2017-08-05 00:00:00	\N	38000177		0	0	0		0	0	0	24041	0	00025152531	44923712		
53539	4451	19133905	2005-03-22	2005-03-22 00:00:00	2005-04-04	2005-04-04 00:00:00	2005-04-04	38000177		0	0	13		0	0	0	296168	0	834102	19133905		
97882	2145	40213160	1964-08-29	1964-08-29 00:00:00	1964-08-29	1964-08-29 00:00:00	1964-08-29	581452		0	0	0		0	0	0	142838	0	10	40213160		
53882	4477	1127433	2009-12-21	2009-12-21 00:00:00	2010-01-04	2010-01-04 00:00:00	2010-01-04	38000177		0	0	14		0	0	0	297951	0	313782	1127433		
161817	3560	40213227	2002-05-15	2002-05-15 00:00:00	2002-05-15	2002-05-15 00:00:00	2002-05-15	581452		0	0	0		0	0	0	236393	0	113	40213227		
6202	518	1713671	1971-05-03	1971-05-03 00:00:00	1971-05-17	1971-05-17 00:00:00	1971-05-17	38000177		0	0	14		0	0	0	34611	0	562251	1713671		
124696	2743	40213306	1982-06-02	1982-06-02 00:00:00	1982-06-02	1982-06-02 00:00:00	1982-06-02	581452		0	0	0		0	0	0	181435	0	43	40213306		
8926	744	19078461	2012-01-14	2012-01-14 00:00:00	2012-01-28	2012-01-28 00:00:00	2012-01-28	38000177		0	0	14		0	0	0	49357	0	310965	19078461		
2998	244	1127433	1993-07-02	1993-07-02 00:00:00	1993-07-09	1993-07-09 00:00:00	1993-07-09	38000177		0	0	7		0	0	0	16286	0	313782	1127433		
36944	3056	1127078	1962-11-16	1962-11-16 00:00:00	1962-11-30	1962-11-30 00:00:00	1962-11-30	38000177		0	0	14		0	0	0	203261	0	282464	1127078		
19523	1608	40220960	2016-04-16	2016-04-16 00:00:00	2016-04-16	2016-04-16 00:00:00	2016-04-16	38000177		0	0	0		0	0	0	107980	0	1804799	40220960		
131941	2899	40213198	2014-11-20	2014-11-20 00:00:00	2014-11-20	2014-11-20 00:00:00	2014-11-20	581452		0	0	0		0	0	0	193195	0	133	40213198		
181129	3980	40213227	2007-08-19	2007-08-19 00:00:00	2007-08-19	2007-08-19 00:00:00	2007-08-19	581452		0	0	0		0	0	0	264611	0	113	40213227		
102368	2243	40213227	2008-02-15	2008-02-15 00:00:00	2008-02-15	2008-02-15 00:00:00	2008-02-15	581452		0	0	0		0	0	0	149341	0	113	40213227		
43459	3603	19059056	1971-09-08	1971-09-08 00:00:00	1971-09-22	1971-09-22 00:00:00	1971-09-22	38000177		0	0	14		0	0	0	239323	0	243670	19059056		
147668	3246	40213314	1980-12-29	1980-12-29 00:00:00	1980-12-29	1980-12-29 00:00:00	1980-12-29	581452		0	0	0		0	0	0	215808	0	49	40213314		
208386	4571	40213160	1955-06-04	1955-06-04 00:00:00	1955-06-04	1955-06-04 00:00:00	1955-06-04	581452		0	0	0		0	0	0	304538	0	10	40213160		
2398	191	40169281	1990-09-25	1990-09-25 00:00:00	1990-09-25	1990-09-25 00:00:00	\N	38000177		0	0	0		0	0	0	13120	0	896209	40169281		
142634	3133	40213160	1956-05-30	1956-05-30 00:00:00	1956-05-30	1956-05-30 00:00:00	1956-05-30	581452		0	0	0		0	0	0	208480	0	10	40213160		
59214	4922	1127433	2011-12-05	2011-12-05 00:00:00	2011-12-26	2011-12-26 00:00:00	2011-12-26	38000177		0	0	21		0	0	0	327003	0	313782	1127433		
39613	3275	19128065	1979-03-11	1979-03-11 00:00:00	1980-03-05	1980-03-05 00:00:00	1980-03-05	38000177		0	0	360		0	0	0	217621	0	749882	19128065		
5	1	40213198	2014-04-24	2014-04-24 00:00:00	2014-04-24	2014-04-24 00:00:00	2014-04-24	581452		0	0	0		0	0	0	37	0	133	40213198		
60299	5014	40169281	1986-10-28	1986-10-28 00:00:00	1986-10-28	1986-10-28 00:00:00	\N	38000177		0	0	0		0	0	0	333277	0	896209	40169281		
134908	2960	40213160	1959-10-29	1959-10-29 00:00:00	1959-10-29	1959-10-29 00:00:00	1959-10-29	581452		0	0	0		0	0	0	197659	0	10	40213160		
45570	3772	1127433	1984-07-27	1984-07-27 00:00:00	1984-08-03	1984-08-03 00:00:00	1984-08-03	38000177		0	0	7		0	0	0	250697	0	313782	1127433		
156056	3434	40213227	1999-04-29	1999-04-29 00:00:00	1999-04-29	1999-04-29 00:00:00	1999-04-29	581452		0	0	0		0	0	0	227765	0	113	40213227		
51868	4312	19112599	1962-10-06	1962-10-06 00:00:00	1962-10-06	1962-10-06 00:00:00	\N	38000177		0	0	0		0	0	0	286210	0	477045	19112599		
11564	248	40213227	2015-05-19	2015-05-19 00:00:00	2015-05-19	2015-05-19 00:00:00	2015-05-19	581452		0	0	0		0	0	0	16676	0	113	40213227		
51955	4320	1127433	2019-02-26	2019-02-26 00:00:00	2019-03-05	2019-03-05 00:00:00	2019-03-05	38000177		0	0	7		0	0	0	286685	0	313782	1127433		
184940	4064	40213306	1983-02-07	1983-02-07 00:00:00	1983-02-07	1983-02-07 00:00:00	1983-02-07	581452		0	0	0		0	0	0	270059	0	43	40213306		
62522	5200	40229134	1961-04-18	1961-04-18 00:00:00	1961-05-02	1961-05-02 00:00:00	1961-05-02	38000177		0	0	14		0	0	0	345865	0	1043400	40229134		
39396	3253	40169216	1974-05-25	1974-05-25 00:00:00	1974-05-25	1974-05-25 00:00:00	\N	38000177		0	0	0		0	0	0	216321	0	895994	40169216		
69083	1511	40213296	2007-05-06	2007-05-06 00:00:00	2007-05-06	2007-05-06 00:00:00	2007-05-06	581452		0	0	0		0	0	0	100892	0	52	40213296		
3980	331	19078924	1997-04-18	1997-04-18 00:00:00	1997-04-18	1997-04-18 00:00:00	1997-04-18	38000177		0	0	0		0	0	0	21811	0	311700	19078924		
29551	2445	40162522	1979-09-24	1979-09-24 00:00:00	1979-09-24	1979-09-24 00:00:00	\N	38000177		0	0	0		0	0	0	162230	0	857005	40162522		
35264	2906	19073188	2009-09-30	2009-09-30 00:00:00	2009-10-14	2009-10-14 00:00:00	2009-10-14	38000177		0	0	14		0	0	0	193646	0	308192	19073188		
66911	1464	40213227	2011-05-18	2011-05-18 00:00:00	2011-05-18	2011-05-18 00:00:00	2011-05-18	581452		0	0	0		0	0	0	97520	0	113	40213227		
178139	3916	40213314	1979-01-10	1979-01-10 00:00:00	1979-01-10	1979-01-10 00:00:00	1979-01-10	581452		0	0	0		0	0	0	260346	0	49	40213314		
29702	2460	1127433	2012-10-11	2012-10-11 00:00:00	2012-10-18	2012-10-18 00:00:00	2012-10-18	38000177		0	0	7		0	0	0	163072	0	313782	1127433		
1645	129	19059056	1975-08-03	1975-08-03 00:00:00	1975-08-17	1975-08-17 00:00:00	1975-08-17	38000177		0	0	14		0	0	0	8715	0	243670	19059056		
52591	1150	40213227	2001-04-18	2001-04-18 00:00:00	2001-04-18	2001-04-18 00:00:00	2001-04-18	581452		0	0	0		0	0	0	76026	0	113	40213227		
38556	3183	19112599	1981-08-20	1981-08-20 00:00:00	1981-08-20	1981-08-20 00:00:00	\N	38000177		0	0	0		0	0	0	211895	0	477045	19112599		
134369	2949	40213227	2001-07-31	2001-07-31 00:00:00	2001-07-31	2001-07-31 00:00:00	2001-07-31	581452		0	0	0		0	0	0	196820	0	113	40213227		
103087	2261	40213227	1995-01-17	1995-01-17 00:00:00	1995-01-17	1995-01-17 00:00:00	1995-01-17	581452		0	0	0		0	0	0	150345	0	113	40213227		
29226	2418	1115171	1996-09-20	1996-09-20 00:00:00	1996-10-04	1996-10-04 00:00:00	1996-10-04	38000177		0	0	14		0	0	0	160467	0	849574	1115171		
5360	449	1713671	1992-11-29	1992-11-29 00:00:00	1992-12-20	1992-12-20 00:00:00	1992-12-20	38000177		0	0	21		0	0	0	29933	0	562251	1713671		
33612	2781	19133873	1987-07-24	1987-07-24 00:00:00	1987-08-05	1987-08-05 00:00:00	1987-08-05	38000177		0	0	12		0	0	0	184292	0	834061	19133873		
17491	1447	19078461	1975-03-14	1975-03-14 00:00:00	1975-04-13	1975-04-13 00:00:00	1975-04-13	38000177		0	0	30		0	0	0	96483	0	310965	19078461		
15951	1322	19074841	2003-01-18	2003-01-18 00:00:00	2003-02-01	2003-02-01 00:00:00	2003-02-01	38000177		0	0	14		0	0	0	87745	0	309043	19074841		
781	63	1127433	1994-05-03	1994-05-03 00:00:00	1994-05-10	1994-05-10 00:00:00	1994-05-10	38000177		0	0	7		0	0	0	4245	0	313782	1127433		
10982	915	1127078	1961-01-19	1961-01-19 00:00:00	1961-03-20	1961-03-20 00:00:00	1961-03-20	38000177		0	0	60		0	0	0	60784	0	282464	1127078		
16063	1332	19059056	1975-05-09	1975-05-09 00:00:00	1975-05-30	1975-05-30 00:00:00	1975-05-30	38000177		0	0	21		0	0	0	88380	0	243670	19059056		
8497	709	1545959	2005-08-28	2005-08-28 00:00:00	2005-08-28	2005-08-28 00:00:00	2005-08-28	38000177		0	0	0		0	0	0	46975	0	259255	1545959		
29957	2482	1118084	2015-05-20	2015-05-20 00:00:00	2015-05-20	2015-05-20 00:00:00	\N	38000177		0	0	0		0	0	0	164481	0	00025152531	44923712		
22415	1843	1127433	1983-01-13	1983-01-13 00:00:00	1983-01-27	1983-01-27 00:00:00	1983-01-27	38000177		0	0	14		0	0	0	123053	0	313782	1127433		
54686	4543	1127078	1981-07-29	1981-07-29 00:00:00	1981-08-12	1981-08-12 00:00:00	1981-08-12	38000177		0	0	14		0	0	0	302645	0	282464	1127078		
40560	3362	1127433	2013-11-22	2013-11-22 00:00:00	2013-12-13	2013-12-13 00:00:00	2013-12-13	38000177		0	0	21		0	0	0	222896	0	313782	1127433		
22077	1814	19133905	2018-02-25	2018-02-25 00:00:00	2018-03-06	2018-03-06 00:00:00	2018-03-06	38000177		0	0	9		0	0	0	121445	0	834102	19133905		
19387	422	40213160	1959-09-19	1959-09-19 00:00:00	1959-09-19	1959-09-19 00:00:00	1959-09-19	581452		0	0	0		0	0	0	27944	0	10	40213160		
47837	3967	19006318	1975-05-30	1975-05-30 00:00:00	1975-06-13	1975-06-13 00:00:00	1975-06-13	38000177		0	0	14		0	0	0	263713	0	105078	19006318		
106050	2326	40213198	2016-05-05	2016-05-05 00:00:00	2016-05-05	2016-05-05 00:00:00	2016-05-05	581452		0	0	0		0	0	0	154680	0	133	40213198		
42863	3553	19059056	1944-08-26	1944-08-26 00:00:00	1944-09-09	1944-09-09 00:00:00	1944-09-09	38000177		0	0	14		0	0	0	235895	0	243670	19059056		
41080	3408	19129655	1974-08-29	1974-08-29 00:00:00	1974-09-12	1974-09-12 00:00:00	1974-09-12	38000177		0	0	14		0	0	0	226050	0	789980	19129655		
34096	2818	1127433	1985-07-12	1985-07-12 00:00:00	1985-07-26	1985-07-26 00:00:00	1985-07-26	38000177		0	0	14		0	0	0	186729	0	313782	1127433		
4360	362	1127078	1991-07-26	1991-07-26 00:00:00	1991-08-09	1991-08-09 00:00:00	1991-08-09	38000177		0	0	14		0	0	0	24053	0	282464	1127078		
53540	4451	19059056	1955-05-15	1955-05-15 00:00:00	1955-05-29	1955-05-29 00:00:00	1955-05-29	38000177		0	0	14		0	0	0	296151	0	243670	19059056		
97902	2145	40213160	1964-05-30	1964-05-30 00:00:00	1964-05-30	1964-05-30 00:00:00	1964-05-30	581452		0	0	0		0	0	0	142815	0	10	40213160		
53899	4480	1127433	1974-08-21	1974-08-21 00:00:00	1974-09-04	1974-09-04 00:00:00	1974-09-04	38000177		0	0	14		0	0	0	298184	0	313782	1127433		
161818	3560	40213296	2002-05-15	2002-05-15 00:00:00	2002-05-15	2002-05-15 00:00:00	2002-05-15	581452		0	0	0		0	0	0	236393	0	52	40213296		
6203	520	19059056	1969-04-29	1969-04-29 00:00:00	1969-05-20	1969-05-20 00:00:00	1969-05-20	38000177		0	0	21		0	0	0	34742	0	243670	19059056		
125778	2768	40213160	1969-09-16	1969-09-16 00:00:00	1969-09-16	1969-09-16 00:00:00	1969-09-16	581452		0	0	0		0	0	0	183155	0	10	40213160		
8927	744	1127433	1977-12-03	1977-12-03 00:00:00	1978-01-07	1978-01-07 00:00:00	1978-01-07	38000177		0	0	35		0	0	0	49353	0	313782	1127433		
2999	244	19059056	1926-05-07	1926-05-07 00:00:00	1926-05-21	1926-05-21 00:00:00	1926-05-21	38000177		0	0	14		0	0	0	16358	0	243670	19059056		
36945	3056	19006318	1962-11-16	1962-11-16 00:00:00	1962-11-30	1962-11-30 00:00:00	1962-11-30	38000177		0	0	14		0	0	0	203261	0	105078	19006318		
19524	1608	19075601	2016-04-16	2016-04-16 00:00:00	2016-04-16	2016-04-16 00:00:00	2016-04-16	38000177		0	0	0		0	0	0	107980	0	309362	19075601		
131943	2899	40213227	1993-09-09	1993-09-09 00:00:00	1993-09-09	1993-09-09 00:00:00	1993-09-09	581452		0	0	0		0	0	0	193165	0	113	40213227		
181134	3980	40213296	2015-08-30	2015-08-30 00:00:00	2015-08-30	2015-08-30 00:00:00	2015-08-30	581452		0	0	0		0	0	0	264612	0	52	40213296		
102371	2243	40213306	1989-01-20	1989-01-20 00:00:00	1989-01-20	1989-01-20 00:00:00	1989-01-20	581452		0	0	0		0	0	0	149369	0	43	40213306		
43460	3603	19006318	1971-09-08	1971-09-08 00:00:00	1971-09-22	1971-09-22 00:00:00	1971-09-22	38000177		0	0	14		0	0	0	239323	0	105078	19006318		
106667	2339	40213227	2013-11-26	2013-11-26 00:00:00	2013-11-26	2013-11-26 00:00:00	2013-11-26	581452		0	0	0		0	0	0	\N	0	113	40213227		
208391	4571	40213227	2005-07-02	2005-07-02 00:00:00	2005-07-02	2005-07-02 00:00:00	2005-07-02	581452		0	0	0		0	0	0	304588	0	113	40213227		
2399	191	1127433	1987-08-07	1987-08-07 00:00:00	1987-09-11	1987-09-11 00:00:00	1987-09-11	38000177		0	0	35		0	0	0	13041	0	313782	1127433		
142639	3133	40213296	1996-02-28	1996-02-28 00:00:00	1996-02-28	1996-02-28 00:00:00	1996-02-28	581452		0	0	0		0	0	0	208493	0	52	40213296		
59215	4922	19133905	2013-01-04	2013-01-04 00:00:00	2013-01-14	2013-01-14 00:00:00	2013-01-14	38000177		0	0	10		0	0	0	327044	0	834102	19133905		
39618	3277	1127433	1997-10-25	1997-10-25 00:00:00	1998-01-23	1998-01-23 00:00:00	1998-01-23	38000177		0	0	90		0	0	0	217692	0	313782	1127433		
8	1	40213227	2010-04-01	2010-04-01 00:00:00	2010-04-01	2010-04-01 00:00:00	2010-04-01	581452		0	0	0		0	0	0	35	0	113	40213227		
60300	5014	40220960	1996-05-28	1996-05-28 00:00:00	1996-05-28	1996-05-28 00:00:00	1996-05-28	38000177		0	0	0		0	0	0	333290	0	1804799	40220960		
155946	3432	40213160	1956-10-19	1956-10-19 00:00:00	1956-10-19	1956-10-19 00:00:00	1956-10-19	581452		0	0	0		0	0	0	227491	0	10	40213160		
45571	3772	19059056	1970-06-10	1970-06-10 00:00:00	1970-06-24	1970-06-24 00:00:00	1970-06-24	38000177		0	0	14		0	0	0	250763	0	243670	19059056		
156057	3435	40213296	2017-11-25	2017-11-25 00:00:00	2017-11-25	2017-11-25 00:00:00	2017-11-25	581452		0	0	0		0	0	0	227808	0	52	40213296		
51869	4312	19129655	1963-04-09	1963-04-09 00:00:00	1963-04-23	1963-04-23 00:00:00	1963-04-23	38000177		0	0	14		0	0	0	286110	0	789980	19129655		
11565	248	40213296	2015-05-19	2015-05-19 00:00:00	2015-05-19	2015-05-19 00:00:00	2015-05-19	581452		0	0	0		0	0	0	16676	0	52	40213296		
51956	4320	19059056	1973-04-03	1973-04-03 00:00:00	1973-04-17	1973-04-17 00:00:00	1973-04-17	38000177		0	0	14		0	0	0	286667	0	243670	19059056		
184945	4064	40213260	2011-11-14	2011-11-14 00:00:00	2011-11-14	2011-11-14 00:00:00	2011-11-14	581452		0	0	0		0	0	0	270009	0	121	40213260		
62523	5200	1127433	1995-01-27	1995-01-27 00:00:00	1995-02-03	1995-02-03 00:00:00	1995-02-03	38000177		0	0	7		0	0	0	345812	0	313782	1127433		
39397	3253	1154615	1974-05-25	1974-05-25 00:00:00	1974-05-25	1974-05-25 00:00:00	\N	38000177		0	0	0		0	0	0	216321	0	745679	1154615		
69089	1511	40213160	1966-01-02	1966-01-02 00:00:00	1966-01-02	1966-01-02 00:00:00	1966-01-02	581452		0	0	0		0	0	0	100904	0	10	40213160		
3981	331	35605482	1997-04-18	1997-04-18 00:00:00	1997-04-18	1997-04-18 00:00:00	1997-04-18	38000177		0	0	0		0	0	0	21811	0	1740467	35605482		
29552	2445	19059056	1955-10-27	1955-10-27 00:00:00	1955-11-17	1955-11-17 00:00:00	1955-11-17	38000177		0	0	21		0	0	0	162196	0	243670	19059056		
35265	2906	1127433	2009-09-30	2009-09-30 00:00:00	2009-10-14	2009-10-14 00:00:00	2009-10-14	38000177		0	0	14		0	0	0	193646	0	313782	1127433		
66912	1464	40213260	2011-05-18	2011-05-18 00:00:00	2011-05-18	2011-05-18 00:00:00	2011-05-18	581452		0	0	0		0	0	0	97520	0	121	40213260		
178140	3916	40213160	1979-01-10	1979-01-10 00:00:00	1979-01-10	1979-01-10 00:00:00	1979-01-10	581452		0	0	0		0	0	0	260346	0	10	40213160		
29703	2460	19073183	1986-03-31	1986-03-31 00:00:00	1986-04-14	1986-04-14 00:00:00	1986-04-14	38000177		0	0	14		0	0	0	163124	0	308182	19073183		
1646	129	19133873	1986-10-07	1986-10-07 00:00:00	1986-10-18	1986-10-18 00:00:00	1986-10-18	38000177		0	0	11		0	0	0	8673	0	834061	19133873		
52598	1150	40213227	2011-06-15	2011-06-15 00:00:00	2011-06-15	2011-06-15 00:00:00	2011-06-15	581452		0	0	0		0	0	0	76016	0	113	40213227		
38557	3183	1127433	1993-10-19	1993-10-19 00:00:00	1993-11-02	1993-11-02 00:00:00	1993-11-02	38000177		0	0	14		0	0	0	211921	0	313782	1127433		
134371	2949	40213160	1955-07-05	1955-07-05 00:00:00	1955-07-05	1955-07-05 00:00:00	1955-07-05	581452		0	0	0		0	0	0	196854	0	10	40213160		
103089	2261	40213160	1968-10-15	1968-10-15 00:00:00	1968-10-15	1968-10-15 00:00:00	1968-10-15	581452		0	0	0		0	0	0	150276	0	10	40213160		
29227	2418	19128022	1991-08-11	1991-08-11 00:00:00	1992-08-05	1992-08-05 00:00:00	1992-08-05	38000177		0	0	360		0	0	0	160456	0	749785	19128022		
5361	449	1127433	1975-02-09	1975-02-09 00:00:00	1975-02-23	1975-02-23 00:00:00	1975-02-23	38000177		0	0	14		0	0	0	29902	0	313782	1127433		
33613	2781	1127078	1986-01-26	1986-01-26 00:00:00	1986-02-09	1986-02-09 00:00:00	1986-02-09	38000177		0	0	14		0	0	0	184293	0	282464	1127078		
17493	1447	1713671	2016-11-14	2016-11-14 00:00:00	2016-11-28	2016-11-28 00:00:00	2016-11-28	38000177		0	0	14		0	0	0	96542	0	562251	1713671		
15952	1322	1115171	2003-01-18	2003-01-18 00:00:00	2003-02-01	2003-02-01 00:00:00	2003-02-01	38000177		0	0	14		0	0	0	87745	0	849574	1115171		
782	63	1127433	2000-10-15	2000-10-15 00:00:00	2000-10-29	2000-10-29 00:00:00	2000-10-29	38000177		0	0	14		0	0	0	4298	0	313782	1127433		
10986	917	1118084	2005-03-31	2005-03-31 00:00:00	2005-03-31	2005-03-31 00:00:00	\N	38000177		0	0	0		0	0	0	60985	0	00025152531	44923712		
16064	1332	1127433	1999-12-14	1999-12-14 00:00:00	1999-12-21	1999-12-21 00:00:00	1999-12-21	38000177		0	0	7		0	0	0	88368	0	313782	1127433		
8498	709	19133768	2005-08-28	2005-08-28 00:00:00	2005-08-28	2005-08-28 00:00:00	2005-08-28	38000177		0	0	0		0	0	0	46975	0	833036	19133768		
29958	2482	19128022	1991-08-24	1991-08-24 00:00:00	1992-08-18	1992-08-18 00:00:00	1992-08-18	38000177		0	0	360		0	0	0	164430	0	749785	19128022		
22416	1843	43012754	2005-06-24	2005-06-24 00:00:00	2006-06-19	2006-06-19 00:00:00	2006-06-19	38000177		0	0	360		0	0	0	123070	0	1366343	43012754		
54687	4543	19128065	1993-09-04	1993-09-04 00:00:00	1994-08-30	1994-08-30 00:00:00	1994-08-30	38000177		0	0	360		0	0	0	302607	0	749882	19128065		
40561	3362	1115171	1994-04-17	1994-04-17 00:00:00	1994-05-08	1994-05-08 00:00:00	1994-05-08	38000177		0	0	21		0	0	0	222893	0	849574	1115171		
22078	1814	1127433	1940-12-17	1940-12-17 00:00:00	1940-12-24	1940-12-24 00:00:00	1940-12-24	38000177		0	0	7		0	0	0	121408	0	313782	1127433		
19390	422	40213227	2001-01-20	2001-01-20 00:00:00	2001-01-20	2001-01-20 00:00:00	2001-01-20	581452		0	0	0		0	0	0	27939	0	113	40213227		
47838	3967	19078461	1975-05-30	1975-05-30 00:00:00	1975-06-13	1975-06-13 00:00:00	1975-06-13	38000177		0	0	14		0	0	0	263713	0	310965	19078461		
174596	3839	40213201	2016-11-21	2016-11-21 00:00:00	2016-11-21	2016-11-21 00:00:00	2016-11-21	581452		0	0	0		0	0	0	254856	0	33	40213201		
42864	3553	1127433	1952-11-12	1952-11-12 00:00:00	1952-11-26	1952-11-26 00:00:00	1952-11-26	38000177		0	0	14		0	0	0	235924	0	313782	1127433		
47933	3973	1127433	2009-05-19	2009-05-19 00:00:00	2009-06-16	2009-06-16 00:00:00	2009-06-16	38000177		0	0	28		0	0	0	264220	0	313782	1127433		
34097	2818	40229134	1978-08-04	1978-08-04 00:00:00	1978-08-11	1978-08-11 00:00:00	1978-08-11	38000177		0	0	7		0	0	0	186745	0	1043400	40229134		
4361	362	1127433	1981-08-21	1981-08-21 00:00:00	1981-09-04	1981-09-04 00:00:00	1981-09-04	38000177		0	0	14		0	0	0	24017	0	313782	1127433		
53541	4451	19006318	1955-05-15	1955-05-15 00:00:00	1955-05-29	1955-05-29 00:00:00	1955-05-29	38000177		0	0	14		0	0	0	296151	0	105078	19006318		
97908	2145	40213227	2006-10-14	2006-10-14 00:00:00	2006-10-14	2006-10-14 00:00:00	2006-10-14	581452		0	0	0		0	0	0	142821	0	113	40213227		
53901	4480	1127433	2016-09-19	2016-09-19 00:00:00	2016-09-26	2016-09-26 00:00:00	2016-09-26	38000177		0	0	7		0	0	0	298126	0	313782	1127433		
161827	3560	40213227	1994-06-01	1994-06-01 00:00:00	1994-06-01	1994-06-01 00:00:00	1994-06-01	581452		0	0	0		0	0	0	236406	0	113	40213227		
6204	520	19059056	1951-11-04	1951-11-04 00:00:00	1951-11-18	1951-11-18 00:00:00	1951-11-18	38000177		0	0	14		0	0	0	34748	0	243670	19059056		
125783	2768	40213296	2012-09-18	2012-09-18 00:00:00	2012-09-18	2012-09-18 00:00:00	2012-09-18	581452		0	0	0		0	0	0	183179	0	52	40213296		
8928	744	19006318	1953-10-19	1953-10-19 00:00:00	1953-11-02	1953-11-02 00:00:00	1953-11-02	38000177		0	0	14		0	0	0	49364	0	105078	19006318		
3000	244	1118084	1966-06-06	1966-06-06 00:00:00	1966-06-06	1966-06-06 00:00:00	\N	38000177		0	0	0		0	0	0	16283	0	00025152531	44923712		
36946	3056	1127433	1960-05-12	1960-05-12 00:00:00	1960-05-19	1960-05-19 00:00:00	1960-05-19	38000177		0	0	7		0	0	0	203293	0	313782	1127433		
19525	1608	40229134	2013-05-07	2013-05-07 00:00:00	2013-05-21	2013-05-21 00:00:00	2013-05-21	38000177		0	0	14		0	0	0	108004	0	1043400	40229134		
131968	2899	40213227	2000-08-31	2000-08-31 00:00:00	2000-08-31	2000-08-31 00:00:00	2000-08-31	581452		0	0	0		0	0	0	193166	0	113	40213227		
181135	3980	40213314	1977-10-02	1977-10-02 00:00:00	1977-10-02	1977-10-02 00:00:00	1977-10-02	581452		0	0	0		0	0	0	264605	0	49	40213314		
102377	2244	40213227	2014-09-26	2014-09-26 00:00:00	2014-09-26	2014-09-26 00:00:00	2014-09-26	581452		0	0	0		0	0	0	149416	0	113	40213227		
43461	3603	19133873	1973-10-01	1973-10-01 00:00:00	1973-10-11	1973-10-11 00:00:00	1973-10-11	38000177		0	0	10		0	0	0	239355	0	834061	19133873		
106668	2339	40213296	2013-11-26	2013-11-26 00:00:00	2013-11-26	2013-11-26 00:00:00	2013-11-26	581452		0	0	0		0	0	0	\N	0	52	40213296		
208398	4571	40213260	2006-07-08	2006-07-08 00:00:00	2006-07-08	2006-07-08 00:00:00	2006-07-08	581452		0	0	0		0	0	0	304536	0	121	40213260		
2400	191	1127433	1967-06-30	1967-06-30 00:00:00	1967-07-07	1967-07-07 00:00:00	1967-07-07	38000177		0	0	7		0	0	0	13066	0	313782	1127433		
142657	3134	40213201	1987-10-29	1987-10-29 00:00:00	1987-10-29	1987-10-29 00:00:00	1987-10-29	581452		0	0	0		0	0	0	208533	0	33	40213201		
59216	4922	1124300	2013-06-15	2013-06-15 00:00:00	2013-06-15	2013-06-15 00:00:00	\N	38000177		0	0	0		0	0	0	327044	0	00781178901	45011828		
39619	3277	1127433	1998-11-19	1998-11-19 00:00:00	1998-12-10	1998-12-10 00:00:00	1998-12-10	38000177		0	0	21		0	0	0	217693	0	313782	1127433		
9	1	40213227	2000-02-03	2000-02-03 00:00:00	2000-02-03	2000-02-03 00:00:00	2000-02-03	581452		0	0	0		0	0	0	20	0	113	40213227		
60301	5014	1118084	1948-10-19	1948-10-19 00:00:00	1948-10-19	1948-10-19 00:00:00	\N	38000177		0	0	0		0	0	0	333314	0	00025152531	44923712		
155954	3432	40213201	2018-02-09	2018-02-09 00:00:00	2018-02-09	2018-02-09 00:00:00	2018-02-09	581452		0	0	0		0	0	0	227539	0	33	40213201		
45572	3772	19006318	1970-06-10	1970-06-10 00:00:00	1970-06-24	1970-06-24 00:00:00	1970-06-24	38000177		0	0	14		0	0	0	250763	0	105078	19006318		
156060	3435	40213227	2017-11-25	2017-11-25 00:00:00	2017-11-25	2017-11-25 00:00:00	2017-11-25	581452		0	0	0		0	0	0	227808	0	113	40213227		
51870	4312	19059056	1963-04-09	1963-04-09 00:00:00	1963-04-23	1963-04-23 00:00:00	1963-04-23	38000177		0	0	14		0	0	0	286110	0	243670	19059056		
11567	248	40213306	1996-04-23	1996-04-23 00:00:00	1996-04-23	1996-04-23 00:00:00	1996-04-23	581452		0	0	0		0	0	0	16696	0	43	40213306		
51957	4320	19129655	1973-04-03	1973-04-03 00:00:00	1973-04-17	1973-04-17 00:00:00	1973-04-17	38000177		0	0	14		0	0	0	286667	0	789980	19129655		
184946	4064	40213227	2011-11-14	2011-11-14 00:00:00	2011-11-14	2011-11-14 00:00:00	2011-11-14	581452		0	0	0		0	0	0	270009	0	113	40213227		
62524	5200	1127433	1982-03-31	1982-03-31 00:00:00	1982-04-21	1982-04-21 00:00:00	1982-04-21	38000177		0	0	21		0	0	0	345940	0	313782	1127433		
39398	3253	1115171	2012-02-08	2012-02-08 00:00:00	2012-03-09	2012-03-09 00:00:00	2012-03-09	38000177		0	0	30		0	0	0	216244	0	849574	1115171		
69090	1511	40213296	2005-05-01	2005-05-01 00:00:00	2005-05-01	2005-05-01 00:00:00	2005-05-01	581452		0	0	0		0	0	0	100873	0	52	40213296		
3982	331	35605482	1997-04-18	1997-04-18 00:00:00	1997-04-18	1997-04-18 00:00:00	1997-04-18	38000177		0	0	0		0	0	0	21811	0	1740467	35605482		
29553	2445	19078461	1979-09-17	1979-09-17 00:00:00	1979-11-23	1979-11-23 00:00:00	1979-11-23	38000177		0	0	67		0	0	0	162234	0	310965	19078461		
35266	2906	19133905	2004-06-10	2004-06-10 00:00:00	2004-06-18	2004-06-18 00:00:00	2004-06-18	38000177		0	0	8		0	0	0	193625	0	834102	19133905		
66915	1464	40213227	2001-04-18	2001-04-18 00:00:00	2001-04-18	2001-04-18 00:00:00	2001-04-18	581452		0	0	0		0	0	0	97518	0	113	40213227		
178149	3916	40213314	1979-12-12	1979-12-12 00:00:00	1979-12-12	1979-12-12 00:00:00	1979-12-12	581452		0	0	0		0	0	0	260318	0	49	40213314		
29704	2460	19019979	1986-03-31	1986-03-31 00:00:00	1986-04-14	1986-04-14 00:00:00	1986-04-14	38000177		0	0	14		0	0	0	163124	0	198405	19019979		
12119	1016	920300	2007-07-08	2007-07-08 00:00:00	2007-07-15	2007-07-15 00:00:00	2007-07-15	38000177		0	0	7		0	0	0	66890	0	311989	920300		
211663	4641	40213296	2007-07-19	2007-07-19 00:00:00	2007-07-19	2007-07-19 00:00:00	2007-07-19	581452		0	0	0		0	0	0	309344	0	52	40213296		
38558	3183	1713671	1983-03-06	1983-03-06 00:00:00	1983-03-20	1983-03-20 00:00:00	1983-03-20	38000177		0	0	14		0	0	0	211920	0	562251	1713671		
134377	2949	40213227	1992-08-04	1992-08-04 00:00:00	1992-08-04	1992-08-04 00:00:00	1992-08-04	581452		0	0	0		0	0	0	196810	0	113	40213227		
103092	2261	40213227	2014-11-11	2014-11-11 00:00:00	2014-11-11	2014-11-11 00:00:00	2014-11-11	581452		0	0	0		0	0	0	150331	0	113	40213227		
29228	2418	19133873	1983-04-19	1983-04-19 00:00:00	1983-04-26	1983-04-26 00:00:00	1983-04-26	38000177		0	0	7		0	0	0	160419	0	834061	19133873		
5362	449	19008572	1984-11-03	1984-11-03 00:00:00	1984-11-03	1984-11-03 00:00:00	\N	38000177		0	0	0		0	0	0	29946	0	106258	19008572		
33614	2781	19073183	1986-01-26	1986-01-26 00:00:00	1986-02-09	1986-02-09 00:00:00	1986-02-09	38000177		0	0	14		0	0	0	184293	0	308182	19073183		
17494	1447	1127433	2009-01-17	2009-01-17 00:00:00	2009-01-31	2009-01-31 00:00:00	2009-01-31	38000177		0	0	14		0	0	0	96485	0	313782	1127433		
15953	1322	19059056	1929-02-15	1929-02-15 00:00:00	1929-03-08	1929-03-08 00:00:00	1929-03-08	38000177		0	0	21		0	0	0	87782	0	243670	19059056		
783	63	1127433	2000-11-22	2000-11-22 00:00:00	2000-11-29	2000-11-29 00:00:00	2000-11-29	38000177		0	0	7		0	0	0	4284	0	313782	1127433		
10987	917	1713671	1975-10-20	1975-10-20 00:00:00	1975-11-10	1975-11-10 00:00:00	1975-11-10	38000177		0	0	21		0	0	0	60938	0	562251	1713671		
16065	1332	19059056	1971-08-30	1971-08-30 00:00:00	1971-09-27	1971-09-27 00:00:00	1971-09-27	38000177		0	0	28		0	0	0	88319	0	243670	19059056		
8499	709	19059056	1972-03-04	1972-03-04 00:00:00	1972-03-25	1972-03-25 00:00:00	1972-03-25	38000177		0	0	21		0	0	0	46974	0	243670	19059056		
29959	2482	1127433	1991-05-16	1991-05-16 00:00:00	1991-06-15	1991-06-15 00:00:00	1991-06-15	38000177		0	0	30		0	0	0	164478	0	313782	1127433		
22417	1843	1127433	2014-04-03	2014-04-03 00:00:00	2014-04-17	2014-04-17 00:00:00	2014-04-17	38000177		0	0	14		0	0	0	123068	0	313782	1127433		
54688	4544	19059056	1970-07-13	1970-07-13 00:00:00	1970-07-27	1970-07-27 00:00:00	1970-07-27	38000177		0	0	14		0	0	0	302669	0	243670	19059056		
40562	3362	1127433	2004-11-08	2004-11-08 00:00:00	2004-11-22	2004-11-22 00:00:00	2004-11-22	38000177		0	0	14		0	0	0	222885	0	313782	1127433		
32537	2697	19059056	1936-07-14	1936-07-14 00:00:00	1936-07-28	1936-07-28 00:00:00	1936-07-28	38000177		0	0	14		0	0	0	178567	0	243670	19059056		
19391	422	40213296	2001-01-20	2001-01-20 00:00:00	2001-01-20	2001-01-20 00:00:00	2001-01-20	581452		0	0	0		0	0	0	27939	0	52	40213296		
47839	3967	19059056	1966-01-30	1966-01-30 00:00:00	1966-02-20	1966-02-20 00:00:00	1966-02-20	38000177		0	0	21		0	0	0	263784	0	243670	19059056		
174598	3839	40213198	2015-11-16	2015-11-16 00:00:00	2015-11-16	2015-11-16 00:00:00	2015-11-16	581452		0	0	0		0	0	0	254883	0	133	40213198		
42865	3553	40222846	2007-04-20	2007-04-20 00:00:00	2007-04-20	2007-04-20 00:00:00	\N	38000177		0	0	0		0	0	0	235928	0	996740	40222846		
47934	3973	1127433	1984-09-01	1984-09-01 00:00:00	1984-09-08	1984-09-08 00:00:00	1984-09-08	38000177		0	0	7		0	0	0	264167	0	313782	1127433		
34098	2818	1124300	2009-11-03	2009-11-03 00:00:00	2009-11-03	2009-11-03 00:00:00	\N	38000177		0	0	0		0	0	0	186768	0	00781178901	45011828		
4362	362	19078461	1998-07-03	1998-07-03 00:00:00	1998-07-17	1998-07-17 00:00:00	1998-07-17	38000177		0	0	14		0	0	0	24055	0	310965	19078461		
53542	4451	19059056	1980-01-11	1980-01-11 00:00:00	1980-01-25	1980-01-25 00:00:00	1980-01-25	38000177		0	0	14		0	0	0	296139	0	243670	19059056		
97909	2145	40213296	2006-10-14	2006-10-14 00:00:00	2006-10-14	2006-10-14 00:00:00	2006-10-14	581452		0	0	0		0	0	0	142821	0	52	40213296		
53902	4480	1713671	1997-06-18	1997-06-18 00:00:00	1997-07-02	1997-07-02 00:00:00	1997-07-02	38000177		0	0	14		0	0	0	298138	0	562251	1713671		
161834	3560	40213160	1961-01-11	1961-01-11 00:00:00	1961-01-11	1961-01-11 00:00:00	1961-01-11	581452		0	0	0		0	0	0	236386	0	10	40213160		
6205	520	1127433	1965-09-26	1965-09-26 00:00:00	1965-10-17	1965-10-17 00:00:00	1965-10-17	38000177		0	0	21		0	0	0	34750	0	313782	1127433		
125786	2768	40213227	2000-09-19	2000-09-19 00:00:00	2000-09-19	2000-09-19 00:00:00	2000-09-19	581452		0	0	0		0	0	0	183137	0	113	40213227		
8929	744	1127078	1953-10-19	1953-10-19 00:00:00	1953-11-02	1953-11-02 00:00:00	1953-11-02	38000177		0	0	14		0	0	0	49364	0	282464	1127078		
3001	244	1127433	1954-03-09	1954-03-09 00:00:00	1954-03-16	1954-03-16 00:00:00	1954-03-16	38000177		0	0	7		0	0	0	16263	0	313782	1127433		
36947	3056	19133873	1964-02-22	1964-02-22 00:00:00	1964-03-02	1964-03-02 00:00:00	1964-03-02	38000177		0	0	9		0	0	0	203238	0	834061	19133873		
19526	1608	1127433	1945-01-26	1945-01-26 00:00:00	1945-02-02	1945-02-02 00:00:00	1945-02-02	38000177		0	0	7		0	0	0	108017	0	313782	1127433		
131974	2899	40213201	2015-11-26	2015-11-26 00:00:00	2015-11-26	2015-11-26 00:00:00	2015-11-26	581452		0	0	0		0	0	0	193175	0	33	40213201		
181137	3980	40213314	1977-04-03	1977-04-03 00:00:00	1977-04-03	1977-04-03 00:00:00	1977-04-03	581452		0	0	0		0	0	0	264591	0	49	40213314		
102378	2244	40213160	1955-07-01	1955-07-01 00:00:00	1955-07-01	1955-07-01 00:00:00	1955-07-01	581452		0	0	0		0	0	0	149404	0	10	40213160		
43462	3603	1127433	1969-12-18	1969-12-18 00:00:00	1969-12-25	1969-12-25 00:00:00	1969-12-25	38000177		0	0	7		0	0	0	239375	0	313782	1127433		
106674	2339	40213314	1977-08-02	1977-08-02 00:00:00	1977-08-02	1977-08-02 00:00:00	1977-08-02	581452		0	0	0		0	0	0	155619	0	49	40213314		
208409	4571	40213227	2015-08-29	2015-08-29 00:00:00	2015-08-29	2015-08-29 00:00:00	2015-08-29	581452		0	0	0		0	0	0	304580	0	113	40213227		
2401	191	19059056	1939-03-31	1939-03-31 00:00:00	1939-04-30	1939-04-30 00:00:00	1939-04-30	38000177		0	0	30		0	0	0	13039	0	243670	19059056		
153942	3389	40213260	2009-09-07	2009-09-07 00:00:00	2009-09-07	2009-09-07 00:00:00	2009-09-07	581452		0	0	0		0	0	0	224815	0	121	40213260		
59217	4922	920300	2002-10-14	2002-10-14 00:00:00	2002-10-21	2002-10-21 00:00:00	2002-10-21	38000177		0	0	7		0	0	0	327038	0	311989	920300		
39620	3277	1127433	1990-03-06	1990-03-06 00:00:00	1990-03-13	1990-03-13 00:00:00	1990-03-13	38000177		0	0	7		0	0	0	217702	0	313782	1127433		
164055	3609	40213306	1997-03-28	1997-03-28 00:00:00	1997-03-28	1997-03-28 00:00:00	1997-03-28	581452		0	0	0		0	0	0	239781	0	43	40213306		
60302	5014	1127433	1987-04-19	1987-04-19 00:00:00	1987-04-26	1987-04-26 00:00:00	1987-04-26	38000177		0	0	7		0	0	0	333291	0	313782	1127433		
207806	4559	40213227	1996-04-09	1996-04-09 00:00:00	1996-04-09	1996-04-09 00:00:00	1996-04-09	581452		0	0	0		0	0	0	303713	0	113	40213227		
45573	3772	19019979	1974-07-04	1974-07-04 00:00:00	1974-07-18	1974-07-18 00:00:00	1974-07-18	38000177		0	0	14		0	0	0	250688	0	198405	19019979		
156061	3435	40213296	2015-11-21	2015-11-21 00:00:00	2015-11-21	2015-11-21 00:00:00	2015-11-21	581452		0	0	0		0	0	0	227788	0	52	40213296		
51871	4312	1713671	1990-04-04	1990-04-04 00:00:00	1990-04-11	1990-04-11 00:00:00	1990-04-11	38000177		0	0	7		0	0	0	286198	0	562251	1713671		
25986	2138	1127078	1966-09-07	1966-09-07 00:00:00	1966-11-06	1966-11-06 00:00:00	1966-11-06	38000177		0	0	60		0	0	0	142412	0	282464	1127078		
51958	4320	1127433	2018-07-22	2018-07-22 00:00:00	2018-07-29	2018-07-29 00:00:00	2018-07-29	38000177		0	0	7		0	0	0	286679	0	313782	1127433		
223437	4905	40213160	1973-02-08	1973-02-08 00:00:00	1973-02-08	1973-02-08 00:00:00	1973-02-08	581452		0	0	0		0	0	0	326040	0	10	40213160		
62525	5200	19008572	1982-08-21	1982-08-21 00:00:00	1982-08-21	1982-08-21 00:00:00	\N	38000177		0	0	0		0	0	0	345867	0	106258	19008572		
39399	3253	40165015	2012-02-08	2012-02-08 00:00:00	2012-02-08	2012-02-08 00:00:00	\N	38000177		0	0	0		0	0	0	216244	0	861467	40165015		
80377	1758	40213306	1983-05-13	1983-05-13 00:00:00	1983-05-13	1983-05-13 00:00:00	1983-05-13	581452		0	0	0		0	0	0	117513	0	43	40213306		
3983	331	1367571	1997-04-18	1997-04-18 00:00:00	1997-04-18	1997-04-18 00:00:00	1997-04-18	38000177		0	0	0		0	0	0	21811	0	314659	19080464		
29554	2445	19059056	1928-10-27	1928-10-27 00:00:00	1928-11-10	1928-11-10 00:00:00	1928-11-10	38000177		0	0	14		0	0	0	162226	0	243670	19059056		
35267	2906	19133905	1947-07-11	1947-07-11 00:00:00	1947-07-24	1947-07-24 00:00:00	1947-07-24	38000177		0	0	13		0	0	0	193657	0	834102	19133905		
66916	1464	40213296	2001-04-18	2001-04-18 00:00:00	2001-04-18	2001-04-18 00:00:00	2001-04-18	581452		0	0	0		0	0	0	97518	0	52	40213296		
178154	3916	40213251	1984-06-06	1984-06-06 00:00:00	1984-06-06	1984-06-06 00:00:00	1984-06-06	581452		0	0	0		0	0	0	260277	0	21	40213251		
29705	2460	19128065	2000-07-29	2000-07-29 00:00:00	2001-07-24	2001-07-24 00:00:00	2001-07-24	38000177		0	0	360		0	0	0	163116	0	749882	19128065		
12120	1016	40236824	2007-07-08	2007-07-08 00:00:00	2007-07-15	2007-07-15 00:00:00	2007-07-15	38000177		0	0	7		0	0	0	66890	0	1094107	40236824		
211669	4641	40213306	1989-08-24	1989-08-24 00:00:00	1989-08-24	1989-08-24 00:00:00	1989-08-24	581452		0	0	0		0	0	0	309317	0	43	40213306		
38559	3183	19008572	2014-02-10	2014-02-10 00:00:00	2014-02-10	2014-02-10 00:00:00	\N	38000177		0	0	0		0	0	0	211942	0	106258	19008572		
134381	2950	40213227	2007-02-12	2007-02-12 00:00:00	2007-02-12	2007-02-12 00:00:00	2007-02-12	581452		0	0	0		0	0	0	196964	0	113	40213227		
103093	2261	40213260	2014-11-11	2014-11-11 00:00:00	2014-11-11	2014-11-11 00:00:00	2014-11-11	581452		0	0	0		0	0	0	150331	0	121	40213260		
29229	2419	1127433	1948-07-03	1948-07-03 00:00:00	1948-07-10	1948-07-10 00:00:00	1948-07-10	38000177		0	0	7		0	0	0	160510	0	313782	1127433		
5363	449	1127433	1985-08-17	1985-08-17 00:00:00	1985-08-31	1985-08-31 00:00:00	1985-08-31	38000177		0	0	14		0	0	0	29863	0	313782	1127433		
33615	2782	40165015	1955-05-10	1955-05-10 00:00:00	1955-05-10	1955-05-10 00:00:00	\N	38000177		0	0	0		0	0	0	184453	0	861467	40165015		
17495	1447	19128065	1975-07-08	1975-07-08 00:00:00	1976-07-02	1976-07-02 00:00:00	1976-07-02	38000177		0	0	360		0	0	0	96555	0	749882	19128065		
15954	1322	19059056	1928-02-21	1928-02-21 00:00:00	1928-03-22	1928-03-22 00:00:00	1928-03-22	38000177		0	0	30		0	0	0	87781	0	243670	19059056		
784	63	19059056	1966-03-12	1966-03-12 00:00:00	1966-04-16	1966-04-16 00:00:00	1966-04-16	38000177		0	0	35		0	0	0	4296	0	243670	19059056		
10988	917	40229134	1990-04-16	1990-04-16 00:00:00	1990-04-23	1990-04-23 00:00:00	1990-04-23	38000177		0	0	7		0	0	0	60981	0	1043400	40229134		
16066	1332	19059056	1966-11-12	1966-11-12 00:00:00	1966-12-03	1966-12-03 00:00:00	1966-12-03	38000177		0	0	21		0	0	0	88317	0	243670	19059056		
8500	709	19126352	1999-07-04	1999-07-04 00:00:00	2005-08-28	2005-08-28 00:00:00	2005-08-28	38000177		0	0	2247		0	0	0	46961	0	705129	19126352		
29960	2482	1115171	2002-03-26	2002-03-26 00:00:00	2002-06-24	2002-06-24 00:00:00	2002-06-24	38000177		0	0	90		0	0	0	164479	0	849574	1115171		
22418	1843	1713671	1983-11-13	1983-11-13 00:00:00	1983-11-20	1983-11-20 00:00:00	1983-11-20	38000177		0	0	7		0	0	0	123020	0	562251	1713671		
54690	4544	1118084	1984-04-25	1984-04-25 00:00:00	1984-04-25	1984-04-25 00:00:00	\N	38000177		0	0	0		0	0	0	302656	0	00025152531	44923712		
40563	3362	1124300	1996-05-31	1996-05-31 00:00:00	1996-05-31	1996-05-31 00:00:00	\N	38000177		0	0	0		0	0	0	222899	0	00781178901	45011828		
32538	2697	1713671	1960-03-14	1960-03-14 00:00:00	1960-03-21	1960-03-21 00:00:00	1960-03-21	38000177		0	0	7		0	0	0	178638	0	562251	1713671		
19393	422	40213260	2009-07-11	2009-07-11 00:00:00	2009-07-11	2009-07-11 00:00:00	2009-07-11	581452		0	0	0		0	0	0	27928	0	121	40213260		
47840	3967	1127433	2013-02-25	2013-02-25 00:00:00	2013-03-11	2013-03-11 00:00:00	2013-03-11	38000177		0	0	14		0	0	0	263774	0	313782	1127433		
174604	3839	40213227	1992-11-02	1992-11-02 00:00:00	1992-11-02	1992-11-02 00:00:00	1992-11-02	581452		0	0	0		0	0	0	254888	0	113	40213227		
42866	3553	1118084	1966-09-20	1966-09-20 00:00:00	1966-09-20	1966-09-20 00:00:00	\N	38000177		0	0	0		0	0	0	235944	0	00025152531	44923712		
47935	3973	1127078	1973-04-14	1973-04-14 00:00:00	1973-04-28	1973-04-28 00:00:00	1973-04-28	38000177		0	0	14		0	0	0	264217	0	282464	1127078		
34099	2818	1127433	2014-03-16	2014-03-16 00:00:00	2014-03-23	2014-03-23 00:00:00	2014-03-23	38000177		0	0	7		0	0	0	186771	0	313782	1127433		
4363	362	19078461	1995-09-17	1995-09-17 00:00:00	1995-11-16	1995-11-16 00:00:00	1995-11-16	38000177		0	0	60		0	0	0	24054	0	310965	19078461		
53543	4451	1127433	2001-07-08	2001-07-08 00:00:00	2001-07-15	2001-07-15 00:00:00	2001-07-15	38000177		0	0	7		0	0	0	296167	0	313782	1127433		
97911	2145	40213227	1996-09-28	1996-09-28 00:00:00	1996-09-28	1996-09-28 00:00:00	1996-09-28	581452		0	0	0		0	0	0	142824	0	113	40213227		
53903	4480	1118084	1998-08-10	1998-08-10 00:00:00	1998-08-10	1998-08-10 00:00:00	\N	38000177		0	0	0		0	0	0	298138	0	00025152531	44923712		
161835	3560	40213160	1960-10-12	1960-10-12 00:00:00	1960-10-12	1960-10-12 00:00:00	1960-10-12	581452		0	0	0		0	0	0	236360	0	10	40213160		
6206	520	1127433	1975-06-30	1975-06-30 00:00:00	1975-07-07	1975-07-07 00:00:00	1975-07-07	38000177		0	0	7		0	0	0	34726	0	313782	1127433		
125805	2768	40213160	1970-02-17	1970-02-17 00:00:00	1970-02-17	1970-02-17 00:00:00	1970-02-17	581452		0	0	0		0	0	0	183156	0	10	40213160		
8930	744	1118084	1994-07-01	1994-07-01 00:00:00	1994-07-01	1994-07-01 00:00:00	\N	38000177		0	0	0		0	0	0	49296	0	00025152531	44923712		
3002	244	19133905	1972-11-04	1972-11-04 00:00:00	1972-11-12	1972-11-12 00:00:00	1972-11-12	38000177		0	0	8		0	0	0	16266	0	834102	19133905		
36948	3056	19059056	1959-01-31	1959-01-31 00:00:00	1959-02-14	1959-02-14 00:00:00	1959-02-14	38000177		0	0	14		0	0	0	203260	0	243670	19059056		
19527	1608	19006318	1945-03-08	1945-03-08 00:00:00	1945-03-22	1945-03-22 00:00:00	1945-03-22	38000177		0	0	14		0	0	0	108027	0	105078	19006318		
116541	2561	40213227	2018-12-26	2018-12-26 00:00:00	2018-12-26	2018-12-26 00:00:00	2018-12-26	581452		0	0	0		0	0	0	169679	0	113	40213227		
181144	3980	40213306	1997-07-20	1997-07-20 00:00:00	1997-07-20	1997-07-20 00:00:00	1997-07-20	581452		0	0	0		0	0	0	264576	0	43	40213306		
102380	2244	40213260	2006-08-11	2006-08-11 00:00:00	2006-08-11	2006-08-11 00:00:00	2006-08-11	581452		0	0	0		0	0	0	149441	0	121	40213260		
43463	3603	40232448	1970-02-26	1970-02-26 00:00:00	1970-02-26	1970-02-26 00:00:00	\N	38000177		0	0	0		0	0	0	239354	0	1049630	40232448		
106676	2339	40213160	1977-08-02	1977-08-02 00:00:00	1977-08-02	1977-08-02 00:00:00	1977-08-02	581452		0	0	0		0	0	0	155619	0	10	40213160		
208412	4571	40213227	1996-01-13	1996-01-13 00:00:00	1996-01-13	1996-01-13 00:00:00	1996-01-13	581452		0	0	0		0	0	0	304587	0	113	40213227		
2402	191	40231925	1939-03-31	1939-03-31 00:00:00	1939-03-31	1939-03-31 00:00:00	\N	38000177		0	0	0		0	0	0	13039	0	1049221	40231925		
153944	3389	40213260	2008-09-01	2008-09-01 00:00:00	2008-09-01	2008-09-01 00:00:00	2008-09-01	581452		0	0	0		0	0	0	224804	0	121	40213260		
59218	4922	40236824	2002-10-14	2002-10-14 00:00:00	2002-10-21	2002-10-21 00:00:00	2002-10-21	38000177		0	0	7		0	0	0	327038	0	1094107	40236824		
39621	3277	19059056	1967-11-11	1967-11-11 00:00:00	1967-12-02	1967-12-02 00:00:00	1967-12-02	38000177		0	0	21		0	0	0	217691	0	243670	19059056		
164057	3609	40213227	1997-03-28	1997-03-28 00:00:00	1997-03-28	1997-03-28 00:00:00	1997-03-28	581452		0	0	0		0	0	0	239781	0	113	40213227		
60303	5014	19059056	1917-01-20	1917-01-20 00:00:00	1917-02-03	1917-02-03 00:00:00	1917-02-03	38000177		0	0	14		0	0	0	333268	0	243670	19059056		
207815	4559	40213201	2011-07-05	2011-07-05 00:00:00	2011-07-05	2011-07-05 00:00:00	2011-07-05	581452		0	0	0		0	0	0	303730	0	33	40213201		
45574	3772	46233988	1974-07-04	1974-07-04 00:00:00	1974-07-18	1974-07-18 00:00:00	1974-07-18	38000177		0	0	14		0	0	0	250688	0	1652673	46233988		
156065	3435	40213314	1977-10-01	1977-10-01 00:00:00	1977-10-01	1977-10-01 00:00:00	1977-10-01	581452		0	0	0		0	0	0	227784	0	49	40213314		
51872	4312	19078461	1982-01-06	1982-01-06 00:00:00	1982-01-20	1982-01-20 00:00:00	1982-01-20	38000177		0	0	14		0	0	0	286061	0	310965	19078461		
25987	2138	1127433	1972-12-05	1972-12-05 00:00:00	1972-12-12	1972-12-12 00:00:00	1972-12-12	38000177		0	0	7		0	0	0	142430	0	313782	1127433		
62417	5195	1124300	1995-05-29	1995-05-29 00:00:00	1995-05-29	1995-05-29 00:00:00	\N	38000177		0	0	0		0	0	0	345424	0	00781178901	45011828		
223441	4905	40213227	2004-03-25	2004-03-25 00:00:00	2004-03-25	2004-03-25 00:00:00	2004-03-25	581452		0	0	0		0	0	0	326045	0	113	40213227		
62526	5200	40229134	1968-05-24	1968-05-24 00:00:00	1968-06-07	1968-06-07 00:00:00	1968-06-07	38000177		0	0	14		0	0	0	345866	0	1043400	40229134		
39400	3254	1127078	1964-04-07	1964-04-07 00:00:00	1964-04-21	1964-04-21 00:00:00	1964-04-21	38000177		0	0	14		0	0	0	216448	0	282464	1127078		
80381	1758	40213160	1961-04-28	1961-04-28 00:00:00	1961-04-28	1961-04-28 00:00:00	1961-04-28	581452		0	0	0		0	0	0	117529	0	10	40213160		
3984	331	40220386	1997-04-18	1997-04-18 00:00:00	1997-04-18	1997-04-18 00:00:00	1997-04-18	38000177		0	0	0		0	0	0	21811	0	1808217	40220386		
29555	2445	1127433	1969-01-28	1969-01-28 00:00:00	1969-02-11	1969-02-11 00:00:00	1969-02-11	38000177		0	0	14		0	0	0	162233	0	313782	1127433		
35268	2906	1127433	1977-01-15	1977-01-15 00:00:00	1977-01-22	1977-01-22 00:00:00	1977-01-22	38000177		0	0	7		0	0	0	193691	0	313782	1127433		
66920	1464	40213160	1960-08-10	1960-08-10 00:00:00	1960-08-10	1960-08-10 00:00:00	1960-08-10	581452		0	0	0		0	0	0	97516	0	10	40213160		
178156	3916	40213306	2001-11-28	2001-11-28 00:00:00	2001-11-28	2001-11-28 00:00:00	2001-11-28	581452		0	0	0		0	0	0	\N	0	43	40213306		
29706	2460	1127078	1991-04-04	1991-04-04 00:00:00	1991-04-18	1991-04-18 00:00:00	1991-04-18	38000177		0	0	14		0	0	0	163069	0	282464	1127078		
12121	1017	19074679	1972-03-26	1972-03-26 00:00:00	1972-07-02	1972-07-02 00:00:00	1972-07-02	38000177		0	0	98		0	0	0	66962	0	308971	19074679		
211675	4641	40213227	2009-07-23	2009-07-23 00:00:00	2009-07-23	2009-07-23 00:00:00	2009-07-23	581452		0	0	0		0	0	0	309318	0	113	40213227		
38560	3183	1127433	2004-11-30	2004-11-30 00:00:00	2004-12-07	2004-12-07 00:00:00	2004-12-07	38000177		0	0	7		0	0	0	211899	0	313782	1127433		
134384	2950	40213227	1996-12-16	1996-12-16 00:00:00	1996-12-16	1996-12-16 00:00:00	1996-12-16	581452		0	0	0		0	0	0	196950	0	113	40213227		
103095	2261	40213160	1964-07-14	1964-07-14 00:00:00	1964-07-14	1964-07-14 00:00:00	1964-07-14	581452		0	0	0		0	0	0	150305	0	10	40213160		
29230	2419	1127433	1985-06-09	1985-06-09 00:00:00	1985-06-16	1985-06-16 00:00:00	1985-06-16	38000177		0	0	7		0	0	0	160483	0	313782	1127433		
5364	449	40169281	1995-12-14	1995-12-14 00:00:00	1995-12-14	1995-12-14 00:00:00	\N	38000177		0	0	0		0	0	0	29868	0	896209	40169281		
33616	2782	1127433	1987-06-20	1987-06-20 00:00:00	1987-07-04	1987-07-04 00:00:00	1987-07-04	38000177		0	0	14		0	0	0	184423	0	313782	1127433		
17496	1447	19059056	1963-06-01	1963-06-01 00:00:00	1963-06-15	1963-06-15 00:00:00	1963-06-15	38000177		0	0	14		0	0	0	96480	0	243670	19059056		
15955	1322	19133905	1945-05-02	1945-05-02 00:00:00	1945-05-09	1945-05-09 00:00:00	1945-05-09	38000177		0	0	7		0	0	0	87792	0	834102	19133905		
785	63	19059056	1956-12-08	1956-12-08 00:00:00	1956-12-29	1956-12-29 00:00:00	1956-12-29	38000177		0	0	21		0	0	0	4295	0	243670	19059056		
10989	917	1127078	1967-11-10	1967-11-10 00:00:00	1967-11-24	1967-11-24 00:00:00	1967-11-24	38000177		0	0	14		0	0	0	61048	0	282464	1127078		
16067	1332	1713671	1982-08-28	1982-08-28 00:00:00	1982-09-18	1982-09-18 00:00:00	1982-09-18	38000177		0	0	21		0	0	0	88385	0	562251	1713671		
8501	709	19075601	1999-07-04	1999-07-04 00:00:00	2005-08-28	2005-08-28 00:00:00	2005-08-28	38000177		0	0	2247		0	0	0	46961	0	309362	19075601		
29961	2482	1127433	1990-06-04	1990-06-04 00:00:00	1990-06-11	1990-06-11 00:00:00	1990-06-11	38000177		0	0	7		0	0	0	164439	0	313782	1127433		
22419	1843	1519937	2009-06-03	2009-06-03 00:00:00	2010-05-29	2010-05-29 00:00:00	2010-05-29	38000177		0	0	360		0	0	0	123072	0	389221	1519937		
54691	4544	40229134	1942-03-14	1942-03-14 00:00:00	1942-03-28	1942-03-28 00:00:00	1942-03-28	38000177		0	0	14		0	0	0	302708	0	1043400	40229134		
40564	3363	19059056	1958-06-28	1958-06-28 00:00:00	1958-09-26	1958-09-26 00:00:00	1958-09-26	38000177		0	0	90		0	0	0	222950	0	243670	19059056		
32539	2697	40229134	2004-03-20	2004-03-20 00:00:00	2004-04-03	2004-04-03 00:00:00	2004-04-03	38000177		0	0	14		0	0	0	178566	0	1043400	40229134		
19395	422	40213160	1959-06-20	1959-06-20 00:00:00	1959-06-20	1959-06-20 00:00:00	1959-06-20	581452		0	0	0		0	0	0	27915	0	10	40213160		
5791	484	19059056	1947-10-13	1947-10-13 00:00:00	1948-01-11	1948-01-11 00:00:00	1948-01-11	38000177		0	0	90		0	0	0	32399	0	243670	19059056		
174609	3839	40213227	2011-10-24	2011-10-24 00:00:00	2011-10-24	2011-10-24 00:00:00	2011-10-24	581452		0	0	0		0	0	0	254881	0	113	40213227		
42867	3553	1127433	1948-05-01	1948-05-01 00:00:00	1948-05-15	1948-05-15 00:00:00	1948-05-15	38000177		0	0	14		0	0	0	235871	0	313782	1127433		
47936	3973	1127433	2005-07-09	2005-07-09 00:00:00	2005-10-07	2005-10-07 00:00:00	2005-10-07	38000177		0	0	90		0	0	0	264219	0	313782	1127433		
34100	2818	1127078	1971-11-18	1971-11-18 00:00:00	1971-12-02	1971-12-02 00:00:00	1971-12-02	38000177		0	0	14		0	0	0	186727	0	282464	1127078		
4364	362	40165015	1995-09-17	1995-09-17 00:00:00	1995-09-17	1995-09-17 00:00:00	\N	38000177		0	0	0		0	0	0	24054	0	861467	40165015		
53544	4451	1127433	1957-03-14	1957-03-14 00:00:00	1957-03-21	1957-03-21 00:00:00	1957-03-21	38000177		0	0	7		0	0	0	296177	0	313782	1127433		
109191	2395	40213160	1959-10-23	1959-10-23 00:00:00	1959-10-23	1959-10-23 00:00:00	1959-10-23	581452		0	0	0		0	0	0	159276	0	10	40213160		
53904	4480	1127433	1965-09-08	1965-09-08 00:00:00	1965-09-22	1965-09-22 00:00:00	1965-09-22	38000177		0	0	14		0	0	0	298122	0	313782	1127433		
161844	3560	40213160	1965-04-14	1965-04-14 00:00:00	1965-04-14	1965-04-14 00:00:00	1965-04-14	581452		0	0	0		0	0	0	236363	0	10	40213160		
6207	520	1713671	1969-10-06	1969-10-06 00:00:00	1969-10-27	1969-10-27 00:00:00	1969-10-27	38000177		0	0	21		0	0	0	34694	0	562251	1713671		
125808	2768	40213160	1969-11-18	1969-11-18 00:00:00	1969-11-18	1969-11-18 00:00:00	1969-11-18	581452		0	0	0		0	0	0	183144	0	10	40213160		
8954	747	19059056	1985-12-24	1985-12-24 00:00:00	1986-01-14	1986-01-14 00:00:00	1986-01-14	38000177		0	0	21		0	0	0	49476	0	243670	19059056		
3003	244	1127433	1926-12-20	1926-12-20 00:00:00	1926-12-27	1926-12-27 00:00:00	1926-12-27	38000177		0	0	7		0	0	0	16262	0	313782	1127433		
36949	3056	1713671	1966-12-12	1966-12-12 00:00:00	1966-12-19	1966-12-19 00:00:00	1966-12-19	38000177		0	0	7		0	0	0	203249	0	562251	1713671		
19528	1608	19059056	1945-03-08	1945-03-08 00:00:00	1945-03-22	1945-03-22 00:00:00	1945-03-22	38000177		0	0	14		0	0	0	108027	0	243670	19059056		
116542	2561	40213296	2018-12-26	2018-12-26 00:00:00	2018-12-26	2018-12-26 00:00:00	2018-12-26	581452		0	0	0		0	0	0	169679	0	52	40213296		
181146	3980	40213227	1997-07-20	1997-07-20 00:00:00	1997-07-20	1997-07-20 00:00:00	1997-07-20	581452		0	0	0		0	0	0	264576	0	113	40213227		
147547	3244	40213227	2004-11-17	2004-11-17 00:00:00	2004-11-17	2004-11-17 00:00:00	2004-11-17	581452		0	0	0		0	0	0	215727	0	113	40213227		
43464	3603	1127433	1973-12-13	1973-12-13 00:00:00	1973-12-27	1973-12-27 00:00:00	1973-12-27	38000177		0	0	14		0	0	0	239360	0	313782	1127433		
106678	2339	40213160	1972-11-28	1972-11-28 00:00:00	1972-11-28	1972-11-28 00:00:00	1972-11-28	581452		0	0	0		0	0	0	155648	0	10	40213160		
54001	4487	19133905	1985-03-11	1985-03-11 00:00:00	1985-03-18	1985-03-18 00:00:00	1985-03-18	38000177		0	0	7		0	0	0	298749	0	834102	19133905		
2403	191	40229134	1957-10-12	1957-10-12 00:00:00	1957-10-19	1957-10-19 00:00:00	1957-10-19	38000177		0	0	7		0	0	0	13065	0	1043400	40229134		
153946	3389	40213160	1959-05-11	1959-05-11 00:00:00	1959-05-11	1959-05-11 00:00:00	1959-05-11	581452		0	0	0		0	0	0	224808	0	10	40213160		
59219	4923	1713671	1997-09-19	1997-09-19 00:00:00	1997-10-03	1997-10-03 00:00:00	1997-10-03	38000177		0	0	14		0	0	0	327129	0	562251	1713671		
39622	3277	19078461	2013-12-21	2013-12-21 00:00:00	2014-01-11	2014-01-11 00:00:00	2014-01-11	38000177		0	0	21		0	0	0	217694	0	310965	19078461		
164060	3609	40213314	1977-11-04	1977-11-04 00:00:00	1977-11-04	1977-11-04 00:00:00	1977-11-04	581452		0	0	0		0	0	0	239772	0	49	40213314		
60304	5015	19059056	1982-05-22	1982-05-22 00:00:00	1982-06-12	1982-06-12 00:00:00	1982-06-12	38000177		0	0	21		0	0	0	333374	0	243670	19059056		
60123	1315	40213260	2010-06-15	2010-06-15 00:00:00	2010-06-15	2010-06-15 00:00:00	2010-06-15	581452		0	0	0		0	0	0	87094	0	121	40213260		
45575	3772	40229134	2014-06-28	2014-06-28 00:00:00	2014-07-12	2014-07-12 00:00:00	2014-07-12	38000177		0	0	14		0	0	0	250762	0	1043400	40229134		
156069	3435	40213227	2007-11-10	2007-11-10 00:00:00	2007-11-10	2007-11-10 00:00:00	2007-11-10	581452		0	0	0		0	0	0	227794	0	113	40213227		
51873	4312	19074841	1982-01-06	1982-01-06 00:00:00	1982-01-20	1982-01-20 00:00:00	1982-01-20	38000177		0	0	14		0	0	0	286061	0	309043	19074841		
25988	2138	19059056	1957-02-26	1957-02-26 00:00:00	1957-03-12	1957-03-12 00:00:00	1957-03-12	38000177		0	0	14		0	0	0	142424	0	243670	19059056		
62418	5195	19059056	1963-12-28	1963-12-28 00:00:00	1964-01-18	1964-01-18 00:00:00	1964-01-18	38000177		0	0	21		0	0	0	345408	0	243670	19059056		
223447	4905	40213227	1995-03-16	1995-03-16 00:00:00	1995-03-16	1995-03-16 00:00:00	1995-03-16	581452		0	0	0		0	0	0	326053	0	113	40213227		
62527	5200	1713671	2019-04-20	2019-04-20 00:00:00	2019-05-04	2019-05-04 00:00:00	2019-05-04	38000177		0	0	14		0	0	0	345813	0	562251	1713671		
39401	3254	19129655	1964-04-07	1964-04-07 00:00:00	1964-04-21	1964-04-21 00:00:00	1964-04-21	38000177		0	0	14		0	0	0	216448	0	789980	19129655		
80385	1758	40213260	2012-03-09	2012-03-09 00:00:00	2012-03-09	2012-03-09 00:00:00	2012-03-09	581452		0	0	0		0	0	0	117508	0	121	40213260		
224640	4932	40213227	2018-12-13	2018-12-13 00:00:00	2018-12-13	2018-12-13 00:00:00	2018-12-13	581452		0	0	0		0	0	0	327799	0	113	40213227		
29556	2445	19059056	1928-08-28	1928-08-28 00:00:00	1928-09-18	1928-09-18 00:00:00	1928-09-18	38000177		0	0	21		0	0	0	162195	0	243670	19059056		
35269	2906	1713671	1985-05-31	1985-05-31 00:00:00	1985-06-14	1985-06-14 00:00:00	1985-06-14	38000177		0	0	14		0	0	0	193692	0	562251	1713671		
66922	1464	40213160	1964-09-02	1964-09-02 00:00:00	1964-09-02	1964-09-02 00:00:00	1964-09-02	581452		0	0	0		0	0	0	97557	0	10	40213160		
178159	3916	40213227	2010-08-18	2010-08-18 00:00:00	2010-08-18	2010-08-18 00:00:00	2010-08-18	581452		0	0	0		0	0	0	260292	0	113	40213227		
29707	2460	44816277	2003-07-14	2003-07-14 00:00:00	2004-07-08	2004-07-08 00:00:00	2004-07-08	38000177		0	0	360		0	0	0	163118	0	1534809	44816277		
12122	1017	1115171	2009-09-27	2009-09-27 00:00:00	2009-12-26	2009-12-26 00:00:00	2009-12-26	38000177		0	0	90		0	0	0	67004	0	849574	1115171		
211676	4641	40213296	2009-07-23	2009-07-23 00:00:00	2009-07-23	2009-07-23 00:00:00	2009-07-23	581452		0	0	0		0	0	0	309318	0	52	40213296		
38561	3183	1118084	2017-07-14	2017-07-14 00:00:00	2017-07-14	2017-07-14 00:00:00	\N	38000177		0	0	0		0	0	0	211934	0	00025152531	44923712		
180800	3973	40213227	1999-11-25	1999-11-25 00:00:00	1999-11-25	1999-11-25 00:00:00	1999-11-25	581452		0	0	0		0	0	0	264199	0	113	40213227		
103104	2261	40213260	2013-11-05	2013-11-05 00:00:00	2013-11-05	2013-11-05 00:00:00	2013-11-05	581452		0	0	0		0	0	0	150350	0	121	40213260		
5245	440	1713671	1982-02-01	1982-02-01 00:00:00	1982-02-08	1982-02-08 00:00:00	1982-02-08	38000177		0	0	7		0	0	0	29191	0	562251	1713671		
128798	2832	40213160	1965-10-24	1965-10-24 00:00:00	1965-10-24	1965-10-24 00:00:00	1965-10-24	581452		0	0	0		0	0	0	188002	0	10	40213160		
33617	2782	40223774	1997-02-18	1997-02-18 00:00:00	1997-02-18	1997-02-18 00:00:00	\N	38000177		0	0	0		0	0	0	184438	0	998582	40223774		
17497	1447	1713671	1985-12-08	1985-12-08 00:00:00	1985-12-29	1985-12-29 00:00:00	1985-12-29	38000177		0	0	21		0	0	0	96546	0	562251	1713671		
15956	1322	1713671	1995-12-06	1995-12-06 00:00:00	1995-12-13	1995-12-13 00:00:00	1995-12-13	38000177		0	0	7		0	0	0	87721	0	562251	1713671		
786	63	19059056	1956-10-10	1956-10-10 00:00:00	1956-10-24	1956-10-24 00:00:00	1956-10-24	38000177		0	0	14		0	0	0	4305	0	243670	19059056		
10990	917	46233988	1967-11-10	1967-11-10 00:00:00	1967-11-24	1967-11-24 00:00:00	1967-11-24	38000177		0	0	14		0	0	0	61048	0	1652673	46233988		
16068	1332	1713671	1947-01-01	1947-01-01 00:00:00	1947-01-08	1947-01-08 00:00:00	1947-01-08	38000177		0	0	7		0	0	0	88302	0	562251	1713671		
8502	709	1539411	1999-07-04	1999-07-04 00:00:00	1999-07-04	1999-07-04 00:00:00	\N	38000177		0	0	0		0	0	0	46961	0	312961	1539411		
29962	2482	19128022	1992-08-18	1992-08-18 00:00:00	1993-08-13	1993-08-13 00:00:00	1993-08-13	38000177		0	0	360		0	0	0	164431	0	749785	19128022		
22420	1843	19128065	2001-07-15	2001-07-15 00:00:00	2002-07-10	2002-07-10 00:00:00	2002-07-10	38000177		0	0	360		0	0	0	122995	0	749882	19128065		
54692	4544	19059056	1943-09-03	1943-09-03 00:00:00	1943-09-17	1943-09-17 00:00:00	1943-09-17	38000177		0	0	14		0	0	0	302692	0	243670	19059056		
40565	3363	1713671	1956-05-09	1956-05-09 00:00:00	1956-06-06	1956-06-06 00:00:00	1956-06-06	38000177		0	0	28		0	0	0	222954	0	562251	1713671		
32540	2697	19075601	1997-07-10	1997-07-10 00:00:00	1997-07-10	1997-07-10 00:00:00	\N	38000177		0	0	0		0	0	0	178618	0	309362	19075601		
81834	1788	40213260	2011-08-18	2011-08-18 00:00:00	2011-08-18	2011-08-18 00:00:00	2011-08-18	581452		0	0	0		0	0	0	119788	0	121	40213260		
5792	484	1713671	1962-06-01	1962-06-01 00:00:00	1962-06-22	1962-06-22 00:00:00	1962-06-22	38000177		0	0	21		0	0	0	32375	0	562251	1713671		
174632	3839	40213227	2002-09-02	2002-09-02 00:00:00	2002-09-02	2002-09-02 00:00:00	2002-09-02	581452		0	0	0		0	0	0	254879	0	113	40213227		
42868	3553	19059056	1934-07-20	1934-07-20 00:00:00	1934-08-24	1934-08-24 00:00:00	1934-08-24	38000177		0	0	35		0	0	0	235863	0	243670	19059056		
47937	3973	19059056	1979-06-28	1979-06-28 00:00:00	1979-07-12	1979-07-12 00:00:00	1979-07-12	38000177		0	0	14		0	0	0	264206	0	243670	19059056		
34114	2821	1127433	1936-11-05	1936-11-05 00:00:00	1936-11-19	1936-11-19 00:00:00	1936-11-19	38000177		0	0	14		0	0	0	186917	0	313782	1127433		
4365	362	1127433	1996-12-14	1996-12-14 00:00:00	1996-12-28	1996-12-28 00:00:00	1996-12-28	38000177		0	0	14		0	0	0	24018	0	313782	1127433		
53545	4451	1127433	2003-09-28	2003-09-28 00:00:00	2003-12-27	2003-12-27 00:00:00	2003-12-27	38000177		0	0	90		0	0	0	296141	0	313782	1127433		
153447	3378	40213227	2018-09-22	2018-09-22 00:00:00	2018-09-22	2018-09-22 00:00:00	2018-09-22	581452		0	0	0		0	0	0	224163	0	113	40213227		
53905	4480	19059056	1966-09-02	1966-09-02 00:00:00	1966-12-01	1966-12-01 00:00:00	1966-12-01	38000177		0	0	90		0	0	0	298204	0	243670	19059056		
161846	3560	40213160	1960-08-10	1960-08-10 00:00:00	1960-08-10	1960-08-10 00:00:00	1960-08-10	581452		0	0	0		0	0	0	236338	0	10	40213160		
6208	520	1127433	1964-07-08	1964-07-08 00:00:00	1964-07-15	1964-07-15 00:00:00	1964-07-15	38000177		0	0	7		0	0	0	34663	0	313782	1127433		
125811	2768	40213160	1974-05-21	1974-05-21 00:00:00	1974-05-21	1974-05-21 00:00:00	1974-05-21	581452		0	0	0		0	0	0	183148	0	10	40213160		
8955	747	1118084	1996-01-31	1996-01-31 00:00:00	1996-01-31	1996-01-31 00:00:00	\N	38000177		0	0	0		0	0	0	49464	0	00025152531	44923712		
3004	244	40229134	1946-01-29	1946-01-29 00:00:00	1946-02-05	1946-02-05 00:00:00	1946-02-05	38000177		0	0	7		0	0	0	16282	0	1043400	40229134		
36950	3056	1124300	1997-05-12	1997-05-12 00:00:00	1997-05-12	1997-05-12 00:00:00	\N	38000177		0	0	0		0	0	0	203276	0	00781178901	45011828		
19529	1608	19133905	1960-06-23	1960-06-23 00:00:00	1960-07-03	1960-07-03 00:00:00	1960-07-03	38000177		0	0	10		0	0	0	108043	0	834102	19133905		
116546	2561	40213314	1978-01-04	1978-01-04 00:00:00	1978-01-04	1978-01-04 00:00:00	1978-01-04	581452		0	0	0		0	0	0	169677	0	49	40213314		
192427	4227	40213160	1955-10-23	1955-10-23 00:00:00	1955-10-23	1955-10-23 00:00:00	1955-10-23	581452		0	0	0		0	0	0	280809	0	10	40213160		
147548	3244	40213314	1977-03-23	1977-03-23 00:00:00	1977-03-23	1977-03-23 00:00:00	1977-03-23	581452		0	0	0		0	0	0	215683	0	49	40213314		
43465	3603	1118084	2004-03-23	2004-03-23 00:00:00	2004-03-23	2004-03-23 00:00:00	\N	38000177		0	0	0		0	0	0	239322	0	00025152531	44923712		
217512	4773	40213160	1959-04-02	1959-04-02 00:00:00	1959-04-02	1959-04-02 00:00:00	1959-04-02	581452		0	0	0		0	0	0	317856	0	10	40213160		
54002	4487	1713671	1980-11-09	1980-11-09 00:00:00	1980-11-16	1980-11-16 00:00:00	1980-11-16	38000177		0	0	7		0	0	0	298713	0	562251	1713671		
2404	191	40223774	1999-03-08	1999-03-08 00:00:00	1999-03-08	1999-03-08 00:00:00	\N	38000177		0	0	0		0	0	0	13027	0	998582	40223774		
88131	1933	40213160	1958-09-05	1958-09-05 00:00:00	1958-09-05	1958-09-05 00:00:00	1958-09-05	581452		0	0	0		0	0	0	128567	0	10	40213160		
59220	4923	1127078	1978-03-12	1978-03-12 00:00:00	1978-03-26	1978-03-26 00:00:00	1978-03-26	38000177		0	0	14		0	0	0	327132	0	282464	1127078		
39623	3277	19129655	1965-08-23	1965-08-23 00:00:00	1965-09-06	1965-09-06 00:00:00	1965-09-06	38000177		0	0	14		0	0	0	217714	0	789980	19129655		
164067	3609	40213160	1975-03-07	1975-03-07 00:00:00	1975-03-07	1975-03-07 00:00:00	1975-03-07	581452		0	0	0		0	0	0	239749	0	10	40213160		
60305	5015	1127078	1971-02-27	1971-02-27 00:00:00	1971-03-13	1971-03-13 00:00:00	1971-03-13	38000177		0	0	14		0	0	0	333363	0	282464	1127078		
60142	1316	40213227	2000-04-11	2000-04-11 00:00:00	2000-04-11	2000-04-11 00:00:00	2000-04-11	581452		0	0	0		0	0	0	87235	0	113	40213227		
45576	3773	1127433	1961-11-14	1961-11-14 00:00:00	1961-11-28	1961-11-28 00:00:00	1961-11-28	38000177		0	0	14		0	0	0	250777	0	313782	1127433		
222161	4876	40213227	2014-07-05	2014-07-05 00:00:00	2014-07-05	2014-07-05 00:00:00	2014-07-05	581452		0	0	0		0	0	0	324274	0	113	40213227		
51874	4312	1154615	1963-09-22	1963-09-22 00:00:00	1981-09-16	1981-09-16 00:00:00	1981-09-16	38000177		0	0	6569		0	0	0	286193	0	745679	1154615		
25989	2138	19006318	1957-02-26	1957-02-26 00:00:00	1957-03-12	1957-03-12 00:00:00	1957-03-12	38000177		0	0	14		0	0	0	142424	0	105078	19006318		
62419	5195	19133905	1986-09-12	1986-09-12 00:00:00	1986-09-24	1986-09-24 00:00:00	1986-09-24	38000177		0	0	12		0	0	0	345475	0	834102	19133905		
223448	4905	40213306	1995-03-16	1995-03-16 00:00:00	1995-03-16	1995-03-16 00:00:00	1995-03-16	581452		0	0	0		0	0	0	326053	0	43	40213306		
62528	5200	19059056	1960-08-20	1960-08-20 00:00:00	1960-09-03	1960-09-03 00:00:00	1960-09-03	38000177		0	0	14		0	0	0	345937	0	243670	19059056		
39402	3254	920300	1985-01-01	1985-01-01 00:00:00	1985-01-08	1985-01-08 00:00:00	1985-01-08	38000177		0	0	7		0	0	0	216410	0	311989	920300		
80386	1758	40213227	2012-03-09	2012-03-09 00:00:00	2012-03-09	2012-03-09 00:00:00	2012-03-09	581452		0	0	0		0	0	0	117508	0	113	40213227		
224643	4932	40213227	1999-04-29	1999-04-29 00:00:00	1999-04-29	1999-04-29 00:00:00	1999-04-29	581452		0	0	0		0	0	0	327820	0	113	40213227		
29557	2445	1713671	1947-04-26	1947-04-26 00:00:00	1947-05-10	1947-05-10 00:00:00	1947-05-10	38000177		0	0	14		0	0	0	162220	0	562251	1713671		
35270	2906	19059056	1956-11-23	1956-11-23 00:00:00	1957-01-22	1957-01-22 00:00:00	1957-01-22	38000177		0	0	60		0	0	0	193722	0	243670	19059056		
66925	1464	40213160	1960-05-11	1960-05-11 00:00:00	1960-05-11	1960-05-11 00:00:00	1960-05-11	581452		0	0	0		0	0	0	97537	0	10	40213160		
178162	3916	40213160	1983-05-25	1983-05-25 00:00:00	1983-05-25	1983-05-25 00:00:00	1983-05-25	581452		0	0	0		0	0	0	\N	0	10	40213160		
29708	2460	40169216	1988-08-14	1988-08-14 00:00:00	1988-08-14	1988-08-14 00:00:00	\N	38000177		0	0	0		0	0	0	163084	0	895994	40169216		
12123	1017	1127433	1984-10-17	1984-10-17 00:00:00	1984-11-07	1984-11-07 00:00:00	1984-11-07	38000177		0	0	21		0	0	0	67003	0	313782	1127433		
211683	4641	40213227	1998-07-23	1998-07-23 00:00:00	1998-07-23	1998-07-23 00:00:00	1998-07-23	581452		0	0	0		0	0	0	309326	0	113	40213227		
38562	3184	1127433	1997-06-19	1997-06-19 00:00:00	1997-07-10	1997-07-10 00:00:00	1997-07-10	38000177		0	0	21		0	0	0	211992	0	313782	1127433		
180802	3973	40213160	1973-07-05	1973-07-05 00:00:00	1973-07-05	1973-07-05 00:00:00	1973-07-05	581452		0	0	0		0	0	0	264210	0	10	40213160		
156950	3454	40213251	1988-02-15	1988-02-15 00:00:00	1988-02-15	1988-02-15 00:00:00	1988-02-15	581452		0	0	0		0	0	0	229157	0	21	40213251		
5246	440	19128065	1988-11-29	1988-11-29 00:00:00	1989-11-24	1989-11-24 00:00:00	1989-11-24	38000177		0	0	360		0	0	0	29172	0	749882	19128065		
128801	2832	40213160	1965-07-25	1965-07-25 00:00:00	1965-07-25	1965-07-25 00:00:00	1965-07-25	581452		0	0	0		0	0	0	187968	0	10	40213160		
33618	2782	40220960	2002-03-06	2002-03-06 00:00:00	2002-03-06	2002-03-06 00:00:00	2002-03-06	38000177		0	0	0		0	0	0	184443	0	1804799	40220960		
17498	1447	19128065	1974-07-13	1974-07-13 00:00:00	1975-07-08	1975-07-08 00:00:00	1975-07-08	38000177		0	0	360		0	0	0	96544	0	749882	19128065		
15957	1322	19133905	1945-09-09	1945-09-09 00:00:00	1945-09-22	1945-09-22 00:00:00	1945-09-22	38000177		0	0	13		0	0	0	87787	0	834102	19133905		
787	63	19006318	1956-10-10	1956-10-10 00:00:00	1956-10-24	1956-10-24 00:00:00	1956-10-24	38000177		0	0	14		0	0	0	4305	0	105078	19006318		
10991	917	1127433	1981-02-11	1981-02-11 00:00:00	1981-02-25	1981-02-25 00:00:00	1981-02-25	38000177		0	0	14		0	0	0	61016	0	313782	1127433		
16069	1332	19133768	2019-01-02	2019-01-02 00:00:00	2019-01-02	2019-01-02 00:00:00	2019-01-02	38000177		0	0	0		0	0	0	88384	0	833036	19133768		
8503	709	1332419	1999-07-04	1999-07-04 00:00:00	1999-07-04	1999-07-04 00:00:00	\N	38000177		0	0	0		0	0	0	46961	0	197361	1332419		
29963	2482	19128022	1993-08-13	1993-08-13 00:00:00	1994-08-08	1994-08-08 00:00:00	1994-08-08	38000177		0	0	360		0	0	0	164432	0	749785	19128022		
22421	1843	1127078	1992-04-21	1992-04-21 00:00:00	1992-05-12	1992-05-12 00:00:00	1992-05-12	38000177		0	0	21		0	0	0	123010	0	282464	1127078		
54693	4544	1127433	1953-04-21	1953-04-21 00:00:00	1953-04-28	1953-04-28 00:00:00	1953-04-28	38000177		0	0	7		0	0	0	302653	0	313782	1127433		
40566	3363	19133873	1965-08-02	1965-08-02 00:00:00	1965-08-15	1965-08-15 00:00:00	1965-08-15	38000177		0	0	13		0	0	0	222992	0	834061	19133873		
32541	2698	40229134	2017-05-08	2017-05-08 00:00:00	2017-05-15	2017-05-15 00:00:00	2017-05-15	38000177		0	0	7		0	0	0	178687	0	1043400	40229134		
81840	1788	40213306	1984-02-02	1984-02-02 00:00:00	1984-02-02	1984-02-02 00:00:00	1984-02-02	581452		0	0	0		0	0	0	119781	0	43	40213306		
5793	484	1127433	2012-06-24	2012-06-24 00:00:00	2012-07-08	2012-07-08 00:00:00	2012-07-08	38000177		0	0	14		0	0	0	32403	0	313782	1127433		
24201	526	40213160	1976-01-28	1976-01-28 00:00:00	1976-01-28	1976-01-28 00:00:00	1976-01-28	581452		0	0	0		0	0	0	35081	0	10	40213160		
42869	3553	40229134	1942-09-08	1942-09-08 00:00:00	1942-09-15	1942-09-15 00:00:00	1942-09-15	38000177		0	0	7		0	0	0	235922	0	1043400	40229134		
47938	3973	1118084	2004-03-03	2004-03-03 00:00:00	2004-03-03	2004-03-03 00:00:00	\N	38000177		0	0	0		0	0	0	264200	0	00025152531	44923712		
34115	2821	40229134	1983-11-07	1983-11-07 00:00:00	1983-11-14	1983-11-14 00:00:00	1983-11-14	38000177		0	0	7		0	0	0	186952	0	1043400	40229134		
4366	363	1124300	2001-01-09	2001-01-09 00:00:00	2001-01-09	2001-01-09 00:00:00	\N	38000177		0	0	0		0	0	0	24071	0	00781178901	45011828		
53546	4451	40162522	1997-03-03	1997-03-03 00:00:00	1997-03-03	1997-03-03 00:00:00	\N	38000177		0	0	0		0	0	0	296176	0	857005	40162522		
153449	3378	40213227	1992-02-29	1992-02-29 00:00:00	1992-02-29	1992-02-29 00:00:00	1992-02-29	581452		0	0	0		0	0	0	224200	0	113	40213227		
53906	4480	1127433	2013-10-15	2013-10-15 00:00:00	2013-10-29	2013-10-29 00:00:00	2013-10-29	38000177		0	0	14		0	0	0	298125	0	313782	1127433		
161852	3560	40213296	2000-05-10	2000-05-10 00:00:00	2000-05-10	2000-05-10 00:00:00	2000-05-10	581452		0	0	0		0	0	0	236376	0	52	40213296		
6209	520	1713671	1976-09-22	1976-09-22 00:00:00	1976-09-29	1976-09-29 00:00:00	1976-09-29	38000177		0	0	7		0	0	0	34727	0	562251	1713671		
125813	2768	40213227	2010-09-14	2010-09-14 00:00:00	2010-09-14	2010-09-14 00:00:00	2010-09-14	581452		0	0	0		0	0	0	183140	0	113	40213227		
8956	747	1713671	1992-08-29	1992-08-29 00:00:00	1992-09-05	1992-09-05 00:00:00	1992-09-05	38000177		0	0	7		0	0	0	49470	0	562251	1713671		
3005	244	1713671	1932-12-08	1932-12-08 00:00:00	1932-12-29	1932-12-29 00:00:00	1932-12-29	38000177		0	0	21		0	0	0	16340	0	562251	1713671		
36951	3056	1127433	1981-02-20	1981-02-20 00:00:00	1981-03-06	1981-03-06 00:00:00	1981-03-06	38000177		0	0	14		0	0	0	203307	0	313782	1127433		
19530	1608	1127433	1957-09-10	1957-09-10 00:00:00	1957-09-17	1957-09-17 00:00:00	1957-09-17	38000177		0	0	7		0	0	0	107965	0	313782	1127433		
116550	2561	40213227	1999-12-01	1999-12-01 00:00:00	1999-12-01	1999-12-01 00:00:00	1999-12-01	581452		0	0	0		0	0	0	169685	0	113	40213227		
192438	4227	40213260	2007-02-25	2007-02-25 00:00:00	2007-02-25	2007-02-25 00:00:00	2007-02-25	581452		0	0	0		0	0	0	280805	0	121	40213260		
147550	3244	40213227	2015-04-29	2015-04-29 00:00:00	2015-04-29	2015-04-29 00:00:00	2015-04-29	581452		0	0	0		0	0	0	215743	0	113	40213227		
43466	3603	40229134	2006-06-21	2006-06-21 00:00:00	2006-06-28	2006-06-28 00:00:00	2006-06-28	38000177		0	0	7		0	0	0	239368	0	1043400	40229134		
217526	4773	40213227	2001-01-04	2001-01-04 00:00:00	2001-01-04	2001-01-04 00:00:00	2001-01-04	581452		0	0	0		0	0	0	317911	0	113	40213227		
54003	4487	1713671	1990-01-26	1990-01-26 00:00:00	1990-02-09	1990-02-09 00:00:00	1990-02-09	38000177		0	0	14		0	0	0	298719	0	562251	1713671		
2405	191	1127433	2000-06-04	2000-06-04 00:00:00	2000-06-25	2000-06-25 00:00:00	2000-06-25	38000177		0	0	21		0	0	0	13044	0	313782	1127433		
88134	1933	40213296	1998-06-05	1998-06-05 00:00:00	1998-06-05	1998-06-05 00:00:00	1998-06-05	581452		0	0	0		0	0	0	128558	0	52	40213296		
59221	4923	46233988	1978-03-12	1978-03-12 00:00:00	1978-03-26	1978-03-26 00:00:00	1978-03-26	38000177		0	0	14		0	0	0	327132	0	1652673	46233988		
39624	3277	19059056	1965-08-23	1965-08-23 00:00:00	1965-09-06	1965-09-06 00:00:00	1965-09-06	38000177		0	0	14		0	0	0	217714	0	243670	19059056		
164070	3609	40213160	1975-08-08	1975-08-08 00:00:00	1975-08-08	1975-08-08 00:00:00	1975-08-08	581452		0	0	0		0	0	0	239750	0	10	40213160		
60306	5015	46233988	1971-02-27	1971-02-27 00:00:00	1971-03-13	1971-03-13 00:00:00	1971-03-13	38000177		0	0	14		0	0	0	333363	0	1652673	46233988		
71438	1563	40213296	1998-02-14	1998-02-14 00:00:00	1998-02-14	1998-02-14 00:00:00	1998-02-14	581452		0	0	0		0	0	0	\N	0	52	40213296		
45577	3773	1127433	2003-06-09	2003-06-09 00:00:00	2003-06-16	2003-06-16 00:00:00	2003-06-16	38000177		0	0	7		0	0	0	250824	0	313782	1127433		
222162	4876	40213296	2014-07-05	2014-07-05 00:00:00	2014-07-05	2014-07-05 00:00:00	2014-07-05	581452		0	0	0		0	0	0	324274	0	52	40213296		
51875	4312	40169216	1963-09-22	1963-09-22 00:00:00	1981-09-16	1981-09-16 00:00:00	1981-09-16	38000177		0	0	6569		0	0	0	286193	0	895994	40169216		
25990	2138	1118084	1990-04-24	1990-04-24 00:00:00	1990-04-24	1990-04-24 00:00:00	\N	38000177		0	0	0		0	0	0	142387	0	00025152531	44923712		
62420	5195	1127433	1980-03-05	1980-03-05 00:00:00	1980-03-19	1980-03-19 00:00:00	1980-03-19	38000177		0	0	14		0	0	0	345445	0	313782	1127433		
223457	4905	40213296	2014-09-11	2014-09-11 00:00:00	2014-09-11	2014-09-11 00:00:00	2014-09-11	581452		0	0	0		0	0	0	326081	0	52	40213296		
62529	5200	40229134	1966-02-08	1966-02-08 00:00:00	1966-02-15	1966-02-15 00:00:00	1966-02-15	38000177		0	0	7		0	0	0	345848	0	1043400	40229134		
39403	3254	40236824	1985-01-01	1985-01-01 00:00:00	1985-01-08	1985-01-08 00:00:00	1985-01-08	38000177		0	0	7		0	0	0	216410	0	1094107	40236824		
80387	1758	40213160	1961-01-27	1961-01-27 00:00:00	1961-01-27	1961-01-27 00:00:00	1961-01-27	581452		0	0	0		0	0	0	117520	0	10	40213160		
224644	4932	40213296	1999-04-29	1999-04-29 00:00:00	1999-04-29	1999-04-29 00:00:00	1999-04-29	581452		0	0	0		0	0	0	327820	0	52	40213296		
29558	2445	19133873	1935-08-19	1935-08-19 00:00:00	1935-08-27	1935-08-27 00:00:00	1935-08-27	38000177		0	0	8		0	0	0	162197	0	834061	19133873		
35271	2906	1124300	1965-06-11	1965-06-11 00:00:00	1965-06-11	1965-06-11 00:00:00	\N	38000177		0	0	0		0	0	0	193713	0	00781178901	45011828		
66926	1464	40213260	2010-05-12	2010-05-12 00:00:00	2010-05-12	2010-05-12 00:00:00	2010-05-12	581452		0	0	0		0	0	0	97569	0	121	40213260		
178165	3916	40213160	1979-06-13	1979-06-13 00:00:00	1979-06-13	1979-06-13 00:00:00	1979-06-13	581452		0	0	0		0	0	0	260347	0	10	40213160		
29709	2460	1154615	1988-08-14	1988-08-14 00:00:00	1988-08-14	1988-08-14 00:00:00	\N	38000177		0	0	0		0	0	0	163084	0	745679	1154615		
12124	1017	1713671	1970-01-21	1970-01-21 00:00:00	1970-01-28	1970-01-28 00:00:00	1970-01-28	38000177		0	0	7		0	0	0	66927	0	562251	1713671		
211684	4641	40213160	1967-12-21	1967-12-21 00:00:00	1967-12-21	1967-12-21 00:00:00	1967-12-21	581452		0	0	0		0	0	0	309292	0	10	40213160		
38563	3184	1127433	2004-12-02	2004-12-02 00:00:00	2004-12-16	2004-12-16 00:00:00	2004-12-16	38000177		0	0	14		0	0	0	211959	0	313782	1127433		
180813	3973	40213296	2011-08-11	2011-08-11 00:00:00	2011-08-11	2011-08-11 00:00:00	2011-08-11	581452		0	0	0		0	0	0	264202	0	52	40213296		
156952	3454	40213160	1988-02-15	1988-02-15 00:00:00	1988-02-15	1988-02-15 00:00:00	1988-02-15	581452		0	0	0		0	0	0	229157	0	10	40213160		
5247	440	1127433	1983-09-18	1983-09-18 00:00:00	1983-09-25	1983-09-25 00:00:00	1983-09-25	38000177		0	0	7		0	0	0	29203	0	313782	1127433		
128806	2832	40213227	1996-04-28	1996-04-28 00:00:00	1996-04-28	1996-04-28 00:00:00	1996-04-28	581452		0	0	0		0	0	0	187979	0	113	40213227		
33619	2782	19075601	2002-03-06	2002-03-06 00:00:00	2002-03-06	2002-03-06 00:00:00	2002-03-06	38000177		0	0	0		0	0	0	184443	0	309362	19075601		
17499	1447	19059056	1990-09-21	1990-09-21 00:00:00	1990-10-12	1990-10-12 00:00:00	1990-10-12	38000177		0	0	21		0	0	0	96522	0	243670	19059056		
15958	1323	19133905	1986-07-10	1986-07-10 00:00:00	1986-07-17	1986-07-17 00:00:00	1986-07-17	38000177		0	0	7		0	0	0	87870	0	834102	19133905		
788	63	1713671	1962-07-17	1962-07-17 00:00:00	1962-08-07	1962-08-07 00:00:00	1962-08-07	38000177		0	0	21		0	0	0	4241	0	562251	1713671		
10992	917	40165015	1977-07-31	1977-07-31 00:00:00	1977-07-31	1977-07-31 00:00:00	\N	38000177		0	0	0		0	0	0	60913	0	861467	40165015		
16070	1332	1545959	2019-01-02	2019-01-02 00:00:00	2019-01-02	2019-01-02 00:00:00	2019-01-02	38000177		0	0	0		0	0	0	88384	0	259255	1545959		
8504	709	1713671	1991-11-17	1991-11-17 00:00:00	1991-12-08	1991-12-08 00:00:00	1991-12-08	38000177		0	0	21		0	0	0	46932	0	562251	1713671		
29964	2482	1127078	1974-12-11	1974-12-11 00:00:00	1974-12-25	1974-12-25 00:00:00	1974-12-25	38000177		0	0	14		0	0	0	164429	0	282464	1127078		
22422	1844	19133873	1962-11-18	1962-11-18 00:00:00	1962-11-30	1962-11-30 00:00:00	1962-11-30	38000177		0	0	12		0	0	0	123219	0	834061	19133873		
54694	4544	19059056	1949-10-31	1949-10-31 00:00:00	1949-12-30	1949-12-30 00:00:00	1949-12-30	38000177		0	0	60		0	0	0	302668	0	243670	19059056		
40567	3363	1127433	1985-04-30	1985-04-30 00:00:00	1985-05-14	1985-05-14 00:00:00	1985-05-14	38000177		0	0	14		0	0	0	222994	0	313782	1127433		
32542	2698	1118084	2019-04-17	2019-04-17 00:00:00	2019-04-17	2019-04-17 00:00:00	\N	38000177		0	0	0		0	0	0	178669	0	00025152531	44923712		
81850	1788	40213260	2012-10-25	2012-10-25 00:00:00	2012-10-25	2012-10-25 00:00:00	2012-10-25	581452		0	0	0		0	0	0	119802	0	121	40213260		
5794	484	1127433	1958-03-21	1958-03-21 00:00:00	1958-04-04	1958-04-04 00:00:00	1958-04-04	38000177		0	0	14		0	0	0	32307	0	313782	1127433		
24210	526	40213160	1971-11-03	1971-11-03 00:00:00	1971-11-03	1971-11-03 00:00:00	1971-11-03	581452		0	0	0		0	0	0	35055	0	10	40213160		
42898	3556	1713671	1995-07-14	1995-07-14 00:00:00	1995-07-28	1995-07-28 00:00:00	1995-07-28	38000177		0	0	14		0	0	0	236147	0	562251	1713671		
47951	3976	1713671	1998-10-24	1998-10-24 00:00:00	1998-11-07	1998-11-07 00:00:00	1998-11-07	38000177		0	0	14		0	0	0	264346	0	562251	1713671		
34116	2821	19059056	1977-11-25	1977-11-25 00:00:00	1977-12-09	1977-12-09 00:00:00	1977-12-09	38000177		0	0	14		0	0	0	186852	0	243670	19059056		
4367	363	1127433	2000-03-08	2000-03-08 00:00:00	2000-03-29	2000-03-29 00:00:00	2000-03-29	38000177		0	0	21		0	0	0	24071	0	313782	1127433		
53547	4451	1127433	1997-02-24	1997-02-24 00:00:00	1997-04-02	1997-04-02 00:00:00	1997-04-02	38000177		0	0	37		0	0	0	296140	0	313782	1127433		
153461	3378	40213227	1998-12-19	1998-12-19 00:00:00	1998-12-19	1998-12-19 00:00:00	1998-12-19	581452		0	0	0		0	0	0	224158	0	113	40213227		
53907	4480	1713671	1987-08-17	1987-08-17 00:00:00	1987-08-31	1987-08-31 00:00:00	1987-08-31	38000177		0	0	14		0	0	0	298124	0	562251	1713671		
161857	3560	40213306	1983-06-29	1983-06-29 00:00:00	1983-06-29	1983-06-29 00:00:00	1983-06-29	581452		0	0	0		0	0	0	236346	0	43	40213306		
6210	520	40236824	1974-12-10	1974-12-10 00:00:00	1974-12-24	1974-12-24 00:00:00	1974-12-24	38000177		0	0	14		0	0	0	34696	0	1094107	40236824		
125814	2768	40213296	2010-09-14	2010-09-14 00:00:00	2010-09-14	2010-09-14 00:00:00	2010-09-14	581452		0	0	0		0	0	0	183140	0	52	40213296		
8957	747	19078461	2008-06-08	2008-06-08 00:00:00	2008-07-06	2008-07-06 00:00:00	2008-07-06	38000177		0	0	28		0	0	0	49478	0	310965	19078461		
3006	245	1127433	1996-07-21	1996-07-21 00:00:00	1996-08-04	1996-08-04 00:00:00	1996-08-04	38000177		0	0	14		0	0	0	16403	0	313782	1127433		
36952	3056	1127078	1958-01-22	1958-01-22 00:00:00	1958-02-05	1958-02-05 00:00:00	1958-02-05	38000177		0	0	14		0	0	0	203264	0	282464	1127078		
19531	1608	1713671	1988-05-26	1988-05-26 00:00:00	1988-07-21	1988-07-21 00:00:00	1988-07-21	38000177		0	0	56		0	0	0	107970	0	562251	1713671		
116551	2561	40213306	1999-12-01	1999-12-01 00:00:00	1999-12-01	1999-12-01 00:00:00	1999-12-01	581452		0	0	0		0	0	0	169685	0	43	40213306		
16454	1365	19059056	1967-05-03	1967-05-03 00:00:00	1967-07-02	1967-07-02 00:00:00	1967-07-02	38000177		0	0	60		0	0	0	90454	0	243670	19059056		
147551	3244	40213296	2015-04-29	2015-04-29 00:00:00	2015-04-29	2015-04-29 00:00:00	2015-04-29	581452		0	0	0		0	0	0	215743	0	52	40213296		
43467	3603	1713671	1997-03-10	1997-03-10 00:00:00	1997-03-24	1997-03-24 00:00:00	1997-03-24	38000177		0	0	14		0	0	0	239367	0	562251	1713671		
217527	4773	40213296	2001-01-04	2001-01-04 00:00:00	2001-01-04	2001-01-04 00:00:00	2001-01-04	581452		0	0	0		0	0	0	317911	0	52	40213296		
54004	4487	1332419	2004-10-22	2004-10-22 00:00:00	2004-10-22	2004-10-22 00:00:00	\N	38000177		0	0	0		0	0	0	298775	0	197361	1332419		
2406	191	19075001	2000-06-04	2000-06-04 00:00:00	2000-06-25	2000-06-25 00:00:00	2000-06-25	38000177		0	0	21		0	0	0	13044	0	309097	19075001		
88136	1934	40213160	1960-07-09	1960-07-09 00:00:00	1960-07-09	1960-07-09 00:00:00	1960-07-09	581452		0	0	0		0	0	0	128628	0	10	40213160		
59222	4923	40220960	2018-06-19	2018-06-19 00:00:00	2018-06-19	2018-06-19 00:00:00	2018-06-19	38000177		0	0	0		0	0	0	327147	0	1804799	40220960		
39625	3277	1713671	2015-12-28	2015-12-28 00:00:00	2016-01-11	2016-01-11 00:00:00	2016-01-11	38000177		0	0	14		0	0	0	217688	0	562251	1713671		
164073	3609	40213227	2006-04-07	2006-04-07 00:00:00	2006-04-07	2006-04-07 00:00:00	2006-04-07	581452		0	0	0		0	0	0	239796	0	113	40213227		
60307	5015	1713671	2017-12-23	2017-12-23 00:00:00	2017-12-30	2017-12-30 00:00:00	2017-12-30	38000177		0	0	7		0	0	0	333362	0	562251	1713671		
71439	1563	40213160	1961-06-03	1961-06-03 00:00:00	1961-06-03	1961-06-03 00:00:00	1961-06-03	581452		0	0	0		0	0	0	104647	0	10	40213160		
45578	3773	19059056	1963-02-05	1963-02-05 00:00:00	1963-02-26	1963-02-26 00:00:00	1963-02-26	38000177		0	0	21		0	0	0	250812	0	243670	19059056		
222170	4876	40213160	1972-08-26	1972-08-26 00:00:00	1972-08-26	1972-08-26 00:00:00	1972-08-26	581452		0	0	0		0	0	0	324290	0	10	40213160		
51876	4312	1124300	1995-07-29	1995-07-29 00:00:00	1995-07-29	1995-07-29 00:00:00	\N	38000177		0	0	0		0	0	0	286054	0	00781178901	45011828		
25991	2138	19133873	1958-07-24	1958-07-24 00:00:00	1958-08-03	1958-08-03 00:00:00	1958-08-03	38000177		0	0	10		0	0	0	142373	0	834061	19133873		
62421	5195	40229134	2001-02-08	2001-02-08 00:00:00	2001-02-22	2001-02-22 00:00:00	2001-02-22	38000177		0	0	14		0	0	0	345466	0	1043400	40229134		
223459	4905	40213227	2014-09-11	2014-09-11 00:00:00	2014-09-11	2014-09-11 00:00:00	2014-09-11	581452		0	0	0		0	0	0	326081	0	113	40213227		
62530	5200	19078461	2005-07-31	2005-07-31 00:00:00	2005-08-14	2005-08-14 00:00:00	2005-08-14	38000177		0	0	14		0	0	0	345912	0	310965	19078461		
39404	3254	1124300	2005-02-08	2005-02-08 00:00:00	2005-02-08	2005-02-08 00:00:00	\N	38000177		0	0	0		0	0	0	216457	0	00781178901	45011828		
80389	1759	40213314	1985-06-10	1985-06-10 00:00:00	1985-06-10	1985-06-10 00:00:00	1985-06-10	581452		0	0	0		0	0	0	117604	0	49	40213314		
1329	103	1127433	1990-08-16	1990-08-16 00:00:00	1990-08-30	1990-08-30 00:00:00	1990-08-30	38000177		0	0	14		0	0	0	7069	0	313782	1127433		
29559	2445	19059056	1965-12-24	1965-12-24 00:00:00	1966-01-14	1966-01-14 00:00:00	1966-01-14	38000177		0	0	21		0	0	0	162231	0	243670	19059056		
35287	2909	920300	1963-03-30	1963-03-30 00:00:00	1963-04-06	1963-04-06 00:00:00	1963-04-06	38000177		0	0	7		0	0	0	193894	0	311989	920300		
66937	1464	40213296	2003-04-23	2003-04-23 00:00:00	2003-04-23	2003-04-23 00:00:00	2003-04-23	581452		0	0	0		0	0	0	97519	0	52	40213296		
178169	3916	40213314	1979-03-14	1979-03-14 00:00:00	1979-03-14	1979-03-14 00:00:00	1979-03-14	581452		0	0	0		0	0	0	260317	0	49	40213314		
29710	2461	1127433	2010-04-04	2010-04-04 00:00:00	2010-04-11	2010-04-11 00:00:00	2010-04-11	38000177		0	0	7		0	0	0	163148	0	313782	1127433		
12125	1017	19059056	1962-12-21	1962-12-21 00:00:00	1963-01-11	1963-01-11 00:00:00	1963-01-11	38000177		0	0	21		0	0	0	67001	0	243670	19059056		
211688	4641	40213160	1967-10-19	1967-10-19 00:00:00	1967-10-19	1967-10-19 00:00:00	1967-10-19	581452		0	0	0		0	0	0	309300	0	10	40213160		
38564	3184	19059056	1963-03-22	1963-03-22 00:00:00	1963-04-05	1963-04-05 00:00:00	1963-04-05	38000177		0	0	14		0	0	0	211960	0	243670	19059056		
20793	452	40213160	1962-12-14	1962-12-14 00:00:00	1962-12-14	1962-12-14 00:00:00	1962-12-14	581452		0	0	0		0	0	0	30129	0	10	40213160		
156957	3454	40213227	2014-09-01	2014-09-01 00:00:00	2014-09-01	2014-09-01 00:00:00	2014-09-01	581452		0	0	0		0	0	0	\N	0	113	40213227		
5248	440	1127433	1994-03-07	1994-03-07 00:00:00	1994-03-21	1994-03-21 00:00:00	1994-03-21	38000177		0	0	14		0	0	0	29204	0	313782	1127433		
128833	2833	40213227	2007-02-12	2007-02-12 00:00:00	2007-02-12	2007-02-12 00:00:00	2007-02-12	581452		0	0	0		0	0	0	188046	0	113	40213227		
33620	2782	836659	1996-04-24	1996-04-24 00:00:00	1996-04-24	1996-04-24 00:00:00	\N	38000177		0	0	0		0	0	0	184378	0	313185	836659		
17500	1447	1127433	1974-03-05	1974-03-05 00:00:00	1974-03-19	1974-03-19 00:00:00	1974-03-19	38000177		0	0	14		0	0	0	96487	0	313782	1127433		
15959	1323	40229134	1984-03-08	1984-03-08 00:00:00	1984-03-15	1984-03-15 00:00:00	1984-03-15	38000177		0	0	7		0	0	0	87876	0	1043400	40229134		
789	63	1127433	1990-09-14	1990-09-14 00:00:00	1990-09-21	1990-09-21 00:00:00	1990-09-21	38000177		0	0	7		0	0	0	4244	0	313782	1127433		
10993	917	46233710	1977-07-31	1977-07-31 00:00:00	1977-09-04	1977-09-04 00:00:00	1977-09-04	38000177		0	0	35		0	0	0	60913	0	1650142	46233710		
16071	1333	19059056	1976-12-06	1976-12-06 00:00:00	1977-01-10	1977-01-10 00:00:00	1977-01-10	38000177		0	0	35		0	0	0	88414	0	243670	19059056		
8505	709	19133905	1995-06-19	1995-06-19 00:00:00	1995-07-02	1995-07-02 00:00:00	1995-07-02	38000177		0	0	13		0	0	0	46933	0	834102	19133905		
29965	2482	46233988	1974-12-11	1974-12-11 00:00:00	1974-12-25	1974-12-25 00:00:00	1974-12-25	38000177		0	0	14		0	0	0	164429	0	1652673	46233988		
22423	1844	19133873	1976-11-29	1976-11-29 00:00:00	1976-12-08	1976-12-08 00:00:00	1976-12-08	38000177		0	0	9		0	0	0	123134	0	834061	19133873		
54695	4544	19059056	1944-09-18	1944-09-18 00:00:00	1944-10-02	1944-10-02 00:00:00	1944-10-02	38000177		0	0	14		0	0	0	302675	0	243670	19059056		
40568	3363	1127433	1972-06-10	1972-06-10 00:00:00	1972-06-17	1972-06-17 00:00:00	1972-06-17	38000177		0	0	7		0	0	0	222987	0	313782	1127433		
32543	2698	19019979	1989-08-02	1989-08-02 00:00:00	1989-08-16	1989-08-16 00:00:00	1989-08-16	38000177		0	0	14		0	0	0	178693	0	198405	19019979		
81852	1788	40213227	2012-10-25	2012-10-25 00:00:00	2012-10-25	2012-10-25 00:00:00	2012-10-25	581452		0	0	0		0	0	0	119802	0	113	40213227		
5795	484	40162522	1997-03-15	1997-03-15 00:00:00	1997-03-15	1997-03-15 00:00:00	\N	38000177		0	0	0		0	0	0	32401	0	857005	40162522		
24213	526	40213160	1971-08-04	1971-08-04 00:00:00	1971-08-04	1971-08-04 00:00:00	1971-08-04	581452		0	0	0		0	0	0	35078	0	10	40213160		
42899	3556	1118084	2013-10-01	2013-10-01 00:00:00	2013-10-01	2013-10-01 00:00:00	\N	38000177		0	0	0		0	0	0	236116	0	00025152531	44923712		
47952	3976	40229134	1996-03-13	1996-03-13 00:00:00	1996-03-27	1996-03-27 00:00:00	1996-03-27	38000177		0	0	14		0	0	0	264328	0	1043400	40229134		
34117	2821	19059056	1962-01-04	1962-01-04 00:00:00	1962-01-18	1962-01-18 00:00:00	1962-01-18	38000177		0	0	14		0	0	0	186851	0	243670	19059056		
4368	363	19133873	1974-06-19	1974-06-19 00:00:00	1974-07-02	1974-07-02 00:00:00	1974-07-02	38000177		0	0	13		0	0	0	24096	0	834061	19133873		
53548	4451	1127433	1999-03-29	1999-03-29 00:00:00	1999-04-05	1999-04-05 00:00:00	1999-04-05	38000177		0	0	7		0	0	0	296166	0	313782	1127433		
153462	3378	40213296	1998-12-19	1998-12-19 00:00:00	1998-12-19	1998-12-19 00:00:00	1998-12-19	581452		0	0	0		0	0	0	224158	0	52	40213296		
53908	4480	19133905	1995-10-07	1995-10-07 00:00:00	1995-10-18	1995-10-18 00:00:00	1995-10-18	38000177		0	0	11		0	0	0	298137	0	834102	19133905		
9961	836	43012754	1999-07-25	1999-07-25 00:00:00	2000-07-19	2000-07-19 00:00:00	2000-07-19	38000177		0	0	360		0	0	0	55283	0	1366343	43012754		
6211	520	920300	1974-12-10	1974-12-10 00:00:00	1974-12-17	1974-12-17 00:00:00	1974-12-17	38000177		0	0	7		0	0	0	34696	0	311989	920300		
125819	2768	40213306	1991-09-10	1991-09-10 00:00:00	1991-09-10	1991-09-10 00:00:00	1991-09-10	581452		0	0	0		0	0	0	183132	0	43	40213306		
8958	747	19133905	2005-07-07	2005-07-07 00:00:00	2005-07-19	2005-07-19 00:00:00	2005-07-19	38000177		0	0	12		0	0	0	49490	0	834102	19133905		
3007	245	1127433	1984-02-25	1984-02-25 00:00:00	1984-04-25	1984-04-25 00:00:00	1984-04-25	38000177		0	0	60		0	0	0	16402	0	313782	1127433		
36953	3056	19006318	1958-01-22	1958-01-22 00:00:00	1958-02-05	1958-02-05 00:00:00	1958-02-05	38000177		0	0	14		0	0	0	203264	0	105078	19006318		
19532	1608	1127433	1990-09-17	1990-09-17 00:00:00	1990-09-24	1990-09-24 00:00:00	1990-09-24	38000177		0	0	7		0	0	0	108002	0	313782	1127433		
116553	2561	40213251	1984-10-24	1984-10-24 00:00:00	1984-10-24	1984-10-24 00:00:00	1984-10-24	581452		0	0	0		0	0	0	169697	0	21	40213251		
16455	1365	920300	1993-09-14	1993-09-14 00:00:00	1993-09-21	1993-09-21 00:00:00	1993-09-21	38000177		0	0	7		0	0	0	90482	0	311989	920300		
147555	3244	40213160	1973-07-25	1973-07-25 00:00:00	1973-07-25	1973-07-25 00:00:00	1973-07-25	581452		0	0	0		0	0	0	215725	0	10	40213160		
43468	3603	1127433	2001-06-02	2001-06-02 00:00:00	2001-06-16	2001-06-16 00:00:00	2001-06-16	38000177		0	0	14		0	0	0	239321	0	313782	1127433		
217531	4773	40213160	1959-06-04	1959-06-04 00:00:00	1959-06-04	1959-06-04 00:00:00	1959-06-04	581452		0	0	0		0	0	0	317874	0	10	40213160		
54005	4487	1539411	2004-10-22	2004-10-22 00:00:00	2004-10-22	2004-10-22 00:00:00	\N	38000177		0	0	0		0	0	0	298775	0	312961	1539411		
2407	191	1127433	1991-07-25	1991-07-25 00:00:00	1991-08-01	1991-08-01 00:00:00	1991-08-01	38000177		0	0	7		0	0	0	13100	0	313782	1127433		
88140	1934	40213227	2011-02-05	2011-02-05 00:00:00	2011-02-05	2011-02-05 00:00:00	2011-02-05	581452		0	0	0		0	0	0	128643	0	113	40213227		
59223	4923	19075601	2018-06-19	2018-06-19 00:00:00	2018-06-19	2018-06-19 00:00:00	2018-06-19	38000177		0	0	0		0	0	0	327147	0	309362	19075601		
39626	3277	1124300	2004-09-12	2004-09-12 00:00:00	2004-09-12	2004-09-12 00:00:00	\N	38000177		0	0	0		0	0	0	217707	0	00781178901	45011828		
144299	3172	40213160	1977-07-28	1977-07-28 00:00:00	1977-07-28	1977-07-28 00:00:00	1977-07-28	581452		0	0	0		0	0	0	210844	0	10	40213160		
60308	5015	19075001	1983-05-10	1983-05-10 00:00:00	1983-05-24	1983-05-24 00:00:00	1983-05-24	38000177		0	0	14		0	0	0	333346	0	309097	19075001		
38635	843	40213160	1983-01-08	1983-01-08 00:00:00	1983-01-08	1983-01-08 00:00:00	1983-01-08	581452		0	0	0		0	0	0	55856	0	10	40213160		
45579	3773	1713671	1969-12-07	1969-12-07 00:00:00	1969-12-21	1969-12-21 00:00:00	1969-12-21	38000177		0	0	14		0	0	0	250805	0	562251	1713671		
222172	4876	40213296	2012-06-30	2012-06-30 00:00:00	2012-06-30	2012-06-30 00:00:00	2012-06-30	581452		0	0	0		0	0	0	324281	0	52	40213296		
51877	4312	1127433	2019-05-16	2019-05-16 00:00:00	2019-05-30	2019-05-30 00:00:00	2019-05-30	38000177		0	0	14		0	0	0	286126	0	313782	1127433		
25992	2138	1127433	1992-10-30	1992-10-30 00:00:00	1992-11-06	1992-11-06 00:00:00	1992-11-06	38000177		0	0	7		0	0	0	142388	0	313782	1127433		
62422	5195	1127078	1968-12-22	1968-12-22 00:00:00	1969-01-12	1969-01-12 00:00:00	1969-01-12	38000177		0	0	21		0	0	0	345409	0	282464	1127078		
223464	4905	40213160	1977-08-11	1977-08-11 00:00:00	1977-08-11	1977-08-11 00:00:00	1977-08-11	581452		0	0	0		0	0	0	326076	0	10	40213160		
20129	1655	1127433	1989-08-28	1989-08-28 00:00:00	1989-09-11	1989-09-11 00:00:00	1989-09-11	38000177		0	0	14		0	0	0	110992	0	313782	1127433		
39405	3254	19019979	1974-09-04	1974-09-04 00:00:00	1974-09-18	1974-09-18 00:00:00	1974-09-18	38000177		0	0	14		0	0	0	216451	0	198405	19019979		
80390	1759	40213160	1985-06-10	1985-06-10 00:00:00	1985-06-10	1985-06-10 00:00:00	1985-06-10	581452		0	0	0		0	0	0	117604	0	10	40213160		
1330	103	40236824	2000-06-14	2000-06-14 00:00:00	2000-06-21	2000-06-21 00:00:00	2000-06-21	38000177		0	0	7		0	0	0	7025	0	1094107	40236824		
1335	105	1118084	2003-07-17	2003-07-17 00:00:00	2003-07-17	2003-07-17 00:00:00	\N	38000177		0	0	0		0	0	0	7110	0	00025152531	44923712		
35288	2909	40236824	1963-03-30	1963-03-30 00:00:00	1963-04-06	1963-04-06 00:00:00	1963-04-06	38000177		0	0	7		0	0	0	193894	0	1094107	40236824		
66943	1464	40213306	1982-10-13	1982-10-13 00:00:00	1982-10-13	1982-10-13 00:00:00	1982-10-13	581452		0	0	0		0	0	0	97579	0	43	40213306		
178170	3916	40213160	1979-03-14	1979-03-14 00:00:00	1979-03-14	1979-03-14 00:00:00	1979-03-14	581452		0	0	0		0	0	0	260317	0	10	40213160		
29711	2461	1118084	2003-03-07	2003-03-07 00:00:00	2003-03-07	2003-03-07 00:00:00	\N	38000177		0	0	0		0	0	0	163147	0	00025152531	44923712		
12126	1017	1127433	2007-02-09	2007-02-09 00:00:00	2007-02-16	2007-02-16 00:00:00	2007-02-16	38000177		0	0	7		0	0	0	66931	0	313782	1127433		
211689	4641	40213260	2017-07-13	2017-07-13 00:00:00	2017-07-13	2017-07-13 00:00:00	2017-07-13	581452		0	0	0		0	0	0	309346	0	121	40213260		
38565	3184	19006318	1963-03-22	1963-03-22 00:00:00	1963-04-05	1963-04-05 00:00:00	1963-04-05	38000177		0	0	14		0	0	0	211960	0	105078	19006318		
20795	452	40213160	1963-02-15	1963-02-15 00:00:00	1963-02-15	1963-02-15 00:00:00	1963-02-15	581452		0	0	0		0	0	0	30081	0	10	40213160		
156963	3454	40213314	1983-06-13	1983-06-13 00:00:00	1983-06-13	1983-06-13 00:00:00	1983-06-13	581452		0	0	0		0	0	0	229181	0	49	40213314		
5249	440	19128022	1990-11-19	1990-11-19 00:00:00	1991-11-14	1991-11-14 00:00:00	1991-11-14	38000177		0	0	360		0	0	0	29173	0	749785	19128022		
128837	2833	40213227	1996-12-16	1996-12-16 00:00:00	1996-12-16	1996-12-16 00:00:00	1996-12-16	581452		0	0	0		0	0	0	188106	0	113	40213227		
33621	2782	19059056	1955-05-03	1955-05-03 00:00:00	1955-07-09	1955-07-09 00:00:00	1955-07-09	38000177		0	0	67		0	0	0	184405	0	243670	19059056		
17501	1447	19129655	1974-03-05	1974-03-05 00:00:00	1974-03-19	1974-03-19 00:00:00	1974-03-19	38000177		0	0	14		0	0	0	96487	0	789980	19129655		
15960	1323	1124300	2005-02-09	2005-02-09 00:00:00	2005-02-09	2005-02-09 00:00:00	\N	38000177		0	0	0		0	0	0	87859	0	00781178901	45011828		
790	63	1118084	1992-07-28	1992-07-28 00:00:00	1992-07-28	1992-07-28 00:00:00	\N	38000177		0	0	0		0	0	0	4244	0	00025152531	44923712		
10994	917	1127433	1977-07-31	1977-07-31 00:00:00	1977-09-04	1977-09-04 00:00:00	1977-09-04	38000177		0	0	35		0	0	0	60913	0	313782	1127433		
16072	1333	40162522	2002-05-25	2002-05-25 00:00:00	2002-05-25	2002-05-25 00:00:00	\N	38000177		0	0	0		0	0	0	88486	0	857005	40162522		
8506	709	1127433	1961-03-12	1961-03-12 00:00:00	1961-03-26	1961-03-26 00:00:00	1961-03-26	38000177		0	0	14		0	0	0	46954	0	313782	1127433		
29967	2483	19059056	1945-12-24	1945-12-24 00:00:00	1946-01-07	1946-01-07 00:00:00	1946-01-07	38000177		0	0	14		0	0	0	164510	0	243670	19059056		
22425	1844	19078461	1986-07-28	1986-07-28 00:00:00	1986-08-11	1986-08-11 00:00:00	1986-08-11	38000177		0	0	14		0	0	0	123182	0	310965	19078461		
54696	4544	1539411	1991-11-05	1991-11-05 00:00:00	1991-11-05	1991-11-05 00:00:00	\N	38000177		0	0	0		0	0	0	302667	0	312961	1539411		
40569	3363	19059056	1969-02-21	1969-02-21 00:00:00	1969-03-14	1969-03-14 00:00:00	1969-03-14	38000177		0	0	21		0	0	0	222953	0	243670	19059056		
32544	2698	1127433	2001-01-15	2001-01-15 00:00:00	2001-01-29	2001-01-29 00:00:00	2001-01-29	38000177		0	0	14		0	0	0	178694	0	313782	1127433		
36151	2980	19006318	1975-02-22	1975-02-22 00:00:00	1975-03-08	1975-03-08 00:00:00	1975-03-08	38000177		0	0	14		0	0	0	198896	0	105078	19006318		
5796	484	19078461	1997-03-15	1997-03-15 00:00:00	1997-05-14	1997-05-14 00:00:00	1997-05-14	38000177		0	0	60		0	0	0	32401	0	310965	19078461		
24216	526	40213306	1993-12-01	1993-12-01 00:00:00	1993-12-01	1993-12-01 00:00:00	1993-12-01	581452		0	0	0		0	0	0	35063	0	43	40213306		
42900	3556	1115171	1994-01-24	1994-01-24 00:00:00	1994-04-24	1994-04-24 00:00:00	1994-04-24	38000177		0	0	90		0	0	0	236128	0	849574	1115171		
47953	3976	1115171	2017-11-10	2017-11-10 00:00:00	2018-01-09	2018-01-09 00:00:00	2018-01-09	38000177		0	0	60		0	0	0	264353	0	849574	1115171		
34118	2821	1127433	2003-11-13	2003-11-13 00:00:00	2003-11-20	2003-11-20 00:00:00	2003-11-20	38000177		0	0	7		0	0	0	186933	0	313782	1127433		
26935	2220	40229134	1973-10-06	1973-10-06 00:00:00	1973-10-13	1973-10-13 00:00:00	1973-10-13	38000177		0	0	7		0	0	0	147853	0	1043400	40229134		
87009	1908	40213160	1970-09-13	1970-09-13 00:00:00	1970-09-13	1970-09-13 00:00:00	1970-09-13	581452		0	0	0		0	0	0	127002	0	10	40213160		
153465	3378	40213296	1997-07-26	1997-07-26 00:00:00	1997-07-26	1997-07-26 00:00:00	1997-07-26	581452		0	0	0		0	0	0	224157	0	52	40213296		
53909	4480	19128065	1981-12-25	1981-12-25 00:00:00	1982-12-20	1982-12-20 00:00:00	1982-12-20	38000177		0	0	360		0	0	0	298147	0	749882	19128065		
9962	836	40229134	2001-01-29	2001-01-29 00:00:00	2001-02-05	2001-02-05 00:00:00	2001-02-05	38000177		0	0	7		0	0	0	55310	0	1043400	40229134		
6212	520	19059056	1972-03-05	1972-03-05 00:00:00	1972-03-19	1972-03-19 00:00:00	1972-03-19	38000177		0	0	14		0	0	0	34743	0	243670	19059056		
86531	1898	40213227	2002-12-09	2002-12-09 00:00:00	2002-12-09	2002-12-09 00:00:00	2002-12-09	581452		0	0	0		0	0	0	126369	0	113	40213227		
8959	747	1115171	2003-07-14	2003-07-14 00:00:00	2003-08-04	2003-08-04 00:00:00	2003-08-04	38000177		0	0	21		0	0	0	49477	0	849574	1115171		
3008	245	19059056	1968-06-13	1968-06-13 00:00:00	1968-07-18	1968-07-18 00:00:00	1968-07-18	38000177		0	0	35		0	0	0	16443	0	243670	19059056		
36954	3057	40173590	1997-03-03	1997-03-03 00:00:00	1997-03-03	1997-03-03 00:00:00	\N	38000177		0	0	0		0	0	0	203418	0	904419	40173590		
19533	1608	1124300	1977-06-25	1977-06-25 00:00:00	1977-06-25	1977-06-25 00:00:00	\N	38000177		0	0	0		0	0	0	107990	0	00781178901	45011828		
116556	2561	40213160	1981-10-07	1981-10-07 00:00:00	1981-10-07	1981-10-07 00:00:00	1981-10-07	581452		0	0	0		0	0	0	169713	0	10	40213160		
16456	1365	40236824	1993-09-14	1993-09-14 00:00:00	1993-09-28	1993-09-28 00:00:00	1993-09-28	38000177		0	0	14		0	0	0	90482	0	1094107	40236824		
147557	3244	40213296	2013-04-24	2013-04-24 00:00:00	2013-04-24	2013-04-24 00:00:00	2013-04-24	581452		0	0	0		0	0	0	215715	0	52	40213296		
43469	3604	1127433	1993-02-17	1993-02-17 00:00:00	1993-03-03	1993-03-03 00:00:00	1993-03-03	38000177		0	0	14		0	0	0	239475	0	313782	1127433		
217534	4773	40213160	1963-10-10	1963-10-10 00:00:00	1963-10-10	1963-10-10 00:00:00	1963-10-10	581452		0	0	0		0	0	0	317861	0	10	40213160		
54006	4487	19126352	2004-10-22	2004-10-22 00:00:00	2010-02-12	2010-02-12 00:00:00	2010-02-12	38000177		0	0	1939		0	0	0	298775	0	705129	19126352		
2408	192	19075601	2014-07-02	2014-07-02 00:00:00	2014-07-02	2014-07-02 00:00:00	2014-07-02	38000177		0	0	0		0	0	0	13209	0	309362	19075601		
88141	1934	40213260	2011-02-05	2011-02-05 00:00:00	2011-02-05	2011-02-05 00:00:00	2011-02-05	581452		0	0	0		0	0	0	128643	0	121	40213260		
59224	4923	1713671	1984-12-18	1984-12-18 00:00:00	1985-01-01	1985-01-01 00:00:00	1985-01-01	38000177		0	0	14		0	0	0	327144	0	562251	1713671		
39627	3277	40229134	1971-07-24	1971-07-24 00:00:00	1971-08-07	1971-08-07 00:00:00	1971-08-07	38000177		0	0	14		0	0	0	217696	0	1043400	40229134		
144302	3172	40213227	2008-11-13	2008-11-13 00:00:00	2008-11-13	2008-11-13 00:00:00	2008-11-13	581452		0	0	0		0	0	0	210884	0	113	40213227		
60309	5015	1127433	1983-05-10	1983-05-10 00:00:00	1983-05-24	1983-05-24 00:00:00	1983-05-24	38000177		0	0	14		0	0	0	333346	0	313782	1127433		
38642	843	40213160	1987-04-11	1987-04-11 00:00:00	1987-04-11	1987-04-11 00:00:00	1987-04-11	581452		0	0	0		0	0	0	55801	0	10	40213160		
45580	3773	1127433	1981-08-22	1981-08-22 00:00:00	1981-09-05	1981-09-05 00:00:00	1981-09-05	38000177		0	0	14		0	0	0	250809	0	313782	1127433		
222174	4876	40213160	1973-01-27	1973-01-27 00:00:00	1973-01-27	1973-01-27 00:00:00	1973-01-27	581452		0	0	0		0	0	0	324291	0	10	40213160		
51878	4312	19008572	1973-03-26	1973-03-26 00:00:00	1973-04-09	1973-04-09 00:00:00	1973-04-09	38000177		0	0	14		0	0	0	286208	0	106258	19008572		
25993	2138	40229134	1994-09-16	1994-09-16 00:00:00	1994-09-23	1994-09-23 00:00:00	1994-09-23	38000177		0	0	7		0	0	0	142377	0	1043400	40229134		
62423	5195	19006318	1964-07-25	1964-07-25 00:00:00	1964-08-08	1964-08-08 00:00:00	1964-08-08	38000177		0	0	14		0	0	0	345436	0	105078	19006318		
223465	4905	40213314	1977-08-11	1977-08-11 00:00:00	1977-08-11	1977-08-11 00:00:00	1977-08-11	581452		0	0	0		0	0	0	326076	0	49	40213314		
20130	1655	19133873	1981-08-03	1981-08-03 00:00:00	1981-08-14	1981-08-14 00:00:00	1981-08-14	38000177		0	0	11		0	0	0	111006	0	834061	19133873		
39406	3254	1127078	1963-12-31	1963-12-31 00:00:00	1964-01-14	1964-01-14 00:00:00	1964-01-14	38000177		0	0	14		0	0	0	216434	0	282464	1127078		
80393	1759	40213314	1986-03-10	1986-03-10 00:00:00	1986-03-10	1986-03-10 00:00:00	1986-03-10	581452		0	0	0		0	0	0	117628	0	49	40213314		
1331	103	920300	2000-06-14	2000-06-14 00:00:00	2000-06-21	2000-06-21 00:00:00	2000-06-21	38000177		0	0	7		0	0	0	7025	0	311989	920300		
1336	105	1127433	1985-10-08	1985-10-08 00:00:00	1985-10-22	1985-10-22 00:00:00	1985-10-22	38000177		0	0	14		0	0	0	7146	0	313782	1127433		
35289	2909	40229134	1972-03-13	1972-03-13 00:00:00	1972-03-20	1972-03-20 00:00:00	1972-03-20	38000177		0	0	7		0	0	0	193844	0	1043400	40229134		
217387	4771	40213296	1996-06-22	1996-06-22 00:00:00	1996-06-22	1996-06-22 00:00:00	1996-06-22	581452		0	0	0		0	0	0	317740	0	52	40213296		
178172	3917	40213306	1989-11-09	1989-11-09 00:00:00	1989-11-09	1989-11-09 00:00:00	1989-11-09	581452		0	0	0		0	0	0	260485	0	43	40213306		
29712	2461	1127433	2006-01-19	2006-01-19 00:00:00	2006-02-18	2006-02-18 00:00:00	2006-02-18	38000177		0	0	30		0	0	0	163199	0	313782	1127433		
12127	1017	1124300	1997-08-24	1997-08-24 00:00:00	1997-08-24	1997-08-24 00:00:00	\N	38000177		0	0	0		0	0	0	67007	0	00781178901	45011828		
211692	4641	40213160	1972-06-22	1972-06-22 00:00:00	1972-06-22	1972-06-22 00:00:00	1972-06-22	581452		0	0	0		0	0	0	309341	0	10	40213160		
38566	3184	1127078	1966-05-24	1966-05-24 00:00:00	1966-06-07	1966-06-07 00:00:00	1966-06-07	38000177		0	0	14		0	0	0	212002	0	282464	1127078		
20801	452	40213296	2004-09-17	2004-09-17 00:00:00	2004-09-17	2004-09-17 00:00:00	2004-09-17	581452		0	0	0		0	0	0	30092	0	52	40213296		
156964	3454	40213160	1983-06-13	1983-06-13 00:00:00	1983-06-13	1983-06-13 00:00:00	1983-06-13	581452		0	0	0		0	0	0	229181	0	10	40213160		
5250	440	19133905	1997-03-23	1997-03-23 00:00:00	1997-04-01	1997-04-01 00:00:00	1997-04-01	38000177		0	0	9		0	0	0	29198	0	834102	19133905		
68745	1505	40213260	2007-02-03	2007-02-03 00:00:00	2007-02-03	2007-02-03 00:00:00	2007-02-03	581452		0	0	0		0	0	0	100330	0	121	40213260		
33622	2782	19059056	1945-07-03	1945-07-03 00:00:00	1945-07-24	1945-07-24 00:00:00	1945-07-24	38000177		0	0	21		0	0	0	184404	0	243670	19059056		
17502	1448	19128065	1987-03-25	1987-03-25 00:00:00	1988-03-19	1988-03-19 00:00:00	1988-03-19	38000177		0	0	360		0	0	0	96573	0	749882	19128065		
58603	4867	1118084	1950-01-14	1950-01-14 00:00:00	1950-01-14	1950-01-14 00:00:00	\N	38000177		0	0	0		0	0	0	323679	0	00025152531	44923712		
791	64	19078461	2000-08-07	2000-08-07 00:00:00	2000-08-21	2000-08-21 00:00:00	2000-08-21	38000177		0	0	14		0	0	0	4329	0	310965	19078461		
10995	917	40229134	1996-11-18	1996-11-18 00:00:00	1996-12-02	1996-12-02 00:00:00	1996-12-02	38000177		0	0	14		0	0	0	60928	0	1043400	40229134		
16073	1333	1713671	1955-10-04	1955-10-04 00:00:00	1955-10-25	1955-10-25 00:00:00	1955-10-25	38000177		0	0	21		0	0	0	88439	0	562251	1713671		
8507	709	1713671	1986-04-24	1986-04-24 00:00:00	1986-05-08	1986-05-08 00:00:00	1986-05-08	38000177		0	0	14		0	0	0	46966	0	562251	1713671		
29968	2483	1127433	1946-07-24	1946-07-24 00:00:00	1946-07-31	1946-07-31 00:00:00	1946-07-31	38000177		0	0	7		0	0	0	164482	0	313782	1127433		
22426	1844	19133905	2009-04-21	2009-04-21 00:00:00	2009-04-29	2009-04-29 00:00:00	2009-04-29	38000177		0	0	8		0	0	0	123204	0	834102	19133905		
54697	4544	40229134	1955-09-17	1955-09-17 00:00:00	1955-09-24	1955-09-24 00:00:00	1955-09-24	38000177		0	0	7		0	0	0	302709	0	1043400	40229134		
40570	3363	19059056	1964-05-27	1964-05-27 00:00:00	1964-06-17	1964-06-17 00:00:00	1964-06-17	38000177		0	0	21		0	0	0	222951	0	243670	19059056		
32545	2699	40229134	2018-06-03	2018-06-03 00:00:00	2018-06-17	2018-06-17 00:00:00	2018-06-17	38000177		0	0	14		0	0	0	178756	0	1043400	40229134		
36152	2980	19059056	1975-02-22	1975-02-22 00:00:00	1975-03-08	1975-03-08 00:00:00	1975-03-08	38000177		0	0	14		0	0	0	198896	0	243670	19059056		
5797	484	19133873	1940-01-27	1940-01-27 00:00:00	1940-02-08	1940-02-08 00:00:00	1940-02-08	38000177		0	0	12		0	0	0	32305	0	834061	19133873		
24218	526	40213227	1993-12-01	1993-12-01 00:00:00	1993-12-01	1993-12-01 00:00:00	1993-12-01	581452		0	0	0		0	0	0	35063	0	113	40213227		
42901	3556	19073183	1987-09-28	1987-09-28 00:00:00	1987-10-12	1987-10-12 00:00:00	1987-10-12	38000177		0	0	14		0	0	0	236144	0	308182	19073183		
47954	3976	40229134	1985-10-29	1985-10-29 00:00:00	1985-11-05	1985-11-05 00:00:00	1985-11-05	38000177		0	0	7		0	0	0	264387	0	1043400	40229134		
34119	2821	19078461	2000-06-11	2000-06-11 00:00:00	2000-07-02	2000-07-02 00:00:00	2000-07-02	38000177		0	0	21		0	0	0	186855	0	310965	19078461		
26936	2220	19059056	1949-07-07	1949-07-07 00:00:00	1949-07-28	1949-07-28 00:00:00	1949-07-28	38000177		0	0	21		0	0	0	147791	0	243670	19059056		
87012	1908	40213160	1975-05-18	1975-05-18 00:00:00	1975-05-18	1975-05-18 00:00:00	1975-05-18	581452		0	0	0		0	0	0	126963	0	10	40213160		
153468	3378	40213160	1957-10-26	1957-10-26 00:00:00	1957-10-26	1957-10-26 00:00:00	1957-10-26	581452		0	0	0		0	0	0	224169	0	10	40213160		
53911	4480	1127433	1993-12-14	1993-12-14 00:00:00	1994-03-14	1994-03-14 00:00:00	1994-03-14	38000177		0	0	90		0	0	0	298188	0	313782	1127433		
9963	836	42902245	2002-07-09	2002-07-09 00:00:00	2003-07-04	2003-07-04 00:00:00	2003-07-04	38000177		0	0	360		0	0	0	55285	0	1359133	42902245		
98458	2155	40213201	1993-07-21	1993-07-21 00:00:00	1993-07-21	1993-07-21 00:00:00	1993-07-21	581452		0	0	0		0	0	0	143615	0	33	40213201		
15057	1258	19128065	1983-02-27	1983-02-27 00:00:00	1984-02-22	1984-02-22 00:00:00	1984-02-22	38000177		0	0	360		0	0	0	82892	0	749882	19128065		
8960	747	1127433	1994-06-11	1994-06-11 00:00:00	1994-06-18	1994-06-18 00:00:00	1994-06-18	38000177		0	0	7		0	0	0	49471	0	313782	1127433		
3009	245	19059056	1942-04-03	1942-04-03 00:00:00	1942-05-01	1942-05-01 00:00:00	1942-05-01	38000177		0	0	28		0	0	0	16442	0	243670	19059056		
36955	3057	1127433	1941-04-15	1941-04-15 00:00:00	1941-04-29	1941-04-29 00:00:00	1941-04-29	38000177		0	0	14		0	0	0	203358	0	313782	1127433		
19534	1608	1713671	1942-03-20	1942-03-20 00:00:00	1942-03-27	1942-03-27 00:00:00	1942-03-27	38000177		0	0	7		0	0	0	107984	0	562251	1713671		
116561	2561	40213314	1977-02-02	1977-02-02 00:00:00	1977-02-02	1977-02-02 00:00:00	1977-02-02	581452		0	0	0		0	0	0	169728	0	49	40213314		
16457	1365	1127433	1986-02-20	1986-02-20 00:00:00	1986-02-27	1986-02-27 00:00:00	1986-02-27	38000177		0	0	7		0	0	0	90463	0	313782	1127433		
147558	3244	40213160	1973-09-26	1973-09-26 00:00:00	1973-09-26	1973-09-26 00:00:00	1973-09-26	581452		0	0	0		0	0	0	215736	0	10	40213160		
43470	3604	1127433	1996-03-24	1996-03-24 00:00:00	1996-03-31	1996-03-31 00:00:00	1996-03-31	38000177		0	0	7		0	0	0	239476	0	313782	1127433		
139167	3057	40213227	2008-05-05	2008-05-05 00:00:00	2008-05-05	2008-05-05 00:00:00	2008-05-05	581452		0	0	0		0	0	0	203396	0	113	40213227		
54007	4487	19075601	2004-10-22	2004-10-22 00:00:00	2010-02-12	2010-02-12 00:00:00	2010-02-12	38000177		0	0	1939		0	0	0	298775	0	309362	19075601		
2409	192	40220960	2014-07-02	2014-07-02 00:00:00	2014-07-02	2014-07-02 00:00:00	2014-07-02	38000177		0	0	0		0	0	0	13209	0	1804799	40220960		
88155	1934	40213160	1965-01-09	1965-01-09 00:00:00	1965-01-09	1965-01-09 00:00:00	1965-01-09	581452		0	0	0		0	0	0	128631	0	10	40213160		
59225	4923	1127433	1977-04-15	1977-04-15 00:00:00	1977-04-29	1977-04-29 00:00:00	1977-04-29	38000177		0	0	14		0	0	0	327097	0	313782	1127433		
39628	3277	1115171	2017-06-24	2017-06-24 00:00:00	2017-09-22	2017-09-22 00:00:00	2017-09-22	38000177		0	0	90		0	0	0	217742	0	849574	1115171		
144305	3172	40213227	1999-11-04	1999-11-04 00:00:00	1999-11-04	1999-11-04 00:00:00	1999-11-04	581452		0	0	0		0	0	0	210881	0	113	40213227		
60310	5015	19133873	1969-04-02	1969-04-02 00:00:00	1969-04-10	1969-04-10 00:00:00	1969-04-10	38000177		0	0	8		0	0	0	333360	0	834061	19133873		
38644	843	40213251	1987-04-11	1987-04-11 00:00:00	1987-04-11	1987-04-11 00:00:00	1987-04-11	581452		0	0	0		0	0	0	55801	0	21	40213251		
45581	3773	1127433	1982-06-21	1982-06-21 00:00:00	1982-06-28	1982-06-28 00:00:00	1982-06-28	38000177		0	0	7		0	0	0	250807	0	313782	1127433		
222179	4876	40213227	2004-01-10	2004-01-10 00:00:00	2004-01-10	2004-01-10 00:00:00	2004-01-10	581452		0	0	0		0	0	0	324280	0	113	40213227		
51879	4312	920300	1987-10-04	1987-10-04 00:00:00	1987-10-11	1987-10-11 00:00:00	1987-10-11	38000177		0	0	7		0	0	0	286197	0	311989	920300		
25994	2138	19078461	2007-10-16	2007-10-16 00:00:00	2007-11-13	2007-11-13 00:00:00	2007-11-13	38000177		0	0	28		0	0	0	142415	0	310965	19078461		
62424	5195	1127078	1964-07-25	1964-07-25 00:00:00	1964-08-08	1964-08-08 00:00:00	1964-08-08	38000177		0	0	14		0	0	0	345436	0	282464	1127078		
223467	4905	40213160	1972-12-07	1972-12-07 00:00:00	1972-12-07	1972-12-07 00:00:00	1972-12-07	581452		0	0	0		0	0	0	326046	0	10	40213160		
20131	1655	19133873	1984-06-02	1984-06-02 00:00:00	1984-06-15	1984-06-15 00:00:00	1984-06-15	38000177		0	0	13		0	0	0	111028	0	834061	19133873		
39407	3254	1127433	1978-03-31	1978-03-31 00:00:00	1978-05-05	1978-05-05 00:00:00	1978-05-05	38000177		0	0	35		0	0	0	216452	0	313782	1127433		
80394	1759	40213251	1986-03-10	1986-03-10 00:00:00	1986-03-10	1986-03-10 00:00:00	1986-03-10	581452		0	0	0		0	0	0	117628	0	21	40213251		
1334	105	19078461	1982-02-12	1982-02-12 00:00:00	1982-02-26	1982-02-26 00:00:00	1982-02-26	38000177		0	0	14		0	0	0	7145	0	310965	19078461		
1337	105	1713671	2001-11-17	2001-11-17 00:00:00	2001-11-24	2001-11-24 00:00:00	2001-11-24	38000177		0	0	7		0	0	0	7112	0	562251	1713671		
35290	2909	19059056	1956-07-27	1956-07-27 00:00:00	1956-08-10	1956-08-10 00:00:00	1956-08-10	38000177		0	0	14		0	0	0	193909	0	243670	19059056		
217391	4771	40213227	2004-07-17	2004-07-17 00:00:00	2004-07-17	2004-07-17 00:00:00	2004-07-17	581452		0	0	0		0	0	0	317784	0	113	40213227		
27907	2309	19133873	1977-09-07	1977-09-07 00:00:00	1977-09-16	1977-09-16 00:00:00	1977-09-16	38000177		0	0	9		0	0	0	153612	0	834061	19133873		
29713	2461	19019979	1976-01-13	1976-01-13 00:00:00	1976-01-27	1976-01-27 00:00:00	1976-01-27	38000177		0	0	14		0	0	0	163198	0	198405	19019979		
12128	1017	1713671	2018-05-09	2018-05-09 00:00:00	2018-05-30	2018-05-30 00:00:00	2018-05-30	38000177		0	0	21		0	0	0	66980	0	562251	1713671		
211697	4641	40213160	1968-03-21	1968-03-21 00:00:00	1968-03-21	1968-03-21 00:00:00	1968-03-21	581452		0	0	0		0	0	0	309319	0	10	40213160		
38567	3184	19006318	1966-05-24	1966-05-24 00:00:00	1966-06-07	1966-06-07 00:00:00	1966-06-07	38000177		0	0	14		0	0	0	212002	0	105078	19006318		
20803	452	40213227	2013-09-13	2013-09-13 00:00:00	2013-09-13	2013-09-13 00:00:00	2013-09-13	581452		0	0	0		0	0	0	30103	0	113	40213227		
156968	3454	40213227	2005-04-04	2005-04-04 00:00:00	2005-04-04	2005-04-04 00:00:00	2005-04-04	581452		0	0	0		0	0	0	229151	0	113	40213227		
5251	440	1713671	2005-09-08	2005-09-08 00:00:00	2005-09-29	2005-09-29 00:00:00	2005-09-29	38000177		0	0	21		0	0	0	29199	0	562251	1713671		
68747	1505	40213160	1956-02-11	1956-02-11 00:00:00	1956-02-11	1956-02-11 00:00:00	1956-02-11	581452		0	0	0		0	0	0	100319	0	10	40213160		
33623	2782	1118084	1955-03-30	1955-03-30 00:00:00	1955-03-30	1955-03-30 00:00:00	\N	38000177		0	0	0		0	0	0	184355	0	00025152531	44923712		
17503	1448	1127078	1976-01-12	1976-01-12 00:00:00	1976-01-26	1976-01-26 00:00:00	1976-01-26	38000177		0	0	14		0	0	0	96571	0	282464	1127078		
58604	4867	1713671	1949-03-15	1949-03-15 00:00:00	1949-03-29	1949-03-29 00:00:00	1949-03-29	38000177		0	0	14		0	0	0	323679	0	562251	1713671		
792	64	1713671	1993-07-05	1993-07-05 00:00:00	1993-07-26	1993-07-26 00:00:00	1993-07-26	38000177		0	0	21		0	0	0	4321	0	562251	1713671		
10996	917	19078461	2005-11-06	2005-11-06 00:00:00	2006-02-04	2006-02-04 00:00:00	2006-02-04	38000177		0	0	90		0	0	0	61083	0	310965	19078461		
16074	1333	1713671	1973-10-09	1973-10-09 00:00:00	1973-10-16	1973-10-16 00:00:00	1973-10-16	38000177		0	0	7		0	0	0	88451	0	562251	1713671		
8508	709	19059056	1949-10-01	1949-10-01 00:00:00	1949-10-15	1949-10-15 00:00:00	1949-10-15	38000177		0	0	14		0	0	0	46977	0	243670	19059056		
29969	2483	40169281	1968-05-11	1968-05-11 00:00:00	1968-05-11	1968-05-11 00:00:00	\N	38000177		0	0	0		0	0	0	164504	0	896209	40169281		
22428	1844	1118084	2002-10-13	2002-10-13 00:00:00	2002-10-13	2002-10-13 00:00:00	\N	38000177		0	0	0		0	0	0	123168	0	00025152531	44923712		
54698	4544	40236824	1961-11-21	1961-11-21 00:00:00	1961-11-28	1961-11-28 00:00:00	1961-11-28	38000177		0	0	7		0	0	0	302710	0	1094107	40236824		
40571	3363	1118084	1995-08-08	1995-08-08 00:00:00	1995-08-08	1995-08-08 00:00:00	\N	38000177		0	0	0		0	0	0	222967	0	00025152531	44923712		
32546	2699	1713671	1977-07-20	1977-07-20 00:00:00	1977-07-27	1977-07-27 00:00:00	1977-07-27	38000177		0	0	7		0	0	0	178753	0	562251	1713671		
36153	2980	1713671	1984-04-16	1984-04-16 00:00:00	1984-05-07	1984-05-07 00:00:00	1984-05-07	38000177		0	0	21		0	0	0	198967	0	562251	1713671		
5798	484	1127433	1953-08-12	1953-08-12 00:00:00	1953-09-02	1953-09-02 00:00:00	1953-09-02	38000177		0	0	21		0	0	0	32400	0	313782	1127433		
24222	526	40213296	2013-03-06	2013-03-06 00:00:00	2013-03-06	2013-03-06 00:00:00	2013-03-06	581452		0	0	0		0	0	0	35075	0	52	40213296		
42902	3556	19059056	1987-09-28	1987-09-28 00:00:00	1987-10-12	1987-10-12 00:00:00	1987-10-12	38000177		0	0	14		0	0	0	236144	0	243670	19059056		
47955	3976	19078461	1977-05-25	1977-05-25 00:00:00	1977-06-08	1977-06-08 00:00:00	1977-06-08	38000177		0	0	14		0	0	0	264350	0	310965	19078461		
34120	2821	19133873	1927-03-14	1927-03-14 00:00:00	1927-03-23	1927-03-23 00:00:00	1927-03-23	38000177		0	0	9		0	0	0	186947	0	834061	19133873		
26937	2220	1127433	1991-06-07	1991-06-07 00:00:00	1991-06-14	1991-06-14 00:00:00	1991-06-14	38000177		0	0	7		0	0	0	147772	0	313782	1127433		
87016	1908	40213227	2001-11-18	2001-11-18 00:00:00	2001-11-18	2001-11-18 00:00:00	2001-11-18	581452		0	0	0		0	0	0	127003	0	113	40213227		
153469	3378	40213160	1957-12-28	1957-12-28 00:00:00	1957-12-28	1957-12-28 00:00:00	1957-12-28	581452		0	0	0		0	0	0	224155	0	10	40213160		
53912	4480	19128065	1983-12-15	1983-12-15 00:00:00	1984-12-09	1984-12-09 00:00:00	1984-12-09	38000177		0	0	360		0	0	0	298173	0	749882	19128065		
9964	836	1713671	1988-11-09	1988-11-09 00:00:00	1989-02-15	1989-02-15 00:00:00	1989-02-15	38000177		0	0	98		0	0	0	55292	0	562251	1713671		
98462	2156	40213160	1964-10-29	1964-10-29 00:00:00	1964-10-29	1964-10-29 00:00:00	1964-10-29	581452		0	0	0		0	0	0	143701	0	10	40213160		
15058	1258	1127433	1983-05-18	1983-05-18 00:00:00	1983-06-08	1983-06-08 00:00:00	1983-06-08	38000177		0	0	21		0	0	0	82848	0	313782	1127433		
110092	2418	40213160	1974-02-12	1974-02-12 00:00:00	1974-02-12	1974-02-12 00:00:00	1974-02-12	581452		0	0	0		0	0	0	160449	0	10	40213160		
3010	245	40231925	1942-04-03	1942-04-03 00:00:00	1942-04-03	1942-04-03 00:00:00	\N	38000177		0	0	0		0	0	0	16442	0	1049221	40231925		
36956	3057	1115171	2004-10-28	2004-10-28 00:00:00	2004-11-11	2004-11-11 00:00:00	2004-11-11	38000177		0	0	14		0	0	0	203388	0	849574	1115171		
19535	1608	19059056	1947-12-10	1947-12-10 00:00:00	1947-12-24	1947-12-24 00:00:00	1947-12-24	38000177		0	0	14		0	0	0	108011	0	243670	19059056		
116562	2561	40213160	1977-02-02	1977-02-02 00:00:00	1977-02-02	1977-02-02 00:00:00	1977-02-02	581452		0	0	0		0	0	0	169728	0	10	40213160		
16458	1365	920334	1993-11-20	1993-11-20 00:00:00	1993-11-27	1993-11-27 00:00:00	1993-11-27	38000177		0	0	7		0	0	0	90506	0	311995	920334		
147574	3244	40213306	1996-09-18	1996-09-18 00:00:00	1996-09-18	1996-09-18 00:00:00	1996-09-18	581452		0	0	0		0	0	0	\N	0	43	40213306		
43471	3604	1127078	1990-01-03	1990-01-03 00:00:00	1990-01-31	1990-01-31 00:00:00	1990-01-31	38000177		0	0	28		0	0	0	239470	0	282464	1127078		
139169	3057	40213227	2018-07-02	2018-07-02 00:00:00	2018-07-02	2018-07-02 00:00:00	2018-07-02	581452		0	0	0		0	0	0	203432	0	113	40213227		
54008	4487	1127433	2005-10-26	2005-10-26 00:00:00	2005-11-16	2005-11-16 00:00:00	2005-11-16	38000177		0	0	21		0	0	0	298686	0	313782	1127433		
2410	192	1124300	1981-10-27	1981-10-27 00:00:00	1981-10-27	1981-10-27 00:00:00	\N	38000177		0	0	0		0	0	0	13174	0	00781178901	45011828		
88162	1934	40213160	1960-05-07	1960-05-07 00:00:00	1960-05-07	1960-05-07 00:00:00	1960-05-07	581452		0	0	0		0	0	0	128654	0	10	40213160		
59226	4923	19059056	1970-01-01	1970-01-01 00:00:00	1970-01-15	1970-01-15 00:00:00	1970-01-15	38000177		0	0	14		0	0	0	327131	0	243670	19059056		
39629	3277	19133873	1974-06-20	1974-06-20 00:00:00	1974-06-29	1974-06-29 00:00:00	1974-06-29	38000177		0	0	9		0	0	0	217701	0	834061	19133873		
144306	3172	40213306	1999-11-04	1999-11-04 00:00:00	1999-11-04	1999-11-04 00:00:00	1999-11-04	581452		0	0	0		0	0	0	210881	0	43	40213306		
60311	5015	1127433	1977-11-16	1977-11-16 00:00:00	1977-11-30	1977-11-30 00:00:00	1977-11-30	38000177		0	0	14		0	0	0	333344	0	313782	1127433		
38650	843	40213314	1983-07-09	1983-07-09 00:00:00	1983-07-09	1983-07-09 00:00:00	1983-07-09	581452		0	0	0		0	0	0	55799	0	49	40213314		
45582	3773	19006318	1961-05-16	1961-05-16 00:00:00	1961-05-30	1961-05-30 00:00:00	1961-05-30	38000177		0	0	14		0	0	0	250826	0	105078	19006318		
143750	3159	40213227	2010-09-02	2010-09-02 00:00:00	2010-09-02	2010-09-02 00:00:00	2010-09-02	581452		0	0	0		0	0	0	210032	0	113	40213227		
51880	4312	40236824	1987-10-04	1987-10-04 00:00:00	1987-10-11	1987-10-11 00:00:00	1987-10-11	38000177		0	0	7		0	0	0	286197	0	1094107	40236824		
25995	2138	19059056	1959-08-15	1959-08-15 00:00:00	1959-11-13	1959-11-13 00:00:00	1959-11-13	38000177		0	0	90		0	0	0	142411	0	243670	19059056		
62425	5195	40229134	1985-04-07	1985-04-07 00:00:00	1985-04-14	1985-04-14 00:00:00	1985-04-14	38000177		0	0	7		0	0	0	345464	0	1043400	40229134		
62029	1355	40213160	1964-04-17	1964-04-17 00:00:00	1964-04-17	1964-04-17 00:00:00	1964-04-17	581452		0	0	0		0	0	0	89804	0	10	40213160		
20132	1655	40169216	2004-09-29	2004-09-29 00:00:00	2004-09-29	2004-09-29 00:00:00	\N	38000177		0	0	0		0	0	0	110995	0	895994	40169216		
39408	3254	19059056	1967-03-26	1967-03-26 00:00:00	1967-04-09	1967-04-09 00:00:00	1967-04-09	38000177		0	0	14		0	0	0	216449	0	243670	19059056		
80399	1759	40213306	2008-07-07	2008-07-07 00:00:00	2008-07-07	2008-07-07 00:00:00	2008-07-07	581452		0	0	0		0	0	0	117622	0	43	40213306		
19013	1569	1713671	1968-09-29	1968-09-29 00:00:00	1968-10-20	1968-10-20 00:00:00	1968-10-20	38000177		0	0	21		0	0	0	105254	0	562251	1713671		
1338	105	1545959	2005-11-11	2005-11-11 00:00:00	2005-11-11	2005-11-11 00:00:00	2005-11-11	38000177		0	0	0		0	0	0	7147	0	259255	1545959		
35291	2909	1124300	1986-09-03	1986-09-03 00:00:00	1986-09-03	1986-09-03 00:00:00	\N	38000177		0	0	0		0	0	0	193924	0	00781178901	45011828		
217394	4771	40213260	2006-07-29	2006-07-29 00:00:00	2006-07-29	2006-07-29 00:00:00	2006-07-29	581452		0	0	0		0	0	0	317785	0	121	40213260		
27908	2309	1118084	2016-10-10	2016-10-10 00:00:00	2016-10-10	2016-10-10 00:00:00	\N	38000177		0	0	0		0	0	0	153658	0	00025152531	44923712		
29714	2461	1127433	1991-02-24	1991-02-24 00:00:00	1991-03-10	1991-03-10 00:00:00	1991-03-10	38000177		0	0	14		0	0	0	163143	0	313782	1127433		
12129	1017	1127433	1971-03-11	1971-03-11 00:00:00	1971-03-18	1971-03-18 00:00:00	1971-03-18	38000177		0	0	7		0	0	0	66928	0	313782	1127433		
211705	4642	40213260	2006-12-19	2006-12-19 00:00:00	2006-12-19	2006-12-19 00:00:00	2006-12-19	581452		0	0	0		0	0	0	309437	0	121	40213260		
38568	3184	19078461	1995-11-16	1995-11-16 00:00:00	1995-11-30	1995-11-30 00:00:00	1995-11-30	38000177		0	0	14		0	0	0	211961	0	310965	19078461		
20804	452	40213260	2013-09-13	2013-09-13 00:00:00	2013-09-13	2013-09-13 00:00:00	2013-09-13	581452		0	0	0		0	0	0	30103	0	121	40213260		
156969	3454	40213306	2005-04-04	2005-04-04 00:00:00	2005-04-04	2005-04-04 00:00:00	2005-04-04	581452		0	0	0		0	0	0	229151	0	43	40213306		
5252	440	19059056	1974-06-06	1974-06-06 00:00:00	1974-06-20	1974-06-20 00:00:00	1974-06-20	38000177		0	0	14		0	0	0	29200	0	243670	19059056		
68753	1505	40213227	1994-12-24	1994-12-24 00:00:00	1994-12-24	1994-12-24 00:00:00	1994-12-24	581452		0	0	0		0	0	0	100344	0	113	40213227		
33624	2782	1127433	1952-02-01	1952-02-01 00:00:00	1952-02-08	1952-02-08 00:00:00	1952-02-08	38000177		0	0	7		0	0	0	184442	0	313782	1127433		
17504	1448	46233988	1976-01-12	1976-01-12 00:00:00	1976-01-26	1976-01-26 00:00:00	1976-01-26	38000177		0	0	14		0	0	0	96571	0	1652673	46233988		
58605	4867	19133905	1988-04-12	1988-04-12 00:00:00	1988-04-25	1988-04-25 00:00:00	1988-04-25	38000177		0	0	13		0	0	0	323597	0	834102	19133905		
793	64	40229134	1985-02-28	1985-02-28 00:00:00	1985-03-14	1985-03-14 00:00:00	1985-03-14	38000177		0	0	14		0	0	0	4319	0	1043400	40229134		
10997	917	19128065	1979-05-02	1979-05-02 00:00:00	1980-04-26	1980-04-26 00:00:00	1980-04-26	38000177		0	0	360		0	0	0	60943	0	749882	19128065		
16075	1333	19133873	1957-12-18	1957-12-18 00:00:00	1957-12-27	1957-12-27 00:00:00	1957-12-27	38000177		0	0	9		0	0	0	88440	0	834061	19133873		
8509	709	19006318	1949-10-01	1949-10-01 00:00:00	1949-10-15	1949-10-15 00:00:00	1949-10-15	38000177		0	0	14		0	0	0	46977	0	105078	19006318		
29970	2483	19133905	1981-04-06	1981-04-06 00:00:00	1981-04-16	1981-04-16 00:00:00	1981-04-16	38000177		0	0	10		0	0	0	164491	0	834102	19133905		
22429	1844	1127433	1977-07-15	1977-07-15 00:00:00	1977-09-13	1977-09-13 00:00:00	1977-09-13	38000177		0	0	60		0	0	0	123218	0	313782	1127433		
54699	4544	920300	1961-11-21	1961-11-21 00:00:00	1961-11-28	1961-11-28 00:00:00	1961-11-28	38000177		0	0	7		0	0	0	302710	0	311989	920300		
40572	3363	1127078	1956-05-04	1956-05-04 00:00:00	1956-06-08	1956-06-08 00:00:00	1956-06-08	38000177		0	0	35		0	0	0	222949	0	282464	1127078		
32547	2699	1127433	1980-05-13	1980-05-13 00:00:00	1980-05-20	1980-05-20 00:00:00	1980-05-20	38000177		0	0	7		0	0	0	178716	0	313782	1127433		
36154	2980	1713671	2008-05-06	2008-05-06 00:00:00	2008-05-13	2008-05-13 00:00:00	2008-05-13	38000177		0	0	7		0	0	0	198892	0	562251	1713671		
5799	484	19059056	1942-11-25	1942-11-25 00:00:00	1942-12-09	1942-12-09 00:00:00	1942-12-09	38000177		0	0	14		0	0	0	32320	0	243670	19059056		
24224	526	40213227	2013-03-06	2013-03-06 00:00:00	2013-03-06	2013-03-06 00:00:00	2013-03-06	581452		0	0	0		0	0	0	35075	0	113	40213227		
42903	3556	19078461	2002-01-03	2002-01-03 00:00:00	2002-01-17	2002-01-17 00:00:00	2002-01-17	38000177		0	0	14		0	0	0	236130	0	310965	19078461		
47956	3976	1127433	1976-06-08	1976-06-08 00:00:00	1976-06-29	1976-06-29 00:00:00	1976-06-29	38000177		0	0	21		0	0	0	264349	0	313782	1127433		
34121	2821	19059056	1923-07-24	1923-07-24 00:00:00	1923-08-07	1923-08-07 00:00:00	1923-08-07	38000177		0	0	14		0	0	0	186936	0	243670	19059056		
26938	2220	1118084	1987-07-23	1987-07-23 00:00:00	1987-07-23	1987-07-23 00:00:00	\N	38000177		0	0	0		0	0	0	147835	0	00025152531	44923712		
87018	1908	40213160	1970-11-15	1970-11-15 00:00:00	1970-11-15	1970-11-15 00:00:00	1970-11-15	581452		0	0	0		0	0	0	126960	0	10	40213160		
153471	3378	40213260	2008-07-26	2008-07-26 00:00:00	2008-07-26	2008-07-26 00:00:00	2008-07-26	581452		0	0	0		0	0	0	224202	0	121	40213260		
53913	4480	19128065	1975-01-28	1975-01-28 00:00:00	1976-01-23	1976-01-23 00:00:00	1976-01-23	38000177		0	0	360		0	0	0	298144	0	749882	19128065		
9965	836	19128022	1997-08-04	1997-08-04 00:00:00	1998-07-30	1998-07-30 00:00:00	1998-07-30	38000177		0	0	360		0	0	0	55282	0	749785	19128022		
98464	2156	40213227	2016-03-03	2016-03-03 00:00:00	2016-03-03	2016-03-03 00:00:00	2016-03-03	581452		0	0	0		0	0	0	143685	0	113	40213227		
15059	1258	19078461	1986-05-23	1986-05-23 00:00:00	1986-06-20	1986-06-20 00:00:00	1986-06-20	38000177		0	0	28		0	0	0	82849	0	310965	19078461		
110095	2418	40213227	1996-06-18	1996-06-18 00:00:00	1996-06-18	1996-06-18 00:00:00	1996-06-18	581452		0	0	0		0	0	0	160473	0	113	40213227		
3011	245	19078461	2004-12-20	2004-12-20 00:00:00	2005-01-03	2005-01-03 00:00:00	2005-01-03	38000177		0	0	14		0	0	0	16404	0	310965	19078461		
36957	3057	1115171	2017-10-04	2017-10-04 00:00:00	2017-12-03	2017-12-03 00:00:00	2017-12-03	38000177		0	0	60		0	0	0	203389	0	849574	1115171		
19536	1608	40229134	1952-03-01	1952-03-01 00:00:00	1952-03-08	1952-03-08 00:00:00	1952-03-08	38000177		0	0	7		0	0	0	107973	0	1043400	40229134		
116568	2561	40213296	2016-12-21	2016-12-21 00:00:00	2016-12-21	2016-12-21 00:00:00	2016-12-21	581452		0	0	0		0	0	0	169699	0	52	40213296		
18305	1516	40222846	2009-04-12	2009-04-12 00:00:00	2009-04-12	2009-04-12 00:00:00	\N	38000177		0	0	0		0	0	0	101279	0	996740	40222846		
147577	3244	40213227	1995-11-08	1995-11-08 00:00:00	1995-11-08	1995-11-08 00:00:00	1995-11-08	581452		0	0	0		0	0	0	215698	0	113	40213227		
43472	3604	19019979	1987-03-02	1987-03-02 00:00:00	1987-03-16	1987-03-16 00:00:00	1987-03-16	38000177		0	0	14		0	0	0	239554	0	198405	19019979		
63713	5295	19133873	1917-01-01	1917-01-01 00:00:00	1917-01-09	1917-01-09 00:00:00	1917-01-09	38000177		0	0	8		0	0	0	352269	0	834061	19133873		
54009	4487	19133768	2010-02-12	2010-02-12 00:00:00	2010-02-12	2010-02-12 00:00:00	2010-02-12	38000177		0	0	0		0	0	0	298687	0	833036	19133768		
2411	192	19059056	1952-04-12	1952-04-12 00:00:00	1952-04-26	1952-04-26 00:00:00	1952-04-26	38000177		0	0	14		0	0	0	13188	0	243670	19059056		
88164	1934	40213296	2000-02-05	2000-02-05 00:00:00	2000-02-05	2000-02-05 00:00:00	2000-02-05	581452		0	0	0		0	0	0	128663	0	52	40213296		
59227	4923	40165015	1997-03-08	1997-03-08 00:00:00	1997-03-08	1997-03-08 00:00:00	\N	38000177		0	0	0		0	0	0	327126	0	861467	40165015		
39630	3278	1118084	1994-01-30	1994-01-30 00:00:00	1994-01-30	1994-01-30 00:00:00	\N	38000177		0	0	0		0	0	0	217770	0	00025152531	44923712		
144309	3172	40213314	1978-01-26	1978-01-26 00:00:00	1978-01-26	1978-01-26 00:00:00	1978-01-26	581452		0	0	0		0	0	0	210826	0	49	40213314		
60312	5015	1118084	2006-08-14	2006-08-14 00:00:00	2006-08-14	2006-08-14 00:00:00	\N	38000177		0	0	0		0	0	0	333370	0	00025152531	44923712		
38652	843	40213314	1982-10-09	1982-10-09 00:00:00	1982-10-09	1982-10-09 00:00:00	1982-10-09	581452		0	0	0		0	0	0	55798	0	49	40213314		
45583	3773	19059056	1961-05-16	1961-05-16 00:00:00	1961-05-30	1961-05-30 00:00:00	1961-05-30	38000177		0	0	14		0	0	0	250826	0	243670	19059056		
143751	3159	40213260	2010-09-02	2010-09-02 00:00:00	2010-09-02	2010-09-02 00:00:00	2010-09-02	581452		0	0	0		0	0	0	210032	0	121	40213260		
51881	4312	1127433	1989-09-08	1989-09-08 00:00:00	1989-09-29	1989-09-29 00:00:00	1989-09-29	38000177		0	0	21		0	0	0	286124	0	313782	1127433		
25996	2138	19078461	2012-08-18	2012-08-18 00:00:00	2012-09-08	2012-09-08 00:00:00	2012-09-08	38000177		0	0	21		0	0	0	142416	0	310965	19078461		
62426	5195	1127433	2015-09-08	2015-09-08 00:00:00	2015-12-07	2015-12-07 00:00:00	2015-12-07	38000177		0	0	90		0	0	0	345410	0	313782	1127433		
3820	318	40229134	1974-03-07	1974-03-07 00:00:00	1974-03-21	1974-03-21 00:00:00	1974-03-21	38000177		0	0	14		0	0	0	21057	0	1043400	40229134		
20133	1655	1154615	2004-09-29	2004-09-29 00:00:00	2004-09-29	2004-09-29 00:00:00	\N	38000177		0	0	0		0	0	0	110995	0	745679	1154615		
39409	3254	19129655	1967-03-26	1967-03-26 00:00:00	1967-04-09	1967-04-09 00:00:00	1967-04-09	38000177		0	0	14		0	0	0	216449	0	789980	19129655		
80405	1759	40213306	2005-07-04	2005-07-04 00:00:00	2005-07-04	2005-07-04 00:00:00	2005-07-04	581452		0	0	0		0	0	0	117621	0	43	40213306		
19014	1569	40236824	1972-10-01	1972-10-01 00:00:00	1972-10-15	1972-10-15 00:00:00	1972-10-15	38000177		0	0	14		0	0	0	105255	0	1094107	40236824		
1339	105	19133768	2005-11-11	2005-11-11 00:00:00	2005-11-11	2005-11-11 00:00:00	2005-11-11	38000177		0	0	0		0	0	0	7147	0	833036	19133768		
35293	2909	40174880	1999-02-12	1999-02-12 00:00:00	1999-02-12	1999-02-12 00:00:00	\N	38000177		0	0	0		0	0	0	193875	0	966222	40174880		
217398	4771	40213227	1994-06-18	1994-06-18 00:00:00	1994-06-18	1994-06-18 00:00:00	1994-06-18	581452		0	0	0		0	0	0	317782	0	113	40213227		
27909	2309	1127433	2018-01-06	2018-01-06 00:00:00	2018-03-14	2018-03-14 00:00:00	2018-03-14	38000177		0	0	67		0	0	0	153636	0	313782	1127433		
40173	3325	1118084	2004-12-23	2004-12-23 00:00:00	2004-12-23	2004-12-23 00:00:00	\N	38000177		0	0	0		0	0	0	220738	0	00025152531	44923712		
12130	1017	19074679	1970-06-12	1970-06-12 00:00:00	1970-10-09	1970-10-09 00:00:00	1970-10-09	38000177		0	0	119		0	0	0	67002	0	308971	19074679		
239719	5262	40213160	1971-04-11	1971-04-11 00:00:00	1971-04-11	1971-04-11 00:00:00	1971-04-11	581452		0	0	0		0	0	0	350093	0	10	40213160		
38569	3184	19074841	1995-11-16	1995-11-16 00:00:00	1995-11-30	1995-11-30 00:00:00	1995-11-30	38000177		0	0	14		0	0	0	211961	0	309043	19074841		
20806	452	40213227	2004-09-17	2004-09-17 00:00:00	2004-09-17	2004-09-17 00:00:00	2004-09-17	581452		0	0	0		0	0	0	30092	0	113	40213227		
156970	3454	40213180	2005-04-04	2005-04-04 00:00:00	2005-04-04	2005-04-04 00:00:00	2005-04-04	581452		0	0	0		0	0	0	229151	0	114	40213180		
5253	440	46233988	1974-06-06	1974-06-06 00:00:00	1974-06-20	1974-06-20 00:00:00	1974-06-20	38000177		0	0	14		0	0	0	29200	0	1652673	46233988		
68757	1505	40213198	2019-04-13	2019-04-13 00:00:00	2019-04-13	2019-04-13 00:00:00	2019-04-13	581452		0	0	0		0	0	0	100356	0	133	40213198		
33625	2782	1127433	1962-11-19	1962-11-19 00:00:00	1962-11-26	1962-11-26 00:00:00	1962-11-26	38000177		0	0	7		0	0	0	184345	0	313782	1127433		
17505	1448	19133873	1986-04-05	1986-04-05 00:00:00	1986-04-14	1986-04-14 00:00:00	1986-04-14	38000177		0	0	9		0	0	0	96631	0	834061	19133873		
58606	4867	19133873	1931-09-07	1931-09-07 00:00:00	1931-09-17	1931-09-17 00:00:00	1931-09-17	38000177		0	0	10		0	0	0	323642	0	834061	19133873		
794	64	19128065	1994-09-18	1994-09-18 00:00:00	1995-09-13	1995-09-13 00:00:00	1995-09-13	38000177		0	0	360		0	0	0	4370	0	749882	19128065		
10998	917	1713671	1967-03-02	1967-03-02 00:00:00	1967-03-09	1967-03-09 00:00:00	1967-03-09	38000177		0	0	7		0	0	0	61084	0	562251	1713671		
16076	1333	1127433	1970-02-13	1970-02-13 00:00:00	1970-02-20	1970-02-20 00:00:00	1970-02-20	38000177		0	0	7		0	0	0	88404	0	313782	1127433		
8510	709	19133873	1950-09-27	1950-09-27 00:00:00	1950-10-08	1950-10-08 00:00:00	1950-10-08	38000177		0	0	11		0	0	0	46956	0	834061	19133873		
29971	2483	1127433	1962-12-15	1962-12-15 00:00:00	1962-12-29	1962-12-29 00:00:00	1962-12-29	38000177		0	0	14		0	0	0	164512	0	313782	1127433		
22430	1844	19078461	1976-06-06	1976-06-06 00:00:00	1976-06-20	1976-06-20 00:00:00	1976-06-20	38000177		0	0	14		0	0	0	123217	0	310965	19078461		
54700	4544	19133768	1994-02-01	1994-02-01 00:00:00	1994-02-01	1994-02-01 00:00:00	1994-02-01	38000177		0	0	0		0	0	0	302672	0	833036	19133768		
40573	3363	19059056	1951-05-01	1951-05-01 00:00:00	1951-05-15	1951-05-15 00:00:00	1951-05-15	38000177		0	0	14		0	0	0	222957	0	243670	19059056		
32548	2699	19128065	1987-10-29	1987-10-29 00:00:00	1988-10-23	1988-10-23 00:00:00	1988-10-23	38000177		0	0	360		0	0	0	178704	0	749882	19128065		
36155	2980	46233988	1974-06-06	1974-06-06 00:00:00	1974-06-20	1974-06-20 00:00:00	1974-06-20	38000177		0	0	14		0	0	0	198995	0	1652673	46233988		
5800	484	1127433	1976-06-12	1976-06-12 00:00:00	1976-06-26	1976-06-26 00:00:00	1976-06-26	38000177		0	0	14		0	0	0	32378	0	313782	1127433		
24229	526	40213296	2011-03-02	2011-03-02 00:00:00	2011-03-02	2011-03-02 00:00:00	2011-03-02	581452		0	0	0		0	0	0	35107	0	52	40213296		
42904	3556	1115171	2000-01-23	2000-01-23 00:00:00	2000-02-13	2000-02-13 00:00:00	2000-02-13	38000177		0	0	21		0	0	0	236129	0	849574	1115171		
47957	3976	40229134	2018-04-15	2018-04-15 00:00:00	2018-04-22	2018-04-22 00:00:00	2018-04-22	38000177		0	0	7		0	0	0	264399	0	1043400	40229134		
34122	2821	1127433	1946-04-02	1946-04-02 00:00:00	1946-04-09	1946-04-09 00:00:00	1946-04-09	38000177		0	0	7		0	0	0	186867	0	313782	1127433		
26939	2222	19075601	2012-07-24	2012-07-24 00:00:00	2012-07-24	2012-07-24 00:00:00	\N	38000177		0	0	0		0	0	0	147899	0	309362	19075601		
87031	1908	40213227	2012-08-26	2012-08-26 00:00:00	2012-08-26	2012-08-26 00:00:00	2012-08-26	581452		0	0	0		0	0	0	126982	0	113	40213227		
153473	3378	40213227	2008-07-26	2008-07-26 00:00:00	2008-07-26	2008-07-26 00:00:00	2008-07-26	581452		0	0	0		0	0	0	224202	0	113	40213227		
53914	4480	1115171	2013-12-29	2013-12-29 00:00:00	2014-01-26	2014-01-26 00:00:00	2014-01-26	38000177		0	0	28		0	0	0	298189	0	849574	1115171		
9966	836	19019979	1979-12-10	1979-12-10 00:00:00	1979-12-24	1979-12-24 00:00:00	1979-12-24	38000177		0	0	14		0	0	0	55329	0	198405	19019979		
98465	2156	40213260	2016-03-03	2016-03-03 00:00:00	2016-03-03	2016-03-03 00:00:00	2016-03-03	581452		0	0	0		0	0	0	143685	0	121	40213260		
15060	1258	1713671	2004-07-12	2004-07-12 00:00:00	2004-07-26	2004-07-26 00:00:00	2004-07-26	38000177		0	0	14		0	0	0	82877	0	562251	1713671		
110096	2418	40213306	1996-06-18	1996-06-18 00:00:00	1996-06-18	1996-06-18 00:00:00	1996-06-18	581452		0	0	0		0	0	0	160473	0	43	40213306		
3012	245	19133905	1987-10-18	1987-10-18 00:00:00	1987-10-31	1987-10-31 00:00:00	1987-10-31	38000177		0	0	13		0	0	0	16427	0	834102	19133905		
36958	3057	19059056	1992-02-13	1992-02-13 00:00:00	1992-03-05	1992-03-05 00:00:00	1992-03-05	38000177		0	0	21		0	0	0	203387	0	243670	19059056		
19537	1608	19059056	1951-11-03	1951-11-03 00:00:00	1951-11-24	1951-11-24 00:00:00	1951-11-24	38000177		0	0	21		0	0	0	108012	0	243670	19059056		
116572	2561	40213306	1996-11-27	1996-11-27 00:00:00	1996-11-27	1996-11-27 00:00:00	1996-11-27	581452		0	0	0		0	0	0	169684	0	43	40213306		
18306	1516	19078461	2000-04-24	2000-04-24 00:00:00	2000-05-08	2000-05-08 00:00:00	2000-05-08	38000177		0	0	14		0	0	0	101272	0	310965	19078461		
147578	3244	40213306	1995-11-08	1995-11-08 00:00:00	1995-11-08	1995-11-08 00:00:00	1995-11-08	581452		0	0	0		0	0	0	215698	0	43	40213306		
43473	3604	19073183	1987-03-02	1987-03-02 00:00:00	1987-03-16	1987-03-16 00:00:00	1987-03-16	38000177		0	0	14		0	0	0	239554	0	308182	19073183		
63714	5295	1127433	1939-11-22	1939-11-22 00:00:00	1939-11-29	1939-11-29 00:00:00	1939-11-29	38000177		0	0	7		0	0	0	352279	0	313782	1127433		
54010	4487	1545959	2010-02-12	2010-02-12 00:00:00	2010-02-12	2010-02-12 00:00:00	2010-02-12	38000177		0	0	0		0	0	0	298687	0	259255	1545959		
2412	192	19006318	1952-04-12	1952-04-12 00:00:00	1952-04-26	1952-04-26 00:00:00	1952-04-26	38000177		0	0	14		0	0	0	13188	0	105078	19006318		
88166	1934	40213160	1960-10-08	1960-10-08 00:00:00	1960-10-08	1960-10-08 00:00:00	1960-10-08	581452		0	0	0		0	0	0	128655	0	10	40213160		
59228	4923	1115171	1997-03-08	1997-03-08 00:00:00	1997-04-07	1997-04-07 00:00:00	1997-04-07	38000177		0	0	30		0	0	0	327126	0	849574	1115171		
39631	3278	1127078	1969-05-01	1969-05-01 00:00:00	1969-07-30	1969-07-30 00:00:00	1969-07-30	38000177		0	0	90		0	0	0	217743	0	282464	1127078		
103783	2277	40213306	1988-01-03	1988-01-03 00:00:00	1988-01-03	1988-01-03 00:00:00	1988-01-03	581452		0	0	0		0	0	0	151367	0	43	40213306		
60313	5015	1127433	1991-04-26	1991-04-26 00:00:00	1991-05-17	1991-05-17 00:00:00	1991-05-17	38000177		0	0	21		0	0	0	333376	0	313782	1127433		
60207	5004	1127433	1984-07-30	1984-07-30 00:00:00	1984-08-13	1984-08-13 00:00:00	1984-08-13	38000177		0	0	14		0	0	0	332882	0	313782	1127433		
45584	3773	1127433	1990-12-31	1990-12-31 00:00:00	1991-01-14	1991-01-14 00:00:00	1991-01-14	38000177		0	0	14		0	0	0	250814	0	313782	1127433		
143756	3159	40213160	1960-03-03	1960-03-03 00:00:00	1960-03-03	1960-03-03 00:00:00	1960-03-03	581452		0	0	0		0	0	0	210099	0	10	40213160		
51882	4312	1127433	1982-10-16	1982-10-16 00:00:00	1982-10-23	1982-10-23 00:00:00	1982-10-23	38000177		0	0	7		0	0	0	286089	0	313782	1127433		
25997	2138	1127433	1999-12-27	1999-12-27 00:00:00	2000-01-03	2000-01-03 00:00:00	2000-01-03	38000177		0	0	7		0	0	0	142378	0	313782	1127433		
62427	5195	40231925	2015-09-08	2015-09-08 00:00:00	2015-09-08	2015-09-08 00:00:00	\N	38000177		0	0	0		0	0	0	345410	0	1049221	40231925		
3821	318	40236446	1966-05-01	1966-05-01 00:00:00	1966-09-04	1966-09-04 00:00:00	1966-09-04	38000177		0	0	126		0	0	0	21093	0	1091392	40236446		
20134	1655	1118084	2005-10-12	2005-10-12 00:00:00	2005-10-12	2005-10-12 00:00:00	\N	38000177		0	0	0		0	0	0	111008	0	00025152531	44923712		
39410	3254	1713671	2001-07-17	2001-07-17 00:00:00	2001-08-07	2001-08-07 00:00:00	2001-08-07	38000177		0	0	21		0	0	0	216432	0	562251	1713671		
204814	4496	40213227	2018-06-14	2018-06-14 00:00:00	2018-06-14	2018-06-14 00:00:00	2018-06-14	581452		0	0	0		0	0	0	299327	0	113	40213227		
19015	1569	920300	1972-10-01	1972-10-01 00:00:00	1972-10-08	1972-10-08 00:00:00	1972-10-08	38000177		0	0	7		0	0	0	105255	0	311989	920300		
1340	105	19075601	2000-06-09	2000-06-09 00:00:00	2005-11-11	2005-11-11 00:00:00	2005-11-11	38000177		0	0	1981		0	0	0	7109	0	309362	19075601		
35294	2909	1127433	1957-05-13	1957-05-13 00:00:00	1957-05-27	1957-05-27 00:00:00	1957-05-27	38000177		0	0	14		0	0	0	193871	0	313782	1127433		
217400	4771	40213160	1955-01-29	1955-01-29 00:00:00	1955-01-29	1955-01-29 00:00:00	1955-01-29	581452		0	0	0		0	0	0	317792	0	10	40213160		
27910	2309	1115171	2013-11-28	2013-11-28 00:00:00	2013-12-28	2013-12-28 00:00:00	2013-12-28	38000177		0	0	30		0	0	0	153635	0	849574	1115171		
40174	3325	19133873	1964-06-12	1964-06-12 00:00:00	1964-06-22	1964-06-22 00:00:00	1964-06-22	38000177		0	0	10		0	0	0	220742	0	834061	19133873		
12131	1017	1127433	1976-10-25	1976-10-25 00:00:00	1976-11-08	1976-11-08 00:00:00	1976-11-08	38000177		0	0	14		0	0	0	66982	0	313782	1127433		
239725	5262	40213296	2011-01-09	2011-01-09 00:00:00	2011-01-09	2011-01-09 00:00:00	2011-01-09	581452		0	0	0		0	0	0	350120	0	52	40213296		
38570	3184	1124300	2003-10-08	2003-10-08 00:00:00	2003-10-08	2003-10-08 00:00:00	\N	38000177		0	0	0		0	0	0	211999	0	00781178901	45011828		
20808	452	40213160	1963-05-17	1963-05-17 00:00:00	1963-05-17	1963-05-17 00:00:00	1963-05-17	581452		0	0	0		0	0	0	30089	0	10	40213160		
156982	3454	40213160	1983-11-14	1983-11-14 00:00:00	1983-11-14	1983-11-14 00:00:00	1983-11-14	581452		0	0	0		0	0	0	229182	0	10	40213160		
5264	442	40229134	2011-05-28	2011-05-28 00:00:00	2011-06-11	2011-06-11 00:00:00	2011-06-11	38000177		0	0	14		0	0	0	29392	0	1043400	40229134		
68770	1505	40213296	1996-12-28	1996-12-28 00:00:00	1996-12-28	1996-12-28 00:00:00	1996-12-28	581452		0	0	0		0	0	0	100334	0	52	40213296		
33626	2782	19129655	1964-01-07	1964-01-07 00:00:00	1964-01-28	1964-01-28 00:00:00	1964-01-28	38000177		0	0	21		0	0	0	184407	0	789980	19129655		
17506	1448	1127078	1978-01-01	1978-01-01 00:00:00	1978-01-15	1978-01-15 00:00:00	1978-01-15	38000177		0	0	14		0	0	0	96585	0	282464	1127078		
58607	4867	1127433	1948-01-20	1948-01-20 00:00:00	1948-02-03	1948-02-03 00:00:00	1948-02-03	38000177		0	0	14		0	0	0	323707	0	313782	1127433		
795	64	19128022	1989-10-14	1989-10-14 00:00:00	1990-10-09	1990-10-09 00:00:00	1990-10-09	38000177		0	0	360		0	0	0	4325	0	749785	19128022		
10999	917	1127433	2004-01-19	2004-01-19 00:00:00	2004-02-02	2004-02-02 00:00:00	2004-02-02	38000177		0	0	14		0	0	0	60941	0	313782	1127433		
16078	1333	19078461	2002-05-18	2002-05-18 00:00:00	2002-06-24	2002-06-24 00:00:00	2002-06-24	38000177		0	0	37		0	0	0	88417	0	310965	19078461		
8511	709	1713671	1993-03-08	1993-03-08 00:00:00	1993-03-29	1993-03-29 00:00:00	1993-03-29	38000177		0	0	21		0	0	0	46926	0	562251	1713671		
29972	2483	19059056	1945-03-29	1945-03-29 00:00:00	1945-04-12	1945-04-12 00:00:00	1945-04-12	38000177		0	0	14		0	0	0	164526	0	243670	19059056		
22431	1844	1127433	1996-02-08	1996-02-08 00:00:00	1996-02-22	1996-02-22 00:00:00	1996-02-22	38000177		0	0	14		0	0	0	123248	0	313782	1127433		
54701	4544	19126352	1989-10-24	1989-10-24 00:00:00	1994-02-01	1994-02-01 00:00:00	1994-02-01	38000177		0	0	1561		0	0	0	302666	0	705129	19126352		
40574	3363	19133873	1963-03-31	1963-03-31 00:00:00	1963-04-12	1963-04-12 00:00:00	1963-04-12	38000177		0	0	12		0	0	0	222942	0	834061	19133873		
32549	2699	1127433	2013-09-05	2013-09-05 00:00:00	2013-09-19	2013-09-19 00:00:00	2013-09-19	38000177		0	0	14		0	0	0	178755	0	313782	1127433		
36156	2980	19019979	1974-06-06	1974-06-06 00:00:00	1974-06-20	1974-06-20 00:00:00	1974-06-20	38000177		0	0	14		0	0	0	198995	0	198405	19019979		
5801	484	19133905	2001-11-07	2001-11-07 00:00:00	2001-11-17	2001-11-17 00:00:00	2001-11-17	38000177		0	0	10		0	0	0	32317	0	834102	19133905		
8528	183	40213296	2016-11-03	2016-11-03 00:00:00	2016-11-03	2016-11-03 00:00:00	2016-11-03	581452		0	0	0		0	0	0	12389	0	52	40213296		
42905	3556	1127433	2000-08-22	2000-08-22 00:00:00	2000-08-29	2000-08-29 00:00:00	2000-08-29	38000177		0	0	7		0	0	0	236120	0	313782	1127433		
47958	3976	19133905	1988-10-27	1988-10-27 00:00:00	1988-11-03	1988-11-03 00:00:00	1988-11-03	38000177		0	0	7		0	0	0	264327	0	834102	19133905		
34123	2821	1127433	1960-12-14	1960-12-14 00:00:00	1960-12-21	1960-12-21 00:00:00	1960-12-21	38000177		0	0	7		0	0	0	186860	0	313782	1127433		
26940	2222	19126352	2012-07-24	2012-07-24 00:00:00	2012-07-24	2012-07-24 00:00:00	\N	38000177		0	0	0		0	0	0	147899	0	705129	19126352		
87032	1908	40213296	2012-08-26	2012-08-26 00:00:00	2012-08-26	2012-08-26 00:00:00	2012-08-26	581452		0	0	0		0	0	0	126982	0	52	40213296		
153482	3378	40213260	2007-07-21	2007-07-21 00:00:00	2007-07-21	2007-07-21 00:00:00	2007-07-21	581452		0	0	0		0	0	0	224160	0	121	40213260		
53915	4480	1713671	1963-09-23	1963-09-23 00:00:00	1963-10-14	1963-10-14 00:00:00	1963-10-14	38000177		0	0	21		0	0	0	298121	0	562251	1713671		
9967	836	19073183	1979-12-10	1979-12-10 00:00:00	1979-12-24	1979-12-24 00:00:00	1979-12-24	38000177		0	0	14		0	0	0	55329	0	308182	19073183		
98467	2156	40213306	1986-11-20	1986-11-20 00:00:00	1986-11-20	1986-11-20 00:00:00	1986-11-20	581452		0	0	0		0	0	0	143694	0	43	40213306		
15061	1258	1118084	2003-11-14	2003-11-14 00:00:00	2003-11-14	2003-11-14 00:00:00	\N	38000177		0	0	0		0	0	0	82912	0	00025152531	44923712		
110102	2419	40213198	2010-04-09	2010-04-09 00:00:00	2010-04-09	2010-04-09 00:00:00	2010-04-09	581452		0	0	0		0	0	0	160531	0	133	40213198		
3013	245	1127433	1991-04-10	1991-04-10 00:00:00	1991-04-17	1991-04-17 00:00:00	1991-04-17	38000177		0	0	7		0	0	0	16480	0	313782	1127433		
120580	2651	40213227	1998-06-24	1998-06-24 00:00:00	1998-06-24	1998-06-24 00:00:00	1998-06-24	581452		0	0	0		0	0	0	175408	0	113	40213227		
19538	1608	19078461	1982-04-06	1982-04-06 00:00:00	1982-04-20	1982-04-20 00:00:00	1982-04-20	38000177		0	0	14		0	0	0	107983	0	310965	19078461		
166229	3654	40213160	1972-03-10	1972-03-10 00:00:00	1972-03-10	1972-03-10 00:00:00	1972-03-10	581452		0	0	0		0	0	0	243227	0	10	40213160		
18307	1516	19059056	1961-08-07	1961-08-07 00:00:00	1961-08-21	1961-08-21 00:00:00	1961-08-21	38000177		0	0	14		0	0	0	101266	0	243670	19059056		
139087	3056	40213260	2007-04-27	2007-04-27 00:00:00	2007-04-27	2007-04-27 00:00:00	2007-04-27	581452		0	0	0		0	0	0	203328	0	121	40213260		
43474	3604	19133873	1984-08-05	1984-08-05 00:00:00	1984-08-18	1984-08-18 00:00:00	1984-08-18	38000177		0	0	13		0	0	0	239539	0	834061	19133873		
63715	5295	19078461	1995-04-13	1995-04-13 00:00:00	1995-04-27	1995-04-27 00:00:00	1995-04-27	38000177		0	0	14		0	0	0	352213	0	310965	19078461		
54011	4487	19059056	1965-05-03	1965-05-03 00:00:00	1965-05-24	1965-05-24 00:00:00	1965-05-24	38000177		0	0	21		0	0	0	298683	0	243670	19059056		
2413	192	1127433	1987-02-04	1987-02-04 00:00:00	1987-03-04	1987-03-04 00:00:00	1987-03-04	38000177		0	0	28		0	0	0	13218	0	313782	1127433		
88170	1934	40213306	1982-04-03	1982-04-03 00:00:00	1982-04-03	1982-04-03 00:00:00	1982-04-03	581452		0	0	0		0	0	0	128662	0	43	40213306		
59230	4923	1127433	1984-07-16	1984-07-16 00:00:00	1984-08-13	1984-08-13 00:00:00	1984-08-13	38000177		0	0	28		0	0	0	327125	0	313782	1127433		
39632	3278	19059056	1970-07-25	1970-07-25 00:00:00	1970-08-08	1970-08-08 00:00:00	1970-08-08	38000177		0	0	14		0	0	0	217744	0	243670	19059056		
103800	2277	40213227	1997-01-12	1997-01-12 00:00:00	1997-01-12	1997-01-12 00:00:00	1997-01-12	581452		0	0	0		0	0	0	151376	0	113	40213227		
60314	5015	1127433	1991-02-06	1991-02-06 00:00:00	1991-02-13	1991-02-13 00:00:00	1991-02-13	38000177		0	0	7		0	0	0	333382	0	313782	1127433		
60208	5004	19008572	1990-12-05	1990-12-05 00:00:00	1990-12-19	1990-12-19 00:00:00	1990-12-19	38000177		0	0	14		0	0	0	332875	0	106258	19008572		
45585	3773	1127433	1981-01-22	1981-01-22 00:00:00	1981-02-21	1981-02-21 00:00:00	1981-02-21	38000177		0	0	30		0	0	0	250813	0	313782	1127433		
143760	3159	40213260	2009-08-27	2009-08-27 00:00:00	2009-08-27	2009-08-27 00:00:00	2009-08-27	581452		0	0	0		0	0	0	210071	0	121	40213260		
51883	4312	1115171	1999-04-10	1999-04-10 00:00:00	1999-05-01	1999-05-01 00:00:00	1999-05-01	38000177		0	0	21		0	0	0	286125	0	849574	1115171		
25998	2138	1127433	2002-02-14	2002-02-14 00:00:00	2002-02-28	2002-02-28 00:00:00	2002-02-28	38000177		0	0	14		0	0	0	142380	0	313782	1127433		
62428	5196	19133873	1958-01-11	1958-01-11 00:00:00	1958-01-19	1958-01-19 00:00:00	1958-01-19	38000177		0	0	8		0	0	0	345511	0	834061	19133873		
3822	318	1127078	1962-04-08	1962-04-08 00:00:00	1962-04-29	1962-04-29 00:00:00	1962-04-29	38000177		0	0	21		0	0	0	21115	0	282464	1127078		
20135	1655	40229134	1990-11-03	1990-11-03 00:00:00	1990-11-10	1990-11-10 00:00:00	1990-11-10	38000177		0	0	7		0	0	0	111029	0	1043400	40229134		
48168	1054	40213201	1999-07-30	1999-07-30 00:00:00	1999-07-30	1999-07-30 00:00:00	1999-07-30	581452		0	0	0		0	0	0	69106	0	33	40213201		
204824	4496	40213227	1998-06-11	1998-06-11 00:00:00	1998-06-11	1998-06-11 00:00:00	1998-06-11	581452		0	0	0		0	0	0	299296	0	113	40213227		
19016	1569	1713671	1979-04-03	1979-04-03 00:00:00	1979-04-10	1979-04-10 00:00:00	1979-04-10	38000177		0	0	7		0	0	0	105293	0	562251	1713671		
1341	105	19126352	2000-06-09	2000-06-09 00:00:00	2005-11-11	2005-11-11 00:00:00	2005-11-11	38000177		0	0	1981		0	0	0	7109	0	705129	19126352		
35296	2909	19059056	1967-01-15	1967-01-15 00:00:00	1967-02-19	1967-02-19 00:00:00	1967-02-19	38000177		0	0	35		0	0	0	193911	0	243670	19059056		
217415	4771	40213160	1955-07-30	1955-07-30 00:00:00	1955-07-30	1955-07-30 00:00:00	1955-07-30	581452		0	0	0		0	0	0	317750	0	10	40213160		
27911	2309	19078461	2005-07-22	2005-07-22 00:00:00	2005-08-12	2005-08-12 00:00:00	2005-08-12	38000177		0	0	21		0	0	0	153634	0	310965	19078461		
40175	3325	19059056	1965-05-07	1965-05-07 00:00:00	1965-06-11	1965-06-11 00:00:00	1965-06-11	38000177		0	0	35		0	0	0	220695	0	243670	19059056		
12132	1017	46233710	1976-10-25	1976-10-25 00:00:00	1976-11-08	1976-11-08 00:00:00	1976-11-08	38000177		0	0	14		0	0	0	66982	0	1650142	46233710		
239728	5262	40213160	1975-12-14	1975-12-14 00:00:00	1975-12-14	1975-12-14 00:00:00	1975-12-14	581452		0	0	0		0	0	0	350135	0	10	40213160		
38571	3184	1127433	1989-07-27	1989-07-27 00:00:00	1989-08-10	1989-08-10 00:00:00	1989-08-10	38000177		0	0	14		0	0	0	211998	0	313782	1127433		
20811	452	40213306	1985-05-17	1985-05-17 00:00:00	1985-05-17	1985-05-17 00:00:00	1985-05-17	581452		0	0	0		0	0	0	30142	0	43	40213306		
156983	3454	40213314	1983-08-15	1983-08-15 00:00:00	1983-08-15	1983-08-15 00:00:00	1983-08-15	581452		0	0	0		0	0	0	229178	0	49	40213314		
5265	442	40232448	1980-09-11	1980-09-11 00:00:00	1980-09-11	1980-09-11 00:00:00	\N	38000177		0	0	0		0	0	0	29313	0	1049630	40232448		
68772	1505	40213227	2005-01-22	2005-01-22 00:00:00	2005-01-22	2005-01-22 00:00:00	2005-01-22	581452		0	0	0		0	0	0	100329	0	113	40213227		
33627	2782	19059056	1964-01-07	1964-01-07 00:00:00	1964-01-28	1964-01-28 00:00:00	1964-01-28	38000177		0	0	21		0	0	0	184407	0	243670	19059056		
17507	1448	19128022	1994-02-16	1994-02-16 00:00:00	1995-02-11	1995-02-11 00:00:00	1995-02-11	38000177		0	0	360		0	0	0	96606	0	749785	19128022		
58608	4867	1713671	1927-02-07	1927-02-07 00:00:00	1927-02-28	1927-02-28 00:00:00	1927-02-28	38000177		0	0	21		0	0	0	323675	0	562251	1713671		
796	64	1127433	2003-10-05	2003-10-05 00:00:00	2003-10-26	2003-10-26 00:00:00	2003-10-26	38000177		0	0	21		0	0	0	4330	0	313782	1127433		
11000	917	1127078	1965-05-05	1965-05-05 00:00:00	1965-05-19	1965-05-19 00:00:00	1965-05-19	38000177		0	0	14		0	0	0	60929	0	282464	1127078		
16079	1333	19133873	1969-04-02	1969-04-02 00:00:00	1969-04-09	1969-04-09 00:00:00	1969-04-09	38000177		0	0	7		0	0	0	88441	0	834061	19133873		
8512	709	19133905	1967-11-09	1967-11-09 00:00:00	1967-11-22	1967-11-22 00:00:00	1967-11-22	38000177		0	0	13		0	0	0	46924	0	834102	19133905		
29973	2483	19006318	1945-03-29	1945-03-29 00:00:00	1945-04-12	1945-04-12 00:00:00	1945-04-12	38000177		0	0	14		0	0	0	164526	0	105078	19006318		
22432	1844	1127433	1994-10-31	1994-10-31 00:00:00	1994-11-14	1994-11-14 00:00:00	1994-11-14	38000177		0	0	14		0	0	0	123161	0	313782	1127433		
54702	4544	1127433	1949-06-20	1949-06-20 00:00:00	1949-07-04	1949-07-04 00:00:00	1949-07-04	38000177		0	0	14		0	0	0	302680	0	313782	1127433		
40575	3364	1118084	2009-02-01	2009-02-01 00:00:00	2009-02-01	2009-02-01 00:00:00	\N	38000177		0	0	0		0	0	0	223048	0	00025152531	44923712		
32550	2699	1127078	1978-07-13	1978-07-13 00:00:00	1978-08-17	1978-08-17 00:00:00	1978-08-17	38000177		0	0	35		0	0	0	178711	0	282464	1127078		
36157	2980	40229134	1983-05-22	1983-05-22 00:00:00	1983-05-29	1983-05-29 00:00:00	1983-05-29	38000177		0	0	7		0	0	0	199000	0	1043400	40229134		
5802	484	19059056	1943-04-08	1943-04-08 00:00:00	1943-04-22	1943-04-22 00:00:00	1943-04-22	38000177		0	0	14		0	0	0	32314	0	243670	19059056		
8538	184	40213227	1997-02-03	1997-02-03 00:00:00	1997-02-03	1997-02-03 00:00:00	1997-02-03	581452		0	0	0		0	0	0	12469	0	113	40213227		
837	67	40229134	1992-08-09	1992-08-09 00:00:00	1992-08-23	1992-08-23 00:00:00	1992-08-23	38000177		0	0	14		0	0	0	4525	0	1043400	40229134		
47959	3976	1118084	2007-09-24	2007-09-24 00:00:00	2007-09-24	2007-09-24 00:00:00	\N	38000177		0	0	0		0	0	0	264358	0	00025152531	44923712		
34124	2821	40223768	2001-11-13	2001-11-13 00:00:00	2001-11-13	2001-11-13 00:00:00	\N	38000177		0	0	0		0	0	0	186944	0	997223	40223768		
26941	2222	1332419	2012-07-24	2012-07-24 00:00:00	2012-07-24	2012-07-24 00:00:00	\N	38000177		0	0	0		0	0	0	147899	0	197361	1332419		
87033	1908	40213227	1992-11-08	1992-11-08 00:00:00	1992-11-08	1992-11-08 00:00:00	1992-11-08	581452		0	0	0		0	0	0	126967	0	113	40213227		
97706	2141	40213227	2018-03-05	2018-03-05 00:00:00	2018-03-05	2018-03-05 00:00:00	2018-03-05	581452		0	0	0		0	0	0	142610	0	113	40213227		
53916	4480	1127433	1979-06-10	1979-06-10 00:00:00	1979-07-01	1979-07-01 00:00:00	1979-07-01	38000177		0	0	21		0	0	0	298185	0	313782	1127433		
9968	836	1118084	2016-11-07	2016-11-07 00:00:00	2016-11-07	2016-11-07 00:00:00	\N	38000177		0	0	0		0	0	0	55351	0	00025152531	44923712		
98470	2156	40213160	1965-04-01	1965-04-01 00:00:00	1965-04-01	1965-04-01 00:00:00	1965-04-01	581452		0	0	0		0	0	0	143716	0	10	40213160		
15062	1258	1127433	1970-05-28	1970-05-28 00:00:00	1970-06-11	1970-06-11 00:00:00	1970-06-11	38000177		0	0	14		0	0	0	82902	0	313782	1127433		
110113	2419	40213227	1995-10-27	1995-10-27 00:00:00	1995-10-27	1995-10-27 00:00:00	1995-10-27	581452		0	0	0		0	0	0	160640	0	113	40213227		
3014	245	1118084	1954-06-24	1954-06-24 00:00:00	1954-06-24	1954-06-24 00:00:00	\N	38000177		0	0	0		0	0	0	16476	0	00025152531	44923712		
120587	2651	40213227	2018-06-20	2018-06-20 00:00:00	2018-06-20	2018-06-20 00:00:00	2018-06-20	581452		0	0	0		0	0	0	175403	0	113	40213227		
19539	1608	1127433	1950-01-17	1950-01-17 00:00:00	1950-01-31	1950-01-31 00:00:00	1950-01-31	38000177		0	0	14		0	0	0	107985	0	313782	1127433		
166230	3654	40213160	1971-10-09	1971-10-09 00:00:00	1971-10-09	1971-10-09 00:00:00	1971-10-09	581452		0	0	0		0	0	0	243205	0	10	40213160		
18308	1516	19059056	1968-10-18	1968-10-18 00:00:00	1968-11-08	1968-11-08 00:00:00	1968-11-08	38000177		0	0	21		0	0	0	101269	0	243670	19059056		
139100	3056	40213296	2000-04-07	2000-04-07 00:00:00	2000-04-07	2000-04-07 00:00:00	2000-04-07	581452		0	0	0		0	0	0	203218	0	52	40213296		
43475	3604	19112599	1984-12-12	1984-12-12 00:00:00	1984-12-12	1984-12-12 00:00:00	\N	38000177		0	0	0		0	0	0	239520	0	477045	19112599		
63716	5295	1713671	1993-05-20	1993-05-20 00:00:00	1993-06-03	1993-06-03 00:00:00	1993-06-03	38000177		0	0	14		0	0	0	352216	0	562251	1713671		
54012	4487	1127433	1987-09-11	1987-09-11 00:00:00	1987-09-18	1987-09-18 00:00:00	1987-09-18	38000177		0	0	7		0	0	0	298715	0	313782	1127433		
2414	192	1713671	1991-08-12	1991-08-12 00:00:00	1991-08-19	1991-08-19 00:00:00	1991-08-19	38000177		0	0	7		0	0	0	13232	0	562251	1713671		
88171	1934	40213296	2002-02-09	2002-02-09 00:00:00	2002-02-09	2002-02-09 00:00:00	2002-02-09	581452		0	0	0		0	0	0	128668	0	52	40213296		
59231	4923	1127433	1980-11-18	1980-11-18 00:00:00	1980-11-25	1980-11-25 00:00:00	1980-11-25	38000177		0	0	7		0	0	0	327135	0	313782	1127433		
30652	2542	1127433	2001-06-15	2001-06-15 00:00:00	2001-06-22	2001-06-22 00:00:00	2001-06-22	38000177		0	0	7		0	0	0	168113	0	313782	1127433		
53922	1180	40213227	2007-12-12	2007-12-12 00:00:00	2007-12-12	2007-12-12 00:00:00	2007-12-12	581452		0	0	0		0	0	0	77929	0	113	40213227		
60315	5015	19078461	2002-05-19	2002-05-19 00:00:00	2002-06-09	2002-06-09 00:00:00	2002-06-09	38000177		0	0	21		0	0	0	333377	0	310965	19078461		
60209	5004	1118084	2012-08-21	2012-08-21 00:00:00	2012-08-21	2012-08-21 00:00:00	\N	38000177		0	0	0		0	0	0	332812	0	00025152531	44923712		
45586	3773	1124300	1996-10-09	1996-10-09 00:00:00	1996-10-09	1996-10-09 00:00:00	\N	38000177		0	0	0		0	0	0	250797	0	00781178901	45011828		
143766	3159	40213160	1959-12-03	1959-12-03 00:00:00	1959-12-03	1959-12-03 00:00:00	1959-12-03	581452		0	0	0		0	0	0	210058	0	10	40213160		
51884	4313	1118084	1980-01-27	1980-01-27 00:00:00	1980-01-27	1980-01-27 00:00:00	\N	38000177		0	0	0		0	0	0	286227	0	00025152531	44923712		
25999	2138	19073188	2002-02-14	2002-02-14 00:00:00	2002-02-28	2002-02-28 00:00:00	2002-02-28	38000177		0	0	14		0	0	0	142380	0	308192	19073188		
62429	5196	1713671	1952-07-07	1952-07-07 00:00:00	1952-07-14	1952-07-14 00:00:00	1952-07-14	38000177		0	0	7		0	0	0	345563	0	562251	1713671		
3823	318	40231925	2011-02-11	2011-02-11 00:00:00	2011-02-11	2011-02-11 00:00:00	\N	38000177		0	0	0		0	0	0	21116	0	1049221	40231925		
20136	1655	1713671	1994-04-22	1994-04-22 00:00:00	1994-05-06	1994-05-06 00:00:00	1994-05-06	38000177		0	0	14		0	0	0	111030	0	562251	1713671		
48170	1054	40213227	2004-08-27	2004-08-27 00:00:00	2004-08-27	2004-08-27 00:00:00	2004-08-27	581452		0	0	0		0	0	0	69168	0	113	40213227		
204826	4496	40213201	2013-05-16	2013-05-16 00:00:00	2013-05-16	2013-05-16 00:00:00	2013-05-16	581452		0	0	0		0	0	0	299269	0	33	40213201		
19017	1569	19078461	2018-01-28	2018-01-28 00:00:00	2018-02-18	2018-02-18 00:00:00	2018-02-18	38000177		0	0	21		0	0	0	105231	0	310965	19078461		
1342	105	1332419	2000-06-09	2000-06-09 00:00:00	2000-06-09	2000-06-09 00:00:00	\N	38000177		0	0	0		0	0	0	7109	0	197361	1332419		
35297	2909	19133905	1997-02-08	1997-02-08 00:00:00	1997-02-20	1997-02-20 00:00:00	1997-02-20	38000177		0	0	12		0	0	0	193846	0	834102	19133905		
172296	3787	40213160	1962-07-21	1962-07-21 00:00:00	1962-07-21	1962-07-21 00:00:00	1962-07-21	581452		0	0	0		0	0	0	251792	0	10	40213160		
27912	2309	1713671	1986-10-25	1986-10-25 00:00:00	1986-11-01	1986-11-01 00:00:00	1986-11-01	38000177		0	0	7		0	0	0	153614	0	562251	1713671		
40176	3325	1713671	1975-08-17	1975-08-17 00:00:00	1975-09-07	1975-09-07 00:00:00	1975-09-07	38000177		0	0	21		0	0	0	220693	0	562251	1713671		
12134	1017	19074679	1970-11-15	1970-11-15 00:00:00	1971-06-13	1971-06-13 00:00:00	1971-06-13	38000177		0	0	210		0	0	0	66995	0	308971	19074679		
239731	5262	40213227	2002-03-17	2002-03-17 00:00:00	2002-03-17	2002-03-17 00:00:00	2002-03-17	581452		0	0	0		0	0	0	350118	0	113	40213227		
38572	3184	1713671	2004-04-28	2004-04-28 00:00:00	2004-05-19	2004-05-19 00:00:00	2004-05-19	38000177		0	0	21		0	0	0	212000	0	562251	1713671		
20813	452	40213260	2012-09-07	2012-09-07 00:00:00	2012-09-07	2012-09-07 00:00:00	2012-09-07	581452		0	0	0		0	0	0	30146	0	121	40213260		
168262	3699	40213160	1972-03-23	1972-03-23 00:00:00	1972-03-23	1972-03-23 00:00:00	1972-03-23	581452		0	0	0		0	0	0	245915	0	10	40213160		
5266	442	1127433	1964-02-27	1964-02-27 00:00:00	1964-03-12	1964-03-12 00:00:00	1964-03-12	38000177		0	0	14		0	0	0	29311	0	313782	1127433		
68778	1505	40213160	1955-08-13	1955-08-13 00:00:00	1955-08-13	1955-08-13 00:00:00	1955-08-13	581452		0	0	0		0	0	0	100391	0	10	40213160		
33628	2782	1713671	1989-07-25	1989-07-25 00:00:00	1989-08-15	1989-08-15 00:00:00	1989-08-15	38000177		0	0	21		0	0	0	184437	0	562251	1713671		
17508	1448	19133873	1981-05-19	1981-05-19 00:00:00	1981-05-29	1981-05-29 00:00:00	1981-05-29	38000177		0	0	10		0	0	0	96569	0	834061	19133873		
58609	4867	1127433	2011-07-03	2011-07-03 00:00:00	2011-07-10	2011-07-10 00:00:00	2011-07-10	38000177		0	0	7		0	0	0	323671	0	313782	1127433		
797	64	1115171	2012-04-11	2012-04-11 00:00:00	2012-05-09	2012-05-09 00:00:00	2012-05-09	38000177		0	0	28		0	0	0	4328	0	849574	1115171		
11001	917	19129655	1965-05-05	1965-05-05 00:00:00	1965-05-19	1965-05-19 00:00:00	1965-05-19	38000177		0	0	14		0	0	0	60929	0	789980	19129655		
16080	1333	19078461	2013-05-27	2013-05-27 00:00:00	2013-06-17	2013-06-17 00:00:00	2013-06-17	38000177		0	0	21		0	0	0	88418	0	310965	19078461		
8513	710	19129655	1962-11-21	1962-11-21 00:00:00	1962-12-05	1962-12-05 00:00:00	1962-12-05	38000177		0	0	14		0	0	0	47006	0	789980	19129655		
29974	2483	1118084	1984-08-11	1984-08-11 00:00:00	1984-08-11	1984-08-11 00:00:00	\N	38000177		0	0	0		0	0	0	164509	0	00025152531	44923712		
22434	1844	19133905	1979-10-27	1979-10-27 00:00:00	1979-11-06	1979-11-06 00:00:00	1979-11-06	38000177		0	0	10		0	0	0	123155	0	834102	19133905		
54923	4561	1127433	1954-01-22	1954-01-22 00:00:00	1954-02-05	1954-02-05 00:00:00	1954-02-05	38000177		0	0	14		0	0	0	303908	0	313782	1127433		
40576	3364	19133873	1988-01-24	1988-01-24 00:00:00	1988-02-06	1988-02-06 00:00:00	1988-02-06	38000177		0	0	13		0	0	0	223109	0	834061	19133873		
47689	3955	1713671	1957-04-08	1957-04-08 00:00:00	1957-04-15	1957-04-15 00:00:00	1957-04-15	38000177		0	0	7		0	0	0	262825	0	562251	1713671		
36158	2980	1127433	2013-01-03	2013-01-03 00:00:00	2013-01-17	2013-01-17 00:00:00	2013-01-17	38000177		0	0	14		0	0	0	198894	0	313782	1127433		
5803	484	19078461	2011-03-02	2011-03-02 00:00:00	2011-05-31	2011-05-31 00:00:00	2011-05-31	38000177		0	0	90		0	0	0	32402	0	310965	19078461		
8540	184	40213227	2017-08-07	2017-08-07 00:00:00	2017-08-07	2017-08-07 00:00:00	2017-08-07	581452		0	0	0		0	0	0	12460	0	113	40213227		
838	67	19133905	2017-07-12	2017-07-12 00:00:00	2017-07-22	2017-07-22 00:00:00	2017-07-22	38000177		0	0	10		0	0	0	4528	0	834102	19133905		
47960	3976	19059056	1969-01-16	1969-01-16 00:00:00	1969-02-15	1969-02-15 00:00:00	1969-02-15	38000177		0	0	30		0	0	0	264348	0	243670	19059056		
34125	2821	19059056	1961-01-18	1961-01-18 00:00:00	1961-02-08	1961-02-08 00:00:00	1961-02-08	38000177		0	0	21		0	0	0	186850	0	243670	19059056		
26942	2222	1539411	2012-07-24	2012-07-24 00:00:00	2012-07-24	2012-07-24 00:00:00	\N	38000177		0	0	0		0	0	0	147899	0	312961	1539411		
87034	1908	40213306	1992-11-08	1992-11-08 00:00:00	1992-11-08	1992-11-08 00:00:00	1992-11-08	581452		0	0	0		0	0	0	126967	0	43	40213306		
97708	2141	40213227	2008-01-07	2008-01-07 00:00:00	2008-01-07	2008-01-07 00:00:00	2008-01-07	581452		0	0	0		0	0	0	142627	0	113	40213227		
72263	1579	40213160	1955-09-08	1955-09-08 00:00:00	1955-09-08	1955-09-08 00:00:00	1955-09-08	581452		0	0	0		0	0	0	106094	0	10	40213160		
9969	836	19019979	1985-03-30	1985-03-30 00:00:00	1985-04-13	1985-04-13 00:00:00	1985-04-13	38000177		0	0	14		0	0	0	55323	0	198405	19019979		
98472	2156	40213160	1964-12-31	1964-12-31 00:00:00	1964-12-31	1964-12-31 00:00:00	1964-12-31	581452		0	0	0		0	0	0	143705	0	10	40213160		
15063	1258	1127433	2013-10-18	2013-10-18 00:00:00	2013-10-25	2013-10-25 00:00:00	2013-10-25	38000177		0	0	7		0	0	0	82891	0	313782	1127433		
110128	2419	40213201	2011-04-15	2011-04-15 00:00:00	2011-04-15	2011-04-15 00:00:00	2011-04-15	581452		0	0	0		0	0	0	160643	0	33	40213201		
3015	245	1127433	1961-07-08	1961-07-08 00:00:00	1961-07-15	1961-07-15 00:00:00	1961-07-15	38000177		0	0	7		0	0	0	16425	0	313782	1127433		
120602	2651	40213227	2008-08-20	2008-08-20 00:00:00	2008-08-20	2008-08-20 00:00:00	2008-08-20	581452		0	0	0		0	0	0	175461	0	113	40213227		
19540	1608	19133873	1943-08-05	1943-08-05 00:00:00	1943-08-14	1943-08-14 00:00:00	1943-08-14	38000177		0	0	9		0	0	0	108016	0	834061	19133873		
166232	3654	40213227	2003-02-28	2003-02-28 00:00:00	2003-02-28	2003-02-28 00:00:00	2003-02-28	581452		0	0	0		0	0	0	243198	0	113	40213227		
18309	1516	1127433	1988-11-02	1988-11-02 00:00:00	1988-11-09	1988-11-09 00:00:00	1988-11-09	38000177		0	0	7		0	0	0	101262	0	313782	1127433		
139104	3056	40213306	1981-02-27	1981-02-27 00:00:00	1981-02-27	1981-02-27 00:00:00	1981-02-27	581452		0	0	0		0	0	0	203319	0	43	40213306		
43476	3604	1127433	2000-05-06	2000-05-06 00:00:00	2000-05-20	2000-05-20 00:00:00	2000-05-20	38000177		0	0	14		0	0	0	239459	0	313782	1127433		
63717	5295	1127433	1961-09-22	1961-09-22 00:00:00	1961-09-29	1961-09-29 00:00:00	1961-09-29	38000177		0	0	7		0	0	0	352282	0	313782	1127433		
54013	4487	1127433	1984-11-17	1984-11-17 00:00:00	1984-12-01	1984-12-01 00:00:00	1984-12-01	38000177		0	0	14		0	0	0	298691	0	313782	1127433		
2415	192	19073188	2014-04-02	2014-04-02 00:00:00	2014-04-16	2014-04-16 00:00:00	2014-04-16	38000177		0	0	14		0	0	0	13220	0	308192	19073188		
88173	1934	40213227	2002-02-09	2002-02-09 00:00:00	2002-02-09	2002-02-09 00:00:00	2002-02-09	581452		0	0	0		0	0	0	128668	0	113	40213227		
59232	4923	1127433	2014-09-05	2014-09-05 00:00:00	2014-09-19	2014-09-19 00:00:00	2014-09-19	38000177		0	0	14		0	0	0	327127	0	313782	1127433		
30653	2542	1124300	2003-03-07	2003-03-07 00:00:00	2003-03-07	2003-03-07 00:00:00	\N	38000177		0	0	0		0	0	0	168183	0	00781178901	45011828		
53923	1180	40213260	2007-12-12	2007-12-12 00:00:00	2007-12-12	2007-12-12 00:00:00	2007-12-12	581452		0	0	0		0	0	0	77929	0	121	40213260		
60316	5015	19059056	1968-04-05	1968-04-05 00:00:00	1968-04-19	1968-04-19 00:00:00	1968-04-19	38000177		0	0	14		0	0	0	333349	0	243670	19059056		
60210	5004	19075601	1999-05-11	1999-05-11 00:00:00	1999-05-11	1999-05-11 00:00:00	\N	38000177		0	0	0		0	0	0	332808	0	309362	19075601		
45606	3776	19133873	1979-12-29	1979-12-29 00:00:00	1980-01-05	1980-01-05 00:00:00	1980-01-05	38000177		0	0	7		0	0	0	250983	0	834061	19133873		
143771	3159	40213306	1981-07-16	1981-07-16 00:00:00	1981-07-16	1981-07-16 00:00:00	1981-07-16	581452		0	0	0		0	0	0	210042	0	43	40213306		
51885	4313	1127433	1991-08-28	1991-08-28 00:00:00	1991-09-04	1991-09-04 00:00:00	1991-09-04	38000177		0	0	7		0	0	0	286264	0	313782	1127433		
26000	2138	1127433	1995-03-09	1995-03-09 00:00:00	1995-03-23	1995-03-23 00:00:00	1995-03-23	38000177		0	0	14		0	0	0	142414	0	313782	1127433		
62430	5196	1127433	2006-10-07	2006-10-07 00:00:00	2006-10-14	2006-10-14 00:00:00	2006-10-14	38000177		0	0	7		0	0	0	345521	0	313782	1127433		
3824	318	1115171	2011-02-11	2011-02-11 00:00:00	2011-05-12	2011-05-12 00:00:00	2011-05-12	38000177		0	0	90		0	0	0	21116	0	849574	1115171		
20137	1655	1713671	2016-03-31	2016-03-31 00:00:00	2016-04-14	2016-04-14 00:00:00	2016-04-14	38000177		0	0	14		0	0	0	111033	0	562251	1713671		
48178	1054	40213227	1994-01-21	1994-01-21 00:00:00	1994-01-21	1994-01-21 00:00:00	1994-01-21	581452		0	0	0		0	0	0	69156	0	113	40213227		
204836	4496	40213227	2008-08-07	2008-08-07 00:00:00	2008-08-07	2008-08-07 00:00:00	2008-08-07	581452		0	0	0		0	0	0	299284	0	113	40213227		
19026	1571	1127433	1995-01-25	1995-01-25 00:00:00	1995-02-08	1995-02-08 00:00:00	1995-02-08	38000177		0	0	14		0	0	0	105510	0	313782	1127433		
1343	105	1539411	2000-06-09	2000-06-09 00:00:00	2000-06-09	2000-06-09 00:00:00	\N	38000177		0	0	0		0	0	0	7109	0	312961	1539411		
35298	2909	1127433	1954-08-18	1954-08-18 00:00:00	1954-08-25	1954-08-25 00:00:00	1954-08-25	38000177		0	0	7		0	0	0	193869	0	313782	1127433		
172299	3788	40213227	2015-08-18	2015-08-18 00:00:00	2015-08-18	2015-08-18 00:00:00	2015-08-18	581452		0	0	0		0	0	0	251814	0	113	40213227		
27913	2309	19078461	1986-02-04	1986-02-04 00:00:00	1986-04-05	1986-04-05 00:00:00	1986-04-05	38000177		0	0	60		0	0	0	153631	0	310965	19078461		
40177	3325	19133873	1981-03-24	1981-03-24 00:00:00	1981-04-03	1981-04-03 00:00:00	1981-04-03	38000177		0	0	10		0	0	0	220713	0	834061	19133873		
12135	1017	19006318	1960-01-06	1960-01-06 00:00:00	1960-01-20	1960-01-20 00:00:00	1960-01-20	38000177		0	0	14		0	0	0	66933	0	105078	19006318		
239738	5262	40213227	2012-09-02	2012-09-02 00:00:00	2012-09-02	2012-09-02 00:00:00	2012-09-02	581452		0	0	0		0	0	0	350141	0	113	40213227		
38573	3184	1127433	2004-01-14	2004-01-14 00:00:00	2004-01-28	2004-01-28 00:00:00	2004-01-28	38000177		0	0	14		0	0	0	212008	0	313782	1127433		
20820	453	40213227	1993-05-07	1993-05-07 00:00:00	1993-05-07	1993-05-07 00:00:00	1993-05-07	581452		0	0	0		0	0	0	30213	0	113	40213227		
162966	3583	40213260	2019-04-30	2019-04-30 00:00:00	2019-04-30	2019-04-30 00:00:00	2019-04-30	581452		0	0	0		0	0	0	238215	0	121	40213260		
5267	442	1127078	1951-06-03	1951-06-03 00:00:00	1951-07-01	1951-07-01 00:00:00	1951-07-01	38000177		0	0	28		0	0	0	29285	0	282464	1127078		
68780	1505	40213260	2006-01-28	2006-01-28 00:00:00	2006-01-28	2006-01-28 00:00:00	2006-01-28	581452		0	0	0		0	0	0	100337	0	121	40213260		
33629	2782	19018935	1977-01-26	1977-01-26 00:00:00	1977-01-26	1977-01-26 00:00:00	\N	38000177		0	0	0		0	0	0	184359	0	197604	19018935		
17509	1448	1118084	2009-03-09	2009-03-09 00:00:00	2009-03-09	2009-03-09 00:00:00	\N	38000177		0	0	0		0	0	0	96604	0	00025152531	44923712		
58610	4867	1713671	1941-10-12	1941-10-12 00:00:00	1941-11-02	1941-11-02 00:00:00	1941-11-02	38000177		0	0	21		0	0	0	323594	0	562251	1713671		
798	64	19019979	1976-06-14	1976-06-14 00:00:00	1976-06-28	1976-06-28 00:00:00	1976-06-28	38000177		0	0	14		0	0	0	4324	0	198405	19019979		
11002	918	19059056	1964-01-13	1964-01-13 00:00:00	1964-02-03	1964-02-03 00:00:00	1964-02-03	38000177		0	0	21		0	0	0	61198	0	243670	19059056		
16081	1333	40229134	2006-02-08	2006-02-08 00:00:00	2006-02-15	2006-02-15 00:00:00	2006-02-15	38000177		0	0	7		0	0	0	88447	0	1043400	40229134		
8514	710	19059056	1962-11-21	1962-11-21 00:00:00	1962-12-05	1962-12-05 00:00:00	1962-12-05	38000177		0	0	14		0	0	0	47006	0	243670	19059056		
29975	2483	19059056	1961-02-17	1961-02-17 00:00:00	1961-03-10	1961-03-10 00:00:00	1961-03-10	38000177		0	0	21		0	0	0	164511	0	243670	19059056		
22435	1844	40169216	1963-04-13	1963-04-13 00:00:00	1963-04-13	1963-04-13 00:00:00	\N	38000177		0	0	0		0	0	0	123132	0	895994	40169216		
54924	4561	19129655	1961-12-29	1961-12-29 00:00:00	1962-01-12	1962-01-12 00:00:00	1962-01-12	38000177		0	0	14		0	0	0	303884	0	789980	19129655		
40577	3364	19019979	1981-10-02	1981-10-02 00:00:00	1981-10-16	1981-10-16 00:00:00	1981-10-16	38000177		0	0	14		0	0	0	223066	0	198405	19019979		
47690	3955	19133905	1996-01-15	1996-01-15 00:00:00	1996-01-22	1996-01-22 00:00:00	1996-01-22	38000177		0	0	7		0	0	0	262869	0	834102	19133905		
36159	2980	1127078	1975-12-10	1975-12-10 00:00:00	1975-12-24	1975-12-24 00:00:00	1975-12-24	38000177		0	0	14		0	0	0	198923	0	282464	1127078		
5804	484	19059056	1939-08-26	1939-08-26 00:00:00	1939-09-09	1939-09-09 00:00:00	1939-09-09	38000177		0	0	14		0	0	0	32367	0	243670	19059056		
8548	184	40213201	2012-07-09	2012-07-09 00:00:00	2012-07-09	2012-07-09 00:00:00	2012-07-09	581452		0	0	0		0	0	0	12494	0	33	40213201		
839	67	1127078	1973-03-06	1973-03-06 00:00:00	1973-03-20	1973-03-20 00:00:00	1973-03-20	38000177		0	0	14		0	0	0	4516	0	282464	1127078		
47961	3976	1127433	1976-07-09	1976-07-09 00:00:00	1976-07-16	1976-07-16 00:00:00	1976-07-16	38000177		0	0	7		0	0	0	264338	0	313782	1127433		
34126	2821	1118084	1959-02-12	1959-02-12 00:00:00	1959-02-12	1959-02-12 00:00:00	\N	38000177		0	0	0		0	0	0	186965	0	00025152531	44923712		
26943	2222	1127433	1973-05-08	1973-05-08 00:00:00	1973-05-15	1973-05-15 00:00:00	1973-05-15	38000177		0	0	7		0	0	0	147929	0	313782	1127433		
87036	1908	40213160	1971-02-14	1971-02-14 00:00:00	1971-02-14	1971-02-14 00:00:00	1971-02-14	581452		0	0	0		0	0	0	127006	0	10	40213160		
97709	2141	40213198	2012-01-30	2012-01-30 00:00:00	2012-01-30	2012-01-30 00:00:00	2012-01-30	581452		0	0	0		0	0	0	142629	0	133	40213198		
72264	1579	40213160	1959-12-10	1959-12-10 00:00:00	1959-12-10	1959-12-10 00:00:00	1959-12-10	581452		0	0	0		0	0	0	106049	0	10	40213160		
9970	836	19078461	1992-03-28	1992-03-28 00:00:00	1992-06-26	1992-06-26 00:00:00	1992-06-26	38000177		0	0	90		0	0	0	55325	0	310965	19078461		
98474	2156	40213160	1969-07-03	1969-07-03 00:00:00	1969-07-03	1969-07-03 00:00:00	1969-07-03	581452		0	0	0		0	0	0	143709	0	10	40213160		
15064	1258	19059056	1982-03-24	1982-03-24 00:00:00	1982-04-23	1982-04-23 00:00:00	1982-04-23	38000177		0	0	30		0	0	0	82847	0	243670	19059056		
110135	2419	40213227	2016-05-13	2016-05-13 00:00:00	2016-05-13	2016-05-13 00:00:00	2016-05-13	581452		0	0	0		0	0	0	160533	0	113	40213227		
3016	245	40173590	2006-07-16	2006-07-16 00:00:00	2006-07-16	2006-07-16 00:00:00	\N	38000177		0	0	0		0	0	0	16382	0	904419	40173590		
140439	3083	40213160	1955-04-10	1955-04-10 00:00:00	1955-04-10	1955-04-10 00:00:00	1955-04-10	581452		0	0	0		0	0	0	205286	0	10	40213160		
19541	1608	1127433	2017-12-05	2017-12-05 00:00:00	2017-12-12	2017-12-12 00:00:00	2017-12-12	38000177		0	0	7		0	0	0	107972	0	313782	1127433		
166238	3654	40213296	2013-07-13	2013-07-13 00:00:00	2013-07-13	2013-07-13 00:00:00	2013-07-13	581452		0	0	0		0	0	0	243215	0	52	40213296		
18310	1516	1713671	1948-10-05	1948-10-05 00:00:00	1948-10-26	1948-10-26 00:00:00	1948-10-26	38000177		0	0	21		0	0	0	101242	0	562251	1713671		
139107	3056	40213227	1998-07-24	1998-07-24 00:00:00	1998-07-24	1998-07-24 00:00:00	1998-07-24	581452		0	0	0		0	0	0	203217	0	113	40213227		
43477	3604	19073183	1984-10-31	1984-10-31 00:00:00	1984-11-14	1984-11-14 00:00:00	1984-11-14	38000177		0	0	14		0	0	0	239553	0	308182	19073183		
63718	5295	1118084	1943-02-08	1943-02-08 00:00:00	1943-02-08	1943-02-08 00:00:00	\N	38000177		0	0	0		0	0	0	352323	0	00025152531	44923712		
54014	4487	19059056	1968-06-07	1968-06-07 00:00:00	1968-06-28	1968-06-28 00:00:00	1968-06-28	38000177		0	0	21		0	0	0	298684	0	243670	19059056		
2416	192	1127433	2014-04-02	2014-04-02 00:00:00	2014-04-16	2014-04-16 00:00:00	2014-04-16	38000177		0	0	14		0	0	0	13220	0	313782	1127433		
57484	4771	920334	1981-04-01	1981-04-01 00:00:00	1981-04-08	1981-04-08 00:00:00	1981-04-08	38000177		0	0	7		0	0	0	317765	0	311995	920334		
59233	4923	19133873	1969-01-10	1969-01-10 00:00:00	1969-01-20	1969-01-20 00:00:00	1969-01-20	38000177		0	0	10		0	0	0	327096	0	834061	19133873		
30654	2542	19008572	1986-06-07	1986-06-07 00:00:00	1986-06-07	1986-06-07 00:00:00	\N	38000177		0	0	0		0	0	0	168107	0	106258	19008572		
53934	1180	40213296	1997-11-12	1997-11-12 00:00:00	1997-11-12	1997-11-12 00:00:00	1997-11-12	581452		0	0	0		0	0	0	77927	0	52	40213296		
60317	5015	46233988	1968-04-05	1968-04-05 00:00:00	1968-04-19	1968-04-19 00:00:00	1968-04-19	38000177		0	0	14		0	0	0	333349	0	1652673	46233988		
60211	5004	19126352	1995-05-02	1995-05-02 00:00:00	1995-05-02	1995-05-02 00:00:00	\N	38000177		0	0	0		0	0	0	332881	0	705129	19126352		
45607	3776	40162522	2010-11-27	2010-11-27 00:00:00	2010-11-27	2010-11-27 00:00:00	\N	38000177		0	0	0		0	0	0	250955	0	857005	40162522		
208713	4578	40213227	2015-05-31	2015-05-31 00:00:00	2015-05-31	2015-05-31 00:00:00	2015-05-31	581452		0	0	0		0	0	0	305000	0	113	40213227		
51886	4313	1127433	2006-02-18	2006-02-18 00:00:00	2006-02-25	2006-02-25 00:00:00	2006-02-25	38000177		0	0	7		0	0	0	286298	0	313782	1127433		
26005	2140	1127433	1964-12-25	1964-12-25 00:00:00	1965-01-01	1965-01-01 00:00:00	1965-01-01	38000177		0	0	7		0	0	0	142504	0	313782	1127433		
62431	5196	1127433	1995-05-16	1995-05-16 00:00:00	1995-05-23	1995-05-23 00:00:00	1995-05-23	38000177		0	0	7		0	0	0	345545	0	313782	1127433		
11622	249	40213227	2014-02-01	2014-02-01 00:00:00	2014-02-01	2014-02-01 00:00:00	2014-02-01	581452		0	0	0		0	0	0	16737	0	113	40213227		
20138	1655	19133873	1974-04-28	1974-04-28 00:00:00	1974-05-11	1974-05-11 00:00:00	1974-05-11	38000177		0	0	13		0	0	0	111005	0	834061	19133873		
11691	972	19059056	1968-07-03	1968-07-03 00:00:00	1968-07-17	1968-07-17 00:00:00	1968-07-17	38000177		0	0	14		0	0	0	64715	0	243670	19059056		
159604	3513	40213160	1976-10-24	1976-10-24 00:00:00	1976-10-24	1976-10-24 00:00:00	1976-10-24	581452		0	0	0		0	0	0	233112	0	10	40213160		
19027	1571	19078461	2001-03-27	2001-03-27 00:00:00	2001-04-10	2001-04-10 00:00:00	2001-04-10	38000177		0	0	14		0	0	0	105507	0	310965	19078461		
1344	105	1127433	1979-07-28	1979-07-28 00:00:00	1979-08-11	1979-08-11 00:00:00	1979-08-11	38000177		0	0	14		0	0	0	7144	0	313782	1127433		
23329	1923	1713671	2011-08-09	2011-08-09 00:00:00	2011-08-23	2011-08-23 00:00:00	2011-08-23	38000177		0	0	14		0	0	0	127923	0	562251	1713671		
172300	3788	40213296	2004-08-17	2004-08-17 00:00:00	2004-08-17	2004-08-17 00:00:00	2004-08-17	581452		0	0	0		0	0	0	251809	0	52	40213296		
27914	2309	40165015	1986-02-04	1986-02-04 00:00:00	1986-02-04	1986-02-04 00:00:00	\N	38000177		0	0	0		0	0	0	153631	0	861467	40165015		
40178	3325	19129655	1964-05-12	1964-05-12 00:00:00	1964-05-26	1964-05-26 00:00:00	1964-05-26	38000177		0	0	14		0	0	0	220725	0	789980	19129655		
12136	1017	19059056	1960-01-06	1960-01-06 00:00:00	1960-01-20	1960-01-20 00:00:00	1960-01-20	38000177		0	0	14		0	0	0	66933	0	243670	19059056		
239739	5262	40213296	2012-09-02	2012-09-02 00:00:00	2012-09-02	2012-09-02 00:00:00	2012-09-02	581452		0	0	0		0	0	0	350141	0	52	40213296		
38574	3184	19073188	2004-01-14	2004-01-14 00:00:00	2004-01-28	2004-01-28 00:00:00	2004-01-28	38000177		0	0	14		0	0	0	212008	0	308192	19073188		
20821	453	40213306	1993-05-07	1993-05-07 00:00:00	1993-05-07	1993-05-07 00:00:00	1993-05-07	581452		0	0	0		0	0	0	30213	0	43	40213306		
162968	3583	40213306	1991-02-12	1991-02-12 00:00:00	1991-02-12	1991-02-12 00:00:00	1991-02-12	581452		0	0	0		0	0	0	238211	0	43	40213306		
5268	442	19078461	2010-02-24	2010-02-24 00:00:00	2010-03-24	2010-03-24 00:00:00	2010-03-24	38000177		0	0	28		0	0	0	29289	0	310965	19078461		
54167	4501	19133873	1986-05-09	1986-05-09 00:00:00	1986-05-22	1986-05-22 00:00:00	1986-05-22	38000177		0	0	13		0	0	0	299710	0	834061	19133873		
33630	2782	40163554	1977-01-26	1977-01-26 00:00:00	1977-01-26	1977-01-26 00:00:00	\N	38000177		0	0	0		0	0	0	184359	0	855332	40163554		
17510	1448	19006318	1977-11-23	1977-11-23 00:00:00	1977-12-07	1977-12-07 00:00:00	1977-12-07	38000177		0	0	14		0	0	0	96572	0	105078	19006318		
58611	4867	1127433	1918-03-20	1918-03-20 00:00:00	1918-03-27	1918-03-27 00:00:00	1918-03-27	38000177		0	0	7		0	0	0	323640	0	313782	1127433		
799	64	19129655	1976-06-14	1976-06-14 00:00:00	1976-06-28	1976-06-28 00:00:00	1976-06-28	38000177		0	0	14		0	0	0	4324	0	789980	19129655		
11003	918	40229134	2002-12-07	2002-12-07 00:00:00	2002-12-14	2002-12-14 00:00:00	2002-12-14	38000177		0	0	7		0	0	0	61132	0	1043400	40229134		
16082	1333	1118084	1993-07-10	1993-07-10 00:00:00	1993-07-10	1993-07-10 00:00:00	\N	38000177		0	0	0		0	0	0	88475	0	00025152531	44923712		
8515	710	1713671	1980-02-18	1980-02-18 00:00:00	1980-03-10	1980-03-10 00:00:00	1980-03-10	38000177		0	0	21		0	0	0	47002	0	562251	1713671		
29984	2485	19078461	2015-12-23	2015-12-23 00:00:00	2016-01-13	2016-01-13 00:00:00	2016-01-13	38000177		0	0	21		0	0	0	164692	0	310965	19078461		
22436	1844	1154615	1963-04-13	1963-04-13 00:00:00	1963-04-13	1963-04-13 00:00:00	\N	38000177		0	0	0		0	0	0	123132	0	745679	1154615		
54925	4561	1127078	1961-12-29	1961-12-29 00:00:00	1962-01-12	1962-01-12 00:00:00	1962-01-12	38000177		0	0	14		0	0	0	303884	0	282464	1127078		
40578	3364	19073183	1981-10-02	1981-10-02 00:00:00	1981-10-16	1981-10-16 00:00:00	1981-10-16	38000177		0	0	14		0	0	0	223066	0	308182	19073183		
47691	3955	1713671	1981-03-18	1981-03-18 00:00:00	1981-04-01	1981-04-01 00:00:00	1981-04-01	38000177		0	0	14		0	0	0	262848	0	562251	1713671		
36160	2980	46233988	1975-12-10	1975-12-10 00:00:00	1975-12-24	1975-12-24 00:00:00	1975-12-24	38000177		0	0	14		0	0	0	198923	0	1652673	46233988		
5805	484	1118084	1974-06-18	1974-06-18 00:00:00	1974-06-18	1974-06-18 00:00:00	\N	38000177		0	0	0		0	0	0	32392	0	00025152531	44923712		
8561	184	40213198	2011-07-04	2011-07-04 00:00:00	2011-07-04	2011-07-04 00:00:00	2011-07-04	581452		0	0	0		0	0	0	12444	0	133	40213198		
840	67	46233988	1973-03-06	1973-03-06 00:00:00	1973-03-20	1973-03-20 00:00:00	1973-03-20	38000177		0	0	14		0	0	0	4516	0	1652673	46233988		
47962	3976	19059056	1966-12-28	1966-12-28 00:00:00	1967-01-11	1967-01-11 00:00:00	1967-01-11	38000177		0	0	14		0	0	0	264361	0	243670	19059056		
34127	2821	19059056	1920-07-01	1920-07-01 00:00:00	1920-07-15	1920-07-15 00:00:00	1920-07-15	38000177		0	0	14		0	0	0	186935	0	243670	19059056		
26944	2222	19133905	2008-02-10	2008-02-10 00:00:00	2008-02-20	2008-02-20 00:00:00	2008-02-20	38000177		0	0	10		0	0	0	147927	0	834102	19133905		
26981	2226	19133873	1949-08-17	1949-08-17 00:00:00	1949-08-27	1949-08-27 00:00:00	1949-08-27	38000177		0	0	10		0	0	0	148117	0	834061	19133873		
97716	2141	40213201	2013-02-04	2013-02-04 00:00:00	2013-02-04	2013-02-04 00:00:00	2013-02-04	581452		0	0	0		0	0	0	142660	0	33	40213201		
72268	1579	40213160	1955-06-09	1955-06-09 00:00:00	1955-06-09	1955-06-09 00:00:00	1955-06-09	581452		0	0	0		0	0	0	106046	0	10	40213160		
9971	836	19132304	2004-06-28	2004-06-28 00:00:00	2005-04-03	2005-04-03 00:00:00	2005-04-03	38000177		0	0	279		0	0	0	55331	0	807283	19132304		
98479	2156	40213260	2015-02-26	2015-02-26 00:00:00	2015-02-26	2015-02-26 00:00:00	2015-02-26	581452		0	0	0		0	0	0	143730	0	121	40213260		
15065	1258	1713671	2000-05-14	2000-05-14 00:00:00	2000-05-28	2000-05-28 00:00:00	2000-05-28	38000177		0	0	14		0	0	0	82876	0	562251	1713671		
86536	1898	40213160	1971-08-16	1971-08-16 00:00:00	1971-08-16	1971-08-16 00:00:00	1971-08-16	581452		0	0	0		0	0	0	126401	0	10	40213160		
3017	245	1127433	2012-11-23	2012-11-23 00:00:00	2012-11-30	2012-11-30 00:00:00	2012-11-30	38000177		0	0	7		0	0	0	16456	0	313782	1127433		
140457	3084	40213296	2017-11-29	2017-11-29 00:00:00	2017-11-29	2017-11-29 00:00:00	2017-11-29	581452		0	0	0		0	0	0	205394	0	52	40213296		
19542	1608	1127433	1974-11-23	1974-11-23 00:00:00	1974-12-14	1974-12-14 00:00:00	1974-12-14	38000177		0	0	21		0	0	0	108014	0	313782	1127433		
166240	3654	40213227	2013-07-13	2013-07-13 00:00:00	2013-07-13	2013-07-13 00:00:00	2013-07-13	581452		0	0	0		0	0	0	243215	0	113	40213227		
18311	1516	1127433	1982-09-26	1982-09-26 00:00:00	1982-10-26	1982-10-26 00:00:00	1982-10-26	38000177		0	0	30		0	0	0	101270	0	313782	1127433		
139108	3056	40213296	1998-07-24	1998-07-24 00:00:00	1998-07-24	1998-07-24 00:00:00	1998-07-24	581452		0	0	0		0	0	0	203217	0	52	40213296		
43478	3604	1127078	1984-10-31	1984-10-31 00:00:00	1984-11-14	1984-11-14 00:00:00	1984-11-14	38000177		0	0	14		0	0	0	239553	0	282464	1127078		
63719	5295	19059056	1910-05-27	1910-05-27 00:00:00	1910-06-10	1910-06-10 00:00:00	1910-06-10	38000177		0	0	14		0	0	0	352234	0	243670	19059056		
54015	4488	1127433	2012-02-27	2012-02-27 00:00:00	2012-05-27	2012-05-27 00:00:00	2012-05-27	38000177		0	0	90		0	0	0	298832	0	313782	1127433		
2417	192	40165015	2014-04-02	2014-04-02 00:00:00	2014-04-02	2014-04-02 00:00:00	\N	38000177		0	0	0		0	0	0	13220	0	861467	40165015		
57485	4771	19075001	1984-08-05	1984-08-05 00:00:00	1984-09-02	1984-09-02 00:00:00	1984-09-02	38000177		0	0	28		0	0	0	317773	0	309097	19075001		
59234	4923	19128065	1986-09-21	1986-09-21 00:00:00	1987-09-16	1987-09-16 00:00:00	1987-09-16	38000177		0	0	360		0	0	0	327090	0	749882	19128065		
30655	2542	19019979	1974-12-29	1974-12-29 00:00:00	1975-03-29	1975-03-29 00:00:00	1975-03-29	38000177		0	0	90		0	0	0	168089	0	198405	19019979		
53936	1180	40213227	1997-11-12	1997-11-12 00:00:00	1997-11-12	1997-11-12 00:00:00	1997-11-12	581452		0	0	0		0	0	0	77927	0	113	40213227		
60318	5015	1713671	1970-03-25	1970-03-25 00:00:00	1970-04-15	1970-04-15 00:00:00	1970-04-15	38000177		0	0	21		0	0	0	333379	0	562251	1713671		
60212	5004	1332419	1995-05-02	1995-05-02 00:00:00	1995-05-02	1995-05-02 00:00:00	\N	38000177		0	0	0		0	0	0	332881	0	197361	1332419		
45608	3776	1127433	1987-03-21	1987-03-21 00:00:00	1987-06-19	1987-06-19 00:00:00	1987-06-19	38000177		0	0	90		0	0	0	250978	0	313782	1127433		
208714	4578	40213260	2015-05-31	2015-05-31 00:00:00	2015-05-31	2015-05-31 00:00:00	2015-05-31	581452		0	0	0		0	0	0	305000	0	121	40213260		
51887	4313	19133873	1958-12-29	1958-12-29 00:00:00	1959-01-05	1959-01-05 00:00:00	1959-01-05	38000177		0	0	7		0	0	0	286275	0	834061	19133873		
26006	2140	1127078	1952-09-28	1952-09-28 00:00:00	1952-10-12	1952-10-12 00:00:00	1952-10-12	38000177		0	0	14		0	0	0	142572	0	282464	1127078		
62432	5196	1127433	2002-09-12	2002-09-12 00:00:00	2002-09-19	2002-09-19 00:00:00	2002-09-19	38000177		0	0	7		0	0	0	345546	0	313782	1127433		
11624	249	40213314	1982-10-30	1982-10-30 00:00:00	1982-10-30	1982-10-30 00:00:00	1982-10-30	581452		0	0	0		0	0	0	16761	0	49	40213314		
20139	1656	19019979	1981-06-08	1981-06-08 00:00:00	1981-07-08	1981-07-08 00:00:00	1981-07-08	38000177		0	0	30		0	0	0	111150	0	198405	19019979		
11692	972	46233988	1968-07-03	1968-07-03 00:00:00	1968-07-17	1968-07-17 00:00:00	1968-07-17	38000177		0	0	14		0	0	0	64715	0	1652673	46233988		
159612	3513	40213160	1972-08-27	1972-08-27 00:00:00	1972-08-27	1972-08-27 00:00:00	1972-08-27	581452		0	0	0		0	0	0	233108	0	10	40213160		
19028	1571	1551192	1958-04-12	1958-04-12 00:00:00	1958-04-12	1958-04-12 00:00:00	1958-04-12	38000177		0	0	0		0	0	0	105389	0	312617	1551192		
1345	105	19073188	1979-07-28	1979-07-28 00:00:00	1979-08-11	1979-08-11 00:00:00	1979-08-11	38000177		0	0	14		0	0	0	7144	0	308192	19073188		
23330	1923	40229134	2013-03-27	2013-03-27 00:00:00	2013-04-03	2013-04-03 00:00:00	2013-04-03	38000177		0	0	7		0	0	0	127854	0	1043400	40229134		
172301	3788	40213260	2015-08-18	2015-08-18 00:00:00	2015-08-18	2015-08-18 00:00:00	2015-08-18	581452		0	0	0		0	0	0	251814	0	121	40213260		
27915	2309	1713671	1998-10-20	1998-10-20 00:00:00	1998-11-03	1998-11-03 00:00:00	1998-11-03	38000177		0	0	14		0	0	0	153616	0	562251	1713671		
40179	3325	19059056	1964-05-12	1964-05-12 00:00:00	1964-05-26	1964-05-26 00:00:00	1964-05-26	38000177		0	0	14		0	0	0	220725	0	243670	19059056		
12137	1018	1127433	2009-06-20	2009-06-20 00:00:00	2009-07-11	2009-07-11 00:00:00	2009-07-11	38000177		0	0	21		0	0	0	67011	0	313782	1127433		
239740	5262	40213160	1971-06-13	1971-06-13 00:00:00	1971-06-13	1971-06-13 00:00:00	1971-06-13	581452		0	0	0		0	0	0	350131	0	10	40213160		
38575	3184	1127433	1978-04-02	1978-04-02 00:00:00	1978-04-30	1978-04-30 00:00:00	1978-04-30	38000177		0	0	28		0	0	0	211991	0	313782	1127433		
20824	453	40213160	1970-10-23	1970-10-23 00:00:00	1970-10-23	1970-10-23 00:00:00	1970-10-23	581452		0	0	0		0	0	0	30251	0	10	40213160		
162972	3583	40213227	2010-04-06	2010-04-06 00:00:00	2010-04-06	2010-04-06 00:00:00	2010-04-06	581452		0	0	0		0	0	0	238180	0	113	40213227		
5269	442	1124300	1985-09-02	1985-09-02 00:00:00	1985-09-02	1985-09-02 00:00:00	\N	38000177		0	0	0		0	0	0	29303	0	00781178901	45011828		
54168	4501	19128065	1999-09-20	1999-09-20 00:00:00	2000-09-14	2000-09-14 00:00:00	2000-09-14	38000177		0	0	360		0	0	0	299721	0	749882	19128065		
33631	2782	40173590	2000-03-22	2000-03-22 00:00:00	2000-03-22	2000-03-22 00:00:00	\N	38000177		0	0	0		0	0	0	184397	0	904419	40173590		
17511	1448	1127078	1977-11-23	1977-11-23 00:00:00	1977-12-07	1977-12-07 00:00:00	1977-12-07	38000177		0	0	14		0	0	0	96572	0	282464	1127078		
58612	4867	1713671	1932-08-17	1932-08-17 00:00:00	1932-08-24	1932-08-24 00:00:00	1932-08-24	38000177		0	0	7		0	0	0	323676	0	562251	1713671		
800	64	1118084	2009-03-03	2009-03-03 00:00:00	2009-03-03	2009-03-03 00:00:00	\N	38000177		0	0	0		0	0	0	4347	0	00025152531	44923712		
11004	918	19078461	1995-03-04	1995-03-04 00:00:00	1995-03-25	1995-03-25 00:00:00	1995-03-25	38000177		0	0	21		0	0	0	61203	0	310965	19078461		
16083	1333	19059056	1981-07-18	1981-07-18 00:00:00	1981-08-22	1981-08-22 00:00:00	1981-08-22	38000177		0	0	35		0	0	0	88415	0	243670	19059056		
8516	710	19059056	1973-02-14	1973-02-14 00:00:00	1973-04-15	1973-04-15 00:00:00	1973-04-15	38000177		0	0	60		0	0	0	46996	0	243670	19059056		
29985	2485	1713671	1976-10-18	1976-10-18 00:00:00	1976-11-08	1976-11-08 00:00:00	1976-11-08	38000177		0	0	21		0	0	0	164587	0	562251	1713671		
22437	1844	1713671	1977-09-26	1977-09-26 00:00:00	1977-10-31	1977-10-31 00:00:00	1977-10-31	38000177		0	0	35		0	0	0	123243	0	562251	1713671		
54926	4562	1127433	1985-12-23	1985-12-23 00:00:00	1986-01-20	1986-01-20 00:00:00	1986-01-20	38000177		0	0	28		0	0	0	303956	0	313782	1127433		
40579	3364	1127433	1983-09-17	1983-09-17 00:00:00	1983-10-01	1983-10-01 00:00:00	1983-10-01	38000177		0	0	14		0	0	0	223081	0	313782	1127433		
47692	3955	1127433	2004-03-09	2004-03-09 00:00:00	2004-03-16	2004-03-16 00:00:00	2004-03-16	38000177		0	0	7		0	0	0	262830	0	313782	1127433		
36161	2980	19059056	1973-12-08	1973-12-08 00:00:00	1974-01-12	1974-01-12 00:00:00	1974-01-12	38000177		0	0	35		0	0	0	198941	0	243670	19059056		
5806	484	1713671	1954-07-10	1954-07-10 00:00:00	1954-07-17	1954-07-17 00:00:00	1954-07-17	38000177		0	0	7		0	0	0	32308	0	562251	1713671		
154181	3394	40213160	1966-01-08	1966-01-08 00:00:00	1966-01-08	1966-01-08 00:00:00	1966-01-08	581452		0	0	0		0	0	0	225124	0	10	40213160		
841	67	1713671	2000-07-09	2000-07-09 00:00:00	2000-07-23	2000-07-23 00:00:00	2000-07-23	38000177		0	0	14		0	0	0	4539	0	562251	1713671		
47963	3976	19006318	1966-12-28	1966-12-28 00:00:00	1967-01-11	1967-01-11 00:00:00	1967-01-11	38000177		0	0	14		0	0	0	264361	0	105078	19006318		
34128	2821	19059056	1937-07-02	1937-07-02 00:00:00	1937-07-23	1937-07-23 00:00:00	1937-07-23	38000177		0	0	21		0	0	0	186849	0	243670	19059056		
26945	2222	1713671	1968-12-24	1968-12-24 00:00:00	1968-12-31	1968-12-31 00:00:00	1968-12-31	38000177		0	0	7		0	0	0	147906	0	562251	1713671		
26982	2226	1127433	2001-06-12	2001-06-12 00:00:00	2001-07-03	2001-07-03 00:00:00	2001-07-03	38000177		0	0	21		0	0	0	148169	0	313782	1127433		
97728	2141	40213227	1997-11-10	1997-11-10 00:00:00	1997-11-10	1997-11-10 00:00:00	1997-11-10	581452		0	0	0		0	0	0	142656	0	113	40213227		
72273	1579	40213227	2016-02-18	2016-02-18 00:00:00	2016-02-18	2016-02-18 00:00:00	2016-02-18	581452		0	0	0		0	0	0	106114	0	113	40213227		
9972	836	19128065	2001-07-14	2001-07-14 00:00:00	2002-07-09	2002-07-09 00:00:00	2002-07-09	38000177		0	0	360		0	0	0	55284	0	749882	19128065		
98485	2156	40213296	2005-06-09	2005-06-09 00:00:00	2005-06-09	2005-06-09 00:00:00	2005-06-09	581452		0	0	0		0	0	0	143682	0	52	40213296		
15066	1258	1127433	1994-06-06	1994-06-06 00:00:00	1994-06-20	1994-06-20 00:00:00	1994-06-20	38000177		0	0	14		0	0	0	82875	0	313782	1127433		
86539	1898	40213227	2012-12-24	2012-12-24 00:00:00	2012-12-24	2012-12-24 00:00:00	2012-12-24	581452		0	0	0		0	0	0	126360	0	113	40213227		
3018	245	19078461	2013-09-09	2013-09-09 00:00:00	2013-09-30	2013-09-30 00:00:00	2013-09-30	38000177		0	0	21		0	0	0	16406	0	310965	19078461		
140461	3084	40213251	1984-11-14	1984-11-14 00:00:00	1984-11-14	1984-11-14 00:00:00	1984-11-14	581452		0	0	0		0	0	0	205363	0	21	40213251		
19543	1608	1713671	1992-04-08	1992-04-08 00:00:00	1992-04-22	1992-04-22 00:00:00	1992-04-22	38000177		0	0	14		0	0	0	108003	0	562251	1713671		
166257	3654	40213227	1994-02-18	1994-02-18 00:00:00	1994-02-18	1994-02-18 00:00:00	1994-02-18	581452		0	0	0		0	0	0	243212	0	113	40213227		
18312	1516	19077572	2007-04-23	2007-04-23 00:00:00	2007-04-23	2007-04-23 00:00:00	\N	38000177		0	0	0		0	0	0	101354	0	310436	19077572		
139113	3056	40213227	2008-05-02	2008-05-02 00:00:00	2008-05-02	2008-05-02 00:00:00	2008-05-02	581452		0	0	0		0	0	0	203219	0	113	40213227		
43479	3604	1713671	1990-03-12	1990-03-12 00:00:00	1990-03-19	1990-03-19 00:00:00	1990-03-19	38000177		0	0	7		0	0	0	239473	0	562251	1713671		
63720	5295	19059056	1958-10-03	1958-10-03 00:00:00	1958-10-24	1958-10-24 00:00:00	1958-10-24	38000177		0	0	21		0	0	0	352209	0	243670	19059056		
54016	4488	40162522	2012-02-27	2012-02-27 00:00:00	2012-02-27	2012-02-27 00:00:00	\N	38000177		0	0	0		0	0	0	298832	0	857005	40162522		
2418	192	1127433	1973-10-21	1973-10-21 00:00:00	1973-10-28	1973-10-28 00:00:00	1973-10-28	38000177		0	0	7		0	0	0	13205	0	313782	1127433		
57486	4771	1127433	1984-08-05	1984-08-05 00:00:00	1984-09-02	1984-09-02 00:00:00	1984-09-02	38000177		0	0	28		0	0	0	317773	0	313782	1127433		
59235	4923	1127433	1979-05-08	1979-05-08 00:00:00	1979-05-22	1979-05-22 00:00:00	1979-05-22	38000177		0	0	14		0	0	0	327128	0	313782	1127433		
30656	2542	40236824	2015-06-17	2015-06-17 00:00:00	2015-06-24	2015-06-24 00:00:00	2015-06-24	38000177		0	0	7		0	0	0	168199	0	1094107	40236824		
53944	1180	40213227	2017-08-09	2017-08-09 00:00:00	2017-08-09	2017-08-09 00:00:00	2017-08-09	581452		0	0	0		0	0	0	77893	0	113	40213227		
60319	5015	19059056	1970-11-21	1970-11-21 00:00:00	1971-02-19	1971-02-19 00:00:00	1971-02-19	38000177		0	0	90		0	0	0	333373	0	243670	19059056		
60213	5004	1539411	1995-05-02	1995-05-02 00:00:00	1995-05-02	1995-05-02 00:00:00	\N	38000177		0	0	0		0	0	0	332881	0	312961	1539411		
3373	279	19133905	1993-06-13	1993-06-13 00:00:00	1993-06-20	1993-06-20 00:00:00	1993-06-20	38000177		0	0	7		0	0	0	18655	0	834102	19133905		
219993	4828	40213227	1998-07-22	1998-07-22 00:00:00	1998-07-22	1998-07-22 00:00:00	1998-07-22	581452		0	0	0		0	0	0	321301	0	113	40213227		
51888	4313	19059056	1949-05-09	1949-05-09 00:00:00	1949-05-30	1949-05-30 00:00:00	1949-05-30	38000177		0	0	21		0	0	0	286306	0	243670	19059056		
26007	2140	19006318	1952-09-28	1952-09-28 00:00:00	1952-10-12	1952-10-12 00:00:00	1952-10-12	38000177		0	0	14		0	0	0	142572	0	105078	19006318		
62433	5196	19059056	1989-01-15	1989-01-15 00:00:00	1989-02-12	1989-02-12 00:00:00	1989-02-12	38000177		0	0	28		0	0	0	345568	0	243670	19059056		
11627	249	40213251	1984-01-28	1984-01-28 00:00:00	1984-01-28	1984-01-28 00:00:00	1984-01-28	581452		0	0	0		0	0	0	16773	0	21	40213251		
20140	1656	19128065	1997-10-22	1997-10-22 00:00:00	1998-10-17	1998-10-17 00:00:00	1998-10-17	38000177		0	0	360		0	0	0	111155	0	749882	19128065		
11694	972	19128065	1983-05-13	1983-05-13 00:00:00	1984-05-07	1984-05-07 00:00:00	1984-05-07	38000177		0	0	360		0	0	0	64716	0	749882	19128065		
159618	3513	40213160	1972-11-26	1972-11-26 00:00:00	1972-11-26	1972-11-26 00:00:00	1972-11-26	581452		0	0	0		0	0	0	233133	0	10	40213160		
19029	1571	1713671	2011-06-25	2011-06-25 00:00:00	2011-07-02	2011-07-02 00:00:00	2011-07-02	38000177		0	0	7		0	0	0	105421	0	562251	1713671		
1368	110	1127078	1979-08-28	1979-08-28 00:00:00	1979-09-11	1979-09-11 00:00:00	1979-09-11	38000177		0	0	14		0	0	0	7296	0	282464	1127078		
23331	1923	1713671	2004-06-25	2004-06-25 00:00:00	2004-07-09	2004-07-09 00:00:00	2004-07-09	38000177		0	0	14		0	0	0	127937	0	562251	1713671		
172302	3788	40213160	1965-01-19	1965-01-19 00:00:00	1965-01-19	1965-01-19 00:00:00	1965-01-19	581452		0	0	0		0	0	0	251831	0	10	40213160		
27916	2309	40229134	1990-08-29	1990-08-29 00:00:00	1990-09-05	1990-09-05 00:00:00	1990-09-05	38000177		0	0	7		0	0	0	153622	0	1043400	40229134		
40180	3325	1713671	1985-07-23	1985-07-23 00:00:00	1985-08-06	1985-08-06 00:00:00	1985-08-06	38000177		0	0	14		0	0	0	220723	0	562251	1713671		
12138	1018	1127078	1982-11-09	1982-11-09 00:00:00	1983-01-08	1983-01-08 00:00:00	1983-01-08	38000177		0	0	60		0	0	0	67010	0	282464	1127078		
239743	5262	40213227	1993-03-07	1993-03-07 00:00:00	1993-03-07	1993-03-07 00:00:00	1993-03-07	581452		0	0	0		0	0	0	350144	0	113	40213227		
38576	3184	40229134	1973-01-29	1973-01-29 00:00:00	1973-02-12	1973-02-12 00:00:00	1973-02-12	38000177		0	0	14		0	0	0	211973	0	1043400	40229134		
20827	453	40213227	2002-05-17	2002-05-17 00:00:00	2002-05-17	2002-05-17 00:00:00	2002-05-17	581452		0	0	0		0	0	0	30216	0	113	40213227		
162973	3583	40213296	2010-04-06	2010-04-06 00:00:00	2010-04-06	2010-04-06 00:00:00	2010-04-06	581452		0	0	0		0	0	0	238180	0	52	40213296		
5270	442	1115171	1997-05-28	1997-05-28 00:00:00	1997-07-02	1997-07-02 00:00:00	1997-07-02	38000177		0	0	35		0	0	0	29288	0	849574	1115171		
54169	4501	19128065	1988-11-16	1988-11-16 00:00:00	1989-11-11	1989-11-11 00:00:00	1989-11-11	38000177		0	0	360		0	0	0	299717	0	749882	19128065		
33632	2782	40171902	1981-02-18	1981-02-18 00:00:00	1981-02-18	1981-02-18 00:00:00	\N	38000177		0	0	0		0	0	0	184389	0	897718	40171902		
17512	1448	19128065	1990-03-09	1990-03-09 00:00:00	1991-03-04	1991-03-04 00:00:00	1991-03-04	38000177		0	0	360		0	0	0	96633	0	749882	19128065		
58613	4867	40220960	2009-08-26	2009-08-26 00:00:00	2009-08-26	2009-08-26 00:00:00	2009-08-26	38000177		0	0	0		0	0	0	323695	0	1804799	40220960		
801	64	19128022	1992-09-28	1992-09-28 00:00:00	1993-09-23	1993-09-23 00:00:00	1993-09-23	38000177		0	0	360		0	0	0	4369	0	749785	19128022		
11005	918	1127433	1969-01-21	1969-01-21 00:00:00	1969-03-22	1969-03-22 00:00:00	1969-03-22	38000177		0	0	60		0	0	0	61200	0	313782	1127433		
16084	1333	19078461	1990-04-07	1990-04-07 00:00:00	1990-04-21	1990-04-21 00:00:00	1990-04-21	38000177		0	0	14		0	0	0	88416	0	310965	19078461		
8517	710	19129655	1961-10-15	1961-10-15 00:00:00	1961-10-29	1961-10-29 00:00:00	1961-10-29	38000177		0	0	14		0	0	0	47005	0	789980	19129655		
29986	2485	40173590	2003-11-12	2003-11-12 00:00:00	2003-11-12	2003-11-12 00:00:00	\N	38000177		0	0	0		0	0	0	164632	0	904419	40173590		
22438	1845	40229134	2006-02-07	2006-02-07 00:00:00	2006-02-21	2006-02-21 00:00:00	2006-02-21	38000177		0	0	14		0	0	0	123356	0	1043400	40229134		
54927	4562	1551192	1970-11-08	1970-11-08 00:00:00	1970-11-08	1970-11-08 00:00:00	1970-11-08	38000177		0	0	0		0	0	0	303952	0	312617	1551192		
40580	3364	1127078	1986-06-02	1986-06-02 00:00:00	1986-06-16	1986-06-16 00:00:00	1986-06-16	38000177		0	0	14		0	0	0	223106	0	282464	1127078		
47693	3955	1127433	2007-03-02	2007-03-02 00:00:00	2007-03-09	2007-03-09 00:00:00	2007-03-09	38000177		0	0	7		0	0	0	262859	0	313782	1127433		
36162	2980	1127078	1980-02-10	1980-02-10 00:00:00	1980-02-24	1980-02-24 00:00:00	1980-02-24	38000177		0	0	14		0	0	0	198974	0	282464	1127078		
5807	484	19133873	1947-08-16	1947-08-16 00:00:00	1947-08-29	1947-08-29 00:00:00	1947-08-29	38000177		0	0	13		0	0	0	32344	0	834061	19133873		
154182	3394	40213260	2015-10-03	2015-10-03 00:00:00	2015-10-03	2015-10-03 00:00:00	2015-10-03	581452		0	0	0		0	0	0	225140	0	121	40213260		
842	67	1127433	1996-10-05	1996-10-05 00:00:00	1996-10-12	1996-10-12 00:00:00	1996-10-12	38000177		0	0	7		0	0	0	4566	0	313782	1127433		
47964	3976	1115171	2003-03-24	2003-03-24 00:00:00	2003-04-28	2003-04-28 00:00:00	2003-04-28	38000177		0	0	35		0	0	0	264351	0	849574	1115171		
34129	2821	40223774	2002-11-08	2002-11-08 00:00:00	2002-11-08	2002-11-08 00:00:00	\N	38000177		0	0	0		0	0	0	186882	0	998582	40223774		
26946	2222	1127433	1987-06-07	1987-06-07 00:00:00	1987-06-21	1987-06-21 00:00:00	1987-06-21	38000177		0	0	14		0	0	0	147931	0	313782	1127433		
26983	2226	19133905	2003-11-10	2003-11-10 00:00:00	2003-11-17	2003-11-17 00:00:00	2003-11-17	38000177		0	0	7		0	0	0	148076	0	834102	19133905		
89563	1964	40213160	1966-01-11	1966-01-11 00:00:00	1966-01-11	1966-01-11 00:00:00	1966-01-11	581452		0	0	0		0	0	0	130560	0	10	40213160		
72284	1579	40213227	1997-01-09	1997-01-09 00:00:00	1997-01-09	1997-01-09 00:00:00	1997-01-09	581452		0	0	0		0	0	0	106110	0	113	40213227		
9973	836	19128065	1994-08-20	1994-08-20 00:00:00	1995-08-15	1995-08-15 00:00:00	1995-08-15	38000177		0	0	360		0	0	0	55341	0	749882	19128065		
98488	2156	40213227	1997-05-29	1997-05-29 00:00:00	1997-05-29	1997-05-29 00:00:00	1997-05-29	581452		0	0	0		0	0	0	143688	0	113	40213227		
15067	1258	1127433	2004-07-11	2004-07-11 00:00:00	2004-07-18	2004-07-18 00:00:00	2004-07-18	38000177		0	0	7		0	0	0	82861	0	313782	1127433		
86540	1898	40213296	2012-12-24	2012-12-24 00:00:00	2012-12-24	2012-12-24 00:00:00	2012-12-24	581452		0	0	0		0	0	0	126360	0	52	40213296		
3019	245	1127433	2005-10-30	2005-10-30 00:00:00	2005-11-20	2005-11-20 00:00:00	2005-11-20	38000177		0	0	21		0	0	0	16405	0	313782	1127433		
140463	3084	40213160	1978-05-03	1978-05-03 00:00:00	1978-05-03	1978-05-03 00:00:00	1978-05-03	581452		0	0	0		0	0	0	205384	0	10	40213160		
19544	1608	19059056	1943-08-03	1943-08-03 00:00:00	1943-08-17	1943-08-17 00:00:00	1943-08-17	38000177		0	0	14		0	0	0	107943	0	243670	19059056		
166258	3654	40213306	1994-02-18	1994-02-18 00:00:00	1994-02-18	1994-02-18 00:00:00	1994-02-18	581452		0	0	0		0	0	0	243212	0	43	40213306		
18313	1516	1127433	1984-04-18	1984-04-18 00:00:00	1984-05-02	1984-05-02 00:00:00	1984-05-02	38000177		0	0	14		0	0	0	101276	0	313782	1127433		
139114	3056	40213260	2008-05-02	2008-05-02 00:00:00	2008-05-02	2008-05-02 00:00:00	2008-05-02	581452		0	0	0		0	0	0	203219	0	121	40213260		
43480	3604	1124300	2019-05-16	2019-05-16 00:00:00	2019-05-16	2019-05-16 00:00:00	\N	38000177		0	0	0		0	0	0	239472	0	00781178901	45011828		
63721	5295	1127433	1946-01-06	1946-01-06 00:00:00	1946-01-13	1946-01-13 00:00:00	1946-01-13	38000177		0	0	7		0	0	0	352272	0	313782	1127433		
54017	4488	1127433	1992-08-26	1992-08-26 00:00:00	1992-09-09	1992-09-09 00:00:00	1992-09-09	38000177		0	0	14		0	0	0	298831	0	313782	1127433		
2419	192	19133905	1986-03-10	1986-03-10 00:00:00	1986-03-23	1986-03-23 00:00:00	1986-03-23	38000177		0	0	13		0	0	0	13149	0	834102	19133905		
81598	1783	40213160	1964-07-06	1964-07-06 00:00:00	1964-07-06	1964-07-06 00:00:00	1964-07-06	581452		0	0	0		0	0	0	119469	0	10	40213160		
59236	4923	1118084	2000-05-23	2000-05-23 00:00:00	2000-05-23	2000-05-23 00:00:00	\N	38000177		0	0	0		0	0	0	327084	0	00025152531	44923712		
30657	2542	920300	2015-06-17	2015-06-17 00:00:00	2015-06-24	2015-06-24 00:00:00	2015-06-24	38000177		0	0	7		0	0	0	168199	0	311989	920300		
53946	1180	40213160	1961-03-22	1961-03-22 00:00:00	1961-03-22	1961-03-22 00:00:00	1961-03-22	581452		0	0	0		0	0	0	77915	0	10	40213160		
60320	5015	1127433	2010-09-25	2010-09-25 00:00:00	2010-10-16	2010-10-16 00:00:00	2010-10-16	38000177		0	0	21		0	0	0	333378	0	313782	1127433		
60214	5004	19008572	1990-02-11	1990-02-11 00:00:00	1990-03-04	1990-03-04 00:00:00	1990-03-04	38000177		0	0	21		0	0	0	332832	0	106258	19008572		
3374	279	1127433	1967-03-18	1967-03-18 00:00:00	1967-04-01	1967-04-01 00:00:00	1967-04-01	38000177		0	0	14		0	0	0	18616	0	313782	1127433		
220003	4828	40213227	2009-05-20	2009-05-20 00:00:00	2009-05-20	2009-05-20 00:00:00	2009-05-20	581452		0	0	0		0	0	0	321302	0	113	40213227		
9487	789	19078461	1991-02-22	1991-02-22 00:00:00	1991-05-23	1991-05-23 00:00:00	1991-05-23	38000177		0	0	90		0	0	0	52458	0	310965	19078461		
26008	2140	1713671	1999-02-08	1999-02-08 00:00:00	1999-02-22	1999-02-22 00:00:00	1999-02-22	38000177		0	0	14		0	0	0	142552	0	562251	1713671		
62434	5196	19133873	1952-10-27	1952-10-27 00:00:00	1952-11-06	1952-11-06 00:00:00	1952-11-06	38000177		0	0	10		0	0	0	345510	0	834061	19133873		
11635	249	40213314	1982-01-30	1982-01-30 00:00:00	1982-01-30	1982-01-30 00:00:00	1982-01-30	581452		0	0	0		0	0	0	16760	0	49	40213314		
20141	1656	40224805	2004-09-15	2004-09-15 00:00:00	2005-09-10	2005-09-10 00:00:00	2005-09-10	38000177		0	0	360		0	0	0	111057	0	1000126	40224805		
11695	972	19133905	1987-08-11	1987-08-11 00:00:00	1987-08-21	1987-08-21 00:00:00	1987-08-21	38000177		0	0	10		0	0	0	64721	0	834102	19133905		
159621	3513	40213227	2005-10-30	2005-10-30 00:00:00	2005-10-30	2005-10-30 00:00:00	2005-10-30	581452		0	0	0		0	0	0	233147	0	113	40213227		
19030	1571	19133905	1979-02-15	1979-02-15 00:00:00	1979-02-24	1979-02-24 00:00:00	1979-02-24	38000177		0	0	9		0	0	0	105482	0	834102	19133905		
1369	110	920300	1998-03-13	1998-03-13 00:00:00	1998-03-20	1998-03-20 00:00:00	1998-03-20	38000177		0	0	7		0	0	0	7293	0	311989	920300		
23332	1923	1127433	1953-06-13	1953-06-13 00:00:00	1953-07-11	1953-07-11 00:00:00	1953-07-11	38000177		0	0	28		0	0	0	127998	0	313782	1127433		
172306	3788	40213160	1968-12-31	1968-12-31 00:00:00	1968-12-31	1968-12-31 00:00:00	1968-12-31	581452		0	0	0		0	0	0	251862	0	10	40213160		
27917	2309	1127078	1980-04-06	1980-04-06 00:00:00	1980-06-05	1980-06-05 00:00:00	1980-06-05	38000177		0	0	60		0	0	0	153630	0	282464	1127078		
40181	3325	40229134	1963-09-16	1963-09-16 00:00:00	1963-09-23	1963-09-23 00:00:00	1963-09-23	38000177		0	0	7		0	0	0	220741	0	1043400	40229134		
12139	1018	1127433	1987-04-18	1987-04-18 00:00:00	1987-05-02	1987-05-02 00:00:00	1987-05-02	38000177		0	0	14		0	0	0	67030	0	313782	1127433		
239744	5262	40213306	1993-03-07	1993-03-07 00:00:00	1993-03-07	1993-03-07 00:00:00	1993-03-07	581452		0	0	0		0	0	0	350144	0	43	40213306		
38577	3184	40229134	2017-08-11	2017-08-11 00:00:00	2017-08-18	2017-08-18 00:00:00	2017-08-18	38000177		0	0	7		0	0	0	211964	0	1043400	40229134		
20834	453	40213160	1971-01-22	1971-01-22 00:00:00	1971-01-22	1971-01-22 00:00:00	1971-01-22	581452		0	0	0		0	0	0	30166	0	10	40213160		
162977	3583	40213160	1969-04-15	1969-04-15 00:00:00	1969-04-15	1969-04-15 00:00:00	1969-04-15	581452		0	0	0		0	0	0	238272	0	10	40213160		
5271	442	19006318	1952-02-28	1952-02-28 00:00:00	1952-03-13	1952-03-13 00:00:00	1952-03-13	38000177		0	0	14		0	0	0	29347	0	105078	19006318		
54170	4501	40229134	1979-11-25	1979-11-25 00:00:00	1979-12-09	1979-12-09 00:00:00	1979-12-09	38000177		0	0	14		0	0	0	299704	0	1043400	40229134		
33633	2782	1127433	1956-06-03	1956-06-03 00:00:00	1956-06-17	1956-06-17 00:00:00	1956-06-17	38000177		0	0	14		0	0	0	184406	0	313782	1127433		
17513	1448	40224805	1997-01-31	1997-01-31 00:00:00	1998-01-26	1998-01-26 00:00:00	1998-01-26	38000177		0	0	360		0	0	0	96607	0	1000126	40224805		
58614	4867	19075601	2009-08-26	2009-08-26 00:00:00	2009-08-26	2009-08-26 00:00:00	2009-08-26	38000177		0	0	0		0	0	0	323695	0	309362	19075601		
802	65	1713671	1998-03-29	1998-03-29 00:00:00	1998-04-05	1998-04-05 00:00:00	1998-04-05	38000177		0	0	7		0	0	0	4420	0	562251	1713671		
11006	918	19059056	1921-05-06	1921-05-06 00:00:00	1921-05-20	1921-05-20 00:00:00	1921-05-20	38000177		0	0	14		0	0	0	61144	0	243670	19059056		
16085	1333	1127433	1974-10-29	1974-10-29 00:00:00	1974-11-12	1974-11-12 00:00:00	1974-11-12	38000177		0	0	14		0	0	0	88452	0	313782	1127433		
8518	710	1127078	1961-10-15	1961-10-15 00:00:00	1961-10-29	1961-10-29 00:00:00	1961-10-29	38000177		0	0	14		0	0	0	47005	0	282464	1127078		
50515	4199	19059056	1963-01-17	1963-01-17 00:00:00	1963-01-31	1963-01-31 00:00:00	1963-01-31	38000177		0	0	14		0	0	0	278621	0	243670	19059056		
22439	1845	1127433	2019-02-06	2019-02-06 00:00:00	2019-02-13	2019-02-13 00:00:00	2019-02-13	38000177		0	0	7		0	0	0	123284	0	313782	1127433		
54928	4562	40229134	1982-08-26	1982-08-26 00:00:00	1982-09-09	1982-09-09 00:00:00	1982-09-09	38000177		0	0	14		0	0	0	304058	0	1043400	40229134		
40581	3364	19019979	1980-08-02	1980-08-02 00:00:00	1980-08-16	1980-08-16 00:00:00	1980-08-16	38000177		0	0	14		0	0	0	223092	0	198405	19019979		
47694	3955	40231925	1994-02-28	1994-02-28 00:00:00	1994-02-28	1994-02-28 00:00:00	\N	38000177		0	0	0		0	0	0	262901	0	1049221	40231925		
36163	2980	40232448	1974-01-08	1974-01-08 00:00:00	1974-01-08	1974-01-08 00:00:00	\N	38000177		0	0	0		0	0	0	198914	0	1049630	40232448		
16279	1352	1713671	1999-03-13	1999-03-13 00:00:00	1999-04-03	1999-04-03 00:00:00	1999-04-03	38000177		0	0	21		0	0	0	89535	0	562251	1713671		
154187	3394	40213160	1966-03-12	1966-03-12 00:00:00	1966-03-12	1966-03-12 00:00:00	1966-03-12	581452		0	0	0		0	0	0	225148	0	10	40213160		
843	67	1127433	1980-01-31	1980-01-31 00:00:00	1980-02-14	1980-02-14 00:00:00	1980-02-14	38000177		0	0	14		0	0	0	4537	0	313782	1127433		
47965	3976	19133905	1989-09-03	1989-09-03 00:00:00	1989-09-13	1989-09-13 00:00:00	1989-09-13	38000177		0	0	10		0	0	0	264344	0	834102	19133905		
34130	2821	1127433	1990-05-05	1990-05-05 00:00:00	1990-06-04	1990-06-04 00:00:00	1990-06-04	38000177		0	0	30		0	0	0	186853	0	313782	1127433		
26947	2222	40229134	1967-07-03	1967-07-03 00:00:00	1967-07-10	1967-07-10 00:00:00	1967-07-10	38000177		0	0	7		0	0	0	147905	0	1043400	40229134		
26984	2226	1127433	1945-08-29	1945-08-29 00:00:00	1945-09-12	1945-09-12 00:00:00	1945-09-12	38000177		0	0	14		0	0	0	148136	0	313782	1127433		
89568	1965	40213227	2004-05-16	2004-05-16 00:00:00	2004-05-16	2004-05-16 00:00:00	2004-05-16	581452		0	0	0		0	0	0	130664	0	113	40213227		
72285	1579	40213296	1997-01-09	1997-01-09 00:00:00	1997-01-09	1997-01-09 00:00:00	1997-01-09	581452		0	0	0		0	0	0	106110	0	52	40213296		
9974	836	19128022	1992-08-30	1992-08-30 00:00:00	1993-08-25	1993-08-25 00:00:00	1993-08-25	38000177		0	0	360		0	0	0	55340	0	749785	19128022		
98491	2156	40213296	2007-06-14	2007-06-14 00:00:00	2007-06-14	2007-06-14 00:00:00	2007-06-14	581452		0	0	0		0	0	0	143695	0	52	40213296		
15068	1258	19059056	1968-11-02	1968-11-02 00:00:00	1968-11-16	1968-11-16 00:00:00	1968-11-16	38000177		0	0	14		0	0	0	82867	0	243670	19059056		
86545	1898	40213227	1993-11-29	1993-11-29 00:00:00	1993-11-29	1993-11-29 00:00:00	1993-11-29	581452		0	0	0		0	0	0	126366	0	113	40213227		
3020	245	19075001	2005-10-30	2005-10-30 00:00:00	2005-11-20	2005-11-20 00:00:00	2005-11-20	38000177		0	0	21		0	0	0	16405	0	309097	19075001		
140464	3084	40213314	1978-05-03	1978-05-03 00:00:00	1978-05-03	1978-05-03 00:00:00	1978-05-03	581452		0	0	0		0	0	0	205384	0	49	40213314		
19545	1609	19059056	1946-10-15	1946-10-15 00:00:00	1946-10-29	1946-10-29 00:00:00	1946-10-29	38000177		0	0	14		0	0	0	108112	0	243670	19059056		
166261	3654	40213160	1976-06-12	1976-06-12 00:00:00	1976-06-12	1976-06-12 00:00:00	1976-06-12	581452		0	0	0		0	0	0	243192	0	10	40213160		
18314	1516	40173590	1998-03-02	1998-03-02 00:00:00	1998-03-02	1998-03-02 00:00:00	\N	38000177		0	0	0		0	0	0	101252	0	904419	40173590		
139117	3056	40213160	1957-09-06	1957-09-06 00:00:00	1957-09-06	1957-09-06 00:00:00	1957-09-06	581452		0	0	0		0	0	0	203266	0	10	40213160		
43481	3604	19133873	1992-04-24	1992-04-24 00:00:00	1992-05-02	1992-05-02 00:00:00	1992-05-02	38000177		0	0	8		0	0	0	239474	0	834061	19133873		
63722	5295	19133905	1985-08-06	1985-08-06 00:00:00	1985-08-19	1985-08-19 00:00:00	1985-08-19	38000177		0	0	13		0	0	0	352244	0	834102	19133905		
54018	4488	19133905	2011-11-23	2011-11-23 00:00:00	2011-11-30	2011-11-30 00:00:00	2011-11-30	38000177		0	0	7		0	0	0	298823	0	834102	19133905		
2420	192	1127433	2017-07-17	2017-07-17 00:00:00	2017-07-24	2017-07-24 00:00:00	2017-07-24	38000177		0	0	7		0	0	0	13187	0	313782	1127433		
81602	1783	40213260	2010-04-12	2010-04-12 00:00:00	2010-04-12	2010-04-12 00:00:00	2010-04-12	581452		0	0	0		0	0	0	119447	0	121	40213260		
59237	4923	19128065	1985-09-26	1985-09-26 00:00:00	1986-09-21	1986-09-21 00:00:00	1986-09-21	38000177		0	0	360		0	0	0	327089	0	749882	19128065		
30658	2542	1127433	1989-02-14	1989-02-14 00:00:00	1989-02-21	1989-02-21 00:00:00	1989-02-21	38000177		0	0	7		0	0	0	168124	0	313782	1127433		
53953	1180	40213160	1956-09-19	1956-09-19 00:00:00	1956-09-19	1956-09-19 00:00:00	1956-09-19	581452		0	0	0		0	0	0	77890	0	10	40213160		
60324	5017	1127433	1997-07-21	1997-07-21 00:00:00	1997-07-28	1997-07-28 00:00:00	1997-07-28	38000177		0	0	7		0	0	0	333439	0	313782	1127433		
60215	5004	40162522	2015-07-17	2015-07-17 00:00:00	2015-07-17	2015-07-17 00:00:00	\N	38000177		0	0	0		0	0	0	332907	0	857005	40162522		
3375	279	1713671	2001-12-13	2001-12-13 00:00:00	2001-12-27	2001-12-27 00:00:00	2001-12-27	38000177		0	0	14		0	0	0	18642	0	562251	1713671		
220004	4828	40213296	2009-05-20	2009-05-20 00:00:00	2009-05-20	2009-05-20 00:00:00	2009-05-20	581452		0	0	0		0	0	0	321302	0	52	40213296		
9488	789	1127078	1972-07-26	1972-07-26 00:00:00	1972-08-09	1972-08-09 00:00:00	1972-08-09	38000177		0	0	14		0	0	0	52465	0	282464	1127078		
26009	2140	19078461	1984-02-13	1984-02-13 00:00:00	1984-03-05	1984-03-05 00:00:00	1984-03-05	38000177		0	0	21		0	0	0	142555	0	310965	19078461		
62435	5196	1127433	2017-01-10	2017-01-10 00:00:00	2017-01-24	2017-01-24 00:00:00	2017-01-24	38000177		0	0	14		0	0	0	345549	0	313782	1127433		
22932	498	40213160	1974-10-31	1974-10-31 00:00:00	1974-10-31	1974-10-31 00:00:00	1974-10-31	581452		0	0	0		0	0	0	33277	0	10	40213160		
20142	1656	19127922	2007-09-04	2007-09-04 00:00:00	2008-08-29	2008-08-29 00:00:00	2008-08-29	38000177		0	0	360		0	0	0	111130	0	748962	19127922		
11696	972	19128022	1989-04-11	1989-04-11 00:00:00	1990-04-06	1990-04-06 00:00:00	1990-04-06	38000177		0	0	360		0	0	0	64664	0	749785	19128022		
159626	3513	40213296	2013-11-10	2013-11-10 00:00:00	2013-11-10	2013-11-10 00:00:00	2013-11-10	581452		0	0	0		0	0	0	233156	0	52	40213296		
19031	1571	1551192	1966-01-06	1966-01-06 00:00:00	1966-01-06	1966-01-06 00:00:00	1966-01-06	38000177		0	0	0		0	0	0	105505	0	312617	1551192		
1370	110	40236824	1998-03-13	1998-03-13 00:00:00	1998-03-20	1998-03-20 00:00:00	1998-03-20	38000177		0	0	7		0	0	0	7293	0	1094107	40236824		
23333	1923	1713671	1940-05-14	1940-05-14 00:00:00	1940-08-06	1940-08-06 00:00:00	1940-08-06	38000177		0	0	84		0	0	0	127950	0	562251	1713671		
172308	3788	40213227	1996-05-07	1996-05-07 00:00:00	1996-05-07	1996-05-07 00:00:00	1996-05-07	581452		0	0	0		0	0	0	251844	0	113	40213227		
27918	2309	19059056	1977-01-08	1977-01-08 00:00:00	1977-01-22	1977-01-22 00:00:00	1977-01-22	38000177		0	0	14		0	0	0	153629	0	243670	19059056		
40182	3325	19133873	1974-05-02	1974-05-02 00:00:00	1974-05-14	1974-05-14 00:00:00	1974-05-14	38000177		0	0	12		0	0	0	220692	0	834061	19133873		
12140	1018	1127078	1972-11-01	1972-11-01 00:00:00	1972-12-01	1972-12-01 00:00:00	1972-12-01	38000177		0	0	30		0	0	0	67009	0	282464	1127078		
239759	5262	40213160	1971-09-12	1971-09-12 00:00:00	1971-09-12	1971-09-12 00:00:00	1971-09-12	581452		0	0	0		0	0	0	350087	0	10	40213160		
43525	3609	1127078	1982-10-18	1982-10-18 00:00:00	1982-11-08	1982-11-08 00:00:00	1982-11-08	38000177		0	0	21		0	0	0	239784	0	282464	1127078		
145968	3211	40213227	1999-07-23	1999-07-23 00:00:00	1999-07-23	1999-07-23 00:00:00	1999-07-23	581452		0	0	0		0	0	0	213356	0	113	40213227		
44477	969	40213227	2000-09-17	2000-09-17 00:00:00	2000-09-17	2000-09-17 00:00:00	2000-09-17	581452		0	0	0		0	0	0	64466	0	113	40213227		
5272	442	19059056	1952-02-28	1952-02-28 00:00:00	1952-03-13	1952-03-13 00:00:00	1952-03-13	38000177		0	0	14		0	0	0	29347	0	243670	19059056		
54171	4501	1124300	2014-11-10	2014-11-10 00:00:00	2014-11-10	2014-11-10 00:00:00	\N	38000177		0	0	0		0	0	0	299752	0	00781178901	45011828		
33634	2782	19059056	1921-08-10	1921-08-10 00:00:00	1921-08-24	1921-08-24 00:00:00	1921-08-24	38000177		0	0	14		0	0	0	184428	0	243670	19059056		
17514	1448	1127433	1973-12-24	1973-12-24 00:00:00	1974-01-07	1974-01-07 00:00:00	1974-01-07	38000177		0	0	14		0	0	0	96586	0	313782	1127433		
58615	4867	1115171	1995-04-01	1995-04-01 00:00:00	1995-06-30	1995-06-30 00:00:00	1995-06-30	38000177		0	0	90		0	0	0	323687	0	849574	1115171		
803	65	1713671	1968-07-29	1968-07-29 00:00:00	1968-08-19	1968-08-19 00:00:00	1968-08-19	38000177		0	0	21		0	0	0	4417	0	562251	1713671		
11007	918	19133905	1935-06-25	1935-06-25 00:00:00	1935-07-02	1935-07-02 00:00:00	1935-07-02	38000177		0	0	7		0	0	0	61136	0	834102	19133905		
16086	1334	1127078	1973-09-05	1973-09-05 00:00:00	1973-09-26	1973-09-26 00:00:00	1973-09-26	38000177		0	0	21		0	0	0	88530	0	282464	1127078		
8519	710	1127433	1992-07-05	1992-07-05 00:00:00	1992-07-12	1992-07-12 00:00:00	1992-07-12	38000177		0	0	7		0	0	0	47026	0	313782	1127433		
50516	4199	19059056	1940-02-17	1940-02-17 00:00:00	1940-05-17	1940-05-17 00:00:00	1940-05-17	38000177		0	0	90		0	0	0	278705	0	243670	19059056		
22440	1845	40229134	1972-04-22	1972-04-22 00:00:00	1972-05-06	1972-05-06 00:00:00	1972-05-06	38000177		0	0	14		0	0	0	123365	0	1043400	40229134		
54929	4562	1127433	2015-10-09	2015-10-09 00:00:00	2015-10-23	2015-10-23 00:00:00	2015-10-23	38000177		0	0	14		0	0	0	304044	0	313782	1127433		
40582	3364	19074843	1980-08-02	1980-08-02 00:00:00	1980-08-16	1980-08-16 00:00:00	1980-08-16	38000177		0	0	14		0	0	0	223092	0	309045	19074843		
47695	3955	1115171	1994-02-28	1994-02-28 00:00:00	1994-05-29	1994-05-29 00:00:00	1994-05-29	38000177		0	0	90		0	0	0	262901	0	849574	1115171		
36164	2980	1118084	2007-11-25	2007-11-25 00:00:00	2007-11-25	2007-11-25 00:00:00	\N	38000177		0	0	0		0	0	0	198913	0	00025152531	44923712		
16280	1352	1127433	1993-02-28	1993-02-28 00:00:00	1993-03-14	1993-03-14 00:00:00	1993-03-14	38000177		0	0	14		0	0	0	89598	0	313782	1127433		
154196	3394	40213160	1966-06-11	1966-06-11 00:00:00	1966-06-11	1966-06-11 00:00:00	1966-06-11	581452		0	0	0		0	0	0	225125	0	10	40213160		
852	69	40229134	2000-11-15	2000-11-15 00:00:00	2000-11-22	2000-11-22 00:00:00	2000-11-22	38000177		0	0	7		0	0	0	4701	0	1043400	40229134		
58433	4853	1127433	2002-06-29	2002-06-29 00:00:00	2002-07-13	2002-07-13 00:00:00	2002-07-13	38000177		0	0	14		0	0	0	322913	0	313782	1127433		
34131	2821	1115171	2005-05-07	2005-05-07 00:00:00	2005-06-06	2005-06-06 00:00:00	2005-06-06	38000177		0	0	30		0	0	0	186856	0	849574	1115171		
26948	2222	40229134	1979-05-13	1979-05-13 00:00:00	1979-05-20	1979-05-20 00:00:00	1979-05-20	38000177		0	0	7		0	0	0	147924	0	1043400	40229134		
26985	2226	40229134	1957-08-11	1957-08-11 00:00:00	1957-08-25	1957-08-25 00:00:00	1957-08-25	38000177		0	0	14		0	0	0	148137	0	1043400	40229134		
89574	1965	40213296	2013-02-03	2013-02-03 00:00:00	2013-02-03	2013-02-03 00:00:00	2013-02-03	581452		0	0	0		0	0	0	130632	0	52	40213296		
4461	370	19059056	1965-08-19	1965-08-19 00:00:00	1965-09-02	1965-09-02 00:00:00	1965-09-02	38000177		0	0	14		0	0	0	24620	0	243670	19059056		
9975	836	1127433	1983-06-11	1983-06-11 00:00:00	1983-06-18	1983-06-18 00:00:00	1983-06-18	38000177		0	0	7		0	0	0	55328	0	313782	1127433		
98493	2156	40213227	2007-06-14	2007-06-14 00:00:00	2007-06-14	2007-06-14 00:00:00	2007-06-14	581452		0	0	0		0	0	0	143695	0	113	40213227		
15069	1258	46233988	1968-11-02	1968-11-02 00:00:00	1968-11-16	1968-11-16 00:00:00	1968-11-16	38000177		0	0	14		0	0	0	82867	0	1652673	46233988		
86546	1898	40213306	1993-11-29	1993-11-29 00:00:00	1993-11-29	1993-11-29 00:00:00	1993-11-29	581452		0	0	0		0	0	0	126366	0	43	40213306		
3021	245	40229134	1917-05-16	1917-05-16 00:00:00	1917-05-30	1917-05-30 00:00:00	1917-05-30	38000177		0	0	14		0	0	0	16420	0	1043400	40229134		
140471	3084	40213160	1982-11-03	1982-11-03 00:00:00	1982-11-03	1982-11-03 00:00:00	1982-11-03	581452		0	0	0		0	0	0	205359	0	10	40213160		
19546	1609	19006318	1946-10-15	1946-10-15 00:00:00	1946-10-29	1946-10-29 00:00:00	1946-10-29	38000177		0	0	14		0	0	0	108112	0	105078	19006318		
166264	3654	40213296	2011-07-09	2011-07-09 00:00:00	2011-07-09	2011-07-09 00:00:00	2011-07-09	581452		0	0	0		0	0	0	243199	0	52	40213296		
18315	1516	1118084	1979-07-12	1979-07-12 00:00:00	1979-07-12	1979-07-12 00:00:00	\N	38000177		0	0	0		0	0	0	101249	0	00025152531	44923712		
139119	3056	40213160	1957-04-05	1957-04-05 00:00:00	1957-04-05	1957-04-05 00:00:00	1957-04-05	581452		0	0	0		0	0	0	203265	0	10	40213160		
43482	3604	19075001	1987-08-08	1987-08-08 00:00:00	1987-08-22	1987-08-22 00:00:00	1987-08-22	38000177		0	0	14		0	0	0	239564	0	309097	19075001		
63723	5295	1127433	1971-02-18	1971-02-18 00:00:00	1971-04-19	1971-04-19 00:00:00	1971-04-19	38000177		0	0	60		0	0	0	352210	0	313782	1127433		
54019	4488	19133873	1978-10-08	1978-10-08 00:00:00	1978-10-21	1978-10-21 00:00:00	1978-10-21	38000177		0	0	13		0	0	0	298820	0	834061	19133873		
2421	192	1115171	1996-04-15	1996-04-15 00:00:00	1996-05-06	1996-05-06 00:00:00	1996-05-06	38000177		0	0	21		0	0	0	13219	0	849574	1115171		
81604	1783	40213306	1982-07-19	1982-07-19 00:00:00	1982-07-19	1982-07-19 00:00:00	1982-07-19	581452		0	0	0		0	0	0	119406	0	43	40213306		
59238	4923	1127078	1977-01-24	1977-01-24 00:00:00	1977-03-25	1977-03-25 00:00:00	1977-03-25	38000177		0	0	60		0	0	0	327124	0	282464	1127078		
30659	2542	1115171	1998-11-23	1998-11-23 00:00:00	1998-12-07	1998-12-07 00:00:00	1998-12-07	38000177		0	0	14		0	0	0	168092	0	849574	1115171		
53961	1180	40213160	1956-12-19	1956-12-19 00:00:00	1956-12-19	1956-12-19 00:00:00	1956-12-19	581452		0	0	0		0	0	0	77906	0	10	40213160		
60325	5017	1127433	2011-10-15	2011-10-15 00:00:00	2011-10-29	2011-10-29 00:00:00	2011-10-29	38000177		0	0	14		0	0	0	333440	0	313782	1127433		
60216	5004	19078461	2015-07-17	2015-07-17 00:00:00	2015-09-15	2015-09-15 00:00:00	2015-09-15	38000177		0	0	60		0	0	0	332907	0	310965	19078461		
3376	279	1118084	1991-05-09	1991-05-09 00:00:00	1991-05-09	1991-05-09 00:00:00	\N	38000177		0	0	0		0	0	0	18607	0	00025152531	44923712		
220020	4829	40213227	1994-11-04	1994-11-04 00:00:00	1994-11-04	1994-11-04 00:00:00	1994-11-04	581452		0	0	0		0	0	0	321305	0	113	40213227		
9489	789	46233988	1972-07-26	1972-07-26 00:00:00	1972-08-09	1972-08-09 00:00:00	1972-08-09	38000177		0	0	14		0	0	0	52465	0	1652673	46233988		
26010	2140	40229134	1963-06-21	1963-06-21 00:00:00	1963-07-05	1963-07-05 00:00:00	1963-07-05	38000177		0	0	14		0	0	0	142529	0	1043400	40229134		
62436	5196	40229134	1958-12-26	1958-12-26 00:00:00	1959-01-02	1959-01-02 00:00:00	1959-01-02	38000177		0	0	7		0	0	0	345551	0	1043400	40229134		
22941	498	40213227	2002-02-07	2002-02-07 00:00:00	2002-02-07	2002-02-07 00:00:00	2002-02-07	581452		0	0	0		0	0	0	33251	0	113	40213227		
20143	1656	42902245	2003-09-21	2003-09-21 00:00:00	2004-09-15	2004-09-15 00:00:00	2004-09-15	38000177		0	0	360		0	0	0	111071	0	1359133	42902245		
11697	972	40231925	2016-01-11	2016-01-11 00:00:00	2016-01-11	2016-01-11 00:00:00	\N	38000177		0	0	0		0	0	0	64714	0	1049221	40231925		
159628	3513	40213227	2013-11-10	2013-11-10 00:00:00	2013-11-10	2013-11-10 00:00:00	2013-11-10	581452		0	0	0		0	0	0	233156	0	113	40213227		
19032	1571	1127433	1980-03-06	1980-03-06 00:00:00	1980-03-13	1980-03-13 00:00:00	1980-03-13	38000177		0	0	7		0	0	0	105429	0	313782	1127433		
1371	110	1127433	2001-04-06	2001-04-06 00:00:00	2001-04-13	2001-04-13 00:00:00	2001-04-13	38000177		0	0	7		0	0	0	7323	0	313782	1127433		
23334	1923	1713671	1980-11-01	1980-11-01 00:00:00	1980-11-22	1980-11-22 00:00:00	1980-11-22	38000177		0	0	21		0	0	0	127906	0	562251	1713671		
172318	3788	40213227	2006-08-22	2006-08-22 00:00:00	2006-08-22	2006-08-22 00:00:00	2006-08-22	581452		0	0	0		0	0	0	251845	0	113	40213227		
27919	2309	1713671	2000-10-31	2000-10-31 00:00:00	2000-11-14	2000-11-14 00:00:00	2000-11-14	38000177		0	0	14		0	0	0	153617	0	562251	1713671		
33925	2806	19059056	1957-09-22	1957-09-22 00:00:00	1957-10-13	1957-10-13 00:00:00	1957-10-13	38000177		0	0	21		0	0	0	185958	0	243670	19059056		
12141	1018	1127078	1972-02-05	1972-02-05 00:00:00	1972-02-19	1972-02-19 00:00:00	1972-02-19	38000177		0	0	14		0	0	0	67051	0	282464	1127078		
102964	2258	40213160	1960-12-01	1960-12-01 00:00:00	1960-12-01	1960-12-01 00:00:00	1960-12-01	581452		0	0	0		0	0	0	150028	0	10	40213160		
43526	3609	19133905	2008-07-26	2008-07-26 00:00:00	2008-08-03	2008-08-03 00:00:00	2008-08-03	38000177		0	0	8		0	0	0	239791	0	834102	19133905		
145980	3211	40213160	1957-05-03	1957-05-03 00:00:00	1957-05-03	1957-05-03 00:00:00	1957-05-03	581452		0	0	0		0	0	0	213399	0	10	40213160		
44478	969	40213306	2000-09-17	2000-09-17 00:00:00	2000-09-17	2000-09-17 00:00:00	2000-09-17	581452		0	0	0		0	0	0	64466	0	43	40213306		
5273	442	19077572	2016-07-02	2016-07-02 00:00:00	2016-07-02	2016-07-02 00:00:00	\N	38000177		0	0	0		0	0	0	29276	0	310436	19077572		
54172	4501	43012754	1998-09-25	1998-09-25 00:00:00	1999-09-20	1999-09-20 00:00:00	1999-09-20	38000177		0	0	360		0	0	0	299720	0	1366343	43012754		
33635	2782	19059056	1936-08-21	1936-08-21 00:00:00	1936-09-18	1936-09-18 00:00:00	1936-09-18	38000177		0	0	28		0	0	0	184403	0	243670	19059056		
17515	1448	1713671	1984-10-01	1984-10-01 00:00:00	1984-10-22	1984-10-22 00:00:00	1984-10-22	38000177		0	0	21		0	0	0	96601	0	562251	1713671		
58616	4867	19059056	1968-09-21	1968-09-21 00:00:00	1968-10-05	1968-10-05 00:00:00	1968-10-05	38000177		0	0	14		0	0	0	323683	0	243670	19059056		
804	65	19059056	1969-06-18	1969-06-18 00:00:00	1969-07-02	1969-07-02 00:00:00	1969-07-02	38000177		0	0	14		0	0	0	4380	0	243670	19059056		
11008	918	19059056	1913-10-07	1913-10-07 00:00:00	1913-10-21	1913-10-21 00:00:00	1913-10-21	38000177		0	0	14		0	0	0	61190	0	243670	19059056		
16087	1334	19059056	1971-10-11	1971-10-11 00:00:00	1971-10-25	1971-10-25 00:00:00	1971-10-25	38000177		0	0	14		0	0	0	88508	0	243670	19059056		
8520	710	19059056	1964-01-20	1964-01-20 00:00:00	1964-02-03	1964-02-03 00:00:00	1964-02-03	38000177		0	0	14		0	0	0	47046	0	243670	19059056		
50517	4199	40231925	1970-06-14	1970-06-14 00:00:00	1970-06-14	1970-06-14 00:00:00	\N	38000177		0	0	0		0	0	0	278707	0	1049221	40231925		
22441	1845	1127433	1996-04-15	1996-04-15 00:00:00	1996-04-29	1996-04-29 00:00:00	1996-04-29	38000177		0	0	14		0	0	0	123325	0	313782	1127433		
54930	4562	1127433	2016-04-28	2016-04-28 00:00:00	2016-05-12	2016-05-12 00:00:00	2016-05-12	38000177		0	0	14		0	0	0	303986	0	313782	1127433		
119150	2620	40213160	1964-04-21	1964-04-21 00:00:00	1964-04-21	1964-04-21 00:00:00	1964-04-21	581452		0	0	0		0	0	0	173313	0	10	40213160		
47696	3955	19078461	1976-03-20	1976-03-20 00:00:00	1976-04-03	1976-04-03 00:00:00	1976-04-03	38000177		0	0	14		0	0	0	262844	0	310965	19078461		
36165	2980	1127078	1981-02-18	1981-02-18 00:00:00	1981-03-18	1981-03-18 00:00:00	1981-03-18	38000177		0	0	28		0	0	0	198975	0	282464	1127078		
16281	1352	19073188	1993-02-28	1993-02-28 00:00:00	1993-03-14	1993-03-14 00:00:00	1993-03-14	38000177		0	0	14		0	0	0	89598	0	308192	19073188		
154198	3394	40213227	2016-10-08	2016-10-08 00:00:00	2016-10-08	2016-10-08 00:00:00	2016-10-08	581452		0	0	0		0	0	0	225171	0	113	40213227		
853	69	40229134	1955-12-24	1955-12-24 00:00:00	1956-01-07	1956-01-07 00:00:00	1956-01-07	38000177		0	0	14		0	0	0	4694	0	1043400	40229134		
58434	4853	1127433	2000-07-20	2000-07-20 00:00:00	2000-08-03	2000-08-03 00:00:00	2000-08-03	38000177		0	0	14		0	0	0	322927	0	313782	1127433		
34132	2821	40229134	1999-03-26	1999-03-26 00:00:00	1999-04-02	1999-04-02 00:00:00	1999-04-02	38000177		0	0	7		0	0	0	186932	0	1043400	40229134		
26949	2222	19059056	1992-08-19	1992-08-19 00:00:00	1992-09-09	1992-09-09 00:00:00	1992-09-09	38000177		0	0	21		0	0	0	147957	0	243670	19059056		
26986	2226	1127433	1971-02-23	1971-02-23 00:00:00	1971-03-02	1971-03-02 00:00:00	1971-03-02	38000177		0	0	7		0	0	0	148144	0	313782	1127433		
89577	1965	40213227	1995-05-07	1995-05-07 00:00:00	1995-05-07	1995-05-07 00:00:00	1995-05-07	581452		0	0	0		0	0	0	130637	0	113	40213227		
4462	370	1127078	1967-12-07	1967-12-07 00:00:00	1968-01-04	1968-01-04 00:00:00	1968-01-04	38000177		0	0	28		0	0	0	24581	0	282464	1127078		
9976	836	1127433	1990-06-09	1990-06-09 00:00:00	1990-06-16	1990-06-16 00:00:00	1990-06-16	38000177		0	0	7		0	0	0	55295	0	313782	1127433		
38379	3175	1713671	1994-08-07	1994-08-07 00:00:00	1994-08-28	1994-08-28 00:00:00	1994-08-28	38000177		0	0	21		0	0	0	211019	0	562251	1713671		
15070	1258	19078461	2006-02-05	2006-02-05 00:00:00	2006-02-26	2006-02-26 00:00:00	2006-02-26	38000177		0	0	21		0	0	0	82899	0	310965	19078461		
86556	1898	40213296	2010-12-20	2010-12-20 00:00:00	2010-12-20	2010-12-20 00:00:00	2010-12-20	581452		0	0	0		0	0	0	126372	0	52	40213296		
3022	245	19059056	1920-06-10	1920-06-10 00:00:00	1920-06-24	1920-06-24 00:00:00	1920-06-24	38000177		0	0	14		0	0	0	16430	0	243670	19059056		
140473	3084	40213314	1978-03-01	1978-03-01 00:00:00	1978-03-01	1978-03-01 00:00:00	1978-03-01	581452		0	0	0		0	0	0	205403	0	49	40213314		
19547	1609	19075601	1998-10-28	1998-10-28 00:00:00	1998-10-29	1998-10-29 00:00:00	1998-10-29	38000177		0	0	1		0	0	0	108089	0	309362	19075601		
166267	3654	40213160	1971-11-12	1971-11-12 00:00:00	1971-11-12	1971-11-12 00:00:00	1971-11-12	581452		0	0	0		0	0	0	\N	0	10	40213160		
18316	1516	1127433	1967-12-02	1967-12-02 00:00:00	1967-12-23	1967-12-23 00:00:00	1967-12-23	38000177		0	0	21		0	0	0	101268	0	313782	1127433		
206164	4525	40213306	1990-02-07	1990-02-07 00:00:00	1990-02-07	1990-02-07 00:00:00	1990-02-07	581452		0	0	0		0	0	0	301296	0	43	40213306		
43483	3604	1127078	1987-08-08	1987-08-08 00:00:00	1987-08-22	1987-08-22 00:00:00	1987-08-22	38000177		0	0	14		0	0	0	239564	0	282464	1127078		
63724	5295	1127433	1981-11-16	1981-11-16 00:00:00	1981-11-23	1981-11-23 00:00:00	1981-11-23	38000177		0	0	7		0	0	0	352243	0	313782	1127433		
54020	4488	1713671	1984-06-03	1984-06-03 00:00:00	1984-06-17	1984-06-17 00:00:00	1984-06-17	38000177		0	0	14		0	0	0	298780	0	562251	1713671		
2422	192	19059056	1944-04-24	1944-04-24 00:00:00	1944-05-15	1944-05-15 00:00:00	1944-05-15	38000177		0	0	21		0	0	0	13214	0	243670	19059056		
81615	1783	40213160	1960-04-04	1960-04-04 00:00:00	1960-04-04	1960-04-04 00:00:00	1960-04-04	581452		0	0	0		0	0	0	119461	0	10	40213160		
59239	4923	1127433	1974-03-13	1974-03-13 00:00:00	1974-03-27	1974-03-27 00:00:00	1974-03-27	38000177		0	0	14		0	0	0	327133	0	313782	1127433		
30660	2542	19133905	2006-12-30	2006-12-30 00:00:00	2007-01-11	2007-01-11 00:00:00	2007-01-11	38000177		0	0	12		0	0	0	168114	0	834102	19133905		
53965	1180	40213260	2006-12-06	2006-12-06 00:00:00	2006-12-06	2006-12-06 00:00:00	2006-12-06	581452		0	0	0		0	0	0	77958	0	121	40213260		
60326	5017	19133873	1981-11-05	1981-11-05 00:00:00	1981-11-15	1981-11-15 00:00:00	1981-11-15	38000177		0	0	10		0	0	0	333446	0	834061	19133873		
60217	5004	1150771	1977-11-26	1977-11-26 00:00:00	1977-11-26	1977-11-26 00:00:00	\N	38000177		0	0	0		0	0	0	332831	0	197378	1150771		
3377	279	1127433	1958-10-25	1958-10-25 00:00:00	1958-11-01	1958-11-01 00:00:00	1958-11-01	38000177		0	0	7		0	0	0	18652	0	313782	1127433		
220021	4829	40213306	1994-11-04	1994-11-04 00:00:00	1994-11-04	1994-11-04 00:00:00	1994-11-04	581452		0	0	0		0	0	0	321305	0	43	40213306		
9490	789	1713671	1993-01-23	1993-01-23 00:00:00	1993-02-13	1993-02-13 00:00:00	1993-02-13	38000177		0	0	21		0	0	0	52476	0	562251	1713671		
26011	2140	40229134	1962-10-08	1962-10-08 00:00:00	1962-10-22	1962-10-22 00:00:00	1962-10-22	38000177		0	0	14		0	0	0	142560	0	1043400	40229134		
62438	5196	1127433	2005-09-04	2005-09-04 00:00:00	2005-09-11	2005-09-11 00:00:00	2005-09-11	38000177		0	0	7		0	0	0	345513	0	313782	1127433		
22943	498	40213227	1993-01-28	1993-01-28 00:00:00	1993-01-28	1993-01-28 00:00:00	1993-01-28	581452		0	0	0		0	0	0	33248	0	113	40213227		
20144	1656	19132304	2012-08-13	2012-08-13 00:00:00	2013-08-13	2013-08-13 00:00:00	2013-08-13	38000177		0	0	365		0	0	0	111108	0	807283	19132304		
11698	972	1127078	1967-01-27	1967-01-27 00:00:00	1967-02-10	1967-02-10 00:00:00	1967-02-10	38000177		0	0	14		0	0	0	64713	0	282464	1127078		
159632	3513	40213160	1972-06-25	1972-06-25 00:00:00	1972-06-25	1972-06-25 00:00:00	1972-06-25	581452		0	0	0		0	0	0	233132	0	10	40213160		
19033	1571	40229134	1959-07-08	1959-07-08 00:00:00	1959-07-22	1959-07-22 00:00:00	1959-07-22	38000177		0	0	14		0	0	0	105479	0	1043400	40229134		
1372	110	19128065	1990-02-11	1990-02-11 00:00:00	1991-02-06	1991-02-06 00:00:00	1991-02-06	38000177		0	0	360		0	0	0	7312	0	749882	19128065		
23335	1923	40222846	2011-04-16	2011-04-16 00:00:00	2011-04-16	2011-04-16 00:00:00	\N	38000177		0	0	0		0	0	0	127970	0	996740	40222846		
172319	3788	40213296	2006-08-22	2006-08-22 00:00:00	2006-08-22	2006-08-22 00:00:00	2006-08-22	581452		0	0	0		0	0	0	251845	0	52	40213296		
27920	2309	1127433	1987-03-31	1987-03-31 00:00:00	1987-04-28	1987-04-28 00:00:00	1987-04-28	38000177		0	0	28		0	0	0	153632	0	313782	1127433		
33926	2806	1127433	1982-01-10	1982-01-10 00:00:00	1982-04-10	1982-04-10 00:00:00	1982-04-10	38000177		0	0	90		0	0	0	185960	0	313782	1127433		
12142	1018	1127433	1998-03-06	1998-03-06 00:00:00	1998-03-20	1998-03-20 00:00:00	1998-03-20	38000177		0	0	14		0	0	0	67031	0	313782	1127433		
89923	1973	40213160	1976-05-17	1976-05-17 00:00:00	1976-05-17	1976-05-17 00:00:00	1976-05-17	581452		0	0	0		0	0	0	131167	0	10	40213160		
43527	3609	1127433	1992-03-01	1992-03-01 00:00:00	1992-03-08	1992-03-08 00:00:00	1992-03-08	38000177		0	0	7		0	0	0	239746	0	313782	1127433		
145987	3211	40213227	2007-11-30	2007-11-30 00:00:00	2007-11-30	2007-11-30 00:00:00	2007-11-30	581452		0	0	0		0	0	0	213396	0	113	40213227		
44480	969	40213227	2009-09-27	2009-09-27 00:00:00	2009-09-27	2009-09-27 00:00:00	2009-09-27	581452		0	0	0		0	0	0	64453	0	113	40213227		
5274	442	1127433	1971-07-06	1971-07-06 00:00:00	1971-07-20	1971-07-20 00:00:00	1971-07-20	38000177		0	0	14		0	0	0	29312	0	313782	1127433		
54173	4501	1127078	1976-03-14	1976-03-14 00:00:00	1976-03-28	1976-03-28 00:00:00	1976-03-28	38000177		0	0	14		0	0	0	299715	0	282464	1127078		
33636	2782	19133905	1956-01-04	1956-01-04 00:00:00	1956-01-15	1956-01-15 00:00:00	1956-01-15	38000177		0	0	11		0	0	0	184361	0	834102	19133905		
17516	1448	19128022	1989-03-14	1989-03-14 00:00:00	1990-03-09	1990-03-09 00:00:00	1990-03-09	38000177		0	0	360		0	0	0	96574	0	749785	19128022		
58617	4867	19129655	1968-09-21	1968-09-21 00:00:00	1968-10-05	1968-10-05 00:00:00	1968-10-05	38000177		0	0	14		0	0	0	323683	0	789980	19129655		
805	65	920300	2016-05-02	2016-05-02 00:00:00	2016-05-09	2016-05-09 00:00:00	2016-05-09	38000177		0	0	7		0	0	0	4378	0	311989	920300		
11009	918	19129655	1978-08-01	1978-08-01 00:00:00	1978-08-15	1978-08-15 00:00:00	1978-08-15	38000177		0	0	14		0	0	0	61191	0	789980	19129655		
16088	1334	19059056	1972-08-04	1972-08-04 00:00:00	1972-10-10	1972-10-10 00:00:00	1972-10-10	38000177		0	0	67		0	0	0	88529	0	243670	19059056		
8521	710	40229134	1985-01-21	1985-01-21 00:00:00	1985-01-28	1985-01-28 00:00:00	1985-01-28	38000177		0	0	7		0	0	0	47003	0	1043400	40229134		
50518	4199	46233710	1970-06-14	1970-06-14 00:00:00	1970-06-28	1970-06-28 00:00:00	1970-06-28	38000177		0	0	14		0	0	0	278707	0	1650142	46233710		
22442	1845	1127433	1979-01-31	1979-01-31 00:00:00	1979-02-14	1979-02-14 00:00:00	1979-02-14	38000177		0	0	14		0	0	0	123326	0	313782	1127433		
54931	4562	19059056	1971-10-17	1971-10-17 00:00:00	1971-11-07	1971-11-07 00:00:00	1971-11-07	38000177		0	0	21		0	0	0	303953	0	243670	19059056		
119163	2620	40213296	2003-11-18	2003-11-18 00:00:00	2003-11-18	2003-11-18 00:00:00	2003-11-18	581452		0	0	0		0	0	0	173266	0	52	40213296		
47697	3955	1713671	1973-06-14	1973-06-14 00:00:00	1973-06-21	1973-06-21 00:00:00	1973-06-21	38000177		0	0	7		0	0	0	262846	0	562251	1713671		
36166	2980	1127433	1993-01-11	1993-01-11 00:00:00	1993-01-18	1993-01-18 00:00:00	1993-01-18	38000177		0	0	7		0	0	0	198890	0	313782	1127433		
16282	1352	19019273	1971-07-29	1971-07-29 00:00:00	1971-07-29	1971-07-29 00:00:00	\N	38000177		0	0	0		0	0	0	89559	0	198014	19019273		
154199	3394	40213260	2016-10-08	2016-10-08 00:00:00	2016-10-08	2016-10-08 00:00:00	2016-10-08	581452		0	0	0		0	0	0	225171	0	121	40213260		
854	69	19059056	1949-05-28	1949-05-28 00:00:00	1949-06-18	1949-06-18 00:00:00	1949-06-18	38000177		0	0	21		0	0	0	4708	0	243670	19059056		
58435	4853	1127078	1968-03-25	1968-03-25 00:00:00	1968-04-08	1968-04-08 00:00:00	1968-04-08	38000177		0	0	14		0	0	0	322903	0	282464	1127078		
34133	2821	19133905	1993-06-25	1993-06-25 00:00:00	1993-07-08	1993-07-08 00:00:00	1993-07-08	38000177		0	0	13		0	0	0	186866	0	834102	19133905		
26950	2222	1118084	2005-11-04	2005-11-04 00:00:00	2005-11-04	2005-11-04 00:00:00	\N	38000177		0	0	0		0	0	0	147898	0	00025152531	44923712		
26987	2226	1124300	1978-02-03	1978-02-03 00:00:00	1978-02-03	1978-02-03 00:00:00	\N	38000177		0	0	0		0	0	0	148101	0	00781178901	45011828		
89578	1965	40213306	1995-05-07	1995-05-07 00:00:00	1995-05-07	1995-05-07 00:00:00	1995-05-07	581452		0	0	0		0	0	0	130637	0	43	40213306		
4463	370	19006318	1967-12-07	1967-12-07 00:00:00	1968-01-04	1968-01-04 00:00:00	1968-01-04	38000177		0	0	28		0	0	0	24581	0	105078	19006318		
9977	836	19019979	1987-06-02	1987-06-02 00:00:00	1987-06-23	1987-06-23 00:00:00	1987-06-23	38000177		0	0	21		0	0	0	55324	0	198405	19019979		
38380	3175	19078461	1993-12-24	1993-12-24 00:00:00	1994-01-07	1994-01-07 00:00:00	1994-01-07	38000177		0	0	14		0	0	0	211053	0	310965	19078461		
15071	1258	19133905	1997-11-30	1997-11-30 00:00:00	1997-12-10	1997-12-10 00:00:00	1997-12-10	38000177		0	0	10		0	0	0	82865	0	834102	19133905		
86562	1898	40213160	1971-03-15	1971-03-15 00:00:00	1971-03-15	1971-03-15 00:00:00	1971-03-15	581452		0	0	0		0	0	0	126354	0	10	40213160		
3023	245	1127433	2014-07-23	2014-07-23 00:00:00	2014-07-30	2014-07-30 00:00:00	2014-07-30	38000177		0	0	7		0	0	0	16495	0	313782	1127433		
140474	3084	40213160	1978-03-01	1978-03-01 00:00:00	1978-03-01	1978-03-01 00:00:00	1978-03-01	581452		0	0	0		0	0	0	205403	0	10	40213160		
19548	1609	40220960	1998-10-28	1998-10-28 00:00:00	1998-10-29	1998-10-29 00:00:00	1998-10-29	38000177		0	0	1		0	0	0	108089	0	1804799	40220960		
53051	4408	19078461	2014-05-29	2014-05-29 00:00:00	2014-06-19	2014-06-19 00:00:00	2014-06-19	38000177		0	0	21		0	0	0	293001	0	310965	19078461		
18317	1516	19059056	1966-12-23	1966-12-23 00:00:00	1967-01-06	1967-01-06 00:00:00	1967-01-06	38000177		0	0	14		0	0	0	101267	0	243670	19059056		
206172	4525	40213227	2010-02-10	2010-02-10 00:00:00	2010-02-10	2010-02-10 00:00:00	2010-02-10	581452		0	0	0		0	0	0	301315	0	113	40213227		
53953	4484	19133905	2001-01-15	2001-01-15 00:00:00	2001-01-24	2001-01-24 00:00:00	2001-01-24	38000177		0	0	9		0	0	0	298494	0	834102	19133905		
63725	5295	19059056	1949-05-15	1949-05-15 00:00:00	1949-05-29	1949-05-29 00:00:00	1949-05-29	38000177		0	0	14		0	0	0	352219	0	243670	19059056		
54021	4488	1124300	2018-02-10	2018-02-10 00:00:00	2018-02-10	2018-02-10 00:00:00	\N	38000177		0	0	0		0	0	0	298781	0	00781178901	45011828		
21401	1760	1118084	2017-08-23	2017-08-23 00:00:00	2017-08-23	2017-08-23 00:00:00	\N	38000177		0	0	0		0	0	0	117659	0	00025152531	44923712		
81620	1783	40213296	2001-11-12	2001-11-12 00:00:00	2001-11-12	2001-11-12 00:00:00	2001-11-12	581452		0	0	0		0	0	0	119431	0	52	40213296		
59240	4924	19008572	1980-04-11	1980-04-11 00:00:00	1980-05-02	1980-05-02 00:00:00	1980-05-02	38000177		0	0	21		0	0	0	327225	0	106258	19008572		
30661	2542	1127433	2005-04-04	2005-04-04 00:00:00	2005-04-11	2005-04-11 00:00:00	2005-04-11	38000177		0	0	7		0	0	0	168155	0	313782	1127433		
144569	3178	40213260	2007-09-29	2007-09-29 00:00:00	2007-09-29	2007-09-29 00:00:00	2007-09-29	581452		0	0	0		0	0	0	211413	0	121	40213260		
10279	219	40213160	1968-09-07	1968-09-07 00:00:00	1968-09-07	1968-09-07 00:00:00	1968-09-07	581452		0	0	0		0	0	0	14782	0	10	40213160		
60218	5005	19128065	1990-06-12	1990-06-12 00:00:00	1991-06-07	1991-06-07 00:00:00	1991-06-07	38000177		0	0	360		0	0	0	332932	0	749882	19128065		
3378	279	19059056	1968-10-01	1968-10-01 00:00:00	1968-10-15	1968-10-15 00:00:00	1968-10-15	38000177		0	0	14		0	0	0	18635	0	243670	19059056		
220025	4829	40213227	2014-10-24	2014-10-24 00:00:00	2014-10-24	2014-10-24 00:00:00	2014-10-24	581452		0	0	0		0	0	0	321309	0	113	40213227		
9491	789	19133873	1985-03-21	1985-03-21 00:00:00	1985-03-30	1985-03-30 00:00:00	1985-03-30	38000177		0	0	9		0	0	0	52493	0	834061	19133873		
26012	2140	1127433	1998-03-20	1998-03-20 00:00:00	1998-04-03	1998-04-03 00:00:00	1998-04-03	38000177		0	0	14		0	0	0	142488	0	313782	1127433		
9582	800	1127433	1973-06-21	1973-06-21 00:00:00	1973-06-28	1973-06-28 00:00:00	1973-06-28	38000177		0	0	7		0	0	0	53152	0	313782	1127433		
22944	498	40213306	1993-01-28	1993-01-28 00:00:00	1993-01-28	1993-01-28 00:00:00	1993-01-28	581452		0	0	0		0	0	0	33248	0	43	40213306		
20145	1656	1519937	2011-08-19	2011-08-19 00:00:00	2012-08-13	2012-08-13 00:00:00	2012-08-13	38000177		0	0	360		0	0	0	111106	0	389221	1519937		
11699	972	46233988	1967-01-27	1967-01-27 00:00:00	1967-02-10	1967-02-10 00:00:00	1967-02-10	38000177		0	0	14		0	0	0	64713	0	1652673	46233988		
159634	3513	40213227	1995-03-12	1995-03-12 00:00:00	1995-03-12	1995-03-12 00:00:00	1995-03-12	581452		0	0	0		0	0	0	233154	0	113	40213227		
19034	1571	1713671	1994-05-18	1994-05-18 00:00:00	1994-06-01	1994-06-01 00:00:00	1994-06-01	38000177		0	0	14		0	0	0	105487	0	562251	1713671		
1373	110	19128022	1993-02-03	1993-02-03 00:00:00	1994-01-29	1994-01-29 00:00:00	1994-01-29	38000177		0	0	360		0	0	0	7338	0	749785	19128022		
23336	1923	19006318	1948-09-29	1948-09-29 00:00:00	1948-10-13	1948-10-13 00:00:00	1948-10-13	38000177		0	0	14		0	0	0	127857	0	105078	19006318		
172326	3788	40213306	1987-04-28	1987-04-28 00:00:00	1987-04-28	1987-04-28 00:00:00	1987-04-28	581452		0	0	0		0	0	0	251806	0	43	40213306		
27921	2309	19133873	1983-05-19	1983-05-19 00:00:00	1983-05-27	1983-05-27 00:00:00	1983-05-27	38000177		0	0	8		0	0	0	153621	0	834061	19133873		
33927	2806	19128065	1976-02-25	1976-02-25 00:00:00	1977-02-19	1977-02-19 00:00:00	1977-02-19	38000177		0	0	360		0	0	0	185996	0	749882	19128065		
12355	1039	1115171	2001-09-08	2001-09-08 00:00:00	2001-10-06	2001-10-06 00:00:00	2001-10-06	38000177		0	0	28		0	0	0	68333	0	849574	1115171		
89927	1973	40213296	2014-12-01	2014-12-01 00:00:00	2014-12-01	2014-12-01 00:00:00	2014-12-01	581452		0	0	0		0	0	0	131198	0	52	40213296		
43528	3609	1127433	1990-03-06	1990-03-06 00:00:00	1990-03-27	1990-03-27 00:00:00	1990-03-27	38000177		0	0	21		0	0	0	239787	0	313782	1127433		
145988	3211	40213260	2007-11-30	2007-11-30 00:00:00	2007-11-30	2007-11-30 00:00:00	2007-11-30	581452		0	0	0		0	0	0	213396	0	121	40213260		
44482	969	40213160	1979-01-14	1979-01-14 00:00:00	1979-01-14	1979-01-14 00:00:00	1979-01-14	581452		0	0	0		0	0	0	64450	0	10	40213160		
5275	442	1127433	1992-08-08	1992-08-08 00:00:00	1992-08-22	1992-08-22 00:00:00	1992-08-22	38000177		0	0	14		0	0	0	29287	0	313782	1127433		
54174	4501	46233988	1976-03-14	1976-03-14 00:00:00	1976-03-28	1976-03-28 00:00:00	1976-03-28	38000177		0	0	14		0	0	0	299715	0	1652673	46233988		
33637	2782	19133873	1922-02-08	1922-02-08 00:00:00	1922-02-20	1922-02-20 00:00:00	1922-02-20	38000177		0	0	12		0	0	0	184439	0	834061	19133873		
17517	1448	19128065	1992-02-27	1992-02-27 00:00:00	1993-02-21	1993-02-21 00:00:00	1993-02-21	38000177		0	0	360		0	0	0	96605	0	749882	19128065		
58618	4867	1127433	1988-08-21	1988-08-21 00:00:00	1988-09-04	1988-09-04 00:00:00	1988-09-04	38000177		0	0	14		0	0	0	323686	0	313782	1127433		
806	65	40236824	2016-05-02	2016-05-02 00:00:00	2016-05-16	2016-05-16 00:00:00	2016-05-16	38000177		0	0	14		0	0	0	4378	0	1094107	40236824		
11010	918	1127433	1978-08-01	1978-08-01 00:00:00	1978-08-15	1978-08-15 00:00:00	1978-08-15	38000177		0	0	14		0	0	0	61191	0	313782	1127433		
16089	1334	19073188	1982-06-02	1982-06-02 00:00:00	1982-06-16	1982-06-16 00:00:00	1982-06-16	38000177		0	0	14		0	0	0	88526	0	308192	19073188		
8522	710	1713671	2009-09-16	2009-09-16 00:00:00	2009-09-23	2009-09-23 00:00:00	2009-09-23	38000177		0	0	7		0	0	0	47045	0	562251	1713671		
50519	4199	19059056	1970-06-14	1970-06-14 00:00:00	1970-06-28	1970-06-28 00:00:00	1970-06-28	38000177		0	0	14		0	0	0	278707	0	243670	19059056		
22443	1845	1124300	1997-07-24	1997-07-24 00:00:00	1997-07-24	1997-07-24 00:00:00	\N	38000177		0	0	0		0	0	0	123355	0	00781178901	45011828		
54932	4562	40169216	1964-02-04	1964-02-04 00:00:00	1964-02-04	1964-02-04 00:00:00	\N	38000177		0	0	0		0	0	0	304011	0	895994	40169216		
119168	2620	40213227	1995-02-14	1995-02-14 00:00:00	1995-02-14	1995-02-14 00:00:00	1995-02-14	581452		0	0	0		0	0	0	173296	0	113	40213227		
47698	3955	1118084	1995-03-16	1995-03-16 00:00:00	1995-03-16	1995-03-16 00:00:00	\N	38000177		0	0	0		0	0	0	262849	0	00025152531	44923712		
66668	1459	40213227	2004-08-26	2004-08-26 00:00:00	2004-08-26	2004-08-26 00:00:00	2004-08-26	581452		0	0	0		0	0	0	97245	0	113	40213227		
16283	1352	19089061	1971-07-29	1971-07-29 00:00:00	1971-08-19	1971-08-19 00:00:00	1971-08-19	38000177		0	0	21		0	0	0	89559	0	567645	19089061		
154201	3394	40213227	1999-06-05	1999-06-05 00:00:00	1999-06-05	1999-06-05 00:00:00	1999-06-05	581452		0	0	0		0	0	0	225177	0	113	40213227		
855	69	1127433	1988-02-24	1988-02-24 00:00:00	1988-03-16	1988-03-16 00:00:00	1988-03-16	38000177		0	0	21		0	0	0	4709	0	313782	1127433		
58436	4853	19006318	1968-03-25	1968-03-25 00:00:00	1968-04-08	1968-04-08 00:00:00	1968-04-08	38000177		0	0	14		0	0	0	322903	0	105078	19006318		
34134	2822	1713671	1977-03-26	1977-03-26 00:00:00	1977-04-02	1977-04-02 00:00:00	1977-04-02	38000177		0	0	7		0	0	0	187033	0	562251	1713671		
26951	2222	19129655	1963-12-20	1963-12-20 00:00:00	1964-01-03	1964-01-03 00:00:00	1964-01-03	38000177		0	0	14		0	0	0	147892	0	789980	19129655		
26988	2226	1127433	1988-09-30	1988-09-30 00:00:00	1988-10-07	1988-10-07 00:00:00	1988-10-07	38000177		0	0	7		0	0	0	148119	0	313782	1127433		
89579	1965	40213314	1977-01-02	1977-01-02 00:00:00	1977-01-02	1977-01-02 00:00:00	1977-01-02	581452		0	0	0		0	0	0	130622	0	49	40213314		
4464	370	1124300	2000-01-08	2000-01-08 00:00:00	2000-01-08	2000-01-08 00:00:00	\N	38000177		0	0	0		0	0	0	24599	0	00781178901	45011828		
9978	836	1127433	2010-09-04	2010-09-04 00:00:00	2010-09-18	2010-09-18 00:00:00	2010-09-18	38000177		0	0	14		0	0	0	55332	0	313782	1127433		
38381	3175	19133873	1954-02-25	1954-02-25 00:00:00	1954-03-08	1954-03-08 00:00:00	1954-03-08	38000177		0	0	11		0	0	0	211048	0	834061	19133873		
15072	1258	1127433	2015-11-16	2015-11-16 00:00:00	2015-11-23	2015-11-23 00:00:00	2015-11-23	38000177		0	0	7		0	0	0	82880	0	313782	1127433		
86565	1898	40213160	1975-11-17	1975-11-17 00:00:00	1975-11-17	1975-11-17 00:00:00	1975-11-17	581452		0	0	0		0	0	0	126350	0	10	40213160		
3024	245	1713671	1978-01-18	1978-01-18 00:00:00	1978-03-15	1978-03-15 00:00:00	1978-03-15	38000177		0	0	56		0	0	0	16439	0	562251	1713671		
140479	3084	40213227	2000-04-05	2000-04-05 00:00:00	2000-04-05	2000-04-05 00:00:00	2000-04-05	581452		0	0	0		0	0	0	205376	0	113	40213227		
19549	1609	1124300	1980-01-29	1980-01-29 00:00:00	1980-01-29	1980-01-29 00:00:00	\N	38000177		0	0	0		0	0	0	108125	0	00781178901	45011828		
53052	4408	1127433	1989-10-09	1989-10-09 00:00:00	1989-10-23	1989-10-23 00:00:00	1989-10-23	38000177		0	0	14		0	0	0	293040	0	313782	1127433		
18318	1516	19133905	1959-04-21	1959-04-21 00:00:00	1959-04-29	1959-04-29 00:00:00	1959-04-29	38000177		0	0	8		0	0	0	101274	0	834102	19133905		
206173	4525	40213296	2010-02-10	2010-02-10 00:00:00	2010-02-10	2010-02-10 00:00:00	2010-02-10	581452		0	0	0		0	0	0	301315	0	52	40213296		
53954	4484	1127078	1960-12-24	1960-12-24 00:00:00	1961-01-07	1961-01-07 00:00:00	1961-01-07	38000177		0	0	14		0	0	0	298448	0	282464	1127078		
63726	5295	19006318	1949-05-15	1949-05-15 00:00:00	1949-05-29	1949-05-29 00:00:00	1949-05-29	38000177		0	0	14		0	0	0	352219	0	105078	19006318		
54022	4488	19133905	2002-01-17	2002-01-17 00:00:00	2002-01-30	2002-01-30 00:00:00	2002-01-30	38000177		0	0	13		0	0	0	298792	0	834102	19133905		
21402	1760	19059056	1979-02-23	1979-02-23 00:00:00	1979-03-09	1979-03-09 00:00:00	1979-03-09	38000177		0	0	14		0	0	0	117676	0	243670	19059056		
35871	2953	19133873	1993-12-14	1993-12-14 00:00:00	1993-12-22	1993-12-22 00:00:00	1993-12-22	38000177		0	0	8		0	0	0	197130	0	834061	19133873		
59241	4924	19133873	1980-03-07	1980-03-07 00:00:00	1980-03-17	1980-03-17 00:00:00	1980-03-17	38000177		0	0	10		0	0	0	327149	0	834061	19133873		
30662	2542	19128065	1977-05-27	1977-05-27 00:00:00	1978-05-22	1978-05-22 00:00:00	1978-05-22	38000177		0	0	360		0	0	0	168157	0	749882	19128065		
144581	3178	40213227	2005-09-17	2005-09-17 00:00:00	2005-09-17	2005-09-17 00:00:00	2005-09-17	581452		0	0	0		0	0	0	211443	0	113	40213227		
10280	219	40213160	1968-12-14	1968-12-14 00:00:00	1968-12-14	1968-12-14 00:00:00	1968-12-14	581452		0	0	0		0	0	0	14716	0	10	40213160		
60219	5005	1118084	2008-01-09	2008-01-09 00:00:00	2008-01-09	2008-01-09 00:00:00	\N	38000177		0	0	0		0	0	0	332912	0	00025152531	44923712		
3379	279	1713671	2018-09-16	2018-09-16 00:00:00	2018-09-30	2018-09-30 00:00:00	2018-09-30	38000177		0	0	14		0	0	0	18656	0	562251	1713671		
220026	4829	40213296	2014-10-24	2014-10-24 00:00:00	2014-10-24	2014-10-24 00:00:00	2014-10-24	581452		0	0	0		0	0	0	321309	0	52	40213296		
9492	789	1118084	2014-09-04	2014-09-04 00:00:00	2014-09-04	2014-09-04 00:00:00	\N	38000177		0	0	0		0	0	0	52474	0	00025152531	44923712		
26013	2140	19133905	1989-11-22	1989-11-22 00:00:00	1989-12-04	1989-12-04 00:00:00	1989-12-04	38000177		0	0	12		0	0	0	142487	0	834102	19133905		
9583	800	1713671	1970-12-08	1970-12-08 00:00:00	1970-12-22	1970-12-22 00:00:00	1970-12-22	38000177		0	0	14		0	0	0	53107	0	562251	1713671		
3222	70	40213227	2009-12-20	2009-12-20 00:00:00	2009-12-20	2009-12-20 00:00:00	2009-12-20	581452		0	0	0		0	0	0	4783	0	113	40213227		
20146	1656	40236824	2001-12-26	2001-12-26 00:00:00	2002-01-02	2002-01-02 00:00:00	2002-01-02	38000177		0	0	7		0	0	0	111070	0	1094107	40236824		
11700	973	40229134	1993-12-03	1993-12-03 00:00:00	1993-12-10	1993-12-10 00:00:00	1993-12-10	38000177		0	0	7		0	0	0	64744	0	1043400	40229134		
159635	3513	40213306	1995-03-12	1995-03-12 00:00:00	1995-03-12	1995-03-12 00:00:00	1995-03-12	581452		0	0	0		0	0	0	233154	0	43	40213306		
19035	1571	19059056	1971-02-03	1971-02-03 00:00:00	1971-03-05	1971-03-05 00:00:00	1971-03-05	38000177		0	0	30		0	0	0	105506	0	243670	19059056		
1374	110	1115171	2009-08-18	2009-08-18 00:00:00	2009-09-22	2009-09-22 00:00:00	2009-09-22	38000177		0	0	35		0	0	0	7308	0	849574	1115171		
23337	1923	19059056	1948-09-29	1948-09-29 00:00:00	1948-10-13	1948-10-13 00:00:00	1948-10-13	38000177		0	0	14		0	0	0	127857	0	243670	19059056		
172333	3788	40213160	1965-04-20	1965-04-20 00:00:00	1965-04-20	1965-04-20 00:00:00	1965-04-20	581452		0	0	0		0	0	0	251848	0	10	40213160		
27922	2309	1127433	1999-03-15	1999-03-15 00:00:00	1999-03-29	1999-03-29 00:00:00	1999-03-29	38000177		0	0	14		0	0	0	153623	0	313782	1127433		
33928	2806	19126352	1985-03-07	1985-03-07 00:00:00	1985-03-07	1985-03-07 00:00:00	\N	38000177		0	0	0		0	0	0	185970	0	705129	19126352		
12356	1039	1127433	1995-06-15	1995-06-15 00:00:00	1995-06-29	1995-06-29 00:00:00	1995-06-29	38000177		0	0	14		0	0	0	68340	0	313782	1127433		
89934	1973	40213160	1971-09-13	1971-09-13 00:00:00	1971-09-13	1971-09-13 00:00:00	1971-09-13	581452		0	0	0		0	0	0	131157	0	10	40213160		
43529	3609	1127078	1986-07-11	1986-07-11 00:00:00	1986-07-25	1986-07-25 00:00:00	1986-07-25	38000177		0	0	14		0	0	0	239786	0	282464	1127078		
145994	3211	40213296	1997-07-18	1997-07-18 00:00:00	1997-07-18	1997-07-18 00:00:00	1997-07-18	581452		0	0	0		0	0	0	213391	0	52	40213296		
44491	969	40213314	1979-07-15	1979-07-15 00:00:00	1979-07-15	1979-07-15 00:00:00	1979-07-15	581452		0	0	0		0	0	0	64424	0	49	40213314		
5276	442	45892894	2017-11-24	2017-11-24 00:00:00	2017-11-24	2017-11-24 00:00:00	\N	38000177		0	0	0		0	0	0	29371	0	1599803	45892894		
54175	4501	40224805	1997-09-30	1997-09-30 00:00:00	1998-09-25	1998-09-25 00:00:00	1998-09-25	38000177		0	0	360		0	0	0	299718	0	1000126	40224805		
60420	1321	40213160	1959-10-08	1959-10-08 00:00:00	1959-10-08	1959-10-08 00:00:00	1959-10-08	581452		0	0	0		0	0	0	87662	0	10	40213160		
17518	1448	1713671	1982-04-19	1982-04-19 00:00:00	1982-05-10	1982-05-10 00:00:00	1982-05-10	38000177		0	0	21		0	0	0	96600	0	562251	1713671		
58619	4867	40231925	1926-11-01	1926-11-01 00:00:00	1926-11-01	1926-11-01 00:00:00	\N	38000177		0	0	0		0	0	0	323682	0	1049221	40231925		
807	65	1127433	2001-09-15	2001-09-15 00:00:00	2001-09-22	2001-09-22 00:00:00	2001-09-22	38000177		0	0	7		0	0	0	4421	0	313782	1127433		
11011	918	19059056	1949-01-10	1949-01-10 00:00:00	1949-01-24	1949-01-24 00:00:00	1949-01-24	38000177		0	0	14		0	0	0	61139	0	243670	19059056		
16090	1334	1127433	1982-06-02	1982-06-02 00:00:00	1982-06-16	1982-06-16 00:00:00	1982-06-16	38000177		0	0	14		0	0	0	88526	0	313782	1127433		
8523	710	1127433	1964-10-30	1964-10-30 00:00:00	1964-11-06	1964-11-06 00:00:00	1964-11-06	38000177		0	0	7		0	0	0	47042	0	313782	1127433		
50520	4199	40229134	2011-02-08	2011-02-08 00:00:00	2011-02-15	2011-02-15 00:00:00	2011-02-15	38000177		0	0	7		0	0	0	278691	0	1043400	40229134		
22444	1845	19129655	1964-08-31	1964-08-31 00:00:00	1964-09-14	1964-09-14 00:00:00	1964-09-14	38000177		0	0	14		0	0	0	123302	0	789980	19129655		
54933	4562	1154615	1964-02-04	1964-02-04 00:00:00	1964-02-04	1964-02-04 00:00:00	\N	38000177		0	0	0		0	0	0	304011	0	745679	1154615		
119170	2620	40213227	2014-11-18	2014-11-18 00:00:00	2014-11-18	2014-11-18 00:00:00	2014-11-18	581452		0	0	0		0	0	0	173258	0	113	40213227		
47699	3955	1713671	1969-02-09	1969-02-09 00:00:00	1969-03-02	1969-03-02 00:00:00	1969-03-02	38000177		0	0	21		0	0	0	262827	0	562251	1713671		
66677	1459	40213198	2010-09-30	2010-09-30 00:00:00	2010-09-30	2010-09-30 00:00:00	2010-09-30	581452		0	0	0		0	0	0	97213	0	133	40213198		
16284	1352	1713671	2005-12-05	2005-12-05 00:00:00	2005-12-26	2005-12-26 00:00:00	2005-12-26	38000177		0	0	21		0	0	0	89595	0	562251	1713671		
33897	741	40213227	1996-04-19	1996-04-19 00:00:00	1996-04-19	1996-04-19 00:00:00	1996-04-19	581452		0	0	0		0	0	0	49063	0	113	40213227		
856	69	1713671	1977-10-05	1977-10-05 00:00:00	1977-10-26	1977-10-26 00:00:00	1977-10-26	38000177		0	0	21		0	0	0	4696	0	562251	1713671		
16385	1358	19059056	1959-09-20	1959-09-20 00:00:00	1959-10-04	1959-10-04 00:00:00	1959-10-04	38000177		0	0	14		0	0	0	90098	0	243670	19059056		
34135	2822	40229134	2001-09-04	2001-09-04 00:00:00	2001-09-11	2001-09-11 00:00:00	2001-09-11	38000177		0	0	7		0	0	0	186987	0	1043400	40229134		
26952	2222	1127078	1963-12-20	1963-12-20 00:00:00	1964-01-03	1964-01-03 00:00:00	1964-01-03	38000177		0	0	14		0	0	0	147892	0	282464	1127078		
26989	2226	1127433	1945-05-08	1945-05-08 00:00:00	1945-05-15	1945-05-15 00:00:00	1945-05-15	38000177		0	0	7		0	0	0	148135	0	313782	1127433		
89581	1965	40213160	1973-07-08	1973-07-08 00:00:00	1973-07-08	1973-07-08 00:00:00	1973-07-08	581452		0	0	0		0	0	0	130647	0	10	40213160		
4465	370	1127433	2004-09-25	2004-09-25 00:00:00	2004-10-02	2004-10-02 00:00:00	2004-10-02	38000177		0	0	7		0	0	0	24632	0	313782	1127433		
9979	836	1127433	2008-03-04	2008-03-04 00:00:00	2008-04-01	2008-04-01 00:00:00	2008-04-01	38000177		0	0	28		0	0	0	55326	0	313782	1127433		
38382	3175	19133905	1999-05-16	1999-05-16 00:00:00	1999-05-28	1999-05-28 00:00:00	1999-05-28	38000177		0	0	12		0	0	0	211007	0	834102	19133905		
15073	1258	920300	1984-04-04	1984-04-04 00:00:00	1984-04-11	1984-04-11 00:00:00	1984-04-11	38000177		0	0	7		0	0	0	82882	0	311989	920300		
86570	1898	40213160	1971-05-17	1971-05-17 00:00:00	1971-05-17	1971-05-17 00:00:00	1971-05-17	581452		0	0	0		0	0	0	126347	0	10	40213160		
3025	245	19059056	1917-03-15	1917-03-15 00:00:00	1917-03-29	1917-03-29 00:00:00	1917-03-29	38000177		0	0	14		0	0	0	16488	0	243670	19059056		
140480	3084	40213306	2000-04-05	2000-04-05 00:00:00	2000-04-05	2000-04-05 00:00:00	2000-04-05	581452		0	0	0		0	0	0	205376	0	43	40213306		
19550	1609	1127433	1992-11-03	1992-11-03 00:00:00	1992-11-10	1992-11-10 00:00:00	1992-11-10	38000177		0	0	7		0	0	0	108132	0	313782	1127433		
53053	4408	1118084	2017-09-05	2017-09-05 00:00:00	2017-09-05	2017-09-05 00:00:00	\N	38000177		0	0	0		0	0	0	293029	0	00025152531	44923712		
18319	1516	40165015	1960-08-12	1960-08-12 00:00:00	1960-08-12	1960-08-12 00:00:00	\N	38000177		0	0	0		0	0	0	101254	0	861467	40165015		
206176	4525	40213227	1999-02-17	1999-02-17 00:00:00	1999-02-17	1999-02-17 00:00:00	1999-02-17	581452		0	0	0		0	0	0	301275	0	113	40213227		
14771	1236	19059056	1932-01-28	1932-01-28 00:00:00	1932-02-11	1932-02-11 00:00:00	1932-02-11	38000177		0	0	14		0	0	0	81382	0	243670	19059056		
63727	5295	836659	1995-09-06	1995-09-06 00:00:00	1995-09-06	1995-09-06 00:00:00	\N	38000177		0	0	0		0	0	0	352255	0	313185	836659		
54023	4488	19133905	1996-05-03	1996-05-03 00:00:00	1996-05-15	1996-05-15 00:00:00	1996-05-15	38000177		0	0	12		0	0	0	298811	0	834102	19133905		
21403	1760	19073183	1979-02-23	1979-02-23 00:00:00	1979-03-09	1979-03-09 00:00:00	1979-03-09	38000177		0	0	14		0	0	0	117676	0	308182	19073183		
35872	2953	1124300	2019-01-17	2019-01-17 00:00:00	2019-01-17	2019-01-17 00:00:00	\N	38000177		0	0	0		0	0	0	197136	0	00781178901	45011828		
59242	4924	19128022	1995-11-24	1995-11-24 00:00:00	1996-11-18	1996-11-18 00:00:00	1996-11-18	38000177		0	0	360		0	0	0	327253	0	749785	19128022		
30663	2542	1127433	2018-12-30	2018-12-30 00:00:00	2019-01-06	2019-01-06 00:00:00	2019-01-06	38000177		0	0	7		0	0	0	168116	0	313782	1127433		
144584	3178	40213160	1955-06-04	1955-06-04 00:00:00	1955-06-04	1955-06-04 00:00:00	1955-06-04	581452		0	0	0		0	0	0	211396	0	10	40213160		
10291	220	40213251	1987-08-12	1987-08-12 00:00:00	1987-08-12	1987-08-12 00:00:00	1987-08-12	581452		0	0	0		0	0	0	14804	0	21	40213251		
60220	5005	19128022	1991-06-07	1991-06-07 00:00:00	1992-06-01	1992-06-01 00:00:00	1992-06-01	38000177		0	0	360		0	0	0	332933	0	749785	19128022		
3380	279	19006318	1956-07-25	1956-07-25 00:00:00	1956-08-08	1956-08-08 00:00:00	1956-08-08	38000177		0	0	14		0	0	0	18657	0	105078	19006318		
220027	4829	40213160	1976-11-19	1976-11-19 00:00:00	1976-11-19	1976-11-19 00:00:00	1976-11-19	581452		0	0	0		0	0	0	321351	0	10	40213160		
9493	789	1127433	2005-12-03	2005-12-03 00:00:00	2005-12-17	2005-12-17 00:00:00	2005-12-17	38000177		0	0	14		0	0	0	52485	0	313782	1127433		
26014	2140	1713671	1959-04-28	1959-04-28 00:00:00	1959-05-05	1959-05-05 00:00:00	1959-05-05	38000177		0	0	7		0	0	0	142558	0	562251	1713671		
9584	800	1127433	1980-03-14	1980-03-14 00:00:00	1980-05-13	1980-05-13 00:00:00	1980-05-13	38000177		0	0	60		0	0	0	53091	0	313782	1127433		
1149	94	19078461	1983-07-14	1983-07-14 00:00:00	1983-08-11	1983-08-11 00:00:00	1983-08-11	38000177		0	0	28		0	0	0	6300	0	310965	19078461		
20147	1656	920300	2001-12-26	2001-12-26 00:00:00	2002-01-02	2002-01-02 00:00:00	2002-01-02	38000177		0	0	7		0	0	0	111070	0	311989	920300		
11701	973	1127433	2006-10-11	2006-10-11 00:00:00	2006-10-18	2006-10-18 00:00:00	2006-10-18	38000177		0	0	7		0	0	0	64878	0	313782	1127433		
159638	3513	40213296	2015-11-15	2015-11-15 00:00:00	2015-11-15	2015-11-15 00:00:00	2015-11-15	581452		0	0	0		0	0	0	233141	0	52	40213296		
19036	1571	19133873	1967-04-28	1967-04-28 00:00:00	1967-05-11	1967-05-11 00:00:00	1967-05-11	38000177		0	0	13		0	0	0	105519	0	834061	19133873		
1375	110	1127433	2013-09-01	2013-09-01 00:00:00	2013-10-06	2013-10-06 00:00:00	2013-10-06	38000177		0	0	35		0	0	0	7309	0	313782	1127433		
23338	1923	19077572	2010-05-21	2010-05-21 00:00:00	2010-05-21	2010-05-21 00:00:00	\N	38000177		0	0	0		0	0	0	127965	0	310436	19077572		
172340	3788	40213260	2014-08-12	2014-08-12 00:00:00	2014-08-12	2014-08-12 00:00:00	2014-08-12	581452		0	0	0		0	0	0	251811	0	121	40213260		
27925	2311	1127433	1982-08-05	1982-08-05 00:00:00	1982-08-12	1982-08-12 00:00:00	1982-08-12	38000177		0	0	7		0	0	0	153698	0	313782	1127433		
33929	2806	1539411	1991-03-14	1991-03-14 00:00:00	1991-03-14	1991-03-14 00:00:00	\N	38000177		0	0	0		0	0	0	185983	0	312961	1539411		
12357	1039	1127433	1996-09-27	1996-09-27 00:00:00	1996-12-03	1996-12-03 00:00:00	1996-12-03	38000177		0	0	67		0	0	0	68332	0	313782	1127433		
89938	1973	40213306	1993-10-04	1993-10-04 00:00:00	1993-10-04	1993-10-04 00:00:00	1993-10-04	581452		0	0	0		0	0	0	131176	0	43	40213306		
43530	3609	19075001	1986-07-11	1986-07-11 00:00:00	1986-07-25	1986-07-25 00:00:00	1986-07-25	38000177		0	0	14		0	0	0	239786	0	309097	19075001		
145996	3211	40213160	1961-06-09	1961-06-09 00:00:00	1961-06-09	1961-06-09 00:00:00	1961-06-09	581452		0	0	0		0	0	0	213377	0	10	40213160		
44496	969	40213314	1978-08-13	1978-08-13 00:00:00	1978-08-13	1978-08-13 00:00:00	1978-08-13	581452		0	0	0		0	0	0	64433	0	49	40213314		
5277	442	19008572	1980-08-24	1980-08-24 00:00:00	1980-08-24	1980-08-24 00:00:00	\N	38000177		0	0	0		0	0	0	29295	0	106258	19008572		
54183	4503	19018935	2014-04-01	2014-04-01 00:00:00	2014-04-01	2014-04-01 00:00:00	\N	38000177		0	0	0		0	0	0	299856	0	197604	19018935		
60422	1321	40213260	2009-11-26	2009-11-26 00:00:00	2009-11-26	2009-11-26 00:00:00	2009-11-26	581452		0	0	0		0	0	0	87629	0	121	40213260		
46455	3849	19059056	1964-11-15	1964-11-15 00:00:00	1964-12-06	1964-12-06 00:00:00	1964-12-06	38000177		0	0	21		0	0	0	255446	0	243670	19059056		
58620	4867	19059056	1926-11-01	1926-11-01 00:00:00	1927-01-30	1927-01-30 00:00:00	1927-01-30	38000177		0	0	90		0	0	0	323682	0	243670	19059056		
808	65	1124300	2009-06-03	2009-06-03 00:00:00	2009-06-03	2009-06-03 00:00:00	\N	38000177		0	0	0		0	0	0	4444	0	00781178901	45011828		
11012	918	19006318	1949-01-10	1949-01-10 00:00:00	1949-01-24	1949-01-24 00:00:00	1949-01-24	38000177		0	0	14		0	0	0	61139	0	105078	19006318		
16091	1334	1124300	2008-11-30	2008-11-30 00:00:00	2008-11-30	2008-11-30 00:00:00	\N	38000177		0	0	0		0	0	0	88525	0	00781178901	45011828		
8524	710	1127433	1992-04-05	1992-04-05 00:00:00	1992-04-26	1992-04-26 00:00:00	1992-04-26	38000177		0	0	21		0	0	0	46997	0	313782	1127433		
50521	4199	1127433	1948-03-08	1948-03-08 00:00:00	1948-03-22	1948-03-22 00:00:00	1948-03-22	38000177		0	0	14		0	0	0	278633	0	313782	1127433		
22445	1845	19059056	1964-08-31	1964-08-31 00:00:00	1964-09-14	1964-09-14 00:00:00	1964-09-14	38000177		0	0	14		0	0	0	123302	0	243670	19059056		
54934	4562	40232448	1966-02-17	1966-02-17 00:00:00	1966-02-17	1966-02-17 00:00:00	\N	38000177		0	0	0		0	0	0	304014	0	1049630	40232448		
119171	2620	40213260	2014-11-18	2014-11-18 00:00:00	2014-11-18	2014-11-18 00:00:00	2014-11-18	581452		0	0	0		0	0	0	173258	0	121	40213260		
47700	3955	1713671	1998-07-25	1998-07-25 00:00:00	1998-08-01	1998-08-01 00:00:00	1998-08-01	38000177		0	0	7		0	0	0	262870	0	562251	1713671		
208755	4579	40213260	2019-01-11	2019-01-11 00:00:00	2019-01-11	2019-01-11 00:00:00	2019-01-11	581452		0	0	0		0	0	0	305045	0	121	40213260		
16285	1352	19133873	1951-09-21	1951-09-21 00:00:00	1951-10-01	1951-10-01 00:00:00	1951-10-01	38000177		0	0	10		0	0	0	89536	0	834061	19133873		
33898	741	40213306	1996-04-19	1996-04-19 00:00:00	1996-04-19	1996-04-19 00:00:00	1996-04-19	581452		0	0	0		0	0	0	49063	0	43	40213306		
857	69	19059056	1947-11-05	1947-11-05 00:00:00	1947-11-19	1947-11-19 00:00:00	1947-11-19	38000177		0	0	14		0	0	0	4618	0	243670	19059056		
16386	1358	19006318	1959-09-20	1959-09-20 00:00:00	1959-10-04	1959-10-04 00:00:00	1959-10-04	38000177		0	0	14		0	0	0	90098	0	105078	19006318		
34136	2822	1127433	2016-02-27	2016-02-27 00:00:00	2016-03-05	2016-03-05 00:00:00	2016-03-05	38000177		0	0	7		0	0	0	186988	0	313782	1127433		
26953	2222	19078461	2014-02-16	2014-02-16 00:00:00	2014-03-02	2014-03-02 00:00:00	2014-03-02	38000177		0	0	14		0	0	0	147958	0	310965	19078461		
26990	2226	1713671	2002-03-19	2002-03-19 00:00:00	2002-04-02	2002-04-02 00:00:00	2002-04-02	38000177		0	0	14		0	0	0	148122	0	562251	1713671		
89584	1965	40213160	1973-10-07	1973-10-07 00:00:00	1973-10-07	1973-10-07 00:00:00	1973-10-07	581452		0	0	0		0	0	0	130657	0	10	40213160		
4466	370	19059056	1970-10-20	1970-10-20 00:00:00	1970-11-10	1970-11-10 00:00:00	1970-11-10	38000177		0	0	21		0	0	0	24582	0	243670	19059056		
9980	836	1127078	1979-05-31	1979-05-31 00:00:00	1979-06-14	1979-06-14 00:00:00	1979-06-14	38000177		0	0	14		0	0	0	55311	0	282464	1127078		
38383	3175	1127433	1989-11-17	1989-11-17 00:00:00	1989-11-24	1989-11-24 00:00:00	1989-11-24	38000177		0	0	7		0	0	0	211003	0	313782	1127433		
15074	1258	40236824	1984-04-04	1984-04-04 00:00:00	1984-04-11	1984-04-11 00:00:00	1984-04-11	38000177		0	0	7		0	0	0	82882	0	1094107	40236824		
99010	2168	40213227	2017-11-16	2017-11-16 00:00:00	2017-11-16	2017-11-16 00:00:00	2017-11-16	581452		0	0	0		0	0	0	144533	0	113	40213227		
3026	245	1127433	2015-09-20	2015-09-20 00:00:00	2015-10-20	2015-10-20 00:00:00	2015-10-20	38000177		0	0	30		0	0	0	16407	0	313782	1127433		
140482	3084	40213314	1979-01-31	1979-01-31 00:00:00	1979-01-31	1979-01-31 00:00:00	1979-01-31	581452		0	0	0		0	0	0	205385	0	49	40213314		
19551	1609	1127433	1996-09-27	1996-09-27 00:00:00	1996-10-18	1996-10-18 00:00:00	1996-10-18	38000177		0	0	21		0	0	0	108164	0	313782	1127433		
53054	4408	19133873	1995-06-10	1995-06-10 00:00:00	1995-06-22	1995-06-22 00:00:00	1995-06-22	38000177		0	0	12		0	0	0	293016	0	834061	19133873		
18320	1516	1127433	1960-08-05	1960-08-05 00:00:00	1960-10-11	1960-10-11 00:00:00	1960-10-11	38000177		0	0	67		0	0	0	101265	0	313782	1127433		
206181	4525	40213160	1972-11-15	1972-11-15 00:00:00	1972-11-15	1972-11-15 00:00:00	1972-11-15	581452		0	0	0		0	0	0	301310	0	10	40213160		
14772	1236	1713671	1950-08-23	1950-08-23 00:00:00	1950-09-06	1950-09-06 00:00:00	1950-09-06	38000177		0	0	14		0	0	0	81446	0	562251	1713671		
63728	5295	19078461	1977-12-13	1977-12-13 00:00:00	1978-02-11	1978-02-11 00:00:00	1978-02-11	38000177		0	0	60		0	0	0	352212	0	310965	19078461		
54024	4488	1127433	1986-12-07	1986-12-07 00:00:00	1986-12-14	1986-12-14 00:00:00	1986-12-14	38000177		0	0	7		0	0	0	298821	0	313782	1127433		
21404	1760	46233988	1980-05-21	1980-05-21 00:00:00	1980-06-04	1980-06-04 00:00:00	1980-06-04	38000177		0	0	14		0	0	0	117677	0	1652673	46233988		
35873	2953	19133905	2009-05-15	2009-05-15 00:00:00	2009-05-27	2009-05-27 00:00:00	2009-05-27	38000177		0	0	12		0	0	0	197109	0	834102	19133905		
59243	4924	40232448	1978-06-24	1978-06-24 00:00:00	1978-06-24	1978-06-24 00:00:00	\N	38000177		0	0	0		0	0	0	327278	0	1049630	40232448		
30664	2543	1713671	1971-02-06	1971-02-06 00:00:00	1971-02-13	1971-02-13 00:00:00	1971-02-13	38000177		0	0	7		0	0	0	168231	0	562251	1713671		
144585	3178	40213160	1959-03-07	1959-03-07 00:00:00	1959-03-07	1959-03-07 00:00:00	1959-03-07	581452		0	0	0		0	0	0	211398	0	10	40213160		
10293	220	40213160	1987-08-12	1987-08-12 00:00:00	1987-08-12	1987-08-12 00:00:00	1987-08-12	581452		0	0	0		0	0	0	14804	0	10	40213160		
60221	5005	1127433	2008-08-28	2008-08-28 00:00:00	2008-09-11	2008-09-11 00:00:00	2008-09-11	38000177		0	0	14		0	0	0	332929	0	313782	1127433		
3381	279	19059056	1956-07-25	1956-07-25 00:00:00	1956-08-08	1956-08-08 00:00:00	1956-08-08	38000177		0	0	14		0	0	0	18657	0	243670	19059056		
201431	4423	40213227	2007-11-02	2007-11-02 00:00:00	2007-11-02	2007-11-02 00:00:00	2007-11-02	581452		0	0	0		0	0	0	294117	0	113	40213227		
9494	789	40229134	1994-12-28	1994-12-28 00:00:00	1995-01-04	1995-01-04 00:00:00	1995-01-04	38000177		0	0	7		0	0	0	52510	0	1043400	40229134		
26015	2140	1127078	1960-01-20	1960-01-20 00:00:00	1960-03-20	1960-03-20 00:00:00	1960-03-20	38000177		0	0	60		0	0	0	142554	0	282464	1127078		
9585	800	40165015	1980-03-14	1980-03-14 00:00:00	1980-03-14	1980-03-14 00:00:00	\N	38000177		0	0	0		0	0	0	53091	0	861467	40165015		
1150	94	40162522	1983-07-14	1983-07-14 00:00:00	1983-07-14	1983-07-14 00:00:00	\N	38000177		0	0	0		0	0	0	6300	0	857005	40162522		
20148	1656	19132304	2009-08-24	2009-08-24 00:00:00	2010-08-24	2010-08-24 00:00:00	2010-08-24	38000177		0	0	365		0	0	0	111128	0	807283	19132304		
11702	973	40229134	1944-07-27	1944-07-27 00:00:00	1944-08-03	1944-08-03 00:00:00	1944-08-03	38000177		0	0	7		0	0	0	64738	0	1043400	40229134		
147856	3250	40213227	2014-01-14	2014-01-14 00:00:00	2014-01-14	2014-01-14 00:00:00	2014-01-14	581452		0	0	0		0	0	0	216075	0	113	40213227		
19037	1571	1118084	1998-08-05	1998-08-05 00:00:00	1998-08-05	1998-08-05 00:00:00	\N	38000177		0	0	0		0	0	0	105452	0	00025152531	44923712		
1376	110	19133873	1984-04-06	1984-04-06 00:00:00	1984-04-17	1984-04-17 00:00:00	1984-04-17	38000177		0	0	11		0	0	0	7317	0	834061	19133873		
23339	1923	1127433	2008-08-10	2008-08-10 00:00:00	2008-08-24	2008-08-24 00:00:00	2008-08-24	38000177		0	0	14		0	0	0	127938	0	313782	1127433		
172341	3788	40213160	1964-11-17	1964-11-17 00:00:00	1964-11-17	1964-11-17 00:00:00	1964-11-17	581452		0	0	0		0	0	0	251822	0	10	40213160		
27926	2311	1124300	1993-05-11	1993-05-11 00:00:00	1993-05-11	1993-05-11 00:00:00	\N	38000177		0	0	0		0	0	0	153715	0	00781178901	45011828		
33930	2806	1118084	1996-03-21	1996-03-21 00:00:00	1996-03-21	1996-03-21 00:00:00	\N	38000177		0	0	0		0	0	0	185932	0	00025152531	44923712		
12358	1039	19059056	1965-04-28	1965-04-28 00:00:00	1965-05-12	1965-05-12 00:00:00	1965-05-12	38000177		0	0	14		0	0	0	68342	0	243670	19059056		
89940	1973	40213227	1993-10-04	1993-10-04 00:00:00	1993-10-04	1993-10-04 00:00:00	1993-10-04	581452		0	0	0		0	0	0	131176	0	113	40213227		
43531	3609	19019979	1983-09-04	1983-09-04 00:00:00	1983-09-25	1983-09-25 00:00:00	1983-09-25	38000177		0	0	21		0	0	0	239785	0	198405	19019979		
146005	3211	40213160	1957-03-01	1957-03-01 00:00:00	1957-03-01	1957-03-01 00:00:00	1957-03-01	581452		0	0	0		0	0	0	213335	0	10	40213160		
44497	969	40213160	1978-08-13	1978-08-13 00:00:00	1978-08-13	1978-08-13 00:00:00	1978-08-13	581452		0	0	0		0	0	0	64433	0	10	40213160		
5278	442	1127433	1989-12-08	1989-12-08 00:00:00	1989-12-22	1989-12-22 00:00:00	1989-12-22	38000177		0	0	14		0	0	0	29286	0	313782	1127433		
54184	4503	40171902	2014-04-01	2014-04-01 00:00:00	2014-04-01	2014-04-01 00:00:00	\N	38000177		0	0	0		0	0	0	299856	0	897718	40171902		
60423	1321	40213160	1959-12-10	1959-12-10 00:00:00	1959-12-10	1959-12-10 00:00:00	1959-12-10	581452		0	0	0		0	0	0	87621	0	10	40213160		
46456	3849	19078461	2009-10-09	2009-10-09 00:00:00	2009-11-13	2009-11-13 00:00:00	2009-11-13	38000177		0	0	35		0	0	0	255449	0	310965	19078461		
58621	4867	1127433	1987-05-29	1987-05-29 00:00:00	1987-07-28	1987-07-28 00:00:00	1987-07-28	38000177		0	0	60		0	0	0	323685	0	313782	1127433		
58656	4872	1127433	1960-07-25	1960-07-25 00:00:00	1960-08-08	1960-08-08 00:00:00	1960-08-08	38000177		0	0	14		0	0	0	324009	0	313782	1127433		
11013	918	1115171	1998-10-05	1998-10-05 00:00:00	1998-11-09	1998-11-09 00:00:00	1998-11-09	38000177		0	0	35		0	0	0	61204	0	849574	1115171		
16092	1334	1713671	2008-08-06	2008-08-06 00:00:00	2008-08-27	2008-08-27 00:00:00	2008-08-27	38000177		0	0	21		0	0	0	88525	0	562251	1713671		
8525	710	1124300	2004-04-27	2004-04-27 00:00:00	2004-04-27	2004-04-27 00:00:00	\N	38000177		0	0	0		0	0	0	47055	0	00781178901	45011828		
50522	4199	19133873	1945-02-03	1945-02-03 00:00:00	1945-02-16	1945-02-16 00:00:00	1945-02-16	38000177		0	0	13		0	0	0	278679	0	834061	19133873		
22446	1846	19006318	1952-07-20	1952-07-20 00:00:00	1952-08-03	1952-08-03 00:00:00	1952-08-03	38000177		0	0	14		0	0	0	123428	0	105078	19006318		
54935	4562	1127433	2011-10-06	2011-10-06 00:00:00	2011-10-27	2011-10-27 00:00:00	2011-10-27	38000177		0	0	21		0	0	0	304030	0	313782	1127433		
119173	2620	40213160	1964-07-21	1964-07-21 00:00:00	1964-07-21	1964-07-21 00:00:00	1964-07-21	581452		0	0	0		0	0	0	173261	0	10	40213160		
47701	3955	1127433	1989-08-10	1989-08-10 00:00:00	1989-08-24	1989-08-24 00:00:00	1989-08-24	38000177		0	0	14		0	0	0	262894	0	313782	1127433		
208757	4579	40213227	2019-01-11	2019-01-11 00:00:00	2019-01-11	2019-01-11 00:00:00	2019-01-11	581452		0	0	0		0	0	0	305045	0	113	40213227		
16286	1352	1127433	1946-09-05	1946-09-05 00:00:00	1946-09-19	1946-09-19 00:00:00	1946-09-19	38000177		0	0	14		0	0	0	89532	0	313782	1127433		
33900	741	40213160	1975-08-08	1975-08-08 00:00:00	1975-08-08	1975-08-08 00:00:00	1975-08-08	581452		0	0	0		0	0	0	49057	0	10	40213160		
858	69	1127433	1997-12-24	1997-12-24 00:00:00	1998-01-07	1998-01-07 00:00:00	1998-01-07	38000177		0	0	14		0	0	0	4710	0	313782	1127433		
16387	1358	1127078	1965-02-20	1965-02-20 00:00:00	1965-03-06	1965-03-06 00:00:00	1965-03-06	38000177		0	0	14		0	0	0	90037	0	282464	1127078		
23993	1975	1713671	1931-12-28	1931-12-28 00:00:00	1932-01-18	1932-01-18 00:00:00	1932-01-18	38000177		0	0	21		0	0	0	131264	0	562251	1713671		
26978	2226	19133905	1993-11-06	1993-11-06 00:00:00	1993-11-19	1993-11-19 00:00:00	1993-11-19	38000177		0	0	13		0	0	0	148075	0	834102	19133905		
26991	2226	19133905	1999-03-09	1999-03-09 00:00:00	1999-03-19	1999-03-19 00:00:00	1999-03-19	38000177		0	0	10		0	0	0	148120	0	834102	19133905		
89593	1965	40213160	1973-05-06	1973-05-06 00:00:00	1973-05-06	1973-05-06 00:00:00	1973-05-06	581452		0	0	0		0	0	0	130656	0	10	40213160		
4467	370	1127433	1994-01-27	1994-01-27 00:00:00	1994-02-26	1994-02-26 00:00:00	1994-02-26	38000177		0	0	30		0	0	0	24585	0	313782	1127433		
9981	836	19074843	1979-05-31	1979-05-31 00:00:00	1979-06-14	1979-06-14 00:00:00	1979-06-14	38000177		0	0	14		0	0	0	55311	0	309045	19074843		
38384	3175	1713671	1960-09-14	1960-09-14 00:00:00	1960-09-28	1960-09-28 00:00:00	1960-09-28	38000177		0	0	14		0	0	0	211018	0	562251	1713671		
15075	1259	1713671	1954-05-04	1954-05-04 00:00:00	1954-05-11	1954-05-11 00:00:00	1954-05-11	38000177		0	0	7		0	0	0	82941	0	562251	1713671		
99013	2168	40213160	1961-08-24	1961-08-24 00:00:00	1961-08-24	1961-08-24 00:00:00	1961-08-24	581452		0	0	0		0	0	0	144400	0	10	40213160		
3027	246	1127433	2003-05-23	2003-05-23 00:00:00	2003-06-06	2003-06-06 00:00:00	2003-06-06	38000177		0	0	14		0	0	0	16506	0	313782	1127433		
209053	4586	40213296	1997-01-19	1997-01-19 00:00:00	1997-01-19	1997-01-19 00:00:00	1997-01-19	581452		0	0	0		0	0	0	305516	0	52	40213296		
19552	1609	1127433	2014-02-15	2014-02-15 00:00:00	2014-05-17	2014-05-17 00:00:00	2014-05-17	38000177		0	0	91		0	0	0	108165	0	313782	1127433		
53055	4408	19128022	1996-01-14	1996-01-14 00:00:00	1997-01-08	1997-01-08 00:00:00	1997-01-08	38000177		0	0	360		0	0	0	293030	0	749785	19128022		
18321	1516	19133873	1944-02-15	1944-02-15 00:00:00	1944-02-22	1944-02-22 00:00:00	1944-02-22	38000177		0	0	7		0	0	0	101348	0	834061	19133873		
206185	4525	40213160	1968-07-10	1968-07-10 00:00:00	1968-07-10	1968-07-10 00:00:00	1968-07-10	581452		0	0	0		0	0	0	301305	0	10	40213160		
14773	1236	1713671	1993-04-14	1993-04-14 00:00:00	1993-04-21	1993-04-21 00:00:00	1993-04-21	38000177		0	0	7		0	0	0	81465	0	562251	1713671		
63729	5295	40223774	1997-01-28	1997-01-28 00:00:00	1997-01-28	1997-01-28 00:00:00	\N	38000177		0	0	0		0	0	0	352217	0	998582	40223774		
54025	4488	19078461	1990-08-16	1990-08-16 00:00:00	1990-09-06	1990-09-06 00:00:00	1990-09-06	38000177		0	0	21		0	0	0	298830	0	310965	19078461		
21405	1760	19019979	1980-05-21	1980-05-21 00:00:00	1980-06-04	1980-06-04 00:00:00	1980-06-04	38000177		0	0	14		0	0	0	117677	0	198405	19019979		
35874	2953	40229134	2002-03-20	2002-03-20 00:00:00	2002-04-03	2002-04-03 00:00:00	2002-04-03	38000177		0	0	14		0	0	0	197125	0	1043400	40229134		
59244	4924	19059056	1991-06-02	1991-06-02 00:00:00	1991-06-23	1991-06-23 00:00:00	1991-06-23	38000177		0	0	21		0	0	0	327220	0	243670	19059056		
30665	2543	40229134	2015-10-23	2015-10-23 00:00:00	2015-10-30	2015-10-30 00:00:00	2015-10-30	38000177		0	0	7		0	0	0	168254	0	1043400	40229134		
144589	3178	40213227	1996-10-26	1996-10-26 00:00:00	1996-10-26	1996-10-26 00:00:00	1996-10-26	581452		0	0	0		0	0	0	211441	0	113	40213227		
10299	220	40213306	2005-07-27	2005-07-27 00:00:00	2005-07-27	2005-07-27 00:00:00	2005-07-27	581452		0	0	0		0	0	0	14852	0	43	40213306		
60222	5005	40162522	2010-03-24	2010-03-24 00:00:00	2010-03-24	2010-03-24 00:00:00	\N	38000177		0	0	0		0	0	0	332957	0	857005	40162522		
3382	280	1127433	1988-05-20	1988-05-20 00:00:00	1988-06-10	1988-06-10 00:00:00	1988-06-10	38000177		0	0	21		0	0	0	18706	0	313782	1127433		
201434	4423	40213227	1997-10-24	1997-10-24 00:00:00	1997-10-24	1997-10-24 00:00:00	1997-10-24	581452		0	0	0		0	0	0	294083	0	113	40213227		
9495	789	1127433	1990-02-22	1990-02-22 00:00:00	1990-03-29	1990-03-29 00:00:00	1990-03-29	38000177		0	0	35		0	0	0	52457	0	313782	1127433		
26016	2140	1118084	1989-10-14	1989-10-14 00:00:00	1989-10-14	1989-10-14 00:00:00	\N	38000177		0	0	0		0	0	0	142569	0	00025152531	44923712		
9586	800	19006318	1958-05-09	1958-05-09 00:00:00	1958-05-23	1958-05-23 00:00:00	1958-05-23	38000177		0	0	14		0	0	0	53167	0	105078	19006318		
1151	94	19075001	1983-07-14	1983-07-14 00:00:00	1983-08-11	1983-08-11 00:00:00	1983-08-11	38000177		0	0	28		0	0	0	6300	0	309097	19075001		
20149	1656	40224805	2005-09-10	2005-09-10 00:00:00	2006-09-05	2006-09-05 00:00:00	2006-09-05	38000177		0	0	360		0	0	0	111059	0	1000126	40224805		
11703	973	19059056	1965-03-22	1965-03-22 00:00:00	1965-04-26	1965-04-26 00:00:00	1965-04-26	38000177		0	0	35		0	0	0	64800	0	243670	19059056		
147857	3250	40213260	2014-01-14	2014-01-14 00:00:00	2014-01-14	2014-01-14 00:00:00	2014-01-14	581452		0	0	0		0	0	0	216075	0	121	40213260		
19038	1572	19128065	1982-05-26	1982-05-26 00:00:00	1983-05-21	1983-05-21 00:00:00	1983-05-21	38000177		0	0	360		0	0	0	105570	0	749882	19128065		
1377	110	19078461	2003-07-23	2003-07-23 00:00:00	2003-08-20	2003-08-20 00:00:00	2003-08-20	38000177		0	0	28		0	0	0	7307	0	310965	19078461		
23340	1923	1118084	1972-06-29	1972-06-29 00:00:00	1972-06-29	1972-06-29 00:00:00	\N	38000177		0	0	0		0	0	0	127960	0	00025152531	44923712		
148003	3253	40213227	2001-07-31	2001-07-31 00:00:00	2001-07-31	2001-07-31 00:00:00	2001-07-31	581452		0	0	0		0	0	0	216356	0	113	40213227		
27927	2311	19129655	1964-06-07	1964-06-07 00:00:00	1964-06-21	1964-06-21 00:00:00	1964-06-21	38000177		0	0	14		0	0	0	153746	0	789980	19129655		
33931	2806	1332419	1995-04-27	1995-04-27 00:00:00	1995-04-27	1995-04-27 00:00:00	\N	38000177		0	0	0		0	0	0	185932	0	197361	1332419		
12359	1039	19129655	1965-04-28	1965-04-28 00:00:00	1965-05-12	1965-05-12 00:00:00	1965-05-12	38000177		0	0	14		0	0	0	68342	0	789980	19129655		
89944	1973	40213227	2012-11-26	2012-11-26 00:00:00	2012-11-26	2012-11-26 00:00:00	2012-11-26	581452		0	0	0		0	0	0	131188	0	113	40213227		
43532	3609	1127433	2017-06-24	2017-06-24 00:00:00	2017-07-15	2017-07-15 00:00:00	2017-07-15	38000177		0	0	21		0	0	0	239789	0	313782	1127433		
47389	3928	1118084	2012-08-17	2012-08-17 00:00:00	2012-08-17	2012-08-17 00:00:00	\N	38000177		0	0	0		0	0	0	261144	0	00025152531	44923712		
44499	969	40213314	1978-10-15	1978-10-15 00:00:00	1978-10-15	1978-10-15 00:00:00	1978-10-15	581452		0	0	0		0	0	0	64423	0	49	40213314		
5279	442	19133873	1955-06-29	1955-06-29 00:00:00	1955-07-11	1955-07-11 00:00:00	1955-07-11	38000177		0	0	12		0	0	0	29310	0	834061	19133873		
54185	4503	40163554	2014-04-01	2014-04-01 00:00:00	2014-04-01	2014-04-01 00:00:00	\N	38000177		0	0	0		0	0	0	299856	0	855332	40163554		
60426	1321	40213160	1960-03-10	1960-03-10 00:00:00	1960-03-10	1960-03-10 00:00:00	1960-03-10	581452		0	0	0		0	0	0	87663	0	10	40213160		
46457	3849	19133873	1969-04-20	1969-04-20 00:00:00	1969-05-03	1969-05-03 00:00:00	1969-05-03	38000177		0	0	13		0	0	0	255452	0	834061	19133873		
58622	4867	1127433	2001-07-17	2001-07-17 00:00:00	2001-07-24	2001-07-24 00:00:00	2001-07-24	38000177		0	0	7		0	0	0	323609	0	313782	1127433		
58657	4872	1713671	1925-06-25	1925-06-25 00:00:00	1925-07-16	1925-07-16 00:00:00	1925-07-16	38000177		0	0	21		0	0	0	323960	0	562251	1713671		
11014	918	1118084	1954-12-21	1954-12-21 00:00:00	1954-12-21	1954-12-21 00:00:00	\N	38000177		0	0	0		0	0	0	61179	0	00025152531	44923712		
16093	1334	1127078	1969-12-20	1969-12-20 00:00:00	1970-01-17	1970-01-17 00:00:00	1970-01-17	38000177		0	0	28		0	0	0	88528	0	282464	1127078		
8526	710	46233710	1974-10-28	1974-10-28 00:00:00	1974-11-11	1974-11-11 00:00:00	1974-11-11	38000177		0	0	14		0	0	0	46986	0	1650142	46233710		
50523	4199	1127433	1980-06-05	1980-06-05 00:00:00	1980-06-19	1980-06-19 00:00:00	1980-06-19	38000177		0	0	14		0	0	0	278708	0	313782	1127433		
22447	1846	19059056	1952-07-20	1952-07-20 00:00:00	1952-08-03	1952-08-03 00:00:00	1952-08-03	38000177		0	0	14		0	0	0	123428	0	243670	19059056		
54936	4562	1713671	1979-03-21	1979-03-21 00:00:00	1979-04-11	1979-04-11 00:00:00	1979-04-11	38000177		0	0	21		0	0	0	303981	0	562251	1713671		
119181	2620	40213306	1986-01-14	1986-01-14 00:00:00	1986-01-14	1986-01-14 00:00:00	1986-01-14	581452		0	0	0		0	0	0	173290	0	43	40213306		
47702	3956	1127433	1958-11-22	1958-11-22 00:00:00	1958-12-27	1958-12-27 00:00:00	1958-12-27	38000177		0	0	35		0	0	0	262906	0	313782	1127433		
208768	4579	40213306	1989-08-18	1989-08-18 00:00:00	1989-08-18	1989-08-18 00:00:00	1989-08-18	581452		0	0	0		0	0	0	305020	0	43	40213306		
16287	1352	42707627	1976-07-29	1976-07-29 00:00:00	1976-07-29	1976-07-29 00:00:00	1976-07-29	38000177		0	0	0		0	0	0	89606	0	1234995	42707627		
33905	741	40213296	2015-05-08	2015-05-08 00:00:00	2015-05-08	2015-05-08 00:00:00	2015-05-08	581452		0	0	0		0	0	0	49092	0	52	40213296		
859	69	1118084	1984-08-02	1984-08-02 00:00:00	1984-08-02	1984-08-02 00:00:00	\N	38000177		0	0	0		0	0	0	4674	0	00025152531	44923712		
16388	1358	1124300	1996-08-01	1996-08-01 00:00:00	1996-08-01	1996-08-01 00:00:00	\N	38000177		0	0	0		0	0	0	90063	0	00781178901	45011828		
23994	1975	19059056	1928-08-22	1928-08-22 00:00:00	1928-11-07	1928-11-07 00:00:00	1928-11-07	38000177		0	0	77		0	0	0	131309	0	243670	19059056		
26979	2226	19059056	1942-09-20	1942-09-20 00:00:00	1942-10-04	1942-10-04 00:00:00	1942-10-04	38000177		0	0	14		0	0	0	148086	0	243670	19059056		
26992	2226	19059056	1947-02-11	1947-02-11 00:00:00	1947-02-25	1947-02-25 00:00:00	1947-02-25	38000177		0	0	14		0	0	0	148140	0	243670	19059056		
89598	1965	40213227	2015-02-08	2015-02-08 00:00:00	2015-02-08	2015-02-08 00:00:00	2015-02-08	581452		0	0	0		0	0	0	130667	0	113	40213227		
4469	371	1127433	1968-08-30	1968-08-30 00:00:00	1968-09-13	1968-09-13 00:00:00	1968-09-13	38000177		0	0	14		0	0	0	24671	0	313782	1127433		
9982	836	920300	2007-10-04	2007-10-04 00:00:00	2007-10-11	2007-10-11 00:00:00	2007-10-11	38000177		0	0	7		0	0	0	55297	0	311989	920300		
38385	3175	920300	2006-12-17	2006-12-17 00:00:00	2006-12-24	2006-12-24 00:00:00	2006-12-24	38000177		0	0	7		0	0	0	211020	0	311989	920300		
15076	1259	1127433	1991-02-15	1991-02-15 00:00:00	1991-03-01	1991-03-01 00:00:00	1991-03-01	38000177		0	0	14		0	0	0	82964	0	313782	1127433		
99015	2168	40213260	2006-09-14	2006-09-14 00:00:00	2006-09-14	2006-09-14 00:00:00	2006-09-14	581452		0	0	0		0	0	0	144452	0	121	40213260		
3028	246	19133873	1964-09-13	1964-09-13 00:00:00	1964-09-26	1964-09-26 00:00:00	1964-09-26	38000177		0	0	13		0	0	0	16521	0	834061	19133873		
5825	487	1127433	1988-08-10	1988-08-10 00:00:00	1988-08-24	1988-08-24 00:00:00	1988-08-24	38000177		0	0	14		0	0	0	32568	0	313782	1127433		
19553	1609	40229134	1986-11-14	1986-11-14 00:00:00	1986-11-28	1986-11-28 00:00:00	1986-11-28	38000177		0	0	14		0	0	0	108149	0	1043400	40229134		
53056	4408	1713671	2007-10-18	2007-10-18 00:00:00	2007-10-25	2007-10-25 00:00:00	2007-10-25	38000177		0	0	7		0	0	0	293022	0	562251	1713671		
18322	1516	1713671	1972-12-14	1972-12-14 00:00:00	1972-12-21	1972-12-21 00:00:00	1972-12-21	38000177		0	0	7		0	0	0	101294	0	562251	1713671		
206186	4525	40213296	2008-02-06	2008-02-06 00:00:00	2008-02-06	2008-02-06 00:00:00	2008-02-06	581452		0	0	0		0	0	0	301285	0	52	40213296		
14774	1236	19133905	1971-04-26	1971-04-26 00:00:00	1971-05-06	1971-05-06 00:00:00	1971-05-06	38000177		0	0	10		0	0	0	81383	0	834102	19133905		
63730	5295	40220960	1998-06-10	1998-06-10 00:00:00	1998-06-10	1998-06-10 00:00:00	1998-06-10	38000177		0	0	0		0	0	0	352214	0	1804799	40220960		
54026	4488	1713671	1987-06-09	1987-06-09 00:00:00	1987-06-23	1987-06-23 00:00:00	1987-06-23	38000177		0	0	14		0	0	0	298799	0	562251	1713671		
21406	1760	19128022	1992-06-10	1992-06-10 00:00:00	1993-06-05	1993-06-05 00:00:00	1993-06-05	38000177		0	0	360		0	0	0	117678	0	749785	19128022		
35875	2953	19019979	1988-12-10	1988-12-10 00:00:00	1989-03-10	1989-03-10 00:00:00	1989-03-10	38000177		0	0	90		0	0	0	197112	0	198405	19019979		
59245	4924	19133905	2002-02-09	2002-02-09 00:00:00	2002-02-18	2002-02-18 00:00:00	2002-02-18	38000177		0	0	9		0	0	0	327176	0	834102	19133905		
30666	2543	19059056	1965-11-12	1965-11-12 00:00:00	1965-11-26	1965-11-26 00:00:00	1965-11-26	38000177		0	0	14		0	0	0	168265	0	243670	19059056		
144591	3178	40213296	1996-10-26	1996-10-26 00:00:00	1996-10-26	1996-10-26 00:00:00	1996-10-26	581452		0	0	0		0	0	0	211441	0	52	40213296		
10300	220	40213180	2005-07-27	2005-07-27 00:00:00	2005-07-27	2005-07-27 00:00:00	2005-07-27	581452		0	0	0		0	0	0	14852	0	114	40213180		
60223	5005	1127433	1986-02-23	1986-02-23 00:00:00	1986-03-09	1986-03-09 00:00:00	1986-03-09	38000177		0	0	14		0	0	0	332908	0	313782	1127433		
3383	280	19059056	1946-10-16	1946-10-16 00:00:00	1946-10-30	1946-10-30 00:00:00	1946-10-30	38000177		0	0	14		0	0	0	18702	0	243670	19059056		
201435	4423	40213306	1997-10-24	1997-10-24 00:00:00	1997-10-24	1997-10-24 00:00:00	1997-10-24	581452		0	0	0		0	0	0	294083	0	43	40213306		
9496	789	1127433	1989-05-07	1989-05-07 00:00:00	1989-05-21	1989-05-21 00:00:00	1989-05-21	38000177		0	0	14		0	0	0	52509	0	313782	1127433		
26017	2141	19133873	1955-10-20	1955-10-20 00:00:00	1955-10-27	1955-10-27 00:00:00	1955-10-27	38000177		0	0	7		0	0	0	142611	0	834061	19133873		
9587	800	1127078	1958-05-09	1958-05-09 00:00:00	1958-05-23	1958-05-23 00:00:00	1958-05-23	38000177		0	0	14		0	0	0	53167	0	282464	1127078		
1152	94	1127433	1960-10-04	1960-10-04 00:00:00	1960-10-18	1960-10-18 00:00:00	1960-10-18	38000177		0	0	14		0	0	0	6315	0	313782	1127433		
20150	1656	1127433	1994-06-01	1994-06-01 00:00:00	1994-06-15	1994-06-15 00:00:00	1994-06-15	38000177		0	0	14		0	0	0	111055	0	313782	1127433		
11704	973	1127433	1916-09-06	1916-09-06 00:00:00	1916-09-20	1916-09-20 00:00:00	1916-09-20	38000177		0	0	14		0	0	0	64830	0	313782	1127433		
147860	3250	40213260	2013-01-08	2013-01-08 00:00:00	2013-01-08	2013-01-08 00:00:00	2013-01-08	581452		0	0	0		0	0	0	216091	0	121	40213260		
19039	1572	1539411	1991-05-31	1991-05-31 00:00:00	1991-05-31	1991-05-31 00:00:00	\N	38000177		0	0	0		0	0	0	105590	0	312961	1539411		
1378	110	1118084	2018-08-23	2018-08-23 00:00:00	2018-08-23	2018-08-23 00:00:00	\N	38000177		0	0	0		0	0	0	7350	0	00025152531	44923712		
23341	1923	19059056	1938-10-16	1938-10-16 00:00:00	1938-10-30	1938-10-30 00:00:00	1938-10-30	38000177		0	0	14		0	0	0	127997	0	243670	19059056		
148004	3254	40213260	2013-12-01	2013-12-01 00:00:00	2013-12-01	2013-12-01 00:00:00	2013-12-01	581452		0	0	0		0	0	0	216425	0	121	40213260		
27928	2311	19059056	1964-06-07	1964-06-07 00:00:00	1964-06-21	1964-06-21 00:00:00	1964-06-21	38000177		0	0	14		0	0	0	153746	0	243670	19059056		
33934	2806	40236824	1987-05-12	1987-05-12 00:00:00	1987-05-19	1987-05-19 00:00:00	1987-05-19	38000177		0	0	7		0	0	0	185975	0	1094107	40236824		
12360	1039	1127433	2008-08-14	2008-08-14 00:00:00	2008-09-18	2008-09-18 00:00:00	2008-09-18	38000177		0	0	35		0	0	0	68335	0	313782	1127433		
89945	1973	40213296	2012-11-26	2012-11-26 00:00:00	2012-11-26	2012-11-26 00:00:00	2012-11-26	581452		0	0	0		0	0	0	131188	0	52	40213296		
43533	3609	1118084	2018-08-05	2018-08-05 00:00:00	2018-08-05	2018-08-05 00:00:00	\N	38000177		0	0	0		0	0	0	239789	0	00025152531	44923712		
47390	3929	1127433	1999-12-14	1999-12-14 00:00:00	1999-12-21	1999-12-21 00:00:00	1999-12-21	38000177		0	0	7		0	0	0	261190	0	313782	1127433		
44500	969	40213160	1978-10-15	1978-10-15 00:00:00	1978-10-15	1978-10-15 00:00:00	1978-10-15	581452		0	0	0		0	0	0	64423	0	10	40213160		
5280	442	1713671	1992-04-19	1992-04-19 00:00:00	1992-05-03	1992-05-03 00:00:00	1992-05-03	38000177		0	0	14		0	0	0	29409	0	562251	1713671		
54186	4503	1127433	1944-07-11	1944-07-11 00:00:00	1944-07-18	1944-07-18 00:00:00	1944-07-18	38000177		0	0	7		0	0	0	299864	0	313782	1127433		
60431	1321	40213227	1994-06-23	1994-06-23 00:00:00	1994-06-23	1994-06-23 00:00:00	1994-06-23	581452		0	0	0		0	0	0	87673	0	113	40213227		
46459	3849	920300	2007-01-19	2007-01-19 00:00:00	2007-01-26	2007-01-26 00:00:00	2007-01-26	38000177		0	0	7		0	0	0	255398	0	311989	920300		
58623	4867	1127433	2011-03-08	2011-03-08 00:00:00	2011-04-14	2011-04-14 00:00:00	2011-04-14	38000177		0	0	37		0	0	0	323691	0	313782	1127433		
58658	4872	1127433	1952-08-14	1952-08-14 00:00:00	1952-08-21	1952-08-21 00:00:00	1952-08-21	38000177		0	0	7		0	0	0	324008	0	313782	1127433		
11015	918	40229134	2015-12-19	2015-12-19 00:00:00	2016-01-02	2016-01-02 00:00:00	2016-01-02	38000177		0	0	14		0	0	0	61142	0	1043400	40229134		
16094	1334	1713671	1997-04-07	1997-04-07 00:00:00	1997-04-28	1997-04-28 00:00:00	1997-04-28	38000177		0	0	21		0	0	0	88532	0	562251	1713671		
8527	710	19078461	1974-10-28	1974-10-28 00:00:00	1974-11-11	1974-11-11 00:00:00	1974-11-11	38000177		0	0	14		0	0	0	46986	0	310965	19078461		
50524	4199	1127433	1994-05-29	1994-05-29 00:00:00	1994-06-05	1994-06-05 00:00:00	1994-06-05	38000177		0	0	7		0	0	0	278616	0	313782	1127433		
22448	1846	1713671	1971-10-10	1971-10-10 00:00:00	1971-10-31	1971-10-31 00:00:00	1971-10-31	38000177		0	0	21		0	0	0	123398	0	562251	1713671		
54937	4562	1127433	1978-04-09	1978-04-09 00:00:00	1978-04-16	1978-04-16 00:00:00	1978-04-16	38000177		0	0	7		0	0	0	304002	0	313782	1127433		
119183	2621	40213260	2006-08-26	2006-08-26 00:00:00	2006-08-26	2006-08-26 00:00:00	2006-08-26	581452		0	0	0		0	0	0	173373	0	121	40213260		
47703	3956	40231925	1958-11-22	1958-11-22 00:00:00	1958-11-22	1958-11-22 00:00:00	\N	38000177		0	0	0		0	0	0	262906	0	1049221	40231925		
208769	4579	40213160	1967-10-20	1967-10-20 00:00:00	1967-10-20	1967-10-20 00:00:00	1967-10-20	581452		0	0	0		0	0	0	305051	0	10	40213160		
16288	1352	1367571	1976-07-29	1976-07-29 00:00:00	1976-07-29	1976-07-29 00:00:00	1976-07-29	38000177		0	0	0		0	0	0	89606	0	314659	19080464		
33906	741	40213160	1975-05-09	1975-05-09 00:00:00	1975-05-09	1975-05-09 00:00:00	1975-05-09	581452		0	0	0		0	0	0	49102	0	10	40213160		
860	69	1713671	1979-01-27	1979-01-27 00:00:00	1979-02-03	1979-02-03 00:00:00	1979-02-03	38000177		0	0	7		0	0	0	4697	0	562251	1713671		
16389	1358	1115171	2002-01-05	2002-01-05 00:00:00	2002-01-26	2002-01-26 00:00:00	2002-01-26	38000177		0	0	21		0	0	0	90110	0	849574	1115171		
23995	1975	19133905	1952-11-21	1952-11-21 00:00:00	1952-12-04	1952-12-04 00:00:00	1952-12-04	38000177		0	0	13		0	0	0	131297	0	834102	19133905		
26980	2226	1127433	2008-11-23	2008-11-23 00:00:00	2008-12-14	2008-12-14 00:00:00	2008-12-14	38000177		0	0	21		0	0	0	148170	0	313782	1127433		
26993	2226	19006318	1947-02-11	1947-02-11 00:00:00	1947-02-25	1947-02-25 00:00:00	1947-02-25	38000177		0	0	14		0	0	0	148140	0	105078	19006318		
89599	1965	40213296	2015-02-08	2015-02-08 00:00:00	2015-02-08	2015-02-08 00:00:00	2015-02-08	581452		0	0	0		0	0	0	130667	0	52	40213296		
4474	371	40236824	2000-02-28	2000-02-28 00:00:00	2000-03-06	2000-03-06 00:00:00	2000-03-06	38000177		0	0	7		0	0	0	24665	0	1094107	40236824		
9983	836	40236824	2007-10-04	2007-10-04 00:00:00	2007-10-11	2007-10-11 00:00:00	2007-10-11	38000177		0	0	7		0	0	0	55297	0	1094107	40236824		
38386	3175	40236824	2006-12-17	2006-12-17 00:00:00	2006-12-24	2006-12-24 00:00:00	2006-12-24	38000177		0	0	7		0	0	0	211020	0	1094107	40236824		
15077	1259	19059056	1953-01-02	1953-01-02 00:00:00	1953-01-16	1953-01-16 00:00:00	1953-01-16	38000177		0	0	14		0	0	0	82961	0	243670	19059056		
99026	2168	40213160	1957-05-23	1957-05-23 00:00:00	1957-05-23	1957-05-23 00:00:00	1957-05-23	581452		0	0	0		0	0	0	144567	0	10	40213160		
3029	246	19078461	1981-06-06	1981-06-06 00:00:00	1981-06-27	1981-06-27 00:00:00	1981-06-27	38000177		0	0	21		0	0	0	16547	0	310965	19078461		
5826	487	1713671	2000-05-09	2000-05-09 00:00:00	2000-05-23	2000-05-23 00:00:00	2000-05-23	38000177		0	0	14		0	0	0	32542	0	562251	1713671		
19554	1609	1127433	1957-03-01	1957-03-01 00:00:00	1957-03-22	1957-03-22 00:00:00	1957-03-22	38000177		0	0	21		0	0	0	108159	0	313782	1127433		
53057	4408	19128065	1999-12-24	1999-12-24 00:00:00	2000-12-18	2000-12-18 00:00:00	2000-12-18	38000177		0	0	360		0	0	0	293003	0	749882	19128065		
18323	1516	1127433	1952-10-17	1952-10-17 00:00:00	1952-10-24	1952-10-24 00:00:00	1952-10-24	38000177		0	0	7		0	0	0	101257	0	313782	1127433		
72099	1576	40213296	2007-10-13	2007-10-13 00:00:00	2007-10-13	2007-10-13 00:00:00	2007-10-13	581452		0	0	0		0	0	0	105779	0	52	40213296		
25233	2077	1127433	1942-06-08	1942-06-08 00:00:00	1942-06-22	1942-06-22 00:00:00	1942-06-22	38000177		0	0	14		0	0	0	138238	0	313782	1127433		
63731	5295	19075601	1998-06-10	1998-06-10 00:00:00	1998-06-10	1998-06-10 00:00:00	1998-06-10	38000177		0	0	0		0	0	0	352214	0	309362	19075601		
54027	4488	19019979	1982-09-27	1982-09-27 00:00:00	1982-12-26	1982-12-26 00:00:00	1982-12-26	38000177		0	0	90		0	0	0	298843	0	198405	19019979		
21407	1760	19133873	1993-03-19	1993-03-19 00:00:00	1993-03-31	1993-03-31 00:00:00	1993-03-31	38000177		0	0	12		0	0	0	117693	0	834061	19133873		
35876	2953	19019979	1984-11-01	1984-11-01 00:00:00	1984-12-31	1984-12-31 00:00:00	1984-12-31	38000177		0	0	60		0	0	0	197111	0	198405	19019979		
59246	4924	19078461	2006-11-01	2006-11-01 00:00:00	2006-11-15	2006-11-15 00:00:00	2006-11-15	38000177		0	0	14		0	0	0	327221	0	310965	19078461		
30667	2543	19078461	2011-10-17	2011-10-17 00:00:00	2011-11-07	2011-11-07 00:00:00	2011-11-07	38000177		0	0	21		0	0	0	168267	0	310965	19078461		
144601	3178	40213227	2015-11-14	2015-11-14 00:00:00	2015-11-14	2015-11-14 00:00:00	2015-11-14	581452		0	0	0		0	0	0	211449	0	113	40213227		
10302	220	40213227	2014-08-06	2014-08-06 00:00:00	2014-08-06	2014-08-06 00:00:00	2014-08-06	581452		0	0	0		0	0	0	14823	0	113	40213227		
60224	5005	19128022	1992-06-01	1992-06-01 00:00:00	1993-05-27	1993-05-27 00:00:00	1993-05-27	38000177		0	0	360		0	0	0	332961	0	749785	19128022		
3384	280	1545959	2019-05-31	2019-05-31 00:00:00	2019-05-31	2019-05-31 00:00:00	2019-05-31	38000177		0	0	0		0	0	0	18709	0	259255	1545959		
201437	4423	40213160	1976-04-30	1976-04-30 00:00:00	1976-04-30	1976-04-30 00:00:00	1976-04-30	581452		0	0	0		0	0	0	294095	0	10	40213160		
9497	789	1127433	1987-12-07	1987-12-07 00:00:00	1987-12-21	1987-12-21 00:00:00	1987-12-21	38000177		0	0	14		0	0	0	52462	0	313782	1127433		
26018	2141	1713671	1958-05-03	1958-05-03 00:00:00	1958-05-10	1958-05-10 00:00:00	1958-05-10	38000177		0	0	7		0	0	0	142651	0	562251	1713671		
9588	800	19078461	1984-02-22	1984-02-22 00:00:00	1984-03-28	1984-03-28 00:00:00	1984-03-28	38000177		0	0	35		0	0	0	53092	0	310965	19078461		
1153	94	1713671	1989-10-13	1989-10-13 00:00:00	1989-10-27	1989-10-27 00:00:00	1989-10-27	38000177		0	0	14		0	0	0	6303	0	562251	1713671		
20151	1656	1127433	1992-06-10	1992-06-10 00:00:00	1992-08-09	1992-08-09 00:00:00	1992-08-09	38000177		0	0	60		0	0	0	111151	0	313782	1127433		
11705	973	1127433	1962-12-29	1962-12-29 00:00:00	1963-01-12	1963-01-12 00:00:00	1963-01-12	38000177		0	0	14		0	0	0	64865	0	313782	1127433		
143125	3144	40213160	1968-05-08	1968-05-08 00:00:00	1968-05-08	1968-05-08 00:00:00	1968-05-08	581452		0	0	0		0	0	0	209227	0	10	40213160		
19040	1572	1713671	2019-02-13	2019-02-13 00:00:00	2019-03-06	2019-03-06 00:00:00	2019-03-06	38000177		0	0	21		0	0	0	105610	0	562251	1713671		
1379	110	1127433	2015-02-10	2015-02-10 00:00:00	2015-02-17	2015-02-17 00:00:00	2015-02-17	38000177		0	0	7		0	0	0	7311	0	313782	1127433		
23342	1923	19133873	1946-08-09	1946-08-09 00:00:00	1946-08-16	1946-08-16 00:00:00	1946-08-16	38000177		0	0	7		0	0	0	127951	0	834061	19133873		
148005	3254	40213296	2003-12-07	2003-12-07 00:00:00	2003-12-07	2003-12-07 00:00:00	2003-12-07	581452		0	0	0		0	0	0	216423	0	52	40213296		
27929	2311	46233710	1976-11-06	1976-11-06 00:00:00	1976-11-20	1976-11-20 00:00:00	1976-11-20	38000177		0	0	14		0	0	0	153757	0	1650142	46233710		
33935	2806	920300	1987-05-12	1987-05-12 00:00:00	1987-05-19	1987-05-19 00:00:00	1987-05-19	38000177		0	0	7		0	0	0	185975	0	311989	920300		
12361	1039	1124300	2003-03-29	2003-03-29 00:00:00	2003-03-29	2003-03-29 00:00:00	\N	38000177		0	0	0		0	0	0	68374	0	00781178901	45011828		
58100	1272	40213251	1984-08-24	1984-08-24 00:00:00	1984-08-24	1984-08-24 00:00:00	1984-08-24	581452		0	0	0		0	0	0	83918	0	21	40213251		
43534	3610	19007333	2017-04-18	2017-04-18 00:00:00	2017-04-18	2017-04-18 00:00:00	\N	38000177		0	0	0		0	0	0	239893	0	105586	19007333		
47391	3929	920300	1977-05-23	1977-05-23 00:00:00	1977-05-30	1977-05-30 00:00:00	1977-05-30	38000177		0	0	7		0	0	0	261169	0	311989	920300		
44509	969	40213251	1984-04-22	1984-04-22 00:00:00	1984-04-22	1984-04-22 00:00:00	1984-04-22	581452		0	0	0		0	0	0	64436	0	21	40213251		
5281	442	1127433	1974-12-18	1974-12-18 00:00:00	1974-12-25	1974-12-25 00:00:00	1974-12-25	38000177		0	0	7		0	0	0	29293	0	313782	1127433		
54187	4503	1118084	1971-01-04	1971-01-04 00:00:00	1971-01-04	1971-01-04 00:00:00	\N	38000177		0	0	0		0	0	0	299878	0	00025152531	44923712		
93976	2062	40213227	2018-08-04	2018-08-04 00:00:00	2018-08-04	2018-08-04 00:00:00	2018-08-04	581452		0	0	0		0	0	0	137150	0	113	40213227		
46460	3849	40236824	2007-01-19	2007-01-19 00:00:00	2007-01-26	2007-01-26 00:00:00	2007-01-26	38000177		0	0	7		0	0	0	255398	0	1094107	40236824		
68887	1508	40213201	1990-01-09	1990-01-09 00:00:00	1990-01-09	1990-01-09 00:00:00	1990-01-09	581452		0	0	0		0	0	0	100539	0	33	40213201		
58659	4872	19133873	1915-09-30	1915-09-30 00:00:00	1915-10-12	1915-10-12 00:00:00	1915-10-12	38000177		0	0	12		0	0	0	323988	0	834061	19133873		
11016	918	19075601	1997-12-26	1997-12-26 00:00:00	1997-12-26	1997-12-26 00:00:00	\N	38000177		0	0	0		0	0	0	61114	0	309362	19075601		
16095	1334	46233988	1974-05-19	1974-05-19 00:00:00	1974-06-02	1974-06-02 00:00:00	1974-06-02	38000177		0	0	14		0	0	0	88509	0	1652673	46233988		
8528	711	40236824	2010-01-03	2010-01-03 00:00:00	2010-01-10	2010-01-10 00:00:00	2010-01-10	38000177		0	0	7		0	0	0	47086	0	1094107	40236824		
50525	4199	19059056	1946-11-12	1946-11-12 00:00:00	1946-12-17	1946-12-17 00:00:00	1946-12-17	38000177		0	0	35		0	0	0	278706	0	243670	19059056		
22449	1846	1127433	1975-10-24	1975-10-24 00:00:00	1975-11-07	1975-11-07 00:00:00	1975-11-07	38000177		0	0	14		0	0	0	123399	0	313782	1127433		
54938	4562	19059056	1963-02-17	1963-02-17 00:00:00	1963-03-03	1963-03-03 00:00:00	1963-03-03	38000177		0	0	14		0	0	0	304021	0	243670	19059056		
119190	2621	40213227	2007-11-24	2007-11-24 00:00:00	2007-11-24	2007-11-24 00:00:00	2007-11-24	581452		0	0	0		0	0	0	173366	0	113	40213227		
47704	3956	19006318	1958-11-22	1958-11-22 00:00:00	1958-12-27	1958-12-27 00:00:00	1958-12-27	38000177		0	0	35		0	0	0	262906	0	105078	19006318		
208771	4579	40213227	2009-03-20	2009-03-20 00:00:00	2009-03-20	2009-03-20 00:00:00	2009-03-20	581452		0	0	0		0	0	0	305021	0	113	40213227		
16289	1352	19078219	1976-07-29	1976-07-29 00:00:00	1976-07-29	1976-07-29 00:00:00	1976-07-29	38000177		0	0	0		0	0	0	89606	0	56795	19078219		
33907	741	40213314	1977-05-06	1977-05-06 00:00:00	1977-05-06	1977-05-06 00:00:00	1977-05-06	581452		0	0	0		0	0	0	49070	0	49	40213314		
861	69	1127433	1975-02-28	1975-02-28 00:00:00	1975-03-14	1975-03-14 00:00:00	1975-03-14	38000177		0	0	14		0	0	0	4687	0	313782	1127433		
16390	1358	1115171	2010-08-17	2010-08-17 00:00:00	2010-10-16	2010-10-16 00:00:00	2010-10-16	38000177		0	0	60		0	0	0	90112	0	849574	1115171		
23996	1975	19059056	1923-01-07	1923-01-07 00:00:00	1923-02-06	1923-02-06 00:00:00	1923-02-06	38000177		0	0	30		0	0	0	131307	0	243670	19059056		
139927	3074	40213201	2017-07-26	2017-07-26 00:00:00	2017-07-26	2017-07-26 00:00:00	2017-07-26	581452		0	0	0		0	0	0	204596	0	33	40213201		
26994	2226	19059056	1943-05-31	1943-05-31 00:00:00	1943-06-14	1943-06-14 00:00:00	1943-06-14	38000177		0	0	14		0	0	0	148149	0	243670	19059056		
89603	1965	40213160	1978-01-08	1978-01-08 00:00:00	1978-01-08	1978-01-08 00:00:00	1978-01-08	581452		0	0	0		0	0	0	130650	0	10	40213160		
4475	371	920300	2000-02-28	2000-02-28 00:00:00	2000-03-06	2000-03-06 00:00:00	2000-03-06	38000177		0	0	7		0	0	0	24665	0	311989	920300		
9984	836	46233988	1980-12-06	1980-12-06 00:00:00	1980-12-20	1980-12-20 00:00:00	1980-12-20	38000177		0	0	14		0	0	0	55312	0	1652673	46233988		
38387	3175	40231925	1995-02-01	1995-02-01 00:00:00	1995-02-01	1995-02-01 00:00:00	\N	38000177		0	0	0		0	0	0	211054	0	1049221	40231925		
15078	1259	40229134	2001-03-14	2001-03-14 00:00:00	2001-03-21	2001-03-21 00:00:00	2001-03-21	38000177		0	0	7		0	0	0	83004	0	1043400	40229134		
99034	2168	40213160	1957-02-21	1957-02-21 00:00:00	1957-02-21	1957-02-21 00:00:00	1957-02-21	581452		0	0	0		0	0	0	144512	0	10	40213160		
3030	246	1127433	1980-06-27	1980-06-27 00:00:00	1980-07-11	1980-07-11 00:00:00	1980-07-11	38000177		0	0	14		0	0	0	16546	0	313782	1127433		
5827	487	1713671	1991-12-28	1991-12-28 00:00:00	1992-01-11	1992-01-11 00:00:00	1992-01-11	38000177		0	0	14		0	0	0	32595	0	562251	1713671		
19555	1609	1551192	1959-07-29	1959-07-29 00:00:00	1959-07-29	1959-07-29 00:00:00	1959-07-29	38000177		0	0	0		0	0	0	108160	0	312617	1551192		
53059	4409	19133873	1975-08-08	1975-08-08 00:00:00	1975-08-21	1975-08-21 00:00:00	1975-08-21	38000177		0	0	13		0	0	0	293118	0	834061	19133873		
18324	1516	1127433	1979-05-07	1979-05-07 00:00:00	1979-05-14	1979-05-14 00:00:00	1979-05-14	38000177		0	0	7		0	0	0	101261	0	313782	1127433		
72105	1576	40213227	2009-10-17	2009-10-17 00:00:00	2009-10-17	2009-10-17 00:00:00	2009-10-17	581452		0	0	0		0	0	0	105816	0	113	40213227		
25234	2077	40243436	2005-08-21	2005-08-21 00:00:00	2005-08-21	2005-08-21 00:00:00	2005-08-21	38000177		0	0	0		0	0	0	138380	0	1190795	40243436		
63732	5295	1127433	1944-05-08	1944-05-08 00:00:00	1944-05-15	1944-05-15 00:00:00	1944-05-15	38000177		0	0	7		0	0	0	352281	0	313782	1127433		
54030	4490	1124300	1963-09-04	1963-09-04 00:00:00	1963-09-04	1963-09-04 00:00:00	\N	38000177		0	0	0		0	0	0	298867	0	00781178901	45011828		
21408	1760	1127078	1988-12-18	1988-12-18 00:00:00	1989-01-17	1989-01-17 00:00:00	1989-01-17	38000177		0	0	30		0	0	0	117688	0	282464	1127078		
35877	2953	19133905	2012-08-10	2012-08-10 00:00:00	2012-08-20	2012-08-20 00:00:00	2012-08-20	38000177		0	0	10		0	0	0	197110	0	834102	19133905		
59247	4924	19078461	2013-03-13	2013-03-13 00:00:00	2013-04-17	2013-04-17 00:00:00	2013-04-17	38000177		0	0	35		0	0	0	327222	0	310965	19078461		
30668	2543	1127433	2015-02-19	2015-02-19 00:00:00	2015-03-19	2015-03-19 00:00:00	2015-03-19	38000177		0	0	28		0	0	0	168268	0	313782	1127433		
144605	3178	40213260	2006-09-23	2006-09-23 00:00:00	2006-09-23	2006-09-23 00:00:00	2006-09-23	581452		0	0	0		0	0	0	211447	0	121	40213260		
10305	220	40213227	2005-07-27	2005-07-27 00:00:00	2005-07-27	2005-07-27 00:00:00	2005-07-27	581452		0	0	0		0	0	0	14852	0	113	40213227		
60225	5005	1115171	2010-03-17	2010-03-17 00:00:00	2010-04-23	2010-04-23 00:00:00	2010-04-23	38000177		0	0	37		0	0	0	332910	0	849574	1115171		
3385	280	19133768	2019-05-31	2019-05-31 00:00:00	2019-05-31	2019-05-31 00:00:00	2019-05-31	38000177		0	0	0		0	0	0	18709	0	833036	19133768		
201440	4423	40213227	2017-11-17	2017-11-17 00:00:00	2017-11-17	2017-11-17 00:00:00	2017-11-17	581452		0	0	0		0	0	0	294075	0	113	40213227		
9509	793	19078461	2012-02-13	2012-02-13 00:00:00	2012-04-20	2012-04-20 00:00:00	2012-04-20	38000177		0	0	67		0	0	0	52612	0	310965	19078461		
26019	2141	19059056	1955-03-23	1955-03-23 00:00:00	1955-04-06	1955-04-06 00:00:00	1955-04-06	38000177		0	0	14		0	0	0	142600	0	243670	19059056		
9589	800	19078461	1996-07-30	1996-07-30 00:00:00	1996-08-20	1996-08-20 00:00:00	1996-08-20	38000177		0	0	21		0	0	0	53094	0	310965	19078461		
1154	94	40220960	2005-01-28	2005-01-28 00:00:00	2005-01-28	2005-01-28 00:00:00	2005-01-28	38000177		0	0	0		0	0	0	6358	0	1804799	40220960		
20152	1656	19128022	1993-11-12	1993-11-12 00:00:00	1994-11-07	1994-11-07 00:00:00	1994-11-07	38000177		0	0	360		0	0	0	111121	0	749785	19128022		
11706	973	1713671	1932-01-10	1932-01-10 00:00:00	1932-01-31	1932-01-31 00:00:00	1932-01-31	38000177		0	0	21		0	0	0	64831	0	562251	1713671		
143126	3144	40213160	1963-09-04	1963-09-04 00:00:00	1963-09-04	1963-09-04 00:00:00	1963-09-04	581452		0	0	0		0	0	0	209217	0	10	40213160		
19041	1572	19128065	1981-05-31	1981-05-31 00:00:00	1982-05-26	1982-05-26 00:00:00	1982-05-26	38000177		0	0	360		0	0	0	105611	0	749882	19128065		
1380	111	1127078	1985-12-26	1985-12-26 00:00:00	1986-01-09	1986-01-09 00:00:00	1986-01-09	38000177		0	0	14		0	0	0	7365	0	282464	1127078		
23343	1924	1127433	1985-10-18	1985-10-18 00:00:00	1985-11-01	1985-11-01 00:00:00	1985-11-01	38000177		0	0	14		0	0	0	128070	0	313782	1127433		
148014	3254	40213160	1964-08-09	1964-08-09 00:00:00	1964-08-09	1964-08-09 00:00:00	1964-08-09	581452		0	0	0		0	0	0	216413	0	10	40213160		
27930	2311	19059056	1976-11-06	1976-11-06 00:00:00	1976-11-20	1976-11-20 00:00:00	1976-11-20	38000177		0	0	14		0	0	0	153757	0	243670	19059056		
33938	2806	40165015	1983-03-13	1983-03-13 00:00:00	1983-03-13	1983-03-13 00:00:00	\N	38000177		0	0	0		0	0	0	185957	0	861467	40165015		
12362	1039	1713671	2012-01-30	2012-01-30 00:00:00	2012-02-13	2012-02-13 00:00:00	2012-02-13	38000177		0	0	14		0	0	0	68398	0	562251	1713671		
58101	1272	40213160	1984-08-24	1984-08-24 00:00:00	1984-08-24	1984-08-24 00:00:00	1984-08-24	581452		0	0	0		0	0	0	83918	0	10	40213160		
43535	3610	19019273	2017-04-18	2017-04-18 00:00:00	2017-04-18	2017-04-18 00:00:00	\N	38000177		0	0	0		0	0	0	239893	0	198014	19019273		
47392	3929	40236824	1977-05-23	1977-05-23 00:00:00	1977-05-30	1977-05-30 00:00:00	1977-05-30	38000177		0	0	7		0	0	0	261169	0	1094107	40236824		
44513	969	40213296	2018-05-13	2018-05-13 00:00:00	2018-05-13	2018-05-13 00:00:00	2018-05-13	581452		0	0	0		0	0	0	64444	0	52	40213296		
5282	443	1115171	2012-05-01	2012-05-01 00:00:00	2012-06-30	2012-06-30 00:00:00	2012-06-30	38000177		0	0	60		0	0	0	29431	0	849574	1115171		
54188	4503	40162522	2001-02-17	2001-02-17 00:00:00	2001-02-17	2001-02-17 00:00:00	\N	38000177		0	0	0		0	0	0	299863	0	857005	40162522		
93992	2062	40213227	2007-10-20	2007-10-20 00:00:00	2007-10-20	2007-10-20 00:00:00	2007-10-20	581452		0	0	0		0	0	0	137136	0	113	40213227		
46461	3849	19133873	1965-02-14	1965-02-14 00:00:00	1965-02-25	1965-02-25 00:00:00	1965-02-25	38000177		0	0	11		0	0	0	255451	0	834061	19133873		
68895	1508	40213227	2015-04-21	2015-04-21 00:00:00	2015-04-21	2015-04-21 00:00:00	2015-04-21	581452		0	0	0		0	0	0	100622	0	113	40213227		
58660	4872	19059056	1941-04-28	1941-04-28 00:00:00	1941-06-02	1941-06-02 00:00:00	1941-06-02	38000177		0	0	35		0	0	0	323951	0	243670	19059056		
11017	918	1127433	1985-04-27	1985-04-27 00:00:00	1985-05-27	1985-05-27 00:00:00	1985-05-27	38000177		0	0	30		0	0	0	61201	0	313782	1127433		
16096	1334	1127078	1974-05-19	1974-05-19 00:00:00	1974-06-02	1974-06-02 00:00:00	1974-06-02	38000177		0	0	14		0	0	0	88509	0	282464	1127078		
8529	711	920300	2010-01-03	2010-01-03 00:00:00	2010-01-10	2010-01-10 00:00:00	2010-01-10	38000177		0	0	7		0	0	0	47086	0	311989	920300		
50526	4199	40236824	1955-05-25	1955-05-25 00:00:00	1955-06-01	1955-06-01 00:00:00	1955-06-01	38000177		0	0	7		0	0	0	278634	0	1094107	40236824		
22450	1846	1713671	1964-05-13	1964-05-13 00:00:00	1964-05-27	1964-05-27 00:00:00	1964-05-27	38000177		0	0	14		0	0	0	123396	0	562251	1713671		
54939	4562	19129655	1963-02-17	1963-02-17 00:00:00	1963-03-03	1963-03-03 00:00:00	1963-03-03	38000177		0	0	14		0	0	0	304021	0	789980	19129655		
119191	2621	40213260	2007-11-24	2007-11-24 00:00:00	2007-11-24	2007-11-24 00:00:00	2007-11-24	581452		0	0	0		0	0	0	173366	0	121	40213260		
47705	3956	19059056	1917-07-25	1917-07-25 00:00:00	1917-08-08	1917-08-08 00:00:00	1917-08-08	38000177		0	0	14		0	0	0	262970	0	243670	19059056		
208772	4579	40213296	2009-03-20	2009-03-20 00:00:00	2009-03-20	2009-03-20 00:00:00	2009-03-20	581452		0	0	0		0	0	0	305021	0	52	40213296		
16290	1352	19078924	1976-07-29	1976-07-29 00:00:00	1976-07-29	1976-07-29 00:00:00	1976-07-29	38000177		0	0	0		0	0	0	89606	0	311700	19078924		
48967	4064	1118084	1997-12-16	1997-12-16 00:00:00	1997-12-16	1997-12-16 00:00:00	\N	38000177		0	0	0		0	0	0	270106	0	00025152531	44923712		
862	69	1713671	1976-03-21	1976-03-21 00:00:00	1976-04-04	1976-04-04 00:00:00	1976-04-04	38000177		0	0	14		0	0	0	4699	0	562251	1713671		
16391	1358	19133905	1976-07-27	1976-07-27 00:00:00	1976-08-05	1976-08-05 00:00:00	1976-08-05	38000177		0	0	9		0	0	0	90047	0	834102	19133905		
23997	1975	1713671	1938-05-23	1938-05-23 00:00:00	1938-06-06	1938-06-06 00:00:00	1938-06-06	38000177		0	0	14		0	0	0	131296	0	562251	1713671		
139932	3074	40213227	1992-07-15	1992-07-15 00:00:00	1992-07-15	1992-07-15 00:00:00	1992-07-15	581452		0	0	0		0	0	0	204591	0	113	40213227		
27007	2228	1124300	1984-08-26	1984-08-26 00:00:00	1984-08-26	1984-08-26 00:00:00	\N	38000177		0	0	0		0	0	0	148212	0	00781178901	45011828		
143257	3147	40213227	1998-02-16	1998-02-16 00:00:00	1998-02-16	1998-02-16 00:00:00	1998-02-16	581452		0	0	0		0	0	0	209424	0	113	40213227		
4476	371	1713671	1971-02-21	1971-02-21 00:00:00	1971-03-07	1971-03-07 00:00:00	1971-03-07	38000177		0	0	14		0	0	0	24692	0	562251	1713671		
44788	3707	19019979	1975-09-27	1975-09-27 00:00:00	1975-11-01	1975-11-01 00:00:00	1975-11-01	38000177		0	0	35		0	0	0	246453	0	198405	19019979		
38388	3175	19078461	1995-02-01	1995-02-01 00:00:00	1995-03-03	1995-03-03 00:00:00	1995-03-03	38000177		0	0	30		0	0	0	211054	0	310965	19078461		
15079	1259	19008572	1981-04-02	1981-04-02 00:00:00	1981-04-02	1981-04-02 00:00:00	\N	38000177		0	0	0		0	0	0	82922	0	106258	19008572		
99046	2168	40213296	1996-09-19	1996-09-19 00:00:00	1996-09-19	1996-09-19 00:00:00	1996-09-19	581452		0	0	0		0	0	0	144471	0	52	40213296		
3031	246	19059056	1975-02-03	1975-02-03 00:00:00	1975-02-24	1975-02-24 00:00:00	1975-02-24	38000177		0	0	21		0	0	0	16545	0	243670	19059056		
5828	487	1127433	1998-10-23	1998-10-23 00:00:00	1998-11-06	1998-11-06 00:00:00	1998-11-06	38000177		0	0	14		0	0	0	32528	0	313782	1127433		
19556	1609	19059056	1980-11-21	1980-11-21 00:00:00	1980-12-19	1980-12-19 00:00:00	1980-12-19	38000177		0	0	28		0	0	0	108162	0	243670	19059056		
53060	4409	1713671	2008-09-18	2008-09-18 00:00:00	2008-12-18	2008-12-18 00:00:00	2008-12-18	38000177		0	0	91		0	0	0	293056	0	562251	1713671		
18325	1517	40229134	1984-11-25	1984-11-25 00:00:00	1984-12-02	1984-12-02 00:00:00	1984-12-02	38000177		0	0	7		0	0	0	101456	0	1043400	40229134		
72106	1576	40213296	2009-10-17	2009-10-17 00:00:00	2009-10-17	2009-10-17 00:00:00	2009-10-17	581452		0	0	0		0	0	0	105816	0	52	40213296		
25235	2077	1310034	2005-08-21	2005-08-21 00:00:00	2005-08-21	2005-08-21 00:00:00	2005-08-21	38000177		0	0	0		0	0	0	138380	0	834357	1310034		
63733	5295	19059056	1933-07-25	1933-07-25 00:00:00	1933-08-15	1933-08-15 00:00:00	1933-08-15	38000177		0	0	21		0	0	0	352208	0	243670	19059056		
54031	4490	19126352	1984-02-18	1984-02-18 00:00:00	1988-04-23	1988-04-23 00:00:00	1988-04-23	38000177		0	0	1526		0	0	0	298872	0	705129	19126352		
21409	1760	19128022	1993-06-05	1993-06-05 00:00:00	1994-05-31	1994-05-31 00:00:00	1994-05-31	38000177		0	0	360		0	0	0	117679	0	749785	19128022		
35885	2955	1127433	1975-04-30	1975-04-30 00:00:00	1975-05-07	1975-05-07 00:00:00	1975-05-07	38000177		0	0	7		0	0	0	197203	0	313782	1127433		
59248	4924	1124300	2014-01-19	2014-01-19 00:00:00	2014-01-19	2014-01-19 00:00:00	\N	38000177		0	0	0		0	0	0	327222	0	00781178901	45011828		
30669	2543	19133873	1979-09-04	1979-09-04 00:00:00	1979-09-14	1979-09-14 00:00:00	1979-09-14	38000177		0	0	10		0	0	0	168281	0	834061	19133873		
144609	3178	40213160	1955-09-03	1955-09-03 00:00:00	1955-09-03	1955-09-03 00:00:00	1955-09-03	581452		0	0	0		0	0	0	211381	0	10	40213160		
10310	220	40213314	1983-11-09	1983-11-09 00:00:00	1983-11-09	1983-11-09 00:00:00	1983-11-09	581452		0	0	0		0	0	0	14831	0	49	40213314		
60226	5005	1127078	1980-07-24	1980-07-24 00:00:00	1980-08-07	1980-08-07 00:00:00	1980-08-07	38000177		0	0	14		0	0	0	332937	0	282464	1127078		
3386	280	1713671	1960-12-06	1960-12-06 00:00:00	1960-12-27	1960-12-27 00:00:00	1960-12-27	38000177		0	0	21		0	0	0	18673	0	562251	1713671		
201441	4423	40213296	2017-11-17	2017-11-17 00:00:00	2017-11-17	2017-11-17 00:00:00	2017-11-17	581452		0	0	0		0	0	0	294075	0	52	40213296		
9510	793	1127433	1982-03-23	1982-03-23 00:00:00	1982-03-30	1982-03-30 00:00:00	1982-03-30	38000177		0	0	7		0	0	0	52602	0	313782	1127433		
26020	2141	1713671	1981-06-24	1981-06-24 00:00:00	1981-07-08	1981-07-08 00:00:00	1981-07-08	38000177		0	0	14		0	0	0	142614	0	562251	1713671		
9590	800	1127433	1994-06-04	1994-06-04 00:00:00	1994-08-10	1994-08-10 00:00:00	1994-08-10	38000177		0	0	67		0	0	0	53093	0	313782	1127433		
1155	94	19075601	2005-01-28	2005-01-28 00:00:00	2005-01-28	2005-01-28 00:00:00	2005-01-28	38000177		0	0	0		0	0	0	6358	0	309362	19075601		
20153	1656	19128263	2010-08-24	2010-08-24 00:00:00	2011-08-19	2011-08-19 00:00:00	2011-08-19	38000177		0	0	360		0	0	0	111066	0	751905	19128263		
11707	973	1713671	1970-12-07	1970-12-07 00:00:00	1970-12-28	1970-12-28 00:00:00	1970-12-28	38000177		0	0	21		0	0	0	64836	0	562251	1713671		
143129	3144	40213296	2005-06-08	2005-06-08 00:00:00	2005-06-08	2005-06-08 00:00:00	2005-06-08	581452		0	0	0		0	0	0	209237	0	52	40213296		
19042	1572	1127433	1976-01-24	1976-01-24 00:00:00	1976-04-23	1976-04-23 00:00:00	1976-04-23	38000177		0	0	90		0	0	0	105546	0	313782	1127433		
1680	133	1118084	2019-03-26	2019-03-26 00:00:00	2019-03-26	2019-03-26 00:00:00	\N	38000177		0	0	0		0	0	0	8972	0	00025152531	44923712		
23344	1924	1713671	1981-12-05	1981-12-05 00:00:00	1982-02-20	1982-02-20 00:00:00	1982-02-20	38000177		0	0	77		0	0	0	128071	0	562251	1713671		
148024	3254	40213160	1964-03-08	1964-03-08 00:00:00	1964-03-08	1964-03-08 00:00:00	1964-03-08	581452		0	0	0		0	0	0	216412	0	10	40213160		
27931	2311	40229134	1973-08-31	1973-08-31 00:00:00	1973-09-14	1973-09-14 00:00:00	1973-09-14	38000177		0	0	14		0	0	0	153696	0	1043400	40229134		
33939	2806	40173590	2013-06-13	2013-06-13 00:00:00	2013-06-13	2013-06-13 00:00:00	\N	38000177		0	0	0		0	0	0	185935	0	904419	40173590		
12363	1039	40162522	1978-10-02	1978-10-02 00:00:00	1978-10-02	1978-10-02 00:00:00	\N	38000177		0	0	0		0	0	0	68331	0	857005	40162522		
58104	1272	40213314	1979-12-21	1979-12-21 00:00:00	1979-12-21	1979-12-21 00:00:00	1979-12-21	581452		0	0	0		0	0	0	83943	0	49	40213314		
43536	3610	1127433	1992-07-14	1992-07-14 00:00:00	1992-07-28	1992-07-28 00:00:00	1992-07-28	38000177		0	0	14		0	0	0	239890	0	313782	1127433		
47395	3929	1127433	2004-10-09	2004-10-09 00:00:00	2004-10-23	2004-10-23 00:00:00	2004-10-23	38000177		0	0	14		0	0	0	261151	0	313782	1127433		
44516	970	40213160	1957-05-19	1957-05-19 00:00:00	1957-05-19	1957-05-19 00:00:00	1957-05-19	581452		0	0	0		0	0	0	64554	0	10	40213160		
5283	443	1127433	1991-06-23	1991-06-23 00:00:00	1991-07-07	1991-07-07 00:00:00	1991-07-07	38000177		0	0	14		0	0	0	29428	0	313782	1127433		
54189	4503	1713671	2018-05-29	2018-05-29 00:00:00	2018-06-12	2018-06-12 00:00:00	2018-06-12	38000177		0	0	14		0	0	0	299830	0	562251	1713671		
93998	2063	40213296	2013-05-17	2013-05-17 00:00:00	2013-05-17	2013-05-17 00:00:00	2013-05-17	581452		0	0	0		0	0	0	137208	0	52	40213296		
46462	3849	1127433	1983-12-07	1983-12-07 00:00:00	1983-12-21	1983-12-21 00:00:00	1983-12-21	38000177		0	0	14		0	0	0	255429	0	313782	1127433		
80198	1755	40213227	1993-09-01	1993-09-01 00:00:00	1993-09-01	1993-09-01 00:00:00	1993-09-01	581452		0	0	0		0	0	0	117389	0	113	40213227		
58661	4872	1713671	1921-12-30	1921-12-30 00:00:00	1922-01-06	1922-01-06 00:00:00	1922-01-06	38000177		0	0	7		0	0	0	323959	0	562251	1713671		
11018	918	1310034	2016-05-20	2016-05-20 00:00:00	2016-05-20	2016-05-20 00:00:00	2016-05-20	38000177		0	0	0		0	0	0	61206	0	834357	1310034		
16097	1334	1127433	1997-01-23	1997-01-23 00:00:00	1997-02-27	1997-02-27 00:00:00	1997-02-27	38000177		0	0	35		0	0	0	88531	0	313782	1127433		
8530	711	1127433	1978-07-28	1978-07-28 00:00:00	1978-10-03	1978-10-03 00:00:00	1978-10-03	38000177		0	0	67		0	0	0	47197	0	313782	1127433		
50527	4199	920300	1955-05-25	1955-05-25 00:00:00	1955-06-01	1955-06-01 00:00:00	1955-06-01	38000177		0	0	7		0	0	0	278634	0	311989	920300		
22451	1846	40231925	1963-12-20	1963-12-20 00:00:00	1963-12-20	1963-12-20 00:00:00	\N	38000177		0	0	0		0	0	0	123441	0	1049221	40231925		
54940	4562	19008572	1967-11-30	1967-11-30 00:00:00	1967-12-21	1967-12-21 00:00:00	1967-12-21	38000177		0	0	21		0	0	0	304018	0	106258	19008572		
29535	2444	19075601	2013-08-11	2013-08-11 00:00:00	2013-08-11	2013-08-11 00:00:00	2013-08-11	38000177		0	0	0		0	0	0	162130	0	309362	19075601		
47706	3956	19078461	1974-12-10	1974-12-10 00:00:00	1974-12-24	1974-12-24 00:00:00	1974-12-24	38000177		0	0	14		0	0	0	263002	0	310965	19078461		
208775	4579	40213160	1968-03-22	1968-03-22 00:00:00	1968-03-22	1968-03-22 00:00:00	1968-03-22	581452		0	0	0		0	0	0	305025	0	10	40213160		
16291	1352	40165015	1976-07-30	1976-07-30 00:00:00	1976-07-30	1976-07-30 00:00:00	\N	38000177		0	0	0		0	0	0	89606	0	861467	40165015		
48968	4064	19008572	1982-02-12	1982-02-12 00:00:00	1982-02-26	1982-02-26 00:00:00	1982-02-26	38000177		0	0	14		0	0	0	270112	0	106258	19008572		
863	70	40229134	1962-07-17	1962-07-17 00:00:00	1962-07-31	1962-07-31 00:00:00	1962-07-31	38000177		0	0	14		0	0	0	4716	0	1043400	40229134		
16392	1358	1713671	1957-08-10	1957-08-10 00:00:00	1957-10-05	1957-10-05 00:00:00	1957-10-05	38000177		0	0	56		0	0	0	90096	0	562251	1713671		
23998	1975	19059056	1924-10-28	1924-10-28 00:00:00	1924-11-11	1924-11-11 00:00:00	1924-11-11	38000177		0	0	14		0	0	0	131308	0	243670	19059056		
36931	806	40213296	1997-01-05	1997-01-05 00:00:00	1997-01-05	1997-01-05 00:00:00	1997-01-05	581452		0	0	0		0	0	0	53497	0	52	40213296		
27008	2228	40173590	2007-04-21	2007-04-21 00:00:00	2007-04-21	2007-04-21 00:00:00	\N	38000177		0	0	0		0	0	0	148242	0	904419	40173590		
143278	3147	40213198	2012-05-07	2012-05-07 00:00:00	2012-05-07	2012-05-07 00:00:00	2012-05-07	581452		0	0	0		0	0	0	209367	0	133	40213198		
4477	371	19133873	1982-04-02	1982-04-02 00:00:00	1982-04-09	1982-04-09 00:00:00	1982-04-09	38000177		0	0	7		0	0	0	24664	0	834061	19133873		
44789	3707	19059056	1970-04-07	1970-04-07 00:00:00	1970-04-21	1970-04-21 00:00:00	1970-04-21	38000177		0	0	14		0	0	0	246466	0	243670	19059056		
38389	3175	1124300	1999-05-02	1999-05-02 00:00:00	1999-05-02	1999-05-02 00:00:00	\N	38000177		0	0	0		0	0	0	211046	0	00781178901	45011828		
15080	1259	1150771	1981-04-14	1981-04-14 00:00:00	1981-04-14	1981-04-14 00:00:00	\N	38000177		0	0	0		0	0	0	82942	0	197378	1150771		
179472	3946	40213227	2001-08-14	2001-08-14 00:00:00	2001-08-14	2001-08-14 00:00:00	2001-08-14	581452		0	0	0		0	0	0	262326	0	113	40213227		
3032	246	19059056	1961-11-15	1961-11-15 00:00:00	1962-01-14	1962-01-14 00:00:00	1962-01-14	38000177		0	0	60		0	0	0	16583	0	243670	19059056		
5829	487	1127433	2009-11-08	2009-11-08 00:00:00	2009-11-22	2009-11-22 00:00:00	2009-11-22	38000177		0	0	14		0	0	0	32529	0	313782	1127433		
53005	4405	46233988	1969-09-01	1969-09-01 00:00:00	1969-09-15	1969-09-15 00:00:00	1969-09-15	38000177		0	0	14		0	0	0	292787	0	1652673	46233988		
53061	4409	1127433	1983-07-15	1983-07-15 00:00:00	1983-08-19	1983-08-19 00:00:00	1983-08-19	38000177		0	0	35		0	0	0	293128	0	313782	1127433		
18326	1517	19059056	1945-02-22	1945-02-22 00:00:00	1945-03-08	1945-03-08 00:00:00	1945-03-08	38000177		0	0	14		0	0	0	101445	0	243670	19059056		
153805	3386	40213160	1969-03-09	1969-03-09 00:00:00	1969-03-09	1969-03-09 00:00:00	1969-03-09	581452		0	0	0		0	0	0	224611	0	10	40213160		
25236	2077	46275916	2005-08-21	2005-08-21 00:00:00	2005-08-21	2005-08-21 00:00:00	2005-08-21	38000177		0	0	0		0	0	0	138380	0	1660014	46275916		
90651	1989	40213227	2013-04-19	2013-04-19 00:00:00	2013-04-19	2013-04-19 00:00:00	2013-04-19	581452		0	0	0		0	0	0	132440	0	113	40213227		
54032	4490	19133905	1971-03-29	1971-03-29 00:00:00	1971-04-07	1971-04-07 00:00:00	1971-04-07	38000177		0	0	9		0	0	0	298917	0	834102	19133905		
21410	1760	19078461	2005-02-22	2005-02-22 00:00:00	2005-03-29	2005-03-29 00:00:00	2005-03-29	38000177		0	0	35		0	0	0	117689	0	310965	19078461		
35886	2955	19133873	1969-12-29	1969-12-29 00:00:00	1970-01-07	1970-01-07 00:00:00	1970-01-07	38000177		0	0	9		0	0	0	197274	0	834061	19133873		
59249	4924	19019979	1989-04-15	1989-04-15 00:00:00	1989-05-13	1989-05-13 00:00:00	1989-05-13	38000177		0	0	28		0	0	0	327219	0	198405	19019979		
30671	2543	19059056	1967-08-04	1967-08-04 00:00:00	1967-08-18	1967-08-18 00:00:00	1967-08-18	38000177		0	0	14		0	0	0	168255	0	243670	19059056		
144610	3178	40213160	1955-03-05	1955-03-05 00:00:00	1955-03-05	1955-03-05 00:00:00	1955-03-05	581452		0	0	0		0	0	0	211428	0	10	40213160		
10315	220	40213251	1984-02-08	1984-02-08 00:00:00	1984-02-08	1984-02-08 00:00:00	1984-02-08	581452		0	0	0		0	0	0	14802	0	21	40213251		
60227	5005	40229134	2013-12-08	2013-12-08 00:00:00	2013-12-15	2013-12-15 00:00:00	2013-12-15	38000177		0	0	7		0	0	0	332931	0	1043400	40229134		
3387	280	1127433	1993-11-18	1993-11-18 00:00:00	1993-12-09	1993-12-09 00:00:00	1993-12-09	38000177		0	0	21		0	0	0	18707	0	313782	1127433		
201443	4423	40213314	1977-07-29	1977-07-29 00:00:00	1977-07-29	1977-07-29 00:00:00	1977-07-29	581452		0	0	0		0	0	0	294068	0	49	40213314		
9511	793	40165015	2012-02-20	2012-02-20 00:00:00	2012-02-20	2012-02-20 00:00:00	\N	38000177		0	0	0		0	0	0	52650	0	861467	40165015		
26021	2141	1713671	1995-10-30	1995-10-30 00:00:00	1995-11-13	1995-11-13 00:00:00	1995-11-13	38000177		0	0	14		0	0	0	142662	0	562251	1713671		
9591	800	19133905	2013-03-15	2013-03-15 00:00:00	2013-03-23	2013-03-23 00:00:00	2013-03-23	38000177		0	0	8		0	0	0	53132	0	834102	19133905		
1156	94	19059056	1954-05-17	1954-05-17 00:00:00	1954-05-31	1954-05-31 00:00:00	1954-05-31	38000177		0	0	14		0	0	0	6359	0	243670	19059056		
20154	1656	1118084	2018-07-04	2018-07-04 00:00:00	2018-07-04	2018-07-04 00:00:00	\N	38000177		0	0	0		0	0	0	111097	0	00025152531	44923712		
11708	973	1154615	1917-08-23	1917-08-23 00:00:00	1917-08-23	1917-08-23 00:00:00	\N	38000177		0	0	0		0	0	0	64732	0	745679	1154615		
143131	3144	40213227	2005-06-08	2005-06-08 00:00:00	2005-06-08	2005-06-08 00:00:00	2005-06-08	581452		0	0	0		0	0	0	209237	0	113	40213227		
19043	1572	1127433	2016-07-27	2016-07-27 00:00:00	2016-08-10	2016-08-10 00:00:00	2016-08-10	38000177		0	0	14		0	0	0	105579	0	313782	1127433		
1681	133	19133873	1990-05-31	1990-05-31 00:00:00	1990-06-10	1990-06-10 00:00:00	1990-06-10	38000177		0	0	10		0	0	0	8958	0	834061	19133873		
23345	1924	40171902	2019-06-28	2019-06-28 00:00:00	2019-06-28	2019-06-28 00:00:00	\N	38000177		0	0	0		0	0	0	128060	0	897718	40171902		
148031	3254	40213227	2005-12-11	2005-12-11 00:00:00	2005-12-11	2005-12-11 00:00:00	2005-12-11	581452		0	0	0		0	0	0	216462	0	113	40213227		
27932	2311	1127433	2010-11-03	2010-11-03 00:00:00	2010-12-01	2010-12-01 00:00:00	2010-12-01	38000177		0	0	28		0	0	0	153700	0	313782	1127433		
33940	2806	1127433	1985-02-28	1985-02-28 00:00:00	1985-03-14	1985-03-14 00:00:00	1985-03-14	38000177		0	0	14		0	0	0	185992	0	313782	1127433		
12364	1039	19059056	1978-10-02	1978-10-02 00:00:00	1978-12-01	1978-12-01 00:00:00	1978-12-01	38000177		0	0	60		0	0	0	68331	0	243670	19059056		
58105	1272	40213160	1979-12-21	1979-12-21 00:00:00	1979-12-21	1979-12-21 00:00:00	1979-12-21	581452		0	0	0		0	0	0	83943	0	10	40213160		
43537	3610	1124300	1985-02-10	1985-02-10 00:00:00	1985-02-10	1985-02-10 00:00:00	\N	38000177		0	0	0		0	0	0	239880	0	00781178901	45011828		
47396	3929	19078461	1983-09-04	1983-09-04 00:00:00	1983-10-02	1983-10-02 00:00:00	1983-10-02	38000177		0	0	28		0	0	0	261148	0	310965	19078461		
44519	970	40213160	1956-05-13	1956-05-13 00:00:00	1956-05-13	1956-05-13 00:00:00	1956-05-13	581452		0	0	0		0	0	0	64560	0	10	40213160		
5284	443	1127433	2013-05-26	2013-05-26 00:00:00	2013-06-25	2013-06-25 00:00:00	2013-06-25	38000177		0	0	30		0	0	0	29432	0	313782	1127433		
54190	4503	1713671	2004-07-24	2004-07-24 00:00:00	2004-07-31	2004-07-31 00:00:00	2004-07-31	38000177		0	0	7		0	0	0	299812	0	562251	1713671		
94000	2063	40213160	1973-02-16	1973-02-16 00:00:00	1973-02-16	1973-02-16 00:00:00	1973-02-16	581452		0	0	0		0	0	0	137252	0	10	40213160		
46463	3849	1124300	2003-06-29	2003-06-29 00:00:00	2003-06-29	2003-06-29 00:00:00	\N	38000177		0	0	0		0	0	0	255415	0	00781178901	45011828		
80201	1755	40213227	2001-06-27	2001-06-27 00:00:00	2001-06-27	2001-06-27 00:00:00	2001-06-27	581452		0	0	0		0	0	0	117338	0	113	40213227		
58662	4872	19059056	1930-11-14	1930-11-14 00:00:00	1930-11-28	1930-11-28 00:00:00	1930-11-28	38000177		0	0	14		0	0	0	324058	0	243670	19059056		
11019	918	40243436	2016-05-20	2016-05-20 00:00:00	2016-05-20	2016-05-20 00:00:00	2016-05-20	38000177		0	0	0		0	0	0	61206	0	1190795	40243436		
16098	1335	1127433	2017-06-24	2017-06-24 00:00:00	2017-07-01	2017-07-01 00:00:00	2017-07-01	38000177		0	0	7		0	0	0	88544	0	313782	1127433		
8531	711	1127433	1985-10-30	1985-10-30 00:00:00	1985-11-06	1985-11-06 00:00:00	1985-11-06	38000177		0	0	7		0	0	0	47165	0	313782	1127433		
50528	4199	1127433	2014-09-28	2014-09-28 00:00:00	2014-10-05	2014-10-05 00:00:00	2014-10-05	38000177		0	0	7		0	0	0	278627	0	313782	1127433		
22452	1846	19059056	1963-12-20	1963-12-20 00:00:00	1964-03-19	1964-03-19 00:00:00	1964-03-19	38000177		0	0	90		0	0	0	123441	0	243670	19059056		
54941	4562	1127433	1985-04-30	1985-04-30 00:00:00	1985-05-07	1985-05-07 00:00:00	1985-05-07	38000177		0	0	7		0	0	0	304041	0	313782	1127433		
29536	2444	1124300	1998-11-14	1998-11-14 00:00:00	1998-11-14	1998-11-14 00:00:00	\N	38000177		0	0	0		0	0	0	162105	0	00781178901	45011828		
47707	3956	40229134	1924-03-22	1924-03-22 00:00:00	1924-04-05	1924-04-05 00:00:00	1924-04-05	38000177		0	0	14		0	0	0	263025	0	1043400	40229134		
208779	4579	40213296	2010-06-18	2010-06-18 00:00:00	2010-06-18	2010-06-18 00:00:00	2010-06-18	581452		0	0	0		0	0	0	\N	0	52	40213296		
16292	1352	40220386	1976-07-29	1976-07-29 00:00:00	1976-07-29	1976-07-29 00:00:00	1976-07-29	38000177		0	0	0		0	0	0	89606	0	1808217	40220386		
48969	4064	19133873	1966-11-18	1966-11-18 00:00:00	1966-11-30	1966-11-30 00:00:00	1966-11-30	38000177		0	0	12		0	0	0	270109	0	834061	19133873		
864	70	19133905	2019-04-24	2019-04-24 00:00:00	2019-05-03	2019-05-03 00:00:00	2019-05-03	38000177		0	0	9		0	0	0	4766	0	834102	19133905		
16393	1358	1127433	1976-04-07	1976-04-07 00:00:00	1976-05-07	1976-05-07 00:00:00	1976-05-07	38000177		0	0	30		0	0	0	90108	0	313782	1127433		
23999	1975	19115351	1973-01-29	1973-01-29 00:00:00	1973-01-29	1973-01-29 00:00:00	\N	38000177		0	0	0		0	0	0	131312	0	563026	19115351		
36943	806	40213227	2008-01-06	2008-01-06 00:00:00	2008-01-06	2008-01-06 00:00:00	2008-01-06	581452		0	0	0		0	0	0	53493	0	113	40213227		
27009	2228	1713671	1996-01-21	1996-01-21 00:00:00	1996-02-04	1996-02-04 00:00:00	1996-02-04	38000177		0	0	14		0	0	0	148267	0	562251	1713671		
136349	2993	40213227	1992-08-15	1992-08-15 00:00:00	1992-08-15	1992-08-15 00:00:00	1992-08-15	581452		0	0	0		0	0	0	199824	0	113	40213227		
4478	371	1124300	2008-05-11	2008-05-11 00:00:00	2008-05-11	2008-05-11 00:00:00	\N	38000177		0	0	0		0	0	0	24691	0	00781178901	45011828		
44790	3707	46233988	1970-04-07	1970-04-07 00:00:00	1970-04-21	1970-04-21 00:00:00	1970-04-21	38000177		0	0	14		0	0	0	246466	0	1652673	46233988		
38390	3175	40229134	2010-07-09	2010-07-09 00:00:00	2010-07-23	2010-07-23 00:00:00	2010-07-23	38000177		0	0	14		0	0	0	211030	0	1043400	40229134		
15081	1259	1127433	1988-05-26	1988-05-26 00:00:00	1988-06-30	1988-06-30 00:00:00	1988-06-30	38000177		0	0	35		0	0	0	82963	0	313782	1127433		
179473	3946	40213296	2001-08-14	2001-08-14 00:00:00	2001-08-14	2001-08-14 00:00:00	2001-08-14	581452		0	0	0		0	0	0	262326	0	52	40213296		
3033	246	1127433	2018-03-15	2018-03-15 00:00:00	2018-04-05	2018-04-05 00:00:00	2018-04-05	38000177		0	0	21		0	0	0	16551	0	313782	1127433		
5831	487	19133873	1972-08-12	1972-08-12 00:00:00	1972-08-22	1972-08-22 00:00:00	1972-08-22	38000177		0	0	10		0	0	0	32603	0	834061	19133873		
53006	4405	1713671	2011-06-20	2011-06-20 00:00:00	2011-07-11	2011-07-11 00:00:00	2011-07-11	38000177		0	0	21		0	0	0	292789	0	562251	1713671		
53062	4409	1127433	2016-09-29	2016-09-29 00:00:00	2016-10-13	2016-10-13 00:00:00	2016-10-13	38000177		0	0	14		0	0	0	293109	0	313782	1127433		
18327	1517	19115351	1949-10-29	1949-10-29 00:00:00	1950-01-28	1950-01-28 00:00:00	1950-01-28	38000177		0	0	91		0	0	0	101446	0	563026	19115351		
153810	3386	40213160	1973-11-11	1973-11-11 00:00:00	1973-11-11	1973-11-11 00:00:00	1973-11-11	581452		0	0	0		0	0	0	224614	0	10	40213160		
25237	2077	1124300	1972-06-04	1972-06-04 00:00:00	1972-06-04	1972-06-04 00:00:00	\N	38000177		0	0	0		0	0	0	138292	0	00781178901	45011828		
90657	1989	40213160	1955-02-11	1955-02-11 00:00:00	1955-02-11	1955-02-11 00:00:00	1955-02-11	581452		0	0	0		0	0	0	132436	0	10	40213160		
54033	4490	19133768	1988-04-23	1988-04-23 00:00:00	1988-04-23	1988-04-23 00:00:00	1988-04-23	38000177		0	0	0		0	0	0	298886	0	833036	19133768		
21411	1760	40229134	2015-01-02	2015-01-02 00:00:00	2015-01-16	2015-01-16 00:00:00	2015-01-16	38000177		0	0	14		0	0	0	117694	0	1043400	40229134		
35887	2955	1713671	1978-08-16	1978-08-16 00:00:00	1978-08-30	1978-08-30 00:00:00	1978-08-30	38000177		0	0	14		0	0	0	197240	0	562251	1713671		
59250	4924	19008572	1989-02-17	1989-02-17 00:00:00	1989-03-10	1989-03-10 00:00:00	1989-03-10	38000177		0	0	21		0	0	0	327260	0	106258	19008572		
30672	2543	19129655	1967-08-04	1967-08-04 00:00:00	1967-08-18	1967-08-18 00:00:00	1967-08-18	38000177		0	0	14		0	0	0	168255	0	789980	19129655		
134815	2959	40213296	2010-12-28	2010-12-28 00:00:00	2010-12-28	2010-12-28 00:00:00	2010-12-28	581452		0	0	0		0	0	0	197598	0	52	40213296		
10316	220	40213314	1982-12-08	1982-12-08 00:00:00	1982-12-08	1982-12-08 00:00:00	1982-12-08	581452		0	0	0		0	0	0	14847	0	49	40213314		
60228	5005	1713671	2003-05-28	2003-05-28 00:00:00	2003-06-11	2003-06-11 00:00:00	2003-06-11	38000177		0	0	14		0	0	0	332911	0	562251	1713671		
3388	280	1713671	1947-03-20	1947-03-20 00:00:00	1947-04-10	1947-04-10 00:00:00	1947-04-10	38000177		0	0	21		0	0	0	18715	0	562251	1713671		
201449	4423	40213314	1978-01-27	1978-01-27 00:00:00	1978-01-27	1978-01-27 00:00:00	1978-01-27	581452		0	0	0		0	0	0	294077	0	49	40213314		
9512	793	1127433	1992-07-02	1992-07-02 00:00:00	1992-07-09	1992-07-09 00:00:00	1992-07-09	38000177		0	0	7		0	0	0	52617	0	313782	1127433		
26022	2141	1127433	1958-04-07	1958-04-07 00:00:00	1958-04-14	1958-04-14 00:00:00	1958-04-14	38000177		0	0	7		0	0	0	142650	0	313782	1127433		
9592	800	19078461	2010-02-08	2010-02-08 00:00:00	2010-03-01	2010-03-01 00:00:00	2010-03-01	38000177		0	0	21		0	0	0	53095	0	310965	19078461		
1157	94	19006318	1954-05-17	1954-05-17 00:00:00	1954-05-31	1954-05-31 00:00:00	1954-05-31	38000177		0	0	14		0	0	0	6359	0	105078	19006318		
20155	1656	19133679	2013-08-13	2013-08-13 00:00:00	2014-08-08	2014-08-08 00:00:00	2014-08-08	38000177		0	0	360		0	0	0	111072	0	831533	19133679		
11709	973	40169216	1917-08-23	1917-08-23 00:00:00	1917-08-23	1917-08-23 00:00:00	\N	38000177		0	0	0		0	0	0	64732	0	895994	40169216		
143133	3144	40213160	1963-11-06	1963-11-06 00:00:00	1963-11-06	1963-11-06 00:00:00	1963-11-06	581452		0	0	0		0	0	0	209210	0	10	40213160		
19044	1572	40236824	1987-08-01	1987-08-01 00:00:00	1987-08-08	1987-08-08 00:00:00	1987-08-08	38000177		0	0	7		0	0	0	105568	0	1094107	40236824		
1682	133	1127433	2010-08-11	2010-08-11 00:00:00	2010-08-25	2010-08-25 00:00:00	2010-08-25	38000177		0	0	14		0	0	0	8959	0	313782	1127433		
23346	1924	19018935	2019-06-28	2019-06-28 00:00:00	2019-06-28	2019-06-28 00:00:00	\N	38000177		0	0	0		0	0	0	128060	0	197604	19018935		
148032	3254	40213296	2005-12-11	2005-12-11 00:00:00	2005-12-11	2005-12-11 00:00:00	2005-12-11	581452		0	0	0		0	0	0	216462	0	52	40213296		
27933	2311	1127433	1963-03-25	1963-03-25 00:00:00	1963-04-08	1963-04-08 00:00:00	1963-04-08	38000177		0	0	14		0	0	0	153717	0	313782	1127433		
33941	2806	19075601	1997-05-01	1997-05-01 00:00:00	1997-05-01	1997-05-01 00:00:00	\N	38000177		0	0	0		0	0	0	185984	0	309362	19075601		
12365	1039	1127433	1977-08-17	1977-08-17 00:00:00	1977-09-07	1977-09-07 00:00:00	1977-09-07	38000177		0	0	21		0	0	0	68330	0	313782	1127433		
58109	1272	40213227	2002-01-18	2002-01-18 00:00:00	2002-01-18	2002-01-18 00:00:00	2002-01-18	581452		0	0	0		0	0	0	83924	0	113	40213227		
43538	3610	1127433	1987-06-20	1987-06-20 00:00:00	1987-07-04	1987-07-04 00:00:00	1987-07-04	38000177		0	0	14		0	0	0	239884	0	313782	1127433		
47397	3929	19133873	1961-04-05	1961-04-05 00:00:00	1961-04-17	1961-04-17 00:00:00	1961-04-17	38000177		0	0	12		0	0	0	261196	0	834061	19133873		
39745	867	40213227	1992-04-07	1992-04-07 00:00:00	1992-04-07	1992-04-07 00:00:00	1992-04-07	581452		0	0	0		0	0	0	57609	0	113	40213227		
5285	443	1115171	2006-03-19	2006-03-19 00:00:00	2006-04-03	2006-04-03 00:00:00	2006-04-03	38000177		0	0	15		0	0	0	29430	0	849574	1115171		
54191	4503	1127433	1999-07-31	1999-07-31 00:00:00	1999-08-14	1999-08-14 00:00:00	1999-08-14	38000177		0	0	14		0	0	0	299867	0	313782	1127433		
94007	2063	40213306	1995-02-17	1995-02-17 00:00:00	1995-02-17	1995-02-17 00:00:00	1995-02-17	581452		0	0	0		0	0	0	137242	0	43	40213306		
46464	3849	19133873	1968-04-13	1968-04-13 00:00:00	1968-04-21	1968-04-21 00:00:00	1968-04-21	38000177		0	0	8		0	0	0	255428	0	834061	19133873		
80202	1755	40213296	2001-06-27	2001-06-27 00:00:00	2001-06-27	2001-06-27 00:00:00	2001-06-27	581452		0	0	0		0	0	0	117338	0	52	40213296		
58663	4872	1713671	1927-12-10	1927-12-10 00:00:00	1927-12-24	1927-12-24 00:00:00	1927-12-24	38000177		0	0	14		0	0	0	323971	0	562251	1713671		
11020	918	46275916	2016-05-20	2016-05-20 00:00:00	2016-05-20	2016-05-20 00:00:00	2016-05-20	38000177		0	0	0		0	0	0	61206	0	1660014	46275916		
5728	124	40213227	2007-02-19	2007-02-19 00:00:00	2007-02-19	2007-02-19 00:00:00	2007-02-19	581452		0	0	0		0	0	0	8342	0	113	40213227		
8532	711	1127433	1983-06-09	1983-06-09 00:00:00	1983-07-07	1983-07-07 00:00:00	1983-07-07	38000177		0	0	28		0	0	0	47198	0	313782	1127433		
50529	4199	19008572	1962-05-03	1962-05-03 00:00:00	1962-05-03	1962-05-03 00:00:00	\N	38000177		0	0	0		0	0	0	278681	0	106258	19008572		
45238	986	40213201	1983-08-13	1983-08-13 00:00:00	1983-08-13	1983-08-13 00:00:00	1983-08-13	581452		0	0	0		0	0	0	65421	0	33	40213201		
54942	4562	1127433	1984-12-28	1984-12-28 00:00:00	1985-01-27	1985-01-27 00:00:00	1985-01-27	38000177		0	0	30		0	0	0	303955	0	313782	1127433		
29537	2444	1713671	1963-11-21	1963-11-21 00:00:00	1963-12-05	1963-12-05 00:00:00	1963-12-05	38000177		0	0	14		0	0	0	162158	0	562251	1713671		
47708	3956	1713671	1977-09-25	1977-09-25 00:00:00	1977-10-02	1977-10-02 00:00:00	1977-10-02	38000177		0	0	7		0	0	0	263028	0	562251	1713671		
208783	4579	40213227	2000-03-03	2000-03-03 00:00:00	2000-03-03	2000-03-03 00:00:00	2000-03-03	581452		0	0	0		0	0	0	305041	0	113	40213227		
49408	4100	1713671	1966-09-20	1966-09-20 00:00:00	1966-10-11	1966-10-11 00:00:00	1966-10-11	38000177		0	0	21		0	0	0	272381	0	562251	1713671		
59445	4942	19133873	1960-03-29	1960-03-29 00:00:00	1960-04-10	1960-04-10 00:00:00	1960-04-10	38000177		0	0	12		0	0	0	328520	0	834061	19133873		
865	70	1127433	1960-01-10	1960-01-10 00:00:00	1960-01-24	1960-01-24 00:00:00	1960-01-24	38000177		0	0	14		0	0	0	4715	0	313782	1127433		
16394	1358	40162522	1976-04-07	1976-04-07 00:00:00	1976-04-07	1976-04-07 00:00:00	\N	38000177		0	0	0		0	0	0	90108	0	857005	40162522		
24000	1975	19133873	1932-07-22	1932-07-22 00:00:00	1932-07-29	1932-07-29 00:00:00	1932-07-29	38000177		0	0	7		0	0	0	131268	0	834061	19133873		
36944	806	40213260	2008-01-06	2008-01-06 00:00:00	2008-01-06	2008-01-06 00:00:00	2008-01-06	581452		0	0	0		0	0	0	53493	0	121	40213260		
27010	2228	1127433	1962-02-19	1962-02-19 00:00:00	1962-03-19	1962-03-19 00:00:00	1962-03-19	38000177		0	0	28		0	0	0	148292	0	313782	1127433		
136350	2993	40213306	1992-08-15	1992-08-15 00:00:00	1992-08-15	1992-08-15 00:00:00	1992-08-15	581452		0	0	0		0	0	0	199824	0	43	40213306		
4479	371	40229134	1991-12-10	1991-12-10 00:00:00	1991-12-24	1991-12-24 00:00:00	1991-12-24	38000177		0	0	14		0	0	0	24673	0	1043400	40229134		
44791	3707	1127433	1986-10-08	1986-10-08 00:00:00	1986-10-15	1986-10-15 00:00:00	1986-10-15	38000177		0	0	7		0	0	0	246460	0	313782	1127433		
38391	3175	19006318	1954-11-19	1954-11-19 00:00:00	1954-12-03	1954-12-03 00:00:00	1954-12-03	38000177		0	0	14		0	0	0	211039	0	105078	19006318		
15082	1259	19133905	1990-10-03	1990-10-03 00:00:00	1990-10-16	1990-10-16 00:00:00	1990-10-16	38000177		0	0	13		0	0	0	82977	0	834102	19133905		
179475	3946	40213260	2010-09-07	2010-09-07 00:00:00	2010-09-07	2010-09-07 00:00:00	2010-09-07	581452		0	0	0		0	0	0	262337	0	121	40213260		
3034	246	1118084	2000-06-03	2000-06-03 00:00:00	2000-06-03	2000-06-03 00:00:00	\N	38000177		0	0	0		0	0	0	16565	0	00025152531	44923712		
5832	487	19133905	2013-10-06	2013-10-06 00:00:00	2013-10-16	2013-10-16 00:00:00	2013-10-16	38000177		0	0	10		0	0	0	32600	0	834102	19133905		
53007	4405	19078461	2011-06-10	2011-06-10 00:00:00	2011-07-01	2011-07-01 00:00:00	2011-07-01	38000177		0	0	21		0	0	0	292837	0	310965	19078461		
53063	4409	19128065	1990-12-01	1990-12-01 00:00:00	1991-11-26	1991-11-26 00:00:00	1991-11-26	38000177		0	0	360		0	0	0	293061	0	749882	19128065		
18328	1517	19078461	2013-02-09	2013-02-09 00:00:00	2013-03-11	2013-03-11 00:00:00	2013-03-11	38000177		0	0	30		0	0	0	101448	0	310965	19078461		
153813	3386	40213306	1991-02-24	1991-02-24 00:00:00	1991-02-24	1991-02-24 00:00:00	1991-02-24	581452		0	0	0		0	0	0	224652	0	43	40213306		
25238	2077	1713671	1997-02-08	1997-02-08 00:00:00	1997-02-22	1997-02-22 00:00:00	1997-02-22	38000177		0	0	14		0	0	0	138368	0	562251	1713671		
90670	1990	40213260	2016-05-27	2016-05-27 00:00:00	2016-05-27	2016-05-27 00:00:00	2016-05-27	581452		0	0	0		0	0	0	132500	0	121	40213260		
54034	4490	1127433	1956-02-09	1956-02-09 00:00:00	1956-03-01	1956-03-01 00:00:00	1956-03-01	38000177		0	0	21		0	0	0	298885	0	313782	1127433		
21412	1760	46233988	1978-06-14	1978-06-14 00:00:00	1978-06-28	1978-06-28 00:00:00	1978-06-28	38000177		0	0	14		0	0	0	117675	0	1652673	46233988		
35888	2955	1127433	1983-05-02	1983-05-02 00:00:00	1983-05-09	1983-05-09 00:00:00	1983-05-09	38000177		0	0	7		0	0	0	197204	0	313782	1127433		
59251	4924	19128022	1993-12-04	1993-12-04 00:00:00	1994-11-29	1994-11-29 00:00:00	1994-11-29	38000177		0	0	360		0	0	0	327252	0	749785	19128022		
30673	2543	1127433	1978-05-22	1978-05-22 00:00:00	1978-06-12	1978-06-12 00:00:00	1978-06-12	38000177		0	0	21		0	0	0	168266	0	313782	1127433		
134818	2959	40213160	1975-12-02	1975-12-02 00:00:00	1975-12-02	1975-12-02 00:00:00	1975-12-02	581452		0	0	0		0	0	0	197468	0	10	40213160		
10317	220	40213160	1982-12-08	1982-12-08 00:00:00	1982-12-08	1982-12-08 00:00:00	1982-12-08	581452		0	0	0		0	0	0	14847	0	10	40213160		
60229	5005	19078461	2004-08-31	2004-08-31 00:00:00	2004-09-14	2004-09-14 00:00:00	2004-09-14	38000177		0	0	14		0	0	0	332909	0	310965	19078461		
3389	280	19126352	2015-02-27	2015-02-27 00:00:00	2019-05-31	2019-05-31 00:00:00	2019-05-31	38000177		0	0	1554		0	0	0	18701	0	705129	19126352		
201451	4423	40213296	2015-11-13	2015-11-13 00:00:00	2015-11-13	2015-11-13 00:00:00	2015-11-13	581452		0	0	0		0	0	0	294084	0	52	40213296		
9513	793	1118084	2010-05-14	2010-05-14 00:00:00	2010-05-14	2010-05-14 00:00:00	\N	38000177		0	0	0		0	0	0	52604	0	00025152531	44923712		
26023	2141	1127433	1961-09-01	1961-09-01 00:00:00	1961-10-08	1961-10-08 00:00:00	1961-10-08	38000177		0	0	37		0	0	0	142598	0	313782	1127433		
9593	800	1124300	1994-07-09	1994-07-09 00:00:00	1994-07-09	1994-07-09 00:00:00	\N	38000177		0	0	0		0	0	0	53141	0	00781178901	45011828		
1158	94	1127433	1958-02-27	1958-02-27 00:00:00	1958-03-13	1958-03-13 00:00:00	1958-03-13	38000177		0	0	14		0	0	0	6352	0	313782	1127433		
20156	1656	43012433	2014-08-08	2014-08-08 00:00:00	2015-08-03	2015-08-03 00:00:00	2015-08-03	38000177		0	0	360		0	0	0	111074	0	1367439	43012433		
11710	973	19059056	1918-11-24	1918-11-24 00:00:00	1918-12-08	1918-12-08 00:00:00	1918-12-08	38000177		0	0	14		0	0	0	64774	0	243670	19059056		
143135	3144	40213306	1986-01-15	1986-01-15 00:00:00	1986-01-15	1986-01-15 00:00:00	1986-01-15	581452		0	0	0		0	0	0	209249	0	43	40213306		
19045	1572	920300	1987-08-01	1987-08-01 00:00:00	1987-08-08	1987-08-08 00:00:00	1987-08-08	38000177		0	0	7		0	0	0	105568	0	311989	920300		
1683	133	1713671	2001-05-08	2001-05-08 00:00:00	2001-05-22	2001-05-22 00:00:00	2001-05-22	38000177		0	0	14		0	0	0	8988	0	562251	1713671		
23347	1924	40163554	2019-06-28	2019-06-28 00:00:00	2019-06-28	2019-06-28 00:00:00	\N	38000177		0	0	0		0	0	0	128060	0	855332	40163554		
80550	1762	40213201	2007-03-01	2007-03-01 00:00:00	2007-03-01	2007-03-01 00:00:00	2007-03-01	581452		0	0	0		0	0	0	117830	0	33	40213201		
27934	2311	40229134	1972-04-22	1972-04-22 00:00:00	1972-05-06	1972-05-06 00:00:00	1972-05-06	38000177		0	0	14		0	0	0	153718	0	1043400	40229134		
33942	2806	1127433	2009-05-25	2009-05-25 00:00:00	2009-07-24	2009-07-24 00:00:00	2009-07-24	38000177		0	0	60		0	0	0	185962	0	313782	1127433		
12366	1039	19059056	1964-09-24	1964-09-24 00:00:00	1964-10-08	1964-10-08 00:00:00	1964-10-08	38000177		0	0	14		0	0	0	68400	0	243670	19059056		
58110	1272	40213306	2002-01-18	2002-01-18 00:00:00	2002-01-18	2002-01-18 00:00:00	2002-01-18	581452		0	0	0		0	0	0	83924	0	43	40213306		
43539	3610	1713671	1950-06-19	1950-06-19 00:00:00	1950-07-03	1950-07-03 00:00:00	1950-07-03	38000177		0	0	14		0	0	0	239810	0	562251	1713671		
47398	3929	1127433	1992-04-01	1992-04-01 00:00:00	1992-04-15	1992-04-15 00:00:00	1992-04-15	38000177		0	0	14		0	0	0	261150	0	313782	1127433		
171363	3767	40213227	2016-03-18	2016-03-18 00:00:00	2016-03-18	2016-03-18 00:00:00	2016-03-18	581452		0	0	0		0	0	0	250347	0	113	40213227		
5286	443	1127433	1980-11-15	1980-11-15 00:00:00	1980-11-29	1980-11-29 00:00:00	1980-11-29	38000177		0	0	14		0	0	0	29475	0	313782	1127433		
54192	4503	1127433	1973-08-16	1973-08-16 00:00:00	1973-08-23	1973-08-23 00:00:00	1973-08-23	38000177		0	0	7		0	0	0	299809	0	313782	1127433		
94009	2063	40213227	1995-02-17	1995-02-17 00:00:00	1995-02-17	1995-02-17 00:00:00	1995-02-17	581452		0	0	0		0	0	0	137242	0	113	40213227		
46465	3849	19059056	1969-01-23	1969-01-23 00:00:00	1969-02-06	1969-02-06 00:00:00	1969-02-06	38000177		0	0	14		0	0	0	255430	0	243670	19059056		
175179	3852	40213198	2017-06-05	2017-06-05 00:00:00	2017-06-05	2017-06-05 00:00:00	2017-06-05	581452		0	0	0		0	0	0	255705	0	133	40213198		
58664	4872	19133905	1971-08-08	1971-08-08 00:00:00	1971-08-19	1971-08-19 00:00:00	1971-08-19	38000177		0	0	11		0	0	0	324028	0	834102	19133905		
11021	918	40229134	1991-11-14	1991-11-14 00:00:00	1991-11-28	1991-11-28 00:00:00	1991-11-28	38000177		0	0	14		0	0	0	61123	0	1043400	40229134		
17048	368	40213160	1972-06-14	1972-06-14 00:00:00	1972-06-14	1972-06-14 00:00:00	1972-06-14	581452		0	0	0		0	0	0	24517	0	10	40213160		
8533	711	19079524	1967-01-29	1967-01-29 00:00:00	1967-01-30	1967-01-30 00:00:00	1967-01-30	38000177		0	0	1		0	0	0	47196	0	313002	19079524		
50530	4199	1713671	1987-08-30	1987-08-30 00:00:00	1987-09-13	1987-09-13 00:00:00	1987-09-13	38000177		0	0	14		0	0	0	278668	0	562251	1713671		
45267	987	40213296	1997-09-14	1997-09-14 00:00:00	1997-09-14	1997-09-14 00:00:00	1997-09-14	581452		0	0	0		0	0	0	65530	0	52	40213296		
54943	4562	1551192	1962-06-22	1962-06-22 00:00:00	1962-06-22	1962-06-22 00:00:00	1962-06-22	38000177		0	0	0		0	0	0	303950	0	312617	1551192		
29540	2444	1127433	2011-01-18	2011-01-18 00:00:00	2011-01-25	2011-01-25 00:00:00	2011-01-25	38000177		0	0	7		0	0	0	162168	0	313782	1127433		
47709	3956	1127433	1932-12-26	1932-12-26 00:00:00	1933-01-09	1933-01-09 00:00:00	1933-01-09	38000177		0	0	14		0	0	0	262975	0	313782	1127433		
208790	4579	40213260	2018-01-05	2018-01-05 00:00:00	2018-01-05	2018-01-05 00:00:00	2018-01-05	581452		0	0	0		0	0	0	305022	0	121	40213260		
49409	4100	40229134	1979-06-13	1979-06-13 00:00:00	1979-06-27	1979-06-27 00:00:00	1979-06-27	38000177		0	0	14		0	0	0	272412	0	1043400	40229134		
59446	4942	1332419	1995-01-05	1995-01-05 00:00:00	1995-01-05	1995-01-05 00:00:00	\N	38000177		0	0	0		0	0	0	328499	0	197361	1332419		
866	70	40229134	2007-12-03	2007-12-03 00:00:00	2007-12-10	2007-12-10 00:00:00	2007-12-10	38000177		0	0	7		0	0	0	4745	0	1043400	40229134		
16395	1358	1127433	1987-03-04	1987-03-04 00:00:00	1987-03-18	1987-03-18 00:00:00	1987-03-18	38000177		0	0	14		0	0	0	90049	0	313782	1127433		
24001	1975	1118084	1957-04-23	1957-04-23 00:00:00	1957-04-23	1957-04-23 00:00:00	\N	38000177		0	0	0		0	0	0	131282	0	00025152531	44923712		
36951	806	40213160	1961-12-10	1961-12-10 00:00:00	1961-12-10	1961-12-10 00:00:00	1961-12-10	581452		0	0	0		0	0	0	53473	0	10	40213160		
27011	2228	1713671	2015-11-16	2015-11-16 00:00:00	2015-11-30	2015-11-30 00:00:00	2015-11-30	38000177		0	0	14		0	0	0	148270	0	562251	1713671		
136354	2993	40213227	2001-08-25	2001-08-25 00:00:00	2001-08-25	2001-08-25 00:00:00	2001-08-25	581452		0	0	0		0	0	0	199791	0	113	40213227		
4480	371	19133873	1980-04-13	1980-04-13 00:00:00	1980-04-23	1980-04-23 00:00:00	1980-04-23	38000177		0	0	10		0	0	0	24693	0	834061	19133873		
44792	3707	1713671	2009-12-20	2009-12-20 00:00:00	2010-01-03	2010-01-03 00:00:00	2010-01-03	38000177		0	0	14		0	0	0	246410	0	562251	1713671		
38392	3175	19059056	1954-11-19	1954-11-19 00:00:00	1954-12-03	1954-12-03 00:00:00	1954-12-03	38000177		0	0	14		0	0	0	211039	0	243670	19059056		
15083	1259	1127433	1960-12-05	1960-12-05 00:00:00	1960-12-19	1960-12-19 00:00:00	1960-12-19	38000177		0	0	14		0	0	0	82962	0	313782	1127433		
179479	3946	40213227	1994-06-14	1994-06-14 00:00:00	1994-06-14	1994-06-14 00:00:00	1994-06-14	581452		0	0	0		0	0	0	262334	0	113	40213227		
3035	246	40169281	2000-09-07	2000-09-07 00:00:00	2000-09-07	2000-09-07 00:00:00	\N	38000177		0	0	0		0	0	0	16541	0	896209	40169281		
5833	487	1713671	1989-05-08	1989-05-08 00:00:00	1989-05-15	1989-05-15 00:00:00	1989-05-15	38000177		0	0	7		0	0	0	32548	0	562251	1713671		
53008	4405	1713671	1973-09-03	1973-09-03 00:00:00	1973-09-10	1973-09-10 00:00:00	1973-09-10	38000177		0	0	7		0	0	0	292840	0	562251	1713671		
53064	4409	1118084	2005-06-28	2005-06-28 00:00:00	2005-06-28	2005-06-28 00:00:00	\N	38000177		0	0	0		0	0	0	293135	0	00025152531	44923712		
18329	1517	19133905	1996-04-27	1996-04-27 00:00:00	1996-05-05	1996-05-05 00:00:00	1996-05-05	38000177		0	0	8		0	0	0	101457	0	834102	19133905		
153815	3386	40213296	2010-12-12	2010-12-12 00:00:00	2010-12-12	2010-12-12 00:00:00	2010-12-12	581452		0	0	0		0	0	0	224648	0	52	40213296		
25239	2077	1713671	1939-10-25	1939-10-25 00:00:00	1939-11-08	1939-11-08 00:00:00	1939-11-08	38000177		0	0	14		0	0	0	138282	0	562251	1713671		
90673	1990	40213227	1998-03-20	1998-03-20 00:00:00	1998-03-20	1998-03-20 00:00:00	1998-03-20	581452		0	0	0		0	0	0	132552	0	113	40213227		
54035	4490	19059056	1926-04-21	1926-04-21 00:00:00	1926-05-05	1926-05-05 00:00:00	1926-05-05	38000177		0	0	14		0	0	0	298919	0	243670	19059056		
21413	1760	19019979	1978-06-14	1978-06-14 00:00:00	1978-06-28	1978-06-28 00:00:00	1978-06-28	38000177		0	0	14		0	0	0	117675	0	198405	19019979		
35889	2955	1127433	1985-12-26	1985-12-26 00:00:00	1986-01-09	1986-01-09 00:00:00	1986-01-09	38000177		0	0	14		0	0	0	197237	0	313782	1127433		
59252	4924	19133873	1985-05-24	1985-05-24 00:00:00	1985-06-01	1985-06-01 00:00:00	1985-06-01	38000177		0	0	8		0	0	0	327279	0	834061	19133873		
30674	2543	1118084	2001-03-28	2001-03-28 00:00:00	2001-03-28	2001-03-28 00:00:00	\N	38000177		0	0	0		0	0	0	168273	0	00025152531	44923712		
4814	403	1713671	2008-12-14	2008-12-14 00:00:00	2008-12-28	2008-12-28 00:00:00	2008-12-28	38000177		0	0	14		0	0	0	26515	0	562251	1713671		
51437	4275	1127433	2005-02-16	2005-02-16 00:00:00	2005-03-02	2005-03-02 00:00:00	2005-03-02	38000177		0	0	14		0	0	0	283679	0	313782	1127433		
60232	5007	40229134	1999-08-02	1999-08-02 00:00:00	1999-08-16	1999-08-16 00:00:00	1999-08-16	38000177		0	0	14		0	0	0	333023	0	1043400	40229134		
3390	280	19075601	2015-02-27	2015-02-27 00:00:00	2019-05-31	2019-05-31 00:00:00	2019-05-31	38000177		0	0	1554		0	0	0	18701	0	309362	19075601		
201453	4423	40213160	1976-01-30	1976-01-30 00:00:00	1976-01-30	1976-01-30 00:00:00	1976-01-30	581452		0	0	0		0	0	0	294101	0	10	40213160		
9514	793	1127433	1993-08-10	1993-08-10 00:00:00	1993-08-17	1993-08-17 00:00:00	1993-08-17	38000177		0	0	7		0	0	0	52603	0	313782	1127433		
26024	2141	1127433	1959-03-12	1959-03-12 00:00:00	1959-03-26	1959-03-26 00:00:00	1959-03-26	38000177		0	0	14		0	0	0	142639	0	313782	1127433		
9594	800	1127433	1970-06-11	1970-06-11 00:00:00	1970-06-25	1970-06-25 00:00:00	1970-06-25	38000177		0	0	14		0	0	0	53112	0	313782	1127433		
1159	94	19078461	1978-01-30	1978-01-30 00:00:00	1978-02-13	1978-02-13 00:00:00	1978-02-13	38000177		0	0	14		0	0	0	6348	0	310965	19078461		
20157	1656	19128022	1996-10-27	1996-10-27 00:00:00	1997-10-22	1997-10-22 00:00:00	1997-10-22	38000177		0	0	360		0	0	0	111154	0	749785	19128022		
11711	973	1713671	1982-05-07	1982-05-07 00:00:00	1982-05-21	1982-05-21 00:00:00	1982-05-21	38000177		0	0	14		0	0	0	64815	0	562251	1713671		
143143	3145	40213227	2001-10-07	2001-10-07 00:00:00	2001-10-07	2001-10-07 00:00:00	2001-10-07	581452		0	0	0		0	0	0	209259	0	113	40213227		
19046	1572	19126352	1968-03-01	1968-03-01 00:00:00	1968-03-01	1968-03-01 00:00:00	\N	38000177		0	0	0		0	0	0	105586	0	705129	19126352		
1684	133	19075001	1988-11-03	1988-11-03 00:00:00	1988-11-17	1988-11-17 00:00:00	1988-11-17	38000177		0	0	14		0	0	0	8994	0	309097	19075001		
23348	1924	1713671	2000-06-10	2000-06-10 00:00:00	2000-07-01	2000-07-01 00:00:00	2000-07-01	38000177		0	0	21		0	0	0	128075	0	562251	1713671		
91846	2016	40213314	1982-02-16	1982-02-16 00:00:00	1982-02-16	1982-02-16 00:00:00	1982-02-16	581452		0	0	0		0	0	0	134099	0	49	40213314		
27935	2311	1713671	1965-10-21	1965-10-21 00:00:00	1965-11-11	1965-11-11 00:00:00	1965-11-11	38000177		0	0	21		0	0	0	153753	0	562251	1713671		
33943	2806	1127078	1964-07-08	1964-07-08 00:00:00	1964-08-12	1964-08-12 00:00:00	1964-08-12	38000177		0	0	35		0	0	0	185959	0	282464	1127078		
12367	1039	19129655	1964-09-24	1964-09-24 00:00:00	1964-10-08	1964-10-08 00:00:00	1964-10-08	38000177		0	0	14		0	0	0	68400	0	789980	19129655		
58113	1272	40213160	1980-05-23	1980-05-23 00:00:00	1980-05-23	1980-05-23 00:00:00	1980-05-23	581452		0	0	0		0	0	0	83944	0	10	40213160		
43540	3610	920334	1966-06-15	1966-06-15 00:00:00	1966-06-22	1966-06-22 00:00:00	1966-06-22	38000177		0	0	7		0	0	0	239863	0	311995	920334		
47399	3929	19059056	1954-01-07	1954-01-07 00:00:00	1954-01-21	1954-01-21 00:00:00	1954-01-21	38000177		0	0	14		0	0	0	261200	0	243670	19059056		
171370	3767	40213160	1985-10-25	1985-10-25 00:00:00	1985-10-25	1985-10-25 00:00:00	1985-10-25	581452		0	0	0		0	0	0	250370	0	10	40213160		
5287	443	46233988	1973-02-07	1973-02-07 00:00:00	1973-02-21	1973-02-21 00:00:00	1973-02-21	38000177		0	0	14		0	0	0	29442	0	1652673	46233988		
54193	4503	40229134	1998-12-24	1998-12-24 00:00:00	1998-12-31	1998-12-31 00:00:00	1998-12-31	38000177		0	0	7		0	0	0	299882	0	1043400	40229134		
24997	545	40213227	2003-08-09	2003-08-09 00:00:00	2003-08-09	2003-08-09 00:00:00	2003-08-09	581452		0	0	0		0	0	0	36096	0	113	40213227		
46466	3849	46233988	1969-01-23	1969-01-23 00:00:00	1969-02-06	1969-02-06 00:00:00	1969-02-06	38000177		0	0	14		0	0	0	255430	0	1652673	46233988		
175182	3852	40213201	2018-06-11	2018-06-11 00:00:00	2018-06-11	2018-06-11 00:00:00	2018-06-11	581452		0	0	0		0	0	0	255639	0	33	40213201		
58665	4872	19059056	1918-07-14	1918-07-14 00:00:00	1918-07-28	1918-07-28 00:00:00	1918-07-28	38000177		0	0	14		0	0	0	324085	0	243670	19059056		
11022	918	40229134	1941-10-11	1941-10-11 00:00:00	1941-10-25	1941-10-25 00:00:00	1941-10-25	38000177		0	0	14		0	0	0	61187	0	1043400	40229134		
58741	4878	1127078	1964-01-30	1964-01-30 00:00:00	1964-02-20	1964-02-20 00:00:00	1964-02-20	38000177		0	0	21		0	0	0	324460	0	282464	1127078		
8534	711	19023423	1967-01-29	1967-01-29 00:00:00	1967-01-29	1967-01-29 00:00:00	1967-01-29	38000177		0	0	0		0	0	0	47196	0	200252	19023423		
50531	4199	1127433	1976-01-04	1976-01-04 00:00:00	1976-01-18	1976-01-18 00:00:00	1976-01-18	38000177		0	0	14		0	0	0	278624	0	313782	1127433		
133573	2933	40213227	2015-11-02	2015-11-02 00:00:00	2015-11-02	2015-11-02 00:00:00	2015-11-02	581452		0	0	0		0	0	0	195622	0	113	40213227		
54944	4562	1118084	1999-10-06	1999-10-06 00:00:00	1999-10-06	1999-10-06 00:00:00	\N	38000177		0	0	0		0	0	0	303991	0	00025152531	44923712		
29542	2444	19059056	1963-02-26	1963-02-26 00:00:00	1963-05-04	1963-05-04 00:00:00	1963-05-04	38000177		0	0	67		0	0	0	162153	0	243670	19059056		
47710	3956	19059056	1939-05-01	1939-05-01 00:00:00	1939-06-05	1939-06-05 00:00:00	1939-06-05	38000177		0	0	35		0	0	0	262904	0	243670	19059056		
208791	4579	40213160	1967-12-22	1967-12-22 00:00:00	1967-12-22	1967-12-22 00:00:00	1967-12-22	581452		0	0	0		0	0	0	305065	0	10	40213160		
49410	4100	1118084	1979-12-21	1979-12-21 00:00:00	1979-12-21	1979-12-21 00:00:00	\N	38000177		0	0	0		0	0	0	272412	0	00025152531	44923712		
59447	4942	19126352	1982-10-14	1982-10-14 00:00:00	1982-10-14	1982-10-14 00:00:00	\N	38000177		0	0	0		0	0	0	328496	0	705129	19126352		
867	70	19059056	1982-08-17	1982-08-17 00:00:00	1982-08-31	1982-08-31 00:00:00	1982-08-31	38000177		0	0	14		0	0	0	4767	0	243670	19059056		
16396	1358	40229134	1969-04-01	1969-04-01 00:00:00	1969-04-15	1969-04-15 00:00:00	1969-04-15	38000177		0	0	14		0	0	0	90045	0	1043400	40229134		
24002	1975	19059056	1927-04-16	1927-04-16 00:00:00	1927-04-30	1927-04-30 00:00:00	1927-04-30	38000177		0	0	14		0	0	0	131302	0	243670	19059056		
36954	806	40213227	2018-03-04	2018-03-04 00:00:00	2018-03-04	2018-03-04 00:00:00	2018-03-04	581452		0	0	0		0	0	0	53487	0	113	40213227		
27012	2228	1115171	2016-01-17	2016-01-17 00:00:00	2016-02-07	2016-02-07 00:00:00	2016-02-07	38000177		0	0	21		0	0	0	148279	0	849574	1115171		
136356	2993	40213160	1971-02-20	1971-02-20 00:00:00	1971-02-20	1971-02-20 00:00:00	1971-02-20	581452		0	0	0		0	0	0	199805	0	10	40213160		
4481	372	1115171	2017-11-27	2017-11-27 00:00:00	2017-12-27	2017-12-27 00:00:00	2017-12-27	38000177		0	0	30		0	0	0	24790	0	849574	1115171		
44793	3707	19059056	1973-11-19	1973-11-19 00:00:00	1973-12-03	1973-12-03 00:00:00	1973-12-03	38000177		0	0	14		0	0	0	246439	0	243670	19059056		
38393	3175	19133905	1987-02-12	1987-02-12 00:00:00	1987-02-22	1987-02-22 00:00:00	1987-02-22	38000177		0	0	10		0	0	0	211002	0	834102	19133905		
15084	1259	1127433	2016-07-23	2016-07-23 00:00:00	2016-07-30	2016-07-30 00:00:00	2016-07-30	38000177		0	0	7		0	0	0	82944	0	313782	1127433		
179482	3946	40213296	2000-03-28	2000-03-28 00:00:00	2000-03-28	2000-03-28 00:00:00	2000-03-28	581452		0	0	0		0	0	0	262325	0	52	40213296		
3036	246	19129655	1974-03-12	1974-03-12 00:00:00	1974-04-09	1974-04-09 00:00:00	1974-04-09	38000177		0	0	28		0	0	0	16586	0	789980	19129655		
5834	487	1127433	1995-11-29	1995-11-29 00:00:00	1995-12-13	1995-12-13 00:00:00	1995-12-13	38000177		0	0	14		0	0	0	32532	0	313782	1127433		
53009	4405	40229134	1968-10-25	1968-10-25 00:00:00	1968-11-01	1968-11-01 00:00:00	1968-11-01	38000177		0	0	7		0	0	0	292839	0	1043400	40229134		
53065	4409	19128065	1986-12-15	1986-12-15 00:00:00	1987-12-10	1987-12-10 00:00:00	1987-12-10	38000177		0	0	360		0	0	0	293073	0	749882	19128065		
18330	1517	1118084	1981-04-09	1981-04-09 00:00:00	1981-04-09	1981-04-09 00:00:00	\N	38000177		0	0	0		0	0	0	101440	0	00025152531	44923712		
153817	3386	40213227	2010-12-12	2010-12-12 00:00:00	2010-12-12	2010-12-12 00:00:00	2010-12-12	581452		0	0	0		0	0	0	224648	0	113	40213227		
25240	2077	40165015	1988-05-06	1988-05-06 00:00:00	1988-05-06	1988-05-06 00:00:00	\N	38000177		0	0	0		0	0	0	138270	0	861467	40165015		
90677	1990	40213160	1966-11-04	1966-11-04 00:00:00	1966-11-04	1966-11-04 00:00:00	1966-11-04	581452		0	0	0		0	0	0	132492	0	10	40213160		
54036	4490	1127433	1980-10-03	1980-10-03 00:00:00	1980-10-10	1980-10-10 00:00:00	1980-10-10	38000177		0	0	7		0	0	0	298890	0	313782	1127433		
21414	1760	19078461	2006-01-23	2006-01-23 00:00:00	2006-02-22	2006-02-22 00:00:00	2006-02-22	38000177		0	0	30		0	0	0	117690	0	310965	19078461		
35890	2955	1127433	1980-04-21	1980-04-21 00:00:00	1980-04-28	1980-04-28 00:00:00	1980-04-28	38000177		0	0	7		0	0	0	197241	0	313782	1127433		
59253	4924	1127433	2002-06-07	2002-06-07 00:00:00	2002-06-14	2002-06-14 00:00:00	2002-06-14	38000177		0	0	7		0	0	0	327191	0	313782	1127433		
30675	2543	1713671	1998-01-13	1998-01-13 00:00:00	1998-01-20	1998-01-20 00:00:00	1998-01-20	38000177		0	0	7		0	0	0	168222	0	562251	1713671		
15273	1276	19059056	1961-10-13	1961-10-13 00:00:00	1961-10-27	1961-10-27 00:00:00	1961-10-27	38000177		0	0	14		0	0	0	84268	0	243670	19059056		
51438	4275	40231925	1992-05-17	1992-05-17 00:00:00	1992-05-17	1992-05-17 00:00:00	\N	38000177		0	0	0		0	0	0	283708	0	1049221	40231925		
60233	5007	19115351	2002-08-25	2002-08-25 00:00:00	2002-12-22	2002-12-22 00:00:00	2002-12-22	38000177		0	0	119		0	0	0	333032	0	563026	19115351		
3391	280	1332419	2015-02-27	2015-02-27 00:00:00	2015-02-27	2015-02-27 00:00:00	\N	38000177		0	0	0		0	0	0	18701	0	197361	1332419		
201455	4423	40213314	1977-01-28	1977-01-28 00:00:00	1977-01-28	1977-01-28 00:00:00	1977-01-28	581452		0	0	0		0	0	0	294096	0	49	40213314		
9515	793	1127433	2017-11-18	2017-11-18 00:00:00	2017-11-25	2017-11-25 00:00:00	2017-11-25	38000177		0	0	7		0	0	0	52618	0	313782	1127433		
26025	2141	1713671	1950-06-23	1950-06-23 00:00:00	1950-07-14	1950-07-14 00:00:00	1950-07-14	38000177		0	0	21		0	0	0	142637	0	562251	1713671		
9595	800	19129655	1970-06-11	1970-06-11 00:00:00	1970-06-25	1970-06-25 00:00:00	1970-06-25	38000177		0	0	14		0	0	0	53112	0	789980	19129655		
1160	94	46233710	1978-01-30	1978-01-30 00:00:00	1978-02-13	1978-02-13 00:00:00	1978-02-13	38000177		0	0	14		0	0	0	6348	0	1650142	46233710		
20158	1657	19059056	1947-09-09	1947-09-09 00:00:00	1947-09-23	1947-09-23 00:00:00	1947-09-23	38000177		0	0	14		0	0	0	111182	0	243670	19059056		
11712	973	40229134	1990-04-27	1990-04-27 00:00:00	1990-05-11	1990-05-11 00:00:00	1990-05-11	38000177		0	0	14		0	0	0	64817	0	1043400	40229134		
143148	3145	40213227	1992-09-27	1992-09-27 00:00:00	1992-09-27	1992-09-27 00:00:00	1992-09-27	581452		0	0	0		0	0	0	209285	0	113	40213227		
19047	1572	1713671	1974-11-19	1974-11-19 00:00:00	1974-12-10	1974-12-10 00:00:00	1974-12-10	38000177		0	0	21		0	0	0	105557	0	562251	1713671		
1685	133	19019979	1988-11-03	1988-11-03 00:00:00	1988-11-17	1988-11-17 00:00:00	1988-11-17	38000177		0	0	14		0	0	0	8994	0	198405	19019979		
23349	1924	1118084	2017-03-04	2017-03-04 00:00:00	2017-03-04	2017-03-04 00:00:00	\N	38000177		0	0	0		0	0	0	128076	0	00025152531	44923712		
91849	2016	40213160	1981-08-18	1981-08-18 00:00:00	1981-08-18	1981-08-18 00:00:00	1981-08-18	581452		0	0	0		0	0	0	134124	0	10	40213160		
27936	2311	1127433	1960-10-28	1960-10-28 00:00:00	1960-11-04	1960-11-04 00:00:00	1960-11-04	38000177		0	0	7		0	0	0	153752	0	313782	1127433		
33944	2806	19059056	1983-03-06	1983-03-06 00:00:00	1983-05-12	1983-05-12 00:00:00	1983-05-12	38000177		0	0	67		0	0	0	185961	0	243670	19059056		
12368	1039	1713671	1980-02-01	1980-02-01 00:00:00	1980-02-08	1980-02-08 00:00:00	1980-02-08	38000177		0	0	7		0	0	0	68396	0	562251	1713671		
58119	1272	40213314	1980-11-21	1980-11-21 00:00:00	1980-11-21	1980-11-21 00:00:00	1980-11-21	581452		0	0	0		0	0	0	83915	0	49	40213314		
43541	3610	1127433	2001-01-01	2001-01-01 00:00:00	2001-01-08	2001-01-08 00:00:00	2001-01-08	38000177		0	0	7		0	0	0	239843	0	313782	1127433		
47400	3929	40169281	1990-04-09	1990-04-09 00:00:00	1990-04-09	1990-04-09 00:00:00	\N	38000177		0	0	0		0	0	0	261209	0	896209	40169281		
171373	3767	40213227	2007-04-27	2007-04-27 00:00:00	2007-04-27	2007-04-27 00:00:00	2007-04-27	581452		0	0	0		0	0	0	250344	0	113	40213227		
5288	443	1127078	1973-02-07	1973-02-07 00:00:00	1973-02-21	1973-02-21 00:00:00	1973-02-21	38000177		0	0	14		0	0	0	29442	0	282464	1127078		
54194	4503	40229134	1977-08-20	1977-08-20 00:00:00	1977-08-27	1977-08-27 00:00:00	1977-08-27	38000177		0	0	7		0	0	0	299810	0	1043400	40229134		
25001	546	40213227	2005-01-16	2005-01-16 00:00:00	2005-01-16	2005-01-16 00:00:00	2005-01-16	581452		0	0	0		0	0	0	36238	0	113	40213227		
46467	3849	1115171	2016-11-06	2016-11-06 00:00:00	2016-12-11	2016-12-11 00:00:00	2016-12-11	38000177		0	0	35		0	0	0	255450	0	849574	1115171		
175184	3852	40213160	1956-09-17	1956-09-17 00:00:00	1956-09-17	1956-09-17 00:00:00	1956-09-17	581452		0	0	0		0	0	0	255624	0	10	40213160		
58666	4872	1115171	2011-04-27	2011-04-27 00:00:00	2011-05-18	2011-05-18 00:00:00	2011-05-18	38000177		0	0	21		0	0	0	324093	0	849574	1115171		
11023	918	1539411	1991-01-11	1991-01-11 00:00:00	1991-01-11	1991-01-11 00:00:00	\N	38000177		0	0	0		0	0	0	61167	0	312961	1539411		
58742	4878	1118084	1999-06-15	1999-06-15 00:00:00	1999-06-15	1999-06-15 00:00:00	\N	38000177		0	0	0		0	0	0	324374	0	00025152531	44923712		
8535	711	1367571	1967-01-29	1967-01-29 00:00:00	1967-01-29	1967-01-29 00:00:00	1967-01-29	38000177		0	0	0		0	0	0	47196	0	314659	19080464		
50532	4199	1127433	1987-12-15	1987-12-15 00:00:00	1987-12-29	1987-12-29 00:00:00	1987-12-29	38000177		0	0	14		0	0	0	278615	0	313782	1127433		
133578	2933	40213296	1997-08-11	1997-08-11 00:00:00	1997-08-11	1997-08-11 00:00:00	1997-08-11	581452		0	0	0		0	0	0	195610	0	52	40213296		
54945	4562	19059056	1966-07-01	1966-07-01 00:00:00	1966-07-15	1966-07-15 00:00:00	1966-07-15	38000177		0	0	14		0	0	0	303951	0	243670	19059056		
29543	2444	1127433	1985-02-02	1985-02-02 00:00:00	1985-02-09	1985-02-09 00:00:00	1985-02-09	38000177		0	0	7		0	0	0	162160	0	313782	1127433		
47711	3956	19078461	1983-05-20	1983-05-20 00:00:00	1983-06-03	1983-06-03 00:00:00	1983-06-03	38000177		0	0	14		0	0	0	262907	0	310965	19078461		
208796	4579	40213160	1972-01-21	1972-01-21 00:00:00	1972-01-21	1972-01-21 00:00:00	1972-01-21	581452		0	0	0		0	0	0	305069	0	10	40213160		
49411	4100	19075601	2008-08-27	2008-08-27 00:00:00	2008-08-27	2008-08-27 00:00:00	2008-08-27	38000177		0	0	0		0	0	0	272433	0	309362	19075601		
59448	4942	1127433	1981-12-08	1981-12-08 00:00:00	1981-12-29	1981-12-29 00:00:00	1981-12-29	38000177		0	0	21		0	0	0	328464	0	313782	1127433		
868	70	19074841	1982-08-17	1982-08-17 00:00:00	1982-08-31	1982-08-31 00:00:00	1982-08-31	38000177		0	0	14		0	0	0	4767	0	309043	19074841		
16397	1358	1127433	1964-05-27	1964-05-27 00:00:00	1964-06-10	1964-06-10 00:00:00	1964-06-10	38000177		0	0	14		0	0	0	90043	0	313782	1127433		
24003	1975	1713671	1948-02-19	1948-02-19 00:00:00	1948-03-04	1948-03-04 00:00:00	1948-03-04	38000177		0	0	14		0	0	0	131321	0	562251	1713671		
36962	806	40213160	1957-04-07	1957-04-07 00:00:00	1957-04-07	1957-04-07 00:00:00	1957-04-07	581452		0	0	0		0	0	0	53517	0	10	40213160		
27013	2228	19133873	1950-12-01	1950-12-01 00:00:00	1950-12-09	1950-12-09 00:00:00	1950-12-09	38000177		0	0	8		0	0	0	148280	0	834061	19133873		
136359	2993	40213160	1970-11-21	1970-11-21 00:00:00	1970-11-21	1970-11-21 00:00:00	1970-11-21	581452		0	0	0		0	0	0	199788	0	10	40213160		
4482	372	19008572	1985-05-15	1985-05-15 00:00:00	1985-05-15	1985-05-15 00:00:00	\N	38000177		0	0	0		0	0	0	24746	0	106258	19008572		
44794	3707	46233988	1973-11-19	1973-11-19 00:00:00	1973-12-03	1973-12-03 00:00:00	1973-12-03	38000177		0	0	14		0	0	0	246439	0	1652673	46233988		
38394	3175	1115171	1996-10-23	1996-10-23 00:00:00	1996-11-27	1996-11-27 00:00:00	1996-11-27	38000177		0	0	35		0	0	0	211055	0	849574	1115171		
15085	1259	1118084	1981-10-07	1981-10-07 00:00:00	1981-10-07	1981-10-07 00:00:00	\N	38000177		0	0	0		0	0	0	82976	0	00025152531	44923712		
179484	3946	40213227	2011-09-13	2011-09-13 00:00:00	2011-09-13	2011-09-13 00:00:00	2011-09-13	581452		0	0	0		0	0	0	262349	0	113	40213227		
3037	246	1127433	1974-03-12	1974-03-12 00:00:00	1974-04-09	1974-04-09 00:00:00	1974-04-09	38000177		0	0	28		0	0	0	16586	0	313782	1127433		
5835	487	19128065	1981-05-12	1981-05-12 00:00:00	1982-05-07	1982-05-07 00:00:00	1982-05-07	38000177		0	0	360		0	0	0	32556	0	749882	19128065		
53010	4405	1124300	2006-09-24	2006-09-24 00:00:00	2006-09-24	2006-09-24 00:00:00	\N	38000177		0	0	0		0	0	0	292836	0	00781178901	45011828		
53066	4409	19128022	1989-12-06	1989-12-06 00:00:00	1990-12-01	1990-12-01 00:00:00	1990-12-01	38000177		0	0	360		0	0	0	293060	0	749785	19128022		
18332	1517	19115351	1951-12-03	1951-12-03 00:00:00	1952-07-07	1952-07-07 00:00:00	1952-07-07	38000177		0	0	217		0	0	0	101383	0	563026	19115351		
79297	1736	40213227	2002-07-04	2002-07-04 00:00:00	2002-07-04	2002-07-04 00:00:00	2002-07-04	581452		0	0	0		0	0	0	115954	0	113	40213227		
25241	2077	19133905	1951-07-09	1951-07-09 00:00:00	1951-07-22	1951-07-22 00:00:00	1951-07-22	38000177		0	0	13		0	0	0	138266	0	834102	19133905		
90684	1990	40213227	2008-06-06	2008-06-06 00:00:00	2008-06-06	2008-06-06 00:00:00	2008-06-06	581452		0	0	0		0	0	0	132553	0	113	40213227		
54037	4490	19059056	1932-12-11	1932-12-11 00:00:00	1933-03-11	1933-03-11 00:00:00	1933-03-11	38000177		0	0	90		0	0	0	298883	0	243670	19059056		
31900	2644	19059056	1985-05-28	1985-05-28 00:00:00	1985-06-11	1985-06-11 00:00:00	1985-06-11	38000177		0	0	14		0	0	0	174964	0	243670	19059056		
35891	2955	19059056	1981-12-23	1981-12-23 00:00:00	1982-01-27	1982-01-27 00:00:00	1982-01-27	38000177		0	0	35		0	0	0	197250	0	243670	19059056		
59254	4924	19133905	2000-09-24	2000-09-24 00:00:00	2000-10-04	2000-10-04 00:00:00	2000-10-04	38000177		0	0	10		0	0	0	327200	0	834102	19133905		
13833	298	40213227	2003-04-15	2003-04-15 00:00:00	2003-04-15	2003-04-15 00:00:00	2003-04-15	581452		0	0	0		0	0	0	19869	0	113	40213227		
15274	1276	1127433	1976-09-15	1976-09-15 00:00:00	1976-09-29	1976-09-29 00:00:00	1976-09-29	38000177		0	0	14		0	0	0	84140	0	313782	1127433		
51439	4275	1332419	1994-02-13	1994-02-13 00:00:00	1994-02-13	1994-02-13 00:00:00	\N	38000177		0	0	0		0	0	0	283699	0	197361	1332419		
60234	5007	19115351	2001-08-19	2001-08-19 00:00:00	2001-11-25	2001-11-25 00:00:00	2001-11-25	38000177		0	0	98		0	0	0	333010	0	563026	19115351		
3392	280	1539411	2015-02-27	2015-02-27 00:00:00	2015-02-27	2015-02-27 00:00:00	\N	38000177		0	0	0		0	0	0	18701	0	312961	1539411		
201458	4423	40213160	1975-11-28	1975-11-28 00:00:00	1975-11-28	1975-11-28 00:00:00	1975-11-28	581452		0	0	0		0	0	0	294094	0	10	40213160		
9516	793	1127433	2003-02-27	2003-02-27 00:00:00	2003-03-06	2003-03-06 00:00:00	2003-03-06	38000177		0	0	7		0	0	0	52625	0	313782	1127433		
26026	2141	1118084	1978-06-20	1978-06-20 00:00:00	1978-06-20	1978-06-20 00:00:00	\N	38000177		0	0	0		0	0	0	142590	0	00025152531	44923712		
57247	4753	19059056	1962-03-04	1962-03-04 00:00:00	1962-03-18	1962-03-18 00:00:00	1962-03-18	38000177		0	0	14		0	0	0	316559	0	243670	19059056		
1161	94	1127433	2015-11-30	2015-11-30 00:00:00	2015-12-14	2015-12-14 00:00:00	2015-12-14	38000177		0	0	14		0	0	0	6347	0	313782	1127433		
20160	1657	19059056	1946-06-24	1946-06-24 00:00:00	1946-07-08	1946-07-08 00:00:00	1946-07-08	38000177		0	0	14		0	0	0	111249	0	243670	19059056		
11713	973	1127433	1953-09-02	1953-09-02 00:00:00	1953-09-16	1953-09-16 00:00:00	1953-09-16	38000177		0	0	14		0	0	0	64872	0	313782	1127433		
143149	3145	40213306	1992-09-27	1992-09-27 00:00:00	1992-09-27	1992-09-27 00:00:00	1992-09-27	581452		0	0	0		0	0	0	209285	0	43	40213306		
19048	1572	1118084	1997-12-25	1997-12-25 00:00:00	1997-12-25	1997-12-25 00:00:00	\N	38000177		0	0	0		0	0	0	105559	0	00025152531	44923712		
1686	133	19133905	2002-11-06	2002-11-06 00:00:00	2002-11-13	2002-11-13 00:00:00	2002-11-13	38000177		0	0	7		0	0	0	8969	0	834102	19133905		
23351	1924	19059056	1978-08-26	1978-08-26 00:00:00	1978-11-24	1978-11-24 00:00:00	1978-11-24	38000177		0	0	90		0	0	0	128069	0	243670	19059056		
91851	2016	40213314	1981-05-19	1981-05-19 00:00:00	1981-05-19	1981-05-19 00:00:00	1981-05-19	581452		0	0	0		0	0	0	134098	0	49	40213314		
27947	2314	19133905	2016-03-25	2016-03-25 00:00:00	2016-04-02	2016-04-02 00:00:00	2016-04-02	38000177		0	0	8		0	0	0	153893	0	834102	19133905		
32929	2731	19128065	1974-07-08	1974-07-08 00:00:00	1975-07-03	1975-07-03 00:00:00	1975-07-03	38000177		0	0	360		0	0	0	180748	0	749882	19128065		
12369	1039	1115171	2002-09-01	2002-09-01 00:00:00	2002-09-15	2002-09-15 00:00:00	2002-09-15	38000177		0	0	14		0	0	0	68334	0	849574	1115171		
58125	1272	40213314	1980-02-22	1980-02-22 00:00:00	1980-02-22	1980-02-22 00:00:00	1980-02-22	581452		0	0	0		0	0	0	83954	0	49	40213314		
43542	3610	40236824	1966-06-08	1966-06-08 00:00:00	1966-06-22	1966-06-22 00:00:00	1966-06-22	38000177		0	0	14		0	0	0	239862	0	1094107	40236824		
47401	3929	1127433	1970-06-27	1970-06-27 00:00:00	1970-07-04	1970-07-04 00:00:00	1970-07-04	38000177		0	0	7		0	0	0	261154	0	313782	1127433		
171374	3767	40213180	2007-04-27	2007-04-27 00:00:00	2007-04-27	2007-04-27 00:00:00	2007-04-27	581452		0	0	0		0	0	0	250344	0	114	40213180		
5289	443	1127433	1993-07-27	1993-07-27 00:00:00	1993-08-03	1993-08-03 00:00:00	1993-08-03	38000177		0	0	7		0	0	0	29476	0	313782	1127433		
54195	4503	19059056	1939-01-07	1939-01-07 00:00:00	1939-01-21	1939-01-21 00:00:00	1939-01-21	38000177		0	0	14		0	0	0	299857	0	243670	19059056		
25012	546	40213227	1994-11-20	1994-11-20 00:00:00	1994-11-20	1994-11-20 00:00:00	1994-11-20	581452		0	0	0		0	0	0	36232	0	113	40213227		
46468	3849	19128065	1981-11-03	1981-11-03 00:00:00	1982-10-29	1982-10-29 00:00:00	1982-10-29	38000177		0	0	360		0	0	0	255401	0	749882	19128065		
175189	3852	40213160	1955-09-12	1955-09-12 00:00:00	1955-09-12	1955-09-12 00:00:00	1955-09-12	581452		0	0	0		0	0	0	255747	0	10	40213160		
58667	4872	1127433	1960-09-20	1960-09-20 00:00:00	1960-10-11	1960-10-11 00:00:00	1960-10-11	38000177		0	0	21		0	0	0	323952	0	313782	1127433		
11024	918	19126352	1991-01-11	1991-01-11 00:00:00	1991-01-11	1991-01-11 00:00:00	\N	38000177		0	0	0		0	0	0	61167	0	705129	19126352		
58743	4878	19059056	1969-10-21	1969-10-21 00:00:00	1969-11-11	1969-11-11 00:00:00	1969-11-11	38000177		0	0	21		0	0	0	324429	0	243670	19059056		
8536	711	19078924	1967-01-29	1967-01-29 00:00:00	1967-01-29	1967-01-29 00:00:00	1967-01-29	38000177		0	0	0		0	0	0	47196	0	311700	19078924		
50533	4199	1713671	2016-03-31	2016-03-31 00:00:00	2016-06-09	2016-06-09 00:00:00	2016-06-09	38000177		0	0	70		0	0	0	278619	0	562251	1713671		
133579	2933	40213260	2007-09-17	2007-09-17 00:00:00	2007-09-17	2007-09-17 00:00:00	2007-09-17	581452		0	0	0		0	0	0	195612	0	121	40213260		
54946	4562	19008572	1966-09-12	1966-09-12 00:00:00	1966-10-03	1966-10-03 00:00:00	1966-10-03	38000177		0	0	21		0	0	0	304016	0	106258	19008572		
29544	2444	1115171	2007-12-23	2007-12-23 00:00:00	2008-01-20	2008-01-20 00:00:00	2008-01-20	38000177		0	0	28		0	0	0	162156	0	849574	1115171		
47712	3956	1127433	2012-10-02	2012-10-02 00:00:00	2012-10-09	2012-10-09 00:00:00	2012-10-09	38000177		0	0	7		0	0	0	262968	0	313782	1127433		
31988	697	40213260	2015-10-21	2015-10-21 00:00:00	2015-10-21	2015-10-21 00:00:00	2015-10-21	581452		0	0	0		0	0	0	\N	0	121	40213260		
49412	4100	40220960	2008-08-27	2008-08-27 00:00:00	2008-08-27	2008-08-27 00:00:00	2008-08-27	38000177		0	0	0		0	0	0	272433	0	1804799	40220960		
59449	4942	19075601	1997-01-09	1997-01-09 00:00:00	2006-08-03	2006-08-03 00:00:00	2006-08-03	38000177		0	0	3493		0	0	0	328532	0	309362	19075601		
869	70	1127433	1981-06-02	1981-06-02 00:00:00	1981-06-16	1981-06-16 00:00:00	1981-06-16	38000177		0	0	14		0	0	0	4725	0	313782	1127433		
16398	1358	19133873	1970-07-18	1970-07-18 00:00:00	1970-07-25	1970-07-25 00:00:00	1970-07-25	38000177		0	0	7		0	0	0	90046	0	834061	19133873		
24004	1975	19133905	1961-09-21	1961-09-21 00:00:00	1961-09-30	1961-09-30 00:00:00	1961-09-30	38000177		0	0	9		0	0	0	131298	0	834102	19133905		
36964	806	40213160	1957-09-08	1957-09-08 00:00:00	1957-09-08	1957-09-08 00:00:00	1957-09-08	581452		0	0	0		0	0	0	53518	0	10	40213160		
27014	2228	40236824	2007-02-27	2007-02-27 00:00:00	2007-03-06	2007-03-06 00:00:00	2007-03-06	38000177		0	0	7		0	0	0	148250	0	1094107	40236824		
136361	2993	40213227	2012-06-23	2012-06-23 00:00:00	2012-06-23	2012-06-23 00:00:00	2012-06-23	581452		0	0	0		0	0	0	199792	0	113	40213227		
14941	1249	19133873	1971-12-09	1971-12-09 00:00:00	1971-12-21	1971-12-21 00:00:00	1971-12-21	38000177		0	0	12		0	0	0	82296	0	834061	19133873		
44795	3707	1127078	1969-09-28	1969-09-28 00:00:00	1969-10-12	1969-10-12 00:00:00	1969-10-12	38000177		0	0	14		0	0	0	246447	0	282464	1127078		
38396	3175	19006318	1959-08-09	1959-08-09 00:00:00	1959-08-23	1959-08-23 00:00:00	1959-08-23	38000177		0	0	14		0	0	0	211031	0	105078	19006318		
15086	1259	40229134	2008-03-15	2008-03-15 00:00:00	2008-03-29	2008-03-29 00:00:00	2008-03-29	38000177		0	0	14		0	0	0	83005	0	1043400	40229134		
179485	3946	40213260	2011-09-13	2011-09-13 00:00:00	2011-09-13	2011-09-13 00:00:00	2011-09-13	581452		0	0	0		0	0	0	262349	0	121	40213260		
3038	246	40231925	1974-03-12	1974-03-12 00:00:00	1974-03-12	1974-03-12 00:00:00	\N	38000177		0	0	0		0	0	0	16586	0	1049221	40231925		
5836	487	40229134	2007-05-27	2007-05-27 00:00:00	2007-06-03	2007-06-03 00:00:00	2007-06-03	38000177		0	0	7		0	0	0	32543	0	1043400	40229134		
53011	4405	19059056	1964-11-13	1964-11-13 00:00:00	1964-11-27	1964-11-27 00:00:00	1964-11-27	38000177		0	0	14		0	0	0	292791	0	243670	19059056		
53067	4409	19128065	1983-01-05	1983-01-05 00:00:00	1983-12-31	1983-12-31 00:00:00	1983-12-31	38000177		0	0	360		0	0	0	293071	0	749882	19128065		
18333	1517	19078461	1998-04-29	1998-04-29 00:00:00	1998-05-29	1998-05-29 00:00:00	1998-05-29	38000177		0	0	30		0	0	0	101447	0	310965	19078461		
16185	349	40213227	2009-03-07	2009-03-07 00:00:00	2009-03-07	2009-03-07 00:00:00	2009-03-07	581452		0	0	0		0	0	0	23214	0	113	40213227		
25242	2077	1127433	1952-02-26	1952-02-26 00:00:00	1952-03-11	1952-03-11 00:00:00	1952-03-11	38000177		0	0	14		0	0	0	138267	0	313782	1127433		
90686	1990	40213296	2008-06-06	2008-06-06 00:00:00	2008-06-06	2008-06-06 00:00:00	2008-06-06	581452		0	0	0		0	0	0	132553	0	52	40213296		
54038	4490	19059056	1936-01-25	1936-01-25 00:00:00	1936-02-24	1936-02-24 00:00:00	1936-02-24	38000177		0	0	30		0	0	0	298884	0	243670	19059056		
31901	2644	19073183	1985-05-28	1985-05-28 00:00:00	1985-06-11	1985-06-11 00:00:00	1985-06-11	38000177		0	0	14		0	0	0	174964	0	308182	19073183		
35892	2955	1127433	2015-05-19	2015-05-19 00:00:00	2015-06-02	2015-06-02 00:00:00	2015-06-02	38000177		0	0	14		0	0	0	197226	0	313782	1127433		
59255	4924	40229134	2011-05-29	2011-05-29 00:00:00	2011-06-05	2011-06-05 00:00:00	2011-06-05	38000177		0	0	7		0	0	0	327177	0	1043400	40229134		
13834	298	40213160	1955-08-09	1955-08-09 00:00:00	1955-08-09	1955-08-09 00:00:00	1955-08-09	581452		0	0	0		0	0	0	19878	0	10	40213160		
15275	1276	1115171	2009-07-17	2009-07-17 00:00:00	2009-09-15	2009-09-15 00:00:00	2009-09-15	38000177		0	0	60		0	0	0	84134	0	849574	1115171		
51440	4275	1539411	1994-02-13	1994-02-13 00:00:00	1994-02-13	1994-02-13 00:00:00	\N	38000177		0	0	0		0	0	0	283699	0	312961	1539411		
60235	5007	19115351	1998-05-03	1998-05-03 00:00:00	1998-09-13	1998-09-13 00:00:00	1998-09-13	38000177		0	0	133		0	0	0	333031	0	563026	19115351		
3393	280	40229134	1947-08-13	1947-08-13 00:00:00	1947-08-27	1947-08-27 00:00:00	1947-08-27	38000177		0	0	14		0	0	0	18710	0	1043400	40229134		
201460	4423	40213306	1998-10-02	1998-10-02 00:00:00	1998-10-02	1998-10-02 00:00:00	1998-10-02	581452		0	0	0		0	0	0	294073	0	43	40213306		
9517	793	1127433	1988-01-30	1988-01-30 00:00:00	1988-02-13	1988-02-13 00:00:00	1988-02-13	38000177		0	0	14		0	0	0	52624	0	313782	1127433		
26027	2141	19008572	1970-07-14	1970-07-14 00:00:00	1970-07-14	1970-07-14 00:00:00	\N	38000177		0	0	0		0	0	0	142640	0	106258	19008572		
57248	4753	19129655	1962-03-04	1962-03-04 00:00:00	1962-03-18	1962-03-18 00:00:00	1962-03-18	38000177		0	0	14		0	0	0	316559	0	789980	19129655		
1162	94	1127433	1972-04-27	1972-04-27 00:00:00	1972-05-11	1972-05-11 00:00:00	1972-05-11	38000177		0	0	14		0	0	0	6354	0	313782	1127433		
20161	1657	19006318	1946-06-24	1946-06-24 00:00:00	1946-07-08	1946-07-08 00:00:00	1946-07-08	38000177		0	0	14		0	0	0	111249	0	105078	19006318		
11714	973	1118084	1953-12-25	1953-12-25 00:00:00	1953-12-25	1953-12-25 00:00:00	\N	38000177		0	0	0		0	0	0	64873	0	00025152531	44923712		
143150	3145	40213160	1971-02-07	1971-02-07 00:00:00	1971-02-07	1971-02-07 00:00:00	1971-02-07	581452		0	0	0		0	0	0	209277	0	10	40213160		
19049	1572	1332419	1994-06-03	1994-06-03 00:00:00	1994-06-03	1994-06-03 00:00:00	\N	38000177		0	0	0		0	0	0	105591	0	197361	1332419		
1692	135	19128022	1990-05-16	1990-05-16 00:00:00	1991-05-11	1991-05-11 00:00:00	1991-05-11	38000177		0	0	360		0	0	0	9041	0	749785	19128022		
23352	1925	1713671	1953-07-06	1953-07-06 00:00:00	1953-07-27	1953-07-27 00:00:00	1953-07-27	38000177		0	0	21		0	0	0	128117	0	562251	1713671		
91852	2016	40213160	1981-05-19	1981-05-19 00:00:00	1981-05-19	1981-05-19 00:00:00	1981-05-19	581452		0	0	0		0	0	0	134098	0	10	40213160		
27948	2314	1127078	1961-01-15	1961-01-15 00:00:00	1961-02-21	1961-02-21 00:00:00	1961-02-21	38000177		0	0	37		0	0	0	153863	0	282464	1127078		
32930	2731	1127433	1973-05-25	1973-05-25 00:00:00	1973-06-01	1973-06-01 00:00:00	1973-06-01	38000177		0	0	7		0	0	0	180740	0	313782	1127433		
54951	4563	1127433	1980-04-17	1980-04-17 00:00:00	1980-05-15	1980-05-15 00:00:00	1980-05-15	38000177		0	0	28		0	0	0	304073	0	313782	1127433		
58126	1272	40213160	1980-02-22	1980-02-22 00:00:00	1980-02-22	1980-02-22 00:00:00	1980-02-22	581452		0	0	0		0	0	0	83954	0	10	40213160		
43543	3610	920300	1966-06-08	1966-06-08 00:00:00	1966-06-15	1966-06-15 00:00:00	1966-06-15	38000177		0	0	7		0	0	0	239862	0	311989	920300		
47402	3929	1127433	1968-02-13	1968-02-13 00:00:00	1968-02-27	1968-02-27 00:00:00	1968-02-27	38000177		0	0	14		0	0	0	261186	0	313782	1127433		
171375	3767	40213306	2007-04-27	2007-04-27 00:00:00	2007-04-27	2007-04-27 00:00:00	2007-04-27	581452		0	0	0		0	0	0	250344	0	43	40213306		
5290	443	40162522	2013-05-26	2013-05-26 00:00:00	2013-05-26	2013-05-26 00:00:00	\N	38000177		0	0	0		0	0	0	29432	0	857005	40162522		
54196	4503	1115171	2001-02-10	2001-02-10 00:00:00	2001-03-19	2001-03-19 00:00:00	2001-03-19	38000177		0	0	37		0	0	0	299862	0	849574	1115171		
25017	546	40213198	2010-02-14	2010-02-14 00:00:00	2010-02-14	2010-02-14 00:00:00	2010-02-14	581452		0	0	0		0	0	0	36236	0	133	40213198		
46469	3849	1127433	1976-06-06	1976-06-06 00:00:00	1976-07-04	1976-07-04 00:00:00	1976-07-04	38000177		0	0	28		0	0	0	255447	0	313782	1127433		
175201	3852	40213260	2006-02-20	2006-02-20 00:00:00	2006-02-20	2006-02-20 00:00:00	2006-02-20	581452		0	0	0		0	0	0	255665	0	121	40213260		
58668	4872	1115171	2018-11-07	2018-11-07 00:00:00	2018-11-21	2018-11-21 00:00:00	2018-11-21	38000177		0	0	14		0	0	0	324094	0	849574	1115171		
11025	918	19078461	1989-03-07	1989-03-07 00:00:00	1989-04-04	1989-04-04 00:00:00	1989-04-04	38000177		0	0	28		0	0	0	61202	0	310965	19078461		
58754	4881	1127433	1981-12-18	1981-12-18 00:00:00	1982-02-23	1982-02-23 00:00:00	1982-02-23	38000177		0	0	67		0	0	0	324545	0	313782	1127433		
29895	2477	19059056	1956-03-23	1956-03-23 00:00:00	1956-04-06	1956-04-06 00:00:00	1956-04-06	38000177		0	0	14		0	0	0	164167	0	243670	19059056		
50534	4199	40236824	1957-06-27	1957-06-27 00:00:00	1957-07-04	1957-07-04 00:00:00	1957-07-04	38000177		0	0	7		0	0	0	278635	0	1094107	40236824		
133583	2933	40213227	1995-08-07	1995-08-07 00:00:00	1995-08-07	1995-08-07 00:00:00	1995-08-07	581452		0	0	0		0	0	0	195569	0	113	40213227		
8595	185	40213227	1998-03-01	1998-03-01 00:00:00	1998-03-01	1998-03-01 00:00:00	1998-03-01	581452		0	0	0		0	0	0	12513	0	113	40213227		
29545	2444	1127078	1965-04-23	1965-04-23 00:00:00	1965-05-07	1965-05-07 00:00:00	1965-05-07	38000177		0	0	14		0	0	0	162154	0	282464	1127078		
47713	3956	1115171	2013-02-25	2013-02-25 00:00:00	2013-04-26	2013-04-26 00:00:00	2013-04-26	38000177		0	0	60		0	0	0	262908	0	849574	1115171		
31989	697	40213227	2016-07-06	2016-07-06 00:00:00	2016-07-06	2016-07-06 00:00:00	2016-07-06	581452		0	0	0		0	0	0	\N	0	113	40213227		
49413	4100	1127433	1957-08-23	1957-08-23 00:00:00	1957-09-20	1957-09-20 00:00:00	1957-09-20	38000177		0	0	28		0	0	0	272467	0	313782	1127433		
59450	4942	19018935	2004-04-29	2004-04-29 00:00:00	2004-04-29	2004-04-29 00:00:00	\N	38000177		0	0	0		0	0	0	328521	0	197604	19018935		
870	70	19133905	1993-04-29	1993-04-29 00:00:00	1993-05-07	1993-05-07 00:00:00	1993-05-07	38000177		0	0	8		0	0	0	4763	0	834102	19133905		
16399	1358	19059056	1986-10-12	1986-10-12 00:00:00	1986-10-26	1986-10-26 00:00:00	1986-10-26	38000177		0	0	14		0	0	0	90109	0	243670	19059056		
24005	1976	19019979	1986-12-20	1986-12-20 00:00:00	1987-01-03	1987-01-03 00:00:00	1987-01-03	38000177		0	0	14		0	0	0	131380	0	198405	19019979		
36975	806	40213260	2006-12-31	2006-12-31 00:00:00	2006-12-31	2006-12-31 00:00:00	2006-12-31	581452		0	0	0		0	0	0	53499	0	121	40213260		
27015	2228	920300	2007-02-27	2007-02-27 00:00:00	2007-03-06	2007-03-06 00:00:00	2007-03-06	38000177		0	0	7		0	0	0	148250	0	311989	920300		
136362	2993	40213296	2012-06-23	2012-06-23 00:00:00	2012-06-23	2012-06-23 00:00:00	2012-06-23	581452		0	0	0		0	0	0	199792	0	52	40213296		
14942	1249	40229134	1973-05-29	1973-05-29 00:00:00	1973-06-05	1973-06-05 00:00:00	1973-06-05	38000177		0	0	7		0	0	0	82253	0	1043400	40229134		
44796	3707	46233988	1969-09-28	1969-09-28 00:00:00	1969-10-12	1969-10-12 00:00:00	1969-10-12	38000177		0	0	14		0	0	0	246447	0	1652673	46233988		
38397	3175	1127078	1959-08-09	1959-08-09 00:00:00	1959-08-23	1959-08-23 00:00:00	1959-08-23	38000177		0	0	14		0	0	0	211031	0	282464	1127078		
15087	1259	1713671	1968-10-28	1968-10-28 00:00:00	1968-11-04	1968-11-04 00:00:00	1968-11-04	38000177		0	0	7		0	0	0	82973	0	562251	1713671		
179490	3946	40213160	1960-11-29	1960-11-29 00:00:00	1960-11-29	1960-11-29 00:00:00	1960-11-29	581452		0	0	0		0	0	0	262317	0	10	40213160		
3039	246	1127433	2011-08-12	2011-08-12 00:00:00	2011-08-26	2011-08-26 00:00:00	2011-08-26	38000177		0	0	14		0	0	0	16582	0	313782	1127433		
5837	487	1118084	2000-01-26	2000-01-26 00:00:00	2000-01-26	2000-01-26 00:00:00	\N	38000177		0	0	0		0	0	0	32612	0	00025152531	44923712		
53012	4405	19006318	1964-11-13	1964-11-13 00:00:00	1964-11-27	1964-11-27 00:00:00	1964-11-27	38000177		0	0	14		0	0	0	292791	0	105078	19006318		
53068	4409	19128065	1988-12-11	1988-12-11 00:00:00	1989-12-06	1989-12-06 00:00:00	1989-12-06	38000177		0	0	360		0	0	0	293096	0	749882	19128065		
18334	1517	40171902	2017-04-17	2017-04-17 00:00:00	2017-04-17	2017-04-17 00:00:00	\N	38000177		0	0	0		0	0	0	101405	0	897718	40171902		
16186	349	40213260	2009-03-07	2009-03-07 00:00:00	2009-03-07	2009-03-07 00:00:00	2009-03-07	581452		0	0	0		0	0	0	23214	0	121	40213260		
25243	2077	19008572	1958-03-29	1958-03-29 00:00:00	1958-03-29	1958-03-29 00:00:00	\N	38000177		0	0	0		0	0	0	138268	0	106258	19008572		
90689	1990	40213296	2006-06-02	2006-06-02 00:00:00	2006-06-02	2006-06-02 00:00:00	2006-06-02	581452		0	0	0		0	0	0	132498	0	52	40213296		
54039	4490	19059056	1925-12-22	1925-12-22 00:00:00	1926-01-05	1926-01-05 00:00:00	1926-01-05	38000177		0	0	14		0	0	0	298880	0	243670	19059056		
31902	2644	40229134	2006-05-26	2006-05-26 00:00:00	2006-06-02	2006-06-02 00:00:00	2006-06-02	38000177		0	0	7		0	0	0	174973	0	1043400	40229134		
35893	2955	19019979	1974-03-05	1974-03-05 00:00:00	1974-03-19	1974-03-19 00:00:00	1974-03-19	38000177		0	0	14		0	0	0	197265	0	198405	19019979		
52461	4365	40165015	1985-07-08	1985-07-08 00:00:00	1985-07-08	1985-07-08 00:00:00	\N	38000177		0	0	0		0	0	0	289590	0	861467	40165015		
13836	298	40213160	1956-02-07	1956-02-07 00:00:00	1956-02-07	1956-02-07 00:00:00	1956-02-07	581452		0	0	0		0	0	0	19890	0	10	40213160		
15276	1276	40229134	1967-03-18	1967-03-18 00:00:00	1967-03-25	1967-03-25 00:00:00	1967-03-25	38000177		0	0	7		0	0	0	84273	0	1043400	40229134		
51441	4275	19126352	1994-02-13	1994-02-13 00:00:00	1994-02-13	1994-02-13 00:00:00	\N	38000177		0	0	0		0	0	0	283699	0	705129	19126352		
60236	5007	19078461	2000-06-25	2000-06-25 00:00:00	2000-07-09	2000-07-09 00:00:00	2000-07-09	38000177		0	0	14		0	0	0	332997	0	310965	19078461		
3394	280	19133873	1949-04-06	1949-04-06 00:00:00	1949-04-18	1949-04-18 00:00:00	1949-04-18	38000177		0	0	12		0	0	0	18718	0	834061	19133873		
201463	4423	40213160	1980-08-01	1980-08-01 00:00:00	1980-08-01	1980-08-01 00:00:00	1980-08-01	581452		0	0	0		0	0	0	294103	0	10	40213160		
9518	793	1127433	1983-11-04	1983-11-04 00:00:00	1983-11-11	1983-11-11 00:00:00	1983-11-11	38000177		0	0	7		0	0	0	52616	0	313782	1127433		
26028	2141	19133873	1949-09-07	1949-09-07 00:00:00	1949-09-18	1949-09-18 00:00:00	1949-09-18	38000177		0	0	11		0	0	0	142636	0	834061	19133873		
57249	4753	19133905	1984-11-03	1984-11-03 00:00:00	1984-11-11	1984-11-11 00:00:00	1984-11-11	38000177		0	0	8		0	0	0	316546	0	834102	19133905		
11630	969	19128022	1994-04-23	1994-04-23 00:00:00	1995-04-18	1995-04-18 00:00:00	1995-04-18	38000177		0	0	360		0	0	0	64421	0	749785	19128022		
20162	1657	1124300	1987-02-01	1987-02-01 00:00:00	1987-02-01	1987-02-01 00:00:00	\N	38000177		0	0	0		0	0	0	111167	0	00781178901	45011828		
11715	973	19059056	1920-03-23	1920-03-23 00:00:00	1920-04-06	1920-04-06 00:00:00	1920-04-06	38000177		0	0	14		0	0	0	64780	0	243670	19059056		
143151	3145	40213160	1970-12-06	1970-12-06 00:00:00	1970-12-06	1970-12-06 00:00:00	1970-12-06	581452		0	0	0		0	0	0	209304	0	10	40213160		
19050	1572	40229134	1995-07-30	1995-07-30 00:00:00	1995-08-06	1995-08-06 00:00:00	1995-08-06	38000177		0	0	7		0	0	0	105558	0	1043400	40229134		
1693	135	1127433	2005-11-09	2005-11-09 00:00:00	2005-12-07	2005-12-07 00:00:00	2005-12-07	38000177		0	0	28		0	0	0	9023	0	313782	1127433		
23353	1925	40165015	1957-06-16	1957-06-16 00:00:00	1957-06-16	1957-06-16 00:00:00	\N	38000177		0	0	0		0	0	0	128083	0	861467	40165015		
91859	2016	40213251	1984-05-15	1984-05-15 00:00:00	1984-05-15	1984-05-15 00:00:00	1984-05-15	581452		0	0	0		0	0	0	134152	0	21	40213251		
84369	1845	40213160	1966-03-30	1966-03-30 00:00:00	1966-03-30	1966-03-30 00:00:00	1966-03-30	581452		0	0	0		0	0	0	123305	0	10	40213160		
32931	2731	1127078	1961-07-18	1961-07-18 00:00:00	1961-08-01	1961-08-01 00:00:00	1961-08-01	38000177		0	0	14		0	0	0	180826	0	282464	1127078		
54953	4563	1713671	2016-05-16	2016-05-16 00:00:00	2016-05-23	2016-05-23 00:00:00	2016-05-23	38000177		0	0	7		0	0	0	304129	0	562251	1713671		
27930	607	40213227	1992-12-25	1992-12-25 00:00:00	1992-12-25	1992-12-25 00:00:00	1992-12-25	581452		0	0	0		0	0	0	40347	0	113	40213227		
43544	3610	1127433	1985-08-31	1985-08-31 00:00:00	1985-09-07	1985-09-07 00:00:00	1985-09-07	38000177		0	0	7		0	0	0	239842	0	313782	1127433		
47403	3929	1127433	1991-05-23	1991-05-23 00:00:00	1991-06-06	1991-06-06 00:00:00	1991-06-06	38000177		0	0	14		0	0	0	261149	0	313782	1127433		
171381	3767	40213314	1985-07-26	1985-07-26 00:00:00	1985-07-26	1985-07-26 00:00:00	1985-07-26	581452		0	0	0		0	0	0	250376	0	49	40213314		
50893	4227	1127433	2007-09-06	2007-09-06 00:00:00	2007-10-04	2007-10-04 00:00:00	2007-10-04	38000177		0	0	28		0	0	0	280799	0	313782	1127433		
54197	4503	1127433	1992-06-11	1992-06-11 00:00:00	1992-06-25	1992-06-25 00:00:00	1992-06-25	38000177		0	0	14		0	0	0	299866	0	313782	1127433		
25019	546	40213201	2010-02-14	2010-02-14 00:00:00	2010-02-14	2010-02-14 00:00:00	2010-02-14	581452		0	0	0		0	0	0	36236	0	33	40213201		
46470	3849	920300	2005-12-14	2005-12-14 00:00:00	2005-12-21	2005-12-21 00:00:00	2005-12-21	38000177		0	0	7		0	0	0	255393	0	311989	920300		
175203	3852	40213160	1955-03-14	1955-03-14 00:00:00	1955-03-14	1955-03-14 00:00:00	1955-03-14	581452		0	0	0		0	0	0	255623	0	10	40213160		
58669	4872	1713671	1980-06-29	1980-06-29 00:00:00	1980-07-06	1980-07-06 00:00:00	1980-07-06	38000177		0	0	7		0	0	0	324031	0	562251	1713671		
11026	918	1332419	1994-12-09	1994-12-09 00:00:00	1994-12-09	1994-12-09 00:00:00	\N	38000177		0	0	0		0	0	0	61212	0	197361	1332419		
58755	4881	40231925	1981-12-25	1981-12-25 00:00:00	1981-12-25	1981-12-25 00:00:00	\N	38000177		0	0	0		0	0	0	324523	0	1049221	40231925		
29896	2477	19128065	1977-01-12	1977-01-12 00:00:00	1978-01-07	1978-01-07 00:00:00	1978-01-07	38000177		0	0	360		0	0	0	164124	0	749882	19128065		
50535	4199	920300	1957-06-27	1957-06-27 00:00:00	1957-07-04	1957-07-04 00:00:00	1957-07-04	38000177		0	0	7		0	0	0	278635	0	311989	920300		
133589	2933	40213160	1955-05-02	1955-05-02 00:00:00	1955-05-02	1955-05-02 00:00:00	1955-05-02	581452		0	0	0		0	0	0	195627	0	10	40213160		
8597	185	40213201	2012-05-20	2012-05-20 00:00:00	2012-05-20	2012-05-20 00:00:00	2012-05-20	581452		0	0	0		0	0	0	12517	0	33	40213201		
29546	2445	19133873	1933-02-22	1933-02-22 00:00:00	1933-03-01	1933-03-01 00:00:00	1933-03-01	38000177		0	0	7		0	0	0	162255	0	834061	19133873		
47714	3956	40229134	1975-11-07	1975-11-07 00:00:00	1975-11-14	1975-11-14 00:00:00	1975-11-14	38000177		0	0	7		0	0	0	262997	0	1043400	40229134		
31992	697	40213306	1987-05-06	1987-05-06 00:00:00	1987-05-06	1987-05-06 00:00:00	1987-05-06	581452		0	0	0		0	0	0	46107	0	43	40213306		
49414	4100	19133873	1949-09-01	1949-09-01 00:00:00	1949-09-14	1949-09-14 00:00:00	1949-09-14	38000177		0	0	13		0	0	0	272454	0	834061	19133873		
13139	1102	19128065	1984-01-05	1984-01-05 00:00:00	1984-12-30	1984-12-30 00:00:00	1984-12-30	38000177		0	0	360		0	0	0	72410	0	749882	19128065		
871	70	19006318	1952-05-20	1952-05-20 00:00:00	1952-06-03	1952-06-03 00:00:00	1952-06-03	38000177		0	0	14		0	0	0	4731	0	105078	19006318		
16400	1358	19078461	2004-02-15	2004-02-15 00:00:00	2004-03-21	2004-03-21 00:00:00	2004-03-21	38000177		0	0	35		0	0	0	90111	0	310965	19078461		
24006	1976	19073183	1986-12-20	1986-12-20 00:00:00	1987-01-03	1987-01-03 00:00:00	1987-01-03	38000177		0	0	14		0	0	0	131380	0	308182	19073183		
82225	1796	40213227	2010-06-16	2010-06-16 00:00:00	2010-06-16	2010-06-16 00:00:00	2010-06-16	581452		0	0	0		0	0	0	120398	0	113	40213227		
27016	2228	19078461	1987-07-06	1987-07-06 00:00:00	1987-07-20	1987-07-20 00:00:00	1987-07-20	38000177		0	0	14		0	0	0	148295	0	310965	19078461		
136381	2993	40213160	1970-09-19	1970-09-19 00:00:00	1970-09-19	1970-09-19 00:00:00	1970-09-19	581452		0	0	0		0	0	0	199785	0	10	40213160		
14943	1249	19133905	2004-04-29	2004-04-29 00:00:00	2004-05-06	2004-05-06 00:00:00	2004-05-06	38000177		0	0	7		0	0	0	82298	0	834102	19133905		
44797	3707	1118084	2008-07-05	2008-07-05 00:00:00	2008-07-05	2008-07-05 00:00:00	\N	38000177		0	0	0		0	0	0	246422	0	00025152531	44923712		
38398	3176	1118084	2007-10-11	2007-10-11 00:00:00	2007-10-11	2007-10-11 00:00:00	\N	38000177		0	0	0		0	0	0	211119	0	00025152531	44923712		
15088	1259	1713671	1962-01-06	1962-01-06 00:00:00	1962-01-27	1962-01-27 00:00:00	1962-01-27	38000177		0	0	21		0	0	0	82971	0	562251	1713671		
179494	3946	40213306	1982-06-01	1982-06-01 00:00:00	1982-06-01	1982-06-01 00:00:00	1982-06-01	581452		0	0	0		0	0	0	262321	0	43	40213306		
3040	246	40169216	1963-12-02	1963-12-02 00:00:00	1963-12-02	1963-12-02 00:00:00	\N	38000177		0	0	0		0	0	0	16519	0	895994	40169216		
5838	487	19059056	1971-03-14	1971-03-14 00:00:00	1971-03-28	1971-03-28 00:00:00	1971-03-28	38000177		0	0	14		0	0	0	32534	0	243670	19059056		
53013	4405	1127433	1983-05-10	1983-05-10 00:00:00	1983-05-17	1983-05-17 00:00:00	1983-05-17	38000177		0	0	7		0	0	0	292810	0	313782	1127433		
53069	4409	1127078	1976-12-27	1976-12-27 00:00:00	1977-01-17	1977-01-17 00:00:00	1977-01-17	38000177		0	0	21		0	0	0	293127	0	282464	1127078		
18335	1517	40163554	2017-04-17	2017-04-17 00:00:00	2017-04-17	2017-04-17 00:00:00	\N	38000177		0	0	0		0	0	0	101405	0	855332	40163554		
16192	349	40213227	2019-05-04	2019-05-04 00:00:00	2019-05-04	2019-05-04 00:00:00	2019-05-04	581452		0	0	0		0	0	0	23239	0	113	40213227		
25244	2077	1127433	1962-08-21	1962-08-21 00:00:00	1962-09-04	1962-09-04 00:00:00	1962-09-04	38000177		0	0	14		0	0	0	138213	0	313782	1127433		
92227	2025	40213227	1992-02-22	1992-02-22 00:00:00	1992-02-22	1992-02-22 00:00:00	1992-02-22	581452		0	0	0		0	0	0	134764	0	113	40213227		
54040	4490	19059056	1929-12-15	1929-12-15 00:00:00	1929-12-29	1929-12-29 00:00:00	1929-12-29	38000177		0	0	14		0	0	0	298881	0	243670	19059056		
31903	2644	1127078	1980-11-07	1980-11-07 00:00:00	1980-11-21	1980-11-21 00:00:00	1980-11-21	38000177		0	0	14		0	0	0	174995	0	282464	1127078		
35894	2955	46233988	1974-03-05	1974-03-05 00:00:00	1974-03-19	1974-03-19 00:00:00	1974-03-19	38000177		0	0	14		0	0	0	197265	0	1652673	46233988		
52462	4365	19059056	1985-07-08	1985-07-08 00:00:00	1985-07-29	1985-07-29 00:00:00	1985-07-29	38000177		0	0	21		0	0	0	289590	0	243670	19059056		
13851	299	40213260	2012-12-15	2012-12-15 00:00:00	2012-12-15	2012-12-15 00:00:00	2012-12-15	581452		0	0	0		0	0	0	19959	0	121	40213260		
15277	1276	1713671	1984-11-16	1984-11-16 00:00:00	1984-11-30	1984-11-30 00:00:00	1984-11-30	38000177		0	0	14		0	0	0	84142	0	562251	1713671		
51442	4275	1115171	1995-04-01	1995-04-01 00:00:00	1995-04-23	1995-04-23 00:00:00	1995-04-23	38000177		0	0	22		0	0	0	283716	0	849574	1115171		
60238	5007	19115351	2000-08-13	2000-08-13 00:00:00	2001-02-25	2001-02-25 00:00:00	2001-02-25	38000177		0	0	196		0	0	0	333038	0	563026	19115351		
3395	280	1127433	2014-02-15	2014-02-15 00:00:00	2014-03-01	2014-03-01 00:00:00	2014-03-01	38000177		0	0	14		0	0	0	18767	0	313782	1127433		
75207	1642	40213160	1956-05-08	1956-05-08 00:00:00	1956-05-08	1956-05-08 00:00:00	1956-05-08	581452		0	0	0		0	0	0	110208	0	10	40213160		
9532	795	1118084	1982-08-23	1982-08-23 00:00:00	1982-08-23	1982-08-23 00:00:00	\N	38000177		0	0	0		0	0	0	52792	0	00025152531	44923712		
26029	2141	19059056	1950-11-14	1950-11-14 00:00:00	1950-11-28	1950-11-28 00:00:00	1950-11-28	38000177		0	0	14		0	0	0	142615	0	243670	19059056		
57251	4753	19133905	1982-12-31	1982-12-31 00:00:00	1983-01-12	1983-01-12 00:00:00	1983-01-12	38000177		0	0	12		0	0	0	316491	0	834102	19133905		
11631	969	1118084	2014-07-17	2014-07-17 00:00:00	2014-07-17	2014-07-17 00:00:00	\N	38000177		0	0	0		0	0	0	64449	0	00025152531	44923712		
20163	1657	1127433	1990-11-23	1990-11-23 00:00:00	1990-12-07	1990-12-07 00:00:00	1990-12-07	38000177		0	0	14		0	0	0	111213	0	313782	1127433		
11716	973	19078461	2016-06-02	2016-06-02 00:00:00	2016-06-16	2016-06-16 00:00:00	2016-06-16	38000177		0	0	14		0	0	0	64829	0	310965	19078461		
143155	3145	40213160	1975-08-10	1975-08-10 00:00:00	1975-08-10	1975-08-10 00:00:00	1975-08-10	581452		0	0	0		0	0	0	209279	0	10	40213160		
19051	1572	1127433	1989-07-12	1989-07-12 00:00:00	1989-08-09	1989-08-09 00:00:00	1989-08-09	38000177		0	0	28		0	0	0	105548	0	313782	1127433		
1696	135	1127433	2001-01-06	2001-01-06 00:00:00	2001-02-03	2001-02-03 00:00:00	2001-02-03	38000177		0	0	28		0	0	0	9021	0	313782	1127433		
23354	1925	19059056	1957-06-16	1957-06-16 00:00:00	1957-07-16	1957-07-16 00:00:00	1957-07-16	38000177		0	0	30		0	0	0	128083	0	243670	19059056		
91865	2016	40213306	2003-06-10	2003-06-10 00:00:00	2003-06-10	2003-06-10 00:00:00	2003-06-10	581452		0	0	0		0	0	0	134131	0	43	40213306		
84375	1845	40213160	1961-07-26	1961-07-26 00:00:00	1961-07-26	1961-07-26 00:00:00	1961-07-26	581452		0	0	0		0	0	0	123336	0	10	40213160		
32932	2731	19129655	1961-07-18	1961-07-18 00:00:00	1961-08-01	1961-08-01 00:00:00	1961-08-01	38000177		0	0	14		0	0	0	180826	0	789980	19129655		
54954	4563	1127433	1981-04-10	1981-04-10 00:00:00	1981-07-09	1981-07-09 00:00:00	1981-07-09	38000177		0	0	90		0	0	0	304074	0	313782	1127433		
27937	608	40213296	2013-12-25	2013-12-25 00:00:00	2013-12-25	2013-12-25 00:00:00	2013-12-25	581452		0	0	0		0	0	0	40393	0	52	40213296		
43545	3610	19073188	2017-06-26	2017-06-26 00:00:00	2017-07-10	2017-07-10 00:00:00	2017-07-10	38000177		0	0	14		0	0	0	239885	0	308192	19073188		
47404	3929	19059056	1952-12-01	1952-12-01 00:00:00	1952-12-15	1952-12-15 00:00:00	1952-12-15	38000177		0	0	14		0	0	0	261158	0	243670	19059056		
171382	3767	40213160	1985-07-26	1985-07-26 00:00:00	1985-07-26	1985-07-26 00:00:00	1985-07-26	581452		0	0	0		0	0	0	250376	0	10	40213160		
50903	4229	1713671	2018-10-05	2018-10-05 00:00:00	2018-10-19	2018-10-19 00:00:00	2018-10-19	38000177		0	0	14		0	0	0	280904	0	562251	1713671		
54198	4504	19019979	1978-01-20	1978-01-20 00:00:00	1978-03-21	1978-03-21 00:00:00	1978-03-21	38000177		0	0	60		0	0	0	299900	0	198405	19019979		
25021	546	40213227	2015-03-15	2015-03-15 00:00:00	2015-03-15	2015-03-15 00:00:00	2015-03-15	581452		0	0	0		0	0	0	36224	0	113	40213227		
46471	3849	40236824	2005-12-14	2005-12-14 00:00:00	2005-12-21	2005-12-21 00:00:00	2005-12-21	38000177		0	0	7		0	0	0	255393	0	1094107	40236824		
17021	1410	19133873	1973-02-24	1973-02-24 00:00:00	1973-03-04	1973-03-04 00:00:00	1973-03-04	38000177		0	0	8		0	0	0	93848	0	834061	19133873		
58670	4872	19059056	1926-12-29	1926-12-29 00:00:00	1927-01-12	1927-01-12 00:00:00	1927-01-12	38000177		0	0	14		0	0	0	323950	0	243670	19059056		
811	65	1127433	2009-05-28	2009-05-28 00:00:00	2009-06-04	2009-06-04 00:00:00	2009-06-04	38000177		0	0	7		0	0	0	4422	0	313782	1127433		
58756	4881	1124300	1988-11-18	1988-11-18 00:00:00	1988-11-18	1988-11-18 00:00:00	\N	38000177		0	0	0		0	0	0	324529	0	00781178901	45011828		
29897	2477	1127433	1967-10-22	1967-10-22 00:00:00	1967-11-12	1967-11-12 00:00:00	1967-11-12	38000177		0	0	21		0	0	0	164118	0	313782	1127433		
50536	4199	1118084	1979-08-06	1979-08-06 00:00:00	1979-08-06	1979-08-06 00:00:00	\N	38000177		0	0	0		0	0	0	278660	0	00025152531	44923712		
133592	2933	40213160	1955-10-31	1955-10-31 00:00:00	1955-10-31	1955-10-31 00:00:00	1955-10-31	581452		0	0	0		0	0	0	195600	0	10	40213160		
8599	185	40213198	2011-05-15	2011-05-15 00:00:00	2011-05-15	2011-05-15 00:00:00	2011-05-15	581452		0	0	0		0	0	0	12516	0	133	40213198		
29547	2445	1127433	1981-09-08	1981-09-08 00:00:00	1981-09-15	1981-09-15 00:00:00	1981-09-15	38000177		0	0	7		0	0	0	162222	0	313782	1127433		
47715	3956	1118084	1959-02-10	1959-02-10 00:00:00	1959-02-10	1959-02-10 00:00:00	\N	38000177		0	0	0		0	0	0	263022	0	00025152531	44923712		
31993	697	40213160	1965-09-22	1965-09-22 00:00:00	1965-09-22	1965-09-22 00:00:00	1965-09-22	581452		0	0	0		0	0	0	46138	0	10	40213160		
49415	4100	1127433	1947-10-11	1947-10-11 00:00:00	1947-10-25	1947-10-25 00:00:00	1947-10-25	38000177		0	0	14		0	0	0	272453	0	313782	1127433		
13140	1102	40229134	1998-07-26	1998-07-26 00:00:00	1998-08-02	1998-08-02 00:00:00	1998-08-02	38000177		0	0	7		0	0	0	72415	0	1043400	40229134		
872	70	1127078	1952-05-20	1952-05-20 00:00:00	1952-06-03	1952-06-03 00:00:00	1952-06-03	38000177		0	0	14		0	0	0	4731	0	282464	1127078		
16401	1358	19133873	1965-12-21	1965-12-21 00:00:00	1965-12-28	1965-12-28 00:00:00	1965-12-28	38000177		0	0	7		0	0	0	90068	0	834061	19133873		
24007	1976	19019979	1988-01-29	1988-01-29 00:00:00	1988-02-12	1988-02-12 00:00:00	1988-02-12	38000177		0	0	14		0	0	0	131381	0	198405	19019979		
82228	1796	40213227	2001-06-06	2001-06-06 00:00:00	2001-06-06	2001-06-06 00:00:00	2001-06-06	581452		0	0	0		0	0	0	120421	0	113	40213227		
27017	2228	1127433	2001-02-26	2001-02-26 00:00:00	2001-03-12	2001-03-12 00:00:00	2001-03-12	38000177		0	0	14		0	0	0	148275	0	313782	1127433		
240811	5285	40213198	2010-10-03	2010-10-03 00:00:00	2010-10-03	2010-10-03 00:00:00	2010-10-03	581452		0	0	0		0	0	0	351647	0	133	40213198		
14944	1249	1115171	2018-03-03	2018-03-03 00:00:00	2018-04-07	2018-04-07 00:00:00	2018-04-07	38000177		0	0	35		0	0	0	82294	0	849574	1115171		
44798	3707	19128065	1983-06-27	1983-06-27 00:00:00	1984-06-21	1984-06-21 00:00:00	1984-06-21	38000177		0	0	360		0	0	0	246467	0	749882	19128065		
38399	3176	1127433	2000-08-17	2000-08-17 00:00:00	2000-08-31	2000-08-31 00:00:00	2000-08-31	38000177		0	0	14		0	0	0	211151	0	313782	1127433		
15089	1259	1115171	2007-07-05	2007-07-05 00:00:00	2007-07-19	2007-07-19 00:00:00	2007-07-19	38000177		0	0	14		0	0	0	82965	0	849574	1115171		
179501	3946	40213160	1965-02-23	1965-02-23 00:00:00	1965-02-23	1965-02-23 00:00:00	1965-02-23	581452		0	0	0		0	0	0	262329	0	10	40213160		
50226	1100	40213306	2004-11-24	2004-11-24 00:00:00	2004-11-24	2004-11-24 00:00:00	2004-11-24	581452		0	0	0		0	0	0	72289	0	43	40213306		
5839	487	19006318	1971-03-14	1971-03-14 00:00:00	1971-03-28	1971-03-28 00:00:00	1971-03-28	38000177		0	0	14		0	0	0	32534	0	105078	19006318		
53014	4406	920334	1977-01-01	1977-01-01 00:00:00	1977-01-08	1977-01-08 00:00:00	1977-01-08	38000177		0	0	7		0	0	0	292863	0	311995	920334		
53070	4409	19133873	1978-11-07	1978-11-07 00:00:00	1978-11-16	1978-11-16 00:00:00	1978-11-16	38000177		0	0	9		0	0	0	293053	0	834061	19133873		
18336	1517	19018935	2017-04-17	2017-04-17 00:00:00	2017-04-17	2017-04-17 00:00:00	\N	38000177		0	0	0		0	0	0	101405	0	197604	19018935		
16195	349	40213160	1962-08-11	1962-08-11 00:00:00	1962-08-11	1962-08-11 00:00:00	1962-08-11	581452		0	0	0		0	0	0	23236	0	10	40213160		
25245	2078	1127433	2005-05-09	2005-05-09 00:00:00	2005-06-08	2005-06-08 00:00:00	2005-06-08	38000177		0	0	30		0	0	0	138382	0	313782	1127433		
92243	2025	40213227	2000-04-08	2000-04-08 00:00:00	2000-04-08	2000-04-08 00:00:00	2000-04-08	581452		0	0	0		0	0	0	134779	0	113	40213227		
54041	4490	1127433	1956-04-15	1956-04-15 00:00:00	1956-04-29	1956-04-29 00:00:00	1956-04-29	38000177		0	0	14		0	0	0	298916	0	313782	1127433		
31904	2644	19073183	1980-11-07	1980-11-07 00:00:00	1980-11-21	1980-11-21 00:00:00	1980-11-21	38000177		0	0	14		0	0	0	174995	0	308182	19073183		
35895	2955	1127433	1998-01-10	1998-01-10 00:00:00	1998-01-17	1998-01-17 00:00:00	1998-01-17	38000177		0	0	7		0	0	0	197207	0	313782	1127433		
52463	4365	19074841	1985-07-08	1985-07-08 00:00:00	1985-07-29	1985-07-29 00:00:00	1985-07-29	38000177		0	0	21		0	0	0	289590	0	309043	19074841		
13853	299	40213227	2012-12-15	2012-12-15 00:00:00	2012-12-15	2012-12-15 00:00:00	2012-12-15	581452		0	0	0		0	0	0	19959	0	113	40213227		
60115	4998	19134077	2007-11-15	2007-11-15 00:00:00	2007-12-06	2007-12-06 00:00:00	2007-12-06	38000177		0	0	21		0	0	0	332383	0	835900	19134077		
51443	4275	1127433	1993-03-27	1993-03-27 00:00:00	1993-04-03	1993-04-03 00:00:00	1993-04-03	38000177		0	0	7		0	0	0	283678	0	313782	1127433		
60240	5007	1713671	1999-11-18	1999-11-18 00:00:00	1999-11-25	1999-11-25 00:00:00	1999-11-25	38000177		0	0	7		0	0	0	333025	0	562251	1713671		
3396	280	1127433	1981-01-08	1981-01-08 00:00:00	1981-01-15	1981-01-15 00:00:00	1981-01-15	38000177		0	0	7		0	0	0	18716	0	313782	1127433		
75209	1642	40213227	1993-06-01	1993-06-01 00:00:00	1993-06-01	1993-06-01 00:00:00	1993-06-01	581452		0	0	0		0	0	0	110242	0	113	40213227		
62079	5165	19133873	1977-02-07	1977-02-07 00:00:00	1977-02-15	1977-02-15 00:00:00	1977-02-15	38000177		0	0	8		0	0	0	343256	0	834061	19133873		
26030	2141	19006318	1950-11-14	1950-11-14 00:00:00	1950-11-28	1950-11-28 00:00:00	1950-11-28	38000177		0	0	14		0	0	0	142615	0	105078	19006318		
57253	4753	19133873	1975-02-28	1975-02-28 00:00:00	1975-03-10	1975-03-10 00:00:00	1975-03-10	38000177		0	0	10		0	0	0	316539	0	834061	19133873		
11632	969	1713671	1984-07-26	1984-07-26 00:00:00	1984-08-09	1984-08-09 00:00:00	1984-08-09	38000177		0	0	14		0	0	0	64418	0	562251	1713671		
20164	1657	1127433	2014-02-06	2014-02-06 00:00:00	2014-02-20	2014-02-20 00:00:00	2014-02-20	38000177		0	0	14		0	0	0	111190	0	313782	1127433		
11717	973	19078461	1998-02-16	1998-02-16 00:00:00	1998-03-09	1998-03-09 00:00:00	1998-03-09	38000177		0	0	21		0	0	0	64807	0	310965	19078461		
143157	3145	40213227	2012-09-09	2012-09-09 00:00:00	2012-09-09	2012-09-09 00:00:00	2012-09-09	581452		0	0	0		0	0	0	209313	0	113	40213227		
19052	1572	19059056	1972-11-26	1972-11-26 00:00:00	1972-12-10	1972-12-10 00:00:00	1972-12-10	38000177		0	0	14		0	0	0	105544	0	243670	19059056		
1697	135	1127433	2010-10-21	2010-10-21 00:00:00	2010-10-28	2010-10-28 00:00:00	2010-10-28	38000177		0	0	7		0	0	0	9083	0	313782	1127433		
23355	1925	1115171	2006-11-10	2006-11-10 00:00:00	2006-12-08	2006-12-08 00:00:00	2006-12-08	38000177		0	0	28		0	0	0	128087	0	849574	1115171		
91866	2016	40213227	2003-06-10	2003-06-10 00:00:00	2003-06-10	2003-06-10 00:00:00	2003-06-10	581452		0	0	0		0	0	0	134131	0	113	40213227		
84380	1845	40213227	2012-04-25	2012-04-25 00:00:00	2012-04-25	2012-04-25 00:00:00	2012-04-25	581452		0	0	0		0	0	0	123341	0	113	40213227		
32933	2731	19059056	1972-09-06	1972-09-06 00:00:00	1972-09-27	1972-09-27 00:00:00	1972-09-27	38000177		0	0	21		0	0	0	180817	0	243670	19059056		
54955	4563	1127433	2001-11-03	2001-11-03 00:00:00	2001-11-10	2001-11-10 00:00:00	2001-11-10	38000177		0	0	7		0	0	0	304127	0	313782	1127433		
27938	608	40213314	1977-11-23	1977-11-23 00:00:00	1977-11-23	1977-11-23 00:00:00	1977-11-23	581452		0	0	0		0	0	0	40390	0	49	40213314		
43546	3610	40165015	2017-06-26	2017-06-26 00:00:00	2017-06-26	2017-06-26 00:00:00	\N	38000177		0	0	0		0	0	0	239885	0	861467	40165015		
47405	3929	19006318	1952-12-01	1952-12-01 00:00:00	1952-12-15	1952-12-15 00:00:00	1952-12-15	38000177		0	0	14		0	0	0	261158	0	105078	19006318		
171383	3767	40213314	1986-04-25	1986-04-25 00:00:00	1986-04-25	1986-04-25 00:00:00	1986-04-25	581452		0	0	0		0	0	0	250377	0	49	40213314		
50904	4229	19133873	1953-10-16	1953-10-16 00:00:00	1953-10-27	1953-10-27 00:00:00	1953-10-27	38000177		0	0	11		0	0	0	280900	0	834061	19133873		
54199	4504	19078461	1992-03-07	1992-03-07 00:00:00	1992-05-06	1992-05-06 00:00:00	1992-05-06	38000177		0	0	60		0	0	0	299901	0	310965	19078461		
49233	4085	1127433	1983-06-09	1983-06-09 00:00:00	1983-06-16	1983-06-16 00:00:00	1983-06-16	38000177		0	0	7		0	0	0	271495	0	313782	1127433		
46475	3851	920300	1931-06-10	1931-06-10 00:00:00	1931-06-17	1931-06-17 00:00:00	1931-06-17	38000177		0	0	7		0	0	0	255574	0	311989	920300		
17022	1410	19059056	1970-12-24	1970-12-24 00:00:00	1971-01-07	1971-01-07 00:00:00	1971-01-07	38000177		0	0	14		0	0	0	93834	0	243670	19059056		
58671	4872	19133905	1946-11-05	1946-11-05 00:00:00	1946-11-13	1946-11-13 00:00:00	1946-11-13	38000177		0	0	8		0	0	0	323977	0	834102	19133905		
812	65	19133905	2004-11-06	2004-11-06 00:00:00	2004-11-14	2004-11-14 00:00:00	2004-11-14	38000177		0	0	8		0	0	0	4404	0	834102	19133905		
58757	4881	19006318	1952-09-18	1952-09-18 00:00:00	1952-10-02	1952-10-02 00:00:00	1952-10-02	38000177		0	0	14		0	0	0	324510	0	105078	19006318		
29898	2477	1127433	1957-06-17	1957-06-17 00:00:00	1957-07-01	1957-07-01 00:00:00	1957-07-01	38000177		0	0	14		0	0	0	164151	0	313782	1127433		
50537	4199	19133873	1939-01-25	1939-01-25 00:00:00	1939-02-02	1939-02-02 00:00:00	1939-02-02	38000177		0	0	8		0	0	0	278678	0	834061	19133873		
133597	2933	40213160	1958-10-06	1958-10-06 00:00:00	1958-10-06	1958-10-06 00:00:00	1958-10-06	581452		0	0	0		0	0	0	195606	0	10	40213160		
31888	695	40213160	1973-10-01	1973-10-01 00:00:00	1973-10-01	1973-10-01 00:00:00	1973-10-01	581452		0	0	0		0	0	0	46038	0	10	40213160		
29548	2445	40229134	1955-11-07	1955-11-07 00:00:00	1955-11-21	1955-11-21 00:00:00	1955-11-21	38000177		0	0	14		0	0	0	162236	0	1043400	40229134		
47716	3956	40229134	1944-09-12	1944-09-12 00:00:00	1944-09-19	1944-09-19 00:00:00	1944-09-19	38000177		0	0	7		0	0	0	262973	0	1043400	40229134		
31999	697	40213160	1965-12-22	1965-12-22 00:00:00	1965-12-22	1965-12-22 00:00:00	1965-12-22	581452		0	0	0		0	0	0	46131	0	10	40213160		
49416	4100	1713671	2007-08-27	2007-08-27 00:00:00	2007-09-10	2007-09-10 00:00:00	2007-09-10	38000177		0	0	14		0	0	0	272414	0	562251	1713671		
13141	1102	1713671	1997-01-21	1997-01-21 00:00:00	1997-02-04	1997-02-04 00:00:00	1997-02-04	38000177		0	0	14		0	0	0	72408	0	562251	1713671		
873	70	1124300	1983-06-27	1983-06-27 00:00:00	1983-06-27	1983-06-27 00:00:00	\N	38000177		0	0	0		0	0	0	4726	0	00781178901	45011828		
16402	1359	40229134	1962-01-22	1962-01-22 00:00:00	1962-01-29	1962-01-29 00:00:00	1962-01-29	38000177		0	0	7		0	0	0	90168	0	1043400	40229134		
24008	1976	42902245	1999-12-05	1999-12-05 00:00:00	2000-11-29	2000-11-29 00:00:00	2000-11-29	38000177		0	0	360		0	0	0	131386	0	1359133	42902245		
82229	1796	40213306	2001-06-06	2001-06-06 00:00:00	2001-06-06	2001-06-06 00:00:00	2001-06-06	581452		0	0	0		0	0	0	120421	0	43	40213306		
27018	2228	40229134	1958-12-17	1958-12-17 00:00:00	1958-12-31	1958-12-31 00:00:00	1958-12-31	38000177		0	0	14		0	0	0	148273	0	1043400	40229134		
61389	5107	1127078	1981-12-02	1981-12-02 00:00:00	1981-12-30	1981-12-30 00:00:00	1981-12-30	38000177		0	0	28		0	0	0	339350	0	282464	1127078		
14945	1249	1127433	1984-09-27	1984-09-27 00:00:00	1984-12-26	1984-12-26 00:00:00	1984-12-26	38000177		0	0	90		0	0	0	82291	0	313782	1127433		
44799	3707	19133873	1980-10-03	1980-10-03 00:00:00	1980-10-14	1980-10-14 00:00:00	1980-10-14	38000177		0	0	11		0	0	0	246435	0	834061	19133873		
38400	3176	920334	2001-01-18	2001-01-18 00:00:00	2001-01-25	2001-01-25 00:00:00	2001-01-25	38000177		0	0	7		0	0	0	211152	0	311995	920334		
15090	1259	40229134	1994-02-27	1994-02-27 00:00:00	1994-03-13	1994-03-13 00:00:00	1994-03-13	38000177		0	0	14		0	0	0	82983	0	1043400	40229134		
179502	3946	40213160	1960-06-28	1960-06-28 00:00:00	1960-06-28	1960-06-28 00:00:00	1960-06-28	581452		0	0	0		0	0	0	262316	0	10	40213160		
50228	1100	40213227	2004-11-24	2004-11-24 00:00:00	2004-11-24	2004-11-24 00:00:00	2004-11-24	581452		0	0	0		0	0	0	72289	0	113	40213227		
5840	487	1127433	2015-02-24	2015-02-24 00:00:00	2015-03-10	2015-03-10 00:00:00	2015-03-10	38000177		0	0	14		0	0	0	32530	0	313782	1127433		
53015	4406	1127433	1975-04-28	1975-04-28 00:00:00	1975-05-19	1975-05-19 00:00:00	1975-05-19	38000177		0	0	21		0	0	0	292860	0	313782	1127433		
53071	4409	46275916	1999-10-28	1999-10-28 00:00:00	1999-10-28	1999-10-28 00:00:00	1999-10-28	38000177		0	0	0		0	0	0	293129	0	1660014	46275916		
18337	1518	1127433	1968-06-03	1968-06-03 00:00:00	1968-06-24	1968-06-24 00:00:00	1968-06-24	38000177		0	0	21		0	0	0	101486	0	313782	1127433		
16199	349	40213296	2001-02-10	2001-02-10 00:00:00	2001-02-10	2001-02-10 00:00:00	2001-02-10	581452		0	0	0		0	0	0	23213	0	52	40213296		
25246	2078	1713671	1996-12-15	1996-12-15 00:00:00	1997-01-05	1997-01-05 00:00:00	1997-01-05	38000177		0	0	21		0	0	0	138429	0	562251	1713671		
21309	1752	19133905	2009-08-08	2009-08-08 00:00:00	2009-08-21	2009-08-21 00:00:00	2009-08-21	38000177		0	0	13		0	0	0	117122	0	834102	19133905		
54042	4490	19059056	1931-12-19	1931-12-19 00:00:00	1932-01-16	1932-01-16 00:00:00	1932-01-16	38000177		0	0	28		0	0	0	298882	0	243670	19059056		
28991	2396	19133873	1934-03-09	1934-03-09 00:00:00	1934-03-16	1934-03-16 00:00:00	1934-03-16	38000177		0	0	7		0	0	0	159399	0	834061	19133873		
35896	2955	1118084	2004-08-04	2004-08-04 00:00:00	2004-08-04	2004-08-04 00:00:00	\N	38000177		0	0	0		0	0	0	197222	0	00025152531	44923712		
52464	4365	1127078	1954-05-08	1954-05-08 00:00:00	1954-05-22	1954-05-22 00:00:00	1954-05-22	38000177		0	0	14		0	0	0	289526	0	282464	1127078		
13858	299	40213227	2003-12-20	2003-12-20 00:00:00	2003-12-20	2003-12-20 00:00:00	2003-12-20	581452		0	0	0		0	0	0	19990	0	113	40213227		
60116	4998	1713671	2013-09-11	2013-09-11 00:00:00	2013-09-25	2013-09-25 00:00:00	2013-09-25	38000177		0	0	14		0	0	0	332385	0	562251	1713671		
51444	4275	1118084	2018-02-17	2018-02-17 00:00:00	2018-02-17	2018-02-17 00:00:00	\N	38000177		0	0	0		0	0	0	283714	0	00025152531	44923712		
60241	5007	1118084	2019-04-07	2019-04-07 00:00:00	2019-04-07	2019-04-07 00:00:00	\N	38000177		0	0	0		0	0	0	333021	0	00025152531	44923712		
3397	280	1127433	1992-09-21	1992-09-21 00:00:00	1992-09-28	1992-09-28 00:00:00	1992-09-28	38000177		0	0	7		0	0	0	18734	0	313782	1127433		
75214	1642	40213198	2016-10-11	2016-10-11 00:00:00	2016-10-11	2016-10-11 00:00:00	2016-10-11	581452		0	0	0		0	0	0	110253	0	133	40213198		
62080	5166	1713671	1969-06-27	1969-06-27 00:00:00	1969-07-04	1969-07-04 00:00:00	1969-07-04	38000177		0	0	7		0	0	0	343406	0	562251	1713671		
24990	2056	19133873	1981-05-17	1981-05-17 00:00:00	1981-05-28	1981-05-28 00:00:00	1981-05-28	38000177		0	0	11		0	0	0	136741	0	834061	19133873		
57254	4753	19128065	1975-06-04	1975-06-04 00:00:00	1976-05-29	1976-05-29 00:00:00	1976-05-29	38000177		0	0	360		0	0	0	316494	0	749882	19128065		
11633	969	1127433	1998-11-02	1998-11-02 00:00:00	1998-11-30	1998-11-30 00:00:00	1998-11-30	38000177		0	0	28		0	0	0	64471	0	313782	1127433		
20165	1657	1127078	1953-04-24	1953-04-24 00:00:00	1953-06-23	1953-06-23 00:00:00	1953-06-23	38000177		0	0	60		0	0	0	111183	0	282464	1127078		
11718	973	1115171	1997-04-08	1997-04-08 00:00:00	1997-04-22	1997-04-22 00:00:00	1997-04-22	38000177		0	0	14		0	0	0	64806	0	849574	1115171		
143158	3145	40213296	2012-09-09	2012-09-09 00:00:00	2012-09-09	2012-09-09 00:00:00	2012-09-09	581452		0	0	0		0	0	0	209313	0	52	40213296		
19053	1572	1127433	1974-10-31	1974-10-31 00:00:00	1974-12-30	1974-12-30 00:00:00	1974-12-30	38000177		0	0	60		0	0	0	105545	0	313782	1127433		
1698	135	1127433	2016-05-15	2016-05-15 00:00:00	2016-05-22	2016-05-22 00:00:00	2016-05-22	38000177		0	0	7		0	0	0	9034	0	313782	1127433		
23357	1925	19006318	1945-06-19	1945-06-19 00:00:00	1945-07-03	1945-07-03 00:00:00	1945-07-03	38000177		0	0	14		0	0	0	128146	0	105078	19006318		
182678	4014	40213227	2009-12-06	2009-12-06 00:00:00	2009-12-06	2009-12-06 00:00:00	2009-12-06	581452		0	0	0		0	0	0	266729	0	113	40213227		
84381	1845	40213260	2012-04-25	2012-04-25 00:00:00	2012-04-25	2012-04-25 00:00:00	2012-04-25	581452		0	0	0		0	0	0	123341	0	121	40213260		
32934	2731	19078461	1977-07-01	1977-07-01 00:00:00	1977-07-15	1977-07-15 00:00:00	1977-07-15	38000177		0	0	14		0	0	0	180819	0	310965	19078461		
54956	4563	1124300	2003-07-21	2003-07-21 00:00:00	2003-07-21	2003-07-21 00:00:00	\N	38000177		0	0	0		0	0	0	304127	0	00781178901	45011828		
27941	608	40213160	1974-05-29	1974-05-29 00:00:00	1974-05-29	1974-05-29 00:00:00	1974-05-29	581452		0	0	0		0	0	0	40397	0	10	40213160		
43547	3610	1115171	2017-06-26	2017-06-26 00:00:00	2017-07-10	2017-07-10 00:00:00	2017-07-10	38000177		0	0	14		0	0	0	239885	0	849574	1115171		
47406	3929	19059056	1956-04-14	1956-04-14 00:00:00	1956-04-28	1956-04-28 00:00:00	1956-04-28	38000177		0	0	14		0	0	0	261166	0	243670	19059056		
171384	3767	40213251	1986-04-25	1986-04-25 00:00:00	1986-04-25	1986-04-25 00:00:00	1986-04-25	581452		0	0	0		0	0	0	250377	0	21	40213251		
50905	4229	19059056	1959-08-14	1959-08-14 00:00:00	1959-08-28	1959-08-28 00:00:00	1959-08-28	38000177		0	0	14		0	0	0	280950	0	243670	19059056		
54200	4504	40171902	2019-06-22	2019-06-22 00:00:00	2019-06-22	2019-06-22 00:00:00	\N	38000177		0	0	0		0	0	0	299921	0	897718	40171902		
49234	4085	1127433	1964-04-07	1964-04-07 00:00:00	1964-04-21	1964-04-21 00:00:00	1964-04-21	38000177		0	0	14		0	0	0	271441	0	313782	1127433		
46476	3851	40236824	1931-06-10	1931-06-10 00:00:00	1931-06-24	1931-06-24 00:00:00	1931-06-24	38000177		0	0	14		0	0	0	255574	0	1094107	40236824		
17023	1410	19129655	1970-12-24	1970-12-24 00:00:00	1971-01-07	1971-01-07 00:00:00	1971-01-07	38000177		0	0	14		0	0	0	93834	0	789980	19129655		
58672	4872	1127433	2005-12-21	2005-12-21 00:00:00	2006-01-04	2006-01-04 00:00:00	2006-01-04	38000177		0	0	14		0	0	0	324012	0	313782	1127433		
813	65	920334	2016-05-09	2016-05-09 00:00:00	2016-05-16	2016-05-16 00:00:00	2016-05-16	38000177		0	0	7		0	0	0	4424	0	311995	920334		
58758	4881	19059056	1952-09-18	1952-09-18 00:00:00	1952-10-02	1952-10-02 00:00:00	1952-10-02	38000177		0	0	14		0	0	0	324510	0	243670	19059056		
29899	2477	19133905	2015-01-30	2015-01-30 00:00:00	2015-02-09	2015-02-09 00:00:00	2015-02-09	38000177		0	0	10		0	0	0	164166	0	834102	19133905		
50538	4200	1713671	1976-08-03	1976-08-03 00:00:00	1976-08-17	1976-08-17 00:00:00	1976-08-17	38000177		0	0	14		0	0	0	278736	0	562251	1713671		
123740	2721	40213160	1968-02-17	1968-02-17 00:00:00	1968-02-17	1968-02-17 00:00:00	1968-02-17	581452		0	0	0		0	0	0	180332	0	10	40213160		
116934	2570	40213227	1997-02-13	1997-02-13 00:00:00	1997-02-13	1997-02-13 00:00:00	1997-02-13	581452		0	0	0		0	0	0	170251	0	113	40213227		
40007	3311	1594382	1990-03-30	1990-03-30 00:00:00	1990-03-30	1990-03-30 00:00:00	\N	38000177		0	0	0		0	0	0	219805	0	1870230	1594382		
47717	3956	19059056	1920-08-29	1920-08-29 00:00:00	1920-09-12	1920-09-12 00:00:00	1920-09-12	38000177		0	0	14		0	0	0	262971	0	243670	19059056		
32012	697	40213227	1998-12-23	1998-12-23 00:00:00	1998-12-23	1998-12-23 00:00:00	1998-12-23	581452		0	0	0		0	0	0	46146	0	113	40213227		
49417	4100	1713671	1978-05-11	1978-05-11 00:00:00	1978-05-25	1978-05-25 00:00:00	1978-05-25	38000177		0	0	14		0	0	0	272408	0	562251	1713671		
13184	1107	1713671	1952-10-20	1952-10-20 00:00:00	1952-10-27	1952-10-27 00:00:00	1952-10-27	38000177		0	0	7		0	0	0	72913	0	562251	1713671		
880	72	1127433	1985-10-04	1985-10-04 00:00:00	1985-10-18	1985-10-18 00:00:00	1985-10-18	38000177		0	0	14		0	0	0	4858	0	313782	1127433		
16403	1359	1127433	1994-05-06	1994-05-06 00:00:00	1994-05-20	1994-05-20 00:00:00	1994-05-20	38000177		0	0	14		0	0	0	90183	0	313782	1127433		
24009	1976	40224805	1996-12-16	1996-12-16 00:00:00	1997-12-11	1997-12-11 00:00:00	1997-12-11	38000177		0	0	360		0	0	0	131366	0	1000126	40224805		
82242	1796	40213160	1979-12-12	1979-12-12 00:00:00	1979-12-12	1979-12-12 00:00:00	1979-12-12	581452		0	0	0		0	0	0	120405	0	10	40213160		
27019	2228	19059056	1952-12-17	1952-12-17 00:00:00	1953-01-07	1953-01-07 00:00:00	1953-01-07	38000177		0	0	21		0	0	0	148291	0	243670	19059056		
61390	5107	1127078	1987-01-03	1987-01-03 00:00:00	1987-01-31	1987-01-31 00:00:00	1987-01-31	38000177		0	0	28		0	0	0	339351	0	282464	1127078		
14946	1249	40165015	1984-09-27	1984-09-27 00:00:00	1984-09-27	1984-09-27 00:00:00	\N	38000177		0	0	0		0	0	0	82291	0	861467	40165015		
44800	3707	1127433	1984-09-10	1984-09-10 00:00:00	1984-09-17	1984-09-17 00:00:00	1984-09-17	38000177		0	0	7		0	0	0	246459	0	313782	1127433		
38401	3176	1127433	1992-04-29	1992-04-29 00:00:00	1992-06-28	1992-06-28 00:00:00	1992-06-28	38000177		0	0	60		0	0	0	211125	0	313782	1127433		
15101	1261	1127078	1972-03-06	1972-03-06 00:00:00	1972-03-20	1972-03-20 00:00:00	1972-03-20	38000177		0	0	14		0	0	0	83215	0	282464	1127078		
22219	1826	1713671	1963-02-16	1963-02-16 00:00:00	1963-03-09	1963-03-09 00:00:00	1963-03-09	38000177		0	0	21		0	0	0	122052	0	562251	1713671		
50233	1100	40213227	2013-12-04	2013-12-04 00:00:00	2013-12-04	2013-12-04 00:00:00	2013-12-04	581452		0	0	0		0	0	0	72259	0	113	40213227		
5841	488	1127433	1962-09-21	1962-09-21 00:00:00	1962-09-28	1962-09-28 00:00:00	1962-09-28	38000177		0	0	7		0	0	0	32616	0	313782	1127433		
53016	4406	40236824	1978-02-08	1978-02-08 00:00:00	1978-02-15	1978-02-15 00:00:00	1978-02-15	38000177		0	0	7		0	0	0	292864	0	1094107	40236824		
53072	4409	40243436	1999-10-28	1999-10-28 00:00:00	1999-10-28	1999-10-28 00:00:00	1999-10-28	38000177		0	0	0		0	0	0	293129	0	1190795	40243436		
18338	1518	1127078	1959-02-23	1959-02-23 00:00:00	1959-03-09	1959-03-09 00:00:00	1959-03-09	38000177		0	0	14		0	0	0	101484	0	282464	1127078		
16204	349	40213160	1957-12-07	1957-12-07 00:00:00	1957-12-07	1957-12-07 00:00:00	1957-12-07	581452		0	0	0		0	0	0	23183	0	10	40213160		
25247	2078	1713671	1982-08-17	1982-08-17 00:00:00	1982-08-24	1982-08-24 00:00:00	1982-08-24	38000177		0	0	7		0	0	0	138427	0	562251	1713671		
21310	1752	1127433	2004-11-03	2004-11-03 00:00:00	2004-11-17	2004-11-17 00:00:00	2004-11-17	38000177		0	0	14		0	0	0	117161	0	313782	1127433		
54043	4491	19059056	1948-04-02	1948-04-02 00:00:00	1948-04-16	1948-04-16 00:00:00	1948-04-16	38000177		0	0	14		0	0	0	298978	0	243670	19059056		
28992	2396	40236824	1971-12-19	1971-12-19 00:00:00	1971-12-26	1971-12-26 00:00:00	1971-12-26	38000177		0	0	7		0	0	0	159306	0	1094107	40236824		
35897	2955	19133905	2012-07-10	2012-07-10 00:00:00	2012-07-19	2012-07-19 00:00:00	2012-07-19	38000177		0	0	9		0	0	0	197208	0	834102	19133905		
52465	4365	19133905	1993-12-09	1993-12-09 00:00:00	1993-12-20	1993-12-20 00:00:00	1993-12-20	38000177		0	0	11		0	0	0	289523	0	834102	19133905		
13859	299	40213296	2003-12-20	2003-12-20 00:00:00	2003-12-20	2003-12-20 00:00:00	2003-12-20	581452		0	0	0		0	0	0	19990	0	52	40213296		
60117	4998	40229134	1967-02-27	1967-02-27 00:00:00	1967-03-13	1967-03-13 00:00:00	1967-03-13	38000177		0	0	14		0	0	0	332326	0	1043400	40229134		
51445	4275	19133905	2008-07-29	2008-07-29 00:00:00	2008-08-08	2008-08-08 00:00:00	2008-08-08	38000177		0	0	10		0	0	0	283710	0	834102	19133905		
60242	5007	19019979	1983-06-25	1983-06-25 00:00:00	1983-07-09	1983-07-09 00:00:00	1983-07-09	38000177		0	0	14		0	0	0	333014	0	198405	19019979		
3398	280	1127433	2017-08-17	2017-08-17 00:00:00	2017-08-31	2017-08-31 00:00:00	2017-08-31	38000177		0	0	14		0	0	0	18768	0	313782	1127433		
75219	1642	40213227	2002-07-23	2002-07-23 00:00:00	2002-07-23	2002-07-23 00:00:00	2002-07-23	581452		0	0	0		0	0	0	110243	0	113	40213227		
62081	5166	19133905	2011-04-23	2011-04-23 00:00:00	2011-05-04	2011-05-04 00:00:00	2011-05-04	38000177		0	0	11		0	0	0	343465	0	834102	19133905		
24991	2056	1713671	2010-08-01	2010-08-01 00:00:00	2010-08-22	2010-08-22 00:00:00	2010-08-22	38000177		0	0	21		0	0	0	136744	0	562251	1713671		
57255	4753	1118084	2003-12-09	2003-12-09 00:00:00	2003-12-09	2003-12-09 00:00:00	\N	38000177		0	0	0		0	0	0	316517	0	00025152531	44923712		
11634	969	40220960	2014-12-07	2014-12-07 00:00:00	2014-12-07	2014-12-07 00:00:00	2014-12-07	38000177		0	0	0		0	0	0	64419	0	1804799	40220960		
20166	1657	1127433	1975-08-02	1975-08-02 00:00:00	1975-08-30	1975-08-30 00:00:00	1975-08-30	38000177		0	0	28		0	0	0	111185	0	313782	1127433		
11719	974	19059056	1971-08-05	1971-08-05 00:00:00	1971-09-09	1971-09-09 00:00:00	1971-09-09	38000177		0	0	35		0	0	0	64964	0	243670	19059056		
143165	3145	40213160	1971-05-09	1971-05-09 00:00:00	1971-05-09	1971-05-09 00:00:00	1971-05-09	581452		0	0	0		0	0	0	209305	0	10	40213160		
19054	1572	40162522	1974-10-31	1974-10-31 00:00:00	1974-10-31	1974-10-31 00:00:00	\N	38000177		0	0	0		0	0	0	105545	0	857005	40162522		
1699	135	40229134	2017-11-14	2017-11-14 00:00:00	2017-11-21	2017-11-21 00:00:00	2017-11-21	38000177		0	0	7		0	0	0	9062	0	1043400	40229134		
23358	1925	19059056	1945-06-19	1945-06-19 00:00:00	1945-07-03	1945-07-03 00:00:00	1945-07-03	38000177		0	0	14		0	0	0	128146	0	243670	19059056		
182680	4014	40213296	2009-12-06	2009-12-06 00:00:00	2009-12-06	2009-12-06 00:00:00	2009-12-06	581452		0	0	0		0	0	0	266729	0	52	40213296		
84398	1846	40213227	2012-02-02	2012-02-02 00:00:00	2012-02-02	2012-02-02 00:00:00	2012-02-02	581452		0	0	0		0	0	0	123457	0	113	40213227		
32935	2731	19059056	1960-12-08	1960-12-08 00:00:00	1960-12-22	1960-12-22 00:00:00	1960-12-22	38000177		0	0	14		0	0	0	180825	0	243670	19059056		
54957	4563	1713671	1972-08-21	1972-08-21 00:00:00	1972-09-04	1972-09-04 00:00:00	1972-09-04	38000177		0	0	14		0	0	0	304065	0	562251	1713671		
27942	608	40213160	1974-08-28	1974-08-28 00:00:00	1974-08-28	1974-08-28 00:00:00	1974-08-28	581452		0	0	0		0	0	0	40386	0	10	40213160		
43548	3610	1127433	2003-12-05	2003-12-05 00:00:00	2003-12-12	2003-12-12 00:00:00	2003-12-12	38000177		0	0	7		0	0	0	239892	0	313782	1127433		
47407	3929	1124300	1989-10-18	1989-10-18 00:00:00	1989-10-18	1989-10-18 00:00:00	\N	38000177		0	0	0		0	0	0	261161	0	00781178901	45011828		
171388	3767	40213160	1990-01-26	1990-01-26 00:00:00	1990-01-26	1990-01-26 00:00:00	1990-01-26	581452		0	0	0		0	0	0	250356	0	10	40213160		
50906	4229	19006318	1959-08-14	1959-08-14 00:00:00	1959-08-28	1959-08-28 00:00:00	1959-08-28	38000177		0	0	14		0	0	0	280950	0	105078	19006318		
54201	4504	19018935	2019-06-22	2019-06-22 00:00:00	2019-06-22	2019-06-22 00:00:00	\N	38000177		0	0	0		0	0	0	299921	0	197604	19018935		
49235	4086	1713671	1998-01-16	1998-01-16 00:00:00	1998-02-06	1998-02-06 00:00:00	1998-02-06	38000177		0	0	21		0	0	0	271596	0	562251	1713671		
46477	3851	19059056	1987-08-02	1987-08-02 00:00:00	1987-08-16	1987-08-16 00:00:00	1987-08-16	38000177		0	0	14		0	0	0	255595	0	243670	19059056		
17024	1410	1713671	2004-08-07	2004-08-07 00:00:00	2004-08-28	2004-08-28 00:00:00	2004-08-28	38000177		0	0	21		0	0	0	93896	0	562251	1713671		
58673	4872	40236824	1953-08-25	1953-08-25 00:00:00	1953-09-01	1953-09-01 00:00:00	1953-09-01	38000177		0	0	7		0	0	0	323989	0	1094107	40236824		
814	65	1713671	1991-07-03	1991-07-03 00:00:00	1991-07-10	1991-07-10 00:00:00	1991-07-10	38000177		0	0	7		0	0	0	4418	0	562251	1713671		
58759	4881	1127078	1952-05-21	1952-05-21 00:00:00	1952-06-18	1952-06-18 00:00:00	1952-06-18	38000177		0	0	28		0	0	0	324520	0	282464	1127078		
29901	2477	920334	2003-05-01	2003-05-01 00:00:00	2003-05-08	2003-05-08 00:00:00	2003-05-08	38000177		0	0	7		0	0	0	164211	0	311995	920334		
50539	4200	1127433	2009-04-15	2009-04-15 00:00:00	2009-05-13	2009-05-13 00:00:00	2009-05-13	38000177		0	0	28		0	0	0	278720	0	313782	1127433		
123747	2721	40213260	2018-04-28	2018-04-28 00:00:00	2018-04-28	2018-04-28 00:00:00	2018-04-28	581452		0	0	0		0	0	0	180316	0	121	40213260		
116974	2570	40213227	2006-10-12	2006-10-12 00:00:00	2006-10-12	2006-10-12 00:00:00	2006-10-12	581452		0	0	0		0	0	0	170262	0	113	40213227		
40031	3313	40165015	1997-06-23	1997-06-23 00:00:00	1997-06-23	1997-06-23 00:00:00	\N	38000177		0	0	0		0	0	0	219997	0	861467	40165015		
47718	3956	19059056	1924-06-18	1924-06-18 00:00:00	1924-08-17	1924-08-17 00:00:00	1924-08-17	38000177		0	0	60		0	0	0	262903	0	243670	19059056		
91397	2006	40213227	2017-05-19	2017-05-19 00:00:00	2017-05-19	2017-05-19 00:00:00	2017-05-19	581452		0	0	0		0	0	0	133557	0	113	40213227		
49418	4100	1127078	1952-03-17	1952-03-17 00:00:00	1952-04-21	1952-04-21 00:00:00	1952-04-21	38000177		0	0	35		0	0	0	272466	0	282464	1127078		
34945	762	40213296	1997-01-08	1997-01-08 00:00:00	1997-01-08	1997-01-08 00:00:00	1997-01-08	581452		0	0	0		0	0	0	50706	0	52	40213296		
881	72	1127433	1985-05-26	1985-05-26 00:00:00	1985-06-02	1985-06-02 00:00:00	1985-06-02	38000177		0	0	7		0	0	0	4835	0	313782	1127433		
16404	1359	1713671	1998-09-12	1998-09-12 00:00:00	1998-10-03	1998-10-03 00:00:00	1998-10-03	38000177		0	0	21		0	0	0	90157	0	562251	1713671		
24010	1976	19078461	1995-07-15	1995-07-15 00:00:00	1995-08-19	1995-08-19 00:00:00	1995-08-19	38000177		0	0	35		0	0	0	131373	0	310965	19078461		
82246	1796	40213160	1979-09-12	1979-09-12 00:00:00	1979-09-12	1979-09-12 00:00:00	1979-09-12	581452		0	0	0		0	0	0	120382	0	10	40213160		
27020	2228	19006318	1952-12-17	1952-12-17 00:00:00	1953-01-07	1953-01-07 00:00:00	1953-01-07	38000177		0	0	21		0	0	0	148291	0	105078	19006318		
61391	5107	1127433	1997-10-05	1997-10-05 00:00:00	1997-10-12	1997-10-12 00:00:00	1997-10-12	38000177		0	0	7		0	0	0	339320	0	313782	1127433		
14947	1249	19133873	1979-01-17	1979-01-17 00:00:00	1979-01-25	1979-01-25 00:00:00	1979-01-25	38000177		0	0	8		0	0	0	82275	0	834061	19133873		
44801	3707	1127433	2002-08-23	2002-08-23 00:00:00	2002-09-06	2002-09-06 00:00:00	2002-09-06	38000177		0	0	14		0	0	0	246462	0	313782	1127433		
38402	3176	40231925	1992-04-29	1992-04-29 00:00:00	1992-04-29	1992-04-29 00:00:00	\N	38000177		0	0	0		0	0	0	211125	0	1049221	40231925		
15102	1261	1127433	2006-11-06	2006-11-06 00:00:00	2006-11-20	2006-11-20 00:00:00	2006-11-20	38000177		0	0	14		0	0	0	83143	0	313782	1127433		
22220	1826	1713671	2016-12-11	2016-12-11 00:00:00	2016-12-18	2016-12-18 00:00:00	2016-12-18	38000177		0	0	7		0	0	0	122019	0	562251	1713671		
50239	1101	40213227	2006-07-02	2006-07-02 00:00:00	2006-07-02	2006-07-02 00:00:00	2006-07-02	581452		0	0	0		0	0	0	72304	0	113	40213227		
5842	488	19059056	1966-06-30	1966-06-30 00:00:00	1966-07-30	1966-07-30 00:00:00	1966-07-30	38000177		0	0	30		0	0	0	32697	0	243670	19059056		
53017	4406	920300	1978-02-08	1978-02-08 00:00:00	1978-02-15	1978-02-15 00:00:00	1978-02-15	38000177		0	0	7		0	0	0	292864	0	311989	920300		
53073	4409	1310034	1999-10-28	1999-10-28 00:00:00	1999-10-28	1999-10-28 00:00:00	1999-10-28	38000177		0	0	0		0	0	0	293129	0	834357	1310034		
18339	1518	19133905	1981-08-20	1981-08-20 00:00:00	1981-08-31	1981-08-31 00:00:00	1981-08-31	38000177		0	0	11		0	0	0	101494	0	834102	19133905		
16216	350	40213160	1959-12-25	1959-12-25 00:00:00	1959-12-25	1959-12-25 00:00:00	1959-12-25	581452		0	0	0		0	0	0	23315	0	10	40213160		
25248	2078	1115171	2019-01-24	2019-01-24 00:00:00	2019-03-25	2019-03-25 00:00:00	2019-03-25	38000177		0	0	60		0	0	0	138385	0	849574	1115171		
21311	1753	19128065	1983-04-16	1983-04-16 00:00:00	1984-04-10	1984-04-10 00:00:00	1984-04-10	38000177		0	0	360		0	0	0	117304	0	749882	19128065		
54044	4491	19006318	1948-04-02	1948-04-02 00:00:00	1948-04-16	1948-04-16 00:00:00	1948-04-16	38000177		0	0	14		0	0	0	298978	0	105078	19006318		
28993	2396	920300	1971-12-19	1971-12-19 00:00:00	1971-12-26	1971-12-26 00:00:00	1971-12-26	38000177		0	0	7		0	0	0	159306	0	311989	920300		
35898	2955	46275916	2017-07-25	2017-07-25 00:00:00	2017-07-25	2017-07-25 00:00:00	2017-07-25	38000177		0	0	0		0	0	0	197252	0	1660014	46275916		
52466	4365	19074679	1982-07-15	1982-07-15 00:00:00	1991-12-15	1991-12-15 00:00:00	1991-12-15	38000177		0	0	3440		0	0	0	289586	0	308971	19074679		
13863	299	40213160	1962-05-19	1962-05-19 00:00:00	1962-05-19	1962-05-19 00:00:00	1962-05-19	581452		0	0	0		0	0	0	19996	0	10	40213160		
60118	4998	1127433	1992-05-02	1992-05-02 00:00:00	1992-05-16	1992-05-16 00:00:00	1992-05-16	38000177		0	0	14		0	0	0	332382	0	313782	1127433		
51446	4275	1127433	1992-05-10	1992-05-10 00:00:00	1992-06-16	1992-06-16 00:00:00	1992-06-16	38000177		0	0	37		0	0	0	283715	0	313782	1127433		
60243	5007	19075001	1983-06-25	1983-06-25 00:00:00	1983-07-09	1983-07-09 00:00:00	1983-07-09	38000177		0	0	14		0	0	0	333014	0	309097	19075001		
3399	280	19078461	2010-10-11	2010-10-11 00:00:00	2011-01-09	2011-01-09 00:00:00	2011-01-09	38000177		0	0	90		0	0	0	18708	0	310965	19078461		
75224	1642	40213227	2012-09-18	2012-09-18 00:00:00	2012-09-18	2012-09-18 00:00:00	2012-09-18	581452		0	0	0		0	0	0	110276	0	113	40213227		
62082	5166	1127433	1998-06-03	1998-06-03 00:00:00	1998-06-17	1998-06-17 00:00:00	1998-06-17	38000177		0	0	14		0	0	0	343462	0	313782	1127433		
24992	2056	1127433	1991-12-12	1991-12-12 00:00:00	1991-12-26	1991-12-26 00:00:00	1991-12-26	38000177		0	0	14		0	0	0	136746	0	313782	1127433		
57256	4753	19128065	1978-05-19	1978-05-19 00:00:00	1979-05-14	1979-05-14 00:00:00	1979-05-14	38000177		0	0	360		0	0	0	316520	0	749882	19128065		
11635	969	19075601	2014-12-07	2014-12-07 00:00:00	2014-12-07	2014-12-07 00:00:00	2014-12-07	38000177		0	0	0		0	0	0	64419	0	309362	19075601		
20167	1657	19133873	1955-11-22	1955-11-22 00:00:00	1955-12-03	1955-12-03 00:00:00	1955-12-03	38000177		0	0	11		0	0	0	111175	0	834061	19133873		
11720	974	1127433	2014-04-08	2014-04-08 00:00:00	2014-06-07	2014-06-07 00:00:00	2014-06-07	38000177		0	0	60		0	0	0	64968	0	313782	1127433		
227943	5005	40213160	1974-03-10	1974-03-10 00:00:00	1974-03-10	1974-03-10 00:00:00	1974-03-10	581452		0	0	0		0	0	0	332938	0	10	40213160		
19055	1572	19075601	1997-06-06	1997-06-06 00:00:00	1997-06-06	1997-06-06 00:00:00	\N	38000177		0	0	0		0	0	0	105613	0	309362	19075601		
1700	135	1127433	1988-12-10	1988-12-10 00:00:00	1989-03-10	1989-03-10 00:00:00	1989-03-10	38000177		0	0	90		0	0	0	9020	0	313782	1127433		
23359	1925	1713671	1981-08-11	1981-08-11 00:00:00	1981-08-25	1981-08-25 00:00:00	1981-08-25	38000177		0	0	14		0	0	0	128131	0	562251	1713671		
182684	4014	40213227	1999-05-23	1999-05-23 00:00:00	1999-05-23	1999-05-23 00:00:00	1999-05-23	581452		0	0	0		0	0	0	266778	0	113	40213227		
209873	4602	40213160	1978-01-16	1978-01-16 00:00:00	1978-01-16	1978-01-16 00:00:00	1978-01-16	581452		0	0	0		0	0	0	306569	0	10	40213160		
32936	2731	19006318	1960-12-08	1960-12-08 00:00:00	1960-12-22	1960-12-22 00:00:00	1960-12-22	38000177		0	0	14		0	0	0	180825	0	105078	19006318		
54958	4563	40229134	1984-04-10	1984-04-10 00:00:00	1984-04-17	1984-04-17 00:00:00	1984-04-17	38000177		0	0	7		0	0	0	304096	0	1043400	40229134		
27946	608	40213314	1977-05-25	1977-05-25 00:00:00	1977-05-25	1977-05-25 00:00:00	1977-05-25	581452		0	0	0		0	0	0	40369	0	49	40213314		
43557	3612	1127433	2013-10-20	2013-10-20 00:00:00	2013-11-03	2013-11-03 00:00:00	2013-11-03	38000177		0	0	14		0	0	0	239958	0	313782	1127433		
47408	3930	1127433	1917-09-14	1917-09-14 00:00:00	1917-09-28	1917-09-28 00:00:00	1917-09-28	38000177		0	0	14		0	0	0	261262	0	313782	1127433		
171389	3767	40213251	1990-01-26	1990-01-26 00:00:00	1990-01-26	1990-01-26 00:00:00	1990-01-26	581452		0	0	0		0	0	0	250356	0	21	40213251		
50907	4229	1713671	1960-04-15	1960-04-15 00:00:00	1960-05-06	1960-05-06 00:00:00	1960-05-06	38000177		0	0	21		0	0	0	280963	0	562251	1713671		
54202	4504	40163554	2019-06-22	2019-06-22 00:00:00	2019-06-22	2019-06-22 00:00:00	\N	38000177		0	0	0		0	0	0	299921	0	855332	40163554		
49236	4086	1127078	1979-11-23	1979-11-23 00:00:00	1979-12-07	1979-12-07 00:00:00	1979-12-07	38000177		0	0	14		0	0	0	271570	0	282464	1127078		
46478	3851	1127433	1935-12-31	1935-12-31 00:00:00	1936-01-14	1936-01-14 00:00:00	1936-01-14	38000177		0	0	14		0	0	0	255509	0	313782	1127433		
17025	1410	1127433	1991-12-05	1991-12-05 00:00:00	1991-12-19	1991-12-19 00:00:00	1991-12-19	38000177		0	0	14		0	0	0	93904	0	313782	1127433		
58674	4872	920300	1953-08-25	1953-08-25 00:00:00	1953-09-01	1953-09-01 00:00:00	1953-09-01	38000177		0	0	7		0	0	0	323989	0	311989	920300		
815	65	1127433	2005-09-21	2005-09-21 00:00:00	2005-10-05	2005-10-05 00:00:00	2005-10-05	38000177		0	0	14		0	0	0	4397	0	313782	1127433		
58760	4881	19133873	1957-05-10	1957-05-10 00:00:00	1957-05-17	1957-05-17 00:00:00	1957-05-17	38000177		0	0	7		0	0	0	324536	0	834061	19133873		
29904	2477	19133873	1967-06-10	1967-06-10 00:00:00	1967-06-18	1967-06-18 00:00:00	1967-06-18	38000177		0	0	8		0	0	0	164141	0	834061	19133873		
50540	4200	40229134	1991-05-07	1991-05-07 00:00:00	1991-05-14	1991-05-14 00:00:00	1991-05-14	38000177		0	0	7		0	0	0	278728	0	1043400	40229134		
123749	2721	40213306	1990-01-13	1990-01-13 00:00:00	1990-01-13	1990-01-13 00:00:00	1990-01-13	581452		0	0	0		0	0	0	180339	0	43	40213306		
161334	3550	40213314	1985-09-28	1985-09-28 00:00:00	1985-09-28	1985-09-28 00:00:00	1985-09-28	581452		0	0	0		0	0	0	235742	0	49	40213314		
40032	3313	19078461	1997-06-23	1997-06-23 00:00:00	1997-07-14	1997-07-14 00:00:00	1997-07-14	38000177		0	0	21		0	0	0	219997	0	310965	19078461		
47719	3956	19133873	1928-07-31	1928-07-31 00:00:00	1928-08-07	1928-08-07 00:00:00	1928-08-07	38000177		0	0	7		0	0	0	262939	0	834061	19133873		
91403	2006	40213198	2011-04-15	2011-04-15 00:00:00	2011-04-15	2011-04-15 00:00:00	2011-04-15	581452		0	0	0		0	0	0	133590	0	133	40213198		
49419	4101	1127433	1973-08-17	1973-08-17 00:00:00	1973-09-14	1973-09-14 00:00:00	1973-09-14	38000177		0	0	28		0	0	0	272470	0	313782	1127433		
34952	762	40213227	1996-07-24	1996-07-24 00:00:00	1996-07-24	1996-07-24 00:00:00	1996-07-24	581452		0	0	0		0	0	0	50725	0	113	40213227		
882	72	1118084	1984-12-26	1984-12-26 00:00:00	1984-12-26	1984-12-26 00:00:00	\N	38000177		0	0	0		0	0	0	4894	0	00025152531	44923712		
16405	1359	19059056	1932-05-28	1932-05-28 00:00:00	1932-06-11	1932-06-11 00:00:00	1932-06-11	38000177		0	0	14		0	0	0	90154	0	243670	19059056		
24011	1976	1127433	2008-06-07	2008-06-07 00:00:00	2008-06-21	2008-06-21 00:00:00	2008-06-21	38000177		0	0	14		0	0	0	131391	0	313782	1127433		
82247	1796	40213314	1979-09-12	1979-09-12 00:00:00	1979-09-12	1979-09-12 00:00:00	1979-09-12	581452		0	0	0		0	0	0	120382	0	49	40213314		
27021	2228	19078461	2010-04-20	2010-04-20 00:00:00	2010-05-18	2010-05-18 00:00:00	2010-05-18	38000177		0	0	28		0	0	0	148296	0	310965	19078461		
61392	5107	1124300	2011-05-19	2011-05-19 00:00:00	2011-05-19	2011-05-19 00:00:00	\N	38000177		0	0	0		0	0	0	339336	0	00781178901	45011828		
14948	1249	1115171	2002-08-24	2002-08-24 00:00:00	2002-09-23	2002-09-23 00:00:00	2002-09-23	38000177		0	0	30		0	0	0	82292	0	849574	1115171		
44802	3708	1713671	1984-07-28	1984-07-28 00:00:00	1984-08-11	1984-08-11 00:00:00	1984-08-11	38000177		0	0	14		0	0	0	246504	0	562251	1713671		
38403	3176	19128022	1991-10-30	1991-10-30 00:00:00	1992-10-24	1992-10-24 00:00:00	1992-10-24	38000177		0	0	360		0	0	0	211101	0	749785	19128022		
22167	1821	1127433	1978-08-02	1978-08-02 00:00:00	1978-08-23	1978-08-23 00:00:00	1978-08-23	38000177		0	0	21		0	0	0	121774	0	313782	1127433		
22221	1826	19133873	1945-08-02	1945-08-02 00:00:00	1945-08-13	1945-08-13 00:00:00	1945-08-13	38000177		0	0	11		0	0	0	121997	0	834061	19133873		
50240	1101	40213160	1975-01-26	1975-01-26 00:00:00	1975-01-26	1975-01-26 00:00:00	1975-01-26	581452		0	0	0		0	0	0	72331	0	10	40213160		
5843	488	1713671	1965-05-14	1965-05-14 00:00:00	1965-05-28	1965-05-28 00:00:00	1965-05-28	38000177		0	0	14		0	0	0	32673	0	562251	1713671		
53018	4406	40236824	1976-12-25	1976-12-25 00:00:00	1977-01-08	1977-01-08 00:00:00	1977-01-08	38000177		0	0	14		0	0	0	292906	0	1094107	40236824		
53074	4409	19133873	1968-11-13	1968-11-13 00:00:00	1968-11-23	1968-11-23 00:00:00	1968-11-23	38000177		0	0	10		0	0	0	293081	0	834061	19133873		
18340	1518	1127433	1997-12-24	1997-12-24 00:00:00	1997-12-31	1997-12-31 00:00:00	1997-12-31	38000177		0	0	7		0	0	0	101514	0	313782	1127433		
16220	350	40213306	1981-09-25	1981-09-25 00:00:00	1981-09-25	1981-09-25 00:00:00	1981-09-25	581452		0	0	0		0	0	0	23275	0	43	40213306		
25249	2078	19078461	2008-05-23	2008-05-23 00:00:00	2008-06-13	2008-06-13 00:00:00	2008-06-13	38000177		0	0	21		0	0	0	138383	0	310965	19078461		
21312	1753	19128065	1986-03-31	1986-03-31 00:00:00	1987-03-26	1987-03-26 00:00:00	1987-03-26	38000177		0	0	360		0	0	0	117306	0	749882	19128065		
54045	4491	19059056	1983-04-11	1983-04-11 00:00:00	1983-04-25	1983-04-25 00:00:00	1983-04-25	38000177		0	0	14		0	0	0	299026	0	243670	19059056		
28994	2396	40165015	1971-02-08	1971-02-08 00:00:00	1971-02-08	1971-02-08 00:00:00	\N	38000177		0	0	0		0	0	0	159322	0	861467	40165015		
35899	2955	1310034	2017-07-25	2017-07-25 00:00:00	2017-07-25	2017-07-25 00:00:00	2017-07-25	38000177		0	0	0		0	0	0	197252	0	834357	1310034		
52467	4365	1127433	1958-03-18	1958-03-18 00:00:00	1958-04-01	1958-04-01 00:00:00	1958-04-01	38000177		0	0	14		0	0	0	289541	0	313782	1127433		
13869	299	40213296	2001-12-15	2001-12-15 00:00:00	2001-12-15	2001-12-15 00:00:00	2001-12-15	581452		0	0	0		0	0	0	20001	0	52	40213296		
60119	4998	19008572	1996-12-22	1996-12-22 00:00:00	1997-01-05	1997-01-05 00:00:00	1997-01-05	38000177		0	0	14		0	0	0	332376	0	106258	19008572		
51447	4275	1127433	1988-03-02	1988-03-02 00:00:00	1988-03-09	1988-03-09 00:00:00	1988-03-09	38000177		0	0	7		0	0	0	283717	0	313782	1127433		
60244	5007	1115171	2008-08-26	2008-08-26 00:00:00	2008-09-09	2008-09-09 00:00:00	2008-09-09	38000177		0	0	14		0	0	0	332998	0	849574	1115171		
3400	280	1127433	2009-01-03	2009-01-03 00:00:00	2009-01-10	2009-01-10 00:00:00	2009-01-10	38000177		0	0	7		0	0	0	18744	0	313782	1127433		
75230	1642	40213160	1955-05-03	1955-05-03 00:00:00	1955-05-03	1955-05-03 00:00:00	1955-05-03	581452		0	0	0		0	0	0	110256	0	10	40213160		
62083	5166	1127433	1958-09-06	1958-09-06 00:00:00	1958-09-20	1958-09-20 00:00:00	1958-09-20	38000177		0	0	14		0	0	0	343415	0	313782	1127433		
24993	2056	19073188	1991-12-12	1991-12-12 00:00:00	1991-12-26	1991-12-26 00:00:00	1991-12-26	38000177		0	0	14		0	0	0	136746	0	308192	19073188		
57257	4753	19133905	1985-05-14	1985-05-14 00:00:00	1985-05-23	1985-05-23 00:00:00	1985-05-23	38000177		0	0	9		0	0	0	316570	0	834102	19133905		
11636	969	19128022	1996-04-12	1996-04-12 00:00:00	1997-04-07	1997-04-07 00:00:00	1997-04-07	38000177		0	0	360		0	0	0	64439	0	749785	19128022		
20168	1657	40165015	2013-01-12	2013-01-12 00:00:00	2013-01-12	2013-01-12 00:00:00	\N	38000177		0	0	0		0	0	0	111189	0	861467	40165015		
11721	974	1127433	1976-06-14	1976-06-14 00:00:00	1976-07-05	1976-07-05 00:00:00	1976-07-05	38000177		0	0	21		0	0	0	64965	0	313782	1127433		
227948	5005	40213160	1978-06-11	1978-06-11 00:00:00	1978-06-11	1978-06-11 00:00:00	1978-06-11	581452		0	0	0		0	0	0	332918	0	10	40213160		
19056	1572	19078461	1987-09-23	1987-09-23 00:00:00	1987-10-21	1987-10-21 00:00:00	1987-10-21	38000177		0	0	28		0	0	0	105547	0	310965	19078461		
1701	135	40165015	1988-12-10	1988-12-10 00:00:00	1988-12-10	1988-12-10 00:00:00	\N	38000177		0	0	0		0	0	0	9020	0	861467	40165015		
23360	1925	1118084	1984-01-31	1984-01-31 00:00:00	1984-01-31	1984-01-31 00:00:00	\N	38000177		0	0	0		0	0	0	128131	0	00025152531	44923712		
182689	4014	40213160	1968-03-03	1968-03-03 00:00:00	1968-03-03	1968-03-03 00:00:00	1968-03-03	581452		0	0	0		0	0	0	266811	0	10	40213160		
209883	4602	40213160	1977-08-15	1977-08-15 00:00:00	1977-08-15	1977-08-15 00:00:00	1977-08-15	581452		0	0	0		0	0	0	306585	0	10	40213160		
32937	2731	1127433	1990-07-01	1990-07-01 00:00:00	1990-07-15	1990-07-15 00:00:00	1990-07-15	38000177		0	0	14		0	0	0	180823	0	313782	1127433		
54959	4563	1127433	1970-04-12	1970-04-12 00:00:00	1970-04-26	1970-04-26 00:00:00	1970-04-26	38000177		0	0	14		0	0	0	304091	0	313782	1127433		
27956	608	40213160	1974-03-27	1974-03-27 00:00:00	1974-03-27	1974-03-27 00:00:00	1974-03-27	581452		0	0	0		0	0	0	40385	0	10	40213160		
43558	3612	1127433	1995-05-15	1995-05-15 00:00:00	1995-05-22	1995-05-22 00:00:00	1995-05-22	38000177		0	0	7		0	0	0	239935	0	313782	1127433		
47409	3930	1127433	1935-02-28	1935-02-28 00:00:00	1935-03-14	1935-03-14 00:00:00	1935-03-14	38000177		0	0	14		0	0	0	261239	0	313782	1127433		
171394	3767	40213314	1985-05-24	1985-05-24 00:00:00	1985-05-24	1985-05-24 00:00:00	1985-05-24	581452		0	0	0		0	0	0	250369	0	49	40213314		
50908	4229	19059056	1967-07-08	1967-07-08 00:00:00	1967-08-05	1967-08-05 00:00:00	1967-08-05	38000177		0	0	28		0	0	0	280922	0	243670	19059056		
54203	4504	1713671	1995-07-06	1995-07-06 00:00:00	1995-07-20	1995-07-20 00:00:00	1995-07-20	38000177		0	0	14		0	0	0	299930	0	562251	1713671		
49237	4086	1127433	1986-06-04	1986-06-04 00:00:00	1986-06-18	1986-06-18 00:00:00	1986-06-18	38000177		0	0	14		0	0	0	271571	0	313782	1127433		
46479	3851	1118084	1948-10-08	1948-10-08 00:00:00	1948-10-08	1948-10-08 00:00:00	\N	38000177		0	0	0		0	0	0	255531	0	00025152531	44923712		
17026	1410	1127433	2016-12-19	2016-12-19 00:00:00	2017-01-02	2017-01-02 00:00:00	2017-01-02	38000177		0	0	14		0	0	0	93898	0	313782	1127433		
58675	4872	1713671	1953-11-05	1953-11-05 00:00:00	1953-11-12	1953-11-12 00:00:00	1953-11-12	38000177		0	0	7		0	0	0	323990	0	562251	1713671		
816	65	1127433	1996-10-25	1996-10-25 00:00:00	1996-11-08	1996-11-08 00:00:00	1996-11-08	38000177		0	0	14		0	0	0	4419	0	313782	1127433		
58761	4881	1127433	1984-11-09	1984-11-09 00:00:00	1984-12-07	1984-12-07 00:00:00	1984-12-07	38000177		0	0	28		0	0	0	324546	0	313782	1127433		
29921	2480	40229134	1996-10-28	1996-10-28 00:00:00	1996-11-11	1996-11-11 00:00:00	1996-11-11	38000177		0	0	14		0	0	0	164277	0	1043400	40229134		
50541	4200	40229134	1974-09-18	1974-09-18 00:00:00	1974-10-02	1974-10-02 00:00:00	1974-10-02	38000177		0	0	14		0	0	0	278800	0	1043400	40229134		
123752	2721	40213227	2019-05-04	2019-05-04 00:00:00	2019-05-04	2019-05-04 00:00:00	2019-05-04	581452		0	0	0		0	0	0	180324	0	113	40213227		
161335	3550	40213251	1985-09-28	1985-09-28 00:00:00	1985-09-28	1985-09-28 00:00:00	1985-09-28	581452		0	0	0		0	0	0	235742	0	21	40213251		
40033	3313	19073188	1997-06-23	1997-06-23 00:00:00	1997-07-14	1997-07-14 00:00:00	1997-07-14	38000177		0	0	21		0	0	0	219997	0	308192	19073188		
74901	1635	40213306	1995-10-18	1995-10-18 00:00:00	1995-10-18	1995-10-18 00:00:00	1995-10-18	581452		0	0	0		0	0	0	109814	0	43	40213306		
91416	2006	40213201	2012-04-20	2012-04-20 00:00:00	2012-04-20	2012-04-20 00:00:00	2012-04-20	581452		0	0	0		0	0	0	133565	0	33	40213201		
49420	4101	1127433	1978-05-24	1978-05-24 00:00:00	1978-05-31	1978-05-31 00:00:00	1978-05-31	38000177		0	0	7		0	0	0	272515	0	313782	1127433		
34953	762	40213296	1996-07-24	1996-07-24 00:00:00	1996-07-24	1996-07-24 00:00:00	1996-07-24	581452		0	0	0		0	0	0	50725	0	52	40213296		
32689	2709	40222846	2013-10-08	2013-10-08 00:00:00	2013-10-08	2013-10-08 00:00:00	\N	38000177		0	0	0		0	0	0	179528	0	996740	40222846		
16406	1359	1713671	1947-06-04	1947-06-04 00:00:00	1947-06-18	1947-06-18 00:00:00	1947-06-18	38000177		0	0	14		0	0	0	90166	0	562251	1713671		
24012	1976	1713671	2003-08-10	2003-08-10 00:00:00	2003-08-17	2003-08-17 00:00:00	2003-08-17	38000177		0	0	7		0	0	0	131407	0	562251	1713671		
82248	1796	40213314	1980-06-11	1980-06-11 00:00:00	1980-06-11	1980-06-11 00:00:00	1980-06-11	581452		0	0	0		0	0	0	120383	0	49	40213314		
3253	268	1124300	2004-01-28	2004-01-28 00:00:00	2004-01-28	2004-01-28 00:00:00	\N	38000177		0	0	0		0	0	0	17835	0	00781178901	45011828		
61393	5107	1127078	1980-07-10	1980-07-10 00:00:00	1980-07-24	1980-07-24 00:00:00	1980-07-24	38000177		0	0	14		0	0	0	339349	0	282464	1127078		
14949	1249	1115171	2019-05-02	2019-05-02 00:00:00	2019-06-06	2019-06-06 00:00:00	2019-06-06	38000177		0	0	35		0	0	0	82295	0	849574	1115171		
44803	3708	1124300	2015-06-18	2015-06-18 00:00:00	2015-06-18	2015-06-18 00:00:00	\N	38000177		0	0	0		0	0	0	246528	0	00781178901	45011828		
38404	3176	40223834	2001-12-23	2001-12-23 00:00:00	2001-12-23	2001-12-23 00:00:00	\N	38000177		0	0	0		0	0	0	211108	0	997501	40223834		
22168	1821	1124300	1982-08-12	1982-08-12 00:00:00	1982-08-12	1982-08-12 00:00:00	\N	38000177		0	0	0		0	0	0	121784	0	00781178901	45011828		
22222	1826	1127433	2004-02-27	2004-02-27 00:00:00	2004-03-05	2004-03-05 00:00:00	2004-03-05	38000177		0	0	7		0	0	0	122057	0	313782	1127433		
50241	1101	40213314	1977-09-18	1977-09-18 00:00:00	1977-09-18	1977-09-18 00:00:00	1977-09-18	581452		0	0	0		0	0	0	72307	0	49	40213314		
5844	488	1713671	2013-11-23	2013-11-23 00:00:00	2013-12-14	2013-12-14 00:00:00	2013-12-14	38000177		0	0	21		0	0	0	32652	0	562251	1713671		
53019	4406	920300	1976-12-25	1976-12-25 00:00:00	1977-01-01	1977-01-01 00:00:00	1977-01-01	38000177		0	0	7		0	0	0	292906	0	311989	920300		
53075	4409	1713671	1985-12-31	1985-12-31 00:00:00	1986-01-14	1986-01-14 00:00:00	1986-01-14	38000177		0	0	14		0	0	0	293093	0	562251	1713671		
18342	1518	1127433	1997-01-22	1997-01-22 00:00:00	1997-02-05	1997-02-05 00:00:00	1997-02-05	38000177		0	0	14		0	0	0	101530	0	313782	1127433		
16226	350	40213227	2001-11-23	2001-11-23 00:00:00	2001-11-23	2001-11-23 00:00:00	2001-11-23	581452		0	0	0		0	0	0	23308	0	113	40213227		
25250	2078	46233988	1982-07-09	1982-07-09 00:00:00	1982-07-23	1982-07-23 00:00:00	1982-07-23	38000177		0	0	14		0	0	0	138431	0	1652673	46233988		
21313	1753	19129655	1968-07-26	1968-07-26 00:00:00	1968-08-09	1968-08-09 00:00:00	1968-08-09	38000177		0	0	14		0	0	0	117209	0	789980	19129655		
54046	4491	19059056	1952-02-02	1952-02-02 00:00:00	1952-05-02	1952-05-02 00:00:00	1952-05-02	38000177		0	0	90		0	0	0	299023	0	243670	19059056		
28995	2396	1127433	1971-02-08	1971-02-08 00:00:00	1971-05-09	1971-05-09 00:00:00	1971-05-09	38000177		0	0	90		0	0	0	159322	0	313782	1127433		
35900	2955	40243436	2017-07-25	2017-07-25 00:00:00	2017-07-25	2017-07-25 00:00:00	2017-07-25	38000177		0	0	0		0	0	0	197252	0	1190795	40243436		
52468	4365	1118084	1991-05-29	1991-05-29 00:00:00	1991-05-29	1991-05-29 00:00:00	\N	38000177		0	0	0		0	0	0	289522	0	00025152531	44923712		
13871	299	40213160	1962-03-17	1962-03-17 00:00:00	1962-03-17	1962-03-17 00:00:00	1962-03-17	581452		0	0	0		0	0	0	19970	0	10	40213160		
60120	4998	19134077	1996-12-22	1996-12-22 00:00:00	1997-01-05	1997-01-05 00:00:00	1997-01-05	38000177		0	0	14		0	0	0	332376	0	835900	19134077		
51448	4275	19075601	1997-03-02	1997-03-02 00:00:00	1997-03-02	1997-03-02 00:00:00	\N	38000177		0	0	0		0	0	0	283685	0	309362	19075601		
60245	5007	19115351	1996-04-21	1996-04-21 00:00:00	1996-07-21	1996-07-21 00:00:00	1996-07-21	38000177		0	0	91		0	0	0	333030	0	563026	19115351		
3401	280	19078461	1991-02-02	1991-02-02 00:00:00	1991-04-03	1991-04-03 00:00:00	1991-04-03	38000177		0	0	60		0	0	0	18686	0	310965	19078461		
75244	1642	40213201	2017-10-17	2017-10-17 00:00:00	2017-10-17	2017-10-17 00:00:00	2017-10-17	581452		0	0	0		0	0	0	110274	0	33	40213201		
62084	5166	1713671	2010-05-29	2010-05-29 00:00:00	2010-06-05	2010-06-05 00:00:00	2010-06-05	38000177		0	0	7		0	0	0	343472	0	562251	1713671		
24994	2056	1127433	1990-09-25	1990-09-25 00:00:00	1990-10-25	1990-10-25 00:00:00	1990-10-25	38000177		0	0	30		0	0	0	136716	0	313782	1127433		
57258	4753	1127433	1965-06-17	1965-06-17 00:00:00	1965-07-01	1965-07-01 00:00:00	1965-07-01	38000177		0	0	14		0	0	0	316576	0	313782	1127433		
11637	969	19128022	1993-04-28	1993-04-28 00:00:00	1994-04-23	1994-04-23 00:00:00	1994-04-23	38000177		0	0	360		0	0	0	64465	0	749785	19128022		
20169	1657	1115171	2013-01-12	2013-01-12 00:00:00	2013-04-12	2013-04-12 00:00:00	2013-04-12	38000177		0	0	90		0	0	0	111189	0	849574	1115171		
11722	974	19059056	1956-12-21	1956-12-21 00:00:00	1957-01-04	1957-01-04 00:00:00	1957-01-04	38000177		0	0	14		0	0	0	64999	0	243670	19059056		
227951	5005	40213227	2015-12-20	2015-12-20 00:00:00	2015-12-20	2015-12-20 00:00:00	2015-12-20	581452		0	0	0		0	0	0	332956	0	113	40213227		
19057	1574	1127433	1966-07-25	1966-07-25 00:00:00	1966-08-08	1966-08-08 00:00:00	1966-08-08	38000177		0	0	14		0	0	0	105694	0	313782	1127433		
1702	135	1127433	2000-11-10	2000-11-10 00:00:00	2000-11-24	2000-11-24 00:00:00	2000-11-24	38000177		0	0	14		0	0	0	9033	0	313782	1127433		
23361	1925	1127433	1954-02-04	1954-02-04 00:00:00	1954-02-11	1954-02-11 00:00:00	1954-02-11	38000177		0	0	7		0	0	0	128171	0	313782	1127433		
34801	2872	46275916	1971-09-07	1971-09-07 00:00:00	1971-09-07	1971-09-07 00:00:00	1971-09-07	38000177		0	0	0		0	0	0	191205	0	1660014	46275916		
209884	4602	40213314	1977-08-15	1977-08-15 00:00:00	1977-08-15	1977-08-15 00:00:00	1977-08-15	581452		0	0	0		0	0	0	306585	0	49	40213314		
32938	2731	19059056	1975-07-14	1975-07-14 00:00:00	1975-08-11	1975-08-11 00:00:00	1975-08-11	38000177		0	0	28		0	0	0	180818	0	243670	19059056		
54960	4563	1127433	1976-06-27	1976-06-27 00:00:00	1976-07-11	1976-07-11 00:00:00	1976-07-11	38000177		0	0	14		0	0	0	304113	0	313782	1127433		
27959	608	40213227	1996-07-17	1996-07-17 00:00:00	1996-07-17	1996-07-17 00:00:00	1996-07-17	581452		0	0	0		0	0	0	40355	0	113	40213227		
43559	3612	19133873	1967-07-12	1967-07-12 00:00:00	1967-07-22	1967-07-22 00:00:00	1967-07-22	38000177		0	0	10		0	0	0	239933	0	834061	19133873		
47410	3930	19133873	1927-10-05	1927-10-05 00:00:00	1927-10-18	1927-10-18 00:00:00	1927-10-18	38000177		0	0	13		0	0	0	261229	0	834061	19133873		
171395	3767	40213160	1985-05-24	1985-05-24 00:00:00	1985-05-24	1985-05-24 00:00:00	1985-05-24	581452		0	0	0		0	0	0	250369	0	10	40213160		
50909	4229	1127433	1996-03-10	1996-03-10 00:00:00	1996-03-17	1996-03-17 00:00:00	1996-03-17	38000177		0	0	7		0	0	0	280947	0	313782	1127433		
54204	4504	1118084	2010-12-23	2010-12-23 00:00:00	2010-12-23	2010-12-23 00:00:00	\N	38000177		0	0	0		0	0	0	299939	0	00025152531	44923712		
49238	4086	19078461	2006-06-20	2006-06-20 00:00:00	2006-09-18	2006-09-18 00:00:00	2006-09-18	38000177		0	0	90		0	0	0	271576	0	310965	19078461		
46480	3851	19059056	1916-12-21	1916-12-21 00:00:00	1917-01-04	1917-01-04 00:00:00	1917-01-04	38000177		0	0	14		0	0	0	255566	0	243670	19059056		
17027	1410	19128065	1991-01-26	1991-01-26 00:00:00	1992-01-21	1992-01-21 00:00:00	1992-01-21	38000177		0	0	360		0	0	0	93906	0	749882	19128065		
58676	4872	40229134	1968-03-01	1968-03-01 00:00:00	1968-03-08	1968-03-08 00:00:00	1968-03-08	38000177		0	0	7		0	0	0	324010	0	1043400	40229134		
817	65	1115171	2018-07-31	2018-07-31 00:00:00	2018-09-29	2018-09-29 00:00:00	2018-09-29	38000177		0	0	60		0	0	0	4446	0	849574	1115171		
58762	4881	1127433	1967-09-28	1967-09-28 00:00:00	1967-11-02	1967-11-02 00:00:00	1967-11-02	38000177		0	0	35		0	0	0	324521	0	313782	1127433		
29922	2480	19129655	1964-05-05	1964-05-05 00:00:00	1964-05-19	1964-05-19 00:00:00	1964-05-19	38000177		0	0	14		0	0	0	164335	0	789980	19129655		
50542	4200	46233988	1971-01-05	1971-01-05 00:00:00	1971-01-19	1971-01-19 00:00:00	1971-01-19	38000177		0	0	14		0	0	0	278832	0	1652673	46233988		
123753	2721	40213260	2019-05-04	2019-05-04 00:00:00	2019-05-04	2019-05-04 00:00:00	2019-05-04	581452		0	0	0		0	0	0	180324	0	121	40213260		
161336	3550	40213314	1984-12-29	1984-12-29 00:00:00	1984-12-29	1984-12-29 00:00:00	1984-12-29	581452		0	0	0		0	0	0	235741	0	49	40213314		
40034	3313	19059056	1976-08-28	1976-08-28 00:00:00	1976-09-11	1976-09-11 00:00:00	1976-09-11	38000177		0	0	14		0	0	0	219996	0	243670	19059056		
74903	1635	40213227	1995-10-18	1995-10-18 00:00:00	1995-10-18	1995-10-18 00:00:00	1995-10-18	581452		0	0	0		0	0	0	109814	0	113	40213227		
33074	2743	1713671	1995-11-01	1995-11-01 00:00:00	1995-11-15	1995-11-15 00:00:00	1995-11-15	38000177		0	0	14		0	0	0	181461	0	562251	1713671		
49421	4101	19115351	1960-02-27	1960-02-27 00:00:00	1960-05-07	1960-05-07 00:00:00	1960-05-07	38000177		0	0	70		0	0	0	272468	0	563026	19115351		
34957	762	40213227	2015-09-16	2015-09-16 00:00:00	2015-09-16	2015-09-16 00:00:00	2015-09-16	581452		0	0	0		0	0	0	50653	0	113	40213227		
32690	2709	40229134	1943-12-17	1943-12-17 00:00:00	1943-12-24	1943-12-24 00:00:00	1943-12-24	38000177		0	0	7		0	0	0	179440	0	1043400	40229134		
16407	1359	1118084	1971-05-14	1971-05-14 00:00:00	1971-05-14	1971-05-14 00:00:00	\N	38000177		0	0	0		0	0	0	90134	0	00025152531	44923712		
24013	1976	1124300	2017-11-01	2017-11-01 00:00:00	2017-11-01	2017-11-01 00:00:00	\N	38000177		0	0	0		0	0	0	131410	0	00781178901	45011828		
21171	1745	1127078	1980-02-09	1980-02-09 00:00:00	1980-02-23	1980-02-23 00:00:00	1980-02-23	38000177		0	0	14		0	0	0	116696	0	282464	1127078		
3254	268	19133873	1969-10-12	1969-10-12 00:00:00	1969-10-22	1969-10-22 00:00:00	1969-10-22	38000177		0	0	10		0	0	0	17832	0	834061	19133873		
61394	5107	19073183	1980-07-10	1980-07-10 00:00:00	1980-07-24	1980-07-24 00:00:00	1980-07-24	38000177		0	0	14		0	0	0	339349	0	308182	19073183		
14950	1249	1124300	2009-10-06	2009-10-06 00:00:00	2009-10-06	2009-10-06 00:00:00	\N	38000177		0	0	0		0	0	0	82307	0	00781178901	45011828		
44804	3708	40169216	1979-05-20	1979-05-20 00:00:00	1979-05-20	1979-05-20 00:00:00	\N	38000177		0	0	0		0	0	0	246469	0	895994	40169216		
38405	3176	1594382	2001-12-23	2001-12-23 00:00:00	2001-12-23	2001-12-23 00:00:00	\N	38000177		0	0	0		0	0	0	211108	0	1870230	1594382		
22169	1821	1127433	1952-12-12	1952-12-12 00:00:00	1953-01-02	1953-01-02 00:00:00	1953-01-02	38000177		0	0	21		0	0	0	121770	0	313782	1127433		
22223	1826	40229134	1999-04-13	1999-04-13 00:00:00	1999-04-20	1999-04-20 00:00:00	1999-04-20	38000177		0	0	7		0	0	0	122016	0	1043400	40229134		
50249	1101	40213314	1977-03-20	1977-03-20 00:00:00	1977-03-20	1977-03-20 00:00:00	1977-03-20	581452		0	0	0		0	0	0	72333	0	49	40213314		
5845	488	1115171	2001-10-24	2001-10-24 00:00:00	2001-11-07	2001-11-07 00:00:00	2001-11-07	38000177		0	0	14		0	0	0	32701	0	849574	1115171		
53020	4406	19075001	2004-07-06	2004-07-06 00:00:00	2004-07-20	2004-07-20 00:00:00	2004-07-20	38000177		0	0	14		0	0	0	292945	0	309097	19075001		
53076	4409	19133873	1969-06-24	1969-06-24 00:00:00	1969-07-06	1969-07-06 00:00:00	1969-07-06	38000177		0	0	12		0	0	0	293090	0	834061	19133873		
18343	1518	1713671	1975-09-16	1975-09-16 00:00:00	1975-09-30	1975-09-30 00:00:00	1975-09-30	38000177		0	0	14		0	0	0	101492	0	562251	1713671		
16227	350	40213296	2001-11-23	2001-11-23 00:00:00	2001-11-23	2001-11-23 00:00:00	2001-11-23	581452		0	0	0		0	0	0	23308	0	52	40213296		
25251	2078	19059056	1982-07-09	1982-07-09 00:00:00	1982-07-23	1982-07-23 00:00:00	1982-07-23	38000177		0	0	14		0	0	0	138431	0	243670	19059056		
21314	1753	1127078	1968-07-26	1968-07-26 00:00:00	1968-08-09	1968-08-09 00:00:00	1968-08-09	38000177		0	0	14		0	0	0	117209	0	282464	1127078		
65517	1433	40213227	1994-12-12	1994-12-12 00:00:00	1994-12-12	1994-12-12 00:00:00	1994-12-12	581452		0	0	0		0	0	0	95480	0	113	40213227		
28996	2396	19126352	1989-02-01	1989-02-01 00:00:00	2001-02-21	2001-02-21 00:00:00	2001-02-21	38000177		0	0	4403		0	0	0	159359	0	705129	19126352		
35901	2955	19133873	1974-08-27	1974-08-27 00:00:00	1974-09-09	1974-09-09 00:00:00	1974-09-09	38000177		0	0	13		0	0	0	197235	0	834061	19133873		
52469	4365	19115351	1983-06-27	1983-06-27 00:00:00	1983-12-18	1983-12-18 00:00:00	1983-12-18	38000177		0	0	174		0	0	0	289554	0	563026	19115351		
5819	126	40213227	2019-02-18	2019-02-18 00:00:00	2019-02-18	2019-02-18 00:00:00	2019-02-18	581452		0	0	0		0	0	0	8494	0	113	40213227		
60121	4998	1713671	1973-12-25	1973-12-25 00:00:00	1974-01-08	1974-01-08 00:00:00	1974-01-08	38000177		0	0	14		0	0	0	332328	0	562251	1713671		
51449	4276	1118084	1996-10-30	1996-10-30 00:00:00	1996-10-30	1996-10-30 00:00:00	\N	38000177		0	0	0		0	0	0	283796	0	00025152531	44923712		
60246	5007	19115351	1995-03-24	1995-03-24 00:00:00	1995-07-28	1995-07-28 00:00:00	1995-07-28	38000177		0	0	126		0	0	0	332996	0	563026	19115351		
3402	280	19078461	1976-06-24	1976-06-24 00:00:00	1976-07-22	1976-07-22 00:00:00	1976-07-22	38000177		0	0	28		0	0	0	18705	0	310965	19078461		
120258	2644	40213314	1981-04-20	1981-04-20 00:00:00	1981-04-20	1981-04-20 00:00:00	1981-04-20	581452		0	0	0		0	0	0	174967	0	49	40213314		
4857	105	40213227	1997-06-06	1997-06-06 00:00:00	1997-06-06	1997-06-06 00:00:00	1997-06-06	581452		0	0	0		0	0	0	7108	0	113	40213227		
24995	2056	1127433	1994-04-09	1994-04-09 00:00:00	1994-04-23	1994-04-23 00:00:00	1994-04-23	38000177		0	0	14		0	0	0	136709	0	313782	1127433		
57259	4753	1127078	1966-03-26	1966-03-26 00:00:00	1966-04-09	1966-04-09 00:00:00	1966-04-09	38000177		0	0	14		0	0	0	316572	0	282464	1127078		
11638	969	1127433	1988-07-15	1988-07-15 00:00:00	1988-07-29	1988-07-29 00:00:00	1988-07-29	38000177		0	0	14		0	0	0	64462	0	313782	1127433		
20170	1657	1127433	2008-01-09	2008-01-09 00:00:00	2008-03-09	2008-03-09 00:00:00	2008-03-09	38000177		0	0	60		0	0	0	111187	0	313782	1127433		
11723	974	19006318	1956-12-21	1956-12-21 00:00:00	1957-01-04	1957-01-04 00:00:00	1957-01-04	38000177		0	0	14		0	0	0	64999	0	105078	19006318		
227952	5005	40213296	2015-12-20	2015-12-20 00:00:00	2015-12-20	2015-12-20 00:00:00	2015-12-20	581452		0	0	0		0	0	0	332956	0	52	40213296		
19058	1574	19059056	1967-04-19	1967-04-19 00:00:00	1967-07-18	1967-07-18 00:00:00	1967-07-18	38000177		0	0	90		0	0	0	105632	0	243670	19059056		
1703	135	1713671	1997-06-28	1997-06-28 00:00:00	1997-07-19	1997-07-19 00:00:00	1997-07-19	38000177		0	0	21		0	0	0	9039	0	562251	1713671		
23362	1925	19059056	1971-09-22	1971-09-22 00:00:00	1971-10-06	1971-10-06 00:00:00	1971-10-06	38000177		0	0	14		0	0	0	128107	0	243670	19059056		
35299	2909	1127433	1990-07-15	1990-07-15 00:00:00	1990-07-29	1990-07-29 00:00:00	1990-07-29	38000177		0	0	14		0	0	0	193845	0	313782	1127433		
209890	4603	40213227	2002-09-12	2002-09-12 00:00:00	2002-09-12	2002-09-12 00:00:00	2002-09-12	581452		0	0	0		0	0	0	306678	0	113	40213227		
32939	2731	1127433	2012-11-20	2012-11-20 00:00:00	2012-12-04	2012-12-04 00:00:00	2012-12-04	38000177		0	0	14		0	0	0	180769	0	313782	1127433		
54961	4563	19133873	1969-05-16	1969-05-16 00:00:00	1969-05-26	1969-05-26 00:00:00	1969-05-26	38000177		0	0	10		0	0	0	304090	0	834061	19133873		
27960	608	40213306	1996-07-17	1996-07-17 00:00:00	1996-07-17	1996-07-17 00:00:00	1996-07-17	581452		0	0	0		0	0	0	40355	0	43	40213306		
43560	3612	1127433	1993-01-25	1993-01-25 00:00:00	1993-02-22	1993-02-22 00:00:00	1993-02-22	38000177		0	0	28		0	0	0	240001	0	313782	1127433		
47411	3930	19059056	1916-01-29	1916-01-29 00:00:00	1916-02-12	1916-02-12 00:00:00	1916-02-12	38000177		0	0	14		0	0	0	261243	0	243670	19059056		
134412	2950	40213201	2002-01-14	2002-01-14 00:00:00	2002-01-14	2002-01-14 00:00:00	2002-01-14	581452		0	0	0		0	0	0	196957	0	33	40213201		
50910	4229	19059056	1953-05-17	1953-05-17 00:00:00	1953-05-31	1953-05-31 00:00:00	1953-05-31	38000177		0	0	14		0	0	0	280919	0	243670	19059056		
54205	4504	1127433	2003-11-05	2003-11-05 00:00:00	2003-12-05	2003-12-05 00:00:00	2003-12-05	38000177		0	0	30		0	0	0	299902	0	313782	1127433		
49239	4086	1127433	1991-02-03	1991-02-03 00:00:00	1991-02-17	1991-02-17 00:00:00	1991-02-17	38000177		0	0	14		0	0	0	271574	0	313782	1127433		
56939	4724	1127433	2008-12-16	2008-12-16 00:00:00	2009-02-14	2009-02-14 00:00:00	2009-02-14	38000177		0	0	60		0	0	0	314861	0	313782	1127433		
17028	1410	19128065	1983-03-01	1983-03-01 00:00:00	1984-02-24	1984-02-24 00:00:00	1984-02-24	38000177		0	0	360		0	0	0	93878	0	749882	19128065		
58677	4872	1127433	2007-09-22	2007-09-22 00:00:00	2007-09-29	2007-09-29 00:00:00	2007-09-29	38000177		0	0	7		0	0	0	324057	0	313782	1127433		
818	65	1713671	1969-05-25	1969-05-25 00:00:00	1969-06-01	1969-06-01 00:00:00	1969-06-01	38000177		0	0	7		0	0	0	4394	0	562251	1713671		
58763	4881	40220960	2017-03-05	2017-03-05 00:00:00	2017-03-05	2017-03-05 00:00:00	2017-03-05	38000177		0	0	0		0	0	0	324558	0	1804799	40220960		
29923	2480	19059056	1964-05-05	1964-05-05 00:00:00	1964-05-19	1964-05-19 00:00:00	1964-05-19	38000177		0	0	14		0	0	0	164335	0	243670	19059056		
50543	4200	19059056	1971-01-05	1971-01-05 00:00:00	1971-01-19	1971-01-19 00:00:00	1971-01-19	38000177		0	0	14		0	0	0	278832	0	243670	19059056		
123755	2721	40213296	2007-11-17	2007-11-17 00:00:00	2007-11-17	2007-11-17 00:00:00	2007-11-17	581452		0	0	0		0	0	0	180345	0	52	40213296		
161337	3550	40213160	1984-12-29	1984-12-29 00:00:00	1984-12-29	1984-12-29 00:00:00	1984-12-29	581452		0	0	0		0	0	0	235741	0	10	40213160		
40035	3313	19059056	1956-12-25	1956-12-25 00:00:00	1957-01-08	1957-01-08 00:00:00	1957-01-08	38000177		0	0	14		0	0	0	219983	0	243670	19059056		
74906	1635	40213227	2004-10-27	2004-10-27 00:00:00	2004-10-27	2004-10-27 00:00:00	2004-10-27	581452		0	0	0		0	0	0	109801	0	113	40213227		
33075	2743	1127433	1989-05-02	1989-05-02 00:00:00	1989-05-16	1989-05-16 00:00:00	1989-05-16	38000177		0	0	14		0	0	0	181452	0	313782	1127433		
49422	4101	1118084	1999-06-07	1999-06-07 00:00:00	1999-06-07	1999-06-07 00:00:00	\N	38000177		0	0	0		0	0	0	272488	0	00025152531	44923712		
34961	762	40213160	1959-01-28	1959-01-28 00:00:00	1959-01-28	1959-01-28 00:00:00	1959-01-28	581452		0	0	0		0	0	0	50687	0	10	40213160		
32691	2709	40231925	2017-10-06	2017-10-06 00:00:00	2017-10-06	2017-10-06 00:00:00	\N	38000177		0	0	0		0	0	0	179451	0	1049221	40231925		
16408	1359	19133873	1945-04-17	1945-04-17 00:00:00	1945-04-24	1945-04-24 00:00:00	1945-04-24	38000177		0	0	7		0	0	0	90201	0	834061	19133873		
24014	1976	19078461	2010-07-01	2010-07-01 00:00:00	2010-07-22	2010-07-22 00:00:00	2010-07-22	38000177		0	0	21		0	0	0	131374	0	310965	19078461		
21172	1745	19127922	2004-11-09	2004-11-09 00:00:00	2005-11-04	2005-11-04 00:00:00	2005-11-04	38000177		0	0	360		0	0	0	116697	0	748962	19127922		
3255	268	19129655	1977-05-29	1977-05-29 00:00:00	1977-06-19	1977-06-19 00:00:00	1977-06-19	38000177		0	0	21		0	0	0	17797	0	789980	19129655		
61395	5107	1127433	1984-05-21	1984-05-21 00:00:00	1984-06-04	1984-06-04 00:00:00	1984-06-04	38000177		0	0	14		0	0	0	339345	0	313782	1127433		
14951	1249	1127433	2017-07-03	2017-07-03 00:00:00	2017-07-17	2017-07-17 00:00:00	2017-07-17	38000177		0	0	14		0	0	0	82299	0	313782	1127433		
44805	3708	1154615	1979-05-20	1979-05-20 00:00:00	1979-05-20	1979-05-20 00:00:00	\N	38000177		0	0	0		0	0	0	246469	0	745679	1154615		
38406	3176	19059056	1982-04-10	1982-04-10 00:00:00	1982-04-24	1982-04-24 00:00:00	1982-04-24	38000177		0	0	14		0	0	0	211122	0	243670	19059056		
22170	1821	40163554	1986-08-03	1986-08-03 00:00:00	1986-08-03	1986-08-03 00:00:00	\N	38000177		0	0	0		0	0	0	121841	0	855332	40163554		
22224	1826	1127433	1997-12-25	1997-12-25 00:00:00	1998-01-08	1998-01-08 00:00:00	1998-01-08	38000177		0	0	14		0	0	0	122067	0	313782	1127433		
50252	1101	40213160	1975-04-27	1975-04-27 00:00:00	1975-04-27	1975-04-27 00:00:00	1975-04-27	581452		0	0	0		0	0	0	72347	0	10	40213160		
5846	488	19133873	1958-10-24	1958-10-24 00:00:00	1958-11-05	1958-11-05 00:00:00	1958-11-05	38000177		0	0	12		0	0	0	32671	0	834061	19133873		
53021	4406	1127433	2004-07-06	2004-07-06 00:00:00	2004-07-20	2004-07-20 00:00:00	2004-07-20	38000177		0	0	14		0	0	0	292945	0	313782	1127433		
53077	4409	19129655	1967-07-18	1967-07-18 00:00:00	1967-08-01	1967-08-01 00:00:00	1967-08-01	38000177		0	0	14		0	0	0	293059	0	789980	19129655		
18344	1518	1713671	1992-12-04	1992-12-04 00:00:00	1992-12-11	1992-12-11 00:00:00	1992-12-11	38000177		0	0	7		0	0	0	101529	0	562251	1713671		
218766	4801	40213160	1972-01-01	1972-01-01 00:00:00	1972-01-01	1972-01-01 00:00:00	1972-01-01	581452		0	0	0		0	0	0	319408	0	10	40213160		
25252	2078	40231925	1995-08-30	1995-08-30 00:00:00	1995-08-30	1995-08-30 00:00:00	\N	38000177		0	0	0		0	0	0	138381	0	1049221	40231925		
21315	1753	19128065	1985-04-05	1985-04-05 00:00:00	1986-03-31	1986-03-31 00:00:00	1986-03-31	38000177		0	0	360		0	0	0	117305	0	749882	19128065		
65518	1433	40213160	1960-06-13	1960-06-13 00:00:00	1960-06-13	1960-06-13 00:00:00	1960-06-13	581452		0	0	0		0	0	0	95445	0	10	40213160		
28997	2396	1127433	1959-01-25	1959-01-25 00:00:00	1959-02-01	1959-02-01 00:00:00	1959-02-01	38000177		0	0	7		0	0	0	159296	0	313782	1127433		
35902	2955	1115171	2002-11-08	2002-11-08 00:00:00	2002-11-22	2002-11-22 00:00:00	2002-11-22	38000177		0	0	14		0	0	0	197251	0	849574	1115171		
52470	4365	40229134	1989-08-27	1989-08-27 00:00:00	1989-09-03	1989-09-03 00:00:00	1989-09-03	38000177		0	0	7		0	0	0	289520	0	1043400	40229134		
5824	126	40213198	2013-01-14	2013-01-14 00:00:00	2013-01-14	2013-01-14 00:00:00	2013-01-14	581452		0	0	0		0	0	0	8459	0	133	40213198		
60122	4998	19133905	1993-02-08	1993-02-08 00:00:00	1993-02-17	1993-02-17 00:00:00	1993-02-17	38000177		0	0	9		0	0	0	332406	0	834102	19133905		
51450	4276	1127433	1953-01-25	1953-01-25 00:00:00	1953-02-01	1953-02-01 00:00:00	1953-02-01	38000177		0	0	7		0	0	0	283758	0	313782	1127433		
132415	2909	40213227	1996-05-12	1996-05-12 00:00:00	1996-05-12	1996-05-12 00:00:00	1996-05-12	581452		0	0	0		0	0	0	193868	0	113	40213227		
3403	280	40162522	1962-03-10	1962-03-10 00:00:00	1962-03-10	1962-03-10 00:00:00	\N	38000177		0	0	0		0	0	0	18704	0	857005	40162522		
120262	2644	40213251	1985-01-21	1985-01-21 00:00:00	1985-01-21	1985-01-21 00:00:00	1985-01-21	581452		0	0	0		0	0	0	174970	0	21	40213251		
4861	105	40213160	1966-02-18	1966-02-18 00:00:00	1966-02-18	1966-02-18 00:00:00	1966-02-18	581452		0	0	0		0	0	0	7139	0	10	40213160		
24996	2056	1124300	2016-02-26	2016-02-26 00:00:00	2016-02-26	2016-02-26 00:00:00	\N	38000177		0	0	0		0	0	0	136753	0	00781178901	45011828		
57260	4753	19129655	1966-03-26	1966-03-26 00:00:00	1966-04-09	1966-04-09 00:00:00	1966-04-09	38000177		0	0	14		0	0	0	316572	0	789980	19129655		
11639	969	19078461	1997-09-24	1997-09-24 00:00:00	1997-10-08	1997-10-08 00:00:00	1997-10-08	38000177		0	0	14		0	0	0	64470	0	310965	19078461		
20171	1657	19059056	1944-02-27	1944-02-27 00:00:00	1944-03-12	1944-03-12 00:00:00	1944-03-12	38000177		0	0	14		0	0	0	111248	0	243670	19059056		
11725	974	920300	2001-09-03	2001-09-03 00:00:00	2001-09-10	2001-09-10 00:00:00	2001-09-10	38000177		0	0	7		0	0	0	64996	0	311989	920300		
227953	5005	40213160	1973-12-09	1973-12-09 00:00:00	1973-12-09	1973-12-09 00:00:00	1973-12-09	581452		0	0	0		0	0	0	332915	0	10	40213160		
24727	2033	40229134	1978-05-08	1978-05-08 00:00:00	1978-05-15	1978-05-15 00:00:00	1978-05-15	38000177		0	0	7		0	0	0	135316	0	1043400	40229134		
1704	135	1118084	2009-11-27	2009-11-27 00:00:00	2009-11-27	2009-11-27 00:00:00	\N	38000177		0	0	0		0	0	0	9078	0	00025152531	44923712		
23363	1925	1127433	1975-06-08	1975-06-08 00:00:00	1975-06-15	1975-06-15 00:00:00	1975-06-15	38000177		0	0	7		0	0	0	128161	0	313782	1127433		
35300	2909	40169281	1972-03-26	1972-03-26 00:00:00	1972-03-26	1972-03-26 00:00:00	\N	38000177		0	0	0		0	0	0	193851	0	896209	40169281		
179321	3942	40213251	1984-04-05	1984-04-05 00:00:00	1984-04-05	1984-04-05 00:00:00	1984-04-05	581452		0	0	0		0	0	0	262108	0	21	40213251		
32940	2731	1127433	1964-02-22	1964-02-22 00:00:00	1964-03-07	1964-03-07 00:00:00	1964-03-07	38000177		0	0	14		0	0	0	180820	0	313782	1127433		
54962	4563	1713671	2019-03-14	2019-03-14 00:00:00	2019-03-21	2019-03-21 00:00:00	2019-03-21	38000177		0	0	7		0	0	0	304095	0	562251	1713671		
27962	608	40213227	2005-07-27	2005-07-27 00:00:00	2005-07-27	2005-07-27 00:00:00	2005-07-27	581452		0	0	0		0	0	0	40358	0	113	40213227		
43561	3612	19078461	2009-02-28	2009-02-28 00:00:00	2009-03-28	2009-03-28 00:00:00	2009-03-28	38000177		0	0	28		0	0	0	240002	0	310965	19078461		
47412	3930	19059056	1945-07-13	1945-07-13 00:00:00	1945-07-27	1945-07-27 00:00:00	1945-07-27	38000177		0	0	14		0	0	0	261308	0	243670	19059056		
134416	2950	40213227	2017-07-10	2017-07-10 00:00:00	2017-07-10	2017-07-10 00:00:00	2017-07-10	581452		0	0	0		0	0	0	196968	0	113	40213227		
50911	4229	1127433	2001-07-03	2001-07-03 00:00:00	2001-07-24	2001-07-24 00:00:00	2001-07-24	38000177		0	0	21		0	0	0	280925	0	313782	1127433		
54206	4504	40231925	2003-11-05	2003-11-05 00:00:00	2003-11-05	2003-11-05 00:00:00	\N	38000177		0	0	0		0	0	0	299902	0	1049221	40231925		
49240	4086	40165015	1991-02-03	1991-02-03 00:00:00	1991-02-03	1991-02-03 00:00:00	\N	38000177		0	0	0		0	0	0	271574	0	861467	40165015		
56940	4724	40162522	2008-12-16	2008-12-16 00:00:00	2008-12-16	2008-12-16 00:00:00	\N	38000177		0	0	0		0	0	0	314861	0	857005	40162522		
17030	1410	1115171	2008-02-22	2008-02-22 00:00:00	2008-03-07	2008-03-07 00:00:00	2008-03-07	38000177		0	0	14		0	0	0	93837	0	849574	1115171		
58678	4872	1127433	1944-05-29	1944-05-29 00:00:00	1944-06-12	1944-06-12 00:00:00	1944-06-12	38000177		0	0	14		0	0	0	323976	0	313782	1127433		
819	66	19059056	1979-03-30	1979-03-30 00:00:00	1979-04-20	1979-04-20 00:00:00	1979-04-20	38000177		0	0	21		0	0	0	4448	0	243670	19059056		
58764	4881	19075601	2017-03-05	2017-03-05 00:00:00	2017-03-05	2017-03-05 00:00:00	2017-03-05	38000177		0	0	0		0	0	0	324558	0	309362	19075601		
29924	2480	1127433	2010-08-29	2010-08-29 00:00:00	2010-09-23	2010-09-23 00:00:00	2010-09-23	38000177		0	0	25		0	0	0	164320	0	313782	1127433		
50544	4200	19133873	1979-06-26	1979-06-26 00:00:00	1979-07-04	1979-07-04 00:00:00	1979-07-04	38000177		0	0	8		0	0	0	278737	0	834061	19133873		
123762	2721	40213227	2009-11-21	2009-11-21 00:00:00	2009-11-21	2009-11-21 00:00:00	2009-11-21	581452		0	0	0		0	0	0	180322	0	113	40213227		
161338	3550	40213306	2006-10-07	2006-10-07 00:00:00	2006-10-07	2006-10-07 00:00:00	2006-10-07	581452		0	0	0		0	0	0	235733	0	43	40213306		
40036	3313	19006318	1956-12-25	1956-12-25 00:00:00	1957-01-08	1957-01-08 00:00:00	1957-01-08	38000177		0	0	14		0	0	0	219983	0	105078	19006318		
74917	1635	40213314	1977-09-28	1977-09-28 00:00:00	1977-09-28	1977-09-28 00:00:00	1977-09-28	581452		0	0	0		0	0	0	109837	0	49	40213314		
33076	2743	1127433	1961-08-31	1961-08-31 00:00:00	1961-09-14	1961-09-14 00:00:00	1961-09-14	38000177		0	0	14		0	0	0	181500	0	313782	1127433		
49423	4101	19059056	1987-12-30	1987-12-30 00:00:00	1988-01-20	1988-01-20 00:00:00	1988-01-20	38000177		0	0	21		0	0	0	272524	0	243670	19059056		
34963	762	40213260	2006-07-26	2006-07-26 00:00:00	2006-07-26	2006-07-26 00:00:00	2006-07-26	581452		0	0	0		0	0	0	50708	0	121	40213260		
32692	2709	1115171	2017-10-06	2017-10-06 00:00:00	2017-12-05	2017-12-05 00:00:00	2017-12-05	38000177		0	0	60		0	0	0	179451	0	849574	1115171		
16409	1359	40163554	1987-04-14	1987-04-14 00:00:00	1987-04-14	1987-04-14 00:00:00	\N	38000177		0	0	0		0	0	0	90184	0	855332	40163554		
24015	1976	1127078	1993-05-26	1993-05-26 00:00:00	1993-06-25	1993-06-25 00:00:00	1993-06-25	38000177		0	0	30		0	0	0	131375	0	282464	1127078		
21173	1745	1127078	1984-08-16	1984-08-16 00:00:00	1984-09-13	1984-09-13 00:00:00	1984-09-13	38000177		0	0	28		0	0	0	116680	0	282464	1127078		
3256	268	19059056	1977-05-29	1977-05-29 00:00:00	1977-06-19	1977-06-19 00:00:00	1977-06-19	38000177		0	0	21		0	0	0	17797	0	243670	19059056		
61396	5107	19133905	2018-03-02	2018-03-02 00:00:00	2018-03-14	2018-03-14 00:00:00	2018-03-14	38000177		0	0	12		0	0	0	339334	0	834102	19133905		
14952	1249	964261	1988-01-20	1988-01-20 00:00:00	1988-01-20	1988-01-20 00:00:00	\N	38000177		0	0	0		0	0	0	82277	0	2001499	964261		
44806	3708	1127433	1984-07-20	1984-07-20 00:00:00	1984-07-27	1984-07-27 00:00:00	1984-07-27	38000177		0	0	7		0	0	0	246565	0	313782	1127433		
38407	3176	19128022	1989-11-09	1989-11-09 00:00:00	1990-11-04	1990-11-04 00:00:00	1990-11-04	38000177		0	0	360		0	0	0	211222	0	749785	19128022		
22171	1821	19018935	1986-08-03	1986-08-03 00:00:00	1986-08-03	1986-08-03 00:00:00	\N	38000177		0	0	0		0	0	0	121841	0	197604	19018935		
22225	1826	1127433	1964-05-04	1964-05-04 00:00:00	1964-06-03	1964-06-03 00:00:00	1964-06-03	38000177		0	0	30		0	0	0	122061	0	313782	1127433		
50256	1101	40213296	2014-08-24	2014-08-24 00:00:00	2014-08-24	2014-08-24 00:00:00	2014-08-24	581452		0	0	0		0	0	0	72314	0	52	40213296		
5847	488	1124300	1993-12-10	1993-12-10 00:00:00	1993-12-10	1993-12-10 00:00:00	\N	38000177		0	0	0		0	0	0	32645	0	00781178901	45011828		
53022	4406	1124300	1981-08-29	1981-08-29 00:00:00	1981-08-29	1981-08-29 00:00:00	\N	38000177		0	0	0		0	0	0	292939	0	00781178901	45011828		
53078	4409	19059056	1967-07-18	1967-07-18 00:00:00	1967-08-01	1967-08-01 00:00:00	1967-08-01	38000177		0	0	14		0	0	0	293059	0	243670	19059056		
18345	1518	1127433	2010-04-29	2010-04-29 00:00:00	2010-05-06	2010-05-06 00:00:00	2010-05-06	38000177		0	0	7		0	0	0	101532	0	313782	1127433		
218776	4801	40213160	1972-04-01	1972-04-01 00:00:00	1972-04-01	1972-04-01 00:00:00	1972-04-01	581452		0	0	0		0	0	0	319395	0	10	40213160		
25253	2078	19078461	1995-08-30	1995-08-30 00:00:00	1995-11-28	1995-11-28 00:00:00	1995-11-28	38000177		0	0	90		0	0	0	138381	0	310965	19078461		
21316	1753	1154615	1967-05-14	1967-05-14 00:00:00	1986-05-29	1986-05-29 00:00:00	1986-05-29	38000177		0	0	6955		0	0	0	117194	0	745679	1154615		
65523	1433	40213227	2002-01-14	2002-01-14 00:00:00	2002-01-14	2002-01-14 00:00:00	2002-01-14	581452		0	0	0		0	0	0	95482	0	113	40213227		
28998	2396	19059056	1946-01-15	1946-01-15 00:00:00	1946-01-29	1946-01-29 00:00:00	1946-01-29	38000177		0	0	14		0	0	0	159320	0	243670	19059056		
35907	2957	920300	1978-08-01	1978-08-01 00:00:00	1978-08-08	1978-08-08 00:00:00	1978-08-08	38000177		0	0	7		0	0	0	197392	0	311989	920300		
52471	4365	19133873	1960-03-23	1960-03-23 00:00:00	1960-04-05	1960-04-05 00:00:00	1960-04-05	38000177		0	0	13		0	0	0	289517	0	834061	19133873		
5831	126	40213227	2008-12-22	2008-12-22 00:00:00	2008-12-22	2008-12-22 00:00:00	2008-12-22	581452		0	0	0		0	0	0	8457	0	113	40213227		
60123	4998	19133905	2008-04-13	2008-04-13 00:00:00	2008-04-25	2008-04-25 00:00:00	2008-04-25	38000177		0	0	12		0	0	0	332407	0	834102	19133905		
51451	4276	19078461	2005-05-21	2005-05-21 00:00:00	2005-07-20	2005-07-20 00:00:00	2005-07-20	38000177		0	0	60		0	0	0	283772	0	310965	19078461		
10243	857	19059056	1954-02-20	1954-02-20 00:00:00	1954-03-06	1954-03-06 00:00:00	1954-03-06	38000177		0	0	14		0	0	0	56610	0	243670	19059056		
3404	280	19059056	1962-03-10	1962-03-10 00:00:00	1962-04-09	1962-04-09 00:00:00	1962-04-09	38000177		0	0	30		0	0	0	18704	0	243670	19059056		
120265	2644	40213160	1985-01-21	1985-01-21 00:00:00	1985-01-21	1985-01-21 00:00:00	1985-01-21	581452		0	0	0		0	0	0	174970	0	10	40213160		
21733	472	40213306	1999-10-03	1999-10-03 00:00:00	1999-10-03	1999-10-03 00:00:00	1999-10-03	581452		0	0	0		0	0	0	31511	0	43	40213306		
24997	2056	19078461	2001-04-30	2001-04-30 00:00:00	2001-05-14	2001-05-14 00:00:00	2001-05-14	38000177		0	0	14		0	0	0	136717	0	310965	19078461		
57261	4753	46275916	1987-11-18	1987-11-18 00:00:00	1987-11-18	1987-11-18 00:00:00	1987-11-18	38000177		0	0	0		0	0	0	316575	0	1660014	46275916		
11640	969	19128065	1992-05-03	1992-05-03 00:00:00	1993-04-28	1993-04-28 00:00:00	1993-04-28	38000177		0	0	360		0	0	0	64464	0	749882	19128065		
20172	1657	1310034	1998-04-22	1998-04-22 00:00:00	1998-04-22	1998-04-22 00:00:00	1998-04-22	38000177		0	0	0		0	0	0	111186	0	834357	1310034		
11726	974	40236824	2001-09-03	2001-09-03 00:00:00	2001-09-10	2001-09-10 00:00:00	2001-09-10	38000177		0	0	7		0	0	0	64996	0	1094107	40236824		
227961	5005	40213314	1977-06-05	1977-06-05 00:00:00	1977-06-05	1977-06-05 00:00:00	1977-06-05	581452		0	0	0		0	0	0	332964	0	49	40213314		
24728	2033	40229134	2004-10-17	2004-10-17 00:00:00	2004-10-31	2004-10-31 00:00:00	2004-10-31	38000177		0	0	14		0	0	0	135352	0	1043400	40229134		
1705	135	1127078	1980-01-29	1980-01-29 00:00:00	1980-02-26	1980-02-26 00:00:00	1980-02-26	38000177		0	0	28		0	0	0	9019	0	282464	1127078		
23364	1925	19006318	1946-06-26	1946-06-26 00:00:00	1946-07-10	1946-07-10 00:00:00	1946-07-10	38000177		0	0	14		0	0	0	128147	0	105078	19006318		
35301	2909	1127433	1952-03-21	1952-03-21 00:00:00	1952-03-28	1952-03-28 00:00:00	1952-03-28	38000177		0	0	7		0	0	0	193840	0	313782	1127433		
179325	3942	40213296	2018-04-26	2018-04-26 00:00:00	2018-04-26	2018-04-26 00:00:00	2018-04-26	581452		0	0	0		0	0	0	262076	0	52	40213296		
32941	2731	1127433	1969-02-21	1969-02-21 00:00:00	1969-03-07	1969-03-07 00:00:00	1969-03-07	38000177		0	0	14		0	0	0	180755	0	313782	1127433		
54963	4563	1127433	2005-01-04	2005-01-04 00:00:00	2005-02-01	2005-02-01 00:00:00	2005-02-01	38000177		0	0	28		0	0	0	304075	0	313782	1127433		
27964	608	40213227	2015-12-30	2015-12-30 00:00:00	2015-12-30	2015-12-30 00:00:00	2015-12-30	581452		0	0	0		0	0	0	40361	0	113	40213227		
43563	3612	920300	2004-01-08	2004-01-08 00:00:00	2004-01-15	2004-01-15 00:00:00	2004-01-15	38000177		0	0	7		0	0	0	239938	0	311989	920300		
47413	3930	19059056	1914-09-28	1914-09-28 00:00:00	1914-10-12	1914-10-12 00:00:00	1914-10-12	38000177		0	0	14		0	0	0	261258	0	243670	19059056		
20841	453	40213296	2010-05-28	2010-05-28 00:00:00	2010-05-28	2010-05-28 00:00:00	2010-05-28	581452		0	0	0		0	0	0	30244	0	52	40213296		
50912	4229	1127433	1974-07-29	1974-07-29 00:00:00	1974-08-19	1974-08-19 00:00:00	1974-08-19	38000177		0	0	21		0	0	0	280923	0	313782	1127433		
54207	4504	1127433	2008-08-10	2008-08-10 00:00:00	2008-08-24	2008-08-24 00:00:00	2008-08-24	38000177		0	0	14		0	0	0	299903	0	313782	1127433		
49241	4086	19075001	1991-02-03	1991-02-03 00:00:00	1991-02-17	1991-02-17 00:00:00	1991-02-17	38000177		0	0	14		0	0	0	271574	0	309097	19075001		
56941	4724	40169216	1945-05-13	1945-05-13 00:00:00	1961-03-29	1961-03-29 00:00:00	1961-03-29	38000177		0	0	5799		0	0	0	314745	0	895994	40169216		
17031	1410	19133873	1976-01-21	1976-01-21 00:00:00	1976-01-31	1976-01-31 00:00:00	1976-01-31	38000177		0	0	10		0	0	0	93902	0	834061	19133873		
58679	4872	19133905	1990-08-17	1990-08-17 00:00:00	1990-08-27	1990-08-27 00:00:00	1990-08-27	38000177		0	0	10		0	0	0	323993	0	834102	19133905		
820	66	19059056	1959-04-23	1959-04-23 00:00:00	1959-05-14	1959-05-14 00:00:00	1959-05-14	38000177		0	0	21		0	0	0	4447	0	243670	19059056		
1256	28	40213314	1981-01-07	1981-01-07 00:00:00	1981-01-07	1981-01-07 00:00:00	1981-01-07	581452		0	0	0		0	0	0	1982	0	49	40213314		
29925	2480	1127078	1957-11-06	1957-11-06 00:00:00	1957-11-20	1957-11-20 00:00:00	1957-11-20	38000177		0	0	14		0	0	0	164305	0	282464	1127078		
50545	4200	40232448	1972-07-09	1972-07-09 00:00:00	1972-07-09	1972-07-09 00:00:00	\N	38000177		0	0	0		0	0	0	278739	0	1049630	40232448		
123763	2721	40213296	2009-11-21	2009-11-21 00:00:00	2009-11-21	2009-11-21 00:00:00	2009-11-21	581452		0	0	0		0	0	0	180322	0	52	40213296		
161340	3550	40213227	2006-10-07	2006-10-07 00:00:00	2006-10-07	2006-10-07 00:00:00	2006-10-07	581452		0	0	0		0	0	0	235733	0	113	40213227		
40037	3313	1127433	1994-03-15	1994-03-15 00:00:00	1994-03-22	1994-03-22 00:00:00	1994-03-22	38000177		0	0	7		0	0	0	219981	0	313782	1127433		
74918	1635	40213160	1977-09-28	1977-09-28 00:00:00	1977-09-28	1977-09-28 00:00:00	1977-09-28	581452		0	0	0		0	0	0	109837	0	10	40213160		
33077	2743	1118084	1992-02-18	1992-02-18 00:00:00	1992-02-18	1992-02-18 00:00:00	\N	38000177		0	0	0		0	0	0	181483	0	00025152531	44923712		
49424	4101	19133905	2008-08-16	2008-08-16 00:00:00	2008-08-28	2008-08-28 00:00:00	2008-08-28	38000177		0	0	12		0	0	0	272535	0	834102	19133905		
34968	763	40213227	2007-03-29	2007-03-29 00:00:00	2007-03-29	2007-03-29 00:00:00	2007-03-29	581452		0	0	0		0	0	0	50793	0	113	40213227		
32693	2709	1127433	1970-09-22	1970-09-22 00:00:00	1970-10-13	1970-10-13 00:00:00	1970-10-13	38000177		0	0	21		0	0	0	179448	0	313782	1127433		
16410	1359	19018935	1987-04-14	1987-04-14 00:00:00	1987-04-14	1987-04-14 00:00:00	\N	38000177		0	0	0		0	0	0	90184	0	197604	19018935		
24016	1976	19112599	1986-01-09	1986-01-09 00:00:00	1986-01-09	1986-01-09 00:00:00	\N	38000177		0	0	0		0	0	0	131338	0	477045	19112599		
21174	1745	1127433	2018-03-18	2018-03-18 00:00:00	2018-03-25	2018-03-25 00:00:00	2018-03-25	38000177		0	0	7		0	0	0	116653	0	313782	1127433		
3257	268	19129655	1967-11-18	1967-11-18 00:00:00	1967-12-02	1967-12-02 00:00:00	1967-12-02	38000177		0	0	14		0	0	0	17784	0	789980	19129655		
61397	5107	1713671	2015-05-04	2015-05-04 00:00:00	2015-05-25	2015-05-25 00:00:00	2015-05-25	38000177		0	0	21		0	0	0	339321	0	562251	1713671		
14953	1250	1713671	1968-09-24	1968-09-24 00:00:00	1968-10-08	1968-10-08 00:00:00	1968-10-08	38000177		0	0	14		0	0	0	82383	0	562251	1713671		
44807	3708	1127078	1988-09-12	1988-09-12 00:00:00	1988-10-12	1988-10-12 00:00:00	1988-10-12	38000177		0	0	30		0	0	0	246508	0	282464	1127078		
38408	3176	1127078	1973-09-24	1973-09-24 00:00:00	1973-10-08	1973-10-08 00:00:00	1973-10-08	38000177		0	0	14		0	0	0	211154	0	282464	1127078		
22172	1821	40171902	1986-08-03	1986-08-03 00:00:00	1986-08-03	1986-08-03 00:00:00	\N	38000177		0	0	0		0	0	0	121841	0	897718	40171902		
22226	1826	19059056	1957-11-23	1957-11-23 00:00:00	1957-12-07	1957-12-07 00:00:00	1957-12-07	38000177		0	0	14		0	0	0	122041	0	243670	19059056		
50262	1101	40213314	1978-03-19	1978-03-19 00:00:00	1978-03-19	1978-03-19 00:00:00	1978-03-19	581452		0	0	0		0	0	0	72350	0	49	40213314		
5848	488	19059056	1977-02-02	1977-02-02 00:00:00	1977-04-03	1977-04-03 00:00:00	1977-04-03	38000177		0	0	60		0	0	0	32699	0	243670	19059056		
53024	4406	1127433	1969-11-27	1969-11-27 00:00:00	1969-12-04	1969-12-04 00:00:00	1969-12-04	38000177		0	0	7		0	0	0	292895	0	313782	1127433		
53083	4411	1713671	1980-09-22	1980-09-22 00:00:00	1980-10-13	1980-10-13 00:00:00	1980-10-13	38000177		0	0	21		0	0	0	293189	0	562251	1713671		
18346	1518	19133873	1956-10-05	1956-10-05 00:00:00	1956-10-13	1956-10-13 00:00:00	1956-10-13	38000177		0	0	8		0	0	0	101526	0	834061	19133873		
218778	4801	40213160	1971-10-30	1971-10-30 00:00:00	1971-10-30	1971-10-30 00:00:00	1971-10-30	581452		0	0	0		0	0	0	319361	0	10	40213160		
25254	2078	1127433	1994-08-07	1994-08-07 00:00:00	1994-08-14	1994-08-14 00:00:00	1994-08-14	38000177		0	0	7		0	0	0	138428	0	313782	1127433		
21317	1753	40169216	1967-05-14	1967-05-14 00:00:00	1986-05-29	1986-05-29 00:00:00	1986-05-29	38000177		0	0	6955		0	0	0	117194	0	895994	40169216		
65524	1433	40213296	2002-01-14	2002-01-14 00:00:00	2002-01-14	2002-01-14 00:00:00	2002-01-14	581452		0	0	0		0	0	0	95482	0	52	40213296		
28999	2396	19059056	1920-08-15	1920-08-15 00:00:00	1920-08-29	1920-08-29 00:00:00	1920-08-29	38000177		0	0	14		0	0	0	159299	0	243670	19059056		
35908	2957	40236824	1978-08-01	1978-08-01 00:00:00	1978-08-08	1978-08-08 00:00:00	1978-08-08	38000177		0	0	7		0	0	0	197392	0	1094107	40236824		
52473	4365	19115351	1993-09-13	1993-09-13 00:00:00	1994-03-13	1994-03-13 00:00:00	1994-03-13	38000177		0	0	181		0	0	0	289573	0	563026	19115351		
5850	126	40213160	1955-07-18	1955-07-18 00:00:00	1955-07-18	1955-07-18 00:00:00	1955-07-18	581452		0	0	0		0	0	0	8452	0	10	40213160		
60124	4998	1127078	1966-03-03	1966-03-03 00:00:00	1966-03-17	1966-03-17 00:00:00	1966-03-17	38000177		0	0	14		0	0	0	332356	0	282464	1127078		
51452	4276	1127433	2001-02-03	2001-02-03 00:00:00	2001-02-17	2001-02-17 00:00:00	2001-02-17	38000177		0	0	14		0	0	0	283763	0	313782	1127433		
10244	858	19133873	1975-02-10	1975-02-10 00:00:00	1975-02-17	1975-02-17 00:00:00	1975-02-17	38000177		0	0	7		0	0	0	56697	0	834061	19133873		
3405	280	1124300	1975-01-07	1975-01-07 00:00:00	1975-01-07	1975-01-07 00:00:00	\N	38000177		0	0	0		0	0	0	18681	0	00781178901	45011828		
120268	2644	40213314	1980-07-21	1980-07-21 00:00:00	1980-07-21	1980-07-21 00:00:00	1980-07-21	581452		0	0	0		0	0	0	174996	0	49	40213314		
21735	472	40213227	1999-10-03	1999-10-03 00:00:00	1999-10-03	1999-10-03 00:00:00	1999-10-03	581452		0	0	0		0	0	0	31511	0	113	40213227		
24998	2056	19019979	1987-12-10	1987-12-10 00:00:00	1987-12-24	1987-12-24 00:00:00	1987-12-24	38000177		0	0	14		0	0	0	136711	0	198405	19019979		
57262	4753	40243436	1987-11-18	1987-11-18 00:00:00	1987-11-18	1987-11-18 00:00:00	1987-11-18	38000177		0	0	0		0	0	0	316575	0	1190795	40243436		
11641	969	19133873	1979-05-05	1979-05-05 00:00:00	1979-05-18	1979-05-18 00:00:00	1979-05-18	38000177		0	0	13		0	0	0	64416	0	834061	19133873		
20173	1657	40243436	1998-04-22	1998-04-22 00:00:00	1998-04-22	1998-04-22 00:00:00	1998-04-22	38000177		0	0	0		0	0	0	111186	0	1190795	40243436		
11727	974	920300	1999-07-25	1999-07-25 00:00:00	1999-08-01	1999-08-01 00:00:00	1999-08-01	38000177		0	0	7		0	0	0	64995	0	311989	920300		
227964	5005	40213227	2004-07-18	2004-07-18 00:00:00	2004-07-18	2004-07-18 00:00:00	2004-07-18	581452		0	0	0		0	0	0	332944	0	113	40213227		
24729	2033	19133905	1992-09-01	1992-09-01 00:00:00	1992-09-08	1992-09-08 00:00:00	1992-09-08	38000177		0	0	7		0	0	0	135336	0	834102	19133905		
1709	137	1115171	1996-10-07	1996-10-07 00:00:00	1997-01-05	1997-01-05 00:00:00	1997-01-05	38000177		0	0	90		0	0	0	9122	0	849574	1115171		
23365	1925	19059056	1946-06-26	1946-06-26 00:00:00	1946-07-10	1946-07-10 00:00:00	1946-07-10	38000177		0	0	14		0	0	0	128147	0	243670	19059056		
35302	2909	40220386	1962-04-07	1962-04-07 00:00:00	1962-04-07	1962-04-07 00:00:00	1962-04-07	38000177		0	0	0		0	0	0	193910	0	1808217	40220386		
179328	3943	40213227	2003-02-20	2003-02-20 00:00:00	2003-02-20	2003-02-20 00:00:00	2003-02-20	581452		0	0	0		0	0	0	262201	0	113	40213227		
32942	2731	19059056	1966-02-24	1966-02-24 00:00:00	1966-03-10	1966-03-10 00:00:00	1966-03-10	38000177		0	0	14		0	0	0	180747	0	243670	19059056		
54964	4563	19128065	1978-12-04	1978-12-04 00:00:00	1979-11-29	1979-11-29 00:00:00	1979-11-29	38000177		0	0	360		0	0	0	304077	0	749882	19128065		
27965	608	40213296	2015-12-30	2015-12-30 00:00:00	2015-12-30	2015-12-30 00:00:00	2015-12-30	581452		0	0	0		0	0	0	40361	0	52	40213296		
43564	3612	40236824	2004-01-08	2004-01-08 00:00:00	2004-01-15	2004-01-15 00:00:00	2004-01-15	38000177		0	0	7		0	0	0	239938	0	1094107	40236824		
47414	3930	1713671	1956-10-30	1956-10-30 00:00:00	1956-11-20	1956-11-20 00:00:00	1956-11-20	38000177		0	0	21		0	0	0	261266	0	562251	1713671		
20842	453	40213160	1970-08-21	1970-08-21 00:00:00	1970-08-21	1970-08-21 00:00:00	1970-08-21	581452		0	0	0		0	0	0	30165	0	10	40213160		
50913	4229	1127433	1995-07-30	1995-07-30 00:00:00	1995-09-03	1995-09-03 00:00:00	1995-09-03	38000177		0	0	35		0	0	0	280924	0	313782	1127433		
54208	4504	1127433	1983-11-11	1983-11-11 00:00:00	1983-11-18	1983-11-18 00:00:00	1983-11-18	38000177		0	0	7		0	0	0	299946	0	313782	1127433		
49242	4086	1115171	1994-08-31	1994-08-31 00:00:00	1994-09-21	1994-09-21 00:00:00	1994-09-21	38000177		0	0	21		0	0	0	271575	0	849574	1115171		
56942	4724	1154615	1945-05-13	1945-05-13 00:00:00	1961-03-29	1961-03-29 00:00:00	1961-03-29	38000177		0	0	5799		0	0	0	314745	0	745679	1154615		
17032	1410	1310034	2010-03-25	2010-03-25 00:00:00	2010-03-25	2010-03-25 00:00:00	2010-03-25	38000177		0	0	0		0	0	0	93838	0	834357	1310034		
58680	4872	1118084	1955-11-07	1955-11-07 00:00:00	1955-11-07	1955-11-07 00:00:00	\N	38000177		0	0	0		0	0	0	324066	0	00025152531	44923712		
821	66	1713671	2017-05-31	2017-05-31 00:00:00	2017-06-07	2017-06-07 00:00:00	2017-06-07	38000177		0	0	7		0	0	0	4484	0	562251	1713671		
1262	28	40213251	1984-10-10	1984-10-10 00:00:00	1984-10-10	1984-10-10 00:00:00	1984-10-10	581452		0	0	0		0	0	0	1984	0	21	40213251		
29926	2480	19006318	1957-11-06	1957-11-06 00:00:00	1957-11-20	1957-11-20 00:00:00	1957-11-20	38000177		0	0	14		0	0	0	164305	0	105078	19006318		
50546	4200	40229134	2016-12-24	2016-12-24 00:00:00	2016-12-31	2016-12-31 00:00:00	2016-12-31	38000177		0	0	7		0	0	0	278750	0	1043400	40229134		
123768	2721	40213227	1999-06-26	1999-06-26 00:00:00	1999-06-26	1999-06-26 00:00:00	1999-06-26	581452		0	0	0		0	0	0	180319	0	113	40213227		
161341	3550	40213180	2006-10-07	2006-10-07 00:00:00	2006-10-07	2006-10-07 00:00:00	2006-10-07	581452		0	0	0		0	0	0	235733	0	114	40213180		
40038	3313	1127433	1978-03-31	1978-03-31 00:00:00	1978-04-07	1978-04-07 00:00:00	1978-04-07	38000177		0	0	7		0	0	0	220035	0	313782	1127433		
74923	1635	40213160	1973-01-24	1973-01-24 00:00:00	1973-01-24	1973-01-24 00:00:00	1973-01-24	581452		0	0	0		0	0	0	109805	0	10	40213160		
33078	2743	19133905	2008-03-19	2008-03-19 00:00:00	2008-03-26	2008-03-26 00:00:00	2008-03-26	38000177		0	0	7		0	0	0	181432	0	834102	19133905		
49425	4101	40236824	1983-03-21	1983-03-21 00:00:00	1983-04-04	1983-04-04 00:00:00	1983-04-04	38000177		0	0	14		0	0	0	272532	0	1094107	40236824		
34969	763	40213296	2007-03-29	2007-03-29 00:00:00	2007-03-29	2007-03-29 00:00:00	2007-03-29	581452		0	0	0		0	0	0	50793	0	52	40213296		
32694	2709	1713671	2003-04-23	2003-04-23 00:00:00	2003-05-07	2003-05-07 00:00:00	2003-05-07	38000177		0	0	14		0	0	0	179444	0	562251	1713671		
16411	1359	40171902	1987-04-14	1987-04-14 00:00:00	1987-04-14	1987-04-14 00:00:00	\N	38000177		0	0	0		0	0	0	90184	0	897718	40171902		
24017	1976	19073183	1984-05-13	1984-05-13 00:00:00	1984-05-27	1984-05-27 00:00:00	1984-05-27	38000177		0	0	14		0	0	0	131379	0	308182	19073183		
21175	1745	42902245	1998-12-11	1998-12-11 00:00:00	1999-12-06	1999-12-06 00:00:00	1999-12-06	38000177		0	0	360		0	0	0	116689	0	1359133	42902245		
3258	268	19059056	1967-11-18	1967-11-18 00:00:00	1967-12-02	1967-12-02 00:00:00	1967-12-02	38000177		0	0	14		0	0	0	17784	0	243670	19059056		
61398	5108	19059056	1967-08-20	1967-08-20 00:00:00	1967-09-17	1967-09-17 00:00:00	1967-09-17	38000177		0	0	28		0	0	0	339381	0	243670	19059056		
14954	1250	1127433	1963-11-18	1963-11-18 00:00:00	1963-11-25	1963-11-25 00:00:00	1963-11-25	38000177		0	0	7		0	0	0	82317	0	313782	1127433		
44808	3708	19128065	1996-04-13	1996-04-13 00:00:00	1997-04-08	1997-04-08 00:00:00	1997-04-08	38000177		0	0	360		0	0	0	246540	0	749882	19128065		
38409	3176	19133873	1984-02-01	1984-02-01 00:00:00	1984-02-10	1984-02-10 00:00:00	1984-02-10	38000177		0	0	9		0	0	0	211148	0	834061	19133873		
22173	1821	1127433	1939-11-22	1939-11-22 00:00:00	1939-12-06	1939-12-06 00:00:00	1939-12-06	38000177		0	0	14		0	0	0	121849	0	313782	1127433		
22227	1826	1118084	1978-05-17	1978-05-17 00:00:00	1978-05-17	1978-05-17 00:00:00	\N	38000177		0	0	0		0	0	0	122009	0	00025152531	44923712		
50266	1101	40213160	1979-03-25	1979-03-25 00:00:00	1979-03-25	1979-03-25 00:00:00	1979-03-25	581452		0	0	0		0	0	0	72308	0	10	40213160		
5849	488	40231925	1977-02-02	1977-02-02 00:00:00	1977-02-02	1977-02-02 00:00:00	\N	38000177		0	0	0		0	0	0	32699	0	1049221	40231925		
53025	4406	19059056	1942-04-21	1942-04-21 00:00:00	1942-05-05	1942-05-05 00:00:00	1942-05-05	38000177		0	0	14		0	0	0	292908	0	243670	19059056		
53084	4411	1118084	1984-01-22	1984-01-22 00:00:00	1984-01-22	1984-01-22 00:00:00	\N	38000177		0	0	0		0	0	0	293271	0	00025152531	44923712		
18347	1518	19059056	1957-03-21	1957-03-21 00:00:00	1957-04-04	1957-04-04 00:00:00	1957-04-04	38000177		0	0	14		0	0	0	101483	0	243670	19059056		
218785	4801	40213227	2013-03-16	2013-03-16 00:00:00	2013-03-16	2013-03-16 00:00:00	2013-03-16	581452		0	0	0		0	0	0	319377	0	113	40213227		
25255	2078	19075001	1983-04-13	1983-04-13 00:00:00	1983-04-27	1983-04-27 00:00:00	1983-04-27	38000177		0	0	14		0	0	0	138412	0	309097	19075001		
21318	1753	1127078	1972-05-09	1972-05-09 00:00:00	1972-05-23	1972-05-23 00:00:00	1972-05-23	38000177		0	0	14		0	0	0	117164	0	282464	1127078		
65526	1433	40213296	2000-01-10	2000-01-10 00:00:00	2000-01-10	2000-01-10 00:00:00	2000-01-10	581452		0	0	0		0	0	0	95453	0	52	40213296		
29000	2396	1545959	2001-02-21	2001-02-21 00:00:00	2001-02-21	2001-02-21 00:00:00	2001-02-21	38000177		0	0	0		0	0	0	159325	0	259255	1545959		
35909	2957	1127078	1956-10-13	1956-10-13 00:00:00	1956-11-02	1956-11-02 00:00:00	1956-11-02	38000177		0	0	20		0	0	0	197394	0	282464	1127078		
52474	4365	19115351	1986-06-30	1986-06-30 00:00:00	1986-12-28	1986-12-28 00:00:00	1986-12-28	38000177		0	0	181		0	0	0	289555	0	563026	19115351		
10127	847	19128065	1982-03-25	1982-03-25 00:00:00	1983-03-20	1983-03-20 00:00:00	1983-03-20	38000177		0	0	360		0	0	0	56123	0	749882	19128065		
60125	4999	1713671	2007-01-14	2007-01-14 00:00:00	2007-01-21	2007-01-21 00:00:00	2007-01-21	38000177		0	0	7		0	0	0	332491	0	562251	1713671		
51453	4276	1127433	1977-07-17	1977-07-17 00:00:00	1977-10-15	1977-10-15 00:00:00	1977-10-15	38000177		0	0	90		0	0	0	283771	0	313782	1127433		
10245	858	1127078	1979-11-15	1979-11-15 00:00:00	1980-01-14	1980-01-14 00:00:00	1980-01-14	38000177		0	0	60		0	0	0	56712	0	282464	1127078		
3406	280	19059056	1949-11-13	1949-11-13 00:00:00	1950-01-12	1950-01-12 00:00:00	1950-01-12	38000177		0	0	60		0	0	0	18703	0	243670	19059056		
120269	2644	40213160	1980-07-21	1980-07-21 00:00:00	1980-07-21	1980-07-21 00:00:00	1980-07-21	581452		0	0	0		0	0	0	174996	0	10	40213160		
21737	472	40213306	1996-09-29	1996-09-29 00:00:00	1996-09-29	1996-09-29 00:00:00	1996-09-29	581452		0	0	0		0	0	0	31510	0	43	40213306		
24999	2056	19074843	1987-12-10	1987-12-10 00:00:00	1987-12-24	1987-12-24 00:00:00	1987-12-24	38000177		0	0	14		0	0	0	136711	0	309045	19074843		
57263	4753	1310034	1987-11-18	1987-11-18 00:00:00	1987-11-18	1987-11-18 00:00:00	1987-11-18	38000177		0	0	0		0	0	0	316575	0	834357	1310034		
11642	969	40162522	2004-08-07	2004-08-07 00:00:00	2004-08-07	2004-08-07 00:00:00	\N	38000177		0	0	0		0	0	0	64469	0	857005	40162522		
20174	1657	46275916	1998-04-22	1998-04-22 00:00:00	1998-04-22	1998-04-22 00:00:00	1998-04-22	38000177		0	0	0		0	0	0	111186	0	1660014	46275916		
11728	974	40236824	1999-07-25	1999-07-25 00:00:00	1999-08-01	1999-08-01 00:00:00	1999-08-01	38000177		0	0	7		0	0	0	64995	0	1094107	40236824		
227966	5005	40213227	1995-09-03	1995-09-03 00:00:00	1995-09-03	1995-09-03 00:00:00	1995-09-03	581452		0	0	0		0	0	0	332924	0	113	40213227		
24730	2033	1127078	1958-03-16	1958-03-16 00:00:00	1958-03-30	1958-03-30 00:00:00	1958-03-30	38000177		0	0	14		0	0	0	135341	0	282464	1127078		
1710	137	1551192	1981-11-08	1981-11-08 00:00:00	1981-11-08	1981-11-08 00:00:00	1981-11-08	38000177		0	0	0		0	0	0	9120	0	312617	1551192		
23366	1925	19059056	1949-07-28	1949-07-28 00:00:00	1949-08-27	1949-08-27 00:00:00	1949-08-27	38000177		0	0	30		0	0	0	128081	0	243670	19059056		
35303	2909	1367571	1962-04-07	1962-04-07 00:00:00	1962-04-07	1962-04-07 00:00:00	1962-04-07	38000177		0	0	0		0	0	0	193910	0	314659	19080464		
179344	3943	40213227	2013-04-18	2013-04-18 00:00:00	2013-04-18	2013-04-18 00:00:00	2013-04-18	581452		0	0	0		0	0	0	262129	0	113	40213227		
32943	2731	46275916	2007-07-09	2007-07-09 00:00:00	2007-07-09	2007-07-09 00:00:00	2007-07-09	38000177		0	0	0		0	0	0	180794	0	1660014	46275916		
54968	4565	1127078	1955-12-13	1955-12-13 00:00:00	1955-12-27	1955-12-27 00:00:00	1955-12-27	38000177		0	0	14		0	0	0	304210	0	282464	1127078		
27972	608	40213160	1978-11-29	1978-11-29 00:00:00	1978-11-29	1978-11-29 00:00:00	1978-11-29	581452		0	0	0		0	0	0	40370	0	10	40213160		
43565	3612	1127433	1994-06-21	1994-06-21 00:00:00	1994-07-05	1994-07-05 00:00:00	1994-07-05	38000177		0	0	14		0	0	0	239972	0	313782	1127433		
47415	3930	19133873	1923-04-18	1923-04-18 00:00:00	1923-04-27	1923-04-27 00:00:00	1923-04-27	38000177		0	0	9		0	0	0	261238	0	834061	19133873		
20848	453	40213160	1975-04-25	1975-04-25 00:00:00	1975-04-25	1975-04-25 00:00:00	1975-04-25	581452		0	0	0		0	0	0	30254	0	10	40213160		
50914	4229	1127433	1963-08-10	1963-08-10 00:00:00	1963-08-24	1963-08-24 00:00:00	1963-08-24	38000177		0	0	14		0	0	0	280961	0	313782	1127433		
54209	4504	1127433	2012-03-05	2012-03-05 00:00:00	2012-03-19	2012-03-19 00:00:00	2012-03-19	38000177		0	0	14		0	0	0	299941	0	313782	1127433		
49243	4086	1127433	1987-05-14	1987-05-14 00:00:00	1987-06-04	1987-06-04 00:00:00	1987-06-04	38000177		0	0	21		0	0	0	271572	0	313782	1127433		
60439	1321	40213160	1964-06-11	1964-06-11 00:00:00	1964-06-11	1964-06-11 00:00:00	1964-06-11	581452		0	0	0		0	0	0	87625	0	10	40213160		
17033	1410	46275916	2010-03-25	2010-03-25 00:00:00	2010-03-25	2010-03-25 00:00:00	2010-03-25	38000177		0	0	0		0	0	0	93838	0	1660014	46275916		
58681	4872	1127433	1968-06-01	1968-06-01 00:00:00	1968-06-22	1968-06-22 00:00:00	1968-06-22	38000177		0	0	21		0	0	0	324090	0	313782	1127433		
822	66	1118084	1996-03-09	1996-03-09 00:00:00	1996-03-09	1996-03-09 00:00:00	\N	38000177		0	0	0		0	0	0	4503	0	00025152531	44923712		
1265	28	40213160	1984-10-10	1984-10-10 00:00:00	1984-10-10	1984-10-10 00:00:00	1984-10-10	581452		0	0	0		0	0	0	1984	0	10	40213160		
29927	2480	1118084	1991-06-16	1991-06-16 00:00:00	1991-06-16	1991-06-16 00:00:00	\N	38000177		0	0	0		0	0	0	164326	0	00025152531	44923712		
50547	4200	1118084	2006-09-23	2006-09-23 00:00:00	2006-09-23	2006-09-23 00:00:00	\N	38000177		0	0	0		0	0	0	278817	0	00025152531	44923712		
123769	2721	40213160	1968-07-20	1968-07-20 00:00:00	1968-07-20	1968-07-20 00:00:00	1968-07-20	581452		0	0	0		0	0	0	180325	0	10	40213160		
161357	3550	40213160	1984-10-27	1984-10-27 00:00:00	1984-10-27	1984-10-27 00:00:00	1984-10-27	581452		0	0	0		0	0	0	235705	0	10	40213160		
187758	4123	40213296	2003-05-04	2003-05-04 00:00:00	2003-05-04	2003-05-04 00:00:00	2003-05-04	581452		0	0	0		0	0	0	274138	0	52	40213296		
74924	1636	40213160	1956-07-20	1956-07-20 00:00:00	1956-07-20	1956-07-20 00:00:00	1956-07-20	581452		0	0	0		0	0	0	109864	0	10	40213160		
33079	2743	1127433	2004-10-24	2004-10-24 00:00:00	2004-10-31	2004-10-31 00:00:00	2004-10-31	38000177		0	0	7		0	0	0	181441	0	313782	1127433		
49426	4101	920300	1983-03-21	1983-03-21 00:00:00	1983-03-28	1983-03-28 00:00:00	1983-03-28	38000177		0	0	7		0	0	0	272532	0	311989	920300		
34971	763	40213160	1965-11-25	1965-11-25 00:00:00	1965-11-25	1965-11-25 00:00:00	1965-11-25	581452		0	0	0		0	0	0	50797	0	10	40213160		
32695	2709	19133905	1973-01-01	1973-01-01 00:00:00	1973-01-14	1973-01-14 00:00:00	1973-01-14	38000177		0	0	13		0	0	0	179462	0	834102	19133905		
16412	1359	19133905	1961-06-02	1961-06-02 00:00:00	1961-06-11	1961-06-11 00:00:00	1961-06-11	38000177		0	0	9		0	0	0	90167	0	834102	19133905		
24018	1976	19059056	1984-05-13	1984-05-13 00:00:00	1984-05-27	1984-05-27 00:00:00	1984-05-27	38000177		0	0	14		0	0	0	131379	0	243670	19059056		
21176	1745	1118084	2017-05-25	2017-05-25 00:00:00	2017-05-25	2017-05-25 00:00:00	\N	38000177		0	0	0		0	0	0	116713	0	00025152531	44923712		
3272	270	1127433	1990-06-27	1990-06-27 00:00:00	1990-07-04	1990-07-04 00:00:00	1990-07-04	38000177		0	0	7		0	0	0	17959	0	313782	1127433		
61399	5108	1127433	1962-04-19	1962-04-19 00:00:00	1962-05-04	1962-05-04 00:00:00	1962-05-04	38000177		0	0	15		0	0	0	339365	0	313782	1127433		
14955	1250	1124300	1991-08-01	1991-08-01 00:00:00	1991-08-01	1991-08-01 00:00:00	\N	38000177		0	0	0		0	0	0	82403	0	00781178901	45011828		
44809	3708	43012754	1999-03-29	1999-03-29 00:00:00	2000-03-23	2000-03-23 00:00:00	2000-03-23	38000177		0	0	360		0	0	0	246541	0	1366343	43012754		
38410	3176	40229134	1979-04-28	1979-04-28 00:00:00	1979-05-12	1979-05-12 00:00:00	1979-05-12	38000177		0	0	14		0	0	0	211084	0	1043400	40229134		
22174	1821	19133873	1950-06-09	1950-06-09 00:00:00	1950-06-19	1950-06-19 00:00:00	1950-06-19	38000177		0	0	10		0	0	0	121816	0	834061	19133873		
22228	1826	40229134	2017-02-27	2017-02-27 00:00:00	2017-03-13	2017-03-13 00:00:00	2017-03-13	38000177		0	0	14		0	0	0	122059	0	1043400	40229134		
61715	5137	1127433	2008-07-13	2008-07-13 00:00:00	2008-07-27	2008-07-27 00:00:00	2008-07-27	38000177		0	0	14		0	0	0	341412	0	313782	1127433		
5850	488	19059056	1956-06-22	1956-06-22 00:00:00	1956-07-06	1956-07-06 00:00:00	1956-07-06	38000177		0	0	14		0	0	0	32622	0	243670	19059056		
53044	4408	19078461	2019-02-23	2019-02-23 00:00:00	2019-03-09	2019-03-09 00:00:00	2019-03-09	38000177		0	0	14		0	0	0	293002	0	310965	19078461		
53085	4411	40229134	2002-07-08	2002-07-08 00:00:00	2002-07-15	2002-07-15 00:00:00	2002-07-15	38000177		0	0	7		0	0	0	293183	0	1043400	40229134		
89221	1956	40213160	1964-03-03	1964-03-03 00:00:00	1964-03-03	1964-03-03 00:00:00	1964-03-03	581452		0	0	0		0	0	0	130145	0	10	40213160		
218786	4801	40213296	2013-03-16	2013-03-16 00:00:00	2013-03-16	2013-03-16 00:00:00	2013-03-16	581452		0	0	0		0	0	0	319377	0	52	40213296		
25256	2078	19019979	1983-04-13	1983-04-13 00:00:00	1983-04-27	1983-04-27 00:00:00	1983-04-27	38000177		0	0	14		0	0	0	138412	0	198405	19019979		
21319	1753	19133905	1998-04-18	1998-04-18 00:00:00	1998-04-29	1998-04-29 00:00:00	1998-04-29	38000177		0	0	11		0	0	0	117204	0	834102	19133905		
25321	2084	40236824	2002-02-17	2002-02-17 00:00:00	2002-02-24	2002-02-24 00:00:00	2002-02-24	38000177		0	0	7		0	0	0	138879	0	1094107	40236824		
29001	2396	19133768	2001-02-21	2001-02-21 00:00:00	2001-02-21	2001-02-21 00:00:00	2001-02-21	38000177		0	0	0		0	0	0	159325	0	833036	19133768		
35910	2957	1713671	1950-09-04	1950-09-04 00:00:00	1950-09-24	1950-09-24 00:00:00	1950-09-24	38000177		0	0	20		0	0	0	197373	0	562251	1713671		
52475	4365	40220960	2016-01-10	2016-01-10 00:00:00	2016-01-10	2016-01-10 00:00:00	2016-01-10	38000177		0	0	0		0	0	0	289584	0	1804799	40220960		
10137	850	1127433	1971-03-15	1971-03-15 00:00:00	1971-03-29	1971-03-29 00:00:00	1971-03-29	38000177		0	0	14		0	0	0	56216	0	313782	1127433		
60127	4999	1127433	1988-08-31	1988-08-31 00:00:00	1988-09-07	1988-09-07 00:00:00	1988-09-07	38000177		0	0	7		0	0	0	332414	0	313782	1127433		
51454	4276	40162522	1977-07-17	1977-07-17 00:00:00	1977-07-17	1977-07-17 00:00:00	\N	38000177		0	0	0		0	0	0	283771	0	857005	40162522		
10246	858	1118084	2009-09-28	2009-09-28 00:00:00	2009-09-28	2009-09-28 00:00:00	\N	38000177		0	0	0		0	0	0	56690	0	00025152531	44923712		
3412	283	1124300	2018-10-12	2018-10-12 00:00:00	2018-10-12	2018-10-12 00:00:00	\N	38000177		0	0	0		0	0	0	18837	0	00781178901	45011828		
120272	2644	40213227	2002-04-15	2002-04-15 00:00:00	2002-04-15	2002-04-15 00:00:00	2002-04-15	581452		0	0	0		0	0	0	174978	0	113	40213227		
21741	472	40213314	1977-01-02	1977-01-02 00:00:00	1977-01-02	1977-01-02 00:00:00	1977-01-02	581452		0	0	0		0	0	0	31530	0	49	40213314		
25000	2056	19019979	1982-01-10	1982-01-10 00:00:00	1982-04-10	1982-04-10 00:00:00	1982-04-10	38000177		0	0	90		0	0	0	136715	0	198405	19019979		
57264	4753	1127433	1986-11-28	1986-11-28 00:00:00	1986-12-12	1986-12-12 00:00:00	1986-12-12	38000177		0	0	14		0	0	0	316547	0	313782	1127433		
11643	969	1127433	2004-08-07	2004-08-07 00:00:00	2004-10-06	2004-10-06 00:00:00	2004-10-06	38000177		0	0	60		0	0	0	64469	0	313782	1127433		
34349	2836	40236824	2008-11-08	2008-11-08 00:00:00	2008-11-22	2008-11-22 00:00:00	2008-11-22	38000177		0	0	14		0	0	0	188405	0	1094107	40236824		
11729	974	19115351	1956-09-30	1956-09-30 00:00:00	1957-03-03	1957-03-03 00:00:00	1957-03-03	38000177		0	0	154		0	0	0	64934	0	563026	19115351		
227967	5005	40213306	1995-09-03	1995-09-03 00:00:00	1995-09-03	1995-09-03 00:00:00	1995-09-03	581452		0	0	0		0	0	0	332924	0	43	40213306		
24731	2033	19006318	1958-03-16	1958-03-16 00:00:00	1958-03-30	1958-03-30 00:00:00	1958-03-30	38000177		0	0	14		0	0	0	135341	0	105078	19006318		
1711	137	19128065	1985-06-26	1985-06-26 00:00:00	1986-06-21	1986-06-21 00:00:00	1986-06-21	38000177		0	0	360		0	0	0	9185	0	749882	19128065		
23367	1925	19078461	2019-02-03	2019-02-03 00:00:00	2019-02-17	2019-02-17 00:00:00	2019-02-17	38000177		0	0	14		0	0	0	128178	0	310965	19078461		
35304	2909	35605482	1962-04-07	1962-04-07 00:00:00	1962-04-07	1962-04-07 00:00:00	1962-04-07	38000177		0	0	0		0	0	0	193910	0	1740467	35605482		
179347	3943	40213227	1994-02-24	1994-02-24 00:00:00	1994-02-24	1994-02-24 00:00:00	1994-02-24	581452		0	0	0		0	0	0	262146	0	113	40213227		
32944	2731	1310034	2007-07-09	2007-07-09 00:00:00	2007-07-09	2007-07-09 00:00:00	2007-07-09	38000177		0	0	0		0	0	0	180794	0	834357	1310034		
54969	4565	19059056	1962-07-14	1962-07-14 00:00:00	1962-09-19	1962-09-19 00:00:00	1962-09-19	38000177		0	0	67		0	0	0	304208	0	243670	19059056		
186727	4102	40213260	2015-03-23	2015-03-23 00:00:00	2015-03-23	2015-03-23 00:00:00	2015-03-23	581452		0	0	0		0	0	0	272551	0	121	40213260		
43566	3612	920300	2008-06-27	2008-06-27 00:00:00	2008-07-04	2008-07-04 00:00:00	2008-07-04	38000177		0	0	7		0	0	0	239987	0	311989	920300		
47416	3930	1124300	1957-11-06	1957-11-06 00:00:00	1957-11-06	1957-11-06 00:00:00	\N	38000177		0	0	0		0	0	0	261287	0	00781178901	45011828		
20855	453	40213227	2012-06-01	2012-06-01 00:00:00	2012-06-01	2012-06-01 00:00:00	2012-06-01	581452		0	0	0		0	0	0	30245	0	113	40213227		
50915	4229	1127433	1963-06-26	1963-06-26 00:00:00	1963-07-10	1963-07-10 00:00:00	1963-07-10	38000177		0	0	14		0	0	0	280960	0	313782	1127433		
54210	4504	1713671	1974-05-05	1974-05-05 00:00:00	1974-05-19	1974-05-19 00:00:00	1974-05-19	38000177		0	0	14		0	0	0	299897	0	562251	1713671		
49244	4086	19078461	1990-03-19	1990-03-19 00:00:00	1990-04-10	1990-04-10 00:00:00	1990-04-10	38000177		0	0	22		0	0	0	271573	0	310965	19078461		
60442	1321	40213227	2010-12-02	2010-12-02 00:00:00	2010-12-02	2010-12-02 00:00:00	2010-12-02	581452		0	0	0		0	0	0	87594	0	113	40213227		
17034	1410	40243436	2010-03-25	2010-03-25 00:00:00	2010-03-25	2010-03-25 00:00:00	2010-03-25	38000177		0	0	0		0	0	0	93838	0	1190795	40243436		
58682	4872	19078461	1999-07-10	1999-07-10 00:00:00	1999-07-24	1999-07-24 00:00:00	1999-07-24	38000177		0	0	14		0	0	0	324091	0	310965	19078461		
823	66	1127433	1998-04-18	1998-04-18 00:00:00	1998-05-02	1998-05-02 00:00:00	1998-05-02	38000177		0	0	14		0	0	0	4505	0	313782	1127433		
44039	3647	19059056	1941-05-28	1941-05-28 00:00:00	1941-06-11	1941-06-11 00:00:00	1941-06-11	38000177		0	0	14		0	0	0	242663	0	243670	19059056		
29928	2480	19129655	1961-03-24	1961-03-24 00:00:00	1961-04-07	1961-04-07 00:00:00	1961-04-07	38000177		0	0	14		0	0	0	164306	0	789980	19129655		
50548	4200	1713671	1970-10-15	1970-10-15 00:00:00	1970-10-29	1970-10-29 00:00:00	1970-10-29	38000177		0	0	14		0	0	0	278731	0	562251	1713671		
83196	1819	40213251	1984-05-15	1984-05-15 00:00:00	1984-05-15	1984-05-15 00:00:00	1984-05-15	581452		0	0	0		0	0	0	121695	0	21	40213251		
161358	3550	40213314	1984-10-27	1984-10-27 00:00:00	1984-10-27	1984-10-27 00:00:00	1984-10-27	581452		0	0	0		0	0	0	235705	0	49	40213314		
187760	4123	40213227	2003-05-04	2003-05-04 00:00:00	2003-05-04	2003-05-04 00:00:00	2003-05-04	581452		0	0	0		0	0	0	274138	0	113	40213227		
74931	1636	40213160	1961-01-20	1961-01-20 00:00:00	1961-01-20	1961-01-20 00:00:00	1961-01-20	581452		0	0	0		0	0	0	109867	0	10	40213160		
33080	2743	19129655	1964-02-15	1964-02-15 00:00:00	1964-02-29	1964-02-29 00:00:00	1964-02-29	38000177		0	0	14		0	0	0	181442	0	789980	19129655		
49427	4101	920334	1983-03-28	1983-03-28 00:00:00	1983-04-04	1983-04-04 00:00:00	1983-04-04	38000177		0	0	7		0	0	0	272533	0	311995	920334		
34976	763	40213227	1996-05-30	1996-05-30 00:00:00	1996-05-30	1996-05-30 00:00:00	1996-05-30	581452		0	0	0		0	0	0	50791	0	113	40213227		
32696	2709	19059056	1944-11-07	1944-11-07 00:00:00	1944-12-07	1944-12-07 00:00:00	1944-12-07	38000177		0	0	30		0	0	0	179447	0	243670	19059056		
16413	1359	19059056	1949-05-13	1949-05-13 00:00:00	1949-06-10	1949-06-10 00:00:00	1949-06-10	38000177		0	0	28		0	0	0	90155	0	243670	19059056		
24019	1976	19074843	1985-09-19	1985-09-19 00:00:00	1985-10-03	1985-10-03 00:00:00	1985-10-03	38000177		0	0	14		0	0	0	131421	0	309045	19074843		
21177	1745	19128022	2002-11-20	2002-11-20 00:00:00	2003-11-15	2003-11-15 00:00:00	2003-11-15	38000177		0	0	360		0	0	0	116692	0	749785	19128022		
3273	270	1713671	1995-10-02	1995-10-02 00:00:00	1995-10-09	1995-10-09 00:00:00	1995-10-09	38000177		0	0	7		0	0	0	17954	0	562251	1713671		
61400	5108	19078461	1974-03-14	1974-03-14 00:00:00	1974-04-13	1974-04-13 00:00:00	1974-04-13	38000177		0	0	30		0	0	0	339382	0	310965	19078461		
14956	1250	1127433	1985-05-09	1985-05-09 00:00:00	1985-05-23	1985-05-23 00:00:00	1985-05-23	38000177		0	0	14		0	0	0	82335	0	313782	1127433		
44810	3708	40229134	1979-03-06	1979-03-06 00:00:00	1979-03-20	1979-03-20 00:00:00	1979-03-20	38000177		0	0	14		0	0	0	246564	0	1043400	40229134		
38411	3176	19008572	2001-12-09	2001-12-09 00:00:00	2001-12-09	2001-12-09 00:00:00	\N	38000177		0	0	0		0	0	0	211153	0	106258	19008572		
22175	1821	1127433	1960-08-18	1960-08-18 00:00:00	1960-09-01	1960-09-01 00:00:00	1960-09-01	38000177		0	0	14		0	0	0	121807	0	313782	1127433		
22229	1826	40162522	1956-10-29	1956-10-29 00:00:00	1956-10-29	1956-10-29 00:00:00	\N	38000177		0	0	0		0	0	0	122040	0	857005	40162522		
61716	5137	1127433	1987-06-06	1987-06-06 00:00:00	1987-06-27	1987-06-27 00:00:00	1987-06-27	38000177		0	0	21		0	0	0	341355	0	313782	1127433		
5851	488	19006318	1956-06-22	1956-06-22 00:00:00	1956-07-06	1956-07-06 00:00:00	1956-07-06	38000177		0	0	14		0	0	0	32622	0	105078	19006318		
53045	4408	1127078	1982-05-17	1982-05-17 00:00:00	1982-05-31	1982-05-31 00:00:00	1982-05-31	38000177		0	0	14		0	0	0	293018	0	282464	1127078		
53087	4411	1127433	1951-04-24	1951-04-24 00:00:00	1951-05-01	1951-05-01 00:00:00	1951-05-01	38000177		0	0	7		0	0	0	293227	0	313782	1127433		
89228	1956	40213306	1986-06-17	1986-06-17 00:00:00	1986-06-17	1986-06-17 00:00:00	1986-06-17	581452		0	0	0		0	0	0	130188	0	43	40213306		
218790	4802	40213160	1969-08-24	1969-08-24 00:00:00	1969-08-24	1969-08-24 00:00:00	1969-08-24	581452		0	0	0		0	0	0	319445	0	10	40213160		
25257	2078	1118084	2017-07-25	2017-07-25 00:00:00	2017-07-25	2017-07-25 00:00:00	\N	38000177		0	0	0		0	0	0	138410	0	00025152531	44923712		
21320	1753	1713671	1999-09-07	1999-09-07 00:00:00	1999-09-28	1999-09-28 00:00:00	1999-09-28	38000177		0	0	21		0	0	0	117205	0	562251	1713671		
25322	2084	920300	2002-02-17	2002-02-17 00:00:00	2002-02-24	2002-02-24 00:00:00	2002-02-24	38000177		0	0	7		0	0	0	138879	0	311989	920300		
29002	2396	19075601	2001-02-21	2001-02-21 00:00:00	2001-02-21	2001-02-21 00:00:00	2001-02-21	38000177		0	0	0		0	0	0	159325	0	309362	19075601		
35911	2957	1127433	2017-08-15	2017-08-15 00:00:00	2017-09-14	2017-09-14 00:00:00	2017-09-14	38000177		0	0	30		0	0	0	197395	0	313782	1127433		
52476	4365	19075601	2016-01-10	2016-01-10 00:00:00	2016-01-10	2016-01-10 00:00:00	2016-01-10	38000177		0	0	0		0	0	0	289584	0	309362	19075601		
10138	850	19006318	1964-09-05	1964-09-05 00:00:00	1964-09-19	1964-09-19 00:00:00	1964-09-19	38000177		0	0	14		0	0	0	56193	0	105078	19006318		
60128	4999	19059056	1971-10-01	1971-10-01 00:00:00	1971-10-15	1971-10-15 00:00:00	1971-10-15	38000177		0	0	14		0	0	0	332420	0	243670	19059056		
51455	4276	40229134	1995-08-07	1995-08-07 00:00:00	1995-08-21	1995-08-21 00:00:00	1995-08-21	38000177		0	0	14		0	0	0	283728	0	1043400	40229134		
10247	858	1713671	2008-04-23	2008-04-23 00:00:00	2008-07-02	2008-07-02 00:00:00	2008-07-02	38000177		0	0	70		0	0	0	56690	0	562251	1713671		
3413	283	19128022	1995-08-24	1995-08-24 00:00:00	1996-08-18	1996-08-18 00:00:00	1996-08-18	38000177		0	0	360		0	0	0	18865	0	749785	19128022		
120273	2644	40213306	2002-04-15	2002-04-15 00:00:00	2002-04-15	2002-04-15 00:00:00	2002-04-15	581452		0	0	0		0	0	0	174978	0	43	40213306		
21743	472	40213296	2016-10-23	2016-10-23 00:00:00	2016-10-23	2016-10-23 00:00:00	2016-10-23	581452		0	0	0		0	0	0	31544	0	52	40213296		
25003	2058	19133905	2001-06-26	2001-06-26 00:00:00	2001-07-03	2001-07-03 00:00:00	2001-07-03	38000177		0	0	7		0	0	0	136813	0	834102	19133905		
57265	4753	1127433	2013-09-16	2013-09-16 00:00:00	2013-09-30	2013-09-30 00:00:00	2013-09-30	38000177		0	0	14		0	0	0	316519	0	313782	1127433		
11644	970	1127078	1956-02-18	1956-02-18 00:00:00	1956-03-17	1956-03-17 00:00:00	1956-03-17	38000177		0	0	28		0	0	0	64474	0	282464	1127078		
34350	2836	1713671	2014-08-20	2014-08-20 00:00:00	2014-08-27	2014-08-27 00:00:00	2014-08-27	38000177		0	0	7		0	0	0	188407	0	562251	1713671		
11731	974	1118084	1993-04-06	1993-04-06 00:00:00	1993-04-06	1993-04-06 00:00:00	\N	38000177		0	0	0		0	0	0	64959	0	00025152531	44923712		
227972	5005	40213296	2013-12-15	2013-12-15 00:00:00	2013-12-15	2013-12-15 00:00:00	2013-12-15	581452		0	0	0		0	0	0	332955	0	52	40213296		
24732	2033	19059056	1956-04-25	1956-04-25 00:00:00	1956-07-24	1956-07-24 00:00:00	1956-07-24	38000177		0	0	90		0	0	0	135298	0	243670	19059056		
1712	137	1713671	2011-04-18	2011-04-18 00:00:00	2011-04-25	2011-04-25 00:00:00	2011-04-25	38000177		0	0	7		0	0	0	9184	0	562251	1713671		
23369	1925	1713671	1998-12-05	1998-12-05 00:00:00	1998-12-19	1998-12-19 00:00:00	1998-12-19	38000177		0	0	14		0	0	0	128133	0	562251	1713671		
35305	2909	35605482	1962-04-07	1962-04-07 00:00:00	1962-04-07	1962-04-07 00:00:00	1962-04-07	38000177		0	0	0		0	0	0	193910	0	1740467	35605482		
179349	3943	40213296	1996-02-29	1996-02-29 00:00:00	1996-02-29	1996-02-29 00:00:00	1996-02-29	581452		0	0	0		0	0	0	262200	0	52	40213296		
32945	2731	40243436	2007-07-09	2007-07-09 00:00:00	2007-07-09	2007-07-09 00:00:00	2007-07-09	38000177		0	0	0		0	0	0	180794	0	1190795	40243436		
54971	4565	1713671	1945-09-11	1945-09-11 00:00:00	1945-09-25	1945-09-25 00:00:00	1945-09-25	38000177		0	0	14		0	0	0	304240	0	562251	1713671		
186736	4102	40213296	2006-01-02	2006-01-02 00:00:00	2006-01-02	2006-01-02 00:00:00	2006-01-02	581452		0	0	0		0	0	0	272550	0	52	40213296		
43567	3612	40236824	2008-06-27	2008-06-27 00:00:00	2008-07-11	2008-07-11 00:00:00	2008-07-11	38000177		0	0	14		0	0	0	239987	0	1094107	40236824		
47417	3930	19059056	1917-05-20	1917-05-20 00:00:00	1917-06-10	1917-06-10 00:00:00	1917-06-10	38000177		0	0	21		0	0	0	261307	0	243670	19059056		
20856	453	40213296	2012-06-01	2012-06-01 00:00:00	2012-06-01	2012-06-01 00:00:00	2012-06-01	581452		0	0	0		0	0	0	30245	0	52	40213296		
50916	4229	1713671	1993-05-30	1993-05-30 00:00:00	1993-06-13	1993-06-13 00:00:00	1993-06-13	38000177		0	0	14		0	0	0	280978	0	562251	1713671		
54211	4504	1127433	1970-08-01	1970-08-01 00:00:00	1970-08-15	1970-08-15 00:00:00	1970-08-15	38000177		0	0	14		0	0	0	299927	0	313782	1127433		
49245	4086	1127433	2016-11-12	2016-11-12 00:00:00	2016-11-19	2016-11-19 00:00:00	2016-11-19	38000177		0	0	7		0	0	0	271621	0	313782	1127433		
60443	1321	40213260	2010-12-02	2010-12-02 00:00:00	2010-12-02	2010-12-02 00:00:00	2010-12-02	581452		0	0	0		0	0	0	87594	0	121	40213260		
17035	1410	19128065	1988-02-03	1988-02-03 00:00:00	1989-01-28	1989-01-28 00:00:00	1989-01-28	38000177		0	0	360		0	0	0	93880	0	749882	19128065		
58683	4872	1127433	2008-07-06	2008-07-06 00:00:00	2008-08-10	2008-08-10 00:00:00	2008-08-10	38000177		0	0	35		0	0	0	324092	0	313782	1127433		
824	66	1127433	2000-09-27	2000-09-27 00:00:00	2000-10-04	2000-10-04 00:00:00	2000-10-04	38000177		0	0	7		0	0	0	4506	0	313782	1127433		
44040	3647	1127433	2004-03-31	2004-03-31 00:00:00	2004-04-07	2004-04-07 00:00:00	2004-04-07	38000177		0	0	7		0	0	0	242722	0	313782	1127433		
29929	2480	19059056	1961-03-24	1961-03-24 00:00:00	1961-04-07	1961-04-07 00:00:00	1961-04-07	38000177		0	0	14		0	0	0	164306	0	243670	19059056		
50549	4200	46233988	1973-06-14	1973-06-14 00:00:00	1973-06-28	1973-06-28 00:00:00	1973-06-28	38000177		0	0	14		0	0	0	278783	0	1652673	46233988		
83200	1819	40213160	1978-01-31	1978-01-31 00:00:00	1978-01-31	1978-01-31 00:00:00	1978-01-31	581452		0	0	0		0	0	0	121650	0	10	40213160		
161366	3550	40213160	1985-03-30	1985-03-30 00:00:00	1985-03-30	1985-03-30 00:00:00	1985-03-30	581452		0	0	0		0	0	0	235706	0	10	40213160		
187762	4123	40213260	2012-06-03	2012-06-03 00:00:00	2012-06-03	2012-06-03 00:00:00	2012-06-03	581452		0	0	0		0	0	0	274110	0	121	40213260		
74940	1636	40213227	2017-04-14	2017-04-14 00:00:00	2017-04-14	2017-04-14 00:00:00	2017-04-14	581452		0	0	0		0	0	0	109895	0	113	40213227		
33081	2743	1127078	1964-02-15	1964-02-15 00:00:00	1964-02-29	1964-02-29 00:00:00	1964-02-29	38000177		0	0	14		0	0	0	181442	0	282464	1127078		
49428	4101	1127433	1980-06-08	1980-06-08 00:00:00	1980-06-22	1980-06-22 00:00:00	1980-06-22	38000177		0	0	14		0	0	0	272516	0	313782	1127433		
34982	763	40213160	1965-06-24	1965-06-24 00:00:00	1965-06-24	1965-06-24 00:00:00	1965-06-24	581452		0	0	0		0	0	0	50764	0	10	40213160		
32697	2709	19059056	1943-12-15	1943-12-15 00:00:00	1943-12-29	1943-12-29 00:00:00	1943-12-29	38000177		0	0	14		0	0	0	179529	0	243670	19059056		
16414	1359	40223774	2003-03-07	2003-03-07 00:00:00	2003-03-07	2003-03-07 00:00:00	\N	38000177		0	0	0		0	0	0	90223	0	998582	40223774		
24020	1976	1127078	1985-09-19	1985-09-19 00:00:00	1985-10-03	1985-10-03 00:00:00	1985-10-03	38000177		0	0	14		0	0	0	131421	0	282464	1127078		
21178	1745	19133873	1979-08-16	1979-08-16 00:00:00	1979-08-27	1979-08-27 00:00:00	1979-08-27	38000177		0	0	11		0	0	0	116670	0	834061	19133873		
3274	270	19059056	1982-04-13	1982-04-13 00:00:00	1982-05-04	1982-05-04 00:00:00	1982-05-04	38000177		0	0	21		0	0	0	18023	0	243670	19059056		
61401	5108	1127433	2002-03-10	2002-03-10 00:00:00	2002-03-17	2002-03-17 00:00:00	2002-03-17	38000177		0	0	7		0	0	0	339419	0	313782	1127433		
14958	1250	1713671	1993-02-13	1993-02-13 00:00:00	1993-03-06	1993-03-06 00:00:00	1993-03-06	38000177		0	0	21		0	0	0	82374	0	562251	1713671		
44811	3708	1713671	2014-05-20	2014-05-20 00:00:00	2014-05-27	2014-05-27 00:00:00	2014-05-27	38000177		0	0	7		0	0	0	246477	0	562251	1713671		
38412	3176	1127433	2006-10-13	2006-10-13 00:00:00	2006-11-03	2006-11-03 00:00:00	2006-11-03	38000177		0	0	21		0	0	0	211225	0	313782	1127433		
22176	1821	19133905	1971-08-17	1971-08-17 00:00:00	1971-08-29	1971-08-29 00:00:00	1971-08-29	38000177		0	0	12		0	0	0	121810	0	834102	19133905		
22230	1826	1127433	1956-10-29	1956-10-29 00:00:00	1956-12-28	1956-12-28 00:00:00	1956-12-28	38000177		0	0	60		0	0	0	122040	0	313782	1127433		
61717	5137	40169216	1970-06-27	1970-06-27 00:00:00	1970-06-27	1970-06-27 00:00:00	\N	38000177		0	0	0		0	0	0	341436	0	895994	40169216		
5852	488	1127433	2015-08-18	2015-08-18 00:00:00	2015-09-01	2015-09-01 00:00:00	2015-09-01	38000177		0	0	14		0	0	0	32654	0	313782	1127433		
53046	4408	1115171	2011-07-14	2011-07-14 00:00:00	2011-09-12	2011-09-12 00:00:00	2011-09-12	38000177		0	0	60		0	0	0	293000	0	849574	1115171		
53088	4411	1127078	1953-10-31	1953-10-31 00:00:00	1953-11-30	1953-11-30 00:00:00	1953-11-30	38000177		0	0	30		0	0	0	293249	0	282464	1127078		
89236	1956	40213160	1968-03-19	1968-03-19 00:00:00	1968-03-19	1968-03-19 00:00:00	1968-03-19	581452		0	0	0		0	0	0	130094	0	10	40213160		
218793	4802	40213227	1995-12-09	1995-12-09 00:00:00	1995-12-09	1995-12-09 00:00:00	1995-12-09	581452		0	0	0		0	0	0	319476	0	113	40213227		
25258	2078	1115171	2014-01-13	2014-01-13 00:00:00	2014-02-19	2014-02-19 00:00:00	2014-02-19	38000177		0	0	37		0	0	0	138384	0	849574	1115171		
21322	1753	19133873	1965-04-03	1965-04-03 00:00:00	1965-04-16	1965-04-16 00:00:00	1965-04-16	38000177		0	0	13		0	0	0	117192	0	834061	19133873		
25323	2084	40229134	2002-02-18	2002-02-18 00:00:00	2002-02-25	2002-02-25 00:00:00	2002-02-25	38000177		0	0	7		0	0	0	138875	0	1043400	40229134		
29003	2396	1713671	1936-04-30	1936-04-30 00:00:00	1936-05-21	1936-05-21 00:00:00	1936-05-21	38000177		0	0	21		0	0	0	159294	0	562251	1713671		
35912	2957	920300	1977-06-10	1977-06-10 00:00:00	1977-06-17	1977-06-17 00:00:00	1977-06-17	38000177		0	0	7		0	0	0	197307	0	311989	920300		
52477	4365	19115351	1982-11-24	1982-11-24 00:00:00	1983-04-06	1983-04-06 00:00:00	1983-04-06	38000177		0	0	133		0	0	0	289587	0	563026	19115351		
10139	850	19059056	1964-09-05	1964-09-05 00:00:00	1964-09-19	1964-09-19 00:00:00	1964-09-19	38000177		0	0	14		0	0	0	56193	0	243670	19059056		
60129	4999	19129655	1971-10-01	1971-10-01 00:00:00	1971-10-15	1971-10-15 00:00:00	1971-10-15	38000177		0	0	14		0	0	0	332420	0	789980	19129655		
51456	4276	1127433	2016-11-14	2016-11-14 00:00:00	2016-11-21	2016-11-21 00:00:00	2016-11-21	38000177		0	0	7		0	0	0	283779	0	313782	1127433		
10248	859	1127433	1976-11-02	1976-11-02 00:00:00	1976-11-09	1976-11-09 00:00:00	1976-11-09	38000177		0	0	7		0	0	0	56753	0	313782	1127433		
3414	283	1115171	1998-04-21	1998-04-21 00:00:00	1998-07-20	1998-07-20 00:00:00	1998-07-20	38000177		0	0	90		0	0	0	18881	0	849574	1115171		
120279	2644	40213227	2011-04-25	2011-04-25 00:00:00	2011-04-25	2011-04-25 00:00:00	2011-04-25	581452		0	0	0		0	0	0	174981	0	113	40213227		
21746	472	40213314	1977-07-03	1977-07-03 00:00:00	1977-07-03	1977-07-03 00:00:00	1977-07-03	581452		0	0	0		0	0	0	31505	0	49	40213314		
25004	2058	40236824	2008-11-16	2008-11-16 00:00:00	2008-11-30	2008-11-30 00:00:00	2008-11-30	38000177		0	0	14		0	0	0	136914	0	1094107	40236824		
57266	4753	1127433	2006-02-25	2006-02-25 00:00:00	2006-05-26	2006-05-26 00:00:00	2006-05-26	38000177		0	0	90		0	0	0	316518	0	313782	1127433		
36535	3013	40165015	2014-05-05	2014-05-05 00:00:00	2014-05-05	2014-05-05 00:00:00	\N	38000177		0	0	0		0	0	0	200967	0	861467	40165015		
34351	2837	1713671	1984-06-13	1984-06-13 00:00:00	1984-06-27	1984-06-27 00:00:00	1984-06-27	38000177		0	0	14		0	0	0	188461	0	562251	1713671		
11732	974	19133873	1960-02-07	1960-02-07 00:00:00	1960-02-17	1960-02-17 00:00:00	1960-02-17	38000177		0	0	10		0	0	0	64930	0	834061	19133873		
227981	5005	40213160	1973-10-07	1973-10-07 00:00:00	1973-10-07	1973-10-07 00:00:00	1973-10-07	581452		0	0	0		0	0	0	332962	0	10	40213160		
24733	2033	1127433	2013-03-25	2013-03-25 00:00:00	2013-04-01	2013-04-01 00:00:00	2013-04-01	38000177		0	0	7		0	0	0	135323	0	313782	1127433		
26105	2149	19133873	1961-10-08	1961-10-08 00:00:00	1961-10-15	1961-10-15 00:00:00	1961-10-15	38000177		0	0	7		0	0	0	143070	0	834061	19133873		
23371	1925	1127433	1962-01-23	1962-01-23 00:00:00	1962-02-06	1962-02-06 00:00:00	1962-02-06	38000177		0	0	14		0	0	0	128122	0	313782	1127433		
35306	2909	19078924	1962-04-07	1962-04-07 00:00:00	1962-04-07	1962-04-07 00:00:00	1962-04-07	38000177		0	0	0		0	0	0	193910	0	311700	19078924		
179358	3943	40213198	2017-06-22	2017-06-22 00:00:00	2017-06-22	2017-06-22 00:00:00	2017-06-22	581452		0	0	0		0	0	0	262132	0	133	40213198		
32946	2731	1127433	1984-06-08	1984-06-08 00:00:00	1984-06-29	1984-06-29 00:00:00	1984-06-29	38000177		0	0	21		0	0	0	180789	0	313782	1127433		
54972	4565	1127433	2016-11-04	2016-11-04 00:00:00	2017-02-02	2017-02-02 00:00:00	2017-02-02	38000177		0	0	90		0	0	0	304213	0	313782	1127433		
186738	4102	40213227	2016-03-28	2016-03-28 00:00:00	2016-03-28	2016-03-28 00:00:00	2016-03-28	581452		0	0	0		0	0	0	272615	0	113	40213227		
43568	3612	40165015	1974-04-05	1974-04-05 00:00:00	1974-04-05	1974-04-05 00:00:00	\N	38000177		0	0	0		0	0	0	239999	0	861467	40165015		
47418	3930	19126352	1972-07-22	1972-07-22 00:00:00	1979-12-29	1979-12-29 00:00:00	1979-12-29	38000177		0	0	2716		0	0	0	261271	0	705129	19126352		
20876	454	40213227	2016-03-05	2016-03-05 00:00:00	2016-03-05	2016-03-05 00:00:00	2016-03-05	581452		0	0	0		0	0	0	30303	0	113	40213227		
50917	4229	1118084	1993-09-24	1993-09-24 00:00:00	1993-09-24	1993-09-24 00:00:00	\N	38000177		0	0	0		0	0	0	280978	0	00025152531	44923712		
54212	4504	19059056	1972-11-17	1972-11-17 00:00:00	1972-12-01	1972-12-01 00:00:00	1972-12-01	38000177		0	0	14		0	0	0	299949	0	243670	19059056		
49246	4086	1127433	2019-02-09	2019-02-09 00:00:00	2019-02-16	2019-02-16 00:00:00	2019-02-16	38000177		0	0	7		0	0	0	271614	0	313782	1127433		
60454	1321	40213296	2000-10-26	2000-10-26 00:00:00	2000-10-26	2000-10-26 00:00:00	2000-10-26	581452		0	0	0		0	0	0	\N	0	52	40213296		
17036	1410	19128022	1996-01-09	1996-01-09 00:00:00	1997-01-03	1997-01-03 00:00:00	1997-01-03	38000177		0	0	360		0	0	0	93856	0	749785	19128022		
58684	4873	1127078	1977-02-11	1977-02-11 00:00:00	1977-02-25	1977-02-25 00:00:00	1977-02-25	38000177		0	0	14		0	0	0	324105	0	282464	1127078		
825	66	19078461	1981-03-10	1981-03-10 00:00:00	1981-03-31	1981-03-31 00:00:00	1981-03-31	38000177		0	0	21		0	0	0	4449	0	310965	19078461		
44041	3647	19078461	2007-01-01	2007-01-01 00:00:00	2007-01-29	2007-01-29 00:00:00	2007-01-29	38000177		0	0	28		0	0	0	242666	0	310965	19078461		
29930	2480	1713671	1956-09-03	1956-09-03 00:00:00	1956-09-10	1956-09-10 00:00:00	1956-09-10	38000177		0	0	7		0	0	0	164316	0	562251	1713671		
50550	4200	1127078	1973-06-14	1973-06-14 00:00:00	1973-06-28	1973-06-28 00:00:00	1973-06-28	38000177		0	0	14		0	0	0	278783	0	282464	1127078		
83202	1819	40213296	2019-06-04	2019-06-04 00:00:00	2019-06-04	2019-06-04 00:00:00	2019-06-04	581452		0	0	0		0	0	0	121653	0	52	40213296		
161369	3550	40213227	2015-10-17	2015-10-17 00:00:00	2015-10-17	2015-10-17 00:00:00	2015-10-17	581452		0	0	0		0	0	0	235719	0	113	40213227		
187767	4124	40213227	1995-01-14	1995-01-14 00:00:00	1995-01-14	1995-01-14 00:00:00	1995-01-14	581452		0	0	0		0	0	0	274188	0	113	40213227		
74942	1636	40213296	1996-02-16	1996-02-16 00:00:00	1996-02-16	1996-02-16 00:00:00	1996-02-16	581452		0	0	0		0	0	0	109907	0	52	40213296		
33082	2743	19059056	1968-02-24	1968-02-24 00:00:00	1968-03-23	1968-03-23 00:00:00	1968-03-23	38000177		0	0	28		0	0	0	181450	0	243670	19059056		
49429	4101	19128065	1977-02-07	1977-02-07 00:00:00	1978-02-02	1978-02-02 00:00:00	1978-02-02	38000177		0	0	360		0	0	0	272514	0	749882	19128065		
34985	763	40213306	1987-05-21	1987-05-21 00:00:00	1987-05-21	1987-05-21 00:00:00	1987-05-21	581452		0	0	0		0	0	0	50771	0	43	40213306		
32698	2709	19133873	1950-12-09	1950-12-09 00:00:00	1950-12-17	1950-12-17 00:00:00	1950-12-17	38000177		0	0	8		0	0	0	179491	0	834061	19133873		
16415	1359	40229134	1976-08-21	1976-08-21 00:00:00	1976-08-28	1976-08-28 00:00:00	1976-08-28	38000177		0	0	7		0	0	0	90193	0	1043400	40229134		
24021	1976	1127433	2003-12-02	2003-12-02 00:00:00	2003-12-09	2003-12-09 00:00:00	2003-12-09	38000177		0	0	7		0	0	0	131390	0	313782	1127433		
21179	1745	19129144	2003-11-15	2003-11-15 00:00:00	2004-11-09	2004-11-09 00:00:00	2004-11-09	38000177		0	0	360		0	0	0	116693	0	757594	19129144		
3275	270	1115171	1995-08-15	1995-08-15 00:00:00	1995-09-05	1995-09-05 00:00:00	1995-09-05	38000177		0	0	21		0	0	0	18025	0	849574	1115171		
61402	5108	19006318	1962-07-29	1962-07-29 00:00:00	1962-08-12	1962-08-12 00:00:00	1962-08-12	38000177		0	0	14		0	0	0	339386	0	105078	19006318		
14959	1250	19059056	1955-03-13	1955-03-13 00:00:00	1955-06-11	1955-06-11 00:00:00	1955-06-11	38000177		0	0	90		0	0	0	82333	0	243670	19059056		
44812	3708	19128065	2002-03-13	2002-03-13 00:00:00	2002-05-31	2002-05-31 00:00:00	2002-05-31	38000177		0	0	79		0	0	0	246544	0	749882	19128065		
38414	3176	40236824	2001-01-11	2001-01-11 00:00:00	2001-01-25	2001-01-25 00:00:00	2001-01-25	38000177		0	0	14		0	0	0	211107	0	1094107	40236824		
22177	1821	1127433	1974-11-18	1974-11-18 00:00:00	1974-11-25	1974-11-25 00:00:00	1974-11-25	38000177		0	0	7		0	0	0	121811	0	313782	1127433		
22231	1826	1713671	1995-08-19	1995-08-19 00:00:00	1995-09-09	1995-09-09 00:00:00	1995-09-09	38000177		0	0	21		0	0	0	122055	0	562251	1713671		
61718	5137	1154615	1970-06-27	1970-06-27 00:00:00	1970-06-27	1970-06-27 00:00:00	\N	38000177		0	0	0		0	0	0	341436	0	745679	1154615		
5853	488	1713671	1990-10-23	1990-10-23 00:00:00	1990-11-20	1990-11-20 00:00:00	1990-11-20	38000177		0	0	28		0	0	0	32694	0	562251	1713671		
53047	4408	40231925	2011-07-14	2011-07-14 00:00:00	2011-07-14	2011-07-14 00:00:00	\N	38000177		0	0	0		0	0	0	293000	0	1049221	40231925		
53090	4411	40229134	1993-08-16	1993-08-16 00:00:00	1993-08-23	1993-08-23 00:00:00	1993-08-23	38000177		0	0	7		0	0	0	293231	0	1043400	40229134		
89238	1956	40213160	1963-10-01	1963-10-01 00:00:00	1963-10-01	1963-10-01 00:00:00	1963-10-01	581452		0	0	0		0	0	0	130144	0	10	40213160		
218802	4802	40213260	2015-05-03	2015-05-03 00:00:00	2015-05-03	2015-05-03 00:00:00	2015-05-03	581452		0	0	0		0	0	0	319482	0	121	40213260		
25259	2079	1127433	1975-12-28	1975-12-28 00:00:00	1976-01-11	1976-01-11 00:00:00	1976-01-11	38000177		0	0	14		0	0	0	138492	0	313782	1127433		
21323	1753	19059056	1968-05-16	1968-05-16 00:00:00	1968-05-30	1968-05-30 00:00:00	1968-05-30	38000177		0	0	14		0	0	0	117163	0	243670	19059056		
25324	2084	1713671	1981-08-23	1981-08-23 00:00:00	1981-09-06	1981-09-06 00:00:00	1981-09-06	38000177		0	0	14		0	0	0	138878	0	562251	1713671		
29004	2396	19059056	1923-06-20	1923-06-20 00:00:00	1923-07-04	1923-07-04 00:00:00	1923-07-04	38000177		0	0	14		0	0	0	159386	0	243670	19059056		
35913	2957	40236824	1977-06-10	1977-06-10 00:00:00	1977-06-17	1977-06-17 00:00:00	1977-06-17	38000177		0	0	7		0	0	0	197307	0	1094107	40236824		
52478	4365	19018935	2001-07-23	2001-07-23 00:00:00	2001-07-23	2001-07-23 00:00:00	\N	38000177		0	0	0		0	0	0	289578	0	197604	19018935		
10140	850	1127433	1978-04-06	1978-04-06 00:00:00	1978-04-20	1978-04-20 00:00:00	1978-04-20	38000177		0	0	14		0	0	0	56237	0	313782	1127433		
60131	4999	1713671	2008-09-17	2008-09-17 00:00:00	2008-10-01	2008-10-01 00:00:00	2008-10-01	38000177		0	0	14		0	0	0	332484	0	562251	1713671		
51457	4276	40229134	1964-01-07	1964-01-07 00:00:00	1964-01-21	1964-01-21 00:00:00	1964-01-21	38000177		0	0	14		0	0	0	283774	0	1043400	40229134		
10249	859	1127433	1992-11-11	1992-11-11 00:00:00	1992-11-18	1992-11-18 00:00:00	1992-11-18	38000177		0	0	7		0	0	0	56870	0	313782	1127433		
3415	283	1154615	1984-09-07	1984-09-07 00:00:00	1984-09-07	1984-09-07 00:00:00	\N	38000177		0	0	0		0	0	0	18834	0	745679	1154615		
120286	2644	40213251	1984-01-16	1984-01-16 00:00:00	1984-01-16	1984-01-16 00:00:00	1984-01-16	581452		0	0	0		0	0	0	174986	0	21	40213251		
21747	472	40213227	2008-10-12	2008-10-12 00:00:00	2008-10-12	2008-10-12 00:00:00	2008-10-12	581452		0	0	0		0	0	0	31549	0	113	40213227		
25005	2058	920300	2008-11-16	2008-11-16 00:00:00	2008-11-23	2008-11-23 00:00:00	2008-11-23	38000177		0	0	7		0	0	0	136914	0	311989	920300		
57267	4753	19059056	1968-04-01	1968-04-01 00:00:00	1968-05-01	1968-05-01 00:00:00	1968-05-01	38000177		0	0	30		0	0	0	316573	0	243670	19059056		
36536	3013	19059056	1971-11-12	1971-11-12 00:00:00	1971-12-17	1971-12-17 00:00:00	1971-12-17	38000177		0	0	35		0	0	0	200966	0	243670	19059056		
34352	2837	1127433	2015-01-23	2015-01-23 00:00:00	2015-01-30	2015-01-30 00:00:00	2015-01-30	38000177		0	0	7		0	0	0	188476	0	313782	1127433		
11733	974	19115351	1956-06-24	1956-06-24 00:00:00	1956-09-16	1956-09-16 00:00:00	1956-09-16	38000177		0	0	84		0	0	0	64962	0	563026	19115351		
39424	3258	19128065	1995-05-31	1995-05-31 00:00:00	1996-05-25	1996-05-25 00:00:00	1996-05-25	38000177		0	0	360		0	0	0	216556	0	749882	19128065		
24734	2033	1127433	1962-03-17	1962-03-17 00:00:00	1962-03-31	1962-03-31 00:00:00	1962-03-31	38000177		0	0	14		0	0	0	135330	0	313782	1127433		
26106	2149	19059056	1982-03-14	1982-03-14 00:00:00	1982-04-04	1982-04-04 00:00:00	1982-04-04	38000177		0	0	21		0	0	0	143126	0	243670	19059056		
23372	1925	40236824	2000-02-05	2000-02-05 00:00:00	2000-02-12	2000-02-12 00:00:00	2000-02-12	38000177		0	0	7		0	0	0	128144	0	1094107	40236824		
35307	2909	46275444	1962-04-07	1962-04-07 00:00:00	1962-04-07	1962-04-07 00:00:00	1962-04-07	38000177		0	0	0		0	0	0	193910	0	1659149	46275444		
241346	5298	40213227	2011-07-24	2011-07-24 00:00:00	2011-07-24	2011-07-24 00:00:00	2011-07-24	581452		0	0	0		0	0	0	352403	0	113	40213227		
32947	2731	1118084	2003-07-21	2003-07-21 00:00:00	2003-07-21	2003-07-21 00:00:00	\N	38000177		0	0	0		0	0	0	180812	0	00025152531	44923712		
54973	4565	1713671	1976-05-04	1976-05-04 00:00:00	1976-05-18	1976-05-18 00:00:00	1976-05-18	38000177		0	0	14		0	0	0	304222	0	562251	1713671		
186739	4102	40213260	2016-03-28	2016-03-28 00:00:00	2016-03-28	2016-03-28 00:00:00	2016-03-28	581452		0	0	0		0	0	0	272615	0	121	40213260		
43569	3612	19078461	1974-04-05	1974-04-05 00:00:00	1974-06-04	1974-06-04 00:00:00	1974-06-04	38000177		0	0	60		0	0	0	239999	0	310965	19078461		
47419	3930	19059056	1917-02-01	1917-02-01 00:00:00	1917-02-15	1917-02-15 00:00:00	1917-02-15	38000177		0	0	14		0	0	0	261244	0	243670	19059056		
20878	454	40213201	2002-02-16	2002-02-16 00:00:00	2002-02-16	2002-02-16 00:00:00	2002-02-16	581452		0	0	0		0	0	0	30362	0	33	40213201		
50918	4229	1127078	1956-02-15	1956-02-15 00:00:00	1956-03-07	1956-03-07 00:00:00	1956-03-07	38000177		0	0	21		0	0	0	280920	0	282464	1127078		
55163	4579	1127433	2010-06-10	2010-06-10 00:00:00	2010-06-24	2010-06-24 00:00:00	2010-06-24	38000177		0	0	14		0	0	0	305031	0	313782	1127433		
49247	4086	1127433	1979-02-28	1979-02-28 00:00:00	1979-03-07	1979-03-07 00:00:00	1979-03-07	38000177		0	0	7		0	0	0	271594	0	313782	1127433		
60456	1321	40213227	2000-10-26	2000-10-26 00:00:00	2000-10-26	2000-10-26 00:00:00	2000-10-26	581452		0	0	0		0	0	0	\N	0	113	40213227		
17037	1410	1118084	2004-05-25	2004-05-25 00:00:00	2004-05-25	2004-05-25 00:00:00	\N	38000177		0	0	0		0	0	0	93891	0	00025152531	44923712		
58685	4873	46233988	1977-02-11	1977-02-11 00:00:00	1977-02-25	1977-02-25 00:00:00	1977-02-25	38000177		0	0	14		0	0	0	324105	0	1652673	46233988		
826	66	46233710	1975-09-26	1975-09-26 00:00:00	1975-10-10	1975-10-10 00:00:00	1975-10-10	38000177		0	0	14		0	0	0	4478	0	1650142	46233710		
44042	3647	19059056	1947-04-11	1947-04-11 00:00:00	1947-04-25	1947-04-25 00:00:00	1947-04-25	38000177		0	0	14		0	0	0	242664	0	243670	19059056		
29931	2480	1127433	2009-06-05	2009-06-05 00:00:00	2009-09-03	2009-09-03 00:00:00	2009-09-03	38000177		0	0	90		0	0	0	164319	0	313782	1127433		
29405	2435	19133873	1979-07-17	1979-07-17 00:00:00	1979-07-24	1979-07-24 00:00:00	1979-07-24	38000177		0	0	7		0	0	0	161408	0	834061	19133873		
83204	1819	40213227	2019-06-04	2019-06-04 00:00:00	2019-06-04	2019-06-04 00:00:00	2019-06-04	581452		0	0	0		0	0	0	121653	0	113	40213227		
63532	1389	40213160	1959-11-07	1959-11-07 00:00:00	1959-11-07	1959-11-07 00:00:00	1959-11-07	581452		0	0	0		0	0	0	92188	0	10	40213160		
187768	4124	40213306	1995-01-14	1995-01-14 00:00:00	1995-01-14	1995-01-14 00:00:00	1995-01-14	581452		0	0	0		0	0	0	274188	0	43	40213306		
74944	1636	40213160	1956-10-19	1956-10-19 00:00:00	1956-10-19	1956-10-19 00:00:00	1956-10-19	581452		0	0	0		0	0	0	109923	0	10	40213160		
33083	2743	19128065	1975-03-29	1975-03-29 00:00:00	1976-03-23	1976-03-23 00:00:00	1976-03-23	38000177		0	0	360		0	0	0	181490	0	749882	19128065		
49430	4101	19133873	1963-09-20	1963-09-20 00:00:00	1963-10-01	1963-10-01 00:00:00	1963-10-01	38000177		0	0	11		0	0	0	272507	0	834061	19133873		
34987	763	40213296	2005-03-24	2005-03-24 00:00:00	2005-03-24	2005-03-24 00:00:00	2005-03-24	581452		0	0	0		0	0	0	50804	0	52	40213296		
32699	2709	19133873	1953-08-04	1953-08-04 00:00:00	1953-08-13	1953-08-13 00:00:00	1953-08-13	38000177		0	0	9		0	0	0	179486	0	834061	19133873		
16416	1359	19077572	2002-03-12	2002-03-12 00:00:00	2002-03-12	2002-03-12 00:00:00	\N	38000177		0	0	0		0	0	0	90189	0	310436	19077572		
24022	1977	19059056	1911-11-02	1911-11-02 00:00:00	1911-11-16	1911-11-16 00:00:00	1911-11-16	38000177		0	0	14		0	0	0	131547	0	243670	19059056		
21180	1745	1713671	1993-10-31	1993-10-31 00:00:00	1993-11-14	1993-11-14 00:00:00	1993-11-14	38000177		0	0	14		0	0	0	116652	0	562251	1713671		
3276	270	1713671	1964-10-31	1964-10-31 00:00:00	1964-11-07	1964-11-07 00:00:00	1964-11-07	38000177		0	0	7		0	0	0	18012	0	562251	1713671		
61403	5108	1127078	1962-07-29	1962-07-29 00:00:00	1962-08-12	1962-08-12 00:00:00	1962-08-12	38000177		0	0	14		0	0	0	339386	0	282464	1127078		
14960	1250	1127433	2002-12-02	2002-12-02 00:00:00	2002-12-16	2002-12-16 00:00:00	2002-12-16	38000177		0	0	14		0	0	0	82376	0	313782	1127433		
44813	3708	19073183	1980-10-24	1980-10-24 00:00:00	1980-11-07	1980-11-07 00:00:00	1980-11-07	38000177		0	0	14		0	0	0	246539	0	308182	19073183		
38415	3176	920300	2001-01-11	2001-01-11 00:00:00	2001-01-18	2001-01-18 00:00:00	2001-01-18	38000177		0	0	7		0	0	0	211107	0	311989	920300		
22178	1821	1713671	1964-01-13	1964-01-13 00:00:00	1964-01-27	1964-01-27 00:00:00	1964-01-27	38000177		0	0	14		0	0	0	121808	0	562251	1713671		
22232	1826	19133905	1985-06-18	1985-06-18 00:00:00	1985-06-30	1985-06-30 00:00:00	1985-06-30	38000177		0	0	12		0	0	0	122054	0	834102	19133905		
61719	5137	19078461	1998-04-21	1998-04-21 00:00:00	1998-05-05	1998-05-05 00:00:00	1998-05-05	38000177		0	0	14		0	0	0	341357	0	310965	19078461		
5854	488	1127433	1988-01-17	1988-01-17 00:00:00	1988-01-31	1988-01-31 00:00:00	1988-01-31	38000177		0	0	14		0	0	0	32624	0	313782	1127433		
53048	4408	1127078	1984-07-20	1984-07-20 00:00:00	1984-08-03	1984-08-03 00:00:00	1984-08-03	38000177		0	0	14		0	0	0	293023	0	282464	1127078		
53092	4411	920300	1996-07-06	1996-07-06 00:00:00	1996-07-13	1996-07-13 00:00:00	1996-07-13	38000177		0	0	7		0	0	0	293190	0	311989	920300		
89244	1956	40213296	2004-05-11	2004-05-11 00:00:00	2004-05-11	2004-05-11 00:00:00	2004-05-11	581452		0	0	0		0	0	0	130117	0	52	40213296		
132211	2904	40213227	2001-08-01	2001-08-01 00:00:00	2001-08-01	2001-08-01 00:00:00	2001-08-01	581452		0	0	0		0	0	0	193534	0	113	40213227		
25260	2079	19078461	2016-03-26	2016-03-26 00:00:00	2016-04-23	2016-04-23 00:00:00	2016-04-23	38000177		0	0	28		0	0	0	138491	0	310965	19078461		
21324	1753	1118084	2002-06-17	2002-06-17 00:00:00	2002-06-17	2002-06-17 00:00:00	\N	38000177		0	0	0		0	0	0	117265	0	00025152531	44923712		
25325	2084	1127433	2015-10-25	2015-10-25 00:00:00	2015-11-01	2015-11-01 00:00:00	2015-11-01	38000177		0	0	7		0	0	0	138841	0	313782	1127433		
29032	2402	1124300	2014-03-18	2014-03-18 00:00:00	2014-03-18	2014-03-18 00:00:00	\N	38000177		0	0	0		0	0	0	159677	0	00781178901	45011828		
35914	2957	1118084	1985-05-14	1985-05-14 00:00:00	1985-05-14	1985-05-14 00:00:00	\N	38000177		0	0	0		0	0	0	197314	0	00025152531	44923712		
52479	4365	40163554	2001-07-23	2001-07-23 00:00:00	2001-07-23	2001-07-23 00:00:00	\N	38000177		0	0	0		0	0	0	289578	0	855332	40163554		
10141	850	1127433	1991-07-11	1991-07-11 00:00:00	1991-08-08	1991-08-08 00:00:00	1991-08-08	38000177		0	0	28		0	0	0	56238	0	313782	1127433		
60132	4999	40171902	2018-01-21	2018-01-21 00:00:00	2018-01-21	2018-01-21 00:00:00	\N	38000177		0	0	0		0	0	0	332478	0	897718	40171902		
51458	4276	19133905	2016-09-24	2016-09-24 00:00:00	2016-10-07	2016-10-07 00:00:00	2016-10-07	38000177		0	0	13		0	0	0	283778	0	834102	19133905		
10250	859	19059056	1961-02-11	1961-02-11 00:00:00	1961-03-11	1961-03-11 00:00:00	1961-03-11	38000177		0	0	28		0	0	0	56713	0	243670	19059056		
3416	283	40169216	1984-09-07	1984-09-07 00:00:00	1984-09-07	1984-09-07 00:00:00	\N	38000177		0	0	0		0	0	0	18834	0	895994	40169216		
131566	2891	40213296	2013-11-28	2013-11-28 00:00:00	2013-11-28	2013-11-28 00:00:00	2013-11-28	581452		0	0	0		0	0	0	192299	0	52	40213296		
21752	472	40213160	1976-07-04	1976-07-04 00:00:00	1976-07-04	1976-07-04 00:00:00	1976-07-04	581452		0	0	0		0	0	0	31518	0	10	40213160		
25006	2058	19059056	1970-04-29	1970-04-29 00:00:00	1970-05-27	1970-05-27 00:00:00	1970-05-27	38000177		0	0	28		0	0	0	136799	0	243670	19059056		
57268	4754	19133873	1972-03-13	1972-03-13 00:00:00	1972-03-25	1972-03-25 00:00:00	1972-03-25	38000177		0	0	12		0	0	0	316639	0	834061	19133873		
36537	3013	1127078	1952-06-19	1952-06-19 00:00:00	1952-07-03	1952-07-03 00:00:00	1952-07-03	38000177		0	0	14		0	0	0	200963	0	282464	1127078		
34353	2837	1127433	1998-09-25	1998-09-25 00:00:00	1998-10-02	1998-10-02 00:00:00	1998-10-02	38000177		0	0	7		0	0	0	188463	0	313782	1127433		
11734	974	1127078	1960-03-05	1960-03-05 00:00:00	1960-05-04	1960-05-04 00:00:00	1960-05-04	38000177		0	0	60		0	0	0	64963	0	282464	1127078		
39425	3258	19074843	1993-04-15	1993-04-15 00:00:00	1993-05-20	1993-05-20 00:00:00	1993-05-20	38000177		0	0	35		0	0	0	216549	0	309045	19074843		
35193	2903	1127433	1973-04-10	1973-04-10 00:00:00	1973-04-24	1973-04-24 00:00:00	1973-04-24	38000177		0	0	14		0	0	0	193409	0	313782	1127433		
26107	2149	1118084	1995-11-25	1995-11-25 00:00:00	1995-11-25	1995-11-25 00:00:00	\N	38000177		0	0	0		0	0	0	143077	0	00025152531	44923712		
23373	1925	920300	2000-02-05	2000-02-05 00:00:00	2000-02-12	2000-02-12 00:00:00	2000-02-12	38000177		0	0	7		0	0	0	128144	0	311989	920300		
35308	2909	19059528	1962-04-07	1962-04-07 00:00:00	1962-04-07	1962-04-07 00:00:00	1962-04-07	38000177		0	0	0		0	0	0	193910	0	480	19059528		
241365	5299	40213160	1976-05-23	1976-05-23 00:00:00	1976-05-23	1976-05-23 00:00:00	1976-05-23	581452		0	0	0		0	0	0	352501	0	10	40213160		
32948	2731	1127078	1970-12-16	1970-12-16 00:00:00	1971-01-15	1971-01-15 00:00:00	1971-01-15	38000177		0	0	30		0	0	0	180816	0	282464	1127078		
54974	4565	1127433	1993-08-25	1993-08-25 00:00:00	1993-09-01	1993-09-01 00:00:00	1993-09-01	38000177		0	0	7		0	0	0	304165	0	313782	1127433		
186742	4102	40213160	1965-11-29	1965-11-29 00:00:00	1965-11-29	1965-11-29 00:00:00	1965-11-29	581452		0	0	0		0	0	0	272570	0	10	40213160		
43570	3612	19133905	2017-06-02	2017-06-02 00:00:00	2017-06-13	2017-06-13 00:00:00	2017-06-13	38000177		0	0	11		0	0	0	239963	0	834102	19133905		
47420	3930	19133905	1971-07-11	1971-07-11 00:00:00	1971-07-21	1971-07-21 00:00:00	1971-07-21	38000177		0	0	10		0	0	0	261231	0	834102	19133905		
20882	454	40213227	2006-03-11	2006-03-11 00:00:00	2006-03-11	2006-03-11 00:00:00	2006-03-11	581452		0	0	0		0	0	0	30300	0	113	40213227		
50919	4229	1127078	1957-03-02	1957-03-02 00:00:00	1957-05-01	1957-05-01 00:00:00	1957-05-01	38000177		0	0	60		0	0	0	280921	0	282464	1127078		
55164	4579	19075001	1999-05-14	1999-05-14 00:00:00	1999-05-28	1999-05-28 00:00:00	1999-05-28	38000177		0	0	14		0	0	0	305012	0	309097	19075001		
49248	4086	1127433	1991-10-02	1991-10-02 00:00:00	1991-10-16	1991-10-16 00:00:00	1991-10-16	38000177		0	0	14		0	0	0	271619	0	313782	1127433		
60461	1321	40213306	1982-06-10	1982-06-10 00:00:00	1982-06-10	1982-06-10 00:00:00	1982-06-10	581452		0	0	0		0	0	0	87669	0	43	40213306		
17038	1410	19059056	1971-04-23	1971-04-23 00:00:00	1971-05-08	1971-05-08 00:00:00	1971-05-08	38000177		0	0	15		0	0	0	93877	0	243670	19059056		
58686	4873	19133905	2009-09-07	2009-09-07 00:00:00	2009-09-17	2009-09-17 00:00:00	2009-09-17	38000177		0	0	10		0	0	0	324128	0	834102	19133905		
827	66	19078461	1975-09-26	1975-09-26 00:00:00	1975-10-10	1975-10-10 00:00:00	1975-10-10	38000177		0	0	14		0	0	0	4478	0	310965	19078461		
44043	3647	19059056	1956-05-09	1956-05-09 00:00:00	1956-05-23	1956-05-23 00:00:00	1956-05-23	38000177		0	0	14		0	0	0	242605	0	243670	19059056		
29932	2480	1713671	1969-06-09	1969-06-09 00:00:00	1969-06-23	1969-06-23 00:00:00	1969-06-23	38000177		0	0	14		0	0	0	164298	0	562251	1713671		
29406	2435	19073188	1988-02-07	1988-02-07 00:00:00	1988-02-21	1988-02-21 00:00:00	1988-02-21	38000177		0	0	14		0	0	0	161420	0	308192	19073188		
83206	1819	40213227	1999-10-12	1999-10-12 00:00:00	1999-10-12	1999-10-12 00:00:00	1999-10-12	581452		0	0	0		0	0	0	121662	0	113	40213227		
63538	1389	40213260	2007-03-17	2007-03-17 00:00:00	2007-03-17	2007-03-17 00:00:00	2007-03-17	581452		0	0	0		0	0	0	92215	0	121	40213260		
187770	4124	40213314	1977-05-28	1977-05-28 00:00:00	1977-05-28	1977-05-28 00:00:00	1977-05-28	581452		0	0	0		0	0	0	274159	0	49	40213314		
74733	1632	40213227	2002-07-29	2002-07-29 00:00:00	2002-07-29	2002-07-29 00:00:00	2002-07-29	581452		0	0	0		0	0	0	109605	0	113	40213227		
33084	2743	19128065	1976-03-23	1976-03-23 00:00:00	1977-03-18	1977-03-18 00:00:00	1977-03-18	38000177		0	0	360		0	0	0	181491	0	749882	19128065		
49431	4101	1127433	2014-08-08	2014-08-08 00:00:00	2014-08-15	2014-08-15 00:00:00	2014-08-15	38000177		0	0	7		0	0	0	272525	0	313782	1127433		
34988	763	40213160	1965-08-26	1965-08-26 00:00:00	1965-08-26	1965-08-26 00:00:00	1965-08-26	581452		0	0	0		0	0	0	50739	0	10	40213160		
32700	2709	40229134	2013-10-12	2013-10-12 00:00:00	2013-10-26	2013-10-26 00:00:00	2013-10-26	38000177		0	0	14		0	0	0	179465	0	1043400	40229134		
16417	1360	19128022	1990-09-26	1990-09-26 00:00:00	1991-09-21	1991-09-21 00:00:00	1991-09-21	38000177		0	0	360		0	0	0	90253	0	749785	19128022		
24023	1977	1127433	1993-08-19	1993-08-19 00:00:00	1993-09-09	1993-09-09 00:00:00	1993-09-09	38000177		0	0	21		0	0	0	131625	0	313782	1127433		
21181	1745	1519937	2006-10-30	2006-10-30 00:00:00	2007-10-25	2007-10-25 00:00:00	2007-10-25	38000177		0	0	360		0	0	0	116698	0	389221	1519937		
3277	270	1127433	1985-06-17	1985-06-17 00:00:00	1985-07-08	1985-07-08 00:00:00	1985-07-08	38000177		0	0	21		0	0	0	18024	0	313782	1127433		
61404	5108	1127433	1998-11-20	1998-11-20 00:00:00	1998-11-27	1998-11-27 00:00:00	1998-11-27	38000177		0	0	7		0	0	0	339384	0	313782	1127433		
14961	1250	1127433	1997-10-03	1997-10-03 00:00:00	1997-10-17	1997-10-17 00:00:00	1997-10-17	38000177		0	0	14		0	0	0	82375	0	313782	1127433		
44814	3708	1127078	1980-10-24	1980-10-24 00:00:00	1980-11-07	1980-11-07 00:00:00	1980-11-07	38000177		0	0	14		0	0	0	246539	0	282464	1127078		
38416	3176	19075601	2014-01-04	2014-01-04 00:00:00	2014-01-04	2014-01-04 00:00:00	2014-01-04	38000177		0	0	0		0	0	0	211121	0	309362	19075601		
22179	1821	1127433	2010-02-20	2010-02-20 00:00:00	2010-03-13	2010-03-13 00:00:00	2010-03-13	38000177		0	0	21		0	0	0	121776	0	313782	1127433		
22233	1826	1713671	1978-09-21	1978-09-21 00:00:00	1978-10-12	1978-10-12 00:00:00	1978-10-12	38000177		0	0	21		0	0	0	122065	0	562251	1713671		
61720	5137	1115171	2010-04-24	2010-04-24 00:00:00	2010-05-08	2010-05-08 00:00:00	2010-05-08	38000177		0	0	14		0	0	0	341374	0	849574	1115171		
5855	488	1127433	1969-08-13	1969-08-13 00:00:00	1969-09-12	1969-09-12 00:00:00	1969-09-12	38000177		0	0	30		0	0	0	32698	0	313782	1127433		
53049	4408	19074843	1984-07-20	1984-07-20 00:00:00	1984-08-03	1984-08-03 00:00:00	1984-08-03	38000177		0	0	14		0	0	0	293023	0	309045	19074843		
53093	4411	40236824	1996-07-06	1996-07-06 00:00:00	1996-07-13	1996-07-13 00:00:00	1996-07-13	38000177		0	0	7		0	0	0	293190	0	1094107	40236824		
89245	1956	40213260	2014-07-01	2014-07-01 00:00:00	2014-07-01	2014-07-01 00:00:00	2014-07-01	581452		0	0	0		0	0	0	130102	0	121	40213260		
132214	2904	40213160	1975-04-30	1975-04-30 00:00:00	1975-04-30	1975-04-30 00:00:00	1975-04-30	581452		0	0	0		0	0	0	193508	0	10	40213160		
25261	2079	19078461	2008-01-17	2008-01-17 00:00:00	2008-02-07	2008-02-07 00:00:00	2008-02-07	38000177		0	0	21		0	0	0	138490	0	310965	19078461		
21325	1753	19059056	1965-04-02	1965-04-02 00:00:00	1965-04-16	1965-04-16 00:00:00	1965-04-16	38000177		0	0	14		0	0	0	117208	0	243670	19059056		
25326	2084	19133905	1992-12-07	1992-12-07 00:00:00	1992-12-15	1992-12-15 00:00:00	1992-12-15	38000177		0	0	8		0	0	0	138837	0	834102	19133905		
29033	2402	19059056	1987-01-17	1987-01-17 00:00:00	1987-02-07	1987-02-07 00:00:00	1987-02-07	38000177		0	0	21		0	0	0	159670	0	243670	19059056		
35915	2957	1127433	1949-06-24	1949-06-24 00:00:00	1949-07-08	1949-07-08 00:00:00	1949-07-08	38000177		0	0	14		0	0	0	197372	0	313782	1127433		
52480	4365	40171902	2001-07-23	2001-07-23 00:00:00	2001-07-23	2001-07-23 00:00:00	\N	38000177		0	0	0		0	0	0	289578	0	897718	40171902		
10142	850	19059056	1949-03-09	1949-03-09 00:00:00	1949-03-23	1949-03-23 00:00:00	1949-03-23	38000177		0	0	14		0	0	0	56231	0	243670	19059056		
60133	4999	19018935	2018-01-21	2018-01-21 00:00:00	2018-01-21	2018-01-21 00:00:00	\N	38000177		0	0	0		0	0	0	332478	0	197604	19018935		
51459	4276	1713671	2006-07-01	2006-07-01 00:00:00	2006-07-08	2006-07-08 00:00:00	2006-07-08	38000177		0	0	7		0	0	0	283729	0	562251	1713671		
10251	859	1127433	2007-08-10	2007-08-10 00:00:00	2007-09-07	2007-09-07 00:00:00	2007-09-07	38000177		0	0	28		0	0	0	56878	0	313782	1127433		
3417	283	19128022	1996-08-18	1996-08-18 00:00:00	1997-08-13	1997-08-13 00:00:00	1997-08-13	38000177		0	0	360		0	0	0	18866	0	749785	19128022		
136723	3001	40213160	1955-02-15	1955-02-15 00:00:00	1955-02-15	1955-02-15 00:00:00	1955-02-15	581452		0	0	0		0	0	0	200322	0	10	40213160		
21755	472	40213160	1981-01-04	1981-01-04 00:00:00	1981-01-04	1981-01-04 00:00:00	1981-01-04	581452		0	0	0		0	0	0	31522	0	10	40213160		
25007	2058	40220960	2017-11-15	2017-11-15 00:00:00	2017-11-15	2017-11-15 00:00:00	2017-11-15	38000177		0	0	0		0	0	0	136827	0	1804799	40220960		
57269	4754	1127433	1991-09-13	1991-09-13 00:00:00	1991-09-20	1991-09-20 00:00:00	1991-09-20	38000177		0	0	7		0	0	0	316613	0	313782	1127433		
36538	3013	40229134	1982-05-15	1982-05-15 00:00:00	1982-05-22	1982-05-22 00:00:00	1982-05-22	38000177		0	0	7		0	0	0	200932	0	1043400	40229134		
34354	2837	40229134	1992-04-19	1992-04-19 00:00:00	1992-05-03	1992-05-03 00:00:00	1992-05-03	38000177		0	0	14		0	0	0	188437	0	1043400	40229134		
11735	974	19078461	2013-02-21	2013-02-21 00:00:00	2013-03-14	2013-03-14 00:00:00	2013-03-14	38000177		0	0	21		0	0	0	64967	0	310965	19078461		
39426	3258	19059056	1993-04-15	1993-04-15 00:00:00	1993-05-20	1993-05-20 00:00:00	1993-05-20	38000177		0	0	35		0	0	0	216549	0	243670	19059056		
35194	2903	19059056	1965-12-03	1965-12-03 00:00:00	1965-12-17	1965-12-17 00:00:00	1965-12-17	38000177		0	0	14		0	0	0	193442	0	243670	19059056		
26108	2149	1127433	1996-10-12	1996-10-12 00:00:00	1996-10-19	1996-10-19 00:00:00	1996-10-19	38000177		0	0	7		0	0	0	143128	0	313782	1127433		
23374	1925	19078461	2002-12-17	2002-12-17 00:00:00	2002-12-31	2002-12-31 00:00:00	2002-12-31	38000177		0	0	14		0	0	0	128086	0	310965	19078461		
35309	2909	35605858	1962-04-07	1962-04-07 00:00:00	1962-04-07	1962-04-07 00:00:00	1962-04-07	38000177		0	0	0		0	0	0	193910	0	1732136	35605858		
175602	3860	40213296	2012-07-14	2012-07-14 00:00:00	2012-07-14	2012-07-14 00:00:00	2012-07-14	581452		0	0	0		0	0	0	256288	0	52	40213296		
32949	2731	19078461	2008-04-04	2008-04-04 00:00:00	2008-04-25	2008-04-25 00:00:00	2008-04-25	38000177		0	0	21		0	0	0	180795	0	310965	19078461		
54976	4565	1127433	2004-11-03	2004-11-03 00:00:00	2004-11-17	2004-11-17 00:00:00	2004-11-17	38000177		0	0	14		0	0	0	304179	0	313782	1127433		
186747	4102	40213160	1965-06-28	1965-06-28 00:00:00	1965-06-28	1965-06-28 00:00:00	1965-06-28	581452		0	0	0		0	0	0	272569	0	10	40213160		
117347	2579	40213227	2003-04-27	2003-04-27 00:00:00	2003-04-27	2003-04-27 00:00:00	2003-04-27	581452		0	0	0		0	0	0	170828	0	113	40213227		
47421	3930	19059056	1916-06-19	1916-06-19 00:00:00	1916-07-24	1916-07-24 00:00:00	1916-07-24	38000177		0	0	35		0	0	0	261306	0	243670	19059056		
146015	3211	40213227	2018-01-26	2018-01-26 00:00:00	2018-01-26	2018-01-26 00:00:00	2018-01-26	581452		0	0	0		0	0	0	213329	0	113	40213227		
50920	4229	1115171	1998-01-07	1998-01-07 00:00:00	1998-01-21	1998-01-21 00:00:00	1998-01-21	38000177		0	0	14		0	0	0	280951	0	849574	1115171		
55165	4579	19078461	1999-05-14	1999-05-14 00:00:00	1999-05-28	1999-05-28 00:00:00	1999-05-28	38000177		0	0	14		0	0	0	305012	0	310965	19078461		
49249	4086	40236824	2016-12-16	2016-12-16 00:00:00	2016-12-23	2016-12-23 00:00:00	2016-12-23	38000177		0	0	7		0	0	0	271561	0	1094107	40236824		
60464	1321	40213296	1999-07-08	1999-07-08 00:00:00	1999-07-08	1999-07-08 00:00:00	1999-07-08	581452		0	0	0		0	0	0	87631	0	52	40213296		
17039	1410	46233988	1971-04-23	1971-04-23 00:00:00	1971-05-08	1971-05-08 00:00:00	1971-05-08	38000177		0	0	15		0	0	0	93877	0	1652673	46233988		
58687	4873	19133873	1980-11-25	1980-11-25 00:00:00	1980-12-04	1980-12-04 00:00:00	1980-12-04	38000177		0	0	9		0	0	0	324104	0	834061	19133873		
828	66	1713671	1988-12-17	1988-12-17 00:00:00	1988-12-24	1988-12-24 00:00:00	1988-12-24	38000177		0	0	7		0	0	0	4477	0	562251	1713671		
44044	3647	19006318	1956-05-09	1956-05-09 00:00:00	1956-05-23	1956-05-23 00:00:00	1956-05-23	38000177		0	0	14		0	0	0	242605	0	105078	19006318		
29933	2480	1713671	1968-10-12	1968-10-12 00:00:00	1968-11-02	1968-11-02 00:00:00	1968-11-02	38000177		0	0	21		0	0	0	164331	0	562251	1713671		
29407	2435	1127433	1988-02-07	1988-02-07 00:00:00	1988-02-21	1988-02-21 00:00:00	1988-02-21	38000177		0	0	14		0	0	0	161420	0	313782	1127433		
83207	1819	40213306	1999-10-12	1999-10-12 00:00:00	1999-10-12	1999-10-12 00:00:00	1999-10-12	581452		0	0	0		0	0	0	121662	0	43	40213306		
63540	1389	40213160	1955-11-12	1955-11-12 00:00:00	1955-11-12	1955-11-12 00:00:00	1955-11-12	581452		0	0	0		0	0	0	92154	0	10	40213160		
199049	4373	40213227	2018-01-16	2018-01-16 00:00:00	2018-01-16	2018-01-16 00:00:00	2018-01-16	581452		0	0	0		0	0	0	290340	0	113	40213227		
74736	1632	40213160	1956-07-02	1956-07-02 00:00:00	1956-07-02	1956-07-02 00:00:00	1956-07-02	581452		0	0	0		0	0	0	109609	0	10	40213160		
33085	2743	40231925	1977-07-04	1977-07-04 00:00:00	1977-07-04	1977-07-04 00:00:00	\N	38000177		0	0	0		0	0	0	181451	0	1049221	40231925		
49433	4101	19006318	1965-09-28	1965-09-28 00:00:00	1965-10-12	1965-10-12 00:00:00	1965-10-12	38000177		0	0	14		0	0	0	272517	0	105078	19006318		
81909	1789	40213314	1977-02-03	1977-02-03 00:00:00	1977-02-03	1977-02-03 00:00:00	1977-02-03	581452		0	0	0		0	0	0	119946	0	49	40213314		
32701	2709	19077572	2012-01-17	2012-01-17 00:00:00	2012-01-17	2012-01-17 00:00:00	\N	38000177		0	0	0		0	0	0	179468	0	310436	19077572		
16418	1360	1118084	2018-06-11	2018-06-11 00:00:00	2018-06-11	2018-06-11 00:00:00	\N	38000177		0	0	0		0	0	0	90241	0	00025152531	44923712		
24024	1977	19133905	1988-05-20	1988-05-20 00:00:00	1988-05-30	1988-05-30 00:00:00	1988-05-30	38000177		0	0	10		0	0	0	131560	0	834102	19133905		
21182	1745	19059056	1986-06-05	1986-06-05 00:00:00	1986-08-04	1986-08-04 00:00:00	1986-08-04	38000177		0	0	60		0	0	0	116681	0	243670	19059056		
3278	270	1118084	1995-05-16	1995-05-16 00:00:00	1995-05-16	1995-05-16 00:00:00	\N	38000177		0	0	0		0	0	0	17961	0	00025152531	44923712		
61405	5108	40229134	1999-01-28	1999-01-28 00:00:00	1999-02-11	1999-02-11 00:00:00	1999-02-11	38000177		0	0	14		0	0	0	339411	0	1043400	40229134		
14962	1250	1127433	1961-06-11	1961-06-11 00:00:00	1961-06-18	1961-06-18 00:00:00	1961-06-18	38000177		0	0	7		0	0	0	82328	0	313782	1127433		
44815	3708	19128065	2000-03-23	2000-03-23 00:00:00	2001-03-18	2001-03-18 00:00:00	2001-03-18	38000177		0	0	360		0	0	0	246542	0	749882	19128065		
38417	3176	40220960	2014-01-04	2014-01-04 00:00:00	2014-01-04	2014-01-04 00:00:00	2014-01-04	38000177		0	0	0		0	0	0	211121	0	1804799	40220960		
22180	1821	19133873	1944-07-30	1944-07-30 00:00:00	1944-08-06	1944-08-06 00:00:00	1944-08-06	38000177		0	0	7		0	0	0	121850	0	834061	19133873		
22234	1826	1127433	1965-04-17	1965-04-17 00:00:00	1965-05-01	1965-05-01 00:00:00	1965-05-01	38000177		0	0	14		0	0	0	122015	0	313782	1127433		
61721	5137	19073188	2010-04-24	2010-04-24 00:00:00	2010-05-08	2010-05-08 00:00:00	2010-05-08	38000177		0	0	14		0	0	0	341374	0	308192	19073188		
5856	488	40229134	2002-04-01	2002-04-01 00:00:00	2002-04-15	2002-04-15 00:00:00	2002-04-15	38000177		0	0	14		0	0	0	32651	0	1043400	40229134		
53050	4408	19128022	2000-12-18	2000-12-18 00:00:00	2001-12-13	2001-12-13 00:00:00	2001-12-13	38000177		0	0	360		0	0	0	293004	0	749785	19128022		
53094	4411	1127433	1977-07-15	1977-07-15 00:00:00	1977-07-22	1977-07-22 00:00:00	1977-07-22	38000177		0	0	7		0	0	0	293180	0	313782	1127433		
52175	4340	19006318	1976-04-04	1976-04-04 00:00:00	1976-04-18	1976-04-18 00:00:00	1976-04-18	38000177		0	0	14		0	0	0	287750	0	105078	19006318		
132219	2905	40213296	2007-07-02	2007-07-02 00:00:00	2007-07-02	2007-07-02 00:00:00	2007-07-02	581452		0	0	0		0	0	0	193593	0	52	40213296		
25262	2079	1127433	2002-07-03	2002-07-03 00:00:00	2002-07-17	2002-07-17 00:00:00	2002-07-17	38000177		0	0	14		0	0	0	138489	0	313782	1127433		
21326	1753	19006318	1965-04-02	1965-04-02 00:00:00	1965-04-16	1965-04-16 00:00:00	1965-04-16	38000177		0	0	14		0	0	0	117208	0	105078	19006318		
25327	2084	19006318	1967-02-16	1967-02-16 00:00:00	1967-03-02	1967-03-02 00:00:00	1967-03-02	38000177		0	0	14		0	0	0	138864	0	105078	19006318		
29034	2402	1551192	1990-08-31	1990-08-31 00:00:00	1990-08-31	1990-08-31 00:00:00	1990-08-31	38000177		0	0	0		0	0	0	159672	0	312617	1551192		
173809	3822	40213198	2010-03-29	2010-03-29 00:00:00	2010-03-29	2010-03-29 00:00:00	2010-03-29	581452		0	0	0		0	0	0	253831	0	133	40213198		
52481	4365	1713671	1955-02-10	1955-02-10 00:00:00	1955-02-24	1955-02-24 00:00:00	1955-02-24	38000177		0	0	14		0	0	0	289537	0	562251	1713671		
10143	850	1118084	1990-01-23	1990-01-23 00:00:00	1990-01-23	1990-01-23 00:00:00	\N	38000177		0	0	0		0	0	0	56259	0	00025152531	44923712		
60134	4999	40163554	2018-01-21	2018-01-21 00:00:00	2018-01-21	2018-01-21 00:00:00	\N	38000177		0	0	0		0	0	0	332478	0	855332	40163554		
61919	5150	1127433	2011-06-01	2011-06-01 00:00:00	2011-06-08	2011-06-08 00:00:00	2011-06-08	38000177		0	0	7		0	0	0	342466	0	313782	1127433		
10252	859	40169216	1961-03-10	1961-03-10 00:00:00	1961-03-10	1961-03-10 00:00:00	\N	38000177		0	0	0		0	0	0	56729	0	895994	40169216		
3418	283	19078461	2004-06-18	2004-06-18 00:00:00	2004-07-02	2004-07-02 00:00:00	2004-07-02	38000177		0	0	14		0	0	0	18883	0	310965	19078461		
136733	3001	40213201	2014-02-18	2014-02-18 00:00:00	2014-02-18	2014-02-18 00:00:00	2014-02-18	581452		0	0	0		0	0	0	200259	0	33	40213201		
21757	472	40213160	1976-05-02	1976-05-02 00:00:00	1976-05-02	1976-05-02 00:00:00	1976-05-02	581452		0	0	0		0	0	0	31537	0	10	40213160		
25008	2058	19075601	2017-11-15	2017-11-15 00:00:00	2017-11-15	2017-11-15 00:00:00	2017-11-15	38000177		0	0	0		0	0	0	136827	0	309362	19075601		
57270	4754	1127433	1968-07-03	1968-07-03 00:00:00	1968-07-17	1968-07-17 00:00:00	1968-07-17	38000177		0	0	14		0	0	0	316653	0	313782	1127433		
36540	3013	1118084	1992-10-02	1992-10-02 00:00:00	1992-10-02	1992-10-02 00:00:00	\N	38000177		0	0	0		0	0	0	200904	0	00025152531	44923712		
34355	2837	40229134	2008-10-11	2008-10-11 00:00:00	2008-10-25	2008-10-25 00:00:00	2008-10-25	38000177		0	0	14		0	0	0	188420	0	1043400	40229134		
11736	975	1127078	1966-12-05	1966-12-05 00:00:00	1966-12-19	1966-12-19 00:00:00	1966-12-19	38000177		0	0	14		0	0	0	65039	0	282464	1127078		
39427	3258	40236824	2008-06-30	2008-06-30 00:00:00	2008-07-07	2008-07-07 00:00:00	2008-07-07	38000177		0	0	7		0	0	0	216561	0	1094107	40236824		
35195	2903	19129655	1965-12-03	1965-12-03 00:00:00	1965-12-17	1965-12-17 00:00:00	1965-12-17	38000177		0	0	14		0	0	0	193442	0	789980	19129655		
26109	2149	1127078	1960-02-12	1960-02-12 00:00:00	1960-03-04	1960-03-04 00:00:00	1960-03-04	38000177		0	0	21		0	0	0	143075	0	282464	1127078		
5504	119	40213260	2005-12-27	2005-12-27 00:00:00	2005-12-27	2005-12-27 00:00:00	2005-12-27	581452		0	0	0		0	0	0	7891	0	121	40213260		
35310	2909	42707627	1962-04-07	1962-04-07 00:00:00	1962-04-07	1962-04-07 00:00:00	1962-04-07	38000177		0	0	0		0	0	0	193910	0	1234995	42707627		
175605	3860	40213296	2014-02-15	2014-02-15 00:00:00	2014-02-15	2014-02-15 00:00:00	2014-02-15	581452		0	0	0		0	0	0	256328	0	52	40213296		
32950	2731	19059056	1990-03-21	1990-03-21 00:00:00	1990-04-18	1990-04-18 00:00:00	1990-04-18	38000177		0	0	28		0	0	0	180791	0	243670	19059056		
54977	4565	1127433	2012-10-23	2012-10-23 00:00:00	2012-10-30	2012-10-30 00:00:00	2012-10-30	38000177		0	0	7		0	0	0	304258	0	313782	1127433		
186752	4102	40213227	1996-10-28	1996-10-28 00:00:00	1996-10-28	1996-10-28 00:00:00	1996-10-28	581452		0	0	0		0	0	0	272612	0	113	40213227		
117349	2579	40213160	1955-03-27	1955-03-27 00:00:00	1955-03-27	1955-03-27 00:00:00	1955-03-27	581452		0	0	0		0	0	0	170777	0	10	40213160		
47422	3930	40169281	1964-11-28	1964-11-28 00:00:00	1964-11-28	1964-11-28 00:00:00	\N	38000177		0	0	0		0	0	0	261292	0	896209	40169281		
146023	3212	40213160	1982-04-06	1982-04-06 00:00:00	1982-04-06	1982-04-06 00:00:00	1982-04-06	581452		0	0	0		0	0	0	213453	0	10	40213160		
50921	4229	19073188	1998-01-07	1998-01-07 00:00:00	1998-01-21	1998-01-21 00:00:00	1998-01-21	38000177		0	0	14		0	0	0	280951	0	308192	19073188		
55166	4579	1127078	1977-11-18	1977-11-18 00:00:00	1978-02-16	1978-02-16 00:00:00	1978-02-16	38000177		0	0	90		0	0	0	305005	0	282464	1127078		
49250	4086	920300	2016-12-16	2016-12-16 00:00:00	2016-12-23	2016-12-23 00:00:00	2016-12-23	38000177		0	0	7		0	0	0	271561	0	311989	920300		
94017	2063	40213227	2015-05-22	2015-05-22 00:00:00	2015-05-22	2015-05-22 00:00:00	2015-05-22	581452		0	0	0		0	0	0	137258	0	113	40213227		
17040	1411	1118084	2002-11-11	2002-11-11 00:00:00	2002-11-11	2002-11-11 00:00:00	\N	38000177		0	0	0		0	0	0	93953	0	00025152531	44923712		
58688	4873	1127078	1979-06-20	1979-06-20 00:00:00	1979-07-04	1979-07-04 00:00:00	1979-07-04	38000177		0	0	14		0	0	0	324116	0	282464	1127078		
830	66	1115171	2016-02-26	2016-02-26 00:00:00	2016-03-27	2016-03-27 00:00:00	2016-03-27	38000177		0	0	30		0	0	0	4450	0	849574	1115171		
44045	3647	1118084	1970-01-01	1970-01-01 00:00:00	1970-01-01	1970-01-01 00:00:00	\N	38000177		0	0	0		0	0	0	242692	0	00025152531	44923712		
29934	2480	1127433	1975-07-21	1975-07-21 00:00:00	1975-08-04	1975-08-04 00:00:00	1975-08-04	38000177		0	0	14		0	0	0	164301	0	313782	1127433		
29408	2435	19128022	1993-10-07	1993-10-07 00:00:00	1994-10-02	1994-10-02 00:00:00	1994-10-02	38000177		0	0	360		0	0	0	161422	0	749785	19128022		
83213	1819	40213306	1998-04-21	1998-04-21 00:00:00	1998-04-21	1998-04-21 00:00:00	1998-04-21	581452		0	0	0		0	0	0	\N	0	43	40213306		
74828	1634	40213227	2010-08-06	2010-08-06 00:00:00	2010-08-06	2010-08-06 00:00:00	2010-08-06	581452		0	0	0		0	0	0	109766	0	113	40213227		
199051	4373	40213227	2007-04-24	2007-04-24 00:00:00	2007-04-24	2007-04-24 00:00:00	2007-04-24	581452		0	0	0		0	0	0	290435	0	113	40213227		
74752	1632	40213198	2017-04-03	2017-04-03 00:00:00	2017-04-03	2017-04-03 00:00:00	2017-04-03	581452		0	0	0		0	0	0	109556	0	133	40213198		
33086	2743	1127433	1977-07-04	1977-07-04 00:00:00	1977-10-02	1977-10-02 00:00:00	1977-10-02	38000177		0	0	90		0	0	0	181451	0	313782	1127433		
49434	4101	1127078	1965-09-28	1965-09-28 00:00:00	1965-10-12	1965-10-12 00:00:00	1965-10-12	38000177		0	0	14		0	0	0	272517	0	282464	1127078		
81912	1789	40213296	2017-06-08	2017-06-08 00:00:00	2017-06-08	2017-06-08 00:00:00	2017-06-08	581452		0	0	0		0	0	0	119917	0	52	40213296		
32702	2709	19059056	1942-12-20	1942-12-20 00:00:00	1943-01-17	1943-01-17 00:00:00	1943-01-17	38000177		0	0	28		0	0	0	179446	0	243670	19059056		
16419	1360	40236824	2014-10-30	2014-10-30 00:00:00	2014-11-06	2014-11-06 00:00:00	2014-11-06	38000177		0	0	7		0	0	0	90285	0	1094107	40236824		
24025	1977	1713671	1973-09-07	1973-09-07 00:00:00	1973-09-28	1973-09-28 00:00:00	1973-09-28	38000177		0	0	21		0	0	0	131559	0	562251	1713671		
21183	1745	19128022	1997-12-16	1997-12-16 00:00:00	1998-12-11	1998-12-11 00:00:00	1998-12-11	38000177		0	0	360		0	0	0	116675	0	749785	19128022		
3279	270	1713671	1994-06-19	1994-06-19 00:00:00	1994-07-03	1994-07-03 00:00:00	1994-07-03	38000177		0	0	14		0	0	0	17961	0	562251	1713671		
61406	5108	1127433	2002-11-14	2002-11-14 00:00:00	2002-11-28	2002-11-28 00:00:00	2002-11-28	38000177		0	0	14		0	0	0	339400	0	313782	1127433		
14963	1250	19078461	1981-03-26	1981-03-26 00:00:00	1981-04-30	1981-04-30 00:00:00	1981-04-30	38000177		0	0	35		0	0	0	82334	0	310965	19078461		
44816	3708	1551192	1978-01-08	1978-01-08 00:00:00	1978-01-08	1978-01-08 00:00:00	1978-01-08	38000177		0	0	0		0	0	0	246505	0	312617	1551192		
38418	3176	19078461	1989-02-16	1989-02-16 00:00:00	1989-03-16	1989-03-16 00:00:00	1989-03-16	38000177		0	0	28		0	0	0	211123	0	310965	19078461		
22181	1821	1127433	2016-02-14	2016-02-14 00:00:00	2016-02-21	2016-02-21 00:00:00	2016-02-21	38000177		0	0	7		0	0	0	121798	0	313782	1127433		
22235	1826	19059056	1940-01-27	1940-01-27 00:00:00	1940-02-10	1940-02-10 00:00:00	1940-02-10	38000177		0	0	14		0	0	0	122046	0	243670	19059056		
61722	5137	1127433	1970-11-04	1970-11-04 00:00:00	1970-11-18	1970-11-18 00:00:00	1970-11-18	38000177		0	0	14		0	0	0	341428	0	313782	1127433		
5857	488	19133873	1958-06-13	1958-06-13 00:00:00	1958-06-25	1958-06-25 00:00:00	1958-06-25	38000177		0	0	12		0	0	0	32615	0	834061	19133873		
5863	489	1118084	2016-09-03	2016-09-03 00:00:00	2016-09-03	2016-09-03 00:00:00	\N	38000177		0	0	0		0	0	0	32770	0	00025152531	44923712		
53096	4411	1713671	1979-02-16	1979-02-16 00:00:00	1979-02-23	1979-02-23 00:00:00	1979-02-23	38000177		0	0	7		0	0	0	293230	0	562251	1713671		
52176	4340	1118084	2010-01-31	2010-01-31 00:00:00	2010-01-31	2010-01-31 00:00:00	\N	38000177		0	0	0		0	0	0	287764	0	00025152531	44923712		
132222	2905	40213260	2016-11-28	2016-11-28 00:00:00	2016-11-28	2016-11-28 00:00:00	2016-11-28	581452		0	0	0		0	0	0	193580	0	121	40213260		
25263	2079	1127433	1970-05-25	1970-05-25 00:00:00	1970-06-01	1970-06-01 00:00:00	1970-06-01	38000177		0	0	7		0	0	0	138475	0	313782	1127433		
21327	1753	1127433	1988-06-02	1988-06-02 00:00:00	1988-06-09	1988-06-09 00:00:00	1988-06-09	38000177		0	0	7		0	0	0	117214	0	313782	1127433		
25328	2084	1127078	1967-02-16	1967-02-16 00:00:00	1967-03-02	1967-03-02 00:00:00	1967-03-02	38000177		0	0	14		0	0	0	138864	0	282464	1127078		
29035	2402	40169216	1978-09-20	1978-09-20 00:00:00	1978-09-20	1978-09-20 00:00:00	\N	38000177		0	0	0		0	0	0	159573	0	895994	40169216		
150593	3313	40213296	1998-04-03	1998-04-03 00:00:00	1998-04-03	1998-04-03 00:00:00	1998-04-03	581452		0	0	0		0	0	0	220022	0	52	40213296		
52482	4365	1127433	2005-12-09	2005-12-09 00:00:00	2005-12-23	2005-12-23 00:00:00	2005-12-23	38000177		0	0	14		0	0	0	289524	0	313782	1127433		
10144	850	1713671	1968-12-15	1968-12-15 00:00:00	1968-12-22	1968-12-22 00:00:00	1968-12-22	38000177		0	0	7		0	0	0	56190	0	562251	1713671		
60135	4999	19128065	1975-10-20	1975-10-20 00:00:00	1976-10-14	1976-10-14 00:00:00	1976-10-14	38000177		0	0	360		0	0	0	332485	0	749882	19128065		
61920	5150	19078461	2004-05-20	2004-05-20 00:00:00	2004-06-03	2004-06-03 00:00:00	2004-06-03	38000177		0	0	14		0	0	0	342337	0	310965	19078461		
10253	859	1154615	1961-03-10	1961-03-10 00:00:00	1961-03-10	1961-03-10 00:00:00	\N	38000177		0	0	0		0	0	0	56729	0	745679	1154615		
10370	222	40213198	2016-12-09	2016-12-09 00:00:00	2016-12-09	2016-12-09 00:00:00	2016-12-09	581452		0	0	0		0	0	0	14898	0	133	40213198		
136744	3001	40213198	2012-03-20	2012-03-20 00:00:00	2012-03-20	2012-03-20 00:00:00	2012-03-20	581452		0	0	0		0	0	0	200258	0	133	40213198		
13359	289	40213160	1959-11-23	1959-11-23 00:00:00	1959-11-23	1959-11-23 00:00:00	1959-11-23	581452		0	0	0		0	0	0	19264	0	10	40213160		
25009	2058	1127433	1972-09-26	1972-09-26 00:00:00	1972-10-03	1972-10-03 00:00:00	1972-10-03	38000177		0	0	7		0	0	0	136870	0	313782	1127433		
11580	248	40213227	1995-03-21	1995-03-21 00:00:00	1995-03-21	1995-03-21 00:00:00	1995-03-21	581452		0	0	0		0	0	0	16722	0	113	40213227		
36541	3014	40229134	2000-03-19	2000-03-19 00:00:00	2000-03-26	2000-03-26 00:00:00	2000-03-26	38000177		0	0	7		0	0	0	200987	0	1043400	40229134		
34356	2837	1118084	2008-01-10	2008-01-10 00:00:00	2008-01-10	2008-01-10 00:00:00	\N	38000177		0	0	0		0	0	0	188471	0	00025152531	44923712		
3672	80	40213201	2002-12-09	2002-12-09 00:00:00	2002-12-09	2002-12-09 00:00:00	2002-12-09	581452		0	0	0		0	0	0	5367	0	33	40213201		
39428	3258	920300	2008-06-30	2008-06-30 00:00:00	2008-07-07	2008-07-07 00:00:00	2008-07-07	38000177		0	0	7		0	0	0	216561	0	311989	920300		
35196	2903	1124300	2000-05-23	2000-05-23 00:00:00	2000-05-23	2000-05-23 00:00:00	\N	38000177		0	0	0		0	0	0	193467	0	00781178901	45011828		
26110	2149	19075601	2005-11-12	2005-11-12 00:00:00	2005-11-12	2005-11-12 00:00:00	2005-11-12	38000177		0	0	0		0	0	0	143066	0	309362	19075601		
5519	119	40213227	2017-02-28	2017-02-28 00:00:00	2017-02-28	2017-02-28 00:00:00	2017-02-28	581452		0	0	0		0	0	0	7893	0	113	40213227		
35311	2909	782047	1962-04-07	1962-04-07 00:00:00	1962-04-07	1962-04-07 00:00:00	1962-04-07	38000177		0	0	0		0	0	0	193910	0	542347	782047		
175607	3860	40213227	2014-02-15	2014-02-15 00:00:00	2014-02-15	2014-02-15 00:00:00	2014-02-15	581452		0	0	0		0	0	0	256328	0	113	40213227		
32951	2731	19078461	2001-07-19	2001-07-19 00:00:00	2001-08-09	2001-08-09 00:00:00	2001-08-09	38000177		0	0	21		0	0	0	180793	0	310965	19078461		
54978	4565	920300	1999-08-29	1999-08-29 00:00:00	1999-09-05	1999-09-05 00:00:00	1999-09-05	38000177		0	0	7		0	0	0	304192	0	311989	920300		
186757	4102	40213306	1987-10-19	1987-10-19 00:00:00	1987-10-19	1987-10-19 00:00:00	1987-10-19	581452		0	0	0		0	0	0	272608	0	43	40213306		
117350	2579	40213260	2006-05-14	2006-05-14 00:00:00	2006-05-14	2006-05-14 00:00:00	2006-05-14	581452		0	0	0		0	0	0	170832	0	121	40213260		
47431	3932	1127433	1982-05-12	1982-05-12 00:00:00	1982-05-26	1982-05-26 00:00:00	1982-05-26	38000177		0	0	14		0	0	0	261403	0	313782	1127433		
146027	3212	40213314	1981-11-03	1981-11-03 00:00:00	1981-11-03	1981-11-03 00:00:00	1981-11-03	581452		0	0	0		0	0	0	213452	0	49	40213314		
50922	4229	1127433	2008-08-14	2008-08-14 00:00:00	2008-08-28	2008-08-28 00:00:00	2008-08-28	38000177		0	0	14		0	0	0	280949	0	313782	1127433		
55167	4579	1124300	2008-03-20	2008-03-20 00:00:00	2008-03-20	2008-03-20 00:00:00	\N	38000177		0	0	0		0	0	0	305050	0	00781178901	45011828		
49251	4086	1124300	2016-08-31	2016-08-31 00:00:00	2016-08-31	2016-08-31 00:00:00	\N	38000177		0	0	0		0	0	0	271598	0	00781178901	45011828		
94018	2063	40213296	2015-05-22	2015-05-22 00:00:00	2015-05-22	2015-05-22 00:00:00	2015-05-22	581452		0	0	0		0	0	0	137258	0	52	40213296		
17042	1411	40165015	1996-03-29	1996-03-29 00:00:00	1996-03-29	1996-03-29 00:00:00	\N	38000177		0	0	0		0	0	0	93977	0	861467	40165015		
58689	4873	19074843	1979-06-20	1979-06-20 00:00:00	1979-07-04	1979-07-04 00:00:00	1979-07-04	38000177		0	0	14		0	0	0	324116	0	309045	19074843		
11289	940	1332419	1994-12-08	1994-12-08 00:00:00	1994-12-08	1994-12-08 00:00:00	\N	38000177		0	0	0		0	0	0	62547	0	197361	1332419		
44046	3647	40220960	1992-08-19	1992-08-19 00:00:00	1992-08-19	1992-08-19 00:00:00	1992-08-19	38000177		0	0	0		0	0	0	242650	0	1804799	40220960		
29935	2480	1127078	1957-01-25	1957-01-25 00:00:00	1957-02-08	1957-02-08 00:00:00	1957-02-08	38000177		0	0	14		0	0	0	164334	0	282464	1127078		
29409	2435	19133873	1981-04-15	1981-04-15 00:00:00	1981-04-28	1981-04-28 00:00:00	1981-04-28	38000177		0	0	13		0	0	0	161417	0	834061	19133873		
83214	1819	40213296	2017-05-30	2017-05-30 00:00:00	2017-05-30	2017-05-30 00:00:00	2017-05-30	581452		0	0	0		0	0	0	121703	0	52	40213296		
55249	1211	40213306	1984-12-05	1984-12-05 00:00:00	1984-12-05	1984-12-05 00:00:00	1984-12-05	581452		0	0	0		0	0	0	\N	0	43	40213306		
199067	4374	40213314	1977-02-03	1977-02-03 00:00:00	1977-02-03	1977-02-03 00:00:00	1977-02-03	581452		0	0	0		0	0	0	290470	0	49	40213314		
74762	1632	40213160	1955-06-27	1955-06-27 00:00:00	1955-06-27	1955-06-27 00:00:00	1955-06-27	581452		0	0	0		0	0	0	109576	0	10	40213160		
33087	2743	920300	1995-05-12	1995-05-12 00:00:00	1995-05-19	1995-05-19 00:00:00	1995-05-19	38000177		0	0	7		0	0	0	181502	0	311989	920300		
49436	4101	19133873	1971-06-08	1971-06-08 00:00:00	1971-06-20	1971-06-20 00:00:00	1971-06-20	38000177		0	0	12		0	0	0	272510	0	834061	19133873		
81914	1789	40213227	2017-06-08	2017-06-08 00:00:00	2017-06-08	2017-06-08 00:00:00	2017-06-08	581452		0	0	0		0	0	0	119917	0	113	40213227		
43161	3576	1127433	1992-03-25	1992-03-25 00:00:00	1992-04-01	1992-04-01 00:00:00	1992-04-01	38000177		0	0	7		0	0	0	237716	0	313782	1127433		
16420	1360	920300	2014-10-30	2014-10-30 00:00:00	2014-11-06	2014-11-06 00:00:00	2014-11-06	38000177		0	0	7		0	0	0	90285	0	311989	920300		
24026	1977	1127433	1922-01-10	1922-01-10 00:00:00	1922-01-24	1922-01-24 00:00:00	1922-01-24	38000177		0	0	14		0	0	0	131505	0	313782	1127433		
21184	1745	19132304	2008-10-23	2008-10-23 00:00:00	2009-10-22	2009-10-22 00:00:00	2009-10-22	38000177		0	0	364		0	0	0	116654	0	807283	19132304		
3280	270	1713671	2000-08-21	2000-08-21 00:00:00	2000-08-28	2000-08-28 00:00:00	2000-08-28	38000177		0	0	7		0	0	0	17962	0	562251	1713671		
61407	5108	1127078	1961-06-22	1961-06-22 00:00:00	1961-07-06	1961-07-06 00:00:00	1961-07-06	38000177		0	0	14		0	0	0	339385	0	282464	1127078		
54393	4521	1127433	1996-12-15	1996-12-15 00:00:00	1997-02-13	1997-02-13 00:00:00	1997-02-13	38000177		0	0	60		0	0	0	301015	0	313782	1127433		
44817	3708	1713671	1992-02-09	1992-02-09 00:00:00	1992-02-16	1992-02-16 00:00:00	1992-02-16	38000177		0	0	7		0	0	0	246519	0	562251	1713671		
38419	3176	1713671	1999-06-11	1999-06-11 00:00:00	1999-06-25	1999-06-25 00:00:00	1999-06-25	38000177		0	0	14		0	0	0	211200	0	562251	1713671		
22182	1821	1713671	1981-07-04	1981-07-04 00:00:00	1981-07-11	1981-07-11 00:00:00	1981-07-11	38000177		0	0	7		0	0	0	121813	0	562251	1713671		
31036	2572	1118084	2009-07-04	2009-07-04 00:00:00	2009-07-04	2009-07-04 00:00:00	\N	38000177		0	0	0		0	0	0	170401	0	00025152531	44923712		
61723	5137	40236824	1997-07-18	1997-07-18 00:00:00	1997-07-25	1997-07-25 00:00:00	1997-07-25	38000177		0	0	7		0	0	0	341431	0	1094107	40236824		
5858	489	19078461	2000-08-02	2000-08-02 00:00:00	2000-08-30	2000-08-30 00:00:00	2000-08-30	38000177		0	0	28		0	0	0	32706	0	310965	19078461		
5864	489	1127078	1975-11-28	1975-11-28 00:00:00	1975-12-12	1975-12-12 00:00:00	1975-12-12	38000177		0	0	14		0	0	0	32739	0	282464	1127078		
54335	1189	40213306	1986-02-03	1986-02-03 00:00:00	1986-02-03	1986-02-03 00:00:00	1986-02-03	581452		0	0	0		0	0	0	78369	0	43	40213306		
52177	4340	19133873	1978-11-03	1978-11-03 00:00:00	1978-11-16	1978-11-16 00:00:00	1978-11-16	38000177		0	0	13		0	0	0	287747	0	834061	19133873		
132229	2905	40213160	1967-08-07	1967-08-07 00:00:00	1967-08-07	1967-08-07 00:00:00	1967-08-07	581452		0	0	0		0	0	0	193547	0	10	40213160		
25264	2079	1127433	1989-05-21	1989-05-21 00:00:00	1989-05-28	1989-05-28 00:00:00	1989-05-28	38000177		0	0	7		0	0	0	138493	0	313782	1127433		
21328	1755	1127433	1995-12-06	1995-12-06 00:00:00	1995-12-27	1995-12-27 00:00:00	1995-12-27	38000177		0	0	21		0	0	0	117377	0	313782	1127433		
25329	2084	40236824	1995-11-03	1995-11-03 00:00:00	1995-11-10	1995-11-10 00:00:00	1995-11-10	38000177		0	0	7		0	0	0	138838	0	1094107	40236824		
29036	2402	1154615	1978-09-20	1978-09-20 00:00:00	1978-09-20	1978-09-20 00:00:00	\N	38000177		0	0	0		0	0	0	159573	0	745679	1154615		
150600	3313	40213160	1955-09-30	1955-09-30 00:00:00	1955-09-30	1955-09-30 00:00:00	1955-09-30	581452		0	0	0		0	0	0	220000	0	10	40213160		
52483	4365	1127433	1976-03-12	1976-03-12 00:00:00	1976-03-26	1976-03-26 00:00:00	1976-03-26	38000177		0	0	14		0	0	0	289585	0	313782	1127433		
10145	851	19133905	2009-07-08	2009-07-08 00:00:00	2009-07-15	2009-07-15 00:00:00	2009-07-15	38000177		0	0	7		0	0	0	56306	0	834102	19133905		
60136	4999	19128065	1980-09-23	1980-09-23 00:00:00	1981-09-18	1981-09-18 00:00:00	1981-09-18	38000177		0	0	360		0	0	0	332438	0	749882	19128065		
61921	5150	1124300	1976-07-19	1976-07-19 00:00:00	1976-07-19	1976-07-19 00:00:00	\N	38000177		0	0	0		0	0	0	342367	0	00781178901	45011828		
10254	859	40229134	2003-06-17	2003-06-17 00:00:00	2003-06-24	2003-06-24 00:00:00	2003-06-24	38000177		0	0	7		0	0	0	56796	0	1043400	40229134		
10382	222	40213160	1955-02-18	1955-02-18 00:00:00	1955-02-18	1955-02-18 00:00:00	1955-02-18	581452		0	0	0		0	0	0	14903	0	10	40213160		
136746	3002	40213296	2013-07-09	2013-07-09 00:00:00	2013-07-09	2013-07-09 00:00:00	2013-07-09	581452		0	0	0		0	0	0	200345	0	52	40213296		
13360	289	40213160	1959-08-25	1959-08-25 00:00:00	1959-08-25	1959-08-25 00:00:00	1959-08-25	581452		0	0	0		0	0	0	19286	0	10	40213160		
25010	2058	1118084	2000-08-03	2000-08-03 00:00:00	2000-08-03	2000-08-03 00:00:00	\N	38000177		0	0	0		0	0	0	136808	0	00025152531	44923712		
11581	248	40213306	1995-03-21	1995-03-21 00:00:00	1995-03-21	1995-03-21 00:00:00	1995-03-21	581452		0	0	0		0	0	0	16722	0	43	40213306		
36543	3014	40162522	2013-06-12	2013-06-12 00:00:00	2013-06-12	2013-06-12 00:00:00	\N	38000177		0	0	0		0	0	0	201034	0	857005	40162522		
34358	2839	1127433	1977-11-22	1977-11-22 00:00:00	1977-12-06	1977-12-06 00:00:00	1977-12-06	38000177		0	0	14		0	0	0	188550	0	313782	1127433		
3686	80	40213227	1997-11-10	1997-11-10 00:00:00	1997-11-10	1997-11-10 00:00:00	1997-11-10	581452		0	0	0		0	0	0	5408	0	113	40213227		
39429	3258	19075001	1983-03-25	1983-03-25 00:00:00	1983-04-08	1983-04-08 00:00:00	1983-04-08	38000177		0	0	14		0	0	0	216615	0	309097	19075001		
35197	2903	920300	1998-10-08	1998-10-08 00:00:00	1998-10-15	1998-10-15 00:00:00	1998-10-15	38000177		0	0	7		0	0	0	193467	0	311989	920300		
26111	2149	40220960	2005-11-12	2005-11-12 00:00:00	2005-11-12	2005-11-12 00:00:00	2005-11-12	38000177		0	0	0		0	0	0	143066	0	1804799	40220960		
5520	120	40213160	1978-09-16	1978-09-16 00:00:00	1978-09-16	1978-09-16 00:00:00	1978-09-16	581452		0	0	0		0	0	0	7957	0	10	40213160		
35312	2909	19079524	1962-04-07	1962-04-07 00:00:00	1962-04-08	1962-04-08 00:00:00	1962-04-08	38000177		0	0	1		0	0	0	193910	0	313002	19079524		
37288	814	40213160	1980-10-18	1980-10-18 00:00:00	1980-10-18	1980-10-18 00:00:00	1980-10-18	581452		0	0	0		0	0	0	53958	0	10	40213160		
32952	2731	40236824	2008-07-29	2008-07-29 00:00:00	2008-08-05	2008-08-05 00:00:00	2008-08-05	38000177		0	0	7		0	0	0	180758	0	1094107	40236824		
54979	4565	40236824	1999-08-29	1999-08-29 00:00:00	1999-09-05	1999-09-05 00:00:00	1999-09-05	38000177		0	0	7		0	0	0	304192	0	1094107	40236824		
186763	4102	40213160	1965-08-30	1965-08-30 00:00:00	1965-08-30	1965-08-30 00:00:00	1965-08-30	581452		0	0	0		0	0	0	272602	0	10	40213160		
117354	2579	40213198	2017-06-04	2017-06-04 00:00:00	2017-06-04	2017-06-04 00:00:00	2017-06-04	581452		0	0	0		0	0	0	170835	0	133	40213198		
47432	3932	19133873	1975-09-17	1975-09-17 00:00:00	1975-09-24	1975-09-24 00:00:00	1975-09-24	38000177		0	0	7		0	0	0	261401	0	834061	19133873		
146028	3212	40213160	1981-11-03	1981-11-03 00:00:00	1981-11-03	1981-11-03 00:00:00	1981-11-03	581452		0	0	0		0	0	0	213452	0	10	40213160		
50923	4229	1127433	2011-10-20	2011-10-20 00:00:00	2011-10-27	2011-10-27 00:00:00	2011-10-27	38000177		0	0	7		0	0	0	280903	0	313782	1127433		
55168	4579	1127433	1969-07-05	1969-07-05 00:00:00	1969-07-19	1969-07-19 00:00:00	1969-07-19	38000177		0	0	14		0	0	0	305027	0	313782	1127433		
49252	4086	40169281	2010-06-10	2010-06-10 00:00:00	2010-06-10	2010-06-10 00:00:00	\N	38000177		0	0	0		0	0	0	271610	0	896209	40169281		
94023	2063	40213227	2004-02-27	2004-02-27 00:00:00	2004-02-27	2004-02-27 00:00:00	2004-02-27	581452		0	0	0		0	0	0	137245	0	113	40213227		
17043	1411	35605482	1999-11-23	1999-11-23 00:00:00	1999-11-23	1999-11-23 00:00:00	1999-11-23	38000177		0	0	0		0	0	0	93967	0	1740467	35605482		
58690	4873	40236824	1996-08-04	1996-08-04 00:00:00	1996-08-11	1996-08-11 00:00:00	1996-08-11	38000177		0	0	7		0	0	0	324112	0	1094107	40236824		
11290	940	1539411	1992-11-26	1992-11-26 00:00:00	1992-11-26	1992-11-26 00:00:00	\N	38000177		0	0	0		0	0	0	62546	0	312961	1539411		
44047	3647	1127433	2018-06-25	2018-06-25 00:00:00	2018-07-09	2018-07-09 00:00:00	2018-07-09	38000177		0	0	14		0	0	0	242604	0	313782	1127433		
29936	2480	19006318	1957-01-25	1957-01-25 00:00:00	1957-02-08	1957-02-08 00:00:00	1957-02-08	38000177		0	0	14		0	0	0	164334	0	105078	19006318		
29410	2435	19128065	1992-10-12	1992-10-12 00:00:00	1993-10-07	1993-10-07 00:00:00	1993-10-07	38000177		0	0	360		0	0	0	161390	0	749882	19128065		
83216	1819	40213314	1977-11-01	1977-11-01 00:00:00	1977-11-01	1977-11-01 00:00:00	1977-11-01	581452		0	0	0		0	0	0	121691	0	49	40213314		
55252	1211	40213160	1964-07-01	1964-07-01 00:00:00	1964-07-01	1964-07-01 00:00:00	1964-07-01	581452		0	0	0		0	0	0	79588	0	10	40213160		
199069	4374	40213160	1977-02-03	1977-02-03 00:00:00	1977-02-03	1977-02-03 00:00:00	1977-02-03	581452		0	0	0		0	0	0	290470	0	10	40213160		
74769	1632	40213227	2013-03-11	2013-03-11 00:00:00	2013-03-11	2013-03-11 00:00:00	2013-03-11	581452		0	0	0		0	0	0	109553	0	113	40213227		
33088	2743	40236824	1995-05-12	1995-05-12 00:00:00	1995-05-19	1995-05-19 00:00:00	1995-05-19	38000177		0	0	7		0	0	0	181502	0	1094107	40236824		
49437	4101	1713671	1992-07-09	1992-07-09 00:00:00	1992-07-16	1992-07-16 00:00:00	1992-07-16	38000177		0	0	7		0	0	0	272475	0	562251	1713671		
81918	1789	40213160	1975-11-06	1975-11-06 00:00:00	1975-11-06	1975-11-06 00:00:00	1975-11-06	581452		0	0	0		0	0	0	119937	0	10	40213160		
43162	3576	1713671	1987-02-26	1987-02-26 00:00:00	1987-03-19	1987-03-19 00:00:00	1987-03-19	38000177		0	0	21		0	0	0	237710	0	562251	1713671		
16421	1360	19019979	1977-08-30	1977-08-30 00:00:00	1977-09-13	1977-09-13 00:00:00	1977-09-13	38000177		0	0	14		0	0	0	90269	0	198405	19019979		
24027	1977	1127433	1984-12-18	1984-12-18 00:00:00	1985-01-01	1985-01-01 00:00:00	1985-01-01	38000177		0	0	14		0	0	0	131650	0	313782	1127433		
21185	1745	19128022	1999-12-06	1999-12-06 00:00:00	2000-11-30	2000-11-30 00:00:00	2000-11-30	38000177		0	0	360		0	0	0	116690	0	749785	19128022		
3281	270	19059056	1965-07-27	1965-07-27 00:00:00	1965-08-10	1965-08-10 00:00:00	1965-08-10	38000177		0	0	14		0	0	0	18022	0	243670	19059056		
61408	5108	19129655	1961-06-22	1961-06-22 00:00:00	1961-07-06	1961-07-06 00:00:00	1961-07-06	38000177		0	0	14		0	0	0	339385	0	789980	19129655		
54394	4521	1127433	1976-02-19	1976-02-19 00:00:00	1976-02-26	1976-02-26 00:00:00	1976-02-26	38000177		0	0	7		0	0	0	301007	0	313782	1127433		
44818	3708	42902245	2001-03-18	2001-03-18 00:00:00	2002-03-13	2002-03-13 00:00:00	2002-03-13	38000177		0	0	360		0	0	0	246543	0	1359133	42902245		
38420	3176	1127078	1976-05-28	1976-05-28 00:00:00	1976-06-11	1976-06-11 00:00:00	1976-06-11	38000177		0	0	14		0	0	0	211155	0	282464	1127078		
22183	1821	1127433	1998-10-07	1998-10-07 00:00:00	1998-10-21	1998-10-21 00:00:00	1998-10-21	38000177		0	0	14		0	0	0	121775	0	313782	1127433		
31037	2572	1127433	2005-01-18	2005-01-18 00:00:00	2005-01-25	2005-01-25 00:00:00	2005-01-25	38000177		0	0	7		0	0	0	170347	0	313782	1127433		
61724	5137	920300	1997-07-18	1997-07-18 00:00:00	1997-07-25	1997-07-25 00:00:00	1997-07-25	38000177		0	0	7		0	0	0	341431	0	311989	920300		
5859	489	19078461	1999-09-07	1999-09-07 00:00:00	1999-10-07	1999-10-07 00:00:00	1999-10-07	38000177		0	0	30		0	0	0	32705	0	310965	19078461		
5865	489	19129655	1975-11-28	1975-11-28 00:00:00	1975-12-12	1975-12-12 00:00:00	1975-12-12	38000177		0	0	14		0	0	0	32739	0	789980	19129655		
54338	1189	40213227	1995-02-13	1995-02-13 00:00:00	1995-02-13	1995-02-13 00:00:00	1995-02-13	581452		0	0	0		0	0	0	78342	0	113	40213227		
52178	4340	19059056	1984-02-13	1984-02-13 00:00:00	1984-03-05	1984-03-05 00:00:00	1984-03-05	38000177		0	0	21		0	0	0	287780	0	243670	19059056		
132232	2905	40213227	1998-09-07	1998-09-07 00:00:00	1998-09-07	1998-09-07 00:00:00	1998-09-07	581452		0	0	0		0	0	0	193559	0	113	40213227		
25265	2079	1118084	1991-06-25	1991-06-25 00:00:00	1991-06-25	1991-06-25 00:00:00	\N	38000177		0	0	0		0	0	0	138440	0	00025152531	44923712		
21330	1755	1115171	2018-10-16	2018-10-16 00:00:00	2018-10-30	2018-10-30 00:00:00	2018-10-30	38000177		0	0	14		0	0	0	117381	0	849574	1115171		
25330	2084	920300	1995-11-03	1995-11-03 00:00:00	1995-11-10	1995-11-10 00:00:00	1995-11-10	38000177		0	0	7		0	0	0	138838	0	311989	920300		
32091	2659	1127433	1988-03-15	1988-03-15 00:00:00	1988-03-22	1988-03-22 00:00:00	1988-03-22	38000177		0	0	7		0	0	0	176152	0	313782	1127433		
150607	3313	40213227	1996-03-29	1996-03-29 00:00:00	1996-03-29	1996-03-29 00:00:00	1996-03-29	581452		0	0	0		0	0	0	220046	0	113	40213227		
52484	4366	1127433	1982-05-02	1982-05-02 00:00:00	1982-05-16	1982-05-16 00:00:00	1982-05-16	38000177		0	0	14		0	0	0	289664	0	313782	1127433		
10146	851	19133873	1990-10-30	1990-10-30 00:00:00	1990-11-07	1990-11-07 00:00:00	1990-11-07	38000177		0	0	8		0	0	0	56321	0	834061	19133873		
60137	4999	1713671	1971-08-17	1971-08-17 00:00:00	1971-08-24	1971-08-24 00:00:00	1971-08-24	38000177		0	0	7		0	0	0	332479	0	562251	1713671		
61922	5150	1127433	1978-06-24	1978-06-24 00:00:00	1978-07-08	1978-07-08 00:00:00	1978-07-08	38000177		0	0	14		0	0	0	342343	0	313782	1127433		
10255	859	19078461	1996-05-09	1996-05-09 00:00:00	1996-06-08	1996-06-08 00:00:00	1996-06-08	38000177		0	0	30		0	0	0	56874	0	310965	19078461		
21661	470	40213227	2016-02-23	2016-02-23 00:00:00	2016-02-23	2016-02-23 00:00:00	2016-02-23	581452		0	0	0		0	0	0	31439	0	113	40213227		
136747	3002	40213296	2014-12-02	2014-12-02 00:00:00	2014-12-02	2014-12-02 00:00:00	2014-12-02	581452		0	0	0		0	0	0	\N	0	52	40213296		
13365	289	40213296	1999-03-22	1999-03-22 00:00:00	1999-03-22	1999-03-22 00:00:00	1999-03-22	581452		0	0	0		0	0	0	19324	0	52	40213296		
25011	2058	1115171	2013-08-09	2013-08-09 00:00:00	2013-09-15	2013-09-15 00:00:00	2013-09-15	38000177		0	0	37		0	0	0	136800	0	849574	1115171		
11583	248	40213296	2013-05-14	2013-05-14 00:00:00	2013-05-14	2013-05-14 00:00:00	2013-05-14	581452		0	0	0		0	0	0	16703	0	52	40213296		
36544	3014	19128022	1993-05-26	1993-05-26 00:00:00	1994-05-21	1994-05-21 00:00:00	1994-05-21	38000177		0	0	360		0	0	0	201019	0	749785	19128022		
34359	2839	1127078	1973-05-16	1973-05-16 00:00:00	1973-05-30	1973-05-30 00:00:00	1973-05-30	38000177		0	0	14		0	0	0	188549	0	282464	1127078		
143092	3144	40213227	2014-06-04	2014-06-04 00:00:00	2014-06-04	2014-06-04 00:00:00	2014-06-04	581452		0	0	0		0	0	0	209230	0	113	40213227		
39430	3258	1127078	1983-03-25	1983-03-25 00:00:00	1983-04-08	1983-04-08 00:00:00	1983-04-08	38000177		0	0	14		0	0	0	216615	0	282464	1127078		
35198	2903	40236824	1998-10-08	1998-10-08 00:00:00	1998-10-15	1998-10-15 00:00:00	1998-10-15	38000177		0	0	7		0	0	0	193467	0	1094107	40236824		
26112	2149	1713671	1984-10-06	1984-10-06 00:00:00	1984-10-20	1984-10-20 00:00:00	1984-10-20	38000177		0	0	14		0	0	0	143060	0	562251	1713671		
5526	120	40213306	2000-09-09	2000-09-09 00:00:00	2000-09-09	2000-09-09 00:00:00	2000-09-09	581452		0	0	0		0	0	0	7990	0	43	40213306		
35313	2909	40231925	1962-04-08	1962-04-08 00:00:00	1962-04-08	1962-04-08 00:00:00	\N	38000177		0	0	0		0	0	0	193910	0	1049221	40231925		
37292	814	40213251	1984-06-16	1984-06-16 00:00:00	1984-06-16	1984-06-16 00:00:00	1984-06-16	581452		0	0	0		0	0	0	54000	0	21	40213251		
32953	2731	920300	2008-07-29	2008-07-29 00:00:00	2008-08-05	2008-08-05 00:00:00	2008-08-05	38000177		0	0	7		0	0	0	180758	0	311989	920300		
54980	4565	1127433	1977-05-23	1977-05-23 00:00:00	1977-05-30	1977-05-30 00:00:00	1977-05-30	38000177		0	0	7		0	0	0	304236	0	313782	1127433		
78384	1715	40213160	1956-08-04	1956-08-04 00:00:00	1956-08-04	1956-08-04 00:00:00	1956-08-04	581452		0	0	0		0	0	0	114524	0	10	40213160		
117356	2579	40213160	1957-03-31	1957-03-31 00:00:00	1957-03-31	1957-03-31 00:00:00	1957-03-31	581452		0	0	0		0	0	0	170821	0	10	40213160		
47433	3932	1127433	2018-05-06	2018-05-06 00:00:00	2018-05-13	2018-05-13 00:00:00	2018-05-13	38000177		0	0	7		0	0	0	261398	0	313782	1127433		
146032	3212	40213251	1984-01-03	1984-01-03 00:00:00	1984-01-03	1984-01-03 00:00:00	1984-01-03	581452		0	0	0		0	0	0	213445	0	21	40213251		
50924	4229	40229134	1985-05-05	1985-05-05 00:00:00	1985-05-19	1985-05-19 00:00:00	1985-05-19	38000177		0	0	14		0	0	0	280946	0	1043400	40229134		
55169	4580	1118084	2004-06-09	2004-06-09 00:00:00	2004-06-09	2004-06-09 00:00:00	\N	38000177		0	0	0		0	0	0	305124	0	00025152531	44923712		
49253	4087	19133873	1985-11-08	1985-11-08 00:00:00	1985-11-19	1985-11-19 00:00:00	1985-11-19	38000177		0	0	11		0	0	0	271645	0	834061	19133873		
94024	2063	40213314	1977-10-21	1977-10-21 00:00:00	1977-10-21	1977-10-21 00:00:00	1977-10-21	581452		0	0	0		0	0	0	137233	0	49	40213314		
17044	1411	35605482	1999-11-23	1999-11-23 00:00:00	1999-11-23	1999-11-23 00:00:00	1999-11-23	38000177		0	0	0		0	0	0	93967	0	1740467	35605482		
58691	4873	920300	1996-08-04	1996-08-04 00:00:00	1996-08-11	1996-08-11 00:00:00	1996-08-11	38000177		0	0	7		0	0	0	324112	0	311989	920300		
11291	940	19059056	1944-09-16	1944-09-16 00:00:00	1944-09-30	1944-09-30 00:00:00	1944-09-30	38000177		0	0	14		0	0	0	62569	0	243670	19059056		
44048	3647	1127433	1950-12-08	1950-12-08 00:00:00	1950-12-15	1950-12-15 00:00:00	1950-12-15	38000177		0	0	7		0	0	0	242677	0	313782	1127433		
29937	2480	19019273	1988-10-24	1988-10-24 00:00:00	1988-10-24	1988-10-24 00:00:00	\N	38000177		0	0	0		0	0	0	164344	0	198014	19019273		
29411	2435	1118084	2015-11-20	2015-11-20 00:00:00	2015-11-20	2015-11-20 00:00:00	\N	38000177		0	0	0		0	0	0	161419	0	00025152531	44923712		
83217	1819	40213160	1977-11-01	1977-11-01 00:00:00	1977-11-01	1977-11-01 00:00:00	1977-11-01	581452		0	0	0		0	0	0	121691	0	10	40213160		
55260	1211	40213306	1986-04-30	1986-04-30 00:00:00	1986-04-30	1986-04-30 00:00:00	1986-04-30	581452		0	0	0		0	0	0	79642	0	43	40213306		
199070	4374	40213160	1976-08-26	1976-08-26 00:00:00	1976-08-26	1976-08-26 00:00:00	1976-08-26	581452		0	0	0		0	0	0	290468	0	10	40213160		
14793	320	40213227	2017-03-19	2017-03-19 00:00:00	2017-03-19	2017-03-19 00:00:00	2017-03-19	581452		0	0	0		0	0	0	21219	0	113	40213227		
33089	2743	1713671	2009-03-04	2009-03-04 00:00:00	2009-03-11	2009-03-11 00:00:00	2009-03-11	38000177		0	0	7		0	0	0	181433	0	562251	1713671		
49438	4102	1127078	1973-11-03	1973-11-03 00:00:00	1973-12-03	1973-12-03 00:00:00	1973-12-03	38000177		0	0	30		0	0	0	272577	0	282464	1127078		
81920	1789	40213160	1975-08-07	1975-08-07 00:00:00	1975-08-07	1975-08-07 00:00:00	1975-08-07	581452		0	0	0		0	0	0	119944	0	10	40213160		
43163	3576	1127433	2010-11-11	2010-11-11 00:00:00	2010-12-11	2010-12-11 00:00:00	2010-12-11	38000177		0	0	30		0	0	0	237713	0	313782	1127433		
16422	1360	1127433	2013-06-17	2013-06-17 00:00:00	2013-08-16	2013-08-16 00:00:00	2013-08-16	38000177		0	0	60		0	0	0	90274	0	313782	1127433		
24028	1977	1127433	1926-11-07	1926-11-07 00:00:00	1926-11-21	1926-11-21 00:00:00	1926-11-21	38000177		0	0	14		0	0	0	131556	0	313782	1127433		
21186	1745	40229134	2007-06-19	2007-06-19 00:00:00	2007-06-26	2007-06-26 00:00:00	2007-06-26	38000177		0	0	7		0	0	0	116688	0	1043400	40229134		
3282	270	1127433	1966-08-23	1966-08-23 00:00:00	1966-08-30	1966-08-30 00:00:00	1966-08-30	38000177		0	0	7		0	0	0	17951	0	313782	1127433		
61409	5108	1332419	2012-12-30	2012-12-30 00:00:00	2012-12-30	2012-12-30 00:00:00	\N	38000177		0	0	0		0	0	0	339398	0	197361	1332419		
54395	4521	1127433	1996-05-06	1996-05-06 00:00:00	1996-05-20	1996-05-20 00:00:00	1996-05-20	38000177		0	0	14		0	0	0	300983	0	313782	1127433		
44819	3708	19128022	1992-05-04	1992-05-04 00:00:00	1993-04-29	1993-04-29 00:00:00	1993-04-29	38000177		0	0	360		0	0	0	246485	0	749785	19128022		
38421	3176	19006318	1976-05-28	1976-05-28 00:00:00	1976-06-11	1976-06-11 00:00:00	1976-06-11	38000177		0	0	14		0	0	0	211155	0	105078	19006318		
22184	1821	40229134	1978-07-07	1978-07-07 00:00:00	1978-07-21	1978-07-21 00:00:00	1978-07-21	38000177		0	0	14		0	0	0	121812	0	1043400	40229134		
31039	2572	19059056	1971-05-15	1971-05-15 00:00:00	1971-05-29	1971-05-29 00:00:00	1971-05-29	38000177		0	0	14		0	0	0	170366	0	243670	19059056		
61725	5137	19128065	1983-06-07	1983-06-07 00:00:00	1984-06-01	1984-06-01 00:00:00	1984-06-01	38000177		0	0	360		0	0	0	341433	0	749882	19128065		
5860	489	1551192	1976-10-23	1976-10-23 00:00:00	1976-10-23	1976-10-23 00:00:00	1976-10-23	38000177		0	0	0		0	0	0	32702	0	312617	1551192		
5866	489	1551192	1977-10-19	1977-10-19 00:00:00	1977-10-19	1977-10-19 00:00:00	1977-10-19	38000177		0	0	0		0	0	0	32703	0	312617	1551192		
54341	1189	40213160	1968-11-11	1968-11-11 00:00:00	1968-11-11	1968-11-11 00:00:00	1968-11-11	581452		0	0	0		0	0	0	78332	0	10	40213160		
52190	4342	1127433	2015-08-05	2015-08-05 00:00:00	2015-08-26	2015-08-26 00:00:00	2015-08-26	38000177		0	0	21		0	0	0	287847	0	313782	1127433		
132248	2905	40213296	2006-12-04	2006-12-04 00:00:00	2006-12-04	2006-12-04 00:00:00	2006-12-04	581452		0	0	0		0	0	0	193577	0	52	40213296		
25266	2079	1127433	2005-11-01	2005-11-01 00:00:00	2005-11-08	2005-11-08 00:00:00	2005-11-08	38000177		0	0	7		0	0	0	138448	0	313782	1127433		
21331	1755	19059056	1967-05-11	1967-05-11 00:00:00	1967-06-08	1967-06-08 00:00:00	1967-06-08	38000177		0	0	28		0	0	0	117342	0	243670	19059056		
25331	2084	19059056	1984-03-23	1984-03-23 00:00:00	1984-04-06	1984-04-06 00:00:00	1984-04-06	38000177		0	0	14		0	0	0	138834	0	243670	19059056		
32092	2659	19019979	1978-08-02	1978-08-02 00:00:00	1978-08-23	1978-08-23 00:00:00	1978-08-23	38000177		0	0	21		0	0	0	176146	0	198405	19019979		
150608	3313	40213296	1996-03-29	1996-03-29 00:00:00	1996-03-29	1996-03-29 00:00:00	1996-03-29	581452		0	0	0		0	0	0	220046	0	52	40213296		
52485	4366	19078461	1998-10-20	1998-10-20 00:00:00	1998-11-03	1998-11-03 00:00:00	1998-11-03	38000177		0	0	14		0	0	0	289719	0	310965	19078461		
10147	851	19075001	1983-06-05	1983-06-05 00:00:00	1983-06-19	1983-06-19 00:00:00	1983-06-19	38000177		0	0	14		0	0	0	56298	0	309097	19075001		
60138	4999	1127433	1978-12-25	1978-12-25 00:00:00	1979-01-08	1979-01-08 00:00:00	1979-01-08	38000177		0	0	14		0	0	0	332413	0	313782	1127433		
61923	5151	1118084	1997-12-12	1997-12-12 00:00:00	1997-12-12	1997-12-12 00:00:00	\N	38000177		0	0	0		0	0	0	342517	0	00025152531	44923712		
10256	859	1127433	2018-03-13	2018-03-13 00:00:00	2018-04-10	2018-04-10 00:00:00	2018-04-10	38000177		0	0	28		0	0	0	56880	0	313782	1127433		
21668	470	40213227	1997-11-04	1997-11-04 00:00:00	1997-11-04	1997-11-04 00:00:00	1997-11-04	581452		0	0	0		0	0	0	31458	0	113	40213227		
136751	3002	40213227	2014-12-02	2014-12-02 00:00:00	2014-12-02	2014-12-02 00:00:00	2014-12-02	581452		0	0	0		0	0	0	\N	0	113	40213227		
13366	289	40213160	1964-02-24	1964-02-24 00:00:00	1964-02-24	1964-02-24 00:00:00	1964-02-24	581452		0	0	0		0	0	0	19296	0	10	40213160		
25012	2058	920334	2008-11-23	2008-11-23 00:00:00	2008-11-30	2008-11-30 00:00:00	2008-11-30	38000177		0	0	7		0	0	0	136809	0	311995	920334		
11586	248	40213227	2005-05-03	2005-05-03 00:00:00	2005-05-03	2005-05-03 00:00:00	2005-05-03	581452		0	0	0		0	0	0	16699	0	113	40213227		
36545	3014	19128065	1990-06-11	1990-06-11 00:00:00	1991-06-06	1991-06-06 00:00:00	1991-06-06	38000177		0	0	360		0	0	0	200991	0	749882	19128065		
34360	2839	46233988	1973-05-16	1973-05-16 00:00:00	1973-05-30	1973-05-30 00:00:00	1973-05-30	38000177		0	0	14		0	0	0	188549	0	1652673	46233988		
143093	3144	40213260	2014-06-04	2014-06-04 00:00:00	2014-06-04	2014-06-04 00:00:00	2014-06-04	581452		0	0	0		0	0	0	209230	0	121	40213260		
39431	3258	1124300	2019-01-15	2019-01-15 00:00:00	2019-01-15	2019-01-15 00:00:00	\N	38000177		0	0	0		0	0	0	216612	0	00781178901	45011828		
35199	2903	920300	2009-12-23	2009-12-23 00:00:00	2009-12-30	2009-12-30 00:00:00	2009-12-30	38000177		0	0	7		0	0	0	193455	0	311989	920300		
26113	2149	1127433	2004-09-26	2004-09-26 00:00:00	2004-10-03	2004-10-03 00:00:00	2004-10-03	38000177		0	0	7		0	0	0	143065	0	313782	1127433		
5528	120	40213227	2000-09-09	2000-09-09 00:00:00	2000-09-09	2000-09-09 00:00:00	2000-09-09	581452		0	0	0		0	0	0	7990	0	113	40213227		
35314	2909	1713671	1992-02-08	1992-02-08 00:00:00	1992-02-29	1992-02-29 00:00:00	1992-02-29	38000177		0	0	21		0	0	0	193874	0	562251	1713671		
37299	814	40213306	2003-04-26	2003-04-26 00:00:00	2003-04-26	2003-04-26 00:00:00	2003-04-26	581452		0	0	0		0	0	0	53953	0	43	40213306		
32954	2731	1127433	1986-09-21	1986-09-21 00:00:00	1986-10-05	1986-10-05 00:00:00	1986-10-05	38000177		0	0	14		0	0	0	180742	0	313782	1127433		
54981	4565	1127433	1961-06-28	1961-06-28 00:00:00	1961-07-19	1961-07-19 00:00:00	1961-07-19	38000177		0	0	21		0	0	0	304207	0	313782	1127433		
78385	1715	40213160	1960-04-30	1960-04-30 00:00:00	1960-04-30	1960-04-30 00:00:00	1960-04-30	581452		0	0	0		0	0	0	114550	0	10	40213160		
117358	2579	40213227	2013-05-12	2013-05-12 00:00:00	2013-05-12	2013-05-12 00:00:00	2013-05-12	581452		0	0	0		0	0	0	170833	0	113	40213227		
47434	3932	19078461	1994-01-08	1994-01-08 00:00:00	1994-01-22	1994-01-22 00:00:00	1994-01-22	38000177		0	0	14		0	0	0	261400	0	310965	19078461		
146038	3212	40213227	2015-05-19	2015-05-19 00:00:00	2015-05-19	2015-05-19 00:00:00	2015-05-19	581452		0	0	0		0	0	0	213441	0	113	40213227		
10639	227	40213296	2011-09-23	2011-09-23 00:00:00	2011-09-23	2011-09-23 00:00:00	2011-09-23	581452		0	0	0		0	0	0	15347	0	52	40213296		
55170	4580	1127433	2002-01-23	2002-01-23 00:00:00	2002-02-06	2002-02-06 00:00:00	2002-02-06	38000177		0	0	14		0	0	0	305124	0	313782	1127433		
49254	4087	1127078	1984-05-15	1984-05-15 00:00:00	1984-06-19	1984-06-19 00:00:00	1984-06-19	38000177		0	0	35		0	0	0	271677	0	282464	1127078		
94026	2063	40213160	1977-10-21	1977-10-21 00:00:00	1977-10-21	1977-10-21 00:00:00	1977-10-21	581452		0	0	0		0	0	0	137233	0	10	40213160		
17045	1411	1367571	1999-11-23	1999-11-23 00:00:00	1999-11-23	1999-11-23 00:00:00	1999-11-23	38000177		0	0	0		0	0	0	93967	0	314659	19080464		
58692	4873	1713671	2005-03-17	2005-03-17 00:00:00	2005-03-31	2005-03-31 00:00:00	2005-03-31	38000177		0	0	14		0	0	0	324096	0	562251	1713671		
11292	940	19126352	1990-12-20	1990-12-20 00:00:00	2001-11-29	2001-11-29 00:00:00	2001-11-29	38000177		0	0	3997		0	0	0	62545	0	705129	19126352		
44049	3647	1713671	1943-10-20	1943-10-20 00:00:00	1943-11-03	1943-11-03 00:00:00	1943-11-03	38000177		0	0	14		0	0	0	242668	0	562251	1713671		
29938	2480	19089061	1988-10-24	1988-10-24 00:00:00	1988-11-14	1988-11-14 00:00:00	1988-11-14	38000177		0	0	21		0	0	0	164344	0	567645	19089061		
29412	2435	1713671	2014-12-12	2014-12-12 00:00:00	2014-12-26	2014-12-26 00:00:00	2014-12-26	38000177		0	0	14		0	0	0	161419	0	562251	1713671		
83223	1819	40213160	1982-05-04	1982-05-04 00:00:00	1982-05-04	1982-05-04 00:00:00	1982-05-04	581452		0	0	0		0	0	0	121694	0	10	40213160		
55264	1211	40213306	1984-12-12	1984-12-12 00:00:00	1984-12-12	1984-12-12 00:00:00	1984-12-12	581452		0	0	0		0	0	0	\N	0	43	40213306		
142238	3125	40213160	1955-06-02	1955-06-02 00:00:00	1955-06-02	1955-06-02 00:00:00	1955-06-02	581452		0	0	0		0	0	0	207956	0	10	40213160		
14799	320	40213260	2006-02-19	2006-02-19 00:00:00	2006-02-19	2006-02-19 00:00:00	2006-02-19	581452		0	0	0		0	0	0	21183	0	121	40213260		
147156	3236	40213227	2015-09-11	2015-09-11 00:00:00	2015-09-11	2015-09-11 00:00:00	2015-09-11	581452		0	0	0		0	0	0	215086	0	113	40213227		
49439	4102	1127433	1969-09-28	1969-09-28 00:00:00	1969-10-05	1969-10-05 00:00:00	1969-10-05	38000177		0	0	7		0	0	0	272590	0	313782	1127433		
81923	1789	40213160	1980-02-07	1980-02-07 00:00:00	1980-02-07	1980-02-07 00:00:00	1980-02-07	581452		0	0	0		0	0	0	119947	0	10	40213160		
43165	3576	1127078	1972-10-10	1972-10-10 00:00:00	1972-11-09	1972-11-09 00:00:00	1972-11-09	38000177		0	0	30		0	0	0	237709	0	282464	1127078		
16423	1360	46233988	1977-03-28	1977-03-28 00:00:00	1977-04-11	1977-04-11 00:00:00	1977-04-11	38000177		0	0	14		0	0	0	90286	0	1652673	46233988		
24029	1977	19059056	1938-03-15	1938-03-15 00:00:00	1938-04-19	1938-04-19 00:00:00	1938-04-19	38000177		0	0	35		0	0	0	131623	0	243670	19059056		
21187	1746	920300	2014-06-16	2014-06-16 00:00:00	2014-06-23	2014-06-23 00:00:00	2014-06-23	38000177		0	0	7		0	0	0	116727	0	311989	920300		
3283	270	19059056	1958-12-01	1958-12-01 00:00:00	1958-12-15	1958-12-15 00:00:00	1958-12-15	38000177		0	0	14		0	0	0	17991	0	243670	19059056		
61410	5108	1118084	2002-05-28	2002-05-28 00:00:00	2002-05-28	2002-05-28 00:00:00	\N	38000177		0	0	0		0	0	0	339377	0	00025152531	44923712		
54396	4522	19128022	1990-01-05	1990-01-05 00:00:00	1990-12-31	1990-12-31 00:00:00	1990-12-31	38000177		0	0	360		0	0	0	301137	0	749785	19128022		
44820	3708	1127433	1998-06-30	1998-06-30 00:00:00	1998-07-14	1998-07-14 00:00:00	1998-07-14	38000177		0	0	14		0	0	0	246524	0	313782	1127433		
38422	3176	19128022	1994-10-14	1994-10-14 00:00:00	1995-10-09	1995-10-09 00:00:00	1995-10-09	38000177		0	0	360		0	0	0	211102	0	749785	19128022		
87685	1924	40213160	1976-05-14	1976-05-14 00:00:00	1976-05-14	1976-05-14 00:00:00	1976-05-14	581452		0	0	0		0	0	0	128065	0	10	40213160		
31040	2572	1713671	1986-01-31	1986-01-31 00:00:00	1986-02-07	1986-02-07 00:00:00	1986-02-07	38000177		0	0	7		0	0	0	170389	0	562251	1713671		
61726	5137	1127433	2002-09-05	2002-09-05 00:00:00	2002-09-12	2002-09-12 00:00:00	2002-09-12	38000177		0	0	7		0	0	0	341369	0	313782	1127433		
5861	489	40232448	1976-11-03	1976-11-03 00:00:00	1976-11-03	1976-11-03 00:00:00	\N	38000177		0	0	0		0	0	0	32754	0	1049630	40232448		
5867	489	19128065	1995-04-27	1995-04-27 00:00:00	1996-04-21	1996-04-21 00:00:00	1996-04-21	38000177		0	0	360		0	0	0	32789	0	749882	19128065		
54348	1189	40213227	2005-07-18	2005-07-18 00:00:00	2005-07-18	2005-07-18 00:00:00	2005-07-18	581452		0	0	0		0	0	0	78346	0	113	40213227		
52191	4342	1127433	1975-07-01	1975-07-01 00:00:00	1975-07-15	1975-07-15 00:00:00	1975-07-15	38000177		0	0	14		0	0	0	287844	0	313782	1127433		
18710	406	40213260	2006-03-14	2006-03-14 00:00:00	2006-03-14	2006-03-14 00:00:00	2006-03-14	581452		0	0	0		0	0	0	26785	0	121	40213260		
25267	2079	1127433	1967-08-16	1967-08-16 00:00:00	1967-08-23	1967-08-23 00:00:00	1967-08-23	38000177		0	0	7		0	0	0	138446	0	313782	1127433		
21332	1755	1124300	2002-02-21	2002-02-21 00:00:00	2002-02-21	2002-02-21 00:00:00	\N	38000177		0	0	0		0	0	0	117378	0	00781178901	45011828		
25332	2084	1127433	1979-06-27	1979-06-27 00:00:00	1979-07-18	1979-07-18 00:00:00	1979-07-18	38000177		0	0	21		0	0	0	138833	0	313782	1127433		
32093	2659	1713671	1974-12-29	1974-12-29 00:00:00	1975-08-17	1975-08-17 00:00:00	1975-08-17	38000177		0	0	231		0	0	0	176154	0	562251	1713671		
150614	3313	40213227	2006-04-28	2006-04-28 00:00:00	2006-04-28	2006-04-28 00:00:00	2006-04-28	581452		0	0	0		0	0	0	220048	0	113	40213227		
52486	4366	19073188	1998-10-20	1998-10-20 00:00:00	1998-11-03	1998-11-03 00:00:00	1998-11-03	38000177		0	0	14		0	0	0	289719	0	308192	19073188		
10148	851	19019979	1983-06-05	1983-06-05 00:00:00	1983-06-19	1983-06-19 00:00:00	1983-06-19	38000177		0	0	14		0	0	0	56298	0	198405	19019979		
60139	4999	1713671	2009-04-06	2009-04-06 00:00:00	2009-04-27	2009-04-27 00:00:00	2009-04-27	38000177		0	0	21		0	0	0	332492	0	562251	1713671		
61924	5151	1127078	1957-12-27	1957-12-27 00:00:00	1958-01-10	1958-01-10 00:00:00	1958-01-10	38000177		0	0	14		0	0	0	342562	0	282464	1127078		
10257	859	19133905	1982-07-09	1982-07-09 00:00:00	1982-07-20	1982-07-20 00:00:00	1982-07-20	38000177		0	0	11		0	0	0	56794	0	834102	19133905		
21669	470	40213296	1997-11-04	1997-11-04 00:00:00	1997-11-04	1997-11-04 00:00:00	1997-11-04	581452		0	0	0		0	0	0	31458	0	52	40213296		
148034	3254	40213306	1986-02-02	1986-02-02 00:00:00	1986-02-02	1986-02-02 00:00:00	1986-02-02	581452		0	0	0		0	0	0	216442	0	43	40213306		
13377	289	40213227	1993-06-01	1993-06-01 00:00:00	1993-06-01	1993-06-01 00:00:00	1993-06-01	581452		0	0	0		0	0	0	19322	0	113	40213227		
25013	2058	1127078	1968-06-17	1968-06-17 00:00:00	1968-07-08	1968-07-08 00:00:00	1968-07-08	38000177		0	0	21		0	0	0	136798	0	282464	1127078		
11588	248	40213160	1973-01-09	1973-01-09 00:00:00	1973-01-09	1973-01-09 00:00:00	1973-01-09	581452		0	0	0		0	0	0	16725	0	10	40213160		
36546	3014	1127078	1984-04-02	1984-04-02 00:00:00	1984-05-08	1984-05-08 00:00:00	1984-05-08	38000177		0	0	36		0	0	0	200999	0	282464	1127078		
34361	2839	19059056	1986-04-29	1986-04-29 00:00:00	1986-06-28	1986-06-28 00:00:00	1986-06-28	38000177		0	0	60		0	0	0	188534	0	243670	19059056		
143100	3144	40213160	1964-02-05	1964-02-05 00:00:00	1964-02-05	1964-02-05 00:00:00	1964-02-05	581452		0	0	0		0	0	0	209218	0	10	40213160		
39432	3258	40224805	2002-04-24	2002-04-24 00:00:00	2003-04-19	2003-04-19 00:00:00	2003-04-19	38000177		0	0	360		0	0	0	216562	0	1000126	40224805		
35200	2903	40236824	2009-12-23	2009-12-23 00:00:00	2009-12-30	2009-12-30 00:00:00	2009-12-30	38000177		0	0	7		0	0	0	193455	0	1094107	40236824		
26114	2149	19112599	1962-05-08	1962-05-08 00:00:00	1962-05-08	1962-05-08 00:00:00	\N	38000177		0	0	0		0	0	0	143108	0	477045	19112599		
5531	120	40213160	1982-09-04	1982-09-04 00:00:00	1982-09-04	1982-09-04 00:00:00	1982-09-04	581452		0	0	0		0	0	0	7960	0	10	40213160		
35315	2909	920300	1969-05-20	1969-05-20 00:00:00	1969-05-27	1969-05-27 00:00:00	1969-05-27	38000177		0	0	7		0	0	0	193872	0	311989	920300		
37302	814	40213251	1985-06-22	1985-06-22 00:00:00	1985-06-22	1985-06-22 00:00:00	1985-06-22	581452		0	0	0		0	0	0	53986	0	21	40213251		
32955	2731	40229134	1977-09-16	1977-09-16 00:00:00	1977-09-30	1977-09-30 00:00:00	1977-09-30	38000177		0	0	14		0	0	0	180822	0	1043400	40229134		
54982	4565	19006318	1961-06-28	1961-06-28 00:00:00	1961-07-19	1961-07-19 00:00:00	1961-07-19	38000177		0	0	21		0	0	0	304207	0	105078	19006318		
78389	1715	40213160	1956-03-03	1956-03-03 00:00:00	1956-03-03	1956-03-03 00:00:00	1956-03-03	581452		0	0	0		0	0	0	114523	0	10	40213160		
117364	2579	40213296	1996-05-05	1996-05-05 00:00:00	1996-05-05	1996-05-05 00:00:00	1996-05-05	581452		0	0	0		0	0	0	170827	0	52	40213296		
59182	1294	40213227	1994-12-17	1994-12-17 00:00:00	1994-12-17	1994-12-17 00:00:00	1994-12-17	581452		0	0	0		0	0	0	85661	0	113	40213227		
146048	3212	40213314	1982-10-05	1982-10-05 00:00:00	1982-10-05	1982-10-05 00:00:00	1982-10-05	581452		0	0	0		0	0	0	213425	0	49	40213314		
10640	227	40213306	1993-11-19	1993-11-19 00:00:00	1993-11-19	1993-11-19 00:00:00	1993-11-19	581452		0	0	0		0	0	0	15308	0	43	40213306		
55171	4580	1127433	1971-01-21	1971-01-21 00:00:00	1971-02-04	1971-02-04 00:00:00	1971-02-04	38000177		0	0	14		0	0	0	305111	0	313782	1127433		
49255	4087	40229134	1988-11-20	1988-11-20 00:00:00	1988-11-27	1988-11-27 00:00:00	1988-11-27	38000177		0	0	7		0	0	0	271667	0	1043400	40229134		
94036	2063	40213160	1973-04-20	1973-04-20 00:00:00	1973-04-20	1973-04-20 00:00:00	1973-04-20	581452		0	0	0		0	0	0	137230	0	10	40213160		
17046	1411	35605858	1999-11-23	1999-11-23 00:00:00	1999-11-23	1999-11-23 00:00:00	1999-11-23	38000177		0	0	0		0	0	0	93967	0	1732136	35605858		
58693	4873	1118084	2018-10-24	2018-10-24 00:00:00	2018-10-24	2018-10-24 00:00:00	\N	38000177		0	0	0		0	0	0	324114	0	00025152531	44923712		
11293	940	1127078	1950-04-18	1950-04-18 00:00:00	1950-05-02	1950-05-02 00:00:00	1950-05-02	38000177		0	0	14		0	0	0	62559	0	282464	1127078		
44050	3647	1713671	1991-02-01	1991-02-01 00:00:00	1991-02-15	1991-02-15 00:00:00	1991-02-15	38000177		0	0	14		0	0	0	242720	0	562251	1713671		
29939	2480	19078461	1977-12-06	1977-12-06 00:00:00	1977-12-20	1977-12-20 00:00:00	1977-12-20	38000177		0	0	14		0	0	0	164317	0	310965	19078461		
29413	2435	1127078	1974-08-02	1974-08-02 00:00:00	1974-08-16	1974-08-16 00:00:00	1974-08-16	38000177		0	0	14		0	0	0	161412	0	282464	1127078		
144642	3179	40213201	1986-02-01	1986-02-01 00:00:00	1986-02-01	1986-02-01 00:00:00	1986-02-01	581452		0	0	0		0	0	0	211547	0	33	40213201		
79982	1750	40213160	1968-07-24	1968-07-24 00:00:00	1968-07-24	1968-07-24 00:00:00	1968-07-24	581452		0	0	0		0	0	0	117033	0	10	40213160		
142249	3125	40213201	2017-08-03	2017-08-03 00:00:00	2017-08-03	2017-08-03 00:00:00	2017-08-03	581452		0	0	0		0	0	0	207963	0	33	40213201		
94727	2078	40213314	1982-11-17	1982-11-17 00:00:00	1982-11-17	1982-11-17 00:00:00	1982-11-17	581452		0	0	0		0	0	0	138414	0	49	40213314		
147168	3236	40213227	2005-03-25	2005-03-25 00:00:00	2005-03-25	2005-03-25 00:00:00	2005-03-25	581452		0	0	0		0	0	0	215104	0	113	40213227		
49440	4102	1127433	1974-08-11	1974-08-11 00:00:00	1974-08-25	1974-08-25 00:00:00	1974-08-25	38000177		0	0	14		0	0	0	272582	0	313782	1127433		
66733	1460	40213314	1981-09-05	1981-09-05 00:00:00	1981-09-05	1981-09-05 00:00:00	1981-09-05	581452		0	0	0		0	0	0	97281	0	49	40213314		
43166	3576	19128065	1985-12-11	1985-12-11 00:00:00	1986-12-06	1986-12-06 00:00:00	1986-12-06	38000177		0	0	360		0	0	0	237762	0	749882	19128065		
16424	1360	1127078	1977-03-28	1977-03-28 00:00:00	1977-04-11	1977-04-11 00:00:00	1977-04-11	38000177		0	0	14		0	0	0	90286	0	282464	1127078		
24030	1977	1127433	1957-08-07	1957-08-07 00:00:00	1957-08-14	1957-08-14 00:00:00	1957-08-14	38000177		0	0	7		0	0	0	131508	0	313782	1127433		
21188	1746	40236824	2014-06-16	2014-06-16 00:00:00	2014-06-23	2014-06-23 00:00:00	2014-06-23	38000177		0	0	7		0	0	0	116727	0	1094107	40236824		
3284	270	19006318	1958-12-01	1958-12-01 00:00:00	1958-12-15	1958-12-15 00:00:00	1958-12-15	38000177		0	0	14		0	0	0	17991	0	105078	19006318		
61411	5108	19126352	2012-12-30	2012-12-30 00:00:00	2012-12-30	2012-12-30 00:00:00	\N	38000177		0	0	0		0	0	0	339398	0	705129	19126352		
54397	4522	1127433	1985-04-23	1985-04-23 00:00:00	1985-04-30	1985-04-30 00:00:00	1985-04-30	38000177		0	0	7		0	0	0	301106	0	313782	1127433		
55279	4590	40229134	1968-08-09	1968-08-09 00:00:00	1968-08-16	1968-08-16 00:00:00	1968-08-16	38000177		0	0	7		0	0	0	305884	0	1043400	40229134		
38423	3176	1127433	1997-06-30	1997-06-30 00:00:00	1997-07-07	1997-07-07 00:00:00	1997-07-07	38000177		0	0	7		0	0	0	211150	0	313782	1127433		
87689	1924	40213160	1971-09-10	1971-09-10 00:00:00	1971-09-10	1971-09-10 00:00:00	1971-09-10	581452		0	0	0		0	0	0	128039	0	10	40213160		
31041	2572	1127433	2015-02-04	2015-02-04 00:00:00	2015-02-11	2015-02-11 00:00:00	2015-02-11	38000177		0	0	7		0	0	0	170377	0	313782	1127433		
61727	5137	19133905	1999-11-22	1999-11-22 00:00:00	1999-11-30	1999-11-30 00:00:00	1999-11-30	38000177		0	0	8		0	0	0	341440	0	834102	19133905		
5862	489	19128065	1990-05-23	1990-05-23 00:00:00	1991-05-18	1991-05-18 00:00:00	1991-05-18	38000177		0	0	360		0	0	0	32740	0	749882	19128065		
5868	489	1127078	1987-04-29	1987-04-29 00:00:00	1987-05-13	1987-05-13 00:00:00	1987-05-13	38000177		0	0	14		0	0	0	32704	0	282464	1127078		
54349	1189	40213296	2005-07-18	2005-07-18 00:00:00	2005-07-18	2005-07-18 00:00:00	2005-07-18	581452		0	0	0		0	0	0	78346	0	52	40213296		
52192	4342	1115171	2016-07-21	2016-07-21 00:00:00	2016-08-11	2016-08-11 00:00:00	2016-08-11	38000177		0	0	21		0	0	0	287848	0	849574	1115171		
18717	406	40213198	2017-03-28	2017-03-28 00:00:00	2017-03-28	2017-03-28 00:00:00	2017-03-28	581452		0	0	0		0	0	0	26852	0	133	40213198		
25268	2079	1127433	1978-06-18	1978-06-18 00:00:00	1978-07-09	1978-07-09 00:00:00	1978-07-09	38000177		0	0	21		0	0	0	138488	0	313782	1127433		
21333	1755	1127433	2001-11-25	2001-11-25 00:00:00	2001-12-30	2001-12-30 00:00:00	2001-12-30	38000177		0	0	35		0	0	0	117378	0	313782	1127433		
25333	2084	1713671	1971-09-17	1971-09-17 00:00:00	1971-10-08	1971-10-08 00:00:00	1971-10-08	38000177		0	0	21		0	0	0	138835	0	562251	1713671		
32105	2661	40232448	1968-10-01	1968-10-01 00:00:00	1968-10-01	1968-10-01 00:00:00	\N	38000177		0	0	0		0	0	0	176239	0	1049630	40232448		
150615	3313	40213260	2006-04-28	2006-04-28 00:00:00	2006-04-28	2006-04-28 00:00:00	2006-04-28	581452		0	0	0		0	0	0	220048	0	121	40213260		
52487	4366	1713671	1991-02-06	1991-02-06 00:00:00	1991-02-13	1991-02-13 00:00:00	1991-02-13	38000177		0	0	7		0	0	0	289669	0	562251	1713671		
10149	851	1713671	1985-02-16	1985-02-16 00:00:00	1985-03-09	1985-03-09 00:00:00	1985-03-09	38000177		0	0	21		0	0	0	56319	0	562251	1713671		
60141	4999	40236824	2007-12-12	2007-12-12 00:00:00	2007-12-19	2007-12-19 00:00:00	2007-12-19	38000177		0	0	7		0	0	0	332471	0	1094107	40236824		
61925	5151	19006318	1957-12-27	1957-12-27 00:00:00	1958-01-10	1958-01-10 00:00:00	1958-01-10	38000177		0	0	14		0	0	0	342562	0	105078	19006318		
10258	859	1118084	1993-06-18	1993-06-18 00:00:00	1993-06-18	1993-06-18 00:00:00	\N	38000177		0	0	0		0	0	0	56872	0	00025152531	44923712		
21677	471	40213227	2016-12-30	2016-12-30 00:00:00	2016-12-30	2016-12-30 00:00:00	2016-12-30	581452		0	0	0		0	0	0	31479	0	113	40213227		
148037	3254	40213227	1995-02-12	1995-02-12 00:00:00	1995-02-12	1995-02-12 00:00:00	1995-02-12	581452		0	0	0		0	0	0	216420	0	113	40213227		
13378	289	40213160	1959-06-23	1959-06-23 00:00:00	1959-06-23	1959-06-23 00:00:00	1959-06-23	581452		0	0	0		0	0	0	19263	0	10	40213160		
25014	2058	40231925	2013-08-16	2013-08-16 00:00:00	2013-08-16	2013-08-16 00:00:00	\N	38000177		0	0	0		0	0	0	136811	0	1049221	40231925		
11592	248	40213314	1977-07-12	1977-07-12 00:00:00	1977-07-12	1977-07-12 00:00:00	1977-07-12	581452		0	0	0		0	0	0	16727	0	49	40213314		
36547	3014	1118084	2012-11-06	2012-11-06 00:00:00	2012-11-06	2012-11-06 00:00:00	\N	38000177		0	0	0		0	0	0	201023	0	00025152531	44923712		
34362	2839	1713671	2015-07-27	2015-07-27 00:00:00	2015-08-17	2015-08-17 00:00:00	2015-08-17	38000177		0	0	21		0	0	0	188522	0	562251	1713671		
143103	3144	40213296	2003-06-04	2003-06-04 00:00:00	2003-06-04	2003-06-04 00:00:00	2003-06-04	581452		0	0	0		0	0	0	209186	0	52	40213296		
39433	3258	1127433	1990-12-23	1990-12-23 00:00:00	1990-12-30	1990-12-30 00:00:00	1990-12-30	38000177		0	0	7		0	0	0	216559	0	313782	1127433		
35202	2903	1127433	1966-06-02	1966-06-02 00:00:00	1966-06-16	1966-06-16 00:00:00	1966-06-16	38000177		0	0	14		0	0	0	193438	0	313782	1127433		
26115	2150	40229134	1989-06-30	1989-06-30 00:00:00	1989-07-07	1989-07-07 00:00:00	1989-07-07	38000177		0	0	7		0	0	0	143191	0	1043400	40229134		
5537	120	40213314	1978-06-17	1978-06-17 00:00:00	1978-06-17	1978-06-17 00:00:00	1978-06-17	581452		0	0	0		0	0	0	8009	0	49	40213314		
35316	2909	40236824	1969-05-20	1969-05-20 00:00:00	1969-05-27	1969-05-27 00:00:00	1969-05-27	38000177		0	0	7		0	0	0	193872	0	1094107	40236824		
37304	814	40213160	1985-06-22	1985-06-22 00:00:00	1985-06-22	1985-06-22 00:00:00	1985-06-22	581452		0	0	0		0	0	0	53986	0	10	40213160		
32956	2732	19059056	1987-07-23	1987-07-23 00:00:00	1987-08-06	1987-08-06 00:00:00	1987-08-06	38000177		0	0	14		0	0	0	180929	0	243670	19059056		
54983	4565	40162522	1961-06-28	1961-06-28 00:00:00	1961-06-28	1961-06-28 00:00:00	\N	38000177		0	0	0		0	0	0	304207	0	857005	40162522		
78391	1715	40213227	1998-03-21	1998-03-21 00:00:00	1998-03-21	1998-03-21 00:00:00	1998-03-21	581452		0	0	0		0	0	0	114584	0	113	40213227		
117368	2579	40213201	2018-06-10	2018-06-10 00:00:00	2018-06-10	2018-06-10 00:00:00	2018-06-10	581452		0	0	0		0	0	0	170782	0	33	40213201		
59184	1294	40213227	2006-10-21	2006-10-21 00:00:00	2006-10-21	2006-10-21 00:00:00	2006-10-21	581452		0	0	0		0	0	0	85635	0	113	40213227		
146053	3212	40213227	2003-10-28	2003-10-28 00:00:00	2003-10-28	2003-10-28 00:00:00	2003-10-28	581452		0	0	0		0	0	0	213444	0	113	40213227		
10642	227	40213227	1993-11-19	1993-11-19 00:00:00	1993-11-19	1993-11-19 00:00:00	1993-11-19	581452		0	0	0		0	0	0	15308	0	113	40213227		
55172	4580	1127433	1972-11-29	1972-11-29 00:00:00	1972-12-13	1972-12-13 00:00:00	1972-12-13	38000177		0	0	14		0	0	0	305112	0	313782	1127433		
49256	4087	1127433	1983-12-18	1983-12-18 00:00:00	1984-01-01	1984-01-01 00:00:00	1984-01-01	38000177		0	0	14		0	0	0	271666	0	313782	1127433		
94038	2063	40213160	1973-07-20	1973-07-20 00:00:00	1973-07-20	1973-07-20 00:00:00	1973-07-20	581452		0	0	0		0	0	0	137212	0	10	40213160		
17047	1411	40220386	1999-11-23	1999-11-23 00:00:00	1999-11-23	1999-11-23 00:00:00	1999-11-23	38000177		0	0	0		0	0	0	93967	0	1808217	40220386		
58694	4873	1127078	1978-10-16	1978-10-16 00:00:00	1978-10-30	1978-10-30 00:00:00	1978-10-30	38000177		0	0	14		0	0	0	324115	0	282464	1127078		
11294	940	19073188	1982-07-16	1982-07-16 00:00:00	1982-07-30	1982-07-30 00:00:00	1982-07-30	38000177		0	0	14		0	0	0	62552	0	308192	19073188		
44051	3647	1713671	1988-11-28	1988-11-28 00:00:00	1988-12-05	1988-12-05 00:00:00	1988-12-05	38000177		0	0	7		0	0	0	242623	0	562251	1713671		
29940	2481	19059056	1972-05-05	1972-05-05 00:00:00	1972-05-19	1972-05-19 00:00:00	1972-05-19	38000177		0	0	14		0	0	0	164392	0	243670	19059056		
29414	2435	46233988	1974-08-02	1974-08-02 00:00:00	1974-08-16	1974-08-16 00:00:00	1974-08-16	38000177		0	0	14		0	0	0	161412	0	1652673	46233988		
144654	3179	40213227	1992-07-25	1992-07-25 00:00:00	1992-07-25	1992-07-25 00:00:00	1992-07-25	581452		0	0	0		0	0	0	211483	0	113	40213227		
79983	1750	40213296	2011-06-15	2011-06-15 00:00:00	2011-06-15	2011-06-15 00:00:00	2011-06-15	581452		0	0	0		0	0	0	117030	0	52	40213296		
38803	3208	1127433	1992-09-07	1992-09-07 00:00:00	1992-09-21	1992-09-21 00:00:00	1992-09-21	38000177		0	0	14		0	0	0	213247	0	313782	1127433		
94728	2078	40213160	1982-11-17	1982-11-17 00:00:00	1982-11-17	1982-11-17 00:00:00	1982-11-17	581452		0	0	0		0	0	0	138414	0	10	40213160		
147173	3236	40213201	1989-12-29	1989-12-29 00:00:00	1989-12-29	1989-12-29 00:00:00	1989-12-29	581452		0	0	0		0	0	0	215076	0	33	40213201		
49441	4102	1124300	2006-06-25	2006-06-25 00:00:00	2006-06-25	2006-06-25 00:00:00	\N	38000177		0	0	0		0	0	0	272550	0	00781178901	45011828		
66734	1460	40213160	1981-09-05	1981-09-05 00:00:00	1981-09-05	1981-09-05 00:00:00	1981-09-05	581452		0	0	0		0	0	0	97281	0	10	40213160		
43167	3576	1127433	1978-12-26	1978-12-26 00:00:00	1979-01-02	1979-01-02 00:00:00	1979-01-02	38000177		0	0	7		0	0	0	237692	0	313782	1127433		
16425	1360	1127433	2015-09-29	2015-09-29 00:00:00	2015-10-06	2015-10-06 00:00:00	2015-10-06	38000177		0	0	7		0	0	0	90268	0	313782	1127433		
24031	1977	19078461	2007-12-09	2007-12-09 00:00:00	2007-12-23	2007-12-23 00:00:00	2007-12-23	38000177		0	0	14		0	0	0	131627	0	310965	19078461		
21189	1746	19133905	1997-08-09	1997-08-09 00:00:00	1997-08-20	1997-08-20 00:00:00	1997-08-20	38000177		0	0	11		0	0	0	116723	0	834102	19133905		
3285	270	1310034	2012-06-05	2012-06-05 00:00:00	2012-06-05	2012-06-05 00:00:00	2012-06-05	38000177		0	0	0		0	0	0	18027	0	834357	1310034		
61412	5108	19075601	2012-12-30	2012-12-30 00:00:00	2012-12-30	2012-12-30 00:00:00	\N	38000177		0	0	0		0	0	0	339398	0	309362	19075601		
54398	4522	19133905	2017-02-12	2017-02-12 00:00:00	2017-02-25	2017-02-25 00:00:00	2017-02-25	38000177		0	0	13		0	0	0	301110	0	834102	19133905		
55281	4590	1127433	1980-11-13	1980-11-13 00:00:00	1980-11-20	1980-11-20 00:00:00	1980-11-20	38000177		0	0	7		0	0	0	305885	0	313782	1127433		
38424	3176	19128065	1990-11-04	1990-11-04 00:00:00	1991-10-30	1991-10-30 00:00:00	1991-10-30	38000177		0	0	360		0	0	0	211223	0	749882	19128065		
87694	1924	40213160	1971-11-12	1971-11-12 00:00:00	1971-11-12	1971-11-12 00:00:00	1971-11-12	581452		0	0	0		0	0	0	128062	0	10	40213160		
31042	2572	1127433	1999-10-29	1999-10-29 00:00:00	1999-11-19	1999-11-19 00:00:00	1999-11-19	38000177		0	0	21		0	0	0	170368	0	313782	1127433		
61728	5137	19059056	1971-08-29	1971-08-29 00:00:00	1971-09-12	1971-09-12 00:00:00	1971-09-12	38000177		0	0	14		0	0	0	341373	0	243670	19059056		
52959	4401	40236824	2005-01-23	2005-01-23 00:00:00	2005-01-30	2005-01-30 00:00:00	2005-01-30	38000177		0	0	7		0	0	0	292592	0	1094107	40236824		
5891	492	1713671	1961-06-26	1961-06-26 00:00:00	1961-07-03	1961-07-03 00:00:00	1961-07-03	38000177		0	0	7		0	0	0	32950	0	562251	1713671		
54351	1189	40213160	1964-08-10	1964-08-10 00:00:00	1964-08-10	1964-08-10 00:00:00	1964-08-10	581452		0	0	0		0	0	0	78357	0	10	40213160		
52193	4342	1127433	1964-01-02	1964-01-02 00:00:00	1964-01-09	1964-01-09 00:00:00	1964-01-09	38000177		0	0	7		0	0	0	287942	0	313782	1127433		
18724	406	40213227	1994-03-01	1994-03-01 00:00:00	1994-03-01	1994-03-01 00:00:00	1994-03-01	581452		0	0	0		0	0	0	26838	0	113	40213227		
25269	2079	19006318	1957-03-10	1957-03-10 00:00:00	1957-03-24	1957-03-24 00:00:00	1957-03-24	38000177		0	0	14		0	0	0	138470	0	105078	19006318		
21334	1755	19059056	1969-04-28	1969-04-28 00:00:00	1969-05-26	1969-05-26 00:00:00	1969-05-26	38000177		0	0	28		0	0	0	117343	0	243670	19059056		
25334	2084	40229134	1986-06-03	1986-06-03 00:00:00	1986-06-17	1986-06-17 00:00:00	1986-06-17	38000177		0	0	14		0	0	0	138852	0	1043400	40229134		
32106	2661	1713671	1967-12-04	1967-12-04 00:00:00	1967-12-25	1967-12-25 00:00:00	1967-12-25	38000177		0	0	21		0	0	0	176268	0	562251	1713671		
150618	3313	40213260	2007-05-04	2007-05-04 00:00:00	2007-05-04	2007-05-04 00:00:00	2007-05-04	581452		0	0	0		0	0	0	219992	0	121	40213260		
52488	4366	1127433	2003-09-26	2003-09-26 00:00:00	2003-10-24	2003-10-24 00:00:00	2003-10-24	38000177		0	0	28		0	0	0	289598	0	313782	1127433		
10150	851	19074843	1982-05-27	1982-05-27 00:00:00	1982-06-10	1982-06-10 00:00:00	1982-06-10	38000177		0	0	14		0	0	0	56272	0	309045	19074843		
60142	4999	920300	2007-12-12	2007-12-12 00:00:00	2007-12-19	2007-12-19 00:00:00	2007-12-19	38000177		0	0	7		0	0	0	332471	0	311989	920300		
61926	5151	1713671	1961-03-20	1961-03-20 00:00:00	1961-04-10	1961-04-10 00:00:00	1961-04-10	38000177		0	0	21		0	0	0	342535	0	562251	1713671		
10259	859	1127433	1971-07-09	1971-07-09 00:00:00	1971-07-23	1971-07-23 00:00:00	1971-07-23	38000177		0	0	14		0	0	0	56897	0	313782	1127433		
21680	471	40213160	1986-01-10	1986-01-10 00:00:00	1986-01-10	1986-01-10 00:00:00	1986-01-10	581452		0	0	0		0	0	0	31469	0	10	40213160		
148040	3254	40213260	2014-12-07	2014-12-07 00:00:00	2014-12-07	2014-12-07 00:00:00	2014-12-07	581452		0	0	0		0	0	0	216428	0	121	40213260		
13382	289	40213306	1981-05-19	1981-05-19 00:00:00	1981-05-19	1981-05-19 00:00:00	1981-05-19	581452		0	0	0		0	0	0	19321	0	43	40213306		
25028	2060	1713671	1996-05-18	1996-05-18 00:00:00	1996-06-01	1996-06-01 00:00:00	1996-06-01	38000177		0	0	14		0	0	0	137008	0	562251	1713671		
11595	248	40213160	1977-07-12	1977-07-12 00:00:00	1977-07-12	1977-07-12 00:00:00	1977-07-12	581452		0	0	0		0	0	0	16727	0	10	40213160		
36548	3014	46233988	1978-07-17	1978-07-17 00:00:00	1978-07-31	1978-07-31 00:00:00	1978-07-31	38000177		0	0	14		0	0	0	200998	0	1652673	46233988		
44821	3708	1127433	2011-01-15	2011-01-15 00:00:00	2011-02-05	2011-02-05 00:00:00	2011-02-05	38000177		0	0	21		0	0	0	246498	0	313782	1127433		
143106	3144	40213260	2013-05-29	2013-05-29 00:00:00	2013-05-29	2013-05-29 00:00:00	2013-05-29	581452		0	0	0		0	0	0	209196	0	121	40213260		
39434	3258	19078461	1994-06-14	1994-06-14 00:00:00	1994-08-13	1994-08-13 00:00:00	1994-08-13	38000177		0	0	60		0	0	0	216550	0	310965	19078461		
35203	2903	19078461	1980-03-01	1980-03-01 00:00:00	1980-03-15	1980-03-15 00:00:00	1980-03-15	38000177		0	0	14		0	0	0	193443	0	310965	19078461		
26116	2150	19078461	2008-01-26	2008-01-26 00:00:00	2008-02-16	2008-02-16 00:00:00	2008-02-16	38000177		0	0	21		0	0	0	143154	0	310965	19078461		
5538	120	40213160	1978-06-17	1978-06-17 00:00:00	1978-06-17	1978-06-17 00:00:00	1978-06-17	581452		0	0	0		0	0	0	8009	0	10	40213160		
70170	1535	40213314	1979-06-11	1979-06-11 00:00:00	1979-06-11	1979-06-11 00:00:00	1979-06-11	581452		0	0	0		0	0	0	102766	0	49	40213314		
37306	814	40213314	1981-09-19	1981-09-19 00:00:00	1981-09-19	1981-09-19 00:00:00	1981-09-19	581452		0	0	0		0	0	0	53975	0	49	40213314		
32957	2732	1127078	1978-12-18	1978-12-18 00:00:00	1979-01-08	1979-01-08 00:00:00	1979-01-08	38000177		0	0	21		0	0	0	180927	0	282464	1127078		
54984	4565	19133873	1963-03-30	1963-03-30 00:00:00	1963-04-07	1963-04-07 00:00:00	1963-04-07	38000177		0	0	8		0	0	0	304162	0	834061	19133873		
78392	1715	40213296	1998-03-21	1998-03-21 00:00:00	1998-03-21	1998-03-21 00:00:00	1998-03-21	581452		0	0	0		0	0	0	114584	0	52	40213296		
117373	2579	40213227	1994-05-01	1994-05-01 00:00:00	1994-05-01	1994-05-01 00:00:00	1994-05-01	581452		0	0	0		0	0	0	170784	0	113	40213227		
59188	1294	40213227	2014-07-19	2014-07-19 00:00:00	2014-07-19	2014-07-19 00:00:00	2014-07-19	581452		0	0	0		0	0	0	\N	0	113	40213227		
146054	3212	40213306	2003-10-28	2003-10-28 00:00:00	2003-10-28	2003-10-28 00:00:00	2003-10-28	581452		0	0	0		0	0	0	213444	0	43	40213306		
10647	227	40213160	1976-08-27	1976-08-27 00:00:00	1976-08-27	1976-08-27 00:00:00	1976-08-27	581452		0	0	0		0	0	0	15334	0	10	40213160		
55173	4580	19133873	1976-11-04	1976-11-04 00:00:00	1976-11-15	1976-11-15 00:00:00	1976-11-15	38000177		0	0	11		0	0	0	305113	0	834061	19133873		
49257	4087	1115171	1995-07-06	1995-07-06 00:00:00	1995-07-27	1995-07-27 00:00:00	1995-07-27	38000177		0	0	21		0	0	0	271640	0	849574	1115171		
94040	2064	40213227	2018-11-28	2018-11-28 00:00:00	2018-11-28	2018-11-28 00:00:00	2018-11-28	581452		0	0	0		0	0	0	137262	0	113	40213227		
17048	1411	19023423	1999-11-23	1999-11-23 00:00:00	1999-11-23	1999-11-23 00:00:00	1999-11-23	38000177		0	0	0		0	0	0	93967	0	200252	19023423		
29884	651	40213227	2009-02-12	2009-02-12 00:00:00	2009-02-12	2009-02-12 00:00:00	2009-02-12	581452		0	0	0		0	0	0	43095	0	113	40213227		
11295	940	1127433	1982-07-16	1982-07-16 00:00:00	1982-07-30	1982-07-30 00:00:00	1982-07-30	38000177		0	0	14		0	0	0	62552	0	313782	1127433		
44052	3647	19133873	1940-08-05	1940-08-05 00:00:00	1940-08-13	1940-08-13 00:00:00	1940-08-13	38000177		0	0	8		0	0	0	242595	0	834061	19133873		
9201	764	1713671	2013-07-01	2013-07-01 00:00:00	2013-07-15	2013-07-15 00:00:00	2013-07-15	38000177		0	0	14		0	0	0	50810	0	562251	1713671		
29415	2435	1127433	2014-03-07	2014-03-07 00:00:00	2014-03-21	2014-03-21 00:00:00	2014-03-21	38000177		0	0	14		0	0	0	161418	0	313782	1127433		
98320	2153	40213260	2015-11-21	2015-11-21 00:00:00	2015-11-21	2015-11-21 00:00:00	2015-11-21	581452		0	0	0		0	0	0	143468	0	121	40213260		
79991	1750	40213160	1968-10-23	1968-10-23 00:00:00	1968-10-23	1968-10-23 00:00:00	1968-10-23	581452		0	0	0		0	0	0	117023	0	10	40213160		
38805	3208	19128065	1988-12-02	1988-12-02 00:00:00	1989-11-27	1989-11-27 00:00:00	1989-11-27	38000177		0	0	360		0	0	0	213254	0	749882	19128065		
94733	2078	40213314	1983-08-17	1983-08-17 00:00:00	1983-08-17	1983-08-17 00:00:00	1983-08-17	581452		0	0	0		0	0	0	138415	0	49	40213314		
135584	2976	40213160	1960-06-02	1960-06-02 00:00:00	1960-06-02	1960-06-02 00:00:00	1960-06-02	581452		0	0	0		0	0	0	198720	0	10	40213160		
49442	4102	19128065	1980-03-13	1980-03-13 00:00:00	1981-03-08	1981-03-08 00:00:00	1981-03-08	38000177		0	0	360		0	0	0	272559	0	749882	19128065		
66737	1460	40213314	1981-11-07	1981-11-07 00:00:00	1981-11-07	1981-11-07 00:00:00	1981-11-07	581452		0	0	0		0	0	0	97309	0	49	40213314		
43168	3576	1127433	1967-11-08	1967-11-08 00:00:00	1967-11-22	1967-11-22 00:00:00	1967-11-22	38000177		0	0	14		0	0	0	237743	0	313782	1127433		
16426	1360	1127433	1981-02-07	1981-02-07 00:00:00	1981-02-14	1981-02-14 00:00:00	1981-02-14	38000177		0	0	7		0	0	0	90275	0	313782	1127433		
24032	1977	1539411	1991-01-31	1991-01-31 00:00:00	1991-01-31	1991-01-31 00:00:00	\N	38000177		0	0	0		0	0	0	131521	0	312961	1539411		
21190	1746	1127433	1964-03-26	1964-03-26 00:00:00	1964-04-02	1964-04-02 00:00:00	1964-04-02	38000177		0	0	7		0	0	0	116780	0	313782	1127433		
3286	270	40243436	2012-06-05	2012-06-05 00:00:00	2012-06-05	2012-06-05 00:00:00	2012-06-05	38000177		0	0	0		0	0	0	18027	0	1190795	40243436		
61413	5108	1539411	2012-12-30	2012-12-30 00:00:00	2012-12-30	2012-12-30 00:00:00	\N	38000177		0	0	0		0	0	0	339398	0	312961	1539411		
54399	4522	1118084	2017-08-16	2017-08-16 00:00:00	2017-08-16	2017-08-16 00:00:00	\N	38000177		0	0	0		0	0	0	301110	0	00025152531	44923712		
55282	4590	1118084	1995-11-24	1995-11-24 00:00:00	1995-11-24	1995-11-24 00:00:00	\N	38000177		0	0	0		0	0	0	305824	0	00025152531	44923712		
7210	605	19078461	1982-11-26	1982-11-26 00:00:00	1982-12-17	1982-12-17 00:00:00	1982-12-17	38000177		0	0	21		0	0	0	40162	0	310965	19078461		
87699	1924	40213160	1972-02-11	1972-02-11 00:00:00	1972-02-11	1972-02-11 00:00:00	1972-02-11	581452		0	0	0		0	0	0	128077	0	10	40213160		
41501	3439	1713671	2000-10-03	2000-10-03 00:00:00	2000-10-17	2000-10-17 00:00:00	2000-10-17	38000177		0	0	14		0	0	0	228218	0	562251	1713671		
61729	5137	19129655	1971-08-29	1971-08-29 00:00:00	1971-09-12	1971-09-12 00:00:00	1971-09-12	38000177		0	0	14		0	0	0	341373	0	789980	19129655		
52960	4401	1115171	2017-05-04	2017-05-04 00:00:00	2017-05-25	2017-05-25 00:00:00	2017-05-25	38000177		0	0	21		0	0	0	292565	0	849574	1115171		
5892	492	19006318	1949-09-28	1949-09-28 00:00:00	1949-10-12	1949-10-12 00:00:00	1949-10-12	38000177		0	0	14		0	0	0	32942	0	105078	19006318		
54358	1189	40213227	2015-09-07	2015-09-07 00:00:00	2015-09-07	2015-09-07 00:00:00	2015-09-07	581452		0	0	0		0	0	0	78373	0	113	40213227		
52194	4342	1551192	1958-10-28	1958-10-28 00:00:00	1958-10-28	1958-10-28 00:00:00	1958-10-28	38000177		0	0	0		0	0	0	287842	0	312617	1551192		
18728	406	40213227	2013-09-03	2013-09-03 00:00:00	2013-09-03	2013-09-03 00:00:00	2013-09-03	581452		0	0	0		0	0	0	26743	0	113	40213227		
25270	2079	1127078	1957-03-10	1957-03-10 00:00:00	1957-03-24	1957-03-24 00:00:00	1957-03-24	38000177		0	0	14		0	0	0	138470	0	282464	1127078		
21336	1755	40243436	2015-08-26	2015-08-26 00:00:00	2015-08-26	2015-08-26 00:00:00	2015-08-26	38000177		0	0	0		0	0	0	117380	0	1190795	40243436		
25335	2084	19129655	1967-10-20	1967-10-20 00:00:00	1967-11-03	1967-11-03 00:00:00	1967-11-03	38000177		0	0	14		0	0	0	138880	0	789980	19129655		
32107	2661	19128065	1979-09-03	1979-09-03 00:00:00	1980-08-28	1980-08-28 00:00:00	1980-08-28	38000177		0	0	360		0	0	0	176364	0	749882	19128065		
150623	3313	40213160	1955-07-01	1955-07-01 00:00:00	1955-07-01	1955-07-01 00:00:00	1955-07-01	581452		0	0	0		0	0	0	220038	0	10	40213160		
52489	4366	42902245	2001-03-31	2001-03-31 00:00:00	2002-03-26	2002-03-26 00:00:00	2002-03-26	38000177		0	0	360		0	0	0	289720	0	1359133	42902245		
31997	2651	1127433	2017-01-28	2017-01-28 00:00:00	2017-03-04	2017-03-04 00:00:00	2017-03-04	38000177		0	0	35		0	0	0	175424	0	313782	1127433		
60143	4999	19133873	1968-05-20	1968-05-20 00:00:00	1968-06-02	1968-06-02 00:00:00	1968-06-02	38000177		0	0	13		0	0	0	332444	0	834061	19133873		
61927	5151	19078461	1989-03-17	1989-03-17 00:00:00	1989-04-07	1989-04-07 00:00:00	1989-04-07	38000177		0	0	21		0	0	0	342589	0	310965	19078461		
10260	859	19059056	1969-01-28	1969-01-28 00:00:00	1969-02-13	1969-02-13 00:00:00	1969-02-13	38000177		0	0	16		0	0	0	56715	0	243670	19059056		
21682	471	40213314	1985-08-09	1985-08-09 00:00:00	1985-08-09	1985-08-09 00:00:00	1985-08-09	581452		0	0	0		0	0	0	31468	0	49	40213314		
124954	2749	40213296	1999-12-29	1999-12-29 00:00:00	1999-12-29	1999-12-29 00:00:00	1999-12-29	581452		0	0	0		0	0	0	181799	0	52	40213296		
57155	4745	1127078	1982-11-12	1982-11-12 00:00:00	1982-12-10	1982-12-10 00:00:00	1982-12-10	38000177		0	0	28		0	0	0	315991	0	282464	1127078		
25029	2060	19133905	1993-09-10	1993-09-10 00:00:00	1993-09-20	1993-09-20 00:00:00	1993-09-20	38000177		0	0	10		0	0	0	137037	0	834102	19133905		
11598	248	40213160	1973-04-10	1973-04-10 00:00:00	1973-04-10	1973-04-10 00:00:00	1973-04-10	581452		0	0	0		0	0	0	16684	0	10	40213160		
36549	3014	1127078	1978-07-17	1978-07-17 00:00:00	1978-07-31	1978-07-31 00:00:00	1978-07-31	38000177		0	0	14		0	0	0	200998	0	282464	1127078		
44822	3708	40232448	1978-01-26	1978-01-26 00:00:00	1978-01-26	1978-01-26 00:00:00	\N	38000177		0	0	0		0	0	0	246551	0	1049630	40232448		
143119	3144	40213227	1995-03-22	1995-03-22 00:00:00	1995-03-22	1995-03-22 00:00:00	1995-03-22	581452		0	0	0		0	0	0	209234	0	113	40213227		
39435	3258	40165015	1995-07-09	1995-07-09 00:00:00	1995-07-09	1995-07-09 00:00:00	\N	38000177		0	0	0		0	0	0	216551	0	861467	40165015		
35204	2903	1127078	1973-08-23	1973-08-23 00:00:00	1973-09-13	1973-09-13 00:00:00	1973-09-13	38000177		0	0	21		0	0	0	193430	0	282464	1127078		
26117	2150	1127433	1968-02-25	1968-02-25 00:00:00	1968-03-03	1968-03-03 00:00:00	1968-03-03	38000177		0	0	7		0	0	0	143167	0	313782	1127433		
5540	120	40213227	2009-09-19	2009-09-19 00:00:00	2009-09-19	2009-09-19 00:00:00	2009-09-19	581452		0	0	0		0	0	0	7982	0	113	40213227		
70173	1535	40213160	1978-12-11	1978-12-11 00:00:00	1978-12-11	1978-12-11 00:00:00	1978-12-11	581452		0	0	0		0	0	0	102710	0	10	40213160		
37309	814	40213314	1980-12-20	1980-12-20 00:00:00	1980-12-20	1980-12-20 00:00:00	1980-12-20	581452		0	0	0		0	0	0	53974	0	49	40213314		
32958	2732	1127078	1980-02-02	1980-02-02 00:00:00	1980-03-01	1980-03-01 00:00:00	1980-03-01	38000177		0	0	28		0	0	0	180928	0	282464	1127078		
54985	4565	1124300	1981-10-17	1981-10-17 00:00:00	1981-10-17	1981-10-17 00:00:00	\N	38000177		0	0	0		0	0	0	304248	0	00781178901	45011828		
78398	1715	40213227	2017-08-26	2017-08-26 00:00:00	2017-08-26	2017-08-26 00:00:00	2017-08-26	581452		0	0	0		0	0	0	114527	0	113	40213227		
48753	1068	40213314	1977-02-18	1977-02-18 00:00:00	1977-02-18	1977-02-18 00:00:00	1977-02-18	581452		0	0	0		0	0	0	69959	0	49	40213314		
59190	1294	40213296	2014-07-19	2014-07-19 00:00:00	2014-07-19	2014-07-19 00:00:00	2014-07-19	581452		0	0	0		0	0	0	\N	0	52	40213296		
146056	3212	40213251	1986-07-08	1986-07-08 00:00:00	1986-07-08	1986-07-08 00:00:00	1986-07-08	581452		0	0	0		0	0	0	213411	0	21	40213251		
168269	3699	40213160	1976-06-10	1976-06-10 00:00:00	1976-06-10	1976-06-10 00:00:00	1976-06-10	581452		0	0	0		0	0	0	245902	0	10	40213160		
55174	4580	1127433	1967-05-26	1967-05-26 00:00:00	1967-06-09	1967-06-09 00:00:00	1967-06-09	38000177		0	0	14		0	0	0	305119	0	313782	1127433		
49258	4087	1127433	2010-10-13	2010-10-13 00:00:00	2010-10-20	2010-10-20 00:00:00	2010-10-20	38000177		0	0	7		0	0	0	271648	0	313782	1127433		
94041	2064	40213296	2018-11-28	2018-11-28 00:00:00	2018-11-28	2018-11-28 00:00:00	2018-11-28	581452		0	0	0		0	0	0	137262	0	52	40213296		
17049	1411	19078924	1999-11-23	1999-11-23 00:00:00	1999-11-23	1999-11-23 00:00:00	1999-11-23	38000177		0	0	0		0	0	0	93967	0	311700	19078924		
29888	651	40213314	1978-07-13	1978-07-13 00:00:00	1978-07-13	1978-07-13 00:00:00	1978-07-13	581452		0	0	0		0	0	0	43124	0	49	40213314		
11296	940	1127433	1947-05-05	1947-05-05 00:00:00	1947-05-19	1947-05-19 00:00:00	1947-05-19	38000177		0	0	14		0	0	0	62537	0	313782	1127433		
44053	3647	1127433	1963-06-11	1963-06-11 00:00:00	1963-06-25	1963-06-25 00:00:00	1963-06-25	38000177		0	0	14		0	0	0	242621	0	313782	1127433		
9202	764	1713671	1990-05-04	1990-05-04 00:00:00	1990-05-25	1990-05-25 00:00:00	1990-05-25	38000177		0	0	21		0	0	0	50816	0	562251	1713671		
29416	2435	19133905	2011-01-26	2011-01-26 00:00:00	2011-02-06	2011-02-06 00:00:00	2011-02-06	38000177		0	0	11		0	0	0	161411	0	834102	19133905		
98323	2153	40213160	1966-07-30	1966-07-30 00:00:00	1966-07-30	1966-07-30 00:00:00	1966-07-30	581452		0	0	0		0	0	0	143487	0	10	40213160		
79994	1750	40213227	1999-12-01	1999-12-01 00:00:00	1999-12-01	1999-12-01 00:00:00	1999-12-01	581452		0	0	0		0	0	0	117001	0	113	40213227		
38806	3208	40162522	2016-02-09	2016-02-09 00:00:00	2016-02-09	2016-02-09 00:00:00	\N	38000177		0	0	0		0	0	0	213249	0	857005	40162522		
94734	2078	40213251	1984-05-16	1984-05-16 00:00:00	1984-05-16	1984-05-16 00:00:00	1984-05-16	581452		0	0	0		0	0	0	138416	0	21	40213251		
135588	2976	40213227	2006-10-12	2006-10-12 00:00:00	2006-10-12	2006-10-12 00:00:00	2006-10-12	581452		0	0	0		0	0	0	198776	0	113	40213227		
49443	4102	19059056	1972-02-14	1972-02-14 00:00:00	1972-03-06	1972-03-06 00:00:00	1972-03-06	38000177		0	0	21		0	0	0	272578	0	243670	19059056		
66738	1460	40213160	1981-11-07	1981-11-07 00:00:00	1981-11-07	1981-11-07 00:00:00	1981-11-07	581452		0	0	0		0	0	0	97309	0	10	40213160		
43169	3577	19078461	1993-04-10	1993-04-10 00:00:00	1993-06-09	1993-06-09 00:00:00	1993-06-09	38000177		0	0	60		0	0	0	237828	0	310965	19078461		
16427	1360	1127433	2009-11-12	2009-11-12 00:00:00	2009-11-26	2009-11-26 00:00:00	2009-11-26	38000177		0	0	14		0	0	0	90267	0	313782	1127433		
24033	1977	1127433	1963-12-20	1963-12-20 00:00:00	1963-12-27	1963-12-27 00:00:00	1963-12-27	38000177		0	0	7		0	0	0	131576	0	313782	1127433		
21192	1746	920300	2005-01-25	2005-01-25 00:00:00	2005-02-01	2005-02-01 00:00:00	2005-02-01	38000177		0	0	7		0	0	0	116798	0	311989	920300		
3287	270	46275916	2012-06-05	2012-06-05 00:00:00	2012-06-05	2012-06-05 00:00:00	2012-06-05	38000177		0	0	0		0	0	0	18027	0	1660014	46275916		
96792	2123	40213198	2014-07-18	2014-07-18 00:00:00	2014-07-18	2014-07-18 00:00:00	2014-07-18	581452		0	0	0		0	0	0	141264	0	133	40213198		
54400	4522	1127078	1981-03-13	1981-03-13 00:00:00	1981-03-27	1981-03-27 00:00:00	1981-03-27	38000177		0	0	14		0	0	0	301118	0	282464	1127078		
151361	3330	40213227	1995-12-10	1995-12-10 00:00:00	1995-12-10	1995-12-10 00:00:00	1995-12-10	581452		0	0	0		0	0	0	220967	0	113	40213227		
7211	606	19133905	2008-04-12	2008-04-12 00:00:00	2008-04-25	2008-04-25 00:00:00	2008-04-25	38000177		0	0	13		0	0	0	40217	0	834102	19133905		
87704	1924	40213296	2011-06-10	2011-06-10 00:00:00	2011-06-10	2011-06-10 00:00:00	2011-06-10	581452		0	0	0		0	0	0	128059	0	52	40213296		
41502	3439	1713671	1960-05-19	1960-05-19 00:00:00	1960-06-02	1960-06-02 00:00:00	1960-06-02	38000177		0	0	14		0	0	0	228184	0	562251	1713671		
61730	5137	1127433	1992-07-20	1992-07-20 00:00:00	1992-08-03	1992-08-03 00:00:00	1992-08-03	38000177		0	0	14		0	0	0	341398	0	313782	1127433		
52961	4401	1118084	2009-02-08	2009-02-08 00:00:00	2009-02-08	2009-02-08 00:00:00	\N	38000177		0	0	0		0	0	0	292587	0	00025152531	44923712		
5893	492	19059056	1949-09-28	1949-09-28 00:00:00	1949-10-12	1949-10-12 00:00:00	1949-10-12	38000177		0	0	14		0	0	0	32942	0	243670	19059056		
9321	775	40229134	1982-09-05	1982-09-05 00:00:00	1982-09-12	1982-09-12 00:00:00	1982-09-12	38000177		0	0	7		0	0	0	51487	0	1043400	40229134		
52195	4342	1127078	1959-02-09	1959-02-09 00:00:00	1959-02-23	1959-02-23 00:00:00	1959-02-23	38000177		0	0	14		0	0	0	287889	0	282464	1127078		
18732	406	40213160	1955-01-25	1955-01-25 00:00:00	1955-01-25	1955-01-25 00:00:00	1955-01-25	581452		0	0	0		0	0	0	26750	0	10	40213160		
25271	2080	19078461	2000-11-11	2000-11-11 00:00:00	2000-12-09	2000-12-09 00:00:00	2000-12-09	38000177		0	0	28		0	0	0	138523	0	310965	19078461		
21337	1755	46275916	2015-08-26	2015-08-26 00:00:00	2015-08-26	2015-08-26 00:00:00	2015-08-26	38000177		0	0	0		0	0	0	117380	0	1660014	46275916		
25336	2084	1127078	1967-10-20	1967-10-20 00:00:00	1967-11-03	1967-11-03 00:00:00	1967-11-03	38000177		0	0	14		0	0	0	138880	0	282464	1127078		
32108	2661	1551192	1976-06-11	1976-06-11 00:00:00	1976-06-11	1976-06-11 00:00:00	1976-06-11	38000177		0	0	0		0	0	0	176282	0	312617	1551192		
132909	2919	40213201	2015-12-05	2015-12-05 00:00:00	2015-12-05	2015-12-05 00:00:00	2015-12-05	581452		0	0	0		0	0	0	194621	0	33	40213201		
52490	4366	1127433	1999-01-01	1999-01-01 00:00:00	1999-02-05	1999-02-05 00:00:00	1999-02-05	38000177		0	0	35		0	0	0	289596	0	313782	1127433		
31998	2651	1127433	1954-02-28	1954-02-28 00:00:00	1954-03-14	1954-03-14 00:00:00	1954-03-14	38000177		0	0	14		0	0	0	175426	0	313782	1127433		
60144	4999	1713671	1993-08-31	1993-08-31 00:00:00	1993-09-21	1993-09-21 00:00:00	1993-09-21	38000177		0	0	21		0	0	0	332446	0	562251	1713671		
61928	5151	1713671	1973-12-24	1973-12-24 00:00:00	1973-12-31	1973-12-31 00:00:00	1973-12-31	38000177		0	0	7		0	0	0	342538	0	562251	1713671		
10261	859	40232448	1959-03-25	1959-03-25 00:00:00	1959-03-25	1959-03-25 00:00:00	\N	38000177		0	0	0		0	0	0	56790	0	1049630	40232448		
21683	471	40213160	1985-08-09	1985-08-09 00:00:00	1985-08-09	1985-08-09 00:00:00	1985-08-09	581452		0	0	0		0	0	0	31468	0	10	40213160		
124960	2749	40213306	1982-12-15	1982-12-15 00:00:00	1982-12-15	1982-12-15 00:00:00	1982-12-15	581452		0	0	0		0	0	0	181842	0	43	40213306		
57156	4745	19074843	1982-11-12	1982-11-12 00:00:00	1982-12-10	1982-12-10 00:00:00	1982-12-10	38000177		0	0	28		0	0	0	315991	0	309045	19074843		
25030	2060	19128065	1981-11-09	1981-11-09 00:00:00	1982-11-04	1982-11-04 00:00:00	1982-11-04	38000177		0	0	360		0	0	0	137013	0	749882	19128065		
11601	249	40213314	1981-11-28	1981-11-28 00:00:00	1981-11-28	1981-11-28 00:00:00	1981-11-28	581452		0	0	0		0	0	0	16777	0	49	40213314		
36550	3014	1713671	2013-10-25	2013-10-25 00:00:00	2013-11-01	2013-11-01 00:00:00	2013-11-01	38000177		0	0	7		0	0	0	200997	0	562251	1713671		
44823	3708	19078461	2003-07-26	2003-07-26 00:00:00	2003-09-24	2003-09-24 00:00:00	2003-09-24	38000177		0	0	60		0	0	0	246495	0	310965	19078461		
136499	2997	40213160	1982-06-13	1982-06-13 00:00:00	1982-06-13	1982-06-13 00:00:00	1982-06-13	581452		0	0	0		0	0	0	199960	0	10	40213160		
39436	3258	1115171	1995-07-09	1995-07-09 00:00:00	1995-10-07	1995-10-07 00:00:00	1995-10-07	38000177		0	0	90		0	0	0	216551	0	849574	1115171		
35205	2904	920334	2012-06-13	2012-06-13 00:00:00	2012-06-20	2012-06-20 00:00:00	2012-06-20	38000177		0	0	7		0	0	0	193505	0	311995	920334		
26118	2150	19059056	1965-12-18	1965-12-18 00:00:00	1966-01-08	1966-01-08 00:00:00	1966-01-08	38000177		0	0	21		0	0	0	143150	0	243670	19059056		
5543	120	40213314	1979-03-17	1979-03-17 00:00:00	1979-03-17	1979-03-17 00:00:00	1979-03-17	581452		0	0	0		0	0	0	7985	0	49	40213314		
16830	363	40213160	1969-06-17	1969-06-17 00:00:00	1969-06-17	1969-06-17 00:00:00	1969-06-17	581452		0	0	0		0	0	0	24089	0	10	40213160		
37310	814	40213160	1980-12-20	1980-12-20 00:00:00	1980-12-20	1980-12-20 00:00:00	1980-12-20	581452		0	0	0		0	0	0	53974	0	10	40213160		
32959	2732	1713671	1978-06-26	1978-06-26 00:00:00	1978-07-17	1978-07-17 00:00:00	1978-07-17	38000177		0	0	21		0	0	0	180891	0	562251	1713671		
54986	4565	1713671	2019-05-26	2019-05-26 00:00:00	2019-06-02	2019-06-02 00:00:00	2019-06-02	38000177		0	0	7		0	0	0	304238	0	562251	1713671		
78399	1715	40213160	1956-05-05	1956-05-05 00:00:00	1956-05-05	1956-05-05 00:00:00	1956-05-05	581452		0	0	0		0	0	0	114572	0	10	40213160		
48758	1068	40213227	1996-06-21	1996-06-21 00:00:00	1996-06-21	1996-06-21 00:00:00	1996-06-21	581452		0	0	0		0	0	0	69981	0	113	40213227		
59196	1294	40213160	1973-04-28	1973-04-28 00:00:00	1973-04-28	1973-04-28 00:00:00	1973-04-28	581452		0	0	0		0	0	0	85653	0	10	40213160		
146058	3212	40213160	1986-07-08	1986-07-08 00:00:00	1986-07-08	1986-07-08 00:00:00	1986-07-08	581452		0	0	0		0	0	0	213411	0	10	40213160		
168273	3699	40213296	2012-02-09	2012-02-09 00:00:00	2012-02-09	2012-02-09 00:00:00	2012-02-09	581452		0	0	0		0	0	0	245925	0	52	40213296		
55175	4580	1127433	1984-06-18	1984-06-18 00:00:00	1984-06-25	1984-06-25 00:00:00	1984-06-25	38000177		0	0	7		0	0	0	305114	0	313782	1127433		
49259	4087	1127078	1982-01-26	1982-01-26 00:00:00	1982-02-09	1982-02-09 00:00:00	1982-02-09	38000177		0	0	14		0	0	0	271650	0	282464	1127078		
94042	2064	40213314	1977-09-14	1977-09-14 00:00:00	1977-09-14	1977-09-14 00:00:00	1977-09-14	581452		0	0	0		0	0	0	137289	0	49	40213314		
17050	1411	19079524	1999-11-23	1999-11-23 00:00:00	1999-11-23	1999-11-23 00:00:00	1999-11-23	38000177		0	0	0		0	0	0	93967	0	313002	19079524		
29889	651	40213160	1977-08-11	1977-08-11 00:00:00	1977-08-11	1977-08-11 00:00:00	1977-08-11	581452		0	0	0		0	0	0	43102	0	10	40213160		
11297	940	1127433	1971-08-09	1971-08-09 00:00:00	1971-08-23	1971-08-23 00:00:00	1971-08-23	38000177		0	0	14		0	0	0	62500	0	313782	1127433		
44054	3647	1127433	1954-05-21	1954-05-21 00:00:00	1954-05-28	1954-05-28 00:00:00	1954-05-28	38000177		0	0	7		0	0	0	242717	0	313782	1127433		
9203	764	1124300	2003-12-24	2003-12-24 00:00:00	2003-12-24	2003-12-24 00:00:00	\N	38000177		0	0	0		0	0	0	50843	0	00781178901	45011828		
29417	2436	1713671	1984-03-21	1984-03-21 00:00:00	1984-03-28	1984-03-28 00:00:00	1984-03-28	38000177		0	0	7		0	0	0	161589	0	562251	1713671		
98327	2153	40213296	2005-11-26	2005-11-26 00:00:00	2005-11-26	2005-11-26 00:00:00	2005-11-26	581452		0	0	0		0	0	0	143467	0	52	40213296		
80005	1750	40213260	2018-11-14	2018-11-14 00:00:00	2018-11-14	2018-11-14 00:00:00	2018-11-14	581452		0	0	0		0	0	0	117047	0	121	40213260		
38807	3208	1127433	2016-02-09	2016-02-09 00:00:00	2016-02-23	2016-02-23 00:00:00	2016-02-23	38000177		0	0	14		0	0	0	213249	0	313782	1127433		
94743	2078	40213314	1982-09-15	1982-09-15 00:00:00	1982-09-15	1982-09-15 00:00:00	1982-09-15	581452		0	0	0		0	0	0	138432	0	49	40213314		
135589	2976	40213260	2006-10-12	2006-10-12 00:00:00	2006-10-12	2006-10-12 00:00:00	2006-10-12	581452		0	0	0		0	0	0	198776	0	121	40213260		
49444	4102	19133873	1979-09-09	1979-09-09 00:00:00	1979-09-18	1979-09-18 00:00:00	1979-09-18	38000177		0	0	9		0	0	0	272618	0	834061	19133873		
66741	1460	40213251	1986-05-10	1986-05-10 00:00:00	1986-05-10	1986-05-10 00:00:00	1986-05-10	581452		0	0	0		0	0	0	97311	0	21	40213251		
43170	3577	19078461	1978-05-29	1978-05-29 00:00:00	1978-08-27	1978-08-27 00:00:00	1978-08-27	38000177		0	0	90		0	0	0	237826	0	310965	19078461		
16428	1360	19133905	2016-03-28	2016-03-28 00:00:00	2016-04-05	2016-04-05 00:00:00	2016-04-05	38000177		0	0	8		0	0	0	90252	0	834102	19133905		
24034	1977	1332419	1994-02-17	1994-02-17 00:00:00	1994-02-17	1994-02-17 00:00:00	\N	38000177		0	0	0		0	0	0	131467	0	197361	1332419		
21193	1746	40236824	2005-01-25	2005-01-25 00:00:00	2005-02-01	2005-02-01 00:00:00	2005-02-01	38000177		0	0	7		0	0	0	116798	0	1094107	40236824		
3288	270	1713671	2006-04-07	2006-04-07 00:00:00	2006-04-14	2006-04-14 00:00:00	2006-04-14	38000177		0	0	7		0	0	0	17956	0	562251	1713671		
96804	2123	40213227	2000-04-28	2000-04-28 00:00:00	2000-04-28	2000-04-28 00:00:00	2000-04-28	581452		0	0	0		0	0	0	141290	0	113	40213227		
54401	4522	19073183	1981-03-13	1981-03-13 00:00:00	1981-03-27	1981-03-27 00:00:00	1981-03-27	38000177		0	0	14		0	0	0	301118	0	308182	19073183		
151362	3330	40213306	1995-12-10	1995-12-10 00:00:00	1995-12-10	1995-12-10 00:00:00	1995-12-10	581452		0	0	0		0	0	0	220967	0	43	40213306		
7212	606	46233988	1976-06-18	1976-06-18 00:00:00	1976-07-02	1976-07-02 00:00:00	1976-07-02	38000177		0	0	14		0	0	0	40218	0	1652673	46233988		
98988	2167	40213314	1978-08-23	1978-08-23 00:00:00	1978-08-23	1978-08-23 00:00:00	1978-08-23	581452		0	0	0		0	0	0	144367	0	49	40213314		
41503	3439	19059056	1969-02-20	1969-02-20 00:00:00	1969-04-21	1969-04-21 00:00:00	1969-04-21	38000177		0	0	60		0	0	0	228169	0	243670	19059056		
61731	5137	1127433	1972-02-20	1972-02-20 00:00:00	1972-03-05	1972-03-05 00:00:00	1972-03-05	38000177		0	0	14		0	0	0	341360	0	313782	1127433		
52962	4401	19128065	1983-01-01	1983-01-01 00:00:00	1983-12-27	1983-12-27 00:00:00	1983-12-27	38000177		0	0	360		0	0	0	292568	0	749882	19128065		
5894	492	1127433	1954-10-03	1954-10-03 00:00:00	1954-10-17	1954-10-17 00:00:00	1954-10-17	38000177		0	0	14		0	0	0	32949	0	313782	1127433		
9322	775	19059056	1940-03-10	1940-03-10 00:00:00	1940-03-24	1940-03-24 00:00:00	1940-03-24	38000177		0	0	14		0	0	0	51408	0	243670	19059056		
52196	4342	1127433	1987-05-07	1987-05-07 00:00:00	1987-05-14	1987-05-14 00:00:00	1987-05-14	38000177		0	0	7		0	0	0	287958	0	313782	1127433		
18739	406	40213201	2018-04-03	2018-04-03 00:00:00	2018-04-03	2018-04-03 00:00:00	2018-04-03	581452		0	0	0		0	0	0	26796	0	33	40213201		
25272	2080	19133873	1984-01-20	1984-01-20 00:00:00	1984-01-29	1984-01-29 00:00:00	1984-01-29	38000177		0	0	9		0	0	0	138514	0	834061	19133873		
21338	1755	1310034	2015-08-26	2015-08-26 00:00:00	2015-08-26	2015-08-26 00:00:00	2015-08-26	38000177		0	0	0		0	0	0	117380	0	834357	1310034		
25337	2084	1124300	1999-08-17	1999-08-17 00:00:00	1999-08-17	1999-08-17 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00781178901	45011828		
32109	2661	19128065	1981-08-23	1981-08-23 00:00:00	1982-08-18	1982-08-18 00:00:00	1982-08-18	38000177		0	0	360		0	0	0	176366	0	749882	19128065		
132919	2919	40213160	1955-05-28	1955-05-28 00:00:00	1955-05-28	1955-05-28 00:00:00	1955-05-28	581452		0	0	0		0	0	0	194606	0	10	40213160		
52491	4366	1127433	1996-11-12	1996-11-12 00:00:00	1997-01-11	1997-01-11 00:00:00	1997-01-11	38000177		0	0	60		0	0	0	289595	0	313782	1127433		
32023	2654	19006318	1949-11-02	1949-11-02 00:00:00	1949-11-16	1949-11-16 00:00:00	1949-11-16	38000177		0	0	14		0	0	0	175661	0	105078	19006318		
60146	4999	1713671	2004-10-26	2004-10-26 00:00:00	2004-11-16	2004-11-16 00:00:00	2004-11-16	38000177		0	0	21		0	0	0	332490	0	562251	1713671		
61929	5151	19133905	1995-03-11	1995-03-11 00:00:00	1995-03-21	1995-03-21 00:00:00	1995-03-21	38000177		0	0	10		0	0	0	342549	0	834102	19133905		
10262	859	19078461	1979-10-31	1979-10-31 00:00:00	1979-12-05	1979-12-05 00:00:00	1979-12-05	38000177		0	0	35		0	0	0	56716	0	310965	19078461		
60373	5022	1127078	1972-09-06	1972-09-06 00:00:00	1972-09-20	1972-09-20 00:00:00	1972-09-20	38000177		0	0	14		0	0	0	333697	0	282464	1127078		
124964	2749	40213160	1960-03-30	1960-03-30 00:00:00	1960-03-30	1960-03-30 00:00:00	1960-03-30	581452		0	0	0		0	0	0	181774	0	10	40213160		
57157	4745	40232448	1978-04-22	1978-04-22 00:00:00	1978-04-22	1978-04-22 00:00:00	\N	38000177		0	0	0		0	0	0	315961	0	1049630	40232448		
25031	2060	40236824	1996-12-27	1996-12-27 00:00:00	1997-01-03	1997-01-03 00:00:00	1997-01-03	38000177		0	0	7		0	0	0	136998	0	1094107	40236824		
11602	249	40213160	1981-11-28	1981-11-28 00:00:00	1981-11-28	1981-11-28 00:00:00	1981-11-28	581452		0	0	0		0	0	0	16777	0	10	40213160		
36551	3014	1127433	2013-06-05	2013-06-05 00:00:00	2013-08-11	2013-08-11 00:00:00	2013-08-11	38000177		0	0	67		0	0	0	201001	0	313782	1127433		
44824	3708	19128022	1994-04-24	1994-04-24 00:00:00	1995-04-19	1995-04-19 00:00:00	1995-04-19	38000177		0	0	360		0	0	0	246487	0	749785	19128022		
136504	2997	40213314	1982-12-12	1982-12-12 00:00:00	1982-12-12	1982-12-12 00:00:00	1982-12-12	581452		0	0	0		0	0	0	199933	0	49	40213314		
39437	3258	1127078	1990-09-14	1990-09-14 00:00:00	1990-09-28	1990-09-28 00:00:00	1990-09-28	38000177		0	0	14		0	0	0	216548	0	282464	1127078		
35206	2904	40236824	2012-06-06	2012-06-06 00:00:00	2012-06-20	2012-06-20 00:00:00	2012-06-20	38000177		0	0	14		0	0	0	193490	0	1094107	40236824		
26119	2150	1713671	1977-03-30	1977-03-30 00:00:00	1977-04-13	1977-04-13 00:00:00	1977-04-13	38000177		0	0	14		0	0	0	143159	0	562251	1713671		
22341	1837	19133873	1974-03-27	1974-03-27 00:00:00	1974-04-04	1974-04-04 00:00:00	1974-04-04	38000177		0	0	8		0	0	0	122668	0	834061	19133873		
16837	364	40213227	2006-12-03	2006-12-03 00:00:00	2006-12-03	2006-12-03 00:00:00	2006-12-03	581452		0	0	0		0	0	0	24197	0	113	40213227		
37316	814	40213160	1981-03-21	1981-03-21 00:00:00	1981-03-21	1981-03-21 00:00:00	1981-03-21	581452		0	0	0		0	0	0	53959	0	10	40213160		
32960	2732	920300	1992-08-25	1992-08-25 00:00:00	1992-09-01	1992-09-01 00:00:00	1992-09-01	38000177		0	0	7		0	0	0	180935	0	311989	920300		
54987	4565	1127433	2011-11-04	2011-11-04 00:00:00	2011-11-11	2011-11-11 00:00:00	2011-11-11	38000177		0	0	7		0	0	0	304168	0	313782	1127433		
78402	1715	40213296	1996-03-16	1996-03-16 00:00:00	1996-03-16	1996-03-16 00:00:00	1996-03-16	581452		0	0	0		0	0	0	114531	0	52	40213296		
48759	1068	40213306	1996-06-21	1996-06-21 00:00:00	1996-06-21	1996-06-21 00:00:00	1996-06-21	581452		0	0	0		0	0	0	69981	0	43	40213306		
67578	1478	40213227	1994-01-18	1994-01-18 00:00:00	1994-01-18	1994-01-18 00:00:00	1994-01-18	581452		0	0	0		0	0	0	98610	0	113	40213227		
70532	1542	40213160	1970-09-09	1970-09-09 00:00:00	1970-09-09	1970-09-09 00:00:00	1970-09-09	581452		0	0	0		0	0	0	103327	0	10	40213160		
168277	3699	40213227	2014-02-13	2014-02-13 00:00:00	2014-02-13	2014-02-13 00:00:00	2014-02-13	581452		0	0	0		0	0	0	245942	0	113	40213227		
55177	4580	19059056	1970-12-05	1970-12-05 00:00:00	1970-12-19	1970-12-19 00:00:00	1970-12-19	38000177		0	0	14		0	0	0	305106	0	243670	19059056		
49260	4087	19073183	1982-01-26	1982-01-26 00:00:00	1982-02-09	1982-02-09 00:00:00	1982-02-09	38000177		0	0	14		0	0	0	271650	0	308182	19073183		
94046	2064	40213296	2016-11-23	2016-11-23 00:00:00	2016-11-23	2016-11-23 00:00:00	2016-11-23	581452		0	0	0		0	0	0	137279	0	52	40213296		
17051	1411	19059528	1999-11-23	1999-11-23 00:00:00	1999-11-23	1999-11-23 00:00:00	1999-11-23	38000177		0	0	0		0	0	0	93967	0	480	19059528		
29890	651	40213314	1977-08-11	1977-08-11 00:00:00	1977-08-11	1977-08-11 00:00:00	1977-08-11	581452		0	0	0		0	0	0	43102	0	49	40213314		
11298	940	1127433	1979-05-30	1979-05-30 00:00:00	1979-06-13	1979-06-13 00:00:00	1979-06-13	38000177		0	0	14		0	0	0	62562	0	313782	1127433		
44055	3647	1713671	2014-02-22	2014-02-22 00:00:00	2014-03-08	2014-03-08 00:00:00	2014-03-08	38000177		0	0	14		0	0	0	242723	0	562251	1713671		
9204	764	1127433	1992-05-16	1992-05-16 00:00:00	1992-05-30	1992-05-30 00:00:00	1992-05-30	38000177		0	0	14		0	0	0	50813	0	313782	1127433		
29418	2436	1332419	2008-02-02	2008-02-02 00:00:00	2008-02-02	2008-02-02 00:00:00	\N	38000177		0	0	0		0	0	0	161482	0	197361	1332419		
98330	2153	40213306	1988-08-06	1988-08-06 00:00:00	1988-08-06	1988-08-06 00:00:00	1988-08-06	581452		0	0	0		0	0	0	143530	0	43	40213306		
80008	1750	40213160	1973-01-24	1973-01-24 00:00:00	1973-01-24	1973-01-24 00:00:00	1973-01-24	581452		0	0	0		0	0	0	117036	0	10	40213160		
38808	3208	19073188	2016-02-09	2016-02-09 00:00:00	2016-02-23	2016-02-23 00:00:00	2016-02-23	38000177		0	0	14		0	0	0	213249	0	308192	19073188		
94744	2078	40213160	1982-09-15	1982-09-15 00:00:00	1982-09-15	1982-09-15 00:00:00	1982-09-15	581452		0	0	0		0	0	0	138432	0	10	40213160		
127560	2806	40213227	2014-06-19	2014-06-19 00:00:00	2014-06-19	2014-06-19 00:00:00	2014-06-19	581452		0	0	0		0	0	0	185944	0	113	40213227		
96603	2119	40213296	2001-06-18	2001-06-18 00:00:00	2001-06-18	2001-06-18 00:00:00	2001-06-18	581452		0	0	0		0	0	0	141095	0	52	40213296		
66744	1460	40213160	1986-05-10	1986-05-10 00:00:00	1986-05-10	1986-05-10 00:00:00	1986-05-10	581452		0	0	0		0	0	0	97311	0	10	40213160		
43171	3577	1118084	1996-05-09	1996-05-09 00:00:00	1996-05-09	1996-05-09 00:00:00	\N	38000177		0	0	0		0	0	0	237812	0	00025152531	44923712		
16429	1360	1713671	1999-12-11	1999-12-11 00:00:00	1999-12-25	1999-12-25 00:00:00	1999-12-25	38000177		0	0	14		0	0	0	90276	0	562251	1713671		
24035	1977	19126352	1963-12-26	1963-12-26 00:00:00	1963-12-26	1963-12-26 00:00:00	\N	38000177		0	0	0		0	0	0	131642	0	705129	19126352		
21194	1746	1127433	1996-05-16	1996-05-16 00:00:00	1996-05-30	1996-05-30 00:00:00	1996-05-30	38000177		0	0	14		0	0	0	116730	0	313782	1127433		
87273	1915	40213314	1977-02-08	1977-02-08 00:00:00	1977-02-08	1977-02-08 00:00:00	1977-02-08	581452		0	0	0		0	0	0	127365	0	49	40213314		
96809	2123	40213201	2015-07-24	2015-07-24 00:00:00	2015-07-24	2015-07-24 00:00:00	2015-07-24	581452		0	0	0		0	0	0	141305	0	33	40213201		
54402	4522	43012754	1993-12-15	1993-12-15 00:00:00	1994-12-10	1994-12-10 00:00:00	1994-12-10	38000177		0	0	360		0	0	0	301138	0	1366343	43012754		
151368	3330	40213160	1978-09-17	1978-09-17 00:00:00	1978-09-17	1978-09-17 00:00:00	1978-09-17	581452		0	0	0		0	0	0	220988	0	10	40213160		
7213	606	1127078	1976-06-18	1976-06-18 00:00:00	1976-07-02	1976-07-02 00:00:00	1976-07-02	38000177		0	0	14		0	0	0	40218	0	282464	1127078		
98989	2167	40213160	1978-08-23	1978-08-23 00:00:00	1978-08-23	1978-08-23 00:00:00	1978-08-23	581452		0	0	0		0	0	0	144367	0	10	40213160		
41504	3439	1127433	2009-02-20	2009-02-20 00:00:00	2009-03-20	2009-03-20 00:00:00	2009-03-20	38000177		0	0	28		0	0	0	228170	0	313782	1127433		
61732	5137	19074841	1991-04-03	1991-04-03 00:00:00	1991-04-17	1991-04-17 00:00:00	1991-04-17	38000177		0	0	14		0	0	0	341434	0	309043	19074841		
52963	4401	1713671	1995-11-29	1995-11-29 00:00:00	1995-12-06	1995-12-06 00:00:00	1995-12-06	38000177		0	0	7		0	0	0	292549	0	562251	1713671		
5895	492	19133873	1961-03-23	1961-03-23 00:00:00	1961-04-02	1961-04-02 00:00:00	1961-04-02	38000177		0	0	10		0	0	0	32937	0	834061	19133873		
9323	775	19075601	2017-03-15	2017-03-15 00:00:00	2017-03-15	2017-03-15 00:00:00	2017-03-15	38000177		0	0	0		0	0	0	51455	0	309362	19075601		
52197	4342	19006318	1958-06-30	1958-06-30 00:00:00	1958-07-14	1958-07-14 00:00:00	1958-07-14	38000177		0	0	14		0	0	0	287850	0	105078	19006318		
18740	406	40213160	1955-07-26	1955-07-26 00:00:00	1955-07-26	1955-07-26 00:00:00	1955-07-26	581452		0	0	0		0	0	0	26801	0	10	40213160		
25273	2080	1127078	1989-02-21	1989-02-21 00:00:00	1989-05-22	1989-05-22 00:00:00	1989-05-22	38000177		0	0	90		0	0	0	138520	0	282464	1127078		
21339	1755	40229134	2010-04-21	2010-04-21 00:00:00	2010-05-05	2010-05-05 00:00:00	2010-05-05	38000177		0	0	14		0	0	0	117345	0	1043400	40229134		
25338	2084	40229134	1977-04-25	1977-04-25 00:00:00	1977-05-09	1977-05-09 00:00:00	1977-05-09	38000177		0	0	14		0	0	0	138877	0	1043400	40229134		
32110	2661	1127433	1989-10-31	1989-10-31 00:00:00	1989-11-07	1989-11-07 00:00:00	1989-11-07	38000177		0	0	7		0	0	0	176323	0	313782	1127433		
100753	2207	40213314	1980-07-31	1980-07-31 00:00:00	1980-07-31	1980-07-31 00:00:00	1980-07-31	581452		0	0	0		0	0	0	147082	0	49	40213314		
52492	4366	42902245	2000-04-05	2000-04-05 00:00:00	2001-03-31	2001-03-31 00:00:00	2001-03-31	38000177		0	0	360		0	0	0	289732	0	1359133	42902245		
32024	2654	19059056	1949-11-02	1949-11-02 00:00:00	1949-11-16	1949-11-16 00:00:00	1949-11-16	38000177		0	0	14		0	0	0	175661	0	243670	19059056		
60148	4999	1124300	1991-06-28	1991-06-28 00:00:00	1991-06-28	1991-06-28 00:00:00	\N	38000177		0	0	0		0	0	0	332454	0	00781178901	45011828		
61930	5151	1127433	1983-10-14	1983-10-14 00:00:00	1983-10-21	1983-10-21 00:00:00	1983-10-21	38000177		0	0	7		0	0	0	342509	0	313782	1127433		
10263	859	1127433	1970-05-26	1970-05-26 00:00:00	1970-06-09	1970-06-09 00:00:00	1970-06-09	38000177		0	0	14		0	0	0	56751	0	313782	1127433		
60374	5022	19059056	1977-07-10	1977-07-10 00:00:00	1977-09-08	1977-09-08 00:00:00	1977-09-08	38000177		0	0	60		0	0	0	333658	0	243670	19059056		
124965	2749	40213160	1960-06-01	1960-06-01 00:00:00	1960-06-01	1960-06-01 00:00:00	1960-06-01	581452		0	0	0		0	0	0	181787	0	10	40213160		
57158	4745	1713671	2017-06-23	2017-06-23 00:00:00	2017-06-30	2017-06-30 00:00:00	2017-06-30	38000177		0	0	7		0	0	0	315987	0	562251	1713671		
25032	2060	920300	1996-12-27	1996-12-27 00:00:00	1997-01-03	1997-01-03 00:00:00	1997-01-03	38000177		0	0	7		0	0	0	136998	0	311989	920300		
11604	249	40213227	2003-10-25	2003-10-25 00:00:00	2003-10-25	2003-10-25 00:00:00	2003-10-25	581452		0	0	0		0	0	0	16754	0	113	40213227		
36552	3014	46233988	1974-04-26	1974-04-26 00:00:00	1974-05-10	1974-05-10 00:00:00	1974-05-10	38000177		0	0	14		0	0	0	200989	0	1652673	46233988		
44825	3708	40236824	1999-06-05	1999-06-05 00:00:00	1999-06-12	1999-06-12 00:00:00	1999-06-12	38000177		0	0	7		0	0	0	246525	0	1094107	40236824		
136510	2997	40213251	1986-09-14	1986-09-14 00:00:00	1986-09-14	1986-09-14 00:00:00	1986-09-14	581452		0	0	0		0	0	0	199935	0	21	40213251		
39438	3258	1713671	1996-04-05	1996-04-05 00:00:00	1996-04-19	1996-04-19 00:00:00	1996-04-19	38000177		0	0	14		0	0	0	216579	0	562251	1713671		
26063	2145	19059056	1965-12-10	1965-12-10 00:00:00	1966-02-08	1966-02-08 00:00:00	1966-02-08	38000177		0	0	60		0	0	0	142797	0	243670	19059056		
26120	2150	19059056	1961-02-21	1961-02-21 00:00:00	1961-03-14	1961-03-14 00:00:00	1961-03-14	38000177		0	0	21		0	0	0	143149	0	243670	19059056		
22342	1837	19059056	1965-02-16	1965-02-16 00:00:00	1965-05-17	1965-05-17 00:00:00	1965-05-17	38000177		0	0	90		0	0	0	122692	0	243670	19059056		
16847	364	40213201	2012-01-01	2012-01-01 00:00:00	2012-01-01	2012-01-01 00:00:00	2012-01-01	581452		0	0	0		0	0	0	24174	0	33	40213201		
222576	4886	40213160	1965-12-13	1965-12-13 00:00:00	1965-12-13	1965-12-13 00:00:00	1965-12-13	581452		0	0	0		0	0	0	324917	0	10	40213160		
32961	2732	40236824	1992-08-25	1992-08-25 00:00:00	1992-09-01	1992-09-01 00:00:00	1992-09-01	38000177		0	0	7		0	0	0	180935	0	1094107	40236824		
54988	4565	40229134	1991-08-27	1991-08-27 00:00:00	1991-09-03	1991-09-03 00:00:00	1991-09-03	38000177		0	0	7		0	0	0	304164	0	1043400	40229134		
89681	1967	40213260	2007-10-25	2007-10-25 00:00:00	2007-10-25	2007-10-25 00:00:00	2007-10-25	581452		0	0	0		0	0	0	130815	0	121	40213260		
48762	1068	40213227	2005-07-01	2005-07-01 00:00:00	2005-07-01	2005-07-01 00:00:00	2005-07-01	581452		0	0	0		0	0	0	69984	0	113	40213227		
67579	1478	40213306	1983-10-25	1983-10-25 00:00:00	1983-10-25	1983-10-25 00:00:00	1983-10-25	581452		0	0	0		0	0	0	98587	0	43	40213306		
70534	1542	40213160	1966-05-04	1966-05-04 00:00:00	1966-05-04	1966-05-04 00:00:00	1966-05-04	581452		0	0	0		0	0	0	103333	0	10	40213160		
168278	3699	40213296	2014-02-13	2014-02-13 00:00:00	2014-02-13	2014-02-13 00:00:00	2014-02-13	581452		0	0	0		0	0	0	245942	0	52	40213296		
55178	4580	46233988	1970-12-05	1970-12-05 00:00:00	1970-12-19	1970-12-19 00:00:00	1970-12-19	38000177		0	0	14		0	0	0	305106	0	1652673	46233988		
49261	4087	1115171	2013-12-03	2013-12-03 00:00:00	2014-02-01	2014-02-01 00:00:00	2014-02-01	38000177		0	0	60		0	0	0	271643	0	849574	1115171		
94051	2064	40213314	1977-03-16	1977-03-16 00:00:00	1977-03-16	1977-03-16 00:00:00	1977-03-16	581452		0	0	0		0	0	0	137294	0	49	40213314		
17052	1411	42707627	1999-11-23	1999-11-23 00:00:00	1999-11-23	1999-11-23 00:00:00	1999-11-23	38000177		0	0	0		0	0	0	93967	0	1234995	42707627		
33473	2771	19074679	1972-09-01	1972-09-01 00:00:00	1972-12-08	1972-12-08 00:00:00	1972-12-08	38000177		0	0	98		0	0	0	183473	0	308971	19074679		
11299	940	1127433	1987-05-02	1987-05-02 00:00:00	1987-05-23	1987-05-23 00:00:00	1987-05-23	38000177		0	0	21		0	0	0	62563	0	313782	1127433		
44056	3647	19059056	1991-09-01	1991-09-01 00:00:00	1991-09-22	1991-09-22 00:00:00	1991-09-22	38000177		0	0	21		0	0	0	242665	0	243670	19059056		
9205	764	1127433	1989-01-01	1989-01-01 00:00:00	1989-01-31	1989-01-31 00:00:00	1989-01-31	38000177		0	0	30		0	0	0	50858	0	313782	1127433		
29419	2436	19075601	2008-02-02	2008-02-02 00:00:00	2008-02-02	2008-02-02 00:00:00	\N	38000177		0	0	0		0	0	0	161482	0	309362	19075601		
98332	2153	40213160	1970-10-31	1970-10-31 00:00:00	1970-10-31	1970-10-31 00:00:00	1970-10-31	581452		0	0	0		0	0	0	143516	0	10	40213160		
80013	1750	40213227	2009-06-10	2009-06-10 00:00:00	2009-06-10	2009-06-10 00:00:00	2009-06-10	581452		0	0	0		0	0	0	117029	0	113	40213227		
38809	3208	1127433	1990-03-17	1990-03-17 00:00:00	1990-03-31	1990-03-31 00:00:00	1990-03-31	38000177		0	0	14		0	0	0	213255	0	313782	1127433		
94748	2078	40213251	1987-05-20	1987-05-20 00:00:00	1987-05-20	1987-05-20 00:00:00	1987-05-20	581452		0	0	0		0	0	0	138417	0	21	40213251		
127561	2806	40213160	1958-03-27	1958-03-27 00:00:00	1958-03-27	1958-03-27 00:00:00	1958-03-27	581452		0	0	0		0	0	0	185978	0	10	40213160		
96605	2119	40213296	2003-06-23	2003-06-23 00:00:00	2003-06-23	2003-06-23 00:00:00	2003-06-23	581452		0	0	0		0	0	0	141024	0	52	40213296		
66752	1460	40213227	2013-04-20	2013-04-20 00:00:00	2013-04-20	2013-04-20 00:00:00	2013-04-20	581452		0	0	0		0	0	0	97321	0	113	40213227		
43173	3577	19006318	1966-05-21	1966-05-21 00:00:00	1966-06-04	1966-06-04 00:00:00	1966-06-04	38000177		0	0	14		0	0	0	237804	0	105078	19006318		
16430	1360	19133905	1993-12-11	1993-12-11 00:00:00	1993-12-20	1993-12-20 00:00:00	1993-12-20	38000177		0	0	9		0	0	0	90282	0	834102	19133905		
24036	1977	19078461	2000-05-05	2000-05-05 00:00:00	2000-05-19	2000-05-19 00:00:00	2000-05-19	38000177		0	0	14		0	0	0	131626	0	310965	19078461		
21195	1746	19074841	1996-05-16	1996-05-16 00:00:00	1996-05-30	1996-05-30 00:00:00	1996-05-30	38000177		0	0	14		0	0	0	116730	0	309043	19074841		
87275	1915	40213314	1978-02-07	1978-02-07 00:00:00	1978-02-07	1978-02-07 00:00:00	1978-02-07	581452		0	0	0		0	0	0	127346	0	49	40213314		
96822	2123	40213160	1955-04-08	1955-04-08 00:00:00	1955-04-08	1955-04-08 00:00:00	1955-04-08	581452		0	0	0		0	0	0	141284	0	10	40213160		
54403	4523	19075001	2017-12-15	2017-12-15 00:00:00	2017-12-29	2017-12-29 00:00:00	2017-12-29	38000177		0	0	14		0	0	0	301197	0	309097	19075001		
151372	3330	40213314	1977-09-11	1977-09-11 00:00:00	1977-09-11	1977-09-11 00:00:00	1977-09-11	581452		0	0	0		0	0	0	220998	0	49	40213314		
7214	606	19078461	1992-01-19	1992-01-19 00:00:00	1992-03-19	1992-03-19 00:00:00	1992-03-19	38000177		0	0	60		0	0	0	40238	0	310965	19078461		
98992	2167	40213314	1979-05-23	1979-05-23 00:00:00	1979-05-23	1979-05-23 00:00:00	1979-05-23	581452		0	0	0		0	0	0	144368	0	49	40213314		
41505	3439	1713671	2003-01-14	2003-01-14 00:00:00	2003-01-28	2003-01-28 00:00:00	2003-01-28	38000177		0	0	14		0	0	0	228193	0	562251	1713671		
61733	5137	1127433	1991-04-03	1991-04-03 00:00:00	1991-04-17	1991-04-17 00:00:00	1991-04-17	38000177		0	0	14		0	0	0	341434	0	313782	1127433		
52964	4401	1127433	2011-05-25	2011-05-25 00:00:00	2011-06-08	2011-06-08 00:00:00	2011-06-08	38000177		0	0	14		0	0	0	292539	0	313782	1127433		
5896	492	1124300	1986-06-16	1986-06-16 00:00:00	1986-06-16	1986-06-16 00:00:00	\N	38000177		0	0	0		0	0	0	32912	0	00781178901	45011828		
9324	775	40220960	2017-03-15	2017-03-15 00:00:00	2017-03-15	2017-03-15 00:00:00	2017-03-15	38000177		0	0	0		0	0	0	51455	0	1804799	40220960		
52198	4342	1127078	1958-06-30	1958-06-30 00:00:00	1958-07-14	1958-07-14 00:00:00	1958-07-14	38000177		0	0	14		0	0	0	287850	0	282464	1127078		
170684	3752	40213160	1962-11-22	1962-11-22 00:00:00	1962-11-22	1962-11-22 00:00:00	1962-11-22	581452		0	0	0		0	0	0	249326	0	10	40213160		
25274	2080	1127433	1993-03-23	1993-03-23 00:00:00	1993-06-21	1993-06-21 00:00:00	1993-06-21	38000177		0	0	90		0	0	0	138522	0	313782	1127433		
21340	1755	19059056	1960-07-11	1960-07-11 00:00:00	1960-08-15	1960-08-15 00:00:00	1960-08-15	38000177		0	0	35		0	0	0	117341	0	243670	19059056		
25339	2084	1127433	1997-04-29	1997-04-29 00:00:00	1997-05-06	1997-05-06 00:00:00	1997-05-06	38000177		0	0	7		0	0	0	138839	0	313782	1127433		
32111	2661	1127433	2015-11-02	2015-11-02 00:00:00	2015-11-09	2015-11-09 00:00:00	2015-11-09	38000177		0	0	7		0	0	0	176363	0	313782	1127433		
100754	2207	40213160	1980-07-31	1980-07-31 00:00:00	1980-07-31	1980-07-31 00:00:00	1980-07-31	581452		0	0	0		0	0	0	147082	0	10	40213160		
52493	4366	19073183	1983-01-25	1983-01-25 00:00:00	1983-02-08	1983-02-08 00:00:00	1983-02-08	38000177		0	0	14		0	0	0	289621	0	308182	19073183		
32025	2654	19059056	1945-06-26	1945-06-26 00:00:00	1945-07-31	1945-07-31 00:00:00	1945-07-31	38000177		0	0	35		0	0	0	175720	0	243670	19059056		
60149	4999	40229134	2001-09-19	2001-09-19 00:00:00	2001-09-26	2001-09-26 00:00:00	2001-09-26	38000177		0	0	7		0	0	0	332417	0	1043400	40229134		
61931	5151	1127078	1957-11-27	1957-11-27 00:00:00	1957-12-11	1957-12-11 00:00:00	1957-12-11	38000177		0	0	14		0	0	0	342585	0	282464	1127078		
10264	859	46233988	1969-01-30	1969-01-30 00:00:00	1969-02-13	1969-02-13 00:00:00	1969-02-13	38000177		0	0	14		0	0	0	56746	0	1652673	46233988		
60375	5022	1127433	1978-01-10	1978-01-10 00:00:00	1978-01-17	1978-01-17 00:00:00	1978-01-17	38000177		0	0	7		0	0	0	333677	0	313782	1127433		
124966	2749	40213160	1964-12-02	1964-12-02 00:00:00	1964-12-02	1964-12-02 00:00:00	1964-12-02	581452		0	0	0		0	0	0	181837	0	10	40213160		
57159	4745	1127433	1988-02-23	1988-02-23 00:00:00	1988-03-01	1988-03-01 00:00:00	1988-03-01	38000177		0	0	7		0	0	0	315964	0	313782	1127433		
25033	2060	19133873	1964-11-02	1964-11-02 00:00:00	1964-11-14	1964-11-14 00:00:00	1964-11-14	38000177		0	0	12		0	0	0	137032	0	834061	19133873		
11605	249	40213306	2003-10-25	2003-10-25 00:00:00	2003-10-25	2003-10-25 00:00:00	2003-10-25	581452		0	0	0		0	0	0	16754	0	43	40213306		
36553	3014	1127078	1974-04-26	1974-04-26 00:00:00	1974-05-10	1974-05-10 00:00:00	1974-05-10	38000177		0	0	14		0	0	0	200989	0	282464	1127078		
44826	3708	920300	1999-06-05	1999-06-05 00:00:00	1999-06-12	1999-06-12 00:00:00	1999-06-12	38000177		0	0	7		0	0	0	246525	0	311989	920300		
136513	2997	40213160	1986-09-14	1986-09-14 00:00:00	1986-09-14	1986-09-14 00:00:00	1986-09-14	581452		0	0	0		0	0	0	199935	0	10	40213160		
39439	3258	19133873	1989-04-26	1989-04-26 00:00:00	1989-05-03	1989-05-03 00:00:00	1989-05-03	38000177		0	0	7		0	0	0	216558	0	834061	19133873		
26064	2145	1127433	1993-09-09	1993-09-09 00:00:00	1993-09-23	1993-09-23 00:00:00	1993-09-23	38000177		0	0	14		0	0	0	142814	0	313782	1127433		
26121	2150	19078461	1995-09-14	1995-09-14 00:00:00	1995-09-28	1995-09-28 00:00:00	1995-09-28	38000177		0	0	14		0	0	0	143180	0	310965	19078461		
22343	1837	19133905	2016-11-21	2016-11-21 00:00:00	2016-11-28	2016-11-28 00:00:00	2016-11-28	38000177		0	0	7		0	0	0	122717	0	834102	19133905		
23375	1925	19006318	1947-06-26	1947-06-26 00:00:00	1947-07-10	1947-07-10 00:00:00	1947-07-10	38000177		0	0	14		0	0	0	128164	0	105078	19006318		
222582	4886	40213227	2006-11-13	2006-11-13 00:00:00	2006-11-13	2006-11-13 00:00:00	2006-11-13	581452		0	0	0		0	0	0	324923	0	113	40213227		
32962	2732	1118084	2004-03-21	2004-03-21 00:00:00	2004-03-21	2004-03-21 00:00:00	\N	38000177		0	0	0		0	0	0	180837	0	00025152531	44923712		
54990	4565	40229134	1972-02-18	1972-02-18 00:00:00	1972-03-03	1972-03-03 00:00:00	1972-03-03	38000177		0	0	14		0	0	0	304217	0	1043400	40229134		
89687	1967	40213160	1960-09-22	1960-09-22 00:00:00	1960-09-22	1960-09-22 00:00:00	1960-09-22	581452		0	0	0		0	0	0	130811	0	10	40213160		
48769	1068	40213227	2015-09-25	2015-09-25 00:00:00	2015-09-25	2015-09-25 00:00:00	2015-09-25	581452		0	0	0		0	0	0	69955	0	113	40213227		
67583	1478	40213160	1965-05-11	1965-05-11 00:00:00	1965-05-11	1965-05-11 00:00:00	1965-05-11	581452		0	0	0		0	0	0	98578	0	10	40213160		
70536	1542	40213260	2015-11-25	2015-11-25 00:00:00	2015-11-25	2015-11-25 00:00:00	2015-11-25	581452		0	0	0		0	0	0	103319	0	121	40213260		
168279	3699	40213160	1971-12-23	1971-12-23 00:00:00	1971-12-23	1971-12-23 00:00:00	1971-12-23	581452		0	0	0		0	0	0	245936	0	10	40213160		
55179	4580	1127078	1971-07-25	1971-07-25 00:00:00	1971-08-08	1971-08-08 00:00:00	1971-08-08	38000177		0	0	14		0	0	0	305115	0	282464	1127078		
49262	4087	40162522	2013-12-03	2013-12-03 00:00:00	2013-12-03	2013-12-03 00:00:00	\N	38000177		0	0	0		0	0	0	271643	0	857005	40162522		
4249	351	1118084	2018-06-07	2018-06-07 00:00:00	2018-06-07	2018-06-07 00:00:00	\N	38000177		0	0	0		0	0	0	23348	0	00025152531	44923712		
17053	1411	46275444	1999-11-23	1999-11-23 00:00:00	1999-11-23	1999-11-23 00:00:00	1999-11-23	38000177		0	0	0		0	0	0	93967	0	1659149	46275444		
33474	2771	1127433	1990-09-08	1990-09-08 00:00:00	1990-09-29	1990-09-29 00:00:00	1990-09-29	38000177		0	0	21		0	0	0	183475	0	313782	1127433		
11300	940	1127433	1956-10-06	1956-10-06 00:00:00	1956-10-20	1956-10-20 00:00:00	1956-10-20	38000177		0	0	14		0	0	0	62536	0	313782	1127433		
44057	3647	19078461	2010-11-09	2010-11-09 00:00:00	2010-12-14	2010-12-14 00:00:00	2010-12-14	38000177		0	0	35		0	0	0	242667	0	310965	19078461		
9206	764	40162522	1989-01-01	1989-01-01 00:00:00	1989-01-01	1989-01-01 00:00:00	\N	38000177		0	0	0		0	0	0	50858	0	857005	40162522		
29420	2436	19126352	2008-02-02	2008-02-02 00:00:00	2008-02-02	2008-02-02 00:00:00	\N	38000177		0	0	0		0	0	0	161482	0	705129	19126352		
98339	2153	40213160	1966-04-30	1966-04-30 00:00:00	1966-04-30	1966-04-30 00:00:00	1966-04-30	581452		0	0	0		0	0	0	143493	0	10	40213160		
91300	2004	40213227	1993-07-20	1993-07-20 00:00:00	1993-07-20	1993-07-20 00:00:00	1993-07-20	581452		0	0	0		0	0	0	133471	0	113	40213227		
38810	3208	19073188	1990-03-17	1990-03-17 00:00:00	1990-03-31	1990-03-31 00:00:00	1990-03-31	38000177		0	0	14		0	0	0	213255	0	308192	19073188		
94750	2078	40213160	1987-05-20	1987-05-20 00:00:00	1987-05-20	1987-05-20 00:00:00	1987-05-20	581452		0	0	0		0	0	0	138417	0	10	40213160		
127568	2806	40213160	1955-03-24	1955-03-24 00:00:00	1955-03-24	1955-03-24 00:00:00	1955-03-24	581452		0	0	0		0	0	0	186000	0	10	40213160		
96607	2119	40213227	2003-06-23	2003-06-23 00:00:00	2003-06-23	2003-06-23 00:00:00	2003-06-23	581452		0	0	0		0	0	0	141024	0	113	40213227		
66756	1460	40213251	1984-05-05	1984-05-05 00:00:00	1984-05-05	1984-05-05 00:00:00	1984-05-05	581452		0	0	0		0	0	0	97284	0	21	40213251		
43174	3577	1127078	1966-05-21	1966-05-21 00:00:00	1966-06-04	1966-06-04 00:00:00	1966-06-04	38000177		0	0	14		0	0	0	237804	0	282464	1127078		
3155	260	19129655	1969-10-10	1969-10-10 00:00:00	1969-10-24	1969-10-24 00:00:00	1969-10-24	38000177		0	0	14		0	0	0	17182	0	789980	19129655		
24037	1977	1127433	1990-11-12	1990-11-12 00:00:00	1990-12-03	1990-12-03 00:00:00	1990-12-03	38000177		0	0	21		0	0	0	131624	0	313782	1127433		
21196	1746	19133873	1962-06-28	1962-06-28 00:00:00	1962-07-08	1962-07-08 00:00:00	1962-07-08	38000177		0	0	10		0	0	0	116806	0	834061	19133873		
87284	1915	40213227	2016-03-15	2016-03-15 00:00:00	2016-03-15	2016-03-15 00:00:00	2016-03-15	581452		0	0	0		0	0	0	127370	0	113	40213227		
96824	2123	40213227	2010-06-25	2010-06-25 00:00:00	2010-06-25	2010-06-25 00:00:00	2010-06-25	581452		0	0	0		0	0	0	141263	0	113	40213227		
54404	4523	1118084	2018-01-04	2018-01-04 00:00:00	2018-01-04	2018-01-04 00:00:00	\N	38000177		0	0	0		0	0	0	301197	0	00025152531	44923712		
151377	3330	40213314	1977-03-13	1977-03-13 00:00:00	1977-03-13	1977-03-13 00:00:00	1977-03-13	581452		0	0	0		0	0	0	220987	0	49	40213314		
7215	606	40229134	2004-02-20	2004-02-20 00:00:00	2004-02-27	2004-02-27 00:00:00	2004-02-27	38000177		0	0	7		0	0	0	40243	0	1043400	40229134		
98993	2167	40213314	1978-06-21	1978-06-21 00:00:00	1978-06-21	1978-06-21 00:00:00	1978-06-21	581452		0	0	0		0	0	0	144392	0	49	40213314		
41506	3439	1127433	1988-04-26	1988-04-26 00:00:00	1988-05-03	1988-05-03 00:00:00	1988-05-03	38000177		0	0	7		0	0	0	228188	0	313782	1127433		
61734	5137	1118084	2004-03-28	2004-03-28 00:00:00	2004-03-28	2004-03-28 00:00:00	\N	38000177		0	0	0		0	0	0	341446	0	00025152531	44923712		
52965	4401	1115171	2012-03-10	2012-03-10 00:00:00	2012-03-31	2012-03-31 00:00:00	2012-03-31	38000177		0	0	21		0	0	0	292564	0	849574	1115171		
5898	492	19006318	1952-08-13	1952-08-13 00:00:00	1952-09-17	1952-09-17 00:00:00	1952-09-17	38000177		0	0	35		0	0	0	32985	0	105078	19006318		
9325	775	40229134	1962-07-23	1962-07-23 00:00:00	1962-08-06	1962-08-06 00:00:00	1962-08-06	38000177		0	0	14		0	0	0	51453	0	1043400	40229134		
52199	4342	19078461	2014-07-20	2014-07-20 00:00:00	2014-08-10	2014-08-10 00:00:00	2014-08-10	38000177		0	0	21		0	0	0	287846	0	310965	19078461		
47555	3941	920300	1993-03-15	1993-03-15 00:00:00	1993-03-22	1993-03-22 00:00:00	1993-03-22	38000177		0	0	7		0	0	0	262000	0	311989	920300		
36348	2997	40236824	2001-11-11	2001-11-11 00:00:00	2001-11-18	2001-11-18 00:00:00	2001-11-18	38000177		0	0	7		0	0	0	199940	0	1094107	40236824		
21341	1755	1127433	1961-10-06	1961-10-06 00:00:00	1961-10-20	1961-10-20 00:00:00	1961-10-20	38000177		0	0	14		0	0	0	117332	0	313782	1127433		
25340	2084	40236824	2001-12-16	2001-12-16 00:00:00	2001-12-23	2001-12-23 00:00:00	2001-12-23	38000177		0	0	7		0	0	0	138862	0	1094107	40236824		
32113	2661	1713671	1981-01-17	1981-01-17 00:00:00	1981-03-21	1981-03-21 00:00:00	1981-03-21	38000177		0	0	63		0	0	0	176297	0	562251	1713671		
100755	2207	40213251	1984-03-29	1984-03-29 00:00:00	1984-03-29	1984-03-29 00:00:00	1984-03-29	581452		0	0	0		0	0	0	147092	0	21	40213251		
52494	4366	1127078	1983-01-25	1983-01-25 00:00:00	1983-02-08	1983-02-08 00:00:00	1983-02-08	38000177		0	0	14		0	0	0	289621	0	282464	1127078		
32026	2654	1127433	1968-05-21	1968-05-21 00:00:00	1968-06-04	1968-06-04 00:00:00	1968-06-04	38000177		0	0	14		0	0	0	175713	0	313782	1127433		
60150	5000	1127433	1992-11-06	1992-11-06 00:00:00	1992-11-13	1992-11-13 00:00:00	1992-11-13	38000177		0	0	7		0	0	0	332527	0	313782	1127433		
61932	5151	19059056	1969-09-09	1969-09-09 00:00:00	1969-10-14	1969-10-14 00:00:00	1969-10-14	38000177		0	0	35		0	0	0	342587	0	243670	19059056		
10265	859	1713671	2018-12-17	2018-12-17 00:00:00	2018-12-31	2018-12-31 00:00:00	2018-12-31	38000177		0	0	14		0	0	0	56797	0	562251	1713671		
60376	5023	1154615	1974-08-13	1974-08-13 00:00:00	1974-08-13	1974-08-13 00:00:00	\N	38000177		0	0	0		0	0	0	333749	0	745679	1154615		
124969	2749	40213160	1960-08-31	1960-08-31 00:00:00	1960-08-31	1960-08-31 00:00:00	1960-08-31	581452		0	0	0		0	0	0	181793	0	10	40213160		
57160	4745	1118084	2016-10-08	2016-10-08 00:00:00	2016-10-08	2016-10-08 00:00:00	\N	38000177		0	0	0		0	0	0	315898	0	00025152531	44923712		
25034	2060	1118084	2009-09-08	2009-09-08 00:00:00	2009-09-08	2009-09-08 00:00:00	\N	38000177		0	0	0		0	0	0	136999	0	00025152531	44923712		
11607	249	40213160	1982-05-01	1982-05-01 00:00:00	1982-05-01	1982-05-01 00:00:00	1982-05-01	581452		0	0	0		0	0	0	16729	0	10	40213160		
36554	3014	1127433	1998-01-21	1998-01-21 00:00:00	1998-01-28	1998-01-28 00:00:00	1998-01-28	38000177		0	0	7		0	0	0	201037	0	313782	1127433		
44827	3708	19128022	1993-04-29	1993-04-29 00:00:00	1994-04-24	1994-04-24 00:00:00	1994-04-24	38000177		0	0	360		0	0	0	246486	0	749785	19128022		
136517	2997	40213306	2004-01-25	2004-01-25 00:00:00	2004-01-25	2004-01-25 00:00:00	2004-01-25	581452		0	0	0		0	0	0	199945	0	43	40213306		
39440	3258	19074843	1985-03-31	1985-03-31 00:00:00	1985-04-14	1985-04-14 00:00:00	1985-04-14	38000177		0	0	14		0	0	0	216624	0	309045	19074843		
26065	2145	19133905	2013-08-09	2013-08-09 00:00:00	2013-08-21	2013-08-21 00:00:00	2013-08-21	38000177		0	0	12		0	0	0	142802	0	834102	19133905		
26122	2150	19074841	1995-09-14	1995-09-14 00:00:00	1995-09-28	1995-09-28 00:00:00	1995-09-28	38000177		0	0	14		0	0	0	143180	0	309043	19074841		
22344	1837	1127433	1980-01-15	1980-01-15 00:00:00	1980-01-29	1980-01-29 00:00:00	1980-01-29	38000177		0	0	14		0	0	0	122685	0	313782	1127433		
23376	1925	19059056	1947-06-26	1947-06-26 00:00:00	1947-07-10	1947-07-10 00:00:00	1947-07-10	38000177		0	0	14		0	0	0	128164	0	243670	19059056		
222583	4886	40213296	2006-11-13	2006-11-13 00:00:00	2006-11-13	2006-11-13 00:00:00	2006-11-13	581452		0	0	0		0	0	0	324923	0	52	40213296		
32963	2732	19128065	1983-08-04	1983-08-04 00:00:00	1984-07-29	1984-07-29 00:00:00	1984-07-29	38000177		0	0	360		0	0	0	180882	0	749882	19128065		
54991	4565	1713671	2001-04-29	2001-04-29 00:00:00	2001-05-20	2001-05-20 00:00:00	2001-05-20	38000177		0	0	21		0	0	0	304220	0	562251	1713671		
233959	5142	40213227	2006-11-14	2006-11-14 00:00:00	2006-11-14	2006-11-14 00:00:00	2006-11-14	581452		0	0	0		0	0	0	341785	0	113	40213227		
48770	1068	40213296	2015-09-25	2015-09-25 00:00:00	2015-09-25	2015-09-25 00:00:00	2015-09-25	581452		0	0	0		0	0	0	69955	0	52	40213296		
67586	1478	40213160	1961-08-29	1961-08-29 00:00:00	1961-08-29	1961-08-29 00:00:00	1961-08-29	581452		0	0	0		0	0	0	98597	0	10	40213160		
70540	1542	40213306	1987-01-07	1987-01-07 00:00:00	1987-01-07	1987-01-07 00:00:00	1987-01-07	581452		0	0	0		0	0	0	103353	0	43	40213306		
168281	3699	40213227	1993-09-02	1993-09-02 00:00:00	1993-09-02	1993-09-02 00:00:00	1993-09-02	581452		0	0	0		0	0	0	245905	0	113	40213227		
55180	4580	19006318	1971-07-25	1971-07-25 00:00:00	1971-08-08	1971-08-08 00:00:00	1971-08-08	38000177		0	0	14		0	0	0	305115	0	105078	19006318		
49263	4087	19133873	1991-08-22	1991-08-22 00:00:00	1991-08-31	1991-08-31 00:00:00	1991-08-31	38000177		0	0	9		0	0	0	271646	0	834061	19133873		
4250	351	40229134	1985-02-28	1985-02-28 00:00:00	1985-03-14	1985-03-14 00:00:00	1985-03-14	38000177		0	0	14		0	0	0	23411	0	1043400	40229134		
17054	1411	19059056	1972-04-27	1972-04-27 00:00:00	1972-07-26	1972-07-26 00:00:00	1972-07-26	38000177		0	0	90		0	0	0	93976	0	243670	19059056		
33475	2771	19059056	1961-08-27	1961-08-27 00:00:00	1961-09-10	1961-09-10 00:00:00	1961-09-10	38000177		0	0	14		0	0	0	183471	0	243670	19059056		
11301	940	40229134	1982-07-13	1982-07-13 00:00:00	1982-07-20	1982-07-20 00:00:00	1982-07-20	38000177		0	0	7		0	0	0	62567	0	1043400	40229134		
44058	3647	1713671	1958-11-20	1958-11-20 00:00:00	1958-11-27	1958-11-27 00:00:00	1958-11-27	38000177		0	0	7		0	0	0	242620	0	562251	1713671		
9207	764	1127433	1997-01-08	1997-01-08 00:00:00	1997-01-15	1997-01-15 00:00:00	1997-01-15	38000177		0	0	7		0	0	0	50834	0	313782	1127433		
29421	2436	1539411	2008-02-02	2008-02-02 00:00:00	2008-02-02	2008-02-02 00:00:00	\N	38000177		0	0	0		0	0	0	161482	0	312961	1539411		
98343	2153	40213160	1966-02-26	1966-02-26 00:00:00	1966-02-26	1966-02-26 00:00:00	1966-02-26	581452		0	0	0		0	0	0	143486	0	10	40213160		
91301	2004	40213306	1993-07-20	1993-07-20 00:00:00	1993-07-20	1993-07-20 00:00:00	1993-07-20	581452		0	0	0		0	0	0	133471	0	43	40213306		
38811	3208	19128065	1985-12-18	1985-12-18 00:00:00	1986-12-13	1986-12-13 00:00:00	1986-12-13	38000177		0	0	360		0	0	0	213276	0	749882	19128065		
94754	2079	40213160	1956-08-24	1956-08-24 00:00:00	1956-08-24	1956-08-24 00:00:00	1956-08-24	581452		0	0	0		0	0	0	138494	0	10	40213160		
127570	2806	40213198	2018-07-12	2018-07-12 00:00:00	2018-07-12	2018-07-12 00:00:00	2018-07-12	581452		0	0	0		0	0	0	185927	0	133	40213198		
33350	728	40213260	2007-02-03	2007-02-03 00:00:00	2007-02-03	2007-02-03 00:00:00	2007-02-03	581452		0	0	0		0	0	0	48326	0	121	40213260		
66765	1461	40213160	1971-10-07	1971-10-07 00:00:00	1971-10-07	1971-10-07 00:00:00	1971-10-07	581452		0	0	0		0	0	0	97335	0	10	40213160		
43175	3577	1127433	2013-08-28	2013-08-28 00:00:00	2013-09-04	2013-09-04 00:00:00	2013-09-04	38000177		0	0	7		0	0	0	237843	0	313782	1127433		
3156	260	19059056	1969-10-10	1969-10-10 00:00:00	1969-10-24	1969-10-24 00:00:00	1969-10-24	38000177		0	0	14		0	0	0	17182	0	243670	19059056		
24038	1977	1713671	1966-04-20	1966-04-20 00:00:00	1966-05-11	1966-05-11 00:00:00	1966-05-11	38000177		0	0	21		0	0	0	131509	0	562251	1713671		
21197	1746	1127433	2015-06-03	2015-06-03 00:00:00	2015-06-24	2015-06-24 00:00:00	2015-06-24	38000177		0	0	21		0	0	0	116766	0	313782	1127433		
87285	1915	40213296	2016-03-15	2016-03-15 00:00:00	2016-03-15	2016-03-15 00:00:00	2016-03-15	581452		0	0	0		0	0	0	127370	0	52	40213296		
79649	1743	40213227	2007-02-14	2007-02-14 00:00:00	2007-02-14	2007-02-14 00:00:00	2007-02-14	581452		0	0	0		0	0	0	116568	0	113	40213227		
54405	4523	19078461	2017-12-15	2017-12-15 00:00:00	2017-12-29	2017-12-29 00:00:00	2017-12-29	38000177		0	0	14		0	0	0	301197	0	310965	19078461		
151382	3330	40213227	2015-10-18	2015-10-18 00:00:00	2015-10-18	2015-10-18 00:00:00	2015-10-18	581452		0	0	0		0	0	0	220981	0	113	40213227		
7216	606	19128065	1993-01-18	1993-01-18 00:00:00	1994-01-13	1994-01-13 00:00:00	1994-01-13	38000177		0	0	360		0	0	0	40245	0	749882	19128065		
98994	2167	40213160	1978-06-21	1978-06-21 00:00:00	1978-06-21	1978-06-21 00:00:00	1978-06-21	581452		0	0	0		0	0	0	144392	0	10	40213160		
41507	3439	19133905	1983-06-06	1983-06-06 00:00:00	1983-06-19	1983-06-19 00:00:00	1983-06-19	38000177		0	0	13		0	0	0	228143	0	834102	19133905		
61735	5137	1127433	1989-05-17	1989-05-17 00:00:00	1989-06-07	1989-06-07 00:00:00	1989-06-07	38000177		0	0	21		0	0	0	341356	0	313782	1127433		
52966	4401	1713671	1989-01-10	1989-01-10 00:00:00	1989-01-17	1989-01-17 00:00:00	1989-01-17	38000177		0	0	7		0	0	0	292547	0	562251	1713671		
5899	492	19059056	1952-08-13	1952-08-13 00:00:00	1952-09-17	1952-09-17 00:00:00	1952-09-17	38000177		0	0	35		0	0	0	32985	0	243670	19059056		
9326	775	1127433	1959-07-01	1959-07-01 00:00:00	1959-07-08	1959-07-08 00:00:00	1959-07-08	38000177		0	0	7		0	0	0	51417	0	313782	1127433		
52200	4342	1713671	2005-10-24	2005-10-24 00:00:00	2005-11-14	2005-11-14 00:00:00	2005-11-14	38000177		0	0	21		0	0	0	287888	0	562251	1713671		
47556	3941	40236824	1993-03-15	1993-03-15 00:00:00	1993-03-22	1993-03-22 00:00:00	1993-03-22	38000177		0	0	7		0	0	0	262000	0	1094107	40236824		
36349	2997	920300	2001-11-11	2001-11-11 00:00:00	2001-11-18	2001-11-18 00:00:00	2001-11-18	38000177		0	0	7		0	0	0	199940	0	311989	920300		
21342	1755	19128065	1980-05-07	1980-05-07 00:00:00	1981-05-02	1981-05-02 00:00:00	1981-05-02	38000177		0	0	360		0	0	0	117348	0	749882	19128065		
25341	2084	920300	2001-12-16	2001-12-16 00:00:00	2001-12-23	2001-12-23 00:00:00	2001-12-23	38000177		0	0	7		0	0	0	138862	0	311989	920300		
32114	2661	19078461	2006-12-21	2006-12-21 00:00:00	2007-01-04	2007-01-04 00:00:00	2007-01-04	38000177		0	0	14		0	0	0	176232	0	310965	19078461		
112057	2462	40213227	1992-12-20	1992-12-20 00:00:00	1992-12-20	1992-12-20 00:00:00	1992-12-20	581452		0	0	0		0	0	0	163271	0	113	40213227		
52495	4366	1127078	1984-09-01	1984-09-01 00:00:00	1984-09-15	1984-09-15 00:00:00	1984-09-15	38000177		0	0	14		0	0	0	289613	0	282464	1127078		
32027	2654	1127433	2004-08-09	2004-08-09 00:00:00	2004-09-06	2004-09-06 00:00:00	2004-09-06	38000177		0	0	28		0	0	0	175726	0	313782	1127433		
60151	5000	1118084	1973-12-02	1973-12-02 00:00:00	1973-12-02	1973-12-02 00:00:00	\N	38000177		0	0	0		0	0	0	332564	0	00025152531	44923712		
61933	5151	19133873	1958-11-23	1958-11-23 00:00:00	1958-12-02	1958-12-02 00:00:00	1958-12-02	38000177		0	0	9		0	0	0	342499	0	834061	19133873		
10277	862	1127433	1973-09-16	1973-09-16 00:00:00	1973-09-30	1973-09-30 00:00:00	1973-09-30	38000177		0	0	14		0	0	0	57040	0	313782	1127433		
60377	5023	40169216	1974-08-13	1974-08-13 00:00:00	1974-08-13	1974-08-13 00:00:00	\N	38000177		0	0	0		0	0	0	333749	0	895994	40169216		
124977	2749	40213227	2010-12-29	2010-12-29 00:00:00	2010-12-29	2010-12-29 00:00:00	2010-12-29	581452		0	0	0		0	0	0	181812	0	113	40213227		
57161	4745	1115171	1995-10-03	1995-10-03 00:00:00	1995-10-31	1995-10-31 00:00:00	1995-10-31	38000177		0	0	28		0	0	0	315992	0	849574	1115171		
43546	949	40213160	1958-06-23	1958-06-23 00:00:00	1958-06-23	1958-06-23 00:00:00	1958-06-23	581452		0	0	0		0	0	0	63046	0	10	40213160		
11612	249	40213160	1986-08-02	1986-08-02 00:00:00	1986-08-02	1986-08-02 00:00:00	1986-08-02	581452		0	0	0		0	0	0	16748	0	10	40213160		
36567	3017	19006318	1958-04-13	1958-04-13 00:00:00	1958-04-27	1958-04-27 00:00:00	1958-04-27	38000177		0	0	14		0	0	0	201258	0	105078	19006318		
44828	3708	19074843	1981-05-12	1981-05-12 00:00:00	1981-05-26	1981-05-26 00:00:00	1981-05-26	38000177		0	0	14		0	0	0	246484	0	309045	19074843		
136519	2997	40213227	2004-01-25	2004-01-25 00:00:00	2004-01-25	2004-01-25 00:00:00	2004-01-25	581452		0	0	0		0	0	0	199945	0	113	40213227		
39441	3258	1127078	1985-03-31	1985-03-31 00:00:00	1985-04-14	1985-04-14 00:00:00	1985-04-14	38000177		0	0	14		0	0	0	216624	0	282464	1127078		
26066	2145	1127433	1989-09-05	1989-09-05 00:00:00	1989-09-19	1989-09-19 00:00:00	1989-09-19	38000177		0	0	14		0	0	0	142784	0	313782	1127433		
26123	2150	1713671	1981-09-24	1981-09-24 00:00:00	1981-10-01	1981-10-01 00:00:00	1981-10-01	38000177		0	0	7		0	0	0	143177	0	562251	1713671		
22345	1837	40229134	1971-06-07	1971-06-07 00:00:00	1971-06-21	1971-06-21 00:00:00	1971-06-21	38000177		0	0	14		0	0	0	122739	0	1043400	40229134		
23377	1925	19133905	1966-02-13	1966-02-13 00:00:00	1966-02-23	1966-02-23 00:00:00	1966-02-23	38000177		0	0	10		0	0	0	128118	0	834102	19133905		
222585	4886	40213160	1966-02-14	1966-02-14 00:00:00	1966-02-14	1966-02-14 00:00:00	1966-02-14	581452		0	0	0		0	0	0	324893	0	10	40213160		
32964	2732	1713671	1975-03-14	1975-03-14 00:00:00	1975-04-04	1975-04-04 00:00:00	1975-04-04	38000177		0	0	21		0	0	0	180911	0	562251	1713671		
54992	4565	1127433	2018-11-24	2018-11-24 00:00:00	2018-12-15	2018-12-15 00:00:00	2018-12-15	38000177		0	0	21		0	0	0	304214	0	313782	1127433		
233968	5142	40213198	2010-12-07	2010-12-07 00:00:00	2010-12-07	2010-12-07 00:00:00	2010-12-07	581452		0	0	0		0	0	0	341786	0	133	40213198		
48772	1068	40213296	2013-09-20	2013-09-20 00:00:00	2013-09-20	2013-09-20 00:00:00	2013-09-20	581452		0	0	0		0	0	0	69972	0	52	40213296		
67591	1478	40213260	2011-03-22	2011-03-22 00:00:00	2011-03-22	2011-03-22 00:00:00	2011-03-22	581452		0	0	0		0	0	0	98668	0	121	40213260		
70545	1542	40213227	2017-11-01	2017-11-01 00:00:00	2017-11-01	2017-11-01 00:00:00	2017-11-01	581452		0	0	0		0	0	0	103320	0	113	40213227		
168282	3699	40213306	1993-09-02	1993-09-02 00:00:00	1993-09-02	1993-09-02 00:00:00	1993-09-02	581452		0	0	0		0	0	0	245905	0	43	40213306		
55181	4580	40236824	2008-04-03	2008-04-03 00:00:00	2008-04-10	2008-04-10 00:00:00	2008-04-10	38000177		0	0	7		0	0	0	305082	0	1094107	40236824		
49264	4087	19078461	2008-03-20	2008-03-20 00:00:00	2008-04-03	2008-04-03 00:00:00	2008-04-03	38000177		0	0	14		0	0	0	271642	0	310965	19078461		
4251	351	40224805	2002-09-29	2002-09-29 00:00:00	2003-09-24	2003-09-24 00:00:00	2003-09-24	38000177		0	0	360		0	0	0	23365	0	1000126	40224805		
17056	1411	19059056	1968-07-30	1968-07-30 00:00:00	1968-08-13	1968-08-13 00:00:00	1968-08-13	38000177		0	0	14		0	0	0	93932	0	243670	19059056		
33476	2771	1115171	2013-09-28	2013-09-28 00:00:00	2013-10-28	2013-10-28 00:00:00	2013-10-28	38000177		0	0	30		0	0	0	183478	0	849574	1115171		
11302	940	1118084	1982-07-09	1982-07-09 00:00:00	1982-07-09	1982-07-09 00:00:00	\N	38000177		0	0	0		0	0	0	62529	0	00025152531	44923712		
11027	918	1127433	1966-02-22	1966-02-22 00:00:00	1966-03-08	1966-03-08 00:00:00	1966-03-08	38000177		0	0	14		0	0	0	61199	0	313782	1127433		
9208	764	1127433	2010-01-08	2010-01-08 00:00:00	2010-01-15	2010-01-15 00:00:00	2010-01-15	38000177		0	0	7		0	0	0	50824	0	313782	1127433		
29422	2436	1127433	1961-09-18	1961-09-18 00:00:00	1961-10-02	1961-10-02 00:00:00	1961-10-02	38000177		0	0	14		0	0	0	161499	0	313782	1127433		
98347	2153	40213227	1997-08-16	1997-08-16 00:00:00	1997-08-16	1997-08-16 00:00:00	1997-08-16	581452		0	0	0		0	0	0	143464	0	113	40213227		
116111	2551	40213160	1959-01-29	1959-01-29 00:00:00	1959-01-29	1959-01-29 00:00:00	1959-01-29	581452		0	0	0		0	0	0	168868	0	10	40213160		
38817	3211	19059056	1965-06-09	1965-06-09 00:00:00	1965-06-23	1965-06-23 00:00:00	1965-06-23	38000177		0	0	14		0	0	0	213358	0	243670	19059056		
94760	2079	40213160	1956-05-25	1956-05-25 00:00:00	1956-05-25	1956-05-25 00:00:00	1956-05-25	581452		0	0	0		0	0	0	138451	0	10	40213160		
202745	4451	40213198	2016-08-07	2016-08-07 00:00:00	2016-08-07	2016-08-07 00:00:00	2016-08-07	581452		0	0	0		0	0	0	296117	0	133	40213198		
33353	728	40213160	1955-07-02	1955-07-02 00:00:00	1955-07-02	1955-07-02 00:00:00	1955-07-02	581452		0	0	0		0	0	0	48345	0	10	40213160		
78046	1707	40213227	1992-10-12	1992-10-12 00:00:00	1992-10-12	1992-10-12 00:00:00	1992-10-12	581452		0	0	0		0	0	0	114114	0	113	40213227		
43176	3577	19006318	1961-05-28	1961-05-28 00:00:00	1961-06-11	1961-06-11 00:00:00	1961-06-11	38000177		0	0	14		0	0	0	237844	0	105078	19006318		
3157	260	1127433	1979-09-06	1979-09-06 00:00:00	1979-09-13	1979-09-13 00:00:00	1979-09-13	38000177		0	0	7		0	0	0	17156	0	313782	1127433		
6002	502	1713671	2001-05-13	2001-05-13 00:00:00	2001-05-27	2001-05-27 00:00:00	2001-05-27	38000177		0	0	14		0	0	0	33585	0	562251	1713671		
21198	1746	920300	2005-04-12	2005-04-12 00:00:00	2005-04-19	2005-04-19 00:00:00	2005-04-19	38000177		0	0	7		0	0	0	116799	0	311989	920300		
87289	1915	40213227	1996-07-16	1996-07-16 00:00:00	1996-07-16	1996-07-16 00:00:00	1996-07-16	581452		0	0	0		0	0	0	127412	0	113	40213227		
79651	1743	40213296	2007-02-14	2007-02-14 00:00:00	2007-02-14	2007-02-14 00:00:00	2007-02-14	581452		0	0	0		0	0	0	116568	0	52	40213296		
54406	4523	40229134	1998-11-27	1998-11-27 00:00:00	1998-12-04	1998-12-04 00:00:00	1998-12-04	38000177		0	0	7		0	0	0	301183	0	1043400	40229134		
151383	3330	40213296	2015-10-18	2015-10-18 00:00:00	2015-10-18	2015-10-18 00:00:00	2015-10-18	581452		0	0	0		0	0	0	220981	0	52	40213296		
7217	606	19006318	1975-07-12	1975-07-12 00:00:00	1975-07-26	1975-07-26 00:00:00	1975-07-26	38000177		0	0	14		0	0	0	40254	0	105078	19006318		
98996	2168	40213227	2007-09-20	2007-09-20 00:00:00	2007-09-20	2007-09-20 00:00:00	2007-09-20	581452		0	0	0		0	0	0	144407	0	113	40213227		
41508	3439	19059056	1957-01-30	1957-01-30 00:00:00	1957-02-13	1957-02-13 00:00:00	1957-02-13	38000177		0	0	14		0	0	0	228219	0	243670	19059056		
61736	5137	1127433	1975-01-17	1975-01-17 00:00:00	1975-01-24	1975-01-24 00:00:00	1975-01-24	38000177		0	0	7		0	0	0	341395	0	313782	1127433		
52976	4403	1127433	1989-09-15	1989-09-15 00:00:00	1989-10-20	1989-10-20 00:00:00	1989-10-20	38000177		0	0	35		0	0	0	292711	0	313782	1127433		
5900	492	19133873	1954-03-18	1954-03-18 00:00:00	1954-03-29	1954-03-29 00:00:00	1954-03-29	38000177		0	0	11		0	0	0	32979	0	834061	19133873		
9327	775	1127433	2012-09-06	2012-09-06 00:00:00	2012-09-20	2012-09-20 00:00:00	2012-09-20	38000177		0	0	14		0	0	0	51411	0	313782	1127433		
52201	4342	1127433	1998-08-05	1998-08-05 00:00:00	1998-08-12	1998-08-12 00:00:00	1998-08-12	38000177		0	0	7		0	0	0	287877	0	313782	1127433		
47557	3942	1127433	1993-03-02	1993-03-02 00:00:00	1993-04-06	1993-04-06 00:00:00	1993-04-06	38000177		0	0	35		0	0	0	262087	0	313782	1127433		
36350	2997	19078461	2004-12-16	2004-12-16 00:00:00	2005-01-22	2005-01-22 00:00:00	2005-01-22	38000177		0	0	37		0	0	0	199962	0	310965	19078461		
21343	1755	19133905	2000-04-21	2000-04-21 00:00:00	2000-04-29	2000-04-29 00:00:00	2000-04-29	38000177		0	0	8		0	0	0	117386	0	834102	19133905		
25342	2084	1127433	1976-08-27	1976-08-27 00:00:00	1976-09-10	1976-09-10 00:00:00	1976-09-10	38000177		0	0	14		0	0	0	138832	0	313782	1127433		
32115	2661	1118084	2005-01-19	2005-01-19 00:00:00	2005-01-19	2005-01-19 00:00:00	\N	38000177		0	0	0		0	0	0	176343	0	00025152531	44923712		
112069	2462	40213160	1962-06-17	1962-06-17 00:00:00	1962-06-17	1962-06-17 00:00:00	1962-06-17	581452		0	0	0		0	0	0	163279	0	10	40213160		
52496	4366	40232448	1982-04-19	1982-04-19 00:00:00	1982-04-19	1982-04-19 00:00:00	\N	38000177		0	0	0		0	0	0	289663	0	1049630	40232448		
32028	2654	1127433	2015-03-31	2015-03-31 00:00:00	2015-04-07	2015-04-07 00:00:00	2015-04-07	38000177		0	0	7		0	0	0	175717	0	313782	1127433		
60152	5000	19059056	1938-09-22	1938-09-22 00:00:00	1938-10-06	1938-10-06 00:00:00	1938-10-06	38000177		0	0	14		0	0	0	332518	0	243670	19059056		
61934	5151	19126352	2017-01-27	2017-01-27 00:00:00	2017-01-27	2017-01-27 00:00:00	\N	38000177		0	0	0		0	0	0	342520	0	705129	19126352		
10278	862	40229134	1997-06-29	1997-06-29 00:00:00	1997-07-06	1997-07-06 00:00:00	1997-07-06	38000177		0	0	7		0	0	0	57089	0	1043400	40229134		
60378	5023	19078461	2017-11-15	2017-11-15 00:00:00	2017-12-13	2017-12-13 00:00:00	2017-12-13	38000177		0	0	28		0	0	0	333776	0	310965	19078461		
124978	2749	40213260	2010-12-29	2010-12-29 00:00:00	2010-12-29	2010-12-29 00:00:00	2010-12-29	581452		0	0	0		0	0	0	181812	0	121	40213260		
57162	4745	19128065	1991-03-19	1991-03-19 00:00:00	1992-03-13	1992-03-13 00:00:00	1992-03-13	38000177		0	0	360		0	0	0	315911	0	749882	19128065		
43548	949	40213296	2000-04-03	2000-04-03 00:00:00	2000-04-03	2000-04-03 00:00:00	2000-04-03	581452		0	0	0		0	0	0	63034	0	52	40213296		
11613	249	40213251	1986-08-02	1986-08-02 00:00:00	1986-08-02	1986-08-02 00:00:00	1986-08-02	581452		0	0	0		0	0	0	16748	0	21	40213251		
36568	3017	19059056	1958-04-13	1958-04-13 00:00:00	1958-04-27	1958-04-27 00:00:00	1958-04-27	38000177		0	0	14		0	0	0	201258	0	243670	19059056		
44829	3708	19019979	1981-05-12	1981-05-12 00:00:00	1981-05-26	1981-05-26 00:00:00	1981-05-26	38000177		0	0	14		0	0	0	246484	0	198405	19019979		
136521	2997	40213227	2013-02-03	2013-02-03 00:00:00	2013-02-03	2013-02-03 00:00:00	2013-02-03	581452		0	0	0		0	0	0	199948	0	113	40213227		
39442	3258	1127433	1989-08-22	1989-08-22 00:00:00	1989-08-29	1989-08-29 00:00:00	1989-08-29	38000177		0	0	7		0	0	0	216555	0	313782	1127433		
26067	2145	19078461	1982-03-16	1982-03-16 00:00:00	1982-04-15	1982-04-15 00:00:00	1982-04-15	38000177		0	0	30		0	0	0	142799	0	310965	19078461		
26124	2150	1127078	1952-12-22	1952-12-22 00:00:00	1953-01-05	1953-01-05 00:00:00	1953-01-05	38000177		0	0	14		0	0	0	143172	0	282464	1127078		
22346	1837	40229134	2015-07-02	2015-07-02 00:00:00	2015-07-16	2015-07-16 00:00:00	2015-07-16	38000177		0	0	14		0	0	0	122731	0	1043400	40229134		
23378	1925	19059056	1952-07-12	1952-07-12 00:00:00	1952-08-11	1952-08-11 00:00:00	1952-08-11	38000177		0	0	30		0	0	0	128082	0	243670	19059056		
140829	3092	40213160	1960-07-06	1960-07-06 00:00:00	1960-07-06	1960-07-06 00:00:00	1960-07-06	581452		0	0	0		0	0	0	205900	0	10	40213160		
32965	2732	19133905	2014-01-30	2014-01-30 00:00:00	2014-02-10	2014-02-10 00:00:00	2014-02-10	38000177		0	0	11		0	0	0	180880	0	834102	19133905		
34005	2812	1118084	1970-12-15	1970-12-15 00:00:00	1970-12-15	1970-12-15 00:00:00	\N	38000177		0	0	0		0	0	0	186355	0	00025152531	44923712		
233995	5142	40213227	1996-09-17	1996-09-17 00:00:00	1996-09-17	1996-09-17 00:00:00	1996-09-17	581452		0	0	0		0	0	0	341779	0	113	40213227		
48776	1068	40213160	1974-05-24	1974-05-24 00:00:00	1974-05-24	1974-05-24 00:00:00	1974-05-24	581452		0	0	0		0	0	0	69992	0	10	40213160		
67599	1478	40213160	1961-06-27	1961-06-27 00:00:00	1961-06-27	1961-06-27 00:00:00	1961-06-27	581452		0	0	0		0	0	0	98565	0	10	40213160		
47435	3932	19133905	1995-12-08	1995-12-08 00:00:00	1995-12-20	1995-12-20 00:00:00	1995-12-20	38000177		0	0	12		0	0	0	261404	0	834102	19133905		
168294	3699	40213227	2002-09-12	2002-09-12 00:00:00	2002-09-12	2002-09-12 00:00:00	2002-09-12	581452		0	0	0		0	0	0	245908	0	113	40213227		
55182	4580	920300	2008-04-03	2008-04-03 00:00:00	2008-04-10	2008-04-10 00:00:00	2008-04-10	38000177		0	0	7		0	0	0	305082	0	311989	920300		
49265	4087	1127433	2002-09-17	2002-09-17 00:00:00	2002-09-24	2002-09-24 00:00:00	2002-09-24	38000177		0	0	7		0	0	0	271670	0	313782	1127433		
4252	351	19128022	1998-10-20	1998-10-20 00:00:00	1999-10-15	1999-10-15 00:00:00	1999-10-15	38000177		0	0	360		0	0	0	23399	0	749785	19128022		
17058	1411	1127433	1996-03-22	1996-03-22 00:00:00	1996-04-28	1996-04-28 00:00:00	1996-04-28	38000177		0	0	37		0	0	0	93966	0	313782	1127433		
33477	2771	40220960	1993-02-19	1993-02-19 00:00:00	1993-02-19	1993-02-19 00:00:00	1993-02-19	38000177		0	0	0		0	0	0	183476	0	1804799	40220960		
11303	940	1713671	1968-04-20	1968-04-20 00:00:00	1968-04-27	1968-04-27 00:00:00	1968-04-27	38000177		0	0	7		0	0	0	62540	0	562251	1713671		
11028	918	1115171	2008-05-20	2008-05-20 00:00:00	2008-06-03	2008-06-03 00:00:00	2008-06-03	38000177		0	0	14		0	0	0	61205	0	849574	1115171		
50474	4194	19078461	2005-11-19	2005-11-19 00:00:00	2005-12-17	2005-12-17 00:00:00	2005-12-17	38000177		0	0	28		0	0	0	278386	0	310965	19078461		
29423	2436	40165015	1963-02-11	1963-02-11 00:00:00	1963-02-11	1963-02-11 00:00:00	\N	38000177		0	0	0		0	0	0	161574	0	861467	40165015		
98354	2153	40213227	2007-12-01	2007-12-01 00:00:00	2007-12-01	2007-12-01 00:00:00	2007-12-01	581452		0	0	0		0	0	0	143498	0	113	40213227		
116118	2551	40213227	2001-02-01	2001-02-01 00:00:00	2001-02-01	2001-02-01 00:00:00	2001-02-01	581452		0	0	0		0	0	0	168890	0	113	40213227		
38820	3211	1127433	1961-06-02	1961-06-02 00:00:00	1961-06-16	1961-06-16 00:00:00	1961-06-16	38000177		0	0	14		0	0	0	213363	0	313782	1127433		
94766	2079	40213296	1999-06-18	1999-06-18 00:00:00	1999-06-18	1999-06-18 00:00:00	1999-06-18	581452		0	0	0		0	0	0	138484	0	52	40213296		
202752	4451	40213227	1994-01-30	1994-01-30 00:00:00	1994-01-30	1994-01-30 00:00:00	1994-01-30	581452		0	0	0		0	0	0	296190	0	113	40213227		
33354	728	40213227	2006-01-28	2006-01-28 00:00:00	2006-01-28	2006-01-28 00:00:00	2006-01-28	581452		0	0	0		0	0	0	48272	0	113	40213227		
78047	1707	40213306	1992-10-12	1992-10-12 00:00:00	1992-10-12	1992-10-12 00:00:00	1992-10-12	581452		0	0	0		0	0	0	114114	0	43	40213306		
43177	3577	19059056	1961-05-28	1961-05-28 00:00:00	1961-06-11	1961-06-11 00:00:00	1961-06-11	38000177		0	0	14		0	0	0	237844	0	243670	19059056		
5977	499	19008572	1964-09-07	1964-09-07 00:00:00	1964-09-21	1964-09-21 00:00:00	1964-09-21	38000177		0	0	14		0	0	0	33450	0	106258	19008572		
6003	502	1713671	1974-08-05	1974-08-05 00:00:00	1974-08-12	1974-08-12 00:00:00	1974-08-12	38000177		0	0	7		0	0	0	33633	0	562251	1713671		
21199	1746	40236824	2005-04-12	2005-04-12 00:00:00	2005-04-19	2005-04-19 00:00:00	2005-04-19	38000177		0	0	7		0	0	0	116799	0	1094107	40236824		
87290	1915	40213306	1996-07-16	1996-07-16 00:00:00	1996-07-16	1996-07-16 00:00:00	1996-07-16	581452		0	0	0		0	0	0	127412	0	43	40213306		
79653	1743	40213227	2016-02-10	2016-02-10 00:00:00	2016-02-10	2016-02-10 00:00:00	2016-02-10	581452		0	0	0		0	0	0	116543	0	113	40213227		
54407	4523	19133873	1977-10-19	1977-10-19 00:00:00	1977-10-30	1977-10-30 00:00:00	1977-10-30	38000177		0	0	11		0	0	0	301174	0	834061	19133873		
151385	3330	40213160	1974-06-16	1974-06-16 00:00:00	1974-06-16	1974-06-16 00:00:00	1974-06-16	581452		0	0	0		0	0	0	220963	0	10	40213160		
7218	606	1127078	1975-07-12	1975-07-12 00:00:00	1975-07-26	1975-07-26 00:00:00	1975-07-26	38000177		0	0	14		0	0	0	40254	0	282464	1127078		
98997	2168	40213260	2007-09-20	2007-09-20 00:00:00	2007-09-20	2007-09-20 00:00:00	2007-09-20	581452		0	0	0		0	0	0	144407	0	121	40213260		
41509	3439	19006318	1957-01-30	1957-01-30 00:00:00	1957-02-13	1957-02-13 00:00:00	1957-02-13	38000177		0	0	14		0	0	0	228219	0	105078	19006318		
61737	5137	1127433	2011-02-24	2011-02-24 00:00:00	2011-03-10	2011-03-10 00:00:00	2011-03-10	38000177		0	0	14		0	0	0	341372	0	313782	1127433		
52977	4403	19059056	1962-06-29	1962-06-29 00:00:00	1962-07-13	1962-07-13 00:00:00	1962-07-13	38000177		0	0	14		0	0	0	292707	0	243670	19059056		
5901	492	19059056	1968-07-25	1968-07-25 00:00:00	1968-08-08	1968-08-08 00:00:00	1968-08-08	38000177		0	0	14		0	0	0	32905	0	243670	19059056		
9328	775	1118084	1976-05-25	1976-05-25 00:00:00	1976-05-25	1976-05-25 00:00:00	\N	38000177		0	0	0		0	0	0	51462	0	00025152531	44923712		
52202	4342	19133905	1980-04-02	1980-04-02 00:00:00	1980-04-15	1980-04-15 00:00:00	1980-04-15	38000177		0	0	13		0	0	0	287976	0	834102	19133905		
47558	3942	1127078	1989-06-21	1989-06-21 00:00:00	1989-07-21	1989-07-21 00:00:00	1989-07-21	38000177		0	0	30		0	0	0	262086	0	282464	1127078		
36351	2997	40165015	2004-12-23	2004-12-23 00:00:00	2004-12-23	2004-12-23 00:00:00	\N	38000177		0	0	0		0	0	0	199956	0	861467	40165015		
21344	1755	1127433	1990-08-22	1990-08-22 00:00:00	1990-09-05	1990-09-05 00:00:00	1990-09-05	38000177		0	0	14		0	0	0	117385	0	313782	1127433		
25366	2087	1713671	1941-09-15	1941-09-15 00:00:00	1941-09-22	1941-09-22 00:00:00	1941-09-22	38000177		0	0	7		0	0	0	139134	0	562251	1713671		
32116	2661	19059056	1969-06-17	1969-06-17 00:00:00	1969-07-08	1969-07-08 00:00:00	1969-07-08	38000177		0	0	21		0	0	0	176281	0	243670	19059056		
112072	2462	40213160	1962-01-14	1962-01-14 00:00:00	1962-01-14	1962-01-14 00:00:00	1962-01-14	581452		0	0	0		0	0	0	163278	0	10	40213160		
52497	4366	19133873	1983-09-25	1983-09-25 00:00:00	1983-10-02	1983-10-02 00:00:00	1983-10-02	38000177		0	0	7		0	0	0	289667	0	834061	19133873		
32029	2654	1127433	1989-12-05	1989-12-05 00:00:00	1989-12-26	1989-12-26 00:00:00	1989-12-26	38000177		0	0	21		0	0	0	175724	0	313782	1127433		
60153	5000	19059056	1947-05-22	1947-05-22 00:00:00	1947-06-12	1947-06-12 00:00:00	1947-06-12	38000177		0	0	21		0	0	0	332550	0	243670	19059056		
61935	5151	1539411	2017-01-27	2017-01-27 00:00:00	2017-01-27	2017-01-27 00:00:00	\N	38000177		0	0	0		0	0	0	342520	0	312961	1539411		
10279	862	1124300	2004-08-07	2004-08-07 00:00:00	2004-08-07	2004-08-07 00:00:00	\N	38000177		0	0	0		0	0	0	57097	0	00781178901	45011828		
60379	5023	1127433	2003-02-01	2003-02-01 00:00:00	2003-02-15	2003-02-15 00:00:00	2003-02-15	38000177		0	0	14		0	0	0	333777	0	313782	1127433		
124981	2749	40213260	2009-12-23	2009-12-23 00:00:00	2009-12-23	2009-12-23 00:00:00	2009-12-23	581452		0	0	0		0	0	0	181815	0	121	40213260		
57163	4745	19128065	1992-03-13	1992-03-13 00:00:00	1993-03-08	1993-03-08 00:00:00	1993-03-08	38000177		0	0	360		0	0	0	315912	0	749882	19128065		
43550	949	40213227	2000-04-03	2000-04-03 00:00:00	2000-04-03	2000-04-03 00:00:00	2000-04-03	581452		0	0	0		0	0	0	63034	0	113	40213227		
21826	474	40213296	2009-12-20	2009-12-20 00:00:00	2009-12-20	2009-12-20 00:00:00	2009-12-20	581452		0	0	0		0	0	0	31637	0	52	40213296		
36569	3017	1127433	2000-11-08	2000-11-08 00:00:00	2000-11-15	2000-11-15 00:00:00	2000-11-15	38000177		0	0	7		0	0	0	201276	0	313782	1127433		
5485	458	1127433	2002-06-23	2002-06-23 00:00:00	2002-07-07	2002-07-07 00:00:00	2002-07-07	38000177		0	0	14		0	0	0	30649	0	313782	1127433		
136523	2997	40213314	1982-03-14	1982-03-14 00:00:00	1982-03-14	1982-03-14 00:00:00	1982-03-14	581452		0	0	0		0	0	0	199932	0	49	40213314		
39443	3258	44816277	2005-04-08	2005-04-08 00:00:00	2006-04-03	2006-04-03 00:00:00	2006-04-03	38000177		0	0	360		0	0	0	216565	0	1534809	44816277		
26068	2145	19133873	1968-06-30	1968-06-30 00:00:00	1968-07-11	1968-07-11 00:00:00	1968-07-11	38000177		0	0	11		0	0	0	142789	0	834061	19133873		
26125	2150	19006318	1951-07-14	1951-07-14 00:00:00	1951-07-28	1951-07-28 00:00:00	1951-07-28	38000177		0	0	14		0	0	0	143171	0	105078	19006318		
22347	1837	1127433	1990-04-23	1990-04-23 00:00:00	1990-04-30	1990-04-30 00:00:00	1990-04-30	38000177		0	0	7		0	0	0	122669	0	313782	1127433		
23379	1925	19059056	1959-06-06	1959-06-06 00:00:00	1959-07-06	1959-07-06 00:00:00	1959-07-06	38000177		0	0	30		0	0	0	128084	0	243670	19059056		
140835	3092	40213227	1997-08-06	1997-08-06 00:00:00	1997-08-06	1997-08-06 00:00:00	1997-08-06	581452		0	0	0		0	0	0	205852	0	113	40213227		
32966	2732	19128065	1987-07-14	1987-07-14 00:00:00	1988-07-08	1988-07-08 00:00:00	1988-07-08	38000177		0	0	360		0	0	0	180883	0	749882	19128065		
34006	2812	1127433	2012-11-24	2012-11-24 00:00:00	2012-12-08	2012-12-08 00:00:00	2012-12-08	38000177		0	0	14		0	0	0	186304	0	313782	1127433		
233999	5142	40213201	2011-12-13	2011-12-13 00:00:00	2011-12-13	2011-12-13 00:00:00	2011-12-13	581452		0	0	0		0	0	0	341749	0	33	40213201		
48778	1068	40213160	1974-02-22	1974-02-22 00:00:00	1974-02-22	1974-02-22 00:00:00	1974-02-22	581452		0	0	0		0	0	0	69957	0	10	40213160		
67602	1478	40213160	1961-11-28	1961-11-28 00:00:00	1961-11-28	1961-11-28 00:00:00	1961-11-28	581452		0	0	0		0	0	0	98566	0	10	40213160		
47436	3932	1118084	2010-11-10	2010-11-10 00:00:00	2010-11-10	2010-11-10 00:00:00	\N	38000177		0	0	0		0	0	0	261387	0	00025152531	44923712		
168299	3699	40213160	1971-10-21	1971-10-21 00:00:00	1971-10-21	1971-10-21 00:00:00	1971-10-21	581452		0	0	0		0	0	0	245899	0	10	40213160		
55183	4580	19078461	1993-10-10	1993-10-10 00:00:00	1993-10-24	1993-10-24 00:00:00	1993-10-24	38000177		0	0	14		0	0	0	305078	0	310965	19078461		
49266	4087	19078461	1990-10-16	1990-10-16 00:00:00	1990-10-30	1990-10-30 00:00:00	1990-10-30	38000177		0	0	14		0	0	0	271678	0	310965	19078461		
4253	351	19128065	1992-11-20	1992-11-20 00:00:00	1993-11-15	1993-11-15 00:00:00	1993-11-15	38000177		0	0	360		0	0	0	23412	0	749882	19128065		
17059	1411	1713671	1982-07-04	1982-07-04 00:00:00	1982-07-25	1982-07-25 00:00:00	1982-07-25	38000177		0	0	21		0	0	0	93918	0	562251	1713671		
33478	2771	19079524	1974-09-02	1974-09-02 00:00:00	1974-09-02	1974-09-02 00:00:00	1974-09-02	38000177		0	0	0		0	0	0	183474	0	313002	19079524		
11304	940	19075601	1997-12-25	1997-12-25 00:00:00	2001-11-29	2001-11-29 00:00:00	2001-11-29	38000177		0	0	1435		0	0	0	62533	0	309362	19075601		
11029	918	19059056	1928-01-22	1928-01-22 00:00:00	1928-04-21	1928-04-21 00:00:00	1928-04-21	38000177		0	0	90		0	0	0	61197	0	243670	19059056		
50475	4194	1118084	2014-07-06	2014-07-06 00:00:00	2014-07-06	2014-07-06 00:00:00	\N	38000177		0	0	0		0	0	0	278405	0	00025152531	44923712		
29424	2436	1127433	1963-02-11	1963-02-11 00:00:00	1963-04-12	1963-04-12 00:00:00	1963-04-12	38000177		0	0	60		0	0	0	161574	0	313782	1127433		
98355	2153	40213296	2007-12-01	2007-12-01 00:00:00	2007-12-01	2007-12-01 00:00:00	2007-12-01	581452		0	0	0		0	0	0	143498	0	52	40213296		
116119	2551	40213296	2001-02-01	2001-02-01 00:00:00	2001-02-01	2001-02-01 00:00:00	2001-02-01	581452		0	0	0		0	0	0	168890	0	52	40213296		
38821	3211	19133905	2009-03-31	2009-03-31 00:00:00	2009-04-12	2009-04-12 00:00:00	2009-04-12	38000177		0	0	12		0	0	0	213333	0	834102	19133905		
94767	2079	40213160	1956-03-23	1956-03-23 00:00:00	1956-03-23	1956-03-23 00:00:00	1956-03-23	581452		0	0	0		0	0	0	138471	0	10	40213160		
202763	4451	40213160	1955-04-17	1955-04-17 00:00:00	1955-04-17	1955-04-17 00:00:00	1955-04-17	581452		0	0	0		0	0	0	296103	0	10	40213160		
33356	728	40213260	2006-01-28	2006-01-28 00:00:00	2006-01-28	2006-01-28 00:00:00	2006-01-28	581452		0	0	0		0	0	0	48272	0	121	40213260		
78049	1707	40213160	1971-04-19	1971-04-19 00:00:00	1971-04-19	1971-04-19 00:00:00	1971-04-19	581452		0	0	0		0	0	0	114152	0	10	40213160		
43178	3577	19006318	1963-03-30	1963-03-30 00:00:00	1963-04-13	1963-04-13 00:00:00	1963-04-13	38000177		0	0	14		0	0	0	237845	0	105078	19006318		
5978	499	1713671	2011-05-29	2011-05-29 00:00:00	2011-06-05	2011-06-05 00:00:00	2011-06-05	38000177		0	0	7		0	0	0	33373	0	562251	1713671		
6005	502	19059056	1977-02-02	1977-02-02 00:00:00	1977-02-16	1977-02-16 00:00:00	1977-02-16	38000177		0	0	14		0	0	0	33614	0	243670	19059056		
21200	1746	920300	2002-12-08	2002-12-08 00:00:00	2002-12-15	2002-12-15 00:00:00	2002-12-15	38000177		0	0	7		0	0	0	116754	0	311989	920300		
87292	1915	40213160	1974-06-11	1974-06-11 00:00:00	1974-06-11	1974-06-11 00:00:00	1974-06-11	581452		0	0	0		0	0	0	127344	0	10	40213160		
79654	1743	40213260	2016-02-10	2016-02-10 00:00:00	2016-02-10	2016-02-10 00:00:00	2016-02-10	581452		0	0	0		0	0	0	116543	0	121	40213260		
54408	4523	1713671	2008-07-13	2008-07-13 00:00:00	2008-07-27	2008-07-27 00:00:00	2008-07-27	38000177		0	0	14		0	0	0	301201	0	562251	1713671		
151387	3330	40213160	1974-01-13	1974-01-13 00:00:00	1974-01-13	1974-01-13 00:00:00	1974-01-13	581452		0	0	0		0	0	0	220962	0	10	40213160		
7219	606	40236824	1997-03-03	1997-03-03 00:00:00	1997-03-10	1997-03-10 00:00:00	1997-03-10	38000177		0	0	7		0	0	0	40252	0	1094107	40236824		
8869	741	40243436	2000-05-26	2000-05-26 00:00:00	2000-05-26	2000-05-26 00:00:00	2000-05-26	38000177		0	0	0		0	0	0	49043	0	1190795	40243436		
41510	3439	1127433	1970-02-22	1970-02-22 00:00:00	1970-03-01	1970-03-01 00:00:00	1970-03-01	38000177		0	0	7		0	0	0	228186	0	313782	1127433		
61738	5137	1127078	1972-06-30	1972-06-30 00:00:00	1972-07-14	1972-07-14 00:00:00	1972-07-14	38000177		0	0	14		0	0	0	341432	0	282464	1127078		
52978	4403	1127433	1992-10-04	1992-10-04 00:00:00	1992-11-03	1992-11-03 00:00:00	1992-11-03	38000177		0	0	30		0	0	0	292712	0	313782	1127433		
5903	492	1713671	1956-03-14	1956-03-14 00:00:00	1956-04-04	1956-04-04 00:00:00	1956-04-04	38000177		0	0	21		0	0	0	32936	0	562251	1713671		
9329	775	19059056	1955-04-19	1955-04-19 00:00:00	1955-05-17	1955-05-17 00:00:00	1955-05-17	38000177		0	0	28		0	0	0	51449	0	243670	19059056		
52203	4342	1713671	1977-10-25	1977-10-25 00:00:00	1977-11-01	1977-11-01 00:00:00	1977-11-01	38000177		0	0	7		0	0	0	287975	0	562251	1713671		
47559	3942	19133873	1991-09-29	1991-09-29 00:00:00	1991-10-12	1991-10-12 00:00:00	1991-10-12	38000177		0	0	13		0	0	0	262112	0	834061	19133873		
36352	2997	19078461	1994-01-29	1994-01-29 00:00:00	1994-02-12	1994-02-12 00:00:00	1994-02-12	38000177		0	0	14		0	0	0	199961	0	310965	19078461		
21345	1755	1127433	1969-09-03	1969-09-03 00:00:00	1969-09-10	1969-09-10 00:00:00	1969-09-10	38000177		0	0	7		0	0	0	117333	0	313782	1127433		
46891	3884	19133873	1980-01-18	1980-01-18 00:00:00	1980-01-31	1980-01-31 00:00:00	1980-01-31	38000177		0	0	13		0	0	0	258146	0	834061	19133873		
32117	2661	1154615	1967-09-18	1967-09-18 00:00:00	1967-09-18	1967-09-18 00:00:00	\N	38000177		0	0	0		0	0	0	176267	0	745679	1154615		
112073	2462	40213260	2011-10-09	2011-10-09 00:00:00	2011-10-09	2011-10-09 00:00:00	2011-10-09	581452		0	0	0		0	0	0	163241	0	121	40213260		
52498	4366	40169216	1984-05-11	1984-05-11 00:00:00	2001-04-03	2001-04-03 00:00:00	2001-04-03	38000177		0	0	6171		0	0	0	289632	0	895994	40169216		
32030	2654	1713671	1985-01-04	1985-01-04 00:00:00	1985-02-22	1985-02-22 00:00:00	1985-02-22	38000177		0	0	49		0	0	0	175687	0	562251	1713671		
60154	5000	1127433	2011-03-06	2011-03-06 00:00:00	2011-06-04	2011-06-04 00:00:00	2011-06-04	38000177		0	0	90		0	0	0	332555	0	313782	1127433		
61936	5151	19075601	2017-01-27	2017-01-27 00:00:00	2017-01-27	2017-01-27 00:00:00	\N	38000177		0	0	0		0	0	0	342520	0	309362	19075601		
10280	862	1127433	1995-08-31	1995-08-31 00:00:00	1995-09-07	1995-09-07 00:00:00	1995-09-07	38000177		0	0	7		0	0	0	57084	0	313782	1127433		
60380	5023	1127433	1994-09-12	1994-09-12 00:00:00	1994-09-26	1994-09-26 00:00:00	1994-09-26	38000177		0	0	14		0	0	0	333746	0	313782	1127433		
6800	148	40213160	1979-06-24	1979-06-24 00:00:00	1979-06-24	1979-06-24 00:00:00	1979-06-24	581452		0	0	0		0	0	0	9997	0	10	40213160		
57164	4745	1127078	1981-12-26	1981-12-26 00:00:00	1982-01-16	1982-01-16 00:00:00	1982-01-16	38000177		0	0	21		0	0	0	315887	0	282464	1127078		
43559	949	40213227	2009-11-09	2009-11-09 00:00:00	2009-11-09	2009-11-09 00:00:00	2009-11-09	581452		0	0	0		0	0	0	63041	0	113	40213227		
21828	474	40213227	1992-01-19	1992-01-19 00:00:00	1992-01-19	1992-01-19 00:00:00	1992-01-19	581452		0	0	0		0	0	0	31621	0	113	40213227		
36570	3017	1713671	1973-12-08	1973-12-08 00:00:00	1974-02-16	1974-02-16 00:00:00	1974-02-16	38000177		0	0	70		0	0	0	201211	0	562251	1713671		
5487	458	19128022	1991-07-15	1991-07-15 00:00:00	1992-07-09	1992-07-09 00:00:00	1992-07-09	38000177		0	0	360		0	0	0	30631	0	749785	19128022		
136524	2997	40213160	1982-03-14	1982-03-14 00:00:00	1982-03-14	1982-03-14 00:00:00	1982-03-14	581452		0	0	0		0	0	0	199932	0	10	40213160		
39444	3258	19133905	2010-09-15	2010-09-15 00:00:00	2010-09-28	2010-09-28 00:00:00	2010-09-28	38000177		0	0	13		0	0	0	216614	0	834102	19133905		
26074	2147	1713671	2001-04-09	2001-04-09 00:00:00	2001-04-23	2001-04-23 00:00:00	2001-04-23	38000177		0	0	14		0	0	0	142929	0	562251	1713671		
26126	2150	19059056	1951-07-14	1951-07-14 00:00:00	1951-07-28	1951-07-28 00:00:00	1951-07-28	38000177		0	0	14		0	0	0	143171	0	243670	19059056		
22348	1837	1551192	1964-01-23	1964-01-23 00:00:00	1964-01-23	1964-01-23 00:00:00	1964-01-23	38000177		0	0	0		0	0	0	122691	0	312617	1551192		
23380	1925	1127433	1960-05-01	1960-05-01 00:00:00	1960-05-31	1960-05-31 00:00:00	1960-05-31	38000177		0	0	30		0	0	0	128085	0	313782	1127433		
140836	3092	40213296	1997-08-06	1997-08-06 00:00:00	1997-08-06	1997-08-06 00:00:00	1997-08-06	581452		0	0	0		0	0	0	205852	0	52	40213296		
32967	2732	1127433	1972-07-23	1972-07-23 00:00:00	1972-07-30	1972-07-30 00:00:00	1972-07-30	38000177		0	0	7		0	0	0	180909	0	313782	1127433		
34007	2812	1127433	1962-08-29	1962-08-29 00:00:00	1962-09-12	1962-09-12 00:00:00	1962-09-12	38000177		0	0	14		0	0	0	186283	0	313782	1127433		
212218	4653	40213306	1981-11-01	1981-11-01 00:00:00	1981-11-01	1981-11-01 00:00:00	1981-11-01	581452		0	0	0		0	0	0	310160	0	43	40213306		
48780	1068	40213160	1973-12-21	1973-12-21 00:00:00	1973-12-21	1973-12-21 00:00:00	1973-12-21	581452		0	0	0		0	0	0	69991	0	10	40213160		
67607	1478	40213260	2012-03-27	2012-03-27 00:00:00	2012-03-27	2012-03-27 00:00:00	2012-03-27	581452		0	0	0		0	0	0	98650	0	121	40213260		
47437	3932	1127433	2006-09-27	2006-09-27 00:00:00	2006-10-04	2006-10-04 00:00:00	2006-10-04	38000177		0	0	7		0	0	0	261380	0	313782	1127433		
168306	3700	40213160	1971-08-11	1971-08-11 00:00:00	1971-08-11	1971-08-11 00:00:00	1971-08-11	581452		0	0	0		0	0	0	246015	0	10	40213160		
55184	4580	19019979	1975-07-12	1975-07-12 00:00:00	1975-08-16	1975-08-16 00:00:00	1975-08-16	38000177		0	0	35		0	0	0	305137	0	198405	19019979		
49267	4087	1124300	2018-01-27	2018-01-27 00:00:00	2018-01-27	2018-01-27 00:00:00	\N	38000177		0	0	0		0	0	0	271679	0	00781178901	45011828		
4254	351	40224805	1997-10-25	1997-10-25 00:00:00	1998-10-20	1998-10-20 00:00:00	1998-10-20	38000177		0	0	360		0	0	0	23397	0	1000126	40224805		
17061	1411	1127078	1966-09-26	1966-09-26 00:00:00	1966-10-10	1966-10-10 00:00:00	1966-10-10	38000177		0	0	14		0	0	0	93954	0	282464	1127078		
33479	2771	1154029	1974-09-02	1974-09-02 00:00:00	1974-09-02	1974-09-02 00:00:00	1974-09-02	38000177		0	0	0		0	0	0	183474	0	4337	1154029		
11305	940	1127433	1965-07-16	1965-07-16 00:00:00	1965-07-23	1965-07-23 00:00:00	1965-07-23	38000177		0	0	7		0	0	0	62539	0	313782	1127433		
11030	918	40231925	1928-01-22	1928-01-22 00:00:00	1928-01-22	1928-01-22 00:00:00	\N	38000177		0	0	0		0	0	0	61197	0	1049221	40231925		
50476	4194	19073183	1981-08-28	1981-08-28 00:00:00	1981-09-11	1981-09-11 00:00:00	1981-09-11	38000177		0	0	14		0	0	0	278381	0	308182	19073183		
29425	2436	1127433	1980-08-21	1980-08-21 00:00:00	1980-09-04	1980-09-04 00:00:00	1980-09-04	38000177		0	0	14		0	0	0	161588	0	313782	1127433		
98358	2153	40213227	2016-11-26	2016-11-26 00:00:00	2016-11-26	2016-11-26 00:00:00	2016-11-26	581452		0	0	0		0	0	0	143491	0	113	40213227		
116123	2551	40213227	2010-02-25	2010-02-25 00:00:00	2010-02-25	2010-02-25 00:00:00	2010-02-25	581452		0	0	0		0	0	0	168919	0	113	40213227		
38824	3211	1127433	2001-11-19	2001-11-19 00:00:00	2001-12-03	2001-12-03 00:00:00	2001-12-03	38000177		0	0	14		0	0	0	213317	0	313782	1127433		
94768	2079	40213260	2007-07-13	2007-07-13 00:00:00	2007-07-13	2007-07-13 00:00:00	2007-07-13	581452		0	0	0		0	0	0	138485	0	121	40213260		
202775	4451	40213201	2017-08-13	2017-08-13 00:00:00	2017-08-13	2017-08-13 00:00:00	2017-08-13	581452		0	0	0		0	0	0	296196	0	33	40213201		
33359	728	40213227	1997-04-12	1997-04-12 00:00:00	1997-04-12	1997-04-12 00:00:00	1997-04-12	581452		0	0	0		0	0	0	48271	0	113	40213227		
46679	3866	19133873	1957-05-16	1957-05-16 00:00:00	1957-05-24	1957-05-24 00:00:00	1957-05-24	38000177		0	0	8		0	0	0	256722	0	834061	19133873		
43179	3577	19059056	1963-03-30	1963-03-30 00:00:00	1963-04-13	1963-04-13 00:00:00	1963-04-13	38000177		0	0	14		0	0	0	237845	0	243670	19059056		
5979	499	19008572	1971-12-08	1971-12-08 00:00:00	1971-12-29	1971-12-29 00:00:00	1971-12-29	38000177		0	0	21		0	0	0	33455	0	106258	19008572		
6006	502	46233710	1977-02-02	1977-02-02 00:00:00	1977-02-16	1977-02-16 00:00:00	1977-02-16	38000177		0	0	14		0	0	0	33614	0	1650142	46233710		
21201	1746	40236824	2002-12-08	2002-12-08 00:00:00	2002-12-15	2002-12-15 00:00:00	2002-12-15	38000177		0	0	7		0	0	0	116754	0	1094107	40236824		
87298	1915	40213160	1979-02-13	1979-02-13 00:00:00	1979-02-13	1979-02-13 00:00:00	1979-02-13	581452		0	0	0		0	0	0	127398	0	10	40213160		
177037	3890	40213160	1955-12-27	1955-12-27 00:00:00	1955-12-27	1955-12-27 00:00:00	1955-12-27	581452		0	0	0		0	0	0	258599	0	10	40213160		
54409	4523	19059056	1984-01-13	1984-01-13 00:00:00	1984-02-17	1984-02-17 00:00:00	1984-02-17	38000177		0	0	35		0	0	0	301153	0	243670	19059056		
151390	3330	40213160	1974-03-17	1974-03-17 00:00:00	1974-03-17	1974-03-17 00:00:00	1974-03-17	581452		0	0	0		0	0	0	220978	0	10	40213160		
7220	606	920300	1997-03-03	1997-03-03 00:00:00	1997-03-10	1997-03-10 00:00:00	1997-03-10	38000177		0	0	7		0	0	0	40252	0	311989	920300		
8870	741	46275916	2000-05-26	2000-05-26 00:00:00	2000-05-26	2000-05-26 00:00:00	2000-05-26	38000177		0	0	0		0	0	0	49043	0	1660014	46275916		
41511	3439	1127433	1964-12-08	1964-12-08 00:00:00	1965-01-12	1965-01-12 00:00:00	1965-01-12	38000177		0	0	35		0	0	0	228139	0	313782	1127433		
61739	5137	46233988	1972-06-30	1972-06-30 00:00:00	1972-07-14	1972-07-14 00:00:00	1972-07-14	38000177		0	0	14		0	0	0	341432	0	1652673	46233988		
52979	4403	19059056	1949-10-14	1949-10-14 00:00:00	1949-11-04	1949-11-04 00:00:00	1949-11-04	38000177		0	0	21		0	0	0	292706	0	243670	19059056		
5904	492	19006318	1950-05-17	1950-05-17 00:00:00	1950-05-31	1950-05-31 00:00:00	1950-05-31	38000177		0	0	14		0	0	0	32983	0	105078	19006318		
9330	775	19059056	1947-05-03	1947-05-03 00:00:00	1947-06-02	1947-06-02 00:00:00	1947-06-02	38000177		0	0	30		0	0	0	51447	0	243670	19059056		
52204	4342	1551192	1993-01-30	1993-01-30 00:00:00	1993-01-30	1993-01-30 00:00:00	1993-01-30	38000177		0	0	0		0	0	0	287845	0	312617	1551192		
47560	3942	19019979	1978-09-17	1978-09-17 00:00:00	1978-10-01	1978-10-01 00:00:00	1978-10-01	38000177		0	0	14		0	0	0	262100	0	198405	19019979		
36353	2997	40224805	1996-09-25	1996-09-25 00:00:00	1997-09-20	1997-09-20 00:00:00	1997-09-20	38000177		0	0	360		0	0	0	199958	0	1000126	40224805		
21346	1755	1127433	2006-05-27	2006-05-27 00:00:00	2006-06-10	2006-06-10 00:00:00	2006-06-10	38000177		0	0	14		0	0	0	117387	0	313782	1127433		
46892	3884	19133905	2005-05-22	2005-05-22 00:00:00	2005-06-02	2005-06-02 00:00:00	2005-06-02	38000177		0	0	11		0	0	0	258155	0	834102	19133905		
32118	2661	40169216	1967-09-18	1967-09-18 00:00:00	1967-09-18	1967-09-18 00:00:00	\N	38000177		0	0	0		0	0	0	176267	0	895994	40169216		
112075	2462	40213160	1966-01-23	1966-01-23 00:00:00	1966-01-23	1966-01-23 00:00:00	1966-01-23	581452		0	0	0		0	0	0	\N	0	10	40213160		
52499	4366	1154615	1984-05-11	1984-05-11 00:00:00	2001-04-03	2001-04-03 00:00:00	2001-04-03	38000177		0	0	6171		0	0	0	289632	0	745679	1154615		
32031	2654	19078461	1983-04-13	1983-04-13 00:00:00	1983-06-19	1983-06-19 00:00:00	1983-06-19	38000177		0	0	67		0	0	0	175722	0	310965	19078461		
60155	5000	40165015	2011-03-06	2011-03-06 00:00:00	2011-03-06	2011-03-06 00:00:00	\N	38000177		0	0	0		0	0	0	332555	0	861467	40165015		
61937	5151	1332419	2017-01-27	2017-01-27 00:00:00	2017-01-27	2017-01-27 00:00:00	\N	38000177		0	0	0		0	0	0	342520	0	197361	1332419		
10281	862	1127433	1986-06-06	1986-06-06 00:00:00	1986-09-04	1986-09-04 00:00:00	1986-09-04	38000177		0	0	90		0	0	0	57052	0	313782	1127433		
60381	5023	19006318	1972-10-05	1972-10-05 00:00:00	1972-10-19	1972-10-19 00:00:00	1972-10-19	38000177		0	0	14		0	0	0	333739	0	105078	19006318		
18080	392	40213227	2007-02-23	2007-02-23 00:00:00	2007-02-23	2007-02-23 00:00:00	2007-02-23	581452		0	0	0		0	0	0	25736	0	113	40213227		
57188	4748	19078461	1976-03-27	1976-03-27 00:00:00	1976-06-25	1976-06-25 00:00:00	1976-06-25	38000177		0	0	90		0	0	0	316219	0	310965	19078461		
43560	949	40213260	2009-11-09	2009-11-09 00:00:00	2009-11-09	2009-11-09 00:00:00	2009-11-09	581452		0	0	0		0	0	0	63041	0	121	40213260		
21829	474	40213306	1992-01-19	1992-01-19 00:00:00	1992-01-19	1992-01-19 00:00:00	1992-01-19	581452		0	0	0		0	0	0	31621	0	43	40213306		
36572	3017	1127078	1960-07-01	1960-07-01 00:00:00	1960-09-29	1960-09-29 00:00:00	1960-09-29	38000177		0	0	90		0	0	0	201237	0	282464	1127078		
5488	458	46233988	1975-07-11	1975-07-11 00:00:00	1975-07-25	1975-07-25 00:00:00	1975-07-25	38000177		0	0	14		0	0	0	30652	0	1652673	46233988		
136525	2997	40213251	1984-03-11	1984-03-11 00:00:00	1984-03-11	1984-03-11 00:00:00	1984-03-11	581452		0	0	0		0	0	0	199949	0	21	40213251		
39445	3258	19128009	2003-04-19	2003-04-19 00:00:00	2004-04-13	2004-04-13 00:00:00	2004-04-13	38000177		0	0	360		0	0	0	216563	0	749762	19128009		
26075	2147	40229134	1988-01-23	1988-01-23 00:00:00	1988-02-06	1988-02-06 00:00:00	1988-02-06	38000177		0	0	14		0	0	0	142943	0	1043400	40229134		
26127	2150	19078461	2003-10-19	2003-10-19 00:00:00	2003-11-18	2003-11-18 00:00:00	2003-11-18	38000177		0	0	30		0	0	0	143152	0	310965	19078461		
22349	1837	1127433	1964-01-04	1964-01-04 00:00:00	1964-01-18	1964-01-18 00:00:00	1964-01-18	38000177		0	0	14		0	0	0	122702	0	313782	1127433		
23382	1926	40162522	1984-06-26	1984-06-26 00:00:00	1984-06-26	1984-06-26 00:00:00	\N	38000177		0	0	0		0	0	0	128199	0	857005	40162522		
140853	3092	40213227	2016-09-28	2016-09-28 00:00:00	2016-09-28	2016-09-28 00:00:00	2016-09-28	581452		0	0	0		0	0	0	205881	0	113	40213227		
32968	2732	1127433	1981-12-02	1981-12-02 00:00:00	1981-12-16	1981-12-16 00:00:00	1981-12-16	38000177		0	0	14		0	0	0	180881	0	313782	1127433		
34008	2812	1713671	1981-08-26	1981-08-26 00:00:00	1981-09-02	1981-09-02 00:00:00	1981-09-02	38000177		0	0	7		0	0	0	186303	0	562251	1713671		
212224	4653	40213160	1964-02-02	1964-02-02 00:00:00	1964-02-02	1964-02-02 00:00:00	1964-02-02	581452		0	0	0		0	0	0	310178	0	10	40213160		
48781	1068	40213314	1977-08-19	1977-08-19 00:00:00	1977-08-19	1977-08-19 00:00:00	1977-08-19	581452		0	0	0		0	0	0	69949	0	49	40213314		
67609	1478	40213227	2012-03-27	2012-03-27 00:00:00	2012-03-27	2012-03-27 00:00:00	2012-03-27	581452		0	0	0		0	0	0	98650	0	113	40213227		
47438	3932	1127433	1989-01-04	1989-01-04 00:00:00	1989-04-04	1989-04-04 00:00:00	1989-04-04	38000177		0	0	90		0	0	0	261399	0	313782	1127433		
168309	3700	40213160	1967-02-08	1967-02-08 00:00:00	1967-02-08	1967-02-08 00:00:00	1967-02-08	581452		0	0	0		0	0	0	246012	0	10	40213160		
55185	4580	19128065	1983-02-10	1983-02-10 00:00:00	1984-02-05	1984-02-05 00:00:00	1984-02-05	38000177		0	0	360		0	0	0	305108	0	749882	19128065		
49467	1083	40213306	1987-11-05	1987-11-05 00:00:00	1987-11-05	1987-11-05 00:00:00	1987-11-05	581452		0	0	0		0	0	0	\N	0	43	40213306		
4255	352	1127433	1981-09-26	1981-09-26 00:00:00	1981-10-10	1981-10-10 00:00:00	1981-10-10	38000177		0	0	14		0	0	0	23436	0	313782	1127433		
17062	1411	19006318	1966-09-26	1966-09-26 00:00:00	1966-10-10	1966-10-10 00:00:00	1966-10-10	38000177		0	0	14		0	0	0	93954	0	105078	19006318		
33480	2771	782047	1974-09-02	1974-09-02 00:00:00	1974-09-02	1974-09-02 00:00:00	1974-09-02	38000177		0	0	0		0	0	0	183474	0	542347	782047		
11306	940	1127433	1956-05-30	1956-05-30 00:00:00	1956-08-28	1956-08-28 00:00:00	1956-08-28	38000177		0	0	90		0	0	0	62560	0	313782	1127433		
11031	919	1713671	2002-02-06	2002-02-06 00:00:00	2002-02-13	2002-02-13 00:00:00	2002-02-13	38000177		0	0	7		0	0	0	61242	0	562251	1713671		
50477	4194	1127078	1981-08-28	1981-08-28 00:00:00	1981-09-11	1981-09-11 00:00:00	1981-09-11	38000177		0	0	14		0	0	0	278381	0	282464	1127078		
29426	2436	1127433	1970-10-25	1970-10-25 00:00:00	1970-11-08	1970-11-08 00:00:00	1970-11-08	38000177		0	0	14		0	0	0	161580	0	313782	1127433		
98359	2153	40213260	2016-11-26	2016-11-26 00:00:00	2016-11-26	2016-11-26 00:00:00	2016-11-26	581452		0	0	0		0	0	0	143491	0	121	40213260		
116124	2551	40213260	2010-02-25	2010-02-25 00:00:00	2010-02-25	2010-02-25 00:00:00	2010-02-25	581452		0	0	0		0	0	0	168919	0	121	40213260		
38825	3211	1127433	1992-02-07	1992-02-07 00:00:00	1992-03-06	1992-03-06 00:00:00	1992-03-06	38000177		0	0	28		0	0	0	213362	0	313782	1127433		
94770	2079	40213227	2007-07-13	2007-07-13 00:00:00	2007-07-13	2007-07-13 00:00:00	2007-07-13	581452		0	0	0		0	0	0	138485	0	113	40213227		
202782	4451	40213227	2012-07-15	2012-07-15 00:00:00	2012-07-15	2012-07-15 00:00:00	2012-07-15	581452		0	0	0		0	0	0	296115	0	113	40213227		
33360	728	40213296	1997-04-12	1997-04-12 00:00:00	1997-04-12	1997-04-12 00:00:00	1997-04-12	581452		0	0	0		0	0	0	48271	0	52	40213296		
46680	3866	1127433	2003-04-28	2003-04-28 00:00:00	2003-05-05	2003-05-05 00:00:00	2003-05-05	38000177		0	0	7		0	0	0	256762	0	313782	1127433		
43180	3577	1713671	1973-08-16	1973-08-16 00:00:00	1973-08-30	1973-08-30 00:00:00	1973-08-30	38000177		0	0	14		0	0	0	237840	0	562251	1713671		
5980	500	1127433	1974-06-23	1974-06-23 00:00:00	1974-07-07	1974-07-07 00:00:00	1974-07-07	38000177		0	0	14		0	0	0	33548	0	313782	1127433		
6007	502	1118084	1979-08-26	1979-08-26 00:00:00	1979-08-26	1979-08-26 00:00:00	\N	38000177		0	0	0		0	0	0	33582	0	00025152531	44923712		
21202	1746	19006318	1958-07-15	1958-07-15 00:00:00	1958-07-29	1958-07-29 00:00:00	1958-07-29	38000177		0	0	14		0	0	0	116728	0	105078	19006318		
87301	1915	40213227	2005-12-13	2005-12-13 00:00:00	2005-12-13	2005-12-13 00:00:00	2005-12-13	581452		0	0	0		0	0	0	127385	0	113	40213227		
177040	3891	40213160	1987-11-04	1987-11-04 00:00:00	1987-11-04	1987-11-04 00:00:00	1987-11-04	581452		0	0	0		0	0	0	258662	0	10	40213160		
54410	4523	1115171	2015-11-20	2015-11-20 00:00:00	2015-12-04	2015-12-04 00:00:00	2015-12-04	38000177		0	0	14		0	0	0	301157	0	849574	1115171		
151396	3330	40213296	2013-10-13	2013-10-13 00:00:00	2013-10-13	2013-10-13 00:00:00	2013-10-13	581452		0	0	0		0	0	0	220973	0	52	40213296		
7221	606	19128022	1995-01-08	1995-01-08 00:00:00	1996-01-03	1996-01-03 00:00:00	1996-01-03	38000177		0	0	360		0	0	0	40247	0	749785	19128022		
8871	741	1310034	2000-05-26	2000-05-26 00:00:00	2000-05-26	2000-05-26 00:00:00	2000-05-26	38000177		0	0	0		0	0	0	49043	0	834357	1310034		
41512	3439	19059056	1962-04-02	1962-04-02 00:00:00	1962-04-23	1962-04-23 00:00:00	1962-04-23	38000177		0	0	21		0	0	0	228138	0	243670	19059056		
61740	5138	1713671	1998-06-21	1998-06-21 00:00:00	1998-07-05	1998-07-05 00:00:00	1998-07-05	38000177		0	0	14		0	0	0	341477	0	562251	1713671		
52980	4403	1115171	1999-05-01	1999-05-01 00:00:00	1999-05-29	1999-05-29 00:00:00	1999-05-29	38000177		0	0	28		0	0	0	292713	0	849574	1115171		
5905	492	1127078	1950-05-17	1950-05-17 00:00:00	1950-05-31	1950-05-31 00:00:00	1950-05-31	38000177		0	0	14		0	0	0	32983	0	282464	1127078		
9331	775	1127433	2016-05-24	2016-05-24 00:00:00	2016-06-30	2016-06-30 00:00:00	2016-06-30	38000177		0	0	37		0	0	0	51435	0	313782	1127433		
52205	4342	1118084	1993-02-16	1993-02-16 00:00:00	1993-02-16	1993-02-16 00:00:00	\N	38000177		0	0	0		0	0	0	287884	0	00025152531	44923712		
47561	3942	46233988	1978-09-17	1978-09-17 00:00:00	1978-10-01	1978-10-01 00:00:00	1978-10-01	38000177		0	0	14		0	0	0	262100	0	1652673	46233988		
36354	2997	1118084	2016-11-09	2016-11-09 00:00:00	2016-11-09	2016-11-09 00:00:00	\N	38000177		0	0	0		0	0	0	199972	0	00025152531	44923712		
21347	1755	1127433	2008-07-26	2008-07-26 00:00:00	2008-08-09	2008-08-09 00:00:00	2008-08-09	38000177		0	0	14		0	0	0	117379	0	313782	1127433		
46893	3884	40236446	1984-03-24	1984-03-24 00:00:00	1990-04-14	1990-04-14 00:00:00	1990-04-14	38000177		0	0	2212		0	0	0	258104	0	1091392	40236446		
32119	2662	40165015	2002-07-12	2002-07-12 00:00:00	2002-07-12	2002-07-12 00:00:00	\N	38000177		0	0	0		0	0	0	176391	0	861467	40165015		
92341	2027	40213160	1965-11-05	1965-11-05 00:00:00	1965-11-05	1965-11-05 00:00:00	1965-11-05	581452		0	0	0		0	0	0	134923	0	10	40213160		
52500	4366	1713671	1983-09-24	1983-09-24 00:00:00	1983-10-08	1983-10-08 00:00:00	1983-10-08	38000177		0	0	14		0	0	0	289639	0	562251	1713671		
32032	2654	1127433	1955-01-06	1955-01-06 00:00:00	1955-01-20	1955-01-20 00:00:00	1955-01-20	38000177		0	0	14		0	0	0	175710	0	313782	1127433		
60156	5000	19059056	1940-10-19	1940-10-19 00:00:00	1940-11-02	1940-11-02 00:00:00	1940-11-02	38000177		0	0	14		0	0	0	332519	0	243670	19059056		
61938	5151	1127433	2000-11-05	2000-11-05 00:00:00	2000-11-26	2000-11-26 00:00:00	2000-11-26	38000177		0	0	21		0	0	0	342591	0	313782	1127433		
10282	862	40165015	1986-06-06	1986-06-06 00:00:00	1986-06-06	1986-06-06 00:00:00	\N	38000177		0	0	0		0	0	0	57052	0	861467	40165015		
60382	5023	1127078	1972-10-05	1972-10-05 00:00:00	1972-10-19	1972-10-19 00:00:00	1972-10-19	38000177		0	0	14		0	0	0	333739	0	282464	1127078		
18087	392	40213160	1980-03-07	1980-03-07 00:00:00	1980-03-07	1980-03-07 00:00:00	1980-03-07	581452		0	0	0		0	0	0	25756	0	10	40213160		
57189	4748	1127433	1997-07-19	1997-07-19 00:00:00	1997-08-25	1997-08-25 00:00:00	1997-08-25	38000177		0	0	37		0	0	0	316222	0	313782	1127433		
43584	950	40213160	1975-05-04	1975-05-04 00:00:00	1975-05-04	1975-05-04 00:00:00	1975-05-04	581452		0	0	0		0	0	0	63133	0	10	40213160		
21830	474	40213296	2011-12-25	2011-12-25 00:00:00	2011-12-25	2011-12-25 00:00:00	2011-12-25	581452		0	0	0		0	0	0	31625	0	52	40213296		
36573	3017	920334	2002-09-16	2002-09-16 00:00:00	2002-09-23	2002-09-23 00:00:00	2002-09-23	38000177		0	0	7		0	0	0	201255	0	311995	920334		
5489	458	1127078	1975-07-11	1975-07-11 00:00:00	1975-07-25	1975-07-25 00:00:00	1975-07-25	38000177		0	0	14		0	0	0	30652	0	282464	1127078		
136529	2997	40213160	1982-01-10	1982-01-10 00:00:00	1982-01-10	1982-01-10 00:00:00	1982-01-10	581452		0	0	0		0	0	0	199929	0	10	40213160		
39446	3258	19128022	1997-05-20	1997-05-20 00:00:00	1998-05-15	1998-05-15 00:00:00	1998-05-15	38000177		0	0	360		0	0	0	216617	0	749785	19128022		
26076	2147	40243436	2005-03-25	2005-03-25 00:00:00	2005-03-25	2005-03-25 00:00:00	2005-03-25	38000177		0	0	0		0	0	0	142966	0	1190795	40243436		
26128	2150	40162522	2003-10-19	2003-10-19 00:00:00	2003-10-19	2003-10-19 00:00:00	\N	38000177		0	0	0		0	0	0	143152	0	857005	40162522		
22350	1837	1713671	2001-11-25	2001-11-25 00:00:00	2001-12-16	2001-12-16 00:00:00	2001-12-16	38000177		0	0	21		0	0	0	122716	0	562251	1713671		
23383	1926	19059056	1984-06-26	1984-06-26 00:00:00	1984-08-25	1984-08-25 00:00:00	1984-08-25	38000177		0	0	60		0	0	0	128199	0	243670	19059056		
140856	3092	40213160	1956-04-04	1956-04-04 00:00:00	1956-04-04	1956-04-04 00:00:00	1956-04-04	581452		0	0	0		0	0	0	205873	0	10	40213160		
32969	2732	19074841	1981-12-02	1981-12-02 00:00:00	1981-12-16	1981-12-16 00:00:00	1981-12-16	38000177		0	0	14		0	0	0	180881	0	309043	19074841		
34009	2812	1127433	1999-07-20	1999-07-20 00:00:00	1999-08-03	1999-08-03 00:00:00	1999-08-03	38000177		0	0	14		0	0	0	186312	0	313782	1127433		
212226	4653	40213160	1959-11-01	1959-11-01 00:00:00	1959-11-01	1959-11-01 00:00:00	1959-11-01	581452		0	0	0		0	0	0	310144	0	10	40213160		
45504	992	40213160	1956-01-29	1956-01-29 00:00:00	1956-01-29	1956-01-29 00:00:00	1956-01-29	581452		0	0	0		0	0	0	65812	0	10	40213160		
67616	1478	40213306	1985-04-02	1985-04-02 00:00:00	1985-04-02	1985-04-02 00:00:00	1985-04-02	581452		0	0	0		0	0	0	98607	0	43	40213306		
47439	3932	19019979	1975-06-17	1975-06-17 00:00:00	1975-09-15	1975-09-15 00:00:00	1975-09-15	38000177		0	0	90		0	0	0	261411	0	198405	19019979		
8633	720	40236824	1998-09-17	1998-09-17 00:00:00	1998-09-24	1998-09-24 00:00:00	1998-09-24	38000177		0	0	7		0	0	0	47667	0	1094107	40236824		
55186	4580	1713671	1986-07-20	1986-07-20 00:00:00	1986-08-10	1986-08-10 00:00:00	1986-08-10	38000177		0	0	21		0	0	0	305120	0	562251	1713671		
49469	1083	40213260	2017-05-25	2017-05-25 00:00:00	2017-05-25	2017-05-25 00:00:00	2017-05-25	581452		0	0	0		0	0	0	71153	0	121	40213260		
4256	352	1127433	1991-09-11	1991-09-11 00:00:00	1991-09-18	1991-09-18 00:00:00	1991-09-18	38000177		0	0	7		0	0	0	23437	0	313782	1127433		
17063	1412	1127433	1979-08-23	1979-08-23 00:00:00	1979-08-30	1979-08-30 00:00:00	1979-08-30	38000177		0	0	7		0	0	0	94053	0	313782	1127433		
33481	2771	19078924	1974-09-02	1974-09-02 00:00:00	1974-09-02	1974-09-02 00:00:00	1974-09-02	38000177		0	0	0		0	0	0	183474	0	311700	19078924		
11307	940	40231925	1956-05-30	1956-05-30 00:00:00	1956-05-30	1956-05-30 00:00:00	\N	38000177		0	0	0		0	0	0	62560	0	1049221	40231925		
11032	919	19059056	1979-05-19	1979-05-19 00:00:00	1979-06-23	1979-06-23 00:00:00	1979-06-23	38000177		0	0	35		0	0	0	61221	0	243670	19059056		
50478	4194	19133905	2010-03-06	2010-03-06 00:00:00	2010-03-17	2010-03-17 00:00:00	2010-03-17	38000177		0	0	11		0	0	0	278380	0	834102	19133905		
29427	2436	19078461	2000-05-18	2000-05-18 00:00:00	2000-06-08	2000-06-08 00:00:00	2000-06-08	38000177		0	0	21		0	0	0	161578	0	310965	19078461		
151769	3339	40213160	1964-09-22	1964-09-22 00:00:00	1964-09-22	1964-09-22 00:00:00	1964-09-22	581452		0	0	0		0	0	0	221520	0	10	40213160		
116127	2551	40213160	1959-04-30	1959-04-30 00:00:00	1959-04-30	1959-04-30 00:00:00	1959-04-30	581452		0	0	0		0	0	0	168901	0	10	40213160		
38826	3211	19059056	1966-04-19	1966-04-19 00:00:00	1966-07-18	1966-07-18 00:00:00	1966-07-18	38000177		0	0	90		0	0	0	213359	0	243670	19059056		
120295	2644	40213160	1980-10-20	1980-10-20 00:00:00	1980-10-20	1980-10-20 00:00:00	1980-10-20	581452		0	0	0		0	0	0	174989	0	10	40213160		
202784	4451	40213227	2002-05-19	2002-05-19 00:00:00	2002-05-19	2002-05-19 00:00:00	2002-05-19	581452		0	0	0		0	0	0	296125	0	113	40213227		
33364	728	40213160	1955-10-01	1955-10-01 00:00:00	1955-10-01	1955-10-01 00:00:00	1955-10-01	581452		0	0	0		0	0	0	48361	0	10	40213160		
46681	3866	1127078	1960-10-11	1960-10-11 00:00:00	1960-11-08	1960-11-08 00:00:00	1960-11-08	38000177		0	0	28		0	0	0	256759	0	282464	1127078		
43181	3577	1713671	1971-07-29	1971-07-29 00:00:00	1971-08-19	1971-08-19 00:00:00	1971-08-19	38000177		0	0	21		0	0	0	237790	0	562251	1713671		
5981	500	1115171	2013-03-19	2013-03-19 00:00:00	2013-05-18	2013-05-18 00:00:00	2013-05-18	38000177		0	0	60		0	0	0	33550	0	849574	1115171		
6008	502	40243436	2016-03-05	2016-03-05 00:00:00	2016-03-05	2016-03-05 00:00:00	2016-03-05	38000177		0	0	0		0	0	0	33579	0	1190795	40243436		
21203	1746	1127078	1958-07-15	1958-07-15 00:00:00	1958-07-29	1958-07-29 00:00:00	1958-07-29	38000177		0	0	14		0	0	0	116728	0	282464	1127078		
31604	689	40213314	1982-05-30	1982-05-30 00:00:00	1982-05-30	1982-05-30 00:00:00	1982-05-30	581452		0	0	0		0	0	0	45680	0	49	40213314		
177041	3891	40213251	1987-11-04	1987-11-04 00:00:00	1987-11-04	1987-11-04 00:00:00	1987-11-04	581452		0	0	0		0	0	0	258662	0	21	40213251		
54411	4523	1115171	2013-12-09	2013-12-09 00:00:00	2013-12-30	2013-12-30 00:00:00	2013-12-30	38000177		0	0	21		0	0	0	301156	0	849574	1115171		
151401	3330	40213227	2004-12-19	2004-12-19 00:00:00	2004-12-19	2004-12-19 00:00:00	2004-12-19	581452		0	0	0		0	0	0	220970	0	113	40213227		
7222	606	19073188	2013-12-24	2013-12-24 00:00:00	2014-01-07	2014-01-07 00:00:00	2014-01-07	38000177		0	0	14		0	0	0	40240	0	308192	19073188		
8872	741	1127433	2001-07-22	2001-07-22 00:00:00	2001-08-19	2001-08-19 00:00:00	2001-08-19	38000177		0	0	28		0	0	0	49044	0	313782	1127433		
41513	3439	19059056	1967-01-02	1967-01-02 00:00:00	1967-04-02	1967-04-02 00:00:00	1967-04-02	38000177		0	0	90		0	0	0	228168	0	243670	19059056		
61741	5138	40165015	2011-02-28	2011-02-28 00:00:00	2011-02-28	2011-02-28 00:00:00	\N	38000177		0	0	0		0	0	0	341455	0	861467	40165015		
52981	4403	19059056	1946-11-29	1946-11-29 00:00:00	1947-01-28	1947-01-28 00:00:00	1947-01-28	38000177		0	0	60		0	0	0	292705	0	243670	19059056		
5906	492	19006318	1950-12-17	1950-12-17 00:00:00	1950-12-31	1950-12-31 00:00:00	1950-12-31	38000177		0	0	14		0	0	0	32987	0	105078	19006318		
9332	775	19059056	1948-03-28	1948-03-28 00:00:00	1948-04-25	1948-04-25 00:00:00	1948-04-25	38000177		0	0	28		0	0	0	51448	0	243670	19059056		
52207	4343	1115171	2009-10-23	2009-10-23 00:00:00	2009-11-06	2009-11-06 00:00:00	2009-11-06	38000177		0	0	14		0	0	0	288082	0	849574	1115171		
47562	3942	1118084	2019-05-30	2019-05-30 00:00:00	2019-05-30	2019-05-30 00:00:00	\N	38000177		0	0	0		0	0	0	262099	0	00025152531	44923712		
46820	3879	19059056	1946-08-21	1946-08-21 00:00:00	1946-09-25	1946-09-25 00:00:00	1946-09-25	38000177		0	0	35		0	0	0	257655	0	243670	19059056		
21348	1755	1713671	1975-04-19	1975-04-19 00:00:00	1975-05-03	1975-05-03 00:00:00	1975-05-03	38000177		0	0	14		0	0	0	117384	0	562251	1713671		
46894	3884	1127433	1975-10-10	1975-10-10 00:00:00	1975-10-24	1975-10-24 00:00:00	1975-10-24	38000177		0	0	14		0	0	0	258103	0	313782	1127433		
32120	2662	1713671	1993-07-05	1993-07-05 00:00:00	1993-07-12	1993-07-12 00:00:00	1993-07-12	38000177		0	0	7		0	0	0	176393	0	562251	1713671		
92353	2027	40213306	1983-04-15	1983-04-15 00:00:00	1983-04-15	1983-04-15 00:00:00	1983-04-15	581452		0	0	0		0	0	0	134915	0	43	40213306		
52501	4366	1713671	2018-10-06	2018-10-06 00:00:00	2018-10-13	2018-10-13 00:00:00	2018-10-13	38000177		0	0	7		0	0	0	289731	0	562251	1713671		
32033	2654	19078461	2010-03-09	2010-03-09 00:00:00	2010-06-07	2010-06-07 00:00:00	2010-06-07	38000177		0	0	90		0	0	0	175727	0	310965	19078461		
60157	5000	1127433	1983-01-28	1983-01-28 00:00:00	1983-02-11	1983-02-11 00:00:00	1983-02-11	38000177		0	0	14		0	0	0	332545	0	313782	1127433		
61939	5151	1127433	2007-03-21	2007-03-21 00:00:00	2007-04-04	2007-04-04 00:00:00	2007-04-04	38000177		0	0	14		0	0	0	342580	0	313782	1127433		
10283	862	19133873	1980-10-14	1980-10-14 00:00:00	1980-10-23	1980-10-23 00:00:00	1980-10-23	38000177		0	0	9		0	0	0	57086	0	834061	19133873		
60383	5023	40165015	1994-04-20	1994-04-20 00:00:00	1994-04-20	1994-04-20 00:00:00	\N	38000177		0	0	0		0	0	0	333798	0	861467	40165015		
18088	392	40213314	1978-06-09	1978-06-09 00:00:00	1978-06-09	1978-06-09 00:00:00	1978-06-09	581452		0	0	0		0	0	0	25724	0	49	40213314		
57190	4748	19059056	1965-05-19	1965-05-19 00:00:00	1965-06-23	1965-06-23 00:00:00	1965-06-23	38000177		0	0	35		0	0	0	316218	0	243670	19059056		
35373	2915	1127433	2007-07-07	2007-07-07 00:00:00	2007-07-14	2007-07-14 00:00:00	2007-07-14	38000177		0	0	7		0	0	0	194275	0	313782	1127433		
21832	474	40213227	2011-12-25	2011-12-25 00:00:00	2011-12-25	2011-12-25 00:00:00	2011-12-25	581452		0	0	0		0	0	0	31625	0	113	40213227		
36574	3017	40229134	1966-03-03	1966-03-03 00:00:00	1966-03-10	1966-03-10 00:00:00	1966-03-10	38000177		0	0	7		0	0	0	201209	0	1043400	40229134		
5490	458	19078461	2010-06-25	2010-06-25 00:00:00	2010-07-25	2010-07-25 00:00:00	2010-07-25	38000177		0	0	30		0	0	0	30615	0	310965	19078461		
136530	2997	40213314	1982-01-10	1982-01-10 00:00:00	1982-01-10	1982-01-10 00:00:00	1982-01-10	581452		0	0	0		0	0	0	199929	0	49	40213314		
39447	3258	1127433	1997-10-26	1997-10-26 00:00:00	1997-11-23	1997-11-23 00:00:00	1997-11-23	38000177		0	0	28		0	0	0	216552	0	313782	1127433		
26077	2147	46275916	2005-03-25	2005-03-25 00:00:00	2005-03-25	2005-03-25 00:00:00	2005-03-25	38000177		0	0	0		0	0	0	142966	0	1660014	46275916		
26129	2150	1127433	2013-03-28	2013-03-28 00:00:00	2013-04-04	2013-04-04 00:00:00	2013-04-04	38000177		0	0	7		0	0	0	143178	0	313782	1127433		
22351	1837	1118084	2000-07-22	2000-07-22 00:00:00	2000-07-22	2000-07-22 00:00:00	\N	38000177		0	0	0		0	0	0	122663	0	00025152531	44923712		
23384	1926	19075001	1988-09-20	1988-09-20 00:00:00	1988-10-04	1988-10-04 00:00:00	1988-10-04	38000177		0	0	14		0	0	0	128257	0	309097	19075001		
140860	3092	40213260	2007-08-08	2007-08-08 00:00:00	2007-08-08	2007-08-08 00:00:00	2007-08-08	581452		0	0	0		0	0	0	205891	0	121	40213260		
32970	2732	19112599	1973-08-27	1973-08-27 00:00:00	1973-08-27	1973-08-27 00:00:00	\N	38000177		0	0	0		0	0	0	180910	0	477045	19112599		
34010	2812	19059056	1940-04-26	1940-04-26 00:00:00	1940-05-10	1940-05-10 00:00:00	1940-05-10	38000177		0	0	14		0	0	0	186314	0	243670	19059056		
212228	4653	40213296	2001-03-04	2001-03-04 00:00:00	2001-03-04	2001-03-04 00:00:00	2001-03-04	581452		0	0	0		0	0	0	310123	0	52	40213296		
45515	992	40213227	2005-08-21	2005-08-21 00:00:00	2005-08-21	2005-08-21 00:00:00	2005-08-21	581452		0	0	0		0	0	0	65741	0	113	40213227		
67622	1478	40213296	2001-03-27	2001-03-27 00:00:00	2001-03-27	2001-03-27 00:00:00	2001-03-27	581452		0	0	0		0	0	0	98666	0	52	40213296		
47440	3932	19129655	1976-09-09	1976-09-09 00:00:00	1976-09-23	1976-09-23 00:00:00	1976-09-23	38000177		0	0	14		0	0	0	261366	0	789980	19129655		
8634	720	19133905	2001-09-13	2001-09-13 00:00:00	2001-09-23	2001-09-23 00:00:00	2001-09-23	38000177		0	0	10		0	0	0	47618	0	834102	19133905		
29231	2419	1713671	1977-10-29	1977-10-29 00:00:00	1977-11-19	1977-11-19 00:00:00	1977-11-19	38000177		0	0	21		0	0	0	160482	0	562251	1713671		
49471	1083	40213227	2017-05-25	2017-05-25 00:00:00	2017-05-25	2017-05-25 00:00:00	2017-05-25	581452		0	0	0		0	0	0	71153	0	113	40213227		
4257	352	1127078	1987-06-26	1987-06-26 00:00:00	1987-07-24	1987-07-24 00:00:00	1987-07-24	38000177		0	0	28		0	0	0	23433	0	282464	1127078		
17064	1412	40236824	2007-06-09	2007-06-09 00:00:00	2007-06-16	2007-06-16 00:00:00	2007-06-16	38000177		0	0	7		0	0	0	93998	0	1094107	40236824		
33482	2771	46275444	1974-09-02	1974-09-02 00:00:00	1974-09-02	1974-09-02 00:00:00	1974-09-02	38000177		0	0	0		0	0	0	183474	0	1659149	46275444		
11308	940	1545959	2001-11-29	2001-11-29 00:00:00	2001-11-29	2001-11-29 00:00:00	2001-11-29	38000177		0	0	0		0	0	0	62565	0	259255	1545959		
11033	919	19128022	1992-06-19	1992-06-19 00:00:00	1993-06-14	1993-06-14 00:00:00	1993-06-14	38000177		0	0	360		0	0	0	61233	0	749785	19128022		
50479	4194	1127433	2012-06-18	2012-06-18 00:00:00	2012-07-02	2012-07-02 00:00:00	2012-07-02	38000177		0	0	14		0	0	0	278372	0	313782	1127433		
29428	2436	19059056	1915-12-26	1915-12-26 00:00:00	1916-01-30	1916-01-30 00:00:00	1916-01-30	38000177		0	0	35		0	0	0	161446	0	243670	19059056		
151772	3339	40213160	1960-03-22	1960-03-22 00:00:00	1960-03-22	1960-03-22 00:00:00	1960-03-22	581452		0	0	0		0	0	0	221535	0	10	40213160		
116133	2551	40213260	2009-02-19	2009-02-19 00:00:00	2009-02-19	2009-02-19 00:00:00	2009-02-19	581452		0	0	0		0	0	0	168891	0	121	40213260		
38827	3211	19128065	1977-10-14	1977-10-14 00:00:00	1978-10-09	1978-10-09 00:00:00	1978-10-09	38000177		0	0	360		0	0	0	213369	0	749882	19128065		
120298	2644	40213314	1980-05-19	1980-05-19 00:00:00	1980-05-19	1980-05-19 00:00:00	1980-05-19	581452		0	0	0		0	0	0	174988	0	49	40213314		
202785	4451	40213160	1956-04-22	1956-04-22 00:00:00	1956-04-22	1956-04-22 00:00:00	1956-04-22	581452		0	0	0		0	0	0	296119	0	10	40213160		
33386	728	40213227	2016-03-26	2016-03-26 00:00:00	2016-03-26	2016-03-26 00:00:00	2016-03-26	581452		0	0	0		0	0	0	48353	0	113	40213227		
46700	3869	19059056	1950-09-28	1950-09-28 00:00:00	1950-10-12	1950-10-12 00:00:00	1950-10-12	38000177		0	0	14		0	0	0	256842	0	243670	19059056		
43182	3577	19128065	1975-02-24	1975-02-24 00:00:00	1976-02-19	1976-02-19 00:00:00	1976-02-19	38000177		0	0	360		0	0	0	237774	0	749882	19128065		
5982	500	40162522	2013-03-19	2013-03-19 00:00:00	2013-03-19	2013-03-19 00:00:00	\N	38000177		0	0	0		0	0	0	33550	0	857005	40162522		
6009	502	1310034	2016-03-05	2016-03-05 00:00:00	2016-03-05	2016-03-05 00:00:00	2016-03-05	38000177		0	0	0		0	0	0	33579	0	834357	1310034		
21204	1746	19133905	1972-01-04	1972-01-04 00:00:00	1972-01-11	1972-01-11 00:00:00	1972-01-11	38000177		0	0	7		0	0	0	116722	0	834102	19133905		
31605	689	40213160	1982-05-30	1982-05-30 00:00:00	1982-05-30	1982-05-30 00:00:00	1982-05-30	581452		0	0	0		0	0	0	45680	0	10	40213160		
177042	3891	40213314	1983-05-04	1983-05-04 00:00:00	1983-05-04	1983-05-04 00:00:00	1983-05-04	581452		0	0	0		0	0	0	258660	0	49	40213314		
54412	4523	43012754	1993-12-31	1993-12-31 00:00:00	1994-12-26	1994-12-26 00:00:00	1994-12-26	38000177		0	0	360		0	0	0	301177	0	1366343	43012754		
62895	1376	40213160	1982-10-22	1982-10-22 00:00:00	1982-10-22	1982-10-22 00:00:00	1982-10-22	581452		0	0	0		0	0	0	91226	0	10	40213160		
7223	606	1127433	2013-12-24	2013-12-24 00:00:00	2014-01-07	2014-01-07 00:00:00	2014-01-07	38000177		0	0	14		0	0	0	40240	0	313782	1127433		
8873	741	46233988	1977-04-17	1977-04-17 00:00:00	1977-05-01	1977-05-01 00:00:00	1977-05-01	38000177		0	0	14		0	0	0	49037	0	1652673	46233988		
41514	3439	40231925	1967-01-02	1967-01-02 00:00:00	1967-01-02	1967-01-02 00:00:00	\N	38000177		0	0	0		0	0	0	228168	0	1049221	40231925		
61742	5138	1115171	2011-02-28	2011-02-28 00:00:00	2011-04-29	2011-04-29 00:00:00	2011-04-29	38000177		0	0	60		0	0	0	341455	0	849574	1115171		
52982	4403	1127433	1964-06-02	1964-06-02 00:00:00	1964-06-16	1964-06-16 00:00:00	1964-06-16	38000177		0	0	14		0	0	0	292708	0	313782	1127433		
5907	492	19059056	1950-12-17	1950-12-17 00:00:00	1950-12-31	1950-12-31 00:00:00	1950-12-31	38000177		0	0	14		0	0	0	32987	0	243670	19059056		
9333	776	1713671	2002-01-22	2002-01-22 00:00:00	2002-02-12	2002-02-12 00:00:00	2002-02-12	38000177		0	0	21		0	0	0	51562	0	562251	1713671		
52208	4343	1713671	1959-08-01	1959-08-01 00:00:00	1959-08-22	1959-08-22 00:00:00	1959-08-22	38000177		0	0	21		0	0	0	288051	0	562251	1713671		
47563	3942	19128065	1992-04-16	1992-04-16 00:00:00	1993-04-11	1993-04-11 00:00:00	1993-04-11	38000177		0	0	360		0	0	0	262104	0	749882	19128065		
46821	3879	19059056	1941-11-03	1941-11-03 00:00:00	1941-12-01	1941-12-01 00:00:00	1941-12-01	38000177		0	0	28		0	0	0	257653	0	243670	19059056		
21350	1755	19128065	1985-04-19	1985-04-19 00:00:00	1985-09-11	1985-09-11 00:00:00	1985-09-11	38000177		0	0	145		0	0	0	117367	0	749882	19128065		
46895	3884	1118084	2011-04-07	2011-04-07 00:00:00	2011-04-07	2011-04-07 00:00:00	\N	38000177		0	0	0		0	0	0	258070	0	00025152531	44923712		
32121	2662	1127433	1995-10-28	1995-10-28 00:00:00	1995-11-10	1995-11-10 00:00:00	1995-11-10	38000177		0	0	13		0	0	0	176394	0	313782	1127433		
92357	2027	40213160	1961-11-24	1961-11-24 00:00:00	1961-11-24	1961-11-24 00:00:00	1961-11-24	581452		0	0	0		0	0	0	134882	0	10	40213160		
52502	4366	1127433	2000-09-27	2000-09-27 00:00:00	2000-10-11	2000-10-11 00:00:00	2000-10-11	38000177		0	0	14		0	0	0	289597	0	313782	1127433		
32034	2654	1118084	1983-04-18	1983-04-18 00:00:00	1983-04-18	1983-04-18 00:00:00	\N	38000177		0	0	0		0	0	0	175747	0	00025152531	44923712		
60158	5000	19059056	1941-10-25	1941-10-25 00:00:00	1941-11-08	1941-11-08 00:00:00	1941-11-08	38000177		0	0	14		0	0	0	332529	0	243670	19059056		
61940	5151	1127433	2005-10-31	2005-10-31 00:00:00	2005-11-14	2005-11-14 00:00:00	2005-11-14	38000177		0	0	14		0	0	0	342592	0	313782	1127433		
10284	862	19133873	1981-02-24	1981-02-24 00:00:00	1981-03-05	1981-03-05 00:00:00	1981-03-05	38000177		0	0	9		0	0	0	57101	0	834061	19133873		
60384	5023	1118084	2015-06-12	2015-06-12 00:00:00	2015-06-12	2015-06-12 00:00:00	\N	38000177		0	0	0		0	0	0	333763	0	00025152531	44923712		
18090	392	40213314	1977-12-09	1977-12-09 00:00:00	1977-12-09	1977-12-09 00:00:00	1977-12-09	581452		0	0	0		0	0	0	25755	0	49	40213314		
57191	4748	19059056	1946-06-28	1946-06-28 00:00:00	1946-07-12	1946-07-12 00:00:00	1946-07-12	38000177		0	0	14		0	0	0	316208	0	243670	19059056		
35374	2915	19008572	1967-05-11	1967-05-11 00:00:00	1967-05-11	1967-05-11 00:00:00	\N	38000177		0	0	0		0	0	0	194341	0	106258	19008572		
33116	723	40213160	1965-10-21	1965-10-21 00:00:00	1965-10-21	1965-10-21 00:00:00	1965-10-21	581452		0	0	0		0	0	0	47813	0	10	40213160		
36575	3017	1124300	1991-04-30	1991-04-30 00:00:00	1991-04-30	1991-04-30 00:00:00	\N	38000177		0	0	0		0	0	0	201270	0	00781178901	45011828		
5491	458	920300	2009-09-09	2009-09-09 00:00:00	2009-09-16	2009-09-16 00:00:00	2009-09-16	38000177		0	0	7		0	0	0	30630	0	311989	920300		
18925	1563	1127433	1976-04-06	1976-04-06 00:00:00	1976-04-13	1976-04-13 00:00:00	1976-04-13	38000177		0	0	7		0	0	0	104676	0	313782	1127433		
39448	3259	1127433	1982-03-30	1982-03-30 00:00:00	1982-04-20	1982-04-20 00:00:00	1982-04-20	38000177		0	0	21		0	0	0	216673	0	313782	1127433		
26078	2147	1310034	2005-03-25	2005-03-25 00:00:00	2005-03-25	2005-03-25 00:00:00	2005-03-25	38000177		0	0	0		0	0	0	142966	0	834357	1310034		
26130	2150	1127433	1966-07-14	1966-07-14 00:00:00	1966-07-28	1966-07-28 00:00:00	1966-07-28	38000177		0	0	14		0	0	0	143147	0	313782	1127433		
22352	1837	19128065	1978-04-19	1978-04-19 00:00:00	1979-04-14	1979-04-14 00:00:00	1979-04-14	38000177		0	0	360		0	0	0	122672	0	749882	19128065		
23385	1926	19078461	1988-09-20	1988-09-20 00:00:00	1988-10-04	1988-10-04 00:00:00	1988-10-04	38000177		0	0	14		0	0	0	128257	0	310965	19078461		
140867	3092	40213227	2006-08-02	2006-08-02 00:00:00	2006-08-02	2006-08-02 00:00:00	2006-08-02	581452		0	0	0		0	0	0	205861	0	113	40213227		
44447	3680	19008572	1992-10-14	1992-10-14 00:00:00	1992-10-28	1992-10-28 00:00:00	1992-10-28	38000177		0	0	14		0	0	0	244682	0	106258	19008572		
34011	2812	1115171	2000-04-23	2000-04-23 00:00:00	2000-06-22	2000-06-22 00:00:00	2000-06-22	38000177		0	0	60		0	0	0	186319	0	849574	1115171		
212230	4653	40213227	2001-03-04	2001-03-04 00:00:00	2001-03-04	2001-03-04 00:00:00	2001-03-04	581452		0	0	0		0	0	0	310123	0	113	40213227		
57283	1253	40213260	2007-04-25	2007-04-25 00:00:00	2007-04-25	2007-04-25 00:00:00	2007-04-25	581452		0	0	0		0	0	0	82559	0	121	40213260		
63408	5267	1594382	1995-12-23	1995-12-23 00:00:00	1995-12-23	1995-12-23 00:00:00	\N	38000177		0	0	0		0	0	0	350431	0	1870230	1594382		
47441	3932	1127078	1976-09-09	1976-09-09 00:00:00	1976-09-23	1976-09-23 00:00:00	1976-09-23	38000177		0	0	14		0	0	0	261366	0	282464	1127078		
8635	720	19059056	1968-08-08	1968-08-08 00:00:00	1968-10-07	1968-10-07 00:00:00	1968-10-07	38000177		0	0	60		0	0	0	47657	0	243670	19059056		
29232	2419	1713671	1953-05-12	1953-05-12 00:00:00	1953-05-19	1953-05-19 00:00:00	1953-05-19	38000177		0	0	7		0	0	0	160628	0	562251	1713671		
49475	1083	40213160	1971-02-25	1971-02-25 00:00:00	1971-02-25	1971-02-25 00:00:00	1971-02-25	581452		0	0	0		0	0	0	71101	0	10	40213160		
4258	352	19059056	1980-11-13	1980-11-13 00:00:00	1980-11-27	1980-11-27 00:00:00	1980-11-27	38000177		0	0	14		0	0	0	23451	0	243670	19059056		
17065	1412	920300	2007-06-09	2007-06-09 00:00:00	2007-06-16	2007-06-16 00:00:00	2007-06-16	38000177		0	0	7		0	0	0	93998	0	311989	920300		
33483	2771	42707627	1974-09-02	1974-09-02 00:00:00	1974-09-02	1974-09-02 00:00:00	1974-09-02	38000177		0	0	0		0	0	0	183474	0	1234995	42707627		
11309	940	19133768	2001-11-29	2001-11-29 00:00:00	2001-11-29	2001-11-29 00:00:00	2001-11-29	38000177		0	0	0		0	0	0	62565	0	833036	19133768		
11034	919	1127433	1975-09-09	1975-09-09 00:00:00	1975-09-16	1975-09-16 00:00:00	1975-09-16	38000177		0	0	7		0	0	0	61252	0	313782	1127433		
50491	4197	19133679	2005-08-24	2005-08-24 00:00:00	2006-08-19	2006-08-19 00:00:00	2006-08-19	38000177		0	0	360		0	0	0	278499	0	831533	19133679		
29429	2436	40229134	2014-12-08	2014-12-08 00:00:00	2014-12-22	2014-12-22 00:00:00	2014-12-22	38000177		0	0	14		0	0	0	161454	0	1043400	40229134		
151773	3339	40213260	2011-08-09	2011-08-09 00:00:00	2011-08-09	2011-08-09 00:00:00	2011-08-09	581452		0	0	0		0	0	0	221487	0	121	40213260		
196080	4309	40213296	1997-09-03	1997-09-03 00:00:00	1997-09-03	1997-09-03 00:00:00	1997-09-03	581452		0	0	0		0	0	0	285881	0	52	40213296		
38828	3211	19128065	1974-10-30	1974-10-30 00:00:00	1975-10-25	1975-10-25 00:00:00	1975-10-25	38000177		0	0	360		0	0	0	213346	0	749882	19128065		
120299	2644	40213160	1980-05-19	1980-05-19 00:00:00	1980-05-19	1980-05-19 00:00:00	1980-05-19	581452		0	0	0		0	0	0	174988	0	10	40213160		
226646	4977	40213306	1982-11-12	1982-11-12 00:00:00	1982-11-12	1982-11-12 00:00:00	1982-11-12	581452		0	0	0		0	0	0	331140	0	43	40213306		
33388	728	40213160	1960-01-02	1960-01-02 00:00:00	1960-01-02	1960-01-02 00:00:00	1960-01-02	581452		0	0	0		0	0	0	48319	0	10	40213160		
46701	3869	1127433	1947-03-16	1947-03-16 00:00:00	1947-03-23	1947-03-23 00:00:00	1947-03-23	38000177		0	0	7		0	0	0	256939	0	313782	1127433		
43183	3577	19133905	2014-05-14	2014-05-14 00:00:00	2014-05-23	2014-05-23 00:00:00	2014-05-23	38000177		0	0	9		0	0	0	237802	0	834102	19133905		
5983	500	19059056	1962-03-18	1962-03-18 00:00:00	1962-04-01	1962-04-01 00:00:00	1962-04-01	38000177		0	0	14		0	0	0	33526	0	243670	19059056		
6010	502	46275916	2016-03-05	2016-03-05 00:00:00	2016-03-05	2016-03-05 00:00:00	2016-03-05	38000177		0	0	0		0	0	0	33579	0	1660014	46275916		
21205	1746	1127433	1970-11-15	1970-11-15 00:00:00	1970-11-29	1970-11-29 00:00:00	1970-11-29	38000177		0	0	14		0	0	0	116721	0	313782	1127433		
31610	689	40213160	1982-10-31	1982-10-31 00:00:00	1982-10-31	1982-10-31 00:00:00	1982-10-31	581452		0	0	0		0	0	0	45630	0	10	40213160		
177043	3891	40213160	1983-05-04	1983-05-04 00:00:00	1983-05-04	1983-05-04 00:00:00	1983-05-04	581452		0	0	0		0	0	0	258660	0	10	40213160		
54413	4523	19078461	2016-11-28	2016-11-28 00:00:00	2016-12-19	2016-12-19 00:00:00	2016-12-19	38000177		0	0	21		0	0	0	301158	0	310965	19078461		
62899	1376	40213314	1979-01-19	1979-01-19 00:00:00	1979-01-19	1979-01-19 00:00:00	1979-01-19	581452		0	0	0		0	0	0	91224	0	49	40213314		
7224	606	40165015	2013-12-24	2013-12-24 00:00:00	2013-12-24	2013-12-24 00:00:00	\N	38000177		0	0	0		0	0	0	40240	0	861467	40165015		
8874	741	19019979	1977-04-17	1977-04-17 00:00:00	1977-05-01	1977-05-01 00:00:00	1977-05-01	38000177		0	0	14		0	0	0	49037	0	198405	19019979		
41515	3439	1713671	1984-12-09	1984-12-09 00:00:00	1984-12-16	1984-12-16 00:00:00	1984-12-16	38000177		0	0	7		0	0	0	228187	0	562251	1713671		
61743	5138	19019979	1989-03-17	1989-03-17 00:00:00	1989-03-31	1989-03-31 00:00:00	1989-03-31	38000177		0	0	14		0	0	0	341492	0	198405	19019979		
52983	4403	19129655	1964-06-02	1964-06-02 00:00:00	1964-06-16	1964-06-16 00:00:00	1964-06-16	38000177		0	0	14		0	0	0	292708	0	789980	19129655		
5908	492	19078461	2014-08-07	2014-08-07 00:00:00	2014-09-06	2014-09-06 00:00:00	2014-09-06	38000177		0	0	30		0	0	0	32906	0	310965	19078461		
9335	776	19078461	2011-08-16	2011-08-16 00:00:00	2011-09-15	2011-09-15 00:00:00	2011-09-15	38000177		0	0	30		0	0	0	51573	0	310965	19078461		
52209	4343	1127078	1963-04-11	1963-04-11 00:00:00	1963-04-25	1963-04-25 00:00:00	1963-04-25	38000177		0	0	14		0	0	0	288077	0	282464	1127078		
47564	3942	19128065	1996-03-26	1996-03-26 00:00:00	1997-03-21	1997-03-21 00:00:00	1997-03-21	38000177		0	0	360		0	0	0	262078	0	749882	19128065		
46822	3879	40236824	1967-01-09	1967-01-09 00:00:00	1967-01-16	1967-01-16 00:00:00	1967-01-16	38000177		0	0	7		0	0	0	257664	0	1094107	40236824		
21351	1755	19128065	1977-05-23	1977-05-23 00:00:00	1978-05-18	1978-05-18 00:00:00	1978-05-18	38000177		0	0	360		0	0	0	117346	0	749882	19128065		
46896	3885	1115171	1995-02-11	1995-02-11 00:00:00	1995-03-04	1995-03-04 00:00:00	1995-03-04	38000177		0	0	21		0	0	0	258218	0	849574	1115171		
32122	2662	19073183	1980-05-31	1980-05-31 00:00:00	1980-06-14	1980-06-14 00:00:00	1980-06-14	38000177		0	0	14		0	0	0	176434	0	308182	19073183		
92359	2027	40213296	2001-03-23	2001-03-23 00:00:00	2001-03-23	2001-03-23 00:00:00	2001-03-23	581452		0	0	0		0	0	0	134907	0	52	40213296		
52503	4366	1127433	1985-09-24	1985-09-24 00:00:00	1985-10-01	1985-10-01 00:00:00	1985-10-01	38000177		0	0	7		0	0	0	289690	0	313782	1127433		
32035	2654	40162522	1983-04-20	1983-04-20 00:00:00	1983-04-20	1983-04-20 00:00:00	\N	38000177		0	0	0		0	0	0	175747	0	857005	40162522		
60159	5000	1127433	2000-06-01	2000-06-01 00:00:00	2000-07-01	2000-07-01 00:00:00	2000-07-01	38000177		0	0	30		0	0	0	332554	0	313782	1127433		
13921	300	40213296	2015-07-17	2015-07-17 00:00:00	2015-07-17	2015-07-17 00:00:00	2015-07-17	581452		0	0	0		0	0	0	20067	0	52	40213296		
10285	862	19133873	1972-05-23	1972-05-23 00:00:00	1972-06-02	1972-06-02 00:00:00	1972-06-02	38000177		0	0	10		0	0	0	57100	0	834061	19133873		
60385	5023	1127433	1994-04-13	1994-04-13 00:00:00	1994-05-20	1994-05-20 00:00:00	1994-05-20	38000177		0	0	37		0	0	0	333770	0	313782	1127433		
18091	392	40213160	1975-12-12	1975-12-12 00:00:00	1975-12-12	1975-12-12 00:00:00	1975-12-12	581452		0	0	0		0	0	0	25719	0	10	40213160		
57192	4748	1127433	1982-10-22	1982-10-22 00:00:00	1982-11-05	1982-11-05 00:00:00	1982-11-05	38000177		0	0	14		0	0	0	316220	0	313782	1127433		
35375	2915	1118084	1981-11-14	1981-11-14 00:00:00	1981-11-14	1981-11-14 00:00:00	\N	38000177		0	0	0		0	0	0	194363	0	00025152531	44923712		
33118	723	40213160	1961-02-16	1961-02-16 00:00:00	1961-02-16	1961-02-16 00:00:00	1961-02-16	581452		0	0	0		0	0	0	47863	0	10	40213160		
36576	3017	1127433	2003-03-28	2003-03-28 00:00:00	2003-04-11	2003-04-11 00:00:00	2003-04-11	38000177		0	0	14		0	0	0	201256	0	313782	1127433		
5492	458	40236824	2009-09-09	2009-09-09 00:00:00	2009-09-16	2009-09-16 00:00:00	2009-09-16	38000177		0	0	7		0	0	0	30630	0	1094107	40236824		
18926	1563	19133873	1958-06-17	1958-06-17 00:00:00	1958-06-28	1958-06-28 00:00:00	1958-06-28	38000177		0	0	11		0	0	0	104664	0	834061	19133873		
39449	3259	19059056	1966-12-23	1966-12-23 00:00:00	1967-01-06	1967-01-06 00:00:00	1967-01-06	38000177		0	0	14		0	0	0	216687	0	243670	19059056		
26079	2147	19059056	1955-06-14	1955-06-14 00:00:00	1955-07-19	1955-07-19 00:00:00	1955-07-19	38000177		0	0	35		0	0	0	142897	0	243670	19059056		
26131	2150	40229134	1969-08-06	1969-08-06 00:00:00	1969-08-13	1969-08-13 00:00:00	1969-08-13	38000177		0	0	7		0	0	0	143157	0	1043400	40229134		
22353	1837	1127433	1974-04-30	1974-04-30 00:00:00	1974-05-28	1974-05-28 00:00:00	1974-05-28	38000177		0	0	28		0	0	0	122693	0	313782	1127433		
23386	1926	1115171	2005-07-27	2005-07-27 00:00:00	2005-08-26	2005-08-26 00:00:00	2005-08-26	38000177		0	0	30		0	0	0	128201	0	849574	1115171		
140868	3092	40213260	2006-08-02	2006-08-02 00:00:00	2006-08-02	2006-08-02 00:00:00	2006-08-02	581452		0	0	0		0	0	0	205861	0	121	40213260		
44448	3680	19112599	1979-12-15	1979-12-15 00:00:00	1979-12-15	1979-12-15 00:00:00	\N	38000177		0	0	0		0	0	0	244725	0	477045	19112599		
34012	2812	1127433	1971-10-13	1971-10-13 00:00:00	1971-10-27	1971-10-27 00:00:00	1971-10-27	38000177		0	0	14		0	0	0	186302	0	313782	1127433		
212232	4653	40213160	1959-08-02	1959-08-02 00:00:00	1959-08-02	1959-08-02 00:00:00	1959-08-02	581452		0	0	0		0	0	0	310174	0	10	40213160		
57287	1253	40213227	2016-08-03	2016-08-03 00:00:00	2016-08-03	2016-08-03 00:00:00	2016-08-03	581452		0	0	0		0	0	0	82563	0	113	40213227		
63409	5267	40232448	1995-12-23	1995-12-23 00:00:00	1995-12-23	1995-12-23 00:00:00	\N	38000177		0	0	0		0	0	0	350431	0	1049630	40232448		
47442	3934	1127433	2015-12-03	2015-12-03 00:00:00	2015-12-31	2015-12-31 00:00:00	2015-12-31	38000177		0	0	28		0	0	0	261508	0	313782	1127433		
8646	722	1127433	1969-07-12	1969-07-12 00:00:00	1969-07-19	1969-07-19 00:00:00	1969-07-19	38000177		0	0	7		0	0	0	47800	0	313782	1127433		
29233	2419	1124300	1979-10-02	1979-10-02 00:00:00	1979-10-02	1979-10-02 00:00:00	\N	38000177		0	0	0		0	0	0	160499	0	00781178901	45011828		
49478	1083	40213227	1997-05-29	1997-05-29 00:00:00	1997-05-29	1997-05-29 00:00:00	1997-05-29	581452		0	0	0		0	0	0	71082	0	113	40213227		
4259	352	19019979	1988-08-17	1988-08-17 00:00:00	1988-09-07	1988-09-07 00:00:00	1988-09-07	38000177		0	0	21		0	0	0	23434	0	198405	19019979		
17066	1412	40229134	2018-07-31	2018-07-31 00:00:00	2018-08-14	2018-08-14 00:00:00	2018-08-14	38000177		0	0	14		0	0	0	93989	0	1043400	40229134		
33484	2771	40165015	1974-09-02	1974-09-02 00:00:00	1974-09-02	1974-09-02 00:00:00	\N	38000177		0	0	0		0	0	0	183474	0	861467	40165015		
11310	940	46275916	1993-03-04	1993-03-04 00:00:00	1993-03-04	1993-03-04 00:00:00	1993-03-04	38000177		0	0	0		0	0	0	62564	0	1660014	46275916		
11035	919	1127433	2002-01-30	2002-01-30 00:00:00	2002-02-06	2002-02-06 00:00:00	2002-02-06	38000177		0	0	7		0	0	0	61256	0	313782	1127433		
50492	4197	19073183	1988-06-14	1988-06-14 00:00:00	1988-06-28	1988-06-28 00:00:00	1988-06-28	38000177		0	0	14		0	0	0	278487	0	308182	19073183		
29430	2436	19008572	1930-03-21	1930-03-21 00:00:00	1930-03-21	1930-03-21 00:00:00	\N	38000177		0	0	0		0	0	0	161496	0	106258	19008572		
151775	3339	40213227	2011-08-09	2011-08-09 00:00:00	2011-08-09	2011-08-09 00:00:00	2011-08-09	581452		0	0	0		0	0	0	221487	0	113	40213227		
196084	4309	40213227	2015-11-25	2015-11-25 00:00:00	2015-11-25	2015-11-25 00:00:00	2015-11-25	581452		0	0	0		0	0	0	285915	0	113	40213227		
38829	3211	1713671	1963-01-30	1963-01-30 00:00:00	1963-02-13	1963-02-13 00:00:00	1963-02-13	38000177		0	0	14		0	0	0	213364	0	562251	1713671		
117025	2572	40213296	2010-02-02	2010-02-02 00:00:00	2010-02-02	2010-02-02 00:00:00	2010-02-02	581452		0	0	0		0	0	0	170371	0	52	40213296		
226654	4977	40213227	2010-12-24	2010-12-24 00:00:00	2010-12-24	2010-12-24 00:00:00	2010-12-24	581452		0	0	0		0	0	0	331176	0	113	40213227		
23449	1929	1127433	1975-09-19	1975-09-19 00:00:00	1975-10-10	1975-10-10 00:00:00	1975-10-10	38000177		0	0	21		0	0	0	128392	0	313782	1127433		
46702	3869	40243436	1926-10-09	1926-10-09 00:00:00	1926-10-09	1926-10-09 00:00:00	1926-10-09	38000177		0	0	0		0	0	0	256936	0	1190795	40243436		
43184	3577	1127433	2011-03-08	2011-03-08 00:00:00	2011-03-15	2011-03-15 00:00:00	2011-03-15	38000177		0	0	7		0	0	0	237801	0	313782	1127433		
5984	500	19129655	1962-03-18	1962-03-18 00:00:00	1962-04-01	1962-04-01 00:00:00	1962-04-01	38000177		0	0	14		0	0	0	33526	0	789980	19129655		
6011	502	40229134	2017-06-20	2017-06-20 00:00:00	2017-06-27	2017-06-27 00:00:00	2017-06-27	38000177		0	0	7		0	0	0	33613	0	1043400	40229134		
21206	1746	1118084	1988-04-23	1988-04-23 00:00:00	1988-04-23	1988-04-23 00:00:00	\N	38000177		0	0	0		0	0	0	116795	0	00025152531	44923712		
31612	689	40213227	2004-05-02	2004-05-02 00:00:00	2004-05-02	2004-05-02 00:00:00	2004-05-02	581452		0	0	0		0	0	0	45622	0	113	40213227		
177047	3891	40213306	2004-09-01	2004-09-01 00:00:00	2004-09-01	2004-09-01 00:00:00	2004-09-01	581452		0	0	0		0	0	0	258731	0	43	40213306		
54414	4523	1127433	2017-04-30	2017-04-30 00:00:00	2017-05-07	2017-05-07 00:00:00	2017-05-07	38000177		0	0	7		0	0	0	301202	0	313782	1127433		
62902	1376	40213227	2010-09-24	2010-09-24 00:00:00	2010-09-24	2010-09-24 00:00:00	2010-09-24	581452		0	0	0		0	0	0	91219	0	113	40213227		
7225	606	19128065	1996-01-03	1996-01-03 00:00:00	1996-12-28	1996-12-28 00:00:00	1996-12-28	38000177		0	0	360		0	0	0	40248	0	749882	19128065		
8875	741	1713671	1999-03-02	1999-03-02 00:00:00	1999-03-16	1999-03-16 00:00:00	1999-03-16	38000177		0	0	14		0	0	0	49068	0	562251	1713671		
41516	3439	19133905	1999-07-23	1999-07-23 00:00:00	1999-07-30	1999-07-30 00:00:00	1999-07-30	38000177		0	0	7		0	0	0	228211	0	834102	19133905		
61744	5138	1127433	2013-03-19	2013-03-19 00:00:00	2013-04-02	2013-04-02 00:00:00	2013-04-02	38000177		0	0	14		0	0	0	341456	0	313782	1127433		
52984	4403	40165015	1964-06-02	1964-06-02 00:00:00	1964-06-02	1964-06-02 00:00:00	\N	38000177		0	0	0		0	0	0	292708	0	861467	40165015		
9302	774	1127433	2017-05-15	2017-05-15 00:00:00	2017-05-29	2017-05-29 00:00:00	2017-05-29	38000177		0	0	14		0	0	0	51395	0	313782	1127433		
9336	776	1127433	2009-10-11	2009-10-11 00:00:00	2009-10-25	2009-10-25 00:00:00	2009-10-25	38000177		0	0	14		0	0	0	51572	0	313782	1127433		
52211	4343	19059056	1958-07-29	1958-07-29 00:00:00	1958-10-04	1958-10-04 00:00:00	1958-10-04	38000177		0	0	67		0	0	0	288076	0	243670	19059056		
47565	3942	1127433	2004-09-05	2004-09-05 00:00:00	2004-10-10	2004-10-10 00:00:00	2004-10-10	38000177		0	0	35		0	0	0	262088	0	313782	1127433		
46823	3879	920300	1967-01-09	1967-01-09 00:00:00	1967-01-16	1967-01-16 00:00:00	1967-01-16	38000177		0	0	7		0	0	0	257664	0	311989	920300		
21352	1755	19128065	1975-06-03	1975-06-03 00:00:00	1976-05-28	1976-05-28 00:00:00	1976-05-28	38000177		0	0	360		0	0	0	117364	0	749882	19128065		
46897	3885	19078461	2001-10-28	2001-10-28 00:00:00	2001-11-11	2001-11-11 00:00:00	2001-11-11	38000177		0	0	14		0	0	0	258219	0	310965	19078461		
32123	2662	1127078	1980-05-31	1980-05-31 00:00:00	1980-06-14	1980-06-14 00:00:00	1980-06-14	38000177		0	0	14		0	0	0	176434	0	282464	1127078		
92361	2027	40213227	1992-04-24	1992-04-24 00:00:00	1992-04-24	1992-04-24 00:00:00	1992-04-24	581452		0	0	0		0	0	0	134928	0	113	40213227		
52504	4366	1124300	2015-06-16	2015-06-16 00:00:00	2015-06-16	2015-06-16 00:00:00	\N	38000177		0	0	0		0	0	0	289608	0	00781178901	45011828		
32036	2654	1127433	1988-12-19	1988-12-19 00:00:00	1989-01-09	1989-01-09 00:00:00	1989-01-09	38000177		0	0	21		0	0	0	175723	0	313782	1127433		
60160	5000	1127433	1956-01-12	1956-01-12 00:00:00	1956-01-26	1956-01-26 00:00:00	1956-01-26	38000177		0	0	14		0	0	0	332513	0	313782	1127433		
13922	300	40213314	1977-03-11	1977-03-11 00:00:00	1977-03-11	1977-03-11 00:00:00	1977-03-11	581452		0	0	0		0	0	0	20032	0	49	40213314		
10286	862	19019979	1979-09-11	1979-09-11 00:00:00	1979-10-11	1979-10-11 00:00:00	1979-10-11	38000177		0	0	30		0	0	0	57051	0	198405	19019979		
7321	613	40229134	2015-05-15	2015-05-15 00:00:00	2015-05-29	2015-05-29 00:00:00	2015-05-29	38000177		0	0	14		0	0	0	40709	0	1043400	40229134		
205063	4501	40213227	2004-07-01	2004-07-01 00:00:00	2004-07-01	2004-07-01 00:00:00	2004-07-01	581452		0	0	0		0	0	0	299736	0	113	40213227		
57193	4748	1118084	1983-10-17	1983-10-17 00:00:00	1983-10-17	1983-10-17 00:00:00	\N	38000177		0	0	0		0	0	0	316220	0	00025152531	44923712		
35376	2915	19133873	1955-03-19	1955-03-19 00:00:00	1955-03-31	1955-03-31 00:00:00	1955-03-31	38000177		0	0	12		0	0	0	194344	0	834061	19133873		
33119	723	40213160	1961-07-20	1961-07-20 00:00:00	1961-07-20	1961-07-20 00:00:00	1961-07-20	581452		0	0	0		0	0	0	47864	0	10	40213160		
36577	3017	920300	2002-09-09	2002-09-09 00:00:00	2002-09-16	2002-09-16 00:00:00	2002-09-16	38000177		0	0	7		0	0	0	201254	0	311989	920300		
5493	458	19133873	1978-05-10	1978-05-10 00:00:00	1978-05-18	1978-05-18 00:00:00	1978-05-18	38000177		0	0	8		0	0	0	30664	0	834061	19133873		
18927	1563	40169216	1977-06-25	1977-06-25 00:00:00	1977-06-25	1977-06-25 00:00:00	\N	38000177		0	0	0		0	0	0	104703	0	895994	40169216		
39450	3259	19074841	1980-01-03	1980-01-03 00:00:00	1980-01-17	1980-01-17 00:00:00	1980-01-17	38000177		0	0	14		0	0	0	216689	0	309043	19074841		
26080	2147	1127433	1987-05-02	1987-05-02 00:00:00	1987-05-16	1987-05-16 00:00:00	1987-05-16	38000177		0	0	14		0	0	0	142903	0	313782	1127433		
26132	2150	19073188	2017-02-28	2017-02-28 00:00:00	2017-03-28	2017-03-28 00:00:00	2017-03-28	38000177		0	0	28		0	0	0	143155	0	308192	19073188		
22354	1837	1127433	1966-05-11	1966-05-11 00:00:00	1966-05-18	1966-05-18 00:00:00	1966-05-18	38000177		0	0	7		0	0	0	122723	0	313782	1127433		
23387	1926	19133873	1978-07-02	1978-07-02 00:00:00	1978-07-10	1978-07-10 00:00:00	1978-07-10	38000177		0	0	8		0	0	0	128252	0	834061	19133873		
170322	3745	40213201	1996-06-12	1996-06-12 00:00:00	1996-06-12	1996-06-12 00:00:00	1996-06-12	581452		0	0	0		0	0	0	248959	0	33	40213201		
44449	3680	1127433	2000-10-25	2000-10-25 00:00:00	2000-11-08	2000-11-08 00:00:00	2000-11-08	38000177		0	0	14		0	0	0	244773	0	313782	1127433		
34013	2812	19059056	1947-06-19	1947-06-19 00:00:00	1947-08-18	1947-08-18 00:00:00	1947-08-18	38000177		0	0	60		0	0	0	186282	0	243670	19059056		
212241	4653	40213260	2009-02-22	2009-02-22 00:00:00	2009-02-22	2009-02-22 00:00:00	2009-02-22	581452		0	0	0		0	0	0	310199	0	121	40213260		
18593	1537	19059056	1969-07-19	1969-07-19 00:00:00	1969-08-16	1969-08-16 00:00:00	1969-08-16	38000177		0	0	28		0	0	0	102886	0	243670	19059056		
63410	5267	19133873	1972-02-23	1972-02-23 00:00:00	1972-03-07	1972-03-07 00:00:00	1972-03-07	38000177		0	0	13		0	0	0	350428	0	834061	19133873		
47443	3934	19133905	1976-11-15	1976-11-15 00:00:00	1976-11-26	1976-11-26 00:00:00	1976-11-26	38000177		0	0	11		0	0	0	261490	0	834102	19133905		
8647	722	1124300	2010-04-17	2010-04-17 00:00:00	2010-04-17	2010-04-17 00:00:00	\N	38000177		0	0	0		0	0	0	47789	0	00781178901	45011828		
29234	2419	1713671	1951-01-26	1951-01-26 00:00:00	1951-02-16	1951-02-16 00:00:00	1951-02-16	38000177		0	0	21		0	0	0	160615	0	562251	1713671		
49480	1083	40213260	2016-05-19	2016-05-19 00:00:00	2016-05-19	2016-05-19 00:00:00	2016-05-19	581452		0	0	0		0	0	0	71064	0	121	40213260		
4260	352	1127078	1983-03-12	1983-03-12 00:00:00	1983-03-26	1983-03-26 00:00:00	1983-03-26	38000177		0	0	14		0	0	0	23440	0	282464	1127078		
1215	97	40236824	1966-08-09	1966-08-09 00:00:00	1966-08-16	1966-08-16 00:00:00	1966-08-16	38000177		0	0	7		0	0	0	6585	0	1094107	40236824		
33485	2771	35605482	1974-09-02	1974-09-02 00:00:00	1974-09-02	1974-09-02 00:00:00	1974-09-02	38000177		0	0	0		0	0	0	183474	0	1740467	35605482		
11311	940	1310034	1993-03-04	1993-03-04 00:00:00	1993-03-04	1993-03-04 00:00:00	1993-03-04	38000177		0	0	0		0	0	0	62564	0	834357	1310034		
11036	919	19128065	1986-07-21	1986-07-21 00:00:00	1987-07-16	1987-07-16 00:00:00	1987-07-16	38000177		0	0	360		0	0	0	61263	0	749882	19128065		
50493	4197	19019979	1988-06-14	1988-06-14 00:00:00	1988-06-28	1988-06-28 00:00:00	1988-06-28	38000177		0	0	14		0	0	0	278487	0	198405	19019979		
29431	2436	19059056	1922-07-27	1922-07-27 00:00:00	1922-08-24	1922-08-24 00:00:00	1922-08-24	38000177		0	0	28		0	0	0	161447	0	243670	19059056		
151780	3339	40213160	1960-01-19	1960-01-19 00:00:00	1960-01-19	1960-01-19 00:00:00	1960-01-19	581452		0	0	0		0	0	0	221505	0	10	40213160		
196085	4309	40213160	1959-07-15	1959-07-15 00:00:00	1959-07-15	1959-07-15 00:00:00	1959-07-15	581452		0	0	0		0	0	0	285925	0	10	40213160		
38830	3211	19059056	1970-05-12	1970-05-12 00:00:00	1970-06-02	1970-06-02 00:00:00	1970-06-02	38000177		0	0	21		0	0	0	213361	0	243670	19059056		
117033	2572	40213160	1970-03-03	1970-03-03 00:00:00	1970-03-03	1970-03-03 00:00:00	1970-03-03	581452		0	0	0		0	0	0	170356	0	10	40213160		
226655	4977	40213260	2010-12-24	2010-12-24 00:00:00	2010-12-24	2010-12-24 00:00:00	2010-12-24	581452		0	0	0		0	0	0	331176	0	121	40213260		
23474	1933	1127078	1960-05-19	1960-05-19 00:00:00	1960-08-17	1960-08-17 00:00:00	1960-08-17	38000177		0	0	90		0	0	0	128561	0	282464	1127078		
46703	3869	46275916	1926-10-09	1926-10-09 00:00:00	1926-10-09	1926-10-09 00:00:00	1926-10-09	38000177		0	0	0		0	0	0	256936	0	1660014	46275916		
43185	3578	1127433	2008-05-03	2008-05-03 00:00:00	2008-05-17	2008-05-17 00:00:00	2008-05-17	38000177		0	0	14		0	0	0	237864	0	313782	1127433		
5985	500	1127078	1962-09-14	1962-09-14 00:00:00	1962-10-05	1962-10-05 00:00:00	1962-10-05	38000177		0	0	21		0	0	0	33503	0	282464	1127078		
6012	502	19018935	2011-04-02	2011-04-02 00:00:00	2011-04-02	2011-04-02 00:00:00	\N	38000177		0	0	0		0	0	0	33622	0	197604	19018935		
21207	1746	19059056	1957-10-16	1957-10-16 00:00:00	1958-01-14	1958-01-14 00:00:00	1958-01-14	38000177		0	0	90		0	0	0	116762	0	243670	19059056		
31613	689	40213306	2004-05-02	2004-05-02 00:00:00	2004-05-02	2004-05-02 00:00:00	2004-05-02	581452		0	0	0		0	0	0	45622	0	43	40213306		
177049	3891	40213227	2016-09-14	2016-09-14 00:00:00	2016-09-14	2016-09-14 00:00:00	2016-09-14	581452		0	0	0		0	0	0	258735	0	113	40213227		
54415	4523	1127433	1989-01-21	1989-01-21 00:00:00	1989-02-20	1989-02-20 00:00:00	1989-02-20	38000177		0	0	30		0	0	0	301154	0	313782	1127433		
62903	1376	40213251	1984-11-02	1984-11-02 00:00:00	1984-11-02	1984-11-02 00:00:00	1984-11-02	581452		0	0	0		0	0	0	91210	0	21	40213251		
7226	606	1127433	1978-07-27	1978-07-27 00:00:00	1978-08-03	1978-08-03 00:00:00	1978-08-03	38000177		0	0	7		0	0	0	40260	0	313782	1127433		
8876	741	1127078	1982-10-18	1982-10-18 00:00:00	1982-11-01	1982-11-01 00:00:00	1982-11-01	38000177		0	0	14		0	0	0	49041	0	282464	1127078		
41517	3439	19018935	2015-12-10	2015-12-10 00:00:00	2015-12-10	2015-12-10 00:00:00	\N	38000177		0	0	0		0	0	0	228145	0	197604	19018935		
61745	5138	1713671	1985-07-30	1985-07-30 00:00:00	1985-08-20	1985-08-20 00:00:00	1985-08-20	38000177		0	0	21		0	0	0	341462	0	562251	1713671		
52985	4403	40229134	1982-07-12	1982-07-12 00:00:00	1982-07-26	1982-07-26 00:00:00	1982-07-26	38000177		0	0	14		0	0	0	292669	0	1043400	40229134		
9303	774	1713671	1982-08-29	1982-08-29 00:00:00	1982-09-12	1982-09-12 00:00:00	1982-09-12	38000177		0	0	14		0	0	0	51393	0	562251	1713671		
9337	776	40229134	1961-09-15	1961-09-15 00:00:00	1961-09-29	1961-09-29 00:00:00	1961-09-29	38000177		0	0	14		0	0	0	51516	0	1043400	40229134		
52212	4343	19133873	1967-09-26	1967-09-26 00:00:00	1967-10-04	1967-10-04 00:00:00	1967-10-04	38000177		0	0	8		0	0	0	287989	0	834061	19133873		
47566	3943	1127433	1968-03-12	1968-03-12 00:00:00	1968-04-09	1968-04-09 00:00:00	1968-04-09	38000177		0	0	28		0	0	0	262136	0	313782	1127433		
46824	3879	1127078	1951-02-01	1951-02-01 00:00:00	1951-03-08	1951-03-08 00:00:00	1951-03-08	38000177		0	0	35		0	0	0	257727	0	282464	1127078		
21353	1756	19133873	1977-05-13	1977-05-13 00:00:00	1977-05-20	1977-05-20 00:00:00	1977-05-20	38000177		0	0	7		0	0	0	117424	0	834061	19133873		
46898	3885	40229134	1981-10-29	1981-10-29 00:00:00	1981-11-12	1981-11-12 00:00:00	1981-11-12	38000177		0	0	14		0	0	0	258226	0	1043400	40229134		
32124	2662	19074843	1979-04-22	1979-04-22 00:00:00	1979-05-07	1979-05-07 00:00:00	1979-05-07	38000177		0	0	15		0	0	0	176400	0	309045	19074843		
92364	2027	40213260	2011-03-18	2011-03-18 00:00:00	2011-03-18	2011-03-18 00:00:00	2011-03-18	581452		0	0	0		0	0	0	134889	0	121	40213260		
52505	4366	1127078	1984-01-04	1984-01-04 00:00:00	1984-01-18	1984-01-18 00:00:00	1984-01-18	38000177		0	0	14		0	0	0	289612	0	282464	1127078		
32037	2654	1127433	1980-06-16	1980-06-16 00:00:00	1980-06-23	1980-06-23 00:00:00	1980-06-23	38000177		0	0	7		0	0	0	175714	0	313782	1127433		
207728	4557	40213227	2001-10-14	2001-10-14 00:00:00	2001-10-14	2001-10-14 00:00:00	2001-10-14	581452		0	0	0		0	0	0	303662	0	113	40213227		
13924	300	40213160	1977-03-11	1977-03-11 00:00:00	1977-03-11	1977-03-11 00:00:00	1977-03-11	581452		0	0	0		0	0	0	20032	0	10	40213160		
10287	862	1127433	1977-02-10	1977-02-10 00:00:00	1977-02-24	1977-02-24 00:00:00	1977-02-24	38000177		0	0	14		0	0	0	57042	0	313782	1127433		
7322	613	19078461	2007-03-07	2007-03-07 00:00:00	2007-05-06	2007-05-06 00:00:00	2007-05-06	38000177		0	0	60		0	0	0	40696	0	310965	19078461		
205068	4501	40213160	1973-08-09	1973-08-09 00:00:00	1973-08-09	1973-08-09 00:00:00	1973-08-09	581452		0	0	0		0	0	0	299724	0	10	40213160		
57194	4748	40236824	1996-11-04	1996-11-04 00:00:00	1996-11-11	1996-11-11 00:00:00	1996-11-11	38000177		0	0	7		0	0	0	316185	0	1094107	40236824		
35377	2915	19059056	1955-10-28	1955-10-28 00:00:00	1955-11-18	1955-11-18 00:00:00	1955-11-18	38000177		0	0	21		0	0	0	194302	0	243670	19059056		
26031	2141	40162522	1961-09-08	1961-09-08 00:00:00	1961-09-08	1961-09-08 00:00:00	\N	38000177		0	0	0		0	0	0	142596	0	857005	40162522		
36578	3017	40236824	2002-09-09	2002-09-09 00:00:00	2002-09-23	2002-09-23 00:00:00	2002-09-23	38000177		0	0	14		0	0	0	201254	0	1094107	40236824		
5494	458	19059056	1973-03-11	1973-03-11 00:00:00	1973-03-25	1973-03-25 00:00:00	1973-03-25	38000177		0	0	14		0	0	0	30617	0	243670	19059056		
18928	1563	1154615	1977-06-25	1977-06-25 00:00:00	1977-06-25	1977-06-25 00:00:00	\N	38000177		0	0	0		0	0	0	104703	0	745679	1154615		
39451	3259	1127433	1980-01-03	1980-01-03 00:00:00	1980-01-17	1980-01-17 00:00:00	1980-01-17	38000177		0	0	14		0	0	0	216689	0	313782	1127433		
26081	2147	1127433	1958-03-01	1958-03-01 00:00:00	1958-03-08	1958-03-08 00:00:00	1958-03-08	38000177		0	0	7		0	0	0	142924	0	313782	1127433		
26133	2150	1115171	2017-02-28	2017-02-28 00:00:00	2017-03-28	2017-03-28 00:00:00	2017-03-28	38000177		0	0	28		0	0	0	143155	0	849574	1115171		
22355	1837	19133873	1962-09-04	1962-09-04 00:00:00	1962-09-11	1962-09-11 00:00:00	1962-09-11	38000177		0	0	7		0	0	0	122734	0	834061	19133873		
23388	1926	46233988	1973-03-26	1973-03-26 00:00:00	1973-04-09	1973-04-09 00:00:00	1973-04-09	38000177		0	0	14		0	0	0	128238	0	1652673	46233988		
170352	3745	40213227	2001-07-11	2001-07-11 00:00:00	2001-07-11	2001-07-11 00:00:00	2001-07-11	581452		0	0	0		0	0	0	248871	0	113	40213227		
44450	3680	19008572	1998-08-29	1998-08-29 00:00:00	1998-09-12	1998-09-12 00:00:00	1998-09-12	38000177		0	0	14		0	0	0	244696	0	106258	19008572		
34014	2812	1713671	1977-08-11	1977-08-11 00:00:00	1977-08-18	1977-08-18 00:00:00	1977-08-18	38000177		0	0	7		0	0	0	186311	0	562251	1713671		
212246	4653	40213296	1999-02-28	1999-02-28 00:00:00	1999-02-28	1999-02-28 00:00:00	1999-02-28	581452		0	0	0		0	0	0	310136	0	52	40213296		
18595	1537	19128065	1982-04-10	1982-04-10 00:00:00	1983-04-05	1983-04-05 00:00:00	1983-04-05	38000177		0	0	360		0	0	0	102928	0	749882	19128065		
63411	5267	1127078	1976-01-16	1976-01-16 00:00:00	1976-02-20	1976-02-20 00:00:00	1976-02-20	38000177		0	0	35		0	0	0	350357	0	282464	1127078		
47444	3934	46275916	1984-09-19	1984-09-19 00:00:00	1984-09-19	1984-09-19 00:00:00	1984-09-19	38000177		0	0	0		0	0	0	261504	0	1660014	46275916		
8648	722	1713671	2000-08-16	2000-08-16 00:00:00	2000-08-30	2000-08-30 00:00:00	2000-08-30	38000177		0	0	14		0	0	0	47752	0	562251	1713671		
29235	2419	40229134	2000-01-30	2000-01-30 00:00:00	2000-02-06	2000-02-06 00:00:00	2000-02-06	38000177		0	0	7		0	0	0	160546	0	1043400	40229134		
49484	1083	40213296	2006-05-25	2006-05-25 00:00:00	2006-05-25	2006-05-25 00:00:00	2006-05-25	581452		0	0	0		0	0	0	71062	0	52	40213296		
4261	352	19073183	1983-03-12	1983-03-12 00:00:00	1983-03-26	1983-03-26 00:00:00	1983-03-26	38000177		0	0	14		0	0	0	23440	0	308182	19073183		
1216	97	920300	1966-08-09	1966-08-09 00:00:00	1966-08-16	1966-08-16 00:00:00	1966-08-16	38000177		0	0	7		0	0	0	6585	0	311989	920300		
33486	2771	35605482	1974-09-02	1974-09-02 00:00:00	1974-09-02	1974-09-02 00:00:00	1974-09-02	38000177		0	0	0		0	0	0	183474	0	1740467	35605482		
11312	940	40243436	1993-03-04	1993-03-04 00:00:00	1993-03-04	1993-03-04 00:00:00	1993-03-04	38000177		0	0	0		0	0	0	62564	0	1190795	40243436		
11037	919	1118084	2009-06-05	2009-06-05 00:00:00	2009-06-05	2009-06-05 00:00:00	\N	38000177		0	0	0		0	0	0	61273	0	00025152531	44923712		
50494	4197	40165015	2009-12-15	2009-12-15 00:00:00	2009-12-15	2009-12-15 00:00:00	\N	38000177		0	0	0		0	0	0	278527	0	861467	40165015		
29432	2436	1127433	1942-10-28	1942-10-28 00:00:00	1942-11-11	1942-11-11 00:00:00	1942-11-11	38000177		0	0	14		0	0	0	161513	0	313782	1127433		
151791	3339	40213306	1981-10-20	1981-10-20 00:00:00	1981-10-20	1981-10-20 00:00:00	1981-10-20	581452		0	0	0		0	0	0	221472	0	43	40213306		
196101	4309	40213227	1995-08-30	1995-08-30 00:00:00	1995-08-30	1995-08-30 00:00:00	1995-08-30	581452		0	0	0		0	0	0	285909	0	113	40213227		
38831	3211	1127078	1958-11-13	1958-11-13 00:00:00	1958-11-27	1958-11-27 00:00:00	1958-11-27	38000177		0	0	14		0	0	0	213334	0	282464	1127078		
117036	2572	40213227	2012-02-07	2012-02-07 00:00:00	2012-02-07	2012-02-07 00:00:00	2012-02-07	581452		0	0	0		0	0	0	170362	0	113	40213227		
226657	4977	40213260	2009-12-18	2009-12-18 00:00:00	2009-12-18	2009-12-18 00:00:00	2009-12-18	581452		0	0	0		0	0	0	331181	0	121	40213260		
23475	1933	920300	1979-06-29	1979-06-29 00:00:00	1979-07-06	1979-07-06 00:00:00	1979-07-06	38000177		0	0	7		0	0	0	128563	0	311989	920300		
46704	3869	19059056	1909-05-17	1909-05-17 00:00:00	1909-05-31	1909-05-31 00:00:00	1909-05-31	38000177		0	0	14		0	0	0	256944	0	243670	19059056		
43186	3578	19019979	1980-04-22	1980-04-22 00:00:00	1980-05-20	1980-05-20 00:00:00	1980-05-20	38000177		0	0	28		0	0	0	237859	0	198405	19019979		
5986	500	1118084	1998-09-25	1998-09-25 00:00:00	1998-09-25	1998-09-25 00:00:00	\N	38000177		0	0	0		0	0	0	33498	0	00025152531	44923712		
6013	502	40171902	2011-04-02	2011-04-02 00:00:00	2011-04-02	2011-04-02 00:00:00	\N	38000177		0	0	0		0	0	0	33622	0	897718	40171902		
21208	1746	19133905	2014-03-27	2014-03-27 00:00:00	2014-04-09	2014-04-09 00:00:00	2014-04-09	38000177		0	0	13		0	0	0	116801	0	834102	19133905		
31616	689	40213306	2005-09-04	2005-09-04 00:00:00	2005-09-04	2005-09-04 00:00:00	2005-09-04	581452		0	0	0		0	0	0	45613	0	43	40213306		
162620	3576	40213227	2007-11-24	2007-11-24 00:00:00	2007-11-24	2007-11-24 00:00:00	2007-11-24	581452		0	0	0		0	0	0	237741	0	113	40213227		
54416	4523	40165015	1989-01-21	1989-01-21 00:00:00	1989-01-21	1989-01-21 00:00:00	\N	38000177		0	0	0		0	0	0	301154	0	861467	40165015		
62915	1376	40213227	2000-02-11	2000-02-11 00:00:00	2000-02-11	2000-02-11 00:00:00	2000-02-11	581452		0	0	0		0	0	0	91230	0	113	40213227		
7227	606	19128022	1994-01-13	1994-01-13 00:00:00	1995-01-08	1995-01-08 00:00:00	1995-01-08	38000177		0	0	360		0	0	0	40246	0	749785	19128022		
8877	741	19128065	1991-11-10	1991-11-10 00:00:00	1992-11-04	1992-11-04 00:00:00	1992-11-04	38000177		0	0	360		0	0	0	49100	0	749882	19128065		
41518	3439	40171902	2015-12-10	2015-12-10 00:00:00	2015-12-10	2015-12-10 00:00:00	\N	38000177		0	0	0		0	0	0	228145	0	897718	40171902		
61746	5138	1713671	1990-04-04	1990-04-04 00:00:00	1990-04-25	1990-04-25 00:00:00	1990-04-25	38000177		0	0	21		0	0	0	341463	0	562251	1713671		
52986	4403	19059056	1969-06-20	1969-06-20 00:00:00	1969-07-18	1969-07-18 00:00:00	1969-07-18	38000177		0	0	28		0	0	0	292709	0	243670	19059056		
9304	774	1127433	1991-04-16	1991-04-16 00:00:00	1991-04-23	1991-04-23 00:00:00	1991-04-23	38000177		0	0	7		0	0	0	51376	0	313782	1127433		
9338	776	920300	1995-10-04	1995-10-04 00:00:00	1995-10-11	1995-10-11 00:00:00	1995-10-11	38000177		0	0	7		0	0	0	51522	0	311989	920300		
52213	4343	40173590	2014-12-15	2014-12-15 00:00:00	2014-12-15	2014-12-15 00:00:00	\N	38000177		0	0	0		0	0	0	288073	0	904419	40173590		
47568	3943	19133873	1954-12-02	1954-12-02 00:00:00	1954-12-15	1954-12-15 00:00:00	1954-12-15	38000177		0	0	13		0	0	0	262133	0	834061	19133873		
46825	3879	40165015	2003-06-03	2003-06-03 00:00:00	2003-06-03	2003-06-03 00:00:00	\N	38000177		0	0	0		0	0	0	257728	0	861467	40165015		
21354	1756	1127433	1995-11-06	1995-11-06 00:00:00	1995-11-20	1995-11-20 00:00:00	1995-11-20	38000177		0	0	14		0	0	0	117448	0	313782	1127433		
46899	3885	46233988	1973-09-10	1973-09-10 00:00:00	1973-10-01	1973-10-01 00:00:00	1973-10-01	38000177		0	0	21		0	0	0	258296	0	1652673	46233988		
32125	2662	1127078	1979-04-22	1979-04-22 00:00:00	1979-05-07	1979-05-07 00:00:00	1979-05-07	38000177		0	0	15		0	0	0	176400	0	282464	1127078		
123365	2711	40213198	2015-12-07	2015-12-07 00:00:00	2015-12-07	2015-12-07 00:00:00	2015-12-07	581452		0	0	0		0	0	0	179716	0	133	40213198		
52506	4366	19075001	1984-01-04	1984-01-04 00:00:00	1984-01-18	1984-01-18 00:00:00	1984-01-18	38000177		0	0	14		0	0	0	289612	0	309097	19075001		
20674	449	40213227	2001-03-01	2001-03-01 00:00:00	2001-03-01	2001-03-01 00:00:00	2001-03-01	581452		0	0	0		0	0	0	29990	0	113	40213227		
207732	4557	40213227	1992-08-23	1992-08-23 00:00:00	1992-08-23	1992-08-23 00:00:00	1992-08-23	581452		0	0	0		0	0	0	303665	0	113	40213227		
13930	300	40213227	2003-11-14	2003-11-14 00:00:00	2003-11-14	2003-11-14 00:00:00	2003-11-14	581452		0	0	0		0	0	0	20068	0	113	40213227		
10288	862	1115171	1994-02-24	1994-02-24 00:00:00	1994-03-26	1994-03-26 00:00:00	1994-03-26	38000177		0	0	30		0	0	0	57053	0	849574	1115171		
7323	613	40231925	2007-03-07	2007-03-07 00:00:00	2007-03-07	2007-03-07 00:00:00	\N	38000177		0	0	0		0	0	0	40696	0	1049221	40231925		
205070	4501	40213227	1995-06-22	1995-06-22 00:00:00	1995-06-22	1995-06-22 00:00:00	1995-06-22	581452		0	0	0		0	0	0	299733	0	113	40213227		
57195	4748	920300	1996-11-04	1996-11-04 00:00:00	1996-11-11	1996-11-11 00:00:00	1996-11-11	38000177		0	0	7		0	0	0	316185	0	311989	920300		
35378	2915	40173590	2005-04-03	2005-04-03 00:00:00	2005-04-03	2005-04-03 00:00:00	\N	38000177		0	0	0		0	0	0	194378	0	904419	40173590		
26032	2141	19059056	1956-01-31	1956-01-31 00:00:00	1956-03-01	1956-03-01 00:00:00	1956-03-01	38000177		0	0	30		0	0	0	142597	0	243670	19059056		
38974	851	40213160	1982-02-08	1982-02-08 00:00:00	1982-02-08	1982-02-08 00:00:00	1982-02-08	581452		0	0	0		0	0	0	56300	0	10	40213160		
5495	458	19129655	1973-03-11	1973-03-11 00:00:00	1973-03-25	1973-03-25 00:00:00	1973-03-25	38000177		0	0	14		0	0	0	30617	0	789980	19129655		
18929	1563	1124300	1997-09-01	1997-09-01 00:00:00	1997-09-01	1997-09-01 00:00:00	\N	38000177		0	0	0		0	0	0	104663	0	00781178901	45011828		
39452	3259	1127078	1966-08-25	1966-08-25 00:00:00	1966-09-22	1966-09-22 00:00:00	1966-09-22	38000177		0	0	28		0	0	0	216695	0	282464	1127078		
26083	2147	1127433	1984-12-24	1984-12-24 00:00:00	1985-01-07	1985-01-07 00:00:00	1985-01-07	38000177		0	0	14		0	0	0	142942	0	313782	1127433		
26134	2150	1127078	1958-04-08	1958-04-08 00:00:00	1958-06-07	1958-06-07 00:00:00	1958-06-07	38000177		0	0	60		0	0	0	143148	0	282464	1127078		
22356	1837	19129655	1961-08-06	1961-08-06 00:00:00	1961-08-20	1961-08-20 00:00:00	1961-08-20	38000177		0	0	14		0	0	0	122689	0	789980	19129655		
23389	1926	19059056	1973-03-26	1973-03-26 00:00:00	1973-04-09	1973-04-09 00:00:00	1973-04-09	38000177		0	0	14		0	0	0	128238	0	243670	19059056		
170359	3745	40213227	1992-05-20	1992-05-20 00:00:00	1992-05-20	1992-05-20 00:00:00	1992-05-20	581452		0	0	0		0	0	0	248870	0	113	40213227		
44451	3680	19134077	1998-08-29	1998-08-29 00:00:00	1998-09-12	1998-09-12 00:00:00	1998-09-12	38000177		0	0	14		0	0	0	244696	0	835900	19134077		
34015	2812	1127433	1991-07-12	1991-07-12 00:00:00	1991-08-09	1991-08-09 00:00:00	1991-08-09	38000177		0	0	28		0	0	0	186318	0	313782	1127433		
212248	4653	40213227	2010-02-28	2010-02-28 00:00:00	2010-02-28	2010-02-28 00:00:00	2010-02-28	581452		0	0	0		0	0	0	310183	0	113	40213227		
18596	1537	1713671	1978-01-15	1978-01-15 00:00:00	1978-01-22	1978-01-22 00:00:00	1978-01-22	38000177		0	0	7		0	0	0	102869	0	562251	1713671		
6290	137	40213227	2013-01-16	2013-01-16 00:00:00	2013-01-16	2013-01-16 00:00:00	2013-01-16	581452		0	0	0		0	0	0	9227	0	113	40213227		
47445	3934	1310034	1984-09-19	1984-09-19 00:00:00	1984-09-19	1984-09-19 00:00:00	1984-09-19	38000177		0	0	0		0	0	0	261504	0	834357	1310034		
8649	722	1127433	1975-08-19	1975-08-19 00:00:00	1975-08-26	1975-08-26 00:00:00	1975-08-26	38000177		0	0	7		0	0	0	47762	0	313782	1127433		
29236	2419	1127433	1972-11-19	1972-11-19 00:00:00	1972-12-03	1972-12-03 00:00:00	1972-12-03	38000177		0	0	14		0	0	0	160571	0	313782	1127433		
49486	1083	40213160	1966-08-25	1966-08-25 00:00:00	1966-08-25	1966-08-25 00:00:00	1966-08-25	581452		0	0	0		0	0	0	71125	0	10	40213160		
4262	352	19073183	1988-12-04	1988-12-04 00:00:00	1988-12-18	1988-12-18 00:00:00	1988-12-18	38000177		0	0	14		0	0	0	23452	0	308182	19073183		
1217	97	19077572	2015-08-10	2015-08-10 00:00:00	2015-08-10	2015-08-10 00:00:00	\N	38000177		0	0	0		0	0	0	6613	0	310436	19077572		
33487	2771	35605858	1974-09-02	1974-09-02 00:00:00	1974-09-02	1974-09-02 00:00:00	1974-09-02	38000177		0	0	0		0	0	0	183474	0	1732136	35605858		
58695	4873	46233988	1978-10-16	1978-10-16 00:00:00	1978-10-30	1978-10-30 00:00:00	1978-10-30	38000177		0	0	14		0	0	0	324115	0	1652673	46233988		
11038	919	40229134	1992-08-19	1992-08-19 00:00:00	1992-09-02	1992-09-02 00:00:00	1992-09-02	38000177		0	0	14		0	0	0	61254	0	1043400	40229134		
50495	4197	19019979	1997-03-16	1997-03-16 00:00:00	1997-04-15	1997-04-15 00:00:00	1997-04-15	38000177		0	0	30		0	0	0	278525	0	198405	19019979		
29433	2436	19078461	1990-01-20	1990-01-20 00:00:00	1990-03-21	1990-03-21 00:00:00	1990-03-21	38000177		0	0	60		0	0	0	161576	0	310965	19078461		
37831	825	40213227	1993-07-24	1993-07-24 00:00:00	1993-07-24	1993-07-24 00:00:00	1993-07-24	581452		0	0	0		0	0	0	54638	0	113	40213227		
196104	4309	40213260	2007-10-10	2007-10-10 00:00:00	2007-10-10	2007-10-10 00:00:00	2007-10-10	581452		0	0	0		0	0	0	285883	0	121	40213260		
38832	3211	19006318	1958-11-13	1958-11-13 00:00:00	1958-11-27	1958-11-27 00:00:00	1958-11-27	38000177		0	0	14		0	0	0	213334	0	105078	19006318		
117037	2572	40213296	2012-02-07	2012-02-07 00:00:00	2012-02-07	2012-02-07 00:00:00	2012-02-07	581452		0	0	0		0	0	0	170362	0	52	40213296		
226664	4977	40213160	1960-03-25	1960-03-25 00:00:00	1960-03-25	1960-03-25 00:00:00	1960-03-25	581452		0	0	0		0	0	0	331118	0	10	40213160		
23476	1933	40236824	1979-06-29	1979-06-29 00:00:00	1979-07-06	1979-07-06 00:00:00	1979-07-06	38000177		0	0	7		0	0	0	128563	0	1094107	40236824		
46705	3869	40229134	1941-06-30	1941-06-30 00:00:00	1941-07-14	1941-07-14 00:00:00	1941-07-14	38000177		0	0	14		0	0	0	256938	0	1043400	40229134		
43187	3578	1127433	1992-03-18	1992-03-18 00:00:00	1992-05-17	1992-05-17 00:00:00	1992-05-17	38000177		0	0	60		0	0	0	237860	0	313782	1127433		
5987	500	1127078	1962-07-28	1962-07-28 00:00:00	1962-08-11	1962-08-11 00:00:00	1962-08-11	38000177		0	0	14		0	0	0	33527	0	282464	1127078		
6014	502	40163554	2011-04-02	2011-04-02 00:00:00	2011-04-02	2011-04-02 00:00:00	\N	38000177		0	0	0		0	0	0	33622	0	855332	40163554		
21209	1746	1127433	1957-07-07	1957-07-07 00:00:00	1957-07-21	1957-07-21 00:00:00	1957-07-21	38000177		0	0	14		0	0	0	116719	0	313782	1127433		
31617	689	40213180	2005-09-04	2005-09-04 00:00:00	2005-09-04	2005-09-04 00:00:00	2005-09-04	581452		0	0	0		0	0	0	45613	0	114	40213180		
162621	3576	40213296	2007-11-24	2007-11-24 00:00:00	2007-11-24	2007-11-24 00:00:00	2007-11-24	581452		0	0	0		0	0	0	237741	0	52	40213296		
54417	4523	19128022	1991-01-16	1991-01-16 00:00:00	1992-01-11	1992-01-11 00:00:00	1992-01-11	38000177		0	0	360		0	0	0	301176	0	749785	19128022		
62916	1376	40213306	2000-02-11	2000-02-11 00:00:00	2000-02-11	2000-02-11 00:00:00	2000-02-11	581452		0	0	0		0	0	0	91230	0	43	40213306		
7228	606	1713671	2010-02-24	2010-02-24 00:00:00	2010-03-03	2010-03-03 00:00:00	2010-03-03	38000177		0	0	7		0	0	0	40263	0	562251	1713671		
8878	741	19078461	1989-12-24	1989-12-24 00:00:00	1990-01-21	1990-01-21 00:00:00	1990-01-21	38000177		0	0	28		0	0	0	49042	0	310965	19078461		
41519	3439	40163554	2015-12-10	2015-12-10 00:00:00	2015-12-10	2015-12-10 00:00:00	\N	38000177		0	0	0		0	0	0	228145	0	855332	40163554		
23854	518	40213160	1971-03-09	1971-03-09 00:00:00	1971-03-09	1971-03-09 00:00:00	1971-03-09	581452		0	0	0		0	0	0	34618	0	10	40213160		
52987	4403	40169281	1990-05-19	1990-05-19 00:00:00	1990-05-19	1990-05-19 00:00:00	\N	38000177		0	0	0		0	0	0	292736	0	896209	40169281		
9305	774	19078461	2006-11-05	2006-11-05 00:00:00	2006-12-05	2006-12-05 00:00:00	2006-12-05	38000177		0	0	30		0	0	0	51391	0	310965	19078461		
9339	776	40236824	1995-10-04	1995-10-04 00:00:00	1995-10-11	1995-10-11 00:00:00	1995-10-11	38000177		0	0	7		0	0	0	51522	0	1094107	40236824		
52214	4343	40229134	1961-07-28	1961-07-28 00:00:00	1961-08-11	1961-08-11 00:00:00	1961-08-11	38000177		0	0	14		0	0	0	288008	0	1043400	40229134		
47569	3943	19059056	1973-03-14	1973-03-14 00:00:00	1973-04-20	1973-04-20 00:00:00	1973-04-20	38000177		0	0	37		0	0	0	262137	0	243670	19059056		
46826	3879	1127433	2003-06-03	2003-06-03 00:00:00	2003-08-02	2003-08-02 00:00:00	2003-08-02	38000177		0	0	60		0	0	0	257728	0	313782	1127433		
21541	1770	19133873	1996-01-21	1996-01-21 00:00:00	1996-01-28	1996-01-28 00:00:00	1996-01-28	38000177		0	0	7		0	0	0	118379	0	834061	19133873		
46900	3885	19059056	1973-09-10	1973-09-10 00:00:00	1973-10-01	1973-10-01 00:00:00	1973-10-01	38000177		0	0	21		0	0	0	258296	0	243670	19059056		
32126	2662	1118084	2016-07-02	2016-07-02 00:00:00	2016-07-02	2016-07-02 00:00:00	\N	38000177		0	0	0		0	0	0	176408	0	00025152531	44923712		
123384	2711	40213227	2001-09-17	2001-09-17 00:00:00	2001-09-17	2001-09-17 00:00:00	2001-09-17	581452		0	0	0		0	0	0	179709	0	113	40213227		
21881	1793	40231925	1943-04-02	1943-04-02 00:00:00	1943-04-02	1943-04-02 00:00:00	\N	38000177		0	0	0		0	0	0	120221	0	1049221	40231925		
20675	449	40213296	2001-03-01	2001-03-01 00:00:00	2001-03-01	2001-03-01 00:00:00	2001-03-01	581452		0	0	0		0	0	0	29990	0	52	40213296		
38516	841	40213227	2003-01-22	2003-01-22 00:00:00	2003-01-22	2003-01-22 00:00:00	2003-01-22	581452		0	0	0		0	0	0	55586	0	113	40213227		
13933	300	40213160	1972-09-01	1972-09-01 00:00:00	1972-09-01	1972-09-01 00:00:00	1972-09-01	581452		0	0	0		0	0	0	20050	0	10	40213160		
205009	4500	40213160	1961-12-20	1961-12-20 00:00:00	1961-12-20	1961-12-20 00:00:00	1961-12-20	581452		0	0	0		0	0	0	299554	0	10	40213160		
7324	613	1127433	1992-08-17	1992-08-17 00:00:00	1992-09-07	1992-09-07 00:00:00	1992-09-07	38000177		0	0	21		0	0	0	40778	0	313782	1127433		
205071	4501	40213306	1995-06-22	1995-06-22 00:00:00	1995-06-22	1995-06-22 00:00:00	1995-06-22	581452		0	0	0		0	0	0	299733	0	43	40213306		
57196	4748	40231925	1997-07-26	1997-07-26 00:00:00	1997-07-26	1997-07-26 00:00:00	\N	38000177		0	0	0		0	0	0	316216	0	1049221	40231925		
35379	2915	19133905	1969-09-16	1969-09-16 00:00:00	1969-09-23	1969-09-23 00:00:00	1969-09-23	38000177		0	0	7		0	0	0	194346	0	834102	19133905		
26033	2141	19078461	2006-02-14	2006-02-14 00:00:00	2006-03-07	2006-03-07 00:00:00	2006-03-07	38000177		0	0	21		0	0	0	142599	0	310965	19078461		
38977	851	40213314	1981-11-09	1981-11-09 00:00:00	1981-11-09	1981-11-09 00:00:00	1981-11-09	581452		0	0	0		0	0	0	56308	0	49	40213314		
5496	458	1124300	2007-06-21	2007-06-21 00:00:00	2007-06-21	2007-06-21 00:00:00	\N	38000177		0	0	0		0	0	0	30661	0	00781178901	45011828		
18930	1563	19059056	1959-01-09	1959-01-09 00:00:00	1959-01-23	1959-01-23 00:00:00	1959-01-23	38000177		0	0	14		0	0	0	104719	0	243670	19059056		
39453	3259	1127078	1967-12-02	1967-12-02 00:00:00	1967-12-16	1967-12-16 00:00:00	1967-12-16	38000177		0	0	14		0	0	0	216688	0	282464	1127078		
26084	2147	19078461	2013-08-27	2013-08-27 00:00:00	2013-09-10	2013-09-10 00:00:00	2013-09-10	38000177		0	0	14		0	0	0	142967	0	310965	19078461		
26135	2150	1713671	1961-02-17	1961-02-17 00:00:00	1961-02-24	1961-02-24 00:00:00	1961-02-24	38000177		0	0	7		0	0	0	143200	0	562251	1713671		
22357	1837	1127078	1961-08-06	1961-08-06 00:00:00	1961-08-20	1961-08-20 00:00:00	1961-08-20	38000177		0	0	14		0	0	0	122689	0	282464	1127078		
23390	1926	1127433	1986-05-17	1986-05-17 00:00:00	1986-06-07	1986-06-07 00:00:00	1986-06-07	38000177		0	0	21		0	0	0	128200	0	313782	1127433		
200837	4411	40213201	2011-09-05	2011-09-05 00:00:00	2011-09-05	2011-09-05 00:00:00	2011-09-05	581452		0	0	0		0	0	0	293261	0	33	40213201		
44452	3680	1115171	1994-03-15	1994-03-15 00:00:00	1994-04-05	1994-04-05 00:00:00	1994-04-05	38000177		0	0	21		0	0	0	244719	0	849574	1115171		
34016	2813	1713671	1975-06-13	1975-06-13 00:00:00	1975-07-04	1975-07-04 00:00:00	1975-07-04	38000177		0	0	21		0	0	0	186409	0	562251	1713671		
212249	4653	40213260	2010-02-28	2010-02-28 00:00:00	2010-02-28	2010-02-28 00:00:00	2010-02-28	581452		0	0	0		0	0	0	310183	0	121	40213260		
18597	1537	1118084	1992-01-21	1992-01-21 00:00:00	1992-01-21	1992-01-21 00:00:00	\N	38000177		0	0	0		0	0	0	102905	0	00025152531	44923712		
6291	137	40213296	2013-01-16	2013-01-16 00:00:00	2013-01-16	2013-01-16 00:00:00	2013-01-16	581452		0	0	0		0	0	0	9227	0	52	40213296		
47446	3934	40243436	1984-09-19	1984-09-19 00:00:00	1984-09-19	1984-09-19 00:00:00	1984-09-19	38000177		0	0	0		0	0	0	261504	0	1190795	40243436		
8650	722	1127433	1989-07-26	1989-07-26 00:00:00	1989-08-25	1989-08-25 00:00:00	1989-08-25	38000177		0	0	30		0	0	0	47801	0	313782	1127433		
29237	2419	19059056	1959-05-10	1959-05-10 00:00:00	1959-05-24	1959-05-24 00:00:00	1959-05-24	38000177		0	0	14		0	0	0	160506	0	243670	19059056		
49488	1083	40213296	2006-11-23	2006-11-23 00:00:00	2006-11-23	2006-11-23 00:00:00	2006-11-23	581452		0	0	0		0	0	0	\N	0	52	40213296		
4263	352	19059056	1988-12-04	1988-12-04 00:00:00	1988-12-18	1988-12-18 00:00:00	1988-12-18	38000177		0	0	14		0	0	0	23452	0	243670	19059056		
1218	97	1127433	1959-09-23	1959-09-23 00:00:00	1959-11-22	1959-11-22 00:00:00	1959-11-22	38000177		0	0	60		0	0	0	6642	0	313782	1127433		
33488	2771	40220386	1974-09-02	1974-09-02 00:00:00	1974-09-02	1974-09-02 00:00:00	1974-09-02	38000177		0	0	0		0	0	0	183474	0	1808217	40220386		
58696	4873	19128022	1991-07-08	1991-07-08 00:00:00	1992-07-02	1992-07-02 00:00:00	1992-07-02	38000177		0	0	360		0	0	0	324098	0	749785	19128022		
11039	919	1127433	1998-11-09	1998-11-09 00:00:00	1998-11-16	1998-11-16 00:00:00	1998-11-16	38000177		0	0	7		0	0	0	61250	0	313782	1127433		
50496	4197	44816277	2006-08-19	2006-08-19 00:00:00	2007-08-14	2007-08-14 00:00:00	2007-08-14	38000177		0	0	360		0	0	0	278500	0	1534809	44816277		
29434	2436	1124300	1948-06-25	1948-06-25 00:00:00	1948-06-25	1948-06-25 00:00:00	\N	38000177		0	0	0		0	0	0	161564	0	00781178901	45011828		
37832	825	40213306	1993-07-24	1993-07-24 00:00:00	1993-07-24	1993-07-24 00:00:00	1993-07-24	581452		0	0	0		0	0	0	54638	0	43	40213306		
196109	4309	40213260	2006-10-04	2006-10-04 00:00:00	2006-10-04	2006-10-04 00:00:00	2006-10-04	581452		0	0	0		0	0	0	285917	0	121	40213260		
38833	3211	19133873	1972-02-29	1972-02-29 00:00:00	1972-03-10	1972-03-10 00:00:00	1972-03-10	38000177		0	0	10		0	0	0	213315	0	834061	19133873		
117040	2572	40213227	2001-03-06	2001-03-06 00:00:00	2001-03-06	2001-03-06 00:00:00	2001-03-06	581452		0	0	0		0	0	0	170387	0	113	40213227		
226673	4977	40213160	1960-08-27	1960-08-27 00:00:00	1960-08-27	1960-08-27 00:00:00	1960-08-27	581452		0	0	0		0	0	0	331119	0	10	40213160		
23477	1933	1127433	1980-12-02	1980-12-02 00:00:00	1980-12-16	1980-12-16 00:00:00	1980-12-16	38000177		0	0	14		0	0	0	128546	0	313782	1127433		
46706	3869	19059056	1911-03-08	1911-03-08 00:00:00	1911-04-05	1911-04-05 00:00:00	1911-04-05	38000177		0	0	28		0	0	0	256935	0	243670	19059056		
43188	3578	19133873	1976-08-28	1976-08-28 00:00:00	1976-09-07	1976-09-07 00:00:00	1976-09-07	38000177		0	0	10		0	0	0	237862	0	834061	19133873		
5988	500	1127433	1981-12-27	1981-12-27 00:00:00	1982-01-31	1982-01-31 00:00:00	1982-01-31	38000177		0	0	35		0	0	0	33549	0	313782	1127433		
6015	502	1127433	1979-06-01	1979-06-01 00:00:00	1979-06-08	1979-06-08 00:00:00	1979-06-08	38000177		0	0	7		0	0	0	33634	0	313782	1127433		
21210	1746	1127078	1953-10-09	1953-10-09 00:00:00	1953-11-06	1953-11-06 00:00:00	1953-11-06	38000177		0	0	28		0	0	0	116761	0	282464	1127078		
31619	689	40213160	1987-02-01	1987-02-01 00:00:00	1987-02-01	1987-02-01 00:00:00	1987-02-01	581452		0	0	0		0	0	0	45660	0	10	40213160		
162627	3576	40213227	1998-04-11	1998-04-11 00:00:00	1998-04-11	1998-04-11 00:00:00	1998-04-11	581452		0	0	0		0	0	0	237736	0	113	40213227		
54418	4523	19128022	1990-01-21	1990-01-21 00:00:00	1991-01-16	1991-01-16 00:00:00	1991-01-16	38000177		0	0	360		0	0	0	301203	0	749785	19128022		
62918	1376	40213314	1978-04-21	1978-04-21 00:00:00	1978-04-21	1978-04-21 00:00:00	1978-04-21	581452		0	0	0		0	0	0	91223	0	49	40213314		
7229	606	1118084	2010-07-28	2010-07-28 00:00:00	2010-07-28	2010-07-28 00:00:00	\N	38000177		0	0	0		0	0	0	40263	0	00025152531	44923712		
8879	741	1127433	2004-05-05	2004-05-05 00:00:00	2004-05-19	2004-05-19 00:00:00	2004-05-19	38000177		0	0	14		0	0	0	49096	0	313782	1127433		
41520	3440	1713671	1944-11-26	1944-11-26 00:00:00	1944-12-17	1944-12-17 00:00:00	1944-12-17	38000177		0	0	21		0	0	0	228273	0	562251	1713671		
23858	518	40213227	2001-09-11	2001-09-11 00:00:00	2001-09-11	2001-09-11 00:00:00	2001-09-11	581452		0	0	0		0	0	0	34646	0	113	40213227		
52988	4403	1127433	1986-04-20	1986-04-20 00:00:00	1986-04-27	1986-04-27 00:00:00	1986-04-27	38000177		0	0	7		0	0	0	292722	0	313782	1127433		
9306	774	40165015	2006-11-05	2006-11-05 00:00:00	2006-11-05	2006-11-05 00:00:00	\N	38000177		0	0	0		0	0	0	51391	0	861467	40165015		
9340	776	19059056	1959-08-25	1959-08-25 00:00:00	1959-09-15	1959-09-15 00:00:00	1959-09-15	38000177		0	0	21		0	0	0	51567	0	243670	19059056		
52215	4343	19059056	1967-03-05	1967-03-05 00:00:00	1967-04-04	1967-04-04 00:00:00	1967-04-04	38000177		0	0	30		0	0	0	288078	0	243670	19059056		
47570	3943	1127433	1985-03-01	1985-03-01 00:00:00	1985-03-15	1985-03-15 00:00:00	1985-03-15	38000177		0	0	14		0	0	0	262150	0	313782	1127433		
46827	3879	40236824	1971-02-26	1971-02-26 00:00:00	1971-03-05	1971-03-05 00:00:00	1971-03-05	38000177		0	0	7		0	0	0	257690	0	1094107	40236824		
21542	1770	1127433	1995-01-04	1995-01-04 00:00:00	1995-01-18	1995-01-18 00:00:00	1995-01-18	38000177		0	0	14		0	0	0	118401	0	313782	1127433		
46901	3885	19128065	1987-09-16	1987-09-16 00:00:00	1988-09-10	1988-09-10 00:00:00	1988-09-10	38000177		0	0	360		0	0	0	258231	0	749882	19128065		
32127	2662	1127433	2000-09-29	2000-09-29 00:00:00	2000-10-13	2000-10-13 00:00:00	2000-10-13	38000177		0	0	14		0	0	0	176430	0	313782	1127433		
123396	2711	40213227	2011-09-19	2011-09-19 00:00:00	2011-09-19	2011-09-19 00:00:00	2011-09-19	581452		0	0	0		0	0	0	179790	0	113	40213227		
21882	1793	19059056	1943-04-02	1943-04-02 00:00:00	1943-05-07	1943-05-07 00:00:00	1943-05-07	38000177		0	0	35		0	0	0	120221	0	243670	19059056		
20684	450	40213296	2008-03-31	2008-03-31 00:00:00	2008-03-31	2008-03-31 00:00:00	2008-03-31	581452		0	0	0		0	0	0	30036	0	52	40213296		
38517	841	40213201	2018-04-18	2018-04-18 00:00:00	2018-04-18	2018-04-18 00:00:00	2018-04-18	581452		0	0	0		0	0	0	55533	0	33	40213201		
13935	300	40213160	1972-06-30	1972-06-30 00:00:00	1972-06-30	1972-06-30 00:00:00	1972-06-30	581452		0	0	0		0	0	0	20078	0	10	40213160		
205011	4500	40213160	1966-08-24	1966-08-24 00:00:00	1966-08-24	1966-08-24 00:00:00	1966-08-24	581452		0	0	0		0	0	0	299635	0	10	40213160		
7325	613	1713671	1978-06-13	1978-06-13 00:00:00	1978-07-04	1978-07-04 00:00:00	1978-07-04	38000177		0	0	21		0	0	0	40718	0	562251	1713671		
205076	4501	40213296	2012-12-06	2012-12-06 00:00:00	2012-12-06	2012-12-06 00:00:00	2012-12-06	581452		0	0	0		0	0	0	299752	0	52	40213296		
57197	4748	1127433	1995-12-28	1995-12-28 00:00:00	1996-01-11	1996-01-11 00:00:00	1996-01-11	38000177		0	0	14		0	0	0	316142	0	313782	1127433		
35380	2915	1713671	1985-08-30	1985-08-30 00:00:00	1985-09-20	1985-09-20 00:00:00	1985-09-20	38000177		0	0	21		0	0	0	194294	0	562251	1713671		
26054	2145	1127078	1969-02-22	1969-02-22 00:00:00	1969-03-08	1969-03-08 00:00:00	1969-03-08	38000177		0	0	14		0	0	0	142792	0	282464	1127078		
38978	851	40213160	1981-11-09	1981-11-09 00:00:00	1981-11-09	1981-11-09 00:00:00	1981-11-09	581452		0	0	0		0	0	0	56308	0	10	40213160		
5497	458	1127433	1974-02-06	1974-02-06 00:00:00	1974-02-13	1974-02-13 00:00:00	1974-02-13	38000177		0	0	7		0	0	0	30616	0	313782	1127433		
18931	1563	19006318	1959-01-09	1959-01-09 00:00:00	1959-01-23	1959-01-23 00:00:00	1959-01-23	38000177		0	0	14		0	0	0	104719	0	105078	19006318		
39454	3259	1124300	1999-10-11	1999-10-11 00:00:00	1999-10-11	1999-10-11 00:00:00	\N	38000177		0	0	0		0	0	0	216678	0	00781178901	45011828		
26085	2147	1127433	1973-08-27	1973-08-27 00:00:00	1973-09-10	1973-09-10 00:00:00	1973-09-10	38000177		0	0	14		0	0	0	143003	0	313782	1127433		
26136	2150	1124300	1986-02-25	1986-02-25 00:00:00	1986-02-25	1986-02-25 00:00:00	\N	38000177		0	0	0		0	0	0	143238	0	00781178901	45011828		
22358	1837	40229134	1961-01-10	1961-01-10 00:00:00	1961-01-17	1961-01-17 00:00:00	1961-01-17	38000177		0	0	7		0	0	0	122701	0	1043400	40229134		
23391	1926	1118084	2006-06-16	2006-06-16 00:00:00	2006-06-16	2006-06-16 00:00:00	\N	38000177		0	0	0		0	0	0	128216	0	00025152531	44923712		
200974	4413	40213306	1983-09-08	1983-09-08 00:00:00	1983-09-08	1983-09-08 00:00:00	1983-09-08	581452		0	0	0		0	0	0	293440	0	43	40213306		
44453	3680	19133905	1999-11-17	1999-11-17 00:00:00	1999-11-29	1999-11-29 00:00:00	1999-11-29	38000177		0	0	12		0	0	0	244702	0	834102	19133905		
207943	4562	40213160	1961-05-06	1961-05-06 00:00:00	1961-05-06	1961-05-06 00:00:00	1961-05-06	581452		0	0	0		0	0	0	303993	0	10	40213160		
212395	4656	40213227	2000-09-17	2000-09-17 00:00:00	2000-09-17	2000-09-17 00:00:00	2000-09-17	581452		0	0	0		0	0	0	310421	0	113	40213227		
18598	1537	19006318	1958-05-04	1958-05-04 00:00:00	1958-05-18	1958-05-18 00:00:00	1958-05-18	38000177		0	0	14		0	0	0	102924	0	105078	19006318		
6293	137	40213160	1976-06-09	1976-06-09 00:00:00	1976-06-09	1976-06-09 00:00:00	1976-06-09	581452		0	0	0		0	0	0	9223	0	10	40213160		
47447	3934	19059056	1967-06-08	1967-06-08 00:00:00	1967-06-22	1967-06-22 00:00:00	1967-06-22	38000177		0	0	14		0	0	0	261502	0	243670	19059056		
8651	722	40162522	1989-07-26	1989-07-26 00:00:00	1989-07-26	1989-07-26 00:00:00	\N	38000177		0	0	0		0	0	0	47801	0	857005	40162522		
29238	2419	19059056	1955-11-22	1955-11-22 00:00:00	1955-12-27	1955-12-27 00:00:00	1955-12-27	38000177		0	0	35		0	0	0	160505	0	243670	19059056		
49491	1083	40213160	1967-01-26	1967-01-26 00:00:00	1967-01-26	1967-01-26 00:00:00	1967-01-26	581452		0	0	0		0	0	0	71126	0	10	40213160		
4264	352	1118084	2012-08-28	2012-08-28 00:00:00	2012-08-28	2012-08-28 00:00:00	\N	38000177		0	0	0		0	0	0	23465	0	00025152531	44923712		
1219	97	1713671	1992-08-27	1992-08-27 00:00:00	1992-09-03	1992-09-03 00:00:00	1992-09-03	38000177		0	0	7		0	0	0	6618	0	562251	1713671		
33489	2771	1367571	1974-09-02	1974-09-02 00:00:00	1974-09-02	1974-09-02 00:00:00	1974-09-02	38000177		0	0	0		0	0	0	183474	0	314659	19080464		
58697	4873	19128065	1993-06-27	1993-06-27 00:00:00	1994-06-22	1994-06-22 00:00:00	1994-06-22	38000177		0	0	360		0	0	0	324099	0	749882	19128065		
11040	919	19078461	1998-02-13	1998-02-13 00:00:00	1998-03-06	1998-03-06 00:00:00	1998-03-06	38000177		0	0	21		0	0	0	61222	0	310965	19078461		
50497	4197	19127922	2007-08-14	2007-08-14 00:00:00	2007-12-16	2007-12-16 00:00:00	2007-12-16	38000177		0	0	124		0	0	0	278501	0	748962	19127922		
29435	2436	1127433	1919-07-09	1919-07-09 00:00:00	1919-07-23	1919-07-23 00:00:00	1919-07-23	38000177		0	0	14		0	0	0	161450	0	313782	1127433		
37834	825	40213227	2012-04-28	2012-04-28 00:00:00	2012-04-28	2012-04-28 00:00:00	2012-04-28	581452		0	0	0		0	0	0	54673	0	113	40213227		
34902	761	40213227	2010-11-19	2010-11-19 00:00:00	2010-11-19	2010-11-19 00:00:00	2010-11-19	581452		0	0	0		0	0	0	50600	0	113	40213227		
38834	3211	1713671	1985-02-08	1985-02-08 00:00:00	1985-02-22	1985-02-22 00:00:00	1985-02-22	38000177		0	0	14		0	0	0	213340	0	562251	1713671		
117041	2572	40213160	1969-09-30	1969-09-30 00:00:00	1969-09-30	1969-09-30 00:00:00	1969-09-30	581452		0	0	0		0	0	0	170355	0	10	40213160		
226677	4977	40213296	2000-07-01	2000-07-01 00:00:00	2000-07-01	2000-07-01 00:00:00	2000-07-01	581452		0	0	0		0	0	0	331150	0	52	40213296		
23478	1933	1118084	1998-05-10	1998-05-10 00:00:00	1998-05-10	1998-05-10 00:00:00	\N	38000177		0	0	0		0	0	0	128557	0	00025152531	44923712		
46707	3869	1127433	1980-12-03	1980-12-03 00:00:00	1981-03-03	1981-03-03 00:00:00	1981-03-03	38000177		0	0	90		0	0	0	256844	0	313782	1127433		
43189	3578	1118084	2016-11-09	2016-11-09 00:00:00	2016-11-09	2016-11-09 00:00:00	\N	38000177		0	0	0		0	0	0	237851	0	00025152531	44923712		
5989	500	19133873	1967-05-23	1967-05-23 00:00:00	1967-06-03	1967-06-03 00:00:00	1967-06-03	38000177		0	0	11		0	0	0	33538	0	834061	19133873		
6016	502	1115171	2009-03-30	2009-03-30 00:00:00	2009-05-04	2009-05-04 00:00:00	2009-05-04	38000177		0	0	35		0	0	0	33651	0	849574	1115171		
21212	1746	1127433	1967-10-13	1967-10-13 00:00:00	1967-10-20	1967-10-20 00:00:00	1967-10-20	38000177		0	0	7		0	0	0	116785	0	313782	1127433		
31621	689	40213251	1987-02-01	1987-02-01 00:00:00	1987-02-01	1987-02-01 00:00:00	1987-02-01	581452		0	0	0		0	0	0	45660	0	21	40213251		
162637	3576	40213296	2009-11-28	2009-11-28 00:00:00	2009-11-28	2009-11-28 00:00:00	2009-11-28	581452		0	0	0		0	0	0	237707	0	52	40213296		
54419	4523	19078461	1994-07-24	1994-07-24 00:00:00	1994-08-21	1994-08-21 00:00:00	1994-08-21	38000177		0	0	28		0	0	0	301155	0	310965	19078461		
62919	1376	40213160	1978-04-21	1978-04-21 00:00:00	1978-04-21	1978-04-21 00:00:00	1978-04-21	581452		0	0	0		0	0	0	91223	0	10	40213160		
7230	606	19128022	1989-02-08	1989-02-08 00:00:00	1990-02-03	1990-02-03 00:00:00	1990-02-03	38000177		0	0	360		0	0	0	40255	0	749785	19128022		
8880	742	1127433	2009-10-08	2009-10-08 00:00:00	2009-10-22	2009-10-22 00:00:00	2009-10-22	38000177		0	0	14		0	0	0	49193	0	313782	1127433		
41521	3440	1127433	1955-05-31	1955-05-31 00:00:00	1955-06-30	1955-06-30 00:00:00	1955-06-30	38000177		0	0	30		0	0	0	228292	0	313782	1127433		
23864	518	40213227	1992-09-01	1992-09-01 00:00:00	1992-09-01	1992-09-01 00:00:00	1992-09-01	581452		0	0	0		0	0	0	34643	0	113	40213227		
52989	4403	1118084	1973-08-09	1973-08-09 00:00:00	1973-08-09	1973-08-09 00:00:00	\N	38000177		0	0	0		0	0	0	292648	0	00025152531	44923712		
9307	774	40236824	2003-09-01	2003-09-01 00:00:00	2003-09-08	2003-09-08 00:00:00	2003-09-08	38000177		0	0	7		0	0	0	51373	0	1094107	40236824		
9341	776	1118084	1998-01-12	1998-01-12 00:00:00	1998-01-12	1998-01-12 00:00:00	\N	38000177		0	0	0		0	0	0	51561	0	00025152531	44923712		
52216	4343	1115171	1999-07-04	1999-07-04 00:00:00	1999-07-18	1999-07-18 00:00:00	1999-07-18	38000177		0	0	14		0	0	0	288081	0	849574	1115171		
47571	3943	1127078	1961-09-24	1961-09-24 00:00:00	1961-10-15	1961-10-15 00:00:00	1961-10-15	38000177		0	0	21		0	0	0	262135	0	282464	1127078		
46828	3879	920300	1971-02-26	1971-02-26 00:00:00	1971-03-05	1971-03-05 00:00:00	1971-03-05	38000177		0	0	7		0	0	0	257690	0	311989	920300		
21543	1770	1127433	2006-04-30	2006-04-30 00:00:00	2006-05-14	2006-05-14 00:00:00	2006-05-14	38000177		0	0	14		0	0	0	118342	0	313782	1127433		
46902	3885	40236824	1995-12-22	1995-12-22 00:00:00	1996-01-05	1996-01-05 00:00:00	1996-01-05	38000177		0	0	14		0	0	0	258214	0	1094107	40236824		
32128	2662	19078461	2018-02-17	2018-02-17 00:00:00	2018-03-20	2018-03-20 00:00:00	2018-03-20	38000177		0	0	31		0	0	0	176432	0	310965	19078461		
199321	4379	40213227	2011-06-28	2011-06-28 00:00:00	2011-06-28	2011-06-28 00:00:00	2011-06-28	581452		0	0	0		0	0	0	290956	0	113	40213227		
21883	1793	1713671	1964-06-05	1964-06-05 00:00:00	1964-06-12	1964-06-12 00:00:00	1964-06-12	38000177		0	0	7		0	0	0	120180	0	562251	1713671		
20687	450	40213306	1989-06-12	1989-06-12 00:00:00	1989-06-12	1989-06-12 00:00:00	1989-06-12	581452		0	0	0		0	0	0	30017	0	43	40213306		
38519	841	40213160	1957-01-09	1957-01-09 00:00:00	1957-01-09	1957-01-09 00:00:00	1957-01-09	581452		0	0	0		0	0	0	55569	0	10	40213160		
13943	300	40213227	2013-07-12	2013-07-12 00:00:00	2013-07-12	2013-07-12 00:00:00	2013-07-12	581452		0	0	0		0	0	0	20069	0	113	40213227		
42593	3531	19133873	1981-09-07	1981-09-07 00:00:00	1981-09-16	1981-09-16 00:00:00	1981-09-16	38000177		0	0	9		0	0	0	234541	0	834061	19133873		
7326	613	40173590	2016-05-27	2016-05-27 00:00:00	2016-05-27	2016-05-27 00:00:00	\N	38000177		0	0	0		0	0	0	40683	0	904419	40173590		
205078	4501	40213160	1973-05-10	1973-05-10 00:00:00	1973-05-10	1973-05-10 00:00:00	1973-05-10	581452		0	0	0		0	0	0	299693	0	10	40213160		
57198	4748	1127433	1970-08-16	1970-08-16 00:00:00	1970-08-30	1970-08-30 00:00:00	1970-08-30	38000177		0	0	14		0	0	0	316132	0	313782	1127433		
35381	2915	1127078	1950-12-02	1950-12-02 00:00:00	1950-12-23	1950-12-23 00:00:00	1950-12-23	38000177		0	0	21		0	0	0	194300	0	282464	1127078		
26055	2145	46233988	1969-02-22	1969-02-22 00:00:00	1969-03-08	1969-03-08 00:00:00	1969-03-08	38000177		0	0	14		0	0	0	142792	0	1652673	46233988		
38988	851	40213160	1986-05-12	1986-05-12 00:00:00	1986-05-12	1986-05-12 00:00:00	1986-05-12	581452		0	0	0		0	0	0	56312	0	10	40213160		
5498	459	1713671	2012-10-25	2012-10-25 00:00:00	2012-11-01	2012-11-01 00:00:00	2012-11-01	38000177		0	0	7		0	0	0	30681	0	562251	1713671		
18932	1563	1127433	1971-06-06	1971-06-06 00:00:00	1971-06-20	1971-06-20 00:00:00	1971-06-20	38000177		0	0	14		0	0	0	104702	0	313782	1127433		
39455	3259	40229134	1969-12-08	1969-12-08 00:00:00	1969-12-22	1969-12-22 00:00:00	1969-12-22	38000177		0	0	14		0	0	0	216670	0	1043400	40229134		
26086	2147	1124300	1989-03-06	1989-03-06 00:00:00	1989-03-06	1989-03-06 00:00:00	\N	38000177		0	0	0		0	0	0	142936	0	00781178901	45011828		
26137	2150	1127433	1954-12-27	1954-12-27 00:00:00	1955-01-10	1955-01-10 00:00:00	1955-01-10	38000177		0	0	14		0	0	0	143188	0	313782	1127433		
22359	1837	920300	1992-06-17	1992-06-17 00:00:00	1992-06-24	1992-06-24 00:00:00	1992-06-24	38000177		0	0	7		0	0	0	122687	0	311989	920300		
23392	1926	19128065	1988-03-17	1988-03-17 00:00:00	1989-03-12	1989-03-12 00:00:00	1989-03-12	38000177		0	0	360		0	0	0	128248	0	749882	19128065		
200982	4413	40213227	2002-12-19	2002-12-19 00:00:00	2002-12-19	2002-12-19 00:00:00	2002-12-19	581452		0	0	0		0	0	0	293477	0	113	40213227		
44454	3680	19008572	1983-04-29	1983-04-29 00:00:00	1983-05-20	1983-05-20 00:00:00	1983-05-20	38000177		0	0	21		0	0	0	244676	0	106258	19008572		
207947	4562	40213306	1982-09-11	1982-09-11 00:00:00	1982-09-11	1982-09-11 00:00:00	1982-09-11	581452		0	0	0		0	0	0	\N	0	43	40213306		
212402	4657	40213260	2011-07-29	2011-07-29 00:00:00	2011-07-29	2011-07-29 00:00:00	2011-07-29	581452		0	0	0		0	0	0	310530	0	121	40213260		
18599	1537	19059056	1958-05-04	1958-05-04 00:00:00	1958-05-18	1958-05-18 00:00:00	1958-05-18	38000177		0	0	14		0	0	0	102924	0	243670	19059056		
6299	137	40213160	1972-03-08	1972-03-08 00:00:00	1972-03-08	1972-03-08 00:00:00	1972-03-08	581452		0	0	0		0	0	0	9152	0	10	40213160		
47448	3934	19059056	1941-10-01	1941-10-01 00:00:00	1941-10-22	1941-10-22 00:00:00	1941-10-22	38000177		0	0	21		0	0	0	261498	0	243670	19059056		
8652	722	19133873	1980-05-30	1980-05-30 00:00:00	1980-06-11	1980-06-11 00:00:00	1980-06-11	38000177		0	0	12		0	0	0	47742	0	834061	19133873		
29239	2419	19059056	1949-07-26	1949-07-26 00:00:00	1949-08-09	1949-08-09 00:00:00	1949-08-09	38000177		0	0	14		0	0	0	160595	0	243670	19059056		
49495	1083	40213227	2008-05-29	2008-05-29 00:00:00	2008-05-29	2008-05-29 00:00:00	2008-05-29	581452		0	0	0		0	0	0	71105	0	113	40213227		
4265	352	1127433	2007-04-18	2007-04-18 00:00:00	2007-04-25	2007-04-25 00:00:00	2007-04-25	38000177		0	0	7		0	0	0	23443	0	313782	1127433		
1220	97	1127433	1992-09-04	1992-09-04 00:00:00	1992-10-09	1992-10-09 00:00:00	1992-10-09	38000177		0	0	35		0	0	0	6644	0	313782	1127433		
33490	2771	19059056	1915-01-19	1915-01-19 00:00:00	1915-02-02	1915-02-02 00:00:00	1915-02-02	38000177		0	0	14		0	0	0	183548	0	243670	19059056		
58698	4873	1127433	2004-09-18	2004-09-18 00:00:00	2004-10-02	2004-10-02 00:00:00	2004-10-02	38000177		0	0	14		0	0	0	324095	0	313782	1127433		
11048	921	40163554	2016-06-21	2016-06-21 00:00:00	2016-06-21	2016-06-21 00:00:00	\N	38000177		0	0	0		0	0	0	61366	0	855332	40163554		
50498	4197	40220960	2011-02-20	2011-02-20 00:00:00	2011-02-20	2011-02-20 00:00:00	2011-02-20	38000177		0	0	0		0	0	0	278508	0	1804799	40220960		
29436	2436	1713671	1966-01-03	1966-01-03 00:00:00	1966-01-17	1966-01-17 00:00:00	1966-01-17	38000177		0	0	14		0	0	0	161500	0	562251	1713671		
37835	825	40213296	2012-04-28	2012-04-28 00:00:00	2012-04-28	2012-04-28 00:00:00	2012-04-28	581452		0	0	0		0	0	0	54673	0	52	40213296		
63358	1385	40213306	1982-07-16	1982-07-16 00:00:00	1982-07-16	1982-07-16 00:00:00	1982-07-16	581452		0	0	0		0	0	0	91866	0	43	40213306		
38835	3211	1118084	1996-11-03	1996-11-03 00:00:00	1996-11-03	1996-11-03 00:00:00	\N	38000177		0	0	0		0	0	0	213332	0	00025152531	44923712		
117042	2572	40213306	1992-02-25	1992-02-25 00:00:00	1992-02-25	1992-02-25 00:00:00	1992-02-25	581452		0	0	0		0	0	0	170384	0	43	40213306		
226680	4977	40213160	1964-08-15	1964-08-15 00:00:00	1964-08-15	1964-08-15 00:00:00	1964-08-15	581452		0	0	0		0	0	0	331135	0	10	40213160		
23479	1933	1127078	1959-11-21	1959-11-21 00:00:00	1959-12-05	1959-12-05 00:00:00	1959-12-05	38000177		0	0	14		0	0	0	128578	0	282464	1127078		
46708	3869	40165015	1980-12-03	1980-12-03 00:00:00	1980-12-03	1980-12-03 00:00:00	\N	38000177		0	0	0		0	0	0	256844	0	861467	40165015		
43190	3578	1127433	1998-01-20	1998-01-20 00:00:00	1998-02-03	1998-02-03 00:00:00	1998-02-03	38000177		0	0	14		0	0	0	237853	0	313782	1127433		
5990	500	19059056	1968-06-19	1968-06-19 00:00:00	1968-07-03	1968-07-03 00:00:00	1968-07-03	38000177		0	0	14		0	0	0	33546	0	243670	19059056		
6017	502	40162522	2000-10-13	2000-10-13 00:00:00	2000-10-13	2000-10-13 00:00:00	\N	38000177		0	0	0		0	0	0	33650	0	857005	40162522		
21213	1746	40165015	2000-03-25	2000-03-25 00:00:00	2000-03-25	2000-03-25 00:00:00	\N	38000177		0	0	0		0	0	0	116764	0	861467	40165015		
31627	689	40213314	1983-05-01	1983-05-01 00:00:00	1983-05-01	1983-05-01 00:00:00	1983-05-01	581452		0	0	0		0	0	0	45657	0	49	40213314		
162638	3576	40213160	1966-04-23	1966-04-23 00:00:00	1966-04-23	1966-04-23 00:00:00	1966-04-23	581452		0	0	0		0	0	0	237750	0	10	40213160		
54420	4523	40229134	2004-08-06	2004-08-06 00:00:00	2004-08-20	2004-08-20 00:00:00	2004-08-20	38000177		0	0	14		0	0	0	301184	0	1043400	40229134		
62922	1376	40213227	2019-02-15	2019-02-15 00:00:00	2019-02-15	2019-02-15 00:00:00	2019-02-15	581452		0	0	0		0	0	0	91233	0	113	40213227		
7231	606	1127433	1987-06-09	1987-06-09 00:00:00	1987-07-14	1987-07-14 00:00:00	1987-07-14	38000177		0	0	35		0	0	0	40215	0	313782	1127433		
8881	742	1713671	1992-03-26	1992-03-26 00:00:00	1992-04-02	1992-04-02 00:00:00	1992-04-02	38000177		0	0	7		0	0	0	49140	0	562251	1713671		
41522	3440	19059056	1978-02-18	1978-02-18 00:00:00	1978-03-11	1978-03-11 00:00:00	1978-03-11	38000177		0	0	21		0	0	0	228226	0	243670	19059056		
23865	518	40213306	1992-09-01	1992-09-01 00:00:00	1992-09-01	1992-09-01 00:00:00	1992-09-01	581452		0	0	0		0	0	0	34643	0	43	40213306		
52990	4403	1127433	1950-08-12	1950-08-12 00:00:00	1950-08-19	1950-08-19 00:00:00	1950-08-19	38000177		0	0	7		0	0	0	292719	0	313782	1127433		
9308	774	920300	2003-09-01	2003-09-01 00:00:00	2003-09-08	2003-09-08 00:00:00	2003-09-08	38000177		0	0	7		0	0	0	51373	0	311989	920300		
9342	776	1127078	1967-05-27	1967-05-27 00:00:00	1967-06-10	1967-06-10 00:00:00	1967-06-10	38000177		0	0	14		0	0	0	51569	0	282464	1127078		
52217	4343	1127433	1992-02-13	1992-02-13 00:00:00	1992-03-12	1992-03-12 00:00:00	1992-03-12	38000177		0	0	28		0	0	0	288080	0	313782	1127433		
47572	3943	1124300	1990-07-24	1990-07-24 00:00:00	1990-07-24	1990-07-24 00:00:00	\N	38000177		0	0	0		0	0	0	262187	0	00781178901	45011828		
46829	3879	1127433	1987-02-19	1987-02-19 00:00:00	1987-03-05	1987-03-05 00:00:00	1987-03-05	38000177		0	0	14		0	0	0	257663	0	313782	1127433		
21544	1770	1127078	1981-05-26	1981-05-26 00:00:00	1981-06-23	1981-06-23 00:00:00	1981-06-23	38000177		0	0	28		0	0	0	118374	0	282464	1127078		
46903	3885	920300	1995-12-22	1995-12-22 00:00:00	1995-12-29	1995-12-29 00:00:00	1995-12-29	38000177		0	0	7		0	0	0	258214	0	311989	920300		
32129	2662	19078461	2002-07-05	2002-07-05 00:00:00	2002-08-11	2002-08-11 00:00:00	2002-08-11	38000177		0	0	37		0	0	0	176431	0	310965	19078461		
199322	4379	40213296	2011-06-28	2011-06-28 00:00:00	2011-06-28	2011-06-28 00:00:00	2011-06-28	581452		0	0	0		0	0	0	290956	0	52	40213296		
21884	1794	1127433	1990-04-25	1990-04-25 00:00:00	1990-05-09	1990-05-09 00:00:00	1990-05-09	38000177		0	0	14		0	0	0	120328	0	313782	1127433		
20689	450	40213160	1967-10-16	1967-10-16 00:00:00	1967-10-16	1967-10-16 00:00:00	1967-10-16	581452		0	0	0		0	0	0	\N	0	10	40213160		
38523	841	40213227	1994-01-26	1994-01-26 00:00:00	1994-01-26	1994-01-26 00:00:00	1994-01-26	581452		0	0	0		0	0	0	55541	0	113	40213227		
13944	300	40213296	2013-07-12	2013-07-12 00:00:00	2013-07-12	2013-07-12 00:00:00	2013-07-12	581452		0	0	0		0	0	0	20069	0	52	40213296		
42594	3531	46233988	1967-04-28	1967-04-28 00:00:00	1967-05-12	1967-05-12 00:00:00	1967-05-12	38000177		0	0	14		0	0	0	234574	0	1652673	46233988		
7327	613	40236824	1989-01-29	1989-01-29 00:00:00	1989-02-05	1989-02-05 00:00:00	1989-02-05	38000177		0	0	7		0	0	0	40729	0	1094107	40236824		
205089	4501	40213160	1977-11-10	1977-11-10 00:00:00	1977-11-10	1977-11-10 00:00:00	1977-11-10	581452		0	0	0		0	0	0	299697	0	10	40213160		
57200	4748	1713671	1954-12-21	1954-12-21 00:00:00	1954-12-28	1954-12-28 00:00:00	1954-12-28	38000177		0	0	7		0	0	0	316161	0	562251	1713671		
35382	2915	1713671	1947-04-01	1947-04-01 00:00:00	1947-04-22	1947-04-22 00:00:00	1947-04-22	38000177		0	0	21		0	0	0	194291	0	562251	1713671		
26056	2145	1118084	1999-09-28	1999-09-28 00:00:00	1999-09-28	1999-09-28 00:00:00	\N	38000177		0	0	0		0	0	0	142825	0	00025152531	44923712		
38989	851	40213251	1986-05-12	1986-05-12 00:00:00	1986-05-12	1986-05-12 00:00:00	1986-05-12	581452		0	0	0		0	0	0	56312	0	21	40213251		
5499	459	1127078	1975-01-07	1975-01-07 00:00:00	1975-01-21	1975-01-21 00:00:00	1975-01-21	38000177		0	0	14		0	0	0	30682	0	282464	1127078		
18933	1563	1127433	1998-02-03	1998-02-03 00:00:00	1998-02-10	1998-02-10 00:00:00	1998-02-10	38000177		0	0	7		0	0	0	104715	0	313782	1127433		
39456	3259	1127433	1977-07-15	1977-07-15 00:00:00	1977-07-29	1977-07-29 00:00:00	1977-07-29	38000177		0	0	14		0	0	0	216684	0	313782	1127433		
26087	2147	40169216	1956-10-03	1956-10-03 00:00:00	1956-10-03	1956-10-03 00:00:00	\N	38000177		0	0	0		0	0	0	142926	0	895994	40169216		
26138	2150	1115171	2005-11-07	2005-11-07 00:00:00	2006-02-05	2006-02-05 00:00:00	2006-02-05	38000177		0	0	90		0	0	0	143153	0	849574	1115171		
22360	1837	40236824	1992-06-17	1992-06-17 00:00:00	1992-06-24	1992-06-24 00:00:00	1992-06-24	38000177		0	0	7		0	0	0	122687	0	1094107	40236824		
23393	1926	19059056	1975-10-18	1975-10-18 00:00:00	1975-11-01	1975-11-01 00:00:00	1975-11-01	38000177		0	0	14		0	0	0	128196	0	243670	19059056		
200983	4413	40213296	2002-12-19	2002-12-19 00:00:00	2002-12-19	2002-12-19 00:00:00	2002-12-19	581452		0	0	0		0	0	0	293477	0	52	40213296		
44455	3680	19059056	1985-01-01	1985-01-01 00:00:00	1985-01-15	1985-01-15 00:00:00	1985-01-15	38000177		0	0	14		0	0	0	244703	0	243670	19059056		
207951	4562	40213227	1992-12-05	1992-12-05 00:00:00	1992-12-05	1992-12-05 00:00:00	1992-12-05	581452		0	0	0		0	0	0	304060	0	113	40213227		
212413	4657	40213260	2012-08-03	2012-08-03 00:00:00	2012-08-03	2012-08-03 00:00:00	2012-08-03	581452		0	0	0		0	0	0	310541	0	121	40213260		
18600	1537	1127433	1977-11-04	1977-11-04 00:00:00	1977-11-11	1977-11-11 00:00:00	1977-11-11	38000177		0	0	7		0	0	0	102922	0	313782	1127433		
111284	2444	40213227	1997-08-10	1997-08-10 00:00:00	1997-08-10	1997-08-10 00:00:00	1997-08-10	581452		0	0	0		0	0	0	162105	0	113	40213227		
47449	3934	19078461	2011-11-03	2011-11-03 00:00:00	2011-11-24	2011-11-24 00:00:00	2011-11-24	38000177		0	0	21		0	0	0	261507	0	310965	19078461		
8653	722	1127433	2011-11-28	2011-11-28 00:00:00	2011-12-19	2011-12-19 00:00:00	2011-12-19	38000177		0	0	21		0	0	0	47802	0	313782	1127433		
29240	2419	19006318	1949-07-26	1949-07-26 00:00:00	1949-08-09	1949-08-09 00:00:00	1949-08-09	38000177		0	0	14		0	0	0	160595	0	105078	19006318		
174397	3834	40213160	1955-10-23	1955-10-23 00:00:00	1955-10-23	1955-10-23 00:00:00	1955-10-23	581452		0	0	0		0	0	0	254568	0	10	40213160		
4266	352	19059056	1978-06-13	1978-06-13 00:00:00	1978-06-27	1978-06-27 00:00:00	1978-06-27	38000177		0	0	14		0	0	0	23450	0	243670	19059056		
1221	97	1127433	1966-04-21	1966-04-21 00:00:00	1966-04-28	1966-04-28 00:00:00	1966-04-28	38000177		0	0	7		0	0	0	6584	0	313782	1127433		
33500	2774	19059056	1941-01-16	1941-01-16 00:00:00	1941-01-30	1941-01-30 00:00:00	1941-01-30	38000177		0	0	14		0	0	0	183681	0	243670	19059056		
58699	4874	1127433	1992-12-25	1992-12-25 00:00:00	1993-01-08	1993-01-08 00:00:00	1993-01-08	38000177		0	0	14		0	0	0	324212	0	313782	1127433		
11049	921	19018935	2016-06-21	2016-06-21 00:00:00	2016-06-21	2016-06-21 00:00:00	\N	38000177		0	0	0		0	0	0	61366	0	197604	19018935		
50499	4197	19075601	2011-02-20	2011-02-20 00:00:00	2011-02-20	2011-02-20 00:00:00	2011-02-20	38000177		0	0	0		0	0	0	278508	0	309362	19075601		
29437	2436	1127433	2009-04-13	2009-04-13 00:00:00	2009-04-27	2009-04-27 00:00:00	2009-04-27	38000177		0	0	14		0	0	0	161452	0	313782	1127433		
37842	826	40213160	1963-06-27	1963-06-27 00:00:00	1963-06-27	1963-06-27 00:00:00	1963-06-27	581452		0	0	0		0	0	0	54735	0	10	40213160		
206812	4538	40213260	2006-06-02	2006-06-02 00:00:00	2006-06-02	2006-06-02 00:00:00	2006-06-02	581452		0	0	0		0	0	0	302328	0	121	40213260		
38836	3211	1127078	1968-06-07	1968-06-07 00:00:00	1968-06-21	1968-06-21 00:00:00	1968-06-21	38000177		0	0	14		0	0	0	213360	0	282464	1127078		
117044	2572	40213227	1992-02-25	1992-02-25 00:00:00	1992-02-25	1992-02-25 00:00:00	1992-02-25	581452		0	0	0		0	0	0	170384	0	113	40213227		
216687	4755	40213227	2006-04-28	2006-04-28 00:00:00	2006-04-28	2006-04-28 00:00:00	2006-04-28	581452		0	0	0		0	0	0	316760	0	113	40213227		
23480	1933	19006318	1959-11-21	1959-11-21 00:00:00	1959-12-05	1959-12-05 00:00:00	1959-12-05	38000177		0	0	14		0	0	0	128578	0	105078	19006318		
46709	3869	1124300	1943-07-03	1943-07-03 00:00:00	1943-07-03	1943-07-03 00:00:00	\N	38000177		0	0	0		0	0	0	256855	0	00781178901	45011828		
43191	3578	1127433	2009-02-17	2009-02-17 00:00:00	2009-03-03	2009-03-03 00:00:00	2009-03-03	38000177		0	0	14		0	0	0	237861	0	313782	1127433		
5991	500	19006318	1963-04-25	1963-04-25 00:00:00	1963-05-09	1963-05-09 00:00:00	1963-05-09	38000177		0	0	14		0	0	0	33540	0	105078	19006318		
6018	502	19078461	2000-10-13	2000-10-13 00:00:00	2001-01-11	2001-01-11 00:00:00	2001-01-11	38000177		0	0	90		0	0	0	33650	0	310965	19078461		
21214	1746	1127433	2000-03-25	2000-03-25 00:00:00	2000-06-23	2000-06-23 00:00:00	2000-06-23	38000177		0	0	90		0	0	0	116764	0	313782	1127433		
11479	956	19059056	1969-10-12	1969-10-12 00:00:00	1969-10-26	1969-10-26 00:00:00	1969-10-26	38000177		0	0	14		0	0	0	63457	0	243670	19059056		
162640	3576	40213160	1966-09-24	1966-09-24 00:00:00	1966-09-24	1966-09-24 00:00:00	1966-09-24	581452		0	0	0		0	0	0	237751	0	10	40213160		
44733	3701	1127433	1986-03-26	1986-03-26 00:00:00	1986-04-02	1986-04-02 00:00:00	1986-04-02	38000177		0	0	7		0	0	0	246033	0	313782	1127433		
62923	1376	40213296	2019-02-15	2019-02-15 00:00:00	2019-02-15	2019-02-15 00:00:00	2019-02-15	581452		0	0	0		0	0	0	91233	0	52	40213296		
7232	607	19133905	2009-05-09	2009-05-09 00:00:00	2009-05-21	2009-05-21 00:00:00	2009-05-21	38000177		0	0	12		0	0	0	40270	0	834102	19133905		
8882	742	1127433	1974-08-14	1974-08-14 00:00:00	1974-08-21	1974-08-21 00:00:00	1974-08-21	38000177		0	0	7		0	0	0	49127	0	313782	1127433		
41523	3440	1115171	2004-12-22	2004-12-22 00:00:00	2005-01-05	2005-01-05 00:00:00	2005-01-05	38000177		0	0	14		0	0	0	228229	0	849574	1115171		
23868	518	40213160	1975-06-10	1975-06-10 00:00:00	1975-06-10	1975-06-10 00:00:00	1975-06-10	581452		0	0	0		0	0	0	34604	0	10	40213160		
52991	4403	19059056	1940-10-01	1940-10-01 00:00:00	1940-11-30	1940-11-30 00:00:00	1940-11-30	38000177		0	0	60		0	0	0	292703	0	243670	19059056		
9309	774	1713671	1971-05-06	1971-05-06 00:00:00	1971-05-20	1971-05-20 00:00:00	1971-05-20	38000177		0	0	14		0	0	0	51359	0	562251	1713671		
9343	776	19059056	1969-06-29	1969-06-29 00:00:00	1969-09-27	1969-09-27 00:00:00	1969-09-27	38000177		0	0	90		0	0	0	51570	0	243670	19059056		
52218	4343	19133905	2019-06-24	2019-06-24 00:00:00	2019-06-24	2019-06-24 00:00:00	\N	38000177		0	0	0		0	0	0	288037	0	834102	19133905		
47574	3943	40162522	1973-03-21	1973-03-21 00:00:00	1973-03-21	1973-03-21 00:00:00	\N	38000177		0	0	0		0	0	0	262206	0	857005	40162522		
46830	3879	19073188	1987-02-19	1987-02-19 00:00:00	1987-03-05	1987-03-05 00:00:00	1987-03-05	38000177		0	0	14		0	0	0	257663	0	308192	19073188		
21545	1770	1127078	1983-03-17	1983-03-17 00:00:00	1983-03-31	1983-03-31 00:00:00	1983-03-31	38000177		0	0	14		0	0	0	118362	0	282464	1127078		
46904	3885	19059056	1968-09-06	1968-09-06 00:00:00	1968-10-06	1968-10-06 00:00:00	1968-10-06	38000177		0	0	30		0	0	0	258295	0	243670	19059056		
32130	2663	1115171	2018-05-15	2018-05-15 00:00:00	2018-06-05	2018-06-05 00:00:00	2018-06-05	38000177		0	0	21		0	0	0	176440	0	849574	1115171		
199325	4379	40213160	1974-05-28	1974-05-28 00:00:00	1974-05-28	1974-05-28 00:00:00	1974-05-28	581452		0	0	0		0	0	0	290951	0	10	40213160		
21885	1794	19078461	2005-03-21	2005-03-21 00:00:00	2005-04-04	2005-04-04 00:00:00	2005-04-04	38000177		0	0	14		0	0	0	120329	0	310965	19078461		
20694	450	40213227	1998-06-22	1998-06-22 00:00:00	1998-06-22	1998-06-22 00:00:00	1998-06-22	581452		0	0	0		0	0	0	30034	0	113	40213227		
38530	841	40213160	1955-06-22	1955-06-22 00:00:00	1955-06-22	1955-06-22 00:00:00	1955-06-22	581452		0	0	0		0	0	0	55551	0	10	40213160		
41201	3417	1713671	1943-07-28	1943-07-28 00:00:00	1943-08-18	1943-08-18 00:00:00	1943-08-18	38000177		0	0	21		0	0	0	226603	0	562251	1713671		
42595	3531	19059056	1967-04-28	1967-04-28 00:00:00	1967-05-12	1967-05-12 00:00:00	1967-05-12	38000177		0	0	14		0	0	0	234574	0	243670	19059056		
7328	613	920300	1989-01-29	1989-01-29 00:00:00	1989-02-05	1989-02-05 00:00:00	1989-02-05	38000177		0	0	7		0	0	0	40729	0	311989	920300		
205091	4501	40213296	2014-12-11	2014-12-11 00:00:00	2014-12-11	2014-12-11 00:00:00	2014-12-11	581452		0	0	0		0	0	0	299700	0	52	40213296		
11489	246	40213306	1982-01-28	1982-01-28 00:00:00	1982-01-28	1982-01-28 00:00:00	1982-01-28	581452		0	0	0		0	0	0	16571	0	43	40213306		
35383	2915	19133873	1950-07-18	1950-07-18 00:00:00	1950-07-30	1950-07-30 00:00:00	1950-07-30	38000177		0	0	12		0	0	0	194338	0	834061	19133873		
26057	2145	1127433	1968-06-29	1968-06-29 00:00:00	1968-07-13	1968-07-13 00:00:00	1968-07-13	38000177		0	0	14		0	0	0	142785	0	313782	1127433		
38994	851	40213160	1981-09-07	1981-09-07 00:00:00	1981-09-07	1981-09-07 00:00:00	1981-09-07	581452		0	0	0		0	0	0	56299	0	10	40213160		
5500	459	19078461	2013-12-16	2013-12-16 00:00:00	2014-02-14	2014-02-14 00:00:00	2014-02-14	38000177		0	0	60		0	0	0	30714	0	310965	19078461		
18934	1563	19133905	2002-10-24	2002-10-24 00:00:00	2002-10-31	2002-10-31 00:00:00	2002-10-31	38000177		0	0	7		0	0	0	104678	0	834102	19133905		
39457	3259	1127078	1974-08-11	1974-08-11 00:00:00	1974-09-08	1974-09-08 00:00:00	1974-09-08	38000177		0	0	28		0	0	0	216672	0	282464	1127078		
26088	2147	1154615	1956-10-03	1956-10-03 00:00:00	1956-10-03	1956-10-03 00:00:00	\N	38000177		0	0	0		0	0	0	142926	0	745679	1154615		
26139	2150	19133873	1953-07-04	1953-07-04 00:00:00	1953-07-12	1953-07-12 00:00:00	1953-07-12	38000177		0	0	8		0	0	0	143145	0	834061	19133873		
22361	1837	19128065	1975-05-05	1975-05-05 00:00:00	1976-04-29	1976-04-29 00:00:00	1976-04-29	38000177		0	0	360		0	0	0	122671	0	749882	19128065		
23394	1926	19078461	2017-12-21	2017-12-21 00:00:00	2018-01-18	2018-01-18 00:00:00	2018-01-18	38000177		0	0	28		0	0	0	128203	0	310965	19078461		
200986	4413	40213227	1992-09-17	1992-09-17 00:00:00	1992-09-17	1992-09-17 00:00:00	1992-09-17	581452		0	0	0		0	0	0	293435	0	113	40213227		
44456	3680	19075001	1985-01-01	1985-01-01 00:00:00	1985-01-15	1985-01-15 00:00:00	1985-01-15	38000177		0	0	14		0	0	0	244703	0	309097	19075001		
207958	4562	40213160	1965-08-28	1965-08-28 00:00:00	1965-08-28	1965-08-28 00:00:00	1965-08-28	581452		0	0	0		0	0	0	304026	0	10	40213160		
212416	4657	40213227	2012-08-03	2012-08-03 00:00:00	2012-08-03	2012-08-03 00:00:00	2012-08-03	581452		0	0	0		0	0	0	310541	0	113	40213227		
18601	1537	1713671	1970-07-05	1970-07-05 00:00:00	1970-07-19	1970-07-19 00:00:00	1970-07-19	38000177		0	0	14		0	0	0	102847	0	562251	1713671		
111285	2444	40213296	1997-08-10	1997-08-10 00:00:00	1997-08-10	1997-08-10 00:00:00	1997-08-10	581452		0	0	0		0	0	0	162105	0	52	40213296		
47450	3934	19059056	1945-08-02	1945-08-02 00:00:00	1945-10-31	1945-10-31 00:00:00	1945-10-31	38000177		0	0	90		0	0	0	261499	0	243670	19059056		
8654	722	1713671	1990-05-25	1990-05-25 00:00:00	1990-06-08	1990-06-08 00:00:00	1990-06-08	38000177		0	0	14		0	0	0	47764	0	562251	1713671		
29241	2419	19133905	1970-08-01	1970-08-01 00:00:00	1970-08-09	1970-08-09 00:00:00	1970-08-09	38000177		0	0	8		0	0	0	160511	0	834102	19133905		
174409	3835	40213160	1966-02-26	1966-02-26 00:00:00	1966-02-26	1966-02-26 00:00:00	1966-02-26	581452		0	0	0		0	0	0	254640	0	10	40213160		
4267	352	1127433	1996-10-03	1996-10-03 00:00:00	1996-10-10	1996-10-10 00:00:00	1996-10-10	38000177		0	0	7		0	0	0	23479	0	313782	1127433		
1222	97	1118084	1986-03-25	1986-03-25 00:00:00	1986-03-25	1986-03-25 00:00:00	\N	38000177		0	0	0		0	0	0	6624	0	00025152531	44923712		
33501	2774	1127433	1952-01-18	1952-01-18 00:00:00	1952-01-25	1952-01-25 00:00:00	1952-01-25	38000177		0	0	7		0	0	0	183724	0	313782	1127433		
58700	4874	19128065	1995-05-24	1995-05-24 00:00:00	1996-05-18	1996-05-18 00:00:00	1996-05-18	38000177		0	0	360		0	0	0	324173	0	749882	19128065		
11050	921	40171902	2016-06-21	2016-06-21 00:00:00	2016-06-21	2016-06-21 00:00:00	\N	38000177		0	0	0		0	0	0	61366	0	897718	40171902		
50500	4197	1127078	1985-10-15	1985-10-15 00:00:00	1985-10-29	1985-10-29 00:00:00	1985-10-29	38000177		0	0	14		0	0	0	278510	0	282464	1127078		
29438	2436	19059056	1957-07-21	1957-07-21 00:00:00	1957-08-11	1957-08-11 00:00:00	1957-08-11	38000177		0	0	21		0	0	0	161573	0	243670	19059056		
37847	826	40213160	1958-12-25	1958-12-25 00:00:00	1958-12-25	1958-12-25 00:00:00	1958-12-25	581452		0	0	0		0	0	0	54710	0	10	40213160		
206813	4538	40213160	1956-04-20	1956-04-20 00:00:00	1956-04-20	1956-04-20 00:00:00	1956-04-20	581452		0	0	0		0	0	0	302369	0	10	40213160		
38838	3211	19133873	1963-10-19	1963-10-19 00:00:00	1963-11-01	1963-11-01 00:00:00	1963-11-01	38000177		0	0	13		0	0	0	213330	0	834061	19133873		
117063	2572	40213160	1969-12-02	1969-12-02 00:00:00	1969-12-02	1969-12-02 00:00:00	1969-12-02	581452		0	0	0		0	0	0	170350	0	10	40213160		
216690	4755	40213201	1991-02-08	1991-02-08 00:00:00	1991-02-08	1991-02-08 00:00:00	1991-02-08	581452		0	0	0		0	0	0	316691	0	33	40213201		
23483	1933	19078461	2015-05-01	2015-05-01 00:00:00	2015-05-22	2015-05-22 00:00:00	2015-05-22	38000177		0	0	21		0	0	0	128598	0	310965	19078461		
46710	3869	1127433	1961-07-16	1961-07-16 00:00:00	1961-08-15	1961-08-15 00:00:00	1961-08-15	38000177		0	0	30		0	0	0	256843	0	313782	1127433		
43192	3578	46233988	1973-11-25	1973-11-25 00:00:00	1973-12-09	1973-12-09 00:00:00	1973-12-09	38000177		0	0	14		0	0	0	237865	0	1652673	46233988		
5992	500	1127078	1963-04-25	1963-04-25 00:00:00	1963-05-09	1963-05-09 00:00:00	1963-05-09	38000177		0	0	14		0	0	0	33540	0	282464	1127078		
6019	502	19059056	1953-10-06	1953-10-06 00:00:00	1953-10-20	1953-10-20 00:00:00	1953-10-20	38000177		0	0	14		0	0	0	33649	0	243670	19059056		
21215	1746	1127433	2005-10-28	2005-10-28 00:00:00	2005-11-04	2005-11-04 00:00:00	2005-11-04	38000177		0	0	7		0	0	0	116800	0	313782	1127433		
11480	956	1127433	2004-01-31	2004-01-31 00:00:00	2004-02-14	2004-02-14 00:00:00	2004-02-14	38000177		0	0	14		0	0	0	63515	0	313782	1127433		
162648	3577	40213306	1983-09-26	1983-09-26 00:00:00	1983-09-26	1983-09-26 00:00:00	1983-09-26	581452		0	0	0		0	0	0	237786	0	43	40213306		
44734	3701	1127433	2000-01-09	2000-01-09 00:00:00	2000-01-30	2000-01-30 00:00:00	2000-01-30	38000177		0	0	21		0	0	0	246100	0	313782	1127433		
62930	1377	40213251	1984-11-13	1984-11-13 00:00:00	1984-11-13	1984-11-13 00:00:00	1984-11-13	581452		0	0	0		0	0	0	91263	0	21	40213251		
7233	607	19133905	1984-09-05	1984-09-05 00:00:00	1984-09-16	1984-09-16 00:00:00	1984-09-16	38000177		0	0	11		0	0	0	40269	0	834102	19133905		
8883	742	1127433	1972-08-22	1972-08-22 00:00:00	1972-08-29	1972-08-29 00:00:00	1972-08-29	38000177		0	0	7		0	0	0	49218	0	313782	1127433		
41524	3440	19059056	1945-11-19	1945-11-19 00:00:00	1945-12-03	1945-12-03 00:00:00	1945-12-03	38000177		0	0	14		0	0	0	228241	0	243670	19059056		
23877	518	40213160	1970-12-08	1970-12-08 00:00:00	1970-12-08	1970-12-08 00:00:00	1970-12-08	581452		0	0	0		0	0	0	34602	0	10	40213160		
52992	4403	1713671	1980-03-26	1980-03-26 00:00:00	1980-04-02	1980-04-02 00:00:00	1980-04-02	38000177		0	0	7		0	0	0	292655	0	562251	1713671		
9310	774	1127433	1994-12-22	1994-12-22 00:00:00	1994-12-29	1994-12-29 00:00:00	1994-12-29	38000177		0	0	7		0	0	0	51372	0	313782	1127433		
9344	776	40229134	1979-08-22	1979-08-22 00:00:00	1979-08-29	1979-08-29 00:00:00	1979-08-29	38000177		0	0	7		0	0	0	51560	0	1043400	40229134		
52219	4343	1127433	1994-01-28	1994-01-28 00:00:00	1994-02-11	1994-02-11 00:00:00	1994-02-11	38000177		0	0	14		0	0	0	288052	0	313782	1127433		
47575	3943	1127433	2013-05-20	2013-05-20 00:00:00	2013-05-27	2013-05-27 00:00:00	2013-05-27	38000177		0	0	7		0	0	0	262142	0	313782	1127433		
46831	3879	1127433	1969-06-10	1969-06-10 00:00:00	1969-06-17	1969-06-17 00:00:00	1969-06-17	38000177		0	0	7		0	0	0	257665	0	313782	1127433		
21546	1770	19073183	1983-03-17	1983-03-17 00:00:00	1983-03-31	1983-03-31 00:00:00	1983-03-31	38000177		0	0	14		0	0	0	118362	0	308182	19073183		
46906	3885	920334	1995-12-29	1995-12-29 00:00:00	1996-01-05	1996-01-05 00:00:00	1996-01-05	38000177		0	0	7		0	0	0	258215	0	311995	920334		
32131	2663	1713671	2015-09-22	2015-09-22 00:00:00	2015-10-06	2015-10-06 00:00:00	2015-10-06	38000177		0	0	14		0	0	0	176447	0	562251	1713671		
144454	3175	40213227	2015-08-18	2015-08-18 00:00:00	2015-08-18	2015-08-18 00:00:00	2015-08-18	581452		0	0	0		0	0	0	211036	0	113	40213227		
21886	1794	19059056	1963-06-07	1963-06-07 00:00:00	1963-06-21	1963-06-21 00:00:00	1963-06-21	38000177		0	0	14		0	0	0	120286	0	243670	19059056		
20707	450	40213160	1972-03-19	1972-03-19 00:00:00	1972-03-19	1972-03-19 00:00:00	1972-03-19	581452		0	0	0		0	0	0	30004	0	10	40213160		
38531	841	40213260	2006-02-08	2006-02-08 00:00:00	2006-02-08	2006-02-08 00:00:00	2006-02-08	581452		0	0	0		0	0	0	55543	0	121	40213260		
41202	3417	1127433	2004-02-25	2004-02-25 00:00:00	2004-03-03	2004-03-03 00:00:00	2004-03-03	38000177		0	0	7		0	0	0	226619	0	313782	1127433		
42596	3531	1127433	1982-09-07	1982-09-07 00:00:00	1982-09-21	1982-09-21 00:00:00	1982-09-21	38000177		0	0	14		0	0	0	234521	0	313782	1127433		
61995	5157	19129655	1976-03-28	1976-03-28 00:00:00	1976-04-11	1976-04-11 00:00:00	1976-04-11	38000177		0	0	14		0	0	0	342915	0	789980	19129655		
205093	4501	40213227	2014-12-11	2014-12-11 00:00:00	2014-12-11	2014-12-11 00:00:00	2014-12-11	581452		0	0	0		0	0	0	299700	0	113	40213227		
11495	246	40213296	2000-09-07	2000-09-07 00:00:00	2000-09-07	2000-09-07 00:00:00	2000-09-07	581452		0	0	0		0	0	0	16541	0	52	40213296		
35384	2915	1127078	1954-10-03	1954-10-03 00:00:00	1955-01-01	1955-01-01 00:00:00	1955-01-01	38000177		0	0	90		0	0	0	194301	0	282464	1127078		
26058	2145	1127433	1993-10-14	1993-10-14 00:00:00	1993-10-28	1993-10-28 00:00:00	1993-10-28	38000177		0	0	14		0	0	0	142800	0	313782	1127433		
38995	851	40213314	1981-09-07	1981-09-07 00:00:00	1981-09-07	1981-09-07 00:00:00	1981-09-07	581452		0	0	0		0	0	0	56299	0	49	40213314		
5501	459	19078461	1984-12-20	1984-12-20 00:00:00	1985-01-19	1985-01-19 00:00:00	1985-01-19	38000177		0	0	30		0	0	0	30712	0	310965	19078461		
18944	1565	19059056	1968-05-25	1968-05-25 00:00:00	1968-06-08	1968-06-08 00:00:00	1968-06-08	38000177		0	0	14		0	0	0	104897	0	243670	19059056		
39458	3260	1127433	1998-02-07	1998-02-07 00:00:00	1998-02-21	1998-02-21 00:00:00	1998-02-21	38000177		0	0	14		0	0	0	216755	0	313782	1127433		
26100	2149	1127433	1959-08-17	1959-08-17 00:00:00	1959-08-31	1959-08-31 00:00:00	1959-08-31	38000177		0	0	14		0	0	0	143119	0	313782	1127433		
26140	2150	1127433	1990-04-02	1990-04-02 00:00:00	1990-04-30	1990-04-30 00:00:00	1990-04-30	38000177		0	0	28		0	0	0	143151	0	313782	1127433		
22362	1837	1127433	1976-05-17	1976-05-17 00:00:00	1976-06-16	1976-06-16 00:00:00	1976-06-16	38000177		0	0	30		0	0	0	122694	0	313782	1127433		
23395	1926	1127433	2016-01-11	2016-01-11 00:00:00	2016-01-18	2016-01-18 00:00:00	2016-01-18	38000177		0	0	7		0	0	0	128245	0	313782	1127433		
200990	4413	40213296	2000-12-14	2000-12-14 00:00:00	2000-12-14	2000-12-14 00:00:00	2000-12-14	581452		0	0	0		0	0	0	293449	0	52	40213296		
44457	3680	40229134	2006-07-29	2006-07-29 00:00:00	2006-08-12	2006-08-12 00:00:00	2006-08-12	38000177		0	0	14		0	0	0	244715	0	1043400	40229134		
207962	4562	40213296	2004-04-03	2004-04-03 00:00:00	2004-04-03	2004-04-03 00:00:00	2004-04-03	581452		0	0	0		0	0	0	303995	0	52	40213296		
212417	4657	40213160	1965-09-17	1965-09-17 00:00:00	1965-09-17	1965-09-17 00:00:00	1965-09-17	581452		0	0	0		0	0	0	310558	0	10	40213160		
18602	1537	1127078	1960-11-19	1960-11-19 00:00:00	1960-12-03	1960-12-03 00:00:00	1960-12-03	38000177		0	0	14		0	0	0	102884	0	282464	1127078		
111308	2445	40213201	1993-11-22	1993-11-22 00:00:00	1993-11-22	1993-11-22 00:00:00	1993-11-22	581452		0	0	0		0	0	0	162185	0	33	40213201		
47451	3934	1127433	1939-02-16	1939-02-16 00:00:00	1939-03-02	1939-03-02 00:00:00	1939-03-02	38000177		0	0	14		0	0	0	261448	0	313782	1127433		
8655	723	1127433	1990-10-25	1990-10-25 00:00:00	1990-11-01	1990-11-01 00:00:00	1990-11-01	38000177		0	0	7		0	0	0	47824	0	313782	1127433		
29242	2419	19059056	1989-12-12	1989-12-12 00:00:00	1990-02-10	1990-02-10 00:00:00	1990-02-10	38000177		0	0	60		0	0	0	160507	0	243670	19059056		
174412	3835	40213227	2007-09-29	2007-09-29 00:00:00	2007-09-29	2007-09-29 00:00:00	2007-09-29	581452		0	0	0		0	0	0	254650	0	113	40213227		
4268	352	1115171	2002-01-27	2002-01-27 00:00:00	2002-02-17	2002-02-17 00:00:00	2002-02-17	38000177		0	0	21		0	0	0	23435	0	849574	1115171		
1223	97	40174880	2008-07-02	2008-07-02 00:00:00	2008-07-02	2008-07-02 00:00:00	\N	38000177		0	0	0		0	0	0	6587	0	966222	40174880		
33502	2774	1127433	2011-03-27	2011-03-27 00:00:00	2011-04-26	2011-04-26 00:00:00	2011-04-26	38000177		0	0	30		0	0	0	183692	0	313782	1127433		
58701	4874	19128065	1983-07-26	1983-07-26 00:00:00	1984-07-20	1984-07-20 00:00:00	1984-07-20	38000177		0	0	360		0	0	0	324207	0	749882	19128065		
11051	921	19078461	1999-12-26	1999-12-26 00:00:00	2000-01-16	2000-01-16 00:00:00	2000-01-16	38000177		0	0	21		0	0	0	61384	0	310965	19078461		
50501	4197	19128065	2000-09-06	2000-09-06 00:00:00	2001-09-01	2001-09-01 00:00:00	2001-09-01	38000177		0	0	360		0	0	0	278492	0	749882	19128065		
29439	2436	1127433	1992-03-10	1992-03-10 00:00:00	1992-03-31	1992-03-31 00:00:00	1992-03-31	38000177		0	0	21		0	0	0	161577	0	313782	1127433		
37850	826	40213296	2000-07-27	2000-07-27 00:00:00	2000-07-27	2000-07-27 00:00:00	2000-07-27	581452		0	0	0		0	0	0	54744	0	52	40213296		
206825	4538	40213160	1955-10-21	1955-10-21 00:00:00	1955-10-21	1955-10-21 00:00:00	1955-10-21	581452		0	0	0		0	0	0	302320	0	10	40213160		
38840	3212	1127433	1996-05-15	1996-05-15 00:00:00	1996-06-19	1996-06-19 00:00:00	1996-06-19	38000177		0	0	35		0	0	0	213428	0	313782	1127433		
14083	304	40213160	1957-01-14	1957-01-14 00:00:00	1957-01-14	1957-01-14 00:00:00	1957-01-14	581452		0	0	0		0	0	0	20206	0	10	40213160		
191812	4214	40213227	2014-12-09	2014-12-09 00:00:00	2014-12-09	2014-12-09 00:00:00	2014-12-09	581452		0	0	0		0	0	0	279792	0	113	40213227		
23484	1934	1713671	1987-12-01	1987-12-01 00:00:00	1987-12-22	1987-12-22 00:00:00	1987-12-22	38000177		0	0	21		0	0	0	128634	0	562251	1713671		
46711	3869	19059056	1943-07-16	1943-07-16 00:00:00	1943-08-06	1943-08-06 00:00:00	1943-08-06	38000177		0	0	21		0	0	0	256841	0	243670	19059056		
70832	1550	40213296	2009-12-19	2009-12-19 00:00:00	2009-12-19	2009-12-19 00:00:00	2009-12-19	581452		0	0	0		0	0	0	103781	0	52	40213296		
5993	500	40229134	1966-06-27	1966-06-27 00:00:00	1966-07-04	1966-07-04 00:00:00	1966-07-04	38000177		0	0	7		0	0	0	33486	0	1043400	40229134		
6020	502	40229134	1955-03-31	1955-03-31 00:00:00	1955-04-07	1955-04-07 00:00:00	1955-04-07	38000177		0	0	7		0	0	0	33598	0	1043400	40229134		
21216	1746	920300	2011-05-17	2011-05-17 00:00:00	2011-05-24	2011-05-24 00:00:00	2011-05-24	38000177		0	0	7		0	0	0	116726	0	311989	920300		
11481	956	1127433	1955-02-02	1955-02-02 00:00:00	1955-02-23	1955-02-23 00:00:00	1955-02-23	38000177		0	0	21		0	0	0	63553	0	313782	1127433		
162656	3577	40213227	2003-03-10	2003-03-10 00:00:00	2003-03-10	2003-03-10 00:00:00	2003-03-10	581452		0	0	0		0	0	0	237834	0	113	40213227		
44735	3701	1127433	1955-08-20	1955-08-20 00:00:00	1955-09-03	1955-09-03 00:00:00	1955-09-03	38000177		0	0	14		0	0	0	246029	0	313782	1127433		
62932	1377	40213160	1984-11-13	1984-11-13 00:00:00	1984-11-13	1984-11-13 00:00:00	1984-11-13	581452		0	0	0		0	0	0	91263	0	10	40213160		
7234	607	1115171	2001-07-20	2001-07-20 00:00:00	2001-09-18	2001-09-18 00:00:00	2001-09-18	38000177		0	0	60		0	0	0	40299	0	849574	1115171		
8884	742	1127433	1975-05-19	1975-05-19 00:00:00	1975-06-09	1975-06-09 00:00:00	1975-06-09	38000177		0	0	21		0	0	0	49189	0	313782	1127433		
41525	3440	19006318	1945-11-19	1945-11-19 00:00:00	1945-12-03	1945-12-03 00:00:00	1945-12-03	38000177		0	0	14		0	0	0	228241	0	105078	19006318		
23878	518	40213160	1970-10-06	1970-10-06 00:00:00	1970-10-06	1970-10-06 00:00:00	1970-10-06	581452		0	0	0		0	0	0	34617	0	10	40213160		
52993	4403	1713671	1996-11-20	1996-11-20 00:00:00	1996-12-04	1996-12-04 00:00:00	1996-12-04	38000177		0	0	14		0	0	0	292698	0	562251	1713671		
9311	774	1713671	2006-03-23	2006-03-23 00:00:00	2006-03-30	2006-03-30 00:00:00	2006-03-30	38000177		0	0	7		0	0	0	51377	0	562251	1713671		
9345	776	1127433	2003-02-01	2003-02-01 00:00:00	2003-02-15	2003-02-15 00:00:00	2003-02-15	38000177		0	0	14		0	0	0	51571	0	313782	1127433		
52220	4343	1127433	2007-08-31	2007-08-31 00:00:00	2007-09-07	2007-09-07 00:00:00	2007-09-07	38000177		0	0	7		0	0	0	288013	0	313782	1127433		
47576	3943	1127433	2018-07-23	2018-07-23 00:00:00	2018-10-21	2018-10-21 00:00:00	2018-10-21	38000177		0	0	90		0	0	0	262139	0	313782	1127433		
46832	3879	19059056	1944-09-16	1944-09-16 00:00:00	1944-09-30	1944-09-30 00:00:00	1944-09-30	38000177		0	0	14		0	0	0	257654	0	243670	19059056		
21547	1770	19059056	1992-09-23	1992-09-23 00:00:00	1992-10-21	1992-10-21 00:00:00	1992-10-21	38000177		0	0	28		0	0	0	118375	0	243670	19059056		
46908	3885	19128065	1988-09-10	1988-09-10 00:00:00	1989-09-05	1989-09-05 00:00:00	1989-09-05	38000177		0	0	360		0	0	0	258232	0	749882	19128065		
32132	2663	1713671	2013-06-06	2013-06-06 00:00:00	2013-06-27	2013-06-27 00:00:00	2013-06-27	38000177		0	0	21		0	0	0	176479	0	562251	1713671		
144459	3176	40213160	1972-05-13	1972-05-13 00:00:00	1972-05-13	1972-05-13 00:00:00	1972-05-13	581452		0	0	0		0	0	0	211104	0	10	40213160		
21887	1794	19006318	1963-06-07	1963-06-07 00:00:00	1963-06-21	1963-06-21 00:00:00	1963-06-21	38000177		0	0	14		0	0	0	120286	0	105078	19006318		
42687	3537	46233988	1967-12-21	1967-12-21 00:00:00	1968-01-04	1968-01-04 00:00:00	1968-01-04	38000177		0	0	14		0	0	0	234956	0	1652673	46233988		
38535	841	40213198	2017-04-12	2017-04-12 00:00:00	2017-04-12	2017-04-12 00:00:00	2017-04-12	581452		0	0	0		0	0	0	55590	0	133	40213198		
41203	3417	1127433	1980-06-15	1980-06-15 00:00:00	1980-07-15	1980-07-15 00:00:00	1980-07-15	38000177		0	0	30		0	0	0	226624	0	313782	1127433		
42597	3531	920300	1994-05-08	1994-05-08 00:00:00	1994-05-15	1994-05-15 00:00:00	1994-05-15	38000177		0	0	7		0	0	0	234522	0	311989	920300		
61996	5157	19059056	1976-03-28	1976-03-28 00:00:00	1976-04-11	1976-04-11 00:00:00	1976-04-11	38000177		0	0	14		0	0	0	342915	0	243670	19059056		
205094	4501	40213314	1977-11-10	1977-11-10 00:00:00	1977-11-10	1977-11-10 00:00:00	1977-11-10	581452		0	0	0		0	0	0	299697	0	49	40213314		
11496	246	40213160	1960-08-04	1960-08-04 00:00:00	1960-08-04	1960-08-04 00:00:00	1960-08-04	581452		0	0	0		0	0	0	16509	0	10	40213160		
35392	2917	1713671	1987-12-26	1987-12-26 00:00:00	1988-01-02	1988-01-02 00:00:00	1988-01-02	38000177		0	0	7		0	0	0	194437	0	562251	1713671		
26059	2145	1127433	1978-07-27	1978-07-27 00:00:00	1978-08-03	1978-08-03 00:00:00	1978-08-03	38000177		0	0	7		0	0	0	142791	0	313782	1127433		
38997	851	40213314	1982-08-09	1982-08-09 00:00:00	1982-08-09	1982-08-09 00:00:00	1982-08-09	581452		0	0	0		0	0	0	56309	0	49	40213314		
5502	459	1118084	2008-07-12	2008-07-12 00:00:00	2008-07-12	2008-07-12 00:00:00	\N	38000177		0	0	0		0	0	0	30702	0	00025152531	44923712		
18945	1565	19006318	1968-05-25	1968-05-25 00:00:00	1968-06-08	1968-06-08 00:00:00	1968-06-08	38000177		0	0	14		0	0	0	104897	0	105078	19006318		
39459	3260	19006318	1962-01-22	1962-01-22 00:00:00	1962-02-05	1962-02-05 00:00:00	1962-02-05	38000177		0	0	14		0	0	0	216758	0	105078	19006318		
26101	2149	19078461	1990-09-19	1990-09-19 00:00:00	1990-10-10	1990-10-10 00:00:00	1990-10-10	38000177		0	0	21		0	0	0	143127	0	310965	19078461		
26141	2151	1332419	1994-08-17	1994-08-17 00:00:00	1994-08-17	1994-08-17 00:00:00	\N	38000177		0	0	0		0	0	0	143294	0	197361	1332419		
22369	1840	1713671	1985-11-19	1985-11-19 00:00:00	1985-12-10	1985-12-10 00:00:00	1985-12-10	38000177		0	0	21		0	0	0	122796	0	562251	1713671		
23396	1926	1127433	2000-01-06	2000-01-06 00:00:00	2000-01-20	2000-01-20 00:00:00	2000-01-20	38000177		0	0	14		0	0	0	128255	0	313782	1127433		
229216	5037	40213296	2019-02-27	2019-02-27 00:00:00	2019-02-27	2019-02-27 00:00:00	2019-02-27	581452		0	0	0		0	0	0	334823	0	52	40213296		
44458	3680	19008572	1989-05-18	1989-05-18 00:00:00	1989-06-01	1989-06-01 00:00:00	1989-06-01	38000177		0	0	14		0	0	0	244678	0	106258	19008572		
207967	4562	40213160	1961-07-08	1961-07-08 00:00:00	1961-07-08	1961-07-08 00:00:00	1961-07-08	581452		0	0	0		0	0	0	303959	0	10	40213160		
212426	4657	40213296	2002-01-11	2002-01-11 00:00:00	2002-01-11	2002-01-11 00:00:00	2002-01-11	581452		0	0	0		0	0	0	310529	0	52	40213296		
18603	1537	1127078	1961-05-26	1961-05-26 00:00:00	1961-06-09	1961-06-09 00:00:00	1961-06-09	38000177		0	0	14		0	0	0	102925	0	282464	1127078		
35980	785	40213160	1964-05-17	1964-05-17 00:00:00	1964-05-17	1964-05-17 00:00:00	1964-05-17	581452		0	0	0		0	0	0	52300	0	10	40213160		
47452	3934	1127433	1991-02-07	1991-02-07 00:00:00	1991-02-21	1991-02-21 00:00:00	1991-02-21	38000177		0	0	14		0	0	0	261505	0	313782	1127433		
8656	723	40231925	2013-12-21	2013-12-21 00:00:00	2013-12-21	2013-12-21 00:00:00	\N	38000177		0	0	0		0	0	0	47822	0	1049221	40231925		
29257	2423	1127433	1997-06-29	1997-06-29 00:00:00	1997-09-27	1997-09-27 00:00:00	1997-09-27	38000177		0	0	90		0	0	0	160767	0	313782	1127433		
174413	3835	40213296	2007-09-29	2007-09-29 00:00:00	2007-09-29	2007-09-29 00:00:00	2007-09-29	581452		0	0	0		0	0	0	254650	0	52	40213296		
4269	354	1127433	1968-12-27	1968-12-27 00:00:00	1969-01-17	1969-01-17 00:00:00	1969-01-17	38000177		0	0	21		0	0	0	23545	0	313782	1127433		
1224	97	45892894	2016-07-05	2016-07-05 00:00:00	2016-07-05	2016-07-05 00:00:00	\N	38000177		0	0	0		0	0	0	6621	0	1599803	45892894		
33503	2774	40231925	2011-03-27	2011-03-27 00:00:00	2011-03-27	2011-03-27 00:00:00	\N	38000177		0	0	0		0	0	0	183692	0	1049221	40231925		
58702	4874	1127433	1976-12-12	1976-12-12 00:00:00	1976-12-26	1976-12-26 00:00:00	1976-12-26	38000177		0	0	14		0	0	0	324159	0	313782	1127433		
11052	921	19128065	1980-06-17	1980-06-17 00:00:00	1981-06-12	1981-06-12 00:00:00	1981-06-12	38000177		0	0	360		0	0	0	61372	0	749882	19128065		
50502	4197	42902245	1999-09-12	1999-09-12 00:00:00	2000-09-06	2000-09-06 00:00:00	2000-09-06	38000177		0	0	360		0	0	0	278491	0	1359133	42902245		
29440	2437	1127433	1977-10-26	1977-10-26 00:00:00	1977-11-30	1977-11-30 00:00:00	1977-11-30	38000177		0	0	35		0	0	0	161668	0	313782	1127433		
37851	826	40213227	2000-07-27	2000-07-27 00:00:00	2000-07-27	2000-07-27 00:00:00	2000-07-27	581452		0	0	0		0	0	0	54744	0	113	40213227		
206827	4538	40213227	1995-05-26	1995-05-26 00:00:00	1995-05-26	1995-05-26 00:00:00	1995-05-26	581452		0	0	0		0	0	0	302347	0	113	40213227		
38841	3212	1367571	2018-07-21	2018-07-21 00:00:00	2018-07-21	2018-07-21 00:00:00	2018-07-21	38000177		0	0	0		0	0	0	213430	0	314659	19080464		
14084	304	40213160	1956-08-13	1956-08-13 00:00:00	1956-08-13	1956-08-13 00:00:00	1956-08-13	581452		0	0	0		0	0	0	20205	0	10	40213160		
56720	1242	40213306	1981-12-23	1981-12-23 00:00:00	1981-12-23	1981-12-23 00:00:00	1981-12-23	581452		0	0	0		0	0	0	81805	0	43	40213306		
23485	1934	1115171	2001-11-02	2001-11-02 00:00:00	2001-11-23	2001-11-23 00:00:00	2001-11-23	38000177		0	0	21		0	0	0	128625	0	849574	1115171		
46712	3869	19059056	1914-10-26	1914-10-26 00:00:00	1914-11-09	1914-11-09 00:00:00	1914-11-09	38000177		0	0	14		0	0	0	256914	0	243670	19059056		
58330	4847	1127078	1953-09-28	1953-09-28 00:00:00	1953-10-19	1953-10-19 00:00:00	1953-10-19	38000177		0	0	21		0	0	0	322424	0	282464	1127078		
5994	500	19059056	1971-04-19	1971-04-19 00:00:00	1971-05-10	1971-05-10 00:00:00	1971-05-10	38000177		0	0	21		0	0	0	33547	0	243670	19059056		
6038	505	19059056	1969-03-31	1969-03-31 00:00:00	1969-04-14	1969-04-14 00:00:00	1969-04-14	38000177		0	0	14		0	0	0	33763	0	243670	19059056		
165677	3641	40213227	1993-12-10	1993-12-10 00:00:00	1993-12-10	1993-12-10 00:00:00	1993-12-10	581452		0	0	0		0	0	0	242252	0	113	40213227		
11482	956	1118084	1975-10-13	1975-10-13 00:00:00	1975-10-13	1975-10-13 00:00:00	\N	38000177		0	0	0		0	0	0	63476	0	00025152531	44923712		
162657	3577	40213296	2003-03-10	2003-03-10 00:00:00	2003-03-10	2003-03-10 00:00:00	2003-03-10	581452		0	0	0		0	0	0	237834	0	52	40213296		
44736	3701	1127433	1986-09-16	1986-09-16 00:00:00	1986-10-14	1986-10-14 00:00:00	1986-10-14	38000177		0	0	28		0	0	0	246069	0	313782	1127433		
62937	1377	40213314	1980-03-11	1980-03-11 00:00:00	1980-03-11	1980-03-11 00:00:00	1980-03-11	581452		0	0	0		0	0	0	91275	0	49	40213314		
7235	607	1127433	2009-09-09	2009-09-09 00:00:00	2009-09-16	2009-09-16 00:00:00	2009-09-16	38000177		0	0	7		0	0	0	40280	0	313782	1127433		
8885	742	19133905	1990-03-29	1990-03-29 00:00:00	1990-04-09	1990-04-09 00:00:00	1990-04-09	38000177		0	0	11		0	0	0	49220	0	834102	19133905		
41526	3440	1115171	2014-09-20	2014-09-20 00:00:00	2014-10-04	2014-10-04 00:00:00	2014-10-04	38000177		0	0	14		0	0	0	228231	0	849574	1115171		
23879	518	40213296	2012-07-10	2012-07-10 00:00:00	2012-07-10	2012-07-10 00:00:00	2012-07-10	581452		0	0	0		0	0	0	34609	0	52	40213296		
52994	4403	1713671	1955-05-09	1955-05-09 00:00:00	1955-05-23	1955-05-23 00:00:00	1955-05-23	38000177		0	0	14		0	0	0	292720	0	562251	1713671		
9313	774	19074841	1983-03-27	1983-03-27 00:00:00	1983-04-10	1983-04-10 00:00:00	1983-04-10	38000177		0	0	14		0	0	0	51351	0	309043	19074841		
9346	776	40169281	2010-08-12	2010-08-12 00:00:00	2010-08-12	2010-08-12 00:00:00	\N	38000177		0	0	0		0	0	0	51583	0	896209	40169281		
31223	2588	40231925	1978-06-07	1978-06-07 00:00:00	1978-06-07	1978-06-07 00:00:00	\N	38000177		0	0	0		0	0	0	171309	0	1049221	40231925		
47577	3943	1127433	1986-02-11	1986-02-11 00:00:00	1986-03-13	1986-03-13 00:00:00	1986-03-13	38000177		0	0	30		0	0	0	262138	0	313782	1127433		
46833	3879	40229134	1996-10-13	1996-10-13 00:00:00	1996-10-20	1996-10-20 00:00:00	1996-10-20	38000177		0	0	7		0	0	0	257659	0	1043400	40229134		
21548	1770	19128022	1993-06-02	1993-06-02 00:00:00	1994-05-28	1994-05-28 00:00:00	1994-05-28	38000177		0	0	360		0	0	0	118352	0	749785	19128022		
46909	3885	1127433	1980-05-27	1980-05-27 00:00:00	1980-06-10	1980-06-10 00:00:00	1980-06-10	38000177		0	0	14		0	0	0	258297	0	313782	1127433		
32133	2663	1127433	1973-04-20	1973-04-20 00:00:00	1973-04-27	1973-04-27 00:00:00	1973-04-27	38000177		0	0	7		0	0	0	176443	0	313782	1127433		
144463	3176	40213160	1972-08-12	1972-08-12 00:00:00	1972-08-12	1972-08-12 00:00:00	1972-08-12	581452		0	0	0		0	0	0	211137	0	10	40213160		
21888	1794	1127078	1960-11-28	1960-11-28 00:00:00	1960-12-12	1960-12-12 00:00:00	1960-12-12	38000177		0	0	14		0	0	0	120305	0	282464	1127078		
42688	3537	40229134	2008-06-03	2008-06-03 00:00:00	2008-06-10	2008-06-10 00:00:00	2008-06-10	38000177		0	0	7		0	0	0	234939	0	1043400	40229134		
38543	841	40213296	1996-01-31	1996-01-31 00:00:00	1996-01-31	1996-01-31 00:00:00	1996-01-31	581452		0	0	0		0	0	0	55585	0	52	40213296		
41204	3417	40231925	1980-06-15	1980-06-15 00:00:00	1980-06-15	1980-06-15 00:00:00	\N	38000177		0	0	0		0	0	0	226624	0	1049221	40231925		
42598	3531	40236824	1994-05-08	1994-05-08 00:00:00	1994-05-15	1994-05-15 00:00:00	1994-05-15	38000177		0	0	7		0	0	0	234522	0	1094107	40236824		
61997	5157	1124300	2000-08-19	2000-08-19 00:00:00	2000-08-19	2000-08-19 00:00:00	\N	38000177		0	0	0		0	0	0	342939	0	00781178901	45011828		
205101	4501	40213160	1973-03-08	1973-03-08 00:00:00	1973-03-08	1973-03-08 00:00:00	1973-03-08	581452		0	0	0		0	0	0	299723	0	10	40213160		
25939	2134	1127433	1955-04-15	1955-04-15 00:00:00	1955-04-22	1955-04-22 00:00:00	1955-04-22	38000177		0	0	7		0	0	0	141985	0	313782	1127433		
35393	2917	1713671	1941-10-12	1941-10-12 00:00:00	1941-10-19	1941-10-19 00:00:00	1941-10-19	38000177		0	0	7		0	0	0	194466	0	562251	1713671		
26060	2145	1127433	1976-07-17	1976-07-17 00:00:00	1976-07-31	1976-07-31 00:00:00	1976-07-31	38000177		0	0	14		0	0	0	142793	0	313782	1127433		
39001	851	40213227	2012-08-13	2012-08-13 00:00:00	2012-08-13	2012-08-13 00:00:00	2012-08-13	581452		0	0	0		0	0	0	56289	0	113	40213227		
5503	459	19078461	1987-12-05	1987-12-05 00:00:00	1988-01-02	1988-01-02 00:00:00	1988-01-02	38000177		0	0	28		0	0	0	30713	0	310965	19078461		
18946	1565	1127433	1998-03-14	1998-03-14 00:00:00	1998-03-28	1998-03-28 00:00:00	1998-03-28	38000177		0	0	14		0	0	0	104919	0	313782	1127433		
39460	3260	19059056	1962-01-22	1962-01-22 00:00:00	1962-02-05	1962-02-05 00:00:00	1962-02-05	38000177		0	0	14		0	0	0	216758	0	243670	19059056		
26102	2149	1127433	1972-10-27	1972-10-27 00:00:00	1972-12-01	1972-12-01 00:00:00	1972-12-01	38000177		0	0	35		0	0	0	143076	0	313782	1127433		
26142	2151	19133768	1999-12-08	1999-12-08 00:00:00	1999-12-08	1999-12-08 00:00:00	1999-12-08	38000177		0	0	0		0	0	0	143282	0	833036	19133768		
22370	1840	1127078	1978-02-02	1978-02-02 00:00:00	1978-02-16	1978-02-16 00:00:00	1978-02-16	38000177		0	0	14		0	0	0	122827	0	282464	1127078		
23397	1926	1127078	1973-11-14	1973-11-14 00:00:00	1973-11-28	1973-11-28 00:00:00	1973-11-28	38000177		0	0	14		0	0	0	128246	0	282464	1127078		
229218	5037	40213227	2019-02-27	2019-02-27 00:00:00	2019-02-27	2019-02-27 00:00:00	2019-02-27	581452		0	0	0		0	0	0	334823	0	113	40213227		
44459	3680	19008572	2004-08-15	2004-08-15 00:00:00	2004-08-29	2004-08-29 00:00:00	2004-08-29	38000177		0	0	14		0	0	0	244714	0	106258	19008572		
207969	4562	40213227	2012-02-04	2012-02-04 00:00:00	2012-02-04	2012-02-04 00:00:00	2012-02-04	581452		0	0	0		0	0	0	304038	0	113	40213227		
212427	4657	40213160	1961-01-13	1961-01-13 00:00:00	1961-01-13	1961-01-13 00:00:00	1961-01-13	581452		0	0	0		0	0	0	310520	0	10	40213160		
18604	1537	19129655	1961-05-26	1961-05-26 00:00:00	1961-06-09	1961-06-09 00:00:00	1961-06-09	38000177		0	0	14		0	0	0	102925	0	789980	19129655		
35984	785	40213160	1964-03-15	1964-03-15 00:00:00	1964-03-15	1964-03-15 00:00:00	1964-03-15	581452		0	0	0		0	0	0	52274	0	10	40213160		
47453	3934	46275916	2005-11-16	2005-11-16 00:00:00	2005-11-16	2005-11-16 00:00:00	2005-11-16	38000177		0	0	0		0	0	0	261506	0	1660014	46275916		
5313	445	1118084	1953-11-30	1953-11-30 00:00:00	1953-11-30	1953-11-30 00:00:00	\N	38000177		0	0	0		0	0	0	29586	0	00025152531	44923712		
29258	2423	1124300	1997-09-02	1997-09-02 00:00:00	1997-09-02	1997-09-02 00:00:00	\N	38000177		0	0	0		0	0	0	160767	0	00781178901	45011828		
96142	2108	40213201	2005-12-09	2005-12-09 00:00:00	2005-12-09	2005-12-09 00:00:00	2005-12-09	581452		0	0	0		0	0	0	140352	0	33	40213201		
4270	354	19128065	1976-11-25	1976-11-25 00:00:00	1977-11-20	1977-11-20 00:00:00	1977-11-20	38000177		0	0	360		0	0	0	23553	0	749882	19128065		
1225	97	40229134	1999-07-06	1999-07-06 00:00:00	1999-07-20	1999-07-20 00:00:00	1999-07-20	38000177		0	0	14		0	0	0	6567	0	1043400	40229134		
33504	2774	1127433	1995-12-03	1995-12-03 00:00:00	1995-12-17	1995-12-17 00:00:00	1995-12-17	38000177		0	0	14		0	0	0	183705	0	313782	1127433		
58704	4874	19128065	1989-06-24	1989-06-24 00:00:00	1990-06-19	1990-06-19 00:00:00	1990-06-19	38000177		0	0	360		0	0	0	324172	0	749882	19128065		
11053	921	1713671	1998-08-07	1998-08-07 00:00:00	1998-08-14	1998-08-14 00:00:00	1998-08-14	38000177		0	0	7		0	0	0	61320	0	562251	1713671		
50503	4197	1127078	1990-10-10	1990-10-10 00:00:00	1990-10-24	1990-10-24 00:00:00	1990-10-24	38000177		0	0	14		0	0	0	278488	0	282464	1127078		
29441	2437	1127433	1995-05-13	1995-05-13 00:00:00	1995-05-20	1995-05-20 00:00:00	1995-05-20	38000177		0	0	7		0	0	0	161695	0	313782	1127433		
37854	826	40213227	1992-10-01	1992-10-01 00:00:00	1992-10-01	1992-10-01 00:00:00	1992-10-01	581452		0	0	0		0	0	0	54743	0	113	40213227		
206829	4538	40213296	1997-05-30	1997-05-30 00:00:00	1997-05-30	1997-05-30 00:00:00	1997-05-30	581452		0	0	0		0	0	0	302373	0	52	40213296		
38842	3212	19079524	2018-07-21	2018-07-21 00:00:00	2018-07-21	2018-07-21 00:00:00	2018-07-21	38000177		0	0	0		0	0	0	213430	0	313002	19079524		
14087	304	40213296	1996-05-13	1996-05-13 00:00:00	1996-05-13	1996-05-13 00:00:00	1996-05-13	581452		0	0	0		0	0	0	20203	0	52	40213296		
56730	1242	40213160	1959-08-19	1959-08-19 00:00:00	1959-08-19	1959-08-19 00:00:00	1959-08-19	581452		0	0	0		0	0	0	81800	0	10	40213160		
23486	1934	1127433	1992-04-11	1992-04-11 00:00:00	1992-04-25	1992-04-25 00:00:00	1992-04-25	38000177		0	0	14		0	0	0	128623	0	313782	1127433		
46713	3869	1127433	1981-11-11	1981-11-11 00:00:00	1981-11-25	1981-11-25 00:00:00	1981-11-25	38000177		0	0	14		0	0	0	256913	0	313782	1127433		
58331	4847	19059056	1959-09-18	1959-09-18 00:00:00	1959-10-09	1959-10-09 00:00:00	1959-10-09	38000177		0	0	21		0	0	0	322425	0	243670	19059056		
5995	500	1127078	1965-06-21	1965-06-21 00:00:00	1965-07-05	1965-07-05 00:00:00	1965-07-05	38000177		0	0	14		0	0	0	33545	0	282464	1127078		
6039	505	46233988	1969-03-31	1969-03-31 00:00:00	1969-04-14	1969-04-14 00:00:00	1969-04-14	38000177		0	0	14		0	0	0	33763	0	1652673	46233988		
35674	778	40213314	1978-06-29	1978-06-29 00:00:00	1978-06-29	1978-06-29 00:00:00	1978-06-29	581452		0	0	0		0	0	0	51658	0	49	40213314		
11483	956	1713671	2009-01-15	2009-01-15 00:00:00	2009-01-29	2009-01-29 00:00:00	2009-01-29	38000177		0	0	14		0	0	0	63445	0	562251	1713671		
158108	3481	40213251	1984-04-21	1984-04-21 00:00:00	1984-04-21	1984-04-21 00:00:00	1984-04-21	581452		0	0	0		0	0	0	230866	0	21	40213251		
44737	3701	1127433	2004-10-01	2004-10-01 00:00:00	2004-10-08	2004-10-08 00:00:00	2004-10-08	38000177		0	0	7		0	0	0	246080	0	313782	1127433		
62938	1377	40213160	1980-03-11	1980-03-11 00:00:00	1980-03-11	1980-03-11 00:00:00	1980-03-11	581452		0	0	0		0	0	0	91275	0	10	40213160		
7236	607	19059056	1960-03-27	1960-03-27 00:00:00	1960-04-10	1960-04-10 00:00:00	1960-04-10	38000177		0	0	14		0	0	0	40272	0	243670	19059056		
8886	742	40165015	1991-11-12	1991-11-12 00:00:00	1991-11-12	1991-11-12 00:00:00	\N	38000177		0	0	0		0	0	0	49190	0	861467	40165015		
41527	3440	1127433	1957-10-16	1957-10-16 00:00:00	1957-10-23	1957-10-23 00:00:00	1957-10-23	38000177		0	0	7		0	0	0	228275	0	313782	1127433		
23881	518	40213227	2012-07-10	2012-07-10 00:00:00	2012-07-10	2012-07-10 00:00:00	2012-07-10	581452		0	0	0		0	0	0	34609	0	113	40213227		
52995	4403	19059056	1943-11-15	1943-11-15 00:00:00	1944-02-13	1944-02-13 00:00:00	1944-02-13	38000177		0	0	90		0	0	0	292704	0	243670	19059056		
9314	774	1127433	1983-03-27	1983-03-27 00:00:00	1983-04-10	1983-04-10 00:00:00	1983-04-10	38000177		0	0	14		0	0	0	51351	0	313782	1127433		
9347	776	920300	1991-08-27	1991-08-27 00:00:00	1991-09-03	1991-09-03 00:00:00	1991-09-03	38000177		0	0	7		0	0	0	51508	0	311989	920300		
31224	2588	1127433	1978-06-07	1978-06-07 00:00:00	1978-09-05	1978-09-05 00:00:00	1978-09-05	38000177		0	0	90		0	0	0	171309	0	313782	1127433		
47578	3943	1713671	2013-11-16	2013-11-16 00:00:00	2013-11-30	2013-11-30 00:00:00	2013-11-30	38000177		0	0	14		0	0	0	262143	0	562251	1713671		
46835	3879	40173590	2010-04-08	2010-04-08 00:00:00	2010-04-08	2010-04-08 00:00:00	\N	38000177		0	0	0		0	0	0	257704	0	904419	40173590		
21564	1773	1551192	1967-10-04	1967-10-04 00:00:00	1967-10-04	1967-10-04 00:00:00	1967-10-04	38000177		0	0	0		0	0	0	118551	0	312617	1551192		
46910	3885	1127078	1963-11-11	1963-11-11 00:00:00	1963-12-02	1963-12-02 00:00:00	1963-12-02	38000177		0	0	21		0	0	0	258294	0	282464	1127078		
32134	2663	19007333	2007-08-21	2007-08-21 00:00:00	2011-05-02	2011-05-02 00:00:00	2011-05-02	38000177		0	0	1350		0	0	0	176485	0	105586	19007333		
144467	3176	40213296	2011-12-17	2011-12-17 00:00:00	2011-12-17	2011-12-17 00:00:00	2011-12-17	581452		0	0	0		0	0	0	211194	0	52	40213296		
21889	1794	19006318	1960-11-28	1960-11-28 00:00:00	1960-12-12	1960-12-12 00:00:00	1960-12-12	38000177		0	0	14		0	0	0	120305	0	105078	19006318		
42689	3537	1118084	2002-04-01	2002-04-01 00:00:00	2002-04-01	2002-04-01 00:00:00	\N	38000177		0	0	0		0	0	0	234951	0	00025152531	44923712		
38557	841	40213227	2013-03-20	2013-03-20 00:00:00	2013-03-20	2013-03-20 00:00:00	2013-03-20	581452		0	0	0		0	0	0	55534	0	113	40213227		
41205	3417	1127433	1914-09-20	1914-09-20 00:00:00	1914-09-27	1914-09-27 00:00:00	1914-09-27	38000177		0	0	7		0	0	0	226652	0	313782	1127433		
42599	3531	1713671	1994-01-27	1994-01-27 00:00:00	1994-02-03	1994-02-03 00:00:00	1994-02-03	38000177		0	0	7		0	0	0	234562	0	562251	1713671		
61998	5157	19129655	1965-02-11	1965-02-11 00:00:00	1965-02-25	1965-02-25 00:00:00	1965-02-25	38000177		0	0	14		0	0	0	342925	0	789980	19129655		
165885	3647	40213227	1997-12-24	1997-12-24 00:00:00	1997-12-24	1997-12-24 00:00:00	1997-12-24	581452		0	0	0		0	0	0	242708	0	113	40213227		
25940	2134	1127433	2014-09-19	2014-09-19 00:00:00	2014-10-03	2014-10-03 00:00:00	2014-10-03	38000177		0	0	14		0	0	0	142028	0	313782	1127433		
35394	2917	19077572	2017-02-15	2017-02-15 00:00:00	2017-02-15	2017-02-15 00:00:00	\N	38000177		0	0	0		0	0	0	194482	0	310436	19077572		
26061	2145	46233710	1976-07-17	1976-07-17 00:00:00	1976-07-31	1976-07-31 00:00:00	1976-07-31	38000177		0	0	14		0	0	0	142793	0	1650142	46233710		
39002	851	40213227	2003-08-04	2003-08-04 00:00:00	2003-08-04	2003-08-04 00:00:00	2003-08-04	581452		0	0	0		0	0	0	56317	0	113	40213227		
5504	459	1127433	1985-02-15	1985-02-15 00:00:00	1985-02-22	1985-02-22 00:00:00	1985-02-22	38000177		0	0	7		0	0	0	30672	0	313782	1127433		
18947	1565	1118084	1999-11-24	1999-11-24 00:00:00	1999-11-24	1999-11-24 00:00:00	\N	38000177		0	0	0		0	0	0	104925	0	00025152531	44923712		
39461	3260	1124300	1998-06-07	1998-06-07 00:00:00	1998-06-07	1998-06-07 00:00:00	\N	38000177		0	0	0		0	0	0	216737	0	00781178901	45011828		
26103	2149	1127433	2010-01-12	2010-01-12 00:00:00	2010-01-19	2010-01-19 00:00:00	2010-01-19	38000177		0	0	7		0	0	0	143079	0	313782	1127433		
26143	2151	1545959	1999-12-08	1999-12-08 00:00:00	1999-12-08	1999-12-08 00:00:00	1999-12-08	38000177		0	0	0		0	0	0	143282	0	259255	1545959		
22371	1840	1127433	2016-02-17	2016-02-17 00:00:00	2016-02-24	2016-02-24 00:00:00	2016-02-24	38000177		0	0	7		0	0	0	122825	0	313782	1127433		
23398	1926	1713671	1995-07-25	1995-07-25 00:00:00	1995-08-01	1995-08-01 00:00:00	1995-08-01	38000177		0	0	7		0	0	0	128254	0	562251	1713671		
229220	5037	40213251	1984-02-08	1984-02-08 00:00:00	1984-02-08	1984-02-08 00:00:00	1984-02-08	581452		0	0	0		0	0	0	334832	0	21	40213251		
44460	3680	19134077	2004-08-15	2004-08-15 00:00:00	2004-08-29	2004-08-29 00:00:00	2004-08-29	38000177		0	0	14		0	0	0	244714	0	835900	19134077		
207970	4562	40213260	2012-02-04	2012-02-04 00:00:00	2012-02-04	2012-02-04 00:00:00	2012-02-04	581452		0	0	0		0	0	0	304038	0	121	40213260		
212429	4657	40213227	2002-01-11	2002-01-11 00:00:00	2002-01-11	2002-01-11 00:00:00	2002-01-11	581452		0	0	0		0	0	0	310529	0	113	40213227		
18605	1537	40174880	2010-05-31	2010-05-31 00:00:00	2010-05-31	2010-05-31 00:00:00	\N	38000177		0	0	0		0	0	0	102871	0	966222	40174880		
35992	785	40213306	1986-02-09	1986-02-09 00:00:00	1986-02-09	1986-02-09 00:00:00	1986-02-09	581452		0	0	0		0	0	0	52281	0	43	40213306		
47454	3934	1310034	2005-11-16	2005-11-16 00:00:00	2005-11-16	2005-11-16 00:00:00	2005-11-16	38000177		0	0	0		0	0	0	261506	0	834357	1310034		
5314	445	19059056	1915-09-01	1915-09-01 00:00:00	1915-09-15	1915-09-15 00:00:00	1915-09-15	38000177		0	0	14		0	0	0	29634	0	243670	19059056		
29259	2423	19078461	1998-09-22	1998-09-22 00:00:00	1998-11-28	1998-11-28 00:00:00	1998-11-28	38000177		0	0	67		0	0	0	160768	0	310965	19078461		
96152	2108	40213227	2000-11-10	2000-11-10 00:00:00	2000-11-10	2000-11-10 00:00:00	2000-11-10	581452		0	0	0		0	0	0	140306	0	113	40213227		
4271	354	1127078	1957-12-25	1957-12-25 00:00:00	1958-01-08	1958-01-08 00:00:00	1958-01-08	38000177		0	0	14		0	0	0	23528	0	282464	1127078		
1226	97	1127433	2015-03-23	2015-03-23 00:00:00	2015-04-06	2015-04-06 00:00:00	2015-04-06	38000177		0	0	14		0	0	0	6649	0	313782	1127433		
33505	2774	19075601	1997-12-26	1997-12-26 00:00:00	1997-12-26	1997-12-26 00:00:00	\N	38000177		0	0	0		0	0	0	183650	0	309362	19075601		
58706	4874	19128022	1992-06-08	1992-06-08 00:00:00	1993-06-03	1993-06-03 00:00:00	1993-06-03	38000177		0	0	360		0	0	0	324165	0	749785	19128022		
11054	921	1713671	2015-03-29	2015-03-29 00:00:00	2015-04-12	2015-04-12 00:00:00	2015-04-12	38000177		0	0	14		0	0	0	61377	0	562251	1713671		
50504	4197	19073183	1990-10-10	1990-10-10 00:00:00	1990-10-24	1990-10-24 00:00:00	1990-10-24	38000177		0	0	14		0	0	0	278488	0	308182	19073183		
29442	2437	1124300	1998-10-17	1998-10-17 00:00:00	1998-10-17	1998-10-17 00:00:00	\N	38000177		0	0	0		0	0	0	161699	0	00781178901	45011828		
37857	826	40213260	2009-04-23	2009-04-23 00:00:00	2009-04-23	2009-04-23 00:00:00	2009-04-23	581452		0	0	0		0	0	0	54759	0	121	40213260		
206832	4538	40213227	2004-05-21	2004-05-21 00:00:00	2004-05-21	2004-05-21 00:00:00	2004-05-21	581452		0	0	0		0	0	0	302374	0	113	40213227		
38843	3212	35605482	2018-07-21	2018-07-21 00:00:00	2018-07-21	2018-07-21 00:00:00	2018-07-21	38000177		0	0	0		0	0	0	213430	0	1740467	35605482		
14098	304	40213260	2006-09-18	2006-09-18 00:00:00	2006-09-18	2006-09-18 00:00:00	2006-09-18	581452		0	0	0		0	0	0	20226	0	121	40213260		
56736	1242	40213160	1959-06-17	1959-06-17 00:00:00	1959-06-17	1959-06-17 00:00:00	1959-06-17	581452		0	0	0		0	0	0	81827	0	10	40213160		
23487	1934	1127433	1999-01-19	1999-01-19 00:00:00	1999-02-16	1999-02-16 00:00:00	1999-02-16	38000177		0	0	28		0	0	0	128624	0	313782	1127433		
46714	3869	40229134	1953-08-31	1953-08-31 00:00:00	1953-09-07	1953-09-07 00:00:00	1953-09-07	38000177		0	0	7		0	0	0	256929	0	1043400	40229134		
58332	4847	40229134	1996-04-11	1996-04-11 00:00:00	1996-04-18	1996-04-18 00:00:00	1996-04-18	38000177		0	0	7		0	0	0	322463	0	1043400	40229134		
44768	974	40213160	1957-03-03	1957-03-03 00:00:00	1957-03-03	1957-03-03 00:00:00	1957-03-03	581452		0	0	0		0	0	0	64935	0	10	40213160		
6040	505	40236824	1998-06-21	1998-06-21 00:00:00	1998-07-05	1998-07-05 00:00:00	1998-07-05	38000177		0	0	14		0	0	0	33761	0	1094107	40236824		
35675	778	40213160	1978-06-29	1978-06-29 00:00:00	1978-06-29	1978-06-29 00:00:00	1978-06-29	581452		0	0	0		0	0	0	51658	0	10	40213160		
11484	956	19059056	1952-05-27	1952-05-27 00:00:00	1952-06-17	1952-06-17 00:00:00	1952-06-17	38000177		0	0	21		0	0	0	63552	0	243670	19059056		
158120	3481	40213160	1978-01-07	1978-01-07 00:00:00	1978-01-07	1978-01-07 00:00:00	1978-01-07	581452		0	0	0		0	0	0	230841	0	10	40213160		
44751	3703	19078461	1982-01-24	1982-01-24 00:00:00	1982-03-25	1982-03-25 00:00:00	1982-03-25	38000177		0	0	60		0	0	0	246255	0	310965	19078461		
26245	2160	1713671	1981-07-27	1981-07-27 00:00:00	1981-08-03	1981-08-03 00:00:00	1981-08-03	38000177		0	0	7		0	0	0	143954	0	562251	1713671		
7237	607	19006318	1960-03-27	1960-03-27 00:00:00	1960-04-10	1960-04-10 00:00:00	1960-04-10	38000177		0	0	14		0	0	0	40272	0	105078	19006318		
8887	742	1127433	1991-11-12	1991-11-12 00:00:00	1992-01-11	1992-01-11 00:00:00	1992-01-11	38000177		0	0	60		0	0	0	49190	0	313782	1127433		
41528	3440	1127433	1954-02-18	1954-02-18 00:00:00	1954-03-04	1954-03-04 00:00:00	1954-03-04	38000177		0	0	14		0	0	0	228320	0	313782	1127433		
41533	3440	1115171	2015-10-29	2015-10-29 00:00:00	2015-11-28	2015-11-28 00:00:00	2015-11-28	38000177		0	0	30		0	0	0	228232	0	849574	1115171		
52996	4403	1127433	1969-02-21	1969-02-21 00:00:00	1969-03-07	1969-03-07 00:00:00	1969-03-07	38000177		0	0	14		0	0	0	292660	0	313782	1127433		
9315	774	1124300	2008-04-30	2008-04-30 00:00:00	2008-04-30	2008-04-30 00:00:00	\N	38000177		0	0	0		0	0	0	51378	0	00781178901	45011828		
9348	776	40236824	1991-08-27	1991-08-27 00:00:00	1991-09-03	1991-09-03 00:00:00	1991-09-03	38000177		0	0	7		0	0	0	51508	0	1094107	40236824		
31225	2588	1127078	1972-06-03	1972-06-03 00:00:00	1972-07-08	1972-07-08 00:00:00	1972-07-08	38000177		0	0	35		0	0	0	171308	0	282464	1127078		
47579	3943	1127078	1956-05-23	1956-05-23 00:00:00	1956-06-06	1956-06-06 00:00:00	1956-06-06	38000177		0	0	14		0	0	0	262144	0	282464	1127078		
46836	3879	19008572	1965-12-16	1965-12-16 00:00:00	1965-12-16	1965-12-16 00:00:00	\N	38000177		0	0	0		0	0	0	257730	0	106258	19008572		
21565	1773	1127433	1988-04-04	1988-04-04 00:00:00	1988-05-02	1988-05-02 00:00:00	1988-05-02	38000177		0	0	28		0	0	0	118552	0	313782	1127433		
46911	3885	1127433	2005-09-19	2005-09-19 00:00:00	2005-09-26	2005-09-26 00:00:00	2005-09-26	38000177		0	0	7		0	0	0	258258	0	313782	1127433		
32135	2663	19019273	2007-08-21	2007-08-21 00:00:00	2011-05-02	2011-05-02 00:00:00	2011-05-02	38000177		0	0	1350		0	0	0	176485	0	198014	19019273		
144472	3176	40213227	2014-03-15	2014-03-15 00:00:00	2014-03-15	2014-03-15 00:00:00	2014-03-15	581452		0	0	0		0	0	0	211195	0	113	40213227		
21890	1794	1127078	1961-02-13	1961-02-13 00:00:00	1961-02-27	1961-02-27 00:00:00	1961-02-27	38000177		0	0	14		0	0	0	120276	0	282464	1127078		
42690	3537	1127433	1998-10-09	1998-10-09 00:00:00	1998-10-23	1998-10-23 00:00:00	1998-10-23	38000177		0	0	14		0	0	0	234938	0	313782	1127433		
132287	2906	40213227	2005-05-21	2005-05-21 00:00:00	2005-05-21	2005-05-21 00:00:00	2005-05-21	581452		0	0	0		0	0	0	193662	0	113	40213227		
41206	3417	1713671	2016-03-25	2016-03-25 00:00:00	2016-04-15	2016-04-15 00:00:00	2016-04-15	38000177		0	0	21		0	0	0	226657	0	562251	1713671		
42600	3531	19059056	1969-01-17	1969-01-17 00:00:00	1969-04-17	1969-04-17 00:00:00	1969-04-17	38000177		0	0	90		0	0	0	234586	0	243670	19059056		
61999	5157	1127078	1965-02-11	1965-02-11 00:00:00	1965-02-25	1965-02-25 00:00:00	1965-02-25	38000177		0	0	14		0	0	0	342925	0	282464	1127078		
165905	3647	40213227	2008-04-30	2008-04-30 00:00:00	2008-04-30	2008-04-30 00:00:00	2008-04-30	581452		0	0	0		0	0	0	242683	0	113	40213227		
25941	2134	1127433	2000-08-14	2000-08-14 00:00:00	2000-09-11	2000-09-11 00:00:00	2000-09-11	38000177		0	0	28		0	0	0	141964	0	313782	1127433		
35395	2917	19078461	2013-08-19	2013-08-19 00:00:00	2013-09-16	2013-09-16 00:00:00	2013-09-16	38000177		0	0	28		0	0	0	194503	0	310965	19078461		
26062	2145	19078461	2015-06-05	2015-06-05 00:00:00	2015-06-19	2015-06-19 00:00:00	2015-06-19	38000177		0	0	14		0	0	0	142801	0	310965	19078461		
39003	851	40213306	2003-08-04	2003-08-04 00:00:00	2003-08-04	2003-08-04 00:00:00	2003-08-04	581452		0	0	0		0	0	0	56317	0	43	40213306		
5505	459	19059056	1975-05-07	1975-05-07 00:00:00	1975-06-11	1975-06-11 00:00:00	1975-06-11	38000177		0	0	35		0	0	0	30710	0	243670	19059056		
18948	1565	1127433	1998-11-25	1998-11-25 00:00:00	1998-12-09	1998-12-09 00:00:00	1998-12-09	38000177		0	0	14		0	0	0	104940	0	313782	1127433		
39463	3260	19059056	1961-04-27	1961-04-27 00:00:00	1961-05-18	1961-05-18 00:00:00	1961-05-18	38000177		0	0	21		0	0	0	216747	0	243670	19059056		
26104	2149	1551192	1959-10-15	1959-10-15 00:00:00	1959-10-15	1959-10-15 00:00:00	1959-10-15	38000177		0	0	0		0	0	0	143074	0	312617	1551192		
26144	2151	40220960	1992-12-09	1992-12-09 00:00:00	1992-12-09	1992-12-09 00:00:00	1992-12-09	38000177		0	0	0		0	0	0	143331	0	1804799	40220960		
22372	1840	1127078	1986-08-19	1986-08-19 00:00:00	1986-11-17	1986-11-17 00:00:00	1986-11-17	38000177		0	0	90		0	0	0	122840	0	282464	1127078		
23399	1926	19019979	1974-09-12	1974-09-12 00:00:00	1974-09-26	1974-09-26 00:00:00	1974-09-26	38000177		0	0	14		0	0	0	128247	0	198405	19019979		
229223	5037	40213296	2017-02-22	2017-02-22 00:00:00	2017-02-22	2017-02-22 00:00:00	2017-02-22	581452		0	0	0		0	0	0	334771	0	52	40213296		
44461	3680	1115171	1995-04-30	1995-04-30 00:00:00	1995-05-21	1995-05-21 00:00:00	1995-05-21	38000177		0	0	21		0	0	0	244720	0	849574	1115171		
207976	4562	40213306	1983-04-09	1983-04-09 00:00:00	1983-04-09	1983-04-09 00:00:00	1983-04-09	581452		0	0	0		0	0	0	304053	0	43	40213306		
212431	4657	40213227	1993-12-31	1993-12-31 00:00:00	1993-12-31	1993-12-31 00:00:00	1993-12-31	581452		0	0	0		0	0	0	310567	0	113	40213227		
18606	1537	1127433	1956-08-13	1956-08-13 00:00:00	1956-08-27	1956-08-27 00:00:00	1956-08-27	38000177		0	0	14		0	0	0	102846	0	313782	1127433		
35994	785	40213160	1964-08-16	1964-08-16 00:00:00	1964-08-16	1964-08-16 00:00:00	1964-08-16	581452		0	0	0		0	0	0	52275	0	10	40213160		
47455	3934	40243436	2005-11-16	2005-11-16 00:00:00	2005-11-16	2005-11-16 00:00:00	2005-11-16	38000177		0	0	0		0	0	0	261506	0	1190795	40243436		
5316	445	1127433	1968-03-15	1968-03-15 00:00:00	1968-03-22	1968-03-22 00:00:00	1968-03-22	38000177		0	0	7		0	0	0	29606	0	313782	1127433		
29260	2423	1713671	1957-08-26	1957-08-26 00:00:00	1957-09-09	1957-09-09 00:00:00	1957-09-09	38000177		0	0	14		0	0	0	160726	0	562251	1713671		
96160	2109	40213306	1992-01-26	1992-01-26 00:00:00	1992-01-26	1992-01-26 00:00:00	1992-01-26	581452		0	0	0		0	0	0	140458	0	43	40213306		
4272	354	19006318	1957-12-25	1957-12-25 00:00:00	1958-01-08	1958-01-08 00:00:00	1958-01-08	38000177		0	0	14		0	0	0	23528	0	105078	19006318		
1227	97	1115171	1995-08-25	1995-08-25 00:00:00	1995-09-22	1995-09-22 00:00:00	1995-09-22	38000177		0	0	28		0	0	0	6646	0	849574	1115171		
33506	2774	19126352	1997-12-26	1997-12-26 00:00:00	1997-12-26	1997-12-26 00:00:00	\N	38000177		0	0	0		0	0	0	183650	0	705129	19126352		
58707	4874	1713671	1975-03-09	1975-03-09 00:00:00	1975-03-23	1975-03-23 00:00:00	1975-03-23	38000177		0	0	14		0	0	0	324204	0	562251	1713671		
11055	921	19078461	2011-07-22	2011-07-22 00:00:00	2011-08-26	2011-08-26 00:00:00	2011-08-26	38000177		0	0	35		0	0	0	61387	0	310965	19078461		
50505	4197	19059056	1986-06-20	1986-06-20 00:00:00	1986-07-04	1986-07-04 00:00:00	1986-07-04	38000177		0	0	14		0	0	0	278516	0	243670	19059056		
187635	4121	40213201	1986-11-02	1986-11-02 00:00:00	1986-11-02	1986-11-02 00:00:00	1986-11-02	581452		0	0	0		0	0	0	273992	0	33	40213201		
37861	826	40213296	1998-07-23	1998-07-23 00:00:00	1998-07-23	1998-07-23 00:00:00	1998-07-23	581452		0	0	0		0	0	0	54719	0	52	40213296		
206835	4538	40213160	1955-04-22	1955-04-22 00:00:00	1955-04-22	1955-04-22 00:00:00	1955-04-22	581452		0	0	0		0	0	0	302342	0	10	40213160		
38844	3212	35605482	2018-07-21	2018-07-21 00:00:00	2018-07-21	2018-07-21 00:00:00	2018-07-21	38000177		0	0	0		0	0	0	213430	0	1740467	35605482		
14099	304	40213160	1960-12-05	1960-12-05 00:00:00	1960-12-05	1960-12-05 00:00:00	1960-12-05	581452		0	0	0		0	0	0	20279	0	10	40213160		
56742	1242	40213227	1994-01-05	1994-01-05 00:00:00	1994-01-05	1994-01-05 00:00:00	1994-01-05	581452		0	0	0		0	0	0	81816	0	113	40213227		
23488	1934	1127433	2013-01-22	2013-01-22 00:00:00	2013-01-29	2013-01-29 00:00:00	2013-01-29	38000177		0	0	7		0	0	0	128635	0	313782	1127433		
43359	946	40213260	2010-04-21	2010-04-21 00:00:00	2010-04-21	2010-04-21 00:00:00	2010-04-21	581452		0	0	0		0	0	0	62786	0	121	40213260		
58333	4847	40229134	1959-12-06	1959-12-06 00:00:00	1959-12-20	1959-12-20 00:00:00	1959-12-20	38000177		0	0	14		0	0	0	322442	0	1043400	40229134		
44772	974	40213260	2006-06-25	2006-06-25 00:00:00	2006-06-25	2006-06-25 00:00:00	2006-06-25	581452		0	0	0		0	0	0	64948	0	121	40213260		
6041	505	920300	1998-06-21	1998-06-21 00:00:00	1998-06-28	1998-06-28 00:00:00	1998-06-28	38000177		0	0	7		0	0	0	33761	0	311989	920300		
35677	778	40213160	1978-09-28	1978-09-28 00:00:00	1978-09-28	1978-09-28 00:00:00	1978-09-28	581452		0	0	0		0	0	0	51654	0	10	40213160		
11485	956	1127433	1945-04-15	1945-04-15 00:00:00	1945-04-22	1945-04-22 00:00:00	1945-04-22	38000177		0	0	7		0	0	0	63489	0	313782	1127433		
158122	3481	40213227	1999-07-03	1999-07-03 00:00:00	1999-07-03	1999-07-03 00:00:00	1999-07-03	581452		0	0	0		0	0	0	230879	0	113	40213227		
44752	3703	19059056	1969-01-22	1969-01-22 00:00:00	1969-02-05	1969-02-05 00:00:00	1969-02-05	38000177		0	0	14		0	0	0	246232	0	243670	19059056		
26246	2160	920334	1993-11-03	1993-11-03 00:00:00	1993-11-10	1993-11-10 00:00:00	1993-11-10	38000177		0	0	7		0	0	0	143979	0	311995	920334		
7238	607	19073188	1989-05-25	1989-05-25 00:00:00	1989-06-08	1989-06-08 00:00:00	1989-06-08	38000177		0	0	14		0	0	0	40340	0	308192	19073188		
8888	742	40229134	1926-06-10	1926-06-10 00:00:00	1926-06-24	1926-06-24 00:00:00	1926-06-24	38000177		0	0	14		0	0	0	49104	0	1043400	40229134		
41529	3440	1124300	1980-10-21	1980-10-21 00:00:00	1980-10-21	1980-10-21 00:00:00	\N	38000177		0	0	0		0	0	0	228248	0	00781178901	45011828		
41534	3440	19133905	1985-06-30	1985-06-30 00:00:00	1985-07-11	1985-07-11 00:00:00	1985-07-11	38000177		0	0	11		0	0	0	228261	0	834102	19133905		
52997	4403	1127433	1987-01-15	1987-01-15 00:00:00	1987-01-29	1987-01-29 00:00:00	1987-01-29	38000177		0	0	14		0	0	0	292710	0	313782	1127433		
9316	774	1127433	1985-08-14	1985-08-14 00:00:00	1985-08-28	1985-08-28 00:00:00	1985-08-28	38000177		0	0	14		0	0	0	51390	0	313782	1127433		
9349	776	19059056	1962-07-01	1962-07-01 00:00:00	1962-07-22	1962-07-22 00:00:00	1962-07-22	38000177		0	0	21		0	0	0	51568	0	243670	19059056		
31226	2588	40229134	1981-05-01	1981-05-01 00:00:00	1981-05-08	1981-05-08 00:00:00	1981-05-08	38000177		0	0	7		0	0	0	171286	0	1043400	40229134		
47580	3943	19006318	1956-05-23	1956-05-23 00:00:00	1956-06-06	1956-06-06 00:00:00	1956-06-06	38000177		0	0	14		0	0	0	262144	0	105078	19006318		
46837	3879	1118084	1981-03-23	1981-03-23 00:00:00	1981-03-23	1981-03-23 00:00:00	\N	38000177		0	0	0		0	0	0	257699	0	00025152531	44923712		
21566	1773	1127078	1957-04-26	1957-04-26 00:00:00	1957-05-10	1957-05-10 00:00:00	1957-05-10	38000177		0	0	14		0	0	0	118624	0	282464	1127078		
46912	3885	19133873	1973-06-17	1973-06-17 00:00:00	1973-06-26	1973-06-26 00:00:00	1973-06-26	38000177		0	0	9		0	0	0	258282	0	834061	19133873		
32136	2663	19133873	1974-10-19	1974-10-19 00:00:00	1974-10-29	1974-10-29 00:00:00	1974-10-29	38000177		0	0	10		0	0	0	176452	0	834061	19133873		
144473	3176	40213296	2014-03-15	2014-03-15 00:00:00	2014-03-15	2014-03-15 00:00:00	2014-03-15	581452		0	0	0		0	0	0	211195	0	52	40213296		
21891	1794	19129655	1961-02-13	1961-02-13 00:00:00	1961-02-27	1961-02-27 00:00:00	1961-02-27	38000177		0	0	14		0	0	0	120276	0	789980	19129655		
42701	3539	1713671	1998-12-05	1998-12-05 00:00:00	1998-12-26	1998-12-26 00:00:00	1998-12-26	38000177		0	0	21		0	0	0	235100	0	562251	1713671		
132316	2906	40213227	2015-07-18	2015-07-18 00:00:00	2015-07-18	2015-07-18 00:00:00	2015-07-18	581452		0	0	0		0	0	0	193707	0	113	40213227		
41207	3417	1713671	1928-07-01	1928-07-01 00:00:00	1928-07-08	1928-07-08 00:00:00	1928-07-08	38000177		0	0	7		0	0	0	226580	0	562251	1713671		
42601	3531	40165015	1979-05-25	1979-05-25 00:00:00	1979-05-25	1979-05-25 00:00:00	\N	38000177		0	0	0		0	0	0	234588	0	861467	40165015		
62000	5157	1713671	2004-11-04	2004-11-04 00:00:00	2004-11-18	2004-11-18 00:00:00	2004-11-18	38000177		0	0	14		0	0	0	342906	0	562251	1713671		
165907	3647	40213227	2018-06-27	2018-06-27 00:00:00	2018-06-27	2018-06-27 00:00:00	2018-06-27	581452		0	0	0		0	0	0	242691	0	113	40213227		
25942	2135	19008572	1968-02-10	1968-02-10 00:00:00	1968-02-10	1968-02-10 00:00:00	\N	38000177		0	0	0		0	0	0	142127	0	106258	19008572		
35396	2917	19059056	1939-01-20	1939-01-20 00:00:00	1939-02-03	1939-02-03 00:00:00	1939-02-03	38000177		0	0	14		0	0	0	194530	0	243670	19059056		
36521	3013	1127433	1986-12-21	1986-12-21 00:00:00	1987-01-04	1987-01-04 00:00:00	1987-01-04	38000177		0	0	14		0	0	0	200897	0	313782	1127433		
35547	2929	1118084	2014-08-22	2014-08-22 00:00:00	2014-08-22	2014-08-22 00:00:00	\N	38000177		0	0	0		0	0	0	195388	0	00025152531	44923712		
5516	461	1713671	2000-01-25	2000-01-25 00:00:00	2000-02-01	2000-02-01 00:00:00	2000-02-01	38000177		0	0	7		0	0	0	30781	0	562251	1713671		
18949	1565	1127433	1974-07-24	1974-07-24 00:00:00	1974-08-07	1974-08-07 00:00:00	1974-08-07	38000177		0	0	14		0	0	0	104970	0	313782	1127433		
39464	3260	1127433	2013-06-08	2013-06-08 00:00:00	2013-06-22	2013-06-22 00:00:00	2013-06-22	38000177		0	0	14		0	0	0	216753	0	313782	1127433		
30725	2546	1127078	1985-05-25	1985-05-25 00:00:00	1985-06-24	1985-06-24 00:00:00	1985-06-24	38000177		0	0	30		0	0	0	168459	0	282464	1127078		
26145	2151	40229134	1954-09-02	1954-09-02 00:00:00	1954-09-16	1954-09-16 00:00:00	1954-09-16	38000177		0	0	14		0	0	0	143284	0	1043400	40229134		
22373	1840	1118084	2016-12-29	2016-12-29 00:00:00	2016-12-29	2016-12-29 00:00:00	\N	38000177		0	0	0		0	0	0	122814	0	00025152531	44923712		
23400	1926	19129655	1974-09-12	1974-09-12 00:00:00	1974-09-26	1974-09-26 00:00:00	1974-09-26	38000177		0	0	14		0	0	0	128247	0	789980	19129655		
229226	5037	40213227	1999-06-02	1999-06-02 00:00:00	1999-06-02	1999-06-02 00:00:00	1999-06-02	581452		0	0	0		0	0	0	334837	0	113	40213227		
44462	3680	1124300	2018-05-13	2018-05-13 00:00:00	2018-05-13	2018-05-13 00:00:00	\N	38000177		0	0	0		0	0	0	244768	0	00781178901	45011828		
160968	3542	40213201	2003-07-05	2003-07-05 00:00:00	2003-07-05	2003-07-05 00:00:00	2003-07-05	581452		0	0	0		0	0	0	235290	0	33	40213201		
159478	3510	40213201	2001-09-07	2001-09-07 00:00:00	2001-09-07	2001-09-07 00:00:00	2001-09-07	581452		0	0	0		0	0	0	232853	0	33	40213201		
18607	1537	19075001	1994-02-13	1994-02-13 00:00:00	1994-02-27	1994-02-27 00:00:00	1994-02-27	38000177		0	0	14		0	0	0	102877	0	309097	19075001		
35996	785	40213227	1995-02-19	1995-02-19 00:00:00	1995-02-19	1995-02-19 00:00:00	1995-02-19	581452		0	0	0		0	0	0	52293	0	113	40213227		
47456	3934	46275916	1957-03-06	1957-03-06 00:00:00	1957-03-06	1957-03-06 00:00:00	1957-03-06	38000177		0	0	0		0	0	0	261501	0	1660014	46275916		
5317	445	19059056	1935-06-02	1935-06-02 00:00:00	1935-06-30	1935-06-30 00:00:00	1935-06-30	38000177		0	0	28		0	0	0	29637	0	243670	19059056		
29261	2423	1713671	1959-04-08	1959-04-08 00:00:00	1959-04-15	1959-04-15 00:00:00	1959-04-15	38000177		0	0	7		0	0	0	160725	0	562251	1713671		
96162	2109	40213227	1992-01-26	1992-01-26 00:00:00	1992-01-26	1992-01-26 00:00:00	1992-01-26	581452		0	0	0		0	0	0	140458	0	113	40213227		
4273	354	1127433	1989-10-29	1989-10-29 00:00:00	1989-11-19	1989-11-19 00:00:00	1989-11-19	38000177		0	0	21		0	0	0	23546	0	313782	1127433		
1228	97	40236824	1973-01-28	1973-01-28 00:00:00	1973-02-04	1973-02-04 00:00:00	1973-02-04	38000177		0	0	7		0	0	0	6565	0	1094107	40236824		
33507	2774	1332419	1997-12-26	1997-12-26 00:00:00	1997-12-26	1997-12-26 00:00:00	\N	38000177		0	0	0		0	0	0	183650	0	197361	1332419		
58708	4874	40231925	2006-11-28	2006-11-28 00:00:00	2006-11-28	2006-11-28 00:00:00	\N	38000177		0	0	0		0	0	0	324208	0	1049221	40231925		
11056	921	19059056	1971-01-10	1971-01-10 00:00:00	1971-02-07	1971-02-07 00:00:00	1971-02-07	38000177		0	0	28		0	0	0	61342	0	243670	19059056		
50506	4197	19078461	2009-12-08	2009-12-08 00:00:00	2010-02-13	2010-02-13 00:00:00	2010-02-13	38000177		0	0	67		0	0	0	278540	0	310965	19078461		
9271	771	19128065	1978-11-05	1978-11-05 00:00:00	1979-10-31	1979-10-31 00:00:00	1979-10-31	38000177		0	0	360		0	0	0	51226	0	749882	19128065		
37867	826	40213260	2010-04-29	2010-04-29 00:00:00	2010-04-29	2010-04-29 00:00:00	2010-04-29	581452		0	0	0		0	0	0	54750	0	121	40213260		
206846	4538	40213198	2018-08-10	2018-08-10 00:00:00	2018-08-10	2018-08-10 00:00:00	2018-08-10	581452		0	0	0		0	0	0	302359	0	133	40213198		
49303	4090	19059056	1964-03-04	1964-03-04 00:00:00	1964-03-25	1964-03-25 00:00:00	1964-03-25	38000177		0	0	21		0	0	0	271935	0	243670	19059056		
94596	2075	40213296	2005-12-06	2005-12-06 00:00:00	2005-12-06	2005-12-06 00:00:00	2005-12-06	581452		0	0	0		0	0	0	138014	0	52	40213296		
115303	2534	40213160	1973-01-02	1973-01-02 00:00:00	1973-01-02	1973-01-02 00:00:00	1973-01-02	581452		0	0	0		0	0	0	167405	0	10	40213160		
23489	1934	1124300	2000-08-12	2000-08-12 00:00:00	2000-08-12	2000-08-12 00:00:00	\N	38000177		0	0	0		0	0	0	128663	0	00781178901	45011828		
43364	946	40213160	1960-12-14	1960-12-14 00:00:00	1960-12-14	1960-12-14 00:00:00	1960-12-14	581452		0	0	0		0	0	0	62779	0	10	40213160		
58334	4847	1124300	1977-07-08	1977-07-08 00:00:00	1977-07-08	1977-07-08 00:00:00	\N	38000177		0	0	0		0	0	0	322413	0	00781178901	45011828		
44777	974	40213160	1956-09-30	1956-09-30 00:00:00	1956-09-30	1956-09-30 00:00:00	1956-09-30	581452		0	0	0		0	0	0	64934	0	10	40213160		
6042	505	40232448	1970-06-25	1970-06-25 00:00:00	1970-06-25	1970-06-25 00:00:00	\N	38000177		0	0	0		0	0	0	33735	0	1049630	40232448		
35679	778	40213227	2000-05-11	2000-05-11 00:00:00	2000-05-11	2000-05-11 00:00:00	2000-05-11	581452		0	0	0		0	0	0	51676	0	113	40213227		
11486	956	1127433	2001-03-24	2001-03-24 00:00:00	2001-04-07	2001-04-07 00:00:00	2001-04-07	38000177		0	0	14		0	0	0	63543	0	313782	1127433		
158124	3481	40213306	1999-07-03	1999-07-03 00:00:00	1999-07-03	1999-07-03 00:00:00	1999-07-03	581452		0	0	0		0	0	0	230879	0	43	40213306		
44753	3703	46233988	1969-01-22	1969-01-22 00:00:00	1969-02-05	1969-02-05 00:00:00	1969-02-05	38000177		0	0	14		0	0	0	246232	0	1652673	46233988		
26247	2160	1127433	1982-09-14	1982-09-14 00:00:00	1982-09-28	1982-09-28 00:00:00	1982-09-28	38000177		0	0	14		0	0	0	143918	0	313782	1127433		
7239	607	1127433	1989-05-25	1989-05-25 00:00:00	1989-06-08	1989-06-08 00:00:00	1989-06-08	38000177		0	0	14		0	0	0	40340	0	313782	1127433		
8889	742	19059056	1930-09-16	1930-09-16 00:00:00	1930-09-30	1930-09-30 00:00:00	1930-09-30	38000177		0	0	14		0	0	0	49141	0	243670	19059056		
41530	3440	19133905	1980-12-12	1980-12-12 00:00:00	1980-12-22	1980-12-22 00:00:00	1980-12-22	38000177		0	0	10		0	0	0	228260	0	834102	19133905		
41535	3440	40174880	2015-02-20	2015-02-20 00:00:00	2015-02-20	2015-02-20 00:00:00	\N	38000177		0	0	0		0	0	0	228239	0	966222	40174880		
53001	4405	1127433	1996-04-28	1996-04-28 00:00:00	1996-05-05	1996-05-05 00:00:00	1996-05-05	38000177		0	0	7		0	0	0	292786	0	313782	1127433		
9317	775	40165015	2016-05-31	2016-05-31 00:00:00	2016-05-31	2016-05-31 00:00:00	\N	38000177		0	0	0		0	0	0	51436	0	861467	40165015		
9350	776	19133873	1971-05-28	1971-05-28 00:00:00	1971-06-10	1971-06-10 00:00:00	1971-06-10	38000177		0	0	13		0	0	0	51514	0	834061	19133873		
31227	2589	1115171	2016-10-08	2016-10-08 00:00:00	2016-10-22	2016-10-22 00:00:00	2016-10-22	38000177		0	0	14		0	0	0	171330	0	849574	1115171		
47581	3943	1713671	2005-06-05	2005-06-05 00:00:00	2005-06-26	2005-06-26 00:00:00	2005-06-26	38000177		0	0	21		0	0	0	262152	0	562251	1713671		
46838	3879	1127433	1984-10-05	1984-10-05 00:00:00	1984-10-12	1984-10-12 00:00:00	1984-10-12	38000177		0	0	7		0	0	0	257744	0	313782	1127433		
21567	1773	19006318	1957-04-26	1957-04-26 00:00:00	1957-05-10	1957-05-10 00:00:00	1957-05-10	38000177		0	0	14		0	0	0	118624	0	105078	19006318		
46913	3885	1127433	1987-11-29	1987-11-29 00:00:00	1987-12-20	1987-12-20 00:00:00	1987-12-20	38000177		0	0	21		0	0	0	258217	0	313782	1127433		
39135	3234	19133905	1976-09-20	1976-09-20 00:00:00	1976-10-02	1976-10-02 00:00:00	1976-10-02	38000177		0	0	12		0	0	0	214925	0	834102	19133905		
4655	387	19128065	1991-08-07	1991-08-07 00:00:00	1992-08-01	1992-08-01 00:00:00	1992-08-01	38000177		0	0	360		0	0	0	25474	0	749882	19128065		
21892	1794	1118084	1996-01-19	1996-01-19 00:00:00	1996-01-19	1996-01-19 00:00:00	\N	38000177		0	0	0		0	0	0	120292	0	00025152531	44923712		
42702	3539	40229134	2000-10-14	2000-10-14 00:00:00	2000-10-28	2000-10-28 00:00:00	2000-10-28	38000177		0	0	14		0	0	0	235105	0	1043400	40229134		
132326	2906	40213227	1996-03-30	1996-03-30 00:00:00	1996-03-30	1996-03-30 00:00:00	1996-03-30	581452		0	0	0		0	0	0	193661	0	113	40213227		
41208	3417	40173590	1999-09-04	1999-09-04 00:00:00	1999-09-04	1999-09-04 00:00:00	\N	38000177		0	0	0		0	0	0	226701	0	904419	40173590		
42602	3531	19078461	1979-05-25	1979-05-25 00:00:00	1979-06-24	1979-06-24 00:00:00	1979-06-24	38000177		0	0	30		0	0	0	234588	0	310965	19078461		
62001	5157	19006318	1966-12-08	1966-12-08 00:00:00	1966-12-22	1966-12-22 00:00:00	1966-12-22	38000177		0	0	14		0	0	0	342926	0	105078	19006318		
51465	4278	1115171	1995-06-08	1995-06-08 00:00:00	1995-06-22	1995-06-22 00:00:00	1995-06-22	38000177		0	0	14		0	0	0	283934	0	849574	1115171		
25943	2135	19059056	1963-06-18	1963-06-18 00:00:00	1963-07-02	1963-07-02 00:00:00	1963-07-02	38000177		0	0	14		0	0	0	142101	0	243670	19059056		
35397	2917	19133905	1990-02-08	1990-02-08 00:00:00	1990-02-15	1990-02-15 00:00:00	1990-02-15	38000177		0	0	7		0	0	0	194496	0	834102	19133905		
36522	3013	1127433	2005-02-22	2005-02-22 00:00:00	2005-03-08	2005-03-08 00:00:00	2005-03-08	38000177		0	0	14		0	0	0	200905	0	313782	1127433		
35548	2929	1127433	2004-10-05	2004-10-05 00:00:00	2004-10-19	2004-10-19 00:00:00	2004-10-19	38000177		0	0	14		0	0	0	195412	0	313782	1127433		
5517	461	1127433	1993-02-07	1993-02-07 00:00:00	1993-02-14	1993-02-14 00:00:00	1993-02-14	38000177		0	0	7		0	0	0	30816	0	313782	1127433		
18950	1565	1127433	2017-08-18	2017-08-18 00:00:00	2017-09-01	2017-09-01 00:00:00	2017-09-01	38000177		0	0	14		0	0	0	104941	0	313782	1127433		
39465	3260	40229134	1983-02-02	1983-02-02 00:00:00	1983-02-09	1983-02-09 00:00:00	1983-02-09	38000177		0	0	7		0	0	0	216759	0	1043400	40229134		
30726	2546	1127078	1976-08-19	1976-08-19 00:00:00	1976-09-02	1976-09-02 00:00:00	1976-09-02	38000177		0	0	14		0	0	0	168483	0	282464	1127078		
26146	2151	1539411	1991-07-31	1991-07-31 00:00:00	1991-07-31	1991-07-31 00:00:00	\N	38000177		0	0	0		0	0	0	143278	0	312961	1539411		
22374	1840	1127433	2006-09-04	2006-09-04 00:00:00	2006-09-18	2006-09-18 00:00:00	2006-09-18	38000177		0	0	14		0	0	0	122800	0	313782	1127433		
33865	2801	1713671	1923-06-17	1923-06-17 00:00:00	1923-06-24	1923-06-24 00:00:00	1923-06-24	38000177		0	0	7		0	0	0	185637	0	562251	1713671		
229227	5037	40213306	1999-06-02	1999-06-02 00:00:00	1999-06-02	1999-06-02 00:00:00	1999-06-02	581452		0	0	0		0	0	0	334837	0	43	40213306		
44463	3680	1551192	1979-11-29	1979-11-29 00:00:00	1979-11-29	1979-11-29 00:00:00	1979-11-29	38000177		0	0	0		0	0	0	244780	0	312617	1551192		
160978	3542	40213227	2018-09-29	2018-09-29 00:00:00	2018-09-29	2018-09-29 00:00:00	2018-09-29	581452		0	0	0		0	0	0	235281	0	113	40213227		
170767	3754	40213260	2010-01-05	2010-01-05 00:00:00	2010-01-05	2010-01-05 00:00:00	2010-01-05	581452		0	0	0		0	0	0	249457	0	121	40213260		
18608	1537	1115171	1994-02-13	1994-02-13 00:00:00	1994-02-27	1994-02-27 00:00:00	1994-02-27	38000177		0	0	14		0	0	0	102877	0	849574	1115171		
35998	785	40213160	1968-11-17	1968-11-17 00:00:00	1968-11-17	1968-11-17 00:00:00	1968-11-17	581452		0	0	0		0	0	0	52258	0	10	40213160		
47457	3934	40243436	1957-03-06	1957-03-06 00:00:00	1957-03-06	1957-03-06 00:00:00	1957-03-06	38000177		0	0	0		0	0	0	261501	0	1190795	40243436		
5318	445	19074679	1925-09-18	1925-09-18 00:00:00	1927-07-01	1927-07-01 00:00:00	1927-07-01	38000177		0	0	651		0	0	0	29635	0	308971	19074679		
29262	2423	1127433	1987-11-30	1987-11-30 00:00:00	1987-12-28	1987-12-28 00:00:00	1987-12-28	38000177		0	0	28		0	0	0	160764	0	313782	1127433		
96164	2109	40213227	2001-02-04	2001-02-04 00:00:00	2001-02-04	2001-02-04 00:00:00	2001-02-04	581452		0	0	0		0	0	0	140420	0	113	40213227		
4274	354	19078461	2008-06-12	2008-06-12 00:00:00	2008-07-03	2008-07-03 00:00:00	2008-07-03	38000177		0	0	21		0	0	0	23547	0	310965	19078461		
1229	97	920300	1973-01-28	1973-01-28 00:00:00	1973-02-04	1973-02-04 00:00:00	1973-02-04	38000177		0	0	7		0	0	0	6565	0	311989	920300		
33508	2774	1539411	1997-12-26	1997-12-26 00:00:00	1997-12-26	1997-12-26 00:00:00	\N	38000177		0	0	0		0	0	0	183650	0	312961	1539411		
58709	4874	1118084	2004-02-11	2004-02-11 00:00:00	2004-02-11	2004-02-11 00:00:00	\N	38000177		0	0	0		0	0	0	324195	0	00025152531	44923712		
11057	921	19059056	1972-03-03	1972-03-03 00:00:00	1972-03-31	1972-03-31 00:00:00	1972-03-31	38000177		0	0	28		0	0	0	61343	0	243670	19059056		
50507	4197	1118084	2017-04-30	2017-04-30 00:00:00	2017-04-30	2017-04-30 00:00:00	\N	38000177		0	0	0		0	0	0	278533	0	00025152531	44923712		
9272	771	40162522	1971-12-04	1971-12-04 00:00:00	1971-12-04	1971-12-04 00:00:00	\N	38000177		0	0	0		0	0	0	51185	0	857005	40162522		
37869	826	40213227	2010-04-29	2010-04-29 00:00:00	2010-04-29	2010-04-29 00:00:00	2010-04-29	581452		0	0	0		0	0	0	54750	0	113	40213227		
206849	4538	40213160	1958-04-25	1958-04-25 00:00:00	1958-04-25	1958-04-25 00:00:00	1958-04-25	581452		0	0	0		0	0	0	302343	0	10	40213160		
49304	4090	1127433	1957-03-11	1957-03-11 00:00:00	1957-06-09	1957-06-09 00:00:00	1957-06-09	38000177		0	0	90		0	0	0	271934	0	313782	1127433		
94602	2075	40213306	1988-07-12	1988-07-12 00:00:00	1988-07-12	1988-07-12 00:00:00	1988-07-12	581452		0	0	0		0	0	0	138042	0	43	40213306		
115310	2534	40213227	1994-09-27	1994-09-27 00:00:00	1994-09-27	1994-09-27 00:00:00	1994-09-27	581452		0	0	0		0	0	0	167418	0	113	40213227		
23490	1934	19129655	1963-12-03	1963-12-03 00:00:00	1963-12-17	1963-12-17 00:00:00	1963-12-17	38000177		0	0	14		0	0	0	128637	0	789980	19129655		
43365	946	40213160	1960-09-14	1960-09-14 00:00:00	1960-09-14	1960-09-14 00:00:00	1960-09-14	581452		0	0	0		0	0	0	62834	0	10	40213160		
58335	4847	1127433	1969-11-06	1969-11-06 00:00:00	1969-11-27	1969-11-27 00:00:00	1969-11-27	38000177		0	0	21		0	0	0	322427	0	313782	1127433		
44779	974	40213160	1961-06-04	1961-06-04 00:00:00	1961-06-04	1961-06-04 00:00:00	1961-06-04	581452		0	0	0		0	0	0	64979	0	10	40213160		
6043	505	1127433	2013-11-06	2013-11-06 00:00:00	2013-11-20	2013-11-20 00:00:00	2013-11-20	38000177		0	0	14		0	0	0	33791	0	313782	1127433		
35680	778	40213306	2000-05-11	2000-05-11 00:00:00	2000-05-11	2000-05-11 00:00:00	2000-05-11	581452		0	0	0		0	0	0	51676	0	43	40213306		
11487	956	19059056	1950-04-08	1950-04-08 00:00:00	1950-06-07	1950-06-07 00:00:00	1950-06-07	38000177		0	0	60		0	0	0	63551	0	243670	19059056		
158126	3481	40213314	1977-10-08	1977-10-08 00:00:00	1977-10-08	1977-10-08 00:00:00	1977-10-08	581452		0	0	0		0	0	0	230863	0	49	40213314		
44754	3703	1127433	1999-07-24	1999-07-24 00:00:00	1999-08-07	1999-08-07 00:00:00	1999-08-07	38000177		0	0	14		0	0	0	246257	0	313782	1127433		
26248	2160	1118084	1998-07-22	1998-07-22 00:00:00	1998-07-22	1998-07-22 00:00:00	\N	38000177		0	0	0		0	0	0	143938	0	00025152531	44923712		
7240	607	1127433	1977-11-04	1977-11-04 00:00:00	1977-11-11	1977-11-11 00:00:00	1977-11-11	38000177		0	0	7		0	0	0	40326	0	313782	1127433		
8890	742	19133873	1933-07-29	1933-07-29 00:00:00	1933-08-10	1933-08-10 00:00:00	1933-08-10	38000177		0	0	12		0	0	0	49106	0	834061	19133873		
41531	3440	1713671	2004-07-22	2004-07-22 00:00:00	2004-08-05	2004-08-05 00:00:00	2004-08-05	38000177		0	0	14		0	0	0	228326	0	562251	1713671		
41536	3440	1127433	1998-09-20	1998-09-20 00:00:00	1998-10-25	1998-10-25 00:00:00	1998-10-25	38000177		0	0	35		0	0	0	228228	0	313782	1127433		
53002	4405	40236446	1977-02-13	1977-02-13 00:00:00	1982-02-22	1982-02-22 00:00:00	1982-02-22	38000177		0	0	1835		0	0	0	292784	0	1091392	40236446		
9318	775	40236824	1966-12-13	1966-12-13 00:00:00	1966-12-20	1966-12-20 00:00:00	1966-12-20	38000177		0	0	7		0	0	0	51420	0	1094107	40236824		
9361	778	40229134	1990-03-18	1990-03-18 00:00:00	1990-03-25	1990-03-25 00:00:00	1990-03-25	38000177		0	0	7		0	0	0	51642	0	1043400	40229134		
31228	2589	1118084	2015-10-30	2015-10-30 00:00:00	2015-10-30	2015-10-30 00:00:00	\N	38000177		0	0	0		0	0	0	171328	0	00025152531	44923712		
47582	3943	1127433	1962-08-21	1962-08-21 00:00:00	1962-08-28	1962-08-28 00:00:00	1962-08-28	38000177		0	0	7		0	0	0	262165	0	313782	1127433		
46839	3879	1713671	2014-04-26	2014-04-26 00:00:00	2014-05-17	2014-05-17 00:00:00	2014-05-17	38000177		0	0	21		0	0	0	257747	0	562251	1713671		
21568	1773	19059056	1966-08-07	1966-08-07 00:00:00	1966-08-28	1966-08-28 00:00:00	1966-08-28	38000177		0	0	21		0	0	0	118550	0	243670	19059056		
46914	3885	19128065	1984-10-01	1984-10-01 00:00:00	1985-09-26	1985-09-26 00:00:00	1985-09-26	38000177		0	0	360		0	0	0	258285	0	749882	19128065		
39136	3234	19075601	1997-10-27	1997-10-27 00:00:00	2010-01-19	2010-01-19 00:00:00	2010-01-19	38000177		0	0	4467		0	0	0	214955	0	309362	19075601		
4656	387	19133873	1979-05-18	1979-05-18 00:00:00	1979-05-31	1979-05-31 00:00:00	1979-05-31	38000177		0	0	13		0	0	0	25487	0	834061	19133873		
21893	1794	19129655	1961-09-13	1961-09-13 00:00:00	1961-09-27	1961-09-27 00:00:00	1961-09-27	38000177		0	0	14		0	0	0	120277	0	789980	19129655		
42703	3539	1115171	1996-03-23	1996-03-23 00:00:00	1996-04-13	1996-04-13 00:00:00	1996-04-13	38000177		0	0	21		0	0	0	235092	0	849574	1115171		
16084	347	40213160	1970-06-28	1970-06-28 00:00:00	1970-06-28	1970-06-28 00:00:00	1970-06-28	581452		0	0	0		0	0	0	23082	0	10	40213160		
41209	3417	19059056	1937-04-20	1937-04-20 00:00:00	1937-05-11	1937-05-11 00:00:00	1937-05-11	38000177		0	0	21		0	0	0	226622	0	243670	19059056		
42603	3531	19128065	1984-03-09	1984-03-09 00:00:00	1985-03-04	1985-03-04 00:00:00	1985-03-04	38000177		0	0	360		0	0	0	234551	0	749882	19128065		
62002	5157	19059056	1966-12-08	1966-12-08 00:00:00	1966-12-22	1966-12-22 00:00:00	1966-12-22	38000177		0	0	14		0	0	0	342926	0	243670	19059056		
51466	4278	1713671	1957-11-16	1957-11-16 00:00:00	1957-12-07	1957-12-07 00:00:00	1957-12-07	38000177		0	0	21		0	0	0	283880	0	562251	1713671		
25944	2135	19059056	1969-07-14	1969-07-14 00:00:00	1969-08-11	1969-08-11 00:00:00	1969-08-11	38000177		0	0	28		0	0	0	142103	0	243670	19059056		
35398	2917	45892894	2019-03-07	2019-03-07 00:00:00	2019-03-07	2019-03-07 00:00:00	\N	38000177		0	0	0		0	0	0	194500	0	1599803	45892894		
36523	3013	1127078	1951-09-23	1951-09-23 00:00:00	1951-10-07	1951-10-07 00:00:00	1951-10-07	38000177		0	0	14		0	0	0	200954	0	282464	1127078		
35549	2929	1127433	1990-10-22	1990-10-22 00:00:00	1990-12-28	1990-12-28 00:00:00	1990-12-28	38000177		0	0	67		0	0	0	195377	0	313782	1127433		
5518	461	19133873	1954-07-15	1954-07-15 00:00:00	1954-07-24	1954-07-24 00:00:00	1954-07-24	38000177		0	0	9		0	0	0	30806	0	834061	19133873		
18951	1565	1713671	1965-08-18	1965-08-18 00:00:00	1965-09-08	1965-09-08 00:00:00	1965-09-08	38000177		0	0	21		0	0	0	104949	0	562251	1713671		
39466	3260	1127433	1994-03-31	1994-03-31 00:00:00	1994-04-14	1994-04-14 00:00:00	1994-04-14	38000177		0	0	14		0	0	0	216706	0	313782	1127433		
30727	2546	46233988	1976-08-19	1976-08-19 00:00:00	1976-09-02	1976-09-02 00:00:00	1976-09-02	38000177		0	0	14		0	0	0	168483	0	1652673	46233988		
26147	2151	1713671	1940-11-18	1940-11-18 00:00:00	1940-12-02	1940-12-02 00:00:00	1940-12-02	38000177		0	0	14		0	0	0	143256	0	562251	1713671		
22375	1840	40229134	2017-07-20	2017-07-20 00:00:00	2017-07-27	2017-07-27 00:00:00	2017-07-27	38000177		0	0	7		0	0	0	122826	0	1043400	40229134		
33866	2802	19133768	1997-12-13	1997-12-13 00:00:00	1997-12-13	1997-12-13 00:00:00	1997-12-13	38000177		0	0	0		0	0	0	185715	0	833036	19133768		
229235	5037	40213314	1977-07-27	1977-07-27 00:00:00	1977-07-27	1977-07-27 00:00:00	1977-07-27	581452		0	0	0		0	0	0	334821	0	49	40213314		
44464	3680	19008572	2011-05-27	2011-05-27 00:00:00	2011-06-10	2011-06-10 00:00:00	2011-06-10	38000177		0	0	14		0	0	0	244775	0	106258	19008572		
160980	3542	40213227	2008-08-02	2008-08-02 00:00:00	2008-08-02	2008-08-02 00:00:00	2008-08-02	581452		0	0	0		0	0	0	235245	0	113	40213227		
170771	3754	40213160	1959-04-14	1959-04-14 00:00:00	1959-04-14	1959-04-14 00:00:00	1959-04-14	581452		0	0	0		0	0	0	249544	0	10	40213160		
18610	1538	19059056	1931-07-10	1931-07-10 00:00:00	1931-07-24	1931-07-24 00:00:00	1931-07-24	38000177		0	0	14		0	0	0	103040	0	243670	19059056		
36001	785	40213227	2014-12-14	2014-12-14 00:00:00	2014-12-14	2014-12-14 00:00:00	2014-12-14	581452		0	0	0		0	0	0	52306	0	113	40213227		
47458	3934	1127433	1952-03-26	1952-03-26 00:00:00	1952-04-09	1952-04-09 00:00:00	1952-04-09	38000177		0	0	14		0	0	0	261520	0	313782	1127433		
37503	3100	19059056	1952-09-12	1952-09-12 00:00:00	1952-09-26	1952-09-26 00:00:00	1952-09-26	38000177		0	0	14		0	0	0	206245	0	243670	19059056		
29263	2423	1127433	1970-01-14	1970-01-14 00:00:00	1970-01-28	1970-01-28 00:00:00	1970-01-28	38000177		0	0	14		0	0	0	160728	0	313782	1127433		
96169	2109	40213296	2009-11-29	2009-11-29 00:00:00	2009-11-29	2009-11-29 00:00:00	2009-11-29	581452		0	0	0		0	0	0	140423	0	52	40213296		
4275	354	19128065	1974-12-06	1974-12-06 00:00:00	1975-12-01	1975-12-01 00:00:00	1975-12-01	38000177		0	0	360		0	0	0	23551	0	749882	19128065		
1230	97	1127433	2001-05-15	2001-05-15 00:00:00	2001-05-29	2001-05-29 00:00:00	2001-05-29	38000177		0	0	14		0	0	0	6619	0	313782	1127433		
33509	2774	1127433	1977-04-07	1977-04-07 00:00:00	1977-04-21	1977-04-21 00:00:00	1977-04-21	38000177		0	0	14		0	0	0	183689	0	313782	1127433		
58710	4874	19128065	1988-06-29	1988-06-29 00:00:00	1989-06-24	1989-06-24 00:00:00	1989-06-24	38000177		0	0	360		0	0	0	324171	0	749882	19128065		
11058	921	19128065	1984-05-27	1984-05-27 00:00:00	1985-05-22	1985-05-22 00:00:00	1985-05-22	38000177		0	0	360		0	0	0	61378	0	749882	19128065		
50508	4197	1115171	2007-02-22	2007-02-22 00:00:00	2007-04-23	2007-04-23 00:00:00	2007-04-23	38000177		0	0	60		0	0	0	278526	0	849574	1115171		
9274	771	1713671	1968-01-18	1968-01-18 00:00:00	1968-01-25	1968-01-25 00:00:00	1968-01-25	38000177		0	0	7		0	0	0	51173	0	562251	1713671		
4322	94	40213260	2006-04-21	2006-04-21 00:00:00	2006-04-21	2006-04-21 00:00:00	2006-04-21	581452		0	0	0		0	0	0	6389	0	121	40213260		
22453	1846	1127433	1979-09-29	1979-09-29 00:00:00	1979-10-13	1979-10-13 00:00:00	1979-10-13	38000177		0	0	14		0	0	0	123400	0	313782	1127433		
49305	4090	19059056	1968-01-04	1968-01-04 00:00:00	1968-02-01	1968-02-01 00:00:00	1968-02-01	38000177		0	0	28		0	0	0	271936	0	243670	19059056		
94604	2075	40213260	2016-03-15	2016-03-15 00:00:00	2016-03-15	2016-03-15 00:00:00	2016-03-15	581452		0	0	0		0	0	0	138045	0	121	40213260		
115311	2534	40213306	1994-09-27	1994-09-27 00:00:00	1994-09-27	1994-09-27 00:00:00	1994-09-27	581452		0	0	0		0	0	0	167418	0	43	40213306		
23491	1934	19059056	1963-12-03	1963-12-03 00:00:00	1963-12-17	1963-12-17 00:00:00	1963-12-17	38000177		0	0	14		0	0	0	128637	0	243670	19059056		
43366	946	40213160	1960-07-13	1960-07-13 00:00:00	1960-07-13	1960-07-13 00:00:00	1960-07-13	581452		0	0	0		0	0	0	62816	0	10	40213160		
58336	4847	19059056	1960-09-03	1960-09-03 00:00:00	1960-09-24	1960-09-24 00:00:00	1960-09-24	38000177		0	0	21		0	0	0	322426	0	243670	19059056		
44786	974	40213227	2017-08-27	2017-08-27 00:00:00	2017-08-27	2017-08-27 00:00:00	2017-08-27	581452		0	0	0		0	0	0	64978	0	113	40213227		
6044	505	1115171	1996-10-22	1996-10-22 00:00:00	1996-11-05	1996-11-05 00:00:00	1996-11-05	38000177		0	0	14		0	0	0	33783	0	849574	1115171		
35682	778	40213227	2011-02-03	2011-02-03 00:00:00	2011-02-03	2011-02-03 00:00:00	2011-02-03	581452		0	0	0		0	0	0	51684	0	113	40213227		
11488	956	40162522	1950-04-08	1950-04-08 00:00:00	1950-04-08	1950-04-08 00:00:00	\N	38000177		0	0	0		0	0	0	63551	0	857005	40162522		
158127	3481	40213160	1977-10-08	1977-10-08 00:00:00	1977-10-08	1977-10-08 00:00:00	1977-10-08	581452		0	0	0		0	0	0	230863	0	10	40213160		
44755	3703	1127078	1970-11-21	1970-11-21 00:00:00	1970-12-05	1970-12-05 00:00:00	1970-12-05	38000177		0	0	14		0	0	0	246233	0	282464	1127078		
26249	2160	19078461	2012-06-25	2012-06-25 00:00:00	2012-08-31	2012-08-31 00:00:00	2012-08-31	38000177		0	0	67		0	0	0	143922	0	310965	19078461		
7241	607	1127433	1964-12-03	1964-12-03 00:00:00	1964-12-10	1964-12-10 00:00:00	1964-12-10	38000177		0	0	7		0	0	0	40279	0	313782	1127433		
8891	742	19077572	2012-12-17	2012-12-17 00:00:00	2012-12-17	2012-12-17 00:00:00	\N	38000177		0	0	0		0	0	0	49197	0	310436	19077572		
41532	3440	19078461	1981-09-21	1981-09-21 00:00:00	1981-10-12	1981-10-12 00:00:00	1981-10-12	38000177		0	0	21		0	0	0	228227	0	310965	19078461		
41537	3440	1115171	2009-07-11	2009-07-11 00:00:00	2009-07-25	2009-07-25 00:00:00	2009-07-25	38000177		0	0	14		0	0	0	228265	0	849574	1115171		
53003	4405	1127433	1975-12-26	1975-12-26 00:00:00	1976-01-09	1976-01-09 00:00:00	1976-01-09	38000177		0	0	14		0	0	0	292783	0	313782	1127433		
9319	775	920300	1966-12-13	1966-12-13 00:00:00	1966-12-20	1966-12-20 00:00:00	1966-12-20	38000177		0	0	7		0	0	0	51420	0	311989	920300		
9362	778	19128022	1992-01-16	1992-01-16 00:00:00	1993-01-10	1993-01-10 00:00:00	1993-01-10	38000177		0	0	360		0	0	0	51692	0	749785	19128022		
31229	2589	1127433	1993-07-29	1993-07-29 00:00:00	1993-08-12	1993-08-12 00:00:00	1993-08-12	38000177		0	0	14		0	0	0	171337	0	313782	1127433		
132071	2902	40213227	2017-09-08	2017-09-08 00:00:00	2017-09-08	2017-09-08 00:00:00	2017-09-08	581452		0	0	0		0	0	0	\N	0	113	40213227		
46840	3879	19059056	1941-02-06	1941-02-06 00:00:00	1941-02-20	1941-02-20 00:00:00	1941-02-20	38000177		0	0	14		0	0	0	257719	0	243670	19059056		
21569	1773	40232448	1954-09-15	1954-09-15 00:00:00	1954-09-15	1954-09-15 00:00:00	\N	38000177		0	0	0		0	0	0	118503	0	1049630	40232448		
46915	3885	1713671	1967-01-20	1967-01-20 00:00:00	1967-01-27	1967-01-27 00:00:00	1967-01-27	38000177		0	0	7		0	0	0	258221	0	562251	1713671		
39137	3234	40229134	1977-06-24	1977-06-24 00:00:00	1977-07-08	1977-07-08 00:00:00	1977-07-08	38000177		0	0	14		0	0	0	214932	0	1043400	40229134		
4657	387	1127433	1998-04-04	1998-04-04 00:00:00	1998-07-03	1998-07-03 00:00:00	1998-07-03	38000177		0	0	90		0	0	0	25458	0	313782	1127433		
21894	1794	19059056	1961-09-13	1961-09-13 00:00:00	1961-09-27	1961-09-27 00:00:00	1961-09-27	38000177		0	0	14		0	0	0	120277	0	243670	19059056		
42704	3539	1127433	2015-12-30	2015-12-30 00:00:00	2016-01-20	2016-01-20 00:00:00	2016-01-20	38000177		0	0	21		0	0	0	235093	0	313782	1127433		
16086	347	40213306	1991-11-17	1991-11-17 00:00:00	1991-11-17	1991-11-17 00:00:00	1991-11-17	581452		0	0	0		0	0	0	23079	0	43	40213306		
41210	3417	19059056	1948-04-13	1948-04-13 00:00:00	1948-05-04	1948-05-04 00:00:00	1948-05-04	38000177		0	0	21		0	0	0	226623	0	243670	19059056		
42604	3531	19019979	1975-07-15	1975-07-15 00:00:00	1975-10-13	1975-10-13 00:00:00	1975-10-13	38000177		0	0	90		0	0	0	234587	0	198405	19019979		
62003	5157	19129655	1963-11-07	1963-11-07 00:00:00	1963-11-21	1963-11-21 00:00:00	1963-11-21	38000177		0	0	14		0	0	0	342908	0	789980	19129655		
51468	4278	19126352	1978-12-29	1978-12-29 00:00:00	1978-12-29	1978-12-29 00:00:00	\N	38000177		0	0	0		0	0	0	283874	0	705129	19126352		
25945	2135	19059056	1968-09-03	1968-09-03 00:00:00	1968-09-17	1968-09-17 00:00:00	1968-09-17	38000177		0	0	14		0	0	0	142102	0	243670	19059056		
35399	2917	1713671	2014-02-22	2014-02-22 00:00:00	2014-03-08	2014-03-08 00:00:00	2014-03-08	38000177		0	0	14		0	0	0	194471	0	562251	1713671		
36525	3013	19133905	1997-09-24	1997-09-24 00:00:00	1997-10-03	1997-10-03 00:00:00	1997-10-03	38000177		0	0	9		0	0	0	200941	0	834102	19133905		
35550	2929	1127433	1992-10-13	1992-10-13 00:00:00	1992-10-20	1992-10-20 00:00:00	1992-10-20	38000177		0	0	7		0	0	0	195365	0	313782	1127433		
5519	461	40173590	2018-12-18	2018-12-18 00:00:00	2018-12-18	2018-12-18 00:00:00	\N	38000177		0	0	0		0	0	0	30847	0	904419	40173590		
18952	1566	40229134	2017-03-16	2017-03-16 00:00:00	2017-03-23	2017-03-23 00:00:00	2017-03-23	38000177		0	0	7		0	0	0	105046	0	1043400	40229134		
11737	975	19129655	1966-12-05	1966-12-05 00:00:00	1966-12-19	1966-12-19 00:00:00	1966-12-19	38000177		0	0	14		0	0	0	65039	0	789980	19129655		
30728	2546	1127433	1987-07-14	1987-07-14 00:00:00	1987-08-13	1987-08-13 00:00:00	1987-08-13	38000177		0	0	30		0	0	0	168460	0	313782	1127433		
26148	2151	40171902	1981-06-03	1981-06-03 00:00:00	1981-06-03	1981-06-03 00:00:00	\N	38000177		0	0	0		0	0	0	143276	0	897718	40171902		
22376	1840	1713671	1985-05-25	1985-05-25 00:00:00	1985-06-15	1985-06-15 00:00:00	1985-06-15	38000177		0	0	21		0	0	0	122823	0	562251	1713671		
33867	2802	1545959	1997-12-13	1997-12-13 00:00:00	1997-12-13	1997-12-13 00:00:00	1997-12-13	38000177		0	0	0		0	0	0	185715	0	259255	1545959		
229236	5037	40213160	1977-07-27	1977-07-27 00:00:00	1977-07-27	1977-07-27 00:00:00	1977-07-27	581452		0	0	0		0	0	0	334821	0	10	40213160		
44465	3680	19134077	2011-05-27	2011-05-27 00:00:00	2011-06-10	2011-06-10 00:00:00	2011-06-10	38000177		0	0	14		0	0	0	244775	0	835900	19134077		
39267	858	40213296	2014-02-20	2014-02-20 00:00:00	2014-02-20	2014-02-20 00:00:00	2014-02-20	581452		0	0	0		0	0	0	56688	0	52	40213296		
170776	3754	40213227	1993-01-19	1993-01-19 00:00:00	1993-01-19	1993-01-19 00:00:00	1993-01-19	581452		0	0	0		0	0	0	249452	0	113	40213227		
18611	1538	19133905	1994-05-19	1994-05-19 00:00:00	1994-05-31	1994-05-31 00:00:00	1994-05-31	38000177		0	0	12		0	0	0	103038	0	834102	19133905		
36002	785	40213260	2014-12-14	2014-12-14 00:00:00	2014-12-14	2014-12-14 00:00:00	2014-12-14	581452		0	0	0		0	0	0	52306	0	121	40213260		
47459	3934	19059056	1981-08-07	1981-08-07 00:00:00	1981-08-28	1981-08-28 00:00:00	1981-08-28	38000177		0	0	21		0	0	0	261503	0	243670	19059056		
37504	3100	19006318	1952-09-12	1952-09-12 00:00:00	1952-09-26	1952-09-26 00:00:00	1952-09-26	38000177		0	0	14		0	0	0	206245	0	105078	19006318		
29264	2423	40236824	1996-11-16	1996-11-16 00:00:00	1996-11-23	1996-11-23 00:00:00	1996-11-23	38000177		0	0	7		0	0	0	160781	0	1094107	40236824		
96170	2109	40213160	1970-05-03	1970-05-03 00:00:00	1970-05-03	1970-05-03 00:00:00	1970-05-03	581452		0	0	0		0	0	0	140412	0	10	40213160		
4277	354	1127433	1957-06-30	1957-06-30 00:00:00	1957-07-14	1957-07-14 00:00:00	1957-07-14	38000177		0	0	14		0	0	0	23530	0	313782	1127433		
1231	97	19078461	2002-07-08	2002-07-08 00:00:00	2002-07-29	2002-07-29 00:00:00	2002-07-29	38000177		0	0	21		0	0	0	6648	0	310965	19078461		
33510	2774	1118084	1977-09-29	1977-09-29 00:00:00	1977-09-29	1977-09-29 00:00:00	\N	38000177		0	0	0		0	0	0	183689	0	00025152531	44923712		
58711	4874	1127433	1972-09-20	1972-09-20 00:00:00	1972-10-04	1972-10-04 00:00:00	1972-10-04	38000177		0	0	14		0	0	0	324167	0	313782	1127433		
11059	921	40165015	1983-03-25	1983-03-25 00:00:00	1983-03-25	1983-03-25 00:00:00	\N	38000177		0	0	0		0	0	0	61345	0	861467	40165015		
50514	4199	19006318	1963-01-17	1963-01-17 00:00:00	1963-01-31	1963-01-31 00:00:00	1963-01-31	38000177		0	0	14		0	0	0	278621	0	105078	19006318		
9275	771	1127433	1980-10-17	1980-10-17 00:00:00	1980-12-16	1980-12-16 00:00:00	1980-12-16	38000177		0	0	60		0	0	0	51181	0	313782	1127433		
4327	94	40213227	2003-04-04	2003-04-04 00:00:00	2003-04-04	2003-04-04 00:00:00	2003-04-04	581452		0	0	0		0	0	0	6381	0	113	40213227		
22454	1846	1115171	2018-01-26	2018-01-26 00:00:00	2018-02-25	2018-02-25 00:00:00	2018-02-25	38000177		0	0	30		0	0	0	123470	0	849574	1115171		
49306	4090	19126352	2015-08-03	2015-08-03 00:00:00	2015-08-03	2015-08-03 00:00:00	\N	38000177		0	0	0		0	0	0	271869	0	705129	19126352		
94606	2076	40213306	1987-12-17	1987-12-17 00:00:00	1987-12-17	1987-12-17 00:00:00	1987-12-17	581452		0	0	0		0	0	0	138177	0	43	40213306		
115316	2534	40213296	2016-02-02	2016-02-02 00:00:00	2016-02-02	2016-02-02 00:00:00	2016-02-02	581452		0	0	0		0	0	0	167375	0	52	40213296		
23492	1934	1713671	1963-05-03	1963-05-03 00:00:00	1963-05-24	1963-05-24 00:00:00	1963-05-24	38000177		0	0	21		0	0	0	128633	0	562251	1713671		
43368	946	40213227	2011-04-27	2011-04-27 00:00:00	2011-04-27	2011-04-27 00:00:00	2011-04-27	581452		0	0	0		0	0	0	62771	0	113	40213227		
58337	4847	40169281	1978-01-25	1978-01-25 00:00:00	1978-01-25	1978-01-25 00:00:00	\N	38000177		0	0	0		0	0	0	322414	0	896209	40169281		
44791	974	40213227	1998-07-05	1998-07-05 00:00:00	1998-07-05	1998-07-05 00:00:00	1998-07-05	581452		0	0	0		0	0	0	64925	0	113	40213227		
6045	505	1127078	1971-03-21	1971-03-21 00:00:00	1971-04-04	1971-04-04 00:00:00	1971-04-04	38000177		0	0	14		0	0	0	33826	0	282464	1127078		
35685	778	40213160	1982-12-30	1982-12-30 00:00:00	1982-12-30	1982-12-30 00:00:00	1982-12-30	581452		0	0	0		0	0	0	51662	0	10	40213160		
11489	956	19059056	1936-06-29	1936-06-29 00:00:00	1936-07-13	1936-07-13 00:00:00	1936-07-13	38000177		0	0	14		0	0	0	63468	0	243670	19059056		
158128	3481	40213314	1978-07-08	1978-07-08 00:00:00	1978-07-08	1978-07-08 00:00:00	1978-07-08	581452		0	0	0		0	0	0	230864	0	49	40213314		
44756	3703	19059056	1973-08-04	1973-08-04 00:00:00	1973-09-08	1973-09-08 00:00:00	1973-09-08	38000177		0	0	35		0	0	0	246254	0	243670	19059056		
26250	2160	40229134	2005-12-23	2005-12-23 00:00:00	2005-12-30	2005-12-30 00:00:00	2005-12-30	38000177		0	0	7		0	0	0	143985	0	1043400	40229134		
7242	607	1127433	2018-01-26	2018-01-26 00:00:00	2018-02-09	2018-02-09 00:00:00	2018-02-09	38000177		0	0	14		0	0	0	40271	0	313782	1127433		
8892	742	19059056	1961-04-27	1961-04-27 00:00:00	1961-06-01	1961-06-01 00:00:00	1961-06-01	38000177		0	0	35		0	0	0	49188	0	243670	19059056		
10077	844	46233988	1967-12-14	1967-12-14 00:00:00	1967-12-28	1967-12-28 00:00:00	1967-12-28	38000177		0	0	14		0	0	0	55969	0	1652673	46233988		
41538	3440	19075001	2009-07-11	2009-07-11 00:00:00	2009-07-25	2009-07-25 00:00:00	2009-07-25	38000177		0	0	14		0	0	0	228265	0	309097	19075001		
53004	4405	19059056	1969-09-01	1969-09-01 00:00:00	1969-09-15	1969-09-15 00:00:00	1969-09-15	38000177		0	0	14		0	0	0	292787	0	243670	19059056		
9320	775	1127433	2000-02-20	2000-02-20 00:00:00	2000-03-19	2000-03-19 00:00:00	2000-03-19	38000177		0	0	28		0	0	0	51451	0	313782	1127433		
9363	778	1127433	2008-01-22	2008-01-22 00:00:00	2008-02-05	2008-02-05 00:00:00	2008-02-05	38000177		0	0	14		0	0	0	51647	0	313782	1127433		
31230	2589	42902245	2001-02-25	2001-02-25 00:00:00	2002-02-20	2002-02-20 00:00:00	2002-02-20	38000177		0	0	360		0	0	0	171349	0	1359133	42902245		
9413	782	836659	1994-05-15	1994-05-15 00:00:00	1994-05-15	1994-05-15 00:00:00	\N	38000177		0	0	0		0	0	0	52012	0	313185	836659		
27519	2280	1713671	1983-03-20	1983-03-20 00:00:00	1983-08-21	1983-08-21 00:00:00	1983-08-21	38000177		0	0	154		0	0	0	151563	0	562251	1713671		
21570	1773	19133873	1959-07-19	1959-07-19 00:00:00	1959-07-29	1959-07-29 00:00:00	1959-07-29	38000177		0	0	10		0	0	0	118554	0	834061	19133873		
46916	3885	1127433	2003-06-06	2003-06-06 00:00:00	2003-06-13	2003-06-13 00:00:00	2003-06-13	38000177		0	0	7		0	0	0	258257	0	313782	1127433		
39144	3236	1127433	1979-12-06	1979-12-06 00:00:00	1980-01-10	1980-01-10 00:00:00	1980-01-10	38000177		0	0	35		0	0	0	215028	0	313782	1127433		
4658	387	40231925	1998-04-04	1998-04-04 00:00:00	1998-04-04	1998-04-04 00:00:00	\N	38000177		0	0	0		0	0	0	25458	0	1049221	40231925		
21895	1794	1127433	1978-07-29	1978-07-29 00:00:00	1978-08-05	1978-08-05 00:00:00	1978-08-05	38000177		0	0	7		0	0	0	120302	0	313782	1127433		
42705	3539	1118084	2016-06-21	2016-06-21 00:00:00	2016-06-21	2016-06-21 00:00:00	\N	38000177		0	0	0		0	0	0	235093	0	00025152531	44923712		
52395	4359	1713671	1987-06-13	1987-06-13 00:00:00	1987-06-20	1987-06-20 00:00:00	1987-06-20	38000177		0	0	7		0	0	0	289223	0	562251	1713671		
41211	3417	1127433	1980-01-29	1980-01-29 00:00:00	1980-02-12	1980-02-12 00:00:00	1980-02-12	38000177		0	0	14		0	0	0	226593	0	313782	1127433		
42605	3531	1115171	2009-02-16	2009-02-16 00:00:00	2009-03-16	2009-03-16 00:00:00	2009-03-16	38000177		0	0	28		0	0	0	234528	0	849574	1115171		
62004	5157	19059056	1963-11-07	1963-11-07 00:00:00	1963-11-21	1963-11-21 00:00:00	1963-11-21	38000177		0	0	14		0	0	0	342908	0	243670	19059056		
51469	4278	1115171	2010-09-01	2010-09-01 00:00:00	2010-09-15	2010-09-15 00:00:00	2010-09-15	38000177		0	0	14		0	0	0	283935	0	849574	1115171		
25946	2135	19133873	1958-02-13	1958-02-13 00:00:00	1958-02-23	1958-02-23 00:00:00	1958-02-23	38000177		0	0	10		0	0	0	142069	0	834061	19133873		
35400	2917	1713671	1952-06-20	1952-06-20 00:00:00	1952-06-27	1952-06-27 00:00:00	1952-06-27	38000177		0	0	7		0	0	0	194467	0	562251	1713671		
36526	3013	19059056	1960-01-23	1960-01-23 00:00:00	1960-02-13	1960-02-13 00:00:00	1960-02-13	38000177		0	0	21		0	0	0	200964	0	243670	19059056		
35551	2929	1713671	1998-12-17	1998-12-17 00:00:00	1998-12-31	1998-12-31 00:00:00	1998-12-31	38000177		0	0	14		0	0	0	195367	0	562251	1713671		
5520	461	1115171	2001-02-19	2001-02-19 00:00:00	2001-03-05	2001-03-05 00:00:00	2001-03-05	38000177		0	0	14		0	0	0	30858	0	849574	1115171		
18953	1566	1713671	1994-08-31	1994-08-31 00:00:00	1994-09-07	1994-09-07 00:00:00	1994-09-07	38000177		0	0	7		0	0	0	105059	0	562251	1713671		
11738	975	40229134	2003-01-27	2003-01-27 00:00:00	2003-02-03	2003-02-03 00:00:00	2003-02-03	38000177		0	0	7		0	0	0	65024	0	1043400	40229134		
30729	2546	40162522	1987-07-14	1987-07-14 00:00:00	1987-07-14	1987-07-14 00:00:00	\N	38000177		0	0	0		0	0	0	168460	0	857005	40162522		
26149	2151	19059056	1919-11-04	1919-11-04 00:00:00	1919-11-18	1919-11-18 00:00:00	1919-11-18	38000177		0	0	14		0	0	0	143312	0	243670	19059056		
33851	2801	1713671	1966-03-25	1966-03-25 00:00:00	1966-06-03	1966-06-03 00:00:00	1966-06-03	38000177		0	0	70		0	0	0	185572	0	562251	1713671		
33868	2802	1127433	1971-05-16	1971-05-16 00:00:00	1971-05-23	1971-05-23 00:00:00	1971-05-23	38000177		0	0	7		0	0	0	185741	0	313782	1127433		
229239	5037	40213160	1982-01-27	1982-01-27 00:00:00	1982-01-27	1982-01-27 00:00:00	1982-01-27	581452		0	0	0		0	0	0	334794	0	10	40213160		
44466	3680	19078461	2018-06-19	2018-06-19 00:00:00	2018-07-24	2018-07-24 00:00:00	2018-07-24	38000177		0	0	35		0	0	0	244721	0	310965	19078461		
39271	858	40213227	2016-02-25	2016-02-25 00:00:00	2016-02-25	2016-02-25 00:00:00	2016-02-25	581452		0	0	0		0	0	0	56707	0	113	40213227		
170778	3754	40213160	1963-12-17	1963-12-17 00:00:00	1963-12-17	1963-12-17 00:00:00	1963-12-17	581452		0	0	0		0	0	0	249432	0	10	40213160		
18612	1538	40229134	2010-04-28	2010-04-28 00:00:00	2010-05-05	2010-05-05 00:00:00	2010-05-05	38000177		0	0	7		0	0	0	103068	0	1043400	40229134		
36006	785	40213227	2005-12-18	2005-12-18 00:00:00	2005-12-18	2005-12-18 00:00:00	2005-12-18	581452		0	0	0		0	0	0	52295	0	113	40213227		
47460	3934	1118084	1972-09-23	1972-09-23 00:00:00	1972-09-23	1972-09-23 00:00:00	\N	38000177		0	0	0		0	0	0	261478	0	00025152531	44923712		
37505	3100	1118084	1989-10-18	1989-10-18 00:00:00	1989-10-18	1989-10-18 00:00:00	\N	38000177		0	0	0		0	0	0	206290	0	00025152531	44923712		
29265	2423	920300	1996-11-16	1996-11-16 00:00:00	1996-11-23	1996-11-23 00:00:00	1996-11-23	38000177		0	0	7		0	0	0	160781	0	311989	920300		
96174	2109	40213160	1970-03-01	1970-03-01 00:00:00	1970-03-01	1970-03-01 00:00:00	1970-03-01	581452		0	0	0		0	0	0	140427	0	10	40213160		
4278	354	1118084	1989-12-12	1989-12-12 00:00:00	1989-12-12	1989-12-12 00:00:00	\N	38000177		0	0	0		0	0	0	23515	0	00025152531	44923712		
1232	97	19078461	1996-09-16	1996-09-16 00:00:00	1996-10-07	1996-10-07 00:00:00	1996-10-07	38000177		0	0	21		0	0	0	6647	0	310965	19078461		
33511	2774	1127433	1981-11-26	1981-11-26 00:00:00	1981-12-31	1981-12-31 00:00:00	1981-12-31	38000177		0	0	35		0	0	0	183690	0	313782	1127433		
58712	4874	1713671	2016-07-19	2016-07-19 00:00:00	2016-08-02	2016-08-02 00:00:00	2016-08-02	38000177		0	0	14		0	0	0	324196	0	562251	1713671		
11060	921	1127433	1983-03-25	1983-03-25 00:00:00	1983-06-23	1983-06-23 00:00:00	1983-06-23	38000177		0	0	90		0	0	0	61345	0	313782	1127433		
28161	2328	40231925	1991-01-07	1991-01-07 00:00:00	1991-01-07	1991-01-07 00:00:00	\N	38000177		0	0	0		0	0	0	154899	0	1049221	40231925		
9276	771	19078461	1999-09-08	1999-09-08 00:00:00	1999-10-13	1999-10-13 00:00:00	1999-10-13	38000177		0	0	35		0	0	0	51182	0	310965	19078461		
8594	718	1127078	1967-03-23	1967-03-23 00:00:00	1967-04-13	1967-04-13 00:00:00	1967-04-13	38000177		0	0	21		0	0	0	47523	0	282464	1127078		
22455	1846	1115171	2007-04-24	2007-04-24 00:00:00	2007-06-23	2007-06-23 00:00:00	2007-06-23	38000177		0	0	60		0	0	0	123469	0	849574	1115171		
37171	3072	1310034	1964-02-01	1964-02-01 00:00:00	1964-02-01	1964-02-01 00:00:00	1964-02-01	38000177		0	0	0		0	0	0	204459	0	834357	1310034		
94609	2076	40213160	1967-09-07	1967-09-07 00:00:00	1967-09-07	1967-09-07 00:00:00	1967-09-07	581452		0	0	0		0	0	0	138150	0	10	40213160		
115321	2535	40213260	2011-01-02	2011-01-02 00:00:00	2011-01-02	2011-01-02 00:00:00	2011-01-02	581452		0	0	0		0	0	0	167485	0	121	40213260		
23493	1934	19129655	1965-09-06	1965-09-06 00:00:00	1965-09-20	1965-09-20 00:00:00	1965-09-20	38000177		0	0	14		0	0	0	128627	0	789980	19129655		
43369	946	40213260	2011-04-27	2011-04-27 00:00:00	2011-04-27	2011-04-27 00:00:00	2011-04-27	581452		0	0	0		0	0	0	62771	0	121	40213260		
58338	4847	19059056	1950-12-06	1950-12-06 00:00:00	1951-01-12	1951-01-12 00:00:00	1951-01-12	38000177		0	0	37		0	0	0	322423	0	243670	19059056		
44792	974	40213296	1998-07-05	1998-07-05 00:00:00	1998-07-05	1998-07-05 00:00:00	1998-07-05	581452		0	0	0		0	0	0	64925	0	52	40213296		
6046	505	1127078	1972-04-27	1972-04-27 00:00:00	1972-05-11	1972-05-11 00:00:00	1972-05-11	38000177		0	0	14		0	0	0	33792	0	282464	1127078		
219908	4827	40213201	2016-03-10	2016-03-10 00:00:00	2016-03-10	2016-03-10 00:00:00	2016-03-10	581452		0	0	0		0	0	0	\N	0	33	40213201		
11495	958	1127433	2002-12-12	2002-12-12 00:00:00	2002-12-26	2002-12-26 00:00:00	2002-12-26	38000177		0	0	14		0	0	0	63598	0	313782	1127433		
171806	3777	40213160	1984-10-04	1984-10-04 00:00:00	1984-10-04	1984-10-04 00:00:00	1984-10-04	581452		0	0	0		0	0	0	251029	0	10	40213160		
44757	3703	1713671	1973-08-05	1973-08-05 00:00:00	1973-08-12	1973-08-12 00:00:00	1973-08-12	38000177		0	0	7		0	0	0	246271	0	562251	1713671		
26252	2160	19059056	1962-03-03	1962-03-03 00:00:00	1962-03-17	1962-03-17 00:00:00	1962-03-17	38000177		0	0	14		0	0	0	143968	0	243670	19059056		
7243	607	19059056	1957-06-11	1957-06-11 00:00:00	1957-09-09	1957-09-09 00:00:00	1957-09-09	38000177		0	0	90		0	0	0	40298	0	243670	19059056		
8893	742	19133873	1926-11-18	1926-11-18 00:00:00	1926-11-29	1926-11-29 00:00:00	1926-11-29	38000177		0	0	11		0	0	0	49105	0	834061	19133873		
10078	844	1127433	1993-10-03	1993-10-03 00:00:00	1993-10-17	1993-10-17 00:00:00	1993-10-17	38000177		0	0	14		0	0	0	55873	0	313782	1127433		
41539	3440	19078461	1995-10-06	1995-10-06 00:00:00	1995-11-05	1995-11-05 00:00:00	1995-11-05	38000177		0	0	30		0	0	0	228225	0	310965	19078461		
41579	3443	19128022	2000-01-17	2000-01-17 00:00:00	2001-01-11	2001-01-11 00:00:00	2001-01-11	38000177		0	0	360		0	0	0	228460	0	749785	19128022		
41631	3446	1713671	1997-11-19	1997-11-19 00:00:00	1997-12-10	1997-12-10 00:00:00	1997-12-10	38000177		0	0	21		0	0	0	228851	0	562251	1713671		
9364	778	1127078	1985-01-10	1985-01-10 00:00:00	1985-01-31	1985-01-31 00:00:00	1985-01-31	38000177		0	0	21		0	0	0	51672	0	282464	1127078		
31231	2589	1713671	1998-09-01	1998-09-01 00:00:00	1998-10-13	1998-10-13 00:00:00	1998-10-13	38000177		0	0	42		0	0	0	171344	0	562251	1713671		
9414	782	1127433	1921-11-16	1921-11-16 00:00:00	1921-11-30	1921-11-30 00:00:00	1921-11-30	38000177		0	0	14		0	0	0	52052	0	313782	1127433		
27520	2280	1127433	1982-07-28	1982-07-28 00:00:00	1982-08-11	1982-08-11 00:00:00	1982-08-11	38000177		0	0	14		0	0	0	151562	0	313782	1127433		
21571	1773	1127433	1969-12-21	1969-12-21 00:00:00	1970-01-04	1970-01-04 00:00:00	1970-01-04	38000177		0	0	14		0	0	0	118536	0	313782	1127433		
46917	3885	1127433	1978-07-27	1978-07-27 00:00:00	1978-08-10	1978-08-10 00:00:00	1978-08-10	38000177		0	0	14		0	0	0	258222	0	313782	1127433		
39145	3236	19006318	1958-10-29	1958-10-29 00:00:00	1958-11-26	1958-11-26 00:00:00	1958-11-26	38000177		0	0	28		0	0	0	215027	0	105078	19006318		
4659	387	1127433	1991-08-25	1991-08-25 00:00:00	1991-09-08	1991-09-08 00:00:00	1991-09-08	38000177		0	0	14		0	0	0	25457	0	313782	1127433		
21896	1794	1127433	2014-11-15	2014-11-15 00:00:00	2014-11-29	2014-11-29 00:00:00	2014-11-29	38000177		0	0	14		0	0	0	120331	0	313782	1127433		
42706	3539	19073183	1983-12-27	1983-12-27 00:00:00	1984-01-10	1984-01-10 00:00:00	1984-01-10	38000177		0	0	14		0	0	0	235106	0	308182	19073183		
52396	4359	19073188	1985-04-01	1985-04-01 00:00:00	1985-04-15	1985-04-15 00:00:00	1985-04-15	38000177		0	0	14		0	0	0	289254	0	308192	19073188		
41212	3417	1713671	1918-11-05	1918-11-05 00:00:00	1918-11-12	1918-11-12 00:00:00	1918-11-12	38000177		0	0	7		0	0	0	226653	0	562251	1713671		
42606	3531	1127433	1987-05-30	1987-05-30 00:00:00	1987-06-13	1987-06-13 00:00:00	1987-06-13	38000177		0	0	14		0	0	0	234569	0	313782	1127433		
62005	5157	19078461	2018-01-22	2018-01-22 00:00:00	2018-03-23	2018-03-23 00:00:00	2018-03-23	38000177		0	0	60		0	0	0	342948	0	310965	19078461		
51470	4278	19075601	1998-01-23	1998-01-23 00:00:00	1998-01-23	1998-01-23 00:00:00	\N	38000177		0	0	0		0	0	0	283885	0	309362	19075601		
25947	2135	1127433	1953-02-06	1953-02-06 00:00:00	1953-02-20	1953-02-20 00:00:00	1953-02-20	38000177		0	0	14		0	0	0	142126	0	313782	1127433		
35401	2917	40163554	1989-09-13	1989-09-13 00:00:00	1989-09-13	1989-09-13 00:00:00	\N	38000177		0	0	0		0	0	0	194453	0	855332	40163554		
36527	3013	19059056	1962-03-13	1962-03-13 00:00:00	1962-03-27	1962-03-27 00:00:00	1962-03-27	38000177		0	0	14		0	0	0	200955	0	243670	19059056		
35552	2929	46233988	1975-10-11	1975-10-11 00:00:00	1975-10-25	1975-10-25 00:00:00	1975-10-25	38000177		0	0	14		0	0	0	195395	0	1652673	46233988		
5521	461	19133905	1969-06-28	1969-06-28 00:00:00	1969-07-06	1969-07-06 00:00:00	1969-07-06	38000177		0	0	8		0	0	0	30829	0	834102	19133905		
18954	1566	40229134	2000-08-13	2000-08-13 00:00:00	2000-08-20	2000-08-20 00:00:00	2000-08-20	38000177		0	0	7		0	0	0	105026	0	1043400	40229134		
11739	975	1124300	2000-03-26	2000-03-26 00:00:00	2000-03-26	2000-03-26 00:00:00	\N	38000177		0	0	0		0	0	0	65052	0	00781178901	45011828		
30730	2546	19059056	1976-12-31	1976-12-31 00:00:00	1977-01-14	1977-01-14 00:00:00	1977-01-14	38000177		0	0	14		0	0	0	168522	0	243670	19059056		
26150	2151	19133873	1925-07-06	1925-07-06 00:00:00	1925-07-16	1925-07-16 00:00:00	1925-07-16	38000177		0	0	10		0	0	0	143306	0	834061	19133873		
33852	2801	1118084	1966-02-21	1966-02-21 00:00:00	1966-02-21	1966-02-21 00:00:00	\N	38000177		0	0	0		0	0	0	185589	0	00025152531	44923712		
33869	2802	19059056	1965-01-01	1965-01-01 00:00:00	1965-04-01	1965-04-01 00:00:00	1965-04-01	38000177		0	0	90		0	0	0	185711	0	243670	19059056		
239453	5256	40213227	2011-10-14	2011-10-14 00:00:00	2011-10-14	2011-10-14 00:00:00	2011-10-14	581452		0	0	0		0	0	0	349740	0	113	40213227		
44467	3680	19008572	1987-05-02	1987-05-02 00:00:00	1987-05-23	1987-05-23 00:00:00	1987-05-23	38000177		0	0	21		0	0	0	244723	0	106258	19008572		
39272	858	40213296	2016-02-25	2016-02-25 00:00:00	2016-02-25	2016-02-25 00:00:00	2016-02-25	581452		0	0	0		0	0	0	56707	0	52	40213296		
227726	5000	40213227	1999-10-26	1999-10-26 00:00:00	1999-10-26	1999-10-26 00:00:00	1999-10-26	581452		0	0	0		0	0	0	332509	0	113	40213227		
18613	1538	1127433	1938-02-21	1938-02-21 00:00:00	1938-02-28	1938-02-28 00:00:00	1938-02-28	38000177		0	0	7		0	0	0	102951	0	313782	1127433		
36007	785	40213296	2005-12-18	2005-12-18 00:00:00	2005-12-18	2005-12-18 00:00:00	2005-12-18	581452		0	0	0		0	0	0	52295	0	52	40213296		
47461	3934	1713671	1988-02-01	1988-02-01 00:00:00	1988-03-07	1988-03-07 00:00:00	1988-03-07	38000177		0	0	35		0	0	0	261479	0	562251	1713671		
37506	3100	19059056	1967-11-29	1967-11-29 00:00:00	1967-12-13	1967-12-13 00:00:00	1967-12-13	38000177		0	0	14		0	0	0	206241	0	243670	19059056		
29266	2423	40173590	2016-12-19	2016-12-19 00:00:00	2016-12-19	2016-12-19 00:00:00	\N	38000177		0	0	0		0	0	0	160790	0	904419	40173590		
168369	3701	40213160	1957-04-15	1957-04-15 00:00:00	1957-04-15	1957-04-15 00:00:00	1957-04-15	581452		0	0	0		0	0	0	246105	0	10	40213160		
4279	354	1127433	1973-03-24	1973-03-24 00:00:00	1973-04-07	1973-04-07 00:00:00	1973-04-07	38000177		0	0	14		0	0	0	23518	0	313782	1127433		
1233	97	40236824	1966-12-15	1966-12-15 00:00:00	1966-12-22	1966-12-22 00:00:00	1966-12-22	38000177		0	0	7		0	0	0	6614	0	1094107	40236824		
33512	2774	1127433	1968-03-03	1968-03-03 00:00:00	1968-03-17	1968-03-17 00:00:00	1968-03-17	38000177		0	0	14		0	0	0	183656	0	313782	1127433		
58713	4874	40229134	1972-06-14	1972-06-14 00:00:00	1972-06-21	1972-06-21 00:00:00	1972-06-21	38000177		0	0	7		0	0	0	324158	0	1043400	40229134		
11061	921	1713671	1977-06-11	1977-06-11 00:00:00	1977-06-25	1977-06-25 00:00:00	1977-06-25	38000177		0	0	14		0	0	0	61319	0	562251	1713671		
28162	2328	19073188	1991-01-07	1991-01-07 00:00:00	1991-02-04	1991-02-04 00:00:00	1991-02-04	38000177		0	0	28		0	0	0	154899	0	308192	19073188		
9277	771	1127433	1975-12-13	1975-12-13 00:00:00	1976-03-12	1976-03-12 00:00:00	1976-03-12	38000177		0	0	90		0	0	0	51180	0	313782	1127433		
8595	718	1127433	2000-04-22	2000-04-22 00:00:00	2000-05-06	2000-05-06 00:00:00	2000-05-06	38000177		0	0	14		0	0	0	47460	0	313782	1127433		
22456	1846	1127433	1963-05-25	1963-05-25 00:00:00	1963-06-01	1963-06-01 00:00:00	1963-06-01	38000177		0	0	7		0	0	0	123408	0	313782	1127433		
37172	3072	1118084	2003-05-23	2003-05-23 00:00:00	2003-05-23	2003-05-23 00:00:00	\N	38000177		0	0	0		0	0	0	204443	0	00025152531	44923712		
94611	2076	40213227	2000-04-06	2000-04-06 00:00:00	2000-04-06	2000-04-06 00:00:00	2000-04-06	581452		0	0	0		0	0	0	138170	0	113	40213227		
115326	2535	40213227	2003-01-12	2003-01-12 00:00:00	2003-01-12	2003-01-12 00:00:00	2003-01-12	581452		0	0	0		0	0	0	167491	0	113	40213227		
23494	1934	19059056	1965-09-06	1965-09-06 00:00:00	1965-09-20	1965-09-20 00:00:00	1965-09-20	38000177		0	0	14		0	0	0	128627	0	243670	19059056		
43375	946	40213227	1994-08-31	1994-08-31 00:00:00	1994-08-31	1994-08-31 00:00:00	1994-08-31	581452		0	0	0		0	0	0	62797	0	113	40213227		
58339	4847	19126352	2013-03-27	2013-03-27 00:00:00	2013-03-27	2013-03-27 00:00:00	\N	38000177		0	0	0		0	0	0	322420	0	705129	19126352		
44795	974	40213160	1956-12-02	1956-12-02 00:00:00	1956-12-02	1956-12-02 00:00:00	1956-12-02	581452		0	0	0		0	0	0	64990	0	10	40213160		
131848	2897	40213160	1960-09-10	1960-09-10 00:00:00	1960-09-10	1960-09-10 00:00:00	1960-09-10	581452		0	0	0		0	0	0	192952	0	10	40213160		
219916	4827	40213227	2001-03-01	2001-03-01 00:00:00	2001-03-01	2001-03-01 00:00:00	2001-03-01	581452		0	0	0		0	0	0	321157	0	113	40213227		
11496	958	1713671	1994-02-14	1994-02-14 00:00:00	1994-02-21	1994-02-21 00:00:00	1994-02-21	38000177		0	0	7		0	0	0	63636	0	562251	1713671		
171807	3777	40213314	1984-10-04	1984-10-04 00:00:00	1984-10-04	1984-10-04 00:00:00	1984-10-04	581452		0	0	0		0	0	0	251029	0	49	40213314		
44758	3703	19059056	1971-10-30	1971-10-30 00:00:00	1971-11-13	1971-11-13 00:00:00	1971-11-13	38000177		0	0	14		0	0	0	246253	0	243670	19059056		
26253	2160	19129655	1962-03-03	1962-03-03 00:00:00	1962-03-17	1962-03-17 00:00:00	1962-03-17	38000177		0	0	14		0	0	0	143968	0	789980	19129655		
7244	607	1115171	2016-12-28	2016-12-28 00:00:00	2017-01-25	2017-01-25 00:00:00	2017-01-25	38000177		0	0	28		0	0	0	40300	0	849574	1115171		
8894	742	19018935	2008-07-21	2008-07-21 00:00:00	2008-07-21	2008-07-21 00:00:00	\N	38000177		0	0	0		0	0	0	49195	0	197604	19018935		
10079	844	19078461	1995-04-21	1995-04-21 00:00:00	1995-05-12	1995-05-12 00:00:00	1995-05-12	38000177		0	0	21		0	0	0	56004	0	310965	19078461		
41540	3440	19059056	1973-04-24	1973-04-24 00:00:00	1973-05-15	1973-05-15 00:00:00	1973-05-15	38000177		0	0	21		0	0	0	228296	0	243670	19059056		
41580	3443	1124300	2012-05-19	2012-05-19 00:00:00	2012-05-19	2012-05-19 00:00:00	\N	38000177		0	0	0		0	0	0	228516	0	00781178901	45011828		
41632	3446	1713671	1991-11-23	1991-11-23 00:00:00	1991-12-14	1991-12-14 00:00:00	1991-12-14	38000177		0	0	21		0	0	0	228812	0	562251	1713671		
9365	778	19128065	1996-12-20	1996-12-20 00:00:00	1997-12-15	1997-12-15 00:00:00	1997-12-15	38000177		0	0	360		0	0	0	51695	0	749882	19128065		
31232	2589	1115171	1998-01-02	1998-01-02 00:00:00	1998-01-16	1998-01-16 00:00:00	1998-01-16	38000177		0	0	14		0	0	0	171329	0	849574	1115171		
9415	782	1127433	1977-11-15	1977-11-15 00:00:00	1977-11-29	1977-11-29 00:00:00	1977-11-29	38000177		0	0	14		0	0	0	52019	0	313782	1127433		
27521	2280	40229134	2015-11-01	2015-11-01 00:00:00	2015-11-15	2015-11-15 00:00:00	2015-11-15	38000177		0	0	14		0	0	0	151618	0	1043400	40229134		
21572	1773	1127433	1982-08-01	1982-08-01 00:00:00	1982-08-08	1982-08-08 00:00:00	1982-08-08	38000177		0	0	7		0	0	0	118524	0	313782	1127433		
46918	3885	19128065	1983-10-07	1983-10-07 00:00:00	1984-10-01	1984-10-01 00:00:00	1984-10-01	38000177		0	0	360		0	0	0	258284	0	749882	19128065		
39146	3236	19059056	1958-10-29	1958-10-29 00:00:00	1958-11-26	1958-11-26 00:00:00	1958-11-26	38000177		0	0	28		0	0	0	215027	0	243670	19059056		
4660	387	1127078	1976-01-18	1976-01-18 00:00:00	1976-02-01	1976-02-01 00:00:00	1976-02-01	38000177		0	0	14		0	0	0	25491	0	282464	1127078		
21903	1796	19128022	1996-03-15	1996-03-15 00:00:00	1997-03-10	1997-03-10 00:00:00	1997-03-10	38000177		0	0	360		0	0	0	120413	0	749785	19128022		
42707	3539	1127078	1983-12-27	1983-12-27 00:00:00	1984-01-10	1984-01-10 00:00:00	1984-01-10	38000177		0	0	14		0	0	0	235106	0	282464	1127078		
52397	4359	19078461	1985-04-01	1985-04-01 00:00:00	1985-04-15	1985-04-15 00:00:00	1985-04-15	38000177		0	0	14		0	0	0	289254	0	310965	19078461		
41213	3417	19133905	1947-04-17	1947-04-17 00:00:00	1947-04-26	1947-04-26 00:00:00	1947-04-26	38000177		0	0	9		0	0	0	226604	0	834102	19133905		
42607	3531	19128065	1981-03-25	1981-03-25 00:00:00	1982-03-20	1982-03-20 00:00:00	1982-03-20	38000177		0	0	360		0	0	0	234575	0	749882	19128065		
62006	5157	19075601	2015-05-14	2015-05-14 00:00:00	2015-05-14	2015-05-14 00:00:00	2015-05-14	38000177		0	0	0		0	0	0	342944	0	309362	19075601		
51471	4278	1124300	1993-07-26	1993-07-26 00:00:00	1993-07-26	1993-07-26 00:00:00	\N	38000177		0	0	0		0	0	0	283926	0	00781178901	45011828		
25948	2135	1115171	2011-05-24	2011-05-24 00:00:00	2011-06-07	2011-06-07 00:00:00	2011-06-07	38000177		0	0	14		0	0	0	142105	0	849574	1115171		
35402	2917	19018935	1989-09-13	1989-09-13 00:00:00	1989-09-13	1989-09-13 00:00:00	\N	38000177		0	0	0		0	0	0	194453	0	197604	19018935		
36528	3013	19129655	1962-03-13	1962-03-13 00:00:00	1962-03-27	1962-03-27 00:00:00	1962-03-27	38000177		0	0	14		0	0	0	200955	0	789980	19129655		
35553	2929	19019979	1975-10-11	1975-10-11 00:00:00	1975-10-25	1975-10-25 00:00:00	1975-10-25	38000177		0	0	14		0	0	0	195395	0	198405	19019979		
5522	461	1127433	1955-04-24	1955-04-24 00:00:00	1955-05-01	1955-05-01 00:00:00	1955-05-01	38000177		0	0	7		0	0	0	30807	0	313782	1127433		
18955	1566	19019979	1979-10-02	1979-10-02 00:00:00	1979-10-30	1979-10-30 00:00:00	1979-10-30	38000177		0	0	28		0	0	0	105010	0	198405	19019979		
11740	975	19133873	1967-10-03	1967-10-03 00:00:00	1967-10-16	1967-10-16 00:00:00	1967-10-16	38000177		0	0	13		0	0	0	65029	0	834061	19133873		
30731	2546	40229134	1989-09-12	1989-09-12 00:00:00	1989-09-19	1989-09-19 00:00:00	1989-09-19	38000177		0	0	7		0	0	0	168508	0	1043400	40229134		
35207	2904	920300	2012-06-06	2012-06-06 00:00:00	2012-06-13	2012-06-13 00:00:00	2012-06-13	38000177		0	0	7		0	0	0	193490	0	311989	920300		
33853	2801	19059056	1968-10-16	1968-10-16 00:00:00	1968-12-15	1968-12-15 00:00:00	1968-12-15	38000177		0	0	60		0	0	0	185605	0	243670	19059056		
33870	2802	1127433	1947-01-28	1947-01-28 00:00:00	1947-02-04	1947-02-04 00:00:00	1947-02-04	38000177		0	0	7		0	0	0	185763	0	313782	1127433		
239454	5256	40213260	2011-10-14	2011-10-14 00:00:00	2011-10-14	2011-10-14 00:00:00	2011-10-14	581452		0	0	0		0	0	0	349740	0	121	40213260		
44468	3680	40229134	1984-09-04	1984-09-04 00:00:00	1984-09-18	1984-09-18 00:00:00	1984-09-18	38000177		0	0	14		0	0	0	244728	0	1043400	40229134		
39276	858	40213227	1996-02-15	1996-02-15 00:00:00	1996-02-15	1996-02-15 00:00:00	1996-02-15	581452		0	0	0		0	0	0	56686	0	113	40213227		
227731	5000	40213201	2004-11-23	2004-11-23 00:00:00	2004-11-23	2004-11-23 00:00:00	2004-11-23	581452		0	0	0		0	0	0	332600	0	33	40213201		
18614	1538	40171902	2008-05-05	2008-05-05 00:00:00	2008-05-05	2008-05-05 00:00:00	\N	38000177		0	0	0		0	0	0	103050	0	897718	40171902		
36015	785	40213260	2013-12-08	2013-12-08 00:00:00	2013-12-08	2013-12-08 00:00:00	2013-12-08	581452		0	0	0		0	0	0	52255	0	121	40213260		
47462	3935	1127433	1952-02-28	1952-02-28 00:00:00	1952-03-13	1952-03-13 00:00:00	1952-03-13	38000177		0	0	14		0	0	0	261574	0	313782	1127433		
37507	3100	19059056	1954-06-06	1954-06-06 00:00:00	1954-06-20	1954-06-20 00:00:00	1954-06-20	38000177		0	0	14		0	0	0	206278	0	243670	19059056		
29267	2423	40165015	1998-09-29	1998-09-29 00:00:00	1998-09-29	1998-09-29 00:00:00	\N	38000177		0	0	0		0	0	0	160719	0	861467	40165015		
168372	3701	40213296	1996-04-15	1996-04-15 00:00:00	1996-04-15	1996-04-15 00:00:00	1996-04-15	581452		0	0	0		0	0	0	246060	0	52	40213296		
4280	354	1713671	2013-08-18	2013-08-18 00:00:00	2013-08-25	2013-08-25 00:00:00	2013-08-25	38000177		0	0	7		0	0	0	23522	0	562251	1713671		
1234	97	920300	1966-12-15	1966-12-15 00:00:00	1966-12-22	1966-12-22 00:00:00	1966-12-22	38000177		0	0	7		0	0	0	6614	0	311989	920300		
33513	2774	19078461	2007-03-20	2007-03-20 00:00:00	2007-04-17	2007-04-17 00:00:00	2007-04-17	38000177		0	0	28		0	0	0	183691	0	310965	19078461		
58720	4876	19133873	1987-04-24	1987-04-24 00:00:00	1987-05-06	1987-05-06 00:00:00	1987-05-06	38000177		0	0	12		0	0	0	324297	0	834061	19133873		
11062	921	1115171	2007-07-08	2007-07-08 00:00:00	2007-08-12	2007-08-12 00:00:00	2007-08-12	38000177		0	0	35		0	0	0	61386	0	849574	1115171		
28163	2328	1127433	1991-01-07	1991-01-07 00:00:00	1991-02-04	1991-02-04 00:00:00	1991-02-04	38000177		0	0	28		0	0	0	154899	0	313782	1127433		
9278	771	40229134	1965-04-08	1965-04-08 00:00:00	1965-04-15	1965-04-15 00:00:00	1965-04-15	38000177		0	0	7		0	0	0	51171	0	1043400	40229134		
8596	718	46275916	1974-10-19	1974-10-19 00:00:00	1974-10-19	1974-10-19 00:00:00	1974-10-19	38000177		0	0	0		0	0	0	47525	0	1660014	46275916		
22457	1846	1713671	1984-03-01	1984-03-01 00:00:00	1984-03-08	1984-03-08 00:00:00	1984-03-08	38000177		0	0	7		0	0	0	123459	0	562251	1713671		
37173	3072	19006318	1960-08-11	1960-08-11 00:00:00	1960-08-25	1960-08-25 00:00:00	1960-08-25	38000177		0	0	14		0	0	0	204486	0	105078	19006318		
94625	2076	40213160	1967-04-06	1967-04-06 00:00:00	1967-04-06	1967-04-06 00:00:00	1967-04-06	581452		0	0	0		0	0	0	138153	0	10	40213160		
115327	2535	40213296	2003-01-12	2003-01-12 00:00:00	2003-01-12	2003-01-12 00:00:00	2003-01-12	581452		0	0	0		0	0	0	167491	0	52	40213296		
13351	1118	1127078	1975-11-30	1975-11-30 00:00:00	1975-12-14	1975-12-14 00:00:00	1975-12-14	38000177		0	0	14		0	0	0	73688	0	282464	1127078		
43377	946	40213296	2000-04-12	2000-04-12 00:00:00	2000-04-12	2000-04-12 00:00:00	2000-04-12	581452		0	0	0		0	0	0	62825	0	52	40213296		
58340	4847	1539411	2013-03-27	2013-03-27 00:00:00	2013-03-27	2013-03-27 00:00:00	\N	38000177		0	0	0		0	0	0	322420	0	312961	1539411		
44801	974	40213296	1996-06-30	1996-06-30 00:00:00	1996-06-30	1996-06-30 00:00:00	1996-06-30	581452		0	0	0		0	0	0	64946	0	52	40213296		
131854	2897	40213296	2003-07-26	2003-07-26 00:00:00	2003-07-26	2003-07-26 00:00:00	2003-07-26	581452		0	0	0		0	0	0	192908	0	52	40213296		
219931	4827	40213198	2015-09-10	2015-09-10 00:00:00	2015-09-10	2015-09-10 00:00:00	2015-09-10	581452		0	0	0		0	0	0	321235	0	133	40213198		
11497	958	1713671	2017-11-23	2017-11-23 00:00:00	2017-12-14	2017-12-14 00:00:00	2017-12-14	38000177		0	0	21		0	0	0	63648	0	562251	1713671		
171809	3777	40213314	1984-08-02	1984-08-02 00:00:00	1984-08-02	1984-08-02 00:00:00	1984-08-02	581452		0	0	0		0	0	0	251047	0	49	40213314		
44759	3703	1551192	1985-03-29	1985-03-29 00:00:00	1985-03-29	1985-03-29 00:00:00	1985-03-29	38000177		0	0	0		0	0	0	246256	0	312617	1551192		
26254	2160	19133873	1974-05-16	1974-05-16 00:00:00	1974-05-28	1974-05-28 00:00:00	1974-05-28	38000177		0	0	12		0	0	0	143977	0	834061	19133873		
7245	607	19059056	1954-07-27	1954-07-27 00:00:00	1954-08-26	1954-08-26 00:00:00	1954-08-26	38000177		0	0	30		0	0	0	40297	0	243670	19059056		
8895	742	40163554	2008-07-21	2008-07-21 00:00:00	2008-07-21	2008-07-21 00:00:00	\N	38000177		0	0	0		0	0	0	49195	0	855332	40163554		
10080	844	1551192	1980-05-09	1980-05-09 00:00:00	1980-05-09	1980-05-09 00:00:00	1980-05-09	38000177		0	0	0		0	0	0	56002	0	312617	1551192		
41541	3440	19059056	1944-01-29	1944-01-29 00:00:00	1944-02-28	1944-02-28 00:00:00	1944-02-28	38000177		0	0	30		0	0	0	228291	0	243670	19059056		
41581	3443	19128065	1992-02-28	1992-02-28 00:00:00	1993-02-22	1993-02-22 00:00:00	1993-02-22	38000177		0	0	360		0	0	0	228500	0	749882	19128065		
41633	3446	40229134	2015-10-04	2015-10-04 00:00:00	2015-10-18	2015-10-18 00:00:00	2015-10-18	38000177		0	0	14		0	0	0	228768	0	1043400	40229134		
9366	778	19128022	1997-12-15	1997-12-15 00:00:00	1998-12-10	1998-12-10 00:00:00	1998-12-10	38000177		0	0	360		0	0	0	51698	0	749785	19128022		
31233	2590	19078461	1979-01-18	1979-01-18 00:00:00	1979-02-22	1979-02-22 00:00:00	1979-02-22	38000177		0	0	35		0	0	0	171406	0	310965	19078461		
9416	782	1127433	1963-11-14	1963-11-14 00:00:00	1963-11-28	1963-11-28 00:00:00	1963-11-28	38000177		0	0	14		0	0	0	51982	0	313782	1127433		
27522	2280	1127078	1972-04-19	1972-04-19 00:00:00	1972-05-03	1972-05-03 00:00:00	1972-05-03	38000177		0	0	14		0	0	0	151609	0	282464	1127078		
21574	1773	1551192	1965-01-14	1965-01-14 00:00:00	1965-01-14	1965-01-14 00:00:00	1965-01-14	38000177		0	0	0		0	0	0	118549	0	312617	1551192		
46920	3885	1127433	1987-09-19	1987-09-19 00:00:00	1987-09-26	1987-09-26 00:00:00	1987-09-26	38000177		0	0	7		0	0	0	258213	0	313782	1127433		
39147	3236	40162522	1958-10-29	1958-10-29 00:00:00	1958-10-29	1958-10-29 00:00:00	\N	38000177		0	0	0		0	0	0	215027	0	857005	40162522		
4661	387	46233988	1976-01-18	1976-01-18 00:00:00	1976-02-01	1976-02-01 00:00:00	1976-02-01	38000177		0	0	14		0	0	0	25491	0	1652673	46233988		
21904	1796	42902245	1998-03-05	1998-03-05 00:00:00	1999-02-28	1999-02-28 00:00:00	1999-02-28	38000177		0	0	360		0	0	0	120415	0	1359133	42902245		
42708	3539	1127433	1983-06-01	1983-06-01 00:00:00	1983-06-15	1983-06-15 00:00:00	1983-06-15	38000177		0	0	14		0	0	0	235094	0	313782	1127433		
52398	4359	1115171	2012-06-17	2012-06-17 00:00:00	2012-08-16	2012-08-16 00:00:00	2012-08-16	38000177		0	0	60		0	0	0	289214	0	849574	1115171		
41214	3417	1127433	1989-03-28	1989-03-28 00:00:00	1989-04-04	1989-04-04 00:00:00	1989-04-04	38000177		0	0	7		0	0	0	226654	0	313782	1127433		
42608	3532	1713671	1999-08-04	1999-08-04 00:00:00	1999-08-18	1999-08-18 00:00:00	1999-08-18	38000177		0	0	14		0	0	0	234646	0	562251	1713671		
62007	5157	40220960	2015-05-14	2015-05-14 00:00:00	2015-05-14	2015-05-14 00:00:00	2015-05-14	38000177		0	0	0		0	0	0	342944	0	1804799	40220960		
51472	4278	1539411	1992-01-10	1992-01-10 00:00:00	1992-01-10	1992-01-10 00:00:00	\N	38000177		0	0	0		0	0	0	283926	0	312961	1539411		
25949	2135	19059056	1961-06-28	1961-06-28 00:00:00	1961-09-26	1961-09-26 00:00:00	1961-09-26	38000177		0	0	90		0	0	0	142100	0	243670	19059056		
35403	2917	40171902	1989-09-13	1989-09-13 00:00:00	1989-09-13	1989-09-13 00:00:00	\N	38000177		0	0	0		0	0	0	194453	0	897718	40171902		
36530	3013	1127433	1962-09-17	1962-09-17 00:00:00	1962-10-01	1962-10-01 00:00:00	1962-10-01	38000177		0	0	14		0	0	0	200896	0	313782	1127433		
35554	2929	1713671	1990-10-17	1990-10-17 00:00:00	1990-10-24	1990-10-24 00:00:00	1990-10-24	38000177		0	0	7		0	0	0	195411	0	562251	1713671		
5523	461	19059056	1950-06-17	1950-06-17 00:00:00	1950-07-01	1950-07-01 00:00:00	1950-07-01	38000177		0	0	14		0	0	0	30833	0	243670	19059056		
18956	1566	1127433	1985-05-01	1985-05-01 00:00:00	1985-05-15	1985-05-15 00:00:00	1985-05-15	38000177		0	0	14		0	0	0	105011	0	313782	1127433		
11741	975	19019979	1975-10-19	1975-10-19 00:00:00	1975-11-02	1975-11-02 00:00:00	1975-11-02	38000177		0	0	14		0	0	0	65031	0	198405	19019979		
30732	2546	40229134	1990-05-19	1990-05-19 00:00:00	1990-06-02	1990-06-02 00:00:00	1990-06-02	38000177		0	0	14		0	0	0	168509	0	1043400	40229134		
35208	2904	1127433	2005-06-17	2005-06-17 00:00:00	2005-06-24	2005-06-24 00:00:00	2005-06-24	38000177		0	0	7		0	0	0	193489	0	313782	1127433		
33854	2801	1127433	2002-03-25	2002-03-25 00:00:00	2002-03-25	2002-03-25 00:00:00	\N	38000177		0	0	0		0	0	0	185617	0	313782	1127433		
33871	2802	19133873	1953-09-01	1953-09-01 00:00:00	1953-09-14	1953-09-14 00:00:00	1953-09-14	38000177		0	0	13		0	0	0	185705	0	834061	19133873		
239457	5256	40213227	2001-09-14	2001-09-14 00:00:00	2001-09-14	2001-09-14 00:00:00	2001-09-14	581452		0	0	0		0	0	0	349735	0	113	40213227		
54947	4562	19059056	1965-05-26	1965-05-26 00:00:00	1965-06-09	1965-06-09 00:00:00	1965-06-09	38000177		0	0	14		0	0	0	304022	0	243670	19059056		
39277	858	40213306	1996-02-15	1996-02-15 00:00:00	1996-02-15	1996-02-15 00:00:00	1996-02-15	581452		0	0	0		0	0	0	56686	0	43	40213306		
227748	5000	40213227	1992-09-15	1992-09-15 00:00:00	1992-09-15	1992-09-15 00:00:00	1992-09-15	581452		0	0	0		0	0	0	332508	0	113	40213227		
18615	1538	40163554	2008-05-05	2008-05-05 00:00:00	2008-05-05	2008-05-05 00:00:00	\N	38000177		0	0	0		0	0	0	103050	0	855332	40163554		
103374	2267	40213160	1970-11-23	1970-11-23 00:00:00	1970-11-23	1970-11-23 00:00:00	1970-11-23	581452		0	0	0		0	0	0	150704	0	10	40213160		
47463	3935	19133905	1987-10-23	1987-10-23 00:00:00	1987-11-01	1987-11-01 00:00:00	1987-11-01	38000177		0	0	9		0	0	0	261567	0	834102	19133905		
37508	3100	19006318	1954-06-06	1954-06-06 00:00:00	1954-06-20	1954-06-20 00:00:00	1954-06-20	38000177		0	0	14		0	0	0	206278	0	105078	19006318		
29268	2423	1127433	2005-10-02	2005-10-02 00:00:00	2005-10-09	2005-10-09 00:00:00	2005-10-09	38000177		0	0	7		0	0	0	160793	0	313782	1127433		
168376	3701	40213227	2004-01-05	2004-01-05 00:00:00	2004-01-05	2004-01-05 00:00:00	2004-01-05	581452		0	0	0		0	0	0	246095	0	113	40213227		
4281	354	40229134	2001-10-18	2001-10-18 00:00:00	2001-10-25	2001-10-25 00:00:00	2001-10-25	38000177		0	0	7		0	0	0	23520	0	1043400	40229134		
1238	99	19128065	1976-09-30	1976-09-30 00:00:00	1977-09-25	1977-09-25 00:00:00	1977-09-25	38000177		0	0	360		0	0	0	6719	0	749882	19128065		
33514	2774	1127433	1946-11-01	1946-11-01 00:00:00	1946-11-08	1946-11-08 00:00:00	1946-11-08	38000177		0	0	7		0	0	0	183638	0	313782	1127433		
58721	4876	1713671	2004-06-12	2004-06-12 00:00:00	2004-07-03	2004-07-03 00:00:00	2004-07-03	38000177		0	0	21		0	0	0	324298	0	562251	1713671		
11063	921	1127433	1989-01-22	1989-01-22 00:00:00	1989-02-21	1989-02-21 00:00:00	1989-02-21	38000177		0	0	30		0	0	0	61383	0	313782	1127433		
28164	2328	1127433	2015-12-26	2015-12-26 00:00:00	2016-01-02	2016-01-02 00:00:00	2016-01-02	38000177		0	0	7		0	0	0	154858	0	313782	1127433		
9279	771	1124300	1998-05-19	1998-05-19 00:00:00	1998-05-19	1998-05-19 00:00:00	\N	38000177		0	0	0		0	0	0	51219	0	00781178901	45011828		
8597	718	40243436	1974-10-19	1974-10-19 00:00:00	1974-10-19	1974-10-19 00:00:00	1974-10-19	38000177		0	0	0		0	0	0	47525	0	1190795	40243436		
22458	1846	1118084	1987-11-09	1987-11-09 00:00:00	1987-11-09	1987-11-09 00:00:00	\N	38000177		0	0	0		0	0	0	123439	0	00025152531	44923712		
37174	3072	1127078	1960-08-11	1960-08-11 00:00:00	1960-08-25	1960-08-25 00:00:00	1960-08-25	38000177		0	0	14		0	0	0	204486	0	282464	1127078		
94627	2076	40213296	2007-07-26	2007-07-26 00:00:00	2007-07-26	2007-07-26 00:00:00	2007-07-26	581452		0	0	0		0	0	0	138141	0	52	40213296		
115329	2535	40213160	1961-06-11	1961-06-11 00:00:00	1961-06-11	1961-06-11 00:00:00	1961-06-11	581452		0	0	0		0	0	0	167543	0	10	40213160		
13352	1118	19006318	1975-11-30	1975-11-30 00:00:00	1975-12-14	1975-12-14 00:00:00	1975-12-14	38000177		0	0	14		0	0	0	73688	0	105078	19006318		
43395	946	40213306	1982-07-28	1982-07-28 00:00:00	1982-07-28	1982-07-28 00:00:00	1982-07-28	581452		0	0	0		0	0	0	62842	0	43	40213306		
58341	4847	19075601	2013-03-27	2013-03-27 00:00:00	2013-03-27	2013-03-27 00:00:00	\N	38000177		0	0	0		0	0	0	322420	0	309362	19075601		
20172	439	40213227	1999-10-21	1999-10-21 00:00:00	1999-10-21	1999-10-21 00:00:00	1999-10-21	581452		0	0	0		0	0	0	29142	0	113	40213227		
131857	2897	40213227	2001-07-21	2001-07-21 00:00:00	2001-07-21	2001-07-21 00:00:00	2001-07-21	581452		0	0	0		0	0	0	192897	0	113	40213227		
8363	180	40213251	1984-04-12	1984-04-12 00:00:00	1984-04-12	1984-04-12 00:00:00	1984-04-12	581452		0	0	0		0	0	0	12177	0	21	40213251		
11498	958	1127433	1990-01-15	1990-01-15 00:00:00	1990-01-22	1990-01-22 00:00:00	1990-01-22	38000177		0	0	7		0	0	0	63635	0	313782	1127433		
171810	3777	40213160	1984-08-02	1984-08-02 00:00:00	1984-08-02	1984-08-02 00:00:00	1984-08-02	581452		0	0	0		0	0	0	251047	0	10	40213160		
44760	3703	19133905	2014-07-22	2014-07-22 00:00:00	2014-07-31	2014-07-31 00:00:00	2014-07-31	38000177		0	0	9		0	0	0	246231	0	834102	19133905		
26255	2160	19078461	2002-03-31	2002-03-31 00:00:00	2002-04-21	2002-04-21 00:00:00	2002-04-21	38000177		0	0	21		0	0	0	143920	0	310965	19078461		
7246	607	19133905	1984-10-20	1984-10-20 00:00:00	1984-10-30	1984-10-30 00:00:00	1984-10-30	38000177		0	0	10		0	0	0	40327	0	834102	19133905		
8896	742	40171902	2008-07-21	2008-07-21 00:00:00	2008-07-21	2008-07-21 00:00:00	\N	38000177		0	0	0		0	0	0	49195	0	897718	40171902		
10081	844	19078461	2002-03-06	2002-03-06 00:00:00	2002-04-10	2002-04-10 00:00:00	2002-04-10	38000177		0	0	35		0	0	0	56005	0	310965	19078461		
41542	3440	19078461	2009-11-10	2009-11-10 00:00:00	2009-12-15	2009-12-15 00:00:00	2009-12-15	38000177		0	0	35		0	0	0	228230	0	310965	19078461		
41582	3443	19128022	1995-02-12	1995-02-12 00:00:00	1996-02-07	1996-02-07 00:00:00	1996-02-07	38000177		0	0	360		0	0	0	228513	0	749785	19128022		
41634	3446	19059056	1944-09-08	1944-09-08 00:00:00	1944-09-22	1944-09-22 00:00:00	1944-09-22	38000177		0	0	14		0	0	0	228769	0	243670	19059056		
65255	1428	40213227	1995-08-30	1995-08-30 00:00:00	1995-08-30	1995-08-30 00:00:00	1995-08-30	581452		0	0	0		0	0	0	95042	0	113	40213227		
31234	2590	19059056	1966-06-27	1966-06-27 00:00:00	1966-07-25	1966-07-25 00:00:00	1966-07-25	38000177		0	0	28		0	0	0	171404	0	243670	19059056		
9417	782	19133905	1938-09-27	1938-09-27 00:00:00	1938-10-10	1938-10-10 00:00:00	1938-10-10	38000177		0	0	13		0	0	0	51991	0	834102	19133905		
27523	2280	40229134	1995-08-28	1995-08-28 00:00:00	1995-09-04	1995-09-04 00:00:00	1995-09-04	38000177		0	0	7		0	0	0	151644	0	1043400	40229134		
21575	1773	1118084	1986-01-29	1986-01-29 00:00:00	1986-01-29	1986-01-29 00:00:00	\N	38000177		0	0	0		0	0	0	118537	0	00025152531	44923712		
46921	3885	1124300	2004-10-26	2004-10-26 00:00:00	2004-10-26	2004-10-26 00:00:00	\N	38000177		0	0	0		0	0	0	258223	0	00781178901	45011828		
39148	3236	19078461	2013-10-09	2013-10-09 00:00:00	2013-11-08	2013-11-08 00:00:00	2013-11-08	38000177		0	0	30		0	0	0	215033	0	310965	19078461		
4662	388	1127433	2006-02-16	2006-02-16 00:00:00	2006-03-02	2006-03-02 00:00:00	2006-03-02	38000177		0	0	14		0	0	0	25586	0	313782	1127433		
21905	1796	19078461	2016-05-01	2016-05-01 00:00:00	2016-06-05	2016-06-05 00:00:00	2016-06-05	38000177		0	0	35		0	0	0	120435	0	310965	19078461		
42709	3539	1127433	1998-08-02	1998-08-02 00:00:00	1998-08-16	1998-08-16 00:00:00	1998-08-16	38000177		0	0	14		0	0	0	235099	0	313782	1127433		
52399	4359	40165015	2012-06-17	2012-06-17 00:00:00	2012-06-17	2012-06-17 00:00:00	\N	38000177		0	0	0		0	0	0	289214	0	861467	40165015		
41215	3417	1127433	2018-03-28	2018-03-28 00:00:00	2018-06-26	2018-06-26 00:00:00	2018-06-26	38000177		0	0	90		0	0	0	226627	0	313782	1127433		
42609	3532	1118084	2007-06-23	2007-06-23 00:00:00	2007-06-23	2007-06-23 00:00:00	\N	38000177		0	0	0		0	0	0	234625	0	00025152531	44923712		
62008	5157	1713671	2004-08-17	2004-08-17 00:00:00	2004-08-31	2004-08-31 00:00:00	2004-08-31	38000177		0	0	14		0	0	0	342883	0	562251	1713671		
51473	4278	19059056	1978-03-18	1978-03-18 00:00:00	1978-04-08	1978-04-08 00:00:00	1978-04-08	38000177		0	0	21		0	0	0	283932	0	243670	19059056		
25950	2135	1713671	1983-12-07	1983-12-07 00:00:00	1983-12-28	1983-12-28 00:00:00	1983-12-28	38000177		0	0	21		0	0	0	142183	0	562251	1713671		
35404	2917	1127433	1964-11-14	1964-11-14 00:00:00	1964-11-28	1964-11-28 00:00:00	1964-11-28	38000177		0	0	14		0	0	0	194433	0	313782	1127433		
36531	3013	19129655	1962-09-17	1962-09-17 00:00:00	1962-10-01	1962-10-01 00:00:00	1962-10-01	38000177		0	0	14		0	0	0	200896	0	789980	19129655		
35555	2929	40162522	1990-10-29	1990-10-29 00:00:00	1990-10-29	1990-10-29 00:00:00	\N	38000177		0	0	0		0	0	0	195382	0	857005	40162522		
5524	461	19006318	1950-06-17	1950-06-17 00:00:00	1950-07-01	1950-07-01 00:00:00	1950-07-01	38000177		0	0	14		0	0	0	30833	0	105078	19006318		
18957	1566	1127078	1970-08-20	1970-08-20 00:00:00	1970-09-19	1970-09-19 00:00:00	1970-09-19	38000177		0	0	30		0	0	0	104982	0	282464	1127078		
11742	975	1127433	2009-07-27	2009-07-27 00:00:00	2009-08-03	2009-08-03 00:00:00	2009-08-03	38000177		0	0	7		0	0	0	65005	0	313782	1127433		
30733	2546	1127433	2014-12-13	2014-12-13 00:00:00	2014-12-20	2014-12-20 00:00:00	2014-12-20	38000177		0	0	7		0	0	0	168482	0	313782	1127433		
35209	2904	19059056	1973-07-24	1973-07-24 00:00:00	1973-08-07	1973-08-07 00:00:00	1973-08-07	38000177		0	0	14		0	0	0	193495	0	243670	19059056		
33855	2801	40162522	2002-03-25	2002-03-25 00:00:00	2002-03-25	2002-03-25 00:00:00	\N	38000177		0	0	0		0	0	0	185617	0	857005	40162522		
33872	2802	1539411	1991-09-28	1991-09-28 00:00:00	1991-09-28	1991-09-28 00:00:00	\N	38000177		0	0	0		0	0	0	185693	0	312961	1539411		
239458	5256	40213296	2001-09-14	2001-09-14 00:00:00	2001-09-14	2001-09-14 00:00:00	2001-09-14	581452		0	0	0		0	0	0	349735	0	52	40213296		
54948	4562	19129655	1965-05-26	1965-05-26 00:00:00	1965-06-09	1965-06-09 00:00:00	1965-06-09	38000177		0	0	14		0	0	0	304022	0	789980	19129655		
39279	858	40213227	2005-02-24	2005-02-24 00:00:00	2005-02-24	2005-02-24 00:00:00	2005-02-24	581452		0	0	0		0	0	0	56677	0	113	40213227		
227750	5000	40213227	2010-07-13	2010-07-13 00:00:00	2010-07-13	2010-07-13 00:00:00	2010-07-13	581452		0	0	0		0	0	0	332571	0	113	40213227		
18616	1538	19018935	2008-05-05	2008-05-05 00:00:00	2008-05-05	2008-05-05 00:00:00	\N	38000177		0	0	0		0	0	0	103050	0	197604	19018935		
103378	2267	40213227	1997-09-01	1997-09-01 00:00:00	1997-09-01	1997-09-01 00:00:00	1997-09-01	581452		0	0	0		0	0	0	150737	0	113	40213227		
47464	3935	19059056	1958-05-25	1958-05-25 00:00:00	1958-06-15	1958-06-15 00:00:00	1958-06-15	38000177		0	0	21		0	0	0	261540	0	243670	19059056		
37509	3100	1127433	1986-03-03	1986-03-03 00:00:00	1986-03-17	1986-03-17 00:00:00	1986-03-17	38000177		0	0	14		0	0	0	206257	0	313782	1127433		
29269	2423	19078461	1992-11-01	1992-11-01 00:00:00	1992-11-22	1992-11-22 00:00:00	1992-11-22	38000177		0	0	21		0	0	0	160766	0	310965	19078461		
168380	3701	40213201	2019-04-01	2019-04-01 00:00:00	2019-04-01	2019-04-01 00:00:00	2019-04-01	581452		0	0	0		0	0	0	246099	0	33	40213201		
4282	354	40236824	1981-01-27	1981-01-27 00:00:00	1981-02-03	1981-02-03 00:00:00	1981-02-03	38000177		0	0	7		0	0	0	23514	0	1094107	40236824		
1239	99	19078461	2001-01-01	2001-01-01 00:00:00	2001-01-15	2001-01-15 00:00:00	2001-01-15	38000177		0	0	14		0	0	0	6730	0	310965	19078461		
33515	2774	1127433	1941-04-17	1941-04-17 00:00:00	1941-04-24	1941-04-24 00:00:00	1941-04-24	38000177		0	0	7		0	0	0	183655	0	313782	1127433		
58722	4876	19128065	1989-05-05	1989-05-05 00:00:00	1990-04-30	1990-04-30 00:00:00	1990-04-30	38000177		0	0	360		0	0	0	324244	0	749882	19128065		
11064	921	1127433	1981-04-13	1981-04-13 00:00:00	1981-05-04	1981-05-04 00:00:00	1981-05-04	38000177		0	0	21		0	0	0	61344	0	313782	1127433		
28165	2328	1127433	1969-12-09	1969-12-09 00:00:00	1969-12-16	1969-12-16 00:00:00	1969-12-16	38000177		0	0	7		0	0	0	154806	0	313782	1127433		
9282	771	19133873	1975-05-28	1975-05-28 00:00:00	1975-06-06	1975-06-06 00:00:00	1975-06-06	38000177		0	0	9		0	0	0	51241	0	834061	19133873		
8598	718	1310034	1974-10-19	1974-10-19 00:00:00	1974-10-19	1974-10-19 00:00:00	1974-10-19	38000177		0	0	0		0	0	0	47525	0	834357	1310034		
22459	1846	40229134	2002-11-30	2002-11-30 00:00:00	2002-12-14	2002-12-14 00:00:00	2002-12-14	38000177		0	0	14		0	0	0	123460	0	1043400	40229134		
37175	3072	1713671	1986-02-28	1986-02-28 00:00:00	1986-03-14	1986-03-14 00:00:00	1986-03-14	38000177		0	0	14		0	0	0	204492	0	562251	1713671		
94629	2076	40213160	1971-12-09	1971-12-09 00:00:00	1971-12-09	1971-12-09 00:00:00	1971-12-09	581452		0	0	0		0	0	0	138165	0	10	40213160		
115336	2535	40213160	1965-12-12	1965-12-12 00:00:00	1965-12-12	1965-12-12 00:00:00	1965-12-12	581452		0	0	0		0	0	0	167546	0	10	40213160		
13359	1120	19128065	1978-11-02	1978-11-02 00:00:00	1979-10-28	1979-10-28 00:00:00	1979-10-28	38000177		0	0	360		0	0	0	73803	0	749882	19128065		
124792	2745	40213227	1993-04-18	1993-04-18 00:00:00	1993-04-18	1993-04-18 00:00:00	1993-04-18	581452		0	0	0		0	0	0	181595	0	113	40213227		
58342	4847	1332419	2013-03-27	2013-03-27 00:00:00	2013-03-27	2013-03-27 00:00:00	\N	38000177		0	0	0		0	0	0	322420	0	197361	1332419		
20173	439	40213306	1999-10-21	1999-10-21 00:00:00	1999-10-21	1999-10-21 00:00:00	1999-10-21	581452		0	0	0		0	0	0	29142	0	43	40213306		
131858	2897	40213296	2001-07-21	2001-07-21 00:00:00	2001-07-21	2001-07-21 00:00:00	2001-07-21	581452		0	0	0		0	0	0	192897	0	52	40213296		
8366	180	40213227	2008-07-17	2008-07-17 00:00:00	2008-07-17	2008-07-17 00:00:00	2008-07-17	581452		0	0	0		0	0	0	12202	0	113	40213227		
11499	958	19133905	2012-12-07	2012-12-07 00:00:00	2012-12-16	2012-12-16 00:00:00	2012-12-16	38000177		0	0	9		0	0	0	63646	0	834102	19133905		
171825	3778	40213160	1965-01-10	1965-01-10 00:00:00	1965-01-10	1965-01-10 00:00:00	1965-01-10	581452		0	0	0		0	0	0	251053	0	10	40213160		
44761	3703	1124300	2010-07-01	2010-07-01 00:00:00	2010-07-01	2010-07-01 00:00:00	\N	38000177		0	0	0		0	0	0	246297	0	00781178901	45011828		
26256	2160	40165015	2012-07-02	2012-07-02 00:00:00	2012-07-02	2012-07-02 00:00:00	\N	38000177		0	0	0		0	0	0	143996	0	861467	40165015		
7247	607	1118084	1991-02-23	1991-02-23 00:00:00	1991-02-23	1991-02-23 00:00:00	\N	38000177		0	0	0		0	0	0	40309	0	00025152531	44923712		
8897	742	1118084	1968-02-19	1968-02-19 00:00:00	1968-02-19	1968-02-19 00:00:00	\N	38000177		0	0	0		0	0	0	49169	0	00025152531	44923712		
10082	844	1118084	2002-09-26	2002-09-26 00:00:00	2002-09-26	2002-09-26 00:00:00	\N	38000177		0	0	0		0	0	0	56005	0	00025152531	44923712		
41543	3440	40162522	1959-01-10	1959-01-10 00:00:00	1959-01-10	1959-01-10 00:00:00	\N	38000177		0	0	0		0	0	0	228293	0	857005	40162522		
41583	3443	19128022	1993-02-22	1993-02-22 00:00:00	1994-02-17	1994-02-17 00:00:00	1994-02-17	38000177		0	0	360		0	0	0	228501	0	749785	19128022		
41635	3446	1127433	2000-09-20	2000-09-20 00:00:00	2000-10-04	2000-10-04 00:00:00	2000-10-04	38000177		0	0	14		0	0	0	228785	0	313782	1127433		
65274	1428	40213227	2016-01-05	2016-01-05 00:00:00	2016-01-05	2016-01-05 00:00:00	2016-01-05	581452		0	0	0		0	0	0	95007	0	113	40213227		
31235	2590	1127433	1980-02-17	1980-02-17 00:00:00	1980-03-09	1980-03-09 00:00:00	1980-03-09	38000177		0	0	21		0	0	0	171407	0	313782	1127433		
9418	782	1127433	1954-06-12	1954-06-12 00:00:00	1954-08-18	1954-08-18 00:00:00	1954-08-18	38000177		0	0	67		0	0	0	52018	0	313782	1127433		
27524	2280	19133905	1993-04-04	1993-04-04 00:00:00	1993-04-15	1993-04-15 00:00:00	1993-04-15	38000177		0	0	11		0	0	0	151670	0	834102	19133905		
21576	1773	1127433	1992-01-12	1992-01-12 00:00:00	1992-02-16	1992-02-16 00:00:00	1992-02-16	38000177		0	0	35		0	0	0	118553	0	313782	1127433		
46922	3885	1127433	2014-06-18	2014-06-18 00:00:00	2014-06-25	2014-06-25 00:00:00	2014-06-25	38000177		0	0	7		0	0	0	258227	0	313782	1127433		
39149	3236	1127433	2003-06-28	2003-06-28 00:00:00	2003-07-12	2003-07-12 00:00:00	2003-07-12	38000177		0	0	14		0	0	0	215128	0	313782	1127433		
4663	388	19059056	1957-08-20	1957-08-20 00:00:00	1957-09-03	1957-09-03 00:00:00	1957-09-03	38000177		0	0	14		0	0	0	25528	0	243670	19059056		
21906	1796	1118084	2017-09-06	2017-09-06 00:00:00	2017-09-06	2017-09-06 00:00:00	\N	38000177		0	0	0		0	0	0	120426	0	00025152531	44923712		
42710	3539	19073183	1984-09-15	1984-09-15 00:00:00	1984-09-29	1984-09-29 00:00:00	1984-09-29	38000177		0	0	14		0	0	0	235084	0	308182	19073183		
52400	4359	1127433	1999-06-11	1999-06-11 00:00:00	1999-06-18	1999-06-18 00:00:00	1999-06-18	38000177		0	0	7		0	0	0	289224	0	313782	1127433		
41216	3418	1118084	1977-07-30	1977-07-30 00:00:00	1977-07-30	1977-07-30 00:00:00	\N	38000177		0	0	0		0	0	0	226787	0	00025152531	44923712		
42610	3532	19133873	1981-10-13	1981-10-13 00:00:00	1981-10-25	1981-10-25 00:00:00	1981-10-25	38000177		0	0	12		0	0	0	234644	0	834061	19133873		
62009	5157	1127433	1980-08-10	1980-08-10 00:00:00	1980-08-24	1980-08-24 00:00:00	1980-08-24	38000177		0	0	14		0	0	0	342881	0	313782	1127433		
51474	4278	19133905	2000-12-24	2000-12-24 00:00:00	2001-01-05	2001-01-05 00:00:00	2001-01-05	38000177		0	0	12		0	0	0	283940	0	834102	19133905		
25951	2135	1118084	1983-11-15	1983-11-15 00:00:00	1983-11-15	1983-11-15 00:00:00	\N	38000177		0	0	0		0	0	0	142148	0	00025152531	44923712		
35405	2917	1713671	2007-08-31	2007-08-31 00:00:00	2007-09-07	2007-09-07 00:00:00	2007-09-07	38000177		0	0	7		0	0	0	194498	0	562251	1713671		
36532	3013	19133873	1963-05-06	1963-05-06 00:00:00	1963-05-14	1963-05-14 00:00:00	1963-05-14	38000177		0	0	8		0	0	0	200938	0	834061	19133873		
35576	2933	19059056	1958-08-29	1958-08-29 00:00:00	1958-09-26	1958-09-26 00:00:00	1958-09-26	38000177		0	0	28		0	0	0	195603	0	243670	19059056		
5525	461	1127433	1951-12-10	1951-12-10 00:00:00	1951-12-24	1951-12-24 00:00:00	1951-12-24	38000177		0	0	14		0	0	0	30805	0	313782	1127433		
18958	1566	1118084	2002-11-10	2002-11-10 00:00:00	2002-11-10	2002-11-10 00:00:00	\N	38000177		0	0	0		0	0	0	105034	0	00025152531	44923712		
11743	975	19059056	1972-01-08	1972-01-08 00:00:00	1972-02-07	1972-02-07 00:00:00	1972-02-07	38000177		0	0	30		0	0	0	65030	0	243670	19059056		
30734	2546	19133873	1981-04-27	1981-04-27 00:00:00	1981-05-09	1981-05-09 00:00:00	1981-05-09	38000177		0	0	12		0	0	0	168461	0	834061	19133873		
35210	2904	46233988	1973-07-24	1973-07-24 00:00:00	1973-08-07	1973-08-07 00:00:00	1973-08-07	38000177		0	0	14		0	0	0	193495	0	1652673	46233988		
33856	2801	19078461	1985-03-26	1985-03-26 00:00:00	1985-04-23	1985-04-23 00:00:00	1985-04-23	38000177		0	0	28		0	0	0	185616	0	310965	19078461		
33873	2802	19059056	1949-12-09	1949-12-09 00:00:00	1949-12-30	1949-12-30 00:00:00	1949-12-30	38000177		0	0	21		0	0	0	185709	0	243670	19059056		
239461	5256	40213296	2003-09-19	2003-09-19 00:00:00	2003-09-19	2003-09-19 00:00:00	2003-09-19	581452		0	0	0		0	0	0	349756	0	52	40213296		
54949	4562	40229134	1975-09-14	1975-09-14 00:00:00	1975-09-21	1975-09-21 00:00:00	1975-09-21	38000177		0	0	7		0	0	0	304057	0	1043400	40229134		
39281	858	40213314	1977-11-17	1977-11-17 00:00:00	1977-11-17	1977-11-17 00:00:00	1977-11-17	581452		0	0	0		0	0	0	56681	0	49	40213314		
26861	2213	40232448	1991-08-01	1991-08-01 00:00:00	1991-08-01	1991-08-01 00:00:00	\N	38000177		0	0	0		0	0	0	147361	0	1049630	40232448		
18617	1538	40229134	1960-05-18	1960-05-18 00:00:00	1960-05-25	1960-05-25 00:00:00	1960-05-25	38000177		0	0	7		0	0	0	103055	0	1043400	40229134		
103380	2267	40213160	1966-05-23	1966-05-23 00:00:00	1966-05-23	1966-05-23 00:00:00	1966-05-23	581452		0	0	0		0	0	0	150700	0	10	40213160		
47465	3935	1127433	1987-05-16	1987-05-16 00:00:00	1987-05-30	1987-05-30 00:00:00	1987-05-30	38000177		0	0	14		0	0	0	261553	0	313782	1127433		
47989	3980	1713671	1997-02-02	1997-02-02 00:00:00	1997-02-23	1997-02-23 00:00:00	1997-02-23	38000177		0	0	21		0	0	0	264616	0	562251	1713671		
29270	2423	19133873	1967-12-08	1967-12-08 00:00:00	1967-12-16	1967-12-16 00:00:00	1967-12-16	38000177		0	0	8		0	0	0	160727	0	834061	19133873		
168385	3701	40213160	1955-08-29	1955-08-29 00:00:00	1955-08-29	1955-08-29 00:00:00	1955-08-29	581452		0	0	0		0	0	0	\N	0	10	40213160		
4283	354	920300	1981-01-27	1981-01-27 00:00:00	1981-02-03	1981-02-03 00:00:00	1981-02-03	38000177		0	0	7		0	0	0	23514	0	311989	920300		
1240	99	1713671	1976-09-30	1976-09-30 00:00:00	1976-10-14	1976-10-14 00:00:00	1976-10-14	38000177		0	0	14		0	0	0	6707	0	562251	1713671		
33516	2774	19133905	2004-04-06	2004-04-06 00:00:00	2004-04-13	2004-04-13 00:00:00	2004-04-13	38000177		0	0	7		0	0	0	183660	0	834102	19133905		
58723	4876	1118084	2013-08-28	2013-08-28 00:00:00	2013-08-28	2013-08-28 00:00:00	\N	38000177		0	0	0		0	0	0	324281	0	00025152531	44923712		
11065	921	19059056	1968-05-11	1968-05-11 00:00:00	1968-05-25	1968-05-25 00:00:00	1968-05-25	38000177		0	0	14		0	0	0	61341	0	243670	19059056		
28166	2328	1713671	2005-11-13	2005-11-13 00:00:00	2005-11-27	2005-11-27 00:00:00	2005-11-27	38000177		0	0	14		0	0	0	154857	0	562251	1713671		
9283	771	19128065	1980-10-25	1980-10-25 00:00:00	1981-10-20	1981-10-20 00:00:00	1981-10-20	38000177		0	0	360		0	0	0	51228	0	749882	19128065		
8599	718	40229134	1983-10-26	1983-10-26 00:00:00	1983-11-09	1983-11-09 00:00:00	1983-11-09	38000177		0	0	14		0	0	0	47440	0	1043400	40229134		
22460	1846	1115171	2003-06-23	2003-06-23 00:00:00	2003-07-14	2003-07-14 00:00:00	2003-07-14	38000177		0	0	21		0	0	0	123468	0	849574	1115171		
37180	3074	1127433	1968-04-07	1968-04-07 00:00:00	1968-04-21	1968-04-21 00:00:00	1968-04-21	38000177		0	0	14		0	0	0	204595	0	313782	1127433		
94633	2076	40213227	2009-07-30	2009-07-30 00:00:00	2009-07-30	2009-07-30 00:00:00	2009-07-30	581452		0	0	0		0	0	0	138180	0	113	40213227		
115345	2535	40213296	2001-01-07	2001-01-07 00:00:00	2001-01-07	2001-01-07 00:00:00	2001-01-07	581452		0	0	0		0	0	0	167513	0	52	40213296		
13360	1120	40236824	2015-01-01	2015-01-01 00:00:00	2015-01-08	2015-01-08 00:00:00	2015-01-08	38000177		0	0	7		0	0	0	73790	0	1094107	40236824		
124793	2745	40213306	1993-04-18	1993-04-18 00:00:00	1993-04-18	1993-04-18 00:00:00	1993-04-18	581452		0	0	0		0	0	0	181595	0	43	40213306		
58343	4847	19059056	1947-05-12	1947-05-12 00:00:00	1947-05-26	1947-05-26 00:00:00	1947-05-26	38000177		0	0	14		0	0	0	322475	0	243670	19059056		
20177	439	40213314	1978-03-09	1978-03-09 00:00:00	1978-03-09	1978-03-09 00:00:00	1978-03-09	581452		0	0	0		0	0	0	29122	0	49	40213314		
131859	2897	40213160	1960-11-12	1960-11-12 00:00:00	1960-11-12	1960-11-12 00:00:00	1960-11-12	581452		0	0	0		0	0	0	192928	0	10	40213160		
8374	180	40213314	1978-06-29	1978-06-29 00:00:00	1978-06-29	1978-06-29 00:00:00	1978-06-29	581452		0	0	0		0	0	0	12173	0	49	40213314		
11500	958	1118084	1993-08-15	1993-08-15 00:00:00	1993-08-15	1993-08-15 00:00:00	\N	38000177		0	0	0		0	0	0	63619	0	00025152531	44923712		
171829	3778	40213227	1995-12-17	1995-12-17 00:00:00	1995-12-17	1995-12-17 00:00:00	1995-12-17	581452		0	0	0		0	0	0	251102	0	113	40213227		
44762	3703	40229134	2013-08-09	2013-08-09 00:00:00	2013-08-16	2013-08-16 00:00:00	2013-08-16	38000177		0	0	7		0	0	0	246230	0	1043400	40229134		
26257	2160	1115171	1997-09-09	1997-09-09 00:00:00	1997-09-23	1997-09-23 00:00:00	1997-09-23	38000177		0	0	14		0	0	0	143919	0	849574	1115171		
7248	607	1713671	1969-08-16	1969-08-16 00:00:00	1969-08-23	1969-08-23 00:00:00	1969-08-23	38000177		0	0	7		0	0	0	40323	0	562251	1713671		
8898	742	1713671	2011-03-16	2011-03-16 00:00:00	2011-03-23	2011-03-23 00:00:00	2011-03-23	38000177		0	0	7		0	0	0	49222	0	562251	1713671		
10083	844	40231925	1979-01-15	1979-01-15 00:00:00	1979-01-15	1979-01-15 00:00:00	\N	38000177		0	0	0		0	0	0	56001	0	1049221	40231925		
41544	3440	1127433	1959-01-10	1959-01-10 00:00:00	1959-01-24	1959-01-24 00:00:00	1959-01-24	38000177		0	0	14		0	0	0	228293	0	313782	1127433		
41584	3443	43012754	2003-01-01	2003-01-01 00:00:00	2003-12-27	2003-12-27 00:00:00	2003-12-27	38000177		0	0	360		0	0	0	228461	0	1366343	43012754		
41636	3446	1127433	1995-11-02	1995-11-02 00:00:00	1995-11-16	1995-11-16 00:00:00	1995-11-16	38000177		0	0	14		0	0	0	228784	0	313782	1127433		
10667	886	1127433	1998-11-19	1998-11-19 00:00:00	1998-12-03	1998-12-03 00:00:00	1998-12-03	38000177		0	0	14		0	0	0	59060	0	313782	1127433		
31236	2590	1118084	2002-09-21	2002-09-21 00:00:00	2002-09-21	2002-09-21 00:00:00	\N	38000177		0	0	0		0	0	0	171360	0	00025152531	44923712		
9419	782	19078461	1990-05-09	1990-05-09 00:00:00	1990-07-08	1990-07-08 00:00:00	1990-07-08	38000177		0	0	60		0	0	0	52021	0	310965	19078461		
27525	2280	19133873	1976-04-16	1976-04-16 00:00:00	1976-04-28	1976-04-28 00:00:00	1976-04-28	38000177		0	0	12		0	0	0	151560	0	834061	19133873		
21577	1773	1713671	1984-09-10	1984-09-10 00:00:00	1984-09-24	1984-09-24 00:00:00	1984-09-24	38000177		0	0	14		0	0	0	118573	0	562251	1713671		
46923	3885	1127433	2011-12-19	2011-12-19 00:00:00	2012-01-02	2012-01-02 00:00:00	2012-01-02	38000177		0	0	14		0	0	0	258220	0	313782	1127433		
39150	3236	40171902	1982-12-24	1982-12-24 00:00:00	1982-12-24	1982-12-24 00:00:00	\N	38000177		0	0	0		0	0	0	215073	0	897718	40171902		
4664	388	19006318	1957-08-20	1957-08-20 00:00:00	1957-09-03	1957-09-03 00:00:00	1957-09-03	38000177		0	0	14		0	0	0	25528	0	105078	19006318		
21907	1796	19128263	2004-02-02	2004-02-02 00:00:00	2005-01-27	2005-01-27 00:00:00	2005-01-27	38000177		0	0	360		0	0	0	120388	0	751905	19128263		
42711	3539	1127078	1984-09-15	1984-09-15 00:00:00	1984-09-29	1984-09-29 00:00:00	1984-09-29	38000177		0	0	14		0	0	0	235084	0	282464	1127078		
52404	4359	19133873	1950-01-20	1950-01-20 00:00:00	1950-01-30	1950-01-30 00:00:00	1950-01-30	38000177		0	0	10		0	0	0	289187	0	834061	19133873		
41217	3418	19006318	1949-07-17	1949-07-17 00:00:00	1949-07-31	1949-07-31 00:00:00	1949-07-31	38000177		0	0	14		0	0	0	226734	0	105078	19006318		
42611	3532	19078461	2017-01-27	2017-01-27 00:00:00	2017-02-17	2017-02-17 00:00:00	2017-02-17	38000177		0	0	21		0	0	0	234633	0	310965	19078461		
62010	5157	1127078	1974-02-12	1974-02-12 00:00:00	1974-03-14	1974-03-14 00:00:00	1974-03-14	38000177		0	0	30		0	0	0	342945	0	282464	1127078		
51475	4278	40169281	1988-03-11	1988-03-11 00:00:00	1988-03-11	1988-03-11 00:00:00	\N	38000177		0	0	0		0	0	0	283896	0	896209	40169281		
25952	2135	1127433	1967-05-12	1967-05-12 00:00:00	1967-05-19	1967-05-19 00:00:00	1967-05-19	38000177		0	0	7		0	0	0	142161	0	313782	1127433		
35406	2917	1127433	1941-02-10	1941-02-10 00:00:00	1941-02-17	1941-02-17 00:00:00	1941-02-17	38000177		0	0	7		0	0	0	194465	0	313782	1127433		
36533	3013	1127433	2007-05-02	2007-05-02 00:00:00	2007-05-09	2007-05-09 00:00:00	2007-05-09	38000177		0	0	7		0	0	0	200974	0	313782	1127433		
35577	2933	1124300	1998-07-30	1998-07-30 00:00:00	1998-07-30	1998-07-30 00:00:00	\N	38000177		0	0	0		0	0	0	195610	0	00781178901	45011828		
5526	461	19075601	1998-01-06	1998-01-06 00:00:00	1998-01-06	1998-01-06 00:00:00	1998-01-06	38000177		0	0	0		0	0	0	30785	0	309362	19075601		
18959	1566	40169216	1970-11-10	1970-11-10 00:00:00	1970-11-10	1970-11-10 00:00:00	\N	38000177		0	0	0		0	0	0	105052	0	895994	40169216		
11744	975	1127433	1979-12-11	1979-12-11 00:00:00	1980-01-17	1980-01-17 00:00:00	1980-01-17	38000177		0	0	37		0	0	0	65022	0	313782	1127433		
30748	2548	19133873	1967-12-25	1967-12-25 00:00:00	1968-01-06	1968-01-06 00:00:00	1968-01-06	38000177		0	0	12		0	0	0	168694	0	834061	19133873		
35211	2904	19133905	2006-05-12	2006-05-12 00:00:00	2006-05-24	2006-05-24 00:00:00	2006-05-24	38000177		0	0	12		0	0	0	193485	0	834102	19133905		
33857	2801	40223774	1997-12-27	1997-12-27 00:00:00	1997-12-27	1997-12-27 00:00:00	\N	38000177		0	0	0		0	0	0	185582	0	998582	40223774		
33874	2802	19006318	1949-12-09	1949-12-09 00:00:00	1949-12-30	1949-12-30 00:00:00	1949-12-30	38000177		0	0	21		0	0	0	185709	0	105078	19006318		
239463	5256	40213160	1960-07-22	1960-07-22 00:00:00	1960-07-22	1960-07-22 00:00:00	1960-07-22	581452		0	0	0		0	0	0	349763	0	10	40213160		
54950	4562	19008572	1971-11-04	1971-11-04 00:00:00	1971-11-18	1971-11-18 00:00:00	1971-11-18	38000177		0	0	14		0	0	0	303999	0	106258	19008572		
39284	858	40213160	1974-07-25	1974-07-25 00:00:00	1974-07-25	1974-07-25 00:00:00	1974-07-25	581452		0	0	0		0	0	0	56711	0	10	40213160		
26862	2213	1127433	2004-09-04	2004-09-04 00:00:00	2004-09-18	2004-09-18 00:00:00	2004-09-18	38000177		0	0	14		0	0	0	147391	0	313782	1127433		
18618	1538	1127433	1999-07-05	1999-07-05 00:00:00	1999-07-26	1999-07-26 00:00:00	1999-07-26	38000177		0	0	21		0	0	0	102947	0	313782	1127433		
103386	2267	40213296	2007-12-24	2007-12-24 00:00:00	2007-12-24	2007-12-24 00:00:00	2007-12-24	581452		0	0	0		0	0	0	150739	0	52	40213296		
47466	3935	1127433	1958-01-15	1958-01-15 00:00:00	1958-01-22	1958-01-22 00:00:00	1958-01-22	38000177		0	0	7		0	0	0	261559	0	313782	1127433		
47990	3980	19073183	1980-02-28	1980-02-28 00:00:00	1980-03-13	1980-03-13 00:00:00	1980-03-13	38000177		0	0	14		0	0	0	264565	0	308182	19073183		
29271	2423	19059056	1962-05-24	1962-05-24 00:00:00	1962-06-14	1962-06-14 00:00:00	1962-06-14	38000177		0	0	21		0	0	0	160763	0	243670	19059056		
168388	3701	40213227	2014-03-03	2014-03-03 00:00:00	2014-03-03	2014-03-03 00:00:00	2014-03-03	581452		0	0	0		0	0	0	246117	0	113	40213227		
4284	354	19128065	1975-12-01	1975-12-01 00:00:00	1976-11-25	1976-11-25 00:00:00	1976-11-25	38000177		0	0	360		0	0	0	23552	0	749882	19128065		
1242	99	1127433	2015-09-20	2015-09-20 00:00:00	2015-12-19	2015-12-19 00:00:00	2015-12-19	38000177		0	0	90		0	0	0	6733	0	313782	1127433		
33517	2774	40229134	1975-04-23	1975-04-23 00:00:00	1975-05-07	1975-05-07 00:00:00	1975-05-07	38000177		0	0	14		0	0	0	183640	0	1043400	40229134		
58724	4876	19073188	1987-12-28	1987-12-28 00:00:00	1988-01-11	1988-01-11 00:00:00	1988-01-11	38000177		0	0	14		0	0	0	324265	0	308192	19073188		
11066	921	1118084	2004-04-02	2004-04-02 00:00:00	2004-04-02	2004-04-02 00:00:00	\N	38000177		0	0	0		0	0	0	61375	0	00025152531	44923712		
28167	2328	1713671	1985-12-25	1985-12-25 00:00:00	1986-01-15	1986-01-15 00:00:00	1986-01-15	38000177		0	0	21		0	0	0	154865	0	562251	1713671		
17097	369	40213227	2003-07-19	2003-07-19 00:00:00	2003-07-19	2003-07-19 00:00:00	2003-07-19	581452		0	0	0		0	0	0	24573	0	113	40213227		
8600	718	1115171	2007-06-10	2007-06-10 00:00:00	2007-07-08	2007-07-08 00:00:00	2007-07-08	38000177		0	0	28		0	0	0	47527	0	849574	1115171		
22461	1847	1127433	1931-08-15	1931-08-15 00:00:00	1931-08-22	1931-08-22 00:00:00	1931-08-22	38000177		0	0	7		0	0	0	123573	0	313782	1127433		
37181	3074	40229134	1972-09-28	1972-09-28 00:00:00	1972-10-12	1972-10-12 00:00:00	1972-10-12	38000177		0	0	14		0	0	0	204538	0	1043400	40229134		
94634	2076	40213296	2009-07-30	2009-07-30 00:00:00	2009-07-30	2009-07-30 00:00:00	2009-07-30	581452		0	0	0		0	0	0	138180	0	52	40213296		
180185	3960	40213160	1958-05-24	1958-05-24 00:00:00	1958-05-24	1958-05-24 00:00:00	1958-05-24	581452		0	0	0		0	0	0	263273	0	10	40213160		
13361	1120	920300	2015-01-01	2015-01-01 00:00:00	2015-01-08	2015-01-08 00:00:00	2015-01-08	38000177		0	0	7		0	0	0	73790	0	311989	920300		
124798	2745	40213160	1971-11-28	1971-11-28 00:00:00	1971-11-28	1971-11-28 00:00:00	1971-11-28	581452		0	0	0		0	0	0	181589	0	10	40213160		
58344	4847	1713671	2005-03-26	2005-03-26 00:00:00	2005-04-02	2005-04-02 00:00:00	2005-04-02	38000177		0	0	7		0	0	0	322464	0	562251	1713671		
20178	439	40213160	1978-03-09	1978-03-09 00:00:00	1978-03-09	1978-03-09 00:00:00	1978-03-09	581452		0	0	0		0	0	0	29122	0	10	40213160		
131861	2897	40213160	1965-05-15	1965-05-15 00:00:00	1965-05-15	1965-05-15 00:00:00	1965-05-15	581452		0	0	0		0	0	0	192931	0	10	40213160		
8377	180	40213160	1977-12-29	1977-12-29 00:00:00	1977-12-29	1977-12-29 00:00:00	1977-12-29	581452		0	0	0		0	0	0	12101	0	10	40213160		
11501	958	1127433	2013-12-06	2013-12-06 00:00:00	2013-12-13	2013-12-13 00:00:00	2013-12-13	38000177		0	0	7		0	0	0	63611	0	313782	1127433		
171831	3778	40213306	1986-12-07	1986-12-07 00:00:00	1986-12-07	1986-12-07 00:00:00	1986-12-07	581452		0	0	0		0	0	0	251069	0	43	40213306		
44763	3703	19059056	1969-12-18	1969-12-18 00:00:00	1970-01-08	1970-01-08 00:00:00	1970-01-08	38000177		0	0	21		0	0	0	246252	0	243670	19059056		
26258	2160	40236824	1993-10-27	1993-10-27 00:00:00	1993-11-10	1993-11-10 00:00:00	1993-11-10	38000177		0	0	14		0	0	0	143962	0	1094107	40236824		
7249	608	1545959	2005-07-13	2005-07-13 00:00:00	2005-07-13	2005-07-13 00:00:00	2005-07-13	38000177		0	0	0		0	0	0	40409	0	259255	1545959		
8899	742	1127433	1952-10-20	1952-10-20 00:00:00	1952-11-10	1952-11-10 00:00:00	1952-11-10	38000177		0	0	21		0	0	0	49187	0	313782	1127433		
10084	844	19078461	1979-01-15	1979-01-15 00:00:00	1979-03-16	1979-03-16 00:00:00	1979-03-16	38000177		0	0	60		0	0	0	56001	0	310965	19078461		
41545	3440	19006318	1959-01-10	1959-01-10 00:00:00	1959-01-24	1959-01-24 00:00:00	1959-01-24	38000177		0	0	14		0	0	0	228293	0	105078	19006318		
41585	3443	19078461	2018-11-28	2018-11-28 00:00:00	2018-12-26	2018-12-26 00:00:00	2018-12-26	38000177		0	0	28		0	0	0	228486	0	310965	19078461		
41637	3446	1127433	1972-08-01	1972-08-01 00:00:00	1972-08-08	1972-08-08 00:00:00	1972-08-08	38000177		0	0	7		0	0	0	228809	0	313782	1127433		
10668	886	40229134	2016-02-19	2016-02-19 00:00:00	2016-02-26	2016-02-26 00:00:00	2016-02-26	38000177		0	0	7		0	0	0	59063	0	1043400	40229134		
31237	2590	1127433	2000-12-06	2000-12-06 00:00:00	2000-12-13	2000-12-13 00:00:00	2000-12-13	38000177		0	0	7		0	0	0	171360	0	313782	1127433		
9420	782	1118084	1944-10-27	1944-10-27 00:00:00	1944-10-27	1944-10-27 00:00:00	\N	38000177		0	0	0		0	0	0	52022	0	00025152531	44923712		
27526	2280	19008572	1975-06-11	1975-06-11 00:00:00	1978-03-14	1978-03-14 00:00:00	1978-03-14	38000177		0	0	1007		0	0	0	151585	0	106258	19008572		
218881	4804	40213314	1977-08-29	1977-08-29 00:00:00	1977-08-29	1977-08-29 00:00:00	1977-08-29	581452		0	0	0		0	0	0	319648	0	49	40213314		
46924	3885	19059056	1984-03-21	1984-03-21 00:00:00	1984-04-18	1984-04-18 00:00:00	1984-04-18	38000177		0	0	28		0	0	0	258216	0	243670	19059056		
39151	3236	40163554	1982-12-24	1982-12-24 00:00:00	1982-12-24	1982-12-24 00:00:00	\N	38000177		0	0	0		0	0	0	215073	0	855332	40163554		
4665	388	19115351	2017-09-26	2017-09-26 00:00:00	2018-01-09	2018-01-09 00:00:00	2018-01-09	38000177		0	0	105		0	0	0	25588	0	563026	19115351		
21908	1796	19128022	1997-03-10	1997-03-10 00:00:00	1998-03-05	1998-03-05 00:00:00	1998-03-05	38000177		0	0	360		0	0	0	120414	0	749785	19128022		
42712	3539	1127433	2011-08-19	2011-08-19 00:00:00	2011-09-02	2011-09-02 00:00:00	2011-09-02	38000177		0	0	14		0	0	0	235102	0	313782	1127433		
52405	4359	1127433	1970-10-17	1970-10-17 00:00:00	1970-10-24	1970-10-24 00:00:00	1970-10-24	38000177		0	0	7		0	0	0	289222	0	313782	1127433		
41218	3418	19059056	1949-07-17	1949-07-17 00:00:00	1949-07-31	1949-07-31 00:00:00	1949-07-31	38000177		0	0	14		0	0	0	226734	0	243670	19059056		
42612	3532	1127078	1972-09-29	1972-09-29 00:00:00	1972-10-13	1972-10-13 00:00:00	1972-10-13	38000177		0	0	14		0	0	0	234650	0	282464	1127078		
62011	5157	40163554	2019-05-16	2019-05-16 00:00:00	2019-05-16	2019-05-16 00:00:00	\N	38000177		0	0	0		0	0	0	342902	0	855332	40163554		
51476	4278	1332419	1994-01-14	1994-01-14 00:00:00	1994-01-14	1994-01-14 00:00:00	\N	38000177		0	0	0		0	0	0	283919	0	197361	1332419		
25955	2135	1127078	1953-02-05	1953-02-05 00:00:00	1953-03-12	1953-03-12 00:00:00	1953-03-12	38000177		0	0	35		0	0	0	142159	0	282464	1127078		
35407	2917	1127433	2016-08-31	2016-08-31 00:00:00	2016-09-14	2016-09-14 00:00:00	2016-09-14	38000177		0	0	14		0	0	0	194504	0	313782	1127433		
36534	3013	1115171	2014-05-05	2014-05-05 00:00:00	2014-08-03	2014-08-03 00:00:00	2014-08-03	38000177		0	0	90		0	0	0	200967	0	849574	1115171		
35578	2933	19133873	1958-01-09	1958-01-09 00:00:00	1958-01-22	1958-01-22 00:00:00	1958-01-22	38000177		0	0	13		0	0	0	195624	0	834061	19133873		
5527	461	40220960	1998-01-06	1998-01-06 00:00:00	1998-01-06	1998-01-06 00:00:00	1998-01-06	38000177		0	0	0		0	0	0	30785	0	1804799	40220960		
18960	1566	1154615	1970-11-10	1970-11-10 00:00:00	1970-11-10	1970-11-10 00:00:00	\N	38000177		0	0	0		0	0	0	105052	0	745679	1154615		
11745	975	40231925	1979-12-18	1979-12-18 00:00:00	1979-12-18	1979-12-18 00:00:00	\N	38000177		0	0	0		0	0	0	65021	0	1049221	40231925		
30749	2548	1127433	1985-04-29	1985-04-29 00:00:00	1985-05-13	1985-05-13 00:00:00	1985-05-13	38000177		0	0	14		0	0	0	168682	0	313782	1127433		
35212	2904	1124300	2007-03-27	2007-03-27 00:00:00	2007-03-27	2007-03-27 00:00:00	\N	38000177		0	0	0		0	0	0	193485	0	00781178901	45011828		
33858	2801	40229134	1959-04-13	1959-04-13 00:00:00	1959-04-20	1959-04-20 00:00:00	1959-04-20	38000177		0	0	7		0	0	0	185655	0	1043400	40229134		
33875	2802	19126352	1987-06-27	1987-06-27 00:00:00	1997-12-13	1997-12-13 00:00:00	1997-12-13	38000177		0	0	3822		0	0	0	185700	0	705129	19126352		
239468	5256	40213306	1983-11-18	1983-11-18 00:00:00	1983-11-18	1983-11-18 00:00:00	1983-11-18	581452		0	0	0		0	0	0	349773	0	43	40213306		
115467	2537	40213227	2019-02-17	2019-02-17 00:00:00	2019-02-17	2019-02-17 00:00:00	2019-02-17	581452		0	0	0		0	0	0	167689	0	113	40213227		
39287	858	40213314	1977-05-19	1977-05-19 00:00:00	1977-05-19	1977-05-19 00:00:00	1977-05-19	581452		0	0	0		0	0	0	56702	0	49	40213314		
26863	2213	19133905	1997-09-14	1997-09-14 00:00:00	1997-09-22	1997-09-22 00:00:00	1997-09-22	38000177		0	0	8		0	0	0	147362	0	834102	19133905		
18619	1538	1127433	1992-11-18	1992-11-18 00:00:00	1992-12-02	1992-12-02 00:00:00	1992-12-02	38000177		0	0	14		0	0	0	103028	0	313782	1127433		
103388	2267	40213227	2007-12-24	2007-12-24 00:00:00	2007-12-24	2007-12-24 00:00:00	2007-12-24	581452		0	0	0		0	0	0	150739	0	113	40213227		
47467	3935	1713671	1986-06-06	1986-06-06 00:00:00	1986-06-20	1986-06-20 00:00:00	1986-06-20	38000177		0	0	14		0	0	0	261562	0	562251	1713671		
47991	3980	19059056	1980-02-28	1980-02-28 00:00:00	1980-03-13	1980-03-13 00:00:00	1980-03-13	38000177		0	0	14		0	0	0	264565	0	243670	19059056		
29272	2424	40220386	1997-06-06	1997-06-06 00:00:00	1997-06-06	1997-06-06 00:00:00	1997-06-06	38000177		0	0	0		0	0	0	160819	0	1808217	40220386		
168394	3701	40213260	2006-01-16	2006-01-16 00:00:00	2006-01-16	2006-01-16 00:00:00	2006-01-16	581452		0	0	0		0	0	0	246096	0	121	40213260		
4285	354	40169281	1998-01-15	1998-01-15 00:00:00	1998-01-15	1998-01-15 00:00:00	\N	38000177		0	0	0		0	0	0	23566	0	896209	40169281		
1243	99	1118084	2000-01-03	2000-01-03 00:00:00	2000-01-03	2000-01-03 00:00:00	\N	38000177		0	0	0		0	0	0	6747	0	00025152531	44923712		
33518	2774	1115171	2016-10-26	2016-10-26 00:00:00	2016-11-16	2016-11-16 00:00:00	2016-11-16	38000177		0	0	21		0	0	0	183727	0	849574	1115171		
58725	4876	1127433	1987-12-28	1987-12-28 00:00:00	1988-01-11	1988-01-11 00:00:00	1988-01-11	38000177		0	0	14		0	0	0	324265	0	313782	1127433		
11067	921	1127433	2004-02-04	2004-02-04 00:00:00	2004-02-18	2004-02-18 00:00:00	2004-02-18	38000177		0	0	14		0	0	0	61375	0	313782	1127433		
28168	2328	1127433	2009-12-08	2009-12-08 00:00:00	2009-12-15	2009-12-15 00:00:00	2009-12-15	38000177		0	0	7		0	0	0	154870	0	313782	1127433		
17103	369	40213160	1981-09-05	1981-09-05 00:00:00	1981-09-05	1981-09-05 00:00:00	1981-09-05	581452		0	0	0		0	0	0	24531	0	10	40213160		
8601	718	1124300	2005-09-29	2005-09-29 00:00:00	2005-09-29	2005-09-29 00:00:00	\N	38000177		0	0	0		0	0	0	47531	0	00781178901	45011828		
22462	1847	19059056	1926-06-08	1926-06-08 00:00:00	1926-07-08	1926-07-08 00:00:00	1926-07-08	38000177		0	0	30		0	0	0	123516	0	243670	19059056		
37182	3074	1118084	1986-07-20	1986-07-20 00:00:00	1986-07-20	1986-07-20 00:00:00	\N	38000177		0	0	0		0	0	0	204617	0	00025152531	44923712		
226062	4964	40213260	2010-10-16	2010-10-16 00:00:00	2010-10-16	2010-10-16 00:00:00	2010-10-16	581452		0	0	0		0	0	0	330043	0	121	40213260		
180191	3960	40213296	1998-02-21	1998-02-21 00:00:00	1998-02-21	1998-02-21 00:00:00	1998-02-21	581452		0	0	0		0	0	0	263296	0	52	40213296		
13363	1120	19059056	1971-12-19	1971-12-19 00:00:00	1972-01-18	1972-01-18 00:00:00	1972-01-18	38000177		0	0	30		0	0	0	73810	0	243670	19059056		
161621	3556	40213314	1979-09-24	1979-09-24 00:00:00	1979-09-24	1979-09-24 00:00:00	1979-09-24	581452		0	0	0		0	0	0	236133	0	49	40213314		
58345	4847	19059056	1943-11-29	1943-11-29 00:00:00	1943-12-13	1943-12-13 00:00:00	1943-12-13	38000177		0	0	14		0	0	0	322465	0	243670	19059056		
20182	439	40213251	1984-05-10	1984-05-10 00:00:00	1984-05-10	1984-05-10 00:00:00	1984-05-10	581452		0	0	0		0	0	0	29136	0	21	40213251		
131864	2897	40213227	2011-08-20	2011-08-20 00:00:00	2011-08-20	2011-08-20 00:00:00	2011-08-20	581452		0	0	0		0	0	0	192899	0	113	40213227		
8381	180	40213227	1999-03-11	1999-03-11 00:00:00	1999-03-11	1999-03-11 00:00:00	1999-03-11	581452		0	0	0		0	0	0	12085	0	113	40213227		
11502	958	40231925	1979-12-07	1979-12-07 00:00:00	1979-12-07	1979-12-07 00:00:00	\N	38000177		0	0	0		0	0	0	63596	0	1049221	40231925		
171833	3778	40213260	2014-10-05	2014-10-05 00:00:00	2014-10-05	2014-10-05 00:00:00	2014-10-05	581452		0	0	0		0	0	0	251077	0	121	40213260		
44764	3703	1127433	1995-03-09	1995-03-09 00:00:00	1995-03-16	1995-03-16 00:00:00	1995-03-16	38000177		0	0	7		0	0	0	246228	0	313782	1127433		
26259	2160	920300	1993-10-27	1993-10-27 00:00:00	1993-11-03	1993-11-03 00:00:00	1993-11-03	38000177		0	0	7		0	0	0	143962	0	311989	920300		
7250	608	19133768	2005-07-13	2005-07-13 00:00:00	2005-07-13	2005-07-13 00:00:00	2005-07-13	38000177		0	0	0		0	0	0	40409	0	833036	19133768		
8900	742	40169281	1961-10-09	1961-10-09 00:00:00	1961-10-09	1961-10-09 00:00:00	\N	38000177		0	0	0		0	0	0	49216	0	896209	40169281		
10085	844	19133873	1972-05-22	1972-05-22 00:00:00	1972-05-29	1972-05-29 00:00:00	1972-05-29	38000177		0	0	7		0	0	0	55888	0	834061	19133873		
41546	3440	19059056	1960-12-14	1960-12-14 00:00:00	1960-12-28	1960-12-28 00:00:00	1960-12-28	38000177		0	0	14		0	0	0	228295	0	243670	19059056		
41586	3443	46233988	1978-07-02	1978-07-02 00:00:00	1978-07-16	1978-07-16 00:00:00	1978-07-16	38000177		0	0	14		0	0	0	228458	0	1652673	46233988		
41638	3446	1713671	1947-07-30	1947-07-30 00:00:00	1947-08-06	1947-08-06 00:00:00	1947-08-06	38000177		0	0	7		0	0	0	228829	0	562251	1713671		
10669	886	1713671	2007-06-21	2007-06-21 00:00:00	2007-07-12	2007-07-12 00:00:00	2007-07-12	38000177		0	0	21		0	0	0	59062	0	562251	1713671		
31238	2590	1127433	1990-10-04	1990-10-04 00:00:00	1990-11-01	1990-11-01 00:00:00	1990-11-01	38000177		0	0	28		0	0	0	171409	0	313782	1127433		
9421	782	1713671	1999-01-07	1999-01-07 00:00:00	1999-01-28	1999-01-28 00:00:00	1999-01-28	38000177		0	0	21		0	0	0	51985	0	562251	1713671		
27527	2280	40229134	1993-12-20	1993-12-20 00:00:00	1994-01-03	1994-01-03 00:00:00	1994-01-03	38000177		0	0	14		0	0	0	151607	0	1043400	40229134		
218882	4804	40213160	1977-08-29	1977-08-29 00:00:00	1977-08-29	1977-08-29 00:00:00	1977-08-29	581452		0	0	0		0	0	0	319648	0	10	40213160		
46930	3887	1127433	1977-05-20	1977-05-20 00:00:00	1977-06-03	1977-06-03 00:00:00	1977-06-03	38000177		0	0	14		0	0	0	258402	0	313782	1127433		
39152	3236	19018935	1982-12-24	1982-12-24 00:00:00	1982-12-24	1982-12-24 00:00:00	\N	38000177		0	0	0		0	0	0	215073	0	197604	19018935		
4666	388	40232448	1956-10-04	1956-10-04 00:00:00	1956-10-04	1956-10-04 00:00:00	\N	38000177		0	0	0		0	0	0	25578	0	1049630	40232448		
21909	1796	19128022	1995-03-21	1995-03-21 00:00:00	1996-03-15	1996-03-15 00:00:00	1996-03-15	38000177		0	0	360		0	0	0	120412	0	749785	19128022		
42713	3540	1127433	1984-05-06	1984-05-06 00:00:00	1984-05-13	1984-05-13 00:00:00	1984-05-13	38000177		0	0	7		0	0	0	235134	0	313782	1127433		
52406	4359	19059056	1959-12-13	1959-12-13 00:00:00	1960-01-10	1960-01-10 00:00:00	1960-01-10	38000177		0	0	28		0	0	0	289211	0	243670	19059056		
41220	3418	19133905	1980-12-17	1980-12-17 00:00:00	1980-12-30	1980-12-30 00:00:00	1980-12-30	38000177		0	0	13		0	0	0	226715	0	834102	19133905		
42613	3532	46233988	1972-09-29	1972-09-29 00:00:00	1972-10-13	1972-10-13 00:00:00	1972-10-13	38000177		0	0	14		0	0	0	234650	0	1652673	46233988		
62012	5157	19018935	2019-05-16	2019-05-16 00:00:00	2019-05-16	2019-05-16 00:00:00	\N	38000177		0	0	0		0	0	0	342902	0	197604	19018935		
51477	4278	1127078	1959-02-05	1959-02-05 00:00:00	1959-02-26	1959-02-26 00:00:00	1959-02-26	38000177		0	0	21		0	0	0	283930	0	282464	1127078		
25956	2135	40236824	1991-03-01	1991-03-01 00:00:00	1991-03-08	1991-03-08 00:00:00	1991-03-08	38000177		0	0	7		0	0	0	142172	0	1094107	40236824		
35408	2917	19059056	1940-04-28	1940-04-28 00:00:00	1940-05-12	1940-05-12 00:00:00	1940-05-12	38000177		0	0	14		0	0	0	194459	0	243670	19059056		
25035	2060	40229134	1998-12-19	1998-12-19 00:00:00	1999-01-02	1999-01-02 00:00:00	1999-01-02	38000177		0	0	14		0	0	0	136977	0	1043400	40229134		
35579	2933	19059056	1955-11-13	1955-11-13 00:00:00	1955-11-27	1955-11-27 00:00:00	1955-11-27	38000177		0	0	14		0	0	0	195625	0	243670	19059056		
5528	461	19059056	1954-05-11	1954-05-11 00:00:00	1954-05-25	1954-05-25 00:00:00	1954-05-25	38000177		0	0	14		0	0	0	30783	0	243670	19059056		
18961	1567	1127433	1990-07-05	1990-07-05 00:00:00	1990-07-26	1990-07-26 00:00:00	1990-07-26	38000177		0	0	21		0	0	0	105105	0	313782	1127433		
11767	978	19133873	1979-09-25	1979-09-25 00:00:00	1979-10-03	1979-10-03 00:00:00	1979-10-03	38000177		0	0	8		0	0	0	65165	0	834061	19133873		
30750	2548	1127433	1975-11-12	1975-11-12 00:00:00	1975-11-19	1975-11-19 00:00:00	1975-11-19	38000177		0	0	7		0	0	0	168695	0	313782	1127433		
35213	2904	1713671	1987-02-18	1987-02-18 00:00:00	1987-03-11	1987-03-11 00:00:00	1987-03-11	38000177		0	0	21		0	0	0	193504	0	562251	1713671		
33859	2801	19059056	1923-11-09	1923-11-09 00:00:00	1923-11-23	1923-11-23 00:00:00	1923-11-23	38000177		0	0	14		0	0	0	185653	0	243670	19059056		
33876	2802	1118084	1983-01-17	1983-01-17 00:00:00	1983-01-17	1983-01-17 00:00:00	\N	38000177		0	0	0		0	0	0	185713	0	00025152531	44923712		
239476	5256	40213227	1993-09-03	1993-09-03 00:00:00	1993-09-03	1993-09-03 00:00:00	1993-09-03	581452		0	0	0		0	0	0	349772	0	113	40213227		
115469	2537	40213198	2013-01-13	2013-01-13 00:00:00	2013-01-13	2013-01-13 00:00:00	2013-01-13	581452		0	0	0		0	0	0	167596	0	133	40213198		
39292	858	40213160	1978-11-23	1978-11-23 00:00:00	1978-11-23	1978-11-23 00:00:00	1978-11-23	581452		0	0	0		0	0	0	56703	0	10	40213160		
26890	2217	1124300	2018-11-06	2018-11-06 00:00:00	2018-11-06	2018-11-06 00:00:00	\N	38000177		0	0	0		0	0	0	147681	0	00781178901	45011828		
18620	1538	19059056	1932-04-06	1932-04-06 00:00:00	1932-04-20	1932-04-20 00:00:00	1932-04-20	38000177		0	0	14		0	0	0	102992	0	243670	19059056		
103393	2267	40213306	1988-08-22	1988-08-22 00:00:00	1988-08-22	1988-08-22 00:00:00	1988-08-22	581452		0	0	0		0	0	0	150748	0	43	40213306		
47468	3935	1118084	1982-10-16	1982-10-16 00:00:00	1982-10-16	1982-10-16 00:00:00	\N	38000177		0	0	0		0	0	0	261561	0	00025152531	44923712		
47992	3980	920300	1992-11-19	1992-11-19 00:00:00	1992-11-26	1992-11-26 00:00:00	1992-11-26	38000177		0	0	7		0	0	0	264562	0	311989	920300		
29273	2424	19023398	1997-06-06	1997-06-06 00:00:00	1997-06-06	1997-06-06 00:00:00	1997-06-06	38000177		0	0	0		0	0	0	160819	0	200243	19023398		
168395	3701	40213160	1955-04-11	1955-04-11 00:00:00	1955-04-11	1955-04-11 00:00:00	1955-04-11	581452		0	0	0		0	0	0	246083	0	10	40213160		
4286	354	1127433	2012-04-13	2012-04-13 00:00:00	2012-05-18	2012-05-18 00:00:00	2012-05-18	38000177		0	0	35		0	0	0	23548	0	313782	1127433		
1244	99	19059056	1960-10-12	1960-10-12 00:00:00	1960-11-02	1960-11-02 00:00:00	1960-11-02	38000177		0	0	21		0	0	0	6760	0	243670	19059056		
119338	2624	40213296	2010-01-14	2010-01-14 00:00:00	2010-01-14	2010-01-14 00:00:00	2010-01-14	581452		0	0	0		0	0	0	173571	0	52	40213296		
58726	4876	1713671	1991-11-21	1991-11-21 00:00:00	1991-12-12	1991-12-12 00:00:00	1991-12-12	38000177		0	0	21		0	0	0	324271	0	562251	1713671		
11070	923	19059056	1961-06-29	1961-06-29 00:00:00	1961-07-13	1961-07-13 00:00:00	1961-07-13	38000177		0	0	14		0	0	0	61461	0	243670	19059056		
28169	2329	46233988	1973-12-27	1973-12-27 00:00:00	1974-01-10	1974-01-10 00:00:00	1974-01-10	38000177		0	0	14		0	0	0	154941	0	1652673	46233988		
17107	369	40213251	1984-06-02	1984-06-02 00:00:00	1984-06-02	1984-06-02 00:00:00	1984-06-02	581452		0	0	0		0	0	0	24558	0	21	40213251		
8602	718	40229134	2016-01-27	2016-01-27 00:00:00	2016-02-03	2016-02-03 00:00:00	2016-02-03	38000177		0	0	7		0	0	0	47461	0	1043400	40229134		
22463	1847	19059056	1915-07-06	1915-07-06 00:00:00	1915-07-20	1915-07-20 00:00:00	1915-07-20	38000177		0	0	14		0	0	0	123555	0	243670	19059056		
37183	3074	19133873	1952-08-01	1952-08-01 00:00:00	1952-08-11	1952-08-11 00:00:00	1952-08-11	38000177		0	0	10		0	0	0	204584	0	834061	19133873		
226066	4964	40213160	1960-10-22	1960-10-22 00:00:00	1960-10-22	1960-10-22 00:00:00	1960-10-22	581452		0	0	0		0	0	0	330014	0	10	40213160		
180193	3960	40213227	2019-04-20	2019-04-20 00:00:00	2019-04-20	2019-04-20 00:00:00	2019-04-20	581452		0	0	0		0	0	0	263300	0	113	40213227		
13364	1120	1124300	1997-03-07	1997-03-07 00:00:00	1997-03-07	1997-03-07 00:00:00	\N	38000177		0	0	0		0	0	0	73863	0	00781178901	45011828		
161624	3556	40213227	2009-09-28	2009-09-28 00:00:00	2009-09-28	2009-09-28 00:00:00	2009-09-28	581452		0	0	0		0	0	0	236115	0	113	40213227		
58346	4847	1713671	1963-05-17	1963-05-17 00:00:00	1963-05-24	1963-05-24 00:00:00	1963-05-24	38000177		0	0	7		0	0	0	322462	0	562251	1713671		
20188	439	40213160	1978-06-08	1978-06-08 00:00:00	1978-06-08	1978-06-08 00:00:00	1978-06-08	581452		0	0	0		0	0	0	29110	0	10	40213160		
131865	2897	40213260	2011-08-20	2011-08-20 00:00:00	2011-08-20	2011-08-20 00:00:00	2011-08-20	581452		0	0	0		0	0	0	192899	0	121	40213260		
8382	180	40213306	1999-03-11	1999-03-11 00:00:00	1999-03-11	1999-03-11 00:00:00	1999-03-11	581452		0	0	0		0	0	0	12085	0	43	40213306		
11503	958	19078461	1979-12-07	1979-12-07 00:00:00	1980-01-11	1980-01-11 00:00:00	1980-01-11	38000177		0	0	35		0	0	0	63596	0	310965	19078461		
171835	3778	40213160	1969-09-14	1969-09-14 00:00:00	1969-09-14	1969-09-14 00:00:00	1969-09-14	581452		0	0	0		0	0	0	251080	0	10	40213160		
34635	2861	40162522	1977-04-25	1977-04-25 00:00:00	1977-04-25	1977-04-25 00:00:00	\N	38000177		0	0	0		0	0	0	190181	0	857005	40162522		
26260	2160	19078461	2009-09-11	2009-09-11 00:00:00	2009-10-09	2009-10-09 00:00:00	2009-10-09	38000177		0	0	28		0	0	0	143921	0	310965	19078461		
7251	608	19078461	2008-11-13	2008-11-13 00:00:00	2008-11-27	2008-11-27 00:00:00	2008-11-27	38000177		0	0	14		0	0	0	40410	0	310965	19078461		
8901	743	40229134	1983-08-23	1983-08-23 00:00:00	1983-09-06	1983-09-06 00:00:00	1983-09-06	38000177		0	0	14		0	0	0	49238	0	1043400	40229134		
10086	844	1127433	1966-11-20	1966-11-20 00:00:00	1966-11-27	1966-11-27 00:00:00	1966-11-27	38000177		0	0	7		0	0	0	55935	0	313782	1127433		
41547	3440	1127433	1959-12-20	1959-12-20 00:00:00	1960-02-18	1960-02-18 00:00:00	1960-02-18	38000177		0	0	60		0	0	0	228294	0	313782	1127433		
41587	3443	1127078	1978-07-02	1978-07-02 00:00:00	1978-07-16	1978-07-16 00:00:00	1978-07-16	38000177		0	0	14		0	0	0	228458	0	282464	1127078		
41639	3446	19078461	1977-01-23	1977-01-23 00:00:00	1977-02-27	1977-02-27 00:00:00	1977-02-27	38000177		0	0	35		0	0	0	228781	0	310965	19078461		
10670	887	19078461	2002-07-29	2002-07-29 00:00:00	2002-08-19	2002-08-19 00:00:00	2002-08-19	38000177		0	0	21		0	0	0	59106	0	310965	19078461		
31239	2590	1127433	1994-01-03	1994-01-03 00:00:00	1994-01-10	1994-01-10 00:00:00	1994-01-10	38000177		0	0	7		0	0	0	171418	0	313782	1127433		
9422	782	1127433	1911-12-17	1911-12-17 00:00:00	1911-12-31	1911-12-31 00:00:00	1911-12-31	38000177		0	0	14		0	0	0	51989	0	313782	1127433		
27528	2280	46233988	1974-09-27	1974-09-27 00:00:00	1974-10-11	1974-10-11 00:00:00	1974-10-11	38000177		0	0	14		0	0	0	151594	0	1652673	46233988		
218888	4804	40213160	1982-03-01	1982-03-01 00:00:00	1982-03-01	1982-03-01 00:00:00	1982-03-01	581452		0	0	0		0	0	0	319651	0	10	40213160		
46931	3887	1127433	1980-09-01	1980-09-01 00:00:00	1980-09-08	1980-09-08 00:00:00	1980-09-08	38000177		0	0	7		0	0	0	258389	0	313782	1127433		
39153	3236	1124300	1958-05-12	1958-05-12 00:00:00	1958-05-12	1958-05-12 00:00:00	\N	38000177		0	0	0		0	0	0	215045	0	00781178901	45011828		
4667	388	1115171	2000-04-04	2000-04-04 00:00:00	2000-04-18	2000-04-18 00:00:00	2000-04-18	38000177		0	0	14		0	0	0	25585	0	849574	1115171		
21910	1796	19128022	2001-02-17	2001-02-17 00:00:00	2002-02-12	2002-02-12 00:00:00	2002-02-12	38000177		0	0	360		0	0	0	120387	0	749785	19128022		
42714	3540	19133873	1975-11-23	1975-11-23 00:00:00	1975-12-04	1975-12-04 00:00:00	1975-12-04	38000177		0	0	11		0	0	0	235112	0	834061	19133873		
52407	4359	1713671	1959-09-21	1959-09-21 00:00:00	1959-10-05	1959-10-05 00:00:00	1959-10-05	38000177		0	0	14		0	0	0	289177	0	562251	1713671		
41221	3418	1127433	2008-12-27	2008-12-27 00:00:00	2009-01-03	2009-01-03 00:00:00	2009-01-03	38000177		0	0	7		0	0	0	226719	0	313782	1127433		
42614	3532	19133873	1978-12-14	1978-12-14 00:00:00	1978-12-24	1978-12-24 00:00:00	1978-12-24	38000177		0	0	10		0	0	0	234596	0	834061	19133873		
62013	5157	40171902	2019-05-16	2019-05-16 00:00:00	2019-05-16	2019-05-16 00:00:00	\N	38000177		0	0	0		0	0	0	342902	0	897718	40171902		
51478	4278	1127433	1989-12-25	1989-12-25 00:00:00	1990-01-08	1990-01-08 00:00:00	1990-01-08	38000177		0	0	14		0	0	0	283938	0	313782	1127433		
25957	2135	920300	1991-03-01	1991-03-01 00:00:00	1991-03-08	1991-03-08 00:00:00	1991-03-08	38000177		0	0	7		0	0	0	142172	0	311989	920300		
35409	2917	1118084	1976-02-10	1976-02-10 00:00:00	1976-02-10	1976-02-10 00:00:00	\N	38000177		0	0	0		0	0	0	194528	0	00025152531	44923712		
25036	2060	40229134	2008-06-29	2008-06-29 00:00:00	2008-07-13	2008-07-13 00:00:00	2008-07-13	38000177		0	0	14		0	0	0	136978	0	1043400	40229134		
35580	2933	19006318	1955-11-13	1955-11-13 00:00:00	1955-11-27	1955-11-27 00:00:00	1955-11-27	38000177		0	0	14		0	0	0	195625	0	105078	19006318		
5529	461	19006318	1954-05-11	1954-05-11 00:00:00	1954-05-25	1954-05-25 00:00:00	1954-05-25	38000177		0	0	14		0	0	0	30783	0	105078	19006318		
18962	1567	1713671	2016-04-10	2016-04-10 00:00:00	2016-04-17	2016-04-17 00:00:00	2016-04-17	38000177		0	0	7		0	0	0	105134	0	562251	1713671		
11768	978	19019979	1985-01-24	1985-01-24 00:00:00	1985-04-24	1985-04-24 00:00:00	1985-04-24	38000177		0	0	90		0	0	0	65152	0	198405	19019979		
30751	2548	1127433	2011-01-10	2011-01-10 00:00:00	2011-01-17	2011-01-17 00:00:00	2011-01-17	38000177		0	0	7		0	0	0	168731	0	313782	1127433		
35215	2904	19059056	1973-03-05	1973-03-05 00:00:00	1973-03-19	1973-03-19 00:00:00	1973-03-19	38000177		0	0	14		0	0	0	193491	0	243670	19059056		
33860	2801	19059056	1928-02-21	1928-02-21 00:00:00	1928-03-20	1928-03-20 00:00:00	1928-03-20	38000177		0	0	28		0	0	0	185604	0	243670	19059056		
33877	2802	1127433	1981-11-17	1981-11-17 00:00:00	1981-12-01	1981-12-01 00:00:00	1981-12-01	38000177		0	0	14		0	0	0	185713	0	313782	1127433		
239478	5256	40213160	1964-10-23	1964-10-23 00:00:00	1964-10-23	1964-10-23 00:00:00	1964-10-23	581452		0	0	0		0	0	0	349723	0	10	40213160		
150194	3304	40213296	2003-01-15	2003-01-15 00:00:00	2003-01-15	2003-01-15 00:00:00	2003-01-15	581452		0	0	0		0	0	0	219443	0	52	40213296		
39295	858	40213160	1974-05-23	1974-05-23 00:00:00	1974-05-23	1974-05-23 00:00:00	1974-05-23	581452		0	0	0		0	0	0	56692	0	10	40213160		
26891	2217	19133873	1993-11-01	1993-11-01 00:00:00	1993-11-08	1993-11-08 00:00:00	1993-11-08	38000177		0	0	7		0	0	0	147670	0	834061	19133873		
18621	1538	19059056	1931-02-27	1931-02-27 00:00:00	1931-03-13	1931-03-13 00:00:00	1931-03-13	38000177		0	0	14		0	0	0	103003	0	243670	19059056		
103397	2267	40213160	1966-08-22	1966-08-22 00:00:00	1966-08-22	1966-08-22 00:00:00	1966-08-22	581452		0	0	0		0	0	0	150727	0	10	40213160		
47469	3935	1127433	1968-05-28	1968-05-28 00:00:00	1968-06-25	1968-06-25 00:00:00	1968-06-25	38000177		0	0	28		0	0	0	261542	0	313782	1127433		
47993	3980	40236824	1992-11-19	1992-11-19 00:00:00	1992-11-26	1992-11-26 00:00:00	1992-11-26	38000177		0	0	7		0	0	0	264562	0	1094107	40236824		
29274	2424	1367571	1997-06-06	1997-06-06 00:00:00	1997-06-06	1997-06-06 00:00:00	1997-06-06	38000177		0	0	0		0	0	0	160819	0	314659	19080464		
168400	3701	40213198	2018-03-26	2018-03-26 00:00:00	2018-03-26	2018-03-26 00:00:00	2018-03-26	581452		0	0	0		0	0	0	246079	0	133	40213198		
25819	2123	920300	2007-05-20	2007-05-20 00:00:00	2007-05-27	2007-05-27 00:00:00	2007-05-27	38000177		0	0	7		0	0	0	141313	0	311989	920300		
1245	99	19059056	1959-08-21	1959-08-21 00:00:00	1959-09-18	1959-09-18 00:00:00	1959-09-18	38000177		0	0	28		0	0	0	6759	0	243670	19059056		
119340	2624	40213227	2010-01-14	2010-01-14 00:00:00	2010-01-14	2010-01-14 00:00:00	2010-01-14	581452		0	0	0		0	0	0	173571	0	113	40213227		
58727	4876	1713671	1986-10-12	1986-10-12 00:00:00	1986-10-19	1986-10-19 00:00:00	1986-10-19	38000177		0	0	7		0	0	0	324286	0	562251	1713671		
11071	923	19129655	1961-06-29	1961-06-29 00:00:00	1961-07-13	1961-07-13 00:00:00	1961-07-13	38000177		0	0	14		0	0	0	61461	0	789980	19129655		
28170	2329	19059056	1973-12-27	1973-12-27 00:00:00	1974-01-10	1974-01-10 00:00:00	1974-01-10	38000177		0	0	14		0	0	0	154941	0	243670	19059056		
17111	369	40213251	1985-12-07	1985-12-07 00:00:00	1985-12-07	1985-12-07 00:00:00	1985-12-07	581452		0	0	0		0	0	0	24550	0	21	40213251		
8603	718	19059056	1970-03-28	1970-03-28 00:00:00	1970-05-04	1970-05-04 00:00:00	1970-05-04	38000177		0	0	37		0	0	0	47524	0	243670	19059056		
22464	1847	1127433	1961-09-24	1961-09-24 00:00:00	1961-10-08	1961-10-08 00:00:00	1961-10-08	38000177		0	0	14		0	0	0	123515	0	313782	1127433		
37184	3074	1127433	1971-07-19	1971-07-19 00:00:00	1971-08-09	1971-08-09 00:00:00	1971-08-09	38000177		0	0	21		0	0	0	204572	0	313782	1127433		
226071	4964	40213296	2001-09-22	2001-09-22 00:00:00	2001-09-22	2001-09-22 00:00:00	2001-09-22	581452		0	0	0		0	0	0	330002	0	52	40213296		
180199	3960	40213260	2009-02-21	2009-02-21 00:00:00	2009-02-21	2009-02-21 00:00:00	2009-02-21	581452		0	0	0		0	0	0	263266	0	121	40213260		
13365	1120	19006318	1958-10-28	1958-10-28 00:00:00	1958-11-11	1958-11-11 00:00:00	1958-11-11	38000177		0	0	14		0	0	0	73800	0	105078	19006318		
64673	1415	40213160	1974-01-06	1974-01-06 00:00:00	1974-01-06	1974-01-06 00:00:00	1974-01-06	581452		0	0	0		0	0	0	94187	0	10	40213160		
58347	4847	40229134	2002-01-20	2002-01-20 00:00:00	2002-02-03	2002-02-03 00:00:00	2002-02-03	38000177		0	0	14		0	0	0	322483	0	1043400	40229134		
20192	439	40213227	2010-08-19	2010-08-19 00:00:00	2010-08-19	2010-08-19 00:00:00	2010-08-19	581452		0	0	0		0	0	0	29148	0	113	40213227		
131869	2897	40213160	1961-02-11	1961-02-11 00:00:00	1961-02-11	1961-02-11 00:00:00	1961-02-11	581452		0	0	0		0	0	0	192900	0	10	40213160		
8386	180	40213160	1982-04-01	1982-04-01 00:00:00	1982-04-01	1982-04-01 00:00:00	1982-04-01	581452		0	0	0		0	0	0	12176	0	10	40213160		
11504	958	19073188	1979-12-07	1979-12-07 00:00:00	1980-01-11	1980-01-11 00:00:00	1980-01-11	38000177		0	0	35		0	0	0	63596	0	308192	19073188		
176537	3881	40213227	2016-12-09	2016-12-09 00:00:00	2016-12-09	2016-12-09 00:00:00	2016-12-09	581452		0	0	0		0	0	0	257894	0	113	40213227		
34636	2861	19078461	1977-04-25	1977-04-25 00:00:00	1977-07-24	1977-07-24 00:00:00	1977-07-24	38000177		0	0	90		0	0	0	190181	0	310965	19078461		
26262	2160	19059056	1963-07-13	1963-07-13 00:00:00	1963-07-27	1963-07-27 00:00:00	1963-07-27	38000177		0	0	14		0	0	0	143969	0	243670	19059056		
7252	608	1713671	1984-06-03	1984-06-03 00:00:00	1984-06-10	1984-06-10 00:00:00	1984-06-10	38000177		0	0	7		0	0	0	40382	0	562251	1713671		
8902	743	19128022	1992-10-13	1992-10-13 00:00:00	1993-10-08	1993-10-08 00:00:00	1993-10-08	38000177		0	0	360		0	0	0	49255	0	749785	19128022		
10087	844	1127433	1982-01-29	1982-01-29 00:00:00	1982-04-29	1982-04-29 00:00:00	1982-04-29	38000177		0	0	90		0	0	0	56003	0	313782	1127433		
41548	3440	1127433	1942-10-07	1942-10-07 00:00:00	1942-10-14	1942-10-14 00:00:00	1942-10-14	38000177		0	0	7		0	0	0	228327	0	313782	1127433		
41588	3443	19059056	1981-10-28	1981-10-28 00:00:00	1981-11-11	1981-11-11 00:00:00	1981-11-11	38000177		0	0	14		0	0	0	228498	0	243670	19059056		
41640	3446	19115351	1957-12-09	1957-12-09 00:00:00	1958-08-11	1958-08-11 00:00:00	1958-08-11	38000177		0	0	245		0	0	0	228777	0	563026	19115351		
10671	887	1127433	1982-04-15	1982-04-15 00:00:00	1982-04-22	1982-04-22 00:00:00	1982-04-22	38000177		0	0	7		0	0	0	59109	0	313782	1127433		
31240	2590	1713671	2011-01-11	2011-01-11 00:00:00	2011-01-25	2011-01-25 00:00:00	2011-01-25	38000177		0	0	14		0	0	0	171420	0	562251	1713671		
9423	782	19078461	1978-12-24	1978-12-24 00:00:00	1979-01-07	1979-01-07 00:00:00	1979-01-07	38000177		0	0	14		0	0	0	52020	0	310965	19078461		
27529	2280	19019979	1974-09-27	1974-09-27 00:00:00	1974-10-11	1974-10-11 00:00:00	1974-10-11	38000177		0	0	14		0	0	0	151594	0	198405	19019979		
218894	4804	40213160	1977-11-28	1977-11-28 00:00:00	1977-11-28	1977-11-28 00:00:00	1977-11-28	581452		0	0	0		0	0	0	319538	0	10	40213160		
46932	3887	1713671	2010-08-01	2010-08-01 00:00:00	2010-08-08	2010-08-08 00:00:00	2010-08-08	38000177		0	0	7		0	0	0	258351	0	562251	1713671		
39154	3236	19059056	1992-07-05	1992-07-05 00:00:00	1992-08-02	1992-08-02 00:00:00	1992-08-02	38000177		0	0	28		0	0	0	215030	0	243670	19059056		
4668	388	1118084	1988-10-25	1988-10-25 00:00:00	1988-10-25	1988-10-25 00:00:00	\N	38000177		0	0	0		0	0	0	25569	0	00025152531	44923712		
21911	1796	1127433	2015-03-10	2015-03-10 00:00:00	2015-04-07	2015-04-07 00:00:00	2015-04-07	38000177		0	0	28		0	0	0	120434	0	313782	1127433		
42715	3540	1127078	1976-09-14	1976-09-14 00:00:00	1976-11-13	1976-11-13 00:00:00	1976-11-13	38000177		0	0	60		0	0	0	235121	0	282464	1127078		
52408	4359	1127433	2016-01-31	2016-01-31 00:00:00	2016-02-14	2016-02-14 00:00:00	2016-02-14	38000177		0	0	14		0	0	0	289259	0	313782	1127433		
41222	3418	1127433	1991-07-09	1991-07-09 00:00:00	1991-07-23	1991-07-23 00:00:00	1991-07-23	38000177		0	0	14		0	0	0	226716	0	313782	1127433		
42615	3532	19059056	1973-09-13	1973-09-13 00:00:00	1973-09-27	1973-09-27 00:00:00	1973-09-27	38000177		0	0	14		0	0	0	234636	0	243670	19059056		
62014	5157	19128065	1984-03-01	1984-03-01 00:00:00	1985-02-24	1985-02-24 00:00:00	1985-02-24	38000177		0	0	360		0	0	0	342917	0	749882	19128065		
51479	4278	19077572	2017-12-01	2017-12-01 00:00:00	2017-12-01	2017-12-01 00:00:00	\N	38000177		0	0	0		0	0	0	283943	0	310436	19077572		
25958	2135	19059056	1957-08-18	1957-08-18 00:00:00	1957-10-17	1957-10-17 00:00:00	1957-10-17	38000177		0	0	60		0	0	0	142099	0	243670	19059056		
35418	2919	1127433	2007-11-03	2007-11-03 00:00:00	2007-11-10	2007-11-10 00:00:00	2007-11-10	38000177		0	0	7		0	0	0	194590	0	313782	1127433		
25037	2060	1127433	1964-02-04	1964-02-04 00:00:00	1964-02-18	1964-02-18 00:00:00	1964-02-18	38000177		0	0	14		0	0	0	136995	0	313782	1127433		
35581	2933	19126352	2011-10-10	2011-10-10 00:00:00	2011-10-10	2011-10-10 00:00:00	\N	38000177		0	0	0		0	0	0	195614	0	705129	19126352		
5530	461	1127433	1953-03-27	1953-03-27 00:00:00	1953-04-03	1953-04-03 00:00:00	1953-04-03	38000177		0	0	7		0	0	0	30779	0	313782	1127433		
18963	1567	1127433	2014-09-15	2014-09-15 00:00:00	2014-09-29	2014-09-29 00:00:00	2014-09-29	38000177		0	0	14		0	0	0	105083	0	313782	1127433		
11769	978	19133905	2011-11-02	2011-11-02 00:00:00	2011-11-13	2011-11-13 00:00:00	2011-11-13	38000177		0	0	11		0	0	0	65143	0	834102	19133905		
30752	2548	19133905	2018-01-22	2018-01-22 00:00:00	2018-02-04	2018-02-04 00:00:00	2018-02-04	38000177		0	0	13		0	0	0	168712	0	834102	19133905		
35216	2904	46233988	1973-03-05	1973-03-05 00:00:00	1973-03-19	1973-03-19 00:00:00	1973-03-19	38000177		0	0	14		0	0	0	193491	0	1652673	46233988		
33861	2801	1127433	1977-07-31	1977-07-31 00:00:00	1977-09-04	1977-09-04 00:00:00	1977-09-04	38000177		0	0	35		0	0	0	185606	0	313782	1127433		
33878	2802	40229134	1961-03-24	1961-03-24 00:00:00	1961-04-07	1961-04-07 00:00:00	1961-04-07	38000177		0	0	14		0	0	0	185739	0	1043400	40229134		
239481	5256	40213160	1960-04-22	1960-04-22 00:00:00	1960-04-22	1960-04-22 00:00:00	1960-04-22	581452		0	0	0		0	0	0	349721	0	10	40213160		
150196	3304	40213227	1996-08-21	1996-08-21 00:00:00	1996-08-21	1996-08-21 00:00:00	1996-08-21	581452		0	0	0		0	0	0	219481	0	113	40213227		
39297	858	40213160	1974-10-24	1974-10-24 00:00:00	1974-10-24	1974-10-24 00:00:00	1974-10-24	581452		0	0	0		0	0	0	56699	0	10	40213160		
26892	2217	19073188	1995-02-05	1995-02-05 00:00:00	1995-02-19	1995-02-19 00:00:00	1995-02-19	38000177		0	0	14		0	0	0	147682	0	308192	19073188		
18622	1538	1127433	2006-04-04	2006-04-04 00:00:00	2006-04-18	2006-04-18 00:00:00	2006-04-18	38000177		0	0	14		0	0	0	103039	0	313782	1127433		
103401	2267	40213227	2016-12-19	2016-12-19 00:00:00	2016-12-19	2016-12-19 00:00:00	2016-12-19	581452		0	0	0		0	0	0	150698	0	113	40213227		
47470	3935	40220960	1990-10-24	1990-10-24 00:00:00	1990-10-24	1990-10-24 00:00:00	1990-10-24	38000177		0	0	0		0	0	0	261552	0	1804799	40220960		
47994	3980	19133905	2016-08-27	2016-08-27 00:00:00	2016-09-07	2016-09-07 00:00:00	2016-09-07	38000177		0	0	11		0	0	0	264564	0	834102	19133905		
29275	2424	35605482	1997-06-06	1997-06-06 00:00:00	1997-06-06	1997-06-06 00:00:00	1997-06-06	38000177		0	0	0		0	0	0	160819	0	1740467	35605482		
168401	3701	40213160	1955-10-10	1955-10-10 00:00:00	1955-10-10	1955-10-10 00:00:00	1955-10-10	581452		0	0	0		0	0	0	246104	0	10	40213160		
25820	2123	40229134	1954-03-28	1954-03-28 00:00:00	1954-04-11	1954-04-11 00:00:00	1954-04-11	38000177		0	0	14		0	0	0	141294	0	1043400	40229134		
1246	99	40229134	2015-03-28	2015-03-28 00:00:00	2015-04-04	2015-04-04 00:00:00	2015-04-04	38000177		0	0	7		0	0	0	6773	0	1043400	40229134		
119348	2624	40213160	1968-09-12	1968-09-12 00:00:00	1968-09-12	1968-09-12 00:00:00	1968-09-12	581452		0	0	0		0	0	0	173539	0	10	40213160		
58728	4876	40229134	1994-12-23	1994-12-23 00:00:00	1995-01-06	1995-01-06 00:00:00	1995-01-06	38000177		0	0	14		0	0	0	324287	0	1043400	40229134		
11072	923	19133905	1986-11-05	1986-11-05 00:00:00	1986-11-12	1986-11-12 00:00:00	1986-11-12	38000177		0	0	7		0	0	0	61475	0	834102	19133905		
28171	2329	40229134	2008-07-27	2008-07-27 00:00:00	2008-08-10	2008-08-10 00:00:00	2008-08-10	38000177		0	0	14		0	0	0	154926	0	1043400	40229134		
17114	369	40213160	1985-12-07	1985-12-07 00:00:00	1985-12-07	1985-12-07 00:00:00	1985-12-07	581452		0	0	0		0	0	0	24550	0	10	40213160		
8604	718	1713671	1991-04-20	1991-04-20 00:00:00	1991-05-11	1991-05-11 00:00:00	1991-05-11	38000177		0	0	21		0	0	0	47496	0	562251	1713671		
22465	1847	1127433	1926-12-24	1926-12-24 00:00:00	1927-01-07	1927-01-07 00:00:00	1927-01-07	38000177		0	0	14		0	0	0	123586	0	313782	1127433		
47643	3950	1713671	2011-08-31	2011-08-31 00:00:00	2011-09-21	2011-09-21 00:00:00	2011-09-21	38000177		0	0	21		0	0	0	262592	0	562251	1713671		
226073	4964	40213227	2001-09-22	2001-09-22 00:00:00	2001-09-22	2001-09-22 00:00:00	2001-09-22	581452		0	0	0		0	0	0	330002	0	113	40213227		
180201	3960	40213227	2009-02-21	2009-02-21 00:00:00	2009-02-21	2009-02-21 00:00:00	2009-02-21	581452		0	0	0		0	0	0	263266	0	113	40213227		
13366	1120	19059056	1958-10-28	1958-10-28 00:00:00	1958-11-11	1958-11-11 00:00:00	1958-11-11	38000177		0	0	14		0	0	0	73800	0	243670	19059056		
64686	1415	40213227	2011-02-06	2011-02-06 00:00:00	2011-02-06	2011-02-06 00:00:00	2011-02-06	581452		0	0	0		0	0	0	94169	0	113	40213227		
58348	4848	19078461	1980-08-16	1980-08-16 00:00:00	1980-09-06	1980-09-06 00:00:00	1980-09-06	38000177		0	0	21		0	0	0	322562	0	310965	19078461		
20194	439	40213296	2018-08-30	2018-08-30 00:00:00	2018-08-30	2018-08-30 00:00:00	2018-08-30	581452		0	0	0		0	0	0	29145	0	52	40213296		
131875	2897	40213306	1983-04-02	1983-04-02 00:00:00	1983-04-02	1983-04-02 00:00:00	1983-04-02	581452		0	0	0		0	0	0	192959	0	43	40213306		
8388	180	40213296	2017-04-27	2017-04-27 00:00:00	2017-04-27	2017-04-27 00:00:00	2017-04-27	581452		0	0	0		0	0	0	12096	0	52	40213296		
11505	958	19078461	2012-10-04	2012-10-04 00:00:00	2012-10-18	2012-10-18 00:00:00	2012-10-18	38000177		0	0	14		0	0	0	63599	0	310965	19078461		
176540	3881	40213296	1996-01-26	1996-01-26 00:00:00	1996-01-26	1996-01-26 00:00:00	1996-01-26	581452		0	0	0		0	0	0	257878	0	52	40213296		
34637	2861	19006318	1966-11-05	1966-11-05 00:00:00	1966-11-19	1966-11-19 00:00:00	1966-11-19	38000177		0	0	14		0	0	0	190210	0	105078	19006318		
26263	2160	19006318	1963-07-13	1963-07-13 00:00:00	1963-07-27	1963-07-27 00:00:00	1963-07-27	38000177		0	0	14		0	0	0	143969	0	105078	19006318		
7253	608	1127433	1975-03-16	1975-03-16 00:00:00	1975-03-30	1975-03-30 00:00:00	1975-03-30	38000177		0	0	14		0	0	0	40411	0	313782	1127433		
8903	743	19128022	1997-09-17	1997-09-17 00:00:00	1998-09-12	1998-09-12 00:00:00	1998-09-12	38000177		0	0	360		0	0	0	49269	0	749785	19128022		
10088	844	1127433	1989-04-02	1989-04-02 00:00:00	1989-04-16	1989-04-16 00:00:00	1989-04-16	38000177		0	0	14		0	0	0	55926	0	313782	1127433		
41561	3442	19059056	1963-02-14	1963-02-14 00:00:00	1963-02-28	1963-02-28 00:00:00	1963-02-28	38000177		0	0	14		0	0	0	228414	0	243670	19059056		
41589	3443	19128022	1994-02-17	1994-02-17 00:00:00	1995-02-12	1995-02-12 00:00:00	1995-02-12	38000177		0	0	360		0	0	0	228512	0	749785	19128022		
41641	3446	19059056	1965-05-21	1965-05-21 00:00:00	1965-06-20	1965-06-20 00:00:00	1965-06-20	38000177		0	0	30		0	0	0	228779	0	243670	19059056		
10672	887	19078461	1989-11-29	1989-11-29 00:00:00	1990-02-27	1990-02-27 00:00:00	1990-02-27	38000177		0	0	90		0	0	0	59104	0	310965	19078461		
31241	2590	19078461	1981-01-03	1981-01-03 00:00:00	1981-01-24	1981-01-24 00:00:00	1981-01-24	38000177		0	0	21		0	0	0	171408	0	310965	19078461		
9424	782	40229134	1950-01-17	1950-01-17 00:00:00	1950-01-24	1950-01-24 00:00:00	1950-01-24	38000177		0	0	7		0	0	0	52024	0	1043400	40229134		
27530	2280	19112599	1974-06-24	1974-06-24 00:00:00	1974-06-24	1974-06-24 00:00:00	\N	38000177		0	0	0		0	0	0	151617	0	477045	19112599		
218897	4804	40213160	1977-06-27	1977-06-27 00:00:00	1977-06-27	1977-06-27 00:00:00	1977-06-27	581452		0	0	0		0	0	0	319537	0	10	40213160		
46934	3887	1127433	1982-11-28	1982-11-28 00:00:00	1982-12-12	1982-12-12 00:00:00	1982-12-12	38000177		0	0	14		0	0	0	258403	0	313782	1127433		
39155	3236	40220960	2016-07-15	2016-07-15 00:00:00	2016-07-15	2016-07-15 00:00:00	2016-07-15	38000177		0	0	0		0	0	0	215114	0	1804799	40220960		
4669	388	19059056	1965-06-18	1965-06-18 00:00:00	1965-07-09	1965-07-09 00:00:00	1965-07-09	38000177		0	0	21		0	0	0	25580	0	243670	19059056		
21912	1796	19128022	1993-03-31	1993-03-31 00:00:00	1994-03-26	1994-03-26 00:00:00	1994-03-26	38000177		0	0	360		0	0	0	120403	0	749785	19128022		
42716	3540	19133873	1982-05-10	1982-05-10 00:00:00	1982-05-18	1982-05-18 00:00:00	1982-05-18	38000177		0	0	8		0	0	0	235143	0	834061	19133873		
52409	4359	1713671	1999-11-23	1999-11-23 00:00:00	1999-11-30	1999-11-30 00:00:00	1999-11-30	38000177		0	0	7		0	0	0	289252	0	562251	1713671		
41223	3418	19077572	2019-03-03	2019-03-03 00:00:00	2019-03-03	2019-03-03 00:00:00	\N	38000177		0	0	0		0	0	0	226740	0	310436	19077572		
42616	3532	19129655	1973-09-13	1973-09-13 00:00:00	1973-09-27	1973-09-27 00:00:00	1973-09-27	38000177		0	0	14		0	0	0	234636	0	789980	19129655		
41293	3423	1713671	1981-12-09	1981-12-09 00:00:00	1981-12-23	1981-12-23 00:00:00	1981-12-23	38000177		0	0	14		0	0	0	227033	0	562251	1713671		
51480	4278	45892894	2019-03-26	2019-03-26 00:00:00	2019-03-26	2019-03-26 00:00:00	\N	38000177		0	0	0		0	0	0	283892	0	1599803	45892894		
25959	2135	1115171	2004-05-09	2004-05-09 00:00:00	2004-05-30	2004-05-30 00:00:00	2004-05-30	38000177		0	0	21		0	0	0	142104	0	849574	1115171		
4867	406	40229134	2007-07-22	2007-07-22 00:00:00	2007-08-05	2007-08-05 00:00:00	2007-08-05	38000177		0	0	14		0	0	0	26746	0	1043400	40229134		
25038	2060	19059056	1968-06-10	1968-06-10 00:00:00	1968-06-24	1968-06-24 00:00:00	1968-06-24	38000177		0	0	14		0	0	0	137012	0	243670	19059056		
35582	2933	1539411	2011-10-10	2011-10-10 00:00:00	2011-10-10	2011-10-10 00:00:00	\N	38000177		0	0	0		0	0	0	195614	0	312961	1539411		
39343	3249	19006318	1959-06-12	1959-06-12 00:00:00	1959-06-26	1959-06-26 00:00:00	1959-06-26	38000177		0	0	14		0	0	0	215970	0	105078	19006318		
18964	1567	19133873	1980-07-29	1980-07-29 00:00:00	1980-08-08	1980-08-08 00:00:00	1980-08-08	38000177		0	0	10		0	0	0	105109	0	834061	19133873		
11770	978	1118084	2012-04-22	2012-04-22 00:00:00	2012-04-22	2012-04-22 00:00:00	\N	38000177		0	0	0		0	0	0	65143	0	00025152531	44923712		
30753	2548	1118084	1997-11-14	1997-11-14 00:00:00	1997-11-14	1997-11-14 00:00:00	\N	38000177		0	0	0		0	0	0	168717	0	00025152531	44923712		
35217	2905	19128065	1982-11-14	1982-11-14 00:00:00	1983-11-09	1983-11-09 00:00:00	1983-11-09	38000177		0	0	360		0	0	0	193604	0	749882	19128065		
33862	2801	836659	1996-07-05	1996-07-05 00:00:00	1996-07-05	1996-07-05 00:00:00	\N	38000177		0	0	0		0	0	0	185644	0	313185	836659		
22392	1842	19133905	1997-08-08	1997-08-08 00:00:00	1997-08-17	1997-08-17 00:00:00	1997-08-17	38000177		0	0	9		0	0	0	122951	0	834102	19133905		
239487	5256	40213160	1960-02-19	1960-02-19 00:00:00	1960-02-19	1960-02-19 00:00:00	1960-02-19	581452		0	0	0		0	0	0	349778	0	10	40213160		
150202	3304	40213306	1984-10-31	1984-10-31 00:00:00	1984-10-31	1984-10-31 00:00:00	1984-10-31	581452		0	0	0		0	0	0	219462	0	43	40213306		
53531	1173	40213198	2010-12-13	2010-12-13 00:00:00	2010-12-13	2010-12-13 00:00:00	2010-12-13	581452		0	0	0		0	0	0	77281	0	133	40213198		
37351	3086	1118084	2004-09-06	2004-09-06 00:00:00	2004-09-06	2004-09-06 00:00:00	\N	38000177		0	0	0		0	0	0	205483	0	00025152531	44923712		
18623	1538	19078461	1993-12-19	1993-12-19 00:00:00	1994-01-02	1994-01-02 00:00:00	1994-01-02	38000177		0	0	14		0	0	0	102946	0	310965	19078461		
103402	2267	40213260	2016-12-19	2016-12-19 00:00:00	2016-12-19	2016-12-19 00:00:00	2016-12-19	581452		0	0	0		0	0	0	150698	0	121	40213260		
47471	3935	1713671	1958-03-16	1958-03-16 00:00:00	1958-03-30	1958-03-30 00:00:00	1958-03-30	38000177		0	0	14		0	0	0	261575	0	562251	1713671		
47995	3980	19128022	1990-10-13	1990-10-13 00:00:00	1991-10-08	1991-10-08 00:00:00	1991-10-08	38000177		0	0	360		0	0	0	264566	0	749785	19128022		
29276	2424	35605482	1997-06-06	1997-06-06 00:00:00	1997-06-06	1997-06-06 00:00:00	1997-06-06	38000177		0	0	0		0	0	0	160819	0	1740467	35605482		
65092	1425	40213227	2017-05-23	2017-05-23 00:00:00	2017-05-23	2017-05-23 00:00:00	2017-05-23	581452		0	0	0		0	0	0	94784	0	113	40213227		
25821	2123	40229134	1967-01-24	1967-01-24 00:00:00	1967-01-31	1967-01-31 00:00:00	1967-01-31	38000177		0	0	7		0	0	0	141295	0	1043400	40229134		
1248	99	19133873	1967-10-11	1967-10-11 00:00:00	1967-10-19	1967-10-19 00:00:00	1967-10-19	38000177		0	0	8		0	0	0	6718	0	834061	19133873		
119352	2624	40213260	2018-01-04	2018-01-04 00:00:00	2018-01-04	2018-01-04 00:00:00	2018-01-04	581452		0	0	0		0	0	0	173622	0	121	40213260		
58729	4876	19128065	1988-05-10	1988-05-10 00:00:00	1989-05-05	1989-05-05 00:00:00	1989-05-05	38000177		0	0	360		0	0	0	324301	0	749882	19128065		
11342	946	19133905	2015-02-23	2015-02-23 00:00:00	2015-03-07	2015-03-07 00:00:00	2015-03-07	38000177		0	0	12		0	0	0	62815	0	834102	19133905		
28172	2329	1713671	2001-09-19	2001-09-19 00:00:00	2001-09-26	2001-09-26 00:00:00	2001-09-26	38000177		0	0	7		0	0	0	154925	0	562251	1713671		
17118	369	40213227	2012-03-31	2012-03-31 00:00:00	2012-03-31	2012-03-31 00:00:00	2012-03-31	581452		0	0	0		0	0	0	24576	0	113	40213227		
8605	718	19078461	1992-09-05	1992-09-05 00:00:00	1992-09-26	1992-09-26 00:00:00	1992-09-26	38000177		0	0	21		0	0	0	47526	0	310965	19078461		
22466	1847	19059056	1928-05-28	1928-05-28 00:00:00	1928-08-26	1928-08-26 00:00:00	1928-08-26	38000177		0	0	90		0	0	0	123517	0	243670	19059056		
47644	3950	1127078	1979-06-07	1979-06-07 00:00:00	1979-06-28	1979-06-28 00:00:00	1979-06-28	38000177		0	0	21		0	0	0	262523	0	282464	1127078		
54757	4548	19019979	1986-10-07	1986-10-07 00:00:00	1986-10-21	1986-10-21 00:00:00	1986-10-21	38000177		0	0	14		0	0	0	303030	0	198405	19019979		
180204	3960	40213160	1958-10-25	1958-10-25 00:00:00	1958-10-25	1958-10-25 00:00:00	1958-10-25	581452		0	0	0		0	0	0	263274	0	10	40213160		
13367	1120	19133873	1972-07-30	1972-07-30 00:00:00	1972-08-06	1972-08-06 00:00:00	1972-08-06	38000177		0	0	7		0	0	0	73788	0	834061	19133873		
64687	1415	40213296	2011-02-06	2011-02-06 00:00:00	2011-02-06	2011-02-06 00:00:00	2011-02-06	581452		0	0	0		0	0	0	94169	0	52	40213296		
58349	4848	40229134	1960-01-08	1960-01-08 00:00:00	1960-01-15	1960-01-15 00:00:00	1960-01-15	38000177		0	0	7		0	0	0	322564	0	1043400	40229134		
20207	440	40213160	1977-11-23	1977-11-23 00:00:00	1977-11-23	1977-11-23 00:00:00	1977-11-23	581452		0	0	0		0	0	0	29211	0	10	40213160		
131884	2897	40213227	1992-01-11	1992-01-11 00:00:00	1992-01-11	1992-01-11 00:00:00	1992-01-11	581452		0	0	0		0	0	0	192920	0	113	40213227		
8389	181	40213160	1978-08-27	1978-08-27 00:00:00	1978-08-27	1978-08-27 00:00:00	1978-08-27	581452		0	0	0		0	0	0	12211	0	10	40213160		
11506	959	40229134	1996-10-18	1996-10-18 00:00:00	1996-10-25	1996-10-25 00:00:00	1996-10-25	38000177		0	0	7		0	0	0	63776	0	1043400	40229134		
176542	3881	40213160	1956-02-03	1956-02-03 00:00:00	1956-02-03	1956-02-03 00:00:00	1956-02-03	581452		0	0	0		0	0	0	257924	0	10	40213160		
34638	2861	19059056	1966-11-05	1966-11-05 00:00:00	1966-11-19	1966-11-19 00:00:00	1966-11-19	38000177		0	0	14		0	0	0	190210	0	243670	19059056		
26264	2160	1127433	1995-11-14	1995-11-14 00:00:00	1995-11-21	1995-11-21 00:00:00	1995-11-21	38000177		0	0	7		0	0	0	143983	0	313782	1127433		
7254	608	1118084	2012-11-29	2012-11-29 00:00:00	2012-11-29	2012-11-29 00:00:00	\N	38000177		0	0	0		0	0	0	40360	0	00025152531	44923712		
8904	743	1713671	1981-07-09	1981-07-09 00:00:00	1981-07-23	1981-07-23 00:00:00	1981-07-23	38000177		0	0	14		0	0	0	49237	0	562251	1713671		
10089	844	40232448	1970-05-13	1970-05-13 00:00:00	1970-05-13	1970-05-13 00:00:00	\N	38000177		0	0	0		0	0	0	55950	0	1049630	40232448		
41562	3442	1713671	1971-12-08	1971-12-08 00:00:00	1971-12-22	1971-12-22 00:00:00	1971-12-22	38000177		0	0	14		0	0	0	228445	0	562251	1713671		
41590	3443	19128022	1996-02-07	1996-02-07 00:00:00	1997-02-01	1997-02-01 00:00:00	1997-02-01	38000177		0	0	360		0	0	0	228514	0	749785	19128022		
41642	3446	1713671	1998-05-17	1998-05-17 00:00:00	1998-06-07	1998-06-07 00:00:00	1998-06-07	38000177		0	0	21		0	0	0	228767	0	562251	1713671		
10673	887	1127433	2007-06-12	2007-06-12 00:00:00	2007-06-19	2007-06-19 00:00:00	2007-06-19	38000177		0	0	7		0	0	0	59144	0	313782	1127433		
31242	2590	1127078	1963-04-14	1963-04-14 00:00:00	1963-04-28	1963-04-28 00:00:00	1963-04-28	38000177		0	0	14		0	0	0	171361	0	282464	1127078		
9425	782	40162522	1954-06-19	1954-06-19 00:00:00	1954-06-19	1954-06-19 00:00:00	\N	38000177		0	0	0		0	0	0	52010	0	857005	40162522		
27531	2280	1124300	2002-06-16	2002-06-16 00:00:00	2002-06-16	2002-06-16 00:00:00	\N	38000177		0	0	0		0	0	0	151559	0	00781178901	45011828		
218898	4804	40213314	1977-06-27	1977-06-27 00:00:00	1977-06-27	1977-06-27 00:00:00	1977-06-27	581452		0	0	0		0	0	0	319537	0	49	40213314		
46935	3887	1127433	1975-06-22	1975-06-22 00:00:00	1975-06-29	1975-06-29 00:00:00	1975-06-29	38000177		0	0	7		0	0	0	258340	0	313782	1127433		
39156	3236	19075601	2016-07-15	2016-07-15 00:00:00	2016-07-15	2016-07-15 00:00:00	2016-07-15	38000177		0	0	0		0	0	0	215114	0	309362	19075601		
4670	388	1127078	1956-08-04	1956-08-04 00:00:00	1956-08-18	1956-08-18 00:00:00	1956-08-18	38000177		0	0	14		0	0	0	25555	0	282464	1127078		
32371	2684	19006318	1962-08-06	1962-08-06 00:00:00	1962-08-20	1962-08-20 00:00:00	1962-08-20	38000177		0	0	14		0	0	0	177862	0	105078	19006318		
42717	3540	46233988	1974-07-27	1974-07-27 00:00:00	1974-08-10	1974-08-10 00:00:00	1974-08-10	38000177		0	0	14		0	0	0	235136	0	1652673	46233988		
52411	4359	1127433	1991-02-08	1991-02-08 00:00:00	1991-02-15	1991-02-15 00:00:00	1991-02-15	38000177		0	0	7		0	0	0	289251	0	313782	1127433		
41224	3418	19133905	1990-06-14	1990-06-14 00:00:00	1990-06-25	1990-06-25 00:00:00	1990-06-25	38000177		0	0	11		0	0	0	226752	0	834102	19133905		
42617	3532	1127433	1994-06-06	1994-06-06 00:00:00	1994-06-27	1994-06-27 00:00:00	1994-06-27	38000177		0	0	21		0	0	0	234630	0	313782	1127433		
41294	3423	19133905	1993-08-03	1993-08-03 00:00:00	1993-08-15	1993-08-15 00:00:00	1993-08-15	38000177		0	0	12		0	0	0	227057	0	834102	19133905		
51481	4279	1713671	1993-03-22	1993-03-22 00:00:00	1993-03-29	1993-03-29 00:00:00	1993-03-29	38000177		0	0	7		0	0	0	283992	0	562251	1713671		
25960	2135	19133905	2000-12-30	2000-12-30 00:00:00	2001-01-08	2001-01-08 00:00:00	2001-01-08	38000177		0	0	9		0	0	0	142108	0	834102	19133905		
4868	406	1115171	2010-10-26	2010-10-26 00:00:00	2010-11-30	2010-11-30 00:00:00	2010-11-30	38000177		0	0	35		0	0	0	26816	0	849574	1115171		
25039	2060	19129655	1968-06-10	1968-06-10 00:00:00	1968-06-24	1968-06-24 00:00:00	1968-06-24	38000177		0	0	14		0	0	0	137012	0	789980	19129655		
35583	2933	1332419	2011-10-10	2011-10-10 00:00:00	2011-10-10	2011-10-10 00:00:00	\N	38000177		0	0	0		0	0	0	195614	0	197361	1332419		
39344	3249	19133905	2008-02-04	2008-02-04 00:00:00	2008-02-15	2008-02-15 00:00:00	2008-02-15	38000177		0	0	11		0	0	0	216015	0	834102	19133905		
18965	1567	1127433	1981-11-21	1981-11-21 00:00:00	1981-12-05	1981-12-05 00:00:00	1981-12-05	38000177		0	0	14		0	0	0	105079	0	313782	1127433		
11771	978	19128065	1990-08-06	1990-08-06 00:00:00	1991-08-01	1991-08-01 00:00:00	1991-08-01	38000177		0	0	360		0	0	0	65181	0	749882	19128065		
30754	2548	1115171	1998-03-14	1998-03-14 00:00:00	1998-04-18	1998-04-18 00:00:00	1998-04-18	38000177		0	0	35		0	0	0	168693	0	849574	1115171		
35218	2905	1713671	1997-02-13	1997-02-13 00:00:00	1997-02-20	1997-02-20 00:00:00	1997-02-20	38000177		0	0	7		0	0	0	193540	0	562251	1713671		
33863	2801	40229134	1931-06-16	1931-06-16 00:00:00	1931-06-30	1931-06-30 00:00:00	1931-06-30	38000177		0	0	14		0	0	0	185640	0	1043400	40229134		
22393	1842	1713671	1974-12-09	1974-12-09 00:00:00	1974-12-23	1974-12-23 00:00:00	1974-12-23	38000177		0	0	14		0	0	0	122956	0	562251	1713671		
220664	4843	40213296	2002-02-26	2002-02-26 00:00:00	2002-02-26	2002-02-26 00:00:00	2002-02-26	581452		0	0	0		0	0	0	322146	0	52	40213296		
150204	3304	40213160	1967-12-20	1967-12-20 00:00:00	1967-12-20	1967-12-20 00:00:00	1967-12-20	581452		0	0	0		0	0	0	219468	0	10	40213160		
53533	1173	40213201	2010-12-13	2010-12-13 00:00:00	2010-12-13	2010-12-13 00:00:00	2010-12-13	581452		0	0	0		0	0	0	77281	0	33	40213201		
37352	3086	1127078	1971-07-12	1971-07-12 00:00:00	1971-07-26	1971-07-26 00:00:00	1971-07-26	38000177		0	0	14		0	0	0	205448	0	282464	1127078		
18624	1538	1713671	2008-09-11	2008-09-11 00:00:00	2008-09-25	2008-09-25 00:00:00	2008-09-25	38000177		0	0	14		0	0	0	103000	0	562251	1713671		
103407	2267	40213160	1966-03-21	1966-03-21 00:00:00	1966-03-21	1966-03-21 00:00:00	1966-03-21	581452		0	0	0		0	0	0	150713	0	10	40213160		
47472	3935	1127433	1964-06-20	1964-06-20 00:00:00	1964-06-27	1964-06-27 00:00:00	1964-06-27	38000177		0	0	7		0	0	0	261565	0	313782	1127433		
47996	3980	1118084	2015-02-04	2015-02-04 00:00:00	2015-02-04	2015-02-04 00:00:00	\N	38000177		0	0	0		0	0	0	264602	0	00025152531	44923712		
48007	3982	40229134	1956-02-23	1956-02-23 00:00:00	1956-03-08	1956-03-08 00:00:00	1956-03-08	38000177		0	0	14		0	0	0	264647	0	1043400	40229134		
65107	1426	40213198	2017-06-06	2017-06-06 00:00:00	2017-06-06	2017-06-06 00:00:00	2017-06-06	581452		0	0	0		0	0	0	94799	0	133	40213198		
25822	2123	40229134	1974-03-12	1974-03-12 00:00:00	1974-03-19	1974-03-19 00:00:00	1974-03-19	38000177		0	0	7		0	0	0	141252	0	1043400	40229134		
1249	99	1115171	2011-09-11	2011-09-11 00:00:00	2011-10-11	2011-10-11 00:00:00	2011-10-11	38000177		0	0	30		0	0	0	6732	0	849574	1115171		
119357	2624	40213227	1999-03-18	1999-03-18 00:00:00	1999-03-18	1999-03-18 00:00:00	1999-03-18	581452		0	0	0		0	0	0	173568	0	113	40213227		
58730	4876	1115171	2018-01-19	2018-01-19 00:00:00	2018-03-20	2018-03-20 00:00:00	2018-03-20	38000177		0	0	60		0	0	0	324304	0	849574	1115171		
11343	946	1127433	2003-12-30	2003-12-30 00:00:00	2004-01-06	2004-01-06 00:00:00	2004-01-06	38000177		0	0	7		0	0	0	62776	0	313782	1127433		
28173	2329	19128065	1985-01-08	1985-01-08 00:00:00	1986-01-03	1986-01-03 00:00:00	1986-01-03	38000177		0	0	360		0	0	0	154942	0	749882	19128065		
17119	369	40213160	1981-06-06	1981-06-06 00:00:00	1981-06-06	1981-06-06 00:00:00	1981-06-06	581452		0	0	0		0	0	0	24547	0	10	40213160		
8606	719	19078461	2009-09-11	2009-09-11 00:00:00	2009-10-11	2009-10-11 00:00:00	2009-10-11	38000177		0	0	30		0	0	0	47564	0	310965	19078461		
22467	1847	1713671	1947-04-24	1947-04-24 00:00:00	1947-05-15	1947-05-15 00:00:00	1947-05-15	38000177		0	0	21		0	0	0	123564	0	562251	1713671		
47645	3950	1127078	1979-09-14	1979-09-14 00:00:00	1979-09-28	1979-09-28 00:00:00	1979-09-28	38000177		0	0	14		0	0	0	262577	0	282464	1127078		
54758	4548	1127433	2016-04-17	2016-04-17 00:00:00	2016-04-24	2016-04-24 00:00:00	2016-04-24	38000177		0	0	7		0	0	0	303054	0	313782	1127433		
180207	3960	40213227	2000-02-26	2000-02-26 00:00:00	2000-02-26	2000-02-26 00:00:00	2000-02-26	581452		0	0	0		0	0	0	263287	0	113	40213227		
13368	1120	19133873	1966-03-23	1966-03-23 00:00:00	1966-04-01	1966-04-01 00:00:00	1966-04-01	38000177		0	0	9		0	0	0	73786	0	834061	19133873		
64692	1415	40213160	1969-07-06	1969-07-06 00:00:00	1969-07-06	1969-07-06 00:00:00	1969-07-06	581452		0	0	0		0	0	0	94199	0	10	40213160		
58350	4848	1118084	1996-08-24	1996-08-24 00:00:00	1996-08-24	1996-08-24 00:00:00	\N	38000177		0	0	0		0	0	0	322519	0	00025152531	44923712		
20209	440	40213314	1977-11-23	1977-11-23 00:00:00	1977-11-23	1977-11-23 00:00:00	1977-11-23	581452		0	0	0		0	0	0	29211	0	49	40213314		
139854	3072	40213160	1964-06-27	1964-06-27 00:00:00	1964-06-27	1964-06-27 00:00:00	1964-06-27	581452		0	0	0		0	0	0	204502	0	10	40213160		
8393	181	40213160	1974-05-26	1974-05-26 00:00:00	1974-05-26	1974-05-26 00:00:00	1974-05-26	581452		0	0	0		0	0	0	12241	0	10	40213160		
11507	959	1713671	1977-05-21	1977-05-21 00:00:00	1977-06-11	1977-06-11 00:00:00	1977-06-11	38000177		0	0	21		0	0	0	63673	0	562251	1713671		
176543	3881	40213160	1955-12-02	1955-12-02 00:00:00	1955-12-02	1955-12-02 00:00:00	1955-12-02	581452		0	0	0		0	0	0	257935	0	10	40213160		
34639	2861	1713671	1998-03-02	1998-03-02 00:00:00	1998-03-16	1998-03-16 00:00:00	1998-03-16	38000177		0	0	14		0	0	0	190175	0	562251	1713671		
26265	2160	1127433	2014-05-23	2014-05-23 00:00:00	2014-06-13	2014-06-13 00:00:00	2014-06-13	38000177		0	0	21		0	0	0	143923	0	313782	1127433		
1229	28	40213227	2002-01-02	2002-01-02 00:00:00	2002-01-02	2002-01-02 00:00:00	2002-01-02	581452		0	0	0		0	0	0	1988	0	113	40213227		
8905	743	1124300	2011-11-08	2011-11-08 00:00:00	2011-11-08	2011-11-08 00:00:00	\N	38000177		0	0	0		0	0	0	49263	0	00781178901	45011828		
10109	847	1713671	1975-09-09	1975-09-09 00:00:00	1975-09-30	1975-09-30 00:00:00	1975-09-30	38000177		0	0	21		0	0	0	56121	0	562251	1713671		
41563	3442	19078461	2014-08-03	2014-08-03 00:00:00	2014-08-24	2014-08-24 00:00:00	2014-08-24	38000177		0	0	21		0	0	0	228419	0	310965	19078461		
41591	3443	19128022	1991-03-05	1991-03-05 00:00:00	1992-02-28	1992-02-28 00:00:00	1992-02-28	38000177		0	0	360		0	0	0	228499	0	749785	19128022		
41643	3446	1127433	1970-10-21	1970-10-21 00:00:00	1970-11-04	1970-11-04 00:00:00	1970-11-04	38000177		0	0	14		0	0	0	228786	0	313782	1127433		
10674	887	19006318	1960-04-30	1960-04-30 00:00:00	1960-05-14	1960-05-14 00:00:00	1960-05-14	38000177		0	0	14		0	0	0	59146	0	105078	19006318		
31243	2590	19129655	1963-04-14	1963-04-14 00:00:00	1963-04-28	1963-04-28 00:00:00	1963-04-28	38000177		0	0	14		0	0	0	171361	0	789980	19129655		
9426	782	19059056	1949-12-14	1949-12-14 00:00:00	1950-01-04	1950-01-04 00:00:00	1950-01-04	38000177		0	0	21		0	0	0	52017	0	243670	19059056		
27532	2280	19078461	2000-08-27	2000-08-27 00:00:00	2000-09-10	2000-09-10 00:00:00	2000-09-10	38000177		0	0	14		0	0	0	151559	0	310965	19078461		
218900	4804	40213227	2018-10-29	2018-10-29 00:00:00	2018-10-29	2018-10-29 00:00:00	2018-10-29	581452		0	0	0		0	0	0	319657	0	113	40213227		
46936	3887	1127433	1963-09-19	1963-09-19 00:00:00	1963-09-26	1963-09-26 00:00:00	1963-09-26	38000177		0	0	7		0	0	0	258387	0	313782	1127433		
39157	3236	1713671	1944-07-12	1944-07-12 00:00:00	1944-08-02	1944-08-02 00:00:00	1944-08-02	38000177		0	0	21		0	0	0	215062	0	562251	1713671		
4671	388	19006318	1956-08-04	1956-08-04 00:00:00	1956-08-18	1956-08-18 00:00:00	1956-08-18	38000177		0	0	14		0	0	0	25555	0	105078	19006318		
32372	2684	19059056	1962-08-06	1962-08-06 00:00:00	1962-08-20	1962-08-20 00:00:00	1962-08-20	38000177		0	0	14		0	0	0	177862	0	243670	19059056		
42718	3540	19059056	1974-07-27	1974-07-27 00:00:00	1974-08-10	1974-08-10 00:00:00	1974-08-10	38000177		0	0	14		0	0	0	235136	0	243670	19059056		
52412	4359	19059056	1987-04-02	1987-04-02 00:00:00	1987-04-30	1987-04-30 00:00:00	1987-04-30	38000177		0	0	28		0	0	0	289213	0	243670	19059056		
41226	3418	19078461	2005-11-20	2005-11-20 00:00:00	2005-12-04	2005-12-04 00:00:00	2005-12-04	38000177		0	0	14		0	0	0	226756	0	310965	19078461		
42618	3532	1713671	2002-08-10	2002-08-10 00:00:00	2002-08-31	2002-08-31 00:00:00	2002-08-31	38000177		0	0	21		0	0	0	234647	0	562251	1713671		
41295	3423	1118084	2012-01-31	2012-01-31 00:00:00	2012-01-31	2012-01-31 00:00:00	\N	38000177		0	0	0		0	0	0	227060	0	00025152531	44923712		
51482	4279	40232448	1954-04-27	1954-04-27 00:00:00	1954-04-27	1954-04-27 00:00:00	\N	38000177		0	0	0		0	0	0	283944	0	1049630	40232448		
25961	2136	40223834	2001-06-22	2001-06-22 00:00:00	2001-06-22	2001-06-22 00:00:00	\N	38000177		0	0	0		0	0	0	142306	0	997501	40223834		
4869	406	19008572	1974-02-22	1974-02-22 00:00:00	1974-02-22	1974-02-22 00:00:00	\N	38000177		0	0	0		0	0	0	26810	0	106258	19008572		
25040	2060	1127433	2004-08-10	2004-08-10 00:00:00	2004-08-17	2004-08-17 00:00:00	2004-08-17	38000177		0	0	7		0	0	0	137039	0	313782	1127433		
35584	2933	19075601	2011-10-10	2011-10-10 00:00:00	2011-10-10	2011-10-10 00:00:00	\N	38000177		0	0	0		0	0	0	195614	0	309362	19075601		
39345	3249	1127433	1973-06-16	1973-06-16 00:00:00	1973-06-30	1973-06-30 00:00:00	1973-06-30	38000177		0	0	14		0	0	0	216017	0	313782	1127433		
18966	1567	1127433	2018-05-12	2018-05-12 00:00:00	2018-05-26	2018-05-26 00:00:00	2018-05-26	38000177		0	0	14		0	0	0	105136	0	313782	1127433		
11772	978	40165015	1995-09-29	1995-09-29 00:00:00	1995-09-29	1995-09-29 00:00:00	\N	38000177		0	0	0		0	0	0	65153	0	861467	40165015		
30767	2550	19133873	1986-05-02	1986-05-02 00:00:00	1986-05-09	1986-05-09 00:00:00	1986-05-09	38000177		0	0	7		0	0	0	168816	0	834061	19133873		
35219	2905	19019979	1974-06-06	1974-06-06 00:00:00	1974-06-20	1974-06-20 00:00:00	1974-06-20	38000177		0	0	14		0	0	0	193587	0	198405	19019979		
33864	2801	1127433	1971-02-17	1971-02-17 00:00:00	1971-02-24	1971-02-24 00:00:00	1971-02-24	38000177		0	0	7		0	0	0	185657	0	313782	1127433		
22394	1842	40229134	1981-07-29	1981-07-29 00:00:00	1981-08-12	1981-08-12 00:00:00	1981-08-12	38000177		0	0	14		0	0	0	122950	0	1043400	40229134		
220667	4843	40213306	1984-05-15	1984-05-15 00:00:00	1984-05-15	1984-05-15 00:00:00	1984-05-15	581452		0	0	0		0	0	0	322131	0	43	40213306		
150209	3304	40213227	2005-01-19	2005-01-19 00:00:00	2005-01-19	2005-01-19 00:00:00	2005-01-19	581452		0	0	0		0	0	0	219436	0	113	40213227		
16968	366	40213227	2002-04-21	2002-04-21 00:00:00	2002-04-21	2002-04-21 00:00:00	2002-04-21	581452		0	0	0		0	0	0	24363	0	113	40213227		
37353	3086	19133873	1971-10-14	1971-10-14 00:00:00	1971-10-26	1971-10-26 00:00:00	1971-10-26	38000177		0	0	12		0	0	0	205443	0	834061	19133873		
18625	1538	19059056	1960-08-23	1960-08-23 00:00:00	1960-09-13	1960-09-13 00:00:00	1960-09-13	38000177		0	0	21		0	0	0	102945	0	243670	19059056		
192142	4222	40213227	1993-01-21	1993-01-21 00:00:00	1993-01-21	1993-01-21 00:00:00	1993-01-21	581452		0	0	0		0	0	0	280277	0	113	40213227		
47473	3935	19078461	1983-02-07	1983-02-07 00:00:00	1983-02-21	1983-02-21 00:00:00	1983-02-21	38000177		0	0	14		0	0	0	261543	0	310965	19078461		
47997	3980	19019979	1977-07-13	1977-07-13 00:00:00	1977-08-03	1977-08-03 00:00:00	1977-08-03	38000177		0	0	21		0	0	0	264589	0	198405	19019979		
48008	3982	19133905	1965-02-20	1965-02-20 00:00:00	1965-02-27	1965-02-27 00:00:00	1965-02-27	38000177		0	0	7		0	0	0	264654	0	834102	19133905		
65110	1426	40213227	2003-03-18	2003-03-18 00:00:00	2003-03-18	2003-03-18 00:00:00	2003-03-18	581452		0	0	0		0	0	0	94841	0	113	40213227		
25823	2123	1127433	1984-06-17	1984-06-17 00:00:00	1984-07-15	1984-07-15 00:00:00	1984-07-15	38000177		0	0	28		0	0	0	141318	0	313782	1127433		
1250	99	40169281	1998-10-10	1998-10-10 00:00:00	1998-10-10	1998-10-10 00:00:00	\N	38000177		0	0	0		0	0	0	6778	0	896209	40169281		
119363	2624	40213160	1968-04-11	1968-04-11 00:00:00	1968-04-11	1968-04-11 00:00:00	1968-04-11	581452		0	0	0		0	0	0	173553	0	10	40213160		
58731	4876	40224805	1992-04-19	1992-04-19 00:00:00	1993-04-14	1993-04-14 00:00:00	1993-04-14	38000177		0	0	360		0	0	0	324245	0	1000126	40224805		
11345	946	1118084	2001-09-13	2001-09-13 00:00:00	2001-09-13	2001-09-13 00:00:00	\N	38000177		0	0	0		0	0	0	62769	0	00025152531	44923712		
28174	2329	19133873	1978-04-23	1978-04-23 00:00:00	1978-05-03	1978-05-03 00:00:00	1978-05-03	38000177		0	0	10		0	0	0	154929	0	834061	19133873		
17120	369	40213314	1981-06-06	1981-06-06 00:00:00	1981-06-06	1981-06-06 00:00:00	1981-06-06	581452		0	0	0		0	0	0	24547	0	49	40213314		
8607	719	1124300	2014-08-23	2014-08-23 00:00:00	2014-08-23	2014-08-23 00:00:00	\N	38000177		0	0	0		0	0	0	47556	0	00781178901	45011828		
22468	1847	1118084	1958-01-16	1958-01-16 00:00:00	1958-01-16	1958-01-16 00:00:00	\N	38000177		0	0	0		0	0	0	123512	0	00025152531	44923712		
47646	3950	19073183	1979-09-14	1979-09-14 00:00:00	1979-09-28	1979-09-28 00:00:00	1979-09-28	38000177		0	0	14		0	0	0	262577	0	308182	19073183		
54759	4548	1713671	2011-05-21	2011-05-21 00:00:00	2011-05-28	2011-05-28 00:00:00	2011-05-28	38000177		0	0	7		0	0	0	303053	0	562251	1713671		
180208	3960	40213296	2000-02-26	2000-02-26 00:00:00	2000-02-26	2000-02-26 00:00:00	2000-02-26	581452		0	0	0		0	0	0	263287	0	52	40213296		
13369	1120	40236824	2016-02-17	2016-02-17 00:00:00	2016-02-24	2016-02-24 00:00:00	2016-02-24	38000177		0	0	7		0	0	0	73799	0	1094107	40236824		
64694	1415	40213160	1969-10-05	1969-10-05 00:00:00	1969-10-05	1969-10-05 00:00:00	1969-10-05	581452		0	0	0		0	0	0	94221	0	10	40213160		
58351	4848	19078461	1988-10-24	1988-10-24 00:00:00	1988-11-07	1988-11-07 00:00:00	1988-11-07	38000177		0	0	14		0	0	0	322563	0	310965	19078461		
20210	440	40213160	1973-05-23	1973-05-23 00:00:00	1973-05-23	1973-05-23 00:00:00	1973-05-23	581452		0	0	0		0	0	0	29189	0	10	40213160		
139864	3072	40213227	2002-04-20	2002-04-20 00:00:00	2002-04-20	2002-04-20 00:00:00	2002-04-20	581452		0	0	0		0	0	0	204443	0	113	40213227		
8395	181	40213160	1974-02-24	1974-02-24 00:00:00	1974-02-24	1974-02-24 00:00:00	1974-02-24	581452		0	0	0		0	0	0	12206	0	10	40213160		
11508	959	1127433	1978-07-01	1978-07-01 00:00:00	1978-07-15	1978-07-15 00:00:00	1978-07-15	38000177		0	0	14		0	0	0	63697	0	313782	1127433		
79300	1736	40213227	2010-07-15	2010-07-15 00:00:00	2010-07-15	2010-07-15 00:00:00	2010-07-15	581452		0	0	0		0	0	0	115912	0	113	40213227		
34640	2861	40229134	2010-11-25	2010-11-25 00:00:00	2010-12-09	2010-12-09 00:00:00	2010-12-09	38000177		0	0	14		0	0	0	190189	0	1043400	40229134		
26266	2160	1127433	1989-01-11	1989-01-11 00:00:00	1989-01-18	1989-01-18 00:00:00	1989-01-18	38000177		0	0	7		0	0	0	143981	0	313782	1127433		
1230	28	40213306	2002-01-02	2002-01-02 00:00:00	2002-01-02	2002-01-02 00:00:00	2002-01-02	581452		0	0	0		0	0	0	1988	0	43	40213306		
8906	743	42902245	1999-09-07	1999-09-07 00:00:00	2000-09-01	2000-09-01 00:00:00	2000-09-01	38000177		0	0	360		0	0	0	49247	0	1359133	42902245		
10110	847	19128022	1989-02-16	1989-02-16 00:00:00	1990-02-11	1990-02-11 00:00:00	1990-02-11	38000177		0	0	360		0	0	0	56094	0	749785	19128022		
41564	3442	40236824	1999-07-12	1999-07-12 00:00:00	1999-07-19	1999-07-19 00:00:00	1999-07-19	38000177		0	0	7		0	0	0	228400	0	1094107	40236824		
41592	3443	40236824	2006-04-10	2006-04-10 00:00:00	2006-04-17	2006-04-17 00:00:00	2006-04-17	38000177		0	0	7		0	0	0	228484	0	1094107	40236824		
41644	3446	1127433	1975-02-28	1975-02-28 00:00:00	1975-04-04	1975-04-04 00:00:00	1975-04-04	38000177		0	0	35		0	0	0	228780	0	313782	1127433		
10675	887	19059056	1960-04-30	1960-04-30 00:00:00	1960-05-14	1960-05-14 00:00:00	1960-05-14	38000177		0	0	14		0	0	0	59146	0	243670	19059056		
31244	2590	1127078	1968-06-28	1968-06-28 00:00:00	1968-07-12	1968-07-12 00:00:00	1968-07-12	38000177		0	0	14		0	0	0	171370	0	282464	1127078		
9427	782	19059056	1913-07-07	1913-07-07 00:00:00	1913-07-28	1913-07-28 00:00:00	1913-07-28	38000177		0	0	21		0	0	0	52015	0	243670	19059056		
27533	2280	19008572	1983-10-17	1983-10-17 00:00:00	1983-10-31	1983-10-31 00:00:00	1983-10-31	38000177		0	0	14		0	0	0	151578	0	106258	19008572		
218901	4804	40213296	2018-10-29	2018-10-29 00:00:00	2018-10-29	2018-10-29 00:00:00	2018-10-29	581452		0	0	0		0	0	0	319657	0	52	40213296		
65843	1441	40213227	2018-07-02	2018-07-02 00:00:00	2018-07-02	2018-07-02 00:00:00	2018-07-02	581452		0	0	0		0	0	0	96004	0	113	40213227		
39158	3236	19059056	1930-07-28	1930-07-28 00:00:00	1930-10-26	1930-10-26 00:00:00	1930-10-26	38000177		0	0	90		0	0	0	215026	0	243670	19059056		
4673	388	1127433	1994-08-16	1994-08-16 00:00:00	1994-08-30	1994-08-30 00:00:00	1994-08-30	38000177		0	0	14		0	0	0	25526	0	313782	1127433		
32373	2684	1115171	2014-04-08	2014-04-08 00:00:00	2014-06-07	2014-06-07 00:00:00	2014-06-07	38000177		0	0	60		0	0	0	177896	0	849574	1115171		
42719	3540	46233988	1976-06-28	1976-06-28 00:00:00	1976-07-12	1976-07-12 00:00:00	1976-07-12	38000177		0	0	14		0	0	0	235152	0	1652673	46233988		
52413	4359	1127433	1979-06-29	1979-06-29 00:00:00	1979-07-13	1979-07-13 00:00:00	1979-07-13	38000177		0	0	14		0	0	0	289212	0	313782	1127433		
41231	3418	1713671	1965-03-29	1965-03-29 00:00:00	1965-04-19	1965-04-19 00:00:00	1965-04-19	38000177		0	0	21		0	0	0	226714	0	562251	1713671		
42619	3532	1127433	1986-12-15	1986-12-15 00:00:00	1987-03-15	1987-03-15 00:00:00	1987-03-15	38000177		0	0	90		0	0	0	234629	0	313782	1127433		
41296	3423	19133873	1988-12-04	1988-12-04 00:00:00	1988-12-14	1988-12-14 00:00:00	1988-12-14	38000177		0	0	10		0	0	0	227063	0	834061	19133873		
51483	4279	19133873	1954-01-20	1954-01-20 00:00:00	1954-01-30	1954-01-30 00:00:00	1954-01-30	38000177		0	0	10		0	0	0	283960	0	834061	19133873		
25962	2136	1594382	2001-06-22	2001-06-22 00:00:00	2001-06-22	2001-06-22 00:00:00	\N	38000177		0	0	0		0	0	0	142306	0	1870230	1594382		
4870	406	1713671	1959-05-31	1959-05-31 00:00:00	1959-06-07	1959-06-07 00:00:00	1959-06-07	38000177		0	0	7		0	0	0	26755	0	562251	1713671		
25041	2060	19128065	1982-11-04	1982-11-04 00:00:00	1983-10-30	1983-10-30 00:00:00	1983-10-30	38000177		0	0	360		0	0	0	137014	0	749882	19128065		
43661	951	40213201	2018-11-21	2018-11-21 00:00:00	2018-11-21	2018-11-21 00:00:00	2018-11-21	581452		0	0	0		0	0	0	63206	0	33	40213201		
39346	3249	1713671	1974-09-17	1974-09-17 00:00:00	1974-10-08	1974-10-08 00:00:00	1974-10-08	38000177		0	0	21		0	0	0	215963	0	562251	1713671		
227898	5004	40213296	2019-03-19	2019-03-19 00:00:00	2019-03-19	2019-03-19 00:00:00	2019-03-19	581452		0	0	0		0	0	0	332806	0	52	40213296		
11773	978	1127433	1995-09-29	1995-09-29 00:00:00	1995-12-28	1995-12-28 00:00:00	1995-12-28	38000177		0	0	90		0	0	0	65153	0	313782	1127433		
30768	2550	19078461	1997-01-02	1997-01-02 00:00:00	1997-03-03	1997-03-03 00:00:00	1997-03-03	38000177		0	0	60		0	0	0	168803	0	310965	19078461		
35220	2905	19129655	1974-06-06	1974-06-06 00:00:00	1974-06-20	1974-06-20 00:00:00	1974-06-20	38000177		0	0	14		0	0	0	193587	0	789980	19129655		
44323	3668	19078461	2016-02-28	2016-02-28 00:00:00	2016-03-27	2016-03-27 00:00:00	2016-03-27	38000177		0	0	28		0	0	0	244023	0	310965	19078461		
22395	1842	19133873	1968-08-07	1968-08-07 00:00:00	1968-08-15	1968-08-15 00:00:00	1968-08-15	38000177		0	0	8		0	0	0	122966	0	834061	19133873		
220669	4843	40213227	2004-03-02	2004-03-02 00:00:00	2004-03-02	2004-03-02 00:00:00	2004-03-02	581452		0	0	0		0	0	0	322163	0	113	40213227		
150211	3304	40213296	2005-01-19	2005-01-19 00:00:00	2005-01-19	2005-01-19 00:00:00	2005-01-19	581452		0	0	0		0	0	0	219436	0	52	40213296		
16973	366	40213227	1992-02-23	1992-02-23 00:00:00	1992-02-23	1992-02-23 00:00:00	1992-02-23	581452		0	0	0		0	0	0	24372	0	113	40213227		
37354	3086	1127433	2014-10-22	2014-10-22 00:00:00	2014-11-05	2014-11-05 00:00:00	2014-11-05	38000177		0	0	14		0	0	0	205446	0	313782	1127433		
18626	1538	1713671	2001-06-23	2001-06-23 00:00:00	2001-07-14	2001-07-14 00:00:00	2001-07-14	38000177		0	0	21		0	0	0	103032	0	562251	1713671		
192157	4222	40213227	2011-04-14	2011-04-14 00:00:00	2011-04-14	2011-04-14 00:00:00	2011-04-14	581452		0	0	0		0	0	0	280281	0	113	40213227		
47474	3935	19059056	1961-05-30	1961-05-30 00:00:00	1961-07-04	1961-07-04 00:00:00	1961-07-04	38000177		0	0	35		0	0	0	261541	0	243670	19059056		
47998	3980	19019979	1986-04-18	1986-04-18 00:00:00	1986-05-18	1986-05-18 00:00:00	1986-05-18	38000177		0	0	30		0	0	0	264578	0	198405	19019979		
48009	3982	19074841	1988-11-18	1988-11-18 00:00:00	1988-12-02	1988-12-02 00:00:00	1988-12-02	38000177		0	0	14		0	0	0	264714	0	309043	19074841		
65112	1426	40213160	1955-11-15	1955-11-15 00:00:00	1955-11-15	1955-11-15 00:00:00	1955-11-15	581452		0	0	0		0	0	0	94852	0	10	40213160		
25824	2123	19006318	1958-01-11	1958-01-11 00:00:00	1958-01-25	1958-01-25 00:00:00	1958-01-25	38000177		0	0	14		0	0	0	141231	0	105078	19006318		
1251	99	1127433	1994-04-02	1994-04-02 00:00:00	1994-04-16	1994-04-16 00:00:00	1994-04-16	38000177		0	0	14		0	0	0	6701	0	313782	1127433		
119365	2624	40213306	1990-03-08	1990-03-08 00:00:00	1990-03-08	1990-03-08 00:00:00	1990-03-08	581452		0	0	0		0	0	0	173565	0	43	40213306		
58732	4876	19133873	1977-11-24	1977-11-24 00:00:00	1977-12-01	1977-12-01 00:00:00	1977-12-01	38000177		0	0	7		0	0	0	324296	0	834061	19133873		
11346	946	1127433	2001-03-21	2001-03-21 00:00:00	2001-04-04	2001-04-04 00:00:00	2001-04-04	38000177		0	0	14		0	0	0	62801	0	313782	1127433		
28175	2329	1118084	2014-03-22	2014-03-22 00:00:00	2014-03-22	2014-03-22 00:00:00	\N	38000177		0	0	0		0	0	0	154921	0	00025152531	44923712		
17123	369	40213314	1982-03-06	1982-03-06 00:00:00	1982-03-06	1982-03-06 00:00:00	1982-03-06	581452		0	0	0		0	0	0	24548	0	49	40213314		
8608	719	19133873	1992-05-17	1992-05-17 00:00:00	1992-05-28	1992-05-28 00:00:00	1992-05-28	38000177		0	0	11		0	0	0	47567	0	834061	19133873		
22469	1847	40236824	1963-12-06	1963-12-06 00:00:00	1963-12-13	1963-12-13 00:00:00	1963-12-13	38000177		0	0	7		0	0	0	123551	0	1094107	40236824		
47647	3950	40229134	1976-08-01	1976-08-01 00:00:00	1976-08-15	1976-08-15 00:00:00	1976-08-15	38000177		0	0	14		0	0	0	262586	0	1043400	40229134		
54760	4548	1713671	1988-03-17	1988-03-17 00:00:00	1988-03-31	1988-03-31 00:00:00	1988-03-31	38000177		0	0	14		0	0	0	303096	0	562251	1713671		
180210	3960	40213160	1958-07-26	1958-07-26 00:00:00	1958-07-26	1958-07-26 00:00:00	1958-07-26	581452		0	0	0		0	0	0	263292	0	10	40213160		
13370	1120	920300	2016-02-17	2016-02-17 00:00:00	2016-02-24	2016-02-24 00:00:00	2016-02-24	38000177		0	0	7		0	0	0	73799	0	311989	920300		
64697	1415	40213160	1969-05-04	1969-05-04 00:00:00	1969-05-04	1969-05-04 00:00:00	1969-05-04	581452		0	0	0		0	0	0	94220	0	10	40213160		
58352	4848	1127433	2003-10-25	2003-10-25 00:00:00	2003-11-01	2003-11-01 00:00:00	2003-11-01	38000177		0	0	7		0	0	0	322509	0	313782	1127433		
59995	4987	1127433	1980-05-25	1980-05-25 00:00:00	1980-06-08	1980-06-08 00:00:00	1980-06-08	38000177		0	0	14		0	0	0	331787	0	313782	1127433		
139866	3072	40213160	1959-12-26	1959-12-26 00:00:00	1959-12-26	1959-12-26 00:00:00	1959-12-26	581452		0	0	0		0	0	0	204432	0	10	40213160		
8397	181	40213227	2004-12-05	2004-12-05 00:00:00	2004-12-05	2004-12-05 00:00:00	2004-12-05	581452		0	0	0		0	0	0	12231	0	113	40213227		
11509	959	1127078	1969-05-27	1969-05-27 00:00:00	1969-06-17	1969-06-17 00:00:00	1969-06-17	38000177		0	0	21		0	0	0	63782	0	282464	1127078		
79301	1736	40213296	2010-07-15	2010-07-15 00:00:00	2010-07-15	2010-07-15 00:00:00	2010-07-15	581452		0	0	0		0	0	0	115912	0	52	40213296		
34641	2861	1127433	1982-03-30	1982-03-30 00:00:00	1982-04-20	1982-04-20 00:00:00	1982-04-20	38000177		0	0	21		0	0	0	190183	0	313782	1127433		
26267	2160	40236824	1993-08-05	1993-08-05 00:00:00	1993-08-12	1993-08-12 00:00:00	1993-08-12	38000177		0	0	7		0	0	0	143982	0	1094107	40236824		
1233	28	40213227	2011-01-12	2011-01-12 00:00:00	2011-01-12	2011-01-12 00:00:00	2011-01-12	581452		0	0	0		0	0	0	1994	0	113	40213227		
8907	743	1713671	2016-01-13	2016-01-13 00:00:00	2016-01-20	2016-01-20 00:00:00	2016-01-20	38000177		0	0	7		0	0	0	49281	0	562251	1713671		
10112	847	19133905	1992-01-23	1992-01-23 00:00:00	1992-02-03	1992-02-03 00:00:00	1992-02-03	38000177		0	0	11		0	0	0	56092	0	834102	19133905		
41565	3442	920300	1999-07-12	1999-07-12 00:00:00	1999-07-19	1999-07-19 00:00:00	1999-07-19	38000177		0	0	7		0	0	0	228400	0	311989	920300		
41593	3443	920300	2006-04-10	2006-04-10 00:00:00	2006-04-17	2006-04-17 00:00:00	2006-04-17	38000177		0	0	7		0	0	0	228484	0	311989	920300		
41645	3446	19133905	1991-10-18	1991-10-18 00:00:00	1991-10-27	1991-10-27 00:00:00	1991-10-27	38000177		0	0	9		0	0	0	228850	0	834102	19133905		
10676	887	40173590	2018-02-24	2018-02-24 00:00:00	2018-02-24	2018-02-24 00:00:00	\N	38000177		0	0	0		0	0	0	59163	0	904419	40173590		
31245	2590	19059056	1967-06-20	1967-06-20 00:00:00	1967-08-19	1967-08-19 00:00:00	1967-08-19	38000177		0	0	60		0	0	0	171405	0	243670	19059056		
9428	782	19059056	1914-08-22	1914-08-22 00:00:00	1914-09-19	1914-09-19 00:00:00	1914-09-19	38000177		0	0	28		0	0	0	52016	0	243670	19059056		
27534	2280	1115171	1997-04-08	1997-04-08 00:00:00	1997-05-15	1997-05-15 00:00:00	1997-05-15	38000177		0	0	37		0	0	0	151558	0	849574	1115171		
152129	3347	40213260	2006-09-16	2006-09-16 00:00:00	2006-09-16	2006-09-16 00:00:00	2006-09-16	581452		0	0	0		0	0	0	222100	0	121	40213260		
65844	1441	40213260	2018-07-02	2018-07-02 00:00:00	2018-07-02	2018-07-02 00:00:00	2018-07-02	581452		0	0	0		0	0	0	96004	0	121	40213260		
39159	3236	1127433	1953-08-06	1953-08-06 00:00:00	1953-08-20	1953-08-20 00:00:00	1953-08-20	38000177		0	0	14		0	0	0	215126	0	313782	1127433		
4674	388	1127433	1969-09-16	1969-09-16 00:00:00	1969-10-14	1969-10-14 00:00:00	1969-10-14	38000177		0	0	28		0	0	0	25583	0	313782	1127433		
32374	2684	1127078	1969-12-27	1969-12-27 00:00:00	1970-01-17	1970-01-17 00:00:00	1970-01-17	38000177		0	0	21		0	0	0	177846	0	282464	1127078		
42720	3540	19019979	1976-06-28	1976-06-28 00:00:00	1976-07-12	1976-07-12 00:00:00	1976-07-12	38000177		0	0	14		0	0	0	235152	0	198405	19019979		
52414	4359	1127078	1952-07-04	1952-07-04 00:00:00	1952-07-18	1952-07-18 00:00:00	1952-07-18	38000177		0	0	14		0	0	0	289228	0	282464	1127078		
41232	3418	920300	1974-11-17	1974-11-17 00:00:00	1974-11-24	1974-11-24 00:00:00	1974-11-24	38000177		0	0	7		0	0	0	226751	0	311989	920300		
42620	3532	40162522	1986-12-15	1986-12-15 00:00:00	1986-12-15	1986-12-15 00:00:00	\N	38000177		0	0	0		0	0	0	234629	0	857005	40162522		
41297	3423	40229134	2010-10-25	2010-10-25 00:00:00	2010-11-01	2010-11-01 00:00:00	2010-11-01	38000177		0	0	7		0	0	0	227059	0	1043400	40229134		
51484	4279	1713671	1978-10-04	1978-10-04 00:00:00	1978-10-18	1978-10-18 00:00:00	1978-10-18	38000177		0	0	14		0	0	0	284075	0	562251	1713671		
25964	2136	19128065	1988-04-27	1988-04-27 00:00:00	1989-04-22	1989-04-22 00:00:00	1989-04-22	38000177		0	0	360		0	0	0	142273	0	749882	19128065		
4871	406	19006318	1952-09-16	1952-09-16 00:00:00	1952-09-30	1952-09-30 00:00:00	1952-09-30	38000177		0	0	14		0	0	0	26797	0	105078	19006318		
25042	2060	1713671	2008-07-05	2008-07-05 00:00:00	2008-07-19	2008-07-19 00:00:00	2008-07-19	38000177		0	0	14		0	0	0	136979	0	562251	1713671		
43665	951	40213227	2003-01-08	2003-01-08 00:00:00	2003-01-08	2003-01-08 00:00:00	2003-01-08	581452		0	0	0		0	0	0	63175	0	113	40213227		
39347	3249	19078461	1999-09-14	1999-09-14 00:00:00	1999-10-14	1999-10-14 00:00:00	1999-10-14	38000177		0	0	30		0	0	0	215990	0	310965	19078461		
227900	5004	40213227	2019-03-19	2019-03-19 00:00:00	2019-03-19	2019-03-19 00:00:00	2019-03-19	581452		0	0	0		0	0	0	332806	0	113	40213227		
11774	978	19078461	2003-06-19	2003-06-19 00:00:00	2003-07-10	2003-07-10 00:00:00	2003-07-10	38000177		0	0	21		0	0	0	65121	0	310965	19078461		
30769	2550	40162522	1997-01-02	1997-01-02 00:00:00	1997-01-02	1997-01-02 00:00:00	\N	38000177		0	0	0		0	0	0	168803	0	857005	40162522		
35221	2905	40229134	2012-12-03	2012-12-03 00:00:00	2012-12-10	2012-12-10 00:00:00	2012-12-10	38000177		0	0	7		0	0	0	193601	0	1043400	40229134		
44324	3668	19059056	1991-05-09	1991-05-09 00:00:00	1991-07-08	1991-07-08 00:00:00	1991-07-08	38000177		0	0	60		0	0	0	244029	0	243670	19059056		
22396	1842	1713671	1975-12-26	1975-12-26 00:00:00	1976-01-09	1976-01-09 00:00:00	1976-01-09	38000177		0	0	14		0	0	0	122943	0	562251	1713671		
220670	4843	40213296	2004-03-02	2004-03-02 00:00:00	2004-03-02	2004-03-02 00:00:00	2004-03-02	581452		0	0	0		0	0	0	322163	0	52	40213296		
150212	3304	40213160	1963-09-18	1963-09-18 00:00:00	1963-09-18	1963-09-18 00:00:00	1963-09-18	581452		0	0	0		0	0	0	219457	0	10	40213160		
41459	3436	1713671	1970-09-22	1970-09-22 00:00:00	1970-10-13	1970-10-13 00:00:00	1970-10-13	38000177		0	0	21		0	0	0	227876	0	562251	1713671		
37355	3086	19059056	1971-11-30	1971-11-30 00:00:00	1971-12-14	1971-12-14 00:00:00	1971-12-14	38000177		0	0	14		0	0	0	205471	0	243670	19059056		
18627	1538	1118084	1964-02-14	1964-02-14 00:00:00	1964-02-14	1964-02-14 00:00:00	\N	38000177		0	0	0		0	0	0	103022	0	00025152531	44923712		
192160	4222	40213160	1955-06-02	1955-06-02 00:00:00	1955-06-02	1955-06-02 00:00:00	1955-06-02	581452		0	0	0		0	0	0	280293	0	10	40213160		
47475	3936	19059056	1962-02-01	1962-02-01 00:00:00	1962-02-22	1962-02-22 00:00:00	1962-02-22	38000177		0	0	21		0	0	0	261631	0	243670	19059056		
47999	3980	19128022	1993-09-27	1993-09-27 00:00:00	1994-09-22	1994-09-22 00:00:00	1994-09-22	38000177		0	0	360		0	0	0	264597	0	749785	19128022		
48010	3982	19059056	1988-11-18	1988-11-18 00:00:00	1988-12-02	1988-12-02 00:00:00	1988-12-02	38000177		0	0	14		0	0	0	264714	0	243670	19059056		
65125	1426	40213227	1994-12-20	1994-12-20 00:00:00	1994-12-20	1994-12-20 00:00:00	1994-12-20	581452		0	0	0		0	0	0	94847	0	113	40213227		
25825	2123	19059056	1958-01-11	1958-01-11 00:00:00	1958-01-25	1958-01-25 00:00:00	1958-01-25	38000177		0	0	14		0	0	0	141231	0	243670	19059056		
1252	99	19073188	1994-04-02	1994-04-02 00:00:00	1994-04-16	1994-04-16 00:00:00	1994-04-16	38000177		0	0	14		0	0	0	6701	0	308192	19073188		
119366	2624	40213296	2008-01-10	2008-01-10 00:00:00	2008-01-10	2008-01-10 00:00:00	2008-01-10	581452		0	0	0		0	0	0	173620	0	52	40213296		
58734	4878	19133873	1963-11-02	1963-11-02 00:00:00	1963-11-09	1963-11-09 00:00:00	1963-11-09	38000177		0	0	7		0	0	0	324400	0	834061	19133873		
11347	946	1713671	2000-01-12	2000-01-12 00:00:00	2000-01-26	2000-01-26 00:00:00	2000-01-26	38000177		0	0	14		0	0	0	62800	0	562251	1713671		
28176	2329	1127078	1982-10-25	1982-10-25 00:00:00	1983-01-23	1983-01-23 00:00:00	1983-01-23	38000177		0	0	90		0	0	0	154901	0	282464	1127078		
17126	369	40213314	1981-04-04	1981-04-04 00:00:00	1981-04-04	1981-04-04 00:00:00	1981-04-04	581452		0	0	0		0	0	0	24530	0	49	40213314		
8609	719	920300	2016-03-26	2016-03-26 00:00:00	2016-04-02	2016-04-02 00:00:00	2016-04-02	38000177		0	0	7		0	0	0	47583	0	311989	920300		
22470	1847	920300	1963-12-06	1963-12-06 00:00:00	1963-12-13	1963-12-13 00:00:00	1963-12-13	38000177		0	0	7		0	0	0	123551	0	311989	920300		
47648	3950	19059056	1972-10-20	1972-10-20 00:00:00	1972-11-10	1972-11-10 00:00:00	1972-11-10	38000177		0	0	21		0	0	0	262522	0	243670	19059056		
54761	4548	1127433	1988-10-15	1988-10-15 00:00:00	1988-10-29	1988-10-29 00:00:00	1988-10-29	38000177		0	0	14		0	0	0	303016	0	313782	1127433		
180214	3960	40213260	2008-02-16	2008-02-16 00:00:00	2008-02-16	2008-02-16 00:00:00	2008-02-16	581452		0	0	0		0	0	0	263298	0	121	40213260		
13371	1120	1713671	1994-09-22	1994-09-22 00:00:00	1994-09-29	1994-09-29 00:00:00	1994-09-29	38000177		0	0	7		0	0	0	73847	0	562251	1713671		
56454	1236	40213201	1987-03-19	1987-03-19 00:00:00	1987-03-19	1987-03-19 00:00:00	1987-03-19	581452		0	0	0		0	0	0	81438	0	33	40213201		
58353	4848	1127433	2017-03-10	2017-03-10 00:00:00	2017-04-14	2017-04-14 00:00:00	2017-04-14	38000177		0	0	35		0	0	0	322540	0	313782	1127433		
59997	4987	1127433	2019-06-10	2019-06-10 00:00:00	2019-06-10	2019-06-10 00:00:00	\N	38000177		0	0	0		0	0	0	331791	0	313782	1127433		
139867	3072	40213260	2009-07-18	2009-07-18 00:00:00	2009-07-18	2009-07-18 00:00:00	2009-07-18	581452		0	0	0		0	0	0	204467	0	121	40213260		
8401	181	40213314	1977-08-21	1977-08-21 00:00:00	1977-08-21	1977-08-21 00:00:00	1977-08-21	581452		0	0	0		0	0	0	12222	0	49	40213314		
11510	959	1127433	1967-02-08	1967-02-08 00:00:00	1967-02-15	1967-02-15 00:00:00	1967-02-15	38000177		0	0	7		0	0	0	63695	0	313782	1127433		
79308	1736	40213160	1974-04-18	1974-04-18 00:00:00	1974-04-18	1974-04-18 00:00:00	1974-04-18	581452		0	0	0		0	0	0	115907	0	10	40213160		
34642	2861	1713671	2002-11-26	2002-11-26 00:00:00	2002-12-03	2002-12-03 00:00:00	2002-12-03	38000177		0	0	7		0	0	0	190208	0	562251	1713671		
26268	2160	920300	1993-08-05	1993-08-05 00:00:00	1993-08-12	1993-08-12 00:00:00	1993-08-12	38000177		0	0	7		0	0	0	143982	0	311989	920300		
37650	3114	1713671	1976-10-27	1976-10-27 00:00:00	1976-11-10	1976-11-10 00:00:00	1976-11-10	38000177		0	0	14		0	0	0	207112	0	562251	1713671		
8908	743	40229134	2006-09-15	2006-09-15 00:00:00	2006-09-29	2006-09-29 00:00:00	2006-09-29	38000177		0	0	14		0	0	0	49267	0	1043400	40229134		
10113	847	19133905	2008-10-27	2008-10-27 00:00:00	2008-11-05	2008-11-05 00:00:00	2008-11-05	38000177		0	0	9		0	0	0	56146	0	834102	19133905		
41566	3442	1127433	2006-06-12	2006-06-12 00:00:00	2006-06-26	2006-06-26 00:00:00	2006-06-26	38000177		0	0	14		0	0	0	228411	0	313782	1127433		
41594	3443	1713671	1993-06-20	1993-06-20 00:00:00	1993-07-04	1993-07-04 00:00:00	1993-07-04	38000177		0	0	14		0	0	0	228510	0	562251	1713671		
41646	3446	45892894	2018-03-30	2018-03-30 00:00:00	2018-03-30	2018-03-30 00:00:00	\N	38000177		0	0	0		0	0	0	228814	0	1599803	45892894		
10677	887	1127433	1974-10-05	1974-10-05 00:00:00	1974-10-19	1974-10-19 00:00:00	1974-10-19	38000177		0	0	14		0	0	0	59102	0	313782	1127433		
31246	2591	1127433	1981-11-02	1981-11-02 00:00:00	1981-11-16	1981-11-16 00:00:00	1981-11-16	38000177		0	0	14		0	0	0	171460	0	313782	1127433		
9429	782	40229134	1913-03-27	1913-03-27 00:00:00	1913-04-03	1913-04-03 00:00:00	1913-04-03	38000177		0	0	7		0	0	0	51990	0	1043400	40229134		
27535	2280	1127433	1984-05-02	1984-05-02 00:00:00	1984-05-16	1984-05-16 00:00:00	1984-05-16	38000177		0	0	14		0	0	0	151588	0	313782	1127433		
163429	3595	40213198	2015-02-05	2015-02-05 00:00:00	2015-02-05	2015-02-05 00:00:00	2015-02-05	581452		0	0	0		0	0	0	238799	0	133	40213198		
65849	1441	40213160	1972-06-05	1972-06-05 00:00:00	1972-06-05	1972-06-05 00:00:00	1972-06-05	581452		0	0	0		0	0	0	96027	0	10	40213160		
39160	3236	19078461	1994-06-07	1994-06-07 00:00:00	1994-06-21	1994-06-21 00:00:00	1994-06-21	38000177		0	0	14		0	0	0	215032	0	310965	19078461		
4677	390	1127433	1998-08-21	1998-08-21 00:00:00	1998-09-04	1998-09-04 00:00:00	1998-09-04	38000177		0	0	14		0	0	0	25618	0	313782	1127433		
32375	2684	1127433	1985-06-07	1985-06-07 00:00:00	1985-06-21	1985-06-21 00:00:00	1985-06-21	38000177		0	0	14		0	0	0	177885	0	313782	1127433		
42721	3540	1118084	2013-07-07	2013-07-07 00:00:00	2013-07-07	2013-07-07 00:00:00	\N	38000177		0	0	0		0	0	0	235163	0	00025152531	44923712		
52415	4359	19059056	1943-09-08	1943-09-08 00:00:00	1943-09-22	1943-09-22 00:00:00	1943-09-22	38000177		0	0	14		0	0	0	289227	0	243670	19059056		
41233	3418	40236824	1974-11-17	1974-11-17 00:00:00	1974-11-24	1974-11-24 00:00:00	1974-11-24	38000177		0	0	7		0	0	0	226751	0	1094107	40236824		
42621	3532	1127433	1995-10-31	1995-10-31 00:00:00	1995-11-14	1995-11-14 00:00:00	1995-11-14	38000177		0	0	14		0	0	0	234598	0	313782	1127433		
41298	3423	1713671	1994-03-22	1994-03-22 00:00:00	1994-04-05	1994-04-05 00:00:00	1994-04-05	38000177		0	0	14		0	0	0	227036	0	562251	1713671		
51485	4279	19133905	1975-10-09	1975-10-09 00:00:00	1975-10-16	1975-10-16 00:00:00	1975-10-16	38000177		0	0	7		0	0	0	283948	0	834102	19133905		
25965	2136	1713671	1995-10-21	1995-10-21 00:00:00	1995-11-04	1995-11-04 00:00:00	1995-11-04	38000177		0	0	14		0	0	0	142194	0	562251	1713671		
4872	406	19059056	1952-09-16	1952-09-16 00:00:00	1952-09-30	1952-09-30 00:00:00	1952-09-30	38000177		0	0	14		0	0	0	26797	0	243670	19059056		
25043	2060	1127433	1969-07-15	1969-07-15 00:00:00	1969-07-22	1969-07-22 00:00:00	1969-07-22	38000177		0	0	7		0	0	0	136996	0	313782	1127433		
43667	951	40213227	2013-10-23	2013-10-23 00:00:00	2013-10-23	2013-10-23 00:00:00	2013-10-23	581452		0	0	0		0	0	0	63153	0	113	40213227		
39348	3249	19078461	1998-08-22	1998-08-22 00:00:00	1998-09-19	1998-09-19 00:00:00	1998-09-19	38000177		0	0	28		0	0	0	215989	0	310965	19078461		
227904	5004	40213314	1977-06-14	1977-06-14 00:00:00	1977-06-14	1977-06-14 00:00:00	1977-06-14	581452		0	0	0		0	0	0	332818	0	49	40213314		
11775	978	19133873	1981-05-29	1981-05-29 00:00:00	1981-06-11	1981-06-11 00:00:00	1981-06-11	38000177		0	0	13		0	0	0	65175	0	834061	19133873		
30770	2550	1127433	2018-02-09	2018-02-09 00:00:00	2018-04-10	2018-04-10 00:00:00	2018-04-10	38000177		0	0	60		0	0	0	168845	0	313782	1127433		
35222	2905	1127433	1995-08-29	1995-08-29 00:00:00	1995-09-12	1995-09-12 00:00:00	1995-09-12	38000177		0	0	14		0	0	0	193598	0	313782	1127433		
104064	2283	40213227	1998-12-21	1998-12-21 00:00:00	1998-12-21	1998-12-21 00:00:00	1998-12-21	581452		0	0	0		0	0	0	151928	0	113	40213227		
22397	1842	1713671	2001-02-13	2001-02-13 00:00:00	2001-02-27	2001-02-27 00:00:00	2001-02-27	38000177		0	0	14		0	0	0	122952	0	562251	1713671		
220674	4843	40213160	1962-05-29	1962-05-29 00:00:00	1962-05-29	1962-05-29 00:00:00	1962-05-29	581452		0	0	0		0	0	0	322138	0	10	40213160		
7993	669	1127433	2007-05-31	2007-05-31 00:00:00	2007-06-14	2007-06-14 00:00:00	2007-06-14	38000177		0	0	14		0	0	0	44193	0	313782	1127433		
41460	3437	1713671	1945-05-09	1945-05-09 00:00:00	1945-05-30	1945-05-30 00:00:00	1945-05-30	38000177		0	0	21		0	0	0	227938	0	562251	1713671		
37356	3086	19006318	1971-11-30	1971-11-30 00:00:00	1971-12-14	1971-12-14 00:00:00	1971-12-14	38000177		0	0	14		0	0	0	205471	0	105078	19006318		
18628	1538	1713671	1985-04-16	1985-04-16 00:00:00	1985-04-30	1985-04-30 00:00:00	1985-04-30	38000177		0	0	14		0	0	0	103057	0	562251	1713671		
192165	4222	40213201	2016-05-12	2016-05-12 00:00:00	2016-05-12	2016-05-12 00:00:00	2016-05-12	581452		0	0	0		0	0	0	280316	0	33	40213201		
47476	3936	19059056	1958-08-07	1958-08-07 00:00:00	1958-08-21	1958-08-21 00:00:00	1958-08-21	38000177		0	0	14		0	0	0	261644	0	243670	19059056		
48000	3980	19128022	1992-10-02	1992-10-02 00:00:00	1993-09-27	1993-09-27 00:00:00	1993-09-27	38000177		0	0	360		0	0	0	264596	0	749785	19128022		
48011	3982	1127433	1984-05-16	1984-05-16 00:00:00	1984-05-30	1984-05-30 00:00:00	1984-05-30	38000177		0	0	14		0	0	0	264712	0	313782	1127433		
65130	1426	40213160	1956-11-20	1956-11-20 00:00:00	1956-11-20	1956-11-20 00:00:00	1956-11-20	581452		0	0	0		0	0	0	94801	0	10	40213160		
25826	2123	1127433	1994-10-21	1994-10-21 00:00:00	1994-12-27	1994-12-27 00:00:00	1994-12-27	38000177		0	0	67		0	0	0	141319	0	313782	1127433		
1253	99	19133873	1972-01-30	1972-01-30 00:00:00	1972-02-11	1972-02-11 00:00:00	1972-02-11	38000177		0	0	12		0	0	0	6772	0	834061	19133873		
119368	2624	40213227	2019-01-10	2019-01-10 00:00:00	2019-01-10	2019-01-10 00:00:00	2019-01-10	581452		0	0	0		0	0	0	173585	0	113	40213227		
58735	4878	1713671	2007-06-23	2007-06-23 00:00:00	2007-06-30	2007-06-30 00:00:00	2007-06-30	38000177		0	0	7		0	0	0	324321	0	562251	1713671		
11348	946	1713671	2010-07-12	2010-07-12 00:00:00	2010-08-02	2010-08-02 00:00:00	2010-08-02	38000177		0	0	21		0	0	0	62814	0	562251	1713671		
28177	2329	46233988	1976-08-06	1976-08-06 00:00:00	1976-08-20	1976-08-20 00:00:00	1976-08-20	38000177		0	0	14		0	0	0	154927	0	1652673	46233988		
17128	369	40213160	1981-04-04	1981-04-04 00:00:00	1981-04-04	1981-04-04 00:00:00	1981-04-04	581452		0	0	0		0	0	0	24530	0	10	40213160		
8610	719	40236824	2016-03-26	2016-03-26 00:00:00	2016-04-02	2016-04-02 00:00:00	2016-04-02	38000177		0	0	7		0	0	0	47583	0	1094107	40236824		
22471	1847	19133905	1952-09-07	1952-09-07 00:00:00	1952-09-20	1952-09-20 00:00:00	1952-09-20	38000177		0	0	13		0	0	0	123565	0	834102	19133905		
47649	3951	1713671	2004-04-24	2004-04-24 00:00:00	2004-05-15	2004-05-15 00:00:00	2004-05-15	38000177		0	0	21		0	0	0	262628	0	562251	1713671		
54762	4548	1118084	2017-09-29	2017-09-29 00:00:00	2017-09-29	2017-09-29 00:00:00	\N	38000177		0	0	0		0	0	0	303055	0	00025152531	44923712		
180221	3961	40213160	1973-07-24	1973-07-24 00:00:00	1973-07-24	1973-07-24 00:00:00	1973-07-24	581452		0	0	0		0	0	0	263354	0	10	40213160		
13372	1120	19129655	1961-08-27	1961-08-27 00:00:00	1961-09-10	1961-09-10 00:00:00	1961-09-10	38000177		0	0	14		0	0	0	73848	0	789980	19129655		
56485	1236	40213227	2011-08-04	2011-08-04 00:00:00	2011-08-04	2011-08-04 00:00:00	2011-08-04	581452		0	0	0		0	0	0	81374	0	113	40213227		
58355	4848	1127433	1970-12-09	1970-12-09 00:00:00	1971-01-06	1971-01-06 00:00:00	1971-01-06	38000177		0	0	28		0	0	0	322561	0	313782	1127433		
59998	4987	1127433	2016-05-28	2016-05-28 00:00:00	2016-06-25	2016-06-25 00:00:00	2016-06-25	38000177		0	0	28		0	0	0	331790	0	313782	1127433		
139868	3072	40213296	2002-04-20	2002-04-20 00:00:00	2002-04-20	2002-04-20 00:00:00	2002-04-20	581452		0	0	0		0	0	0	204443	0	52	40213296		
8405	181	40213296	2013-09-22	2013-09-22 00:00:00	2013-09-22	2013-09-22 00:00:00	2013-09-22	581452		0	0	0		0	0	0	12226	0	52	40213296		
11511	959	40232448	1963-04-15	1963-04-15 00:00:00	1963-04-15	1963-04-15 00:00:00	\N	38000177		0	0	0		0	0	0	63669	0	1049630	40232448		
79317	1736	40213227	1992-05-07	1992-05-07 00:00:00	1992-05-07	1992-05-07 00:00:00	1992-05-07	581452		0	0	0		0	0	0	115950	0	113	40213227		
34643	2861	19006318	1965-05-28	1965-05-28 00:00:00	1965-06-11	1965-06-11 00:00:00	1965-06-11	38000177		0	0	14		0	0	0	190176	0	105078	19006318		
34681	2864	1127433	1998-09-01	1998-09-01 00:00:00	1998-09-08	1998-09-08 00:00:00	1998-09-08	38000177		0	0	7		0	0	0	190469	0	313782	1127433		
37651	3114	19078461	2016-04-04	2016-04-04 00:00:00	2016-05-04	2016-05-04 00:00:00	2016-05-04	38000177		0	0	30		0	0	0	207118	0	310965	19078461		
8909	743	19019979	1977-01-25	1977-01-25 00:00:00	1977-02-08	1977-02-08 00:00:00	1977-02-08	38000177		0	0	14		0	0	0	49246	0	198405	19019979		
10114	847	40243436	1970-07-24	1970-07-24 00:00:00	1970-07-24	1970-07-24 00:00:00	1970-07-24	38000177		0	0	0		0	0	0	56137	0	1190795	40243436		
41567	3442	1713671	1962-03-13	1962-03-13 00:00:00	1962-03-27	1962-03-27 00:00:00	1962-03-27	38000177		0	0	14		0	0	0	228396	0	562251	1713671		
41595	3443	1127433	1981-09-16	1981-09-16 00:00:00	1981-09-23	1981-09-23 00:00:00	1981-09-23	38000177		0	0	7		0	0	0	228480	0	313782	1127433		
41647	3446	19059056	1950-08-08	1950-08-08 00:00:00	1950-09-07	1950-09-07 00:00:00	1950-09-07	38000177		0	0	30		0	0	0	228827	0	243670	19059056		
10678	887	19133905	1992-10-17	1992-10-17 00:00:00	1992-10-25	1992-10-25 00:00:00	1992-10-25	38000177		0	0	8		0	0	0	59111	0	834102	19133905		
31247	2591	1127433	1951-04-29	1951-04-29 00:00:00	1951-05-13	1951-05-13 00:00:00	1951-05-13	38000177		0	0	14		0	0	0	171479	0	313782	1127433		
9443	784	1127433	1982-04-01	1982-04-01 00:00:00	1982-05-01	1982-05-01 00:00:00	1982-05-01	38000177		0	0	30		0	0	0	52250	0	313782	1127433		
27536	2280	40231925	1997-04-15	1997-04-15 00:00:00	1997-04-15	1997-04-15 00:00:00	\N	38000177		0	0	0		0	0	0	151692	0	1049221	40231925		
163436	3595	40213227	2011-01-13	2011-01-13 00:00:00	2011-01-13	2011-01-13 00:00:00	2011-01-13	581452		0	0	0		0	0	0	238811	0	113	40213227		
65850	1441	40213160	1967-10-02	1967-10-02 00:00:00	1967-10-02	1967-10-02 00:00:00	1967-10-02	581452		0	0	0		0	0	0	96041	0	10	40213160		
39161	3236	1127433	1952-02-05	1952-02-05 00:00:00	1952-02-12	1952-02-12 00:00:00	1952-02-12	38000177		0	0	7		0	0	0	215054	0	313782	1127433		
4678	390	19128065	1992-01-17	1992-01-17 00:00:00	1993-01-11	1993-01-11 00:00:00	1993-01-11	38000177		0	0	360		0	0	0	25655	0	749882	19128065		
32377	2684	40236824	1995-03-09	1995-03-09 00:00:00	1995-03-16	1995-03-16 00:00:00	1995-03-16	38000177		0	0	7		0	0	0	177860	0	1094107	40236824		
42722	3540	1127433	1988-02-14	1988-02-14 00:00:00	1988-03-06	1988-03-06 00:00:00	1988-03-06	38000177		0	0	21		0	0	0	235122	0	313782	1127433		
52417	4359	40173590	2013-09-04	2013-09-04 00:00:00	2013-09-04	2013-09-04 00:00:00	\N	38000177		0	0	0		0	0	0	289209	0	904419	40173590		
32726	715	40213227	2015-02-17	2015-02-17 00:00:00	2015-02-17	2015-02-17 00:00:00	2015-02-17	581452		0	0	0		0	0	0	47299	0	113	40213227		
42622	3532	1127078	1977-07-05	1977-07-05 00:00:00	1977-10-03	1977-10-03 00:00:00	1977-10-03	38000177		0	0	90		0	0	0	234628	0	282464	1127078		
41299	3423	1127433	2004-12-27	2004-12-27 00:00:00	2005-01-24	2005-01-24 00:00:00	2005-01-24	38000177		0	0	28		0	0	0	227095	0	313782	1127433		
51486	4279	1127433	1980-12-23	1980-12-23 00:00:00	1980-12-30	1980-12-30 00:00:00	1980-12-30	38000177		0	0	7		0	0	0	283951	0	313782	1127433		
25966	2136	40229134	1983-12-11	1983-12-11 00:00:00	1983-12-25	1983-12-25 00:00:00	1983-12-25	38000177		0	0	14		0	0	0	142212	0	1043400	40229134		
4891	408	1127433	1994-06-16	1994-06-16 00:00:00	1994-06-30	1994-06-30 00:00:00	1994-06-30	38000177		0	0	14		0	0	0	26928	0	313782	1127433		
25054	2062	19074841	1989-03-03	1989-03-03 00:00:00	1989-03-17	1989-03-17 00:00:00	1989-03-17	38000177		0	0	14		0	0	0	137199	0	309043	19074841		
43670	951	40213296	1996-02-14	1996-02-14 00:00:00	1996-02-14	1996-02-14 00:00:00	1996-02-14	581452		0	0	0		0	0	0	63203	0	52	40213296		
39349	3249	1118084	2002-02-18	2002-02-18 00:00:00	2002-02-18	2002-02-18 00:00:00	\N	38000177		0	0	0		0	0	0	215983	0	00025152531	44923712		
227905	5004	40213160	1977-06-14	1977-06-14 00:00:00	1977-06-14	1977-06-14 00:00:00	1977-06-14	581452		0	0	0		0	0	0	332818	0	10	40213160		
11776	978	40229134	1985-10-23	1985-10-23 00:00:00	1985-10-30	1985-10-30 00:00:00	1985-10-30	38000177		0	0	7		0	0	0	65142	0	1043400	40229134		
81426	1780	40213160	1970-05-26	1970-05-26 00:00:00	1970-05-26	1970-05-26 00:00:00	1970-05-26	581452		0	0	0		0	0	0	119182	0	10	40213160		
35223	2905	19128065	1980-11-24	1980-11-24 00:00:00	1981-11-19	1981-11-19 00:00:00	1981-11-19	38000177		0	0	360		0	0	0	193545	0	749882	19128065		
138764	3049	40213306	1997-10-24	1997-10-24 00:00:00	1997-10-24	1997-10-24 00:00:00	1997-10-24	581452		0	0	0		0	0	0	202872	0	43	40213306		
22398	1842	19059056	1967-02-11	1967-02-11 00:00:00	1967-02-25	1967-02-25 00:00:00	1967-02-25	38000177		0	0	14		0	0	0	122946	0	243670	19059056		
220676	4843	40213260	2012-07-03	2012-07-03 00:00:00	2012-07-03	2012-07-03 00:00:00	2012-07-03	581452		0	0	0		0	0	0	322171	0	121	40213260		
7994	669	1127433	1998-06-15	1998-06-15 00:00:00	1998-07-06	1998-07-06 00:00:00	1998-07-06	38000177		0	0	21		0	0	0	44156	0	313782	1127433		
41461	3437	1713671	1951-02-15	1951-02-15 00:00:00	1951-03-01	1951-03-01 00:00:00	1951-03-01	38000177		0	0	14		0	0	0	227939	0	562251	1713671		
37357	3086	19133873	1982-05-27	1982-05-27 00:00:00	1982-06-03	1982-06-03 00:00:00	1982-06-03	38000177		0	0	7		0	0	0	205444	0	834061	19133873		
18629	1538	1713671	1942-01-17	1942-01-17 00:00:00	1942-01-31	1942-01-31 00:00:00	1942-01-31	38000177		0	0	14		0	0	0	103053	0	562251	1713671		
192167	4222	40213227	2001-02-15	2001-02-15 00:00:00	2001-02-15	2001-02-15 00:00:00	2001-02-15	581452		0	0	0		0	0	0	280312	0	113	40213227		
18601	403	40213227	2013-04-22	2013-04-22 00:00:00	2013-04-22	2013-04-22 00:00:00	2013-04-22	581452		0	0	0		0	0	0	26506	0	113	40213227		
44532	970	40213201	2018-11-18	2018-11-18 00:00:00	2018-11-18	2018-11-18 00:00:00	2018-11-18	581452		0	0	0		0	0	0	64516	0	33	40213201		
48012	3982	19078461	2010-06-17	2010-06-17 00:00:00	2010-07-15	2010-07-15 00:00:00	2010-07-15	38000177		0	0	28		0	0	0	264676	0	310965	19078461		
219671	4822	40213198	2012-12-19	2012-12-19 00:00:00	2012-12-19	2012-12-19 00:00:00	2012-12-19	581452		0	0	0		0	0	0	320706	0	133	40213198		
25827	2123	19006318	1952-07-22	1952-07-22 00:00:00	1952-08-05	1952-08-05 00:00:00	1952-08-05	38000177		0	0	14		0	0	0	141230	0	105078	19006318		
1254	99	1127078	1968-10-21	1968-10-21 00:00:00	1968-11-20	1968-11-20 00:00:00	1968-11-20	38000177		0	0	30		0	0	0	6728	0	282464	1127078		
119369	2624	40213260	2019-01-10	2019-01-10 00:00:00	2019-01-10	2019-01-10 00:00:00	2019-01-10	581452		0	0	0		0	0	0	173585	0	121	40213260		
58736	4878	1154615	1965-01-11	1965-01-11 00:00:00	1985-02-16	1985-02-16 00:00:00	1985-02-16	38000177		0	0	7341		0	0	0	324409	0	745679	1154615		
11349	946	19059056	1969-01-19	1969-01-19 00:00:00	1969-02-23	1969-02-23 00:00:00	1969-02-23	38000177		0	0	35		0	0	0	62808	0	243670	19059056		
28178	2329	19019979	1976-08-06	1976-08-06 00:00:00	1976-08-20	1976-08-20 00:00:00	1976-08-20	38000177		0	0	14		0	0	0	154927	0	198405	19019979		
17129	370	40213160	1963-10-10	1963-10-10 00:00:00	1963-10-10	1963-10-10 00:00:00	1963-10-10	581452		0	0	0		0	0	0	24602	0	10	40213160		
8611	719	19073183	1982-06-07	1982-06-07 00:00:00	1982-06-21	1982-06-21 00:00:00	1982-06-21	38000177		0	0	14		0	0	0	47572	0	308182	19073183		
22472	1847	1127433	1949-05-10	1949-05-10 00:00:00	1949-05-17	1949-05-17 00:00:00	1949-05-17	38000177		0	0	7		0	0	0	123575	0	313782	1127433		
47651	3951	1118084	1986-08-30	1986-08-30 00:00:00	1986-08-30	1986-08-30 00:00:00	\N	38000177		0	0	0		0	0	0	262684	0	00025152531	44923712		
54763	4548	1115171	2000-01-11	2000-01-11 00:00:00	2000-02-08	2000-02-08 00:00:00	2000-02-08	38000177		0	0	28		0	0	0	303026	0	849574	1115171		
180223	3961	40213296	2015-02-17	2015-02-17 00:00:00	2015-02-17	2015-02-17 00:00:00	2015-02-17	581452		0	0	0		0	0	0	263338	0	52	40213296		
13373	1120	1127078	1961-08-27	1961-08-27 00:00:00	1961-09-10	1961-09-10 00:00:00	1961-09-10	38000177		0	0	14		0	0	0	73848	0	282464	1127078		
216769	4756	40213227	2005-09-17	2005-09-17 00:00:00	2005-09-17	2005-09-17 00:00:00	2005-09-17	581452		0	0	0		0	0	0	316857	0	113	40213227		
58356	4848	1713671	2014-11-23	2014-11-23 00:00:00	2014-11-30	2014-11-30 00:00:00	2014-11-30	38000177		0	0	7		0	0	0	322549	0	562251	1713671		
59999	4987	920300	2014-10-25	2014-10-25 00:00:00	2014-11-01	2014-11-01 00:00:00	2014-11-01	38000177		0	0	7		0	0	0	331760	0	311989	920300		
139872	3072	40213306	1981-09-19	1981-09-19 00:00:00	1981-09-19	1981-09-19 00:00:00	1981-09-19	581452		0	0	0		0	0	0	204442	0	43	40213306		
23786	1956	1127078	1975-01-23	1975-01-23 00:00:00	1975-02-13	1975-02-13 00:00:00	1975-02-13	38000177		0	0	21		0	0	0	130149	0	282464	1127078		
11512	959	1713671	2014-10-01	2014-10-01 00:00:00	2014-10-22	2014-10-22 00:00:00	2014-10-22	38000177		0	0	21		0	0	0	63777	0	562251	1713671		
79318	1736	40213306	1992-05-07	1992-05-07 00:00:00	1992-05-07	1992-05-07 00:00:00	1992-05-07	581452		0	0	0		0	0	0	115950	0	43	40213306		
34644	2861	1127078	1965-05-28	1965-05-28 00:00:00	1965-06-11	1965-06-11 00:00:00	1965-06-11	38000177		0	0	14		0	0	0	190176	0	282464	1127078		
34682	2864	1127433	1954-09-06	1954-09-06 00:00:00	1954-09-13	1954-09-13 00:00:00	1954-09-13	38000177		0	0	7		0	0	0	190495	0	313782	1127433		
37652	3114	19006318	1950-12-04	1950-12-04 00:00:00	1950-12-18	1950-12-18 00:00:00	1950-12-18	38000177		0	0	14		0	0	0	207124	0	105078	19006318		
8910	743	19129655	1977-01-25	1977-01-25 00:00:00	1977-02-08	1977-02-08 00:00:00	1977-02-08	38000177		0	0	14		0	0	0	49246	0	789980	19129655		
10115	847	46275916	1970-07-24	1970-07-24 00:00:00	1970-07-24	1970-07-24 00:00:00	1970-07-24	38000177		0	0	0		0	0	0	56137	0	1660014	46275916		
41568	3442	1713671	1983-10-27	1983-10-27 00:00:00	1983-11-24	1983-11-24 00:00:00	1983-11-24	38000177		0	0	28		0	0	0	228448	0	562251	1713671		
41596	3444	19133905	1958-01-12	1958-01-12 00:00:00	1958-01-20	1958-01-20 00:00:00	1958-01-20	38000177		0	0	8		0	0	0	228536	0	834102	19133905		
41648	3446	19059056	1954-10-29	1954-10-29 00:00:00	1954-11-12	1954-11-12 00:00:00	1954-11-12	38000177		0	0	14		0	0	0	228815	0	243670	19059056		
10679	887	1124300	1991-06-27	1991-06-27 00:00:00	1991-06-27	1991-06-27 00:00:00	\N	38000177		0	0	0		0	0	0	59123	0	00781178901	45011828		
31248	2591	1127433	2017-11-22	2017-11-22 00:00:00	2017-11-29	2017-11-29 00:00:00	2017-11-29	38000177		0	0	7		0	0	0	171458	0	313782	1127433		
9444	784	1127433	1991-06-29	1991-06-29 00:00:00	1991-07-13	1991-07-13 00:00:00	1991-07-13	38000177		0	0	14		0	0	0	52180	0	313782	1127433		
59709	4964	19128065	1977-01-24	1977-01-24 00:00:00	1978-01-19	1978-01-19 00:00:00	1978-01-19	38000177		0	0	360		0	0	0	330010	0	749882	19128065		
163440	3595	40213227	1993-04-29	1993-04-29 00:00:00	1993-04-29	1993-04-29 00:00:00	1993-04-29	581452		0	0	0		0	0	0	238807	0	113	40213227		
65852	1441	40213160	1968-03-04	1968-03-04 00:00:00	1968-03-04	1968-03-04 00:00:00	1968-03-04	581452		0	0	0		0	0	0	96042	0	10	40213160		
39162	3236	1127433	1988-07-26	1988-07-26 00:00:00	1988-10-24	1988-10-24 00:00:00	1988-10-24	38000177		0	0	90		0	0	0	215029	0	313782	1127433		
4679	390	1713671	2017-09-30	2017-09-30 00:00:00	2017-10-14	2017-10-14 00:00:00	2017-10-14	38000177		0	0	14		0	0	0	25607	0	562251	1713671		
32378	2684	920300	1995-03-09	1995-03-09 00:00:00	1995-03-16	1995-03-16 00:00:00	1995-03-16	38000177		0	0	7		0	0	0	177860	0	311989	920300		
42723	3540	1115171	2019-06-13	2019-06-13 00:00:00	2019-06-13	2019-06-13 00:00:00	\N	38000177		0	0	0		0	0	0	235125	0	849574	1115171		
52418	4359	1118084	1985-02-14	1985-02-14 00:00:00	1985-02-14	1985-02-14 00:00:00	\N	38000177		0	0	0		0	0	0	289196	0	00025152531	44923712		
32736	715	40213160	1983-05-24	1983-05-24 00:00:00	1983-05-24	1983-05-24 00:00:00	1983-05-24	581452		0	0	0		0	0	0	47320	0	10	40213160		
42623	3532	19133873	1976-09-10	1976-09-10 00:00:00	1976-09-23	1976-09-23 00:00:00	1976-09-23	38000177		0	0	13		0	0	0	234590	0	834061	19133873		
41300	3423	40229134	1992-04-16	1992-04-16 00:00:00	1992-04-30	1992-04-30 00:00:00	1992-04-30	38000177		0	0	14		0	0	0	227064	0	1043400	40229134		
51487	4279	40229134	1970-10-20	1970-10-20 00:00:00	1970-11-03	1970-11-03 00:00:00	1970-11-03	38000177		0	0	14		0	0	0	283947	0	1043400	40229134		
25967	2136	19008572	2001-06-03	2001-06-03 00:00:00	2001-06-03	2001-06-03 00:00:00	\N	38000177		0	0	0		0	0	0	142305	0	106258	19008572		
4892	408	1551192	1962-02-03	1962-02-03 00:00:00	1962-02-03	1962-02-03 00:00:00	1962-02-03	38000177		0	0	0		0	0	0	26972	0	312617	1551192		
25055	2062	1127433	1989-03-03	1989-03-03 00:00:00	1989-03-17	1989-03-17 00:00:00	1989-03-17	38000177		0	0	14		0	0	0	137199	0	313782	1127433		
35475	2925	19133873	1973-12-09	1973-12-09 00:00:00	1973-12-18	1973-12-18 00:00:00	1973-12-18	38000177		0	0	9		0	0	0	194996	0	834061	19133873		
39350	3249	1115171	2008-02-29	2008-02-29 00:00:00	2008-03-30	2008-03-30 00:00:00	2008-03-30	38000177		0	0	30		0	0	0	215992	0	849574	1115171		
227906	5004	40213314	1978-05-16	1978-05-16 00:00:00	1978-05-16	1978-05-16 00:00:00	1978-05-16	581452		0	0	0		0	0	0	332838	0	49	40213314		
11777	978	40236824	2014-09-09	2014-09-09 00:00:00	2014-09-16	2014-09-16 00:00:00	2014-09-16	38000177		0	0	7		0	0	0	65167	0	1094107	40236824		
81429	1780	40213160	1965-11-23	1965-11-23 00:00:00	1965-11-23	1965-11-23 00:00:00	1965-11-23	581452		0	0	0		0	0	0	119180	0	10	40213160		
35224	2905	920300	2007-01-01	2007-01-01 00:00:00	2007-01-08	2007-01-08 00:00:00	2007-01-08	38000177		0	0	7		0	0	0	193577	0	311989	920300		
138768	3049	40213296	2018-05-04	2018-05-04 00:00:00	2018-05-04	2018-05-04 00:00:00	2018-05-04	581452		0	0	0		0	0	0	\N	0	52	40213296		
22399	1842	19078461	1986-05-02	1986-05-02 00:00:00	1986-05-30	1986-05-30 00:00:00	1986-05-30	38000177		0	0	28		0	0	0	122987	0	310965	19078461		
220682	4843	40213160	1962-10-30	1962-10-30 00:00:00	1962-10-30	1962-10-30 00:00:00	1962-10-30	581452		0	0	0		0	0	0	322172	0	10	40213160		
7995	669	19128022	1991-08-17	1991-08-17 00:00:00	1992-08-11	1992-08-11 00:00:00	1992-08-11	38000177		0	0	360		0	0	0	44195	0	749785	19128022		
41462	3437	1127433	1980-11-30	1980-11-30 00:00:00	1980-12-14	1980-12-14 00:00:00	1980-12-14	38000177		0	0	14		0	0	0	227970	0	313782	1127433		
37358	3087	1127433	1955-12-07	1955-12-07 00:00:00	1955-12-21	1955-12-21 00:00:00	1955-12-21	38000177		0	0	14		0	0	0	205502	0	313782	1127433		
18630	1538	19075601	2016-09-19	2016-09-19 00:00:00	2016-09-19	2016-09-19 00:00:00	2016-09-19	38000177		0	0	0		0	0	0	103052	0	309362	19075601		
205510	4509	40213260	2017-08-29	2017-08-29 00:00:00	2017-08-29	2017-08-29 00:00:00	2017-08-29	581452		0	0	0		0	0	0	300351	0	121	40213260		
18613	404	40213227	1994-03-01	1994-03-01 00:00:00	1994-03-01	1994-03-01 00:00:00	1994-03-01	581452		0	0	0		0	0	0	26689	0	113	40213227		
44536	970	40213227	2003-06-15	2003-06-15 00:00:00	2003-06-15	2003-06-15 00:00:00	2003-06-15	581452		0	0	0		0	0	0	64568	0	113	40213227		
48013	3982	1127433	1986-09-22	1986-09-22 00:00:00	1986-09-29	1986-09-29 00:00:00	1986-09-29	38000177		0	0	7		0	0	0	264655	0	313782	1127433		
182779	4017	40213201	1986-10-23	1986-10-23 00:00:00	1986-10-23	1986-10-23 00:00:00	1986-10-23	581452		0	0	0		0	0	0	267022	0	33	40213201		
25828	2123	19059056	1952-07-22	1952-07-22 00:00:00	1952-08-05	1952-08-05 00:00:00	1952-08-05	38000177		0	0	14		0	0	0	141230	0	243670	19059056		
1255	99	1127433	1980-11-30	1980-11-30 00:00:00	1980-12-14	1980-12-14 00:00:00	1980-12-14	38000177		0	0	14		0	0	0	6777	0	313782	1127433		
14799	1237	19059056	1947-04-23	1947-04-23 00:00:00	1947-05-07	1947-05-07 00:00:00	1947-05-07	38000177		0	0	14		0	0	0	81513	0	243670	19059056		
58737	4878	40169216	1965-01-11	1965-01-11 00:00:00	1985-02-16	1985-02-16 00:00:00	1985-02-16	38000177		0	0	7341		0	0	0	324409	0	895994	40169216		
11350	946	19133905	1979-07-16	1979-07-16 00:00:00	1979-07-28	1979-07-28 00:00:00	1979-07-28	38000177		0	0	12		0	0	0	62804	0	834102	19133905		
28179	2329	19059056	1976-12-11	1976-12-11 00:00:00	1976-12-25	1976-12-25 00:00:00	1976-12-25	38000177		0	0	14		0	0	0	154900	0	243670	19059056		
17133	370	40213227	2005-05-12	2005-05-12 00:00:00	2005-05-12	2005-05-12 00:00:00	2005-05-12	581452		0	0	0		0	0	0	24640	0	113	40213227		
8612	719	19019979	1982-06-07	1982-06-07 00:00:00	1982-06-21	1982-06-21 00:00:00	1982-06-21	38000177		0	0	14		0	0	0	47572	0	198405	19019979		
22473	1847	19078461	1981-05-03	1981-05-03 00:00:00	1981-05-17	1981-05-17 00:00:00	1981-05-17	38000177		0	0	14		0	0	0	123556	0	310965	19078461		
47652	3951	1127078	1950-01-21	1950-01-21 00:00:00	1950-04-21	1950-04-21 00:00:00	1950-04-21	38000177		0	0	90		0	0	0	262600	0	282464	1127078		
54764	4548	1713671	2013-01-26	2013-01-26 00:00:00	2013-02-16	2013-02-16 00:00:00	2013-02-16	38000177		0	0	21		0	0	0	303011	0	562251	1713671		
180225	3961	40213227	2015-02-17	2015-02-17 00:00:00	2015-02-17	2015-02-17 00:00:00	2015-02-17	581452		0	0	0		0	0	0	263338	0	113	40213227		
13374	1120	1713671	1994-01-26	1994-01-26 00:00:00	1994-02-16	1994-02-16 00:00:00	1994-02-16	38000177		0	0	21		0	0	0	73797	0	562251	1713671		
228047	5007	40213227	2005-08-28	2005-08-28 00:00:00	2005-08-28	2005-08-28 00:00:00	2005-08-28	581452		0	0	0		0	0	0	333039	0	113	40213227		
58357	4848	1127433	2007-08-14	2007-08-14 00:00:00	2007-08-28	2007-08-28 00:00:00	2007-08-28	38000177		0	0	14		0	0	0	322502	0	313782	1127433		
60000	4987	40236824	2014-10-25	2014-10-25 00:00:00	2014-11-01	2014-11-01 00:00:00	2014-11-01	38000177		0	0	7		0	0	0	331760	0	1094107	40236824		
139876	3072	40213160	1960-03-26	1960-03-26 00:00:00	1960-03-26	1960-03-26 00:00:00	1960-03-26	581452		0	0	0		0	0	0	204435	0	10	40213160		
23787	1956	1127078	1972-11-04	1972-11-04 00:00:00	1973-02-02	1973-02-02 00:00:00	1973-02-02	38000177		0	0	90		0	0	0	130215	0	282464	1127078		
11513	959	19059056	1962-07-16	1962-07-16 00:00:00	1962-07-30	1962-07-30 00:00:00	1962-07-30	38000177		0	0	14		0	0	0	63779	0	243670	19059056		
79321	1736	40213296	2011-11-03	2011-11-03 00:00:00	2011-11-03	2011-11-03 00:00:00	2011-11-03	581452		0	0	0		0	0	0	115913	0	52	40213296		
34645	2861	19133873	1970-04-28	1970-04-28 00:00:00	1970-05-11	1970-05-11 00:00:00	1970-05-11	38000177		0	0	13		0	0	0	190227	0	834061	19133873		
34683	2864	1713671	1947-09-21	1947-09-21 00:00:00	1947-09-28	1947-09-28 00:00:00	1947-09-28	38000177		0	0	7		0	0	0	190493	0	562251	1713671		
37653	3114	1127078	1950-12-04	1950-12-04 00:00:00	1950-12-18	1950-12-18 00:00:00	1950-12-18	38000177		0	0	14		0	0	0	207124	0	282464	1127078		
8911	743	19073188	2004-05-01	2004-05-01 00:00:00	2004-05-15	2004-05-15 00:00:00	2004-05-15	38000177		0	0	14		0	0	0	49244	0	308192	19073188		
10116	847	1310034	1970-07-24	1970-07-24 00:00:00	1970-07-24	1970-07-24 00:00:00	1970-07-24	38000177		0	0	0		0	0	0	56137	0	834357	1310034		
41569	3442	19078461	2015-06-20	2015-06-20 00:00:00	2015-07-04	2015-07-04 00:00:00	2015-07-04	38000177		0	0	14		0	0	0	228420	0	310965	19078461		
41597	3444	920300	1996-11-17	1996-11-17 00:00:00	1996-11-24	1996-11-24 00:00:00	1996-11-24	38000177		0	0	7		0	0	0	228552	0	311989	920300		
41649	3446	19006318	1954-10-29	1954-10-29 00:00:00	1954-11-12	1954-11-12 00:00:00	1954-11-12	38000177		0	0	14		0	0	0	228815	0	105078	19006318		
10680	887	19133873	1969-07-25	1969-07-25 00:00:00	1969-08-06	1969-08-06 00:00:00	1969-08-06	38000177		0	0	12		0	0	0	59137	0	834061	19133873		
31249	2591	1713671	1996-01-17	1996-01-17 00:00:00	1996-03-20	1996-03-20 00:00:00	1996-03-20	38000177		0	0	63		0	0	0	171428	0	562251	1713671		
9445	784	19059056	1992-08-06	1992-08-06 00:00:00	1992-08-27	1992-08-27 00:00:00	1992-08-27	38000177		0	0	21		0	0	0	52251	0	243670	19059056		
59710	4964	1127433	2015-09-27	2015-09-27 00:00:00	2015-12-26	2015-12-26 00:00:00	2015-12-26	38000177		0	0	90		0	0	0	329972	0	313782	1127433		
11239	935	19018935	1990-05-09	1990-05-09 00:00:00	1990-05-09	1990-05-09 00:00:00	\N	38000177		0	0	0		0	0	0	62238	0	197604	19018935		
65859	1441	40213227	1999-01-04	1999-01-04 00:00:00	1999-01-04	1999-01-04 00:00:00	1999-01-04	581452		0	0	0		0	0	0	96006	0	113	40213227		
39163	3236	19133905	1942-03-14	1942-03-14 00:00:00	1942-03-23	1942-03-23 00:00:00	1942-03-23	38000177		0	0	9		0	0	0	215089	0	834102	19133905		
4680	390	1124300	2016-05-15	2016-05-15 00:00:00	2016-05-15	2016-05-15 00:00:00	\N	38000177		0	0	0		0	0	0	25632	0	00781178901	45011828		
32379	2684	1118084	1995-09-27	1995-09-27 00:00:00	1995-09-27	1995-09-27 00:00:00	\N	38000177		0	0	0		0	0	0	177860	0	00025152531	44923712		
42724	3540	1127433	1994-10-19	1994-10-19 00:00:00	1994-11-02	1994-11-02 00:00:00	1994-11-02	38000177		0	0	14		0	0	0	235114	0	313782	1127433		
52419	4359	19078461	2013-07-12	2013-07-12 00:00:00	2013-08-09	2013-08-09 00:00:00	2013-08-09	38000177		0	0	28		0	0	0	289215	0	310965	19078461		
32737	715	40213314	1983-05-24	1983-05-24 00:00:00	1983-05-24	1983-05-24 00:00:00	1983-05-24	581452		0	0	0		0	0	0	47320	0	49	40213314		
42624	3533	19078461	2000-04-18	2000-04-18 00:00:00	2000-05-09	2000-05-09 00:00:00	2000-05-09	38000177		0	0	21		0	0	0	234720	0	310965	19078461		
41311	3427	46233988	1969-11-29	1969-11-29 00:00:00	1969-12-13	1969-12-13 00:00:00	1969-12-13	38000177		0	0	14		0	0	0	227178	0	1652673	46233988		
51488	4279	40165015	1966-11-14	1966-11-14 00:00:00	1966-11-14	1966-11-14 00:00:00	\N	38000177		0	0	0		0	0	0	284091	0	861467	40165015		
25968	2136	1713671	2017-06-28	2017-06-28 00:00:00	2017-07-05	2017-07-05 00:00:00	2017-07-05	38000177		0	0	7		0	0	0	142271	0	562251	1713671		
4893	408	19078461	2014-12-24	2014-12-24 00:00:00	2015-01-28	2015-01-28 00:00:00	2015-01-28	38000177		0	0	35		0	0	0	26974	0	310965	19078461		
25056	2062	40162522	1989-03-03	1989-03-03 00:00:00	1989-03-03	1989-03-03 00:00:00	\N	38000177		0	0	0		0	0	0	137199	0	857005	40162522		
35477	2925	19128065	1975-12-27	1975-12-27 00:00:00	1976-12-21	1976-12-21 00:00:00	1976-12-21	38000177		0	0	360		0	0	0	195038	0	749882	19128065		
39351	3249	40231925	2008-02-29	2008-02-29 00:00:00	2008-02-29	2008-02-29 00:00:00	\N	38000177		0	0	0		0	0	0	215992	0	1049221	40231925		
227909	5004	40213160	1977-11-15	1977-11-15 00:00:00	1977-11-15	1977-11-15 00:00:00	1977-11-15	581452		0	0	0		0	0	0	332819	0	10	40213160		
11778	978	920300	2014-09-09	2014-09-09 00:00:00	2014-09-16	2014-09-16 00:00:00	2014-09-16	38000177		0	0	7		0	0	0	65167	0	311989	920300		
81432	1780	40213296	2005-06-21	2005-06-21 00:00:00	2005-06-21	2005-06-21 00:00:00	2005-06-21	581452		0	0	0		0	0	0	119120	0	52	40213296		
35225	2905	40236824	2007-01-01	2007-01-01 00:00:00	2007-01-08	2007-01-08 00:00:00	2007-01-08	38000177		0	0	7		0	0	0	193577	0	1094107	40236824		
138769	3049	40213296	2017-11-17	2017-11-17 00:00:00	2017-11-17	2017-11-17 00:00:00	2017-11-17	581452		0	0	0		0	0	0	202858	0	52	40213296		
22400	1842	1118084	2004-11-28	2004-11-28 00:00:00	2004-11-28	2004-11-28 00:00:00	\N	38000177		0	0	0		0	0	0	122963	0	00025152531	44923712		
220694	4843	40213227	2013-07-09	2013-07-09 00:00:00	2013-07-09	2013-07-09 00:00:00	2013-07-09	581452		0	0	0		0	0	0	322164	0	113	40213227		
7996	669	19128065	1989-08-27	1989-08-27 00:00:00	1990-08-22	1990-08-22 00:00:00	1990-08-22	38000177		0	0	360		0	0	0	44145	0	749882	19128065		
41463	3437	19059056	1936-03-20	1936-03-20 00:00:00	1936-04-03	1936-04-03 00:00:00	1936-04-03	38000177		0	0	14		0	0	0	227923	0	243670	19059056		
37359	3087	1713671	1978-02-28	1978-02-28 00:00:00	1978-03-14	1978-03-14 00:00:00	1978-03-14	38000177		0	0	14		0	0	0	205532	0	562251	1713671		
18631	1538	40220960	2016-09-19	2016-09-19 00:00:00	2016-09-19	2016-09-19 00:00:00	2016-09-19	38000177		0	0	0		0	0	0	103052	0	1804799	40220960		
205512	4509	40213306	1990-04-10	1990-04-10 00:00:00	1990-04-10	1990-04-10 00:00:00	1990-04-10	581452		0	0	0		0	0	0	300359	0	43	40213306		
18614	404	40213160	1960-09-20	1960-09-20 00:00:00	1960-09-20	1960-09-20 00:00:00	1960-09-20	581452		0	0	0		0	0	0	26701	0	10	40213160		
44539	970	40213160	1955-05-15	1955-05-15 00:00:00	1955-05-15	1955-05-15 00:00:00	1955-05-15	581452		0	0	0		0	0	0	64535	0	10	40213160		
48014	3982	40229134	1952-08-18	1952-08-18 00:00:00	1952-09-01	1952-09-01 00:00:00	1952-09-01	38000177		0	0	14		0	0	0	264653	0	1043400	40229134		
182798	4017	40213227	2012-05-31	2012-05-31 00:00:00	2012-05-31	2012-05-31 00:00:00	2012-05-31	581452		0	0	0		0	0	0	267005	0	113	40213227		
25829	2123	1713671	1954-05-02	1954-05-02 00:00:00	1954-05-23	1954-05-23 00:00:00	1954-05-23	38000177		0	0	21		0	0	0	141277	0	562251	1713671		
1256	99	1127433	2004-07-28	2004-07-28 00:00:00	2004-08-18	2004-08-18 00:00:00	2004-08-18	38000177		0	0	21		0	0	0	6731	0	313782	1127433		
14800	1237	19059056	1948-05-17	1948-05-17 00:00:00	1948-05-31	1948-05-31 00:00:00	1948-05-31	38000177		0	0	14		0	0	0	81517	0	243670	19059056		
58738	4878	1127433	1988-01-25	1988-01-25 00:00:00	1988-02-08	1988-02-08 00:00:00	1988-02-08	38000177		0	0	14		0	0	0	324346	0	313782	1127433		
11351	946	1713671	2014-07-17	2014-07-17 00:00:00	2014-10-23	2014-10-23 00:00:00	2014-10-23	38000177		0	0	98		0	0	0	62778	0	562251	1713671		
28180	2329	19133873	1977-03-14	1977-03-14 00:00:00	1977-03-26	1977-03-26 00:00:00	1977-03-26	38000177		0	0	12		0	0	0	154922	0	834061	19133873		
17134	370	40213296	2005-05-12	2005-05-12 00:00:00	2005-05-12	2005-05-12 00:00:00	2005-05-12	581452		0	0	0		0	0	0	24640	0	52	40213296		
8613	719	1127078	1983-07-19	1983-07-19 00:00:00	1983-08-02	1983-08-02 00:00:00	1983-08-02	38000177		0	0	14		0	0	0	47584	0	282464	1127078		
22474	1847	19073188	1981-05-03	1981-05-03 00:00:00	1981-05-17	1981-05-17 00:00:00	1981-05-17	38000177		0	0	14		0	0	0	123556	0	308192	19073188		
47653	3951	1713671	1948-04-06	1948-04-06 00:00:00	1948-04-27	1948-04-27 00:00:00	1948-04-27	38000177		0	0	21		0	0	0	262648	0	562251	1713671		
54765	4548	1127433	1987-01-02	1987-01-02 00:00:00	1987-01-16	1987-01-16 00:00:00	1987-01-16	38000177		0	0	14		0	0	0	303094	0	313782	1127433		
180228	3961	40213160	1978-01-24	1978-01-24 00:00:00	1978-01-24	1978-01-24 00:00:00	1978-01-24	581452		0	0	0		0	0	0	263357	0	10	40213160		
13375	1120	19128065	1975-11-08	1975-11-08 00:00:00	1976-11-02	1976-11-02 00:00:00	1976-11-02	38000177		0	0	360		0	0	0	73851	0	749882	19128065		
228048	5007	40213306	2005-08-28	2005-08-28 00:00:00	2005-08-28	2005-08-28 00:00:00	2005-08-28	581452		0	0	0		0	0	0	333039	0	43	40213306		
58358	4848	19133873	1963-11-30	1963-11-30 00:00:00	1963-12-10	1963-12-10 00:00:00	1963-12-10	38000177		0	0	10		0	0	0	322545	0	834061	19133873		
60001	4987	1127433	2007-01-30	2007-01-30 00:00:00	2007-02-06	2007-02-06 00:00:00	2007-02-06	38000177		0	0	7		0	0	0	331735	0	313782	1127433		
139881	3072	40213306	1983-03-26	1983-03-26 00:00:00	1983-03-26	1983-03-26 00:00:00	1983-03-26	581452		0	0	0		0	0	0	204451	0	43	40213306		
23788	1956	19078461	2002-07-21	2002-07-21 00:00:00	2002-08-11	2002-08-11 00:00:00	2002-08-11	38000177		0	0	21		0	0	0	130150	0	310965	19078461		
11514	959	19006318	1962-07-16	1962-07-16 00:00:00	1962-07-30	1962-07-30 00:00:00	1962-07-30	38000177		0	0	14		0	0	0	63779	0	105078	19006318		
170058	3739	40213227	1998-10-12	1998-10-12 00:00:00	1998-10-12	1998-10-12 00:00:00	1998-10-12	581452		0	0	0		0	0	0	248416	0	113	40213227		
34646	2861	19133905	1999-01-16	1999-01-16 00:00:00	1999-01-29	1999-01-29 00:00:00	1999-01-29	38000177		0	0	13		0	0	0	190186	0	834102	19133905		
34684	2864	1127433	2015-04-07	2015-04-07 00:00:00	2015-04-14	2015-04-14 00:00:00	2015-04-14	38000177		0	0	7		0	0	0	190532	0	313782	1127433		
37654	3114	1713671	1979-10-04	1979-10-04 00:00:00	1979-10-25	1979-10-25 00:00:00	1979-10-25	38000177		0	0	21		0	0	0	207132	0	562251	1713671		
8912	743	1115171	2004-05-01	2004-05-01 00:00:00	2004-05-15	2004-05-15 00:00:00	2004-05-15	38000177		0	0	14		0	0	0	49244	0	849574	1115171		
10117	847	19128022	1991-02-06	1991-02-06 00:00:00	1992-02-01	1992-02-01 00:00:00	1992-02-01	38000177		0	0	360		0	0	0	56101	0	749785	19128022		
41570	3442	1127433	1974-12-05	1974-12-05 00:00:00	1974-12-19	1974-12-19 00:00:00	1974-12-19	38000177		0	0	14		0	0	0	228447	0	313782	1127433		
41598	3444	40236824	1996-11-17	1996-11-17 00:00:00	1996-11-24	1996-11-24 00:00:00	1996-11-24	38000177		0	0	7		0	0	0	228552	0	1094107	40236824		
41650	3446	1124300	1989-02-19	1989-02-19 00:00:00	1989-02-19	1989-02-19 00:00:00	\N	38000177		0	0	0		0	0	0	228759	0	00781178901	45011828		
10681	887	1127078	1967-10-21	1967-10-21 00:00:00	1967-11-11	1967-11-11 00:00:00	1967-11-11	38000177		0	0	21		0	0	0	59101	0	282464	1127078		
31250	2591	19078461	2004-02-15	2004-02-15 00:00:00	2004-05-15	2004-05-15 00:00:00	2004-05-15	38000177		0	0	90		0	0	0	171448	0	310965	19078461		
9446	784	1127433	2002-09-27	2002-09-27 00:00:00	2002-10-04	2002-10-04 00:00:00	2002-10-04	38000177		0	0	7		0	0	0	52222	0	313782	1127433		
59711	4964	19059056	1961-02-07	1961-02-07 00:00:00	1961-02-28	1961-02-28 00:00:00	1961-02-28	38000177		0	0	21		0	0	0	329968	0	243670	19059056		
11240	935	40163554	1990-05-09	1990-05-09 00:00:00	1990-05-09	1990-05-09 00:00:00	\N	38000177		0	0	0		0	0	0	62238	0	855332	40163554		
65861	1441	40213296	2007-07-02	2007-07-02 00:00:00	2007-07-02	2007-07-02 00:00:00	2007-07-02	581452		0	0	0		0	0	0	96070	0	52	40213296		
39164	3236	40173590	2014-09-05	2014-09-05 00:00:00	2014-09-05	2014-09-05 00:00:00	\N	38000177		0	0	0		0	0	0	215106	0	904419	40173590		
4681	390	920300	2016-02-22	2016-02-22 00:00:00	2016-02-29	2016-02-29 00:00:00	2016-02-29	38000177		0	0	7		0	0	0	25632	0	311989	920300		
32380	2684	1127433	1977-02-09	1977-02-09 00:00:00	1977-02-23	1977-02-23 00:00:00	1977-02-23	38000177		0	0	14		0	0	0	177894	0	313782	1127433		
42725	3540	1127433	2005-02-05	2005-02-05 00:00:00	2005-02-26	2005-02-26 00:00:00	2005-02-26	38000177		0	0	21		0	0	0	235123	0	313782	1127433		
1845	148	19078461	2007-05-10	2007-05-10 00:00:00	2007-06-07	2007-06-07 00:00:00	2007-06-07	38000177		0	0	28		0	0	0	9979	0	310965	19078461		
32742	715	40213314	1983-07-26	1983-07-26 00:00:00	1983-07-26	1983-07-26 00:00:00	1983-07-26	581452		0	0	0		0	0	0	47337	0	49	40213314		
42625	3533	19128065	1979-11-05	1979-11-05 00:00:00	1980-10-30	1980-10-30 00:00:00	1980-10-30	38000177		0	0	360		0	0	0	234712	0	749882	19128065		
41312	3427	1127078	1969-11-29	1969-11-29 00:00:00	1969-12-13	1969-12-13 00:00:00	1969-12-13	38000177		0	0	14		0	0	0	227178	0	282464	1127078		
51489	4279	19059056	1966-11-14	1966-11-14 00:00:00	1967-02-12	1967-02-12 00:00:00	1967-02-12	38000177		0	0	90		0	0	0	284091	0	243670	19059056		
25970	2136	40236824	2013-06-27	2013-06-27 00:00:00	2013-07-04	2013-07-04 00:00:00	2013-07-04	38000177		0	0	7		0	0	0	142294	0	1094107	40236824		
4894	408	1127433	2011-06-03	2011-06-03 00:00:00	2011-06-10	2011-06-10 00:00:00	2011-06-10	38000177		0	0	7		0	0	0	26992	0	313782	1127433		
25057	2062	1118084	1984-03-25	1984-03-25 00:00:00	1984-03-25	1984-03-25 00:00:00	\N	38000177		0	0	0		0	0	0	137143	0	00025152531	44923712		
35478	2925	19059056	1961-02-03	1961-02-03 00:00:00	1961-02-17	1961-02-17 00:00:00	1961-02-17	38000177		0	0	14		0	0	0	195081	0	243670	19059056		
39352	3249	1127433	2001-08-10	2001-08-10 00:00:00	2001-08-17	2001-08-17 00:00:00	2001-08-17	38000177		0	0	7		0	0	0	215966	0	313782	1127433		
227910	5004	40213227	2008-05-20	2008-05-20 00:00:00	2008-05-20	2008-05-20 00:00:00	2008-05-20	581452		0	0	0		0	0	0	332811	0	113	40213227		
3713	80	40213227	2008-01-07	2008-01-07 00:00:00	2008-01-07	2008-01-07 00:00:00	2008-01-07	581452		0	0	0		0	0	0	5390	0	113	40213227		
81436	1780	40213227	1997-03-25	1997-03-25 00:00:00	1997-03-25	1997-03-25 00:00:00	1997-03-25	581452		0	0	0		0	0	0	119118	0	113	40213227		
35226	2905	1118084	1999-10-06	1999-10-06 00:00:00	1999-10-06	1999-10-06 00:00:00	\N	38000177		0	0	0		0	0	0	193571	0	00025152531	44923712		
138771	3049	40213227	2017-11-17	2017-11-17 00:00:00	2017-11-17	2017-11-17 00:00:00	2017-11-17	581452		0	0	0		0	0	0	202858	0	113	40213227		
22401	1843	19133873	1993-10-02	1993-10-02 00:00:00	1993-10-15	1993-10-15 00:00:00	1993-10-15	38000177		0	0	13		0	0	0	123058	0	834061	19133873		
220695	4843	40213260	2013-07-09	2013-07-09 00:00:00	2013-07-09	2013-07-09 00:00:00	2013-07-09	581452		0	0	0		0	0	0	322164	0	121	40213260		
7997	669	1118084	2004-10-07	2004-10-07 00:00:00	2004-10-07	2004-10-07 00:00:00	\N	38000177		0	0	0		0	0	0	44202	0	00025152531	44923712		
41464	3437	1127433	1976-12-28	1976-12-28 00:00:00	1977-01-04	1977-01-04 00:00:00	1977-01-04	38000177		0	0	7		0	0	0	227969	0	313782	1127433		
37360	3087	19059056	1958-08-13	1958-08-13 00:00:00	1958-09-03	1958-09-03 00:00:00	1958-09-03	38000177		0	0	21		0	0	0	205554	0	243670	19059056		
55043	4571	19078461	1979-02-06	1979-02-06 00:00:00	1979-02-27	1979-02-27 00:00:00	1979-02-27	38000177		0	0	21		0	0	0	304553	0	310965	19078461		
205515	4509	40213160	1968-02-06	1968-02-06 00:00:00	1968-02-06	1968-02-06 00:00:00	1968-02-06	581452		0	0	0		0	0	0	300389	0	10	40213160		
29896	651	40213160	1978-01-12	1978-01-12 00:00:00	1978-01-12	1978-01-12 00:00:00	1978-01-12	581452		0	0	0		0	0	0	43117	0	10	40213160		
44549	970	40213227	2013-10-20	2013-10-20 00:00:00	2013-10-20	2013-10-20 00:00:00	2013-10-20	581452		0	0	0		0	0	0	64497	0	113	40213227		
48015	3982	1127433	2007-12-10	2007-12-10 00:00:00	2007-12-24	2007-12-24 00:00:00	2007-12-24	38000177		0	0	14		0	0	0	264731	0	313782	1127433		
192279	4224	40213201	2012-01-11	2012-01-11 00:00:00	2012-01-11	2012-01-11 00:00:00	2012-01-11	581452		0	0	0		0	0	0	280503	0	33	40213201		
25830	2123	1127433	1980-03-30	1980-03-30 00:00:00	1980-04-06	1980-04-06 00:00:00	1980-04-06	38000177		0	0	7		0	0	0	141307	0	313782	1127433		
1257	99	1127078	1959-06-22	1959-06-22 00:00:00	1959-07-06	1959-07-06 00:00:00	1959-07-06	38000177		0	0	14		0	0	0	6700	0	282464	1127078		
14801	1238	1118084	1997-09-13	1997-09-13 00:00:00	1997-09-13	1997-09-13 00:00:00	\N	38000177		0	0	0		0	0	0	81580	0	00025152531	44923712		
58739	4878	1127078	1970-12-06	1970-12-06 00:00:00	1970-12-20	1970-12-20 00:00:00	1970-12-20	38000177		0	0	14		0	0	0	324430	0	282464	1127078		
11352	946	40162522	1975-04-23	1975-04-23 00:00:00	1975-04-23	1975-04-23 00:00:00	\N	38000177		0	0	0		0	0	0	62809	0	857005	40162522		
28181	2330	19073183	1979-08-29	1979-08-29 00:00:00	1979-09-12	1979-09-12 00:00:00	1979-09-12	38000177		0	0	14		0	0	0	154995	0	308182	19073183		
17139	370	40213227	2014-05-08	2014-05-08 00:00:00	2014-05-08	2014-05-08 00:00:00	2014-05-08	581452		0	0	0		0	0	0	24608	0	113	40213227		
8614	719	19074843	1983-07-19	1983-07-19 00:00:00	1983-08-02	1983-08-02 00:00:00	1983-08-02	38000177		0	0	14		0	0	0	47584	0	309045	19074843		
22475	1847	1713671	1981-11-09	1981-11-09 00:00:00	1981-11-16	1981-11-16 00:00:00	1981-11-16	38000177		0	0	7		0	0	0	123554	0	562251	1713671		
47654	3951	1127433	1997-12-11	1997-12-11 00:00:00	1997-12-25	1997-12-25 00:00:00	1997-12-25	38000177		0	0	14		0	0	0	262686	0	313782	1127433		
54766	4548	40165015	2016-08-03	2016-08-03 00:00:00	2016-08-03	2016-08-03 00:00:00	\N	38000177		0	0	0		0	0	0	303028	0	861467	40165015		
64389	1409	40213227	2008-03-31	2008-03-31 00:00:00	2008-03-31	2008-03-31 00:00:00	2008-03-31	581452		0	0	0		0	0	0	93703	0	113	40213227		
13376	1120	1127433	1987-10-26	1987-10-26 00:00:00	1988-01-24	1988-01-24 00:00:00	1988-01-24	38000177		0	0	90		0	0	0	73812	0	313782	1127433		
228049	5007	40213180	2005-08-28	2005-08-28 00:00:00	2005-08-28	2005-08-28 00:00:00	2005-08-28	581452		0	0	0		0	0	0	333039	0	114	40213180		
58359	4848	920300	2003-09-29	2003-09-29 00:00:00	2003-10-06	2003-10-06 00:00:00	2003-10-06	38000177		0	0	7		0	0	0	322546	0	311989	920300		
60002	4987	1115171	2002-03-15	2002-03-15 00:00:00	2002-04-12	2002-04-12 00:00:00	2002-04-12	38000177		0	0	28		0	0	0	331789	0	849574	1115171		
139886	3072	40213296	2000-04-15	2000-04-15 00:00:00	2000-04-15	2000-04-15 00:00:00	2000-04-15	581452		0	0	0		0	0	0	204472	0	52	40213296		
23789	1956	1127433	1996-04-23	1996-04-23 00:00:00	1996-05-07	1996-05-07 00:00:00	1996-05-07	38000177		0	0	14		0	0	0	130142	0	313782	1127433		
11515	959	1127078	1958-11-21	1958-11-21 00:00:00	1958-12-05	1958-12-05 00:00:00	1958-12-05	38000177		0	0	14		0	0	0	63769	0	282464	1127078		
170062	3739	40213306	1989-10-02	1989-10-02 00:00:00	1989-10-02	1989-10-02 00:00:00	1989-10-02	581452		0	0	0		0	0	0	248413	0	43	40213306		
34647	2861	1127433	1987-12-20	1987-12-20 00:00:00	1988-01-19	1988-01-19 00:00:00	1988-01-19	38000177		0	0	30		0	0	0	190244	0	313782	1127433		
34685	2864	19133873	1947-02-15	1947-02-15 00:00:00	1947-02-25	1947-02-25 00:00:00	1947-02-25	38000177		0	0	10		0	0	0	190492	0	834061	19133873		
37655	3114	19059056	1961-02-01	1961-02-01 00:00:00	1961-05-02	1961-05-02 00:00:00	1961-05-02	38000177		0	0	90		0	0	0	207115	0	243670	19059056		
8913	743	19073188	1991-11-08	1991-11-08 00:00:00	1991-12-06	1991-12-06 00:00:00	1991-12-06	38000177		0	0	28		0	0	0	49243	0	308192	19073188		
10118	847	1118084	2011-06-11	2011-06-11 00:00:00	2011-06-11	2011-06-11 00:00:00	\N	38000177		0	0	0		0	0	0	56118	0	00025152531	44923712		
41571	3442	1127078	1962-02-02	1962-02-02 00:00:00	1962-02-16	1962-02-16 00:00:00	1962-02-16	38000177		0	0	14		0	0	0	228386	0	282464	1127078		
41599	3444	920334	2000-01-15	2000-01-15 00:00:00	2000-01-22	2000-01-22 00:00:00	2000-01-22	38000177		0	0	7		0	0	0	228525	0	311995	920334		
41651	3446	1127433	1968-09-23	1968-09-23 00:00:00	1968-09-30	1968-09-30 00:00:00	1968-09-30	38000177		0	0	7		0	0	0	228808	0	313782	1127433		
10682	887	1127433	1965-06-05	1965-06-05 00:00:00	1965-06-12	1965-06-12 00:00:00	1965-06-12	38000177		0	0	7		0	0	0	59142	0	313782	1127433		
31251	2591	1127433	1997-12-12	1997-12-12 00:00:00	1997-12-26	1997-12-26 00:00:00	1997-12-26	38000177		0	0	14		0	0	0	171511	0	313782	1127433		
9447	784	1127433	1979-01-17	1979-01-17 00:00:00	1979-01-24	1979-01-24 00:00:00	1979-01-24	38000177		0	0	7		0	0	0	52200	0	313782	1127433		
59712	4964	1713671	2003-08-27	2003-08-27 00:00:00	2003-09-17	2003-09-17 00:00:00	2003-09-17	38000177		0	0	21		0	0	0	330008	0	562251	1713671		
11241	935	1713671	1946-01-03	1946-01-03 00:00:00	1946-01-10	1946-01-10 00:00:00	1946-01-10	38000177		0	0	7		0	0	0	62198	0	562251	1713671		
65863	1441	40213260	2017-06-26	2017-06-26 00:00:00	2017-06-26	2017-06-26 00:00:00	2017-06-26	581452		0	0	0		0	0	0	96073	0	121	40213260		
39165	3236	19059056	1993-06-28	1993-06-28 00:00:00	1993-07-12	1993-07-12 00:00:00	1993-07-12	38000177		0	0	14		0	0	0	215031	0	243670	19059056		
4682	390	40236824	2016-02-22	2016-02-22 00:00:00	2016-02-29	2016-02-29 00:00:00	2016-02-29	38000177		0	0	7		0	0	0	25632	0	1094107	40236824		
32381	2684	1115171	1999-06-28	1999-06-28 00:00:00	1999-07-26	1999-07-26 00:00:00	1999-07-26	38000177		0	0	28		0	0	0	177895	0	849574	1115171		
42726	3541	1124300	2010-07-17	2010-07-17 00:00:00	2010-07-17	2010-07-17 00:00:00	\N	38000177		0	0	0		0	0	0	235187	0	00781178901	45011828		
1846	148	1713671	1989-07-26	1989-07-26 00:00:00	1989-08-09	1989-08-09 00:00:00	1989-08-09	38000177		0	0	14		0	0	0	10018	0	562251	1713671		
32743	715	40213160	1983-07-26	1983-07-26 00:00:00	1983-07-26	1983-07-26 00:00:00	1983-07-26	581452		0	0	0		0	0	0	47337	0	10	40213160		
42626	3533	46233988	1969-02-04	1969-02-04 00:00:00	1969-02-18	1969-02-18 00:00:00	1969-02-18	38000177		0	0	14		0	0	0	234693	0	1652673	46233988		
41313	3427	1115171	2013-01-04	2013-01-04 00:00:00	2013-04-04	2013-04-04 00:00:00	2013-04-04	38000177		0	0	90		0	0	0	227229	0	849574	1115171		
51490	4279	1713671	1980-10-25	1980-10-25 00:00:00	1980-11-08	1980-11-08 00:00:00	1980-11-08	38000177		0	0	14		0	0	0	284076	0	562251	1713671		
25971	2136	920300	2013-06-27	2013-06-27 00:00:00	2013-07-04	2013-07-04 00:00:00	2013-07-04	38000177		0	0	7		0	0	0	142294	0	311989	920300		
4895	408	1713671	2013-11-06	2013-11-06 00:00:00	2013-11-27	2013-11-27 00:00:00	2013-11-27	38000177		0	0	21		0	0	0	26994	0	562251	1713671		
25058	2062	19059056	1948-04-08	1948-04-08 00:00:00	1948-04-22	1948-04-22 00:00:00	1948-04-22	38000177		0	0	14		0	0	0	137151	0	243670	19059056		
35479	2925	19073188	2001-05-04	2001-05-04 00:00:00	2001-05-18	2001-05-18 00:00:00	2001-05-18	38000177		0	0	14		0	0	0	195132	0	308192	19073188		
39353	3249	46233710	1972-03-16	1972-03-16 00:00:00	1972-03-30	1972-03-30 00:00:00	1972-03-30	38000177		0	0	14		0	0	0	215952	0	1650142	46233710		
227917	5004	40213227	1999-05-11	1999-05-11 00:00:00	1999-05-11	1999-05-11 00:00:00	1999-05-11	581452		0	0	0		0	0	0	332808	0	113	40213227		
3718	81	40213296	1997-03-12	1997-03-12 00:00:00	1997-03-12	1997-03-12 00:00:00	1997-03-12	581452		0	0	0		0	0	0	5477	0	52	40213296		
81442	1780	40213227	2016-06-21	2016-06-21 00:00:00	2016-06-21	2016-06-21 00:00:00	2016-06-21	581452		0	0	0		0	0	0	119140	0	113	40213227		
35227	2905	19128065	1985-10-29	1985-10-29 00:00:00	1986-10-24	1986-10-24 00:00:00	1986-10-24	38000177		0	0	360		0	0	0	193605	0	749882	19128065		
138773	3049	40213227	1997-09-12	1997-09-12 00:00:00	1997-09-12	1997-09-12 00:00:00	1997-09-12	581452		0	0	0		0	0	0	202871	0	113	40213227		
22402	1843	1127078	1984-08-03	1984-08-03 00:00:00	1984-08-17	1984-08-17 00:00:00	1984-08-17	38000177		0	0	14		0	0	0	123008	0	282464	1127078		
220706	4844	40213227	2001-07-12	2001-07-12 00:00:00	2001-07-12	2001-07-12 00:00:00	2001-07-12	581452		0	0	0		0	0	0	322314	0	113	40213227		
7998	669	1127433	1985-06-09	1985-06-09 00:00:00	1985-06-23	1985-06-23 00:00:00	1985-06-23	38000177		0	0	14		0	0	0	44155	0	313782	1127433		
41465	3437	1118084	1955-03-03	1955-03-03 00:00:00	1955-03-03	1955-03-03 00:00:00	\N	38000177		0	0	0		0	0	0	227954	0	00025152531	44923712		
37361	3087	1127433	1954-07-07	1954-07-07 00:00:00	1954-07-14	1954-07-14 00:00:00	1954-07-14	38000177		0	0	7		0	0	0	205525	0	313782	1127433		
55044	4571	40165015	2001-03-24	2001-03-24 00:00:00	2001-03-24	2001-03-24 00:00:00	\N	38000177		0	0	0		0	0	0	304551	0	861467	40165015		
7459	160	40213160	1962-04-05	1962-04-05 00:00:00	1962-04-05	1962-04-05 00:00:00	1962-04-05	581452		0	0	0		0	0	0	11008	0	10	40213160		
29901	652	40213160	1972-09-12	1972-09-12 00:00:00	1972-09-12	1972-09-12 00:00:00	1972-09-12	581452		0	0	0		0	0	0	43131	0	10	40213160		
44552	970	40213260	2006-09-10	2006-09-10 00:00:00	2006-09-10	2006-09-10 00:00:00	2006-09-10	581452		0	0	0		0	0	0	64509	0	121	40213260		
48016	3982	40229134	1942-03-06	1942-03-06 00:00:00	1942-03-13	1942-03-13 00:00:00	1942-03-13	38000177		0	0	7		0	0	0	264646	0	1043400	40229134		
192280	4224	40213198	2012-01-11	2012-01-11 00:00:00	2012-01-11	2012-01-11 00:00:00	2012-01-11	581452		0	0	0		0	0	0	280503	0	133	40213198		
25831	2123	1127433	1961-06-06	1961-06-06 00:00:00	1961-06-13	1961-06-13 00:00:00	1961-06-13	38000177		0	0	7		0	0	0	141251	0	313782	1127433		
1258	99	19006318	1959-06-22	1959-06-22 00:00:00	1959-07-06	1959-07-06 00:00:00	1959-07-06	38000177		0	0	14		0	0	0	6700	0	105078	19006318		
14802	1238	1127433	2004-06-05	2004-06-05 00:00:00	2004-09-03	2004-09-03 00:00:00	2004-09-03	38000177		0	0	90		0	0	0	81584	0	313782	1127433		
58740	4878	1551192	1963-08-03	1963-08-03 00:00:00	1963-08-03	1963-08-03 00:00:00	1963-08-03	38000177		0	0	0		0	0	0	324459	0	312617	1551192		
11353	946	1127433	1975-04-23	1975-04-23 00:00:00	1975-06-22	1975-06-22 00:00:00	1975-06-22	38000177		0	0	60		0	0	0	62809	0	313782	1127433		
28182	2330	19059056	1979-08-29	1979-08-29 00:00:00	1979-09-12	1979-09-12 00:00:00	1979-09-12	38000177		0	0	14		0	0	0	154995	0	243670	19059056		
17140	370	40213260	2014-05-08	2014-05-08 00:00:00	2014-05-08	2014-05-08 00:00:00	2014-05-08	581452		0	0	0		0	0	0	24608	0	121	40213260		
8615	719	920300	2003-12-25	2003-12-25 00:00:00	2004-01-01	2004-01-01 00:00:00	2004-01-01	38000177		0	0	7		0	0	0	47604	0	311989	920300		
22476	1847	1127433	1956-02-29	1956-02-29 00:00:00	1956-03-14	1956-03-14 00:00:00	1956-03-14	38000177		0	0	14		0	0	0	123511	0	313782	1127433		
47655	3951	19078461	2006-04-18	2006-04-18 00:00:00	2006-05-02	2006-05-02 00:00:00	2006-05-02	38000177		0	0	14		0	0	0	262646	0	310965	19078461		
54767	4548	19078461	2016-08-03	2016-08-03 00:00:00	2016-09-02	2016-09-02 00:00:00	2016-09-02	38000177		0	0	30		0	0	0	303028	0	310965	19078461		
64406	1409	40213201	1983-10-03	1983-10-03 00:00:00	1983-10-03	1983-10-03 00:00:00	1983-10-03	581452		0	0	0		0	0	0	93811	0	33	40213201		
13381	1122	1127078	1972-08-03	1972-08-03 00:00:00	1972-11-01	1972-11-01 00:00:00	1972-11-01	38000177		0	0	90		0	0	0	73928	0	282464	1127078		
228052	5007	40213160	1983-12-04	1983-12-04 00:00:00	1983-12-04	1983-12-04 00:00:00	1983-12-04	581452		0	0	0		0	0	0	333033	0	10	40213160		
58360	4848	40236824	2003-09-29	2003-09-29 00:00:00	2003-10-06	2003-10-06 00:00:00	2003-10-06	38000177		0	0	7		0	0	0	322546	0	1094107	40236824		
60003	4987	1118084	1997-06-04	1997-06-04 00:00:00	1997-06-04	1997-06-04 00:00:00	\N	38000177		0	0	0		0	0	0	331730	0	00025152531	44923712		
946	78	19006318	1967-07-04	1967-07-04 00:00:00	1967-07-18	1967-07-18 00:00:00	1967-07-18	38000177		0	0	14		0	0	0	5156	0	105078	19006318		
23790	1956	1124300	2005-07-29	2005-07-29 00:00:00	2005-07-29	2005-07-29 00:00:00	\N	38000177		0	0	0		0	0	0	130117	0	00781178901	45011828		
11516	959	19006318	1958-11-21	1958-11-21 00:00:00	1958-12-05	1958-12-05 00:00:00	1958-12-05	38000177		0	0	14		0	0	0	63769	0	105078	19006318		
170065	3739	40213160	1967-11-20	1967-11-20 00:00:00	1967-11-20	1967-11-20 00:00:00	1967-11-20	581452		0	0	0		0	0	0	248454	0	10	40213160		
34648	2861	1127433	1999-06-29	1999-06-29 00:00:00	1999-07-13	1999-07-13 00:00:00	1999-07-13	38000177		0	0	14		0	0	0	190187	0	313782	1127433		
34686	2864	19059056	1945-02-24	1945-02-24 00:00:00	1945-03-10	1945-03-10 00:00:00	1945-03-10	38000177		0	0	14		0	0	0	190533	0	243670	19059056		
37656	3114	19059056	1946-10-18	1946-10-18 00:00:00	1946-11-01	1946-11-01 00:00:00	1946-11-01	38000177		0	0	14		0	0	0	207114	0	243670	19059056		
8914	743	1127433	1991-11-08	1991-11-08 00:00:00	1991-12-06	1991-12-06 00:00:00	1991-12-06	38000177		0	0	28		0	0	0	49243	0	313782	1127433		
10119	847	19133905	2008-05-22	2008-05-22 00:00:00	2008-05-29	2008-05-29 00:00:00	2008-05-29	38000177		0	0	7		0	0	0	56099	0	834102	19133905		
41572	3442	19129655	1962-02-02	1962-02-02 00:00:00	1962-02-16	1962-02-16 00:00:00	1962-02-16	38000177		0	0	14		0	0	0	228386	0	789980	19129655		
41600	3444	1127433	1978-06-04	1978-06-04 00:00:00	1978-06-11	1978-06-11 00:00:00	1978-06-11	38000177		0	0	7		0	0	0	228537	0	313782	1127433		
41652	3446	1127433	1982-10-20	1982-10-20 00:00:00	1982-11-10	1982-11-10 00:00:00	1982-11-10	38000177		0	0	21		0	0	0	228783	0	313782	1127433		
10683	887	19133905	2019-06-24	2019-06-24 00:00:00	2019-06-24	2019-06-24 00:00:00	\N	38000177		0	0	0		0	0	0	59145	0	834102	19133905		
31252	2591	40173590	2012-03-14	2012-03-14 00:00:00	2012-03-14	2012-03-14 00:00:00	\N	38000177		0	0	0		0	0	0	171547	0	904419	40173590		
9448	784	19133873	1972-09-03	1972-09-03 00:00:00	1972-09-11	1972-09-11 00:00:00	1972-09-11	38000177		0	0	8		0	0	0	52220	0	834061	19133873		
59713	4964	19133905	1990-08-29	1990-08-29 00:00:00	1990-09-11	1990-09-11 00:00:00	1990-09-11	38000177		0	0	13		0	0	0	330007	0	834102	19133905		
11242	935	19059056	1931-04-06	1931-04-06 00:00:00	1931-06-05	1931-06-05 00:00:00	1931-06-05	38000177		0	0	60		0	0	0	62223	0	243670	19059056		
65867	1441	40213306	1989-12-25	1989-12-25 00:00:00	1989-12-25	1989-12-25 00:00:00	1989-12-25	581452		0	0	0		0	0	0	96082	0	43	40213306		
39166	3236	40229134	1987-03-27	1987-03-27 00:00:00	1987-04-10	1987-04-10 00:00:00	1987-04-10	38000177		0	0	14		0	0	0	215060	0	1043400	40229134		
4683	390	1127433	1989-10-20	1989-10-20 00:00:00	1989-10-27	1989-10-27 00:00:00	1989-10-27	38000177		0	0	7		0	0	0	25654	0	313782	1127433		
32382	2684	1127433	2014-07-23	2014-07-23 00:00:00	2014-08-06	2014-08-06 00:00:00	2014-08-06	38000177		0	0	14		0	0	0	177889	0	313782	1127433		
42727	3541	1127433	1998-10-25	1998-10-25 00:00:00	1998-11-08	1998-11-08 00:00:00	1998-11-08	38000177		0	0	14		0	0	0	235192	0	313782	1127433		
1847	148	40236446	1987-10-13	1987-10-13 00:00:00	1996-10-20	1996-10-20 00:00:00	1996-10-20	38000177		0	0	3295		0	0	0	10017	0	1091392	40236446		
32746	715	40213160	1988-01-26	1988-01-26 00:00:00	1988-01-26	1988-01-26 00:00:00	1988-01-26	581452		0	0	0		0	0	0	47341	0	10	40213160		
42627	3533	19059056	1969-02-04	1969-02-04 00:00:00	1969-02-18	1969-02-18 00:00:00	1969-02-18	38000177		0	0	14		0	0	0	234693	0	243670	19059056		
41314	3427	1118084	2000-11-13	2000-11-13 00:00:00	2000-11-13	2000-11-13 00:00:00	\N	38000177		0	0	0		0	0	0	227221	0	00025152531	44923712		
51491	4279	19133905	2007-03-03	2007-03-03 00:00:00	2007-03-16	2007-03-16 00:00:00	2007-03-16	38000177		0	0	13		0	0	0	284006	0	834102	19133905		
25972	2136	1127433	1988-01-26	1988-01-26 00:00:00	1988-02-02	1988-02-02 00:00:00	1988-02-02	38000177		0	0	7		0	0	0	142213	0	313782	1127433		
4896	408	19133873	1964-08-22	1964-08-22 00:00:00	1964-09-02	1964-09-02 00:00:00	1964-09-02	38000177		0	0	11		0	0	0	26985	0	834061	19133873		
25059	2062	19006318	1948-04-08	1948-04-08 00:00:00	1948-04-22	1948-04-22 00:00:00	1948-04-22	38000177		0	0	14		0	0	0	137151	0	105078	19006318		
35480	2925	19078461	2001-05-04	2001-05-04 00:00:00	2001-05-18	2001-05-18 00:00:00	2001-05-18	38000177		0	0	14		0	0	0	195132	0	310965	19078461		
39354	3249	1127433	1972-03-16	1972-03-16 00:00:00	1972-03-30	1972-03-30 00:00:00	1972-03-30	38000177		0	0	14		0	0	0	215952	0	313782	1127433		
227918	5004	40213306	1999-05-11	1999-05-11 00:00:00	1999-05-11	1999-05-11 00:00:00	1999-05-11	581452		0	0	0		0	0	0	332808	0	43	40213306		
3720	81	40213160	1956-08-29	1956-08-29 00:00:00	1956-08-29	1956-08-29 00:00:00	1956-08-29	581452		0	0	0		0	0	0	5521	0	10	40213160		
81443	1780	40213260	2016-06-21	2016-06-21 00:00:00	2016-06-21	2016-06-21 00:00:00	2016-06-21	581452		0	0	0		0	0	0	119140	0	121	40213260		
35228	2905	1127433	2019-06-17	2019-06-17 00:00:00	2019-07-01	2019-07-01 00:00:00	2019-07-01	38000177		0	0	14		0	0	0	193603	0	313782	1127433		
138774	3049	40213306	1997-09-12	1997-09-12 00:00:00	1997-09-12	1997-09-12 00:00:00	1997-09-12	581452		0	0	0		0	0	0	202871	0	43	40213306		
22403	1843	1150771	1982-09-26	1982-09-26 00:00:00	1982-09-26	1982-09-26 00:00:00	\N	38000177		0	0	0		0	0	0	123101	0	197378	1150771		
220707	4844	40213296	2001-07-12	2001-07-12 00:00:00	2001-07-12	2001-07-12 00:00:00	2001-07-12	581452		0	0	0		0	0	0	322314	0	52	40213296		
7999	669	920300	1995-11-07	1995-11-07 00:00:00	1995-11-14	1995-11-14 00:00:00	1995-11-14	38000177		0	0	7		0	0	0	44168	0	311989	920300		
41466	3437	1713671	1970-10-26	1970-10-26 00:00:00	1970-11-09	1970-11-09 00:00:00	1970-11-09	38000177		0	0	14		0	0	0	228031	0	562251	1713671		
37362	3087	40229134	1984-07-18	1984-07-18 00:00:00	1984-07-25	1984-07-25 00:00:00	1984-07-25	38000177		0	0	7		0	0	0	205563	0	1043400	40229134		
55045	4571	1124300	1995-04-02	1995-04-02 00:00:00	1995-04-02	1995-04-02 00:00:00	\N	38000177		0	0	0		0	0	0	304546	0	00781178901	45011828		
7468	161	40213314	1979-02-04	1979-02-04 00:00:00	1979-02-04	1979-02-04 00:00:00	1979-02-04	581452		0	0	0		0	0	0	11074	0	49	40213314		
29903	652	40213160	1968-07-23	1968-07-23 00:00:00	1968-07-23	1968-07-23 00:00:00	1968-07-23	581452		0	0	0		0	0	0	43150	0	10	40213160		
44565	970	40213198	2017-11-12	2017-11-12 00:00:00	2017-11-12	2017-11-12 00:00:00	2017-11-12	581452		0	0	0		0	0	0	64511	0	133	40213198		
48017	3982	40222846	2012-11-05	2012-11-05 00:00:00	2012-11-05	2012-11-05 00:00:00	\N	38000177		0	0	0		0	0	0	264753	0	996740	40222846		
192291	4224	40213227	2007-03-14	2007-03-14 00:00:00	2007-03-14	2007-03-14 00:00:00	2007-03-14	581452		0	0	0		0	0	0	280527	0	113	40213227		
25832	2123	1118084	1986-11-29	1986-11-29 00:00:00	1986-11-29	1986-11-29 00:00:00	\N	38000177		0	0	0		0	0	0	141288	0	00025152531	44923712		
20307	442	40213227	1992-08-15	1992-08-15 00:00:00	1992-08-15	1992-08-15 00:00:00	1992-08-15	581452		0	0	0		0	0	0	29316	0	113	40213227		
14805	1238	40165015	1982-08-25	1982-08-25 00:00:00	1982-08-25	1982-08-25 00:00:00	\N	38000177		0	0	0		0	0	0	81606	0	861467	40165015		
33519	2774	1127433	1971-07-11	1971-07-11 00:00:00	1971-07-25	1971-07-25 00:00:00	1971-07-25	38000177		0	0	14		0	0	0	183703	0	313782	1127433		
11354	946	40229134	1985-08-09	1985-08-09 00:00:00	1985-08-23	1985-08-23 00:00:00	1985-08-23	38000177		0	0	14		0	0	0	62812	0	1043400	40229134		
28183	2330	40229134	2015-10-21	2015-10-21 00:00:00	2015-10-28	2015-10-28 00:00:00	2015-10-28	38000177		0	0	7		0	0	0	154988	0	1043400	40229134		
2257	182	40229134	2007-10-17	2007-10-17 00:00:00	2007-10-31	2007-10-31 00:00:00	2007-10-31	38000177		0	0	14		0	0	0	12298	0	1043400	40229134		
8616	719	40236824	2003-12-25	2003-12-25 00:00:00	2004-01-01	2004-01-01 00:00:00	2004-01-01	38000177		0	0	7		0	0	0	47604	0	1094107	40236824		
22477	1847	1127433	1990-10-28	1990-10-28 00:00:00	1990-11-04	1990-11-04 00:00:00	1990-11-04	38000177		0	0	7		0	0	0	123566	0	313782	1127433		
47656	3951	1115171	2011-05-31	2011-05-31 00:00:00	2011-07-30	2011-07-30 00:00:00	2011-07-30	38000177		0	0	60		0	0	0	262602	0	849574	1115171		
54768	4548	1127433	1989-06-27	1989-06-27 00:00:00	1989-07-04	1989-07-04 00:00:00	1989-07-04	38000177		0	0	7		0	0	0	303106	0	313782	1127433		
64428	1409	40213227	1998-10-19	1998-10-19 00:00:00	1998-10-19	1998-10-19 00:00:00	1998-10-19	581452		0	0	0		0	0	0	93700	0	113	40213227		
13382	1122	1127433	1972-01-08	1972-01-08 00:00:00	1972-01-22	1972-01-22 00:00:00	1972-01-22	38000177		0	0	14		0	0	0	73886	0	313782	1127433		
228059	5007	40213251	1988-03-06	1988-03-06 00:00:00	1988-03-06	1988-03-06 00:00:00	1988-03-06	581452		0	0	0		0	0	0	333006	0	21	40213251		
58361	4848	19059056	1966-10-01	1966-10-01 00:00:00	1966-12-30	1966-12-30 00:00:00	1966-12-30	38000177		0	0	90		0	0	0	322560	0	243670	19059056		
60004	4987	19059056	1970-01-27	1970-01-27 00:00:00	1970-02-17	1970-02-17 00:00:00	1970-02-17	38000177		0	0	21		0	0	0	331786	0	243670	19059056		
947	78	19059056	1967-07-04	1967-07-04 00:00:00	1967-07-18	1967-07-18 00:00:00	1967-07-18	38000177		0	0	14		0	0	0	5156	0	243670	19059056		
23791	1956	19133905	1994-01-27	1994-01-27 00:00:00	1994-02-07	1994-02-07 00:00:00	1994-02-07	38000177		0	0	11		0	0	0	130204	0	834102	19133905		
11517	959	19133905	1979-01-16	1979-01-16 00:00:00	1979-01-27	1979-01-27 00:00:00	1979-01-27	38000177		0	0	11		0	0	0	63698	0	834102	19133905		
170067	3739	40213160	1968-04-22	1968-04-22 00:00:00	1968-04-22	1968-04-22 00:00:00	1968-04-22	581452		0	0	0		0	0	0	248448	0	10	40213160		
34649	2861	1127433	1989-04-24	1989-04-24 00:00:00	1989-05-08	1989-05-08 00:00:00	1989-05-08	38000177		0	0	14		0	0	0	190185	0	313782	1127433		
34687	2864	19006318	1945-02-24	1945-02-24 00:00:00	1945-03-10	1945-03-10 00:00:00	1945-03-10	38000177		0	0	14		0	0	0	190533	0	105078	19006318		
37657	3114	19133873	1958-04-03	1958-04-03 00:00:00	1958-04-15	1958-04-15 00:00:00	1958-04-15	38000177		0	0	12		0	0	0	207143	0	834061	19133873		
24403	2006	19059056	1955-09-28	1955-09-28 00:00:00	1955-10-12	1955-10-12 00:00:00	1955-10-12	38000177		0	0	14		0	0	0	133601	0	243670	19059056		
10120	847	1127433	1985-03-20	1985-03-20 00:00:00	1985-04-10	1985-04-10 00:00:00	1985-04-10	38000177		0	0	21		0	0	0	56139	0	313782	1127433		
41573	3442	1118084	2001-03-24	2001-03-24 00:00:00	2001-03-24	2001-03-24 00:00:00	\N	38000177		0	0	0		0	0	0	228424	0	00025152531	44923712		
41601	3444	1713671	1953-12-26	1953-12-26 00:00:00	1954-01-02	1954-01-02 00:00:00	1954-01-02	38000177		0	0	7		0	0	0	228535	0	562251	1713671		
41653	3446	1127433	1958-07-29	1958-07-29 00:00:00	1958-08-05	1958-08-05 00:00:00	1958-08-05	38000177		0	0	7		0	0	0	228835	0	313782	1127433		
10684	887	1115171	2000-08-03	2000-08-03 00:00:00	2000-09-07	2000-09-07 00:00:00	2000-09-07	38000177		0	0	35		0	0	0	59105	0	849574	1115171		
31253	2591	1127433	1987-12-17	1987-12-17 00:00:00	1987-12-24	1987-12-24 00:00:00	1987-12-24	38000177		0	0	7		0	0	0	171497	0	313782	1127433		
9449	784	1127433	1967-11-18	1967-11-18 00:00:00	1967-11-25	1967-11-25 00:00:00	1967-11-25	38000177		0	0	7		0	0	0	52217	0	313782	1127433		
59714	4964	19133905	2000-05-31	2000-05-31 00:00:00	2000-06-12	2000-06-12 00:00:00	2000-06-12	38000177		0	0	12		0	0	0	329986	0	834102	19133905		
11243	935	1118084	1972-06-24	1972-06-24 00:00:00	1972-06-24	1972-06-24 00:00:00	\N	38000177		0	0	0		0	0	0	62234	0	00025152531	44923712		
65870	1441	40213227	2008-11-03	2008-11-03 00:00:00	2008-11-03	2008-11-03 00:00:00	2008-11-03	581452		0	0	0		0	0	0	96003	0	113	40213227		
39167	3236	1127433	1940-04-17	1940-04-17 00:00:00	1940-05-01	1940-05-01 00:00:00	1940-05-01	38000177		0	0	14		0	0	0	215125	0	313782	1127433		
4684	390	19133873	1988-06-10	1988-06-10 00:00:00	1988-06-23	1988-06-23 00:00:00	1988-06-23	38000177		0	0	13		0	0	0	25605	0	834061	19133873		
32383	2684	46275916	1967-05-21	1967-05-21 00:00:00	1967-05-21	1967-05-21 00:00:00	1967-05-21	38000177		0	0	0		0	0	0	177845	0	1660014	46275916		
42728	3541	1127433	2014-08-18	2014-08-18 00:00:00	2014-09-01	2014-09-01 00:00:00	2014-09-01	38000177		0	0	14		0	0	0	235174	0	313782	1127433		
1848	148	1127433	2008-09-09	2008-09-09 00:00:00	2008-09-23	2008-09-23 00:00:00	2008-09-23	38000177		0	0	14		0	0	0	10019	0	313782	1127433		
32747	715	40213251	1988-01-26	1988-01-26 00:00:00	1988-01-26	1988-01-26 00:00:00	1988-01-26	581452		0	0	0		0	0	0	47341	0	21	40213251		
42628	3533	1127433	2000-05-25	2000-05-25 00:00:00	2000-06-08	2000-06-08 00:00:00	2000-06-08	38000177		0	0	14		0	0	0	234709	0	313782	1127433		
41315	3427	1115171	2018-08-06	2018-08-06 00:00:00	2018-08-20	2018-08-20 00:00:00	2018-08-20	38000177		0	0	14		0	0	0	227230	0	849574	1115171		
51492	4279	19078461	2018-03-16	2018-03-16 00:00:00	2018-05-15	2018-05-15 00:00:00	2018-05-15	38000177		0	0	60		0	0	0	284093	0	310965	19078461		
25973	2136	1127078	1971-07-16	1971-07-16 00:00:00	1971-07-30	1971-07-30 00:00:00	1971-07-30	38000177		0	0	14		0	0	0	142295	0	282464	1127078		
4897	408	920300	1985-07-05	1985-07-05 00:00:00	1985-07-12	1985-07-12 00:00:00	1985-07-12	38000177		0	0	7		0	0	0	26964	0	311989	920300		
25060	2062	19059056	1964-04-10	1964-04-10 00:00:00	1964-04-24	1964-04-24 00:00:00	1964-04-24	38000177		0	0	14		0	0	0	137196	0	243670	19059056		
35481	2925	1118084	1998-12-21	1998-12-21 00:00:00	1998-12-21	1998-12-21 00:00:00	\N	38000177		0	0	0		0	0	0	195067	0	00025152531	44923712		
39355	3250	1127433	1964-05-03	1964-05-03 00:00:00	1964-05-10	1964-05-10 00:00:00	1964-05-10	38000177		0	0	7		0	0	0	216038	0	313782	1127433		
227920	5004	40213296	2017-03-14	2017-03-14 00:00:00	2017-03-14	2017-03-14 00:00:00	2017-03-14	581452		0	0	0		0	0	0	332814	0	52	40213296		
3723	81	40213160	1956-06-27	1956-06-27 00:00:00	1956-06-27	1956-06-27 00:00:00	1956-06-27	581452		0	0	0		0	0	0	5466	0	10	40213160		
92726	2034	40213227	2014-07-09	2014-07-09 00:00:00	2014-07-09	2014-07-09 00:00:00	2014-07-09	581452		0	0	0		0	0	0	135500	0	113	40213227		
35229	2905	46233988	1971-08-04	1971-08-04 00:00:00	1971-08-18	1971-08-18 00:00:00	1971-08-18	38000177		0	0	14		0	0	0	193544	0	1652673	46233988		
138778	3049	40213160	1981-04-03	1981-04-03 00:00:00	1981-04-03	1981-04-03 00:00:00	1981-04-03	581452		0	0	0		0	0	0	202884	0	10	40213160		
22404	1843	1713671	2013-04-23	2013-04-23 00:00:00	2013-05-14	2013-05-14 00:00:00	2013-05-14	38000177		0	0	21		0	0	0	122994	0	562251	1713671		
50112	4159	40236824	2015-02-28	2015-02-28 00:00:00	2015-03-07	2015-03-07 00:00:00	2015-03-07	38000177		0	0	7		0	0	0	276333	0	1094107	40236824		
8000	669	40236824	1995-11-07	1995-11-07 00:00:00	1995-11-14	1995-11-14 00:00:00	1995-11-14	38000177		0	0	7		0	0	0	44168	0	1094107	40236824		
41467	3437	1713671	1982-05-15	1982-05-15 00:00:00	1982-06-05	1982-06-05 00:00:00	1982-06-05	38000177		0	0	21		0	0	0	227943	0	562251	1713671		
37363	3087	19133905	2013-03-21	2013-03-21 00:00:00	2013-04-03	2013-04-03 00:00:00	2013-04-03	38000177		0	0	13		0	0	0	205520	0	834102	19133905		
55046	4571	1127433	2001-03-17	2001-03-17 00:00:00	2001-05-23	2001-05-23 00:00:00	2001-05-23	38000177		0	0	67		0	0	0	304555	0	313782	1127433		
7474	161	40213227	2000-01-30	2000-01-30 00:00:00	2000-01-30	2000-01-30 00:00:00	2000-01-30	581452		0	0	0		0	0	0	11080	0	113	40213227		
208273	4569	40213160	1967-01-03	1967-01-03 00:00:00	1967-01-03	1967-01-03 00:00:00	1967-01-03	581452		0	0	0		0	0	0	304407	0	10	40213160		
84764	1854	40213296	2010-11-09	2010-11-09 00:00:00	2010-11-09	2010-11-09 00:00:00	2010-11-09	581452		0	0	0		0	0	0	124118	0	52	40213296		
48018	3982	19077572	2011-11-11	2011-11-11 00:00:00	2011-11-11	2011-11-11 00:00:00	\N	38000177		0	0	0		0	0	0	264704	0	310436	19077572		
192301	4225	40213160	1979-07-12	1979-07-12 00:00:00	1979-07-12	1979-07-12 00:00:00	1979-07-12	581452		0	0	0		0	0	0	280624	0	10	40213160		
25849	2127	1127433	2004-09-11	2004-09-11 00:00:00	2004-09-25	2004-09-25 00:00:00	2004-09-25	38000177		0	0	14		0	0	0	141461	0	313782	1127433		
20314	442	40213227	1998-09-05	1998-09-05 00:00:00	1998-09-05	1998-09-05 00:00:00	1998-09-05	581452		0	0	0		0	0	0	29388	0	113	40213227		
14806	1238	19059056	1957-10-28	1957-10-28 00:00:00	1957-11-11	1957-11-11 00:00:00	1957-11-11	38000177		0	0	14		0	0	0	81586	0	243670	19059056		
33520	2774	19133905	1978-08-28	1978-08-28 00:00:00	1978-09-08	1978-09-08 00:00:00	1978-09-08	38000177		0	0	11		0	0	0	183726	0	834102	19133905		
11356	946	1127433	1969-03-22	1969-03-22 00:00:00	1969-04-05	1969-04-05 00:00:00	1969-04-05	38000177		0	0	14		0	0	0	62773	0	313782	1127433		
28184	2330	19019979	1980-03-26	1980-03-26 00:00:00	1980-04-09	1980-04-09 00:00:00	1980-04-09	38000177		0	0	14		0	0	0	155004	0	198405	19019979		
2258	183	1127433	1976-02-18	1976-02-18 00:00:00	1976-02-25	1976-02-25 00:00:00	1976-02-25	38000177		0	0	7		0	0	0	12349	0	313782	1127433		
8617	719	1713671	1992-08-21	1992-08-21 00:00:00	1992-09-11	1992-09-11 00:00:00	1992-09-11	38000177		0	0	21		0	0	0	47603	0	562251	1713671		
22478	1847	1127433	1919-12-13	1919-12-13 00:00:00	1919-12-20	1919-12-20 00:00:00	1919-12-20	38000177		0	0	7		0	0	0	123549	0	313782	1127433		
47657	3951	40165015	2011-05-31	2011-05-31 00:00:00	2011-05-31	2011-05-31 00:00:00	\N	38000177		0	0	0		0	0	0	262602	0	861467	40165015		
54769	4548	1127078	1984-10-12	1984-10-12 00:00:00	1984-11-16	1984-11-16 00:00:00	1984-11-16	38000177		0	0	35		0	0	0	303029	0	282464	1127078		
148888	3275	40213306	1982-05-29	1982-05-29 00:00:00	1982-05-29	1982-05-29 00:00:00	1982-05-29	581452		0	0	0		0	0	0	217614	0	43	40213306		
13383	1122	40169216	1973-11-23	1973-11-23 00:00:00	1973-11-23	1973-11-23 00:00:00	\N	38000177		0	0	0		0	0	0	73931	0	895994	40169216		
228061	5007	40213160	1988-03-06	1988-03-06 00:00:00	1988-03-06	1988-03-06 00:00:00	1988-03-06	581452		0	0	0		0	0	0	333006	0	10	40213160		
58362	4848	1127433	1975-04-27	1975-04-27 00:00:00	1975-05-11	1975-05-11 00:00:00	1975-05-11	38000177		0	0	14		0	0	0	322508	0	313782	1127433		
60006	4987	40229134	2004-06-29	2004-06-29 00:00:00	2004-07-13	2004-07-13 00:00:00	2004-07-13	38000177		0	0	14		0	0	0	331775	0	1043400	40229134		
948	78	1127078	1968-11-25	1968-11-25 00:00:00	1968-12-16	1968-12-16 00:00:00	1968-12-16	38000177		0	0	21		0	0	0	5162	0	282464	1127078		
23792	1956	1127433	1967-03-07	1967-03-07 00:00:00	1967-03-21	1967-03-21 00:00:00	1967-03-21	38000177		0	0	14		0	0	0	130175	0	313782	1127433		
11518	959	1124300	1995-01-31	1995-01-31 00:00:00	1995-01-31	1995-01-31 00:00:00	\N	38000177		0	0	0		0	0	0	63775	0	00781178901	45011828		
170070	3739	40213296	2011-02-14	2011-02-14 00:00:00	2011-02-14	2011-02-14 00:00:00	2011-02-14	581452		0	0	0		0	0	0	248419	0	52	40213296		
34650	2862	1118084	2006-04-03	2006-04-03 00:00:00	2006-04-03	2006-04-03 00:00:00	\N	38000177		0	0	0		0	0	0	190309	0	00025152531	44923712		
34688	2864	1713671	1956-06-17	1956-06-17 00:00:00	1956-06-24	1956-06-24 00:00:00	1956-06-24	38000177		0	0	7		0	0	0	190465	0	562251	1713671		
37658	3114	1127433	1980-07-21	1980-07-21 00:00:00	1980-08-11	1980-08-11 00:00:00	1980-08-11	38000177		0	0	21		0	0	0	207116	0	313782	1127433		
24404	2006	920300	1993-02-12	1993-02-12 00:00:00	1993-02-19	1993-02-19 00:00:00	1993-02-19	38000177		0	0	7		0	0	0	133642	0	311989	920300		
10121	847	19128065	1980-04-04	1980-04-04 00:00:00	1981-03-30	1981-03-30 00:00:00	1981-03-30	38000177		0	0	360		0	0	0	56100	0	749882	19128065		
41574	3442	1127433	1965-03-19	1965-03-19 00:00:00	1965-03-26	1965-03-26 00:00:00	1965-03-26	38000177		0	0	7		0	0	0	228397	0	313782	1127433		
41602	3444	19059056	1940-05-23	1940-05-23 00:00:00	1940-06-06	1940-06-06 00:00:00	1940-06-06	38000177		0	0	14		0	0	0	228580	0	243670	19059056		
41654	3446	1127433	2007-02-25	2007-02-25 00:00:00	2007-03-11	2007-03-11 00:00:00	2007-03-11	38000177		0	0	14		0	0	0	228789	0	313782	1127433		
10685	887	19133873	1971-10-27	1971-10-27 00:00:00	1971-11-05	1971-11-05 00:00:00	1971-11-05	38000177		0	0	9		0	0	0	59154	0	834061	19133873		
31254	2591	19059056	1947-09-12	1947-09-12 00:00:00	1947-12-11	1947-12-11 00:00:00	1947-12-11	38000177		0	0	90		0	0	0	171447	0	243670	19059056		
9450	784	1127433	1970-12-22	1970-12-22 00:00:00	1970-12-29	1970-12-29 00:00:00	1970-12-29	38000177		0	0	7		0	0	0	52243	0	313782	1127433		
59737	4967	19129655	1963-11-23	1963-11-23 00:00:00	1963-12-07	1963-12-07 00:00:00	1963-12-07	38000177		0	0	14		0	0	0	330136	0	789980	19129655		
11244	936	1127433	2013-11-15	2013-11-15 00:00:00	2013-11-22	2013-11-22 00:00:00	2013-11-22	38000177		0	0	7		0	0	0	62251	0	313782	1127433		
65871	1441	40213296	2008-11-03	2008-11-03 00:00:00	2008-11-03	2008-11-03 00:00:00	2008-11-03	581452		0	0	0		0	0	0	96003	0	52	40213296		
39168	3236	1127433	1933-05-15	1933-05-15 00:00:00	1933-05-22	1933-05-22 00:00:00	1933-05-22	38000177		0	0	7		0	0	0	215088	0	313782	1127433		
4685	390	1127433	2015-05-20	2015-05-20 00:00:00	2015-05-27	2015-05-27 00:00:00	2015-05-27	38000177		0	0	7		0	0	0	25631	0	313782	1127433		
32384	2684	1310034	1967-05-21	1967-05-21 00:00:00	1967-05-21	1967-05-21 00:00:00	1967-05-21	38000177		0	0	0		0	0	0	177845	0	834357	1310034		
42729	3541	19059056	1987-04-08	1987-04-08 00:00:00	1987-04-22	1987-04-22 00:00:00	1987-04-22	38000177		0	0	14		0	0	0	235215	0	243670	19059056		
1849	148	1118084	2012-12-25	2012-12-25 00:00:00	2012-12-25	2012-12-25 00:00:00	\N	38000177		0	0	0		0	0	0	10026	0	00025152531	44923712		
52599	4374	1713671	2015-03-24	2015-03-24 00:00:00	2015-04-07	2015-04-07 00:00:00	2015-04-07	38000177		0	0	14		0	0	0	290511	0	562251	1713671		
42629	3533	1124300	2001-01-03	2001-01-03 00:00:00	2001-01-03	2001-01-03 00:00:00	\N	38000177		0	0	0		0	0	0	234709	0	00781178901	45011828		
41316	3427	19073188	2018-08-06	2018-08-06 00:00:00	2018-08-20	2018-08-20 00:00:00	2018-08-20	38000177		0	0	14		0	0	0	227230	0	308192	19073188		
51493	4279	19078461	2011-07-21	2011-07-21 00:00:00	2011-09-19	2011-09-19 00:00:00	2011-09-19	38000177		0	0	60		0	0	0	284092	0	310965	19078461		
25974	2136	46233988	1971-07-16	1971-07-16 00:00:00	1971-07-30	1971-07-30 00:00:00	1971-07-30	38000177		0	0	14		0	0	0	142295	0	1652673	46233988		
4898	408	40236824	1985-07-05	1985-07-05 00:00:00	1985-07-12	1985-07-12 00:00:00	1985-07-12	38000177		0	0	7		0	0	0	26964	0	1094107	40236824		
25061	2062	1127433	1951-12-03	1951-12-03 00:00:00	1951-12-10	1951-12-10 00:00:00	1951-12-10	38000177		0	0	7		0	0	0	137109	0	313782	1127433		
35482	2925	19128065	1976-12-21	1976-12-21 00:00:00	1977-12-16	1977-12-16 00:00:00	1977-12-16	38000177		0	0	360		0	0	0	195039	0	749882	19128065		
39356	3250	19133873	1970-01-03	1970-01-03 00:00:00	1970-01-14	1970-01-14 00:00:00	1970-01-14	38000177		0	0	11		0	0	0	216050	0	834061	19133873		
227930	5004	40213160	1982-02-16	1982-02-16 00:00:00	1982-02-16	1982-02-16 00:00:00	1982-02-16	581452		0	0	0		0	0	0	332802	0	10	40213160		
3725	81	40213227	2017-06-07	2017-06-07 00:00:00	2017-06-07	2017-06-07 00:00:00	2017-06-07	581452		0	0	0		0	0	0	5517	0	113	40213227		
92733	2034	40213227	1994-09-07	1994-09-07 00:00:00	1994-09-07	1994-09-07 00:00:00	1994-09-07	581452		0	0	0		0	0	0	135396	0	113	40213227		
35230	2905	1127078	1971-08-04	1971-08-04 00:00:00	1971-08-18	1971-08-18 00:00:00	1971-08-18	38000177		0	0	14		0	0	0	193544	0	282464	1127078		
138781	3049	40213251	1984-04-20	1984-04-20 00:00:00	1984-04-20	1984-04-20 00:00:00	1984-04-20	581452		0	0	0		0	0	0	202866	0	21	40213251		
22405	1843	19128009	2007-06-14	2007-06-14 00:00:00	2008-06-08	2008-06-08 00:00:00	2008-06-08	38000177		0	0	360		0	0	0	123071	0	749762	19128009		
50113	4159	920300	2015-02-28	2015-02-28 00:00:00	2015-03-07	2015-03-07 00:00:00	2015-03-07	38000177		0	0	7		0	0	0	276333	0	311989	920300		
8001	669	19133905	2008-04-22	2008-04-22 00:00:00	2008-04-30	2008-04-30 00:00:00	2008-04-30	38000177		0	0	8		0	0	0	44180	0	834102	19133905		
41468	3437	19133873	1916-05-09	1916-05-09 00:00:00	1916-05-16	1916-05-16 00:00:00	1916-05-16	38000177		0	0	7		0	0	0	227980	0	834061	19133873		
37364	3087	40229134	2002-03-12	2002-03-12 00:00:00	2002-03-26	2002-03-26 00:00:00	2002-03-26	38000177		0	0	14		0	0	0	205494	0	1043400	40229134		
55047	4571	19059056	1956-01-17	1956-01-17 00:00:00	1956-01-31	1956-01-31 00:00:00	1956-01-31	38000177		0	0	14		0	0	0	304525	0	243670	19059056		
7475	161	40213306	2000-01-30	2000-01-30 00:00:00	2000-01-30	2000-01-30 00:00:00	2000-01-30	581452		0	0	0		0	0	0	11080	0	43	40213306		
195202	4288	40213227	2012-02-25	2012-02-25 00:00:00	2012-02-25	2012-02-25 00:00:00	2012-02-25	581452		0	0	0		0	0	0	284724	0	113	40213227		
84768	1854	40213227	1992-08-25	1992-08-25 00:00:00	1992-08-25	1992-08-25 00:00:00	1992-08-25	581452		0	0	0		0	0	0	\N	0	113	40213227		
48019	3982	40220960	2018-04-27	2018-04-27 00:00:00	2018-04-27	2018-04-27 00:00:00	2018-04-27	38000177		0	0	0		0	0	0	264663	0	1804799	40220960		
32255	703	40213201	2016-01-15	2016-01-15 00:00:00	2016-01-15	2016-01-15 00:00:00	2016-01-15	581452		0	0	0		0	0	0	46490	0	33	40213201		
25850	2127	1115171	1995-06-23	1995-06-23 00:00:00	1995-07-07	1995-07-07 00:00:00	1995-07-07	38000177		0	0	14		0	0	0	141449	0	849574	1115171		
20327	442	40213160	1955-08-20	1955-08-20 00:00:00	1955-08-20	1955-08-20 00:00:00	1955-08-20	581452		0	0	0		0	0	0	29398	0	10	40213160		
14807	1238	1127433	1982-08-18	1982-08-18 00:00:00	1982-09-24	1982-09-24 00:00:00	1982-09-24	38000177		0	0	37		0	0	0	81582	0	313782	1127433		
33521	2774	19059056	1941-04-29	1941-04-29 00:00:00	1941-05-13	1941-05-13 00:00:00	1941-05-13	38000177		0	0	14		0	0	0	183682	0	243670	19059056		
11357	946	1127433	1970-08-18	1970-08-18 00:00:00	1970-08-25	1970-08-25 00:00:00	1970-08-25	38000177		0	0	7		0	0	0	62774	0	313782	1127433		
28185	2330	1118084	2008-06-27	2008-06-27 00:00:00	2008-06-27	2008-06-27 00:00:00	\N	38000177		0	0	0		0	0	0	154973	0	00025152531	44923712		
2259	183	1118084	2017-03-02	2017-03-02 00:00:00	2017-03-02	2017-03-02 00:00:00	\N	38000177		0	0	0		0	0	0	12389	0	00025152531	44923712		
8618	719	1127078	1983-08-31	1983-08-31 00:00:00	1983-09-28	1983-09-28 00:00:00	1983-09-28	38000177		0	0	28		0	0	0	47563	0	282464	1127078		
22479	1848	1127433	2010-01-24	2010-01-24 00:00:00	2010-02-07	2010-02-07 00:00:00	2010-02-07	38000177		0	0	14		0	0	0	123602	0	313782	1127433		
47658	3951	1127433	2014-03-09	2014-03-09 00:00:00	2014-03-16	2014-03-16 00:00:00	2014-03-16	38000177		0	0	7		0	0	0	262644	0	313782	1127433		
54779	4550	1127078	1963-06-06	1963-06-06 00:00:00	1963-06-20	1963-06-20 00:00:00	1963-06-20	38000177		0	0	14		0	0	0	303207	0	282464	1127078		
148893	3275	40213260	2011-04-16	2011-04-16 00:00:00	2011-04-16	2011-04-16 00:00:00	2011-04-16	581452		0	0	0		0	0	0	217592	0	121	40213260		
13384	1122	1154615	1973-11-23	1973-11-23 00:00:00	1973-11-23	1973-11-23 00:00:00	\N	38000177		0	0	0		0	0	0	73931	0	745679	1154615		
228062	5007	40213314	1984-06-03	1984-06-03 00:00:00	1984-06-03	1984-06-03 00:00:00	1984-06-03	581452		0	0	0		0	0	0	333003	0	49	40213314		
85280	1867	40213296	2012-05-29	2012-05-29 00:00:00	2012-05-29	2012-05-29 00:00:00	2012-05-29	581452		0	0	0		0	0	0	124710	0	52	40213296		
60007	4988	1127078	1960-09-11	1960-09-11 00:00:00	1960-09-25	1960-09-25 00:00:00	1960-09-25	38000177		0	0	14		0	0	0	331793	0	282464	1127078		
949	78	1127078	1968-03-13	1968-03-13 00:00:00	1968-03-27	1968-03-27 00:00:00	1968-03-27	38000177		0	0	14		0	0	0	5183	0	282464	1127078		
23793	1956	1127433	2016-01-07	2016-01-07 00:00:00	2016-01-14	2016-01-14 00:00:00	2016-01-14	38000177		0	0	7		0	0	0	130127	0	313782	1127433		
11519	959	1127433	1992-04-17	1992-04-17 00:00:00	1992-04-24	1992-04-24 00:00:00	1992-04-24	38000177		0	0	7		0	0	0	63794	0	313782	1127433		
170074	3739	40213227	2019-03-11	2019-03-11 00:00:00	2019-03-11	2019-03-11 00:00:00	2019-03-11	581452		0	0	0		0	0	0	248437	0	113	40213227		
34651	2862	1115171	2000-12-25	2000-12-25 00:00:00	2001-01-22	2001-01-22 00:00:00	2001-01-22	38000177		0	0	28		0	0	0	190262	0	849574	1115171		
34689	2864	1127433	2012-03-19	2012-03-19 00:00:00	2012-04-02	2012-04-02 00:00:00	2012-04-02	38000177		0	0	14		0	0	0	190515	0	313782	1127433		
37659	3114	1118084	1983-02-21	1983-02-21 00:00:00	1983-02-21	1983-02-21 00:00:00	\N	38000177		0	0	0		0	0	0	207149	0	00025152531	44923712		
24405	2006	40236824	1993-02-12	1993-02-12 00:00:00	1993-02-19	1993-02-19 00:00:00	1993-02-19	38000177		0	0	7		0	0	0	133642	0	1094107	40236824		
10122	847	1127078	1973-08-29	1973-08-29 00:00:00	1973-09-19	1973-09-19 00:00:00	1973-09-19	38000177		0	0	21		0	0	0	56138	0	282464	1127078		
41575	3442	1713671	2017-06-10	2017-06-10 00:00:00	2017-07-01	2017-07-01 00:00:00	2017-07-01	38000177		0	0	21		0	0	0	228412	0	562251	1713671		
41603	3444	1713671	1963-09-01	1963-09-01 00:00:00	1963-09-15	1963-09-15 00:00:00	1963-09-15	38000177		0	0	14		0	0	0	228617	0	562251	1713671		
41655	3446	40229134	1959-12-01	1959-12-01 00:00:00	1959-12-08	1959-12-08 00:00:00	1959-12-08	38000177		0	0	7		0	0	0	228807	0	1043400	40229134		
10707	890	19133873	1963-09-08	1963-09-08 00:00:00	1963-09-19	1963-09-19 00:00:00	1963-09-19	38000177		0	0	11		0	0	0	59329	0	834061	19133873		
31255	2591	40165015	1947-09-12	1947-09-12 00:00:00	1947-09-12	1947-09-12 00:00:00	\N	38000177		0	0	0		0	0	0	171447	0	861467	40165015		
9451	784	1713671	2008-02-10	2008-02-10 00:00:00	2008-03-02	2008-03-02 00:00:00	2008-03-02	38000177		0	0	21		0	0	0	52203	0	562251	1713671		
59738	4967	1127078	1963-11-23	1963-11-23 00:00:00	1963-12-07	1963-12-07 00:00:00	1963-12-07	38000177		0	0	14		0	0	0	330136	0	282464	1127078		
11245	936	1713671	1992-12-07	1992-12-07 00:00:00	1992-12-21	1992-12-21 00:00:00	1992-12-21	38000177		0	0	14		0	0	0	62266	0	562251	1713671		
77151	1686	40213227	1994-05-08	1994-05-08 00:00:00	1994-05-08	1994-05-08 00:00:00	1994-05-08	581452		0	0	0		0	0	0	112959	0	113	40213227		
39169	3236	1127433	1948-05-26	1948-05-26 00:00:00	1948-06-09	1948-06-09 00:00:00	1948-06-09	38000177		0	0	14		0	0	0	215091	0	313782	1127433		
4686	390	19128022	1993-01-11	1993-01-11 00:00:00	1994-01-06	1994-01-06 00:00:00	1994-01-06	38000177		0	0	360		0	0	0	25656	0	749785	19128022		
21024	457	40213227	1993-08-24	1993-08-24 00:00:00	1993-08-24	1993-08-24 00:00:00	1993-08-24	581452		0	0	0		0	0	0	30585	0	113	40213227		
42730	3541	19078461	2000-06-26	2000-06-26 00:00:00	2000-07-31	2000-07-31 00:00:00	2000-07-31	38000177		0	0	35		0	0	0	235217	0	310965	19078461		
1850	148	19128022	1997-09-15	1997-09-15 00:00:00	1998-09-10	1998-09-10 00:00:00	1998-09-10	38000177		0	0	360		0	0	0	9991	0	749785	19128022		
52600	4374	1118084	2013-01-31	2013-01-31 00:00:00	2013-01-31	2013-01-31 00:00:00	\N	38000177		0	0	0		0	0	0	290510	0	00025152531	44923712		
42630	3533	1127078	1972-06-04	1972-06-04 00:00:00	1972-06-18	1972-06-18 00:00:00	1972-06-18	38000177		0	0	14		0	0	0	234661	0	282464	1127078		
41317	3427	40165015	2018-08-06	2018-08-06 00:00:00	2018-08-06	2018-08-06 00:00:00	\N	38000177		0	0	0		0	0	0	227230	0	861467	40165015		
51494	4279	1127433	1976-03-08	1976-03-08 00:00:00	1976-03-22	1976-03-22 00:00:00	1976-03-22	38000177		0	0	14		0	0	0	283949	0	313782	1127433		
25975	2136	1124300	2008-01-08	2008-01-08 00:00:00	2008-01-08	2008-01-08 00:00:00	\N	38000177		0	0	0		0	0	0	142287	0	00781178901	45011828		
4900	408	19133905	2010-06-29	2010-06-29 00:00:00	2010-07-11	2010-07-11 00:00:00	2010-07-11	38000177		0	0	12		0	0	0	26968	0	834102	19133905		
25062	2062	1713671	1950-12-29	1950-12-29 00:00:00	1951-01-05	1951-01-05 00:00:00	1951-01-05	38000177		0	0	7		0	0	0	137164	0	562251	1713671		
35483	2925	1127433	2007-06-17	2007-06-17 00:00:00	2007-07-22	2007-07-22 00:00:00	2007-07-22	38000177		0	0	35		0	0	0	195025	0	313782	1127433		
39357	3250	1115171	2017-04-24	2017-04-24 00:00:00	2017-05-22	2017-05-22 00:00:00	2017-05-22	38000177		0	0	28		0	0	0	216089	0	849574	1115171		
227933	5004	40213314	1977-08-16	1977-08-16 00:00:00	1977-08-16	1977-08-16 00:00:00	1977-08-16	581452		0	0	0		0	0	0	332864	0	49	40213314		
3727	81	40213160	1956-11-28	1956-11-28 00:00:00	1956-11-28	1956-11-28 00:00:00	1956-11-28	581452		0	0	0		0	0	0	5467	0	10	40213160		
1730	38	40213296	2005-02-15	2005-02-15 00:00:00	2005-02-15	2005-02-15 00:00:00	2005-02-15	581452		0	0	0		0	0	0	2704	0	52	40213296		
35231	2905	40229134	1987-10-07	1987-10-07 00:00:00	1987-10-14	1987-10-14 00:00:00	1987-10-14	38000177		0	0	7		0	0	0	193539	0	1043400	40229134		
138785	3049	40213227	2009-11-06	2009-11-06 00:00:00	2009-11-06	2009-11-06 00:00:00	2009-11-06	581452		0	0	0		0	0	0	202888	0	113	40213227		
22406	1843	19128022	2002-07-10	2002-07-10 00:00:00	2003-07-05	2003-07-05 00:00:00	2003-07-05	38000177		0	0	360		0	0	0	122996	0	749785	19128022		
50114	4159	1127433	1967-04-02	1967-04-02 00:00:00	1967-04-09	1967-04-09 00:00:00	1967-04-09	38000177		0	0	7		0	0	0	276366	0	313782	1127433		
8002	669	1127433	2002-10-16	2002-10-16 00:00:00	2002-10-23	2002-10-23 00:00:00	2002-10-23	38000177		0	0	7		0	0	0	44178	0	313782	1127433		
41469	3437	19059056	1920-03-16	1920-03-16 00:00:00	1920-04-13	1920-04-13 00:00:00	1920-04-13	38000177		0	0	28		0	0	0	228018	0	243670	19059056		
36839	3047	19133873	1976-11-06	1976-11-06 00:00:00	1976-11-16	1976-11-16 00:00:00	1976-11-16	38000177		0	0	10		0	0	0	202718	0	834061	19133873		
55048	4571	19006318	1956-01-17	1956-01-17 00:00:00	1956-01-31	1956-01-31 00:00:00	1956-01-31	38000177		0	0	14		0	0	0	304525	0	105078	19006318		
7479	161	40213306	2000-02-27	2000-02-27 00:00:00	2000-02-27	2000-02-27 00:00:00	2000-02-27	581452		0	0	0		0	0	0	11050	0	43	40213306		
195211	4288	40213198	2016-03-19	2016-03-19 00:00:00	2016-03-19	2016-03-19 00:00:00	2016-03-19	581452		0	0	0		0	0	0	284683	0	133	40213198		
84769	1854	40213306	1992-08-25	1992-08-25 00:00:00	1992-08-25	1992-08-25 00:00:00	1992-08-25	581452		0	0	0		0	0	0	\N	0	43	40213306		
48020	3982	19075601	2018-04-27	2018-04-27 00:00:00	2018-04-27	2018-04-27 00:00:00	2018-04-27	38000177		0	0	0		0	0	0	264663	0	309362	19075601		
32278	704	40213227	1997-09-03	1997-09-03 00:00:00	1997-09-03	1997-09-03 00:00:00	1997-09-03	581452		0	0	0		0	0	0	46543	0	113	40213227		
25851	2127	1127433	1966-10-03	1966-10-03 00:00:00	1966-10-10	1966-10-10 00:00:00	1966-10-10	38000177		0	0	7		0	0	0	141460	0	313782	1127433		
29369	2431	1713671	2001-10-04	2001-10-04 00:00:00	2001-10-25	2001-10-25 00:00:00	2001-10-25	38000177		0	0	21		0	0	0	161216	0	562251	1713671		
14808	1238	1127433	1985-07-10	1985-07-10 00:00:00	1985-08-14	1985-08-14 00:00:00	1985-08-14	38000177		0	0	35		0	0	0	81583	0	313782	1127433		
33532	2776	1127433	1991-07-21	1991-07-21 00:00:00	1991-08-04	1991-08-04 00:00:00	1991-08-04	38000177		0	0	14		0	0	0	183794	0	313782	1127433		
11358	947	1713671	2008-02-22	2008-02-22 00:00:00	2008-06-20	2008-06-20 00:00:00	2008-06-20	38000177		0	0	119		0	0	0	62887	0	562251	1713671		
28195	2332	1713671	1963-07-02	1963-07-02 00:00:00	1963-07-09	1963-07-09 00:00:00	1963-07-09	38000177		0	0	7		0	0	0	155047	0	562251	1713671		
2260	183	19059056	1979-02-25	1979-02-25 00:00:00	1979-03-11	1979-03-11 00:00:00	1979-03-11	38000177		0	0	14		0	0	0	12394	0	243670	19059056		
8619	719	1713671	2010-03-15	2010-03-15 00:00:00	2010-04-12	2010-04-12 00:00:00	2010-04-12	38000177		0	0	28		0	0	0	47560	0	562251	1713671		
22480	1848	40236824	1981-11-07	1981-11-07 00:00:00	1981-11-14	1981-11-14 00:00:00	1981-11-14	38000177		0	0	7		0	0	0	123685	0	1094107	40236824		
47659	3951	19059056	1946-03-13	1946-03-13 00:00:00	1946-03-27	1946-03-27 00:00:00	1946-03-27	38000177		0	0	14		0	0	0	262645	0	243670	19059056		
54780	4550	19129655	1963-06-06	1963-06-06 00:00:00	1963-06-20	1963-06-20 00:00:00	1963-06-20	38000177		0	0	14		0	0	0	303207	0	789980	19129655		
148895	3275	40213227	2011-04-16	2011-04-16 00:00:00	2011-04-16	2011-04-16 00:00:00	2011-04-16	581452		0	0	0		0	0	0	217592	0	113	40213227		
13385	1122	1127433	1991-09-07	1991-09-07 00:00:00	1991-09-28	1991-09-28 00:00:00	1991-09-28	38000177		0	0	21		0	0	0	73964	0	313782	1127433		
228063	5007	40213251	1984-06-03	1984-06-03 00:00:00	1984-06-03	1984-06-03 00:00:00	1984-06-03	581452		0	0	0		0	0	0	333003	0	21	40213251		
85283	1867	40213160	1972-10-31	1972-10-31 00:00:00	1972-10-31	1972-10-31 00:00:00	1972-10-31	581452		0	0	0		0	0	0	124711	0	10	40213160		
60008	4988	1713671	2002-08-27	2002-08-27 00:00:00	2002-09-03	2002-09-03 00:00:00	2002-09-03	38000177		0	0	7		0	0	0	331846	0	562251	1713671		
950	78	19133905	1985-05-13	1985-05-13 00:00:00	1985-05-23	1985-05-23 00:00:00	1985-05-23	38000177		0	0	10		0	0	0	5178	0	834102	19133905		
23797	1958	1115171	2003-09-12	2003-09-12 00:00:00	2003-10-17	2003-10-17 00:00:00	2003-10-17	38000177		0	0	35		0	0	0	130244	0	849574	1115171		
11520	959	19059056	1970-05-13	1970-05-13 00:00:00	1970-07-12	1970-07-12 00:00:00	1970-07-12	38000177		0	0	60		0	0	0	63783	0	243670	19059056		
170075	3739	40213260	2019-03-11	2019-03-11 00:00:00	2019-03-11	2019-03-11 00:00:00	2019-03-11	581452		0	0	0		0	0	0	248437	0	121	40213260		
34652	2862	1127433	2016-08-06	2016-08-06 00:00:00	2016-08-13	2016-08-13 00:00:00	2016-08-13	38000177		0	0	7		0	0	0	190284	0	313782	1127433		
34690	2864	1127433	1990-06-10	1990-06-10 00:00:00	1990-06-17	1990-06-17 00:00:00	1990-06-17	38000177		0	0	7		0	0	0	190511	0	313782	1127433		
37660	3114	19133873	1960-02-07	1960-02-07 00:00:00	1960-02-17	1960-02-17 00:00:00	1960-02-17	38000177		0	0	10		0	0	0	207144	0	834061	19133873		
24407	2006	1713671	1949-07-20	1949-07-20 00:00:00	1949-08-10	1949-08-10 00:00:00	1949-08-10	38000177		0	0	21		0	0	0	133618	0	562251	1713671		
24454	2012	19006318	1959-12-18	1959-12-18 00:00:00	1960-01-01	1960-01-01 00:00:00	1960-01-01	38000177		0	0	14		0	0	0	133906	0	105078	19006318		
41576	3442	1127433	2011-07-15	2011-07-15 00:00:00	2011-08-19	2011-08-19 00:00:00	2011-08-19	38000177		0	0	35		0	0	0	228418	0	313782	1127433		
41604	3444	920300	2000-01-08	2000-01-08 00:00:00	2000-01-15	2000-01-15 00:00:00	2000-01-15	38000177		0	0	7		0	0	0	228572	0	311989	920300		
41656	3446	19077572	2016-12-05	2016-12-05 00:00:00	2016-12-05	2016-12-05 00:00:00	\N	38000177		0	0	0		0	0	0	228881	0	310436	19077572		
10708	890	19059056	1961-06-17	1961-06-17 00:00:00	1961-08-16	1961-08-16 00:00:00	1961-08-16	38000177		0	0	60		0	0	0	59325	0	243670	19059056		
31256	2591	1713671	1954-12-07	1954-12-07 00:00:00	1954-12-14	1954-12-14 00:00:00	1954-12-14	38000177		0	0	7		0	0	0	171509	0	562251	1713671		
9452	784	1118084	2000-09-13	2000-09-13 00:00:00	2000-09-13	2000-09-13 00:00:00	\N	38000177		0	0	0		0	0	0	52193	0	00025152531	44923712		
59739	4967	19133873	1968-12-07	1968-12-07 00:00:00	1968-12-20	1968-12-20 00:00:00	1968-12-20	38000177		0	0	13		0	0	0	330155	0	834061	19133873		
11246	936	1127433	2008-10-28	2008-10-28 00:00:00	2008-11-25	2008-11-25 00:00:00	2008-11-25	38000177		0	0	28		0	0	0	62264	0	313782	1127433		
77152	1686	40213260	2012-06-17	2012-06-17 00:00:00	2012-06-17	2012-06-17 00:00:00	2012-06-17	581452		0	0	0		0	0	0	112983	0	121	40213260		
39170	3237	19077572	2006-04-26	2006-04-26 00:00:00	2006-04-26	2006-04-26 00:00:00	\N	38000177		0	0	0		0	0	0	215200	0	310436	19077572		
4687	390	19019979	1980-04-09	1980-04-09 00:00:00	1980-04-23	1980-04-23 00:00:00	1980-04-23	38000177		0	0	14		0	0	0	25651	0	198405	19019979		
21037	457	40213198	2017-05-16	2017-05-16 00:00:00	2017-05-16	2017-05-16 00:00:00	2017-05-16	581452		0	0	0		0	0	0	30553	0	133	40213198		
42731	3541	1713671	1968-04-10	1968-04-10 00:00:00	1968-04-24	1968-04-24 00:00:00	1968-04-24	38000177		0	0	14		0	0	0	235170	0	562251	1713671		
1851	148	19059056	1980-09-04	1980-09-04 00:00:00	1980-09-18	1980-09-18 00:00:00	1980-09-18	38000177		0	0	14		0	0	0	9980	0	243670	19059056		
52601	4374	46233988	1976-12-16	1976-12-16 00:00:00	1976-12-30	1976-12-30 00:00:00	1976-12-30	38000177		0	0	14		0	0	0	290540	0	1652673	46233988		
42631	3533	19078461	1996-07-03	1996-07-03 00:00:00	1996-08-07	1996-08-07 00:00:00	1996-08-07	38000177		0	0	35		0	0	0	234719	0	310965	19078461		
41318	3427	1127433	2008-04-02	2008-04-02 00:00:00	2008-04-30	2008-04-30 00:00:00	2008-04-30	38000177		0	0	28		0	0	0	227228	0	313782	1127433		
51495	4279	1127433	1964-01-24	1964-01-24 00:00:00	1964-02-28	1964-02-28 00:00:00	1964-02-28	38000177		0	0	35		0	0	0	284011	0	313782	1127433		
25976	2136	19128065	1984-05-18	1984-05-18 00:00:00	1985-05-13	1985-05-13 00:00:00	1985-05-13	38000177		0	0	360		0	0	0	142228	0	749882	19128065		
4901	408	1124300	2004-07-16	2004-07-16 00:00:00	2004-07-16	2004-07-16 00:00:00	\N	38000177		0	0	0		0	0	0	26961	0	00781178901	45011828		
25063	2062	1127433	1985-04-04	1985-04-04 00:00:00	1985-04-18	1985-04-18 00:00:00	1985-04-18	38000177		0	0	14		0	0	0	137197	0	313782	1127433		
35484	2925	40231925	2007-06-17	2007-06-17 00:00:00	2007-06-17	2007-06-17 00:00:00	\N	38000177		0	0	0		0	0	0	195025	0	1049221	40231925		
39358	3250	1713671	1977-12-19	1977-12-19 00:00:00	1977-12-26	1977-12-26 00:00:00	1977-12-26	38000177		0	0	7		0	0	0	216054	0	562251	1713671		
227934	5004	40213160	1977-08-16	1977-08-16 00:00:00	1977-08-16	1977-08-16 00:00:00	1977-08-16	581452		0	0	0		0	0	0	332864	0	10	40213160		
3730	81	40213160	1961-03-01	1961-03-01 00:00:00	1961-03-01	1961-03-01 00:00:00	1961-03-01	581452		0	0	0		0	0	0	5525	0	10	40213160		
1734	38	40213227	1996-11-26	1996-11-26 00:00:00	1996-11-26	1996-11-26 00:00:00	1996-11-26	581452		0	0	0		0	0	0	2694	0	113	40213227		
35232	2905	1127433	2007-08-25	2007-08-25 00:00:00	2007-09-08	2007-09-08 00:00:00	2007-09-08	38000177		0	0	14		0	0	0	193572	0	313782	1127433		
138787	3049	40213314	1977-07-01	1977-07-01 00:00:00	1977-07-01	1977-07-01 00:00:00	1977-07-01	581452		0	0	0		0	0	0	202881	0	49	40213314		
22407	1843	1127433	1989-06-26	1989-06-26 00:00:00	1989-07-03	1989-07-03 00:00:00	1989-07-03	38000177		0	0	7		0	0	0	123012	0	313782	1127433		
50116	4159	1115171	2006-06-23	2006-06-23 00:00:00	2006-07-14	2006-07-14 00:00:00	2006-07-14	38000177		0	0	21		0	0	0	276364	0	849574	1115171		
8003	669	19128065	1990-08-22	1990-08-22 00:00:00	1991-08-17	1991-08-17 00:00:00	1991-08-17	38000177		0	0	360		0	0	0	44183	0	749882	19128065		
41470	3437	1127433	1971-05-20	1971-05-20 00:00:00	1971-05-27	1971-05-27 00:00:00	1971-05-27	38000177		0	0	7		0	0	0	228032	0	313782	1127433		
36840	3047	19128065	1988-07-12	1988-07-12 00:00:00	1989-07-07	1989-07-07 00:00:00	1989-07-07	38000177		0	0	360		0	0	0	202759	0	749882	19128065		
55049	4571	1127433	2018-03-11	2018-03-11 00:00:00	2018-03-25	2018-03-25 00:00:00	2018-03-25	38000177		0	0	14		0	0	0	304562	0	313782	1127433		
7485	161	40213160	1978-05-07	1978-05-07 00:00:00	1978-05-07	1978-05-07 00:00:00	1978-05-07	581452		0	0	0		0	0	0	11073	0	10	40213160		
195214	4288	40213160	1955-01-15	1955-01-15 00:00:00	1955-01-15	1955-01-15 00:00:00	1955-01-15	581452		0	0	0		0	0	0	284666	0	10	40213160		
84771	1854	40213160	1975-05-20	1975-05-20 00:00:00	1975-05-20	1975-05-20 00:00:00	1975-05-20	581452		0	0	0		0	0	0	\N	0	10	40213160		
48021	3982	1124300	1977-11-21	1977-11-21 00:00:00	1977-11-21	1977-11-21 00:00:00	\N	38000177		0	0	0		0	0	0	264711	0	00781178901	45011828		
32281	704	40213160	1970-09-02	1970-09-02 00:00:00	1970-09-02	1970-09-02 00:00:00	1970-09-02	581452		0	0	0		0	0	0	46531	0	10	40213160		
25853	2127	1118084	1997-01-07	1997-01-07 00:00:00	1997-01-07	1997-01-07 00:00:00	\N	38000177		0	0	0		0	0	0	141490	0	00025152531	44923712		
29370	2431	1127433	1992-09-29	1992-09-29 00:00:00	1992-10-06	1992-10-06 00:00:00	1992-10-06	38000177		0	0	7		0	0	0	161236	0	313782	1127433		
14809	1238	19133905	2002-05-05	2002-05-05 00:00:00	2002-05-16	2002-05-16 00:00:00	2002-05-16	38000177		0	0	11		0	0	0	81612	0	834102	19133905		
44005	3644	19059056	1962-03-04	1962-03-04 00:00:00	1962-04-03	1962-04-03 00:00:00	1962-04-03	38000177		0	0	30		0	0	0	242489	0	243670	19059056		
130713	2872	40213160	1955-08-16	1955-08-16 00:00:00	1955-08-16	1955-08-16 00:00:00	1955-08-16	581452		0	0	0		0	0	0	191225	0	10	40213160		
28196	2332	1127433	1988-11-15	1988-11-15 00:00:00	1988-12-15	1988-12-15 00:00:00	1988-12-15	38000177		0	0	30		0	0	0	155126	0	313782	1127433		
2261	183	19074843	1979-02-25	1979-02-25 00:00:00	1979-03-11	1979-03-11 00:00:00	1979-03-11	38000177		0	0	14		0	0	0	12394	0	309045	19074843		
8620	719	19078461	2016-08-19	2016-08-19 00:00:00	2016-11-17	2016-11-17 00:00:00	2016-11-17	38000177		0	0	90		0	0	0	47566	0	310965	19078461		
22481	1848	920300	1981-11-07	1981-11-07 00:00:00	1981-11-14	1981-11-14 00:00:00	1981-11-14	38000177		0	0	7		0	0	0	123685	0	311989	920300		
47660	3951	19006318	1946-03-13	1946-03-13 00:00:00	1946-03-27	1946-03-27 00:00:00	1946-03-27	38000177		0	0	14		0	0	0	262645	0	105078	19006318		
8415	181	40213227	2015-09-27	2015-09-27 00:00:00	2015-09-27	2015-09-27 00:00:00	2015-09-27	581452		0	0	0		0	0	0	12220	0	113	40213227		
148904	3275	40213296	2002-06-08	2002-06-08 00:00:00	2002-06-08	2002-06-08 00:00:00	2002-06-08	581452		0	0	0		0	0	0	217617	0	52	40213296		
13386	1122	1127433	1992-07-24	1992-07-24 00:00:00	1992-09-22	1992-09-22 00:00:00	1992-09-22	38000177		0	0	60		0	0	0	73965	0	313782	1127433		
228066	5007	40213314	1983-09-04	1983-09-04 00:00:00	1983-09-04	1983-09-04 00:00:00	1983-09-04	581452		0	0	0		0	0	0	333002	0	49	40213314		
85286	1867	40213227	2003-06-03	2003-06-03 00:00:00	2003-06-03	2003-06-03 00:00:00	2003-06-03	581452		0	0	0		0	0	0	124725	0	113	40213227		
60009	4988	1127433	2007-09-13	2007-09-13 00:00:00	2007-09-27	2007-09-27 00:00:00	2007-09-27	38000177		0	0	14		0	0	0	331829	0	313782	1127433		
951	78	1118084	2003-02-15	2003-02-15 00:00:00	2003-02-15	2003-02-15 00:00:00	\N	38000177		0	0	0		0	0	0	5166	0	00025152531	44923712		
23798	1958	1115171	2004-09-11	2004-09-11 00:00:00	2004-09-25	2004-09-25 00:00:00	2004-09-25	38000177		0	0	14		0	0	0	130245	0	849574	1115171		
11521	959	40165015	1970-05-13	1970-05-13 00:00:00	1970-05-13	1970-05-13 00:00:00	\N	38000177		0	0	0		0	0	0	63783	0	861467	40165015		
170080	3739	40213227	2009-02-09	2009-02-09 00:00:00	2009-02-09	2009-02-09 00:00:00	2009-02-09	581452		0	0	0		0	0	0	248410	0	113	40213227		
34653	2862	19133873	1967-10-28	1967-10-28 00:00:00	1967-11-04	1967-11-04 00:00:00	1967-11-04	38000177		0	0	7		0	0	0	190267	0	834061	19133873		
34691	2864	19133873	1941-02-17	1941-02-17 00:00:00	1941-02-28	1941-02-28 00:00:00	1941-02-28	38000177		0	0	11		0	0	0	190551	0	834061	19133873		
37661	3114	1127433	1953-09-12	1953-09-12 00:00:00	1953-09-26	1953-09-26 00:00:00	1953-09-26	38000177		0	0	14		0	0	0	207141	0	313782	1127433		
24408	2006	19133905	1972-02-28	1972-02-28 00:00:00	1972-03-11	1972-03-11 00:00:00	1972-03-11	38000177		0	0	12		0	0	0	133619	0	834102	19133905		
24455	2012	19059056	1959-12-18	1959-12-18 00:00:00	1960-01-01	1960-01-01 00:00:00	1960-01-01	38000177		0	0	14		0	0	0	133906	0	243670	19059056		
41577	3442	1713671	1999-12-05	1999-12-05 00:00:00	1999-12-19	1999-12-19 00:00:00	1999-12-19	38000177		0	0	14		0	0	0	228410	0	562251	1713671		
41605	3444	40236824	2000-01-08	2000-01-08 00:00:00	2000-01-22	2000-01-22 00:00:00	2000-01-22	38000177		0	0	14		0	0	0	228572	0	1094107	40236824		
41657	3446	19078461	2006-09-03	2006-09-03 00:00:00	2006-09-24	2006-09-24 00:00:00	2006-09-24	38000177		0	0	21		0	0	0	228801	0	310965	19078461		
10709	890	1713671	1986-08-21	1986-08-21 00:00:00	1986-09-04	1986-09-04 00:00:00	1986-09-04	38000177		0	0	14		0	0	0	59335	0	562251	1713671		
31257	2591	19059056	1963-11-26	1963-11-26 00:00:00	1963-12-10	1963-12-10 00:00:00	1963-12-10	38000177		0	0	14		0	0	0	171459	0	243670	19059056		
9453	785	1127433	1989-08-15	1989-08-15 00:00:00	1989-08-22	1989-08-22 00:00:00	1989-08-22	38000177		0	0	7		0	0	0	52286	0	313782	1127433		
59740	4967	19078461	1982-07-08	1982-07-08 00:00:00	1982-10-06	1982-10-06 00:00:00	1982-10-06	38000177		0	0	90		0	0	0	330154	0	310965	19078461		
11247	936	1118084	2002-05-06	2002-05-06 00:00:00	2002-05-06	2002-05-06 00:00:00	\N	38000177		0	0	0		0	0	0	62259	0	00025152531	44923712		
77154	1686	40213227	2012-06-17	2012-06-17 00:00:00	2012-06-17	2012-06-17 00:00:00	2012-06-17	581452		0	0	0		0	0	0	112983	0	113	40213227		
39171	3237	1127433	1951-08-21	1951-08-21 00:00:00	1951-09-04	1951-09-04 00:00:00	1951-09-04	38000177		0	0	14		0	0	0	215149	0	313782	1127433		
4688	390	19128065	1994-01-06	1994-01-06 00:00:00	1995-01-01	1995-01-01 00:00:00	1995-01-01	38000177		0	0	360		0	0	0	25657	0	749882	19128065		
21042	457	40213201	2018-05-22	2018-05-22 00:00:00	2018-05-22	2018-05-22 00:00:00	2018-05-22	581452		0	0	0		0	0	0	30531	0	33	40213201		
42732	3541	19133905	2018-09-27	2018-09-27 00:00:00	2018-10-08	2018-10-08 00:00:00	2018-10-08	38000177		0	0	11		0	0	0	235213	0	834102	19133905		
1852	148	19078461	2000-08-09	2000-08-09 00:00:00	2000-09-13	2000-09-13 00:00:00	2000-09-13	38000177		0	0	35		0	0	0	9978	0	310965	19078461		
52602	4374	19019979	1976-12-16	1976-12-16 00:00:00	1976-12-30	1976-12-30 00:00:00	1976-12-30	38000177		0	0	14		0	0	0	290540	0	198405	19019979		
42632	3533	19059056	1973-07-13	1973-07-13 00:00:00	1973-08-03	1973-08-03 00:00:00	1973-08-03	38000177		0	0	21		0	0	0	234662	0	243670	19059056		
41319	3427	19133873	1974-07-24	1974-07-24 00:00:00	1974-07-31	1974-07-31 00:00:00	1974-07-31	38000177		0	0	7		0	0	0	227209	0	834061	19133873		
51496	4279	1127433	1986-12-05	1986-12-05 00:00:00	1986-12-12	1986-12-12 00:00:00	1986-12-12	38000177		0	0	7		0	0	0	283964	0	313782	1127433		
25977	2136	1127078	1974-01-24	1974-01-24 00:00:00	1974-02-07	1974-02-07 00:00:00	1974-02-07	38000177		0	0	14		0	0	0	142253	0	282464	1127078		
4902	408	1127433	2013-01-05	2013-01-05 00:00:00	2013-02-02	2013-02-02 00:00:00	2013-02-02	38000177		0	0	28		0	0	0	26973	0	313782	1127433		
25064	2062	1127433	1962-01-30	1962-01-30 00:00:00	1962-02-20	1962-02-20 00:00:00	1962-02-20	38000177		0	0	21		0	0	0	137162	0	313782	1127433		
35485	2925	19073188	2007-06-17	2007-06-17 00:00:00	2007-07-22	2007-07-22 00:00:00	2007-07-22	38000177		0	0	35		0	0	0	195025	0	308192	19073188		
39359	3250	1115171	2009-08-04	2009-08-04 00:00:00	2009-08-18	2009-08-18 00:00:00	2009-08-18	38000177		0	0	14		0	0	0	216094	0	849574	1115171		
227938	5004	40213251	1984-02-28	1984-02-28 00:00:00	1984-02-28	1984-02-28 00:00:00	1984-02-28	581452		0	0	0		0	0	0	332803	0	21	40213251		
3746	81	40213260	2006-04-05	2006-04-05 00:00:00	2006-04-05	2006-04-05 00:00:00	2006-04-05	581452		0	0	0		0	0	0	5514	0	121	40213260		
1740	38	40213160	1965-05-18	1965-05-18 00:00:00	1965-05-18	1965-05-18 00:00:00	1965-05-18	581452		0	0	0		0	0	0	2728	0	10	40213160		
35233	2905	1127433	1981-02-14	1981-02-14 00:00:00	1981-02-21	1981-02-21 00:00:00	1981-02-21	38000177		0	0	7		0	0	0	193538	0	313782	1127433		
138793	3049	40213160	1976-12-31	1976-12-31 00:00:00	1976-12-31	1976-12-31 00:00:00	1976-12-31	581452		0	0	0		0	0	0	202853	0	10	40213160		
22408	1843	40231925	1997-03-17	1997-03-17 00:00:00	1997-03-17	1997-03-17 00:00:00	\N	38000177		0	0	0		0	0	0	123011	0	1049221	40231925		
50118	4159	1127433	2000-09-01	2000-09-01 00:00:00	2000-09-22	2000-09-22 00:00:00	2000-09-22	38000177		0	0	21		0	0	0	276363	0	313782	1127433		
8004	669	1127433	1974-04-09	1974-04-09 00:00:00	1974-04-16	1974-04-16 00:00:00	1974-04-16	38000177		0	0	7		0	0	0	44141	0	313782	1127433		
41471	3437	19059056	1915-03-13	1915-03-13 00:00:00	1915-05-12	1915-05-12 00:00:00	1915-05-12	38000177		0	0	60		0	0	0	228017	0	243670	19059056		
36841	3047	46233988	1978-02-16	1978-02-16 00:00:00	1978-03-02	1978-03-02 00:00:00	1978-03-02	38000177		0	0	14		0	0	0	202717	0	1652673	46233988		
55050	4571	40236824	2004-07-27	2004-07-27 00:00:00	2004-08-03	2004-08-03 00:00:00	2004-08-03	38000177		0	0	7		0	0	0	304593	0	1094107	40236824		
7487	161	40213314	1978-05-07	1978-05-07 00:00:00	1978-05-07	1978-05-07 00:00:00	1978-05-07	581452		0	0	0		0	0	0	11073	0	49	40213314		
6307	137	40213227	1993-07-14	1993-07-14 00:00:00	1993-07-14	1993-07-14 00:00:00	1993-07-14	581452		0	0	0		0	0	0	9192	0	113	40213227		
84776	1854	40213160	1971-07-13	1971-07-13 00:00:00	1971-07-13	1971-07-13 00:00:00	1971-07-13	581452		0	0	0		0	0	0	124067	0	10	40213160		
48022	3982	1713671	1976-01-29	1976-01-29 00:00:00	1976-02-05	1976-02-05 00:00:00	1976-02-05	38000177		0	0	7		0	0	0	264711	0	562251	1713671		
32289	704	40213306	1988-08-24	1988-08-24 00:00:00	1988-08-24	1988-08-24 00:00:00	1988-08-24	581452		0	0	0		0	0	0	46638	0	43	40213306		
25854	2127	1713671	2018-11-15	2018-11-15 00:00:00	2018-11-22	2018-11-22 00:00:00	2018-11-22	38000177		0	0	7		0	0	0	141456	0	562251	1713671		
29371	2431	19128065	1988-07-01	1988-07-01 00:00:00	1989-06-26	1989-06-26 00:00:00	1989-06-26	38000177		0	0	360		0	0	0	161206	0	749882	19128065		
14810	1239	19128065	1984-06-21	1984-06-21 00:00:00	1985-06-16	1985-06-16 00:00:00	1985-06-16	38000177		0	0	360		0	0	0	81672	0	749882	19128065		
44006	3644	46275916	1982-02-24	1982-02-24 00:00:00	1982-02-24	1982-02-24 00:00:00	1982-02-24	38000177		0	0	0		0	0	0	242492	0	1660014	46275916		
130728	2872	40213296	1996-03-26	1996-03-26 00:00:00	1996-03-26	1996-03-26 00:00:00	1996-03-26	581452		0	0	0		0	0	0	191214	0	52	40213296		
28197	2332	40165015	1988-11-15	1988-11-15 00:00:00	1988-11-15	1988-11-15 00:00:00	\N	38000177		0	0	0		0	0	0	155126	0	861467	40165015		
2262	183	19019979	1981-05-04	1981-05-04 00:00:00	1981-08-02	1981-08-02 00:00:00	1981-08-02	38000177		0	0	90		0	0	0	12347	0	198405	19019979		
8621	719	1127433	1992-06-16	1992-06-16 00:00:00	1992-06-30	1992-06-30 00:00:00	1992-06-30	38000177		0	0	14		0	0	0	47558	0	313782	1127433		
22482	1848	1118084	1982-09-25	1982-09-25 00:00:00	1982-09-25	1982-09-25 00:00:00	\N	38000177		0	0	0		0	0	0	123685	0	00025152531	44923712		
37199	3076	1115171	2017-10-20	2017-10-20 00:00:00	2017-11-19	2017-11-19 00:00:00	2017-11-19	38000177		0	0	30		0	0	0	204649	0	849574	1115171		
8423	181	40213314	1977-02-20	1977-02-20 00:00:00	1977-02-20	1977-02-20 00:00:00	1977-02-20	581452		0	0	0		0	0	0	12210	0	49	40213314		
148905	3275	40213227	2001-04-21	2001-04-21 00:00:00	2001-04-21	2001-04-21 00:00:00	2001-04-21	581452		0	0	0		0	0	0	217645	0	113	40213227		
13387	1122	1124300	2004-01-28	2004-01-28 00:00:00	2004-01-28	2004-01-28 00:00:00	\N	38000177		0	0	0		0	0	0	73935	0	00781178901	45011828		
228067	5007	40213160	1983-09-04	1983-09-04 00:00:00	1983-09-04	1983-09-04 00:00:00	1983-09-04	581452		0	0	0		0	0	0	333002	0	10	40213160		
85296	1867	40213227	2014-06-03	2014-06-03 00:00:00	2014-06-03	2014-06-03 00:00:00	2014-06-03	581452		0	0	0		0	0	0	124728	0	113	40213227		
60010	4988	1127433	1977-04-17	1977-04-17 00:00:00	1977-04-24	1977-04-24 00:00:00	1977-04-24	38000177		0	0	7		0	0	0	331844	0	313782	1127433		
952	78	19006318	1967-11-13	1967-11-13 00:00:00	1967-11-27	1967-11-27 00:00:00	1967-11-27	38000177		0	0	14		0	0	0	5157	0	105078	19006318		
23799	1958	19073183	1979-05-16	1979-05-16 00:00:00	1979-05-30	1979-05-30 00:00:00	1979-05-30	38000177		0	0	14		0	0	0	130261	0	308182	19073183		
167912	3691	40213160	1955-01-21	1955-01-21 00:00:00	1955-01-21	1955-01-21 00:00:00	1955-01-21	581452		0	0	0		0	0	0	245307	0	10	40213160		
170081	3739	40213296	2009-02-09	2009-02-09 00:00:00	2009-02-09	2009-02-09 00:00:00	2009-02-09	581452		0	0	0		0	0	0	248410	0	52	40213296		
34654	2862	1713671	2012-11-21	2012-11-21 00:00:00	2012-12-12	2012-12-12 00:00:00	2012-12-12	38000177		0	0	21		0	0	0	190274	0	562251	1713671		
34692	2864	19059056	1951-08-22	1951-08-22 00:00:00	1951-09-19	1951-09-19 00:00:00	1951-09-19	38000177		0	0	28		0	0	0	190560	0	243670	19059056		
37662	3114	1127433	2013-02-19	2013-02-19 00:00:00	2013-05-20	2013-05-20 00:00:00	2013-05-20	38000177		0	0	90		0	0	0	207117	0	313782	1127433		
24410	2006	1127433	1950-03-30	1950-03-30 00:00:00	1950-04-13	1950-04-13 00:00:00	1950-04-13	38000177		0	0	14		0	0	0	133545	0	313782	1127433		
24456	2012	40165015	1970-07-23	1970-07-23 00:00:00	1970-07-23	1970-07-23 00:00:00	\N	38000177		0	0	0		0	0	0	133863	0	861467	40165015		
41578	3443	1127433	1994-05-20	1994-05-20 00:00:00	1994-06-03	1994-06-03 00:00:00	1994-06-03	38000177		0	0	14		0	0	0	228511	0	313782	1127433		
41606	3444	40229134	2013-08-07	2013-08-07 00:00:00	2013-08-21	2013-08-21 00:00:00	2013-08-21	38000177		0	0	14		0	0	0	228578	0	1043400	40229134		
41658	3446	19078461	1981-01-07	1981-01-07 00:00:00	1981-01-28	1981-01-28 00:00:00	1981-01-28	38000177		0	0	21		0	0	0	228782	0	310965	19078461		
10710	890	1127433	1992-10-30	1992-10-30 00:00:00	1992-11-20	1992-11-20 00:00:00	1992-11-20	38000177		0	0	21		0	0	0	59288	0	313782	1127433		
31258	2591	19006318	1963-11-26	1963-11-26 00:00:00	1963-12-10	1963-12-10 00:00:00	1963-12-10	38000177		0	0	14		0	0	0	171459	0	105078	19006318		
9454	785	1118084	2004-07-15	2004-07-15 00:00:00	2004-07-15	2004-07-15 00:00:00	\N	38000177		0	0	0		0	0	0	52253	0	00025152531	44923712		
59741	4967	1713671	1978-09-02	1978-09-02 00:00:00	1978-10-28	1978-10-28 00:00:00	1978-10-28	38000177		0	0	56		0	0	0	330183	0	562251	1713671		
11248	936	19059056	1965-11-01	1965-11-01 00:00:00	1965-11-15	1965-11-15 00:00:00	1965-11-15	38000177		0	0	14		0	0	0	62289	0	243670	19059056		
76764	1677	40213306	1991-09-14	1991-09-14 00:00:00	1991-09-14	1991-09-14 00:00:00	1991-09-14	581452		0	0	0		0	0	0	112478	0	43	40213306		
39172	3237	1127433	1971-01-27	1971-01-27 00:00:00	1971-02-26	1971-02-26 00:00:00	1971-02-26	38000177		0	0	30		0	0	0	215153	0	313782	1127433		
4694	392	1127433	1979-02-14	1979-02-14 00:00:00	1979-02-28	1979-02-28 00:00:00	1979-02-28	38000177		0	0	14		0	0	0	25716	0	313782	1127433		
21046	457	40213227	2002-08-20	2002-08-20 00:00:00	2002-08-20	2002-08-20 00:00:00	2002-08-20	581452		0	0	0		0	0	0	30598	0	113	40213227		
32612	711	40213227	2001-12-28	2001-12-28 00:00:00	2001-12-28	2001-12-28 00:00:00	2001-12-28	581452		0	0	0		0	0	0	47064	0	113	40213227		
1853	148	1115171	1995-06-02	1995-06-02 00:00:00	1995-07-07	1995-07-07 00:00:00	1995-07-07	38000177		0	0	35		0	0	0	9982	0	849574	1115171		
52603	4374	19078461	2003-12-16	2003-12-16 00:00:00	2004-01-06	2004-01-06 00:00:00	2004-01-06	38000177		0	0	21		0	0	0	290538	0	310965	19078461		
42633	3533	19059056	1963-04-23	1963-04-23 00:00:00	1963-05-07	1963-05-07 00:00:00	1963-05-07	38000177		0	0	14		0	0	0	234663	0	243670	19059056		
41320	3427	40236446	1975-04-04	1975-04-04 00:00:00	1984-04-11	1984-04-11 00:00:00	1984-04-11	38000177		0	0	3295		0	0	0	227210	0	1091392	40236446		
51497	4279	1124300	1987-08-16	1987-08-16 00:00:00	1987-08-16	1987-08-16 00:00:00	\N	38000177		0	0	0		0	0	0	284080	0	00781178901	45011828		
24943	2051	19133905	1993-06-13	1993-06-13 00:00:00	1993-06-26	1993-06-26 00:00:00	1993-06-26	38000177		0	0	13		0	0	0	136350	0	834102	19133905		
4903	408	40229134	2003-04-27	2003-04-27 00:00:00	2003-05-04	2003-05-04 00:00:00	2003-05-04	38000177		0	0	7		0	0	0	26990	0	1043400	40229134		
25065	2062	1127433	1947-08-13	1947-08-13 00:00:00	1947-08-27	1947-08-27 00:00:00	1947-08-27	38000177		0	0	14		0	0	0	137122	0	313782	1127433		
35486	2925	19128065	1980-11-30	1980-11-30 00:00:00	1981-11-25	1981-11-25 00:00:00	1981-11-25	38000177		0	0	360		0	0	0	195013	0	749882	19128065		
39360	3250	19075001	2009-08-04	2009-08-04 00:00:00	2009-08-18	2009-08-18 00:00:00	2009-08-18	38000177		0	0	14		0	0	0	216094	0	309097	19075001		
231235	5081	40213227	2005-01-28	2005-01-28 00:00:00	2005-01-28	2005-01-28 00:00:00	2005-01-28	581452		0	0	0		0	0	0	337927	0	113	40213227		
3754	81	40213227	1999-03-17	1999-03-17 00:00:00	1999-03-17	1999-03-17 00:00:00	1999-03-17	581452		0	0	0		0	0	0	5533	0	113	40213227		
1742	38	40213160	1965-07-20	1965-07-20 00:00:00	1965-07-20	1965-07-20 00:00:00	1965-07-20	581452		0	0	0		0	0	0	2741	0	10	40213160		
35234	2905	46233988	1972-01-07	1972-01-07 00:00:00	1972-01-21	1972-01-21 00:00:00	1972-01-21	38000177		0	0	14		0	0	0	193564	0	1652673	46233988		
138794	3049	40213314	1976-12-31	1976-12-31 00:00:00	1976-12-31	1976-12-31 00:00:00	1976-12-31	581452		0	0	0		0	0	0	202853	0	49	40213314		
22409	1843	1115171	1997-03-17	1997-03-17 00:00:00	1997-05-16	1997-05-16 00:00:00	1997-05-16	38000177		0	0	60		0	0	0	123011	0	849574	1115171		
50119	4159	19128065	1976-12-18	1976-12-18 00:00:00	1977-12-13	1977-12-13 00:00:00	1977-12-13	38000177		0	0	360		0	0	0	276311	0	749882	19128065		
8005	669	19133873	1972-03-22	1972-03-22 00:00:00	1972-04-01	1972-04-01 00:00:00	1972-04-01	38000177		0	0	10		0	0	0	44164	0	834061	19133873		
41472	3437	1127433	1972-11-25	1972-11-25 00:00:00	1972-12-23	1972-12-23 00:00:00	1972-12-23	38000177		0	0	28		0	0	0	227921	0	313782	1127433		
36842	3047	1127078	1978-02-16	1978-02-16 00:00:00	1978-03-02	1978-03-02 00:00:00	1978-03-02	38000177		0	0	14		0	0	0	202717	0	282464	1127078		
55051	4571	920300	2004-07-27	2004-07-27 00:00:00	2004-08-03	2004-08-03 00:00:00	2004-08-03	38000177		0	0	7		0	0	0	304593	0	311989	920300		
7490	161	40213160	1978-08-06	1978-08-06 00:00:00	1978-08-06	1978-08-06 00:00:00	1978-08-06	581452		0	0	0		0	0	0	11027	0	10	40213160		
6308	137	40213306	1993-07-14	1993-07-14 00:00:00	1993-07-14	1993-07-14 00:00:00	1993-07-14	581452		0	0	0		0	0	0	9192	0	43	40213306		
84779	1854	40213160	1971-02-09	1971-02-09 00:00:00	1971-02-09	1971-02-09 00:00:00	1971-02-09	581452		0	0	0		0	0	0	124084	0	10	40213160		
48023	3982	1127433	2015-01-17	2015-01-17 00:00:00	2015-01-24	2015-01-24 00:00:00	2015-01-24	38000177		0	0	7		0	0	0	264754	0	313782	1127433		
32291	704	40213160	1966-05-18	1966-05-18 00:00:00	1966-05-18	1966-05-18 00:00:00	1966-05-18	581452		0	0	0		0	0	0	46527	0	10	40213160		
25855	2127	19078461	1992-07-17	1992-07-17 00:00:00	1992-08-07	1992-08-07 00:00:00	1992-08-07	38000177		0	0	21		0	0	0	141448	0	310965	19078461		
29372	2431	19078461	1989-09-20	1989-09-20 00:00:00	1989-10-04	1989-10-04 00:00:00	1989-10-04	38000177		0	0	14		0	0	0	161232	0	310965	19078461		
14811	1239	1127433	2015-10-20	2015-10-20 00:00:00	2015-10-27	2015-10-27 00:00:00	2015-10-27	38000177		0	0	7		0	0	0	81642	0	313782	1127433		
44007	3644	1310034	1982-02-24	1982-02-24 00:00:00	1982-02-24	1982-02-24 00:00:00	1982-02-24	38000177		0	0	0		0	0	0	242492	0	834357	1310034		
130734	2872	40213227	1994-03-22	1994-03-22 00:00:00	1994-03-22	1994-03-22 00:00:00	1994-03-22	581452		0	0	0		0	0	0	191213	0	113	40213227		
28198	2332	1118084	1996-10-27	1996-10-27 00:00:00	1996-10-27	1996-10-27 00:00:00	\N	38000177		0	0	0		0	0	0	155117	0	00025152531	44923712		
2263	183	1713671	2006-07-11	2006-07-11 00:00:00	2006-07-18	2006-07-18 00:00:00	2006-07-18	38000177		0	0	7		0	0	0	12411	0	562251	1713671		
8622	719	1127433	2010-09-06	2010-09-06 00:00:00	2010-09-20	2010-09-20 00:00:00	2010-09-20	38000177		0	0	14		0	0	0	47565	0	313782	1127433		
22483	1848	19018935	2011-02-17	2011-02-17 00:00:00	2011-02-17	2011-02-17 00:00:00	\N	38000177		0	0	0		0	0	0	123636	0	197604	19018935		
37200	3076	1127433	1974-03-22	1974-03-22 00:00:00	1974-04-12	1974-04-12 00:00:00	1974-04-12	38000177		0	0	21		0	0	0	204642	0	313782	1127433		
8427	181	40213227	1995-11-26	1995-11-26 00:00:00	1995-11-26	1995-11-26 00:00:00	1995-11-26	581452		0	0	0		0	0	0	12224	0	113	40213227		
148906	3275	40213296	2001-04-21	2001-04-21 00:00:00	2001-04-21	2001-04-21 00:00:00	2001-04-21	581452		0	0	0		0	0	0	217645	0	52	40213296		
13388	1122	1127078	1976-11-10	1976-11-10 00:00:00	1976-11-24	1976-11-24 00:00:00	1976-11-24	38000177		0	0	14		0	0	0	73929	0	282464	1127078		
145123	3189	40213306	1988-03-30	1988-03-30 00:00:00	1988-03-30	1988-03-30 00:00:00	1988-03-30	581452		0	0	0		0	0	0	212291	0	43	40213306		
85297	1867	40213296	2014-06-03	2014-06-03 00:00:00	2014-06-03	2014-06-03 00:00:00	2014-06-03	581452		0	0	0		0	0	0	124728	0	52	40213296		
60011	4988	1118084	1991-04-27	1991-04-27 00:00:00	1991-04-27	1991-04-27 00:00:00	\N	38000177		0	0	0		0	0	0	331868	0	00025152531	44923712		
953	78	19059056	1967-11-13	1967-11-13 00:00:00	1967-11-27	1967-11-27 00:00:00	1967-11-27	38000177		0	0	14		0	0	0	5157	0	243670	19059056		
23800	1958	1127078	1979-05-16	1979-05-16 00:00:00	1979-05-30	1979-05-30 00:00:00	1979-05-30	38000177		0	0	14		0	0	0	130261	0	282464	1127078		
179005	3936	40213160	1963-02-18	1963-02-18 00:00:00	1963-02-18	1963-02-18 00:00:00	1963-02-18	581452		0	0	0		0	0	0	261598	0	10	40213160		
170082	3739	40213160	1968-01-22	1968-01-22 00:00:00	1968-01-22	1968-01-22 00:00:00	1968-01-22	581452		0	0	0		0	0	0	248455	0	10	40213160		
34655	2862	19133873	1968-01-05	1968-01-05 00:00:00	1968-01-16	1968-01-16 00:00:00	1968-01-16	38000177		0	0	11		0	0	0	190282	0	834061	19133873		
34693	2864	1124300	1976-04-02	1976-04-02 00:00:00	1976-04-02	1976-04-02 00:00:00	\N	38000177		0	0	0		0	0	0	190565	0	00781178901	45011828		
37663	3114	40165015	2013-02-19	2013-02-19 00:00:00	2013-02-19	2013-02-19 00:00:00	\N	38000177		0	0	0		0	0	0	207117	0	861467	40165015		
24411	2007	1127078	1987-12-27	1987-12-27 00:00:00	1988-01-10	1988-01-10 00:00:00	1988-01-10	38000177		0	0	14		0	0	0	133662	0	282464	1127078		
24457	2012	1127433	1970-07-23	1970-07-23 00:00:00	1970-08-22	1970-08-22 00:00:00	1970-08-22	38000177		0	0	30		0	0	0	133863	0	313782	1127433		
10123	847	19128065	1984-03-14	1984-03-14 00:00:00	1985-03-09	1985-03-09 00:00:00	1985-03-09	38000177		0	0	360		0	0	0	56141	0	749882	19128065		
41607	3444	1127433	2019-03-03	2019-03-03 00:00:00	2019-03-17	2019-03-17 00:00:00	2019-03-17	38000177		0	0	14		0	0	0	228579	0	313782	1127433		
42678	931	40213296	2000-09-22	2000-09-22 00:00:00	2000-09-22	2000-09-22 00:00:00	2000-09-22	581452		0	0	0		0	0	0	61956	0	52	40213296		
10711	890	1127433	1966-03-25	1966-03-25 00:00:00	1966-04-01	1966-04-01 00:00:00	1966-04-01	38000177		0	0	7		0	0	0	59318	0	313782	1127433		
31259	2591	1127433	1947-04-26	1947-04-26 00:00:00	1947-05-10	1947-05-10 00:00:00	1947-05-10	38000177		0	0	14		0	0	0	171488	0	313782	1127433		
9455	785	19078461	1984-12-17	1984-12-17 00:00:00	1985-01-07	1985-01-07 00:00:00	1985-01-07	38000177		0	0	21		0	0	0	52252	0	310965	19078461		
59742	4967	19006318	1961-06-28	1961-06-28 00:00:00	1961-07-12	1961-07-12 00:00:00	1961-07-12	38000177		0	0	14		0	0	0	330166	0	105078	19006318		
11249	936	19006318	1965-11-01	1965-11-01 00:00:00	1965-11-15	1965-11-15 00:00:00	1965-11-15	38000177		0	0	14		0	0	0	62289	0	105078	19006318		
76770	1677	40213160	1974-06-22	1974-06-22 00:00:00	1974-06-22	1974-06-22 00:00:00	1974-06-22	581452		0	0	0		0	0	0	112496	0	10	40213160		
39173	3237	1127433	1954-06-20	1954-06-20 00:00:00	1954-07-11	1954-07-11 00:00:00	1954-07-11	38000177		0	0	21		0	0	0	215150	0	313782	1127433		
4695	392	19019979	1978-03-20	1978-03-20 00:00:00	1978-04-19	1978-04-19 00:00:00	1978-04-19	38000177		0	0	30		0	0	0	25744	0	198405	19019979		
21052	457	40213160	1956-04-17	1956-04-17 00:00:00	1956-04-17	1956-04-17 00:00:00	1956-04-17	581452		0	0	0		0	0	0	30573	0	10	40213160		
32621	711	40213227	2012-02-24	2012-02-24 00:00:00	2012-02-24	2012-02-24 00:00:00	2012-02-24	581452		0	0	0		0	0	0	47066	0	113	40213227		
1854	148	40162522	1993-06-12	1993-06-12 00:00:00	1993-06-12	1993-06-12 00:00:00	\N	38000177		0	0	0		0	0	0	9981	0	857005	40162522		
52604	4374	1127078	1986-03-29	1986-03-29 00:00:00	1986-04-19	1986-04-19 00:00:00	1986-04-19	38000177		0	0	21		0	0	0	290537	0	282464	1127078		
42634	3533	19129655	1963-04-23	1963-04-23 00:00:00	1963-05-07	1963-05-07 00:00:00	1963-05-07	38000177		0	0	14		0	0	0	234663	0	789980	19129655		
41321	3427	1127078	1970-02-14	1970-02-14 00:00:00	1970-04-22	1970-04-22 00:00:00	1970-04-22	38000177		0	0	67		0	0	0	227245	0	282464	1127078		
2921	236	19059056	1956-06-10	1956-06-10 00:00:00	1956-06-24	1956-06-24 00:00:00	1956-06-24	38000177		0	0	14		0	0	0	15911	0	243670	19059056		
24944	2051	19078461	2012-12-28	2012-12-28 00:00:00	2013-01-27	2013-01-27 00:00:00	2013-01-27	38000177		0	0	30		0	0	0	136399	0	310965	19078461		
4904	408	1127433	2011-09-27	2011-09-27 00:00:00	2011-10-04	2011-10-04 00:00:00	2011-10-04	38000177		0	0	7		0	0	0	26993	0	313782	1127433		
25066	2062	19078461	1988-02-02	1988-02-02 00:00:00	1988-03-08	1988-03-08 00:00:00	1988-03-08	38000177		0	0	35		0	0	0	137198	0	310965	19078461		
35488	2925	19128065	1982-11-20	1982-11-20 00:00:00	1983-11-15	1983-11-15 00:00:00	1983-11-15	38000177		0	0	360		0	0	0	195015	0	749882	19128065		
39361	3250	19059056	1973-06-14	1973-06-14 00:00:00	1973-09-12	1973-09-12 00:00:00	1973-09-12	38000177		0	0	90		0	0	0	216088	0	243670	19059056		
231239	5081	40213227	1994-09-16	1994-09-16 00:00:00	1994-09-16	1994-09-16 00:00:00	1994-09-16	581452		0	0	0		0	0	0	337829	0	113	40213227		
3755	81	40213296	1999-03-17	1999-03-17 00:00:00	1999-03-17	1999-03-17 00:00:00	1999-03-17	581452		0	0	0		0	0	0	5533	0	52	40213296		
1744	38	40213260	2016-01-12	2016-01-12 00:00:00	2016-01-12	2016-01-12 00:00:00	2016-01-12	581452		0	0	0		0	0	0	2752	0	121	40213260		
35235	2905	19059056	1972-01-07	1972-01-07 00:00:00	1972-01-21	1972-01-21 00:00:00	1972-01-21	38000177		0	0	14		0	0	0	193564	0	243670	19059056		
138796	3049	40213314	1977-04-01	1977-04-01 00:00:00	1977-04-01	1977-04-01 00:00:00	1977-04-01	581452		0	0	0		0	0	0	202838	0	49	40213314		
22410	1843	1127433	2012-06-04	2012-06-04 00:00:00	2012-06-11	2012-06-11 00:00:00	2012-06-11	38000177		0	0	7		0	0	0	123086	0	313782	1127433		
50120	4159	1115171	2012-01-14	2012-01-14 00:00:00	2012-02-11	2012-02-11 00:00:00	2012-02-11	38000177		0	0	28		0	0	0	276365	0	849574	1115171		
8006	670	40229134	1995-12-11	1995-12-11 00:00:00	1995-12-25	1995-12-25 00:00:00	1995-12-25	38000177		0	0	14		0	0	0	44223	0	1043400	40229134		
41473	3437	40165015	1972-11-25	1972-11-25 00:00:00	1972-11-25	1972-11-25 00:00:00	\N	38000177		0	0	0		0	0	0	227921	0	861467	40165015		
36843	3047	40229134	1990-03-26	1990-03-26 00:00:00	1990-04-09	1990-04-09 00:00:00	1990-04-09	38000177		0	0	14		0	0	0	202752	0	1043400	40229134		
55052	4571	19059056	1958-12-02	1958-12-02 00:00:00	1958-12-23	1958-12-23 00:00:00	1958-12-23	38000177		0	0	21		0	0	0	304552	0	243670	19059056		
7494	161	40213296	2018-02-04	2018-02-04 00:00:00	2018-02-04	2018-02-04 00:00:00	2018-02-04	581452		0	0	0		0	0	0	11055	0	52	40213296		
6312	137	40213227	2002-07-24	2002-07-24 00:00:00	2002-07-24	2002-07-24 00:00:00	2002-07-24	581452		0	0	0		0	0	0	9180	0	113	40213227		
84780	1854	40213306	1993-01-05	1993-01-05 00:00:00	1993-01-05	1993-01-05 00:00:00	1993-01-05	581452		0	0	0		0	0	0	124105	0	43	40213306		
48024	3982	1127433	1940-08-03	1940-08-03 00:00:00	1940-08-17	1940-08-17 00:00:00	1940-08-17	38000177		0	0	14		0	0	0	264708	0	313782	1127433		
32297	704	40213260	2016-05-11	2016-05-11 00:00:00	2016-05-11	2016-05-11 00:00:00	2016-05-11	581452		0	0	0		0	0	0	46640	0	121	40213260		
25856	2127	1713671	1978-05-02	1978-05-02 00:00:00	1978-05-23	1978-05-23 00:00:00	1978-05-23	38000177		0	0	21		0	0	0	141453	0	562251	1713671		
29373	2431	19073188	1989-09-20	1989-09-20 00:00:00	1989-10-04	1989-10-04 00:00:00	1989-10-04	38000177		0	0	14		0	0	0	161232	0	308192	19073188		
14812	1239	19006318	1975-11-10	1975-11-10 00:00:00	1975-11-24	1975-11-24 00:00:00	1975-11-24	38000177		0	0	14		0	0	0	81671	0	105078	19006318		
44008	3644	40243436	1982-02-24	1982-02-24 00:00:00	1982-02-24	1982-02-24 00:00:00	1982-02-24	38000177		0	0	0		0	0	0	242492	0	1190795	40243436		
130737	2872	40213160	1957-02-19	1957-02-19 00:00:00	1957-02-19	1957-02-19 00:00:00	1957-02-19	581452		0	0	0		0	0	0	191226	0	10	40213160		
28199	2332	40229134	1997-03-05	1997-03-05 00:00:00	1997-03-19	1997-03-19 00:00:00	1997-03-19	38000177		0	0	14		0	0	0	155085	0	1043400	40229134		
2264	183	1127078	1975-10-19	1975-10-19 00:00:00	1975-11-02	1975-11-02 00:00:00	1975-11-02	38000177		0	0	14		0	0	0	12346	0	282464	1127078		
8623	719	1127433	2005-05-31	2005-05-31 00:00:00	2005-06-07	2005-06-07 00:00:00	2005-06-07	38000177		0	0	7		0	0	0	47568	0	313782	1127433		
22484	1848	40163554	2011-02-17	2011-02-17 00:00:00	2011-02-17	2011-02-17 00:00:00	\N	38000177		0	0	0		0	0	0	123636	0	855332	40163554		
37201	3076	1713671	1970-04-13	1970-04-13 00:00:00	1970-04-20	1970-04-20 00:00:00	1970-04-20	38000177		0	0	7		0	0	0	204658	0	562251	1713671		
8428	181	40213306	1995-11-26	1995-11-26 00:00:00	1995-11-26	1995-11-26 00:00:00	1995-11-26	581452		0	0	0		0	0	0	12224	0	43	40213306		
148912	3275	40213160	1960-09-17	1960-09-17 00:00:00	1960-09-17	1960-09-17 00:00:00	1960-09-17	581452		0	0	0		0	0	0	217623	0	10	40213160		
13389	1122	1127433	1985-11-23	1985-11-23 00:00:00	1985-12-07	1985-12-07 00:00:00	1985-12-07	38000177		0	0	14		0	0	0	73899	0	313782	1127433		
156235	3439	40213160	1955-08-04	1955-08-04 00:00:00	1955-08-04	1955-08-04 00:00:00	1955-08-04	581452		0	0	0		0	0	0	228148	0	10	40213160		
85302	1867	40213160	1972-11-28	1972-11-28 00:00:00	1972-11-28	1972-11-28 00:00:00	1972-11-28	581452		0	0	0		0	0	0	124681	0	10	40213160		
60012	4988	1127078	1956-02-05	1956-02-05 00:00:00	1956-04-05	1956-04-05 00:00:00	1956-04-05	38000177		0	0	60		0	0	0	331792	0	282464	1127078		
954	78	1127433	1991-10-28	1991-10-28 00:00:00	1991-11-04	1991-11-04 00:00:00	1991-11-04	38000177		0	0	7		0	0	0	5203	0	313782	1127433		
23801	1958	1118084	2010-08-01	2010-08-01 00:00:00	2010-08-01	2010-08-01 00:00:00	\N	38000177		0	0	0		0	0	0	130276	0	00025152531	44923712		
179008	3936	40213260	2009-03-16	2009-03-16 00:00:00	2009-03-16	2009-03-16 00:00:00	2009-03-16	581452		0	0	0		0	0	0	261655	0	121	40213260		
170087	3739	40213160	1972-07-24	1972-07-24 00:00:00	1972-07-24	1972-07-24 00:00:00	1972-07-24	581452		0	0	0		0	0	0	248459	0	10	40213160		
34656	2862	1115171	1999-03-15	1999-03-15 00:00:00	1999-04-06	1999-04-06 00:00:00	1999-04-06	38000177		0	0	22		0	0	0	190261	0	849574	1115171		
34694	2865	1127433	2002-07-31	2002-07-31 00:00:00	2002-08-07	2002-08-07 00:00:00	2002-08-07	38000177		0	0	7		0	0	0	190600	0	313782	1127433		
37665	3115	19128065	1985-12-21	1985-12-21 00:00:00	1986-12-16	1986-12-16 00:00:00	1986-12-16	38000177		0	0	360		0	0	0	207205	0	749882	19128065		
24412	2007	19075001	1987-12-27	1987-12-27 00:00:00	1988-01-10	1988-01-10 00:00:00	1988-01-10	38000177		0	0	14		0	0	0	133662	0	309097	19075001		
24458	2012	1127433	2009-11-21	2009-11-21 00:00:00	2009-12-05	2009-12-05 00:00:00	2009-12-05	38000177		0	0	14		0	0	0	133845	0	313782	1127433		
10125	847	1127433	2007-11-30	2007-11-30 00:00:00	2007-12-14	2007-12-14 00:00:00	2007-12-14	38000177		0	0	14		0	0	0	56122	0	313782	1127433		
41608	3444	40220960	2018-10-29	2018-10-29 00:00:00	2018-10-29	2018-10-29 00:00:00	2018-10-29	38000177		0	0	0		0	0	0	228576	0	1804799	40220960		
42682	931	40213160	1961-05-26	1961-05-26 00:00:00	1961-05-26	1961-05-26 00:00:00	1961-05-26	581452		0	0	0		0	0	0	61993	0	10	40213160		
10712	890	1124300	1997-09-06	1997-09-06 00:00:00	1997-09-06	1997-09-06 00:00:00	\N	38000177		0	0	0		0	0	0	59366	0	00781178901	45011828		
31260	2591	19073188	2017-02-19	2017-02-19 00:00:00	2017-03-05	2017-03-05 00:00:00	2017-03-05	38000177		0	0	14		0	0	0	171430	0	308192	19073188		
9456	785	46233988	1968-10-12	1968-10-12 00:00:00	1968-10-26	1968-10-26 00:00:00	1968-10-26	38000177		0	0	14		0	0	0	52299	0	1652673	46233988		
59743	4967	1127078	1961-06-28	1961-06-28 00:00:00	1961-07-12	1961-07-12 00:00:00	1961-07-12	38000177		0	0	14		0	0	0	330166	0	282464	1127078		
11250	936	1127433	1991-08-19	1991-08-19 00:00:00	1991-08-26	1991-08-26 00:00:00	1991-08-26	38000177		0	0	7		0	0	0	62286	0	313782	1127433		
76776	1677	40213227	2000-09-23	2000-09-23 00:00:00	2000-09-23	2000-09-23 00:00:00	2000-09-23	581452		0	0	0		0	0	0	112481	0	113	40213227		
39174	3237	1713671	1931-06-24	1931-06-24 00:00:00	1931-07-01	1931-07-01 00:00:00	1931-07-01	38000177		0	0	7		0	0	0	215230	0	562251	1713671		
4696	392	19078461	1988-02-26	1988-02-26 00:00:00	1988-03-11	1988-03-11 00:00:00	1988-03-11	38000177		0	0	14		0	0	0	25745	0	310965	19078461		
21061	457	40213160	1955-04-12	1955-04-12 00:00:00	1955-04-12	1955-04-12 00:00:00	1955-04-12	581452		0	0	0		0	0	0	30538	0	10	40213160		
32623	711	40213160	1955-12-02	1955-12-02 00:00:00	1955-12-02	1955-12-02 00:00:00	1955-12-02	581452		0	0	0		0	0	0	47059	0	10	40213160		
1855	148	1127433	1993-06-12	1993-06-12 00:00:00	1993-08-11	1993-08-11 00:00:00	1993-08-11	38000177		0	0	60		0	0	0	9981	0	313782	1127433		
52605	4374	1127433	1976-08-20	1976-08-20 00:00:00	1976-09-03	1976-09-03 00:00:00	1976-09-03	38000177		0	0	14		0	0	0	290573	0	313782	1127433		
42635	3533	1127433	1994-10-09	1994-10-09 00:00:00	1994-10-23	1994-10-23 00:00:00	1994-10-23	38000177		0	0	14		0	0	0	234680	0	313782	1127433		
41322	3427	1127433	2014-04-28	2014-04-28 00:00:00	2014-05-12	2014-05-12 00:00:00	2014-05-12	38000177		0	0	14		0	0	0	227201	0	313782	1127433		
2922	236	1115171	2009-01-21	2009-01-21 00:00:00	2009-02-11	2009-02-11 00:00:00	2009-02-11	38000177		0	0	21		0	0	0	15918	0	849574	1115171		
24945	2051	19133873	1976-10-18	1976-10-18 00:00:00	1976-10-26	1976-10-26 00:00:00	1976-10-26	38000177		0	0	8		0	0	0	136345	0	834061	19133873		
4905	408	19128065	1978-05-19	1978-05-19 00:00:00	1979-05-14	1979-05-14 00:00:00	1979-05-14	38000177		0	0	360		0	0	0	26995	0	749882	19128065		
35525	2927	1127433	1954-05-21	1954-05-21 00:00:00	1954-06-04	1954-06-04 00:00:00	1954-06-04	38000177		0	0	14		0	0	0	195293	0	313782	1127433		
35489	2925	1127433	1983-02-10	1983-02-10 00:00:00	1983-02-17	1983-02-17 00:00:00	1983-02-17	38000177		0	0	7		0	0	0	195092	0	313782	1127433		
39362	3250	1713671	2001-12-01	2001-12-01 00:00:00	2001-12-08	2001-12-08 00:00:00	2001-12-08	38000177		0	0	7		0	0	0	216065	0	562251	1713671		
23229	1915	1713671	1991-12-22	1991-12-22 00:00:00	1992-01-12	1992-01-12 00:00:00	1992-01-12	38000177		0	0	21		0	0	0	127353	0	562251	1713671		
242549	5325	40213201	2012-02-05	2012-02-05 00:00:00	2012-02-05	2012-02-05 00:00:00	2012-02-05	581452		0	0	0		0	0	0	354480	0	33	40213201		
1748	38	40213227	2007-02-20	2007-02-20 00:00:00	2007-02-20	2007-02-20 00:00:00	2007-02-20	581452		0	0	0		0	0	0	2751	0	113	40213227		
35236	2905	1127433	2015-05-31	2015-05-31 00:00:00	2015-06-14	2015-06-14 00:00:00	2015-06-14	38000177		0	0	14		0	0	0	193602	0	313782	1127433		
138799	3049	40213160	1976-10-01	1976-10-01 00:00:00	1976-10-01	1976-10-01 00:00:00	1976-10-01	581452		0	0	0		0	0	0	202880	0	10	40213160		
32871	2724	1115171	2011-07-10	2011-07-10 00:00:00	2011-07-24	2011-07-24 00:00:00	2011-07-24	38000177		0	0	14		0	0	0	180436	0	849574	1115171		
50121	4159	19059056	1972-10-30	1972-10-30 00:00:00	1973-01-28	1973-01-28 00:00:00	1973-01-28	38000177		0	0	90		0	0	0	276384	0	243670	19059056		
8007	670	1127433	1977-09-15	1977-09-15 00:00:00	1977-09-22	1977-09-22 00:00:00	1977-09-22	38000177		0	0	7		0	0	0	44220	0	313782	1127433		
41474	3437	19006318	1972-11-25	1972-11-25 00:00:00	1972-12-23	1972-12-23 00:00:00	1972-12-23	38000177		0	0	28		0	0	0	227921	0	105078	19006318		
36844	3047	1713671	1985-06-14	1985-06-14 00:00:00	1985-07-05	1985-07-05 00:00:00	1985-07-05	38000177		0	0	21		0	0	0	202727	0	562251	1713671		
55053	4571	1127433	2000-08-03	2000-08-03 00:00:00	2000-08-10	2000-08-10 00:00:00	2000-08-10	38000177		0	0	7		0	0	0	304592	0	313782	1127433		
7496	161	40213160	1982-11-07	1982-11-07 00:00:00	1982-11-07	1982-11-07 00:00:00	1982-11-07	581452		0	0	0		0	0	0	11076	0	10	40213160		
6314	137	40213296	2015-01-21	2015-01-21 00:00:00	2015-01-21	2015-01-21 00:00:00	2015-01-21	581452		0	0	0		0	0	0	9242	0	52	40213296		
84787	1854	40213306	1993-05-18	1993-05-18 00:00:00	1993-05-18	1993-05-18 00:00:00	1993-05-18	581452		0	0	0		0	0	0	\N	0	43	40213306		
48025	3982	1115171	1995-09-13	1995-09-13 00:00:00	1995-10-04	1995-10-04 00:00:00	1995-10-04	38000177		0	0	21		0	0	0	264675	0	849574	1115171		
145805	3207	40213227	1993-10-14	1993-10-14 00:00:00	1993-10-14	1993-10-14 00:00:00	1993-10-14	581452		0	0	0		0	0	0	213139	0	113	40213227		
25857	2127	19059056	1962-11-22	1962-11-22 00:00:00	1962-12-06	1962-12-06 00:00:00	1962-12-06	38000177		0	0	14		0	0	0	141457	0	243670	19059056		
29379	2433	1539411	2014-03-16	2014-03-16 00:00:00	2014-03-16	2014-03-16 00:00:00	\N	38000177		0	0	0		0	0	0	161315	0	312961	1539411		
14813	1239	1127078	1975-11-10	1975-11-10 00:00:00	1975-11-24	1975-11-24 00:00:00	1975-11-24	38000177		0	0	14		0	0	0	81671	0	282464	1127078		
44009	3644	19006318	1948-11-12	1948-11-12 00:00:00	1948-11-26	1948-11-26 00:00:00	1948-11-26	38000177		0	0	14		0	0	0	242495	0	105078	19006318		
130738	2872	40213160	1955-02-15	1955-02-15 00:00:00	1955-02-15	1955-02-15 00:00:00	1955-02-15	581452		0	0	0		0	0	0	191169	0	10	40213160		
28200	2332	19059056	1964-08-11	1964-08-11 00:00:00	1964-09-10	1964-09-10 00:00:00	1964-09-10	38000177		0	0	30		0	0	0	155122	0	243670	19059056		
2265	183	1127078	1978-08-04	1978-08-04 00:00:00	1978-08-18	1978-08-18 00:00:00	1978-08-18	38000177		0	0	14		0	0	0	12393	0	282464	1127078		
8624	719	920300	2010-02-06	2010-02-06 00:00:00	2010-02-13	2010-02-13 00:00:00	2010-02-13	38000177		0	0	7		0	0	0	47570	0	311989	920300		
22485	1848	40171902	2011-02-17	2011-02-17 00:00:00	2011-02-17	2011-02-17 00:00:00	\N	38000177		0	0	0		0	0	0	123636	0	897718	40171902		
37202	3076	1118084	1989-02-06	1989-02-06 00:00:00	1989-02-06	1989-02-06 00:00:00	\N	38000177		0	0	0		0	0	0	204679	0	00025152531	44923712		
73819	1611	40213227	1994-09-25	1994-09-25 00:00:00	1994-09-25	1994-09-25 00:00:00	1994-09-25	581452		0	0	0		0	0	0	108314	0	113	40213227		
148915	3275	40213160	1960-07-16	1960-07-16 00:00:00	1960-07-16	1960-07-16 00:00:00	1960-07-16	581452		0	0	0		0	0	0	217650	0	10	40213160		
13390	1122	19073188	1985-11-23	1985-11-23 00:00:00	1985-12-07	1985-12-07 00:00:00	1985-12-07	38000177		0	0	14		0	0	0	73899	0	308192	19073188		
209548	4595	40213296	2002-07-19	2002-07-19 00:00:00	2002-07-19	2002-07-19 00:00:00	2002-07-19	581452		0	0	0		0	0	0	306203	0	52	40213296		
85304	1867	40213227	1994-05-24	1994-05-24 00:00:00	1994-05-24	1994-05-24 00:00:00	1994-05-24	581452		0	0	0		0	0	0	124722	0	113	40213227		
60013	4988	1127433	1967-05-22	1967-05-22 00:00:00	1967-06-19	1967-06-19 00:00:00	1967-06-19	38000177		0	0	28		0	0	0	331794	0	313782	1127433		
955	78	19019979	1978-09-25	1978-09-25 00:00:00	1978-11-24	1978-11-24 00:00:00	1978-11-24	38000177		0	0	60		0	0	0	5163	0	198405	19019979		
23802	1958	1127433	1989-09-20	1989-09-20 00:00:00	1989-10-25	1989-10-25 00:00:00	1989-10-25	38000177		0	0	35		0	0	0	130243	0	313782	1127433		
179010	3936	40213227	2009-03-16	2009-03-16 00:00:00	2009-03-16	2009-03-16 00:00:00	2009-03-16	581452		0	0	0		0	0	0	261655	0	113	40213227		
158505	3489	40213296	2012-11-03	2012-11-03 00:00:00	2012-11-03	2012-11-03 00:00:00	2012-11-03	581452		0	0	0		0	0	0	231482	0	52	40213296		
34657	2862	1713671	1994-11-22	1994-11-22 00:00:00	1994-11-29	1994-11-29 00:00:00	1994-11-29	38000177		0	0	7		0	0	0	190283	0	562251	1713671		
45153	3736	1127433	1991-12-31	1991-12-31 00:00:00	1992-01-21	1992-01-21 00:00:00	1992-01-21	38000177		0	0	21		0	0	0	248333	0	313782	1127433		
37666	3115	1118084	2006-04-30	2006-04-30 00:00:00	2006-04-30	2006-04-30 00:00:00	\N	38000177		0	0	0		0	0	0	207259	0	00025152531	44923712		
24413	2007	1115171	2014-09-06	2014-09-06 00:00:00	2014-10-11	2014-10-11 00:00:00	2014-10-11	38000177		0	0	35		0	0	0	133661	0	849574	1115171		
24459	2012	19078461	2006-06-05	2006-06-05 00:00:00	2006-06-26	2006-06-26 00:00:00	2006-06-26	38000177		0	0	21		0	0	0	133869	0	310965	19078461		
10126	847	19059056	1967-02-02	1967-02-02 00:00:00	1967-04-03	1967-04-03 00:00:00	1967-04-03	38000177		0	0	60		0	0	0	56136	0	243670	19059056		
41609	3444	19075601	2018-10-29	2018-10-29 00:00:00	2018-10-29	2018-10-29 00:00:00	2018-10-29	38000177		0	0	0		0	0	0	228576	0	309362	19075601		
42687	931	40213227	1992-08-07	1992-08-07 00:00:00	1992-08-07	1992-08-07 00:00:00	1992-08-07	581452		0	0	0		0	0	0	61962	0	113	40213227		
10922	911	1127433	1986-01-16	1986-01-16 00:00:00	1986-01-30	1986-01-30 00:00:00	1986-01-30	38000177		0	0	14		0	0	0	60490	0	313782	1127433		
31261	2591	1127433	2017-02-19	2017-02-19 00:00:00	2017-03-05	2017-03-05 00:00:00	2017-03-05	38000177		0	0	14		0	0	0	171430	0	313782	1127433		
9457	785	19059056	1968-10-12	1968-10-12 00:00:00	1968-10-26	1968-10-26 00:00:00	1968-10-26	38000177		0	0	14		0	0	0	52299	0	243670	19059056		
59744	4967	1124300	2003-11-10	2003-11-10 00:00:00	2003-11-10	2003-11-10 00:00:00	\N	38000177		0	0	0		0	0	0	330189	0	00781178901	45011828		
11251	936	1127433	2010-09-23	2010-09-23 00:00:00	2010-09-30	2010-09-30 00:00:00	2010-09-30	38000177		0	0	7		0	0	0	62288	0	313782	1127433		
76786	1677	40213227	2011-07-23	2011-07-23 00:00:00	2011-07-23	2011-07-23 00:00:00	2011-07-23	581452		0	0	0		0	0	0	112484	0	113	40213227		
39175	3237	19074841	1986-05-08	1986-05-08 00:00:00	1986-06-05	1986-06-05 00:00:00	1986-06-05	38000177		0	0	28		0	0	0	215154	0	309043	19074841		
4697	392	19133873	1985-12-11	1985-12-11 00:00:00	1985-12-19	1985-12-19 00:00:00	1985-12-19	38000177		0	0	8		0	0	0	25714	0	834061	19133873		
52309	4352	19059056	1949-02-24	1949-02-24 00:00:00	1949-03-10	1949-03-10 00:00:00	1949-03-10	38000177		0	0	14		0	0	0	288645	0	243670	19059056		
32626	711	40213201	2017-11-17	2017-11-17 00:00:00	2017-11-17	2017-11-17 00:00:00	2017-11-17	581452		0	0	0		0	0	0	47140	0	33	40213201		
1856	149	1127433	1947-01-21	1947-01-21 00:00:00	1947-01-28	1947-01-28 00:00:00	1947-01-28	38000177		0	0	7		0	0	0	10070	0	313782	1127433		
52606	4374	1713671	1993-09-12	1993-09-12 00:00:00	1993-10-03	1993-10-03 00:00:00	1993-10-03	38000177		0	0	21		0	0	0	290508	0	562251	1713671		
42825	3550	19075001	2005-08-12	2005-08-12 00:00:00	2005-09-09	2005-09-09 00:00:00	2005-09-09	38000177		0	0	28		0	0	0	235757	0	309097	19075001		
41323	3427	1127433	1973-12-27	1973-12-27 00:00:00	1974-01-03	1974-01-03 00:00:00	1974-01-03	38000177		0	0	7		0	0	0	227208	0	313782	1127433		
2923	236	19006318	1952-01-28	1952-01-28 00:00:00	1952-02-11	1952-02-11 00:00:00	1952-02-11	38000177		0	0	14		0	0	0	15853	0	105078	19006318		
24946	2051	1127433	2002-08-07	2002-08-07 00:00:00	2002-08-14	2002-08-14 00:00:00	2002-08-14	38000177		0	0	7		0	0	0	136352	0	313782	1127433		
4906	408	19128065	1981-05-03	1981-05-03 00:00:00	1982-04-28	1982-04-28 00:00:00	1982-04-28	38000177		0	0	360		0	0	0	26953	0	749882	19128065		
35526	2927	1124300	1982-07-03	1982-07-03 00:00:00	1982-07-03	1982-07-03 00:00:00	\N	38000177		0	0	0		0	0	0	195265	0	00781178901	45011828		
35490	2925	19059056	1963-10-22	1963-10-22 00:00:00	1963-11-04	1963-11-04 00:00:00	1963-11-04	38000177		0	0	13		0	0	0	195024	0	243670	19059056		
39363	3250	1127433	1986-08-15	1986-08-15 00:00:00	1986-08-22	1986-08-22 00:00:00	1986-08-22	38000177		0	0	7		0	0	0	216077	0	313782	1127433		
23230	1915	1713671	1980-06-21	1980-06-21 00:00:00	1980-07-12	1980-07-12 00:00:00	1980-07-12	38000177		0	0	21		0	0	0	127342	0	562251	1713671		
242573	5325	40213227	2017-03-05	2017-03-05 00:00:00	2017-03-05	2017-03-05 00:00:00	2017-03-05	581452		0	0	0		0	0	0	354490	0	113	40213227		
1749	38	40213296	2007-02-20	2007-02-20 00:00:00	2007-02-20	2007-02-20 00:00:00	2007-02-20	581452		0	0	0		0	0	0	2751	0	52	40213296		
35237	2905	1127433	2007-06-24	2007-06-24 00:00:00	2007-07-01	2007-07-01 00:00:00	2007-07-01	38000177		0	0	7		0	0	0	193600	0	313782	1127433		
138801	3049	40213160	1976-07-30	1976-07-30 00:00:00	1976-07-30	1976-07-30 00:00:00	1976-07-30	581452		0	0	0		0	0	0	202859	0	10	40213160		
32872	2724	40162522	2011-07-10	2011-07-10 00:00:00	2011-07-10	2011-07-10 00:00:00	\N	38000177		0	0	0		0	0	0	180436	0	857005	40162522		
50122	4159	40162522	1972-10-30	1972-10-30 00:00:00	1972-10-30	1972-10-30 00:00:00	\N	38000177		0	0	0		0	0	0	276384	0	857005	40162522		
8008	670	1713671	1994-11-03	1994-11-03 00:00:00	1994-11-24	1994-11-24 00:00:00	1994-11-24	38000177		0	0	21		0	0	0	44255	0	562251	1713671		
41475	3437	40229134	1980-05-19	1980-05-19 00:00:00	1980-06-02	1980-06-02 00:00:00	1980-06-02	38000177		0	0	14		0	0	0	227942	0	1043400	40229134		
36845	3047	1713671	1985-09-09	1985-09-09 00:00:00	1985-09-30	1985-09-30 00:00:00	1985-09-30	38000177		0	0	21		0	0	0	202720	0	562251	1713671		
55054	4571	19059056	1956-11-29	1956-11-29 00:00:00	1956-12-13	1956-12-13 00:00:00	1956-12-13	38000177		0	0	14		0	0	0	304595	0	243670	19059056		
115661	2541	40213227	1998-04-27	1998-04-27 00:00:00	1998-04-27	1998-04-27 00:00:00	1998-04-27	581452		0	0	0		0	0	0	168027	0	113	40213227		
6316	137	40213160	1971-12-08	1971-12-08 00:00:00	1971-12-08	1971-12-08 00:00:00	1971-12-08	581452		0	0	0		0	0	0	9236	0	10	40213160		
84794	1854	40213227	2002-01-15	2002-01-15 00:00:00	2002-01-15	2002-01-15 00:00:00	2002-01-15	581452		0	0	0		0	0	0	124108	0	113	40213227		
48026	3982	40236824	1968-11-29	1968-11-29 00:00:00	1968-12-06	1968-12-06 00:00:00	1968-12-06	38000177		0	0	7		0	0	0	264751	0	1094107	40236824		
145808	3207	40213227	2009-12-17	2009-12-17 00:00:00	2009-12-17	2009-12-17 00:00:00	2009-12-17	581452		0	0	0		0	0	0	213163	0	113	40213227		
25858	2127	19129655	1962-11-22	1962-11-22 00:00:00	1962-12-06	1962-12-06 00:00:00	1962-12-06	38000177		0	0	14		0	0	0	141457	0	789980	19129655		
29380	2433	19075601	2014-03-16	2014-03-16 00:00:00	2014-03-16	2014-03-16 00:00:00	\N	38000177		0	0	0		0	0	0	161315	0	309362	19075601		
14814	1239	19133873	1983-06-03	1983-06-03 00:00:00	1983-06-12	1983-06-12 00:00:00	1983-06-12	38000177		0	0	9		0	0	0	81640	0	834061	19133873		
44010	3644	19059056	1948-11-12	1948-11-12 00:00:00	1948-11-26	1948-11-26 00:00:00	1948-11-26	38000177		0	0	14		0	0	0	242495	0	243670	19059056		
130743	2872	40213160	1956-02-14	1956-02-14 00:00:00	1956-02-14	1956-02-14 00:00:00	1956-02-14	581452		0	0	0		0	0	0	191197	0	10	40213160		
28201	2332	1127433	1978-07-29	1978-07-29 00:00:00	1978-08-19	1978-08-19 00:00:00	1978-08-19	38000177		0	0	21		0	0	0	155124	0	313782	1127433		
2266	183	46233988	1978-08-04	1978-08-04 00:00:00	1978-08-18	1978-08-18 00:00:00	1978-08-18	38000177		0	0	14		0	0	0	12393	0	1652673	46233988		
8625	719	40236824	2010-02-06	2010-02-06 00:00:00	2010-02-13	2010-02-13 00:00:00	2010-02-13	38000177		0	0	7		0	0	0	47570	0	1094107	40236824		
22487	1848	40236824	1975-10-07	1975-10-07 00:00:00	1975-10-14	1975-10-14 00:00:00	1975-10-14	38000177		0	0	7		0	0	0	123684	0	1094107	40236824		
37203	3076	19078461	1993-05-23	1993-05-23 00:00:00	1993-06-27	1993-06-27 00:00:00	1993-06-27	38000177		0	0	35		0	0	0	204644	0	310965	19078461		
73828	1611	40213227	2013-08-11	2013-08-11 00:00:00	2013-08-11	2013-08-11 00:00:00	2013-08-11	581452		0	0	0		0	0	0	108286	0	113	40213227		
148917	3275	40213227	1993-04-10	1993-04-10 00:00:00	1993-04-10	1993-04-10 00:00:00	1993-04-10	581452		0	0	0		0	0	0	217588	0	113	40213227		
13391	1123	19078461	2015-02-25	2015-02-25 00:00:00	2015-03-18	2015-03-18 00:00:00	2015-03-18	38000177		0	0	21		0	0	0	73969	0	310965	19078461		
209549	4595	40213160	1962-12-20	1962-12-20 00:00:00	1962-12-20	1962-12-20 00:00:00	1962-12-20	581452		0	0	0		0	0	0	306159	0	10	40213160		
85305	1867	40213306	1994-05-24	1994-05-24 00:00:00	1994-05-24	1994-05-24 00:00:00	1994-05-24	581452		0	0	0		0	0	0	124722	0	43	40213306		
60016	4988	1127433	1977-12-23	1977-12-23 00:00:00	1978-01-27	1978-01-27 00:00:00	1978-01-27	38000177		0	0	35		0	0	0	331795	0	313782	1127433		
956	78	1127433	2009-04-14	2009-04-14 00:00:00	2009-04-21	2009-04-21 00:00:00	2009-04-21	38000177		0	0	7		0	0	0	5193	0	313782	1127433		
23803	1958	1127433	2008-03-10	2008-03-10 00:00:00	2008-03-17	2008-03-17 00:00:00	2008-03-17	38000177		0	0	7		0	0	0	130259	0	313782	1127433		
179014	3936	40213306	1981-01-26	1981-01-26 00:00:00	1981-01-26	1981-01-26 00:00:00	1981-01-26	581452		0	0	0		0	0	0	261602	0	43	40213306		
158512	3489	40213160	1973-04-07	1973-04-07 00:00:00	1973-04-07	1973-04-07 00:00:00	1973-04-07	581452		0	0	0		0	0	0	231467	0	10	40213160		
34658	2862	1127433	2008-10-08	2008-10-08 00:00:00	2008-10-15	2008-10-15 00:00:00	2008-10-15	38000177		0	0	7		0	0	0	190271	0	313782	1127433		
45154	3736	1127078	1954-03-05	1954-03-05 00:00:00	1954-03-19	1954-03-19 00:00:00	1954-03-19	38000177		0	0	14		0	0	0	248331	0	282464	1127078		
37667	3115	40236824	2006-02-24	2006-02-24 00:00:00	2006-03-03	2006-03-03 00:00:00	2006-03-03	38000177		0	0	7		0	0	0	207259	0	1094107	40236824		
24414	2007	19019979	1991-11-25	1991-11-25 00:00:00	1991-12-09	1991-12-09 00:00:00	1991-12-09	38000177		0	0	14		0	0	0	133682	0	198405	19019979		
24460	2012	1118084	1994-04-13	1994-04-13 00:00:00	1994-04-13	1994-04-13 00:00:00	\N	38000177		0	0	0		0	0	0	133857	0	00025152531	44923712		
20586	1695	19078461	2000-06-29	2000-06-29 00:00:00	2000-08-03	2000-08-03 00:00:00	2000-08-03	38000177		0	0	35		0	0	0	113482	0	310965	19078461		
41610	3444	1124300	1970-12-12	1970-12-12 00:00:00	1970-12-12	1970-12-12 00:00:00	\N	38000177		0	0	0		0	0	0	228554	0	00781178901	45011828		
42691	931	40213227	2002-09-27	2002-09-27 00:00:00	2002-09-27	2002-09-27 00:00:00	2002-09-27	581452		0	0	0		0	0	0	61988	0	113	40213227		
10923	911	40232448	1977-06-15	1977-06-15 00:00:00	1977-06-15	1977-06-15 00:00:00	\N	38000177		0	0	0		0	0	0	60471	0	1049630	40232448		
31262	2591	19059056	1943-06-14	1943-06-14 00:00:00	1943-07-05	1943-07-05 00:00:00	1943-07-05	38000177		0	0	21		0	0	0	171449	0	243670	19059056		
9458	785	19128065	1977-12-04	1977-12-04 00:00:00	1978-11-29	1978-11-29 00:00:00	1978-11-29	38000177		0	0	360		0	0	0	52264	0	749882	19128065		
59745	4967	1127433	2014-11-19	2014-11-19 00:00:00	2014-11-26	2014-11-26 00:00:00	2014-11-26	38000177		0	0	7		0	0	0	330139	0	313782	1127433		
11252	936	1127433	1992-03-12	1992-03-12 00:00:00	1992-03-19	1992-03-19 00:00:00	1992-03-19	38000177		0	0	7		0	0	0	62287	0	313782	1127433		
76787	1677	40213296	2011-07-23	2011-07-23 00:00:00	2011-07-23	2011-07-23 00:00:00	2011-07-23	581452		0	0	0		0	0	0	112484	0	52	40213296		
39176	3237	40231925	1986-05-08	1986-05-08 00:00:00	1986-05-08	1986-05-08 00:00:00	\N	38000177		0	0	0		0	0	0	215154	0	1049221	40231925		
4698	392	1713671	1989-01-01	1989-01-01 00:00:00	1989-01-22	1989-01-22 00:00:00	1989-01-22	38000177		0	0	21		0	0	0	25739	0	562251	1713671		
52310	4352	19059056	1949-08-05	1949-08-05 00:00:00	1949-08-19	1949-08-19 00:00:00	1949-08-19	38000177		0	0	14		0	0	0	288659	0	243670	19059056		
32636	711	40213198	2016-11-11	2016-11-11 00:00:00	2016-11-11	2016-11-11 00:00:00	2016-11-11	581452		0	0	0		0	0	0	47172	0	133	40213198		
1857	149	19059056	1958-07-21	1958-07-21 00:00:00	1958-08-11	1958-08-11 00:00:00	1958-08-11	38000177		0	0	21		0	0	0	10103	0	243670	19059056		
52607	4374	1127433	2000-07-27	2000-07-27 00:00:00	2000-08-10	2000-08-10 00:00:00	2000-08-10	38000177		0	0	14		0	0	0	290509	0	313782	1127433		
42826	3550	1127433	1991-07-17	1991-07-17 00:00:00	1991-07-24	1991-07-24 00:00:00	1991-07-24	38000177		0	0	7		0	0	0	235713	0	313782	1127433		
41324	3427	19059056	1970-06-09	1970-06-09 00:00:00	1970-06-23	1970-06-23 00:00:00	1970-06-23	38000177		0	0	14		0	0	0	227179	0	243670	19059056		
2924	236	1127078	1952-01-28	1952-01-28 00:00:00	1952-02-11	1952-02-11 00:00:00	1952-02-11	38000177		0	0	14		0	0	0	15853	0	282464	1127078		
24947	2051	1127433	1969-03-18	1969-03-18 00:00:00	1969-04-01	1969-04-01 00:00:00	1969-04-01	38000177		0	0	14		0	0	0	136365	0	313782	1127433		
4907	409	19078461	1980-10-28	1980-10-28 00:00:00	1981-01-26	1981-01-26 00:00:00	1981-01-26	38000177		0	0	90		0	0	0	27151	0	310965	19078461		
35527	2927	19078461	2013-10-27	2013-10-27 00:00:00	2013-11-10	2013-11-10 00:00:00	2013-11-10	38000177		0	0	14		0	0	0	195301	0	310965	19078461		
35491	2925	1127433	1980-09-06	1980-09-06 00:00:00	1980-09-20	1980-09-20 00:00:00	1980-09-20	38000177		0	0	14		0	0	0	195012	0	313782	1127433		
39364	3250	1713671	1981-07-30	1981-07-30 00:00:00	1981-08-20	1981-08-20 00:00:00	1981-08-20	38000177		0	0	21		0	0	0	216040	0	562251	1713671		
23231	1915	19059056	1985-03-07	1985-03-07 00:00:00	1985-03-21	1985-03-21 00:00:00	1985-03-21	38000177		0	0	14		0	0	0	127416	0	243670	19059056		
242589	5325	40213198	2011-01-30	2011-01-30 00:00:00	2011-01-30	2011-01-30 00:00:00	2011-01-30	581452		0	0	0		0	0	0	354478	0	133	40213198		
1756	38	40213260	2015-02-10	2015-02-10 00:00:00	2015-02-10	2015-02-10 00:00:00	2015-02-10	581452		0	0	0		0	0	0	2706	0	121	40213260		
35238	2905	19078461	2014-05-04	2014-05-04 00:00:00	2014-05-18	2014-05-18 00:00:00	2014-05-18	38000177		0	0	14		0	0	0	193552	0	310965	19078461		
236267	5189	40213227	2006-05-28	2006-05-28 00:00:00	2006-05-28	2006-05-28 00:00:00	2006-05-28	581452		0	0	0		0	0	0	344957	0	113	40213227		
32873	2724	19073188	2011-07-10	2011-07-10 00:00:00	2011-07-24	2011-07-24 00:00:00	2011-07-24	38000177		0	0	14		0	0	0	180436	0	308192	19073188		
50123	4159	40236824	2017-05-31	2017-05-31 00:00:00	2017-06-07	2017-06-07 00:00:00	2017-06-07	38000177		0	0	7		0	0	0	276334	0	1094107	40236824		
8009	670	1127433	1984-10-02	1984-10-02 00:00:00	1984-10-09	1984-10-09 00:00:00	1984-10-09	38000177		0	0	7		0	0	0	44222	0	313782	1127433		
41476	3437	19059056	1921-03-09	1921-03-09 00:00:00	1921-05-08	1921-05-08 00:00:00	1921-05-08	38000177		0	0	60		0	0	0	228019	0	243670	19059056		
36846	3047	19078461	1989-04-28	1989-04-28 00:00:00	1989-05-26	1989-05-26 00:00:00	1989-05-26	38000177		0	0	28		0	0	0	202741	0	310965	19078461		
55055	4571	19006318	1956-11-29	1956-11-29 00:00:00	1956-12-13	1956-12-13 00:00:00	1956-12-13	38000177		0	0	14		0	0	0	304595	0	105078	19006318		
115662	2541	40213306	1998-04-27	1998-04-27 00:00:00	1998-04-27	1998-04-27 00:00:00	1998-04-27	581452		0	0	0		0	0	0	168027	0	43	40213306		
6321	137	40213160	1971-10-06	1971-10-06 00:00:00	1971-10-06	1971-10-06 00:00:00	1971-10-06	581452		0	0	0		0	0	0	9151	0	10	40213160		
84795	1854	40213227	2012-11-13	2012-11-13 00:00:00	2012-11-13	2012-11-13 00:00:00	2012-11-13	581452		0	0	0		0	0	0	124110	0	113	40213227		
48027	3982	920300	1968-11-29	1968-11-29 00:00:00	1968-12-06	1968-12-06 00:00:00	1968-12-06	38000177		0	0	7		0	0	0	264751	0	311989	920300		
145809	3207	40213260	2009-12-17	2009-12-17 00:00:00	2009-12-17	2009-12-17 00:00:00	2009-12-17	581452		0	0	0		0	0	0	213163	0	121	40213260		
25859	2127	920300	1978-09-29	1978-09-29 00:00:00	1978-10-06	1978-10-06 00:00:00	1978-10-06	38000177		0	0	7		0	0	0	141489	0	311989	920300		
29381	2433	1332419	2014-03-16	2014-03-16 00:00:00	2014-03-16	2014-03-16 00:00:00	\N	38000177		0	0	0		0	0	0	161315	0	197361	1332419		
14815	1239	19133873	1987-10-23	1987-10-23 00:00:00	1987-11-02	1987-11-02 00:00:00	1987-11-02	38000177		0	0	10		0	0	0	81669	0	834061	19133873		
44011	3644	1127433	1956-08-03	1956-08-03 00:00:00	1956-08-17	1956-08-17 00:00:00	1956-08-17	38000177		0	0	14		0	0	0	242503	0	313782	1127433		
14891	1246	1118084	1980-08-23	1980-08-23 00:00:00	1980-08-23	1980-08-23 00:00:00	\N	38000177		0	0	0		0	0	0	82146	0	00025152531	44923712		
28202	2332	40229134	1960-06-13	1960-06-13 00:00:00	1960-06-20	1960-06-20 00:00:00	1960-06-20	38000177		0	0	7		0	0	0	155102	0	1043400	40229134		
2267	183	19133905	1996-11-26	1996-11-26 00:00:00	1996-12-07	1996-12-07 00:00:00	1996-12-07	38000177		0	0	11		0	0	0	12338	0	834102	19133905		
8626	720	19128065	1979-08-21	1979-08-21 00:00:00	1980-08-15	1980-08-15 00:00:00	1980-08-15	38000177		0	0	360		0	0	0	47678	0	749882	19128065		
22488	1848	920300	1975-10-07	1975-10-07 00:00:00	1975-10-14	1975-10-14 00:00:00	1975-10-14	38000177		0	0	7		0	0	0	123684	0	311989	920300		
37204	3076	19059056	1967-07-27	1967-07-27 00:00:00	1967-08-26	1967-08-26 00:00:00	1967-08-26	38000177		0	0	30		0	0	0	204641	0	243670	19059056		
73834	1611	40213296	1996-09-29	1996-09-29 00:00:00	1996-09-29	1996-09-29 00:00:00	1996-09-29	581452		0	0	0		0	0	0	108336	0	52	40213296		
148926	3275	40213260	2010-04-10	2010-04-10 00:00:00	2010-04-10	2010-04-10 00:00:00	2010-04-10	581452		0	0	0		0	0	0	217599	0	121	40213260		
13392	1123	1127078	1970-01-26	1970-01-26 00:00:00	1970-02-09	1970-02-09 00:00:00	1970-02-09	38000177		0	0	14		0	0	0	74016	0	282464	1127078		
209551	4595	40213160	1962-10-19	1962-10-19 00:00:00	1962-10-19	1962-10-19 00:00:00	1962-10-19	581452		0	0	0		0	0	0	306190	0	10	40213160		
85308	1867	40213314	1977-03-01	1977-03-01 00:00:00	1977-03-01	1977-03-01 00:00:00	1977-03-01	581452		0	0	0		0	0	0	124701	0	49	40213314		
60017	4988	920300	1983-05-27	1983-05-27 00:00:00	1983-06-03	1983-06-03 00:00:00	1983-06-03	38000177		0	0	7		0	0	0	331874	0	311989	920300		
958	79	1127433	1990-08-05	1990-08-05 00:00:00	1990-08-12	1990-08-12 00:00:00	1990-08-12	38000177		0	0	7		0	0	0	5260	0	313782	1127433		
23804	1958	19073188	1996-02-25	1996-02-25 00:00:00	1996-03-10	1996-03-10 00:00:00	1996-03-10	38000177		0	0	14		0	0	0	130262	0	308192	19073188		
179015	3936	40213160	1958-08-18	1958-08-18 00:00:00	1958-08-18	1958-08-18 00:00:00	1958-08-18	581452		0	0	0		0	0	0	261624	0	10	40213160		
158513	3489	40213296	2014-11-08	2014-11-08 00:00:00	2014-11-08	2014-11-08 00:00:00	2014-11-08	581452		0	0	0		0	0	0	231440	0	52	40213296		
34659	2862	19059056	1974-12-16	1974-12-16 00:00:00	1975-01-20	1975-01-20 00:00:00	1975-01-20	38000177		0	0	35		0	0	0	190260	0	243670	19059056		
45155	3736	19006318	1954-03-05	1954-03-05 00:00:00	1954-03-19	1954-03-19 00:00:00	1954-03-19	38000177		0	0	14		0	0	0	248331	0	105078	19006318		
37668	3115	920300	2006-02-24	2006-02-24 00:00:00	2006-03-03	2006-03-03 00:00:00	2006-03-03	38000177		0	0	7		0	0	0	207259	0	311989	920300		
24415	2007	19073183	1991-11-25	1991-11-25 00:00:00	1991-12-09	1991-12-09 00:00:00	1991-12-09	38000177		0	0	14		0	0	0	133682	0	308182	19073183		
24461	2012	1127433	1983-03-08	1983-03-08 00:00:00	1983-06-06	1983-06-06 00:00:00	1983-06-06	38000177		0	0	90		0	0	0	133866	0	313782	1127433		
20587	1695	1127433	2016-11-02	2016-11-02 00:00:00	2016-11-16	2016-11-16 00:00:00	2016-11-16	38000177		0	0	14		0	0	0	113491	0	313782	1127433		
41611	3444	19133905	1989-09-28	1989-09-28 00:00:00	1989-10-05	1989-10-05 00:00:00	1989-10-05	38000177		0	0	7		0	0	0	228567	0	834102	19133905		
42692	931	40213296	2002-09-27	2002-09-27 00:00:00	2002-09-27	2002-09-27 00:00:00	2002-09-27	581452		0	0	0		0	0	0	61988	0	52	40213296		
10924	911	46233988	1976-04-06	1976-04-06 00:00:00	1976-04-20	1976-04-20 00:00:00	1976-04-20	38000177		0	0	14		0	0	0	60470	0	1652673	46233988		
31263	2591	1118084	1974-08-20	1974-08-20 00:00:00	1974-08-20	1974-08-20 00:00:00	\N	38000177		0	0	0		0	0	0	171507	0	00025152531	44923712		
52221	4343	1127433	1978-10-03	1978-10-03 00:00:00	1978-10-24	1978-10-24 00:00:00	1978-10-24	38000177		0	0	21		0	0	0	288079	0	313782	1127433		
54159	1185	40213227	2008-03-09	2008-03-09 00:00:00	2008-03-09	2008-03-09 00:00:00	2008-03-09	581452		0	0	0		0	0	0	78153	0	113	40213227		
11253	936	1127433	1988-03-03	1988-03-03 00:00:00	1988-03-17	1988-03-17 00:00:00	1988-03-17	38000177		0	0	14		0	0	0	62263	0	313782	1127433		
76790	1677	40213296	2009-07-18	2009-07-18 00:00:00	2009-07-18	2009-07-18 00:00:00	2009-07-18	581452		0	0	0		0	0	0	112509	0	52	40213296		
49635	4116	1118084	2012-06-23	2012-06-23 00:00:00	2012-06-23	2012-06-23 00:00:00	\N	38000177		0	0	0		0	0	0	273636	0	00025152531	44923712		
4699	392	1713671	2015-10-22	2015-10-22 00:00:00	2015-11-05	2015-11-05 00:00:00	2015-11-05	38000177		0	0	14		0	0	0	25753	0	562251	1713671		
52311	4352	19006318	1949-08-05	1949-08-05 00:00:00	1949-08-19	1949-08-19 00:00:00	1949-08-19	38000177		0	0	14		0	0	0	288659	0	105078	19006318		
32646	712	40213314	1977-10-13	1977-10-13 00:00:00	1977-10-13	1977-10-13 00:00:00	1977-10-13	581452		0	0	0		0	0	0	47251	0	49	40213314		
1858	149	19133905	1971-07-10	1971-07-10 00:00:00	1971-07-17	1971-07-17 00:00:00	1971-07-17	38000177		0	0	7		0	0	0	10048	0	834102	19133905		
52608	4374	19112599	1979-06-10	1979-06-10 00:00:00	1979-06-10	1979-06-10 00:00:00	\N	38000177		0	0	0		0	0	0	290447	0	477045	19112599		
42827	3550	1118084	2016-11-05	2016-11-05 00:00:00	2016-11-05	2016-11-05 00:00:00	\N	38000177		0	0	0		0	0	0	235719	0	00025152531	44923712		
41325	3427	1127433	1993-08-15	1993-08-15 00:00:00	1993-08-29	1993-08-29 00:00:00	1993-08-29	38000177		0	0	14		0	0	0	227177	0	313782	1127433		
2926	236	1127078	1951-09-18	1951-09-18 00:00:00	1951-10-02	1951-10-02 00:00:00	1951-10-02	38000177		0	0	14		0	0	0	15919	0	282464	1127078		
24948	2052	46275916	2015-10-19	2015-10-19 00:00:00	2015-10-19	2015-10-19 00:00:00	2015-10-19	38000177		0	0	0		0	0	0	136411	0	1660014	46275916		
4908	409	1713671	1997-03-09	1997-03-09 00:00:00	1997-03-23	1997-03-23 00:00:00	1997-03-23	38000177		0	0	14		0	0	0	27010	0	562251	1713671		
35528	2927	1127433	1962-07-20	1962-07-20 00:00:00	1962-07-27	1962-07-27 00:00:00	1962-07-27	38000177		0	0	7		0	0	0	195209	0	313782	1127433		
35492	2925	19073188	1980-09-06	1980-09-06 00:00:00	1980-09-20	1980-09-20 00:00:00	1980-09-20	38000177		0	0	14		0	0	0	195012	0	308192	19073188		
39365	3250	1118084	2002-08-16	2002-08-16 00:00:00	2002-08-16	2002-08-16 00:00:00	\N	38000177		0	0	0		0	0	0	216053	0	00025152531	44923712		
23232	1915	1713671	2012-07-22	2012-07-22 00:00:00	2012-08-05	2012-08-05 00:00:00	2012-08-05	38000177		0	0	14		0	0	0	127392	0	562251	1713671		
18967	1567	1127433	1989-07-07	1989-07-07 00:00:00	1989-07-14	1989-07-14 00:00:00	1989-07-14	38000177		0	0	7		0	0	0	105112	0	313782	1127433		
47204	3916	1127433	1997-06-17	1997-06-17 00:00:00	1997-07-24	1997-07-24 00:00:00	1997-07-24	38000177		0	0	37		0	0	0	260435	0	313782	1127433		
35239	2906	19077572	2009-06-13	2009-06-13 00:00:00	2009-06-13	2009-06-13 00:00:00	\N	38000177		0	0	0		0	0	0	193664	0	310436	19077572		
236268	5189	40213260	2006-05-28	2006-05-28 00:00:00	2006-05-28	2006-05-28 00:00:00	2006-05-28	581452		0	0	0		0	0	0	344957	0	121	40213260		
32874	2724	19133873	1957-01-24	1957-01-24 00:00:00	1957-02-01	1957-02-01 00:00:00	1957-02-01	38000177		0	0	8		0	0	0	180491	0	834061	19133873		
50124	4159	920300	2017-05-31	2017-05-31 00:00:00	2017-06-07	2017-06-07 00:00:00	2017-06-07	38000177		0	0	7		0	0	0	276334	0	311989	920300		
8010	670	1127078	1978-05-11	1978-05-11 00:00:00	1978-08-09	1978-08-09 00:00:00	1978-08-09	38000177		0	0	90		0	0	0	44252	0	282464	1127078		
41477	3437	920300	1946-05-16	1946-05-16 00:00:00	1946-05-23	1946-05-23 00:00:00	1946-05-23	38000177		0	0	7		0	0	0	227985	0	311989	920300		
36847	3047	40229134	1993-09-28	1993-09-28 00:00:00	1993-10-05	1993-10-05 00:00:00	1993-10-05	38000177		0	0	7		0	0	0	202753	0	1043400	40229134		
55056	4571	1713671	2010-07-07	2010-07-07 00:00:00	2010-07-28	2010-07-28 00:00:00	2010-07-28	38000177		0	0	21		0	0	0	304561	0	562251	1713671		
115665	2541	40213160	1976-01-05	1976-01-05 00:00:00	1976-01-05	1976-01-05 00:00:00	1976-01-05	581452		0	0	0		0	0	0	168065	0	10	40213160		
67623	1478	40213296	2003-04-01	2003-04-01 00:00:00	2003-04-01	2003-04-01 00:00:00	2003-04-01	581452		0	0	0		0	0	0	98588	0	52	40213296		
84796	1854	40213296	2012-11-13	2012-11-13 00:00:00	2012-11-13	2012-11-13 00:00:00	2012-11-13	581452		0	0	0		0	0	0	124110	0	52	40213296		
48034	3984	1127433	1961-03-19	1961-03-19 00:00:00	1961-03-26	1961-03-26 00:00:00	1961-03-26	38000177		0	0	7		0	0	0	264805	0	313782	1127433		
145812	3207	40213296	1998-12-17	1998-12-17 00:00:00	1998-12-17	1998-12-17 00:00:00	1998-12-17	581452		0	0	0		0	0	0	213141	0	52	40213296		
25860	2127	40236824	1978-09-29	1978-09-29 00:00:00	1978-10-06	1978-10-06 00:00:00	1978-10-06	38000177		0	0	7		0	0	0	141489	0	1094107	40236824		
29382	2433	19126352	2014-03-16	2014-03-16 00:00:00	2014-03-16	2014-03-16 00:00:00	\N	38000177		0	0	0		0	0	0	161315	0	705129	19126352		
14816	1239	19128022	1989-05-26	1989-05-26 00:00:00	1990-05-21	1990-05-21 00:00:00	1990-05-21	38000177		0	0	360		0	0	0	81644	0	749785	19128022		
44012	3644	1713671	1962-04-08	1962-04-08 00:00:00	1962-04-22	1962-04-22 00:00:00	1962-04-22	38000177		0	0	14		0	0	0	242463	0	562251	1713671		
14892	1246	1127433	1985-11-30	1985-11-30 00:00:00	1985-12-14	1985-12-14 00:00:00	1985-12-14	38000177		0	0	14		0	0	0	82115	0	313782	1127433		
28203	2332	19133873	1963-09-01	1963-09-01 00:00:00	1963-09-10	1963-09-10 00:00:00	1963-09-10	38000177		0	0	9		0	0	0	155048	0	834061	19133873		
2268	183	1127433	1983-01-26	1983-01-26 00:00:00	1983-02-09	1983-02-09 00:00:00	1983-02-09	38000177		0	0	14		0	0	0	12373	0	313782	1127433		
8627	720	1118084	2000-09-04	2000-09-04 00:00:00	2000-09-04	2000-09-04 00:00:00	\N	38000177		0	0	0		0	0	0	47649	0	00025152531	44923712		
22489	1848	1127433	1978-07-07	1978-07-07 00:00:00	1978-07-21	1978-07-21 00:00:00	1978-07-21	38000177		0	0	14		0	0	0	123670	0	313782	1127433		
37205	3076	1115171	2012-11-24	2012-11-24 00:00:00	2012-12-15	2012-12-15 00:00:00	2012-12-15	38000177		0	0	21		0	0	0	204648	0	849574	1115171		
73847	1611	40213227	2003-06-15	2003-06-15 00:00:00	2003-06-15	2003-06-15 00:00:00	2003-06-15	581452		0	0	0		0	0	0	108282	0	113	40213227		
148928	3275	40213160	1960-12-17	1960-12-17 00:00:00	1960-12-17	1960-12-17 00:00:00	1960-12-17	581452		0	0	0		0	0	0	217651	0	10	40213160		
13393	1123	46233988	1970-01-26	1970-01-26 00:00:00	1970-02-09	1970-02-09 00:00:00	1970-02-09	38000177		0	0	14		0	0	0	74016	0	1652673	46233988		
209562	4595	40213227	1994-04-22	1994-04-22 00:00:00	1994-04-22	1994-04-22 00:00:00	1994-04-22	581452		0	0	0		0	0	0	306213	0	113	40213227		
85310	1867	40213160	1977-03-01	1977-03-01 00:00:00	1977-03-01	1977-03-01 00:00:00	1977-03-01	581452		0	0	0		0	0	0	124701	0	10	40213160		
60018	4988	40236824	1983-05-27	1983-05-27 00:00:00	1983-06-03	1983-06-03 00:00:00	1983-06-03	38000177		0	0	7		0	0	0	331874	0	1094107	40236824		
959	79	1154615	1949-05-02	1949-05-02 00:00:00	1949-05-02	1949-05-02 00:00:00	\N	38000177		0	0	0		0	0	0	5251	0	745679	1154615		
23805	1958	1115171	1996-02-25	1996-02-25 00:00:00	1996-03-10	1996-03-10 00:00:00	1996-03-10	38000177		0	0	14		0	0	0	130262	0	849574	1115171		
179019	3936	40213160	1958-11-17	1958-11-17 00:00:00	1958-11-17	1958-11-17 00:00:00	1958-11-17	581452		0	0	0		0	0	0	261611	0	10	40213160		
158515	3489	40213227	2014-11-08	2014-11-08 00:00:00	2014-11-08	2014-11-08 00:00:00	2014-11-08	581452		0	0	0		0	0	0	231440	0	113	40213227		
34660	2862	1713671	2010-05-16	2010-05-16 00:00:00	2010-05-30	2010-05-30 00:00:00	2010-05-30	38000177		0	0	14		0	0	0	190312	0	562251	1713671		
45156	3736	1118084	1987-07-20	1987-07-20 00:00:00	1987-07-20	1987-07-20 00:00:00	\N	38000177		0	0	0		0	0	0	248260	0	00025152531	44923712		
16735	1385	19133873	1970-07-21	1970-07-21 00:00:00	1970-07-31	1970-07-31 00:00:00	1970-07-31	38000177		0	0	10		0	0	0	91864	0	834061	19133873		
24416	2007	1127433	2015-01-14	2015-01-14 00:00:00	2015-01-28	2015-01-28 00:00:00	2015-01-28	38000177		0	0	14		0	0	0	133668	0	313782	1127433		
24462	2012	40229134	2014-02-23	2014-02-23 00:00:00	2014-03-02	2014-03-02 00:00:00	2014-03-02	38000177		0	0	7		0	0	0	133846	0	1043400	40229134		
20588	1695	1127433	2003-06-19	2003-06-19 00:00:00	2003-07-26	2003-07-26 00:00:00	2003-07-26	38000177		0	0	37		0	0	0	113483	0	313782	1127433		
41613	3444	19059056	1941-02-04	1941-02-04 00:00:00	1941-02-18	1941-02-18 00:00:00	1941-02-18	38000177		0	0	14		0	0	0	228581	0	243670	19059056		
42698	931	40213160	1960-12-23	1960-12-23 00:00:00	1960-12-23	1960-12-23 00:00:00	1960-12-23	581452		0	0	0		0	0	0	61983	0	10	40213160		
10925	911	19019979	1976-04-06	1976-04-06 00:00:00	1976-04-20	1976-04-20 00:00:00	1976-04-20	38000177		0	0	14		0	0	0	60470	0	198405	19019979		
79712	1744	40213296	2018-09-14	2018-09-14 00:00:00	2018-09-14	2018-09-14 00:00:00	2018-09-14	581452		0	0	0		0	0	0	116607	0	52	40213296		
52222	4343	1127433	1955-07-17	1955-07-17 00:00:00	1955-07-31	1955-07-31 00:00:00	1955-07-31	38000177		0	0	14		0	0	0	287987	0	313782	1127433		
65741	1438	40213201	2018-05-11	2018-05-11 00:00:00	2018-05-11	2018-05-11 00:00:00	2018-05-11	581452		0	0	0		0	0	0	95836	0	33	40213201		
11254	936	19059056	1971-10-01	1971-10-01 00:00:00	1971-10-29	1971-10-29 00:00:00	1971-10-29	38000177		0	0	28		0	0	0	62262	0	243670	19059056		
76791	1677	40213160	1969-12-20	1969-12-20 00:00:00	1969-12-20	1969-12-20 00:00:00	1969-12-20	581452		0	0	0		0	0	0	112493	0	10	40213160		
49636	4116	19128065	1984-10-03	1984-10-03 00:00:00	1985-09-28	1985-09-28 00:00:00	1985-09-28	38000177		0	0	360		0	0	0	273640	0	749882	19128065		
4700	392	1118084	2012-03-16	2012-03-16 00:00:00	2012-03-16	2012-03-16 00:00:00	\N	38000177		0	0	0		0	0	0	25750	0	00025152531	44923712		
52312	4352	1127433	2015-08-07	2015-08-07 00:00:00	2015-08-28	2015-08-28 00:00:00	2015-08-28	38000177		0	0	21		0	0	0	288671	0	313782	1127433		
32652	712	40213314	1978-04-13	1978-04-13 00:00:00	1978-04-13	1978-04-13 00:00:00	1978-04-13	581452		0	0	0		0	0	0	47212	0	49	40213314		
1859	149	1127433	1960-02-21	1960-02-21 00:00:00	1960-03-06	1960-03-06 00:00:00	1960-03-06	38000177		0	0	14		0	0	0	10029	0	313782	1127433		
52609	4374	40224805	1992-05-06	1992-05-06 00:00:00	1993-05-01	1993-05-01 00:00:00	1993-05-01	38000177		0	0	360		0	0	0	290569	0	1000126	40224805		
42828	3550	1127078	1985-07-16	1985-07-16 00:00:00	1985-07-30	1985-07-30 00:00:00	1985-07-30	38000177		0	0	14		0	0	0	235755	0	282464	1127078		
41326	3427	19059056	1967-01-01	1967-01-01 00:00:00	1967-01-15	1967-01-15 00:00:00	1967-01-15	38000177		0	0	14		0	0	0	227214	0	243670	19059056		
2927	236	1127433	1987-03-13	1987-03-13 00:00:00	1987-03-27	1987-03-27 00:00:00	1987-03-27	38000177		0	0	14		0	0	0	15916	0	313782	1127433		
24949	2052	1310034	2015-10-19	2015-10-19 00:00:00	2015-10-19	2015-10-19 00:00:00	2015-10-19	38000177		0	0	0		0	0	0	136411	0	834357	1310034		
4909	409	19133905	1968-12-03	1968-12-03 00:00:00	1968-12-15	1968-12-15 00:00:00	1968-12-15	38000177		0	0	12		0	0	0	27071	0	834102	19133905		
35529	2927	1127433	1950-05-06	1950-05-06 00:00:00	1950-05-20	1950-05-20 00:00:00	1950-05-20	38000177		0	0	14		0	0	0	195258	0	313782	1127433		
35493	2925	1127433	2001-04-25	2001-04-25 00:00:00	2001-05-09	2001-05-09 00:00:00	2001-05-09	38000177		0	0	14		0	0	0	195010	0	313782	1127433		
16291	351	40213314	1978-05-09	1978-05-09 00:00:00	1978-05-09	1978-05-09 00:00:00	1978-05-09	581452		0	0	0		0	0	0	23374	0	49	40213314		
23233	1915	1127433	2002-11-29	2002-11-29 00:00:00	2002-12-06	2002-12-06 00:00:00	2002-12-06	38000177		0	0	7		0	0	0	127380	0	313782	1127433		
18968	1567	1551192	2002-09-06	2002-09-06 00:00:00	2002-09-06	2002-09-06 00:00:00	2002-09-06	38000177		0	0	0		0	0	0	105107	0	312617	1551192		
47205	3916	1118084	2016-05-07	2016-05-07 00:00:00	2016-05-07	2016-05-07 00:00:00	\N	38000177		0	0	0		0	0	0	260308	0	00025152531	44923712		
35240	2906	19059056	1934-08-25	1934-08-25 00:00:00	1934-10-24	1934-10-24 00:00:00	1934-10-24	38000177		0	0	60		0	0	0	193718	0	243670	19059056		
236272	5189	40213160	1955-08-28	1955-08-28 00:00:00	1955-08-28	1955-08-28 00:00:00	1955-08-28	581452		0	0	0		0	0	0	344905	0	10	40213160		
32875	2724	1713671	1985-01-01	1985-01-01 00:00:00	1985-01-15	1985-01-15 00:00:00	1985-01-15	38000177		0	0	14		0	0	0	180485	0	562251	1713671		
50126	4159	1127433	1991-08-22	1991-08-22 00:00:00	1991-09-19	1991-09-19 00:00:00	1991-09-19	38000177		0	0	28		0	0	0	276362	0	313782	1127433		
8011	670	46233988	1976-04-03	1976-04-03 00:00:00	1976-04-17	1976-04-17 00:00:00	1976-04-17	38000177		0	0	14		0	0	0	44206	0	1652673	46233988		
41478	3437	40236824	1946-05-16	1946-05-16 00:00:00	1946-05-23	1946-05-23 00:00:00	1946-05-23	38000177		0	0	7		0	0	0	227985	0	1094107	40236824		
36848	3047	19129655	1975-02-11	1975-02-11 00:00:00	1975-02-25	1975-02-25 00:00:00	1975-02-25	38000177		0	0	14		0	0	0	202756	0	789980	19129655		
55057	4571	19078461	1981-03-18	1981-03-18 00:00:00	1981-04-01	1981-04-01 00:00:00	1981-04-01	38000177		0	0	14		0	0	0	304554	0	310965	19078461		
115667	2541	40213160	1976-03-08	1976-03-08 00:00:00	1976-03-08	1976-03-08 00:00:00	1976-03-08	581452		0	0	0		0	0	0	168038	0	10	40213160		
67625	1478	40213227	2003-04-01	2003-04-01 00:00:00	2003-04-01	2003-04-01 00:00:00	2003-04-01	581452		0	0	0		0	0	0	98588	0	113	40213227		
84802	1855	40213314	1978-02-24	1978-02-24 00:00:00	1978-02-24	1978-02-24 00:00:00	1978-02-24	581452		0	0	0		0	0	0	124202	0	49	40213314		
48035	3984	19078461	2018-07-21	2018-07-21 00:00:00	2018-08-20	2018-08-20 00:00:00	2018-08-20	38000177		0	0	30		0	0	0	264888	0	310965	19078461		
145817	3207	40213306	1981-10-01	1981-10-01 00:00:00	1981-10-01	1981-10-01 00:00:00	1981-10-01	581452		0	0	0		0	0	0	213221	0	43	40213306		
25861	2127	1127433	1970-07-23	1970-07-23 00:00:00	1970-08-06	1970-08-06 00:00:00	1970-08-06	38000177		0	0	14		0	0	0	141452	0	313782	1127433		
39841	3295	1713671	1999-05-02	1999-05-02 00:00:00	1999-05-16	1999-05-16 00:00:00	1999-05-16	38000177		0	0	14		0	0	0	218918	0	562251	1713671		
14817	1239	1713671	1974-12-16	1974-12-16 00:00:00	1975-01-06	1975-01-06 00:00:00	1975-01-06	38000177		0	0	21		0	0	0	81637	0	562251	1713671		
44013	3644	1124300	1981-10-25	1981-10-25 00:00:00	1981-10-25	1981-10-25 00:00:00	\N	38000177		0	0	0		0	0	0	242481	0	00781178901	45011828		
14893	1246	1127433	1955-01-22	1955-01-22 00:00:00	1955-03-23	1955-03-23 00:00:00	1955-03-23	38000177		0	0	60		0	0	0	82135	0	313782	1127433		
28204	2332	1127078	1967-08-26	1967-08-26 00:00:00	1967-10-25	1967-10-25 00:00:00	1967-10-25	38000177		0	0	60		0	0	0	155123	0	282464	1127078		
2269	183	19133873	1988-07-27	1988-07-27 00:00:00	1988-08-07	1988-08-07 00:00:00	1988-08-07	38000177		0	0	11		0	0	0	12409	0	834061	19133873		
8628	720	1127078	1975-05-04	1975-05-04 00:00:00	1975-05-25	1975-05-25 00:00:00	1975-05-25	38000177		0	0	21		0	0	0	47658	0	282464	1127078		
22490	1848	1127433	1962-04-13	1962-04-13 00:00:00	1962-04-27	1962-04-27 00:00:00	1962-04-27	38000177		0	0	14		0	0	0	123604	0	313782	1127433		
37206	3076	1115171	2010-12-07	2010-12-07 00:00:00	2011-01-04	2011-01-04 00:00:00	2011-01-04	38000177		0	0	28		0	0	0	204647	0	849574	1115171		
73852	1611	40213260	2006-07-02	2006-07-02 00:00:00	2006-07-02	2006-07-02 00:00:00	2006-07-02	581452		0	0	0		0	0	0	108305	0	121	40213260		
157124	3457	40213227	2008-08-29	2008-08-29 00:00:00	2008-08-29	2008-08-29 00:00:00	2008-08-29	581452		0	0	0		0	0	0	229343	0	113	40213227		
13394	1123	19059056	1971-09-29	1971-09-29 00:00:00	1971-10-13	1971-10-13 00:00:00	1971-10-13	38000177		0	0	14		0	0	0	74002	0	243670	19059056		
209565	4595	40213227	2004-07-23	2004-07-23 00:00:00	2004-07-23	2004-07-23 00:00:00	2004-07-23	581452		0	0	0		0	0	0	306192	0	113	40213227		
85316	1867	40213160	1972-08-29	1972-08-29 00:00:00	1972-08-29	1972-08-29 00:00:00	1972-08-29	581452		0	0	0		0	0	0	124708	0	10	40213160		
60020	4988	19133905	2006-12-10	2006-12-10 00:00:00	2006-12-17	2006-12-17 00:00:00	2006-12-17	38000177		0	0	7		0	0	0	331833	0	834102	19133905		
960	79	40169216	1949-05-02	1949-05-02 00:00:00	1949-05-02	1949-05-02 00:00:00	\N	38000177		0	0	0		0	0	0	5251	0	895994	40169216		
23806	1958	19133873	1981-05-19	1981-05-19 00:00:00	1981-05-26	1981-05-26 00:00:00	1981-05-26	38000177		0	0	7		0	0	0	130255	0	834061	19133873		
179021	3936	40213296	2000-09-04	2000-09-04 00:00:00	2000-09-04	2000-09-04 00:00:00	2000-09-04	581452		0	0	0		0	0	0	261580	0	52	40213296		
158517	3489	40213160	1973-02-03	1973-02-03 00:00:00	1973-02-03	1973-02-03 00:00:00	1973-02-03	581452		0	0	0		0	0	0	231477	0	10	40213160		
34661	2862	40229134	1972-05-03	1972-05-03 00:00:00	1972-05-10	1972-05-10 00:00:00	1972-05-10	38000177		0	0	7		0	0	0	190263	0	1043400	40229134		
45157	3736	19133873	1965-05-16	1965-05-16 00:00:00	1965-05-26	1965-05-26 00:00:00	1965-05-26	38000177		0	0	10		0	0	0	248273	0	834061	19133873		
16736	1385	19077344	2007-05-02	2007-05-02 00:00:00	2007-05-02	2007-05-02 00:00:00	\N	38000177		0	0	0		0	0	0	91820	0	310325	19077344		
24417	2007	1127078	1988-11-05	1988-11-05 00:00:00	1988-11-19	1988-11-19 00:00:00	1988-11-19	38000177		0	0	14		0	0	0	133669	0	282464	1127078		
24463	2012	19059056	1978-02-25	1978-02-25 00:00:00	1978-05-03	1978-05-03 00:00:00	1978-05-03	38000177		0	0	67		0	0	0	133865	0	243670	19059056		
20589	1695	1713671	1996-06-12	1996-06-12 00:00:00	1996-06-26	1996-06-26 00:00:00	1996-06-26	38000177		0	0	14		0	0	0	113486	0	562251	1713671		
32763	2712	19078461	2003-08-06	2003-08-06 00:00:00	2003-08-27	2003-08-27 00:00:00	2003-08-27	38000177		0	0	21		0	0	0	179885	0	310965	19078461		
20673	1703	1713671	1953-03-03	1953-03-03 00:00:00	1953-03-10	1953-03-10 00:00:00	1953-03-10	38000177		0	0	7		0	0	0	113905	0	562251	1713671		
10926	911	1118084	2015-06-16	2015-06-16 00:00:00	2015-06-16	2015-06-16 00:00:00	\N	38000177		0	0	0		0	0	0	60518	0	00025152531	44923712		
79721	1744	40213314	1977-10-07	1977-10-07 00:00:00	1977-10-07	1977-10-07 00:00:00	1977-10-07	581452		0	0	0		0	0	0	116623	0	49	40213314		
52223	4343	1713671	1979-07-01	1979-07-01 00:00:00	1979-07-08	1979-07-08 00:00:00	1979-07-08	38000177		0	0	7		0	0	0	287992	0	562251	1713671		
65750	1438	40213227	2013-02-15	2013-02-15 00:00:00	2013-02-15	2013-02-15 00:00:00	2013-02-15	581452		0	0	0		0	0	0	95783	0	113	40213227		
11258	938	1127433	2000-12-30	2000-12-30 00:00:00	2001-01-06	2001-01-06 00:00:00	2001-01-06	38000177		0	0	7		0	0	0	62353	0	313782	1127433		
100674	2206	40213160	1976-11-12	1976-11-12 00:00:00	1976-11-12	1976-11-12 00:00:00	1976-11-12	581452		0	0	0		0	0	0	147043	0	10	40213160		
49637	4117	19078461	1997-05-14	1997-05-14 00:00:00	1997-06-18	1997-06-18 00:00:00	1997-06-18	38000177		0	0	35		0	0	0	273680	0	310965	19078461		
120888	2657	40213160	1966-09-17	1966-09-17 00:00:00	1966-09-17	1966-09-17 00:00:00	1966-09-17	581452		0	0	0		0	0	0	175942	0	10	40213160		
52313	4352	1127433	2006-03-27	2006-03-27 00:00:00	2006-04-03	2006-04-03 00:00:00	2006-04-03	38000177		0	0	7		0	0	0	288711	0	313782	1127433		
32654	712	40213227	2006-01-19	2006-01-19 00:00:00	2006-01-19	2006-01-19 00:00:00	2006-01-19	581452		0	0	0		0	0	0	47264	0	113	40213227		
1860	149	1127433	1999-03-29	1999-03-29 00:00:00	1999-04-05	1999-04-05 00:00:00	1999-04-05	38000177		0	0	7		0	0	0	10049	0	313782	1127433		
52610	4374	19073188	1989-06-07	1989-06-07 00:00:00	1989-06-21	1989-06-21 00:00:00	1989-06-21	38000177		0	0	14		0	0	0	290541	0	308192	19073188		
53288	4428	19133873	1954-05-05	1954-05-05 00:00:00	1954-05-15	1954-05-15 00:00:00	1954-05-15	38000177		0	0	10		0	0	0	294377	0	834061	19133873		
41327	3427	19006318	1967-01-01	1967-01-01 00:00:00	1967-01-15	1967-01-15 00:00:00	1967-01-15	38000177		0	0	14		0	0	0	227214	0	105078	19006318		
2929	236	19133905	1981-11-22	1981-11-22 00:00:00	1981-12-04	1981-12-04 00:00:00	1981-12-04	38000177		0	0	12		0	0	0	15925	0	834102	19133905		
24950	2052	40243436	2015-10-19	2015-10-19 00:00:00	2015-10-19	2015-10-19 00:00:00	2015-10-19	38000177		0	0	0		0	0	0	136411	0	1190795	40243436		
4910	409	19078461	1995-09-10	1995-09-10 00:00:00	1995-10-01	1995-10-01 00:00:00	1995-10-01	38000177		0	0	21		0	0	0	27152	0	310965	19078461		
35530	2927	1127433	1987-05-17	1987-05-17 00:00:00	1987-07-16	1987-07-16 00:00:00	1987-07-16	38000177		0	0	60		0	0	0	195296	0	313782	1127433		
35494	2925	19078461	2015-03-12	2015-03-12 00:00:00	2015-05-18	2015-05-18 00:00:00	2015-05-18	38000177		0	0	67		0	0	0	195026	0	310965	19078461		
16292	351	40213160	1978-05-09	1978-05-09 00:00:00	1978-05-09	1978-05-09 00:00:00	1978-05-09	581452		0	0	0		0	0	0	23374	0	10	40213160		
23234	1915	19059056	1977-05-18	1977-05-18 00:00:00	1977-06-01	1977-06-01 00:00:00	1977-06-01	38000177		0	0	14		0	0	0	127382	0	243670	19059056		
18969	1567	1118084	2008-05-06	2008-05-06 00:00:00	2008-05-06	2008-05-06 00:00:00	\N	38000177		0	0	0		0	0	0	105128	0	00025152531	44923712		
47206	3916	1713671	1987-01-26	1987-01-26 00:00:00	1987-02-09	1987-02-09 00:00:00	1987-02-09	38000177		0	0	14		0	0	0	260253	0	562251	1713671		
35241	2906	19059056	1925-05-19	1925-05-19 00:00:00	1925-06-02	1925-06-02 00:00:00	1925-06-02	38000177		0	0	14		0	0	0	193694	0	243670	19059056		
236273	5189	40213260	2007-06-03	2007-06-03 00:00:00	2007-06-03	2007-06-03 00:00:00	2007-06-03	581452		0	0	0		0	0	0	344938	0	121	40213260		
32876	2724	920300	1989-06-29	1989-06-29 00:00:00	1989-07-06	1989-07-06 00:00:00	1989-07-06	38000177		0	0	7		0	0	0	180486	0	311989	920300		
50127	4159	1118084	1991-10-06	1991-10-06 00:00:00	1991-10-06	1991-10-06 00:00:00	\N	38000177		0	0	0		0	0	0	276362	0	00025152531	44923712		
8012	670	19019979	1976-04-03	1976-04-03 00:00:00	1976-04-17	1976-04-17 00:00:00	1976-04-17	38000177		0	0	14		0	0	0	44206	0	198405	19019979		
41479	3437	1127433	1977-05-16	1977-05-16 00:00:00	1977-05-30	1977-05-30 00:00:00	1977-05-30	38000177		0	0	14		0	0	0	227925	0	313782	1127433		
36849	3047	19019979	1975-02-11	1975-02-11 00:00:00	1975-02-25	1975-02-25 00:00:00	1975-02-25	38000177		0	0	14		0	0	0	202756	0	198405	19019979		
55058	4571	1127433	1993-12-29	1993-12-29 00:00:00	1994-01-05	1994-01-05 00:00:00	1994-01-05	38000177		0	0	7		0	0	0	304560	0	313782	1127433		
115675	2542	40213227	1994-10-21	1994-10-21 00:00:00	1994-10-21	1994-10-21 00:00:00	1994-10-21	581452		0	0	0		0	0	0	168147	0	113	40213227		
78942	1727	40213227	1993-04-15	1993-04-15 00:00:00	1993-04-15	1993-04-15 00:00:00	1993-04-15	581452		0	0	0		0	0	0	115423	0	113	40213227		
84805	1855	40213314	1977-08-26	1977-08-26 00:00:00	1977-08-26	1977-08-26 00:00:00	1977-08-26	581452		0	0	0		0	0	0	124174	0	49	40213314		
48036	3984	1127433	1970-06-25	1970-06-25 00:00:00	1970-07-30	1970-07-30 00:00:00	1970-07-30	38000177		0	0	35		0	0	0	264885	0	313782	1127433		
145823	3207	40213227	2000-12-21	2000-12-21 00:00:00	2000-12-21	2000-12-21 00:00:00	2000-12-21	581452		0	0	0		0	0	0	213168	0	113	40213227		
25862	2127	1713671	1995-08-29	1995-08-29 00:00:00	1995-09-19	1995-09-19 00:00:00	1995-09-19	38000177		0	0	21		0	0	0	141454	0	562251	1713671		
39842	3296	19115351	1967-02-17	1967-02-17 00:00:00	1967-06-16	1967-06-16 00:00:00	1967-06-16	38000177		0	0	119		0	0	0	219009	0	563026	19115351		
14818	1239	40229134	2010-02-27	2010-02-27 00:00:00	2010-03-13	2010-03-13 00:00:00	2010-03-13	38000177		0	0	14		0	0	0	81646	0	1043400	40229134		
44014	3644	1127433	1979-09-22	1979-09-22 00:00:00	1979-10-06	1979-10-06 00:00:00	1979-10-06	38000177		0	0	14		0	0	0	242491	0	313782	1127433		
14894	1246	1127433	1974-09-14	1974-09-14 00:00:00	1974-11-13	1974-11-13 00:00:00	1974-11-13	38000177		0	0	60		0	0	0	82054	0	313782	1127433		
28205	2332	19059056	1958-12-11	1958-12-11 00:00:00	1958-12-25	1958-12-25 00:00:00	1958-12-25	38000177		0	0	14		0	0	0	155087	0	243670	19059056		
2270	184	40229134	1964-01-25	1964-01-25 00:00:00	1964-02-08	1964-02-08 00:00:00	1964-02-08	38000177		0	0	14		0	0	0	12472	0	1043400	40229134		
29987	2485	19073188	1999-10-14	1999-10-14 00:00:00	1999-10-28	1999-10-28 00:00:00	1999-10-28	38000177		0	0	14		0	0	0	164650	0	308192	19073188		
22491	1848	19129655	1962-04-13	1962-04-13 00:00:00	1962-04-27	1962-04-27 00:00:00	1962-04-27	38000177		0	0	14		0	0	0	123604	0	789980	19129655		
37207	3076	1115171	1997-03-08	1997-03-08 00:00:00	1997-03-29	1997-03-29 00:00:00	1997-03-29	38000177		0	0	21		0	0	0	204645	0	849574	1115171		
73856	1612	40213160	1968-07-10	1968-07-10 00:00:00	1968-07-10	1968-07-10 00:00:00	1968-07-10	581452		0	0	0		0	0	0	108379	0	10	40213160		
157129	3458	40213160	1980-06-27	1980-06-27 00:00:00	1980-06-27	1980-06-27 00:00:00	1980-06-27	581452		0	0	0		0	0	0	229488	0	10	40213160		
13395	1123	46233988	1971-09-29	1971-09-29 00:00:00	1971-10-13	1971-10-13 00:00:00	1971-10-13	38000177		0	0	14		0	0	0	74002	0	1652673	46233988		
209566	4595	40213296	2004-07-23	2004-07-23 00:00:00	2004-07-23	2004-07-23 00:00:00	2004-07-23	581452		0	0	0		0	0	0	306192	0	52	40213296		
237527	5215	40213227	2001-07-16	2001-07-16 00:00:00	2001-07-16	2001-07-16 00:00:00	2001-07-16	581452		0	0	0		0	0	0	346862	0	113	40213227		
60021	4988	19078461	1983-07-30	1983-07-30 00:00:00	1983-08-20	1983-08-20 00:00:00	1983-08-20	38000177		0	0	21		0	0	0	331828	0	310965	19078461		
961	79	19059056	1947-10-17	1947-10-17 00:00:00	1947-10-31	1947-10-31 00:00:00	1947-10-31	38000177		0	0	14		0	0	0	5352	0	243670	19059056		
23807	1958	1127433	1987-09-02	1987-09-02 00:00:00	1987-09-16	1987-09-16 00:00:00	1987-09-16	38000177		0	0	14		0	0	0	130257	0	313782	1127433		
179023	3936	40213227	2000-09-04	2000-09-04 00:00:00	2000-09-04	2000-09-04 00:00:00	2000-09-04	581452		0	0	0		0	0	0	261580	0	113	40213227		
158529	3490	40213198	2010-12-10	2010-12-10 00:00:00	2010-12-10	2010-12-10 00:00:00	2010-12-10	581452		0	0	0		0	0	0	231541	0	133	40213198		
34662	2862	1127433	1994-03-16	1994-03-16 00:00:00	1994-03-23	1994-03-23 00:00:00	1994-03-23	38000177		0	0	7		0	0	0	190273	0	313782	1127433		
45158	3736	40229134	1969-01-11	1969-01-11 00:00:00	1969-01-25	1969-01-25 00:00:00	1969-01-25	38000177		0	0	14		0	0	0	248314	0	1043400	40229134		
16737	1385	1127433	1965-08-17	1965-08-17 00:00:00	1965-08-31	1965-08-31 00:00:00	1965-08-31	38000177		0	0	14		0	0	0	91817	0	313782	1127433		
24418	2007	19075001	1988-11-05	1988-11-05 00:00:00	1988-11-19	1988-11-19 00:00:00	1988-11-19	38000177		0	0	14		0	0	0	133669	0	309097	19075001		
24464	2012	1127433	1965-06-02	1965-06-02 00:00:00	1965-06-16	1965-06-16 00:00:00	1965-06-16	38000177		0	0	14		0	0	0	133917	0	313782	1127433		
20590	1695	1713671	2009-11-24	2009-11-24 00:00:00	2009-12-15	2009-12-15 00:00:00	2009-12-15	38000177		0	0	21		0	0	0	113490	0	562251	1713671		
32764	2712	19078461	1978-04-07	1978-04-07 00:00:00	1978-05-12	1978-05-12 00:00:00	1978-05-12	38000177		0	0	35		0	0	0	179883	0	310965	19078461		
20674	1703	19059056	1954-11-10	1954-11-10 00:00:00	1955-02-08	1955-02-08 00:00:00	1955-02-08	38000177		0	0	90		0	0	0	113925	0	243670	19059056		
10927	911	1713671	1984-11-13	1984-11-13 00:00:00	1984-11-27	1984-11-27 00:00:00	1984-11-27	38000177		0	0	14		0	0	0	60473	0	562251	1713671		
79722	1744	40213160	1975-10-10	1975-10-10 00:00:00	1975-10-10	1975-10-10 00:00:00	1975-10-10	581452		0	0	0		0	0	0	116632	0	10	40213160		
52224	4343	1127433	1997-02-27	1997-02-27 00:00:00	1997-03-13	1997-03-13 00:00:00	1997-03-13	38000177		0	0	14		0	0	0	288031	0	313782	1127433		
65761	1439	40213227	2000-03-25	2000-03-25 00:00:00	2000-03-25	2000-03-25 00:00:00	2000-03-25	581452		0	0	0		0	0	0	95893	0	113	40213227		
11259	938	1127433	1993-12-21	1993-12-21 00:00:00	1994-01-04	1994-01-04 00:00:00	1994-01-04	38000177		0	0	14		0	0	0	62381	0	313782	1127433		
100680	2206	40213160	1972-05-12	1972-05-12 00:00:00	1972-05-12	1972-05-12 00:00:00	1972-05-12	581452		0	0	0		0	0	0	146996	0	10	40213160		
49638	4117	1127433	2011-09-03	2011-09-03 00:00:00	2011-10-01	2011-10-01 00:00:00	2011-10-01	38000177		0	0	28		0	0	0	273681	0	313782	1127433		
120895	2657	40213227	2008-06-21	2008-06-21 00:00:00	2008-06-21	2008-06-21 00:00:00	2008-06-21	581452		0	0	0		0	0	0	175962	0	113	40213227		
52315	4352	19133905	2003-04-22	2003-04-22 00:00:00	2003-05-01	2003-05-01 00:00:00	2003-05-01	38000177		0	0	9		0	0	0	288708	0	834102	19133905		
216014	4739	40213227	1992-01-04	1992-01-04 00:00:00	1992-01-04	1992-01-04 00:00:00	1992-01-04	581452		0	0	0		0	0	0	315777	0	113	40213227		
1861	149	19133873	1943-11-08	1943-11-08 00:00:00	1943-11-21	1943-11-21 00:00:00	1943-11-21	38000177		0	0	13		0	0	0	10031	0	834061	19133873		
52611	4374	1127433	1989-06-07	1989-06-07 00:00:00	1989-06-21	1989-06-21 00:00:00	1989-06-21	38000177		0	0	14		0	0	0	290541	0	313782	1127433		
53289	4428	1713671	1994-01-02	1994-01-02 00:00:00	1994-01-16	1994-01-16 00:00:00	1994-01-16	38000177		0	0	14		0	0	0	294399	0	562251	1713671		
41328	3427	1127433	1976-12-20	1976-12-20 00:00:00	1977-01-03	1977-01-03 00:00:00	1977-01-03	38000177		0	0	14		0	0	0	227216	0	313782	1127433		
2930	236	1127078	1952-09-25	1952-09-25 00:00:00	1952-10-09	1952-10-09 00:00:00	1952-10-09	38000177		0	0	14		0	0	0	15834	0	282464	1127078		
24951	2052	40229134	2013-02-02	2013-02-02 00:00:00	2013-02-09	2013-02-09 00:00:00	2013-02-09	38000177		0	0	7		0	0	0	136409	0	1043400	40229134		
4911	409	40162522	1965-05-20	1965-05-20 00:00:00	1965-05-20	1965-05-20 00:00:00	\N	38000177		0	0	0		0	0	0	27150	0	857005	40162522		
35531	2927	40231925	1987-05-17	1987-05-17 00:00:00	1987-05-17	1987-05-17 00:00:00	\N	38000177		0	0	0		0	0	0	195296	0	1049221	40231925		
35495	2925	19133905	1999-11-05	1999-11-05 00:00:00	1999-11-13	1999-11-13 00:00:00	1999-11-13	38000177		0	0	8		0	0	0	195009	0	834102	19133905		
16295	351	40213227	2000-05-02	2000-05-02 00:00:00	2000-05-02	2000-05-02 00:00:00	2000-05-02	581452		0	0	0		0	0	0	23431	0	113	40213227		
23235	1915	46233988	1977-05-18	1977-05-18 00:00:00	1977-06-01	1977-06-01 00:00:00	1977-06-01	38000177		0	0	14		0	0	0	127382	0	1652673	46233988		
18970	1567	1551192	1991-09-29	1991-09-29 00:00:00	1991-09-29	1991-09-29 00:00:00	1991-09-29	38000177		0	0	0		0	0	0	105106	0	312617	1551192		
47207	3916	19133905	2001-11-20	2001-11-20 00:00:00	2001-11-30	2001-11-30 00:00:00	2001-11-30	38000177		0	0	10		0	0	0	260374	0	834102	19133905		
35242	2906	1127433	1982-04-30	1982-04-30 00:00:00	1982-05-14	1982-05-14 00:00:00	1982-05-14	38000177		0	0	14		0	0	0	193725	0	313782	1127433		
27798	605	40213227	2018-03-02	2018-03-02 00:00:00	2018-03-02	2018-03-02 00:00:00	2018-03-02	581452		0	0	0		0	0	0	40141	0	113	40213227		
32877	2724	40236824	1989-06-29	1989-06-29 00:00:00	1989-07-13	1989-07-13 00:00:00	1989-07-13	38000177		0	0	14		0	0	0	180486	0	1094107	40236824		
50128	4159	40236824	2016-04-17	2016-04-17 00:00:00	2016-04-24	2016-04-24 00:00:00	2016-04-24	38000177		0	0	7		0	0	0	276352	0	1094107	40236824		
8013	670	19133873	1984-08-06	1984-08-06 00:00:00	1984-08-18	1984-08-18 00:00:00	1984-08-18	38000177		0	0	12		0	0	0	44240	0	834061	19133873		
41480	3437	19129655	1977-05-16	1977-05-16 00:00:00	1977-05-30	1977-05-30 00:00:00	1977-05-30	38000177		0	0	14		0	0	0	227925	0	789980	19129655		
36850	3047	19078461	2008-05-16	2008-05-16 00:00:00	2008-05-30	2008-05-30 00:00:00	2008-05-30	38000177		0	0	14		0	0	0	202742	0	310965	19078461		
55060	4572	19133905	2018-07-16	2018-07-16 00:00:00	2018-07-23	2018-07-23 00:00:00	2018-07-23	38000177		0	0	7		0	0	0	304626	0	834102	19133905		
115679	2542	40213160	1963-09-06	1963-09-06 00:00:00	1963-09-06	1963-09-06 00:00:00	1963-09-06	581452		0	0	0		0	0	0	168200	0	10	40213160		
111324	2445	40213227	1998-12-21	1998-12-21 00:00:00	1998-12-21	1998-12-21 00:00:00	1998-12-21	581452		0	0	0		0	0	0	162273	0	113	40213227		
171440	3769	40213227	1993-08-29	1993-08-29 00:00:00	1993-08-29	1993-08-29 00:00:00	1993-08-29	581452		0	0	0		0	0	0	250512	0	113	40213227		
48037	3984	1127433	1975-05-09	1975-05-09 00:00:00	1975-05-16	1975-05-16 00:00:00	1975-05-16	38000177		0	0	7		0	0	0	264808	0	313782	1127433		
145824	3207	40213296	2000-12-21	2000-12-21 00:00:00	2000-12-21	2000-12-21 00:00:00	2000-12-21	581452		0	0	0		0	0	0	213168	0	52	40213296		
25863	2127	19073188	2005-06-28	2005-06-28 00:00:00	2005-07-12	2005-07-12 00:00:00	2005-07-12	38000177		0	0	14		0	0	0	141493	0	308192	19073188		
39843	3296	1713671	1993-11-04	1993-11-04 00:00:00	1993-11-18	1993-11-18 00:00:00	1993-11-18	38000177		0	0	14		0	0	0	219089	0	562251	1713671		
14820	1239	19059056	1980-06-02	1980-06-02 00:00:00	1980-06-23	1980-06-23 00:00:00	1980-06-23	38000177		0	0	21		0	0	0	81673	0	243670	19059056		
44015	3644	1127433	1959-11-11	1959-11-11 00:00:00	1959-11-18	1959-11-18 00:00:00	1959-11-18	38000177		0	0	7		0	0	0	242504	0	313782	1127433		
14895	1246	1127433	1943-11-22	1943-11-22 00:00:00	1943-11-29	1943-11-29 00:00:00	1943-11-29	38000177		0	0	7		0	0	0	82068	0	313782	1127433		
28206	2332	19006318	1958-12-11	1958-12-11 00:00:00	1958-12-25	1958-12-25 00:00:00	1958-12-25	38000177		0	0	14		0	0	0	155087	0	105078	19006318		
2271	184	1713671	1953-05-28	1953-05-28 00:00:00	1953-06-11	1953-06-11 00:00:00	1953-06-11	38000177		0	0	14		0	0	0	12471	0	562251	1713671		
29988	2485	1127433	1999-10-14	1999-10-14 00:00:00	1999-10-28	1999-10-28 00:00:00	1999-10-28	38000177		0	0	14		0	0	0	164650	0	313782	1127433		
22492	1848	19133873	1954-11-24	1954-11-24 00:00:00	1954-12-06	1954-12-06 00:00:00	1954-12-06	38000177		0	0	12		0	0	0	123680	0	834061	19133873		
37208	3076	19078461	2004-09-18	2004-09-18 00:00:00	2004-10-09	2004-10-09 00:00:00	2004-10-09	38000177		0	0	21		0	0	0	204646	0	310965	19078461		
73860	1612	40213227	1994-12-27	1994-12-27 00:00:00	1994-12-27	1994-12-27 00:00:00	1994-12-27	581452		0	0	0		0	0	0	108408	0	113	40213227		
157137	3458	40213314	1980-01-25	1980-01-25 00:00:00	1980-01-25	1980-01-25 00:00:00	1980-01-25	581452		0	0	0		0	0	0	229492	0	49	40213314		
13396	1123	19133905	2002-10-03	2002-10-03 00:00:00	2002-10-12	2002-10-12 00:00:00	2002-10-12	38000177		0	0	9		0	0	0	74000	0	834102	19133905		
209571	4595	40213260	2012-07-13	2012-07-13 00:00:00	2012-07-13	2012-07-13 00:00:00	2012-07-13	581452		0	0	0		0	0	0	306205	0	121	40213260		
8243	177	40213160	1966-10-03	1966-10-03 00:00:00	1966-10-03	1966-10-03 00:00:00	1966-10-03	581452		0	0	0		0	0	0	11995	0	10	40213160		
60022	4988	1127433	1979-01-05	1979-01-05 00:00:00	1979-01-19	1979-01-19 00:00:00	1979-01-19	38000177		0	0	14		0	0	0	331855	0	313782	1127433		
962	79	19006318	1947-10-17	1947-10-17 00:00:00	1947-10-31	1947-10-31 00:00:00	1947-10-31	38000177		0	0	14		0	0	0	5352	0	105078	19006318		
23809	1960	40229134	1983-10-04	1983-10-04 00:00:00	1983-10-11	1983-10-11 00:00:00	1983-10-11	38000177		0	0	7		0	0	0	130374	0	1043400	40229134		
8410	181	40213160	1973-12-23	1973-12-23 00:00:00	1973-12-23	1973-12-23 00:00:00	1973-12-23	581452		0	0	0		0	0	0	12240	0	10	40213160		
72514	1585	40213227	2010-09-05	2010-09-05 00:00:00	2010-09-05	2010-09-05 00:00:00	2010-09-05	581452		0	0	0		0	0	0	106325	0	113	40213227		
34663	2863	1713671	1968-10-14	1968-10-14 00:00:00	1968-10-28	1968-10-28 00:00:00	1968-10-28	38000177		0	0	14		0	0	0	190424	0	562251	1713671		
45159	3736	40229134	1964-09-13	1964-09-13 00:00:00	1964-09-20	1964-09-20 00:00:00	1964-09-20	38000177		0	0	7		0	0	0	248313	0	1043400	40229134		
16738	1385	19078461	2016-03-23	2016-03-23 00:00:00	2016-04-13	2016-04-13 00:00:00	2016-04-13	38000177		0	0	21		0	0	0	91876	0	310965	19078461		
24419	2007	1127433	1993-07-29	1993-07-29 00:00:00	1993-08-05	1993-08-05 00:00:00	1993-08-05	38000177		0	0	7		0	0	0	133692	0	313782	1127433		
24465	2012	1127433	1968-03-10	1968-03-10 00:00:00	1968-03-17	1968-03-17 00:00:00	1968-03-17	38000177		0	0	7		0	0	0	133844	0	313782	1127433		
20591	1695	1124300	2010-05-03	2010-05-03 00:00:00	2010-05-03	2010-05-03 00:00:00	\N	38000177		0	0	0		0	0	0	113490	0	00781178901	45011828		
32765	2712	19059056	1966-04-01	1966-04-01 00:00:00	1966-04-15	1966-04-15 00:00:00	1966-04-15	38000177		0	0	14		0	0	0	179859	0	243670	19059056		
20675	1703	1115171	2019-05-11	2019-05-11 00:00:00	2019-05-11	2019-05-11 00:00:00	\N	38000177		0	0	0		0	0	0	113933	0	849574	1115171		
10928	911	1127433	2003-12-23	2003-12-23 00:00:00	2003-12-30	2003-12-30 00:00:00	2003-12-30	38000177		0	0	7		0	0	0	60491	0	313782	1127433		
79724	1744	40213227	2016-09-09	2016-09-09 00:00:00	2016-09-09	2016-09-09 00:00:00	2016-09-09	581452		0	0	0		0	0	0	116610	0	113	40213227		
52225	4343	1118084	1995-06-20	1995-06-20 00:00:00	1995-06-20	1995-06-20 00:00:00	\N	38000177		0	0	0		0	0	0	288004	0	00025152531	44923712		
65762	1439	40213306	2000-03-25	2000-03-25 00:00:00	2000-03-25	2000-03-25 00:00:00	2000-03-25	581452		0	0	0		0	0	0	95893	0	43	40213306		
11260	938	1124300	1987-05-30	1987-05-30 00:00:00	1987-05-30	1987-05-30 00:00:00	\N	38000177		0	0	0		0	0	0	62377	0	00781178901	45011828		
100681	2206	40213160	1972-03-10	1972-03-10 00:00:00	1972-03-10	1972-03-10 00:00:00	1972-03-10	581452		0	0	0		0	0	0	147015	0	10	40213160		
40749	3378	19133905	1998-12-10	1998-12-10 00:00:00	1998-12-18	1998-12-18 00:00:00	1998-12-18	38000177		0	0	8		0	0	0	224127	0	834102	19133905		
120896	2657	40213296	2008-06-21	2008-06-21 00:00:00	2008-06-21	2008-06-21 00:00:00	2008-06-21	581452		0	0	0		0	0	0	175962	0	52	40213296		
52317	4352	1127078	1952-04-26	1952-04-26 00:00:00	1952-05-10	1952-05-10 00:00:00	1952-05-10	38000177		0	0	14		0	0	0	288646	0	282464	1127078		
13011	280	40213227	2010-01-22	2010-01-22 00:00:00	2010-01-22	2010-01-22 00:00:00	2010-01-22	581452		0	0	0		0	0	0	18761	0	113	40213227		
1862	149	40229134	1975-05-25	1975-05-25 00:00:00	1975-06-01	1975-06-01 00:00:00	1975-06-01	38000177		0	0	7		0	0	0	10038	0	1043400	40229134		
52612	4374	19133873	1985-02-18	1985-02-18 00:00:00	1985-02-27	1985-02-27 00:00:00	1985-02-27	38000177		0	0	9		0	0	0	290487	0	834061	19133873		
53290	4428	1713671	2011-10-17	2011-10-17 00:00:00	2011-10-31	2011-10-31 00:00:00	2011-10-31	38000177		0	0	14		0	0	0	294419	0	562251	1713671		
41329	3428	1127433	1976-12-20	1976-12-20 00:00:00	1976-12-27	1976-12-27 00:00:00	1976-12-27	38000177		0	0	7		0	0	0	227253	0	313782	1127433		
2931	236	1127433	1978-01-01	1978-01-01 00:00:00	1978-01-08	1978-01-08 00:00:00	1978-01-08	38000177		0	0	7		0	0	0	15902	0	313782	1127433		
24952	2052	1127433	2015-03-03	2015-03-03 00:00:00	2015-03-10	2015-03-10 00:00:00	2015-03-10	38000177		0	0	7		0	0	0	136414	0	313782	1127433		
4912	409	1127433	1965-05-20	1965-05-20 00:00:00	1965-06-19	1965-06-19 00:00:00	1965-06-19	38000177		0	0	30		0	0	0	27150	0	313782	1127433		
35532	2927	40229134	2004-07-05	2004-07-05 00:00:00	2004-07-19	2004-07-19 00:00:00	2004-07-19	38000177		0	0	14		0	0	0	195206	0	1043400	40229134		
35496	2925	19128065	1979-12-06	1979-12-06 00:00:00	1980-11-30	1980-11-30 00:00:00	1980-11-30	38000177		0	0	360		0	0	0	195040	0	749882	19128065		
16296	351	40213306	2000-05-02	2000-05-02 00:00:00	2000-05-02	2000-05-02 00:00:00	2000-05-02	581452		0	0	0		0	0	0	23431	0	43	40213306		
23236	1915	1118084	2006-08-14	2006-08-14 00:00:00	2006-08-14	2006-08-14 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00025152531	44923712		
18971	1567	19112599	1975-10-07	1975-10-07 00:00:00	1975-10-07	1975-10-07 00:00:00	\N	38000177		0	0	0		0	0	0	105078	0	477045	19112599		
47208	3916	19073183	1980-12-22	1980-12-22 00:00:00	1981-01-05	1981-01-05 00:00:00	1981-01-05	38000177		0	0	14		0	0	0	260388	0	308182	19073183		
35243	2906	40173590	2014-07-12	2014-07-12 00:00:00	2014-07-12	2014-07-12 00:00:00	\N	38000177		0	0	0		0	0	0	193623	0	904419	40173590		
27806	605	40213227	1997-12-05	1997-12-05 00:00:00	1997-12-05	1997-12-05 00:00:00	1997-12-05	581452		0	0	0		0	0	0	40123	0	113	40213227		
32878	2724	1127433	1997-10-30	1997-10-30 00:00:00	1997-11-20	1997-11-20 00:00:00	1997-11-20	38000177		0	0	21		0	0	0	180435	0	313782	1127433		
50129	4159	920300	2016-04-17	2016-04-17 00:00:00	2016-04-24	2016-04-24 00:00:00	2016-04-24	38000177		0	0	7		0	0	0	276352	0	311989	920300		
8014	670	19128022	1989-10-24	1989-10-24 00:00:00	1990-10-19	1990-10-19 00:00:00	1990-10-19	38000177		0	0	360		0	0	0	44207	0	749785	19128022		
41481	3437	19059056	1938-03-24	1938-03-24 00:00:00	1938-04-28	1938-04-28 00:00:00	1938-04-28	38000177		0	0	35		0	0	0	227924	0	243670	19059056		
36851	3047	40236824	2007-08-11	2007-08-11 00:00:00	2007-08-18	2007-08-18 00:00:00	2007-08-18	38000177		0	0	7		0	0	0	202723	0	1094107	40236824		
55061	4572	1118084	2018-10-24	2018-10-24 00:00:00	2018-10-24	2018-10-24 00:00:00	\N	38000177		0	0	0		0	0	0	304626	0	00025152531	44923712		
115680	2542	40213296	2005-04-15	2005-04-15 00:00:00	2005-04-15	2005-04-15 00:00:00	2005-04-15	581452		0	0	0		0	0	0	168119	0	52	40213296		
192174	4222	40213198	2015-05-07	2015-05-07 00:00:00	2015-05-07	2015-05-07 00:00:00	2015-05-07	581452		0	0	0		0	0	0	280354	0	133	40213198		
180920	3976	40213260	2013-04-25	2013-04-25 00:00:00	2013-04-25	2013-04-25 00:00:00	2013-04-25	581452		0	0	0		0	0	0	264341	0	121	40213260		
48038	3984	19133873	1968-01-21	1968-01-21 00:00:00	1968-02-01	1968-02-01 00:00:00	1968-02-01	38000177		0	0	11		0	0	0	264822	0	834061	19133873		
145832	3207	40213160	1959-03-19	1959-03-19 00:00:00	1959-03-19	1959-03-19 00:00:00	1959-03-19	581452		0	0	0		0	0	0	213185	0	10	40213160		
25864	2127	1115171	2005-06-28	2005-06-28 00:00:00	2005-07-12	2005-07-12 00:00:00	2005-07-12	38000177		0	0	14		0	0	0	141493	0	849574	1115171		
39844	3296	1127433	1998-04-22	1998-04-22 00:00:00	1998-04-29	1998-04-29 00:00:00	1998-04-29	38000177		0	0	7		0	0	0	219024	0	313782	1127433		
14821	1239	1127433	1991-09-24	1991-09-24 00:00:00	1991-10-08	1991-10-08 00:00:00	1991-10-08	38000177		0	0	14		0	0	0	81674	0	313782	1127433		
44016	3644	1127433	1965-09-05	1965-09-05 00:00:00	1965-09-12	1965-09-12 00:00:00	1965-09-12	38000177		0	0	7		0	0	0	242464	0	313782	1127433		
14896	1246	19059056	1939-04-16	1939-04-16 00:00:00	1939-04-30	1939-04-30 00:00:00	1939-04-30	38000177		0	0	14		0	0	0	82155	0	243670	19059056		
107686	2359	40213201	1992-01-06	1992-01-06 00:00:00	1992-01-06	1992-01-06 00:00:00	1992-01-06	581452		0	0	0		0	0	0	157196	0	33	40213201		
2272	184	40173590	2016-08-01	2016-08-01 00:00:00	2016-08-01	2016-08-01 00:00:00	\N	38000177		0	0	0		0	0	0	12437	0	904419	40173590		
29989	2485	19059056	1914-11-02	1914-11-02 00:00:00	1914-11-16	1914-11-16 00:00:00	1914-11-16	38000177		0	0	14		0	0	0	164590	0	243670	19059056		
22493	1848	1713671	1947-04-10	1947-04-10 00:00:00	1947-04-17	1947-04-17 00:00:00	1947-04-17	38000177		0	0	7		0	0	0	123592	0	562251	1713671		
37209	3076	1127433	1978-04-21	1978-04-21 00:00:00	1978-05-12	1978-05-12 00:00:00	1978-05-12	38000177		0	0	21		0	0	0	204643	0	313782	1127433		
12788	276	40213314	1977-09-15	1977-09-15 00:00:00	1977-09-15	1977-09-15 00:00:00	1977-09-15	581452		0	0	0		0	0	0	18451	0	49	40213314		
157138	3458	40213160	1980-01-25	1980-01-25 00:00:00	1980-01-25	1980-01-25 00:00:00	1980-01-25	581452		0	0	0		0	0	0	229492	0	10	40213160		
86280	1892	40213227	2011-07-21	2011-07-21 00:00:00	2011-07-21	2011-07-21 00:00:00	2011-07-21	581452		0	0	0		0	0	0	126014	0	113	40213227		
109877	2414	40213227	1999-09-16	1999-09-16 00:00:00	1999-09-16	1999-09-16 00:00:00	1999-09-16	581452		0	0	0		0	0	0	160247	0	113	40213227		
8254	177	40213260	2016-04-25	2016-04-25 00:00:00	2016-04-25	2016-04-25 00:00:00	2016-04-25	581452		0	0	0		0	0	0	12006	0	121	40213260		
60023	4988	19073188	1979-01-05	1979-01-05 00:00:00	1979-01-19	1979-01-19 00:00:00	1979-01-19	38000177		0	0	14		0	0	0	331855	0	308192	19073188		
965	79	1127433	1987-07-25	1987-07-25 00:00:00	1987-08-29	1987-08-29 00:00:00	1987-08-29	38000177		0	0	35		0	0	0	5267	0	313782	1127433		
23810	1960	19059056	1932-04-28	1932-04-28 00:00:00	1932-05-12	1932-05-12 00:00:00	1932-05-12	38000177		0	0	14		0	0	0	130401	0	243670	19059056		
8413	181	40213296	2015-09-27	2015-09-27 00:00:00	2015-09-27	2015-09-27 00:00:00	2015-09-27	581452		0	0	0		0	0	0	12220	0	52	40213296		
72520	1585	40213227	1992-03-29	1992-03-29 00:00:00	1992-03-29	1992-03-29 00:00:00	1992-03-29	581452		0	0	0		0	0	0	106329	0	113	40213227		
34664	2863	19133873	1961-11-14	1961-11-14 00:00:00	1961-11-21	1961-11-21 00:00:00	1961-11-21	38000177		0	0	7		0	0	0	190421	0	834061	19133873		
45160	3736	1713671	2004-11-04	2004-11-04 00:00:00	2004-11-11	2004-11-11 00:00:00	2004-11-11	38000177		0	0	7		0	0	0	248275	0	562251	1713671		
16739	1385	19073188	2016-03-23	2016-03-23 00:00:00	2016-04-13	2016-04-13 00:00:00	2016-04-13	38000177		0	0	21		0	0	0	91876	0	308192	19073188		
24420	2007	1118084	2018-08-21	2018-08-21 00:00:00	2018-08-21	2018-08-21 00:00:00	\N	38000177		0	0	0		0	0	0	133691	0	00025152531	44923712		
24466	2012	1713671	1973-04-12	1973-04-12 00:00:00	1973-04-26	1973-04-26 00:00:00	1973-04-26	38000177		0	0	14		0	0	0	133898	0	562251	1713671		
20592	1695	40229134	2007-02-27	2007-02-27 00:00:00	2007-03-13	2007-03-13 00:00:00	2007-03-13	38000177		0	0	14		0	0	0	113440	0	1043400	40229134		
32766	2712	19006318	1968-01-30	1968-01-30 00:00:00	1968-02-08	1968-02-08 00:00:00	1968-02-08	38000177		0	0	9		0	0	0	179822	0	105078	19006318		
20676	1703	1127078	1956-01-04	1956-01-04 00:00:00	1956-01-25	1956-01-25 00:00:00	1956-01-25	38000177		0	0	21		0	0	0	113926	0	282464	1127078		
10929	911	1551192	1984-05-24	1984-05-24 00:00:00	1984-05-24	1984-05-24 00:00:00	1984-05-24	38000177		0	0	0		0	0	0	60479	0	312617	1551192		
79725	1744	40213296	2016-09-09	2016-09-09 00:00:00	2016-09-09	2016-09-09 00:00:00	2016-09-09	581452		0	0	0		0	0	0	116610	0	52	40213296		
52252	4347	19128065	1980-04-06	1980-04-06 00:00:00	1981-04-01	1981-04-01 00:00:00	1981-04-01	38000177		0	0	360		0	0	0	288278	0	749882	19128065		
65765	1439	40213314	1978-09-23	1978-09-23 00:00:00	1978-09-23	1978-09-23 00:00:00	1978-09-23	581452		0	0	0		0	0	0	95926	0	49	40213314		
11261	938	19133873	1957-11-01	1957-11-01 00:00:00	1957-11-10	1957-11-10 00:00:00	1957-11-10	38000177		0	0	9		0	0	0	62315	0	834061	19133873		
100697	2206	40213227	1994-03-04	1994-03-04 00:00:00	1994-03-04	1994-03-04 00:00:00	1994-03-04	581452		0	0	0		0	0	0	147033	0	113	40213227		
40750	3378	19133905	1978-11-10	1978-11-10 00:00:00	1978-11-22	1978-11-22 00:00:00	1978-11-22	38000177		0	0	12		0	0	0	224124	0	834102	19133905		
120904	2657	40213306	1989-08-19	1989-08-19 00:00:00	1989-08-19	1989-08-19 00:00:00	1989-08-19	581452		0	0	0		0	0	0	175961	0	43	40213306		
52318	4352	19006318	1952-04-26	1952-04-26 00:00:00	1952-05-10	1952-05-10 00:00:00	1952-05-10	38000177		0	0	14		0	0	0	288646	0	105078	19006318		
13028	280	40213227	1999-11-12	1999-11-12 00:00:00	1999-11-12	1999-11-12 00:00:00	1999-11-12	581452		0	0	0		0	0	0	18759	0	113	40213227		
1863	149	19059056	1942-06-15	1942-06-15 00:00:00	1942-06-29	1942-06-29 00:00:00	1942-06-29	38000177		0	0	14		0	0	0	10052	0	243670	19059056		
52613	4374	40229134	1980-09-15	1980-09-15 00:00:00	1980-09-22	1980-09-22 00:00:00	1980-09-22	38000177		0	0	7		0	0	0	290458	0	1043400	40229134		
53291	4428	19133873	1961-11-05	1961-11-05 00:00:00	1961-11-17	1961-11-17 00:00:00	1961-11-17	38000177		0	0	12		0	0	0	294415	0	834061	19133873		
41330	3428	40229134	1973-03-20	1973-03-20 00:00:00	1973-04-03	1973-04-03 00:00:00	1973-04-03	38000177		0	0	14		0	0	0	227265	0	1043400	40229134		
2932	236	1127433	2000-06-16	2000-06-16 00:00:00	2000-07-07	2000-07-07 00:00:00	2000-07-07	38000177		0	0	21		0	0	0	15917	0	313782	1127433		
24953	2052	19078461	2014-06-30	2014-06-30 00:00:00	2014-07-28	2014-07-28 00:00:00	2014-07-28	38000177		0	0	28		0	0	0	136410	0	310965	19078461		
57243	1253	40213227	1997-03-19	1997-03-19 00:00:00	1997-03-19	1997-03-19 00:00:00	1997-03-19	581452		0	0	0		0	0	0	82535	0	113	40213227		
35533	2927	19059056	1942-10-21	1942-10-21 00:00:00	1942-11-04	1942-11-04 00:00:00	1942-11-04	38000177		0	0	14		0	0	0	195255	0	243670	19059056		
35497	2925	1713671	1981-09-11	1981-09-11 00:00:00	1981-09-25	1981-09-25 00:00:00	1981-09-25	38000177		0	0	14		0	0	0	195091	0	562251	1713671		
16299	351	40213160	1982-10-12	1982-10-12 00:00:00	1982-10-12	1982-10-12 00:00:00	1982-10-12	581452		0	0	0		0	0	0	\N	0	10	40213160		
23237	1915	1127433	2005-12-06	2005-12-06 00:00:00	2005-12-20	2005-12-20 00:00:00	2005-12-20	38000177		0	0	14		0	0	0	127406	0	313782	1127433		
18972	1568	40229134	1975-02-12	1975-02-12 00:00:00	1975-02-19	1975-02-19 00:00:00	1975-02-19	38000177		0	0	7		0	0	0	105166	0	1043400	40229134		
47209	3916	19059056	1980-12-22	1980-12-22 00:00:00	1981-01-05	1981-01-05 00:00:00	1981-01-05	38000177		0	0	14		0	0	0	260388	0	243670	19059056		
35244	2906	40222846	2010-05-09	2010-05-09 00:00:00	2010-05-09	2010-05-09 00:00:00	\N	38000177		0	0	0		0	0	0	193626	0	996740	40222846		
27807	605	40213296	1997-12-05	1997-12-05 00:00:00	1997-12-05	1997-12-05 00:00:00	1997-12-05	581452		0	0	0		0	0	0	40123	0	52	40213296		
32879	2724	19133905	1974-11-17	1974-11-17 00:00:00	1974-11-29	1974-11-29 00:00:00	1974-11-29	38000177		0	0	12		0	0	0	180496	0	834102	19133905		
50130	4160	19128065	1979-06-16	1979-06-16 00:00:00	1980-06-10	1980-06-10 00:00:00	1980-06-10	38000177		0	0	360		0	0	0	276421	0	749882	19128065		
8015	670	1127433	1998-08-24	1998-08-24 00:00:00	1998-09-14	1998-09-14 00:00:00	1998-09-14	38000177		0	0	21		0	0	0	44253	0	313782	1127433		
41482	3438	40229134	1927-01-03	1927-01-03 00:00:00	1927-01-10	1927-01-10 00:00:00	1927-01-10	38000177		0	0	7		0	0	0	228072	0	1043400	40229134		
36852	3047	19128065	1986-07-23	1986-07-23 00:00:00	1987-07-18	1987-07-18 00:00:00	1987-07-18	38000177		0	0	360		0	0	0	202757	0	749882	19128065		
55062	4572	1127433	1987-04-17	1987-04-17 00:00:00	1987-05-01	1987-05-01 00:00:00	1987-05-01	38000177		0	0	14		0	0	0	304622	0	313782	1127433		
115682	2542	40213227	2005-04-15	2005-04-15 00:00:00	2005-04-15	2005-04-15 00:00:00	2005-04-15	581452		0	0	0		0	0	0	168119	0	113	40213227		
192185	4223	40213160	1957-05-03	1957-05-03 00:00:00	1957-05-03	1957-05-03 00:00:00	1957-05-03	581452		0	0	0		0	0	0	280362	0	10	40213160		
180929	3976	40213296	2004-04-01	2004-04-01 00:00:00	2004-04-01	2004-04-01 00:00:00	2004-04-01	581452		0	0	0		0	0	0	264334	0	52	40213296		
48039	3984	40229134	1989-08-31	1989-08-31 00:00:00	1989-09-14	1989-09-14 00:00:00	1989-09-14	38000177		0	0	14		0	0	0	264837	0	1043400	40229134		
145836	3207	40213260	2008-12-11	2008-12-11 00:00:00	2008-12-11	2008-12-11 00:00:00	2008-12-11	581452		0	0	0		0	0	0	213143	0	121	40213260		
49289	4090	40171902	2017-08-14	2017-08-14 00:00:00	2017-08-14	2017-08-14 00:00:00	\N	38000177		0	0	0		0	0	0	271870	0	897718	40171902		
39845	3296	19059056	1937-07-22	1937-07-22 00:00:00	1937-08-05	1937-08-05 00:00:00	1937-08-05	38000177		0	0	14		0	0	0	218990	0	243670	19059056		
14822	1239	1713671	1987-08-24	1987-08-24 00:00:00	1987-10-12	1987-10-12 00:00:00	1987-10-12	38000177		0	0	49		0	0	0	81641	0	562251	1713671		
44017	3644	1127433	1977-09-11	1977-09-11 00:00:00	1977-10-02	1977-10-02 00:00:00	1977-10-02	38000177		0	0	21		0	0	0	242490	0	313782	1127433		
14897	1246	1127433	1972-01-14	1972-01-14 00:00:00	1972-01-28	1972-01-28 00:00:00	1972-01-28	38000177		0	0	14		0	0	0	82053	0	313782	1127433		
10982	235	40213251	1984-04-16	1984-04-16 00:00:00	1984-04-16	1984-04-16 00:00:00	1984-04-16	581452		0	0	0		0	0	0	15743	0	21	40213251		
2273	184	1713671	1955-12-05	1955-12-05 00:00:00	1955-12-26	1955-12-26 00:00:00	1955-12-26	38000177		0	0	21		0	0	0	12482	0	562251	1713671		
29990	2485	1713671	2002-11-08	2002-11-08 00:00:00	2003-01-31	2003-01-31 00:00:00	2003-01-31	38000177		0	0	84		0	0	0	164598	0	562251	1713671		
22494	1848	1127433	1985-04-03	1985-04-03 00:00:00	1985-05-03	1985-05-03 00:00:00	1985-05-03	38000177		0	0	30		0	0	0	123647	0	313782	1127433		
37210	3077	1127433	1979-11-18	1979-11-18 00:00:00	1979-12-18	1979-12-18 00:00:00	1979-12-18	38000177		0	0	30		0	0	0	204722	0	313782	1127433		
12789	276	40213160	1977-09-15	1977-09-15 00:00:00	1977-09-15	1977-09-15 00:00:00	1977-09-15	581452		0	0	0		0	0	0	18451	0	10	40213160		
157142	3458	40213160	1980-03-28	1980-03-28 00:00:00	1980-03-28	1980-03-28 00:00:00	1980-03-28	581452		0	0	0		0	0	0	229455	0	10	40213160		
86281	1892	40213260	2011-07-21	2011-07-21 00:00:00	2011-07-21	2011-07-21 00:00:00	2011-07-21	581452		0	0	0		0	0	0	126014	0	121	40213260		
109890	2414	40213227	1992-08-06	1992-08-06 00:00:00	1992-08-06	1992-08-06 00:00:00	1992-08-06	581452		0	0	0		0	0	0	160260	0	113	40213227		
8256	177	40213160	1970-11-08	1970-11-08 00:00:00	1970-11-08	1970-11-08 00:00:00	1970-11-08	581452		0	0	0		0	0	0	11999	0	10	40213160		
60024	4988	1713671	1996-07-25	1996-07-25 00:00:00	1996-08-08	1996-08-08 00:00:00	1996-08-08	38000177		0	0	14		0	0	0	331825	0	562251	1713671		
966	79	1127433	1979-02-15	1979-02-15 00:00:00	1979-03-08	1979-03-08 00:00:00	1979-03-08	38000177		0	0	21		0	0	0	5265	0	313782	1127433		
23811	1960	19133905	1983-05-27	1983-05-27 00:00:00	1983-06-06	1983-06-06 00:00:00	1983-06-06	38000177		0	0	10		0	0	0	130341	0	834102	19133905		
2730	61	40213306	1990-05-20	1990-05-20 00:00:00	1990-05-20	1990-05-20 00:00:00	1990-05-20	581452		0	0	0		0	0	0	\N	0	43	40213306		
72522	1585	40213201	1996-04-21	1996-04-21 00:00:00	1996-04-21	1996-04-21 00:00:00	1996-04-21	581452		0	0	0		0	0	0	106321	0	33	40213201		
34665	2863	19133905	2015-05-07	2015-05-07 00:00:00	2015-05-16	2015-05-16 00:00:00	2015-05-16	38000177		0	0	9		0	0	0	190416	0	834102	19133905		
45161	3736	19133905	1985-04-12	1985-04-12 00:00:00	1985-04-24	1985-04-24 00:00:00	1985-04-24	38000177		0	0	12		0	0	0	248315	0	834102	19133905		
87635	1923	40213227	2014-09-12	2014-09-12 00:00:00	2014-09-12	2014-09-12 00:00:00	2014-09-12	581452		0	0	0		0	0	0	127986	0	113	40213227		
24421	2007	46275916	1994-07-17	1994-07-17 00:00:00	1994-07-17	1994-07-17 00:00:00	1994-07-17	38000177		0	0	0		0	0	0	133660	0	1660014	46275916		
24467	2012	1713671	1966-05-21	1966-05-21 00:00:00	1966-06-11	1966-06-11 00:00:00	1966-06-11	38000177		0	0	21		0	0	0	133843	0	562251	1713671		
20593	1695	40165015	2003-06-26	2003-06-26 00:00:00	2003-06-26	2003-06-26 00:00:00	\N	38000177		0	0	0		0	0	0	113481	0	861467	40165015		
32767	2712	1713671	1987-07-18	1987-07-18 00:00:00	1987-08-08	1987-08-08 00:00:00	1987-08-08	38000177		0	0	21		0	0	0	179818	0	562251	1713671		
20677	1703	40229134	1983-09-05	1983-09-05 00:00:00	1983-09-12	1983-09-12 00:00:00	1983-09-12	38000177		0	0	7		0	0	0	113923	0	1043400	40229134		
5909	492	40236824	1983-01-03	1983-01-03 00:00:00	1983-01-10	1983-01-10 00:00:00	1983-01-10	38000177		0	0	7		0	0	0	32982	0	1094107	40236824		
79730	1744	40213227	2008-08-29	2008-08-29 00:00:00	2008-08-29	2008-08-29 00:00:00	2008-08-29	581452		0	0	0		0	0	0	116609	0	113	40213227		
52253	4347	19059056	1971-12-10	1971-12-10 00:00:00	1972-01-14	1972-01-14 00:00:00	1972-01-14	38000177		0	0	35		0	0	0	288244	0	243670	19059056		
65772	1439	40213227	2019-05-18	2019-05-18 00:00:00	2019-05-18	2019-05-18 00:00:00	2019-05-18	581452		0	0	0		0	0	0	95874	0	113	40213227		
11262	938	1127433	1976-06-20	1976-06-20 00:00:00	1976-07-18	1976-07-18 00:00:00	1976-07-18	38000177		0	0	28		0	0	0	62330	0	313782	1127433		
100698	2206	40213306	1994-03-04	1994-03-04 00:00:00	1994-03-04	1994-03-04 00:00:00	1994-03-04	581452		0	0	0		0	0	0	147033	0	43	40213306		
40751	3378	1127433	1965-10-08	1965-10-08 00:00:00	1965-10-22	1965-10-22 00:00:00	1965-10-22	38000177		0	0	14		0	0	0	224122	0	313782	1127433		
120905	2657	40213160	1966-06-18	1966-06-18 00:00:00	1966-06-18	1966-06-18 00:00:00	1966-06-18	581452		0	0	0		0	0	0	175994	0	10	40213160		
52319	4352	19059056	1965-11-27	1965-11-27 00:00:00	1966-01-26	1966-01-26 00:00:00	1966-01-26	38000177		0	0	60		0	0	0	288648	0	243670	19059056		
135496	2975	40213227	2004-04-18	2004-04-18 00:00:00	2004-04-18	2004-04-18 00:00:00	2004-04-18	581452		0	0	0		0	0	0	198701	0	113	40213227		
1864	149	1118084	1982-10-23	1982-10-23 00:00:00	1982-10-23	1982-10-23 00:00:00	\N	38000177		0	0	0		0	0	0	10074	0	00025152531	44923712		
52614	4375	19059056	1929-01-30	1929-01-30 00:00:00	1929-02-13	1929-02-13 00:00:00	1929-02-13	38000177		0	0	14		0	0	0	290680	0	243670	19059056		
53292	4428	40236824	2005-12-09	2005-12-09 00:00:00	2005-12-16	2005-12-16 00:00:00	2005-12-16	38000177		0	0	7		0	0	0	294418	0	1094107	40236824		
41331	3428	19077572	2017-05-31	2017-05-31 00:00:00	2017-05-31	2017-05-31 00:00:00	\N	38000177		0	0	0		0	0	0	227299	0	310436	19077572		
2948	239	40229134	2003-11-21	2003-11-21 00:00:00	2003-12-05	2003-12-05 00:00:00	2003-12-05	38000177		0	0	14		0	0	0	16037	0	1043400	40229134		
24954	2052	1127433	1964-02-24	1964-02-24 00:00:00	1964-03-09	1964-03-09 00:00:00	1964-03-09	38000177		0	0	14		0	0	0	136407	0	313782	1127433		
57244	1253	40213296	1997-03-19	1997-03-19 00:00:00	1997-03-19	1997-03-19 00:00:00	1997-03-19	581452		0	0	0		0	0	0	82535	0	52	40213296		
35534	2927	1115171	2010-09-13	2010-09-13 00:00:00	2010-12-12	2010-12-12 00:00:00	2010-12-12	38000177		0	0	90		0	0	0	195300	0	849574	1115171		
35498	2926	1713671	1998-12-12	1998-12-12 00:00:00	1998-12-26	1998-12-26 00:00:00	1998-12-26	38000177		0	0	14		0	0	0	195140	0	562251	1713671		
16312	351	40213296	2017-12-05	2017-12-05 00:00:00	2017-12-05	2017-12-05 00:00:00	2017-12-05	581452		0	0	0		0	0	0	23348	0	52	40213296		
23238	1915	19073188	2005-12-06	2005-12-06 00:00:00	2005-12-20	2005-12-20 00:00:00	2005-12-20	38000177		0	0	14		0	0	0	127406	0	308192	19073188		
18973	1568	1118084	1993-05-13	1993-05-13 00:00:00	1993-05-13	1993-05-13 00:00:00	\N	38000177		0	0	0		0	0	0	105224	0	00025152531	44923712		
47210	3916	1127433	2007-08-01	2007-08-01 00:00:00	2007-10-07	2007-10-07 00:00:00	2007-10-07	38000177		0	0	67		0	0	0	260440	0	313782	1127433		
35245	2906	1115171	2014-02-25	2014-02-25 00:00:00	2014-03-18	2014-03-18 00:00:00	2014-03-18	38000177		0	0	21		0	0	0	193645	0	849574	1115171		
27818	605	40213260	2006-12-29	2006-12-29 00:00:00	2006-12-29	2006-12-29 00:00:00	2006-12-29	581452		0	0	0		0	0	0	40150	0	121	40213260		
32880	2724	19059056	1962-09-13	1962-09-13 00:00:00	1962-10-04	1962-10-04 00:00:00	1962-10-04	38000177		0	0	21		0	0	0	180434	0	243670	19059056		
50131	4160	40243436	1965-11-25	1965-11-25 00:00:00	1965-11-25	1965-11-25 00:00:00	1965-11-25	38000177		0	0	0		0	0	0	276447	0	1190795	40243436		
8016	670	1118084	2017-05-11	2017-05-11 00:00:00	2017-05-11	2017-05-11 00:00:00	\N	38000177		0	0	0		0	0	0	44241	0	00025152531	44923712		
41483	3438	1118084	1946-12-29	1946-12-29 00:00:00	1946-12-29	1946-12-29 00:00:00	\N	38000177		0	0	0		0	0	0	228122	0	00025152531	44923712		
59092	1292	40213160	1955-07-26	1955-07-26 00:00:00	1955-07-26	1955-07-26 00:00:00	1955-07-26	581452		0	0	0		0	0	0	85401	0	10	40213160		
55063	4572	1127078	1978-05-02	1978-05-02 00:00:00	1978-05-16	1978-05-16 00:00:00	1978-05-16	38000177		0	0	14		0	0	0	304611	0	282464	1127078		
115694	2542	40213306	1986-03-07	1986-03-07 00:00:00	1986-03-07	1986-03-07 00:00:00	1986-03-07	581452		0	0	0		0	0	0	168140	0	43	40213306		
192186	4223	40213160	1957-07-05	1957-07-05 00:00:00	1957-07-05	1957-07-05 00:00:00	1957-07-05	581452		0	0	0		0	0	0	280395	0	10	40213160		
20914	454	40213227	1997-01-18	1997-01-18 00:00:00	1997-01-18	1997-01-18 00:00:00	1997-01-18	581452		0	0	0		0	0	0	30313	0	113	40213227		
48040	3984	1713671	1963-06-12	1963-06-12 00:00:00	1963-07-03	1963-07-03 00:00:00	1963-07-03	38000177		0	0	21		0	0	0	264842	0	562251	1713671		
145841	3207	40213160	1959-05-21	1959-05-21 00:00:00	1959-05-21	1959-05-21 00:00:00	1959-05-21	581452		0	0	0		0	0	0	213177	0	10	40213160		
49290	4090	19018935	2017-08-14	2017-08-14 00:00:00	2017-08-14	2017-08-14 00:00:00	\N	38000177		0	0	0		0	0	0	271870	0	197604	19018935		
39846	3296	1127433	1944-05-17	1944-05-17 00:00:00	1944-05-24	1944-05-24 00:00:00	1944-05-24	38000177		0	0	7		0	0	0	219062	0	313782	1127433		
14824	1239	1118084	2006-02-26	2006-02-26 00:00:00	2006-02-26	2006-02-26 00:00:00	\N	38000177		0	0	0		0	0	0	81656	0	00025152531	44923712		
44018	3644	19126352	1947-12-31	1947-12-31 00:00:00	1947-12-31	1947-12-31 00:00:00	\N	38000177		0	0	0		0	0	0	242484	0	705129	19126352		
14898	1246	1127433	2005-07-24	2005-07-24 00:00:00	2005-08-23	2005-08-23 00:00:00	2005-08-23	38000177		0	0	30		0	0	0	82056	0	313782	1127433		
18893	1560	1713671	1968-09-22	1968-09-22 00:00:00	1968-09-29	1968-09-29 00:00:00	1968-09-29	38000177		0	0	7		0	0	0	104502	0	562251	1713671		
2274	184	1118084	1987-01-03	1987-01-03 00:00:00	1987-01-03	1987-01-03 00:00:00	\N	38000177		0	0	0		0	0	0	12467	0	00025152531	44923712		
29991	2485	1118084	1953-03-09	1953-03-09 00:00:00	1953-03-09	1953-03-09 00:00:00	\N	38000177		0	0	0		0	0	0	164688	0	00025152531	44923712		
22495	1848	1127433	1960-08-23	1960-08-23 00:00:00	1960-09-06	1960-09-06 00:00:00	1960-09-06	38000177		0	0	14		0	0	0	123593	0	313782	1127433		
37211	3077	40236824	2011-07-07	2011-07-07 00:00:00	2011-07-14	2011-07-14 00:00:00	2011-07-14	38000177		0	0	7		0	0	0	204769	0	1094107	40236824		
12791	276	40213296	2018-10-25	2018-10-25 00:00:00	2018-10-25	2018-10-25 00:00:00	2018-10-25	581452		0	0	0		0	0	0	18395	0	52	40213296		
157143	3458	40213314	1980-03-28	1980-03-28 00:00:00	1980-03-28	1980-03-28 00:00:00	1980-03-28	581452		0	0	0		0	0	0	229455	0	49	40213314		
86285	1892	40213227	2003-05-08	2003-05-08 00:00:00	2003-05-08	2003-05-08 00:00:00	2003-05-08	581452		0	0	0		0	0	0	126005	0	113	40213227		
109905	2414	40213201	1984-11-22	1984-11-22 00:00:00	1984-11-22	1984-11-22 00:00:00	1984-11-22	581452		0	0	0		0	0	0	160277	0	33	40213201		
106057	2326	40213227	2002-02-14	2002-02-14 00:00:00	2002-02-14	2002-02-14 00:00:00	2002-02-14	581452		0	0	0		0	0	0	154715	0	113	40213227		
60025	4988	1713671	2000-02-26	2000-02-26 00:00:00	2000-03-04	2000-03-04 00:00:00	2000-03-04	38000177		0	0	7		0	0	0	331826	0	562251	1713671		
967	79	19059056	1967-07-05	1967-07-05 00:00:00	1967-07-19	1967-07-19 00:00:00	1967-07-19	38000177		0	0	14		0	0	0	5263	0	243670	19059056		
23812	1960	1713671	1939-03-10	1939-03-10 00:00:00	1939-03-17	1939-03-17 00:00:00	1939-03-17	38000177		0	0	7		0	0	0	130318	0	562251	1713671		
2735	61	40213160	1968-09-29	1968-09-29 00:00:00	1968-09-29	1968-09-29 00:00:00	1968-09-29	581452		0	0	0		0	0	0	4169	0	10	40213160		
72536	1585	40213227	2001-05-20	2001-05-20 00:00:00	2001-05-20	2001-05-20 00:00:00	2001-05-20	581452		0	0	0		0	0	0	106330	0	113	40213227		
34666	2863	1127433	1990-03-18	1990-03-18 00:00:00	1990-04-01	1990-04-01 00:00:00	1990-04-01	38000177		0	0	14		0	0	0	190429	0	313782	1127433		
45162	3736	1713671	1974-01-06	1974-01-06 00:00:00	1974-01-20	1974-01-20 00:00:00	1974-01-20	38000177		0	0	14		0	0	0	248348	0	562251	1713671		
87639	1923	40213227	2004-04-16	2004-04-16 00:00:00	2004-04-16	2004-04-16 00:00:00	2004-04-16	581452		0	0	0		0	0	0	127983	0	113	40213227		
24422	2007	1310034	1994-07-17	1994-07-17 00:00:00	1994-07-17	1994-07-17 00:00:00	1994-07-17	38000177		0	0	0		0	0	0	133660	0	834357	1310034		
24468	2012	1127433	1957-08-31	1957-08-31 00:00:00	1957-09-14	1957-09-14 00:00:00	1957-09-14	38000177		0	0	14		0	0	0	133896	0	313782	1127433		
20594	1695	1127433	1986-09-12	1986-09-12 00:00:00	1986-09-19	1986-09-19 00:00:00	1986-09-19	38000177		0	0	7		0	0	0	113437	0	313782	1127433		
32768	2712	19059056	1968-01-09	1968-01-09 00:00:00	1968-02-08	1968-02-08 00:00:00	1968-02-08	38000177		0	0	30		0	0	0	179881	0	243670	19059056		
20710	1707	1713671	1998-08-23	1998-08-23 00:00:00	1998-09-06	1998-09-06 00:00:00	1998-09-06	38000177		0	0	14		0	0	0	114133	0	562251	1713671		
5910	492	920300	1983-01-03	1983-01-03 00:00:00	1983-01-10	1983-01-10 00:00:00	1983-01-10	38000177		0	0	7		0	0	0	32982	0	311989	920300		
79734	1744	40213160	1980-04-11	1980-04-11 00:00:00	1980-04-11	1980-04-11 00:00:00	1980-04-11	581452		0	0	0		0	0	0	116646	0	10	40213160		
52254	4347	1713671	1998-01-09	1998-01-09 00:00:00	1998-01-23	1998-01-23 00:00:00	1998-01-23	38000177		0	0	14		0	0	0	288296	0	562251	1713671		
65773	1439	40213296	2019-05-18	2019-05-18 00:00:00	2019-05-18	2019-05-18 00:00:00	2019-05-18	581452		0	0	0		0	0	0	95874	0	52	40213296		
11263	938	1115171	2015-10-22	2015-10-22 00:00:00	2015-11-21	2015-11-21 00:00:00	2015-11-21	38000177		0	0	30		0	0	0	62331	0	849574	1115171		
100705	2206	40213227	2004-04-30	2004-04-30 00:00:00	2004-04-30	2004-04-30 00:00:00	2004-04-30	581452		0	0	0		0	0	0	146997	0	113	40213227		
40769	3381	1127433	2018-06-05	2018-06-05 00:00:00	2018-06-12	2018-06-12 00:00:00	2018-06-12	38000177		0	0	7		0	0	0	224369	0	313782	1127433		
120907	2657	40213160	1970-12-19	1970-12-19 00:00:00	1970-12-19	1970-12-19 00:00:00	1970-12-19	581452		0	0	0		0	0	0	175998	0	10	40213160		
52320	4352	1127078	1950-04-04	1950-04-04 00:00:00	1950-04-18	1950-04-18 00:00:00	1950-04-18	38000177		0	0	14		0	0	0	288713	0	282464	1127078		
135497	2975	40213296	2004-04-18	2004-04-18 00:00:00	2004-04-18	2004-04-18 00:00:00	2004-04-18	581452		0	0	0		0	0	0	198701	0	52	40213296		
1865	149	1127433	2011-09-15	2011-09-15 00:00:00	2011-09-29	2011-09-29 00:00:00	2011-09-29	38000177		0	0	14		0	0	0	10051	0	313782	1127433		
52615	4375	40174880	1982-06-26	1982-06-26 00:00:00	1982-06-26	1982-06-26 00:00:00	\N	38000177		0	0	0		0	0	0	290614	0	966222	40174880		
53293	4428	920300	2005-12-09	2005-12-09 00:00:00	2005-12-16	2005-12-16 00:00:00	2005-12-16	38000177		0	0	7		0	0	0	294418	0	311989	920300		
41332	3428	1713671	1966-10-28	1966-10-28 00:00:00	1966-11-04	1966-11-04 00:00:00	1966-11-04	38000177		0	0	7		0	0	0	227285	0	562251	1713671		
2949	239	1127433	1988-09-01	1988-09-01 00:00:00	1988-09-08	1988-09-08 00:00:00	1988-09-08	38000177		0	0	7		0	0	0	16059	0	313782	1127433		
24955	2052	19133905	1987-03-26	1987-03-26 00:00:00	1987-04-07	1987-04-07 00:00:00	1987-04-07	38000177		0	0	12		0	0	0	136408	0	834102	19133905		
57253	1253	40213160	1955-06-15	1955-06-15 00:00:00	1955-06-15	1955-06-15 00:00:00	1955-06-15	581452		0	0	0		0	0	0	82518	0	10	40213160		
43589	950	40213227	1992-11-29	1992-11-29 00:00:00	1992-11-29	1992-11-29 00:00:00	1992-11-29	581452		0	0	0		0	0	0	63074	0	113	40213227		
35499	2926	19128022	2005-07-24	2005-07-24 00:00:00	2006-07-19	2006-07-19 00:00:00	2006-07-19	38000177		0	0	360		0	0	0	195184	0	749785	19128022		
16314	352	40213314	1977-10-24	1977-10-24 00:00:00	1977-10-24	1977-10-24 00:00:00	1977-10-24	581452		0	0	0		0	0	0	23480	0	49	40213314		
23239	1915	1127433	1984-05-13	1984-05-13 00:00:00	1984-05-20	1984-05-20 00:00:00	1984-05-20	38000177		0	0	7		0	0	0	127375	0	313782	1127433		
18974	1568	1127433	1993-01-12	1993-01-12 00:00:00	1993-02-16	1993-02-16 00:00:00	1993-02-16	38000177		0	0	35		0	0	0	105224	0	313782	1127433		
47211	3916	40224805	1992-09-30	1992-09-30 00:00:00	1993-09-25	1993-09-25 00:00:00	1993-09-25	38000177		0	0	360		0	0	0	260389	0	1000126	40224805		
35246	2906	1713671	1951-07-27	1951-07-27 00:00:00	1951-08-10	1951-08-10 00:00:00	1951-08-10	38000177		0	0	14		0	0	0	193615	0	562251	1713671		
27821	605	40213160	1956-11-23	1956-11-23 00:00:00	1956-11-23	1956-11-23 00:00:00	1956-11-23	581452		0	0	0		0	0	0	40190	0	10	40213160		
32882	2724	1118084	1999-11-23	1999-11-23 00:00:00	1999-11-23	1999-11-23 00:00:00	\N	38000177		0	0	0		0	0	0	180437	0	00025152531	44923712		
50132	4160	46275916	1965-11-25	1965-11-25 00:00:00	1965-11-25	1965-11-25 00:00:00	1965-11-25	38000177		0	0	0		0	0	0	276447	0	1660014	46275916		
8017	670	19006318	1974-07-01	1974-07-01 00:00:00	1974-07-15	1974-07-15 00:00:00	1974-07-15	38000177		0	0	14		0	0	0	44205	0	105078	19006318		
41484	3438	19133905	1957-11-20	1957-11-20 00:00:00	1957-11-27	1957-11-27 00:00:00	1957-11-27	38000177		0	0	7		0	0	0	228095	0	834102	19133905		
59099	1293	40213227	1992-01-07	1992-01-07 00:00:00	1992-01-07	1992-01-07 00:00:00	1992-01-07	581452		0	0	0		0	0	0	85533	0	113	40213227		
55064	4572	19133873	1977-01-08	1977-01-08 00:00:00	1977-01-21	1977-01-21 00:00:00	1977-01-21	38000177		0	0	13		0	0	0	304610	0	834061	19133873		
115699	2542	40213227	2015-05-15	2015-05-15 00:00:00	2015-05-15	2015-05-15 00:00:00	2015-05-15	581452		0	0	0		0	0	0	168191	0	113	40213227		
192191	4223	40213260	2007-01-26	2007-01-26 00:00:00	2007-01-26	2007-01-26 00:00:00	2007-01-26	581452		0	0	0		0	0	0	280411	0	121	40213260		
208280	4569	40213227	1993-02-02	1993-02-02 00:00:00	1993-02-02	1993-02-02 00:00:00	1993-02-02	581452		0	0	0		0	0	0	304414	0	113	40213227		
48041	3984	1127433	1969-05-17	1969-05-17 00:00:00	1969-05-31	1969-05-31 00:00:00	1969-05-31	38000177		0	0	14		0	0	0	264818	0	313782	1127433		
145844	3207	40213160	1963-11-21	1963-11-21 00:00:00	1963-11-21	1963-11-21 00:00:00	1963-11-21	581452		0	0	0		0	0	0	213179	0	10	40213160		
49291	4090	40163554	2017-08-14	2017-08-14 00:00:00	2017-08-14	2017-08-14 00:00:00	\N	38000177		0	0	0		0	0	0	271870	0	855332	40163554		
39847	3296	19059056	1949-02-19	1949-02-19 00:00:00	1949-03-21	1949-03-21 00:00:00	1949-03-21	38000177		0	0	30		0	0	0	219091	0	243670	19059056		
14825	1239	40169281	2014-07-10	2014-07-10 00:00:00	2014-07-10	2014-07-10 00:00:00	\N	38000177		0	0	0		0	0	0	81688	0	896209	40169281		
44019	3644	1127433	1975-05-29	1975-05-29 00:00:00	1975-06-12	1975-06-12 00:00:00	1975-06-12	38000177		0	0	14		0	0	0	242494	0	313782	1127433		
14899	1246	1127433	2011-03-12	2011-03-12 00:00:00	2011-03-26	2011-03-26 00:00:00	2011-03-26	38000177		0	0	14		0	0	0	82016	0	313782	1127433		
18894	1560	19018935	2018-02-05	2018-02-05 00:00:00	2018-02-05	2018-02-05 00:00:00	\N	38000177		0	0	0		0	0	0	104471	0	197604	19018935		
2276	184	19133905	1966-10-28	1966-10-28 00:00:00	1966-11-05	1966-11-05 00:00:00	1966-11-05	38000177		0	0	8		0	0	0	12433	0	834102	19133905		
29992	2485	1127433	1920-04-28	1920-04-28 00:00:00	1920-05-12	1920-05-12 00:00:00	1920-05-12	38000177		0	0	14		0	0	0	164571	0	313782	1127433		
22496	1848	40229134	1970-12-15	1970-12-15 00:00:00	1970-12-29	1970-12-29 00:00:00	1970-12-29	38000177		0	0	14		0	0	0	123595	0	1043400	40229134		
37212	3077	920300	2011-07-07	2011-07-07 00:00:00	2011-07-14	2011-07-14 00:00:00	2011-07-14	38000177		0	0	7		0	0	0	204769	0	311989	920300		
12793	276	40213227	2018-10-25	2018-10-25 00:00:00	2018-10-25	2018-10-25 00:00:00	2018-10-25	581452		0	0	0		0	0	0	18395	0	113	40213227		
157146	3458	40213314	1980-12-26	1980-12-26 00:00:00	1980-12-26	1980-12-26 00:00:00	1980-12-26	581452		0	0	0		0	0	0	229456	0	49	40213314		
86286	1892	40213296	2003-05-08	2003-05-08 00:00:00	2003-05-08	2003-05-08 00:00:00	2003-05-08	581452		0	0	0		0	0	0	126005	0	52	40213296		
121189	2663	40213160	1964-05-10	1964-05-10 00:00:00	1964-05-10	1964-05-10 00:00:00	1964-05-10	581452		0	0	0		0	0	0	176489	0	10	40213160		
106059	2326	40213160	1955-01-13	1955-01-13 00:00:00	1955-01-13	1955-01-13 00:00:00	1955-01-13	581452		0	0	0		0	0	0	154705	0	10	40213160		
60026	4988	40229134	1988-03-28	1988-03-28 00:00:00	1988-04-11	1988-04-11 00:00:00	1988-04-11	38000177		0	0	14		0	0	0	331824	0	1043400	40229134		
968	79	1713671	1996-06-05	1996-06-05 00:00:00	1996-07-03	1996-07-03 00:00:00	1996-07-03	38000177		0	0	28		0	0	0	5246	0	562251	1713671		
23813	1960	19059056	1934-12-31	1934-12-31 00:00:00	1935-01-14	1935-01-14 00:00:00	1935-01-14	38000177		0	0	14		0	0	0	130402	0	243670	19059056		
2737	61	40213296	2008-01-27	2008-01-27 00:00:00	2008-01-27	2008-01-27 00:00:00	2008-01-27	581452		0	0	0		0	0	0	4178	0	52	40213296		
187392	4116	40213260	2018-10-18	2018-10-18 00:00:00	2018-10-18	2018-10-18 00:00:00	2018-10-18	581452		0	0	0		0	0	0	273624	0	121	40213260		
34667	2863	19112599	1966-10-04	1966-10-04 00:00:00	1966-10-04	1966-10-04 00:00:00	\N	38000177		0	0	0		0	0	0	190423	0	477045	19112599		
45163	3736	19133873	1964-06-09	1964-06-09 00:00:00	1964-06-17	1964-06-17 00:00:00	1964-06-17	38000177		0	0	8		0	0	0	248312	0	834061	19133873		
87644	1923	40213201	1999-03-19	1999-03-19 00:00:00	1999-03-19	1999-03-19 00:00:00	1999-03-19	581452		0	0	0		0	0	0	127903	0	33	40213201		
24423	2007	40243436	1994-07-17	1994-07-17 00:00:00	1994-07-17	1994-07-17 00:00:00	1994-07-17	38000177		0	0	0		0	0	0	133660	0	1190795	40243436		
24469	2012	19059056	1976-02-22	1976-02-22 00:00:00	1976-03-07	1976-03-07 00:00:00	1976-03-07	38000177		0	0	14		0	0	0	133864	0	243670	19059056		
20595	1695	1127433	2016-09-15	2016-09-15 00:00:00	2016-09-29	2016-09-29 00:00:00	2016-09-29	38000177		0	0	14		0	0	0	113484	0	313782	1127433		
32786	2715	1332419	1994-06-09	1994-06-09 00:00:00	1994-06-09	1994-06-09 00:00:00	\N	38000177		0	0	0		0	0	0	180089	0	197361	1332419		
20711	1707	1127078	1973-10-23	1973-10-23 00:00:00	1973-11-06	1973-11-06 00:00:00	1973-11-06	38000177		0	0	14		0	0	0	114143	0	282464	1127078		
5911	492	19078461	2010-07-16	2010-07-16 00:00:00	2010-07-30	2010-07-30 00:00:00	2010-07-30	38000177		0	0	14		0	0	0	32944	0	310965	19078461		
79742	1744	40213160	1976-01-09	1976-01-09 00:00:00	1976-01-09	1976-01-09 00:00:00	1976-01-09	581452		0	0	0		0	0	0	116594	0	10	40213160		
52255	4347	19128065	1981-04-01	1981-04-01 00:00:00	1982-03-27	1982-03-27 00:00:00	1982-03-27	38000177		0	0	360		0	0	0	288279	0	749882	19128065		
65775	1439	40213160	1977-11-19	1977-11-19 00:00:00	1977-11-19	1977-11-19 00:00:00	1977-11-19	581452		0	0	0		0	0	0	95901	0	10	40213160		
11264	938	19059056	1952-05-13	1952-05-13 00:00:00	1952-07-12	1952-07-12 00:00:00	1952-07-12	38000177		0	0	60		0	0	0	62327	0	243670	19059056		
2331	187	19059056	1957-04-20	1957-04-20 00:00:00	1957-05-05	1957-05-05 00:00:00	1957-05-05	38000177		0	0	15		0	0	0	12733	0	243670	19059056		
40770	3381	19073183	1979-04-19	1979-04-19 00:00:00	1979-05-03	1979-05-03 00:00:00	1979-05-03	38000177		0	0	14		0	0	0	224352	0	308182	19073183		
120909	2657	40213260	2016-01-09	2016-01-09 00:00:00	2016-01-09	2016-01-09 00:00:00	2016-01-09	581452		0	0	0		0	0	0	175990	0	121	40213260		
52321	4352	19006318	1950-04-04	1950-04-04 00:00:00	1950-04-18	1950-04-18 00:00:00	1950-04-18	38000177		0	0	14		0	0	0	288713	0	105078	19006318		
135500	2975	40213296	2002-04-14	2002-04-14 00:00:00	2002-04-14	2002-04-14 00:00:00	2002-04-14	581452		0	0	0		0	0	0	198679	0	52	40213296		
1866	149	19074679	1948-08-17	1948-08-17 00:00:00	1949-03-15	1949-03-15 00:00:00	1949-03-15	38000177		0	0	210		0	0	0	10102	0	308971	19074679		
52616	4375	40173590	2018-03-04	2018-03-04 00:00:00	2018-03-04	2018-03-04 00:00:00	\N	38000177		0	0	0		0	0	0	290599	0	904419	40173590		
53294	4428	19059056	1952-05-13	1952-05-13 00:00:00	1952-05-27	1952-05-27 00:00:00	1952-05-27	38000177		0	0	14		0	0	0	294369	0	243670	19059056		
41333	3428	1713671	2019-03-16	2019-03-16 00:00:00	2019-04-06	2019-04-06 00:00:00	2019-04-06	38000177		0	0	21		0	0	0	227290	0	562251	1713671		
2950	239	1118084	1992-04-26	1992-04-26 00:00:00	1992-04-26	1992-04-26 00:00:00	\N	38000177		0	0	0		0	0	0	16036	0	00025152531	44923712		
24956	2052	40229134	2000-11-29	2000-11-29 00:00:00	2000-12-06	2000-12-06 00:00:00	2000-12-06	38000177		0	0	7		0	0	0	136440	0	1043400	40229134		
57260	1253	40213160	1955-11-16	1955-11-16 00:00:00	1955-11-16	1955-11-16 00:00:00	1955-11-16	581452		0	0	0		0	0	0	82519	0	10	40213160		
43590	950	40213306	1992-11-29	1992-11-29 00:00:00	1992-11-29	1992-11-29 00:00:00	1992-11-29	581452		0	0	0		0	0	0	63074	0	43	40213306		
35500	2926	1127433	1984-09-04	1984-09-04 00:00:00	1984-09-11	1984-09-11 00:00:00	1984-09-11	38000177		0	0	7		0	0	0	195195	0	313782	1127433		
16315	352	40213160	1977-10-24	1977-10-24 00:00:00	1977-10-24	1977-10-24 00:00:00	1977-10-24	581452		0	0	0		0	0	0	23480	0	10	40213160		
23240	1915	1127433	2018-09-13	2018-09-13 00:00:00	2018-09-27	2018-09-27 00:00:00	2018-09-27	38000177		0	0	14		0	0	0	127407	0	313782	1127433		
18975	1568	1127433	1986-01-03	1986-01-03 00:00:00	1986-01-10	1986-01-10 00:00:00	1986-01-10	38000177		0	0	7		0	0	0	105167	0	313782	1127433		
47212	3916	1115171	2003-07-23	2003-07-23 00:00:00	2003-10-21	2003-10-21 00:00:00	2003-10-21	38000177		0	0	90		0	0	0	260438	0	849574	1115171		
35247	2906	920300	1982-06-13	1982-06-13 00:00:00	1982-06-20	1982-06-20 00:00:00	1982-06-20	38000177		0	0	7		0	0	0	193739	0	311989	920300		
27826	605	40213160	1956-09-21	1956-09-21 00:00:00	1956-09-21	1956-09-21 00:00:00	1956-09-21	581452		0	0	0		0	0	0	40166	0	10	40213160		
104078	2283	40213201	2004-08-30	2004-08-30 00:00:00	2004-08-30	2004-08-30 00:00:00	2004-08-30	581452		0	0	0		0	0	0	151930	0	33	40213201		
60591	5039	1127078	1977-01-19	1977-01-19 00:00:00	1977-02-02	1977-02-02 00:00:00	1977-02-02	38000177		0	0	14		0	0	0	334884	0	282464	1127078		
8018	670	1127078	1974-07-01	1974-07-01 00:00:00	1974-07-15	1974-07-15 00:00:00	1974-07-15	38000177		0	0	14		0	0	0	44205	0	282464	1127078		
41485	3438	19059056	1934-09-03	1934-09-03 00:00:00	1934-10-03	1934-10-03 00:00:00	1934-10-03	38000177		0	0	30		0	0	0	228134	0	243670	19059056		
59109	1293	40213227	2011-03-01	2011-03-01 00:00:00	2011-03-01	2011-03-01 00:00:00	2011-03-01	581452		0	0	0		0	0	0	85506	0	113	40213227		
55065	4572	1713671	2008-04-25	2008-04-25 00:00:00	2008-06-13	2008-06-13 00:00:00	2008-06-13	38000177		0	0	49		0	0	0	304623	0	562251	1713671		
115700	2542	40213260	2015-05-15	2015-05-15 00:00:00	2015-05-15	2015-05-15 00:00:00	2015-05-15	581452		0	0	0		0	0	0	168191	0	121	40213260		
192198	4223	40213296	1999-08-13	1999-08-13 00:00:00	1999-08-13	1999-08-13 00:00:00	1999-08-13	581452		0	0	0		0	0	0	280437	0	52	40213296		
208284	4569	40213160	1962-05-01	1962-05-01 00:00:00	1962-05-01	1962-05-01 00:00:00	1962-05-01	581452		0	0	0		0	0	0	304378	0	10	40213160		
48042	3984	1127433	2006-10-19	2006-10-19 00:00:00	2006-11-23	2006-11-23 00:00:00	2006-11-23	38000177		0	0	35		0	0	0	264886	0	313782	1127433		
70649	1545	40213160	1973-11-16	1973-11-16 00:00:00	1973-11-16	1973-11-16 00:00:00	1973-11-16	581452		0	0	0		0	0	0	103542	0	10	40213160		
49292	4090	1127433	1988-06-21	1988-06-21 00:00:00	1988-06-28	1988-06-28 00:00:00	1988-06-28	38000177		0	0	7		0	0	0	271845	0	313782	1127433		
39848	3296	19115351	1966-09-18	1966-09-18 00:00:00	1967-01-22	1967-01-22 00:00:00	1967-01-22	38000177		0	0	126		0	0	0	219093	0	563026	19115351		
14826	1239	46233988	1972-11-11	1972-11-11 00:00:00	1972-11-25	1972-11-25 00:00:00	1972-11-25	38000177		0	0	14		0	0	0	81676	0	1652673	46233988		
44020	3644	40229134	1961-02-05	1961-02-05 00:00:00	1961-02-19	1961-02-19 00:00:00	1961-02-19	38000177		0	0	14		0	0	0	242474	0	1043400	40229134		
14900	1246	19073188	2011-03-12	2011-03-12 00:00:00	2011-03-26	2011-03-26 00:00:00	2011-03-26	38000177		0	0	14		0	0	0	82016	0	308192	19073188		
18895	1560	40171902	2018-02-05	2018-02-05 00:00:00	2018-02-05	2018-02-05 00:00:00	\N	38000177		0	0	0		0	0	0	104471	0	897718	40171902		
2277	184	40229134	1983-12-02	1983-12-02 00:00:00	1983-12-09	1983-12-09 00:00:00	1983-12-09	38000177		0	0	7		0	0	0	12431	0	1043400	40229134		
29993	2485	40229134	1924-07-25	1924-07-25 00:00:00	1924-08-01	1924-08-01 00:00:00	1924-08-01	38000177		0	0	7		0	0	0	164593	0	1043400	40229134		
22497	1848	19059056	1957-03-10	1957-03-10 00:00:00	1957-03-31	1957-03-31 00:00:00	1957-03-31	38000177		0	0	21		0	0	0	123677	0	243670	19059056		
37213	3077	40229134	2007-10-09	2007-10-09 00:00:00	2007-10-23	2007-10-23 00:00:00	2007-10-23	38000177		0	0	14		0	0	0	204768	0	1043400	40229134		
12795	276	40213160	1978-02-16	1978-02-16 00:00:00	1978-02-16	1978-02-16 00:00:00	1978-02-16	581452		0	0	0		0	0	0	18435	0	10	40213160		
157149	3458	40213227	2010-10-29	2010-10-29 00:00:00	2010-10-29	2010-10-29 00:00:00	2010-10-29	581452		0	0	0		0	0	0	229480	0	113	40213227		
86292	1892	40213160	1961-03-23	1961-03-23 00:00:00	1961-03-23	1961-03-23 00:00:00	1961-03-23	581452		0	0	0		0	0	0	126033	0	10	40213160		
121191	2663	40213160	1963-12-08	1963-12-08 00:00:00	1963-12-08	1963-12-08 00:00:00	1963-12-08	581452		0	0	0		0	0	0	176488	0	10	40213160		
106064	2326	40213160	1956-01-19	1956-01-19 00:00:00	1956-01-19	1956-01-19 00:00:00	1956-01-19	581452		0	0	0		0	0	0	154679	0	10	40213160		
60031	4990	1127433	1975-04-09	1975-04-09 00:00:00	1975-04-23	1975-04-23 00:00:00	1975-04-23	38000177		0	0	14		0	0	0	331961	0	313782	1127433		
969	79	19078461	2016-08-26	2016-08-26 00:00:00	2016-09-23	2016-09-23 00:00:00	2016-09-23	38000177		0	0	28		0	0	0	5273	0	310965	19078461		
23814	1960	19059056	1936-02-07	1936-02-07 00:00:00	1936-03-13	1936-03-13 00:00:00	1936-03-13	38000177		0	0	35		0	0	0	130330	0	243670	19059056		
2741	61	40213160	1972-12-31	1972-12-31 00:00:00	1972-12-31	1972-12-31 00:00:00	1972-12-31	581452		0	0	0		0	0	0	4111	0	10	40213160		
187395	4116	40213160	1973-09-27	1973-09-27 00:00:00	1973-09-27	1973-09-27 00:00:00	1973-09-27	581452		0	0	0		0	0	0	273658	0	10	40213160		
34668	2863	19059056	1988-05-16	1988-05-16 00:00:00	1988-08-14	1988-08-14 00:00:00	1988-08-14	38000177		0	0	90		0	0	0	190390	0	243670	19059056		
45164	3736	19133873	1968-02-26	1968-02-26 00:00:00	1968-03-10	1968-03-10 00:00:00	1968-03-10	38000177		0	0	13		0	0	0	248256	0	834061	19133873		
179369	3943	40213160	1955-01-20	1955-01-20 00:00:00	1955-01-20	1955-01-20 00:00:00	1955-01-20	581452		0	0	0		0	0	0	262173	0	10	40213160		
24424	2007	1713671	1996-11-08	1996-11-08 00:00:00	1996-11-29	1996-11-29 00:00:00	1996-11-29	38000177		0	0	21		0	0	0	133666	0	562251	1713671		
24470	2012	19006318	1971-05-10	1971-05-10 00:00:00	1971-05-24	1971-05-24 00:00:00	1971-05-24	38000177		0	0	14		0	0	0	133907	0	105078	19006318		
20597	1695	19128065	1984-11-30	1984-11-30 00:00:00	1985-11-25	1985-11-25 00:00:00	1985-11-25	38000177		0	0	360		0	0	0	113427	0	749882	19128065		
32787	2715	19133873	1974-10-01	1974-10-01 00:00:00	1974-10-11	1974-10-11 00:00:00	1974-10-11	38000177		0	0	10		0	0	0	180003	0	834061	19133873		
20712	1707	19006318	1973-10-23	1973-10-23 00:00:00	1973-11-06	1973-11-06 00:00:00	1973-11-06	38000177		0	0	14		0	0	0	114143	0	105078	19006318		
5912	492	1127433	2006-09-02	2006-09-02 00:00:00	2006-09-09	2006-09-09 00:00:00	2006-09-09	38000177		0	0	7		0	0	0	32941	0	313782	1127433		
79744	1745	40213314	1979-06-25	1979-06-25 00:00:00	1979-06-25	1979-06-25 00:00:00	1979-06-25	581452		0	0	0		0	0	0	116660	0	49	40213314		
52256	4347	19059056	1969-05-24	1969-05-24 00:00:00	1969-06-07	1969-06-07 00:00:00	1969-06-07	38000177		0	0	14		0	0	0	288304	0	243670	19059056		
65776	1439	40213314	1977-11-19	1977-11-19 00:00:00	1977-11-19	1977-11-19 00:00:00	1977-11-19	581452		0	0	0		0	0	0	95901	0	49	40213314		
11265	938	40236824	1974-08-27	1974-08-27 00:00:00	1974-09-03	1974-09-03 00:00:00	1974-09-03	38000177		0	0	7		0	0	0	62410	0	1094107	40236824		
2332	187	19059056	1948-04-07	1948-04-07 00:00:00	1948-05-08	1948-05-08 00:00:00	1948-05-08	38000177		0	0	31		0	0	0	12732	0	243670	19059056		
40771	3381	19019979	1979-04-19	1979-04-19 00:00:00	1979-05-03	1979-05-03 00:00:00	1979-05-03	38000177		0	0	14		0	0	0	224352	0	198405	19019979		
120910	2657	40213227	1998-06-06	1998-06-06 00:00:00	1998-06-06	1998-06-06 00:00:00	1998-06-06	581452		0	0	0		0	0	0	175985	0	113	40213227		
52322	4352	1118084	1987-04-11	1987-04-11 00:00:00	1987-04-11	1987-04-11 00:00:00	\N	38000177		0	0	0		0	0	0	288649	0	00025152531	44923712		
146814	3229	40213227	2002-06-07	2002-06-07 00:00:00	2002-06-07	2002-06-07 00:00:00	2002-06-07	581452		0	0	0		0	0	0	214585	0	113	40213227		
170462	3748	40213314	1980-05-20	1980-05-20 00:00:00	1980-05-20	1980-05-20 00:00:00	1980-05-20	581452		0	0	0		0	0	0	249130	0	49	40213314		
52617	4375	1713671	1959-08-03	1959-08-03 00:00:00	1959-08-24	1959-08-24 00:00:00	1959-08-24	38000177		0	0	21		0	0	0	290637	0	562251	1713671		
53295	4428	19006318	1952-05-13	1952-05-13 00:00:00	1952-05-27	1952-05-27 00:00:00	1952-05-27	38000177		0	0	14		0	0	0	294369	0	105078	19006318		
41334	3428	1127433	2010-06-03	2010-06-03 00:00:00	2010-06-24	2010-06-24 00:00:00	2010-06-24	38000177		0	0	21		0	0	0	227263	0	313782	1127433		
2951	239	19126352	2012-01-12	2012-01-12 00:00:00	2012-07-05	2012-07-05 00:00:00	2012-07-05	38000177		0	0	175		0	0	0	16025	0	705129	19126352		
24957	2052	1127433	1973-03-28	1973-03-28 00:00:00	1973-04-04	1973-04-04 00:00:00	1973-04-04	38000177		0	0	7		0	0	0	136438	0	313782	1127433		
57261	1253	40213160	1955-08-17	1955-08-17 00:00:00	1955-08-17	1955-08-17 00:00:00	1955-08-17	581452		0	0	0		0	0	0	82498	0	10	40213160		
43597	950	40213227	2012-08-26	2012-08-26 00:00:00	2012-08-26	2012-08-26 00:00:00	2012-08-26	581452		0	0	0		0	0	0	63082	0	113	40213227		
35501	2926	19128009	2003-08-04	2003-08-04 00:00:00	2004-07-29	2004-07-29 00:00:00	2004-07-29	38000177		0	0	360		0	0	0	195183	0	749762	19128009		
16318	352	40213160	1978-03-27	1978-03-27 00:00:00	1978-03-27	1978-03-27 00:00:00	1978-03-27	581452		0	0	0		0	0	0	23481	0	10	40213160		
33699	2788	40165015	2017-12-01	2017-12-01 00:00:00	2017-12-01	2017-12-01 00:00:00	\N	38000177		0	0	0		0	0	0	184722	0	861467	40165015		
18976	1568	1127433	1977-09-08	1977-09-08 00:00:00	1977-09-15	1977-09-15 00:00:00	1977-09-15	38000177		0	0	7		0	0	0	105184	0	313782	1127433		
47213	3916	19128065	1997-09-04	1997-09-04 00:00:00	1998-08-30	1998-08-30 00:00:00	1998-08-30	38000177		0	0	360		0	0	0	260396	0	749882	19128065		
35248	2906	40236824	1982-06-13	1982-06-13 00:00:00	1982-06-20	1982-06-20 00:00:00	1982-06-20	38000177		0	0	7		0	0	0	193739	0	1094107	40236824		
27836	606	40213160	1975-10-22	1975-10-22 00:00:00	1975-10-22	1975-10-22 00:00:00	1975-10-22	581452		0	0	0		0	0	0	40202	0	10	40213160		
104108	2283	40213227	2018-11-19	2018-11-19 00:00:00	2018-11-19	2018-11-19 00:00:00	2018-11-19	581452		0	0	0		0	0	0	151872	0	113	40213227		
60592	5039	40162522	1994-12-17	1994-12-17 00:00:00	1994-12-17	1994-12-17 00:00:00	\N	38000177		0	0	0		0	0	0	334867	0	857005	40162522		
8036	672	1127433	1965-04-19	1965-04-19 00:00:00	1965-05-03	1965-05-03 00:00:00	1965-05-03	38000177		0	0	14		0	0	0	44335	0	313782	1127433		
41486	3438	40231925	1924-06-27	1924-06-27 00:00:00	1924-06-27	1924-06-27 00:00:00	\N	38000177		0	0	0		0	0	0	228133	0	1049221	40231925		
59115	1293	40213227	2001-02-27	2001-02-27 00:00:00	2001-02-27	2001-02-27 00:00:00	2001-02-27	581452		0	0	0		0	0	0	85534	0	113	40213227		
55066	4572	19059056	1977-11-08	1977-11-08 00:00:00	1977-12-13	1977-12-13 00:00:00	1977-12-13	38000177		0	0	35		0	0	0	304636	0	243670	19059056		
115702	2542	40213160	1968-05-10	1968-05-10 00:00:00	1968-05-10	1968-05-10 00:00:00	1968-05-10	581452		0	0	0		0	0	0	168144	0	10	40213160		
192200	4223	40213227	1999-08-13	1999-08-13 00:00:00	1999-08-13	1999-08-13 00:00:00	1999-08-13	581452		0	0	0		0	0	0	280437	0	113	40213227		
208288	4569	40213296	2002-01-29	2002-01-29 00:00:00	2002-01-29	2002-01-29 00:00:00	2002-01-29	581452		0	0	0		0	0	0	304391	0	52	40213296		
48043	3984	19018935	2014-11-26	2014-11-26 00:00:00	2014-11-26	2014-11-26 00:00:00	\N	38000177		0	0	0		0	0	0	264884	0	197604	19018935		
70652	1545	40213227	2010-10-08	2010-10-08 00:00:00	2010-10-08	2010-10-08 00:00:00	2010-10-08	581452		0	0	0		0	0	0	103547	0	113	40213227		
49293	4090	40165015	1955-01-21	1955-01-21 00:00:00	1955-01-21	1955-01-21 00:00:00	\N	38000177		0	0	0		0	0	0	271905	0	861467	40165015		
39849	3296	40229134	2004-07-04	2004-07-04 00:00:00	2004-07-18	2004-07-18 00:00:00	2004-07-18	38000177		0	0	14		0	0	0	219068	0	1043400	40229134		
14827	1239	1127078	1972-11-11	1972-11-11 00:00:00	1972-11-25	1972-11-25 00:00:00	1972-11-25	38000177		0	0	14		0	0	0	81676	0	282464	1127078		
44021	3644	19133873	1947-11-21	1947-11-21 00:00:00	1947-12-01	1947-12-01 00:00:00	1947-12-01	38000177		0	0	10		0	0	0	242471	0	834061	19133873		
14901	1246	19077572	2012-11-02	2012-11-02 00:00:00	2012-11-02	2012-11-02 00:00:00	\N	38000177		0	0	0		0	0	0	82087	0	310436	19077572		
18896	1560	40163554	2018-02-05	2018-02-05 00:00:00	2018-02-05	2018-02-05 00:00:00	\N	38000177		0	0	0		0	0	0	104471	0	855332	40163554		
2278	184	19133873	1949-04-14	1949-04-14 00:00:00	1949-04-27	1949-04-27 00:00:00	1949-04-27	38000177		0	0	13		0	0	0	12428	0	834061	19133873		
29994	2485	1127433	1990-03-11	1990-03-11 00:00:00	1990-06-09	1990-06-09 00:00:00	1990-06-09	38000177		0	0	90		0	0	0	164690	0	313782	1127433		
59267	1297	40213314	1978-11-19	1978-11-19 00:00:00	1978-11-19	1978-11-19 00:00:00	1978-11-19	581452		0	0	0		0	0	0	85734	0	49	40213314		
37214	3077	1127078	1963-03-02	1963-03-02 00:00:00	1963-03-30	1963-03-30 00:00:00	1963-03-30	38000177		0	0	28		0	0	0	204716	0	282464	1127078		
12801	276	40213160	1982-05-20	1982-05-20 00:00:00	1982-05-20	1982-05-20 00:00:00	1982-05-20	581452		0	0	0		0	0	0	18425	0	10	40213160		
157158	3458	40213251	1984-09-28	1984-09-28 00:00:00	1984-09-28	1984-09-28 00:00:00	1984-09-28	581452		0	0	0		0	0	0	229459	0	21	40213251		
86295	1892	40213306	1981-04-02	1981-04-02 00:00:00	1981-04-02	1981-04-02 00:00:00	1981-04-02	581452		0	0	0		0	0	0	\N	0	43	40213306		
52885	4393	40229134	2011-12-20	2011-12-20 00:00:00	2011-12-27	2011-12-27 00:00:00	2011-12-27	38000177		0	0	7		0	0	0	292091	0	1043400	40229134		
106067	2326	40213201	2017-05-11	2017-05-11 00:00:00	2017-05-11	2017-05-11 00:00:00	2017-05-11	581452		0	0	0		0	0	0	154719	0	33	40213201		
60032	4990	19059056	1966-07-02	1966-07-02 00:00:00	1966-07-16	1966-07-16 00:00:00	1966-07-16	38000177		0	0	14		0	0	0	331924	0	243670	19059056		
970	79	1713671	1966-01-05	1966-01-05 00:00:00	1966-01-26	1966-01-26 00:00:00	1966-01-26	38000177		0	0	21		0	0	0	5299	0	562251	1713671		
23815	1960	920300	1954-09-22	1954-09-22 00:00:00	1954-09-29	1954-09-29 00:00:00	1954-09-29	38000177		0	0	7		0	0	0	130336	0	311989	920300		
2742	61	40213160	1968-04-28	1968-04-28 00:00:00	1968-04-28	1968-04-28 00:00:00	1968-04-28	581452		0	0	0		0	0	0	4083	0	10	40213160		
187402	4116	40213306	1991-10-17	1991-10-17 00:00:00	1991-10-17	1991-10-17 00:00:00	1991-10-17	581452		0	0	0		0	0	0	273662	0	43	40213306		
34669	2863	40165015	1988-05-16	1988-05-16 00:00:00	1988-05-16	1988-05-16 00:00:00	\N	38000177		0	0	0		0	0	0	190390	0	861467	40165015		
45165	3736	1127433	1962-06-07	1962-06-07 00:00:00	1962-06-14	1962-06-14 00:00:00	1962-06-14	38000177		0	0	7		0	0	0	248311	0	313782	1127433		
179375	3943	40213160	1956-01-19	1956-01-19 00:00:00	1956-01-19	1956-01-19 00:00:00	1956-01-19	581452		0	0	0		0	0	0	262193	0	10	40213160		
24425	2007	19133873	1994-05-27	1994-05-27 00:00:00	1994-06-06	1994-06-06 00:00:00	1994-06-06	38000177		0	0	10		0	0	0	133680	0	834061	19133873		
24471	2012	19059056	1971-05-10	1971-05-10 00:00:00	1971-05-24	1971-05-24 00:00:00	1971-05-24	38000177		0	0	14		0	0	0	133907	0	243670	19059056		
20598	1695	19128065	1982-12-11	1982-12-11 00:00:00	1983-12-06	1983-12-06 00:00:00	1983-12-06	38000177		0	0	360		0	0	0	113425	0	749882	19128065		
32788	2715	1127433	1966-06-14	1966-06-14 00:00:00	1966-06-28	1966-06-28 00:00:00	1966-06-28	38000177		0	0	14		0	0	0	180037	0	313782	1127433		
20713	1707	1127078	1976-06-02	1976-06-02 00:00:00	1976-06-16	1976-06-16 00:00:00	1976-06-16	38000177		0	0	14		0	0	0	114134	0	282464	1127078		
5913	492	1127433	2016-03-31	2016-03-31 00:00:00	2016-04-14	2016-04-14 00:00:00	2016-04-14	38000177		0	0	14		0	0	0	32954	0	313782	1127433		
79745	1745	40213160	1979-06-25	1979-06-25 00:00:00	1979-06-25	1979-06-25 00:00:00	1979-06-25	581452		0	0	0		0	0	0	116660	0	10	40213160		
52257	4347	1127433	2012-06-12	2012-06-12 00:00:00	2012-07-03	2012-07-03 00:00:00	2012-07-03	38000177		0	0	21		0	0	0	288293	0	313782	1127433		
65777	1439	40213227	2009-08-01	2009-08-01 00:00:00	2009-08-01	2009-08-01 00:00:00	2009-08-01	581452		0	0	0		0	0	0	95883	0	113	40213227		
11266	938	920300	1974-08-27	1974-08-27 00:00:00	1974-09-03	1974-09-03 00:00:00	1974-09-03	38000177		0	0	7		0	0	0	62410	0	311989	920300		
2333	187	1127433	1999-07-27	1999-07-27 00:00:00	1999-08-03	1999-08-03 00:00:00	1999-08-03	38000177		0	0	7		0	0	0	12745	0	313782	1127433		
40772	3381	1127433	1988-01-11	1988-01-11 00:00:00	1988-01-25	1988-01-25 00:00:00	1988-01-25	38000177		0	0	14		0	0	0	224397	0	313782	1127433		
196308	4313	40213227	2009-05-09	2009-05-09 00:00:00	2009-05-09	2009-05-09 00:00:00	2009-05-09	581452		0	0	0		0	0	0	286348	0	113	40213227		
52323	4352	1127078	1956-03-19	1956-03-19 00:00:00	1956-06-17	1956-06-17 00:00:00	1956-06-17	38000177		0	0	90		0	0	0	288672	0	282464	1127078		
146815	3229	40213306	2002-06-07	2002-06-07 00:00:00	2002-06-07	2002-06-07 00:00:00	2002-06-07	581452		0	0	0		0	0	0	214585	0	43	40213306		
170466	3748	40213227	2011-08-23	2011-08-23 00:00:00	2011-08-23	2011-08-23 00:00:00	2011-08-23	581452		0	0	0		0	0	0	249135	0	113	40213227		
52618	4375	920300	1980-07-21	1980-07-21 00:00:00	1980-07-28	1980-07-28 00:00:00	1980-07-28	38000177		0	0	7		0	0	0	290679	0	311989	920300		
53296	4428	1127433	1972-10-25	1972-10-25 00:00:00	1972-11-07	1972-11-07 00:00:00	1972-11-07	38000177		0	0	13		0	0	0	294345	0	313782	1127433		
51793	4305	1115171	2013-07-15	2013-07-15 00:00:00	2013-08-12	2013-08-12 00:00:00	2013-08-12	38000177		0	0	28		0	0	0	285536	0	849574	1115171		
2952	239	1539411	2012-01-12	2012-01-12 00:00:00	2012-01-12	2012-01-12 00:00:00	\N	38000177		0	0	0		0	0	0	16025	0	312961	1539411		
24958	2052	1127433	1978-05-04	1978-05-04 00:00:00	1978-05-18	1978-05-18 00:00:00	1978-05-18	38000177		0	0	14		0	0	0	136439	0	313782	1127433		
57272	1253	40213227	2006-04-19	2006-04-19 00:00:00	2006-04-19	2006-04-19 00:00:00	2006-04-19	581452		0	0	0		0	0	0	82501	0	113	40213227		
43598	950	40213296	2012-08-26	2012-08-26 00:00:00	2012-08-26	2012-08-26 00:00:00	2012-08-26	581452		0	0	0		0	0	0	63082	0	52	40213296		
35502	2926	1713671	1989-08-15	1989-08-15 00:00:00	1989-08-29	1989-08-29 00:00:00	1989-08-29	38000177		0	0	14		0	0	0	195196	0	562251	1713671		
16319	352	40213314	1978-09-25	1978-09-25 00:00:00	1978-09-25	1978-09-25 00:00:00	1978-09-25	581452		0	0	0		0	0	0	23455	0	49	40213314		
33710	2790	40236824	1989-08-27	1989-08-27 00:00:00	1989-09-03	1989-09-03 00:00:00	1989-09-03	38000177		0	0	7		0	0	0	184898	0	1094107	40236824		
18977	1568	1713671	2003-05-20	2003-05-20 00:00:00	2003-05-27	2003-05-27 00:00:00	2003-05-27	38000177		0	0	7		0	0	0	105186	0	562251	1713671		
47214	3916	19128022	1993-09-25	1993-09-25 00:00:00	1994-09-20	1994-09-20 00:00:00	1994-09-20	38000177		0	0	360		0	0	0	260390	0	749785	19128022		
35249	2906	19059056	1924-11-08	1924-11-08 00:00:00	1924-11-22	1924-11-22 00:00:00	1924-11-22	38000177		0	0	14		0	0	0	193742	0	243670	19059056		
27840	606	40213227	2006-05-10	2006-05-10 00:00:00	2006-05-10	2006-05-10 00:00:00	2006-05-10	581452		0	0	0		0	0	0	40212	0	113	40213227		
104110	2283	40213227	2009-09-28	2009-09-28 00:00:00	2009-09-28	2009-09-28 00:00:00	2009-09-28	581452		0	0	0		0	0	0	151852	0	113	40213227		
60593	5039	1115171	1994-12-17	1994-12-17 00:00:00	1995-03-17	1995-03-17 00:00:00	1995-03-17	38000177		0	0	90		0	0	0	334867	0	849574	1115171		
8037	672	1118084	1989-04-13	1989-04-13 00:00:00	1989-04-13	1989-04-13 00:00:00	\N	38000177		0	0	0		0	0	0	44387	0	00025152531	44923712		
41487	3438	19059056	1924-06-27	1924-06-27 00:00:00	1924-08-26	1924-08-26 00:00:00	1924-08-26	38000177		0	0	60		0	0	0	228133	0	243670	19059056		
104295	2287	40213227	2001-05-04	2001-05-04 00:00:00	2001-05-04	2001-05-04 00:00:00	2001-05-04	581452		0	0	0		0	0	0	152164	0	113	40213227		
55067	4572	1127433	2002-05-06	2002-05-06 00:00:00	2002-05-27	2002-05-27 00:00:00	2002-05-27	38000177		0	0	21		0	0	0	304637	0	313782	1127433		
115704	2542	40213260	2014-05-09	2014-05-09 00:00:00	2014-05-09	2014-05-09 00:00:00	2014-05-09	581452		0	0	0		0	0	0	168185	0	121	40213260		
192201	4223	40213260	2008-02-01	2008-02-01 00:00:00	2008-02-01	2008-02-01 00:00:00	2008-02-01	581452		0	0	0		0	0	0	280438	0	121	40213260		
208291	4569	40213296	2004-02-03	2004-02-03 00:00:00	2004-02-03	2004-02-03 00:00:00	2004-02-03	581452		0	0	0		0	0	0	304371	0	52	40213296		
48044	3984	40171902	2014-11-26	2014-11-26 00:00:00	2014-11-26	2014-11-26 00:00:00	\N	38000177		0	0	0		0	0	0	264884	0	897718	40171902		
70653	1545	40213296	2010-10-08	2010-10-08 00:00:00	2010-10-08	2010-10-08 00:00:00	2010-10-08	581452		0	0	0		0	0	0	103547	0	52	40213296		
49294	4090	1127433	1955-01-14	1955-01-14 00:00:00	1955-03-22	1955-03-22 00:00:00	1955-03-22	38000177		0	0	67		0	0	0	271933	0	313782	1127433		
39850	3296	19133873	1949-09-29	1949-09-29 00:00:00	1949-10-08	1949-10-08 00:00:00	1949-10-08	38000177		0	0	9		0	0	0	218992	0	834061	19133873		
14831	1242	19059056	1960-03-05	1960-03-05 00:00:00	1960-03-19	1960-03-19 00:00:00	1960-03-19	38000177		0	0	14		0	0	0	81825	0	243670	19059056		
119377	2624	40213160	1972-12-14	1972-12-14 00:00:00	1972-12-14	1972-12-14 00:00:00	1972-12-14	581452		0	0	0		0	0	0	173560	0	10	40213160		
14902	1246	1127433	1983-08-04	1983-08-04 00:00:00	1983-08-11	1983-08-11 00:00:00	1983-08-11	38000177		0	0	7		0	0	0	82114	0	313782	1127433		
18922	1563	1127433	1975-10-12	1975-10-12 00:00:00	1975-10-26	1975-10-26 00:00:00	1975-10-26	38000177		0	0	14		0	0	0	104745	0	313782	1127433		
2279	184	19078461	1984-07-07	1984-07-07 00:00:00	1984-07-28	1984-07-28 00:00:00	1984-07-28	38000177		0	0	21		0	0	0	12503	0	310965	19078461		
29995	2485	40162522	1990-03-11	1990-03-11 00:00:00	1990-03-11	1990-03-11 00:00:00	\N	38000177		0	0	0		0	0	0	164690	0	857005	40162522		
59268	1297	40213160	1978-11-19	1978-11-19 00:00:00	1978-11-19	1978-11-19 00:00:00	1978-11-19	581452		0	0	0		0	0	0	85734	0	10	40213160		
37215	3077	19126352	2013-11-20	2013-11-20 00:00:00	2013-11-20	2013-11-20 00:00:00	\N	38000177		0	0	0		0	0	0	204737	0	705129	19126352		
12809	276	40213160	1977-11-17	1977-11-17 00:00:00	1977-11-17	1977-11-17 00:00:00	1977-11-17	581452		0	0	0		0	0	0	18422	0	10	40213160		
157160	3458	40213160	1984-09-28	1984-09-28 00:00:00	1984-09-28	1984-09-28 00:00:00	1984-09-28	581452		0	0	0		0	0	0	229459	0	10	40213160		
86301	1892	40213227	1993-04-22	1993-04-22 00:00:00	1993-04-22	1993-04-22 00:00:00	1993-04-22	581452		0	0	0		0	0	0	126011	0	113	40213227		
52886	4394	19128065	1987-02-11	1987-02-11 00:00:00	1988-02-06	1988-02-06 00:00:00	1988-02-06	38000177		0	0	360		0	0	0	292144	0	749882	19128065		
106068	2327	40213260	2008-07-09	2008-07-09 00:00:00	2008-07-09	2008-07-09 00:00:00	2008-07-09	581452		0	0	0		0	0	0	154785	0	121	40213260		
60033	4990	19129655	1966-07-02	1966-07-02 00:00:00	1966-07-16	1966-07-16 00:00:00	1966-07-16	38000177		0	0	14		0	0	0	331924	0	789980	19129655		
971	79	1118084	1988-12-05	1988-12-05 00:00:00	1988-12-05	1988-12-05 00:00:00	\N	38000177		0	0	0		0	0	0	5306	0	00025152531	44923712		
23816	1960	40236824	1954-09-22	1954-09-22 00:00:00	1954-09-29	1954-09-29 00:00:00	1954-09-29	38000177		0	0	7		0	0	0	130336	0	1094107	40236824		
2744	61	40213227	2010-01-31	2010-01-31 00:00:00	2010-01-31	2010-01-31 00:00:00	2010-01-31	581452		0	0	0		0	0	0	4091	0	113	40213227		
187408	4116	40213160	1969-03-27	1969-03-27 00:00:00	1969-03-27	1969-03-27 00:00:00	1969-03-27	581452		0	0	0		0	0	0	273638	0	10	40213160		
34670	2863	19059056	1972-02-19	1972-02-19 00:00:00	1972-03-11	1972-03-11 00:00:00	1972-03-11	38000177		0	0	21		0	0	0	190389	0	243670	19059056		
45166	3736	1127433	1985-07-31	1985-07-31 00:00:00	1985-08-07	1985-08-07 00:00:00	1985-08-07	38000177		0	0	7		0	0	0	248259	0	313782	1127433		
179381	3943	40213201	2018-06-28	2018-06-28 00:00:00	2018-06-28	2018-06-28 00:00:00	2018-06-28	581452		0	0	0		0	0	0	262205	0	33	40213201		
50131	1098	40213296	1999-07-17	1999-07-17 00:00:00	1999-07-17	1999-07-17 00:00:00	1999-07-17	581452		0	0	0		0	0	0	72097	0	52	40213296		
24472	2013	40231925	1975-10-16	1975-10-16 00:00:00	1975-10-16	1975-10-16 00:00:00	\N	38000177		0	0	0		0	0	0	134003	0	1049221	40231925		
20600	1695	1127433	2001-01-31	2001-01-31 00:00:00	2001-02-14	2001-02-14 00:00:00	2001-02-14	38000177		0	0	14		0	0	0	113477	0	313782	1127433		
32789	2715	19059056	1971-08-20	1971-08-20 00:00:00	1971-09-10	1971-09-10 00:00:00	1971-09-10	38000177		0	0	21		0	0	0	179966	0	243670	19059056		
20714	1707	1118084	2006-04-18	2006-04-18 00:00:00	2006-04-18	2006-04-18 00:00:00	\N	38000177		0	0	0		0	0	0	114150	0	00025152531	44923712		
5924	495	1127078	1971-03-04	1971-03-04 00:00:00	1971-03-25	1971-03-25 00:00:00	1971-03-25	38000177		0	0	21		0	0	0	33105	0	282464	1127078		
53098	4411	1127433	2014-11-24	2014-11-24 00:00:00	2014-12-24	2014-12-24 00:00:00	2014-12-24	38000177		0	0	30		0	0	0	293251	0	313782	1127433		
52258	4347	1124300	2002-10-18	2002-10-18 00:00:00	2002-10-18	2002-10-18 00:00:00	\N	38000177		0	0	0		0	0	0	288252	0	00781178901	45011828		
65783	1439	40213160	1982-06-26	1982-06-26 00:00:00	1982-06-26	1982-06-26 00:00:00	1982-06-26	581452		0	0	0		0	0	0	95888	0	10	40213160		
11267	938	19059056	1963-12-12	1963-12-12 00:00:00	1964-01-11	1964-01-11 00:00:00	1964-01-11	38000177		0	0	30		0	0	0	62328	0	243670	19059056		
2334	187	1713671	1962-04-07	1962-04-07 00:00:00	1962-04-14	1962-04-14 00:00:00	1962-04-14	38000177		0	0	7		0	0	0	12713	0	562251	1713671		
40773	3381	1118084	2011-01-15	2011-01-15 00:00:00	2011-01-15	2011-01-15 00:00:00	\N	38000177		0	0	0		0	0	0	224362	0	00025152531	44923712		
196322	4313	40213198	2013-06-01	2013-06-01 00:00:00	2013-06-01	2013-06-01 00:00:00	2013-06-01	581452		0	0	0		0	0	0	286270	0	133	40213198		
52324	4352	40229134	2018-08-14	2018-08-14 00:00:00	2018-08-21	2018-08-21 00:00:00	2018-08-21	38000177		0	0	7		0	0	0	288644	0	1043400	40229134		
61219	1338	40213201	2010-04-08	2010-04-08 00:00:00	2010-04-08	2010-04-08 00:00:00	2010-04-08	581452		0	0	0		0	0	0	88716	0	33	40213201		
170472	3748	40213160	1979-11-20	1979-11-20 00:00:00	1979-11-20	1979-11-20 00:00:00	1979-11-20	581452		0	0	0		0	0	0	249103	0	10	40213160		
52619	4375	40236824	1980-07-21	1980-07-21 00:00:00	1980-07-28	1980-07-28 00:00:00	1980-07-28	38000177		0	0	7		0	0	0	290679	0	1094107	40236824		
53324	4432	1127433	1970-03-11	1970-03-11 00:00:00	1970-03-18	1970-03-18 00:00:00	1970-03-18	38000177		0	0	7		0	0	0	294587	0	313782	1127433		
51794	4305	1127078	1969-09-20	1969-09-20 00:00:00	1969-12-19	1969-12-19 00:00:00	1969-12-19	38000177		0	0	90		0	0	0	285583	0	282464	1127078		
2953	239	1332419	2012-01-12	2012-01-12 00:00:00	2012-01-12	2012-01-12 00:00:00	\N	38000177		0	0	0		0	0	0	16025	0	197361	1332419		
24959	2052	1118084	2003-07-13	2003-07-13 00:00:00	2003-07-13	2003-07-13 00:00:00	\N	38000177		0	0	0		0	0	0	136454	0	00025152531	44923712		
57274	1253	40213260	2006-04-19	2006-04-19 00:00:00	2006-04-19	2006-04-19 00:00:00	2006-04-19	581452		0	0	0		0	0	0	82501	0	121	40213260		
43604	950	40213160	1970-11-01	1970-11-01 00:00:00	1970-11-01	1970-11-01 00:00:00	1970-11-01	581452		0	0	0		0	0	0	63130	0	10	40213160		
35503	2926	19078461	2018-10-04	2018-10-04 00:00:00	2018-11-08	2018-11-08 00:00:00	2018-11-08	38000177		0	0	35		0	0	0	195194	0	310965	19078461		
16325	352	40213306	1999-10-18	1999-10-18 00:00:00	1999-10-18	1999-10-18 00:00:00	1999-10-18	581452		0	0	0		0	0	0	23477	0	43	40213306		
33711	2790	920300	1989-08-27	1989-08-27 00:00:00	1989-09-03	1989-09-03 00:00:00	1989-09-03	38000177		0	0	7		0	0	0	184898	0	311989	920300		
18978	1568	19059056	1964-09-27	1964-09-27 00:00:00	1964-10-11	1964-10-11 00:00:00	1964-10-11	38000177		0	0	14		0	0	0	105164	0	243670	19059056		
47215	3916	19128065	1995-09-15	1995-09-15 00:00:00	1996-09-09	1996-09-09 00:00:00	1996-09-09	38000177		0	0	360		0	0	0	260392	0	749882	19128065		
35250	2906	1127433	1970-03-14	1970-03-14 00:00:00	1970-03-21	1970-03-21 00:00:00	1970-03-21	38000177		0	0	7		0	0	0	193746	0	313782	1127433		
196473	4317	40213160	1955-02-03	1955-02-03 00:00:00	1955-02-03	1955-02-03 00:00:00	1955-02-03	581452		0	0	0		0	0	0	286483	0	10	40213160		
44363	3672	1127433	1986-02-07	1986-02-07 00:00:00	1986-02-21	1986-02-21 00:00:00	1986-02-21	38000177		0	0	14		0	0	0	244289	0	313782	1127433		
60594	5039	1127078	1976-05-13	1976-05-13 00:00:00	1976-06-03	1976-06-03 00:00:00	1976-06-03	38000177		0	0	21		0	0	0	334865	0	282464	1127078		
8038	672	19078461	2000-02-17	2000-02-17 00:00:00	2000-04-24	2000-04-24 00:00:00	2000-04-24	38000177		0	0	67		0	0	0	44414	0	310965	19078461		
41488	3438	920300	1938-05-19	1938-05-19 00:00:00	1938-05-26	1938-05-26 00:00:00	1938-05-26	38000177		0	0	7		0	0	0	228109	0	311989	920300		
104334	2289	40213198	2015-08-25	2015-08-25 00:00:00	2015-08-25	2015-08-25 00:00:00	2015-08-25	581452		0	0	0		0	0	0	152230	0	133	40213198		
55068	4572	19078461	2008-04-25	2008-04-25 00:00:00	2008-05-30	2008-05-30 00:00:00	2008-05-30	38000177		0	0	35		0	0	0	304638	0	310965	19078461		
153283	3375	40213160	1955-08-12	1955-08-12 00:00:00	1955-08-12	1955-08-12 00:00:00	1955-08-12	581452		0	0	0		0	0	0	223888	0	10	40213160		
192203	4223	40213227	2008-02-01	2008-02-01 00:00:00	2008-02-01	2008-02-01 00:00:00	2008-02-01	581452		0	0	0		0	0	0	280438	0	113	40213227		
208293	4569	40213227	2004-02-03	2004-02-03 00:00:00	2004-02-03	2004-02-03 00:00:00	2004-02-03	581452		0	0	0		0	0	0	304371	0	113	40213227		
48045	3984	40163554	2014-11-26	2014-11-26 00:00:00	2014-11-26	2014-11-26 00:00:00	\N	38000177		0	0	0		0	0	0	264884	0	855332	40163554		
70657	1545	40213160	1969-08-15	1969-08-15 00:00:00	1969-08-15	1969-08-15 00:00:00	1969-08-15	581452		0	0	0		0	0	0	103525	0	10	40213160		
49295	4090	19059056	1949-09-12	1949-09-12 00:00:00	1949-12-11	1949-12-11 00:00:00	1949-12-11	38000177		0	0	90		0	0	0	271904	0	243670	19059056		
39851	3296	19133873	1948-08-21	1948-08-21 00:00:00	1948-09-01	1948-09-01 00:00:00	1948-09-01	38000177		0	0	11		0	0	0	218985	0	834061	19133873		
14832	1242	40229134	1979-02-14	1979-02-14 00:00:00	1979-02-21	1979-02-21 00:00:00	1979-02-21	38000177		0	0	7		0	0	0	81793	0	1043400	40229134		
119381	2624	40213160	1968-06-13	1968-06-13 00:00:00	1968-06-13	1968-06-13 00:00:00	1968-06-13	581452		0	0	0		0	0	0	173557	0	10	40213160		
14903	1246	1713671	1957-09-26	1957-09-26 00:00:00	1957-10-03	1957-10-03 00:00:00	1957-10-03	38000177		0	0	7		0	0	0	82060	0	562251	1713671		
18923	1563	19059056	1976-08-21	1976-08-21 00:00:00	1976-09-18	1976-09-18 00:00:00	1976-09-18	38000177		0	0	28		0	0	0	104746	0	243670	19059056		
2280	184	40162522	1991-03-24	1991-03-24 00:00:00	1991-03-24	1991-03-24 00:00:00	\N	38000177		0	0	0		0	0	0	12504	0	857005	40162522		
29996	2485	19059056	1913-08-31	1913-08-31 00:00:00	1913-09-14	1913-09-14 00:00:00	1913-09-14	38000177		0	0	14		0	0	0	164599	0	243670	19059056		
59276	1297	40213160	1983-07-24	1983-07-24 00:00:00	1983-07-24	1983-07-24 00:00:00	1983-07-24	581452		0	0	0		0	0	0	85745	0	10	40213160		
37216	3077	19075601	2013-11-20	2013-11-20 00:00:00	2014-06-11	2014-06-11 00:00:00	2014-06-11	38000177		0	0	203		0	0	0	204737	0	309362	19075601		
12810	276	40213314	1977-11-17	1977-11-17 00:00:00	1977-11-17	1977-11-17 00:00:00	1977-11-17	581452		0	0	0		0	0	0	18422	0	49	40213314		
203369	4465	40213296	2015-02-06	2015-02-06 00:00:00	2015-02-06	2015-02-06 00:00:00	2015-02-06	581452		0	0	0		0	0	0	297056	0	52	40213296		
86303	1892	40213306	1981-04-09	1981-04-09 00:00:00	1981-04-09	1981-04-09 00:00:00	1981-04-09	581452		0	0	0		0	0	0	126007	0	43	40213306		
52887	4394	19059056	1978-02-18	1978-02-18 00:00:00	1978-03-11	1978-03-11 00:00:00	1978-03-11	38000177		0	0	21		0	0	0	292167	0	243670	19059056		
106073	2327	40213160	1958-01-22	1958-01-22 00:00:00	1958-01-22	1958-01-22 00:00:00	1958-01-22	581452		0	0	0		0	0	0	154779	0	10	40213160		
60034	4990	40165015	1979-12-21	1979-12-21 00:00:00	1979-12-21	1979-12-21 00:00:00	\N	38000177		0	0	0		0	0	0	331970	0	861467	40165015		
972	79	19133873	1957-02-13	1957-02-13 00:00:00	1957-02-21	1957-02-21 00:00:00	1957-02-21	38000177		0	0	8		0	0	0	5276	0	834061	19133873		
23817	1960	920300	1955-11-13	1955-11-13 00:00:00	1955-11-20	1955-11-20 00:00:00	1955-11-20	38000177		0	0	7		0	0	0	\N	0	311989	920300		
2745	61	40213296	2010-01-31	2010-01-31 00:00:00	2010-01-31	2010-01-31 00:00:00	2010-01-31	581452		0	0	0		0	0	0	4091	0	52	40213296		
187412	4116	40213160	1969-01-23	1969-01-23 00:00:00	1969-01-23	1969-01-23 00:00:00	1969-01-23	581452		0	0	0		0	0	0	273652	0	10	40213160		
34671	2863	19059056	1963-10-04	1963-10-04 00:00:00	1963-10-18	1963-10-18 00:00:00	1963-10-18	38000177		0	0	14		0	0	0	190376	0	243670	19059056		
45178	3739	1124300	2007-02-15	2007-02-15 00:00:00	2007-02-15	2007-02-15 00:00:00	\N	38000177		0	0	0		0	0	0	248451	0	00781178901	45011828		
179383	3943	40213260	2006-03-09	2006-03-09 00:00:00	2006-03-09	2006-03-09 00:00:00	2006-03-09	581452		0	0	0		0	0	0	262147	0	121	40213260		
50143	1099	40213198	2017-07-29	2017-07-29 00:00:00	2017-07-29	2017-07-29 00:00:00	2017-07-29	581452		0	0	0		0	0	0	72118	0	133	40213198		
24473	2013	1127433	1975-10-16	1975-10-16 00:00:00	1975-12-15	1975-12-15 00:00:00	1975-12-15	38000177		0	0	60		0	0	0	134003	0	313782	1127433		
20602	1695	40236824	2018-02-01	2018-02-01 00:00:00	2018-02-08	2018-02-08 00:00:00	2018-02-08	38000177		0	0	7		0	0	0	113447	0	1094107	40236824		
32790	2715	1124300	1999-05-25	1999-05-25 00:00:00	1999-05-25	1999-05-25 00:00:00	\N	38000177		0	0	0		0	0	0	180056	0	00781178901	45011828		
54285	1188	40213160	1975-10-11	1975-10-11 00:00:00	1975-10-11	1975-10-11 00:00:00	1975-10-11	581452		0	0	0		0	0	0	78268	0	10	40213160		
5925	495	1127433	2006-01-22	2006-01-22 00:00:00	2006-01-29	2006-01-29 00:00:00	2006-01-29	38000177		0	0	7		0	0	0	33042	0	313782	1127433		
53099	4411	1127433	1962-01-16	1962-01-16 00:00:00	1962-01-23	1962-01-23 00:00:00	1962-01-23	38000177		0	0	7		0	0	0	293229	0	313782	1127433		
52259	4347	1127433	2001-05-07	2001-05-07 00:00:00	2001-05-21	2001-05-21 00:00:00	2001-05-21	38000177		0	0	14		0	0	0	288268	0	313782	1127433		
13737	1148	1127433	1964-03-19	1964-03-19 00:00:00	1964-03-26	1964-03-26 00:00:00	1964-03-26	38000177		0	0	7		0	0	0	75920	0	313782	1127433		
11268	938	40231925	1963-12-12	1963-12-12 00:00:00	1963-12-12	1963-12-12 00:00:00	\N	38000177		0	0	0		0	0	0	62328	0	1049221	40231925		
2335	187	19059056	1947-04-13	1947-04-13 00:00:00	1947-04-28	1947-04-28 00:00:00	1947-04-28	38000177		0	0	15		0	0	0	12705	0	243670	19059056		
40774	3381	1127433	1986-10-10	1986-10-10 00:00:00	1986-10-24	1986-10-24 00:00:00	1986-10-24	38000177		0	0	14		0	0	0	224366	0	313782	1127433		
77496	1695	40213227	2017-11-16	2017-11-16 00:00:00	2017-11-16	2017-11-16 00:00:00	2017-11-16	581452		0	0	0		0	0	0	113460	0	113	40213227		
52325	4352	1127433	1985-04-17	1985-04-17 00:00:00	1985-05-01	1985-05-01 00:00:00	1985-05-01	38000177		0	0	14		0	0	0	288638	0	313782	1127433		
61220	1338	40213198	2010-04-08	2010-04-08 00:00:00	2010-04-08	2010-04-08 00:00:00	2010-04-08	581452		0	0	0		0	0	0	88716	0	133	40213198		
170473	3748	40213314	1979-08-21	1979-08-21 00:00:00	1979-08-21	1979-08-21 00:00:00	1979-08-21	581452		0	0	0		0	0	0	249129	0	49	40213314		
52620	4375	1124300	1969-07-19	1969-07-19 00:00:00	1969-07-19	1969-07-19 00:00:00	\N	38000177		0	0	0		0	0	0	290611	0	00781178901	45011828		
53325	4432	19078461	1995-08-03	1995-08-03 00:00:00	1995-08-31	1995-08-31 00:00:00	1995-08-31	38000177		0	0	28		0	0	0	294584	0	310965	19078461		
51795	4305	19133873	1963-07-28	1963-07-28 00:00:00	1963-08-08	1963-08-08 00:00:00	1963-08-08	38000177		0	0	11		0	0	0	285558	0	834061	19133873		
2954	239	19075601	2012-01-12	2012-01-12 00:00:00	2012-07-05	2012-07-05 00:00:00	2012-07-05	38000177		0	0	175		0	0	0	16025	0	309362	19075601		
24960	2053	1127433	1989-09-21	1989-09-21 00:00:00	1989-10-12	1989-10-12 00:00:00	1989-10-12	38000177		0	0	21		0	0	0	136569	0	313782	1127433		
57278	1253	40213160	1960-02-17	1960-02-17 00:00:00	1960-02-17	1960-02-17 00:00:00	1960-02-17	581452		0	0	0		0	0	0	82569	0	10	40213160		
43605	950	40213160	1970-08-30	1970-08-30 00:00:00	1970-08-30	1970-08-30 00:00:00	1970-08-30	581452		0	0	0		0	0	0	63119	0	10	40213160		
35504	2926	920300	2000-10-21	2000-10-21 00:00:00	2000-10-28	2000-10-28 00:00:00	2000-10-28	38000177		0	0	7		0	0	0	195198	0	311989	920300		
16326	352	40213227	1999-10-18	1999-10-18 00:00:00	1999-10-18	1999-10-18 00:00:00	1999-10-18	581452		0	0	0		0	0	0	23477	0	113	40213227		
33712	2790	1127433	2009-04-13	2009-04-13 00:00:00	2009-06-12	2009-06-12 00:00:00	2009-06-12	38000177		0	0	60		0	0	0	184875	0	313782	1127433		
18979	1568	19059056	1960-03-22	1960-03-22 00:00:00	1960-05-21	1960-05-21 00:00:00	1960-05-21	38000177		0	0	60		0	0	0	105163	0	243670	19059056		
47216	3916	19112599	1979-04-17	1979-04-17 00:00:00	1979-04-17	1979-04-17 00:00:00	\N	38000177		0	0	0		0	0	0	260278	0	477045	19112599		
35251	2906	19059056	1940-05-09	1940-05-09 00:00:00	1940-05-30	1940-05-30 00:00:00	1940-05-30	38000177		0	0	21		0	0	0	193720	0	243670	19059056		
196479	4317	40213227	2008-09-04	2008-09-04 00:00:00	2008-09-04	2008-09-04 00:00:00	2008-09-04	581452		0	0	0		0	0	0	286559	0	113	40213227		
44364	3672	1127433	1979-06-23	1979-06-23 00:00:00	1979-07-07	1979-07-07 00:00:00	1979-07-07	38000177		0	0	14		0	0	0	244300	0	313782	1127433		
60595	5039	1127078	1984-02-22	1984-02-22 00:00:00	1984-03-14	1984-03-14 00:00:00	1984-03-14	38000177		0	0	21		0	0	0	334866	0	282464	1127078		
39213	857	40213160	1955-02-06	1955-02-06 00:00:00	1955-02-06	1955-02-06 00:00:00	1955-02-06	581452		0	0	0		0	0	0	56612	0	10	40213160		
41489	3438	40236824	1938-05-19	1938-05-19 00:00:00	1938-06-02	1938-06-02 00:00:00	1938-06-02	38000177		0	0	14		0	0	0	228109	0	1094107	40236824		
12093	1015	40229134	1984-11-21	1984-11-21 00:00:00	1984-11-28	1984-11-28 00:00:00	1984-11-28	38000177		0	0	7		0	0	0	66819	0	1043400	40229134		
55069	4572	1127078	1976-11-08	1976-11-08 00:00:00	1976-12-13	1976-12-13 00:00:00	1976-12-13	38000177		0	0	35		0	0	0	304635	0	282464	1127078		
153285	3375	40213260	2007-03-02	2007-03-02 00:00:00	2007-03-02	2007-03-02 00:00:00	2007-03-02	581452		0	0	0		0	0	0	\N	0	121	40213260		
7502	161	40213160	1978-03-05	1978-03-05 00:00:00	1978-03-05	1978-03-05 00:00:00	1978-03-05	581452		0	0	0		0	0	0	11065	0	10	40213160		
208295	4569	40213160	1962-07-03	1962-07-03 00:00:00	1962-07-03	1962-07-03 00:00:00	1962-07-03	581452		0	0	0		0	0	0	304403	0	10	40213160		
48046	3984	1127433	2008-10-16	2008-10-16 00:00:00	2008-10-30	2008-10-30 00:00:00	2008-10-30	38000177		0	0	14		0	0	0	264844	0	313782	1127433		
70662	1545	40213306	1991-03-15	1991-03-15 00:00:00	1991-03-15	1991-03-15 00:00:00	1991-03-15	581452		0	0	0		0	0	0	103491	0	43	40213306		
49296	4090	1115171	2011-08-14	2011-08-14 00:00:00	2011-08-28	2011-08-28 00:00:00	2011-08-28	38000177		0	0	14		0	0	0	271939	0	849574	1115171		
39852	3296	19059056	1937-11-02	1937-11-02 00:00:00	1937-11-16	1937-11-16 00:00:00	1937-11-16	38000177		0	0	14		0	0	0	218991	0	243670	19059056		
14833	1242	1127433	1989-12-26	1989-12-26 00:00:00	1990-01-09	1990-01-09 00:00:00	1990-01-09	38000177		0	0	14		0	0	0	81769	0	313782	1127433		
130677	2871	40213227	2001-12-17	2001-12-17 00:00:00	2001-12-17	2001-12-17 00:00:00	2001-12-17	581452		0	0	0		0	0	0	191104	0	113	40213227		
14904	1246	1127433	1947-11-06	1947-11-06 00:00:00	1947-11-20	1947-11-20 00:00:00	1947-11-20	38000177		0	0	14		0	0	0	82058	0	313782	1127433		
18924	1563	1127433	1978-04-04	1978-04-04 00:00:00	1978-04-18	1978-04-18 00:00:00	1978-04-18	38000177		0	0	14		0	0	0	104698	0	313782	1127433		
2281	184	19078461	1991-03-24	1991-03-24 00:00:00	1991-05-23	1991-05-23 00:00:00	1991-05-23	38000177		0	0	60		0	0	0	12504	0	310965	19078461		
29997	2485	19078461	1983-12-22	1983-12-22 00:00:00	1984-01-12	1984-01-12 00:00:00	1984-01-12	38000177		0	0	21		0	0	0	164620	0	310965	19078461		
59278	1297	40213160	1979-04-22	1979-04-22 00:00:00	1979-04-22	1979-04-22 00:00:00	1979-04-22	581452		0	0	0		0	0	0	85735	0	10	40213160		
37217	3077	1539411	2013-11-20	2013-11-20 00:00:00	2013-11-20	2013-11-20 00:00:00	\N	38000177		0	0	0		0	0	0	204737	0	312961	1539411		
12815	277	40213306	1986-11-25	1986-11-25 00:00:00	1986-11-25	1986-11-25 00:00:00	1986-11-25	581452		0	0	0		0	0	0	18486	0	43	40213306		
203371	4465	40213227	2015-02-06	2015-02-06 00:00:00	2015-02-06	2015-02-06 00:00:00	2015-02-06	581452		0	0	0		0	0	0	297056	0	113	40213227		
86308	1892	40213160	1960-12-22	1960-12-22 00:00:00	1960-12-22	1960-12-22 00:00:00	1960-12-22	581452		0	0	0		0	0	0	126038	0	10	40213160		
52888	4394	1118084	2013-02-04	2013-02-04 00:00:00	2013-02-04	2013-02-04 00:00:00	\N	38000177		0	0	0		0	0	0	292189	0	00025152531	44923712		
106077	2327	40213160	1958-03-26	1958-03-26 00:00:00	1958-03-26	1958-03-26 00:00:00	1958-03-26	581452		0	0	0		0	0	0	154751	0	10	40213160		
60035	4990	19078461	1979-12-21	1979-12-21 00:00:00	1980-03-20	1980-03-20 00:00:00	1980-03-20	38000177		0	0	90		0	0	0	331970	0	310965	19078461		
974	79	1713671	1958-09-27	1958-09-27 00:00:00	1958-10-18	1958-10-18 00:00:00	1958-10-18	38000177		0	0	21		0	0	0	5255	0	562251	1713671		
23818	1960	40236824	1955-11-13	1955-11-13 00:00:00	1955-11-20	1955-11-20 00:00:00	1955-11-20	38000177		0	0	7		0	0	0	\N	0	1094107	40236824		
2748	61	40213227	1999-07-18	1999-07-18 00:00:00	1999-07-18	1999-07-18 00:00:00	1999-07-18	581452		0	0	0		0	0	0	4134	0	113	40213227		
198691	4365	40213227	2002-07-29	2002-07-29 00:00:00	2002-07-29	2002-07-29 00:00:00	2002-07-29	581452		0	0	0		0	0	0	289550	0	113	40213227		
34672	2863	19129655	1963-10-04	1963-10-04 00:00:00	1963-10-18	1963-10-18 00:00:00	1963-10-18	38000177		0	0	14		0	0	0	190376	0	789980	19129655		
45179	3739	19133905	2007-02-01	2007-02-01 00:00:00	2007-02-12	2007-02-12 00:00:00	2007-02-12	38000177		0	0	11		0	0	0	248451	0	834102	19133905		
179164	3939	40213160	1974-09-29	1974-09-29 00:00:00	1974-09-29	1974-09-29 00:00:00	1974-09-29	581452		0	0	0		0	0	0	261845	0	10	40213160		
50150	1099	40213160	1955-04-09	1955-04-09 00:00:00	1955-04-09	1955-04-09 00:00:00	1955-04-09	581452		0	0	0		0	0	0	72163	0	10	40213160		
24474	2013	1127078	1956-10-13	1956-10-13 00:00:00	1956-10-27	1956-10-27 00:00:00	1956-10-27	38000177		0	0	14		0	0	0	133951	0	282464	1127078		
20603	1695	920300	2018-02-01	2018-02-01 00:00:00	2018-02-08	2018-02-08 00:00:00	2018-02-08	38000177		0	0	7		0	0	0	113447	0	311989	920300		
32791	2715	19126352	1979-04-26	1979-04-26 00:00:00	2017-11-23	2017-11-23 00:00:00	2017-11-23	38000177		0	0	14091		0	0	0	180087	0	705129	19126352		
54288	1188	40213160	1975-05-10	1975-05-10 00:00:00	1975-05-10	1975-05-10 00:00:00	1975-05-10	581452		0	0	0		0	0	0	78262	0	10	40213160		
5926	495	1713671	2018-09-27	2018-09-27 00:00:00	2018-10-18	2018-10-18 00:00:00	2018-10-18	38000177		0	0	21		0	0	0	33084	0	562251	1713671		
53100	4411	920300	1990-05-20	1990-05-20 00:00:00	1990-05-27	1990-05-27 00:00:00	1990-05-27	38000177		0	0	7		0	0	0	293202	0	311989	920300		
52261	4347	1127078	1974-02-02	1974-02-02 00:00:00	1974-03-04	1974-03-04 00:00:00	1974-03-04	38000177		0	0	30		0	0	0	288291	0	282464	1127078		
13738	1148	1118084	2001-07-01	2001-07-01 00:00:00	2001-07-01	2001-07-01 00:00:00	\N	38000177		0	0	0		0	0	0	75882	0	00025152531	44923712		
11270	938	1127433	1958-02-12	1958-02-12 00:00:00	1958-02-19	1958-02-19 00:00:00	1958-02-19	38000177		0	0	7		0	0	0	62316	0	313782	1127433		
2336	187	1127433	1965-10-07	1965-10-07 00:00:00	1965-10-21	1965-10-21 00:00:00	1965-10-21	38000177		0	0	14		0	0	0	12701	0	313782	1127433		
40775	3381	19059056	1972-05-04	1972-05-04 00:00:00	1972-05-18	1972-05-18 00:00:00	1972-05-18	38000177		0	0	14		0	0	0	224351	0	243670	19059056		
208477	4572	40213160	1976-09-21	1976-09-21 00:00:00	1976-09-21	1976-09-21 00:00:00	1976-09-21	581452		0	0	0		0	0	0	304641	0	10	40213160		
52326	4353	1127078	1967-04-04	1967-04-04 00:00:00	1967-04-18	1967-04-18 00:00:00	1967-04-18	38000177		0	0	14		0	0	0	288834	0	282464	1127078		
61231	1338	40213227	2004-10-28	2004-10-28 00:00:00	2004-10-28	2004-10-28 00:00:00	2004-10-28	581452		0	0	0		0	0	0	\N	0	113	40213227		
170474	3748	40213160	1979-08-21	1979-08-21 00:00:00	1979-08-21	1979-08-21 00:00:00	1979-08-21	581452		0	0	0		0	0	0	249129	0	10	40213160		
52621	4375	1127433	1933-06-09	1933-06-09 00:00:00	1933-06-16	1933-06-16 00:00:00	1933-06-16	38000177		0	0	7		0	0	0	290601	0	313782	1127433		
53326	4432	1118084	1997-02-05	1997-02-05 00:00:00	1997-02-05	1997-02-05 00:00:00	\N	38000177		0	0	0		0	0	0	294584	0	00025152531	44923712		
51796	4305	1127433	2012-08-01	2012-08-01 00:00:00	2012-08-15	2012-08-15 00:00:00	2012-08-15	38000177		0	0	14		0	0	0	285644	0	313782	1127433		
2955	239	19059056	1963-12-25	1963-12-25 00:00:00	1964-01-08	1964-01-08 00:00:00	1964-01-08	38000177		0	0	14		0	0	0	16050	0	243670	19059056		
24961	2053	19078461	2000-11-13	2000-11-13 00:00:00	2000-12-11	2000-12-11 00:00:00	2000-12-11	38000177		0	0	28		0	0	0	136570	0	310965	19078461		
125510	2761	40213314	1980-08-25	1980-08-25 00:00:00	1980-08-25	1980-08-25 00:00:00	1980-08-25	581452		0	0	0		0	0	0	182629	0	49	40213314		
43608	950	40213160	1971-01-31	1971-01-31 00:00:00	1971-01-31	1971-01-31 00:00:00	1971-01-31	581452		0	0	0		0	0	0	63075	0	10	40213160		
35505	2926	40236824	2000-10-21	2000-10-21 00:00:00	2000-10-28	2000-10-28 00:00:00	2000-10-28	38000177		0	0	7		0	0	0	195198	0	1094107	40236824		
16330	352	40213160	1977-12-26	1977-12-26 00:00:00	1977-12-26	1977-12-26 00:00:00	1977-12-26	581452		0	0	0		0	0	0	23441	0	10	40213160		
12687	1068	1127433	1992-12-13	1992-12-13 00:00:00	1992-12-27	1992-12-27 00:00:00	1992-12-27	38000177		0	0	14		0	0	0	69945	0	313782	1127433		
18980	1568	1127433	1967-07-28	1967-07-28 00:00:00	1967-10-26	1967-10-26 00:00:00	1967-10-26	38000177		0	0	90		0	0	0	105165	0	313782	1127433		
47217	3916	19078461	2010-11-20	2010-11-20 00:00:00	2010-12-25	2010-12-25 00:00:00	2010-12-25	38000177		0	0	35		0	0	0	260441	0	310965	19078461		
35252	2906	1713671	1971-09-15	1971-09-15 00:00:00	1971-09-22	1971-09-22 00:00:00	1971-09-22	38000177		0	0	7		0	0	0	193617	0	562251	1713671		
196486	4317	40213201	2013-10-03	2013-10-03 00:00:00	2013-10-03	2013-10-03 00:00:00	2013-10-03	581452		0	0	0		0	0	0	286522	0	33	40213201		
44365	3672	1118084	2002-02-21	2002-02-21 00:00:00	2002-02-21	2002-02-21 00:00:00	\N	38000177		0	0	0		0	0	0	244266	0	00025152531	44923712		
60596	5041	19059056	1971-04-23	1971-04-23 00:00:00	1971-05-07	1971-05-07 00:00:00	1971-05-07	38000177		0	0	14		0	0	0	334929	0	243670	19059056		
39224	857	40213227	2003-03-09	2003-03-09 00:00:00	2003-03-09	2003-03-09 00:00:00	2003-03-09	581452		0	0	0		0	0	0	56587	0	113	40213227		
41490	3438	1713671	1988-09-14	1988-09-14 00:00:00	1988-10-05	1988-10-05 00:00:00	1988-10-05	38000177		0	0	21		0	0	0	228111	0	562251	1713671		
12094	1015	1127433	1994-11-25	1994-11-25 00:00:00	1994-12-09	1994-12-09 00:00:00	1994-12-09	38000177		0	0	14		0	0	0	66820	0	313782	1127433		
55070	4572	1127078	1981-10-01	1981-10-01 00:00:00	1981-10-15	1981-10-15 00:00:00	1981-10-15	38000177		0	0	14		0	0	0	304605	0	282464	1127078		
153290	3375	40213227	1996-06-28	1996-06-28 00:00:00	1996-06-28	1996-06-28 00:00:00	1996-06-28	581452		0	0	0		0	0	0	223893	0	113	40213227		
7503	161	40213314	1978-03-05	1978-03-05 00:00:00	1978-03-05	1978-03-05 00:00:00	1978-03-05	581452		0	0	0		0	0	0	11065	0	49	40213314		
208296	4569	40213160	1962-10-02	1962-10-02 00:00:00	1962-10-02	1962-10-02 00:00:00	1962-10-02	581452		0	0	0		0	0	0	304379	0	10	40213160		
48047	3984	1127433	1963-12-13	1963-12-13 00:00:00	1963-12-27	1963-12-27 00:00:00	1963-12-27	38000177		0	0	14		0	0	0	264821	0	313782	1127433		
70665	1545	40213160	1969-03-14	1969-03-14 00:00:00	1969-03-14	1969-03-14 00:00:00	1969-03-14	581452		0	0	0		0	0	0	103524	0	10	40213160		
49297	4090	1713671	1968-09-01	1968-09-01 00:00:00	1968-09-22	1968-09-22 00:00:00	1968-09-22	38000177		0	0	21		0	0	0	271844	0	562251	1713671		
39853	3296	1127433	1948-10-02	1948-10-02 00:00:00	1948-10-09	1948-10-09 00:00:00	1948-10-09	38000177		0	0	7		0	0	0	219085	0	313782	1127433		
14834	1242	1127433	1975-10-14	1975-10-14 00:00:00	1975-10-21	1975-10-21 00:00:00	1975-10-21	38000177		0	0	7		0	0	0	81821	0	313782	1127433		
130679	2871	40213227	2012-02-13	2012-02-13 00:00:00	2012-02-13	2012-02-13 00:00:00	2012-02-13	581452		0	0	0		0	0	0	191059	0	113	40213227		
14905	1246	1127433	1971-09-30	1971-09-30 00:00:00	1971-10-07	1971-10-07 00:00:00	1971-10-07	38000177		0	0	7		0	0	0	82041	0	313782	1127433		
29383	2433	1127433	1994-03-17	1994-03-17 00:00:00	1994-04-21	1994-04-21 00:00:00	1994-04-21	38000177		0	0	35		0	0	0	161347	0	313782	1127433		
2282	184	19133873	1950-02-25	1950-02-25 00:00:00	1950-03-10	1950-03-10 00:00:00	1950-03-10	38000177		0	0	13		0	0	0	12432	0	834061	19133873		
29998	2485	19078461	2004-08-24	2004-08-24 00:00:00	2004-09-21	2004-09-21 00:00:00	2004-09-21	38000177		0	0	28		0	0	0	164691	0	310965	19078461		
59280	1297	40213227	2000-12-31	2000-12-31 00:00:00	2000-12-31	2000-12-31 00:00:00	2000-12-31	581452		0	0	0		0	0	0	85738	0	113	40213227		
37218	3077	40220960	2014-06-11	2014-06-11 00:00:00	2014-06-11	2014-06-11 00:00:00	2014-06-11	38000177		0	0	0		0	0	0	204737	0	1804799	40220960		
12823	277	40213306	1986-03-18	1986-03-18 00:00:00	1986-03-18	1986-03-18 00:00:00	1986-03-18	581452		0	0	0		0	0	0	18468	0	43	40213306		
8725	187	40213198	2011-02-13	2011-02-13 00:00:00	2011-02-13	2011-02-13 00:00:00	2011-02-13	581452		0	0	0		0	0	0	12690	0	133	40213198		
86313	1892	40213160	1965-06-24	1965-06-24 00:00:00	1965-06-24	1965-06-24 00:00:00	1965-06-24	581452		0	0	0		0	0	0	125998	0	10	40213160		
52889	4394	19078461	2000-08-12	2000-08-12 00:00:00	2000-11-10	2000-11-10 00:00:00	2000-11-10	38000177		0	0	90		0	0	0	292168	0	310965	19078461		
106080	2327	40213160	1958-06-25	1958-06-25 00:00:00	1958-06-25	1958-06-25 00:00:00	1958-06-25	581452		0	0	0		0	0	0	154757	0	10	40213160		
60036	4990	19059056	1966-03-04	1966-03-04 00:00:00	1966-06-02	1966-06-02 00:00:00	1966-06-02	38000177		0	0	90		0	0	0	331967	0	243670	19059056		
58409	4852	920300	1993-11-30	1993-11-30 00:00:00	1993-12-07	1993-12-07 00:00:00	1993-12-07	38000177		0	0	7		0	0	0	322835	0	311989	920300		
23819	1960	40222846	2004-04-05	2004-04-05 00:00:00	2004-04-05	2004-04-05 00:00:00	\N	38000177		0	0	0		0	0	0	130366	0	996740	40222846		
2753	61	40213306	1990-07-08	1990-07-08 00:00:00	1990-07-08	1990-07-08 00:00:00	1990-07-08	581452		0	0	0		0	0	0	4131	0	43	40213306		
198695	4365	40213227	1993-09-13	1993-09-13 00:00:00	1993-09-13	1993-09-13 00:00:00	1993-09-13	581452		0	0	0		0	0	0	289573	0	113	40213227		
34673	2863	1118084	2006-04-21	2006-04-21 00:00:00	2006-04-21	2006-04-21 00:00:00	\N	38000177		0	0	0		0	0	0	190409	0	00025152531	44923712		
45180	3739	19059056	1968-09-07	1968-09-07 00:00:00	1968-09-28	1968-09-28 00:00:00	1968-09-28	38000177		0	0	21		0	0	0	248441	0	243670	19059056		
179170	3939	40213160	1974-04-28	1974-04-28 00:00:00	1974-04-28	1974-04-28 00:00:00	1974-04-28	581452		0	0	0		0	0	0	261859	0	10	40213160		
50156	1099	40213160	1957-04-13	1957-04-13 00:00:00	1957-04-13	1957-04-13 00:00:00	1957-04-13	581452		0	0	0		0	0	0	72164	0	10	40213160		
24475	2013	19128065	1974-02-21	1974-02-21 00:00:00	1975-02-16	1975-02-16 00:00:00	1975-02-16	38000177		0	0	360		0	0	0	133954	0	749882	19128065		
20617	1699	19059056	1967-08-26	1967-08-26 00:00:00	1967-09-09	1967-09-09 00:00:00	1967-09-09	38000177		0	0	14		0	0	0	113673	0	243670	19059056		
32792	2715	1545959	2017-11-23	2017-11-23 00:00:00	2017-11-23	2017-11-23 00:00:00	2017-11-23	38000177		0	0	0		0	0	0	179971	0	259255	1545959		
54292	1188	40213296	2015-02-07	2015-02-07 00:00:00	2015-02-07	2015-02-07 00:00:00	2015-02-07	581452		0	0	0		0	0	0	78295	0	52	40213296		
5927	495	1115171	2001-10-13	2001-10-13 00:00:00	2001-11-03	2001-11-03 00:00:00	2001-11-03	38000177		0	0	21		0	0	0	33107	0	849574	1115171		
53101	4411	40236824	1990-05-20	1990-05-20 00:00:00	1990-05-27	1990-05-27 00:00:00	1990-05-27	38000177		0	0	7		0	0	0	293202	0	1094107	40236824		
52262	4347	19059056	1972-11-09	1972-11-09 00:00:00	1973-01-08	1973-01-08 00:00:00	1973-01-08	38000177		0	0	60		0	0	0	288290	0	243670	19059056		
13739	1148	1127078	1959-01-21	1959-01-21 00:00:00	1959-02-04	1959-02-04 00:00:00	1959-02-04	38000177		0	0	14		0	0	0	75876	0	282464	1127078		
11271	938	19059056	1971-04-04	1971-04-04 00:00:00	1971-04-18	1971-04-18 00:00:00	1971-04-18	38000177		0	0	14		0	0	0	62329	0	243670	19059056		
2337	187	40165015	2012-04-15	2012-04-15 00:00:00	2012-04-15	2012-04-15 00:00:00	\N	38000177		0	0	0		0	0	0	12739	0	861467	40165015		
40776	3381	46233988	1972-05-04	1972-05-04 00:00:00	1972-05-18	1972-05-18 00:00:00	1972-05-18	38000177		0	0	14		0	0	0	224351	0	1652673	46233988		
24371	2005	1115171	2013-08-11	2013-08-11 00:00:00	2013-10-10	2013-10-10 00:00:00	2013-10-10	38000177		0	0	60		0	0	0	133496	0	849574	1115171		
52327	4353	46233988	1967-04-04	1967-04-04 00:00:00	1967-04-18	1967-04-18 00:00:00	1967-04-18	38000177		0	0	14		0	0	0	288834	0	1652673	46233988		
61242	1338	40213227	2015-05-07	2015-05-07 00:00:00	2015-05-07	2015-05-07 00:00:00	2015-05-07	581452		0	0	0		0	0	0	88762	0	113	40213227		
170476	3748	40213227	2001-12-04	2001-12-04 00:00:00	2001-12-04	2001-12-04 00:00:00	2001-12-04	581452		0	0	0		0	0	0	249119	0	113	40213227		
52622	4375	1127433	1936-03-12	1936-03-12 00:00:00	1936-03-19	1936-03-19 00:00:00	1936-03-19	38000177		0	0	7		0	0	0	290633	0	313782	1127433		
53327	4432	1713671	1959-11-21	1959-11-21 00:00:00	1959-11-28	1959-11-28 00:00:00	1959-11-28	38000177		0	0	7		0	0	0	294614	0	562251	1713671		
32141	701	40213296	1999-09-11	1999-09-11 00:00:00	1999-09-11	1999-09-11 00:00:00	1999-09-11	581452		0	0	0		0	0	0	46342	0	52	40213296		
2956	239	19059056	1966-08-25	1966-08-25 00:00:00	1966-09-15	1966-09-15 00:00:00	1966-09-15	38000177		0	0	21		0	0	0	16051	0	243670	19059056		
24962	2053	1127433	1954-09-26	1954-09-26 00:00:00	1954-10-03	1954-10-03 00:00:00	1954-10-03	38000177		0	0	7		0	0	0	136507	0	313782	1127433		
125511	2761	40213160	1980-08-25	1980-08-25 00:00:00	1980-08-25	1980-08-25 00:00:00	1980-08-25	581452		0	0	0		0	0	0	182629	0	10	40213160		
43609	950	40213296	2010-08-22	2010-08-22 00:00:00	2010-08-22	2010-08-22 00:00:00	2010-08-22	581452		0	0	0		0	0	0	63125	0	52	40213296		
35506	2926	19133873	1995-12-03	1995-12-03 00:00:00	1995-12-11	1995-12-11 00:00:00	1995-12-11	38000177		0	0	8		0	0	0	195192	0	834061	19133873		
16331	352	40213314	1977-12-26	1977-12-26 00:00:00	1977-12-26	1977-12-26 00:00:00	1977-12-26	581452		0	0	0		0	0	0	23441	0	49	40213314		
12688	1068	19078461	2004-10-01	2004-10-01 00:00:00	2004-10-15	2004-10-15 00:00:00	2004-10-15	38000177		0	0	14		0	0	0	69961	0	310965	19078461		
18981	1568	1127433	1960-01-22	1960-01-22 00:00:00	1960-01-29	1960-01-29 00:00:00	1960-01-29	38000177		0	0	7		0	0	0	105198	0	313782	1127433		
47218	3916	19075001	2010-11-20	2010-11-20 00:00:00	2010-12-25	2010-12-25 00:00:00	2010-12-25	38000177		0	0	35		0	0	0	260441	0	309097	19075001		
30771	2550	920300	2012-02-08	2012-02-08 00:00:00	2012-02-15	2012-02-15 00:00:00	2012-02-15	38000177		0	0	7		0	0	0	168807	0	311989	920300		
196509	4317	40213227	1998-07-09	1998-07-09 00:00:00	1998-07-09	1998-07-09 00:00:00	1998-07-09	581452		0	0	0		0	0	0	286518	0	113	40213227		
44366	3672	1127433	1982-08-27	1982-08-27 00:00:00	1982-09-10	1982-09-10 00:00:00	1982-09-10	38000177		0	0	14		0	0	0	244305	0	313782	1127433		
60597	5041	46233988	1971-04-23	1971-04-23 00:00:00	1971-05-07	1971-05-07 00:00:00	1971-05-07	38000177		0	0	14		0	0	0	334929	0	1652673	46233988		
39228	857	40213260	2006-03-26	2006-03-26 00:00:00	2006-03-26	2006-03-26 00:00:00	2006-03-26	581452		0	0	0		0	0	0	56625	0	121	40213260		
41491	3438	19059056	1965-10-20	1965-10-20 00:00:00	1965-11-10	1965-11-10 00:00:00	1965-11-10	38000177		0	0	21		0	0	0	228135	0	243670	19059056		
12095	1015	19059056	1957-11-04	1957-11-04 00:00:00	1957-11-18	1957-11-18 00:00:00	1957-11-18	38000177		0	0	14		0	0	0	66812	0	243670	19059056		
55071	4572	19073183	1981-10-01	1981-10-01 00:00:00	1981-10-15	1981-10-15 00:00:00	1981-10-15	38000177		0	0	14		0	0	0	304605	0	308182	19073183		
153291	3375	40213296	1996-06-28	1996-06-28 00:00:00	1996-06-28	1996-06-28 00:00:00	1996-06-28	581452		0	0	0		0	0	0	223893	0	52	40213296		
7506	161	40213227	2009-03-08	2009-03-08 00:00:00	2009-03-08	2009-03-08 00:00:00	2009-03-08	581452		0	0	0		0	0	0	11053	0	113	40213227		
208302	4569	40213260	2012-01-24	2012-01-24 00:00:00	2012-01-24	2012-01-24 00:00:00	2012-01-24	581452		0	0	0		0	0	0	304393	0	121	40213260		
48048	3984	19059056	1964-08-27	1964-08-27 00:00:00	1964-09-10	1964-09-10 00:00:00	1964-09-10	38000177		0	0	14		0	0	0	264817	0	243670	19059056		
30002	653	40213201	2019-03-15	2019-03-15 00:00:00	2019-03-15	2019-03-15 00:00:00	2019-03-15	581452		0	0	0		0	0	0	43208	0	33	40213201		
49298	4090	46275916	2015-03-23	2015-03-23 00:00:00	2015-03-23	2015-03-23 00:00:00	2015-03-23	38000177		0	0	0		0	0	0	271940	0	1660014	46275916		
39854	3296	1713671	1994-06-23	1994-06-23 00:00:00	1994-07-14	1994-07-14 00:00:00	1994-07-14	38000177		0	0	21		0	0	0	219100	0	562251	1713671		
14835	1242	19006318	1964-02-27	1964-02-27 00:00:00	1964-03-12	1964-03-12 00:00:00	1964-03-12	38000177		0	0	14		0	0	0	81760	0	105078	19006318		
130686	2871	40213160	1955-11-21	1955-11-21 00:00:00	1955-11-21	1955-11-21 00:00:00	1955-11-21	581452		0	0	0		0	0	0	191089	0	10	40213160		
14906	1246	19059056	1969-09-26	1969-09-26 00:00:00	1969-11-25	1969-11-25 00:00:00	1969-11-25	38000177		0	0	60		0	0	0	82052	0	243670	19059056		
29384	2433	1127433	1966-09-21	1966-09-21 00:00:00	1966-11-20	1966-11-20 00:00:00	1966-11-20	38000177		0	0	60		0	0	0	161343	0	313782	1127433		
2283	184	19078461	2017-10-03	2017-10-03 00:00:00	2017-10-17	2017-10-17 00:00:00	2017-10-17	38000177		0	0	14		0	0	0	12505	0	310965	19078461		
29999	2486	19128022	1990-03-08	1990-03-08 00:00:00	1991-03-03	1991-03-03 00:00:00	1991-03-03	38000177		0	0	360		0	0	0	164754	0	749785	19128022		
59281	1297	40213306	2000-12-31	2000-12-31 00:00:00	2000-12-31	2000-12-31 00:00:00	2000-12-31	581452		0	0	0		0	0	0	85738	0	43	40213306		
37219	3077	1332419	2013-11-20	2013-11-20 00:00:00	2013-11-20	2013-11-20 00:00:00	\N	38000177		0	0	0		0	0	0	204737	0	197361	1332419		
12825	277	40213160	1968-11-12	1968-11-12 00:00:00	1968-11-12	1968-11-12 00:00:00	1968-11-12	581452		0	0	0		0	0	0	18483	0	10	40213160		
8737	187	40213201	2012-02-19	2012-02-19 00:00:00	2012-02-19	2012-02-19 00:00:00	2012-02-19	581452		0	0	0		0	0	0	12758	0	33	40213201		
86315	1892	40213160	1960-10-20	1960-10-20 00:00:00	1960-10-20	1960-10-20 00:00:00	1960-10-20	581452		0	0	0		0	0	0	126032	0	10	40213160		
52890	4394	40162522	2000-08-12	2000-08-12 00:00:00	2000-08-12	2000-08-12 00:00:00	\N	38000177		0	0	0		0	0	0	292168	0	857005	40162522		
106098	2327	40213227	1999-06-16	1999-06-16 00:00:00	1999-06-16	1999-06-16 00:00:00	1999-06-16	581452		0	0	0		0	0	0	154770	0	113	40213227		
60037	4990	40236824	1983-04-11	1983-04-11 00:00:00	1983-04-18	1983-04-18 00:00:00	1983-04-18	38000177		0	0	7		0	0	0	331954	0	1094107	40236824		
58411	4852	19006318	1951-03-11	1951-03-11 00:00:00	1951-03-25	1951-03-25 00:00:00	1951-03-25	38000177		0	0	14		0	0	0	322792	0	105078	19006318		
23820	1960	1118084	1971-05-14	1971-05-14 00:00:00	1971-05-14	1971-05-14 00:00:00	\N	38000177		0	0	0		0	0	0	130352	0	00025152531	44923712		
2757	61	40213260	2019-01-06	2019-01-06 00:00:00	2019-01-06	2019-01-06 00:00:00	2019-01-06	581452		0	0	0		0	0	0	4094	0	121	40213260		
164640	3621	40213227	1993-05-22	1993-05-22 00:00:00	1993-05-22	1993-05-22 00:00:00	1993-05-22	581452		0	0	0		0	0	0	240597	0	113	40213227		
34674	2864	19133873	1955-02-25	1955-02-25 00:00:00	1955-03-07	1955-03-07 00:00:00	1955-03-07	38000177		0	0	10		0	0	0	190550	0	834061	19133873		
45181	3739	19133905	2000-09-19	2000-09-19 00:00:00	2000-10-01	2000-10-01 00:00:00	2000-10-01	38000177		0	0	12		0	0	0	248446	0	834102	19133905		
179171	3939	40213306	1995-08-06	1995-08-06 00:00:00	1995-08-06	1995-08-06 00:00:00	1995-08-06	581452		0	0	0		0	0	0	261840	0	43	40213306		
50159	1099	40213227	2013-07-06	2013-07-06 00:00:00	2013-07-06	2013-07-06 00:00:00	2013-07-06	581452		0	0	0		0	0	0	72155	0	113	40213227		
24476	2013	1127433	1971-12-22	1971-12-22 00:00:00	1972-01-05	1972-01-05 00:00:00	1972-01-05	38000177		0	0	14		0	0	0	134002	0	313782	1127433		
20618	1699	1127433	1973-02-26	1973-02-26 00:00:00	1973-03-12	1973-03-12 00:00:00	1973-03-12	38000177		0	0	14		0	0	0	113605	0	313782	1127433		
32793	2715	19133768	2017-11-23	2017-11-23 00:00:00	2017-11-23	2017-11-23 00:00:00	2017-11-23	38000177		0	0	0		0	0	0	179971	0	833036	19133768		
54294	1188	40213314	1977-01-08	1977-01-08 00:00:00	1977-01-08	1977-01-08 00:00:00	1977-01-08	581452		0	0	0		0	0	0	78287	0	49	40213314		
5928	495	1127433	1998-12-08	1998-12-08 00:00:00	1998-12-22	1998-12-22 00:00:00	1998-12-22	38000177		0	0	14		0	0	0	33083	0	313782	1127433		
53102	4411	1127433	1946-03-13	1946-03-13 00:00:00	1946-03-20	1946-03-20 00:00:00	1946-03-20	38000177		0	0	7		0	0	0	293185	0	313782	1127433		
52263	4348	1127433	1982-11-16	1982-11-16 00:00:00	1982-11-23	1982-11-23 00:00:00	1982-11-23	38000177		0	0	7		0	0	0	288342	0	313782	1127433		
13740	1148	19006318	1959-01-21	1959-01-21 00:00:00	1959-02-04	1959-02-04 00:00:00	1959-02-04	38000177		0	0	14		0	0	0	75876	0	105078	19006318		
11274	938	1713671	2017-12-09	2017-12-09 00:00:00	2017-12-16	2017-12-16 00:00:00	2017-12-16	38000177		0	0	7		0	0	0	62322	0	562251	1713671		
2338	187	1115171	2012-04-15	2012-04-15 00:00:00	2012-07-14	2012-07-14 00:00:00	2012-07-14	38000177		0	0	90		0	0	0	12739	0	849574	1115171		
40777	3381	1127078	1974-10-10	1974-10-10 00:00:00	1974-10-24	1974-10-24 00:00:00	1974-10-24	38000177		0	0	14		0	0	0	224370	0	282464	1127078		
24372	2005	1713671	1985-06-13	1985-06-13 00:00:00	1985-07-04	1985-07-04 00:00:00	1985-07-04	38000177		0	0	21		0	0	0	133520	0	562251	1713671		
52329	4353	1127433	1980-08-30	1980-08-30 00:00:00	1980-09-29	1980-09-29 00:00:00	1980-09-29	38000177		0	0	30		0	0	0	288787	0	313782	1127433		
18469	1529	19133905	1994-02-21	1994-02-21 00:00:00	1994-02-28	1994-02-28 00:00:00	1994-02-28	38000177		0	0	7		0	0	0	102359	0	834102	19133905		
170477	3748	40213306	2001-12-04	2001-12-04 00:00:00	2001-12-04	2001-12-04 00:00:00	2001-12-04	581452		0	0	0		0	0	0	249119	0	43	40213306		
63081	5240	19006318	1952-05-27	1952-05-27 00:00:00	1952-06-10	1952-06-10 00:00:00	1952-06-10	38000177		0	0	14		0	0	0	348655	0	105078	19006318		
53328	4432	40229134	1966-01-11	1966-01-11 00:00:00	1966-01-25	1966-01-25 00:00:00	1966-01-25	38000177		0	0	14		0	0	0	294612	0	1043400	40229134		
32143	701	40213227	1999-09-11	1999-09-11 00:00:00	1999-09-11	1999-09-11 00:00:00	1999-09-11	581452		0	0	0		0	0	0	46342	0	113	40213227		
2957	239	1545959	2012-07-05	2012-07-05 00:00:00	2012-07-05	2012-07-05 00:00:00	2012-07-05	38000177		0	0	0		0	0	0	16054	0	259255	1545959		
24963	2053	1127433	2010-03-24	2010-03-24 00:00:00	2010-04-23	2010-04-23 00:00:00	2010-04-23	38000177		0	0	30		0	0	0	136571	0	313782	1127433		
125513	2761	40213227	2011-07-11	2011-07-11 00:00:00	2011-07-11	2011-07-11 00:00:00	2011-07-11	581452		0	0	0		0	0	0	182666	0	113	40213227		
43612	950	40213227	2001-12-09	2001-12-09 00:00:00	2001-12-09	2001-12-09 00:00:00	2001-12-09	581452		0	0	0		0	0	0	63124	0	113	40213227		
35507	2926	1127078	1982-11-12	1982-11-12 00:00:00	1982-11-26	1982-11-26 00:00:00	1982-11-26	38000177		0	0	14		0	0	0	195180	0	282464	1127078		
3630	79	40213201	2012-10-05	2012-10-05 00:00:00	2012-10-05	2012-10-05 00:00:00	2012-10-05	581452		0	0	0		0	0	0	5327	0	33	40213201		
12689	1068	1713671	1992-03-14	1992-03-14 00:00:00	1992-03-28	1992-03-28 00:00:00	1992-03-28	38000177		0	0	14		0	0	0	69956	0	562251	1713671		
18982	1568	1127078	1956-10-09	1956-10-09 00:00:00	1956-10-23	1956-10-23 00:00:00	1956-10-23	38000177		0	0	14		0	0	0	105168	0	282464	1127078		
47219	3916	1127078	1987-10-17	1987-10-17 00:00:00	1987-11-07	1987-11-07 00:00:00	1987-11-07	38000177		0	0	21		0	0	0	260434	0	282464	1127078		
30772	2550	19128022	1997-01-12	1997-01-12 00:00:00	1998-01-07	1998-01-07 00:00:00	1998-01-07	38000177		0	0	360		0	0	0	168835	0	749785	19128022		
196511	4317	40213227	2018-11-01	2018-11-01 00:00:00	2018-11-01	2018-11-01 00:00:00	2018-11-01	581452		0	0	0		0	0	0	286529	0	113	40213227		
44367	3672	19133873	1967-09-26	1967-09-26 00:00:00	1967-10-07	1967-10-07 00:00:00	1967-10-07	38000177		0	0	11		0	0	0	244285	0	834061	19133873		
60598	5041	19078461	2013-01-17	2013-01-17 00:00:00	2013-03-18	2013-03-18 00:00:00	2013-03-18	38000177		0	0	60		0	0	0	334921	0	310965	19078461		
39229	857	40213160	1955-08-07	1955-08-07 00:00:00	1955-08-07	1955-08-07 00:00:00	1955-08-07	581452		0	0	0		0	0	0	56602	0	10	40213160		
41492	3438	1127433	1977-08-11	1977-08-11 00:00:00	1977-08-18	1977-08-18 00:00:00	1977-08-18	38000177		0	0	7		0	0	0	228116	0	313782	1127433		
12096	1015	40229134	2010-06-30	2010-06-30 00:00:00	2010-07-07	2010-07-07 00:00:00	2010-07-07	38000177		0	0	7		0	0	0	66838	0	1043400	40229134		
55072	4572	19133873	1981-05-17	1981-05-17 00:00:00	1981-05-27	1981-05-27 00:00:00	1981-05-27	38000177		0	0	10		0	0	0	304600	0	834061	19133873		
153300	3375	40213160	1955-05-13	1955-05-13 00:00:00	1955-05-13	1955-05-13 00:00:00	1955-05-13	581452		0	0	0		0	0	0	223917	0	10	40213160		
7509	161	40213251	1984-11-18	1984-11-18 00:00:00	1984-11-18	1984-11-18 00:00:00	1984-11-18	581452		0	0	0		0	0	0	11077	0	21	40213251		
208309	4569	40213306	1984-01-24	1984-01-24 00:00:00	1984-01-24	1984-01-24 00:00:00	1984-01-24	581452		0	0	0		0	0	0	304411	0	43	40213306		
48049	3984	1127433	1957-05-07	1957-05-07 00:00:00	1957-05-21	1957-05-21 00:00:00	1957-05-21	38000177		0	0	14		0	0	0	264819	0	313782	1127433		
30006	654	40213160	1967-01-27	1967-01-27 00:00:00	1967-01-27	1967-01-27 00:00:00	1967-01-27	581452		0	0	0		0	0	0	43326	0	10	40213160		
49299	4090	1310034	2015-03-23	2015-03-23 00:00:00	2015-03-23	2015-03-23 00:00:00	2015-03-23	38000177		0	0	0		0	0	0	271940	0	834357	1310034		
39855	3296	1713671	2000-04-24	2000-04-24 00:00:00	2000-05-08	2000-05-08 00:00:00	2000-05-08	38000177		0	0	14		0	0	0	219025	0	562251	1713671		
14836	1242	1127078	1964-02-27	1964-02-27 00:00:00	1964-03-12	1964-03-12 00:00:00	1964-03-12	38000177		0	0	14		0	0	0	81760	0	282464	1127078		
130698	2871	40213201	2017-03-13	2017-03-13 00:00:00	2017-03-13	2017-03-13 00:00:00	2017-03-13	581452		0	0	0		0	0	0	191108	0	33	40213201		
14907	1246	40231925	1969-09-26	1969-09-26 00:00:00	1969-09-26	1969-09-26 00:00:00	\N	38000177		0	0	0		0	0	0	82052	0	1049221	40231925		
29385	2433	19078461	1981-06-04	1981-06-04 00:00:00	1981-07-02	1981-07-02 00:00:00	1981-07-02	38000177		0	0	28		0	0	0	161344	0	310965	19078461		
2284	184	40229134	2019-03-06	2019-03-06 00:00:00	2019-03-13	2019-03-13 00:00:00	2019-03-13	38000177		0	0	7		0	0	0	12435	0	1043400	40229134		
30000	2486	19128065	1994-02-15	1994-02-15 00:00:00	1995-02-10	1995-02-10 00:00:00	1995-02-10	38000177		0	0	360		0	0	0	164703	0	749882	19128065		
133639	2935	40213227	1998-06-10	1998-06-10 00:00:00	1998-06-10	1998-06-10 00:00:00	1998-06-10	581452		0	0	0		0	0	0	195713	0	113	40213227		
37220	3077	1127078	1954-06-17	1954-06-17 00:00:00	1954-08-16	1954-08-16 00:00:00	1954-08-16	38000177		0	0	60		0	0	0	204779	0	282464	1127078		
48809	4045	1127433	1982-03-07	1982-03-07 00:00:00	1982-03-21	1982-03-21 00:00:00	1982-03-21	38000177		0	0	14		0	0	0	269040	0	313782	1127433		
8742	187	40213227	2016-11-06	2016-11-06 00:00:00	2016-11-06	2016-11-06 00:00:00	2016-11-06	581452		0	0	0		0	0	0	12760	0	113	40213227		
22542	489	40213160	1975-11-09	1975-11-09 00:00:00	1975-11-09	1975-11-09 00:00:00	1975-11-09	581452		0	0	0		0	0	0	32741	0	10	40213160		
52892	4394	40229134	2014-05-12	2014-05-12 00:00:00	2014-05-26	2014-05-26 00:00:00	2014-05-26	38000177		0	0	14		0	0	0	292149	0	1043400	40229134		
106099	2327	40213296	1999-06-16	1999-06-16 00:00:00	1999-06-16	1999-06-16 00:00:00	1999-06-16	581452		0	0	0		0	0	0	154770	0	52	40213296		
60038	4990	920300	1983-04-11	1983-04-11 00:00:00	1983-04-18	1983-04-18 00:00:00	1983-04-18	38000177		0	0	7		0	0	0	331954	0	311989	920300		
58412	4852	19059056	1951-03-11	1951-03-11 00:00:00	1951-03-25	1951-03-25 00:00:00	1951-03-25	38000177		0	0	14		0	0	0	322792	0	243670	19059056		
23821	1960	19059056	1969-11-15	1969-11-15 00:00:00	1969-12-06	1969-12-06 00:00:00	1969-12-06	38000177		0	0	21		0	0	0	130331	0	243670	19059056		
2770	61	40213160	1968-06-30	1968-06-30 00:00:00	1968-06-30	1968-06-30 00:00:00	1968-06-30	581452		0	0	0		0	0	0	4108	0	10	40213160		
164676	3621	40213201	1988-10-22	1988-10-22 00:00:00	1988-10-22	1988-10-22 00:00:00	1988-10-22	581452		0	0	0		0	0	0	240656	0	33	40213201		
34675	2864	1127433	1969-08-27	1969-08-27 00:00:00	1969-09-10	1969-09-10 00:00:00	1969-09-10	38000177		0	0	14		0	0	0	190498	0	313782	1127433		
45182	3739	19133873	1971-01-26	1971-01-26 00:00:00	1971-02-03	1971-02-03 00:00:00	1971-02-03	38000177		0	0	8		0	0	0	248426	0	834061	19133873		
179173	3939	40213227	1995-08-06	1995-08-06 00:00:00	1995-08-06	1995-08-06 00:00:00	1995-08-06	581452		0	0	0		0	0	0	261840	0	113	40213227		
50160	1099	40213296	1996-04-27	1996-04-27 00:00:00	1996-04-27	1996-04-27 00:00:00	1996-04-27	581452		0	0	0		0	0	0	72169	0	52	40213296		
24478	2013	1118084	1996-08-19	1996-08-19 00:00:00	1996-08-19	1996-08-19 00:00:00	\N	38000177		0	0	0		0	0	0	133995	0	00025152531	44923712		
20619	1699	1713671	1998-06-10	1998-06-10 00:00:00	1998-07-01	1998-07-01 00:00:00	1998-07-01	38000177		0	0	21		0	0	0	113652	0	562251	1713671		
32794	2715	1127433	1982-05-15	1982-05-15 00:00:00	1982-07-14	1982-07-14 00:00:00	1982-07-14	38000177		0	0	60		0	0	0	179968	0	313782	1127433		
54296	1188	40213160	1975-07-12	1975-07-12 00:00:00	1975-07-12	1975-07-12 00:00:00	1975-07-12	581452		0	0	0		0	0	0	78285	0	10	40213160		
5929	495	1713671	2017-04-16	2017-04-16 00:00:00	2017-04-30	2017-04-30 00:00:00	2017-04-30	38000177		0	0	14		0	0	0	33057	0	562251	1713671		
53103	4411	19059056	1950-01-20	1950-01-20 00:00:00	1950-03-21	1950-03-21 00:00:00	1950-03-21	38000177		0	0	60		0	0	0	293248	0	243670	19059056		
52264	4348	1127433	2007-05-17	2007-05-17 00:00:00	2007-05-31	2007-05-31 00:00:00	2007-05-31	38000177		0	0	14		0	0	0	288346	0	313782	1127433		
13741	1148	19133873	1958-08-17	1958-08-17 00:00:00	1958-08-24	1958-08-24 00:00:00	1958-08-24	38000177		0	0	7		0	0	0	75886	0	834061	19133873		
11275	938	1713671	2000-02-19	2000-02-19 00:00:00	2000-03-04	2000-03-04 00:00:00	2000-03-04	38000177		0	0	14		0	0	0	62352	0	562251	1713671		
2339	187	1713671	1987-09-06	1987-09-06 00:00:00	1987-09-27	1987-09-27 00:00:00	1987-09-27	38000177		0	0	21		0	0	0	12743	0	562251	1713671		
40778	3381	19129655	1974-10-10	1974-10-10 00:00:00	1974-10-24	1974-10-24 00:00:00	1974-10-24	38000177		0	0	14		0	0	0	224370	0	789980	19129655		
24373	2005	1127433	2018-03-18	2018-03-18 00:00:00	2018-04-08	2018-04-08 00:00:00	2018-04-08	38000177		0	0	21		0	0	0	133497	0	313782	1127433		
52330	4353	40165015	1980-08-30	1980-08-30 00:00:00	1980-08-30	1980-08-30 00:00:00	\N	38000177		0	0	0		0	0	0	288787	0	861467	40165015		
18470	1529	19078461	2013-04-15	2013-04-15 00:00:00	2013-05-20	2013-05-20 00:00:00	2013-05-20	38000177		0	0	35		0	0	0	102356	0	310965	19078461		
170488	3748	40213160	1984-02-21	1984-02-21 00:00:00	1984-02-21	1984-02-21 00:00:00	1984-02-21	581452		0	0	0		0	0	0	249123	0	10	40213160		
63082	5240	1124300	1984-05-31	1984-05-31 00:00:00	1984-05-31	1984-05-31 00:00:00	\N	38000177		0	0	0		0	0	0	348643	0	00781178901	45011828		
1925	153	40236446	1957-06-06	1957-06-06 00:00:00	1960-01-14	1960-01-14 00:00:00	1960-01-14	38000177		0	0	952		0	0	0	10366	0	1091392	40236446		
32145	701	40213260	2007-09-01	2007-09-01 00:00:00	2007-09-01	2007-09-01 00:00:00	2007-09-01	581452		0	0	0		0	0	0	46361	0	121	40213260		
2958	239	19133768	2012-07-05	2012-07-05 00:00:00	2012-07-05	2012-07-05 00:00:00	2012-07-05	38000177		0	0	0		0	0	0	16054	0	833036	19133768		
24964	2053	40165015	2010-03-24	2010-03-24 00:00:00	2010-03-24	2010-03-24 00:00:00	\N	38000177		0	0	0		0	0	0	136571	0	861467	40165015		
125514	2761	40213314	1980-10-27	1980-10-27 00:00:00	1980-10-27	1980-10-27 00:00:00	1980-10-27	581452		0	0	0		0	0	0	182640	0	49	40213314		
43617	951	40213260	2006-01-25	2006-01-25 00:00:00	2006-01-25	2006-01-25 00:00:00	2006-01-25	581452		0	0	0		0	0	0	63152	0	121	40213260		
35508	2926	19073183	1982-11-12	1982-11-12 00:00:00	1982-11-26	1982-11-26 00:00:00	1982-11-26	38000177		0	0	14		0	0	0	195180	0	308182	19073183		
3631	79	40213227	1997-07-11	1997-07-11 00:00:00	1997-07-11	1997-07-11 00:00:00	1997-07-11	581452		0	0	0		0	0	0	5323	0	113	40213227		
12690	1068	1115171	2013-07-28	2013-07-28 00:00:00	2013-08-18	2013-08-18 00:00:00	2013-08-18	38000177		0	0	21		0	0	0	69963	0	849574	1115171		
18983	1568	19006318	1956-10-09	1956-10-09 00:00:00	1956-10-23	1956-10-23 00:00:00	1956-10-23	38000177		0	0	14		0	0	0	105168	0	105078	19006318		
47220	3916	1154615	1980-10-10	1980-10-10 00:00:00	1980-10-10	1980-10-10 00:00:00	\N	38000177		0	0	0		0	0	0	260340	0	745679	1154615		
30773	2550	19078461	2001-07-10	2001-07-10 00:00:00	2001-07-31	2001-07-31 00:00:00	2001-07-31	38000177		0	0	21		0	0	0	168804	0	310965	19078461		
21559	469	40213201	2002-07-06	2002-07-06 00:00:00	2002-07-06	2002-07-06 00:00:00	2002-07-06	581452		0	0	0		0	0	0	31369	0	33	40213201		
44368	3672	1127433	2009-03-09	2009-03-09 00:00:00	2009-03-16	2009-03-16 00:00:00	2009-03-16	38000177		0	0	7		0	0	0	244309	0	313782	1127433		
60599	5041	1127433	2007-02-14	2007-02-14 00:00:00	2007-02-28	2007-02-28 00:00:00	2007-02-28	38000177		0	0	14		0	0	0	334963	0	313782	1127433		
39232	857	40213160	1956-02-05	1956-02-05 00:00:00	1956-02-05	1956-02-05 00:00:00	1956-02-05	581452		0	0	0		0	0	0	56652	0	10	40213160		
41493	3438	1127433	1944-01-03	1944-01-03 00:00:00	1944-01-10	1944-01-10 00:00:00	1944-01-10	38000177		0	0	7		0	0	0	228115	0	313782	1127433		
12097	1015	1713671	2009-12-29	2009-12-29 00:00:00	2010-01-05	2010-01-05 00:00:00	2010-01-05	38000177		0	0	7		0	0	0	66837	0	562251	1713671		
55073	4572	1713671	1981-10-22	1981-10-22 00:00:00	1981-11-05	1981-11-05 00:00:00	1981-11-05	38000177		0	0	14		0	0	0	304646	0	562251	1713671		
153303	3375	40213160	1955-02-11	1955-02-11 00:00:00	1955-02-11	1955-02-11 00:00:00	1955-02-11	581452		0	0	0		0	0	0	223857	0	10	40213160		
18798	408	40213160	1966-05-18	1966-05-18 00:00:00	1966-05-18	1966-05-18 00:00:00	1966-05-18	581452		0	0	0		0	0	0	26931	0	10	40213160		
208316	4569	40213260	2013-01-29	2013-01-29 00:00:00	2013-01-29	2013-01-29 00:00:00	2013-01-29	581452		0	0	0		0	0	0	304367	0	121	40213260		
48050	3984	1127433	1965-05-23	1965-05-23 00:00:00	1965-05-30	1965-05-30 00:00:00	1965-05-30	38000177		0	0	7		0	0	0	264806	0	313782	1127433		
30009	654	40213296	2002-02-22	2002-02-22 00:00:00	2002-02-22	2002-02-22 00:00:00	2002-02-22	581452		0	0	0		0	0	0	43319	0	52	40213296		
49300	4090	40243436	2015-03-23	2015-03-23 00:00:00	2015-03-23	2015-03-23 00:00:00	2015-03-23	38000177		0	0	0		0	0	0	271940	0	1190795	40243436		
39856	3296	1127433	1971-03-24	1971-03-24 00:00:00	1971-04-21	1971-04-21 00:00:00	1971-04-21	38000177		0	0	28		0	0	0	219094	0	313782	1127433		
14837	1242	1127433	2007-05-20	2007-05-20 00:00:00	2007-06-03	2007-06-03 00:00:00	2007-06-03	38000177		0	0	14		0	0	0	81759	0	313782	1127433		
14853	1245	19133873	1947-08-31	1947-08-31 00:00:00	1947-09-08	1947-09-08 00:00:00	1947-09-08	38000177		0	0	8		0	0	0	81980	0	834061	19133873		
14908	1246	1127433	2005-04-12	2005-04-12 00:00:00	2005-04-19	2005-04-19 00:00:00	2005-04-19	38000177		0	0	7		0	0	0	82091	0	313782	1127433		
29386	2433	1127433	1996-02-06	1996-02-06 00:00:00	1996-02-20	1996-02-20 00:00:00	1996-02-20	38000177		0	0	14		0	0	0	161282	0	313782	1127433		
2285	185	1332419	1996-02-18	1996-02-18 00:00:00	1996-02-18	1996-02-18 00:00:00	\N	38000177		0	0	0		0	0	0	12572	0	197361	1332419		
30001	2486	19006318	1974-07-20	1974-07-20 00:00:00	1974-08-03	1974-08-03 00:00:00	1974-08-03	38000177		0	0	14		0	0	0	164737	0	105078	19006318		
133640	2935	40213306	1998-06-10	1998-06-10 00:00:00	1998-06-10	1998-06-10 00:00:00	1998-06-10	581452		0	0	0		0	0	0	195713	0	43	40213306		
37221	3077	19078461	1978-02-12	1978-02-12 00:00:00	1978-02-26	1978-02-26 00:00:00	1978-02-26	38000177		0	0	14		0	0	0	204721	0	310965	19078461		
48810	4045	1713671	1984-11-23	1984-11-23 00:00:00	1984-12-14	1984-12-14 00:00:00	1984-12-14	38000177		0	0	21		0	0	0	269014	0	562251	1713671		
8747	187	40213227	2007-01-21	2007-01-21 00:00:00	2007-01-21	2007-01-21 00:00:00	2007-01-21	581452		0	0	0		0	0	0	12730	0	113	40213227		
22547	489	40213160	1980-05-11	1980-05-11 00:00:00	1980-05-11	1980-05-11 00:00:00	1980-05-11	581452		0	0	0		0	0	0	32769	0	10	40213160		
52893	4394	19133873	1978-03-22	1978-03-22 00:00:00	1978-04-04	1978-04-04 00:00:00	1978-04-04	38000177		0	0	13		0	0	0	292140	0	834061	19133873		
8581	184	40213227	2007-06-11	2007-06-11 00:00:00	2007-06-11	2007-06-11 00:00:00	2007-06-11	581452		0	0	0		0	0	0	12415	0	113	40213227		
60039	4990	40229134	2008-06-06	2008-06-06 00:00:00	2008-06-13	2008-06-13 00:00:00	2008-06-13	38000177		0	0	7		0	0	0	332005	0	1043400	40229134		
58413	4852	19006318	1952-01-07	1952-01-07 00:00:00	1952-01-21	1952-01-21 00:00:00	1952-01-21	38000177		0	0	14		0	0	0	322793	0	105078	19006318		
23822	1960	1115171	2007-01-26	2007-01-26 00:00:00	2007-03-27	2007-03-27 00:00:00	2007-03-27	38000177		0	0	60		0	0	0	130333	0	849574	1115171		
31328	682	40213160	1971-04-28	1971-04-28 00:00:00	1971-04-28	1971-04-28 00:00:00	1971-04-28	581452		0	0	0		0	0	0	45161	0	10	40213160		
222044	4873	40213160	1981-06-26	1981-06-26 00:00:00	1981-06-26	1981-06-26 00:00:00	1981-06-26	581452		0	0	0		0	0	0	324120	0	10	40213160		
34676	2864	920300	1961-06-07	1961-06-07 00:00:00	1961-06-14	1961-06-14 00:00:00	1961-06-14	38000177		0	0	7		0	0	0	190496	0	311989	920300		
45183	3739	1127433	2005-05-27	2005-05-27 00:00:00	2005-06-03	2005-06-03 00:00:00	2005-06-03	38000177		0	0	7		0	0	0	248439	0	313782	1127433		
179177	3939	40213296	2017-04-16	2017-04-16 00:00:00	2017-04-16	2017-04-16 00:00:00	2017-04-16	581452		0	0	0		0	0	0	261851	0	52	40213296		
50163	1099	40213227	2003-04-19	2003-04-19 00:00:00	2003-04-19	2003-04-19 00:00:00	2003-04-19	581452		0	0	0		0	0	0	72170	0	113	40213227		
24480	2013	1127078	1965-07-28	1965-07-28 00:00:00	1965-08-25	1965-08-25 00:00:00	1965-08-25	38000177		0	0	28		0	0	0	134001	0	282464	1127078		
20620	1699	1124300	2003-11-10	2003-11-10 00:00:00	2003-11-10	2003-11-10 00:00:00	\N	38000177		0	0	0		0	0	0	113611	0	00781178901	45011828		
32795	2715	19075601	1997-03-27	1997-03-27 00:00:00	2017-11-23	2017-11-23 00:00:00	2017-11-23	38000177		0	0	7546		0	0	0	\N	0	309362	19075601		
54300	1188	40213306	1997-04-05	1997-04-05 00:00:00	1997-04-05	1997-04-05 00:00:00	1997-04-05	581452		0	0	0		0	0	0	78298	0	43	40213306		
5930	495	19133873	1979-01-18	1979-01-18 00:00:00	1979-01-25	1979-01-25 00:00:00	1979-01-25	38000177		0	0	7		0	0	0	33063	0	834061	19133873		
53104	4411	19133905	2017-06-15	2017-06-15 00:00:00	2017-06-26	2017-06-26 00:00:00	2017-06-26	38000177		0	0	11		0	0	0	293166	0	834102	19133905		
52265	4348	19078461	2000-11-01	2000-11-01 00:00:00	2000-11-15	2000-11-15 00:00:00	2000-11-15	38000177		0	0	14		0	0	0	288319	0	310965	19078461		
13742	1148	19133873	1963-02-03	1963-02-03 00:00:00	1963-02-10	1963-02-10 00:00:00	1963-02-10	38000177		0	0	7		0	0	0	75877	0	834061	19133873		
11276	938	1127433	1990-08-10	1990-08-10 00:00:00	1990-08-24	1990-08-24 00:00:00	1990-08-24	38000177		0	0	14		0	0	0	62351	0	313782	1127433		
2340	187	19059056	1947-09-28	1947-09-28 00:00:00	1947-10-11	1947-10-11 00:00:00	1947-10-11	38000177		0	0	13		0	0	0	12706	0	243670	19059056		
40779	3381	1713671	2013-05-18	2013-05-18 00:00:00	2013-06-01	2013-06-01 00:00:00	2013-06-01	38000177		0	0	14		0	0	0	224368	0	562251	1713671		
24374	2005	1713671	2001-04-12	2001-04-12 00:00:00	2001-05-03	2001-05-03 00:00:00	2001-05-03	38000177		0	0	21		0	0	0	133481	0	562251	1713671		
52331	4353	19133905	1990-05-20	1990-05-20 00:00:00	1990-05-28	1990-05-28 00:00:00	1990-05-28	38000177		0	0	8		0	0	0	288757	0	834102	19133905		
18471	1529	19006318	1978-10-23	1978-10-23 00:00:00	1978-11-06	1978-11-06 00:00:00	1978-11-06	38000177		0	0	14		0	0	0	102311	0	105078	19006318		
170489	3748	40213251	1984-02-21	1984-02-21 00:00:00	1984-02-21	1984-02-21 00:00:00	1984-02-21	581452		0	0	0		0	0	0	249123	0	21	40213251		
63083	5240	19078461	1979-04-06	1979-04-06 00:00:00	1979-06-12	1979-06-12 00:00:00	1979-06-12	38000177		0	0	67		0	0	0	348611	0	310965	19078461		
1926	153	40236824	1997-07-03	1997-07-03 00:00:00	1997-07-10	1997-07-10 00:00:00	1997-07-10	38000177		0	0	7		0	0	0	10387	0	1094107	40236824		
32157	701	40213160	1958-02-08	1958-02-08 00:00:00	1958-02-08	1958-02-08 00:00:00	1958-02-08	581452		0	0	0		0	0	0	46307	0	10	40213160		
2959	239	19059056	1947-07-17	1947-07-17 00:00:00	1947-08-21	1947-08-21 00:00:00	1947-08-21	38000177		0	0	35		0	0	0	16048	0	243670	19059056		
24965	2053	19075601	2007-09-20	2007-09-20 00:00:00	2007-09-20	2007-09-20 00:00:00	2007-09-20	38000177		0	0	0		0	0	0	136496	0	309362	19075601		
125515	2761	40213160	1980-10-27	1980-10-27 00:00:00	1980-10-27	1980-10-27 00:00:00	1980-10-27	581452		0	0	0		0	0	0	182640	0	10	40213160		
43618	951	40213160	1955-06-08	1955-06-08 00:00:00	1955-06-08	1955-06-08 00:00:00	1955-06-08	581452		0	0	0		0	0	0	63157	0	10	40213160		
35509	2926	1713671	1990-07-30	1990-07-30 00:00:00	1990-08-06	1990-08-06 00:00:00	1990-08-06	38000177		0	0	7		0	0	0	195175	0	562251	1713671		
3644	79	40213198	2011-09-30	2011-09-30 00:00:00	2011-09-30	2011-09-30 00:00:00	2011-09-30	581452		0	0	0		0	0	0	5222	0	133	40213198		
12698	1070	1713671	2018-12-30	2018-12-30 00:00:00	2019-01-06	2019-01-06 00:00:00	2019-01-06	38000177		0	0	7		0	0	0	70066	0	562251	1713671		
18984	1568	1127433	1959-04-29	1959-04-29 00:00:00	1959-05-13	1959-05-13 00:00:00	1959-05-13	38000177		0	0	14		0	0	0	105153	0	313782	1127433		
47221	3916	40169216	1980-10-10	1980-10-10 00:00:00	1980-10-10	1980-10-10 00:00:00	\N	38000177		0	0	0		0	0	0	260340	0	895994	40169216		
30774	2550	19128065	1998-01-07	1998-01-07 00:00:00	1999-01-02	1999-01-02 00:00:00	1999-01-02	38000177		0	0	360		0	0	0	168794	0	749882	19128065		
21566	469	40213227	1997-06-07	1997-06-07 00:00:00	1997-06-07	1997-06-07 00:00:00	1997-06-07	581452		0	0	0		0	0	0	31218	0	113	40213227		
44369	3672	19059056	1965-06-05	1965-06-05 00:00:00	1965-06-19	1965-06-19 00:00:00	1965-06-19	38000177		0	0	14		0	0	0	244330	0	243670	19059056		
60600	5041	19128065	1984-11-20	1984-11-20 00:00:00	1985-11-15	1985-11-15 00:00:00	1985-11-15	38000177		0	0	360		0	0	0	334943	0	749882	19128065		
39244	857	40213227	2013-05-05	2013-05-05 00:00:00	2013-05-05	2013-05-05 00:00:00	2013-05-05	581452		0	0	0		0	0	0	56643	0	113	40213227		
41494	3438	920334	1938-05-26	1938-05-26 00:00:00	1938-06-02	1938-06-02 00:00:00	1938-06-02	38000177		0	0	7		0	0	0	228073	0	311995	920334		
12098	1015	1127433	1976-07-29	1976-07-29 00:00:00	1976-08-05	1976-08-05 00:00:00	1976-08-05	38000177		0	0	7		0	0	0	66823	0	313782	1127433		
55081	4574	1127433	1968-04-14	1968-04-14 00:00:00	1968-04-21	1968-04-21 00:00:00	1968-04-21	38000177		0	0	7		0	0	0	304725	0	313782	1127433		
153312	3375	40213227	2005-03-11	2005-03-11 00:00:00	2005-03-11	2005-03-11 00:00:00	2005-03-11	581452		0	0	0		0	0	0	223894	0	113	40213227		
18799	408	40213160	1961-11-15	1961-11-15 00:00:00	1961-11-15	1961-11-15 00:00:00	1961-11-15	581452		0	0	0		0	0	0	26929	0	10	40213160		
208317	4569	40213227	2013-01-29	2013-01-29 00:00:00	2013-01-29	2013-01-29 00:00:00	2013-01-29	581452		0	0	0		0	0	0	304367	0	113	40213227		
48051	3984	40229134	1958-03-26	1958-03-26 00:00:00	1958-04-02	1958-04-02 00:00:00	1958-04-02	38000177		0	0	7		0	0	0	264804	0	1043400	40229134		
30015	654	40213160	1962-07-27	1962-07-27 00:00:00	1962-07-27	1962-07-27 00:00:00	1962-07-27	581452		0	0	0		0	0	0	43324	0	10	40213160		
49301	4090	1127433	1952-02-01	1952-02-01 00:00:00	1952-02-08	1952-02-08 00:00:00	1952-02-08	38000177		0	0	7		0	0	0	271847	0	313782	1127433		
39857	3296	19077572	2018-08-17	2018-08-17 00:00:00	2018-08-17	2018-08-17 00:00:00	\N	38000177		0	0	0		0	0	0	219050	0	310436	19077572		
14838	1242	1118084	2000-10-21	2000-10-21 00:00:00	2000-10-21	2000-10-21 00:00:00	\N	38000177		0	0	0		0	0	0	81808	0	00025152531	44923712		
14854	1245	1713671	1968-11-02	1968-11-02 00:00:00	1968-11-23	1968-11-23 00:00:00	1968-11-23	38000177		0	0	21		0	0	0	81953	0	562251	1713671		
51349	1124	40213227	2017-07-23	2017-07-23 00:00:00	2017-07-23	2017-07-23 00:00:00	2017-07-23	581452		0	0	0		0	0	0	74063	0	113	40213227		
29387	2433	1127078	1955-01-01	1955-01-01 00:00:00	1955-01-22	1955-01-22 00:00:00	1955-01-22	38000177		0	0	21		0	0	0	161342	0	282464	1127078		
2286	185	1539411	1996-02-18	1996-02-18 00:00:00	1996-02-18	1996-02-18 00:00:00	\N	38000177		0	0	0		0	0	0	12572	0	312961	1539411		
30002	2486	1127078	1974-07-20	1974-07-20 00:00:00	1974-08-03	1974-08-03 00:00:00	1974-08-03	38000177		0	0	14		0	0	0	164737	0	282464	1127078		
133648	2935	40213160	1981-03-18	1981-03-18 00:00:00	1981-03-18	1981-03-18 00:00:00	1981-03-18	581452		0	0	0		0	0	0	195709	0	10	40213160		
37222	3077	1127433	1991-09-16	1991-09-16 00:00:00	1991-09-30	1991-09-30 00:00:00	1991-09-30	38000177		0	0	14		0	0	0	204723	0	313782	1127433		
48823	4049	1127433	1979-11-24	1979-11-24 00:00:00	1980-02-22	1980-02-22 00:00:00	1980-02-22	38000177		0	0	90		0	0	0	269137	0	313782	1127433		
6514	549	1127433	1977-03-12	1977-03-12 00:00:00	1977-04-16	1977-04-16 00:00:00	1977-04-16	38000177		0	0	35		0	0	0	36423	0	313782	1127433		
33854	739	40213227	1992-01-08	1992-01-08 00:00:00	1992-01-08	1992-01-08 00:00:00	1992-01-08	581452		0	0	0		0	0	0	49020	0	113	40213227		
52894	4395	19059056	1949-10-26	1949-10-26 00:00:00	1949-12-25	1949-12-25 00:00:00	1949-12-25	38000177		0	0	60		0	0	0	292236	0	243670	19059056		
19870	432	40213227	2002-04-15	2002-04-15 00:00:00	2002-04-15	2002-04-15 00:00:00	2002-04-15	581452		0	0	0		0	0	0	28707	0	113	40213227		
60040	4990	1713671	1980-08-31	1980-08-31 00:00:00	1980-09-14	1980-09-14 00:00:00	1980-09-14	38000177		0	0	14		0	0	0	332000	0	562251	1713671		
58414	4852	19059056	1952-01-07	1952-01-07 00:00:00	1952-01-21	1952-01-21 00:00:00	1952-01-21	38000177		0	0	14		0	0	0	322793	0	243670	19059056		
23823	1960	19077572	2002-11-12	2002-11-12 00:00:00	2002-11-12	2002-11-12 00:00:00	\N	38000177		0	0	0		0	0	0	130412	0	310436	19077572		
31329	682	40213160	1971-07-28	1971-07-28 00:00:00	1971-07-28	1971-07-28 00:00:00	1971-07-28	581452		0	0	0		0	0	0	45167	0	10	40213160		
222047	4873	40213314	1977-03-25	1977-03-25 00:00:00	1977-03-25	1977-03-25 00:00:00	1977-03-25	581452		0	0	0		0	0	0	324101	0	49	40213314		
34677	2864	40236824	1961-06-07	1961-06-07 00:00:00	1961-06-14	1961-06-14 00:00:00	1961-06-14	38000177		0	0	7		0	0	0	190496	0	1094107	40236824		
45184	3739	1115171	2009-08-24	2009-08-24 00:00:00	2009-10-23	2009-10-23 00:00:00	2009-10-23	38000177		0	0	60		0	0	0	248443	0	849574	1115171		
12427	268	40213160	1967-05-30	1967-05-30 00:00:00	1967-05-30	1967-05-30 00:00:00	1967-05-30	581452		0	0	0		0	0	0	17785	0	10	40213160		
50165	1099	40213260	2006-09-23	2006-09-23 00:00:00	2006-09-23	2006-09-23 00:00:00	2006-09-23	581452		0	0	0		0	0	0	72116	0	121	40213260		
24481	2013	1127433	1964-05-06	1964-05-06 00:00:00	1964-05-20	1964-05-20 00:00:00	1964-05-20	38000177		0	0	14		0	0	0	134005	0	313782	1127433		
20621	1699	19078461	1979-01-25	1979-01-25 00:00:00	1979-04-25	1979-04-25 00:00:00	1979-04-25	38000177		0	0	90		0	0	0	113627	0	310965	19078461		
32796	2715	1539411	1991-06-06	1991-06-06 00:00:00	1991-06-06	1991-06-06 00:00:00	\N	38000177		0	0	0		0	0	0	180091	0	312961	1539411		
54302	1188	40213227	1997-04-05	1997-04-05 00:00:00	1997-04-05	1997-04-05 00:00:00	1997-04-05	581452		0	0	0		0	0	0	78298	0	113	40213227		
5931	495	1127078	1969-08-11	1969-08-11 00:00:00	1969-08-25	1969-08-25 00:00:00	1969-08-25	38000177		0	0	14		0	0	0	33058	0	282464	1127078		
53105	4411	1127433	2003-03-13	2003-03-13 00:00:00	2003-03-27	2003-03-27 00:00:00	2003-03-27	38000177		0	0	14		0	0	0	293250	0	313782	1127433		
52266	4348	1115171	1995-11-07	1995-11-07 00:00:00	1995-11-28	1995-11-28 00:00:00	1995-11-28	38000177		0	0	21		0	0	0	288326	0	849574	1115171		
13743	1148	19059056	1967-09-03	1967-09-03 00:00:00	1967-10-03	1967-10-03 00:00:00	1967-10-03	38000177		0	0	30		0	0	0	75931	0	243670	19059056		
11277	938	1127433	2017-05-22	2017-05-22 00:00:00	2017-06-05	2017-06-05 00:00:00	2017-06-05	38000177		0	0	14		0	0	0	62382	0	313782	1127433		
2341	187	19006318	1947-09-28	1947-09-28 00:00:00	1947-10-11	1947-10-11 00:00:00	1947-10-11	38000177		0	0	13		0	0	0	12706	0	105078	19006318		
40780	3381	40229134	2015-07-24	2015-07-24 00:00:00	2015-08-07	2015-08-07 00:00:00	2015-08-07	38000177		0	0	14		0	0	0	224385	0	1043400	40229134		
24375	2005	1127078	1976-09-07	1976-09-07 00:00:00	1976-09-21	1976-09-21 00:00:00	1976-09-21	38000177		0	0	14		0	0	0	133502	0	282464	1127078		
52332	4353	1127433	1991-11-26	1991-11-26 00:00:00	1991-12-03	1991-12-03 00:00:00	1991-12-03	38000177		0	0	7		0	0	0	288784	0	313782	1127433		
18472	1529	19078461	1978-10-23	1978-10-23 00:00:00	1978-11-06	1978-11-06 00:00:00	1978-11-06	38000177		0	0	14		0	0	0	102311	0	310965	19078461		
170499	3748	40213314	1979-06-19	1979-06-19 00:00:00	1979-06-19	1979-06-19 00:00:00	1979-06-19	581452		0	0	0		0	0	0	249102	0	49	40213314		
63084	5240	1127433	2001-12-13	2001-12-13 00:00:00	2002-01-03	2002-01-03 00:00:00	2002-01-03	38000177		0	0	21		0	0	0	348613	0	313782	1127433		
1927	153	920300	1997-07-03	1997-07-03 00:00:00	1997-07-10	1997-07-10 00:00:00	1997-07-10	38000177		0	0	7		0	0	0	10387	0	311989	920300		
32159	701	40213227	2008-09-06	2008-09-06 00:00:00	2008-09-06	2008-09-06 00:00:00	2008-09-06	581452		0	0	0		0	0	0	46298	0	113	40213227		
2960	239	40229134	1984-10-23	1984-10-23 00:00:00	1984-10-30	1984-10-30 00:00:00	1984-10-30	38000177		0	0	7		0	0	0	16028	0	1043400	40229134		
24966	2053	40220960	2007-09-20	2007-09-20 00:00:00	2007-09-20	2007-09-20 00:00:00	2007-09-20	38000177		0	0	0		0	0	0	136496	0	1804799	40220960		
125522	2761	40213306	2002-06-03	2002-06-03 00:00:00	2002-06-03	2002-06-03 00:00:00	2002-06-03	581452		0	0	0		0	0	0	182659	0	43	40213306		
43625	951	40213198	2017-11-15	2017-11-15 00:00:00	2017-11-15	2017-11-15 00:00:00	2017-11-15	581452		0	0	0		0	0	0	63216	0	133	40213198		
35510	2926	19128065	1997-09-04	1997-09-04 00:00:00	1998-08-30	1998-08-30 00:00:00	1998-08-30	38000177		0	0	360		0	0	0	195142	0	749882	19128065		
3660	80	40213227	2018-04-09	2018-04-09 00:00:00	2018-04-09	2018-04-09 00:00:00	2018-04-09	581452		0	0	0		0	0	0	5459	0	113	40213227		
12699	1070	19059056	1976-09-12	1976-09-12 00:00:00	1976-10-03	1976-10-03 00:00:00	1976-10-03	38000177		0	0	21		0	0	0	70097	0	243670	19059056		
18985	1568	1127433	2017-12-07	2017-12-07 00:00:00	2017-12-28	2017-12-28 00:00:00	2017-12-28	38000177		0	0	21		0	0	0	105225	0	313782	1127433		
47222	3916	40231925	1997-06-24	1997-06-24 00:00:00	1997-06-24	1997-06-24 00:00:00	\N	38000177		0	0	0		0	0	0	260357	0	1049221	40231925		
30775	2550	1713671	1997-07-24	1997-07-24 00:00:00	1997-10-02	1997-10-02 00:00:00	1997-10-02	38000177		0	0	70		0	0	0	168806	0	562251	1713671		
21591	469	40213227	2007-08-04	2007-08-04 00:00:00	2007-08-04	2007-08-04 00:00:00	2007-08-04	581452		0	0	0		0	0	0	31259	0	113	40213227		
44370	3672	19006318	1965-06-05	1965-06-05 00:00:00	1965-06-19	1965-06-19 00:00:00	1965-06-19	38000177		0	0	14		0	0	0	244330	0	105078	19006318		
60601	5041	1118084	2013-10-04	2013-10-04 00:00:00	2013-10-04	2013-10-04 00:00:00	\N	38000177		0	0	0		0	0	0	334964	0	00025152531	44923712		
39250	857	40213160	1957-02-10	1957-02-10 00:00:00	1957-02-10	1957-02-10 00:00:00	1957-02-10	581452		0	0	0		0	0	0	56603	0	10	40213160		
41495	3438	1713671	1930-04-20	1930-04-20 00:00:00	1930-05-04	1930-05-04 00:00:00	1930-05-04	38000177		0	0	14		0	0	0	228113	0	562251	1713671		
12099	1015	1118084	1988-06-04	1988-06-04 00:00:00	1988-06-04	1988-06-04 00:00:00	\N	38000177		0	0	0		0	0	0	66786	0	00025152531	44923712		
55082	4574	19059056	1970-11-28	1970-11-28 00:00:00	1971-01-02	1971-01-02 00:00:00	1971-01-02	38000177		0	0	35		0	0	0	304711	0	243670	19059056		
153314	3375	40213227	2015-12-04	2015-12-04 00:00:00	2015-12-04	2015-12-04 00:00:00	2015-12-04	581452		0	0	0		0	0	0	223909	0	113	40213227		
18801	408	40213160	1962-02-14	1962-02-14 00:00:00	1962-02-14	1962-02-14 00:00:00	1962-02-14	581452		0	0	0		0	0	0	26971	0	10	40213160		
70580	1543	40213227	1992-09-13	1992-09-13 00:00:00	1992-09-13	1992-09-13 00:00:00	1992-09-13	581452		0	0	0		0	0	0	103388	0	113	40213227		
48052	3984	1118084	1995-02-01	1995-02-01 00:00:00	1995-02-01	1995-02-01 00:00:00	\N	38000177		0	0	0		0	0	0	264864	0	00025152531	44923712		
30016	654	40213160	1962-05-25	1962-05-25 00:00:00	1962-05-25	1962-05-25 00:00:00	1962-05-25	581452		0	0	0		0	0	0	43340	0	10	40213160		
49302	4090	1118084	1984-06-30	1984-06-30 00:00:00	1984-06-30	1984-06-30 00:00:00	\N	38000177		0	0	0		0	0	0	271887	0	00025152531	44923712		
39858	3296	1124300	1980-06-26	1980-06-26 00:00:00	1980-06-26	1980-06-26 00:00:00	\N	38000177		0	0	0		0	0	0	219038	0	00781178901	45011828		
14840	1242	1127433	1985-05-07	1985-05-07 00:00:00	1985-05-14	1985-05-14 00:00:00	1985-05-14	38000177		0	0	7		0	0	0	81823	0	313782	1127433		
14855	1245	40231925	1949-02-18	1949-02-18 00:00:00	1949-02-18	1949-02-18 00:00:00	\N	38000177		0	0	0		0	0	0	81935	0	1049221	40231925		
51354	1124	40213227	1997-06-22	1997-06-22 00:00:00	1997-06-22	1997-06-22 00:00:00	1997-06-22	581452		0	0	0		0	0	0	74087	0	113	40213227		
29388	2433	19059056	1958-02-14	1958-02-14 00:00:00	1958-02-28	1958-02-28 00:00:00	1958-02-28	38000177		0	0	14		0	0	0	161337	0	243670	19059056		
2287	185	19126352	1996-02-18	1996-02-18 00:00:00	1996-02-18	1996-02-18 00:00:00	\N	38000177		0	0	0		0	0	0	12572	0	705129	19126352		
30003	2486	1127433	2007-02-07	2007-02-07 00:00:00	2007-02-21	2007-02-21 00:00:00	2007-02-21	38000177		0	0	14		0	0	0	164742	0	313782	1127433		
133652	2935	40213160	1976-09-15	1976-09-15 00:00:00	1976-09-15	1976-09-15 00:00:00	1976-09-15	581452		0	0	0		0	0	0	195689	0	10	40213160		
37223	3077	1118084	1992-05-03	1992-05-03 00:00:00	1992-05-03	1992-05-03 00:00:00	\N	38000177		0	0	0		0	0	0	204723	0	00025152531	44923712		
48824	4049	1127433	2017-11-13	2017-11-13 00:00:00	2017-11-27	2017-11-27 00:00:00	2017-11-27	38000177		0	0	14		0	0	0	269175	0	313782	1127433		
6516	549	19133873	1958-09-01	1958-09-01 00:00:00	1958-09-12	1958-09-12 00:00:00	1958-09-12	38000177		0	0	11		0	0	0	36355	0	834061	19133873		
19410	422	40213296	1999-01-16	1999-01-16 00:00:00	1999-01-16	1999-01-16 00:00:00	1999-01-16	581452		0	0	0		0	0	0	27927	0	52	40213296		
52895	4395	40165015	1963-03-17	1963-03-17 00:00:00	1963-03-17	1963-03-17 00:00:00	\N	38000177		0	0	0		0	0	0	292238	0	861467	40165015		
19886	432	40213227	1992-08-10	1992-08-10 00:00:00	1992-08-10	1992-08-10 00:00:00	1992-08-10	581452		0	0	0		0	0	0	28706	0	113	40213227		
13233	1110	1127433	1988-10-11	1988-10-11 00:00:00	1988-10-18	1988-10-18 00:00:00	1988-10-18	38000177		0	0	7		0	0	0	73100	0	313782	1127433		
58415	4852	1127433	1975-11-23	1975-11-23 00:00:00	1975-11-30	1975-11-30 00:00:00	1975-11-30	38000177		0	0	7		0	0	0	322773	0	313782	1127433		
23824	1960	920300	1951-08-14	1951-08-14 00:00:00	1951-08-21	1951-08-21 00:00:00	1951-08-21	38000177		0	0	7		0	0	0	130322	0	311989	920300		
42255	921	40213227	1997-09-02	1997-09-02 00:00:00	1997-09-02	1997-09-02 00:00:00	1997-09-02	581452		0	0	0		0	0	0	61351	0	113	40213227		
222049	4873	40213160	1977-03-25	1977-03-25 00:00:00	1977-03-25	1977-03-25 00:00:00	1977-03-25	581452		0	0	0		0	0	0	324101	0	10	40213160		
34678	2864	1127433	2013-05-05	2013-05-05 00:00:00	2013-05-19	2013-05-19 00:00:00	2013-05-19	38000177		0	0	14		0	0	0	190470	0	313782	1127433		
14965	1250	920300	1984-04-23	1984-04-23 00:00:00	1984-04-30	1984-04-30 00:00:00	1984-04-30	38000177		0	0	7		0	0	0	82319	0	311989	920300		
12438	268	40213160	1971-10-26	1971-10-26 00:00:00	1971-10-26	1971-10-26 00:00:00	1971-10-26	581452		0	0	0		0	0	0	17787	0	10	40213160		
50168	1099	40213201	2018-08-04	2018-08-04 00:00:00	2018-08-04	2018-08-04 00:00:00	2018-08-04	581452		0	0	0		0	0	0	72236	0	33	40213201		
68201	1493	40213227	1998-10-06	1998-10-06 00:00:00	1998-10-06	1998-10-06 00:00:00	1998-10-06	581452		0	0	0		0	0	0	99508	0	113	40213227		
20622	1699	40162522	1979-01-25	1979-01-25 00:00:00	1979-01-25	1979-01-25 00:00:00	\N	38000177		0	0	0		0	0	0	113627	0	857005	40162522		
32797	2715	1127078	1970-07-21	1970-07-21 00:00:00	1970-08-25	1970-08-25 00:00:00	1970-08-25	38000177		0	0	35		0	0	0	179965	0	282464	1127078		
54303	1188	40213314	1978-01-07	1978-01-07 00:00:00	1978-01-07	1978-01-07 00:00:00	1978-01-07	581452		0	0	0		0	0	0	78270	0	49	40213314		
5932	495	1118084	2005-06-28	2005-06-28 00:00:00	2005-06-28	2005-06-28 00:00:00	\N	38000177		0	0	0		0	0	0	33101	0	00025152531	44923712		
53106	4412	1115171	2007-01-18	2007-01-18 00:00:00	2007-02-01	2007-02-01 00:00:00	2007-02-01	38000177		0	0	14		0	0	0	293286	0	849574	1115171		
31290	2594	1127433	1993-07-03	1993-07-03 00:00:00	1993-07-10	1993-07-10 00:00:00	1993-07-10	38000177		0	0	7		0	0	0	171700	0	313782	1127433		
13744	1148	1115171	2002-02-15	2002-02-15 00:00:00	2002-03-01	2002-03-01 00:00:00	2002-03-01	38000177		0	0	14		0	0	0	75933	0	849574	1115171		
11278	938	1127433	1975-05-22	1975-05-22 00:00:00	1975-05-29	1975-05-29 00:00:00	1975-05-29	38000177		0	0	7		0	0	0	62348	0	313782	1127433		
2342	188	1127078	1968-08-18	1968-08-18 00:00:00	1968-09-01	1968-09-01 00:00:00	1968-09-01	38000177		0	0	14		0	0	0	12829	0	282464	1127078		
40782	3381	19059056	1973-12-07	1973-12-07 00:00:00	1973-12-21	1973-12-21 00:00:00	1973-12-21	38000177		0	0	14		0	0	0	224390	0	243670	19059056		
24376	2005	46233988	1976-09-07	1976-09-07 00:00:00	1976-09-21	1976-09-21 00:00:00	1976-09-21	38000177		0	0	14		0	0	0	133502	0	1652673	46233988		
52333	4353	1118084	2008-01-09	2008-01-09 00:00:00	2008-01-09	2008-01-09 00:00:00	\N	38000177		0	0	0		0	0	0	288790	0	00025152531	44923712		
18473	1529	1713671	2009-07-03	2009-07-03 00:00:00	2009-07-24	2009-07-24 00:00:00	2009-07-24	38000177		0	0	21		0	0	0	102304	0	562251	1713671		
170500	3748	40213160	1979-06-19	1979-06-19 00:00:00	1979-06-19	1979-06-19 00:00:00	1979-06-19	581452		0	0	0		0	0	0	249102	0	10	40213160		
63085	5240	1115171	1997-04-08	1997-04-08 00:00:00	1997-06-07	1997-06-07 00:00:00	1997-06-07	38000177		0	0	60		0	0	0	348612	0	849574	1115171		
1929	154	1127433	2017-07-15	2017-07-15 00:00:00	2017-07-22	2017-07-22 00:00:00	2017-07-22	38000177		0	0	7		0	0	0	10473	0	313782	1127433		
32160	701	40213260	2008-09-06	2008-09-06 00:00:00	2008-09-06	2008-09-06 00:00:00	2008-09-06	581452		0	0	0		0	0	0	46298	0	121	40213260		
2961	239	19129655	1963-10-21	1963-10-21 00:00:00	1963-11-04	1963-11-04 00:00:00	1963-11-04	38000177		0	0	14		0	0	0	16020	0	789980	19129655		
24967	2053	1127078	1957-06-28	1957-06-28 00:00:00	1957-07-12	1957-07-12 00:00:00	1957-07-12	38000177		0	0	14		0	0	0	136480	0	282464	1127078		
125524	2761	40213227	2002-06-03	2002-06-03 00:00:00	2002-06-03	2002-06-03 00:00:00	2002-06-03	581452		0	0	0		0	0	0	182659	0	113	40213227		
43628	951	40213227	1994-02-09	1994-02-09 00:00:00	1994-02-09	1994-02-09 00:00:00	1994-02-09	581452		0	0	0		0	0	0	63174	0	113	40213227		
235262	5168	40213160	1971-11-05	1971-11-05 00:00:00	1971-11-05	1971-11-05 00:00:00	1971-11-05	581452		0	0	0		0	0	0	343639	0	10	40213160		
8417	703	19133905	1981-12-06	1981-12-06 00:00:00	1981-12-18	1981-12-18 00:00:00	1981-12-18	38000177		0	0	12		0	0	0	46436	0	834102	19133905		
12700	1070	1127433	1979-11-27	1979-11-27 00:00:00	1979-12-11	1979-12-11 00:00:00	1979-12-11	38000177		0	0	14		0	0	0	70061	0	313782	1127433		
18986	1569	40229134	2016-06-24	2016-06-24 00:00:00	2016-07-08	2016-07-08 00:00:00	2016-07-08	38000177		0	0	14		0	0	0	105273	0	1043400	40229134		
5965	129	40213227	2008-06-16	2008-06-16 00:00:00	2008-06-16	2008-06-16 00:00:00	2008-06-16	581452		0	0	0		0	0	0	8668	0	113	40213227		
30776	2550	1124300	2019-06-26	2019-06-26 00:00:00	2019-06-26	2019-06-26 00:00:00	\N	38000177		0	0	0		0	0	0	168793	0	00781178901	45011828		
52627	4375	19018935	2006-06-25	2006-06-25 00:00:00	2006-06-25	2006-06-25 00:00:00	\N	38000177		0	0	0		0	0	0	290646	0	197604	19018935		
44371	3672	40162522	1976-01-09	1976-01-09 00:00:00	1976-01-09	1976-01-09 00:00:00	\N	38000177		0	0	0		0	0	0	244326	0	857005	40162522		
60602	5041	1115171	1994-08-20	1994-08-20 00:00:00	1994-09-24	1994-09-24 00:00:00	1994-09-24	38000177		0	0	35		0	0	0	334920	0	849574	1115171		
39255	857	40213227	1994-09-25	1994-09-25 00:00:00	1994-09-25	1994-09-25 00:00:00	1994-09-25	581452		0	0	0		0	0	0	56630	0	113	40213227		
41496	3438	1127433	1918-03-02	1918-03-02 00:00:00	1918-03-16	1918-03-16 00:00:00	1918-03-16	38000177		0	0	14		0	0	0	228094	0	313782	1127433		
12100	1015	40229134	1979-12-29	1979-12-29 00:00:00	1980-01-05	1980-01-05 00:00:00	1980-01-05	38000177		0	0	7		0	0	0	66766	0	1043400	40229134		
55083	4574	46233710	1968-04-03	1968-04-03 00:00:00	1968-04-17	1968-04-17 00:00:00	1968-04-17	38000177		0	0	14		0	0	0	304698	0	1650142	46233710		
153318	3375	40213160	1959-02-13	1959-02-13 00:00:00	1959-02-13	1959-02-13 00:00:00	1959-02-13	581452		0	0	0		0	0	0	223861	0	10	40213160		
18809	408	40213227	1992-07-08	1992-07-08 00:00:00	1992-07-08	1992-07-08 00:00:00	1992-07-08	581452		0	0	0		0	0	0	26983	0	113	40213227		
146060	3212	40213314	1982-01-05	1982-01-05 00:00:00	1982-01-05	1982-01-05 00:00:00	1982-01-05	581452		0	0	0		0	0	0	213406	0	49	40213314		
175069	3849	40213160	1964-04-30	1964-04-30 00:00:00	1964-04-30	1964-04-30 00:00:00	1964-04-30	581452		0	0	0		0	0	0	255383	0	10	40213160		
30024	654	40213260	2013-02-22	2013-02-22 00:00:00	2013-02-22	2013-02-22 00:00:00	2013-02-22	581452		0	0	0		0	0	0	43291	0	121	40213260		
59763	4970	19059056	1934-10-17	1934-10-17 00:00:00	1934-11-21	1934-11-21 00:00:00	1934-11-21	38000177		0	0	35		0	0	0	330394	0	243670	19059056		
39861	3296	40231925	2016-02-24	2016-02-24 00:00:00	2016-02-24	2016-02-24 00:00:00	\N	38000177		0	0	0		0	0	0	219096	0	1049221	40231925		
14841	1242	1713671	1977-12-06	1977-12-06 00:00:00	1977-12-27	1977-12-27 00:00:00	1977-12-27	38000177		0	0	21		0	0	0	81822	0	562251	1713671		
14856	1245	19006318	1949-02-18	1949-02-18 00:00:00	1949-03-11	1949-03-11 00:00:00	1949-03-11	38000177		0	0	21		0	0	0	81935	0	105078	19006318		
51373	1125	40213227	1992-10-02	1992-10-02 00:00:00	1992-10-02	1992-10-02 00:00:00	1992-10-02	581452		0	0	0		0	0	0	74146	0	113	40213227		
29389	2433	40231925	1986-02-27	1986-02-27 00:00:00	1986-02-27	1986-02-27 00:00:00	\N	38000177		0	0	0		0	0	0	161346	0	1049221	40231925		
2288	185	1127433	2015-02-21	2015-02-21 00:00:00	2015-03-28	2015-03-28 00:00:00	2015-03-28	38000177		0	0	35		0	0	0	12522	0	313782	1127433		
30004	2486	19128065	1988-03-18	1988-03-18 00:00:00	1989-03-13	1989-03-13 00:00:00	1989-03-13	38000177		0	0	360		0	0	0	164743	0	749882	19128065		
133653	2935	40213251	1984-04-04	1984-04-04 00:00:00	1984-04-04	1984-04-04 00:00:00	1984-04-04	581452		0	0	0		0	0	0	195734	0	21	40213251		
37224	3077	19133905	1987-07-03	1987-07-03 00:00:00	1987-07-15	1987-07-15 00:00:00	1987-07-15	38000177		0	0	12		0	0	0	204782	0	834102	19133905		
48825	4049	1127433	1990-10-27	1990-10-27 00:00:00	1990-11-03	1990-11-03 00:00:00	1990-11-03	38000177		0	0	7		0	0	0	269163	0	313782	1127433		
6517	549	40236824	1986-08-31	1986-08-31 00:00:00	1986-09-14	1986-09-14 00:00:00	1986-09-14	38000177		0	0	14		0	0	0	36358	0	1094107	40236824		
19416	422	40213160	1959-04-18	1959-04-18 00:00:00	1959-04-18	1959-04-18 00:00:00	1959-04-18	581452		0	0	0		0	0	0	27943	0	10	40213160		
52896	4395	19059056	1963-03-17	1963-03-17 00:00:00	1963-04-16	1963-04-16 00:00:00	1963-04-16	38000177		0	0	30		0	0	0	292238	0	243670	19059056		
59451	4942	40171902	2004-04-29	2004-04-29 00:00:00	2004-04-29	2004-04-29 00:00:00	\N	38000177		0	0	0		0	0	0	328521	0	897718	40171902		
13234	1110	40232448	1983-04-24	1983-04-24 00:00:00	1983-04-24	1983-04-24 00:00:00	\N	38000177		0	0	0		0	0	0	73088	0	1049630	40232448		
58416	4852	1127433	1956-12-28	1956-12-28 00:00:00	1957-01-11	1957-01-11 00:00:00	1957-01-11	38000177		0	0	14		0	0	0	322848	0	313782	1127433		
23825	1960	40236824	1951-08-14	1951-08-14 00:00:00	1951-08-21	1951-08-21 00:00:00	1951-08-21	38000177		0	0	7		0	0	0	130322	0	1094107	40236824		
42257	921	40213160	1966-09-27	1966-09-27 00:00:00	1966-09-27	1966-09-27 00:00:00	1966-09-27	581452		0	0	0		0	0	0	61356	0	10	40213160		
222056	4874	40213296	2010-09-25	2010-09-25 00:00:00	2010-09-25	2010-09-25 00:00:00	2010-09-25	581452		0	0	0		0	0	0	324180	0	52	40213296		
34679	2864	19059056	1949-08-02	1949-08-02 00:00:00	1949-10-31	1949-10-31 00:00:00	1949-10-31	38000177		0	0	90		0	0	0	190549	0	243670	19059056		
14966	1250	40236824	1984-04-23	1984-04-23 00:00:00	1984-04-30	1984-04-30 00:00:00	1984-04-30	38000177		0	0	7		0	0	0	82319	0	1094107	40236824		
12439	268	40213296	2007-04-24	2007-04-24 00:00:00	2007-04-24	2007-04-24 00:00:00	2007-04-24	581452		0	0	0		0	0	0	17829	0	52	40213296		
50170	1099	40213227	1994-04-23	1994-04-23 00:00:00	1994-04-23	1994-04-23 00:00:00	1994-04-23	581452		0	0	0		0	0	0	72150	0	113	40213227		
68205	1493	40213160	1961-09-19	1961-09-19 00:00:00	1961-09-19	1961-09-19 00:00:00	1961-09-19	581452		0	0	0		0	0	0	99530	0	10	40213160		
20623	1699	19133873	1969-10-18	1969-10-18 00:00:00	1969-10-29	1969-10-29 00:00:00	1969-10-29	38000177		0	0	11		0	0	0	113628	0	834061	19133873		
32798	2715	1127433	1990-09-30	1990-09-30 00:00:00	1990-12-29	1990-12-29 00:00:00	1990-12-29	38000177		0	0	90		0	0	0	179970	0	313782	1127433		
54305	1188	40213296	2017-02-11	2017-02-11 00:00:00	2017-02-11	2017-02-11 00:00:00	2017-02-11	581452		0	0	0		0	0	0	78302	0	52	40213296		
5952	498	1127433	2007-05-16	2007-05-16 00:00:00	2007-06-06	2007-06-06 00:00:00	2007-06-06	38000177		0	0	21		0	0	0	33247	0	313782	1127433		
53107	4412	1713671	1995-07-02	1995-07-02 00:00:00	1995-07-23	1995-07-23 00:00:00	1995-07-23	38000177		0	0	21		0	0	0	293373	0	562251	1713671		
31291	2594	1127433	2002-04-25	2002-04-25 00:00:00	2002-05-09	2002-05-09 00:00:00	2002-05-09	38000177		0	0	14		0	0	0	171682	0	313782	1127433		
13745	1148	19059056	1976-05-18	1976-05-18 00:00:00	1976-06-01	1976-06-01 00:00:00	1976-06-01	38000177		0	0	14		0	0	0	75932	0	243670	19059056		
11279	939	19078461	1981-03-29	1981-03-29 00:00:00	1981-04-19	1981-04-19 00:00:00	1981-04-19	38000177		0	0	21		0	0	0	62480	0	310965	19078461		
2343	188	19006318	1968-08-18	1968-08-18 00:00:00	1968-09-01	1968-09-01 00:00:00	1968-09-01	38000177		0	0	14		0	0	0	12829	0	105078	19006318		
40783	3381	46233988	1973-12-07	1973-12-07 00:00:00	1973-12-21	1973-12-21 00:00:00	1973-12-21	38000177		0	0	14		0	0	0	224390	0	1652673	46233988		
24377	2005	19133905	2003-12-04	2003-12-04 00:00:00	2003-12-12	2003-12-12 00:00:00	2003-12-12	38000177		0	0	8		0	0	0	133525	0	834102	19133905		
52334	4353	1127433	1992-01-30	1992-01-30 00:00:00	1992-03-30	1992-03-30 00:00:00	1992-03-30	38000177		0	0	60		0	0	0	288788	0	313782	1127433		
18474	1529	19133873	1968-05-03	1968-05-03 00:00:00	1968-05-12	1968-05-12 00:00:00	1968-05-12	38000177		0	0	9		0	0	0	102360	0	834061	19133873		
48749	4040	1713671	2015-03-12	2015-03-12 00:00:00	2015-03-26	2015-03-26 00:00:00	2015-03-26	38000177		0	0	14		0	0	0	268704	0	562251	1713671		
63086	5241	1127078	1969-04-19	1969-04-19 00:00:00	1969-05-19	1969-05-19 00:00:00	1969-05-19	38000177		0	0	30		0	0	0	348786	0	282464	1127078		
1930	154	1713671	1977-09-11	1977-09-11 00:00:00	1977-10-02	1977-10-02 00:00:00	1977-10-02	38000177		0	0	21		0	0	0	10432	0	562251	1713671		
32164	701	40213227	1992-02-22	1992-02-22 00:00:00	1992-02-22	1992-02-22 00:00:00	1992-02-22	581452		0	0	0		0	0	0	46295	0	113	40213227		
2962	239	1127433	1963-10-21	1963-10-21 00:00:00	1963-11-04	1963-11-04 00:00:00	1963-11-04	38000177		0	0	14		0	0	0	16020	0	313782	1127433		
24968	2053	19006318	1953-09-30	1953-09-30 00:00:00	1953-10-14	1953-10-14 00:00:00	1953-10-14	38000177		0	0	14		0	0	0	136524	0	105078	19006318		
125527	2761	40213251	1984-04-23	1984-04-23 00:00:00	1984-04-23	1984-04-23 00:00:00	1984-04-23	581452		0	0	0		0	0	0	182661	0	21	40213251		
43630	951	40213160	1955-12-07	1955-12-07 00:00:00	1955-12-07	1955-12-07 00:00:00	1955-12-07	581452		0	0	0		0	0	0	63199	0	10	40213160		
235274	5168	40213160	1976-02-06	1976-02-06 00:00:00	1976-02-06	1976-02-06 00:00:00	1976-02-06	581452		0	0	0		0	0	0	343631	0	10	40213160		
8418	703	1127433	1992-06-19	1992-06-19 00:00:00	1992-07-03	1992-07-03 00:00:00	1992-07-03	38000177		0	0	14		0	0	0	46437	0	313782	1127433		
12701	1070	1118084	2009-09-14	2009-09-14 00:00:00	2009-09-14	2009-09-14 00:00:00	\N	38000177		0	0	0		0	0	0	70091	0	00025152531	44923712		
18987	1569	19059056	1937-11-28	1937-11-28 00:00:00	1937-12-12	1937-12-12 00:00:00	1937-12-12	38000177		0	0	14		0	0	0	105305	0	243670	19059056		
5975	129	40213160	1975-06-16	1975-06-16 00:00:00	1975-06-16	1975-06-16 00:00:00	1975-06-16	581452		0	0	0		0	0	0	8685	0	10	40213160		
30777	2550	920300	2018-03-13	2018-03-13 00:00:00	2018-03-20	2018-03-20 00:00:00	2018-03-20	38000177		0	0	7		0	0	0	168808	0	311989	920300		
52628	4375	40171902	2006-06-25	2006-06-25 00:00:00	2006-06-25	2006-06-25 00:00:00	\N	38000177		0	0	0		0	0	0	290646	0	897718	40171902		
44372	3672	19078461	1976-01-09	1976-01-09 00:00:00	1976-02-08	1976-02-08 00:00:00	1976-02-08	38000177		0	0	30		0	0	0	244326	0	310965	19078461		
60604	5041	19128065	1987-11-05	1987-11-05 00:00:00	1988-10-30	1988-10-30 00:00:00	1988-10-30	38000177		0	0	360		0	0	0	334945	0	749882	19128065		
207889	4561	40213160	1955-02-09	1955-02-09 00:00:00	1955-02-09	1955-02-09 00:00:00	1955-02-09	581452		0	0	0		0	0	0	303946	0	10	40213160		
41497	3439	1713671	1977-02-28	1977-02-28 00:00:00	1977-03-14	1977-03-14 00:00:00	1977-03-14	38000177		0	0	14		0	0	0	228216	0	562251	1713671		
12101	1015	19078461	2003-07-25	2003-07-25 00:00:00	2003-08-08	2003-08-08 00:00:00	2003-08-08	38000177		0	0	14		0	0	0	66816	0	310965	19078461		
55084	4574	19059056	1968-04-03	1968-04-03 00:00:00	1968-04-17	1968-04-17 00:00:00	1968-04-17	38000177		0	0	14		0	0	0	304698	0	243670	19059056		
63936	1399	40213160	1961-03-08	1961-03-08 00:00:00	1961-03-08	1961-03-08 00:00:00	1961-03-08	581452		0	0	0		0	0	0	93073	0	10	40213160		
18819	408	40213227	2002-07-03	2002-07-03 00:00:00	2002-07-03	2002-07-03 00:00:00	2002-07-03	581452		0	0	0		0	0	0	26984	0	113	40213227		
146061	3212	40213160	1982-01-05	1982-01-05 00:00:00	1982-01-05	1982-01-05 00:00:00	1982-01-05	581452		0	0	0		0	0	0	213406	0	10	40213160		
6425	539	1713671	1976-11-12	1976-11-12 00:00:00	1976-11-19	1976-11-19 00:00:00	1976-11-19	38000177		0	0	7		0	0	0	35814	0	562251	1713671		
30027	654	40213227	2013-02-22	2013-02-22 00:00:00	2013-02-22	2013-02-22 00:00:00	2013-02-22	581452		0	0	0		0	0	0	43291	0	113	40213227		
59764	4970	19059056	1987-01-17	1987-01-17 00:00:00	1987-02-21	1987-02-21 00:00:00	1987-02-21	38000177		0	0	35		0	0	0	330396	0	243670	19059056		
39862	3296	19078461	2016-02-24	2016-02-24 00:00:00	2016-05-24	2016-05-24 00:00:00	2016-05-24	38000177		0	0	90		0	0	0	219096	0	310965	19078461		
14842	1242	19078461	2014-07-02	2014-07-02 00:00:00	2014-07-23	2014-07-23 00:00:00	2014-07-23	38000177		0	0	21		0	0	0	81770	0	310965	19078461		
14857	1245	19059056	1949-02-18	1949-02-18 00:00:00	1949-03-11	1949-03-11 00:00:00	1949-03-11	38000177		0	0	21		0	0	0	81935	0	243670	19059056		
41512	905	40213296	2008-09-27	2008-09-27 00:00:00	2008-09-27	2008-09-27 00:00:00	2008-09-27	581452		0	0	0		0	0	0	60186	0	52	40213296		
29390	2433	1127433	1986-02-27	1986-02-27 00:00:00	1986-05-28	1986-05-28 00:00:00	1986-05-28	38000177		0	0	90		0	0	0	161346	0	313782	1127433		
2289	185	19075601	1997-02-23	1997-02-23 00:00:00	1997-02-23	1997-02-23 00:00:00	\N	38000177		0	0	0		0	0	0	12548	0	309362	19075601		
30005	2486	19128022	1989-03-13	1989-03-13 00:00:00	1990-03-08	1990-03-08 00:00:00	1990-03-08	38000177		0	0	360		0	0	0	164744	0	749785	19128022		
133660	2935	40213227	2010-02-17	2010-02-17 00:00:00	2010-02-17	2010-02-17 00:00:00	2010-02-17	581452		0	0	0		0	0	0	195706	0	113	40213227		
37225	3077	19059056	1972-03-10	1972-03-10 00:00:00	1972-03-31	1972-03-31 00:00:00	1972-03-31	38000177		0	0	21		0	0	0	204719	0	243670	19059056		
48826	4049	1127433	1974-08-08	1974-08-08 00:00:00	1974-08-22	1974-08-22 00:00:00	1974-08-22	38000177		0	0	14		0	0	0	269136	0	313782	1127433		
6518	549	920300	1986-08-31	1986-08-31 00:00:00	1986-09-07	1986-09-07 00:00:00	1986-09-07	38000177		0	0	7		0	0	0	36358	0	311989	920300		
19422	422	40213227	2010-07-17	2010-07-17 00:00:00	2010-07-17	2010-07-17 00:00:00	2010-07-17	581452		0	0	0		0	0	0	27906	0	113	40213227		
52898	4395	1127433	1981-08-09	1981-08-09 00:00:00	1981-09-13	1981-09-13 00:00:00	1981-09-13	38000177		0	0	35		0	0	0	292239	0	313782	1127433		
59452	4942	40163554	2004-04-29	2004-04-29 00:00:00	2004-04-29	2004-04-29 00:00:00	\N	38000177		0	0	0		0	0	0	328521	0	855332	40163554		
13235	1110	1713671	1988-10-08	1988-10-08 00:00:00	1988-10-22	1988-10-22 00:00:00	1988-10-22	38000177		0	0	14		0	0	0	73050	0	562251	1713671		
58418	4852	1127433	1995-01-24	1995-01-24 00:00:00	1995-02-07	1995-02-07 00:00:00	1995-02-07	38000177		0	0	14		0	0	0	322782	0	313782	1127433		
23826	1960	19059056	1973-08-17	1973-08-17 00:00:00	1973-09-21	1973-09-21 00:00:00	1973-09-21	38000177		0	0	35		0	0	0	130332	0	243670	19059056		
42262	921	40213160	1971-06-01	1971-06-01 00:00:00	1971-06-01	1971-06-01 00:00:00	1971-06-01	581452		0	0	0		0	0	0	61334	0	10	40213160		
222062	4874	40213306	1991-02-23	1991-02-23 00:00:00	1991-02-23	1991-02-23 00:00:00	1991-02-23	581452		0	0	0		0	0	0	324154	0	43	40213306		
34680	2864	1127433	2005-01-03	2005-01-03 00:00:00	2005-01-17	2005-01-17 00:00:00	2005-01-17	38000177		0	0	14		0	0	0	190514	0	313782	1127433		
14968	1250	1713671	1988-03-15	1988-03-15 00:00:00	1988-04-05	1988-04-05 00:00:00	1988-04-05	38000177		0	0	21		0	0	0	82373	0	562251	1713671		
12443	268	40213227	2018-02-27	2018-02-27 00:00:00	2018-02-27	2018-02-27 00:00:00	2018-02-27	581452		0	0	0		0	0	0	17831	0	113	40213227		
61609	5127	1127433	1989-06-28	1989-06-28 00:00:00	1989-07-05	1989-07-05 00:00:00	1989-07-05	38000177		0	0	7		0	0	0	340890	0	313782	1127433		
68208	1493	40213160	1957-03-05	1957-03-05 00:00:00	1957-03-05	1957-03-05 00:00:00	1957-03-05	581452		0	0	0		0	0	0	99539	0	10	40213160		
20625	1699	1115171	2011-03-27	2011-03-27 00:00:00	2011-04-10	2011-04-10 00:00:00	2011-04-10	38000177		0	0	14		0	0	0	113617	0	849574	1115171		
32799	2715	1551192	1974-01-31	1974-01-31 00:00:00	1974-01-31	1974-01-31 00:00:00	1974-01-31	38000177		0	0	0		0	0	0	179967	0	312617	1551192		
54307	1188	40213227	2017-02-11	2017-02-11 00:00:00	2017-02-11	2017-02-11 00:00:00	2017-02-11	581452		0	0	0		0	0	0	78302	0	113	40213227		
5953	498	1118084	2010-06-09	2010-06-09 00:00:00	2010-06-09	2010-06-09 00:00:00	\N	38000177		0	0	0		0	0	0	33268	0	00025152531	44923712		
53108	4412	1127433	2000-09-14	2000-09-14 00:00:00	2000-11-20	2000-11-20 00:00:00	2000-11-20	38000177		0	0	67		0	0	0	293285	0	313782	1127433		
31292	2594	19133873	1983-07-30	1983-07-30 00:00:00	1983-08-08	1983-08-08 00:00:00	1983-08-08	38000177		0	0	9		0	0	0	171681	0	834061	19133873		
13746	1148	1127078	1958-09-15	1958-09-15 00:00:00	1958-09-29	1958-09-29 00:00:00	1958-09-29	38000177		0	0	14		0	0	0	75875	0	282464	1127078		
11280	939	1118084	2005-03-26	2005-03-26 00:00:00	2005-03-26	2005-03-26 00:00:00	\N	38000177		0	0	0		0	0	0	62468	0	00025152531	44923712		
2344	188	19133873	1967-10-25	1967-10-25 00:00:00	1967-11-07	1967-11-07 00:00:00	1967-11-07	38000177		0	0	13		0	0	0	12824	0	834061	19133873		
40784	3381	1127433	2007-01-15	2007-01-15 00:00:00	2007-02-19	2007-02-19 00:00:00	2007-02-19	38000177		0	0	35		0	0	0	224398	0	313782	1127433		
24378	2005	40229134	2013-05-02	2013-05-02 00:00:00	2013-05-09	2013-05-09 00:00:00	2013-05-09	38000177		0	0	7		0	0	0	133511	0	1043400	40229134		
52335	4353	19133873	1968-05-31	1968-05-31 00:00:00	1968-06-11	1968-06-11 00:00:00	1968-06-11	38000177		0	0	11		0	0	0	288728	0	834061	19133873		
18475	1529	1127433	1996-12-19	1996-12-19 00:00:00	1997-01-02	1997-01-02 00:00:00	1997-01-02	38000177		0	0	14		0	0	0	102303	0	313782	1127433		
48750	4040	1118084	2013-01-20	2013-01-20 00:00:00	2013-01-20	2013-01-20 00:00:00	\N	38000177		0	0	0		0	0	0	268710	0	00025152531	44923712		
63087	5241	19128065	1983-02-15	1983-02-15 00:00:00	1984-02-10	1984-02-10 00:00:00	1984-02-10	38000177		0	0	360		0	0	0	348723	0	749882	19128065		
1931	154	19019979	1979-05-29	1979-05-29 00:00:00	1979-07-03	1979-07-03 00:00:00	1979-07-03	38000177		0	0	35		0	0	0	10471	0	198405	19019979		
32167	701	40213296	1997-09-06	1997-09-06 00:00:00	1997-09-06	1997-09-06 00:00:00	1997-09-06	581452		0	0	0		0	0	0	46359	0	52	40213296		
2963	239	1127433	1964-01-20	1964-01-20 00:00:00	1964-02-03	1964-02-03 00:00:00	1964-02-03	38000177		0	0	14		0	0	0	16057	0	313782	1127433		
24969	2053	1127078	1953-09-30	1953-09-30 00:00:00	1953-10-14	1953-10-14 00:00:00	1953-10-14	38000177		0	0	14		0	0	0	136524	0	282464	1127078		
125531	2761	40213314	1981-07-27	1981-07-27 00:00:00	1981-07-27	1981-07-27 00:00:00	1981-07-27	581452		0	0	0		0	0	0	182641	0	49	40213314		
43634	951	40213160	1956-12-12	1956-12-12 00:00:00	1956-12-12	1956-12-12 00:00:00	1956-12-12	581452		0	0	0		0	0	0	63158	0	10	40213160		
235277	5168	40213306	1993-10-15	1993-10-15 00:00:00	1993-10-15	1993-10-15 00:00:00	1993-10-15	581452		0	0	0		0	0	0	343645	0	43	40213306		
8419	703	1713671	1980-01-21	1980-01-21 00:00:00	1980-01-28	1980-01-28 00:00:00	1980-01-28	38000177		0	0	7		0	0	0	46475	0	562251	1713671		
12702	1070	1127433	2017-06-26	2017-06-26 00:00:00	2017-07-03	2017-07-03 00:00:00	2017-07-03	38000177		0	0	7		0	0	0	70049	0	313782	1127433		
18988	1569	1127433	2005-02-12	2005-02-12 00:00:00	2005-02-26	2005-02-26 00:00:00	2005-02-26	38000177		0	0	14		0	0	0	105259	0	313782	1127433		
5976	129	40213160	1975-03-17	1975-03-17 00:00:00	1975-03-17	1975-03-17 00:00:00	1975-03-17	581452		0	0	0		0	0	0	8677	0	10	40213160		
30778	2550	40236824	2018-03-13	2018-03-13 00:00:00	2018-03-20	2018-03-20 00:00:00	2018-03-20	38000177		0	0	7		0	0	0	168808	0	1094107	40236824		
52629	4375	1127433	1952-06-13	1952-06-13 00:00:00	1952-06-20	1952-06-20 00:00:00	1952-06-20	38000177		0	0	7		0	0	0	290603	0	313782	1127433		
44388	3675	1127433	2018-02-28	2018-02-28 00:00:00	2018-03-07	2018-03-07 00:00:00	2018-03-07	38000177		0	0	7		0	0	0	244415	0	313782	1127433		
60605	5041	19128065	1988-10-30	1988-10-30 00:00:00	1989-10-25	1989-10-25 00:00:00	1989-10-25	38000177		0	0	360		0	0	0	334946	0	749882	19128065		
207903	4561	40213227	1992-04-22	1992-04-22 00:00:00	1992-04-22	1992-04-22 00:00:00	1992-04-22	581452		0	0	0		0	0	0	303931	0	113	40213227		
41498	3439	1118084	1995-05-06	1995-05-06 00:00:00	1995-05-06	1995-05-06 00:00:00	\N	38000177		0	0	0		0	0	0	228153	0	00025152531	44923712		
12102	1015	1127433	2012-10-31	2012-10-31 00:00:00	2012-11-07	2012-11-07 00:00:00	2012-11-07	38000177		0	0	7		0	0	0	66795	0	313782	1127433		
55085	4574	40229134	1990-02-06	1990-02-06 00:00:00	1990-02-13	1990-02-13 00:00:00	1990-02-13	38000177		0	0	7		0	0	0	304739	0	1043400	40229134		
63950	1399	40213160	1960-10-05	1960-10-05 00:00:00	1960-10-05	1960-10-05 00:00:00	1960-10-05	581452		0	0	0		0	0	0	93072	0	10	40213160		
89391	1960	40213227	2001-11-06	2001-11-06 00:00:00	2001-11-06	2001-11-06 00:00:00	2001-11-06	581452		0	0	0		0	0	0	130418	0	113	40213227		
157368	3464	40213251	1984-04-18	1984-04-18 00:00:00	1984-04-18	1984-04-18 00:00:00	1984-04-18	581452		0	0	0		0	0	0	229983	0	21	40213251		
6426	539	19059056	1934-06-30	1934-06-30 00:00:00	1934-07-14	1934-07-14 00:00:00	1934-07-14	38000177		0	0	14		0	0	0	35789	0	243670	19059056		
30039	654	40213160	1962-10-26	1962-10-26 00:00:00	1962-10-26	1962-10-26 00:00:00	1962-10-26	581452		0	0	0		0	0	0	43332	0	10	40213160		
59765	4970	836659	1995-11-29	1995-11-29 00:00:00	1995-11-29	1995-11-29 00:00:00	\N	38000177		0	0	0		0	0	0	330355	0	313185	836659		
39863	3296	19059056	1963-09-04	1963-09-04 00:00:00	1963-10-02	1963-10-02 00:00:00	1963-10-02	38000177		0	0	28		0	0	0	219092	0	243670	19059056		
14843	1242	1713671	1996-02-28	1996-02-28 00:00:00	1996-03-06	1996-03-06 00:00:00	1996-03-06	38000177		0	0	7		0	0	0	81757	0	562251	1713671		
14858	1245	19059056	1959-02-17	1959-02-17 00:00:00	1959-05-18	1959-05-18 00:00:00	1959-05-18	38000177		0	0	90		0	0	0	81899	0	243670	19059056		
41523	905	40213160	1969-05-31	1969-05-31 00:00:00	1969-05-31	1969-05-31 00:00:00	1969-05-31	581452		0	0	0		0	0	0	60175	0	10	40213160		
29391	2433	1118084	1992-01-27	1992-01-27 00:00:00	1992-01-27	1992-01-27 00:00:00	\N	38000177		0	0	0		0	0	0	161322	0	00025152531	44923712		
2290	185	1118084	1986-01-22	1986-01-22 00:00:00	1986-01-22	1986-01-22 00:00:00	\N	38000177		0	0	0		0	0	0	12536	0	00025152531	44923712		
30006	2486	40229134	1978-09-29	1978-09-29 00:00:00	1978-10-06	1978-10-06 00:00:00	1978-10-06	38000177		0	0	7		0	0	0	164738	0	1043400	40229134		
133661	2935	40213314	1977-06-15	1977-06-15 00:00:00	1977-06-15	1977-06-15 00:00:00	1977-06-15	581452		0	0	0		0	0	0	195707	0	49	40213314		
37226	3077	1127433	1975-03-16	1975-03-16 00:00:00	1975-03-30	1975-03-30 00:00:00	1975-03-30	38000177		0	0	14		0	0	0	204720	0	313782	1127433		
48827	4049	19059056	1961-07-03	1961-07-03 00:00:00	1961-07-17	1961-07-17 00:00:00	1961-07-17	38000177		0	0	14		0	0	0	269132	0	243670	19059056		
6519	549	19078461	2011-04-18	2011-04-18 00:00:00	2011-05-09	2011-05-09 00:00:00	2011-05-09	38000177		0	0	21		0	0	0	36424	0	310965	19078461		
19425	422	40213160	1963-12-21	1963-12-21 00:00:00	1963-12-21	1963-12-21 00:00:00	1963-12-21	581452		0	0	0		0	0	0	27919	0	10	40213160		
52899	4395	19059056	1960-11-27	1960-11-27 00:00:00	1961-02-25	1961-02-25 00:00:00	1961-02-25	38000177		0	0	90		0	0	0	292237	0	243670	19059056		
59453	4942	19059056	1985-09-09	1985-09-09 00:00:00	1985-09-30	1985-09-30 00:00:00	1985-09-30	38000177		0	0	21		0	0	0	328465	0	243670	19059056		
13236	1110	1127433	2009-08-20	2009-08-20 00:00:00	2009-09-03	2009-09-03 00:00:00	2009-09-03	38000177		0	0	14		0	0	0	73083	0	313782	1127433		
58419	4852	40231925	1967-03-26	1967-03-26 00:00:00	1967-03-26	1967-03-26 00:00:00	\N	38000177		0	0	0		0	0	0	322779	0	1049221	40231925		
101828	2232	40213160	1968-04-19	1968-04-19 00:00:00	1968-04-19	1968-04-19 00:00:00	1968-04-19	581452		0	0	0		0	0	0	148501	0	10	40213160		
42264	921	40213296	2006-06-27	2006-06-27 00:00:00	2006-06-27	2006-06-27 00:00:00	2006-06-27	581452		0	0	0		0	0	0	61355	0	52	40213296		
222064	4874	40213160	1972-09-30	1972-09-30 00:00:00	1972-09-30	1972-09-30 00:00:00	1972-09-30	581452		0	0	0		0	0	0	\N	0	10	40213160		
195711	4299	40213227	1995-06-25	1995-06-25 00:00:00	1995-06-25	1995-06-25 00:00:00	1995-06-25	581452		0	0	0		0	0	0	285251	0	113	40213227		
14969	1250	1127433	1987-05-13	1987-05-13 00:00:00	1987-06-17	1987-06-17 00:00:00	1987-06-17	38000177		0	0	35		0	0	0	82336	0	313782	1127433		
12446	268	40213260	2018-02-27	2018-02-27 00:00:00	2018-02-27	2018-02-27 00:00:00	2018-02-27	581452		0	0	0		0	0	0	17831	0	121	40213260		
61610	5127	1124300	2009-11-13	2009-11-13 00:00:00	2009-11-13	2009-11-13 00:00:00	\N	38000177		0	0	0		0	0	0	340864	0	00781178901	45011828		
68210	1493	40213260	2007-04-24	2007-04-24 00:00:00	2007-04-24	2007-04-24 00:00:00	2007-04-24	581452		0	0	0		0	0	0	99522	0	121	40213260		
20626	1699	1127433	1995-02-06	1995-02-06 00:00:00	1995-02-20	1995-02-20 00:00:00	1995-02-20	38000177		0	0	14		0	0	0	113649	0	313782	1127433		
32800	2715	1127078	1966-11-09	1966-11-09 00:00:00	1966-11-23	1966-11-23 00:00:00	1966-11-23	38000177		0	0	14		0	0	0	180038	0	282464	1127078		
54310	1189	40213160	1964-05-11	1964-05-11 00:00:00	1964-05-11	1964-05-11 00:00:00	1964-05-11	581452		0	0	0		0	0	0	78328	0	10	40213160		
5954	498	40229134	1972-04-16	1972-04-16 00:00:00	1972-04-30	1972-04-30 00:00:00	1972-04-30	38000177		0	0	14		0	0	0	33290	0	1043400	40229134		
53109	4412	19059056	1969-07-20	1969-07-20 00:00:00	1969-08-03	1969-08-03 00:00:00	1969-08-03	38000177		0	0	14		0	0	0	293390	0	243670	19059056		
31293	2594	46233988	1975-07-26	1975-07-26 00:00:00	1975-08-09	1975-08-09 00:00:00	1975-08-09	38000177		0	0	14		0	0	0	171716	0	1652673	46233988		
13747	1148	19006318	1958-09-15	1958-09-15 00:00:00	1958-09-29	1958-09-29 00:00:00	1958-09-29	38000177		0	0	14		0	0	0	75875	0	105078	19006318		
11281	939	19059056	1976-01-27	1976-01-27 00:00:00	1976-02-24	1976-02-24 00:00:00	1976-02-24	38000177		0	0	28		0	0	0	62479	0	243670	19059056		
2345	188	1127433	2012-04-08	2012-04-08 00:00:00	2012-04-22	2012-04-22 00:00:00	2012-04-22	38000177		0	0	14		0	0	0	12828	0	313782	1127433		
40785	3381	19133873	1972-03-09	1972-03-09 00:00:00	1972-03-17	1972-03-17 00:00:00	1972-03-17	38000177		0	0	8		0	0	0	224381	0	834061	19133873		
24379	2005	46233988	1977-10-12	1977-10-12 00:00:00	1977-10-26	1977-10-26 00:00:00	1977-10-26	38000177		0	0	14		0	0	0	133483	0	1652673	46233988		
52336	4353	19128065	1988-06-22	1988-06-22 00:00:00	1989-06-17	1989-06-17 00:00:00	1989-06-17	38000177		0	0	360		0	0	0	288816	0	749882	19128065		
18476	1529	1127433	1979-02-05	1979-02-05 00:00:00	1979-02-19	1979-02-19 00:00:00	1979-02-19	38000177		0	0	14		0	0	0	102363	0	313782	1127433		
48751	4040	1127433	2017-03-02	2017-03-02 00:00:00	2017-03-09	2017-03-09 00:00:00	2017-03-09	38000177		0	0	7		0	0	0	268673	0	313782	1127433		
63088	5241	19133873	1972-01-06	1972-01-06 00:00:00	1972-01-14	1972-01-14 00:00:00	1972-01-14	38000177		0	0	8		0	0	0	348752	0	834061	19133873		
1932	154	1127433	1985-03-29	1985-03-29 00:00:00	1985-04-05	1985-04-05 00:00:00	1985-04-05	38000177		0	0	7		0	0	0	10495	0	313782	1127433		
32169	701	40213160	1962-08-11	1962-08-11 00:00:00	1962-08-11	1962-08-11 00:00:00	1962-08-11	581452		0	0	0		0	0	0	46334	0	10	40213160		
2964	239	40231925	2012-03-01	2012-03-01 00:00:00	2012-03-01	2012-03-01 00:00:00	\N	38000177		0	0	0		0	0	0	16053	0	1049221	40231925		
24970	2053	19133873	1955-07-25	1955-07-25 00:00:00	1955-08-02	1955-08-02 00:00:00	1955-08-02	38000177		0	0	8		0	0	0	136508	0	834061	19133873		
20907	1724	1127433	1950-05-12	1950-05-12 00:00:00	1950-05-19	1950-05-19 00:00:00	1950-05-19	38000177		0	0	7		0	0	0	115239	0	313782	1127433		
35419	2919	19126352	2017-12-16	2017-12-16 00:00:00	2017-12-16	2017-12-16 00:00:00	\N	38000177		0	0	0		0	0	0	194622	0	705129	19126352		
235279	5168	40213227	1993-10-15	1993-10-15 00:00:00	1993-10-15	1993-10-15 00:00:00	1993-10-15	581452		0	0	0		0	0	0	343645	0	113	40213227		
8420	703	19018935	2006-01-27	2006-01-27 00:00:00	2006-01-27	2006-01-27 00:00:00	\N	38000177		0	0	0		0	0	0	46430	0	197604	19018935		
12703	1070	1127433	1982-06-05	1982-06-05 00:00:00	1982-06-19	1982-06-19 00:00:00	1982-06-19	38000177		0	0	14		0	0	0	70074	0	313782	1127433		
18989	1569	40165015	1987-04-13	1987-04-13 00:00:00	1987-04-13	1987-04-13 00:00:00	\N	38000177		0	0	0		0	0	0	105233	0	861467	40165015		
5977	129	40213314	1978-03-13	1978-03-13 00:00:00	1978-03-13	1978-03-13 00:00:00	1978-03-13	581452		0	0	0		0	0	0	8680	0	49	40213314		
30779	2550	19128065	1999-12-28	1999-12-28 00:00:00	2000-12-22	2000-12-22 00:00:00	2000-12-22	38000177		0	0	360		0	0	0	168795	0	749882	19128065		
52630	4375	40229134	1976-10-27	1976-10-27 00:00:00	1976-11-10	1976-11-10 00:00:00	1976-11-10	38000177		0	0	14		0	0	0	290639	0	1043400	40229134		
44389	3675	19059056	1990-08-14	1990-08-14 00:00:00	1990-09-04	1990-09-04 00:00:00	1990-09-04	38000177		0	0	21		0	0	0	244484	0	243670	19059056		
26516	578	40213160	1968-02-07	1968-02-07 00:00:00	1968-02-07	1968-02-07 00:00:00	1968-02-07	581452		0	0	0		0	0	0	38247	0	10	40213160		
207906	4561	40213198	2015-07-08	2015-07-08 00:00:00	2015-07-08	2015-07-08 00:00:00	2015-07-08	581452		0	0	0		0	0	0	303936	0	133	40213198		
41499	3439	19059056	1955-09-08	1955-09-08 00:00:00	1955-10-06	1955-10-06 00:00:00	1955-10-06	38000177		0	0	28		0	0	0	228137	0	243670	19059056		
12103	1015	19059056	1983-02-05	1983-02-05 00:00:00	1983-03-12	1983-03-12 00:00:00	1983-03-12	38000177		0	0	35		0	0	0	66814	0	243670	19059056		
55086	4574	19078461	1985-10-15	1985-10-15 00:00:00	1985-10-29	1985-10-29 00:00:00	1985-10-29	38000177		0	0	14		0	0	0	304712	0	310965	19078461		
63953	1399	40213160	1965-04-28	1965-04-28 00:00:00	1965-04-28	1965-04-28 00:00:00	1965-04-28	581452		0	0	0		0	0	0	93004	0	10	40213160		
89397	1960	40213201	1996-10-08	1996-10-08 00:00:00	1996-10-08	1996-10-08 00:00:00	1996-10-08	581452		0	0	0		0	0	0	130392	0	33	40213201		
157371	3464	40213227	2011-12-21	2011-12-21 00:00:00	2011-12-21	2011-12-21 00:00:00	2011-12-21	581452		0	0	0		0	0	0	229932	0	113	40213227		
6427	539	1713671	1990-12-19	1990-12-19 00:00:00	1991-01-02	1991-01-02 00:00:00	1991-01-02	38000177		0	0	14		0	0	0	35817	0	562251	1713671		
30041	654	40213296	2004-02-27	2004-02-27 00:00:00	2004-02-27	2004-02-27 00:00:00	2004-02-27	581452		0	0	0		0	0	0	43345	0	52	40213296		
59766	4970	1713671	1926-05-27	1926-05-27 00:00:00	1926-06-03	1926-06-03 00:00:00	1926-06-03	38000177		0	0	7		0	0	0	330490	0	562251	1713671		
39864	3296	1127433	2019-02-08	2019-02-08 00:00:00	2019-04-09	2019-04-09 00:00:00	2019-04-09	38000177		0	0	60		0	0	0	219097	0	313782	1127433		
14844	1242	19059056	1969-10-14	1969-10-14 00:00:00	1969-11-11	1969-11-11 00:00:00	1969-11-11	38000177		0	0	28		0	0	0	81768	0	243670	19059056		
14859	1245	1127433	1970-06-04	1970-06-04 00:00:00	1970-06-18	1970-06-18 00:00:00	1970-06-18	38000177		0	0	14		0	0	0	81982	0	313782	1127433		
41524	905	40213160	1968-12-28	1968-12-28 00:00:00	1968-12-28	1968-12-28 00:00:00	1968-12-28	581452		0	0	0		0	0	0	60174	0	10	40213160		
29392	2433	19133873	1961-01-30	1961-01-30 00:00:00	1961-02-07	1961-02-07 00:00:00	1961-02-07	38000177		0	0	8		0	0	0	161280	0	834061	19133873		
2291	185	1127433	2018-05-23	2018-05-23 00:00:00	2018-05-30	2018-05-30 00:00:00	2018-05-30	38000177		0	0	7		0	0	0	12570	0	313782	1127433		
30007	2486	1115171	1996-12-21	1996-12-21 00:00:00	1997-02-19	1997-02-19 00:00:00	1997-02-19	38000177		0	0	60		0	0	0	164712	0	849574	1115171		
45284	987	40213260	2006-09-17	2006-09-17 00:00:00	2006-09-17	2006-09-17 00:00:00	2006-09-17	581452		0	0	0		0	0	0	65570	0	121	40213260		
37227	3077	19059056	1968-01-01	1968-01-01 00:00:00	1968-03-01	1968-03-01 00:00:00	1968-03-01	38000177		0	0	60		0	0	0	204718	0	243670	19059056		
48828	4049	19129655	1961-07-03	1961-07-03 00:00:00	1961-07-17	1961-07-17 00:00:00	1961-07-17	38000177		0	0	14		0	0	0	269132	0	789980	19129655		
6520	549	1127433	2014-08-31	2014-08-31 00:00:00	2014-09-14	2014-09-14 00:00:00	2014-09-14	38000177		0	0	14		0	0	0	36399	0	313782	1127433		
81866	1788	40213160	1962-01-25	1962-01-25 00:00:00	1962-01-25	1962-01-25 00:00:00	1962-01-25	581452		0	0	0		0	0	0	119817	0	10	40213160		
52900	4395	1713671	2010-12-31	2010-12-31 00:00:00	2011-02-11	2011-02-11 00:00:00	2011-02-11	38000177		0	0	42		0	0	0	292263	0	562251	1713671		
59454	4942	1118084	1986-12-07	1986-12-07 00:00:00	1986-12-07	1986-12-07 00:00:00	\N	38000177		0	0	0		0	0	0	328497	0	00025152531	44923712		
13237	1110	1551192	1983-04-09	1983-04-09 00:00:00	1983-04-09	1983-04-09 00:00:00	1983-04-09	38000177		0	0	0		0	0	0	73118	0	312617	1551192		
58420	4852	19059056	1967-03-26	1967-03-26 00:00:00	1967-05-26	1967-05-26 00:00:00	1967-05-26	38000177		0	0	61		0	0	0	322779	0	243670	19059056		
101831	2232	40213296	2003-05-16	2003-05-16 00:00:00	2003-05-16	2003-05-16 00:00:00	2003-05-16	581452		0	0	0		0	0	0	148477	0	52	40213296		
42273	921	40213227	2008-07-01	2008-07-01 00:00:00	2008-07-01	2008-07-01 00:00:00	2008-07-01	581452		0	0	0		0	0	0	61340	0	113	40213227		
222067	4874	40213227	2001-12-15	2001-12-15 00:00:00	2001-12-15	2001-12-15 00:00:00	2001-12-15	581452		0	0	0		0	0	0	324187	0	113	40213227		
6550	143	40213160	1969-10-12	1969-10-12 00:00:00	1969-10-12	1969-10-12 00:00:00	1969-10-12	581452		0	0	0		0	0	0	9555	0	10	40213160		
14970	1250	1127433	1970-10-03	1970-10-03 00:00:00	1970-10-17	1970-10-17 00:00:00	1970-10-17	38000177		0	0	14		0	0	0	82384	0	313782	1127433		
12453	268	40213227	2009-04-28	2009-04-28 00:00:00	2009-04-28	2009-04-28 00:00:00	2009-04-28	581452		0	0	0		0	0	0	17825	0	113	40213227		
61611	5127	1127433	1972-07-07	1972-07-07 00:00:00	1972-07-14	1972-07-14 00:00:00	1972-07-14	38000177		0	0	7		0	0	0	340865	0	313782	1127433		
68224	1493	40213160	1957-01-01	1957-01-01 00:00:00	1957-01-01	1957-01-01 00:00:00	1957-01-01	581452		0	0	0		0	0	0	99526	0	10	40213160		
25611	558	40213227	1994-11-17	1994-11-17 00:00:00	1994-11-17	1994-11-17 00:00:00	1994-11-17	581452		0	0	0		0	0	0	37022	0	113	40213227		
32801	2715	19006318	1966-11-09	1966-11-09 00:00:00	1966-11-23	1966-11-23 00:00:00	1966-11-23	38000177		0	0	14		0	0	0	180038	0	105078	19006318		
54315	1189	40213260	2014-08-11	2014-08-11 00:00:00	2014-08-11	2014-08-11 00:00:00	2014-08-11	581452		0	0	0		0	0	0	78372	0	121	40213260		
52139	4337	40229134	1977-02-07	1977-02-07 00:00:00	1977-02-21	1977-02-21 00:00:00	1977-02-21	38000177		0	0	14		0	0	0	287589	0	1043400	40229134		
53110	4412	46233988	1969-07-20	1969-07-20 00:00:00	1969-08-03	1969-08-03 00:00:00	1969-08-03	38000177		0	0	14		0	0	0	293390	0	1652673	46233988		
31294	2594	1127078	1975-07-26	1975-07-26 00:00:00	1975-08-09	1975-08-09 00:00:00	1975-08-09	38000177		0	0	14		0	0	0	171716	0	282464	1127078		
13748	1148	1127078	1965-12-07	1965-12-07 00:00:00	1966-01-11	1966-01-11 00:00:00	1966-01-11	38000177		0	0	35		0	0	0	75930	0	282464	1127078		
11282	939	40236446	1977-07-11	1977-07-11 00:00:00	1977-12-12	1977-12-12 00:00:00	1977-12-12	38000177		0	0	154		0	0	0	62462	0	1091392	40236446		
2346	188	40229134	1981-09-10	1981-09-10 00:00:00	1981-09-17	1981-09-17 00:00:00	1981-09-17	38000177		0	0	7		0	0	0	12786	0	1043400	40229134		
40786	3381	19133873	1982-01-25	1982-01-25 00:00:00	1982-02-05	1982-02-05 00:00:00	1982-02-05	38000177		0	0	11		0	0	0	224365	0	834061	19133873		
24380	2005	19059056	1977-10-12	1977-10-12 00:00:00	1977-10-26	1977-10-26 00:00:00	1977-10-26	38000177		0	0	14		0	0	0	133483	0	243670	19059056		
52337	4353	1713671	1978-12-07	1978-12-07 00:00:00	1978-12-28	1978-12-28 00:00:00	1978-12-28	38000177		0	0	21		0	0	0	288801	0	562251	1713671		
18477	1529	1124300	2000-07-12	2000-07-12 00:00:00	2000-07-12	2000-07-12 00:00:00	\N	38000177		0	0	0		0	0	0	102346	0	00781178901	45011828		
48752	4040	1127078	1977-02-03	1977-02-03 00:00:00	1977-02-17	1977-02-17 00:00:00	1977-02-17	38000177		0	0	14		0	0	0	268665	0	282464	1127078		
63089	5241	1127078	1962-04-26	1962-04-26 00:00:00	1962-05-10	1962-05-10 00:00:00	1962-05-10	38000177		0	0	14		0	0	0	348772	0	282464	1127078		
1933	154	19128065	1991-11-02	1991-11-02 00:00:00	1992-10-27	1992-10-27 00:00:00	1992-10-27	38000177		0	0	360		0	0	0	10496	0	749882	19128065		
63165	5249	1713671	1981-11-15	1981-11-15 00:00:00	1981-11-29	1981-11-29 00:00:00	1981-11-29	38000177		0	0	14		0	0	0	349157	0	562251	1713671		
2965	239	1127433	2012-03-01	2012-03-01 00:00:00	2012-04-30	2012-04-30 00:00:00	2012-04-30	38000177		0	0	60		0	0	0	16053	0	313782	1127433		
24971	2053	19133873	1971-02-27	1971-02-27 00:00:00	1971-03-10	1971-03-10 00:00:00	1971-03-10	38000177		0	0	11		0	0	0	136515	0	834061	19133873		
20908	1724	1127078	1954-06-18	1954-06-18 00:00:00	1954-07-16	1954-07-16 00:00:00	1954-07-16	38000177		0	0	28		0	0	0	115262	0	282464	1127078		
35420	2919	19075601	2017-12-16	2017-12-16 00:00:00	2017-12-16	2017-12-16 00:00:00	\N	38000177		0	0	0		0	0	0	194622	0	309362	19075601		
235282	5168	40213227	2002-10-25	2002-10-25 00:00:00	2002-10-25	2002-10-25 00:00:00	2002-10-25	581452		0	0	0		0	0	0	343602	0	113	40213227		
8421	703	40163554	2006-01-27	2006-01-27 00:00:00	2006-01-27	2006-01-27 00:00:00	\N	38000177		0	0	0		0	0	0	46430	0	855332	40163554		
12704	1070	1127433	1987-01-02	1987-01-02 00:00:00	1987-01-16	1987-01-16 00:00:00	1987-01-16	38000177		0	0	14		0	0	0	70062	0	313782	1127433		
18990	1569	1713671	1976-12-14	1976-12-14 00:00:00	1977-01-04	1977-01-04 00:00:00	1977-01-04	38000177		0	0	21		0	0	0	105257	0	562251	1713671		
5980	129	40213227	1996-06-03	1996-06-03 00:00:00	1996-06-03	1996-06-03 00:00:00	1996-06-03	581452		0	0	0		0	0	0	8693	0	113	40213227		
30780	2550	1713671	2000-09-22	2000-09-22 00:00:00	2000-10-13	2000-10-13 00:00:00	2000-10-13	38000177		0	0	21		0	0	0	168818	0	562251	1713671		
52631	4375	19126352	2015-08-16	2015-08-16 00:00:00	2015-08-16	2015-08-16 00:00:00	\N	38000177		0	0	0		0	0	0	290647	0	705129	19126352		
44390	3675	46233988	1967-11-13	1967-11-13 00:00:00	1967-11-27	1967-11-27 00:00:00	1967-11-27	38000177		0	0	14		0	0	0	244454	0	1652673	46233988		
26517	578	40213296	2009-02-25	2009-02-25 00:00:00	2009-02-25	2009-02-25 00:00:00	2009-02-25	581452		0	0	0		0	0	0	38231	0	52	40213296		
207910	4561	40213227	2001-04-18	2001-04-18 00:00:00	2001-04-18	2001-04-18 00:00:00	2001-04-18	581452		0	0	0		0	0	0	303903	0	113	40213227		
41500	3439	40229134	1972-06-20	1972-06-20 00:00:00	1972-07-04	1972-07-04 00:00:00	1972-07-04	38000177		0	0	14		0	0	0	228142	0	1043400	40229134		
12104	1015	46275916	1973-07-23	1973-07-23 00:00:00	1973-07-23	1973-07-23 00:00:00	1973-07-23	38000177		0	0	0		0	0	0	66813	0	1660014	46275916		
55087	4574	1713671	1986-12-18	1986-12-18 00:00:00	1987-01-01	1987-01-01 00:00:00	1987-01-01	38000177		0	0	14		0	0	0	304683	0	562251	1713671		
63958	1399	40213227	2002-07-10	2002-07-10 00:00:00	2002-07-10	2002-07-10 00:00:00	2002-07-10	581452		0	0	0		0	0	0	93104	0	113	40213227		
89412	1960	40213227	1992-09-15	1992-09-15 00:00:00	1992-09-15	1992-09-15 00:00:00	1992-09-15	581452		0	0	0		0	0	0	130384	0	113	40213227		
157374	3464	40213160	1981-01-21	1981-01-21 00:00:00	1981-01-21	1981-01-21 00:00:00	1981-01-21	581452		0	0	0		0	0	0	229949	0	10	40213160		
6428	539	19059056	1955-12-26	1955-12-26 00:00:00	1956-03-02	1956-03-02 00:00:00	1956-03-02	38000177		0	0	67		0	0	0	35824	0	243670	19059056		
30042	654	40213260	2012-02-17	2012-02-17 00:00:00	2012-02-17	2012-02-17 00:00:00	2012-02-17	581452		0	0	0		0	0	0	43308	0	121	40213260		
59767	4970	1713671	1995-12-09	1995-12-09 00:00:00	1995-12-16	1995-12-16 00:00:00	1995-12-16	38000177		0	0	7		0	0	0	330457	0	562251	1713671		
39869	3298	1127078	1972-08-09	1972-08-09 00:00:00	1972-08-30	1972-08-30 00:00:00	1972-08-30	38000177		0	0	21		0	0	0	219143	0	282464	1127078		
51257	1122	40213160	1970-02-23	1970-02-23 00:00:00	1970-02-23	1970-02-23 00:00:00	1970-02-23	581452		0	0	0		0	0	0	73961	0	10	40213160		
14860	1245	1713671	1947-12-18	1947-12-18 00:00:00	1948-01-01	1948-01-01 00:00:00	1948-01-01	38000177		0	0	14		0	0	0	81870	0	562251	1713671		
52807	1155	40213227	2007-06-11	2007-06-11 00:00:00	2007-06-11	2007-06-11 00:00:00	2007-06-11	581452		0	0	0		0	0	0	76351	0	113	40213227		
29393	2433	1713671	2019-02-28	2019-02-28 00:00:00	2019-03-14	2019-03-14 00:00:00	2019-03-14	38000177		0	0	14		0	0	0	161329	0	562251	1713671		
2292	185	19059056	1948-01-16	1948-01-16 00:00:00	1948-01-30	1948-01-30 00:00:00	1948-01-30	38000177		0	0	14		0	0	0	12550	0	243670	19059056		
30008	2486	40162522	1996-12-21	1996-12-21 00:00:00	1996-12-21	1996-12-21 00:00:00	\N	38000177		0	0	0		0	0	0	164712	0	857005	40162522		
56572	1238	40213160	1960-10-18	1960-10-18 00:00:00	1960-10-18	1960-10-18 00:00:00	1960-10-18	581452		0	0	0		0	0	0	81555	0	10	40213160		
37228	3077	19059056	1965-04-18	1965-04-18 00:00:00	1965-05-16	1965-05-16 00:00:00	1965-05-16	38000177		0	0	28		0	0	0	204717	0	243670	19059056		
48829	4049	1127433	1989-11-01	1989-11-01 00:00:00	1989-11-29	1989-11-29 00:00:00	1989-11-29	38000177		0	0	28		0	0	0	269138	0	313782	1127433		
6521	549	40229134	1989-05-19	1989-05-19 00:00:00	1989-06-02	1989-06-02 00:00:00	1989-06-02	38000177		0	0	14		0	0	0	36372	0	1043400	40229134		
81870	1788	40213160	1962-04-26	1962-04-26 00:00:00	1962-04-26	1962-04-26 00:00:00	1962-04-26	581452		0	0	0		0	0	0	119778	0	10	40213160		
52901	4395	1713671	1965-11-02	1965-11-02 00:00:00	1965-11-23	1965-11-23 00:00:00	1965-11-23	38000177		0	0	21		0	0	0	292257	0	562251	1713671		
59455	4942	1539411	1992-12-31	1992-12-31 00:00:00	1992-12-31	1992-12-31 00:00:00	\N	38000177		0	0	0		0	0	0	328533	0	312961	1539411		
13238	1110	19128022	1997-03-06	1997-03-06 00:00:00	1998-03-01	1998-03-01 00:00:00	1998-03-01	38000177		0	0	360		0	0	0	73122	0	749785	19128022		
58421	4852	1127433	1951-10-17	1951-10-17 00:00:00	1951-10-24	1951-10-24 00:00:00	1951-10-24	38000177		0	0	7		0	0	0	322846	0	313782	1127433		
53467	4446	19133873	1972-02-23	1972-02-23 00:00:00	1972-03-07	1972-03-07 00:00:00	1972-03-07	38000177		0	0	13		0	0	0	295668	0	834061	19133873		
42274	921	40213296	2008-07-01	2008-07-01 00:00:00	2008-07-01	2008-07-01 00:00:00	2008-07-01	581452		0	0	0		0	0	0	61340	0	52	40213296		
222076	4874	40213260	2018-08-04	2018-08-04 00:00:00	2018-08-04	2018-08-04 00:00:00	2018-08-04	581452		0	0	0		0	0	0	324157	0	121	40213260		
6552	143	40213160	1965-04-11	1965-04-11 00:00:00	1965-04-11	1965-04-11 00:00:00	1965-04-11	581452		0	0	0		0	0	0	9552	0	10	40213160		
14991	1253	1127078	1960-11-24	1960-11-24 00:00:00	1960-12-08	1960-12-08 00:00:00	1960-12-08	38000177		0	0	14		0	0	0	82526	0	282464	1127078		
12454	268	40213296	2009-04-28	2009-04-28 00:00:00	2009-04-28	2009-04-28 00:00:00	2009-04-28	581452		0	0	0		0	0	0	17825	0	52	40213296		
61612	5127	19059056	1971-02-11	1971-02-11 00:00:00	1971-02-25	1971-02-25 00:00:00	1971-02-25	38000177		0	0	14		0	0	0	340868	0	243670	19059056		
68227	1493	40213260	2007-01-16	2007-01-16 00:00:00	2007-01-16	2007-01-16 00:00:00	2007-01-16	581452		0	0	0		0	0	0	99583	0	121	40213260		
25613	558	40213260	2010-11-04	2010-11-04 00:00:00	2010-11-04	2010-11-04 00:00:00	2010-11-04	581452		0	0	0		0	0	0	37041	0	121	40213260		
32802	2715	1127433	1997-03-18	1997-03-18 00:00:00	1997-03-25	1997-03-25 00:00:00	1997-03-25	38000177		0	0	7		0	0	0	180046	0	313782	1127433		
54316	1189	40213260	2014-09-01	2014-09-01 00:00:00	2014-09-01	2014-09-01 00:00:00	2014-09-01	581452		0	0	0		0	0	0	78366	0	121	40213260		
52140	4337	1127433	1962-04-07	1962-04-07 00:00:00	1962-04-14	1962-04-14 00:00:00	1962-04-14	38000177		0	0	7		0	0	0	287600	0	313782	1127433		
53111	4412	1127078	1965-11-19	1965-11-19 00:00:00	1965-12-03	1965-12-03 00:00:00	1965-12-03	38000177		0	0	14		0	0	0	293315	0	282464	1127078		
31295	2594	1127433	1977-02-17	1977-02-17 00:00:00	1977-02-24	1977-02-24 00:00:00	1977-02-24	38000177		0	0	7		0	0	0	171720	0	313782	1127433		
13749	1149	1127078	1981-09-30	1981-09-30 00:00:00	1981-10-14	1981-10-14 00:00:00	1981-10-14	38000177		0	0	14		0	0	0	75963	0	282464	1127078		
11283	939	1127433	1986-06-22	1986-06-22 00:00:00	1986-07-06	1986-07-06 00:00:00	1986-07-06	38000177		0	0	14		0	0	0	62481	0	313782	1127433		
2347	188	1127433	1988-10-22	1988-10-22 00:00:00	1988-10-29	1988-10-29 00:00:00	1988-10-29	38000177		0	0	7		0	0	0	12773	0	313782	1127433		
40787	3381	40229134	1974-08-23	1974-08-23 00:00:00	1974-09-06	1974-09-06 00:00:00	1974-09-06	38000177		0	0	14		0	0	0	224364	0	1043400	40229134		
24381	2005	1127433	1988-07-24	1988-07-24 00:00:00	1988-08-07	1988-08-07 00:00:00	1988-08-07	38000177		0	0	14		0	0	0	133521	0	313782	1127433		
52338	4353	19128065	1989-06-17	1989-06-17 00:00:00	1990-06-12	1990-06-12 00:00:00	1990-06-12	38000177		0	0	360		0	0	0	288817	0	749882	19128065		
18478	1529	19059056	1966-07-06	1966-07-06 00:00:00	1966-07-20	1966-07-20 00:00:00	1966-07-20	38000177		0	0	14		0	0	0	102305	0	243670	19059056		
48753	4040	46233988	1977-02-03	1977-02-03 00:00:00	1977-02-17	1977-02-17 00:00:00	1977-02-17	38000177		0	0	14		0	0	0	268665	0	1652673	46233988		
63090	5241	19129655	1962-04-26	1962-04-26 00:00:00	1962-05-10	1962-05-10 00:00:00	1962-05-10	38000177		0	0	14		0	0	0	348772	0	789980	19129655		
1934	154	1118084	2012-03-06	2012-03-06 00:00:00	2012-03-06	2012-03-06 00:00:00	\N	38000177		0	0	0		0	0	0	10429	0	00025152531	44923712		
63166	5249	19059056	1963-02-19	1963-02-19 00:00:00	1963-03-12	1963-03-12 00:00:00	1963-03-12	38000177		0	0	21		0	0	0	349245	0	243670	19059056		
2966	239	1127078	1956-12-31	1956-12-31 00:00:00	1957-03-31	1957-03-31 00:00:00	1957-03-31	38000177		0	0	90		0	0	0	16049	0	282464	1127078		
24972	2053	1713671	1981-03-04	1981-03-04 00:00:00	1981-03-25	1981-03-25 00:00:00	1981-03-25	38000177		0	0	21		0	0	0	136476	0	562251	1713671		
20909	1724	1127433	1958-06-08	1958-06-08 00:00:00	1958-06-22	1958-06-22 00:00:00	1958-06-22	38000177		0	0	14		0	0	0	115276	0	313782	1127433		
35421	2919	1539411	2017-12-16	2017-12-16 00:00:00	2017-12-16	2017-12-16 00:00:00	\N	38000177		0	0	0		0	0	0	194622	0	312961	1539411		
235287	5168	40213296	2011-08-19	2011-08-19 00:00:00	2011-08-19	2011-08-19 00:00:00	2011-08-19	581452		0	0	0		0	0	0	343600	0	52	40213296		
8422	703	40171902	2006-01-27	2006-01-27 00:00:00	2006-01-27	2006-01-27 00:00:00	\N	38000177		0	0	0		0	0	0	46430	0	897718	40171902		
12705	1070	1713671	2011-04-29	2011-04-29 00:00:00	2011-05-06	2011-05-06 00:00:00	2011-05-06	38000177		0	0	7		0	0	0	70065	0	562251	1713671		
18991	1569	19059056	1938-12-08	1938-12-08 00:00:00	1938-12-22	1938-12-22 00:00:00	1938-12-22	38000177		0	0	14		0	0	0	105300	0	243670	19059056		
5981	129	40213306	1996-06-03	1996-06-03 00:00:00	1996-06-03	1996-06-03 00:00:00	1996-06-03	581452		0	0	0		0	0	0	8693	0	43	40213306		
30781	2550	40236824	2012-02-08	2012-02-08 00:00:00	2012-02-15	2012-02-15 00:00:00	2012-02-15	38000177		0	0	7		0	0	0	168807	0	1094107	40236824		
52632	4375	1332419	2015-08-16	2015-08-16 00:00:00	2015-08-16	2015-08-16 00:00:00	\N	38000177		0	0	0		0	0	0	290647	0	197361	1332419		
44391	3675	1127078	1967-11-13	1967-11-13 00:00:00	1967-11-27	1967-11-27 00:00:00	1967-11-27	38000177		0	0	14		0	0	0	244454	0	282464	1127078		
26518	578	40213227	2009-02-25	2009-02-25 00:00:00	2009-02-25	2009-02-25 00:00:00	2009-02-25	581452		0	0	0		0	0	0	38231	0	113	40213227		
207919	4561	40213227	2011-06-15	2011-06-15 00:00:00	2011-06-15	2011-06-15 00:00:00	2011-06-15	581452		0	0	0		0	0	0	303880	0	113	40213227		
51959	4320	40236824	2016-04-27	2016-04-27 00:00:00	2016-05-04	2016-05-04 00:00:00	2016-05-04	38000177		0	0	7		0	0	0	286683	0	1094107	40236824		
12105	1015	40243436	1973-07-23	1973-07-23 00:00:00	1973-07-23	1973-07-23 00:00:00	1973-07-23	38000177		0	0	0		0	0	0	66813	0	1190795	40243436		
55088	4574	1118084	1992-06-25	1992-06-25 00:00:00	1992-06-25	1992-06-25 00:00:00	\N	38000177		0	0	0		0	0	0	304746	0	00025152531	44923712		
63959	1399	40213296	2002-07-10	2002-07-10 00:00:00	2002-07-10	2002-07-10 00:00:00	2002-07-10	581452		0	0	0		0	0	0	93104	0	52	40213296		
157568	3469	40213160	1956-03-07	1956-03-07 00:00:00	1956-03-07	1956-03-07 00:00:00	1956-03-07	581452		0	0	0		0	0	0	230281	0	10	40213160		
57939	4814	19059056	1970-07-29	1970-07-29 00:00:00	1970-08-19	1970-08-19 00:00:00	1970-08-19	38000177		0	0	21		0	0	0	320247	0	243670	19059056		
6429	539	19059056	1970-05-18	1970-05-18 00:00:00	1970-06-08	1970-06-08 00:00:00	1970-06-08	38000177		0	0	21		0	0	0	35825	0	243670	19059056		
30044	654	40213227	2004-02-27	2004-02-27 00:00:00	2004-02-27	2004-02-27 00:00:00	2004-02-27	581452		0	0	0		0	0	0	43345	0	113	40213227		
59768	4970	1127433	1962-08-31	1962-08-31 00:00:00	1962-09-14	1962-09-14 00:00:00	1962-09-14	38000177		0	0	14		0	0	0	330426	0	313782	1127433		
39870	3298	19059056	1976-01-12	1976-01-12 00:00:00	1976-01-26	1976-01-26 00:00:00	1976-01-26	38000177		0	0	14		0	0	0	219144	0	243670	19059056		
51264	1123	40213160	1965-09-02	1965-09-02 00:00:00	1965-09-02	1965-09-02 00:00:00	1965-09-02	581452		0	0	0		0	0	0	74021	0	10	40213160		
14861	1245	19059056	1935-10-02	1935-10-02 00:00:00	1935-10-16	1935-10-16 00:00:00	1935-10-16	38000177		0	0	14		0	0	0	81945	0	243670	19059056		
52808	1155	40213296	2007-06-11	2007-06-11 00:00:00	2007-06-11	2007-06-11 00:00:00	2007-06-11	581452		0	0	0		0	0	0	76351	0	52	40213296		
29394	2433	1127433	1962-12-22	1962-12-22 00:00:00	1962-12-29	1962-12-29 00:00:00	1962-12-29	38000177		0	0	7		0	0	0	161281	0	313782	1127433		
2293	185	19006318	1948-01-16	1948-01-16 00:00:00	1948-01-30	1948-01-30 00:00:00	1948-01-30	38000177		0	0	14		0	0	0	12550	0	105078	19006318		
30009	2486	1118084	2011-03-03	2011-03-03 00:00:00	2011-03-03	2011-03-03 00:00:00	\N	38000177		0	0	0		0	0	0	164721	0	00025152531	44923712		
56575	1238	40213160	1956-07-17	1956-07-17 00:00:00	1956-07-17	1956-07-17 00:00:00	1956-07-17	581452		0	0	0		0	0	0	81565	0	10	40213160		
37229	3077	19075601	2014-11-26	2014-11-26 00:00:00	2014-11-26	2014-11-26 00:00:00	\N	38000177		0	0	0		0	0	0	204796	0	309362	19075601		
48830	4049	40229134	1983-02-10	1983-02-10 00:00:00	1983-02-24	1983-02-24 00:00:00	1983-02-24	38000177		0	0	14		0	0	0	269125	0	1043400	40229134		
6522	549	19059056	1953-05-26	1953-05-26 00:00:00	1953-06-09	1953-06-09 00:00:00	1953-06-09	38000177		0	0	14		0	0	0	36400	0	243670	19059056		
81875	1788	40213160	1965-11-04	1965-11-04 00:00:00	1965-11-04	1965-11-04 00:00:00	1965-11-04	581452		0	0	0		0	0	0	119807	0	10	40213160		
52903	4395	19133905	1981-12-17	1981-12-17 00:00:00	1981-12-27	1981-12-27 00:00:00	1981-12-27	38000177		0	0	10		0	0	0	292266	0	834102	19133905		
59456	4942	1713671	1961-07-23	1961-07-23 00:00:00	1961-07-30	1961-07-30 00:00:00	1961-07-30	38000177		0	0	7		0	0	0	328518	0	562251	1713671		
13239	1110	1127078	1992-10-18	1992-10-18 00:00:00	1992-12-17	1992-12-17 00:00:00	1992-12-17	38000177		0	0	60		0	0	0	73082	0	282464	1127078		
58422	4852	920334	1995-04-13	1995-04-13 00:00:00	1995-04-20	1995-04-20 00:00:00	1995-04-20	38000177		0	0	7		0	0	0	322854	0	311995	920334		
53468	4446	1118084	2002-03-05	2002-03-05 00:00:00	2002-03-05	2002-03-05 00:00:00	\N	38000177		0	0	0		0	0	0	295640	0	00025152531	44923712		
42276	921	40213306	1988-08-23	1988-08-23 00:00:00	1988-08-23	1988-08-23 00:00:00	1988-08-23	581452		0	0	0		0	0	0	61363	0	43	40213306		
222079	4874	40213227	2009-12-26	2009-12-26 00:00:00	2009-12-26	2009-12-26 00:00:00	2009-12-26	581452		0	0	0		0	0	0	324190	0	113	40213227		
6558	143	40213260	2014-11-02	2014-11-02 00:00:00	2014-11-02	2014-11-02 00:00:00	2014-11-02	581452		0	0	0		0	0	0	9598	0	121	40213260		
14992	1253	19006318	1960-11-24	1960-11-24 00:00:00	1960-12-08	1960-12-08 00:00:00	1960-12-08	38000177		0	0	14		0	0	0	82526	0	105078	19006318		
14219	307	40213296	2012-09-08	2012-09-08 00:00:00	2012-09-08	2012-09-08 00:00:00	2012-09-08	581452		0	0	0		0	0	0	20396	0	52	40213296		
61613	5127	1127433	1984-02-16	1984-02-16 00:00:00	1984-02-23	1984-02-23 00:00:00	1984-02-23	38000177		0	0	7		0	0	0	340866	0	313782	1127433		
68229	1493	40213160	1957-06-04	1957-06-04 00:00:00	1957-06-04	1957-06-04 00:00:00	1957-06-04	581452		0	0	0		0	0	0	99527	0	10	40213160		
25617	558	40213260	2011-11-10	2011-11-10 00:00:00	2011-11-10	2011-11-10 00:00:00	2011-11-10	581452		0	0	0		0	0	0	37002	0	121	40213260		
20628	1699	1127433	1991-06-20	1991-06-20 00:00:00	1991-07-04	1991-07-04 00:00:00	1991-07-04	38000177		0	0	14		0	0	0	113647	0	313782	1127433		
54322	1189	40213160	1964-03-09	1964-03-09 00:00:00	1964-03-09	1964-03-09 00:00:00	1964-03-09	581452		0	0	0		0	0	0	78356	0	10	40213160		
52141	4337	40229134	1984-09-13	1984-09-13 00:00:00	1984-09-20	1984-09-20 00:00:00	1984-09-20	38000177		0	0	7		0	0	0	287585	0	1043400	40229134		
53112	4412	19006318	1965-11-19	1965-11-19 00:00:00	1965-12-03	1965-12-03 00:00:00	1965-12-03	38000177		0	0	14		0	0	0	293315	0	105078	19006318		
31296	2594	19133873	1975-03-30	1975-03-30 00:00:00	1975-04-08	1975-04-08 00:00:00	1975-04-08	38000177		0	0	9		0	0	0	171688	0	834061	19133873		
13750	1149	19073183	1981-09-30	1981-09-30 00:00:00	1981-10-14	1981-10-14 00:00:00	1981-10-14	38000177		0	0	14		0	0	0	75963	0	308182	19073183		
11284	939	1127433	1997-11-26	1997-11-26 00:00:00	1997-12-10	1997-12-10 00:00:00	1997-12-10	38000177		0	0	14		0	0	0	62466	0	313782	1127433		
2348	188	1115171	2011-10-30	2011-10-30 00:00:00	2011-11-20	2011-11-20 00:00:00	2011-11-20	38000177		0	0	21		0	0	0	12785	0	849574	1115171		
40788	3382	19133905	2014-07-10	2014-07-10 00:00:00	2014-07-23	2014-07-23 00:00:00	2014-07-23	38000177		0	0	13		0	0	0	224447	0	834102	19133905		
24382	2005	19133873	1979-11-12	1979-11-12 00:00:00	1979-11-25	1979-11-25 00:00:00	1979-11-25	38000177		0	0	13		0	0	0	133510	0	834061	19133873		
102117	2238	40213260	2018-08-05	2018-08-05 00:00:00	2018-08-05	2018-08-05 00:00:00	2018-08-05	581452		0	0	0		0	0	0	149014	0	121	40213260		
18479	1529	19129655	1966-07-06	1966-07-06 00:00:00	1966-07-20	1966-07-20 00:00:00	1966-07-20	38000177		0	0	14		0	0	0	102305	0	789980	19129655		
48754	4040	1127078	1982-11-04	1982-11-04 00:00:00	1982-11-18	1982-11-18 00:00:00	1982-11-18	38000177		0	0	14		0	0	0	268659	0	282464	1127078		
63091	5241	19078461	1987-03-14	1987-03-14 00:00:00	1987-04-11	1987-04-11 00:00:00	1987-04-11	38000177		0	0	28		0	0	0	348799	0	310965	19078461		
1935	154	43012754	1995-10-12	1995-10-12 00:00:00	1996-10-06	1996-10-06 00:00:00	1996-10-06	38000177		0	0	360		0	0	0	10476	0	1366343	43012754		
63167	5249	40229134	1963-07-10	1963-07-10 00:00:00	1963-07-17	1963-07-17 00:00:00	1963-07-17	38000177		0	0	7		0	0	0	349194	0	1043400	40229134		
188158	4131	40213160	1977-02-18	1977-02-18 00:00:00	1977-02-18	1977-02-18 00:00:00	1977-02-18	581452		0	0	0		0	0	0	274677	0	10	40213160		
24973	2053	19006318	1956-06-01	1956-06-01 00:00:00	1956-06-15	1956-06-15 00:00:00	1956-06-15	38000177		0	0	14		0	0	0	136550	0	105078	19006318		
20910	1724	40229134	2015-01-23	2015-01-23 00:00:00	2015-01-30	2015-01-30 00:00:00	2015-01-30	38000177		0	0	7		0	0	0	115325	0	1043400	40229134		
35422	2919	1332419	2017-12-16	2017-12-16 00:00:00	2017-12-16	2017-12-16 00:00:00	\N	38000177		0	0	0		0	0	0	194622	0	197361	1332419		
235290	5168	40213160	1971-06-04	1971-06-04 00:00:00	1971-06-04	1971-06-04 00:00:00	1971-06-04	581452		0	0	0		0	0	0	343606	0	10	40213160		
8423	703	1127433	1976-04-06	1976-04-06 00:00:00	1976-04-13	1976-04-13 00:00:00	1976-04-13	38000177		0	0	7		0	0	0	46474	0	313782	1127433		
12706	1070	1127433	2007-02-11	2007-02-11 00:00:00	2007-02-18	2007-02-18 00:00:00	2007-02-18	38000177		0	0	7		0	0	0	70048	0	313782	1127433		
18992	1569	1127433	1943-03-03	1943-03-03 00:00:00	1943-03-17	1943-03-17 00:00:00	1943-03-17	38000177		0	0	14		0	0	0	105240	0	313782	1127433		
5988	129	40213160	1979-09-17	1979-09-17 00:00:00	1979-09-17	1979-09-17 00:00:00	1979-09-17	581452		0	0	0		0	0	0	8681	0	10	40213160		
30782	2551	19128065	1976-07-27	1976-07-27 00:00:00	1977-07-22	1977-07-22 00:00:00	1977-07-22	38000177		0	0	360		0	0	0	168846	0	749882	19128065		
52633	4375	1539411	2015-08-16	2015-08-16 00:00:00	2015-08-16	2015-08-16 00:00:00	\N	38000177		0	0	0		0	0	0	290647	0	312961	1539411		
44392	3675	1127433	1998-11-16	1998-11-16 00:00:00	1998-11-23	1998-11-23 00:00:00	1998-11-23	38000177		0	0	7		0	0	0	244478	0	313782	1127433		
26520	578	40213160	1972-03-01	1972-03-01 00:00:00	1972-03-01	1972-03-01 00:00:00	1972-03-01	581452		0	0	0		0	0	0	38223	0	10	40213160		
207926	4561	40213201	2016-07-13	2016-07-13 00:00:00	2016-07-13	2016-07-13 00:00:00	2016-07-13	581452		0	0	0		0	0	0	303897	0	33	40213201		
51960	4320	920300	2016-04-27	2016-04-27 00:00:00	2016-05-04	2016-05-04 00:00:00	2016-05-04	38000177		0	0	7		0	0	0	286683	0	311989	920300		
12106	1015	1310034	1973-07-23	1973-07-23 00:00:00	1973-07-23	1973-07-23 00:00:00	1973-07-23	38000177		0	0	0		0	0	0	66813	0	834357	1310034		
152289	3352	40213160	1969-10-03	1969-10-03 00:00:00	1969-10-03	1969-10-03 00:00:00	1969-10-03	581452		0	0	0		0	0	0	222261	0	10	40213160		
63961	1399	40213227	1992-07-29	1992-07-29 00:00:00	1992-07-29	1992-07-29 00:00:00	1992-07-29	581452		0	0	0		0	0	0	93066	0	113	40213227		
157572	3469	40213227	2014-07-30	2014-07-30 00:00:00	2014-07-30	2014-07-30 00:00:00	2014-07-30	581452		0	0	0		0	0	0	230291	0	113	40213227		
57940	4814	1127433	2010-12-13	2010-12-13 00:00:00	2010-12-27	2010-12-27 00:00:00	2010-12-27	38000177		0	0	14		0	0	0	320250	0	313782	1127433		
6430	539	19059056	1935-08-28	1935-08-28 00:00:00	1935-09-11	1935-09-11 00:00:00	1935-09-11	38000177		0	0	14		0	0	0	35790	0	243670	19059056		
30047	654	40213227	1993-05-28	1993-05-28 00:00:00	1993-05-28	1993-05-28 00:00:00	1993-05-28	581452		0	0	0		0	0	0	43288	0	113	40213227		
59769	4970	1127433	1927-02-27	1927-02-27 00:00:00	1927-03-13	1927-03-13 00:00:00	1927-03-13	38000177		0	0	14		0	0	0	330379	0	313782	1127433		
39871	3298	1127078	1979-12-06	1979-12-06 00:00:00	1979-12-20	1979-12-20 00:00:00	1979-12-20	38000177		0	0	14		0	0	0	219145	0	282464	1127078		
51266	1123	40213296	2005-12-01	2005-12-01 00:00:00	2005-12-01	2005-12-01 00:00:00	2005-12-01	581452		0	0	0		0	0	0	73973	0	52	40213296		
14862	1245	1127433	1940-04-10	1940-04-10 00:00:00	1940-04-17	1940-04-17 00:00:00	1940-04-17	38000177		0	0	7		0	0	0	81936	0	313782	1127433		
52814	1155	40213227	1999-05-31	1999-05-31 00:00:00	1999-05-31	1999-05-31 00:00:00	1999-05-31	581452		0	0	0		0	0	0	76350	0	113	40213227		
29395	2433	1127433	1984-05-17	1984-05-17 00:00:00	1984-06-07	1984-06-07 00:00:00	1984-06-07	38000177		0	0	21		0	0	0	161345	0	313782	1127433		
2294	185	1127433	1977-04-30	1977-04-30 00:00:00	1977-05-14	1977-05-14 00:00:00	1977-05-14	38000177		0	0	14		0	0	0	12525	0	313782	1127433		
30010	2487	40229134	1993-09-30	1993-09-30 00:00:00	1993-10-07	1993-10-07 00:00:00	1993-10-07	38000177		0	0	7		0	0	0	164762	0	1043400	40229134		
56578	1238	40213227	2017-01-10	2017-01-10 00:00:00	2017-01-10	2017-01-10 00:00:00	2017-01-10	581452		0	0	0		0	0	0	81616	0	113	40213227		
37230	3077	1127433	2013-04-01	2013-04-01 00:00:00	2013-04-08	2013-04-08 00:00:00	2013-04-08	38000177		0	0	7		0	0	0	204750	0	313782	1127433		
48831	4049	1713671	2003-11-30	2003-11-30 00:00:00	2003-12-14	2003-12-14 00:00:00	2003-12-14	38000177		0	0	14		0	0	0	269130	0	562251	1713671		
6524	549	1127078	1962-07-08	1962-07-08 00:00:00	1962-07-29	1962-07-29 00:00:00	1962-07-29	38000177		0	0	21		0	0	0	36422	0	282464	1127078		
81879	1788	40213296	2002-08-01	2002-08-01 00:00:00	2002-08-01	2002-08-01 00:00:00	2002-08-01	581452		0	0	0		0	0	0	119849	0	52	40213296		
52904	4395	1127433	2013-11-08	2013-11-08 00:00:00	2013-12-08	2013-12-08 00:00:00	2013-12-08	38000177		0	0	30		0	0	0	292288	0	313782	1127433		
59457	4942	19078461	1994-10-13	1994-10-13 00:00:00	1994-11-03	1994-11-03 00:00:00	1994-11-03	38000177		0	0	21		0	0	0	328466	0	310965	19078461		
13240	1110	1118084	2014-11-27	2014-11-27 00:00:00	2014-11-27	2014-11-27 00:00:00	\N	38000177		0	0	0		0	0	0	73136	0	00025152531	44923712		
58423	4852	19059056	1969-05-15	1969-05-15 00:00:00	1969-06-12	1969-06-12 00:00:00	1969-06-12	38000177		0	0	28		0	0	0	322780	0	243670	19059056		
53469	4446	1127433	1964-12-06	1964-12-06 00:00:00	1964-12-20	1964-12-20 00:00:00	1964-12-20	38000177		0	0	14		0	0	0	295648	0	313782	1127433		
42280	921	40213160	1967-02-28	1967-02-28 00:00:00	1967-02-28	1967-02-28 00:00:00	1967-02-28	581452		0	0	0		0	0	0	61357	0	10	40213160		
222080	4874	40213296	2009-12-26	2009-12-26 00:00:00	2009-12-26	2009-12-26 00:00:00	2009-12-26	581452		0	0	0		0	0	0	324190	0	52	40213296		
6562	143	40213227	1996-03-03	1996-03-03 00:00:00	1996-03-03	1996-03-03 00:00:00	1996-03-03	581452		0	0	0		0	0	0	9593	0	113	40213227		
14993	1253	1127433	2012-07-05	2012-07-05 00:00:00	2012-07-19	2012-07-19 00:00:00	2012-07-19	38000177		0	0	14		0	0	0	82511	0	313782	1127433		
14221	307	40213160	1969-09-27	1969-09-27 00:00:00	1969-09-27	1969-09-27 00:00:00	1969-09-27	581452		0	0	0		0	0	0	20388	0	10	40213160		
61614	5127	1127433	1975-12-17	1975-12-17 00:00:00	1975-12-31	1975-12-31 00:00:00	1975-12-31	38000177		0	0	14		0	0	0	340888	0	313782	1127433		
68235	1493	40213296	1996-10-01	1996-10-01 00:00:00	1996-10-01	1996-10-01 00:00:00	1996-10-01	581452		0	0	0		0	0	0	99515	0	52	40213296		
25618	558	40213227	2011-11-10	2011-11-10 00:00:00	2011-11-10	2011-11-10 00:00:00	2011-11-10	581452		0	0	0		0	0	0	37002	0	113	40213227		
20629	1699	1713671	2000-12-23	2000-12-23 00:00:00	2000-12-30	2000-12-30 00:00:00	2000-12-30	38000177		0	0	7		0	0	0	113650	0	562251	1713671		
54325	1189	40213296	2003-12-08	2003-12-08 00:00:00	2003-12-08	2003-12-08 00:00:00	2003-12-08	581452		0	0	0		0	0	0	78345	0	52	40213296		
52142	4337	1127433	2016-07-06	2016-07-06 00:00:00	2016-07-13	2016-07-13 00:00:00	2016-07-13	38000177		0	0	7		0	0	0	287567	0	313782	1127433		
53113	4412	19059056	1967-03-14	1967-03-14 00:00:00	1967-03-28	1967-03-28 00:00:00	1967-03-28	38000177		0	0	14		0	0	0	293283	0	243670	19059056		
31297	2594	1127433	2013-05-23	2013-05-23 00:00:00	2013-06-06	2013-06-06 00:00:00	2013-06-06	38000177		0	0	14		0	0	0	171715	0	313782	1127433		
13751	1149	1713671	1992-12-20	1992-12-20 00:00:00	1992-12-27	1992-12-27 00:00:00	1992-12-27	38000177		0	0	7		0	0	0	75979	0	562251	1713671		
19013	411	40213296	1999-12-04	1999-12-04 00:00:00	1999-12-04	1999-12-04 00:00:00	1999-12-04	581452		0	0	0		0	0	0	27390	0	52	40213296		
2349	188	1127433	1986-03-28	1986-03-28 00:00:00	1986-04-04	1986-04-04 00:00:00	1986-04-04	38000177		0	0	7		0	0	0	12825	0	313782	1127433		
40789	3382	19133905	2013-05-02	2013-05-02 00:00:00	2013-05-13	2013-05-13 00:00:00	2013-05-13	38000177		0	0	11		0	0	0	224446	0	834102	19133905		
24383	2006	1115171	2013-04-18	2013-04-18 00:00:00	2013-05-09	2013-05-09 00:00:00	2013-05-09	38000177		0	0	21		0	0	0	133606	0	849574	1115171		
102121	2238	40213160	1968-11-10	1968-11-10 00:00:00	1968-11-10	1968-11-10 00:00:00	1968-11-10	581452		0	0	0		0	0	0	148907	0	10	40213160		
18480	1529	1127433	1974-10-02	1974-10-02 00:00:00	1974-12-31	1974-12-31 00:00:00	1974-12-31	38000177		0	0	90		0	0	0	102354	0	313782	1127433		
48755	4040	1127433	2009-03-12	2009-03-12 00:00:00	2009-03-26	2009-03-26 00:00:00	2009-03-26	38000177		0	0	14		0	0	0	268685	0	313782	1127433		
63093	5241	19128065	1986-01-30	1986-01-30 00:00:00	1987-01-25	1987-01-25 00:00:00	1987-01-25	38000177		0	0	360		0	0	0	348728	0	749882	19128065		
1936	154	40224805	1994-10-17	1994-10-17 00:00:00	1995-10-12	1995-10-12 00:00:00	1995-10-12	38000177		0	0	360		0	0	0	10475	0	1000126	40224805		
63168	5249	40220960	2004-04-25	2004-04-25 00:00:00	2004-04-25	2004-04-25 00:00:00	2004-04-25	38000177		0	0	0		0	0	0	349230	0	1804799	40220960		
188159	4131	40213314	1977-02-18	1977-02-18 00:00:00	1977-02-18	1977-02-18 00:00:00	1977-02-18	581452		0	0	0		0	0	0	274677	0	49	40213314		
24974	2053	19059056	1956-06-01	1956-06-01 00:00:00	1956-06-15	1956-06-15 00:00:00	1956-06-15	38000177		0	0	14		0	0	0	136550	0	243670	19059056		
20911	1724	19078461	1986-05-27	1986-05-27 00:00:00	1986-08-25	1986-08-25 00:00:00	1986-08-25	38000177		0	0	90		0	0	0	115264	0	310965	19078461		
35423	2919	40169281	2013-11-23	2013-11-23 00:00:00	2013-11-23	2013-11-23 00:00:00	\N	38000177		0	0	0		0	0	0	194634	0	896209	40169281		
235294	5168	40213160	1971-08-06	1971-08-06 00:00:00	1971-08-06	1971-08-06 00:00:00	1971-08-06	581452		0	0	0		0	0	0	343628	0	10	40213160		
8424	703	1127433	1992-09-13	1992-09-13 00:00:00	1992-09-27	1992-09-27 00:00:00	1992-09-27	38000177		0	0	14		0	0	0	46510	0	313782	1127433		
12715	1072	1127433	1990-10-20	1990-10-20 00:00:00	1990-11-18	1990-11-18 00:00:00	1990-11-18	38000177		0	0	29		0	0	0	70258	0	313782	1127433		
18993	1569	19059056	1956-01-26	1956-01-26 00:00:00	1956-02-09	1956-02-09 00:00:00	1956-02-09	38000177		0	0	14		0	0	0	105274	0	243670	19059056		
5989	129	40213160	1975-01-13	1975-01-13 00:00:00	1975-01-13	1975-01-13 00:00:00	1975-01-13	581452		0	0	0		0	0	0	8716	0	10	40213160		
30783	2551	920300	2000-12-04	2000-12-04 00:00:00	2000-12-11	2000-12-11 00:00:00	2000-12-11	38000177		0	0	7		0	0	0	168898	0	311989	920300		
52634	4375	19075601	2015-08-16	2015-08-16 00:00:00	2015-08-16	2015-08-16 00:00:00	\N	38000177		0	0	0		0	0	0	290647	0	309362	19075601		
44393	3675	1118084	2008-11-22	2008-11-22 00:00:00	2008-11-22	2008-11-22 00:00:00	\N	38000177		0	0	0		0	0	0	244471	0	00025152531	44923712		
26523	578	40213306	1989-07-26	1989-07-26 00:00:00	1989-07-26	1989-07-26 00:00:00	1989-07-26	581452		0	0	0		0	0	0	38230	0	43	40213306		
7080	153	40213198	2010-09-16	2010-09-16 00:00:00	2010-09-16	2010-09-16 00:00:00	2010-09-16	581452		0	0	0		0	0	0	10329	0	133	40213198		
51961	4320	19006318	1973-02-11	1973-02-11 00:00:00	1973-02-25	1973-02-25 00:00:00	1973-02-25	38000177		0	0	14		0	0	0	286666	0	105078	19006318		
12107	1016	920334	2010-08-25	2010-08-25 00:00:00	2010-09-01	2010-09-01 00:00:00	2010-09-01	38000177		0	0	7		0	0	0	66899	0	311995	920334		
152290	3352	40213160	1965-01-29	1965-01-29 00:00:00	1965-01-29	1965-01-29 00:00:00	1965-01-29	581452		0	0	0		0	0	0	222297	0	10	40213160		
63964	1399	40213227	2011-07-06	2011-07-06 00:00:00	2011-07-06	2011-07-06 00:00:00	2011-07-06	581452		0	0	0		0	0	0	93103	0	113	40213227		
157576	3469	40213160	1955-03-09	1955-03-09 00:00:00	1955-03-09	1955-03-09 00:00:00	1955-03-09	581452		0	0	0		0	0	0	230225	0	10	40213160		
57941	4814	19059056	1960-05-04	1960-05-04 00:00:00	1960-05-18	1960-05-18 00:00:00	1960-05-18	38000177		0	0	14		0	0	0	320254	0	243670	19059056		
6463	545	40236824	2017-11-08	2017-11-08 00:00:00	2017-11-15	2017-11-15 00:00:00	2017-11-15	38000177		0	0	7		0	0	0	36049	0	1094107	40236824		
39844	869	40213227	2005-09-30	2005-09-30 00:00:00	2005-09-30	2005-09-30 00:00:00	2005-09-30	581452		0	0	0		0	0	0	57814	0	113	40213227		
59770	4970	1127433	1964-06-21	1964-06-21 00:00:00	1964-06-28	1964-06-28 00:00:00	1964-06-28	38000177		0	0	7		0	0	0	330382	0	313782	1127433		
39872	3298	1115171	2018-06-28	2018-06-28 00:00:00	2018-07-26	2018-07-26 00:00:00	2018-07-26	38000177		0	0	28		0	0	0	219146	0	849574	1115171		
51270	1123	40213260	2015-05-28	2015-05-28 00:00:00	2015-05-28	2015-05-28 00:00:00	2015-05-28	581452		0	0	0		0	0	0	73993	0	121	40213260		
14863	1245	19059056	1937-07-23	1937-07-23 00:00:00	1937-08-20	1937-08-20 00:00:00	1937-08-20	38000177		0	0	28		0	0	0	81934	0	243670	19059056		
52820	1155	40213160	1971-02-01	1971-02-01 00:00:00	1971-02-01	1971-02-01 00:00:00	1971-02-01	581452		0	0	0		0	0	0	76343	0	10	40213160		
36507	3011	19133905	2003-04-02	2003-04-02 00:00:00	2003-04-09	2003-04-09 00:00:00	2003-04-09	38000177		0	0	7		0	0	0	200824	0	834102	19133905		
2295	185	1127433	1958-08-07	1958-08-07 00:00:00	1958-11-05	1958-11-05 00:00:00	1958-11-05	38000177		0	0	90		0	0	0	12506	0	313782	1127433		
30011	2487	1127433	1965-06-24	1965-06-24 00:00:00	1965-07-01	1965-07-01 00:00:00	1965-07-01	38000177		0	0	7		0	0	0	164788	0	313782	1127433		
56596	1239	40213160	1971-03-04	1971-03-04 00:00:00	1971-03-04	1971-03-04 00:00:00	1971-03-04	581452		0	0	0		0	0	0	81648	0	10	40213160		
37239	3079	1127433	1971-03-02	1971-03-02 00:00:00	1971-03-16	1971-03-16 00:00:00	1971-03-16	38000177		0	0	14		0	0	0	204962	0	313782	1127433		
48832	4049	19133905	1993-08-15	1993-08-15 00:00:00	1993-08-23	1993-08-23 00:00:00	1993-08-23	38000177		0	0	8		0	0	0	269174	0	834102	19133905		
6525	549	40236824	1989-10-19	1989-10-19 00:00:00	1989-10-26	1989-10-26 00:00:00	1989-10-26	38000177		0	0	7		0	0	0	36364	0	1094107	40236824		
81880	1788	40213160	1961-11-23	1961-11-23 00:00:00	1961-11-23	1961-11-23 00:00:00	1961-11-23	581452		0	0	0		0	0	0	119777	0	10	40213160		
52905	4395	19059056	1982-07-10	1982-07-10 00:00:00	1982-07-24	1982-07-24 00:00:00	1982-07-24	38000177		0	0	14		0	0	0	292287	0	243670	19059056		
59458	4942	920334	2003-05-27	2003-05-27 00:00:00	2003-06-03	2003-06-03 00:00:00	2003-06-03	38000177		0	0	7		0	0	0	328505	0	311995	920334		
13241	1110	1127433	2010-09-10	2010-09-10 00:00:00	2010-09-24	2010-09-24 00:00:00	2010-09-24	38000177		0	0	14		0	0	0	73120	0	313782	1127433		
58424	4852	19129655	1969-05-15	1969-05-15 00:00:00	1969-06-12	1969-06-12 00:00:00	1969-06-12	38000177		0	0	28		0	0	0	322780	0	789980	19129655		
53470	4446	1127433	1977-04-21	1977-04-21 00:00:00	1977-05-05	1977-05-05 00:00:00	1977-05-05	38000177		0	0	14		0	0	0	295666	0	313782	1127433		
42284	921	40213160	1966-11-29	1966-11-29 00:00:00	1966-11-29	1966-11-29 00:00:00	1966-11-29	581452		0	0	0		0	0	0	61330	0	10	40213160		
240111	5272	40213227	2008-04-02	2008-04-02 00:00:00	2008-04-02	2008-04-02 00:00:00	2008-04-02	581452		0	0	0		0	0	0	350647	0	113	40213227		
6565	143	40213296	2004-11-07	2004-11-07 00:00:00	2004-11-07	2004-11-07 00:00:00	2004-11-07	581452		0	0	0		0	0	0	9596	0	52	40213296		
14994	1253	1127433	2010-09-20	2010-09-20 00:00:00	2010-09-27	2010-09-27 00:00:00	2010-09-27	38000177		0	0	7		0	0	0	82494	0	313782	1127433		
14224	307	40213227	1993-08-14	1993-08-14 00:00:00	1993-08-14	1993-08-14 00:00:00	1993-08-14	581452		0	0	0		0	0	0	20359	0	113	40213227		
61615	5127	1713671	1999-06-13	1999-06-13 00:00:00	1999-07-04	1999-07-04 00:00:00	1999-07-04	38000177		0	0	21		0	0	0	340867	0	562251	1713671		
68243	1493	40213227	2018-06-26	2018-06-26 00:00:00	2018-06-26	2018-06-26 00:00:00	2018-06-26	581452		0	0	0		0	0	0	99524	0	113	40213227		
25621	558	40213227	2002-11-14	2002-11-14 00:00:00	2002-11-14	2002-11-14 00:00:00	2002-11-14	581452		0	0	0		0	0	0	37012	0	113	40213227		
20631	1699	19059056	1968-12-18	1968-12-18 00:00:00	1969-02-16	1969-02-16 00:00:00	1969-02-16	38000177		0	0	60		0	0	0	113626	0	243670	19059056		
65208	1427	40213160	1956-02-15	1956-02-15 00:00:00	1956-02-15	1956-02-15 00:00:00	1956-02-15	581452		0	0	0		0	0	0	94889	0	10	40213160		
52143	4337	1713671	1981-04-22	1981-04-22 00:00:00	1981-04-29	1981-04-29 00:00:00	1981-04-29	38000177		0	0	7		0	0	0	287639	0	562251	1713671		
53114	4412	1127433	2016-03-13	2016-03-13 00:00:00	2016-03-20	2016-03-20 00:00:00	2016-03-20	38000177		0	0	7		0	0	0	293389	0	313782	1127433		
31298	2594	1118084	2015-05-07	2015-05-07 00:00:00	2015-05-07	2015-05-07 00:00:00	\N	38000177		0	0	0		0	0	0	171715	0	00025152531	44923712		
13752	1149	19019979	1980-02-24	1980-02-24 00:00:00	1980-03-09	1980-03-09 00:00:00	1980-03-09	38000177		0	0	14		0	0	0	75955	0	198405	19019979		
19016	411	40213160	1959-05-30	1959-05-30 00:00:00	1959-05-30	1959-05-30 00:00:00	1959-05-30	581452		0	0	0		0	0	0	27340	0	10	40213160		
2350	188	1127433	1986-10-27	1986-10-27 00:00:00	1986-11-10	1986-11-10 00:00:00	1986-11-10	38000177		0	0	14		0	0	0	12784	0	313782	1127433		
40790	3382	40231925	1992-04-20	1992-04-20 00:00:00	1992-04-20	1992-04-20 00:00:00	\N	38000177		0	0	0		0	0	0	224401	0	1049221	40231925		
24385	2006	19133873	1961-12-11	1961-12-11 00:00:00	1961-12-21	1961-12-21 00:00:00	1961-12-21	38000177		0	0	10		0	0	0	133567	0	834061	19133873		
108699	2384	40213160	1988-03-01	1988-03-01 00:00:00	1988-03-01	1988-03-01 00:00:00	1988-03-01	581452		0	0	0		0	0	0	158494	0	10	40213160		
18481	1529	1713671	2018-03-15	2018-03-15 00:00:00	2018-04-05	2018-04-05 00:00:00	2018-04-05	38000177		0	0	21		0	0	0	102310	0	562251	1713671		
48756	4040	19133873	1986-11-27	1986-11-27 00:00:00	1986-12-04	1986-12-04 00:00:00	1986-12-04	38000177		0	0	7		0	0	0	268671	0	834061	19133873		
63094	5241	1127433	2001-04-02	2001-04-02 00:00:00	2001-04-09	2001-04-09 00:00:00	2001-04-09	38000177		0	0	7		0	0	0	348720	0	313782	1127433		
1937	154	19128022	1993-10-22	1993-10-22 00:00:00	1994-10-17	1994-10-17 00:00:00	1994-10-17	38000177		0	0	360		0	0	0	10474	0	749785	19128022		
63169	5249	19075601	2004-04-25	2004-04-25 00:00:00	2004-04-25	2004-04-25 00:00:00	2004-04-25	38000177		0	0	0		0	0	0	349230	0	309362	19075601		
188163	4131	40213227	2007-08-10	2007-08-10 00:00:00	2007-08-10	2007-08-10 00:00:00	2007-08-10	581452		0	0	0		0	0	0	274709	0	113	40213227		
24975	2053	19133873	1959-09-08	1959-09-08 00:00:00	1959-09-16	1959-09-16 00:00:00	1959-09-16	38000177		0	0	8		0	0	0	136501	0	834061	19133873		
20912	1724	40165015	1986-05-27	1986-05-27 00:00:00	1986-05-27	1986-05-27 00:00:00	\N	38000177		0	0	0		0	0	0	115264	0	861467	40165015		
35424	2919	1127433	1951-11-10	1951-11-10 00:00:00	1951-11-17	1951-11-17 00:00:00	1951-11-17	38000177		0	0	7		0	0	0	194584	0	313782	1127433		
64017	5317	19133873	1984-01-29	1984-01-29 00:00:00	1984-02-06	1984-02-06 00:00:00	1984-02-06	38000177		0	0	8		0	0	0	353617	0	834061	19133873		
8425	703	1127433	2007-09-08	2007-09-08 00:00:00	2007-09-22	2007-09-22 00:00:00	2007-09-22	38000177		0	0	14		0	0	0	46476	0	313782	1127433		
12716	1072	1127078	1968-03-08	1968-03-08 00:00:00	1968-04-05	1968-04-05 00:00:00	1968-04-05	38000177		0	0	28		0	0	0	70284	0	282464	1127078		
18994	1569	19006318	1956-01-26	1956-01-26 00:00:00	1956-02-09	1956-02-09 00:00:00	1956-02-09	38000177		0	0	14		0	0	0	105274	0	105078	19006318		
48298	1057	40213260	2012-05-10	2012-05-10 00:00:00	2012-05-10	2012-05-10 00:00:00	2012-05-10	581452		0	0	0		0	0	0	69286	0	121	40213260		
30784	2551	40236824	2000-12-04	2000-12-04 00:00:00	2000-12-11	2000-12-11 00:00:00	2000-12-11	38000177		0	0	7		0	0	0	168898	0	1094107	40236824		
52635	4375	19059056	1933-03-27	1933-03-27 00:00:00	1933-04-10	1933-04-10 00:00:00	1933-04-10	38000177		0	0	14		0	0	0	290681	0	243670	19059056		
44394	3675	19059056	1968-04-11	1968-04-11 00:00:00	1968-06-10	1968-06-10 00:00:00	1968-06-10	38000177		0	0	60		0	0	0	244428	0	243670	19059056		
26539	578	40213227	1999-12-29	1999-12-29 00:00:00	1999-12-29	1999-12-29 00:00:00	1999-12-29	581452		0	0	0		0	0	0	38209	0	113	40213227		
7092	153	40213227	2004-08-12	2004-08-12 00:00:00	2004-08-12	2004-08-12 00:00:00	2004-08-12	581452		0	0	0		0	0	0	10302	0	113	40213227		
51962	4320	19059056	1973-02-11	1973-02-11 00:00:00	1973-02-25	1973-02-25 00:00:00	1973-02-25	38000177		0	0	14		0	0	0	286666	0	243670	19059056		
12108	1016	1118084	2010-01-24	2010-01-24 00:00:00	2010-01-24	2010-01-24 00:00:00	\N	38000177		0	0	0		0	0	0	66916	0	00025152531	44923712		
152293	3352	40213306	1986-12-05	1986-12-05 00:00:00	1986-12-05	1986-12-05 00:00:00	1986-12-05	581452		0	0	0		0	0	0	222266	0	43	40213306		
63965	1399	40213260	2011-07-06	2011-07-06 00:00:00	2011-07-06	2011-07-06 00:00:00	2011-07-06	581452		0	0	0		0	0	0	93103	0	121	40213260		
157583	3469	40213227	2003-10-08	2003-10-08 00:00:00	2003-10-08	2003-10-08 00:00:00	2003-10-08	581452		0	0	0		0	0	0	230265	0	113	40213227		
57942	4814	19059056	1953-09-28	1953-09-28 00:00:00	1953-10-26	1953-10-26 00:00:00	1953-10-26	38000177		0	0	28		0	0	0	320246	0	243670	19059056		
6464	545	920300	2017-11-08	2017-11-08 00:00:00	2017-11-15	2017-11-15 00:00:00	2017-11-15	38000177		0	0	7		0	0	0	36049	0	311989	920300		
58031	4820	19059056	1967-02-13	1967-02-13 00:00:00	1967-05-14	1967-05-14 00:00:00	1967-05-14	38000177		0	0	90		0	0	0	320645	0	243670	19059056		
59771	4970	40229134	1983-01-21	1983-01-21 00:00:00	1983-01-28	1983-01-28 00:00:00	1983-01-28	38000177		0	0	7		0	0	0	330427	0	1043400	40229134		
68388	1497	40213227	2011-06-03	2011-06-03 00:00:00	2011-06-03	2011-06-03 00:00:00	2011-06-03	581452		0	0	0		0	0	0	99836	0	113	40213227		
51271	1123	40213296	2007-12-06	2007-12-06 00:00:00	2007-12-06	2007-12-06 00:00:00	2007-12-06	581452		0	0	0		0	0	0	73986	0	52	40213296		
14864	1245	1713671	1951-03-21	1951-03-21 00:00:00	1951-04-11	1951-04-11 00:00:00	1951-04-11	38000177		0	0	21		0	0	0	81949	0	562251	1713671		
52823	1155	40213260	2016-03-07	2016-03-07 00:00:00	2016-03-07	2016-03-07 00:00:00	2016-03-07	581452		0	0	0		0	0	0	76310	0	121	40213260		
36508	3011	1118084	2009-02-15	2009-02-15 00:00:00	2009-02-15	2009-02-15 00:00:00	\N	38000177		0	0	0		0	0	0	200813	0	00025152531	44923712		
2296	185	40169281	2014-06-01	2014-06-01 00:00:00	2014-06-01	2014-06-01 00:00:00	\N	38000177		0	0	0		0	0	0	12518	0	896209	40169281		
30012	2487	1127433	2007-12-27	2007-12-27 00:00:00	2008-01-03	2008-01-03 00:00:00	2008-01-03	38000177		0	0	7		0	0	0	164804	0	313782	1127433		
56597	1239	40213160	1975-06-05	1975-06-05 00:00:00	1975-06-05	1975-06-05 00:00:00	1975-06-05	581452		0	0	0		0	0	0	81633	0	10	40213160		
37240	3079	1118084	1972-11-26	1972-11-26 00:00:00	1972-11-26	1972-11-26 00:00:00	\N	38000177		0	0	0		0	0	0	204929	0	00025152531	44923712		
48833	4049	1127433	1973-08-29	1973-08-29 00:00:00	1973-09-12	1973-09-12 00:00:00	1973-09-12	38000177		0	0	14		0	0	0	269135	0	313782	1127433		
6526	549	920300	1989-10-19	1989-10-19 00:00:00	1989-10-26	1989-10-26 00:00:00	1989-10-26	38000177		0	0	7		0	0	0	36364	0	311989	920300		
81882	1788	40213227	2004-08-05	2004-08-05 00:00:00	2004-08-05	2004-08-05 00:00:00	2004-08-05	581452		0	0	0		0	0	0	119854	0	113	40213227		
52907	4395	1118084	1992-04-13	1992-04-13 00:00:00	1992-04-13	1992-04-13 00:00:00	\N	38000177		0	0	0		0	0	0	292252	0	00025152531	44923712		
59459	4942	19059056	1955-02-23	1955-02-23 00:00:00	1955-04-24	1955-04-24 00:00:00	1955-04-24	38000177		0	0	60		0	0	0	328460	0	243670	19059056		
13242	1110	1115171	2019-01-14	2019-01-14 00:00:00	2019-01-28	2019-01-28 00:00:00	2019-01-28	38000177		0	0	14		0	0	0	73084	0	849574	1115171		
58425	4852	40229134	1986-06-09	1986-06-09 00:00:00	1986-06-23	1986-06-23 00:00:00	1986-06-23	38000177		0	0	14		0	0	0	322786	0	1043400	40229134		
53471	4446	19059056	1964-05-08	1964-05-08 00:00:00	1964-05-29	1964-05-29 00:00:00	1964-05-29	38000177		0	0	21		0	0	0	295665	0	243670	19059056		
44926	978	40213314	1978-01-20	1978-01-20 00:00:00	1978-01-20	1978-01-20 00:00:00	1978-01-20	581452		0	0	0		0	0	0	65127	0	49	40213314		
50967	4235	19078461	2012-11-14	2012-11-14 00:00:00	2012-12-05	2012-12-05 00:00:00	2012-12-05	38000177		0	0	21		0	0	0	281213	0	310965	19078461		
6566	143	40213306	1986-11-16	1986-11-16 00:00:00	1986-11-16	1986-11-16 00:00:00	1986-11-16	581452		0	0	0		0	0	0	9604	0	43	40213306		
14995	1253	1713671	1984-12-13	1984-12-13 00:00:00	1985-01-03	1985-01-03 00:00:00	1985-01-03	38000177		0	0	21		0	0	0	82508	0	562251	1713671		
14227	307	40213160	1970-02-28	1970-02-28 00:00:00	1970-02-28	1970-02-28 00:00:00	1970-02-28	581452		0	0	0		0	0	0	20370	0	10	40213160		
61616	5127	19059056	1980-03-25	1980-03-25 00:00:00	1980-04-24	1980-04-24 00:00:00	1980-04-24	38000177		0	0	30		0	0	0	340894	0	243670	19059056		
12517	270	40213296	1998-07-14	1998-07-14 00:00:00	1998-07-14	1998-07-14 00:00:00	1998-07-14	581452		0	0	0		0	0	0	17969	0	52	40213296		
25622	558	40213296	2002-11-14	2002-11-14 00:00:00	2002-11-14	2002-11-14 00:00:00	2002-11-14	581452		0	0	0		0	0	0	37012	0	52	40213296		
20632	1699	1127433	2004-06-10	2004-06-10 00:00:00	2004-07-01	2004-07-01 00:00:00	2004-07-01	38000177		0	0	21		0	0	0	113615	0	313782	1127433		
65210	1427	40213160	1956-04-18	1956-04-18 00:00:00	1956-04-18	1956-04-18 00:00:00	1956-04-18	581452		0	0	0		0	0	0	94927	0	10	40213160		
52144	4337	1118084	2006-02-13	2006-02-13 00:00:00	2006-02-13	2006-02-13 00:00:00	\N	38000177		0	0	0		0	0	0	287624	0	00025152531	44923712		
53115	4412	19133905	1982-10-17	1982-10-17 00:00:00	1982-10-25	1982-10-25 00:00:00	1982-10-25	38000177		0	0	8		0	0	0	293341	0	834102	19133905		
31299	2594	19019979	1979-09-03	1979-09-03 00:00:00	1979-10-03	1979-10-03 00:00:00	1979-10-03	38000177		0	0	30		0	0	0	171726	0	198405	19019979		
13753	1149	1127433	1987-08-18	1987-08-18 00:00:00	1987-08-25	1987-08-25 00:00:00	1987-08-25	38000177		0	0	7		0	0	0	75959	0	313782	1127433		
19020	411	40213260	2009-02-21	2009-02-21 00:00:00	2009-02-21	2009-02-21 00:00:00	2009-02-21	581452		0	0	0		0	0	0	27358	0	121	40213260		
2351	188	19133905	2018-04-17	2018-04-17 00:00:00	2018-04-28	2018-04-28 00:00:00	2018-04-28	38000177		0	0	11		0	0	0	12788	0	834102	19133905		
40791	3382	19059056	1992-04-20	1992-04-20 00:00:00	1992-05-20	1992-05-20 00:00:00	1992-05-20	38000177		0	0	30		0	0	0	224401	0	243670	19059056		
24386	2006	19078461	2008-06-22	2008-06-22 00:00:00	2008-07-13	2008-07-13 00:00:00	2008-07-13	38000177		0	0	21		0	0	0	133605	0	310965	19078461		
108701	2384	40213251	1988-03-01	1988-03-01 00:00:00	1988-03-01	1988-03-01 00:00:00	1988-03-01	581452		0	0	0		0	0	0	158494	0	21	40213251		
18482	1529	40229134	2001-06-10	2001-06-10 00:00:00	2001-06-24	2001-06-24 00:00:00	2001-06-24	38000177		0	0	14		0	0	0	102365	0	1043400	40229134		
48757	4040	19133873	1981-02-13	1981-02-13 00:00:00	1981-02-25	1981-02-25 00:00:00	1981-02-25	38000177		0	0	12		0	0	0	268702	0	834061	19133873		
63095	5241	19128065	1984-02-10	1984-02-10 00:00:00	1985-02-04	1985-02-04 00:00:00	1985-02-04	38000177		0	0	360		0	0	0	348787	0	749882	19128065		
1938	154	1127433	1990-01-14	1990-01-14 00:00:00	1990-01-28	1990-01-28 00:00:00	1990-01-28	38000177		0	0	14		0	0	0	10472	0	313782	1127433		
63170	5249	19129655	1963-05-20	1963-05-20 00:00:00	1963-06-03	1963-06-03 00:00:00	1963-06-03	38000177		0	0	14		0	0	0	349160	0	789980	19129655		
227243	4990	40213296	2002-08-07	2002-08-07 00:00:00	2002-08-07	2002-08-07 00:00:00	2002-08-07	581452		0	0	0		0	0	0	\N	0	52	40213296		
24976	2053	19006318	1954-10-06	1954-10-06 00:00:00	1954-10-20	1954-10-20 00:00:00	1954-10-20	38000177		0	0	14		0	0	0	136549	0	105078	19006318		
20913	1724	19006318	1954-11-15	1954-11-15 00:00:00	1954-11-29	1954-11-29 00:00:00	1954-11-29	38000177		0	0	14		0	0	0	115245	0	105078	19006318		
35425	2919	40220960	1996-06-15	1996-06-15 00:00:00	1996-06-15	1996-06-15 00:00:00	1996-06-15	38000177		0	0	0		0	0	0	194646	0	1804799	40220960		
64018	5317	1127433	2006-03-01	2006-03-01 00:00:00	2006-03-08	2006-03-08 00:00:00	2006-03-08	38000177		0	0	7		0	0	0	353653	0	313782	1127433		
8426	703	1127433	2009-05-04	2009-05-04 00:00:00	2009-05-18	2009-05-18 00:00:00	2009-05-18	38000177		0	0	14		0	0	0	46438	0	313782	1127433		
12717	1072	19078461	2019-04-20	2019-04-20 00:00:00	2019-05-04	2019-05-04 00:00:00	2019-05-04	38000177		0	0	14		0	0	0	70289	0	310965	19078461		
18995	1569	19078461	2003-12-22	2003-12-22 00:00:00	2004-01-12	2004-01-12 00:00:00	2004-01-12	38000177		0	0	21		0	0	0	105230	0	310965	19078461		
48301	1057	40213160	1966-06-30	1966-06-30 00:00:00	1966-06-30	1966-06-30 00:00:00	1966-06-30	581452		0	0	0		0	0	0	69331	0	10	40213160		
30785	2551	1127433	1985-10-29	1985-10-29 00:00:00	1985-11-05	1985-11-05 00:00:00	1985-11-05	38000177		0	0	7		0	0	0	168909	0	313782	1127433		
52636	4376	19133905	1951-05-01	1951-05-01 00:00:00	1951-05-12	1951-05-12 00:00:00	1951-05-12	38000177		0	0	11		0	0	0	290743	0	834102	19133905		
44395	3675	1713671	1978-03-14	1978-03-14 00:00:00	1978-07-18	1978-07-18 00:00:00	1978-07-18	38000177		0	0	126		0	0	0	244409	0	562251	1713671		
26541	578	40213260	2017-11-29	2017-11-29 00:00:00	2017-11-29	2017-11-29 00:00:00	2017-11-29	581452		0	0	0		0	0	0	38213	0	121	40213260		
7101	154	40213160	1975-02-27	1975-02-27 00:00:00	1975-02-27	1975-02-27 00:00:00	1975-02-27	581452		0	0	0		0	0	0	10447	0	10	40213160		
145482	3199	40213227	2004-06-16	2004-06-16 00:00:00	2004-06-16	2004-06-16 00:00:00	2004-06-16	581452		0	0	0		0	0	0	212777	0	113	40213227		
12109	1016	19128065	1986-05-15	1986-05-15 00:00:00	1987-05-10	1987-05-10 00:00:00	1987-05-10	38000177		0	0	360		0	0	0	66909	0	749882	19128065		
152309	3352	40213260	2014-10-24	2014-10-24 00:00:00	2014-10-24	2014-10-24 00:00:00	2014-10-24	581452		0	0	0		0	0	0	222322	0	121	40213260		
63973	1399	40213160	1960-12-07	1960-12-07 00:00:00	1960-12-07	1960-12-07 00:00:00	1960-12-07	581452		0	0	0		0	0	0	93127	0	10	40213160		
157586	3469	40213160	1957-09-11	1957-09-11 00:00:00	1957-09-11	1957-09-11 00:00:00	1957-09-11	581452		0	0	0		0	0	0	230282	0	10	40213160		
57943	4814	19059056	1946-11-13	1946-11-13 00:00:00	1946-12-04	1946-12-04 00:00:00	1946-12-04	38000177		0	0	21		0	0	0	320245	0	243670	19059056		
6465	545	40165015	2015-10-16	2015-10-16 00:00:00	2015-10-16	2015-10-16 00:00:00	\N	38000177		0	0	0		0	0	0	36146	0	861467	40165015		
58035	4822	964261	1993-09-12	1993-09-12 00:00:00	1993-09-12	1993-09-12 00:00:00	\N	38000177		0	0	0		0	0	0	320747	0	2001499	964261		
59772	4970	19008572	1946-04-20	1946-04-20 00:00:00	1946-04-20	1946-04-20 00:00:00	\N	38000177		0	0	0		0	0	0	330381	0	106258	19008572		
68398	1497	40213227	1992-03-20	1992-03-20 00:00:00	1992-03-20	1992-03-20 00:00:00	1992-03-20	581452		0	0	0		0	0	0	99830	0	113	40213227		
51273	1123	40213227	2007-12-06	2007-12-06 00:00:00	2007-12-06	2007-12-06 00:00:00	2007-12-06	581452		0	0	0		0	0	0	73986	0	113	40213227		
14865	1245	1118084	1976-09-06	1976-09-06 00:00:00	1976-09-06	1976-09-06 00:00:00	\N	38000177		0	0	0		0	0	0	81890	0	00025152531	44923712		
52829	1155	40213160	1966-08-01	1966-08-01 00:00:00	1966-08-01	1966-08-01 00:00:00	1966-08-01	581452		0	0	0		0	0	0	76321	0	10	40213160		
36509	3011	1127433	2014-05-12	2014-05-12 00:00:00	2014-05-19	2014-05-19 00:00:00	2014-05-19	38000177		0	0	7		0	0	0	200854	0	313782	1127433		
2297	185	19059056	1948-08-16	1948-08-16 00:00:00	1948-08-30	1948-08-30 00:00:00	1948-08-30	38000177		0	0	14		0	0	0	12571	0	243670	19059056		
30013	2487	1127433	1986-05-17	1986-05-17 00:00:00	1986-05-24	1986-05-24 00:00:00	1986-05-24	38000177		0	0	7		0	0	0	164761	0	313782	1127433		
56600	1239	40213227	2012-03-08	2012-03-08 00:00:00	2012-03-08	2012-03-08 00:00:00	2012-03-08	581452		0	0	0		0	0	0	81681	0	113	40213227		
37241	3079	19073188	2014-04-04	2014-04-04 00:00:00	2014-05-09	2014-05-09 00:00:00	2014-05-09	38000177		0	0	35		0	0	0	204966	0	308192	19073188		
48834	4049	19133905	2018-03-01	2018-03-01 00:00:00	2018-03-12	2018-03-12 00:00:00	2018-03-12	38000177		0	0	11		0	0	0	269131	0	834102	19133905		
6527	549	920334	1986-09-07	1986-09-07 00:00:00	1986-09-14	1986-09-14 00:00:00	1986-09-14	38000177		0	0	7		0	0	0	36353	0	311995	920334		
81883	1788	40213296	2004-08-05	2004-08-05 00:00:00	2004-08-05	2004-08-05 00:00:00	2004-08-05	581452		0	0	0		0	0	0	119854	0	52	40213296		
52908	4395	19133905	2018-05-31	2018-05-31 00:00:00	2018-06-08	2018-06-08 00:00:00	2018-06-08	38000177		0	0	8		0	0	0	292214	0	834102	19133905		
59460	4942	1127078	1957-03-14	1957-03-14 00:00:00	1957-03-28	1957-03-28 00:00:00	1957-03-28	38000177		0	0	14		0	0	0	328461	0	282464	1127078		
13243	1110	1127433	2002-08-27	2002-08-27 00:00:00	2002-09-10	2002-09-10 00:00:00	2002-09-10	38000177		0	0	14		0	0	0	73078	0	313782	1127433		
58426	4853	1127433	2018-09-06	2018-09-06 00:00:00	2018-09-20	2018-09-20 00:00:00	2018-09-20	38000177		0	0	14		0	0	0	322929	0	313782	1127433		
53472	4446	1115171	2014-06-20	2014-06-20 00:00:00	2014-07-04	2014-07-04 00:00:00	2014-07-04	38000177		0	0	14		0	0	0	295667	0	849574	1115171		
56208	1231	40213227	2010-06-03	2010-06-03 00:00:00	2010-06-03	2010-06-03 00:00:00	2010-06-03	581452		0	0	0		0	0	0	81080	0	113	40213227		
50968	4235	1115171	2007-03-09	2007-03-09 00:00:00	2007-04-15	2007-04-15 00:00:00	2007-04-15	38000177		0	0	37		0	0	0	281212	0	849574	1115171		
6568	143	40213260	2015-11-08	2015-11-08 00:00:00	2015-11-08	2015-11-08 00:00:00	2015-11-08	581452		0	0	0		0	0	0	9564	0	121	40213260		
14996	1253	1127433	1970-12-16	1970-12-16 00:00:00	1970-12-23	1970-12-23 00:00:00	1970-12-23	38000177		0	0	7		0	0	0	82561	0	313782	1127433		
14229	307	40213160	1974-06-01	1974-06-01 00:00:00	1974-06-01	1974-06-01 00:00:00	1974-06-01	581452		0	0	0		0	0	0	20348	0	10	40213160		
61617	5128	1713671	2005-08-12	2005-08-12 00:00:00	2005-09-02	2005-09-02 00:00:00	2005-09-02	38000177		0	0	21		0	0	0	340962	0	562251	1713671		
12522	270	40213160	1958-05-13	1958-05-13 00:00:00	1958-05-13	1958-05-13 00:00:00	1958-05-13	581452		0	0	0		0	0	0	17992	0	10	40213160		
25623	558	40213160	1961-07-13	1961-07-13 00:00:00	1961-07-13	1961-07-13 00:00:00	1961-07-13	581452		0	0	0		0	0	0	36974	0	10	40213160		
20633	1699	1115171	2005-07-26	2005-07-26 00:00:00	2005-09-24	2005-09-24 00:00:00	2005-09-24	38000177		0	0	60		0	0	0	113616	0	849574	1115171		
65211	1427	40213160	1960-10-19	1960-10-19 00:00:00	1960-10-19	1960-10-19 00:00:00	1960-10-19	581452		0	0	0		0	0	0	94898	0	10	40213160		
52145	4337	40220960	1991-02-22	1991-02-22 00:00:00	1991-02-22	1991-02-22 00:00:00	1991-02-22	38000177		0	0	0		0	0	0	287563	0	1804799	40220960		
53116	4412	40165015	2000-09-21	2000-09-21 00:00:00	2000-09-21	2000-09-21 00:00:00	\N	38000177		0	0	0		0	0	0	293364	0	861467	40165015		
31300	2594	1713671	1984-07-30	1984-07-30 00:00:00	1984-08-20	1984-08-20 00:00:00	1984-08-20	38000177		0	0	21		0	0	0	171711	0	562251	1713671		
13754	1149	1118084	2013-08-09	2013-08-09 00:00:00	2013-08-09	2013-08-09 00:00:00	\N	38000177		0	0	0		0	0	0	75964	0	00025152531	44923712		
19025	412	40213160	1955-10-21	1955-10-21 00:00:00	1955-10-21	1955-10-21 00:00:00	1955-10-21	581452		0	0	0		0	0	0	27456	0	10	40213160		
2352	188	1713671	1997-04-13	1997-04-13 00:00:00	1997-04-27	1997-04-27 00:00:00	1997-04-27	38000177		0	0	14		0	0	0	12794	0	562251	1713671		
40792	3382	40229134	1978-11-01	1978-11-01 00:00:00	1978-11-08	1978-11-08 00:00:00	1978-11-08	38000177		0	0	7		0	0	0	224413	0	1043400	40229134		
24387	2006	1124300	1986-01-28	1986-01-28 00:00:00	1986-01-28	1986-01-28 00:00:00	\N	38000177		0	0	0		0	0	0	133550	0	00781178901	45011828		
108704	2384	40213227	2006-10-24	2006-10-24 00:00:00	2006-10-24	2006-10-24 00:00:00	2006-10-24	581452		0	0	0		0	0	0	158492	0	113	40213227		
18483	1529	1127433	2010-04-19	2010-04-19 00:00:00	2010-05-03	2010-05-03 00:00:00	2010-05-03	38000177		0	0	14		0	0	0	102321	0	313782	1127433		
48758	4040	19078461	1994-08-17	1994-08-17 00:00:00	1994-09-21	1994-09-21 00:00:00	1994-09-21	38000177		0	0	35		0	0	0	268661	0	310965	19078461		
63097	5241	19073188	1981-10-21	1981-10-21 00:00:00	1981-11-04	1981-11-04 00:00:00	1981-11-04	38000177		0	0	14		0	0	0	348722	0	308192	19073188		
1939	155	19078461	1985-09-21	1985-09-21 00:00:00	1985-10-05	1985-10-05 00:00:00	1985-10-05	38000177		0	0	14		0	0	0	10528	0	310965	19078461		
63171	5249	19059056	1963-05-20	1963-05-20 00:00:00	1963-06-03	1963-06-03 00:00:00	1963-06-03	38000177		0	0	14		0	0	0	349160	0	243670	19059056		
227250	4990	40213227	2013-01-30	2013-01-30 00:00:00	2013-01-30	2013-01-30 00:00:00	2013-01-30	581452		0	0	0		0	0	0	331999	0	113	40213227		
24977	2053	19059056	1954-10-06	1954-10-06 00:00:00	1954-10-20	1954-10-20 00:00:00	1954-10-20	38000177		0	0	14		0	0	0	136549	0	243670	19059056		
20914	1724	19059056	1954-11-15	1954-11-15 00:00:00	1954-11-29	1954-11-29 00:00:00	1954-11-29	38000177		0	0	14		0	0	0	115245	0	243670	19059056		
35426	2919	19133905	2007-12-09	2007-12-09 00:00:00	2007-12-20	2007-12-20 00:00:00	2007-12-20	38000177		0	0	11		0	0	0	194578	0	834102	19133905		
64019	5317	1127433	2012-08-31	2012-08-31 00:00:00	2012-09-14	2012-09-14 00:00:00	2012-09-14	38000177		0	0	14		0	0	0	353654	0	313782	1127433		
8427	703	19059056	1974-04-16	1974-04-16 00:00:00	1974-05-21	1974-05-21 00:00:00	1974-05-21	38000177		0	0	35		0	0	0	46509	0	243670	19059056		
12718	1072	1127433	1979-01-12	1979-01-12 00:00:00	1979-01-26	1979-01-26 00:00:00	1979-01-26	38000177		0	0	14		0	0	0	70248	0	313782	1127433		
18996	1569	19073188	2003-12-22	2003-12-22 00:00:00	2004-01-12	2004-01-12 00:00:00	2004-01-12	38000177		0	0	21		0	0	0	105230	0	308192	19073188		
88305	1937	40213160	1968-02-20	1968-02-20 00:00:00	1968-02-20	1968-02-20 00:00:00	1968-02-20	581452		0	0	0		0	0	0	128894	0	10	40213160		
30786	2551	1127433	2014-12-22	2014-12-22 00:00:00	2015-01-05	2015-01-05 00:00:00	2015-01-05	38000177		0	0	14		0	0	0	168867	0	313782	1127433		
52637	4376	1713671	1953-02-28	1953-02-28 00:00:00	1953-03-14	1953-03-14 00:00:00	1953-03-14	38000177		0	0	14		0	0	0	290762	0	562251	1713671		
44396	3675	1713671	2012-02-26	2012-02-26 00:00:00	2012-03-18	2012-03-18 00:00:00	2012-03-18	38000177		0	0	21		0	0	0	244413	0	562251	1713671		
14605	1223	19073188	2010-11-24	2010-11-24 00:00:00	2010-12-08	2010-12-08 00:00:00	2010-12-08	38000177		0	0	14		0	0	0	80456	0	308192	19073188		
7104	154	40213227	1997-02-20	1997-02-20 00:00:00	1997-02-20	1997-02-20 00:00:00	1997-02-20	581452		0	0	0		0	0	0	10486	0	113	40213227		
145490	3199	40213227	1995-06-07	1995-06-07 00:00:00	1995-06-07	1995-06-07 00:00:00	1995-06-07	581452		0	0	0		0	0	0	212774	0	113	40213227		
12110	1016	1127433	2009-06-15	2009-06-15 00:00:00	2009-06-22	2009-06-22 00:00:00	2009-06-22	38000177		0	0	7		0	0	0	66908	0	313782	1127433		
152322	3353	40213227	2016-03-19	2016-03-19 00:00:00	2016-03-19	2016-03-19 00:00:00	2016-03-19	581452		0	0	0		0	0	0	222412	0	113	40213227		
63977	1399	40213260	2010-06-30	2010-06-30 00:00:00	2010-06-30	2010-06-30 00:00:00	2010-06-30	581452		0	0	0		0	0	0	93052	0	121	40213260		
157588	3469	40213201	2018-10-17	2018-10-17 00:00:00	2018-10-17	2018-10-17 00:00:00	2018-10-17	581452		0	0	0		0	0	0	230271	0	33	40213201		
57944	4814	19059056	1946-01-03	1946-01-03 00:00:00	1946-01-17	1946-01-17 00:00:00	1946-01-17	38000177		0	0	14		0	0	0	320244	0	243670	19059056		
6466	545	19078461	2015-10-16	2015-10-16 00:00:00	2016-01-14	2016-01-14 00:00:00	2016-01-14	38000177		0	0	90		0	0	0	36146	0	310965	19078461		
58037	4822	1124300	1987-07-31	1987-07-31 00:00:00	1987-07-31	1987-07-31 00:00:00	\N	38000177		0	0	0		0	0	0	320787	0	00781178901	45011828		
59773	4970	1713671	1980-04-18	1980-04-18 00:00:00	1980-04-25	1980-04-25 00:00:00	1980-04-25	38000177		0	0	7		0	0	0	330360	0	562251	1713671		
68420	1498	40213306	1987-10-20	1987-10-20 00:00:00	1987-10-20	1987-10-20 00:00:00	1987-10-20	581452		0	0	0		0	0	0	\N	0	43	40213306		
51280	1123	40213160	1966-02-03	1966-02-03 00:00:00	1966-02-03	1966-02-03 00:00:00	1966-02-03	581452		0	0	0		0	0	0	74022	0	10	40213160		
14866	1245	1115171	2008-08-08	2008-08-08 00:00:00	2008-11-06	2008-11-06 00:00:00	2008-11-06	38000177		0	0	90		0	0	0	81905	0	849574	1115171		
152870	3365	40213160	1969-06-27	1969-06-27 00:00:00	1969-06-27	1969-06-27 00:00:00	1969-06-27	581452		0	0	0		0	0	0	223185	0	10	40213160		
36510	3011	19128022	1989-06-30	1989-06-30 00:00:00	1990-06-25	1990-06-25 00:00:00	1990-06-25	38000177		0	0	360		0	0	0	200839	0	749785	19128022		
2298	185	19006318	1948-08-16	1948-08-16 00:00:00	1948-08-30	1948-08-30 00:00:00	1948-08-30	38000177		0	0	14		0	0	0	12571	0	105078	19006318		
30014	2487	1127433	2003-12-22	2003-12-22 00:00:00	2004-01-05	2004-01-05 00:00:00	2004-01-05	38000177		0	0	14		0	0	0	164791	0	313782	1127433		
56601	1239	40213296	2012-03-08	2012-03-08 00:00:00	2012-03-08	2012-03-08 00:00:00	2012-03-08	581452		0	0	0		0	0	0	81681	0	52	40213296		
37242	3079	1127433	2014-04-04	2014-04-04 00:00:00	2014-05-09	2014-05-09 00:00:00	2014-05-09	38000177		0	0	35		0	0	0	204966	0	313782	1127433		
48835	4049	19007333	1991-03-28	1991-03-28 00:00:00	1995-05-06	1995-05-06 00:00:00	1995-05-06	38000177		0	0	1500		0	0	0	269127	0	105586	19007333		
6528	549	1118084	1987-12-04	1987-12-04 00:00:00	1987-12-04	1987-12-04 00:00:00	\N	38000177		0	0	0		0	0	0	36387	0	00025152531	44923712		
81885	1788	40213227	1994-07-21	1994-07-21 00:00:00	1994-07-21	1994-07-21 00:00:00	1994-07-21	581452		0	0	0		0	0	0	119784	0	113	40213227		
52925	4398	1127078	1970-08-23	1970-08-23 00:00:00	1970-11-21	1970-11-21 00:00:00	1970-11-21	38000177		0	0	90		0	0	0	292432	0	282464	1127078		
59461	4942	1127433	1989-12-16	1989-12-16 00:00:00	1989-12-23	1989-12-23 00:00:00	1989-12-23	38000177		0	0	7		0	0	0	328504	0	313782	1127433		
13247	1112	1127433	1990-11-05	1990-11-05 00:00:00	1990-11-12	1990-11-12 00:00:00	1990-11-12	38000177		0	0	7		0	0	0	73168	0	313782	1127433		
58427	4853	1127433	1978-04-15	1978-04-15 00:00:00	1978-05-06	1978-05-06 00:00:00	1978-05-06	38000177		0	0	21		0	0	0	322912	0	313782	1127433		
53473	4446	19059056	1963-04-14	1963-04-14 00:00:00	1963-04-28	1963-04-28 00:00:00	1963-04-28	38000177		0	0	14		0	0	0	295685	0	243670	19059056		
56212	1231	40213227	1992-02-19	1992-02-19 00:00:00	1992-02-19	1992-02-19 00:00:00	1992-02-19	581452		0	0	0		0	0	0	81158	0	113	40213227		
50969	4235	40229134	2011-05-13	2011-05-13 00:00:00	2011-05-20	2011-05-20 00:00:00	2011-05-20	38000177		0	0	7		0	0	0	281216	0	1043400	40229134		
6570	143	40213227	2015-11-08	2015-11-08 00:00:00	2015-11-08	2015-11-08 00:00:00	2015-11-08	581452		0	0	0		0	0	0	9564	0	113	40213227		
14997	1253	1127433	2012-04-20	2012-04-20 00:00:00	2012-05-04	2012-05-04 00:00:00	2012-05-04	38000177		0	0	14		0	0	0	82517	0	313782	1127433		
22131	1819	19078461	2007-02-14	2007-02-14 00:00:00	2007-03-14	2007-03-14 00:00:00	2007-03-14	38000177		0	0	28		0	0	0	121685	0	310965	19078461		
61618	5128	1713671	1930-11-24	1930-11-24 00:00:00	1930-12-15	1930-12-15 00:00:00	1930-12-15	38000177		0	0	21		0	0	0	340955	0	562251	1713671		
12528	270	40213227	2009-02-10	2009-02-10 00:00:00	2009-02-10	2009-02-10 00:00:00	2009-02-10	581452		0	0	0		0	0	0	18011	0	113	40213227		
25626	558	40213160	1961-02-09	1961-02-09 00:00:00	1961-02-09	1961-02-09 00:00:00	1961-02-09	581452		0	0	0		0	0	0	36973	0	10	40213160		
20634	1699	19059056	1982-04-09	1982-04-09 00:00:00	1982-05-07	1982-05-07 00:00:00	1982-05-07	38000177		0	0	28		0	0	0	113614	0	243670	19059056		
65217	1427	40213160	1956-07-18	1956-07-18 00:00:00	1956-07-18	1956-07-18 00:00:00	1956-07-18	581452		0	0	0		0	0	0	94935	0	10	40213160		
52146	4337	19059056	1963-03-31	1963-03-31 00:00:00	1963-04-21	1963-04-21 00:00:00	1963-04-21	38000177		0	0	21		0	0	0	287613	0	243670	19059056		
53117	4412	1127433	1989-01-31	1989-01-31 00:00:00	1989-02-14	1989-02-14 00:00:00	1989-02-14	38000177		0	0	14		0	0	0	293284	0	313782	1127433		
31301	2594	19074843	1980-11-08	1980-11-08 00:00:00	1980-11-22	1980-11-22 00:00:00	1980-11-22	38000177		0	0	14		0	0	0	171683	0	309045	19074843		
13755	1149	1115171	2004-12-21	2004-12-21 00:00:00	2005-01-04	2005-01-04 00:00:00	2005-01-04	38000177		0	0	14		0	0	0	75946	0	849574	1115171		
19028	412	40213227	2004-05-21	2004-05-21 00:00:00	2004-05-21	2004-05-21 00:00:00	2004-05-21	581452		0	0	0		0	0	0	27423	0	113	40213227		
2353	188	19078461	1975-09-11	1975-09-11 00:00:00	1975-09-25	1975-09-25 00:00:00	1975-09-25	38000177		0	0	14		0	0	0	12783	0	310965	19078461		
40794	3382	1118084	2003-08-29	2003-08-29 00:00:00	2003-08-29	2003-08-29 00:00:00	\N	38000177		0	0	0		0	0	0	224424	0	00025152531	44923712		
24388	2006	40174880	2017-12-31	2017-12-31 00:00:00	2017-12-31	2017-12-31 00:00:00	\N	38000177		0	0	0		0	0	0	133644	0	966222	40174880		
108705	2384	40213306	2006-10-24	2006-10-24 00:00:00	2006-10-24	2006-10-24 00:00:00	2006-10-24	581452		0	0	0		0	0	0	158492	0	43	40213306		
18484	1529	19059056	1967-07-06	1967-07-06 00:00:00	1967-09-04	1967-09-04 00:00:00	1967-09-04	38000177		0	0	60		0	0	0	102352	0	243670	19059056		
48759	4040	1713671	2005-11-20	2005-11-20 00:00:00	2005-12-04	2005-12-04 00:00:00	2005-12-04	38000177		0	0	14		0	0	0	268684	0	562251	1713671		
63098	5241	19059056	1981-10-21	1981-10-21 00:00:00	1981-11-04	1981-11-04 00:00:00	1981-11-04	38000177		0	0	14		0	0	0	348722	0	243670	19059056		
1940	155	1127433	2011-05-22	2011-05-22 00:00:00	2011-06-19	2011-06-19 00:00:00	2011-06-19	38000177		0	0	28		0	0	0	10530	0	313782	1127433		
63172	5249	19059056	1951-08-21	1951-08-21 00:00:00	1951-11-19	1951-11-19 00:00:00	1951-11-19	38000177		0	0	90		0	0	0	349244	0	243670	19059056		
227251	4990	40213260	2013-01-30	2013-01-30 00:00:00	2013-01-30	2013-01-30 00:00:00	2013-01-30	581452		0	0	0		0	0	0	331999	0	121	40213260		
24978	2053	1124300	1993-11-04	1993-11-04 00:00:00	1993-11-04	1993-11-04 00:00:00	\N	38000177		0	0	0		0	0	0	136492	0	00781178901	45011828		
20915	1724	19078461	2019-02-01	2019-02-01 00:00:00	2019-02-22	2019-02-22 00:00:00	2019-02-22	38000177		0	0	21		0	0	0	115303	0	310965	19078461		
35427	2919	40165015	2018-03-21	2018-03-21 00:00:00	2018-03-21	2018-03-21 00:00:00	\N	38000177		0	0	0		0	0	0	194613	0	861467	40165015		
64020	5317	1127078	1981-04-23	1981-04-23 00:00:00	1981-05-07	1981-05-07 00:00:00	1981-05-07	38000177		0	0	14		0	0	0	353645	0	282464	1127078		
8428	703	1127078	1952-02-11	1952-02-11 00:00:00	1952-04-11	1952-04-11 00:00:00	1952-04-11	38000177		0	0	60		0	0	0	46507	0	282464	1127078		
12719	1072	19133905	1987-07-22	1987-07-22 00:00:00	1987-07-29	1987-07-29 00:00:00	1987-07-29	38000177		0	0	7		0	0	0	70250	0	834102	19133905		
18997	1569	19133905	2006-06-15	2006-06-15 00:00:00	2006-06-22	2006-06-22 00:00:00	2006-06-22	38000177		0	0	7		0	0	0	105272	0	834102	19133905		
88308	1937	40213227	2005-05-24	2005-05-24 00:00:00	2005-05-24	2005-05-24 00:00:00	2005-05-24	581452		0	0	0		0	0	0	128900	0	113	40213227		
30787	2551	1115171	2016-09-06	2016-09-06 00:00:00	2016-10-04	2016-10-04 00:00:00	2016-10-04	38000177		0	0	28		0	0	0	168906	0	849574	1115171		
52638	4376	1115171	1999-06-12	1999-06-12 00:00:00	1999-08-18	1999-08-18 00:00:00	1999-08-18	38000177		0	0	67		0	0	0	290734	0	849574	1115171		
44397	3675	1127433	1970-03-03	1970-03-03 00:00:00	1970-03-17	1970-03-17 00:00:00	1970-03-17	38000177		0	0	14		0	0	0	244431	0	313782	1127433		
25067	2062	1127078	1951-04-23	1951-04-23 00:00:00	1951-05-28	1951-05-28 00:00:00	1951-05-28	38000177		0	0	35		0	0	0	137161	0	282464	1127078		
7105	154	40213306	1997-02-20	1997-02-20 00:00:00	1997-02-20	1997-02-20 00:00:00	1997-02-20	581452		0	0	0		0	0	0	10486	0	43	40213306		
145491	3199	40213306	1995-06-07	1995-06-07 00:00:00	1995-06-07	1995-06-07 00:00:00	1995-06-07	581452		0	0	0		0	0	0	212774	0	43	40213306		
12111	1016	19133905	1996-03-16	1996-03-16 00:00:00	1996-03-23	1996-03-23 00:00:00	1996-03-23	38000177		0	0	7		0	0	0	66897	0	834102	19133905		
163608	3599	40213227	1998-03-13	1998-03-13 00:00:00	1998-03-13	1998-03-13 00:00:00	1998-03-13	581452		0	0	0		0	0	0	239041	0	113	40213227		
193886	4260	40213201	2003-04-08	2003-04-08 00:00:00	2003-04-08	2003-04-08 00:00:00	2003-04-08	581452		0	0	0		0	0	0	282846	0	33	40213201		
157591	3469	40213227	1994-03-23	1994-03-23 00:00:00	1994-03-23	1994-03-23 00:00:00	1994-03-23	581452		0	0	0		0	0	0	230264	0	113	40213227		
57945	4814	40173590	2016-08-15	2016-08-15 00:00:00	2016-08-15	2016-08-15 00:00:00	\N	38000177		0	0	0		0	0	0	320266	0	904419	40173590		
6467	545	19128065	1985-10-05	1985-10-05 00:00:00	1986-09-30	1986-09-30 00:00:00	1986-09-30	38000177		0	0	360		0	0	0	36066	0	749882	19128065		
58038	4822	40229134	2018-06-01	2018-06-01 00:00:00	2018-06-15	2018-06-15 00:00:00	2018-06-15	38000177		0	0	14		0	0	0	320716	0	1043400	40229134		
59774	4970	1124300	1958-11-25	1958-11-25 00:00:00	1958-11-25	1958-11-25 00:00:00	\N	38000177		0	0	0		0	0	0	330350	0	00781178901	45011828		
68424	1498	40213160	1969-02-24	1969-02-24 00:00:00	1969-02-24	1969-02-24 00:00:00	1969-02-24	581452		0	0	0		0	0	0	99953	0	10	40213160		
51281	1123	40213160	1970-05-07	1970-05-07 00:00:00	1970-05-07	1970-05-07 00:00:00	1970-05-07	581452		0	0	0		0	0	0	74009	0	10	40213160		
14867	1245	19059056	1986-06-30	1986-06-30 00:00:00	1986-08-04	1986-08-04 00:00:00	1986-08-04	38000177		0	0	35		0	0	0	81902	0	243670	19059056		
152876	3365	40213260	2015-07-24	2015-07-24 00:00:00	2015-07-24	2015-07-24 00:00:00	2015-07-24	581452		0	0	0		0	0	0	223197	0	121	40213260		
36511	3011	19019979	1978-01-19	1978-01-19 00:00:00	1978-02-02	1978-02-02 00:00:00	1978-02-02	38000177		0	0	14		0	0	0	200801	0	198405	19019979		
2299	185	1713671	1947-04-12	1947-04-12 00:00:00	1947-05-03	1947-05-03 00:00:00	1947-05-03	38000177		0	0	21		0	0	0	12523	0	562251	1713671		
30015	2487	19133873	1961-04-17	1961-04-17 00:00:00	1961-04-29	1961-04-29 00:00:00	1961-04-29	38000177		0	0	12		0	0	0	164785	0	834061	19133873		
123773	2721	40213160	1972-10-21	1972-10-21 00:00:00	1972-10-21	1972-10-21 00:00:00	1972-10-21	581452		0	0	0		0	0	0	180355	0	10	40213160		
37243	3079	40231925	2014-04-04	2014-04-04 00:00:00	2014-04-04	2014-04-04 00:00:00	\N	38000177		0	0	0		0	0	0	204966	0	1049221	40231925		
48836	4049	19019273	1991-03-28	1991-03-28 00:00:00	1991-03-28	1991-03-28 00:00:00	\N	38000177		0	0	0		0	0	0	269127	0	198014	19019273		
6529	550	40229134	1974-10-25	1974-10-25 00:00:00	1974-11-08	1974-11-08 00:00:00	1974-11-08	38000177		0	0	14		0	0	0	36491	0	1043400	40229134		
81889	1789	40213296	2015-05-28	2015-05-28 00:00:00	2015-05-28	2015-05-28 00:00:00	2015-05-28	581452		0	0	0		0	0	0	\N	0	52	40213296		
52926	4398	1127433	1996-09-05	1996-09-05 00:00:00	1996-09-19	1996-09-19 00:00:00	1996-09-19	38000177		0	0	14		0	0	0	292448	0	313782	1127433		
59462	4942	1127433	1972-11-04	1972-11-04 00:00:00	1972-11-25	1972-11-25 00:00:00	1972-11-25	38000177		0	0	21		0	0	0	328463	0	313782	1127433		
13248	1112	1124300	2007-06-03	2007-06-03 00:00:00	2007-06-03	2007-06-03 00:00:00	\N	38000177		0	0	0		0	0	0	73229	0	00781178901	45011828		
58428	4853	19133873	1965-08-22	1965-08-22 00:00:00	1965-09-04	1965-09-04 00:00:00	1965-09-04	38000177		0	0	13		0	0	0	322868	0	834061	19133873		
53474	4446	19129655	1963-04-14	1963-04-14 00:00:00	1963-04-28	1963-04-28 00:00:00	1963-04-28	38000177		0	0	14		0	0	0	295685	0	789980	19129655		
127930	2813	40213227	1995-09-01	1995-09-01 00:00:00	1995-09-01	1995-09-01 00:00:00	1995-09-01	581452		0	0	0		0	0	0	186456	0	113	40213227		
50970	4235	40229134	1995-06-06	1995-06-06 00:00:00	1995-06-20	1995-06-20 00:00:00	1995-06-20	38000177		0	0	14		0	0	0	281168	0	1043400	40229134		
6575	143	40213160	1965-02-07	1965-02-07 00:00:00	1965-02-07	1965-02-07 00:00:00	1965-02-07	581452		0	0	0		0	0	0	9587	0	10	40213160		
15000	1253	19128065	1977-01-22	1977-01-22 00:00:00	1978-01-17	1978-01-17 00:00:00	1978-01-17	38000177		0	0	360		0	0	0	82495	0	749882	19128065		
22132	1819	19128065	1992-05-15	1992-05-15 00:00:00	1993-05-10	1993-05-10 00:00:00	1993-05-10	38000177		0	0	360		0	0	0	121679	0	749882	19128065		
61619	5128	19059056	1943-05-14	1943-05-14 00:00:00	1943-05-28	1943-05-28 00:00:00	1943-05-28	38000177		0	0	14		0	0	0	340917	0	243670	19059056		
12529	270	40213260	2009-02-10	2009-02-10 00:00:00	2009-02-10	2009-02-10 00:00:00	2009-02-10	581452		0	0	0		0	0	0	18011	0	121	40213260		
25629	559	40213160	1969-03-31	1969-03-31 00:00:00	1969-03-31	1969-03-31 00:00:00	1969-03-31	581452		0	0	0		0	0	0	37080	0	10	40213160		
20650	1702	40229134	2003-09-27	2003-09-27 00:00:00	2003-10-04	2003-10-04 00:00:00	2003-10-04	38000177		0	0	7		0	0	0	113804	0	1043400	40229134		
65232	1428	40213227	2005-11-08	2005-11-08 00:00:00	2005-11-08	2005-11-08 00:00:00	2005-11-08	581452		0	0	0		0	0	0	94990	0	113	40213227		
52147	4337	19129655	1961-08-08	1961-08-08 00:00:00	1961-08-22	1961-08-22 00:00:00	1961-08-22	38000177		0	0	14		0	0	0	287594	0	789980	19129655		
53118	4412	1127433	1979-12-07	1979-12-07 00:00:00	1979-12-21	1979-12-21 00:00:00	1979-12-21	38000177		0	0	14		0	0	0	293325	0	313782	1127433		
31302	2594	1127078	1980-11-08	1980-11-08 00:00:00	1980-11-22	1980-11-22 00:00:00	1980-11-22	38000177		0	0	14		0	0	0	171683	0	282464	1127078		
13756	1149	40165015	2011-11-29	2011-11-29 00:00:00	2011-11-29	2011-11-29 00:00:00	\N	38000177		0	0	0		0	0	0	75948	0	861467	40165015		
19030	412	40213160	1956-04-20	1956-04-20 00:00:00	1956-04-20	1956-04-20 00:00:00	1956-04-20	581452		0	0	0		0	0	0	27437	0	10	40213160		
2354	188	1118084	1999-11-24	1999-11-24 00:00:00	1999-11-24	1999-11-24 00:00:00	\N	38000177		0	0	0		0	0	0	12826	0	00025152531	44923712		
20055	1646	19078461	2012-03-22	2012-03-22 00:00:00	2012-05-21	2012-05-21 00:00:00	2012-05-21	38000177		0	0	60		0	0	0	110450	0	310965	19078461		
24390	2006	19059056	1946-02-17	1946-02-17 00:00:00	1946-03-03	1946-03-03 00:00:00	1946-03-03	38000177		0	0	14		0	0	0	133645	0	243670	19059056		
108706	2384	40213180	2006-10-24	2006-10-24 00:00:00	2006-10-24	2006-10-24 00:00:00	2006-10-24	581452		0	0	0		0	0	0	158492	0	114	40213180		
18485	1529	1127433	1993-02-24	1993-02-24 00:00:00	1993-03-31	1993-03-31 00:00:00	1993-03-31	38000177		0	0	35		0	0	0	102355	0	313782	1127433		
48760	4040	1127433	1979-11-22	1979-11-22 00:00:00	1979-12-06	1979-12-06 00:00:00	1979-12-06	38000177		0	0	14		0	0	0	268663	0	313782	1127433		
63099	5241	19133905	1996-01-20	1996-01-20 00:00:00	1996-02-01	1996-02-01 00:00:00	1996-02-01	38000177		0	0	12		0	0	0	348719	0	834102	19133905		
1941	155	1118084	1990-09-20	1990-09-20 00:00:00	1990-09-20	1990-09-20 00:00:00	\N	38000177		0	0	0		0	0	0	10605	0	00025152531	44923712		
63173	5249	19133905	1994-03-17	1994-03-17 00:00:00	1994-03-28	1994-03-28 00:00:00	1994-03-28	38000177		0	0	11		0	0	0	349159	0	834102	19133905		
227252	4990	40213306	1985-05-22	1985-05-22 00:00:00	1985-05-22	1985-05-22 00:00:00	1985-05-22	581452		0	0	0		0	0	0	331932	0	43	40213306		
24979	2054	1118084	2010-08-28	2010-08-28 00:00:00	2010-08-28	2010-08-28 00:00:00	\N	38000177		0	0	0		0	0	0	136622	0	00025152531	44923712		
20916	1724	19078461	1987-06-21	1987-06-21 00:00:00	1987-07-05	1987-07-05 00:00:00	1987-07-05	38000177		0	0	14		0	0	0	115265	0	310965	19078461		
35428	2919	19078461	2018-03-21	2018-03-21 00:00:00	2018-05-20	2018-05-20 00:00:00	2018-05-20	38000177		0	0	60		0	0	0	194613	0	310965	19078461		
64021	5317	1127433	1983-09-20	1983-09-20 00:00:00	1983-09-27	1983-09-27 00:00:00	1983-09-27	38000177		0	0	7		0	0	0	353649	0	313782	1127433		
8429	703	1118084	1989-02-01	1989-02-01 00:00:00	1989-02-01	1989-02-01 00:00:00	\N	38000177		0	0	0		0	0	0	46505	0	00025152531	44923712		
12720	1072	1713671	1980-11-06	1980-11-06 00:00:00	1980-11-27	1980-11-27 00:00:00	1980-11-27	38000177		0	0	21		0	0	0	70274	0	562251	1713671		
18998	1569	40236824	1976-11-25	1976-11-25 00:00:00	1976-12-02	1976-12-02 00:00:00	1976-12-02	38000177		0	0	7		0	0	0	105256	0	1094107	40236824		
88309	1937	40213296	2005-05-24	2005-05-24 00:00:00	2005-05-24	2005-05-24 00:00:00	2005-05-24	581452		0	0	0		0	0	0	128900	0	52	40213296		
30788	2551	19128065	1974-08-07	1974-08-07 00:00:00	1975-08-02	1975-08-02 00:00:00	1975-08-02	38000177		0	0	360		0	0	0	168880	0	749882	19128065		
52639	4376	40169281	1976-07-06	1976-07-06 00:00:00	1976-07-06	1976-07-06 00:00:00	\N	38000177		0	0	0		0	0	0	290795	0	896209	40169281		
44398	3676	40229134	1997-03-31	1997-03-31 00:00:00	1997-04-14	1997-04-14 00:00:00	1997-04-14	38000177		0	0	14		0	0	0	244550	0	1043400	40229134		
25068	2062	1127433	2006-02-16	2006-02-16 00:00:00	2006-05-17	2006-05-17 00:00:00	2006-05-17	38000177		0	0	90		0	0	0	137200	0	313782	1127433		
7112	154	40213314	1978-04-27	1978-04-27 00:00:00	1978-04-27	1978-04-27 00:00:00	1978-04-27	581452		0	0	0		0	0	0	10442	0	49	40213314		
145494	3199	40213160	1973-07-11	1973-07-11 00:00:00	1973-07-11	1973-07-11 00:00:00	1973-07-11	581452		0	0	0		0	0	0	212751	0	10	40213160		
12112	1016	1127433	2000-12-19	2000-12-19 00:00:00	2001-01-02	2001-01-02 00:00:00	2001-01-02	38000177		0	0	14		0	0	0	66907	0	313782	1127433		
163609	3599	40213160	1971-04-16	1971-04-16 00:00:00	1971-04-16	1971-04-16 00:00:00	1971-04-16	581452		0	0	0		0	0	0	239025	0	10	40213160		
90012	1976	40213314	1983-03-28	1983-03-28 00:00:00	1983-03-28	1983-03-28 00:00:00	1983-03-28	581452		0	0	0		0	0	0	131448	0	49	40213314		
157602	3469	40213198	2017-10-11	2017-10-11 00:00:00	2017-10-11	2017-10-11 00:00:00	2017-10-11	581452		0	0	0		0	0	0	230274	0	133	40213198		
57946	4814	19059056	1940-03-21	1940-03-21 00:00:00	1940-04-04	1940-04-04 00:00:00	1940-04-04	38000177		0	0	14		0	0	0	320243	0	243670	19059056		
6468	545	1118084	2004-05-23	2004-05-23 00:00:00	2004-05-23	2004-05-23 00:00:00	\N	38000177		0	0	0		0	0	0	36096	0	00025152531	44923712		
58039	4822	920334	1989-10-28	1989-10-28 00:00:00	1989-11-04	1989-11-04 00:00:00	1989-11-04	38000177		0	0	7		0	0	0	320714	0	311995	920334		
59775	4970	40223774	1997-04-22	1997-04-22 00:00:00	1997-04-22	1997-04-22 00:00:00	\N	38000177		0	0	0		0	0	0	330407	0	998582	40223774		
448	35	1127433	1978-11-14	1978-11-14 00:00:00	1978-11-28	1978-11-28 00:00:00	1978-11-28	38000177		0	0	14		0	0	0	2403	0	313782	1127433		
51288	1123	40213306	1988-05-26	1988-05-26 00:00:00	1988-05-26	1988-05-26 00:00:00	1988-05-26	581452		0	0	0		0	0	0	73985	0	43	40213306		
14868	1245	40243436	2003-10-10	2003-10-10 00:00:00	2003-10-10	2003-10-10 00:00:00	2003-10-10	38000177		0	0	0		0	0	0	81904	0	1190795	40243436		
152878	3365	40213227	2015-07-24	2015-07-24 00:00:00	2015-07-24	2015-07-24 00:00:00	2015-07-24	581452		0	0	0		0	0	0	223197	0	113	40213227		
36518	3013	19128065	1974-07-04	1974-07-04 00:00:00	1975-06-29	1975-06-29 00:00:00	1975-06-29	38000177		0	0	360		0	0	0	200944	0	749882	19128065		
2300	185	19133905	1982-09-24	1982-09-24 00:00:00	1982-10-07	1982-10-07 00:00:00	1982-10-07	38000177		0	0	13		0	0	0	12526	0	834102	19133905		
30016	2487	1127433	2013-01-07	2013-01-07 00:00:00	2013-01-14	2013-01-14 00:00:00	2013-01-14	38000177		0	0	7		0	0	0	164806	0	313782	1127433		
123774	2721	40213160	1968-04-20	1968-04-20 00:00:00	1968-04-20	1968-04-20 00:00:00	1968-04-20	581452		0	0	0		0	0	0	180352	0	10	40213160		
37244	3079	19078461	1975-08-22	1975-08-22 00:00:00	1975-09-12	1975-09-12 00:00:00	1975-09-12	38000177		0	0	21		0	0	0	204963	0	310965	19078461		
48837	4049	1118084	1997-08-13	1997-08-13 00:00:00	1997-08-13	1997-08-13 00:00:00	\N	38000177		0	0	0		0	0	0	269201	0	00025152531	44923712		
6530	550	1127433	1994-09-24	1994-09-24 00:00:00	1994-10-08	1994-10-08 00:00:00	1994-10-08	38000177		0	0	14		0	0	0	36492	0	313782	1127433		
81890	1789	40213160	1975-06-05	1975-06-05 00:00:00	1975-06-05	1975-06-05 00:00:00	1975-06-05	581452		0	0	0		0	0	0	119936	0	10	40213160		
52927	4398	1127078	1963-05-10	1963-05-10 00:00:00	1963-05-24	1963-05-24 00:00:00	1963-05-24	38000177		0	0	14		0	0	0	292391	0	282464	1127078		
59463	4942	1115171	1998-04-16	1998-04-16 00:00:00	1998-05-21	1998-05-21 00:00:00	1998-05-21	38000177		0	0	35		0	0	0	328467	0	849574	1115171		
13249	1112	1127078	1971-03-03	1971-03-03 00:00:00	1971-04-07	1971-04-07 00:00:00	1971-04-07	38000177		0	0	35		0	0	0	73185	0	282464	1127078		
58429	4853	19059056	1963-12-14	1963-12-14 00:00:00	1963-12-28	1963-12-28 00:00:00	1963-12-28	38000177		0	0	14		0	0	0	322930	0	243670	19059056		
53475	4446	1713671	2009-09-26	2009-09-26 00:00:00	2009-10-17	2009-10-17 00:00:00	2009-10-17	38000177		0	0	21		0	0	0	295669	0	562251	1713671		
127934	2813	40213227	2005-09-02	2005-09-02 00:00:00	2005-09-02	2005-09-02 00:00:00	2005-09-02	581452		0	0	0		0	0	0	186401	0	113	40213227		
50971	4235	40165015	2007-03-16	2007-03-16 00:00:00	2007-03-16	2007-03-16 00:00:00	\N	38000177		0	0	0		0	0	0	281189	0	861467	40165015		
150502	3311	40213160	1956-06-27	1956-06-27 00:00:00	1956-06-27	1956-06-27 00:00:00	1956-06-27	581452		0	0	0		0	0	0	219887	0	10	40213160		
15001	1253	19078461	2015-08-10	2015-08-10 00:00:00	2015-09-14	2015-09-14 00:00:00	2015-09-14	38000177		0	0	35		0	0	0	82579	0	310965	19078461		
22133	1819	19128022	1995-04-30	1995-04-30 00:00:00	1996-04-24	1996-04-24 00:00:00	1996-04-24	38000177		0	0	360		0	0	0	121648	0	749785	19128022		
61620	5128	19078461	2009-12-26	2009-12-26 00:00:00	2010-01-25	2010-01-25 00:00:00	2010-01-25	38000177		0	0	30		0	0	0	340921	0	310965	19078461		
14281	308	40213306	1981-12-22	1981-12-22 00:00:00	1981-12-22	1981-12-22 00:00:00	1981-12-22	581452		0	0	0		0	0	0	20439	0	43	40213306		
25632	559	40213296	2009-03-02	2009-03-02 00:00:00	2009-03-02	2009-03-02 00:00:00	2009-03-02	581452		0	0	0		0	0	0	37107	0	52	40213296		
20651	1702	1127433	2016-08-22	2016-08-22 00:00:00	2016-09-05	2016-09-05 00:00:00	2016-09-05	38000177		0	0	14		0	0	0	113805	0	313782	1127433		
65245	1428	40213201	2010-12-07	2010-12-07 00:00:00	2010-12-07	2010-12-07 00:00:00	2010-12-07	581452		0	0	0		0	0	0	95025	0	33	40213201		
52148	4337	19059056	1961-08-08	1961-08-08 00:00:00	1961-08-22	1961-08-22 00:00:00	1961-08-22	38000177		0	0	14		0	0	0	287594	0	243670	19059056		
53119	4412	1124300	2002-09-11	2002-09-11 00:00:00	2002-09-11	2002-09-11 00:00:00	\N	38000177		0	0	0		0	0	0	293404	0	00781178901	45011828		
31303	2596	40229134	1988-12-07	1988-12-07 00:00:00	1988-12-14	1988-12-14 00:00:00	1988-12-14	38000177		0	0	7		0	0	0	171813	0	1043400	40229134		
13757	1149	1127433	2011-11-29	2011-11-29 00:00:00	2011-12-27	2011-12-27 00:00:00	2011-12-27	38000177		0	0	28		0	0	0	75948	0	313782	1127433		
19032	412	40213160	1958-04-25	1958-04-25 00:00:00	1958-04-25	1958-04-25 00:00:00	1958-04-25	581452		0	0	0		0	0	0	27419	0	10	40213160		
2355	189	19078461	1992-06-02	1992-06-02 00:00:00	1992-06-23	1992-06-23 00:00:00	1992-06-23	38000177		0	0	21		0	0	0	12890	0	310965	19078461		
20056	1646	40236824	1977-12-24	1977-12-24 00:00:00	1977-12-31	1977-12-31 00:00:00	1977-12-31	38000177		0	0	7		0	0	0	110372	0	1094107	40236824		
24391	2006	1127433	1967-03-29	1967-03-29 00:00:00	1967-04-05	1967-04-05 00:00:00	1967-04-05	38000177		0	0	7		0	0	0	133568	0	313782	1127433		
108708	2384	40213160	1984-10-30	1984-10-30 00:00:00	1984-10-30	1984-10-30 00:00:00	1984-10-30	581452		0	0	0		0	0	0	158515	0	10	40213160		
18486	1529	19006318	1966-04-25	1966-04-25 00:00:00	1966-05-09	1966-05-09 00:00:00	1966-05-09	38000177		0	0	14		0	0	0	102366	0	105078	19006318		
102204	2240	40213227	1999-04-06	1999-04-06 00:00:00	1999-04-06	1999-04-06 00:00:00	1999-04-06	581452		0	0	0		0	0	0	149111	0	113	40213227		
63100	5241	19133905	2005-10-14	2005-10-14 00:00:00	2005-10-24	2005-10-24 00:00:00	2005-10-24	38000177		0	0	10		0	0	0	348759	0	834102	19133905		
1944	155	19112599	1959-05-27	1959-05-27 00:00:00	1959-05-27	1959-05-27 00:00:00	\N	38000177		0	0	0		0	0	0	10589	0	477045	19112599		
63174	5249	19059056	1966-05-25	1966-05-25 00:00:00	1966-06-08	1966-06-08 00:00:00	1966-06-08	38000177		0	0	14		0	0	0	349246	0	243670	19059056		
227266	4990	40213160	1962-07-04	1962-07-04 00:00:00	1962-07-04	1962-07-04 00:00:00	1962-07-04	581452		0	0	0		0	0	0	331966	0	10	40213160		
24980	2054	1127433	1987-01-11	1987-01-11 00:00:00	1987-01-25	1987-01-25 00:00:00	1987-01-25	38000177		0	0	14		0	0	0	136640	0	313782	1127433		
31378	2602	1713671	1986-05-08	1986-05-08 00:00:00	1986-05-22	1986-05-22 00:00:00	1986-05-22	38000177		0	0	14		0	0	0	172132	0	562251	1713671		
35429	2919	1713671	1958-12-29	1958-12-29 00:00:00	1959-01-19	1959-01-19 00:00:00	1959-01-19	38000177		0	0	21		0	0	0	194574	0	562251	1713671		
64022	5317	1127078	1974-01-30	1974-01-30 00:00:00	1974-02-13	1974-02-13 00:00:00	1974-02-13	38000177		0	0	14		0	0	0	353681	0	282464	1127078		
8430	704	1127078	1976-03-19	1976-03-19 00:00:00	1976-04-02	1976-04-02 00:00:00	1976-04-02	38000177		0	0	14		0	0	0	46549	0	282464	1127078		
12721	1072	1127433	1996-12-03	1996-12-03 00:00:00	1996-12-17	1996-12-17 00:00:00	1996-12-17	38000177		0	0	14		0	0	0	70261	0	313782	1127433		
18999	1569	920300	1976-11-25	1976-11-25 00:00:00	1976-12-02	1976-12-02 00:00:00	1976-12-02	38000177		0	0	7		0	0	0	105256	0	311989	920300		
88328	1937	40213306	1986-01-07	1986-01-07 00:00:00	1986-01-07	1986-01-07 00:00:00	1986-01-07	581452		0	0	0		0	0	0	128863	0	43	40213306		
30789	2551	19133873	1970-06-22	1970-06-22 00:00:00	1970-07-02	1970-07-02 00:00:00	1970-07-02	38000177		0	0	10		0	0	0	168896	0	834061	19133873		
52640	4376	1713671	1973-03-09	1973-03-09 00:00:00	1973-03-23	1973-03-23 00:00:00	1973-03-23	38000177		0	0	14		0	0	0	290712	0	562251	1713671		
44399	3676	19128065	1991-10-03	1991-10-03 00:00:00	1992-09-27	1992-09-27 00:00:00	1992-09-27	38000177		0	0	360		0	0	0	244488	0	749882	19128065		
25069	2062	40171902	2014-11-29	2014-11-29 00:00:00	2014-11-29	2014-11-29 00:00:00	\N	38000177		0	0	0		0	0	0	137121	0	897718	40171902		
7115	154	40213314	1977-10-27	1977-10-27 00:00:00	1977-10-27	1977-10-27 00:00:00	1977-10-27	581452		0	0	0		0	0	0	10479	0	49	40213314		
145496	3199	40213296	2015-07-29	2015-07-29 00:00:00	2015-07-29	2015-07-29 00:00:00	2015-07-29	581452		0	0	0		0	0	0	212728	0	52	40213296		
12143	1018	1124300	2012-02-20	2012-02-20 00:00:00	2012-02-20	2012-02-20 00:00:00	\N	38000177		0	0	0		0	0	0	67014	0	00781178901	45011828		
73350	1602	40213160	1963-12-25	1963-12-25 00:00:00	1963-12-25	1963-12-25 00:00:00	1963-12-25	581452		0	0	0		0	0	0	107508	0	10	40213160		
90014	1976	40213160	1983-03-28	1983-03-28 00:00:00	1983-03-28	1983-03-28 00:00:00	1983-03-28	581452		0	0	0		0	0	0	131448	0	10	40213160		
157605	3469	40213160	1955-09-07	1955-09-07 00:00:00	1955-09-07	1955-09-07 00:00:00	1955-09-07	581452		0	0	0		0	0	0	230259	0	10	40213160		
57947	4814	1118084	1981-10-17	1981-10-17 00:00:00	1981-10-17	1981-10-17 00:00:00	\N	38000177		0	0	0		0	0	0	320282	0	00025152531	44923712		
6469	545	40236824	2018-01-15	2018-01-15 00:00:00	2018-01-22	2018-01-22 00:00:00	2018-01-22	38000177		0	0	7		0	0	0	36120	0	1094107	40236824		
58040	4822	40169281	2004-11-03	2004-11-03 00:00:00	2004-11-03	2004-11-03 00:00:00	\N	38000177		0	0	0		0	0	0	320789	0	896209	40169281		
59776	4970	40229134	1934-04-13	1934-04-13 00:00:00	1934-04-20	1934-04-20 00:00:00	1934-04-20	38000177		0	0	7		0	0	0	330343	0	1043400	40229134		
449	35	40229134	2007-02-25	2007-02-25 00:00:00	2007-03-04	2007-03-04 00:00:00	2007-03-04	38000177		0	0	7		0	0	0	2436	0	1043400	40229134		
51291	1123	40213160	1965-11-04	1965-11-04 00:00:00	1965-11-04	1965-11-04 00:00:00	1965-11-04	581452		0	0	0		0	0	0	74005	0	10	40213160		
14869	1245	1310034	2003-10-10	2003-10-10 00:00:00	2003-10-10	2003-10-10 00:00:00	2003-10-10	38000177		0	0	0		0	0	0	81904	0	834357	1310034		
152883	3365	40213260	2014-07-18	2014-07-18 00:00:00	2014-07-18	2014-07-18 00:00:00	2014-07-18	581452		0	0	0		0	0	0	223224	0	121	40213260		
36520	3013	1127433	1963-12-24	1963-12-24 00:00:00	1964-02-22	1964-02-22 00:00:00	1964-02-22	38000177		0	0	60		0	0	0	200965	0	313782	1127433		
2301	185	19059056	1947-04-07	1947-04-07 00:00:00	1947-04-21	1947-04-21 00:00:00	1947-04-21	38000177		0	0	14		0	0	0	12528	0	243670	19059056		
30017	2487	1127433	1989-04-20	1989-04-20 00:00:00	1989-05-04	1989-05-04 00:00:00	1989-05-04	38000177		0	0	14		0	0	0	164813	0	313782	1127433		
123777	2721	40213306	1990-06-16	1990-06-16 00:00:00	1990-06-16	1990-06-16 00:00:00	1990-06-16	581452		0	0	0		0	0	0	180340	0	43	40213306		
12772	276	40213306	1999-07-08	1999-07-08 00:00:00	1999-07-08	1999-07-08 00:00:00	1999-07-08	581452		0	0	0		0	0	0	18454	0	43	40213306		
48838	4049	19078461	1999-06-10	1999-06-10 00:00:00	1999-07-01	1999-07-01 00:00:00	1999-07-01	38000177		0	0	21		0	0	0	269140	0	310965	19078461		
6531	550	19059056	1920-12-13	1920-12-13 00:00:00	1921-03-13	1921-03-13 00:00:00	1921-03-13	38000177		0	0	90		0	0	0	36445	0	243670	19059056		
81894	1789	40213314	1978-02-02	1978-02-02 00:00:00	1978-02-02	1978-02-02 00:00:00	1978-02-02	581452		0	0	0		0	0	0	119881	0	49	40213314		
52928	4398	1713671	1986-07-01	1986-07-01 00:00:00	1986-10-14	1986-10-14 00:00:00	1986-10-14	38000177		0	0	105		0	0	0	292437	0	562251	1713671		
59464	4942	40236824	2003-05-20	2003-05-20 00:00:00	2003-06-03	2003-06-03 00:00:00	2003-06-03	38000177		0	0	14		0	0	0	328470	0	1094107	40236824		
13250	1112	19059056	1968-07-02	1968-07-02 00:00:00	1968-07-16	1968-07-16 00:00:00	1968-07-16	38000177		0	0	14		0	0	0	73184	0	243670	19059056		
58430	4853	19006318	1963-12-14	1963-12-14 00:00:00	1963-12-28	1963-12-28 00:00:00	1963-12-28	38000177		0	0	14		0	0	0	322930	0	105078	19006318		
53476	4447	1154615	1953-08-27	1953-08-27 00:00:00	1953-08-27	1953-08-27 00:00:00	\N	38000177		0	0	0		0	0	0	295786	0	745679	1154615		
46453	1015	40213227	1994-12-05	1994-12-05 00:00:00	1994-12-05	1994-12-05 00:00:00	1994-12-05	581452		0	0	0		0	0	0	66779	0	113	40213227		
50989	4238	19078461	2013-06-18	2013-06-18 00:00:00	2013-07-25	2013-07-25 00:00:00	2013-07-25	38000177		0	0	37		0	0	0	281411	0	310965	19078461		
150503	3311	40213160	1956-11-28	1956-11-28 00:00:00	1956-11-28	1956-11-28 00:00:00	1956-11-28	581452		0	0	0		0	0	0	219888	0	10	40213160		
15002	1253	1713671	2002-01-04	2002-01-04 00:00:00	2002-01-25	2002-01-25 00:00:00	2002-01-25	38000177		0	0	21		0	0	0	82493	0	562251	1713671		
22134	1819	19128022	1994-05-05	1994-05-05 00:00:00	1995-04-30	1995-04-30 00:00:00	1995-04-30	38000177		0	0	360		0	0	0	121654	0	749785	19128022		
61621	5128	40165015	2009-12-26	2009-12-26 00:00:00	2009-12-26	2009-12-26 00:00:00	\N	38000177		0	0	0		0	0	0	340921	0	861467	40165015		
14288	308	40213227	1994-01-04	1994-01-04 00:00:00	1994-01-04	1994-01-04 00:00:00	1994-01-04	581452		0	0	0		0	0	0	20450	0	113	40213227		
25633	559	40213296	2009-07-06	2009-07-06 00:00:00	2009-07-06	2009-07-06 00:00:00	2009-07-06	581452		0	0	0		0	0	0	37066	0	52	40213296		
20652	1702	1127433	1967-09-20	1967-09-20 00:00:00	1967-10-04	1967-10-04 00:00:00	1967-10-04	38000177		0	0	14		0	0	0	113798	0	313782	1127433		
65246	1428	40213198	2010-12-07	2010-12-07 00:00:00	2010-12-07	2010-12-07 00:00:00	2010-12-07	581452		0	0	0		0	0	0	95025	0	133	40213198		
52149	4337	920300	2004-07-15	2004-07-15 00:00:00	2004-07-22	2004-07-22 00:00:00	2004-07-22	38000177		0	0	7		0	0	0	287566	0	311989	920300		
53120	4412	1713671	1979-12-21	1979-12-21 00:00:00	1980-01-04	1980-01-04 00:00:00	1980-01-04	38000177		0	0	14		0	0	0	293306	0	562251	1713671		
31304	2596	1127433	1983-09-21	1983-09-21 00:00:00	1983-12-20	1983-12-20 00:00:00	1983-12-20	38000177		0	0	90		0	0	0	171762	0	313782	1127433		
13758	1149	19073188	2011-11-29	2011-11-29 00:00:00	2011-12-27	2011-12-27 00:00:00	2011-12-27	38000177		0	0	28		0	0	0	75948	0	308192	19073188		
19040	412	40213227	1995-12-08	1995-12-08 00:00:00	1995-12-08	1995-12-08 00:00:00	1995-12-08	581452		0	0	0		0	0	0	27417	0	113	40213227		
2356	189	1127433	2012-09-24	2012-09-24 00:00:00	2012-10-08	2012-10-08 00:00:00	2012-10-08	38000177		0	0	14		0	0	0	12839	0	313782	1127433		
20057	1646	920300	1977-12-24	1977-12-24 00:00:00	1977-12-31	1977-12-31 00:00:00	1977-12-31	38000177		0	0	7		0	0	0	110372	0	311989	920300		
24392	2006	19133905	1980-07-29	1980-07-29 00:00:00	1980-08-11	1980-08-11 00:00:00	1980-08-11	38000177		0	0	13		0	0	0	133593	0	834102	19133905		
46945	1025	40213227	1992-11-21	1992-11-21 00:00:00	1992-11-21	1992-11-21 00:00:00	1992-11-21	581452		0	0	0		0	0	0	67500	0	113	40213227		
18487	1529	19059056	1966-04-25	1966-04-25 00:00:00	1966-05-09	1966-05-09 00:00:00	1966-05-09	38000177		0	0	14		0	0	0	102366	0	243670	19059056		
102205	2240	40213296	1999-04-06	1999-04-06 00:00:00	1999-04-06	1999-04-06 00:00:00	1999-04-06	581452		0	0	0		0	0	0	149111	0	52	40213296		
63101	5241	19078461	2012-10-26	2012-10-26 00:00:00	2012-11-09	2012-11-09 00:00:00	2012-11-09	38000177		0	0	14		0	0	0	348800	0	310965	19078461		
1946	155	1127433	2005-07-09	2005-07-09 00:00:00	2005-07-16	2005-07-16 00:00:00	2005-07-16	38000177		0	0	7		0	0	0	10535	0	313782	1127433		
63175	5249	1127433	1979-02-02	1979-02-02 00:00:00	1979-02-09	1979-02-09 00:00:00	1979-02-09	38000177		0	0	7		0	0	0	349195	0	313782	1127433		
227268	4990	40213306	1982-05-19	1982-05-19 00:00:00	1982-05-19	1982-05-19 00:00:00	1982-05-19	581452		0	0	0		0	0	0	331945	0	43	40213306		
24981	2054	1127433	1973-04-16	1973-04-16 00:00:00	1973-04-23	1973-04-23 00:00:00	1973-04-23	38000177		0	0	7		0	0	0	136583	0	313782	1127433		
31379	2602	1124300	1986-11-14	1986-11-14 00:00:00	1986-11-14	1986-11-14 00:00:00	\N	38000177		0	0	0		0	0	0	172132	0	00781178901	45011828		
35430	2919	1118084	1984-03-29	1984-03-29 00:00:00	1984-03-29	1984-03-29 00:00:00	\N	38000177		0	0	0		0	0	0	194616	0	00025152531	44923712		
64023	5317	46233988	1974-01-30	1974-01-30 00:00:00	1974-02-13	1974-02-13 00:00:00	1974-02-13	38000177		0	0	14		0	0	0	353681	0	1652673	46233988		
8431	704	46233988	1976-03-19	1976-03-19 00:00:00	1976-04-02	1976-04-02 00:00:00	1976-04-02	38000177		0	0	14		0	0	0	46549	0	1652673	46233988		
12722	1072	19078461	1979-05-29	1979-05-29 00:00:00	1979-06-28	1979-06-28 00:00:00	1979-06-28	38000177		0	0	30		0	0	0	70286	0	310965	19078461		
19000	1569	19133873	1945-04-09	1945-04-09 00:00:00	1945-04-20	1945-04-20 00:00:00	1945-04-20	38000177		0	0	11		0	0	0	105242	0	834061	19133873		
88331	1937	40213227	2014-05-20	2014-05-20 00:00:00	2014-05-20	2014-05-20 00:00:00	2014-05-20	581452		0	0	0		0	0	0	128886	0	113	40213227		
30790	2551	19078461	1990-07-04	1990-07-04 00:00:00	1990-07-25	1990-07-25 00:00:00	1990-07-25	38000177		0	0	21		0	0	0	168905	0	310965	19078461		
52641	4376	1127433	1989-05-05	1989-05-05 00:00:00	1989-08-03	1989-08-03 00:00:00	1989-08-03	38000177		0	0	90		0	0	0	290733	0	313782	1127433		
44400	3676	19059056	1973-07-29	1973-07-29 00:00:00	1973-08-28	1973-08-28 00:00:00	1973-08-28	38000177		0	0	30		0	0	0	244485	0	243670	19059056		
25070	2062	40163554	2014-11-29	2014-11-29 00:00:00	2014-11-29	2014-11-29 00:00:00	\N	38000177		0	0	0		0	0	0	137121	0	855332	40163554		
7117	154	40213227	2016-12-01	2016-12-01 00:00:00	2016-12-01	2016-12-01 00:00:00	2016-12-01	581452		0	0	0		0	0	0	10431	0	113	40213227		
145499	3199	40213160	1978-01-11	1978-01-11 00:00:00	1978-01-11	1978-01-11 00:00:00	1978-01-11	581452		0	0	0		0	0	0	212765	0	10	40213160		
12144	1018	1115171	2014-12-12	2014-12-12 00:00:00	2015-01-09	2015-01-09 00:00:00	2015-01-09	38000177		0	0	28		0	0	0	67012	0	849574	1115171		
73355	1602	40213160	1963-07-24	1963-07-24 00:00:00	1963-07-24	1963-07-24 00:00:00	1963-07-24	581452		0	0	0		0	0	0	107507	0	10	40213160		
90017	1976	40213160	1987-11-30	1987-11-30 00:00:00	1987-11-30	1987-11-30 00:00:00	1987-11-30	581452		0	0	0		0	0	0	131377	0	10	40213160		
115711	2542	40213296	2003-06-27	2003-06-27 00:00:00	2003-06-27	2003-06-27 00:00:00	2003-06-27	581452		0	0	0		0	0	0	168149	0	52	40213296		
57948	4814	19133873	1936-12-11	1936-12-11 00:00:00	1936-12-18	1936-12-18 00:00:00	1936-12-18	38000177		0	0	7		0	0	0	320299	0	834061	19133873		
6470	545	920300	2018-01-15	2018-01-15 00:00:00	2018-01-22	2018-01-22 00:00:00	2018-01-22	38000177		0	0	7		0	0	0	36120	0	311989	920300		
58041	4822	19006318	1952-04-02	1952-04-02 00:00:00	1952-04-16	1952-04-16 00:00:00	1952-04-16	38000177		0	0	14		0	0	0	320718	0	105078	19006318		
59777	4970	1127433	1962-06-27	1962-06-27 00:00:00	1962-07-27	1962-07-27 00:00:00	1962-07-27	38000177		0	0	30		0	0	0	330395	0	313782	1127433		
450	35	19059056	1993-04-28	1993-04-28 00:00:00	1993-05-28	1993-05-28 00:00:00	1993-05-28	38000177		0	0	30		0	0	0	2393	0	243670	19059056		
51296	1123	40213306	1988-11-10	1988-11-10 00:00:00	1988-11-10	1988-11-10 00:00:00	1988-11-10	581452		0	0	0		0	0	0	74029	0	43	40213306		
14870	1245	46275916	2003-10-10	2003-10-10 00:00:00	2003-10-10	2003-10-10 00:00:00	2003-10-10	38000177		0	0	0		0	0	0	81904	0	1660014	46275916		
152886	3365	40213296	2008-05-30	2008-05-30 00:00:00	2008-05-30	2008-05-30 00:00:00	2008-05-30	581452		0	0	0		0	0	0	223223	0	52	40213296		
46979	3891	1124300	2019-06-03	2019-06-03 00:00:00	2019-06-03	2019-06-03 00:00:00	\N	38000177		0	0	0		0	0	0	258644	0	00781178901	45011828		
2302	185	19006318	1947-04-07	1947-04-07 00:00:00	1947-04-21	1947-04-21 00:00:00	1947-04-21	38000177		0	0	14		0	0	0	12528	0	105078	19006318		
30018	2487	40174880	2010-02-16	2010-02-16 00:00:00	2010-02-16	2010-02-16 00:00:00	\N	38000177		0	0	0		0	0	0	164764	0	966222	40174880		
83224	1819	40213314	1977-08-30	1977-08-30 00:00:00	1977-08-30	1977-08-30 00:00:00	1977-08-30	581452		0	0	0		0	0	0	121655	0	49	40213314		
12774	276	40213227	1999-07-08	1999-07-08 00:00:00	1999-07-08	1999-07-08 00:00:00	1999-07-08	581452		0	0	0		0	0	0	18454	0	113	40213227		
48847	4051	40232448	1979-02-05	1979-02-05 00:00:00	1979-02-05	1979-02-05 00:00:00	\N	38000177		0	0	0		0	0	0	269251	0	1049630	40232448		
6532	550	19133873	1927-03-16	1927-03-16 00:00:00	1927-03-25	1927-03-25 00:00:00	1927-03-25	38000177		0	0	9		0	0	0	36489	0	834061	19133873		
81897	1789	40213314	1977-08-04	1977-08-04 00:00:00	1977-08-04	1977-08-04 00:00:00	1977-08-04	581452		0	0	0		0	0	0	119864	0	49	40213314		
52929	4398	1127433	2005-05-23	2005-05-23 00:00:00	2005-06-06	2005-06-06 00:00:00	2005-06-06	38000177		0	0	14		0	0	0	292465	0	313782	1127433		
59465	4942	920300	2003-05-20	2003-05-20 00:00:00	2003-05-27	2003-05-27 00:00:00	2003-05-27	38000177		0	0	7		0	0	0	328470	0	311989	920300		
13251	1112	1127433	2012-07-05	2012-07-05 00:00:00	2012-07-12	2012-07-12 00:00:00	2012-07-12	38000177		0	0	7		0	0	0	73215	0	313782	1127433		
58431	4853	1127078	1963-07-03	1963-07-03 00:00:00	1963-07-17	1963-07-17 00:00:00	1963-07-17	38000177		0	0	14		0	0	0	322880	0	282464	1127078		
53477	4447	40169216	1953-08-27	1953-08-27 00:00:00	1953-08-27	1953-08-27 00:00:00	\N	38000177		0	0	0		0	0	0	295786	0	895994	40169216		
46457	1015	40213160	1958-10-06	1958-10-06 00:00:00	1958-10-06	1958-10-06 00:00:00	1958-10-06	581452		0	0	0		0	0	0	66776	0	10	40213160		
50990	4238	40236824	1992-10-05	1992-10-05 00:00:00	1992-10-12	1992-10-12 00:00:00	1992-10-12	38000177		0	0	7		0	0	0	281389	0	1094107	40236824		
150512	3311	40213260	2006-03-22	2006-03-22 00:00:00	2006-03-22	2006-03-22 00:00:00	2006-03-22	581452		0	0	0		0	0	0	219875	0	121	40213260		
15003	1253	1127433	2017-01-28	2017-01-28 00:00:00	2017-02-04	2017-02-04 00:00:00	2017-02-04	38000177		0	0	7		0	0	0	82512	0	313782	1127433		
22135	1819	19078461	1991-06-10	1991-06-10 00:00:00	1991-07-08	1991-07-08 00:00:00	1991-07-08	38000177		0	0	28		0	0	0	121684	0	310965	19078461		
61622	5128	1127433	1947-10-22	1947-10-22 00:00:00	1947-10-29	1947-10-29 00:00:00	1947-10-29	38000177		0	0	7		0	0	0	340957	0	313782	1127433		
14296	308	40213227	2010-07-27	2010-07-27 00:00:00	2010-07-27	2010-07-27 00:00:00	2010-07-27	581452		0	0	0		0	0	0	20447	0	113	40213227		
25635	559	40213227	2011-07-11	2011-07-11 00:00:00	2011-07-11	2011-07-11 00:00:00	2011-07-11	581452		0	0	0		0	0	0	37108	0	113	40213227		
20653	1702	1127078	1976-09-30	1976-09-30 00:00:00	1976-10-21	1976-10-21 00:00:00	1976-10-21	38000177		0	0	21		0	0	0	113793	0	282464	1127078		
68357	1497	40213201	2006-06-09	2006-06-09 00:00:00	2006-06-09	2006-06-09 00:00:00	2006-06-09	581452		0	0	0		0	0	0	99760	0	33	40213201		
52150	4337	40236824	2004-07-15	2004-07-15 00:00:00	2004-07-22	2004-07-22 00:00:00	2004-07-22	38000177		0	0	7		0	0	0	287566	0	1094107	40236824		
63580	5283	40231925	1984-09-07	1984-09-07 00:00:00	1984-09-07	1984-09-07 00:00:00	\N	38000177		0	0	0		0	0	0	351478	0	1049221	40231925		
31305	2596	1713671	2010-12-23	2010-12-23 00:00:00	2011-01-06	2011-01-06 00:00:00	2011-01-06	38000177		0	0	14		0	0	0	171808	0	562251	1713671		
13759	1149	19074843	1980-02-24	1980-02-24 00:00:00	1980-03-09	1980-03-09 00:00:00	1980-03-09	38000177		0	0	14		0	0	0	75955	0	309045	19074843		
19048	412	40213160	1955-04-22	1955-04-22 00:00:00	1955-04-22	1955-04-22 00:00:00	1955-04-22	581452		0	0	0		0	0	0	27435	0	10	40213160		
2357	189	1118084	1992-03-18	1992-03-18 00:00:00	1992-03-18	1992-03-18 00:00:00	\N	38000177		0	0	0		0	0	0	12867	0	00025152531	44923712		
20077	1649	1127433	1978-05-02	1978-05-02 00:00:00	1978-05-23	1978-05-23 00:00:00	1978-05-23	38000177		0	0	21		0	0	0	110679	0	313782	1127433		
24393	2006	19078461	2006-06-05	2006-06-05 00:00:00	2006-07-03	2006-07-03 00:00:00	2006-07-03	38000177		0	0	28		0	0	0	133604	0	310965	19078461		
46965	1025	40213227	2012-03-10	2012-03-10 00:00:00	2012-03-10	2012-03-10 00:00:00	2012-03-10	581452		0	0	0		0	0	0	67562	0	113	40213227		
18488	1529	19059056	1963-02-27	1963-02-27 00:00:00	1963-03-13	1963-03-13 00:00:00	1963-03-13	38000177		0	0	14		0	0	0	102325	0	243670	19059056		
102206	2240	40213260	2008-04-01	2008-04-01 00:00:00	2008-04-01	2008-04-01 00:00:00	2008-04-01	581452		0	0	0		0	0	0	149161	0	121	40213260		
63102	5241	920300	2019-04-11	2019-04-11 00:00:00	2019-04-18	2019-04-18 00:00:00	2019-04-18	38000177		0	0	7		0	0	0	348727	0	311989	920300		
1947	155	19006318	1958-12-12	1958-12-12 00:00:00	1958-12-26	1958-12-26 00:00:00	1958-12-26	38000177		0	0	14		0	0	0	10558	0	105078	19006318		
63176	5249	19133873	1957-09-21	1957-09-21 00:00:00	1957-09-30	1957-09-30 00:00:00	1957-09-30	38000177		0	0	9		0	0	0	349193	0	834061	19133873		
2905	64	40213160	1979-10-03	1979-10-03 00:00:00	1979-10-03	1979-10-03 00:00:00	1979-10-03	581452		0	0	0		0	0	0	4354	0	10	40213160		
24982	2054	19128065	1988-06-12	1988-06-12 00:00:00	1989-06-07	1989-06-07 00:00:00	1989-06-07	38000177		0	0	360		0	0	0	136579	0	749882	19128065		
31380	2602	1127433	2017-01-26	2017-01-26 00:00:00	2017-04-26	2017-04-26 00:00:00	2017-04-26	38000177		0	0	90		0	0	0	172148	0	313782	1127433		
35431	2919	40229134	1981-01-14	1981-01-14 00:00:00	1981-01-21	1981-01-21 00:00:00	1981-01-21	38000177		0	0	7		0	0	0	194602	0	1043400	40229134		
64024	5317	1127433	1978-01-10	1978-01-10 00:00:00	1978-01-17	1978-01-17 00:00:00	1978-01-17	38000177		0	0	7		0	0	0	353648	0	313782	1127433		
8432	704	40229134	1999-03-20	1999-03-20 00:00:00	1999-04-03	1999-04-03 00:00:00	1999-04-03	38000177		0	0	14		0	0	0	46597	0	1043400	40229134		
12723	1072	19059056	1966-02-01	1966-02-01 00:00:00	1966-02-15	1966-02-15 00:00:00	1966-02-15	38000177		0	0	14		0	0	0	70281	0	243670	19059056		
19001	1569	1127433	2007-06-21	2007-06-21 00:00:00	2007-07-05	2007-07-05 00:00:00	2007-07-05	38000177		0	0	14		0	0	0	105298	0	313782	1127433		
88332	1937	40213260	2014-05-20	2014-05-20 00:00:00	2014-05-20	2014-05-20 00:00:00	2014-05-20	581452		0	0	0		0	0	0	128886	0	121	40213260		
30791	2551	40229134	1991-01-09	1991-01-09 00:00:00	1991-01-23	1991-01-23 00:00:00	1991-01-23	38000177		0	0	14		0	0	0	168877	0	1043400	40229134		
52642	4376	1713671	2010-07-02	2010-07-02 00:00:00	2010-07-23	2010-07-23 00:00:00	2010-07-23	38000177		0	0	21		0	0	0	290741	0	562251	1713671		
27842	606	40213160	1975-05-21	1975-05-21 00:00:00	1975-05-21	1975-05-21 00:00:00	1975-05-21	581452		0	0	0		0	0	0	40201	0	10	40213160		
25071	2062	19018935	2014-11-29	2014-11-29 00:00:00	2014-11-29	2014-11-29 00:00:00	\N	38000177		0	0	0		0	0	0	137121	0	197604	19018935		
7118	154	40213296	2016-12-01	2016-12-01 00:00:00	2016-12-01	2016-12-01 00:00:00	2016-12-01	581452		0	0	0		0	0	0	10431	0	52	40213296		
145501	3199	40213160	1973-05-09	1973-05-09 00:00:00	1973-05-09	1973-05-09 00:00:00	1973-05-09	581452		0	0	0		0	0	0	212743	0	10	40213160		
12157	1021	1124300	1990-01-16	1990-01-16 00:00:00	1990-01-16	1990-01-16 00:00:00	\N	38000177		0	0	0		0	0	0	67145	0	00781178901	45011828		
73357	1602	40213227	1995-02-08	1995-02-08 00:00:00	1995-02-08	1995-02-08 00:00:00	1995-02-08	581452		0	0	0		0	0	0	107534	0	113	40213227		
90019	1976	40213251	1987-11-30	1987-11-30 00:00:00	1987-11-30	1987-11-30 00:00:00	1987-11-30	581452		0	0	0		0	0	0	131377	0	21	40213251		
115721	2542	40213160	1963-11-08	1963-11-08 00:00:00	1963-11-08	1963-11-08 00:00:00	1963-11-08	581452		0	0	0		0	0	0	168117	0	10	40213160		
57949	4814	1115171	1995-12-06	1995-12-06 00:00:00	1996-01-03	1996-01-03 00:00:00	1996-01-03	38000177		0	0	28		0	0	0	320248	0	849574	1115171		
62651	5210	19133873	1982-10-31	1982-10-31 00:00:00	1982-11-12	1982-11-12 00:00:00	1982-11-12	38000177		0	0	12		0	0	0	346476	0	834061	19133873		
58042	4822	19059056	1952-04-02	1952-04-02 00:00:00	1952-04-16	1952-04-16 00:00:00	1952-04-16	38000177		0	0	14		0	0	0	320718	0	243670	19059056		
59778	4970	19059056	1928-10-18	1928-10-18 00:00:00	1928-11-01	1928-11-01 00:00:00	1928-11-01	38000177		0	0	14		0	0	0	330436	0	243670	19059056		
451	35	1127433	2014-07-26	2014-07-26 00:00:00	2014-08-02	2014-08-02 00:00:00	2014-08-02	38000177		0	0	7		0	0	0	2450	0	313782	1127433		
51300	1123	40213260	2016-06-02	2016-06-02 00:00:00	2016-06-02	2016-06-02 00:00:00	2016-06-02	581452		0	0	0		0	0	0	73975	0	121	40213260		
14871	1245	19018935	2016-07-01	2016-07-01 00:00:00	2016-07-01	2016-07-01 00:00:00	\N	38000177		0	0	0		0	0	0	81923	0	197604	19018935		
152893	3365	40213227	2006-05-26	2006-05-26 00:00:00	2006-05-26	2006-05-26 00:00:00	2006-05-26	581452		0	0	0		0	0	0	223190	0	113	40213227		
46980	3891	19059056	1984-09-14	1984-09-14 00:00:00	1984-12-13	1984-12-13 00:00:00	1984-12-13	38000177		0	0	90		0	0	0	258716	0	243670	19059056		
10993	235	40213160	1986-04-21	1986-04-21 00:00:00	1986-04-21	1986-04-21 00:00:00	1986-04-21	581452		0	0	0		0	0	0	15776	0	10	40213160		
30019	2487	1124300	1992-08-09	1992-08-09 00:00:00	1992-08-09	1992-08-09 00:00:00	\N	38000177		0	0	0		0	0	0	164821	0	00781178901	45011828		
83225	1819	40213160	1977-08-30	1977-08-30 00:00:00	1977-08-30	1977-08-30 00:00:00	1977-08-30	581452		0	0	0		0	0	0	121655	0	10	40213160		
12776	276	40213314	1978-08-17	1978-08-17 00:00:00	1978-08-17	1978-08-17 00:00:00	1978-08-17	581452		0	0	0		0	0	0	18423	0	49	40213314		
48848	4051	19078461	2018-07-20	2018-07-20 00:00:00	2018-08-03	2018-08-03 00:00:00	2018-08-03	38000177		0	0	14		0	0	0	269263	0	310965	19078461		
6533	550	1127433	1962-07-27	1962-07-27 00:00:00	1962-08-17	1962-08-17 00:00:00	1962-08-17	38000177		0	0	21		0	0	0	36448	0	313782	1127433		
81900	1789	40213227	1997-05-01	1997-05-01 00:00:00	1997-05-01	1997-05-01 00:00:00	1997-05-01	581452		0	0	0		0	0	0	119903	0	113	40213227		
52930	4398	19059056	1962-03-03	1962-03-03 00:00:00	1962-04-07	1962-04-07 00:00:00	1962-04-07	38000177		0	0	35		0	0	0	292431	0	243670	19059056		
59466	4942	1127433	1986-12-08	1986-12-08 00:00:00	1986-12-15	1986-12-15 00:00:00	1986-12-15	38000177		0	0	7		0	0	0	328482	0	313782	1127433		
13252	1112	1713671	2011-11-04	2011-11-04 00:00:00	2011-11-18	2011-11-18 00:00:00	2011-11-18	38000177		0	0	14		0	0	0	73214	0	562251	1713671		
58432	4853	19129655	1963-07-03	1963-07-03 00:00:00	1963-07-17	1963-07-17 00:00:00	1963-07-17	38000177		0	0	14		0	0	0	322880	0	789980	19129655		
53478	4447	19078461	1975-01-17	1975-01-17 00:00:00	1975-01-31	1975-01-31 00:00:00	1975-01-31	38000177		0	0	14		0	0	0	295715	0	310965	19078461		
46462	1015	40213296	1996-12-09	1996-12-09 00:00:00	1996-12-09	1996-12-09 00:00:00	1996-12-09	581452		0	0	0		0	0	0	66832	0	52	40213296		
50991	4238	920300	1992-10-05	1992-10-05 00:00:00	1992-10-12	1992-10-12 00:00:00	1992-10-12	38000177		0	0	7		0	0	0	281389	0	311989	920300		
150514	3311	40213227	2018-02-21	2018-02-21 00:00:00	2018-02-21	2018-02-21 00:00:00	2018-02-21	581452		0	0	0		0	0	0	219789	0	113	40213227		
15004	1253	1127433	1990-11-14	1990-11-14 00:00:00	1990-12-19	1990-12-19 00:00:00	1990-12-19	38000177		0	0	35		0	0	0	82578	0	313782	1127433		
22136	1819	1713671	2013-03-14	2013-03-14 00:00:00	2013-04-04	2013-04-04 00:00:00	2013-04-04	38000177		0	0	21		0	0	0	121665	0	562251	1713671		
61623	5128	1127433	1993-01-11	1993-01-11 00:00:00	1993-01-25	1993-01-25 00:00:00	1993-01-25	38000177		0	0	14		0	0	0	341006	0	313782	1127433		
14297	308	40213260	2010-07-27	2010-07-27 00:00:00	2010-07-27	2010-07-27 00:00:00	2010-07-27	581452		0	0	0		0	0	0	20447	0	121	40213260		
25641	559	40213160	1969-06-30	1969-06-30 00:00:00	1969-06-30	1969-06-30 00:00:00	1969-06-30	581452		0	0	0		0	0	0	37113	0	10	40213160		
20654	1702	1127433	1979-07-08	1979-07-08 00:00:00	1979-10-06	1979-10-06 00:00:00	1979-10-06	38000177		0	0	90		0	0	0	113794	0	313782	1127433		
68360	1497	40213227	2001-05-11	2001-05-11 00:00:00	2001-05-11	2001-05-11 00:00:00	2001-05-11	581452		0	0	0		0	0	0	99871	0	113	40213227		
52151	4337	1713671	1965-01-10	1965-01-10 00:00:00	1965-01-24	1965-01-24 00:00:00	1965-01-24	38000177		0	0	14		0	0	0	287586	0	562251	1713671		
63581	5283	1127433	1984-09-07	1984-09-07 00:00:00	1984-11-06	1984-11-06 00:00:00	1984-11-06	38000177		0	0	60		0	0	0	351478	0	313782	1127433		
31306	2596	1127078	1974-04-11	1974-04-11 00:00:00	1974-05-11	1974-05-11 00:00:00	1974-05-11	38000177		0	0	30		0	0	0	171817	0	282464	1127078		
13760	1149	1127078	1986-11-19	1986-11-19 00:00:00	1986-12-26	1986-12-26 00:00:00	1986-12-26	38000177		0	0	37		0	0	0	75945	0	282464	1127078		
16275	351	40213306	2000-05-09	2000-05-09 00:00:00	2000-05-09	2000-05-09 00:00:00	2000-05-09	581452		0	0	0		0	0	0	23344	0	43	40213306		
2358	189	40229134	2003-07-16	2003-07-16 00:00:00	2003-07-30	2003-07-30 00:00:00	2003-07-30	38000177		0	0	14		0	0	0	12895	0	1043400	40229134		
20078	1649	1545959	2017-08-23	2017-08-23 00:00:00	2017-08-23	2017-08-23 00:00:00	2017-08-23	38000177		0	0	0		0	0	0	110618	0	259255	1545959		
24394	2006	1127433	1993-10-17	1993-10-17 00:00:00	1993-10-31	1993-10-31 00:00:00	1993-10-31	38000177		0	0	14		0	0	0	133569	0	313782	1127433		
154329	3397	40213198	2010-01-16	2010-01-16 00:00:00	2010-01-16	2010-01-16 00:00:00	2010-01-16	581452		0	0	0		0	0	0	225284	0	133	40213198		
18489	1529	19129655	1963-02-27	1963-02-27 00:00:00	1963-03-13	1963-03-13 00:00:00	1963-03-13	38000177		0	0	14		0	0	0	102325	0	789980	19129655		
102208	2240	40213227	2008-04-01	2008-04-01 00:00:00	2008-04-01	2008-04-01 00:00:00	2008-04-01	581452		0	0	0		0	0	0	149161	0	113	40213227		
52443	4364	1127433	2012-11-15	2012-11-15 00:00:00	2012-11-22	2012-11-22 00:00:00	2012-11-22	38000177		0	0	7		0	0	0	289469	0	313782	1127433		
1948	155	19059056	1958-12-12	1958-12-12 00:00:00	1958-12-26	1958-12-26 00:00:00	1958-12-26	38000177		0	0	14		0	0	0	10558	0	243670	19059056		
63177	5249	1124300	1988-05-13	1988-05-13 00:00:00	1988-05-13	1988-05-13 00:00:00	\N	38000177		0	0	0		0	0	0	349234	0	00781178901	45011828		
2909	64	40213314	1977-03-30	1977-03-30 00:00:00	1977-03-30	1977-03-30 00:00:00	1977-03-30	581452		0	0	0		0	0	0	4372	0	49	40213314		
24983	2054	19112599	1974-07-14	1974-07-14 00:00:00	1974-07-14	1974-07-14 00:00:00	\N	38000177		0	0	0		0	0	0	136584	0	477045	19112599		
31381	2602	1127433	2006-02-28	2006-02-28 00:00:00	2006-03-14	2006-03-14 00:00:00	2006-03-14	38000177		0	0	14		0	0	0	172074	0	313782	1127433		
35439	2921	1713671	1950-10-19	1950-10-19 00:00:00	1950-10-26	1950-10-26 00:00:00	1950-10-26	38000177		0	0	7		0	0	0	194721	0	562251	1713671		
64025	5317	19128022	1989-11-17	1989-11-17 00:00:00	1990-11-12	1990-11-12 00:00:00	1990-11-12	38000177		0	0	360		0	0	0	353640	0	749785	19128022		
8433	704	40229134	2015-12-07	2015-12-07 00:00:00	2015-12-14	2015-12-14 00:00:00	2015-12-14	38000177		0	0	7		0	0	0	46631	0	1043400	40229134		
12724	1072	19129655	1966-02-01	1966-02-01 00:00:00	1966-02-15	1966-02-15 00:00:00	1966-02-15	38000177		0	0	14		0	0	0	70281	0	789980	19129655		
19002	1569	40173590	2007-03-02	2007-03-02 00:00:00	2007-03-02	2007-03-02 00:00:00	\N	38000177		0	0	0		0	0	0	105336	0	904419	40173590		
88334	1937	40213296	2003-05-20	2003-05-20 00:00:00	2003-05-20	2003-05-20 00:00:00	2003-05-20	581452		0	0	0		0	0	0	128858	0	52	40213296		
30792	2551	1127433	2008-02-08	2008-02-08 00:00:00	2008-02-22	2008-02-22 00:00:00	2008-02-22	38000177		0	0	14		0	0	0	168866	0	313782	1127433		
52643	4376	40229134	1929-02-15	1929-02-15 00:00:00	1929-03-01	1929-03-01 00:00:00	1929-03-01	38000177		0	0	14		0	0	0	290825	0	1043400	40229134		
27844	606	40213314	1977-01-19	1977-01-19 00:00:00	1977-01-19	1977-01-19 00:00:00	1977-01-19	581452		0	0	0		0	0	0	40229	0	49	40213314		
25072	2063	1127433	2008-04-30	2008-04-30 00:00:00	2008-05-14	2008-05-14 00:00:00	2008-05-14	38000177		0	0	14		0	0	0	137250	0	313782	1127433		
7124	154	40213227	2006-08-10	2006-08-10 00:00:00	2006-08-10	2006-08-10 00:00:00	2006-08-10	581452		0	0	0		0	0	0	10470	0	113	40213227		
145507	3199	40213160	1973-10-10	1973-10-10 00:00:00	1973-10-10	1973-10-10 00:00:00	1973-10-10	581452		0	0	0		0	0	0	212744	0	10	40213160		
12158	1021	1127433	1992-09-24	1992-09-24 00:00:00	1992-10-15	1992-10-15 00:00:00	1992-10-15	38000177		0	0	21		0	0	0	67206	0	313782	1127433		
73361	1602	40213160	1963-09-25	1963-09-25 00:00:00	1963-09-25	1963-09-25 00:00:00	1963-09-25	581452		0	0	0		0	0	0	107532	0	10	40213160		
90024	1976	40213314	1984-02-27	1984-02-27 00:00:00	1984-02-27	1984-02-27 00:00:00	1984-02-27	581452		0	0	0		0	0	0	131376	0	49	40213314		
115723	2542	40213160	1964-02-07	1964-02-07 00:00:00	1964-02-07	1964-02-07 00:00:00	1964-02-07	581452		0	0	0		0	0	0	168201	0	10	40213160		
57950	4814	19133873	1944-07-28	1944-07-28 00:00:00	1944-08-09	1944-08-09 00:00:00	1944-08-09	38000177		0	0	12		0	0	0	320302	0	834061	19133873		
62652	5210	1713671	1984-04-27	1984-04-27 00:00:00	1984-05-11	1984-05-11 00:00:00	1984-05-11	38000177		0	0	14		0	0	0	346459	0	562251	1713671		
58043	4822	1713671	2013-04-04	2013-04-04 00:00:00	2013-04-11	2013-04-11 00:00:00	2013-04-11	38000177		0	0	7		0	0	0	320784	0	562251	1713671		
59779	4971	19075601	2008-01-15	2008-01-15 00:00:00	2008-01-15	2008-01-15 00:00:00	\N	38000177		0	0	0		0	0	0	330659	0	309362	19075601		
452	35	19129655	1964-07-10	1964-07-10 00:00:00	1964-07-24	1964-07-24 00:00:00	1964-07-24	38000177		0	0	14		0	0	0	2410	0	789980	19129655		
41417	902	40213198	2016-06-18	2016-06-18 00:00:00	2016-06-18	2016-06-18 00:00:00	2016-06-18	581452		0	0	0		0	0	0	59998	0	133	40213198		
14872	1245	40171902	2016-07-01	2016-07-01 00:00:00	2016-07-01	2016-07-01 00:00:00	\N	38000177		0	0	0		0	0	0	81923	0	897718	40171902		
152894	3365	40213296	2006-05-26	2006-05-26 00:00:00	2006-05-26	2006-05-26 00:00:00	2006-05-26	581452		0	0	0		0	0	0	223190	0	52	40213296		
46981	3891	1154615	1984-11-30	1984-11-30 00:00:00	1984-11-30	1984-11-30 00:00:00	\N	38000177		0	0	0		0	0	0	258627	0	745679	1154615		
10995	235	40213251	1986-04-21	1986-04-21 00:00:00	1986-04-21	1986-04-21 00:00:00	1986-04-21	581452		0	0	0		0	0	0	15776	0	21	40213251		
30020	2487	1127433	1980-11-17	1980-11-17 00:00:00	1980-12-01	1980-12-01 00:00:00	1980-12-01	38000177		0	0	14		0	0	0	164802	0	313782	1127433		
83234	1819	40213227	2008-08-19	2008-08-19 00:00:00	2008-08-19	2008-08-19 00:00:00	2008-08-19	581452		0	0	0		0	0	0	121681	0	113	40213227		
12779	276	40213227	2010-10-14	2010-10-14 00:00:00	2010-10-14	2010-10-14 00:00:00	2010-10-14	581452		0	0	0		0	0	0	18393	0	113	40213227		
48849	4051	1118084	2009-09-29	2009-09-29 00:00:00	2009-09-29	2009-09-29 00:00:00	\N	38000177		0	0	0		0	0	0	269283	0	00025152531	44923712		
6534	550	1127433	1983-06-20	1983-06-20 00:00:00	1983-06-27	1983-06-27 00:00:00	1983-06-27	38000177		0	0	7		0	0	0	36536	0	313782	1127433		
81901	1789	40213306	1997-05-01	1997-05-01 00:00:00	1997-05-01	1997-05-01 00:00:00	1997-05-01	581452		0	0	0		0	0	0	119903	0	43	40213306		
178311	3920	40213160	1973-05-05	1973-05-05 00:00:00	1973-05-05	1973-05-05 00:00:00	1973-05-05	581452		0	0	0		0	0	0	260678	0	10	40213160		
59467	4942	19006318	1954-11-25	1954-11-25 00:00:00	1954-12-09	1954-12-09 00:00:00	1954-12-09	38000177		0	0	14		0	0	0	328506	0	105078	19006318		
13253	1112	19059056	1967-01-09	1967-01-09 00:00:00	1967-01-23	1967-01-23 00:00:00	1967-01-23	38000177		0	0	14		0	0	0	73209	0	243670	19059056		
896	19	40213201	2015-09-27	2015-09-27 00:00:00	2015-09-27	2015-09-27 00:00:00	2015-09-27	581452		0	0	0		0	0	0	1536	0	33	40213201		
53480	4447	1127433	2015-01-05	2015-01-05 00:00:00	2015-01-12	2015-01-12 00:00:00	2015-01-12	38000177		0	0	7		0	0	0	295735	0	313782	1127433		
46468	1015	40213160	1956-04-02	1956-04-02 00:00:00	1956-04-02	1956-04-02 00:00:00	1956-04-02	581452		0	0	0		0	0	0	66799	0	10	40213160		
50992	4238	920334	1992-12-30	1992-12-30 00:00:00	1993-01-06	1993-01-06 00:00:00	1993-01-06	38000177		0	0	7		0	0	0	281405	0	311995	920334		
150516	3311	40213227	2007-03-28	2007-03-28 00:00:00	2007-03-28	2007-03-28 00:00:00	2007-03-28	581452		0	0	0		0	0	0	219784	0	113	40213227		
15007	1253	1127433	2000-03-22	2000-03-22 00:00:00	2000-04-05	2000-04-05 00:00:00	2000-04-05	38000177		0	0	14		0	0	0	82516	0	313782	1127433		
22137	1819	40236824	2006-06-29	2006-06-29 00:00:00	2006-07-06	2006-07-06 00:00:00	2006-07-06	38000177		0	0	7		0	0	0	121675	0	1094107	40236824		
61624	5128	1127433	1966-08-22	1966-08-22 00:00:00	1966-08-29	1966-08-29 00:00:00	1966-08-29	38000177		0	0	7		0	0	0	340939	0	313782	1127433		
14303	308	40213260	2009-07-21	2009-07-21 00:00:00	2009-07-21	2009-07-21 00:00:00	2009-07-21	581452		0	0	0		0	0	0	20452	0	121	40213260		
58581	1282	40213227	2018-03-03	2018-03-03 00:00:00	2018-03-03	2018-03-03 00:00:00	2018-03-03	581452		0	0	0		0	0	0	84755	0	113	40213227		
20655	1702	40165015	1979-07-08	1979-07-08 00:00:00	1979-07-08	1979-07-08 00:00:00	\N	38000177		0	0	0		0	0	0	113794	0	861467	40165015		
79658	1743	40213227	1996-04-17	1996-04-17 00:00:00	1996-04-17	1996-04-17 00:00:00	1996-04-17	581452		0	0	0		0	0	0	116539	0	113	40213227		
52152	4337	1713671	1962-01-10	1962-01-10 00:00:00	1962-01-17	1962-01-17 00:00:00	1962-01-17	38000177		0	0	7		0	0	0	287636	0	562251	1713671		
63582	5283	1127078	1975-08-21	1975-08-21 00:00:00	1975-11-19	1975-11-19 00:00:00	1975-11-19	38000177		0	0	90		0	0	0	351476	0	282464	1127078		
31307	2596	19059056	1969-05-31	1969-05-31 00:00:00	1969-06-14	1969-06-14 00:00:00	1969-06-14	38000177		0	0	14		0	0	0	171756	0	243670	19059056		
13761	1149	19078461	2007-10-21	2007-10-21 00:00:00	2008-01-19	2008-01-19 00:00:00	2008-01-19	38000177		0	0	90		0	0	0	75947	0	310965	19078461		
16277	351	40213314	1978-03-07	1978-03-07 00:00:00	1978-03-07	1978-03-07 00:00:00	1978-03-07	581452		0	0	0		0	0	0	23385	0	49	40213314		
2359	189	1713671	1997-09-20	1997-09-20 00:00:00	1997-10-11	1997-10-11 00:00:00	1997-10-11	38000177		0	0	21		0	0	0	12880	0	562251	1713671		
20079	1649	19133768	2017-08-23	2017-08-23 00:00:00	2017-08-23	2017-08-23 00:00:00	2017-08-23	38000177		0	0	0		0	0	0	110618	0	833036	19133768		
24395	2006	1127433	1959-11-28	1959-11-28 00:00:00	1959-12-05	1959-12-05 00:00:00	1959-12-05	38000177		0	0	7		0	0	0	133639	0	313782	1127433		
154350	3397	40213201	2011-01-22	2011-01-22 00:00:00	2011-01-22	2011-01-22 00:00:00	2011-01-22	581452		0	0	0		0	0	0	225379	0	33	40213201		
18490	1529	1713671	1991-09-18	1991-09-18 00:00:00	1991-10-09	1991-10-09 00:00:00	1991-10-09	38000177		0	0	21		0	0	0	102358	0	562251	1713671		
108815	2387	40213160	1969-11-01	1969-11-01 00:00:00	1969-11-01	1969-11-01 00:00:00	1969-11-01	581452		0	0	0		0	0	0	158771	0	10	40213160		
52444	4364	1118084	1987-05-16	1987-05-16 00:00:00	1987-05-16	1987-05-16 00:00:00	\N	38000177		0	0	0		0	0	0	289439	0	00025152531	44923712		
1949	155	1127433	2014-04-02	2014-04-02 00:00:00	2014-04-16	2014-04-16 00:00:00	2014-04-16	38000177		0	0	14		0	0	0	10556	0	313782	1127433		
63178	5249	1127433	1955-10-31	1955-10-31 00:00:00	1955-11-14	1955-11-14 00:00:00	1955-11-14	38000177		0	0	14		0	0	0	349182	0	313782	1127433		
2911	64	40213227	2006-05-10	2006-05-10 00:00:00	2006-05-10	2006-05-10 00:00:00	2006-05-10	581452		0	0	0		0	0	0	4347	0	113	40213227		
24984	2054	19059056	1974-01-09	1974-01-09 00:00:00	1974-01-23	1974-01-23 00:00:00	1974-01-23	38000177		0	0	14		0	0	0	136628	0	243670	19059056		
31382	2602	1127433	1972-10-17	1972-10-17 00:00:00	1972-10-24	1972-10-24 00:00:00	1972-10-24	38000177		0	0	7		0	0	0	172107	0	313782	1127433		
35440	2921	19078461	2005-11-09	2005-11-09 00:00:00	2005-11-30	2005-11-30 00:00:00	2005-11-30	38000177		0	0	21		0	0	0	194717	0	310965	19078461		
125612	2764	40213227	2005-07-29	2005-07-29 00:00:00	2005-07-29	2005-07-29 00:00:00	2005-07-29	581452		0	0	0		0	0	0	182766	0	113	40213227		
8434	704	19059056	1977-06-08	1977-06-08 00:00:00	1977-07-06	1977-07-06 00:00:00	1977-07-06	38000177		0	0	28		0	0	0	46512	0	243670	19059056		
12725	1072	1127433	2009-04-14	2009-04-14 00:00:00	2009-04-21	2009-04-21 00:00:00	2009-04-21	38000177		0	0	7		0	0	0	70264	0	313782	1127433		
19003	1569	19078461	1998-12-11	1998-12-11 00:00:00	1999-01-17	1999-01-17 00:00:00	1999-01-17	38000177		0	0	37		0	0	0	105229	0	310965	19078461		
88336	1937	40213227	1995-01-17	1995-01-17 00:00:00	1995-01-17	1995-01-17 00:00:00	1995-01-17	581452		0	0	0		0	0	0	128866	0	113	40213227		
30793	2551	19059056	1959-03-19	1959-03-19 00:00:00	1959-04-02	1959-04-02 00:00:00	1959-04-02	38000177		0	0	14		0	0	0	168879	0	243670	19059056		
52644	4376	19133905	1971-09-27	1971-09-27 00:00:00	1971-10-06	1971-10-06 00:00:00	1971-10-06	38000177		0	0	9		0	0	0	290737	0	834102	19133905		
27847	606	40213160	1975-07-23	1975-07-23 00:00:00	1975-07-23	1975-07-23 00:00:00	1975-07-23	581452		0	0	0		0	0	0	40250	0	10	40213160		
25073	2063	1127433	2018-08-06	2018-08-06 00:00:00	2018-08-13	2018-08-13 00:00:00	2018-08-13	38000177		0	0	7		0	0	0	137251	0	313782	1127433		
7125	154	40213314	1977-04-28	1977-04-28 00:00:00	1977-04-28	1977-04-28 00:00:00	1977-04-28	581452		0	0	0		0	0	0	10448	0	49	40213314		
145522	3200	40213227	1997-08-28	1997-08-28 00:00:00	1997-08-28	1997-08-28 00:00:00	1997-08-28	581452		0	0	0		0	0	0	212814	0	113	40213227		
12159	1021	19059056	1962-07-22	1962-07-22 00:00:00	1962-08-12	1962-08-12 00:00:00	1962-08-12	38000177		0	0	21		0	0	0	67204	0	243670	19059056		
84671	1852	40213160	1973-06-13	1973-06-13 00:00:00	1973-06-13	1973-06-13 00:00:00	1973-06-13	581452		0	0	0		0	0	0	123922	0	10	40213160		
90025	1976	40213251	1984-02-27	1984-02-27 00:00:00	1984-02-27	1984-02-27 00:00:00	1984-02-27	581452		0	0	0		0	0	0	131376	0	21	40213251		
115724	2542	40213306	1985-08-02	1985-08-02 00:00:00	1985-08-02	1985-08-02 00:00:00	1985-08-02	581452		0	0	0		0	0	0	168181	0	43	40213306		
57951	4814	19059056	1939-04-26	1939-04-26 00:00:00	1939-05-26	1939-05-26 00:00:00	1939-05-26	38000177		0	0	30		0	0	0	320292	0	243670	19059056		
62653	5210	1127433	2016-12-06	2016-12-06 00:00:00	2017-01-03	2017-01-03 00:00:00	2017-01-03	38000177		0	0	28		0	0	0	346450	0	313782	1127433		
58044	4822	920300	1989-10-21	1989-10-21 00:00:00	1989-10-28	1989-10-28 00:00:00	1989-10-28	38000177		0	0	7		0	0	0	320746	0	311989	920300		
59780	4971	40162522	2000-11-12	2000-11-12 00:00:00	2000-11-12	2000-11-12 00:00:00	\N	38000177		0	0	0		0	0	0	330514	0	857005	40162522		
453	35	1127078	1964-07-10	1964-07-10 00:00:00	1964-07-24	1964-07-24 00:00:00	1964-07-24	38000177		0	0	14		0	0	0	2410	0	282464	1127078		
15353	331	40213227	2007-04-26	2007-04-26 00:00:00	2007-04-26	2007-04-26 00:00:00	2007-04-26	581452		0	0	0		0	0	0	21848	0	113	40213227		
14873	1245	40163554	2016-07-01	2016-07-01 00:00:00	2016-07-01	2016-07-01 00:00:00	\N	38000177		0	0	0		0	0	0	81923	0	855332	40163554		
9111	194	40213160	1980-11-27	1980-11-27 00:00:00	1980-11-27	1980-11-27 00:00:00	1980-11-27	581452		0	0	0		0	0	0	13321	0	10	40213160		
46982	3891	40169216	1984-11-30	1984-11-30 00:00:00	1984-11-30	1984-11-30 00:00:00	\N	38000177		0	0	0		0	0	0	258627	0	895994	40169216		
10997	235	40213314	1981-10-19	1981-10-19 00:00:00	1981-10-19	1981-10-19 00:00:00	1981-10-19	581452		0	0	0		0	0	0	15773	0	49	40213314		
30021	2487	40236824	1979-04-08	1979-04-08 00:00:00	1979-04-15	1979-04-15 00:00:00	1979-04-15	38000177		0	0	7		0	0	0	164786	0	1094107	40236824		
163126	3589	40213251	1984-06-05	1984-06-05 00:00:00	1984-06-05	1984-06-05 00:00:00	1984-06-05	581452		0	0	0		0	0	0	238413	0	21	40213251		
12781	276	40213251	1984-04-26	1984-04-26 00:00:00	1984-04-26	1984-04-26 00:00:00	1984-04-26	581452		0	0	0		0	0	0	18426	0	21	40213251		
48850	4051	19019979	1977-08-15	1977-08-15 00:00:00	1977-08-29	1977-08-29 00:00:00	1977-08-29	38000177		0	0	14		0	0	0	269243	0	198405	19019979		
6535	550	1713671	1999-02-22	1999-02-22 00:00:00	1999-03-01	1999-03-01 00:00:00	1999-03-01	38000177		0	0	7		0	0	0	36441	0	562251	1713671		
81905	1789	40213227	2006-05-11	2006-05-11 00:00:00	2006-05-11	2006-05-11 00:00:00	2006-05-11	581452		0	0	0		0	0	0	119923	0	113	40213227		
178314	3920	40213160	1972-12-02	1972-12-02 00:00:00	1972-12-02	1972-12-02 00:00:00	1972-12-02	581452		0	0	0		0	0	0	260677	0	10	40213160		
59468	4942	19059056	1954-11-25	1954-11-25 00:00:00	1954-12-09	1954-12-09 00:00:00	1954-12-09	38000177		0	0	14		0	0	0	328506	0	243670	19059056		
13254	1112	46233988	1967-01-09	1967-01-09 00:00:00	1967-01-23	1967-01-23 00:00:00	1967-01-23	38000177		0	0	14		0	0	0	73209	0	1652673	46233988		
34006	743	40213160	1976-04-11	1976-04-11 00:00:00	1976-04-11	1976-04-11 00:00:00	1976-04-11	581452		0	0	0		0	0	0	49283	0	10	40213160		
53481	4447	1115171	2008-09-04	2008-09-04 00:00:00	2008-09-25	2008-09-25 00:00:00	2008-09-25	38000177		0	0	21		0	0	0	295721	0	849574	1115171		
46471	1015	40213160	1955-10-03	1955-10-03 00:00:00	1955-10-03	1955-10-03 00:00:00	1955-10-03	581452		0	0	0		0	0	0	66775	0	10	40213160		
50993	4238	1127433	1962-04-29	1962-04-29 00:00:00	1962-05-06	1962-05-06 00:00:00	1962-05-06	38000177		0	0	7		0	0	0	281402	0	313782	1127433		
150517	3311	40213260	2007-03-28	2007-03-28 00:00:00	2007-03-28	2007-03-28 00:00:00	2007-03-28	581452		0	0	0		0	0	0	219784	0	121	40213260		
15008	1253	19128065	1980-01-07	1980-01-07 00:00:00	1981-01-01	1981-01-01 00:00:00	1981-01-01	38000177		0	0	360		0	0	0	82497	0	749882	19128065		
22138	1819	920300	2006-06-29	2006-06-29 00:00:00	2006-07-06	2006-07-06 00:00:00	2006-07-06	38000177		0	0	7		0	0	0	121675	0	311989	920300		
61625	5128	19018935	2017-09-20	2017-09-20 00:00:00	2017-09-20	2017-09-20 00:00:00	\N	38000177		0	0	0		0	0	0	340994	0	197604	19018935		
14309	308	40213160	1960-03-29	1960-03-29 00:00:00	1960-03-29	1960-03-29 00:00:00	1960-03-29	581452		0	0	0		0	0	0	20429	0	10	40213160		
58582	1282	40213296	2018-03-03	2018-03-03 00:00:00	2018-03-03	2018-03-03 00:00:00	2018-03-03	581452		0	0	0		0	0	0	84755	0	52	40213296		
20656	1702	19059056	1965-11-26	1965-11-26 00:00:00	1965-12-10	1965-12-10 00:00:00	1965-12-10	38000177		0	0	14		0	0	0	113819	0	243670	19059056		
77833	1702	40213296	2005-10-10	2005-10-10 00:00:00	2005-10-10	2005-10-10 00:00:00	2005-10-10	581452		0	0	0		0	0	0	113788	0	52	40213296		
52153	4337	19129655	1961-11-14	1961-11-14 00:00:00	1961-11-28	1961-11-28 00:00:00	1961-11-28	38000177		0	0	14		0	0	0	287580	0	789980	19129655		
63583	5283	1713671	2005-05-26	2005-05-26 00:00:00	2005-06-09	2005-06-09 00:00:00	2005-06-09	38000177		0	0	14		0	0	0	351422	0	562251	1713671		
31308	2596	19006318	1969-05-31	1969-05-31 00:00:00	1969-06-14	1969-06-14 00:00:00	1969-06-14	38000177		0	0	14		0	0	0	171756	0	105078	19006318		
13762	1150	1127433	1982-05-24	1982-05-24 00:00:00	1982-06-07	1982-06-07 00:00:00	1982-06-07	38000177		0	0	14		0	0	0	76062	0	313782	1127433		
16278	351	40213160	1978-03-07	1978-03-07 00:00:00	1978-03-07	1978-03-07 00:00:00	1978-03-07	581452		0	0	0		0	0	0	23385	0	10	40213160		
2360	189	40236446	1972-05-07	1972-05-07 00:00:00	1976-05-16	1976-05-16 00:00:00	1976-05-16	38000177		0	0	1470		0	0	0	12892	0	1091392	40236446		
20080	1649	1124300	1993-05-17	1993-05-17 00:00:00	1993-05-17	1993-05-17 00:00:00	\N	38000177		0	0	0		0	0	0	110623	0	00781178901	45011828		
24397	2006	19078461	2000-09-13	2000-09-13 00:00:00	2000-10-04	2000-10-04 00:00:00	2000-10-04	38000177		0	0	21		0	0	0	133603	0	310965	19078461		
30273	2509	19133873	1976-06-20	1976-06-20 00:00:00	1976-07-02	1976-07-02 00:00:00	1976-07-02	38000177		0	0	12		0	0	0	166090	0	834061	19133873		
18491	1529	19006318	1968-02-07	1968-02-07 00:00:00	1968-02-21	1968-02-21 00:00:00	1968-02-21	38000177		0	0	14		0	0	0	102326	0	105078	19006318		
108823	2387	40213306	1991-04-27	1991-04-27 00:00:00	1991-04-27	1991-04-27 00:00:00	1991-04-27	581452		0	0	0		0	0	0	158772	0	43	40213306		
52445	4364	19059056	1960-10-09	1960-10-09 00:00:00	1960-11-08	1960-11-08 00:00:00	1960-11-08	38000177		0	0	30		0	0	0	289422	0	243670	19059056		
1950	155	1713671	1994-05-22	1994-05-22 00:00:00	1994-05-29	1994-05-29 00:00:00	1994-05-29	38000177		0	0	7		0	0	0	10553	0	562251	1713671		
63179	5249	1127433	2007-12-03	2007-12-03 00:00:00	2007-12-17	2007-12-17 00:00:00	2007-12-17	38000177		0	0	14		0	0	0	349186	0	313782	1127433		
2912	64	40213160	1975-04-02	1975-04-02 00:00:00	1975-04-02	1975-04-02 00:00:00	1975-04-02	581452		0	0	0		0	0	0	4351	0	10	40213160		
24985	2054	1127433	1985-05-11	1985-05-11 00:00:00	1985-05-25	1985-05-25 00:00:00	1985-05-25	38000177		0	0	14		0	0	0	136572	0	313782	1127433		
31384	2602	19006318	1948-11-28	1948-11-28 00:00:00	1948-12-12	1948-12-12 00:00:00	1948-12-12	38000177		0	0	14		0	0	0	172111	0	105078	19006318		
35441	2921	19059056	1940-07-18	1940-07-18 00:00:00	1940-08-01	1940-08-01 00:00:00	1940-08-01	38000177		0	0	14		0	0	0	194698	0	243670	19059056		
125613	2764	40213296	2013-08-30	2013-08-30 00:00:00	2013-08-30	2013-08-30 00:00:00	2013-08-30	581452		0	0	0		0	0	0	182780	0	52	40213296		
8435	704	1118084	2001-02-17	2001-02-17 00:00:00	2001-02-17	2001-02-17 00:00:00	\N	38000177		0	0	0		0	0	0	46643	0	00025152531	44923712		
12726	1072	19059056	1972-02-14	1972-02-14 00:00:00	1972-03-06	1972-03-06 00:00:00	1972-03-06	38000177		0	0	21		0	0	0	70285	0	243670	19059056		
19004	1569	19059056	1987-04-06	1987-04-06 00:00:00	1987-06-12	1987-06-12 00:00:00	1987-06-12	38000177		0	0	67		0	0	0	105228	0	243670	19059056		
88343	1937	40213160	1964-01-21	1964-01-21 00:00:00	1964-01-21	1964-01-21 00:00:00	1964-01-21	581452		0	0	0		0	0	0	128851	0	10	40213160		
30794	2551	1713671	1964-10-25	1964-10-25 00:00:00	1964-11-08	1964-11-08 00:00:00	1964-11-08	38000177		0	0	14		0	0	0	168895	0	562251	1713671		
52645	4376	1713671	1948-02-12	1948-02-12 00:00:00	1948-02-19	1948-02-19 00:00:00	1948-02-19	38000177		0	0	7		0	0	0	290828	0	562251	1713671		
27848	606	40213227	1997-04-30	1997-04-30 00:00:00	1997-04-30	1997-04-30 00:00:00	1997-04-30	581452		0	0	0		0	0	0	40236	0	113	40213227		
25074	2063	1118084	2014-05-19	2014-05-19 00:00:00	2014-05-19	2014-05-19 00:00:00	\N	38000177		0	0	0		0	0	0	137208	0	00025152531	44923712		
73212	1599	40213160	1961-01-16	1961-01-16 00:00:00	1961-01-16	1961-01-16 00:00:00	1961-01-16	581452		0	0	0		0	0	0	107297	0	10	40213160		
145526	3200	40213198	2012-04-26	2012-04-26 00:00:00	2012-04-26	2012-04-26 00:00:00	2012-04-26	581452		0	0	0		0	0	0	212820	0	133	40213198		
12160	1021	1127433	1993-09-10	1993-09-10 00:00:00	1993-10-15	1993-10-15 00:00:00	1993-10-15	38000177		0	0	35		0	0	0	67207	0	313782	1127433		
430	9	40213160	1979-03-29	1979-03-29 00:00:00	1979-03-29	1979-03-29 00:00:00	1979-03-29	581452		0	0	0		0	0	0	829	0	10	40213160		
90029	1976	40213160	1983-08-29	1983-08-29 00:00:00	1983-08-29	1983-08-29 00:00:00	1983-08-29	581452		0	0	0		0	0	0	131449	0	10	40213160		
115733	2543	40213160	1965-01-24	1965-01-24 00:00:00	1965-01-24	1965-01-24 00:00:00	1965-01-24	581452		0	0	0		0	0	0	168234	0	10	40213160		
57952	4814	1127433	1998-12-18	1998-12-18 00:00:00	1999-01-15	1999-01-15 00:00:00	1999-01-15	38000177		0	0	28		0	0	0	320249	0	313782	1127433		
62654	5210	1713671	1980-03-28	1980-03-28 00:00:00	1980-04-11	1980-04-11 00:00:00	1980-04-11	38000177		0	0	14		0	0	0	346457	0	562251	1713671		
58045	4822	40236824	1989-10-21	1989-10-21 00:00:00	1989-11-04	1989-11-04 00:00:00	1989-11-04	38000177		0	0	14		0	0	0	320746	0	1094107	40236824		
59781	4971	19078461	2000-11-12	2000-11-12 00:00:00	2000-12-12	2000-12-12 00:00:00	2000-12-12	38000177		0	0	30		0	0	0	330514	0	310965	19078461		
454	35	1713671	1990-10-23	1990-10-23 00:00:00	1990-11-06	1990-11-06 00:00:00	1990-11-06	38000177		0	0	14		0	0	0	2428	0	562251	1713671		
15361	331	40213227	2016-06-16	2016-06-16 00:00:00	2016-06-16	2016-06-16 00:00:00	2016-06-16	581452		0	0	0		0	0	0	21875	0	113	40213227		
14874	1245	1713671	1982-04-07	1982-04-07 00:00:00	1982-04-21	1982-04-21 00:00:00	1982-04-21	38000177		0	0	14		0	0	0	81941	0	562251	1713671		
9124	195	40213260	2008-03-17	2008-03-17 00:00:00	2008-03-17	2008-03-17 00:00:00	2008-03-17	581452		0	0	0		0	0	0	13366	0	121	40213260		
46983	3891	1713671	1988-11-03	1988-11-03 00:00:00	1988-11-24	1988-11-24 00:00:00	1988-11-24	38000177		0	0	21		0	0	0	258723	0	562251	1713671		
10998	235	40213160	1981-10-19	1981-10-19 00:00:00	1981-10-19	1981-10-19 00:00:00	1981-10-19	581452		0	0	0		0	0	0	15773	0	10	40213160		
30022	2487	920300	1979-04-08	1979-04-08 00:00:00	1979-04-15	1979-04-15 00:00:00	1979-04-15	38000177		0	0	7		0	0	0	164786	0	311989	920300		
163130	3589	40213314	1981-04-06	1981-04-06 00:00:00	1981-04-06	1981-04-06 00:00:00	1981-04-06	581452		0	0	0		0	0	0	238482	0	49	40213314		
5651	474	19019979	1978-03-23	1978-03-23 00:00:00	1978-04-27	1978-04-27 00:00:00	1978-04-27	38000177		0	0	35		0	0	0	31641	0	198405	19019979		
48851	4051	19129655	1977-08-15	1977-08-15 00:00:00	1977-08-29	1977-08-29 00:00:00	1977-08-29	38000177		0	0	14		0	0	0	269243	0	789980	19129655		
6536	550	19059056	1950-06-09	1950-06-09 00:00:00	1950-06-30	1950-06-30 00:00:00	1950-06-30	38000177		0	0	21		0	0	0	36446	0	243670	19059056		
66682	1459	40213227	1994-06-30	1994-06-30 00:00:00	1994-06-30	1994-06-30 00:00:00	1994-06-30	581452		0	0	0		0	0	0	97256	0	113	40213227		
178315	3920	40213160	1973-02-03	1973-02-03 00:00:00	1973-02-03	1973-02-03 00:00:00	1973-02-03	581452		0	0	0		0	0	0	260648	0	10	40213160		
59470	4942	40220960	2006-08-03	2006-08-03 00:00:00	2006-08-03	2006-08-03 00:00:00	2006-08-03	38000177		0	0	0		0	0	0	328522	0	1804799	40220960		
13255	1112	1127433	2000-06-11	2000-06-11 00:00:00	2000-06-18	2000-06-18 00:00:00	2000-06-18	38000177		0	0	7		0	0	0	73206	0	313782	1127433		
34008	743	40213227	2009-09-27	2009-09-27 00:00:00	2009-09-27	2009-09-27 00:00:00	2009-09-27	581452		0	0	0		0	0	0	49263	0	113	40213227		
53483	4447	19133873	1959-02-24	1959-02-24 00:00:00	1959-03-08	1959-03-08 00:00:00	1959-03-08	38000177		0	0	12		0	0	0	295705	0	834061	19133873		
46479	1016	40213260	2017-06-14	2017-06-14 00:00:00	2017-06-14	2017-06-14 00:00:00	2017-06-14	581452		0	0	0		0	0	0	66891	0	121	40213260		
50994	4238	40229134	1973-12-05	1973-12-05 00:00:00	1973-12-19	1973-12-19 00:00:00	1973-12-19	38000177		0	0	14		0	0	0	281403	0	1043400	40229134		
150523	3311	40213160	1956-08-29	1956-08-29 00:00:00	1956-08-29	1956-08-29 00:00:00	1956-08-29	581452		0	0	0		0	0	0	219818	0	10	40213160		
15009	1253	1713671	2000-06-16	2000-06-16 00:00:00	2000-07-07	2000-07-07 00:00:00	2000-07-07	38000177		0	0	21		0	0	0	82510	0	562251	1713671		
22139	1819	1115171	1999-09-26	1999-09-26 00:00:00	1999-10-10	1999-10-10 00:00:00	1999-10-10	38000177		0	0	14		0	0	0	121649	0	849574	1115171		
61626	5128	40171902	2017-09-20	2017-09-20 00:00:00	2017-09-20	2017-09-20 00:00:00	\N	38000177		0	0	0		0	0	0	340994	0	897718	40171902		
58537	1281	40213160	1970-09-12	1970-09-12 00:00:00	1970-09-12	1970-09-12 00:00:00	1970-09-12	581452		0	0	0		0	0	0	84690	0	10	40213160		
58585	1282	40213314	1977-06-11	1977-06-11 00:00:00	1977-06-11	1977-06-11 00:00:00	1977-06-11	581452		0	0	0		0	0	0	84764	0	49	40213314		
20657	1702	19129655	1965-11-26	1965-11-26 00:00:00	1965-12-10	1965-12-10 00:00:00	1965-12-10	38000177		0	0	14		0	0	0	113819	0	789980	19129655		
77835	1702	40213227	1996-02-04	1996-02-04 00:00:00	1996-02-04	1996-02-04 00:00:00	1996-02-04	581452		0	0	0		0	0	0	113844	0	113	40213227		
52154	4337	19059056	1961-11-14	1961-11-14 00:00:00	1961-11-28	1961-11-28 00:00:00	1961-11-28	38000177		0	0	14		0	0	0	287580	0	243670	19059056		
63584	5283	1127433	2008-05-08	2008-05-08 00:00:00	2008-05-15	2008-05-15 00:00:00	2008-05-15	38000177		0	0	7		0	0	0	351426	0	313782	1127433		
31309	2596	40231925	2017-04-02	2017-04-02 00:00:00	2017-04-02	2017-04-02 00:00:00	\N	38000177		0	0	0		0	0	0	171815	0	1049221	40231925		
13763	1150	1118084	1991-10-14	1991-10-14 00:00:00	1991-10-14	1991-10-14 00:00:00	\N	38000177		0	0	0		0	0	0	76084	0	00025152531	44923712		
16279	351	40213314	1979-02-06	1979-02-06 00:00:00	1979-02-06	1979-02-06 00:00:00	1979-02-06	581452		0	0	0		0	0	0	23375	0	49	40213314		
2361	189	1127078	1959-04-06	1959-04-06 00:00:00	1959-04-20	1959-04-20 00:00:00	1959-04-20	38000177		0	0	14		0	0	0	12840	0	282464	1127078		
20081	1649	40229134	1969-11-02	1969-11-02 00:00:00	1969-11-16	1969-11-16 00:00:00	1969-11-16	38000177		0	0	14		0	0	0	110673	0	1043400	40229134		
24398	2006	19078461	1986-08-30	1986-08-30 00:00:00	1986-09-27	1986-09-27 00:00:00	1986-09-27	38000177		0	0	28		0	0	0	133602	0	310965	19078461		
30274	2509	40229134	1979-04-27	1979-04-27 00:00:00	1979-05-11	1979-05-11 00:00:00	1979-05-11	38000177		0	0	14		0	0	0	166091	0	1043400	40229134		
18492	1529	19059056	1968-02-07	1968-02-07 00:00:00	1968-02-21	1968-02-21 00:00:00	1968-02-21	38000177		0	0	14		0	0	0	102326	0	243670	19059056		
108825	2387	40213160	1969-05-31	1969-05-31 00:00:00	1969-05-31	1969-05-31 00:00:00	1969-05-31	581452		0	0	0		0	0	0	158783	0	10	40213160		
52446	4364	40229134	2007-05-28	2007-05-28 00:00:00	2007-06-04	2007-06-04 00:00:00	2007-06-04	38000177		0	0	7		0	0	0	289451	0	1043400	40229134		
1951	155	1713671	1961-09-03	1961-09-03 00:00:00	1961-09-17	1961-09-17 00:00:00	1961-09-17	38000177		0	0	14		0	0	0	10615	0	562251	1713671		
63190	5251	40229134	1954-04-13	1954-04-13 00:00:00	1954-04-27	1954-04-27 00:00:00	1954-04-27	38000177		0	0	14		0	0	0	349364	0	1043400	40229134		
2915	64	40213314	1977-09-28	1977-09-28 00:00:00	1977-09-28	1977-09-28 00:00:00	1977-09-28	581452		0	0	0		0	0	0	4336	0	49	40213314		
24986	2054	19133873	1979-10-13	1979-10-13 00:00:00	1979-10-21	1979-10-21 00:00:00	1979-10-21	38000177		0	0	8		0	0	0	136585	0	834061	19133873		
31385	2602	19059056	1948-11-28	1948-11-28 00:00:00	1948-12-12	1948-12-12 00:00:00	1948-12-12	38000177		0	0	14		0	0	0	172111	0	243670	19059056		
35442	2921	19059056	1941-01-22	1941-01-22 00:00:00	1941-02-05	1941-02-05 00:00:00	1941-02-05	38000177		0	0	14		0	0	0	194769	0	243670	19059056		
125615	2764	40213160	1973-11-30	1973-11-30 00:00:00	1973-11-30	1973-11-30 00:00:00	1973-11-30	581452		0	0	0		0	0	0	182800	0	10	40213160		
8436	704	1127433	1999-06-23	1999-06-23 00:00:00	1999-07-21	1999-07-21 00:00:00	1999-07-21	38000177		0	0	28		0	0	0	46643	0	313782	1127433		
12727	1072	1713671	1994-12-02	1994-12-02 00:00:00	1994-12-09	1994-12-09 00:00:00	1994-12-09	38000177		0	0	7		0	0	0	70242	0	562251	1713671		
19005	1569	19059056	1973-01-14	1973-01-14 00:00:00	1973-02-18	1973-02-18 00:00:00	1973-02-18	38000177		0	0	35		0	0	0	105227	0	243670	19059056		
88349	1937	40213260	2013-05-14	2013-05-14 00:00:00	2013-05-14	2013-05-14 00:00:00	2013-05-14	581452		0	0	0		0	0	0	128860	0	121	40213260		
30795	2551	920300	2000-09-17	2000-09-17 00:00:00	2000-09-24	2000-09-24 00:00:00	2000-09-24	38000177		0	0	7		0	0	0	168858	0	311989	920300		
52646	4376	40165015	1956-10-20	1956-10-20 00:00:00	1956-10-20	1956-10-20 00:00:00	\N	38000177		0	0	0		0	0	0	290730	0	861467	40165015		
27849	606	40213306	1997-04-30	1997-04-30 00:00:00	1997-04-30	1997-04-30 00:00:00	1997-04-30	581452		0	0	0		0	0	0	40236	0	43	40213306		
25075	2063	19133873	1987-01-11	1987-01-11 00:00:00	1987-01-24	1987-01-24 00:00:00	1987-01-24	38000177		0	0	13		0	0	0	137203	0	834061	19133873		
73218	1600	40213201	2012-09-10	2012-09-10 00:00:00	2012-09-10	2012-09-10 00:00:00	2012-09-10	581452		0	0	0		0	0	0	107405	0	33	40213201		
211660	4641	40213227	2018-07-19	2018-07-19 00:00:00	2018-07-19	2018-07-19 00:00:00	2018-07-19	581452		0	0	0		0	0	0	309353	0	113	40213227		
12161	1021	1127433	1976-06-29	1976-06-29 00:00:00	1976-07-20	1976-07-20 00:00:00	1976-07-20	38000177		0	0	21		0	0	0	67205	0	313782	1127433		
10833	232	40213227	2006-01-04	2006-01-04 00:00:00	2006-01-04	2006-01-04 00:00:00	2006-01-04	581452		0	0	0		0	0	0	15594	0	113	40213227		
90032	1976	40213227	2014-03-03	2014-03-03 00:00:00	2014-03-03	2014-03-03 00:00:00	2014-03-03	581452		0	0	0		0	0	0	131409	0	113	40213227		
115737	2543	40213160	1965-06-27	1965-06-27 00:00:00	1965-06-27	1965-06-27 00:00:00	1965-06-27	581452		0	0	0		0	0	0	168235	0	10	40213160		
57953	4814	40229134	2000-05-07	2000-05-07 00:00:00	2000-05-14	2000-05-14 00:00:00	2000-05-14	38000177		0	0	7		0	0	0	320304	0	1043400	40229134		
62655	5210	1127433	2009-03-04	2009-03-04 00:00:00	2009-03-18	2009-03-18 00:00:00	2009-03-18	38000177		0	0	14		0	0	0	346449	0	313782	1127433		
58046	4822	19006318	1949-06-07	1949-06-07 00:00:00	1949-06-21	1949-06-21 00:00:00	1949-06-21	38000177		0	0	14		0	0	0	320748	0	105078	19006318		
59782	4971	1127433	1979-01-09	1979-01-09 00:00:00	1979-01-16	1979-01-16 00:00:00	1979-01-16	38000177		0	0	7		0	0	0	330651	0	313782	1127433		
455	35	1127433	1984-05-15	1984-05-15 00:00:00	1984-06-14	1984-06-14 00:00:00	1984-06-14	38000177		0	0	30		0	0	0	2392	0	313782	1127433		
15367	332	40213160	1968-01-12	1968-01-12 00:00:00	1968-01-12	1968-01-12 00:00:00	1968-01-12	581452		0	0	0		0	0	0	22028	0	10	40213160		
14875	1245	1127433	2011-05-29	2011-05-29 00:00:00	2011-06-05	2011-06-05 00:00:00	2011-06-05	38000177		0	0	7		0	0	0	81909	0	313782	1127433		
26729	582	40213160	1964-02-12	1964-02-12 00:00:00	1964-02-12	1964-02-12 00:00:00	1964-02-12	581452		0	0	0		0	0	0	38545	0	10	40213160		
46984	3891	1551192	1998-01-04	1998-01-04 00:00:00	1998-01-04	1998-01-04 00:00:00	1998-01-04	38000177		0	0	0		0	0	0	258753	0	312617	1551192		
11003	235	40213227	2014-06-16	2014-06-16 00:00:00	2014-06-16	2014-06-16 00:00:00	2014-06-16	581452		0	0	0		0	0	0	15766	0	113	40213227		
50567	4202	1127433	1995-02-10	1995-02-10 00:00:00	1995-02-24	1995-02-24 00:00:00	1995-02-24	38000177		0	0	14		0	0	0	278993	0	313782	1127433		
163131	3589	40213160	1981-04-06	1981-04-06 00:00:00	1981-04-06	1981-04-06 00:00:00	1981-04-06	581452		0	0	0		0	0	0	238482	0	10	40213160		
5652	474	46233988	1975-03-24	1975-03-24 00:00:00	1975-04-07	1975-04-07 00:00:00	1975-04-07	38000177		0	0	14		0	0	0	31655	0	1652673	46233988		
48852	4051	19059056	1979-04-15	1979-04-15 00:00:00	1979-04-29	1979-04-29 00:00:00	1979-04-29	38000177		0	0	14		0	0	0	269255	0	243670	19059056		
6537	550	40236824	1957-12-09	1957-12-09 00:00:00	1957-12-16	1957-12-16 00:00:00	1957-12-16	38000177		0	0	7		0	0	0	36533	0	1094107	40236824		
66691	1459	40213201	2009-09-24	2009-09-24 00:00:00	2009-09-24	2009-09-24 00:00:00	2009-09-24	581452		0	0	0		0	0	0	97236	0	33	40213201		
178319	3920	40213296	2012-09-01	2012-09-01 00:00:00	2012-09-01	2012-09-01 00:00:00	2012-09-01	581452		0	0	0		0	0	0	260667	0	52	40213296		
59471	4943	19133873	1971-12-05	1971-12-05 00:00:00	1971-12-14	1971-12-14 00:00:00	1971-12-14	38000177		0	0	9		0	0	0	328538	0	834061	19133873		
13256	1113	19128065	1985-11-12	1985-11-12 00:00:00	1986-11-07	1986-11-07 00:00:00	1986-11-07	38000177		0	0	360		0	0	0	73242	0	749882	19128065		
45291	987	40213227	1995-09-10	1995-09-10 00:00:00	1995-09-10	1995-09-10 00:00:00	1995-09-10	581452		0	0	0		0	0	0	65568	0	113	40213227		
53484	4447	19059056	1953-07-11	1953-07-11 00:00:00	1953-07-25	1953-07-25 00:00:00	1953-07-25	38000177		0	0	14		0	0	0	295728	0	243670	19059056		
46480	1016	40213296	2007-06-20	2007-06-20 00:00:00	2007-06-20	2007-06-20 00:00:00	2007-06-20	581452		0	0	0		0	0	0	66890	0	52	40213296		
50995	4238	40236824	1992-12-23	1992-12-23 00:00:00	1993-01-06	1993-01-06 00:00:00	1993-01-06	38000177		0	0	14		0	0	0	281363	0	1094107	40236824		
150525	3311	40213296	1996-03-27	1996-03-27 00:00:00	1996-03-27	1996-03-27 00:00:00	1996-03-27	581452		0	0	0		0	0	0	219873	0	52	40213296		
15010	1253	19128065	1979-01-12	1979-01-12 00:00:00	1980-01-07	1980-01-07 00:00:00	1980-01-07	38000177		0	0	360		0	0	0	82496	0	749882	19128065		
22140	1819	19075001	1999-09-26	1999-09-26 00:00:00	1999-10-10	1999-10-10 00:00:00	1999-10-10	38000177		0	0	14		0	0	0	121649	0	309097	19075001		
61627	5128	40163554	2017-09-20	2017-09-20 00:00:00	2017-09-20	2017-09-20 00:00:00	\N	38000177		0	0	0		0	0	0	340994	0	855332	40163554		
58539	1281	40213296	2011-12-24	2011-12-24 00:00:00	2011-12-24	2011-12-24 00:00:00	2011-12-24	581452		0	0	0		0	0	0	84656	0	52	40213296		
58588	1282	40213314	1977-03-12	1977-03-12 00:00:00	1977-03-12	1977-03-12 00:00:00	1977-03-12	581452		0	0	0		0	0	0	84770	0	49	40213314		
20658	1702	1118084	2008-10-07	2008-10-07 00:00:00	2008-10-07	2008-10-07 00:00:00	\N	38000177		0	0	0		0	0	0	113829	0	00025152531	44923712		
77841	1702	40213160	1965-02-07	1965-02-07 00:00:00	1965-02-07	1965-02-07 00:00:00	1965-02-07	581452		0	0	0		0	0	0	113777	0	10	40213160		
52155	4337	1713671	1976-11-29	1976-11-29 00:00:00	1976-12-06	1976-12-06 00:00:00	1976-12-06	38000177		0	0	7		0	0	0	287561	0	562251	1713671		
63585	5283	1127433	1982-06-16	1982-06-16 00:00:00	1982-06-23	1982-06-23 00:00:00	1982-06-23	38000177		0	0	7		0	0	0	351412	0	313782	1127433		
31310	2596	1127078	1968-03-04	1968-03-04 00:00:00	1968-03-18	1968-03-18 00:00:00	1968-03-18	38000177		0	0	14		0	0	0	171814	0	282464	1127078		
13764	1150	19059056	1953-12-22	1953-12-22 00:00:00	1954-02-20	1954-02-20 00:00:00	1954-02-20	38000177		0	0	60		0	0	0	76061	0	243670	19059056		
16283	351	40213251	1984-11-20	1984-11-20 00:00:00	1984-11-20	1984-11-20 00:00:00	1984-11-20	581452		0	0	0		0	0	0	23379	0	21	40213251		
2362	189	19006318	1959-04-06	1959-04-06 00:00:00	1959-04-20	1959-04-20 00:00:00	1959-04-20	38000177		0	0	14		0	0	0	12840	0	105078	19006318		
20082	1649	1127433	1972-10-09	1972-10-09 00:00:00	1972-10-30	1972-10-30 00:00:00	1972-10-30	38000177		0	0	21		0	0	0	110678	0	313782	1127433		
24399	2006	40243436	2014-01-17	2014-01-17 00:00:00	2014-01-17	2014-01-17 00:00:00	2014-01-17	38000177		0	0	0		0	0	0	133607	0	1190795	40243436		
30275	2509	19128065	1988-05-09	1988-05-09 00:00:00	1989-05-04	1989-05-04 00:00:00	1989-05-04	38000177		0	0	360		0	0	0	166102	0	749882	19128065		
18493	1529	19059056	1968-06-30	1968-06-30 00:00:00	1968-08-04	1968-08-04 00:00:00	1968-08-04	38000177		0	0	35		0	0	0	102353	0	243670	19059056		
108827	2387	40213160	1969-08-02	1969-08-02 00:00:00	1969-08-02	1969-08-02 00:00:00	1969-08-02	581452		0	0	0		0	0	0	158748	0	10	40213160		
52447	4364	19059056	1952-09-21	1952-09-21 00:00:00	1952-10-05	1952-10-05 00:00:00	1952-10-05	38000177		0	0	14		0	0	0	289456	0	243670	19059056		
1953	156	1127433	1982-07-05	1982-07-05 00:00:00	1982-07-12	1982-07-12 00:00:00	1982-07-12	38000177		0	0	7		0	0	0	10653	0	313782	1127433		
63191	5251	1713671	1970-08-09	1970-08-09 00:00:00	1970-08-23	1970-08-23 00:00:00	1970-08-23	38000177		0	0	14		0	0	0	349336	0	562251	1713671		
2920	65	40213260	2017-03-31	2017-03-31 00:00:00	2017-03-31	2017-03-31 00:00:00	2017-03-31	581452		0	0	0		0	0	0	4433	0	121	40213260		
24987	2054	19078461	2014-07-22	2014-07-22 00:00:00	2014-10-20	2014-10-20 00:00:00	2014-10-20	38000177		0	0	90		0	0	0	136590	0	310965	19078461		
31386	2602	19133905	2019-06-11	2019-06-11 00:00:00	2019-06-23	2019-06-23 00:00:00	2019-06-23	38000177		0	0	12		0	0	0	172161	0	834102	19133905		
35443	2921	19059056	1964-07-03	1964-07-03 00:00:00	1964-07-17	1964-07-17 00:00:00	1964-07-17	38000177		0	0	14		0	0	0	194737	0	243670	19059056		
125620	2764	40213160	1978-04-21	1978-04-21 00:00:00	1978-04-21	1978-04-21 00:00:00	1978-04-21	581452		0	0	0		0	0	0	182803	0	10	40213160		
8437	704	1713671	1970-09-10	1970-09-10 00:00:00	1970-09-17	1970-09-17 00:00:00	1970-09-17	38000177		0	0	7		0	0	0	46515	0	562251	1713671		
12728	1072	1124300	2000-07-28	2000-07-28 00:00:00	2000-07-28	2000-07-28 00:00:00	\N	38000177		0	0	0		0	0	0	70236	0	00781178901	45011828		
19006	1569	40229134	1974-08-15	1974-08-15 00:00:00	1974-08-22	1974-08-22 00:00:00	1974-08-22	38000177		0	0	7		0	0	0	105235	0	1043400	40229134		
169160	3719	40213227	2005-12-20	2005-12-20 00:00:00	2005-12-20	2005-12-20 00:00:00	2005-12-20	581452		0	0	0		0	0	0	247229	0	113	40213227		
30796	2551	40236824	2000-09-17	2000-09-17 00:00:00	2000-09-24	2000-09-24 00:00:00	2000-09-24	38000177		0	0	7		0	0	0	168858	0	1094107	40236824		
52647	4376	1127433	1956-10-20	1956-10-20 00:00:00	1956-11-24	1956-11-24 00:00:00	1956-11-24	38000177		0	0	35		0	0	0	290730	0	313782	1127433		
27851	606	40213314	1978-01-18	1978-01-18 00:00:00	1978-01-18	1978-01-18 00:00:00	1978-01-18	581452		0	0	0		0	0	0	40220	0	49	40213314		
25076	2063	1127433	1984-11-08	1984-11-08 00:00:00	1984-11-22	1984-11-22 00:00:00	1984-11-22	38000177		0	0	14		0	0	0	137202	0	313782	1127433		
73246	1600	40213227	1997-08-18	1997-08-18 00:00:00	1997-08-18	1997-08-18 00:00:00	1997-08-18	581452		0	0	0		0	0	0	107379	0	113	40213227		
211661	4641	40213260	2018-07-19	2018-07-19 00:00:00	2018-07-19	2018-07-19 00:00:00	2018-07-19	581452		0	0	0		0	0	0	309353	0	121	40213260		
12162	1021	19006318	1958-02-13	1958-02-13 00:00:00	1958-02-27	1958-02-27 00:00:00	1958-02-27	38000177		0	0	14		0	0	0	67189	0	105078	19006318		
53595	1174	40213227	2001-03-17	2001-03-17 00:00:00	2001-03-17	2001-03-17 00:00:00	2001-03-17	581452		0	0	0		0	0	0	77316	0	113	40213227		
90036	1976	40213227	2005-02-21	2005-02-21 00:00:00	2005-02-21	2005-02-21 00:00:00	2005-02-21	581452		0	0	0		0	0	0	131418	0	113	40213227		
115743	2543	40213227	1996-09-22	1996-09-22 00:00:00	1996-09-22	1996-09-22 00:00:00	1996-09-22	581452		0	0	0		0	0	0	168272	0	113	40213227		
57954	4814	19059056	1940-04-20	1940-04-20 00:00:00	1940-05-04	1940-05-04 00:00:00	1940-05-04	38000177		0	0	14		0	0	0	320305	0	243670	19059056		
62656	5210	19078461	1996-09-26	1996-09-26 00:00:00	1996-10-17	1996-10-17 00:00:00	1996-10-17	38000177		0	0	21		0	0	0	346447	0	310965	19078461		
58047	4822	19059056	1949-06-07	1949-06-07 00:00:00	1949-06-21	1949-06-21 00:00:00	1949-06-21	38000177		0	0	14		0	0	0	320748	0	243670	19059056		
36340	793	40213160	1973-11-15	1973-11-15 00:00:00	1973-11-15	1973-11-15 00:00:00	1973-11-15	581452		0	0	0		0	0	0	52629	0	10	40213160		
456	35	40162522	1984-05-15	1984-05-15 00:00:00	1984-05-15	1984-05-15 00:00:00	\N	38000177		0	0	0		0	0	0	2392	0	857005	40162522		
15370	332	40213227	2005-06-24	2005-06-24 00:00:00	2005-06-24	2005-06-24 00:00:00	2005-06-24	581452		0	0	0		0	0	0	21899	0	113	40213227		
14876	1245	1127433	1984-07-05	1984-07-05 00:00:00	1984-08-09	1984-08-09 00:00:00	1984-08-09	38000177		0	0	35		0	0	0	81900	0	313782	1127433		
26735	582	40213160	1959-11-11	1959-11-11 00:00:00	1959-11-11	1959-11-11 00:00:00	1959-11-11	581452		0	0	0		0	0	0	38535	0	10	40213160		
46985	3891	19059056	1986-11-03	1986-11-03 00:00:00	1987-01-02	1987-01-02 00:00:00	1987-01-02	38000177		0	0	60		0	0	0	258751	0	243670	19059056		
11006	235	40213160	1982-01-18	1982-01-18 00:00:00	1982-01-18	1982-01-18 00:00:00	1982-01-18	581452		0	0	0		0	0	0	15741	0	10	40213160		
50568	4202	40232448	1976-06-03	1976-06-03 00:00:00	1976-06-03	1976-06-03 00:00:00	\N	38000177		0	0	0		0	0	0	278980	0	1049630	40232448		
163132	3589	40213160	1981-09-08	1981-09-08 00:00:00	1981-09-08	1981-09-08 00:00:00	1981-09-08	581452		0	0	0		0	0	0	238483	0	10	40213160		
5653	474	1127078	1975-03-24	1975-03-24 00:00:00	1975-04-07	1975-04-07 00:00:00	1975-04-07	38000177		0	0	14		0	0	0	31655	0	282464	1127078		
48853	4051	19073183	1979-04-15	1979-04-15 00:00:00	1979-04-29	1979-04-29 00:00:00	1979-04-29	38000177		0	0	14		0	0	0	269255	0	308182	19073183		
6538	550	920300	1957-12-09	1957-12-09 00:00:00	1957-12-16	1957-12-16 00:00:00	1957-12-16	38000177		0	0	7		0	0	0	36533	0	311989	920300		
66698	1459	40213227	2014-10-23	2014-10-23 00:00:00	2014-10-23	2014-10-23 00:00:00	2014-10-23	581452		0	0	0		0	0	0	97215	0	113	40213227		
178337	3920	40213227	2004-05-22	2004-05-22 00:00:00	2004-05-22	2004-05-22 00:00:00	2004-05-22	581452		0	0	0		0	0	0	260664	0	113	40213227		
59472	4943	1118084	1996-03-09	1996-03-09 00:00:00	1996-03-09	1996-03-09 00:00:00	\N	38000177		0	0	0		0	0	0	328607	0	00025152531	44923712		
13257	1113	1127078	1974-08-10	1974-08-10 00:00:00	1974-08-24	1974-08-24 00:00:00	1974-08-24	38000177		0	0	14		0	0	0	73259	0	282464	1127078		
45300	987	40213227	2004-09-05	2004-09-05 00:00:00	2004-09-05	2004-09-05 00:00:00	2004-09-05	581452		0	0	0		0	0	0	65569	0	113	40213227		
53486	4447	1127433	1998-06-03	1998-06-03 00:00:00	1998-06-17	1998-06-17 00:00:00	1998-06-17	38000177		0	0	14		0	0	0	295779	0	313782	1127433		
46482	1016	40213306	1990-02-07	1990-02-07 00:00:00	1990-02-07	1990-02-07 00:00:00	1990-02-07	581452		0	0	0		0	0	0	66864	0	43	40213306		
50996	4238	920300	1992-12-23	1992-12-23 00:00:00	1992-12-30	1992-12-30 00:00:00	1992-12-30	38000177		0	0	7		0	0	0	281363	0	311989	920300		
150531	3311	40213227	1998-04-01	1998-04-01 00:00:00	1998-04-01	1998-04-01 00:00:00	1998-04-01	581452		0	0	0		0	0	0	219762	0	113	40213227		
13849	1158	1127433	2004-06-14	2004-06-14 00:00:00	2004-06-28	2004-06-28 00:00:00	2004-06-28	38000177		0	0	14		0	0	0	76528	0	313782	1127433		
22141	1819	1713671	1977-07-31	1977-07-31 00:00:00	1977-10-16	1977-10-16 00:00:00	1977-10-16	38000177		0	0	77		0	0	0	121687	0	562251	1713671		
61628	5128	40243436	1955-07-27	1955-07-27 00:00:00	1955-07-27	1955-07-27 00:00:00	1955-07-27	38000177		0	0	0		0	0	0	340918	0	1190795	40243436		
58541	1281	40213227	2011-12-24	2011-12-24 00:00:00	2011-12-24	2011-12-24 00:00:00	2011-12-24	581452		0	0	0		0	0	0	84656	0	113	40213227		
58590	1282	40213160	1976-09-11	1976-09-11 00:00:00	1976-09-11	1976-09-11 00:00:00	1976-09-11	581452		0	0	0		0	0	0	84763	0	10	40213160		
20659	1702	19133873	1970-08-05	1970-08-05 00:00:00	1970-08-15	1970-08-15 00:00:00	1970-08-15	38000177		0	0	10		0	0	0	113775	0	834061	19133873		
77859	1703	40213201	2015-05-13	2015-05-13 00:00:00	2015-05-13	2015-05-13 00:00:00	2015-05-13	581452		0	0	0		0	0	0	113849	0	33	40213201		
52156	4337	19133873	1974-08-04	1974-08-04 00:00:00	1974-08-15	1974-08-15 00:00:00	1974-08-15	38000177		0	0	11		0	0	0	287588	0	834061	19133873		
63586	5283	1115171	2013-12-04	2013-12-04 00:00:00	2014-01-08	2014-01-08 00:00:00	2014-01-08	38000177		0	0	35		0	0	0	351455	0	849574	1115171		
31311	2596	19078461	2017-03-26	2017-03-26 00:00:00	2017-06-01	2017-06-01 00:00:00	2017-06-01	38000177		0	0	67		0	0	0	171765	0	310965	19078461		
13765	1150	1713671	1998-06-20	1998-06-20 00:00:00	1998-07-11	1998-07-11 00:00:00	1998-07-11	38000177		0	0	21		0	0	0	76005	0	562251	1713671		
16286	351	40213160	1978-08-08	1978-08-08 00:00:00	1978-08-08	1978-08-08 00:00:00	1978-08-08	581452		0	0	0		0	0	0	23386	0	10	40213160		
2363	189	19059056	1970-01-08	1970-01-08 00:00:00	1970-02-07	1970-02-07 00:00:00	1970-02-07	38000177		0	0	30		0	0	0	12888	0	243670	19059056		
20083	1649	40229134	1985-01-05	1985-01-05 00:00:00	1985-01-12	1985-01-12 00:00:00	1985-01-12	38000177		0	0	7		0	0	0	110674	0	1043400	40229134		
24400	2006	46275916	2014-01-17	2014-01-17 00:00:00	2014-01-17	2014-01-17 00:00:00	2014-01-17	38000177		0	0	0		0	0	0	133607	0	1660014	46275916		
30276	2509	920300	2006-07-08	2006-07-08 00:00:00	2006-07-15	2006-07-15 00:00:00	2006-07-15	38000177		0	0	7		0	0	0	166099	0	311989	920300		
30523	665	40213260	2007-07-13	2007-07-13 00:00:00	2007-07-13	2007-07-13 00:00:00	2007-07-13	581452		0	0	0		0	0	0	43962	0	121	40213260		
32431	2688	1713671	2015-12-03	2015-12-03 00:00:00	2015-12-17	2015-12-17 00:00:00	2015-12-17	38000177		0	0	14		0	0	0	178154	0	562251	1713671		
52448	4364	19059056	1967-05-13	1967-05-13 00:00:00	1967-06-17	1967-06-17 00:00:00	1967-06-17	38000177		0	0	35		0	0	0	289424	0	243670	19059056		
1954	156	40229134	2005-06-23	2005-06-23 00:00:00	2005-06-30	2005-06-30 00:00:00	2005-06-30	38000177		0	0	7		0	0	0	10673	0	1043400	40229134		
63192	5251	1127433	1947-05-18	1947-05-18 00:00:00	1947-06-01	1947-06-01 00:00:00	1947-06-01	38000177		0	0	14		0	0	0	349340	0	313782	1127433		
2924	65	40213227	2009-06-05	2009-06-05 00:00:00	2009-06-05	2009-06-05 00:00:00	2009-06-05	581452		0	0	0		0	0	0	4444	0	113	40213227		
24988	2054	19078461	2019-06-26	2019-06-26 00:00:00	2019-06-26	2019-06-26 00:00:00	\N	38000177		0	0	0		0	0	0	136591	0	310965	19078461		
31387	2602	1127433	2018-02-20	2018-02-20 00:00:00	2018-03-20	2018-03-20 00:00:00	2018-03-20	38000177		0	0	28		0	0	0	172142	0	313782	1127433		
35444	2921	1713671	1995-12-24	1995-12-24 00:00:00	1995-12-31	1995-12-31 00:00:00	1995-12-31	38000177		0	0	7		0	0	0	194724	0	562251	1713671		
125625	2764	40213160	1974-05-03	1974-05-03 00:00:00	1974-05-03	1974-05-03 00:00:00	1974-05-03	581452		0	0	0		0	0	0	182801	0	10	40213160		
8438	704	1127433	1978-07-04	1978-07-04 00:00:00	1978-07-18	1978-07-18 00:00:00	1978-07-18	38000177		0	0	14		0	0	0	46581	0	313782	1127433		
12729	1072	1127078	1961-08-12	1961-08-12 00:00:00	1961-08-26	1961-08-26 00:00:00	1961-08-26	38000177		0	0	14		0	0	0	70212	0	282464	1127078		
19007	1569	920334	1972-10-08	1972-10-08 00:00:00	1972-10-15	1972-10-15 00:00:00	1972-10-15	38000177		0	0	7		0	0	0	105296	0	311995	920334		
169161	3719	40213296	2005-12-20	2005-12-20 00:00:00	2005-12-20	2005-12-20 00:00:00	2005-12-20	581452		0	0	0		0	0	0	247229	0	52	40213296		
30797	2551	1127433	2017-03-04	2017-03-04 00:00:00	2017-03-18	2017-03-18 00:00:00	2017-03-18	38000177		0	0	14		0	0	0	168899	0	313782	1127433		
52648	4376	19006318	1956-10-20	1956-10-20 00:00:00	1956-11-24	1956-11-24 00:00:00	1956-11-24	38000177		0	0	35		0	0	0	290730	0	105078	19006318		
27854	606	40213296	2018-05-23	2018-05-23 00:00:00	2018-05-23	2018-05-23 00:00:00	2018-05-23	581452		0	0	0		0	0	0	40213	0	52	40213296		
25077	2063	1713671	1973-11-11	1973-11-11 00:00:00	1973-11-25	1973-11-25 00:00:00	1973-11-25	38000177		0	0	14		0	0	0	137227	0	562251	1713671		
73250	1600	40213227	2017-10-09	2017-10-09 00:00:00	2017-10-09	2017-10-09 00:00:00	2017-10-09	581452		0	0	0		0	0	0	107384	0	113	40213227		
89906	1973	40213160	1971-11-15	1971-11-15 00:00:00	1971-11-15	1971-11-15 00:00:00	1971-11-15	581452		0	0	0		0	0	0	131165	0	10	40213160		
12163	1021	19059056	1958-02-13	1958-02-13 00:00:00	1958-02-27	1958-02-27 00:00:00	1958-02-27	38000177		0	0	14		0	0	0	67189	0	243670	19059056		
53615	1174	40213201	2006-04-16	2006-04-16 00:00:00	2006-04-16	2006-04-16 00:00:00	2006-04-16	581452		0	0	0		0	0	0	77385	0	33	40213201		
90037	1976	40213306	2005-02-21	2005-02-21 00:00:00	2005-02-21	2005-02-21 00:00:00	2005-02-21	581452		0	0	0		0	0	0	131418	0	43	40213306		
115750	2543	40213296	2004-10-24	2004-10-24 00:00:00	2004-10-24	2004-10-24 00:00:00	2004-10-24	581452		0	0	0		0	0	0	168216	0	52	40213296		
57955	4815	1118084	2008-09-06	2008-09-06 00:00:00	2008-09-06	2008-09-06 00:00:00	\N	38000177		0	0	0		0	0	0	320321	0	00025152531	44923712		
62657	5210	19133873	1974-01-26	1974-01-26 00:00:00	1974-02-02	1974-02-02 00:00:00	1974-02-02	38000177		0	0	7		0	0	0	346474	0	834061	19133873		
58048	4822	1127433	1947-10-26	1947-10-26 00:00:00	1947-11-02	1947-11-02 00:00:00	1947-11-02	38000177		0	0	7		0	0	0	320739	0	313782	1127433		
36341	793	40213160	1973-09-13	1973-09-13 00:00:00	1973-09-13	1973-09-13 00:00:00	1973-09-13	581452		0	0	0		0	0	0	52605	0	10	40213160		
457	35	1713671	1984-02-18	1984-02-18 00:00:00	1984-02-25	1984-02-25 00:00:00	1984-02-25	38000177		0	0	7		0	0	0	2404	0	562251	1713671		
15371	332	40213296	2005-06-24	2005-06-24 00:00:00	2005-06-24	2005-06-24 00:00:00	2005-06-24	581452		0	0	0		0	0	0	21899	0	52	40213296		
14877	1245	1713671	1991-06-17	1991-06-17 00:00:00	1991-07-01	1991-07-01 00:00:00	1991-07-01	38000177		0	0	14		0	0	0	81983	0	562251	1713671		
26743	582	40213296	1999-03-10	1999-03-10 00:00:00	1999-03-10	1999-03-10 00:00:00	1999-03-10	581452		0	0	0		0	0	0	38605	0	52	40213296		
46986	3891	1115171	2007-10-14	2007-10-14 00:00:00	2007-11-04	2007-11-04 00:00:00	2007-11-04	38000177		0	0	21		0	0	0	258754	0	849574	1115171		
11007	235	40213314	1982-07-19	1982-07-19 00:00:00	1982-07-19	1982-07-19 00:00:00	1982-07-19	581452		0	0	0		0	0	0	15774	0	49	40213314		
50569	4202	1551192	1972-10-06	1972-10-06 00:00:00	1972-10-06	1972-10-06 00:00:00	1972-10-06	38000177		0	0	0		0	0	0	278926	0	312617	1551192		
144712	3181	40213160	1955-06-10	1955-06-10 00:00:00	1955-06-10	1955-06-10 00:00:00	1955-06-10	581452		0	0	0		0	0	0	211633	0	10	40213160		
5654	474	1713671	1976-03-17	1976-03-17 00:00:00	1976-03-24	1976-03-24 00:00:00	1976-03-24	38000177		0	0	7		0	0	0	31626	0	562251	1713671		
48854	4051	1127433	1993-10-08	1993-10-08 00:00:00	1993-10-29	1993-10-29 00:00:00	1993-10-29	38000177		0	0	21		0	0	0	269262	0	313782	1127433		
6539	550	1127433	1963-09-30	1963-09-30 00:00:00	1963-10-07	1963-10-07 00:00:00	1963-10-07	38000177		0	0	7		0	0	0	36454	0	313782	1127433		
66717	1460	40213314	1982-08-07	1982-08-07 00:00:00	1982-08-07	1982-08-07 00:00:00	1982-08-07	581452		0	0	0		0	0	0	97310	0	49	40213314		
178340	3920	40213160	1977-04-30	1977-04-30 00:00:00	1977-04-30	1977-04-30 00:00:00	1977-04-30	581452		0	0	0		0	0	0	260681	0	10	40213160		
59473	4943	1127433	2014-09-30	2014-09-30 00:00:00	2014-10-14	2014-10-14 00:00:00	2014-10-14	38000177		0	0	14		0	0	0	328582	0	313782	1127433		
13258	1113	19129655	1974-08-10	1974-08-10 00:00:00	1974-08-24	1974-08-24 00:00:00	1974-08-24	38000177		0	0	14		0	0	0	73259	0	789980	19129655		
45302	987	40213160	1955-02-06	1955-02-06 00:00:00	1955-02-06	1955-02-06 00:00:00	1955-02-06	581452		0	0	0		0	0	0	65565	0	10	40213160		
53487	4447	1127078	1955-08-30	1955-08-30 00:00:00	1955-09-29	1955-09-29 00:00:00	1955-09-29	38000177		0	0	30		0	0	0	295712	0	282464	1127078		
46487	1016	40213160	1967-11-22	1967-11-22 00:00:00	1967-11-22	1967-11-22 00:00:00	1967-11-22	581452		0	0	0		0	0	0	66912	0	10	40213160		
50997	4238	40162522	2013-06-25	2013-06-25 00:00:00	2013-06-25	2013-06-25 00:00:00	\N	38000177		0	0	0		0	0	0	281438	0	857005	40162522		
150532	3311	40213296	1998-04-01	1998-04-01 00:00:00	1998-04-01	1998-04-01 00:00:00	1998-04-01	581452		0	0	0		0	0	0	219762	0	52	40213296		
13850	1158	1118084	2016-12-13	2016-12-13 00:00:00	2016-12-13	2016-12-13 00:00:00	\N	38000177		0	0	0		0	0	0	76518	0	00025152531	44923712		
22142	1819	40229134	1989-08-20	1989-08-20 00:00:00	1989-08-27	1989-08-27 00:00:00	1989-08-27	38000177		0	0	7		0	0	0	121645	0	1043400	40229134		
61629	5128	19059056	1929-08-25	1929-08-25 00:00:00	1929-09-08	1929-09-08 00:00:00	1929-09-08	38000177		0	0	14		0	0	0	340979	0	243670	19059056		
58544	1281	40213227	2003-12-13	2003-12-13 00:00:00	2003-12-13	2003-12-13 00:00:00	2003-12-13	581452		0	0	0		0	0	0	84653	0	113	40213227		
58592	1282	40213160	1976-07-10	1976-07-10 00:00:00	1976-07-10	1976-07-10 00:00:00	1976-07-10	581452		0	0	0		0	0	0	84742	0	10	40213160		
20660	1703	40231925	2019-05-18	2019-05-18 00:00:00	2019-05-18	2019-05-18 00:00:00	\N	38000177		0	0	0		0	0	0	113888	0	1049221	40231925		
77865	1703	40213227	2000-02-16	2000-02-16 00:00:00	2000-02-16	2000-02-16 00:00:00	2000-02-16	581452		0	0	0		0	0	0	113845	0	113	40213227		
52157	4337	1127433	1964-12-31	1964-12-31 00:00:00	1965-01-14	1965-01-14 00:00:00	1965-01-14	38000177		0	0	14		0	0	0	287637	0	313782	1127433		
63587	5283	1127078	1982-11-12	1982-11-12 00:00:00	1982-12-17	1982-12-17 00:00:00	1982-12-17	38000177		0	0	35		0	0	0	351477	0	282464	1127078		
31312	2596	1127078	1967-03-28	1967-03-28 00:00:00	1967-04-11	1967-04-11 00:00:00	1967-04-11	38000177		0	0	14		0	0	0	171751	0	282464	1127078		
13766	1150	19133873	1959-08-25	1959-08-25 00:00:00	1959-09-02	1959-09-02 00:00:00	1959-09-02	38000177		0	0	8		0	0	0	75998	0	834061	19133873		
27571	600	40213260	2006-05-31	2006-05-31 00:00:00	2006-05-31	2006-05-31 00:00:00	2006-05-31	581452		0	0	0		0	0	0	39596	0	121	40213260		
2364	189	1127433	1984-11-20	1984-11-20 00:00:00	1984-12-11	1984-12-11 00:00:00	1984-12-11	38000177		0	0	21		0	0	0	12889	0	313782	1127433		
20084	1649	1127433	1994-10-26	1994-10-26 00:00:00	1994-11-02	1994-11-02 00:00:00	1994-11-02	38000177		0	0	7		0	0	0	110675	0	313782	1127433		
24401	2006	1310034	2014-01-17	2014-01-17 00:00:00	2014-01-17	2014-01-17 00:00:00	2014-01-17	38000177		0	0	0		0	0	0	133607	0	834357	1310034		
30277	2509	40236824	2006-07-08	2006-07-08 00:00:00	2006-07-15	2006-07-15 00:00:00	2006-07-15	38000177		0	0	7		0	0	0	166099	0	1094107	40236824		
30526	665	40213160	1955-10-07	1955-10-07 00:00:00	1955-10-07	1955-10-07 00:00:00	1955-10-07	581452		0	0	0		0	0	0	43984	0	10	40213160		
32432	2688	1713671	2010-12-16	2010-12-16 00:00:00	2010-12-23	2010-12-23 00:00:00	2010-12-23	38000177		0	0	7		0	0	0	178153	0	562251	1713671		
52449	4364	1713671	2013-06-03	2013-06-03 00:00:00	2013-06-24	2013-06-24 00:00:00	2013-06-24	38000177		0	0	21		0	0	0	289497	0	562251	1713671		
1955	156	1713671	1981-12-11	1981-12-11 00:00:00	1981-12-18	1981-12-18 00:00:00	1981-12-18	38000177		0	0	7		0	0	0	10693	0	562251	1713671		
63193	5251	19133873	1933-01-04	1933-01-04 00:00:00	1933-01-11	1933-01-11 00:00:00	1933-01-11	38000177		0	0	7		0	0	0	349338	0	834061	19133873		
2925	65	40213296	2009-06-05	2009-06-05 00:00:00	2009-06-05	2009-06-05 00:00:00	2009-06-05	581452		0	0	0		0	0	0	4444	0	52	40213296		
18229	1510	1127433	1970-05-21	1970-05-21 00:00:00	1970-06-04	1970-06-04 00:00:00	1970-06-04	38000177		0	0	14		0	0	0	100779	0	313782	1127433		
31388	2602	1127433	1948-11-30	1948-11-30 00:00:00	1948-12-14	1948-12-14 00:00:00	1948-12-14	38000177		0	0	14		0	0	0	172071	0	313782	1127433		
35445	2921	40231925	1989-05-07	1989-05-07 00:00:00	1989-05-07	1989-05-07 00:00:00	\N	38000177		0	0	0		0	0	0	194716	0	1049221	40231925		
125626	2764	40213314	1977-01-28	1977-01-28 00:00:00	1977-01-28	1977-01-28 00:00:00	1977-01-28	581452		0	0	0		0	0	0	182817	0	49	40213314		
8439	704	1713671	2015-09-28	2015-09-28 00:00:00	2015-10-19	2015-10-19 00:00:00	2015-10-19	38000177		0	0	21		0	0	0	46525	0	562251	1713671		
12730	1073	40229134	1966-11-24	1966-11-24 00:00:00	1966-12-01	1966-12-01 00:00:00	1966-12-01	38000177		0	0	7		0	0	0	70408	0	1043400	40229134		
19008	1569	19059056	1957-05-17	1957-05-17 00:00:00	1957-06-07	1957-06-07 00:00:00	1957-06-07	38000177		0	0	21		0	0	0	105226	0	243670	19059056		
169162	3719	40213260	2013-01-08	2013-01-08 00:00:00	2013-01-08	2013-01-08 00:00:00	2013-01-08	581452		0	0	0		0	0	0	247190	0	121	40213260		
30798	2551	1118084	1998-06-27	1998-06-27 00:00:00	1998-06-27	1998-06-27 00:00:00	\N	38000177		0	0	0		0	0	0	168878	0	00025152531	44923712		
52649	4376	19018935	1978-07-18	1978-07-18 00:00:00	1978-07-18	1978-07-18 00:00:00	\N	38000177		0	0	0		0	0	0	290796	0	197604	19018935		
27861	606	40213160	1980-02-06	1980-02-06 00:00:00	1980-02-06	1980-02-06 00:00:00	1980-02-06	581452		0	0	0		0	0	0	40222	0	10	40213160		
25078	2063	1127078	1979-05-08	1979-05-08 00:00:00	1979-06-12	1979-06-12 00:00:00	1979-06-12	38000177		0	0	35		0	0	0	137201	0	282464	1127078		
160927	3541	40213227	2018-08-13	2018-08-13 00:00:00	2018-08-13	2018-08-13 00:00:00	2018-08-13	581452		0	0	0		0	0	0	235191	0	113	40213227		
89908	1973	40213160	1972-02-14	1972-02-14 00:00:00	1972-02-14	1972-02-14 00:00:00	1972-02-14	581452		0	0	0		0	0	0	131158	0	10	40213160		
12165	1022	1124300	2006-07-09	2006-07-09 00:00:00	2006-07-09	2006-07-09 00:00:00	\N	38000177		0	0	0		0	0	0	67215	0	00781178901	45011828		
53618	1174	40213227	2011-05-15	2011-05-15 00:00:00	2011-05-15	2011-05-15 00:00:00	2011-05-15	581452		0	0	0		0	0	0	77405	0	113	40213227		
50673	1110	40213160	1982-11-22	1982-11-22 00:00:00	1982-11-22	1982-11-22 00:00:00	1982-11-22	581452		0	0	0		0	0	0	73138	0	10	40213160		
193938	4261	40213227	2003-12-21	2003-12-21 00:00:00	2003-12-21	2003-12-21 00:00:00	2003-12-21	581452		0	0	0		0	0	0	282926	0	113	40213227		
57956	4815	40162522	1988-08-25	1988-08-25 00:00:00	1988-08-25	1988-08-25 00:00:00	\N	38000177		0	0	0		0	0	0	320334	0	857005	40162522		
62658	5210	1115171	2000-05-29	2000-05-29 00:00:00	2000-06-19	2000-06-19 00:00:00	2000-06-19	38000177		0	0	21		0	0	0	346448	0	849574	1115171		
58049	4822	19059056	1967-08-29	1967-08-29 00:00:00	1967-09-12	1967-09-12 00:00:00	1967-09-12	38000177		0	0	14		0	0	0	320726	0	243670	19059056		
36346	793	40213160	1974-02-14	1974-02-14 00:00:00	1974-02-14	1974-02-14 00:00:00	1974-02-14	581452		0	0	0		0	0	0	52606	0	10	40213160		
458	35	19128065	1978-03-03	1978-03-03 00:00:00	1979-02-26	1979-02-26 00:00:00	1979-02-26	38000177		0	0	360		0	0	0	2411	0	749882	19128065		
1267	101	1127433	1945-06-01	1945-06-01 00:00:00	1945-06-08	1945-06-08 00:00:00	1945-06-08	38000177		0	0	7		0	0	0	6933	0	313782	1127433		
14878	1245	1127433	1948-11-11	1948-11-11 00:00:00	1948-11-25	1948-11-25 00:00:00	1948-11-25	38000177		0	0	14		0	0	0	81937	0	313782	1127433		
232503	5108	40213227	1992-04-06	1992-04-06 00:00:00	1992-04-06	1992-04-06 00:00:00	1992-04-06	581452		0	0	0		0	0	0	339408	0	113	40213227		
46987	3891	1127433	2002-08-12	2002-08-12 00:00:00	2002-08-19	2002-08-19 00:00:00	2002-08-19	38000177		0	0	7		0	0	0	258690	0	313782	1127433		
11014	235	40213227	2004-01-12	2004-01-12 00:00:00	2004-01-12	2004-01-12 00:00:00	2004-01-12	581452		0	0	0		0	0	0	15762	0	113	40213227		
50570	4202	19133873	1981-12-30	1981-12-30 00:00:00	1982-01-11	1982-01-11 00:00:00	1982-01-11	38000177		0	0	12		0	0	0	278982	0	834061	19133873		
144715	3181	40213227	2012-10-12	2012-10-12 00:00:00	2012-10-12	2012-10-12 00:00:00	2012-10-12	581452		0	0	0		0	0	0	211833	0	113	40213227		
5655	474	1127078	1974-02-21	1974-02-21 00:00:00	1974-03-07	1974-03-07 00:00:00	1974-03-07	38000177		0	0	14		0	0	0	31611	0	282464	1127078		
8043	173	40213306	1990-07-29	1990-07-29 00:00:00	1990-07-29	1990-07-29 00:00:00	1990-07-29	581452		0	0	0		0	0	0	11757	0	43	40213306		
6540	550	836659	1996-10-16	1996-10-16 00:00:00	1996-10-16	1996-10-16 00:00:00	\N	38000177		0	0	0		0	0	0	36499	0	313185	836659		
66720	1460	40213227	2004-04-10	2004-04-10 00:00:00	2004-04-10	2004-04-10 00:00:00	2004-04-10	581452		0	0	0		0	0	0	97294	0	113	40213227		
178341	3920	40213314	1977-04-30	1977-04-30 00:00:00	1977-04-30	1977-04-30 00:00:00	1977-04-30	581452		0	0	0		0	0	0	260681	0	49	40213314		
59474	4943	1713671	2000-07-15	2000-07-15 00:00:00	2000-08-05	2000-08-05 00:00:00	2000-08-05	38000177		0	0	21		0	0	0	328543	0	562251	1713671		
13259	1113	19128065	1989-10-30	1989-10-30 00:00:00	1990-10-25	1990-10-25 00:00:00	1990-10-25	38000177		0	0	360		0	0	0	73261	0	749882	19128065		
45304	987	40213198	2019-06-02	2019-06-02 00:00:00	2019-06-02	2019-06-02 00:00:00	2019-06-02	581452		0	0	0		0	0	0	65552	0	133	40213198		
53488	4447	19078461	2012-10-04	2012-10-04 00:00:00	2012-10-25	2012-10-25 00:00:00	2012-10-25	38000177		0	0	21		0	0	0	295723	0	310965	19078461		
46488	1016	40213160	1967-09-20	1967-09-20 00:00:00	1967-09-20	1967-09-20 00:00:00	1967-09-20	581452		0	0	0		0	0	0	66868	0	10	40213160		
50998	4238	19059056	1963-04-23	1963-04-23 00:00:00	1963-05-07	1963-05-07 00:00:00	1963-05-07	38000177		0	0	14		0	0	0	281374	0	243670	19059056		
48345	1058	40213296	1999-07-17	1999-07-17 00:00:00	1999-07-17	1999-07-17 00:00:00	1999-07-17	581452		0	0	0		0	0	0	69376	0	52	40213296		
13851	1158	1115171	2017-02-14	2017-02-14 00:00:00	2017-03-14	2017-03-14 00:00:00	2017-03-14	38000177		0	0	28		0	0	0	76474	0	849574	1115171		
22143	1819	40229134	1998-04-13	1998-04-13 00:00:00	1998-04-27	1998-04-27 00:00:00	1998-04-27	38000177		0	0	14		0	0	0	121674	0	1043400	40229134		
61630	5128	46275916	1955-07-27	1955-07-27 00:00:00	1955-07-27	1955-07-27 00:00:00	1955-07-27	38000177		0	0	0		0	0	0	340918	0	1660014	46275916		
58552	1281	40213306	1992-04-04	1992-04-04 00:00:00	1992-04-04	1992-04-04 00:00:00	1992-04-04	581452		0	0	0		0	0	0	84650	0	43	40213306		
58595	1282	40213227	2007-11-17	2007-11-17 00:00:00	2007-11-17	2007-11-17 00:00:00	2007-11-17	581452		0	0	0		0	0	0	84714	0	113	40213227		
20661	1703	1127433	1954-05-28	1954-05-28 00:00:00	1954-06-04	1954-06-04 00:00:00	1954-06-04	38000177		0	0	7		0	0	0	113853	0	313782	1127433		
35041	2894	19059056	1923-01-07	1923-01-07 00:00:00	1923-02-13	1923-02-13 00:00:00	1923-02-13	38000177		0	0	37		0	0	0	192620	0	243670	19059056		
52158	4337	19059056	1966-12-01	1966-12-01 00:00:00	1967-01-05	1967-01-05 00:00:00	1967-01-05	38000177		0	0	35		0	0	0	287615	0	243670	19059056		
63588	5283	19128022	1989-08-17	1989-08-17 00:00:00	1990-08-12	1990-08-12 00:00:00	1990-08-12	38000177		0	0	360		0	0	0	351432	0	749785	19128022		
31313	2596	46233988	1967-03-28	1967-03-28 00:00:00	1967-04-11	1967-04-11 00:00:00	1967-04-11	38000177		0	0	14		0	0	0	171751	0	1652673	46233988		
13767	1150	19133905	1973-05-25	1973-05-25 00:00:00	1973-06-02	1973-06-02 00:00:00	1973-06-02	38000177		0	0	8		0	0	0	76002	0	834102	19133905		
27578	600	40213160	1955-12-14	1955-12-14 00:00:00	1955-12-14	1955-12-14 00:00:00	1955-12-14	581452		0	0	0		0	0	0	39588	0	10	40213160		
2365	189	1127078	1961-11-05	1961-11-05 00:00:00	1961-11-19	1961-11-19 00:00:00	1961-11-19	38000177		0	0	14		0	0	0	12882	0	282464	1127078		
20085	1649	1127433	1988-03-31	1988-03-31 00:00:00	1988-04-21	1988-04-21 00:00:00	1988-04-21	38000177		0	0	21		0	0	0	110617	0	313782	1127433		
24402	2006	19133873	1948-02-08	1948-02-08 00:00:00	1948-02-19	1948-02-19 00:00:00	1948-02-19	38000177		0	0	11		0	0	0	133591	0	834061	19133873		
30278	2509	19133873	1983-10-26	1983-10-26 00:00:00	1983-11-03	1983-11-03 00:00:00	1983-11-03	38000177		0	0	8		0	0	0	166095	0	834061	19133873		
30533	665	40213296	1997-08-15	1997-08-15 00:00:00	1997-08-15	1997-08-15 00:00:00	1997-08-15	581452		0	0	0		0	0	0	43934	0	52	40213296		
32440	2690	1127433	1956-11-19	1956-11-19 00:00:00	1956-11-26	1956-11-26 00:00:00	1956-11-26	38000177		0	0	7		0	0	0	178228	0	313782	1127433		
52450	4364	19006318	1956-01-21	1956-01-21 00:00:00	1956-02-04	1956-02-04 00:00:00	1956-02-04	38000177		0	0	14		0	0	0	289459	0	105078	19006318		
1956	156	1127078	1980-02-14	1980-02-14 00:00:00	1980-02-28	1980-02-28 00:00:00	1980-02-28	38000177		0	0	14		0	0	0	10675	0	282464	1127078		
63194	5251	1118084	1962-03-09	1962-03-09 00:00:00	1962-03-09	1962-03-09 00:00:00	\N	38000177		0	0	0		0	0	0	349365	0	00025152531	44923712		
2927	65	40213160	1972-03-10	1972-03-10 00:00:00	1972-03-10	1972-03-10 00:00:00	1972-03-10	581452		0	0	0		0	0	0	4387	0	10	40213160		
18230	1510	19059056	1968-05-13	1968-05-13 00:00:00	1968-05-27	1968-05-27 00:00:00	1968-05-27	38000177		0	0	14		0	0	0	100820	0	243670	19059056		
55492	1215	40213227	1995-03-04	1995-03-04 00:00:00	1995-03-04	1995-03-04 00:00:00	1995-03-04	581452		0	0	0		0	0	0	80046	0	113	40213227		
35446	2921	19059056	1989-05-07	1989-05-07 00:00:00	1989-07-06	1989-07-06 00:00:00	1989-07-06	38000177		0	0	60		0	0	0	194716	0	243670	19059056		
125640	2764	40213227	2015-09-04	2015-09-04 00:00:00	2015-09-04	2015-09-04 00:00:00	2015-09-04	581452		0	0	0		0	0	0	182774	0	113	40213227		
8440	704	19008572	1986-12-15	1986-12-15 00:00:00	1986-12-15	1986-12-15 00:00:00	\N	38000177		0	0	0		0	0	0	46534	0	106258	19008572		
12731	1073	1127433	1953-10-24	1953-10-24 00:00:00	1953-11-07	1953-11-07 00:00:00	1953-11-07	38000177		0	0	14		0	0	0	70301	0	313782	1127433		
19009	1569	19059056	1941-07-29	1941-07-29 00:00:00	1941-08-12	1941-08-12 00:00:00	1941-08-12	38000177		0	0	14		0	0	0	105301	0	243670	19059056		
169166	3719	40213227	1995-12-05	1995-12-05 00:00:00	1995-12-05	1995-12-05 00:00:00	1995-12-05	581452		0	0	0		0	0	0	247186	0	113	40213227		
6209	135	40213160	1971-09-21	1971-09-21 00:00:00	1971-09-21	1971-09-21 00:00:00	1971-09-21	581452		0	0	0		0	0	0	9047	0	10	40213160		
52650	4376	40163554	1978-07-18	1978-07-18 00:00:00	1978-07-18	1978-07-18 00:00:00	\N	38000177		0	0	0		0	0	0	290796	0	855332	40163554		
27863	606	40213314	1977-07-20	1977-07-20 00:00:00	1977-07-20	1977-07-20 00:00:00	1977-07-20	581452		0	0	0		0	0	0	40203	0	49	40213314		
25079	2064	1127433	1993-10-06	1993-10-06 00:00:00	1993-10-13	1993-10-13 00:00:00	1993-10-13	38000177		0	0	7		0	0	0	137281	0	313782	1127433		
160928	3541	40213260	2018-08-13	2018-08-13 00:00:00	2018-08-13	2018-08-13 00:00:00	2018-08-13	581452		0	0	0		0	0	0	235191	0	121	40213260		
89912	1973	40213227	2004-10-11	2004-10-11 00:00:00	2004-10-11	2004-10-11 00:00:00	2004-10-11	581452		0	0	0		0	0	0	131180	0	113	40213227		
12166	1022	1127433	1982-01-05	1982-01-05 00:00:00	1982-01-19	1982-01-19 00:00:00	1982-01-19	38000177		0	0	14		0	0	0	67253	0	313782	1127433		
44397	967	40213201	1999-09-04	1999-09-04 00:00:00	1999-09-04	1999-09-04 00:00:00	1999-09-04	581452		0	0	0		0	0	0	64384	0	33	40213201		
50681	1110	40213227	2013-09-23	2013-09-23 00:00:00	2013-09-23	2013-09-23 00:00:00	2013-09-23	581452		0	0	0		0	0	0	73136	0	113	40213227		
193940	4261	40213201	1988-04-17	1988-04-17 00:00:00	1988-04-17	1988-04-17 00:00:00	1988-04-17	581452		0	0	0		0	0	0	282923	0	33	40213201		
57957	4815	1127433	1988-08-25	1988-08-25 00:00:00	1988-10-24	1988-10-24 00:00:00	1988-10-24	38000177		0	0	60		0	0	0	320334	0	313782	1127433		
62659	5210	19133873	1978-02-12	1978-02-12 00:00:00	1978-02-20	1978-02-20 00:00:00	1978-02-20	38000177		0	0	8		0	0	0	346475	0	834061	19133873		
58050	4822	19006318	1950-11-01	1950-11-01 00:00:00	1950-11-15	1950-11-15 00:00:00	1950-11-15	38000177		0	0	14		0	0	0	320717	0	105078	19006318		
71603	1566	40213306	1990-01-06	1990-01-06 00:00:00	1990-01-06	1990-01-06 00:00:00	1990-01-06	581452		0	0	0		0	0	0	104988	0	43	40213306		
459	35	1713671	1995-08-11	1995-08-11 00:00:00	1995-09-15	1995-09-15 00:00:00	1995-09-15	38000177		0	0	35		0	0	0	2433	0	562251	1713671		
1268	101	40163554	2010-06-25	2010-06-25 00:00:00	2010-06-25	2010-06-25 00:00:00	\N	38000177		0	0	0		0	0	0	6852	0	855332	40163554		
14879	1245	1713671	1984-02-19	1984-02-19 00:00:00	1984-02-26	1984-02-26 00:00:00	1984-02-26	38000177		0	0	7		0	0	0	81955	0	562251	1713671		
3228	70	40213160	1955-04-03	1955-04-03 00:00:00	1955-04-03	1955-04-03 00:00:00	1955-04-03	581452		0	0	0		0	0	0	4738	0	10	40213160		
46988	3892	1713671	2014-05-29	2014-05-29 00:00:00	2014-06-05	2014-06-05 00:00:00	2014-06-05	38000177		0	0	7		0	0	0	258782	0	562251	1713671		
11015	235	40213306	2004-01-12	2004-01-12 00:00:00	2004-01-12	2004-01-12 00:00:00	2004-01-12	581452		0	0	0		0	0	0	15762	0	43	40213306		
50571	4202	19008572	1976-01-04	1976-01-04 00:00:00	1976-01-18	1976-01-18 00:00:00	1976-01-18	38000177		0	0	14		0	0	0	278965	0	106258	19008572		
144720	3181	40213201	2017-11-10	2017-11-10 00:00:00	2017-11-10	2017-11-10 00:00:00	2017-11-10	581452		0	0	0		0	0	0	211706	0	33	40213201		
5656	474	19133873	1980-08-02	1980-08-02 00:00:00	1980-08-14	1980-08-14 00:00:00	1980-08-14	38000177		0	0	12		0	0	0	31601	0	834061	19133873		
8047	173	40213160	1973-03-04	1973-03-04 00:00:00	1973-03-04	1973-03-04 00:00:00	1973-03-04	581452		0	0	0		0	0	0	11796	0	10	40213160		
6541	550	19078461	1977-07-29	1977-07-29 00:00:00	1977-09-27	1977-09-27 00:00:00	1977-09-27	38000177		0	0	60		0	0	0	36449	0	310965	19078461		
66721	1460	40213306	2004-04-10	2004-04-10 00:00:00	2004-04-10	2004-04-10 00:00:00	2004-04-10	581452		0	0	0		0	0	0	97294	0	43	40213306		
178344	3920	40213227	1994-11-26	1994-11-26 00:00:00	1994-11-26	1994-11-26 00:00:00	1994-11-26	581452		0	0	0		0	0	0	260658	0	113	40213227		
59476	4943	1127433	1969-10-18	1969-10-18 00:00:00	1969-10-25	1969-10-25 00:00:00	1969-10-25	38000177		0	0	7		0	0	0	328536	0	313782	1127433		
13260	1113	19128065	1992-10-14	1992-10-14 00:00:00	1993-10-09	1993-10-09 00:00:00	1993-10-09	38000177		0	0	360		0	0	0	73244	0	749882	19128065		
45314	987	40213160	1958-08-10	1958-08-10 00:00:00	1958-08-10	1958-08-10 00:00:00	1958-08-10	581452		0	0	0		0	0	0	65557	0	10	40213160		
53489	4447	1127433	1988-05-10	1988-05-10 00:00:00	1988-05-24	1988-05-24 00:00:00	1988-05-24	38000177		0	0	14		0	0	0	295783	0	313782	1127433		
46494	1016	40213160	1972-05-24	1972-05-24 00:00:00	1972-05-24	1972-05-24 00:00:00	1972-05-24	581452		0	0	0		0	0	0	66885	0	10	40213160		
50999	4238	19129655	1963-04-23	1963-04-23 00:00:00	1963-05-07	1963-05-07 00:00:00	1963-05-07	38000177		0	0	14		0	0	0	281374	0	789980	19129655		
48347	1058	40213160	1955-12-31	1955-12-31 00:00:00	1955-12-31	1955-12-31 00:00:00	1955-12-31	581452		0	0	0		0	0	0	69409	0	10	40213160		
13852	1158	19128022	1994-07-27	1994-07-27 00:00:00	1995-07-22	1995-07-22 00:00:00	1995-07-22	38000177		0	0	360		0	0	0	76529	0	749785	19128022		
22144	1819	1124300	2014-08-28	2014-08-28 00:00:00	2014-08-28	2014-08-28 00:00:00	\N	38000177		0	0	0		0	0	0	121683	0	00781178901	45011828		
61631	5128	1713671	1983-12-07	1983-12-07 00:00:00	1984-01-04	1984-01-04 00:00:00	1984-01-04	38000177		0	0	28		0	0	0	340974	0	562251	1713671		
58554	1281	40213227	1992-04-04	1992-04-04 00:00:00	1992-04-04	1992-04-04 00:00:00	1992-04-04	581452		0	0	0		0	0	0	84650	0	113	40213227		
58598	1282	40213160	1976-12-11	1976-12-11 00:00:00	1976-12-11	1976-12-11 00:00:00	1976-12-11	581452		0	0	0		0	0	0	84727	0	10	40213160		
20662	1703	19006318	1950-06-04	1950-06-04 00:00:00	1950-06-18	1950-06-18 00:00:00	1950-06-18	38000177		0	0	14		0	0	0	113873	0	105078	19006318		
35042	2894	1124300	1958-04-23	1958-04-23 00:00:00	1958-04-23	1958-04-23 00:00:00	\N	38000177		0	0	0		0	0	0	192635	0	00781178901	45011828		
52159	4338	1127433	2014-04-26	2014-04-26 00:00:00	2014-05-10	2014-05-10 00:00:00	2014-05-10	38000177		0	0	14		0	0	0	287667	0	313782	1127433		
63590	5284	1127078	1969-03-11	1969-03-11 00:00:00	1969-03-25	1969-03-25 00:00:00	1969-03-25	38000177		0	0	14		0	0	0	351543	0	282464	1127078		
31314	2596	1124300	2004-06-06	2004-06-06 00:00:00	2004-06-06	2004-06-06 00:00:00	\N	38000177		0	0	0		0	0	0	171805	0	00781178901	45011828		
13768	1150	1127433	1992-03-16	1992-03-16 00:00:00	1992-04-13	1992-04-13 00:00:00	1992-04-13	38000177		0	0	28		0	0	0	76063	0	313782	1127433		
27584	601	40213160	1970-04-26	1970-04-26 00:00:00	1970-04-26	1970-04-26 00:00:00	1970-04-26	581452		0	0	0		0	0	0	39768	0	10	40213160		
2366	189	19129655	1961-11-05	1961-11-05 00:00:00	1961-11-19	1961-11-19 00:00:00	1961-11-19	38000177		0	0	14		0	0	0	12882	0	789980	19129655		
20086	1649	1127433	1960-03-18	1960-03-18 00:00:00	1960-03-25	1960-03-25 00:00:00	1960-03-25	38000177		0	0	7		0	0	0	110680	0	313782	1127433		
34861	2878	19133873	1981-09-21	1981-09-21 00:00:00	1981-09-30	1981-09-30 00:00:00	1981-09-30	38000177		0	0	9		0	0	0	191469	0	834061	19133873		
165366	3636	40213314	1977-06-24	1977-06-24 00:00:00	1977-06-24	1977-06-24 00:00:00	1977-06-24	581452		0	0	0		0	0	0	241813	0	49	40213314		
30535	665	40213227	1997-08-15	1997-08-15 00:00:00	1997-08-15	1997-08-15 00:00:00	1997-08-15	581452		0	0	0		0	0	0	43934	0	113	40213227		
32441	2690	19006318	1949-06-27	1949-06-27 00:00:00	1949-07-11	1949-07-11 00:00:00	1949-07-11	38000177		0	0	14		0	0	0	178242	0	105078	19006318		
52451	4364	1127078	1956-01-21	1956-01-21 00:00:00	1956-02-04	1956-02-04 00:00:00	1956-02-04	38000177		0	0	14		0	0	0	289459	0	282464	1127078		
1957	156	19073183	1980-02-14	1980-02-14 00:00:00	1980-02-28	1980-02-28 00:00:00	1980-02-28	38000177		0	0	14		0	0	0	10675	0	308182	19073183		
32527	709	40213227	1993-07-18	1993-07-18 00:00:00	1993-07-18	1993-07-18 00:00:00	1993-07-18	581452		0	0	0		0	0	0	46946	0	113	40213227		
2934	65	40213306	1989-06-02	1989-06-02 00:00:00	1989-06-02	1989-06-02 00:00:00	1989-06-02	581452		0	0	0		0	0	0	4442	0	43	40213306		
18231	1510	1127433	1960-05-26	1960-05-26 00:00:00	1960-06-09	1960-06-09 00:00:00	1960-06-09	38000177		0	0	14		0	0	0	100778	0	313782	1127433		
55493	1215	40213306	1995-03-04	1995-03-04 00:00:00	1995-03-04	1995-03-04 00:00:00	1995-03-04	581452		0	0	0		0	0	0	80046	0	43	40213306		
35447	2921	19059056	1941-05-14	1941-05-14 00:00:00	1941-06-04	1941-06-04 00:00:00	1941-06-04	38000177		0	0	21		0	0	0	194736	0	243670	19059056		
125641	2764	40213296	2015-09-04	2015-09-04 00:00:00	2015-09-04	2015-09-04 00:00:00	2015-09-04	581452		0	0	0		0	0	0	182774	0	52	40213296		
8441	704	1115171	1994-10-26	1994-10-26 00:00:00	1994-11-16	1994-11-16 00:00:00	1994-11-16	38000177		0	0	21		0	0	0	46642	0	849574	1115171		
12732	1073	1127433	1949-07-18	1949-07-18 00:00:00	1949-07-25	1949-07-25 00:00:00	1949-07-25	38000177		0	0	7		0	0	0	70421	0	313782	1127433		
19010	1569	19133873	1945-06-22	1945-06-22 00:00:00	1945-07-03	1945-07-03 00:00:00	1945-07-03	38000177		0	0	11		0	0	0	105294	0	834061	19133873		
169174	3720	40213160	1955-09-13	1955-09-13 00:00:00	1955-09-13	1955-09-13 00:00:00	1955-09-13	581452		0	0	0		0	0	0	247277	0	10	40213160		
6213	135	40213227	2003-11-25	2003-11-25 00:00:00	2003-11-25	2003-11-25 00:00:00	2003-11-25	581452		0	0	0		0	0	0	9076	0	113	40213227		
52651	4376	19073188	2008-03-05	2008-03-05 00:00:00	2008-03-19	2008-03-19 00:00:00	2008-03-19	38000177		0	0	14		0	0	0	290769	0	308192	19073188		
27866	606	40213296	2016-05-18	2016-05-18 00:00:00	2016-05-18	2016-05-18 00:00:00	2016-05-18	581452		0	0	0		0	0	0	40227	0	52	40213296		
25080	2064	1127433	1989-02-28	1989-02-28 00:00:00	1989-03-21	1989-03-21 00:00:00	1989-03-21	38000177		0	0	21		0	0	0	137305	0	313782	1127433		
160930	3541	40213296	2007-08-13	2007-08-13 00:00:00	2007-08-13	2007-08-13 00:00:00	2007-08-13	581452		0	0	0		0	0	0	235219	0	52	40213296		
16620	359	40213160	1978-07-01	1978-07-01 00:00:00	1978-07-01	1978-07-01 00:00:00	1978-07-01	581452		0	0	0		0	0	0	23886	0	10	40213160		
12167	1022	1127433	1970-03-31	1970-03-31 00:00:00	1970-04-07	1970-04-07 00:00:00	1970-04-07	38000177		0	0	7		0	0	0	67269	0	313782	1127433		
44401	967	40213227	2004-10-02	2004-10-02 00:00:00	2004-10-02	2004-10-02 00:00:00	2004-10-02	581452		0	0	0		0	0	0	64328	0	113	40213227		
50682	1110	40213251	1984-02-20	1984-02-20 00:00:00	1984-02-20	1984-02-20 00:00:00	1984-02-20	581452		0	0	0		0	0	0	73129	0	21	40213251		
193950	4261	40213227	2014-02-16	2014-02-16 00:00:00	2014-02-16	2014-02-16 00:00:00	2014-02-16	581452		0	0	0		0	0	0	282957	0	113	40213227		
57958	4815	19078461	1982-10-28	1982-10-28 00:00:00	1982-11-11	1982-11-11 00:00:00	1982-11-11	38000177		0	0	14		0	0	0	320355	0	310965	19078461		
62660	5210	40229134	1981-05-20	1981-05-20 00:00:00	1981-05-27	1981-05-27 00:00:00	1981-05-27	38000177		0	0	7		0	0	0	346458	0	1043400	40229134		
58051	4822	19059056	1950-11-01	1950-11-01 00:00:00	1950-11-15	1950-11-15 00:00:00	1950-11-15	38000177		0	0	14		0	0	0	320717	0	243670	19059056		
71607	1566	40213160	1968-07-13	1968-07-13 00:00:00	1968-07-13	1968-07-13 00:00:00	1968-07-13	581452		0	0	0		0	0	0	105030	0	10	40213160		
460	35	19006318	1960-06-20	1960-06-20 00:00:00	1960-07-04	1960-07-04 00:00:00	1960-07-04	38000177		0	0	14		0	0	0	2409	0	105078	19006318		
1269	101	19018935	2010-06-25	2010-06-25 00:00:00	2010-06-25	2010-06-25 00:00:00	\N	38000177		0	0	0		0	0	0	6852	0	197604	19018935		
14880	1245	1127433	2013-06-05	2013-06-05 00:00:00	2013-06-19	2013-06-19 00:00:00	2013-06-19	38000177		0	0	14		0	0	0	81985	0	313782	1127433		
3234	70	40213227	1999-04-18	1999-04-18 00:00:00	1999-04-18	1999-04-18 00:00:00	1999-04-18	581452		0	0	0		0	0	0	4787	0	113	40213227		
46989	3892	1127078	1970-12-15	1970-12-15 00:00:00	1971-01-05	1971-01-05 00:00:00	1971-01-05	38000177		0	0	21		0	0	0	258772	0	282464	1127078		
11020	235	40213314	1981-08-17	1981-08-17 00:00:00	1981-08-17	1981-08-17 00:00:00	1981-08-17	581452		0	0	0		0	0	0	15786	0	49	40213314		
50572	4202	1713671	1999-11-15	1999-11-15 00:00:00	1999-11-22	1999-11-22 00:00:00	1999-11-22	38000177		0	0	7		0	0	0	278983	0	562251	1713671		
144730	3181	40213198	2016-11-04	2016-11-04 00:00:00	2016-11-04	2016-11-04 00:00:00	2016-11-04	581452		0	0	0		0	0	0	211711	0	133	40213198		
5657	474	1127433	1990-09-05	1990-09-05 00:00:00	1990-09-26	1990-09-26 00:00:00	1990-09-26	38000177		0	0	21		0	0	0	31643	0	313782	1127433		
19333	421	40213227	2007-06-27	2007-06-27 00:00:00	2007-06-27	2007-06-27 00:00:00	2007-06-27	581452		0	0	0		0	0	0	27875	0	113	40213227		
6542	550	40223774	1997-09-11	1997-09-11 00:00:00	1997-09-11	1997-09-11 00:00:00	\N	38000177		0	0	0		0	0	0	36493	0	998582	40223774		
66722	1460	40213160	1982-02-06	1982-02-06 00:00:00	1982-02-06	1982-02-06 00:00:00	1982-02-06	581452		0	0	0		0	0	0	97282	0	10	40213160		
178345	3920	40213306	1994-11-26	1994-11-26 00:00:00	1994-11-26	1994-11-26 00:00:00	1994-11-26	581452		0	0	0		0	0	0	260658	0	43	40213306		
59477	4943	1127433	1974-02-14	1974-02-14 00:00:00	1974-04-15	1974-04-15 00:00:00	1974-04-15	38000177		0	0	60		0	0	0	328621	0	313782	1127433		
13261	1113	1713671	1977-02-23	1977-02-23 00:00:00	1977-03-16	1977-03-16 00:00:00	1977-03-16	38000177		0	0	21		0	0	0	73287	0	562251	1713671		
45318	987	40213227	2014-11-02	2014-11-02 00:00:00	2014-11-02	2014-11-02 00:00:00	2014-11-02	581452		0	0	0		0	0	0	65577	0	113	40213227		
53491	4447	1124300	1990-07-27	1990-07-27 00:00:00	1990-07-27	1990-07-27 00:00:00	\N	38000177		0	0	0		0	0	0	295788	0	00781178901	45011828		
93428	2051	40213160	1963-02-24	1963-02-24 00:00:00	1963-02-24	1963-02-24 00:00:00	1963-02-24	581452		0	0	0		0	0	0	136375	0	10	40213160		
51000	4238	19059056	1969-12-17	1969-12-17 00:00:00	1970-01-21	1970-01-21 00:00:00	1970-01-21	38000177		0	0	35		0	0	0	281382	0	243670	19059056		
48349	1058	40213227	2017-04-29	2017-04-29 00:00:00	2017-04-29	2017-04-29 00:00:00	2017-04-29	581452		0	0	0		0	0	0	69358	0	113	40213227		
13853	1158	40236824	1999-09-11	1999-09-11 00:00:00	1999-09-18	1999-09-18 00:00:00	1999-09-18	38000177		0	0	7		0	0	0	76527	0	1094107	40236824		
22145	1820	1127433	1984-01-09	1984-01-09 00:00:00	1984-01-23	1984-01-23 00:00:00	1984-01-23	38000177		0	0	14		0	0	0	121742	0	313782	1127433		
61632	5128	1713671	1935-11-26	1935-11-26 00:00:00	1935-12-10	1935-12-10 00:00:00	1935-12-10	38000177		0	0	14		0	0	0	340938	0	562251	1713671		
58556	1281	40213160	1970-06-13	1970-06-13 00:00:00	1970-06-13	1970-06-13 00:00:00	1970-06-13	581452		0	0	0		0	0	0	84700	0	10	40213160		
58605	1282	40213160	1981-03-14	1981-03-14 00:00:00	1981-03-14	1981-03-14 00:00:00	1981-03-14	581452		0	0	0		0	0	0	84766	0	10	40213160		
20663	1703	1127078	1950-06-04	1950-06-04 00:00:00	1950-06-18	1950-06-18 00:00:00	1950-06-18	38000177		0	0	14		0	0	0	113873	0	282464	1127078		
35043	2894	40223774	2002-12-27	2002-12-27 00:00:00	2002-12-27	2002-12-27 00:00:00	\N	38000177		0	0	0		0	0	0	192586	0	998582	40223774		
52160	4338	1127078	1966-06-05	1966-06-05 00:00:00	1966-07-05	1966-07-05 00:00:00	1966-07-05	38000177		0	0	30		0	0	0	287670	0	282464	1127078		
63591	5284	46233988	1969-03-11	1969-03-11 00:00:00	1969-03-25	1969-03-25 00:00:00	1969-03-25	38000177		0	0	14		0	0	0	351543	0	1652673	46233988		
35179	2902	19059056	1947-11-27	1947-11-27 00:00:00	1947-12-11	1947-12-11 00:00:00	1947-12-11	38000177		0	0	14		0	0	0	193312	0	243670	19059056		
13769	1150	19133905	1990-03-02	1990-03-02 00:00:00	1990-03-12	1990-03-12 00:00:00	1990-03-12	38000177		0	0	10		0	0	0	76030	0	834102	19133905		
27586	601	40213160	1970-02-22	1970-02-22 00:00:00	1970-02-22	1970-02-22 00:00:00	1970-02-22	581452		0	0	0		0	0	0	39744	0	10	40213160		
2367	190	40236824	1963-08-13	1963-08-13 00:00:00	1963-08-20	1963-08-20 00:00:00	1963-08-20	38000177		0	0	7		0	0	0	12936	0	1094107	40236824		
30545	2534	19074841	1984-10-09	1984-10-09 00:00:00	1984-10-23	1984-10-23 00:00:00	1984-10-23	38000177		0	0	14		0	0	0	167403	0	309043	19074841		
34862	2878	19128065	2000-07-20	2000-07-20 00:00:00	2001-07-15	2001-07-15 00:00:00	2001-07-15	38000177		0	0	360		0	0	0	191433	0	749882	19128065		
165369	3636	40213160	1977-06-24	1977-06-24 00:00:00	1977-06-24	1977-06-24 00:00:00	1977-06-24	581452		0	0	0		0	0	0	241813	0	10	40213160		
41584	906	40213306	1994-05-31	1994-05-31 00:00:00	1994-05-31	1994-05-31 00:00:00	1994-05-31	581452		0	0	0		0	0	0	60248	0	43	40213306		
32442	2690	19059056	1949-06-27	1949-06-27 00:00:00	1949-07-11	1949-07-11 00:00:00	1949-07-11	38000177		0	0	14		0	0	0	178242	0	243670	19059056		
52452	4364	1713671	1955-04-16	1955-04-16 00:00:00	1955-04-30	1955-04-30 00:00:00	1955-04-30	38000177		0	0	14		0	0	0	289466	0	562251	1713671		
1958	156	19128022	1997-09-22	1997-09-22 00:00:00	1998-09-17	1998-09-17 00:00:00	1998-09-17	38000177		0	0	360		0	0	0	10676	0	749785	19128022		
32539	710	40213227	1992-07-14	1992-07-14 00:00:00	1992-07-14	1992-07-14 00:00:00	1992-07-14	581452		0	0	0		0	0	0	\N	0	113	40213227		
2938	65	40213296	2007-10-05	2007-10-05 00:00:00	2007-10-05	2007-10-05 00:00:00	2007-10-05	581452		0	0	0		0	0	0	4415	0	52	40213296		
18232	1510	1127078	1963-09-21	1963-09-21 00:00:00	1963-10-05	1963-10-05 00:00:00	1963-10-05	38000177		0	0	14		0	0	0	100813	0	282464	1127078		
55495	1215	40213160	1976-12-04	1976-12-04 00:00:00	1976-12-04	1976-12-04 00:00:00	1976-12-04	581452		0	0	0		0	0	0	80016	0	10	40213160		
35448	2921	1124300	1979-05-25	1979-05-25 00:00:00	1979-05-25	1979-05-25 00:00:00	\N	38000177		0	0	0		0	0	0	194755	0	00781178901	45011828		
206275	4527	40213260	2010-06-11	2010-06-11 00:00:00	2010-06-11	2010-06-11 00:00:00	2010-06-11	581452		0	0	0		0	0	0	301487	0	121	40213260		
8442	704	1127433	1982-08-03	1982-08-03 00:00:00	1982-08-10	1982-08-10 00:00:00	1982-08-10	38000177		0	0	7		0	0	0	46582	0	313782	1127433		
15509	1293	1713671	2012-12-07	2012-12-07 00:00:00	2012-12-14	2012-12-14 00:00:00	2012-12-14	38000177		0	0	7		0	0	0	85567	0	562251	1713671		
19011	1569	1713671	1939-05-15	1939-05-15 00:00:00	1939-06-26	1939-06-26 00:00:00	1939-06-26	38000177		0	0	42		0	0	0	105239	0	562251	1713671		
169183	3720	40213260	2006-04-18	2006-04-18 00:00:00	2006-04-18	2006-04-18 00:00:00	2006-04-18	581452		0	0	0		0	0	0	247301	0	121	40213260		
6217	135	40213160	1972-02-22	1972-02-22 00:00:00	1972-02-22	1972-02-22 00:00:00	1972-02-22	581452		0	0	0		0	0	0	9048	0	10	40213160		
52652	4376	1127433	2008-03-05	2008-03-05 00:00:00	2008-03-19	2008-03-19 00:00:00	2008-03-19	38000177		0	0	14		0	0	0	290769	0	313782	1127433		
27868	606	40213227	2016-05-18	2016-05-18 00:00:00	2016-05-18	2016-05-18 00:00:00	2016-05-18	581452		0	0	0		0	0	0	40227	0	113	40213227		
25081	2064	1127433	1996-06-30	1996-06-30 00:00:00	1996-07-07	1996-07-07 00:00:00	1996-07-07	38000177		0	0	7		0	0	0	137290	0	313782	1127433		
160938	3541	40213306	1989-10-09	1989-10-09 00:00:00	1989-10-09	1989-10-09 00:00:00	1989-10-09	581452		0	0	0		0	0	0	235186	0	43	40213306		
16623	359	40213314	1978-01-28	1978-01-28 00:00:00	1978-01-28	1978-01-28 00:00:00	1978-01-28	581452		0	0	0		0	0	0	23910	0	49	40213314		
12168	1022	46275916	2010-02-09	2010-02-09 00:00:00	2010-02-09	2010-02-09 00:00:00	2010-02-09	38000177		0	0	0		0	0	0	67211	0	1660014	46275916		
44423	967	40213227	1994-02-26	1994-02-26 00:00:00	1994-02-26	1994-02-26 00:00:00	1994-02-26	581452		0	0	0		0	0	0	64316	0	113	40213227		
50686	1110	40213314	1983-05-23	1983-05-23 00:00:00	1983-05-23	1983-05-23 00:00:00	1983-05-23	581452		0	0	0		0	0	0	73081	0	49	40213314		
101346	2222	40213160	1963-04-02	1963-04-02 00:00:00	1963-04-02	1963-04-02 00:00:00	1963-04-02	581452		0	0	0		0	0	0	147935	0	10	40213160		
57959	4815	40229134	2012-06-02	2012-06-02 00:00:00	2012-06-09	2012-06-09 00:00:00	2012-06-09	38000177		0	0	7		0	0	0	320330	0	1043400	40229134		
62661	5210	19059056	1975-05-20	1975-05-20 00:00:00	1975-06-03	1975-06-03 00:00:00	1975-06-03	38000177		0	0	14		0	0	0	346454	0	243670	19059056		
58052	4822	19006318	1951-04-06	1951-04-06 00:00:00	1951-04-20	1951-04-20 00:00:00	1951-04-20	38000177		0	0	14		0	0	0	320749	0	105078	19006318		
71618	1566	40213227	2018-11-10	2018-11-10 00:00:00	2018-11-10	2018-11-10 00:00:00	2018-11-10	581452		0	0	0		0	0	0	104991	0	113	40213227		
461	35	1127078	1960-06-20	1960-06-20 00:00:00	1960-07-04	1960-07-04 00:00:00	1960-07-04	38000177		0	0	14		0	0	0	2409	0	282464	1127078		
1270	101	40171902	2010-06-25	2010-06-25 00:00:00	2010-06-25	2010-06-25 00:00:00	\N	38000177		0	0	0		0	0	0	6852	0	897718	40171902		
14881	1245	1713671	1990-11-29	1990-11-29 00:00:00	1990-12-13	1990-12-13 00:00:00	1990-12-13	38000177		0	0	14		0	0	0	81942	0	562251	1713671		
82151	1794	40213160	1959-10-17	1959-10-17 00:00:00	1959-10-17	1959-10-17 00:00:00	1959-10-17	581452		0	0	0		0	0	0	120279	0	10	40213160		
46990	3892	1118084	2001-10-03	2001-10-03 00:00:00	2001-10-03	2001-10-03 00:00:00	\N	38000177		0	0	0		0	0	0	258831	0	00025152531	44923712		
11021	235	40213160	1981-08-17	1981-08-17 00:00:00	1981-08-17	1981-08-17 00:00:00	1981-08-17	581452		0	0	0		0	0	0	15786	0	10	40213160		
50573	4202	19133905	1990-09-29	1990-09-29 00:00:00	1990-10-07	1990-10-07 00:00:00	1990-10-07	38000177		0	0	8		0	0	0	278967	0	834102	19133905		
103930	2280	40213160	1970-02-11	1970-02-11 00:00:00	1970-02-11	1970-02-11 00:00:00	1970-02-11	581452		0	0	0		0	0	0	151610	0	10	40213160		
5658	474	19133873	1976-02-14	1976-02-14 00:00:00	1976-02-22	1976-02-22 00:00:00	1976-02-22	38000177		0	0	8		0	0	0	31608	0	834061	19133873		
19341	421	40213260	2015-06-17	2015-06-17 00:00:00	2015-06-17	2015-06-17 00:00:00	2015-06-17	581452		0	0	0		0	0	0	27843	0	121	40213260		
6543	550	1713671	1969-07-30	1969-07-30 00:00:00	1969-08-20	1969-08-20 00:00:00	1969-08-20	38000177		0	0	21		0	0	0	36455	0	562251	1713671		
208800	4579	40213306	1991-02-22	1991-02-22 00:00:00	1991-02-22	1991-02-22 00:00:00	1991-02-22	581452		0	0	0		0	0	0	305038	0	43	40213306		
178352	3921	40213314	1983-01-19	1983-01-19 00:00:00	1983-01-19	1983-01-19 00:00:00	1983-01-19	581452		0	0	0		0	0	0	260736	0	49	40213314		
59478	4943	40231925	1974-02-14	1974-02-14 00:00:00	1974-02-14	1974-02-14 00:00:00	\N	38000177		0	0	0		0	0	0	328621	0	1049221	40231925		
13262	1113	1713671	1978-04-17	1978-04-17 00:00:00	1978-04-24	1978-04-24 00:00:00	1978-04-24	38000177		0	0	7		0	0	0	73279	0	562251	1713671		
45320	987	40213160	1956-02-05	1956-02-05 00:00:00	1956-02-05	1956-02-05 00:00:00	1956-02-05	581452		0	0	0		0	0	0	65539	0	10	40213160		
53492	4447	1127433	1989-06-16	1989-06-16 00:00:00	1989-09-14	1989-09-14 00:00:00	1989-09-14	38000177		0	0	90		0	0	0	295719	0	313782	1127433		
93433	2051	40213160	1963-07-28	1963-07-28 00:00:00	1963-07-28	1963-07-28 00:00:00	1963-07-28	581452		0	0	0		0	0	0	136376	0	10	40213160		
51001	4238	40236824	1998-02-05	1998-02-05 00:00:00	1998-02-19	1998-02-19 00:00:00	1998-02-19	38000177		0	0	14		0	0	0	281407	0	1094107	40236824		
48363	1058	40213227	1997-07-12	1997-07-12 00:00:00	1997-07-12	1997-07-12 00:00:00	1997-07-12	581452		0	0	0		0	0	0	69461	0	113	40213227		
13854	1158	920300	1999-09-11	1999-09-11 00:00:00	1999-09-18	1999-09-18 00:00:00	1999-09-18	38000177		0	0	7		0	0	0	76527	0	311989	920300		
22146	1820	1713671	1995-05-17	1995-05-17 00:00:00	1995-05-24	1995-05-24 00:00:00	1995-05-24	38000177		0	0	7		0	0	0	121704	0	562251	1713671		
61633	5128	40173590	1997-02-19	1997-02-19 00:00:00	1997-02-19	1997-02-19 00:00:00	\N	38000177		0	0	0		0	0	0	340966	0	904419	40173590		
58557	1281	40213160	1974-12-14	1974-12-14 00:00:00	1974-12-14	1974-12-14 00:00:00	1974-12-14	581452		0	0	0		0	0	0	84677	0	10	40213160		
58607	1282	40213314	1977-09-10	1977-09-10 00:00:00	1977-09-10	1977-09-10 00:00:00	1977-09-10	581452		0	0	0		0	0	0	84728	0	49	40213314		
20664	1703	19059056	1963-11-05	1963-11-05 00:00:00	1963-11-19	1963-11-19 00:00:00	1963-11-19	38000177		0	0	14		0	0	0	113928	0	243670	19059056		
35044	2894	40223768	1999-11-13	1999-11-13 00:00:00	1999-11-13	1999-11-13 00:00:00	\N	38000177		0	0	0		0	0	0	192618	0	997223	40223768		
52161	4338	1127433	2011-12-06	2011-12-06 00:00:00	2011-12-20	2011-12-20 00:00:00	2011-12-20	38000177		0	0	14		0	0	0	287646	0	313782	1127433		
63592	5284	19133873	1973-12-19	1973-12-19 00:00:00	1974-01-01	1974-01-01 00:00:00	1974-01-01	38000177		0	0	13		0	0	0	351479	0	834061	19133873		
35180	2902	19006318	1947-11-27	1947-11-27 00:00:00	1947-12-11	1947-12-11 00:00:00	1947-12-11	38000177		0	0	14		0	0	0	193312	0	105078	19006318		
13770	1150	1127433	1951-12-04	1951-12-04 00:00:00	1951-12-18	1951-12-18 00:00:00	1951-12-18	38000177		0	0	14		0	0	0	75999	0	313782	1127433		
27594	601	40213160	1974-10-27	1974-10-27 00:00:00	1974-10-27	1974-10-27 00:00:00	1974-10-27	581452		0	0	0		0	0	0	39772	0	10	40213160		
2368	190	920300	1963-08-13	1963-08-13 00:00:00	1963-08-20	1963-08-20 00:00:00	1963-08-20	38000177		0	0	7		0	0	0	12936	0	311989	920300		
30546	2534	1127433	1984-10-09	1984-10-09 00:00:00	1984-10-23	1984-10-23 00:00:00	1984-10-23	38000177		0	0	14		0	0	0	167403	0	313782	1127433		
34863	2878	1118084	2019-04-02	2019-04-02 00:00:00	2019-04-02	2019-04-02 00:00:00	\N	38000177		0	0	0		0	0	0	191453	0	00025152531	44923712		
165372	3636	40213227	2014-07-25	2014-07-25 00:00:00	2014-07-25	2014-07-25 00:00:00	2014-07-25	581452		0	0	0		0	0	0	241795	0	113	40213227		
41586	906	40213227	1994-05-31	1994-05-31 00:00:00	1994-05-31	1994-05-31 00:00:00	1994-05-31	581452		0	0	0		0	0	0	60248	0	113	40213227		
32443	2690	19078461	1996-03-22	1996-03-22 00:00:00	1996-04-05	1996-04-05 00:00:00	1996-04-05	38000177		0	0	14		0	0	0	178253	0	310965	19078461		
52453	4364	40231925	1963-10-01	1963-10-01 00:00:00	1963-10-01	1963-10-01 00:00:00	\N	38000177		0	0	0		0	0	0	289496	0	1049221	40231925		
1959	156	1713671	2009-02-26	2009-02-26 00:00:00	2009-03-05	2009-03-05 00:00:00	2009-03-05	38000177		0	0	7		0	0	0	10683	0	562251	1713671		
32544	710	40213160	1961-12-26	1961-12-26 00:00:00	1961-12-26	1961-12-26 00:00:00	1961-12-26	581452		0	0	0		0	0	0	47048	0	10	40213160		
2941	65	40213227	1999-11-12	1999-11-12 00:00:00	1999-11-12	1999-11-12 00:00:00	1999-11-12	581452		0	0	0		0	0	0	4443	0	113	40213227		
18233	1510	1127433	1992-11-14	1992-11-14 00:00:00	1992-11-21	1992-11-21 00:00:00	1992-11-21	38000177		0	0	7		0	0	0	100856	0	313782	1127433		
55500	1215	40213227	2004-03-13	2004-03-13 00:00:00	2004-03-13	2004-03-13 00:00:00	2004-03-13	581452		0	0	0		0	0	0	80049	0	113	40213227		
35449	2921	40169281	1978-06-13	1978-06-13 00:00:00	1978-06-13	1978-06-13 00:00:00	\N	38000177		0	0	0		0	0	0	194755	0	896209	40169281		
206279	4527	40213227	2002-07-05	2002-07-05 00:00:00	2002-07-05	2002-07-05 00:00:00	2002-07-05	581452		0	0	0		0	0	0	301486	0	113	40213227		
8443	704	19059056	1968-01-27	1968-01-27 00:00:00	1968-03-11	1968-03-11 00:00:00	1968-03-11	38000177		0	0	44		0	0	0	46511	0	243670	19059056		
15510	1293	19059056	1941-05-19	1941-05-19 00:00:00	1941-06-02	1941-06-02 00:00:00	1941-06-02	38000177		0	0	14		0	0	0	85474	0	243670	19059056		
19012	1569	1118084	1971-03-15	1971-03-15 00:00:00	1971-03-15	1971-03-15 00:00:00	\N	38000177		0	0	0		0	0	0	105254	0	00025152531	44923712		
169184	3720	40213260	2007-04-24	2007-04-24 00:00:00	2007-04-24	2007-04-24 00:00:00	2007-04-24	581452		0	0	0		0	0	0	247262	0	121	40213260		
6222	135	40213296	2011-12-06	2011-12-06 00:00:00	2011-12-06	2011-12-06 00:00:00	2011-12-06	581452		0	0	0		0	0	0	9053	0	52	40213296		
52653	4376	40173590	2010-12-28	2010-12-28 00:00:00	2010-12-28	2010-12-28 00:00:00	\N	38000177		0	0	0		0	0	0	290781	0	904419	40173590		
27883	607	40213227	2012-02-17	2012-02-17 00:00:00	2012-02-17	2012-02-17 00:00:00	2012-02-17	581452		0	0	0		0	0	0	40313	0	113	40213227		
25082	2064	1124300	2017-06-16	2017-06-16 00:00:00	2017-06-16	2017-06-16 00:00:00	\N	38000177		0	0	0		0	0	0	137279	0	00781178901	45011828		
160941	3541	40213160	1968-01-15	1968-01-15 00:00:00	1968-01-15	1968-01-15 00:00:00	1968-01-15	581452		0	0	0		0	0	0	235225	0	10	40213160		
16624	359	40213160	1978-01-28	1978-01-28 00:00:00	1978-01-28	1978-01-28 00:00:00	1978-01-28	581452		0	0	0		0	0	0	23910	0	10	40213160		
12169	1022	1310034	2010-02-09	2010-02-09 00:00:00	2010-02-09	2010-02-09 00:00:00	2010-02-09	38000177		0	0	0		0	0	0	67211	0	834357	1310034		
115590	2540	40213227	2008-02-12	2008-02-12 00:00:00	2008-02-12	2008-02-12 00:00:00	2008-02-12	581452		0	0	0		0	0	0	167921	0	113	40213227		
29139	636	40213201	2014-08-01	2014-08-01 00:00:00	2014-08-01	2014-08-01 00:00:00	2014-08-01	581452		0	0	0		0	0	0	42106	0	33	40213201		
101349	2222	40213227	1996-06-25	1996-06-25 00:00:00	1996-06-25	1996-06-25 00:00:00	1996-06-25	581452		0	0	0		0	0	0	147956	0	113	40213227		
57960	4815	1127433	1985-09-26	1985-09-26 00:00:00	1985-10-10	1985-10-10 00:00:00	1985-10-10	38000177		0	0	14		0	0	0	320356	0	313782	1127433		
62662	5210	19006318	1975-05-20	1975-05-20 00:00:00	1975-06-03	1975-06-03 00:00:00	1975-06-03	38000177		0	0	14		0	0	0	346454	0	105078	19006318		
58053	4822	19059056	1951-04-06	1951-04-06 00:00:00	1951-04-20	1951-04-20 00:00:00	1951-04-20	38000177		0	0	14		0	0	0	320749	0	243670	19059056		
71619	1566	40213260	2018-11-10	2018-11-10 00:00:00	2018-11-10	2018-11-10 00:00:00	2018-11-10	581452		0	0	0		0	0	0	104991	0	121	40213260		
462	35	1713671	1973-02-07	1973-02-07 00:00:00	1973-02-21	1973-02-21 00:00:00	1973-02-21	38000177		0	0	14		0	0	0	2396	0	562251	1713671		
1271	101	1115171	2007-07-23	2007-07-23 00:00:00	2007-08-27	2007-08-27 00:00:00	2007-08-27	38000177		0	0	35		0	0	0	6903	0	849574	1115171		
14882	1245	1713671	2012-02-01	2012-02-01 00:00:00	2012-02-08	2012-02-08 00:00:00	2012-02-08	38000177		0	0	7		0	0	0	81910	0	562251	1713671		
82156	1794	40213260	2010-02-13	2010-02-13 00:00:00	2010-02-13	2010-02-13 00:00:00	2010-02-13	581452		0	0	0		0	0	0	120341	0	121	40213260		
46991	3892	19078461	2013-02-23	2013-02-23 00:00:00	2013-03-09	2013-03-09 00:00:00	2013-03-09	38000177		0	0	14		0	0	0	258773	0	310965	19078461		
2657	212	19078461	1996-04-15	1996-04-15 00:00:00	1996-04-29	1996-04-29 00:00:00	1996-04-29	38000177		0	0	14		0	0	0	14417	0	310965	19078461		
50574	4202	1118084	2009-01-20	2009-01-20 00:00:00	2009-01-20	2009-01-20 00:00:00	\N	38000177		0	0	0		0	0	0	278936	0	00025152531	44923712		
108922	2389	40213296	2012-12-18	2012-12-18 00:00:00	2012-12-18	2012-12-18 00:00:00	2012-12-18	581452		0	0	0		0	0	0	158885	0	52	40213296		
5659	474	1127433	2017-09-04	2017-09-04 00:00:00	2017-09-18	2017-09-18 00:00:00	2017-09-18	38000177		0	0	14		0	0	0	31604	0	313782	1127433		
19346	421	40213160	1965-11-23	1965-11-23 00:00:00	1965-11-23	1965-11-23 00:00:00	1965-11-23	581452		0	0	0		0	0	0	27888	0	10	40213160		
6544	550	1713671	1946-04-10	1946-04-10 00:00:00	1946-05-01	1946-05-01 00:00:00	1946-05-01	38000177		0	0	21		0	0	0	36451	0	562251	1713671		
208810	4580	40213306	1988-07-05	1988-07-05 00:00:00	1988-07-05	1988-07-05 00:00:00	1988-07-05	581452		0	0	0		0	0	0	305076	0	43	40213306		
178353	3921	40213251	1984-04-18	1984-04-18 00:00:00	1984-04-18	1984-04-18 00:00:00	1984-04-18	581452		0	0	0		0	0	0	260699	0	21	40213251		
59479	4943	19133905	1999-05-29	1999-05-29 00:00:00	1999-06-09	1999-06-09 00:00:00	1999-06-09	38000177		0	0	11		0	0	0	328575	0	834102	19133905		
13263	1113	1713671	2014-03-13	2014-03-13 00:00:00	2014-03-27	2014-03-27 00:00:00	2014-03-27	38000177		0	0	14		0	0	0	73290	0	562251	1713671		
45322	987	40213160	1955-08-07	1955-08-07 00:00:00	1955-08-07	1955-08-07 00:00:00	1955-08-07	581452		0	0	0		0	0	0	65555	0	10	40213160		
53493	4448	1713671	2000-08-22	2000-08-22 00:00:00	2000-09-05	2000-09-05 00:00:00	2000-09-05	38000177		0	0	14		0	0	0	295879	0	562251	1713671		
93437	2051	40213227	1994-04-17	1994-04-17 00:00:00	1994-04-17	1994-04-17 00:00:00	1994-04-17	581452		0	0	0		0	0	0	136395	0	113	40213227		
51002	4238	920300	1998-02-05	1998-02-05 00:00:00	1998-02-12	1998-02-12 00:00:00	1998-02-12	38000177		0	0	7		0	0	0	281407	0	311989	920300		
48364	1058	40213296	1997-07-12	1997-07-12 00:00:00	1997-07-12	1997-07-12 00:00:00	1997-07-12	581452		0	0	0		0	0	0	69461	0	52	40213296		
13855	1158	19075001	1983-01-31	1983-01-31 00:00:00	1983-02-14	1983-02-14 00:00:00	1983-02-14	38000177		0	0	14		0	0	0	76480	0	309097	19075001		
22147	1820	19078461	1995-04-30	1995-04-30 00:00:00	1995-05-14	1995-05-14 00:00:00	1995-05-14	38000177		0	0	14		0	0	0	121710	0	310965	19078461		
61634	5128	1127433	2019-05-08	2019-05-08 00:00:00	2019-06-07	2019-06-07 00:00:00	2019-06-07	38000177		0	0	30		0	0	0	340922	0	313782	1127433		
58561	1281	40213296	2013-12-28	2013-12-28 00:00:00	2013-12-28	2013-12-28 00:00:00	2013-12-28	581452		0	0	0		0	0	0	84684	0	52	40213296		
58613	1283	40213160	1959-06-22	1959-06-22 00:00:00	1959-06-22	1959-06-22 00:00:00	1959-06-22	581452		0	0	0		0	0	0	84803	0	10	40213160		
20665	1703	19059056	1962-10-20	1962-10-20 00:00:00	1962-11-10	1962-11-10 00:00:00	1962-11-10	38000177		0	0	21		0	0	0	113927	0	243670	19059056		
35045	2894	19073188	2004-09-18	2004-09-18 00:00:00	2004-10-23	2004-10-23 00:00:00	2004-10-23	38000177		0	0	35		0	0	0	192606	0	308192	19073188		
52162	4338	19073188	2011-12-06	2011-12-06 00:00:00	2011-12-20	2011-12-20 00:00:00	2011-12-20	38000177		0	0	14		0	0	0	287646	0	308192	19073188		
63593	5284	40232448	1971-09-13	1971-09-13 00:00:00	1971-09-13	1971-09-13 00:00:00	\N	38000177		0	0	0		0	0	0	351489	0	1049630	40232448		
35181	2902	19133905	1986-03-17	1986-03-17 00:00:00	1986-03-28	1986-03-28 00:00:00	1986-03-28	38000177		0	0	11		0	0	0	193274	0	834102	19133905		
13771	1150	1713671	2014-05-07	2014-05-07 00:00:00	2014-05-21	2014-05-21 00:00:00	2014-05-21	38000177		0	0	14		0	0	0	76006	0	562251	1713671		
184903	4064	40213227	2001-10-15	2001-10-15 00:00:00	2001-10-15	2001-10-15 00:00:00	2001-10-15	581452		0	0	0		0	0	0	270101	0	113	40213227		
2369	190	19059056	1930-08-07	1930-08-07 00:00:00	1930-08-21	1930-08-21 00:00:00	1930-08-21	38000177		0	0	14		0	0	0	12972	0	243670	19059056		
30547	2534	1118084	2011-04-02	2011-04-02 00:00:00	2011-04-02	2011-04-02 00:00:00	\N	38000177		0	0	0		0	0	0	167472	0	00025152531	44923712		
2423	192	1127433	2018-09-18	2018-09-18 00:00:00	2018-09-25	2018-09-25 00:00:00	2018-09-25	38000177		0	0	7		0	0	0	13211	0	313782	1127433		
84566	1850	40213296	1996-12-20	1996-12-20 00:00:00	1996-12-20	1996-12-20 00:00:00	1996-12-20	581452		0	0	0		0	0	0	123742	0	52	40213296		
154025	3391	40213160	1983-03-01	1983-03-01 00:00:00	1983-03-01	1983-03-01 00:00:00	1983-03-01	581452		0	0	0		0	0	0	224874	0	10	40213160		
32444	2690	1713671	1970-06-17	1970-06-17 00:00:00	1970-07-08	1970-07-08 00:00:00	1970-07-08	38000177		0	0	21		0	0	0	178229	0	562251	1713671		
52454	4364	1127433	2019-01-08	2019-01-08 00:00:00	2019-01-15	2019-01-15 00:00:00	2019-01-15	38000177		0	0	7		0	0	0	289458	0	313782	1127433		
1960	156	1115171	2013-08-19	2013-08-19 00:00:00	2013-09-02	2013-09-02 00:00:00	2013-09-02	38000177		0	0	14		0	0	0	10698	0	849574	1115171		
32548	710	40213227	2003-04-29	2003-04-29 00:00:00	2003-04-29	2003-04-29 00:00:00	2003-04-29	581452		0	0	0		0	0	0	47055	0	113	40213227		
2946	65	40213227	2018-04-06	2018-04-06 00:00:00	2018-04-06	2018-04-06 00:00:00	2018-04-06	581452		0	0	0		0	0	0	4414	0	113	40213227		
18234	1510	19059056	1970-07-16	1970-07-16 00:00:00	1970-08-20	1970-08-20 00:00:00	1970-08-20	38000177		0	0	35		0	0	0	100788	0	243670	19059056		
55504	1216	40213160	1969-11-04	1969-11-04 00:00:00	1969-11-04	1969-11-04 00:00:00	1969-11-04	581452		0	0	0		0	0	0	80091	0	10	40213160		
223929	4916	40213251	1984-07-20	1984-07-20 00:00:00	1984-07-20	1984-07-20 00:00:00	1984-07-20	581452		0	0	0		0	0	0	326670	0	21	40213251		
206280	4527	40213296	2002-07-05	2002-07-05 00:00:00	2002-07-05	2002-07-05 00:00:00	2002-07-05	581452		0	0	0		0	0	0	301486	0	52	40213296		
8444	704	1127433	1985-12-21	1985-12-21 00:00:00	1986-01-11	1986-01-11 00:00:00	1986-01-11	38000177		0	0	21		0	0	0	46641	0	313782	1127433		
15511	1293	19126352	2010-02-23	2010-02-23 00:00:00	2010-02-23	2010-02-23 00:00:00	\N	38000177		0	0	0		0	0	0	85562	0	705129	19126352		
188774	4145	40213314	1977-12-11	1977-12-11 00:00:00	1977-12-11	1977-12-11 00:00:00	1977-12-11	581452		0	0	0		0	0	0	275486	0	49	40213314		
169193	3720	40213160	1955-03-15	1955-03-15 00:00:00	1955-03-15	1955-03-15 00:00:00	1955-03-15	581452		0	0	0		0	0	0	247249	0	10	40213160		
6226	135	40213227	2013-12-10	2013-12-10 00:00:00	2013-12-10	2013-12-10 00:00:00	2013-12-10	581452		0	0	0		0	0	0	9028	0	113	40213227		
52654	4376	1115171	2011-10-14	2011-10-14 00:00:00	2011-11-04	2011-11-04 00:00:00	2011-11-04	38000177		0	0	21		0	0	0	290736	0	849574	1115171		
6993	152	40213160	1967-02-06	1967-02-06 00:00:00	1967-02-06	1967-02-06 00:00:00	1967-02-06	581452		0	0	0		0	0	0	10271	0	10	40213160		
25083	2064	1127078	1982-04-06	1982-04-06 00:00:00	1982-07-05	1982-07-05 00:00:00	1982-07-05	38000177		0	0	90		0	0	0	137304	0	282464	1127078		
160945	3541	40213160	1972-07-17	1972-07-17 00:00:00	1972-07-17	1972-07-17 00:00:00	1972-07-17	581452		0	0	0		0	0	0	235206	0	10	40213160		
16625	359	40213314	1978-04-01	1978-04-01 00:00:00	1978-04-01	1978-04-01 00:00:00	1978-04-01	581452		0	0	0		0	0	0	23872	0	49	40213314		
12170	1022	40243436	2010-02-09	2010-02-09 00:00:00	2010-02-09	2010-02-09 00:00:00	2010-02-09	38000177		0	0	0		0	0	0	67211	0	1190795	40243436		
115609	2540	40213201	2003-01-14	2003-01-14 00:00:00	2003-01-14	2003-01-14 00:00:00	2003-01-14	581452		0	0	0		0	0	0	167970	0	33	40213201		
29142	636	40213160	1955-03-04	1955-03-04 00:00:00	1955-03-04	1955-03-04 00:00:00	1955-03-04	581452		0	0	0		0	0	0	42147	0	10	40213160		
101352	2222	40213306	1985-02-26	1985-02-26 00:00:00	1985-02-26	1985-02-26 00:00:00	1985-02-26	581452		0	0	0		0	0	0	147953	0	43	40213306		
57961	4815	1127433	2003-01-13	2003-01-13 00:00:00	2003-01-20	2003-01-20 00:00:00	2003-01-20	38000177		0	0	7		0	0	0	320320	0	313782	1127433		
62663	5210	1118084	2015-06-14	2015-06-14 00:00:00	2015-06-14	2015-06-14 00:00:00	\N	38000177		0	0	0		0	0	0	346453	0	00025152531	44923712		
58054	4822	19006318	1949-02-15	1949-02-15 00:00:00	1949-03-01	1949-03-01 00:00:00	1949-03-01	38000177		0	0	14		0	0	0	320759	0	105078	19006318		
71622	1566	40213160	1968-04-13	1968-04-13 00:00:00	1968-04-13	1968-04-13 00:00:00	1968-04-13	581452		0	0	0		0	0	0	105067	0	10	40213160		
463	35	1118084	1997-05-02	1997-05-02 00:00:00	1997-05-02	1997-05-02 00:00:00	\N	38000177		0	0	0		0	0	0	2406	0	00025152531	44923712		
1272	101	19059056	1988-11-23	1988-11-23 00:00:00	1988-12-07	1988-12-07 00:00:00	1988-12-07	38000177		0	0	14		0	0	0	6840	0	243670	19059056		
14883	1245	1713671	1963-11-08	1963-11-08 00:00:00	1963-11-22	1963-11-22 00:00:00	1963-11-22	38000177		0	0	14		0	0	0	81911	0	562251	1713671		
82158	1794	40213227	2010-02-13	2010-02-13 00:00:00	2010-02-13	2010-02-13 00:00:00	2010-02-13	581452		0	0	0		0	0	0	120341	0	113	40213227		
46992	3892	19078461	2014-04-03	2014-04-03 00:00:00	2014-04-17	2014-04-17 00:00:00	2014-04-17	38000177		0	0	14		0	0	0	258774	0	310965	19078461		
2658	212	1127078	1978-11-04	1978-11-04 00:00:00	1978-11-18	1978-11-18 00:00:00	1978-11-18	38000177		0	0	14		0	0	0	14437	0	282464	1127078		
50575	4202	19019979	1974-02-28	1974-02-28 00:00:00	1974-03-30	1974-03-30 00:00:00	1974-03-30	38000177		0	0	30		0	0	0	278927	0	198405	19019979		
108924	2389	40213160	1969-07-08	1969-07-08 00:00:00	1969-07-08	1969-07-08 00:00:00	1969-07-08	581452		0	0	0		0	0	0	158838	0	10	40213160		
5660	474	1713671	1975-07-21	1975-07-21 00:00:00	1975-08-11	1975-08-11 00:00:00	1975-08-11	38000177		0	0	21		0	0	0	31644	0	562251	1713671		
19350	421	40213306	1987-08-19	1987-08-19 00:00:00	1987-08-19	1987-08-19 00:00:00	1987-08-19	581452		0	0	0		0	0	0	27860	0	43	40213306		
30403	2521	1127433	1948-03-20	1948-03-20 00:00:00	1948-04-03	1948-04-03 00:00:00	1948-04-03	38000177		0	0	14		0	0	0	166756	0	313782	1127433		
208811	4580	40213160	1971-01-26	1971-01-26 00:00:00	1971-01-26	1971-01-26 00:00:00	1971-01-26	581452		0	0	0		0	0	0	305091	0	10	40213160		
49379	1081	40213160	1962-01-24	1962-01-24 00:00:00	1962-01-24	1962-01-24 00:00:00	1962-01-24	581452		0	0	0		0	0	0	70849	0	10	40213160		
59480	4943	19059056	1970-07-05	1970-07-05 00:00:00	1970-10-03	1970-10-03 00:00:00	1970-10-03	38000177		0	0	90		0	0	0	328620	0	243670	19059056		
13264	1113	1124300	2013-07-23	2013-07-23 00:00:00	2013-07-23	2013-07-23 00:00:00	\N	38000177		0	0	0		0	0	0	73286	0	00781178901	45011828		
70881	1551	40213160	1957-05-27	1957-05-27 00:00:00	1957-05-27	1957-05-27 00:00:00	1957-05-27	581452		0	0	0		0	0	0	103836	0	10	40213160		
53494	4448	1127433	1978-05-09	1978-05-09 00:00:00	1978-06-06	1978-06-06 00:00:00	1978-06-06	38000177		0	0	28		0	0	0	295897	0	313782	1127433		
34183	2825	19059056	1931-01-22	1931-01-22 00:00:00	1931-02-26	1931-02-26 00:00:00	1931-02-26	38000177		0	0	35		0	0	0	187259	0	243670	19059056		
51003	4238	1124300	2005-11-03	2005-11-03 00:00:00	2005-11-03	2005-11-03 00:00:00	\N	38000177		0	0	0		0	0	0	281426	0	00781178901	45011828		
48377	1058	40213160	1956-06-02	1956-06-02 00:00:00	1956-06-02	1956-06-02 00:00:00	1956-06-02	581452		0	0	0		0	0	0	69346	0	10	40213160		
13856	1158	19059056	1983-01-31	1983-01-31 00:00:00	1983-02-14	1983-02-14 00:00:00	1983-02-14	38000177		0	0	14		0	0	0	76480	0	243670	19059056		
22148	1820	19128065	1997-01-08	1997-01-08 00:00:00	1998-01-03	1998-01-03 00:00:00	1998-01-03	38000177		0	0	360		0	0	0	121723	0	749882	19128065		
61635	5128	1127433	1983-05-28	1983-05-28 00:00:00	1983-06-18	1983-06-18 00:00:00	1983-06-18	38000177		0	0	21		0	0	0	340919	0	313782	1127433		
58574	1282	40213251	1984-03-31	1984-03-31 00:00:00	1984-03-31	1984-03-31 00:00:00	1984-03-31	581452		0	0	0		0	0	0	84730	0	21	40213251		
58615	1283	40213296	2001-03-26	2001-03-26 00:00:00	2001-03-26	2001-03-26 00:00:00	2001-03-26	581452		0	0	0		0	0	0	84847	0	52	40213296		
20666	1703	1713671	1952-04-21	1952-04-21 00:00:00	1952-04-28	1952-04-28 00:00:00	1952-04-28	38000177		0	0	7		0	0	0	113890	0	562251	1713671		
35046	2894	1115171	2004-09-18	2004-09-18 00:00:00	2004-10-23	2004-10-23 00:00:00	2004-10-23	38000177		0	0	35		0	0	0	192606	0	849574	1115171		
52163	4338	19078461	1993-01-28	1993-01-28 00:00:00	1993-02-25	1993-02-25 00:00:00	1993-02-25	38000177		0	0	28		0	0	0	287672	0	310965	19078461		
63594	5284	1127433	1969-11-08	1969-11-08 00:00:00	1969-11-15	1969-11-15 00:00:00	1969-11-15	38000177		0	0	7		0	0	0	351519	0	313782	1127433		
35182	2902	1127433	2005-02-18	2005-02-18 00:00:00	2005-03-04	2005-03-04 00:00:00	2005-03-04	38000177		0	0	14		0	0	0	193353	0	313782	1127433		
13772	1150	1127433	2008-08-17	2008-08-17 00:00:00	2008-09-14	2008-09-14 00:00:00	2008-09-14	38000177		0	0	28		0	0	0	76064	0	313782	1127433		
184904	4064	40213296	2001-10-15	2001-10-15 00:00:00	2001-10-15	2001-10-15 00:00:00	2001-10-15	581452		0	0	0		0	0	0	270101	0	52	40213296		
2370	190	19059056	1971-07-17	1971-07-17 00:00:00	1971-08-07	1971-08-07 00:00:00	1971-08-07	38000177		0	0	21		0	0	0	12912	0	243670	19059056		
30548	2534	19128065	1986-07-22	1986-07-22 00:00:00	1987-07-17	1987-07-17 00:00:00	1987-07-17	38000177		0	0	360		0	0	0	167428	0	749882	19128065		
2424	192	19059056	1946-07-04	1946-07-04 00:00:00	1946-08-08	1946-08-08 00:00:00	1946-08-08	38000177		0	0	35		0	0	0	13215	0	243670	19059056		
84574	1850	40213160	1961-11-24	1961-11-24 00:00:00	1961-11-24	1961-11-24 00:00:00	1961-11-24	581452		0	0	0		0	0	0	123796	0	10	40213160		
154028	3391	40213227	2004-12-14	2004-12-14 00:00:00	2004-12-14	2004-12-14 00:00:00	2004-12-14	581452		0	0	0		0	0	0	224899	0	113	40213227		
32445	2690	1713671	1971-11-08	1971-11-08 00:00:00	1971-11-29	1971-11-29 00:00:00	1971-11-29	38000177		0	0	21		0	0	0	178239	0	562251	1713671		
52455	4364	19059056	1963-09-24	1963-09-24 00:00:00	1963-10-31	1963-10-31 00:00:00	1963-10-31	38000177		0	0	37		0	0	0	289423	0	243670	19059056		
1961	156	1118084	2019-01-30	2019-01-30 00:00:00	2019-01-30	2019-01-30 00:00:00	\N	38000177		0	0	0		0	0	0	10692	0	00025152531	44923712		
32549	710	40213296	2003-04-29	2003-04-29 00:00:00	2003-04-29	2003-04-29 00:00:00	2003-04-29	581452		0	0	0		0	0	0	47055	0	52	40213296		
2947	65	40213260	2018-04-06	2018-04-06 00:00:00	2018-04-06	2018-04-06 00:00:00	2018-04-06	581452		0	0	0		0	0	0	4414	0	121	40213260		
18235	1510	19059056	1960-11-21	1960-11-21 00:00:00	1961-01-20	1961-01-20 00:00:00	1961-01-20	38000177		0	0	60		0	0	0	100819	0	243670	19059056		
55509	1216	40213160	1974-07-09	1974-07-09 00:00:00	1974-07-09	1974-07-09 00:00:00	1974-07-09	581452		0	0	0		0	0	0	80074	0	10	40213160		
235210	5166	40213160	1956-03-13	1956-03-13 00:00:00	1956-03-13	1956-03-13 00:00:00	1956-03-13	581452		0	0	0		0	0	0	343445	0	10	40213160		
206282	4527	40213227	1992-06-19	1992-06-19 00:00:00	1992-06-19	1992-06-19 00:00:00	1992-06-19	581452		0	0	0		0	0	0	301473	0	113	40213227		
8445	704	1713671	1983-02-17	1983-02-17 00:00:00	1983-03-10	1983-03-10 00:00:00	1983-03-10	38000177		0	0	21		0	0	0	46516	0	562251	1713671		
15512	1293	1332419	2010-02-23	2010-02-23 00:00:00	2010-02-23	2010-02-23 00:00:00	\N	38000177		0	0	0		0	0	0	85562	0	197361	1332419		
188781	4145	40213227	2005-12-18	2005-12-18 00:00:00	2005-12-18	2005-12-18 00:00:00	2005-12-18	581452		0	0	0		0	0	0	275559	0	113	40213227		
169195	3720	40213227	2015-11-10	2015-11-10 00:00:00	2015-11-10	2015-11-10 00:00:00	2015-11-10	581452		0	0	0		0	0	0	247303	0	113	40213227		
76269	1666	40213227	2006-07-22	2006-07-22 00:00:00	2006-07-22	2006-07-22 00:00:00	2006-07-22	581452		0	0	0		0	0	0	111953	0	113	40213227		
52655	4376	1124300	1961-01-07	1961-01-07 00:00:00	1961-01-07	1961-01-07 00:00:00	\N	38000177		0	0	0		0	0	0	290777	0	00781178901	45011828		
6995	152	40213227	2018-10-29	2018-10-29 00:00:00	2018-10-29	2018-10-29 00:00:00	2018-10-29	581452		0	0	0		0	0	0	10240	0	113	40213227		
25084	2064	1127433	2008-11-02	2008-11-02 00:00:00	2008-11-20	2008-11-20 00:00:00	2008-11-20	38000177		0	0	18		0	0	0	137291	0	313782	1127433		
160953	3541	40213227	2009-08-17	2009-08-17 00:00:00	2009-08-17	2009-08-17 00:00:00	2009-08-17	581452		0	0	0		0	0	0	235187	0	113	40213227		
16626	359	40213296	2017-10-28	2017-10-28 00:00:00	2017-10-28	2017-10-28 00:00:00	2017-10-28	581452		0	0	0		0	0	0	23891	0	52	40213296		
12171	1022	19133873	1973-11-09	1973-11-09 00:00:00	1973-11-21	1973-11-21 00:00:00	1973-11-21	38000177		0	0	12		0	0	0	67230	0	834061	19133873		
87880	1928	40213160	1976-07-14	1976-07-14 00:00:00	1976-07-14	1976-07-14 00:00:00	1976-07-14	581452		0	0	0		0	0	0	128318	0	10	40213160		
186850	4105	40213198	2013-03-23	2013-03-23 00:00:00	2013-03-23	2013-03-23 00:00:00	2013-03-23	581452		0	0	0		0	0	0	272755	0	133	40213198		
101356	2222	40213227	2014-08-05	2014-08-05 00:00:00	2014-08-05	2014-08-05 00:00:00	2014-08-05	581452		0	0	0		0	0	0	147900	0	113	40213227		
57962	4815	19059056	1971-08-27	1971-08-27 00:00:00	1971-09-10	1971-09-10 00:00:00	1971-09-10	38000177		0	0	14		0	0	0	320341	0	243670	19059056		
8890	190	40213227	1992-10-20	1992-10-20 00:00:00	1992-10-20	1992-10-20 00:00:00	1992-10-20	581452		0	0	0		0	0	0	12943	0	113	40213227		
58055	4822	19059056	1949-02-15	1949-02-15 00:00:00	1949-03-01	1949-03-01 00:00:00	1949-03-01	38000177		0	0	14		0	0	0	320759	0	243670	19059056		
140179	3079	40213227	2015-01-01	2015-01-01 00:00:00	2015-01-01	2015-01-01 00:00:00	2015-01-01	581452		0	0	0		0	0	0	204930	0	113	40213227		
464	35	920300	1997-04-22	1997-04-22 00:00:00	1997-04-29	1997-04-29 00:00:00	1997-04-29	38000177		0	0	7		0	0	0	2406	0	311989	920300		
1273	101	19073188	1988-11-23	1988-11-23 00:00:00	1988-12-07	1988-12-07 00:00:00	1988-12-07	38000177		0	0	14		0	0	0	6840	0	308192	19073188		
14884	1246	19059056	1961-11-16	1961-11-16 00:00:00	1961-12-07	1961-12-07 00:00:00	1961-12-07	38000177		0	0	21		0	0	0	82051	0	243670	19059056		
82160	1794	40213160	1959-05-16	1959-05-16 00:00:00	1959-05-16	1959-05-16 00:00:00	1959-05-16	581452		0	0	0		0	0	0	120278	0	10	40213160		
46993	3892	1127433	2019-02-02	2019-02-02 00:00:00	2019-02-16	2019-02-16 00:00:00	2019-02-16	38000177		0	0	14		0	0	0	258784	0	313782	1127433		
2659	212	1127433	2012-07-28	2012-07-28 00:00:00	2012-08-11	2012-08-11 00:00:00	2012-08-11	38000177		0	0	14		0	0	0	14413	0	313782	1127433		
50594	4204	1127433	2015-05-19	2015-05-19 00:00:00	2015-06-02	2015-06-02 00:00:00	2015-06-02	38000177		0	0	14		0	0	0	279084	0	313782	1127433		
108925	2389	40213160	1969-09-09	1969-09-09 00:00:00	1969-09-09	1969-09-09 00:00:00	1969-09-09	581452		0	0	0		0	0	0	158878	0	10	40213160		
5661	474	19078461	1982-12-02	1982-12-02 00:00:00	1982-12-16	1982-12-16 00:00:00	1982-12-16	38000177		0	0	14		0	0	0	31642	0	310965	19078461		
19353	421	40213296	2005-06-22	2005-06-22 00:00:00	2005-06-22	2005-06-22 00:00:00	2005-06-22	581452		0	0	0		0	0	0	27841	0	52	40213296		
30404	2521	1127433	1985-08-24	1985-08-24 00:00:00	1985-09-07	1985-09-07 00:00:00	1985-09-07	38000177		0	0	14		0	0	0	166732	0	313782	1127433		
208815	4580	40213160	1966-11-08	1966-11-08 00:00:00	1966-11-08	1966-11-08 00:00:00	1966-11-08	581452		0	0	0		0	0	0	305084	0	10	40213160		
49384	1081	40213306	1984-01-04	1984-01-04 00:00:00	1984-01-04	1984-01-04 00:00:00	1984-01-04	581452		0	0	0		0	0	0	70879	0	43	40213306		
59481	4943	19078461	1979-11-15	1979-11-15 00:00:00	1979-12-22	1979-12-22 00:00:00	1979-12-22	38000177		0	0	37		0	0	0	328622	0	310965	19078461		
13265	1113	19078461	2012-12-10	2012-12-10 00:00:00	2012-12-31	2012-12-31 00:00:00	2012-12-31	38000177		0	0	21		0	0	0	73286	0	310965	19078461		
70883	1551	40213160	1957-03-25	1957-03-25 00:00:00	1957-03-25	1957-03-25 00:00:00	1957-03-25	581452		0	0	0		0	0	0	103850	0	10	40213160		
53495	4448	1127433	1962-04-05	1962-04-05 00:00:00	1962-04-12	1962-04-12 00:00:00	1962-04-12	38000177		0	0	7		0	0	0	295850	0	313782	1127433		
34184	2825	1127433	2017-02-20	2017-02-20 00:00:00	2017-03-06	2017-03-06 00:00:00	2017-03-06	38000177		0	0	14		0	0	0	187311	0	313782	1127433		
51004	4238	1713671	2007-07-09	2007-07-09 00:00:00	2007-07-30	2007-07-30 00:00:00	2007-07-30	38000177		0	0	21		0	0	0	281420	0	562251	1713671		
48382	1058	40213160	1960-08-06	1960-08-06 00:00:00	1960-08-06	1960-08-06 00:00:00	1960-08-06	581452		0	0	0		0	0	0	\N	0	10	40213160		
13857	1158	1127433	1992-10-27	1992-10-27 00:00:00	1992-11-10	1992-11-10 00:00:00	1992-11-10	38000177		0	0	14		0	0	0	76525	0	313782	1127433		
22149	1820	19078461	1992-07-23	1992-07-23 00:00:00	1992-08-13	1992-08-13 00:00:00	1992-08-13	38000177		0	0	21		0	0	0	121709	0	310965	19078461		
61636	5128	1127433	1994-11-17	1994-11-17 00:00:00	1994-11-24	1994-11-24 00:00:00	1994-11-24	38000177		0	0	7		0	0	0	341007	0	313782	1127433		
58575	1282	40213306	1998-11-07	1998-11-07 00:00:00	1998-11-07	1998-11-07 00:00:00	1998-11-07	581452		0	0	0		0	0	0	84711	0	43	40213306		
58617	1283	40213227	2001-03-26	2001-03-26 00:00:00	2001-03-26	2001-03-26 00:00:00	2001-03-26	581452		0	0	0		0	0	0	84847	0	113	40213227		
20667	1703	1127433	1997-08-20	1997-08-20 00:00:00	1997-09-03	1997-09-03 00:00:00	1997-09-03	38000177		0	0	14		0	0	0	113931	0	313782	1127433		
35047	2894	19059056	1923-09-04	1923-09-04 00:00:00	1923-09-18	1923-09-18 00:00:00	1923-09-18	38000177		0	0	14		0	0	0	192651	0	243670	19059056		
52164	4338	1127078	1973-02-28	1973-02-28 00:00:00	1973-03-14	1973-03-14 00:00:00	1973-03-14	38000177		0	0	14		0	0	0	287671	0	282464	1127078		
63595	5284	1127433	2002-05-17	2002-05-17 00:00:00	2002-05-31	2002-05-31 00:00:00	2002-05-31	38000177		0	0	14		0	0	0	351518	0	313782	1127433		
35183	2902	19075601	2011-02-11	2011-02-11 00:00:00	2011-02-11	2011-02-11 00:00:00	2011-02-11	38000177		0	0	0		0	0	0	193399	0	309362	19075601		
13773	1150	1127433	2007-11-30	2007-11-30 00:00:00	2007-12-14	2007-12-14 00:00:00	2007-12-14	38000177		0	0	14		0	0	0	76040	0	313782	1127433		
16785	363	40213306	1986-11-25	1986-11-25 00:00:00	1986-11-25	1986-11-25 00:00:00	1986-11-25	581452		0	0	0		0	0	0	24124	0	43	40213306		
2371	190	40222846	2010-12-22	2010-12-22 00:00:00	2010-12-22	2010-12-22 00:00:00	\N	38000177		0	0	0		0	0	0	13003	0	996740	40222846		
30549	2534	46233988	1974-10-13	1974-10-13 00:00:00	1974-10-27	1974-10-27 00:00:00	1974-10-27	38000177		0	0	14		0	0	0	167450	0	1652673	46233988		
2435	194	1127078	1990-03-12	1990-03-12 00:00:00	1990-04-11	1990-04-11 00:00:00	1990-04-11	38000177		0	0	30		0	0	0	13307	0	282464	1127078		
84583	1850	40213227	2007-12-14	2007-12-14 00:00:00	2007-12-14	2007-12-14 00:00:00	2007-12-14	581452		0	0	0		0	0	0	123791	0	113	40213227		
154029	3391	40213306	2004-12-14	2004-12-14 00:00:00	2004-12-14	2004-12-14 00:00:00	2004-12-14	581452		0	0	0		0	0	0	224899	0	43	40213306		
32446	2690	1539411	1992-10-15	1992-10-15 00:00:00	1992-10-15	1992-10-15 00:00:00	\N	38000177		0	0	0		0	0	0	178217	0	312961	1539411		
52456	4364	1127433	2005-03-18	2005-03-18 00:00:00	2005-04-01	2005-04-01 00:00:00	2005-04-01	38000177		0	0	14		0	0	0	289464	0	313782	1127433		
32523	2697	19133873	1947-12-21	1947-12-21 00:00:00	1947-12-30	1947-12-30 00:00:00	1947-12-30	38000177		0	0	9		0	0	0	178608	0	834061	19133873		
32553	710	40213260	2011-04-19	2011-04-19 00:00:00	2011-04-19	2011-04-19 00:00:00	2011-04-19	581452		0	0	0		0	0	0	47022	0	121	40213260		
238788	5241	40213306	1984-05-29	1984-05-29 00:00:00	1984-05-29	1984-05-29 00:00:00	1984-05-29	581452		0	0	0		0	0	0	348747	0	43	40213306		
18236	1510	1118084	2002-01-10	2002-01-10 00:00:00	2002-01-10	2002-01-10 00:00:00	\N	38000177		0	0	0		0	0	0	100824	0	00025152531	44923712		
55519	1216	40213227	2000-10-10	2000-10-10 00:00:00	2000-10-10	2000-10-10 00:00:00	2000-10-10	581452		0	0	0		0	0	0	80081	0	113	40213227		
206231	4526	40213160	1955-09-23	1955-09-23 00:00:00	1955-09-23	1955-09-23 00:00:00	1955-09-23	581452		0	0	0		0	0	0	301339	0	10	40213160		
206288	4527	40213260	2011-06-17	2011-06-17 00:00:00	2011-06-17	2011-06-17 00:00:00	2011-06-17	581452		0	0	0		0	0	0	301422	0	121	40213260		
8446	704	40232448	1986-12-25	1986-12-25 00:00:00	1986-12-25	1986-12-25 00:00:00	\N	38000177		0	0	0		0	0	0	46535	0	1049630	40232448		
15513	1293	1539411	2010-02-23	2010-02-23 00:00:00	2010-02-23	2010-02-23 00:00:00	\N	38000177		0	0	0		0	0	0	85562	0	312961	1539411		
188782	4145	40213314	1977-06-12	1977-06-12 00:00:00	1977-06-12	1977-06-12 00:00:00	1977-06-12	581452		0	0	0		0	0	0	275483	0	49	40213314		
169197	3720	40213227	2005-04-12	2005-04-12 00:00:00	2005-04-12	2005-04-12 00:00:00	2005-04-12	581452		0	0	0		0	0	0	247266	0	113	40213227		
76281	1666	40213227	2016-09-17	2016-09-17 00:00:00	2016-09-17	2016-09-17 00:00:00	2016-09-17	581452		0	0	0		0	0	0	111860	0	113	40213227		
52656	4376	1115171	2010-09-19	2010-09-19 00:00:00	2010-10-19	2010-10-19 00:00:00	2010-10-19	38000177		0	0	30		0	0	0	290735	0	849574	1115171		
6996	152	40213260	2018-10-29	2018-10-29 00:00:00	2018-10-29	2018-10-29 00:00:00	2018-10-29	581452		0	0	0		0	0	0	10240	0	121	40213260		
25085	2064	19128065	1993-03-23	1993-03-23 00:00:00	1994-03-18	1994-03-18 00:00:00	1994-03-18	38000177		0	0	360		0	0	0	137284	0	749882	19128065		
160954	3541	40213296	2009-08-17	2009-08-17 00:00:00	2009-08-17	2009-08-17 00:00:00	2009-08-17	581452		0	0	0		0	0	0	235187	0	52	40213296		
16630	359	40213160	1978-04-01	1978-04-01 00:00:00	1978-04-01	1978-04-01 00:00:00	1978-04-01	581452		0	0	0		0	0	0	23872	0	10	40213160		
12172	1022	1127078	1969-07-17	1969-07-17 00:00:00	1969-07-31	1969-07-31 00:00:00	1969-07-31	38000177		0	0	14		0	0	0	67233	0	282464	1127078		
87884	1928	40213306	1993-06-23	1993-06-23 00:00:00	1993-06-23	1993-06-23 00:00:00	1993-06-23	581452		0	0	0		0	0	0	128327	0	43	40213306		
170848	3756	40213227	1992-02-22	1992-02-22 00:00:00	1992-02-22	1992-02-22 00:00:00	1992-02-22	581452		0	0	0		0	0	0	249636	0	113	40213227		
101357	2222	40213260	2014-08-05	2014-08-05 00:00:00	2014-08-05	2014-08-05 00:00:00	2014-08-05	581452		0	0	0		0	0	0	147900	0	121	40213260		
57963	4815	19006318	1971-08-27	1971-08-27 00:00:00	1971-09-10	1971-09-10 00:00:00	1971-09-10	38000177		0	0	14		0	0	0	320341	0	105078	19006318		
8918	190	40213201	1996-11-12	1996-11-12 00:00:00	1996-11-12	1996-11-12 00:00:00	1996-11-12	581452		0	0	0		0	0	0	12986	0	33	40213201		
58056	4822	19133873	1953-12-23	1953-12-23 00:00:00	1954-01-03	1954-01-03 00:00:00	1954-01-03	38000177		0	0	11		0	0	0	320728	0	834061	19133873		
140184	3079	40213201	1999-10-07	1999-10-07 00:00:00	1999-10-07	1999-10-07 00:00:00	1999-10-07	581452		0	0	0		0	0	0	204932	0	33	40213201		
465	35	40236824	1997-04-22	1997-04-22 00:00:00	1997-04-29	1997-04-29 00:00:00	1997-04-29	38000177		0	0	7		0	0	0	2406	0	1094107	40236824		
1274	101	1124300	1965-05-28	1965-05-28 00:00:00	1965-05-28	1965-05-28 00:00:00	\N	38000177		0	0	0		0	0	0	6864	0	00781178901	45011828		
14885	1246	1127433	1994-03-03	1994-03-03 00:00:00	1994-03-24	1994-03-24 00:00:00	1994-03-24	38000177		0	0	21		0	0	0	82055	0	313782	1127433		
93440	2051	40213160	1963-04-28	1963-04-28 00:00:00	1963-04-28	1963-04-28 00:00:00	1963-04-28	581452		0	0	0		0	0	0	136356	0	10	40213160		
46994	3893	1118084	2011-04-28	2011-04-28 00:00:00	2011-04-28	2011-04-28 00:00:00	\N	38000177		0	0	0		0	0	0	258860	0	00025152531	44923712		
2660	212	19128065	1989-02-19	1989-02-19 00:00:00	1990-02-14	1990-02-14 00:00:00	1990-02-14	38000177		0	0	360		0	0	0	14416	0	749882	19128065		
50595	4204	19059056	1954-07-20	1954-07-20 00:00:00	1954-08-03	1954-08-03 00:00:00	1954-08-03	38000177		0	0	14		0	0	0	279078	0	243670	19059056		
108928	2389	40213227	2002-12-03	2002-12-03 00:00:00	2002-12-03	2002-12-03 00:00:00	2002-12-03	581452		0	0	0		0	0	0	158871	0	113	40213227		
5662	474	1127078	1976-05-11	1976-05-11 00:00:00	1976-06-01	1976-06-01 00:00:00	1976-06-01	38000177		0	0	21		0	0	0	31640	0	282464	1127078		
19359	421	40213160	1966-02-22	1966-02-22 00:00:00	1966-02-22	1966-02-22 00:00:00	1966-02-22	581452		0	0	0		0	0	0	27893	0	10	40213160		
30405	2521	920300	1986-02-17	1986-02-17 00:00:00	1986-02-24	1986-02-24 00:00:00	1986-02-24	38000177		0	0	7		0	0	0	166733	0	311989	920300		
208817	4580	40213227	2017-03-07	2017-03-07 00:00:00	2017-03-07	2017-03-07 00:00:00	2017-03-07	581452		0	0	0		0	0	0	305135	0	113	40213227		
49390	1081	40213160	1966-07-27	1966-07-27 00:00:00	1966-07-27	1966-07-27 00:00:00	1966-07-27	581452		0	0	0		0	0	0	70865	0	10	40213160		
59482	4943	19115351	1962-02-01	1962-02-01 00:00:00	1962-08-16	1962-08-16 00:00:00	1962-08-16	38000177		0	0	196		0	0	0	328618	0	563026	19115351		
13266	1113	19133873	1986-10-11	1986-10-11 00:00:00	1986-10-19	1986-10-19 00:00:00	1986-10-19	38000177		0	0	8		0	0	0	73256	0	834061	19133873		
70884	1551	40213260	2007-01-08	2007-01-08 00:00:00	2007-01-08	2007-01-08 00:00:00	2007-01-08	581452		0	0	0		0	0	0	103863	0	121	40213260		
53496	4448	1127433	1987-11-28	1987-11-28 00:00:00	1987-12-12	1987-12-12 00:00:00	1987-12-12	38000177		0	0	14		0	0	0	295845	0	313782	1127433		
34185	2825	1713671	1972-10-26	1972-10-26 00:00:00	1972-11-16	1972-11-16 00:00:00	1972-11-16	38000177		0	0	21		0	0	0	187270	0	562251	1713671		
51005	4238	920334	1998-02-12	1998-02-12 00:00:00	1998-02-19	1998-02-19 00:00:00	1998-02-19	38000177		0	0	7		0	0	0	281408	0	311995	920334		
48387	1058	40213160	1956-03-03	1956-03-03 00:00:00	1956-03-03	1956-03-03 00:00:00	1956-03-03	581452		0	0	0		0	0	0	69397	0	10	40213160		
13858	1158	19019979	1980-11-27	1980-11-27 00:00:00	1980-12-11	1980-12-11 00:00:00	1980-12-11	38000177		0	0	14		0	0	0	76524	0	198405	19019979		
22150	1820	1124300	2014-08-17	2014-08-17 00:00:00	2014-08-17	2014-08-17 00:00:00	\N	38000177		0	0	0		0	0	0	121737	0	00781178901	45011828		
61637	5128	19078461	2008-01-08	2008-01-08 00:00:00	2008-02-05	2008-02-05 00:00:00	2008-02-05	38000177		0	0	28		0	0	0	340920	0	310965	19078461		
58577	1282	40213227	1998-11-07	1998-11-07 00:00:00	1998-11-07	1998-11-07 00:00:00	1998-11-07	581452		0	0	0		0	0	0	84711	0	113	40213227		
24499	2016	19059056	1989-05-26	1989-05-26 00:00:00	1989-06-16	1989-06-16 00:00:00	1989-06-16	38000177		0	0	21		0	0	0	134106	0	243670	19059056		
20668	1703	1118084	1992-10-16	1992-10-16 00:00:00	1992-10-16	1992-10-16 00:00:00	\N	38000177		0	0	0		0	0	0	113880	0	00025152531	44923712		
35048	2894	19078461	1993-11-10	1993-11-10 00:00:00	1993-12-01	1993-12-01 00:00:00	1993-12-01	38000177		0	0	21		0	0	0	192601	0	310965	19078461		
52165	4338	1124300	1998-01-18	1998-01-18 00:00:00	1998-01-18	1998-01-18 00:00:00	\N	38000177		0	0	0		0	0	0	287698	0	00781178901	45011828		
63596	5284	19075001	2002-05-17	2002-05-17 00:00:00	2002-05-31	2002-05-31 00:00:00	2002-05-31	38000177		0	0	14		0	0	0	351518	0	309097	19075001		
35184	2902	40220960	2011-02-11	2011-02-11 00:00:00	2011-02-11	2011-02-11 00:00:00	2011-02-11	38000177		0	0	0		0	0	0	193399	0	1804799	40220960		
13774	1150	1713671	2011-11-12	2011-11-12 00:00:00	2011-11-19	2011-11-19 00:00:00	2011-11-19	38000177		0	0	7		0	0	0	76077	0	562251	1713671		
16791	363	40213227	2015-07-14	2015-07-14 00:00:00	2015-07-14	2015-07-14 00:00:00	2015-07-14	581452		0	0	0		0	0	0	24094	0	113	40213227		
2372	190	1127433	1949-12-26	1949-12-26 00:00:00	1950-01-09	1950-01-09 00:00:00	1950-01-09	38000177		0	0	14		0	0	0	12913	0	313782	1127433		
30550	2534	19019979	1974-10-13	1974-10-13 00:00:00	1974-10-27	1974-10-27 00:00:00	1974-10-27	38000177		0	0	14		0	0	0	167450	0	198405	19019979		
2436	194	19133873	1991-11-11	1991-11-11 00:00:00	1991-11-19	1991-11-19 00:00:00	1991-11-19	38000177		0	0	8		0	0	0	13301	0	834061	19133873		
84584	1850	40213260	2007-12-14	2007-12-14 00:00:00	2007-12-14	2007-12-14 00:00:00	2007-12-14	581452		0	0	0		0	0	0	123791	0	121	40213260		
154036	3391	40213251	1987-06-02	1987-06-02 00:00:00	1987-06-02	1987-06-02 00:00:00	1987-06-02	581452		0	0	0		0	0	0	224894	0	21	40213251		
32447	2690	19006318	1951-07-30	1951-07-30 00:00:00	1951-08-13	1951-08-13 00:00:00	1951-08-13	38000177		0	0	14		0	0	0	178196	0	105078	19006318		
62915	5229	19059056	1964-11-09	1964-11-09 00:00:00	1964-11-23	1964-11-23 00:00:00	1964-11-23	38000177		0	0	14		0	0	0	347876	0	243670	19059056		
32524	2697	1124300	1975-12-26	1975-12-26 00:00:00	1975-12-26	1975-12-26 00:00:00	\N	38000177		0	0	0		0	0	0	178650	0	00781178901	45011828		
32567	710	40213160	1961-09-26	1961-09-26 00:00:00	1961-09-26	1961-09-26 00:00:00	1961-09-26	581452		0	0	0		0	0	0	46989	0	10	40213160		
238798	5242	40213296	2002-08-02	2002-08-02 00:00:00	2002-08-02	2002-08-02 00:00:00	2002-08-02	581452		0	0	0		0	0	0	348819	0	52	40213296		
18237	1511	19078461	2003-06-01	2003-06-01 00:00:00	2003-07-06	2003-07-06 00:00:00	2003-07-06	38000177		0	0	35		0	0	0	100935	0	310965	19078461		
55523	1216	40213160	1970-04-07	1970-04-07 00:00:00	1970-04-07	1970-04-07 00:00:00	1970-04-07	581452		0	0	0		0	0	0	80092	0	10	40213160		
206235	4526	40213160	1956-03-23	1956-03-23 00:00:00	1956-03-23	1956-03-23 00:00:00	1956-03-23	581452		0	0	0		0	0	0	301406	0	10	40213160		
206290	4527	40213227	2011-06-17	2011-06-17 00:00:00	2011-06-17	2011-06-17 00:00:00	2011-06-17	581452		0	0	0		0	0	0	301422	0	113	40213227		
3825	318	19059056	1955-01-24	1955-01-24 00:00:00	1955-02-07	1955-02-07 00:00:00	1955-02-07	38000177		0	0	14		0	0	0	21071	0	243670	19059056		
15514	1293	19075601	2010-02-23	2010-02-23 00:00:00	2010-02-23	2010-02-23 00:00:00	\N	38000177		0	0	0		0	0	0	85562	0	309362	19075601		
188784	4145	40213160	1974-10-13	1974-10-13 00:00:00	1974-10-13	1974-10-13 00:00:00	1974-10-13	581452		0	0	0		0	0	0	275550	0	10	40213160		
169201	3720	40213160	1955-06-14	1955-06-14 00:00:00	1955-06-14	1955-06-14 00:00:00	1955-06-14	581452		0	0	0		0	0	0	247290	0	10	40213160		
47223	3916	1127433	2012-10-07	2012-10-07 00:00:00	2012-10-21	2012-10-21 00:00:00	2012-10-21	38000177		0	0	14		0	0	0	260309	0	313782	1127433		
52657	4376	19059056	1921-10-24	1921-10-24 00:00:00	1921-11-07	1921-11-07 00:00:00	1921-11-07	38000177		0	0	14		0	0	0	290788	0	243670	19059056		
6999	152	40213306	1989-10-09	1989-10-09 00:00:00	1989-10-09	1989-10-09 00:00:00	1989-10-09	581452		0	0	0		0	0	0	10285	0	43	40213306		
25086	2064	19128022	1992-03-28	1992-03-28 00:00:00	1993-03-23	1993-03-23 00:00:00	1993-03-23	38000177		0	0	360		0	0	0	137283	0	749785	19128022		
160964	3542	40213227	1998-06-06	1998-06-06 00:00:00	1998-06-06	1998-06-06 00:00:00	1998-06-06	581452		0	0	0		0	0	0	235256	0	113	40213227		
16633	359	40213314	1978-12-30	1978-12-30 00:00:00	1978-12-30	1978-12-30 00:00:00	1978-12-30	581452		0	0	0		0	0	0	23892	0	49	40213314		
12173	1022	1127078	1966-02-19	1966-02-19 00:00:00	1966-03-05	1966-03-05 00:00:00	1966-03-05	38000177		0	0	14		0	0	0	67271	0	282464	1127078		
87886	1928	40213227	2004-10-06	2004-10-06 00:00:00	2004-10-06	2004-10-06 00:00:00	2004-10-06	581452		0	0	0		0	0	0	128385	0	113	40213227		
170854	3756	40213227	2002-04-20	2002-04-20 00:00:00	2002-04-20	2002-04-20 00:00:00	2002-04-20	581452		0	0	0		0	0	0	249705	0	113	40213227		
101362	2222	40213160	1967-12-05	1967-12-05 00:00:00	1967-12-05	1967-12-05 00:00:00	1967-12-05	581452		0	0	0		0	0	0	147940	0	10	40213160		
57964	4815	19133873	1970-12-31	1970-12-31 00:00:00	1971-01-08	1971-01-08 00:00:00	1971-01-08	38000177		0	0	8		0	0	0	320318	0	834061	19133873		
8921	190	40213227	2012-02-07	2012-02-07 00:00:00	2012-02-07	2012-02-07 00:00:00	2012-02-07	581452		0	0	0		0	0	0	12932	0	113	40213227		
58058	4822	19059056	1966-08-20	1966-08-20 00:00:00	1966-09-03	1966-09-03 00:00:00	1966-09-03	38000177		0	0	14		0	0	0	320724	0	243670	19059056		
140187	3079	40213227	2004-11-04	2004-11-04 00:00:00	2004-11-04	2004-11-04 00:00:00	2004-11-04	581452		0	0	0		0	0	0	204892	0	113	40213227		
466	35	19133905	1996-07-02	1996-07-02 00:00:00	1996-07-10	1996-07-10 00:00:00	1996-07-10	38000177		0	0	8		0	0	0	2405	0	834102	19133905		
1275	101	19133905	1983-04-17	1983-04-17 00:00:00	1983-04-25	1983-04-25 00:00:00	1983-04-25	38000177		0	0	8		0	0	0	6907	0	834102	19133905		
14886	1246	1127433	1945-05-23	1945-05-23 00:00:00	1945-06-06	1945-06-06 00:00:00	1945-06-06	38000177		0	0	14		0	0	0	82038	0	313782	1127433		
93445	2051	40213227	2004-11-28	2004-11-28 00:00:00	2004-11-28	2004-11-28 00:00:00	2004-11-28	581452		0	0	0		0	0	0	136361	0	113	40213227		
46995	3893	1127078	1978-11-07	1978-11-07 00:00:00	1978-11-21	1978-11-21 00:00:00	1978-11-21	38000177		0	0	14		0	0	0	258877	0	282464	1127078		
2661	212	920300	2015-04-22	2015-04-22 00:00:00	2015-04-29	2015-04-29 00:00:00	2015-04-29	38000177		0	0	7		0	0	0	14463	0	311989	920300		
50596	4204	19006318	1954-07-20	1954-07-20 00:00:00	1954-08-03	1954-08-03 00:00:00	1954-08-03	38000177		0	0	14		0	0	0	279078	0	105078	19006318		
191330	4204	40213160	1955-08-01	1955-08-01 00:00:00	1955-08-01	1955-08-01 00:00:00	1955-08-01	581452		0	0	0		0	0	0	279089	0	10	40213160		
5663	474	19133905	2002-03-03	2002-03-03 00:00:00	2002-03-13	2002-03-13 00:00:00	2002-03-13	38000177		0	0	10		0	0	0	31654	0	834102	19133905		
19361	421	40213160	1965-09-22	1965-09-22 00:00:00	1965-09-22	1965-09-22 00:00:00	1965-09-22	581452		0	0	0		0	0	0	27848	0	10	40213160		
30406	2521	40236824	1986-02-17	1986-02-17 00:00:00	1986-03-03	1986-03-03 00:00:00	1986-03-03	38000177		0	0	14		0	0	0	166733	0	1094107	40236824		
208818	4580	40213260	2017-03-07	2017-03-07 00:00:00	2017-03-07	2017-03-07 00:00:00	2017-03-07	581452		0	0	0		0	0	0	305135	0	121	40213260		
49394	1081	40213306	1985-01-30	1985-01-30 00:00:00	1985-01-30	1985-01-30 00:00:00	1985-01-30	581452		0	0	0		0	0	0	70880	0	43	40213306		
59483	4943	19128065	1975-01-29	1975-01-29 00:00:00	1976-01-24	1976-01-24 00:00:00	1976-01-24	38000177		0	0	360		0	0	0	328584	0	749882	19128065		
13267	1113	1713671	2013-11-01	2013-11-01 00:00:00	2013-11-08	2013-11-08 00:00:00	2013-11-08	38000177		0	0	7		0	0	0	73289	0	562251	1713671		
82166	1794	40213160	1959-07-18	1959-07-18 00:00:00	1959-07-18	1959-07-18 00:00:00	1959-07-18	581452		0	0	0		0	0	0	120311	0	10	40213160		
53497	4448	19133873	1955-05-14	1955-05-14 00:00:00	1955-05-24	1955-05-24 00:00:00	1955-05-24	38000177		0	0	10		0	0	0	295843	0	834061	19133873		
44655	3697	920300	1978-06-13	1978-06-13 00:00:00	1978-06-20	1978-06-20 00:00:00	1978-06-20	38000177		0	0	7		0	0	0	245801	0	311989	920300		
51006	4238	1713671	2011-08-13	2011-08-13 00:00:00	2011-09-03	2011-09-03 00:00:00	2011-09-03	38000177		0	0	21		0	0	0	281365	0	562251	1713671		
48389	1058	40213227	2006-09-30	2006-09-30 00:00:00	2006-09-30	2006-09-30 00:00:00	2006-09-30	581452		0	0	0		0	0	0	69462	0	113	40213227		
13859	1158	1713671	2007-08-17	2007-08-17 00:00:00	2007-08-31	2007-08-31 00:00:00	2007-08-31	38000177		0	0	14		0	0	0	76506	0	562251	1713671		
22151	1820	1713671	2015-07-14	2015-07-14 00:00:00	2015-08-04	2015-08-04 00:00:00	2015-08-04	38000177		0	0	21		0	0	0	121748	0	562251	1713671		
61638	5128	1713671	2018-09-27	2018-09-27 00:00:00	2018-10-18	2018-10-18 00:00:00	2018-10-18	38000177		0	0	21		0	0	0	341000	0	562251	1713671		
17639	1460	19128022	1996-05-21	1996-05-21 00:00:00	1997-05-16	1997-05-16 00:00:00	1997-05-16	38000177		0	0	360		0	0	0	97275	0	749785	19128022		
24500	2016	46233988	1981-03-09	1981-03-09 00:00:00	1981-03-23	1981-03-23 00:00:00	1981-03-23	38000177		0	0	14		0	0	0	134123	0	1652673	46233988		
20669	1703	1127433	1949-08-10	1949-08-10 00:00:00	1949-08-17	1949-08-17 00:00:00	1949-08-17	38000177		0	0	7		0	0	0	113914	0	313782	1127433		
35049	2894	19133905	1966-08-01	1966-08-01 00:00:00	1966-08-11	1966-08-11 00:00:00	1966-08-11	38000177		0	0	10		0	0	0	192636	0	834102	19133905		
52166	4338	19133873	1967-12-01	1967-12-01 00:00:00	1967-12-14	1967-12-14 00:00:00	1967-12-14	38000177		0	0	13		0	0	0	287644	0	834061	19133873		
63599	5284	1127433	1971-07-24	1971-07-24 00:00:00	1971-07-31	1971-07-31 00:00:00	1971-07-31	38000177		0	0	7		0	0	0	351549	0	313782	1127433		
35185	2903	1127433	1979-01-26	1979-01-26 00:00:00	1979-02-02	1979-02-02 00:00:00	1979-02-02	38000177		0	0	7		0	0	0	193410	0	313782	1127433		
76669	1674	40213296	2017-06-05	2017-06-05 00:00:00	2017-06-05	2017-06-05 00:00:00	2017-06-05	581452		0	0	0		0	0	0	112353	0	52	40213296		
16792	363	40213260	2015-07-14	2015-07-14 00:00:00	2015-07-14	2015-07-14 00:00:00	2015-07-14	581452		0	0	0		0	0	0	24094	0	121	40213260		
2373	190	1127433	1969-08-12	1969-08-12 00:00:00	1969-08-26	1969-08-26 00:00:00	1969-08-26	38000177		0	0	14		0	0	0	12911	0	313782	1127433		
30551	2534	1127433	2001-05-24	2001-05-24 00:00:00	2001-06-21	2001-06-21 00:00:00	2001-06-21	38000177		0	0	28		0	0	0	167432	0	313782	1127433		
2437	194	1127433	2010-07-25	2010-07-25 00:00:00	2010-08-22	2010-08-22 00:00:00	2010-08-22	38000177		0	0	28		0	0	0	13308	0	313782	1127433		
84594	1850	40213160	1957-08-23	1957-08-23 00:00:00	1957-08-23	1957-08-23 00:00:00	1957-08-23	581452		0	0	0		0	0	0	123760	0	10	40213160		
154038	3391	40213160	1987-06-02	1987-06-02 00:00:00	1987-06-02	1987-06-02 00:00:00	1987-06-02	581452		0	0	0		0	0	0	224894	0	10	40213160		
32448	2690	1127078	1951-07-30	1951-07-30 00:00:00	1951-08-13	1951-08-13 00:00:00	1951-08-13	38000177		0	0	14		0	0	0	178196	0	282464	1127078		
62916	5229	1127433	1977-06-20	1977-06-20 00:00:00	1977-08-19	1977-08-19 00:00:00	1977-08-19	38000177		0	0	60		0	0	0	347867	0	313782	1127433		
32525	2697	19059056	1933-07-19	1933-07-19 00:00:00	1933-08-02	1933-08-02 00:00:00	1933-08-02	38000177		0	0	14		0	0	0	178599	0	243670	19059056		
62983	5234	19077572	2006-07-19	2006-07-19 00:00:00	2006-07-19	2006-07-19 00:00:00	\N	38000177		0	0	0		0	0	0	348277	0	310436	19077572		
238801	5242	40213306	1985-01-11	1985-01-11 00:00:00	1985-01-11	1985-01-11 00:00:00	1985-01-11	581452		0	0	0		0	0	0	348858	0	43	40213306		
18238	1511	19128065	1985-03-21	1985-03-21 00:00:00	1986-03-16	1986-03-16 00:00:00	1986-03-16	38000177		0	0	360		0	0	0	100920	0	749882	19128065		
55524	1216	40213160	1970-01-06	1970-01-06 00:00:00	1970-01-06	1970-01-06 00:00:00	1970-01-06	581452		0	0	0		0	0	0	80101	0	10	40213160		
206244	4526	40213296	1997-08-08	1997-08-08 00:00:00	1997-08-08	1997-08-08 00:00:00	1997-08-08	581452		0	0	0		0	0	0	301393	0	52	40213296		
206292	4527	40213306	1983-06-10	1983-06-10 00:00:00	1983-06-10	1983-06-10 00:00:00	1983-06-10	581452		0	0	0		0	0	0	301483	0	43	40213306		
3826	318	19006318	1955-01-24	1955-01-24 00:00:00	1955-02-07	1955-02-07 00:00:00	1955-02-07	38000177		0	0	14		0	0	0	21071	0	105078	19006318		
15515	1293	19059056	1970-03-18	1970-03-18 00:00:00	1970-05-17	1970-05-17 00:00:00	1970-05-17	38000177		0	0	60		0	0	0	85602	0	243670	19059056		
188785	4145	40213160	1975-03-16	1975-03-16 00:00:00	1975-03-16	1975-03-16 00:00:00	1975-03-16	581452		0	0	0		0	0	0	275551	0	10	40213160		
40244	877	40213160	1977-08-09	1977-08-09 00:00:00	1977-08-09	1977-08-09 00:00:00	1977-08-09	581452		0	0	0		0	0	0	58368	0	10	40213160		
47224	3917	1127078	1972-10-10	1972-10-10 00:00:00	1972-10-24	1972-10-24 00:00:00	1972-10-24	38000177		0	0	14		0	0	0	260473	0	282464	1127078		
52658	4376	40171902	1981-07-14	1981-07-14 00:00:00	1981-07-14	1981-07-14 00:00:00	\N	38000177		0	0	0		0	0	0	290833	0	897718	40171902		
7002	152	40213160	1967-07-10	1967-07-10 00:00:00	1967-07-10	1967-07-10 00:00:00	1967-07-10	581452		0	0	0		0	0	0	10272	0	10	40213160		
34051	744	40213160	1956-03-02	1956-03-02 00:00:00	1956-03-02	1956-03-02 00:00:00	1956-03-02	581452		0	0	0		0	0	0	49318	0	10	40213160		
42168	919	40213160	1973-01-01	1973-01-01 00:00:00	1973-01-01	1973-01-01 00:00:00	1973-01-01	581452		0	0	0		0	0	0	61235	0	10	40213160		
16637	359	40213251	1984-10-13	1984-10-13 00:00:00	1984-10-13	1984-10-13 00:00:00	1984-10-13	581452		0	0	0		0	0	0	23895	0	21	40213251		
12174	1022	19129655	1966-02-19	1966-02-19 00:00:00	1966-03-05	1966-03-05 00:00:00	1966-03-05	38000177		0	0	14		0	0	0	67271	0	789980	19129655		
99167	2172	40213296	2018-10-13	2018-10-13 00:00:00	2018-10-13	2018-10-13 00:00:00	2018-10-13	581452		0	0	0		0	0	0	144661	0	52	40213296		
170875	3756	40213201	2007-05-19	2007-05-19 00:00:00	2007-05-19	2007-05-19 00:00:00	2007-05-19	581452		0	0	0		0	0	0	249691	0	33	40213201		
101368	2222	40213227	2004-07-06	2004-07-06 00:00:00	2004-07-06	2004-07-06 00:00:00	2004-07-06	581452		0	0	0		0	0	0	147898	0	113	40213227		
57965	4815	1127433	2010-11-28	2010-11-28 00:00:00	2011-01-02	2011-01-02 00:00:00	2011-01-02	38000177		0	0	35		0	0	0	320336	0	313782	1127433		
8922	191	40213227	2001-11-06	2001-11-06 00:00:00	2001-11-06	2001-11-06 00:00:00	2001-11-06	581452		0	0	0		0	0	0	13130	0	113	40213227		
58060	4822	1127078	1951-08-04	1951-08-04 00:00:00	1951-08-25	1951-08-25 00:00:00	1951-08-25	38000177		0	0	21		0	0	0	320722	0	282464	1127078		
57058	1249	40213160	1968-10-03	1968-10-03 00:00:00	1968-10-03	1968-10-03 00:00:00	1968-10-03	581452		0	0	0		0	0	0	82312	0	10	40213160		
467	35	19133905	2011-02-21	2011-02-21 00:00:00	2011-02-28	2011-02-28 00:00:00	2011-02-28	38000177		0	0	7		0	0	0	2408	0	834102	19133905		
1276	101	1115171	2017-07-10	2017-07-10 00:00:00	2017-10-08	2017-10-08 00:00:00	2017-10-08	38000177		0	0	90		0	0	0	6946	0	849574	1115171		
14887	1246	1551192	1939-02-16	1939-02-16 00:00:00	1939-02-16	1939-02-16 00:00:00	1939-02-16	38000177		0	0	0		0	0	0	82133	0	312617	1551192		
93446	2051	40213296	2004-11-28	2004-11-28 00:00:00	2004-11-28	2004-11-28 00:00:00	2004-11-28	581452		0	0	0		0	0	0	136361	0	52	40213296		
46996	3893	19006318	1978-11-07	1978-11-07 00:00:00	1978-11-21	1978-11-21 00:00:00	1978-11-21	38000177		0	0	14		0	0	0	258877	0	105078	19006318		
2662	212	40236824	2015-04-22	2015-04-22 00:00:00	2015-04-29	2015-04-29 00:00:00	2015-04-29	38000177		0	0	7		0	0	0	14463	0	1094107	40236824		
50597	4204	1127433	1993-03-18	1993-03-18 00:00:00	1993-04-01	1993-04-01 00:00:00	1993-04-01	38000177		0	0	14		0	0	0	279071	0	313782	1127433		
191334	4204	40213201	2017-01-23	2017-01-23 00:00:00	2017-01-23	2017-01-23 00:00:00	2017-01-23	581452		0	0	0		0	0	0	279151	0	33	40213201		
5671	476	1127433	1983-05-25	1983-05-25 00:00:00	1983-06-15	1983-06-15 00:00:00	1983-06-15	38000177		0	0	21		0	0	0	31752	0	313782	1127433		
19362	421	40213160	1970-05-27	1970-05-27 00:00:00	1970-05-27	1970-05-27 00:00:00	1970-05-27	581452		0	0	0		0	0	0	27891	0	10	40213160		
30407	2521	19133873	1953-01-10	1953-01-10 00:00:00	1953-01-17	1953-01-17 00:00:00	1953-01-17	38000177		0	0	7		0	0	0	166757	0	834061	19133873		
208825	4580	40213227	2009-02-10	2009-02-10 00:00:00	2009-02-10	2009-02-10 00:00:00	2009-02-10	581452		0	0	0		0	0	0	305134	0	113	40213227		
49397	1081	40213260	2011-08-17	2011-08-17 00:00:00	2011-08-17	2011-08-17 00:00:00	2011-08-17	581452		0	0	0		0	0	0	70856	0	121	40213260		
59484	4943	19078461	1995-09-29	1995-09-29 00:00:00	1995-10-13	1995-10-13 00:00:00	1995-10-13	38000177		0	0	14		0	0	0	328617	0	310965	19078461		
13268	1113	19128065	1986-11-07	1986-11-07 00:00:00	1987-11-02	1987-11-02 00:00:00	1987-11-02	38000177		0	0	360		0	0	0	73243	0	749882	19128065		
4317	358	19133905	1982-02-27	1982-02-27 00:00:00	1982-03-10	1982-03-10 00:00:00	1982-03-10	38000177		0	0	11		0	0	0	23828	0	834102	19133905		
53498	4448	1124300	1995-01-20	1995-01-20 00:00:00	1995-01-20	1995-01-20 00:00:00	\N	38000177		0	0	0		0	0	0	295855	0	00781178901	45011828		
44656	3697	40229134	1987-04-16	1987-04-16 00:00:00	1987-04-23	1987-04-23 00:00:00	1987-04-23	38000177		0	0	7		0	0	0	245803	0	1043400	40229134		
51007	4238	1115171	1998-10-21	1998-10-21 00:00:00	1998-11-04	1998-11-04 00:00:00	1998-11-04	38000177		0	0	14		0	0	0	281384	0	849574	1115171		
62880	1376	40213160	1978-02-17	1978-02-17 00:00:00	1978-02-17	1978-02-17 00:00:00	1978-02-17	581452		0	0	0		0	0	0	91211	0	10	40213160		
13860	1158	19073188	2005-02-14	2005-02-14 00:00:00	2005-02-28	2005-02-28 00:00:00	2005-02-28	38000177		0	0	14		0	0	0	76481	0	308192	19073188		
22152	1820	19133873	1982-03-19	1982-03-19 00:00:00	1982-03-31	1982-03-31 00:00:00	1982-03-31	38000177		0	0	12		0	0	0	121738	0	834061	19133873		
61639	5128	40236824	1962-09-10	1962-09-10 00:00:00	1962-09-17	1962-09-17 00:00:00	1962-09-17	38000177		0	0	7		0	0	0	340958	0	1094107	40236824		
17640	1460	1127433	2016-11-20	2016-11-20 00:00:00	2016-12-25	2016-12-25 00:00:00	2016-12-25	38000177		0	0	35		0	0	0	97305	0	313782	1127433		
24501	2016	1127078	1981-03-09	1981-03-09 00:00:00	1981-03-23	1981-03-23 00:00:00	1981-03-23	38000177		0	0	14		0	0	0	134123	0	282464	1127078		
20670	1703	1127433	1965-03-19	1965-03-19 00:00:00	1965-04-02	1965-04-02 00:00:00	1965-04-02	38000177		0	0	14		0	0	0	113908	0	313782	1127433		
35050	2894	19059056	1929-11-08	1929-11-08 00:00:00	1929-12-13	1929-12-13 00:00:00	1929-12-13	38000177		0	0	35		0	0	0	192621	0	243670	19059056		
52170	4340	1127078	1977-04-29	1977-04-29 00:00:00	1977-05-20	1977-05-20 00:00:00	1977-05-20	38000177		0	0	21		0	0	0	287779	0	282464	1127078		
63600	5284	1713671	1990-08-25	1990-08-25 00:00:00	1990-09-15	1990-09-15 00:00:00	1990-09-15	38000177		0	0	21		0	0	0	351603	0	562251	1713671		
35186	2903	1115171	2013-12-12	2013-12-12 00:00:00	2014-01-02	2014-01-02 00:00:00	2014-01-02	38000177		0	0	21		0	0	0	193432	0	849574	1115171		
76671	1674	40213314	1977-03-21	1977-03-21 00:00:00	1977-03-21	1977-03-21 00:00:00	1977-03-21	581452		0	0	0		0	0	0	112395	0	49	40213314		
16793	363	40213260	2014-07-08	2014-07-08 00:00:00	2014-07-08	2014-07-08 00:00:00	2014-07-08	581452		0	0	0		0	0	0	24112	0	121	40213260		
2374	190	19133905	1994-07-14	1994-07-14 00:00:00	1994-07-23	1994-07-23 00:00:00	1994-07-23	38000177		0	0	9		0	0	0	12966	0	834102	19133905		
30552	2534	19133905	2008-08-16	2008-08-16 00:00:00	2008-08-23	2008-08-23 00:00:00	2008-08-23	38000177		0	0	7		0	0	0	167389	0	834102	19133905		
2438	194	1127078	1988-05-07	1988-05-07 00:00:00	1988-05-21	1988-05-21 00:00:00	1988-05-21	38000177		0	0	14		0	0	0	13306	0	282464	1127078		
84597	1850	40213296	1998-12-25	1998-12-25 00:00:00	1998-12-25	1998-12-25 00:00:00	1998-12-25	581452		0	0	0		0	0	0	123804	0	52	40213296		
154041	3391	40213160	1982-11-30	1982-11-30 00:00:00	1982-11-30	1982-11-30 00:00:00	1982-11-30	581452		0	0	0		0	0	0	224890	0	10	40213160		
32449	2690	19075601	1998-10-01	1998-10-01 00:00:00	2001-08-02	2001-08-02 00:00:00	2001-08-02	38000177		0	0	1036		0	0	0	178234	0	309362	19075601		
62917	5229	40162522	1977-06-20	1977-06-20 00:00:00	1977-06-20	1977-06-20 00:00:00	\N	38000177		0	0	0		0	0	0	347867	0	857005	40162522		
32526	2697	1127433	1941-10-07	1941-10-07 00:00:00	1941-10-21	1941-10-21 00:00:00	1941-10-21	38000177		0	0	14		0	0	0	178568	0	313782	1127433		
62984	5234	1127433	1993-08-28	1993-08-28 00:00:00	1993-09-11	1993-09-11 00:00:00	1993-09-11	38000177		0	0	14		0	0	0	348215	0	313782	1127433		
238805	5242	40213260	2012-07-27	2012-07-27 00:00:00	2012-07-27	2012-07-27 00:00:00	2012-07-27	581452		0	0	0		0	0	0	348821	0	121	40213260		
18239	1511	1127078	1974-11-04	1974-11-04 00:00:00	1974-12-04	1974-12-04 00:00:00	1974-12-04	38000177		0	0	30		0	0	0	100931	0	282464	1127078		
55526	1216	40213306	1991-10-01	1991-10-01 00:00:00	1991-10-01	1991-10-01 00:00:00	1991-10-01	581452		0	0	0		0	0	0	80078	0	43	40213306		
206249	4526	40213198	2019-01-04	2019-01-04 00:00:00	2019-01-04	2019-01-04 00:00:00	2019-01-04	581452		0	0	0		0	0	0	301362	0	133	40213198		
206295	4527	40213160	1960-09-16	1960-09-16 00:00:00	1960-09-16	1960-09-16 00:00:00	1960-09-16	581452		0	0	0		0	0	0	301419	0	10	40213160		
3827	318	40229134	2004-07-05	2004-07-05 00:00:00	2004-07-19	2004-07-19 00:00:00	2004-07-19	38000177		0	0	14		0	0	0	21113	0	1043400	40229134		
15516	1293	40165015	1970-03-18	1970-03-18 00:00:00	1970-03-18	1970-03-18 00:00:00	\N	38000177		0	0	0		0	0	0	85602	0	861467	40165015		
24159	1987	1127433	1993-10-19	1993-10-19 00:00:00	1993-11-09	1993-11-09 00:00:00	1993-11-09	38000177		0	0	21		0	0	0	132289	0	313782	1127433		
40249	877	40213306	1999-07-06	1999-07-06 00:00:00	1999-07-06	1999-07-06 00:00:00	1999-07-06	581452		0	0	0		0	0	0	58456	0	43	40213306		
47225	3917	46233988	1972-10-10	1972-10-10 00:00:00	1972-10-24	1972-10-24 00:00:00	1972-10-24	38000177		0	0	14		0	0	0	260473	0	1652673	46233988		
42069	917	40213160	1963-08-22	1963-08-22 00:00:00	1963-08-22	1963-08-22 00:00:00	1963-08-22	581452		0	0	0		0	0	0	60944	0	10	40213160		
7004	152	40213227	1998-10-19	1998-10-19 00:00:00	1998-10-19	1998-10-19 00:00:00	1998-10-19	581452		0	0	0		0	0	0	10288	0	113	40213227		
34053	744	40213227	2013-11-08	2013-11-08 00:00:00	2013-11-08	2013-11-08 00:00:00	2013-11-08	581452		0	0	0		0	0	0	49309	0	113	40213227		
42170	919	40213160	1972-10-30	1972-10-30 00:00:00	1972-10-30	1972-10-30 00:00:00	1972-10-30	581452		0	0	0		0	0	0	61258	0	10	40213160		
16641	359	40213160	1982-10-02	1982-10-02 00:00:00	1982-10-02	1982-10-02 00:00:00	1982-10-02	581452		0	0	0		0	0	0	23894	0	10	40213160		
12176	1022	1713671	2004-04-30	2004-04-30 00:00:00	2004-05-07	2004-05-07 00:00:00	2004-05-07	38000177		0	0	7		0	0	0	67231	0	562251	1713671		
99169	2172	40213227	2000-12-09	2000-12-09 00:00:00	2000-12-09	2000-12-09 00:00:00	2000-12-09	581452		0	0	0		0	0	0	144704	0	113	40213227		
115626	2541	40213160	1980-09-08	1980-09-08 00:00:00	1980-09-08	1980-09-08 00:00:00	1980-09-08	581452		0	0	0		0	0	0	168042	0	10	40213160		
101369	2222	40213296	2004-07-06	2004-07-06 00:00:00	2004-07-06	2004-07-06 00:00:00	2004-07-06	581452		0	0	0		0	0	0	147898	0	52	40213296		
57966	4816	1118084	2017-12-15	2017-12-15 00:00:00	2017-12-15	2017-12-15 00:00:00	\N	38000177		0	0	0		0	0	0	320377	0	00025152531	44923712		
22289	484	40213201	2004-04-05	2004-04-05 00:00:00	2004-04-05	2004-04-05 00:00:00	2004-04-05	581452		0	0	0		0	0	0	32329	0	33	40213201		
58061	4822	1127433	1966-08-25	1966-08-25 00:00:00	1966-09-01	1966-09-01 00:00:00	1966-09-01	38000177		0	0	7		0	0	0	320781	0	313782	1127433		
57061	1249	40213227	1999-04-08	1999-04-08 00:00:00	1999-04-08	1999-04-08 00:00:00	1999-04-08	581452		0	0	0		0	0	0	82306	0	113	40213227		
468	36	1127433	2001-06-17	2001-06-17 00:00:00	2001-07-01	2001-07-01 00:00:00	2001-07-01	38000177		0	0	14		0	0	0	2631	0	313782	1127433		
1277	101	1713671	2017-08-24	2017-08-24 00:00:00	2017-09-14	2017-09-14 00:00:00	2017-09-14	38000177		0	0	21		0	0	0	6838	0	562251	1713671		
14888	1246	19059056	1947-07-03	1947-07-03 00:00:00	1947-09-01	1947-09-01 00:00:00	1947-09-01	38000177		0	0	60		0	0	0	82134	0	243670	19059056		
93448	2051	40213160	1967-10-29	1967-10-29 00:00:00	1967-10-29	1967-10-29 00:00:00	1967-10-29	581452		0	0	0		0	0	0	136342	0	10	40213160		
46997	3893	1127433	1996-10-17	1996-10-17 00:00:00	1996-10-31	1996-10-31 00:00:00	1996-10-31	38000177		0	0	14		0	0	0	258878	0	313782	1127433		
28207	2332	1127433	1975-12-31	1975-12-31 00:00:00	1976-01-07	1976-01-07 00:00:00	1976-01-07	38000177		0	0	7		0	0	0	155063	0	313782	1127433		
50598	4204	40229134	1950-09-15	1950-09-15 00:00:00	1950-09-29	1950-09-29 00:00:00	1950-09-29	38000177		0	0	14		0	0	0	279112	0	1043400	40229134		
191345	4204	40213227	2011-12-26	2011-12-26 00:00:00	2011-12-26	2011-12-26 00:00:00	2011-12-26	581452		0	0	0		0	0	0	279130	0	113	40213227		
5672	476	19059056	1972-06-21	1972-06-21 00:00:00	1972-07-05	1972-07-05 00:00:00	1972-07-05	38000177		0	0	14		0	0	0	31709	0	243670	19059056		
2543	202	1127433	1998-01-30	1998-01-30 00:00:00	1998-02-06	1998-02-06 00:00:00	1998-02-06	38000177		0	0	7		0	0	0	13886	0	313782	1127433		
30408	2521	19059056	1949-02-12	1949-02-12 00:00:00	1949-03-05	1949-03-05 00:00:00	1949-03-05	38000177		0	0	21		0	0	0	166736	0	243670	19059056		
208826	4580	40213296	2009-02-10	2009-02-10 00:00:00	2009-02-10	2009-02-10 00:00:00	2009-02-10	581452		0	0	0		0	0	0	305134	0	52	40213296		
49398	1081	40213160	1961-11-22	1961-11-22 00:00:00	1961-11-22	1961-11-22 00:00:00	1961-11-22	581452		0	0	0		0	0	0	70873	0	10	40213160		
59485	4943	1127078	1964-10-13	1964-10-13 00:00:00	1964-11-03	1964-11-03 00:00:00	1964-11-03	38000177		0	0	21		0	0	0	328619	0	282464	1127078		
13269	1113	19128022	1993-10-09	1993-10-09 00:00:00	1994-10-04	1994-10-04 00:00:00	1994-10-04	38000177		0	0	360		0	0	0	73246	0	749785	19128022		
4318	358	1713671	2004-06-09	2004-06-09 00:00:00	2004-06-23	2004-06-23 00:00:00	2004-06-23	38000177		0	0	14		0	0	0	23853	0	562251	1713671		
171751	3776	40213160	1974-02-09	1974-02-09 00:00:00	1974-02-09	1974-02-09 00:00:00	1974-02-09	581452		0	0	0		0	0	0	250990	0	10	40213160		
44657	3697	1127433	2009-07-15	2009-07-15 00:00:00	2009-07-29	2009-07-29 00:00:00	2009-07-29	38000177		0	0	14		0	0	0	245775	0	313782	1127433		
51008	4238	1713671	1993-09-23	1993-09-23 00:00:00	1993-10-14	1993-10-14 00:00:00	1993-10-14	38000177		0	0	21		0	0	0	281406	0	562251	1713671		
62881	1376	40213314	1978-02-17	1978-02-17 00:00:00	1978-02-17	1978-02-17 00:00:00	1978-02-17	581452		0	0	0		0	0	0	91211	0	49	40213314		
13861	1158	1127433	2005-02-14	2005-02-14 00:00:00	2005-02-28	2005-02-28 00:00:00	2005-02-28	38000177		0	0	14		0	0	0	76481	0	313782	1127433		
22153	1820	19128022	1995-01-19	1995-01-19 00:00:00	1996-01-14	1996-01-14 00:00:00	1996-01-14	38000177		0	0	360		0	0	0	121749	0	749785	19128022		
61640	5128	920300	1962-09-10	1962-09-10 00:00:00	1962-09-17	1962-09-17 00:00:00	1962-09-17	38000177		0	0	7		0	0	0	340958	0	311989	920300		
17641	1460	1118084	2017-09-03	2017-09-03 00:00:00	2017-09-03	2017-09-03 00:00:00	\N	38000177		0	0	0		0	0	0	97305	0	00025152531	44923712		
24502	2016	42902245	1999-11-10	1999-11-10 00:00:00	2000-11-04	2000-11-04 00:00:00	2000-11-04	38000177		0	0	360		0	0	0	134149	0	1359133	42902245		
20671	1703	1713671	1971-12-24	1971-12-24 00:00:00	1972-01-07	1972-01-07 00:00:00	1972-01-07	38000177		0	0	14		0	0	0	113910	0	562251	1713671		
35051	2894	1127433	1991-02-24	1991-02-24 00:00:00	1991-04-25	1991-04-25 00:00:00	1991-04-25	38000177		0	0	60		0	0	0	192600	0	313782	1127433		
52171	4340	1127433	2002-03-20	2002-03-20 00:00:00	2002-03-27	2002-03-27 00:00:00	2002-03-27	38000177		0	0	7		0	0	0	287769	0	313782	1127433		
10713	890	19078461	1975-03-06	1975-03-06 00:00:00	1975-04-03	1975-04-03 00:00:00	1975-04-03	38000177		0	0	28		0	0	0	59327	0	310965	19078461		
35187	2903	920300	2004-11-09	2004-11-09 00:00:00	2004-11-16	2004-11-16 00:00:00	2004-11-16	38000177		0	0	7		0	0	0	193468	0	311989	920300		
76672	1674	40213160	1977-03-21	1977-03-21 00:00:00	1977-03-21	1977-03-21 00:00:00	1977-03-21	581452		0	0	0		0	0	0	112395	0	10	40213160		
16796	363	40213227	1995-10-24	1995-10-24 00:00:00	1995-10-24	1995-10-24 00:00:00	1995-10-24	581452		0	0	0		0	0	0	24065	0	113	40213227		
2375	190	19078461	2014-12-01	2014-12-01 00:00:00	2014-12-22	2014-12-22 00:00:00	2014-12-22	38000177		0	0	21		0	0	0	13001	0	310965	19078461		
30553	2534	19128065	1987-07-17	1987-07-17 00:00:00	1988-07-11	1988-07-11 00:00:00	1988-07-11	38000177		0	0	360		0	0	0	167429	0	749882	19128065		
2439	194	1127433	2013-06-27	2013-06-27 00:00:00	2013-07-04	2013-07-04 00:00:00	2013-07-04	38000177		0	0	7		0	0	0	13332	0	313782	1127433		
84599	1850	40213227	1998-12-25	1998-12-25 00:00:00	1998-12-25	1998-12-25 00:00:00	1998-12-25	581452		0	0	0		0	0	0	123804	0	113	40213227		
154042	3391	40213314	1982-11-30	1982-11-30 00:00:00	1982-11-30	1982-11-30 00:00:00	1982-11-30	581452		0	0	0		0	0	0	224890	0	49	40213314		
32450	2690	1332419	1994-10-20	1994-10-20 00:00:00	1994-10-20	1994-10-20 00:00:00	\N	38000177		0	0	0		0	0	0	178206	0	197361	1332419		
62918	5229	19059056	1963-11-26	1963-11-26 00:00:00	1963-12-10	1963-12-10 00:00:00	1963-12-10	38000177		0	0	14		0	0	0	347864	0	243670	19059056		
32527	2697	19133905	1978-03-07	1978-03-07 00:00:00	1978-03-16	1978-03-16 00:00:00	1978-03-16	38000177		0	0	9		0	0	0	178596	0	834102	19133905		
62985	5234	19059056	1977-09-07	1977-09-07 00:00:00	1977-09-21	1977-09-21 00:00:00	1977-09-21	38000177		0	0	14		0	0	0	348213	0	243670	19059056		
238807	5242	40213160	1963-04-05	1963-04-05 00:00:00	1963-04-05	1963-04-05 00:00:00	1963-04-05	581452		0	0	0		0	0	0	348847	0	10	40213160		
18240	1511	1127433	2014-07-23	2014-07-23 00:00:00	2014-07-30	2014-07-30 00:00:00	2014-07-30	38000177		0	0	7		0	0	0	100916	0	313782	1127433		
55529	1216	40213296	2013-01-08	2013-01-08 00:00:00	2013-01-08	2013-01-08 00:00:00	2013-01-08	581452		0	0	0		0	0	0	80107	0	52	40213296		
206252	4526	40213227	2005-09-02	2005-09-02 00:00:00	2005-09-02	2005-09-02 00:00:00	2005-09-02	581452		0	0	0		0	0	0	301372	0	113	40213227		
206297	4527	40213160	1961-02-17	1961-02-17 00:00:00	1961-02-17	1961-02-17 00:00:00	1961-02-17	581452		0	0	0		0	0	0	301431	0	10	40213160		
3828	318	1118084	1994-12-10	1994-12-10 00:00:00	1994-12-10	1994-12-10 00:00:00	\N	38000177		0	0	0		0	0	0	21080	0	00025152531	44923712		
15517	1293	19133905	1976-07-11	1976-07-11 00:00:00	1976-07-22	1976-07-22 00:00:00	1976-07-22	38000177		0	0	11		0	0	0	85545	0	834102	19133905		
24160	1987	1115171	2003-07-25	2003-07-25 00:00:00	2003-08-15	2003-08-15 00:00:00	2003-08-15	38000177		0	0	21		0	0	0	132291	0	849574	1115171		
40251	877	40213227	1999-07-06	1999-07-06 00:00:00	1999-07-06	1999-07-06 00:00:00	1999-07-06	581452		0	0	0		0	0	0	58456	0	113	40213227		
47226	3917	1127433	1994-01-20	1994-01-20 00:00:00	1994-02-03	1994-02-03 00:00:00	1994-02-03	38000177		0	0	14		0	0	0	260449	0	313782	1127433		
42073	917	40213296	2003-05-22	2003-05-22 00:00:00	2003-05-22	2003-05-22 00:00:00	2003-05-22	581452		0	0	0		0	0	0	60988	0	52	40213296		
7008	152	40213296	2006-11-06	2006-11-06 00:00:00	2006-11-06	2006-11-06 00:00:00	2006-11-06	581452		0	0	0		0	0	0	10289	0	52	40213296		
34060	744	40213227	2003-09-12	2003-09-12 00:00:00	2003-09-12	2003-09-12 00:00:00	2003-09-12	581452		0	0	0		0	0	0	49323	0	113	40213227		
42179	919	40213296	2013-06-10	2013-06-10 00:00:00	2013-06-10	2013-06-10 00:00:00	2013-06-10	581452		0	0	0		0	0	0	61220	0	52	40213296		
16645	359	40213227	2009-07-25	2009-07-25 00:00:00	2009-07-25	2009-07-25 00:00:00	2009-07-25	581452		0	0	0		0	0	0	23923	0	113	40213227		
12179	1022	19078461	2005-12-21	2005-12-21 00:00:00	2006-01-11	2006-01-11 00:00:00	2006-01-11	38000177		0	0	21		0	0	0	67209	0	310965	19078461		
99170	2172	40213306	2000-12-09	2000-12-09 00:00:00	2000-12-09	2000-12-09 00:00:00	2000-12-09	581452		0	0	0		0	0	0	144704	0	43	40213306		
6807	572	19133873	1954-05-24	1954-05-24 00:00:00	1954-06-05	1954-06-05 00:00:00	1954-06-05	38000177		0	0	12		0	0	0	37893	0	834061	19133873		
101371	2222	40213160	1963-09-03	1963-09-03 00:00:00	1963-09-03	1963-09-03 00:00:00	1963-09-03	581452		0	0	0		0	0	0	147936	0	10	40213160		
57967	4816	19128022	1997-10-26	1997-10-26 00:00:00	1998-10-21	1998-10-21 00:00:00	1998-10-21	38000177		0	0	360		0	0	0	320388	0	749785	19128022		
22308	484	40213227	2019-07-01	2019-07-01 00:00:00	2019-07-01	2019-07-01 00:00:00	2019-07-01	581452		0	0	0		0	0	0	32398	0	113	40213227		
58062	4822	19059056	1952-07-20	1952-07-20 00:00:00	1952-08-03	1952-08-03 00:00:00	1952-08-03	38000177		0	0	14		0	0	0	320723	0	243670	19059056		
57078	1249	40213296	2011-05-19	2011-05-19 00:00:00	2011-05-19	2011-05-19 00:00:00	2011-05-19	581452		0	0	0		0	0	0	82290	0	52	40213296		
469	36	1713671	1959-01-28	1959-01-28 00:00:00	1959-02-18	1959-02-18 00:00:00	1959-02-18	38000177		0	0	21		0	0	0	2483	0	562251	1713671		
1278	101	19115351	1986-11-04	1986-11-04 00:00:00	1987-03-10	1987-03-10 00:00:00	1987-03-10	38000177		0	0	126		0	0	0	6899	0	563026	19115351		
14889	1246	40222846	2013-09-28	2013-09-28 00:00:00	2013-09-28	2013-09-28 00:00:00	\N	38000177		0	0	0		0	0	0	81991	0	996740	40222846		
93451	2051	40213227	2013-11-24	2013-11-24 00:00:00	2013-11-24	2013-11-24 00:00:00	2013-11-24	581452		0	0	0		0	0	0	136362	0	113	40213227		
46998	3893	1713671	1998-09-18	1998-09-18 00:00:00	1998-10-02	1998-10-02 00:00:00	1998-10-02	38000177		0	0	14		0	0	0	258868	0	562251	1713671		
28208	2332	1127433	1957-05-21	1957-05-21 00:00:00	1957-06-04	1957-06-04 00:00:00	1957-06-04	38000177		0	0	14		0	0	0	155046	0	313782	1127433		
50599	4204	1118084	1988-10-23	1988-10-23 00:00:00	1988-10-23	1988-10-23 00:00:00	\N	38000177		0	0	0		0	0	0	279111	0	00025152531	44923712		
191350	4204	40213198	2016-01-18	2016-01-18 00:00:00	2016-01-18	2016-01-18 00:00:00	2016-01-18	581452		0	0	0		0	0	0	279131	0	133	40213198		
5673	476	19006318	1972-06-21	1972-06-21 00:00:00	1972-07-05	1972-07-05 00:00:00	1972-07-05	38000177		0	0	14		0	0	0	31709	0	105078	19006318		
2579	207	19059056	1945-10-08	1945-10-08 00:00:00	1945-10-22	1945-10-22 00:00:00	1945-10-22	38000177		0	0	14		0	0	0	14108	0	243670	19059056		
30409	2521	19133873	1961-01-04	1961-01-04 00:00:00	1961-01-13	1961-01-13 00:00:00	1961-01-13	38000177		0	0	9		0	0	0	166712	0	834061	19133873		
208829	4580	40213160	1966-06-07	1966-06-07 00:00:00	1966-06-07	1966-06-07 00:00:00	1966-06-07	581452		0	0	0		0	0	0	305083	0	10	40213160		
49402	1082	40213160	1955-11-26	1955-11-26 00:00:00	1955-11-26	1955-11-26 00:00:00	1955-11-26	581452		0	0	0		0	0	0	70927	0	10	40213160		
59495	4945	1127433	2008-03-10	2008-03-10 00:00:00	2008-03-24	2008-03-24 00:00:00	2008-03-24	38000177		0	0	14		0	0	0	328682	0	313782	1127433		
13270	1113	40236824	2007-12-07	2007-12-07 00:00:00	2007-12-14	2007-12-14 00:00:00	2007-12-14	38000177		0	0	7		0	0	0	73258	0	1094107	40236824		
4319	358	1713671	1971-06-10	1971-06-10 00:00:00	1971-07-01	1971-07-01 00:00:00	1971-07-01	38000177		0	0	21		0	0	0	23851	0	562251	1713671		
171757	3776	40213227	1995-08-05	1995-08-05 00:00:00	1995-08-05	1995-08-05 00:00:00	1995-08-05	581452		0	0	0		0	0	0	250973	0	113	40213227		
44658	3697	19006318	1957-01-21	1957-01-21 00:00:00	1957-02-04	1957-02-04 00:00:00	1957-02-04	38000177		0	0	14		0	0	0	245783	0	105078	19006318		
51009	4238	1310034	1978-12-28	1978-12-28 00:00:00	1978-12-28	1978-12-28 00:00:00	1978-12-28	38000177		0	0	0		0	0	0	281383	0	834357	1310034		
62885	1376	40213160	1978-07-21	1978-07-21 00:00:00	1978-07-21	1978-07-21 00:00:00	1978-07-21	581452		0	0	0		0	0	0	91185	0	10	40213160		
13862	1158	1115171	1999-07-05	1999-07-05 00:00:00	1999-07-19	1999-07-19 00:00:00	1999-07-19	38000177		0	0	14		0	0	0	76473	0	849574	1115171		
22154	1820	42902245	2001-12-16	2001-12-16 00:00:00	2002-12-11	2002-12-11 00:00:00	2002-12-11	38000177		0	0	360		0	0	0	121760	0	1359133	42902245		
61641	5128	1127433	2009-07-26	2009-07-26 00:00:00	2009-08-02	2009-08-02 00:00:00	2009-08-02	38000177		0	0	7		0	0	0	340976	0	313782	1127433		
17642	1460	1127433	1989-07-19	1989-07-19 00:00:00	1989-08-02	1989-08-02 00:00:00	1989-08-02	38000177		0	0	14		0	0	0	97271	0	313782	1127433		
24503	2016	1115171	2011-09-06	2011-09-06 00:00:00	2011-10-06	2011-10-06 00:00:00	2011-10-06	38000177		0	0	30		0	0	0	134136	0	849574	1115171		
20672	1703	1127433	1995-09-02	1995-09-02 00:00:00	1995-09-30	1995-09-30 00:00:00	1995-09-30	38000177		0	0	28		0	0	0	113930	0	313782	1127433		
35052	2894	40231925	1991-02-24	1991-02-24 00:00:00	1991-02-24	1991-02-24 00:00:00	\N	38000177		0	0	0		0	0	0	192600	0	1049221	40231925		
52172	4340	1115171	2000-10-07	2000-10-07 00:00:00	2000-10-28	2000-10-28 00:00:00	2000-10-28	38000177		0	0	21		0	0	0	287782	0	849574	1115171		
10714	890	19133905	2015-05-25	2015-05-25 00:00:00	2015-06-04	2015-06-04 00:00:00	2015-06-04	38000177		0	0	10		0	0	0	59305	0	834102	19133905		
35188	2903	40236824	2004-11-09	2004-11-09 00:00:00	2004-11-16	2004-11-16 00:00:00	2004-11-16	38000177		0	0	7		0	0	0	193468	0	1094107	40236824		
89301	1958	40213227	1993-10-05	1993-10-05 00:00:00	1993-10-05	1993-10-05 00:00:00	1993-10-05	581452		0	0	0		0	0	0	130297	0	113	40213227		
16801	363	40213160	1964-12-15	1964-12-15 00:00:00	1964-12-15	1964-12-15 00:00:00	1964-12-15	581452		0	0	0		0	0	0	24085	0	10	40213160		
2376	190	1118084	1969-01-19	1969-01-19 00:00:00	1969-01-19	1969-01-19 00:00:00	\N	38000177		0	0	0		0	0	0	12937	0	00025152531	44923712		
30554	2534	1127433	2017-07-30	2017-07-30 00:00:00	2017-08-06	2017-08-06 00:00:00	2017-08-06	38000177		0	0	7		0	0	0	167449	0	313782	1127433		
2440	194	19133873	1986-06-18	1986-06-18 00:00:00	1986-06-25	1986-06-25 00:00:00	1986-06-25	38000177		0	0	7		0	0	0	13329	0	834061	19133873		
84602	1850	40213160	1957-03-22	1957-03-22 00:00:00	1957-03-22	1957-03-22 00:00:00	1957-03-22	581452		0	0	0		0	0	0	123759	0	10	40213160		
154045	3391	40213251	1984-05-29	1984-05-29 00:00:00	1984-05-29	1984-05-29 00:00:00	1984-05-29	581452		0	0	0		0	0	0	224892	0	21	40213251		
32451	2690	19126352	1971-06-03	1971-06-03 00:00:00	2001-08-02	2001-08-02 00:00:00	2001-08-02	38000177		0	0	11018		0	0	0	178205	0	705129	19126352		
62919	5229	1127433	2001-12-17	2001-12-17 00:00:00	2001-12-31	2001-12-31 00:00:00	2001-12-31	38000177		0	0	14		0	0	0	347925	0	313782	1127433		
32528	2697	19059056	1941-02-07	1941-02-07 00:00:00	1941-02-28	1941-02-28 00:00:00	1941-02-28	38000177		0	0	21		0	0	0	178580	0	243670	19059056		
62986	5234	19059056	1953-02-05	1953-02-05 00:00:00	1953-03-07	1953-03-07 00:00:00	1953-03-07	38000177		0	0	30		0	0	0	348227	0	243670	19059056		
238811	5242	40213160	1962-11-02	1962-11-02 00:00:00	1962-11-02	1962-11-02 00:00:00	1962-11-02	581452		0	0	0		0	0	0	348846	0	10	40213160		
18241	1511	19128065	1982-04-06	1982-04-06 00:00:00	1983-04-01	1983-04-01 00:00:00	1983-04-01	38000177		0	0	360		0	0	0	100919	0	749882	19128065		
194909	4282	40213227	1997-11-12	1997-11-12 00:00:00	1997-11-12	1997-11-12 00:00:00	1997-11-12	581452		0	0	0		0	0	0	284224	0	113	40213227		
206255	4526	40213260	2006-07-07	2006-07-07 00:00:00	2006-07-07	2006-07-07 00:00:00	2006-07-07	581452		0	0	0		0	0	0	\N	0	121	40213260		
206318	4527	40213160	1960-11-18	1960-11-18 00:00:00	1960-11-18	1960-11-18 00:00:00	1960-11-18	581452		0	0	0		0	0	0	301454	0	10	40213160		
3829	318	19059056	1956-12-14	1956-12-14 00:00:00	1957-01-04	1957-01-04 00:00:00	1957-01-04	38000177		0	0	21		0	0	0	21114	0	243670	19059056		
15518	1293	1713671	1993-06-21	1993-06-21 00:00:00	1993-06-28	1993-06-28 00:00:00	1993-06-28	38000177		0	0	7		0	0	0	85458	0	562251	1713671		
24161	1987	19059056	1945-06-03	1945-06-03 00:00:00	1945-06-17	1945-06-17 00:00:00	1945-06-17	38000177		0	0	14		0	0	0	132332	0	243670	19059056		
40254	877	40213160	1982-04-13	1982-04-13 00:00:00	1982-04-13	1982-04-13 00:00:00	1982-04-13	581452		0	0	0		0	0	0	58448	0	10	40213160		
47227	3917	1713671	1980-12-26	1980-12-26 00:00:00	1981-01-16	1981-01-16 00:00:00	1981-01-16	38000177		0	0	21		0	0	0	260445	0	562251	1713671		
149523	3289	40213296	1995-12-29	1995-12-29 00:00:00	1995-12-29	1995-12-29 00:00:00	1995-12-29	581452		0	0	0		0	0	0	218456	0	52	40213296		
7011	152	40213260	2017-10-23	2017-10-23 00:00:00	2017-10-23	2017-10-23 00:00:00	2017-10-23	581452		0	0	0		0	0	0	10237	0	121	40213260		
34066	744	40213160	1955-03-04	1955-03-04 00:00:00	1955-03-04	1955-03-04 00:00:00	1955-03-04	581452		0	0	0		0	0	0	49335	0	10	40213160		
42187	919	40213227	2005-05-30	2005-05-30 00:00:00	2005-05-30	2005-05-30 00:00:00	2005-05-30	581452		0	0	0		0	0	0	61272	0	113	40213227		
16647	359	40213227	2000-07-15	2000-07-15 00:00:00	2000-07-15	2000-07-15 00:00:00	2000-07-15	581452		0	0	0		0	0	0	23920	0	113	40213227		
12180	1022	40229134	1988-12-18	1988-12-18 00:00:00	1989-01-01	1989-01-01 00:00:00	1989-01-01	38000177		0	0	14		0	0	0	67254	0	1043400	40229134		
99172	2172	40213227	2010-02-06	2010-02-06 00:00:00	2010-02-06	2010-02-06 00:00:00	2010-02-06	581452		0	0	0		0	0	0	144675	0	113	40213227		
6808	573	1118084	1996-01-10	1996-01-10 00:00:00	1996-01-10	1996-01-10 00:00:00	\N	38000177		0	0	0		0	0	0	37944	0	00025152531	44923712		
101376	2222	40213296	2006-07-11	2006-07-11 00:00:00	2006-07-11	2006-07-11 00:00:00	2006-07-11	581452		0	0	0		0	0	0	147944	0	52	40213296		
57968	4816	1713671	2019-03-29	2019-03-29 00:00:00	2019-04-12	2019-04-12 00:00:00	2019-04-12	38000177		0	0	14		0	0	0	320384	0	562251	1713671		
18907	410	40213198	2015-01-29	2015-01-29 00:00:00	2015-01-29	2015-01-29 00:00:00	2015-01-29	581452		0	0	0		0	0	0	27245	0	133	40213198		
206627	4534	40213227	1994-11-02	1994-11-02 00:00:00	1994-11-02	1994-11-02 00:00:00	1994-11-02	581452		0	0	0		0	0	0	302017	0	113	40213227		
57080	1249	40213160	1968-05-02	1968-05-02 00:00:00	1968-05-02	1968-05-02 00:00:00	1968-05-02	581452		0	0	0		0	0	0	82311	0	10	40213160		
470	36	19133905	2006-11-22	2006-11-22 00:00:00	2006-11-30	2006-11-30 00:00:00	2006-11-30	38000177		0	0	8		0	0	0	2562	0	834102	19133905		
1279	101	1127433	1989-05-22	1989-05-22 00:00:00	1989-06-05	1989-06-05 00:00:00	1989-06-05	38000177		0	0	14		0	0	0	6908	0	313782	1127433		
14890	1246	1127433	1950-06-13	1950-06-13 00:00:00	1950-06-20	1950-06-20 00:00:00	1950-06-20	38000177		0	0	7		0	0	0	82099	0	313782	1127433		
93452	2051	40213260	2013-11-24	2013-11-24 00:00:00	2013-11-24	2013-11-24 00:00:00	2013-11-24	581452		0	0	0		0	0	0	136362	0	121	40213260		
46999	3893	1115171	1999-11-15	1999-11-15 00:00:00	1999-11-29	1999-11-29 00:00:00	1999-11-29	38000177		0	0	14		0	0	0	258836	0	849574	1115171		
28209	2332	19059056	1987-01-04	1987-01-04 00:00:00	1987-01-25	1987-01-25 00:00:00	1987-01-25	38000177		0	0	21		0	0	0	155125	0	243670	19059056		
50600	4204	19133873	1955-12-20	1955-12-20 00:00:00	1956-01-02	1956-01-02 00:00:00	1956-01-02	38000177		0	0	13		0	0	0	279068	0	834061	19133873		
202639	4448	40213160	1955-06-23	1955-06-23 00:00:00	1955-06-23	1955-06-23 00:00:00	1955-06-23	581452		0	0	0		0	0	0	295882	0	10	40213160		
5674	476	40229134	1985-07-31	1985-07-31 00:00:00	1985-08-14	1985-08-14 00:00:00	1985-08-14	38000177		0	0	14		0	0	0	31738	0	1043400	40229134		
2580	207	19006318	1945-10-08	1945-10-08 00:00:00	1945-10-22	1945-10-22 00:00:00	1945-10-22	38000177		0	0	14		0	0	0	14108	0	105078	19006318		
30411	2521	19059056	1964-04-15	1964-04-15 00:00:00	1964-05-13	1964-05-13 00:00:00	1964-05-13	38000177		0	0	28		0	0	0	166737	0	243670	19059056		
208832	4580	40213296	2007-02-06	2007-02-06 00:00:00	2007-02-06	2007-02-06 00:00:00	2007-02-06	581452		0	0	0		0	0	0	305103	0	52	40213296		
49403	1082	40213160	1956-01-28	1956-01-28 00:00:00	1956-01-28	1956-01-28 00:00:00	1956-01-28	581452		0	0	0		0	0	0	70943	0	10	40213160		
59496	4945	1713671	1964-03-14	1964-03-14 00:00:00	1964-04-04	1964-04-04 00:00:00	1964-04-04	38000177		0	0	21		0	0	0	328722	0	562251	1713671		
13271	1113	920300	2007-12-07	2007-12-07 00:00:00	2007-12-14	2007-12-14 00:00:00	2007-12-14	38000177		0	0	7		0	0	0	73258	0	311989	920300		
4320	358	1127433	1976-02-16	1976-02-16 00:00:00	1976-03-01	1976-03-01 00:00:00	1976-03-01	38000177		0	0	14		0	0	0	23794	0	313782	1127433		
171758	3776	40213306	1995-08-05	1995-08-05 00:00:00	1995-08-05	1995-08-05 00:00:00	1995-08-05	581452		0	0	0		0	0	0	250973	0	43	40213306		
44659	3697	19059056	1957-01-21	1957-01-21 00:00:00	1957-02-04	1957-02-04 00:00:00	1957-02-04	38000177		0	0	14		0	0	0	245783	0	243670	19059056		
51010	4238	40243436	1978-12-28	1978-12-28 00:00:00	1978-12-28	1978-12-28 00:00:00	1978-12-28	38000177		0	0	0		0	0	0	281383	0	1190795	40243436		
15721	1309	1367571	1994-03-21	1994-03-21 00:00:00	1994-03-21	1994-03-21 00:00:00	1994-03-21	38000177		0	0	0		0	0	0	86444	0	314659	19080464		
13863	1158	19019979	1984-03-11	1984-03-11 00:00:00	1984-03-25	1984-03-25 00:00:00	1984-03-25	38000177		0	0	14		0	0	0	76472	0	198405	19019979		
22155	1820	19075601	2004-09-14	2004-09-14 00:00:00	2004-09-14	2004-09-14 00:00:00	2004-09-14	38000177		0	0	0		0	0	0	121716	0	309362	19075601		
61642	5128	19059056	1930-04-15	1930-04-15 00:00:00	1930-04-29	1930-04-29 00:00:00	1930-04-29	38000177		0	0	14		0	0	0	340924	0	243670	19059056		
17643	1460	19128065	1995-05-27	1995-05-27 00:00:00	1996-05-21	1996-05-21 00:00:00	1996-05-21	38000177		0	0	360		0	0	0	97274	0	749882	19128065		
24504	2016	1127078	1983-09-06	1983-09-06 00:00:00	1983-09-20	1983-09-20 00:00:00	1983-09-20	38000177		0	0	14		0	0	0	134148	0	282464	1127078		
42616	929	40213227	2001-01-29	2001-01-29 00:00:00	2001-01-29	2001-01-29 00:00:00	2001-01-29	581452		0	0	0		0	0	0	61779	0	113	40213227		
35053	2894	19078461	1997-02-13	1997-02-13 00:00:00	1997-04-21	1997-04-21 00:00:00	1997-04-21	38000177		0	0	67		0	0	0	192603	0	310965	19078461		
52173	4340	19133905	1994-10-07	1994-10-07 00:00:00	1994-10-20	1994-10-20 00:00:00	1994-10-20	38000177		0	0	13		0	0	0	287762	0	834102	19133905		
10715	890	1127433	2012-09-04	2012-09-04 00:00:00	2012-09-18	2012-09-18 00:00:00	2012-09-18	38000177		0	0	14		0	0	0	59304	0	313782	1127433		
35189	2903	1127433	2011-03-11	2011-03-11 00:00:00	2011-03-25	2011-03-25 00:00:00	2011-03-25	38000177		0	0	14		0	0	0	193420	0	313782	1127433		
89302	1958	40213306	1993-10-05	1993-10-05 00:00:00	1993-10-05	1993-10-05 00:00:00	1993-10-05	581452		0	0	0		0	0	0	130297	0	43	40213306		
16807	363	40213296	2004-07-13	2004-07-13 00:00:00	2004-07-13	2004-07-13 00:00:00	2004-07-13	581452		0	0	0		0	0	0	24110	0	52	40213296		
24301	1998	1713671	1989-10-26	1989-10-26 00:00:00	1989-11-16	1989-11-16 00:00:00	1989-11-16	38000177		0	0	21		0	0	0	133016	0	562251	1713671		
30555	2534	19128022	1989-07-06	1989-07-06 00:00:00	1990-07-01	1990-07-01 00:00:00	1990-07-01	38000177		0	0	360		0	0	0	167430	0	749785	19128022		
2441	194	1127078	1981-06-13	1981-06-13 00:00:00	1981-06-27	1981-06-27 00:00:00	1981-06-27	38000177		0	0	14		0	0	0	13319	0	282464	1127078		
59976	1313	40213227	2012-02-22	2012-02-22 00:00:00	2012-02-22	2012-02-22 00:00:00	2012-02-22	581452		0	0	0		0	0	0	86907	0	113	40213227		
77301	1690	40213314	1977-03-08	1977-03-08 00:00:00	1977-03-08	1977-03-08 00:00:00	1977-03-08	581452		0	0	0		0	0	0	113216	0	49	40213314		
32452	2690	19078461	1997-04-30	1997-04-30 00:00:00	1997-05-21	1997-05-21 00:00:00	1997-05-21	38000177		0	0	21		0	0	0	178254	0	310965	19078461		
62920	5229	19078461	1989-10-06	1989-10-06 00:00:00	1989-11-05	1989-11-05 00:00:00	1989-11-05	38000177		0	0	30		0	0	0	347869	0	310965	19078461		
32529	2697	19126352	1981-05-14	1981-05-14 00:00:00	1981-05-14	1981-05-14 00:00:00	\N	38000177		0	0	0		0	0	0	178615	0	705129	19126352		
62987	5234	19059056	1960-09-26	1960-09-26 00:00:00	1960-10-10	1960-10-10 00:00:00	1960-10-10	38000177		0	0	14		0	0	0	348228	0	243670	19059056		
238812	5242	40213160	1963-01-04	1963-01-04 00:00:00	1963-01-04	1963-01-04 00:00:00	1963-01-04	581452		0	0	0		0	0	0	348832	0	10	40213160		
18242	1511	1127433	2000-09-09	2000-09-09 00:00:00	2000-10-14	2000-10-14 00:00:00	2000-10-14	38000177		0	0	35		0	0	0	100934	0	313782	1127433		
194916	4282	40213160	1966-07-13	1966-07-13 00:00:00	1966-07-13	1966-07-13 00:00:00	1966-07-13	581452		0	0	0		0	0	0	284179	0	10	40213160		
206258	4526	40213227	1996-02-23	1996-02-23 00:00:00	1996-02-23	1996-02-23 00:00:00	1996-02-23	581452		0	0	0		0	0	0	301354	0	113	40213227		
194501	4274	40213227	2012-10-19	2012-10-19 00:00:00	2012-10-19	2012-10-19 00:00:00	2012-10-19	581452		0	0	0		0	0	0	283558	0	113	40213227		
3830	318	40173590	2013-09-02	2013-09-02 00:00:00	2013-09-02	2013-09-02 00:00:00	\N	38000177		0	0	0		0	0	0	21064	0	904419	40173590		
15519	1293	1713671	1971-12-15	1971-12-15 00:00:00	1971-12-29	1971-12-29 00:00:00	1971-12-29	38000177		0	0	14		0	0	0	85540	0	562251	1713671		
24162	1987	19006318	1945-06-03	1945-06-03 00:00:00	1945-06-17	1945-06-17 00:00:00	1945-06-17	38000177		0	0	14		0	0	0	132332	0	105078	19006318		
40258	877	40213160	1978-01-10	1978-01-10 00:00:00	1978-01-10	1978-01-10 00:00:00	1978-01-10	581452		0	0	0		0	0	0	58369	0	10	40213160		
47228	3917	40171902	2014-02-27	2014-02-27 00:00:00	2014-02-27	2014-02-27 00:00:00	\N	38000177		0	0	0		0	0	0	260496	0	897718	40171902		
149535	3289	40213227	1998-01-02	1998-01-02 00:00:00	1998-01-02	1998-01-02 00:00:00	1998-01-02	581452		0	0	0		0	0	0	218494	0	113	40213227		
7018	152	40213160	1971-07-12	1971-07-12 00:00:00	1971-07-12	1971-07-12 00:00:00	1971-07-12	581452		0	0	0		0	0	0	10249	0	10	40213160		
34073	744	40213201	2019-03-22	2019-03-22 00:00:00	2019-03-22	2019-03-22 00:00:00	2019-03-22	581452		0	0	0		0	0	0	49311	0	33	40213201		
42189	919	40213160	1973-04-02	1973-04-02 00:00:00	1973-04-02	1973-04-02 00:00:00	1973-04-02	581452		0	0	0		0	0	0	61243	0	10	40213160		
27928	607	40213201	2017-03-17	2017-03-17 00:00:00	2017-03-17	2017-03-17 00:00:00	2017-03-17	581452		0	0	0		0	0	0	40305	0	33	40213201		
12417	1046	1118084	2012-10-15	2012-10-15 00:00:00	2012-10-15	2012-10-15 00:00:00	\N	38000177		0	0	0		0	0	0	68694	0	00025152531	44923712		
99176	2172	40213314	1979-03-17	1979-03-17 00:00:00	1979-03-17	1979-03-17 00:00:00	1979-03-17	581452		0	0	0		0	0	0	144706	0	49	40213314		
6809	573	1713671	2015-11-27	2015-11-27 00:00:00	2015-12-04	2015-12-04 00:00:00	2015-12-04	38000177		0	0	7		0	0	0	37975	0	562251	1713671		
50726	1112	40213160	1968-10-06	1968-10-06 00:00:00	1968-10-06	1968-10-06 00:00:00	1968-10-06	581452		0	0	0		0	0	0	73225	0	10	40213160		
57969	4816	1127078	1984-10-11	1984-10-11 00:00:00	1984-10-25	1984-10-25 00:00:00	1984-10-25	38000177		0	0	14		0	0	0	320411	0	282464	1127078		
40520	883	40213260	2011-07-14	2011-07-14 00:00:00	2011-07-14	2011-07-14 00:00:00	2011-07-14	581452		0	0	0		0	0	0	58821	0	121	40213260		
79038	1729	40213306	1999-10-13	1999-10-13 00:00:00	1999-10-13	1999-10-13 00:00:00	1999-10-13	581452		0	0	0		0	0	0	115617	0	43	40213306		
57081	1249	40213260	2018-07-19	2018-07-19 00:00:00	2018-07-19	2018-07-19 00:00:00	2018-07-19	581452		0	0	0		0	0	0	82264	0	121	40213260		
471	36	1127433	2008-06-08	2008-06-08 00:00:00	2008-06-22	2008-06-22 00:00:00	2008-06-22	38000177		0	0	14		0	0	0	2632	0	313782	1127433		
1280	101	1127433	1965-04-17	1965-04-17 00:00:00	1965-05-08	1965-05-08 00:00:00	1965-05-08	38000177		0	0	21		0	0	0	6897	0	313782	1127433		
51302	1123	40213227	2016-06-02	2016-06-02 00:00:00	2016-06-02	2016-06-02 00:00:00	2016-06-02	581452		0	0	0		0	0	0	73975	0	113	40213227		
93464	2051	40213296	2002-11-24	2002-11-24 00:00:00	2002-11-24	2002-11-24 00:00:00	2002-11-24	581452		0	0	0		0	0	0	136385	0	52	40213296		
47000	3893	1127433	1988-09-17	1988-09-17 00:00:00	1988-09-24	1988-09-24 00:00:00	1988-09-24	38000177		0	0	7		0	0	0	258880	0	313782	1127433		
28210	2332	40229134	1994-12-30	1994-12-30 00:00:00	1995-01-13	1995-01-13 00:00:00	1995-01-13	38000177		0	0	14		0	0	0	155071	0	1043400	40229134		
50601	4204	1713671	2017-02-07	2017-02-07 00:00:00	2017-02-21	2017-02-21 00:00:00	2017-02-21	38000177		0	0	14		0	0	0	279085	0	562251	1713671		
135718	2980	40213306	1993-01-17	1993-01-17 00:00:00	1993-01-17	1993-01-17 00:00:00	1993-01-17	581452		0	0	0		0	0	0	\N	0	43	40213306		
5675	476	19133873	1968-06-14	1968-06-14 00:00:00	1968-06-23	1968-06-23 00:00:00	1968-06-23	38000177		0	0	9		0	0	0	31747	0	834061	19133873		
2581	207	19059056	1941-03-19	1941-03-19 00:00:00	1941-04-02	1941-04-02 00:00:00	1941-04-02	38000177		0	0	14		0	0	0	14107	0	243670	19059056		
30412	2521	1118084	1983-12-31	1983-12-31 00:00:00	1983-12-31	1983-12-31 00:00:00	\N	38000177		0	0	0		0	0	0	166763	0	00025152531	44923712		
208836	4580	40213227	1997-07-15	1997-07-15 00:00:00	1997-07-15	1997-07-15 00:00:00	1997-07-15	581452		0	0	0		0	0	0	305133	0	113	40213227		
15839	341	40213260	2011-07-25	2011-07-25 00:00:00	2011-07-25	2011-07-25 00:00:00	2011-07-25	581452		0	0	0		0	0	0	22802	0	121	40213260		
13185	1107	19059056	1980-08-19	1980-08-19 00:00:00	1980-09-02	1980-09-02 00:00:00	1980-09-02	38000177		0	0	14		0	0	0	72856	0	243670	19059056		
13272	1113	1127078	1971-12-16	1971-12-16 00:00:00	1971-12-30	1971-12-30 00:00:00	1971-12-30	38000177		0	0	14		0	0	0	73241	0	282464	1127078		
4321	358	1124300	1976-10-02	1976-10-02 00:00:00	1976-10-02	1976-10-02 00:00:00	\N	38000177		0	0	0		0	0	0	23820	0	00781178901	45011828		
214916	4713	40213160	1970-12-18	1970-12-18 00:00:00	1970-12-18	1970-12-18 00:00:00	1970-12-18	581452		0	0	0		0	0	0	313821	0	10	40213160		
44661	3697	1713671	1981-10-23	1981-10-23 00:00:00	1981-12-11	1981-12-11 00:00:00	1981-12-11	38000177		0	0	49		0	0	0	245772	0	562251	1713671		
51011	4238	46275916	1978-12-28	1978-12-28 00:00:00	1978-12-28	1978-12-28 00:00:00	1978-12-28	38000177		0	0	0		0	0	0	281383	0	1660014	46275916		
15722	1309	1154029	1994-03-22	1994-03-22 00:00:00	1994-03-22	1994-03-22 00:00:00	1994-03-22	38000177		0	0	0		0	0	0	86444	0	4337	1154029		
13864	1159	19078461	2007-09-03	2007-09-03 00:00:00	2007-09-24	2007-09-24 00:00:00	2007-09-24	38000177		0	0	21		0	0	0	76597	0	310965	19078461		
22156	1820	40220960	2004-09-14	2004-09-14 00:00:00	2004-09-14	2004-09-14 00:00:00	2004-09-14	38000177		0	0	0		0	0	0	121716	0	1804799	40220960		
61643	5128	1124300	1965-04-23	1965-04-23 00:00:00	1965-04-23	1965-04-23 00:00:00	\N	38000177		0	0	0		0	0	0	340965	0	00781178901	45011828		
17644	1460	1115171	2017-10-21	2017-10-21 00:00:00	2017-11-11	2017-11-11 00:00:00	2017-11-11	38000177		0	0	21		0	0	0	97306	0	849574	1115171		
24505	2016	1118084	2017-03-20	2017-03-20 00:00:00	2017-03-20	2017-03-20 00:00:00	\N	38000177		0	0	0		0	0	0	134142	0	00025152531	44923712		
42618	929	40213201	1985-11-04	1985-11-04 00:00:00	1985-11-04	1985-11-04 00:00:00	1985-11-04	581452		0	0	0		0	0	0	61798	0	33	40213201		
35054	2894	19059056	1924-08-16	1924-08-16 00:00:00	1924-08-30	1924-08-30 00:00:00	1924-08-30	38000177		0	0	14		0	0	0	192652	0	243670	19059056		
52174	4340	1127078	1976-04-04	1976-04-04 00:00:00	1976-04-18	1976-04-18 00:00:00	1976-04-18	38000177		0	0	14		0	0	0	287750	0	282464	1127078		
10716	890	1127433	1982-06-25	1982-06-25 00:00:00	1982-07-25	1982-07-25 00:00:00	1982-07-25	38000177		0	0	30		0	0	0	59328	0	313782	1127433		
35190	2903	1127078	1974-09-06	1974-09-06 00:00:00	1974-09-20	1974-09-20 00:00:00	1974-09-20	38000177		0	0	14		0	0	0	193415	0	282464	1127078		
89304	1958	40213160	1971-11-02	1971-11-02 00:00:00	1971-11-02	1971-11-02 00:00:00	1971-11-02	581452		0	0	0		0	0	0	130288	0	10	40213160		
16811	363	40213160	1964-10-13	1964-10-13 00:00:00	1964-10-13	1964-10-13 00:00:00	1964-10-13	581452		0	0	0		0	0	0	24128	0	10	40213160		
24302	1998	1115171	2017-05-13	2017-05-13 00:00:00	2017-05-27	2017-05-27 00:00:00	2017-05-27	38000177		0	0	14		0	0	0	133015	0	849574	1115171		
30556	2535	1127078	1961-11-05	1961-11-05 00:00:00	1961-11-19	1961-11-19 00:00:00	1961-11-19	38000177		0	0	14		0	0	0	167557	0	282464	1127078		
2442	194	19073183	1981-06-13	1981-06-13 00:00:00	1981-06-27	1981-06-27 00:00:00	1981-06-27	38000177		0	0	14		0	0	0	13319	0	308182	19073183		
59977	1313	40213296	2012-02-22	2012-02-22 00:00:00	2012-02-22	2012-02-22 00:00:00	2012-02-22	581452		0	0	0		0	0	0	86907	0	52	40213296		
77304	1690	40213227	1996-07-03	1996-07-03 00:00:00	1996-07-03	1996-07-03 00:00:00	1996-07-03	581452		0	0	0		0	0	0	113172	0	113	40213227		
32453	2690	1545959	2001-08-02	2001-08-02 00:00:00	2001-08-02	2001-08-02 00:00:00	2001-08-02	38000177		0	0	0		0	0	0	178255	0	259255	1545959		
62921	5229	1118084	2004-04-14	2004-04-14 00:00:00	2004-04-14	2004-04-14 00:00:00	\N	38000177		0	0	0		0	0	0	347936	0	00025152531	44923712		
32530	2697	1332419	1994-06-23	1994-06-23 00:00:00	1994-06-23	1994-06-23 00:00:00	\N	38000177		0	0	0		0	0	0	178593	0	197361	1332419		
62988	5234	1118084	1979-07-14	1979-07-14 00:00:00	1979-07-14	1979-07-14 00:00:00	\N	38000177		0	0	0		0	0	0	348205	0	00025152531	44923712		
158321	3486	40213227	2001-01-12	2001-01-12 00:00:00	2001-01-12	2001-01-12 00:00:00	2001-01-12	581452		0	0	0		0	0	0	231272	0	113	40213227		
18243	1511	40162522	2012-12-15	2012-12-15 00:00:00	2012-12-15	2012-12-15 00:00:00	\N	38000177		0	0	0		0	0	0	100937	0	857005	40162522		
194918	4282	40213296	2008-04-16	2008-04-16 00:00:00	2008-04-16	2008-04-16 00:00:00	2008-04-16	581452		0	0	0		0	0	0	284190	0	52	40213296		
206259	4526	40213296	1996-02-23	1996-02-23 00:00:00	1996-02-23	1996-02-23 00:00:00	1996-02-23	581452		0	0	0		0	0	0	301354	0	52	40213296		
194518	4274	40213201	1987-01-02	1987-01-02 00:00:00	1987-01-02	1987-01-02 00:00:00	1987-01-02	581452		0	0	0		0	0	0	283668	0	33	40213201		
3831	318	40229134	1961-04-23	1961-04-23 00:00:00	1961-05-07	1961-05-07 00:00:00	1961-05-07	38000177		0	0	14		0	0	0	21055	0	1043400	40229134		
15520	1293	1127433	2014-10-24	2014-10-24 00:00:00	2014-10-31	2014-10-31 00:00:00	2014-10-31	38000177		0	0	7		0	0	0	85462	0	313782	1127433		
24163	1987	1115171	1996-10-24	1996-10-24 00:00:00	1996-11-28	1996-11-28 00:00:00	1996-11-28	38000177		0	0	35		0	0	0	132290	0	849574	1115171		
40260	877	40213251	1984-04-24	1984-04-24 00:00:00	1984-04-24	1984-04-24 00:00:00	1984-04-24	581452		0	0	0		0	0	0	58449	0	21	40213251		
47229	3917	19018935	2014-02-27	2014-02-27 00:00:00	2014-02-27	2014-02-27 00:00:00	\N	38000177		0	0	0		0	0	0	260496	0	197604	19018935		
149536	3289	40213296	1998-01-02	1998-01-02 00:00:00	1998-01-02	1998-01-02 00:00:00	1998-01-02	581452		0	0	0		0	0	0	218494	0	52	40213296		
7023	152	40213296	2008-11-10	2008-11-10 00:00:00	2008-11-10	2008-11-10 00:00:00	2008-11-10	581452		0	0	0		0	0	0	10262	0	52	40213296		
34081	744	40213227	1993-08-13	1993-08-13 00:00:00	1993-08-13	1993-08-13 00:00:00	1993-08-13	581452		0	0	0		0	0	0	49296	0	113	40213227		
42193	919	40213306	1992-08-24	1992-08-24 00:00:00	1992-08-24	1992-08-24 00:00:00	1992-08-24	581452		0	0	0		0	0	0	\N	0	43	40213306		
58047	1271	40213296	2010-08-22	2010-08-22 00:00:00	2010-08-22	2010-08-22 00:00:00	2010-08-22	581452		0	0	0		0	0	0	83838	0	52	40213296		
12418	1046	920300	2010-07-20	2010-07-20 00:00:00	2010-07-27	2010-07-27 00:00:00	2010-07-27	38000177		0	0	7		0	0	0	68705	0	311989	920300		
99177	2172	40213160	1979-03-17	1979-03-17 00:00:00	1979-03-17	1979-03-17 00:00:00	1979-03-17	581452		0	0	0		0	0	0	144706	0	10	40213160		
6810	573	1127433	1982-10-31	1982-10-31 00:00:00	1982-11-07	1982-11-07 00:00:00	1982-11-07	38000177		0	0	7		0	0	0	37971	0	313782	1127433		
50728	1112	40213160	1964-02-02	1964-02-02 00:00:00	1964-02-02	1964-02-02 00:00:00	1964-02-02	581452		0	0	0		0	0	0	73210	0	10	40213160		
57970	4816	19073183	1984-10-11	1984-10-11 00:00:00	1984-10-25	1984-10-25 00:00:00	1984-10-25	38000177		0	0	14		0	0	0	320411	0	308182	19073183		
40521	883	40213306	1983-06-23	1983-06-23 00:00:00	1983-06-23	1983-06-23 00:00:00	1983-06-23	581452		0	0	0		0	0	0	58803	0	43	40213306		
79042	1729	40213160	1982-08-18	1982-08-18 00:00:00	1982-08-18	1982-08-18 00:00:00	1982-08-18	581452		0	0	0		0	0	0	115661	0	10	40213160		
57084	1249	40213227	2009-05-14	2009-05-14 00:00:00	2009-05-14	2009-05-14 00:00:00	2009-05-14	581452		0	0	0		0	0	0	82307	0	113	40213227		
472	36	19008572	2004-09-19	2004-09-19 00:00:00	2004-10-10	2004-10-10 00:00:00	2004-10-10	38000177		0	0	21		0	0	0	2541	0	106258	19008572		
1281	101	1127433	2016-05-11	2016-05-11 00:00:00	2016-06-15	2016-06-15 00:00:00	2016-06-15	38000177		0	0	35		0	0	0	6945	0	313782	1127433		
51307	1123	40213227	1997-11-20	1997-11-20 00:00:00	1997-11-20	1997-11-20 00:00:00	1997-11-20	581452		0	0	0		0	0	0	73989	0	113	40213227		
93467	2051	40213306	1984-04-22	1984-04-22 00:00:00	1984-04-22	1984-04-22 00:00:00	1984-04-22	581452		0	0	0		0	0	0	\N	0	43	40213306		
47001	3893	19133873	1979-10-07	1979-10-07 00:00:00	1979-10-14	1979-10-14 00:00:00	1979-10-14	38000177		0	0	7		0	0	0	258879	0	834061	19133873		
28211	2333	19078461	1998-10-30	1998-10-30 00:00:00	1998-11-20	1998-11-20 00:00:00	1998-11-20	38000177		0	0	21		0	0	0	155165	0	310965	19078461		
50602	4204	19133905	2010-12-15	2010-12-15 00:00:00	2010-12-24	2010-12-24 00:00:00	2010-12-24	38000177		0	0	9		0	0	0	279083	0	834102	19133905		
135720	2980	40213227	1993-01-17	1993-01-17 00:00:00	1993-01-17	1993-01-17 00:00:00	1993-01-17	581452		0	0	0		0	0	0	\N	0	113	40213227		
5676	476	1713671	1970-04-10	1970-04-10 00:00:00	1970-05-01	1970-05-01 00:00:00	1970-05-01	38000177		0	0	21		0	0	0	31737	0	562251	1713671		
2582	207	1127433	1996-10-25	1996-10-25 00:00:00	1996-11-01	1996-11-01 00:00:00	1996-11-01	38000177		0	0	7		0	0	0	14104	0	313782	1127433		
30413	2521	920334	1986-02-24	1986-02-24 00:00:00	1986-03-03	1986-03-03 00:00:00	1986-03-03	38000177		0	0	7		0	0	0	166764	0	311995	920334		
208837	4580	40213260	2016-03-01	2016-03-01 00:00:00	2016-03-01	2016-03-01 00:00:00	2016-03-01	581452		0	0	0		0	0	0	305105	0	121	40213260		
15841	341	40213227	2011-07-25	2011-07-25 00:00:00	2011-07-25	2011-07-25 00:00:00	2011-07-25	581452		0	0	0		0	0	0	22802	0	113	40213227		
13186	1107	1127433	1930-04-03	1930-04-03 00:00:00	1930-04-10	1930-04-10 00:00:00	1930-04-10	38000177		0	0	7		0	0	0	72860	0	313782	1127433		
13273	1113	19133873	1976-05-27	1976-05-27 00:00:00	1976-06-04	1976-06-04 00:00:00	1976-06-04	38000177		0	0	8		0	0	0	73255	0	834061	19133873		
4322	358	1713671	1953-10-21	1953-10-21 00:00:00	1953-11-11	1953-11-11 00:00:00	1953-11-11	38000177		0	0	21		0	0	0	23789	0	562251	1713671		
214918	4713	40213306	1988-07-08	1988-07-08 00:00:00	1988-07-08	1988-07-08 00:00:00	1988-07-08	581452		0	0	0		0	0	0	313867	0	43	40213306		
44662	3697	40236824	1974-04-26	1974-04-26 00:00:00	1974-05-03	1974-05-03 00:00:00	1974-05-03	38000177		0	0	7		0	0	0	245770	0	1094107	40236824		
51012	4239	19133873	1953-11-01	1953-11-01 00:00:00	1953-11-14	1953-11-14 00:00:00	1953-11-14	38000177		0	0	13		0	0	0	281514	0	834061	19133873		
15723	1309	42707627	1994-03-22	1994-03-22 00:00:00	1994-03-22	1994-03-22 00:00:00	1994-03-22	38000177		0	0	0		0	0	0	86444	0	1234995	42707627		
13865	1159	1713671	1981-07-28	1981-07-28 00:00:00	1981-08-04	1981-08-04 00:00:00	1981-08-04	38000177		0	0	7		0	0	0	76569	0	562251	1713671		
22157	1820	19128022	1999-12-27	1999-12-27 00:00:00	2000-12-21	2000-12-21 00:00:00	2000-12-21	38000177		0	0	360		0	0	0	121726	0	749785	19128022		
30983	2566	1115171	2000-08-02	2000-08-02 00:00:00	2000-09-06	2000-09-06 00:00:00	2000-09-06	38000177		0	0	35		0	0	0	170035	0	849574	1115171		
17645	1460	42902245	1999-05-06	1999-05-06 00:00:00	2000-04-30	2000-04-30 00:00:00	2000-04-30	38000177		0	0	360		0	0	0	97276	0	1359133	42902245		
24506	2016	1115171	1998-05-30	1998-05-30 00:00:00	1998-07-04	1998-07-04 00:00:00	1998-07-04	38000177		0	0	35		0	0	0	134107	0	849574	1115171		
54270	1188	40213160	1980-01-12	1980-01-12 00:00:00	1980-01-12	1980-01-12 00:00:00	1980-01-12	581452		0	0	0		0	0	0	78289	0	10	40213160		
35055	2894	40229134	1986-05-08	1986-05-08 00:00:00	1986-05-22	1986-05-22 00:00:00	1986-05-22	38000177		0	0	14		0	0	0	192637	0	1043400	40229134		
20726	1709	19059056	1943-11-12	1943-11-12 00:00:00	1943-12-10	1943-12-10 00:00:00	1943-12-10	38000177		0	0	28		0	0	0	114218	0	243670	19059056		
10717	890	40162522	1982-06-25	1982-06-25 00:00:00	1982-06-25	1982-06-25 00:00:00	\N	38000177		0	0	0		0	0	0	59328	0	857005	40162522		
35191	2903	19128065	1979-09-01	1979-09-01 00:00:00	1980-08-26	1980-08-26 00:00:00	1980-08-26	38000177		0	0	360		0	0	0	193423	0	749882	19128065		
89305	1958	40213160	1972-01-04	1972-01-04 00:00:00	1972-01-04	1972-01-04 00:00:00	1972-01-04	581452		0	0	0		0	0	0	130249	0	10	40213160		
16820	363	40213160	1965-03-16	1965-03-16 00:00:00	1965-03-16	1965-03-16 00:00:00	1965-03-16	581452		0	0	0		0	0	0	24129	0	10	40213160		
24303	1998	1127433	2017-09-21	2017-09-21 00:00:00	2017-10-05	2017-10-05 00:00:00	2017-10-05	38000177		0	0	14		0	0	0	133002	0	313782	1127433		
30557	2535	1713671	1994-04-17	1994-04-17 00:00:00	1994-05-01	1994-05-01 00:00:00	1994-05-01	38000177		0	0	14		0	0	0	167551	0	562251	1713671		
2443	194	1124300	2015-01-31	2015-01-31 00:00:00	2015-01-31	2015-01-31 00:00:00	\N	38000177		0	0	0		0	0	0	13317	0	00781178901	45011828		
27193	2243	1127433	1978-12-08	1978-12-08 00:00:00	1978-12-22	1978-12-22 00:00:00	1978-12-22	38000177		0	0	14		0	0	0	149328	0	313782	1127433		
77305	1690	40213306	1996-07-03	1996-07-03 00:00:00	1996-07-03	1996-07-03 00:00:00	1996-07-03	581452		0	0	0		0	0	0	113172	0	43	40213306		
32454	2690	19133768	2001-08-02	2001-08-02 00:00:00	2001-08-02	2001-08-02 00:00:00	2001-08-02	38000177		0	0	0		0	0	0	178255	0	833036	19133768		
62922	5229	19133873	1975-01-31	1975-01-31 00:00:00	1975-02-07	1975-02-07 00:00:00	1975-02-07	38000177		0	0	7		0	0	0	347880	0	834061	19133873		
32531	2697	1539411	1991-06-06	1991-06-06 00:00:00	1991-06-06	1991-06-06 00:00:00	\N	38000177		0	0	0		0	0	0	178575	0	312961	1539411		
62989	5234	19059056	1965-09-05	1965-09-05 00:00:00	1965-09-19	1965-09-19 00:00:00	1965-09-19	38000177		0	0	14		0	0	0	348230	0	243670	19059056		
158322	3486	40213296	2001-01-12	2001-01-12 00:00:00	2001-01-12	2001-01-12 00:00:00	2001-01-12	581452		0	0	0		0	0	0	231272	0	52	40213296		
18244	1511	19078461	2012-12-15	2012-12-15 00:00:00	2013-02-13	2013-02-13 00:00:00	2013-02-13	38000177		0	0	60		0	0	0	100937	0	310965	19078461		
194920	4282	40213227	2008-04-16	2008-04-16 00:00:00	2008-04-16	2008-04-16 00:00:00	2008-04-16	581452		0	0	0		0	0	0	284190	0	113	40213227		
206262	4526	40213227	2014-12-12	2014-12-12 00:00:00	2014-12-12	2014-12-12 00:00:00	2014-12-12	581452		0	0	0		0	0	0	301360	0	113	40213227		
194524	4274	40213227	2002-08-23	2002-08-23 00:00:00	2002-08-23	2002-08-23 00:00:00	2002-08-23	581452		0	0	0		0	0	0	283586	0	113	40213227		
3840	320	19078461	1998-06-14	1998-06-14 00:00:00	1998-07-12	1998-07-12 00:00:00	1998-07-12	38000177		0	0	28		0	0	0	21238	0	310965	19078461		
15521	1293	19059056	1945-10-25	1945-10-25 00:00:00	1945-11-24	1945-11-24 00:00:00	1945-11-24	38000177		0	0	30		0	0	0	85596	0	243670	19059056		
24164	1987	1115171	2012-04-29	2012-04-29 00:00:00	2012-05-20	2012-05-20 00:00:00	2012-05-20	38000177		0	0	21		0	0	0	132292	0	849574	1115171		
40267	877	40213306	1998-03-24	1998-03-24 00:00:00	1998-03-24	1998-03-24 00:00:00	1998-03-24	581452		0	0	0		0	0	0	\N	0	43	40213306		
47230	3917	40163554	2014-02-27	2014-02-27 00:00:00	2014-02-27	2014-02-27 00:00:00	\N	38000177		0	0	0		0	0	0	260496	0	855332	40163554		
149542	3289	40213160	1956-06-01	1956-06-01 00:00:00	1956-06-01	1956-06-01 00:00:00	1956-06-01	581452		0	0	0		0	0	0	218520	0	10	40213160		
7025	152	40213227	2008-11-10	2008-11-10 00:00:00	2008-11-10	2008-11-10 00:00:00	2008-11-10	581452		0	0	0		0	0	0	10262	0	113	40213227		
34084	744	40213160	1955-09-02	1955-09-02 00:00:00	1955-09-02	1955-09-02 00:00:00	1955-09-02	581452		0	0	0		0	0	0	49368	0	10	40213160		
42194	919	40213160	1977-03-28	1977-03-28 00:00:00	1977-03-28	1977-03-28 00:00:00	1977-03-28	581452		0	0	0		0	0	0	61260	0	10	40213160		
58050	1271	40213260	2018-09-16	2018-09-16 00:00:00	2018-09-16	2018-09-16 00:00:00	2018-09-16	581452		0	0	0		0	0	0	83832	0	121	40213260		
12419	1046	40236824	2010-07-20	2010-07-20 00:00:00	2010-07-27	2010-07-27 00:00:00	2010-07-27	38000177		0	0	7		0	0	0	68705	0	1094107	40236824		
99179	2172	40213251	1984-09-22	1984-09-22 00:00:00	1984-09-22	1984-09-22 00:00:00	1984-09-22	581452		0	0	0		0	0	0	144679	0	21	40213251		
6811	573	1127433	1974-04-15	1974-04-15 00:00:00	1974-04-29	1974-04-29 00:00:00	1974-04-29	38000177		0	0	14		0	0	0	37985	0	313782	1127433		
50734	1112	40213296	2006-12-03	2006-12-03 00:00:00	2006-12-03	2006-12-03 00:00:00	2006-12-03	581452		0	0	0		0	0	0	73229	0	52	40213296		
57971	4816	40229134	1994-03-08	1994-03-08 00:00:00	1994-03-22	1994-03-22 00:00:00	1994-03-22	38000177		0	0	14		0	0	0	320438	0	1043400	40229134		
40525	883	40213296	2001-06-21	2001-06-21 00:00:00	2001-06-21	2001-06-21 00:00:00	2001-06-21	581452		0	0	0		0	0	0	58809	0	52	40213296		
79049	1729	40213296	2017-09-13	2017-09-13 00:00:00	2017-09-13	2017-09-13 00:00:00	2017-09-13	581452		0	0	0		0	0	0	115618	0	52	40213296		
57085	1249	40213296	2009-05-14	2009-05-14 00:00:00	2009-05-14	2009-05-14 00:00:00	2009-05-14	581452		0	0	0		0	0	0	82307	0	52	40213296		
473	36	19134077	2004-09-19	2004-09-19 00:00:00	2004-10-10	2004-10-10 00:00:00	2004-10-10	38000177		0	0	21		0	0	0	2541	0	835900	19134077		
1282	101	1115171	2011-05-08	2011-05-08 00:00:00	2011-08-06	2011-08-06 00:00:00	2011-08-06	38000177		0	0	90		0	0	0	6943	0	849574	1115171		
51341	1124	40213227	2007-01-21	2007-01-21 00:00:00	2007-01-21	2007-01-21 00:00:00	2007-01-21	581452		0	0	0		0	0	0	74036	0	113	40213227		
93470	2051	40213306	1985-04-07	1985-04-07 00:00:00	1985-04-07	1985-04-07 00:00:00	1985-04-07	581452		0	0	0		0	0	0	136401	0	43	40213306		
47002	3893	40229134	1994-07-07	1994-07-07 00:00:00	1994-07-21	1994-07-21 00:00:00	1994-07-21	38000177		0	0	14		0	0	0	258881	0	1043400	40229134		
28212	2333	19059056	1936-01-09	1936-01-09 00:00:00	1936-02-06	1936-02-06 00:00:00	1936-02-06	38000177		0	0	28		0	0	0	155158	0	243670	19059056		
50603	4204	19059056	1952-12-01	1952-12-01 00:00:00	1952-12-15	1952-12-15 00:00:00	1952-12-15	38000177		0	0	14		0	0	0	279133	0	243670	19059056		
135727	2980	40213227	2013-01-13	2013-01-13 00:00:00	2013-01-13	2013-01-13 00:00:00	2013-01-13	581452		0	0	0		0	0	0	198900	0	113	40213227		
5677	476	19078461	1992-06-27	1992-06-27 00:00:00	1992-08-01	1992-08-01 00:00:00	1992-08-01	38000177		0	0	35		0	0	0	31753	0	310965	19078461		
2583	207	40173590	2011-04-10	2011-04-10 00:00:00	2011-04-10	2011-04-10 00:00:00	\N	38000177		0	0	0		0	0	0	14096	0	904419	40173590		
30414	2521	19059056	1949-03-30	1949-03-30 00:00:00	1949-04-13	1949-04-13 00:00:00	1949-04-13	38000177		0	0	14		0	0	0	166747	0	243670	19059056		
208840	4580	40213160	1966-08-09	1966-08-09 00:00:00	1966-08-09	1966-08-09 00:00:00	1966-08-09	581452		0	0	0		0	0	0	305117	0	10	40213160		
15850	341	40213227	1993-06-14	1993-06-14 00:00:00	1993-06-14	1993-06-14 00:00:00	1993-06-14	581452		0	0	0		0	0	0	22800	0	113	40213227		
13187	1107	1127433	2001-10-29	2001-10-29 00:00:00	2001-11-12	2001-11-12 00:00:00	2001-11-12	38000177		0	0	14		0	0	0	72915	0	313782	1127433		
101741	2230	40213227	2005-12-22	2005-12-22 00:00:00	2005-12-22	2005-12-22 00:00:00	2005-12-22	581452		0	0	0		0	0	0	148415	0	113	40213227		
106147	2328	40213160	1955-03-07	1955-03-07 00:00:00	1955-03-07	1955-03-07 00:00:00	1955-03-07	581452		0	0	0		0	0	0	154859	0	10	40213160		
214924	4713	40213260	2016-01-08	2016-01-08 00:00:00	2016-01-08	2016-01-08 00:00:00	2016-01-08	581452		0	0	0		0	0	0	313815	0	121	40213260		
44663	3697	920300	1974-04-26	1974-04-26 00:00:00	1974-05-03	1974-05-03 00:00:00	1974-05-03	38000177		0	0	7		0	0	0	245770	0	311989	920300		
31727	2630	1127433	2014-04-24	2014-04-24 00:00:00	2014-05-29	2014-05-29 00:00:00	2014-05-29	38000177		0	0	35		0	0	0	173998	0	313782	1127433		
15724	1309	40220386	1994-03-22	1994-03-22 00:00:00	1994-03-22	1994-03-22 00:00:00	1994-03-22	38000177		0	0	0		0	0	0	86444	0	1808217	40220386		
13866	1159	19019979	1982-03-18	1982-03-18 00:00:00	1982-04-17	1982-04-17 00:00:00	1982-04-17	38000177		0	0	30		0	0	0	76596	0	198405	19019979		
22158	1820	1713671	1984-03-13	1984-03-13 00:00:00	1984-03-20	1984-03-20 00:00:00	1984-03-20	38000177		0	0	7		0	0	0	121743	0	562251	1713671		
30984	2566	19133873	1947-10-24	1947-10-24 00:00:00	1947-10-31	1947-10-31 00:00:00	1947-10-31	38000177		0	0	7		0	0	0	170007	0	834061	19133873		
17646	1460	19019979	1984-03-15	1984-03-15 00:00:00	1984-03-29	1984-03-29 00:00:00	1984-03-29	38000177		0	0	14		0	0	0	97303	0	198405	19019979		
24507	2016	1115171	2002-06-13	2002-06-13 00:00:00	2002-07-11	2002-07-11 00:00:00	2002-07-11	38000177		0	0	28		0	0	0	134134	0	849574	1115171		
54274	1188	40213314	1977-07-09	1977-07-09 00:00:00	1977-07-09	1977-07-09 00:00:00	1977-07-09	581452		0	0	0		0	0	0	78263	0	49	40213314		
35056	2894	1127433	1986-11-30	1986-11-30 00:00:00	1986-12-07	1986-12-07 00:00:00	1986-12-07	38000177		0	0	7		0	0	0	192658	0	313782	1127433		
20727	1709	19059056	1940-04-22	1940-04-22 00:00:00	1940-05-06	1940-05-06 00:00:00	1940-05-06	38000177		0	0	14		0	0	0	114260	0	243670	19059056		
10718	890	19133873	1964-10-15	1964-10-15 00:00:00	1964-10-23	1964-10-23 00:00:00	1964-10-23	38000177		0	0	8		0	0	0	59317	0	834061	19133873		
35192	2903	1713671	1979-12-26	1979-12-26 00:00:00	1980-01-09	1980-01-09 00:00:00	1980-01-09	38000177		0	0	14		0	0	0	193439	0	562251	1713671		
89310	1958	40213227	2002-10-15	2002-10-15 00:00:00	2002-10-15	2002-10-15 00:00:00	2002-10-15	581452		0	0	0		0	0	0	130240	0	113	40213227		
16824	363	40213227	2006-07-18	2006-07-18 00:00:00	2006-07-18	2006-07-18 00:00:00	2006-07-18	581452		0	0	0		0	0	0	24067	0	113	40213227		
24304	1998	1118084	2015-10-01	2015-10-01 00:00:00	2015-10-01	2015-10-01 00:00:00	\N	38000177		0	0	0		0	0	0	133000	0	00025152531	44923712		
30558	2535	19059056	1970-10-11	1970-10-11 00:00:00	1970-11-08	1970-11-08 00:00:00	1970-11-08	38000177		0	0	28		0	0	0	167519	0	243670	19059056		
2444	195	19133873	1965-12-07	1965-12-07 00:00:00	1965-12-16	1965-12-16 00:00:00	1965-12-16	38000177		0	0	9		0	0	0	13352	0	834061	19133873		
27194	2243	1127433	1980-06-11	1980-06-11 00:00:00	1980-06-25	1980-06-25 00:00:00	1980-06-25	38000177		0	0	14		0	0	0	149311	0	313782	1127433		
77309	1690	40213160	1978-09-13	1978-09-13 00:00:00	1978-09-13	1978-09-13 00:00:00	1978-09-13	581452		0	0	0		0	0	0	113217	0	10	40213160		
32455	2690	1118084	1983-12-16	1983-12-16 00:00:00	1983-12-16	1983-12-16 00:00:00	\N	38000177		0	0	0		0	0	0	178252	0	00025152531	44923712		
62923	5229	19129655	1963-11-26	1963-11-26 00:00:00	1963-12-10	1963-12-10 00:00:00	1963-12-10	38000177		0	0	14		0	0	0	347894	0	789980	19129655		
32532	2697	1127433	2001-06-15	2001-06-15 00:00:00	2001-06-22	2001-06-22 00:00:00	2001-06-22	38000177		0	0	7		0	0	0	178563	0	313782	1127433		
62990	5234	1127433	1972-04-15	1972-04-15 00:00:00	1972-05-06	1972-05-06 00:00:00	1972-05-06	38000177		0	0	21		0	0	0	348211	0	313782	1127433		
88475	1941	40213160	1978-01-26	1978-01-26 00:00:00	1978-01-26	1978-01-26 00:00:00	1978-01-26	581452		0	0	0		0	0	0	129048	0	10	40213160		
18245	1511	40236824	2006-05-28	2006-05-28 00:00:00	2006-06-04	2006-06-04 00:00:00	2006-06-04	38000177		0	0	7		0	0	0	100923	0	1094107	40236824		
194922	4282	40213160	1971-03-17	1971-03-17 00:00:00	1971-03-17	1971-03-17 00:00:00	1971-03-17	581452		0	0	0		0	0	0	284214	0	10	40213160		
206264	4526	40213160	1955-03-25	1955-03-25 00:00:00	1955-03-25	1955-03-25 00:00:00	1955-03-25	581452		0	0	0		0	0	0	301343	0	10	40213160		
149429	3287	40213201	2010-08-16	2010-08-16 00:00:00	2010-08-16	2010-08-16 00:00:00	2010-08-16	581452		0	0	0		0	0	0	218338	0	33	40213201		
3841	320	19059056	1968-07-27	1968-07-27 00:00:00	1968-08-31	1968-08-31 00:00:00	1968-08-31	38000177		0	0	35		0	0	0	21234	0	243670	19059056		
15522	1293	1118084	1979-07-09	1979-07-09 00:00:00	1979-07-09	1979-07-09 00:00:00	\N	38000177		0	0	0		0	0	0	85522	0	00025152531	44923712		
24165	1987	19133873	1947-11-21	1947-11-21 00:00:00	1947-11-29	1947-11-29 00:00:00	1947-11-29	38000177		0	0	8		0	0	0	132316	0	834061	19133873		
40269	877	40213227	2009-06-09	2009-06-09 00:00:00	2009-06-09	2009-06-09 00:00:00	2009-06-09	581452		0	0	0		0	0	0	58407	0	113	40213227		
47231	3917	1127078	1970-05-22	1970-05-22 00:00:00	1970-06-26	1970-06-26 00:00:00	1970-06-26	38000177		0	0	35		0	0	0	260482	0	282464	1127078		
149544	3289	40213160	1956-03-30	1956-03-30 00:00:00	1956-03-30	1956-03-30 00:00:00	1956-03-30	581452		0	0	0		0	0	0	218464	0	10	40213160		
7033	152	40213160	1967-04-10	1967-04-10 00:00:00	1967-04-10	1967-04-10 00:00:00	1967-04-10	581452		0	0	0		0	0	0	10254	0	10	40213160		
34085	744	40213198	2018-03-16	2018-03-16 00:00:00	2018-03-16	2018-03-16 00:00:00	2018-03-16	581452		0	0	0		0	0	0	49301	0	133	40213198		
42196	919	40213314	1977-03-28	1977-03-28 00:00:00	1977-03-28	1977-03-28 00:00:00	1977-03-28	581452		0	0	0		0	0	0	61260	0	49	40213314		
58052	1271	40213227	2018-09-16	2018-09-16 00:00:00	2018-09-16	2018-09-16 00:00:00	2018-09-16	581452		0	0	0		0	0	0	83832	0	113	40213227		
12420	1046	40229134	1980-09-19	1980-09-19 00:00:00	1980-09-26	1980-09-26 00:00:00	1980-09-26	38000177		0	0	7		0	0	0	68674	0	1043400	40229134		
99185	2172	40213314	1979-12-15	1979-12-15 00:00:00	1979-12-15	1979-12-15 00:00:00	1979-12-15	581452		0	0	0		0	0	0	144707	0	49	40213314		
6812	573	1127433	2014-08-08	2014-08-08 00:00:00	2014-08-22	2014-08-22 00:00:00	2014-08-22	38000177		0	0	14		0	0	0	37974	0	313782	1127433		
50740	1112	40213227	1996-11-17	1996-11-17 00:00:00	1996-11-17	1996-11-17 00:00:00	1996-11-17	581452		0	0	0		0	0	0	73201	0	113	40213227		
57972	4816	1127433	1997-03-09	1997-03-09 00:00:00	1997-06-07	1997-06-07 00:00:00	1997-06-07	38000177		0	0	90		0	0	0	320433	0	313782	1127433		
40535	883	40213227	2012-07-19	2012-07-19 00:00:00	2012-07-19	2012-07-19 00:00:00	2012-07-19	581452		0	0	0		0	0	0	58769	0	113	40213227		
79051	1729	40213314	1978-11-15	1978-11-15 00:00:00	1978-11-15	1978-11-15 00:00:00	1978-11-15	581452		0	0	0		0	0	0	115631	0	49	40213314		
57087	1249	40213306	1990-03-29	1990-03-29 00:00:00	1990-03-29	1990-03-29 00:00:00	1990-03-29	581452		0	0	0		0	0	0	82287	0	43	40213306		
474	36	19129655	1963-07-20	1963-07-20 00:00:00	1963-08-03	1963-08-03 00:00:00	1963-08-03	38000177		0	0	14		0	0	0	2635	0	789980	19129655		
1283	101	1713671	2008-07-30	2008-07-30 00:00:00	2008-08-06	2008-08-06 00:00:00	2008-08-06	38000177		0	0	7		0	0	0	6855	0	562251	1713671		
51344	1124	40213201	2001-12-23	2001-12-23 00:00:00	2001-12-23	2001-12-23 00:00:00	2001-12-23	581452		0	0	0		0	0	0	74088	0	33	40213201		
704	16	40213306	1994-01-12	1994-01-12 00:00:00	1994-01-12	1994-01-12 00:00:00	1994-01-12	581452		0	0	0		0	0	0	\N	0	43	40213306		
47009	3895	1713671	1947-04-03	1947-04-03 00:00:00	1947-04-24	1947-04-24 00:00:00	1947-04-24	38000177		0	0	21		0	0	0	259086	0	562251	1713671		
28213	2333	1127433	1951-03-31	1951-03-31 00:00:00	1951-04-14	1951-04-14 00:00:00	1951-04-14	38000177		0	0	14		0	0	0	155161	0	313782	1127433		
50604	4204	19006318	1952-12-01	1952-12-01 00:00:00	1952-12-15	1952-12-15 00:00:00	1952-12-15	38000177		0	0	14		0	0	0	279133	0	105078	19006318		
135728	2980	40213296	2013-01-13	2013-01-13 00:00:00	2013-01-13	2013-01-13 00:00:00	2013-01-13	581452		0	0	0		0	0	0	198900	0	52	40213296		
5678	476	1124300	2002-07-29	2002-07-29 00:00:00	2002-07-29	2002-07-29 00:00:00	\N	38000177		0	0	0		0	0	0	31740	0	00781178901	45011828		
2584	207	1127433	2009-03-23	2009-03-23 00:00:00	2009-03-30	2009-03-30 00:00:00	2009-03-30	38000177		0	0	7		0	0	0	14149	0	313782	1127433		
30415	2521	19006318	1949-03-30	1949-03-30 00:00:00	1949-04-13	1949-04-13 00:00:00	1949-04-13	38000177		0	0	14		0	0	0	166747	0	105078	19006318		
46647	3865	19059056	1969-06-20	1969-06-20 00:00:00	1969-07-20	1969-07-20 00:00:00	1969-07-20	38000177		0	0	30		0	0	0	256555	0	243670	19059056		
15853	341	40213160	1965-06-21	1965-06-21 00:00:00	1965-06-21	1965-06-21 00:00:00	1965-06-21	581452		0	0	0		0	0	0	22791	0	10	40213160		
13188	1107	1332419	1994-02-25	1994-02-25 00:00:00	1994-02-25	1994-02-25 00:00:00	\N	38000177		0	0	0		0	0	0	72909	0	197361	1332419		
101742	2230	40213160	1973-08-23	1973-08-23 00:00:00	1973-08-23	1973-08-23 00:00:00	1973-08-23	581452		0	0	0		0	0	0	148389	0	10	40213160		
117426	2580	40213227	1992-08-17	1992-08-17 00:00:00	1992-08-17	1992-08-17 00:00:00	1992-08-17	581452		0	0	0		0	0	0	170891	0	113	40213227		
214928	4713	40213160	1966-04-15	1966-04-15 00:00:00	1966-04-15	1966-04-15 00:00:00	1966-04-15	581452		0	0	0		0	0	0	313872	0	10	40213160		
44664	3697	1127433	1988-10-12	1988-10-12 00:00:00	1988-11-02	1988-11-02 00:00:00	1988-11-02	38000177		0	0	21		0	0	0	245720	0	313782	1127433		
31728	2630	1118084	1999-07-28	1999-07-28 00:00:00	1999-07-28	1999-07-28 00:00:00	\N	38000177		0	0	0		0	0	0	174005	0	00025152531	44923712		
15725	1309	782047	1994-03-22	1994-03-22 00:00:00	1994-03-22	1994-03-22 00:00:00	1994-03-22	38000177		0	0	0		0	0	0	86444	0	542347	782047		
13867	1159	40224805	2001-06-23	2001-06-23 00:00:00	2002-06-18	2002-06-18 00:00:00	2002-06-18	38000177		0	0	360		0	0	0	76576	0	1000126	40224805		
22159	1820	40236824	2008-03-11	2008-03-11 00:00:00	2008-03-18	2008-03-18 00:00:00	2008-03-18	38000177		0	0	7		0	0	0	121705	0	1094107	40236824		
30985	2566	19059056	1958-11-13	1958-11-13 00:00:00	1958-12-11	1958-12-11 00:00:00	1958-12-11	38000177		0	0	28		0	0	0	170034	0	243670	19059056		
17647	1461	19059056	1969-07-13	1969-07-13 00:00:00	1969-07-27	1969-07-27 00:00:00	1969-07-27	38000177		0	0	14		0	0	0	97376	0	243670	19059056		
24508	2016	1127433	1998-05-11	1998-05-11 00:00:00	1998-05-25	1998-05-25 00:00:00	1998-05-25	38000177		0	0	14		0	0	0	134120	0	313782	1127433		
54277	1188	40213227	2006-04-15	2006-04-15 00:00:00	2006-04-15	2006-04-15 00:00:00	2006-04-15	581452		0	0	0		0	0	0	78301	0	113	40213227		
35057	2894	19059056	1967-07-02	1967-07-02 00:00:00	1967-07-30	1967-07-30 00:00:00	1967-07-30	38000177		0	0	28		0	0	0	192599	0	243670	19059056		
20728	1709	19078461	2017-10-25	2017-10-25 00:00:00	2017-11-22	2017-11-22 00:00:00	2017-11-22	38000177		0	0	28		0	0	0	114242	0	310965	19078461		
10719	890	40229134	1992-03-05	1992-03-05 00:00:00	1992-03-19	1992-03-19 00:00:00	1992-03-19	38000177		0	0	14		0	0	0	59324	0	1043400	40229134		
45672	3783	1127433	1974-06-22	1974-06-22 00:00:00	1974-07-06	1974-07-06 00:00:00	1974-07-06	38000177		0	0	14		0	0	0	251430	0	313782	1127433		
89315	1958	40213160	1976-07-06	1976-07-06 00:00:00	1976-07-06	1976-07-06 00:00:00	1976-07-06	581452		0	0	0		0	0	0	130251	0	10	40213160		
16825	363	40213296	2006-07-18	2006-07-18 00:00:00	2006-07-18	2006-07-18 00:00:00	2006-07-18	581452		0	0	0		0	0	0	24067	0	52	40213296		
24305	1998	1127433	2019-02-22	2019-02-22 00:00:00	2019-03-01	2019-03-01 00:00:00	2019-03-01	38000177		0	0	7		0	0	0	133030	0	313782	1127433		
62863	5223	1127433	2005-10-07	2005-10-07 00:00:00	2005-10-21	2005-10-21 00:00:00	2005-10-21	38000177		0	0	14		0	0	0	347546	0	313782	1127433		
2445	195	1127433	1977-11-23	1977-11-23 00:00:00	1977-12-28	1977-12-28 00:00:00	1977-12-28	38000177		0	0	35		0	0	0	13421	0	313782	1127433		
27195	2243	1118084	2005-09-03	2005-09-03 00:00:00	2005-09-03	2005-09-03 00:00:00	\N	38000177		0	0	0		0	0	0	149357	0	00025152531	44923712		
77310	1690	40213160	1974-03-13	1974-03-13 00:00:00	1974-03-13	1974-03-13 00:00:00	1974-03-13	581452		0	0	0		0	0	0	113213	0	10	40213160		
32456	2690	19133873	1961-11-06	1961-11-06 00:00:00	1961-11-14	1961-11-14 00:00:00	1961-11-14	38000177		0	0	8		0	0	0	178207	0	834061	19133873		
62924	5229	40229134	2000-07-16	2000-07-16 00:00:00	2000-07-23	2000-07-23 00:00:00	2000-07-23	38000177		0	0	7		0	0	0	347892	0	1043400	40229134		
32533	2697	40243436	2005-09-08	2005-09-08 00:00:00	2005-09-08	2005-09-08 00:00:00	2005-09-08	38000177		0	0	0		0	0	0	178582	0	1190795	40243436		
62991	5234	1127433	1989-07-20	1989-07-20 00:00:00	1989-09-18	1989-09-18 00:00:00	1989-09-18	38000177		0	0	60		0	0	0	348214	0	313782	1127433		
88481	1941	40213306	1995-03-30	1995-03-30 00:00:00	1995-03-30	1995-03-30 00:00:00	1995-03-30	581452		0	0	0		0	0	0	129085	0	43	40213306		
18246	1511	920300	2006-05-28	2006-05-28 00:00:00	2006-06-04	2006-06-04 00:00:00	2006-06-04	38000177		0	0	7		0	0	0	100923	0	311989	920300		
194928	4282	40213160	1966-12-14	1966-12-14 00:00:00	1966-12-14	1966-12-14 00:00:00	1966-12-14	581452		0	0	0		0	0	0	284180	0	10	40213160		
206271	4527	40213296	2000-06-30	2000-06-30 00:00:00	2000-06-30	2000-06-30 00:00:00	2000-06-30	581452		0	0	0		0	0	0	301441	0	52	40213296		
149430	3287	40213198	2010-08-16	2010-08-16 00:00:00	2010-08-16	2010-08-16 00:00:00	2010-08-16	581452		0	0	0		0	0	0	218338	0	133	40213198		
3842	320	19059056	1973-02-06	1973-02-06 00:00:00	1973-02-27	1973-02-27 00:00:00	1973-02-27	38000177		0	0	21		0	0	0	21235	0	243670	19059056		
15523	1293	40169216	1942-01-01	1942-01-01 00:00:00	1942-01-01	1942-01-01 00:00:00	\N	38000177		0	0	0		0	0	0	85477	0	895994	40169216		
24166	1987	19059056	1948-04-18	1948-04-18 00:00:00	1948-06-17	1948-06-17 00:00:00	1948-06-17	38000177		0	0	60		0	0	0	132360	0	243670	19059056		
40275	877	40213296	2019-05-14	2019-05-14 00:00:00	2019-05-14	2019-05-14 00:00:00	2019-05-14	581452		0	0	0		0	0	0	58393	0	52	40213296		
47232	3917	1713671	2008-07-09	2008-07-09 00:00:00	2008-07-30	2008-07-30 00:00:00	2008-07-30	38000177		0	0	21		0	0	0	260451	0	562251	1713671		
28705	2367	1118084	2016-04-06	2016-04-06 00:00:00	2016-04-06	2016-04-06 00:00:00	\N	38000177		0	0	0		0	0	0	157570	0	00025152531	44923712		
21609	469	40213227	2017-10-21	2017-10-21 00:00:00	2017-10-21	2017-10-21 00:00:00	2017-10-21	581452		0	0	0		0	0	0	31314	0	113	40213227		
55587	4615	1118084	1995-05-30	1995-05-30 00:00:00	1995-05-30	1995-05-30 00:00:00	\N	38000177		0	0	0		0	0	0	307438	0	00025152531	44923712		
42204	919	40213227	1995-06-26	1995-06-26 00:00:00	1995-06-26	1995-06-26 00:00:00	1995-06-26	581452		0	0	0		0	0	0	61278	0	113	40213227		
58058	1271	40213160	1967-04-16	1967-04-16 00:00:00	1967-04-16	1967-04-16 00:00:00	1967-04-16	581452		0	0	0		0	0	0	83845	0	10	40213160		
12421	1046	1115171	1996-03-29	1996-03-29 00:00:00	1996-04-26	1996-04-26 00:00:00	1996-04-26	38000177		0	0	28		0	0	0	68700	0	849574	1115171		
81637	1783	40213227	2011-04-18	2011-04-18 00:00:00	2011-04-18	2011-04-18 00:00:00	2011-04-18	581452		0	0	0		0	0	0	119401	0	113	40213227		
6813	573	19078461	1988-08-13	1988-08-13 00:00:00	1988-08-27	1988-08-27 00:00:00	1988-08-27	38000177		0	0	14		0	0	0	37986	0	310965	19078461		
50746	1112	40213160	1964-04-05	1964-04-05 00:00:00	1964-04-05	1964-04-05 00:00:00	1964-04-05	581452		0	0	0		0	0	0	73189	0	10	40213160		
57973	4816	40165015	1999-03-29	1999-03-29 00:00:00	1999-03-29	1999-03-29 00:00:00	\N	38000177		0	0	0		0	0	0	320434	0	861467	40165015		
40536	883	40213260	2012-07-19	2012-07-19 00:00:00	2012-07-19	2012-07-19 00:00:00	2012-07-19	581452		0	0	0		0	0	0	58769	0	121	40213260		
79056	1729	40213314	1977-12-14	1977-12-14 00:00:00	1977-12-14	1977-12-14 00:00:00	1977-12-14	581452		0	0	0		0	0	0	115646	0	49	40213314		
57094	1250	40213201	2019-06-24	2019-06-24 00:00:00	2019-06-24	2019-06-24 00:00:00	2019-06-24	581452		0	0	0		0	0	0	82408	0	33	40213201		
475	36	19059056	1963-07-20	1963-07-20 00:00:00	1963-08-03	1963-08-03 00:00:00	1963-08-03	38000177		0	0	14		0	0	0	2635	0	243670	19059056		
1284	101	1127433	1978-10-27	1978-10-27 00:00:00	1979-01-02	1979-01-02 00:00:00	1979-01-02	38000177		0	0	67		0	0	0	6898	0	313782	1127433		
141539	3109	40213201	1984-09-26	1984-09-26 00:00:00	1984-09-26	1984-09-26 00:00:00	1984-09-26	581452		0	0	0		0	0	0	206719	0	33	40213201		
708	16	40213227	2013-10-23	2013-10-23 00:00:00	2013-10-23	2013-10-23 00:00:00	2013-10-23	581452		0	0	0		0	0	0	1218	0	113	40213227		
47010	3895	1127433	1958-06-26	1958-06-26 00:00:00	1958-07-10	1958-07-10 00:00:00	1958-07-10	38000177		0	0	14		0	0	0	259119	0	313782	1127433		
28214	2333	19059056	1922-12-18	1922-12-18 00:00:00	1923-01-01	1923-01-01 00:00:00	1923-01-01	38000177		0	0	14		0	0	0	155209	0	243670	19059056		
50605	4204	1127433	2006-07-17	2006-07-17 00:00:00	2006-07-31	2006-07-31 00:00:00	2006-07-31	38000177		0	0	14		0	0	0	279067	0	313782	1127433		
135731	2980	40213296	2011-12-25	2011-12-25 00:00:00	2011-12-25	2011-12-25 00:00:00	2011-12-25	581452		0	0	0		0	0	0	199006	0	52	40213296		
5679	476	1127433	2002-02-11	2002-02-11 00:00:00	2002-02-25	2002-02-25 00:00:00	2002-02-25	38000177		0	0	14		0	0	0	31740	0	313782	1127433		
2585	207	19078461	2009-07-25	2009-07-25 00:00:00	2009-09-23	2009-09-23 00:00:00	2009-09-23	38000177		0	0	60		0	0	0	14132	0	310965	19078461		
30416	2521	920300	1989-04-05	1989-04-05 00:00:00	1989-04-12	1989-04-12 00:00:00	1989-04-12	38000177		0	0	7		0	0	0	166765	0	311989	920300		
46648	3865	40229134	1985-12-10	1985-12-10 00:00:00	1985-12-24	1985-12-24 00:00:00	1985-12-24	38000177		0	0	14		0	0	0	256582	0	1043400	40229134		
15856	341	40213296	2001-06-25	2001-06-25 00:00:00	2001-06-25	2001-06-25 00:00:00	2001-06-25	581452		0	0	0		0	0	0	22801	0	52	40213296		
13189	1107	19126352	1964-01-24	1964-01-24 00:00:00	2007-06-15	2007-06-15 00:00:00	2007-06-15	38000177		0	0	15848		0	0	0	72899	0	705129	19126352		
101749	2231	40213160	1971-01-16	1971-01-16 00:00:00	1971-01-16	1971-01-16 00:00:00	1971-01-16	581452		0	0	0		0	0	0	148422	0	10	40213160		
117432	2580	40213227	2009-06-15	2009-06-15 00:00:00	2009-06-15	2009-06-15 00:00:00	2009-06-15	581452		0	0	0		0	0	0	170894	0	113	40213227		
238201	5229	40213160	1962-03-14	1962-03-14 00:00:00	1962-03-14	1962-03-14 00:00:00	1962-03-14	581452		0	0	0		0	0	0	347913	0	10	40213160		
44666	3697	1127433	2002-08-21	2002-08-21 00:00:00	2002-10-20	2002-10-20 00:00:00	2002-10-20	38000177		0	0	60		0	0	0	245774	0	313782	1127433		
31729	2630	1713671	2006-10-29	2006-10-29 00:00:00	2006-11-05	2006-11-05 00:00:00	2006-11-05	38000177		0	0	7		0	0	0	174012	0	562251	1713671		
15726	1309	19078924	1994-03-22	1994-03-22 00:00:00	1994-03-22	1994-03-22 00:00:00	1994-03-22	38000177		0	0	0		0	0	0	86444	0	311700	19078924		
13868	1159	1713671	2001-11-28	2001-11-28 00:00:00	2001-12-12	2001-12-12 00:00:00	2001-12-12	38000177		0	0	14		0	0	0	76574	0	562251	1713671		
22160	1820	920300	2008-03-11	2008-03-11 00:00:00	2008-03-18	2008-03-18 00:00:00	2008-03-18	38000177		0	0	7		0	0	0	121705	0	311989	920300		
30986	2566	19133873	1943-09-05	1943-09-05 00:00:00	1943-09-14	1943-09-14 00:00:00	1943-09-14	38000177		0	0	9		0	0	0	170006	0	834061	19133873		
17648	1461	46233988	1969-07-13	1969-07-13 00:00:00	1969-07-27	1969-07-27 00:00:00	1969-07-27	38000177		0	0	14		0	0	0	97376	0	1652673	46233988		
24509	2016	1115171	2003-05-07	2003-05-07 00:00:00	2003-05-21	2003-05-21 00:00:00	2003-05-21	38000177		0	0	14		0	0	0	134135	0	849574	1115171		
65165	1426	40213227	2013-05-14	2013-05-14 00:00:00	2013-05-14	2013-05-14 00:00:00	2013-05-14	581452		0	0	0		0	0	0	94839	0	113	40213227		
35058	2894	19059056	1927-11-03	1927-11-03 00:00:00	1927-11-17	1927-11-17 00:00:00	1927-11-17	38000177		0	0	14		0	0	0	192661	0	243670	19059056		
20729	1709	19059056	1959-10-20	1959-10-20 00:00:00	1959-11-03	1959-11-03 00:00:00	1959-11-03	38000177		0	0	14		0	0	0	114237	0	243670	19059056		
10736	893	19078461	2012-06-25	2012-06-25 00:00:00	2012-07-09	2012-07-09 00:00:00	2012-07-09	38000177		0	0	14		0	0	0	59536	0	310965	19078461		
45673	3783	1118084	1984-04-09	1984-04-09 00:00:00	1984-04-09	1984-04-09 00:00:00	\N	38000177		0	0	0		0	0	0	251392	0	00025152531	44923712		
100601	2204	40213227	2017-07-20	2017-07-20 00:00:00	2017-07-20	2017-07-20 00:00:00	2017-07-20	581452		0	0	0		0	0	0	146958	0	113	40213227		
30080	655	40213160	1964-11-21	1964-11-21 00:00:00	1964-11-21	1964-11-21 00:00:00	1964-11-21	581452		0	0	0		0	0	0	43394	0	10	40213160		
24306	1998	1713671	2016-07-10	2016-07-10 00:00:00	2016-07-17	2016-07-17 00:00:00	2016-07-17	38000177		0	0	7		0	0	0	132992	0	562251	1713671		
62887	5228	19059056	1938-02-04	1938-02-04 00:00:00	1938-02-25	1938-02-25 00:00:00	1938-02-25	38000177		0	0	21		0	0	0	347851	0	243670	19059056		
2446	195	19078461	1997-08-15	1997-08-15 00:00:00	1997-11-13	1997-11-13 00:00:00	1997-11-13	38000177		0	0	90		0	0	0	13422	0	310965	19078461		
27196	2243	40229134	1982-07-23	1982-07-23 00:00:00	1982-08-06	1982-08-06 00:00:00	1982-08-06	38000177		0	0	14		0	0	0	149335	0	1043400	40229134		
77315	1690	40213160	1974-06-12	1974-06-12 00:00:00	1974-06-12	1974-06-12 00:00:00	1974-06-12	581452		0	0	0		0	0	0	113203	0	10	40213160		
32457	2690	1127433	1972-08-17	1972-08-17 00:00:00	1972-08-31	1972-08-31 00:00:00	1972-08-31	38000177		0	0	14		0	0	0	178240	0	313782	1127433		
62925	5229	19059056	1986-11-30	1986-11-30 00:00:00	1986-12-21	1986-12-21 00:00:00	1986-12-21	38000177		0	0	21		0	0	0	347868	0	243670	19059056		
32534	2697	46275916	2005-09-08	2005-09-08 00:00:00	2005-09-08	2005-09-08 00:00:00	2005-09-08	38000177		0	0	0		0	0	0	178582	0	1660014	46275916		
62992	5235	1118084	1960-05-29	1960-05-29 00:00:00	1960-05-29	1960-05-29 00:00:00	\N	38000177		0	0	0		0	0	0	348310	0	00025152531	44923712		
88493	1941	40213227	1995-03-23	1995-03-23 00:00:00	1995-03-23	1995-03-23 00:00:00	1995-03-23	581452		0	0	0		0	0	0	\N	0	113	40213227		
18247	1511	1127433	2007-01-28	2007-01-28 00:00:00	2007-02-04	2007-02-04 00:00:00	2007-02-04	38000177		0	0	7		0	0	0	100879	0	313782	1127433		
194931	4282	40213306	1988-11-02	1988-11-02 00:00:00	1988-11-02	1988-11-02 00:00:00	1988-11-02	581452		0	0	0		0	0	0	284221	0	43	40213306		
206274	4527	40213160	1965-03-12	1965-03-12 00:00:00	1965-03-12	1965-03-12 00:00:00	1965-03-12	581452		0	0	0		0	0	0	301434	0	10	40213160		
149441	3287	40213227	1995-11-20	1995-11-20 00:00:00	1995-11-20	1995-11-20 00:00:00	1995-11-20	581452		0	0	0		0	0	0	218307	0	113	40213227		
3843	320	1127433	1971-09-14	1971-09-14 00:00:00	1971-09-21	1971-09-21 00:00:00	1971-09-21	38000177		0	0	7		0	0	0	21229	0	313782	1127433		
15524	1293	1154615	1942-01-01	1942-01-01 00:00:00	1942-01-01	1942-01-01 00:00:00	\N	38000177		0	0	0		0	0	0	85477	0	745679	1154615		
24167	1987	19006318	1948-06-03	1948-06-03 00:00:00	1948-06-17	1948-06-17 00:00:00	1948-06-17	38000177		0	0	14		0	0	0	132333	0	105078	19006318		
51556	1128	40213160	1969-04-04	1969-04-04 00:00:00	1969-04-04	1969-04-04 00:00:00	1969-04-04	581452		0	0	0		0	0	0	74312	0	10	40213160		
47233	3917	1127078	1974-12-16	1974-12-16 00:00:00	1974-12-30	1974-12-30 00:00:00	1974-12-30	38000177		0	0	14		0	0	0	260474	0	282464	1127078		
28706	2367	1127433	1986-09-20	1986-09-20 00:00:00	1986-10-04	1986-10-04 00:00:00	1986-10-04	38000177		0	0	14		0	0	0	157550	0	313782	1127433		
21623	470	40213160	1955-04-19	1955-04-19 00:00:00	1955-04-19	1955-04-19 00:00:00	1955-04-19	581452		0	0	0		0	0	0	31423	0	10	40213160		
55588	4615	920300	1988-05-15	1988-05-15 00:00:00	1988-05-22	1988-05-22 00:00:00	1988-05-22	38000177		0	0	7		0	0	0	307422	0	311989	920300		
42205	919	40213306	1995-06-26	1995-06-26 00:00:00	1995-06-26	1995-06-26 00:00:00	1995-06-26	581452		0	0	0		0	0	0	61278	0	43	40213306		
58063	1271	40213227	2008-08-17	2008-08-17 00:00:00	2008-08-17	2008-08-17 00:00:00	2008-08-17	581452		0	0	0		0	0	0	83830	0	113	40213227		
12422	1046	1713671	1984-10-19	1984-10-19 00:00:00	1984-11-02	1984-11-02 00:00:00	1984-11-02	38000177		0	0	14		0	0	0	68675	0	562251	1713671		
81638	1783	40213260	2011-04-18	2011-04-18 00:00:00	2011-04-18	2011-04-18 00:00:00	2011-04-18	581452		0	0	0		0	0	0	119401	0	121	40213260		
6814	573	1127433	1964-03-10	1964-03-10 00:00:00	1964-03-24	1964-03-24 00:00:00	1964-03-24	38000177		0	0	14		0	0	0	37969	0	313782	1127433		
50748	1112	40213260	2013-12-22	2013-12-22 00:00:00	2013-12-22	2013-12-22 00:00:00	2013-12-22	581452		0	0	0		0	0	0	73197	0	121	40213260		
57974	4816	19073188	1999-03-29	1999-03-29 00:00:00	1999-05-03	1999-05-03 00:00:00	1999-05-03	38000177		0	0	35		0	0	0	320434	0	308192	19073188		
40550	883	40213160	1966-05-26	1966-05-26 00:00:00	1966-05-26	1966-05-26 00:00:00	1966-05-26	581452		0	0	0		0	0	0	58786	0	10	40213160		
79057	1729	40213160	1977-12-14	1977-12-14 00:00:00	1977-12-14	1977-12-14 00:00:00	1977-12-14	581452		0	0	0		0	0	0	115646	0	10	40213160		
57100	1250	40213227	2014-05-26	2014-05-26 00:00:00	2014-05-26	2014-05-26 00:00:00	2014-05-26	581452		0	0	0		0	0	0	82407	0	113	40213227		
476	36	1127433	1974-05-20	1974-05-20 00:00:00	1974-05-27	1974-05-27 00:00:00	1974-05-27	38000177		0	0	7		0	0	0	2488	0	313782	1127433		
1285	101	1127433	1973-02-28	1973-02-28 00:00:00	1973-03-07	1973-03-07 00:00:00	1973-03-07	38000177		0	0	7		0	0	0	6836	0	313782	1127433		
9074	194	40213160	1985-02-28	1985-02-28 00:00:00	1985-02-28	1985-02-28 00:00:00	1985-02-28	581452		0	0	0		0	0	0	13338	0	10	40213160		
709	16	40213296	2013-10-23	2013-10-23 00:00:00	2013-10-23	2013-10-23 00:00:00	2013-10-23	581452		0	0	0		0	0	0	1218	0	52	40213296		
176294	3876	40213296	2007-05-28	2007-05-28 00:00:00	2007-05-28	2007-05-28 00:00:00	2007-05-28	581452		0	0	0		0	0	0	257537	0	52	40213296		
28215	2333	1127433	1953-09-18	1953-09-18 00:00:00	1953-09-25	1953-09-25 00:00:00	1953-09-25	38000177		0	0	7		0	0	0	155238	0	313782	1127433		
50606	4204	1115171	1994-05-16	1994-05-16 00:00:00	1994-06-20	1994-06-20 00:00:00	1994-06-20	38000177		0	0	35		0	0	0	279066	0	849574	1115171		
135734	2980	40213160	1972-08-27	1972-08-27 00:00:00	1972-08-27	1972-08-27 00:00:00	1972-08-27	581452		0	0	0		0	0	0	198996	0	10	40213160		
5680	476	1127433	1977-05-28	1977-05-28 00:00:00	1977-06-11	1977-06-11 00:00:00	1977-06-11	38000177		0	0	14		0	0	0	31735	0	313782	1127433		
2586	207	1127433	1961-08-31	1961-08-31 00:00:00	1961-10-05	1961-10-05 00:00:00	1961-10-05	38000177		0	0	35		0	0	0	14131	0	313782	1127433		
30417	2521	40236824	1989-04-05	1989-04-05 00:00:00	1989-04-12	1989-04-12 00:00:00	1989-04-12	38000177		0	0	7		0	0	0	166765	0	1094107	40236824		
46649	3865	1127078	1957-04-24	1957-04-24 00:00:00	1957-05-24	1957-05-24 00:00:00	1957-05-24	38000177		0	0	30		0	0	0	256554	0	282464	1127078		
15859	341	40213260	2010-07-19	2010-07-19 00:00:00	2010-07-19	2010-07-19 00:00:00	2010-07-19	581452		0	0	0		0	0	0	22749	0	121	40213260		
13190	1107	1118084	1964-09-30	1964-09-30 00:00:00	1964-09-30	1964-09-30 00:00:00	\N	38000177		0	0	0		0	0	0	72899	0	00025152531	44923712		
101750	2231	40213296	2010-05-15	2010-05-15 00:00:00	2010-05-15	2010-05-15 00:00:00	2010-05-15	581452		0	0	0		0	0	0	148460	0	52	40213296		
117433	2580	40213260	2009-06-15	2009-06-15 00:00:00	2009-06-15	2009-06-15 00:00:00	2009-06-15	581452		0	0	0		0	0	0	170894	0	121	40213260		
238207	5229	40213160	1962-05-16	1962-05-16 00:00:00	1962-05-16	1962-05-16 00:00:00	1962-05-16	581452		0	0	0		0	0	0	347927	0	10	40213160		
44667	3697	40165015	2002-08-21	2002-08-21 00:00:00	2002-08-21	2002-08-21 00:00:00	\N	38000177		0	0	0		0	0	0	245774	0	861467	40165015		
31730	2630	40229134	1980-04-27	1980-04-27 00:00:00	1980-05-04	1980-05-04 00:00:00	1980-05-04	38000177		0	0	7		0	0	0	173949	0	1043400	40229134		
15727	1309	19059056	1964-01-11	1964-01-11 00:00:00	1964-01-25	1964-01-25 00:00:00	1964-01-25	38000177		0	0	14		0	0	0	86448	0	243670	19059056		
13869	1159	1713671	2009-05-13	2009-05-13 00:00:00	2009-05-20	2009-05-20 00:00:00	2009-05-20	38000177		0	0	7		0	0	0	76555	0	562251	1713671		
22161	1820	40229134	2010-11-20	2010-11-20 00:00:00	2010-12-04	2010-12-04 00:00:00	2010-12-04	38000177		0	0	14		0	0	0	121747	0	1043400	40229134		
30987	2566	1118084	1978-12-03	1978-12-03 00:00:00	1978-12-03	1978-12-03 00:00:00	\N	38000177		0	0	0		0	0	0	169982	0	00025152531	44923712		
17649	1461	1127433	1994-09-30	1994-09-30 00:00:00	1994-10-21	1994-10-21 00:00:00	1994-10-21	38000177		0	0	21		0	0	0	97353	0	313782	1127433		
24510	2016	19128065	1996-11-25	1996-11-25 00:00:00	1997-11-20	1997-11-20 00:00:00	1997-11-20	38000177		0	0	360		0	0	0	134096	0	749882	19128065		
65170	1427	40213227	2017-01-11	2017-01-11 00:00:00	2017-01-11	2017-01-11 00:00:00	2017-01-11	581452		0	0	0		0	0	0	94886	0	113	40213227		
35059	2894	19078461	1998-03-17	1998-03-17 00:00:00	1998-05-23	1998-05-23 00:00:00	1998-05-23	38000177		0	0	67		0	0	0	192604	0	310965	19078461		
20730	1709	1713671	1966-08-15	1966-08-15 00:00:00	1966-08-29	1966-08-29 00:00:00	1966-08-29	38000177		0	0	14		0	0	0	114254	0	562251	1713671		
10737	893	1127078	1954-09-16	1954-09-16 00:00:00	1954-09-30	1954-09-30 00:00:00	1954-09-30	38000177		0	0	14		0	0	0	59457	0	282464	1127078		
45674	3783	40165015	2008-11-02	2008-11-02 00:00:00	2008-11-02	2008-11-02 00:00:00	\N	38000177		0	0	0		0	0	0	251384	0	861467	40165015		
100608	2204	40213201	2012-06-21	2012-06-21 00:00:00	2012-06-21	2012-06-21 00:00:00	2012-06-21	581452		0	0	0		0	0	0	146910	0	33	40213201		
30085	655	40213160	1960-05-21	1960-05-21 00:00:00	1960-05-21	1960-05-21 00:00:00	1960-05-21	581452		0	0	0		0	0	0	43391	0	10	40213160		
24307	1998	1713671	1998-08-07	1998-08-07 00:00:00	1998-08-28	1998-08-28 00:00:00	1998-08-28	38000177		0	0	21		0	0	0	133034	0	562251	1713671		
62888	5228	19059056	1939-01-21	1939-01-21 00:00:00	1939-02-11	1939-02-11 00:00:00	1939-02-11	38000177		0	0	21		0	0	0	347852	0	243670	19059056		
2447	195	1127078	1961-09-27	1961-09-27 00:00:00	1961-10-11	1961-10-11 00:00:00	1961-10-11	38000177		0	0	14		0	0	0	13377	0	282464	1127078		
27197	2243	1127433	1984-12-29	1984-12-29 00:00:00	1985-01-05	1985-01-05 00:00:00	1985-01-05	38000177		0	0	7		0	0	0	149336	0	313782	1127433		
77316	1690	40213296	2014-10-22	2014-10-22 00:00:00	2014-10-22	2014-10-22 00:00:00	2014-10-22	581452		0	0	0		0	0	0	113187	0	52	40213296		
32458	2690	19133905	1992-01-24	1992-01-24 00:00:00	1992-02-06	1992-02-06 00:00:00	1992-02-06	38000177		0	0	13		0	0	0	178241	0	834102	19133905		
62926	5229	19059056	1973-06-27	1973-06-27 00:00:00	1973-07-11	1973-07-11 00:00:00	1973-07-11	38000177		0	0	14		0	0	0	347866	0	243670	19059056		
32535	2697	1310034	2005-09-08	2005-09-08 00:00:00	2005-09-08	2005-09-08 00:00:00	2005-09-08	38000177		0	0	0		0	0	0	178582	0	834357	1310034		
62993	5235	1127433	1973-10-19	1973-10-19 00:00:00	1973-10-26	1973-10-26 00:00:00	1973-10-26	38000177		0	0	7		0	0	0	348355	0	313782	1127433		
88494	1941	40213306	1995-03-23	1995-03-23 00:00:00	1995-03-23	1995-03-23 00:00:00	1995-03-23	581452		0	0	0		0	0	0	\N	0	43	40213306		
18248	1511	1127433	1981-08-29	1981-08-29 00:00:00	1981-09-19	1981-09-19 00:00:00	1981-09-19	38000177		0	0	21		0	0	0	100933	0	313782	1127433		
206210	4526	40213260	2006-07-14	2006-07-14 00:00:00	2006-07-14	2006-07-14 00:00:00	2006-07-14	581452		0	0	0		0	0	0	\N	0	121	40213260		
194489	4274	40213227	1992-01-31	1992-01-31 00:00:00	1992-01-31	1992-01-31 00:00:00	1992-01-31	581452		0	0	0		0	0	0	283569	0	113	40213227		
149456	3287	40213227	2006-01-09	2006-01-09 00:00:00	2006-01-09	2006-01-09 00:00:00	2006-01-09	581452		0	0	0		0	0	0	218336	0	113	40213227		
3844	320	19059056	1961-11-03	1961-11-03 00:00:00	1961-12-01	1961-12-01 00:00:00	1961-12-01	38000177		0	0	28		0	0	0	21233	0	243670	19059056		
15525	1293	19133873	1951-01-28	1951-01-28 00:00:00	1951-02-09	1951-02-09 00:00:00	1951-02-09	38000177		0	0	12		0	0	0	85544	0	834061	19133873		
24168	1987	1713671	1951-10-07	1951-10-07 00:00:00	1951-10-21	1951-10-21 00:00:00	1951-10-21	38000177		0	0	14		0	0	0	132283	0	562251	1713671		
46181	3825	1127433	1958-02-21	1958-02-21 00:00:00	1958-02-28	1958-02-28 00:00:00	1958-02-28	38000177		0	0	7		0	0	0	254058	0	313782	1127433		
47234	3917	46233988	1974-12-16	1974-12-16 00:00:00	1974-12-30	1974-12-30 00:00:00	1974-12-30	38000177		0	0	14		0	0	0	260474	0	1652673	46233988		
28709	2369	40169216	1984-05-09	1984-05-09 00:00:00	2001-04-01	2001-04-01 00:00:00	2001-04-01	38000177		0	0	6171		0	0	0	157672	0	895994	40169216		
21632	470	40213227	2006-01-17	2006-01-17 00:00:00	2006-01-17	2006-01-17 00:00:00	2006-01-17	581452		0	0	0		0	0	0	31392	0	113	40213227		
55589	4615	40236824	1988-05-15	1988-05-15 00:00:00	1988-05-22	1988-05-22 00:00:00	1988-05-22	38000177		0	0	7		0	0	0	307422	0	1094107	40236824		
42207	919	40213227	2015-06-15	2015-06-15 00:00:00	2015-06-15	2015-06-15 00:00:00	2015-06-15	581452		0	0	0		0	0	0	61280	0	113	40213227		
58064	1271	40213296	2008-08-17	2008-08-17 00:00:00	2008-08-17	2008-08-17 00:00:00	2008-08-17	581452		0	0	0		0	0	0	83830	0	52	40213296		
12423	1046	46233988	1972-08-01	1972-08-01 00:00:00	1972-08-15	1972-08-15 00:00:00	1972-08-15	38000177		0	0	14		0	0	0	68707	0	1652673	46233988		
81643	1783	40213160	1959-11-02	1959-11-02 00:00:00	1959-11-02	1959-11-02 00:00:00	1959-11-02	581452		0	0	0		0	0	0	119528	0	10	40213160		
6815	573	1127433	1992-07-07	1992-07-07 00:00:00	1992-07-14	1992-07-14 00:00:00	1992-07-14	38000177		0	0	7		0	0	0	37999	0	313782	1127433		
50763	1112	40213160	1964-07-05	1964-07-05 00:00:00	1964-07-05	1964-07-05 00:00:00	1964-07-05	581452		0	0	0		0	0	0	73211	0	10	40213160		
57975	4816	1127433	1999-03-29	1999-03-29 00:00:00	1999-05-03	1999-05-03 00:00:00	1999-05-03	38000177		0	0	35		0	0	0	320434	0	313782	1127433		
40551	883	40213227	1993-02-04	1993-02-04 00:00:00	1993-02-04	1993-02-04 00:00:00	1993-02-04	581452		0	0	0		0	0	0	58806	0	113	40213227		
79058	1729	40213314	1978-02-15	1978-02-15 00:00:00	1978-02-15	1978-02-15 00:00:00	1978-02-15	581452		0	0	0		0	0	0	115630	0	49	40213314		
49512	1084	40213227	2019-03-01	2019-03-01 00:00:00	2019-03-01	2019-03-01 00:00:00	2019-03-01	581452		0	0	0		0	0	0	\N	0	113	40213227		
717	57	19133873	1976-10-29	1976-10-29 00:00:00	1976-11-08	1976-11-08 00:00:00	1976-11-08	38000177		0	0	10		0	0	0	3823	0	834061	19133873		
1286	101	40229134	1984-09-07	1984-09-07 00:00:00	1984-09-14	1984-09-14 00:00:00	1984-09-14	38000177		0	0	7		0	0	0	6837	0	1043400	40229134		
9076	194	40213251	1985-02-28	1985-02-28 00:00:00	1985-02-28	1985-02-28 00:00:00	1985-02-28	581452		0	0	0		0	0	0	13338	0	21	40213251		
186608	4100	40213198	2010-03-24	2010-03-24 00:00:00	2010-03-24	2010-03-24 00:00:00	2010-03-24	581452		0	0	0		0	0	0	272434	0	133	40213198		
176299	3876	40213160	1972-05-01	1972-05-01 00:00:00	1972-05-01	1972-05-01 00:00:00	1972-05-01	581452		0	0	0		0	0	0	257483	0	10	40213160		
28216	2333	40236824	1962-06-17	1962-06-17 00:00:00	1962-07-01	1962-07-01 00:00:00	1962-07-01	38000177		0	0	14		0	0	0	155240	0	1094107	40236824		
119078	2619	40213227	1992-08-14	1992-08-14 00:00:00	1992-08-14	1992-08-14 00:00:00	1992-08-14	581452		0	0	0		0	0	0	173191	0	113	40213227		
198050	4352	40213198	2014-07-03	2014-07-03 00:00:00	2014-07-03	2014-07-03 00:00:00	2014-07-03	581452		0	0	0		0	0	0	288655	0	133	40213198		
38207	834	40213160	1957-03-18	1957-03-18 00:00:00	1957-03-18	1957-03-18 00:00:00	1957-03-18	581452		0	0	0		0	0	0	55197	0	10	40213160		
2587	207	1127433	1963-02-23	1963-02-23 00:00:00	1963-03-09	1963-03-09 00:00:00	1963-03-09	38000177		0	0	14		0	0	0	14112	0	313782	1127433		
30418	2521	19075601	2006-03-20	2006-03-20 00:00:00	2006-03-20	2006-03-20 00:00:00	2006-03-20	38000177		0	0	0		0	0	0	166783	0	309362	19075601		
46650	3865	19078461	1978-10-01	1978-10-01 00:00:00	1978-11-30	1978-11-30 00:00:00	1978-11-30	38000177		0	0	60		0	0	0	256556	0	310965	19078461		
15862	341	40213227	2003-06-30	2003-06-30 00:00:00	2003-06-30	2003-06-30 00:00:00	2003-06-30	581452		0	0	0		0	0	0	22797	0	113	40213227		
13191	1107	19078461	2004-12-09	2004-12-09 00:00:00	2005-03-09	2005-03-09 00:00:00	2005-03-09	38000177		0	0	90		0	0	0	72858	0	310965	19078461		
101751	2231	40213296	2012-05-19	2012-05-19 00:00:00	2012-05-19	2012-05-19 00:00:00	2012-05-19	581452		0	0	0		0	0	0	148434	0	52	40213296		
186010	4087	40213314	1978-03-29	1978-03-29 00:00:00	1978-03-29	1978-03-29 00:00:00	1978-03-29	581452		0	0	0		0	0	0	271675	0	49	40213314		
238209	5229	40213260	2011-12-07	2011-12-07 00:00:00	2011-12-07	2011-12-07 00:00:00	2011-12-07	581452		0	0	0		0	0	0	347937	0	121	40213260		
44668	3697	920334	1978-06-20	1978-06-20 00:00:00	1978-06-27	1978-06-27 00:00:00	1978-06-27	38000177		0	0	7		0	0	0	245771	0	311995	920334		
31731	2630	1127433	2007-04-26	2007-04-26 00:00:00	2007-05-31	2007-05-31 00:00:00	2007-05-31	38000177		0	0	35		0	0	0	173996	0	313782	1127433		
15729	1310	19073188	1987-09-30	1987-09-30 00:00:00	1987-10-14	1987-10-14 00:00:00	1987-10-14	38000177		0	0	14		0	0	0	86624	0	308192	19073188		
13870	1159	1118084	2014-11-30	2014-11-30 00:00:00	2014-11-30	2014-11-30 00:00:00	\N	38000177		0	0	0		0	0	0	76575	0	00025152531	44923712		
22162	1820	1127433	1989-08-25	1989-08-25 00:00:00	1989-09-08	1989-09-08 00:00:00	1989-09-08	38000177		0	0	14		0	0	0	121712	0	313782	1127433		
30988	2567	40229134	1977-11-14	1977-11-14 00:00:00	1977-11-21	1977-11-21 00:00:00	1977-11-21	38000177		0	0	7		0	0	0	170076	0	1043400	40229134		
17651	1461	19128065	1982-10-13	1982-10-13 00:00:00	1983-10-08	1983-10-08 00:00:00	1983-10-08	38000177		0	0	360		0	0	0	97350	0	749882	19128065		
24511	2017	19133873	1971-02-20	1971-02-20 00:00:00	1971-02-27	1971-02-27 00:00:00	1971-02-27	38000177		0	0	7		0	0	0	134166	0	834061	19133873		
65175	1427	40213260	2006-11-15	2006-11-15 00:00:00	2006-11-15	2006-11-15 00:00:00	2006-11-15	581452		0	0	0		0	0	0	94942	0	121	40213260		
35060	2894	1127433	1995-10-22	1995-10-22 00:00:00	1996-01-20	1996-01-20 00:00:00	1996-01-20	38000177		0	0	90		0	0	0	192602	0	313782	1127433		
20731	1709	40173590	2017-02-04	2017-02-04 00:00:00	2017-02-04	2017-02-04 00:00:00	\N	38000177		0	0	0		0	0	0	114283	0	904419	40173590		
10738	893	19006318	1954-09-16	1954-09-16 00:00:00	1954-09-30	1954-09-30 00:00:00	1954-09-30	38000177		0	0	14		0	0	0	59457	0	105078	19006318		
45675	3783	19078461	2008-11-02	2008-11-02 00:00:00	2008-12-02	2008-12-02 00:00:00	2008-12-02	38000177		0	0	30		0	0	0	251384	0	310965	19078461		
100614	2204	40213198	2011-06-16	2011-06-16 00:00:00	2011-06-16	2011-06-16 00:00:00	2011-06-16	581452		0	0	0		0	0	0	146871	0	133	40213198		
30088	655	40213227	2001-10-27	2001-10-27 00:00:00	2001-10-27	2001-10-27 00:00:00	2001-10-27	581452		0	0	0		0	0	0	43375	0	113	40213227		
24308	1998	40229134	2012-01-12	2012-01-12 00:00:00	2012-01-19	2012-01-19 00:00:00	2012-01-19	38000177		0	0	7		0	0	0	133018	0	1043400	40229134		
62889	5228	1127433	1971-03-04	1971-03-04 00:00:00	1971-03-11	1971-03-11 00:00:00	1971-03-11	38000177		0	0	7		0	0	0	347853	0	313782	1127433		
2448	195	40229134	1970-01-14	1970-01-14 00:00:00	1970-01-21	1970-01-21 00:00:00	1970-01-21	38000177		0	0	7		0	0	0	13417	0	1043400	40229134		
27198	2243	1127078	1967-01-16	1967-01-16 00:00:00	1967-01-30	1967-01-30 00:00:00	1967-01-30	38000177		0	0	14		0	0	0	149360	0	282464	1127078		
77318	1690	40213227	2014-10-22	2014-10-22 00:00:00	2014-10-22	2014-10-22 00:00:00	2014-10-22	581452		0	0	0		0	0	0	113187	0	113	40213227		
32463	2692	19078461	1996-02-17	1996-02-17 00:00:00	1996-03-09	1996-03-09 00:00:00	1996-03-09	38000177		0	0	21		0	0	0	178363	0	310965	19078461		
62927	5229	1713671	2000-06-20	2000-06-20 00:00:00	2000-07-04	2000-07-04 00:00:00	2000-07-04	38000177		0	0	14		0	0	0	347872	0	562251	1713671		
32536	2697	1127433	1994-11-17	1994-11-17 00:00:00	1994-12-22	1994-12-22 00:00:00	1994-12-22	38000177		0	0	35		0	0	0	178581	0	313782	1127433		
62994	5235	1713671	1947-02-02	1947-02-02 00:00:00	1947-02-23	1947-02-23 00:00:00	1947-02-23	38000177		0	0	21		0	0	0	348315	0	562251	1713671		
88496	1941	40213160	1973-05-24	1973-05-24 00:00:00	1973-05-24	1973-05-24 00:00:00	1973-05-24	581452		0	0	0		0	0	0	129093	0	10	40213160		
18249	1511	19129655	1968-08-07	1968-08-07 00:00:00	1968-08-21	1968-08-21 00:00:00	1968-08-21	38000177		0	0	14		0	0	0	100917	0	789980	19129655		
206220	4526	40213160	1958-09-26	1958-09-26 00:00:00	1958-09-26	1958-09-26 00:00:00	1958-09-26	581452		0	0	0		0	0	0	301384	0	10	40213160		
149413	3287	40213227	2015-09-14	2015-09-14 00:00:00	2015-09-14	2015-09-14 00:00:00	2015-09-14	581452		0	0	0		0	0	0	218317	0	113	40213227		
24769	539	40213227	1995-02-26	1995-02-26 00:00:00	1995-02-26	1995-02-26 00:00:00	1995-02-26	581452		0	0	0		0	0	0	35844	0	113	40213227		
3845	320	19133905	2008-10-09	2008-10-09 00:00:00	2008-10-22	2008-10-22 00:00:00	2008-10-22	38000177		0	0	13		0	0	0	21239	0	834102	19133905		
15526	1294	19075001	1989-04-14	1989-04-14 00:00:00	1989-04-28	1989-04-28 00:00:00	1989-04-28	38000177		0	0	14		0	0	0	85645	0	309097	19075001		
24169	1987	1124300	1981-04-25	1981-04-25 00:00:00	1981-04-25	1981-04-25 00:00:00	\N	38000177		0	0	0		0	0	0	132308	0	00781178901	45011828		
46182	3825	1713671	1996-01-10	1996-01-10 00:00:00	1996-01-24	1996-01-24 00:00:00	1996-01-24	38000177		0	0	14		0	0	0	254071	0	562251	1713671		
47235	3917	1127433	1980-12-30	1980-12-30 00:00:00	1981-01-27	1981-01-27 00:00:00	1981-01-27	38000177		0	0	28		0	0	0	260483	0	313782	1127433		
28710	2369	1154615	1984-05-09	1984-05-09 00:00:00	2001-04-01	2001-04-01 00:00:00	2001-04-01	38000177		0	0	6171		0	0	0	157672	0	745679	1154615		
21633	470	40213260	2006-01-17	2006-01-17 00:00:00	2006-01-17	2006-01-17 00:00:00	2006-01-17	581452		0	0	0		0	0	0	31392	0	121	40213260		
55590	4615	1127433	2000-09-15	2000-09-15 00:00:00	2000-09-29	2000-09-29 00:00:00	2000-09-29	38000177		0	0	14		0	0	0	307459	0	313782	1127433		
42208	919	40213296	2015-06-15	2015-06-15 00:00:00	2015-06-15	2015-06-15 00:00:00	2015-06-15	581452		0	0	0		0	0	0	61280	0	52	40213296		
58070	1271	40213260	2017-09-10	2017-09-10 00:00:00	2017-09-10	2017-09-10 00:00:00	2017-09-10	581452		0	0	0		0	0	0	83821	0	121	40213260		
12424	1046	1127078	1972-08-01	1972-08-01 00:00:00	1972-08-15	1972-08-15 00:00:00	1972-08-15	38000177		0	0	14		0	0	0	68707	0	282464	1127078		
81652	1783	40213160	1960-01-04	1960-01-04 00:00:00	1960-01-04	1960-01-04 00:00:00	1960-01-04	581452		0	0	0		0	0	0	119466	0	10	40213160		
6816	573	19078461	2013-07-17	2013-07-17 00:00:00	2013-08-14	2013-08-14 00:00:00	2013-08-14	38000177		0	0	28		0	0	0	37983	0	310965	19078461		
153331	3375	40213260	2006-03-17	2006-03-17 00:00:00	2006-03-17	2006-03-17 00:00:00	2006-03-17	581452		0	0	0		0	0	0	223908	0	121	40213260		
57976	4816	1127078	1993-04-24	1993-04-24 00:00:00	1993-05-29	1993-05-29 00:00:00	1993-05-29	38000177		0	0	35		0	0	0	320432	0	282464	1127078		
40556	883	40213227	2003-06-26	2003-06-26 00:00:00	2003-06-26	2003-06-26 00:00:00	2003-06-26	581452		0	0	0		0	0	0	58820	0	113	40213227		
79059	1729	40213160	1978-02-15	1978-02-15 00:00:00	1978-02-15	1978-02-15 00:00:00	1978-02-15	581452		0	0	0		0	0	0	115630	0	10	40213160		
49514	1084	40213296	2018-07-27	2018-07-27 00:00:00	2018-07-27	2018-07-27 00:00:00	2018-07-27	581452		0	0	0		0	0	0	71230	0	52	40213296		
718	57	1713671	2005-07-27	2005-07-27 00:00:00	2005-08-17	2005-08-17 00:00:00	2005-08-17	38000177		0	0	21		0	0	0	3847	0	562251	1713671		
1287	101	19133905	1995-03-25	1995-03-25 00:00:00	1995-04-06	1995-04-06 00:00:00	1995-04-06	38000177		0	0	12		0	0	0	6937	0	834102	19133905		
9078	194	40213314	1980-06-26	1980-06-26 00:00:00	1980-06-26	1980-06-26 00:00:00	1980-06-26	581452		0	0	0		0	0	0	13320	0	49	40213314		
186624	4100	40213201	2008-03-12	2008-03-12 00:00:00	2008-03-12	2008-03-12 00:00:00	2008-03-12	581452		0	0	0		0	0	0	272433	0	33	40213201		
176304	3876	40213260	2017-05-22	2017-05-22 00:00:00	2017-05-22	2017-05-22 00:00:00	2017-05-22	581452		0	0	0		0	0	0	257489	0	121	40213260		
28217	2333	920300	1962-06-17	1962-06-17 00:00:00	1962-06-24	1962-06-24 00:00:00	1962-06-24	38000177		0	0	7		0	0	0	155240	0	311989	920300		
29443	2437	19133873	1971-06-06	1971-06-06 00:00:00	1971-06-17	1971-06-17 00:00:00	1971-06-17	38000177		0	0	11		0	0	0	161693	0	834061	19133873		
198054	4352	40213160	1955-07-21	1955-07-21 00:00:00	1955-07-21	1955-07-21 00:00:00	1955-07-21	581452		0	0	0		0	0	0	288690	0	10	40213160		
38210	834	40213160	1961-05-15	1961-05-15 00:00:00	1961-05-15	1961-05-15 00:00:00	1961-05-15	581452		0	0	0		0	0	0	55159	0	10	40213160		
2588	207	19133905	2018-08-09	2018-08-09 00:00:00	2018-08-16	2018-08-16 00:00:00	2018-08-16	38000177		0	0	7		0	0	0	14106	0	834102	19133905		
30419	2521	40220960	2006-03-20	2006-03-20 00:00:00	2006-03-20	2006-03-20 00:00:00	2006-03-20	38000177		0	0	0		0	0	0	166783	0	1804799	40220960		
46651	3865	1127433	2009-08-06	2009-08-06 00:00:00	2009-08-13	2009-08-13 00:00:00	2009-08-13	38000177		0	0	7		0	0	0	256677	0	313782	1127433		
15863	341	40213296	2003-06-30	2003-06-30 00:00:00	2003-06-30	2003-06-30 00:00:00	2003-06-30	581452		0	0	0		0	0	0	22797	0	52	40213296		
13192	1107	40229134	1956-12-20	1956-12-20 00:00:00	1956-12-27	1956-12-27 00:00:00	1956-12-27	38000177		0	0	7		0	0	0	72928	0	1043400	40229134		
101754	2231	40213227	2012-05-19	2012-05-19 00:00:00	2012-05-19	2012-05-19 00:00:00	2012-05-19	581452		0	0	0		0	0	0	148434	0	113	40213227		
186011	4087	40213160	1978-03-29	1978-03-29 00:00:00	1978-03-29	1978-03-29 00:00:00	1978-03-29	581452		0	0	0		0	0	0	271675	0	10	40213160		
238213	5229	40213296	2003-12-31	2003-12-31 00:00:00	2003-12-31	2003-12-31 00:00:00	2003-12-31	581452		0	0	0		0	0	0	347936	0	52	40213296		
44669	3697	1118084	1993-06-06	1993-06-06 00:00:00	1993-06-06	1993-06-06 00:00:00	\N	38000177		0	0	0		0	0	0	245723	0	00025152531	44923712		
31732	2630	19073188	2007-04-26	2007-04-26 00:00:00	2007-05-31	2007-05-31 00:00:00	2007-05-31	38000177		0	0	35		0	0	0	173996	0	308192	19073188		
15730	1310	1127433	1987-09-30	1987-09-30 00:00:00	1987-10-14	1987-10-14 00:00:00	1987-10-14	38000177		0	0	14		0	0	0	86624	0	313782	1127433		
13871	1159	1127433	1986-01-27	1986-01-27 00:00:00	1986-02-10	1986-02-10 00:00:00	1986-02-10	38000177		0	0	14		0	0	0	76553	0	313782	1127433		
22163	1820	1127433	2006-12-02	2006-12-02 00:00:00	2006-12-09	2006-12-09 00:00:00	2006-12-09	38000177		0	0	7		0	0	0	121746	0	313782	1127433		
30989	2567	1127433	1978-05-01	1978-05-01 00:00:00	1978-05-08	1978-05-08 00:00:00	1978-05-08	38000177		0	0	7		0	0	0	170096	0	313782	1127433		
17652	1461	1115171	2007-11-12	2007-11-12 00:00:00	2007-12-10	2007-12-10 00:00:00	2007-12-10	38000177		0	0	28		0	0	0	97379	0	849574	1115171		
24512	2017	1127433	1983-05-01	1983-05-01 00:00:00	1983-06-05	1983-06-05 00:00:00	1983-06-05	38000177		0	0	35		0	0	0	134158	0	313782	1127433		
65177	1427	40213227	2006-11-15	2006-11-15 00:00:00	2006-11-15	2006-11-15 00:00:00	2006-11-15	581452		0	0	0		0	0	0	94942	0	113	40213227		
35061	2894	1127433	1956-07-01	1956-07-01 00:00:00	1956-07-29	1956-07-29 00:00:00	1956-07-29	38000177		0	0	28		0	0	0	192598	0	313782	1127433		
20732	1709	19059056	1939-03-22	1939-03-22 00:00:00	1939-04-05	1939-04-05 00:00:00	1939-04-05	38000177		0	0	14		0	0	0	114322	0	243670	19059056		
10739	893	19128065	1976-08-01	1976-08-01 00:00:00	1977-07-27	1977-07-27 00:00:00	1977-07-27	38000177		0	0	360		0	0	0	59498	0	749882	19128065		
45676	3783	1551192	1940-12-01	1940-12-01 00:00:00	1940-12-01	1940-12-01 00:00:00	1940-12-01	38000177		0	0	0		0	0	0	251449	0	312617	1551192		
24161	525	40213227	2010-06-07	2010-06-07 00:00:00	2010-06-07	2010-06-07 00:00:00	2010-06-07	581452		0	0	0		0	0	0	35009	0	113	40213227		
30089	655	40213296	2001-10-27	2001-10-27 00:00:00	2001-10-27	2001-10-27 00:00:00	2001-10-27	581452		0	0	0		0	0	0	43375	0	52	40213296		
24309	1999	19008572	2011-09-23	2011-09-23 00:00:00	2011-09-23	2011-09-23 00:00:00	\N	38000177		0	0	0		0	0	0	133054	0	106258	19008572		
62890	5228	19006318	1952-05-21	1952-05-21 00:00:00	1952-06-04	1952-06-04 00:00:00	1952-06-04	38000177		0	0	14		0	0	0	347797	0	105078	19006318		
2449	195	1127433	1974-04-01	1974-04-01 00:00:00	1974-04-15	1974-04-15 00:00:00	1974-04-15	38000177		0	0	14		0	0	0	13400	0	313782	1127433		
27199	2243	19059056	1968-01-25	1968-01-25 00:00:00	1968-02-08	1968-02-08 00:00:00	1968-02-08	38000177		0	0	14		0	0	0	149361	0	243670	19059056		
77321	1690	40213160	1974-01-09	1974-01-09 00:00:00	1974-01-09	1974-01-09 00:00:00	1974-01-09	581452		0	0	0		0	0	0	113202	0	10	40213160		
32464	2692	1124300	1986-01-21	1986-01-21 00:00:00	1986-01-21	1986-01-21 00:00:00	\N	38000177		0	0	0		0	0	0	178313	0	00781178901	45011828		
62928	5229	19059056	1968-07-02	1968-07-02 00:00:00	1968-07-23	1968-07-23 00:00:00	1968-07-23	38000177		0	0	21		0	0	0	347865	0	243670	19059056		
42997	3565	1127433	2019-03-10	2019-03-10 00:00:00	2019-03-24	2019-03-24 00:00:00	2019-03-24	38000177		0	0	14		0	0	0	236788	0	313782	1127433		
62995	5235	19133768	1982-01-23	1982-01-23 00:00:00	1982-01-23	1982-01-23 00:00:00	1982-01-23	38000177		0	0	0		0	0	0	348320	0	833036	19133768		
111010	2439	40213227	2015-01-14	2015-01-14 00:00:00	2015-01-14	2015-01-14 00:00:00	2015-01-14	581452		0	0	0		0	0	0	161783	0	113	40213227		
18250	1511	19059056	1968-08-07	1968-08-07 00:00:00	1968-08-21	1968-08-21 00:00:00	1968-08-21	38000177		0	0	14		0	0	0	100917	0	243670	19059056		
149334	3285	40213160	1963-10-26	1963-10-26 00:00:00	1963-10-26	1963-10-26 00:00:00	1963-10-26	581452		0	0	0		0	0	0	218225	0	10	40213160		
55543	1216	40213227	2011-01-04	2011-01-04 00:00:00	2011-01-04	2011-01-04 00:00:00	2011-01-04	581452		0	0	0		0	0	0	80085	0	113	40213227		
55583	1217	40213306	1995-06-23	1995-06-23 00:00:00	1995-06-23	1995-06-23 00:00:00	1995-06-23	581452		0	0	0		0	0	0	\N	0	43	40213306		
3846	320	19059056	1960-12-24	1960-12-24 00:00:00	1961-01-07	1961-01-07 00:00:00	1961-01-07	38000177		0	0	14		0	0	0	21232	0	243670	19059056		
15527	1294	19059056	1989-04-14	1989-04-14 00:00:00	1989-04-28	1989-04-28 00:00:00	1989-04-28	38000177		0	0	14		0	0	0	85645	0	243670	19059056		
24170	1987	19129655	1964-09-10	1964-09-10 00:00:00	1964-09-24	1964-09-24 00:00:00	1964-09-24	38000177		0	0	14		0	0	0	132359	0	789980	19129655		
46183	3825	920300	1988-07-18	1988-07-18 00:00:00	1988-07-25	1988-07-25 00:00:00	1988-07-25	38000177		0	0	7		0	0	0	254108	0	311989	920300		
47236	3917	19019273	2008-08-27	2008-08-27 00:00:00	2012-03-09	2012-03-09 00:00:00	2012-03-09	38000177		0	0	1290		0	0	0	260491	0	198014	19019273		
28711	2369	1551192	1981-12-29	1981-12-29 00:00:00	1981-12-29	1981-12-29 00:00:00	1981-12-29	38000177		0	0	0		0	0	0	157732	0	312617	1551192		
21642	470	40213260	2007-01-23	2007-01-23 00:00:00	2007-01-23	2007-01-23 00:00:00	2007-01-23	581452		0	0	0		0	0	0	31433	0	121	40213260		
55591	4615	19074841	2000-09-15	2000-09-15 00:00:00	2000-09-29	2000-09-29 00:00:00	2000-09-29	38000177		0	0	14		0	0	0	307459	0	309043	19074841		
52765	4384	19074841	1982-01-12	1982-01-12 00:00:00	1982-01-26	1982-01-26 00:00:00	1982-01-26	38000177		0	0	14		0	0	0	291408	0	309043	19074841		
58072	1271	40213306	1989-02-26	1989-02-26 00:00:00	1989-02-26	1989-02-26 00:00:00	1989-02-26	581452		0	0	0		0	0	0	83817	0	43	40213306		
12425	1046	920300	2009-06-11	2009-06-11 00:00:00	2009-06-18	2009-06-18 00:00:00	2009-06-18	38000177		0	0	7		0	0	0	68704	0	311989	920300		
98937	2166	40213306	1990-04-22	1990-04-22 00:00:00	1990-04-22	1990-04-22 00:00:00	1990-04-22	581452		0	0	0		0	0	0	144337	0	43	40213306		
6817	573	19133873	1960-03-03	1960-03-03 00:00:00	1960-03-11	1960-03-11 00:00:00	1960-03-11	38000177		0	0	8		0	0	0	37967	0	834061	19133873		
153341	3376	40213227	2014-05-30	2014-05-30 00:00:00	2014-05-30	2014-05-30 00:00:00	2014-05-30	581452		0	0	0		0	0	0	223935	0	113	40213227		
57977	4816	19019979	1983-06-02	1983-06-02 00:00:00	1983-06-16	1983-06-16 00:00:00	1983-06-16	38000177		0	0	14		0	0	0	320385	0	198405	19019979		
40557	883	40213296	2003-06-26	2003-06-26 00:00:00	2003-06-26	2003-06-26 00:00:00	2003-06-26	581452		0	0	0		0	0	0	58820	0	52	40213296		
6444	140	40213296	2011-06-16	2011-06-16 00:00:00	2011-06-16	2011-06-16 00:00:00	2011-06-16	581452		0	0	0		0	0	0	9342	0	52	40213296		
49521	1084	40213314	1978-06-16	1978-06-16 00:00:00	1978-06-16	1978-06-16 00:00:00	1978-06-16	581452		0	0	0		0	0	0	71220	0	49	40213314		
743	61	19133905	1990-05-10	1990-05-10 00:00:00	1990-05-20	1990-05-20 00:00:00	1990-05-20	38000177		0	0	10		0	0	0	4140	0	834102	19133905		
1288	101	1127433	1955-02-17	1955-02-17 00:00:00	1955-02-24	1955-02-24 00:00:00	1955-02-24	38000177		0	0	7		0	0	0	6934	0	313782	1127433		
9079	194	40213160	1980-06-26	1980-06-26 00:00:00	1980-06-26	1980-06-26 00:00:00	1980-06-26	581452		0	0	0		0	0	0	13320	0	10	40213160		
200385	4401	40213160	1969-04-12	1969-04-12 00:00:00	1969-04-12	1969-04-12 00:00:00	1969-04-12	581452		0	0	0		0	0	0	292550	0	10	40213160		
176305	3876	40213306	1991-03-04	1991-03-04 00:00:00	1991-03-04	1991-03-04 00:00:00	1991-03-04	581452		0	0	0		0	0	0	257525	0	43	40213306		
28218	2333	40229134	1941-12-17	1941-12-17 00:00:00	1941-12-31	1941-12-31 00:00:00	1941-12-31	38000177		0	0	14		0	0	0	155223	0	1043400	40229134		
29444	2437	1127078	1962-08-02	1962-08-02 00:00:00	1962-08-16	1962-08-16 00:00:00	1962-08-16	38000177		0	0	14		0	0	0	161666	0	282464	1127078		
198070	4352	40213227	2010-06-10	2010-06-10 00:00:00	2010-06-10	2010-06-10 00:00:00	2010-06-10	581452		0	0	0		0	0	0	288653	0	113	40213227		
38218	834	40213227	2018-06-18	2018-06-18 00:00:00	2018-06-18	2018-06-18 00:00:00	2018-06-18	581452		0	0	0		0	0	0	55258	0	113	40213227		
23529	510	40213160	1966-06-11	1966-06-11 00:00:00	1966-06-11	1966-06-11 00:00:00	1966-06-11	581452		0	0	0		0	0	0	34126	0	10	40213160		
30420	2521	1713671	1971-02-18	1971-02-18 00:00:00	1971-03-11	1971-03-11 00:00:00	1971-03-11	38000177		0	0	21		0	0	0	166760	0	562251	1713671		
46652	3865	19112599	1960-07-18	1960-07-18 00:00:00	1960-07-18	1960-07-18 00:00:00	\N	38000177		0	0	0		0	0	0	256576	0	477045	19112599		
15871	341	40213160	1960-10-17	1960-10-17 00:00:00	1960-10-17	1960-10-17 00:00:00	1960-10-17	581452		0	0	0		0	0	0	22788	0	10	40213160		
13193	1107	1713671	1944-10-12	1944-10-12 00:00:00	1944-11-02	1944-11-02 00:00:00	1944-11-02	38000177		0	0	21		0	0	0	72912	0	562251	1713671		
101768	2231	40213160	1975-04-19	1975-04-19 00:00:00	1975-04-19	1975-04-19 00:00:00	1975-04-19	581452		0	0	0		0	0	0	148446	0	10	40213160		
186019	4087	40213227	2000-06-21	2000-06-21 00:00:00	2000-06-21	2000-06-21 00:00:00	2000-06-21	581452		0	0	0		0	0	0	271657	0	113	40213227		
238215	5229	40213227	2003-12-31	2003-12-31 00:00:00	2003-12-31	2003-12-31 00:00:00	2003-12-31	581452		0	0	0		0	0	0	347936	0	113	40213227		
44670	3697	19059056	1955-02-01	1955-02-01 00:00:00	1955-03-10	1955-03-10 00:00:00	1955-03-10	38000177		0	0	37		0	0	0	245719	0	243670	19059056		
31733	2630	1127433	2007-09-18	2007-09-18 00:00:00	2007-09-25	2007-09-25 00:00:00	2007-09-25	38000177		0	0	7		0	0	0	173935	0	313782	1127433		
15731	1310	1127433	1968-02-03	1968-02-03 00:00:00	1968-05-03	1968-05-03 00:00:00	1968-05-03	38000177		0	0	90		0	0	0	86678	0	313782	1127433		
13872	1159	19073183	1980-09-24	1980-09-24 00:00:00	1980-10-08	1980-10-08 00:00:00	1980-10-08	38000177		0	0	14		0	0	0	76559	0	308182	19073183		
22164	1821	40162522	1967-06-01	1967-06-01 00:00:00	1967-06-01	1967-06-01 00:00:00	\N	38000177		0	0	0		0	0	0	121852	0	857005	40162522		
30990	2567	1127433	2011-10-21	2011-10-21 00:00:00	2011-11-04	2011-11-04 00:00:00	2011-11-04	38000177		0	0	14		0	0	0	170084	0	313782	1127433		
17653	1461	1124300	2008-07-28	2008-07-28 00:00:00	2008-07-28	2008-07-28 00:00:00	\N	38000177		0	0	0		0	0	0	97379	0	00781178901	45011828		
24513	2017	1713671	1974-04-11	1974-04-11 00:00:00	1974-04-25	1974-04-25 00:00:00	1974-04-25	38000177		0	0	14		0	0	0	134189	0	562251	1713671		
65188	1427	40213296	1996-08-07	1996-08-07 00:00:00	1996-08-07	1996-08-07 00:00:00	1996-08-07	581452		0	0	0		0	0	0	94903	0	52	40213296		
35062	2894	19059056	1932-07-30	1932-07-30 00:00:00	1932-10-05	1932-10-05 00:00:00	1932-10-05	38000177		0	0	67		0	0	0	192622	0	243670	19059056		
20733	1709	40229134	1970-04-25	1970-04-25 00:00:00	1970-05-02	1970-05-02 00:00:00	1970-05-02	38000177		0	0	7		0	0	0	114256	0	1043400	40229134		
10740	893	19059056	1967-01-11	1967-01-11 00:00:00	1967-02-01	1967-02-01 00:00:00	1967-02-01	38000177		0	0	21		0	0	0	59534	0	243670	19059056		
45678	3783	1127433	2006-04-01	2006-04-01 00:00:00	2006-04-08	2006-04-08 00:00:00	2006-04-08	38000177		0	0	7		0	0	0	251342	0	313782	1127433		
24165	525	40213201	2015-07-06	2015-07-06 00:00:00	2015-07-06	2015-07-06 00:00:00	2015-07-06	581452		0	0	0		0	0	0	34991	0	33	40213201		
30092	655	40213160	1960-08-20	1960-08-20 00:00:00	1960-08-20	1960-08-20 00:00:00	1960-08-20	581452		0	0	0		0	0	0	43351	0	10	40213160		
24310	1999	1115171	1996-11-12	1996-11-12 00:00:00	1996-12-17	1996-12-17 00:00:00	1996-12-17	38000177		0	0	35		0	0	0	133058	0	849574	1115171		
62891	5228	19059056	1952-05-21	1952-05-21 00:00:00	1952-06-04	1952-06-04 00:00:00	1952-06-04	38000177		0	0	14		0	0	0	347797	0	243670	19059056		
2450	195	19059056	1959-01-11	1959-01-11 00:00:00	1959-02-01	1959-02-01 00:00:00	1959-02-01	38000177		0	0	21		0	0	0	13420	0	243670	19059056		
27200	2244	19059056	1966-08-15	1966-08-15 00:00:00	1966-09-14	1966-09-14 00:00:00	1966-09-14	38000177		0	0	30		0	0	0	149381	0	243670	19059056		
77324	1690	40213314	1977-09-07	1977-09-07 00:00:00	1977-09-07	1977-09-07 00:00:00	1977-09-07	581452		0	0	0		0	0	0	113205	0	49	40213314		
32465	2692	19133873	1958-04-26	1958-04-26 00:00:00	1958-05-04	1958-05-04 00:00:00	1958-05-04	38000177		0	0	8		0	0	0	178349	0	834061	19133873		
62929	5229	1115171	2007-08-03	2007-08-03 00:00:00	2007-09-07	2007-09-07 00:00:00	2007-09-07	38000177		0	0	35		0	0	0	347911	0	849574	1115171		
42998	3565	19006318	1945-12-24	1945-12-24 00:00:00	1946-01-07	1946-01-07 00:00:00	1946-01-07	38000177		0	0	14		0	0	0	236733	0	105078	19006318		
62996	5235	19059056	1927-01-31	1927-01-31 00:00:00	1927-02-14	1927-02-14 00:00:00	1927-02-14	38000177		0	0	14		0	0	0	348328	0	243670	19059056		
111022	2439	40213296	2013-01-02	2013-01-02 00:00:00	2013-01-02	2013-01-02 00:00:00	2013-01-02	581452		0	0	0		0	0	0	\N	0	52	40213296		
18251	1511	1127433	1966-01-22	1966-01-22 00:00:00	1966-02-05	1966-02-05 00:00:00	1966-02-05	38000177		0	0	14		0	0	0	100899	0	313782	1127433		
149344	3285	40213160	1959-07-25	1959-07-25 00:00:00	1959-07-25	1959-07-25 00:00:00	1959-07-25	581452		0	0	0		0	0	0	218203	0	10	40213160		
55544	1216	40213296	2011-01-04	2011-01-04 00:00:00	2011-01-04	2011-01-04 00:00:00	2011-01-04	581452		0	0	0		0	0	0	80085	0	52	40213296		
55588	1217	40213160	1972-07-28	1972-07-28 00:00:00	1972-07-28	1972-07-28 00:00:00	1972-07-28	581452		0	0	0		0	0	0	80164	0	10	40213160		
3848	320	1127433	1984-10-10	1984-10-10 00:00:00	1984-10-17	1984-10-17 00:00:00	1984-10-17	38000177		0	0	7		0	0	0	21230	0	313782	1127433		
15528	1294	40229134	1978-09-19	1978-09-19 00:00:00	1978-10-03	1978-10-03 00:00:00	1978-10-03	38000177		0	0	14		0	0	0	85650	0	1043400	40229134		
24171	1987	19059056	1964-09-10	1964-09-10 00:00:00	1964-09-24	1964-09-24 00:00:00	1964-09-24	38000177		0	0	14		0	0	0	132359	0	243670	19059056		
46184	3825	40236824	1988-07-18	1988-07-18 00:00:00	1988-08-01	1988-08-01 00:00:00	1988-08-01	38000177		0	0	14		0	0	0	254108	0	1094107	40236824		
47237	3917	19007333	2008-08-27	2008-08-27 00:00:00	2012-03-09	2012-03-09 00:00:00	2012-03-09	38000177		0	0	1290		0	0	0	260491	0	105586	19007333		
28712	2369	40232448	1982-01-16	1982-01-16 00:00:00	1982-01-16	1982-01-16 00:00:00	\N	38000177		0	0	0		0	0	0	157671	0	1049630	40232448		
21644	470	40213160	1955-06-21	1955-06-21 00:00:00	1955-06-21	1955-06-21 00:00:00	1955-06-21	581452		0	0	0		0	0	0	31416	0	10	40213160		
55593	4615	1127433	2002-08-11	2002-08-11 00:00:00	2002-08-25	2002-08-25 00:00:00	2002-08-25	38000177		0	0	14		0	0	0	307455	0	313782	1127433		
52766	4384	1551192	1976-03-31	1976-03-31 00:00:00	1976-03-31	1976-03-31 00:00:00	1976-03-31	38000177		0	0	0		0	0	0	291363	0	312617	1551192		
58074	1271	40213227	2000-08-06	2000-08-06 00:00:00	2000-08-06	2000-08-06 00:00:00	2000-08-06	581452		0	0	0		0	0	0	83857	0	113	40213227		
12426	1046	40236824	2009-06-11	2009-06-11 00:00:00	2009-06-18	2009-06-18 00:00:00	2009-06-18	38000177		0	0	7		0	0	0	68704	0	1094107	40236824		
98939	2166	40213227	2010-05-16	2010-05-16 00:00:00	2010-05-16	2010-05-16 00:00:00	2010-05-16	581452		0	0	0		0	0	0	144282	0	113	40213227		
6818	573	1127433	1971-04-08	1971-04-08 00:00:00	1971-04-22	1971-04-22 00:00:00	1971-04-22	38000177		0	0	14		0	0	0	37954	0	313782	1127433		
153346	3376	40213160	1956-03-02	1956-03-02 00:00:00	1956-03-02	1956-03-02 00:00:00	1956-03-02	581452		0	0	0		0	0	0	224043	0	10	40213160		
57978	4816	19073183	1983-06-02	1983-06-02 00:00:00	1983-06-16	1983-06-16 00:00:00	1983-06-16	38000177		0	0	14		0	0	0	320385	0	308182	19073183		
40559	883	40213160	1961-09-21	1961-09-21 00:00:00	1961-09-21	1961-09-21 00:00:00	1961-09-21	581452		0	0	0		0	0	0	58823	0	10	40213160		
17726	384	40213296	2002-06-10	2002-06-10 00:00:00	2002-06-10	2002-06-10 00:00:00	2002-06-10	581452		0	0	0		0	0	0	25328	0	52	40213296		
49522	1084	40213160	1978-06-16	1978-06-16 00:00:00	1978-06-16	1978-06-16 00:00:00	1978-06-16	581452		0	0	0		0	0	0	71220	0	10	40213160		
744	61	40232448	1972-02-10	1972-02-10 00:00:00	1972-02-10	1972-02-10 00:00:00	\N	38000177		0	0	0		0	0	0	4095	0	1049630	40232448		
1289	101	1127433	1986-12-21	1986-12-21 00:00:00	1987-01-04	1987-01-04 00:00:00	1987-01-04	38000177		0	0	14		0	0	0	6900	0	313782	1127433		
9086	194	40213314	1981-05-28	1981-05-28 00:00:00	1981-05-28	1981-05-28 00:00:00	1981-05-28	581452		0	0	0		0	0	0	13305	0	49	40213314		
200389	4401	40213227	2002-02-02	2002-02-02 00:00:00	2002-02-02	2002-02-02 00:00:00	2002-02-02	581452		0	0	0		0	0	0	292586	0	113	40213227		
176315	3876	40213306	1988-02-22	1988-02-22 00:00:00	1988-02-22	1988-02-22 00:00:00	1988-02-22	581452		0	0	0		0	0	0	\N	0	43	40213306		
28219	2333	19059056	1940-09-12	1940-09-12 00:00:00	1940-09-26	1940-09-26 00:00:00	1940-09-26	38000177		0	0	14		0	0	0	155159	0	243670	19059056		
29445	2437	19075001	2001-11-24	2001-11-24 00:00:00	2001-12-29	2001-12-29 00:00:00	2001-12-29	38000177		0	0	35		0	0	0	161669	0	309097	19075001		
198074	4352	40213201	2015-07-09	2015-07-09 00:00:00	2015-07-09	2015-07-09 00:00:00	2015-07-09	581452		0	0	0		0	0	0	288684	0	33	40213201		
38222	834	40213260	2006-08-14	2006-08-14 00:00:00	2006-08-14	2006-08-14 00:00:00	2006-08-14	581452		0	0	0		0	0	0	55237	0	121	40213260		
23531	510	40213296	2006-08-12	2006-08-12 00:00:00	2006-08-12	2006-08-12 00:00:00	2006-08-12	581452		0	0	0		0	0	0	34092	0	52	40213296		
30421	2521	1713671	1970-09-24	1970-09-24 00:00:00	1970-10-15	1970-10-15 00:00:00	1970-10-15	38000177		0	0	21		0	0	0	166767	0	562251	1713671		
46653	3865	1118084	1990-04-06	1990-04-06 00:00:00	1990-04-06	1990-04-06 00:00:00	\N	38000177		0	0	0		0	0	0	256563	0	00025152531	44923712		
29783	2468	40229134	1939-12-03	1939-12-03 00:00:00	1939-12-10	1939-12-10 00:00:00	1939-12-10	38000177		0	0	7		0	0	0	163609	0	1043400	40229134		
13194	1107	19133768	2007-06-15	2007-06-15 00:00:00	2007-06-15	2007-06-15 00:00:00	2007-06-15	38000177		0	0	0		0	0	0	72859	0	833036	19133768		
101775	2231	40213227	2002-02-09	2002-02-09 00:00:00	2002-02-09	2002-02-09 00:00:00	2002-02-09	581452		0	0	0		0	0	0	148458	0	113	40213227		
186020	4087	40213306	2000-06-21	2000-06-21 00:00:00	2000-06-21	2000-06-21 00:00:00	2000-06-21	581452		0	0	0		0	0	0	271657	0	43	40213306		
238217	5229	40213296	2001-12-26	2001-12-26 00:00:00	2001-12-26	2001-12-26 00:00:00	2001-12-26	581452		0	0	0		0	0	0	347904	0	52	40213296		
44671	3697	1713671	1960-11-17	1960-11-17 00:00:00	1960-12-01	1960-12-01 00:00:00	1960-12-01	38000177		0	0	14		0	0	0	245800	0	562251	1713671		
31734	2630	1127433	2015-09-04	2015-09-04 00:00:00	2015-09-18	2015-09-18 00:00:00	2015-09-18	38000177		0	0	14		0	0	0	173937	0	313782	1127433		
15732	1310	1713671	1972-09-14	1972-09-14 00:00:00	1972-09-28	1972-09-28 00:00:00	1972-09-28	38000177		0	0	14		0	0	0	86570	0	562251	1713671		
13873	1159	1127078	1980-09-24	1980-09-24 00:00:00	1980-10-08	1980-10-08 00:00:00	1980-10-08	38000177		0	0	14		0	0	0	76559	0	282464	1127078		
22165	1821	1127433	1963-04-01	1963-04-01 00:00:00	1963-04-22	1963-04-22 00:00:00	1963-04-22	38000177		0	0	21		0	0	0	121772	0	313782	1127433		
30991	2567	1127078	1980-10-27	1980-10-27 00:00:00	1980-11-10	1980-11-10 00:00:00	1980-11-10	38000177		0	0	14		0	0	0	170080	0	282464	1127078		
17654	1461	19133905	2005-05-20	2005-05-20 00:00:00	2005-06-01	2005-06-01 00:00:00	2005-06-01	38000177		0	0	12		0	0	0	97327	0	834102	19133905		
24514	2017	46233988	1972-09-11	1972-09-11 00:00:00	1972-09-25	1972-09-25 00:00:00	1972-09-25	38000177		0	0	14		0	0	0	134157	0	1652673	46233988		
65194	1427	40213260	2007-11-21	2007-11-21 00:00:00	2007-11-21	2007-11-21 00:00:00	2007-11-21	581452		0	0	0		0	0	0	94917	0	121	40213260		
35063	2895	1127433	2013-06-10	2013-06-10 00:00:00	2013-06-24	2013-06-24 00:00:00	2013-06-24	38000177		0	0	14		0	0	0	192740	0	313782	1127433		
20734	1709	1127433	1951-10-27	1951-10-27 00:00:00	1951-11-26	1951-11-26 00:00:00	1951-11-26	38000177		0	0	30		0	0	0	114221	0	313782	1127433		
10742	893	40229134	2001-01-22	2001-01-22 00:00:00	2001-01-29	2001-01-29 00:00:00	2001-01-29	38000177		0	0	7		0	0	0	59477	0	1043400	40229134		
45679	3783	1127433	1969-03-21	1969-03-21 00:00:00	1969-04-04	1969-04-04 00:00:00	1969-04-04	38000177		0	0	14		0	0	0	251367	0	313782	1127433		
35444	774	40213160	1971-07-05	1971-07-05 00:00:00	1971-07-05	1971-07-05 00:00:00	1971-07-05	581452		0	0	0		0	0	0	51367	0	10	40213160		
30097	655	40213260	2011-03-12	2011-03-12 00:00:00	2011-03-12	2011-03-12 00:00:00	2011-03-12	581452		0	0	0		0	0	0	43408	0	121	40213260		
24311	1999	1127433	1991-07-12	1991-07-12 00:00:00	1991-08-11	1991-08-11 00:00:00	1991-08-11	38000177		0	0	30		0	0	0	133057	0	313782	1127433		
62892	5228	1118084	1968-12-03	1968-12-03 00:00:00	1968-12-03	1968-12-03 00:00:00	\N	38000177		0	0	0		0	0	0	347793	0	00025152531	44923712		
2451	195	1118084	1993-09-24	1993-09-24 00:00:00	1993-09-24	1993-09-24 00:00:00	\N	38000177		0	0	0		0	0	0	13374	0	00025152531	44923712		
27201	2244	1713671	1968-02-10	1968-02-10 00:00:00	1968-02-24	1968-02-24 00:00:00	1968-02-24	38000177		0	0	14		0	0	0	149396	0	562251	1713671		
92997	2041	40213160	1969-02-04	1969-02-04 00:00:00	1969-02-04	1969-02-04 00:00:00	1969-02-04	581452		0	0	0		0	0	0	135819	0	10	40213160		
32466	2692	1127433	1982-10-16	1982-10-16 00:00:00	1982-10-30	1982-10-30 00:00:00	1982-10-30	38000177		0	0	14		0	0	0	178337	0	313782	1127433		
62930	5230	19078461	2014-02-14	2014-02-14 00:00:00	2014-05-15	2014-05-15 00:00:00	2014-05-15	38000177		0	0	90		0	0	0	347944	0	310965	19078461		
42999	3565	19059056	1945-12-24	1945-12-24 00:00:00	1946-01-07	1946-01-07 00:00:00	1946-01-07	38000177		0	0	14		0	0	0	236733	0	243670	19059056		
62997	5235	19126352	1925-08-22	1925-08-22 00:00:00	1982-01-23	1982-01-23 00:00:00	1982-01-23	38000177		0	0	20608		0	0	0	348338	0	705129	19126352		
111028	2439	40213227	2005-10-26	2005-10-26 00:00:00	2005-10-26	2005-10-26 00:00:00	2005-10-26	581452		0	0	0		0	0	0	161832	0	113	40213227		
18252	1511	1127433	2009-04-27	2009-04-27 00:00:00	2009-05-11	2009-05-11 00:00:00	2009-05-11	38000177		0	0	14		0	0	0	100924	0	313782	1127433		
149345	3285	40213306	1981-04-25	1981-04-25 00:00:00	1981-04-25	1981-04-25 00:00:00	1981-04-25	581452		0	0	0		0	0	0	218197	0	43	40213306		
55548	1217	40213306	1995-06-16	1995-06-16 00:00:00	1995-06-16	1995-06-16 00:00:00	1995-06-16	581452		0	0	0		0	0	0	80182	0	43	40213306		
55589	1217	40213160	1976-06-25	1976-06-25 00:00:00	1976-06-25	1976-06-25 00:00:00	1976-06-25	581452		0	0	0		0	0	0	80174	0	10	40213160		
3850	320	19133905	1981-11-19	1981-11-19 00:00:00	1981-11-29	1981-11-29 00:00:00	1981-11-29	38000177		0	0	10		0	0	0	21227	0	834102	19133905		
15529	1294	19133905	2014-07-12	2014-07-12 00:00:00	2014-07-24	2014-07-24 00:00:00	2014-07-24	38000177		0	0	12		0	0	0	85615	0	834102	19133905		
24172	1987	1127433	1950-03-11	1950-03-11 00:00:00	1950-03-25	1950-03-25 00:00:00	1950-03-25	38000177		0	0	14		0	0	0	132282	0	313782	1127433		
46197	3827	1127433	2015-08-24	2015-08-24 00:00:00	2015-10-23	2015-10-23 00:00:00	2015-10-23	38000177		0	0	60		0	0	0	254191	0	313782	1127433		
47238	3917	1124300	2000-05-21	2000-05-21 00:00:00	2000-05-21	2000-05-21 00:00:00	\N	38000177		0	0	0		0	0	0	260469	0	00781178901	45011828		
28713	2369	19133905	2002-09-07	2002-09-07 00:00:00	2002-09-16	2002-09-16 00:00:00	2002-09-16	38000177		0	0	9		0	0	0	157646	0	834102	19133905		
42076	917	40213296	2004-01-29	2004-01-29 00:00:00	2004-01-29	2004-01-29 00:00:00	2004-01-29	581452		0	0	0		0	0	0	60985	0	52	40213296		
55596	4615	1127433	2004-12-25	2004-12-25 00:00:00	2005-01-08	2005-01-08 00:00:00	2005-01-08	38000177		0	0	14		0	0	0	307425	0	313782	1127433		
52767	4384	1127433	1978-10-17	1978-10-17 00:00:00	1978-10-24	1978-10-24 00:00:00	1978-10-24	38000177		0	0	7		0	0	0	291418	0	313782	1127433		
58075	1271	40213160	1967-06-18	1967-06-18 00:00:00	1967-06-18	1967-06-18 00:00:00	1967-06-18	581452		0	0	0		0	0	0	83808	0	10	40213160		
12427	1046	19133873	1984-08-25	1984-08-25 00:00:00	1984-09-04	1984-09-04 00:00:00	1984-09-04	38000177		0	0	10		0	0	0	68649	0	834061	19133873		
98940	2166	40213296	2010-05-16	2010-05-16 00:00:00	2010-05-16	2010-05-16 00:00:00	2010-05-16	581452		0	0	0		0	0	0	144282	0	52	40213296		
6819	573	19133873	1974-01-22	1974-01-22 00:00:00	1974-02-03	1974-02-03 00:00:00	1974-02-03	38000177		0	0	12		0	0	0	37970	0	834061	19133873		
153356	3376	40213201	2019-06-28	2019-06-28 00:00:00	2019-06-28	2019-06-28 00:00:00	2019-06-28	581452		0	0	0		0	0	0	224026	0	33	40213201		
57979	4816	40224805	1996-10-31	1996-10-31 00:00:00	1997-10-26	1997-10-26 00:00:00	1997-10-26	38000177		0	0	360		0	0	0	320386	0	1000126	40224805		
182285	4005	40213227	2012-06-09	2012-06-09 00:00:00	2012-06-09	2012-06-09 00:00:00	2012-06-09	581452		0	0	0		0	0	0	266134	0	113	40213227		
17728	384	40213227	2002-06-10	2002-06-10 00:00:00	2002-06-10	2002-06-10 00:00:00	2002-06-10	581452		0	0	0		0	0	0	25328	0	113	40213227		
49526	1084	40213160	1982-12-17	1982-12-17 00:00:00	1982-12-17	1982-12-17 00:00:00	1982-12-17	581452		0	0	0		0	0	0	71224	0	10	40213160		
745	61	19078461	1988-10-12	1988-10-12 00:00:00	1988-11-09	1988-11-09 00:00:00	1988-11-09	38000177		0	0	28		0	0	0	4162	0	310965	19078461		
1290	101	1115171	2014-07-21	2014-07-21 00:00:00	2014-08-20	2014-08-20 00:00:00	2014-08-20	38000177		0	0	30		0	0	0	6944	0	849574	1115171		
9092	194	40213227	2012-01-19	2012-01-19 00:00:00	2012-01-19	2012-01-19 00:00:00	2012-01-19	581452		0	0	0		0	0	0	13316	0	113	40213227		
200393	4401	40213296	2011-06-04	2011-06-04 00:00:00	2011-06-04	2011-06-04 00:00:00	2011-06-04	581452		0	0	0		0	0	0	\N	0	52	40213296		
2222	180	19019979	1979-03-12	1979-03-12 00:00:00	1979-04-11	1979-04-11 00:00:00	1979-04-11	38000177		0	0	30		0	0	0	12196	0	198405	19019979		
28220	2333	1115171	1999-10-16	1999-10-16 00:00:00	1999-10-30	1999-10-30 00:00:00	1999-10-30	38000177		0	0	14		0	0	0	155166	0	849574	1115171		
29446	2437	40165015	2001-11-24	2001-11-24 00:00:00	2001-11-24	2001-11-24 00:00:00	\N	38000177		0	0	0		0	0	0	161669	0	861467	40165015		
148777	3272	40213160	1970-11-17	1970-11-17 00:00:00	1970-11-17	1970-11-17 00:00:00	1970-11-17	581452		0	0	0		0	0	0	217433	0	10	40213160		
38232	834	40213160	1956-12-17	1956-12-17 00:00:00	1956-12-17	1956-12-17 00:00:00	1956-12-17	581452		0	0	0		0	0	0	55247	0	10	40213160		
90229	1980	40213227	2014-02-09	2014-02-09 00:00:00	2014-02-09	2014-02-09 00:00:00	2014-02-09	581452		0	0	0		0	0	0	131828	0	113	40213227		
30422	2521	1127433	1986-08-07	1986-08-07 00:00:00	1986-09-04	1986-09-04 00:00:00	1986-09-04	38000177		0	0	28		0	0	0	166784	0	313782	1127433		
46654	3865	1127433	1977-07-10	1977-07-10 00:00:00	1977-07-24	1977-07-24 00:00:00	1977-07-24	38000177		0	0	14		0	0	0	256579	0	313782	1127433		
29784	2468	1127433	1979-05-19	1979-05-19 00:00:00	1979-06-09	1979-06-09 00:00:00	1979-06-09	38000177		0	0	21		0	0	0	163676	0	313782	1127433		
13195	1107	1545959	2007-06-15	2007-06-15 00:00:00	2007-06-15	2007-06-15 00:00:00	2007-06-15	38000177		0	0	0		0	0	0	72859	0	259255	1545959		
101776	2231	40213227	1993-01-30	1993-01-30 00:00:00	1993-01-30	1993-01-30 00:00:00	1993-01-30	581452		0	0	0		0	0	0	148470	0	113	40213227		
186033	4087	40213227	2011-10-05	2011-10-05 00:00:00	2011-10-05	2011-10-05 00:00:00	2011-10-05	581452		0	0	0		0	0	0	271638	0	113	40213227		
238219	5229	40213160	1966-11-16	1966-11-16 00:00:00	1966-11-16	1966-11-16 00:00:00	1966-11-16	581452		0	0	0		0	0	0	347884	0	10	40213160		
44672	3697	1127433	1982-07-26	1982-07-26 00:00:00	1982-08-09	1982-08-09 00:00:00	1982-08-09	38000177		0	0	14		0	0	0	245755	0	313782	1127433		
31735	2630	19078461	2013-03-30	2013-03-30 00:00:00	2013-04-29	2013-04-29 00:00:00	2013-04-29	38000177		0	0	30		0	0	0	173997	0	310965	19078461		
15733	1310	19059056	1944-01-10	1944-01-10 00:00:00	1944-03-10	1944-03-10 00:00:00	1944-03-10	38000177		0	0	60		0	0	0	86677	0	243670	19059056		
13874	1159	1127433	2010-11-05	2010-11-05 00:00:00	2010-11-19	2010-11-19 00:00:00	2010-11-19	38000177		0	0	14		0	0	0	76586	0	313782	1127433		
22166	1821	1127433	1955-09-19	1955-09-19 00:00:00	1955-10-10	1955-10-10 00:00:00	1955-10-10	38000177		0	0	21		0	0	0	121771	0	313782	1127433		
30992	2567	19073183	1980-10-27	1980-10-27 00:00:00	1980-11-10	1980-11-10 00:00:00	1980-11-10	38000177		0	0	14		0	0	0	170080	0	308182	19073183		
17656	1461	1713671	2016-09-11	2016-09-11 00:00:00	2016-09-25	2016-09-25 00:00:00	2016-09-25	38000177		0	0	14		0	0	0	97328	0	562251	1713671		
24515	2017	1127078	1972-09-11	1972-09-11 00:00:00	1972-09-25	1972-09-25 00:00:00	1972-09-25	38000177		0	0	14		0	0	0	134157	0	282464	1127078		
65205	1427	40213227	1998-08-12	1998-08-12 00:00:00	1998-08-12	1998-08-12 00:00:00	1998-08-12	581452		0	0	0		0	0	0	94941	0	113	40213227		
35064	2895	1124300	1997-05-06	1997-05-06 00:00:00	1997-05-06	1997-05-06 00:00:00	\N	38000177		0	0	0		0	0	0	192710	0	00781178901	45011828		
20735	1709	1127433	1989-05-23	1989-05-23 00:00:00	1989-06-06	1989-06-06 00:00:00	1989-06-06	38000177		0	0	14		0	0	0	114321	0	313782	1127433		
10743	893	40236824	1981-10-26	1981-10-26 00:00:00	1981-11-02	1981-11-02 00:00:00	1981-11-02	38000177		0	0	7		0	0	0	59492	0	1094107	40236824		
45680	3783	19078461	2016-01-25	2016-01-25 00:00:00	2016-02-29	2016-02-29 00:00:00	2016-02-29	38000177		0	0	35		0	0	0	251385	0	310965	19078461		
35445	774	40213160	1967-01-01	1967-01-01 00:00:00	1967-01-01	1967-01-01 00:00:00	1967-01-01	581452		0	0	0		0	0	0	51363	0	10	40213160		
30099	655	40213227	2011-03-12	2011-03-12 00:00:00	2011-03-12	2011-03-12 00:00:00	2011-03-12	581452		0	0	0		0	0	0	43408	0	113	40213227		
24312	1999	19133873	1990-03-22	1990-03-22 00:00:00	1990-04-02	1990-04-02 00:00:00	1990-04-02	38000177		0	0	11		0	0	0	133070	0	834061	19133873		
62893	5228	40236824	1972-10-24	1972-10-24 00:00:00	1972-10-31	1972-10-31 00:00:00	1972-10-31	38000177		0	0	7		0	0	0	347780	0	1094107	40236824		
2452	196	1127078	1957-10-17	1957-10-17 00:00:00	1957-10-31	1957-10-31 00:00:00	1957-10-31	38000177		0	0	14		0	0	0	13489	0	282464	1127078		
27202	2244	19133873	1956-09-07	1956-09-07 00:00:00	1956-09-15	1956-09-15 00:00:00	1956-09-15	38000177		0	0	8		0	0	0	149389	0	834061	19133873		
92999	2041	40213160	1964-06-02	1964-06-02 00:00:00	1964-06-02	1964-06-02 00:00:00	1964-06-02	581452		0	0	0		0	0	0	135791	0	10	40213160		
32467	2692	1539411	1995-12-11	1995-12-11 00:00:00	1995-12-11	1995-12-11 00:00:00	\N	38000177		0	0	0		0	0	0	178359	0	312961	1539411		
62931	5230	1713671	1952-11-26	1952-11-26 00:00:00	1952-12-17	1952-12-17 00:00:00	1952-12-17	38000177		0	0	21		0	0	0	347946	0	562251	1713671		
43000	3565	1127433	1977-06-12	1977-06-12 00:00:00	1977-06-19	1977-06-19 00:00:00	1977-06-19	38000177		0	0	7		0	0	0	236786	0	313782	1127433		
62998	5235	19059056	1954-01-15	1954-01-15 00:00:00	1954-01-29	1954-01-29 00:00:00	1954-01-29	38000177		0	0	14		0	0	0	348365	0	243670	19059056		
111031	2439	40213160	1977-04-27	1977-04-27 00:00:00	1977-04-27	1977-04-27 00:00:00	1977-04-27	581452		0	0	0		0	0	0	161792	0	10	40213160		
18253	1511	1124300	2010-01-29	2010-01-29 00:00:00	2010-01-29	2010-01-29 00:00:00	\N	38000177		0	0	0		0	0	0	100924	0	00781178901	45011828		
149348	3285	40213227	1993-05-08	1993-05-08 00:00:00	1993-05-08	1993-05-08 00:00:00	1993-05-08	581452		0	0	0		0	0	0	218186	0	113	40213227		
55551	1217	40213160	1972-02-25	1972-02-25 00:00:00	1972-02-25	1972-02-25 00:00:00	1972-02-25	581452		0	0	0		0	0	0	80163	0	10	40213160		
55592	1217	40213160	1972-04-28	1972-04-28 00:00:00	1972-04-28	1972-04-28 00:00:00	1972-04-28	581452		0	0	0		0	0	0	80126	0	10	40213160		
3851	320	19006318	1957-11-10	1957-11-10 00:00:00	1957-11-24	1957-11-24 00:00:00	1957-11-24	38000177		0	0	14		0	0	0	21224	0	105078	19006318		
15530	1294	1127433	1985-09-05	1985-09-05 00:00:00	1985-09-12	1985-09-12 00:00:00	1985-09-12	38000177		0	0	7		0	0	0	85644	0	313782	1127433		
24184	1989	19059056	1956-12-20	1956-12-20 00:00:00	1957-01-17	1957-01-17 00:00:00	1957-01-17	38000177		0	0	28		0	0	0	132395	0	243670	19059056		
46199	3827	1118084	2001-08-29	2001-08-29 00:00:00	2001-08-29	2001-08-29 00:00:00	\N	38000177		0	0	0		0	0	0	254215	0	00025152531	44923712		
47239	3917	19059056	1968-08-02	1968-08-02 00:00:00	1968-08-30	1968-08-30 00:00:00	1968-08-30	38000177		0	0	28		0	0	0	260481	0	243670	19059056		
28714	2369	1127433	2006-07-09	2006-07-09 00:00:00	2006-07-23	2006-07-23 00:00:00	2006-07-23	38000177		0	0	14		0	0	0	157621	0	313782	1127433		
42084	917	40213160	1964-01-23	1964-01-23 00:00:00	1964-01-23	1964-01-23 00:00:00	1964-01-23	581452		0	0	0		0	0	0	61049	0	10	40213160		
55597	4615	19006318	1957-10-25	1957-10-25 00:00:00	1957-11-08	1957-11-08 00:00:00	1957-11-08	38000177		0	0	14		0	0	0	307408	0	105078	19006318		
52768	4384	19129655	1968-04-24	1968-04-24 00:00:00	1968-05-08	1968-05-08 00:00:00	1968-05-08	38000177		0	0	14		0	0	0	291420	0	789980	19129655		
58086	1271	40213160	1967-09-17	1967-09-17 00:00:00	1967-09-17	1967-09-17 00:00:00	1967-09-17	581452		0	0	0		0	0	0	83825	0	10	40213160		
12428	1046	1127433	1988-06-13	1988-06-13 00:00:00	1988-07-18	1988-07-18 00:00:00	1988-07-18	38000177		0	0	35		0	0	0	68698	0	313782	1127433		
98943	2166	40213160	1969-08-17	1969-08-17 00:00:00	1969-08-17	1969-08-17 00:00:00	1969-08-17	581452		0	0	0		0	0	0	144319	0	10	40213160		
6820	573	1127433	1977-03-25	1977-03-25 00:00:00	1977-04-01	1977-04-01 00:00:00	1977-04-01	38000177		0	0	7		0	0	0	37930	0	313782	1127433		
153365	3376	40213227	2004-04-02	2004-04-02 00:00:00	2004-04-02	2004-04-02 00:00:00	2004-04-02	581452		0	0	0		0	0	0	224022	0	113	40213227		
57980	4816	1127078	1990-05-26	1990-05-26 00:00:00	1990-06-09	1990-06-09 00:00:00	1990-06-09	38000177		0	0	14		0	0	0	320431	0	282464	1127078		
182286	4005	40213296	2012-06-09	2012-06-09 00:00:00	2012-06-09	2012-06-09 00:00:00	2012-06-09	581452		0	0	0		0	0	0	266134	0	52	40213296		
17733	384	40213227	1994-08-08	1994-08-08 00:00:00	1994-08-08	1994-08-08 00:00:00	1994-08-08	581452		0	0	0		0	0	0	25285	0	113	40213227		
49533	1084	40213160	1978-09-15	1978-09-15 00:00:00	1978-09-15	1978-09-15 00:00:00	1978-09-15	581452		0	0	0		0	0	0	71186	0	10	40213160		
746	61	19128065	1983-01-12	1983-01-12 00:00:00	1984-01-07	1984-01-07 00:00:00	1984-01-07	38000177		0	0	360		0	0	0	4082	0	749882	19128065		
1291	101	1310034	2001-01-12	2001-01-12 00:00:00	2001-01-12	2001-01-12 00:00:00	2001-01-12	38000177		0	0	0		0	0	0	6902	0	834357	1310034		
9098	194	40213314	1980-08-28	1980-08-28 00:00:00	1980-08-28	1980-08-28 00:00:00	1980-08-28	581452		0	0	0		0	0	0	13304	0	49	40213314		
200395	4401	40213227	2011-06-04	2011-06-04 00:00:00	2011-06-04	2011-06-04 00:00:00	2011-06-04	581452		0	0	0		0	0	0	\N	0	113	40213227		
2223	180	42902245	2001-02-24	2001-02-24 00:00:00	2002-02-19	2002-02-19 00:00:00	2002-02-19	38000177		0	0	360		0	0	0	12076	0	1359133	42902245		
38679	3195	19006318	1951-10-29	1951-10-29 00:00:00	1951-11-12	1951-11-12 00:00:00	1951-11-12	38000177		0	0	14		0	0	0	212576	0	105078	19006318		
29447	2437	1127433	2001-11-24	2001-11-24 00:00:00	2001-12-29	2001-12-29 00:00:00	2001-12-29	38000177		0	0	35		0	0	0	161669	0	313782	1127433		
148781	3272	40213160	1971-02-16	1971-02-16 00:00:00	1971-02-16	1971-02-16 00:00:00	1971-02-16	581452		0	0	0		0	0	0	217445	0	10	40213160		
38236	834	40213160	1956-10-15	1956-10-15 00:00:00	1956-10-15	1956-10-15 00:00:00	1956-10-15	581452		0	0	0		0	0	0	55196	0	10	40213160		
90235	1980	40213160	1972-12-17	1972-12-17 00:00:00	1972-12-17	1972-12-17 00:00:00	1972-12-17	581452		0	0	0		0	0	0	131888	0	10	40213160		
30423	2521	19059056	1980-08-17	1980-08-17 00:00:00	1980-09-07	1980-09-07 00:00:00	1980-09-07	38000177		0	0	21		0	0	0	166739	0	243670	19059056		
46655	3865	1127433	2009-05-28	2009-05-28 00:00:00	2009-07-04	2009-07-04 00:00:00	2009-07-04	38000177		0	0	37		0	0	0	256558	0	313782	1127433		
29785	2468	40229134	1994-03-27	1994-03-27 00:00:00	1994-04-03	1994-04-03 00:00:00	1994-04-03	38000177		0	0	7		0	0	0	163635	0	1043400	40229134		
160299	3528	40213160	1959-04-13	1959-04-13 00:00:00	1959-04-13	1959-04-13 00:00:00	1959-04-13	581452		0	0	0		0	0	0	234242	0	10	40213160		
101777	2231	40213306	1993-01-30	1993-01-30 00:00:00	1993-01-30	1993-01-30 00:00:00	1993-01-30	581452		0	0	0		0	0	0	148470	0	43	40213306		
186034	4087	40213314	1978-01-25	1978-01-25 00:00:00	1978-01-25	1978-01-25 00:00:00	1978-01-25	581452		0	0	0		0	0	0	271668	0	49	40213314		
238220	5229	40213227	2012-12-12	2012-12-12 00:00:00	2012-12-12	2012-12-12 00:00:00	2012-12-12	581452		0	0	0		0	0	0	347901	0	113	40213227		
44673	3697	1115171	2017-01-09	2017-01-09 00:00:00	2017-02-13	2017-02-13 00:00:00	2017-02-13	38000177		0	0	35		0	0	0	245777	0	849574	1115171		
31736	2630	19078461	1978-01-14	1978-01-14 00:00:00	1978-02-13	1978-02-13 00:00:00	1978-02-13	38000177		0	0	30		0	0	0	174028	0	310965	19078461		
15734	1310	19133873	1953-11-02	1953-11-02 00:00:00	1953-11-11	1953-11-11 00:00:00	1953-11-11	38000177		0	0	9		0	0	0	86572	0	834061	19133873		
13875	1159	19073183	1984-03-15	1984-03-15 00:00:00	1984-03-29	1984-03-29 00:00:00	1984-03-29	38000177		0	0	14		0	0	0	76537	0	308182	19073183		
83631	1829	40213160	1967-10-10	1967-10-10 00:00:00	1967-10-10	1967-10-10 00:00:00	1967-10-10	581452		0	0	0		0	0	0	122307	0	10	40213160		
30993	2567	19128022	1990-07-17	1990-07-17 00:00:00	1991-07-12	1991-07-12 00:00:00	1991-07-12	38000177		0	0	360		0	0	0	170054	0	749785	19128022		
17672	1464	1713671	1982-08-08	1982-08-08 00:00:00	1982-08-29	1982-08-29 00:00:00	1982-08-29	38000177		0	0	21		0	0	0	97513	0	562251	1713671		
24516	2017	1127433	2001-08-08	2001-08-08 00:00:00	2001-08-22	2001-08-22 00:00:00	2001-08-22	38000177		0	0	14		0	0	0	134154	0	313782	1127433		
65206	1427	40213296	1998-08-12	1998-08-12 00:00:00	1998-08-12	1998-08-12 00:00:00	1998-08-12	581452		0	0	0		0	0	0	94941	0	52	40213296		
35065	2895	19078461	2003-05-25	2003-05-25 00:00:00	2003-06-29	2003-06-29 00:00:00	2003-06-29	38000177		0	0	35		0	0	0	192679	0	310965	19078461		
20736	1709	1118084	1978-02-26	1978-02-26 00:00:00	1978-02-26	1978-02-26 00:00:00	\N	38000177		0	0	0		0	0	0	114265	0	00025152531	44923712		
10744	893	920300	1981-10-26	1981-10-26 00:00:00	1981-11-02	1981-11-02 00:00:00	1981-11-02	38000177		0	0	7		0	0	0	59492	0	311989	920300		
45682	3783	1127433	2003-10-06	2003-10-06 00:00:00	2003-10-13	2003-10-13 00:00:00	2003-10-13	38000177		0	0	7		0	0	0	251303	0	313782	1127433		
35450	774	40213296	2008-05-12	2008-05-12 00:00:00	2008-05-12	2008-05-12 00:00:00	2008-05-12	581452		0	0	0		0	0	0	51404	0	52	40213296		
30103	655	40213260	2010-03-06	2010-03-06 00:00:00	2010-03-06	2010-03-06 00:00:00	2010-03-06	581452		0	0	0		0	0	0	43362	0	121	40213260		
24313	1999	19006318	1978-06-20	1978-06-20 00:00:00	1978-07-04	1978-07-04 00:00:00	1978-07-04	38000177		0	0	14		0	0	0	133043	0	105078	19006318		
62894	5228	920300	1972-10-24	1972-10-24 00:00:00	1972-10-31	1972-10-31 00:00:00	1972-10-31	38000177		0	0	7		0	0	0	347780	0	311989	920300		
2453	196	19006318	1957-10-17	1957-10-17 00:00:00	1957-10-31	1957-10-31 00:00:00	1957-10-31	38000177		0	0	14		0	0	0	13489	0	105078	19006318		
27203	2244	1127078	1954-07-19	1954-07-19 00:00:00	1954-08-02	1954-08-02 00:00:00	1954-08-02	38000177		0	0	14		0	0	0	149394	0	282464	1127078		
93003	2041	40213160	1964-11-03	1964-11-03 00:00:00	1964-11-03	1964-11-03 00:00:00	1964-11-03	581452		0	0	0		0	0	0	135835	0	10	40213160		
32468	2692	1332419	1995-12-11	1995-12-11 00:00:00	1995-12-11	1995-12-11 00:00:00	\N	38000177		0	0	0		0	0	0	178359	0	197361	1332419		
62932	5230	40165015	2002-03-05	2002-03-05 00:00:00	2002-03-05	2002-03-05 00:00:00	\N	38000177		0	0	0		0	0	0	347941	0	861467	40165015		
43001	3565	1713671	2008-03-16	2008-03-16 00:00:00	2008-04-06	2008-04-06 00:00:00	2008-04-06	38000177		0	0	21		0	0	0	236732	0	562251	1713671		
62999	5235	19059056	1922-10-16	1922-10-16 00:00:00	1922-10-30	1922-10-30 00:00:00	1922-10-30	38000177		0	0	14		0	0	0	348327	0	243670	19059056		
111032	2439	40213314	1977-04-27	1977-04-27 00:00:00	1977-04-27	1977-04-27 00:00:00	1977-04-27	581452		0	0	0		0	0	0	161792	0	49	40213314		
18254	1511	19128065	1981-04-11	1981-04-11 00:00:00	1982-04-06	1982-04-06 00:00:00	1982-04-06	38000177		0	0	360		0	0	0	100918	0	749882	19128065		
149352	3285	40213260	2009-03-28	2009-03-28 00:00:00	2009-03-28	2009-03-28 00:00:00	2009-03-28	581452		0	0	0		0	0	0	218188	0	121	40213260		
55561	1217	40213227	1994-09-23	1994-09-23 00:00:00	1994-09-23	1994-09-23 00:00:00	1994-09-23	581452		0	0	0		0	0	0	80180	0	113	40213227		
55623	1219	40213198	2010-12-27	2010-12-27 00:00:00	2010-12-27	2010-12-27 00:00:00	2010-12-27	581452		0	0	0		0	0	0	80276	0	133	40213198		
3852	320	19059056	1957-11-10	1957-11-10 00:00:00	1957-11-24	1957-11-24 00:00:00	1957-11-24	38000177		0	0	14		0	0	0	21224	0	243670	19059056		
15531	1294	1127078	1975-01-07	1975-01-07 00:00:00	1975-01-21	1975-01-21 00:00:00	1975-01-21	38000177		0	0	14		0	0	0	85626	0	282464	1127078		
24185	1989	40162522	1988-10-29	1988-10-29 00:00:00	1988-10-29	1988-10-29 00:00:00	\N	38000177		0	0	0		0	0	0	132477	0	857005	40162522		
46200	3827	40229134	1961-10-07	1961-10-07 00:00:00	1961-10-14	1961-10-14 00:00:00	1961-10-14	38000177		0	0	7		0	0	0	254157	0	1043400	40229134		
242151	5316	40213296	1996-08-26	1996-08-26 00:00:00	1996-08-26	1996-08-26 00:00:00	1996-08-26	581452		0	0	0		0	0	0	353555	0	52	40213296		
28715	2369	1124300	2018-07-18	2018-07-18 00:00:00	2018-07-18	2018-07-18 00:00:00	\N	38000177		0	0	0		0	0	0	157731	0	00781178901	45011828		
42086	917	40213227	2006-02-02	2006-02-02 00:00:00	2006-02-02	2006-02-02 00:00:00	2006-02-02	581452		0	0	0		0	0	0	60989	0	113	40213227		
55598	4615	19059056	1957-10-25	1957-10-25 00:00:00	1957-11-08	1957-11-08 00:00:00	1957-11-08	38000177		0	0	14		0	0	0	307408	0	243670	19059056		
52769	4384	19059056	1968-04-24	1968-04-24 00:00:00	1968-05-08	1968-05-08 00:00:00	1968-05-08	38000177		0	0	14		0	0	0	291420	0	243670	19059056		
58088	1272	40213227	2011-10-14	2011-10-14 00:00:00	2011-10-14	2011-10-14 00:00:00	2011-10-14	581452		0	0	0		0	0	0	83956	0	113	40213227		
12429	1046	1127078	1975-03-19	1975-03-19 00:00:00	1975-06-17	1975-06-17 00:00:00	1975-06-17	38000177		0	0	90		0	0	0	68696	0	282464	1127078		
98950	2166	40213296	2012-05-20	2012-05-20 00:00:00	2012-05-20	2012-05-20 00:00:00	2012-05-20	581452		0	0	0		0	0	0	144326	0	52	40213296		
22951	1889	1127078	1994-06-18	1994-06-18 00:00:00	1994-07-02	1994-07-02 00:00:00	1994-07-02	38000177		0	0	14		0	0	0	125915	0	282464	1127078		
153367	3376	40213260	2006-04-14	2006-04-14 00:00:00	2006-04-14	2006-04-14 00:00:00	2006-04-14	581452		0	0	0		0	0	0	224023	0	121	40213260		
57981	4816	1713671	1983-06-08	1983-06-08 00:00:00	1983-07-27	1983-07-27 00:00:00	1983-07-27	38000177		0	0	49		0	0	0	320436	0	562251	1713671		
182287	4005	40213306	1993-05-15	1993-05-15 00:00:00	1993-05-15	1993-05-15 00:00:00	1993-05-15	581452		0	0	0		0	0	0	266076	0	43	40213306		
17737	384	40213160	1960-09-05	1960-09-05 00:00:00	1960-09-05	1960-09-05 00:00:00	1960-09-05	581452		0	0	0		0	0	0	25295	0	10	40213160		
49537	1084	40213227	2010-07-16	2010-07-16 00:00:00	2010-07-16	2010-07-16 00:00:00	2010-07-16	581452		0	0	0		0	0	0	71234	0	113	40213227		
747	61	1154615	1971-01-27	1971-01-27 00:00:00	1971-01-27	1971-01-27 00:00:00	\N	38000177		0	0	0		0	0	0	4151	0	745679	1154615		
1292	101	40243436	2001-01-12	2001-01-12 00:00:00	2001-01-12	2001-01-12 00:00:00	2001-01-12	38000177		0	0	0		0	0	0	6902	0	1190795	40243436		
9099	194	40213160	1980-08-28	1980-08-28 00:00:00	1980-08-28	1980-08-28 00:00:00	1980-08-28	581452		0	0	0		0	0	0	13304	0	10	40213160		
200401	4401	40213160	1973-12-15	1973-12-15 00:00:00	1973-12-15	1973-12-15 00:00:00	1973-12-15	581452		0	0	0		0	0	0	292600	0	10	40213160		
2224	180	40232448	1980-05-11	1980-05-11 00:00:00	1980-05-11	1980-05-11 00:00:00	\N	38000177		0	0	0		0	0	0	12107	0	1049630	40232448		
38680	3196	40229134	1978-04-27	1978-04-27 00:00:00	1978-05-04	1978-05-04 00:00:00	1978-05-04	38000177		0	0	7		0	0	0	212597	0	1043400	40229134		
29448	2437	1713671	1972-11-04	1972-11-04 00:00:00	1972-11-18	1972-11-18 00:00:00	1972-11-18	38000177		0	0	14		0	0	0	161657	0	562251	1713671		
148784	3272	40213296	2014-01-14	2014-01-14 00:00:00	2014-01-14	2014-01-14 00:00:00	2014-01-14	581452		0	0	0		0	0	0	217455	0	52	40213296		
38239	834	40213227	1997-07-21	1997-07-21 00:00:00	1997-07-21	1997-07-21 00:00:00	1997-07-21	581452		0	0	0		0	0	0	55193	0	113	40213227		
90238	1980	40213160	1976-11-28	1976-11-28 00:00:00	1976-11-28	1976-11-28 00:00:00	1976-11-28	581452		0	0	0		0	0	0	131838	0	10	40213160		
30424	2521	19075601	2007-10-15	2007-10-15 00:00:00	2007-10-15	2007-10-15 00:00:00	2007-10-15	38000177		0	0	0		0	0	0	166785	0	309362	19075601		
46656	3865	1115171	2004-11-13	2004-11-13 00:00:00	2004-12-20	2004-12-20 00:00:00	2004-12-20	38000177		0	0	37		0	0	0	256557	0	849574	1115171		
29786	2468	19133905	1970-07-07	1970-07-07 00:00:00	1970-07-15	1970-07-15 00:00:00	1970-07-15	38000177		0	0	8		0	0	0	163586	0	834102	19133905		
160302	3528	40213160	1959-02-09	1959-02-09 00:00:00	1959-02-09	1959-02-09 00:00:00	1959-02-09	581452		0	0	0		0	0	0	234194	0	10	40213160		
101780	2231	40213306	1990-09-08	1990-09-08 00:00:00	1990-09-08	1990-09-08 00:00:00	1990-09-08	581452		0	0	0		0	0	0	\N	0	43	40213306		
186035	4087	40213160	1978-01-25	1978-01-25 00:00:00	1978-01-25	1978-01-25 00:00:00	1978-01-25	581452		0	0	0		0	0	0	271668	0	10	40213160		
238221	5229	40213260	2012-12-12	2012-12-12 00:00:00	2012-12-12	2012-12-12 00:00:00	2012-12-12	581452		0	0	0		0	0	0	347901	0	121	40213260		
44674	3697	40229134	1986-09-10	1986-09-10 00:00:00	1986-09-17	1986-09-17 00:00:00	1986-09-17	38000177		0	0	7		0	0	0	245802	0	1043400	40229134		
31737	2630	40162522	1978-01-14	1978-01-14 00:00:00	1978-01-14	1978-01-14 00:00:00	\N	38000177		0	0	0		0	0	0	174028	0	857005	40162522		
15735	1310	1713671	1951-03-10	1951-03-10 00:00:00	1951-03-17	1951-03-17 00:00:00	1951-03-17	38000177		0	0	7		0	0	0	86567	0	562251	1713671		
13876	1159	1127078	1984-03-15	1984-03-15 00:00:00	1984-03-29	1984-03-29 00:00:00	1984-03-29	38000177		0	0	14		0	0	0	76537	0	282464	1127078		
83632	1829	40213160	1967-12-12	1967-12-12 00:00:00	1967-12-12	1967-12-12 00:00:00	1967-12-12	581452		0	0	0		0	0	0	122277	0	10	40213160		
30994	2567	40229134	1986-10-24	1986-10-24 00:00:00	1986-10-31	1986-10-31 00:00:00	1986-10-31	38000177		0	0	7		0	0	0	170082	0	1043400	40229134		
17673	1464	19133905	2016-07-26	2016-07-26 00:00:00	2016-08-04	2016-08-04 00:00:00	2016-08-04	38000177		0	0	9		0	0	0	97514	0	834102	19133905		
24517	2017	40229134	1985-04-26	1985-04-26 00:00:00	1985-05-03	1985-05-03 00:00:00	1985-05-03	38000177		0	0	7		0	0	0	134167	0	1043400	40229134		
68307	1496	40213201	1986-07-20	1986-07-20 00:00:00	1986-07-20	1986-07-20 00:00:00	1986-07-20	581452		0	0	0		0	0	0	99692	0	33	40213201		
35066	2895	19078461	2013-01-21	2013-01-21 00:00:00	2013-02-04	2013-02-04 00:00:00	2013-02-04	38000177		0	0	14		0	0	0	192681	0	310965	19078461		
20737	1709	1127433	2002-01-21	2002-01-21 00:00:00	2002-02-18	2002-02-18 00:00:00	2002-02-18	38000177		0	0	28		0	0	0	114240	0	313782	1127433		
10746	893	1124300	1993-09-26	1993-09-26 00:00:00	1993-09-26	1993-09-26 00:00:00	\N	38000177		0	0	0		0	0	0	59516	0	00781178901	45011828		
18349	1518	19059056	1967-04-26	1967-04-26 00:00:00	1967-05-10	1967-05-10 00:00:00	1967-05-10	38000177		0	0	14		0	0	0	101485	0	243670	19059056		
35453	774	40213227	2008-05-12	2008-05-12 00:00:00	2008-05-12	2008-05-12 00:00:00	2008-05-12	581452		0	0	0		0	0	0	51404	0	113	40213227		
30107	655	40213160	1960-03-19	1960-03-19 00:00:00	1960-03-19	1960-03-19 00:00:00	1960-03-19	581452		0	0	0		0	0	0	43368	0	10	40213160		
24314	1999	19019979	1978-06-20	1978-06-20 00:00:00	1978-07-04	1978-07-04 00:00:00	1978-07-04	38000177		0	0	14		0	0	0	133043	0	198405	19019979		
62895	5228	1127433	1969-06-21	1969-06-21 00:00:00	1969-06-28	1969-06-28 00:00:00	1969-06-28	38000177		0	0	7		0	0	0	347760	0	313782	1127433		
2454	196	1127433	1985-03-10	1985-03-10 00:00:00	1985-03-31	1985-03-31 00:00:00	1985-03-31	38000177		0	0	21		0	0	0	13526	0	313782	1127433		
27204	2244	19006318	1954-07-19	1954-07-19 00:00:00	1954-08-02	1954-08-02 00:00:00	1954-08-02	38000177		0	0	14		0	0	0	149394	0	105078	19006318		
93008	2041	40213306	1986-08-19	1986-08-19 00:00:00	1986-08-19	1986-08-19 00:00:00	1986-08-19	581452		0	0	0		0	0	0	135841	0	43	40213306		
32469	2692	19126352	1995-12-11	1995-12-11 00:00:00	1998-06-29	1998-06-29 00:00:00	1998-06-29	38000177		0	0	931		0	0	0	178359	0	705129	19126352		
62933	5230	19078461	2002-03-05	2002-03-05 00:00:00	2002-04-04	2002-04-04 00:00:00	2002-04-04	38000177		0	0	30		0	0	0	347941	0	310965	19078461		
43002	3565	1127433	1955-11-21	1955-11-21 00:00:00	1955-11-28	1955-11-28 00:00:00	1955-11-28	38000177		0	0	7		0	0	0	236775	0	313782	1127433		
63000	5235	1127433	1967-07-20	1967-07-20 00:00:00	1967-08-10	1967-08-10 00:00:00	1967-08-10	38000177		0	0	21		0	0	0	348366	0	313782	1127433		
111034	2439	40213227	1993-10-13	1993-10-13 00:00:00	1993-10-13	1993-10-13 00:00:00	1993-10-13	581452		0	0	0		0	0	0	161823	0	113	40213227		
18255	1512	1118084	2016-10-19	2016-10-19 00:00:00	2016-10-19	2016-10-19 00:00:00	\N	38000177		0	0	0		0	0	0	100950	0	00025152531	44923712		
149360	3285	40213160	1959-04-25	1959-04-25 00:00:00	1959-04-25	1959-04-25 00:00:00	1959-04-25	581452		0	0	0		0	0	0	218223	0	10	40213160		
55562	1217	40213306	1994-09-23	1994-09-23 00:00:00	1994-09-23	1994-09-23 00:00:00	1994-09-23	581452		0	0	0		0	0	0	80180	0	43	40213306		
4959	411	1127433	1970-08-03	1970-08-03 00:00:00	1970-08-17	1970-08-17 00:00:00	1970-08-17	38000177		0	0	14		0	0	0	27267	0	313782	1127433		
3853	320	40169281	1993-06-20	1993-06-20 00:00:00	1993-06-20	1993-06-20 00:00:00	\N	38000177		0	0	0		0	0	0	21204	0	896209	40169281		
15532	1294	1127433	2000-10-06	2000-10-06 00:00:00	2000-10-13	2000-10-13 00:00:00	2000-10-13	38000177		0	0	7		0	0	0	85625	0	313782	1127433		
24186	1989	1124300	1986-07-26	1986-07-26 00:00:00	1986-07-26	1986-07-26 00:00:00	\N	38000177		0	0	0		0	0	0	132445	0	00781178901	45011828		
46201	3827	19078461	1977-10-09	1977-10-09 00:00:00	1977-10-23	1977-10-23 00:00:00	1977-10-23	38000177		0	0	14		0	0	0	254188	0	310965	19078461		
242152	5317	40213160	1977-11-23	1977-11-23 00:00:00	1977-11-23	1977-11-23 00:00:00	1977-11-23	581452		0	0	0		0	0	0	353629	0	10	40213160		
28716	2369	1127433	2004-07-03	2004-07-03 00:00:00	2004-07-17	2004-07-17 00:00:00	2004-07-17	38000177		0	0	14		0	0	0	157647	0	313782	1127433		
42088	917	40213160	1963-10-24	1963-10-24 00:00:00	1963-10-24	1963-10-24 00:00:00	1963-10-24	581452		0	0	0		0	0	0	61008	0	10	40213160		
55599	4615	40229134	1973-06-04	1973-06-04 00:00:00	1973-06-18	1973-06-18 00:00:00	1973-06-18	38000177		0	0	14		0	0	0	307427	0	1043400	40229134		
52770	4384	1127433	1982-12-08	1982-12-08 00:00:00	1982-12-29	1982-12-29 00:00:00	1982-12-29	38000177		0	0	21		0	0	0	291364	0	313782	1127433		
186698	4101	40213160	1960-11-05	1960-11-05 00:00:00	1960-11-05	1960-11-05 00:00:00	1960-11-05	581452		0	0	0		0	0	0	272528	0	10	40213160		
12430	1046	1127078	1983-04-06	1983-04-06 00:00:00	1983-05-11	1983-05-11 00:00:00	1983-05-11	38000177		0	0	35		0	0	0	68697	0	282464	1127078		
98956	2167	40213251	1984-02-29	1984-02-29 00:00:00	1984-02-29	1984-02-29 00:00:00	1984-02-29	581452		0	0	0		0	0	0	144396	0	21	40213251		
22960	1892	40229134	2006-05-24	2006-05-24 00:00:00	2006-05-31	2006-05-31 00:00:00	2006-05-31	38000177		0	0	7		0	0	0	126030	0	1043400	40229134		
240251	5274	40213160	1956-10-14	1956-10-14 00:00:00	1956-10-14	1956-10-14 00:00:00	1956-10-14	581452		0	0	0		0	0	0	350786	0	10	40213160		
195224	4288	40213160	1955-09-24	1955-09-24 00:00:00	1955-09-24	1955-09-24 00:00:00	1955-09-24	581452		0	0	0		0	0	0	284703	0	10	40213160		
182289	4005	40213227	1993-05-15	1993-05-15 00:00:00	1993-05-15	1993-05-15 00:00:00	1993-05-15	581452		0	0	0		0	0	0	266076	0	113	40213227		
17739	384	40213160	1960-11-07	1960-11-07 00:00:00	1960-11-07	1960-11-07 00:00:00	1960-11-07	581452		0	0	0		0	0	0	25287	0	10	40213160		
49538	1084	40213314	1979-03-16	1979-03-16 00:00:00	1979-03-16	1979-03-16 00:00:00	1979-03-16	581452		0	0	0		0	0	0	71221	0	49	40213314		
748	61	40169216	1971-01-27	1971-01-27 00:00:00	1971-01-27	1971-01-27 00:00:00	\N	38000177		0	0	0		0	0	0	4151	0	895994	40169216		
1293	101	46275916	2001-01-12	2001-01-12 00:00:00	2001-01-12	2001-01-12 00:00:00	2001-01-12	38000177		0	0	0		0	0	0	6902	0	1660014	46275916		
9104	194	40213227	2003-01-09	2003-01-09 00:00:00	2003-01-09	2003-01-09 00:00:00	2003-01-09	581452		0	0	0		0	0	0	13349	0	113	40213227		
200404	4401	40213260	2019-01-05	2019-01-05 00:00:00	2019-01-05	2019-01-05 00:00:00	2019-01-05	581452		0	0	0		0	0	0	292566	0	121	40213260		
2225	180	40229134	1999-06-27	1999-06-27 00:00:00	1999-07-04	1999-07-04 00:00:00	1999-07-04	38000177		0	0	7		0	0	0	12189	0	1043400	40229134		
38681	3196	1115171	2000-11-25	2000-11-25 00:00:00	2000-12-30	2000-12-30 00:00:00	2000-12-30	38000177		0	0	35		0	0	0	212605	0	849574	1115171		
29449	2437	19133873	1967-10-09	1967-10-09 00:00:00	1967-10-21	1967-10-21 00:00:00	1967-10-21	38000177		0	0	12		0	0	0	161692	0	834061	19133873		
148787	3272	40213296	2012-01-10	2012-01-10 00:00:00	2012-01-10	2012-01-10 00:00:00	2012-01-10	581452		0	0	0		0	0	0	217429	0	52	40213296		
38240	834	40213296	1997-07-21	1997-07-21 00:00:00	1997-07-21	1997-07-21 00:00:00	1997-07-21	581452		0	0	0		0	0	0	55193	0	52	40213296		
90242	1980	40213160	1973-05-20	1973-05-20 00:00:00	1973-05-20	1973-05-20 00:00:00	1973-05-20	581452		0	0	0		0	0	0	131889	0	10	40213160		
30425	2521	40220960	2007-10-15	2007-10-15 00:00:00	2007-10-15	2007-10-15 00:00:00	2007-10-15	38000177		0	0	0		0	0	0	166785	0	1804799	40220960		
46657	3866	1127078	1958-01-22	1958-01-22 00:00:00	1958-02-05	1958-02-05 00:00:00	1958-02-05	38000177		0	0	14		0	0	0	256686	0	282464	1127078		
29787	2468	1713671	2003-09-09	2003-09-09 00:00:00	2003-09-30	2003-09-30 00:00:00	2003-09-30	38000177		0	0	21		0	0	0	163598	0	562251	1713671		
160313	3528	40213296	1998-11-09	1998-11-09 00:00:00	1998-11-09	1998-11-09 00:00:00	1998-11-09	581452		0	0	0		0	0	0	234160	0	52	40213296		
30831	672	40213227	1997-05-12	1997-05-12 00:00:00	1997-05-12	1997-05-12 00:00:00	1997-05-12	581452		0	0	0		0	0	0	44380	0	113	40213227		
165626	3641	40213227	2004-01-23	2004-01-23 00:00:00	2004-01-23	2004-01-23 00:00:00	2004-01-23	581452		0	0	0		0	0	0	242288	0	113	40213227		
238236	5230	40213227	2016-01-06	2016-01-06 00:00:00	2016-01-06	2016-01-06 00:00:00	2016-01-06	581452		0	0	0		0	0	0	347979	0	113	40213227		
44675	3697	1127433	1960-07-05	1960-07-05 00:00:00	1960-07-19	1960-07-19 00:00:00	1960-07-19	38000177		0	0	14		0	0	0	245799	0	313782	1127433		
31738	2630	1713671	1988-11-24	1988-11-24 00:00:00	1988-12-01	1988-12-01 00:00:00	1988-12-01	38000177		0	0	7		0	0	0	173950	0	562251	1713671		
15736	1310	1127433	1953-04-07	1953-04-07 00:00:00	1953-04-14	1953-04-14 00:00:00	1953-04-14	38000177		0	0	7		0	0	0	86569	0	313782	1127433		
13877	1159	1127078	1986-05-21	1986-05-21 00:00:00	1986-06-04	1986-06-04 00:00:00	1986-06-04	38000177		0	0	14		0	0	0	76538	0	282464	1127078		
83633	1829	40213306	1990-04-24	1990-04-24 00:00:00	1990-04-24	1990-04-24 00:00:00	1990-04-24	581452		0	0	0		0	0	0	122317	0	43	40213306		
30995	2567	1115171	2018-08-30	2018-08-30 00:00:00	2018-10-04	2018-10-04 00:00:00	2018-10-04	38000177		0	0	35		0	0	0	170095	0	849574	1115171		
17674	1464	1118084	2002-08-13	2002-08-13 00:00:00	2002-08-13	2002-08-13 00:00:00	\N	38000177		0	0	0		0	0	0	97550	0	00025152531	44923712		
24518	2017	1127433	1980-07-03	1980-07-03 00:00:00	1980-07-17	1980-07-17 00:00:00	1980-07-17	38000177		0	0	14		0	0	0	134191	0	313782	1127433		
68332	1496	40213227	1992-05-03	1992-05-03 00:00:00	1992-05-03	1992-05-03 00:00:00	1992-05-03	581452		0	0	0		0	0	0	99704	0	113	40213227		
35067	2895	1127433	1984-05-20	1984-05-20 00:00:00	1984-05-27	1984-05-27 00:00:00	1984-05-27	38000177		0	0	7		0	0	0	192738	0	313782	1127433		
20738	1709	19059056	1949-11-06	1949-11-06 00:00:00	1949-12-06	1949-12-06 00:00:00	1949-12-06	38000177		0	0	30		0	0	0	114220	0	243670	19059056		
10748	893	1713671	2018-02-11	2018-02-11 00:00:00	2018-03-04	2018-03-04 00:00:00	2018-03-04	38000177		0	0	21		0	0	0	59456	0	562251	1713671		
18350	1518	1115171	2009-12-16	2009-12-16 00:00:00	2010-01-06	2010-01-06 00:00:00	2010-01-06	38000177		0	0	21		0	0	0	101542	0	849574	1115171		
35455	774	40213260	2017-05-29	2017-05-29 00:00:00	2017-05-29	2017-05-29 00:00:00	2017-05-29	581452		0	0	0		0	0	0	51348	0	121	40213260		
30108	656	40213260	2014-06-14	2014-06-14 00:00:00	2014-06-14	2014-06-14 00:00:00	2014-06-14	581452		0	0	0		0	0	0	43485	0	121	40213260		
24315	1999	1115171	2013-04-22	2013-04-22 00:00:00	2013-05-06	2013-05-06 00:00:00	2013-05-06	38000177		0	0	14		0	0	0	133059	0	849574	1115171		
62896	5228	40236824	1966-09-18	1966-09-18 00:00:00	1966-10-02	1966-10-02 00:00:00	1966-10-02	38000177		0	0	14		0	0	0	347759	0	1094107	40236824		
2455	196	40236824	1988-10-31	1988-10-31 00:00:00	1988-11-07	1988-11-07 00:00:00	1988-11-07	38000177		0	0	7		0	0	0	13517	0	1094107	40236824		
27205	2244	40231925	1975-03-22	1975-03-22 00:00:00	1975-03-22	1975-03-22 00:00:00	\N	38000177		0	0	0		0	0	0	149383	0	1049221	40231925		
35963	2960	19128065	1976-12-19	1976-12-19 00:00:00	1977-12-14	1977-12-14 00:00:00	1977-12-14	38000177		0	0	360		0	0	0	197618	0	749882	19128065		
32470	2692	19075601	1997-11-17	1997-11-17 00:00:00	1998-06-29	1998-06-29 00:00:00	1998-06-29	38000177		0	0	224		0	0	0	178360	0	309362	19075601		
62934	5230	19133905	1994-01-05	1994-01-05 00:00:00	1994-01-16	1994-01-16 00:00:00	1994-01-16	38000177		0	0	11		0	0	0	347982	0	834102	19133905		
43003	3565	920300	1966-04-03	1966-04-03 00:00:00	1966-04-10	1966-04-10 00:00:00	1966-04-10	38000177		0	0	7		0	0	0	236714	0	311989	920300		
63001	5235	1713671	1957-02-21	1957-02-21 00:00:00	1957-03-14	1957-03-14 00:00:00	1957-03-14	38000177		0	0	21		0	0	0	348323	0	562251	1713671		
111035	2439	40213306	1993-10-13	1993-10-13 00:00:00	1993-10-13	1993-10-13 00:00:00	1993-10-13	581452		0	0	0		0	0	0	161823	0	43	40213306		
18256	1512	1713671	2014-02-16	2014-02-16 00:00:00	2014-04-27	2014-04-27 00:00:00	2014-04-27	38000177		0	0	70		0	0	0	101007	0	562251	1713671		
69885	1528	40213296	1999-01-15	1999-01-15 00:00:00	1999-01-15	1999-01-15 00:00:00	1999-01-15	581452		0	0	0		0	0	0	102219	0	52	40213296		
55565	1217	40213227	2003-07-11	2003-07-11 00:00:00	2003-07-11	2003-07-11 00:00:00	2003-07-11	581452		0	0	0		0	0	0	80143	0	113	40213227		
4960	411	1127433	1972-08-14	1972-08-14 00:00:00	1972-08-21	1972-08-21 00:00:00	1972-08-21	38000177		0	0	7		0	0	0	27268	0	313782	1127433		
3854	320	40165015	1974-03-01	1974-03-01 00:00:00	1974-03-01	1974-03-01 00:00:00	\N	38000177		0	0	0		0	0	0	21205	0	861467	40165015		
15533	1294	19073188	1986-11-24	1986-11-24 00:00:00	1986-12-08	1986-12-08 00:00:00	1986-12-08	38000177		0	0	14		0	0	0	85652	0	308192	19073188		
24187	1989	40229134	1984-04-14	1984-04-14 00:00:00	1984-04-21	1984-04-21 00:00:00	1984-04-21	38000177		0	0	7		0	0	0	132445	0	1043400	40229134		
46202	3827	19059056	1960-10-03	1960-10-03 00:00:00	1960-10-17	1960-10-17 00:00:00	1960-10-17	38000177		0	0	14		0	0	0	254177	0	243670	19059056		
242155	5317	40213314	1977-11-23	1977-11-23 00:00:00	1977-11-23	1977-11-23 00:00:00	1977-11-23	581452		0	0	0		0	0	0	353629	0	49	40213314		
39177	3237	1127433	1986-05-08	1986-05-08 00:00:00	1986-06-05	1986-06-05 00:00:00	1986-06-05	38000177		0	0	28		0	0	0	215154	0	313782	1127433		
42090	917	40213260	2013-05-16	2013-05-16 00:00:00	2013-05-16	2013-05-16 00:00:00	2013-05-16	581452		0	0	0		0	0	0	60990	0	121	40213260		
55600	4615	19006318	1957-04-09	1957-04-09 00:00:00	1957-04-23	1957-04-23 00:00:00	1957-04-23	38000177		0	0	14		0	0	0	307407	0	105078	19006318		
52782	4387	19133873	1974-07-04	1974-07-04 00:00:00	1974-07-15	1974-07-15 00:00:00	1974-07-15	38000177		0	0	11		0	0	0	291588	0	834061	19133873		
186702	4101	40213160	1960-06-04	1960-06-04 00:00:00	1960-06-04	1960-06-04 00:00:00	1960-06-04	581452		0	0	0		0	0	0	272527	0	10	40213160		
12431	1046	19128065	1987-04-25	1987-04-25 00:00:00	1988-04-19	1988-04-19 00:00:00	1988-04-19	38000177		0	0	360		0	0	0	68663	0	749882	19128065		
98959	2167	40213227	2000-08-30	2000-08-30 00:00:00	2000-08-30	2000-08-30 00:00:00	2000-08-30	581452		0	0	0		0	0	0	144383	0	113	40213227		
22961	1892	19059056	1962-06-04	1962-06-04 00:00:00	1962-06-25	1962-06-25 00:00:00	1962-06-25	38000177		0	0	21		0	0	0	126044	0	243670	19059056		
240267	5274	40213227	2013-12-15	2013-12-15 00:00:00	2013-12-15	2013-12-15 00:00:00	2013-12-15	581452		0	0	0		0	0	0	350830	0	113	40213227		
195245	4288	40213201	2017-03-25	2017-03-25 00:00:00	2017-03-25	2017-03-25 00:00:00	2017-03-25	581452		0	0	0		0	0	0	284672	0	33	40213201		
182290	4005	40213160	1969-11-29	1969-11-29 00:00:00	1969-11-29	1969-11-29 00:00:00	1969-11-29	581452		0	0	0		0	0	0	266114	0	10	40213160		
17745	384	40213260	2011-02-28	2011-02-28 00:00:00	2011-02-28	2011-02-28 00:00:00	2011-02-28	581452		0	0	0		0	0	0	25304	0	121	40213260		
49541	1084	40213227	2000-09-22	2000-09-22 00:00:00	2000-09-22	2000-09-22 00:00:00	2000-09-22	581452		0	0	0		0	0	0	71228	0	113	40213227		
749	61	1713671	1981-05-22	1981-05-22 00:00:00	1981-06-12	1981-06-12 00:00:00	1981-06-12	38000177		0	0	21		0	0	0	4124	0	562251	1713671		
1294	101	1713671	1931-08-01	1931-08-01 00:00:00	1931-08-22	1931-08-22 00:00:00	1931-08-22	38000177		0	0	21		0	0	0	6904	0	562251	1713671		
9105	194	40213306	2003-01-09	2003-01-09 00:00:00	2003-01-09	2003-01-09 00:00:00	2003-01-09	581452		0	0	0		0	0	0	13349	0	43	40213306		
200408	4401	40213160	1969-06-14	1969-06-14 00:00:00	1969-06-14	1969-06-14 00:00:00	1969-06-14	581452		0	0	0		0	0	0	292541	0	10	40213160		
2226	180	46233988	1977-12-17	1977-12-17 00:00:00	1977-12-31	1977-12-31 00:00:00	1977-12-31	38000177		0	0	14		0	0	0	12093	0	1652673	46233988		
38682	3196	40229134	1983-09-16	1983-09-16 00:00:00	1983-09-23	1983-09-23 00:00:00	1983-09-23	38000177		0	0	7		0	0	0	212627	0	1043400	40229134		
29450	2437	1127433	2018-04-04	2018-04-04 00:00:00	2018-05-02	2018-05-02 00:00:00	2018-05-02	38000177		0	0	28		0	0	0	161670	0	313782	1127433		
148789	3272	40213227	2012-01-10	2012-01-10 00:00:00	2012-01-10	2012-01-10 00:00:00	2012-01-10	581452		0	0	0		0	0	0	217429	0	113	40213227		
38250	834	40213227	2007-08-20	2007-08-20 00:00:00	2007-08-20	2007-08-20 00:00:00	2007-08-20	581452		0	0	0		0	0	0	55204	0	113	40213227		
70493	1541	40213160	1963-10-07	1963-10-07 00:00:00	1963-10-07	1963-10-07 00:00:00	1963-10-07	581452		0	0	0		0	0	0	103250	0	10	40213160		
30426	2521	1127433	1981-11-05	1981-11-05 00:00:00	1981-11-12	1981-11-12 00:00:00	1981-11-12	38000177		0	0	7		0	0	0	166731	0	313782	1127433		
46658	3866	19006318	1958-01-22	1958-01-22 00:00:00	1958-02-05	1958-02-05 00:00:00	1958-02-05	38000177		0	0	14		0	0	0	256686	0	105078	19006318		
29788	2468	1127433	1986-11-19	1986-11-19 00:00:00	1986-11-26	1986-11-26 00:00:00	1986-11-26	38000177		0	0	7		0	0	0	163604	0	313782	1127433		
160315	3528	40213306	1981-10-05	1981-10-05 00:00:00	1981-10-05	1981-10-05 00:00:00	1981-10-05	581452		0	0	0		0	0	0	234202	0	43	40213306		
30832	672	40213296	1997-05-12	1997-05-12 00:00:00	1997-05-12	1997-05-12 00:00:00	1997-05-12	581452		0	0	0		0	0	0	44380	0	52	40213296		
35648	778	40213251	1984-01-05	1984-01-05 00:00:00	1984-01-05	1984-01-05 00:00:00	1984-01-05	581452		0	0	0		0	0	0	51708	0	21	40213251		
67917	1486	40213160	1955-10-16	1955-10-16 00:00:00	1955-10-16	1955-10-16 00:00:00	1955-10-16	581452		0	0	0		0	0	0	99058	0	10	40213160		
44676	3697	1713671	2011-04-10	2011-04-10 00:00:00	2011-04-24	2011-04-24 00:00:00	2011-04-24	38000177		0	0	14		0	0	0	245733	0	562251	1713671		
31739	2630	1127433	2008-08-22	2008-08-22 00:00:00	2008-08-29	2008-08-29 00:00:00	2008-08-29	38000177		0	0	7		0	0	0	173952	0	313782	1127433		
15737	1310	19008572	1969-03-03	1969-03-03 00:00:00	1969-03-03	1969-03-03 00:00:00	\N	38000177		0	0	0		0	0	0	86584	0	106258	19008572		
13878	1159	19128022	1995-07-25	1995-07-25 00:00:00	1996-07-19	1996-07-19 00:00:00	1996-07-19	38000177		0	0	360		0	0	0	76588	0	749785	19128022		
83637	1829	40213260	2018-08-28	2018-08-28 00:00:00	2018-08-28	2018-08-28 00:00:00	2018-08-28	581452		0	0	0		0	0	0	122299	0	121	40213260		
30996	2567	1127078	1984-12-05	1984-12-05 00:00:00	1984-12-26	1984-12-26 00:00:00	1984-12-26	38000177		0	0	21		0	0	0	170094	0	282464	1127078		
17675	1464	40229134	1996-03-31	1996-03-31 00:00:00	1996-04-07	1996-04-07 00:00:00	1996-04-07	38000177		0	0	7		0	0	0	97548	0	1043400	40229134		
24519	2017	1124300	2007-10-08	2007-10-08 00:00:00	2007-10-08	2007-10-08 00:00:00	\N	38000177		0	0	0		0	0	0	134215	0	00781178901	45011828		
77793	1702	40213227	2007-10-15	2007-10-15 00:00:00	2007-10-15	2007-10-15 00:00:00	2007-10-15	581452		0	0	0		0	0	0	113829	0	113	40213227		
35068	2895	1127433	1959-12-13	1959-12-13 00:00:00	1959-12-20	1959-12-20 00:00:00	1959-12-20	38000177		0	0	7		0	0	0	192736	0	313782	1127433		
20739	1709	1713671	1967-03-02	1967-03-02 00:00:00	1967-03-09	1967-03-09 00:00:00	1967-03-09	38000177		0	0	7		0	0	0	114255	0	562251	1713671		
10749	893	1127433	1963-08-31	1963-08-31 00:00:00	1963-09-07	1963-09-07 00:00:00	1963-09-07	38000177		0	0	7		0	0	0	59488	0	313782	1127433		
18351	1518	1118084	1998-07-14	1998-07-14 00:00:00	1998-07-14	1998-07-14 00:00:00	\N	38000177		0	0	0		0	0	0	101567	0	00025152531	44923712		
35462	774	40213227	2018-06-04	2018-06-04 00:00:00	2018-06-04	2018-06-04 00:00:00	2018-06-04	581452		0	0	0		0	0	0	51338	0	113	40213227		
30119	656	40213227	1995-03-18	1995-03-18 00:00:00	1995-03-18	1995-03-18 00:00:00	1995-03-18	581452		0	0	0		0	0	0	43441	0	113	40213227		
24316	1999	46233988	1982-10-10	1982-10-10 00:00:00	1982-10-24	1982-10-24 00:00:00	1982-10-24	38000177		0	0	14		0	0	0	133140	0	1652673	46233988		
62897	5228	920300	1966-09-18	1966-09-18 00:00:00	1966-09-25	1966-09-25 00:00:00	1966-09-25	38000177		0	0	7		0	0	0	347759	0	311989	920300		
2456	196	920300	1988-10-31	1988-10-31 00:00:00	1988-11-07	1988-11-07 00:00:00	1988-11-07	38000177		0	0	7		0	0	0	13517	0	311989	920300		
27206	2244	1127433	1975-03-22	1975-03-22 00:00:00	1975-05-21	1975-05-21 00:00:00	1975-05-21	38000177		0	0	60		0	0	0	149383	0	313782	1127433		
35964	2960	1127433	1970-02-14	1970-02-14 00:00:00	1970-03-14	1970-03-14 00:00:00	1970-03-14	38000177		0	0	28		0	0	0	197607	0	313782	1127433		
32471	2692	1713671	1967-06-15	1967-06-15 00:00:00	1967-07-06	1967-07-06 00:00:00	1967-07-06	38000177		0	0	21		0	0	0	178351	0	562251	1713671		
62935	5230	19133873	1953-03-25	1953-03-25 00:00:00	1953-04-05	1953-04-05 00:00:00	1953-04-05	38000177		0	0	11		0	0	0	347947	0	834061	19133873		
43004	3565	40236824	1966-04-03	1966-04-03 00:00:00	1966-04-10	1966-04-10 00:00:00	1966-04-10	38000177		0	0	7		0	0	0	236714	0	1094107	40236824		
63002	5235	19018935	1981-12-12	1981-12-12 00:00:00	1981-12-12	1981-12-12 00:00:00	\N	38000177		0	0	0		0	0	0	348373	0	197604	19018935		
111038	2439	40213160	1973-01-24	1973-01-24 00:00:00	1973-01-24	1973-01-24 00:00:00	1973-01-24	581452		0	0	0		0	0	0	161817	0	10	40213160		
18257	1512	1127433	1979-07-17	1979-07-17 00:00:00	1979-07-24	1979-07-24 00:00:00	1979-07-24	38000177		0	0	7		0	0	0	100959	0	313782	1127433		
69890	1528	40213306	1981-05-22	1981-05-22 00:00:00	1981-05-22	1981-05-22 00:00:00	1981-05-22	581452		0	0	0		0	0	0	102278	0	43	40213306		
55572	1217	40213296	2012-11-30	2012-11-30 00:00:00	2012-11-30	2012-11-30 00:00:00	2012-11-30	581452		0	0	0		0	0	0	80183	0	52	40213296		
4961	411	1127433	1961-02-11	1961-02-11 00:00:00	1961-02-25	1961-02-25 00:00:00	1961-02-25	38000177		0	0	14		0	0	0	27317	0	313782	1127433		
3855	320	920300	1977-04-01	1977-04-01 00:00:00	1977-04-08	1977-04-08 00:00:00	1977-04-08	38000177		0	0	7		0	0	0	21187	0	311989	920300		
15534	1294	19078461	1986-11-24	1986-11-24 00:00:00	1986-12-08	1986-12-08 00:00:00	1986-12-08	38000177		0	0	14		0	0	0	85652	0	310965	19078461		
24188	1989	1713671	1992-04-16	1992-04-16 00:00:00	1992-05-07	1992-05-07 00:00:00	1992-05-07	38000177		0	0	21		0	0	0	132409	0	562251	1713671		
46203	3827	19006318	1960-10-03	1960-10-03 00:00:00	1960-10-17	1960-10-17 00:00:00	1960-10-17	38000177		0	0	14		0	0	0	254177	0	105078	19006318		
242158	5317	40213160	1973-08-15	1973-08-15 00:00:00	1973-08-15	1973-08-15 00:00:00	1973-08-15	581452		0	0	0		0	0	0	353655	0	10	40213160		
39178	3237	1127433	1959-01-16	1959-01-16 00:00:00	1959-01-30	1959-01-30 00:00:00	1959-01-30	38000177		0	0	14		0	0	0	215151	0	313782	1127433		
42093	917	40213306	1986-03-06	1986-03-06 00:00:00	1986-03-06	1986-03-06 00:00:00	1986-03-06	581452		0	0	0		0	0	0	61056	0	43	40213306		
55601	4615	19059056	1957-04-09	1957-04-09 00:00:00	1957-04-23	1957-04-23 00:00:00	1957-04-23	38000177		0	0	14		0	0	0	307407	0	243670	19059056		
52783	4387	19059056	1968-04-02	1968-04-02 00:00:00	1968-04-16	1968-04-16 00:00:00	1968-04-16	38000177		0	0	14		0	0	0	291610	0	243670	19059056		
186709	4101	40213227	1992-02-01	1992-02-01 00:00:00	1992-02-01	1992-02-01 00:00:00	1992-02-01	581452		0	0	0		0	0	0	272486	0	113	40213227		
12432	1046	1127433	2000-03-17	2000-03-17 00:00:00	2000-03-31	2000-03-31 00:00:00	2000-03-31	38000177		0	0	14		0	0	0	68677	0	313782	1127433		
98960	2167	40213306	2000-08-30	2000-08-30 00:00:00	2000-08-30	2000-08-30 00:00:00	2000-08-30	581452		0	0	0		0	0	0	144383	0	43	40213306		
22962	1892	1127433	2008-11-08	2008-11-08 00:00:00	2008-11-22	2008-11-22 00:00:00	2008-11-22	38000177		0	0	14		0	0	0	125976	0	313782	1127433		
29149	636	40213227	2019-04-12	2019-04-12 00:00:00	2019-04-12	2019-04-12 00:00:00	2019-04-12	581452		0	0	0		0	0	0	42105	0	113	40213227		
195251	4288	40213227	2003-01-04	2003-01-04 00:00:00	2003-01-04	2003-01-04 00:00:00	2003-01-04	581452		0	0	0		0	0	0	284733	0	113	40213227		
40344	879	40213227	2013-04-15	2013-04-15 00:00:00	2013-04-15	2013-04-15 00:00:00	2013-04-15	581452		0	0	0		0	0	0	58569	0	113	40213227		
17755	384	40213306	1982-07-26	1982-07-26 00:00:00	1982-07-26	1982-07-26 00:00:00	1982-07-26	581452		0	0	0		0	0	0	25302	0	43	40213306		
49542	1084	40213306	2000-09-22	2000-09-22 00:00:00	2000-09-22	2000-09-22 00:00:00	2000-09-22	581452		0	0	0		0	0	0	71228	0	43	40213306		
750	61	1127078	1969-12-23	1969-12-23 00:00:00	1970-01-06	1970-01-06 00:00:00	1970-01-06	38000177		0	0	14		0	0	0	4081	0	282464	1127078		
1295	101	19059056	1955-06-20	1955-06-20 00:00:00	1955-07-25	1955-07-25 00:00:00	1955-07-25	38000177		0	0	35		0	0	0	6895	0	243670	19059056		
9107	194	40213251	1984-02-23	1984-02-23 00:00:00	1984-02-23	1984-02-23 00:00:00	1984-02-23	581452		0	0	0		0	0	0	13344	0	21	40213251		
200409	4401	40213160	1969-09-13	1969-09-13 00:00:00	1969-09-13	1969-09-13 00:00:00	1969-09-13	581452		0	0	0		0	0	0	292551	0	10	40213160		
2227	180	1127078	1977-12-17	1977-12-17 00:00:00	1977-12-31	1977-12-31 00:00:00	1977-12-31	38000177		0	0	14		0	0	0	12093	0	282464	1127078		
38683	3196	1127433	2004-01-19	2004-01-19 00:00:00	2004-02-02	2004-02-02 00:00:00	2004-02-02	38000177		0	0	14		0	0	0	212616	0	313782	1127433		
29451	2437	19059056	1963-08-11	1963-08-11 00:00:00	1963-09-10	1963-09-10 00:00:00	1963-09-10	38000177		0	0	30		0	0	0	161667	0	243670	19059056		
148790	3272	40213160	1970-09-15	1970-09-15 00:00:00	1970-09-15	1970-09-15 00:00:00	1970-09-15	581452		0	0	0		0	0	0	217447	0	10	40213160		
38251	834	40213260	2007-08-20	2007-08-20 00:00:00	2007-08-20	2007-08-20 00:00:00	2007-08-20	581452		0	0	0		0	0	0	55204	0	121	40213260		
70495	1541	40213306	1985-07-01	1985-07-01 00:00:00	1985-07-01	1985-07-01 00:00:00	1985-07-01	581452		0	0	0		0	0	0	103268	0	43	40213306		
30427	2521	19059056	1949-01-13	1949-01-13 00:00:00	1949-01-27	1949-01-27 00:00:00	1949-01-27	38000177		0	0	14		0	0	0	166685	0	243670	19059056		
46659	3866	19078461	2000-08-15	2000-08-15 00:00:00	2000-09-19	2000-09-19 00:00:00	2000-09-19	38000177		0	0	35		0	0	0	256702	0	310965	19078461		
29789	2468	40229134	1963-04-29	1963-04-29 00:00:00	1963-05-06	1963-05-06 00:00:00	1963-05-06	38000177		0	0	7		0	0	0	163603	0	1043400	40229134		
160317	3528	40213227	1993-10-18	1993-10-18 00:00:00	1993-10-18	1993-10-18 00:00:00	1993-10-18	581452		0	0	0		0	0	0	234158	0	113	40213227		
30835	672	40213160	1955-08-08	1955-08-08 00:00:00	1955-08-08	1955-08-08 00:00:00	1955-08-08	581452		0	0	0		0	0	0	44352	0	10	40213160		
35650	778	40213314	1979-03-29	1979-03-29 00:00:00	1979-03-29	1979-03-29 00:00:00	1979-03-29	581452		0	0	0		0	0	0	51659	0	49	40213314		
67919	1486	40213160	1956-03-18	1956-03-18 00:00:00	1956-03-18	1956-03-18 00:00:00	1956-03-18	581452		0	0	0		0	0	0	99059	0	10	40213160		
44677	3697	19078461	2015-02-28	2015-02-28 00:00:00	2015-03-21	2015-03-21 00:00:00	2015-03-21	38000177		0	0	21		0	0	0	245776	0	310965	19078461		
31740	2630	40229134	1975-05-01	1975-05-01 00:00:00	1975-05-15	1975-05-15 00:00:00	1975-05-15	38000177		0	0	14		0	0	0	173930	0	1043400	40229134		
15738	1310	19059056	1968-09-30	1968-09-30 00:00:00	1968-10-14	1968-10-14 00:00:00	1968-10-14	38000177		0	0	14		0	0	0	86575	0	243670	19059056		
230496	5065	40213160	1969-07-22	1969-07-22 00:00:00	1969-07-22	1969-07-22 00:00:00	1969-07-22	581452		0	0	0		0	0	0	336710	0	10	40213160		
83639	1829	40213227	2018-08-28	2018-08-28 00:00:00	2018-08-28	2018-08-28 00:00:00	2018-08-28	581452		0	0	0		0	0	0	122299	0	113	40213227		
30997	2567	19133873	1978-11-09	1978-11-09 00:00:00	1978-11-19	1978-11-19 00:00:00	1978-11-19	38000177		0	0	10		0	0	0	170077	0	834061	19133873		
17676	1464	19133905	1998-03-08	1998-03-08 00:00:00	1998-03-20	1998-03-20 00:00:00	1998-03-20	38000177		0	0	12		0	0	0	97549	0	834102	19133905		
24520	2017	19006318	1974-05-04	1974-05-04 00:00:00	1974-05-18	1974-05-18 00:00:00	1974-05-18	38000177		0	0	14		0	0	0	134155	0	105078	19006318		
77794	1702	40213296	2007-10-15	2007-10-15 00:00:00	2007-10-15	2007-10-15 00:00:00	2007-10-15	581452		0	0	0		0	0	0	113829	0	52	40213296		
35069	2895	1713671	1960-07-14	1960-07-14 00:00:00	1960-07-28	1960-07-28 00:00:00	1960-07-28	38000177		0	0	14		0	0	0	192712	0	562251	1713671		
20740	1709	19059056	1937-09-14	1937-09-14 00:00:00	1937-09-28	1937-09-28 00:00:00	1937-09-28	38000177		0	0	14		0	0	0	114285	0	243670	19059056		
10750	893	1713671	2014-08-01	2014-08-01 00:00:00	2014-08-22	2014-08-22 00:00:00	2014-08-22	38000177		0	0	21		0	0	0	59494	0	562251	1713671		
18352	1518	19133873	1955-07-03	1955-07-03 00:00:00	1955-07-11	1955-07-11 00:00:00	1955-07-11	38000177		0	0	8		0	0	0	101537	0	834061	19133873		
35466	774	40213306	1988-09-19	1988-09-19 00:00:00	1988-09-19	1988-09-19 00:00:00	1988-09-19	581452		0	0	0		0	0	0	51387	0	43	40213306		
30121	656	40213160	1964-09-12	1964-09-12 00:00:00	1964-09-12	1964-09-12 00:00:00	1964-09-12	581452		0	0	0		0	0	0	43465	0	10	40213160		
24317	1999	1127078	1982-10-10	1982-10-10 00:00:00	1982-10-24	1982-10-24 00:00:00	1982-10-24	38000177		0	0	14		0	0	0	133140	0	282464	1127078		
62898	5228	1127433	1939-01-09	1939-01-09 00:00:00	1939-01-23	1939-01-23 00:00:00	1939-01-23	38000177		0	0	14		0	0	0	347757	0	313782	1127433		
2457	196	40229134	1967-07-29	1967-07-29 00:00:00	1967-08-05	1967-08-05 00:00:00	1967-08-05	38000177		0	0	7		0	0	0	13441	0	1043400	40229134		
27207	2244	1127433	1972-04-15	1972-04-15 00:00:00	1972-05-06	1972-05-06 00:00:00	1972-05-06	38000177		0	0	21		0	0	0	149382	0	313782	1127433		
35967	2960	1115171	2009-03-24	2009-03-24 00:00:00	2009-04-07	2009-04-07 00:00:00	2009-04-07	38000177		0	0	14		0	0	0	197610	0	849574	1115171		
32472	2692	1127078	1959-07-17	1959-07-17 00:00:00	1959-07-31	1959-07-31 00:00:00	1959-07-31	38000177		0	0	14		0	0	0	178361	0	282464	1127078		
62936	5230	1124300	1981-02-13	1981-02-13 00:00:00	1981-02-13	1981-02-13 00:00:00	\N	38000177		0	0	0		0	0	0	347962	0	00781178901	45011828		
43005	3565	19059056	1950-01-02	1950-01-02 00:00:00	1950-01-30	1950-01-30 00:00:00	1950-01-30	38000177		0	0	28		0	0	0	236738	0	243670	19059056		
63003	5235	40163554	1981-12-12	1981-12-12 00:00:00	1981-12-12	1981-12-12 00:00:00	\N	38000177		0	0	0		0	0	0	348373	0	855332	40163554		
111041	2439	40213296	2013-01-09	2013-01-09 00:00:00	2013-01-09	2013-01-09 00:00:00	2013-01-09	581452		0	0	0		0	0	0	161778	0	52	40213296		
18258	1512	19073183	1979-11-04	1979-11-04 00:00:00	1979-11-18	1979-11-18 00:00:00	1979-11-18	38000177		0	0	14		0	0	0	100994	0	308182	19073183		
69893	1528	40213160	1959-06-19	1959-06-19 00:00:00	1959-06-19	1959-06-19 00:00:00	1959-06-19	581452		0	0	0		0	0	0	102291	0	10	40213160		
55574	1217	40213227	2012-11-30	2012-11-30 00:00:00	2012-11-30	2012-11-30 00:00:00	2012-11-30	581452		0	0	0		0	0	0	80183	0	113	40213227		
4962	411	19133873	1971-10-05	1971-10-05 00:00:00	1971-10-14	1971-10-14 00:00:00	1971-10-14	38000177		0	0	9		0	0	0	27308	0	834061	19133873		
3856	320	40236824	1977-04-01	1977-04-01 00:00:00	1977-04-08	1977-04-08 00:00:00	1977-04-08	38000177		0	0	7		0	0	0	21187	0	1094107	40236824		
15535	1294	1713671	1983-10-14	1983-10-14 00:00:00	1983-10-28	1983-10-28 00:00:00	1983-10-28	38000177		0	0	14		0	0	0	85613	0	562251	1713671		
24189	1989	19078461	1994-05-31	1994-05-31 00:00:00	1994-06-14	1994-06-14 00:00:00	1994-06-14	38000177		0	0	14		0	0	0	132480	0	310965	19078461		
46204	3827	1127433	1986-07-08	1986-07-08 00:00:00	1986-07-22	1986-07-22 00:00:00	1986-07-22	38000177		0	0	14		0	0	0	254189	0	313782	1127433		
242160	5317	40213306	1995-02-15	1995-02-15 00:00:00	1995-02-15	1995-02-15 00:00:00	1995-02-15	581452		0	0	0		0	0	0	353634	0	43	40213306		
39179	3237	40229134	2000-01-17	2000-01-17 00:00:00	2000-01-31	2000-01-31 00:00:00	2000-01-31	38000177		0	0	14		0	0	0	215176	0	1043400	40229134		
52676	4379	1127433	1986-11-25	1986-11-25 00:00:00	1986-12-02	1986-12-02 00:00:00	1986-12-02	38000177		0	0	7		0	0	0	290940	0	313782	1127433		
9326	199	40213227	1992-04-08	1992-04-08 00:00:00	1992-04-08	1992-04-08 00:00:00	1992-04-08	581452		0	0	0		0	0	0	13691	0	113	40213227		
52784	4387	46233988	1968-04-02	1968-04-02 00:00:00	1968-04-16	1968-04-16 00:00:00	1968-04-16	38000177		0	0	14		0	0	0	291610	0	1652673	46233988		
186719	4102	40213227	2008-01-07	2008-01-07 00:00:00	2008-01-07	2008-01-07 00:00:00	2008-01-07	581452		0	0	0		0	0	0	272609	0	113	40213227		
12433	1046	19059056	1992-02-28	1992-02-28 00:00:00	1992-03-20	1992-03-20 00:00:00	1992-03-20	38000177		0	0	21		0	0	0	68699	0	243670	19059056		
98968	2167	40213296	2018-03-21	2018-03-21 00:00:00	2018-03-21	2018-03-21 00:00:00	2018-03-21	581452		0	0	0		0	0	0	144375	0	52	40213296		
22963	1892	19059056	1968-02-24	1968-02-24 00:00:00	1968-03-16	1968-03-16 00:00:00	1968-03-16	38000177		0	0	21		0	0	0	126045	0	243670	19059056		
29153	636	40213227	1999-05-28	1999-05-28 00:00:00	1999-05-28	1999-05-28 00:00:00	1999-05-28	581452		0	0	0		0	0	0	42125	0	113	40213227		
195255	4288	40213227	1993-02-20	1993-02-20 00:00:00	1993-02-20	1993-02-20 00:00:00	1993-02-20	581452		0	0	0		0	0	0	284732	0	113	40213227		
40352	879	40213160	1955-01-17	1955-01-17 00:00:00	1955-01-17	1955-01-17 00:00:00	1955-01-17	581452		0	0	0		0	0	0	58553	0	10	40213160		
17761	384	40213296	2000-06-05	2000-06-05 00:00:00	2000-06-05	2000-06-05 00:00:00	2000-06-05	581452		0	0	0		0	0	0	25303	0	52	40213296		
49546	1084	40213314	1978-04-14	1978-04-14 00:00:00	1978-04-14	1978-04-14 00:00:00	1978-04-14	581452		0	0	0		0	0	0	71185	0	49	40213314		
751	61	46233988	1969-12-23	1969-12-23 00:00:00	1970-01-06	1970-01-06 00:00:00	1970-01-06	38000177		0	0	14		0	0	0	4081	0	1652673	46233988		
1296	101	1127433	2000-06-24	2000-06-24 00:00:00	2000-07-29	2000-07-29 00:00:00	2000-07-29	38000177		0	0	35		0	0	0	6901	0	313782	1127433		
15381	332	40213160	1964-02-21	1964-02-21 00:00:00	1964-02-21	1964-02-21 00:00:00	1964-02-21	581452		0	0	0		0	0	0	21940	0	10	40213160		
200417	4401	40213306	1990-01-20	1990-01-20 00:00:00	1990-01-20	1990-01-20 00:00:00	1990-01-20	581452		0	0	0		0	0	0	292558	0	43	40213306		
2228	180	42902245	2002-02-19	2002-02-19 00:00:00	2003-02-14	2003-02-14 00:00:00	2003-02-14	38000177		0	0	360		0	0	0	12077	0	1359133	42902245		
38684	3196	46233988	1972-08-24	1972-08-24 00:00:00	1972-09-07	1972-09-07 00:00:00	1972-09-07	38000177		0	0	14		0	0	0	212622	0	1652673	46233988		
29452	2437	1127078	1964-08-21	1964-08-21 00:00:00	1964-09-04	1964-09-04 00:00:00	1964-09-04	38000177		0	0	14		0	0	0	161718	0	282464	1127078		
42197	3501	1127433	1993-04-02	1993-04-02 00:00:00	1993-04-24	1993-04-24 00:00:00	1993-04-24	38000177		0	0	22		0	0	0	232059	0	313782	1127433		
164370	3615	40213227	2010-11-03	2010-11-03 00:00:00	2010-11-03	2010-11-03 00:00:00	2010-11-03	581452		0	0	0		0	0	0	240168	0	113	40213227		
70504	1542	40213260	2016-10-26	2016-10-26 00:00:00	2016-10-26	2016-10-26 00:00:00	2016-10-26	581452		0	0	0		0	0	0	103355	0	121	40213260		
30428	2521	19006318	1949-01-13	1949-01-13 00:00:00	1949-01-27	1949-01-27 00:00:00	1949-01-27	38000177		0	0	14		0	0	0	166685	0	105078	19006318		
46660	3866	1127433	2003-07-06	2003-07-06 00:00:00	2003-07-27	2003-07-27 00:00:00	2003-07-27	38000177		0	0	21		0	0	0	256703	0	313782	1127433		
29790	2468	1127433	1998-07-21	1998-07-21 00:00:00	1998-07-28	1998-07-28 00:00:00	1998-07-28	38000177		0	0	7		0	0	0	163653	0	313782	1127433		
160318	3528	40213160	1963-07-08	1963-07-08 00:00:00	1963-07-08	1963-07-08 00:00:00	1963-07-08	581452		0	0	0		0	0	0	234197	0	10	40213160		
30846	672	40213160	1956-01-09	1956-01-09 00:00:00	1956-01-09	1956-01-09 00:00:00	1956-01-09	581452		0	0	0		0	0	0	44353	0	10	40213160		
35652	778	40213314	1978-04-27	1978-04-27 00:00:00	1978-04-27	1978-04-27 00:00:00	1978-04-27	581452		0	0	0		0	0	0	51653	0	49	40213314		
67922	1486	40213227	2016-11-20	2016-11-20 00:00:00	2016-11-20	2016-11-20 00:00:00	2016-11-20	581452		0	0	0		0	0	0	99045	0	113	40213227		
44678	3698	19059056	1963-04-02	1963-04-02 00:00:00	1963-04-30	1963-04-30 00:00:00	1963-04-30	38000177		0	0	28		0	0	0	245838	0	243670	19059056		
31741	2630	19133873	1972-12-23	1972-12-23 00:00:00	1973-01-04	1973-01-04 00:00:00	1973-01-04	38000177		0	0	12		0	0	0	174010	0	834061	19133873		
15739	1310	1127433	1954-07-27	1954-07-27 00:00:00	1954-08-10	1954-08-10 00:00:00	1954-08-10	38000177		0	0	14		0	0	0	86573	0	313782	1127433		
230505	5065	40213227	2001-02-27	2001-02-27 00:00:00	2001-02-27	2001-02-27 00:00:00	2001-02-27	581452		0	0	0		0	0	0	336743	0	113	40213227		
83644	1829	40213160	1972-06-13	1972-06-13 00:00:00	1972-06-13	1972-06-13 00:00:00	1972-06-13	581452		0	0	0		0	0	0	122291	0	10	40213160		
30998	2567	1118084	2014-02-01	2014-02-01 00:00:00	2014-02-01	2014-02-01 00:00:00	\N	38000177		0	0	0		0	0	0	170091	0	00025152531	44923712		
17677	1464	1713671	2004-09-05	2004-09-05 00:00:00	2004-09-12	2004-09-12 00:00:00	2004-09-12	38000177		0	0	7		0	0	0	97539	0	562251	1713671		
24521	2017	1127078	1974-05-04	1974-05-04 00:00:00	1974-05-18	1974-05-18 00:00:00	1974-05-18	38000177		0	0	14		0	0	0	134155	0	282464	1127078		
77798	1702	40213160	1965-07-12	1965-07-12 00:00:00	1965-07-12	1965-07-12 00:00:00	1965-07-12	581452		0	0	0		0	0	0	113778	0	10	40213160		
35070	2895	1127433	1968-01-31	1968-01-31 00:00:00	1968-02-07	1968-02-07 00:00:00	1968-02-07	38000177		0	0	7		0	0	0	192713	0	313782	1127433		
20741	1709	1115171	2004-04-08	2004-04-08 00:00:00	2004-05-06	2004-05-06 00:00:00	2004-05-06	38000177		0	0	28		0	0	0	114241	0	849574	1115171		
10751	893	1115171	1996-01-30	1996-01-30 00:00:00	1996-02-20	1996-02-20 00:00:00	1996-02-20	38000177		0	0	21		0	0	0	59535	0	849574	1115171		
18365	1520	1118084	1971-01-11	1971-01-11 00:00:00	1971-01-11	1971-01-11 00:00:00	\N	38000177		0	0	0		0	0	0	101689	0	00025152531	44923712		
35476	774	40213160	1967-04-02	1967-04-02 00:00:00	1967-04-02	1967-04-02 00:00:00	1967-04-02	581452		0	0	0		0	0	0	51355	0	10	40213160		
58105	4827	920300	1994-12-30	1994-12-30 00:00:00	1995-01-06	1995-01-06 00:00:00	1995-01-06	38000177		0	0	7		0	0	0	321225	0	311989	920300		
24318	1999	1127433	1981-03-08	1981-03-08 00:00:00	1981-03-22	1981-03-22 00:00:00	1981-03-22	38000177		0	0	14		0	0	0	133053	0	313782	1127433		
62899	5228	40162522	2013-08-30	2013-08-30 00:00:00	2013-08-30	2013-08-30 00:00:00	\N	38000177		0	0	0		0	0	0	347863	0	857005	40162522		
2458	196	19059056	1957-06-02	1957-06-02 00:00:00	1957-08-01	1957-08-01 00:00:00	1957-08-01	38000177		0	0	60		0	0	0	13448	0	243670	19059056		
27208	2244	1127433	1993-01-16	1993-01-16 00:00:00	1993-02-06	1993-02-06 00:00:00	1993-02-06	38000177		0	0	21		0	0	0	149384	0	313782	1127433		
35968	2960	1127433	2011-11-16	2011-11-16 00:00:00	2011-11-23	2011-11-23 00:00:00	2011-11-23	38000177		0	0	7		0	0	0	197687	0	313782	1127433		
32473	2692	19006318	1950-07-04	1950-07-04 00:00:00	1950-07-18	1950-07-18 00:00:00	1950-07-18	38000177		0	0	14		0	0	0	178330	0	105078	19006318		
17191	371	40213227	2001-01-04	2001-01-04 00:00:00	2001-01-04	2001-01-04 00:00:00	2001-01-04	581452		0	0	0		0	0	0	24689	0	113	40213227		
43006	3565	19059056	1957-11-19	1957-11-19 00:00:00	1957-12-24	1957-12-24 00:00:00	1957-12-24	38000177		0	0	35		0	0	0	236739	0	243670	19059056		
63004	5235	40171902	1981-12-12	1981-12-12 00:00:00	1981-12-12	1981-12-12 00:00:00	\N	38000177		0	0	0		0	0	0	348373	0	897718	40171902		
111045	2439	40213160	1972-08-23	1972-08-23 00:00:00	1972-08-23	1972-08-23 00:00:00	1972-08-23	581452		0	0	0		0	0	0	161816	0	10	40213160		
18259	1512	1127078	1979-11-04	1979-11-04 00:00:00	1979-11-18	1979-11-18 00:00:00	1979-11-18	38000177		0	0	14		0	0	0	100994	0	282464	1127078		
69897	1528	40213227	2010-01-15	2010-01-15 00:00:00	2010-01-15	2010-01-15 00:00:00	2010-01-15	581452		0	0	0		0	0	0	102281	0	113	40213227		
55576	1217	40213296	2012-12-07	2012-12-07 00:00:00	2012-12-07	2012-12-07 00:00:00	2012-12-07	581452		0	0	0		0	0	0	80133	0	52	40213296		
4963	411	1713671	1968-09-28	1968-09-28 00:00:00	1968-10-12	1968-10-12 00:00:00	1968-10-12	38000177		0	0	14		0	0	0	27307	0	562251	1713671		
3857	320	1127433	1995-08-08	1995-08-08 00:00:00	1995-08-29	1995-08-29 00:00:00	1995-08-29	38000177		0	0	21		0	0	0	21237	0	313782	1127433		
15536	1294	1127433	1989-11-19	1989-11-19 00:00:00	1989-12-03	1989-12-03 00:00:00	1989-12-03	38000177		0	0	14		0	0	0	85612	0	313782	1127433		
24190	1989	19078461	2010-07-20	2010-07-20 00:00:00	2010-08-10	2010-08-10 00:00:00	2010-08-10	38000177		0	0	21		0	0	0	132442	0	310965	19078461		
46205	3827	19059056	1960-11-27	1960-11-27 00:00:00	1960-12-11	1960-12-11 00:00:00	1960-12-11	38000177		0	0	14		0	0	0	254178	0	243670	19059056		
242162	5317	40213227	1995-02-15	1995-02-15 00:00:00	1995-02-15	1995-02-15 00:00:00	1995-02-15	581452		0	0	0		0	0	0	353634	0	113	40213227		
39180	3237	19133873	1928-06-05	1928-06-05 00:00:00	1928-06-17	1928-06-17 00:00:00	1928-06-17	38000177		0	0	12		0	0	0	215217	0	834061	19133873		
52677	4379	1127433	1985-12-29	1985-12-29 00:00:00	1986-01-05	1986-01-05 00:00:00	1986-01-05	38000177		0	0	7		0	0	0	290939	0	313782	1127433		
7989	669	1127433	2018-11-07	2018-11-07 00:00:00	2018-11-14	2018-11-14 00:00:00	2018-11-14	38000177		0	0	7		0	0	0	44170	0	313782	1127433		
52785	4387	19059056	1993-05-26	1993-05-26 00:00:00	1993-06-09	1993-06-09 00:00:00	1993-06-09	38000177		0	0	14		0	0	0	291620	0	243670	19059056		
186720	4102	40213296	2008-01-07	2008-01-07 00:00:00	2008-01-07	2008-01-07 00:00:00	2008-01-07	581452		0	0	0		0	0	0	272609	0	52	40213296		
12434	1046	1713671	1989-09-29	1989-09-29 00:00:00	1989-10-20	1989-10-20 00:00:00	1989-10-20	38000177		0	0	21		0	0	0	68702	0	562251	1713671		
98974	2167	40213160	1978-11-22	1978-11-22 00:00:00	1978-11-22	1978-11-22 00:00:00	1978-11-22	581452		0	0	0		0	0	0	144393	0	10	40213160		
22965	1892	19133905	1999-10-29	1999-10-29 00:00:00	1999-11-06	1999-11-06 00:00:00	1999-11-06	38000177		0	0	8		0	0	0	125991	0	834102	19133905		
29163	636	40213227	2009-07-24	2009-07-24 00:00:00	2009-07-24	2009-07-24 00:00:00	2009-07-24	581452		0	0	0		0	0	0	42166	0	113	40213227		
195262	4289	40213227	1994-07-24	1994-07-24 00:00:00	1994-07-24	1994-07-24 00:00:00	1994-07-24	581452		0	0	0		0	0	0	284781	0	113	40213227		
40357	879	40213260	2006-03-06	2006-03-06 00:00:00	2006-03-06	2006-03-06 00:00:00	2006-03-06	581452		0	0	0		0	0	0	58542	0	121	40213260		
17766	384	40213227	2012-03-05	2012-03-05 00:00:00	2012-03-05	2012-03-05 00:00:00	2012-03-05	581452		0	0	0		0	0	0	25325	0	113	40213227		
49547	1084	40213160	1978-04-14	1978-04-14 00:00:00	1978-04-14	1978-04-14 00:00:00	1978-04-14	581452		0	0	0		0	0	0	71185	0	10	40213160		
752	61	1127433	1983-12-03	1983-12-03 00:00:00	1984-01-07	1984-01-07 00:00:00	1984-01-07	38000177		0	0	35		0	0	0	4160	0	313782	1127433		
1297	101	19059056	1960-04-29	1960-04-29 00:00:00	1960-05-13	1960-05-13 00:00:00	1960-05-13	38000177		0	0	14		0	0	0	6896	0	243670	19059056		
15382	332	40213160	1963-09-20	1963-09-20 00:00:00	1963-09-20	1963-09-20 00:00:00	1963-09-20	581452		0	0	0		0	0	0	22025	0	10	40213160		
200421	4401	40213296	2009-12-26	2009-12-26 00:00:00	2009-12-26	2009-12-26 00:00:00	2009-12-26	581452		0	0	0		0	0	0	292560	0	52	40213296		
2229	180	19133873	1980-01-07	1980-01-07 00:00:00	1980-01-16	1980-01-16 00:00:00	1980-01-16	38000177		0	0	9		0	0	0	12151	0	834061	19133873		
38685	3196	1127078	1972-08-24	1972-08-24 00:00:00	1972-09-07	1972-09-07 00:00:00	1972-09-07	38000177		0	0	14		0	0	0	212622	0	282464	1127078		
29453	2437	19129655	1964-08-21	1964-08-21 00:00:00	1964-09-04	1964-09-04 00:00:00	1964-09-04	38000177		0	0	14		0	0	0	161718	0	789980	19129655		
42198	3501	1115171	1994-03-19	1994-03-19 00:00:00	1994-06-18	1994-06-18 00:00:00	1994-06-18	38000177		0	0	91		0	0	0	232060	0	849574	1115171		
164381	3615	40213198	2015-02-04	2015-02-04 00:00:00	2015-02-04	2015-02-04 00:00:00	2015-02-04	581452		0	0	0		0	0	0	240196	0	133	40213198		
70506	1542	40213227	2007-01-31	2007-01-31 00:00:00	2007-01-31	2007-01-31 00:00:00	2007-01-31	581452		0	0	0		0	0	0	103365	0	113	40213227		
30429	2522	1127078	1961-05-26	1961-05-26 00:00:00	1961-06-23	1961-06-23 00:00:00	1961-06-23	38000177		0	0	28		0	0	0	166786	0	282464	1127078		
46661	3866	19133905	1973-07-12	1973-07-12 00:00:00	1973-07-25	1973-07-25 00:00:00	1973-07-25	38000177		0	0	13		0	0	0	256685	0	834102	19133905		
29791	2468	19133905	1972-09-18	1972-09-18 00:00:00	1972-09-26	1972-09-26 00:00:00	1972-09-26	38000177		0	0	8		0	0	0	163652	0	834102	19133905		
160324	3528	40213227	2009-11-09	2009-11-09 00:00:00	2009-11-09	2009-11-09 00:00:00	2009-11-09	581452		0	0	0		0	0	0	234276	0	113	40213227		
30849	672	40213227	2006-12-04	2006-12-04 00:00:00	2006-12-04	2006-12-04 00:00:00	2006-12-04	581452		0	0	0		0	0	0	44381	0	113	40213227		
35653	778	40213160	1978-04-27	1978-04-27 00:00:00	1978-04-27	1978-04-27 00:00:00	1978-04-27	581452		0	0	0		0	0	0	51653	0	10	40213160		
67930	1486	40213227	1996-08-25	1996-08-25 00:00:00	1996-08-25	1996-08-25 00:00:00	1996-08-25	581452		0	0	0		0	0	0	99050	0	113	40213227		
44679	3698	40229134	1989-05-05	1989-05-05 00:00:00	1989-05-12	1989-05-12 00:00:00	1989-05-12	38000177		0	0	7		0	0	0	245829	0	1043400	40229134		
31742	2630	1127433	1992-07-29	1992-07-29 00:00:00	1992-08-12	1992-08-12 00:00:00	1992-08-12	38000177		0	0	14		0	0	0	174029	0	313782	1127433		
15740	1310	19075001	2013-10-10	2013-10-10 00:00:00	2013-10-24	2013-10-24 00:00:00	2013-10-24	38000177		0	0	14		0	0	0	86625	0	309097	19075001		
230509	5065	40213160	1974-01-22	1974-01-22 00:00:00	1974-01-22	1974-01-22 00:00:00	1974-01-22	581452		0	0	0		0	0	0	336714	0	10	40213160		
83660	1829	40213160	1968-03-12	1968-03-12 00:00:00	1968-03-12	1968-03-12 00:00:00	1968-03-12	581452		0	0	0		0	0	0	122308	0	10	40213160		
30999	2567	1127433	2018-01-10	2018-01-10 00:00:00	2018-01-17	2018-01-17 00:00:00	2018-01-17	38000177		0	0	7		0	0	0	170078	0	313782	1127433		
17678	1464	1127433	1963-02-15	1963-02-15 00:00:00	1963-02-22	1963-02-22 00:00:00	1963-02-22	38000177		0	0	7		0	0	0	97510	0	313782	1127433		
24531	2020	40224805	1994-09-05	1994-09-05 00:00:00	1995-08-31	1995-08-31 00:00:00	1995-08-31	38000177		0	0	360		0	0	0	134285	0	1000126	40224805		
77808	1702	40213227	2015-11-08	2015-11-08 00:00:00	2015-11-08	2015-11-08 00:00:00	2015-11-08	581452		0	0	0		0	0	0	113790	0	113	40213227		
35071	2895	1127433	2000-03-21	2000-03-21 00:00:00	2000-04-04	2000-04-04 00:00:00	2000-04-04	38000177		0	0	14		0	0	0	192739	0	313782	1127433		
20742	1709	19059056	1953-10-16	1953-10-16 00:00:00	1953-11-20	1953-11-20 00:00:00	1953-11-20	38000177		0	0	35		0	0	0	114222	0	243670	19059056		
35133	2898	19133873	1991-09-27	1991-09-27 00:00:00	1991-10-05	1991-10-05 00:00:00	1991-10-05	38000177		0	0	8		0	0	0	193067	0	834061	19133873		
18366	1520	19078461	2010-10-17	2010-10-17 00:00:00	2010-12-16	2010-12-16 00:00:00	2010-12-16	38000177		0	0	60		0	0	0	101711	0	310965	19078461		
35477	774	40213160	1966-10-30	1966-10-30 00:00:00	1966-10-30	1966-10-30 00:00:00	1966-10-30	581452		0	0	0		0	0	0	51354	0	10	40213160		
58106	4827	40236824	1994-12-30	1994-12-30 00:00:00	1995-01-06	1995-01-06 00:00:00	1995-01-06	38000177		0	0	7		0	0	0	321225	0	1094107	40236824		
24319	1999	1124300	2017-02-05	2017-02-05 00:00:00	2017-02-05	2017-02-05 00:00:00	\N	38000177		0	0	0		0	0	0	133128	0	00781178901	45011828		
62900	5228	19078461	2013-08-30	2013-08-30 00:00:00	2013-09-29	2013-09-29 00:00:00	2013-09-29	38000177		0	0	30		0	0	0	347863	0	310965	19078461		
2460	196	19059056	1970-12-21	1970-12-21 00:00:00	1971-01-25	1971-01-25 00:00:00	1971-01-25	38000177		0	0	35		0	0	0	13450	0	243670	19059056		
27209	2244	1118084	1993-09-27	1993-09-27 00:00:00	1993-09-27	1993-09-27 00:00:00	\N	38000177		0	0	0		0	0	0	149457	0	00025152531	44923712		
35969	2960	19133873	1955-03-07	1955-03-07 00:00:00	1955-03-14	1955-03-14 00:00:00	1955-03-14	38000177		0	0	7		0	0	0	197611	0	834061	19133873		
32474	2692	1127078	1950-07-04	1950-07-04 00:00:00	1950-07-18	1950-07-18 00:00:00	1950-07-18	38000177		0	0	14		0	0	0	178330	0	282464	1127078		
17194	371	40213306	1991-12-26	1991-12-26 00:00:00	1991-12-26	1991-12-26 00:00:00	1991-12-26	581452		0	0	0		0	0	0	24686	0	43	40213306		
43007	3565	19133873	1947-12-17	1947-12-17 00:00:00	1947-12-30	1947-12-30 00:00:00	1947-12-30	38000177		0	0	13		0	0	0	236725	0	834061	19133873		
63005	5235	1713671	1961-10-08	1961-10-08 00:00:00	1961-10-15	1961-10-15 00:00:00	1961-10-15	38000177		0	0	7		0	0	0	348324	0	562251	1713671		
111049	2439	40213160	1972-10-25	1972-10-25 00:00:00	1972-10-25	1972-10-25 00:00:00	1972-10-25	581452		0	0	0		0	0	0	161789	0	10	40213160		
18260	1512	19133873	1987-10-03	1987-10-03 00:00:00	1987-10-16	1987-10-16 00:00:00	1987-10-16	38000177		0	0	13		0	0	0	100953	0	834061	19133873		
69898	1528	40213260	2010-01-15	2010-01-15 00:00:00	2010-01-15	2010-01-15 00:00:00	2010-01-15	581452		0	0	0		0	0	0	102281	0	121	40213260		
28792	2380	1127433	1950-06-28	1950-06-28 00:00:00	1950-07-12	1950-07-12 00:00:00	1950-07-12	38000177		0	0	14		0	0	0	158225	0	313782	1127433		
4964	411	19133905	1995-11-07	1995-11-07 00:00:00	1995-11-19	1995-11-19 00:00:00	1995-11-19	38000177		0	0	12		0	0	0	27336	0	834102	19133905		
3858	320	1118084	1995-08-28	1995-08-28 00:00:00	1995-08-28	1995-08-28 00:00:00	\N	38000177		0	0	0		0	0	0	21237	0	00025152531	44923712		
15537	1294	1118084	2011-03-29	2011-03-29 00:00:00	2011-03-29	2011-03-29 00:00:00	\N	38000177		0	0	0		0	0	0	85636	0	00025152531	44923712		
24191	1989	1127433	1988-10-22	1988-10-22 00:00:00	1988-11-28	1988-11-28 00:00:00	1988-11-28	38000177		0	0	37		0	0	0	132479	0	313782	1127433		
46207	3827	19078461	1998-07-19	1998-07-19 00:00:00	1998-08-23	1998-08-23 00:00:00	1998-08-23	38000177		0	0	35		0	0	0	254190	0	310965	19078461		
242169	5317	40213296	2014-09-17	2014-09-17 00:00:00	2014-09-17	2014-09-17 00:00:00	2014-09-17	581452		0	0	0		0	0	0	353668	0	52	40213296		
39181	3237	1127433	2012-02-19	2012-02-19 00:00:00	2012-03-11	2012-03-11 00:00:00	2012-03-11	38000177		0	0	21		0	0	0	215155	0	313782	1127433		
52678	4379	1118084	2007-11-30	2007-11-30 00:00:00	2007-11-30	2007-11-30 00:00:00	\N	38000177		0	0	0		0	0	0	290965	0	00025152531	44923712		
7990	669	19128065	1987-09-07	1987-09-07 00:00:00	1988-09-01	1988-09-01 00:00:00	1988-09-01	38000177		0	0	360		0	0	0	44144	0	749882	19128065		
52786	4387	1127433	2002-08-04	2002-08-04 00:00:00	2002-08-11	2002-08-11 00:00:00	2002-08-11	38000177		0	0	7		0	0	0	291603	0	313782	1127433		
186723	4102	40213160	1969-10-06	1969-10-06 00:00:00	1969-10-06	1969-10-06 00:00:00	1969-10-06	581452		0	0	0		0	0	0	272584	0	10	40213160		
51963	4320	19059056	1979-07-10	1979-07-10 00:00:00	1979-07-24	1979-07-24 00:00:00	1979-07-24	38000177		0	0	14		0	0	0	286670	0	243670	19059056		
63176	1382	40213296	2019-06-26	2019-06-26 00:00:00	2019-06-26	2019-06-26 00:00:00	2019-06-26	581452		0	0	0		0	0	0	91668	0	52	40213296		
22966	1892	19059056	1964-07-23	1964-07-23 00:00:00	1964-08-06	1964-08-06 00:00:00	1964-08-06	38000177		0	0	14		0	0	0	125977	0	243670	19059056		
63982	1399	40213296	2000-07-05	2000-07-05 00:00:00	2000-07-05	2000-07-05 00:00:00	2000-07-05	581452		0	0	0		0	0	0	93050	0	52	40213296		
40474	882	40213201	2011-05-28	2011-05-28 00:00:00	2011-05-28	2011-05-28 00:00:00	2011-05-28	581452		0	0	0		0	0	0	58747	0	33	40213201		
40372	879	40213227	1994-12-05	1994-12-05 00:00:00	1994-12-05	1994-12-05 00:00:00	1994-12-05	581452		0	0	0		0	0	0	58599	0	113	40213227		
122737	2698	40213227	2014-06-04	2014-06-04 00:00:00	2014-06-04	2014-06-04 00:00:00	2014-06-04	581452		0	0	0		0	0	0	178668	0	113	40213227		
49548	1084	40213251	1984-12-28	1984-12-28 00:00:00	1984-12-28	1984-12-28 00:00:00	1984-12-28	581452		0	0	0		0	0	0	71225	0	21	40213251		
753	61	19059056	1968-08-18	1968-08-18 00:00:00	1968-09-01	1968-09-01 00:00:00	1968-09-01	38000177		0	0	14		0	0	0	4080	0	243670	19059056		
1298	101	19006318	1960-04-29	1960-04-29 00:00:00	1960-05-13	1960-05-13 00:00:00	1960-05-13	38000177		0	0	14		0	0	0	6896	0	105078	19006318		
15387	332	40213227	1994-08-26	1994-08-26 00:00:00	1994-08-26	1994-08-26 00:00:00	1994-08-26	581452		0	0	0		0	0	0	21897	0	113	40213227		
200424	4401	40213227	1993-01-23	1993-01-23 00:00:00	1993-01-23	1993-01-23 00:00:00	1993-01-23	581452		0	0	0		0	0	0	292583	0	113	40213227		
2230	180	19128022	1992-04-12	1992-04-12 00:00:00	1993-04-07	1993-04-07 00:00:00	1993-04-07	38000177		0	0	360		0	0	0	12097	0	749785	19128022		
38686	3196	1127433	1995-10-31	1995-10-31 00:00:00	1995-11-07	1995-11-07 00:00:00	1995-11-07	38000177		0	0	7		0	0	0	212629	0	313782	1127433		
29454	2438	1118084	2016-08-27	2016-08-27 00:00:00	2016-08-27	2016-08-27 00:00:00	\N	38000177		0	0	0		0	0	0	161773	0	00025152531	44923712		
42199	3501	1713671	1956-04-26	1956-04-26 00:00:00	1956-05-11	1956-05-11 00:00:00	1956-05-11	38000177		0	0	15		0	0	0	232065	0	562251	1713671		
164386	3615	40213201	2016-02-10	2016-02-10 00:00:00	2016-02-10	2016-02-10 00:00:00	2016-02-10	581452		0	0	0		0	0	0	240210	0	33	40213201		
70507	1542	40213296	2007-01-31	2007-01-31 00:00:00	2007-01-31	2007-01-31 00:00:00	2007-01-31	581452		0	0	0		0	0	0	103365	0	52	40213296		
30430	2522	1127433	2009-07-07	2009-07-07 00:00:00	2009-07-21	2009-07-21 00:00:00	2009-07-21	38000177		0	0	14		0	0	0	166790	0	313782	1127433		
46662	3866	1118084	1990-02-18	1990-02-18 00:00:00	1990-02-18	1990-02-18 00:00:00	\N	38000177		0	0	0		0	0	0	256706	0	00025152531	44923712		
29792	2468	1127433	1959-01-09	1959-01-09 00:00:00	1959-01-23	1959-01-23 00:00:00	1959-01-23	38000177		0	0	14		0	0	0	163602	0	313782	1127433		
160326	3528	40213260	2009-11-09	2009-11-09 00:00:00	2009-11-09	2009-11-09 00:00:00	2009-11-09	581452		0	0	0		0	0	0	234276	0	121	40213260		
30850	672	40213260	2006-12-04	2006-12-04 00:00:00	2006-12-04	2006-12-04 00:00:00	2006-12-04	581452		0	0	0		0	0	0	44381	0	121	40213260		
8344	180	40213296	2019-05-02	2019-05-02 00:00:00	2019-05-02	2019-05-02 00:00:00	2019-05-02	581452		0	0	0		0	0	0	12120	0	52	40213296		
67931	1486	40213296	1996-08-25	1996-08-25 00:00:00	1996-08-25	1996-08-25 00:00:00	1996-08-25	581452		0	0	0		0	0	0	99050	0	52	40213296		
44680	3698	19006318	1952-10-26	1952-10-26 00:00:00	1952-11-09	1952-11-09 00:00:00	1952-11-09	38000177		0	0	14		0	0	0	245878	0	105078	19006318		
31743	2630	1713671	2005-11-04	2005-11-04 00:00:00	2005-11-25	2005-11-25 00:00:00	2005-11-25	38000177		0	0	21		0	0	0	173951	0	562251	1713671		
15741	1310	1115171	2013-10-10	2013-10-10 00:00:00	2013-10-24	2013-10-24 00:00:00	2013-10-24	38000177		0	0	14		0	0	0	86625	0	849574	1115171		
230521	5066	40213260	2017-04-08	2017-04-08 00:00:00	2017-04-08	2017-04-08 00:00:00	2017-04-08	581452		0	0	0		0	0	0	336786	0	121	40213260		
83663	1829	40213260	2017-08-22	2017-08-22 00:00:00	2017-08-22	2017-08-22 00:00:00	2017-08-22	581452		0	0	0		0	0	0	122289	0	121	40213260		
31007	2570	1713671	1936-07-24	1936-07-24 00:00:00	1936-08-07	1936-08-07 00:00:00	1936-08-07	38000177		0	0	14		0	0	0	170177	0	562251	1713671		
17679	1464	1127433	2018-11-09	2018-11-09 00:00:00	2018-11-16	2018-11-16 00:00:00	2018-11-16	38000177		0	0	7		0	0	0	97552	0	313782	1127433		
24532	2020	19128065	1984-10-27	1984-10-27 00:00:00	1985-10-22	1985-10-22 00:00:00	1985-10-22	38000177		0	0	360		0	0	0	134248	0	749882	19128065		
77809	1702	40213260	2015-11-08	2015-11-08 00:00:00	2015-11-08	2015-11-08 00:00:00	2015-11-08	581452		0	0	0		0	0	0	113790	0	121	40213260		
35072	2895	1713671	1963-02-22	1963-02-22 00:00:00	1963-03-01	1963-03-01 00:00:00	1963-03-01	38000177		0	0	7		0	0	0	192690	0	562251	1713671		
20743	1709	1713671	1953-07-31	1953-07-31 00:00:00	1953-08-14	1953-08-14 00:00:00	1953-08-14	38000177		0	0	14		0	0	0	114297	0	562251	1713671		
35134	2898	19019979	1979-09-13	1979-09-13 00:00:00	1979-09-27	1979-09-27 00:00:00	1979-09-27	38000177		0	0	14		0	0	0	193073	0	198405	19019979		
18367	1520	40229134	1963-05-04	1963-05-04 00:00:00	1963-05-11	1963-05-11 00:00:00	1963-05-11	38000177		0	0	7		0	0	0	101632	0	1043400	40229134		
79803	1746	40213296	1996-11-28	1996-11-28 00:00:00	1996-11-28	1996-11-28 00:00:00	1996-11-28	581452		0	0	0		0	0	0	116735	0	52	40213296		
58108	4827	19006318	1954-04-16	1954-04-16 00:00:00	1954-04-30	1954-04-30 00:00:00	1954-04-30	38000177		0	0	14		0	0	0	321098	0	105078	19006318		
24320	1999	1594382	2011-10-05	2011-10-05 00:00:00	2011-10-05	2011-10-05 00:00:00	\N	38000177		0	0	0		0	0	0	133114	0	1870230	1594382		
62901	5228	1127433	1958-08-10	1958-08-10 00:00:00	1958-08-17	1958-08-17 00:00:00	1958-08-17	38000177		0	0	7		0	0	0	347775	0	313782	1127433		
2461	196	1118084	2000-09-19	2000-09-19 00:00:00	2000-09-19	2000-09-19 00:00:00	\N	38000177		0	0	0		0	0	0	13502	0	00025152531	44923712		
27210	2244	19018935	2017-10-13	2017-10-13 00:00:00	2017-10-13	2017-10-13 00:00:00	\N	38000177		0	0	0		0	0	0	149422	0	197604	19018935		
35970	2960	1127433	1993-02-11	1993-02-11 00:00:00	1993-02-25	1993-02-25 00:00:00	1993-02-25	38000177		0	0	14		0	0	0	197608	0	313782	1127433		
32475	2692	19133768	1998-06-29	1998-06-29 00:00:00	1998-06-29	1998-06-29 00:00:00	1998-06-29	38000177		0	0	0		0	0	0	178364	0	833036	19133768		
17196	371	40213306	1991-12-19	1991-12-19 00:00:00	1991-12-19	1991-12-19 00:00:00	1991-12-19	581452		0	0	0		0	0	0	\N	0	43	40213306		
43008	3565	1127433	1973-11-30	1973-11-30 00:00:00	1973-12-14	1973-12-14 00:00:00	1973-12-14	38000177		0	0	14		0	0	0	236740	0	313782	1127433		
63006	5235	19059056	1940-03-02	1940-03-02 00:00:00	1940-03-16	1940-03-16 00:00:00	1940-03-16	38000177		0	0	14		0	0	0	348356	0	243670	19059056		
24516	533	40213160	1967-07-12	1967-07-12 00:00:00	1967-07-12	1967-07-12 00:00:00	1967-07-12	581452		0	0	0		0	0	0	35466	0	10	40213160		
28731	2372	40229134	1998-10-30	1998-10-30 00:00:00	1998-11-13	1998-11-13 00:00:00	1998-11-13	38000177		0	0	14		0	0	0	157868	0	1043400	40229134		
69900	1528	40213227	1993-06-04	1993-06-04 00:00:00	1993-06-04	1993-06-04 00:00:00	1993-06-04	581452		0	0	0		0	0	0	102255	0	113	40213227		
28793	2380	1127433	1994-03-18	1994-03-18 00:00:00	1994-03-25	1994-03-25 00:00:00	1994-03-25	38000177		0	0	7		0	0	0	158228	0	313782	1127433		
4965	411	1127433	1981-12-24	1981-12-24 00:00:00	1981-12-31	1981-12-31 00:00:00	1981-12-31	38000177		0	0	7		0	0	0	27269	0	313782	1127433		
3859	320	1127433	1961-02-23	1961-02-23 00:00:00	1961-03-09	1961-03-09 00:00:00	1961-03-09	38000177		0	0	14		0	0	0	21228	0	313782	1127433		
15538	1294	1127433	1997-04-11	1997-04-11 00:00:00	1997-04-18	1997-04-18 00:00:00	1997-04-18	38000177		0	0	7		0	0	0	85651	0	313782	1127433		
24192	1989	920300	1997-03-13	1997-03-13 00:00:00	1997-03-20	1997-03-20 00:00:00	1997-03-20	38000177		0	0	7		0	0	0	132446	0	311989	920300		
46208	3827	1127433	1961-07-31	1961-07-31 00:00:00	1961-08-07	1961-08-07 00:00:00	1961-08-07	38000177		0	0	7		0	0	0	254156	0	313782	1127433		
242172	5317	40213227	2014-09-17	2014-09-17 00:00:00	2014-09-17	2014-09-17 00:00:00	2014-09-17	581452		0	0	0		0	0	0	353668	0	113	40213227		
39182	3237	1713671	1950-03-05	1950-03-05 00:00:00	1950-03-26	1950-03-26 00:00:00	1950-03-26	38000177		0	0	21		0	0	0	215187	0	562251	1713671		
52679	4379	1127078	1974-11-18	1974-11-18 00:00:00	1974-12-02	1974-12-02 00:00:00	1974-12-02	38000177		0	0	14		0	0	0	290975	0	282464	1127078		
7991	669	1127433	1996-01-13	1996-01-13 00:00:00	1996-01-27	1996-01-27 00:00:00	1996-01-27	38000177		0	0	14		0	0	0	44196	0	313782	1127433		
52787	4387	1713671	2018-03-27	2018-03-27 00:00:00	2018-04-03	2018-04-03 00:00:00	2018-04-03	38000177		0	0	7		0	0	0	291609	0	562251	1713671		
78358	1715	40213260	2007-12-08	2007-12-08 00:00:00	2007-12-08	2007-12-08 00:00:00	2007-12-08	581452		0	0	0		0	0	0	114595	0	121	40213260		
51964	4320	19128065	1984-03-25	1984-03-25 00:00:00	1985-03-20	1985-03-20 00:00:00	1985-03-20	38000177		0	0	360		0	0	0	286686	0	749882	19128065		
63178	1382	40213227	2019-06-26	2019-06-26 00:00:00	2019-06-26	2019-06-26 00:00:00	2019-06-26	581452		0	0	0		0	0	0	91668	0	113	40213227		
22967	1892	19129655	1964-07-23	1964-07-23 00:00:00	1964-08-06	1964-08-06 00:00:00	1964-08-06	38000177		0	0	14		0	0	0	125977	0	789980	19129655		
63985	1399	40213306	1982-08-25	1982-08-25 00:00:00	1982-08-25	1982-08-25 00:00:00	1982-08-25	581452		0	0	0		0	0	0	93064	0	43	40213306		
40477	882	40213198	2010-05-22	2010-05-22 00:00:00	2010-05-22	2010-05-22 00:00:00	2010-05-22	581452		0	0	0		0	0	0	58701	0	133	40213198		
40374	879	40213160	1955-07-18	1955-07-18 00:00:00	1955-07-18	1955-07-18 00:00:00	1955-07-18	581452		0	0	0		0	0	0	58587	0	10	40213160		
122740	2698	40213314	1984-06-13	1984-06-13 00:00:00	1984-06-13	1984-06-13 00:00:00	1984-06-13	581452		0	0	0		0	0	0	178658	0	49	40213314		
49554	1085	40213296	2005-01-08	2005-01-08 00:00:00	2005-01-08	2005-01-08 00:00:00	2005-01-08	581452		0	0	0		0	0	0	71247	0	52	40213296		
754	61	19059056	1974-03-20	1974-03-20 00:00:00	1974-04-24	1974-04-24 00:00:00	1974-04-24	38000177		0	0	35		0	0	0	4181	0	243670	19059056		
1299	101	40162522	1960-04-29	1960-04-29 00:00:00	1960-04-29	1960-04-29 00:00:00	\N	38000177		0	0	0		0	0	0	6896	0	857005	40162522		
15394	332	40213296	2003-06-20	2003-06-20 00:00:00	2003-06-20	2003-06-20 00:00:00	2003-06-20	581452		0	0	0		0	0	0	21980	0	52	40213296		
200425	4401	40213306	1993-01-23	1993-01-23 00:00:00	1993-01-23	1993-01-23 00:00:00	1993-01-23	581452		0	0	0		0	0	0	292583	0	43	40213306		
2231	180	42902245	1998-03-12	1998-03-12 00:00:00	1999-03-07	1999-03-07 00:00:00	1999-03-07	38000177		0	0	360		0	0	0	12094	0	1359133	42902245		
38687	3196	19133905	2011-01-10	2011-01-10 00:00:00	2011-01-19	2011-01-19 00:00:00	2011-01-19	38000177		0	0	9		0	0	0	212617	0	834102	19133905		
29455	2438	19133873	1981-12-15	1981-12-15 00:00:00	1981-12-25	1981-12-25 00:00:00	1981-12-25	38000177		0	0	10		0	0	0	161767	0	834061	19133873		
42200	3501	19059056	1950-06-22	1950-06-22 00:00:00	1950-07-06	1950-07-06 00:00:00	1950-07-06	38000177		0	0	14		0	0	0	232085	0	243670	19059056		
164389	3615	40213227	1993-07-14	1993-07-14 00:00:00	1993-07-14	1993-07-14 00:00:00	1993-07-14	581452		0	0	0		0	0	0	240156	0	113	40213227		
70508	1542	40213227	1999-01-20	1999-01-20 00:00:00	1999-01-20	1999-01-20 00:00:00	1999-01-20	581452		0	0	0		0	0	0	103315	0	113	40213227		
30431	2522	1127433	1985-02-17	1985-02-17 00:00:00	1985-03-24	1985-03-24 00:00:00	1985-03-24	38000177		0	0	35		0	0	0	166787	0	313782	1127433		
46663	3866	1127433	2009-12-03	2009-12-03 00:00:00	2009-12-10	2009-12-10 00:00:00	2009-12-10	38000177		0	0	7		0	0	0	256736	0	313782	1127433		
29793	2468	19133873	1941-09-23	1941-09-23 00:00:00	1941-10-05	1941-10-05 00:00:00	1941-10-05	38000177		0	0	12		0	0	0	163662	0	834061	19133873		
160327	3528	40213260	2008-11-03	2008-11-03 00:00:00	2008-11-03	2008-11-03 00:00:00	2008-11-03	581452		0	0	0		0	0	0	234162	0	121	40213260		
30860	673	40213296	2003-03-07	2003-03-07 00:00:00	2003-03-07	2003-03-07 00:00:00	2003-03-07	581452		0	0	0		0	0	0	44450	0	52	40213296		
8346	180	40213227	2019-05-02	2019-05-02 00:00:00	2019-05-02	2019-05-02 00:00:00	2019-05-02	581452		0	0	0		0	0	0	12120	0	113	40213227		
228701	5023	40213160	1973-04-15	1973-04-15 00:00:00	1973-04-15	1973-04-15 00:00:00	1973-04-15	581452		0	0	0		0	0	0	333782	0	10	40213160		
44681	3698	1127078	1952-10-26	1952-10-26 00:00:00	1952-11-09	1952-11-09 00:00:00	1952-11-09	38000177		0	0	14		0	0	0	245878	0	282464	1127078		
31744	2631	40229134	1991-10-20	1991-10-20 00:00:00	1991-11-03	1991-11-03 00:00:00	1991-11-03	38000177		0	0	14		0	0	0	174102	0	1043400	40229134		
15742	1310	1118084	1980-07-09	1980-07-09 00:00:00	1980-07-09	1980-07-09 00:00:00	\N	38000177		0	0	0		0	0	0	86671	0	00025152531	44923712		
230525	5066	40213296	2009-04-18	2009-04-18 00:00:00	2009-04-18	2009-04-18 00:00:00	2009-04-18	581452		0	0	0		0	0	0	336797	0	52	40213296		
83665	1829	40213227	1999-05-04	1999-05-04 00:00:00	1999-05-04	1999-05-04 00:00:00	1999-05-04	581452		0	0	0		0	0	0	122296	0	113	40213227		
31008	2570	40229134	1954-02-23	1954-02-23 00:00:00	1954-03-09	1954-03-09 00:00:00	1954-03-09	38000177		0	0	14		0	0	0	170178	0	1043400	40229134		
17680	1464	1713671	1986-02-18	1986-02-18 00:00:00	1986-03-11	1986-03-11 00:00:00	1986-03-11	38000177		0	0	21		0	0	0	97534	0	562251	1713671		
24533	2020	19128065	1988-10-06	1988-10-06 00:00:00	1989-10-01	1989-10-01 00:00:00	1989-10-01	38000177		0	0	360		0	0	0	134292	0	749882	19128065		
77818	1702	40213160	1969-10-13	1969-10-13 00:00:00	1969-10-13	1969-10-13 00:00:00	1969-10-13	581452		0	0	0		0	0	0	113839	0	10	40213160		
35073	2895	19059056	1961-11-01	1961-11-01 00:00:00	1961-11-15	1961-11-15 00:00:00	1961-11-15	38000177		0	0	14		0	0	0	192715	0	243670	19059056		
20744	1709	19059056	1948-10-14	1948-10-14 00:00:00	1948-11-11	1948-11-11 00:00:00	1948-11-11	38000177		0	0	28		0	0	0	114219	0	243670	19059056		
35135	2898	19073183	1979-09-13	1979-09-13 00:00:00	1979-09-27	1979-09-27 00:00:00	1979-09-27	38000177		0	0	14		0	0	0	193073	0	308182	19073183		
18368	1520	1127433	1963-06-28	1963-06-28 00:00:00	1963-07-26	1963-07-26 00:00:00	1963-07-26	38000177		0	0	28		0	0	0	101709	0	313782	1127433		
79806	1746	40213201	2019-05-02	2019-05-02 00:00:00	2019-05-02	2019-05-02 00:00:00	2019-05-02	581452		0	0	0		0	0	0	116809	0	33	40213201		
58109	4827	19059056	1954-04-16	1954-04-16 00:00:00	1954-04-30	1954-04-30 00:00:00	1954-04-30	38000177		0	0	14		0	0	0	321098	0	243670	19059056		
24321	1999	40228214	2011-10-05	2011-10-05 00:00:00	2011-10-05	2011-10-05 00:00:00	\N	38000177		0	0	0		0	0	0	133114	0	1014678	40228214		
62902	5228	19059056	1939-10-27	1939-10-27 00:00:00	1939-11-10	1939-11-10 00:00:00	1939-11-10	38000177		0	0	14		0	0	0	347763	0	243670	19059056		
2462	196	1127433	1984-04-16	1984-04-16 00:00:00	1984-05-14	1984-05-14 00:00:00	1984-05-14	38000177		0	0	28		0	0	0	13451	0	313782	1127433		
27211	2244	40163554	2017-10-13	2017-10-13 00:00:00	2017-10-13	2017-10-13 00:00:00	\N	38000177		0	0	0		0	0	0	149422	0	855332	40163554		
35971	2960	19133873	1956-03-19	1956-03-19 00:00:00	1956-03-29	1956-03-29 00:00:00	1956-03-29	38000177		0	0	10		0	0	0	197629	0	834061	19133873		
32476	2692	1545959	1998-06-29	1998-06-29 00:00:00	1998-06-29	1998-06-29 00:00:00	1998-06-29	38000177		0	0	0		0	0	0	178364	0	259255	1545959		
17197	371	40213227	1991-12-26	1991-12-26 00:00:00	1991-12-26	1991-12-26 00:00:00	1991-12-26	581452		0	0	0		0	0	0	24686	0	113	40213227		
43009	3565	1127433	2000-04-04	2000-04-04 00:00:00	2000-04-11	2000-04-11 00:00:00	2000-04-11	38000177		0	0	7		0	0	0	236715	0	313782	1127433		
63007	5235	19059056	1930-04-07	1930-04-07 00:00:00	1930-04-21	1930-04-21 00:00:00	1930-04-21	38000177		0	0	14		0	0	0	348364	0	243670	19059056		
24519	533	40213160	1962-11-07	1962-11-07 00:00:00	1962-11-07	1962-11-07 00:00:00	1962-11-07	581452		0	0	0		0	0	0	35499	0	10	40213160		
28732	2372	19133873	1966-07-27	1966-07-27 00:00:00	1966-08-09	1966-08-09 00:00:00	1966-08-09	38000177		0	0	13		0	0	0	157811	0	834061	19133873		
43954	958	40213160	1961-12-17	1961-12-17 00:00:00	1961-12-17	1961-12-17 00:00:00	1961-12-17	581452		0	0	0		0	0	0	63642	0	10	40213160		
28794	2380	1124300	1987-04-08	1987-04-08 00:00:00	1987-04-08	1987-04-08 00:00:00	\N	38000177		0	0	0		0	0	0	158187	0	00781178901	45011828		
4966	411	19078461	1981-10-23	1981-10-23 00:00:00	1981-11-13	1981-11-13 00:00:00	1981-11-13	38000177		0	0	21		0	0	0	27404	0	310965	19078461		
3860	320	1127433	1974-02-22	1974-02-22 00:00:00	1974-04-30	1974-04-30 00:00:00	1974-04-30	38000177		0	0	67		0	0	0	21236	0	313782	1127433		
15539	1294	1127078	1978-08-19	1978-08-19 00:00:00	1978-11-17	1978-11-17 00:00:00	1978-11-17	38000177		0	0	90		0	0	0	85611	0	282464	1127078		
24193	1989	40236824	1997-03-13	1997-03-13 00:00:00	1997-03-20	1997-03-20 00:00:00	1997-03-20	38000177		0	0	7		0	0	0	132446	0	1094107	40236824		
46209	3827	40236824	1998-12-19	1998-12-19 00:00:00	1998-12-26	1998-12-26 00:00:00	1998-12-26	38000177		0	0	7		0	0	0	254229	0	1094107	40236824		
169205	3720	40213160	1958-12-02	1958-12-02 00:00:00	1958-12-02	1958-12-02 00:00:00	1958-12-02	581452		0	0	0		0	0	0	247279	0	10	40213160		
39183	3237	1124300	1964-09-15	1964-09-15 00:00:00	1964-09-15	1964-09-15 00:00:00	\N	38000177		0	0	0		0	0	0	215152	0	00781178901	45011828		
52680	4379	19078461	1990-05-28	1990-05-28 00:00:00	1990-06-25	1990-06-25 00:00:00	1990-06-25	38000177		0	0	28		0	0	0	290991	0	310965	19078461		
7992	669	19075001	1996-01-13	1996-01-13 00:00:00	1996-01-27	1996-01-27 00:00:00	1996-01-27	38000177		0	0	14		0	0	0	44196	0	309097	19075001		
52788	4387	19059056	1972-07-15	1972-07-15 00:00:00	1972-08-14	1972-08-14 00:00:00	1972-08-14	38000177		0	0	30		0	0	0	291618	0	243670	19059056		
78363	1715	40213227	2006-12-02	2006-12-02 00:00:00	2006-12-02	2006-12-02 00:00:00	2006-12-02	581452		0	0	0		0	0	0	114585	0	113	40213227		
51965	4320	1127433	2004-02-01	2004-02-01 00:00:00	2004-02-08	2004-02-08 00:00:00	2004-02-08	38000177		0	0	7		0	0	0	286682	0	313782	1127433		
63183	1382	40213314	1977-10-05	1977-10-05 00:00:00	1977-10-05	1977-10-05 00:00:00	1977-10-05	581452		0	0	0		0	0	0	91626	0	49	40213314		
22968	1892	19059056	1974-07-13	1974-07-13 00:00:00	1974-09-11	1974-09-11 00:00:00	1974-09-11	38000177		0	0	60		0	0	0	126046	0	243670	19059056		
63994	1401	40213314	1977-01-02	1977-01-02 00:00:00	1977-01-02	1977-01-02 00:00:00	1977-01-02	581452		0	0	0		0	0	0	93151	0	49	40213314		
40481	882	40213227	2016-06-25	2016-06-25 00:00:00	2016-06-25	2016-06-25 00:00:00	2016-06-25	581452		0	0	0		0	0	0	58720	0	113	40213227		
40378	879	40213160	1956-01-16	1956-01-16 00:00:00	1956-01-16	1956-01-16 00:00:00	1956-01-16	581452		0	0	0		0	0	0	58564	0	10	40213160		
122741	2698	40213251	1984-06-13	1984-06-13 00:00:00	1984-06-13	1984-06-13 00:00:00	1984-06-13	581452		0	0	0		0	0	0	178658	0	21	40213251		
49555	1085	40213160	1969-10-18	1969-10-18 00:00:00	1969-10-18	1969-10-18 00:00:00	1969-10-18	581452		0	0	0		0	0	0	71264	0	10	40213160		
755	61	1118084	2005-08-29	2005-08-29 00:00:00	2005-08-29	2005-08-29 00:00:00	\N	38000177		0	0	0		0	0	0	4136	0	00025152531	44923712		
1300	101	1127433	1932-04-23	1932-04-23 00:00:00	1932-05-07	1932-05-07 00:00:00	1932-05-07	38000177		0	0	14		0	0	0	6910	0	313782	1127433		
232464	5108	40213160	1966-01-02	1966-01-02 00:00:00	1966-01-02	1966-01-02 00:00:00	1966-01-02	581452		0	0	0		0	0	0	339392	0	10	40213160		
203766	4473	40213227	2013-05-12	2013-05-12 00:00:00	2013-05-12	2013-05-12 00:00:00	2013-05-12	581452		0	0	0		0	0	0	297608	0	113	40213227		
2232	180	42902245	1999-03-07	1999-03-07 00:00:00	2000-03-01	2000-03-01 00:00:00	2000-03-01	38000177		0	0	360		0	0	0	12095	0	1359133	42902245		
38688	3196	19133905	1989-06-28	1989-06-28 00:00:00	1989-07-08	1989-07-08 00:00:00	1989-07-08	38000177		0	0	10		0	0	0	212647	0	834102	19133905		
29456	2438	1127433	2010-01-21	2010-01-21 00:00:00	2010-02-04	2010-02-04 00:00:00	2010-02-04	38000177		0	0	14		0	0	0	161756	0	313782	1127433		
42201	3501	19006318	1950-06-22	1950-06-22 00:00:00	1950-07-06	1950-07-06 00:00:00	1950-07-06	38000177		0	0	14		0	0	0	232085	0	105078	19006318		
164406	3615	40213227	2000-09-06	2000-09-06 00:00:00	2000-09-06	2000-09-06 00:00:00	2000-09-06	581452		0	0	0		0	0	0	240199	0	113	40213227		
70510	1542	40213296	2009-02-04	2009-02-04 00:00:00	2009-02-04	2009-02-04 00:00:00	2009-02-04	581452		0	0	0		0	0	0	103354	0	52	40213296		
30432	2522	19078461	1998-06-14	1998-06-14 00:00:00	1998-07-05	1998-07-05 00:00:00	1998-07-05	38000177		0	0	21		0	0	0	166788	0	310965	19078461		
46664	3866	40174880	2017-09-24	2017-09-24 00:00:00	2017-09-24	2017-09-24 00:00:00	\N	38000177		0	0	0		0	0	0	256725	0	966222	40174880		
29794	2468	1127433	1981-08-08	1981-08-08 00:00:00	1981-08-15	1981-08-15 00:00:00	1981-08-15	38000177		0	0	7		0	0	0	163593	0	313782	1127433		
160333	3528	40213227	2000-11-13	2000-11-13 00:00:00	2000-11-13	2000-11-13 00:00:00	2000-11-13	581452		0	0	0		0	0	0	234206	0	113	40213227		
30862	673	40213227	2003-03-07	2003-03-07 00:00:00	2003-03-07	2003-03-07 00:00:00	2003-03-07	581452		0	0	0		0	0	0	44450	0	113	40213227		
8350	180	40213314	1977-09-29	1977-09-29 00:00:00	1977-09-29	1977-09-29 00:00:00	1977-09-29	581452		0	0	0		0	0	0	12079	0	49	40213314		
228703	5023	40213227	2006-02-19	2006-02-19 00:00:00	2006-02-19	2006-02-19 00:00:00	2006-02-19	581452		0	0	0		0	0	0	333718	0	113	40213227		
44683	3698	1127433	2000-02-03	2000-02-03 00:00:00	2000-02-10	2000-02-10 00:00:00	2000-02-10	38000177		0	0	7		0	0	0	245875	0	313782	1127433		
31745	2631	1118084	1992-10-19	1992-10-19 00:00:00	1992-10-19	1992-10-19 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00025152531	44923712		
15743	1310	1127433	1959-07-17	1959-07-17 00:00:00	1959-07-24	1959-07-24 00:00:00	1959-07-24	38000177		0	0	7		0	0	0	86682	0	313782	1127433		
230527	5066	40213227	2009-04-18	2009-04-18 00:00:00	2009-04-18	2009-04-18 00:00:00	2009-04-18	581452		0	0	0		0	0	0	336797	0	113	40213227		
83667	1829	40213296	2010-08-03	2010-08-03 00:00:00	2010-08-03	2010-08-03 00:00:00	2010-08-03	581452		0	0	0		0	0	0	122318	0	52	40213296		
31009	2570	1713671	1951-06-13	1951-06-13 00:00:00	1951-06-27	1951-06-27 00:00:00	1951-06-27	38000177		0	0	14		0	0	0	170193	0	562251	1713671		
17681	1464	1115171	2017-06-21	2017-06-21 00:00:00	2017-07-05	2017-07-05 00:00:00	2017-07-05	38000177		0	0	14		0	0	0	97582	0	849574	1115171		
24534	2020	1115171	2012-07-22	2012-07-22 00:00:00	2012-08-19	2012-08-19 00:00:00	2012-08-19	38000177		0	0	28		0	0	0	134308	0	849574	1115171		
77820	1702	40213260	2014-11-02	2014-11-02 00:00:00	2014-11-02	2014-11-02 00:00:00	2014-11-02	581452		0	0	0		0	0	0	113816	0	121	40213260		
35074	2895	19006318	1961-11-01	1961-11-01 00:00:00	1961-11-15	1961-11-15 00:00:00	1961-11-15	38000177		0	0	14		0	0	0	192715	0	105078	19006318		
31209	2588	1127433	1967-03-06	1967-03-06 00:00:00	1967-03-13	1967-03-13 00:00:00	1967-03-13	38000177		0	0	7		0	0	0	171285	0	313782	1127433		
35136	2898	1127433	1984-01-21	1984-01-21 00:00:00	1984-01-28	1984-01-28 00:00:00	1984-01-28	38000177		0	0	7		0	0	0	192995	0	313782	1127433		
18369	1520	40229134	1952-01-08	1952-01-08 00:00:00	1952-01-22	1952-01-22 00:00:00	1952-01-22	38000177		0	0	14		0	0	0	101649	0	1043400	40229134		
79814	1746	40213227	2003-11-20	2003-11-20 00:00:00	2003-11-20	2003-11-20 00:00:00	2003-11-20	581452		0	0	0		0	0	0	116736	0	113	40213227		
58110	4827	1127433	2016-02-29	2016-02-29 00:00:00	2016-03-14	2016-03-14 00:00:00	2016-03-14	38000177		0	0	14		0	0	0	321097	0	313782	1127433		
42424	924	40213227	2015-02-07	2015-02-07 00:00:00	2015-02-07	2015-02-07 00:00:00	2015-02-07	581452		0	0	0		0	0	0	61538	0	113	40213227		
62903	5228	19133905	2015-05-03	2015-05-03 00:00:00	2015-05-15	2015-05-15 00:00:00	2015-05-15	38000177		0	0	12		0	0	0	347856	0	834102	19133905		
2463	196	19128065	1981-08-05	1981-08-05 00:00:00	1982-07-31	1982-07-31 00:00:00	1982-07-31	38000177		0	0	360		0	0	0	13522	0	749882	19128065		
27212	2244	40171902	2017-10-13	2017-10-13 00:00:00	2017-10-13	2017-10-13 00:00:00	\N	38000177		0	0	0		0	0	0	149422	0	897718	40171902		
35972	2960	19133905	2011-02-25	2011-02-25 00:00:00	2011-03-07	2011-03-07 00:00:00	2011-03-07	38000177		0	0	10		0	0	0	197621	0	834102	19133905		
154405	3399	40213227	2005-09-27	2005-09-27 00:00:00	2005-09-27	2005-09-27 00:00:00	2005-09-27	581452		0	0	0		0	0	0	225443	0	113	40213227		
17199	371	40213160	1968-05-09	1968-05-09 00:00:00	1968-05-09	1968-05-09 00:00:00	1968-05-09	581452		0	0	0		0	0	0	24695	0	10	40213160		
43010	3565	1127433	1951-08-27	1951-08-27 00:00:00	1951-09-03	1951-09-03 00:00:00	1951-09-03	38000177		0	0	7		0	0	0	236712	0	313782	1127433		
63008	5235	1713671	1970-04-29	1970-04-29 00:00:00	1970-05-06	1970-05-06 00:00:00	1970-05-06	38000177		0	0	7		0	0	0	348354	0	562251	1713671		
35832	782	40213227	1993-05-09	1993-05-09 00:00:00	1993-05-09	1993-05-09 00:00:00	1993-05-09	581452		0	0	0		0	0	0	52039	0	113	40213227		
60779	5053	40174880	2017-02-07	2017-02-07 00:00:00	2017-02-07	2017-02-07 00:00:00	\N	38000177		0	0	0		0	0	0	336012	0	966222	40174880		
43956	958	40213227	2008-03-02	2008-03-02 00:00:00	2008-03-02	2008-03-02 00:00:00	2008-03-02	581452		0	0	0		0	0	0	63629	0	113	40213227		
28795	2380	19059056	1952-12-26	1952-12-26 00:00:00	1953-01-09	1953-01-09 00:00:00	1953-01-09	38000177		0	0	14		0	0	0	158230	0	243670	19059056		
4967	412	40220960	2004-06-18	2004-06-18 00:00:00	2004-06-18	2004-06-18 00:00:00	2004-06-18	38000177		0	0	0		0	0	0	27423	0	1804799	40220960		
3861	320	1127078	1959-11-30	1959-11-30 00:00:00	1960-01-29	1960-01-29 00:00:00	1960-01-29	38000177		0	0	60		0	0	0	21231	0	282464	1127078		
15546	1297	1127433	1983-09-18	1983-09-18 00:00:00	1983-10-02	1983-10-02 00:00:00	1983-10-02	38000177		0	0	14		0	0	0	85707	0	313782	1127433		
24194	1989	1127078	1952-11-11	1952-11-11 00:00:00	1952-11-25	1952-11-25 00:00:00	1952-11-25	38000177		0	0	14		0	0	0	132467	0	282464	1127078		
46210	3827	920300	1998-12-19	1998-12-19 00:00:00	1998-12-26	1998-12-26 00:00:00	1998-12-26	38000177		0	0	7		0	0	0	254229	0	311989	920300		
169213	3720	40213227	1996-04-16	1996-04-16 00:00:00	1996-04-16	1996-04-16 00:00:00	1996-04-16	581452		0	0	0		0	0	0	247256	0	113	40213227		
39184	3237	40229134	1981-12-04	1981-12-04 00:00:00	1981-12-18	1981-12-18 00:00:00	1981-12-18	38000177		0	0	14		0	0	0	215224	0	1043400	40229134		
52681	4379	1127433	1987-04-14	1987-04-14 00:00:00	1987-07-13	1987-07-13 00:00:00	1987-07-13	38000177		0	0	90		0	0	0	290992	0	313782	1127433		
29655	2456	1127433	1968-02-15	1968-02-15 00:00:00	1968-03-16	1968-03-16 00:00:00	1968-03-16	38000177		0	0	30		0	0	0	162816	0	313782	1127433		
63247	5255	1124300	1996-08-26	1996-08-26 00:00:00	1996-08-26	1996-08-26 00:00:00	\N	38000177		0	0	0		0	0	0	349702	0	00781178901	45011828		
78364	1715	40213260	2006-12-02	2006-12-02 00:00:00	2006-12-02	2006-12-02 00:00:00	2006-12-02	581452		0	0	0		0	0	0	114585	0	121	40213260		
51966	4320	19128065	1988-03-04	1988-03-04 00:00:00	1989-02-27	1989-02-27 00:00:00	1989-02-27	38000177		0	0	360		0	0	0	286680	0	749882	19128065		
63184	1382	40213160	1977-10-05	1977-10-05 00:00:00	1977-10-05	1977-10-05 00:00:00	1977-10-05	581452		0	0	0		0	0	0	91626	0	10	40213160		
22969	1892	40165015	1974-07-13	1974-07-13 00:00:00	1974-07-13	1974-07-13 00:00:00	\N	38000177		0	0	0		0	0	0	126046	0	861467	40165015		
63996	1401	40213160	1973-05-06	1973-05-06 00:00:00	1973-05-06	1973-05-06 00:00:00	1973-05-06	581452		0	0	0		0	0	0	93170	0	10	40213160		
40488	882	40213227	1995-12-30	1995-12-30 00:00:00	1995-12-30	1995-12-30 00:00:00	1995-12-30	581452		0	0	0		0	0	0	58714	0	113	40213227		
40385	879	40213160	1957-01-21	1957-01-21 00:00:00	1957-01-21	1957-01-21 00:00:00	1957-01-21	581452		0	0	0		0	0	0	58597	0	10	40213160		
122742	2698	40213160	1983-07-13	1983-07-13 00:00:00	1983-07-13	1983-07-13 00:00:00	1983-07-13	581452		0	0	0		0	0	0	178672	0	10	40213160		
61489	5116	1127433	1977-05-29	1977-05-29 00:00:00	1977-06-05	1977-06-05 00:00:00	1977-06-05	38000177		0	0	7		0	0	0	339982	0	313782	1127433		
756	61	1115171	2009-08-21	2009-08-21 00:00:00	2009-09-25	2009-09-25 00:00:00	2009-09-25	38000177		0	0	35		0	0	0	4166	0	849574	1115171		
1301	101	40229134	1962-04-19	1962-04-19 00:00:00	1962-04-26	1962-04-26 00:00:00	1962-04-26	38000177		0	0	7		0	0	0	6835	0	1043400	40229134		
232465	5108	40213260	2012-12-30	2012-12-30 00:00:00	2012-12-30	2012-12-30 00:00:00	2012-12-30	581452		0	0	0		0	0	0	339398	0	121	40213260		
203767	4473	40213296	2013-05-12	2013-05-12 00:00:00	2013-05-12	2013-05-12 00:00:00	2013-05-12	581452		0	0	0		0	0	0	297608	0	52	40213296		
2233	180	46233988	1981-11-09	1981-11-09 00:00:00	1981-11-23	1981-11-23 00:00:00	1981-11-23	38000177		0	0	14		0	0	0	12161	0	1652673	46233988		
38689	3196	1118084	2008-05-22	2008-05-22 00:00:00	2008-05-22	2008-05-22 00:00:00	\N	38000177		0	0	0		0	0	0	212609	0	00025152531	44923712		
29457	2438	1127078	1987-03-18	1987-03-18 00:00:00	1987-04-08	1987-04-08 00:00:00	1987-04-08	38000177		0	0	21		0	0	0	161754	0	282464	1127078		
42202	3501	1127433	1961-05-15	1961-05-15 00:00:00	1961-05-22	1961-05-22 00:00:00	1961-05-22	38000177		0	0	7		0	0	0	232121	0	313782	1127433		
52755	1154	40213160	1970-12-13	1970-12-13 00:00:00	1970-12-13	1970-12-13 00:00:00	1970-12-13	581452		0	0	0		0	0	0	76223	0	10	40213160		
70516	1542	40213160	1966-08-03	1966-08-03 00:00:00	1966-08-03	1966-08-03 00:00:00	1966-08-03	581452		0	0	0		0	0	0	103341	0	10	40213160		
30433	2522	1124300	1991-01-24	1991-01-24 00:00:00	1991-01-24	1991-01-24 00:00:00	\N	38000177		0	0	0		0	0	0	166856	0	00781178901	45011828		
46665	3866	920334	2004-11-11	2004-11-11 00:00:00	2004-11-18	2004-11-18 00:00:00	2004-11-18	38000177		0	0	7		0	0	0	256735	0	311995	920334		
29795	2468	19059056	1946-05-12	1946-05-12 00:00:00	1946-06-11	1946-06-11 00:00:00	1946-06-11	38000177		0	0	30		0	0	0	163673	0	243670	19059056		
160334	3528	40213296	2000-11-13	2000-11-13 00:00:00	2000-11-13	2000-11-13 00:00:00	2000-11-13	581452		0	0	0		0	0	0	234206	0	52	40213296		
30866	673	40213160	1962-06-01	1962-06-01 00:00:00	1962-06-01	1962-06-01 00:00:00	1962-06-01	581452		0	0	0		0	0	0	44527	0	10	40213160		
8351	180	40213160	1977-09-29	1977-09-29 00:00:00	1977-09-29	1977-09-29 00:00:00	1977-09-29	581452		0	0	0		0	0	0	12079	0	10	40213160		
172058	3783	40213227	2001-10-12	2001-10-12 00:00:00	2001-10-12	2001-10-12 00:00:00	2001-10-12	581452		0	0	0		0	0	0	251396	0	113	40213227		
44684	3698	19133873	1963-12-07	1963-12-07 00:00:00	1963-12-17	1963-12-17 00:00:00	1963-12-17	38000177		0	0	10		0	0	0	245856	0	834061	19133873		
31746	2631	19059056	1960-07-24	1960-07-24 00:00:00	1960-08-21	1960-08-21 00:00:00	1960-08-21	38000177		0	0	28		0	0	0	174074	0	243670	19059056		
15744	1310	1127433	1944-02-11	1944-02-11 00:00:00	1944-02-25	1944-02-25 00:00:00	1944-02-25	38000177		0	0	14		0	0	0	86561	0	313782	1127433		
230532	5066	40213160	1972-03-18	1972-03-18 00:00:00	1972-03-18	1972-03-18 00:00:00	1972-03-18	581452		0	0	0		0	0	0	336793	0	10	40213160		
195861	4304	40213306	1988-05-08	1988-05-08 00:00:00	1988-05-08	1988-05-08 00:00:00	1988-05-08	581452		0	0	0		0	0	0	285474	0	43	40213306		
31010	2570	19059056	1946-09-23	1946-09-23 00:00:00	1946-12-22	1946-12-22 00:00:00	1946-12-22	38000177		0	0	90		0	0	0	170196	0	243670	19059056		
17682	1464	19059056	1970-11-04	1970-11-04 00:00:00	1970-11-25	1970-11-25 00:00:00	1970-11-25	38000177		0	0	21		0	0	0	97581	0	243670	19059056		
24535	2020	19059056	1976-09-20	1976-09-20 00:00:00	1976-10-04	1976-10-04 00:00:00	1976-10-04	38000177		0	0	14		0	0	0	134291	0	243670	19059056		
77822	1702	40213306	1987-01-25	1987-01-25 00:00:00	1987-01-25	1987-01-25 00:00:00	1987-01-25	581452		0	0	0		0	0	0	113843	0	43	40213306		
35075	2895	40229134	1962-02-08	1962-02-08 00:00:00	1962-02-22	1962-02-22 00:00:00	1962-02-22	38000177		0	0	14		0	0	0	192700	0	1043400	40229134		
31210	2588	1115171	2016-07-13	2016-07-13 00:00:00	2016-07-27	2016-07-27 00:00:00	2016-07-27	38000177		0	0	14		0	0	0	171298	0	849574	1115171		
35137	2898	1127433	2017-04-02	2017-04-02 00:00:00	2017-04-09	2017-04-09 00:00:00	2017-04-09	38000177		0	0	7		0	0	0	193110	0	313782	1127433		
18370	1520	1127433	2002-10-29	2002-10-29 00:00:00	2003-01-27	2003-01-27 00:00:00	2003-01-27	38000177		0	0	90		0	0	0	101710	0	313782	1127433		
79818	1746	40213160	1955-10-20	1955-10-20 00:00:00	1955-10-20	1955-10-20 00:00:00	1955-10-20	581452		0	0	0		0	0	0	116802	0	10	40213160		
58111	4827	1127433	1983-04-28	1983-04-28 00:00:00	1983-05-28	1983-05-28 00:00:00	1983-05-28	38000177		0	0	30		0	0	0	321146	0	313782	1127433		
42426	924	40213260	2015-02-07	2015-02-07 00:00:00	2015-02-07	2015-02-07 00:00:00	2015-02-07	581452		0	0	0		0	0	0	61538	0	121	40213260		
62904	5228	40236824	1960-07-30	1960-07-30 00:00:00	1960-08-06	1960-08-06 00:00:00	1960-08-06	38000177		0	0	7		0	0	0	347779	0	1094107	40236824		
2464	196	1713671	2008-09-28	2008-09-28 00:00:00	2008-10-12	2008-10-12 00:00:00	2008-10-12	38000177		0	0	14		0	0	0	13462	0	562251	1713671		
27213	2244	1127433	1976-01-16	1976-01-16 00:00:00	1976-01-23	1976-01-23 00:00:00	1976-01-23	38000177		0	0	7		0	0	0	149379	0	313782	1127433		
35973	2960	1713671	1997-09-21	1997-09-21 00:00:00	1997-09-28	1997-09-28 00:00:00	1997-09-28	38000177		0	0	7		0	0	0	197616	0	562251	1713671		
154409	3399	40213251	1987-06-30	1987-06-30 00:00:00	1987-06-30	1987-06-30 00:00:00	1987-06-30	581452		0	0	0		0	0	0	225529	0	21	40213251		
17204	371	40213160	1973-01-11	1973-01-11 00:00:00	1973-01-11	1973-01-11 00:00:00	1973-01-11	581452		0	0	0		0	0	0	24657	0	10	40213160		
43011	3565	1124300	1982-05-14	1982-05-14 00:00:00	1982-05-14	1982-05-14 00:00:00	\N	38000177		0	0	0		0	0	0	236787	0	00781178901	45011828		
63009	5235	19059056	1927-11-25	1927-11-25 00:00:00	1927-12-09	1927-12-09 00:00:00	1927-12-09	38000177		0	0	14		0	0	0	348326	0	243670	19059056		
100084	2192	40213227	2016-11-10	2016-11-10 00:00:00	2016-11-10	2016-11-10 00:00:00	2016-11-10	581452		0	0	0		0	0	0	146193	0	113	40213227		
60780	5053	1127433	1986-02-18	1986-02-18 00:00:00	1986-03-04	1986-03-04 00:00:00	1986-03-04	38000177		0	0	14		0	0	0	336040	0	313782	1127433		
43957	958	40213260	2008-03-02	2008-03-02 00:00:00	2008-03-02	2008-03-02 00:00:00	2008-03-02	581452		0	0	0		0	0	0	63629	0	121	40213260		
28796	2380	40229134	2008-12-15	2008-12-15 00:00:00	2008-12-29	2008-12-29 00:00:00	2008-12-29	38000177		0	0	14		0	0	0	158212	0	1043400	40229134		
4968	412	1713671	1986-12-23	1986-12-23 00:00:00	1987-01-06	1987-01-06 00:00:00	1987-01-06	38000177		0	0	14		0	0	0	27471	0	562251	1713671		
3862	320	19078461	2004-08-09	2004-08-09 00:00:00	2004-08-23	2004-08-23 00:00:00	2004-08-23	38000177		0	0	14		0	0	0	21179	0	310965	19078461		
15547	1297	40229134	2000-12-26	2000-12-26 00:00:00	2001-01-02	2001-01-02 00:00:00	2001-01-02	38000177		0	0	7		0	0	0	85732	0	1043400	40229134		
24195	1989	19006318	1952-11-11	1952-11-11 00:00:00	1952-11-25	1952-11-25 00:00:00	1952-11-25	38000177		0	0	14		0	0	0	132467	0	105078	19006318		
46211	3827	1127433	1963-10-06	1963-10-06 00:00:00	1963-10-20	1963-10-20 00:00:00	1963-10-20	38000177		0	0	14		0	0	0	254158	0	313782	1127433		
169214	3720	40213296	1996-04-16	1996-04-16 00:00:00	1996-04-16	1996-04-16 00:00:00	1996-04-16	581452		0	0	0		0	0	0	247256	0	52	40213296		
39185	3237	1713671	1931-10-04	1931-10-04 00:00:00	1931-10-11	1931-10-11 00:00:00	1931-10-11	38000177		0	0	7		0	0	0	215196	0	562251	1713671		
52682	4379	1127433	1975-06-17	1975-06-17 00:00:00	1975-06-24	1975-06-24 00:00:00	1975-06-24	38000177		0	0	7		0	0	0	290970	0	313782	1127433		
29656	2456	1127433	1971-12-03	1971-12-03 00:00:00	1971-12-10	1971-12-10 00:00:00	1971-12-10	38000177		0	0	7		0	0	0	162769	0	313782	1127433		
63248	5255	40229134	1984-11-22	1984-11-22 00:00:00	1984-11-29	1984-11-29 00:00:00	1984-11-29	38000177		0	0	7		0	0	0	349667	0	1043400	40229134		
96840	2123	40213227	1993-08-06	1993-08-06 00:00:00	1993-08-06	1993-08-06 00:00:00	1993-08-06	581452		0	0	0		0	0	0	141271	0	113	40213227		
51967	4320	40229134	2013-05-25	2013-05-25 00:00:00	2013-06-08	2013-06-08 00:00:00	2013-06-08	38000177		0	0	14		0	0	0	286663	0	1043400	40229134		
74487	1626	40213227	1996-09-01	1996-09-01 00:00:00	1996-09-01	1996-09-01 00:00:00	1996-09-01	581452		0	0	0		0	0	0	109224	0	113	40213227		
22970	1892	40169281	2009-05-21	2009-05-21 00:00:00	2009-05-21	2009-05-21 00:00:00	\N	38000177		0	0	0		0	0	0	126013	0	896209	40169281		
64001	1401	40213227	1995-02-05	1995-02-05 00:00:00	1995-02-05	1995-02-05 00:00:00	1995-02-05	581452		0	0	0		0	0	0	93161	0	113	40213227		
40504	882	40213227	2006-02-25	2006-02-25 00:00:00	2006-02-25	2006-02-25 00:00:00	2006-02-25	581452		0	0	0		0	0	0	58744	0	113	40213227		
198236	4355	40213251	1986-03-29	1986-03-29 00:00:00	1986-03-29	1986-03-29 00:00:00	1986-03-29	581452		0	0	0		0	0	0	288951	0	21	40213251		
122743	2698	40213314	1983-07-13	1983-07-13 00:00:00	1983-07-13	1983-07-13 00:00:00	1983-07-13	581452		0	0	0		0	0	0	178672	0	49	40213314		
61490	5116	1127433	1989-04-14	1989-04-14 00:00:00	1989-04-28	1989-04-28 00:00:00	1989-04-28	38000177		0	0	14		0	0	0	339983	0	313782	1127433		
757	61	1551192	1978-07-29	1978-07-29 00:00:00	1978-07-29	1978-07-29 00:00:00	1978-07-29	38000177		0	0	0		0	0	0	4159	0	312617	1551192		
1302	102	19128022	1990-06-01	1990-06-01 00:00:00	1991-05-27	1991-05-27 00:00:00	1991-05-27	38000177		0	0	360		0	0	0	6999	0	749785	19128022		
232467	5108	40213227	2012-12-30	2012-12-30 00:00:00	2012-12-30	2012-12-30 00:00:00	2012-12-30	581452		0	0	0		0	0	0	339398	0	113	40213227		
203775	4473	40213227	1993-09-26	1993-09-26 00:00:00	1993-09-26	1993-09-26 00:00:00	1993-09-26	581452		0	0	0		0	0	0	297619	0	113	40213227		
2234	180	1127078	1981-11-09	1981-11-09 00:00:00	1981-11-23	1981-11-23 00:00:00	1981-11-23	38000177		0	0	14		0	0	0	12161	0	282464	1127078		
38690	3196	40229134	2011-09-07	2011-09-07 00:00:00	2011-09-14	2011-09-14 00:00:00	2011-09-14	38000177		0	0	7		0	0	0	212620	0	1043400	40229134		
29458	2438	19128022	1995-06-14	1995-06-14 00:00:00	1996-06-08	1996-06-08 00:00:00	1996-06-08	38000177		0	0	360		0	0	0	161774	0	749785	19128022		
42203	3501	1127433	1949-11-24	1949-11-24 00:00:00	1949-12-01	1949-12-01 00:00:00	1949-12-01	38000177		0	0	7		0	0	0	232119	0	313782	1127433		
52757	1154	40213296	2010-09-12	2010-09-12 00:00:00	2010-09-12	2010-09-12 00:00:00	2010-09-12	581452		0	0	0		0	0	0	76231	0	52	40213296		
217133	4763	40213227	2001-08-28	2001-08-28 00:00:00	2001-08-28	2001-08-28 00:00:00	2001-08-28	581452		0	0	0		0	0	0	317399	0	113	40213227		
30434	2522	40229134	1959-05-08	1959-05-08 00:00:00	1959-05-15	1959-05-15 00:00:00	1959-05-15	38000177		0	0	7		0	0	0	166798	0	1043400	40229134		
46666	3866	19078461	1977-10-31	1977-10-31 00:00:00	1977-11-14	1977-11-14 00:00:00	1977-11-14	38000177		0	0	14		0	0	0	256701	0	310965	19078461		
29796	2468	1127433	1966-11-06	1966-11-06 00:00:00	1966-11-13	1966-11-13 00:00:00	1966-11-13	38000177		0	0	7		0	0	0	163611	0	313782	1127433		
203503	4467	40213198	2017-02-09	2017-02-09 00:00:00	2017-02-09	2017-02-09 00:00:00	2017-02-09	581452		0	0	0		0	0	0	297175	0	133	40213198		
116488	2559	40213160	1962-12-15	1962-12-15 00:00:00	1962-12-15	1962-12-15 00:00:00	1962-12-15	581452		0	0	0		0	0	0	169661	0	10	40213160		
8358	180	40213306	1999-07-08	1999-07-08 00:00:00	1999-07-08	1999-07-08 00:00:00	1999-07-08	581452		0	0	0		0	0	0	12199	0	43	40213306		
172065	3783	40213227	2011-05-06	2011-05-06 00:00:00	2011-05-06	2011-05-06 00:00:00	2011-05-06	581452		0	0	0		0	0	0	251356	0	113	40213227		
44685	3698	40229134	1996-03-16	1996-03-16 00:00:00	1996-03-23	1996-03-23 00:00:00	1996-03-23	38000177		0	0	7		0	0	0	245858	0	1043400	40229134		
31747	2631	19006318	1960-07-24	1960-07-24 00:00:00	1960-08-21	1960-08-21 00:00:00	1960-08-21	38000177		0	0	28		0	0	0	174074	0	105078	19006318		
15746	1310	40229134	1945-04-11	1945-04-11 00:00:00	1945-04-18	1945-04-18 00:00:00	1945-04-18	38000177		0	0	7		0	0	0	86566	0	1043400	40229134		
230533	5066	40213160	1967-09-16	1967-09-16 00:00:00	1967-09-16	1967-09-16 00:00:00	1967-09-16	581452		0	0	0		0	0	0	336789	0	10	40213160		
195867	4304	40213160	1971-08-22	1971-08-22 00:00:00	1971-08-22	1971-08-22 00:00:00	1971-08-22	581452		0	0	0		0	0	0	285502	0	10	40213160		
31011	2570	920334	1993-10-08	1993-10-08 00:00:00	1993-10-15	1993-10-15 00:00:00	1993-10-15	38000177		0	0	7		0	0	0	170181	0	311995	920334		
17683	1464	19059056	1965-09-01	1965-09-01 00:00:00	1965-11-30	1965-11-30 00:00:00	1965-11-30	38000177		0	0	90		0	0	0	97580	0	243670	19059056		
24536	2020	46233988	1976-09-20	1976-09-20 00:00:00	1976-10-04	1976-10-04 00:00:00	1976-10-04	38000177		0	0	14		0	0	0	134291	0	1652673	46233988		
77828	1702	40213160	1965-04-11	1965-04-11 00:00:00	1965-04-11	1965-04-11 00:00:00	1965-04-11	581452		0	0	0		0	0	0	113835	0	10	40213160		
35076	2895	19078461	2005-05-19	2005-05-19 00:00:00	2005-06-02	2005-06-02 00:00:00	2005-06-02	38000177		0	0	14		0	0	0	192680	0	310965	19078461		
31211	2588	19128065	1978-08-27	1978-08-27 00:00:00	1979-08-22	1979-08-22 00:00:00	1979-08-22	38000177		0	0	360		0	0	0	171267	0	749882	19128065		
35138	2898	1127433	2000-08-02	2000-08-02 00:00:00	2000-08-16	2000-08-16 00:00:00	2000-08-16	38000177		0	0	14		0	0	0	192975	0	313782	1127433		
18371	1520	40231925	2002-10-29	2002-10-29 00:00:00	2002-10-29	2002-10-29 00:00:00	\N	38000177		0	0	0		0	0	0	101710	0	1049221	40231925		
79819	1746	40213160	1957-07-18	1957-07-18 00:00:00	1957-07-18	1957-07-18 00:00:00	1957-07-18	581452		0	0	0		0	0	0	116772	0	10	40213160		
58112	4827	1127433	2006-07-12	2006-07-12 00:00:00	2006-07-19	2006-07-19 00:00:00	2006-07-19	38000177		0	0	7		0	0	0	321095	0	313782	1127433		
42430	924	40213260	2014-02-01	2014-02-01 00:00:00	2014-02-01	2014-02-01 00:00:00	2014-02-01	581452		0	0	0		0	0	0	61559	0	121	40213260		
62905	5228	920300	1960-07-30	1960-07-30 00:00:00	1960-08-06	1960-08-06 00:00:00	1960-08-06	38000177		0	0	7		0	0	0	347779	0	311989	920300		
2465	196	19059056	1966-06-15	1966-06-15 00:00:00	1966-08-14	1966-08-14 00:00:00	1966-08-14	38000177		0	0	60		0	0	0	13449	0	243670	19059056		
27214	2244	1127433	1962-02-08	1962-02-08 00:00:00	1962-02-22	1962-02-22 00:00:00	1962-02-22	38000177		0	0	14		0	0	0	149378	0	313782	1127433		
35975	2961	19133873	1987-12-10	1987-12-10 00:00:00	1987-12-18	1987-12-18 00:00:00	1987-12-18	38000177		0	0	8		0	0	0	197704	0	834061	19133873		
154411	3399	40213160	1987-06-30	1987-06-30 00:00:00	1987-06-30	1987-06-30 00:00:00	1987-06-30	581452		0	0	0		0	0	0	225529	0	10	40213160		
17207	371	40213296	2009-01-15	2009-01-15 00:00:00	2009-01-15	2009-01-15 00:00:00	2009-01-15	581452		0	0	0		0	0	0	24709	0	52	40213296		
43012	3565	1713671	1979-06-14	1979-06-14 00:00:00	1979-06-28	1979-06-28 00:00:00	1979-06-28	38000177		0	0	14		0	0	0	236787	0	562251	1713671		
63010	5236	1127433	2008-08-18	2008-08-18 00:00:00	2008-09-01	2008-09-01 00:00:00	2008-09-01	38000177		0	0	14		0	0	0	348422	0	313782	1127433		
100087	2192	40213296	1997-01-02	1997-01-02 00:00:00	1997-01-02	1997-01-02 00:00:00	1997-01-02	581452		0	0	0		0	0	0	146239	0	52	40213296		
60781	5053	1124300	1987-06-05	1987-06-05 00:00:00	1987-06-05	1987-06-05 00:00:00	\N	38000177		0	0	0		0	0	0	336040	0	00781178901	45011828		
43960	958	40213296	2000-02-06	2000-02-06 00:00:00	2000-02-06	2000-02-06 00:00:00	2000-02-06	581452		0	0	0		0	0	0	63658	0	52	40213296		
28797	2380	1127433	2010-09-23	2010-09-23 00:00:00	2010-09-30	2010-09-30 00:00:00	2010-09-30	38000177		0	0	7		0	0	0	158191	0	313782	1127433		
4969	412	1127433	1982-11-09	1982-11-09 00:00:00	1982-11-23	1982-11-23 00:00:00	1982-11-23	38000177		0	0	14		0	0	0	27426	0	313782	1127433		
3863	321	1127433	1996-06-30	1996-06-30 00:00:00	1996-07-21	1996-07-21 00:00:00	1996-07-21	38000177		0	0	21		0	0	0	21322	0	313782	1127433		
15548	1297	1127433	2011-06-30	2011-06-30 00:00:00	2011-07-07	2011-07-07 00:00:00	2011-07-07	38000177		0	0	7		0	0	0	85713	0	313782	1127433		
24197	1989	1127433	1984-01-26	1984-01-26 00:00:00	1984-02-16	1984-02-16 00:00:00	1984-02-16	38000177		0	0	21		0	0	0	132478	0	313782	1127433		
46212	3827	1127433	1967-08-03	1967-08-03 00:00:00	1967-08-17	1967-08-17 00:00:00	1967-08-17	38000177		0	0	14		0	0	0	254174	0	313782	1127433		
169234	3721	40213306	1986-06-20	1986-06-20 00:00:00	1986-06-20	1986-06-20 00:00:00	1986-06-20	581452		0	0	0		0	0	0	247379	0	43	40213306		
39186	3237	40229134	1928-07-02	1928-07-02 00:00:00	1928-07-16	1928-07-16 00:00:00	1928-07-16	38000177		0	0	14		0	0	0	215195	0	1043400	40229134		
52683	4379	19133873	1983-04-08	1983-04-08 00:00:00	1983-04-17	1983-04-17 00:00:00	1983-04-17	38000177		0	0	9		0	0	0	290938	0	834061	19133873		
29657	2456	19129655	1961-01-06	1961-01-06 00:00:00	1961-01-20	1961-01-20 00:00:00	1961-01-20	38000177		0	0	14		0	0	0	162774	0	789980	19129655		
63249	5255	1127433	1962-01-14	1962-01-14 00:00:00	1962-01-21	1962-01-21 00:00:00	1962-01-21	38000177		0	0	7		0	0	0	349628	0	313782	1127433		
63269	5256	40236824	1983-12-03	1983-12-03 00:00:00	1983-12-17	1983-12-17 00:00:00	1983-12-17	38000177		0	0	14		0	0	0	349773	0	1094107	40236824		
51968	4320	19128065	1989-02-27	1989-02-27 00:00:00	1990-02-22	1990-02-22 00:00:00	1990-02-22	38000177		0	0	360		0	0	0	286681	0	749882	19128065		
227764	5001	40213227	1994-04-24	1994-04-24 00:00:00	1994-04-24	1994-04-24 00:00:00	1994-04-24	581452		0	0	0		0	0	0	332664	0	113	40213227		
22971	1892	40236824	1999-08-02	1999-08-02 00:00:00	1999-08-09	1999-08-09 00:00:00	1999-08-09	38000177		0	0	7		0	0	0	126035	0	1094107	40236824		
64002	1401	40213306	1995-02-05	1995-02-05 00:00:00	1995-02-05	1995-02-05 00:00:00	1995-02-05	581452		0	0	0		0	0	0	93161	0	43	40213306		
40515	883	40213160	1961-11-23	1961-11-23 00:00:00	1961-11-23	1961-11-23 00:00:00	1961-11-23	581452		0	0	0		0	0	0	58763	0	10	40213160		
198238	4355	40213160	1986-03-29	1986-03-29 00:00:00	1986-03-29	1986-03-29 00:00:00	1986-03-29	581452		0	0	0		0	0	0	288951	0	10	40213160		
122750	2698	40213160	1983-12-14	1983-12-14 00:00:00	1983-12-14	1983-12-14 00:00:00	1983-12-14	581452		0	0	0		0	0	0	178678	0	10	40213160		
61491	5116	19006318	1966-10-16	1966-10-16 00:00:00	1966-10-30	1966-10-30 00:00:00	1966-10-30	38000177		0	0	14		0	0	0	339951	0	105078	19006318		
758	61	1551192	1977-03-04	1977-03-04 00:00:00	1977-03-04	1977-03-04 00:00:00	1977-03-04	38000177		0	0	0		0	0	0	4182	0	312617	1551192		
1303	102	1127433	2010-03-10	2010-03-10 00:00:00	2010-03-24	2010-03-24 00:00:00	2010-03-24	38000177		0	0	14		0	0	0	7012	0	313782	1127433		
232469	5108	40213296	2001-02-11	2001-02-11 00:00:00	2001-02-11	2001-02-11 00:00:00	2001-02-11	581452		0	0	0		0	0	0	339428	0	52	40213296		
203776	4473	40213306	1993-09-26	1993-09-26 00:00:00	1993-09-26	1993-09-26 00:00:00	1993-09-26	581452		0	0	0		0	0	0	297619	0	43	40213306		
2235	180	43012754	2003-02-14	2003-02-14 00:00:00	2004-02-09	2004-02-09 00:00:00	2004-02-09	38000177		0	0	360		0	0	0	12078	0	1366343	43012754		
38691	3196	1127433	1984-12-18	1984-12-18 00:00:00	1984-12-25	1984-12-25 00:00:00	1984-12-25	38000177		0	0	7		0	0	0	212612	0	313782	1127433		
29459	2438	1127433	2014-01-12	2014-01-12 00:00:00	2014-01-19	2014-01-19 00:00:00	2014-01-19	38000177		0	0	7		0	0	0	161753	0	313782	1127433		
42204	3501	1127433	1995-07-13	1995-07-13 00:00:00	1995-07-27	1995-07-27 00:00:00	1995-07-27	38000177		0	0	14		0	0	0	232061	0	313782	1127433		
52758	1154	40213227	1993-05-09	1993-05-09 00:00:00	1993-05-09	1993-05-09 00:00:00	1993-05-09	581452		0	0	0		0	0	0	76235	0	113	40213227		
217137	4764	40213160	1969-01-29	1969-01-29 00:00:00	1969-01-29	1969-01-29 00:00:00	1969-01-29	581452		0	0	0		0	0	0	317505	0	10	40213160		
30435	2522	40162522	2000-07-24	2000-07-24 00:00:00	2000-07-24	2000-07-24 00:00:00	\N	38000177		0	0	0		0	0	0	166789	0	857005	40162522		
46667	3866	19133873	1966-02-10	1966-02-10 00:00:00	1966-02-17	1966-02-17 00:00:00	1966-02-17	38000177		0	0	7		0	0	0	256684	0	834061	19133873		
29797	2468	1713671	2012-04-27	2012-04-27 00:00:00	2012-05-18	2012-05-18 00:00:00	2012-05-18	38000177		0	0	21		0	0	0	163654	0	562251	1713671		
203509	4467	40213227	1993-08-26	1993-08-26 00:00:00	1993-08-26	1993-08-26 00:00:00	1993-08-26	581452		0	0	0		0	0	0	297227	0	113	40213227		
116494	2559	40213160	1958-10-25	1958-10-25 00:00:00	1958-10-25	1958-10-25 00:00:00	1958-10-25	581452		0	0	0		0	0	0	169533	0	10	40213160		
8360	180	40213314	1977-07-28	1977-07-28 00:00:00	1977-07-28	1977-07-28 00:00:00	1977-07-28	581452		0	0	0		0	0	0	12100	0	49	40213314		
172085	3783	40213201	2006-04-07	2006-04-07 00:00:00	2006-04-07	2006-04-07 00:00:00	2006-04-07	581452		0	0	0		0	0	0	251379	0	33	40213201		
61867	5146	1127433	2012-05-29	2012-05-29 00:00:00	2012-06-05	2012-06-05 00:00:00	2012-06-05	38000177		0	0	7		0	0	0	342113	0	313782	1127433		
31748	2631	1127433	1963-04-12	1963-04-12 00:00:00	1963-04-19	1963-04-19 00:00:00	1963-04-19	38000177		0	0	7		0	0	0	174051	0	313782	1127433		
133718	2936	40213227	1993-10-02	1993-10-02 00:00:00	1993-10-02	1993-10-02 00:00:00	1993-10-02	581452		0	0	0		0	0	0	195811	0	113	40213227		
230537	5066	40213296	2007-04-14	2007-04-14 00:00:00	2007-04-14	2007-04-14 00:00:00	2007-04-14	581452		0	0	0		0	0	0	336784	0	52	40213296		
195869	4304	40213160	1967-02-19	1967-02-19 00:00:00	1967-02-19	1967-02-19 00:00:00	1967-02-19	581452		0	0	0		0	0	0	285498	0	10	40213160		
31012	2570	19078461	2009-06-08	2009-06-08 00:00:00	2009-06-22	2009-06-22 00:00:00	2009-06-22	38000177		0	0	14		0	0	0	170199	0	310965	19078461		
150735	3315	40213160	1957-08-03	1957-08-03 00:00:00	1957-08-03	1957-08-03 00:00:00	1957-08-03	581452		0	0	0		0	0	0	220147	0	10	40213160		
4037	334	19078461	2009-09-12	2009-09-12 00:00:00	2009-10-12	2009-10-12 00:00:00	2009-10-12	38000177		0	0	30		0	0	0	22117	0	310965	19078461		
24537	2020	1124300	2006-05-10	2006-05-10 00:00:00	2006-05-10	2006-05-10 00:00:00	\N	38000177		0	0	0		0	0	0	134254	0	00781178901	45011828		
35077	2895	19008572	1985-12-27	1985-12-27 00:00:00	1985-12-27	1985-12-27 00:00:00	\N	38000177		0	0	0		0	0	0	192692	0	106258	19008572		
31213	2588	1127433	1966-06-22	1966-06-22 00:00:00	1966-06-29	1966-06-29 00:00:00	1966-06-29	38000177		0	0	7		0	0	0	171284	0	313782	1127433		
35139	2898	920300	2012-02-09	2012-02-09 00:00:00	2012-02-16	2012-02-16 00:00:00	2012-02-16	38000177		0	0	7		0	0	0	193098	0	311989	920300		
18372	1520	19133905	1982-08-31	1982-08-31 00:00:00	1982-09-10	1982-09-10 00:00:00	1982-09-10	38000177		0	0	10		0	0	0	101624	0	834102	19133905		
79829	1746	40213260	2006-11-09	2006-11-09 00:00:00	2006-11-09	2006-11-09 00:00:00	2006-11-09	581452		0	0	0		0	0	0	116811	0	121	40213260		
58113	4827	1127433	1963-08-27	1963-08-27 00:00:00	1963-10-26	1963-10-26 00:00:00	1963-10-26	38000177		0	0	60		0	0	0	321144	0	313782	1127433		
42439	924	40213306	1984-12-15	1984-12-15 00:00:00	1984-12-15	1984-12-15 00:00:00	1984-12-15	581452		0	0	0		0	0	0	61556	0	43	40213306		
62906	5228	920334	1966-09-25	1966-09-25 00:00:00	1966-10-02	1966-10-02 00:00:00	1966-10-02	38000177		0	0	7		0	0	0	347786	0	311995	920334		
2468	196	1127078	1956-04-08	1956-04-08 00:00:00	1956-04-22	1956-04-22 00:00:00	1956-04-22	38000177		0	0	14		0	0	0	13521	0	282464	1127078		
37683	3115	19133905	1987-03-20	1987-03-20 00:00:00	1987-03-28	1987-03-28 00:00:00	1987-03-28	38000177		0	0	8		0	0	0	207201	0	834102	19133905		
35976	2961	19128065	1986-09-17	1986-09-17 00:00:00	1987-09-12	1987-09-12 00:00:00	1987-09-12	38000177		0	0	360		0	0	0	197757	0	749882	19128065		
154414	3399	40213160	1983-10-18	1983-10-18 00:00:00	1983-10-18	1983-10-18 00:00:00	1983-10-18	581452		0	0	0		0	0	0	225495	0	10	40213160		
17209	371	40213296	2011-01-20	2011-01-20 00:00:00	2011-01-20	2011-01-20 00:00:00	2011-01-20	581452		0	0	0		0	0	0	24661	0	52	40213296		
43013	3566	1127433	1996-02-14	1996-02-14 00:00:00	1996-03-06	1996-03-06 00:00:00	1996-03-06	38000177		0	0	21		0	0	0	236952	0	313782	1127433		
63011	5236	19019979	1982-10-08	1982-10-08 00:00:00	1982-10-29	1982-10-29 00:00:00	1982-10-29	38000177		0	0	21		0	0	0	348425	0	198405	19019979		
100090	2192	40213227	1997-01-02	1997-01-02 00:00:00	1997-01-02	1997-01-02 00:00:00	1997-01-02	581452		0	0	0		0	0	0	146239	0	113	40213227		
60791	5056	40229134	2000-09-14	2000-09-14 00:00:00	2000-09-28	2000-09-28 00:00:00	2000-09-28	38000177		0	0	14		0	0	0	336124	0	1043400	40229134		
43968	958	40213160	1957-09-15	1957-09-15 00:00:00	1957-09-15	1957-09-15 00:00:00	1957-09-15	581452		0	0	0		0	0	0	63612	0	10	40213160		
28798	2380	920300	1998-06-13	1998-06-13 00:00:00	1998-06-20	1998-06-20 00:00:00	1998-06-20	38000177		0	0	7		0	0	0	158189	0	311989	920300		
4970	412	1127433	1960-01-11	1960-01-11 00:00:00	1960-01-18	1960-01-18 00:00:00	1960-01-18	38000177		0	0	7		0	0	0	27424	0	313782	1127433		
3864	321	19128065	1977-10-29	1977-10-29 00:00:00	1978-10-24	1978-10-24 00:00:00	1978-10-24	38000177		0	0	360		0	0	0	21325	0	749882	19128065		
15549	1297	40236824	2013-09-08	2013-09-08 00:00:00	2013-09-15	2013-09-15 00:00:00	2013-09-15	38000177		0	0	7		0	0	0	85733	0	1094107	40236824		
24198	1989	19133873	1954-02-05	1954-02-05 00:00:00	1954-02-13	1954-02-13 00:00:00	1954-02-13	38000177		0	0	8		0	0	0	132421	0	834061	19133873		
46213	3827	19059056	1959-08-10	1959-08-10 00:00:00	1959-09-14	1959-09-14 00:00:00	1959-09-14	38000177		0	0	35		0	0	0	254187	0	243670	19059056		
169245	3721	40213227	1995-06-30	1995-06-30 00:00:00	1995-06-30	1995-06-30 00:00:00	1995-06-30	581452		0	0	0		0	0	0	247356	0	113	40213227		
39187	3237	40222846	2007-03-22	2007-03-22 00:00:00	2007-03-22	2007-03-22 00:00:00	\N	38000177		0	0	0		0	0	0	215177	0	996740	40222846		
52684	4379	1127433	1997-07-08	1997-07-08 00:00:00	1997-07-15	1997-07-15 00:00:00	1997-07-15	38000177		0	0	7		0	0	0	290941	0	313782	1127433		
29658	2456	1127078	1961-01-06	1961-01-06 00:00:00	1961-01-20	1961-01-20 00:00:00	1961-01-20	38000177		0	0	14		0	0	0	162774	0	282464	1127078		
63251	5255	40229134	1991-07-28	1991-07-28 00:00:00	1991-08-04	1991-08-04 00:00:00	1991-08-04	38000177		0	0	7		0	0	0	349622	0	1043400	40229134		
63270	5256	19133905	2018-08-02	2018-08-02 00:00:00	2018-08-15	2018-08-15 00:00:00	2018-08-15	38000177		0	0	13		0	0	0	349777	0	834102	19133905		
51969	4321	1115171	2011-03-30	2011-03-30 00:00:00	2011-04-13	2011-04-13 00:00:00	2011-04-13	38000177		0	0	14		0	0	0	286753	0	849574	1115171		
227774	5001	40213227	2002-06-30	2002-06-30 00:00:00	2002-06-30	2002-06-30 00:00:00	2002-06-30	581452		0	0	0		0	0	0	332682	0	113	40213227		
22972	1892	920300	1999-08-02	1999-08-02 00:00:00	1999-08-09	1999-08-09 00:00:00	1999-08-09	38000177		0	0	7		0	0	0	126035	0	311989	920300		
64004	1401	40213296	2013-02-03	2013-02-03 00:00:00	2013-02-03	2013-02-03 00:00:00	2013-02-03	581452		0	0	0		0	0	0	93186	0	52	40213296		
40517	883	40213160	1962-02-22	1962-02-22 00:00:00	1962-02-22	1962-02-22 00:00:00	1962-02-22	581452		0	0	0		0	0	0	58824	0	10	40213160		
198240	4355	40213251	1984-03-24	1984-03-24 00:00:00	1984-03-24	1984-03-24 00:00:00	1984-03-24	581452		0	0	0		0	0	0	288981	0	21	40213251		
122759	2698	40213314	1983-09-14	1983-09-14 00:00:00	1983-09-14	1983-09-14 00:00:00	1983-09-14	581452		0	0	0		0	0	0	178657	0	49	40213314		
61492	5116	19059056	1966-10-16	1966-10-16 00:00:00	1966-10-30	1966-10-30 00:00:00	1966-10-30	38000177		0	0	14		0	0	0	339951	0	243670	19059056		
759	61	19133873	1977-12-03	1977-12-03 00:00:00	1977-12-12	1977-12-12 00:00:00	1977-12-12	38000177		0	0	9		0	0	0	4121	0	834061	19133873		
1304	102	19128022	1991-05-27	1991-05-27 00:00:00	1992-05-21	1992-05-21 00:00:00	1992-05-21	38000177		0	0	360		0	0	0	7000	0	749785	19128022		
232472	5108	40213160	1961-07-03	1961-07-03 00:00:00	1961-07-03	1961-07-03 00:00:00	1961-07-03	581452		0	0	0		0	0	0	339403	0	10	40213160		
203780	4474	40213306	1985-10-18	1985-10-18 00:00:00	1985-10-18	1985-10-18 00:00:00	1985-10-18	581452		0	0	0		0	0	0	297675	0	43	40213306		
2236	180	1118084	2012-09-29	2012-09-29 00:00:00	2012-09-29	2012-09-29 00:00:00	\N	38000177		0	0	0		0	0	0	12180	0	00025152531	44923712		
38692	3196	19059056	1975-08-23	1975-08-23 00:00:00	1975-09-06	1975-09-06 00:00:00	1975-09-06	38000177		0	0	14		0	0	0	212600	0	243670	19059056		
29460	2438	19133873	1995-01-03	1995-01-03 00:00:00	1995-01-14	1995-01-14 00:00:00	1995-01-14	38000177		0	0	11		0	0	0	161749	0	834061	19133873		
42205	3501	1127433	2017-12-27	2017-12-27 00:00:00	2018-01-17	2018-01-17 00:00:00	2018-01-17	38000177		0	0	21		0	0	0	232063	0	313782	1127433		
52759	1154	40213306	1993-05-09	1993-05-09 00:00:00	1993-05-09	1993-05-09 00:00:00	1993-05-09	581452		0	0	0		0	0	0	76235	0	43	40213306		
217138	4764	40213160	1969-04-30	1969-04-30 00:00:00	1969-04-30	1969-04-30 00:00:00	1969-04-30	581452		0	0	0		0	0	0	317501	0	10	40213160		
30436	2522	1127433	2000-07-24	2000-07-24 00:00:00	2000-09-22	2000-09-22 00:00:00	2000-09-22	38000177		0	0	60		0	0	0	166789	0	313782	1127433		
46668	3866	19059056	1953-03-24	1953-03-24 00:00:00	1953-04-07	1953-04-07 00:00:00	1953-04-07	38000177		0	0	14		0	0	0	256764	0	243670	19059056		
29798	2468	1124300	1976-01-21	1976-01-21 00:00:00	1976-01-21	1976-01-21 00:00:00	\N	38000177		0	0	0		0	0	0	163592	0	00781178901	45011828		
56499	1236	40213227	1992-04-16	1992-04-16 00:00:00	1992-04-16	1992-04-16 00:00:00	1992-04-16	581452		0	0	0		0	0	0	81396	0	113	40213227		
116500	2559	40213160	1958-07-26	1958-07-26 00:00:00	1958-07-26	1958-07-26 00:00:00	1958-07-26	581452		0	0	0		0	0	0	169657	0	10	40213160		
8361	180	40213160	1977-07-28	1977-07-28 00:00:00	1977-07-28	1977-07-28 00:00:00	1977-07-28	581452		0	0	0		0	0	0	12100	0	10	40213160		
220307	4835	40213227	2001-08-09	2001-08-09 00:00:00	2001-08-09	2001-08-09 00:00:00	2001-08-09	581452		0	0	0		0	0	0	321619	0	113	40213227		
61869	5146	40220960	2013-07-15	2013-07-15 00:00:00	2013-07-15	2013-07-15 00:00:00	2013-07-15	38000177		0	0	0		0	0	0	342126	0	1804799	40220960		
31749	2631	40222846	2013-08-26	2013-08-26 00:00:00	2013-08-26	2013-08-26 00:00:00	\N	38000177		0	0	0		0	0	0	174104	0	996740	40222846		
133719	2936	40213160	1963-02-09	1963-02-09 00:00:00	1963-02-09	1963-02-09 00:00:00	1963-02-09	581452		0	0	0		0	0	0	195785	0	10	40213160		
48392	1058	40213260	2006-09-30	2006-09-30 00:00:00	2006-09-30	2006-09-30 00:00:00	2006-09-30	581452		0	0	0		0	0	0	69462	0	121	40213260		
195871	4304	40213296	2009-11-29	2009-11-29 00:00:00	2009-11-29	2009-11-29 00:00:00	2009-11-29	581452		0	0	0		0	0	0	285464	0	52	40213296		
31013	2570	19073188	2004-03-22	2004-03-22 00:00:00	2004-04-05	2004-04-05 00:00:00	2004-04-05	38000177		0	0	14		0	0	0	170215	0	308192	19073188		
150738	3315	40213227	2008-05-03	2008-05-03 00:00:00	2008-05-03	2008-05-03 00:00:00	2008-05-03	581452		0	0	0		0	0	0	220194	0	113	40213227		
4038	334	19059056	1937-07-24	1937-07-24 00:00:00	1937-08-28	1937-08-28 00:00:00	1937-08-28	38000177		0	0	35		0	0	0	22112	0	243670	19059056		
24538	2020	19059056	1973-07-17	1973-07-17 00:00:00	1973-07-31	1973-07-31 00:00:00	1973-07-31	38000177		0	0	14		0	0	0	134247	0	243670	19059056		
35078	2895	1127433	1968-06-23	1968-06-23 00:00:00	1968-07-07	1968-07-07 00:00:00	1968-07-07	38000177		0	0	14		0	0	0	192717	0	313782	1127433		
31214	2588	1127433	1987-01-26	1987-01-26 00:00:00	1987-02-16	1987-02-16 00:00:00	1987-02-16	38000177		0	0	21		0	0	0	171311	0	313782	1127433		
35140	2898	40236824	2012-02-09	2012-02-09 00:00:00	2012-02-16	2012-02-16 00:00:00	2012-02-16	38000177		0	0	7		0	0	0	193098	0	1094107	40236824		
18373	1520	40229134	2002-09-22	2002-09-22 00:00:00	2002-09-29	2002-09-29 00:00:00	2002-09-29	38000177		0	0	7		0	0	0	101626	0	1043400	40229134		
79832	1746	40213198	2018-04-26	2018-04-26 00:00:00	2018-04-26	2018-04-26 00:00:00	2018-04-26	581452		0	0	0		0	0	0	116767	0	133	40213198		
58114	4827	19008572	1967-12-16	1967-12-16 00:00:00	1967-12-16	1967-12-16 00:00:00	\N	38000177		0	0	0		0	0	0	321112	0	106258	19008572		
42441	924	40213160	1963-12-07	1963-12-07 00:00:00	1963-12-07	1963-12-07 00:00:00	1963-12-07	581452		0	0	0		0	0	0	61572	0	10	40213160		
62907	5228	1713671	1956-07-23	1956-07-23 00:00:00	1956-08-06	1956-08-06 00:00:00	1956-08-06	38000177		0	0	14		0	0	0	347774	0	562251	1713671		
31905	2644	1118084	2014-11-19	2014-11-19 00:00:00	2014-11-19	2014-11-19 00:00:00	\N	38000177		0	0	0		0	0	0	174982	0	00025152531	44923712		
37684	3115	1310034	1991-01-04	1991-01-04 00:00:00	1991-01-04	1991-01-04 00:00:00	1991-01-04	38000177		0	0	0		0	0	0	207279	0	834357	1310034		
35977	2961	40229134	1994-06-29	1994-06-29 00:00:00	1994-07-13	1994-07-13 00:00:00	1994-07-13	38000177		0	0	14		0	0	0	197752	0	1043400	40229134		
154424	3399	40213314	1983-07-19	1983-07-19 00:00:00	1983-07-19	1983-07-19 00:00:00	1983-07-19	581452		0	0	0		0	0	0	225540	0	49	40213314		
17211	371	40213227	2011-01-20	2011-01-20 00:00:00	2011-01-20	2011-01-20 00:00:00	2011-01-20	581452		0	0	0		0	0	0	24661	0	113	40213227		
43014	3566	1127433	1992-01-01	1992-01-01 00:00:00	1992-01-15	1992-01-15 00:00:00	1992-01-15	38000177		0	0	14		0	0	0	236963	0	313782	1127433		
63012	5236	1124300	2009-05-19	2009-05-19 00:00:00	2009-05-19	2009-05-19 00:00:00	\N	38000177		0	0	0		0	0	0	348401	0	00781178901	45011828		
100093	2192	40213296	1997-01-16	1997-01-16 00:00:00	1997-01-16	1997-01-16 00:00:00	1997-01-16	581452		0	0	0		0	0	0	\N	0	52	40213296		
60792	5056	19075601	2003-05-22	2003-05-22 00:00:00	2003-05-22	2003-05-22 00:00:00	2003-05-22	38000177		0	0	0		0	0	0	336194	0	309362	19075601		
43976	958	40213260	2007-02-25	2007-02-25 00:00:00	2007-02-25	2007-02-25 00:00:00	2007-02-25	581452		0	0	0		0	0	0	63664	0	121	40213260		
28799	2380	40236824	1998-06-13	1998-06-13 00:00:00	1998-06-20	1998-06-20 00:00:00	1998-06-20	38000177		0	0	7		0	0	0	158189	0	1094107	40236824		
4972	412	19059056	1955-03-17	1955-03-17 00:00:00	1955-03-31	1955-03-31 00:00:00	1955-03-31	38000177		0	0	14		0	0	0	27472	0	243670	19059056		
3865	321	19133905	1989-08-17	1989-08-17 00:00:00	1989-08-27	1989-08-27 00:00:00	1989-08-27	38000177		0	0	10		0	0	0	21272	0	834102	19133905		
15550	1297	920300	2013-09-08	2013-09-08 00:00:00	2013-09-15	2013-09-15 00:00:00	2013-09-15	38000177		0	0	7		0	0	0	85733	0	311989	920300		
24199	1989	40229134	1967-10-25	1967-10-25 00:00:00	1967-11-08	1967-11-08 00:00:00	1967-11-08	38000177		0	0	14		0	0	0	132407	0	1043400	40229134		
46226	3830	46233988	1982-07-13	1982-07-13 00:00:00	1982-07-27	1982-07-27 00:00:00	1982-07-27	38000177		0	0	14		0	0	0	254283	0	1652673	46233988		
169247	3721	40213227	2005-02-25	2005-02-25 00:00:00	2005-02-25	2005-02-25 00:00:00	2005-02-25	581452		0	0	0		0	0	0	247404	0	113	40213227		
39188	3237	19059056	1928-05-02	1928-05-02 00:00:00	1928-05-23	1928-05-23 00:00:00	1928-05-23	38000177		0	0	21		0	0	0	215148	0	243670	19059056		
52685	4379	19133905	2003-12-29	2003-12-29 00:00:00	2004-01-09	2004-01-09 00:00:00	2004-01-09	38000177		0	0	11		0	0	0	290974	0	834102	19133905		
29659	2456	19133873	1969-04-14	1969-04-14 00:00:00	1969-04-26	1969-04-26 00:00:00	1969-04-26	38000177		0	0	12		0	0	0	162826	0	834061	19133873		
63252	5255	1115171	1999-02-17	1999-02-17 00:00:00	1999-03-03	1999-03-03 00:00:00	1999-03-03	38000177		0	0	14		0	0	0	349703	0	849574	1115171		
63271	5256	19133873	1970-07-21	1970-07-21 00:00:00	1970-07-28	1970-07-28 00:00:00	1970-07-28	38000177		0	0	7		0	0	0	349742	0	834061	19133873		
51970	4321	1127433	2002-10-05	2002-10-05 00:00:00	2002-10-19	2002-10-19 00:00:00	2002-10-19	38000177		0	0	14		0	0	0	286755	0	313782	1127433		
227778	5001	40213160	1964-08-02	1964-08-02 00:00:00	1964-08-02	1964-08-02 00:00:00	1964-08-02	581452		0	0	0		0	0	0	332634	0	10	40213160		
22973	1892	1127433	1981-03-28	1981-03-28 00:00:00	1981-04-28	1981-04-28 00:00:00	1981-04-28	38000177		0	0	31		0	0	0	126027	0	313782	1127433		
64015	1401	40213160	1973-10-07	1973-10-07 00:00:00	1973-10-07	1973-10-07 00:00:00	1973-10-07	581452		0	0	0		0	0	0	93171	0	10	40213160		
64031	1401	40213227	2004-02-15	2004-02-15 00:00:00	2004-02-15	2004-02-15 00:00:00	2004-02-15	581452		0	0	0		0	0	0	93164	0	113	40213227		
75387	1646	40213227	2011-12-24	2011-12-24 00:00:00	2011-12-24	2011-12-24 00:00:00	2011-12-24	581452		0	0	0		0	0	0	110416	0	113	40213227		
122760	2698	40213160	1983-09-14	1983-09-14 00:00:00	1983-09-14	1983-09-14 00:00:00	1983-09-14	581452		0	0	0		0	0	0	178657	0	10	40213160		
61493	5116	1127433	1998-03-25	1998-03-25 00:00:00	1998-04-01	1998-04-01 00:00:00	1998-04-01	38000177		0	0	7		0	0	0	340007	0	313782	1127433		
174463	3836	40213251	1984-03-09	1984-03-09 00:00:00	1984-03-09	1984-03-09 00:00:00	1984-03-09	581452		0	0	0		0	0	0	254699	0	21	40213251		
1305	102	1713671	1989-07-03	1989-07-03 00:00:00	1989-10-02	1989-10-02 00:00:00	1989-10-02	38000177		0	0	91		0	0	0	6998	0	562251	1713671		
232481	5108	40213160	1961-10-02	1961-10-02 00:00:00	1961-10-02	1961-10-02 00:00:00	1961-10-02	581452		0	0	0		0	0	0	339368	0	10	40213160		
203782	4474	40213227	1994-08-12	1994-08-12 00:00:00	1994-08-12	1994-08-12 00:00:00	1994-08-12	581452		0	0	0		0	0	0	297678	0	113	40213227		
2237	180	19133873	1983-09-28	1983-09-28 00:00:00	1983-10-06	1983-10-06 00:00:00	1983-10-06	38000177		0	0	8		0	0	0	12163	0	834061	19133873		
38705	3199	1127078	1980-08-22	1980-08-22 00:00:00	1980-09-19	1980-09-19 00:00:00	1980-09-19	38000177		0	0	28		0	0	0	212768	0	282464	1127078		
29461	2438	19128022	1997-06-03	1997-06-03 00:00:00	1998-05-29	1998-05-29 00:00:00	1998-05-29	38000177		0	0	360		0	0	0	161741	0	749785	19128022		
42206	3501	19059056	1968-02-17	1968-02-17 00:00:00	1968-03-23	1968-03-23 00:00:00	1968-03-23	38000177		0	0	35		0	0	0	232078	0	243670	19059056		
78923	1727	40213227	2000-04-06	2000-04-06 00:00:00	2000-04-06	2000-04-06 00:00:00	2000-04-06	581452		0	0	0		0	0	0	115427	0	113	40213227		
217143	4764	40213227	2001-07-25	2001-07-25 00:00:00	2001-07-25	2001-07-25 00:00:00	2001-07-25	581452		0	0	0		0	0	0	317513	0	113	40213227		
30438	2522	19128065	1976-06-16	1976-06-16 00:00:00	1977-06-11	1977-06-11 00:00:00	1977-06-11	38000177		0	0	360		0	0	0	166832	0	749882	19128065		
46669	3866	19006318	1953-03-24	1953-03-24 00:00:00	1953-04-07	1953-04-07 00:00:00	1953-04-07	38000177		0	0	14		0	0	0	256764	0	105078	19006318		
29799	2468	1127433	1985-01-08	1985-01-08 00:00:00	1985-02-05	1985-02-05 00:00:00	1985-02-05	38000177		0	0	28		0	0	0	163677	0	313782	1127433		
56536	1238	40213160	1956-04-17	1956-04-17 00:00:00	1956-04-17	1956-04-17 00:00:00	1956-04-17	581452		0	0	0		0	0	0	81578	0	10	40213160		
116508	2559	40213227	1992-03-28	1992-03-28 00:00:00	1992-03-28	1992-03-28 00:00:00	1992-03-28	581452		0	0	0		0	0	0	169646	0	113	40213227		
59543	4949	19128022	1995-08-02	1995-08-02 00:00:00	1996-07-27	1996-07-27 00:00:00	1996-07-27	38000177		0	0	360		0	0	0	329041	0	749785	19128022		
220312	4835	40213227	1992-07-30	1992-07-30 00:00:00	1992-07-30	1992-07-30 00:00:00	1992-07-30	581452		0	0	0		0	0	0	321676	0	113	40213227		
61870	5146	19075601	2013-07-15	2013-07-15 00:00:00	2013-07-15	2013-07-15 00:00:00	2013-07-15	38000177		0	0	0		0	0	0	342126	0	309362	19075601		
31750	2631	1127078	1955-07-14	1955-07-14 00:00:00	1955-07-28	1955-07-28 00:00:00	1955-07-28	38000177		0	0	14		0	0	0	174082	0	282464	1127078		
214780	4709	40213227	2017-07-10	2017-07-10 00:00:00	2017-07-10	2017-07-10 00:00:00	2017-07-10	581452		0	0	0		0	0	0	313669	0	113	40213227		
48398	1058	40213260	2007-10-06	2007-10-06 00:00:00	2007-10-06	2007-10-06 00:00:00	2007-10-06	581452		0	0	0		0	0	0	69356	0	121	40213260		
195883	4304	40213260	2016-12-18	2016-12-18 00:00:00	2016-12-18	2016-12-18 00:00:00	2016-12-18	581452		0	0	0		0	0	0	285497	0	121	40213260		
31014	2570	1115171	2004-03-22	2004-03-22 00:00:00	2004-04-05	2004-04-05 00:00:00	2004-04-05	38000177		0	0	14		0	0	0	170215	0	849574	1115171		
150739	3315	40213260	2008-05-03	2008-05-03 00:00:00	2008-05-03	2008-05-03 00:00:00	2008-05-03	581452		0	0	0		0	0	0	220194	0	121	40213260		
4039	334	19077572	2010-07-14	2010-07-14 00:00:00	2010-07-14	2010-07-14 00:00:00	\N	38000177		0	0	0		0	0	0	22169	0	310436	19077572		
24539	2020	46233988	1973-07-17	1973-07-17 00:00:00	1973-07-31	1973-07-31 00:00:00	1973-07-31	38000177		0	0	14		0	0	0	134247	0	1652673	46233988		
35079	2895	19059056	1962-04-16	1962-04-16 00:00:00	1962-04-30	1962-04-30 00:00:00	1962-04-30	38000177		0	0	14		0	0	0	192722	0	243670	19059056		
31215	2588	19133905	1994-09-04	1994-09-04 00:00:00	1994-09-17	1994-09-17 00:00:00	1994-09-17	38000177		0	0	13		0	0	0	171245	0	834102	19133905		
35141	2898	19019979	1980-03-24	1980-03-24 00:00:00	1980-04-07	1980-04-07 00:00:00	1980-04-07	38000177		0	0	14		0	0	0	193082	0	198405	19019979		
18374	1520	40229134	1969-08-08	1969-08-08 00:00:00	1969-08-15	1969-08-15 00:00:00	1969-08-15	38000177		0	0	7		0	0	0	101633	0	1043400	40229134		
91113	1999	40213251	1984-10-05	1984-10-05 00:00:00	1984-10-05	1984-10-05 00:00:00	1984-10-05	581452		0	0	0		0	0	0	133049	0	21	40213251		
58115	4827	1713671	2014-12-17	2014-12-17 00:00:00	2014-12-31	2014-12-31 00:00:00	2014-12-31	38000177		0	0	14		0	0	0	321193	0	562251	1713671		
42447	925	40213296	2009-05-15	2009-05-15 00:00:00	2009-05-15	2009-05-15 00:00:00	2009-05-15	581452		0	0	0		0	0	0	61615	0	52	40213296		
62908	5228	19059056	1941-01-01	1941-01-01 00:00:00	1941-04-01	1941-04-01 00:00:00	1941-04-01	38000177		0	0	90		0	0	0	347860	0	243670	19059056		
31906	2644	1713671	2004-03-20	2004-03-20 00:00:00	2004-03-27	2004-03-27 00:00:00	2004-03-27	38000177		0	0	7		0	0	0	174972	0	562251	1713671		
37685	3115	46275916	1991-01-04	1991-01-04 00:00:00	1991-01-04	1991-01-04 00:00:00	1991-01-04	38000177		0	0	0		0	0	0	207279	0	1660014	46275916		
35978	2961	1118084	2007-11-01	2007-11-01 00:00:00	2007-11-01	2007-11-01 00:00:00	\N	38000177		0	0	0		0	0	0	197726	0	00025152531	44923712		
154425	3399	40213160	1983-07-19	1983-07-19 00:00:00	1983-07-19	1983-07-19 00:00:00	1983-07-19	581452		0	0	0		0	0	0	225540	0	10	40213160		
17215	371	40213260	2018-02-08	2018-02-08 00:00:00	2018-02-08	2018-02-08 00:00:00	2018-02-08	581452		0	0	0		0	0	0	24679	0	121	40213260		
43015	3566	1127078	1957-03-21	1957-03-21 00:00:00	1957-04-04	1957-04-04 00:00:00	1957-04-04	38000177		0	0	14		0	0	0	236949	0	282464	1127078		
63013	5236	19129655	1976-10-09	1976-10-09 00:00:00	1976-10-23	1976-10-23 00:00:00	1976-10-23	38000177		0	0	14		0	0	0	348395	0	789980	19129655		
100097	2192	40213160	1959-11-26	1959-11-26 00:00:00	1959-11-26	1959-11-26 00:00:00	1959-11-26	581452		0	0	0		0	0	0	146144	0	10	40213160		
60793	5056	40220960	2003-05-22	2003-05-22 00:00:00	2003-05-22	2003-05-22 00:00:00	2003-05-22	38000177		0	0	0		0	0	0	336194	0	1804799	40220960		
43982	958	40213160	1957-06-16	1957-06-16 00:00:00	1957-06-16	1957-06-16 00:00:00	1957-06-16	581452		0	0	0		0	0	0	63639	0	10	40213160		
28800	2380	1127433	1960-04-20	1960-04-20 00:00:00	1960-05-04	1960-05-04 00:00:00	1960-05-04	38000177		0	0	14		0	0	0	158184	0	313782	1127433		
4973	412	19006318	1955-03-17	1955-03-17 00:00:00	1955-03-31	1955-03-31 00:00:00	1955-03-31	38000177		0	0	14		0	0	0	27472	0	105078	19006318		
3866	321	40229134	1991-12-29	1991-12-29 00:00:00	1992-01-12	1992-01-12 00:00:00	1992-01-12	38000177		0	0	14		0	0	0	21258	0	1043400	40229134		
15551	1297	1713671	1981-05-09	1981-05-09 00:00:00	1981-05-23	1981-05-23 00:00:00	1981-05-23	38000177		0	0	14		0	0	0	85705	0	562251	1713671		
24200	1990	1127078	1968-06-15	1968-06-15 00:00:00	1968-06-29	1968-06-29 00:00:00	1968-06-29	38000177		0	0	14		0	0	0	132545	0	282464	1127078		
44632	971	40213227	2005-09-02	2005-09-02 00:00:00	2005-09-02	2005-09-02 00:00:00	2005-09-02	581452		0	0	0		0	0	0	64643	0	113	40213227		
46227	3830	1127078	1982-07-13	1982-07-13 00:00:00	1982-07-27	1982-07-27 00:00:00	1982-07-27	38000177		0	0	14		0	0	0	254283	0	282464	1127078		
39189	3238	40169281	2018-03-12	2018-03-12 00:00:00	2018-03-12	2018-03-12 00:00:00	\N	38000177		0	0	0		0	0	0	215287	0	896209	40169281		
52686	4380	1127433	1977-04-23	1977-04-23 00:00:00	1977-04-30	1977-04-30 00:00:00	1977-04-30	38000177		0	0	7		0	0	0	291030	0	313782	1127433		
29667	2458	19128065	1988-04-29	1988-04-29 00:00:00	1989-04-24	1989-04-24 00:00:00	1989-04-24	38000177		0	0	360		0	0	0	162980	0	749882	19128065		
63254	5255	1127433	2004-06-04	2004-06-04 00:00:00	2004-06-18	2004-06-18 00:00:00	2004-06-18	38000177		0	0	14		0	0	0	349704	0	313782	1127433		
63272	5256	920334	1983-12-10	1983-12-10 00:00:00	1983-12-17	1983-12-17 00:00:00	1983-12-17	38000177		0	0	7		0	0	0	349745	0	311995	920334		
51971	4321	1127433	1968-09-30	1968-09-30 00:00:00	1968-10-07	1968-10-07 00:00:00	1968-10-07	38000177		0	0	7		0	0	0	286754	0	313782	1127433		
227780	5001	40213160	1960-01-31	1960-01-31 00:00:00	1960-01-31	1960-01-31 00:00:00	1960-01-31	581452		0	0	0		0	0	0	332659	0	10	40213160		
22974	1892	1124300	1993-09-19	1993-09-19 00:00:00	1993-09-19	1993-09-19 00:00:00	\N	38000177		0	0	0		0	0	0	126011	0	00781178901	45011828		
64019	1401	40213160	1973-07-08	1973-07-08 00:00:00	1973-07-08	1973-07-08 00:00:00	1973-07-08	581452		0	0	0		0	0	0	93180	0	10	40213160		
170940	3757	40213227	2016-10-05	2016-10-05 00:00:00	2016-10-05	2016-10-05 00:00:00	2016-10-05	581452		0	0	0		0	0	0	249799	0	113	40213227		
75389	1646	40213227	2002-02-02	2002-02-02 00:00:00	2002-02-02	2002-02-02 00:00:00	2002-02-02	581452		0	0	0		0	0	0	110406	0	113	40213227		
122761	2699	40213160	1971-07-27	1971-07-27 00:00:00	1971-07-27	1971-07-27 00:00:00	1971-07-27	581452		0	0	0		0	0	0	178757	0	10	40213160		
61494	5117	1127433	1993-07-02	1993-07-02 00:00:00	1993-07-09	1993-07-09 00:00:00	1993-07-09	38000177		0	0	7		0	0	0	340070	0	313782	1127433		
174470	3836	40213160	1982-02-26	1982-02-26 00:00:00	1982-02-26	1982-02-26 00:00:00	1982-02-26	581452		0	0	0		0	0	0	254698	0	10	40213160		
1306	102	19128065	1992-05-21	1992-05-21 00:00:00	1993-05-16	1993-05-16 00:00:00	1993-05-16	38000177		0	0	360		0	0	0	6981	0	749882	19128065		
232487	5108	40213227	2002-03-17	2002-03-17 00:00:00	2002-03-17	2002-03-17 00:00:00	2002-03-17	581452		0	0	0		0	0	0	339377	0	113	40213227		
203795	4474	40213227	2005-06-17	2005-06-17 00:00:00	2005-06-17	2005-06-17 00:00:00	2005-06-17	581452		0	0	0		0	0	0	297666	0	113	40213227		
2238	180	920300	1997-05-18	1997-05-18 00:00:00	1997-05-25	1997-05-25 00:00:00	1997-05-25	38000177		0	0	7		0	0	0	12148	0	311989	920300		
38706	3199	1127433	2012-04-14	2012-04-14 00:00:00	2012-04-21	2012-04-21 00:00:00	2012-04-21	38000177		0	0	7		0	0	0	212736	0	313782	1127433		
29462	2438	1115171	2017-11-05	2017-11-05 00:00:00	2017-11-19	2017-11-19 00:00:00	2017-11-19	38000177		0	0	14		0	0	0	161722	0	849574	1115171		
42230	3504	1713671	1939-11-24	1939-11-24 00:00:00	1939-12-15	1939-12-15 00:00:00	1939-12-15	38000177		0	0	21		0	0	0	232290	0	562251	1713671		
90224	1980	40213306	1995-05-21	1995-05-21 00:00:00	1995-05-21	1995-05-21 00:00:00	1995-05-21	581452		0	0	0		0	0	0	131773	0	43	40213306		
217145	4764	40213260	2018-08-29	2018-08-29 00:00:00	2018-08-29	2018-08-29 00:00:00	2018-08-29	581452		0	0	0		0	0	0	317490	0	121	40213260		
12945	1088	1127433	1988-01-29	1988-01-29 00:00:00	1988-02-19	1988-02-19 00:00:00	1988-02-19	38000177		0	0	21		0	0	0	71423	0	313782	1127433		
46671	3866	920300	2004-11-04	2004-11-04 00:00:00	2004-11-11	2004-11-11 00:00:00	2004-11-11	38000177		0	0	7		0	0	0	256715	0	311989	920300		
29800	2468	1127433	2016-10-07	2016-10-07 00:00:00	2016-10-21	2016-10-21 00:00:00	2016-10-21	38000177		0	0	14		0	0	0	163679	0	313782	1127433		
214159	4696	40213201	2017-06-14	2017-06-14 00:00:00	2017-06-14	2017-06-14 00:00:00	2017-06-14	581452		0	0	0		0	0	0	312877	0	33	40213201		
35037	764	40213160	1969-12-23	1969-12-23 00:00:00	1969-12-23	1969-12-23 00:00:00	1969-12-23	581452		0	0	0		0	0	0	50827	0	10	40213160		
59544	4949	1713671	1997-06-15	1997-06-15 00:00:00	1997-06-29	1997-06-29 00:00:00	1997-06-29	38000177		0	0	14		0	0	0	329000	0	562251	1713671		
220313	4835	40213306	1992-07-30	1992-07-30 00:00:00	1992-07-30	1992-07-30 00:00:00	1992-07-30	581452		0	0	0		0	0	0	321676	0	43	40213306		
61871	5146	1127433	1947-03-04	1947-03-04 00:00:00	1947-03-11	1947-03-11 00:00:00	1947-03-11	38000177		0	0	7		0	0	0	342084	0	313782	1127433		
31751	2631	19059056	1954-09-24	1954-09-24 00:00:00	1954-10-08	1954-10-08 00:00:00	1954-10-08	38000177		0	0	14		0	0	0	174068	0	243670	19059056		
214787	4709	40213227	2007-05-14	2007-05-14 00:00:00	2007-05-14	2007-05-14 00:00:00	2007-05-14	581452		0	0	0		0	0	0	313712	0	113	40213227		
93667	2056	40213227	2018-02-21	2018-02-21 00:00:00	2018-02-21	2018-02-21 00:00:00	2018-02-21	581452		0	0	0		0	0	0	136740	0	113	40213227		
195884	4304	40213160	1966-12-18	1966-12-18 00:00:00	1966-12-18	1966-12-18 00:00:00	1966-12-18	581452		0	0	0		0	0	0	285489	0	10	40213160		
31015	2570	40229134	1936-10-17	1936-10-17 00:00:00	1936-10-24	1936-10-24 00:00:00	1936-10-24	38000177		0	0	7		0	0	0	170192	0	1043400	40229134		
150744	3315	40213296	1999-05-08	1999-05-08 00:00:00	1999-05-08	1999-05-08 00:00:00	1999-05-08	581452		0	0	0		0	0	0	220185	0	52	40213296		
4040	334	1118084	1972-10-18	1972-10-18 00:00:00	1972-10-18	1972-10-18 00:00:00	\N	38000177		0	0	0		0	0	0	22127	0	00025152531	44923712		
24540	2020	19133873	1983-12-06	1983-12-06 00:00:00	1983-12-19	1983-12-19 00:00:00	1983-12-19	38000177		0	0	13		0	0	0	134278	0	834061	19133873		
35080	2895	19129655	1962-04-16	1962-04-16 00:00:00	1962-04-30	1962-04-30 00:00:00	1962-04-30	38000177		0	0	14		0	0	0	192722	0	789980	19129655		
31216	2588	19059056	1969-06-05	1969-06-05 00:00:00	1969-06-19	1969-06-19 00:00:00	1969-06-19	38000177		0	0	14		0	0	0	171307	0	243670	19059056		
35142	2898	19073183	1980-03-24	1980-03-24 00:00:00	1980-04-07	1980-04-07 00:00:00	1980-04-07	38000177		0	0	14		0	0	0	193082	0	308182	19073183		
18375	1520	19059056	1955-02-19	1955-02-19 00:00:00	1955-03-12	1955-03-12 00:00:00	1955-03-12	38000177		0	0	21		0	0	0	101708	0	243670	19059056		
91118	1999	40213314	1978-03-03	1978-03-03 00:00:00	1978-03-03	1978-03-03 00:00:00	1978-03-03	581452		0	0	0		0	0	0	133062	0	49	40213314		
58116	4827	1127433	1982-05-20	1982-05-20 00:00:00	1982-05-27	1982-05-27 00:00:00	1982-05-27	38000177		0	0	7		0	0	0	321158	0	313782	1127433		
42450	925	40213160	1973-11-09	1973-11-09 00:00:00	1973-11-09	1973-11-09 00:00:00	1973-11-09	581452		0	0	0		0	0	0	61624	0	10	40213160		
4583	99	40213160	1959-04-04	1959-04-04 00:00:00	1959-04-04	1959-04-04 00:00:00	1959-04-04	581452		0	0	0		0	0	0	6702	0	10	40213160		
31907	2644	1713671	1988-06-07	1988-06-07 00:00:00	1988-06-21	1988-06-21 00:00:00	1988-06-21	38000177		0	0	14		0	0	0	174962	0	562251	1713671		
37686	3115	40243436	1991-01-04	1991-01-04 00:00:00	1991-01-04	1991-01-04 00:00:00	1991-01-04	38000177		0	0	0		0	0	0	207279	0	1190795	40243436		
35979	2961	1713671	1990-10-28	1990-10-28 00:00:00	1990-11-18	1990-11-18 00:00:00	1990-11-18	38000177		0	0	21		0	0	0	197710	0	562251	1713671		
154427	3399	40213251	1984-04-16	1984-04-16 00:00:00	1984-04-16	1984-04-16 00:00:00	1984-04-16	581452		0	0	0		0	0	0	225541	0	21	40213251		
17223	371	40213260	2019-02-14	2019-02-14 00:00:00	2019-02-14	2019-02-14 00:00:00	2019-02-14	581452		0	0	0		0	0	0	24711	0	121	40213260		
43016	3566	1127078	1954-06-07	1954-06-07 00:00:00	1954-07-05	1954-07-05 00:00:00	1954-07-05	38000177		0	0	28		0	0	0	236948	0	282464	1127078		
63014	5236	19019979	1976-10-09	1976-10-09 00:00:00	1976-10-23	1976-10-23 00:00:00	1976-10-23	38000177		0	0	14		0	0	0	348395	0	198405	19019979		
100103	2192	40213160	1955-06-02	1955-06-02 00:00:00	1955-06-02	1955-06-02 00:00:00	1955-06-02	581452		0	0	0		0	0	0	146186	0	10	40213160		
60794	5056	1127433	1955-08-08	1955-08-08 00:00:00	1955-09-05	1955-09-05 00:00:00	1955-09-05	38000177		0	0	28		0	0	0	336163	0	313782	1127433		
12567	1057	1127433	2002-05-21	2002-05-21 00:00:00	2002-06-18	2002-06-18 00:00:00	2002-06-18	38000177		0	0	28		0	0	0	69304	0	313782	1127433		
28801	2380	1127433	2002-09-28	2002-09-28 00:00:00	2002-10-12	2002-10-12 00:00:00	2002-10-12	38000177		0	0	14		0	0	0	158190	0	313782	1127433		
4974	412	1127433	2004-02-18	2004-02-18 00:00:00	2004-03-03	2004-03-03 00:00:00	2004-03-03	38000177		0	0	14		0	0	0	27453	0	313782	1127433		
3867	321	19128065	1976-11-03	1976-11-03 00:00:00	1977-10-29	1977-10-29 00:00:00	1977-10-29	38000177		0	0	360		0	0	0	21324	0	749882	19128065		
15552	1297	19019979	1981-10-26	1981-10-26 00:00:00	1981-11-09	1981-11-09 00:00:00	1981-11-09	38000177		0	0	14		0	0	0	85708	0	198405	19019979		
24201	1990	19133905	1996-05-21	1996-05-21 00:00:00	1996-06-01	1996-06-01 00:00:00	1996-06-01	38000177		0	0	11		0	0	0	132537	0	834102	19133905		
44633	971	40213198	2010-02-05	2010-02-05 00:00:00	2010-02-05	2010-02-05 00:00:00	2010-02-05	581452		0	0	0		0	0	0	64602	0	133	40213198		
46228	3830	1713671	2007-07-21	2007-07-21 00:00:00	2007-08-11	2007-08-11 00:00:00	2007-08-11	38000177		0	0	21		0	0	0	254300	0	562251	1713671		
39190	3238	19133905	2009-01-13	2009-01-13 00:00:00	2009-01-24	2009-01-24 00:00:00	2009-01-24	38000177		0	0	11		0	0	0	215262	0	834102	19133905		
52687	4380	19059056	1980-04-26	1980-04-26 00:00:00	1980-05-17	1980-05-17 00:00:00	1980-05-17	38000177		0	0	21		0	0	0	290996	0	243670	19059056		
29668	2458	19078461	1996-05-05	1996-05-05 00:00:00	1996-06-09	1996-06-09 00:00:00	1996-06-09	38000177		0	0	35		0	0	0	162943	0	310965	19078461		
63255	5255	1127433	1983-03-03	1983-03-03 00:00:00	1983-04-07	1983-04-07 00:00:00	1983-04-07	38000177		0	0	35		0	0	0	349701	0	313782	1127433		
63273	5256	1127433	1972-11-23	1972-11-23 00:00:00	1972-12-07	1972-12-07 00:00:00	1972-12-07	38000177		0	0	14		0	0	0	349749	0	313782	1127433		
51973	4321	1713671	1984-04-06	1984-04-06 00:00:00	1984-04-27	1984-04-27 00:00:00	1984-04-27	38000177		0	0	21		0	0	0	286704	0	562251	1713671		
227781	5001	40213296	1999-10-31	1999-10-31 00:00:00	1999-10-31	1999-10-31 00:00:00	1999-10-31	581452		0	0	0		0	0	0	332628	0	52	40213296		
22975	1892	1127433	2018-06-13	2018-06-13 00:00:00	2018-09-11	2018-09-11 00:00:00	2018-09-11	38000177		0	0	90		0	0	0	126049	0	313782	1127433		
64022	1401	40213160	1978-01-08	1978-01-08 00:00:00	1978-01-08	1978-01-08 00:00:00	1978-01-08	581452		0	0	0		0	0	0	93173	0	10	40213160		
170942	3757	40213227	2006-12-13	2006-12-13 00:00:00	2006-12-13	2006-12-13 00:00:00	2006-12-13	581452		0	0	0		0	0	0	249759	0	113	40213227		
93097	2043	40213227	2016-11-13	2016-11-13 00:00:00	2016-11-13	2016-11-13 00:00:00	2016-11-13	581452		0	0	0		0	0	0	135902	0	113	40213227		
122767	2699	40213296	2010-11-23	2010-11-23 00:00:00	2010-11-23	2010-11-23 00:00:00	2010-11-23	581452		0	0	0		0	0	0	178751	0	52	40213296		
61495	5117	19059056	1984-03-23	1984-03-23 00:00:00	1984-04-06	1984-04-06 00:00:00	1984-04-06	38000177		0	0	14		0	0	0	340143	0	243670	19059056		
174476	3836	40213314	1978-05-12	1978-05-12 00:00:00	1978-05-12	1978-05-12 00:00:00	1978-05-12	581452		0	0	0		0	0	0	254743	0	49	40213314		
232410	5107	40213296	2017-05-13	2017-05-13 00:00:00	2017-05-13	2017-05-13 00:00:00	2017-05-13	581452		0	0	0		0	0	0	339317	0	52	40213296		
232488	5108	40213296	2002-03-17	2002-03-17 00:00:00	2002-03-17	2002-03-17 00:00:00	2002-03-17	581452		0	0	0		0	0	0	339377	0	52	40213296		
203796	4474	40213296	2005-06-17	2005-06-17 00:00:00	2005-06-17	2005-06-17 00:00:00	2005-06-17	581452		0	0	0		0	0	0	297666	0	52	40213296		
2239	180	40236824	1997-05-18	1997-05-18 00:00:00	1997-05-25	1997-05-25 00:00:00	1997-05-25	38000177		0	0	7		0	0	0	12148	0	1094107	40236824		
38707	3199	1713671	2017-10-18	2017-10-18 00:00:00	2017-11-08	2017-11-08 00:00:00	2017-11-08	38000177		0	0	21		0	0	0	212732	0	562251	1713671		
29463	2438	1127433	1997-05-15	1997-05-15 00:00:00	1997-05-29	1997-05-29 00:00:00	1997-05-29	38000177		0	0	14		0	0	0	161755	0	313782	1127433		
42231	3504	19078461	1993-12-01	1993-12-01 00:00:00	1993-12-29	1993-12-29 00:00:00	1993-12-29	38000177		0	0	28		0	0	0	232335	0	310965	19078461		
90226	1980	40213227	1995-05-21	1995-05-21 00:00:00	1995-05-21	1995-05-21 00:00:00	1995-05-21	581452		0	0	0		0	0	0	131773	0	113	40213227		
133709	2936	40213160	1966-12-24	1966-12-24 00:00:00	1966-12-24	1966-12-24 00:00:00	1966-12-24	581452		0	0	0		0	0	0	195760	0	10	40213160		
12946	1088	1127078	1976-04-10	1976-04-10 00:00:00	1976-05-01	1976-05-01 00:00:00	1976-05-01	38000177		0	0	21		0	0	0	71422	0	282464	1127078		
46672	3866	40236824	2004-11-04	2004-11-04 00:00:00	2004-11-18	2004-11-18 00:00:00	2004-11-18	38000177		0	0	14		0	0	0	256715	0	1094107	40236824		
29801	2468	19059056	1943-05-14	1943-05-14 00:00:00	1943-05-28	1943-05-28 00:00:00	1943-05-28	38000177		0	0	14		0	0	0	163637	0	243670	19059056		
214167	4696	40213160	1956-01-25	1956-01-25 00:00:00	1956-01-25	1956-01-25 00:00:00	1956-01-25	581452		0	0	0		0	0	0	312902	0	10	40213160		
35040	764	40213160	1970-03-24	1970-03-24 00:00:00	1970-03-24	1970-03-24 00:00:00	1970-03-24	581452		0	0	0		0	0	0	50850	0	10	40213160		
59545	4949	19059056	1972-12-20	1972-12-20 00:00:00	1973-01-03	1973-01-03 00:00:00	1973-01-03	38000177		0	0	14		0	0	0	329011	0	243670	19059056		
220320	4835	40213160	1970-10-08	1970-10-08 00:00:00	1970-10-08	1970-10-08 00:00:00	1970-10-08	581452		0	0	0		0	0	0	321665	0	10	40213160		
61872	5146	1127433	1966-07-14	1966-07-14 00:00:00	1966-07-28	1966-07-28 00:00:00	1966-07-28	38000177		0	0	14		0	0	0	342133	0	313782	1127433		
31752	2631	19006318	1954-09-24	1954-09-24 00:00:00	1954-10-08	1954-10-08 00:00:00	1954-10-08	38000177		0	0	14		0	0	0	174068	0	105078	19006318		
214788	4709	40213260	2007-05-14	2007-05-14 00:00:00	2007-05-14	2007-05-14 00:00:00	2007-05-14	581452		0	0	0		0	0	0	313712	0	121	40213260		
93669	2056	40213227	2007-05-09	2007-05-09 00:00:00	2007-05-09	2007-05-09 00:00:00	2007-05-09	581452		0	0	0		0	0	0	136731	0	113	40213227		
129109	2839	40213160	1977-01-31	1977-01-31 00:00:00	1977-01-31	1977-01-31 00:00:00	1977-01-31	581452		0	0	0		0	0	0	188569	0	10	40213160		
31016	2570	40236824	1993-10-01	1993-10-01 00:00:00	1993-10-15	1993-10-15 00:00:00	1993-10-15	38000177		0	0	14		0	0	0	170273	0	1094107	40236824		
150746	3315	40213227	1999-05-08	1999-05-08 00:00:00	1999-05-08	1999-05-08 00:00:00	1999-05-08	581452		0	0	0		0	0	0	220185	0	113	40213227		
4041	334	1127433	1944-09-16	1944-09-16 00:00:00	1944-09-23	1944-09-23 00:00:00	1944-09-23	38000177		0	0	7		0	0	0	22164	0	313782	1127433		
24541	2020	19128065	1989-10-01	1989-10-01 00:00:00	1990-09-26	1990-09-26 00:00:00	1990-09-26	38000177		0	0	360		0	0	0	134268	0	749882	19128065		
35081	2895	1150837	1986-01-09	1986-01-09 00:00:00	1986-01-09	1986-01-09 00:00:00	\N	38000177		0	0	0		0	0	0	192693	0	141918	1150837		
31217	2588	1124300	2002-04-03	2002-04-03 00:00:00	2002-04-03	2002-04-03 00:00:00	\N	38000177		0	0	0		0	0	0	171279	0	00781178901	45011828		
35143	2899	1118084	1990-09-04	1990-09-04 00:00:00	1990-09-04	1990-09-04 00:00:00	\N	38000177		0	0	0		0	0	0	193188	0	00025152531	44923712		
31000	675	40213227	1999-10-26	1999-10-26 00:00:00	1999-10-26	1999-10-26 00:00:00	1999-10-26	581452		0	0	0		0	0	0	44701	0	113	40213227		
91119	1999	40213160	1978-03-03	1978-03-03 00:00:00	1978-03-03	1978-03-03 00:00:00	1978-03-03	581452		0	0	0		0	0	0	133062	0	10	40213160		
58117	4828	1713671	1969-09-02	1969-09-02 00:00:00	1969-09-16	1969-09-16 00:00:00	1969-09-16	38000177		0	0	14		0	0	0	321236	0	562251	1713671		
42453	925	40213160	1969-03-07	1969-03-07 00:00:00	1969-03-07	1969-03-07 00:00:00	1969-03-07	581452		0	0	0		0	0	0	61607	0	10	40213160		
4587	99	40213227	2000-11-25	2000-11-25 00:00:00	2000-11-25	2000-11-25 00:00:00	2000-11-25	581452		0	0	0		0	0	0	6766	0	113	40213227		
31908	2644	1127433	2018-10-28	2018-10-28 00:00:00	2018-11-04	2018-11-04 00:00:00	2018-11-04	38000177		0	0	7		0	0	0	174963	0	313782	1127433		
37687	3115	19059056	1973-02-08	1973-02-08 00:00:00	1973-03-01	1973-03-01 00:00:00	1973-03-01	38000177		0	0	21		0	0	0	207278	0	243670	19059056		
35980	2961	1115171	2004-03-06	2004-03-06 00:00:00	2004-04-03	2004-04-03 00:00:00	2004-04-03	38000177		0	0	28		0	0	0	197768	0	849574	1115171		
154428	3399	40213314	1984-04-16	1984-04-16 00:00:00	1984-04-16	1984-04-16 00:00:00	1984-04-16	581452		0	0	0		0	0	0	225541	0	49	40213314		
17225	371	40213227	2019-02-14	2019-02-14 00:00:00	2019-02-14	2019-02-14 00:00:00	2019-02-14	581452		0	0	0		0	0	0	24711	0	113	40213227		
43017	3566	19133905	1986-05-20	1986-05-20 00:00:00	1986-05-30	1986-05-30 00:00:00	1986-05-30	38000177		0	0	10		0	0	0	236921	0	834102	19133905		
63015	5236	1713671	1992-06-15	1992-06-15 00:00:00	1992-06-22	1992-06-22 00:00:00	1992-06-22	38000177		0	0	7		0	0	0	348420	0	562251	1713671		
100113	2192	40213227	2006-06-01	2006-06-01 00:00:00	2006-06-01	2006-06-01 00:00:00	2006-06-01	581452		0	0	0		0	0	0	146165	0	113	40213227		
60795	5056	1713671	1952-09-02	1952-09-02 00:00:00	1952-09-23	1952-09-23 00:00:00	1952-09-23	38000177		0	0	21		0	0	0	336185	0	562251	1713671		
12568	1057	1127433	1989-12-10	1989-12-10 00:00:00	1989-12-24	1989-12-24 00:00:00	1989-12-24	38000177		0	0	14		0	0	0	69291	0	313782	1127433		
28802	2380	1127433	1969-05-27	1969-05-27 00:00:00	1969-06-10	1969-06-10 00:00:00	1969-06-10	38000177		0	0	14		0	0	0	158227	0	313782	1127433		
4975	412	1127078	1958-03-20	1958-03-20 00:00:00	1958-04-03	1958-04-03 00:00:00	1958-04-03	38000177		0	0	14		0	0	0	27407	0	282464	1127078		
3868	321	1127433	1968-08-08	1968-08-08 00:00:00	1968-08-22	1968-08-22 00:00:00	1968-08-22	38000177		0	0	14		0	0	0	21290	0	313782	1127433		
15553	1297	19074843	1981-10-26	1981-10-26 00:00:00	1981-11-09	1981-11-09 00:00:00	1981-11-09	38000177		0	0	14		0	0	0	85708	0	309045	19074843		
24202	1990	19128065	1983-05-08	1983-05-08 00:00:00	1984-05-02	1984-05-02 00:00:00	1984-05-02	38000177		0	0	360		0	0	0	132527	0	749882	19128065		
44639	972	40213296	2006-06-07	2006-06-07 00:00:00	2006-06-07	2006-06-07 00:00:00	2006-06-07	581452		0	0	0		0	0	0	64680	0	52	40213296		
46229	3830	19078461	2005-08-11	2005-08-11 00:00:00	2005-09-15	2005-09-15 00:00:00	2005-09-15	38000177		0	0	35		0	0	0	254326	0	310965	19078461		
39191	3238	1713671	1987-01-17	1987-01-17 00:00:00	1987-02-07	1987-02-07 00:00:00	1987-02-07	38000177		0	0	21		0	0	0	215289	0	562251	1713671		
52688	4380	19133905	1994-06-08	1994-06-08 00:00:00	1994-06-20	1994-06-20 00:00:00	1994-06-20	38000177		0	0	12		0	0	0	291041	0	834102	19133905		
29670	2458	1115171	2003-03-05	2003-03-05 00:00:00	2003-04-02	2003-04-02 00:00:00	2003-04-02	38000177		0	0	28		0	0	0	162944	0	849574	1115171		
63257	5255	19129655	1961-05-17	1961-05-17 00:00:00	1961-05-31	1961-05-31 00:00:00	1961-05-31	38000177		0	0	14		0	0	0	349669	0	789980	19129655		
63274	5256	1127433	1965-07-16	1965-07-16 00:00:00	1965-07-23	1965-07-23 00:00:00	1965-07-23	38000177		0	0	7		0	0	0	349710	0	313782	1127433		
51974	4321	1713671	2015-08-23	2015-08-23 00:00:00	2015-09-13	2015-09-13 00:00:00	2015-09-13	38000177		0	0	21		0	0	0	286707	0	562251	1713671		
227791	5001	40213160	1960-07-03	1960-07-03 00:00:00	1960-07-03	1960-07-03 00:00:00	1960-07-03	581452		0	0	0		0	0	0	332631	0	10	40213160		
35751	2945	1127433	1974-03-01	1974-03-01 00:00:00	1974-04-05	1974-04-05 00:00:00	1974-04-05	38000177		0	0	35		0	0	0	196484	0	313782	1127433		
64025	1401	40213227	2015-02-08	2015-02-08 00:00:00	2015-02-08	2015-02-08 00:00:00	2015-02-08	581452		0	0	0		0	0	0	93152	0	113	40213227		
40335	879	40213227	2003-02-17	2003-02-17 00:00:00	2003-02-17	2003-02-17 00:00:00	2003-02-17	581452		0	0	0		0	0	0	58532	0	113	40213227		
93106	2043	40213160	1955-12-18	1955-12-18 00:00:00	1955-12-18	1955-12-18 00:00:00	1955-12-18	581452		0	0	0		0	0	0	135908	0	10	40213160		
122771	2699	40213160	1975-10-28	1975-10-28 00:00:00	1975-10-28	1975-10-28 00:00:00	1975-10-28	581452		0	0	0		0	0	0	178726	0	10	40213160		
61496	5117	1127433	1979-09-17	1979-09-17 00:00:00	1979-10-01	1979-10-01 00:00:00	1979-10-01	38000177		0	0	14		0	0	0	340094	0	313782	1127433		
174481	3836	40213160	1977-06-10	1977-06-10 00:00:00	1977-06-10	1977-06-10 00:00:00	1977-06-10	581452		0	0	0		0	0	0	254754	0	10	40213160		
232413	5107	40213314	1977-05-14	1977-05-14 00:00:00	1977-05-14	1977-05-14 00:00:00	1977-05-14	581452		0	0	0		0	0	0	339325	0	49	40213314		
232489	5108	40213306	1983-03-27	1983-03-27 00:00:00	1983-03-27	1983-03-27 00:00:00	1983-03-27	581452		0	0	0		0	0	0	339374	0	43	40213306		
203799	4474	40213260	2013-06-07	2013-06-07 00:00:00	2013-06-07	2013-06-07 00:00:00	2013-06-07	581452		0	0	0		0	0	0	297630	0	121	40213260		
2240	180	19128065	1995-03-28	1995-03-28 00:00:00	1996-03-22	1996-03-22 00:00:00	1996-03-22	38000177		0	0	360		0	0	0	12098	0	749882	19128065		
38708	3199	40229134	2009-12-28	2009-12-28 00:00:00	2010-01-11	2010-01-11 00:00:00	2010-01-11	38000177		0	0	14		0	0	0	212735	0	1043400	40229134		
29464	2438	40229134	1988-06-12	1988-06-12 00:00:00	1988-06-26	1988-06-26 00:00:00	1988-06-26	38000177		0	0	14		0	0	0	161768	0	1043400	40229134		
42232	3504	1127433	1967-06-22	1967-06-22 00:00:00	1967-07-06	1967-07-06 00:00:00	1967-07-06	38000177		0	0	14		0	0	0	232305	0	313782	1127433		
90227	1980	40213296	2014-02-09	2014-02-09 00:00:00	2014-02-09	2014-02-09 00:00:00	2014-02-09	581452		0	0	0		0	0	0	131828	0	52	40213296		
133713	2936	40213227	2004-06-12	2004-06-12 00:00:00	2004-06-12	2004-06-12 00:00:00	2004-06-12	581452		0	0	0		0	0	0	195778	0	113	40213227		
12947	1088	19133873	1975-08-18	1975-08-18 00:00:00	1975-08-26	1975-08-26 00:00:00	1975-08-26	38000177		0	0	8		0	0	0	71451	0	834061	19133873		
46673	3866	1713671	1951-06-11	1951-06-11 00:00:00	1951-06-25	1951-06-25 00:00:00	1951-06-25	38000177		0	0	14		0	0	0	256719	0	562251	1713671		
29802	2468	19059056	1939-04-05	1939-04-05 00:00:00	1939-04-19	1939-04-19 00:00:00	1939-04-19	38000177		0	0	14		0	0	0	163672	0	243670	19059056		
214168	4696	40213198	2016-06-08	2016-06-08 00:00:00	2016-06-08	2016-06-08 00:00:00	2016-06-08	581452		0	0	0		0	0	0	312842	0	133	40213198		
35044	764	40213296	2010-01-19	2010-01-19 00:00:00	2010-01-19	2010-01-19 00:00:00	2010-01-19	581452		0	0	0		0	0	0	50846	0	52	40213296		
59546	4949	19128022	1990-08-28	1990-08-28 00:00:00	1991-08-23	1991-08-23 00:00:00	1991-08-23	38000177		0	0	360		0	0	0	329012	0	749785	19128022		
220324	4835	40213296	2010-05-06	2010-05-06 00:00:00	2010-05-06	2010-05-06 00:00:00	2010-05-06	581452		0	0	0		0	0	0	321642	0	52	40213296		
61873	5146	19059056	1953-08-19	1953-08-19 00:00:00	1953-09-02	1953-09-02 00:00:00	1953-09-02	38000177		0	0	14		0	0	0	342082	0	243670	19059056		
31753	2631	19077572	2012-09-30	2012-09-30 00:00:00	2012-09-30	2012-09-30 00:00:00	\N	38000177		0	0	0		0	0	0	174036	0	310436	19077572		
93622	2054	40213160	1976-04-29	1976-04-29 00:00:00	1976-04-29	1976-04-29 00:00:00	1976-04-29	581452		0	0	0		0	0	0	136655	0	10	40213160		
93670	2056	40213314	1977-01-19	1977-01-19 00:00:00	1977-01-19	1977-01-19 00:00:00	1977-01-19	581452		0	0	0		0	0	0	136748	0	49	40213314		
129118	2839	40213160	1972-07-31	1972-07-31 00:00:00	1972-07-31	1972-07-31 00:00:00	1972-07-31	581452		0	0	0		0	0	0	188537	0	10	40213160		
31017	2570	920300	1993-10-01	1993-10-01 00:00:00	1993-10-08	1993-10-08 00:00:00	1993-10-08	38000177		0	0	7		0	0	0	170273	0	311989	920300		
150760	3315	40213160	1957-10-05	1957-10-05 00:00:00	1957-10-05	1957-10-05 00:00:00	1957-10-05	581452		0	0	0		0	0	0	220174	0	10	40213160		
4042	334	40222846	2012-06-03	2012-06-03 00:00:00	2012-06-03	2012-06-03 00:00:00	\N	38000177		0	0	0		0	0	0	22186	0	996740	40222846		
35027	2893	1127433	1973-09-11	1973-09-11 00:00:00	1973-10-11	1973-10-11 00:00:00	1973-10-11	38000177		0	0	30		0	0	0	192463	0	313782	1127433		
35082	2895	19133873	1967-07-06	1967-07-06 00:00:00	1967-07-14	1967-07-14 00:00:00	1967-07-14	38000177		0	0	8		0	0	0	192745	0	834061	19133873		
31218	2588	40169281	2014-08-31	2014-08-31 00:00:00	2014-08-31	2014-08-31 00:00:00	\N	38000177		0	0	0		0	0	0	171306	0	896209	40169281		
35144	2899	19059056	1953-01-18	1953-01-18 00:00:00	1953-02-01	1953-02-01 00:00:00	1953-02-01	38000177		0	0	14		0	0	0	193118	0	243670	19059056		
31004	675	40213201	2015-01-06	2015-01-06 00:00:00	2015-01-06	2015-01-06 00:00:00	2015-01-06	581452		0	0	0		0	0	0	44663	0	33	40213201		
16505	1368	19133905	1976-09-02	1976-09-02 00:00:00	1976-09-09	1976-09-09 00:00:00	1976-09-09	38000177		0	0	7		0	0	0	90708	0	834102	19133905		
58118	4828	19059056	1967-07-09	1967-07-09 00:00:00	1967-07-23	1967-07-23 00:00:00	1967-07-23	38000177		0	0	14		0	0	0	321255	0	243670	19059056		
42457	925	40213227	2000-03-17	2000-03-17 00:00:00	2000-03-17	2000-03-17 00:00:00	2000-03-17	581452		0	0	0		0	0	0	61594	0	113	40213227		
4588	99	40213296	2000-11-25	2000-11-25 00:00:00	2000-11-25	2000-11-25 00:00:00	2000-11-25	581452		0	0	0		0	0	0	6766	0	52	40213296		
31914	2646	40243436	2007-12-14	2007-12-14 00:00:00	2007-12-14	2007-12-14 00:00:00	2007-12-14	38000177		0	0	0		0	0	0	175085	0	1190795	40243436		
37688	3115	19059056	1972-01-15	1972-01-15 00:00:00	1972-03-15	1972-03-15 00:00:00	1972-03-15	38000177		0	0	60		0	0	0	207277	0	243670	19059056		
35982	2961	1127078	1976-11-27	1976-11-27 00:00:00	1976-12-11	1976-12-11 00:00:00	1976-12-11	38000177		0	0	14		0	0	0	197729	0	282464	1127078		
154435	3399	40213160	1983-05-17	1983-05-17 00:00:00	1983-05-17	1983-05-17 00:00:00	1983-05-17	581452		0	0	0		0	0	0	225494	0	10	40213160		
7588	639	1713671	1976-01-06	1976-01-06 00:00:00	1976-01-20	1976-01-20 00:00:00	1976-01-20	38000177		0	0	14		0	0	0	42300	0	562251	1713671		
43018	3566	1124300	1988-06-23	1988-06-23 00:00:00	1988-06-23	1988-06-23 00:00:00	\N	38000177		0	0	0		0	0	0	236921	0	00781178901	45011828		
63017	5236	1127433	2005-09-28	2005-09-28 00:00:00	2005-10-19	2005-10-19 00:00:00	2005-10-19	38000177		0	0	21		0	0	0	348427	0	313782	1127433		
100114	2192	40213260	2006-06-01	2006-06-01 00:00:00	2006-06-01	2006-06-01 00:00:00	2006-06-01	581452		0	0	0		0	0	0	146165	0	121	40213260		
60796	5056	40236824	1993-03-08	1993-03-08 00:00:00	1993-03-15	1993-03-15 00:00:00	1993-03-15	38000177		0	0	7		0	0	0	336132	0	1094107	40236824		
12569	1058	1127433	1961-12-08	1961-12-08 00:00:00	1961-12-22	1961-12-22 00:00:00	1961-12-22	38000177		0	0	14		0	0	0	69350	0	313782	1127433		
28803	2380	1127078	1950-08-25	1950-08-25 00:00:00	1950-09-08	1950-09-08 00:00:00	1950-09-08	38000177		0	0	14		0	0	0	158192	0	282464	1127078		
4978	412	1713671	1992-01-15	1992-01-15 00:00:00	1992-01-22	1992-01-22 00:00:00	1992-01-22	38000177		0	0	7		0	0	0	27451	0	562251	1713671		
3869	321	19128065	1979-10-19	1979-10-19 00:00:00	1980-10-13	1980-10-13 00:00:00	1980-10-13	38000177		0	0	360		0	0	0	21292	0	749882	19128065		
15554	1297	40229134	1989-11-04	1989-11-04 00:00:00	1989-11-18	1989-11-18 00:00:00	1989-11-18	38000177		0	0	14		0	0	0	85706	0	1043400	40229134		
24203	1990	1127433	2001-03-15	2001-03-15 00:00:00	2001-04-14	2001-04-14 00:00:00	2001-04-14	38000177		0	0	30		0	0	0	132505	0	313782	1127433		
44642	972	40213160	1971-05-12	1971-05-12 00:00:00	1971-05-12	1971-05-12 00:00:00	1971-05-12	581452		0	0	0		0	0	0	64669	0	10	40213160		
46230	3830	1118084	2016-10-22	2016-10-22 00:00:00	2016-10-22	2016-10-22 00:00:00	\N	38000177		0	0	0		0	0	0	254320	0	00025152531	44923712		
39192	3238	1127078	1972-11-27	1972-11-27 00:00:00	1972-12-27	1972-12-27 00:00:00	1972-12-27	38000177		0	0	30		0	0	0	215316	0	282464	1127078		
52689	4380	1127433	2006-06-26	2006-06-26 00:00:00	2006-07-10	2006-07-10 00:00:00	2006-07-10	38000177		0	0	14		0	0	0	291066	0	313782	1127433		
29671	2458	19128022	1991-04-14	1991-04-14 00:00:00	1992-04-08	1992-04-08 00:00:00	1992-04-08	38000177		0	0	360		0	0	0	162981	0	749785	19128022		
63258	5255	19059056	1961-05-17	1961-05-17 00:00:00	1961-05-31	1961-05-31 00:00:00	1961-05-31	38000177		0	0	14		0	0	0	349669	0	243670	19059056		
63275	5256	40229134	1987-08-23	1987-08-23 00:00:00	1987-08-30	1987-08-30 00:00:00	1987-08-30	38000177		0	0	7		0	0	0	349774	0	1043400	40229134		
51975	4321	1127078	1965-11-14	1965-11-14 00:00:00	1965-12-05	1965-12-05 00:00:00	1965-12-05	38000177		0	0	21		0	0	0	286751	0	282464	1127078		
227793	5001	40213160	1960-04-03	1960-04-03 00:00:00	1960-04-03	1960-04-03 00:00:00	1960-04-03	581452		0	0	0		0	0	0	332688	0	10	40213160		
35752	2945	1127433	2007-12-31	2007-12-31 00:00:00	2008-01-07	2008-01-07 00:00:00	2008-01-07	38000177		0	0	7		0	0	0	196527	0	313782	1127433		
64026	1401	40213296	2015-02-08	2015-02-08 00:00:00	2015-02-08	2015-02-08 00:00:00	2015-02-08	581452		0	0	0		0	0	0	93152	0	52	40213296		
40343	879	40213198	2017-05-08	2017-05-08 00:00:00	2017-05-08	2017-05-08 00:00:00	2017-05-08	581452		0	0	0		0	0	0	58545	0	133	40213198		
93109	2043	40213260	2007-09-23	2007-09-23 00:00:00	2007-09-23	2007-09-23 00:00:00	2007-09-23	581452		0	0	0		0	0	0	135924	0	121	40213260		
122774	2699	40213160	1971-02-23	1971-02-23 00:00:00	1971-02-23	1971-02-23 00:00:00	1971-02-23	581452		0	0	0		0	0	0	178705	0	10	40213160		
61497	5117	1118084	1998-02-13	1998-02-13 00:00:00	1998-02-13	1998-02-13 00:00:00	\N	38000177		0	0	0		0	0	0	340084	0	00025152531	44923712		
174482	3836	40213314	1977-06-10	1977-06-10 00:00:00	1977-06-10	1977-06-10 00:00:00	1977-06-10	581452		0	0	0		0	0	0	254754	0	49	40213314		
232420	5107	40213306	1997-10-18	1997-10-18 00:00:00	1997-10-18	1997-10-18 00:00:00	1997-10-18	581452		0	0	0		0	0	0	339362	0	43	40213306		
232499	5108	40213160	1961-05-01	1961-05-01 00:00:00	1961-05-01	1961-05-01 00:00:00	1961-05-01	581452		0	0	0		0	0	0	339412	0	10	40213160		
203802	4474	40213227	2014-06-13	2014-06-13 00:00:00	2014-06-13	2014-06-13 00:00:00	2014-06-13	581452		0	0	0		0	0	0	297701	0	113	40213227		
2241	180	19128065	1997-03-17	1997-03-17 00:00:00	1998-03-12	1998-03-12 00:00:00	1998-03-12	38000177		0	0	360		0	0	0	12099	0	749882	19128065		
38709	3199	1127078	1983-06-29	1983-06-29 00:00:00	1983-07-13	1983-07-13 00:00:00	1983-07-13	38000177		0	0	14		0	0	0	212761	0	282464	1127078		
29465	2439	1124300	2014-08-25	2014-08-25 00:00:00	2014-08-25	2014-08-25 00:00:00	\N	38000177		0	0	0		0	0	0	161800	0	00781178901	45011828		
42233	3504	19059056	1924-05-07	1924-05-07 00:00:00	1924-05-21	1924-05-21 00:00:00	1924-05-21	38000177		0	0	14		0	0	0	232280	0	243670	19059056		
21932	476	40213296	2010-06-05	2010-06-05 00:00:00	2010-06-05	2010-06-05 00:00:00	2010-06-05	581452		0	0	0		0	0	0	31755	0	52	40213296		
237930	5223	40213306	1990-08-04	1990-08-04 00:00:00	1990-08-04	1990-08-04 00:00:00	1990-08-04	581452		0	0	0		0	0	0	347565	0	43	40213306		
12948	1088	40229134	1987-10-20	1987-10-20 00:00:00	1987-10-27	1987-10-27 00:00:00	1987-10-27	38000177		0	0	7		0	0	0	71406	0	1043400	40229134		
46674	3866	1127078	1955-05-13	1955-05-13 00:00:00	1955-06-10	1955-06-10 00:00:00	1955-06-10	38000177		0	0	28		0	0	0	256758	0	282464	1127078		
29803	2468	1713671	1952-12-27	1952-12-27 00:00:00	1953-01-17	1953-01-17 00:00:00	1953-01-17	38000177		0	0	21		0	0	0	163663	0	562251	1713671		
214179	4696	40213160	1955-01-05	1955-01-05 00:00:00	1955-01-05	1955-01-05 00:00:00	1955-01-05	581452		0	0	0		0	0	0	\N	0	10	40213160		
35047	764	40213227	2012-01-24	2012-01-24 00:00:00	2012-01-24	2012-01-24 00:00:00	2012-01-24	581452		0	0	0		0	0	0	50841	0	113	40213227		
59547	4949	1127078	1977-11-08	1977-11-08 00:00:00	1977-11-22	1977-11-22 00:00:00	1977-11-22	38000177		0	0	14		0	0	0	329030	0	282464	1127078		
220326	4835	40213227	2012-05-10	2012-05-10 00:00:00	2012-05-10	2012-05-10 00:00:00	2012-05-10	581452		0	0	0		0	0	0	321622	0	113	40213227		
61874	5146	40231925	2017-01-29	2017-01-29 00:00:00	2017-01-29	2017-01-29 00:00:00	\N	38000177		0	0	0		0	0	0	342083	0	1049221	40231925		
31765	2633	19059056	1951-11-17	1951-11-17 00:00:00	1951-12-01	1951-12-01 00:00:00	1951-12-01	38000177		0	0	14		0	0	0	174222	0	243670	19059056		
93624	2054	40213160	1971-09-30	1971-09-30 00:00:00	1971-09-30	1971-09-30 00:00:00	1971-09-30	581452		0	0	0		0	0	0	136675	0	10	40213160		
93671	2056	40213314	1977-07-20	1977-07-20 00:00:00	1977-07-20	1977-07-20 00:00:00	1977-07-20	581452		0	0	0		0	0	0	136735	0	49	40213314		
129123	2839	40213160	1972-10-30	1972-10-30 00:00:00	1972-10-30	1972-10-30 00:00:00	1972-10-30	581452		0	0	0		0	0	0	188528	0	10	40213160		
31018	2570	19078461	2015-05-22	2015-05-22 00:00:00	2015-07-21	2015-07-21 00:00:00	2015-07-21	38000177		0	0	60		0	0	0	170200	0	310965	19078461		
31239	680	40213227	1999-07-26	1999-07-26 00:00:00	1999-07-26	1999-07-26 00:00:00	1999-07-26	581452		0	0	0		0	0	0	45056	0	113	40213227		
4043	334	19059056	1982-02-08	1982-02-08 00:00:00	1982-03-08	1982-03-08 00:00:00	1982-03-08	38000177		0	0	28		0	0	0	22114	0	243670	19059056		
35028	2893	19133905	1980-11-25	1980-11-25 00:00:00	1980-12-07	1980-12-07 00:00:00	1980-12-07	38000177		0	0	12		0	0	0	192532	0	834102	19133905		
35083	2895	19059056	1966-04-09	1966-04-09 00:00:00	1966-04-23	1966-04-23 00:00:00	1966-04-23	38000177		0	0	14		0	0	0	192742	0	243670	19059056		
31219	2588	19059056	1979-07-02	1979-07-02 00:00:00	1979-08-06	1979-08-06 00:00:00	1979-08-06	38000177		0	0	35		0	0	0	171310	0	243670	19059056		
35145	2899	19006318	1953-01-18	1953-01-18 00:00:00	1953-02-01	1953-02-01 00:00:00	1953-02-01	38000177		0	0	14		0	0	0	193118	0	105078	19006318		
100584	2204	40213227	1996-09-19	1996-09-19 00:00:00	1996-09-19	1996-09-19 00:00:00	1996-09-19	581452		0	0	0		0	0	0	146886	0	113	40213227		
16506	1368	19078461	1982-05-16	1982-05-16 00:00:00	1982-05-30	1982-05-30 00:00:00	1982-05-30	38000177		0	0	14		0	0	0	90738	0	310965	19078461		
58119	4828	19133873	1974-07-04	1974-07-04 00:00:00	1974-07-17	1974-07-17 00:00:00	1974-07-17	38000177		0	0	13		0	0	0	321265	0	834061	19133873		
42459	925	40213160	1969-05-09	1969-05-09 00:00:00	1969-05-09	1969-05-09 00:00:00	1969-05-09	581452		0	0	0		0	0	0	61620	0	10	40213160		
4597	99	40213227	2010-07-24	2010-07-24 00:00:00	2010-07-24	2010-07-24 00:00:00	2010-07-24	581452		0	0	0		0	0	0	6768	0	113	40213227		
31915	2646	1310034	2007-12-14	2007-12-14 00:00:00	2007-12-14	2007-12-14 00:00:00	2007-12-14	38000177		0	0	0		0	0	0	175085	0	834357	1310034		
37689	3115	1127433	1994-10-07	1994-10-07 00:00:00	1994-10-28	1994-10-28 00:00:00	1994-10-28	38000177		0	0	21		0	0	0	207280	0	313782	1127433		
35983	2961	19129655	1976-11-27	1976-11-27 00:00:00	1976-12-11	1976-12-11 00:00:00	1976-12-11	38000177		0	0	14		0	0	0	197729	0	789980	19129655		
154436	3399	40213314	1983-05-17	1983-05-17 00:00:00	1983-05-17	1983-05-17 00:00:00	1983-05-17	581452		0	0	0		0	0	0	225494	0	49	40213314		
7589	639	1124300	1989-05-14	1989-05-14 00:00:00	1989-05-14	1989-05-14 00:00:00	\N	38000177		0	0	0		0	0	0	42292	0	00781178901	45011828		
43019	3566	19078461	1975-10-27	1975-10-27 00:00:00	1975-12-01	1975-12-01 00:00:00	1975-12-01	38000177		0	0	35		0	0	0	236950	0	310965	19078461		
63018	5236	19078461	2015-01-30	2015-01-30 00:00:00	2015-03-06	2015-03-06 00:00:00	2015-03-06	38000177		0	0	35		0	0	0	348428	0	310965	19078461		
51079	1118	40213227	1997-04-13	1997-04-13 00:00:00	1997-04-13	1997-04-13 00:00:00	1997-04-13	581452		0	0	0		0	0	0	73738	0	113	40213227		
60797	5056	920300	1993-03-08	1993-03-08 00:00:00	1993-03-15	1993-03-15 00:00:00	1993-03-15	38000177		0	0	7		0	0	0	336132	0	311989	920300		
12570	1058	1713671	2018-01-26	2018-01-26 00:00:00	2018-05-04	2018-05-04 00:00:00	2018-05-04	38000177		0	0	98		0	0	0	69431	0	562251	1713671		
28804	2380	19006318	1950-08-25	1950-08-25 00:00:00	1950-09-08	1950-09-08 00:00:00	1950-09-08	38000177		0	0	14		0	0	0	158192	0	105078	19006318		
4979	412	1118084	1993-09-22	1993-09-22 00:00:00	1993-09-22	1993-09-22 00:00:00	\N	38000177		0	0	0		0	0	0	27451	0	00025152531	44923712		
3870	321	40229134	1973-04-13	1973-04-13 00:00:00	1973-04-27	1973-04-27 00:00:00	1973-04-27	38000177		0	0	14		0	0	0	21271	0	1043400	40229134		
188697	4143	40213160	1962-01-05	1962-01-05 00:00:00	1962-01-05	1962-01-05 00:00:00	1962-01-05	581452		0	0	0		0	0	0	275384	0	10	40213160		
24204	1990	1127433	2011-06-28	2011-06-28 00:00:00	2011-07-12	2011-07-12 00:00:00	2011-07-12	38000177		0	0	14		0	0	0	132538	0	313782	1127433		
44646	972	40213227	1997-08-13	1997-08-13 00:00:00	1997-08-13	1997-08-13 00:00:00	1997-08-13	581452		0	0	0		0	0	0	64703	0	113	40213227		
46231	3830	1713671	1986-12-25	1986-12-25 00:00:00	1987-01-01	1987-01-01 00:00:00	1987-01-01	38000177		0	0	7		0	0	0	254298	0	562251	1713671		
39193	3238	40229134	1974-06-21	1974-06-21 00:00:00	1974-06-28	1974-06-28 00:00:00	1974-06-28	38000177		0	0	7		0	0	0	215261	0	1043400	40229134		
52690	4380	1127433	1983-07-27	1983-07-27 00:00:00	1983-08-10	1983-08-10 00:00:00	1983-08-10	38000177		0	0	14		0	0	0	291047	0	313782	1127433		
29672	2458	19078461	2015-02-28	2015-02-28 00:00:00	2015-04-29	2015-04-29 00:00:00	2015-04-29	38000177		0	0	60		0	0	0	162945	0	310965	19078461		
63259	5255	19059056	1973-08-31	1973-08-31 00:00:00	1973-09-21	1973-09-21 00:00:00	1973-09-21	38000177		0	0	21		0	0	0	349699	0	243670	19059056		
63276	5256	19078461	1988-04-14	1988-04-14 00:00:00	1988-05-19	1988-05-19 00:00:00	1988-05-19	38000177		0	0	35		0	0	0	349707	0	310965	19078461		
51976	4321	1127433	1995-01-29	1995-01-29 00:00:00	1995-02-12	1995-02-12 00:00:00	1995-02-12	38000177		0	0	14		0	0	0	286710	0	313782	1127433		
227800	5001	40213227	2010-10-31	2010-10-31 00:00:00	2010-10-31	2010-10-31 00:00:00	2010-10-31	581452		0	0	0		0	0	0	332666	0	113	40213227		
35753	2945	1115171	1998-06-26	1998-06-26 00:00:00	1998-07-10	1998-07-10 00:00:00	1998-07-10	38000177		0	0	14		0	0	0	196529	0	849574	1115171		
186868	4105	40213227	1998-07-11	1998-07-11 00:00:00	1998-07-11	1998-07-11 00:00:00	1998-07-11	581452		0	0	0		0	0	0	272750	0	113	40213227		
198201	4355	40213314	1982-06-26	1982-06-26 00:00:00	1982-06-26	1982-06-26 00:00:00	1982-06-26	581452		0	0	0		0	0	0	288949	0	49	40213314		
93111	2043	40213296	1996-04-21	1996-04-21 00:00:00	1996-04-21	1996-04-21 00:00:00	1996-04-21	581452		0	0	0		0	0	0	135946	0	52	40213296		
122779	2699	40213227	2002-10-22	2002-10-22 00:00:00	2002-10-22	2002-10-22 00:00:00	2002-10-22	581452		0	0	0		0	0	0	178764	0	113	40213227		
61498	5117	19128065	1974-02-24	1974-02-24 00:00:00	1975-02-19	1975-02-19 00:00:00	1975-02-19	38000177		0	0	360		0	0	0	340086	0	749882	19128065		
174488	3836	40213160	1977-08-12	1977-08-12 00:00:00	1977-08-12	1977-08-12 00:00:00	1977-08-12	581452		0	0	0		0	0	0	254742	0	10	40213160		
232421	5107	40213160	1975-09-13	1975-09-13 00:00:00	1975-09-13	1975-09-13 00:00:00	1975-09-13	581452		0	0	0		0	0	0	339335	0	10	40213160		
71854	1571	40213160	1955-06-10	1955-06-10 00:00:00	1955-06-10	1955-06-10 00:00:00	1955-06-10	581452		0	0	0		0	0	0	105489	0	10	40213160		
203803	4474	40213260	2014-06-13	2014-06-13 00:00:00	2014-06-13	2014-06-13 00:00:00	2014-06-13	581452		0	0	0		0	0	0	297701	0	121	40213260		
2242	181	40229134	1984-09-19	1984-09-19 00:00:00	1984-10-03	1984-10-03 00:00:00	1984-10-03	38000177		0	0	14		0	0	0	12203	0	1043400	40229134		
38710	3199	19073183	1983-06-29	1983-06-29 00:00:00	1983-07-13	1983-07-13 00:00:00	1983-07-13	38000177		0	0	14		0	0	0	212761	0	308182	19073183		
29466	2439	19059056	1973-05-12	1973-05-12 00:00:00	1973-05-26	1973-05-26 00:00:00	1973-05-26	38000177		0	0	14		0	0	0	161814	0	243670	19059056		
42234	3504	1118084	1956-04-29	1956-04-29 00:00:00	1956-04-29	1956-04-29 00:00:00	\N	38000177		0	0	0		0	0	0	232328	0	00025152531	44923712		
21934	476	40213227	2010-06-05	2010-06-05 00:00:00	2010-06-05	2010-06-05 00:00:00	2010-06-05	581452		0	0	0		0	0	0	31755	0	113	40213227		
237932	5223	40213296	2008-01-26	2008-01-26 00:00:00	2008-01-26	2008-01-26 00:00:00	2008-01-26	581452		0	0	0		0	0	0	347583	0	52	40213296		
23415	1928	19128065	1990-07-05	1990-07-05 00:00:00	1991-06-30	1991-06-30 00:00:00	1991-06-30	38000177		0	0	360		0	0	0	128341	0	749882	19128065		
46675	3866	19059056	1964-08-19	1964-08-19 00:00:00	1964-09-18	1964-09-18 00:00:00	1964-09-18	38000177		0	0	30		0	0	0	256760	0	243670	19059056		
29804	2468	1127433	2003-01-10	2003-01-10 00:00:00	2003-01-17	2003-01-17 00:00:00	2003-01-17	38000177		0	0	7		0	0	0	163607	0	313782	1127433		
214183	4696	40213227	2002-03-20	2002-03-20 00:00:00	2002-03-20	2002-03-20 00:00:00	2002-03-20	581452		0	0	0		0	0	0	312872	0	113	40213227		
35048	764	40213296	2012-01-24	2012-01-24 00:00:00	2012-01-24	2012-01-24 00:00:00	2012-01-24	581452		0	0	0		0	0	0	50841	0	52	40213296		
59548	4949	19129655	1977-11-08	1977-11-08 00:00:00	1977-11-22	1977-11-22 00:00:00	1977-11-22	38000177		0	0	14		0	0	0	329030	0	789980	19129655		
220327	4835	40213296	2012-05-10	2012-05-10 00:00:00	2012-05-10	2012-05-10 00:00:00	2012-05-10	581452		0	0	0		0	0	0	321622	0	52	40213296		
61875	5146	19073188	2017-01-29	2017-01-29 00:00:00	2017-03-05	2017-03-05 00:00:00	2017-03-05	38000177		0	0	35		0	0	0	342083	0	308192	19073188		
31766	2633	19006318	1951-11-17	1951-11-17 00:00:00	1951-12-01	1951-12-01 00:00:00	1951-12-01	38000177		0	0	14		0	0	0	174222	0	105078	19006318		
93627	2054	40213306	1994-02-24	1994-02-24 00:00:00	1994-02-24	1994-02-24 00:00:00	1994-02-24	581452		0	0	0		0	0	0	136617	0	43	40213306		
93674	2056	40213314	1977-04-20	1977-04-20 00:00:00	1977-04-20	1977-04-20 00:00:00	1977-04-20	581452		0	0	0		0	0	0	136714	0	49	40213314		
129125	2839	40213160	1972-05-29	1972-05-29 00:00:00	1972-05-29	1972-05-29 00:00:00	1972-05-29	581452		0	0	0		0	0	0	188527	0	10	40213160		
31019	2570	40220960	1992-11-19	1992-11-19 00:00:00	1992-11-19	1992-11-19 00:00:00	1992-11-19	38000177		0	0	0		0	0	0	170241	0	1804799	40220960		
31240	680	40213160	1968-01-01	1968-01-01 00:00:00	1968-01-01	1968-01-01 00:00:00	1968-01-01	581452		0	0	0		0	0	0	45078	0	10	40213160		
4044	334	19059056	1939-04-02	1939-04-02 00:00:00	1939-04-16	1939-04-16 00:00:00	1939-04-16	38000177		0	0	14		0	0	0	22187	0	243670	19059056		
35029	2893	1713671	1990-05-20	1990-05-20 00:00:00	1990-06-03	1990-06-03 00:00:00	1990-06-03	38000177		0	0	14		0	0	0	192543	0	562251	1713671		
35084	2895	19006318	1966-04-09	1966-04-09 00:00:00	1966-04-23	1966-04-23 00:00:00	1966-04-23	38000177		0	0	14		0	0	0	192742	0	105078	19006318		
31220	2588	19073188	2008-06-10	2008-06-10 00:00:00	2008-06-24	2008-06-24 00:00:00	2008-06-24	38000177		0	0	14		0	0	0	171289	0	308192	19073188		
35146	2899	1127433	1960-08-29	1960-08-29 00:00:00	1960-09-12	1960-09-12 00:00:00	1960-09-12	38000177		0	0	14		0	0	0	193171	0	313782	1127433		
111876	2458	40213296	2012-06-03	2012-06-03 00:00:00	2012-06-03	2012-06-03 00:00:00	2012-06-03	581452		0	0	0		0	0	0	163005	0	52	40213296		
16507	1368	19075601	2019-06-26	2019-06-26 00:00:00	2019-06-26	2019-06-26 00:00:00	2019-06-26	38000177		0	0	0		0	0	0	90677	0	309362	19075601		
58120	4828	1115171	2000-11-02	2000-11-02 00:00:00	2000-11-23	2000-11-23 00:00:00	2000-11-23	38000177		0	0	21		0	0	0	321254	0	849574	1115171		
111994	2460	40213160	1985-04-17	1985-04-17 00:00:00	1985-04-17	1985-04-17 00:00:00	1985-04-17	581452		0	0	0		0	0	0	163095	0	10	40213160		
4598	99	40213260	2010-07-24	2010-07-24 00:00:00	2010-07-24	2010-07-24 00:00:00	2010-07-24	581452		0	0	0		0	0	0	6768	0	121	40213260		
31916	2646	46275916	2007-12-14	2007-12-14 00:00:00	2007-12-14	2007-12-14 00:00:00	2007-12-14	38000177		0	0	0		0	0	0	175085	0	1660014	46275916		
37690	3115	1127433	1987-04-26	1987-04-26 00:00:00	1987-05-10	1987-05-10 00:00:00	1987-05-10	38000177		0	0	14		0	0	0	207256	0	313782	1127433		
35984	2961	1127433	2005-12-28	2005-12-28 00:00:00	2006-01-04	2006-01-04 00:00:00	2006-01-04	38000177		0	0	7		0	0	0	197706	0	313782	1127433		
154438	3399	40213227	2014-10-07	2014-10-07 00:00:00	2014-10-07	2014-10-07 00:00:00	2014-10-07	581452		0	0	0		0	0	0	225446	0	113	40213227		
7591	639	920300	1990-01-31	1990-01-31 00:00:00	1990-02-07	1990-02-07 00:00:00	1990-02-07	38000177		0	0	7		0	0	0	42304	0	311989	920300		
43020	3566	40229134	1965-09-08	1965-09-08 00:00:00	1965-09-22	1965-09-22 00:00:00	1965-09-22	38000177		0	0	14		0	0	0	236910	0	1043400	40229134		
63019	5236	1127433	2004-11-28	2004-11-28 00:00:00	2004-12-05	2004-12-05 00:00:00	2004-12-05	38000177		0	0	7		0	0	0	348421	0	313782	1127433		
51080	1118	40213306	1997-04-13	1997-04-13 00:00:00	1997-04-13	1997-04-13 00:00:00	1997-04-13	581452		0	0	0		0	0	0	73738	0	43	40213306		
60798	5056	40229134	1991-02-26	1991-02-26 00:00:00	1991-03-05	1991-03-05 00:00:00	1991-03-05	38000177		0	0	7		0	0	0	336142	0	1043400	40229134		
12571	1058	19008572	1970-06-26	1970-06-26 00:00:00	1970-07-17	1970-07-17 00:00:00	1970-07-17	38000177		0	0	21		0	0	0	69475	0	106258	19008572		
28805	2380	1127433	1961-04-30	1961-04-30 00:00:00	1961-05-07	1961-05-07 00:00:00	1961-05-07	38000177		0	0	7		0	0	0	158177	0	313782	1127433		
4980	412	1127078	1963-03-13	1963-03-13 00:00:00	1963-06-11	1963-06-11 00:00:00	1963-06-11	38000177		0	0	90		0	0	0	27409	0	282464	1127078		
11191	239	40213227	1996-10-31	1996-10-31 00:00:00	1996-10-31	1996-10-31 00:00:00	1996-10-31	581452		0	0	0		0	0	0	16065	0	113	40213227		
188703	4143	40213260	2011-09-30	2011-09-30 00:00:00	2011-09-30	2011-09-30 00:00:00	2011-09-30	581452		0	0	0		0	0	0	275357	0	121	40213260		
33714	2790	40173590	2013-04-11	2013-04-11 00:00:00	2013-04-11	2013-04-11 00:00:00	\N	38000177		0	0	0		0	0	0	184866	0	904419	40173590		
44648	972	40213160	1966-09-07	1966-09-07 00:00:00	1966-09-07	1966-09-07 00:00:00	1966-09-07	581452		0	0	0		0	0	0	64689	0	10	40213160		
46232	3830	19133873	1983-03-13	1983-03-13 00:00:00	1983-03-21	1983-03-21 00:00:00	1983-03-21	38000177		0	0	8		0	0	0	254280	0	834061	19133873		
39194	3238	1127433	1986-02-27	1986-02-27 00:00:00	1986-03-13	1986-03-13 00:00:00	1986-03-13	38000177		0	0	14		0	0	0	215276	0	313782	1127433		
52691	4380	1124300	2001-09-28	2001-09-28 00:00:00	2001-09-28	2001-09-28 00:00:00	\N	38000177		0	0	0		0	0	0	291004	0	00781178901	45011828		
29673	2458	19128065	1985-05-15	1985-05-15 00:00:00	1986-05-10	1986-05-10 00:00:00	1986-05-10	38000177		0	0	360		0	0	0	162969	0	749882	19128065		
63260	5255	1127078	1965-08-08	1965-08-08 00:00:00	1965-09-12	1965-09-12 00:00:00	1965-09-12	38000177		0	0	35		0	0	0	349698	0	282464	1127078		
63277	5256	1127078	1964-05-15	1964-05-15 00:00:00	1964-05-29	1964-05-29 00:00:00	1964-05-29	38000177		0	0	14		0	0	0	349720	0	282464	1127078		
51978	4321	1127433	1993-08-18	1993-08-18 00:00:00	1993-09-01	1993-09-01 00:00:00	1993-09-01	38000177		0	0	14		0	0	0	286705	0	313782	1127433		
227801	5001	40213260	2010-10-31	2010-10-31 00:00:00	2010-10-31	2010-10-31 00:00:00	2010-10-31	581452		0	0	0		0	0	0	332666	0	121	40213260		
35754	2945	19075001	1998-06-26	1998-06-26 00:00:00	1998-07-10	1998-07-10 00:00:00	1998-07-10	38000177		0	0	14		0	0	0	196529	0	309097	19075001		
186875	4105	40213160	1955-03-12	1955-03-12 00:00:00	1955-03-12	1955-03-12 00:00:00	1955-03-12	581452		0	0	0		0	0	0	272765	0	10	40213160		
198209	4355	40213227	2003-07-05	2003-07-05 00:00:00	2003-07-05	2003-07-05 00:00:00	2003-07-05	581452		0	0	0		0	0	0	288944	0	113	40213227		
93118	2044	40213296	2001-10-20	2001-10-20 00:00:00	2001-10-20	2001-10-20 00:00:00	2001-10-20	581452		0	0	0		0	0	0	135987	0	52	40213296		
8159	680	19059056	1967-10-25	1967-10-25 00:00:00	1967-11-08	1967-11-08 00:00:00	1967-11-08	38000177		0	0	14		0	0	0	45045	0	243670	19059056		
61500	5117	1115171	2017-12-09	2017-12-09 00:00:00	2017-12-30	2017-12-30 00:00:00	2017-12-30	38000177		0	0	21		0	0	0	340155	0	849574	1115171		
174489	3836	40213314	1977-08-12	1977-08-12 00:00:00	1977-08-12	1977-08-12 00:00:00	1977-08-12	581452		0	0	0		0	0	0	254742	0	49	40213314		
232427	5107	40213314	1977-11-12	1977-11-12 00:00:00	1977-11-12	1977-11-12 00:00:00	1977-11-12	581452		0	0	0		0	0	0	339342	0	49	40213314		
71857	1571	40213260	2007-07-20	2007-07-20 00:00:00	2007-07-20	2007-07-20 00:00:00	2007-07-20	581452		0	0	0		0	0	0	105411	0	121	40213260		
203808	4474	40213160	1968-04-19	1968-04-19 00:00:00	1968-04-19	1968-04-19 00:00:00	1968-04-19	581452		0	0	0		0	0	0	297647	0	10	40213160		
2243	181	1713671	1997-03-22	1997-03-22 00:00:00	1997-03-29	1997-03-29 00:00:00	1997-03-29	38000177		0	0	7		0	0	0	12237	0	562251	1713671		
47011	3895	1713671	2019-03-13	2019-03-13 00:00:00	2019-04-03	2019-04-03 00:00:00	2019-04-03	38000177		0	0	21		0	0	0	259107	0	562251	1713671		
29467	2439	19129655	1973-05-12	1973-05-12 00:00:00	1973-05-26	1973-05-26 00:00:00	1973-05-26	38000177		0	0	14		0	0	0	161814	0	789980	19129655		
42235	3504	19133873	1931-04-04	1931-04-04 00:00:00	1931-04-13	1931-04-13 00:00:00	1931-04-13	38000177		0	0	9		0	0	0	232288	0	834061	19133873		
21938	476	40213160	1972-08-26	1972-08-26 00:00:00	1972-08-26	1972-08-26 00:00:00	1972-08-26	581452		0	0	0		0	0	0	31715	0	10	40213160		
237935	5223	40213227	2019-01-26	2019-01-26 00:00:00	2019-01-26	2019-01-26 00:00:00	2019-01-26	581452		0	0	0		0	0	0	347575	0	113	40213227		
23416	1928	1713671	1979-03-20	1979-03-20 00:00:00	1979-04-10	1979-04-10 00:00:00	1979-04-10	38000177		0	0	21		0	0	0	128331	0	562251	1713671		
46676	3866	40231925	1964-08-19	1964-08-19 00:00:00	1964-08-19	1964-08-19 00:00:00	\N	38000177		0	0	0		0	0	0	256760	0	1049221	40231925		
29805	2469	920300	1988-09-03	1988-09-03 00:00:00	1988-09-10	1988-09-10 00:00:00	1988-09-10	38000177		0	0	7		0	0	0	163747	0	311989	920300		
214190	4696	40213227	2012-05-16	2012-05-16 00:00:00	2012-05-16	2012-05-16 00:00:00	2012-05-16	581452		0	0	0		0	0	0	312851	0	113	40213227		
35051	764	40213306	1991-09-17	1991-09-17 00:00:00	1991-09-17	1991-09-17 00:00:00	1991-09-17	581452		0	0	0		0	0	0	50856	0	43	40213306		
59549	4949	1713671	1991-10-19	1991-10-19 00:00:00	1991-11-09	1991-11-09 00:00:00	1991-11-09	38000177		0	0	21		0	0	0	328999	0	562251	1713671		
156607	3446	40213201	2010-11-01	2010-11-01 00:00:00	2010-11-01	2010-11-01 00:00:00	2010-11-01	581452		0	0	0		0	0	0	228763	0	33	40213201		
61876	5146	19078461	2017-01-29	2017-01-29 00:00:00	2017-03-05	2017-03-05 00:00:00	2017-03-05	38000177		0	0	35		0	0	0	342083	0	310965	19078461		
58575	4861	19078461	2008-05-09	2008-05-09 00:00:00	2008-06-08	2008-06-08 00:00:00	2008-06-08	38000177		0	0	30		0	0	0	323459	0	310965	19078461		
93629	2054	40213227	1994-02-24	1994-02-24 00:00:00	1994-02-24	1994-02-24 00:00:00	1994-02-24	581452		0	0	0		0	0	0	136617	0	113	40213227		
93677	2056	40213160	1976-10-20	1976-10-20 00:00:00	1976-10-20	1976-10-20 00:00:00	1976-10-20	581452		0	0	0		0	0	0	136755	0	10	40213160		
129126	2839	40213296	2012-03-12	2012-03-12 00:00:00	2012-03-12	2012-03-12 00:00:00	2012-03-12	581452		0	0	0		0	0	0	188546	0	52	40213296		
31020	2570	1118084	1971-03-06	1971-03-06 00:00:00	1971-03-06	1971-03-06 00:00:00	\N	38000177		0	0	0		0	0	0	170211	0	00025152531	44923712		
42888	935	40213227	1992-09-23	1992-09-23 00:00:00	1992-09-23	1992-09-23 00:00:00	1992-09-23	581452		0	0	0		0	0	0	62228	0	113	40213227		
4045	334	19059056	1983-08-17	1983-08-17 00:00:00	1983-08-31	1983-08-31 00:00:00	1983-08-31	38000177		0	0	14		0	0	0	22213	0	243670	19059056		
35030	2893	1713671	1964-09-15	1964-09-15 00:00:00	1964-09-22	1964-09-22 00:00:00	1964-09-22	38000177		0	0	7		0	0	0	192455	0	562251	1713671		
35085	2896	40229134	2013-07-27	2013-07-27 00:00:00	2013-08-03	2013-08-03 00:00:00	2013-08-03	38000177		0	0	7		0	0	0	192823	0	1043400	40229134		
31221	2588	19078461	2008-06-10	2008-06-10 00:00:00	2008-06-24	2008-06-24 00:00:00	2008-06-24	38000177		0	0	14		0	0	0	171289	0	310965	19078461		
35147	2899	1115171	2004-03-14	2004-03-14 00:00:00	2004-04-04	2004-04-04 00:00:00	2004-04-04	38000177		0	0	21		0	0	0	193181	0	849574	1115171		
111881	2458	40213227	2012-06-03	2012-06-03 00:00:00	2012-06-03	2012-06-03 00:00:00	2012-06-03	581452		0	0	0		0	0	0	163005	0	113	40213227		
16508	1368	40220960	2019-06-26	2019-06-26 00:00:00	2019-06-26	2019-06-26 00:00:00	2019-06-26	38000177		0	0	0		0	0	0	90677	0	1804799	40220960		
58121	4828	40229134	2000-07-17	2000-07-17 00:00:00	2000-07-31	2000-07-31 00:00:00	2000-07-31	38000177		0	0	14		0	0	0	321286	0	1043400	40229134		
112009	2461	40213260	2016-12-27	2016-12-27 00:00:00	2016-12-27	2016-12-27 00:00:00	2016-12-27	581452		0	0	0		0	0	0	163173	0	121	40213260		
4601	99	40213227	1992-12-19	1992-12-19 00:00:00	1992-12-19	1992-12-19 00:00:00	1992-12-19	581452		0	0	0		0	0	0	6763	0	113	40213227		
31917	2646	1118084	2009-07-18	2009-07-18 00:00:00	2009-07-18	2009-07-18 00:00:00	\N	38000177		0	0	0		0	0	0	175080	0	00025152531	44923712		
37691	3115	1127078	1968-01-15	1968-01-15 00:00:00	1968-02-05	1968-02-05 00:00:00	1968-02-05	38000177		0	0	21		0	0	0	207276	0	282464	1127078		
35985	2961	19133873	1982-12-12	1982-12-12 00:00:00	1982-12-21	1982-12-21 00:00:00	1982-12-21	38000177		0	0	9		0	0	0	197751	0	834061	19133873		
30365	2518	1127433	1993-05-25	1993-05-25 00:00:00	1993-06-08	1993-06-08 00:00:00	1993-06-08	38000177		0	0	14		0	0	0	166581	0	313782	1127433		
7592	639	40236824	1990-01-31	1990-01-31 00:00:00	1990-02-07	1990-02-07 00:00:00	1990-02-07	38000177		0	0	7		0	0	0	42304	0	1094107	40236824		
43021	3566	1127433	1977-02-23	1977-02-23 00:00:00	1977-03-02	1977-03-02 00:00:00	1977-03-02	38000177		0	0	7		0	0	0	236911	0	313782	1127433		
63020	5236	19128065	1988-02-19	1988-02-19 00:00:00	1989-02-13	1989-02-13 00:00:00	1989-02-13	38000177		0	0	360		0	0	0	348406	0	749882	19128065		
51081	1118	40213306	1994-04-10	1994-04-10 00:00:00	1994-04-10	1994-04-10 00:00:00	1994-04-10	581452		0	0	0		0	0	0	73737	0	43	40213306		
60799	5056	19059056	1973-08-31	1973-08-31 00:00:00	1973-09-30	1973-09-30 00:00:00	1973-09-30	38000177		0	0	30		0	0	0	336164	0	243670	19059056		
12572	1058	1118084	1992-12-03	1992-12-03 00:00:00	1992-12-03	1992-12-03 00:00:00	\N	38000177		0	0	0		0	0	0	69417	0	00025152531	44923712		
28806	2381	1115171	2003-08-16	2003-08-16 00:00:00	2003-08-30	2003-08-30 00:00:00	2003-08-30	38000177		0	0	14		0	0	0	158244	0	849574	1115171		
15445	1289	1118084	2000-11-23	2000-11-23 00:00:00	2000-11-23	2000-11-23 00:00:00	\N	38000177		0	0	0		0	0	0	85220	0	00025152531	44923712		
11197	239	40213198	2011-01-06	2011-01-06 00:00:00	2011-01-06	2011-01-06 00:00:00	2011-01-06	581452		0	0	0		0	0	0	16072	0	133	40213198		
188710	4143	40213227	2004-05-21	2004-05-21 00:00:00	2004-05-21	2004-05-21 00:00:00	2004-05-21	581452		0	0	0		0	0	0	275389	0	113	40213227		
33715	2790	1713671	2013-04-22	2013-04-22 00:00:00	2013-04-29	2013-04-29 00:00:00	2013-04-29	38000177		0	0	7		0	0	0	184887	0	562251	1713671		
44650	972	40213227	2017-06-07	2017-06-07 00:00:00	2017-06-07	2017-06-07 00:00:00	2017-06-07	581452		0	0	0		0	0	0	64705	0	113	40213227		
46233	3830	19059056	1985-07-11	1985-07-11 00:00:00	1985-07-25	1985-07-25 00:00:00	1985-07-25	38000177		0	0	14		0	0	0	254321	0	243670	19059056		
39195	3238	40231925	1997-05-27	1997-05-27 00:00:00	1997-05-27	1997-05-27 00:00:00	\N	38000177		0	0	0		0	0	0	215273	0	1049221	40231925		
52692	4380	1127433	1999-01-29	1999-01-29 00:00:00	1999-02-05	1999-02-05 00:00:00	1999-02-05	38000177		0	0	7		0	0	0	291034	0	313782	1127433		
29674	2458	1713671	2013-01-03	2013-01-03 00:00:00	2013-01-24	2013-01-24 00:00:00	2013-01-24	38000177		0	0	21		0	0	0	162948	0	562251	1713671		
63262	5255	19059056	1961-11-13	1961-11-13 00:00:00	1961-11-27	1961-11-27 00:00:00	1961-11-27	38000177		0	0	14		0	0	0	349697	0	243670	19059056		
63278	5256	19129655	1964-05-15	1964-05-15 00:00:00	1964-05-29	1964-05-29 00:00:00	1964-05-29	38000177		0	0	14		0	0	0	349720	0	789980	19129655		
51979	4321	1127433	1992-09-14	1992-09-14 00:00:00	1992-10-05	1992-10-05 00:00:00	1992-10-05	38000177		0	0	21		0	0	0	286752	0	313782	1127433		
227804	5001	40213260	2009-10-25	2009-10-25 00:00:00	2009-10-25	2009-10-25 00:00:00	2009-10-25	581452		0	0	0		0	0	0	332642	0	121	40213260		
35755	2945	19059056	1950-11-18	1950-11-18 00:00:00	1950-12-02	1950-12-02 00:00:00	1950-12-02	38000177		0	0	14		0	0	0	196468	0	243670	19059056		
126944	2792	40213160	1962-09-17	1962-09-17 00:00:00	1962-09-17	1962-09-17 00:00:00	1962-09-17	581452		0	0	0		0	0	0	185065	0	10	40213160		
198210	4355	40213306	2003-07-05	2003-07-05 00:00:00	2003-07-05	2003-07-05 00:00:00	2003-07-05	581452		0	0	0		0	0	0	288944	0	43	40213306		
93125	2044	40213227	1993-07-03	1993-07-03 00:00:00	1993-07-03	1993-07-03 00:00:00	1993-07-03	581452		0	0	0		0	0	0	136000	0	113	40213227		
8160	680	46233988	1967-10-25	1967-10-25 00:00:00	1967-11-08	1967-11-08 00:00:00	1967-11-08	38000177		0	0	14		0	0	0	45045	0	1652673	46233988		
61501	5117	40162522	1988-03-16	1988-03-16 00:00:00	1988-03-16	1988-03-16 00:00:00	\N	38000177		0	0	0		0	0	0	340144	0	857005	40162522		
174492	3836	40213160	1977-11-11	1977-11-11 00:00:00	1977-11-11	1977-11-11 00:00:00	1977-11-11	581452		0	0	0		0	0	0	254710	0	10	40213160		
232430	5107	40213296	2019-05-18	2019-05-18 00:00:00	2019-05-18	2019-05-18 00:00:00	2019-05-18	581452		0	0	0		0	0	0	339338	0	52	40213296		
71862	1571	40213227	1997-02-07	1997-02-07 00:00:00	1997-02-07	1997-02-07 00:00:00	1997-02-07	581452		0	0	0		0	0	0	105452	0	113	40213227		
33483	730	40213260	2008-04-19	2008-04-19 00:00:00	2008-04-19	2008-04-19 00:00:00	2008-04-19	581452		0	0	0		0	0	0	48453	0	121	40213260		
2244	181	19128065	1989-09-02	1989-09-02 00:00:00	1990-08-28	1990-08-28 00:00:00	1990-08-28	38000177		0	0	360		0	0	0	12235	0	749882	19128065		
47012	3895	1713671	1952-07-18	1952-07-18 00:00:00	1952-08-01	1952-08-01 00:00:00	1952-08-01	38000177		0	0	14		0	0	0	259118	0	562251	1713671		
29468	2439	19059056	1973-08-24	1973-08-24 00:00:00	1973-09-07	1973-09-07 00:00:00	1973-09-07	38000177		0	0	14		0	0	0	161811	0	243670	19059056		
42236	3504	40223768	2001-12-28	2001-12-28 00:00:00	2001-12-28	2001-12-28 00:00:00	\N	38000177		0	0	0		0	0	0	232301	0	997223	40223768		
85152	1864	40213160	1966-07-08	1966-07-08 00:00:00	1966-07-08	1966-07-08 00:00:00	1966-07-08	581452		0	0	0		0	0	0	124517	0	10	40213160		
237936	5223	40213260	2019-01-26	2019-01-26 00:00:00	2019-01-26	2019-01-26 00:00:00	2019-01-26	581452		0	0	0		0	0	0	347575	0	121	40213260		
23417	1928	1127433	1993-06-10	1993-06-10 00:00:00	1993-06-24	1993-06-24 00:00:00	1993-06-24	38000177		0	0	14		0	0	0	128311	0	313782	1127433		
46677	3866	1127433	1968-04-30	1968-04-30 00:00:00	1968-05-21	1968-05-21 00:00:00	1968-05-21	38000177		0	0	21		0	0	0	256700	0	313782	1127433		
29806	2469	40236824	1988-09-03	1988-09-03 00:00:00	1988-09-10	1988-09-10 00:00:00	1988-09-10	38000177		0	0	7		0	0	0	163747	0	1094107	40236824		
226779	4979	40213227	1999-04-30	1999-04-30 00:00:00	1999-04-30	1999-04-30 00:00:00	1999-04-30	581452		0	0	0		0	0	0	331257	0	113	40213227		
35052	764	40213227	1992-05-26	1992-05-26 00:00:00	1992-05-26	1992-05-26 00:00:00	1992-05-26	581452		0	0	0		0	0	0	\N	0	113	40213227		
59557	4952	1127433	1975-02-07	1975-02-07 00:00:00	1975-02-21	1975-02-21 00:00:00	1975-02-21	38000177		0	0	14		0	0	0	329181	0	313782	1127433		
156608	3446	40213198	2010-11-01	2010-11-01 00:00:00	2010-11-01	2010-11-01 00:00:00	2010-11-01	581452		0	0	0		0	0	0	228763	0	133	40213198		
61877	5146	1127433	2000-01-18	2000-01-18 00:00:00	2000-01-25	2000-01-25 00:00:00	2000-01-25	38000177		0	0	7		0	0	0	342098	0	313782	1127433		
58581	4865	19019979	1974-12-26	1974-12-26 00:00:00	1975-01-23	1975-01-23 00:00:00	1975-01-23	38000177		0	0	28		0	0	0	323499	0	198405	19019979		
93664	2056	40213296	2018-02-21	2018-02-21 00:00:00	2018-02-21	2018-02-21 00:00:00	2018-02-21	581452		0	0	0		0	0	0	136740	0	52	40213296		
93679	2056	40213227	1998-04-29	1998-04-29 00:00:00	1998-04-29	1998-04-29 00:00:00	1998-04-29	581452		0	0	0		0	0	0	136728	0	113	40213227		
129133	2839	40213227	1995-02-20	1995-02-20 00:00:00	1995-02-20	1995-02-20 00:00:00	1995-02-20	581452		0	0	0		0	0	0	188544	0	113	40213227		
31021	2570	1713671	2004-01-31	2004-01-31 00:00:00	2004-02-07	2004-02-07 00:00:00	2004-02-07	38000177		0	0	7		0	0	0	170173	0	562251	1713671		
42896	936	40213160	1961-04-07	1961-04-07 00:00:00	1961-04-07	1961-04-07 00:00:00	1961-04-07	581452		0	0	0		0	0	0	62279	0	10	40213160		
4046	334	40229134	1970-04-21	1970-04-21 00:00:00	1970-05-05	1970-05-05 00:00:00	1970-05-05	38000177		0	0	14		0	0	0	22123	0	1043400	40229134		
35031	2893	1127433	1946-05-18	1946-05-18 00:00:00	1946-06-01	1946-06-01 00:00:00	1946-06-01	38000177		0	0	14		0	0	0	192497	0	313782	1127433		
35086	2896	1127433	2016-01-19	2016-01-19 00:00:00	2016-02-09	2016-02-09 00:00:00	2016-02-09	38000177		0	0	21		0	0	0	192869	0	313782	1127433		
31222	2588	40229134	2010-09-28	2010-09-28 00:00:00	2010-10-12	2010-10-12 00:00:00	2010-10-12	38000177		0	0	14		0	0	0	171288	0	1043400	40229134		
35148	2899	1127078	1950-03-23	1950-03-23 00:00:00	1950-04-06	1950-04-06 00:00:00	1950-04-06	38000177		0	0	14		0	0	0	193174	0	282464	1127078		
111882	2458	40213160	1970-08-30	1970-08-30 00:00:00	1970-08-30	1970-08-30 00:00:00	1970-08-30	581452		0	0	0		0	0	0	162950	0	10	40213160		
16509	1368	1713671	1974-12-20	1974-12-20 00:00:00	1975-01-03	1975-01-03 00:00:00	1975-01-03	38000177		0	0	14		0	0	0	90735	0	562251	1713671		
58122	4828	19078461	1984-05-01	1984-05-01 00:00:00	1984-06-30	1984-06-30 00:00:00	1984-06-30	38000177		0	0	60		0	0	0	321252	0	310965	19078461		
112013	2461	40213160	1967-07-11	1967-07-11 00:00:00	1967-07-11	1967-07-11 00:00:00	1967-07-11	581452		0	0	0		0	0	0	163187	0	10	40213160		
4603	99	40213260	2009-07-18	2009-07-18 00:00:00	2009-07-18	2009-07-18 00:00:00	2009-07-18	581452		0	0	0		0	0	0	6751	0	121	40213260		
31918	2646	19078461	1988-04-29	1988-04-29 00:00:00	1988-07-28	1988-07-28 00:00:00	1988-07-28	38000177		0	0	90		0	0	0	175083	0	310965	19078461		
155055	3413	40213160	1966-10-05	1966-10-05 00:00:00	1966-10-05	1966-10-05 00:00:00	1966-10-05	581452		0	0	0		0	0	0	226415	0	10	40213160		
35986	2961	40236824	2017-10-09	2017-10-09 00:00:00	2017-10-16	2017-10-16 00:00:00	2017-10-16	38000177		0	0	7		0	0	0	197728	0	1094107	40236824		
30366	2518	1713671	1999-09-03	1999-09-03 00:00:00	1999-09-10	1999-09-10 00:00:00	1999-09-10	38000177		0	0	7		0	0	0	166507	0	562251	1713671		
7593	639	19006318	1956-12-04	1956-12-04 00:00:00	1956-12-18	1956-12-18 00:00:00	1956-12-18	38000177		0	0	14		0	0	0	42293	0	105078	19006318		
43022	3566	1713671	1955-04-01	1955-04-01 00:00:00	1955-04-15	1955-04-15 00:00:00	1955-04-15	38000177		0	0	14		0	0	0	236807	0	562251	1713671		
63021	5236	1713671	1993-02-26	1993-02-26 00:00:00	1993-03-05	1993-03-05 00:00:00	1993-03-05	38000177		0	0	7		0	0	0	348405	0	562251	1713671		
51089	1118	40213160	1974-04-21	1974-04-21 00:00:00	1974-04-21	1974-04-21 00:00:00	1974-04-21	581452		0	0	0		0	0	0	73696	0	10	40213160		
60800	5056	19059056	1939-02-19	1939-02-19 00:00:00	1939-03-05	1939-03-05 00:00:00	1939-03-05	38000177		0	0	14		0	0	0	336219	0	243670	19059056		
12573	1058	1127433	1986-10-07	1986-10-07 00:00:00	1986-10-14	1986-10-14 00:00:00	1986-10-14	38000177		0	0	7		0	0	0	69383	0	313782	1127433		
28807	2381	19078461	1982-11-15	1982-11-15 00:00:00	1982-12-06	1982-12-06 00:00:00	1982-12-06	38000177		0	0	21		0	0	0	158242	0	310965	19078461		
15446	1289	19059056	1963-06-19	1963-06-19 00:00:00	1963-07-03	1963-07-03 00:00:00	1963-07-03	38000177		0	0	14		0	0	0	85199	0	243670	19059056		
11201	239	40213227	2006-12-14	2006-12-14 00:00:00	2006-12-14	2006-12-14 00:00:00	2006-12-14	581452		0	0	0		0	0	0	16070	0	113	40213227		
188711	4143	40213296	2004-05-21	2004-05-21 00:00:00	2004-05-21	2004-05-21 00:00:00	2004-05-21	581452		0	0	0		0	0	0	275389	0	52	40213296		
33716	2790	19128065	1975-06-04	1975-06-04 00:00:00	1976-05-29	1976-05-29 00:00:00	1976-05-29	38000177		0	0	360		0	0	0	184902	0	749882	19128065		
44651	972	40213260	2017-06-07	2017-06-07 00:00:00	2017-06-07	2017-06-07 00:00:00	2017-06-07	581452		0	0	0		0	0	0	64705	0	121	40213260		
46234	3830	19075001	1985-07-11	1985-07-11 00:00:00	1985-07-25	1985-07-25 00:00:00	1985-07-25	38000177		0	0	14		0	0	0	254321	0	309097	19075001		
39196	3238	1713671	1979-12-15	1979-12-15 00:00:00	1979-12-29	1979-12-29 00:00:00	1979-12-29	38000177		0	0	14		0	0	0	215288	0	562251	1713671		
52693	4380	19059056	1970-05-19	1970-05-19 00:00:00	1970-07-18	1970-07-18 00:00:00	1970-07-18	38000177		0	0	60		0	0	0	290995	0	243670	19059056		
29675	2458	1127078	1981-09-23	1981-09-23 00:00:00	1981-10-21	1981-10-21 00:00:00	1981-10-21	38000177		0	0	28		0	0	0	162941	0	282464	1127078		
63263	5255	19133905	1993-07-02	1993-07-02 00:00:00	1993-07-12	1993-07-12 00:00:00	1993-07-12	38000177		0	0	10		0	0	0	349677	0	834102	19133905		
63279	5256	1127433	2008-03-05	2008-03-05 00:00:00	2008-06-03	2008-06-03 00:00:00	2008-06-03	38000177		0	0	90		0	0	0	349708	0	313782	1127433		
51980	4321	1124300	2006-05-13	2006-05-13 00:00:00	2006-05-13	2006-05-13 00:00:00	\N	38000177		0	0	0		0	0	0	286740	0	00781178901	45011828		
150320	3307	40213227	2007-11-15	2007-11-15 00:00:00	2007-11-15	2007-11-15 00:00:00	2007-11-15	581452		0	0	0		0	0	0	219571	0	113	40213227		
35756	2945	19006318	1950-11-18	1950-11-18 00:00:00	1950-12-02	1950-12-02 00:00:00	1950-12-02	38000177		0	0	14		0	0	0	196468	0	105078	19006318		
126947	2792	40213160	1958-06-16	1958-06-16 00:00:00	1958-06-16	1958-06-16 00:00:00	1958-06-16	581452		0	0	0		0	0	0	185049	0	10	40213160		
198212	4355	40213227	2012-07-14	2012-07-14 00:00:00	2012-07-14	2012-07-14 00:00:00	2012-07-14	581452		0	0	0		0	0	0	288977	0	113	40213227		
93127	2044	40213306	1984-06-23	1984-06-23 00:00:00	1984-06-23	1984-06-23 00:00:00	1984-06-23	581452		0	0	0		0	0	0	136018	0	43	40213306		
8161	680	19112599	1971-10-15	1971-10-15 00:00:00	1971-10-15	1971-10-15 00:00:00	\N	38000177		0	0	0		0	0	0	44999	0	477045	19112599		
61502	5117	1127433	1988-03-16	1988-03-16 00:00:00	1988-06-14	1988-06-14 00:00:00	1988-06-14	38000177		0	0	90		0	0	0	340144	0	313782	1127433		
174495	3836	40213227	2008-10-03	2008-10-03 00:00:00	2008-10-03	2008-10-03 00:00:00	2008-10-03	581452		0	0	0		0	0	0	\N	0	113	40213227		
232435	5107	40213306	1997-10-11	1997-10-11 00:00:00	1997-10-11	1997-10-11 00:00:00	1997-10-11	581452		0	0	0		0	0	0	\N	0	43	40213306		
71863	1571	40213296	1997-02-07	1997-02-07 00:00:00	1997-02-07	1997-02-07 00:00:00	1997-02-07	581452		0	0	0		0	0	0	105452	0	52	40213296		
33486	730	40213160	1962-03-24	1962-03-24 00:00:00	1962-03-24	1962-03-24 00:00:00	1962-03-24	581452		0	0	0		0	0	0	48439	0	10	40213160		
2245	181	1118084	2010-08-28	2010-08-28 00:00:00	2010-08-28	2010-08-28 00:00:00	\N	38000177		0	0	0		0	0	0	12238	0	00025152531	44923712		
47013	3895	19059056	1925-08-26	1925-08-26 00:00:00	1925-09-09	1925-09-09 00:00:00	1925-09-09	38000177		0	0	14		0	0	0	259092	0	243670	19059056		
29469	2439	19129655	1973-08-24	1973-08-24 00:00:00	1973-09-07	1973-09-07 00:00:00	1973-09-07	38000177		0	0	14		0	0	0	161811	0	789980	19129655		
42237	3504	19059056	1937-12-25	1937-12-25 00:00:00	1938-01-24	1938-01-24 00:00:00	1938-01-24	38000177		0	0	30		0	0	0	232333	0	243670	19059056		
85160	1864	40213227	2016-12-09	2016-12-09 00:00:00	2016-12-09	2016-12-09 00:00:00	2016-12-09	581452		0	0	0		0	0	0	124530	0	113	40213227		
237937	5223	40213227	2010-01-30	2010-01-30 00:00:00	2010-01-30	2010-01-30 00:00:00	2010-01-30	581452		0	0	0		0	0	0	347574	0	113	40213227		
23418	1928	19128065	1985-07-31	1985-07-31 00:00:00	1986-07-26	1986-07-26 00:00:00	1986-07-26	38000177		0	0	360		0	0	0	128373	0	749882	19128065		
46678	3866	1127433	1984-04-12	1984-04-12 00:00:00	1984-04-19	1984-04-19 00:00:00	1984-04-19	38000177		0	0	7		0	0	0	256732	0	313782	1127433		
29807	2469	1127433	1993-04-08	1993-04-08 00:00:00	1993-04-15	1993-04-15 00:00:00	1993-04-15	38000177		0	0	7		0	0	0	163756	0	313782	1127433		
226780	4979	40213306	1999-04-30	1999-04-30 00:00:00	1999-04-30	1999-04-30 00:00:00	1999-04-30	581452		0	0	0		0	0	0	331257	0	43	40213306		
35053	764	40213306	1992-05-26	1992-05-26 00:00:00	1992-05-26	1992-05-26 00:00:00	1992-05-26	581452		0	0	0		0	0	0	\N	0	43	40213306		
59558	4952	19128022	1989-02-19	1989-02-19 00:00:00	1990-02-14	1990-02-14 00:00:00	1990-02-14	38000177		0	0	360		0	0	0	329130	0	749785	19128022		
167903	3691	40213227	2015-11-20	2015-11-20 00:00:00	2015-11-20	2015-11-20 00:00:00	2015-11-20	581452		0	0	0		0	0	0	245356	0	113	40213227		
61878	5146	1127078	1952-08-03	1952-08-03 00:00:00	1952-08-24	1952-08-24 00:00:00	1952-08-24	38000177		0	0	21		0	0	0	342081	0	282464	1127078		
58582	4865	1127433	1991-01-11	1991-01-11 00:00:00	1991-02-01	1991-02-01 00:00:00	1991-02-01	38000177		0	0	21		0	0	0	323503	0	313782	1127433		
241211	5295	40213227	1992-08-19	1992-08-19 00:00:00	1992-08-19	1992-08-19 00:00:00	1992-08-19	581452		0	0	0		0	0	0	352294	0	113	40213227		
93680	2056	40213306	1998-04-29	1998-04-29 00:00:00	1998-04-29	1998-04-29 00:00:00	1998-04-29	581452		0	0	0		0	0	0	136728	0	43	40213306		
129134	2839	40213306	1995-02-20	1995-02-20 00:00:00	1995-02-20	1995-02-20 00:00:00	1995-02-20	581452		0	0	0		0	0	0	188544	0	43	40213306		
31022	2570	19059056	1958-08-21	1958-08-21 00:00:00	1958-09-04	1958-09-04 00:00:00	1958-09-04	38000177		0	0	14		0	0	0	170197	0	243670	19059056		
42901	936	40213296	2000-11-03	2000-11-03 00:00:00	2000-11-03	2000-11-03 00:00:00	2000-11-03	581452		0	0	0		0	0	0	62259	0	52	40213296		
4047	334	1115171	2005-09-03	2005-09-03 00:00:00	2005-11-02	2005-11-02 00:00:00	2005-11-02	38000177		0	0	60		0	0	0	22115	0	849574	1115171		
35032	2893	19059056	1948-03-07	1948-03-07 00:00:00	1948-06-05	1948-06-05 00:00:00	1948-06-05	38000177		0	0	90		0	0	0	192516	0	243670	19059056		
19585	426	40213306	1988-04-28	1988-04-28 00:00:00	1988-04-28	1988-04-28 00:00:00	1988-04-28	581452		0	0	0		0	0	0	28307	0	43	40213306		
597	43	19059056	1957-03-17	1957-03-17 00:00:00	1957-03-31	1957-03-31 00:00:00	1957-03-31	38000177		0	0	14		0	0	0	3176	0	243670	19059056		
35149	2899	19006318	1950-03-23	1950-03-23 00:00:00	1950-04-06	1950-04-06 00:00:00	1950-04-06	38000177		0	0	14		0	0	0	193174	0	105078	19006318		
111885	2458	40213160	1971-01-31	1971-01-31 00:00:00	1971-01-31	1971-01-31 00:00:00	1971-01-31	581452		0	0	0		0	0	0	162951	0	10	40213160		
16510	1368	19059056	1985-01-30	1985-01-30 00:00:00	1985-02-20	1985-02-20 00:00:00	1985-02-20	38000177		0	0	21		0	0	0	90747	0	243670	19059056		
58123	4828	1118084	2014-01-07	2014-01-07 00:00:00	2014-01-07	2014-01-07 00:00:00	\N	38000177		0	0	0		0	0	0	321274	0	00025152531	44923712		
112016	2461	40213296	2006-11-07	2006-11-07 00:00:00	2006-11-07	2006-11-07 00:00:00	2006-11-07	581452		0	0	0		0	0	0	163154	0	52	40213296		
4605	99	40213160	1959-01-31	1959-01-31 00:00:00	1959-01-31	1959-01-31 00:00:00	1959-01-31	581452		0	0	0		0	0	0	6735	0	10	40213160		
31919	2646	1127433	1982-02-19	1982-02-19 00:00:00	1982-02-26	1982-02-26 00:00:00	1982-02-26	38000177		0	0	7		0	0	0	175074	0	313782	1127433		
155057	3413	40213160	1971-04-07	1971-04-07 00:00:00	1971-04-07	1971-04-07 00:00:00	1971-04-07	581452		0	0	0		0	0	0	226366	0	10	40213160		
35987	2961	920300	2017-10-09	2017-10-09 00:00:00	2017-10-16	2017-10-16 00:00:00	2017-10-16	38000177		0	0	7		0	0	0	197728	0	311989	920300		
30368	2518	1713671	1978-01-07	1978-01-07 00:00:00	1978-01-14	1978-01-14 00:00:00	1978-01-14	38000177		0	0	7		0	0	0	166502	0	562251	1713671		
7594	639	19059056	1956-12-04	1956-12-04 00:00:00	1956-12-18	1956-12-18 00:00:00	1956-12-18	38000177		0	0	14		0	0	0	42293	0	243670	19059056		
43023	3566	1127433	2005-07-31	2005-07-31 00:00:00	2005-08-14	2005-08-14 00:00:00	2005-08-14	38000177		0	0	14		0	0	0	236970	0	313782	1127433		
63023	5236	1127433	1986-03-22	1986-03-22 00:00:00	1986-04-05	1986-04-05 00:00:00	1986-04-05	38000177		0	0	14		0	0	0	348403	0	313782	1127433		
69734	1524	40213160	1971-12-23	1971-12-23 00:00:00	1971-12-23	1971-12-23 00:00:00	1971-12-23	581452		0	0	0		0	0	0	101898	0	10	40213160		
60801	5056	1118084	1979-07-04	1979-07-04 00:00:00	1979-07-04	1979-07-04 00:00:00	\N	38000177		0	0	0		0	0	0	336176	0	00025152531	44923712		
12574	1058	40162522	2004-06-06	2004-06-06 00:00:00	2004-06-06	2004-06-06 00:00:00	\N	38000177		0	0	0		0	0	0	69405	0	857005	40162522		
28808	2381	19075601	1997-05-21	1997-05-21 00:00:00	1997-05-21	1997-05-21 00:00:00	\N	38000177		0	0	0		0	0	0	158266	0	309362	19075601		
15447	1289	19129655	1963-06-19	1963-06-19 00:00:00	1963-07-03	1963-07-03 00:00:00	1963-07-03	38000177		0	0	14		0	0	0	85199	0	789980	19129655		
11209	239	40213201	2012-01-12	2012-01-12 00:00:00	2012-01-12	2012-01-12 00:00:00	2012-01-12	581452		0	0	0		0	0	0	16025	0	33	40213201		
188716	4143	40213160	1966-09-09	1966-09-09 00:00:00	1966-09-09	1966-09-09 00:00:00	1966-09-09	581452		0	0	0		0	0	0	275351	0	10	40213160		
33717	2790	19133873	1967-08-28	1967-08-28 00:00:00	1967-09-06	1967-09-06 00:00:00	1967-09-06	38000177		0	0	9		0	0	0	184868	0	834061	19133873		
44654	972	40213306	1988-08-03	1988-08-03 00:00:00	1988-08-03	1988-08-03 00:00:00	1988-08-03	581452		0	0	0		0	0	0	64687	0	43	40213306		
46235	3830	1115171	2008-07-26	2008-07-26 00:00:00	2008-08-09	2008-08-09 00:00:00	2008-08-09	38000177		0	0	14		0	0	0	254322	0	849574	1115171		
39197	3238	19059056	1968-03-23	1968-03-23 00:00:00	1968-04-06	1968-04-06 00:00:00	1968-04-06	38000177		0	0	14		0	0	0	215290	0	243670	19059056		
52694	4380	1127433	1971-09-13	1971-09-13 00:00:00	1971-09-20	1971-09-20 00:00:00	1971-09-20	38000177		0	0	7		0	0	0	291028	0	313782	1127433		
29676	2458	1118084	2006-03-01	2006-03-01 00:00:00	2006-03-01	2006-03-01 00:00:00	\N	38000177		0	0	0		0	0	0	162997	0	00025152531	44923712		
63264	5255	19078461	2015-12-18	2015-12-18 00:00:00	2016-01-01	2016-01-01 00:00:00	2016-01-01	38000177		0	0	14		0	0	0	349706	0	310965	19078461		
63280	5256	1124300	2004-02-15	2004-02-15 00:00:00	2004-02-15	2004-02-15 00:00:00	\N	38000177		0	0	0		0	0	0	349756	0	00781178901	45011828		
51981	4321	1127433	1991-03-23	1991-03-23 00:00:00	1991-03-30	1991-03-30 00:00:00	1991-03-30	38000177		0	0	7		0	0	0	286763	0	313782	1127433		
150321	3307	40213296	2007-11-15	2007-11-15 00:00:00	2007-11-15	2007-11-15 00:00:00	2007-11-15	581452		0	0	0		0	0	0	219571	0	52	40213296		
35757	2945	1127433	1981-06-25	1981-06-25 00:00:00	1981-07-09	1981-07-09 00:00:00	1981-07-09	38000177		0	0	14		0	0	0	196541	0	313782	1127433		
126949	2792	40213260	2008-06-02	2008-06-02 00:00:00	2008-06-02	2008-06-02 00:00:00	2008-06-02	581452		0	0	0		0	0	0	\N	0	121	40213260		
198218	4355	40213314	1981-07-25	1981-07-25 00:00:00	1981-07-25	1981-07-25 00:00:00	1981-07-25	581452		0	0	0		0	0	0	288960	0	49	40213314		
93133	2044	40213160	1962-01-20	1962-01-20 00:00:00	1962-01-20	1962-01-20 00:00:00	1962-01-20	581452		0	0	0		0	0	0	135973	0	10	40213160		
8162	680	19133905	1994-05-17	1994-05-17 00:00:00	1994-05-30	1994-05-30 00:00:00	1994-05-30	38000177		0	0	13		0	0	0	45041	0	834102	19133905		
61503	5117	1713671	2010-11-14	2010-11-14 00:00:00	2010-11-28	2010-11-28 00:00:00	2010-11-28	38000177		0	0	14		0	0	0	340085	0	562251	1713671		
174500	3836	40213227	2000-11-24	2000-11-24 00:00:00	2000-11-24	2000-11-24 00:00:00	2000-11-24	581452		0	0	0		0	0	0	254732	0	113	40213227		
232436	5107	40213160	1975-11-15	1975-11-15 00:00:00	1975-11-15	1975-11-15 00:00:00	1975-11-15	581452		0	0	0		0	0	0	339326	0	10	40213160		
71869	1571	40213160	1959-06-12	1959-06-12 00:00:00	1959-06-12	1959-06-12 00:00:00	1959-06-12	581452		0	0	0		0	0	0	105514	0	10	40213160		
33488	730	40213227	2008-04-19	2008-04-19 00:00:00	2008-04-19	2008-04-19 00:00:00	2008-04-19	581452		0	0	0		0	0	0	48453	0	113	40213227		
2246	181	1127078	1975-02-08	1975-02-08 00:00:00	1975-02-22	1975-02-22 00:00:00	1975-02-22	38000177		0	0	14		0	0	0	12246	0	282464	1127078		
47014	3895	1127433	1933-09-14	1933-09-14 00:00:00	1933-09-28	1933-09-28 00:00:00	1933-09-28	38000177		0	0	14		0	0	0	259115	0	313782	1127433		
29470	2439	19078461	1989-10-25	1989-10-25 00:00:00	1989-11-08	1989-11-08 00:00:00	1989-11-08	38000177		0	0	14		0	0	0	161796	0	310965	19078461		
42238	3504	40223774	2002-11-23	2002-11-23 00:00:00	2002-11-23	2002-11-23 00:00:00	\N	38000177		0	0	0		0	0	0	232308	0	998582	40223774		
85161	1864	40213260	2016-12-09	2016-12-09 00:00:00	2016-12-09	2016-12-09 00:00:00	2016-12-09	581452		0	0	0		0	0	0	124530	0	121	40213260		
237939	5223	40213296	2010-01-30	2010-01-30 00:00:00	2010-01-30	2010-01-30 00:00:00	2010-01-30	581452		0	0	0		0	0	0	347574	0	52	40213296		
23419	1928	40229134	1974-03-22	1974-03-22 00:00:00	1974-04-05	1974-04-05 00:00:00	1974-04-05	38000177		0	0	14		0	0	0	128321	0	1043400	40229134		
124766	2745	40213160	1971-06-27	1971-06-27 00:00:00	1971-06-27	1971-06-27 00:00:00	1971-06-27	581452		0	0	0		0	0	0	181554	0	10	40213160		
29808	2469	46233988	1977-04-12	1977-04-12 00:00:00	1977-04-26	1977-04-26 00:00:00	1977-04-26	38000177		0	0	14		0	0	0	163750	0	1652673	46233988		
145169	3191	40213260	2009-01-15	2009-01-15 00:00:00	2009-01-15	2009-01-15 00:00:00	2009-01-15	581452		0	0	0		0	0	0	212372	0	121	40213260		
35057	764	40213227	2003-01-28	2003-01-28 00:00:00	2003-01-28	2003-01-28 00:00:00	2003-01-28	581452		0	0	0		0	0	0	50843	0	113	40213227		
59559	4952	964261	1991-03-16	1991-03-16 00:00:00	1991-03-16	1991-03-16 00:00:00	\N	38000177		0	0	0		0	0	0	329128	0	2001499	964261		
167655	3686	40213160	1968-04-29	1968-04-29 00:00:00	1968-04-29	1968-04-29 00:00:00	1968-04-29	581452		0	0	0		0	0	0	245069	0	10	40213160		
61879	5146	1127433	1950-11-26	1950-11-26 00:00:00	1950-12-03	1950-12-03 00:00:00	1950-12-03	38000177		0	0	7		0	0	0	342085	0	313782	1127433		
58583	4865	1127433	1980-06-29	1980-06-29 00:00:00	1980-07-06	1980-07-06 00:00:00	1980-07-06	38000177		0	0	7		0	0	0	323490	0	313782	1127433		
241217	5295	40213227	2001-08-22	2001-08-22 00:00:00	2001-08-22	2001-08-22 00:00:00	2001-08-22	581452		0	0	0		0	0	0	352297	0	113	40213227		
93688	2056	40213296	2016-02-17	2016-02-17 00:00:00	2016-02-17	2016-02-17 00:00:00	2016-02-17	581452		0	0	0		0	0	0	136753	0	52	40213296		
129138	2839	40213227	2004-03-01	2004-03-01 00:00:00	2004-03-01	2004-03-01 00:00:00	2004-03-01	581452		0	0	0		0	0	0	188559	0	113	40213227		
10031	842	19059056	1948-08-04	1948-08-04 00:00:00	1948-09-01	1948-09-01 00:00:00	1948-09-01	38000177		0	0	28		0	0	0	55710	0	243670	19059056		
42904	936	40213160	1961-07-07	1961-07-07 00:00:00	1961-07-07	1961-07-07 00:00:00	1961-07-07	581452		0	0	0		0	0	0	62253	0	10	40213160		
4048	334	1127433	1979-02-19	1979-02-19 00:00:00	1979-03-26	1979-03-26 00:00:00	1979-03-26	38000177		0	0	35		0	0	0	22113	0	313782	1127433		
35033	2893	1127433	1949-05-25	1949-05-25 00:00:00	1949-06-01	1949-06-01 00:00:00	1949-06-01	38000177		0	0	7		0	0	0	192451	0	313782	1127433		
19588	426	40213227	2008-01-24	2008-01-24 00:00:00	2008-01-24	2008-01-24 00:00:00	2008-01-24	581452		0	0	0		0	0	0	28311	0	113	40213227		
598	43	19006318	1957-03-17	1957-03-17 00:00:00	1957-03-31	1957-03-31 00:00:00	1957-03-31	38000177		0	0	14		0	0	0	3176	0	105078	19006318		
35150	2899	19133873	1955-12-06	1955-12-06 00:00:00	1955-12-15	1955-12-15 00:00:00	1955-12-15	38000177		0	0	9		0	0	0	193114	0	834061	19133873		
111886	2458	40213296	2010-05-30	2010-05-30 00:00:00	2010-05-30	2010-05-30 00:00:00	2010-05-30	581452		0	0	0		0	0	0	162998	0	52	40213296		
16511	1368	1713671	1994-01-11	1994-01-11 00:00:00	1994-01-25	1994-01-25 00:00:00	1994-01-25	38000177		0	0	14		0	0	0	90709	0	562251	1713671		
58124	4828	46233988	1972-02-20	1972-02-20 00:00:00	1972-03-05	1972-03-05 00:00:00	1972-03-05	38000177		0	0	14		0	0	0	321241	0	1652673	46233988		
112019	2461	40213227	2018-01-02	2018-01-02 00:00:00	2018-01-02	2018-01-02 00:00:00	2018-01-02	581452		0	0	0		0	0	0	163156	0	113	40213227		
4622	99	40213160	1959-07-04	1959-07-04 00:00:00	1959-07-04	1959-07-04 00:00:00	1959-07-04	581452		0	0	0		0	0	0	6736	0	10	40213160		
31920	2646	40229134	1986-11-16	1986-11-16 00:00:00	1986-11-23	1986-11-23 00:00:00	1986-11-23	38000177		0	0	7		0	0	0	175064	0	1043400	40229134		
155062	3413	40213227	1997-10-01	1997-10-01 00:00:00	1997-10-01	1997-10-01 00:00:00	1997-10-01	581452		0	0	0		0	0	0	226396	0	113	40213227		
35988	2961	40162522	1999-05-03	1999-05-03 00:00:00	1999-05-03	1999-05-03 00:00:00	\N	38000177		0	0	0		0	0	0	197713	0	857005	40162522		
30370	2518	40243436	1986-08-08	1986-08-08 00:00:00	1986-08-08	1986-08-08 00:00:00	1986-08-08	38000177		0	0	0		0	0	0	166542	0	1190795	40243436		
7595	639	1127433	1983-02-01	1983-02-01 00:00:00	1983-02-15	1983-02-15 00:00:00	1983-02-15	38000177		0	0	14		0	0	0	42303	0	313782	1127433		
43024	3566	19112599	1953-08-12	1953-08-12 00:00:00	1953-08-12	1953-08-12 00:00:00	\N	38000177		0	0	0		0	0	0	236851	0	477045	19112599		
63024	5236	1127433	2017-10-12	2017-10-12 00:00:00	2017-10-19	2017-10-19 00:00:00	2017-10-19	38000177		0	0	7		0	0	0	348423	0	313782	1127433		
69736	1524	40213160	1967-09-21	1967-09-21 00:00:00	1967-09-21	1967-09-21 00:00:00	1967-09-21	581452		0	0	0		0	0	0	101938	0	10	40213160		
60802	5056	1115171	2013-09-30	2013-09-30 00:00:00	2013-10-14	2013-10-14 00:00:00	2013-10-14	38000177		0	0	14		0	0	0	336182	0	849574	1115171		
12575	1058	19008572	1965-01-08	1965-01-08 00:00:00	1965-01-22	1965-01-22 00:00:00	1965-01-22	38000177		0	0	14		0	0	0	69474	0	106258	19008572		
28809	2381	1127433	1987-07-13	1987-07-13 00:00:00	1987-08-10	1987-08-10 00:00:00	1987-08-10	38000177		0	0	28		0	0	0	158243	0	313782	1127433		
15448	1289	19059056	1972-09-28	1972-09-28 00:00:00	1972-10-12	1972-10-12 00:00:00	1972-10-12	38000177		0	0	14		0	0	0	85240	0	243670	19059056		
22945	498	40213160	1970-09-03	1970-09-03 00:00:00	1970-09-03	1970-09-03 00:00:00	1970-09-03	581452		0	0	0		0	0	0	33294	0	10	40213160		
188719	4143	40213296	2002-05-17	2002-05-17 00:00:00	2002-05-17	2002-05-17 00:00:00	2002-05-17	581452		0	0	0		0	0	0	275367	0	52	40213296		
33718	2790	19059056	1966-07-11	1966-07-11 00:00:00	1966-08-08	1966-08-08 00:00:00	1966-08-08	38000177		0	0	28		0	0	0	184871	0	243670	19059056		
130315	2864	40213227	2011-02-17	2011-02-17 00:00:00	2011-02-17	2011-02-17 00:00:00	2011-02-17	581452		0	0	0		0	0	0	190490	0	113	40213227		
46236	3830	19073188	2008-07-26	2008-07-26 00:00:00	2008-08-09	2008-08-09 00:00:00	2008-08-09	38000177		0	0	14		0	0	0	254322	0	308192	19073188		
39198	3238	19129655	1968-03-23	1968-03-23 00:00:00	1968-04-06	1968-04-06 00:00:00	1968-04-06	38000177		0	0	14		0	0	0	215290	0	789980	19129655		
52695	4380	1127433	2014-04-19	2014-04-19 00:00:00	2014-05-10	2014-05-10 00:00:00	2014-05-10	38000177		0	0	21		0	0	0	290997	0	313782	1127433		
29677	2458	19129655	1972-03-14	1972-03-14 00:00:00	1972-03-28	1972-03-28 00:00:00	1972-03-28	38000177		0	0	14		0	0	0	162961	0	789980	19129655		
63266	5256	1127078	1963-09-23	1963-09-23 00:00:00	1963-10-07	1963-10-07 00:00:00	1963-10-07	38000177		0	0	14		0	0	0	349715	0	282464	1127078		
63281	5257	1127433	1986-07-03	1986-07-03 00:00:00	1986-07-17	1986-07-17 00:00:00	1986-07-17	38000177		0	0	14		0	0	0	349833	0	313782	1127433		
51987	4324	19059056	1967-01-30	1967-01-30 00:00:00	1967-02-13	1967-02-13 00:00:00	1967-02-13	38000177		0	0	14		0	0	0	286845	0	243670	19059056		
150325	3307	40213296	2005-11-10	2005-11-10 00:00:00	2005-11-10	2005-11-10 00:00:00	2005-11-10	581452		0	0	0		0	0	0	219612	0	52	40213296		
35758	2945	19133873	1945-10-19	1945-10-19 00:00:00	1945-11-01	1945-11-01 00:00:00	1945-11-01	38000177		0	0	13		0	0	0	196520	0	834061	19133873		
126952	2792	40213227	1999-10-18	1999-10-18 00:00:00	1999-10-18	1999-10-18 00:00:00	1999-10-18	581452		0	0	0		0	0	0	185036	0	113	40213227		
198219	4355	40213160	1981-07-25	1981-07-25 00:00:00	1981-07-25	1981-07-25 00:00:00	1981-07-25	581452		0	0	0		0	0	0	288960	0	10	40213160		
93137	2044	40213227	2003-10-25	2003-10-25 00:00:00	2003-10-25	2003-10-25 00:00:00	2003-10-25	581452		0	0	0		0	0	0	136003	0	113	40213227		
8163	680	40229134	1989-03-19	1989-03-19 00:00:00	1989-04-02	1989-04-02 00:00:00	1989-04-02	38000177		0	0	14		0	0	0	44995	0	1043400	40229134		
61504	5117	19112599	1960-03-30	1960-03-30 00:00:00	1960-03-30	1960-03-30 00:00:00	\N	38000177		0	0	0		0	0	0	340031	0	477045	19112599		
174501	3836	40213306	2000-11-24	2000-11-24 00:00:00	2000-11-24	2000-11-24 00:00:00	2000-11-24	581452		0	0	0		0	0	0	254732	0	43	40213306		
232438	5107	40213227	2006-10-28	2006-10-28 00:00:00	2006-10-28	2006-10-28 00:00:00	2006-10-28	581452		0	0	0		0	0	0	339357	0	113	40213227		
71879	1571	40213227	2005-07-08	2005-07-08 00:00:00	2005-07-08	2005-07-08 00:00:00	2005-07-08	581452		0	0	0		0	0	0	105410	0	113	40213227		
33495	730	40213160	1957-07-20	1957-07-20 00:00:00	1957-07-20	1957-07-20 00:00:00	1957-07-20	581452		0	0	0		0	0	0	48507	0	10	40213160		
2247	181	19006318	1975-02-08	1975-02-08 00:00:00	1975-02-22	1975-02-22 00:00:00	1975-02-22	38000177		0	0	14		0	0	0	12246	0	105078	19006318		
47015	3895	19059056	1953-06-30	1953-06-30 00:00:00	1953-07-30	1953-07-30 00:00:00	1953-07-30	38000177		0	0	30		0	0	0	259022	0	243670	19059056		
29472	2439	1127078	1981-02-04	1981-02-04 00:00:00	1981-03-11	1981-03-11 00:00:00	1981-03-11	38000177		0	0	35		0	0	0	161795	0	282464	1127078		
42239	3504	19059056	1939-11-15	1939-11-15 00:00:00	1940-01-14	1940-01-14 00:00:00	1940-01-14	38000177		0	0	60		0	0	0	232334	0	243670	19059056		
85165	1864	40213227	1996-12-20	1996-12-20 00:00:00	1996-12-20	1996-12-20 00:00:00	1996-12-20	581452		0	0	0		0	0	0	124526	0	113	40213227		
237942	5223	40213227	1999-08-14	1999-08-14 00:00:00	1999-08-14	1999-08-14 00:00:00	1999-08-14	581452		0	0	0		0	0	0	347552	0	113	40213227		
23420	1928	1127433	1996-02-24	1996-02-24 00:00:00	1996-03-16	1996-03-16 00:00:00	1996-03-16	38000177		0	0	21		0	0	0	128378	0	313782	1127433		
124767	2745	40213160	1971-08-29	1971-08-29 00:00:00	1971-08-29	1971-08-29 00:00:00	1971-08-29	581452		0	0	0		0	0	0	181583	0	10	40213160		
29809	2469	1127078	1977-04-12	1977-04-12 00:00:00	1977-04-26	1977-04-26 00:00:00	1977-04-26	38000177		0	0	14		0	0	0	163750	0	282464	1127078		
156448	3443	40213160	1981-09-23	1981-09-23 00:00:00	1981-09-23	1981-09-23 00:00:00	1981-09-23	581452		0	0	0		0	0	0	228473	0	10	40213160		
78117	1709	40213227	1997-10-18	1997-10-18 00:00:00	1997-10-18	1997-10-18 00:00:00	1997-10-18	581452		0	0	0		0	0	0	114249	0	113	40213227		
59560	4952	46233988	1973-02-17	1973-02-17 00:00:00	1973-03-03	1973-03-03 00:00:00	1973-03-03	38000177		0	0	14		0	0	0	329156	0	1652673	46233988		
167656	3686	40213260	2019-03-18	2019-03-18 00:00:00	2019-03-18	2019-03-18 00:00:00	2019-03-18	581452		0	0	0		0	0	0	245080	0	121	40213260		
61885	5148	1118084	1998-01-21	1998-01-21 00:00:00	1998-01-21	1998-01-21 00:00:00	\N	38000177		0	0	0		0	0	0	342289	0	00025152531	44923712		
58584	4865	1127433	2005-04-28	2005-04-28 00:00:00	2005-05-05	2005-05-05 00:00:00	2005-05-05	38000177		0	0	7		0	0	0	323492	0	313782	1127433		
128900	2834	40213227	1998-08-22	1998-08-22 00:00:00	1998-08-22	1998-08-22 00:00:00	1998-08-22	581452		0	0	0		0	0	0	188143	0	113	40213227		
93691	2056	40213160	1981-01-21	1981-01-21 00:00:00	1981-01-21	1981-01-21 00:00:00	1981-01-21	581452		0	0	0		0	0	0	136724	0	10	40213160		
129140	2839	40213296	2012-11-12	2012-11-12 00:00:00	2012-11-12	2012-11-12 00:00:00	2012-11-12	581452		0	0	0		0	0	0	188562	0	52	40213296		
10032	842	40229134	1992-01-28	1992-01-28 00:00:00	1992-02-11	1992-02-11 00:00:00	1992-02-11	38000177		0	0	14		0	0	0	55646	0	1043400	40229134		
42906	936	40213227	1992-01-10	1992-01-10 00:00:00	1992-01-10	1992-01-10 00:00:00	1992-01-10	581452		0	0	0		0	0	0	62247	0	113	40213227		
4049	335	40229134	1986-10-25	1986-10-25 00:00:00	1986-11-08	1986-11-08 00:00:00	1986-11-08	38000177		0	0	14		0	0	0	22279	0	1043400	40229134		
35034	2893	1713671	2005-10-21	2005-10-21 00:00:00	2005-11-11	2005-11-11 00:00:00	2005-11-11	38000177		0	0	21		0	0	0	192460	0	562251	1713671		
19589	426	40213296	2008-01-24	2008-01-24 00:00:00	2008-01-24	2008-01-24 00:00:00	2008-01-24	581452		0	0	0		0	0	0	28311	0	52	40213296		
599	43	1127433	1990-03-24	1990-03-24 00:00:00	1990-04-07	1990-04-07 00:00:00	1990-04-07	38000177		0	0	14		0	0	0	3155	0	313782	1127433		
35151	2899	1127433	1972-12-09	1972-12-09 00:00:00	1972-12-16	1972-12-16 00:00:00	1972-12-16	38000177		0	0	7		0	0	0	193182	0	313782	1127433		
111889	2458	40213306	1993-05-02	1993-05-02 00:00:00	1993-05-02	1993-05-02 00:00:00	1993-05-02	581452		0	0	0		0	0	0	162993	0	43	40213306		
16512	1368	1127433	1971-07-03	1971-07-03 00:00:00	1971-07-17	1971-07-17 00:00:00	1971-07-17	38000177		0	0	14		0	0	0	90707	0	313782	1127433		
58125	4828	19059056	1972-02-20	1972-02-20 00:00:00	1972-03-05	1972-03-05 00:00:00	1972-03-05	38000177		0	0	14		0	0	0	321241	0	243670	19059056		
112020	2461	40213260	2018-01-02	2018-01-02 00:00:00	2018-01-02	2018-01-02 00:00:00	2018-01-02	581452		0	0	0		0	0	0	163156	0	121	40213260		
4624	99	40213160	1963-10-05	1963-10-05 00:00:00	1963-10-05	1963-10-05 00:00:00	1963-10-05	581452		0	0	0		0	0	0	6739	0	10	40213160		
31921	2646	1127433	1991-05-14	1991-05-14 00:00:00	1991-05-28	1991-05-28 00:00:00	1991-05-28	38000177		0	0	14		0	0	0	175084	0	313782	1127433		
155064	3413	40213160	1966-08-03	1966-08-03 00:00:00	1966-08-03	1966-08-03 00:00:00	1966-08-03	581452		0	0	0		0	0	0	226388	0	10	40213160		
36006	2965	1127433	1985-02-06	1985-02-06 00:00:00	1985-02-13	1985-02-13 00:00:00	1985-02-13	38000177		0	0	7		0	0	0	197909	0	313782	1127433		
30371	2518	46275916	1986-08-08	1986-08-08 00:00:00	1986-08-08	1986-08-08 00:00:00	1986-08-08	38000177		0	0	0		0	0	0	166542	0	1660014	46275916		
7597	639	1127433	1998-11-27	1998-11-27 00:00:00	1998-12-11	1998-12-11 00:00:00	1998-12-11	38000177		0	0	14		0	0	0	42311	0	313782	1127433		
43025	3567	1713671	2001-07-13	2001-07-13 00:00:00	2001-08-03	2001-08-03 00:00:00	2001-08-03	38000177		0	0	21		0	0	0	236990	0	562251	1713671		
63026	5236	40162522	1986-07-10	1986-07-10 00:00:00	1986-07-10	1986-07-10 00:00:00	\N	38000177		0	0	0		0	0	0	348426	0	857005	40162522		
69744	1524	40213160	1967-06-22	1967-06-22 00:00:00	1967-06-22	1967-06-22 00:00:00	1967-06-22	581452		0	0	0		0	0	0	101925	0	10	40213160		
60803	5056	1127433	1982-04-16	1982-04-16 00:00:00	1982-07-15	1982-07-15 00:00:00	1982-07-15	38000177		0	0	90		0	0	0	336165	0	313782	1127433		
12576	1058	1713671	2007-02-09	2007-02-09 00:00:00	2007-02-23	2007-02-23 00:00:00	2007-02-23	38000177		0	0	14		0	0	0	69421	0	562251	1713671		
28810	2381	19133905	2012-11-25	2012-11-25 00:00:00	2012-12-06	2012-12-06 00:00:00	2012-12-06	38000177		0	0	11		0	0	0	158335	0	834102	19133905		
15449	1289	1713671	1995-06-06	1995-06-06 00:00:00	1995-06-20	1995-06-20 00:00:00	1995-06-20	38000177		0	0	14		0	0	0	85210	0	562251	1713671		
22947	498	40213296	2010-04-01	2010-04-01 00:00:00	2010-04-01	2010-04-01 00:00:00	2010-04-01	581452		0	0	0		0	0	0	33268	0	52	40213296		
188720	4143	40213306	1983-12-02	1983-12-02 00:00:00	1983-12-02	1983-12-02 00:00:00	1983-12-02	581452		0	0	0		0	0	0	275364	0	43	40213306		
33719	2790	40231925	1973-07-02	1973-07-02 00:00:00	1973-07-02	1973-07-02 00:00:00	\N	38000177		0	0	0		0	0	0	184872	0	1049221	40231925		
130320	2864	40213227	1992-05-14	1992-05-14 00:00:00	1992-05-14	1992-05-14 00:00:00	1992-05-14	581452		0	0	0		0	0	0	190557	0	113	40213227		
46237	3831	40231925	1971-08-20	1971-08-20 00:00:00	1971-08-20	1971-08-20 00:00:00	\N	38000177		0	0	0		0	0	0	254328	0	1049221	40231925		
39199	3238	1115171	2006-03-11	2006-03-11 00:00:00	2006-04-01	2006-04-01 00:00:00	2006-04-01	38000177		0	0	21		0	0	0	215318	0	849574	1115171		
52696	4380	1713671	1986-12-29	1986-12-29 00:00:00	1987-01-19	1987-01-19 00:00:00	1987-01-19	38000177		0	0	21		0	0	0	291040	0	562251	1713671		
29678	2458	19059056	1972-03-14	1972-03-14 00:00:00	1972-03-28	1972-03-28 00:00:00	1972-03-28	38000177		0	0	14		0	0	0	162961	0	243670	19059056		
63267	5256	1713671	2013-09-25	2013-09-25 00:00:00	2013-10-09	2013-10-09 00:00:00	2013-10-09	38000177		0	0	14		0	0	0	349714	0	562251	1713671		
63282	5257	19128022	2003-01-13	2003-01-13 00:00:00	2004-01-08	2004-01-08 00:00:00	2004-01-08	38000177		0	0	360		0	0	0	349840	0	749785	19128022		
51988	4324	19129655	1967-01-30	1967-01-30 00:00:00	1967-02-13	1967-02-13 00:00:00	1967-02-13	38000177		0	0	14		0	0	0	286845	0	789980	19129655		
150330	3307	40213160	1966-07-01	1966-07-01 00:00:00	1966-07-01	1966-07-01 00:00:00	1966-07-01	581452		0	0	0		0	0	0	219602	0	10	40213160		
35759	2945	1713671	1979-03-05	1979-03-05 00:00:00	1979-03-19	1979-03-19 00:00:00	1979-03-19	38000177		0	0	14		0	0	0	196524	0	562251	1713671		
126953	2792	40213296	1999-10-18	1999-10-18 00:00:00	1999-10-18	1999-10-18 00:00:00	1999-10-18	581452		0	0	0		0	0	0	185036	0	52	40213296		
198223	4355	40213160	1981-09-26	1981-09-26 00:00:00	1981-09-26	1981-09-26 00:00:00	1981-09-26	581452		0	0	0		0	0	0	288948	0	10	40213160		
93138	2044	40213296	2003-10-25	2003-10-25 00:00:00	2003-10-25	2003-10-25 00:00:00	2003-10-25	581452		0	0	0		0	0	0	136003	0	52	40213296		
8164	680	1127433	1986-06-18	1986-06-18 00:00:00	1986-07-02	1986-07-02 00:00:00	1986-07-02	38000177		0	0	14		0	0	0	44959	0	313782	1127433		
61505	5118	1127078	1977-12-23	1977-12-23 00:00:00	1978-02-21	1978-02-21 00:00:00	1978-02-21	38000177		0	0	60		0	0	0	340157	0	282464	1127078		
174504	3836	40213227	2018-11-30	2018-11-30 00:00:00	2018-11-30	2018-11-30 00:00:00	2018-11-30	581452		0	0	0		0	0	0	254735	0	113	40213227		
232440	5107	40213160	1976-02-14	1976-02-14 00:00:00	1976-02-14	1976-02-14 00:00:00	1976-02-14	581452		0	0	0		0	0	0	339310	0	10	40213160		
71887	1571	40213160	1955-03-11	1955-03-11 00:00:00	1955-03-11	1955-03-11 00:00:00	1955-03-11	581452		0	0	0		0	0	0	105424	0	10	40213160		
33500	730	40213160	1957-12-21	1957-12-21 00:00:00	1957-12-21	1957-12-21 00:00:00	1957-12-21	581452		0	0	0		0	0	0	48508	0	10	40213160		
2248	181	40236824	1996-10-09	1996-10-09 00:00:00	1996-10-16	1996-10-16 00:00:00	1996-10-16	38000177		0	0	7		0	0	0	12234	0	1094107	40236824		
47016	3895	1127433	1963-07-29	1963-07-29 00:00:00	1963-08-05	1963-08-05 00:00:00	1963-08-05	38000177		0	0	7		0	0	0	259050	0	313782	1127433		
29473	2439	1127078	1975-05-02	1975-05-02 00:00:00	1975-06-06	1975-06-06 00:00:00	1975-06-06	38000177		0	0	35		0	0	0	161794	0	282464	1127078		
42240	3504	1713671	1988-12-17	1988-12-17 00:00:00	1989-01-07	1989-01-07 00:00:00	1989-01-07	38000177		0	0	21		0	0	0	232321	0	562251	1713671		
85167	1864	40213296	2005-12-09	2005-12-09 00:00:00	2005-12-09	2005-12-09 00:00:00	2005-12-09	581452		0	0	0		0	0	0	124543	0	52	40213296		
156089	3435	40213160	1975-10-04	1975-10-04 00:00:00	1975-10-04	1975-10-04 00:00:00	1975-10-04	581452		0	0	0		0	0	0	227815	0	10	40213160		
23422	1928	40229134	1997-09-23	1997-09-23 00:00:00	1997-09-30	1997-09-30 00:00:00	1997-09-30	38000177		0	0	7		0	0	0	128370	0	1043400	40229134		
124772	2745	40213160	1976-02-29	1976-02-29 00:00:00	1976-02-29	1976-02-29 00:00:00	1976-02-29	581452		0	0	0		0	0	0	181586	0	10	40213160		
29810	2469	1713671	1992-08-28	1992-08-28 00:00:00	1992-09-04	1992-09-04 00:00:00	1992-09-04	38000177		0	0	7		0	0	0	163734	0	562251	1713671		
156451	3443	40213314	1978-05-17	1978-05-17 00:00:00	1978-05-17	1978-05-17 00:00:00	1978-05-17	581452		0	0	0		0	0	0	228464	0	49	40213314		
78135	1709	40213227	2007-12-15	2007-12-15 00:00:00	2007-12-15	2007-12-15 00:00:00	2007-12-15	581452		0	0	0		0	0	0	114234	0	113	40213227		
59561	4952	1127078	1973-02-17	1973-02-17 00:00:00	1973-03-03	1973-03-03 00:00:00	1973-03-03	38000177		0	0	14		0	0	0	329156	0	282464	1127078		
167658	3686	40213227	2019-03-18	2019-03-18 00:00:00	2019-03-18	2019-03-18 00:00:00	2019-03-18	581452		0	0	0		0	0	0	245080	0	113	40213227		
61886	5148	1713671	1966-01-19	1966-01-19 00:00:00	1966-04-28	1966-04-28 00:00:00	1966-04-28	38000177		0	0	99		0	0	0	342224	0	562251	1713671		
58585	4865	1115171	1995-02-10	1995-02-10 00:00:00	1995-02-24	1995-02-24 00:00:00	1995-02-24	38000177		0	0	14		0	0	0	323505	0	849574	1115171		
128910	2835	40213227	1994-05-10	1994-05-10 00:00:00	1994-05-10	1994-05-10 00:00:00	1994-05-10	581452		0	0	0		0	0	0	188205	0	113	40213227		
93695	2056	40213160	1976-05-19	1976-05-19 00:00:00	1976-05-19	1976-05-19 00:00:00	1976-05-19	581452		0	0	0		0	0	0	136754	0	10	40213160		
129144	2839	40213227	2014-11-17	2014-11-17 00:00:00	2014-11-17	2014-11-17 00:00:00	2014-11-17	581452		0	0	0		0	0	0	188547	0	113	40213227		
10033	842	964261	1991-11-07	1991-11-07 00:00:00	1991-11-07	1991-11-07 00:00:00	\N	38000177		0	0	0		0	0	0	55625	0	2001499	964261		
42908	936	40213160	1961-02-03	1961-02-03 00:00:00	1961-02-03	1961-02-03 00:00:00	1961-02-03	581452		0	0	0		0	0	0	62252	0	10	40213160		
4050	335	1713671	2006-11-03	2006-11-03 00:00:00	2006-11-17	2006-11-17 00:00:00	2006-11-17	38000177		0	0	14		0	0	0	22272	0	562251	1713671		
35035	2893	19059056	1954-06-04	1954-06-04 00:00:00	1954-06-18	1954-06-18 00:00:00	1954-06-18	38000177		0	0	14		0	0	0	192505	0	243670	19059056		
19596	426	40213227	2017-09-21	2017-09-21 00:00:00	2017-09-21	2017-09-21 00:00:00	2017-09-21	581452		0	0	0		0	0	0	28312	0	113	40213227		
600	43	19133873	1959-08-08	1959-08-08 00:00:00	1959-08-19	1959-08-19 00:00:00	1959-08-19	38000177		0	0	11		0	0	0	3183	0	834061	19133873		
35152	2899	40229134	2017-08-27	2017-08-27 00:00:00	2017-09-10	2017-09-10 00:00:00	2017-09-10	38000177		0	0	14		0	0	0	193183	0	1043400	40229134		
111891	2458	40213227	1993-05-02	1993-05-02 00:00:00	1993-05-02	1993-05-02 00:00:00	1993-05-02	581452		0	0	0		0	0	0	162993	0	113	40213227		
16513	1368	1127078	1956-10-25	1956-10-25 00:00:00	1956-11-08	1956-11-08 00:00:00	1956-11-08	38000177		0	0	14		0	0	0	90737	0	282464	1127078		
58126	4828	19133873	1982-04-19	1982-04-19 00:00:00	1982-04-28	1982-04-28 00:00:00	1982-04-28	38000177		0	0	9		0	0	0	321266	0	834061	19133873		
112021	2461	40213160	1967-02-07	1967-02-07 00:00:00	1967-02-07	1967-02-07 00:00:00	1967-02-07	581452		0	0	0		0	0	0	163186	0	10	40213160		
56279	4670	40229134	1993-07-03	1993-07-03 00:00:00	1993-07-10	1993-07-10 00:00:00	1993-07-10	38000177		0	0	7		0	0	0	311162	0	1043400	40229134		
31922	2646	1713671	1985-01-23	1985-01-23 00:00:00	1985-02-13	1985-02-13 00:00:00	1985-02-13	38000177		0	0	21		0	0	0	175063	0	562251	1713671		
155066	3413	40213160	1967-01-04	1967-01-04 00:00:00	1967-01-04	1967-01-04 00:00:00	1967-01-04	581452		0	0	0		0	0	0	226401	0	10	40213160		
36007	2965	19078461	1988-08-01	1988-08-01 00:00:00	1988-08-31	1988-08-31 00:00:00	1988-08-31	38000177		0	0	30		0	0	0	197986	0	310965	19078461		
30372	2518	1310034	1986-08-08	1986-08-08 00:00:00	1986-08-08	1986-08-08 00:00:00	1986-08-08	38000177		0	0	0		0	0	0	166542	0	834357	1310034		
7598	639	1127433	2009-03-11	2009-03-11 00:00:00	2009-03-18	2009-03-18 00:00:00	2009-03-18	38000177		0	0	7		0	0	0	42245	0	313782	1127433		
43026	3567	1713671	2016-09-15	2016-09-15 00:00:00	2016-10-06	2016-10-06 00:00:00	2016-10-06	38000177		0	0	21		0	0	0	236992	0	562251	1713671		
63027	5236	19078461	1986-07-10	1986-07-10 00:00:00	1986-10-08	1986-10-08 00:00:00	1986-10-08	38000177		0	0	90		0	0	0	348426	0	310965	19078461		
69749	1525	40213260	2014-08-07	2014-08-07 00:00:00	2014-08-07	2014-08-07 00:00:00	2014-08-07	581452		0	0	0		0	0	0	102036	0	121	40213260		
60804	5056	40229134	1967-04-25	1967-04-25 00:00:00	1967-05-02	1967-05-02 00:00:00	1967-05-02	38000177		0	0	7		0	0	0	336129	0	1043400	40229134		
12577	1058	19008572	1958-02-27	1958-02-27 00:00:00	1958-03-13	1958-03-13 00:00:00	1958-03-13	38000177		0	0	14		0	0	0	69443	0	106258	19008572		
28811	2381	1127433	1961-06-10	1961-06-10 00:00:00	1961-07-08	1961-07-08 00:00:00	1961-07-08	38000177		0	0	28		0	0	0	158305	0	313782	1127433		
15450	1289	19133873	1975-03-19	1975-03-19 00:00:00	1975-03-26	1975-03-26 00:00:00	1975-03-26	38000177		0	0	7		0	0	0	85187	0	834061	19133873		
22951	498	40213227	2012-04-05	2012-04-05 00:00:00	2012-04-05	2012-04-05 00:00:00	2012-04-05	581452		0	0	0		0	0	0	33289	0	113	40213227		
81328	1778	40213251	1985-04-27	1985-04-27 00:00:00	1985-04-27	1985-04-27 00:00:00	1985-04-27	581452		0	0	0		0	0	0	118978	0	21	40213251		
33720	2790	19059056	1973-07-02	1973-07-02 00:00:00	1973-08-01	1973-08-01 00:00:00	1973-08-01	38000177		0	0	30		0	0	0	184872	0	243670	19059056		
130344	2864	40213201	2006-01-19	2006-01-19 00:00:00	2006-01-19	2006-01-19 00:00:00	2006-01-19	581452		0	0	0		0	0	0	190482	0	33	40213201		
46238	3831	19059056	1971-08-20	1971-08-20 00:00:00	1971-11-18	1971-11-18 00:00:00	1971-11-18	38000177		0	0	90		0	0	0	254328	0	243670	19059056		
39200	3238	1118084	2006-12-09	2006-12-09 00:00:00	2006-12-09	2006-12-09 00:00:00	\N	38000177		0	0	0		0	0	0	215318	0	00025152531	44923712		
52697	4381	1127433	1987-10-23	1987-10-23 00:00:00	1987-11-06	1987-11-06 00:00:00	1987-11-06	38000177		0	0	14		0	0	0	291106	0	313782	1127433		
29679	2458	1713671	2008-05-09	2008-05-09 00:00:00	2008-05-23	2008-05-23 00:00:00	2008-05-23	38000177		0	0	14		0	0	0	162960	0	562251	1713671		
63268	5256	920300	1983-12-03	1983-12-03 00:00:00	1983-12-10	1983-12-10 00:00:00	1983-12-10	38000177		0	0	7		0	0	0	349773	0	311989	920300		
63283	5257	19128022	1997-02-13	1997-02-13 00:00:00	1998-02-08	1998-02-08 00:00:00	1998-02-08	38000177		0	0	360		0	0	0	349813	0	749785	19128022		
51989	4324	1127433	2010-11-01	2010-11-01 00:00:00	2010-11-08	2010-11-08 00:00:00	2010-11-08	38000177		0	0	7		0	0	0	286828	0	313782	1127433		
150345	3307	40213260	2015-10-23	2015-10-23 00:00:00	2015-10-23	2015-10-23 00:00:00	2015-10-23	581452		0	0	0		0	0	0	219595	0	121	40213260		
35760	2945	1127433	1973-11-18	1973-11-18 00:00:00	1973-12-02	1973-12-02 00:00:00	1973-12-02	38000177		0	0	14		0	0	0	196540	0	313782	1127433		
170883	3756	40213227	2012-06-16	2012-06-16 00:00:00	2012-06-16	2012-06-16 00:00:00	2012-06-16	581452		0	0	0		0	0	0	249678	0	113	40213227		
198224	4355	40213160	1981-12-26	1981-12-26 00:00:00	1981-12-26	1981-12-26 00:00:00	1981-12-26	581452		0	0	0		0	0	0	288961	0	10	40213160		
99325	2175	40213160	1981-01-08	1981-01-08 00:00:00	1981-01-08	1981-01-08 00:00:00	1981-01-08	581452		0	0	0		0	0	0	145055	0	10	40213160		
8165	680	1713671	1989-04-23	1989-04-23 00:00:00	1989-04-30	1989-04-30 00:00:00	1989-04-30	38000177		0	0	7		0	0	0	45004	0	562251	1713671		
61506	5118	1713671	1987-05-06	1987-05-06 00:00:00	1987-05-20	1987-05-20 00:00:00	1987-05-20	38000177		0	0	14		0	0	0	340219	0	562251	1713671		
174505	3836	40213296	2018-11-30	2018-11-30 00:00:00	2018-11-30	2018-11-30 00:00:00	2018-11-30	581452		0	0	0		0	0	0	254735	0	52	40213296		
232444	5107	40213227	1997-06-07	1997-06-07 00:00:00	1997-06-07	1997-06-07 00:00:00	1997-06-07	581452		0	0	0		0	0	0	339316	0	113	40213227		
71888	1571	40213260	2006-07-14	2006-07-14 00:00:00	2006-07-14	2006-07-14 00:00:00	2006-07-14	581452		0	0	0		0	0	0	105537	0	121	40213260		
31555	2617	1115171	2016-06-05	2016-06-05 00:00:00	2016-06-26	2016-06-26 00:00:00	2016-06-26	38000177		0	0	21		0	0	0	173099	0	849574	1115171		
2249	181	920300	1996-10-09	1996-10-09 00:00:00	1996-10-16	1996-10-16 00:00:00	1996-10-16	38000177		0	0	7		0	0	0	12234	0	311989	920300		
47017	3895	40220960	1999-02-12	1999-02-12 00:00:00	1999-02-12	1999-02-12 00:00:00	1999-02-12	38000177		0	0	0		0	0	0	259125	0	1804799	40220960		
29474	2439	19006318	1976-02-11	1976-02-11 00:00:00	1976-02-25	1976-02-25 00:00:00	1976-02-25	38000177		0	0	14		0	0	0	161815	0	105078	19006318		
42241	3505	19133905	2003-06-06	2003-06-06 00:00:00	2003-06-16	2003-06-16 00:00:00	2003-06-16	38000177		0	0	10		0	0	0	232413	0	834102	19133905		
85180	1864	40213160	1966-05-13	1966-05-13 00:00:00	1966-05-13	1966-05-13 00:00:00	1966-05-13	581452		0	0	0		0	0	0	124567	0	10	40213160		
156096	3435	40213160	1975-08-02	1975-08-02 00:00:00	1975-08-02	1975-08-02 00:00:00	1975-08-02	581452		0	0	0		0	0	0	227824	0	10	40213160		
23423	1928	1115171	2019-04-22	2019-04-22 00:00:00	2019-05-22	2019-05-22 00:00:00	2019-05-22	38000177		0	0	30		0	0	0	128380	0	849574	1115171		
124785	2745	40213227	2012-07-22	2012-07-22 00:00:00	2012-07-22	2012-07-22 00:00:00	2012-07-22	581452		0	0	0		0	0	0	181575	0	113	40213227		
29811	2469	1127433	2017-02-07	2017-02-07 00:00:00	2017-02-21	2017-02-21 00:00:00	2017-02-21	38000177		0	0	14		0	0	0	163735	0	313782	1127433		
156457	3443	40213227	2009-04-08	2009-04-08 00:00:00	2009-04-08	2009-04-08 00:00:00	2009-04-08	581452		0	0	0		0	0	0	228479	0	113	40213227		
46771	3875	1127433	1997-08-20	1997-08-20 00:00:00	1997-09-03	1997-09-03 00:00:00	1997-09-03	38000177		0	0	14		0	0	0	257333	0	313782	1127433		
59563	4952	19128065	1990-02-14	1990-02-14 00:00:00	1991-02-09	1991-02-09 00:00:00	1991-02-09	38000177		0	0	360		0	0	0	329158	0	749882	19128065		
167660	3686	40213227	2000-12-18	2000-12-18 00:00:00	2000-12-18	2000-12-18 00:00:00	2000-12-18	581452		0	0	0		0	0	0	245076	0	113	40213227		
61887	5148	19078461	1996-05-07	1996-05-07 00:00:00	1996-07-06	1996-07-06 00:00:00	1996-07-06	38000177		0	0	60		0	0	0	342223	0	310965	19078461		
58586	4865	1127078	1985-01-14	1985-01-14 00:00:00	1985-02-11	1985-02-11 00:00:00	1985-02-11	38000177		0	0	28		0	0	0	323502	0	282464	1127078		
230477	5065	40213306	1989-02-14	1989-02-14 00:00:00	1989-02-14	1989-02-14 00:00:00	1989-02-14	581452		0	0	0		0	0	0	336728	0	43	40213306		
93701	2056	40213160	1976-07-21	1976-07-21 00:00:00	1976-07-21	1976-07-21 00:00:00	1976-07-21	581452		0	0	0		0	0	0	136713	0	10	40213160		
55283	4590	1713671	1990-12-24	1990-12-24 00:00:00	1990-12-31	1990-12-31 00:00:00	1990-12-31	38000177		0	0	7		0	0	0	305823	0	562251	1713671		
10034	842	1713671	1987-02-02	1987-02-02 00:00:00	1987-02-16	1987-02-16 00:00:00	1987-02-16	38000177		0	0	14		0	0	0	55645	0	562251	1713671		
116261	2554	40213201	1999-12-02	1999-12-02 00:00:00	1999-12-02	1999-12-02 00:00:00	1999-12-02	581452		0	0	0		0	0	0	169105	0	33	40213201		
4051	335	1127078	1973-03-27	1973-03-27 00:00:00	1973-04-10	1973-04-10 00:00:00	1973-04-10	38000177		0	0	14		0	0	0	22293	0	282464	1127078		
35036	2893	19006318	1954-06-04	1954-06-04 00:00:00	1954-06-18	1954-06-18 00:00:00	1954-06-18	38000177		0	0	14		0	0	0	192505	0	105078	19006318		
19598	426	40213260	2017-09-21	2017-09-21 00:00:00	2017-09-21	2017-09-21 00:00:00	2017-09-21	581452		0	0	0		0	0	0	28312	0	121	40213260		
602	43	1127433	1999-07-10	1999-07-10 00:00:00	1999-08-14	1999-08-14 00:00:00	1999-08-14	38000177		0	0	35		0	0	0	3157	0	313782	1127433		
35153	2899	19059056	1967-08-21	1967-08-21 00:00:00	1967-09-25	1967-09-25 00:00:00	1967-09-25	38000177		0	0	35		0	0	0	193179	0	243670	19059056		
233743	5137	40213160	1968-02-28	1968-02-28 00:00:00	1968-02-28	1968-02-28 00:00:00	1968-02-28	581452		0	0	0		0	0	0	341375	0	10	40213160		
16514	1368	19006318	1956-10-25	1956-10-25 00:00:00	1956-11-08	1956-11-08 00:00:00	1956-11-08	38000177		0	0	14		0	0	0	90737	0	105078	19006318		
58127	4828	19019979	1974-11-28	1974-11-28 00:00:00	1974-12-19	1974-12-19 00:00:00	1974-12-19	38000177		0	0	21		0	0	0	321251	0	198405	19019979		
112024	2461	40213296	2008-11-11	2008-11-11 00:00:00	2008-11-11	2008-11-11 00:00:00	2008-11-11	581452		0	0	0		0	0	0	163195	0	52	40213296		
56281	4670	19078461	1993-04-03	1993-04-03 00:00:00	1993-05-01	1993-05-01 00:00:00	1993-05-01	38000177		0	0	28		0	0	0	311157	0	310965	19078461		
31923	2646	19006318	1977-12-23	1977-12-23 00:00:00	1978-01-06	1978-01-06 00:00:00	1978-01-06	38000177		0	0	14		0	0	0	175093	0	105078	19006318		
155069	3413	40213296	2006-05-03	2006-05-03 00:00:00	2006-05-03	2006-05-03 00:00:00	2006-05-03	581452		0	0	0		0	0	0	226407	0	52	40213296		
36008	2965	1127433	2000-08-15	2000-08-15 00:00:00	2000-08-29	2000-08-29 00:00:00	2000-08-29	38000177		0	0	14		0	0	0	197899	0	313782	1127433		
30373	2518	1127433	2000-01-22	2000-01-22 00:00:00	2000-02-05	2000-02-05 00:00:00	2000-02-05	38000177		0	0	14		0	0	0	166519	0	313782	1127433		
7599	639	19006318	1955-07-07	1955-07-07 00:00:00	1955-07-21	1955-07-21 00:00:00	1955-07-21	38000177		0	0	14		0	0	0	42313	0	105078	19006318		
40915	3392	19128065	1985-12-01	1985-12-01 00:00:00	1986-11-26	1986-11-26 00:00:00	1986-11-26	38000177		0	0	360		0	0	0	224954	0	749882	19128065		
17307	374	40213314	1980-04-17	1980-04-17 00:00:00	1980-04-17	1980-04-17 00:00:00	1980-04-17	581452		0	0	0		0	0	0	24823	0	49	40213314		
69750	1525	40213227	2014-08-07	2014-08-07 00:00:00	2014-08-07	2014-08-07 00:00:00	2014-08-07	581452		0	0	0		0	0	0	102036	0	113	40213227		
60805	5056	40222846	2013-12-16	2013-12-16 00:00:00	2013-12-16	2013-12-16 00:00:00	\N	38000177		0	0	0		0	0	0	336145	0	996740	40222846		
12578	1058	19133873	1959-08-07	1959-08-07 00:00:00	1959-08-17	1959-08-17 00:00:00	1959-08-17	38000177		0	0	10		0	0	0	69480	0	834061	19133873		
28812	2381	19133873	1945-05-06	1945-05-06 00:00:00	1945-05-16	1945-05-16 00:00:00	1945-05-16	38000177		0	0	10		0	0	0	158345	0	834061	19133873		
15451	1289	1127433	2015-09-30	2015-09-30 00:00:00	2015-10-28	2015-10-28 00:00:00	2015-10-28	38000177		0	0	28		0	0	0	85245	0	313782	1127433		
22952	498	40213296	2012-04-05	2012-04-05 00:00:00	2012-04-05	2012-04-05 00:00:00	2012-04-05	581452		0	0	0		0	0	0	33289	0	52	40213296		
81330	1778	40213160	1985-04-27	1985-04-27 00:00:00	1985-04-27	1985-04-27 00:00:00	1985-04-27	581452		0	0	0		0	0	0	118978	0	10	40213160		
33721	2790	19133905	1982-11-18	1982-11-18 00:00:00	1982-11-27	1982-11-27 00:00:00	1982-11-27	38000177		0	0	9		0	0	0	184891	0	834102	19133905		
143175	3145	40213296	2010-09-05	2010-09-05 00:00:00	2010-09-05	2010-09-05 00:00:00	2010-09-05	581452		0	0	0		0	0	0	209260	0	52	40213296		
46239	3831	40229134	2013-03-18	2013-03-18 00:00:00	2013-03-25	2013-03-25 00:00:00	2013-03-25	38000177		0	0	7		0	0	0	254358	0	1043400	40229134		
39201	3238	1127433	1997-05-20	1997-05-20 00:00:00	1997-07-26	1997-07-26 00:00:00	1997-07-26	38000177		0	0	67		0	0	0	215317	0	313782	1127433		
52698	4381	19059056	1967-11-05	1967-11-05 00:00:00	1967-11-19	1967-11-19 00:00:00	1967-11-19	38000177		0	0	14		0	0	0	291096	0	243670	19059056		
29680	2458	1127433	2016-12-19	2016-12-19 00:00:00	2017-01-02	2017-01-02 00:00:00	2017-01-02	38000177		0	0	14		0	0	0	162949	0	313782	1127433		
32974	720	40213160	1965-02-06	1965-02-06 00:00:00	1965-02-06	1965-02-06 00:00:00	1965-02-06	581452		0	0	0		0	0	0	47621	0	10	40213160		
63284	5257	43012754	1998-02-08	1998-02-08 00:00:00	1999-02-03	1999-02-03 00:00:00	1999-02-03	38000177		0	0	360		0	0	0	349837	0	1366343	43012754		
51990	4324	19059056	1963-08-30	1963-08-30 00:00:00	1963-09-13	1963-09-13 00:00:00	1963-09-13	38000177		0	0	14		0	0	0	286852	0	243670	19059056		
150350	3307	40213160	1966-01-27	1966-01-27 00:00:00	1966-01-27	1966-01-27 00:00:00	1966-01-27	581452		0	0	0		0	0	0	219601	0	10	40213160		
35761	2945	1127078	1950-08-20	1950-08-20 00:00:00	1950-09-03	1950-09-03 00:00:00	1950-09-03	38000177		0	0	14		0	0	0	196516	0	282464	1127078		
170909	3757	40213227	1996-02-28	1996-02-28 00:00:00	1996-02-28	1996-02-28 00:00:00	1996-02-28	581452		0	0	0		0	0	0	249793	0	113	40213227		
198226	4355	40213314	1981-09-26	1981-09-26 00:00:00	1981-09-26	1981-09-26 00:00:00	1981-09-26	581452		0	0	0		0	0	0	288948	0	49	40213314		
99328	2175	40213306	1996-09-26	1996-09-26 00:00:00	1996-09-26	1996-09-26 00:00:00	1996-09-26	581452		0	0	0		0	0	0	145029	0	43	40213306		
8166	680	40229134	2001-03-01	2001-03-01 00:00:00	2001-03-15	2001-03-15 00:00:00	2001-03-15	38000177		0	0	14		0	0	0	45044	0	1043400	40229134		
61507	5118	40229134	2013-08-18	2013-08-18 00:00:00	2013-09-01	2013-09-01 00:00:00	2013-09-01	38000177		0	0	14		0	0	0	340237	0	1043400	40229134		
138479	3041	40213160	1977-11-10	1977-11-10 00:00:00	1977-11-10	1977-11-10 00:00:00	1977-11-10	581452		0	0	0		0	0	0	202479	0	10	40213160		
232445	5107	40213306	1997-06-07	1997-06-07 00:00:00	1997-06-07	1997-06-07 00:00:00	1997-06-07	581452		0	0	0		0	0	0	339316	0	43	40213306		
29184	636	40213198	2013-07-26	2013-07-26 00:00:00	2013-07-26	2013-07-26 00:00:00	2013-07-26	581452		0	0	0		0	0	0	42137	0	133	40213198		
31556	2617	19075601	2014-09-06	2014-09-06 00:00:00	2014-09-06	2014-09-06 00:00:00	\N	38000177		0	0	0		0	0	0	173057	0	309362	19075601		
2250	181	19128065	1988-09-07	1988-09-07 00:00:00	1989-09-02	1989-09-02 00:00:00	1989-09-02	38000177		0	0	360		0	0	0	12239	0	749882	19128065		
47018	3895	19075601	1999-02-12	1999-02-12 00:00:00	1999-02-12	1999-02-12 00:00:00	1999-02-12	38000177		0	0	0		0	0	0	259125	0	309362	19075601		
29475	2439	19019979	1976-02-11	1976-02-11 00:00:00	1976-02-25	1976-02-25 00:00:00	1976-02-25	38000177		0	0	14		0	0	0	161815	0	198405	19019979		
42242	3505	19059056	1942-12-06	1942-12-06 00:00:00	1942-12-20	1942-12-20 00:00:00	1942-12-20	38000177		0	0	14		0	0	0	232416	0	243670	19059056		
85183	1864	40213306	1987-12-11	1987-12-11 00:00:00	1987-12-11	1987-12-11 00:00:00	1987-12-11	581452		0	0	0		0	0	0	124550	0	43	40213306		
156099	3435	40213227	1997-10-04	1997-10-04 00:00:00	1997-10-04	1997-10-04 00:00:00	1997-10-04	581452		0	0	0		0	0	0	227823	0	113	40213227		
23424	1928	1127433	2004-09-24	2004-09-24 00:00:00	2004-10-08	2004-10-08 00:00:00	2004-10-08	38000177		0	0	14		0	0	0	128371	0	313782	1127433		
124786	2745	40213296	2012-07-22	2012-07-22 00:00:00	2012-07-22	2012-07-22 00:00:00	2012-07-22	581452		0	0	0		0	0	0	181575	0	52	40213296		
29812	2469	19059056	1981-09-07	1981-09-07 00:00:00	1981-10-12	1981-10-12 00:00:00	1981-10-12	38000177		0	0	35		0	0	0	163711	0	243670	19059056		
156459	3443	40213314	1977-06-15	1977-06-15 00:00:00	1977-06-15	1977-06-15 00:00:00	1977-06-15	581452		0	0	0		0	0	0	228515	0	49	40213314		
46773	3875	1127433	2017-07-03	2017-07-03 00:00:00	2017-07-10	2017-07-10 00:00:00	2017-07-10	38000177		0	0	7		0	0	0	257329	0	313782	1127433		
59564	4952	1118084	2008-11-01	2008-11-01 00:00:00	2008-11-01	2008-11-01 00:00:00	\N	38000177		0	0	0		0	0	0	329180	0	00025152531	44923712		
121338	2666	40213227	1992-08-16	1992-08-16 00:00:00	1992-08-16	1992-08-16 00:00:00	1992-08-16	581452		0	0	0		0	0	0	176615	0	113	40213227		
61890	5148	19059056	1970-08-22	1970-08-22 00:00:00	1970-11-19	1970-11-19 00:00:00	1970-11-19	38000177		0	0	89		0	0	0	342221	0	243670	19059056		
58587	4865	1713671	1981-08-09	1981-08-09 00:00:00	1981-08-30	1981-08-30 00:00:00	1981-08-30	38000177		0	0	21		0	0	0	323542	0	562251	1713671		
230481	5065	40213227	1992-02-18	1992-02-18 00:00:00	1992-02-18	1992-02-18 00:00:00	1992-02-18	581452		0	0	0		0	0	0	336752	0	113	40213227		
93704	2056	40213251	1984-02-08	1984-02-08 00:00:00	1984-02-08	1984-02-08 00:00:00	1984-02-08	581452		0	0	0		0	0	0	136758	0	21	40213251		
55284	4590	1713671	1989-04-12	1989-04-12 00:00:00	1989-04-26	1989-04-26 00:00:00	1989-04-26	38000177		0	0	14		0	0	0	305887	0	562251	1713671		
10035	842	1539411	2017-11-04	2017-11-04 00:00:00	2017-11-04	2017-11-04 00:00:00	\N	38000177		0	0	0		0	0	0	55686	0	312961	1539411		
116283	2555	40213227	2002-03-06	2002-03-06 00:00:00	2002-03-06	2002-03-06 00:00:00	2002-03-06	581452		0	0	0		0	0	0	169298	0	113	40213227		
4052	335	1127433	1974-07-22	1974-07-22 00:00:00	1974-08-05	1974-08-05 00:00:00	1974-08-05	38000177		0	0	14		0	0	0	22271	0	313782	1127433		
35037	2893	1127433	2009-02-02	2009-02-02 00:00:00	2009-02-16	2009-02-16 00:00:00	2009-02-16	38000177		0	0	14		0	0	0	192515	0	313782	1127433		
19603	426	40213227	1997-05-08	1997-05-08 00:00:00	1997-05-08	1997-05-08 00:00:00	1997-05-08	581452		0	0	0		0	0	0	28310	0	113	40213227		
603	43	920300	1992-01-07	1992-01-07 00:00:00	1992-01-14	1992-01-14 00:00:00	1992-01-14	38000177		0	0	7		0	0	0	3145	0	311989	920300		
35154	2899	40173590	2009-10-22	2009-10-22 00:00:00	2009-10-22	2009-10-22 00:00:00	\N	38000177		0	0	0		0	0	0	193167	0	904419	40173590		
65966	1443	40213160	1977-09-03	1977-09-03 00:00:00	1977-09-03	1977-09-03 00:00:00	1977-09-03	581452		0	0	0		0	0	0	96198	0	10	40213160		
16515	1368	1713671	2007-01-01	2007-01-01 00:00:00	2007-01-08	2007-01-08 00:00:00	2007-01-08	38000177		0	0	7		0	0	0	90720	0	562251	1713671		
58128	4828	40229134	2009-07-14	2009-07-14 00:00:00	2009-07-21	2009-07-21 00:00:00	2009-07-21	38000177		0	0	7		0	0	0	321288	0	1043400	40229134		
112026	2461	40213227	2008-11-11	2008-11-11 00:00:00	2008-11-11	2008-11-11 00:00:00	2008-11-11	581452		0	0	0		0	0	0	163195	0	113	40213227		
56282	4670	1118084	1989-07-15	1989-07-15 00:00:00	1989-07-15	1989-07-15 00:00:00	\N	38000177		0	0	0		0	0	0	311189	0	00025152531	44923712		
31924	2646	19059056	1977-12-23	1977-12-23 00:00:00	1978-01-06	1978-01-06 00:00:00	1978-01-06	38000177		0	0	14		0	0	0	175093	0	243670	19059056		
155081	3413	40213306	1988-09-21	1988-09-21 00:00:00	1988-09-21	1988-09-21 00:00:00	1988-09-21	581452		0	0	0		0	0	0	226355	0	43	40213306		
57534	4776	1118084	2001-01-17	2001-01-17 00:00:00	2001-01-17	2001-01-17 00:00:00	\N	38000177		0	0	0		0	0	0	318020	0	00025152531	44923712		
30374	2518	1127433	1993-08-09	1993-08-09 00:00:00	1993-08-16	1993-08-16 00:00:00	1993-08-16	38000177		0	0	7		0	0	0	166530	0	313782	1127433		
7600	639	19059056	1955-07-07	1955-07-07 00:00:00	1955-07-21	1955-07-21 00:00:00	1955-07-21	38000177		0	0	14		0	0	0	42313	0	243670	19059056		
40926	3394	1127433	2003-12-01	2003-12-01 00:00:00	2003-12-08	2003-12-08 00:00:00	2003-12-08	38000177		0	0	7		0	0	0	225165	0	313782	1127433		
17308	374	40213160	1980-04-17	1980-04-17 00:00:00	1980-04-17	1980-04-17 00:00:00	1980-04-17	581452		0	0	0		0	0	0	24823	0	10	40213160		
69753	1525	40213227	1994-09-08	1994-09-08 00:00:00	1994-09-08	1994-09-08 00:00:00	1994-09-08	581452		0	0	0		0	0	0	101982	0	113	40213227		
60806	5056	1127433	1950-09-03	1950-09-03 00:00:00	1950-10-03	1950-10-03 00:00:00	1950-10-03	38000177		0	0	30		0	0	0	336162	0	313782	1127433		
12579	1058	1127433	2003-11-16	2003-11-16 00:00:00	2003-11-30	2003-11-30 00:00:00	2003-11-30	38000177		0	0	14		0	0	0	69343	0	313782	1127433		
28813	2381	40229134	1997-11-25	1997-11-25 00:00:00	1997-12-09	1997-12-09 00:00:00	1997-12-09	38000177		0	0	14		0	0	0	158351	0	1043400	40229134		
15452	1289	1115171	2011-10-30	2011-10-30 00:00:00	2011-11-20	2011-11-20 00:00:00	2011-11-20	38000177		0	0	21		0	0	0	85244	0	849574	1115171		
22956	498	40213160	1970-12-03	1970-12-03 00:00:00	1970-12-03	1970-12-03 00:00:00	1970-12-03	581452		0	0	0		0	0	0	33280	0	10	40213160		
81333	1778	40213160	1980-08-23	1980-08-23 00:00:00	1980-08-23	1980-08-23 00:00:00	1980-08-23	581452		0	0	0		0	0	0	118959	0	10	40213160		
33722	2790	19128065	1974-06-09	1974-06-09 00:00:00	1975-06-04	1975-06-04 00:00:00	1975-06-04	38000177		0	0	360		0	0	0	184901	0	749882	19128065		
46107	3820	19128065	1988-09-25	1988-09-25 00:00:00	1989-09-20	1989-09-20 00:00:00	1989-09-20	38000177		0	0	360		0	0	0	253622	0	749882	19128065		
46240	3831	1127433	2001-12-07	2001-12-07 00:00:00	2001-12-14	2001-12-14 00:00:00	2001-12-14	38000177		0	0	7		0	0	0	254331	0	313782	1127433		
39202	3240	19075601	2008-10-08	2008-10-08 00:00:00	2008-10-08	2008-10-08 00:00:00	2008-10-08	38000177		0	0	0		0	0	0	215384	0	309362	19075601		
52699	4381	19059056	1967-01-01	1967-01-01 00:00:00	1967-01-15	1967-01-15 00:00:00	1967-01-15	38000177		0	0	14		0	0	0	291095	0	243670	19059056		
29681	2458	19133873	1975-09-25	1975-09-25 00:00:00	1975-10-08	1975-10-08 00:00:00	1975-10-08	38000177		0	0	13		0	0	0	162965	0	834061	19133873		
32981	720	40213160	1969-08-09	1969-08-09 00:00:00	1969-08-09	1969-08-09 00:00:00	1969-08-09	581452		0	0	0		0	0	0	47624	0	10	40213160		
63285	5257	19128065	2000-01-29	2000-01-29 00:00:00	2001-01-23	2001-01-23 00:00:00	2001-01-23	38000177		0	0	360		0	0	0	349839	0	749882	19128065		
51991	4324	19129655	1963-08-30	1963-08-30 00:00:00	1963-09-13	1963-09-13 00:00:00	1963-09-13	38000177		0	0	14		0	0	0	286852	0	789980	19129655		
150351	3307	40213160	1966-03-31	1966-03-31 00:00:00	1966-03-31	1966-03-31 00:00:00	1966-03-31	581452		0	0	0		0	0	0	219584	0	10	40213160		
35762	2945	40169281	1970-09-22	1970-09-22 00:00:00	1970-09-22	1970-09-22 00:00:00	\N	38000177		0	0	0		0	0	0	196506	0	896209	40169281		
170922	3757	40213201	2011-09-07	2011-09-07 00:00:00	2011-09-07	2011-09-07 00:00:00	2011-09-07	581452		0	0	0		0	0	0	249723	0	33	40213201		
81791	1786	40213227	2004-05-22	2004-05-22 00:00:00	2004-05-22	2004-05-22 00:00:00	2004-05-22	581452		0	0	0		0	0	0	119713	0	113	40213227		
99331	2175	40213227	2009-02-05	2009-02-05 00:00:00	2009-02-05	2009-02-05 00:00:00	2009-02-05	581452		0	0	0		0	0	0	144994	0	113	40213227		
8167	680	1127433	1987-08-09	1987-08-09 00:00:00	1987-08-23	1987-08-23 00:00:00	1987-08-23	38000177		0	0	14		0	0	0	45093	0	313782	1127433		
61508	5118	46233988	1969-09-06	1969-09-06 00:00:00	1969-09-20	1969-09-20 00:00:00	1969-09-20	38000177		0	0	14		0	0	0	340282	0	1652673	46233988		
138483	3041	40213227	1999-12-30	1999-12-30 00:00:00	1999-12-30	1999-12-30 00:00:00	1999-12-30	581452		0	0	0		0	0	0	202517	0	113	40213227		
232447	5107	40213160	1980-05-17	1980-05-17 00:00:00	1980-05-17	1980-05-17 00:00:00	1980-05-17	581452		0	0	0		0	0	0	339359	0	10	40213160		
82116	1793	40213227	1992-06-17	1992-06-17 00:00:00	1992-06-17	1992-06-17 00:00:00	1992-06-17	581452		0	0	0		0	0	0	120264	0	113	40213227		
31557	2617	19126352	2014-09-06	2014-09-06 00:00:00	2014-09-06	2014-09-06 00:00:00	\N	38000177		0	0	0		0	0	0	173057	0	705129	19126352		
2251	182	1713671	2018-06-16	2018-06-16 00:00:00	2018-06-23	2018-06-23 00:00:00	2018-06-23	38000177		0	0	7		0	0	0	12326	0	562251	1713671		
47019	3895	40229134	2008-07-08	2008-07-08 00:00:00	2008-07-15	2008-07-15 00:00:00	2008-07-15	38000177		0	0	7		0	0	0	259076	0	1043400	40229134		
29476	2439	1127433	2008-05-18	2008-05-18 00:00:00	2008-06-01	2008-06-01 00:00:00	2008-06-01	38000177		0	0	14		0	0	0	161785	0	313782	1127433		
211842	4644	40213260	2013-08-29	2013-08-29 00:00:00	2013-08-29	2013-08-29 00:00:00	2013-08-29	581452		0	0	0		0	0	0	309664	0	121	40213260		
85185	1864	40213160	1970-10-09	1970-10-09 00:00:00	1970-10-09	1970-10-09 00:00:00	1970-10-09	581452		0	0	0		0	0	0	124571	0	10	40213160		
156100	3435	40213306	1997-10-04	1997-10-04 00:00:00	1997-10-04	1997-10-04 00:00:00	1997-10-04	581452		0	0	0		0	0	0	227823	0	43	40213306		
23425	1928	1124300	2010-07-15	2010-07-15 00:00:00	2010-07-15	2010-07-15 00:00:00	\N	38000177		0	0	0		0	0	0	128386	0	00781178901	45011828		
124787	2745	40213296	2014-07-27	2014-07-27 00:00:00	2014-07-27	2014-07-27 00:00:00	2014-07-27	581452		0	0	0		0	0	0	181596	0	52	40213296		
29813	2469	1713671	1978-02-16	1978-02-16 00:00:00	1978-03-09	1978-03-09 00:00:00	1978-03-09	38000177		0	0	21		0	0	0	163714	0	562251	1713671		
156460	3443	40213160	1977-06-15	1977-06-15 00:00:00	1977-06-15	1977-06-15 00:00:00	1977-06-15	581452		0	0	0		0	0	0	228515	0	10	40213160		
46774	3875	1127433	1963-06-26	1963-06-26 00:00:00	1963-07-10	1963-07-10 00:00:00	1963-07-10	38000177		0	0	14		0	0	0	257393	0	313782	1127433		
59565	4952	1713671	1984-02-14	1984-02-14 00:00:00	1984-02-21	1984-02-21 00:00:00	1984-02-21	38000177		0	0	7		0	0	0	329154	0	562251	1713671		
121347	2666	40213160	1955-07-31	1955-07-31 00:00:00	1955-07-31	1955-07-31 00:00:00	1955-07-31	581452		0	0	0		0	0	0	176672	0	10	40213160		
61892	5148	19129655	1962-10-03	1962-10-03 00:00:00	1962-10-17	1962-10-17 00:00:00	1962-10-17	38000177		0	0	14		0	0	0	342248	0	789980	19129655		
58588	4865	19133873	1991-10-26	1991-10-26 00:00:00	1991-11-02	1991-11-02 00:00:00	1991-11-02	38000177		0	0	7		0	0	0	323545	0	834061	19133873		
230482	5065	40213306	1992-02-18	1992-02-18 00:00:00	1992-02-18	1992-02-18 00:00:00	1992-02-18	581452		0	0	0		0	0	0	336752	0	43	40213306		
214515	4704	40213160	1966-05-28	1966-05-28 00:00:00	1966-05-28	1966-05-28 00:00:00	1966-05-28	581452		0	0	0		0	0	0	313380	0	10	40213160		
55285	4590	1127078	1962-06-10	1962-06-10 00:00:00	1962-07-01	1962-07-01 00:00:00	1962-07-01	38000177		0	0	21		0	0	0	305862	0	282464	1127078		
10036	842	19075601	2017-11-04	2017-11-04 00:00:00	2017-11-04	2017-11-04 00:00:00	\N	38000177		0	0	0		0	0	0	55686	0	309362	19075601		
116286	2555	40213198	2015-09-03	2015-09-03 00:00:00	2015-09-03	2015-09-03 00:00:00	2015-09-03	581452		0	0	0		0	0	0	169316	0	133	40213198		
4053	335	1127433	1990-07-01	1990-07-01 00:00:00	1990-07-22	1990-07-22 00:00:00	1990-07-22	38000177		0	0	21		0	0	0	22295	0	313782	1127433		
35038	2893	19059056	1952-06-14	1952-06-14 00:00:00	1952-07-05	1952-07-05 00:00:00	1952-07-05	38000177		0	0	21		0	0	0	192517	0	243670	19059056		
19604	426	40213260	2016-12-15	2016-12-15 00:00:00	2016-12-15	2016-12-15 00:00:00	2016-12-15	581452		0	0	0		0	0	0	28274	0	121	40213260		
604	43	40236824	1992-01-07	1992-01-07 00:00:00	1992-01-14	1992-01-14 00:00:00	1992-01-14	38000177		0	0	7		0	0	0	3145	0	1094107	40236824		
35155	2899	19078461	1979-01-25	1979-01-25 00:00:00	1979-02-24	1979-02-24 00:00:00	1979-02-24	38000177		0	0	30		0	0	0	193180	0	310965	19078461		
65967	1443	40213314	1977-07-02	1977-07-02 00:00:00	1977-07-02	1977-07-02 00:00:00	1977-07-02	581452		0	0	0		0	0	0	96205	0	49	40213314		
16516	1368	1127078	1958-04-10	1958-04-10 00:00:00	1958-04-24	1958-04-24 00:00:00	1958-04-24	38000177		0	0	14		0	0	0	90715	0	282464	1127078		
58129	4829	40229134	1999-12-03	1999-12-03 00:00:00	1999-12-17	1999-12-17 00:00:00	1999-12-17	38000177		0	0	14		0	0	0	321356	0	1043400	40229134		
112029	2461	40213160	1967-04-11	1967-04-11 00:00:00	1967-04-11	1967-04-11 00:00:00	1967-04-11	581452		0	0	0		0	0	0	163159	0	10	40213160		
56283	4670	40236824	1990-05-08	1990-05-08 00:00:00	1990-05-22	1990-05-22 00:00:00	1990-05-22	38000177		0	0	14		0	0	0	311194	0	1094107	40236824		
31925	2646	40229134	2002-02-21	2002-02-21 00:00:00	2002-02-28	2002-02-28 00:00:00	2002-02-28	38000177		0	0	7		0	0	0	175092	0	1043400	40229134		
30470	664	40213314	1981-10-15	1981-10-15 00:00:00	1981-10-15	1981-10-15 00:00:00	1981-10-15	581452		0	0	0		0	0	0	43870	0	49	40213314		
57535	4776	1127433	2008-04-23	2008-04-23 00:00:00	2008-05-07	2008-05-07 00:00:00	2008-05-07	38000177		0	0	14		0	0	0	318043	0	313782	1127433		
30375	2518	19073188	1997-10-09	1997-10-09 00:00:00	1997-11-13	1997-11-13 00:00:00	1997-11-13	38000177		0	0	35		0	0	0	166544	0	308192	19073188		
7601	639	40165015	2007-04-27	2007-04-27 00:00:00	2007-04-27	2007-04-27 00:00:00	\N	38000177		0	0	0		0	0	0	42242	0	861467	40165015		
40927	3394	1713671	2001-07-21	2001-07-21 00:00:00	2001-08-04	2001-08-04 00:00:00	2001-08-04	38000177		0	0	14		0	0	0	225143	0	562251	1713671		
17313	374	40213314	1981-01-15	1981-01-15 00:00:00	1981-01-15	1981-01-15 00:00:00	1981-01-15	581452		0	0	0		0	0	0	24824	0	49	40213314		
69755	1525	40213160	1963-11-07	1963-11-07 00:00:00	1963-11-07	1963-11-07 00:00:00	1963-11-07	581452		0	0	0		0	0	0	101993	0	10	40213160		
60807	5056	40162522	1950-09-03	1950-09-03 00:00:00	1950-09-03	1950-09-03 00:00:00	\N	38000177		0	0	0		0	0	0	336162	0	857005	40162522		
12580	1058	1127433	2004-05-30	2004-05-30 00:00:00	2004-07-06	2004-07-06 00:00:00	2004-07-06	38000177		0	0	37		0	0	0	69406	0	313782	1127433		
28814	2381	40243436	2013-01-30	2013-01-30 00:00:00	2013-01-30	2013-01-30 00:00:00	2013-01-30	38000177		0	0	0		0	0	0	158245	0	1190795	40243436		
15453	1289	19059056	1963-02-06	1963-02-06 00:00:00	1963-02-27	1963-02-27 00:00:00	1963-02-27	38000177		0	0	21		0	0	0	85168	0	243670	19059056		
22963	498	40213160	1970-07-02	1970-07-02 00:00:00	1970-07-02	1970-07-02 00:00:00	1970-07-02	581452		0	0	0		0	0	0	33279	0	10	40213160		
81334	1778	40213314	1980-08-23	1980-08-23 00:00:00	1980-08-23	1980-08-23 00:00:00	1980-08-23	581452		0	0	0		0	0	0	118959	0	49	40213314		
33724	2790	19078461	1999-09-19	1999-09-19 00:00:00	1999-10-03	1999-10-03 00:00:00	1999-10-03	38000177		0	0	14		0	0	0	184874	0	310965	19078461		
46108	3820	1127433	1979-09-05	1979-09-05 00:00:00	1979-09-19	1979-09-19 00:00:00	1979-09-19	38000177		0	0	14		0	0	0	253614	0	313782	1127433		
46241	3831	1713671	1987-10-25	1987-10-25 00:00:00	1987-11-08	1987-11-08 00:00:00	1987-11-08	38000177		0	0	14		0	0	0	254374	0	562251	1713671		
39203	3240	40220960	2008-10-08	2008-10-08 00:00:00	2008-10-08	2008-10-08 00:00:00	2008-10-08	38000177		0	0	0		0	0	0	215384	0	1804799	40220960		
52700	4381	46233988	1967-01-01	1967-01-01 00:00:00	1967-01-15	1967-01-15 00:00:00	1967-01-15	38000177		0	0	14		0	0	0	291095	0	1652673	46233988		
29682	2458	40229134	1982-05-23	1982-05-23 00:00:00	1982-05-30	1982-05-30 00:00:00	1982-05-30	38000177		0	0	7		0	0	0	162958	0	1043400	40229134		
145472	3199	40213314	1977-01-05	1977-01-05 00:00:00	1977-01-05	1977-01-05 00:00:00	1977-01-05	581452		0	0	0		0	0	0	212783	0	49	40213314		
63286	5257	1713671	1987-02-02	1987-02-02 00:00:00	1987-02-16	1987-02-16 00:00:00	1987-02-16	38000177		0	0	14		0	0	0	349828	0	562251	1713671		
51992	4324	1127433	1980-07-31	1980-07-31 00:00:00	1980-08-21	1980-08-21 00:00:00	1980-08-21	38000177		0	0	21		0	0	0	286823	0	313782	1127433		
150352	3307	40213227	1997-10-30	1997-10-30 00:00:00	1997-10-30	1997-10-30 00:00:00	1997-10-30	581452		0	0	0		0	0	0	219573	0	113	40213227		
35763	2945	1713671	1988-10-02	1988-10-02 00:00:00	1988-10-23	1988-10-23 00:00:00	1988-10-23	38000177		0	0	21		0	0	0	196545	0	562251	1713671		
40277	877	40213227	2019-05-14	2019-05-14 00:00:00	2019-05-14	2019-05-14 00:00:00	2019-05-14	581452		0	0	0		0	0	0	58393	0	113	40213227		
93088	2043	40213227	1998-04-26	1998-04-26 00:00:00	1998-04-26	1998-04-26 00:00:00	1998-04-26	581452		0	0	0		0	0	0	135891	0	113	40213227		
99335	2175	40213314	1977-07-07	1977-07-07 00:00:00	1977-07-07	1977-07-07 00:00:00	1977-07-07	581452		0	0	0		0	0	0	144989	0	49	40213314		
8168	680	19078461	2008-09-01	2008-09-01 00:00:00	2008-10-06	2008-10-06 00:00:00	2008-10-06	38000177		0	0	35		0	0	0	45094	0	310965	19078461		
61509	5118	1127078	1969-09-06	1969-09-06 00:00:00	1969-09-20	1969-09-20 00:00:00	1969-09-20	38000177		0	0	14		0	0	0	340282	0	282464	1127078		
138484	3041	40213306	1999-12-30	1999-12-30 00:00:00	1999-12-30	1999-12-30 00:00:00	1999-12-30	581452		0	0	0		0	0	0	202517	0	43	40213306		
232452	5108	40213260	2011-12-25	2011-12-25 00:00:00	2011-12-25	2011-12-25 00:00:00	2011-12-25	581452		0	0	0		0	0	0	339416	0	121	40213260		
82129	1794	40213227	2001-02-17	2001-02-17 00:00:00	2001-02-17	2001-02-17 00:00:00	2001-02-17	581452		0	0	0		0	0	0	120295	0	113	40213227		
31558	2617	1332419	2014-09-06	2014-09-06 00:00:00	2014-09-06	2014-09-06 00:00:00	\N	38000177		0	0	0		0	0	0	173057	0	197361	1332419		
2252	182	1127433	1987-05-29	1987-05-29 00:00:00	1987-06-26	1987-06-26 00:00:00	1987-06-26	38000177		0	0	28		0	0	0	12325	0	313782	1127433		
47020	3895	19133905	1946-02-19	1946-02-19 00:00:00	1946-03-02	1946-03-02 00:00:00	1946-03-02	38000177		0	0	11		0	0	0	259085	0	834102	19133905		
29477	2439	40229134	1978-03-19	1978-03-19 00:00:00	1978-03-26	1978-03-26 00:00:00	1978-03-26	38000177		0	0	7		0	0	0	161799	0	1043400	40229134		
211844	4644	40213306	1984-11-15	1984-11-15 00:00:00	1984-11-15	1984-11-15 00:00:00	1984-11-15	581452		0	0	0		0	0	0	309642	0	43	40213306		
85189	1864	40213160	1966-03-11	1966-03-11 00:00:00	1966-03-11	1966-03-11 00:00:00	1966-03-11	581452		0	0	0		0	0	0	124516	0	10	40213160		
109734	2411	40213227	2015-11-26	2015-11-26 00:00:00	2015-11-26	2015-11-26 00:00:00	2015-11-26	581452		0	0	0		0	0	0	159998	0	113	40213227		
23426	1928	19078461	1983-11-29	1983-11-29 00:00:00	1984-02-27	1984-02-27 00:00:00	1984-02-27	38000177		0	0	90		0	0	0	128377	0	310965	19078461		
103225	2264	40213296	2009-12-13	2009-12-13 00:00:00	2009-12-13	2009-12-13 00:00:00	2009-12-13	581452		0	0	0		0	0	0	150444	0	52	40213296		
29814	2469	1118084	2008-08-06	2008-08-06 00:00:00	2008-08-06	2008-08-06 00:00:00	\N	38000177		0	0	0		0	0	0	163716	0	00025152531	44923712		
156464	3443	40213296	2017-04-19	2017-04-19 00:00:00	2017-04-19	2017-04-19 00:00:00	2017-04-19	581452		0	0	0		0	0	0	228469	0	52	40213296		
46775	3875	19059056	1962-10-28	1962-10-28 00:00:00	1962-11-18	1962-11-18 00:00:00	1962-11-18	38000177		0	0	21		0	0	0	257377	0	243670	19059056		
59566	4952	1713671	1976-12-10	1976-12-10 00:00:00	1976-12-17	1976-12-17 00:00:00	1976-12-17	38000177		0	0	7		0	0	0	329142	0	562251	1713671		
132647	2914	40213227	2017-08-05	2017-08-05 00:00:00	2017-08-05	2017-08-05 00:00:00	2017-08-05	581452		0	0	0		0	0	0	194165	0	113	40213227		
61893	5148	19059056	1962-10-03	1962-10-03 00:00:00	1962-10-17	1962-10-17 00:00:00	1962-10-17	38000177		0	0	14		0	0	0	342248	0	243670	19059056		
58589	4865	19019979	1977-11-08	1977-11-08 00:00:00	1978-01-14	1978-01-14 00:00:00	1978-01-14	38000177		0	0	67		0	0	0	323500	0	198405	19019979		
230486	5065	40213160	1969-05-20	1969-05-20 00:00:00	1969-05-20	1969-05-20 00:00:00	1969-05-20	581452		0	0	0		0	0	0	336742	0	10	40213160		
214518	4704	40213260	2016-11-26	2016-11-26 00:00:00	2016-11-26	2016-11-26 00:00:00	2016-11-26	581452		0	0	0		0	0	0	313399	0	121	40213260		
55286	4590	19078461	2002-09-29	2002-09-29 00:00:00	2002-12-28	2002-12-28 00:00:00	2002-12-28	38000177		0	0	90		0	0	0	305863	0	310965	19078461		
10037	842	1332419	2017-11-04	2017-11-04 00:00:00	2017-11-04	2017-11-04 00:00:00	\N	38000177		0	0	0		0	0	0	55686	0	197361	1332419		
53796	1177	40213160	1968-04-08	1968-04-08 00:00:00	1968-04-08	1968-04-08 00:00:00	1968-04-08	581452		0	0	0		0	0	0	77796	0	10	40213160		
4054	335	1127433	1982-03-24	1982-03-24 00:00:00	1982-04-14	1982-04-14 00:00:00	1982-04-14	38000177		0	0	21		0	0	0	22294	0	313782	1127433		
35039	2893	1127433	1997-08-06	1997-08-06 00:00:00	1997-09-03	1997-09-03 00:00:00	1997-09-03	38000177		0	0	28		0	0	0	192465	0	313782	1127433		
19605	426	40213296	2006-01-19	2006-01-19 00:00:00	2006-01-19	2006-01-19 00:00:00	2006-01-19	581452		0	0	0		0	0	0	28253	0	52	40213296		
606	43	1713671	1962-06-11	1962-06-11 00:00:00	1962-06-18	1962-06-18 00:00:00	1962-06-18	38000177		0	0	7		0	0	0	3191	0	562251	1713671		
35156	2899	1127433	1967-07-17	1967-07-17 00:00:00	1967-07-31	1967-07-31 00:00:00	1967-07-31	38000177		0	0	14		0	0	0	193172	0	313782	1127433		
65968	1443	40213160	1977-07-02	1977-07-02 00:00:00	1977-07-02	1977-07-02 00:00:00	1977-07-02	581452		0	0	0		0	0	0	96205	0	10	40213160		
16517	1368	1118084	1992-05-26	1992-05-26 00:00:00	1992-05-26	1992-05-26 00:00:00	\N	38000177		0	0	0		0	0	0	90681	0	00025152531	44923712		
58130	4829	19128065	1995-10-15	1995-10-15 00:00:00	1996-10-09	1996-10-09 00:00:00	1996-10-09	38000177		0	0	360		0	0	0	321326	0	749882	19128065		
45775	3789	1127433	1949-05-24	1949-05-24 00:00:00	1949-05-31	1949-05-31 00:00:00	1949-05-31	38000177		0	0	7		0	0	0	251922	0	313782	1127433		
56284	4670	920300	1990-05-08	1990-05-08 00:00:00	1990-05-15	1990-05-15 00:00:00	1990-05-15	38000177		0	0	7		0	0	0	311194	0	311989	920300		
31926	2646	1127433	2008-11-25	2008-11-25 00:00:00	2008-12-02	2008-12-02 00:00:00	2008-12-02	38000177		0	0	7		0	0	0	175075	0	313782	1127433		
30471	664	40213160	1981-10-15	1981-10-15 00:00:00	1981-10-15	1981-10-15 00:00:00	1981-10-15	581452		0	0	0		0	0	0	43870	0	10	40213160		
57536	4776	1127433	1965-02-21	1965-02-21 00:00:00	1965-03-07	1965-03-07 00:00:00	1965-03-07	38000177		0	0	14		0	0	0	318041	0	313782	1127433		
30376	2518	40165015	1997-10-09	1997-10-09 00:00:00	1997-10-09	1997-10-09 00:00:00	\N	38000177		0	0	0		0	0	0	166544	0	861467	40165015		
7603	639	19128065	1977-11-03	1977-11-03 00:00:00	1978-10-29	1978-10-29 00:00:00	1978-10-29	38000177		0	0	360		0	0	0	42308	0	749882	19128065		
40928	3394	40229134	2018-12-29	2018-12-29 00:00:00	2019-01-05	2019-01-05 00:00:00	2019-01-05	38000177		0	0	7		0	0	0	225166	0	1043400	40229134		
17317	374	40213227	2011-05-19	2011-05-19 00:00:00	2011-05-19	2011-05-19 00:00:00	2011-05-19	581452		0	0	0		0	0	0	24835	0	113	40213227		
69756	1525	40213306	1985-08-29	1985-08-29 00:00:00	1985-08-29	1985-08-29 00:00:00	1985-08-29	581452		0	0	0		0	0	0	102020	0	43	40213306		
60808	5056	19077572	2012-08-23	2012-08-23 00:00:00	2012-08-23	2012-08-23 00:00:00	\N	38000177		0	0	0		0	0	0	336138	0	310436	19077572		
12581	1058	1115171	1996-07-20	1996-07-20 00:00:00	1996-08-10	1996-08-10 00:00:00	1996-08-10	38000177		0	0	21		0	0	0	69404	0	849574	1115171		
28815	2381	46275916	2013-01-30	2013-01-30 00:00:00	2013-01-30	2013-01-30 00:00:00	2013-01-30	38000177		0	0	0		0	0	0	158245	0	1660014	46275916		
15454	1289	1127078	1962-11-08	1962-11-08 00:00:00	1962-11-22	1962-11-22 00:00:00	1962-11-22	38000177		0	0	14		0	0	0	85230	0	282464	1127078		
22971	499	40213160	1963-09-20	1963-09-20 00:00:00	1963-09-20	1963-09-20 00:00:00	1963-09-20	581452		0	0	0		0	0	0	\N	0	10	40213160		
81337	1778	40213227	2011-07-30	2011-07-30 00:00:00	2011-07-30	2011-07-30 00:00:00	2011-07-30	581452		0	0	0		0	0	0	118968	0	113	40213227		
33725	2790	1127433	1986-01-28	1986-01-28 00:00:00	1986-02-04	1986-02-04 00:00:00	1986-02-04	38000177		0	0	7		0	0	0	184876	0	313782	1127433		
46109	3820	19128065	1987-10-01	1987-10-01 00:00:00	1988-09-25	1988-09-25 00:00:00	1988-09-25	38000177		0	0	360		0	0	0	253621	0	749882	19128065		
46242	3831	1127433	1962-07-13	1962-07-13 00:00:00	1962-07-27	1962-07-27 00:00:00	1962-07-27	38000177		0	0	14		0	0	0	254372	0	313782	1127433		
39204	3240	40229134	1990-12-30	1990-12-30 00:00:00	1991-01-06	1991-01-06 00:00:00	1991-01-06	38000177		0	0	7		0	0	0	215345	0	1043400	40229134		
52701	4381	1713671	2007-02-09	2007-02-09 00:00:00	2007-02-16	2007-02-16 00:00:00	2007-02-16	38000177		0	0	7		0	0	0	291073	0	562251	1713671		
29683	2459	1127433	2008-09-06	2008-09-06 00:00:00	2008-09-13	2008-09-13 00:00:00	2008-09-13	38000177		0	0	7		0	0	0	163039	0	313782	1127433		
145477	3199	40213227	2014-04-30	2014-04-30 00:00:00	2014-04-30	2014-04-30 00:00:00	2014-04-30	581452		0	0	0		0	0	0	212780	0	113	40213227		
63287	5257	1713671	2000-08-25	2000-08-25 00:00:00	2000-09-08	2000-09-08 00:00:00	2000-09-08	38000177		0	0	14		0	0	0	349787	0	562251	1713671		
51993	4324	1127433	1981-08-26	1981-08-26 00:00:00	1981-09-02	1981-09-02 00:00:00	1981-09-02	38000177		0	0	7		0	0	0	286838	0	313782	1127433		
150357	3307	40213160	1970-07-24	1970-07-24 00:00:00	1970-07-24	1970-07-24 00:00:00	1970-07-24	581452		0	0	0		0	0	0	219605	0	10	40213160		
35764	2945	19078461	1979-12-05	1979-12-05 00:00:00	1979-12-19	1979-12-19 00:00:00	1979-12-19	38000177		0	0	14		0	0	0	196485	0	310965	19078461		
40279	877	40213296	2017-05-09	2017-05-09 00:00:00	2017-05-09	2017-05-09 00:00:00	2017-05-09	581452		0	0	0		0	0	0	58409	0	52	40213296		
93091	2043	40213296	1998-04-26	1998-04-26 00:00:00	1998-04-26	1998-04-26 00:00:00	1998-04-26	581452		0	0	0		0	0	0	135891	0	52	40213296		
99339	2175	40213296	2019-02-21	2019-02-21 00:00:00	2019-02-21	2019-02-21 00:00:00	2019-02-21	581452		0	0	0		0	0	0	145011	0	52	40213296		
8185	682	19059056	1983-04-12	1983-04-12 00:00:00	1983-04-26	1983-04-26 00:00:00	1983-04-26	38000177		0	0	14		0	0	0	45199	0	243670	19059056		
61510	5118	1118084	2008-02-24	2008-02-24 00:00:00	2008-02-24	2008-02-24 00:00:00	\N	38000177		0	0	0		0	0	0	340270	0	00025152531	44923712		
138485	3041	40213160	1981-09-17	1981-09-17 00:00:00	1981-09-17	1981-09-17 00:00:00	1981-09-17	581452		0	0	0		0	0	0	\N	0	10	40213160		
82084	1793	40213201	1985-05-15	1985-05-15 00:00:00	1985-05-15	1985-05-15 00:00:00	1985-05-15	581452		0	0	0		0	0	0	120236	0	33	40213201		
82130	1794	40213296	2001-02-17	2001-02-17 00:00:00	2001-02-17	2001-02-17 00:00:00	2001-02-17	581452		0	0	0		0	0	0	120295	0	52	40213296		
31559	2617	1539411	2014-09-06	2014-09-06 00:00:00	2014-09-06	2014-09-06 00:00:00	\N	38000177		0	0	0		0	0	0	173057	0	312961	1539411		
2253	182	1127433	1986-09-17	1986-09-17 00:00:00	1986-09-24	1986-09-24 00:00:00	1986-09-24	38000177		0	0	7		0	0	0	12295	0	313782	1127433		
47021	3895	1127433	1977-02-01	1977-02-01 00:00:00	1977-02-15	1977-02-15 00:00:00	1977-02-15	38000177		0	0	14		0	0	0	259122	0	313782	1127433		
29478	2439	40236824	2006-06-04	2006-06-04 00:00:00	2006-06-11	2006-06-11 00:00:00	2006-06-11	38000177		0	0	7		0	0	0	161813	0	1094107	40236824		
211846	4644	40213296	2002-07-11	2002-07-11 00:00:00	2002-07-11	2002-07-11 00:00:00	2002-07-11	581452		0	0	0		0	0	0	309644	0	52	40213296		
85191	1864	40213260	2015-12-04	2015-12-04 00:00:00	2015-12-04	2015-12-04 00:00:00	2015-12-04	581452		0	0	0		0	0	0	124545	0	121	40213260		
109735	2411	40213260	2015-11-26	2015-11-26 00:00:00	2015-11-26	2015-11-26 00:00:00	2015-11-26	581452		0	0	0		0	0	0	159998	0	121	40213260		
23427	1928	920300	2016-09-07	2016-09-07 00:00:00	2016-09-14	2016-09-14 00:00:00	2016-09-14	38000177		0	0	7		0	0	0	128313	0	311989	920300		
103232	2264	40213160	1969-10-19	1969-10-19 00:00:00	1969-10-19	1969-10-19 00:00:00	1969-10-19	581452		0	0	0		0	0	0	150433	0	10	40213160		
29815	2469	1127078	1979-09-18	1979-09-18 00:00:00	1979-11-17	1979-11-17 00:00:00	1979-11-17	38000177		0	0	60		0	0	0	163710	0	282464	1127078		
156466	3443	40213251	1984-10-10	1984-10-10 00:00:00	1984-10-10	1984-10-10 00:00:00	1984-10-10	581452		0	0	0		0	0	0	228506	0	21	40213251		
46776	3875	19129655	1962-10-28	1962-10-28 00:00:00	1962-11-18	1962-11-18 00:00:00	1962-11-18	38000177		0	0	21		0	0	0	257377	0	789980	19129655		
59567	4952	1127433	1973-04-06	1973-04-06 00:00:00	1973-04-20	1973-04-20 00:00:00	1973-04-20	38000177		0	0	14		0	0	0	329124	0	313782	1127433		
132652	2914	40213227	1998-08-29	1998-08-29 00:00:00	1998-08-29	1998-08-29 00:00:00	1998-08-29	581452		0	0	0		0	0	0	194166	0	113	40213227		
61894	5148	19128065	1978-01-21	1978-01-21 00:00:00	1979-01-16	1979-01-16 00:00:00	1979-01-16	38000177		0	0	360		0	0	0	342281	0	749882	19128065		
58590	4865	1124300	2013-06-09	2013-06-09 00:00:00	2013-06-09	2013-06-09 00:00:00	\N	38000177		0	0	0		0	0	0	323540	0	00781178901	45011828		
230488	5065	40213160	1969-10-21	1969-10-21 00:00:00	1969-10-21	1969-10-21 00:00:00	1969-10-21	581452		0	0	0		0	0	0	336745	0	10	40213160		
128941	2835	40213227	2004-03-09	2004-03-09 00:00:00	2004-03-09	2004-03-09 00:00:00	2004-03-09	581452		0	0	0		0	0	0	188209	0	113	40213227		
55287	4591	1127433	2003-03-19	2003-03-19 00:00:00	2003-03-26	2003-03-26 00:00:00	2003-03-26	38000177		0	0	7		0	0	0	305919	0	313782	1127433		
10038	842	19126352	2017-11-04	2017-11-04 00:00:00	2017-11-04	2017-11-04 00:00:00	\N	38000177		0	0	0		0	0	0	55686	0	705129	19126352		
53802	1177	40213160	1964-01-06	1964-01-06 00:00:00	1964-01-06	1964-01-06 00:00:00	1964-01-06	581452		0	0	0		0	0	0	77779	0	10	40213160		
4055	335	1118084	2003-04-29	2003-04-29 00:00:00	2003-04-29	2003-04-29 00:00:00	\N	38000177		0	0	0		0	0	0	22253	0	00025152531	44923712		
35040	2893	19059056	1966-07-22	1966-07-22 00:00:00	1966-08-19	1966-08-19 00:00:00	1966-08-19	38000177		0	0	28		0	0	0	192462	0	243670	19059056		
19614	426	40213160	1966-04-21	1966-04-21 00:00:00	1966-04-21	1966-04-21 00:00:00	1966-04-21	581452		0	0	0		0	0	0	28259	0	10	40213160		
607	43	40229134	1979-10-19	1979-10-19 00:00:00	1979-11-02	1979-11-02 00:00:00	1979-11-02	38000177		0	0	14		0	0	0	3144	0	1043400	40229134		
35157	2899	1127433	2013-10-24	2013-10-24 00:00:00	2013-11-07	2013-11-07 00:00:00	2013-11-07	38000177		0	0	14		0	0	0	193117	0	313782	1127433		
65971	1443	40213160	1982-03-05	1982-03-05 00:00:00	1982-03-05	1982-03-05 00:00:00	1982-03-05	581452		0	0	0		0	0	0	96214	0	10	40213160		
16518	1368	1127078	1959-05-19	1959-05-19 00:00:00	1959-06-18	1959-06-18 00:00:00	1959-06-18	38000177		0	0	30		0	0	0	90716	0	282464	1127078		
58131	4829	19128065	1992-10-30	1992-10-30 00:00:00	1993-10-25	1993-10-25 00:00:00	1993-10-25	38000177		0	0	360		0	0	0	321324	0	749882	19128065		
45776	3789	19078461	1976-04-15	1976-04-15 00:00:00	1976-04-29	1976-04-29 00:00:00	1976-04-29	38000177		0	0	14		0	0	0	251887	0	310965	19078461		
56286	4670	1127433	1969-12-21	1969-12-21 00:00:00	1970-01-04	1970-01-04 00:00:00	1970-01-04	38000177		0	0	14		0	0	0	311155	0	313782	1127433		
31927	2646	1127433	1980-02-13	1980-02-13 00:00:00	1980-02-20	1980-02-20 00:00:00	1980-02-20	38000177		0	0	7		0	0	0	175090	0	313782	1127433		
30474	664	40213227	2012-09-20	2012-09-20 00:00:00	2012-09-20	2012-09-20 00:00:00	2012-09-20	581452		0	0	0		0	0	0	43879	0	113	40213227		
57537	4776	40163554	2011-04-24	2011-04-24 00:00:00	2011-04-24	2011-04-24 00:00:00	\N	38000177		0	0	0		0	0	0	318053	0	855332	40163554		
30377	2518	19078461	1997-10-09	1997-10-09 00:00:00	1997-11-13	1997-11-13 00:00:00	1997-11-13	38000177		0	0	35		0	0	0	166544	0	310965	19078461		
7604	640	1115171	2011-06-08	2011-06-08 00:00:00	2011-06-29	2011-06-29 00:00:00	2011-06-29	38000177		0	0	21		0	0	0	42331	0	849574	1115171		
40929	3394	19128065	1986-08-25	1986-08-25 00:00:00	1987-08-20	1987-08-20 00:00:00	1987-08-20	38000177		0	0	360		0	0	0	225158	0	749882	19128065		
181874	3995	40213160	1971-10-23	1971-10-23 00:00:00	1971-10-23	1971-10-23 00:00:00	1971-10-23	581452		0	0	0		0	0	0	265605	0	10	40213160		
69758	1525	40213227	2005-08-11	2005-08-11 00:00:00	2005-08-11	2005-08-11 00:00:00	2005-08-11	581452		0	0	0		0	0	0	101971	0	113	40213227		
60809	5056	19059056	1942-11-12	1942-11-12 00:00:00	1942-11-26	1942-11-26 00:00:00	1942-11-26	38000177		0	0	14		0	0	0	336220	0	243670	19059056		
12582	1058	1127433	2009-03-09	2009-03-09 00:00:00	2009-03-23	2009-03-23 00:00:00	2009-03-23	38000177		0	0	14		0	0	0	69430	0	313782	1127433		
28816	2381	1310034	2013-01-30	2013-01-30 00:00:00	2013-01-30	2013-01-30 00:00:00	2013-01-30	38000177		0	0	0		0	0	0	158245	0	834357	1310034		
15455	1289	19129655	1962-11-08	1962-11-08 00:00:00	1962-11-22	1962-11-22 00:00:00	1962-11-22	38000177		0	0	14		0	0	0	85230	0	789980	19129655		
22974	499	40213160	1960-01-01	1960-01-01 00:00:00	1960-01-01	1960-01-01 00:00:00	1960-01-01	581452		0	0	0		0	0	0	33309	0	10	40213160		
81338	1778	40213251	1984-04-21	1984-04-21 00:00:00	1984-04-21	1984-04-21 00:00:00	1984-04-21	581452		0	0	0		0	0	0	118961	0	21	40213251		
33727	2790	1127433	1984-12-01	1984-12-01 00:00:00	1985-01-05	1985-01-05 00:00:00	1985-01-05	38000177		0	0	35		0	0	0	184873	0	313782	1127433		
46117	3822	19059056	1945-08-21	1945-08-21 00:00:00	1945-09-11	1945-09-11 00:00:00	1945-09-11	38000177		0	0	21		0	0	0	253893	0	243670	19059056		
46243	3831	1127078	1956-04-19	1956-04-19 00:00:00	1956-05-10	1956-05-10 00:00:00	1956-05-10	38000177		0	0	21		0	0	0	254327	0	282464	1127078		
39205	3240	19006318	1947-09-15	1947-09-15 00:00:00	1947-09-29	1947-09-29 00:00:00	1947-09-29	38000177		0	0	14		0	0	0	215350	0	105078	19006318		
52702	4381	1127433	1972-04-23	1972-04-23 00:00:00	1972-05-07	1972-05-07 00:00:00	1972-05-07	38000177		0	0	14		0	0	0	291148	0	313782	1127433		
29684	2459	19133873	1977-07-19	1977-07-19 00:00:00	1977-07-29	1977-07-29 00:00:00	1977-07-29	38000177		0	0	10		0	0	0	163049	0	834061	19133873		
145478	3199	40213296	2014-04-30	2014-04-30 00:00:00	2014-04-30	2014-04-30 00:00:00	2014-04-30	581452		0	0	0		0	0	0	212780	0	52	40213296		
63288	5257	43012754	2005-01-02	2005-01-02 00:00:00	2005-12-28	2005-12-28 00:00:00	2005-12-28	38000177		0	0	360		0	0	0	349789	0	1366343	43012754		
51994	4324	19133873	1961-08-12	1961-08-12 00:00:00	1961-08-19	1961-08-19 00:00:00	1961-08-19	38000177		0	0	7		0	0	0	286846	0	834061	19133873		
150359	3307	40213227	2016-10-28	2016-10-28 00:00:00	2016-10-28	2016-10-28 00:00:00	2016-10-28	581452		0	0	0		0	0	0	219586	0	113	40213227		
35779	2947	19078461	1991-03-28	1991-03-28 00:00:00	1991-04-19	1991-04-19 00:00:00	1991-04-19	38000177		0	0	22		0	0	0	196699	0	310965	19078461		
40283	877	40213314	1977-10-11	1977-10-11 00:00:00	1977-10-11	1977-10-11 00:00:00	1977-10-11	581452		0	0	0		0	0	0	58469	0	49	40213314		
93093	2043	40213160	1956-05-20	1956-05-20 00:00:00	1956-05-20	1956-05-20 00:00:00	1956-05-20	581452		0	0	0		0	0	0	135909	0	10	40213160		
99341	2175	40213160	1976-10-07	1976-10-07 00:00:00	1976-10-07	1976-10-07 00:00:00	1976-10-07	581452		0	0	0		0	0	0	144988	0	10	40213160		
8186	682	19059056	1972-10-08	1972-10-08 00:00:00	1972-11-05	1972-11-05 00:00:00	1972-11-05	38000177		0	0	28		0	0	0	45198	0	243670	19059056		
61511	5118	1127433	1993-05-24	1993-05-24 00:00:00	1993-06-28	1993-06-28 00:00:00	1993-06-28	38000177		0	0	35		0	0	0	340161	0	313782	1127433		
138489	3041	40213227	2008-07-10	2008-07-10 00:00:00	2008-07-10	2008-07-10 00:00:00	2008-07-10	581452		0	0	0		0	0	0	\N	0	113	40213227		
82095	1793	40213227	1999-07-28	1999-07-28 00:00:00	1999-07-28	1999-07-28 00:00:00	1999-07-28	581452		0	0	0		0	0	0	120173	0	113	40213227		
82133	1794	40213160	1964-01-18	1964-01-18 00:00:00	1964-01-18	1964-01-18 00:00:00	1964-01-18	581452		0	0	0		0	0	0	120315	0	10	40213160		
31560	2617	19059056	1955-11-20	1955-11-20 00:00:00	1955-12-18	1955-12-18 00:00:00	1955-12-18	38000177		0	0	28		0	0	0	173081	0	243670	19059056		
2254	182	1127433	1984-03-17	1984-03-17 00:00:00	1984-03-31	1984-03-31 00:00:00	1984-03-31	38000177		0	0	14		0	0	0	12277	0	313782	1127433		
47022	3895	1127433	1974-04-02	1974-04-02 00:00:00	1974-04-16	1974-04-16 00:00:00	1974-04-16	38000177		0	0	14		0	0	0	259051	0	313782	1127433		
29479	2439	920300	2006-06-04	2006-06-04 00:00:00	2006-06-11	2006-06-11 00:00:00	2006-06-11	38000177		0	0	7		0	0	0	161813	0	311989	920300		
211852	4644	40213160	1963-03-14	1963-03-14 00:00:00	1963-03-14	1963-03-14 00:00:00	1963-03-14	581452		0	0	0		0	0	0	309692	0	10	40213160		
103105	2261	40213160	1964-02-11	1964-02-11 00:00:00	1964-02-11	1964-02-11 00:00:00	1964-02-11	581452		0	0	0		0	0	0	150304	0	10	40213160		
109741	2411	40213160	1964-10-08	1964-10-08 00:00:00	1964-10-08	1964-10-08 00:00:00	1964-10-08	581452		0	0	0		0	0	0	159977	0	10	40213160		
23428	1928	40236824	2016-09-07	2016-09-07 00:00:00	2016-09-14	2016-09-14 00:00:00	2016-09-14	38000177		0	0	7		0	0	0	128313	0	1094107	40236824		
103237	2264	40213227	2011-12-18	2011-12-18 00:00:00	2011-12-18	2011-12-18 00:00:00	2011-12-18	581452		0	0	0		0	0	0	150474	0	113	40213227		
29816	2469	40229134	1993-08-14	1993-08-14 00:00:00	1993-08-28	1993-08-28 00:00:00	1993-08-28	38000177		0	0	14		0	0	0	163748	0	1043400	40229134		
156469	3443	40213227	2019-04-24	2019-04-24 00:00:00	2019-04-24	2019-04-24 00:00:00	2019-04-24	581452		0	0	0		0	0	0	228497	0	113	40213227		
46777	3875	920334	2005-12-13	2005-12-13 00:00:00	2005-12-20	2005-12-20 00:00:00	2005-12-20	38000177		0	0	7		0	0	0	257347	0	311995	920334		
59568	4952	1127433	1978-05-12	1978-05-12 00:00:00	1978-05-19	1978-05-19 00:00:00	1978-05-19	38000177		0	0	7		0	0	0	329153	0	313782	1127433		
132653	2914	40213296	1998-08-29	1998-08-29 00:00:00	1998-08-29	1998-08-29 00:00:00	1998-08-29	581452		0	0	0		0	0	0	194166	0	52	40213296		
61895	5148	19129655	1975-09-16	1975-09-16 00:00:00	1975-09-30	1975-09-30 00:00:00	1975-09-30	38000177		0	0	14		0	0	0	342267	0	789980	19129655		
58591	4865	1127078	1981-11-24	1981-11-24 00:00:00	1982-01-30	1982-01-30 00:00:00	1982-01-30	38000177		0	0	67		0	0	0	323501	0	282464	1127078		
191374	4204	40213227	1992-08-24	1992-08-24 00:00:00	1992-08-24	1992-08-24 00:00:00	1992-08-24	581452		0	0	0		0	0	0	279140	0	113	40213227		
128965	2836	40213160	1981-02-09	1981-02-09 00:00:00	1981-02-09	1981-02-09 00:00:00	1981-02-09	581452		0	0	0		0	0	0	188390	0	10	40213160		
55288	4591	1127433	2012-01-09	2012-01-09 00:00:00	2012-01-23	2012-01-23 00:00:00	2012-01-23	38000177		0	0	14		0	0	0	305946	0	313782	1127433		
10039	842	1713671	1952-02-13	1952-02-13 00:00:00	1952-02-20	1952-02-20 00:00:00	1952-02-20	38000177		0	0	7		0	0	0	55622	0	562251	1713671		
53807	1177	40213260	2013-04-29	2013-04-29 00:00:00	2013-04-29	2013-04-29 00:00:00	2013-04-29	581452		0	0	0		0	0	0	77758	0	121	40213260		
4056	335	19078461	2012-07-26	2012-07-26 00:00:00	2012-08-23	2012-08-23 00:00:00	2012-08-23	38000177		0	0	28		0	0	0	22296	0	310965	19078461		
19573	426	40213160	1966-06-23	1966-06-23 00:00:00	1966-06-23	1966-06-23 00:00:00	1966-06-23	581452		0	0	0		0	0	0	28270	0	10	40213160		
100481	2202	40213227	2015-12-03	2015-12-03 00:00:00	2015-12-03	2015-12-03 00:00:00	2015-12-03	581452		0	0	0		0	0	0	146803	0	113	40213227		
608	43	1713671	1997-12-03	1997-12-03 00:00:00	1997-12-17	1997-12-17 00:00:00	1997-12-17	38000177		0	0	14		0	0	0	3166	0	562251	1713671		
35169	2902	1127433	2000-09-21	2000-09-21 00:00:00	2000-10-05	2000-10-05 00:00:00	2000-10-05	38000177		0	0	14		0	0	0	193300	0	313782	1127433		
65976	1443	40213227	2008-06-14	2008-06-14 00:00:00	2008-06-14	2008-06-14 00:00:00	2008-06-14	581452		0	0	0		0	0	0	96209	0	113	40213227		
16519	1368	46233710	1970-09-18	1970-09-18 00:00:00	1970-10-16	1970-10-16 00:00:00	1970-10-16	38000177		0	0	28		0	0	0	90746	0	1650142	46233710		
58132	4829	46233988	1972-11-04	1972-11-04 00:00:00	1972-11-18	1972-11-18 00:00:00	1972-11-18	38000177		0	0	14		0	0	0	321358	0	1652673	46233988		
45777	3789	1118084	1977-03-01	1977-03-01 00:00:00	1977-03-01	1977-03-01 00:00:00	\N	38000177		0	0	0		0	0	0	251887	0	00025152531	44923712		
56288	4670	1115171	1994-04-26	1994-04-26 00:00:00	1994-05-17	1994-05-17 00:00:00	1994-05-17	38000177		0	0	21		0	0	0	311158	0	849574	1115171		
31928	2647	1127433	1975-11-13	1975-11-13 00:00:00	1975-11-27	1975-11-27 00:00:00	1975-11-27	38000177		0	0	14		0	0	0	175148	0	313782	1127433		
30475	664	40213251	1984-06-14	1984-06-14 00:00:00	1984-06-14	1984-06-14 00:00:00	1984-06-14	581452		0	0	0		0	0	0	43812	0	21	40213251		
57538	4776	19018935	2011-04-24	2011-04-24 00:00:00	2011-04-24	2011-04-24 00:00:00	\N	38000177		0	0	0		0	0	0	318053	0	197604	19018935		
30378	2518	19133905	1993-12-21	1993-12-21 00:00:00	1993-12-28	1993-12-28 00:00:00	1993-12-28	38000177		0	0	7		0	0	0	166506	0	834102	19133905		
7605	640	19059056	1957-04-10	1957-04-10 00:00:00	1957-07-09	1957-07-09 00:00:00	1957-07-09	38000177		0	0	90		0	0	0	42328	0	243670	19059056		
40930	3394	1127433	1980-02-16	1980-02-16 00:00:00	1980-05-16	1980-05-16 00:00:00	1980-05-16	38000177		0	0	90		0	0	0	225156	0	313782	1127433		
181878	3996	40213306	1991-02-12	1991-02-12 00:00:00	1991-02-12	1991-02-12 00:00:00	1991-02-12	581452		0	0	0		0	0	0	265694	0	43	40213306		
69759	1525	40213296	2005-08-11	2005-08-11 00:00:00	2005-08-11	2005-08-11 00:00:00	2005-08-11	581452		0	0	0		0	0	0	101971	0	52	40213296		
60810	5056	40229134	2004-02-12	2004-02-12 00:00:00	2004-02-19	2004-02-19 00:00:00	2004-02-19	38000177		0	0	7		0	0	0	336218	0	1043400	40229134		
12583	1058	1127433	1960-07-30	1960-07-30 00:00:00	1960-08-13	1960-08-13 00:00:00	1960-08-13	38000177		0	0	14		0	0	0	69381	0	313782	1127433		
28817	2381	19059056	1948-05-14	1948-05-14 00:00:00	1948-06-18	1948-06-18 00:00:00	1948-06-18	38000177		0	0	35		0	0	0	158303	0	243670	19059056		
15456	1289	19133873	1973-12-14	1973-12-14 00:00:00	1973-12-23	1973-12-23 00:00:00	1973-12-23	38000177		0	0	9		0	0	0	85193	0	834061	19133873		
23171	1911	920300	1987-12-23	1987-12-23 00:00:00	1987-12-30	1987-12-30 00:00:00	1987-12-30	38000177		0	0	7		0	0	0	127192	0	311989	920300		
81344	1778	40213160	1981-01-24	1981-01-24 00:00:00	1981-01-24	1981-01-24 00:00:00	1981-01-24	581452		0	0	0		0	0	0	118946	0	10	40213160		
33728	2790	1124300	1985-08-30	1985-08-30 00:00:00	1985-08-30	1985-08-30 00:00:00	\N	38000177		0	0	0		0	0	0	184873	0	00781178901	45011828		
46118	3822	40163554	2015-04-27	2015-04-27 00:00:00	2015-04-27	2015-04-27 00:00:00	\N	38000177		0	0	0		0	0	0	253846	0	855332	40163554		
46244	3831	1118084	1991-04-11	1991-04-11 00:00:00	1991-04-11	1991-04-11 00:00:00	\N	38000177		0	0	0		0	0	0	254349	0	00025152531	44923712		
39206	3240	19059056	1947-09-15	1947-09-15 00:00:00	1947-09-29	1947-09-29 00:00:00	1947-09-29	38000177		0	0	14		0	0	0	215350	0	243670	19059056		
52703	4381	1713671	1995-01-15	1995-01-15 00:00:00	1995-01-22	1995-01-22 00:00:00	1995-01-22	38000177		0	0	7		0	0	0	291107	0	562251	1713671		
29685	2459	1127433	1993-04-23	1993-04-23 00:00:00	1993-05-23	1993-05-23 00:00:00	1993-05-23	38000177		0	0	30		0	0	0	163067	0	313782	1127433		
34090	744	40213160	1957-03-08	1957-03-08 00:00:00	1957-03-08	1957-03-08 00:00:00	1957-03-08	581452		0	0	0		0	0	0	49336	0	10	40213160		
63289	5257	19132304	2006-12-23	2006-12-23 00:00:00	2007-12-22	2007-12-22 00:00:00	2007-12-22	38000177		0	0	364		0	0	0	349790	0	807283	19132304		
51995	4324	40229134	2016-07-17	2016-07-17 00:00:00	2016-07-31	2016-07-31 00:00:00	2016-07-31	38000177		0	0	14		0	0	0	286830	0	1043400	40229134		
150360	3307	40213260	2016-10-28	2016-10-28 00:00:00	2016-10-28	2016-10-28 00:00:00	2016-10-28	581452		0	0	0		0	0	0	219586	0	121	40213260		
35780	2947	40224805	1999-03-26	1999-03-26 00:00:00	2000-03-20	2000-03-20 00:00:00	2000-03-20	38000177		0	0	360		0	0	0	196716	0	1000126	40224805		
40284	877	40213160	1977-10-11	1977-10-11 00:00:00	1977-10-11	1977-10-11 00:00:00	1977-10-11	581452		0	0	0		0	0	0	58469	0	10	40213160		
99282	2174	40213160	1974-12-08	1974-12-08 00:00:00	1974-12-08	1974-12-08 00:00:00	1974-12-08	581452		0	0	0		0	0	0	144898	0	10	40213160		
99343	2175	40213314	1977-04-07	1977-04-07 00:00:00	1977-04-07	1977-04-07 00:00:00	1977-04-07	581452		0	0	0		0	0	0	145052	0	49	40213314		
8187	682	1118084	2008-06-26	2008-06-26 00:00:00	2008-06-26	2008-06-26 00:00:00	\N	38000177		0	0	0		0	0	0	45184	0	00025152531	44923712		
61512	5118	1127433	1982-08-18	1982-08-18 00:00:00	1982-09-01	1982-09-01 00:00:00	1982-09-01	38000177		0	0	14		0	0	0	340283	0	313782	1127433		
138490	3041	40213314	1978-05-11	1978-05-11 00:00:00	1978-05-11	1978-05-11 00:00:00	1978-05-11	581452		0	0	0		0	0	0	202437	0	49	40213314		
17870	387	40213160	1974-02-08	1974-02-08 00:00:00	1974-02-08	1974-02-08 00:00:00	1974-02-08	581452		0	0	0		0	0	0	25494	0	10	40213160		
82137	1794	40213296	1999-02-13	1999-02-13 00:00:00	1999-02-13	1999-02-13 00:00:00	1999-02-13	581452		0	0	0		0	0	0	120294	0	52	40213296		
31561	2617	1127433	1969-08-28	1969-08-28 00:00:00	1969-09-04	1969-09-04 00:00:00	1969-09-04	38000177		0	0	7		0	0	0	173059	0	313782	1127433		
2255	182	19133873	1961-06-16	1961-06-16 00:00:00	1961-06-28	1961-06-28 00:00:00	1961-06-28	38000177		0	0	12		0	0	0	12313	0	834061	19133873		
47023	3895	1118084	1958-05-20	1958-05-20 00:00:00	1958-05-20	1958-05-20 00:00:00	\N	38000177		0	0	0		0	0	0	259102	0	00025152531	44923712		
29480	2439	40229134	1993-10-04	1993-10-04 00:00:00	1993-10-18	1993-10-18 00:00:00	1993-10-18	38000177		0	0	14		0	0	0	161784	0	1043400	40229134		
38263	3167	1127078	1964-11-22	1964-11-22 00:00:00	1964-12-06	1964-12-06 00:00:00	1964-12-06	38000177		0	0	14		0	0	0	210597	0	282464	1127078		
103109	2261	40213296	2003-11-11	2003-11-11 00:00:00	2003-11-11	2003-11-11 00:00:00	2003-11-11	581452		0	0	0		0	0	0	150348	0	52	40213296		
109742	2411	40213160	1964-12-10	1964-12-10 00:00:00	1964-12-10	1964-12-10 00:00:00	1964-12-10	581452		0	0	0		0	0	0	159972	0	10	40213160		
23429	1928	1127433	1980-06-09	1980-06-09 00:00:00	1980-06-16	1980-06-16 00:00:00	1980-06-16	38000177		0	0	7		0	0	0	128334	0	313782	1127433		
103238	2264	40213296	2011-12-18	2011-12-18 00:00:00	2011-12-18	2011-12-18 00:00:00	2011-12-18	581452		0	0	0		0	0	0	150474	0	52	40213296		
29817	2469	19128065	1988-07-12	1988-07-12 00:00:00	1989-07-07	1989-07-07 00:00:00	1989-07-07	38000177		0	0	360		0	0	0	163758	0	749882	19128065		
156470	3443	40213296	2019-04-24	2019-04-24 00:00:00	2019-04-24	2019-04-24 00:00:00	2019-04-24	581452		0	0	0		0	0	0	228497	0	52	40213296		
46778	3875	1127433	1971-06-04	1971-06-04 00:00:00	1971-06-18	1971-06-18 00:00:00	1971-06-18	38000177		0	0	14		0	0	0	257379	0	313782	1127433		
59569	4952	19059056	1971-05-15	1971-05-15 00:00:00	1971-05-29	1971-05-29 00:00:00	1971-05-29	38000177		0	0	14		0	0	0	329125	0	243670	19059056		
132654	2914	40213160	1956-06-09	1956-06-09 00:00:00	1956-06-09	1956-06-09 00:00:00	1956-06-09	581452		0	0	0		0	0	0	194177	0	10	40213160		
61896	5148	19078461	1975-09-16	1975-09-16 00:00:00	1975-09-30	1975-09-30 00:00:00	1975-09-30	38000177		0	0	14		0	0	0	342267	0	310965	19078461		
58598	4867	1713671	1935-01-20	1935-01-20 00:00:00	1935-02-10	1935-02-10 00:00:00	1935-02-10	38000177		0	0	21		0	0	0	323606	0	562251	1713671		
191376	4204	40213227	2001-08-20	2001-08-20 00:00:00	2001-08-20	2001-08-20 00:00:00	2001-08-20	581452		0	0	0		0	0	0	279148	0	113	40213227		
128967	2836	40213314	1981-02-09	1981-02-09 00:00:00	1981-02-09	1981-02-09 00:00:00	1981-02-09	581452		0	0	0		0	0	0	188390	0	49	40213314		
55289	4591	19078461	1974-07-25	1974-07-25 00:00:00	1974-08-29	1974-08-29 00:00:00	1974-08-29	38000177		0	0	35		0	0	0	305894	0	310965	19078461		
10040	842	40229134	2011-07-13	2011-07-13 00:00:00	2011-07-20	2011-07-20 00:00:00	2011-07-20	38000177		0	0	7		0	0	0	55606	0	1043400	40229134		
53812	1177	40213160	1963-10-07	1963-10-07 00:00:00	1963-10-07	1963-10-07 00:00:00	1963-10-07	581452		0	0	0		0	0	0	77792	0	10	40213160		
4057	335	1127433	2005-12-15	2005-12-15 00:00:00	2005-12-22	2005-12-22 00:00:00	2005-12-22	38000177		0	0	7		0	0	0	22280	0	313782	1127433		
19574	426	40213160	1970-12-24	1970-12-24 00:00:00	1970-12-24	1970-12-24 00:00:00	1970-12-24	581452		0	0	0		0	0	0	28298	0	10	40213160		
54560	1194	40213296	2003-04-14	2003-04-14 00:00:00	2003-04-14	2003-04-14 00:00:00	2003-04-14	581452		0	0	0		0	0	0	78721	0	52	40213296		
89163	1954	40213227	1997-04-03	1997-04-03 00:00:00	1997-04-03	1997-04-03 00:00:00	1997-04-03	581452		0	0	0		0	0	0	129988	0	113	40213227		
35170	2902	1127078	1950-05-29	1950-05-29 00:00:00	1950-06-12	1950-06-12 00:00:00	1950-06-12	38000177		0	0	14		0	0	0	193301	0	282464	1127078		
65981	1443	40213227	2019-03-30	2019-03-30 00:00:00	2019-03-30	2019-03-30 00:00:00	2019-03-30	581452		0	0	0		0	0	0	96243	0	113	40213227		
16520	1368	19059056	1970-09-18	1970-09-18 00:00:00	1970-10-16	1970-10-16 00:00:00	1970-10-16	38000177		0	0	28		0	0	0	90746	0	243670	19059056		
58133	4829	1127078	1972-11-04	1972-11-04 00:00:00	1972-11-18	1972-11-18 00:00:00	1972-11-18	38000177		0	0	14		0	0	0	321358	0	282464	1127078		
45778	3789	46233710	1976-04-15	1976-04-15 00:00:00	1976-04-29	1976-04-29 00:00:00	1976-04-29	38000177		0	0	14		0	0	0	251887	0	1650142	46233710		
56304	4674	1127433	1984-03-11	1984-03-11 00:00:00	1984-03-25	1984-03-25 00:00:00	1984-03-25	38000177		0	0	14		0	0	0	311387	0	313782	1127433		
31929	2647	1115171	1996-06-29	1996-06-29 00:00:00	1996-09-27	1996-09-27 00:00:00	1996-09-27	38000177		0	0	90		0	0	0	175139	0	849574	1115171		
30481	664	40213314	1982-09-16	1982-09-16 00:00:00	1982-09-16	1982-09-16 00:00:00	1982-09-16	581452		0	0	0		0	0	0	43865	0	49	40213314		
57539	4776	40171902	2011-04-24	2011-04-24 00:00:00	2011-04-24	2011-04-24 00:00:00	\N	38000177		0	0	0		0	0	0	318053	0	897718	40171902		
40837	3386	1127078	1976-05-14	1976-05-14 00:00:00	1976-06-18	1976-06-18 00:00:00	1976-06-18	38000177		0	0	35		0	0	0	224627	0	282464	1127078		
7606	640	1713671	1960-05-02	1960-05-02 00:00:00	1960-05-23	1960-05-23 00:00:00	1960-05-23	38000177		0	0	21		0	0	0	42374	0	562251	1713671		
40931	3394	40220960	2010-08-21	2010-08-21 00:00:00	2010-08-21	2010-08-21 00:00:00	2010-08-21	38000177		0	0	0		0	0	0	225139	0	1804799	40220960		
181885	3996	40213160	1973-10-23	1973-10-23 00:00:00	1973-10-23	1973-10-23 00:00:00	1973-10-23	581452		0	0	0		0	0	0	265635	0	10	40213160		
69768	1525	40213260	2013-08-01	2013-08-01 00:00:00	2013-08-01	2013-08-01 00:00:00	2013-08-01	581452		0	0	0		0	0	0	101974	0	121	40213260		
60811	5056	1127433	1989-10-05	1989-10-05 00:00:00	1989-10-19	1989-10-19 00:00:00	1989-10-19	38000177		0	0	14		0	0	0	336131	0	313782	1127433		
12584	1058	19006318	1956-07-20	1956-07-20 00:00:00	1956-08-03	1956-08-03 00:00:00	1956-08-03	38000177		0	0	14		0	0	0	69408	0	105078	19006318		
28818	2381	19126352	1996-05-15	1996-05-15 00:00:00	1996-05-15	1996-05-15 00:00:00	\N	38000177		0	0	0		0	0	0	158263	0	705129	19126352		
15457	1289	1127078	1965-04-17	1965-04-17 00:00:00	1965-05-01	1965-05-01 00:00:00	1965-05-01	38000177		0	0	14		0	0	0	85212	0	282464	1127078		
23172	1911	40236824	1987-12-23	1987-12-23 00:00:00	1987-12-30	1987-12-30 00:00:00	1987-12-30	38000177		0	0	7		0	0	0	127192	0	1094107	40236824		
81352	1778	40213314	1981-07-25	1981-07-25 00:00:00	1981-07-25	1981-07-25 00:00:00	1981-07-25	581452		0	0	0		0	0	0	118975	0	49	40213314		
33738	2792	19059056	1962-07-24	1962-07-24 00:00:00	1962-08-07	1962-08-07 00:00:00	1962-08-07	38000177		0	0	14		0	0	0	185030	0	243670	19059056		
46119	3822	19018935	2015-04-27	2015-04-27 00:00:00	2015-04-27	2015-04-27 00:00:00	\N	38000177		0	0	0		0	0	0	253846	0	197604	19018935		
46245	3831	1127433	1958-03-11	1958-03-11 00:00:00	1958-03-25	1958-03-25 00:00:00	1958-03-25	38000177		0	0	14		0	0	0	254390	0	313782	1127433		
39207	3240	19059056	1951-05-27	1951-05-27 00:00:00	1951-08-25	1951-08-25 00:00:00	1951-08-25	38000177		0	0	90		0	0	0	215430	0	243670	19059056		
52704	4381	19059056	1965-03-29	1965-03-29 00:00:00	1965-04-12	1965-04-12 00:00:00	1965-04-12	38000177		0	0	14		0	0	0	291094	0	243670	19059056		
29686	2459	19128022	1994-06-01	1994-06-01 00:00:00	1995-05-27	1995-05-27 00:00:00	1995-05-27	38000177		0	0	360		0	0	0	163016	0	749785	19128022		
45872	1000	40213160	1963-10-22	1963-10-22 00:00:00	1963-10-22	1963-10-22 00:00:00	1963-10-22	581452		0	0	0		0	0	0	66202	0	10	40213160		
63290	5257	19059056	1980-01-04	1980-01-04 00:00:00	1980-02-01	1980-02-01 00:00:00	1980-02-01	38000177		0	0	28		0	0	0	349842	0	243670	19059056		
51996	4324	19008572	1981-06-15	1981-06-15 00:00:00	1981-06-15	1981-06-15 00:00:00	\N	38000177		0	0	0		0	0	0	286805	0	106258	19008572		
55947	4644	1713671	1968-12-09	1968-12-09 00:00:00	1968-12-30	1968-12-30 00:00:00	1968-12-30	38000177		0	0	21		0	0	0	309659	0	562251	1713671		
35781	2947	19128065	1994-04-17	1994-04-17 00:00:00	1995-04-12	1995-04-12 00:00:00	1995-04-12	38000177		0	0	360		0	0	0	196703	0	749882	19128065		
81739	1785	40213227	2005-10-10	2005-10-10 00:00:00	2005-10-10	2005-10-10 00:00:00	2005-10-10	581452		0	0	0		0	0	0	119633	0	113	40213227		
99287	2174	40213314	1978-06-04	1978-06-04 00:00:00	1978-06-04	1978-06-04 00:00:00	1978-06-04	581452		0	0	0		0	0	0	144912	0	49	40213314		
110625	2431	40213160	1971-10-27	1971-10-27 00:00:00	1971-10-27	1971-10-27 00:00:00	1971-10-27	581452		0	0	0		0	0	0	161192	0	10	40213160		
8188	682	19059056	1972-07-10	1972-07-10 00:00:00	1972-07-24	1972-07-24 00:00:00	1972-07-24	38000177		0	0	14		0	0	0	45159	0	243670	19059056		
61513	5118	19073188	1982-08-18	1982-08-18 00:00:00	1982-09-01	1982-09-01 00:00:00	1982-09-01	38000177		0	0	14		0	0	0	340283	0	308192	19073188		
138494	3041	40213314	1977-08-11	1977-08-11 00:00:00	1977-08-11	1977-08-11 00:00:00	1977-08-11	581452		0	0	0		0	0	0	202547	0	49	40213314		
17873	387	40213296	2015-09-11	2015-09-11 00:00:00	2015-09-11	2015-09-11 00:00:00	2015-09-11	581452		0	0	0		0	0	0	25471	0	52	40213296		
82139	1794	40213306	1981-04-11	1981-04-11 00:00:00	1981-04-11	1981-04-11 00:00:00	1981-04-11	581452		0	0	0		0	0	0	120337	0	43	40213306		
31562	2617	19078461	2001-03-21	2001-03-21 00:00:00	2001-04-25	2001-04-25 00:00:00	2001-04-25	38000177		0	0	35		0	0	0	173098	0	310965	19078461		
2256	182	1124300	1995-05-17	1995-05-17 00:00:00	1995-05-17	1995-05-17 00:00:00	\N	38000177		0	0	0		0	0	0	12332	0	00781178901	45011828		
47024	3895	40229134	2004-08-30	2004-08-30 00:00:00	2004-09-13	2004-09-13 00:00:00	2004-09-13	38000177		0	0	14		0	0	0	259105	0	1043400	40229134		
29481	2439	40229134	2012-12-24	2012-12-24 00:00:00	2013-01-07	2013-01-07 00:00:00	2013-01-07	38000177		0	0	14		0	0	0	161810	0	1043400	40229134		
38264	3167	19129655	1964-11-22	1964-11-22 00:00:00	1964-12-06	1964-12-06 00:00:00	1964-12-06	38000177		0	0	14		0	0	0	210597	0	789980	19129655		
103122	2261	40213306	1986-01-07	1986-01-07 00:00:00	1986-01-07	1986-01-07 00:00:00	1986-01-07	581452		0	0	0		0	0	0	150297	0	43	40213306		
109746	2411	40213260	2014-11-20	2014-11-20 00:00:00	2014-11-20	2014-11-20 00:00:00	2014-11-20	581452		0	0	0		0	0	0	160013	0	121	40213260		
23430	1928	1127433	2018-02-19	2018-02-19 00:00:00	2018-03-28	2018-03-28 00:00:00	2018-03-28	38000177		0	0	37		0	0	0	128379	0	313782	1127433		
103241	2264	40213160	1969-08-17	1969-08-17 00:00:00	1969-08-17	1969-08-17 00:00:00	1969-08-17	581452		0	0	0		0	0	0	150449	0	10	40213160		
29819	2469	46233988	1971-10-30	1971-10-30 00:00:00	1971-11-13	1971-11-13 00:00:00	1971-11-13	38000177		0	0	14		0	0	0	163736	0	1652673	46233988		
156475	3443	40213160	1977-11-15	1977-11-15 00:00:00	1977-11-15	1977-11-15 00:00:00	1977-11-15	581452		0	0	0		0	0	0	228470	0	10	40213160		
46782	3875	40173590	2018-07-14	2018-07-14 00:00:00	2018-07-14	2018-07-14 00:00:00	\N	38000177		0	0	0		0	0	0	257341	0	904419	40173590		
59570	4952	1127078	1979-06-02	1979-06-02 00:00:00	1979-07-02	1979-07-02 00:00:00	1979-07-02	38000177		0	0	30		0	0	0	329121	0	282464	1127078		
63527	5278	1713671	1990-04-29	1990-04-29 00:00:00	1990-05-13	1990-05-13 00:00:00	1990-05-13	38000177		0	0	14		0	0	0	351074	0	562251	1713671		
61897	5148	1127433	1974-09-30	1974-09-30 00:00:00	1974-12-28	1974-12-28 00:00:00	1974-12-28	38000177		0	0	89		0	0	0	342222	0	313782	1127433		
27789	2300	1118084	1990-07-30	1990-07-30 00:00:00	1990-07-30	1990-07-30 00:00:00	\N	38000177		0	0	0		0	0	0	153165	0	00025152531	44923712		
191390	4205	40213296	2012-01-14	2012-01-14 00:00:00	2012-01-14	2012-01-14 00:00:00	2012-01-14	581452		0	0	0		0	0	0	279240	0	52	40213296		
128972	2836	40213160	1980-12-08	1980-12-08 00:00:00	1980-12-08	1980-12-08 00:00:00	1980-12-08	581452		0	0	0		0	0	0	188408	0	10	40213160		
55290	4591	40229134	1964-06-18	1964-06-18 00:00:00	1964-06-25	1964-06-25 00:00:00	1964-06-25	38000177		0	0	7		0	0	0	305924	0	1043400	40229134		
10041	842	40229134	1988-05-10	1988-05-10 00:00:00	1988-05-17	1988-05-17 00:00:00	1988-05-17	38000177		0	0	7		0	0	0	55714	0	1043400	40229134		
53819	1177	40213227	2005-07-18	2005-07-18 00:00:00	2005-07-18	2005-07-18 00:00:00	2005-07-18	581452		0	0	0		0	0	0	77742	0	113	40213227		
4058	335	1127433	1986-03-21	1986-03-21 00:00:00	1986-03-28	1986-03-28 00:00:00	1986-03-28	38000177		0	0	7		0	0	0	22261	0	313782	1127433		
19580	426	40213160	1966-09-22	1966-09-22 00:00:00	1966-09-22	1966-09-22 00:00:00	1966-09-22	581452		0	0	0		0	0	0	28260	0	10	40213160		
54562	1194	40213227	2003-04-14	2003-04-14 00:00:00	2003-04-14	2003-04-14 00:00:00	2003-04-14	581452		0	0	0		0	0	0	78721	0	113	40213227		
79664	1743	40213296	2005-02-09	2005-02-09 00:00:00	2005-02-09	2005-02-09 00:00:00	2005-02-09	581452		0	0	0		0	0	0	116580	0	52	40213296		
35171	2902	19006318	1950-05-29	1950-05-29 00:00:00	1950-06-12	1950-06-12 00:00:00	1950-06-12	38000177		0	0	14		0	0	0	193301	0	105078	19006318		
65982	1443	40213296	2019-03-30	2019-03-30 00:00:00	2019-03-30	2019-03-30 00:00:00	2019-03-30	581452		0	0	0		0	0	0	96243	0	52	40213296		
16521	1368	40231925	1970-09-18	1970-09-18 00:00:00	1970-09-18	1970-09-18 00:00:00	\N	38000177		0	0	0		0	0	0	90746	0	1049221	40231925		
58134	4829	1713671	2015-12-12	2015-12-12 00:00:00	2015-12-19	2015-12-19 00:00:00	2015-12-19	38000177		0	0	7		0	0	0	321313	0	562251	1713671		
45779	3789	1115171	2010-07-29	2010-07-29 00:00:00	2010-08-28	2010-08-28 00:00:00	2010-08-28	38000177		0	0	30		0	0	0	251914	0	849574	1115171		
56305	4674	19059056	1973-07-23	1973-07-23 00:00:00	1973-08-06	1973-08-06 00:00:00	1973-08-06	38000177		0	0	14		0	0	0	311385	0	243670	19059056		
31930	2647	19128065	1988-11-18	1988-11-18 00:00:00	1989-11-13	1989-11-13 00:00:00	1989-11-13	38000177		0	0	360		0	0	0	175168	0	749882	19128065		
30489	665	40213160	1960-06-10	1960-06-10 00:00:00	1960-06-10	1960-06-10 00:00:00	1960-06-10	581452		0	0	0		0	0	0	43999	0	10	40213160		
57540	4776	1713671	1965-09-27	1965-09-27 00:00:00	1965-10-04	1965-10-04 00:00:00	1965-10-04	38000177		0	0	7		0	0	0	318005	0	562251	1713671		
40838	3386	19078461	1990-11-12	1990-11-12 00:00:00	1990-12-03	1990-12-03 00:00:00	1990-12-03	38000177		0	0	21		0	0	0	224632	0	310965	19078461		
7607	640	19059056	1951-06-11	1951-06-11 00:00:00	1951-06-25	1951-06-25 00:00:00	1951-06-25	38000177		0	0	14		0	0	0	42345	0	243670	19059056		
40932	3394	19075601	2010-08-21	2010-08-21 00:00:00	2010-08-21	2010-08-21 00:00:00	2010-08-21	38000177		0	0	0		0	0	0	225139	0	309362	19075601		
181890	3996	40213296	2008-11-18	2008-11-18 00:00:00	2008-11-18	2008-11-18 00:00:00	2008-11-18	581452		0	0	0		0	0	0	265683	0	52	40213296		
69770	1525	40213160	1968-07-11	1968-07-11 00:00:00	1968-07-11	1968-07-11 00:00:00	1968-07-11	581452		0	0	0		0	0	0	101998	0	10	40213160		
60812	5056	19059056	1945-12-14	1945-12-14 00:00:00	1945-12-28	1945-12-28 00:00:00	1945-12-28	38000177		0	0	14		0	0	0	336161	0	243670	19059056		
12585	1058	1127078	1956-07-20	1956-07-20 00:00:00	1956-08-03	1956-08-03 00:00:00	1956-08-03	38000177		0	0	14		0	0	0	69408	0	282464	1127078		
28819	2381	1539411	1996-05-15	1996-05-15 00:00:00	1996-05-15	1996-05-15 00:00:00	\N	38000177		0	0	0		0	0	0	158263	0	312961	1539411		
15458	1289	19129655	1965-04-17	1965-04-17 00:00:00	1965-05-01	1965-05-01 00:00:00	1965-05-01	38000177		0	0	14		0	0	0	85212	0	789980	19129655		
23173	1911	40169281	1998-09-07	1998-09-07 00:00:00	1998-09-07	1998-09-07 00:00:00	\N	38000177		0	0	0		0	0	0	127121	0	896209	40169281		
81354	1778	40213314	1980-10-25	1980-10-25 00:00:00	1980-10-25	1980-10-25 00:00:00	1980-10-25	581452		0	0	0		0	0	0	118974	0	49	40213314		
33739	2792	19006318	1962-07-24	1962-07-24 00:00:00	1962-08-07	1962-08-07 00:00:00	1962-08-07	38000177		0	0	14		0	0	0	185030	0	105078	19006318		
46120	3822	40171902	2015-04-27	2015-04-27 00:00:00	2015-04-27	2015-04-27 00:00:00	\N	38000177		0	0	0		0	0	0	253846	0	897718	40171902		
46246	3832	1118084	2016-06-27	2016-06-27 00:00:00	2016-06-27	2016-06-27 00:00:00	\N	38000177		0	0	0		0	0	0	254440	0	00025152531	44923712		
39208	3240	1115171	2015-07-07	2015-07-07 00:00:00	2015-07-21	2015-07-21 00:00:00	2015-07-21	38000177		0	0	14		0	0	0	215438	0	849574	1115171		
52705	4381	19129655	1965-03-29	1965-03-29 00:00:00	1965-04-12	1965-04-12 00:00:00	1965-04-12	38000177		0	0	14		0	0	0	291094	0	789980	19129655		
29687	2459	1713671	2013-03-25	2013-03-25 00:00:00	2013-04-15	2013-04-15 00:00:00	2013-04-15	38000177		0	0	21		0	0	0	163040	0	562251	1713671		
122898	2702	40213227	2012-01-15	2012-01-15 00:00:00	2012-01-15	2012-01-15 00:00:00	2012-01-15	581452		0	0	0		0	0	0	179047	0	113	40213227		
63291	5257	43012754	2004-01-08	2004-01-08 00:00:00	2005-01-02	2005-01-02 00:00:00	2005-01-02	38000177		0	0	360		0	0	0	349841	0	1366343	43012754		
51997	4324	1118084	1999-07-27	1999-07-27 00:00:00	1999-07-27	1999-07-27 00:00:00	\N	38000177		0	0	0		0	0	0	286808	0	00025152531	44923712		
55948	4644	19059056	1985-12-01	1985-12-01 00:00:00	1986-01-05	1986-01-05 00:00:00	1986-01-05	38000177		0	0	35		0	0	0	309629	0	243670	19059056		
35782	2947	1127433	1987-08-13	1987-08-13 00:00:00	1987-08-20	1987-08-20 00:00:00	1987-08-20	38000177		0	0	7		0	0	0	196679	0	313782	1127433		
81749	1786	40213227	1994-03-05	1994-03-05 00:00:00	1994-03-05	1994-03-05 00:00:00	1994-03-05	581452		0	0	0		0	0	0	119711	0	113	40213227		
99292	2174	40213160	1975-03-09	1975-03-09 00:00:00	1975-03-09	1975-03-09 00:00:00	1975-03-09	581452		0	0	0		0	0	0	144918	0	10	40213160		
110633	2431	40213306	1992-10-07	1992-10-07 00:00:00	1992-10-07	1992-10-07 00:00:00	1992-10-07	581452		0	0	0		0	0	0	161212	0	43	40213306		
8189	682	19006318	1972-07-10	1972-07-10 00:00:00	1972-07-24	1972-07-24 00:00:00	1972-07-24	38000177		0	0	14		0	0	0	45159	0	105078	19006318		
61514	5118	1127433	1980-10-08	1980-10-08 00:00:00	1980-12-07	1980-12-07 00:00:00	1980-12-07	38000177		0	0	60		0	0	0	340158	0	313782	1127433		
138495	3041	40213160	1977-08-11	1977-08-11 00:00:00	1977-08-11	1977-08-11 00:00:00	1977-08-11	581452		0	0	0		0	0	0	202547	0	10	40213160		
17875	387	40213227	2015-09-11	2015-09-11 00:00:00	2015-09-11	2015-09-11 00:00:00	2015-09-11	581452		0	0	0		0	0	0	25471	0	113	40213227		
82145	1794	40213260	2009-02-07	2009-02-07 00:00:00	2009-02-07	2009-02-07 00:00:00	2009-02-07	581452		0	0	0		0	0	0	120324	0	121	40213260		
31563	2617	40229134	2001-01-23	2001-01-23 00:00:00	2001-02-06	2001-02-06 00:00:00	2001-02-06	38000177		0	0	14		0	0	0	173082	0	1043400	40229134		
54453	4526	40229134	1968-04-03	1968-04-03 00:00:00	1968-04-17	1968-04-17 00:00:00	1968-04-17	38000177		0	0	14		0	0	0	301352	0	1043400	40229134		
47025	3895	46233710	1982-03-30	1982-03-30 00:00:00	1982-04-27	1982-04-27 00:00:00	1982-04-27	38000177		0	0	28		0	0	0	259023	0	1650142	46233710		
29482	2439	1127433	2018-12-06	2018-12-06 00:00:00	2019-01-10	2019-01-10 00:00:00	2019-01-10	38000177		0	0	35		0	0	0	161797	0	313782	1127433		
38265	3167	1127433	1974-01-23	1974-01-23 00:00:00	1974-02-13	1974-02-13 00:00:00	1974-02-13	38000177		0	0	21		0	0	0	210549	0	313782	1127433		
103124	2261	40213160	1964-04-14	1964-04-14 00:00:00	1964-04-14	1964-04-14 00:00:00	1964-04-14	581452		0	0	0		0	0	0	150318	0	10	40213160		
109750	2411	40213160	1965-03-11	1965-03-11 00:00:00	1965-03-11	1965-03-11 00:00:00	1965-03-11	581452		0	0	0		0	0	0	159978	0	10	40213160		
23431	1928	19019979	1974-03-21	1974-03-21 00:00:00	1974-04-20	1974-04-20 00:00:00	1974-04-20	38000177		0	0	30		0	0	0	128307	0	198405	19019979		
103245	2264	40213306	1991-07-14	1991-07-14 00:00:00	1991-07-14	1991-07-14 00:00:00	1991-07-14	581452		0	0	0		0	0	0	150469	0	43	40213306		
29820	2469	19059056	1971-10-30	1971-10-30 00:00:00	1971-11-13	1971-11-13 00:00:00	1971-11-13	38000177		0	0	14		0	0	0	163736	0	243670	19059056		
156483	3443	40213227	1999-06-09	1999-06-09 00:00:00	1999-06-09	1999-06-09 00:00:00	1999-06-09	581452		0	0	0		0	0	0	228494	0	113	40213227		
46783	3875	19133873	1965-04-16	1965-04-16 00:00:00	1965-04-23	1965-04-23 00:00:00	1965-04-23	38000177		0	0	7		0	0	0	257343	0	834061	19133873		
59571	4952	1127433	1994-07-13	1994-07-13 00:00:00	1994-08-03	1994-08-03 00:00:00	1994-08-03	38000177		0	0	21		0	0	0	329122	0	313782	1127433		
63528	5278	1127433	1987-05-05	1987-05-05 00:00:00	1987-05-19	1987-05-19 00:00:00	1987-05-19	38000177		0	0	14		0	0	0	351117	0	313782	1127433		
61898	5148	40165015	1974-09-30	1974-09-30 00:00:00	1974-09-30	1974-09-30 00:00:00	\N	38000177		0	0	0		0	0	0	342222	0	861467	40165015		
27790	2300	1115171	2017-07-03	2017-07-03 00:00:00	2017-07-17	2017-07-17 00:00:00	2017-07-17	38000177		0	0	14		0	0	0	153168	0	849574	1115171		
191393	4205	40213160	1976-12-18	1976-12-18 00:00:00	1976-12-18	1976-12-18 00:00:00	1976-12-18	581452		0	0	0		0	0	0	279268	0	10	40213160		
128973	2836	40213314	1980-12-08	1980-12-08 00:00:00	1980-12-08	1980-12-08 00:00:00	1980-12-08	581452		0	0	0		0	0	0	188408	0	49	40213314		
55291	4591	1118084	1995-01-26	1995-01-26 00:00:00	1995-01-26	1995-01-26 00:00:00	\N	38000177		0	0	0		0	0	0	305960	0	00025152531	44923712		
10042	842	1127433	2009-01-17	2009-01-17 00:00:00	2009-01-24	2009-01-24 00:00:00	2009-01-24	38000177		0	0	7		0	0	0	55648	0	313782	1127433		
53820	1177	40213296	2005-07-18	2005-07-18 00:00:00	2005-07-18	2005-07-18 00:00:00	2005-07-18	581452		0	0	0		0	0	0	77742	0	52	40213296		
4059	335	1127433	1978-04-23	1978-04-23 00:00:00	1978-04-30	1978-04-30 00:00:00	1978-04-30	38000177		0	0	7		0	0	0	22278	0	313782	1127433		
89137	1954	40213201	2003-01-16	2003-01-16 00:00:00	2003-01-16	2003-01-16 00:00:00	2003-01-16	581452		0	0	0		0	0	0	130042	0	33	40213201		
54566	1194	40213227	1994-10-31	1994-10-31 00:00:00	1994-10-31	1994-10-31 00:00:00	1994-10-31	581452		0	0	0		0	0	0	78741	0	113	40213227		
79666	1743	40213160	1965-10-13	1965-10-13 00:00:00	1965-10-13	1965-10-13 00:00:00	1965-10-13	581452		0	0	0		0	0	0	116562	0	10	40213160		
35172	2902	19059056	1952-06-03	1952-06-03 00:00:00	1952-07-08	1952-07-08 00:00:00	1952-07-08	38000177		0	0	35		0	0	0	193368	0	243670	19059056		
63601	5284	19128065	1982-08-17	1982-08-17 00:00:00	1983-08-12	1983-08-12 00:00:00	1983-08-12	38000177		0	0	360		0	0	0	351527	0	749882	19128065		
16522	1368	19059056	1956-04-20	1956-04-20 00:00:00	1956-05-04	1956-05-04 00:00:00	1956-05-04	38000177		0	0	14		0	0	0	90666	0	243670	19059056		
58135	4829	1118084	2012-06-17	2012-06-17 00:00:00	2012-06-17	2012-06-17 00:00:00	\N	38000177		0	0	0		0	0	0	321321	0	00025152531	44923712		
45781	3789	1115171	2014-12-05	2014-12-05 00:00:00	2015-01-09	2015-01-09 00:00:00	2015-01-09	38000177		0	0	35		0	0	0	251915	0	849574	1115171		
56306	4674	1127433	2001-05-31	2001-05-31 00:00:00	2001-06-14	2001-06-14 00:00:00	2001-06-14	38000177		0	0	14		0	0	0	311381	0	313782	1127433		
31931	2647	1118084	2014-08-19	2014-08-19 00:00:00	2014-08-19	2014-08-19 00:00:00	\N	38000177		0	0	0		0	0	0	175146	0	00025152531	44923712		
30490	665	40213160	1955-12-09	1955-12-09 00:00:00	1955-12-09	1955-12-09 00:00:00	1955-12-09	581452		0	0	0		0	0	0	43996	0	10	40213160		
57541	4776	1127433	1974-06-03	1974-06-03 00:00:00	1974-07-08	1974-07-08 00:00:00	1974-07-08	38000177		0	0	35		0	0	0	318024	0	313782	1127433		
40839	3386	1127078	1978-07-08	1978-07-08 00:00:00	1978-08-05	1978-08-05 00:00:00	1978-08-05	38000177		0	0	28		0	0	0	224628	0	282464	1127078		
7608	640	19006318	1951-06-11	1951-06-11 00:00:00	1951-06-25	1951-06-25 00:00:00	1951-06-25	38000177		0	0	14		0	0	0	42345	0	105078	19006318		
40933	3394	1127433	1972-11-25	1972-11-25 00:00:00	1972-12-02	1972-12-02 00:00:00	1972-12-02	38000177		0	0	7		0	0	0	225162	0	313782	1127433		
181892	3996	40213260	2018-11-13	2018-11-13 00:00:00	2018-11-13	2018-11-13 00:00:00	2018-11-13	581452		0	0	0		0	0	0	265685	0	121	40213260		
166415	3658	40213160	1961-05-14	1961-05-14 00:00:00	1961-05-14	1961-05-14 00:00:00	1961-05-14	581452		0	0	0		0	0	0	243484	0	10	40213160		
60813	5056	1127433	2005-10-12	2005-10-12 00:00:00	2006-01-10	2006-01-10 00:00:00	2006-01-10	38000177		0	0	90		0	0	0	336181	0	313782	1127433		
12586	1058	1127433	1976-09-05	1976-09-05 00:00:00	1976-09-19	1976-09-19 00:00:00	1976-09-19	38000177		0	0	14		0	0	0	69482	0	313782	1127433		
28820	2381	1332419	1996-05-15	1996-05-15 00:00:00	1996-05-15	1996-05-15 00:00:00	\N	38000177		0	0	0		0	0	0	158263	0	197361	1332419		
15459	1289	1115171	2002-12-25	2002-12-25 00:00:00	2003-01-15	2003-01-15 00:00:00	2003-01-15	38000177		0	0	21		0	0	0	85243	0	849574	1115171		
23174	1911	19133905	1989-08-02	1989-08-02 00:00:00	1989-08-11	1989-08-11 00:00:00	1989-08-11	38000177		0	0	9		0	0	0	127127	0	834102	19133905		
81355	1778	40213160	1980-10-25	1980-10-25 00:00:00	1980-10-25	1980-10-25 00:00:00	1980-10-25	581452		0	0	0		0	0	0	118974	0	10	40213160		
33740	2792	1713671	1973-09-19	1973-09-19 00:00:00	1973-10-03	1973-10-03 00:00:00	1973-10-03	38000177		0	0	14		0	0	0	185045	0	562251	1713671		
46121	3822	19133873	1948-01-12	1948-01-12 00:00:00	1948-01-24	1948-01-24 00:00:00	1948-01-24	38000177		0	0	12		0	0	0	253862	0	834061	19133873		
46247	3832	1713671	2016-03-19	2016-03-19 00:00:00	2016-03-26	2016-03-26 00:00:00	2016-03-26	38000177		0	0	7		0	0	0	254440	0	562251	1713671		
22676	492	40213227	2008-09-19	2008-09-19 00:00:00	2008-09-19	2008-09-19 00:00:00	2008-09-19	581452		0	0	0		0	0	0	32975	0	113	40213227		
52706	4381	19059056	1965-04-28	1965-04-28 00:00:00	1965-06-04	1965-06-04 00:00:00	1965-06-04	38000177		0	0	37		0	0	0	291142	0	243670	19059056		
29688	2459	19133873	1984-03-09	1984-03-09 00:00:00	1984-03-16	1984-03-16 00:00:00	1984-03-16	38000177		0	0	7		0	0	0	163030	0	834061	19133873		
122923	2702	40213201	2006-12-17	2006-12-17 00:00:00	2006-12-17	2006-12-17 00:00:00	2006-12-17	581452		0	0	0		0	0	0	179006	0	33	40213201		
63292	5257	1118084	2014-03-21	2014-03-21 00:00:00	2014-03-21	2014-03-21 00:00:00	\N	38000177		0	0	0		0	0	0	349784	0	00025152531	44923712		
51998	4324	1150771	1981-06-30	1981-06-30 00:00:00	1981-06-30	1981-06-30 00:00:00	\N	38000177		0	0	0		0	0	0	286849	0	197378	1150771		
55949	4644	19006318	1968-11-17	1968-11-17 00:00:00	1968-12-01	1968-12-01 00:00:00	1968-12-01	38000177		0	0	14		0	0	0	309690	0	105078	19006318		
35783	2947	19128022	2002-03-10	2002-03-10 00:00:00	2003-03-05	2003-03-05 00:00:00	2003-03-05	38000177		0	0	360		0	0	0	196705	0	749785	19128022		
81751	1786	40213227	2014-12-20	2014-12-20 00:00:00	2014-12-20	2014-12-20 00:00:00	2014-12-20	581452		0	0	0		0	0	0	119693	0	113	40213227		
99298	2174	40213314	1977-12-04	1977-12-04 00:00:00	1977-12-04	1977-12-04 00:00:00	1977-12-04	581452		0	0	0		0	0	0	144901	0	49	40213314		
110634	2431	40213227	1992-10-07	1992-10-07 00:00:00	1992-10-07	1992-10-07 00:00:00	1992-10-07	581452		0	0	0		0	0	0	161212	0	113	40213227		
8190	682	1127078	1974-10-15	1974-10-15 00:00:00	1974-10-29	1974-10-29 00:00:00	1974-10-29	38000177		0	0	14		0	0	0	45148	0	282464	1127078		
61515	5118	40231925	1980-10-08	1980-10-08 00:00:00	1980-10-08	1980-10-08 00:00:00	\N	38000177		0	0	0		0	0	0	340158	0	1049221	40231925		
193682	4255	40213227	1996-02-03	1996-02-03 00:00:00	1996-02-03	1996-02-03 00:00:00	1996-02-03	581452		0	0	0		0	0	0	282553	0	113	40213227		
17877	387	40213296	2013-09-06	2013-09-06 00:00:00	2013-09-06	2013-09-06 00:00:00	2013-09-06	581452		0	0	0		0	0	0	25486	0	52	40213296		
82148	1794	40213227	1993-04-24	1993-04-24 00:00:00	1993-04-24	1993-04-24 00:00:00	1993-04-24	581452		0	0	0		0	0	0	120292	0	113	40213227		
31564	2617	1127433	1956-09-16	1956-09-16 00:00:00	1956-09-23	1956-09-23 00:00:00	1956-09-23	38000177		0	0	7		0	0	0	173042	0	313782	1127433		
54454	4526	1118084	1993-01-17	1993-01-17 00:00:00	1993-01-17	1993-01-17 00:00:00	\N	38000177		0	0	0		0	0	0	301392	0	00025152531	44923712		
47026	3895	1127433	1982-03-30	1982-03-30 00:00:00	1982-04-27	1982-04-27 00:00:00	1982-04-27	38000177		0	0	28		0	0	0	259023	0	313782	1127433		
19755	1626	40163554	1995-08-27	1995-08-27 00:00:00	1995-08-27	1995-08-27 00:00:00	\N	38000177		0	0	0		0	0	0	109233	0	855332	40163554		
38266	3167	1118084	2002-08-14	2002-08-14 00:00:00	2002-08-14	2002-08-14 00:00:00	\N	38000177		0	0	0		0	0	0	210545	0	00025152531	44923712		
161372	3550	40213160	1989-07-01	1989-07-01 00:00:00	1989-07-01	1989-07-01 00:00:00	1989-07-01	581452		0	0	0		0	0	0	235744	0	10	40213160		
109752	2411	40213296	2004-07-08	2004-07-08 00:00:00	2004-07-08	2004-07-08 00:00:00	2004-07-08	581452		0	0	0		0	0	0	160029	0	52	40213296		
23432	1928	19128065	1992-06-24	1992-06-24 00:00:00	1993-06-19	1993-06-19 00:00:00	1993-06-19	38000177		0	0	360		0	0	0	128354	0	749882	19128065		
103250	2264	40213227	2001-12-02	2001-12-02 00:00:00	2001-12-02	2001-12-02 00:00:00	2001-12-02	581452		0	0	0		0	0	0	150472	0	113	40213227		
51188	4253	1713671	2010-08-06	2010-08-06 00:00:00	2010-11-11	2010-11-11 00:00:00	2010-11-11	38000177		0	0	97		0	0	0	282459	0	562251	1713671		
156484	3443	40213306	1999-06-09	1999-06-09 00:00:00	1999-06-09	1999-06-09 00:00:00	1999-06-09	581452		0	0	0		0	0	0	228494	0	43	40213306		
46784	3875	920300	2010-01-23	2010-01-23 00:00:00	2010-01-30	2010-01-30 00:00:00	2010-01-30	38000177		0	0	7		0	0	0	257328	0	311989	920300		
59572	4952	19073188	1994-07-13	1994-07-13 00:00:00	1994-08-03	1994-08-03 00:00:00	1994-08-03	38000177		0	0	21		0	0	0	329122	0	308192	19073188		
63529	5278	1713671	1970-11-08	1970-11-08 00:00:00	1970-11-22	1970-11-22 00:00:00	1970-11-22	38000177		0	0	14		0	0	0	351066	0	562251	1713671		
61911	5150	19059056	1944-09-15	1944-09-15 00:00:00	1944-09-29	1944-09-29 00:00:00	1944-09-29	38000177		0	0	14		0	0	0	342440	0	243670	19059056		
27791	2300	19075001	2017-07-03	2017-07-03 00:00:00	2017-07-17	2017-07-17 00:00:00	2017-07-17	38000177		0	0	14		0	0	0	153168	0	309097	19075001		
191400	4205	40213160	1972-06-17	1972-06-17 00:00:00	1972-06-17	1972-06-17 00:00:00	1972-06-17	581452		0	0	0		0	0	0	279176	0	10	40213160		
191409	4205	40213160	1972-09-16	1972-09-16 00:00:00	1972-09-16	1972-09-16 00:00:00	1972-09-16	581452		0	0	0		0	0	0	279196	0	10	40213160		
55292	4591	19078461	2018-04-08	2018-04-08 00:00:00	2018-04-29	2018-04-29 00:00:00	2018-04-29	38000177		0	0	21		0	0	0	305898	0	310965	19078461		
10043	842	1127433	1914-08-04	1914-08-04 00:00:00	1914-08-18	1914-08-18 00:00:00	1914-08-18	38000177		0	0	14		0	0	0	55676	0	313782	1127433		
69305	1516	40213227	1992-01-27	1992-01-27 00:00:00	1992-01-27	1992-01-27 00:00:00	1992-01-27	581452		0	0	0		0	0	0	101304	0	113	40213227		
4071	337	1118084	1997-07-30	1997-07-30 00:00:00	1997-07-30	1997-07-30 00:00:00	\N	38000177		0	0	0		0	0	0	22410	0	00025152531	44923712		
100421	2200	40213296	2013-06-16	2013-06-16 00:00:00	2013-06-16	2013-06-16 00:00:00	2013-06-16	581452		0	0	0		0	0	0	146659	0	52	40213296		
54570	1194	40213227	2011-09-26	2011-09-26 00:00:00	2011-09-26	2011-09-26 00:00:00	2011-09-26	581452		0	0	0		0	0	0	78682	0	113	40213227		
79674	1743	40213160	1970-01-14	1970-01-14 00:00:00	1970-01-14	1970-01-14 00:00:00	1970-01-14	581452		0	0	0		0	0	0	116472	0	10	40213160		
35173	2902	1115171	1998-08-06	1998-08-06 00:00:00	1998-08-27	1998-08-27 00:00:00	1998-08-27	38000177		0	0	21		0	0	0	193369	0	849574	1115171		
63602	5284	1127433	2010-08-07	2010-08-07 00:00:00	2010-08-21	2010-08-21 00:00:00	2010-08-21	38000177		0	0	14		0	0	0	351598	0	313782	1127433		
16523	1368	19006318	1956-04-20	1956-04-20 00:00:00	1956-05-04	1956-05-04 00:00:00	1956-05-04	38000177		0	0	14		0	0	0	90666	0	105078	19006318		
58136	4829	1127433	2007-10-07	2007-10-07 00:00:00	2007-10-14	2007-10-14 00:00:00	2007-10-14	38000177		0	0	7		0	0	0	321312	0	313782	1127433		
45782	3789	19059056	1963-04-09	1963-04-09 00:00:00	1963-05-09	1963-05-09 00:00:00	1963-05-09	38000177		0	0	30		0	0	0	251911	0	243670	19059056		
56307	4674	19128065	1983-08-12	1983-08-12 00:00:00	1984-08-06	1984-08-06 00:00:00	1984-08-06	38000177		0	0	360		0	0	0	311405	0	749882	19128065		
31933	2647	19133873	1980-10-15	1980-10-15 00:00:00	1980-10-25	1980-10-25 00:00:00	1980-10-25	38000177		0	0	10		0	0	0	175112	0	834061	19133873		
30497	665	40213227	2006-07-07	2006-07-07 00:00:00	2006-07-07	2006-07-07 00:00:00	2006-07-07	581452		0	0	0		0	0	0	43989	0	113	40213227		
57542	4776	40229134	1981-12-10	1981-12-10 00:00:00	1981-12-24	1981-12-24 00:00:00	1981-12-24	38000177		0	0	14		0	0	0	317993	0	1043400	40229134		
40840	3386	19078461	1986-02-24	1986-02-24 00:00:00	1986-03-17	1986-03-17 00:00:00	1986-03-17	38000177		0	0	21		0	0	0	224630	0	310965	19078461		
7609	640	1127433	1974-01-11	1974-01-11 00:00:00	1974-01-18	1974-01-18 00:00:00	1974-01-18	38000177		0	0	7		0	0	0	42351	0	313782	1127433		
40934	3394	40229134	1975-11-19	1975-11-19 00:00:00	1975-11-26	1975-11-26 00:00:00	1975-11-26	38000177		0	0	7		0	0	0	225163	0	1043400	40229134		
181897	3996	40213227	2010-11-23	2010-11-23 00:00:00	2010-11-23	2010-11-23 00:00:00	2010-11-23	581452		0	0	0		0	0	0	265664	0	113	40213227		
166421	3658	40213227	1992-12-20	1992-12-20 00:00:00	1992-12-20	1992-12-20 00:00:00	1992-12-20	581452		0	0	0		0	0	0	\N	0	113	40213227		
60816	5058	1118084	1978-05-18	1978-05-18 00:00:00	1978-05-18	1978-05-18 00:00:00	\N	38000177		0	0	0		0	0	0	336357	0	00025152531	44923712		
12587	1058	1713671	2010-03-01	2010-03-01 00:00:00	2010-03-22	2010-03-22 00:00:00	2010-03-22	38000177		0	0	21		0	0	0	69344	0	562251	1713671		
28821	2381	1127433	2003-10-29	2003-10-29 00:00:00	2003-11-12	2003-11-12 00:00:00	2003-11-12	38000177		0	0	14		0	0	0	158349	0	313782	1127433		
15460	1289	40229134	1996-03-07	1996-03-07 00:00:00	1996-03-14	1996-03-14 00:00:00	1996-03-14	38000177		0	0	7		0	0	0	85196	0	1043400	40229134		
23176	1911	1127433	2002-07-30	2002-07-30 00:00:00	2002-08-13	2002-08-13 00:00:00	2002-08-13	38000177		0	0	14		0	0	0	127145	0	313782	1127433		
81361	1779	40213227	2004-01-29	2004-01-29 00:00:00	2004-01-29	2004-01-29 00:00:00	2004-01-29	581452		0	0	0		0	0	0	119093	0	113	40213227		
33741	2792	19059056	1958-11-01	1958-11-01 00:00:00	1958-12-01	1958-12-01 00:00:00	1958-12-01	38000177		0	0	30		0	0	0	185032	0	243670	19059056		
46122	3822	1127433	1988-07-09	1988-07-09 00:00:00	1988-10-07	1988-10-07 00:00:00	1988-10-07	38000177		0	0	90		0	0	0	253836	0	313782	1127433		
46248	3832	1127433	2006-10-11	2006-10-11 00:00:00	2006-11-15	2006-11-15 00:00:00	2006-11-15	38000177		0	0	35		0	0	0	254428	0	313782	1127433		
22688	492	40213198	2012-10-12	2012-10-12 00:00:00	2012-10-12	2012-10-12 00:00:00	2012-10-12	581452		0	0	0		0	0	0	32976	0	133	40213198		
52707	4381	19059056	1973-02-22	1973-02-22 00:00:00	1973-05-23	1973-05-23 00:00:00	1973-05-23	38000177		0	0	90		0	0	0	291143	0	243670	19059056		
29689	2459	1127433	2015-03-23	2015-03-23 00:00:00	2015-04-06	2015-04-06 00:00:00	2015-04-06	38000177		0	0	14		0	0	0	163063	0	313782	1127433		
236575	5195	40213296	2001-02-14	2001-02-14 00:00:00	2001-02-14	2001-02-14 00:00:00	2001-02-14	581452		0	0	0		0	0	0	345462	0	52	40213296		
63293	5257	19128065	1999-02-03	1999-02-03 00:00:00	2000-01-29	2000-01-29 00:00:00	2000-01-29	38000177		0	0	360		0	0	0	349838	0	749882	19128065		
51999	4324	1713671	2015-10-10	2015-10-10 00:00:00	2015-10-24	2015-10-24 00:00:00	2015-10-24	38000177		0	0	14		0	0	0	286843	0	562251	1713671		
55950	4644	1127078	1968-11-17	1968-11-17 00:00:00	1968-12-01	1968-12-01 00:00:00	1968-12-01	38000177		0	0	14		0	0	0	309690	0	282464	1127078		
35784	2947	1127078	1981-10-12	1981-10-12 00:00:00	1981-11-15	1981-11-15 00:00:00	1981-11-15	38000177		0	0	34		0	0	0	196698	0	282464	1127078		
81767	1786	40213198	2010-11-27	2010-11-27 00:00:00	2010-11-27	2010-11-27 00:00:00	2010-11-27	581452		0	0	0		0	0	0	119691	0	133	40213198		
99300	2174	40213314	1977-06-05	1977-06-05 00:00:00	1977-06-05	1977-06-05 00:00:00	1977-06-05	581452		0	0	0		0	0	0	144920	0	49	40213314		
110636	2431	40213296	2014-11-05	2014-11-05 00:00:00	2014-11-05	2014-11-05 00:00:00	2014-11-05	581452		0	0	0		0	0	0	161242	0	52	40213296		
8191	682	1127433	1982-02-20	1982-02-20 00:00:00	1982-03-06	1982-03-06 00:00:00	1982-03-06	38000177		0	0	14		0	0	0	45187	0	313782	1127433		
61516	5118	19078461	1990-05-19	1990-05-19 00:00:00	1990-06-09	1990-06-09 00:00:00	1990-06-09	38000177		0	0	21		0	0	0	340159	0	310965	19078461		
193683	4255	40213306	1996-02-03	1996-02-03 00:00:00	1996-02-03	1996-02-03 00:00:00	1996-02-03	581452		0	0	0		0	0	0	282553	0	43	40213306		
17881	387	40213227	2004-11-12	2004-11-12 00:00:00	2004-11-12	2004-11-12 00:00:00	2004-11-12	581452		0	0	0		0	0	0	25483	0	113	40213227		
203747	4473	40213160	1972-01-02	1972-01-02 00:00:00	1972-01-02	1972-01-02 00:00:00	1972-01-02	581452		0	0	0		0	0	0	297590	0	10	40213160		
31565	2617	19059056	1953-12-30	1953-12-30 00:00:00	1954-01-13	1954-01-13 00:00:00	1954-01-13	38000177		0	0	14		0	0	0	173065	0	243670	19059056		
54455	4526	1127078	1954-09-04	1954-09-04 00:00:00	1954-09-18	1954-09-18 00:00:00	1954-09-18	38000177		0	0	14		0	0	0	301336	0	282464	1127078		
44140	3654	19133873	1983-02-13	1983-02-13 00:00:00	1983-02-25	1983-02-25 00:00:00	1983-02-25	38000177		0	0	12		0	0	0	243240	0	834061	19133873		
19756	1626	19018935	1995-08-27	1995-08-27 00:00:00	1995-08-27	1995-08-27 00:00:00	\N	38000177		0	0	0		0	0	0	109233	0	197604	19018935		
38267	3167	40229134	1966-07-06	1966-07-06 00:00:00	1966-07-20	1966-07-20 00:00:00	1966-07-20	38000177		0	0	14		0	0	0	210529	0	1043400	40229134		
161373	3550	40213251	1989-07-01	1989-07-01 00:00:00	1989-07-01	1989-07-01 00:00:00	1989-07-01	581452		0	0	0		0	0	0	235744	0	21	40213251		
109755	2411	40213296	2006-07-13	2006-07-13 00:00:00	2006-07-13	2006-07-13 00:00:00	2006-07-13	581452		0	0	0		0	0	0	160011	0	52	40213296		
23433	1928	40165015	2018-02-26	2018-02-26 00:00:00	2018-02-26	2018-02-26 00:00:00	\N	38000177		0	0	0		0	0	0	128324	0	861467	40165015		
103255	2264	40213160	1970-01-18	1970-01-18 00:00:00	1970-01-18	1970-01-18 00:00:00	1970-01-18	581452		0	0	0		0	0	0	150450	0	10	40213160		
51189	4253	19133873	1996-06-30	1996-06-30 00:00:00	1996-07-08	1996-07-08 00:00:00	1996-07-08	38000177		0	0	8		0	0	0	282447	0	834061	19133873		
156486	3443	40213314	1977-08-17	1977-08-17 00:00:00	1977-08-17	1977-08-17 00:00:00	1977-08-17	581452		0	0	0		0	0	0	228463	0	49	40213314		
46785	3875	40236824	2010-01-23	2010-01-23 00:00:00	2010-01-30	2010-01-30 00:00:00	2010-01-30	38000177		0	0	7		0	0	0	257328	0	1094107	40236824		
59573	4952	40162522	1994-07-13	1994-07-13 00:00:00	1994-07-13	1994-07-13 00:00:00	\N	38000177		0	0	0		0	0	0	329122	0	857005	40162522		
63530	5278	19133905	2006-01-24	2006-01-24 00:00:00	2006-02-06	2006-02-06 00:00:00	2006-02-06	38000177		0	0	13		0	0	0	351097	0	834102	19133905		
61912	5150	40229134	1998-09-13	1998-09-13 00:00:00	1998-09-27	1998-09-27 00:00:00	1998-09-27	38000177		0	0	14		0	0	0	342410	0	1043400	40229134		
27792	2300	1127433	2010-08-01	2010-08-01 00:00:00	2010-08-22	2010-08-22 00:00:00	2010-08-22	38000177		0	0	21		0	0	0	153131	0	313782	1127433		
191403	4205	40213227	2003-03-22	2003-03-22 00:00:00	2003-03-22	2003-03-22 00:00:00	2003-03-22	581452		0	0	0		0	0	0	279236	0	113	40213227		
191414	4205	40213296	2014-01-18	2014-01-18 00:00:00	2014-01-18	2014-01-18 00:00:00	2014-01-18	581452		0	0	0		0	0	0	279243	0	52	40213296		
55293	4591	19078461	1989-11-22	1989-11-22 00:00:00	1989-12-06	1989-12-06 00:00:00	1989-12-06	38000177		0	0	14		0	0	0	305896	0	310965	19078461		
10044	842	1118084	1943-05-08	1943-05-08 00:00:00	1943-05-08	1943-05-08 00:00:00	\N	38000177		0	0	0		0	0	0	55602	0	00025152531	44923712		
69312	1516	40213227	2009-05-04	2009-05-04 00:00:00	2009-05-04	2009-05-04 00:00:00	2009-05-04	581452		0	0	0		0	0	0	101355	0	113	40213227		
4072	337	1713671	1978-12-05	1978-12-05 00:00:00	1978-12-19	1978-12-19 00:00:00	1978-12-19	38000177		0	0	14		0	0	0	22458	0	562251	1713671		
54509	1193	40213227	2010-08-26	2010-08-26 00:00:00	2010-08-26	2010-08-26 00:00:00	2010-08-26	581452		0	0	0		0	0	0	78603	0	113	40213227		
54571	1194	40213260	2011-09-26	2011-09-26 00:00:00	2011-09-26	2011-09-26 00:00:00	2011-09-26	581452		0	0	0		0	0	0	78682	0	121	40213260		
79677	1743	40213260	2015-02-04	2015-02-04 00:00:00	2015-02-04	2015-02-04 00:00:00	2015-02-04	581452		0	0	0		0	0	0	116582	0	121	40213260		
35174	2902	1127078	1953-02-04	1953-02-04 00:00:00	1953-02-18	1953-02-18 00:00:00	1953-02-18	38000177		0	0	14		0	0	0	193313	0	282464	1127078		
63603	5284	40165015	1997-04-13	1997-04-13 00:00:00	1997-04-13	1997-04-13 00:00:00	\N	38000177		0	0	0		0	0	0	351517	0	861467	40165015		
16537	1371	19133905	2008-11-13	2008-11-13 00:00:00	2008-11-21	2008-11-21 00:00:00	2008-11-21	38000177		0	0	8		0	0	0	90915	0	834102	19133905		
58137	4829	19128022	1996-10-09	1996-10-09 00:00:00	1997-10-04	1997-10-04 00:00:00	1997-10-04	38000177		0	0	360		0	0	0	321334	0	749785	19128022		
45784	3789	1713671	2016-12-29	2016-12-29 00:00:00	2017-01-19	2017-01-19 00:00:00	2017-01-19	38000177		0	0	21		0	0	0	251927	0	562251	1713671		
56308	4674	19059056	1971-09-04	1971-09-04 00:00:00	1971-10-02	1971-10-02 00:00:00	1971-10-02	38000177		0	0	28		0	0	0	311378	0	243670	19059056		
31934	2647	19133873	1977-02-23	1977-02-23 00:00:00	1977-03-04	1977-03-04 00:00:00	1977-03-04	38000177		0	0	9		0	0	0	175111	0	834061	19133873		
30498	665	40213260	2006-07-07	2006-07-07 00:00:00	2006-07-07	2006-07-07 00:00:00	2006-07-07	581452		0	0	0		0	0	0	43989	0	121	40213260		
57543	4776	19129655	1964-12-22	1964-12-22 00:00:00	1965-01-05	1965-01-05 00:00:00	1965-01-05	38000177		0	0	14		0	0	0	317999	0	789980	19129655		
40841	3386	1124300	2007-09-08	2007-09-08 00:00:00	2007-09-08	2007-09-08 00:00:00	\N	38000177		0	0	0		0	0	0	224619	0	00781178901	45011828		
7610	640	1127433	1962-09-11	1962-09-11 00:00:00	1962-10-02	1962-10-02 00:00:00	1962-10-02	38000177		0	0	21		0	0	0	42329	0	313782	1127433		
40935	3394	1713671	1971-09-06	1971-09-06 00:00:00	1971-09-13	1971-09-13 00:00:00	1971-09-13	38000177		0	0	7		0	0	0	225112	0	562251	1713671		
181898	3996	40213296	2010-11-23	2010-11-23 00:00:00	2010-11-23	2010-11-23 00:00:00	2010-11-23	581452		0	0	0		0	0	0	265664	0	52	40213296		
166429	3658	40213260	2010-12-05	2010-12-05 00:00:00	2010-12-05	2010-12-05 00:00:00	2010-12-05	581452		0	0	0		0	0	0	243513	0	121	40213260		
60817	5058	19059056	1943-08-05	1943-08-05 00:00:00	1943-09-09	1943-09-09 00:00:00	1943-09-09	38000177		0	0	35		0	0	0	336342	0	243670	19059056		
28704	624	40213227	2012-05-05	2012-05-05 00:00:00	2012-05-05	2012-05-05 00:00:00	2012-05-05	581452		0	0	0		0	0	0	41715	0	113	40213227		
28822	2381	19059056	1939-05-02	1939-05-02 00:00:00	1939-05-16	1939-05-16 00:00:00	1939-05-16	38000177		0	0	14		0	0	0	158246	0	243670	19059056		
15461	1289	1127078	1964-08-14	1964-08-14 00:00:00	1964-08-28	1964-08-28 00:00:00	1964-08-28	38000177		0	0	14		0	0	0	85188	0	282464	1127078		
23178	1911	1127433	1960-03-12	1960-03-12 00:00:00	1960-06-10	1960-06-10 00:00:00	1960-06-10	38000177		0	0	90		0	0	0	127175	0	313782	1127433		
81363	1779	40213227	2013-11-28	2013-11-28 00:00:00	2013-11-28	2013-11-28 00:00:00	2013-11-28	581452		0	0	0		0	0	0	118983	0	113	40213227		
33742	2792	19078461	2008-07-25	2008-07-25 00:00:00	2008-08-15	2008-08-15 00:00:00	2008-08-15	38000177		0	0	21		0	0	0	185041	0	310965	19078461		
46123	3822	19126352	2009-03-23	2009-03-23 00:00:00	2009-03-23	2009-03-23 00:00:00	\N	38000177		0	0	0		0	0	0	253896	0	705129	19126352		
46249	3832	1127078	1985-11-02	1985-11-02 00:00:00	1985-11-16	1985-11-16 00:00:00	1985-11-16	38000177		0	0	14		0	0	0	254459	0	282464	1127078		
22712	492	40213201	2013-10-18	2013-10-18 00:00:00	2013-10-18	2013-10-18 00:00:00	2013-10-18	581452		0	0	0		0	0	0	32903	0	33	40213201		
52708	4381	1118084	2005-11-04	2005-11-04 00:00:00	2005-11-04	2005-11-04 00:00:00	\N	38000177		0	0	0		0	0	0	291140	0	00025152531	44923712		
29690	2459	19059056	1980-06-30	1980-06-30 00:00:00	1980-07-14	1980-07-14 00:00:00	1980-07-14	38000177		0	0	14		0	0	0	163033	0	243670	19059056		
236578	5195	40213306	1982-04-21	1982-04-21 00:00:00	1982-04-21	1982-04-21 00:00:00	1982-04-21	581452		0	0	0		0	0	0	345414	0	43	40213306		
63294	5257	19078461	2014-04-03	2014-04-03 00:00:00	2014-06-09	2014-06-09 00:00:00	2014-06-09	38000177		0	0	67		0	0	0	349786	0	310965	19078461		
52000	4325	1127433	1996-08-30	1996-08-30 00:00:00	1996-09-06	1996-09-06 00:00:00	1996-09-06	38000177		0	0	7		0	0	0	286882	0	313782	1127433		
55951	4644	19126352	1990-11-22	1990-11-22 00:00:00	1990-11-22	1990-11-22 00:00:00	\N	38000177		0	0	0		0	0	0	309632	0	705129	19126352		
35785	2947	43012754	2003-03-05	2003-03-05 00:00:00	2004-02-28	2004-02-28 00:00:00	2004-02-28	38000177		0	0	360		0	0	0	196706	0	1366343	43012754		
81772	1786	40213201	2009-11-21	2009-11-21 00:00:00	2009-11-21	2009-11-21 00:00:00	2009-11-21	581452		0	0	0		0	0	0	119675	0	33	40213201		
99303	2174	40213160	1979-06-10	1979-06-10 00:00:00	1979-06-10	1979-06-10 00:00:00	1979-06-10	581452		0	0	0		0	0	0	144902	0	10	40213160		
110638	2431	40213160	1971-12-29	1971-12-29 00:00:00	1971-12-29	1971-12-29 00:00:00	1971-12-29	581452		0	0	0		0	0	0	161237	0	10	40213160		
8199	685	1118084	2000-06-18	2000-06-18 00:00:00	2000-06-18	2000-06-18 00:00:00	\N	38000177		0	0	0		0	0	0	45324	0	00025152531	44923712		
61517	5118	1551192	1968-10-11	1968-10-11 00:00:00	1968-10-11	1968-10-11 00:00:00	1968-10-11	38000177		0	0	0		0	0	0	340156	0	312617	1551192		
193690	4255	40213160	1978-04-08	1978-04-08 00:00:00	1978-04-08	1978-04-08 00:00:00	1978-04-08	581452		0	0	0		0	0	0	282535	0	10	40213160		
17886	387	40213160	1973-12-07	1973-12-07 00:00:00	1973-12-07	1973-12-07 00:00:00	1973-12-07	581452		0	0	0		0	0	0	25451	0	10	40213160		
203752	4473	40213296	2015-05-17	2015-05-17 00:00:00	2015-05-17	2015-05-17 00:00:00	2015-05-17	581452		0	0	0		0	0	0	297582	0	52	40213296		
31566	2617	19006318	1953-12-30	1953-12-30 00:00:00	1954-01-13	1954-01-13 00:00:00	1954-01-13	38000177		0	0	14		0	0	0	173065	0	105078	19006318		
54456	4526	19006318	1954-09-04	1954-09-04 00:00:00	1954-09-18	1954-09-18 00:00:00	1954-09-18	38000177		0	0	14		0	0	0	301336	0	105078	19006318		
44141	3654	1127433	1985-04-06	1985-04-06 00:00:00	1985-04-20	1985-04-20 00:00:00	1985-04-20	38000177		0	0	14		0	0	0	243201	0	313782	1127433		
19757	1626	40171902	1995-08-27	1995-08-27 00:00:00	1995-08-27	1995-08-27 00:00:00	\N	38000177		0	0	0		0	0	0	109233	0	897718	40171902		
38268	3167	1713671	2008-09-07	2008-09-07 00:00:00	2008-09-21	2008-09-21 00:00:00	2008-09-21	38000177		0	0	14		0	0	0	210596	0	562251	1713671		
8020	173	40213296	2009-02-22	2009-02-22 00:00:00	2009-02-22	2009-02-22 00:00:00	2009-02-22	581452		0	0	0		0	0	0	11750	0	52	40213296		
109757	2411	40213227	2006-07-13	2006-07-13 00:00:00	2006-07-13	2006-07-13 00:00:00	2006-07-13	581452		0	0	0		0	0	0	160011	0	113	40213227		
23434	1929	1127433	2016-11-03	2016-11-03 00:00:00	2016-11-17	2016-11-17 00:00:00	2016-11-17	38000177		0	0	14		0	0	0	128393	0	313782	1127433		
103261	2264	40213160	1974-04-21	1974-04-21 00:00:00	1974-04-21	1974-04-21 00:00:00	1974-04-21	581452		0	0	0		0	0	0	150464	0	10	40213160		
51190	4253	19128022	1996-12-08	1996-12-08 00:00:00	1997-12-03	1997-12-03 00:00:00	1997-12-03	38000177		0	0	360		0	0	0	282462	0	749785	19128022		
156487	3443	40213160	1977-08-17	1977-08-17 00:00:00	1977-08-17	1977-08-17 00:00:00	1977-08-17	581452		0	0	0		0	0	0	228463	0	10	40213160		
46786	3875	19078461	2004-02-09	2004-02-09 00:00:00	2004-03-15	2004-03-15 00:00:00	2004-03-15	38000177		0	0	35		0	0	0	257381	0	310965	19078461		
23739	1952	19128065	1974-07-02	1974-07-02 00:00:00	1975-06-27	1975-06-27 00:00:00	1975-06-27	38000177		0	0	360		0	0	0	129846	0	749882	19128065		
63531	5278	40169216	1973-05-15	1973-05-15 00:00:00	1973-05-15	1973-05-15 00:00:00	\N	38000177		0	0	0		0	0	0	351068	0	895994	40169216		
37679	822	40213227	2001-08-03	2001-08-03 00:00:00	2001-08-03	2001-08-03 00:00:00	2001-08-03	581452		0	0	0		0	0	0	54477	0	113	40213227		
27793	2300	1127433	2018-03-13	2018-03-13 00:00:00	2018-04-17	2018-04-17 00:00:00	2018-04-17	38000177		0	0	35		0	0	0	153132	0	313782	1127433		
191405	4205	40213160	1972-04-15	1972-04-15 00:00:00	1972-04-15	1972-04-15 00:00:00	1972-04-15	581452		0	0	0		0	0	0	279195	0	10	40213160		
191416	4205	40213227	2014-01-18	2014-01-18 00:00:00	2014-01-18	2014-01-18 00:00:00	2014-01-18	581452		0	0	0		0	0	0	279243	0	113	40213227		
55294	4591	1127433	1982-10-05	1982-10-05 00:00:00	1982-10-19	1982-10-19 00:00:00	1982-10-19	38000177		0	0	14		0	0	0	305925	0	313782	1127433		
10045	842	1713671	1942-03-15	1942-03-15 00:00:00	1942-03-22	1942-03-22 00:00:00	1942-03-22	38000177		0	0	7		0	0	0	55602	0	562251	1713671		
69318	1516	40213227	1999-03-08	1999-03-08 00:00:00	1999-03-08	1999-03-08 00:00:00	1999-03-08	581452		0	0	0		0	0	0	101329	0	113	40213227		
4073	337	19133905	1980-11-02	1980-11-02 00:00:00	1980-11-11	1980-11-11 00:00:00	1980-11-11	38000177		0	0	9		0	0	0	22446	0	834102	19133905		
54515	1193	40213201	2015-09-24	2015-09-24 00:00:00	2015-09-24	2015-09-24 00:00:00	2015-09-24	581452		0	0	0		0	0	0	78653	0	33	40213201		
54575	1194	40213306	1982-10-18	1982-10-18 00:00:00	1982-10-18	1982-10-18 00:00:00	1982-10-18	581452		0	0	0		0	0	0	78711	0	43	40213306		
79684	1743	40213160	1965-07-14	1965-07-14 00:00:00	1965-07-14	1965-07-14 00:00:00	1965-07-14	581452		0	0	0		0	0	0	116469	0	10	40213160		
35175	2902	19006318	1953-02-04	1953-02-04 00:00:00	1953-02-18	1953-02-18 00:00:00	1953-02-18	38000177		0	0	14		0	0	0	193313	0	105078	19006318		
63604	5284	19078461	1997-04-13	1997-04-13 00:00:00	1997-07-12	1997-07-12 00:00:00	1997-07-12	38000177		0	0	90		0	0	0	351517	0	310965	19078461		
16539	1371	19006318	1972-07-06	1972-07-06 00:00:00	1972-07-20	1972-07-20 00:00:00	1972-07-20	38000177		0	0	14		0	0	0	90904	0	105078	19006318		
58138	4829	19128022	1994-10-20	1994-10-20 00:00:00	1995-10-15	1995-10-15 00:00:00	1995-10-15	38000177		0	0	360		0	0	0	321325	0	749785	19128022		
45786	3789	1127433	1970-10-29	1970-10-29 00:00:00	1970-11-26	1970-11-26 00:00:00	1970-11-26	38000177		0	0	28		0	0	0	251913	0	313782	1127433		
56309	4674	1124300	2005-04-28	2005-04-28 00:00:00	2005-04-28	2005-04-28 00:00:00	\N	38000177		0	0	0		0	0	0	311359	0	00781178901	45011828		
31935	2647	19128022	1989-11-13	1989-11-13 00:00:00	1990-11-08	1990-11-08 00:00:00	1990-11-08	38000177		0	0	360		0	0	0	175121	0	749785	19128022		
30504	665	40213160	1956-03-09	1956-03-09 00:00:00	1956-03-09	1956-03-09 00:00:00	1956-03-09	581452		0	0	0		0	0	0	43985	0	10	40213160		
57544	4776	19059056	1964-12-22	1964-12-22 00:00:00	1965-01-05	1965-01-05 00:00:00	1965-01-05	38000177		0	0	14		0	0	0	317999	0	243670	19059056		
40842	3386	1713671	2006-07-18	2006-07-18 00:00:00	2006-07-25	2006-07-25 00:00:00	2006-07-25	38000177		0	0	7		0	0	0	224619	0	562251	1713671		
7611	640	46233710	1980-05-15	1980-05-15 00:00:00	1980-05-29	1980-05-29 00:00:00	1980-05-29	38000177		0	0	14		0	0	0	42356	0	1650142	46233710		
40936	3394	1127433	2016-02-17	2016-02-17 00:00:00	2016-03-02	2016-03-02 00:00:00	2016-03-02	38000177		0	0	14		0	0	0	225120	0	313782	1127433		
181904	3996	40213160	1969-02-18	1969-02-18 00:00:00	1969-02-18	1969-02-18 00:00:00	1969-02-18	581452		0	0	0		0	0	0	265658	0	10	40213160		
166433	3658	40213306	1982-12-12	1982-12-12 00:00:00	1982-12-12	1982-12-12 00:00:00	1982-12-12	581452		0	0	0		0	0	0	243510	0	43	40213306		
60818	5058	19078461	2011-10-31	2011-10-31 00:00:00	2011-11-30	2011-11-30 00:00:00	2011-11-30	38000177		0	0	30		0	0	0	336347	0	310965	19078461		
28713	624	40213227	1992-01-11	1992-01-11 00:00:00	1992-01-11	1992-01-11 00:00:00	1992-01-11	581452		0	0	0		0	0	0	41703	0	113	40213227		
28823	2381	1118084	1973-04-28	1973-04-28 00:00:00	1973-04-28	1973-04-28 00:00:00	\N	38000177		0	0	0		0	0	0	158317	0	00025152531	44923712		
15462	1289	19006318	1964-08-14	1964-08-14 00:00:00	1964-08-28	1964-08-28 00:00:00	1964-08-28	38000177		0	0	14		0	0	0	85188	0	105078	19006318		
23179	1911	40229134	1959-11-23	1959-11-23 00:00:00	1959-12-07	1959-12-07 00:00:00	1959-12-07	38000177		0	0	14		0	0	0	127097	0	1043400	40229134		
5531	461	19133873	1958-03-06	1958-03-06 00:00:00	1958-03-15	1958-03-15 00:00:00	1958-03-15	38000177		0	0	9		0	0	0	30828	0	834061	19133873		
33743	2792	19059056	1961-09-16	1961-09-16 00:00:00	1961-11-15	1961-11-15 00:00:00	1961-11-15	38000177		0	0	60		0	0	0	185033	0	243670	19059056		
46124	3822	1539411	2009-03-23	2009-03-23 00:00:00	2009-03-23	2009-03-23 00:00:00	\N	38000177		0	0	0		0	0	0	253896	0	312961	1539411		
46250	3832	1115171	2001-01-26	2001-01-26 00:00:00	2001-02-09	2001-02-09 00:00:00	2001-02-09	38000177		0	0	14		0	0	0	254461	0	849574	1115171		
22716	492	40213227	2018-11-16	2018-11-16 00:00:00	2018-11-16	2018-11-16 00:00:00	2018-11-16	581452		0	0	0		0	0	0	32934	0	113	40213227		
52709	4381	1127433	2012-11-20	2012-11-20 00:00:00	2012-12-04	2012-12-04 00:00:00	2012-12-04	38000177		0	0	14		0	0	0	291074	0	313782	1127433		
29691	2459	19073183	1980-06-30	1980-06-30 00:00:00	1980-07-14	1980-07-14 00:00:00	1980-07-14	38000177		0	0	14		0	0	0	163033	0	308182	19073183		
236581	5195	40213227	2011-03-16	2011-03-16 00:00:00	2011-03-16	2011-03-16 00:00:00	2011-03-16	581452		0	0	0		0	0	0	345419	0	113	40213227		
63295	5257	40165015	2014-04-10	2014-04-10 00:00:00	2014-04-10	2014-04-10 00:00:00	\N	38000177		0	0	0		0	0	0	349844	0	861467	40165015		
52001	4325	1713671	1972-08-09	1972-08-09 00:00:00	1972-08-23	1972-08-23 00:00:00	1972-08-23	38000177		0	0	14		0	0	0	286886	0	562251	1713671		
55952	4644	19075601	1999-12-02	1999-12-02 00:00:00	1999-12-02	1999-12-02 00:00:00	\N	38000177		0	0	0		0	0	0	309635	0	309362	19075601		
35786	2947	1127433	1998-09-09	1998-09-09 00:00:00	1998-10-14	1998-10-14 00:00:00	1998-10-14	38000177		0	0	35		0	0	0	196700	0	313782	1127433		
99238	2173	40213227	1992-09-15	1992-09-15 00:00:00	1992-09-15	1992-09-15 00:00:00	1992-09-15	581452		0	0	0		0	0	0	144717	0	113	40213227		
99312	2175	40213314	1977-01-06	1977-01-06 00:00:00	1977-01-06	1977-01-06 00:00:00	1977-01-06	581452		0	0	0		0	0	0	145023	0	49	40213314		
110644	2431	40213160	1972-03-29	1972-03-29 00:00:00	1972-03-29	1972-03-29 00:00:00	1972-03-29	581452		0	0	0		0	0	0	161193	0	10	40213160		
8200	685	1713671	1968-05-04	1968-05-04 00:00:00	1968-05-25	1968-05-25 00:00:00	1968-05-25	38000177		0	0	21		0	0	0	45330	0	562251	1713671		
61518	5118	19133873	1968-11-27	1968-11-27 00:00:00	1968-12-08	1968-12-08 00:00:00	1968-12-08	38000177		0	0	11		0	0	0	340210	0	834061	19133873		
193695	4255	40213227	2015-05-09	2015-05-09 00:00:00	2015-05-09	2015-05-09 00:00:00	2015-05-09	581452		0	0	0		0	0	0	282501	0	113	40213227		
17887	387	40213314	1977-02-04	1977-02-04 00:00:00	1977-02-04	1977-02-04 00:00:00	1977-02-04	581452		0	0	0		0	0	0	25497	0	49	40213314		
203755	4473	40213160	1976-07-04	1976-07-04 00:00:00	1976-07-04	1976-07-04 00:00:00	1976-07-04	581452		0	0	0		0	0	0	297578	0	10	40213160		
31567	2617	1118084	1987-07-15	1987-07-15 00:00:00	1987-07-15	1987-07-15 00:00:00	\N	38000177		0	0	0		0	0	0	173074	0	00025152531	44923712		
54457	4526	19133873	1954-12-17	1954-12-17 00:00:00	1954-12-28	1954-12-28 00:00:00	1954-12-28	38000177		0	0	11		0	0	0	301328	0	834061	19133873		
44142	3654	1124300	2004-10-17	2004-10-17 00:00:00	2004-10-17	2004-10-17 00:00:00	\N	38000177		0	0	0		0	0	0	243241	0	00781178901	45011828		
19758	1626	1127433	1977-07-22	1977-07-22 00:00:00	1977-08-19	1977-08-19 00:00:00	1977-08-19	38000177		0	0	28		0	0	0	109188	0	313782	1127433		
38269	3167	1127433	2006-08-29	2006-08-29 00:00:00	2006-09-26	2006-09-26 00:00:00	2006-09-26	38000177		0	0	28		0	0	0	210552	0	313782	1127433		
8028	173	40213160	1968-09-01	1968-09-01 00:00:00	1968-09-01	1968-09-01 00:00:00	1968-09-01	581452		0	0	0		0	0	0	11792	0	10	40213160		
109770	2411	40213306	1986-09-04	1986-09-04 00:00:00	1986-09-04	1986-09-04 00:00:00	1986-09-04	581452		0	0	0		0	0	0	159984	0	43	40213306		
23435	1929	1127078	1954-09-18	1954-09-18 00:00:00	1954-10-02	1954-10-02 00:00:00	1954-10-02	38000177		0	0	14		0	0	0	128453	0	282464	1127078		
135243	2969	40213160	1970-01-01	1970-01-01 00:00:00	1970-01-01	1970-01-01 00:00:00	1970-01-01	581452		0	0	0		0	0	0	198236	0	10	40213160		
51191	4253	1115171	2010-08-16	2010-08-16 00:00:00	2010-08-30	2010-08-30 00:00:00	2010-08-30	38000177		0	0	14		0	0	0	282428	0	849574	1115171		
151144	3325	40213160	1964-02-26	1964-02-26 00:00:00	1964-02-26	1964-02-26 00:00:00	1964-02-26	581452		0	0	0		0	0	0	220716	0	10	40213160		
46787	3875	1127433	1982-02-09	1982-02-09 00:00:00	1982-02-23	1982-02-23 00:00:00	1982-02-23	38000177		0	0	14		0	0	0	257395	0	313782	1127433		
23740	1952	19078461	2012-08-28	2012-08-28 00:00:00	2012-09-18	2012-09-18 00:00:00	2012-09-18	38000177		0	0	21		0	0	0	129790	0	310965	19078461		
63532	5278	1154615	1973-05-15	1973-05-15 00:00:00	1973-05-15	1973-05-15 00:00:00	\N	38000177		0	0	0		0	0	0	351068	0	745679	1154615		
37682	822	40213296	2010-05-21	2010-05-21 00:00:00	2010-05-21	2010-05-21 00:00:00	2010-05-21	581452		0	0	0		0	0	0	54495	0	52	40213296		
27794	2300	19059056	1993-02-28	1993-02-28 00:00:00	1993-03-28	1993-03-28 00:00:00	1993-03-28	38000177		0	0	28		0	0	0	153129	0	243670	19059056		
108479	2380	40213201	2017-02-04	2017-02-04 00:00:00	2017-02-04	2017-02-04 00:00:00	2017-02-04	581452		0	0	0		0	0	0	158168	0	33	40213201		
191422	4205	40213227	1994-03-12	1994-03-12 00:00:00	1994-03-12	1994-03-12 00:00:00	1994-03-12	581452		0	0	0		0	0	0	279202	0	113	40213227		
55295	4591	1713671	1989-01-28	1989-01-28 00:00:00	1989-02-04	1989-02-04 00:00:00	1989-02-04	38000177		0	0	7		0	0	0	305926	0	562251	1713671		
10046	842	19059056	1940-08-16	1940-08-16 00:00:00	1940-09-15	1940-09-15 00:00:00	1940-09-15	38000177		0	0	30		0	0	0	55708	0	243670	19059056		
77694	1699	40213160	1966-09-11	1966-09-11 00:00:00	1966-09-11	1966-09-11 00:00:00	1966-09-11	581452		0	0	0		0	0	0	113676	0	10	40213160		
4074	337	1127078	1962-06-09	1962-06-09 00:00:00	1962-09-07	1962-09-07 00:00:00	1962-09-07	38000177		0	0	90		0	0	0	22471	0	282464	1127078		
54537	1193	40213198	2014-09-18	2014-09-18 00:00:00	2014-09-18	2014-09-18 00:00:00	2014-09-18	581452		0	0	0		0	0	0	78614	0	133	40213198		
54576	1194	40213296	2001-04-09	2001-04-09 00:00:00	2001-04-09	2001-04-09 00:00:00	2001-04-09	581452		0	0	0		0	0	0	78675	0	52	40213296		
79688	1743	40213306	1987-04-08	1987-04-08 00:00:00	1987-04-08	1987-04-08 00:00:00	1987-04-08	581452		0	0	0		0	0	0	116536	0	43	40213306		
35176	2902	1118084	1991-04-10	1991-04-10 00:00:00	1991-04-10	1991-04-10 00:00:00	\N	38000177		0	0	0		0	0	0	193270	0	00025152531	44923712		
63605	5284	1713671	2006-08-24	2006-08-24 00:00:00	2006-09-14	2006-09-14 00:00:00	2006-09-14	38000177		0	0	21		0	0	0	351526	0	562251	1713671		
16540	1371	1127078	1972-07-06	1972-07-06 00:00:00	1972-07-20	1972-07-20 00:00:00	1972-07-20	38000177		0	0	14		0	0	0	90904	0	282464	1127078		
58139	4829	19128022	1997-10-04	1997-10-04 00:00:00	1998-09-29	1998-09-29 00:00:00	1998-09-29	38000177		0	0	360		0	0	0	321335	0	749785	19128022		
45787	3789	19059056	1945-08-11	1945-08-11 00:00:00	1945-08-25	1945-08-25 00:00:00	1945-08-25	38000177		0	0	14		0	0	0	251886	0	243670	19059056		
56310	4674	40229134	2006-04-17	2006-04-17 00:00:00	2006-04-24	2006-04-24 00:00:00	2006-04-24	38000177		0	0	7		0	0	0	311366	0	1043400	40229134		
31936	2647	1713671	2000-12-07	2000-12-07 00:00:00	2000-12-14	2000-12-14 00:00:00	2000-12-14	38000177		0	0	7		0	0	0	175163	0	562251	1713671		
30509	665	40213227	2016-09-30	2016-09-30 00:00:00	2016-09-30	2016-09-30 00:00:00	2016-09-30	581452		0	0	0		0	0	0	44004	0	113	40213227		
57545	4777	1713671	2010-06-17	2010-06-17 00:00:00	2010-07-15	2010-07-15 00:00:00	2010-07-15	38000177		0	0	28		0	0	0	318060	0	562251	1713671		
40843	3386	19128065	1988-10-27	1988-10-27 00:00:00	1989-10-22	1989-10-22 00:00:00	1989-10-22	38000177		0	0	360		0	0	0	224621	0	749882	19128065		
7612	640	1127433	1980-05-15	1980-05-15 00:00:00	1980-05-29	1980-05-29 00:00:00	1980-05-29	38000177		0	0	14		0	0	0	42356	0	313782	1127433		
40937	3394	19128065	1985-08-30	1985-08-30 00:00:00	1986-08-25	1986-08-25 00:00:00	1986-08-25	38000177		0	0	360		0	0	0	225157	0	749882	19128065		
181907	3996	40213160	1969-07-22	1969-07-22 00:00:00	1969-07-22	1969-07-22 00:00:00	1969-07-22	581452		0	0	0		0	0	0	265659	0	10	40213160		
166435	3658	40213260	2011-12-11	2011-12-11 00:00:00	2011-12-11	2011-12-11 00:00:00	2011-12-11	581452		0	0	0		0	0	0	243501	0	121	40213260		
60819	5058	1713671	2001-10-16	2001-10-16 00:00:00	2001-10-23	2001-10-23 00:00:00	2001-10-23	38000177		0	0	7		0	0	0	336307	0	562251	1713671		
58956	4898	1127433	1954-03-14	1954-03-14 00:00:00	1954-03-28	1954-03-28 00:00:00	1954-03-28	38000177		0	0	14		0	0	0	325663	0	313782	1127433		
28824	2381	19133873	1945-12-16	1945-12-16 00:00:00	1945-12-25	1945-12-25 00:00:00	1945-12-25	38000177		0	0	9		0	0	0	158292	0	834061	19133873		
235103	5165	40213160	1964-08-21	1964-08-21 00:00:00	1964-08-21	1964-08-21 00:00:00	1964-08-21	581452		0	0	0		0	0	0	343312	0	10	40213160		
23180	1911	1127433	1957-06-28	1957-06-28 00:00:00	1957-07-05	1957-07-05 00:00:00	1957-07-05	38000177		0	0	7		0	0	0	127165	0	313782	1127433		
5532	461	1118084	1985-01-04	1985-01-04 00:00:00	1985-01-04	1985-01-04 00:00:00	\N	38000177		0	0	0		0	0	0	30839	0	00025152531	44923712		
33744	2792	1713671	1959-05-08	1959-05-08 00:00:00	1959-05-29	1959-05-29 00:00:00	1959-05-29	38000177		0	0	21		0	0	0	184987	0	562251	1713671		
46125	3822	19075601	2009-03-23	2009-03-23 00:00:00	2009-03-23	2009-03-23 00:00:00	\N	38000177		0	0	0		0	0	0	253896	0	309362	19075601		
46251	3832	1127078	1991-12-31	1991-12-31 00:00:00	1992-01-14	1992-01-14 00:00:00	1992-01-14	38000177		0	0	14		0	0	0	254443	0	282464	1127078		
34457	753	40213227	2019-04-21	2019-04-21 00:00:00	2019-04-21	2019-04-21 00:00:00	2019-04-21	581452		0	0	0		0	0	0	49795	0	113	40213227		
52710	4381	1713671	2013-08-01	2013-08-01 00:00:00	2013-08-15	2013-08-15 00:00:00	2013-08-15	38000177		0	0	14		0	0	0	291075	0	562251	1713671		
29692	2459	19128065	1993-06-06	1993-06-06 00:00:00	1994-06-01	1994-06-01 00:00:00	1994-06-01	38000177		0	0	360		0	0	0	163015	0	749882	19128065		
236582	5195	40213260	2011-03-16	2011-03-16 00:00:00	2011-03-16	2011-03-16 00:00:00	2011-03-16	581452		0	0	0		0	0	0	345419	0	121	40213260		
63296	5257	1127078	1989-02-13	1989-02-13 00:00:00	1989-05-14	1989-05-14 00:00:00	1989-05-14	38000177		0	0	90		0	0	0	349843	0	282464	1127078		
52002	4325	1127433	2014-08-19	2014-08-19 00:00:00	2014-09-02	2014-09-02 00:00:00	2014-09-02	38000177		0	0	14		0	0	0	286888	0	313782	1127433		
55953	4644	46233988	1968-01-26	1968-01-26 00:00:00	1968-02-09	1968-02-09 00:00:00	1968-02-09	38000177		0	0	14		0	0	0	309681	0	1652673	46233988		
35787	2947	19128065	2001-03-15	2001-03-15 00:00:00	2002-03-10	2002-03-10 00:00:00	2002-03-10	38000177		0	0	360		0	0	0	196704	0	749882	19128065		
99251	2173	40213227	2012-01-03	2012-01-03 00:00:00	2012-01-03	2012-01-03 00:00:00	2012-01-03	581452		0	0	0		0	0	0	144838	0	113	40213227		
99315	2175	40213227	2017-02-16	2017-02-16 00:00:00	2017-02-16	2017-02-16 00:00:00	2017-02-16	581452		0	0	0		0	0	0	144951	0	113	40213227		
110396	2425	40213227	1994-03-17	1994-03-17 00:00:00	1994-03-17	1994-03-17 00:00:00	1994-03-17	581452		0	0	0		0	0	0	160899	0	113	40213227		
8201	685	1127433	1991-03-24	1991-03-24 00:00:00	1991-04-07	1991-04-07 00:00:00	1991-04-07	38000177		0	0	14		0	0	0	45306	0	313782	1127433		
61519	5119	1127433	1985-04-02	1985-04-02 00:00:00	1985-04-16	1985-04-16 00:00:00	1985-04-16	38000177		0	0	14		0	0	0	340351	0	313782	1127433		
193696	4255	40213296	2015-05-09	2015-05-09 00:00:00	2015-05-09	2015-05-09 00:00:00	2015-05-09	581452		0	0	0		0	0	0	282501	0	52	40213296		
17889	387	40213160	1974-05-10	1974-05-10 00:00:00	1974-05-10	1974-05-10 00:00:00	1974-05-10	581452		0	0	0		0	0	0	25452	0	10	40213160		
203761	4473	40213160	1972-04-02	1972-04-02 00:00:00	1972-04-02	1972-04-02 00:00:00	1972-04-02	581452		0	0	0		0	0	0	297569	0	10	40213160		
31568	2617	1713671	1997-04-14	1997-04-14 00:00:00	1997-04-28	1997-04-28 00:00:00	1997-04-28	38000177		0	0	14		0	0	0	173030	0	562251	1713671		
54458	4526	19059056	1955-10-13	1955-10-13 00:00:00	1955-10-27	1955-10-27 00:00:00	1955-10-27	38000177		0	0	14		0	0	0	301402	0	243670	19059056		
44143	3654	19059056	1973-11-18	1973-11-18 00:00:00	1973-12-02	1973-12-02 00:00:00	1973-12-02	38000177		0	0	14		0	0	0	243187	0	243670	19059056		
19759	1626	19059056	1937-07-30	1937-07-30 00:00:00	1937-08-13	1937-08-13 00:00:00	1937-08-13	38000177		0	0	14		0	0	0	109280	0	243670	19059056		
38270	3167	1127433	2017-08-25	2017-08-25 00:00:00	2017-09-08	2017-09-08 00:00:00	2017-09-08	38000177		0	0	14		0	0	0	210579	0	313782	1127433		
8036	173	40213160	1968-06-30	1968-06-30 00:00:00	1968-06-30	1968-06-30 00:00:00	1968-06-30	581452		0	0	0		0	0	0	11771	0	10	40213160		
109772	2412	40213227	1992-11-20	1992-11-20 00:00:00	1992-11-20	1992-11-20 00:00:00	1992-11-20	581452		0	0	0		0	0	0	160110	0	113	40213227		
23436	1929	19006318	1954-09-18	1954-09-18 00:00:00	1954-10-02	1954-10-02 00:00:00	1954-10-02	38000177		0	0	14		0	0	0	128453	0	105078	19006318		
135246	2969	40213306	1985-12-05	1985-12-05 00:00:00	1985-12-05	1985-12-05 00:00:00	1985-12-05	581452		0	0	0		0	0	0	\N	0	43	40213306		
51192	4253	42902245	2001-11-12	2001-11-12 00:00:00	2002-11-07	2002-11-07 00:00:00	2002-11-07	38000177		0	0	360		0	0	0	282450	0	1359133	42902245		
151146	3325	40213306	1985-08-21	1985-08-21 00:00:00	1985-08-21	1985-08-21 00:00:00	1985-08-21	581452		0	0	0		0	0	0	220709	0	43	40213306		
46788	3875	1127078	1967-09-23	1967-09-23 00:00:00	1967-11-22	1967-11-22 00:00:00	1967-11-22	38000177		0	0	60		0	0	0	257378	0	282464	1127078		
23741	1952	1127433	1965-09-04	1965-09-04 00:00:00	1965-09-11	1965-09-11 00:00:00	1965-09-11	38000177		0	0	7		0	0	0	129814	0	313782	1127433		
63533	5279	19059056	1963-04-28	1963-04-28 00:00:00	1963-06-27	1963-06-27 00:00:00	1963-06-27	38000177		0	0	60		0	0	0	351133	0	243670	19059056		
37687	822	40213160	1970-08-21	1970-08-21 00:00:00	1970-08-21	1970-08-21 00:00:00	1970-08-21	581452		0	0	0		0	0	0	54481	0	10	40213160		
27795	2300	1713671	1987-01-08	1987-01-08 00:00:00	1987-01-29	1987-01-29 00:00:00	1987-01-29	38000177		0	0	21		0	0	0	153176	0	562251	1713671		
108485	2380	40213160	1955-05-14	1955-05-14 00:00:00	1955-05-14	1955-05-14 00:00:00	1955-05-14	581452		0	0	0		0	0	0	158197	0	10	40213160		
191423	4205	40213306	1994-03-12	1994-03-12 00:00:00	1994-03-12	1994-03-12 00:00:00	1994-03-12	581452		0	0	0		0	0	0	279202	0	43	40213306		
55296	4591	19078461	1977-08-13	1977-08-13 00:00:00	1977-08-27	1977-08-27 00:00:00	1977-08-27	38000177		0	0	14		0	0	0	305895	0	310965	19078461		
10047	842	40231925	1940-08-16	1940-08-16 00:00:00	1940-08-16	1940-08-16 00:00:00	\N	38000177		0	0	0		0	0	0	55708	0	1049221	40231925		
9911	830	1127078	1962-06-22	1962-06-22 00:00:00	1962-07-06	1962-07-06 00:00:00	1962-07-06	38000177		0	0	14		0	0	0	54971	0	282464	1127078		
4075	337	19059056	1965-09-21	1965-09-21 00:00:00	1965-10-05	1965-10-05 00:00:00	1965-10-05	38000177		0	0	14		0	0	0	22414	0	243670	19059056		
54539	1194	40213160	1961-02-27	1961-02-27 00:00:00	1961-02-27	1961-02-27 00:00:00	1961-02-27	581452		0	0	0		0	0	0	78693	0	10	40213160		
54586	1194	40213160	1961-05-29	1961-05-29 00:00:00	1961-05-29	1961-05-29 00:00:00	1961-05-29	581452		0	0	0		0	0	0	78697	0	10	40213160		
79694	1743	40213160	1965-05-12	1965-05-12 00:00:00	1965-05-12	1965-05-12 00:00:00	1965-05-12	581452		0	0	0		0	0	0	116505	0	10	40213160		
35177	2902	40229134	2017-09-03	2017-09-03 00:00:00	2017-09-10	2017-09-10 00:00:00	2017-09-10	38000177		0	0	7		0	0	0	193289	0	1043400	40229134		
63606	5284	1124300	2008-07-29	2008-07-29 00:00:00	2008-07-29	2008-07-29 00:00:00	\N	38000177		0	0	0		0	0	0	351591	0	00781178901	45011828		
16541	1371	40231925	1991-08-01	1991-08-01 00:00:00	1991-08-01	1991-08-01 00:00:00	\N	38000177		0	0	0		0	0	0	90895	0	1049221	40231925		
58140	4829	19128065	1987-11-26	1987-11-26 00:00:00	1988-11-20	1988-11-20 00:00:00	1988-11-20	38000177		0	0	360		0	0	0	321359	0	749882	19128065		
45788	3789	19006318	1945-08-11	1945-08-11 00:00:00	1945-08-25	1945-08-25 00:00:00	1945-08-25	38000177		0	0	14		0	0	0	251886	0	105078	19006318		
56311	4674	1127433	1987-02-08	1987-02-08 00:00:00	1987-03-01	1987-03-01 00:00:00	1987-03-01	38000177		0	0	21		0	0	0	311388	0	313782	1127433		
31937	2647	19059056	1973-02-12	1973-02-12 00:00:00	1973-02-26	1973-02-26 00:00:00	1973-02-26	38000177		0	0	14		0	0	0	175166	0	243670	19059056		
118098	2597	40213296	2012-12-04	2012-12-04 00:00:00	2012-12-04	2012-12-04 00:00:00	2012-12-04	581452		0	0	0		0	0	0	171862	0	52	40213296		
57546	4777	1127433	1971-04-05	1971-04-05 00:00:00	1971-04-19	1971-04-19 00:00:00	1971-04-19	38000177		0	0	14		0	0	0	318094	0	313782	1127433		
40844	3386	1127078	1974-08-02	1974-08-02 00:00:00	1974-08-23	1974-08-23 00:00:00	1974-08-23	38000177		0	0	21		0	0	0	224626	0	282464	1127078		
7613	640	1127433	1992-04-24	1992-04-24 00:00:00	1992-05-01	1992-05-01 00:00:00	1992-05-01	38000177		0	0	7		0	0	0	42370	0	313782	1127433		
40938	3394	1124300	1999-10-09	1999-10-09 00:00:00	1999-10-09	1999-10-09 00:00:00	\N	38000177		0	0	0		0	0	0	225177	0	00781178901	45011828		
181915	3996	40213227	2000-02-22	2000-02-22 00:00:00	2000-02-22	2000-02-22 00:00:00	2000-02-22	581452		0	0	0		0	0	0	265642	0	113	40213227		
166437	3658	40213227	2011-12-11	2011-12-11 00:00:00	2011-12-11	2011-12-11 00:00:00	2011-12-11	581452		0	0	0		0	0	0	243501	0	113	40213227		
60820	5058	1127433	1980-11-19	1980-11-19 00:00:00	1980-11-26	1980-11-26 00:00:00	1980-11-26	38000177		0	0	7		0	0	0	336329	0	313782	1127433		
58957	4898	1713671	2005-12-09	2005-12-09 00:00:00	2005-12-23	2005-12-23 00:00:00	2005-12-23	38000177		0	0	14		0	0	0	325742	0	562251	1713671		
59026	4905	1127433	2018-09-01	2018-09-01 00:00:00	2018-09-08	2018-09-08 00:00:00	2018-09-08	38000177		0	0	7		0	0	0	326039	0	313782	1127433		
235106	5165	40213296	2003-12-19	2003-12-19 00:00:00	2003-12-19	2003-12-19 00:00:00	2003-12-19	581452		0	0	0		0	0	0	343376	0	52	40213296		
23181	1911	19006318	1946-07-24	1946-07-24 00:00:00	1946-08-07	1946-08-07 00:00:00	1946-08-07	38000177		0	0	14		0	0	0	127171	0	105078	19006318		
5533	461	1127433	2011-03-11	2011-03-11 00:00:00	2011-03-18	2011-03-18 00:00:00	2011-03-18	38000177		0	0	7		0	0	0	30796	0	313782	1127433		
33745	2792	1124300	2001-12-10	2001-12-10 00:00:00	2001-12-10	2001-12-10 00:00:00	\N	38000177		0	0	0		0	0	0	185056	0	00781178901	45011828		
46126	3822	1332419	2009-03-23	2009-03-23 00:00:00	2009-03-23	2009-03-23 00:00:00	\N	38000177		0	0	0		0	0	0	253896	0	197361	1332419		
46252	3832	1713671	1999-03-18	1999-03-18 00:00:00	1999-04-08	1999-04-08 00:00:00	1999-04-08	38000177		0	0	21		0	0	0	254437	0	562251	1713671		
34458	753	40213260	2019-04-21	2019-04-21 00:00:00	2019-04-21	2019-04-21 00:00:00	2019-04-21	581452		0	0	0		0	0	0	49795	0	121	40213260		
52711	4381	1127433	1992-08-29	1992-08-29 00:00:00	1992-09-12	1992-09-12 00:00:00	1992-09-12	38000177		0	0	14		0	0	0	291112	0	313782	1127433		
29693	2459	1118084	2015-08-31	2015-08-31 00:00:00	2015-08-31	2015-08-31 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00025152531	44923712		
236591	5195	40213160	1965-01-27	1965-01-27 00:00:00	1965-01-27	1965-01-27 00:00:00	1965-01-27	581452		0	0	0		0	0	0	345471	0	10	40213160		
63297	5257	19128022	1995-02-24	1995-02-24 00:00:00	1996-02-19	1996-02-19 00:00:00	1996-02-19	38000177		0	0	360		0	0	0	349788	0	749785	19128022		
52003	4325	40229134	1986-05-21	1986-05-21 00:00:00	1986-06-04	1986-06-04 00:00:00	1986-06-04	38000177		0	0	14		0	0	0	286895	0	1043400	40229134		
55954	4644	1127078	1968-01-26	1968-01-26 00:00:00	1968-02-09	1968-02-09 00:00:00	1968-02-09	38000177		0	0	14		0	0	0	309681	0	282464	1127078		
35788	2947	19128065	1989-05-13	1989-05-13 00:00:00	1990-05-08	1990-05-08 00:00:00	1990-05-08	38000177		0	0	360		0	0	0	196715	0	749882	19128065		
99265	2174	40213296	2016-09-04	2016-09-04 00:00:00	2016-09-04	2016-09-04 00:00:00	2016-09-04	581452		0	0	0		0	0	0	144927	0	52	40213296		
99316	2175	40213296	2017-02-16	2017-02-16 00:00:00	2017-02-16	2017-02-16 00:00:00	2017-02-16	581452		0	0	0		0	0	0	144951	0	52	40213296		
110398	2425	40213227	2011-02-24	2011-02-24 00:00:00	2011-02-24	2011-02-24 00:00:00	2011-02-24	581452		0	0	0		0	0	0	160902	0	113	40213227		
8202	685	1127078	1977-07-09	1977-07-09 00:00:00	1977-07-30	1977-07-30 00:00:00	1977-07-30	38000177		0	0	21		0	0	0	45303	0	282464	1127078		
61520	5119	1127433	1976-11-21	1976-11-21 00:00:00	1976-11-28	1976-11-28 00:00:00	1976-11-28	38000177		0	0	7		0	0	0	340293	0	313782	1127433		
193699	4256	40213227	1995-06-18	1995-06-18 00:00:00	1995-06-18	1995-06-18 00:00:00	1995-06-18	581452		0	0	0		0	0	0	282562	0	113	40213227		
17900	387	40213160	1978-08-11	1978-08-11 00:00:00	1978-08-11	1978-08-11 00:00:00	1978-08-11	581452		0	0	0		0	0	0	25498	0	10	40213160		
21051	1736	920300	1989-08-09	1989-08-09 00:00:00	1989-08-16	1989-08-16 00:00:00	1989-08-16	38000177		0	0	7		0	0	0	115943	0	311989	920300		
31574	2619	19059056	1966-02-17	1966-02-17 00:00:00	1966-03-17	1966-03-17 00:00:00	1966-03-17	38000177		0	0	28		0	0	0	173200	0	243670	19059056		
54459	4526	19006318	1955-10-13	1955-10-13 00:00:00	1955-10-27	1955-10-27 00:00:00	1955-10-27	38000177		0	0	14		0	0	0	301402	0	105078	19006318		
44144	3654	19059056	1973-05-23	1973-05-23 00:00:00	1973-06-06	1973-06-06 00:00:00	1973-06-06	38000177		0	0	14		0	0	0	243222	0	243670	19059056		
19760	1626	19078924	1989-12-17	1989-12-17 00:00:00	1989-12-17	1989-12-17 00:00:00	1989-12-17	38000177		0	0	0		0	0	0	109189	0	311700	19078924		
38271	3167	19078461	1996-01-03	1996-01-03 00:00:00	1996-01-24	1996-01-24 00:00:00	1996-01-24	38000177		0	0	21		0	0	0	210551	0	310965	19078461		
8038	173	40213227	2011-02-27	2011-02-27 00:00:00	2011-02-27	2011-02-27 00:00:00	2011-02-27	581452		0	0	0		0	0	0	11747	0	113	40213227		
139689	3069	40213160	1961-11-22	1961-11-22 00:00:00	1961-11-22	1961-11-22 00:00:00	1961-11-22	581452		0	0	0		0	0	0	204252	0	10	40213160		
23437	1929	19128065	1976-07-07	1976-07-07 00:00:00	1977-07-02	1977-07-02 00:00:00	1977-07-02	38000177		0	0	360		0	0	0	128443	0	749882	19128065		
135250	2969	40213296	2007-11-22	2007-11-22 00:00:00	2007-11-22	2007-11-22 00:00:00	2007-11-22	581452		0	0	0		0	0	0	198222	0	52	40213296		
51193	4253	19128009	2005-10-23	2005-10-23 00:00:00	2006-10-18	2006-10-18 00:00:00	2006-10-18	38000177		0	0	360		0	0	0	282444	0	749762	19128009		
151148	3325	40213260	2014-07-23	2014-07-23 00:00:00	2014-07-23	2014-07-23 00:00:00	2014-07-23	581452		0	0	0		0	0	0	220720	0	121	40213260		
46789	3875	1713671	1985-06-20	1985-06-20 00:00:00	1985-06-27	1985-06-27 00:00:00	1985-06-27	38000177		0	0	7		0	0	0	257396	0	562251	1713671		
23742	1952	19133905	1996-12-09	1996-12-09 00:00:00	1996-12-21	1996-12-21 00:00:00	1996-12-21	38000177		0	0	12		0	0	0	129816	0	834102	19133905		
63534	5279	40229134	1955-11-27	1955-11-27 00:00:00	1955-12-11	1955-12-11 00:00:00	1955-12-11	38000177		0	0	14		0	0	0	351229	0	1043400	40229134		
37692	822	40213160	1975-05-02	1975-05-02 00:00:00	1975-05-02	1975-05-02 00:00:00	1975-05-02	581452		0	0	0		0	0	0	54494	0	10	40213160		
27796	2300	19059056	1960-12-29	1960-12-29 00:00:00	1961-01-12	1961-01-12 00:00:00	1961-01-12	38000177		0	0	14		0	0	0	153126	0	243670	19059056		
108498	2380	40213227	2012-01-07	2012-01-07 00:00:00	2012-01-07	2012-01-07 00:00:00	2012-01-07	581452		0	0	0		0	0	0	158181	0	113	40213227		
191444	4206	40213227	1994-09-12	1994-09-12 00:00:00	1994-09-12	1994-09-12 00:00:00	1994-09-12	581452		0	0	0		0	0	0	279323	0	113	40213227		
55304	4593	46233988	1967-05-15	1967-05-15 00:00:00	1967-05-29	1967-05-29 00:00:00	1967-05-29	38000177		0	0	14		0	0	0	306038	0	1652673	46233988		
10048	842	1713671	1969-03-12	1969-03-12 00:00:00	1969-04-02	1969-04-02 00:00:00	1969-04-02	38000177		0	0	21		0	0	0	55644	0	562251	1713671		
9912	830	19006318	1962-06-22	1962-06-22 00:00:00	1962-07-06	1962-07-06 00:00:00	1962-07-06	38000177		0	0	14		0	0	0	54971	0	105078	19006318		
4076	337	19059056	1960-01-21	1960-01-21 00:00:00	1960-02-04	1960-02-04 00:00:00	1960-02-04	38000177		0	0	14		0	0	0	22424	0	243670	19059056		
54543	1194	40213160	1965-07-26	1965-07-26 00:00:00	1965-07-26	1965-07-26 00:00:00	1965-07-26	581452		0	0	0		0	0	0	78716	0	10	40213160		
54590	1194	40213260	2010-09-20	2010-09-20 00:00:00	2010-09-20	2010-09-20 00:00:00	2010-09-20	581452		0	0	0		0	0	0	78745	0	121	40213260		
79697	1744	40213314	1977-04-08	1977-04-08 00:00:00	1977-04-08	1977-04-08 00:00:00	1977-04-08	581452		0	0	0		0	0	0	116644	0	49	40213314		
35178	2902	40232448	1950-07-25	1950-07-25 00:00:00	1950-07-25	1950-07-25 00:00:00	\N	38000177		0	0	0		0	0	0	193357	0	1049630	40232448		
63608	5285	1713671	2013-09-08	2013-09-08 00:00:00	2013-09-29	2013-09-29 00:00:00	2013-09-29	38000177		0	0	21		0	0	0	351635	0	562251	1713671		
16542	1371	19078461	1991-08-01	1991-08-01 00:00:00	1991-08-31	1991-08-31 00:00:00	1991-08-31	38000177		0	0	30		0	0	0	90895	0	310965	19078461		
58141	4829	1127433	1983-09-10	1983-09-10 00:00:00	1983-09-24	1983-09-24 00:00:00	1983-09-24	38000177		0	0	14		0	0	0	321355	0	313782	1127433		
45789	3790	1713671	1989-04-05	1989-04-05 00:00:00	1989-04-19	1989-04-19 00:00:00	1989-04-19	38000177		0	0	14		0	0	0	251998	0	562251	1713671		
56312	4674	1127433	2012-01-25	2012-01-25 00:00:00	2012-02-08	2012-02-08 00:00:00	2012-02-08	38000177		0	0	14		0	0	0	311383	0	313782	1127433		
31938	2647	1127433	1974-08-25	1974-08-25 00:00:00	1974-09-01	1974-09-01 00:00:00	1974-09-01	38000177		0	0	7		0	0	0	175109	0	313782	1127433		
118100	2597	40213227	2012-12-04	2012-12-04 00:00:00	2012-12-04	2012-12-04 00:00:00	2012-12-04	581452		0	0	0		0	0	0	171862	0	113	40213227		
57547	4777	40236824	1982-06-23	1982-06-23 00:00:00	1982-06-30	1982-06-30 00:00:00	1982-06-30	38000177		0	0	7		0	0	0	318059	0	1094107	40236824		
40845	3386	40236824	2009-12-17	2009-12-17 00:00:00	2009-12-24	2009-12-24 00:00:00	2009-12-24	38000177		0	0	7		0	0	0	224635	0	1094107	40236824		
7614	640	1124300	1992-11-07	1992-11-07 00:00:00	1992-11-07	1992-11-07 00:00:00	\N	38000177		0	0	0		0	0	0	42388	0	00781178901	45011828		
40940	3394	19059056	1971-02-03	1971-02-03 00:00:00	1971-02-17	1971-02-17 00:00:00	1971-02-17	38000177		0	0	14		0	0	0	225122	0	243670	19059056		
25292	552	40213160	1956-09-04	1956-09-04 00:00:00	1956-09-04	1956-09-04 00:00:00	1956-09-04	581452		0	0	0		0	0	0	36604	0	10	40213160		
166441	3658	40213160	1961-03-12	1961-03-12 00:00:00	1961-03-12	1961-03-12 00:00:00	1961-03-12	581452		0	0	0		0	0	0	243500	0	10	40213160		
60821	5058	40162522	2014-07-24	2014-07-24 00:00:00	2014-07-24	2014-07-24 00:00:00	\N	38000177		0	0	0		0	0	0	336277	0	857005	40162522		
58958	4898	1127078	1962-10-27	1962-10-27 00:00:00	1962-11-26	1962-11-26 00:00:00	1962-11-26	38000177		0	0	30		0	0	0	325703	0	282464	1127078		
177290	3895	40213227	2004-07-16	2004-07-16 00:00:00	2004-07-16	2004-07-16 00:00:00	2004-07-16	581452		0	0	0		0	0	0	259018	0	113	40213227		
235107	5165	40213160	1964-05-22	1964-05-22 00:00:00	1964-05-22	1964-05-22 00:00:00	1964-05-22	581452		0	0	0		0	0	0	343296	0	10	40213160		
23182	1911	19059056	1946-07-24	1946-07-24 00:00:00	1946-08-07	1946-08-07 00:00:00	1946-08-07	38000177		0	0	14		0	0	0	127171	0	243670	19059056		
5534	461	19073188	2017-05-10	2017-05-10 00:00:00	2017-06-14	2017-06-14 00:00:00	2017-06-14	38000177		0	0	35		0	0	0	30859	0	308192	19073188		
33746	2792	46233710	1975-05-12	1975-05-12 00:00:00	1975-05-26	1975-05-26 00:00:00	1975-05-26	38000177		0	0	14		0	0	0	185031	0	1650142	46233710		
46127	3822	19133873	1958-02-28	1958-02-28 00:00:00	1958-03-10	1958-03-10 00:00:00	1958-03-10	38000177		0	0	10		0	0	0	253865	0	834061	19133873		
46253	3832	1551192	2010-12-21	2010-12-21 00:00:00	2010-12-21	2010-12-21 00:00:00	2010-12-21	38000177		0	0	0		0	0	0	254429	0	312617	1551192		
34462	753	40213160	1968-06-02	1968-06-02 00:00:00	1968-06-02	1968-06-02 00:00:00	1968-06-02	581452		0	0	0		0	0	0	49778	0	10	40213160		
52712	4382	1154615	1955-01-05	1955-01-05 00:00:00	1955-01-05	1955-01-05 00:00:00	\N	38000177		0	0	0		0	0	0	291260	0	745679	1154615		
29694	2459	19128022	1992-06-11	1992-06-11 00:00:00	1993-06-06	1993-06-06 00:00:00	1993-06-06	38000177		0	0	360		0	0	0	163008	0	749785	19128022		
236595	5195	40213160	1960-05-25	1960-05-25 00:00:00	1960-05-25	1960-05-25 00:00:00	1960-05-25	581452		0	0	0		0	0	0	345468	0	10	40213160		
63298	5257	1127078	1979-06-08	1979-06-08 00:00:00	1979-06-22	1979-06-22 00:00:00	1979-06-22	38000177		0	0	14		0	0	0	349827	0	282464	1127078		
52004	4325	19078461	1982-11-03	1982-11-03 00:00:00	1982-11-17	1982-11-17 00:00:00	1982-11-17	38000177		0	0	14		0	0	0	286933	0	310965	19078461		
55955	4644	1127433	1981-07-01	1981-07-01 00:00:00	1981-07-15	1981-07-15 00:00:00	1981-07-15	38000177		0	0	14		0	0	0	309646	0	313782	1127433		
35789	2947	1124300	2018-09-28	2018-09-28 00:00:00	2018-09-28	2018-09-28 00:00:00	\N	38000177		0	0	0		0	0	0	196678	0	00781178901	45011828		
99267	2174	40213227	2016-09-04	2016-09-04 00:00:00	2016-09-04	2016-09-04 00:00:00	2016-09-04	581452		0	0	0		0	0	0	144927	0	113	40213227		
99321	2175	40213160	1976-07-08	1976-07-08 00:00:00	1976-07-08	1976-07-08 00:00:00	1976-07-08	581452		0	0	0		0	0	0	145051	0	10	40213160		
110399	2425	40213260	2011-02-24	2011-02-24 00:00:00	2011-02-24	2011-02-24 00:00:00	2011-02-24	581452		0	0	0		0	0	0	160902	0	121	40213260		
8203	685	19129655	1966-03-09	1966-03-09 00:00:00	1966-03-23	1966-03-23 00:00:00	1966-03-23	38000177		0	0	14		0	0	0	45359	0	789980	19129655		
61521	5119	19078461	1978-05-14	1978-05-14 00:00:00	1978-05-28	1978-05-28 00:00:00	1978-05-28	38000177		0	0	14		0	0	0	340420	0	310965	19078461		
193702	4256	40213227	2013-12-08	2013-12-08 00:00:00	2013-12-08	2013-12-08 00:00:00	2013-12-08	581452		0	0	0		0	0	0	282595	0	113	40213227		
62271	1360	40213306	1997-10-26	1997-10-26 00:00:00	1997-10-26	1997-10-26 00:00:00	1997-10-26	581452		0	0	0		0	0	0	90231	0	43	40213306		
21052	1736	1713671	1976-06-16	1976-06-16 00:00:00	1976-06-30	1976-06-30 00:00:00	1976-06-30	38000177		0	0	14		0	0	0	115887	0	562251	1713671		
31575	2619	19059056	1948-06-21	1948-06-21 00:00:00	1948-07-21	1948-07-21 00:00:00	1948-07-21	38000177		0	0	30		0	0	0	173199	0	243670	19059056		
54460	4526	1713671	1986-05-02	1986-05-02 00:00:00	1986-05-09	1986-05-09 00:00:00	1986-05-09	38000177		0	0	7		0	0	0	301379	0	562251	1713671		
44145	3654	19129655	1973-11-18	1973-11-18 00:00:00	1973-12-02	1973-12-02 00:00:00	1973-12-02	38000177		0	0	14		0	0	0	243187	0	789980	19129655		
19761	1626	35605482	1989-12-17	1989-12-17 00:00:00	1989-12-17	1989-12-17 00:00:00	1989-12-17	38000177		0	0	0		0	0	0	109189	0	1740467	35605482		
38272	3167	1127433	1990-11-06	1990-11-06 00:00:00	1990-11-13	1990-11-13 00:00:00	1990-11-13	38000177		0	0	7		0	0	0	210533	0	313782	1127433		
8039	173	40213296	2011-02-27	2011-02-27 00:00:00	2011-02-27	2011-02-27 00:00:00	2011-02-27	581452		0	0	0		0	0	0	11747	0	52	40213296		
149173	3280	40213160	1956-07-26	1956-07-26 00:00:00	1956-07-26	1956-07-26 00:00:00	1956-07-26	581452		0	0	0		0	0	0	218049	0	10	40213160		
23438	1929	19006318	1955-02-23	1955-02-23 00:00:00	1955-03-09	1955-03-09 00:00:00	1955-03-09	38000177		0	0	14		0	0	0	128464	0	105078	19006318		
135252	2969	40213227	2007-11-22	2007-11-22 00:00:00	2007-11-22	2007-11-22 00:00:00	2007-11-22	581452		0	0	0		0	0	0	198222	0	113	40213227		
51194	4253	1127433	2017-06-12	2017-06-12 00:00:00	2017-06-26	2017-06-26 00:00:00	2017-06-26	38000177		0	0	14		0	0	0	282460	0	313782	1127433		
151150	3325	40213227	2014-07-23	2014-07-23 00:00:00	2014-07-23	2014-07-23 00:00:00	2014-07-23	581452		0	0	0		0	0	0	220720	0	113	40213227		
46791	3876	1127433	1974-04-17	1974-04-17 00:00:00	1974-04-24	1974-04-24 00:00:00	1974-04-24	38000177		0	0	7		0	0	0	257431	0	313782	1127433		
23745	1952	1127433	1967-12-25	1967-12-25 00:00:00	1968-01-24	1968-01-24 00:00:00	1968-01-24	38000177		0	0	30		0	0	0	129788	0	313782	1127433		
63537	5279	1127433	1969-02-09	1969-02-09 00:00:00	1969-03-02	1969-03-02 00:00:00	1969-03-02	38000177		0	0	21		0	0	0	351135	0	313782	1127433		
37695	822	40213160	1971-01-22	1971-01-22 00:00:00	1971-01-22	1971-01-22 00:00:00	1971-01-22	581452		0	0	0		0	0	0	54491	0	10	40213160		
27797	2300	1127433	1970-12-21	1970-12-21 00:00:00	1971-01-25	1971-01-25 00:00:00	1971-01-25	38000177		0	0	35		0	0	0	153127	0	313782	1127433		
108507	2380	40213227	2001-06-02	2001-06-02 00:00:00	2001-06-02	2001-06-02 00:00:00	2001-06-02	581452		0	0	0		0	0	0	158165	0	113	40213227		
229101	5034	40213227	1994-01-29	1994-01-29 00:00:00	1994-01-29	1994-01-29 00:00:00	1994-01-29	581452		0	0	0		0	0	0	334515	0	113	40213227		
55305	4593	19059056	1967-05-15	1967-05-15 00:00:00	1967-05-29	1967-05-29 00:00:00	1967-05-29	38000177		0	0	14		0	0	0	306038	0	243670	19059056		
10049	842	19075001	1985-08-09	1985-08-09 00:00:00	1985-08-23	1985-08-23 00:00:00	1985-08-23	38000177		0	0	14		0	0	0	55607	0	309097	19075001		
9913	830	1127433	1973-07-12	1973-07-12 00:00:00	1973-07-19	1973-07-19 00:00:00	1973-07-19	38000177		0	0	7		0	0	0	55000	0	313782	1127433		
4077	337	19078461	2018-11-01	2018-11-01 00:00:00	2018-11-22	2018-11-22 00:00:00	2018-11-22	38000177		0	0	21		0	0	0	22416	0	310965	19078461		
236785	5199	40213227	1993-11-23	1993-11-23 00:00:00	1993-11-23	1993-11-23 00:00:00	1993-11-23	581452		0	0	0		0	0	0	345747	0	113	40213227		
54591	1194	40213160	1960-12-26	1960-12-26 00:00:00	1960-12-26	1960-12-26 00:00:00	1960-12-26	581452		0	0	0		0	0	0	78696	0	10	40213160		
79699	1744	40213306	1996-07-05	1996-07-05 00:00:00	1996-07-05	1996-07-05 00:00:00	1996-07-05	581452		0	0	0		0	0	0	116606	0	43	40213306		
30973	675	40213198	2013-08-06	2013-08-06 00:00:00	2013-08-06	2013-08-06 00:00:00	2013-08-06	581452		0	0	0		0	0	0	44662	0	133	40213198		
63609	5285	19133905	1971-10-26	1971-10-26 00:00:00	1971-11-06	1971-11-06 00:00:00	1971-11-06	38000177		0	0	11		0	0	0	351624	0	834102	19133905		
16543	1371	1115171	1998-04-26	1998-04-26 00:00:00	1998-06-25	1998-06-25 00:00:00	1998-06-25	38000177		0	0	60		0	0	0	90896	0	849574	1115171		
58142	4829	46233988	1973-11-13	1973-11-13 00:00:00	1973-11-27	1973-11-27 00:00:00	1973-11-27	38000177		0	0	14		0	0	0	321315	0	1652673	46233988		
45790	3790	1118084	2001-11-03	2001-11-03 00:00:00	2001-11-03	2001-11-03 00:00:00	\N	38000177		0	0	0		0	0	0	251979	0	00025152531	44923712		
56313	4674	1713671	2014-01-10	2014-01-10 00:00:00	2014-01-17	2014-01-17 00:00:00	2014-01-17	38000177		0	0	7		0	0	0	311367	0	562251	1713671		
31939	2647	1713671	1998-03-04	1998-03-04 00:00:00	1998-03-18	1998-03-18 00:00:00	1998-03-18	38000177		0	0	14		0	0	0	175162	0	562251	1713671		
118102	2597	40213160	1975-11-04	1975-11-04 00:00:00	1975-11-04	1975-11-04 00:00:00	1975-11-04	581452		0	0	0		0	0	0	171871	0	10	40213160		
57548	4777	920300	1982-06-23	1982-06-23 00:00:00	1982-06-30	1982-06-30 00:00:00	1982-06-30	38000177		0	0	7		0	0	0	318059	0	311989	920300		
40846	3386	920300	2009-12-17	2009-12-17 00:00:00	2009-12-24	2009-12-24 00:00:00	2009-12-24	38000177		0	0	7		0	0	0	224635	0	311989	920300		
7615	640	1127433	1967-07-04	1967-07-04 00:00:00	1967-07-18	1967-07-18 00:00:00	1967-07-18	38000177		0	0	14		0	0	0	42375	0	313782	1127433		
40941	3394	19129655	1971-02-03	1971-02-03 00:00:00	1971-02-17	1971-02-17 00:00:00	1971-02-17	38000177		0	0	14		0	0	0	225122	0	789980	19129655		
25298	552	40213198	2016-12-20	2016-12-20 00:00:00	2016-12-20	2016-12-20 00:00:00	2016-12-20	581452		0	0	0		0	0	0	36592	0	133	40213198		
106444	2334	40213227	2017-07-27	2017-07-27 00:00:00	2017-07-27	2017-07-27 00:00:00	2017-07-27	581452		0	0	0		0	0	0	155366	0	113	40213227		
60822	5058	1127433	1966-11-03	1966-11-03 00:00:00	1966-11-17	1966-11-17 00:00:00	1966-11-17	38000177		0	0	14		0	0	0	336304	0	313782	1127433		
58959	4898	1127433	2003-09-16	2003-09-16 00:00:00	2003-09-23	2003-09-23 00:00:00	2003-09-23	38000177		0	0	7		0	0	0	325668	0	313782	1127433		
177292	3896	40213314	1978-12-15	1978-12-15 00:00:00	1978-12-15	1978-12-15 00:00:00	1978-12-15	581452		0	0	0		0	0	0	259148	0	49	40213314		
235113	5165	40213227	1995-03-03	1995-03-03 00:00:00	1995-03-03	1995-03-03 00:00:00	1995-03-03	581452		0	0	0		0	0	0	343300	0	113	40213227		
23183	1911	1124300	1984-05-05	1984-05-05 00:00:00	1984-05-05	1984-05-05 00:00:00	\N	38000177		0	0	0		0	0	0	127110	0	00781178901	45011828		
5535	461	1127433	2017-05-10	2017-05-10 00:00:00	2017-06-14	2017-06-14 00:00:00	2017-06-14	38000177		0	0	35		0	0	0	30859	0	313782	1127433		
33747	2792	1127433	1975-05-12	1975-05-12 00:00:00	1975-05-26	1975-05-26 00:00:00	1975-05-26	38000177		0	0	14		0	0	0	185031	0	313782	1127433		
46128	3822	1118084	1986-09-30	1986-09-30 00:00:00	1986-09-30	1986-09-30 00:00:00	\N	38000177		0	0	0		0	0	0	253815	0	00025152531	44923712		
46254	3832	1150771	1984-11-17	1984-11-17 00:00:00	1984-11-17	1984-11-17 00:00:00	\N	38000177		0	0	0		0	0	0	254407	0	197378	1150771		
34465	753	40213296	2009-11-22	2009-11-22 00:00:00	2009-11-22	2009-11-22 00:00:00	2009-11-22	581452		0	0	0		0	0	0	49758	0	52	40213296		
52713	4382	40169216	1955-01-05	1955-01-05 00:00:00	1955-01-05	1955-01-05 00:00:00	\N	38000177		0	0	0		0	0	0	291260	0	895994	40169216		
29695	2459	1713671	2007-06-07	2007-06-07 00:00:00	2007-06-28	2007-06-28 00:00:00	2007-06-28	38000177		0	0	21		0	0	0	163062	0	562251	1713671		
236598	5195	40213160	1960-07-27	1960-07-27 00:00:00	1960-07-27	1960-07-27 00:00:00	1960-07-27	581452		0	0	0		0	0	0	345480	0	10	40213160		
63299	5257	19074843	1979-06-08	1979-06-08 00:00:00	1979-06-22	1979-06-22 00:00:00	1979-06-22	38000177		0	0	14		0	0	0	349827	0	309045	19074843		
52005	4325	1118084	2002-05-03	2002-05-03 00:00:00	2002-05-03	2002-05-03 00:00:00	\N	38000177		0	0	0		0	0	0	286910	0	00025152531	44923712		
55956	4644	1332419	1996-11-28	1996-11-28 00:00:00	1996-11-28	1996-11-28 00:00:00	\N	38000177		0	0	0		0	0	0	309634	0	197361	1332419		
35790	2947	1713671	1983-07-13	1983-07-13 00:00:00	1983-07-20	1983-07-20 00:00:00	1983-07-20	38000177		0	0	7		0	0	0	196701	0	562251	1713671		
99269	2174	40213227	2006-08-20	2006-08-20 00:00:00	2006-08-20	2006-08-20 00:00:00	2006-08-20	581452		0	0	0		0	0	0	144908	0	113	40213227		
110354	2424	40213260	2012-08-02	2012-08-02 00:00:00	2012-08-02	2012-08-02 00:00:00	2012-08-02	581452		0	0	0		0	0	0	160815	0	121	40213260		
110401	2425	40213227	2002-02-28	2002-02-28 00:00:00	2002-02-28	2002-02-28 00:00:00	2002-02-28	581452		0	0	0		0	0	0	160896	0	113	40213227		
8204	685	1127078	1966-03-09	1966-03-09 00:00:00	1966-03-23	1966-03-23 00:00:00	1966-03-23	38000177		0	0	14		0	0	0	45359	0	282464	1127078		
61522	5119	1127433	2000-09-24	2000-09-24 00:00:00	2000-10-08	2000-10-08 00:00:00	2000-10-08	38000177		0	0	14		0	0	0	340383	0	313782	1127433		
193706	4256	40213201	2019-01-06	2019-01-06 00:00:00	2019-01-06	2019-01-06 00:00:00	2019-01-06	581452		0	0	0		0	0	0	282639	0	33	40213201		
62273	1360	40213227	1997-10-26	1997-10-26 00:00:00	1997-10-26	1997-10-26 00:00:00	1997-10-26	581452		0	0	0		0	0	0	90231	0	113	40213227		
21053	1736	1127433	2011-10-24	2011-10-24 00:00:00	2011-11-07	2011-11-07 00:00:00	2011-11-07	38000177		0	0	14		0	0	0	115920	0	313782	1127433		
31576	2619	19133873	1948-03-24	1948-03-24 00:00:00	1948-04-06	1948-04-06 00:00:00	1948-04-06	38000177		0	0	13		0	0	0	173203	0	834061	19133873		
54461	4526	19133873	1959-02-07	1959-02-07 00:00:00	1959-02-19	1959-02-19 00:00:00	1959-02-19	38000177		0	0	12		0	0	0	301329	0	834061	19133873		
44146	3654	1127433	1977-11-23	1977-11-23 00:00:00	1977-12-07	1977-12-07 00:00:00	1977-12-07	38000177		0	0	14		0	0	0	243185	0	313782	1127433		
19762	1626	35605482	1989-12-17	1989-12-17 00:00:00	1989-12-17	1989-12-17 00:00:00	1989-12-17	38000177		0	0	0		0	0	0	109189	0	1740467	35605482		
38273	3167	19006318	1960-09-03	1960-09-03 00:00:00	1960-09-17	1960-09-17 00:00:00	1960-09-17	38000177		0	0	14		0	0	0	210570	0	105078	19006318		
226029	4964	40213227	2011-10-22	2011-10-22 00:00:00	2011-10-22	2011-10-22 00:00:00	2011-10-22	581452		0	0	0		0	0	0	329981	0	113	40213227		
149183	3280	40213227	2012-11-15	2012-11-15 00:00:00	2012-11-15	2012-11-15 00:00:00	2012-11-15	581452		0	0	0		0	0	0	217966	0	113	40213227		
23439	1929	19059056	1955-02-23	1955-02-23 00:00:00	1955-03-09	1955-03-09 00:00:00	1955-03-09	38000177		0	0	14		0	0	0	128464	0	243670	19059056		
135254	2969	40213227	1997-12-25	1997-12-25 00:00:00	1997-12-25	1997-12-25 00:00:00	1997-12-25	581452		0	0	0		0	0	0	198196	0	113	40213227		
51195	4253	1118084	2018-08-01	2018-08-01 00:00:00	2018-08-01	2018-08-01 00:00:00	\N	38000177		0	0	0		0	0	0	282473	0	00025152531	44923712		
160670	3536	40213227	1995-02-23	1995-02-23 00:00:00	1995-02-23	1995-02-23 00:00:00	1995-02-23	581452		0	0	0		0	0	0	234867	0	113	40213227		
46792	3876	1127078	1975-05-10	1975-05-10 00:00:00	1975-05-24	1975-05-24 00:00:00	1975-05-24	38000177		0	0	14		0	0	0	257418	0	282464	1127078		
23746	1952	40231925	1967-12-25	1967-12-25 00:00:00	1967-12-25	1967-12-25 00:00:00	\N	38000177		0	0	0		0	0	0	129788	0	1049221	40231925		
63538	5279	40229134	1974-04-14	1974-04-14 00:00:00	1974-04-28	1974-04-28 00:00:00	1974-04-28	38000177		0	0	14		0	0	0	351203	0	1043400	40229134		
37700	822	40213160	1970-10-23	1970-10-23 00:00:00	1970-10-23	1970-10-23 00:00:00	1970-10-23	581452		0	0	0		0	0	0	54465	0	10	40213160		
27798	2300	1127433	1991-05-09	1991-05-09 00:00:00	1991-05-16	1991-05-16 00:00:00	1991-05-16	38000177		0	0	7		0	0	0	153166	0	313782	1127433		
229092	5034	40213201	1988-12-31	1988-12-31 00:00:00	1988-12-31	1988-12-31 00:00:00	1988-12-31	581452		0	0	0		0	0	0	334444	0	33	40213201		
240405	5277	40213160	1955-06-15	1955-06-15 00:00:00	1955-06-15	1955-06-15 00:00:00	1955-06-15	581452		0	0	0		0	0	0	350990	0	10	40213160		
55306	4593	19129655	1965-11-29	1965-11-29 00:00:00	1965-12-13	1965-12-13 00:00:00	1965-12-13	38000177		0	0	14		0	0	0	306014	0	789980	19129655		
10050	842	1127433	1985-08-09	1985-08-09 00:00:00	1985-08-23	1985-08-23 00:00:00	1985-08-23	38000177		0	0	14		0	0	0	55607	0	313782	1127433		
9914	830	1127433	1984-12-30	1984-12-30 00:00:00	1985-01-06	1985-01-06 00:00:00	1985-01-06	38000177		0	0	7		0	0	0	54967	0	313782	1127433		
4078	337	19059056	1963-04-16	1963-04-16 00:00:00	1963-04-30	1963-04-30 00:00:00	1963-04-30	38000177		0	0	14		0	0	0	22460	0	243670	19059056		
236787	5199	40213160	1962-09-25	1962-09-25 00:00:00	1962-09-25	1962-09-25 00:00:00	1962-09-25	581452		0	0	0		0	0	0	345793	0	10	40213160		
65873	1441	40213160	1967-12-04	1967-12-04 00:00:00	1967-12-04	1967-12-04 00:00:00	1967-12-04	581452		0	0	0		0	0	0	96024	0	10	40213160		
79701	1744	40213227	1996-07-05	1996-07-05 00:00:00	1996-07-05	1996-07-05 00:00:00	1996-07-05	581452		0	0	0		0	0	0	116606	0	113	40213227		
30990	675	40213160	1955-05-17	1955-05-17 00:00:00	1955-05-17	1955-05-17 00:00:00	1955-05-17	581452		0	0	0		0	0	0	44676	0	10	40213160		
63610	5285	19077572	2016-05-29	2016-05-29 00:00:00	2016-05-29	2016-05-29 00:00:00	\N	38000177		0	0	0		0	0	0	351677	0	310436	19077572		
16544	1371	19078461	1999-06-20	1999-06-20 00:00:00	1999-07-04	1999-07-04 00:00:00	1999-07-04	38000177		0	0	14		0	0	0	90939	0	310965	19078461		
58143	4829	1127078	1973-11-13	1973-11-13 00:00:00	1973-11-27	1973-11-27 00:00:00	1973-11-27	38000177		0	0	14		0	0	0	321315	0	282464	1127078		
45791	3790	19133905	2001-02-05	2001-02-05 00:00:00	2001-02-18	2001-02-18 00:00:00	2001-02-18	38000177		0	0	13		0	0	0	251980	0	834102	19133905		
56314	4674	19059056	1969-01-17	1969-01-17 00:00:00	1969-01-31	1969-01-31 00:00:00	1969-01-31	38000177		0	0	14		0	0	0	311369	0	243670	19059056		
31940	2647	920334	2006-01-21	2006-01-21 00:00:00	2006-01-28	2006-01-28 00:00:00	2006-01-28	38000177		0	0	7		0	0	0	175120	0	311995	920334		
118105	2597	40213296	2010-11-30	2010-11-30 00:00:00	2010-11-30	2010-11-30 00:00:00	2010-11-30	581452		0	0	0		0	0	0	171823	0	52	40213296		
57549	4777	19133873	1964-03-14	1964-03-14 00:00:00	1964-03-27	1964-03-27 00:00:00	1964-03-27	38000177		0	0	13		0	0	0	318080	0	834061	19133873		
40847	3386	1127433	2019-02-04	2019-02-04 00:00:00	2019-02-18	2019-02-18 00:00:00	2019-02-18	38000177		0	0	14		0	0	0	224633	0	313782	1127433		
7616	640	1127433	1973-05-07	1973-05-07 00:00:00	1973-05-14	1973-05-14 00:00:00	1973-05-14	38000177		0	0	7		0	0	0	42342	0	313782	1127433		
40942	3394	19078461	1978-02-13	1978-02-13 00:00:00	1978-02-27	1978-02-27 00:00:00	1978-02-27	38000177		0	0	14		0	0	0	225144	0	310965	19078461		
25303	552	40213160	1955-03-01	1955-03-01 00:00:00	1955-03-01	1955-03-01 00:00:00	1955-03-01	581452		0	0	0		0	0	0	36616	0	10	40213160		
106447	2334	40213227	1997-04-03	1997-04-03 00:00:00	1997-04-03	1997-04-03 00:00:00	1997-04-03	581452		0	0	0		0	0	0	155300	0	113	40213227		
60823	5058	19078461	2000-12-29	2000-12-29 00:00:00	2001-01-26	2001-01-26 00:00:00	2001-01-26	38000177		0	0	28		0	0	0	336346	0	310965	19078461		
58960	4898	1127433	2008-01-05	2008-01-05 00:00:00	2008-01-19	2008-01-19 00:00:00	2008-01-19	38000177		0	0	14		0	0	0	325697	0	313782	1127433		
177295	3896	40213227	2009-11-20	2009-11-20 00:00:00	2009-11-20	2009-11-20 00:00:00	2009-11-20	581452		0	0	0		0	0	0	259191	0	113	40213227		
235117	5165	40213160	1964-03-20	1964-03-20 00:00:00	1964-03-20	1964-03-20 00:00:00	1964-03-20	581452		0	0	0		0	0	0	343311	0	10	40213160		
23184	1911	19006318	1950-05-17	1950-05-17 00:00:00	1950-05-31	1950-05-31 00:00:00	1950-05-31	38000177		0	0	14		0	0	0	127183	0	105078	19006318		
5536	461	40162522	2017-05-10	2017-05-10 00:00:00	2017-05-10	2017-05-10 00:00:00	\N	38000177		0	0	0		0	0	0	30859	0	857005	40162522		
33748	2792	1713671	2014-07-10	2014-07-10 00:00:00	2014-07-17	2014-07-17 00:00:00	2014-07-17	38000177		0	0	7		0	0	0	185029	0	562251	1713671		
46129	3822	19059056	1947-04-13	1947-04-13 00:00:00	1947-04-27	1947-04-27 00:00:00	1947-04-27	38000177		0	0	14		0	0	0	253868	0	243670	19059056		
46255	3832	1127433	2012-06-16	2012-06-16 00:00:00	2012-07-21	2012-07-21 00:00:00	2012-07-21	38000177		0	0	35		0	0	0	254430	0	313782	1127433		
34468	753	40213260	2018-04-15	2018-04-15 00:00:00	2018-04-15	2018-04-15 00:00:00	2018-04-15	581452		0	0	0		0	0	0	49760	0	121	40213260		
52716	4382	19078461	1975-12-20	1975-12-20 00:00:00	1976-01-10	1976-01-10 00:00:00	1976-01-10	38000177		0	0	21		0	0	0	291168	0	310965	19078461		
29696	2459	19133873	1984-06-15	1984-06-15 00:00:00	1984-06-25	1984-06-25 00:00:00	1984-06-25	38000177		0	0	10		0	0	0	163052	0	834061	19133873		
236601	5195	40213260	2010-03-10	2010-03-10 00:00:00	2010-03-10	2010-03-10 00:00:00	2010-03-10	581452		0	0	0		0	0	0	345442	0	121	40213260		
63300	5257	19128263	2007-12-22	2007-12-22 00:00:00	2008-12-16	2008-12-16 00:00:00	2008-12-16	38000177		0	0	360		0	0	0	349800	0	751905	19128263		
52006	4325	19133873	1969-12-10	1969-12-10 00:00:00	1969-12-17	1969-12-17 00:00:00	1969-12-17	38000177		0	0	7		0	0	0	286935	0	834061	19133873		
55957	4644	1713671	1993-03-29	1993-03-29 00:00:00	1993-04-05	1993-04-05 00:00:00	1993-04-05	38000177		0	0	7		0	0	0	309647	0	562251	1713671		
35791	2947	40162522	2000-07-07	2000-07-07 00:00:00	2000-07-07	2000-07-07 00:00:00	\N	38000177		0	0	0		0	0	0	196680	0	857005	40162522		
99271	2174	40213296	2014-08-31	2014-08-31 00:00:00	2014-08-31	2014-08-31 00:00:00	2014-08-31	581452		0	0	0		0	0	0	144909	0	52	40213296		
110363	2424	40213306	1985-01-17	1985-01-17 00:00:00	1985-01-17	1985-01-17 00:00:00	1985-01-17	581452		0	0	0		0	0	0	160829	0	43	40213306		
110402	2425	40213296	2002-02-28	2002-02-28 00:00:00	2002-02-28	2002-02-28 00:00:00	2002-02-28	581452		0	0	0		0	0	0	160896	0	52	40213296		
203599	4470	40213227	2003-02-23	2003-02-23 00:00:00	2003-02-23	2003-02-23 00:00:00	2003-02-23	581452		0	0	0		0	0	0	297343	0	113	40213227		
61523	5119	1127433	1997-10-24	1997-10-24 00:00:00	1997-11-07	1997-11-07 00:00:00	1997-11-07	38000177		0	0	14		0	0	0	340418	0	313782	1127433		
193707	4256	40213260	2006-10-29	2006-10-29 00:00:00	2006-10-29	2006-10-29 00:00:00	2006-10-29	581452		0	0	0		0	0	0	282565	0	121	40213260		
62279	1360	40213160	1980-08-03	1980-08-03 00:00:00	1980-08-03	1980-08-03 00:00:00	1980-08-03	581452		0	0	0		0	0	0	90227	0	10	40213160		
21054	1736	1127433	1989-09-06	1989-09-06 00:00:00	1989-09-13	1989-09-13 00:00:00	1989-09-13	38000177		0	0	7		0	0	0	115916	0	313782	1127433		
31577	2619	40229134	2013-02-24	2013-02-24 00:00:00	2013-03-03	2013-03-03 00:00:00	2013-03-03	38000177		0	0	7		0	0	0	173166	0	1043400	40229134		
54462	4526	1713671	1995-03-01	1995-03-01 00:00:00	1995-03-15	1995-03-15 00:00:00	1995-03-15	38000177		0	0	14		0	0	0	301330	0	562251	1713671		
44147	3654	1127433	1994-02-07	1994-02-07 00:00:00	1994-02-21	1994-02-21 00:00:00	1994-02-21	38000177		0	0	14		0	0	0	243202	0	313782	1127433		
19763	1626	19023398	1989-12-17	1989-12-17 00:00:00	1989-12-17	1989-12-17 00:00:00	1989-12-17	38000177		0	0	0		0	0	0	109189	0	200243	19023398		
38274	3167	19059056	1960-09-03	1960-09-03 00:00:00	1960-09-17	1960-09-17 00:00:00	1960-09-17	38000177		0	0	14		0	0	0	210570	0	243670	19059056		
226030	4964	40213260	2011-10-22	2011-10-22 00:00:00	2011-10-22	2011-10-22 00:00:00	2011-10-22	581452		0	0	0		0	0	0	329981	0	121	40213260		
149186	3280	40213201	2017-12-14	2017-12-14 00:00:00	2017-12-14	2017-12-14 00:00:00	2017-12-14	581452		0	0	0		0	0	0	217994	0	33	40213201		
23440	1929	19059056	1966-08-16	1966-08-16 00:00:00	1966-09-06	1966-09-06 00:00:00	1966-09-06	38000177		0	0	21		0	0	0	128391	0	243670	19059056		
135259	2969	40213306	1985-12-12	1985-12-12 00:00:00	1985-12-12	1985-12-12 00:00:00	1985-12-12	581452		0	0	0		0	0	0	198221	0	43	40213306		
51196	4253	43012754	2002-11-07	2002-11-07 00:00:00	2003-11-02	2003-11-02 00:00:00	2003-11-02	38000177		0	0	360		0	0	0	282451	0	1366343	43012754		
160674	3536	40213160	1964-04-16	1964-04-16 00:00:00	1964-04-16	1964-04-16 00:00:00	1964-04-16	581452		0	0	0		0	0	0	234880	0	10	40213160		
46793	3876	19129655	1975-05-10	1975-05-10 00:00:00	1975-05-24	1975-05-24 00:00:00	1975-05-24	38000177		0	0	14		0	0	0	257418	0	789980	19129655		
23747	1952	19059056	1964-01-10	1964-01-10 00:00:00	1964-02-14	1964-02-14 00:00:00	1964-02-14	38000177		0	0	35		0	0	0	129787	0	243670	19059056		
63539	5279	1127433	1988-05-15	1988-05-15 00:00:00	1988-05-22	1988-05-22 00:00:00	1988-05-22	38000177		0	0	7		0	0	0	351186	0	313782	1127433		
54867	1201	40213314	1977-09-21	1977-09-21 00:00:00	1977-09-21	1977-09-21 00:00:00	1977-09-21	581452		0	0	0		0	0	0	79009	0	49	40213314		
27799	2300	1713671	2001-01-24	2001-01-24 00:00:00	2001-01-31	2001-01-31 00:00:00	2001-01-31	38000177		0	0	7		0	0	0	153186	0	562251	1713671		
197499	4340	40213160	1973-06-01	1973-06-01 00:00:00	1973-06-01	1973-06-01 00:00:00	1973-06-01	581452		0	0	0		0	0	0	287790	0	10	40213160		
240407	5277	40213160	1959-12-16	1959-12-16 00:00:00	1959-12-16	1959-12-16 00:00:00	1959-12-16	581452		0	0	0		0	0	0	350993	0	10	40213160		
55307	4593	19059056	1965-11-29	1965-11-29 00:00:00	1965-12-13	1965-12-13 00:00:00	1965-12-13	38000177		0	0	14		0	0	0	306014	0	243670	19059056		
10051	842	1127433	1992-02-02	1992-02-02 00:00:00	1992-03-01	1992-03-01 00:00:00	1992-03-01	38000177		0	0	28		0	0	0	55661	0	313782	1127433		
9915	830	19059056	1965-11-19	1965-11-19 00:00:00	1965-12-24	1965-12-24 00:00:00	1965-12-24	38000177		0	0	35		0	0	0	55005	0	243670	19059056		
4079	337	1127433	1991-08-06	1991-08-06 00:00:00	1991-08-13	1991-08-13 00:00:00	1991-08-13	38000177		0	0	7		0	0	0	22422	0	313782	1127433		
236795	5199	40213260	2013-07-16	2013-07-16 00:00:00	2013-07-16	2013-07-16 00:00:00	2013-07-16	581452		0	0	0		0	0	0	345752	0	121	40213260		
238264	5230	40213198	2010-12-08	2010-12-08 00:00:00	2010-12-08	2010-12-08 00:00:00	2010-12-08	581452		0	0	0		0	0	0	347951	0	133	40213198		
79706	1744	40213160	1975-08-08	1975-08-08 00:00:00	1975-08-08	1975-08-08 00:00:00	1975-08-08	581452		0	0	0		0	0	0	116593	0	10	40213160		
10955	914	19059056	1967-04-17	1967-04-17 00:00:00	1967-05-08	1967-05-08 00:00:00	1967-05-08	38000177		0	0	21		0	0	0	60730	0	243670	19059056		
63611	5285	19126352	2007-02-25	2007-02-25 00:00:00	2008-07-06	2008-07-06 00:00:00	2008-07-06	38000177		0	0	497		0	0	0	351713	0	705129	19126352		
16546	1371	19128065	1989-03-19	1989-03-19 00:00:00	1990-03-14	1990-03-14 00:00:00	1990-03-14	38000177		0	0	360		0	0	0	90886	0	749882	19128065		
58144	4829	19078461	1994-10-10	1994-10-10 00:00:00	1994-11-07	1994-11-07 00:00:00	1994-11-07	38000177		0	0	28		0	0	0	321333	0	310965	19078461		
45792	3790	1713671	2019-01-31	2019-01-31 00:00:00	2019-03-07	2019-03-07 00:00:00	2019-03-07	38000177		0	0	35		0	0	0	252000	0	562251	1713671		
56315	4674	46233988	1969-01-17	1969-01-17 00:00:00	1969-01-31	1969-01-31 00:00:00	1969-01-31	38000177		0	0	14		0	0	0	311369	0	1652673	46233988		
31941	2647	40232448	1974-01-02	1974-01-02 00:00:00	1974-01-02	1974-01-02 00:00:00	\N	38000177		0	0	0		0	0	0	175147	0	1049630	40232448		
118110	2597	40213160	1971-08-03	1971-08-03 00:00:00	1971-08-03	1971-08-03 00:00:00	1971-08-03	581452		0	0	0		0	0	0	171843	0	10	40213160		
57550	4777	1127433	2004-08-21	2004-08-21 00:00:00	2004-08-28	2004-08-28 00:00:00	2004-08-28	38000177		0	0	7		0	0	0	318110	0	313782	1127433		
40848	3386	1127078	1974-11-14	1974-11-14 00:00:00	1974-11-28	1974-11-28 00:00:00	1974-11-28	38000177		0	0	14		0	0	0	224659	0	282464	1127078		
7617	640	1127433	1960-03-26	1960-03-26 00:00:00	1960-04-02	1960-04-02 00:00:00	1960-04-02	38000177		0	0	7		0	0	0	42368	0	313782	1127433		
40943	3394	46233710	1978-02-13	1978-02-13 00:00:00	1978-02-27	1978-02-27 00:00:00	1978-02-27	38000177		0	0	14		0	0	0	225144	0	1650142	46233710		
25309	552	40213201	2017-12-26	2017-12-26 00:00:00	2017-12-26	2017-12-26 00:00:00	2017-12-26	581452		0	0	0		0	0	0	36639	0	33	40213201		
106451	2334	40213201	2002-05-02	2002-05-02 00:00:00	2002-05-02	2002-05-02 00:00:00	2002-05-02	581452		0	0	0		0	0	0	155361	0	33	40213201		
60824	5058	1127433	1995-04-27	1995-04-27 00:00:00	1995-05-04	1995-05-04 00:00:00	1995-05-04	38000177		0	0	7		0	0	0	336285	0	313782	1127433		
58961	4898	1127433	1990-07-30	1990-07-30 00:00:00	1990-08-29	1990-08-29 00:00:00	1990-08-29	38000177		0	0	30		0	0	0	325705	0	313782	1127433		
177299	3896	40213160	1978-03-17	1978-03-17 00:00:00	1978-03-17	1978-03-17 00:00:00	1978-03-17	581452		0	0	0		0	0	0	259147	0	10	40213160		
31435	2604	40229134	2016-11-21	2016-11-21 00:00:00	2016-12-05	2016-12-05 00:00:00	2016-12-05	38000177		0	0	14		0	0	0	172279	0	1043400	40229134		
23185	1911	19059056	1950-05-17	1950-05-17 00:00:00	1950-05-31	1950-05-31 00:00:00	1950-05-31	38000177		0	0	14		0	0	0	127183	0	243670	19059056		
5537	462	40229134	2002-02-03	2002-02-03 00:00:00	2002-02-10	2002-02-10 00:00:00	2002-02-10	38000177		0	0	7		0	0	0	30884	0	1043400	40229134		
33749	2792	19059056	1972-03-22	1972-03-22 00:00:00	1972-04-05	1972-04-05 00:00:00	1972-04-05	38000177		0	0	14		0	0	0	185034	0	243670	19059056		
46130	3822	19006318	1947-04-13	1947-04-13 00:00:00	1947-04-27	1947-04-27 00:00:00	1947-04-27	38000177		0	0	14		0	0	0	253868	0	105078	19006318		
46256	3832	40229134	1993-08-23	1993-08-23 00:00:00	1993-08-30	1993-08-30 00:00:00	1993-08-30	38000177		0	0	7		0	0	0	254453	0	1043400	40229134		
34470	753	40213160	1972-09-03	1972-09-03 00:00:00	1972-09-03	1972-09-03 00:00:00	1972-09-03	581452		0	0	0		0	0	0	49752	0	10	40213160		
52717	4382	1127433	1965-06-16	1965-06-16 00:00:00	1965-06-30	1965-06-30 00:00:00	1965-06-30	38000177		0	0	14		0	0	0	291266	0	313782	1127433		
29697	2459	1127433	2006-06-16	2006-06-16 00:00:00	2006-06-23	2006-06-23 00:00:00	2006-06-23	38000177		0	0	7		0	0	0	163055	0	313782	1127433		
45385	3754	1127433	2017-05-18	2017-05-18 00:00:00	2017-06-24	2017-06-24 00:00:00	2017-06-24	38000177		0	0	37		0	0	0	249553	0	313782	1127433		
63301	5257	1713671	1994-10-12	1994-10-12 00:00:00	1994-10-26	1994-10-26 00:00:00	1994-10-26	38000177		0	0	14		0	0	0	349825	0	562251	1713671		
52007	4325	1713671	1989-07-01	1989-07-01 00:00:00	1989-07-08	1989-07-08 00:00:00	1989-07-08	38000177		0	0	7		0	0	0	286897	0	562251	1713671		
55958	4644	40229134	1964-03-27	1964-03-27 00:00:00	1964-04-10	1964-04-10 00:00:00	1964-04-10	38000177		0	0	14		0	0	0	309661	0	1043400	40229134		
22646	1860	1127433	1984-05-13	1984-05-13 00:00:00	1984-07-12	1984-07-12 00:00:00	1984-07-12	38000177		0	0	60		0	0	0	124403	0	313782	1127433		
99272	2174	40213160	1974-10-06	1974-10-06 00:00:00	1974-10-06	1974-10-06 00:00:00	1974-10-06	581452		0	0	0		0	0	0	144910	0	10	40213160		
110367	2424	40213227	1994-01-27	1994-01-27 00:00:00	1994-01-27	1994-01-27 00:00:00	1994-01-27	581452		0	0	0		0	0	0	160856	0	113	40213227		
110406	2425	40213306	1982-03-04	1982-03-04 00:00:00	1982-03-04	1982-03-04 00:00:00	1982-03-04	581452		0	0	0		0	0	0	160906	0	43	40213306		
203604	4470	40213160	1976-12-19	1976-12-19 00:00:00	1976-12-19	1976-12-19 00:00:00	1976-12-19	581452		0	0	0		0	0	0	297396	0	10	40213160		
61524	5119	46233988	1968-02-06	1968-02-06 00:00:00	1968-02-20	1968-02-20 00:00:00	1968-02-20	38000177		0	0	14		0	0	0	340367	0	1652673	46233988		
51761	1133	40213160	1965-10-15	1965-10-15 00:00:00	1965-10-15	1965-10-15 00:00:00	1965-10-15	581452		0	0	0		0	0	0	74603	0	10	40213160		
62283	1360	40213296	2017-10-08	2017-10-08 00:00:00	2017-10-08	2017-10-08 00:00:00	2017-10-08	581452		0	0	0		0	0	0	90241	0	52	40213296		
21055	1736	19128065	1988-04-08	1988-04-08 00:00:00	1989-04-03	1989-04-03 00:00:00	1989-04-03	38000177		0	0	360		0	0	0	115895	0	749882	19128065		
31578	2619	1127433	2011-07-26	2011-07-26 00:00:00	2011-08-02	2011-08-02 00:00:00	2011-08-02	38000177		0	0	7		0	0	0	173216	0	313782	1127433		
54463	4526	1127433	1962-10-23	1962-10-23 00:00:00	1962-11-06	1962-11-06 00:00:00	1962-11-06	38000177		0	0	14		0	0	0	301351	0	313782	1127433		
44148	3654	19078461	2016-10-18	2016-10-18 00:00:00	2016-11-21	2016-11-21 00:00:00	2016-11-21	38000177		0	0	34		0	0	0	243224	0	310965	19078461		
19764	1626	40220386	1989-12-17	1989-12-17 00:00:00	1989-12-17	1989-12-17 00:00:00	1989-12-17	38000177		0	0	0		0	0	0	109189	0	1808217	40220386		
38275	3167	19133905	1985-04-26	1985-04-26 00:00:00	1985-05-06	1985-05-06 00:00:00	1985-05-06	38000177		0	0	10		0	0	0	210585	0	834102	19133905		
226039	4964	40213160	1965-01-23	1965-01-23 00:00:00	1965-01-23	1965-01-23 00:00:00	1965-01-23	581452		0	0	0		0	0	0	329976	0	10	40213160		
240954	5290	40213296	1997-11-21	1997-11-21 00:00:00	1997-11-21	1997-11-21 00:00:00	1997-11-21	581452		0	0	0		0	0	0	352006	0	52	40213296		
23441	1929	1118084	1993-05-26	1993-05-26 00:00:00	1993-05-26	1993-05-26 00:00:00	\N	38000177		0	0	0		0	0	0	128434	0	00025152531	44923712		
135261	2969	40213160	1965-04-29	1965-04-29 00:00:00	1965-04-29	1965-04-29 00:00:00	1965-04-29	581452		0	0	0		0	0	0	198224	0	10	40213160		
51197	4253	1127433	1987-06-22	1987-06-22 00:00:00	1987-06-29	1987-06-29 00:00:00	1987-06-29	38000177		0	0	7		0	0	0	282440	0	313782	1127433		
209596	4596	40213201	2005-02-27	2005-02-27 00:00:00	2005-02-27	2005-02-27 00:00:00	2005-02-27	581452		0	0	0		0	0	0	306245	0	33	40213201		
46794	3876	1118084	2004-07-26	2004-07-26 00:00:00	2004-07-26	2004-07-26 00:00:00	\N	38000177		0	0	0		0	0	0	257536	0	00025152531	44923712		
23748	1952	40229134	2001-12-18	2001-12-18 00:00:00	2002-01-01	2002-01-01 00:00:00	2002-01-01	38000177		0	0	14		0	0	0	129817	0	1043400	40229134		
63540	5279	1127433	1954-05-16	1954-05-16 00:00:00	1954-05-30	1954-05-30 00:00:00	1954-05-30	38000177		0	0	14		0	0	0	351181	0	313782	1127433		
54869	1201	40213160	1977-09-21	1977-09-21 00:00:00	1977-09-21	1977-09-21 00:00:00	1977-09-21	581452		0	0	0		0	0	0	79009	0	10	40213160		
27800	2300	40169281	1974-11-14	1974-11-14 00:00:00	1974-11-14	1974-11-14 00:00:00	\N	38000177		0	0	0		0	0	0	153199	0	896209	40169281		
197503	4340	40213227	2005-04-01	2005-04-01 00:00:00	2005-04-01	2005-04-01 00:00:00	2005-04-01	581452		0	0	0		0	0	0	287785	0	113	40213227		
240408	5277	40213160	1955-04-13	1955-04-13 00:00:00	1955-04-13	1955-04-13 00:00:00	1955-04-13	581452		0	0	0		0	0	0	351035	0	10	40213160		
55308	4593	19129655	1966-05-18	1966-05-18 00:00:00	1966-06-01	1966-06-01 00:00:00	1966-06-01	38000177		0	0	14		0	0	0	306065	0	789980	19129655		
10052	842	40229134	1938-03-25	1938-03-25 00:00:00	1938-04-01	1938-04-01 00:00:00	1938-04-01	38000177		0	0	7		0	0	0	55655	0	1043400	40229134		
9916	830	1713671	2009-04-21	2009-04-21 00:00:00	2009-04-28	2009-04-28 00:00:00	2009-04-28	38000177		0	0	7		0	0	0	54945	0	562251	1713671		
4080	337	1127433	1986-02-04	1986-02-04 00:00:00	1986-02-18	1986-02-18 00:00:00	1986-02-18	38000177		0	0	14		0	0	0	22455	0	313782	1127433		
236797	5199	40213227	2013-07-16	2013-07-16 00:00:00	2013-07-16	2013-07-16 00:00:00	2013-07-16	581452		0	0	0		0	0	0	345752	0	113	40213227		
238271	5230	40213227	1996-01-10	1996-01-10 00:00:00	1996-01-10	1996-01-10 00:00:00	1996-01-10	581452		0	0	0		0	0	0	347966	0	113	40213227		
79707	1744	40213314	1978-04-07	1978-04-07 00:00:00	1978-04-07	1978-04-07 00:00:00	1978-04-07	581452		0	0	0		0	0	0	116633	0	49	40213314		
10956	914	1115171	2015-06-09	2015-06-09 00:00:00	2015-07-09	2015-07-09 00:00:00	2015-07-09	38000177		0	0	30		0	0	0	60733	0	849574	1115171		
63612	5285	1332419	2007-02-25	2007-02-25 00:00:00	2007-02-25	2007-02-25 00:00:00	\N	38000177		0	0	0		0	0	0	351713	0	197361	1332419		
16547	1371	1127433	2015-09-29	2015-09-29 00:00:00	2015-10-13	2015-10-13 00:00:00	2015-10-13	38000177		0	0	14		0	0	0	90926	0	313782	1127433		
217854	4781	40213227	2014-10-17	2014-10-17 00:00:00	2014-10-17	2014-10-17 00:00:00	2014-10-17	581452		0	0	0		0	0	0	318278	0	113	40213227		
45793	3790	1127078	1965-05-21	1965-05-21 00:00:00	1965-06-04	1965-06-04 00:00:00	1965-06-04	38000177		0	0	14		0	0	0	251982	0	282464	1127078		
56316	4674	1713671	1987-11-16	1987-11-16 00:00:00	1987-12-07	1987-12-07 00:00:00	1987-12-07	38000177		0	0	21		0	0	0	311379	0	562251	1713671		
31942	2647	19006318	1971-05-12	1971-05-12 00:00:00	1971-05-26	1971-05-26 00:00:00	1971-05-26	38000177		0	0	14		0	0	0	175219	0	105078	19006318		
118115	2597	40213160	1971-03-02	1971-03-02 00:00:00	1971-03-02	1971-03-02 00:00:00	1971-03-02	581452		0	0	0		0	0	0	171842	0	10	40213160		
57551	4777	19128065	1977-04-13	1977-04-13 00:00:00	1978-04-08	1978-04-08 00:00:00	1978-04-08	38000177		0	0	360		0	0	0	318079	0	749882	19128065		
40849	3386	46233988	1974-11-14	1974-11-14 00:00:00	1974-11-28	1974-11-28 00:00:00	1974-11-28	38000177		0	0	14		0	0	0	224659	0	1652673	46233988		
7618	640	1115171	2002-10-02	2002-10-02 00:00:00	2002-10-23	2002-10-23 00:00:00	2002-10-23	38000177		0	0	21		0	0	0	42330	0	849574	1115171		
2829	227	19006318	1974-04-04	1974-04-04 00:00:00	1974-04-18	1974-04-18 00:00:00	1974-04-18	38000177		0	0	14		0	0	0	15320	0	105078	19006318		
25313	552	40213227	2012-11-27	2012-11-27 00:00:00	2012-11-27	2012-11-27 00:00:00	2012-11-27	581452		0	0	0		0	0	0	36660	0	113	40213227		
42051	917	40213260	2014-05-22	2014-05-22 00:00:00	2014-05-22	2014-05-22 00:00:00	2014-05-22	581452		0	0	0		0	0	0	60987	0	121	40213260		
43502	948	40213160	1958-12-26	1958-12-26 00:00:00	1958-12-26	1958-12-26 00:00:00	1958-12-26	581452		0	0	0		0	0	0	62923	0	10	40213160		
58962	4898	1127433	1971-04-13	1971-04-13 00:00:00	1971-05-11	1971-05-11 00:00:00	1971-05-11	38000177		0	0	28		0	0	0	325704	0	313782	1127433		
177300	3896	40213314	1978-03-17	1978-03-17 00:00:00	1978-03-17	1978-03-17 00:00:00	1978-03-17	581452		0	0	0		0	0	0	259147	0	49	40213314		
31436	2604	1115171	2017-05-18	2017-05-18 00:00:00	2017-06-01	2017-06-01 00:00:00	2017-06-01	38000177		0	0	14		0	0	0	172299	0	849574	1115171		
23186	1911	19133873	1948-03-17	1948-03-17 00:00:00	1948-03-29	1948-03-29 00:00:00	1948-03-29	38000177		0	0	12		0	0	0	127164	0	834061	19133873		
5538	462	19128022	1993-08-28	1993-08-28 00:00:00	1994-08-23	1994-08-23 00:00:00	1994-08-23	38000177		0	0	360		0	0	0	30910	0	749785	19128022		
33750	2792	19133873	1968-12-28	1968-12-28 00:00:00	1969-01-04	1969-01-04 00:00:00	1969-01-04	38000177		0	0	7		0	0	0	184990	0	834061	19133873		
46131	3822	1127433	1972-08-31	1972-08-31 00:00:00	1972-09-14	1972-09-14 00:00:00	1972-09-14	38000177		0	0	14		0	0	0	253879	0	313782	1127433		
46257	3833	1127433	1999-02-14	1999-02-14 00:00:00	1999-02-28	1999-02-28 00:00:00	1999-02-28	38000177		0	0	14		0	0	0	254485	0	313782	1127433		
34474	753	40213227	2009-02-01	2009-02-01 00:00:00	2009-02-01	2009-02-01 00:00:00	2009-02-01	581452		0	0	0		0	0	0	49793	0	113	40213227		
52718	4382	19133905	2016-04-07	2016-04-07 00:00:00	2016-04-18	2016-04-18 00:00:00	2016-04-18	38000177		0	0	11		0	0	0	291240	0	834102	19133905		
29698	2460	19128022	2002-07-19	2002-07-19 00:00:00	2003-07-14	2003-07-14 00:00:00	2003-07-14	38000177		0	0	360		0	0	0	163117	0	749785	19128022		
45386	3754	19133873	1963-02-18	1963-02-18 00:00:00	1963-03-03	1963-03-03 00:00:00	1963-03-03	38000177		0	0	13		0	0	0	249501	0	834061	19133873		
63302	5258	40229134	1984-09-22	1984-09-22 00:00:00	1984-10-06	1984-10-06 00:00:00	1984-10-06	38000177		0	0	14		0	0	0	349850	0	1043400	40229134		
52008	4325	1713671	1980-12-18	1980-12-18 00:00:00	1981-01-08	1981-01-08 00:00:00	1981-01-08	38000177		0	0	21		0	0	0	286893	0	562251	1713671		
55959	4644	1127433	1970-03-14	1970-03-14 00:00:00	1970-03-21	1970-03-21 00:00:00	1970-03-21	38000177		0	0	7		0	0	0	309687	0	313782	1127433		
22647	1860	19059056	1960-12-15	1960-12-15 00:00:00	1960-12-29	1960-12-29 00:00:00	1960-12-29	38000177		0	0	14		0	0	0	124376	0	243670	19059056		
99276	2174	40213227	1997-03-09	1997-03-09 00:00:00	1997-03-09	1997-03-09 00:00:00	1997-03-09	581452		0	0	0		0	0	0	144904	0	113	40213227		
110371	2424	40213160	1967-05-25	1967-05-25 00:00:00	1967-05-25	1967-05-25 00:00:00	1967-05-25	581452		0	0	0		0	0	0	160858	0	10	40213160		
110408	2425	40213160	1965-01-28	1965-01-28 00:00:00	1965-01-28	1965-01-28 00:00:00	1965-01-28	581452		0	0	0		0	0	0	160883	0	10	40213160		
203611	4470	40213160	1972-09-17	1972-09-17 00:00:00	1972-09-17	1972-09-17 00:00:00	1972-09-17	581452		0	0	0		0	0	0	297383	0	10	40213160		
61525	5119	19059056	1968-02-06	1968-02-06 00:00:00	1968-02-20	1968-02-20 00:00:00	1968-02-20	38000177		0	0	14		0	0	0	340367	0	243670	19059056		
51766	1133	40213296	2005-07-15	2005-07-15 00:00:00	2005-07-15	2005-07-15 00:00:00	2005-07-15	581452		0	0	0		0	0	0	74632	0	52	40213296		
62285	1360	40213227	2017-10-08	2017-10-08 00:00:00	2017-10-08	2017-10-08 00:00:00	2017-10-08	581452		0	0	0		0	0	0	90241	0	113	40213227		
21056	1736	1713671	1980-08-13	1980-08-13 00:00:00	1980-08-20	1980-08-20 00:00:00	1980-08-20	38000177		0	0	7		0	0	0	115942	0	562251	1713671		
31579	2619	1127433	1943-09-18	1943-09-18 00:00:00	1943-10-02	1943-10-02 00:00:00	1943-10-02	38000177		0	0	14		0	0	0	173140	0	313782	1127433		
54464	4526	19059056	1962-08-19	1962-08-19 00:00:00	1962-09-02	1962-09-02 00:00:00	1962-09-02	38000177		0	0	14		0	0	0	301341	0	243670	19059056		
44149	3654	40229134	1975-01-14	1975-01-14 00:00:00	1975-01-21	1975-01-21 00:00:00	1975-01-21	38000177		0	0	7		0	0	0	243184	0	1043400	40229134		
19765	1626	40231925	1989-12-17	1989-12-17 00:00:00	1989-12-17	1989-12-17 00:00:00	\N	38000177		0	0	0		0	0	0	109189	0	1049221	40231925		
38276	3167	1127433	2011-09-30	2011-09-30 00:00:00	2011-10-30	2011-10-30 00:00:00	2011-10-30	38000177		0	0	30		0	0	0	210553	0	313782	1127433		
226043	4964	40213296	2003-09-27	2003-09-27 00:00:00	2003-09-27	2003-09-27 00:00:00	2003-09-27	581452		0	0	0		0	0	0	329980	0	52	40213296		
240962	5290	40213160	1955-04-15	1955-04-15 00:00:00	1955-04-15	1955-04-15 00:00:00	1955-04-15	581452		0	0	0		0	0	0	352000	0	10	40213160		
23442	1929	1713671	1981-10-12	1981-10-12 00:00:00	1981-10-26	1981-10-26 00:00:00	1981-10-26	38000177		0	0	14		0	0	0	128440	0	562251	1713671		
135265	2969	40213260	2015-01-22	2015-01-22 00:00:00	2015-01-22	2015-01-22 00:00:00	2015-01-22	581452		0	0	0		0	0	0	198198	0	121	40213260		
51198	4253	1115171	1995-03-09	1995-03-09 00:00:00	1995-04-07	1995-04-07 00:00:00	1995-04-07	38000177		0	0	29		0	0	0	282427	0	849574	1115171		
220887	4847	40213227	1994-06-08	1994-06-08 00:00:00	1994-06-08	1994-06-08 00:00:00	1994-06-08	581452		0	0	0		0	0	0	322417	0	113	40213227		
46795	3876	40232448	1971-06-11	1971-06-11 00:00:00	1971-06-11	1971-06-11 00:00:00	\N	38000177		0	0	0		0	0	0	257491	0	1049630	40232448		
23750	1953	40173590	2014-10-27	2014-10-27 00:00:00	2014-10-27	2014-10-27 00:00:00	\N	38000177		0	0	0		0	0	0	129945	0	904419	40173590		
63541	5279	1118084	1985-01-02	1985-01-02 00:00:00	1985-01-02	1985-01-02 00:00:00	\N	38000177		0	0	0		0	0	0	351166	0	00025152531	44923712		
54874	1201	40213227	1995-08-09	1995-08-09 00:00:00	1995-08-09	1995-08-09 00:00:00	1995-08-09	581452		0	0	0		0	0	0	79002	0	113	40213227		
27801	2300	19115351	1950-01-26	1950-01-26 00:00:00	1950-08-24	1950-08-24 00:00:00	1950-08-24	38000177		0	0	210		0	0	0	153124	0	563026	19115351		
197515	4340	40213227	2015-04-17	2015-04-17 00:00:00	2015-04-17	2015-04-17 00:00:00	2015-04-17	581452		0	0	0		0	0	0	287760	0	113	40213227		
240411	5277	40213260	2007-01-17	2007-01-17 00:00:00	2007-01-17	2007-01-17 00:00:00	2007-01-17	581452		0	0	0		0	0	0	351018	0	121	40213260		
55309	4593	1127078	1966-05-18	1966-05-18 00:00:00	1966-06-01	1966-06-01 00:00:00	1966-06-01	38000177		0	0	14		0	0	0	306065	0	282464	1127078		
10053	842	19059056	1968-11-15	1968-11-15 00:00:00	1968-11-29	1968-11-29 00:00:00	1968-11-29	38000177		0	0	14		0	0	0	55711	0	243670	19059056		
9939	834	19059056	1956-08-08	1956-08-08 00:00:00	1956-08-22	1956-08-22 00:00:00	1956-08-22	38000177		0	0	14		0	0	0	55183	0	243670	19059056		
4081	337	40236446	1973-09-19	1973-09-19 00:00:00	1977-09-28	1977-09-28 00:00:00	1977-09-28	38000177		0	0	1470		0	0	0	22453	0	1091392	40236446		
50270	1101	40213306	1997-06-22	1997-06-22 00:00:00	1997-06-22	1997-06-22 00:00:00	1997-06-22	581452		0	0	0		0	0	0	72313	0	43	40213306		
238273	5230	40213201	2011-12-14	2011-12-14 00:00:00	2011-12-14	2011-12-14 00:00:00	2011-12-14	581452		0	0	0		0	0	0	347977	0	33	40213201		
35087	2896	1127433	1987-05-23	1987-05-23 00:00:00	1987-05-30	1987-05-30 00:00:00	1987-05-30	38000177		0	0	7		0	0	0	192765	0	313782	1127433		
21415	1760	1713671	1981-03-08	1981-03-08 00:00:00	1981-03-15	1981-03-15 00:00:00	1981-03-15	38000177		0	0	7		0	0	0	117660	0	562251	1713671		
63613	5285	19075601	2007-02-25	2007-02-25 00:00:00	2008-07-06	2008-07-06 00:00:00	2008-07-06	38000177		0	0	497		0	0	0	351713	0	309362	19075601		
16548	1371	1118084	2008-02-23	2008-02-23 00:00:00	2008-02-23	2008-02-23 00:00:00	\N	38000177		0	0	0		0	0	0	90940	0	00025152531	44923712		
217855	4781	40213251	1986-09-12	1986-09-12 00:00:00	1986-09-12	1986-09-12 00:00:00	1986-09-12	581452		0	0	0		0	0	0	318261	0	21	40213251		
45794	3790	19129655	1965-05-21	1965-05-21 00:00:00	1965-06-04	1965-06-04 00:00:00	1965-06-04	38000177		0	0	14		0	0	0	251982	0	789980	19129655		
56317	4674	19078461	2017-06-28	2017-06-28 00:00:00	2017-08-27	2017-08-27 00:00:00	2017-08-27	38000177		0	0	60		0	0	0	311416	0	310965	19078461		
31943	2647	19059056	1971-05-12	1971-05-12 00:00:00	1971-05-26	1971-05-26 00:00:00	1971-05-26	38000177		0	0	14		0	0	0	175219	0	243670	19059056		
118118	2597	40213227	2004-06-15	2004-06-15 00:00:00	2004-06-15	2004-06-15 00:00:00	2004-06-15	581452		0	0	0		0	0	0	171821	0	113	40213227		
57552	4777	19059056	1959-01-08	1959-01-08 00:00:00	1959-01-22	1959-01-22 00:00:00	1959-01-22	38000177		0	0	14		0	0	0	318111	0	243670	19059056		
40850	3386	19133873	1982-06-04	1982-06-04 00:00:00	1982-06-12	1982-06-12 00:00:00	1982-06-12	38000177		0	0	8		0	0	0	224610	0	834061	19133873		
7621	642	1127433	1985-06-08	1985-06-08 00:00:00	1985-06-22	1985-06-22 00:00:00	1985-06-22	38000177		0	0	14		0	0	0	42539	0	313782	1127433		
2830	227	19128022	1996-07-17	1996-07-17 00:00:00	1997-07-12	1997-07-12 00:00:00	1997-07-12	38000177		0	0	360		0	0	0	15350	0	749785	19128022		
25320	552	40213227	1993-09-21	1993-09-21 00:00:00	1993-09-21	1993-09-21 00:00:00	1993-09-21	581452		0	0	0		0	0	0	36658	0	113	40213227		
42053	917	40213227	2014-05-22	2014-05-22 00:00:00	2014-05-22	2014-05-22 00:00:00	2014-05-22	581452		0	0	0		0	0	0	60987	0	113	40213227		
43503	948	40213160	1963-08-30	1963-08-30 00:00:00	1963-08-30	1963-08-30 00:00:00	1963-08-30	581452		0	0	0		0	0	0	62976	0	10	40213160		
58963	4898	1127433	1991-08-24	1991-08-24 00:00:00	1991-09-07	1991-09-07 00:00:00	1991-09-07	38000177		0	0	14		0	0	0	325706	0	313782	1127433		
177301	3896	40213160	1978-06-16	1978-06-16 00:00:00	1978-06-16	1978-06-16 00:00:00	1978-06-16	581452		0	0	0		0	0	0	259172	0	10	40213160		
31461	2609	1118084	1993-07-12	1993-07-12 00:00:00	1993-07-12	1993-07-12 00:00:00	\N	38000177		0	0	0		0	0	0	172515	0	00025152531	44923712		
23188	1911	19059056	1979-08-30	1979-08-30 00:00:00	1979-09-13	1979-09-13 00:00:00	1979-09-13	38000177		0	0	14		0	0	0	127176	0	243670	19059056		
5539	462	19074841	1992-06-17	1992-06-17 00:00:00	1992-07-01	1992-07-01 00:00:00	1992-07-01	38000177		0	0	14		0	0	0	30909	0	309043	19074841		
33751	2792	19059056	1958-02-04	1958-02-04 00:00:00	1958-02-18	1958-02-18 00:00:00	1958-02-18	38000177		0	0	14		0	0	0	184997	0	243670	19059056		
46132	3822	1713671	1980-03-07	1980-03-07 00:00:00	1980-03-28	1980-03-28 00:00:00	1980-03-28	38000177		0	0	21		0	0	0	253848	0	562251	1713671		
46258	3833	1115171	2005-10-27	2005-10-27 00:00:00	2005-11-10	2005-11-10 00:00:00	2005-11-10	38000177		0	0	14		0	0	0	254527	0	849574	1115171		
34475	753	40213296	2009-02-01	2009-02-01 00:00:00	2009-02-01	2009-02-01 00:00:00	2009-02-01	581452		0	0	0		0	0	0	49793	0	52	40213296		
149554	3289	40213260	2005-12-23	2005-12-23 00:00:00	2005-12-23	2005-12-23 00:00:00	2005-12-23	581452		0	0	0		0	0	0	218478	0	121	40213260		
29699	2460	19075001	1988-04-06	1988-04-06 00:00:00	1988-04-20	1988-04-20 00:00:00	1988-04-20	38000177		0	0	14		0	0	0	163093	0	309097	19075001		
45389	3756	1127433	2001-08-02	2001-08-02 00:00:00	2001-10-01	2001-10-01 00:00:00	2001-10-01	38000177		0	0	60		0	0	0	249664	0	313782	1127433		
63303	5258	1118084	1999-07-10	1999-07-10 00:00:00	1999-07-10	1999-07-10 00:00:00	\N	38000177		0	0	0		0	0	0	349920	0	00025152531	44923712		
25201	2075	1551192	1967-04-24	1967-04-24 00:00:00	1967-04-24	1967-04-24 00:00:00	1967-04-24	38000177		0	0	0		0	0	0	137999	0	312617	1551192		
55960	4644	1127433	2007-07-31	2007-07-31 00:00:00	2007-08-14	2007-08-14 00:00:00	2007-08-14	38000177		0	0	14		0	0	0	309668	0	313782	1127433		
22648	1860	19006318	1960-12-15	1960-12-15 00:00:00	1960-12-29	1960-12-29 00:00:00	1960-12-29	38000177		0	0	14		0	0	0	124376	0	105078	19006318		
99277	2174	40213306	1997-03-09	1997-03-09 00:00:00	1997-03-09	1997-03-09 00:00:00	1997-03-09	581452		0	0	0		0	0	0	144904	0	43	40213306		
110391	2425	40213160	1960-07-28	1960-07-28 00:00:00	1960-07-28	1960-07-28 00:00:00	1960-07-28	581452		0	0	0		0	0	0	160947	0	10	40213160		
110418	2425	40213260	2010-02-18	2010-02-18 00:00:00	2010-02-18	2010-02-18 00:00:00	2010-02-18	581452		0	0	0		0	0	0	160936	0	121	40213260		
203612	4470	40213160	1972-06-18	1972-06-18 00:00:00	1972-06-18	1972-06-18 00:00:00	1972-06-18	581452		0	0	0		0	0	0	297394	0	10	40213160		
61526	5119	19112599	1966-05-28	1966-05-28 00:00:00	1966-05-28	1966-05-28 00:00:00	\N	38000177		0	0	0		0	0	0	340372	0	477045	19112599		
51771	1133	40213160	1965-12-17	1965-12-17 00:00:00	1965-12-17	1965-12-17 00:00:00	1965-12-17	581452		0	0	0		0	0	0	74591	0	10	40213160		
21024	1733	19019979	1986-09-20	1986-09-20 00:00:00	1986-10-18	1986-10-18 00:00:00	1986-10-18	38000177		0	0	28		0	0	0	115803	0	198405	19019979		
21057	1736	1127078	1974-04-12	1974-04-12 00:00:00	1974-04-26	1974-04-26 00:00:00	1974-04-26	38000177		0	0	14		0	0	0	115944	0	282464	1127078		
31580	2619	1127433	2010-05-30	2010-05-30 00:00:00	2010-06-13	2010-06-13 00:00:00	2010-06-13	38000177		0	0	14		0	0	0	173210	0	313782	1127433		
54465	4526	19129655	1962-08-19	1962-08-19 00:00:00	1962-09-02	1962-09-02 00:00:00	1962-09-02	38000177		0	0	14		0	0	0	301341	0	789980	19129655		
44150	3655	1118084	1975-12-08	1975-12-08 00:00:00	1975-12-08	1975-12-08 00:00:00	\N	38000177		0	0	0		0	0	0	243327	0	00025152531	44923712		
19766	1626	42707627	1989-12-17	1989-12-17 00:00:00	1989-12-17	1989-12-17 00:00:00	1989-12-17	38000177		0	0	0		0	0	0	109189	0	1234995	42707627		
38277	3167	19133905	2011-09-29	2011-09-29 00:00:00	2011-10-10	2011-10-10 00:00:00	2011-10-10	38000177		0	0	11		0	0	0	210589	0	834102	19133905		
226048	4964	40213160	1960-07-23	1960-07-23 00:00:00	1960-07-23	1960-07-23 00:00:00	1960-07-23	581452		0	0	0		0	0	0	329973	0	10	40213160		
240969	5290	40213260	2007-06-15	2007-06-15 00:00:00	2007-06-15	2007-06-15 00:00:00	2007-06-15	581452		0	0	0		0	0	0	351968	0	121	40213260		
23443	1929	1713671	1962-11-11	1962-11-11 00:00:00	1962-12-02	1962-12-02 00:00:00	1962-12-02	38000177		0	0	21		0	0	0	128408	0	562251	1713671		
135267	2969	40213296	2005-11-17	2005-11-17 00:00:00	2005-11-17	2005-11-17 00:00:00	2005-11-17	581452		0	0	0		0	0	0	198230	0	52	40213296		
51199	4253	19128022	1995-12-14	1995-12-14 00:00:00	1996-12-08	1996-12-08 00:00:00	1996-12-08	38000177		0	0	360		0	0	0	282461	0	749785	19128022		
220894	4847	40213201	2010-03-10	2010-03-10 00:00:00	2010-03-10	2010-03-10 00:00:00	2010-03-10	581452		0	0	0		0	0	0	322479	0	33	40213201		
46796	3876	1127433	2017-12-23	2017-12-23 00:00:00	2018-01-22	2018-01-22 00:00:00	2018-01-22	38000177		0	0	30		0	0	0	257538	0	313782	1127433		
23751	1953	19059056	1969-05-06	1969-05-06 00:00:00	1969-05-20	1969-05-20 00:00:00	1969-05-20	38000177		0	0	14		0	0	0	129871	0	243670	19059056		
63542	5279	19133873	1949-12-09	1949-12-09 00:00:00	1949-12-22	1949-12-22 00:00:00	1949-12-22	38000177		0	0	13		0	0	0	351212	0	834061	19133873		
54875	1201	40213306	1995-08-09	1995-08-09 00:00:00	1995-08-09	1995-08-09 00:00:00	1995-08-09	581452		0	0	0		0	0	0	79002	0	43	40213306		
27802	2300	19059056	1955-12-26	1955-12-26 00:00:00	1956-03-25	1956-03-25 00:00:00	1956-03-25	38000177		0	0	90		0	0	0	153125	0	243670	19059056		
197516	4340	40213296	2015-04-17	2015-04-17 00:00:00	2015-04-17	2015-04-17 00:00:00	2015-04-17	581452		0	0	0		0	0	0	287760	0	52	40213296		
240414	5278	40213227	2000-10-06	2000-10-06 00:00:00	2000-10-06	2000-10-06 00:00:00	2000-10-06	581452		0	0	0		0	0	0	351047	0	113	40213227		
55310	4593	1713671	1996-10-08	1996-10-08 00:00:00	1996-10-22	1996-10-22 00:00:00	1996-10-22	38000177		0	0	14		0	0	0	306081	0	562251	1713671		
10054	842	1127433	1990-04-29	1990-04-29 00:00:00	1990-05-13	1990-05-13 00:00:00	1990-05-13	38000177		0	0	14		0	0	0	55713	0	313782	1127433		
9940	834	19006318	1956-08-08	1956-08-08 00:00:00	1956-08-22	1956-08-22 00:00:00	1956-08-22	38000177		0	0	14		0	0	0	55183	0	105078	19006318		
4082	337	1713671	1985-02-22	1985-02-22 00:00:00	1985-03-01	1985-03-01 00:00:00	1985-03-01	38000177		0	0	7		0	0	0	22454	0	562251	1713671		
50272	1101	40213227	1997-06-22	1997-06-22 00:00:00	1997-06-22	1997-06-22 00:00:00	1997-06-22	581452		0	0	0		0	0	0	72313	0	113	40213227		
11357	244	40213227	1993-07-12	1993-07-12 00:00:00	1993-07-12	1993-07-12 00:00:00	1993-07-12	581452		0	0	0		0	0	0	\N	0	113	40213227		
35088	2896	19112599	1974-04-12	1974-04-12 00:00:00	1974-04-12	1974-04-12 00:00:00	\N	38000177		0	0	0		0	0	0	192763	0	477045	19112599		
21416	1761	1127433	1985-12-21	1985-12-21 00:00:00	1986-01-04	1986-01-04 00:00:00	1986-01-04	38000177		0	0	14		0	0	0	117770	0	313782	1127433		
63614	5285	1539411	2007-02-25	2007-02-25 00:00:00	2007-02-25	2007-02-25 00:00:00	\N	38000177		0	0	0		0	0	0	351713	0	312961	1539411		
16549	1371	19059056	1972-02-07	1972-02-07 00:00:00	1972-03-13	1972-03-13 00:00:00	1972-03-13	38000177		0	0	35		0	0	0	90893	0	243670	19059056		
217857	4781	40213160	1986-09-12	1986-09-12 00:00:00	1986-09-12	1986-09-12 00:00:00	1986-09-12	581452		0	0	0		0	0	0	318261	0	10	40213160		
45795	3790	1127078	1966-06-29	1966-06-29 00:00:00	1966-07-13	1966-07-13 00:00:00	1966-07-13	38000177		0	0	14		0	0	0	251970	0	282464	1127078		
56318	4674	40162522	2017-06-28	2017-06-28 00:00:00	2017-06-28	2017-06-28 00:00:00	\N	38000177		0	0	0		0	0	0	311416	0	857005	40162522		
31944	2647	920300	2006-01-14	2006-01-14 00:00:00	2006-01-21	2006-01-21 00:00:00	2006-01-21	38000177		0	0	7		0	0	0	175119	0	311989	920300		
118123	2598	40213160	1974-09-17	1974-09-17 00:00:00	1974-09-17	1974-09-17 00:00:00	1974-09-17	581452		0	0	0		0	0	0	171931	0	10	40213160		
57553	4777	19006318	1959-01-08	1959-01-08 00:00:00	1959-01-22	1959-01-22 00:00:00	1959-01-22	38000177		0	0	14		0	0	0	318111	0	105078	19006318		
40851	3386	19078461	1988-12-31	1988-12-31 00:00:00	1989-01-21	1989-01-21 00:00:00	1989-01-21	38000177		0	0	21		0	0	0	224631	0	310965	19078461		
7622	642	1713671	2005-08-17	2005-08-17 00:00:00	2005-08-24	2005-08-24 00:00:00	2005-08-24	38000177		0	0	7		0	0	0	42491	0	562251	1713671		
2831	227	19128065	1987-09-03	1987-09-03 00:00:00	1988-08-28	1988-08-28 00:00:00	1988-08-28	38000177		0	0	360		0	0	0	15322	0	749882	19128065		
25333	552	40213160	1955-08-30	1955-08-30 00:00:00	1955-08-30	1955-08-30 00:00:00	1955-08-30	581452		0	0	0		0	0	0	36632	0	10	40213160		
42057	917	40213160	1968-04-25	1968-04-25 00:00:00	1968-04-25	1968-04-25 00:00:00	1968-04-25	581452		0	0	0		0	0	0	61011	0	10	40213160		
43510	948	40213306	1981-06-12	1981-06-12 00:00:00	1981-06-12	1981-06-12 00:00:00	1981-06-12	581452		0	0	0		0	0	0	62933	0	43	40213306		
58964	4898	1127433	1966-09-20	1966-09-20 00:00:00	1966-10-04	1966-10-04 00:00:00	1966-10-04	38000177		0	0	14		0	0	0	325678	0	313782	1127433		
177306	3896	40213227	2000-02-25	2000-02-25 00:00:00	2000-02-25	2000-02-25 00:00:00	2000-02-25	581452		0	0	0		0	0	0	259178	0	113	40213227		
31462	2609	19133905	2013-04-11	2013-04-11 00:00:00	2013-04-22	2013-04-22 00:00:00	2013-04-22	38000177		0	0	11		0	0	0	172499	0	834102	19133905		
23189	1911	19133873	1960-01-13	1960-01-13 00:00:00	1960-01-23	1960-01-23 00:00:00	1960-01-23	38000177		0	0	10		0	0	0	127166	0	834061	19133873		
5540	462	1127433	1992-06-17	1992-06-17 00:00:00	1992-07-01	1992-07-01 00:00:00	1992-07-01	38000177		0	0	14		0	0	0	30909	0	313782	1127433		
33752	2792	19006318	1958-02-04	1958-02-04 00:00:00	1958-02-18	1958-02-18 00:00:00	1958-02-18	38000177		0	0	14		0	0	0	184997	0	105078	19006318		
46133	3822	19059056	1969-05-22	1969-05-22 00:00:00	1969-06-19	1969-06-19 00:00:00	1969-06-19	38000177		0	0	28		0	0	0	253835	0	243670	19059056		
46259	3833	1713671	2008-10-29	2008-10-29 00:00:00	2008-11-05	2008-11-05 00:00:00	2008-11-05	38000177		0	0	7		0	0	0	254540	0	562251	1713671		
34483	753	40213160	1968-03-03	1968-03-03 00:00:00	1968-03-03	1968-03-03 00:00:00	1968-03-03	581452		0	0	0		0	0	0	49749	0	10	40213160		
149557	3289	40213227	2006-12-29	2006-12-29 00:00:00	2006-12-29	2006-12-29 00:00:00	2006-12-29	581452		0	0	0		0	0	0	218502	0	113	40213227		
29700	2460	1127078	1988-04-06	1988-04-06 00:00:00	1988-04-20	1988-04-20 00:00:00	1988-04-20	38000177		0	0	14		0	0	0	163093	0	282464	1127078		
45390	3756	1127433	1970-04-07	1970-04-07 00:00:00	1970-04-21	1970-04-21 00:00:00	1970-04-21	38000177		0	0	14		0	0	0	249679	0	313782	1127433		
63304	5258	1127078	1968-01-14	1968-01-14 00:00:00	1968-02-13	1968-02-13 00:00:00	1968-02-13	38000177		0	0	30		0	0	0	349869	0	282464	1127078		
25202	2075	1127433	1980-06-14	1980-06-14 00:00:00	1980-07-19	1980-07-19 00:00:00	1980-07-19	38000177		0	0	35		0	0	0	138000	0	313782	1127433		
55961	4644	1127078	1965-03-08	1965-03-08 00:00:00	1965-03-22	1965-03-22 00:00:00	1965-03-22	38000177		0	0	14		0	0	0	309680	0	282464	1127078		
22649	1860	1539411	1992-08-10	1992-08-10 00:00:00	1992-08-10	1992-08-10 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	312961	1539411		
110308	2423	40213160	1961-10-02	1961-10-02 00:00:00	1961-10-02	1961-10-02 00:00:00	1961-10-02	581452		0	0	0		0	0	0	160759	0	10	40213160		
161735	3558	40213160	1964-02-08	1964-02-08 00:00:00	1964-02-08	1964-02-08 00:00:00	1964-02-08	581452		0	0	0		0	0	0	236224	0	10	40213160		
110421	2425	40213160	1960-05-26	1960-05-26 00:00:00	1960-05-26	1960-05-26 00:00:00	1960-05-26	581452		0	0	0		0	0	0	160924	0	10	40213160		
203614	4470	40213160	1972-04-16	1972-04-16 00:00:00	1972-04-16	1972-04-16 00:00:00	1972-04-16	581452		0	0	0		0	0	0	297382	0	10	40213160		
61527	5119	1127433	1980-12-09	1980-12-09 00:00:00	1980-12-23	1980-12-23 00:00:00	1980-12-23	38000177		0	0	14		0	0	0	340315	0	313782	1127433		
51774	1133	40213306	1988-06-17	1988-06-17 00:00:00	1988-06-17	1988-06-17 00:00:00	1988-06-17	581452		0	0	0		0	0	0	74624	0	43	40213306		
21025	1733	1713671	2011-12-30	2011-12-30 00:00:00	2012-01-13	2012-01-13 00:00:00	2012-01-13	38000177		0	0	14		0	0	0	115815	0	562251	1713671		
21058	1736	40229134	1999-06-20	1999-06-20 00:00:00	1999-07-04	1999-07-04 00:00:00	1999-07-04	38000177		0	0	14		0	0	0	115900	0	1043400	40229134		
31581	2619	1118084	1978-08-18	1978-08-18 00:00:00	1978-08-18	1978-08-18 00:00:00	\N	38000177		0	0	0		0	0	0	173143	0	00025152531	44923712		
54466	4526	19133905	1997-07-29	1997-07-29 00:00:00	1997-08-10	1997-08-10 00:00:00	1997-08-10	38000177		0	0	12		0	0	0	301365	0	834102	19133905		
44151	3655	19133873	1948-11-02	1948-11-02 00:00:00	1948-11-11	1948-11-11 00:00:00	1948-11-11	38000177		0	0	9		0	0	0	243292	0	834061	19133873		
19767	1626	46275444	1989-12-17	1989-12-17 00:00:00	1989-12-17	1989-12-17 00:00:00	1989-12-17	38000177		0	0	0		0	0	0	109189	0	1659149	46275444		
38278	3167	19078461	1979-02-17	1979-02-17 00:00:00	1979-03-03	1979-03-03 00:00:00	1979-03-03	38000177		0	0	14		0	0	0	210550	0	310965	19078461		
226053	4964	40213160	1960-05-21	1960-05-21 00:00:00	1960-05-21	1960-05-21 00:00:00	1960-05-21	581452		0	0	0		0	0	0	329993	0	10	40213160		
198134	4353	40213260	2016-09-11	2016-09-11 00:00:00	2016-09-11	2016-09-11 00:00:00	2016-09-11	581452		0	0	0		0	0	0	288738	0	121	40213260		
23444	1929	1713671	1989-07-23	1989-07-23 00:00:00	1989-08-06	1989-08-06 00:00:00	1989-08-06	38000177		0	0	14		0	0	0	128425	0	562251	1713671		
135271	2969	40213260	2016-01-28	2016-01-28 00:00:00	2016-01-28	2016-01-28 00:00:00	2016-01-28	581452		0	0	0		0	0	0	198232	0	121	40213260		
51201	4255	1713671	2006-10-11	2006-10-11 00:00:00	2006-10-25	2006-10-25 00:00:00	2006-10-25	38000177		0	0	14		0	0	0	282528	0	562251	1713671		
220895	4847	40213198	2010-03-10	2010-03-10 00:00:00	2010-03-10	2010-03-10 00:00:00	2010-03-10	581452		0	0	0		0	0	0	322479	0	133	40213198		
46797	3876	19133873	1977-05-03	1977-05-03 00:00:00	1977-05-12	1977-05-12 00:00:00	1977-05-12	38000177		0	0	9		0	0	0	257432	0	834061	19133873		
23752	1953	19129655	1969-05-06	1969-05-06 00:00:00	1969-05-20	1969-05-20 00:00:00	1969-05-20	38000177		0	0	14		0	0	0	129871	0	789980	19129655		
63543	5279	1127433	1965-05-17	1965-05-17 00:00:00	1965-05-31	1965-05-31 00:00:00	1965-05-31	38000177		0	0	14		0	0	0	351134	0	313782	1127433		
54878	1201	40213160	1973-01-17	1973-01-17 00:00:00	1973-01-17	1973-01-17 00:00:00	1973-01-17	581452		0	0	0		0	0	0	79030	0	10	40213160		
27803	2300	1127433	2004-09-26	2004-09-26 00:00:00	2004-10-31	2004-10-31 00:00:00	2004-10-31	38000177		0	0	35		0	0	0	153130	0	313782	1127433		
34377	2841	19126352	1983-09-11	1983-09-11 00:00:00	1984-10-21	1984-10-21 00:00:00	1984-10-21	38000177		0	0	406		0	0	0	188599	0	705129	19126352		
240419	5278	40213296	2010-01-08	2010-01-08 00:00:00	2010-01-08	2010-01-08 00:00:00	2010-01-08	581452		0	0	0		0	0	0	351050	0	52	40213296		
55311	4593	19078461	1978-09-21	1978-09-21 00:00:00	1978-10-12	1978-10-12 00:00:00	1978-10-12	38000177		0	0	21		0	0	0	306050	0	310965	19078461		
10055	842	1713671	1937-01-20	1937-01-20 00:00:00	1937-02-03	1937-02-03 00:00:00	1937-02-03	38000177		0	0	14		0	0	0	55637	0	562251	1713671		
9941	834	1713671	2012-03-16	2012-03-16 00:00:00	2012-04-06	2012-04-06 00:00:00	2012-04-06	38000177		0	0	21		0	0	0	55213	0	562251	1713671		
17689	1466	19128065	1987-02-04	1987-02-04 00:00:00	1988-01-30	1988-01-30 00:00:00	1988-01-30	38000177		0	0	360		0	0	0	97623	0	749882	19128065		
50275	1101	40213227	2016-08-28	2016-08-28 00:00:00	2016-08-28	2016-08-28 00:00:00	2016-08-28	581452		0	0	0		0	0	0	72315	0	113	40213227		
11367	244	40213201	1989-01-16	1989-01-16 00:00:00	1989-01-16	1989-01-16 00:00:00	1989-01-16	581452		0	0	0		0	0	0	16325	0	33	40213201		
35089	2896	46233988	1970-10-14	1970-10-14 00:00:00	1970-10-28	1970-10-28 00:00:00	1970-10-28	38000177		0	0	14		0	0	0	192805	0	1652673	46233988		
21417	1761	1713671	1980-04-25	1980-04-25 00:00:00	1980-05-17	1980-05-17 00:00:00	1980-05-17	38000177		0	0	22		0	0	0	117788	0	562251	1713671		
63615	5285	1127433	1985-05-08	1985-05-08 00:00:00	1985-05-22	1985-05-22 00:00:00	1985-05-22	38000177		0	0	14		0	0	0	351689	0	313782	1127433		
16550	1371	1127433	1985-03-02	1985-03-02 00:00:00	1985-03-09	1985-03-09 00:00:00	1985-03-09	38000177		0	0	7		0	0	0	90898	0	313782	1127433		
217867	4781	40213314	1982-03-12	1982-03-12 00:00:00	1982-03-12	1982-03-12 00:00:00	1982-03-12	581452		0	0	0		0	0	0	318258	0	49	40213314		
45796	3790	1127433	2005-05-01	2005-05-01 00:00:00	2005-05-08	2005-05-08 00:00:00	2005-05-08	38000177		0	0	7		0	0	0	251981	0	313782	1127433		
56319	4675	1713671	1930-03-22	1930-03-22 00:00:00	1930-03-29	1930-03-29 00:00:00	1930-03-29	38000177		0	0	7		0	0	0	311545	0	562251	1713671		
31945	2647	40236824	2006-01-14	2006-01-14 00:00:00	2006-01-28	2006-01-28 00:00:00	2006-01-28	38000177		0	0	14		0	0	0	175119	0	1094107	40236824		
118127	2598	40213306	1994-03-01	1994-03-01 00:00:00	1994-03-01	1994-03-01 00:00:00	1994-03-01	581452		0	0	0		0	0	0	\N	0	43	40213306		
57554	4777	1115171	2004-03-17	2004-03-17 00:00:00	2004-04-07	2004-04-07 00:00:00	2004-04-07	38000177		0	0	21		0	0	0	318097	0	849574	1115171		
40852	3386	19133905	2012-04-06	2012-04-06 00:00:00	2012-04-17	2012-04-17 00:00:00	2012-04-17	38000177		0	0	11		0	0	0	224636	0	834102	19133905		
7623	642	1713671	1955-06-09	1955-06-09 00:00:00	1955-06-16	1955-06-16 00:00:00	1955-06-16	38000177		0	0	7		0	0	0	42486	0	562251	1713671		
2832	227	19078461	2019-05-06	2019-05-06 00:00:00	2019-05-27	2019-05-27 00:00:00	2019-05-27	38000177		0	0	21		0	0	0	15314	0	310965	19078461		
113622	2497	40213260	2011-10-13	2011-10-13 00:00:00	2011-10-13	2011-10-13 00:00:00	2011-10-13	581452		0	0	0		0	0	0	165371	0	121	40213260		
42062	917	40213227	1995-03-16	1995-03-16 00:00:00	1995-03-16	1995-03-16 00:00:00	1995-03-16	581452		0	0	0		0	0	0	61035	0	113	40213227		
43512	948	40213260	2008-09-19	2008-09-19 00:00:00	2008-09-19	2008-09-19 00:00:00	2008-09-19	581452		0	0	0		0	0	0	62938	0	121	40213260		
58965	4898	1127433	1983-03-29	1983-03-29 00:00:00	1983-04-12	1983-04-12 00:00:00	1983-04-12	38000177		0	0	14		0	0	0	325691	0	313782	1127433		
177307	3896	40213306	2000-02-25	2000-02-25 00:00:00	2000-02-25	2000-02-25 00:00:00	2000-02-25	581452		0	0	0		0	0	0	259178	0	43	40213306		
31463	2609	1713671	1993-12-04	1993-12-04 00:00:00	1993-12-18	1993-12-18 00:00:00	1993-12-18	38000177		0	0	14		0	0	0	172502	0	562251	1713671		
159517	3510	40213227	2016-12-02	2016-12-02 00:00:00	2016-12-02	2016-12-02 00:00:00	2016-12-02	581452		0	0	0		0	0	0	232858	0	113	40213227		
5541	462	920300	1999-10-14	1999-10-14 00:00:00	1999-10-21	1999-10-21 00:00:00	1999-10-21	38000177		0	0	7		0	0	0	30907	0	311989	920300		
33753	2792	1127433	1962-10-12	1962-10-12 00:00:00	1962-10-19	1962-10-19 00:00:00	1962-10-19	38000177		0	0	7		0	0	0	185024	0	313782	1127433		
46134	3822	19059056	1964-06-03	1964-06-03 00:00:00	1964-06-17	1964-06-17 00:00:00	1964-06-17	38000177		0	0	14		0	0	0	253833	0	243670	19059056		
46260	3833	46233988	1970-10-15	1970-10-15 00:00:00	1970-10-29	1970-10-29 00:00:00	1970-10-29	38000177		0	0	14		0	0	0	254541	0	1652673	46233988		
34489	754	40213227	2018-12-18	2018-12-18 00:00:00	2018-12-18	2018-12-18 00:00:00	2018-12-18	581452		0	0	0		0	0	0	49976	0	113	40213227		
149558	3289	40213260	2006-12-29	2006-12-29 00:00:00	2006-12-29	2006-12-29 00:00:00	2006-12-29	581452		0	0	0		0	0	0	218502	0	121	40213260		
34545	754	40213227	1999-02-02	1999-02-02 00:00:00	1999-02-02	1999-02-02 00:00:00	1999-02-02	581452		0	0	0		0	0	0	49837	0	113	40213227		
45391	3756	19059056	1953-06-16	1953-06-16 00:00:00	1953-08-15	1953-08-15 00:00:00	1953-08-15	38000177		0	0	60		0	0	0	249711	0	243670	19059056		
63305	5258	19129655	1962-11-23	1962-11-23 00:00:00	1962-12-07	1962-12-07 00:00:00	1962-12-07	38000177		0	0	14		0	0	0	349854	0	789980	19129655		
25203	2075	19133873	1982-06-07	1982-06-07 00:00:00	1982-06-20	1982-06-20 00:00:00	1982-06-20	38000177		0	0	13		0	0	0	138117	0	834061	19133873		
55962	4644	19129655	1965-03-08	1965-03-08 00:00:00	1965-03-22	1965-03-22 00:00:00	1965-03-22	38000177		0	0	14		0	0	0	309680	0	789980	19129655		
22650	1860	46275916	1997-07-07	1997-07-07 00:00:00	1997-07-07	1997-07-07 00:00:00	1997-07-07	38000177		0	0	0		0	0	0	124408	0	1660014	46275916		
110313	2423	40213227	1998-11-02	1998-11-02 00:00:00	1998-11-02	1998-11-02 00:00:00	1998-11-02	581452		0	0	0		0	0	0	160787	0	113	40213227		
161738	3558	40213296	2001-04-07	2001-04-07 00:00:00	2001-04-07	2001-04-07 00:00:00	2001-04-07	581452		0	0	0		0	0	0	236186	0	52	40213296		
110424	2425	40213296	2000-02-24	2000-02-24 00:00:00	2000-02-24	2000-02-24 00:00:00	2000-02-24	581452		0	0	0		0	0	0	160895	0	52	40213296		
203616	4470	40213227	1994-03-13	1994-03-13 00:00:00	1994-03-13	1994-03-13 00:00:00	1994-03-13	581452		0	0	0		0	0	0	297340	0	113	40213227		
61528	5119	1118084	2001-08-16	2001-08-16 00:00:00	2001-08-16	2001-08-16 00:00:00	\N	38000177		0	0	0		0	0	0	340396	0	00025152531	44923712		
51783	1134	40213201	2005-11-27	2005-11-27 00:00:00	2005-11-27	2005-11-27 00:00:00	2005-11-27	581452		0	0	0		0	0	0	74704	0	33	40213201		
21026	1733	1127078	1989-08-03	1989-08-03 00:00:00	1989-10-09	1989-10-09 00:00:00	1989-10-09	38000177		0	0	67		0	0	0	115804	0	282464	1127078		
21059	1736	1115171	2010-07-02	2010-07-02 00:00:00	2010-09-30	2010-09-30 00:00:00	2010-09-30	38000177		0	0	90		0	0	0	115958	0	849574	1115171		
31582	2619	19059056	1941-01-29	1941-01-29 00:00:00	1941-02-12	1941-02-12 00:00:00	1941-02-12	38000177		0	0	14		0	0	0	173169	0	243670	19059056		
54467	4527	1127433	1963-08-26	1963-08-26 00:00:00	1963-09-02	1963-09-02 00:00:00	1963-09-02	38000177		0	0	7		0	0	0	301420	0	313782	1127433		
44152	3655	19133873	1949-05-12	1949-05-12 00:00:00	1949-05-19	1949-05-19 00:00:00	1949-05-19	38000177		0	0	7		0	0	0	243249	0	834061	19133873		
19768	1626	35605858	1989-12-17	1989-12-17 00:00:00	1989-12-17	1989-12-17 00:00:00	1989-12-17	38000177		0	0	0		0	0	0	109189	0	1732136	35605858		
38279	3167	1713671	1990-05-25	1990-05-25 00:00:00	1990-08-31	1990-08-31 00:00:00	1990-08-31	38000177		0	0	98		0	0	0	210594	0	562251	1713671		
226058	4964	40213227	1993-09-11	1993-09-11 00:00:00	1993-09-11	1993-09-11 00:00:00	1993-09-11	581452		0	0	0		0	0	0	330000	0	113	40213227		
198135	4353	40213160	1966-11-13	1966-11-13 00:00:00	1966-11-13	1966-11-13 00:00:00	1966-11-13	581452		0	0	0		0	0	0	288822	0	10	40213160		
23445	1929	19006318	1957-08-15	1957-08-15 00:00:00	1957-08-29	1957-08-29 00:00:00	1957-08-29	38000177		0	0	14		0	0	0	128441	0	105078	19006318		
135273	2969	40213227	2016-01-28	2016-01-28 00:00:00	2016-01-28	2016-01-28 00:00:00	2016-01-28	581452		0	0	0		0	0	0	198232	0	113	40213227		
51202	4255	1118084	2010-02-03	2010-02-03 00:00:00	2010-02-03	2010-02-03 00:00:00	\N	38000177		0	0	0		0	0	0	282494	0	00025152531	44923712		
220904	4848	40213227	1994-09-25	1994-09-25 00:00:00	1994-09-25	1994-09-25 00:00:00	1994-09-25	581452		0	0	0		0	0	0	322519	0	113	40213227		
46798	3876	19019979	1977-07-28	1977-07-28 00:00:00	1977-08-25	1977-08-25 00:00:00	1977-08-25	38000177		0	0	28		0	0	0	257430	0	198405	19019979		
23753	1953	1127433	1993-07-26	1993-07-26 00:00:00	1993-08-09	1993-08-09 00:00:00	1993-08-09	38000177		0	0	14		0	0	0	129907	0	313782	1127433		
63544	5279	1127433	1965-11-19	1965-11-19 00:00:00	1965-11-26	1965-11-26 00:00:00	1965-11-26	38000177		0	0	7		0	0	0	351183	0	313782	1127433		
54883	1201	40213227	2014-10-22	2014-10-22 00:00:00	2014-10-22	2014-10-22 00:00:00	2014-10-22	581452		0	0	0		0	0	0	79012	0	113	40213227		
27804	2300	40229134	1974-11-08	1974-11-08 00:00:00	1974-11-15	1974-11-15 00:00:00	1974-11-15	38000177		0	0	7		0	0	0	153205	0	1043400	40229134		
34378	2841	19133768	1994-08-21	1994-08-21 00:00:00	1994-08-21	1994-08-21 00:00:00	1994-08-21	38000177		0	0	0		0	0	0	188636	0	833036	19133768		
108521	2380	40213198	2016-01-30	2016-01-30 00:00:00	2016-01-30	2016-01-30 00:00:00	2016-01-30	581452		0	0	0		0	0	0	158183	0	133	40213198		
55312	4593	19128065	1979-08-29	1979-08-29 00:00:00	1980-08-23	1980-08-23 00:00:00	1980-08-23	38000177		0	0	360		0	0	0	306066	0	749882	19128065		
10056	842	1713671	1950-12-04	1950-12-04 00:00:00	1950-12-11	1950-12-11 00:00:00	1950-12-11	38000177		0	0	7		0	0	0	55643	0	562251	1713671		
9942	834	1127433	2014-05-17	2014-05-17 00:00:00	2014-05-24	2014-05-24 00:00:00	2014-05-24	38000177		0	0	7		0	0	0	55181	0	313782	1127433		
17690	1466	1115171	1998-03-12	1998-03-12 00:00:00	1998-03-26	1998-03-26 00:00:00	1998-03-26	38000177		0	0	14		0	0	0	97664	0	849574	1115171		
50276	1101	40213296	2016-08-28	2016-08-28 00:00:00	2016-08-28	2016-08-28 00:00:00	2016-08-28	581452		0	0	0		0	0	0	72315	0	52	40213296		
236799	5199	40213160	1962-04-24	1962-04-24 00:00:00	1962-04-24	1962-04-24 00:00:00	1962-04-24	581452		0	0	0		0	0	0	345786	0	10	40213160		
35090	2896	19059056	1970-10-14	1970-10-14 00:00:00	1970-10-28	1970-10-28 00:00:00	1970-10-28	38000177		0	0	14		0	0	0	192805	0	243670	19059056		
21418	1761	19128065	1975-07-06	1975-07-06 00:00:00	1976-06-30	1976-06-30 00:00:00	1976-06-30	38000177		0	0	360		0	0	0	117713	0	749882	19128065		
63616	5285	1127433	1968-12-20	1968-12-20 00:00:00	1968-12-27	1968-12-27 00:00:00	1968-12-27	38000177		0	0	7		0	0	0	351698	0	313782	1127433		
48523	4020	40173590	2016-04-28	2016-04-28 00:00:00	2016-04-28	2016-04-28 00:00:00	\N	38000177		0	0	0		0	0	0	267275	0	904419	40173590		
217870	4781	40213227	2002-10-04	2002-10-04 00:00:00	2002-10-04	2002-10-04 00:00:00	2002-10-04	581452		0	0	0		0	0	0	318272	0	113	40213227		
45797	3790	1127433	1981-03-29	1981-03-29 00:00:00	1981-04-05	1981-04-05 00:00:00	1981-04-05	38000177		0	0	7		0	0	0	252021	0	313782	1127433		
56320	4675	1713671	1980-06-19	1980-06-19 00:00:00	1980-07-10	1980-07-10 00:00:00	1980-07-10	38000177		0	0	21		0	0	0	311432	0	562251	1713671		
31946	2647	1127433	1988-01-31	1988-01-31 00:00:00	1988-02-07	1988-02-07 00:00:00	1988-02-07	38000177		0	0	7		0	0	0	175114	0	313782	1127433		
118131	2598	40213227	2007-05-01	2007-05-01 00:00:00	2007-05-01	2007-05-01 00:00:00	2007-05-01	581452		0	0	0		0	0	0	171905	0	113	40213227		
57555	4777	1127433	1990-10-18	1990-10-18 00:00:00	1990-11-01	1990-11-01 00:00:00	1990-11-01	38000177		0	0	14		0	0	0	318085	0	313782	1127433		
40863	3389	1127433	1976-07-28	1976-07-28 00:00:00	1976-09-26	1976-09-26 00:00:00	1976-09-26	38000177		0	0	60		0	0	0	224744	0	313782	1127433		
7624	642	1115171	2017-11-18	2017-11-18 00:00:00	2017-12-18	2017-12-18 00:00:00	2017-12-18	38000177		0	0	30		0	0	0	42576	0	849574	1115171		
2860	232	19059056	1958-02-26	1958-02-26 00:00:00	1958-03-12	1958-03-12 00:00:00	1958-03-12	38000177		0	0	14		0	0	0	15613	0	243670	19059056		
113623	2497	40213160	1962-02-08	1962-02-08 00:00:00	1962-02-08	1962-02-08 00:00:00	1962-02-08	581452		0	0	0		0	0	0	165356	0	10	40213160		
104475	2291	40213227	2003-03-27	2003-03-27 00:00:00	2003-03-27	2003-03-27 00:00:00	2003-03-27	581452		0	0	0		0	0	0	152515	0	113	40213227		
43514	949	40213160	1958-08-25	1958-08-25 00:00:00	1958-08-25	1958-08-25 00:00:00	1958-08-25	581452		0	0	0		0	0	0	62990	0	10	40213160		
58966	4898	40229134	1991-08-26	1991-08-26 00:00:00	1991-09-02	1991-09-02 00:00:00	1991-09-02	38000177		0	0	7		0	0	0	325723	0	1043400	40229134		
177309	3896	40213306	2000-11-10	2000-11-10 00:00:00	2000-11-10	2000-11-10 00:00:00	2000-11-10	581452		0	0	0		0	0	0	259188	0	43	40213306		
31464	2609	1127433	2017-03-02	2017-03-02 00:00:00	2017-03-09	2017-03-09 00:00:00	2017-03-09	38000177		0	0	7		0	0	0	172476	0	313782	1127433		
159519	3510	40213227	1996-04-12	1996-04-12 00:00:00	1996-04-12	1996-04-12 00:00:00	1996-04-12	581452		0	0	0		0	0	0	232955	0	113	40213227		
5542	462	40236824	1999-10-14	1999-10-14 00:00:00	1999-10-21	1999-10-21 00:00:00	1999-10-21	38000177		0	0	7		0	0	0	30907	0	1094107	40236824		
33754	2792	1127433	1994-01-10	1994-01-10 00:00:00	1994-04-10	1994-04-10 00:00:00	1994-04-10	38000177		0	0	90		0	0	0	185040	0	313782	1127433		
46135	3823	1127433	2009-01-27	2009-01-27 00:00:00	2009-02-17	2009-02-17 00:00:00	2009-02-17	38000177		0	0	21		0	0	0	253974	0	313782	1127433		
46261	3833	1127078	1970-10-15	1970-10-15 00:00:00	1970-10-29	1970-10-29 00:00:00	1970-10-29	38000177		0	0	14		0	0	0	254541	0	282464	1127078		
34492	754	40213227	1992-03-03	1992-03-03 00:00:00	1992-03-03	1992-03-03 00:00:00	1992-03-03	581452		0	0	0		0	0	0	\N	0	113	40213227		
149562	3289	40213160	1956-08-31	1956-08-31 00:00:00	1956-08-31	1956-08-31 00:00:00	1956-08-31	581452		0	0	0		0	0	0	218487	0	10	40213160		
34547	754	40213201	2004-03-02	2004-03-02 00:00:00	2004-03-02	2004-03-02 00:00:00	2004-03-02	581452		0	0	0		0	0	0	49858	0	33	40213201		
45392	3756	40165015	1953-06-16	1953-06-16 00:00:00	1953-06-16	1953-06-16 00:00:00	\N	38000177		0	0	0		0	0	0	249711	0	861467	40165015		
63306	5258	19059056	1962-11-23	1962-11-23 00:00:00	1962-12-07	1962-12-07 00:00:00	1962-12-07	38000177		0	0	14		0	0	0	349854	0	243670	19059056		
25204	2075	40229134	2000-09-14	2000-09-14 00:00:00	2000-09-21	2000-09-21 00:00:00	2000-09-21	38000177		0	0	7		0	0	0	138005	0	1043400	40229134		
55963	4644	1124300	2001-02-10	2001-02-10 00:00:00	2001-02-10	2001-02-10 00:00:00	\N	38000177		0	0	0		0	0	0	309678	0	00781178901	45011828		
22651	1860	40243436	1997-07-07	1997-07-07 00:00:00	1997-07-07	1997-07-07 00:00:00	1997-07-07	38000177		0	0	0		0	0	0	124408	0	1190795	40243436		
110314	2423	40213296	1998-11-02	1998-11-02 00:00:00	1998-11-02	1998-11-02 00:00:00	1998-11-02	581452		0	0	0		0	0	0	160787	0	52	40213296		
161739	3558	40213260	2010-04-03	2010-04-03 00:00:00	2010-04-03	2010-04-03 00:00:00	2010-04-03	581452		0	0	0		0	0	0	236204	0	121	40213260		
110427	2425	40213160	1960-10-27	1960-10-27 00:00:00	1960-10-27	1960-10-27 00:00:00	1960-10-27	581452		0	0	0		0	0	0	160925	0	10	40213160		
203617	4470	40213306	1994-03-13	1994-03-13 00:00:00	1994-03-13	1994-03-13 00:00:00	1994-03-13	581452		0	0	0		0	0	0	297340	0	43	40213306		
61529	5119	1127433	1998-08-11	1998-08-11 00:00:00	1998-10-10	1998-10-10 00:00:00	1998-10-10	38000177		0	0	60		0	0	0	340421	0	313782	1127433		
51787	1134	40213227	2010-12-26	2010-12-26 00:00:00	2010-12-26	2010-12-26 00:00:00	2010-12-26	581452		0	0	0		0	0	0	74736	0	113	40213227		
21027	1733	1127078	1983-03-10	1983-03-10 00:00:00	1983-03-24	1983-03-24 00:00:00	1983-03-24	38000177		0	0	14		0	0	0	115831	0	282464	1127078		
21060	1737	19075601	1997-04-25	1997-04-25 00:00:00	2013-10-11	2013-10-11 00:00:00	2013-10-11	38000177		0	0	6013		0	0	0	116079	0	309362	19075601		
31583	2619	1713671	1989-01-17	1989-01-17 00:00:00	1989-02-07	1989-02-07 00:00:00	1989-02-07	38000177		0	0	21		0	0	0	173209	0	562251	1713671		
54468	4527	1124300	2002-01-21	2002-01-21 00:00:00	2002-01-21	2002-01-21 00:00:00	\N	38000177		0	0	0		0	0	0	301441	0	00781178901	45011828		
44153	3655	1713671	1951-01-13	1951-01-13 00:00:00	1951-01-27	1951-01-27 00:00:00	1951-01-27	38000177		0	0	14		0	0	0	243250	0	562251	1713671		
19769	1626	19079524	1989-12-17	1989-12-17 00:00:00	1989-12-17	1989-12-17 00:00:00	1989-12-17	38000177		0	0	0		0	0	0	109189	0	313002	19079524		
38280	3167	1127433	1983-02-11	1983-02-11 00:00:00	1983-02-25	1983-02-25 00:00:00	1983-02-25	38000177		0	0	14		0	0	0	210593	0	313782	1127433		
226060	4964	40213306	1982-08-07	1982-08-07 00:00:00	1982-08-07	1982-08-07 00:00:00	1982-08-07	581452		0	0	0		0	0	0	330022	0	43	40213306		
198142	4353	40213227	1999-06-06	1999-06-06 00:00:00	1999-06-06	1999-06-06 00:00:00	1999-06-06	581452		0	0	0		0	0	0	288793	0	113	40213227		
23446	1929	19059056	1957-08-15	1957-08-15 00:00:00	1957-08-29	1957-08-29 00:00:00	1957-08-29	38000177		0	0	14		0	0	0	128441	0	243670	19059056		
135276	2969	40213306	1988-12-15	1988-12-15 00:00:00	1988-12-15	1988-12-15 00:00:00	1988-12-15	581452		0	0	0		0	0	0	198241	0	43	40213306		
51203	4255	19019979	1977-11-24	1977-11-24 00:00:00	1977-12-15	1977-12-15 00:00:00	1977-12-15	38000177		0	0	21		0	0	0	282503	0	198405	19019979		
220909	4848	40213260	2006-10-08	2006-10-08 00:00:00	2006-10-08	2006-10-08 00:00:00	2006-10-08	581452		0	0	0		0	0	0	322522	0	121	40213260		
46799	3876	40229134	2016-12-10	2016-12-10 00:00:00	2016-12-17	2016-12-17 00:00:00	2016-12-17	38000177		0	0	7		0	0	0	257417	0	1043400	40229134		
23754	1953	40236824	2002-09-04	2002-09-04 00:00:00	2002-09-11	2002-09-11 00:00:00	2002-09-11	38000177		0	0	7		0	0	0	129901	0	1094107	40236824		
63545	5279	1713671	2010-10-04	2010-10-04 00:00:00	2010-10-25	2010-10-25 00:00:00	2010-10-25	38000177		0	0	21		0	0	0	351175	0	562251	1713671		
54884	1201	40213296	2014-10-22	2014-10-22 00:00:00	2014-10-22	2014-10-22 00:00:00	2014-10-22	581452		0	0	0		0	0	0	79012	0	52	40213296		
27805	2300	1127433	1957-09-18	1957-09-18 00:00:00	1957-10-02	1957-10-02 00:00:00	1957-10-02	38000177		0	0	14		0	0	0	153122	0	313782	1127433		
34379	2841	19133768	1984-10-21	1984-10-21 00:00:00	1984-10-21	1984-10-21 00:00:00	1984-10-21	38000177		0	0	0		0	0	0	188634	0	833036	19133768		
108533	2380	40213227	1992-06-06	1992-06-06 00:00:00	1992-06-06	1992-06-06 00:00:00	1992-06-06	581452		0	0	0		0	0	0	158154	0	113	40213227		
55313	4593	19133873	1975-09-11	1975-09-11 00:00:00	1975-09-21	1975-09-21 00:00:00	1975-09-21	38000177		0	0	10		0	0	0	306078	0	834061	19133873		
10057	842	19078461	2010-01-01	2010-01-01 00:00:00	2010-04-01	2010-04-01 00:00:00	2010-04-01	38000177		0	0	90		0	0	0	55706	0	310965	19078461		
9943	834	1115171	2012-11-18	2012-11-18 00:00:00	2012-12-02	2012-12-02 00:00:00	2012-12-02	38000177		0	0	14		0	0	0	55252	0	849574	1115171		
17691	1466	19059056	1969-07-28	1969-07-28 00:00:00	1969-08-11	1969-08-11 00:00:00	1969-08-11	38000177		0	0	14		0	0	0	97606	0	243670	19059056		
50279	1101	40213160	1974-11-24	1974-11-24 00:00:00	1974-11-24	1974-11-24 00:00:00	1974-11-24	581452		0	0	0		0	0	0	72346	0	10	40213160		
236804	5199	40213296	2004-01-27	2004-01-27 00:00:00	2004-01-27	2004-01-27 00:00:00	2004-01-27	581452		0	0	0		0	0	0	345728	0	52	40213296		
35091	2896	1124300	2002-03-05	2002-03-05 00:00:00	2002-03-05	2002-03-05 00:00:00	\N	38000177		0	0	0		0	0	0	192861	0	00781178901	45011828		
21419	1761	1127433	1967-07-09	1967-07-09 00:00:00	1967-07-23	1967-07-23 00:00:00	1967-07-23	38000177		0	0	14		0	0	0	117787	0	313782	1127433		
63617	5285	1118084	1980-12-16	1980-12-16 00:00:00	1980-12-16	1980-12-16 00:00:00	\N	38000177		0	0	0		0	0	0	351655	0	00025152531	44923712		
48524	4020	19006318	1958-12-16	1958-12-16 00:00:00	1958-12-30	1958-12-30 00:00:00	1958-12-30	38000177		0	0	14		0	0	0	267225	0	105078	19006318		
217871	4781	40213306	2002-10-04	2002-10-04 00:00:00	2002-10-04	2002-10-04 00:00:00	2002-10-04	581452		0	0	0		0	0	0	318272	0	43	40213306		
45798	3790	1713671	1976-03-24	1976-03-24 00:00:00	1976-04-14	1976-04-14 00:00:00	1976-04-14	38000177		0	0	21		0	0	0	252020	0	562251	1713671		
56321	4675	1127433	2014-07-02	2014-07-02 00:00:00	2014-07-23	2014-07-23 00:00:00	2014-07-23	38000177		0	0	21		0	0	0	311451	0	313782	1127433		
31949	2649	19059056	1972-12-23	1972-12-23 00:00:00	1973-01-13	1973-01-13 00:00:00	1973-01-13	38000177		0	0	21		0	0	0	175267	0	243670	19059056		
118133	2598	40213160	1974-06-18	1974-06-18 00:00:00	1974-06-18	1974-06-18 00:00:00	1974-06-18	581452		0	0	0		0	0	0	171940	0	10	40213160		
57556	4777	1118084	1992-10-16	1992-10-16 00:00:00	1992-10-16	1992-10-16 00:00:00	\N	38000177		0	0	0		0	0	0	318068	0	00025152531	44923712		
40864	3389	1127078	1963-02-21	1963-02-21 00:00:00	1963-03-07	1963-03-07 00:00:00	1963-03-07	38000177		0	0	14		0	0	0	224791	0	282464	1127078		
7625	642	19075601	2017-10-08	2017-10-08 00:00:00	2017-10-08	2017-10-08 00:00:00	2017-10-08	38000177		0	0	0		0	0	0	42521	0	309362	19075601		
2861	232	19059056	1947-08-18	1947-08-18 00:00:00	1947-09-01	1947-09-01 00:00:00	1947-09-01	38000177		0	0	14		0	0	0	15644	0	243670	19059056		
113628	2497	40213160	1966-08-04	1966-08-04 00:00:00	1966-08-04	1966-08-04 00:00:00	1966-08-04	581452		0	0	0		0	0	0	165304	0	10	40213160		
104476	2291	40213296	2003-03-27	2003-03-27 00:00:00	2003-03-27	2003-03-27 00:00:00	2003-03-27	581452		0	0	0		0	0	0	152515	0	52	40213296		
43515	949	40213160	1958-11-24	1958-11-24 00:00:00	1958-11-24	1958-11-24 00:00:00	1958-11-24	581452		0	0	0		0	0	0	63047	0	10	40213160		
58967	4898	1127433	1999-06-23	1999-06-23 00:00:00	1999-07-07	1999-07-07 00:00:00	1999-07-07	38000177		0	0	14		0	0	0	325667	0	313782	1127433		
177317	3896	40213160	1982-09-17	1982-09-17 00:00:00	1982-09-17	1982-09-17 00:00:00	1982-09-17	581452		0	0	0		0	0	0	259161	0	10	40213160		
31465	2609	19059056	1960-03-22	1960-03-22 00:00:00	1960-04-21	1960-04-21 00:00:00	1960-04-21	38000177		0	0	30		0	0	0	172492	0	243670	19059056		
159527	3510	40213227	2006-10-06	2006-10-06 00:00:00	2006-10-06	2006-10-06 00:00:00	2006-10-06	581452		0	0	0		0	0	0	232897	0	113	40213227		
5543	462	1127433	2009-12-01	2009-12-01 00:00:00	2009-12-08	2009-12-08 00:00:00	2009-12-08	38000177		0	0	7		0	0	0	30869	0	313782	1127433		
33755	2792	1127433	2012-04-26	2012-04-26 00:00:00	2012-05-03	2012-05-03 00:00:00	2012-05-03	38000177		0	0	7		0	0	0	184996	0	313782	1127433		
46136	3823	1127078	1956-06-04	1956-06-04 00:00:00	1956-06-18	1956-06-18 00:00:00	1956-06-18	38000177		0	0	14		0	0	0	253952	0	282464	1127078		
46262	3833	1713671	1968-07-21	1968-07-21 00:00:00	1968-08-11	1968-08-11 00:00:00	1968-08-11	38000177		0	0	21		0	0	0	254481	0	562251	1713671		
134045	2943	40213201	1983-09-19	1983-09-19 00:00:00	1983-09-19	1983-09-19 00:00:00	1983-09-19	581452		0	0	0		0	0	0	196351	0	33	40213201		
149569	3289	40213227	2017-06-09	2017-06-09 00:00:00	2017-06-09	2017-06-09 00:00:00	2017-06-09	581452		0	0	0		0	0	0	218497	0	113	40213227		
45828	1000	40213160	1963-07-23	1963-07-23 00:00:00	1963-07-23	1963-07-23 00:00:00	1963-07-23	581452		0	0	0		0	0	0	66145	0	10	40213160		
45393	3756	19133873	1948-05-27	1948-05-27 00:00:00	1948-06-08	1948-06-08 00:00:00	1948-06-08	38000177		0	0	12		0	0	0	249667	0	834061	19133873		
63307	5258	19006318	1958-11-27	1958-11-27 00:00:00	1958-12-11	1958-12-11 00:00:00	1958-12-11	38000177		0	0	14		0	0	0	349861	0	105078	19006318		
25205	2075	1713671	1973-10-14	1973-10-14 00:00:00	1973-10-21	1973-10-21 00:00:00	1973-10-21	38000177		0	0	7		0	0	0	138076	0	562251	1713671		
55964	4644	1127078	1963-12-27	1963-12-27 00:00:00	1964-01-10	1964-01-10 00:00:00	1964-01-10	38000177		0	0	14		0	0	0	309679	0	282464	1127078		
22652	1860	1310034	1997-07-07	1997-07-07 00:00:00	1997-07-07	1997-07-07 00:00:00	1997-07-07	38000177		0	0	0		0	0	0	124408	0	834357	1310034		
110322	2423	40213227	2007-10-29	2007-10-29 00:00:00	2007-10-29	2007-10-29 00:00:00	2007-10-29	581452		0	0	0		0	0	0	160740	0	113	40213227		
161741	3558	40213227	2001-04-07	2001-04-07 00:00:00	2001-04-07	2001-04-07 00:00:00	2001-04-07	581452		0	0	0		0	0	0	236186	0	113	40213227		
85922	1882	40213160	1969-04-19	1969-04-19 00:00:00	1969-04-19	1969-04-19 00:00:00	1969-04-19	581452		0	0	0		0	0	0	125496	0	10	40213160		
203623	4470	40213227	2014-05-11	2014-05-11 00:00:00	2014-05-11	2014-05-11 00:00:00	2014-05-11	581452		0	0	0		0	0	0	297341	0	113	40213227		
61530	5119	40231925	1998-08-11	1998-08-11 00:00:00	1998-08-11	1998-08-11 00:00:00	\N	38000177		0	0	0		0	0	0	340421	0	1049221	40231925		
93238	2046	40213227	2011-04-05	2011-04-05 00:00:00	2011-04-05	2011-04-05 00:00:00	2011-04-05	581452		0	0	0		0	0	0	136085	0	113	40213227		
21028	1733	1127433	2002-04-08	2002-04-08 00:00:00	2002-04-15	2002-04-15 00:00:00	2002-04-15	38000177		0	0	7		0	0	0	115836	0	313782	1127433		
21061	1737	19075601	2014-04-25	2014-04-25 00:00:00	2014-04-25	2014-04-25 00:00:00	\N	38000177		0	0	0		0	0	0	116077	0	309362	19075601		
31584	2619	1713671	1980-02-26	1980-02-26 00:00:00	1980-03-11	1980-03-11 00:00:00	1980-03-11	38000177		0	0	14		0	0	0	173148	0	562251	1713671		
54469	4527	40220960	2001-03-02	2001-03-02 00:00:00	2001-03-02	2001-03-02 00:00:00	2001-03-02	38000177		0	0	0		0	0	0	301441	0	1804799	40220960		
44154	3655	1127433	2002-02-02	2002-02-02 00:00:00	2002-02-16	2002-02-16 00:00:00	2002-02-16	38000177		0	0	14		0	0	0	243270	0	313782	1127433		
19770	1626	1154029	1989-12-17	1989-12-17 00:00:00	1989-12-17	1989-12-17 00:00:00	1989-12-17	38000177		0	0	0		0	0	0	109189	0	4337	1154029		
38281	3168	1127433	2003-10-17	2003-10-17 00:00:00	2003-10-24	2003-10-24 00:00:00	2003-10-24	38000177		0	0	7		0	0	0	210613	0	313782	1127433		
55273	1211	40213160	1968-10-02	1968-10-02 00:00:00	1968-10-02	1968-10-02 00:00:00	1968-10-02	581452		0	0	0		0	0	0	79612	0	10	40213160		
198145	4353	40213227	2007-08-19	2007-08-19 00:00:00	2007-08-19	2007-08-19 00:00:00	2007-08-19	581452		0	0	0		0	0	0	288790	0	113	40213227		
23447	1929	19073188	1990-12-01	1990-12-01 00:00:00	1990-12-15	1990-12-15 00:00:00	1990-12-15	38000177		0	0	14		0	0	0	128395	0	308192	19073188		
91443	2006	40213227	2007-03-23	2007-03-23 00:00:00	2007-03-23	2007-03-23 00:00:00	2007-03-23	581452		0	0	0		0	0	0	133588	0	113	40213227		
51204	4255	19133873	1984-08-14	1984-08-14 00:00:00	1984-08-21	1984-08-21 00:00:00	1984-08-21	38000177		0	0	7		0	0	0	282507	0	834061	19133873		
220911	4848	40213296	1996-09-29	1996-09-29 00:00:00	1996-09-29	1996-09-29 00:00:00	1996-09-29	581452		0	0	0		0	0	0	322541	0	52	40213296		
57271	4754	1127433	1981-02-23	1981-02-23 00:00:00	1981-03-16	1981-03-16 00:00:00	1981-03-16	38000177		0	0	21		0	0	0	316636	0	313782	1127433		
23755	1953	920300	2002-09-04	2002-09-04 00:00:00	2002-09-11	2002-09-11 00:00:00	2002-09-11	38000177		0	0	7		0	0	0	129901	0	311989	920300		
63546	5279	1713671	2005-07-13	2005-07-13 00:00:00	2005-07-27	2005-07-27 00:00:00	2005-07-27	38000177		0	0	14		0	0	0	351205	0	562251	1713671		
54886	1202	40213314	1980-10-12	1980-10-12 00:00:00	1980-10-12	1980-10-12 00:00:00	1980-10-12	581452		0	0	0		0	0	0	79046	0	49	40213314		
6142	515	1332419	1996-11-23	1996-11-23 00:00:00	1996-11-23	1996-11-23 00:00:00	\N	38000177		0	0	0		0	0	0	34396	0	197361	1332419		
34380	2841	19126352	1986-09-14	1986-09-14 00:00:00	1994-08-21	1994-08-21 00:00:00	1994-08-21	38000177		0	0	2898		0	0	0	188594	0	705129	19126352		
108540	2381	40213201	2002-06-19	2002-06-19 00:00:00	2002-06-19	2002-06-19 00:00:00	2002-06-19	581452		0	0	0		0	0	0	158369	0	33	40213201		
55314	4593	1124300	2007-05-19	2007-05-19 00:00:00	2007-05-19	2007-05-19 00:00:00	\N	38000177		0	0	0		0	0	0	306025	0	00781178901	45011828		
10058	842	1115171	1997-11-30	1997-11-30 00:00:00	1998-01-04	1998-01-04 00:00:00	1998-01-04	38000177		0	0	35		0	0	0	55662	0	849574	1115171		
9944	834	1127078	1957-06-12	1957-06-12 00:00:00	1957-06-26	1957-06-26 00:00:00	1957-06-26	38000177		0	0	14		0	0	0	55184	0	282464	1127078		
17692	1466	19129655	1969-07-28	1969-07-28 00:00:00	1969-08-11	1969-08-11 00:00:00	1969-08-11	38000177		0	0	14		0	0	0	97606	0	789980	19129655		
50283	1102	40213160	1967-05-02	1967-05-02 00:00:00	1967-05-02	1967-05-02 00:00:00	1967-05-02	581452		0	0	0		0	0	0	72486	0	10	40213160		
236806	5199	40213227	2004-01-27	2004-01-27 00:00:00	2004-01-27	2004-01-27 00:00:00	2004-01-27	581452		0	0	0		0	0	0	345728	0	113	40213227		
35092	2896	1713671	2001-10-01	2001-10-01 00:00:00	2001-10-22	2001-10-22 00:00:00	2001-10-22	38000177		0	0	21		0	0	0	192861	0	562251	1713671		
21420	1761	1124300	1995-03-02	1995-03-02 00:00:00	1995-03-02	1995-03-02 00:00:00	\N	38000177		0	0	0		0	0	0	117790	0	00781178901	45011828		
63618	5285	1545959	2008-07-06	2008-07-06 00:00:00	2008-07-06	2008-07-06 00:00:00	2008-07-06	38000177		0	0	0		0	0	0	351690	0	259255	1545959		
48525	4020	1127078	1958-12-16	1958-12-16 00:00:00	1958-12-30	1958-12-30 00:00:00	1958-12-30	38000177		0	0	14		0	0	0	267225	0	282464	1127078		
217872	4781	40213160	1982-03-12	1982-03-12 00:00:00	1982-03-12	1982-03-12 00:00:00	1982-03-12	581452		0	0	0		0	0	0	318258	0	10	40213160		
45799	3790	1713671	1976-12-17	1976-12-17 00:00:00	1976-12-31	1976-12-31 00:00:00	1976-12-31	38000177		0	0	14		0	0	0	251997	0	562251	1713671		
56322	4675	1127433	1961-04-13	1961-04-13 00:00:00	1961-05-11	1961-05-11 00:00:00	1961-05-11	38000177		0	0	28		0	0	0	311507	0	313782	1127433		
31950	2649	1713671	1983-07-17	1983-07-17 00:00:00	1983-08-07	1983-08-07 00:00:00	1983-08-07	38000177		0	0	21		0	0	0	175254	0	562251	1713671		
118134	2598	40213160	1974-04-16	1974-04-16 00:00:00	1974-04-16	1974-04-16 00:00:00	1974-04-16	581452		0	0	0		0	0	0	171930	0	10	40213160		
57557	4777	19128065	1978-04-08	1978-04-08 00:00:00	1979-04-03	1979-04-03 00:00:00	1979-04-03	38000177		0	0	360		0	0	0	318112	0	749882	19128065		
40865	3389	19006318	1963-02-21	1963-02-21 00:00:00	1963-03-07	1963-03-07 00:00:00	1963-03-07	38000177		0	0	14		0	0	0	224791	0	105078	19006318		
7626	642	40220960	2017-10-08	2017-10-08 00:00:00	2017-10-08	2017-10-08 00:00:00	2017-10-08	38000177		0	0	0		0	0	0	42521	0	1804799	40220960		
2862	232	1115171	2016-03-05	2016-03-05 00:00:00	2016-06-03	2016-06-03 00:00:00	2016-06-03	38000177		0	0	90		0	0	0	15620	0	849574	1115171		
113632	2497	40213160	1962-05-10	1962-05-10 00:00:00	1962-05-10	1962-05-10 00:00:00	1962-05-10	581452		0	0	0		0	0	0	165331	0	10	40213160		
104479	2291	40213160	1965-01-28	1965-01-28 00:00:00	1965-01-28	1965-01-28 00:00:00	1965-01-28	581452		0	0	0		0	0	0	\N	0	10	40213160		
43516	949	40213260	2008-11-03	2008-11-03 00:00:00	2008-11-03	2008-11-03 00:00:00	2008-11-03	581452		0	0	0		0	0	0	63055	0	121	40213260		
58968	4898	1127433	2012-03-28	2012-03-28 00:00:00	2012-04-11	2012-04-11 00:00:00	2012-04-11	38000177		0	0	14		0	0	0	325743	0	313782	1127433		
177319	3896	40213296	2017-12-01	2017-12-01 00:00:00	2017-12-01	2017-12-01 00:00:00	2017-12-01	581452		0	0	0		0	0	0	259193	0	52	40213296		
31466	2609	1127078	1967-08-04	1967-08-04 00:00:00	1967-08-25	1967-08-25 00:00:00	1967-08-25	38000177		0	0	21		0	0	0	172495	0	282464	1127078		
216571	4753	40213160	1961-09-13	1961-09-13 00:00:00	1961-09-13	1961-09-13 00:00:00	1961-09-13	581452		0	0	0		0	0	0	316509	0	10	40213160		
5544	462	1127078	1979-10-01	1979-10-01 00:00:00	1979-10-15	1979-10-15 00:00:00	1979-10-15	38000177		0	0	14		0	0	0	30886	0	282464	1127078		
33756	2792	1127433	2008-05-21	2008-05-21 00:00:00	2008-05-28	2008-05-28 00:00:00	2008-05-28	38000177		0	0	7		0	0	0	185048	0	313782	1127433		
46137	3823	19006318	1956-06-04	1956-06-04 00:00:00	1956-06-18	1956-06-18 00:00:00	1956-06-18	38000177		0	0	14		0	0	0	253952	0	105078	19006318		
46263	3833	19006318	1967-03-21	1967-03-21 00:00:00	1967-04-04	1967-04-04 00:00:00	1967-04-04	38000177		0	0	14		0	0	0	254529	0	105078	19006318		
134049	2943	40213227	2006-04-17	2006-04-17 00:00:00	2006-04-17	2006-04-17 00:00:00	2006-04-17	581452		0	0	0		0	0	0	196376	0	113	40213227		
149572	3289	40213160	1960-12-02	1960-12-02 00:00:00	1960-12-02	1960-12-02 00:00:00	1960-12-02	581452		0	0	0		0	0	0	218523	0	10	40213160		
45830	1000	40213260	2013-02-12	2013-02-12 00:00:00	2013-02-12	2013-02-12 00:00:00	2013-02-12	581452		0	0	0		0	0	0	66166	0	121	40213260		
45394	3756	19133873	1949-09-14	1949-09-14 00:00:00	1949-09-24	1949-09-24 00:00:00	1949-09-24	38000177		0	0	10		0	0	0	249622	0	834061	19133873		
63308	5258	19059056	1958-11-27	1958-11-27 00:00:00	1958-12-11	1958-12-11 00:00:00	1958-12-11	38000177		0	0	14		0	0	0	349861	0	243670	19059056		
25206	2075	1118084	2006-03-10	2006-03-10 00:00:00	2006-03-10	2006-03-10 00:00:00	\N	38000177		0	0	0		0	0	0	138014	0	00025152531	44923712		
55965	4644	19129655	1963-12-27	1963-12-27 00:00:00	1964-01-10	1964-01-10 00:00:00	1964-01-10	38000177		0	0	14		0	0	0	309679	0	789980	19129655		
22653	1860	1127433	1992-08-04	1992-08-04 00:00:00	1992-08-18	1992-08-18 00:00:00	1992-08-18	38000177		0	0	14		0	0	0	124375	0	313782	1127433		
110323	2423	40213260	2007-10-29	2007-10-29 00:00:00	2007-10-29	2007-10-29 00:00:00	2007-10-29	581452		0	0	0		0	0	0	160740	0	121	40213260		
161743	3558	40213227	2010-04-03	2010-04-03 00:00:00	2010-04-03	2010-04-03 00:00:00	2010-04-03	581452		0	0	0		0	0	0	236204	0	113	40213227		
85925	1882	40213160	1973-02-24	1973-02-24 00:00:00	1973-02-24	1973-02-24 00:00:00	1973-02-24	581452		0	0	0		0	0	0	\N	0	10	40213160		
203624	4470	40213296	2014-05-11	2014-05-11 00:00:00	2014-05-11	2014-05-11 00:00:00	2014-05-11	581452		0	0	0		0	0	0	297341	0	52	40213296		
175161	3851	40213227	1992-07-06	1992-07-06 00:00:00	1992-07-06	1992-07-06 00:00:00	1992-07-06	581452		0	0	0		0	0	0	255607	0	113	40213227		
93253	2046	40213201	2006-03-07	2006-03-07 00:00:00	2006-03-07	2006-03-07 00:00:00	2006-03-07	581452		0	0	0		0	0	0	136111	0	33	40213201		
21029	1733	19133905	2005-03-16	2005-03-16 00:00:00	2005-03-26	2005-03-26 00:00:00	2005-03-26	38000177		0	0	10		0	0	0	115837	0	834102	19133905		
21062	1737	19059056	1923-01-22	1923-01-22 00:00:00	1923-02-26	1923-02-26 00:00:00	1923-02-26	38000177		0	0	35		0	0	0	115959	0	243670	19059056		
31585	2619	19059056	1976-06-22	1976-06-22 00:00:00	1976-07-20	1976-07-20 00:00:00	1976-07-20	38000177		0	0	28		0	0	0	173201	0	243670	19059056		
54470	4527	19075601	2001-03-02	2001-03-02 00:00:00	2001-03-02	2001-03-02 00:00:00	2001-03-02	38000177		0	0	0		0	0	0	301441	0	309362	19075601		
44155	3655	19126352	2006-08-31	2006-08-31 00:00:00	2010-12-16	2010-12-16 00:00:00	2010-12-16	38000177		0	0	1568		0	0	0	243290	0	705129	19126352		
19771	1626	1367571	1989-12-17	1989-12-17 00:00:00	1989-12-17	1989-12-17 00:00:00	1989-12-17	38000177		0	0	0		0	0	0	109189	0	314659	19080464		
38282	3168	1127433	2010-12-03	2010-12-03 00:00:00	2011-03-03	2011-03-03 00:00:00	2011-03-03	38000177		0	0	90		0	0	0	210622	0	313782	1127433		
55278	1211	40213260	2014-12-10	2014-12-10 00:00:00	2014-12-10	2014-12-10 00:00:00	2014-12-10	581452		0	0	0		0	0	0	79668	0	121	40213260		
198146	4353	40213296	2007-08-19	2007-08-19 00:00:00	2007-08-19	2007-08-19 00:00:00	2007-08-19	581452		0	0	0		0	0	0	288790	0	52	40213296		
23448	1929	1127433	1990-12-01	1990-12-01 00:00:00	1990-12-15	1990-12-15 00:00:00	1990-12-15	38000177		0	0	14		0	0	0	128395	0	313782	1127433		
91452	2007	40213180	2005-02-06	2005-02-06 00:00:00	2005-02-06	2005-02-06 00:00:00	2005-02-06	581452		0	0	0		0	0	0	133656	0	114	40213180		
51205	4255	1713671	1997-05-17	1997-05-17 00:00:00	1997-05-31	1997-05-31 00:00:00	1997-05-31	38000177		0	0	14		0	0	0	282515	0	562251	1713671		
239101	5249	40213227	2000-04-16	2000-04-16 00:00:00	2000-04-16	2000-04-16 00:00:00	2000-04-16	581452		0	0	0		0	0	0	349167	0	113	40213227		
57272	4754	46233988	1968-10-29	1968-10-29 00:00:00	1968-11-12	1968-11-12 00:00:00	1968-11-12	38000177		0	0	14		0	0	0	316617	0	1652673	46233988		
23756	1953	19059056	1964-06-17	1964-06-17 00:00:00	1964-07-17	1964-07-17 00:00:00	1964-07-17	38000177		0	0	30		0	0	0	129882	0	243670	19059056		
63547	5279	1713671	1975-01-19	1975-01-19 00:00:00	1975-01-26	1975-01-26 00:00:00	1975-01-26	38000177		0	0	7		0	0	0	351184	0	562251	1713671		
54887	1202	40213160	1980-10-12	1980-10-12 00:00:00	1980-10-12	1980-10-12 00:00:00	1980-10-12	581452		0	0	0		0	0	0	79046	0	10	40213160		
16601	1376	1127433	2007-09-11	2007-09-11 00:00:00	2007-09-25	2007-09-25 00:00:00	2007-09-25	38000177		0	0	14		0	0	0	91180	0	313782	1127433		
34381	2841	19078461	1979-12-14	1979-12-14 00:00:00	1980-01-11	1980-01-11 00:00:00	1980-01-11	38000177		0	0	28		0	0	0	188632	0	310965	19078461		
108556	2381	40213227	1997-05-21	1997-05-21 00:00:00	1997-05-21	1997-05-21 00:00:00	1997-05-21	581452		0	0	0		0	0	0	158266	0	113	40213227		
55315	4593	1713671	1985-01-16	1985-01-16 00:00:00	1985-02-06	1985-02-06 00:00:00	1985-02-06	38000177		0	0	21		0	0	0	306073	0	562251	1713671		
10059	842	19059056	1912-03-16	1912-03-16 00:00:00	1912-03-30	1912-03-30 00:00:00	1912-03-30	38000177		0	0	14		0	0	0	55651	0	243670	19059056		
9945	834	19006318	1957-06-12	1957-06-12 00:00:00	1957-06-26	1957-06-26 00:00:00	1957-06-26	38000177		0	0	14		0	0	0	55184	0	105078	19006318		
17693	1466	1127433	2016-02-23	2016-02-23 00:00:00	2016-03-01	2016-03-01 00:00:00	2016-03-01	38000177		0	0	7		0	0	0	97651	0	313782	1127433		
50292	1102	40213296	2009-07-21	2009-07-21 00:00:00	2009-07-21	2009-07-21 00:00:00	2009-07-21	581452		0	0	0		0	0	0	72492	0	52	40213296		
236808	5199	40213160	1966-10-18	1966-10-18 00:00:00	1966-10-18	1966-10-18 00:00:00	1966-10-18	581452		0	0	0		0	0	0	345796	0	10	40213160		
35093	2896	1127433	1999-09-24	1999-09-24 00:00:00	1999-10-15	1999-10-15 00:00:00	1999-10-15	38000177		0	0	21		0	0	0	192867	0	313782	1127433		
21421	1761	1115171	2016-05-10	2016-05-10 00:00:00	2016-05-31	2016-05-31 00:00:00	2016-05-31	38000177		0	0	21		0	0	0	117722	0	849574	1115171		
63619	5285	19133768	2008-07-06	2008-07-06 00:00:00	2008-07-06	2008-07-06 00:00:00	2008-07-06	38000177		0	0	0		0	0	0	351690	0	833036	19133768		
48526	4020	1713671	1996-04-26	1996-04-26 00:00:00	1996-05-17	1996-05-17 00:00:00	1996-05-17	38000177		0	0	21		0	0	0	267222	0	562251	1713671		
217879	4781	40213306	2005-10-07	2005-10-07 00:00:00	2005-10-07	2005-10-07 00:00:00	2005-10-07	581452		0	0	0		0	0	0	318273	0	43	40213306		
45800	3790	46233988	1969-05-23	1969-05-23 00:00:00	1969-06-06	1969-06-06 00:00:00	1969-06-06	38000177		0	0	14		0	0	0	252023	0	1652673	46233988		
56323	4675	40229134	1959-07-08	1959-07-08 00:00:00	1959-07-15	1959-07-15 00:00:00	1959-07-15	38000177		0	0	7		0	0	0	311570	0	1043400	40229134		
32137	2663	19059056	1972-03-17	1972-03-17 00:00:00	1972-05-16	1972-05-16 00:00:00	1972-05-16	38000177		0	0	60		0	0	0	176439	0	243670	19059056		
118135	2598	40213314	1977-12-13	1977-12-13 00:00:00	1977-12-13	1977-12-13 00:00:00	1977-12-13	581452		0	0	0		0	0	0	171933	0	49	40213314		
57558	4777	1127433	1979-09-04	1979-09-04 00:00:00	1979-09-25	1979-09-25 00:00:00	1979-09-25	38000177		0	0	21		0	0	0	318096	0	313782	1127433		
40866	3389	1127433	1973-01-15	1973-01-15 00:00:00	1973-02-14	1973-02-14 00:00:00	1973-02-14	38000177		0	0	30		0	0	0	224743	0	313782	1127433		
7627	642	19059056	1940-07-24	1940-07-24 00:00:00	1940-08-07	1940-08-07 00:00:00	1940-08-07	38000177		0	0	14		0	0	0	42527	0	243670	19059056		
2863	232	1118084	1982-12-07	1982-12-07 00:00:00	1982-12-07	1982-12-07 00:00:00	\N	38000177		0	0	0		0	0	0	15636	0	00025152531	44923712		
113636	2497	40213296	2002-09-19	2002-09-19 00:00:00	2002-09-19	2002-09-19 00:00:00	2002-09-19	581452		0	0	0		0	0	0	165310	0	52	40213296		
104483	2291	40213227	1992-10-22	1992-10-22 00:00:00	1992-10-22	1992-10-22 00:00:00	1992-10-22	581452		0	0	0		0	0	0	152434	0	113	40213227		
43529	949	40213296	1998-03-30	1998-03-30 00:00:00	1998-03-30	1998-03-30 00:00:00	1998-03-30	581452		0	0	0		0	0	0	63015	0	52	40213296		
58969	4898	19133873	1954-02-12	1954-02-12 00:00:00	1954-02-20	1954-02-20 00:00:00	1954-02-20	38000177		0	0	8		0	0	0	325693	0	834061	19133873		
177324	3896	40213314	1978-01-13	1978-01-13 00:00:00	1978-01-13	1978-01-13 00:00:00	1978-01-13	581452		0	0	0		0	0	0	259171	0	49	40213314		
31467	2609	19059056	1961-04-16	1961-04-16 00:00:00	1961-05-07	1961-05-07 00:00:00	1961-05-07	38000177		0	0	21		0	0	0	172493	0	243670	19059056		
216573	4753	40213296	2001-06-13	2001-06-13 00:00:00	2001-06-13	2001-06-13 00:00:00	2001-06-13	581452		0	0	0		0	0	0	316505	0	52	40213296		
5545	462	19073183	1979-10-01	1979-10-01 00:00:00	1979-10-15	1979-10-15 00:00:00	1979-10-15	38000177		0	0	14		0	0	0	30886	0	308182	19073183		
12733	1073	1713671	1942-11-20	1942-11-20 00:00:00	1942-11-27	1942-11-27 00:00:00	1942-11-27	38000177		0	0	7		0	0	0	70321	0	562251	1713671		
46139	3823	19128065	1976-08-28	1976-08-28 00:00:00	1977-08-23	1977-08-23 00:00:00	1977-08-23	38000177		0	0	360		0	0	0	253953	0	749882	19128065		
46264	3833	19059056	1967-03-21	1967-03-21 00:00:00	1967-04-04	1967-04-04 00:00:00	1967-04-04	38000177		0	0	14		0	0	0	254529	0	243670	19059056		
134060	2943	40213227	1995-06-12	1995-06-12 00:00:00	1995-06-12	1995-06-12 00:00:00	1995-06-12	581452		0	0	0		0	0	0	196255	0	113	40213227		
149587	3290	40213160	1974-01-09	1974-01-09 00:00:00	1974-01-09	1974-01-09 00:00:00	1974-01-09	581452		0	0	0		0	0	0	218563	0	10	40213160		
45835	1000	40213306	1985-11-26	1985-11-26 00:00:00	1985-11-26	1985-11-26 00:00:00	1985-11-26	581452		0	0	0		0	0	0	66207	0	43	40213306		
45395	3756	40220960	2006-02-04	2006-02-04 00:00:00	2006-02-04	2006-02-04 00:00:00	2006-02-04	38000177		0	0	0		0	0	0	249690	0	1804799	40220960		
63309	5258	19059056	1965-03-25	1965-03-25 00:00:00	1965-04-29	1965-04-29 00:00:00	1965-04-29	38000177		0	0	35		0	0	0	349868	0	243670	19059056		
25207	2075	40232448	1968-12-20	1968-12-20 00:00:00	1968-12-20	1968-12-20 00:00:00	\N	38000177		0	0	0		0	0	0	138066	0	1049630	40232448		
55966	4644	1115171	1995-08-16	1995-08-16 00:00:00	1995-08-30	1995-08-30 00:00:00	1995-08-30	38000177		0	0	14		0	0	0	309630	0	849574	1115171		
22654	1860	1127433	1995-09-30	1995-09-30 00:00:00	1995-10-07	1995-10-07 00:00:00	1995-10-07	38000177		0	0	7		0	0	0	124384	0	313782	1127433		
110328	2424	40213160	1963-02-21	1963-02-21 00:00:00	1963-02-21	1963-02-21 00:00:00	1963-02-21	581452		0	0	0		0	0	0	160849	0	10	40213160		
161755	3559	40213227	1993-06-25	1993-06-25 00:00:00	1993-06-25	1993-06-25 00:00:00	1993-06-25	581452		0	0	0		0	0	0	236331	0	113	40213227		
85930	1882	40213306	1991-10-05	1991-10-05 00:00:00	1991-10-05	1991-10-05 00:00:00	1991-10-05	581452		0	0	0		0	0	0	125526	0	43	40213306		
203630	4470	40213296	2012-05-06	2012-05-06 00:00:00	2012-05-06	2012-05-06 00:00:00	2012-05-06	581452		0	0	0		0	0	0	297339	0	52	40213296		
16975	1407	1127433	1999-09-26	1999-09-26 00:00:00	1999-10-03	1999-10-03 00:00:00	1999-10-03	38000177		0	0	7		0	0	0	93457	0	313782	1127433		
104545	2292	40213306	1984-06-01	1984-06-01 00:00:00	1984-06-01	1984-06-01 00:00:00	1984-06-01	581452		0	0	0		0	0	0	152602	0	43	40213306		
21030	1733	1115171	1999-04-20	1999-04-20 00:00:00	1999-05-18	1999-05-18 00:00:00	1999-05-18	38000177		0	0	28		0	0	0	115805	0	849574	1115171		
21063	1737	1127433	1972-05-02	1972-05-02 00:00:00	1972-05-09	1972-05-09 00:00:00	1972-05-09	38000177		0	0	7		0	0	0	116097	0	313782	1127433		
31586	2619	19059056	1944-10-10	1944-10-10 00:00:00	1944-11-09	1944-11-09 00:00:00	1944-11-09	38000177		0	0	30		0	0	0	173224	0	243670	19059056		
54471	4527	19133905	1986-03-28	1986-03-28 00:00:00	1986-04-04	1986-04-04 00:00:00	1986-04-04	38000177		0	0	7		0	0	0	301426	0	834102	19133905		
44156	3655	1539411	2006-08-31	2006-08-31 00:00:00	2006-08-31	2006-08-31 00:00:00	\N	38000177		0	0	0		0	0	0	243290	0	312961	1539411		
19772	1626	19059056	1935-10-26	1935-10-26 00:00:00	1935-11-09	1935-11-09 00:00:00	1935-11-09	38000177		0	0	14		0	0	0	109194	0	243670	19059056		
38283	3168	19133873	1988-09-07	1988-09-07 00:00:00	1988-09-18	1988-09-18 00:00:00	1988-09-18	38000177		0	0	11		0	0	0	210643	0	834061	19133873		
55281	1211	40213227	2014-12-10	2014-12-10 00:00:00	2014-12-10	2014-12-10 00:00:00	2014-12-10	581452		0	0	0		0	0	0	79668	0	113	40213227		
209432	4593	40213160	1964-05-21	1964-05-21 00:00:00	1964-05-21	1964-05-21 00:00:00	1964-05-21	581452		0	0	0		0	0	0	306040	0	10	40213160		
37291	3082	1118084	2004-03-12	2004-03-12 00:00:00	2004-03-12	2004-03-12 00:00:00	\N	38000177		0	0	0		0	0	0	205220	0	00025152531	44923712		
91455	2007	40213251	1991-10-13	1991-10-13 00:00:00	1991-10-13	1991-10-13 00:00:00	1991-10-13	581452		0	0	0		0	0	0	133653	0	21	40213251		
51206	4255	19059056	1986-08-30	1986-08-30 00:00:00	1986-09-20	1986-09-20 00:00:00	1986-09-20	38000177		0	0	21		0	0	0	282504	0	243670	19059056		
239116	5249	40213160	1955-08-28	1955-08-28 00:00:00	1955-08-28	1955-08-28 00:00:00	1955-08-28	581452		0	0	0		0	0	0	349243	0	10	40213160		
57273	4754	19059056	1968-10-29	1968-10-29 00:00:00	1968-11-12	1968-11-12 00:00:00	1968-11-12	38000177		0	0	14		0	0	0	316617	0	243670	19059056		
23757	1953	1127078	1956-08-28	1956-08-28 00:00:00	1956-09-11	1956-09-11 00:00:00	1956-09-11	38000177		0	0	14		0	0	0	129870	0	282464	1127078		
63548	5279	40236824	1990-02-26	1990-02-26 00:00:00	1990-03-05	1990-03-05 00:00:00	1990-03-05	38000177		0	0	7		0	0	0	351147	0	1094107	40236824		
54892	1202	40213160	1985-06-16	1985-06-16 00:00:00	1985-06-16	1985-06-16 00:00:00	1985-06-16	581452		0	0	0		0	0	0	79032	0	10	40213160		
16602	1376	1127078	1983-06-13	1983-06-13 00:00:00	1983-09-11	1983-09-11 00:00:00	1983-09-11	38000177		0	0	90		0	0	0	91177	0	282464	1127078		
34382	2841	1118084	1990-11-03	1990-11-03 00:00:00	1990-11-03	1990-11-03 00:00:00	\N	38000177		0	0	0		0	0	0	188595	0	00025152531	44923712		
34424	2845	1115171	2001-04-14	2001-04-14 00:00:00	2001-05-12	2001-05-12 00:00:00	2001-05-12	38000177		0	0	28		0	0	0	188985	0	849574	1115171		
55316	4593	40229134	1984-06-09	1984-06-09 00:00:00	1984-06-23	1984-06-23 00:00:00	1984-06-23	38000177		0	0	14		0	0	0	306079	0	1043400	40229134		
10060	842	1127433	1970-10-20	1970-10-20 00:00:00	1970-11-10	1970-11-10 00:00:00	1970-11-10	38000177		0	0	21		0	0	0	55712	0	313782	1127433		
9947	834	1124300	1996-08-18	1996-08-18 00:00:00	1996-08-18	1996-08-18 00:00:00	\N	38000177		0	0	0		0	0	0	55166	0	00781178901	45011828		
17695	1466	19059056	1972-02-13	1972-02-13 00:00:00	1972-02-27	1972-02-27 00:00:00	1972-02-27	38000177		0	0	14		0	0	0	97663	0	243670	19059056		
50294	1102	40213227	2009-07-21	2009-07-21 00:00:00	2009-07-21	2009-07-21 00:00:00	2009-07-21	581452		0	0	0		0	0	0	72492	0	113	40213227		
236811	5199	40213306	1984-11-13	1984-11-13 00:00:00	1984-11-13	1984-11-13 00:00:00	1984-11-13	581452		0	0	0		0	0	0	345759	0	43	40213306		
35094	2896	19059056	1989-02-04	1989-02-04 00:00:00	1989-02-18	1989-02-18 00:00:00	1989-02-18	38000177		0	0	14		0	0	0	192866	0	243670	19059056		
21422	1761	1115171	2019-04-16	2019-04-16 00:00:00	2019-05-21	2019-05-21 00:00:00	2019-05-21	38000177		0	0	35		0	0	0	117723	0	849574	1115171		
63620	5285	1713671	1982-11-21	1982-11-21 00:00:00	1982-11-28	1982-11-28 00:00:00	1982-11-28	38000177		0	0	7		0	0	0	351643	0	562251	1713671		
48527	4020	1127078	1960-10-27	1960-10-27 00:00:00	1960-11-10	1960-11-10 00:00:00	1960-11-10	38000177		0	0	14		0	0	0	267257	0	282464	1127078		
217880	4781	40213180	2005-10-07	2005-10-07 00:00:00	2005-10-07	2005-10-07 00:00:00	2005-10-07	581452		0	0	0		0	0	0	318273	0	114	40213180		
45801	3790	1127078	1969-05-23	1969-05-23 00:00:00	1969-06-06	1969-06-06 00:00:00	1969-06-06	38000177		0	0	14		0	0	0	252023	0	282464	1127078		
56324	4675	1127433	1984-08-28	1984-08-28 00:00:00	1984-09-11	1984-09-11 00:00:00	1984-09-11	38000177		0	0	14		0	0	0	311438	0	313782	1127433		
32138	2663	1118084	2002-09-11	2002-09-11 00:00:00	2002-09-11	2002-09-11 00:00:00	\N	38000177		0	0	0		0	0	0	176470	0	00025152531	44923712		
118139	2598	40213296	2017-05-16	2017-05-16 00:00:00	2017-05-16	2017-05-16 00:00:00	2017-05-16	581452		0	0	0		0	0	0	171910	0	52	40213296		
57559	4777	1127433	1974-11-29	1974-11-29 00:00:00	1975-02-27	1975-02-27 00:00:00	1975-02-27	38000177		0	0	90		0	0	0	318095	0	313782	1127433		
40867	3389	40162522	1973-01-15	1973-01-15 00:00:00	1973-01-15	1973-01-15 00:00:00	\N	38000177		0	0	0		0	0	0	224743	0	857005	40162522		
7628	642	1127433	1944-03-14	1944-03-14 00:00:00	1944-03-28	1944-03-28 00:00:00	1944-03-28	38000177		0	0	14		0	0	0	42517	0	313782	1127433		
2864	232	1713671	2014-08-01	2014-08-01 00:00:00	2014-08-22	2014-08-22 00:00:00	2014-08-22	38000177		0	0	21		0	0	0	15624	0	562251	1713671		
113637	2497	40213160	1961-12-07	1961-12-07 00:00:00	1961-12-07	1961-12-07 00:00:00	1961-12-07	581452		0	0	0		0	0	0	165362	0	10	40213160		
104485	2291	40213306	1983-10-13	1983-10-13 00:00:00	1983-10-13	1983-10-13 00:00:00	1983-10-13	581452		0	0	0		0	0	0	152500	0	43	40213306		
43537	949	40213227	2019-05-20	2019-05-20 00:00:00	2019-05-20	2019-05-20 00:00:00	2019-05-20	581452		0	0	0		0	0	0	63020	0	113	40213227		
58970	4898	1118084	1997-11-22	1997-11-22 00:00:00	1997-11-22	1997-11-22 00:00:00	\N	38000177		0	0	0		0	0	0	325734	0	00025152531	44923712		
177325	3896	40213160	1978-01-13	1978-01-13 00:00:00	1978-01-13	1978-01-13 00:00:00	1978-01-13	581452		0	0	0		0	0	0	259171	0	10	40213160		
31468	2609	40243436	2018-12-14	2018-12-14 00:00:00	2018-12-14	2018-12-14 00:00:00	2018-12-14	38000177		0	0	0		0	0	0	172469	0	1190795	40243436		
216576	4753	40213227	2003-06-18	2003-06-18 00:00:00	2003-06-18	2003-06-18 00:00:00	2003-06-18	581452		0	0	0		0	0	0	316517	0	113	40213227		
5546	462	1118084	2014-08-28	2014-08-28 00:00:00	2014-08-28	2014-08-28 00:00:00	\N	38000177		0	0	0		0	0	0	30908	0	00025152531	44923712		
12734	1073	19059056	1936-11-22	1936-11-22 00:00:00	1936-12-06	1936-12-06 00:00:00	1936-12-06	38000177		0	0	14		0	0	0	70392	0	243670	19059056		
46140	3823	1713671	2014-06-10	2014-06-10 00:00:00	2014-07-01	2014-07-01 00:00:00	2014-07-01	38000177		0	0	21		0	0	0	253926	0	562251	1713671		
46265	3833	1127078	1971-04-29	1971-04-29 00:00:00	1971-06-28	1971-06-28 00:00:00	1971-06-28	38000177		0	0	60		0	0	0	254525	0	282464	1127078		
111499	2450	40213198	2016-09-15	2016-09-15 00:00:00	2016-09-15	2016-09-15 00:00:00	2016-09-15	581452		0	0	0		0	0	0	162548	0	133	40213198		
149590	3290	40213160	1969-12-10	1969-12-10 00:00:00	1969-12-10	1969-12-10 00:00:00	1969-12-10	581452		0	0	0		0	0	0	218558	0	10	40213160		
45843	1000	40213227	1995-08-22	1995-08-22 00:00:00	1995-08-22	1995-08-22 00:00:00	1995-08-22	581452		0	0	0		0	0	0	66174	0	113	40213227		
45396	3756	19075601	2006-02-04	2006-02-04 00:00:00	2006-02-04	2006-02-04 00:00:00	2006-02-04	38000177		0	0	0		0	0	0	249690	0	309362	19075601		
63311	5258	1127433	1982-11-23	1982-11-23 00:00:00	1982-11-30	1982-11-30 00:00:00	1982-11-30	38000177		0	0	7		0	0	0	349890	0	313782	1127433		
25208	2075	1127078	1970-06-20	1970-06-20 00:00:00	1970-07-04	1970-07-04 00:00:00	1970-07-04	38000177		0	0	14		0	0	0	138034	0	282464	1127078		
55969	4646	1127433	1986-06-11	1986-06-11 00:00:00	1986-06-25	1986-06-25 00:00:00	1986-06-25	38000177		0	0	14		0	0	0	309856	0	313782	1127433		
22655	1860	40229134	1971-04-24	1971-04-24 00:00:00	1971-05-08	1971-05-08 00:00:00	1971-05-08	38000177		0	0	14		0	0	0	124350	0	1043400	40229134		
110329	2424	40213160	1962-11-22	1962-11-22 00:00:00	1962-11-22	1962-11-22 00:00:00	1962-11-22	581452		0	0	0		0	0	0	160808	0	10	40213160		
161764	3559	40213198	2015-01-23	2015-01-23 00:00:00	2015-01-23	2015-01-23 00:00:00	2015-01-23	581452		0	0	0		0	0	0	236307	0	133	40213198		
85932	1882	40213160	1968-11-16	1968-11-16 00:00:00	1968-11-16	1968-11-16 00:00:00	1968-11-16	581452		0	0	0		0	0	0	125495	0	10	40213160		
114841	2522	40213160	1963-06-21	1963-06-21 00:00:00	1963-06-21	1963-06-21 00:00:00	1963-06-21	581452		0	0	0		0	0	0	166864	0	10	40213160		
16976	1407	1713671	1989-08-07	1989-08-07 00:00:00	1989-08-21	1989-08-21 00:00:00	1989-08-21	38000177		0	0	14		0	0	0	93536	0	562251	1713671		
104551	2292	40213306	1984-05-25	1984-05-25 00:00:00	1984-05-25	1984-05-25 00:00:00	1984-05-25	581452		0	0	0		0	0	0	\N	0	43	40213306		
21031	1733	1118084	2015-11-27	2015-11-27 00:00:00	2015-11-27	2015-11-27 00:00:00	\N	38000177		0	0	0		0	0	0	115830	0	00025152531	44923712		
21064	1737	1713671	1935-07-12	1935-07-12 00:00:00	1935-08-02	1935-08-02 00:00:00	1935-08-02	38000177		0	0	21		0	0	0	116015	0	562251	1713671		
31587	2619	19126352	2004-10-22	2004-10-22 00:00:00	2004-10-22	2004-10-22 00:00:00	\N	38000177		0	0	0		0	0	0	173248	0	705129	19126352		
54472	4527	1127433	1980-05-06	1980-05-06 00:00:00	1980-05-20	1980-05-20 00:00:00	1980-05-20	38000177		0	0	14		0	0	0	301413	0	313782	1127433		
29320	639	40213260	2006-01-21	2006-01-21 00:00:00	2006-01-21	2006-01-21 00:00:00	2006-01-21	581452		0	0	0		0	0	0	42263	0	121	40213260		
19773	1626	19059056	1943-09-14	1943-09-14 00:00:00	1943-10-05	1943-10-05 00:00:00	1943-10-05	38000177		0	0	21		0	0	0	109186	0	243670	19059056		
38284	3168	1127433	2012-06-09	2012-06-09 00:00:00	2012-06-16	2012-06-16 00:00:00	2012-06-16	38000177		0	0	7		0	0	0	210614	0	313782	1127433		
55288	1211	40213227	1996-06-19	1996-06-19 00:00:00	1996-06-19	1996-06-19 00:00:00	1996-06-19	581452		0	0	0		0	0	0	79665	0	113	40213227		
209443	4593	40213160	1964-02-19	1964-02-19 00:00:00	1964-02-19	1964-02-19 00:00:00	1964-02-19	581452		0	0	0		0	0	0	306077	0	10	40213160		
37292	3082	19128022	1992-05-24	1992-05-24 00:00:00	1993-05-19	1993-05-19 00:00:00	1993-05-19	38000177		0	0	360		0	0	0	205245	0	749785	19128022		
91457	2007	40213160	1991-10-13	1991-10-13 00:00:00	1991-10-13	1991-10-13 00:00:00	1991-10-13	581452		0	0	0		0	0	0	133653	0	10	40213160		
51207	4255	1127078	1974-11-19	1974-11-19 00:00:00	1974-12-03	1974-12-03 00:00:00	1974-12-03	38000177		0	0	14		0	0	0	282555	0	282464	1127078		
239126	5249	40213201	2015-07-12	2015-07-12 00:00:00	2015-07-12	2015-07-12 00:00:00	2015-07-12	581452		0	0	0		0	0	0	349207	0	33	40213201		
57274	4754	40229134	2016-06-28	2016-06-28 00:00:00	2016-07-05	2016-07-05 00:00:00	2016-07-05	38000177		0	0	7		0	0	0	316616	0	1043400	40229134		
23758	1953	19006318	1956-08-28	1956-08-28 00:00:00	1956-09-11	1956-09-11 00:00:00	1956-09-11	38000177		0	0	14		0	0	0	129870	0	105078	19006318		
63549	5279	920300	1990-02-26	1990-02-26 00:00:00	1990-03-05	1990-03-05 00:00:00	1990-03-05	38000177		0	0	7		0	0	0	351147	0	311989	920300		
54893	1202	40213251	1985-06-16	1985-06-16 00:00:00	1985-06-16	1985-06-16 00:00:00	1985-06-16	581452		0	0	0		0	0	0	79032	0	21	40213251		
16603	1376	1713671	1996-08-18	1996-08-18 00:00:00	1996-09-08	1996-09-08 00:00:00	1996-09-08	38000177		0	0	21		0	0	0	91221	0	562251	1713671		
34383	2841	1539411	1991-07-07	1991-07-07 00:00:00	1991-07-07	1991-07-07 00:00:00	\N	38000177		0	0	0		0	0	0	188630	0	312961	1539411		
34425	2845	40231925	2001-04-14	2001-04-14 00:00:00	2001-04-14	2001-04-14 00:00:00	\N	38000177		0	0	0		0	0	0	188985	0	1049221	40231925		
55318	4593	1127433	1977-02-01	1977-02-01 00:00:00	1977-02-15	1977-02-15 00:00:00	1977-02-15	38000177		0	0	14		0	0	0	306034	0	313782	1127433		
10061	842	40169281	1949-12-03	1949-12-03 00:00:00	1949-12-03	1949-12-03 00:00:00	\N	38000177		0	0	0		0	0	0	55756	0	896209	40169281		
9948	834	1127433	1977-09-18	1977-09-18 00:00:00	1977-09-25	1977-09-25 00:00:00	1977-09-25	38000177		0	0	7		0	0	0	55209	0	313782	1127433		
17696	1466	1127433	2004-12-19	2004-12-19 00:00:00	2005-01-09	2005-01-09 00:00:00	2005-01-09	38000177		0	0	21		0	0	0	97665	0	313782	1127433		
55827	4634	19133873	1976-09-17	1976-09-17 00:00:00	1976-09-27	1976-09-27 00:00:00	1976-09-27	38000177		0	0	10		0	0	0	308876	0	834061	19133873		
236817	5199	40213296	2002-01-22	2002-01-22 00:00:00	2002-01-22	2002-01-22 00:00:00	2002-01-22	581452		0	0	0		0	0	0	345750	0	52	40213296		
35095	2896	1127078	1972-11-02	1972-11-02 00:00:00	1972-11-30	1972-11-30 00:00:00	1972-11-30	38000177		0	0	28		0	0	0	192865	0	282464	1127078		
21423	1761	1127433	1995-09-30	1995-09-30 00:00:00	1995-10-07	1995-10-07 00:00:00	1995-10-07	38000177		0	0	7		0	0	0	117757	0	313782	1127433		
63621	5285	19059056	1970-04-13	1970-04-13 00:00:00	1970-04-27	1970-04-27 00:00:00	1970-04-27	38000177		0	0	14		0	0	0	351688	0	243670	19059056		
48528	4020	19133905	1979-07-15	1979-07-15 00:00:00	1979-07-27	1979-07-27 00:00:00	1979-07-27	38000177		0	0	12		0	0	0	267197	0	834102	19133905		
217881	4781	40213251	1984-03-09	1984-03-09 00:00:00	1984-03-09	1984-03-09 00:00:00	1984-03-09	581452		0	0	0		0	0	0	318298	0	21	40213251		
45802	3791	19059056	1980-11-22	1980-11-22 00:00:00	1981-01-21	1981-01-21 00:00:00	1981-01-21	38000177		0	0	60		0	0	0	252160	0	243670	19059056		
38093	3150	19133873	1950-07-25	1950-07-25 00:00:00	1950-08-06	1950-08-06 00:00:00	1950-08-06	38000177		0	0	12		0	0	0	209570	0	834061	19133873		
32139	2663	1127433	1980-12-20	1980-12-20 00:00:00	1981-01-03	1981-01-03 00:00:00	1981-01-03	38000177		0	0	14		0	0	0	176477	0	313782	1127433		
129419	2845	40213227	2003-10-09	2003-10-09 00:00:00	2003-10-09	2003-10-09 00:00:00	2003-10-09	581452		0	0	0		0	0	0	188931	0	113	40213227		
57560	4777	40162522	1974-11-29	1974-11-29 00:00:00	1974-11-29	1974-11-29 00:00:00	\N	38000177		0	0	0		0	0	0	318095	0	857005	40162522		
40868	3389	1115171	2016-12-25	2016-12-25 00:00:00	2017-01-08	2017-01-08 00:00:00	2017-01-08	38000177		0	0	14		0	0	0	224745	0	849574	1115171		
7629	642	1115171	2010-12-20	2010-12-20 00:00:00	2011-01-10	2011-01-10 00:00:00	2011-01-10	38000177		0	0	21		0	0	0	42574	0	849574	1115171		
2865	232	19059056	1948-11-10	1948-11-10 00:00:00	1948-11-24	1948-11-24 00:00:00	1948-11-24	38000177		0	0	14		0	0	0	15567	0	243670	19059056		
113639	2497	40213227	2002-09-19	2002-09-19 00:00:00	2002-09-19	2002-09-19 00:00:00	2002-09-19	581452		0	0	0		0	0	0	165310	0	113	40213227		
104490	2291	40213227	2012-10-11	2012-10-11 00:00:00	2012-10-11	2012-10-11 00:00:00	2012-10-11	581452		0	0	0		0	0	0	152516	0	113	40213227		
43541	949	40213160	1962-11-19	1962-11-19 00:00:00	1962-11-19	1962-11-19 00:00:00	1962-11-19	581452		0	0	0		0	0	0	63051	0	10	40213160		
58971	4899	19133873	1924-11-19	1924-11-19 00:00:00	1924-12-01	1924-12-01 00:00:00	1924-12-01	38000177		0	0	12		0	0	0	325751	0	834061	19133873		
13517	1132	1127433	1983-03-04	1983-03-04 00:00:00	1983-03-18	1983-03-18 00:00:00	1983-03-18	38000177		0	0	14		0	0	0	74497	0	313782	1127433		
31469	2609	1310034	2018-12-14	2018-12-14 00:00:00	2018-12-14	2018-12-14 00:00:00	2018-12-14	38000177		0	0	0		0	0	0	172469	0	834357	1310034		
216577	4753	40213296	2003-06-18	2003-06-18 00:00:00	2003-06-18	2003-06-18 00:00:00	2003-06-18	581452		0	0	0		0	0	0	316517	0	52	40213296		
5547	462	40229134	1981-06-23	1981-06-23 00:00:00	1981-07-07	1981-07-07 00:00:00	1981-07-07	38000177		0	0	14		0	0	0	30880	0	1043400	40229134		
12735	1073	40229134	2006-01-25	2006-01-25 00:00:00	2006-02-01	2006-02-01 00:00:00	2006-02-01	38000177		0	0	7		0	0	0	70323	0	1043400	40229134		
46141	3823	1713671	2010-12-12	2010-12-12 00:00:00	2011-02-20	2011-02-20 00:00:00	2011-02-20	38000177		0	0	70		0	0	0	253951	0	562251	1713671		
46266	3833	19078461	2011-04-06	2011-04-06 00:00:00	2011-04-20	2011-04-20 00:00:00	2011-04-20	38000177		0	0	14		0	0	0	254530	0	310965	19078461		
111503	2450	40213227	2012-08-23	2012-08-23 00:00:00	2012-08-23	2012-08-23 00:00:00	2012-08-23	581452		0	0	0		0	0	0	162535	0	113	40213227		
149594	3290	40213227	2011-07-27	2011-07-27 00:00:00	2011-07-27	2011-07-27 00:00:00	2011-07-27	581452		0	0	0		0	0	0	218569	0	113	40213227		
45851	1000	40213160	1967-09-12	1967-09-12 00:00:00	1967-09-12	1967-09-12 00:00:00	1967-09-12	581452		0	0	0		0	0	0	66164	0	10	40213160		
87525	1921	40213227	2002-10-28	2002-10-28 00:00:00	2002-10-28	2002-10-28 00:00:00	2002-10-28	581452		0	0	0		0	0	0	127775	0	113	40213227		
63312	5258	19128065	1974-07-16	1974-07-16 00:00:00	1975-07-11	1975-07-11 00:00:00	1975-07-11	38000177		0	0	360		0	0	0	349908	0	749882	19128065		
25209	2075	46233988	1970-06-20	1970-06-20 00:00:00	1970-07-04	1970-07-04 00:00:00	1970-07-04	38000177		0	0	14		0	0	0	138034	0	1652673	46233988		
55970	4646	1713671	1970-09-23	1970-09-23 00:00:00	1971-01-13	1971-01-13 00:00:00	1971-01-13	38000177		0	0	112		0	0	0	309760	0	562251	1713671		
22656	1860	1118084	1996-10-02	1996-10-02 00:00:00	1996-10-02	1996-10-02 00:00:00	\N	38000177		0	0	0		0	0	0	124372	0	00025152531	44923712		
110333	2424	40213296	2002-06-20	2002-06-20 00:00:00	2002-06-20	2002-06-20 00:00:00	2002-06-20	581452		0	0	0		0	0	0	160866	0	52	40213296		
161773	3559	40213227	2001-04-06	2001-04-06 00:00:00	2001-04-06	2001-04-06 00:00:00	2001-04-06	581452		0	0	0		0	0	0	236312	0	113	40213227		
85934	1882	40213260	2018-08-11	2018-08-11 00:00:00	2018-08-11	2018-08-11 00:00:00	2018-08-11	581452		0	0	0		0	0	0	125586	0	121	40213260		
47442	1036	40213227	2011-12-09	2011-12-09 00:00:00	2011-12-09	2011-12-09 00:00:00	2011-12-09	581452		0	0	0		0	0	0	68101	0	113	40213227		
16977	1407	1127433	1992-12-14	1992-12-14 00:00:00	1992-12-28	1992-12-28 00:00:00	1992-12-28	38000177		0	0	14		0	0	0	93566	0	313782	1127433		
104554	2292	40213227	1996-06-14	1996-06-14 00:00:00	1996-06-14	1996-06-14 00:00:00	1996-06-14	581452		0	0	0		0	0	0	152621	0	113	40213227		
21032	1733	40229134	2001-03-06	2001-03-06 00:00:00	2001-03-13	2001-03-13 00:00:00	2001-03-13	38000177		0	0	7		0	0	0	115835	0	1043400	40229134		
21065	1737	1127433	2001-02-01	2001-02-01 00:00:00	2001-02-15	2001-02-15 00:00:00	2001-02-15	38000177		0	0	14		0	0	0	116018	0	313782	1127433		
31588	2619	1332419	2004-10-22	2004-10-22 00:00:00	2004-10-22	2004-10-22 00:00:00	\N	38000177		0	0	0		0	0	0	173248	0	197361	1332419		
54473	4527	1127433	2011-09-02	2011-09-02 00:00:00	2011-12-01	2011-12-01 00:00:00	2011-12-01	38000177		0	0	90		0	0	0	301446	0	313782	1127433		
29323	639	40213160	1955-12-10	1955-12-10 00:00:00	1955-12-10	1955-12-10 00:00:00	1955-12-10	581452		0	0	0		0	0	0	42281	0	10	40213160		
19774	1626	40169281	2001-09-30	2001-09-30 00:00:00	2001-09-30	2001-09-30 00:00:00	\N	38000177		0	0	0		0	0	0	109236	0	896209	40169281		
38285	3168	1713671	2015-10-30	2015-10-30 00:00:00	2015-11-13	2015-11-13 00:00:00	2015-11-13	38000177		0	0	14		0	0	0	210624	0	562251	1713671		
55293	1211	40213160	1964-01-29	1964-01-29 00:00:00	1964-01-29	1964-01-29 00:00:00	1964-01-29	581452		0	0	0		0	0	0	79547	0	10	40213160		
209445	4593	40213227	1996-07-04	1996-07-04 00:00:00	1996-07-04	1996-07-04 00:00:00	1996-07-04	581452		0	0	0		0	0	0	306024	0	113	40213227		
37293	3082	19128065	1985-06-30	1985-06-30 00:00:00	1986-06-25	1986-06-25 00:00:00	1986-06-25	38000177		0	0	360		0	0	0	205184	0	749882	19128065		
91460	2007	40213314	1987-04-12	1987-04-12 00:00:00	1987-04-12	1987-04-12 00:00:00	1987-04-12	581452		0	0	0		0	0	0	133649	0	49	40213314		
51208	4255	19129655	1974-11-19	1974-11-19 00:00:00	1974-12-03	1974-12-03 00:00:00	1974-12-03	38000177		0	0	14		0	0	0	282555	0	789980	19129655		
239127	5249	40213198	2014-07-06	2014-07-06 00:00:00	2014-07-06	2014-07-06 00:00:00	2014-07-06	581452		0	0	0		0	0	0	349233	0	133	40213198		
43448	947	40213160	1967-06-09	1967-06-09 00:00:00	1967-06-09	1967-06-09 00:00:00	1967-06-09	581452		0	0	0		0	0	0	62897	0	10	40213160		
23759	1953	1118084	1998-03-11	1998-03-11 00:00:00	1998-03-11	1998-03-11 00:00:00	\N	38000177		0	0	0		0	0	0	129900	0	00025152531	44923712		
63550	5279	40229134	1975-08-07	1975-08-07 00:00:00	1975-08-21	1975-08-21 00:00:00	1975-08-21	38000177		0	0	14		0	0	0	351146	0	1043400	40229134		
54901	1202	40213251	1984-06-10	1984-06-10 00:00:00	1984-06-10	1984-06-10 00:00:00	1984-06-10	581452		0	0	0		0	0	0	79048	0	21	40213251		
16604	1376	19077344	1979-11-11	1979-11-11 00:00:00	1979-11-11	1979-11-11 00:00:00	\N	38000177		0	0	0		0	0	0	91181	0	310325	19077344		
34384	2842	19059056	1970-03-26	1970-03-26 00:00:00	1970-04-30	1970-04-30 00:00:00	1970-04-30	38000177		0	0	35		0	0	0	188707	0	243670	19059056		
34426	2845	19073188	2001-04-14	2001-04-14 00:00:00	2001-05-12	2001-05-12 00:00:00	2001-05-12	38000177		0	0	28		0	0	0	188985	0	308192	19073188		
55319	4593	1713671	1992-05-06	1992-05-06 00:00:00	1992-05-27	1992-05-27 00:00:00	1992-05-27	38000177		0	0	21		0	0	0	306080	0	562251	1713671		
10062	842	1713671	1990-01-09	1990-01-09 00:00:00	1990-01-16	1990-01-16 00:00:00	1990-01-16	38000177		0	0	7		0	0	0	55715	0	562251	1713671		
9949	834	1127078	1965-09-20	1965-09-20 00:00:00	1965-10-25	1965-10-25 00:00:00	1965-10-25	38000177		0	0	35		0	0	0	55206	0	282464	1127078		
17697	1466	1118084	2004-11-16	2004-11-16 00:00:00	2004-11-16	2004-11-16 00:00:00	\N	38000177		0	0	0		0	0	0	97646	0	00025152531	44923712		
55828	4634	1127078	1967-07-02	1967-07-02 00:00:00	1967-07-16	1967-07-16 00:00:00	1967-07-16	38000177		0	0	14		0	0	0	308883	0	282464	1127078		
7530	162	40213227	1992-07-28	1992-07-28 00:00:00	1992-07-28	1992-07-28 00:00:00	1992-07-28	581452		0	0	0		0	0	0	11130	0	113	40213227		
35096	2896	19078461	2014-10-26	2014-10-26 00:00:00	2014-12-25	2014-12-25 00:00:00	2014-12-25	38000177		0	0	60		0	0	0	192868	0	310965	19078461		
21425	1761	19133873	1958-02-25	1958-02-25 00:00:00	1958-03-04	1958-03-04 00:00:00	1958-03-04	38000177		0	0	7		0	0	0	117703	0	834061	19133873		
63622	5285	45892894	2017-04-24	2017-04-24 00:00:00	2017-04-24	2017-04-24 00:00:00	\N	38000177		0	0	0		0	0	0	351637	0	1599803	45892894		
48529	4020	1127433	1964-07-19	1964-07-19 00:00:00	1964-07-26	1964-07-26 00:00:00	1964-07-26	38000177		0	0	7		0	0	0	267217	0	313782	1127433		
217883	4781	40213314	1982-12-10	1982-12-10 00:00:00	1982-12-10	1982-12-10 00:00:00	1982-12-10	581452		0	0	0		0	0	0	318259	0	49	40213314		
45803	3791	1127433	1966-03-15	1966-03-15 00:00:00	1966-04-10	1966-04-10 00:00:00	1966-04-10	38000177		0	0	26		0	0	0	252055	0	313782	1127433		
38094	3150	1127433	1955-01-20	1955-01-20 00:00:00	1955-01-27	1955-01-27 00:00:00	1955-01-27	38000177		0	0	7		0	0	0	209582	0	313782	1127433		
32140	2663	1127433	1965-07-23	1965-07-23 00:00:00	1965-07-30	1965-07-30 00:00:00	1965-07-30	38000177		0	0	7		0	0	0	176475	0	313782	1127433		
28246	614	40213160	1964-02-09	1964-02-09 00:00:00	1964-02-09	1964-02-09 00:00:00	1964-02-09	581452		0	0	0		0	0	0	40801	0	10	40213160		
57561	4777	1127433	1983-06-02	1983-06-02 00:00:00	1983-06-09	1983-06-09 00:00:00	1983-06-09	38000177		0	0	7		0	0	0	318109	0	313782	1127433		
6624	144	40213160	1975-05-30	1975-05-30 00:00:00	1975-05-30	1975-05-30 00:00:00	1975-05-30	581452		0	0	0		0	0	0	9636	0	10	40213160		
7630	642	1118084	1971-06-09	1971-06-09 00:00:00	1971-06-09	1971-06-09 00:00:00	\N	38000177		0	0	0		0	0	0	42554	0	00025152531	44923712		
2866	232	19006318	1948-11-10	1948-11-10 00:00:00	1948-11-24	1948-11-24 00:00:00	1948-11-24	38000177		0	0	14		0	0	0	15567	0	105078	19006318		
113643	2497	40213306	1983-09-29	1983-09-29 00:00:00	1983-09-29	1983-09-29 00:00:00	1983-09-29	581452		0	0	0		0	0	0	165340	0	43	40213306		
104492	2291	40213260	2010-10-14	2010-10-14 00:00:00	2010-10-14	2010-10-14 00:00:00	2010-10-14	581452		0	0	0		0	0	0	152547	0	121	40213260		
24876	2046	1127433	2001-01-31	2001-01-31 00:00:00	2001-02-07	2001-02-07 00:00:00	2001-02-07	38000177		0	0	7		0	0	0	136176	0	313782	1127433		
58972	4899	1127433	1998-03-01	1998-03-01 00:00:00	1998-03-15	1998-03-15 00:00:00	1998-03-15	38000177		0	0	14		0	0	0	325813	0	313782	1127433		
13518	1133	1713671	2002-08-26	2002-08-26 00:00:00	2002-09-09	2002-09-09 00:00:00	2002-09-09	38000177		0	0	14		0	0	0	74575	0	562251	1713671		
31470	2609	46275916	2018-12-14	2018-12-14 00:00:00	2018-12-14	2018-12-14 00:00:00	2018-12-14	38000177		0	0	0		0	0	0	172469	0	1660014	46275916		
216581	4753	40213160	1965-06-23	1965-06-23 00:00:00	1965-06-23	1965-06-23 00:00:00	1965-06-23	581452		0	0	0		0	0	0	316526	0	10	40213160		
5548	462	1127433	1986-09-16	1986-09-16 00:00:00	1986-09-23	1986-09-23 00:00:00	1986-09-23	38000177		0	0	7		0	0	0	30890	0	313782	1127433		
12736	1073	40173590	1996-08-29	1996-08-29 00:00:00	1996-08-29	1996-08-29 00:00:00	\N	38000177		0	0	0		0	0	0	70353	0	904419	40173590		
46142	3823	19059056	1959-05-20	1959-05-20 00:00:00	1959-06-19	1959-06-19 00:00:00	1959-06-19	38000177		0	0	30		0	0	0	253972	0	243670	19059056		
46267	3833	19073188	2011-04-06	2011-04-06 00:00:00	2011-04-20	2011-04-20 00:00:00	2011-04-20	38000177		0	0	14		0	0	0	254530	0	308192	19073188		
111506	2450	40213227	1992-06-04	1992-06-04 00:00:00	1992-06-04	1992-06-04 00:00:00	1992-06-04	581452		0	0	0		0	0	0	162485	0	113	40213227		
149595	3290	40213296	2011-07-27	2011-07-27 00:00:00	2011-07-27	2011-07-27 00:00:00	2011-07-27	581452		0	0	0		0	0	0	218569	0	52	40213296		
45853	1000	40213296	2004-01-06	2004-01-06 00:00:00	2004-01-06	2004-01-06 00:00:00	2004-01-06	581452		0	0	0		0	0	0	66175	0	52	40213296		
87527	1921	40213160	1956-08-20	1956-08-20 00:00:00	1956-08-20	1956-08-20 00:00:00	1956-08-20	581452		0	0	0		0	0	0	127727	0	10	40213160		
63313	5258	1127078	1960-03-02	1960-03-02 00:00:00	1960-03-16	1960-03-16 00:00:00	1960-03-16	38000177		0	0	14		0	0	0	349923	0	282464	1127078		
25210	2075	19059056	1966-07-28	1966-07-28 00:00:00	1966-08-11	1966-08-11 00:00:00	1966-08-11	38000177		0	0	14		0	0	0	138033	0	243670	19059056		
55971	4646	1127433	1945-09-22	1945-09-22 00:00:00	1945-09-29	1945-09-29 00:00:00	1945-09-29	38000177		0	0	7		0	0	0	309719	0	313782	1127433		
22657	1860	1332419	1996-01-15	1996-01-15 00:00:00	1996-01-15	1996-01-15 00:00:00	\N	38000177		0	0	0		0	0	0	124372	0	197361	1332419		
110337	2424	40213227	2013-08-08	2013-08-08 00:00:00	2013-08-08	2013-08-08 00:00:00	2013-08-08	581452		0	0	0		0	0	0	160834	0	113	40213227		
56085	4656	19075601	2008-11-02	2008-11-02 00:00:00	2014-05-11	2014-05-11 00:00:00	2014-05-11	38000177		0	0	2016		0	0	0	310475	0	309362	19075601		
161793	3559	40213160	1955-04-01	1955-04-01 00:00:00	1955-04-01	1955-04-01 00:00:00	1955-04-01	581452		0	0	0		0	0	0	236285	0	10	40213160		
47443	1036	40213296	2011-12-09	2011-12-09 00:00:00	2011-12-09	2011-12-09 00:00:00	2011-12-09	581452		0	0	0		0	0	0	68101	0	52	40213296		
16978	1407	19133905	2012-10-02	2012-10-02 00:00:00	2012-10-15	2012-10-15 00:00:00	2012-10-15	38000177		0	0	13		0	0	0	93485	0	834102	19133905		
104556	2292	40213260	2015-02-13	2015-02-13 00:00:00	2015-02-13	2015-02-13 00:00:00	2015-02-13	581452		0	0	0		0	0	0	152580	0	121	40213260		
21038	1736	1127433	1970-09-01	1970-09-01 00:00:00	1970-09-08	1970-09-08 00:00:00	1970-09-08	38000177		0	0	7		0	0	0	115941	0	313782	1127433		
21066	1737	19059056	1952-12-20	1952-12-20 00:00:00	1953-01-17	1953-01-17 00:00:00	1953-01-17	38000177		0	0	28		0	0	0	115961	0	243670	19059056		
31589	2619	1539411	2004-10-22	2004-10-22 00:00:00	2004-10-22	2004-10-22 00:00:00	\N	38000177		0	0	0		0	0	0	173248	0	312961	1539411		
54474	4527	19128065	1977-05-22	1977-05-22 00:00:00	1978-05-17	1978-05-17 00:00:00	1978-05-17	38000177		0	0	360		0	0	0	301459	0	749882	19128065		
29330	639	40213227	2004-01-10	2004-01-10 00:00:00	2004-01-10	2004-01-10 00:00:00	2004-01-10	581452		0	0	0		0	0	0	42262	0	113	40213227		
19775	1626	19059056	1939-10-26	1939-10-26 00:00:00	1939-11-09	1939-11-09 00:00:00	1939-11-09	38000177		0	0	14		0	0	0	109195	0	243670	19059056		
38286	3168	1115171	2008-10-14	2008-10-14 00:00:00	2009-01-12	2009-01-12 00:00:00	2009-01-12	38000177		0	0	90		0	0	0	210651	0	849574	1115171		
55294	1211	40213160	1964-04-01	1964-04-01 00:00:00	1964-04-01	1964-04-01 00:00:00	1964-04-01	581452		0	0	0		0	0	0	79608	0	10	40213160		
209447	4593	40213227	2014-11-19	2014-11-19 00:00:00	2014-11-19	2014-11-19 00:00:00	2014-11-19	581452		0	0	0		0	0	0	306031	0	113	40213227		
37294	3082	19128065	1989-06-09	1989-06-09 00:00:00	1990-06-04	1990-06-04 00:00:00	1990-06-04	38000177		0	0	360		0	0	0	205240	0	749882	19128065		
91461	2007	40213160	1987-04-12	1987-04-12 00:00:00	1987-04-12	1987-04-12 00:00:00	1987-04-12	581452		0	0	0		0	0	0	133649	0	10	40213160		
51209	4255	1713671	1979-07-27	1979-07-27 00:00:00	1979-08-03	1979-08-03 00:00:00	1979-08-03	38000177		0	0	7		0	0	0	282512	0	562251	1713671		
156241	3439	40213160	1955-02-03	1955-02-03 00:00:00	1955-02-03	1955-02-03 00:00:00	1955-02-03	581452		0	0	0		0	0	0	228174	0	10	40213160		
43450	947	40213227	2008-05-09	2008-05-09 00:00:00	2008-05-09	2008-05-09 00:00:00	2008-05-09	581452		0	0	0		0	0	0	\N	0	113	40213227		
23760	1953	1127078	1960-07-27	1960-07-27 00:00:00	1960-08-10	1960-08-10 00:00:00	1960-08-10	38000177		0	0	14		0	0	0	129911	0	282464	1127078		
63571	5283	1127433	1998-08-29	1998-08-29 00:00:00	1998-09-12	1998-09-12 00:00:00	1998-09-12	38000177		0	0	14		0	0	0	351430	0	313782	1127433		
54907	1202	40213314	1980-12-14	1980-12-14 00:00:00	1980-12-14	1980-12-14 00:00:00	1980-12-14	581452		0	0	0		0	0	0	79077	0	49	40213314		
16605	1376	1124300	2019-04-20	2019-04-20 00:00:00	2019-04-20	2019-04-20 00:00:00	\N	38000177		0	0	0		0	0	0	91233	0	00781178901	45011828		
34385	2842	40229134	2002-02-23	2002-02-23 00:00:00	2002-03-02	2002-03-02 00:00:00	2002-03-02	38000177		0	0	7		0	0	0	188650	0	1043400	40229134		
34428	2845	1127433	2014-02-10	2014-02-10 00:00:00	2014-02-24	2014-02-24 00:00:00	2014-02-24	38000177		0	0	14		0	0	0	188940	0	313782	1127433		
55320	4593	1127078	1971-05-03	1971-05-03 00:00:00	1971-05-31	1971-05-31 00:00:00	1971-05-31	38000177		0	0	28		0	0	0	306049	0	282464	1127078		
10063	843	19133873	1984-02-24	1984-02-24 00:00:00	1984-03-05	1984-03-05 00:00:00	1984-03-05	38000177		0	0	10		0	0	0	55805	0	834061	19133873		
9950	834	1713671	2018-02-09	2018-02-09 00:00:00	2018-02-23	2018-02-23 00:00:00	2018-02-23	38000177		0	0	14		0	0	0	55214	0	562251	1713671		
17698	1466	19128065	1983-02-25	1983-02-25 00:00:00	1984-02-20	1984-02-20 00:00:00	1984-02-20	38000177		0	0	360		0	0	0	97653	0	749882	19128065		
55829	4634	19129655	1967-07-02	1967-07-02 00:00:00	1967-07-16	1967-07-16 00:00:00	1967-07-16	38000177		0	0	14		0	0	0	308883	0	789980	19129655		
7544	162	40213201	2005-09-27	2005-09-27 00:00:00	2005-09-27	2005-09-27 00:00:00	2005-09-27	581452		0	0	0		0	0	0	11144	0	33	40213201		
35097	2896	1127433	2017-09-29	2017-09-29 00:00:00	2017-10-13	2017-10-13 00:00:00	2017-10-13	38000177		0	0	14		0	0	0	192804	0	313782	1127433		
21426	1761	1127433	2014-04-21	2014-04-21 00:00:00	2014-05-21	2014-05-21 00:00:00	2014-05-21	38000177		0	0	30		0	0	0	117721	0	313782	1127433		
63623	5285	19133873	1950-09-27	1950-09-27 00:00:00	1950-10-04	1950-10-04 00:00:00	1950-10-04	38000177		0	0	7		0	0	0	351710	0	834061	19133873		
48530	4020	40229134	1965-02-23	1965-02-23 00:00:00	1965-03-02	1965-03-02 00:00:00	1965-03-02	38000177		0	0	7		0	0	0	267266	0	1043400	40229134		
217889	4781	40213160	1982-01-08	1982-01-08 00:00:00	1982-01-08	1982-01-08 00:00:00	1982-01-08	581452		0	0	0		0	0	0	318281	0	10	40213160		
45804	3791	1127433	2000-07-04	2000-07-04 00:00:00	2000-07-11	2000-07-11 00:00:00	2000-07-11	38000177		0	0	7		0	0	0	252086	0	313782	1127433		
38095	3150	40229134	1945-07-25	1945-07-25 00:00:00	1945-08-08	1945-08-08 00:00:00	1945-08-08	38000177		0	0	14		0	0	0	209572	0	1043400	40229134		
32141	2663	19133873	1965-12-21	1965-12-21 00:00:00	1966-01-01	1966-01-01 00:00:00	1966-01-01	38000177		0	0	11		0	0	0	176476	0	834061	19133873		
28257	614	40213160	1963-12-08	1963-12-08 00:00:00	1963-12-08	1963-12-08 00:00:00	1963-12-08	581452		0	0	0		0	0	0	40860	0	10	40213160		
57563	4777	40229134	1978-05-29	1978-05-29 00:00:00	1978-06-12	1978-06-12 00:00:00	1978-06-12	38000177		0	0	14		0	0	0	318082	0	1043400	40229134		
6626	144	40213160	1975-08-29	1975-08-29 00:00:00	1975-08-29	1975-08-29 00:00:00	1975-08-29	581452		0	0	0		0	0	0	9624	0	10	40213160		
7631	642	1115171	2017-01-08	2017-01-08 00:00:00	2017-01-22	2017-01-22 00:00:00	2017-01-22	38000177		0	0	14		0	0	0	42575	0	849574	1115171		
2867	232	19073188	1988-11-06	1988-11-06 00:00:00	1988-11-27	1988-11-27 00:00:00	1988-11-27	38000177		0	0	21		0	0	0	15618	0	308192	19073188		
113647	2497	40213260	2012-10-18	2012-10-18 00:00:00	2012-10-18	2012-10-18 00:00:00	2012-10-18	581452		0	0	0		0	0	0	165299	0	121	40213260		
104494	2291	40213160	1961-01-19	1961-01-19 00:00:00	1961-01-19	1961-01-19 00:00:00	1961-01-19	581452		0	0	0		0	0	0	152510	0	10	40213160		
24877	2046	1127433	1946-11-21	1946-11-21 00:00:00	1946-11-28	1946-11-28 00:00:00	1946-11-28	38000177		0	0	7		0	0	0	136170	0	313782	1127433		
58973	4899	40236824	1951-06-18	1951-06-18 00:00:00	1951-06-25	1951-06-25 00:00:00	1951-06-25	38000177		0	0	7		0	0	0	325837	0	1094107	40236824		
13520	1133	40231925	2011-03-10	2011-03-10 00:00:00	2011-03-10	2011-03-10 00:00:00	\N	38000177		0	0	0		0	0	0	74585	0	1049221	40231925		
31471	2609	40229134	1960-07-21	1960-07-21 00:00:00	1960-07-28	1960-07-28 00:00:00	1960-07-28	38000177		0	0	7		0	0	0	172496	0	1043400	40229134		
216587	4753	40213306	1983-06-22	1983-06-22 00:00:00	1983-06-22	1983-06-22 00:00:00	1983-06-22	581452		0	0	0		0	0	0	316500	0	43	40213306		
5550	464	1118084	2014-10-23	2014-10-23 00:00:00	2014-10-23	2014-10-23 00:00:00	\N	38000177		0	0	0		0	0	0	30972	0	00025152531	44923712		
12737	1073	19059056	1950-09-10	1950-09-10 00:00:00	1950-10-10	1950-10-10 00:00:00	1950-10-10	38000177		0	0	30		0	0	0	70300	0	243670	19059056		
46143	3823	1115171	2014-10-19	2014-10-19 00:00:00	2014-11-23	2014-11-23 00:00:00	2014-11-23	38000177		0	0	35		0	0	0	253975	0	849574	1115171		
46268	3833	1713671	1973-03-10	1973-03-10 00:00:00	1973-03-31	1973-03-31 00:00:00	1973-03-31	38000177		0	0	21		0	0	0	254499	0	562251	1713671		
55495	4608	1551192	1967-02-11	1967-02-11 00:00:00	1967-02-11	1967-02-11 00:00:00	1967-02-11	38000177		0	0	0		0	0	0	307065	0	312617	1551192		
149598	3290	40213160	1969-07-09	1969-07-09 00:00:00	1969-07-09	1969-07-09 00:00:00	1969-07-09	581452		0	0	0		0	0	0	218557	0	10	40213160		
45855	1000	40213160	1963-05-21	1963-05-21 00:00:00	1963-05-21	1963-05-21 00:00:00	1963-05-21	581452		0	0	0		0	0	0	66201	0	10	40213160		
98809	2164	40213314	1977-09-09	1977-09-09 00:00:00	1977-09-09	1977-09-09 00:00:00	1977-09-09	581452		0	0	0		0	0	0	144131	0	49	40213314		
63314	5258	19006318	1960-03-02	1960-03-02 00:00:00	1960-03-16	1960-03-16 00:00:00	1960-03-16	38000177		0	0	14		0	0	0	349923	0	105078	19006318		
25211	2075	19129655	1966-07-28	1966-07-28 00:00:00	1966-08-11	1966-08-11 00:00:00	1966-08-11	38000177		0	0	14		0	0	0	138033	0	789980	19129655		
55972	4646	19133905	1977-01-23	1977-01-23 00:00:00	1977-02-02	1977-02-02 00:00:00	1977-02-02	38000177		0	0	10		0	0	0	309786	0	834102	19133905		
22658	1860	19126352	1973-12-03	1973-12-03 00:00:00	1985-11-11	1985-11-11 00:00:00	1985-11-11	38000177		0	0	4361		0	0	0	124381	0	705129	19126352		
110338	2424	40213260	2013-08-08	2013-08-08 00:00:00	2013-08-08	2013-08-08 00:00:00	2013-08-08	581452		0	0	0		0	0	0	160834	0	121	40213260		
56086	4656	19126352	2008-11-02	2008-11-02 00:00:00	2014-05-11	2014-05-11 00:00:00	2014-05-11	38000177		0	0	2016		0	0	0	310475	0	705129	19126352		
161800	3559	40213201	2016-01-29	2016-01-29 00:00:00	2016-01-29	2016-01-29 00:00:00	2016-01-29	581452		0	0	0		0	0	0	236316	0	33	40213201		
47446	1036	40213227	2000-11-17	2000-11-17 00:00:00	2000-11-17	2000-11-17 00:00:00	2000-11-17	581452		0	0	0		0	0	0	68100	0	113	40213227		
16979	1407	1127078	1970-10-01	1970-10-01 00:00:00	1970-10-22	1970-10-22 00:00:00	1970-10-22	38000177		0	0	21		0	0	0	93561	0	282464	1127078		
75497	1649	40213160	1960-03-23	1960-03-23 00:00:00	1960-03-23	1960-03-23 00:00:00	1960-03-23	581452		0	0	0		0	0	0	\N	0	10	40213160		
21039	1736	1127433	1992-05-02	1992-05-02 00:00:00	1992-05-09	1992-05-09 00:00:00	1992-05-09	38000177		0	0	7		0	0	0	115917	0	313782	1127433		
21067	1737	19078461	2000-10-12	2000-10-12 00:00:00	2000-11-11	2000-11-11 00:00:00	2000-11-11	38000177		0	0	30		0	0	0	115964	0	310965	19078461		
31590	2619	19075601	2004-10-22	2004-10-22 00:00:00	2004-10-22	2004-10-22 00:00:00	\N	38000177		0	0	0		0	0	0	173248	0	309362	19075601		
54475	4527	19078461	1986-05-25	1986-05-25 00:00:00	1986-06-15	1986-06-15 00:00:00	1986-06-15	38000177		0	0	21		0	0	0	301445	0	310965	19078461		
40634	885	40213160	1975-12-21	1975-12-21 00:00:00	1975-12-21	1975-12-21 00:00:00	1975-12-21	581452		0	0	0		0	0	0	58987	0	10	40213160		
19776	1626	19133905	1956-07-19	1956-07-19 00:00:00	1956-07-26	1956-07-26 00:00:00	1956-07-26	38000177		0	0	7		0	0	0	109260	0	834102	19133905		
38287	3168	40165015	2008-10-14	2008-10-14 00:00:00	2008-10-14	2008-10-14 00:00:00	\N	38000177		0	0	0		0	0	0	210651	0	861467	40165015		
55297	1211	40213260	2013-11-27	2013-11-27 00:00:00	2013-11-27	2013-11-27 00:00:00	2013-11-27	581452		0	0	0		0	0	0	\N	0	121	40213260		
209448	4593	40213260	2014-11-19	2014-11-19 00:00:00	2014-11-19	2014-11-19 00:00:00	2014-11-19	581452		0	0	0		0	0	0	306031	0	121	40213260		
37295	3082	1127078	1970-10-07	1970-10-07 00:00:00	1970-10-21	1970-10-21 00:00:00	1970-10-21	38000177		0	0	14		0	0	0	205225	0	282464	1127078		
91464	2007	40213227	2018-02-25	2018-02-25 00:00:00	2018-02-25	2018-02-25 00:00:00	2018-02-25	581452		0	0	0		0	0	0	133691	0	113	40213227		
51210	4255	1713671	1994-03-25	1994-03-25 00:00:00	1994-04-01	1994-04-01 00:00:00	1994-04-01	38000177		0	0	7		0	0	0	282491	0	562251	1713671		
156252	3439	40213227	2012-11-22	2012-11-22 00:00:00	2012-11-22	2012-11-22 00:00:00	2012-11-22	581452		0	0	0		0	0	0	228172	0	113	40213227		
43451	947	40213296	2008-05-09	2008-05-09 00:00:00	2008-05-09	2008-05-09 00:00:00	2008-05-09	581452		0	0	0		0	0	0	\N	0	52	40213296		
23761	1953	19006318	1960-07-27	1960-07-27 00:00:00	1960-08-10	1960-08-10 00:00:00	1960-08-10	38000177		0	0	14		0	0	0	129911	0	105078	19006318		
63572	5283	19006318	1978-04-07	1978-04-07 00:00:00	1978-04-21	1978-04-21 00:00:00	1978-04-21	38000177		0	0	14		0	0	0	351416	0	105078	19006318		
54908	1202	40213160	1980-12-14	1980-12-14 00:00:00	1980-12-14	1980-12-14 00:00:00	1980-12-14	581452		0	0	0		0	0	0	79077	0	10	40213160		
16606	1376	1713671	1985-08-24	1985-08-24 00:00:00	1985-09-07	1985-09-07 00:00:00	1985-09-07	38000177		0	0	14		0	0	0	91201	0	562251	1713671		
34386	2842	19059056	1979-11-09	1979-11-09 00:00:00	1979-11-23	1979-11-23 00:00:00	1979-11-23	38000177		0	0	14		0	0	0	188708	0	243670	19059056		
34429	2845	1118084	1994-10-12	1994-10-12 00:00:00	1994-10-12	1994-10-12 00:00:00	\N	38000177		0	0	0		0	0	0	188949	0	00025152531	44923712		
207104	4544	40213227	1992-11-10	1992-11-10 00:00:00	1992-11-10	1992-11-10 00:00:00	1992-11-10	581452		0	0	0		0	0	0	302720	0	113	40213227		
10064	843	1127433	1983-07-26	1983-07-26 00:00:00	1983-08-02	1983-08-02 00:00:00	1983-08-02	38000177		0	0	7		0	0	0	55787	0	313782	1127433		
9951	834	1713671	1980-02-03	1980-02-03 00:00:00	1980-02-17	1980-02-17 00:00:00	1980-02-17	38000177		0	0	14		0	0	0	55175	0	562251	1713671		
17699	1466	1713671	1980-12-04	1980-12-04 00:00:00	1980-12-25	1980-12-25 00:00:00	1980-12-25	38000177		0	0	21		0	0	0	97660	0	562251	1713671		
55830	4634	1713671	2015-08-01	2015-08-01 00:00:00	2015-08-22	2015-08-22 00:00:00	2015-08-22	38000177		0	0	21		0	0	0	308882	0	562251	1713671		
55879	4639	19059056	1973-03-06	1973-03-06 00:00:00	1973-04-03	1973-04-03 00:00:00	1973-04-03	38000177		0	0	28		0	0	0	309190	0	243670	19059056		
35098	2896	1127433	1985-06-29	1985-06-29 00:00:00	1985-07-06	1985-07-06 00:00:00	1985-07-06	38000177		0	0	7		0	0	0	192835	0	313782	1127433		
21428	1761	19133873	1959-04-10	1959-04-10 00:00:00	1959-04-20	1959-04-20 00:00:00	1959-04-20	38000177		0	0	10		0	0	0	117786	0	834061	19133873		
63624	5285	1127433	2007-09-05	2007-09-05 00:00:00	2007-09-12	2007-09-12 00:00:00	2007-09-12	38000177		0	0	7		0	0	0	351662	0	313782	1127433		
48531	4020	19075601	2014-10-02	2014-10-02 00:00:00	2014-10-02	2014-10-02 00:00:00	2014-10-02	38000177		0	0	0		0	0	0	267274	0	309362	19075601		
217890	4781	40213314	1982-01-08	1982-01-08 00:00:00	1982-01-08	1982-01-08 00:00:00	1982-01-08	581452		0	0	0		0	0	0	318281	0	49	40213314		
45805	3791	40220960	2014-11-01	2014-11-01 00:00:00	2014-11-01	2014-11-01 00:00:00	2014-11-01	38000177		0	0	0		0	0	0	252148	0	1804799	40220960		
38096	3150	40162522	1957-01-22	1957-01-22 00:00:00	1957-01-22	1957-01-22 00:00:00	\N	38000177		0	0	0		0	0	0	209568	0	857005	40162522		
32164	2666	19059056	1959-12-19	1959-12-19 00:00:00	1960-01-23	1960-01-23 00:00:00	1960-01-23	38000177		0	0	35		0	0	0	176682	0	243670	19059056		
39564	864	40213227	2003-07-28	2003-07-28 00:00:00	2003-07-28	2003-07-28 00:00:00	2003-07-28	581452		0	0	0		0	0	0	57248	0	113	40213227		
88223	1935	40213260	2014-02-04	2014-02-04 00:00:00	2014-02-04	2014-02-04 00:00:00	2014-02-04	581452		0	0	0		0	0	0	128698	0	121	40213260		
6629	144	40213227	2016-12-30	2016-12-30 00:00:00	2016-12-30	2016-12-30 00:00:00	2016-12-30	581452		0	0	0		0	0	0	9645	0	113	40213227		
7632	642	45892894	2016-12-12	2016-12-12 00:00:00	2016-12-12	2016-12-12 00:00:00	\N	38000177		0	0	0		0	0	0	42492	0	1599803	45892894		
2868	232	1127433	1988-11-06	1988-11-06 00:00:00	1988-11-27	1988-11-27 00:00:00	1988-11-27	38000177		0	0	21		0	0	0	15618	0	313782	1127433		
113649	2497	40213227	2012-10-18	2012-10-18 00:00:00	2012-10-18	2012-10-18 00:00:00	2012-10-18	581452		0	0	0		0	0	0	165299	0	113	40213227		
104496	2291	40213160	1961-06-22	1961-06-22 00:00:00	1961-06-22	1961-06-22 00:00:00	1961-06-22	581452		0	0	0		0	0	0	152511	0	10	40213160		
24878	2046	1127433	1991-11-12	1991-11-12 00:00:00	1991-11-19	1991-11-19 00:00:00	1991-11-19	38000177		0	0	7		0	0	0	136183	0	313782	1127433		
58974	4899	920300	1951-06-18	1951-06-18 00:00:00	1951-06-25	1951-06-25 00:00:00	1951-06-25	38000177		0	0	7		0	0	0	325837	0	311989	920300		
13521	1133	19078461	2011-03-10	2011-03-10 00:00:00	2011-05-09	2011-05-09 00:00:00	2011-05-09	38000177		0	0	60		0	0	0	74585	0	310965	19078461		
31472	2609	19059056	1961-11-12	1961-11-12 00:00:00	1961-11-26	1961-11-26 00:00:00	1961-11-26	38000177		0	0	14		0	0	0	172480	0	243670	19059056		
216589	4753	40213260	2012-06-13	2012-06-13 00:00:00	2012-06-13	2012-06-13 00:00:00	2012-06-13	581452		0	0	0		0	0	0	316488	0	121	40213260		
5551	464	1115171	2016-06-24	2016-06-24 00:00:00	2016-07-15	2016-07-15 00:00:00	2016-07-15	38000177		0	0	21		0	0	0	30964	0	849574	1115171		
12738	1073	40162522	1950-09-10	1950-09-10 00:00:00	1950-09-10	1950-09-10 00:00:00	\N	38000177		0	0	0		0	0	0	70300	0	857005	40162522		
46145	3823	19075601	2016-11-16	2016-11-16 00:00:00	2016-11-16	2016-11-16 00:00:00	2016-11-16	38000177		0	0	0		0	0	0	253946	0	309362	19075601		
46269	3833	40229134	1966-09-24	1966-09-24 00:00:00	1966-10-01	1966-10-01 00:00:00	1966-10-01	38000177		0	0	7		0	0	0	254520	0	1043400	40229134		
55496	4608	1127433	1992-05-15	1992-05-15 00:00:00	1992-05-22	1992-05-22 00:00:00	1992-05-22	38000177		0	0	7		0	0	0	306977	0	313782	1127433		
61851	1352	40213198	2012-06-03	2012-06-03 00:00:00	2012-06-03	2012-06-03 00:00:00	2012-06-03	581452		0	0	0		0	0	0	89545	0	133	40213198		
45860	1000	40213227	2014-02-18	2014-02-18 00:00:00	2014-02-18	2014-02-18 00:00:00	2014-02-18	581452		0	0	0		0	0	0	66156	0	113	40213227		
98811	2164	40213160	1973-03-09	1973-03-09 00:00:00	1973-03-09	1973-03-09 00:00:00	1973-03-09	581452		0	0	0		0	0	0	144128	0	10	40213160		
52523	1148	40213260	2007-09-01	2007-09-01 00:00:00	2007-09-01	2007-09-01 00:00:00	2007-09-01	581452		0	0	0		0	0	0	75870	0	121	40213260		
25212	2076	19059056	1973-01-17	1973-01-17 00:00:00	1973-02-16	1973-02-16 00:00:00	1973-02-16	38000177		0	0	30		0	0	0	138209	0	243670	19059056		
55973	4646	1127433	1983-09-17	1983-09-17 00:00:00	1983-09-24	1983-09-24 00:00:00	1983-09-24	38000177		0	0	7		0	0	0	309724	0	313782	1127433		
22659	1860	19126352	1987-01-05	1987-01-05 00:00:00	1987-01-05	1987-01-05 00:00:00	\N	38000177		0	0	0		0	0	0	124402	0	705129	19126352		
110344	2424	40213160	1962-09-20	1962-09-20 00:00:00	1962-09-20	1962-09-20 00:00:00	1962-09-20	581452		0	0	0		0	0	0	160848	0	10	40213160		
56087	4656	1127078	1950-10-06	1950-10-06 00:00:00	1950-11-03	1950-11-03 00:00:00	1950-11-03	38000177		0	0	28		0	0	0	310468	0	282464	1127078		
161802	3559	40213227	2011-06-03	2011-06-03 00:00:00	2011-06-03	2011-06-03 00:00:00	2011-06-03	581452		0	0	0		0	0	0	236292	0	113	40213227		
47450	1036	40213160	1970-02-13	1970-02-13 00:00:00	1970-02-13	1970-02-13 00:00:00	1970-02-13	581452		0	0	0		0	0	0	68175	0	10	40213160		
16980	1407	19059056	1973-11-09	1973-11-09 00:00:00	1973-11-23	1973-11-23 00:00:00	1973-11-23	38000177		0	0	14		0	0	0	93487	0	243670	19059056		
75499	1649	40213227	2017-05-10	2017-05-10 00:00:00	2017-05-10	2017-05-10 00:00:00	2017-05-10	581452		0	0	0		0	0	0	110631	0	113	40213227		
21040	1736	40236824	1985-06-17	1985-06-17 00:00:00	1985-06-24	1985-06-24 00:00:00	1985-06-24	38000177		0	0	7		0	0	0	115910	0	1094107	40236824		
21068	1737	1118084	1950-07-04	1950-07-04 00:00:00	1950-07-04	1950-07-04 00:00:00	\N	38000177		0	0	0		0	0	0	116050	0	00025152531	44923712		
31591	2619	1127433	1980-06-27	1980-06-27 00:00:00	1980-07-04	1980-07-04 00:00:00	1980-07-04	38000177		0	0	7		0	0	0	173208	0	313782	1127433		
54476	4527	1127433	2012-03-21	2012-03-21 00:00:00	2012-04-04	2012-04-04 00:00:00	2012-04-04	38000177		0	0	14		0	0	0	301416	0	313782	1127433		
40638	885	40213314	1977-03-20	1977-03-20 00:00:00	1977-03-20	1977-03-20 00:00:00	1977-03-20	581452		0	0	0		0	0	0	59022	0	49	40213314		
19777	1626	920300	1994-02-14	1994-02-14 00:00:00	1994-02-21	1994-02-21 00:00:00	1994-02-21	38000177		0	0	7		0	0	0	109276	0	311989	920300		
38288	3168	1127078	1981-12-09	1981-12-09 00:00:00	1982-01-08	1982-01-08 00:00:00	1982-01-08	38000177		0	0	30		0	0	0	210647	0	282464	1127078		
55302	1211	40213227	2006-03-01	2006-03-01 00:00:00	2006-03-01	2006-03-01 00:00:00	2006-03-01	581452		0	0	0		0	0	0	79676	0	113	40213227		
209453	4593	40213160	1968-08-22	1968-08-22 00:00:00	1968-08-22	1968-08-22 00:00:00	1968-08-22	581452		0	0	0		0	0	0	306056	0	10	40213160		
37296	3082	1127433	1998-03-28	1998-03-28 00:00:00	1998-04-27	1998-04-27 00:00:00	1998-04-27	38000177		0	0	30		0	0	0	205229	0	313782	1127433		
91468	2007	40213314	1987-02-08	1987-02-08 00:00:00	1987-02-08	1987-02-08 00:00:00	1987-02-08	581452		0	0	0		0	0	0	133670	0	49	40213314		
51211	4255	19133905	2008-12-16	2008-12-16 00:00:00	2008-12-26	2008-12-26 00:00:00	2008-12-26	38000177		0	0	10		0	0	0	282529	0	834102	19133905		
156263	3439	40213160	1956-08-09	1956-08-09 00:00:00	1956-08-09	1956-08-09 00:00:00	1956-08-09	581452		0	0	0		0	0	0	228175	0	10	40213160		
43456	947	40213306	1988-12-02	1988-12-02 00:00:00	1988-12-02	1988-12-02 00:00:00	1988-12-02	581452		0	0	0		0	0	0	62882	0	43	40213306		
23762	1953	1713671	1969-04-01	1969-04-01 00:00:00	1969-04-22	1969-04-22 00:00:00	1969-04-22	38000177		0	0	21		0	0	0	129881	0	562251	1713671		
189777	4167	40213251	1984-04-04	1984-04-04 00:00:00	1984-04-04	1984-04-04 00:00:00	1984-04-04	581452		0	0	0		0	0	0	276997	0	21	40213251		
132662	2914	40213160	1956-01-07	1956-01-07 00:00:00	1956-01-07	1956-01-07 00:00:00	1956-01-07	581452		0	0	0		0	0	0	194176	0	10	40213160		
16607	1376	1127433	2012-07-17	2012-07-17 00:00:00	2012-07-24	2012-07-24 00:00:00	2012-07-24	38000177		0	0	7		0	0	0	91184	0	313782	1127433		
34387	2842	40229134	1982-06-19	1982-06-19 00:00:00	1982-07-03	1982-07-03 00:00:00	1982-07-03	38000177		0	0	14		0	0	0	188649	0	1043400	40229134		
34430	2845	19133873	1953-10-30	1953-10-30 00:00:00	1953-11-08	1953-11-08 00:00:00	1953-11-08	38000177		0	0	9		0	0	0	188904	0	834061	19133873		
45185	3739	19133905	2001-10-28	2001-10-28 00:00:00	2001-11-08	2001-11-08 00:00:00	2001-11-08	38000177		0	0	11		0	0	0	248450	0	834102	19133905		
10065	843	19128009	2006-03-06	2006-03-06 00:00:00	2007-03-01	2007-03-01 00:00:00	2007-03-01	38000177		0	0	360		0	0	0	55796	0	749762	19128009		
9952	834	1127078	1963-05-04	1963-05-04 00:00:00	1963-08-02	1963-08-02 00:00:00	1963-08-02	38000177		0	0	90		0	0	0	55205	0	282464	1127078		
17700	1466	19133873	1975-06-30	1975-06-30 00:00:00	1975-07-09	1975-07-09 00:00:00	1975-07-09	38000177		0	0	9		0	0	0	97620	0	834061	19133873		
55831	4634	40229134	2002-03-15	2002-03-15 00:00:00	2002-03-29	2002-03-29 00:00:00	2002-03-29	38000177		0	0	14		0	0	0	308879	0	1043400	40229134		
55881	4639	19128022	1992-12-31	1992-12-31 00:00:00	1993-12-26	1993-12-26 00:00:00	1993-12-26	38000177		0	0	360		0	0	0	309199	0	749785	19128022		
35099	2897	19078461	2001-03-23	2001-03-23 00:00:00	2001-04-13	2001-04-13 00:00:00	2001-04-13	38000177		0	0	21		0	0	0	192944	0	310965	19078461		
21429	1761	19133905	2001-01-01	2001-01-01 00:00:00	2001-01-10	2001-01-10 00:00:00	2001-01-10	38000177		0	0	9		0	0	0	117709	0	834102	19133905		
63625	5285	40174880	2011-11-19	2011-11-19 00:00:00	2011-11-19	2011-11-19 00:00:00	\N	38000177		0	0	0		0	0	0	351664	0	966222	40174880		
48532	4020	40220960	2014-10-02	2014-10-02 00:00:00	2014-10-02	2014-10-02 00:00:00	2014-10-02	38000177		0	0	0		0	0	0	267274	0	1804799	40220960		
82735	1808	40213306	1984-10-09	1984-10-09 00:00:00	1984-10-09	1984-10-09 00:00:00	1984-10-09	581452		0	0	0		0	0	0	121054	0	43	40213306		
45806	3791	19075601	2014-11-01	2014-11-01 00:00:00	2014-11-01	2014-11-01 00:00:00	2014-11-01	38000177		0	0	0		0	0	0	252148	0	309362	19075601		
38097	3150	19059056	1957-01-22	1957-01-22 00:00:00	1957-02-21	1957-02-21 00:00:00	1957-02-21	38000177		0	0	30		0	0	0	209568	0	243670	19059056		
32165	2666	19059056	1954-10-27	1954-10-27 00:00:00	1954-11-10	1954-11-10 00:00:00	1954-11-10	38000177		0	0	14		0	0	0	176607	0	243670	19059056		
41543	905	40213227	2000-05-27	2000-05-27 00:00:00	2000-05-27	2000-05-27 00:00:00	2000-05-27	581452		0	0	0		0	0	0	60152	0	113	40213227		
88225	1935	40213227	2006-05-16	2006-05-16 00:00:00	2006-05-16	2006-05-16 00:00:00	2006-05-16	581452		0	0	0		0	0	0	128697	0	113	40213227		
6630	144	40213296	2016-12-30	2016-12-30 00:00:00	2016-12-30	2016-12-30 00:00:00	2016-12-30	581452		0	0	0		0	0	0	9645	0	52	40213296		
50138	4160	19078461	2017-06-08	2017-06-08 00:00:00	2017-06-29	2017-06-29 00:00:00	2017-06-29	38000177		0	0	21		0	0	0	276413	0	310965	19078461		
2869	232	1127433	2007-08-31	2007-08-31 00:00:00	2007-09-07	2007-09-07 00:00:00	2007-09-07	38000177		0	0	7		0	0	0	15637	0	313782	1127433		
113654	2497	40213227	1994-09-08	1994-09-08 00:00:00	1994-09-08	1994-09-08 00:00:00	1994-09-08	581452		0	0	0		0	0	0	165344	0	113	40213227		
104500	2291	40213160	1961-03-23	1961-03-23 00:00:00	1961-03-23	1961-03-23 00:00:00	1961-03-23	581452		0	0	0		0	0	0	152550	0	10	40213160		
24879	2046	1713671	1996-04-19	1996-04-19 00:00:00	1996-05-03	1996-05-03 00:00:00	1996-05-03	38000177		0	0	14		0	0	0	136175	0	562251	1713671		
58975	4899	40229134	1947-09-10	1947-09-10 00:00:00	1947-09-17	1947-09-17 00:00:00	1947-09-17	38000177		0	0	7		0	0	0	325767	0	1043400	40229134		
13522	1133	19128065	1982-06-20	1982-06-20 00:00:00	1983-06-15	1983-06-15 00:00:00	1983-06-15	38000177		0	0	360		0	0	0	74602	0	749882	19128065		
31473	2609	19129655	1961-11-12	1961-11-12 00:00:00	1961-11-26	1961-11-26 00:00:00	1961-11-26	38000177		0	0	14		0	0	0	172480	0	789980	19129655		
188667	4142	40213227	2012-12-02	2012-12-02 00:00:00	2012-12-02	2012-12-02 00:00:00	2012-12-02	581452		0	0	0		0	0	0	275316	0	113	40213227		
5552	464	1713671	1983-04-26	1983-04-26 00:00:00	1983-05-03	1983-05-03 00:00:00	1983-05-03	38000177		0	0	7		0	0	0	30982	0	562251	1713671		
12739	1073	19133905	1996-08-08	1996-08-08 00:00:00	1996-08-16	1996-08-16 00:00:00	1996-08-16	38000177		0	0	8		0	0	0	70422	0	834102	19133905		
46146	3823	40220960	2016-11-16	2016-11-16 00:00:00	2016-11-16	2016-11-16 00:00:00	2016-11-16	38000177		0	0	0		0	0	0	253946	0	1804799	40220960		
46270	3833	1127433	1985-09-23	1985-09-23 00:00:00	1985-09-30	1985-09-30 00:00:00	1985-09-30	38000177		0	0	7		0	0	0	254538	0	313782	1127433		
55497	4608	19059056	1967-12-08	1967-12-08 00:00:00	1967-12-22	1967-12-22 00:00:00	1967-12-22	38000177		0	0	14		0	0	0	306960	0	243670	19059056		
61855	1352	40213227	2018-01-28	2018-01-28 00:00:00	2018-01-28	2018-01-28 00:00:00	2018-01-28	581452		0	0	0		0	0	0	89575	0	113	40213227		
45861	1000	40213260	2014-02-18	2014-02-18 00:00:00	2014-02-18	2014-02-18 00:00:00	2014-02-18	581452		0	0	0		0	0	0	66156	0	121	40213260		
98821	2164	40213227	1995-02-17	1995-02-17 00:00:00	1995-02-17	1995-02-17 00:00:00	1995-02-17	581452		0	0	0		0	0	0	144165	0	113	40213227		
52530	1149	40213314	1980-04-08	1980-04-08 00:00:00	1980-04-08	1980-04-08 00:00:00	1980-04-08	581452		0	0	0		0	0	0	75966	0	49	40213314		
25213	2076	1127078	1976-11-27	1976-11-27 00:00:00	1977-02-25	1977-02-25 00:00:00	1977-02-25	38000177		0	0	90		0	0	0	138210	0	282464	1127078		
55974	4646	40229134	1947-07-03	1947-07-03 00:00:00	1947-07-17	1947-07-17 00:00:00	1947-07-17	38000177		0	0	14		0	0	0	309720	0	1043400	40229134		
22660	1860	46275916	1991-12-23	1991-12-23 00:00:00	1991-12-23	1991-12-23 00:00:00	1991-12-23	38000177		0	0	0		0	0	0	124407	0	1660014	46275916		
110346	2424	40213227	2004-06-24	2004-06-24 00:00:00	2004-06-24	2004-06-24 00:00:00	2004-06-24	581452		0	0	0		0	0	0	160832	0	113	40213227		
56088	4656	1127433	1989-05-12	1989-05-12 00:00:00	1989-06-02	1989-06-02 00:00:00	1989-06-02	38000177		0	0	21		0	0	0	310470	0	313782	1127433		
161809	3560	40213260	2011-05-11	2011-05-11 00:00:00	2011-05-11	2011-05-11 00:00:00	2011-05-11	581452		0	0	0		0	0	0	236397	0	121	40213260		
47462	1036	40213296	2009-12-04	2009-12-04 00:00:00	2009-12-04	2009-12-04 00:00:00	2009-12-04	581452		0	0	0		0	0	0	68215	0	52	40213296		
16981	1407	19129655	1973-11-09	1973-11-09 00:00:00	1973-11-23	1973-11-23 00:00:00	1973-11-23	38000177		0	0	14		0	0	0	93487	0	789980	19129655		
75501	1649	40213260	2006-03-08	2006-03-08 00:00:00	2006-03-08	2006-03-08 00:00:00	2006-03-08	581452		0	0	0		0	0	0	110629	0	121	40213260		
21041	1736	920300	1985-06-17	1985-06-17 00:00:00	1985-06-24	1985-06-24 00:00:00	1985-06-24	38000177		0	0	7		0	0	0	115910	0	311989	920300		
21069	1737	1127433	1941-08-31	1941-08-31 00:00:00	1941-09-14	1941-09-14 00:00:00	1941-09-14	38000177		0	0	14		0	0	0	115978	0	313782	1127433		
31592	2619	19006318	1945-10-24	1945-10-24 00:00:00	1945-11-07	1945-11-07 00:00:00	1945-11-07	38000177		0	0	14		0	0	0	173217	0	105078	19006318		
54477	4527	19059056	1964-02-20	1964-02-20 00:00:00	1964-03-05	1964-03-05 00:00:00	1964-03-05	38000177		0	0	14		0	0	0	301418	0	243670	19059056		
40640	885	40213314	1977-09-18	1977-09-18 00:00:00	1977-09-18	1977-09-18 00:00:00	1977-09-18	581452		0	0	0		0	0	0	59042	0	49	40213314		
19778	1626	40236824	1994-02-14	1994-02-14 00:00:00	1994-02-21	1994-02-21 00:00:00	1994-02-21	38000177		0	0	7		0	0	0	109276	0	1094107	40236824		
38289	3168	1115171	2007-10-22	2007-10-22 00:00:00	2007-11-19	2007-11-19 00:00:00	2007-11-19	38000177		0	0	28		0	0	0	210650	0	849574	1115171		
55303	1211	40213296	2006-03-01	2006-03-01 00:00:00	2006-03-01	2006-03-01 00:00:00	2006-03-01	581452		0	0	0		0	0	0	79676	0	52	40213296		
227627	4998	40213160	1965-06-18	1965-06-18 00:00:00	1965-06-18	1965-06-18 00:00:00	1965-06-18	581452		0	0	0		0	0	0	332409	0	10	40213160		
37297	3082	19128065	1984-07-05	1984-07-05 00:00:00	1985-06-30	1985-06-30 00:00:00	1985-06-30	38000177		0	0	360		0	0	0	205233	0	749882	19128065		
91469	2007	40213160	1987-02-08	1987-02-08 00:00:00	1987-02-08	1987-02-08 00:00:00	1987-02-08	581452		0	0	0		0	0	0	133670	0	10	40213160		
51212	4255	1115171	2019-06-29	2019-06-29 00:00:00	2019-06-29	2019-06-29 00:00:00	\N	38000177		0	0	0		0	0	0	282506	0	849574	1115171		
156267	3439	40213201	2017-12-21	2017-12-21 00:00:00	2017-12-21	2017-12-21 00:00:00	2017-12-21	581452		0	0	0		0	0	0	228146	0	33	40213201		
43459	948	40213296	2000-09-29	2000-09-29 00:00:00	2000-09-29	2000-09-29 00:00:00	2000-09-29	581452		0	0	0		0	0	0	62957	0	52	40213296		
23763	1953	40229134	1957-06-26	1957-06-26 00:00:00	1957-07-03	1957-07-03 00:00:00	1957-07-03	38000177		0	0	7		0	0	0	129908	0	1043400	40229134		
189781	4167	40213314	1978-12-27	1978-12-27 00:00:00	1978-12-27	1978-12-27 00:00:00	1978-12-27	581452		0	0	0		0	0	0	276900	0	49	40213314		
132668	2914	40213260	2007-10-13	2007-10-13 00:00:00	2007-10-13	2007-10-13 00:00:00	2007-10-13	581452		0	0	0		0	0	0	194168	0	121	40213260		
16608	1377	40224805	1995-11-20	1995-11-20 00:00:00	1996-11-14	1996-11-14 00:00:00	1996-11-14	38000177		0	0	360		0	0	0	91257	0	1000126	40224805		
34388	2842	40229134	1989-07-16	1989-07-16 00:00:00	1989-07-23	1989-07-23 00:00:00	1989-07-23	38000177		0	0	7		0	0	0	188646	0	1043400	40229134		
34431	2845	40236824	2015-11-28	2015-11-28 00:00:00	2015-12-05	2015-12-05 00:00:00	2015-12-05	38000177		0	0	7		0	0	0	188962	0	1094107	40236824		
45186	3739	1115171	2006-06-11	2006-06-11 00:00:00	2006-08-10	2006-08-10 00:00:00	2006-08-10	38000177		0	0	60		0	0	0	248442	0	849574	1115171		
10066	843	19059056	1983-11-22	1983-11-22 00:00:00	1983-12-06	1983-12-06 00:00:00	1983-12-06	38000177		0	0	14		0	0	0	55852	0	243670	19059056		
9953	834	1127433	1989-11-09	1989-11-09 00:00:00	1989-11-23	1989-11-23 00:00:00	1989-11-23	38000177		0	0	14		0	0	0	55176	0	313782	1127433		
17701	1467	19078461	1994-03-20	1994-03-20 00:00:00	1994-04-17	1994-04-17 00:00:00	1994-04-17	38000177		0	0	28		0	0	0	97667	0	310965	19078461		
55832	4634	19128065	1981-10-09	1981-10-09 00:00:00	1982-10-04	1982-10-04 00:00:00	1982-10-04	38000177		0	0	360		0	0	0	308840	0	749882	19128065		
55882	4639	43012754	1996-12-10	1996-12-10 00:00:00	1997-12-05	1997-12-05 00:00:00	1997-12-05	38000177		0	0	360		0	0	0	309223	0	1366343	43012754		
35100	2897	1127433	1977-02-21	1977-02-21 00:00:00	1977-02-28	1977-02-28 00:00:00	1977-02-28	38000177		0	0	7		0	0	0	192948	0	313782	1127433		
21430	1761	1127078	1960-10-12	1960-10-12 00:00:00	1960-11-15	1960-11-15 00:00:00	1960-11-15	38000177		0	0	34		0	0	0	117718	0	282464	1127078		
63626	5285	19126352	2008-09-21	2008-09-21 00:00:00	2008-09-21	2008-09-21 00:00:00	\N	38000177		0	0	0		0	0	0	351646	0	705129	19126352		
48533	4020	19059056	1959-12-11	1959-12-11 00:00:00	1960-01-01	1960-01-01 00:00:00	1960-01-01	38000177		0	0	21		0	0	0	267234	0	243670	19059056		
82737	1808	40213160	1962-10-16	1962-10-16 00:00:00	1962-10-16	1962-10-16 00:00:00	1962-10-16	581452		0	0	0		0	0	0	121027	0	10	40213160		
45807	3791	1118084	1947-10-10	1947-10-10 00:00:00	1947-10-10	1947-10-10 00:00:00	\N	38000177		0	0	0		0	0	0	252142	0	00025152531	44923712		
38098	3150	19133873	1947-01-01	1947-01-01 00:00:00	1947-01-11	1947-01-11 00:00:00	1947-01-11	38000177		0	0	10		0	0	0	209569	0	834061	19133873		
32166	2666	19006318	1954-10-27	1954-10-27 00:00:00	1954-11-10	1954-11-10 00:00:00	1954-11-10	38000177		0	0	14		0	0	0	176607	0	105078	19006318		
41544	905	40213260	2018-09-22	2018-09-22 00:00:00	2018-09-22	2018-09-22 00:00:00	2018-09-22	581452		0	0	0		0	0	0	60157	0	121	40213260		
88226	1935	40213296	2006-05-16	2006-05-16 00:00:00	2006-05-16	2006-05-16 00:00:00	2006-05-16	581452		0	0	0		0	0	0	128697	0	52	40213296		
193602	4253	40213314	1982-03-01	1982-03-01 00:00:00	1982-03-01	1982-03-01 00:00:00	1982-03-01	581452		0	0	0		0	0	0	282426	0	49	40213314		
50139	4160	19128065	1983-05-26	1983-05-26 00:00:00	1984-05-20	1984-05-20 00:00:00	1984-05-20	38000177		0	0	360		0	0	0	276423	0	749882	19128065		
2870	232	19133905	2007-11-11	2007-11-11 00:00:00	2007-11-20	2007-11-20 00:00:00	2007-11-20	38000177		0	0	9		0	0	0	15601	0	834102	19133905		
113664	2497	40213296	2004-09-23	2004-09-23 00:00:00	2004-09-23	2004-09-23 00:00:00	2004-09-23	581452		0	0	0		0	0	0	165337	0	52	40213296		
104511	2292	40213306	1987-06-05	1987-06-05 00:00:00	1987-06-05	1987-06-05 00:00:00	1987-06-05	581452		0	0	0		0	0	0	152603	0	43	40213306		
24880	2046	19133873	1945-03-03	1945-03-03 00:00:00	1945-03-15	1945-03-15 00:00:00	1945-03-15	38000177		0	0	12		0	0	0	136145	0	834061	19133873		
58976	4899	19133873	1934-10-07	1934-10-07 00:00:00	1934-10-16	1934-10-16 00:00:00	1934-10-16	38000177		0	0	9		0	0	0	325775	0	834061	19133873		
13524	1133	1118084	2000-07-20	2000-07-20 00:00:00	2000-07-20	2000-07-20 00:00:00	\N	38000177		0	0	0		0	0	0	74630	0	00025152531	44923712		
31474	2609	1713671	1966-07-14	1966-07-14 00:00:00	1966-07-28	1966-07-28 00:00:00	1966-07-28	38000177		0	0	14		0	0	0	172472	0	562251	1713671		
188673	4143	40213227	1994-05-06	1994-05-06 00:00:00	1994-05-06	1994-05-06 00:00:00	1994-05-06	581452		0	0	0		0	0	0	275400	0	113	40213227		
24113	1982	40231925	1957-05-25	1957-05-25 00:00:00	1957-05-25	1957-05-25 00:00:00	\N	38000177		0	0	0		0	0	0	131970	0	1049221	40231925		
12740	1073	19133905	1980-03-23	1980-03-23 00:00:00	1980-04-02	1980-04-02 00:00:00	1980-04-02	38000177		0	0	10		0	0	0	70311	0	834102	19133905		
46147	3823	40162522	1976-01-21	1976-01-21 00:00:00	1976-01-21	1976-01-21 00:00:00	\N	38000177		0	0	0		0	0	0	253973	0	857005	40162522		
46271	3833	1118084	2001-12-07	2001-12-07 00:00:00	2001-12-07	2001-12-07 00:00:00	\N	38000177		0	0	0		0	0	0	254486	0	00025152531	44923712		
55498	4608	19129655	1967-12-08	1967-12-08 00:00:00	1967-12-22	1967-12-22 00:00:00	1967-12-22	38000177		0	0	14		0	0	0	306960	0	789980	19129655		
61876	1352	40213227	1997-08-31	1997-08-31 00:00:00	1997-08-31	1997-08-31 00:00:00	1997-08-31	581452		0	0	0		0	0	0	89587	0	113	40213227		
45863	1000	40213296	2006-01-10	2006-01-10 00:00:00	2006-01-10	2006-01-10 00:00:00	2006-01-10	581452		0	0	0		0	0	0	66185	0	52	40213296		
98822	2164	40213306	1995-02-17	1995-02-17 00:00:00	1995-02-17	1995-02-17 00:00:00	1995-02-17	581452		0	0	0		0	0	0	144165	0	43	40213306		
52535	1149	40213160	1984-01-10	1984-01-10 00:00:00	1984-01-10	1984-01-10 00:00:00	1984-01-10	581452		0	0	0		0	0	0	75967	0	10	40213160		
25214	2076	1127433	2017-12-27	2017-12-27 00:00:00	2018-01-24	2018-01-24 00:00:00	2018-01-24	38000177		0	0	28		0	0	0	138212	0	313782	1127433		
55975	4646	40229134	2001-09-20	2001-09-20 00:00:00	2001-10-04	2001-10-04 00:00:00	2001-10-04	38000177		0	0	14		0	0	0	309826	0	1043400	40229134		
22661	1860	40243436	1991-12-23	1991-12-23 00:00:00	1991-12-23	1991-12-23 00:00:00	1991-12-23	38000177		0	0	0		0	0	0	124407	0	1190795	40243436		
110347	2424	40213296	2004-06-24	2004-06-24 00:00:00	2004-06-24	2004-06-24 00:00:00	2004-06-24	581452		0	0	0		0	0	0	160832	0	52	40213296		
56089	4656	19059056	1963-05-15	1963-05-15 00:00:00	1963-05-29	1963-05-29 00:00:00	1963-05-29	38000177		0	0	14		0	0	0	310484	0	243670	19059056		
161811	3560	40213227	2011-05-11	2011-05-11 00:00:00	2011-05-11	2011-05-11 00:00:00	2011-05-11	581452		0	0	0		0	0	0	236397	0	113	40213227		
47464	1036	40213160	1970-05-15	1970-05-15 00:00:00	1970-05-15	1970-05-15 00:00:00	1970-05-15	581452		0	0	0		0	0	0	68125	0	10	40213160		
16982	1407	1118084	2002-11-17	2002-11-17 00:00:00	2002-11-17	2002-11-17 00:00:00	\N	38000177		0	0	0		0	0	0	93508	0	00025152531	44923712		
75505	1649	40213296	1998-11-11	1998-11-11 00:00:00	1998-11-11	1998-11-11 00:00:00	1998-11-11	581452		0	0	0		0	0	0	110668	0	52	40213296		
21042	1736	40236824	1989-10-20	1989-10-20 00:00:00	1989-11-03	1989-11-03 00:00:00	1989-11-03	38000177		0	0	14		0	0	0	115899	0	1094107	40236824		
21070	1737	1127433	1912-10-17	1912-10-17 00:00:00	1912-10-24	1912-10-24 00:00:00	1912-10-24	38000177		0	0	7		0	0	0	115975	0	313782	1127433		
31593	2619	19059056	1945-10-24	1945-10-24 00:00:00	1945-11-07	1945-11-07 00:00:00	1945-11-07	38000177		0	0	14		0	0	0	173217	0	243670	19059056		
54478	4527	19129655	1964-02-20	1964-02-20 00:00:00	1964-03-05	1964-03-05 00:00:00	1964-03-05	38000177		0	0	14		0	0	0	301418	0	789980	19129655		
78798	1724	40213160	1955-08-29	1955-08-29 00:00:00	1955-08-29	1955-08-29 00:00:00	1955-08-29	581452		0	0	0		0	0	0	115335	0	10	40213160		
19779	1626	1713671	1976-03-18	1976-03-18 00:00:00	1976-04-01	1976-04-01 00:00:00	1976-04-01	38000177		0	0	14		0	0	0	109204	0	562251	1713671		
38290	3168	1127078	1987-03-13	1987-03-13 00:00:00	1987-06-11	1987-06-11 00:00:00	1987-06-11	38000177		0	0	90		0	0	0	210648	0	282464	1127078		
55304	1211	40213296	2004-02-25	2004-02-25 00:00:00	2004-02-25	2004-02-25 00:00:00	2004-02-25	581452		0	0	0		0	0	0	79530	0	52	40213296		
227630	4998	40213160	1969-09-19	1969-09-19 00:00:00	1969-09-19	1969-09-19 00:00:00	1969-09-19	581452		0	0	0		0	0	0	332363	0	10	40213160		
37298	3082	1310034	1988-05-04	1988-05-04 00:00:00	1988-05-04	1988-05-04 00:00:00	1988-05-04	38000177		0	0	0		0	0	0	205228	0	834357	1310034		
33097	2745	1127433	2017-09-09	2017-09-09 00:00:00	2017-09-30	2017-09-30 00:00:00	2017-09-30	38000177		0	0	21		0	0	0	181605	0	313782	1127433		
51213	4255	1127433	1999-12-11	1999-12-11 00:00:00	2000-01-10	2000-01-10 00:00:00	2000-01-10	38000177		0	0	30		0	0	0	282505	0	313782	1127433		
121196	2663	40213227	1994-11-06	1994-11-06 00:00:00	1994-11-06	1994-11-06 00:00:00	1994-11-06	581452		0	0	0		0	0	0	176468	0	113	40213227		
43461	948	40213227	2000-09-29	2000-09-29 00:00:00	2000-09-29	2000-09-29 00:00:00	2000-09-29	581452		0	0	0		0	0	0	62957	0	113	40213227		
23765	1954	19059056	1936-12-25	1936-12-25 00:00:00	1937-01-08	1937-01-08 00:00:00	1937-01-08	38000177		0	0	14		0	0	0	129953	0	243670	19059056		
189782	4167	40213160	1978-12-27	1978-12-27 00:00:00	1978-12-27	1978-12-27 00:00:00	1978-12-27	581452		0	0	0		0	0	0	276900	0	10	40213160		
132669	2914	40213296	1996-08-24	1996-08-24 00:00:00	1996-08-24	1996-08-24 00:00:00	1996-08-24	581452		0	0	0		0	0	0	194232	0	52	40213296		
16609	1377	1127078	1982-11-18	1982-11-18 00:00:00	1982-12-02	1982-12-02 00:00:00	1982-12-02	38000177		0	0	14		0	0	0	91271	0	282464	1127078		
34389	2842	1713671	2000-10-06	2000-10-06 00:00:00	2000-10-20	2000-10-20 00:00:00	2000-10-20	38000177		0	0	14		0	0	0	188666	0	562251	1713671		
34432	2845	920300	2015-11-28	2015-11-28 00:00:00	2015-12-05	2015-12-05 00:00:00	2015-12-05	38000177		0	0	7		0	0	0	188962	0	311989	920300		
45187	3739	40165015	2006-06-11	2006-06-11 00:00:00	2006-06-11	2006-06-11 00:00:00	\N	38000177		0	0	0		0	0	0	248442	0	861467	40165015		
10067	843	1127078	1984-11-03	1984-11-03 00:00:00	1984-11-17	1984-11-17 00:00:00	1984-11-17	38000177		0	0	14		0	0	0	55814	0	282464	1127078		
9954	834	1127433	1983-01-04	1983-01-04 00:00:00	1983-01-25	1983-01-25 00:00:00	1983-01-25	38000177		0	0	21		0	0	0	55251	0	313782	1127433		
17702	1467	19059056	1966-08-30	1966-08-30 00:00:00	1966-09-13	1966-09-13 00:00:00	1966-09-13	38000177		0	0	14		0	0	0	97666	0	243670	19059056		
55833	4634	19133905	1989-06-30	1989-06-30 00:00:00	1989-07-09	1989-07-09 00:00:00	1989-07-09	38000177		0	0	9		0	0	0	308878	0	834102	19133905		
55883	4639	19128065	1993-12-26	1993-12-26 00:00:00	1994-12-21	1994-12-21 00:00:00	1994-12-21	38000177		0	0	360		0	0	0	309200	0	749882	19128065		
35101	2897	19059056	1970-11-23	1970-11-23 00:00:00	1970-12-28	1970-12-28 00:00:00	1970-12-28	38000177		0	0	35		0	0	0	192941	0	243670	19059056		
21431	1761	1127078	1957-10-27	1957-10-27 00:00:00	1957-11-10	1957-11-10 00:00:00	1957-11-10	38000177		0	0	14		0	0	0	117746	0	282464	1127078		
63627	5285	19075601	2008-09-21	2008-09-21 00:00:00	2008-09-21	2008-09-21 00:00:00	\N	38000177		0	0	0		0	0	0	351646	0	309362	19075601		
48534	4020	19133905	1979-04-04	1979-04-04 00:00:00	1979-04-14	1979-04-14 00:00:00	1979-04-14	38000177		0	0	10		0	0	0	267219	0	834102	19133905		
82744	1808	40213160	1962-05-15	1962-05-15 00:00:00	1962-05-15	1962-05-15 00:00:00	1962-05-15	581452		0	0	0		0	0	0	121026	0	10	40213160		
45808	3791	1127433	1932-06-26	1932-06-26 00:00:00	1932-07-03	1932-07-03 00:00:00	1932-07-03	38000177		0	0	7		0	0	0	252053	0	313782	1127433		
38099	3150	40229134	1955-12-24	1955-12-24 00:00:00	1956-01-07	1956-01-07 00:00:00	1956-01-07	38000177		0	0	14		0	0	0	209606	0	1043400	40229134		
32167	2666	1713671	1958-02-01	1958-02-01 00:00:00	1958-02-15	1958-02-15 00:00:00	1958-02-15	38000177		0	0	14		0	0	0	176604	0	562251	1713671		
41547	905	40213306	1991-05-18	1991-05-18 00:00:00	1991-05-18	1991-05-18 00:00:00	1991-05-18	581452		0	0	0		0	0	0	60169	0	43	40213306		
88229	1935	40213227	1996-02-06	1996-02-06 00:00:00	1996-02-06	1996-02-06 00:00:00	1996-02-06	581452		0	0	0		0	0	0	128734	0	113	40213227		
193616	4253	40213160	1981-09-01	1981-09-01 00:00:00	1981-09-01	1981-09-01 00:00:00	1981-09-01	581452		0	0	0		0	0	0	282445	0	10	40213160		
50140	4160	1127433	2011-11-18	2011-11-18 00:00:00	2011-12-02	2011-12-02 00:00:00	2011-12-02	38000177		0	0	14		0	0	0	276452	0	313782	1127433		
2871	232	1127433	1983-05-07	1983-05-07 00:00:00	1983-07-06	1983-07-06 00:00:00	1983-07-06	38000177		0	0	60		0	0	0	15617	0	313782	1127433		
59338	4932	1713671	2012-09-21	2012-09-21 00:00:00	2012-10-12	2012-10-12 00:00:00	2012-10-12	38000177		0	0	21		0	0	0	327884	0	562251	1713671		
104515	2292	40213160	1964-02-21	1964-02-21 00:00:00	1964-02-21	1964-02-21 00:00:00	1964-02-21	581452		0	0	0		0	0	0	152608	0	10	40213160		
24881	2046	19059056	1966-03-30	1966-03-30 00:00:00	1966-04-13	1966-04-13 00:00:00	1966-04-13	38000177		0	0	14		0	0	0	136152	0	243670	19059056		
58977	4899	40162522	1976-10-22	1976-10-22 00:00:00	1976-10-22	1976-10-22 00:00:00	\N	38000177		0	0	0		0	0	0	325851	0	857005	40162522		
13525	1133	19059056	1973-10-25	1973-10-25 00:00:00	1973-12-24	1973-12-24 00:00:00	1973-12-24	38000177		0	0	60		0	0	0	74584	0	243670	19059056		
31475	2609	40236446	1967-04-30	1967-04-30 00:00:00	1976-05-07	1976-05-07 00:00:00	1976-05-07	38000177		0	0	3295		0	0	0	172497	0	1091392	40236446		
188681	4143	40213260	2012-10-05	2012-10-05 00:00:00	2012-10-05	2012-10-05 00:00:00	2012-10-05	581452		0	0	0		0	0	0	275390	0	121	40213260		
24114	1982	1127433	1957-05-18	1957-05-18 00:00:00	1957-07-24	1957-07-24 00:00:00	1957-07-24	38000177		0	0	67		0	0	0	131972	0	313782	1127433		
12741	1073	1127433	1983-05-07	1983-05-07 00:00:00	1983-05-21	1983-05-21 00:00:00	1983-05-21	38000177		0	0	14		0	0	0	70409	0	313782	1127433		
46148	3823	1127433	1976-01-21	1976-01-21 00:00:00	1976-04-20	1976-04-20 00:00:00	1976-04-20	38000177		0	0	90		0	0	0	253973	0	313782	1127433		
46272	3833	1713671	2001-10-18	2001-10-18 00:00:00	2001-11-08	2001-11-08 00:00:00	2001-11-08	38000177		0	0	21		0	0	0	254486	0	562251	1713671		
55499	4608	1713671	1977-07-13	1977-07-13 00:00:00	1977-07-27	1977-07-27 00:00:00	1977-07-27	38000177		0	0	14		0	0	0	307073	0	562251	1713671		
145356	3196	40213160	1970-12-15	1970-12-15 00:00:00	1970-12-15	1970-12-15 00:00:00	1970-12-15	581452		0	0	0		0	0	0	212651	0	10	40213160		
45865	1000	40213227	2006-01-10	2006-01-10 00:00:00	2006-01-10	2006-01-10 00:00:00	2006-01-10	581452		0	0	0		0	0	0	66185	0	113	40213227		
98824	2164	40213227	2004-02-27	2004-02-27 00:00:00	2004-02-27	2004-02-27 00:00:00	2004-02-27	581452		0	0	0		0	0	0	144168	0	113	40213227		
52536	1149	40213251	1984-01-10	1984-01-10 00:00:00	1984-01-10	1984-01-10 00:00:00	1984-01-10	581452		0	0	0		0	0	0	75967	0	21	40213251		
25215	2076	1127078	1970-11-08	1970-11-08 00:00:00	1970-11-29	1970-11-29 00:00:00	1970-11-29	38000177		0	0	21		0	0	0	138208	0	282464	1127078		
55976	4646	19059056	1946-09-16	1946-09-16 00:00:00	1946-09-30	1946-09-30 00:00:00	1946-09-30	38000177		0	0	14		0	0	0	309737	0	243670	19059056		
22662	1860	1310034	1991-12-23	1991-12-23 00:00:00	1991-12-23	1991-12-23 00:00:00	1991-12-23	38000177		0	0	0		0	0	0	124407	0	834357	1310034		
74535	1627	40213160	1955-04-09	1955-04-09 00:00:00	1955-04-09	1955-04-09 00:00:00	1955-04-09	581452		0	0	0		0	0	0	109309	0	10	40213160		
56090	4656	19129655	1963-05-15	1963-05-15 00:00:00	1963-05-29	1963-05-29 00:00:00	1963-05-29	38000177		0	0	14		0	0	0	310484	0	789980	19129655		
161814	3560	40213260	2010-05-05	2010-05-05 00:00:00	2010-05-05	2010-05-05 00:00:00	2010-05-05	581452		0	0	0		0	0	0	236378	0	121	40213260		
47467	1036	40213160	1969-12-12	1969-12-12 00:00:00	1969-12-12	1969-12-12 00:00:00	1969-12-12	581452		0	0	0		0	0	0	68191	0	10	40213160		
16983	1407	19128065	1987-10-07	1987-10-07 00:00:00	1988-10-01	1988-10-01 00:00:00	1988-10-01	38000177		0	0	360		0	0	0	93488	0	749882	19128065		
75506	1649	40213227	1998-11-11	1998-11-11 00:00:00	1998-11-11	1998-11-11 00:00:00	1998-11-11	581452		0	0	0		0	0	0	110668	0	113	40213227		
21043	1736	920300	1989-10-20	1989-10-20 00:00:00	1989-10-27	1989-10-27 00:00:00	1989-10-27	38000177		0	0	7		0	0	0	115899	0	311989	920300		
21071	1737	19133873	1918-08-19	1918-08-19 00:00:00	1918-08-27	1918-08-27 00:00:00	1918-08-27	38000177		0	0	8		0	0	0	116036	0	834061	19133873		
31594	2619	1127433	1964-04-18	1964-04-18 00:00:00	1964-05-02	1964-05-02 00:00:00	1964-05-02	38000177		0	0	14		0	0	0	173141	0	313782	1127433		
54491	4529	19133873	1970-03-26	1970-03-26 00:00:00	1970-04-05	1970-04-05 00:00:00	1970-04-05	38000177		0	0	10		0	0	0	301547	0	834061	19133873		
78803	1724	40213198	2015-02-02	2015-02-02 00:00:00	2015-02-02	2015-02-02 00:00:00	2015-02-02	581452		0	0	0		0	0	0	115318	0	133	40213198		
19780	1626	19059056	1967-08-30	1967-08-30 00:00:00	1967-09-13	1967-09-13 00:00:00	1967-09-13	38000177		0	0	14		0	0	0	109187	0	243670	19059056		
38291	3168	1115171	2003-02-17	2003-02-17 00:00:00	2003-03-17	2003-03-17 00:00:00	2003-03-17	38000177		0	0	28		0	0	0	210649	0	849574	1115171		
74855	1634	40213227	2000-03-10	2000-03-10 00:00:00	2000-03-10	2000-03-10 00:00:00	2000-03-10	581452		0	0	0		0	0	0	109762	0	113	40213227		
227633	4998	40213160	1965-03-19	1965-03-19 00:00:00	1965-03-19	1965-03-19 00:00:00	1965-03-19	581452		0	0	0		0	0	0	332359	0	10	40213160		
37299	3082	40243436	1988-05-04	1988-05-04 00:00:00	1988-05-04	1988-05-04 00:00:00	1988-05-04	38000177		0	0	0		0	0	0	205228	0	1190795	40243436		
33098	2745	19133873	1972-06-17	1972-06-17 00:00:00	1972-06-30	1972-06-30 00:00:00	1972-06-30	38000177		0	0	13		0	0	0	181597	0	834061	19133873		
51214	4255	1127433	1988-04-11	1988-04-11 00:00:00	1988-04-25	1988-04-25 00:00:00	1988-04-25	38000177		0	0	14		0	0	0	282527	0	313782	1127433		
121200	2663	40213306	1986-01-12	1986-01-12 00:00:00	1986-01-12	1986-01-12 00:00:00	1986-01-12	581452		0	0	0		0	0	0	176509	0	43	40213306		
43462	948	40213227	2009-09-25	2009-09-25 00:00:00	2009-09-25	2009-09-25 00:00:00	2009-09-25	581452		0	0	0		0	0	0	62980	0	113	40213227		
23766	1954	1127433	1952-12-01	1952-12-01 00:00:00	1952-12-15	1952-12-15 00:00:00	1952-12-15	38000177		0	0	14		0	0	0	130034	0	313782	1127433		
189788	4167	40213306	2002-08-21	2002-08-21 00:00:00	2002-08-21	2002-08-21 00:00:00	2002-08-21	581452		0	0	0		0	0	0	276913	0	43	40213306		
132675	2914	40213160	1960-09-10	1960-09-10 00:00:00	1960-09-10	1960-09-10 00:00:00	1960-09-10	581452		0	0	0		0	0	0	194197	0	10	40213160		
16610	1377	19073183	1982-11-18	1982-11-18 00:00:00	1982-12-02	1982-12-02 00:00:00	1982-12-02	38000177		0	0	14		0	0	0	91271	0	308182	19073183		
34390	2842	1127433	1973-01-10	1973-01-10 00:00:00	1973-01-17	1973-01-17 00:00:00	1973-01-17	38000177		0	0	7		0	0	0	188644	0	313782	1127433		
34434	2845	1713671	1973-07-13	1973-07-13 00:00:00	1973-07-20	1973-07-20 00:00:00	1973-07-20	38000177		0	0	7		0	0	0	188910	0	562251	1713671		
45188	3739	19128065	1984-08-02	1984-08-02 00:00:00	1985-07-28	1985-07-28 00:00:00	1985-07-28	38000177		0	0	360		0	0	0	248447	0	749882	19128065		
10068	843	19074843	1984-11-03	1984-11-03 00:00:00	1984-11-17	1984-11-17 00:00:00	1984-11-17	38000177		0	0	14		0	0	0	55814	0	309045	19074843		
9955	834	19059056	1967-09-15	1967-09-15 00:00:00	1967-10-20	1967-10-20 00:00:00	1967-10-20	38000177		0	0	35		0	0	0	55249	0	243670	19059056		
17703	1467	1127433	1998-04-16	1998-04-16 00:00:00	1998-04-30	1998-04-30 00:00:00	1998-04-30	38000177		0	0	14		0	0	0	97719	0	313782	1127433		
55834	4634	19006318	1963-07-06	1963-07-06 00:00:00	1963-07-20	1963-07-20 00:00:00	1963-07-20	38000177		0	0	14		0	0	0	308833	0	105078	19006318		
55884	4639	19128022	1991-01-11	1991-01-11 00:00:00	1992-01-06	1992-01-06 00:00:00	1992-01-06	38000177		0	0	360		0	0	0	309197	0	749785	19128022		
35102	2897	1713671	2013-06-23	2013-06-23 00:00:00	2013-06-30	2013-06-30 00:00:00	2013-06-30	38000177		0	0	7		0	0	0	192890	0	562251	1713671		
21433	1761	19059056	1972-10-14	1972-10-14 00:00:00	1972-10-28	1972-10-28 00:00:00	1972-10-28	38000177		0	0	14		0	0	0	117719	0	243670	19059056		
63628	5285	19059056	1943-06-04	1943-06-04 00:00:00	1943-06-18	1943-06-18 00:00:00	1943-06-18	38000177		0	0	14		0	0	0	351704	0	243670	19059056		
48535	4020	19059056	1968-02-18	1968-02-18 00:00:00	1968-03-03	1968-03-03 00:00:00	1968-03-03	38000177		0	0	14		0	0	0	267235	0	243670	19059056		
82761	1809	40213227	2013-12-18	2013-12-18 00:00:00	2013-12-18	2013-12-18 00:00:00	2013-12-18	581452		0	0	0		0	0	0	121128	0	113	40213227		
45809	3791	19059056	1915-08-24	1915-08-24 00:00:00	1915-09-07	1915-09-07 00:00:00	1915-09-07	38000177		0	0	14		0	0	0	252111	0	243670	19059056		
38137	3157	19059056	1966-09-17	1966-09-17 00:00:00	1966-10-15	1966-10-15 00:00:00	1966-10-15	38000177		0	0	28		0	0	0	209879	0	243670	19059056		
32168	2666	40229134	1955-07-25	1955-07-25 00:00:00	1955-08-01	1955-08-01 00:00:00	1955-08-01	38000177		0	0	7		0	0	0	176603	0	1043400	40229134		
41553	906	40213296	2014-03-11	2014-03-11 00:00:00	2014-03-11	2014-03-11 00:00:00	2014-03-11	581452		0	0	0		0	0	0	60270	0	52	40213296		
88239	1935	40213160	1964-05-12	1964-05-12 00:00:00	1964-05-12	1964-05-12 00:00:00	1964-05-12	581452		0	0	0		0	0	0	128700	0	10	40213160		
193618	4253	40213306	2003-02-24	2003-02-24 00:00:00	2003-02-24	2003-02-24 00:00:00	2003-02-24	581452		0	0	0		0	0	0	282433	0	43	40213306		
50141	4160	1127433	2017-01-27	2017-01-27 00:00:00	2017-02-03	2017-02-03 00:00:00	2017-02-03	38000177		0	0	7		0	0	0	276476	0	313782	1127433		
2872	232	1127433	1977-04-14	1977-04-14 00:00:00	1977-04-28	1977-04-28 00:00:00	1977-04-28	38000177		0	0	14		0	0	0	15635	0	313782	1127433		
59339	4932	19008572	1976-11-22	1976-11-22 00:00:00	1976-11-22	1976-11-22 00:00:00	\N	38000177		0	0	0		0	0	0	327866	0	106258	19008572		
53102	1162	40213201	1986-02-01	1986-02-01 00:00:00	1986-02-01	1986-02-01 00:00:00	1986-02-01	581452		0	0	0		0	0	0	76776	0	33	40213201		
24882	2046	19126352	2004-02-24	2004-02-24 00:00:00	2014-04-01	2014-04-01 00:00:00	2014-04-01	38000177		0	0	3689		0	0	0	136128	0	705129	19126352		
58978	4899	19059056	1972-10-10	1972-10-10 00:00:00	1972-11-14	1972-11-14 00:00:00	1972-11-14	38000177		0	0	35		0	0	0	325815	0	243670	19059056		
13526	1133	40229134	2005-10-16	2005-10-16 00:00:00	2005-10-30	2005-10-30 00:00:00	2005-10-30	38000177		0	0	14		0	0	0	74576	0	1043400	40229134		
31476	2610	1127078	1960-05-21	1960-05-21 00:00:00	1960-06-04	1960-06-04 00:00:00	1960-06-04	38000177		0	0	14		0	0	0	172592	0	282464	1127078		
188683	4143	40213227	2012-10-05	2012-10-05 00:00:00	2012-10-05	2012-10-05 00:00:00	2012-10-05	581452		0	0	0		0	0	0	275390	0	113	40213227		
24115	1982	1545959	2006-10-19	2006-10-19 00:00:00	2006-10-19	2006-10-19 00:00:00	2006-10-19	38000177		0	0	0		0	0	0	131963	0	259255	1545959		
12742	1073	1127433	2010-08-20	2010-08-20 00:00:00	2010-09-19	2010-09-19 00:00:00	2010-09-19	38000177		0	0	30		0	0	0	70304	0	313782	1127433		
56607	4696	1127433	2017-12-20	2017-12-20 00:00:00	2018-01-03	2018-01-03 00:00:00	2018-01-03	38000177		0	0	14		0	0	0	312826	0	313782	1127433		
44669	972	40213296	2008-06-11	2008-06-11 00:00:00	2008-06-11	2008-06-11 00:00:00	2008-06-11	581452		0	0	0		0	0	0	64730	0	52	40213296		
55500	4608	19059056	1987-10-08	1987-10-08 00:00:00	1987-11-14	1987-11-14 00:00:00	1987-11-14	38000177		0	0	37		0	0	0	307066	0	243670	19059056		
145361	3196	40213160	1970-07-14	1970-07-14 00:00:00	1970-07-14	1970-07-14 00:00:00	1970-07-14	581452		0	0	0		0	0	0	212650	0	10	40213160		
21647	470	40213160	1959-12-22	1959-12-22 00:00:00	1959-12-22	1959-12-22 00:00:00	1959-12-22	581452		0	0	0		0	0	0	31452	0	10	40213160		
98828	2164	40213160	1973-01-05	1973-01-05 00:00:00	1973-01-05	1973-01-05 00:00:00	1973-01-05	581452		0	0	0		0	0	0	144162	0	10	40213160		
52538	1149	40213160	1979-05-08	1979-05-08 00:00:00	1979-05-08	1979-05-08 00:00:00	1979-05-08	581452		0	0	0		0	0	0	75984	0	10	40213160		
25216	2076	1127433	1988-03-17	1988-03-17 00:00:00	1988-03-31	1988-03-31 00:00:00	1988-03-31	38000177		0	0	14		0	0	0	138200	0	313782	1127433		
55977	4646	1127433	2010-04-22	2010-04-22 00:00:00	2010-05-06	2010-05-06 00:00:00	2010-05-06	38000177		0	0	14		0	0	0	309827	0	313782	1127433		
22663	1860	1713671	1995-12-20	1995-12-20 00:00:00	1996-01-10	1996-01-10 00:00:00	1996-01-10	38000177		0	0	21		0	0	0	124362	0	562251	1713671		
74540	1627	40213227	2014-01-04	2014-01-04 00:00:00	2014-01-04	2014-01-04 00:00:00	2014-01-04	581452		0	0	0		0	0	0	109295	0	113	40213227		
56091	4656	40173590	2009-11-08	2009-11-08 00:00:00	2009-11-08	2009-11-08 00:00:00	\N	38000177		0	0	0		0	0	0	310440	0	904419	40173590		
10363	866	19006318	1962-10-23	1962-10-23 00:00:00	1962-11-06	1962-11-06 00:00:00	1962-11-06	38000177		0	0	14		0	0	0	57468	0	105078	19006318		
47469	1036	40213306	1991-11-08	1991-11-08 00:00:00	1991-11-08	1991-11-08 00:00:00	1991-11-08	581452		0	0	0		0	0	0	68098	0	43	40213306		
16984	1407	1127433	1986-06-28	1986-06-28 00:00:00	1986-07-19	1986-07-19 00:00:00	1986-07-19	38000177		0	0	21		0	0	0	93564	0	313782	1127433		
75515	1649	40213160	1956-08-15	1956-08-15 00:00:00	1956-08-15	1956-08-15 00:00:00	1956-08-15	581452		0	0	0		0	0	0	110660	0	10	40213160		
21044	1736	19128065	1986-04-19	1986-04-19 00:00:00	1987-04-14	1987-04-14 00:00:00	1987-04-14	38000177		0	0	360		0	0	0	115894	0	749882	19128065		
21072	1737	1539411	1991-08-30	1991-08-30 00:00:00	1991-08-30	1991-08-30 00:00:00	\N	38000177		0	0	0		0	0	0	116070	0	312961	1539411		
31595	2620	1127433	1989-08-18	1989-08-18 00:00:00	1989-09-22	1989-09-22 00:00:00	1989-09-22	38000177		0	0	35		0	0	0	173273	0	313782	1127433		
54492	4529	19059056	1985-04-25	1985-04-25 00:00:00	1985-05-09	1985-05-09 00:00:00	1985-05-09	38000177		0	0	14		0	0	0	301560	0	243670	19059056		
78810	1724	40213201	2016-07-18	2016-07-18 00:00:00	2016-07-18	2016-07-18 00:00:00	2016-07-18	581452		0	0	0		0	0	0	115273	0	33	40213201		
19781	1626	1713671	1984-06-20	1984-06-20 00:00:00	1984-07-04	1984-07-04 00:00:00	1984-07-04	38000177		0	0	14		0	0	0	109212	0	562251	1713671		
38292	3168	1118084	2015-09-27	2015-09-27 00:00:00	2015-09-27	2015-09-27 00:00:00	\N	38000177		0	0	0		0	0	0	210642	0	00025152531	44923712		
74870	1634	40213227	1992-01-24	1992-01-24 00:00:00	1992-01-24	1992-01-24 00:00:00	1992-01-24	581452		0	0	0		0	0	0	109795	0	113	40213227		
227639	4998	40213227	1998-07-17	1998-07-17 00:00:00	1998-07-17	1998-07-17 00:00:00	1998-07-17	581452		0	0	0		0	0	0	332350	0	113	40213227		
37300	3082	46275916	1988-05-04	1988-05-04 00:00:00	1988-05-04	1988-05-04 00:00:00	1988-05-04	38000177		0	0	0		0	0	0	205228	0	1660014	46275916		
33099	2745	1127433	2003-12-28	2003-12-28 00:00:00	2004-01-18	2004-01-18 00:00:00	2004-01-18	38000177		0	0	21		0	0	0	181576	0	313782	1127433		
51215	4255	1713671	1997-08-06	1997-08-06 00:00:00	1997-08-20	1997-08-20 00:00:00	1997-08-20	38000177		0	0	14		0	0	0	282516	0	562251	1713671		
121207	2663	40213160	1968-06-30	1968-06-30 00:00:00	1968-06-30	1968-06-30 00:00:00	1968-06-30	581452		0	0	0		0	0	0	176493	0	10	40213160		
43463	948	40213260	2009-09-25	2009-09-25 00:00:00	2009-09-25	2009-09-25 00:00:00	2009-09-25	581452		0	0	0		0	0	0	62980	0	121	40213260		
23767	1954	40223768	1998-12-24	1998-12-24 00:00:00	1998-12-24	1998-12-24 00:00:00	\N	38000177		0	0	0		0	0	0	129989	0	997223	40223768		
189794	4167	40213160	1979-02-28	1979-02-28 00:00:00	1979-02-28	1979-02-28 00:00:00	1979-02-28	581452		0	0	0		0	0	0	276990	0	10	40213160		
132678	2914	40213160	1956-03-10	1956-03-10 00:00:00	1956-03-10	1956-03-10 00:00:00	1956-03-10	581452		0	0	0		0	0	0	194223	0	10	40213160		
16611	1377	19128022	1993-11-30	1993-11-30 00:00:00	1994-11-25	1994-11-25 00:00:00	1994-11-25	38000177		0	0	360		0	0	0	91255	0	749785	19128022		
34391	2842	1127078	1964-08-24	1964-08-24 00:00:00	1964-11-22	1964-11-22 00:00:00	1964-11-22	38000177		0	0	90		0	0	0	188647	0	282464	1127078		
34435	2845	40236824	2009-10-28	2009-10-28 00:00:00	2009-11-04	2009-11-04 00:00:00	2009-11-04	38000177		0	0	7		0	0	0	188960	0	1094107	40236824		
45189	3739	19128065	1986-07-23	1986-07-23 00:00:00	1987-07-18	1987-07-18 00:00:00	1987-07-18	38000177		0	0	360		0	0	0	248453	0	749882	19128065		
10069	843	1118084	2017-09-04	2017-09-04 00:00:00	2017-09-04	2017-09-04 00:00:00	\N	38000177		0	0	0		0	0	0	55866	0	00025152531	44923712		
9956	834	1127433	1971-06-01	1971-06-01 00:00:00	1971-07-06	1971-07-06 00:00:00	1971-07-06	38000177		0	0	35		0	0	0	55250	0	313782	1127433		
17704	1467	40165015	2011-07-19	2011-07-19 00:00:00	2011-07-19	2011-07-19 00:00:00	\N	38000177		0	0	0		0	0	0	97700	0	861467	40165015		
55835	4634	1127078	1963-07-06	1963-07-06 00:00:00	1963-07-20	1963-07-20 00:00:00	1963-07-20	38000177		0	0	14		0	0	0	308833	0	282464	1127078		
55885	4639	1118084	2004-07-01	2004-07-01 00:00:00	2004-07-01	2004-07-01 00:00:00	\N	38000177		0	0	0		0	0	0	309210	0	00025152531	44923712		
35103	2897	19059056	1965-11-24	1965-11-24 00:00:00	1965-12-08	1965-12-08 00:00:00	1965-12-08	38000177		0	0	14		0	0	0	192951	0	243670	19059056		
21434	1762	1115171	2012-05-16	2012-05-16 00:00:00	2012-05-30	2012-05-30 00:00:00	2012-05-30	38000177		0	0	14		0	0	0	117865	0	849574	1115171		
63629	5285	1127433	2009-09-03	2009-09-03 00:00:00	2009-09-10	2009-09-10 00:00:00	2009-09-10	38000177		0	0	7		0	0	0	351663	0	313782	1127433		
48536	4020	1127433	1972-09-08	1972-09-08 00:00:00	1972-09-22	1972-09-22 00:00:00	1972-09-22	38000177		0	0	14		0	0	0	267236	0	313782	1127433		
82763	1809	40213260	2013-12-18	2013-12-18 00:00:00	2013-12-18	2013-12-18 00:00:00	2013-12-18	581452		0	0	0		0	0	0	121128	0	121	40213260		
45810	3791	1115171	2012-04-08	2012-04-08 00:00:00	2012-06-07	2012-06-07 00:00:00	2012-06-07	38000177		0	0	60		0	0	0	252162	0	849574	1115171		
38138	3157	19006318	1957-10-29	1957-10-29 00:00:00	1957-11-12	1957-11-12 00:00:00	1957-11-12	38000177		0	0	14		0	0	0	209867	0	105078	19006318		
32169	2666	19059056	1955-12-19	1955-12-19 00:00:00	1956-01-09	1956-01-09 00:00:00	1956-01-09	38000177		0	0	21		0	0	0	176681	0	243670	19059056		
41555	906	40213227	2014-03-11	2014-03-11 00:00:00	2014-03-11	2014-03-11 00:00:00	2014-03-11	581452		0	0	0		0	0	0	60270	0	113	40213227		
88244	1936	40213201	2013-05-24	2013-05-24 00:00:00	2013-05-24	2013-05-24 00:00:00	2013-05-24	581452		0	0	0		0	0	0	128792	0	33	40213201		
193620	4253	40213227	2003-02-24	2003-02-24 00:00:00	2003-02-24	2003-02-24 00:00:00	2003-02-24	581452		0	0	0		0	0	0	282433	0	113	40213227		
50143	4160	920300	1993-09-11	1993-09-11 00:00:00	1993-09-18	1993-09-18 00:00:00	1993-09-18	38000177		0	0	7		0	0	0	276416	0	311989	920300		
2873	232	19059056	1959-02-05	1959-02-05 00:00:00	1959-04-13	1959-04-13 00:00:00	1959-04-13	38000177		0	0	67		0	0	0	15614	0	243670	19059056		
59340	4932	1118084	1996-02-23	1996-02-23 00:00:00	1996-02-23	1996-02-23 00:00:00	\N	38000177		0	0	0		0	0	0	327920	0	00025152531	44923712		
53105	1162	40213227	1992-01-04	1992-01-04 00:00:00	1992-01-04	1992-01-04 00:00:00	1992-01-04	581452		0	0	0		0	0	0	76680	0	113	40213227		
24883	2046	19075601	2004-02-24	2004-02-24 00:00:00	2014-04-01	2014-04-01 00:00:00	2014-04-01	38000177		0	0	3689		0	0	0	136128	0	309362	19075601		
58979	4899	19059056	1922-10-19	1922-10-19 00:00:00	1922-11-02	1922-11-02 00:00:00	1922-11-02	38000177		0	0	14		0	0	0	325806	0	243670	19059056		
13529	1133	40236824	2012-08-06	2012-08-06 00:00:00	2012-08-13	2012-08-13 00:00:00	2012-08-13	38000177		0	0	7		0	0	0	74599	0	1094107	40236824		
31477	2610	19059056	1973-04-26	1973-04-26 00:00:00	1973-06-26	1973-06-26 00:00:00	1973-06-26	38000177		0	0	61		0	0	0	172595	0	243670	19059056		
188685	4143	40213160	1962-06-08	1962-06-08 00:00:00	1962-06-08	1962-06-08 00:00:00	1962-06-08	581452		0	0	0		0	0	0	275385	0	10	40213160		
24116	1982	19133768	2006-10-19	2006-10-19 00:00:00	2006-10-19	2006-10-19 00:00:00	2006-10-19	38000177		0	0	0		0	0	0	131963	0	833036	19133768		
12743	1073	1713671	1995-12-21	1995-12-21 00:00:00	1996-01-11	1996-01-11 00:00:00	1996-01-11	38000177		0	0	21		0	0	0	70313	0	562251	1713671		
56608	4696	19078461	2017-06-30	2017-06-30 00:00:00	2017-07-14	2017-07-14 00:00:00	2017-07-14	38000177		0	0	14		0	0	0	312836	0	310965	19078461		
44671	972	40213227	2008-06-11	2008-06-11 00:00:00	2008-06-11	2008-06-11 00:00:00	2008-06-11	581452		0	0	0		0	0	0	64730	0	113	40213227		
55501	4608	1127433	1956-04-11	1956-04-11 00:00:00	1956-04-25	1956-04-25 00:00:00	1956-04-25	38000177		0	0	14		0	0	0	307072	0	313782	1127433		
145369	3196	40213160	1975-03-18	1975-03-18 00:00:00	1975-03-18	1975-03-18 00:00:00	1975-03-18	581452		0	0	0		0	0	0	212642	0	10	40213160		
21654	470	40213160	1955-09-20	1955-09-20 00:00:00	1955-09-20	1955-09-20 00:00:00	1955-09-20	581452		0	0	0		0	0	0	31424	0	10	40213160		
98833	2164	40213296	2014-10-10	2014-10-10 00:00:00	2014-10-10	2014-10-10 00:00:00	2014-10-10	581452		0	0	0		0	0	0	144171	0	52	40213296		
52539	1149	40213314	1979-05-08	1979-05-08 00:00:00	1979-05-08	1979-05-08 00:00:00	1979-05-08	581452		0	0	0		0	0	0	75984	0	49	40213314		
25217	2076	1127433	2005-07-10	2005-07-10 00:00:00	2005-07-24	2005-07-24 00:00:00	2005-07-24	38000177		0	0	14		0	0	0	138145	0	313782	1127433		
55978	4646	40163554	2001-10-02	2001-10-02 00:00:00	2001-10-02	2001-10-02 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	855332	40163554		
22664	1860	19133768	1985-11-11	1985-11-11 00:00:00	1985-11-11	1985-11-11 00:00:00	1985-11-11	38000177		0	0	0		0	0	0	124404	0	833036	19133768		
74542	1627	40213227	2003-11-08	2003-11-08 00:00:00	2003-11-08	2003-11-08 00:00:00	2003-11-08	581452		0	0	0		0	0	0	109283	0	113	40213227		
56092	4656	19075601	1997-10-05	1997-10-05 00:00:00	2008-06-29	2008-06-29 00:00:00	2008-06-29	38000177		0	0	3920		0	0	0	310466	0	309362	19075601		
10364	866	1127433	2007-03-22	2007-03-22 00:00:00	2007-04-05	2007-04-05 00:00:00	2007-04-05	38000177		0	0	14		0	0	0	57488	0	313782	1127433		
216971	4760	40213160	1955-07-06	1955-07-06 00:00:00	1955-07-06	1955-07-06 00:00:00	1955-07-06	581452		0	0	0		0	0	0	317149	0	10	40213160		
16985	1407	19059056	1968-10-06	1968-10-06 00:00:00	1968-11-10	1968-11-10 00:00:00	1968-11-10	38000177		0	0	35		0	0	0	93560	0	243670	19059056		
75525	1649	40213296	1996-11-06	1996-11-06 00:00:00	1996-11-06	1996-11-06 00:00:00	1996-11-06	581452		0	0	0		0	0	0	110646	0	52	40213296		
21045	1736	40236824	1990-12-03	1990-12-03 00:00:00	1990-12-10	1990-12-10 00:00:00	1990-12-10	38000177		0	0	7		0	0	0	115889	0	1094107	40236824		
21073	1737	1332419	1994-04-08	1994-04-08 00:00:00	1994-04-08	1994-04-08 00:00:00	\N	38000177		0	0	0		0	0	0	116094	0	197361	1332419		
31596	2620	19078461	1979-09-19	1979-09-19 00:00:00	1979-11-18	1979-11-18 00:00:00	1979-11-18	38000177		0	0	60		0	0	0	173271	0	310965	19078461		
54493	4529	1127433	2016-10-30	2016-10-30 00:00:00	2016-12-04	2016-12-04 00:00:00	2016-12-04	38000177		0	0	35		0	0	0	301616	0	313782	1127433		
59049	1292	40213227	1992-08-25	1992-08-25 00:00:00	1992-08-25	1992-08-25 00:00:00	1992-08-25	581452		0	0	0		0	0	0	85374	0	113	40213227		
19782	1627	19059056	1981-09-26	1981-09-26 00:00:00	1981-10-26	1981-10-26 00:00:00	1981-10-26	38000177		0	0	30		0	0	0	109350	0	243670	19059056		
38299	3170	1127433	1987-10-01	1987-10-01 00:00:00	1987-10-15	1987-10-15 00:00:00	1987-10-15	38000177		0	0	14		0	0	0	210745	0	313782	1127433		
74878	1634	40213201	2005-03-25	2005-03-25 00:00:00	2005-03-25	2005-03-25 00:00:00	2005-03-25	581452		0	0	0		0	0	0	109764	0	33	40213201		
227644	4999	40213227	2007-11-25	2007-11-25 00:00:00	2007-11-25	2007-11-25 00:00:00	2007-11-25	581452		0	0	0		0	0	0	332471	0	113	40213227		
37301	3082	19128022	1994-05-21	1994-05-21 00:00:00	1995-05-16	1995-05-16 00:00:00	1995-05-16	38000177		0	0	360		0	0	0	205251	0	749785	19128022		
33100	2745	40229134	1995-06-24	1995-06-24 00:00:00	1995-07-01	1995-07-01 00:00:00	1995-07-01	38000177		0	0	7		0	0	0	181587	0	1043400	40229134		
51216	4255	1127433	1989-12-26	1989-12-26 00:00:00	1990-01-09	1990-01-09 00:00:00	1990-01-09	38000177		0	0	14		0	0	0	282514	0	313782	1127433		
121216	2663	40213160	1964-02-09	1964-02-09 00:00:00	1964-02-09	1964-02-09 00:00:00	1964-02-09	581452		0	0	0		0	0	0	176448	0	10	40213160		
43478	948	40213160	1959-05-29	1959-05-29 00:00:00	1959-05-29	1959-05-29 00:00:00	1959-05-29	581452		0	0	0		0	0	0	62924	0	10	40213160		
23768	1954	40223774	1999-11-19	1999-11-19 00:00:00	1999-11-19	1999-11-19 00:00:00	\N	38000177		0	0	0		0	0	0	130000	0	998582	40223774		
189795	4167	40213314	1979-02-28	1979-02-28 00:00:00	1979-02-28	1979-02-28 00:00:00	1979-02-28	581452		0	0	0		0	0	0	276990	0	49	40213314		
132701	2914	40213227	2006-10-07	2006-10-07 00:00:00	2006-10-07	2006-10-07 00:00:00	2006-10-07	581452		0	0	0		0	0	0	194163	0	113	40213227		
16612	1377	1127433	2008-12-02	2008-12-02 00:00:00	2008-12-09	2008-12-09 00:00:00	2008-12-09	38000177		0	0	7		0	0	0	91253	0	313782	1127433		
34392	2842	1127433	2017-02-12	2017-02-12 00:00:00	2017-02-26	2017-02-26 00:00:00	2017-02-26	38000177		0	0	14		0	0	0	188667	0	313782	1127433		
34436	2845	920300	2009-10-28	2009-10-28 00:00:00	2009-11-04	2009-11-04 00:00:00	2009-11-04	38000177		0	0	7		0	0	0	188960	0	311989	920300		
45190	3739	19133905	2014-12-15	2014-12-15 00:00:00	2014-12-27	2014-12-27 00:00:00	2014-12-27	38000177		0	0	12		0	0	0	248423	0	834102	19133905		
10070	843	19133873	1996-02-15	1996-02-15 00:00:00	1996-02-28	1996-02-28 00:00:00	1996-02-28	38000177		0	0	13		0	0	0	55870	0	834061	19133873		
60508	1322	40213227	2004-08-18	2004-08-18 00:00:00	2004-08-18	2004-08-18 00:00:00	2004-08-18	581452		0	0	0		0	0	0	87705	0	113	40213227		
17705	1467	1118084	1967-10-09	1967-10-09 00:00:00	1967-10-09	1967-10-09 00:00:00	\N	38000177		0	0	0		0	0	0	97709	0	00025152531	44923712		
55836	4634	19059056	1964-09-11	1964-09-11 00:00:00	1964-09-25	1964-09-25 00:00:00	1964-09-25	38000177		0	0	14		0	0	0	308839	0	243670	19059056		
55886	4639	19059056	1986-03-26	1986-03-26 00:00:00	1986-04-25	1986-04-25 00:00:00	1986-04-25	38000177		0	0	30		0	0	0	309191	0	243670	19059056		
35104	2897	19006318	1965-11-24	1965-11-24 00:00:00	1965-12-08	1965-12-08 00:00:00	1965-12-08	38000177		0	0	14		0	0	0	192951	0	105078	19006318		
21435	1762	1127433	1982-01-25	1982-01-25 00:00:00	1982-02-08	1982-02-08 00:00:00	1982-02-08	38000177		0	0	14		0	0	0	117802	0	313782	1127433		
63630	5285	1713671	2014-10-31	2014-10-31 00:00:00	2014-11-21	2014-11-21 00:00:00	2014-11-21	38000177		0	0	21		0	0	0	351636	0	562251	1713671		
48537	4020	40231925	1972-09-08	1972-09-08 00:00:00	1972-09-08	1972-09-08 00:00:00	\N	38000177		0	0	0		0	0	0	267236	0	1049221	40231925		
82764	1809	40213306	1985-02-13	1985-02-13 00:00:00	1985-02-13	1985-02-13 00:00:00	1985-02-13	581452		0	0	0		0	0	0	121115	0	43	40213306		
45811	3791	1127433	1953-09-17	1953-09-17 00:00:00	1953-10-01	1953-10-01 00:00:00	1953-10-01	38000177		0	0	14		0	0	0	252051	0	313782	1127433		
59119	4913	1127433	1979-05-24	1979-05-24 00:00:00	1979-05-31	1979-05-31 00:00:00	1979-05-31	38000177		0	0	7		0	0	0	326521	0	313782	1127433		
32171	2666	19059056	1953-01-05	1953-01-05 00:00:00	1953-02-02	1953-02-02 00:00:00	1953-02-02	38000177		0	0	28		0	0	0	176680	0	243670	19059056		
41558	906	40213160	1972-11-07	1972-11-07 00:00:00	1972-11-07	1972-11-07 00:00:00	1972-11-07	581452		0	0	0		0	0	0	60256	0	10	40213160		
150677	3314	40213160	1963-05-18	1963-05-18 00:00:00	1963-05-18	1963-05-18 00:00:00	1963-05-18	581452		0	0	0		0	0	0	220071	0	10	40213160		
193622	4253	40213227	2013-10-08	2013-10-08 00:00:00	2013-10-08	2013-10-08 00:00:00	2013-10-08	581452		0	0	0		0	0	0	282437	0	113	40213227		
50144	4160	40236824	1993-09-11	1993-09-11 00:00:00	1993-09-18	1993-09-18 00:00:00	1993-09-18	38000177		0	0	7		0	0	0	276416	0	1094107	40236824		
2874	232	19133873	1945-10-29	1945-10-29 00:00:00	1945-11-10	1945-11-10 00:00:00	1945-11-10	38000177		0	0	12		0	0	0	15538	0	834061	19133873		
59341	4932	1127433	1964-12-08	1964-12-08 00:00:00	1964-12-22	1964-12-22 00:00:00	1964-12-22	38000177		0	0	14		0	0	0	327865	0	313782	1127433		
53115	1162	40213227	2001-02-24	2001-02-24 00:00:00	2001-02-24	2001-02-24 00:00:00	2001-02-24	581452		0	0	0		0	0	0	76681	0	113	40213227		
24884	2046	1539411	2004-02-24	2004-02-24 00:00:00	2004-02-24	2004-02-24 00:00:00	\N	38000177		0	0	0		0	0	0	136128	0	312961	1539411		
58980	4899	19059056	1973-09-10	1973-09-10 00:00:00	1973-10-01	1973-10-01 00:00:00	1973-10-01	38000177		0	0	21		0	0	0	325809	0	243670	19059056		
13530	1133	920300	2012-08-06	2012-08-06 00:00:00	2012-08-13	2012-08-13 00:00:00	2012-08-13	38000177		0	0	7		0	0	0	74599	0	311989	920300		
31478	2610	1127433	2011-11-20	2011-11-20 00:00:00	2011-12-04	2011-12-04 00:00:00	2011-12-04	38000177		0	0	14		0	0	0	172611	0	313782	1127433		
188689	4143	40213160	1962-03-09	1962-03-09 00:00:00	1962-03-09	1962-03-09 00:00:00	1962-03-09	581452		0	0	0		0	0	0	275347	0	10	40213160		
24117	1982	19133905	1954-01-14	1954-01-14 00:00:00	1954-01-27	1954-01-27 00:00:00	1954-01-27	38000177		0	0	13		0	0	0	131950	0	834102	19133905		
12744	1073	19059056	1964-10-10	1964-10-10 00:00:00	1964-11-14	1964-11-14 00:00:00	1964-11-14	38000177		0	0	35		0	0	0	70302	0	243670	19059056		
56610	4696	1127433	1954-12-24	1954-12-24 00:00:00	1954-12-31	1954-12-31 00:00:00	1954-12-31	38000177		0	0	7		0	0	0	312853	0	313782	1127433		
44673	972	40213160	1967-02-08	1967-02-08 00:00:00	1967-02-08	1967-02-08 00:00:00	1967-02-08	581452		0	0	0		0	0	0	64690	0	10	40213160		
55502	4608	1127433	2008-08-23	2008-08-23 00:00:00	2008-09-22	2008-09-22 00:00:00	2008-09-22	38000177		0	0	30		0	0	0	307070	0	313782	1127433		
145371	3196	40213227	2002-02-05	2002-02-05 00:00:00	2002-02-05	2002-02-05 00:00:00	2002-02-05	581452		0	0	0		0	0	0	212607	0	113	40213227		
32938	720	40213306	1986-11-15	1986-11-15 00:00:00	1986-11-15	1986-11-15 00:00:00	1986-11-15	581452		0	0	0		0	0	0	47640	0	43	40213306		
98835	2164	40213227	2014-10-10	2014-10-10 00:00:00	2014-10-10	2014-10-10 00:00:00	2014-10-10	581452		0	0	0		0	0	0	144171	0	113	40213227		
52541	1149	40213296	2019-02-05	2019-02-05 00:00:00	2019-02-05	2019-02-05 00:00:00	2019-02-05	581452		0	0	0		0	0	0	75944	0	52	40213296		
25218	2076	1713671	1969-10-19	1969-10-19 00:00:00	1969-10-26	1969-10-26 00:00:00	1969-10-26	38000177		0	0	7		0	0	0	138189	0	562251	1713671		
55979	4646	19018935	2001-10-02	2001-10-02 00:00:00	2001-10-02	2001-10-02 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	197604	19018935		
5153	430	19059056	1941-10-25	1941-10-25 00:00:00	1941-11-24	1941-11-24 00:00:00	1941-11-24	38000177		0	0	30		0	0	0	28538	0	243670	19059056		
74548	1627	40213160	1957-04-13	1957-04-13 00:00:00	1957-04-13	1957-04-13 00:00:00	1957-04-13	581452		0	0	0		0	0	0	109305	0	10	40213160		
56093	4656	19126352	1959-09-20	1959-09-20 00:00:00	2008-06-29	2008-06-29 00:00:00	2008-06-29	38000177		0	0	17815		0	0	0	310430	0	705129	19126352		
10365	866	1124300	1998-01-17	1998-01-17 00:00:00	1998-01-17	1998-01-17 00:00:00	\N	38000177		0	0	0		0	0	0	57506	0	00781178901	45011828		
216974	4760	40213227	2016-09-21	2016-09-21 00:00:00	2016-09-21	2016-09-21 00:00:00	2016-09-21	581452		0	0	0		0	0	0	317209	0	113	40213227		
16986	1407	1127078	1975-04-29	1975-04-29 00:00:00	1975-05-27	1975-05-27 00:00:00	1975-05-27	38000177		0	0	28		0	0	0	93563	0	282464	1127078		
75528	1649	40213160	1956-11-14	1956-11-14 00:00:00	1956-11-14	1956-11-14 00:00:00	1956-11-14	581452		0	0	0		0	0	0	110633	0	10	40213160		
21046	1736	920300	1990-12-03	1990-12-03 00:00:00	1990-12-10	1990-12-10 00:00:00	1990-12-10	38000177		0	0	7		0	0	0	115889	0	311989	920300		
21074	1737	19126352	1970-11-13	1970-11-13 00:00:00	1970-11-13	1970-11-13 00:00:00	\N	38000177		0	0	0		0	0	0	115995	0	705129	19126352		
31597	2620	1713671	1974-12-20	1974-12-20 00:00:00	1975-01-03	1975-01-03 00:00:00	1975-01-03	38000177		0	0	14		0	0	0	173299	0	562251	1713671		
54494	4529	19133905	1993-07-14	1993-07-14 00:00:00	1993-07-21	1993-07-21 00:00:00	1993-07-21	38000177		0	0	7		0	0	0	301551	0	834102	19133905		
54845	4557	46275916	1978-12-31	1978-12-31 00:00:00	1978-12-31	1978-12-31 00:00:00	1978-12-31	38000177		0	0	0		0	0	0	303643	0	1660014	46275916		
19783	1627	1127433	1980-06-25	1980-06-25 00:00:00	1980-07-09	1980-07-09 00:00:00	1980-07-09	38000177		0	0	14		0	0	0	109373	0	313782	1127433		
38301	3170	1127078	1951-07-20	1951-07-20 00:00:00	1951-08-03	1951-08-03 00:00:00	1951-08-03	38000177		0	0	14		0	0	0	210699	0	282464	1127078		
74885	1635	40213160	1973-06-27	1973-06-27 00:00:00	1973-06-27	1973-06-27 00:00:00	1973-06-27	581452		0	0	0		0	0	0	109806	0	10	40213160		
227645	4999	40213260	2007-11-25	2007-11-25 00:00:00	2007-11-25	2007-11-25 00:00:00	2007-11-25	581452		0	0	0		0	0	0	332471	0	121	40213260		
37302	3082	19128065	1990-06-04	1990-06-04 00:00:00	1991-05-30	1991-05-30 00:00:00	1991-05-30	38000177		0	0	360		0	0	0	205244	0	749882	19128065		
33101	2745	19075001	2007-08-28	2007-08-28 00:00:00	2007-10-02	2007-10-02 00:00:00	2007-10-02	38000177		0	0	35		0	0	0	181578	0	309097	19075001		
51217	4255	19019979	1979-04-14	1979-04-14 00:00:00	1979-04-28	1979-04-28 00:00:00	1979-04-28	38000177		0	0	14		0	0	0	282559	0	198405	19019979		
121218	2663	40213227	2005-09-11	2005-09-11 00:00:00	2005-09-11	2005-09-11 00:00:00	2005-09-11	581452		0	0	0		0	0	0	176471	0	113	40213227		
43485	948	40213227	1993-06-25	1993-06-25 00:00:00	1993-06-25	1993-06-25 00:00:00	1993-06-25	581452		0	0	0		0	0	0	62911	0	113	40213227		
23769	1954	19133905	1997-11-05	1997-11-05 00:00:00	1997-11-13	1997-11-13 00:00:00	1997-11-13	38000177		0	0	8		0	0	0	130052	0	834102	19133905		
189797	4167	40213227	2011-08-31	2011-08-31 00:00:00	2011-08-31	2011-08-31 00:00:00	2011-08-31	581452		0	0	0		0	0	0	276916	0	113	40213227		
138203	3035	40213260	2013-12-20	2013-12-20 00:00:00	2013-12-20	2013-12-20 00:00:00	2013-12-20	581452		0	0	0		0	0	0	202232	0	121	40213260		
16613	1377	1127078	1988-05-13	1988-05-13 00:00:00	1988-05-27	1988-05-27 00:00:00	1988-05-27	38000177		0	0	14		0	0	0	91241	0	282464	1127078		
34393	2842	1118084	1995-12-05	1995-12-05 00:00:00	1995-12-05	1995-12-05 00:00:00	\N	38000177		0	0	0		0	0	0	188697	0	00025152531	44923712		
34437	2845	19059056	1961-03-24	1961-03-24 00:00:00	1961-04-14	1961-04-14 00:00:00	1961-04-14	38000177		0	0	21		0	0	0	188981	0	243670	19059056		
45207	3742	19133873	1984-08-04	1984-08-04 00:00:00	1984-08-11	1984-08-11 00:00:00	1984-08-11	38000177		0	0	7		0	0	0	248667	0	834061	19133873		
10071	843	19127922	2003-03-22	2003-03-22 00:00:00	2004-03-16	2004-03-16 00:00:00	2004-03-16	38000177		0	0	360		0	0	0	55795	0	748962	19127922		
60521	1322	40213227	2014-08-06	2014-08-06 00:00:00	2014-08-06	2014-08-06 00:00:00	2014-08-06	581452		0	0	0		0	0	0	87759	0	113	40213227		
17706	1467	19059056	1935-06-14	1935-06-14 00:00:00	1935-06-28	1935-06-28 00:00:00	1935-06-28	38000177		0	0	14		0	0	0	97674	0	243670	19059056		
55837	4634	19133873	1975-10-15	1975-10-15 00:00:00	1975-10-22	1975-10-22 00:00:00	1975-10-22	38000177		0	0	7		0	0	0	308830	0	834061	19133873		
55887	4639	19059056	1975-07-24	1975-07-24 00:00:00	1975-08-07	1975-08-07 00:00:00	1975-08-07	38000177		0	0	14		0	0	0	309187	0	243670	19059056		
35105	2897	1127078	1968-12-19	1968-12-19 00:00:00	1969-01-02	1969-01-02 00:00:00	1969-01-02	38000177		0	0	14		0	0	0	192940	0	282464	1127078		
21436	1762	1127433	1948-08-22	1948-08-22 00:00:00	1948-09-05	1948-09-05 00:00:00	1948-09-05	38000177		0	0	14		0	0	0	117805	0	313782	1127433		
10759	895	19133905	2011-10-15	2011-10-15 00:00:00	2011-10-24	2011-10-24 00:00:00	2011-10-24	38000177		0	0	9		0	0	0	59721	0	834102	19133905		
48538	4020	46233710	1972-09-08	1972-09-08 00:00:00	1972-09-22	1972-09-22 00:00:00	1972-09-22	38000177		0	0	14		0	0	0	267236	0	1650142	46233710		
82768	1809	40213260	2012-12-12	2012-12-12 00:00:00	2012-12-12	2012-12-12 00:00:00	2012-12-12	581452		0	0	0		0	0	0	121137	0	121	40213260		
45812	3791	40229134	1937-07-08	1937-07-08 00:00:00	1937-07-22	1937-07-22 00:00:00	1937-07-22	38000177		0	0	14		0	0	0	252133	0	1043400	40229134		
59120	4913	19128065	1988-04-14	1988-04-14 00:00:00	1989-04-09	1989-04-09 00:00:00	1989-04-09	38000177		0	0	360		0	0	0	326512	0	749882	19128065		
32172	2666	1118084	1992-06-24	1992-06-24 00:00:00	1992-06-24	1992-06-24 00:00:00	\N	38000177		0	0	0		0	0	0	176654	0	00025152531	44923712		
41559	906	40213160	1972-08-08	1972-08-08 00:00:00	1972-08-08	1972-08-08 00:00:00	1972-08-08	581452		0	0	0		0	0	0	60276	0	10	40213160		
150681	3314	40213227	2004-08-14	2004-08-14 00:00:00	2004-08-14	2004-08-14 00:00:00	2004-08-14	581452		0	0	0		0	0	0	220109	0	113	40213227		
193625	4253	40213314	1981-06-02	1981-06-02 00:00:00	1981-06-02	1981-06-02 00:00:00	1981-06-02	581452		0	0	0		0	0	0	282425	0	49	40213314		
50145	4160	920300	1989-08-01	1989-08-01 00:00:00	1989-08-08	1989-08-08 00:00:00	1989-08-08	38000177		0	0	7		0	0	0	276455	0	311989	920300		
1928	42	40213227	1992-04-14	1992-04-14 00:00:00	1992-04-14	1992-04-14 00:00:00	1992-04-14	581452		0	0	0		0	0	0	3119	0	113	40213227		
59342	4932	1127433	2010-10-22	2010-10-22 00:00:00	2010-10-29	2010-10-29 00:00:00	2010-10-29	38000177		0	0	7		0	0	0	327924	0	313782	1127433		
165508	3638	40213160	1963-08-08	1963-08-08 00:00:00	1963-08-08	1963-08-08 00:00:00	1963-08-08	581452		0	0	0		0	0	0	241948	0	10	40213160		
24885	2046	1332419	2004-02-24	2004-02-24 00:00:00	2004-02-24	2004-02-24 00:00:00	\N	38000177		0	0	0		0	0	0	136128	0	197361	1332419		
182017	3998	40213160	1955-06-09	1955-06-09 00:00:00	1955-06-09	1955-06-09 00:00:00	1955-06-09	581452		0	0	0		0	0	0	265798	0	10	40213160		
13531	1133	19133873	1968-05-12	1968-05-12 00:00:00	1968-05-24	1968-05-24 00:00:00	1968-05-24	38000177		0	0	12		0	0	0	74586	0	834061	19133873		
31480	2610	19059056	1964-04-13	1964-04-13 00:00:00	1964-05-14	1964-05-14 00:00:00	1964-05-14	38000177		0	0	31		0	0	0	172593	0	243670	19059056		
24071	1980	1127078	1982-03-22	1982-03-22 00:00:00	1982-06-20	1982-06-20 00:00:00	1982-06-20	38000177		0	0	90		0	0	0	131804	0	282464	1127078		
24118	1982	1115171	1997-02-07	1997-02-07 00:00:00	1997-05-08	1997-05-08 00:00:00	1997-05-08	38000177		0	0	90		0	0	0	131961	0	849574	1115171		
12745	1073	1124300	1974-04-02	1974-04-02 00:00:00	1974-04-02	1974-04-02 00:00:00	\N	38000177		0	0	0		0	0	0	70394	0	00781178901	45011828		
123280	2709	40213227	1992-01-28	1992-01-28 00:00:00	1992-01-28	1992-01-28 00:00:00	1992-01-28	581452		0	0	0		0	0	0	179511	0	113	40213227		
44677	972	40213260	2016-06-01	2016-06-01 00:00:00	2016-06-01	2016-06-01 00:00:00	2016-06-01	581452		0	0	0		0	0	0	64682	0	121	40213260		
55503	4608	1127433	2017-10-10	2017-10-10 00:00:00	2017-10-24	2017-10-24 00:00:00	2017-10-24	38000177		0	0	14		0	0	0	307036	0	313782	1127433		
145373	3196	40213296	2011-09-13	2011-09-13 00:00:00	2011-09-13	2011-09-13 00:00:00	2011-09-13	581452		0	0	0		0	0	0	\N	0	52	40213296		
32943	720	40213227	2015-09-05	2015-09-05 00:00:00	2015-09-05	2015-09-05 00:00:00	2015-09-05	581452		0	0	0		0	0	0	47615	0	113	40213227		
98838	2164	40213296	2012-10-05	2012-10-05 00:00:00	2012-10-05	2012-10-05 00:00:00	2012-10-05	581452		0	0	0		0	0	0	144151	0	52	40213296		
52543	1149	40213314	1979-07-10	1979-07-10 00:00:00	1979-07-10	1979-07-10 00:00:00	1979-07-10	581452		0	0	0		0	0	0	75965	0	49	40213314		
25219	2076	1124300	1999-11-11	1999-11-11 00:00:00	1999-11-11	1999-11-11 00:00:00	\N	38000177		0	0	0		0	0	0	138201	0	00781178901	45011828		
55980	4646	40171902	2001-10-02	2001-10-02 00:00:00	2001-10-02	2001-10-02 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	897718	40171902		
5155	431	1115171	1999-01-22	1999-01-22 00:00:00	1999-04-22	1999-04-22 00:00:00	1999-04-22	38000177		0	0	90		0	0	0	28596	0	849574	1115171		
74551	1627	40213201	2019-02-02	2019-02-02 00:00:00	2019-02-02	2019-02-02 00:00:00	2019-02-02	581452		0	0	0		0	0	0	109293	0	33	40213201		
56094	4656	1127433	2009-08-29	2009-08-29 00:00:00	2009-09-12	2009-09-12 00:00:00	2009-09-12	38000177		0	0	14		0	0	0	310483	0	313782	1127433		
10366	866	40229134	1972-10-31	1972-10-31 00:00:00	1972-11-14	1972-11-14 00:00:00	1972-11-14	38000177		0	0	14		0	0	0	57489	0	1043400	40229134		
216979	4760	40213227	2005-11-02	2005-11-02 00:00:00	2005-11-02	2005-11-02 00:00:00	2005-11-02	581452		0	0	0		0	0	0	317212	0	113	40213227		
16987	1407	1127433	1989-03-05	1989-03-05 00:00:00	1989-04-04	1989-04-04 00:00:00	1989-04-04	38000177		0	0	30		0	0	0	93565	0	313782	1127433		
75530	1649	40213160	1956-06-13	1956-06-13 00:00:00	1956-06-13	1956-06-13 00:00:00	1956-06-13	581452		0	0	0		0	0	0	110607	0	10	40213160		
21047	1736	920334	1989-10-27	1989-10-27 00:00:00	1989-11-03	1989-11-03 00:00:00	1989-11-03	38000177		0	0	7		0	0	0	115888	0	311995	920334		
21075	1737	40220960	2013-10-11	2013-10-11 00:00:00	2013-10-11	2013-10-11 00:00:00	2013-10-11	38000177		0	0	0		0	0	0	116083	0	1804799	40220960		
31598	2620	1118084	2000-10-23	2000-10-23 00:00:00	2000-10-23	2000-10-23 00:00:00	\N	38000177		0	0	0		0	0	0	173297	0	00025152531	44923712		
54495	4529	19133873	1965-11-08	1965-11-08 00:00:00	1965-11-15	1965-11-15 00:00:00	1965-11-15	38000177		0	0	7		0	0	0	301566	0	834061	19133873		
54846	4557	1310034	1978-12-31	1978-12-31 00:00:00	1978-12-31	1978-12-31 00:00:00	1978-12-31	38000177		0	0	0		0	0	0	303643	0	834357	1310034		
19784	1627	46233710	1980-06-25	1980-06-25 00:00:00	1980-07-09	1980-07-09 00:00:00	1980-07-09	38000177		0	0	14		0	0	0	109373	0	1650142	46233710		
38302	3170	19006318	1951-07-20	1951-07-20 00:00:00	1951-08-03	1951-08-03 00:00:00	1951-08-03	38000177		0	0	14		0	0	0	210699	0	105078	19006318		
74892	1635	40213296	2015-08-12	2015-08-12 00:00:00	2015-08-12	2015-08-12 00:00:00	2015-08-12	581452		0	0	0		0	0	0	109832	0	52	40213296		
227649	4999	40213160	1957-07-28	1957-07-28 00:00:00	1957-07-28	1957-07-28 00:00:00	1957-07-28	581452		0	0	0		0	0	0	332422	0	10	40213160		
37304	3082	19128065	1986-06-25	1986-06-25 00:00:00	1987-06-20	1987-06-20 00:00:00	1987-06-20	38000177		0	0	360		0	0	0	205185	0	749882	19128065		
33102	2745	19078461	2007-08-28	2007-08-28 00:00:00	2007-10-02	2007-10-02 00:00:00	2007-10-02	38000177		0	0	35		0	0	0	181578	0	310965	19078461		
51218	4255	19073183	1979-04-14	1979-04-14 00:00:00	1979-04-28	1979-04-28 00:00:00	1979-04-28	38000177		0	0	14		0	0	0	282559	0	308182	19073183		
121219	2663	40213296	2005-09-11	2005-09-11 00:00:00	2005-09-11	2005-09-11 00:00:00	2005-09-11	581452		0	0	0		0	0	0	176471	0	52	40213296		
43487	948	40213296	1998-09-25	1998-09-25 00:00:00	1998-09-25	1998-09-25 00:00:00	1998-09-25	581452		0	0	0		0	0	0	62936	0	52	40213296		
23770	1954	19059056	1949-12-17	1949-12-17 00:00:00	1950-02-15	1950-02-15 00:00:00	1950-02-15	38000177		0	0	60		0	0	0	130033	0	243670	19059056		
189800	4167	40213306	1999-08-18	1999-08-18 00:00:00	1999-08-18	1999-08-18 00:00:00	1999-08-18	581452		0	0	0		0	0	0	276912	0	43	40213306		
138210	3035	40213227	1995-11-10	1995-11-10 00:00:00	1995-11-10	1995-11-10 00:00:00	1995-11-10	581452		0	0	0		0	0	0	202198	0	113	40213227		
16614	1377	19128065	1994-11-25	1994-11-25 00:00:00	1995-11-20	1995-11-20 00:00:00	1995-11-20	38000177		0	0	360		0	0	0	91256	0	749882	19128065		
34394	2842	1127433	1995-04-23	1995-04-23 00:00:00	1995-04-30	1995-04-30 00:00:00	1995-04-30	38000177		0	0	7		0	0	0	188697	0	313782	1127433		
34438	2845	1127433	1961-01-19	1961-01-19 00:00:00	1961-02-02	1961-02-02 00:00:00	1961-02-02	38000177		0	0	14		0	0	0	188905	0	313782	1127433		
45208	3742	1713671	1989-01-16	1989-01-16 00:00:00	1989-02-06	1989-02-06 00:00:00	1989-02-06	38000177		0	0	21		0	0	0	248669	0	562251	1713671		
10072	843	42902245	2009-02-18	2009-02-18 00:00:00	2010-02-13	2010-02-13 00:00:00	2010-02-13	38000177		0	0	360		0	0	0	55786	0	1359133	42902245		
60522	1322	40213201	1989-05-24	1989-05-24 00:00:00	1989-05-24	1989-05-24 00:00:00	1989-05-24	581452		0	0	0		0	0	0	87753	0	33	40213201		
17707	1467	1713671	1997-04-21	1997-04-21 00:00:00	1997-04-28	1997-04-28 00:00:00	1997-04-28	38000177		0	0	7		0	0	0	97718	0	562251	1713671		
55847	4636	1713671	1976-07-08	1976-07-08 00:00:00	1976-07-22	1976-07-22 00:00:00	1976-07-22	38000177		0	0	14		0	0	0	308945	0	562251	1713671		
55888	4639	19129655	1975-07-24	1975-07-24 00:00:00	1975-08-07	1975-08-07 00:00:00	1975-08-07	38000177		0	0	14		0	0	0	309187	0	789980	19129655		
35106	2897	1115171	2017-11-15	2017-11-15 00:00:00	2017-12-15	2017-12-15 00:00:00	2017-12-15	38000177		0	0	30		0	0	0	192945	0	849574	1115171		
21437	1762	19059056	1946-08-01	1946-08-01 00:00:00	1946-08-15	1946-08-15 00:00:00	1946-08-15	38000177		0	0	14		0	0	0	117809	0	243670	19059056		
10760	895	1118084	2005-12-10	2005-12-10 00:00:00	2005-12-10	2005-12-10 00:00:00	\N	38000177		0	0	0		0	0	0	59684	0	00025152531	44923712		
48540	4021	1115171	2016-06-21	2016-06-21 00:00:00	2016-07-05	2016-07-05 00:00:00	2016-07-05	38000177		0	0	14		0	0	0	267349	0	849574	1115171		
82773	1809	40213160	1963-03-20	1963-03-20 00:00:00	1963-03-20	1963-03-20 00:00:00	1963-03-20	581452		0	0	0		0	0	0	121118	0	10	40213160		
45813	3791	19018935	2011-06-25	2011-06-25 00:00:00	2011-06-25	2011-06-25 00:00:00	\N	38000177		0	0	0		0	0	0	252036	0	197604	19018935		
59121	4913	1127078	1976-12-03	1976-12-03 00:00:00	1976-12-17	1976-12-17 00:00:00	1976-12-17	38000177		0	0	14		0	0	0	326570	0	282464	1127078		
32174	2666	19059056	1971-11-21	1971-11-21 00:00:00	1971-12-12	1971-12-12 00:00:00	1971-12-12	38000177		0	0	21		0	0	0	176683	0	243670	19059056		
41566	906	40213296	2012-03-06	2012-03-06 00:00:00	2012-03-06	2012-03-06 00:00:00	2012-03-06	581452		0	0	0		0	0	0	60241	0	52	40213296		
150682	3314	40213296	2004-08-14	2004-08-14 00:00:00	2004-08-14	2004-08-14 00:00:00	2004-08-14	581452		0	0	0		0	0	0	220109	0	52	40213296		
193626	4253	40213160	1981-06-02	1981-06-02 00:00:00	1981-06-02	1981-06-02 00:00:00	1981-06-02	581452		0	0	0		0	0	0	282425	0	10	40213160		
50146	4160	40236824	1989-08-01	1989-08-01 00:00:00	1989-08-08	1989-08-08 00:00:00	1989-08-08	38000177		0	0	7		0	0	0	276455	0	1094107	40236824		
1933	42	40213227	2000-11-28	2000-11-28 00:00:00	2000-11-28	2000-11-28 00:00:00	2000-11-28	581452		0	0	0		0	0	0	3090	0	113	40213227		
59343	4932	1127433	2002-10-12	2002-10-12 00:00:00	2002-10-26	2002-10-26 00:00:00	2002-10-26	38000177		0	0	14		0	0	0	327827	0	313782	1127433		
165513	3638	40213160	1963-10-10	1963-10-10 00:00:00	1963-10-10	1963-10-10 00:00:00	1963-10-10	581452		0	0	0		0	0	0	241999	0	10	40213160		
24886	2046	19078461	1995-01-18	1995-01-18 00:00:00	1995-02-08	1995-02-08 00:00:00	1995-02-08	38000177		0	0	21		0	0	0	136153	0	310965	19078461		
182027	3998	40213227	2018-12-13	2018-12-13 00:00:00	2018-12-13	2018-12-13 00:00:00	2018-12-13	581452		0	0	0		0	0	0	265787	0	113	40213227		
13532	1133	40229134	1973-03-30	1973-03-30 00:00:00	1973-04-06	1973-04-06 00:00:00	1973-04-06	38000177		0	0	7		0	0	0	74587	0	1043400	40229134		
23117	1905	1118084	2008-08-31	2008-08-31 00:00:00	2008-08-31	2008-08-31 00:00:00	\N	38000177		0	0	0		0	0	0	126837	0	00025152531	44923712		
24072	1980	40232448	1975-10-01	1975-10-01 00:00:00	1975-10-01	1975-10-01 00:00:00	\N	38000177		0	0	0		0	0	0	131876	0	1049630	40232448		
24119	1982	19078461	1983-10-02	1983-10-02 00:00:00	1983-10-23	1983-10-23 00:00:00	1983-10-23	38000177		0	0	21		0	0	0	131976	0	310965	19078461		
12746	1073	19078461	2017-02-14	2017-02-14 00:00:00	2017-04-15	2017-04-15 00:00:00	2017-04-15	38000177		0	0	60		0	0	0	70305	0	310965	19078461		
123285	2709	40213201	2005-12-13	2005-12-13 00:00:00	2005-12-13	2005-12-13 00:00:00	2005-12-13	581452		0	0	0		0	0	0	179497	0	33	40213201		
44684	972	40213160	1966-11-09	1966-11-09 00:00:00	1966-11-09	1966-11-09 00:00:00	1966-11-09	581452		0	0	0		0	0	0	64724	0	10	40213160		
225153	4943	40213296	2001-06-06	2001-06-06 00:00:00	2001-06-06	2001-06-06 00:00:00	2001-06-06	581452		0	0	0		0	0	0	328560	0	52	40213296		
145375	3196	40213227	2011-09-13	2011-09-13 00:00:00	2011-09-13	2011-09-13 00:00:00	2011-09-13	581452		0	0	0		0	0	0	\N	0	113	40213227		
32944	720	40213260	2015-09-05	2015-09-05 00:00:00	2015-09-05	2015-09-05 00:00:00	2015-09-05	581452		0	0	0		0	0	0	47615	0	121	40213260		
98841	2164	40213160	1973-06-08	1973-06-08 00:00:00	1973-06-08	1973-06-08 00:00:00	1973-06-08	581452		0	0	0		0	0	0	144163	0	10	40213160		
52544	1149	40213160	1979-07-10	1979-07-10 00:00:00	1979-07-10	1979-07-10 00:00:00	1979-07-10	581452		0	0	0		0	0	0	75965	0	10	40213160		
25220	2076	1127433	1997-12-23	1997-12-23 00:00:00	1998-01-06	1998-01-06 00:00:00	1998-01-06	38000177		0	0	14		0	0	0	138201	0	313782	1127433		
55981	4646	1118084	1986-12-15	1986-12-15 00:00:00	1986-12-15	1986-12-15 00:00:00	\N	38000177		0	0	0		0	0	0	309726	0	00025152531	44923712		
5157	431	1127433	1992-05-11	1992-05-11 00:00:00	1992-05-18	1992-05-18 00:00:00	1992-05-18	38000177		0	0	7		0	0	0	28622	0	313782	1127433		
74556	1627	40213198	2018-01-27	2018-01-27 00:00:00	2018-01-27	2018-01-27 00:00:00	2018-01-27	581452		0	0	0		0	0	0	109297	0	133	40213198		
56095	4656	1124300	1993-06-12	1993-06-12 00:00:00	1993-06-12	1993-06-12 00:00:00	\N	38000177		0	0	0		0	0	0	310456	0	00781178901	45011828		
10367	866	1127433	1970-11-10	1970-11-10 00:00:00	1970-12-01	1970-12-01 00:00:00	1970-12-01	38000177		0	0	21		0	0	0	57487	0	313782	1127433		
216983	4760	40213160	1955-02-02	1955-02-02 00:00:00	1955-02-02	1955-02-02 00:00:00	1955-02-02	581452		0	0	0		0	0	0	317180	0	10	40213160		
16988	1407	1713671	1979-09-15	1979-09-15 00:00:00	1979-09-22	1979-09-22 00:00:00	1979-09-22	38000177		0	0	7		0	0	0	93572	0	562251	1713671		
173200	3807	40213201	2012-12-15	2012-12-15 00:00:00	2012-12-15	2012-12-15 00:00:00	2012-12-15	581452		0	0	0		0	0	0	253034	0	33	40213201		
21048	1736	1118084	2010-01-13	2010-01-13 00:00:00	2010-01-13	2010-01-13 00:00:00	\N	38000177		0	0	0		0	0	0	115956	0	00025152531	44923712		
21076	1737	19133873	1922-12-08	1922-12-08 00:00:00	1922-12-20	1922-12-20 00:00:00	1922-12-20	38000177		0	0	12		0	0	0	115976	0	834061	19133873		
31599	2620	1713671	2005-04-09	2005-04-09 00:00:00	2005-04-30	2005-04-30 00:00:00	2005-04-30	38000177		0	0	21		0	0	0	173277	0	562251	1713671		
54496	4529	19128065	1986-09-30	1986-09-30 00:00:00	1987-09-25	1987-09-25 00:00:00	1987-09-25	38000177		0	0	360		0	0	0	301609	0	749882	19128065		
54847	4557	40243436	1978-12-31	1978-12-31 00:00:00	1978-12-31	1978-12-31 00:00:00	1978-12-31	38000177		0	0	0		0	0	0	303643	0	1190795	40243436		
19785	1627	19059056	1955-09-13	1955-09-13 00:00:00	1955-09-27	1955-09-27 00:00:00	1955-09-27	38000177		0	0	14		0	0	0	109371	0	243670	19059056		
38303	3170	1127433	1979-05-15	1979-05-15 00:00:00	1979-05-29	1979-05-29 00:00:00	1979-05-29	38000177		0	0	14		0	0	0	210744	0	313782	1127433		
74895	1635	40213227	2015-08-12	2015-08-12 00:00:00	2015-08-12	2015-08-12 00:00:00	2015-08-12	581452		0	0	0		0	0	0	109832	0	113	40213227		
227664	4999	40213160	1957-04-28	1957-04-28 00:00:00	1957-04-28	1957-04-28 00:00:00	1957-04-28	581452		0	0	0		0	0	0	332440	0	10	40213160		
37305	3082	1127433	1997-05-19	1997-05-19 00:00:00	1997-05-26	1997-05-26 00:00:00	1997-05-26	38000177		0	0	7		0	0	0	205230	0	313782	1127433		
33103	2745	40165015	2007-08-28	2007-08-28 00:00:00	2007-08-28	2007-08-28 00:00:00	\N	38000177		0	0	0		0	0	0	181578	0	861467	40165015		
51219	4255	19019979	1975-01-18	1975-01-18 00:00:00	1975-02-08	1975-02-08 00:00:00	1975-02-08	38000177		0	0	21		0	0	0	282502	0	198405	19019979		
52931	4398	19059056	1961-02-06	1961-02-06 00:00:00	1961-05-07	1961-05-07 00:00:00	1961-05-07	38000177		0	0	90		0	0	0	292430	0	243670	19059056		
43491	948	40213160	1959-02-27	1959-02-27 00:00:00	1959-02-27	1959-02-27 00:00:00	1959-02-27	581452		0	0	0		0	0	0	62944	0	10	40213160		
23771	1954	40162522	1949-12-17	1949-12-17 00:00:00	1949-12-17	1949-12-17 00:00:00	\N	38000177		0	0	0		0	0	0	130033	0	857005	40162522		
189803	4167	40213306	2002-01-23	2002-01-23 00:00:00	2002-01-23	2002-01-23 00:00:00	2002-01-23	581452		0	0	0		0	0	0	\N	0	43	40213306		
138215	3035	40213160	1964-05-29	1964-05-29 00:00:00	1964-05-29	1964-05-29 00:00:00	1964-05-29	581452		0	0	0		0	0	0	202204	0	10	40213160		
16615	1377	1118084	2015-07-13	2015-07-13 00:00:00	2015-07-13	2015-07-13 00:00:00	\N	38000177		0	0	0		0	0	0	91285	0	00025152531	44923712		
34395	2843	1127433	2001-07-06	2001-07-06 00:00:00	2001-08-03	2001-08-03 00:00:00	2001-08-03	38000177		0	0	28		0	0	0	188742	0	313782	1127433		
34439	2845	1127433	1965-08-11	1965-08-11 00:00:00	1965-08-25	1965-08-25 00:00:00	1965-08-25	38000177		0	0	14		0	0	0	188900	0	313782	1127433		
45209	3742	1127433	1993-09-14	1993-09-14 00:00:00	1993-09-28	1993-09-28 00:00:00	1993-09-28	38000177		0	0	14		0	0	0	248640	0	313782	1127433		
10073	843	19112599	1983-05-08	1983-05-08 00:00:00	1983-05-08	1983-05-08 00:00:00	\N	38000177		0	0	0		0	0	0	55804	0	477045	19112599		
60529	1323	40213306	1984-03-17	1984-03-17 00:00:00	1984-03-17	1984-03-17 00:00:00	1984-03-17	581452		0	0	0		0	0	0	87858	0	43	40213306		
17708	1467	920300	1955-04-27	1955-04-27 00:00:00	1955-05-04	1955-05-04 00:00:00	1955-05-04	38000177		0	0	7		0	0	0	97775	0	311989	920300		
55849	4636	1127433	1972-07-01	1972-07-01 00:00:00	1972-07-08	1972-07-08 00:00:00	1972-07-08	38000177		0	0	7		0	0	0	308967	0	313782	1127433		
55889	4639	19133873	1971-07-18	1971-07-18 00:00:00	1971-07-25	1971-07-25 00:00:00	1971-07-25	38000177		0	0	7		0	0	0	309185	0	834061	19133873		
35107	2897	40162522	2017-11-15	2017-11-15 00:00:00	2017-11-15	2017-11-15 00:00:00	\N	38000177		0	0	0		0	0	0	192945	0	857005	40162522		
21438	1762	19006318	1946-08-01	1946-08-01 00:00:00	1946-08-15	1946-08-15 00:00:00	1946-08-15	38000177		0	0	14		0	0	0	117809	0	105078	19006318		
10761	895	19059056	1971-11-18	1971-11-18 00:00:00	1971-12-02	1971-12-02 00:00:00	1971-12-02	38000177		0	0	14		0	0	0	59678	0	243670	19059056		
48541	4021	19006318	1958-04-04	1958-04-04 00:00:00	1958-04-18	1958-04-18 00:00:00	1958-04-18	38000177		0	0	14		0	0	0	267281	0	105078	19006318		
177694	3906	40213227	2013-11-06	2013-11-06 00:00:00	2013-11-06	2013-11-06 00:00:00	2013-11-06	581452		0	0	0		0	0	0	259687	0	113	40213227		
45814	3791	40171902	2011-06-25	2011-06-25 00:00:00	2011-06-25	2011-06-25 00:00:00	\N	38000177		0	0	0		0	0	0	252036	0	897718	40171902		
59123	4913	1127433	1995-12-17	1995-12-17 00:00:00	1995-12-31	1995-12-31 00:00:00	1995-12-31	38000177		0	0	14		0	0	0	326558	0	313782	1127433		
32175	2666	1127433	2007-06-11	2007-06-11 00:00:00	2007-06-18	2007-06-18 00:00:00	2007-06-18	38000177		0	0	7		0	0	0	176622	0	313782	1127433		
41569	906	40213227	2003-06-10	2003-06-10 00:00:00	2003-06-10	2003-06-10 00:00:00	2003-06-10	581452		0	0	0		0	0	0	60251	0	113	40213227		
150684	3314	40213260	2013-09-14	2013-09-14 00:00:00	2013-09-14	2013-09-14 00:00:00	2013-09-14	581452		0	0	0		0	0	0	220052	0	121	40213260		
176700	3884	40213227	1995-03-06	1995-03-06 00:00:00	1995-03-06	1995-03-06 00:00:00	1995-03-06	581452		0	0	0		0	0	0	258163	0	113	40213227		
50147	4160	40165015	1978-05-17	1978-05-17 00:00:00	1978-05-17	1978-05-17 00:00:00	\N	38000177		0	0	0		0	0	0	276450	0	861467	40165015		
176818	3887	40213160	1961-06-05	1961-06-05 00:00:00	1961-06-05	1961-06-05 00:00:00	1961-06-05	581452		0	0	0		0	0	0	258372	0	10	40213160		
59344	4932	40232448	1976-12-03	1976-12-03 00:00:00	1976-12-03	1976-12-03 00:00:00	\N	38000177		0	0	0		0	0	0	327863	0	1049630	40232448		
165517	3638	40213227	1994-10-06	1994-10-06 00:00:00	1994-10-06	1994-10-06 00:00:00	1994-10-06	581452		0	0	0		0	0	0	242015	0	113	40213227		
24887	2046	19133873	1945-08-14	1945-08-14 00:00:00	1945-08-27	1945-08-27 00:00:00	1945-08-27	38000177		0	0	13		0	0	0	136146	0	834061	19133873		
193321	4246	40213260	2018-01-03	2018-01-03 00:00:00	2018-01-03	2018-01-03 00:00:00	2018-01-03	581452		0	0	0		0	0	0	281966	0	121	40213260		
13533	1134	1127433	1999-06-16	1999-06-16 00:00:00	1999-07-16	1999-07-16 00:00:00	1999-07-16	38000177		0	0	30		0	0	0	74730	0	313782	1127433		
23118	1906	19133905	2012-03-26	2012-03-26 00:00:00	2012-04-04	2012-04-04 00:00:00	2012-04-04	38000177		0	0	9		0	0	0	126913	0	834102	19133905		
24073	1980	40165015	1988-07-02	1988-07-02 00:00:00	1988-07-02	1988-07-02 00:00:00	\N	38000177		0	0	0		0	0	0	131806	0	861467	40165015		
24120	1982	1127433	1993-03-09	1993-03-09 00:00:00	1993-03-30	1993-03-30 00:00:00	1993-03-30	38000177		0	0	21		0	0	0	131960	0	313782	1127433		
12747	1073	1713671	1944-11-25	1944-11-25 00:00:00	1944-12-16	1944-12-16 00:00:00	1944-12-16	38000177		0	0	21		0	0	0	70384	0	562251	1713671		
55131	1208	40213227	1992-11-03	1992-11-03 00:00:00	1992-11-03	1992-11-03 00:00:00	1992-11-03	581452		0	0	0		0	0	0	79383	0	113	40213227		
44693	973	40213201	1983-07-11	1983-07-11 00:00:00	1983-07-11	1983-07-11 00:00:00	1983-07-11	581452		0	0	0		0	0	0	64821	0	33	40213201		
225156	4943	40213306	1984-01-04	1984-01-04 00:00:00	1984-01-04	1984-01-04 00:00:00	1984-01-04	581452		0	0	0		0	0	0	328603	0	43	40213306		
145381	3196	40213306	1993-01-26	1993-01-26 00:00:00	1993-01-26	1993-01-26 00:00:00	1993-01-26	581452		0	0	0		0	0	0	212662	0	43	40213306		
32946	720	40213160	1964-12-05	1964-12-05 00:00:00	1964-12-05	1964-12-05 00:00:00	1964-12-05	581452		0	0	0		0	0	0	47670	0	10	40213160		
199942	4391	40213201	2007-05-11	2007-05-11 00:00:00	2007-05-11	2007-05-11 00:00:00	2007-05-11	581452		0	0	0		0	0	0	291982	0	33	40213201		
52546	1149	40213160	1979-10-09	1979-10-09 00:00:00	1979-10-09	1979-10-09 00:00:00	1979-10-09	581452		0	0	0		0	0	0	75985	0	10	40213160		
25221	2076	1127433	1987-12-09	1987-12-09 00:00:00	1987-12-16	1987-12-16 00:00:00	1987-12-16	38000177		0	0	7		0	0	0	138199	0	313782	1127433		
55982	4646	19078461	2017-10-17	2017-10-17 00:00:00	2017-11-07	2017-11-07 00:00:00	2017-11-07	38000177		0	0	21		0	0	0	309819	0	310965	19078461		
5158	431	920300	1988-01-15	1988-01-15 00:00:00	1988-01-22	1988-01-22 00:00:00	1988-01-22	38000177		0	0	7		0	0	0	28561	0	311989	920300		
74557	1627	40213160	1955-10-08	1955-10-08 00:00:00	1955-10-08	1955-10-08 00:00:00	1955-10-08	581452		0	0	0		0	0	0	109304	0	10	40213160		
56096	4656	1332419	1995-10-01	1995-10-01 00:00:00	1995-10-01	1995-10-01 00:00:00	\N	38000177		0	0	0		0	0	0	310449	0	197361	1332419		
10368	866	19133873	1966-08-18	1966-08-18 00:00:00	1966-08-27	1966-08-27 00:00:00	1966-08-27	38000177		0	0	9		0	0	0	57465	0	834061	19133873		
216985	4760	40213160	1955-04-06	1955-04-06 00:00:00	1955-04-06	1955-04-06 00:00:00	1955-04-06	581452		0	0	0		0	0	0	317128	0	10	40213160		
16989	1407	1127078	1971-08-18	1971-08-18 00:00:00	1971-09-17	1971-09-17 00:00:00	1971-09-17	38000177		0	0	30		0	0	0	93562	0	282464	1127078		
173203	3807	40213227	2007-11-17	2007-11-17 00:00:00	2007-11-17	2007-11-17 00:00:00	2007-11-17	581452		0	0	0		0	0	0	253036	0	113	40213227		
21049	1736	1127433	2006-07-15	2006-07-15 00:00:00	2006-07-29	2006-07-29 00:00:00	2006-07-29	38000177		0	0	14		0	0	0	115892	0	313782	1127433		
21077	1737	1127433	1958-10-18	1958-10-18 00:00:00	1958-11-22	1958-11-22 00:00:00	1958-11-22	38000177		0	0	35		0	0	0	115962	0	313782	1127433		
31600	2620	1115171	2005-03-07	2005-03-07 00:00:00	2005-04-11	2005-04-11 00:00:00	2005-04-11	38000177		0	0	35		0	0	0	173256	0	849574	1115171		
54497	4529	40169281	1988-12-04	1988-12-04 00:00:00	1988-12-04	1988-12-04 00:00:00	\N	38000177		0	0	0		0	0	0	301590	0	896209	40169281		
54848	4557	40229134	1988-12-26	1988-12-26 00:00:00	1989-01-02	1989-01-02 00:00:00	1989-01-02	38000177		0	0	7		0	0	0	303578	0	1043400	40229134		
19787	1627	1124300	1987-11-04	1987-11-04 00:00:00	1987-11-04	1987-11-04 00:00:00	\N	38000177		0	0	0		0	0	0	109325	0	00781178901	45011828		
38304	3170	1713671	1965-06-23	1965-06-23 00:00:00	1965-07-07	1965-07-07 00:00:00	1965-07-07	38000177		0	0	14		0	0	0	210731	0	562251	1713671		
74898	1635	40213160	1973-03-28	1973-03-28 00:00:00	1973-03-28	1973-03-28 00:00:00	1973-03-28	581452		0	0	0		0	0	0	109846	0	10	40213160		
227666	4999	40213227	1999-08-29	1999-08-29 00:00:00	1999-08-29	1999-08-29 00:00:00	1999-08-29	581452		0	0	0		0	0	0	332433	0	113	40213227		
37307	3082	1127433	1980-03-02	1980-03-02 00:00:00	1980-05-31	1980-05-31 00:00:00	1980-05-31	38000177		0	0	90		0	0	0	205227	0	313782	1127433		
33104	2745	1118084	2012-12-25	2012-12-25 00:00:00	2012-12-25	2012-12-25 00:00:00	\N	38000177		0	0	0		0	0	0	181575	0	00025152531	44923712		
51220	4255	1127433	1990-09-07	1990-09-07 00:00:00	1990-09-14	1990-09-14 00:00:00	1990-09-14	38000177		0	0	7		0	0	0	282490	0	313782	1127433		
52932	4398	19133873	1965-01-31	1965-01-31 00:00:00	1965-02-13	1965-02-13 00:00:00	1965-02-13	38000177		0	0	13		0	0	0	292436	0	834061	19133873		
172968	3803	40213160	1960-09-21	1960-09-21 00:00:00	1960-09-21	1960-09-21 00:00:00	1960-09-21	581452		0	0	0		0	0	0	252814	0	10	40213160		
23772	1954	1118084	1970-08-14	1970-08-14 00:00:00	1970-08-14	1970-08-14 00:00:00	\N	38000177		0	0	0		0	0	0	129949	0	00025152531	44923712		
189806	4167	40213227	2002-01-23	2002-01-23 00:00:00	2002-01-23	2002-01-23 00:00:00	2002-01-23	581452		0	0	0		0	0	0	\N	0	113	40213227		
138216	3035	40213306	1986-10-31	1986-10-31 00:00:00	1986-10-31	1986-10-31 00:00:00	1986-10-31	581452		0	0	0		0	0	0	202227	0	43	40213306		
16616	1378	1127433	1968-01-10	1968-01-10 00:00:00	1968-01-24	1968-01-24 00:00:00	1968-01-24	38000177		0	0	14		0	0	0	91433	0	313782	1127433		
34396	2843	40229134	1998-01-06	1998-01-06 00:00:00	1998-01-13	1998-01-13 00:00:00	1998-01-13	38000177		0	0	7		0	0	0	188791	0	1043400	40229134		
34440	2845	1127078	1955-06-19	1955-06-19 00:00:00	1955-07-24	1955-07-24 00:00:00	1955-07-24	38000177		0	0	35		0	0	0	188980	0	282464	1127078		
45210	3742	1127433	2003-03-27	2003-03-27 00:00:00	2003-04-10	2003-04-10 00:00:00	2003-04-10	38000177		0	0	14		0	0	0	248635	0	313782	1127433		
10074	843	19128022	2001-04-01	2001-04-01 00:00:00	2002-03-27	2002-03-27 00:00:00	2002-03-27	38000177		0	0	360		0	0	0	55794	0	749785	19128022		
60534	1323	40213160	1966-04-16	1966-04-16 00:00:00	1966-04-16	1966-04-16 00:00:00	1966-04-16	581452		0	0	0		0	0	0	87824	0	10	40213160		
17709	1467	40236824	1955-04-27	1955-04-27 00:00:00	1955-05-04	1955-05-04 00:00:00	1955-05-04	38000177		0	0	7		0	0	0	97775	0	1094107	40236824		
55850	4636	1127433	1963-10-18	1963-10-18 00:00:00	1963-10-25	1963-10-25 00:00:00	1963-10-25	38000177		0	0	7		0	0	0	308933	0	313782	1127433		
55891	4639	1127433	2004-10-09	2004-10-09 00:00:00	2004-10-23	2004-10-23 00:00:00	2004-10-23	38000177		0	0	14		0	0	0	309201	0	313782	1127433		
35108	2897	1127433	1985-12-30	1985-12-30 00:00:00	1986-01-13	1986-01-13 00:00:00	1986-01-13	38000177		0	0	14		0	0	0	192938	0	313782	1127433		
21439	1762	1118084	1979-10-12	1979-10-12 00:00:00	1979-10-12	1979-10-12 00:00:00	\N	38000177		0	0	0		0	0	0	117801	0	00025152531	44923712		
10762	895	1127433	1989-12-28	1989-12-28 00:00:00	1990-01-04	1990-01-04 00:00:00	1990-01-04	38000177		0	0	7		0	0	0	59698	0	313782	1127433		
48542	4021	1127078	1958-04-04	1958-04-04 00:00:00	1958-04-18	1958-04-18 00:00:00	1958-04-18	38000177		0	0	14		0	0	0	267281	0	282464	1127078		
177698	3906	40213227	1994-07-20	1994-07-20 00:00:00	1994-07-20	1994-07-20 00:00:00	1994-07-20	581452		0	0	0		0	0	0	259715	0	113	40213227		
45815	3791	40163554	2011-06-25	2011-06-25 00:00:00	2011-06-25	2011-06-25 00:00:00	\N	38000177		0	0	0		0	0	0	252036	0	855332	40163554		
59124	4913	40229134	2017-09-23	2017-09-23 00:00:00	2017-10-07	2017-10-07 00:00:00	2017-10-07	38000177		0	0	14		0	0	0	326500	0	1043400	40229134		
49639	4117	19059056	1965-04-16	1965-04-16 00:00:00	1965-04-30	1965-04-30 00:00:00	1965-04-30	38000177		0	0	14		0	0	0	273697	0	243670	19059056		
41573	906	40213160	1972-06-06	1972-06-06 00:00:00	1972-06-06	1972-06-06 00:00:00	1972-06-06	581452		0	0	0		0	0	0	60255	0	10	40213160		
150686	3314	40213227	2013-09-14	2013-09-14 00:00:00	2013-09-14	2013-09-14 00:00:00	2013-09-14	581452		0	0	0		0	0	0	220052	0	113	40213227		
176701	3884	40213306	1995-03-06	1995-03-06 00:00:00	1995-03-06	1995-03-06 00:00:00	1995-03-06	581452		0	0	0		0	0	0	258163	0	43	40213306		
50148	4160	1127433	1978-05-17	1978-05-17 00:00:00	1978-07-16	1978-07-16 00:00:00	1978-07-16	38000177		0	0	60		0	0	0	276450	0	313782	1127433		
176831	3887	40213296	1999-10-04	1999-10-04 00:00:00	1999-10-04	1999-10-04 00:00:00	1999-10-04	581452		0	0	0		0	0	0	258392	0	52	40213296		
59345	4932	1127433	1997-04-18	1997-04-18 00:00:00	1997-04-25	1997-04-25 00:00:00	1997-04-25	38000177		0	0	7		0	0	0	327921	0	313782	1127433		
165520	3638	40213227	2005-07-07	2005-07-07 00:00:00	2005-07-07	2005-07-07 00:00:00	2005-07-07	581452		0	0	0		0	0	0	242010	0	113	40213227		
24888	2046	19133873	1948-02-17	1948-02-17 00:00:00	1948-02-29	1948-02-29 00:00:00	1948-02-29	38000177		0	0	12		0	0	0	136171	0	834061	19133873		
193322	4246	40213160	1967-04-05	1967-04-05 00:00:00	1967-04-05	1967-04-05 00:00:00	1967-04-05	581452		0	0	0		0	0	0	281959	0	10	40213160		
13534	1134	40162522	1999-06-16	1999-06-16 00:00:00	1999-06-16	1999-06-16 00:00:00	\N	38000177		0	0	0		0	0	0	74730	0	857005	40162522		
23119	1906	1713671	1973-12-24	1973-12-24 00:00:00	1974-01-15	1974-01-15 00:00:00	1974-01-15	38000177		0	0	22		0	0	0	126870	0	562251	1713671		
24074	1980	19078461	1988-07-02	1988-07-02 00:00:00	1988-08-01	1988-08-01 00:00:00	1988-08-01	38000177		0	0	30		0	0	0	131806	0	310965	19078461		
24121	1982	1127433	1960-07-08	1960-07-08 00:00:00	1960-07-29	1960-07-29 00:00:00	1960-07-29	38000177		0	0	21		0	0	0	131973	0	313782	1127433		
12748	1073	1115171	2004-06-17	2004-06-17 00:00:00	2004-07-22	2004-07-22 00:00:00	2004-07-22	38000177		0	0	35		0	0	0	70303	0	849574	1115171		
163852	3604	40213314	1984-08-10	1984-08-10 00:00:00	1984-08-10	1984-08-10 00:00:00	1984-08-10	581452		0	0	0		0	0	0	239460	0	49	40213314		
130366	2865	40213160	1973-01-08	1973-01-08 00:00:00	1973-01-08	1973-01-08 00:00:00	1973-01-08	581452		0	0	0		0	0	0	190595	0	10	40213160		
225159	4943	40213160	1961-10-11	1961-10-11 00:00:00	1961-10-11	1961-10-11 00:00:00	1961-10-11	581452		0	0	0		0	0	0	328594	0	10	40213160		
145383	3196	40213227	1993-01-26	1993-01-26 00:00:00	1993-01-26	1993-01-26 00:00:00	1993-01-26	581452		0	0	0		0	0	0	212662	0	113	40213227		
32951	720	40213296	2004-09-04	2004-09-04 00:00:00	2004-09-04	2004-09-04 00:00:00	2004-09-04	581452		0	0	0		0	0	0	47653	0	52	40213296		
107184	2349	40213160	1972-12-17	1972-12-17 00:00:00	1972-12-17	1972-12-17 00:00:00	1972-12-17	581452		0	0	0		0	0	0	156336	0	10	40213160		
52553	1149	40213306	2001-10-30	2001-10-30 00:00:00	2001-10-30	2001-10-30 00:00:00	2001-10-30	581452		0	0	0		0	0	0	75975	0	43	40213306		
25222	2076	1115171	2006-10-21	2006-10-21 00:00:00	2006-11-25	2006-11-25 00:00:00	2006-11-25	38000177		0	0	35		0	0	0	138211	0	849574	1115171		
96411	2114	40213160	1965-07-07	1965-07-07 00:00:00	1965-07-07	1965-07-07 00:00:00	1965-07-07	581452		0	0	0		0	0	0	140674	0	10	40213160		
5159	431	40236824	1988-01-15	1988-01-15 00:00:00	1988-01-22	1988-01-22 00:00:00	1988-01-22	38000177		0	0	7		0	0	0	28561	0	1094107	40236824		
161708	3558	40213306	1981-05-23	1981-05-23 00:00:00	1981-05-23	1981-05-23 00:00:00	1981-05-23	581452		0	0	0		0	0	0	236208	0	43	40213306		
56097	4656	19133768	2014-05-11	2014-05-11 00:00:00	2014-05-11	2014-05-11 00:00:00	2014-05-11	38000177		0	0	0		0	0	0	310472	0	833036	19133768		
10369	867	1127433	1986-05-07	1986-05-07 00:00:00	1986-05-21	1986-05-21 00:00:00	1986-05-21	38000177		0	0	14		0	0	0	57517	0	313782	1127433		
216988	4760	40213227	1996-11-06	1996-11-06 00:00:00	1996-11-06	1996-11-06 00:00:00	1996-11-06	581452		0	0	0		0	0	0	317170	0	113	40213227		
16990	1408	19059056	1954-09-03	1954-09-03 00:00:00	1954-10-01	1954-10-01 00:00:00	1954-10-01	38000177		0	0	28		0	0	0	93619	0	243670	19059056		
173209	3807	40213198	2011-12-10	2011-12-10 00:00:00	2011-12-10	2011-12-10 00:00:00	2011-12-10	581452		0	0	0		0	0	0	253021	0	133	40213198		
21050	1736	40236824	1989-08-09	1989-08-09 00:00:00	1989-08-16	1989-08-16 00:00:00	1989-08-16	38000177		0	0	7		0	0	0	115943	0	1094107	40236824		
21078	1737	40229134	1993-03-21	1993-03-21 00:00:00	1993-04-04	1993-04-04 00:00:00	1993-04-04	38000177		0	0	14		0	0	0	116099	0	1043400	40229134		
112705	2476	40213260	2006-10-04	2006-10-04 00:00:00	2006-10-04	2006-10-04 00:00:00	2006-10-04	581452		0	0	0		0	0	0	164058	0	121	40213260		
54498	4529	1115171	1998-09-28	1998-09-28 00:00:00	1998-11-04	1998-11-04 00:00:00	1998-11-04	38000177		0	0	37		0	0	0	301615	0	849574	1115171		
54849	4557	19133873	1934-10-05	1934-10-05 00:00:00	1934-10-16	1934-10-16 00:00:00	1934-10-16	38000177		0	0	11		0	0	0	303602	0	834061	19133873		
19788	1627	1713671	1985-07-29	1985-07-29 00:00:00	1985-08-05	1985-08-05 00:00:00	1985-08-05	38000177		0	0	7		0	0	0	109340	0	562251	1713671		
124174	2731	40213160	1960-10-17	1960-10-17 00:00:00	1960-10-17	1960-10-17 00:00:00	1960-10-17	581452		0	0	0		0	0	0	180749	0	10	40213160		
74900	1635	40213296	2013-08-07	2013-08-07 00:00:00	2013-08-07	2013-08-07 00:00:00	2013-08-07	581452		0	0	0		0	0	0	109818	0	52	40213296		
227667	4999	40213296	1999-08-29	1999-08-29 00:00:00	1999-08-29	1999-08-29 00:00:00	1999-08-29	581452		0	0	0		0	0	0	332433	0	52	40213296		
37308	3082	40162522	1980-03-02	1980-03-02 00:00:00	1980-03-02	1980-03-02 00:00:00	\N	38000177		0	0	0		0	0	0	205227	0	857005	40162522		
33105	2745	1127433	1977-01-20	1977-01-20 00:00:00	1977-01-27	1977-01-27 00:00:00	1977-01-27	38000177		0	0	7		0	0	0	181552	0	313782	1127433		
51221	4256	1118084	1992-06-12	1992-06-12 00:00:00	1992-06-12	1992-06-12 00:00:00	\N	38000177		0	0	0		0	0	0	282614	0	00025152531	44923712		
52933	4398	1713671	1980-08-04	1980-08-04 00:00:00	1980-08-25	1980-08-25 00:00:00	1980-08-25	38000177		0	0	21		0	0	0	292388	0	562251	1713671		
172974	3803	40213227	2002-10-02	2002-10-02 00:00:00	2002-10-02	2002-10-02 00:00:00	2002-10-02	581452		0	0	0		0	0	0	252777	0	113	40213227		
23773	1954	1127433	1964-05-04	1964-05-04 00:00:00	1964-05-11	1964-05-11 00:00:00	1964-05-11	38000177		0	0	7		0	0	0	130046	0	313782	1127433		
189807	4167	40213160	1979-05-30	1979-05-30 00:00:00	1979-05-30	1979-05-30 00:00:00	1979-05-30	581452		0	0	0		0	0	0	276901	0	10	40213160		
219958	4827	40213227	2011-08-18	2011-08-18 00:00:00	2011-08-18	2011-08-18 00:00:00	2011-08-18	581452		0	0	0		0	0	0	321233	0	113	40213227		
16617	1378	19059056	1945-05-16	1945-05-16 00:00:00	1945-06-06	1945-06-06 00:00:00	1945-06-06	38000177		0	0	21		0	0	0	91316	0	243670	19059056		
34397	2843	1127433	1990-12-31	1990-12-31 00:00:00	1991-03-31	1991-03-31 00:00:00	1991-03-31	38000177		0	0	90		0	0	0	188741	0	313782	1127433		
34441	2846	1127433	2003-11-21	2003-11-21 00:00:00	2003-12-05	2003-12-05 00:00:00	2003-12-05	38000177		0	0	14		0	0	0	189013	0	313782	1127433		
45211	3742	19133905	1995-04-02	1995-04-02 00:00:00	1995-04-14	1995-04-14 00:00:00	1995-04-14	38000177		0	0	12		0	0	0	248671	0	834102	19133905		
10075	843	19128022	1997-04-22	1997-04-22 00:00:00	1998-04-17	1998-04-17 00:00:00	1998-04-17	38000177		0	0	360		0	0	0	55815	0	749785	19128022		
60536	1323	40213227	2003-05-17	2003-05-17 00:00:00	2003-05-17	2003-05-17 00:00:00	2003-05-17	581452		0	0	0		0	0	0	87859	0	113	40213227		
17710	1467	40229134	1988-07-19	1988-07-19 00:00:00	1988-08-02	1988-08-02 00:00:00	1988-08-02	38000177		0	0	14		0	0	0	97717	0	1043400	40229134		
55851	4636	19059056	1948-05-08	1948-05-08 00:00:00	1948-05-22	1948-05-22 00:00:00	1948-05-22	38000177		0	0	14		0	0	0	308977	0	243670	19059056		
55892	4639	1127433	1994-07-15	1994-07-15 00:00:00	1994-07-29	1994-07-29 00:00:00	1994-07-29	38000177		0	0	14		0	0	0	309193	0	313782	1127433		
35109	2897	19133905	1983-12-13	1983-12-13 00:00:00	1983-12-21	1983-12-21 00:00:00	1983-12-21	38000177		0	0	8		0	0	0	192889	0	834102	19133905		
21440	1762	1127433	1975-09-20	1975-09-20 00:00:00	1975-09-27	1975-09-27 00:00:00	1975-09-27	38000177		0	0	7		0	0	0	117806	0	313782	1127433		
10763	895	1332419	1996-01-12	1996-01-12 00:00:00	1996-01-12	1996-01-12 00:00:00	\N	38000177		0	0	0		0	0	0	59665	0	197361	1332419		
48543	4021	19059056	1957-08-29	1957-08-29 00:00:00	1957-09-19	1957-09-19 00:00:00	1957-09-19	38000177		0	0	21		0	0	0	267308	0	243670	19059056		
177725	3906	40213201	2009-10-14	2009-10-14 00:00:00	2009-10-14	2009-10-14 00:00:00	2009-10-14	581452		0	0	0		0	0	0	259708	0	33	40213201		
45816	3791	1127433	1944-06-01	1944-06-01 00:00:00	1944-06-15	1944-06-15 00:00:00	1944-06-15	38000177		0	0	14		0	0	0	252046	0	313782	1127433		
59125	4913	1127078	1981-04-25	1981-04-25 00:00:00	1981-07-24	1981-07-24 00:00:00	1981-07-24	38000177		0	0	90		0	0	0	326571	0	282464	1127078		
49640	4117	1127433	1980-03-16	1980-03-16 00:00:00	1980-03-23	1980-03-23 00:00:00	1980-03-23	38000177		0	0	7		0	0	0	273693	0	313782	1127433		
41577	906	40213160	1977-02-08	1977-02-08 00:00:00	1977-02-08	1977-02-08 00:00:00	1977-02-08	581452		0	0	0		0	0	0	60280	0	10	40213160		
150694	3314	40213227	1995-07-08	1995-07-08 00:00:00	1995-07-08	1995-07-08 00:00:00	1995-07-08	581452		0	0	0		0	0	0	220102	0	113	40213227		
176711	3884	40213227	2006-01-30	2006-01-30 00:00:00	2006-01-30	2006-01-30 00:00:00	2006-01-30	581452		0	0	0		0	0	0	258069	0	113	40213227		
50149	4160	1124300	2004-08-08	2004-08-08 00:00:00	2004-08-08	2004-08-08 00:00:00	\N	38000177		0	0	0		0	0	0	276408	0	00781178901	45011828		
176834	3887	40213160	1956-10-01	1956-10-01 00:00:00	1956-10-01	1956-10-01 00:00:00	1956-10-01	581452		0	0	0		0	0	0	258410	0	10	40213160		
59346	4932	1115171	1997-11-14	1997-11-14 00:00:00	1997-11-28	1997-11-28 00:00:00	1997-11-28	38000177		0	0	14		0	0	0	327807	0	849574	1115171		
165521	3638	40213296	2005-07-07	2005-07-07 00:00:00	2005-07-07	2005-07-07 00:00:00	2005-07-07	581452		0	0	0		0	0	0	242010	0	52	40213296		
24889	2046	19073188	2005-06-18	2005-06-18 00:00:00	2005-07-02	2005-07-02 00:00:00	2005-07-02	38000177		0	0	14		0	0	0	136178	0	308192	19073188		
193324	4246	40213306	1989-05-10	1989-05-10 00:00:00	1989-05-10	1989-05-10 00:00:00	1989-05-10	581452		0	0	0		0	0	0	281948	0	43	40213306		
13535	1134	1127433	1966-08-01	1966-08-01 00:00:00	1966-08-15	1966-08-15 00:00:00	1966-08-15	38000177		0	0	14		0	0	0	74679	0	313782	1127433		
23120	1906	19129655	1964-01-15	1964-01-15 00:00:00	1964-01-29	1964-01-29 00:00:00	1964-01-29	38000177		0	0	14		0	0	0	126855	0	789980	19129655		
24075	1980	19128065	1992-08-06	1992-08-06 00:00:00	1993-08-01	1993-08-01 00:00:00	1993-08-01	38000177		0	0	360		0	0	0	131835	0	749882	19128065		
24122	1982	1713671	1963-12-05	1963-12-05 00:00:00	1963-12-12	1963-12-12 00:00:00	1963-12-12	38000177		0	0	7		0	0	0	131952	0	562251	1713671		
12776	1076	1118084	2013-08-19	2013-08-19 00:00:00	2013-08-19	2013-08-19 00:00:00	\N	38000177		0	0	0		0	0	0	70584	0	00025152531	44923712		
163853	3604	40213160	1984-08-10	1984-08-10 00:00:00	1984-08-10	1984-08-10 00:00:00	1984-08-10	581452		0	0	0		0	0	0	239460	0	10	40213160		
130375	2865	40213296	2008-02-04	2008-02-04 00:00:00	2008-02-04	2008-02-04 00:00:00	2008-02-04	581452		0	0	0		0	0	0	190587	0	52	40213296		
225160	4943	40213160	1961-05-10	1961-05-10 00:00:00	1961-05-10	1961-05-10 00:00:00	1961-05-10	581452		0	0	0		0	0	0	328578	0	10	40213160		
34014	743	40213160	1976-02-08	1976-02-08 00:00:00	1976-02-08	1976-02-08 00:00:00	1976-02-08	581452		0	0	0		0	0	0	49270	0	10	40213160		
32953	720	40213227	1995-11-25	1995-11-25 00:00:00	1995-11-25	1995-11-25 00:00:00	1995-11-25	581452		0	0	0		0	0	0	47648	0	113	40213227		
107185	2349	40213296	2012-04-15	2012-04-15 00:00:00	2012-04-15	2012-04-15 00:00:00	2012-04-15	581452		0	0	0		0	0	0	156361	0	52	40213296		
52558	1149	40213227	2001-10-30	2001-10-30 00:00:00	2001-10-30	2001-10-30 00:00:00	2001-10-30	581452		0	0	0		0	0	0	75975	0	113	40213227		
25223	2076	1713671	2016-07-25	2016-07-25 00:00:00	2016-11-07	2016-11-07 00:00:00	2016-11-07	38000177		0	0	105		0	0	0	138195	0	562251	1713671		
96418	2115	40213160	1962-06-04	1962-06-04 00:00:00	1962-06-04	1962-06-04 00:00:00	1962-06-04	581452		0	0	0		0	0	0	140763	0	10	40213160		
5161	431	1713671	1970-11-22	1970-11-22 00:00:00	1970-11-29	1970-11-29 00:00:00	1970-11-29	38000177		0	0	7		0	0	0	28568	0	562251	1713671		
161709	3558	40213160	1959-09-05	1959-09-05 00:00:00	1959-09-05	1959-09-05 00:00:00	1959-09-05	581452		0	0	0		0	0	0	236179	0	10	40213160		
56098	4656	1545959	2014-05-11	2014-05-11 00:00:00	2014-05-11	2014-05-11 00:00:00	2014-05-11	38000177		0	0	0		0	0	0	310472	0	259255	1545959		
10370	867	1127433	1973-05-15	1973-05-15 00:00:00	1973-05-22	1973-05-22 00:00:00	1973-05-22	38000177		0	0	7		0	0	0	57516	0	313782	1127433		
216989	4760	40213296	1996-11-06	1996-11-06 00:00:00	1996-11-06	1996-11-06 00:00:00	1996-11-06	581452		0	0	0		0	0	0	317170	0	52	40213296		
16991	1408	19059056	1972-09-24	1972-09-24 00:00:00	1972-10-08	1972-10-08 00:00:00	1972-10-08	38000177		0	0	14		0	0	0	93621	0	243670	19059056		
110740	2433	40213260	2006-01-29	2006-01-29 00:00:00	2006-01-29	2006-01-29 00:00:00	2006-01-29	581452		0	0	0		0	0	0	161297	0	121	40213260		
175215	3852	40213227	2003-02-03	2003-02-03 00:00:00	2003-02-03	2003-02-03 00:00:00	2003-02-03	581452		0	0	0		0	0	0	255700	0	113	40213227		
21079	1738	1124300	2013-02-27	2013-02-27 00:00:00	2013-02-27	2013-02-27 00:00:00	\N	38000177		0	0	0		0	0	0	116127	0	00781178901	45011828		
112708	2476	40213160	1961-09-13	1961-09-13 00:00:00	1961-09-13	1961-09-13 00:00:00	1961-09-13	581452		0	0	0		0	0	0	164086	0	10	40213160		
3283	72	40213227	2008-09-15	2008-09-15 00:00:00	2008-09-15	2008-09-15 00:00:00	2008-09-15	581452		0	0	0		0	0	0	4873	0	113	40213227		
54850	4557	1118084	1966-04-22	1966-04-22 00:00:00	1966-04-22	1966-04-22 00:00:00	\N	38000177		0	0	0		0	0	0	303596	0	00025152531	44923712		
19789	1627	19059056	1972-03-12	1972-03-12 00:00:00	1972-03-26	1972-03-26 00:00:00	1972-03-26	38000177		0	0	14		0	0	0	109372	0	243670	19059056		
124183	2731	40213306	1982-10-11	1982-10-11 00:00:00	1982-10-11	1982-10-11 00:00:00	1982-10-11	581452		0	0	0		0	0	0	180809	0	43	40213306		
91308	2004	40213160	1971-09-07	1971-09-07 00:00:00	1971-09-07	1971-09-07 00:00:00	1971-09-07	581452		0	0	0		0	0	0	133456	0	10	40213160		
227672	4999	40213227	2018-01-21	2018-01-21 00:00:00	2018-01-21	2018-01-21 00:00:00	2018-01-21	581452		0	0	0		0	0	0	332478	0	113	40213227		
37309	3082	1127433	2001-11-03	2001-11-03 00:00:00	2001-11-10	2001-11-10 00:00:00	2001-11-10	38000177		0	0	7		0	0	0	205231	0	313782	1127433		
33106	2745	19133873	1988-11-04	1988-11-04 00:00:00	1988-11-13	1988-11-13 00:00:00	1988-11-13	38000177		0	0	9		0	0	0	181564	0	834061	19133873		
51222	4256	1127433	1958-03-09	1958-03-09 00:00:00	1958-03-16	1958-03-16 00:00:00	1958-03-16	38000177		0	0	7		0	0	0	282580	0	313782	1127433		
52934	4398	1127433	1984-02-07	1984-02-07 00:00:00	1984-02-21	1984-02-21 00:00:00	1984-02-21	38000177		0	0	14		0	0	0	292389	0	313782	1127433		
172975	3803	40213296	2002-10-02	2002-10-02 00:00:00	2002-10-02	2002-10-02 00:00:00	2002-10-02	581452		0	0	0		0	0	0	252777	0	52	40213296		
23774	1954	19059056	1960-05-07	1960-05-07 00:00:00	1960-06-13	1960-06-13 00:00:00	1960-06-13	38000177		0	0	37		0	0	0	130035	0	243670	19059056		
189812	4167	40213160	1983-03-30	1983-03-30 00:00:00	1983-03-30	1983-03-30 00:00:00	1983-03-30	581452		0	0	0		0	0	0	276992	0	10	40213160		
219960	4827	40213160	1955-11-24	1955-11-24 00:00:00	1955-11-24	1955-11-24 00:00:00	1955-11-24	581452		0	0	0		0	0	0	321203	0	10	40213160		
16618	1378	40229134	1964-09-26	1964-09-26 00:00:00	1964-10-10	1964-10-10 00:00:00	1964-10-10	38000177		0	0	14		0	0	0	91293	0	1043400	40229134		
34398	2843	40162522	1990-12-31	1990-12-31 00:00:00	1990-12-31	1990-12-31 00:00:00	\N	38000177		0	0	0		0	0	0	188741	0	857005	40162522		
34442	2846	1115171	1996-12-28	1996-12-28 00:00:00	1997-02-01	1997-02-01 00:00:00	1997-02-01	38000177		0	0	35		0	0	0	188992	0	849574	1115171		
45212	3742	1713671	1996-09-01	1996-09-01 00:00:00	1996-09-22	1996-09-22 00:00:00	1996-09-22	38000177		0	0	21		0	0	0	248681	0	562251	1713671		
10076	844	19059056	1967-12-14	1967-12-14 00:00:00	1967-12-28	1967-12-28 00:00:00	1967-12-28	38000177		0	0	14		0	0	0	55969	0	243670	19059056		
60537	1323	40213296	2003-05-17	2003-05-17 00:00:00	2003-05-17	2003-05-17 00:00:00	2003-05-17	581452		0	0	0		0	0	0	87859	0	52	40213296		
17711	1467	1713671	1942-11-01	1942-11-01 00:00:00	1942-11-15	1942-11-15 00:00:00	1942-11-15	38000177		0	0	14		0	0	0	97696	0	562251	1713671		
55852	4636	19059056	1950-11-24	1950-11-24 00:00:00	1950-12-08	1950-12-08 00:00:00	1950-12-08	38000177		0	0	14		0	0	0	309007	0	243670	19059056		
55893	4639	19133873	1984-05-30	1984-05-30 00:00:00	1984-06-10	1984-06-10 00:00:00	1984-06-10	38000177		0	0	11		0	0	0	309233	0	834061	19133873		
35110	2897	1124300	2003-11-06	2003-11-06 00:00:00	2003-11-06	2003-11-06 00:00:00	\N	38000177		0	0	0		0	0	0	192908	0	00781178901	45011828		
21441	1762	40169281	1964-03-12	1964-03-12 00:00:00	1964-03-12	1964-03-12 00:00:00	\N	38000177		0	0	0		0	0	0	117888	0	896209	40169281		
10764	895	19126352	1980-02-29	1980-02-29 00:00:00	1980-02-29	1980-02-29 00:00:00	\N	38000177		0	0	0		0	0	0	59740	0	705129	19126352		
48544	4021	19128065	1974-12-08	1974-12-08 00:00:00	1975-12-03	1975-12-03 00:00:00	1975-12-03	38000177		0	0	360		0	0	0	267284	0	749882	19128065		
192536	4229	40213227	1995-03-04	1995-03-04 00:00:00	1995-03-04	1995-03-04 00:00:00	1995-03-04	581452		0	0	0		0	0	0	280930	0	113	40213227		
56275	4670	1127433	1964-03-18	1964-03-18 00:00:00	1964-03-25	1964-03-25 00:00:00	1964-03-25	38000177		0	0	7		0	0	0	311203	0	313782	1127433		
59126	4913	1713671	2005-11-29	2005-11-29 00:00:00	2005-12-06	2005-12-06 00:00:00	2005-12-06	38000177		0	0	7		0	0	0	326533	0	562251	1713671		
49641	4117	1713671	1967-09-25	1967-09-25 00:00:00	1967-10-09	1967-10-09 00:00:00	1967-10-09	38000177		0	0	14		0	0	0	273691	0	562251	1713671		
41578	906	40213314	1977-02-08	1977-02-08 00:00:00	1977-02-08	1977-02-08 00:00:00	1977-02-08	581452		0	0	0		0	0	0	60280	0	49	40213314		
150697	3314	40213306	1986-08-16	1986-08-16 00:00:00	1986-08-16	1986-08-16 00:00:00	1986-08-16	581452		0	0	0		0	0	0	\N	0	43	40213306		
176714	3885	40213160	1963-04-26	1963-04-26 00:00:00	1963-04-26	1963-04-26 00:00:00	1963-04-26	581452		0	0	0		0	0	0	258233	0	10	40213160		
50150	4160	19073188	1989-02-18	1989-02-18 00:00:00	1989-03-18	1989-03-18 00:00:00	1989-03-18	38000177		0	0	28		0	0	0	276451	0	308192	19073188		
6680	145	40213198	2014-02-25	2014-02-25 00:00:00	2014-02-25	2014-02-25 00:00:00	2014-02-25	581452		0	0	0		0	0	0	9693	0	133	40213198		
59347	4932	40229134	1967-02-18	1967-02-18 00:00:00	1967-03-04	1967-03-04 00:00:00	1967-03-04	38000177		0	0	14		0	0	0	327862	0	1043400	40229134		
165547	3639	40213201	1988-05-07	1988-05-07 00:00:00	1988-05-07	1988-05-07 00:00:00	1988-05-07	581452		0	0	0		0	0	0	242077	0	33	40213201		
24890	2046	1127433	2005-06-18	2005-06-18 00:00:00	2005-07-02	2005-07-02 00:00:00	2005-07-02	38000177		0	0	14		0	0	0	136178	0	313782	1127433		
193330	4247	40213251	1988-02-27	1988-02-27 00:00:00	1988-02-27	1988-02-27 00:00:00	1988-02-27	581452		0	0	0		0	0	0	282093	0	21	40213251		
13536	1134	19133873	1940-07-26	1940-07-26 00:00:00	1940-08-05	1940-08-05 00:00:00	1940-08-05	38000177		0	0	10		0	0	0	74661	0	834061	19133873		
23121	1906	1127078	1964-01-15	1964-01-15 00:00:00	1964-01-29	1964-01-29 00:00:00	1964-01-29	38000177		0	0	14		0	0	0	126855	0	282464	1127078		
24098	1982	40229134	1987-08-16	1987-08-16 00:00:00	1987-08-30	1987-08-30 00:00:00	1987-08-30	38000177		0	0	14		0	0	0	131957	0	1043400	40229134		
24123	1982	1713671	1925-01-01	1925-01-01 00:00:00	1925-01-22	1925-01-22 00:00:00	1925-01-22	38000177		0	0	21		0	0	0	131997	0	562251	1713671		
12777	1076	1127433	1976-04-10	1976-04-10 00:00:00	1976-04-17	1976-04-17 00:00:00	1976-04-17	38000177		0	0	7		0	0	0	70565	0	313782	1127433		
163855	3604	40213251	1985-07-12	1985-07-12 00:00:00	1985-07-12	1985-07-12 00:00:00	1985-07-12	581452		0	0	0		0	0	0	239505	0	21	40213251		
130376	2865	40213160	1968-05-06	1968-05-06 00:00:00	1968-05-06	1968-05-06 00:00:00	1968-05-06	581452		0	0	0		0	0	0	190604	0	10	40213160		
225164	4943	40213160	1966-01-12	1966-01-12 00:00:00	1966-01-12	1966-01-12 00:00:00	1966-01-12	581452		0	0	0		0	0	0	328548	0	10	40213160		
34017	743	40213227	2017-10-08	2017-10-08 00:00:00	2017-10-08	2017-10-08 00:00:00	2017-10-08	581452		0	0	0		0	0	0	49233	0	113	40213227		
32958	720	40213227	2006-09-09	2006-09-09 00:00:00	2006-09-09	2006-09-09 00:00:00	2006-09-09	581452		0	0	0		0	0	0	47628	0	113	40213227		
107188	2349	40213227	2003-06-22	2003-06-22 00:00:00	2003-06-22	2003-06-22 00:00:00	2003-06-22	581452		0	0	0		0	0	0	156407	0	113	40213227		
52561	1149	40213227	2010-11-09	2010-11-09 00:00:00	2010-11-09	2010-11-09 00:00:00	2010-11-09	581452		0	0	0		0	0	0	75943	0	113	40213227		
25224	2076	1127433	1984-04-16	1984-04-16 00:00:00	1984-04-23	1984-04-23 00:00:00	1984-04-23	38000177		0	0	7		0	0	0	138144	0	313782	1127433		
96421	2115	40213227	2003-10-06	2003-10-06 00:00:00	2003-10-06	2003-10-06 00:00:00	2003-10-06	581452		0	0	0		0	0	0	140719	0	113	40213227		
5162	431	1118084	1985-01-06	1985-01-06 00:00:00	1985-01-06	1985-01-06 00:00:00	\N	38000177		0	0	0		0	0	0	28621	0	00025152531	44923712		
161715	3558	40213296	1999-04-03	1999-04-03 00:00:00	1999-04-03	1999-04-03 00:00:00	1999-04-03	581452		0	0	0		0	0	0	236211	0	52	40213296		
56099	4656	1539411	1991-09-22	1991-09-22 00:00:00	1991-09-22	1991-09-22 00:00:00	\N	38000177		0	0	0		0	0	0	310437	0	312961	1539411		
10371	867	19075601	2016-08-23	2016-08-23 00:00:00	2016-08-23	2016-08-23 00:00:00	\N	38000177		0	0	0		0	0	0	57617	0	309362	19075601		
216998	4761	40213160	1981-01-12	1981-01-12 00:00:00	1981-01-12	1981-01-12 00:00:00	1981-01-12	581452		0	0	0		0	0	0	317254	0	10	40213160		
16992	1408	1713671	1982-07-18	1982-07-18 00:00:00	1982-11-07	1982-11-07 00:00:00	1982-11-07	38000177		0	0	112		0	0	0	93642	0	562251	1713671		
110762	2433	40213198	2018-04-08	2018-04-08 00:00:00	2018-04-08	2018-04-08 00:00:00	2018-04-08	581452		0	0	0		0	0	0	161336	0	133	40213198		
175224	3852	40213227	2013-04-01	2013-04-01 00:00:00	2013-04-01	2013-04-01 00:00:00	2013-04-01	581452		0	0	0		0	0	0	255692	0	113	40213227		
21080	1738	1713671	1991-04-06	1991-04-06 00:00:00	1991-04-13	1991-04-13 00:00:00	1991-04-13	38000177		0	0	7		0	0	0	116131	0	562251	1713671		
112709	2476	40213160	1957-03-13	1957-03-13 00:00:00	1957-03-13	1957-03-13 00:00:00	1957-03-13	581452		0	0	0		0	0	0	164083	0	10	40213160		
3293	72	40213227	1998-07-20	1998-07-20 00:00:00	1998-07-20	1998-07-20 00:00:00	1998-07-20	581452		0	0	0		0	0	0	4851	0	113	40213227		
54851	4557	1713671	1996-06-25	1996-06-25 00:00:00	1996-07-09	1996-07-09 00:00:00	1996-07-09	38000177		0	0	14		0	0	0	303656	0	562251	1713671		
19791	1627	19128065	1977-04-08	1977-04-08 00:00:00	1978-04-03	1978-04-03 00:00:00	1978-04-03	38000177		0	0	360		0	0	0	109299	0	749882	19128065		
124186	2731	40213160	1960-12-19	1960-12-19 00:00:00	1960-12-19	1960-12-19 00:00:00	1960-12-19	581452		0	0	0		0	0	0	180781	0	10	40213160		
91309	2004	40213227	2013-06-11	2013-06-11 00:00:00	2013-06-11	2013-06-11 00:00:00	2013-06-11	581452		0	0	0		0	0	0	133435	0	113	40213227		
42289	3508	1127433	1971-12-20	1971-12-20 00:00:00	1971-12-27	1971-12-27 00:00:00	1971-12-27	38000177		0	0	7		0	0	0	232662	0	313782	1127433		
37311	3083	1115171	2004-10-20	2004-10-20 00:00:00	2004-11-03	2004-11-03 00:00:00	2004-11-03	38000177		0	0	14		0	0	0	205352	0	849574	1115171		
33107	2745	1713671	2005-10-06	2005-10-06 00:00:00	2005-10-13	2005-10-13 00:00:00	2005-10-13	38000177		0	0	7		0	0	0	181579	0	562251	1713671		
51223	4256	19078461	1974-09-10	1974-09-10 00:00:00	1974-10-01	1974-10-01 00:00:00	1974-10-01	38000177		0	0	21		0	0	0	282634	0	310965	19078461		
52935	4398	19133873	1964-01-25	1964-01-25 00:00:00	1964-02-03	1964-02-03 00:00:00	1964-02-03	38000177		0	0	9		0	0	0	292462	0	834061	19133873		
172978	3803	40213160	1960-07-20	1960-07-20 00:00:00	1960-07-20	1960-07-20 00:00:00	1960-07-20	581452		0	0	0		0	0	0	252760	0	10	40213160		
23775	1954	1127433	1972-11-07	1972-11-07 00:00:00	1972-12-12	1972-12-12 00:00:00	1972-12-12	38000177		0	0	35		0	0	0	130037	0	313782	1127433		
189813	4167	40213314	1979-11-28	1979-11-28 00:00:00	1979-11-28	1979-11-28 00:00:00	1979-11-28	581452		0	0	0		0	0	0	276932	0	49	40213314		
219962	4828	40213260	2017-05-10	2017-05-10 00:00:00	2017-05-10	2017-05-10 00:00:00	2017-05-10	581452		0	0	0		0	0	0	321282	0	121	40213260		
16619	1378	19133905	1967-03-15	1967-03-15 00:00:00	1967-03-23	1967-03-23 00:00:00	1967-03-23	38000177		0	0	8		0	0	0	91294	0	834102	19133905		
34399	2843	1127078	1964-10-04	1964-10-04 00:00:00	1964-10-18	1964-10-18 00:00:00	1964-10-18	38000177		0	0	14		0	0	0	188739	0	282464	1127078		
34443	2846	19078461	1990-04-20	1990-04-20 00:00:00	1990-05-04	1990-05-04 00:00:00	1990-05-04	38000177		0	0	14		0	0	0	188991	0	310965	19078461		
45213	3742	1118084	2010-09-18	2010-09-18 00:00:00	2010-09-18	2010-09-18 00:00:00	\N	38000177		0	0	0		0	0	0	248656	0	00025152531	44923712		
56901	1245	40213227	1995-11-10	1995-11-10 00:00:00	1995-11-10	1995-11-10 00:00:00	1995-11-10	581452		0	0	0		0	0	0	81930	0	113	40213227		
62369	5191	1127078	1977-08-18	1977-08-18 00:00:00	1977-09-08	1977-09-08 00:00:00	1977-09-08	38000177		0	0	21		0	0	0	345061	0	282464	1127078		
17712	1467	1713671	1983-10-11	1983-10-11 00:00:00	1983-10-25	1983-10-25 00:00:00	1983-10-25	38000177		0	0	14		0	0	0	97671	0	562251	1713671		
55853	4636	19006318	1950-11-24	1950-11-24 00:00:00	1950-12-08	1950-12-08 00:00:00	1950-12-08	38000177		0	0	14		0	0	0	309007	0	105078	19006318		
55894	4639	19128065	1988-01-27	1988-01-27 00:00:00	1989-01-21	1989-01-21 00:00:00	1989-01-21	38000177		0	0	360		0	0	0	309195	0	749882	19128065		
35111	2897	1127433	1974-06-22	1974-06-22 00:00:00	1974-06-29	1974-06-29 00:00:00	1974-06-29	38000177		0	0	7		0	0	0	192937	0	313782	1127433		
21442	1762	1713671	1989-05-25	1989-05-25 00:00:00	1989-06-15	1989-06-15 00:00:00	1989-06-15	38000177		0	0	21		0	0	0	117803	0	562251	1713671		
10765	895	19133905	2007-08-11	2007-08-11 00:00:00	2007-08-22	2007-08-22 00:00:00	2007-08-22	38000177		0	0	11		0	0	0	59674	0	834102	19133905		
48545	4021	1127078	1961-09-03	1961-09-03 00:00:00	1961-11-02	1961-11-02 00:00:00	1961-11-02	38000177		0	0	60		0	0	0	267310	0	282464	1127078		
192538	4229	40213260	2006-06-24	2006-06-24 00:00:00	2006-06-24	2006-06-24 00:00:00	2006-06-24	581452		0	0	0		0	0	0	280965	0	121	40213260		
56276	4670	19059056	1954-05-30	1954-05-30 00:00:00	1954-06-13	1954-06-13 00:00:00	1954-06-13	38000177		0	0	14		0	0	0	311165	0	243670	19059056		
59127	4913	19133905	2018-03-02	2018-03-02 00:00:00	2018-03-12	2018-03-12 00:00:00	2018-03-12	38000177		0	0	10		0	0	0	326534	0	834102	19133905		
49642	4117	1127433	2012-06-30	2012-06-30 00:00:00	2012-07-07	2012-07-07 00:00:00	2012-07-07	38000177		0	0	7		0	0	0	273695	0	313782	1127433		
154864	3409	40213160	1955-09-22	1955-09-22 00:00:00	1955-09-22	1955-09-22 00:00:00	1955-09-22	581452		0	0	0		0	0	0	226127	0	10	40213160		
150703	3314	40213160	1967-08-19	1967-08-19 00:00:00	1967-08-19	1967-08-19 00:00:00	1967-08-19	581452		0	0	0		0	0	0	220059	0	10	40213160		
176715	3885	40213160	1963-07-26	1963-07-26 00:00:00	1963-07-26	1963-07-26 00:00:00	1963-07-26	581452		0	0	0		0	0	0	258262	0	10	40213160		
50151	4160	19059056	1989-02-18	1989-02-18 00:00:00	1989-03-18	1989-03-18 00:00:00	1989-03-18	38000177		0	0	28		0	0	0	276451	0	243670	19059056		
6685	145	40213227	1999-12-07	1999-12-07 00:00:00	1999-12-07	1999-12-07 00:00:00	1999-12-07	581452		0	0	0		0	0	0	9743	0	113	40213227		
59348	4932	1713671	2005-04-24	2005-04-24 00:00:00	2005-05-08	2005-05-08 00:00:00	2005-05-08	38000177		0	0	14		0	0	0	327857	0	562251	1713671		
196668	4321	40213260	2014-11-16	2014-11-16 00:00:00	2014-11-16	2014-11-16 00:00:00	2014-11-16	581452		0	0	0		0	0	0	286767	0	121	40213260		
24891	2046	1118084	1984-11-29	1984-11-29 00:00:00	1984-11-29	1984-11-29 00:00:00	\N	38000177		0	0	0		0	0	0	136140	0	00025152531	44923712		
173586	3817	40213227	2007-07-06	2007-07-06 00:00:00	2007-07-06	2007-07-06 00:00:00	2007-07-06	581452		0	0	0		0	0	0	253482	0	113	40213227		
13537	1134	19059056	1947-07-19	1947-07-19 00:00:00	1947-08-18	1947-08-18 00:00:00	1947-08-18	38000177		0	0	30		0	0	0	74729	0	243670	19059056		
23122	1906	1713671	1968-08-13	1968-08-13 00:00:00	1968-08-27	1968-08-27 00:00:00	1968-08-27	38000177		0	0	14		0	0	0	126869	0	562251	1713671		
24099	1982	1713671	1960-12-06	1960-12-06 00:00:00	1960-12-13	1960-12-13 00:00:00	1960-12-13	38000177		0	0	7		0	0	0	132033	0	562251	1713671		
24124	1982	40229134	1939-03-25	1939-03-25 00:00:00	1939-04-08	1939-04-08 00:00:00	1939-04-08	38000177		0	0	14		0	0	0	131948	0	1043400	40229134		
12778	1076	19128022	1989-04-27	1989-04-27 00:00:00	1990-04-22	1990-04-22 00:00:00	1990-04-22	38000177		0	0	360		0	0	0	70531	0	749785	19128022		
163857	3604	40213314	1985-07-12	1985-07-12 00:00:00	1985-07-12	1985-07-12 00:00:00	1985-07-12	581452		0	0	0		0	0	0	239505	0	49	40213314		
130379	2865	40213160	1968-07-08	1968-07-08 00:00:00	1968-07-08	1968-07-08 00:00:00	1968-07-08	581452		0	0	0		0	0	0	190591	0	10	40213160		
236460	5193	40213296	2000-08-31	2000-08-31 00:00:00	2000-08-31	2000-08-31 00:00:00	2000-08-31	581452		0	0	0		0	0	0	345227	0	52	40213296		
34018	743	40213296	2017-10-08	2017-10-08 00:00:00	2017-10-08	2017-10-08 00:00:00	2017-10-08	581452		0	0	0		0	0	0	49233	0	52	40213296		
32959	720	40213296	2006-09-09	2006-09-09 00:00:00	2006-09-09	2006-09-09 00:00:00	2006-09-09	581452		0	0	0		0	0	0	47628	0	52	40213296		
107195	2349	40213160	1972-07-16	1972-07-16 00:00:00	1972-07-16	1972-07-16 00:00:00	1972-07-16	581452		0	0	0		0	0	0	156335	0	10	40213160		
159430	3509	40213227	2003-03-21	2003-03-21 00:00:00	2003-03-21	2003-03-21 00:00:00	2003-03-21	581452		0	0	0		0	0	0	232746	0	113	40213227		
25225	2076	1127433	1972-07-02	1972-07-02 00:00:00	1972-07-09	1972-07-09 00:00:00	1972-07-09	38000177		0	0	7		0	0	0	138143	0	313782	1127433		
96422	2115	40213296	2003-10-06	2003-10-06 00:00:00	2003-10-06	2003-10-06 00:00:00	2003-10-06	581452		0	0	0		0	0	0	140719	0	52	40213296		
5163	431	1127433	1964-11-03	1964-11-03 00:00:00	1964-11-10	1964-11-10 00:00:00	1964-11-10	38000177		0	0	7		0	0	0	28566	0	313782	1127433		
161718	3558	40213160	1959-12-05	1959-12-05 00:00:00	1959-12-05	1959-12-05 00:00:00	1959-12-05	581452		0	0	0		0	0	0	236221	0	10	40213160		
56100	4657	40236824	1987-11-04	1987-11-04 00:00:00	1987-11-11	1987-11-11 00:00:00	1987-11-11	38000177		0	0	7		0	0	0	310552	0	1094107	40236824		
10372	867	19126352	2014-08-12	2014-08-12 00:00:00	2014-08-12	2014-08-12 00:00:00	\N	38000177		0	0	0		0	0	0	57616	0	705129	19126352		
217001	4761	40213306	2000-08-28	2000-08-28 00:00:00	2000-08-28	2000-08-28 00:00:00	2000-08-28	581452		0	0	0		0	0	0	\N	0	43	40213306		
16993	1408	19126352	2015-03-23	2015-03-23 00:00:00	2015-03-23	2015-03-23 00:00:00	\N	38000177		0	0	0		0	0	0	93607	0	705129	19126352		
110764	2433	40213227	2014-03-16	2014-03-16 00:00:00	2014-03-16	2014-03-16 00:00:00	2014-03-16	581452		0	0	0		0	0	0	161315	0	113	40213227		
175233	3852	40213227	1993-10-11	1993-10-11 00:00:00	1993-10-11	1993-10-11 00:00:00	1993-10-11	581452		0	0	0		0	0	0	255663	0	113	40213227		
21081	1738	1127433	1979-05-03	1979-05-03 00:00:00	1979-05-17	1979-05-17 00:00:00	1979-05-17	38000177		0	0	14		0	0	0	116101	0	313782	1127433		
112714	2476	40213227	2007-10-10	2007-10-10 00:00:00	2007-10-10	2007-10-10 00:00:00	2007-10-10	581452		0	0	0		0	0	0	164093	0	113	40213227		
29280	639	40213201	2019-05-18	2019-05-18 00:00:00	2019-05-18	2019-05-18 00:00:00	2019-05-18	581452		0	0	0		0	0	0	42266	0	33	40213201		
54852	4557	1127433	2001-11-15	2001-11-15 00:00:00	2002-02-13	2002-02-13 00:00:00	2002-02-13	38000177		0	0	90		0	0	0	303644	0	313782	1127433		
19792	1627	19059056	1964-12-24	1964-12-24 00:00:00	1965-01-23	1965-01-23 00:00:00	1965-01-23	38000177		0	0	30		0	0	0	109349	0	243670	19059056		
124188	2731	40213227	2002-10-21	2002-10-21 00:00:00	2002-10-21	2002-10-21 00:00:00	2002-10-21	581452		0	0	0		0	0	0	180812	0	113	40213227		
91310	2004	40213296	2013-06-11	2013-06-11 00:00:00	2013-06-11	2013-06-11 00:00:00	2013-06-11	581452		0	0	0		0	0	0	133435	0	52	40213296		
42290	3508	19059056	1966-08-08	1966-08-08 00:00:00	1966-10-07	1966-10-07 00:00:00	1966-10-07	38000177		0	0	60		0	0	0	232692	0	243670	19059056		
37312	3083	19133905	1996-11-13	1996-11-13 00:00:00	1996-11-24	1996-11-24 00:00:00	1996-11-24	38000177		0	0	11		0	0	0	205264	0	834102	19133905		
33108	2745	19078461	2004-12-13	2004-12-13 00:00:00	2005-01-10	2005-01-10 00:00:00	2005-01-10	38000177		0	0	28		0	0	0	181577	0	310965	19078461		
51224	4256	1127078	1961-04-21	1961-04-21 00:00:00	1961-06-20	1961-06-20 00:00:00	1961-06-20	38000177		0	0	60		0	0	0	282588	0	282464	1127078		
52936	4398	1127433	1998-04-28	1998-04-28 00:00:00	1998-05-26	1998-05-26 00:00:00	1998-05-26	38000177		0	0	28		0	0	0	292435	0	313782	1127433		
172987	3803	40213227	1992-09-16	1992-09-16 00:00:00	1992-09-16	1992-09-16 00:00:00	1992-09-16	581452		0	0	0		0	0	0	252784	0	113	40213227		
23776	1954	19006318	1972-11-07	1972-11-07 00:00:00	1972-12-12	1972-12-12 00:00:00	1972-12-12	38000177		0	0	35		0	0	0	130037	0	105078	19006318		
72159	1577	40213201	1988-12-02	1988-12-02 00:00:00	1988-12-02	1988-12-02 00:00:00	1988-12-02	581452		0	0	0		0	0	0	105855	0	33	40213201		
219963	4828	40213160	1967-10-18	1967-10-18 00:00:00	1967-10-18	1967-10-18 00:00:00	1967-10-18	581452		0	0	0		0	0	0	321257	0	10	40213160		
16620	1378	1713671	1962-06-11	1962-06-11 00:00:00	1962-06-25	1962-06-25 00:00:00	1962-06-25	38000177		0	0	14		0	0	0	91292	0	562251	1713671		
34400	2843	19006318	1962-07-17	1962-07-17 00:00:00	1962-07-31	1962-07-31 00:00:00	1962-07-31	38000177		0	0	14		0	0	0	188794	0	105078	19006318		
34444	2846	40236824	2016-07-26	2016-07-26 00:00:00	2016-08-09	2016-08-09 00:00:00	2016-08-09	38000177		0	0	14		0	0	0	189037	0	1094107	40236824		
45214	3742	19059056	1972-07-04	1972-07-04 00:00:00	1972-07-18	1972-07-18 00:00:00	1972-07-18	38000177		0	0	14		0	0	0	248682	0	243670	19059056		
12501	270	40213160	1963-01-15	1963-01-15 00:00:00	1963-01-15	1963-01-15 00:00:00	1963-01-15	581452		0	0	0		0	0	0	18002	0	10	40213160		
62370	5191	1118084	2012-11-27	2012-11-27 00:00:00	2012-11-27	2012-11-27 00:00:00	\N	38000177		0	0	0		0	0	0	345070	0	00025152531	44923712		
17713	1467	1127433	1944-02-29	1944-02-29 00:00:00	1944-03-07	1944-03-07 00:00:00	1944-03-07	38000177		0	0	7		0	0	0	97670	0	313782	1127433		
55854	4636	1124300	1986-10-26	1986-10-26 00:00:00	1986-10-26	1986-10-26 00:00:00	\N	38000177		0	0	0		0	0	0	308958	0	00781178901	45011828		
55895	4639	19128022	1992-01-06	1992-01-06 00:00:00	1992-12-31	1992-12-31 00:00:00	1992-12-31	38000177		0	0	360		0	0	0	309198	0	749785	19128022		
35112	2897	1713671	1984-07-26	1984-07-26 00:00:00	1984-08-09	1984-08-09 00:00:00	1984-08-09	38000177		0	0	14		0	0	0	192949	0	562251	1713671		
21443	1762	40171902	1998-04-09	1998-04-09 00:00:00	1998-04-09	1998-04-09 00:00:00	\N	38000177		0	0	0		0	0	0	117826	0	897718	40171902		
10766	895	1539411	1993-01-08	1993-01-08 00:00:00	1993-01-08	1993-01-08 00:00:00	\N	38000177		0	0	0		0	0	0	59743	0	312961	1539411		
48546	4021	1118084	1992-05-22	1992-05-22 00:00:00	1992-05-22	1992-05-22 00:00:00	\N	38000177		0	0	0		0	0	0	267280	0	00025152531	44923712		
192541	4229	40213160	1955-12-03	1955-12-03 00:00:00	1955-12-03	1955-12-03 00:00:00	1955-12-03	581452		0	0	0		0	0	0	280938	0	10	40213160		
56277	4670	1127433	1962-03-21	1962-03-21 00:00:00	1962-03-28	1962-03-28 00:00:00	1962-03-28	38000177		0	0	7		0	0	0	311192	0	313782	1127433		
27677	603	40213296	1999-12-03	1999-12-03 00:00:00	1999-12-03	1999-12-03 00:00:00	1999-12-03	581452		0	0	0		0	0	0	39985	0	52	40213296		
49643	4117	1127078	1964-05-07	1964-05-07 00:00:00	1964-05-21	1964-05-21 00:00:00	1964-05-21	38000177		0	0	14		0	0	0	273696	0	282464	1127078		
154875	3409	40213227	2006-12-14	2006-12-14 00:00:00	2006-12-14	2006-12-14 00:00:00	2006-12-14	581452		0	0	0		0	0	0	226106	0	113	40213227		
150708	3315	40213227	2018-06-30	2018-06-30 00:00:00	2018-06-30	2018-06-30 00:00:00	2018-06-30	581452		0	0	0		0	0	0	220143	0	113	40213227		
176716	3885	40213160	1967-10-27	1967-10-27 00:00:00	1967-10-27	1967-10-27 00:00:00	1967-10-27	581452		0	0	0		0	0	0	258291	0	10	40213160		
50152	4160	1127433	1991-05-14	1991-05-14 00:00:00	1991-05-21	1991-05-21 00:00:00	1991-05-21	38000177		0	0	7		0	0	0	276415	0	313782	1127433		
6692	145	40213227	2010-02-02	2010-02-02 00:00:00	2010-02-02	2010-02-02 00:00:00	2010-02-02	581452		0	0	0		0	0	0	9681	0	113	40213227		
59349	4932	1127433	2016-09-09	2016-09-09 00:00:00	2016-09-16	2016-09-16 00:00:00	2016-09-16	38000177		0	0	7		0	0	0	327842	0	313782	1127433		
196677	4321	40213260	2013-11-10	2013-11-10 00:00:00	2013-11-10	2013-11-10 00:00:00	2013-11-10	581452		0	0	0		0	0	0	286730	0	121	40213260		
24892	2046	19078461	2003-08-13	2003-08-13 00:00:00	2003-08-27	2003-08-27 00:00:00	2003-08-27	38000177		0	0	14		0	0	0	136160	0	310965	19078461		
173587	3817	40213296	2007-07-06	2007-07-06 00:00:00	2007-07-06	2007-07-06 00:00:00	2007-07-06	581452		0	0	0		0	0	0	253482	0	52	40213296		
13538	1134	1115171	2013-07-02	2013-07-02 00:00:00	2013-08-01	2013-08-01 00:00:00	2013-08-01	38000177		0	0	30		0	0	0	74731	0	849574	1115171		
23123	1906	40229134	1975-10-27	1975-10-27 00:00:00	1975-11-03	1975-11-03 00:00:00	1975-11-03	38000177		0	0	7		0	0	0	126865	0	1043400	40229134		
24100	1982	1127433	1996-07-17	1996-07-17 00:00:00	1996-07-24	1996-07-24 00:00:00	1996-07-24	38000177		0	0	7		0	0	0	132022	0	313782	1127433		
24125	1982	19126352	1976-09-23	1976-09-23 00:00:00	2006-10-19	2006-10-19 00:00:00	2006-10-19	38000177		0	0	10983		0	0	0	132061	0	705129	19126352		
15555	1297	1713671	1979-10-27	1979-10-27 00:00:00	1979-11-10	1979-11-10 00:00:00	1979-11-10	38000177		0	0	14		0	0	0	85716	0	562251	1713671		
163861	3604	40213251	1989-04-14	1989-04-14 00:00:00	1989-04-14	1989-04-14 00:00:00	1989-04-14	581452		0	0	0		0	0	0	239508	0	21	40213251		
130390	2865	40213227	2019-02-04	2019-02-04 00:00:00	2019-02-04	2019-02-04 00:00:00	2019-02-04	581452		0	0	0		0	0	0	190615	0	113	40213227		
236468	5193	40213296	2002-09-05	2002-09-05 00:00:00	2002-09-05	2002-09-05 00:00:00	2002-09-05	581452		0	0	0		0	0	0	345216	0	52	40213296		
34022	743	40213160	1976-07-11	1976-07-11 00:00:00	1976-07-11	1976-07-11 00:00:00	1976-07-11	581452		0	0	0		0	0	0	49271	0	10	40213160		
32961	720	40213306	1986-11-01	1986-11-01 00:00:00	1986-11-01	1986-11-01 00:00:00	1986-11-01	581452		0	0	0		0	0	0	47646	0	43	40213306		
221570	4861	40213227	2008-05-27	2008-05-27 00:00:00	2008-05-27	2008-05-27 00:00:00	2008-05-27	581452		0	0	0		0	0	0	323349	0	113	40213227		
159442	3509	40213201	2008-04-18	2008-04-18 00:00:00	2008-04-18	2008-04-18 00:00:00	2008-04-18	581452		0	0	0		0	0	0	232732	0	33	40213201		
25226	2076	19133873	1982-12-07	1982-12-07 00:00:00	1982-12-18	1982-12-18 00:00:00	1982-12-18	38000177		0	0	11		0	0	0	138192	0	834061	19133873		
96431	2115	40213227	2012-10-01	2012-10-01 00:00:00	2012-10-01	2012-10-01 00:00:00	2012-10-01	581452		0	0	0		0	0	0	140721	0	113	40213227		
5164	431	1127433	1967-01-21	1967-01-21 00:00:00	1967-02-25	1967-02-25 00:00:00	1967-02-25	38000177		0	0	35		0	0	0	28594	0	313782	1127433		
161719	3558	40213160	1959-07-04	1959-07-04 00:00:00	1959-07-04	1959-07-04 00:00:00	1959-07-04	581452		0	0	0		0	0	0	236192	0	10	40213160		
56101	4657	920300	1987-11-04	1987-11-04 00:00:00	1987-11-11	1987-11-11 00:00:00	1987-11-11	38000177		0	0	7		0	0	0	310552	0	311989	920300		
10373	867	1539411	2014-08-12	2014-08-12 00:00:00	2014-08-12	2014-08-12 00:00:00	\N	38000177		0	0	0		0	0	0	57616	0	312961	1539411		
217006	4761	40213251	1984-04-09	1984-04-09 00:00:00	1984-04-09	1984-04-09 00:00:00	1984-04-09	581452		0	0	0		0	0	0	317255	0	21	40213251		
16994	1408	19075601	2015-03-23	2015-03-23 00:00:00	2015-03-23	2015-03-23 00:00:00	\N	38000177		0	0	0		0	0	0	93607	0	309362	19075601		
121811	2677	40213160	1972-09-23	1972-09-23 00:00:00	1972-09-23	1972-09-23 00:00:00	1972-09-23	581452		0	0	0		0	0	0	177393	0	10	40213160		
192395	4226	40213306	1986-03-23	1986-03-23 00:00:00	1986-03-23	1986-03-23 00:00:00	1986-03-23	581452		0	0	0		0	0	0	280719	0	43	40213306		
21082	1738	19073188	2014-12-19	2014-12-19 00:00:00	2015-01-02	2015-01-02 00:00:00	2015-01-02	38000177		0	0	14		0	0	0	116168	0	308192	19073188		
112715	2476	40213260	2007-10-10	2007-10-10 00:00:00	2007-10-10	2007-10-10 00:00:00	2007-10-10	581452		0	0	0		0	0	0	164093	0	121	40213260		
29284	639	40213227	2014-04-19	2014-04-19 00:00:00	2014-04-19	2014-04-19 00:00:00	2014-04-19	581452		0	0	0		0	0	0	42267	0	113	40213227		
54853	4557	19059056	1932-10-03	1932-10-03 00:00:00	1932-10-31	1932-10-31 00:00:00	1932-10-31	38000177		0	0	28		0	0	0	303638	0	243670	19059056		
19794	1627	1127433	1977-01-13	1977-01-13 00:00:00	1977-01-27	1977-01-27 00:00:00	1977-01-27	38000177		0	0	14		0	0	0	109331	0	313782	1127433		
124189	2731	40213296	2002-10-21	2002-10-21 00:00:00	2002-10-21	2002-10-21 00:00:00	2002-10-21	581452		0	0	0		0	0	0	180812	0	52	40213296		
91315	2004	40213160	1976-05-11	1976-05-11 00:00:00	1976-05-11	1976-05-11 00:00:00	1976-05-11	581452		0	0	0		0	0	0	133426	0	10	40213160		
42291	3508	19129655	1961-09-20	1961-09-20 00:00:00	1961-10-04	1961-10-04 00:00:00	1961-10-04	38000177		0	0	14		0	0	0	232629	0	789980	19129655		
37313	3083	1127433	1997-02-15	1997-02-15 00:00:00	1997-03-01	1997-03-01 00:00:00	1997-03-01	38000177		0	0	14		0	0	0	205351	0	313782	1127433		
33121	2747	19133873	1980-10-28	1980-10-28 00:00:00	1980-11-04	1980-11-04 00:00:00	1980-11-04	38000177		0	0	7		0	0	0	181715	0	834061	19133873		
233061	5121	40213260	2014-12-12	2014-12-12 00:00:00	2014-12-12	2014-12-12 00:00:00	2014-12-12	581452		0	0	0		0	0	0	340484	0	121	40213260		
52937	4398	1118084	1998-07-27	1998-07-27 00:00:00	1998-07-27	1998-07-27 00:00:00	\N	38000177		0	0	0		0	0	0	292435	0	00025152531	44923712		
172994	3803	40213160	1965-03-24	1965-03-24 00:00:00	1965-03-24	1965-03-24 00:00:00	1965-03-24	581452		0	0	0		0	0	0	252818	0	10	40213160		
23777	1954	1127433	1981-05-29	1981-05-29 00:00:00	1981-06-12	1981-06-12 00:00:00	1981-06-12	38000177		0	0	14		0	0	0	130038	0	313782	1127433		
27334	596	40213227	1999-02-23	1999-02-23 00:00:00	1999-02-23	1999-02-23 00:00:00	1999-02-23	581452		0	0	0		0	0	0	39322	0	113	40213227		
219967	4828	40213296	2007-05-16	2007-05-16 00:00:00	2007-05-16	2007-05-16 00:00:00	2007-05-16	581452		0	0	0		0	0	0	321280	0	52	40213296		
16621	1378	40169281	2000-07-25	2000-07-25 00:00:00	2000-07-25	2000-07-25 00:00:00	\N	38000177		0	0	0		0	0	0	91440	0	896209	40169281		
34401	2843	1127078	1962-07-17	1962-07-17 00:00:00	1962-07-31	1962-07-31 00:00:00	1962-07-31	38000177		0	0	14		0	0	0	188794	0	282464	1127078		
34445	2846	920300	2016-07-26	2016-07-26 00:00:00	2016-08-02	2016-08-02 00:00:00	2016-08-02	38000177		0	0	7		0	0	0	189037	0	311989	920300		
45215	3742	19129655	1972-07-04	1972-07-04 00:00:00	1972-07-18	1972-07-18 00:00:00	1972-07-18	38000177		0	0	14		0	0	0	248682	0	789980	19129655		
12508	270	40213260	2008-02-05	2008-02-05 00:00:00	2008-02-05	2008-02-05 00:00:00	2008-02-05	581452		0	0	0		0	0	0	17977	0	121	40213260		
62382	5193	1713671	1986-05-31	1986-05-31 00:00:00	1986-06-14	1986-06-14 00:00:00	1986-06-14	38000177		0	0	14		0	0	0	345201	0	562251	1713671		
17715	1468	1713671	1983-09-12	1983-09-12 00:00:00	1983-09-26	1983-09-26 00:00:00	1983-09-26	38000177		0	0	14		0	0	0	97854	0	562251	1713671		
55855	4636	40173590	2006-08-15	2006-08-15 00:00:00	2006-08-15	2006-08-15 00:00:00	\N	38000177		0	0	0		0	0	0	308943	0	904419	40173590		
55901	4641	19128022	1992-05-12	1992-05-12 00:00:00	1993-05-07	1993-05-07 00:00:00	1993-05-07	38000177		0	0	360		0	0	0	309315	0	749785	19128022		
35113	2897	1127433	1979-03-16	1979-03-16 00:00:00	1979-04-20	1979-04-20 00:00:00	1979-04-20	38000177		0	0	35		0	0	0	192942	0	313782	1127433		
21444	1762	40163554	1998-04-09	1998-04-09 00:00:00	1998-04-09	1998-04-09 00:00:00	\N	38000177		0	0	0		0	0	0	117826	0	855332	40163554		
10767	895	19059056	1962-11-21	1962-11-21 00:00:00	1962-12-05	1962-12-05 00:00:00	1962-12-05	38000177		0	0	14		0	0	0	59749	0	243670	19059056		
48547	4021	1713671	1992-03-21	1992-03-21 00:00:00	1992-04-11	1992-04-11 00:00:00	1992-04-11	38000177		0	0	21		0	0	0	267280	0	562251	1713671		
192547	4229	40213160	1955-06-04	1955-06-04 00:00:00	1955-06-04	1955-06-04 00:00:00	1955-06-04	581452		0	0	0		0	0	0	280954	0	10	40213160		
56278	4670	1127433	1967-02-23	1967-02-23 00:00:00	1967-03-02	1967-03-02 00:00:00	1967-03-02	38000177		0	0	7		0	0	0	311227	0	313782	1127433		
27679	603	40213160	1956-06-15	1956-06-15 00:00:00	1956-06-15	1956-06-15 00:00:00	1956-06-15	581452		0	0	0		0	0	0	40009	0	10	40213160		
49644	4117	19129655	1964-05-07	1964-05-07 00:00:00	1964-05-21	1964-05-21 00:00:00	1964-05-21	38000177		0	0	14		0	0	0	273696	0	789980	19129655		
154876	3409	40213260	2006-12-14	2006-12-14 00:00:00	2006-12-14	2006-12-14 00:00:00	2006-12-14	581452		0	0	0		0	0	0	226106	0	121	40213260		
150709	3315	40213160	1962-04-07	1962-04-07 00:00:00	1962-04-07	1962-04-07 00:00:00	1962-04-07	581452		0	0	0		0	0	0	220178	0	10	40213160		
176723	3885	40213227	2004-10-22	2004-10-22 00:00:00	2004-10-22	2004-10-22 00:00:00	2004-10-22	581452		0	0	0		0	0	0	258223	0	113	40213227		
50153	4160	19128065	1976-07-01	1976-07-01 00:00:00	1977-06-26	1977-06-26 00:00:00	1977-06-26	38000177		0	0	360		0	0	0	276419	0	749882	19128065		
6701	145	40213227	1993-09-07	1993-09-07 00:00:00	1993-09-07	1993-09-07 00:00:00	1993-09-07	581452		0	0	0		0	0	0	9761	0	113	40213227		
59350	4932	1713671	2008-09-19	2008-09-19 00:00:00	2008-10-03	2008-10-03 00:00:00	2008-10-03	38000177		0	0	14		0	0	0	327828	0	562251	1713671		
196681	4321	40213296	2006-10-22	2006-10-22 00:00:00	2006-10-22	2006-10-22 00:00:00	2006-10-22	581452		0	0	0		0	0	0	286748	0	52	40213296		
24893	2046	19059056	1952-09-18	1952-09-18 00:00:00	1952-10-09	1952-10-09 00:00:00	1952-10-09	38000177		0	0	21		0	0	0	136151	0	243670	19059056		
173589	3817	40213160	1968-08-23	1968-08-23 00:00:00	1968-08-23	1968-08-23 00:00:00	1968-08-23	581452		0	0	0		0	0	0	\N	0	10	40213160		
13539	1134	1127433	1955-06-08	1955-06-08 00:00:00	1955-06-22	1955-06-22 00:00:00	1955-06-22	38000177		0	0	14		0	0	0	74666	0	313782	1127433		
23124	1906	40162522	2017-05-18	2017-05-18 00:00:00	2017-05-18	2017-05-18 00:00:00	\N	38000177		0	0	0		0	0	0	126852	0	857005	40162522		
24101	1982	19059056	1987-05-05	1987-05-05 00:00:00	1987-06-09	1987-06-09 00:00:00	1987-06-09	38000177		0	0	35		0	0	0	131959	0	243670	19059056		
24147	1986	19133873	1988-12-03	1988-12-03 00:00:00	1988-12-13	1988-12-13 00:00:00	1988-12-13	38000177		0	0	10		0	0	0	132264	0	834061	19133873		
15556	1297	1124300	2014-10-23	2014-10-23 00:00:00	2014-10-23	2014-10-23 00:00:00	\N	38000177		0	0	0		0	0	0	85754	0	00781178901	45011828		
163862	3604	40213160	1989-04-14	1989-04-14 00:00:00	1989-04-14	1989-04-14 00:00:00	1989-04-14	581452		0	0	0		0	0	0	239508	0	10	40213160		
130391	2865	40213260	2019-02-04	2019-02-04 00:00:00	2019-02-04	2019-02-04 00:00:00	2019-02-04	581452		0	0	0		0	0	0	190615	0	121	40213260		
236470	5193	40213227	2002-09-05	2002-09-05 00:00:00	2002-09-05	2002-09-05 00:00:00	2002-09-05	581452		0	0	0		0	0	0	345216	0	113	40213227		
34025	743	40213160	1980-10-12	1980-10-12 00:00:00	1980-10-12	1980-10-12 00:00:00	1980-10-12	581452		0	0	0		0	0	0	49287	0	10	40213160		
32963	720	40213260	2014-08-30	2014-08-30 00:00:00	2014-08-30	2014-08-30 00:00:00	2014-08-30	581452		0	0	0		0	0	0	47655	0	121	40213260		
232884	5117	40213227	2019-05-13	2019-05-13 00:00:00	2019-05-13	2019-05-13 00:00:00	2019-05-13	581452		0	0	0		0	0	0	340142	0	113	40213227		
159443	3509	40213227	2013-05-17	2013-05-17 00:00:00	2013-05-17	2013-05-17 00:00:00	2013-05-17	581452		0	0	0		0	0	0	232778	0	113	40213227		
25227	2077	1127433	1977-08-16	1977-08-16 00:00:00	1977-08-30	1977-08-30 00:00:00	1977-08-30	38000177		0	0	14		0	0	0	138214	0	313782	1127433		
96432	2115	40213260	2012-10-01	2012-10-01 00:00:00	2012-10-01	2012-10-01 00:00:00	2012-10-01	581452		0	0	0		0	0	0	140721	0	121	40213260		
5165	431	19078461	1985-09-18	1985-09-18 00:00:00	1985-10-02	1985-10-02 00:00:00	1985-10-02	38000177		0	0	14		0	0	0	28595	0	310965	19078461		
161725	3558	40213260	2009-03-28	2009-03-28 00:00:00	2009-03-28	2009-03-28 00:00:00	2009-03-28	581452		0	0	0		0	0	0	236213	0	121	40213260		
56102	4657	19059056	1969-03-24	1969-03-24 00:00:00	1969-04-23	1969-04-23 00:00:00	1969-04-23	38000177		0	0	30		0	0	0	310509	0	243670	19059056		
10374	867	19075601	2014-08-12	2014-08-12 00:00:00	2016-07-05	2016-07-05 00:00:00	2016-07-05	38000177		0	0	693		0	0	0	57616	0	309362	19075601		
217011	4761	40213227	2012-03-26	2012-03-26 00:00:00	2012-03-26	2012-03-26 00:00:00	2012-03-26	581452		0	0	0		0	0	0	317246	0	113	40213227		
16995	1408	1332419	2015-03-23	2015-03-23 00:00:00	2015-03-23	2015-03-23 00:00:00	\N	38000177		0	0	0		0	0	0	93607	0	197361	1332419		
121816	2677	40213160	1972-07-22	1972-07-22 00:00:00	1972-07-22	1972-07-22 00:00:00	1972-07-22	581452		0	0	0		0	0	0	177349	0	10	40213160		
192401	4227	40213227	1997-11-16	1997-11-16 00:00:00	1997-11-16	1997-11-16 00:00:00	1997-11-16	581452		0	0	0		0	0	0	280818	0	113	40213227		
31541	2616	1127433	2017-04-01	2017-04-01 00:00:00	2017-04-29	2017-04-29 00:00:00	2017-04-29	38000177		0	0	28		0	0	0	172966	0	313782	1127433		
112721	2476	40213160	1957-06-12	1957-06-12 00:00:00	1957-06-12	1957-06-12 00:00:00	1957-06-12	581452		0	0	0		0	0	0	164104	0	10	40213160		
29287	639	40213227	1995-10-21	1995-10-21 00:00:00	1995-10-21	1995-10-21 00:00:00	1995-10-21	581452		0	0	0		0	0	0	42255	0	113	40213227		
54854	4557	19059056	1951-12-21	1951-12-21 00:00:00	1952-01-25	1952-01-25 00:00:00	1952-01-25	38000177		0	0	35		0	0	0	303639	0	243670	19059056		
19796	1627	19133905	1971-02-09	1971-02-09 00:00:00	1971-02-22	1971-02-22 00:00:00	1971-02-22	38000177		0	0	13		0	0	0	109364	0	834102	19133905		
124191	2731	40213160	1961-03-20	1961-03-20 00:00:00	1961-03-20	1961-03-20 00:00:00	1961-03-20	581452		0	0	0		0	0	0	180750	0	10	40213160		
91320	2004	40213227	2002-07-30	2002-07-30 00:00:00	2002-07-30	2002-07-30 00:00:00	2002-07-30	581452		0	0	0		0	0	0	133474	0	113	40213227		
42292	3508	19059056	1961-09-20	1961-09-20 00:00:00	1961-10-04	1961-10-04 00:00:00	1961-10-04	38000177		0	0	14		0	0	0	232629	0	243670	19059056		
37314	3083	1127433	1955-12-21	1955-12-21 00:00:00	1955-12-28	1955-12-28 00:00:00	1955-12-28	38000177		0	0	7		0	0	0	205259	0	313782	1127433		
33122	2747	19019979	1976-02-21	1976-02-21 00:00:00	1976-03-06	1976-03-06 00:00:00	1976-03-06	38000177		0	0	14		0	0	0	181662	0	198405	19019979		
233063	5121	40213260	2015-12-18	2015-12-18 00:00:00	2015-12-18	2015-12-18 00:00:00	2015-12-18	581452		0	0	0		0	0	0	340459	0	121	40213260		
52938	4398	40229134	1993-04-15	1993-04-15 00:00:00	1993-04-22	1993-04-22 00:00:00	1993-04-22	38000177		0	0	7		0	0	0	292451	0	1043400	40229134		
172998	3803	40213260	2010-04-14	2010-04-14 00:00:00	2010-04-14	2010-04-14 00:00:00	2010-04-14	581452		0	0	0		0	0	0	252786	0	121	40213260		
23778	1954	1713671	2003-10-27	2003-10-27 00:00:00	2003-11-03	2003-11-03 00:00:00	2003-11-03	38000177		0	0	7		0	0	0	130015	0	562251	1713671		
27338	596	40213227	1992-02-11	1992-02-11 00:00:00	1992-02-11	1992-02-11 00:00:00	1992-02-11	581452		0	0	0		0	0	0	39314	0	113	40213227		
219973	4828	40213160	1967-08-16	1967-08-16 00:00:00	1967-08-16	1967-08-16 00:00:00	1967-08-16	581452		0	0	0		0	0	0	321291	0	10	40213160		
16622	1378	1127433	1950-12-18	1950-12-18 00:00:00	1951-01-01	1951-01-01 00:00:00	1951-01-01	38000177		0	0	14		0	0	0	91362	0	313782	1127433		
34404	2843	1118084	2000-01-09	2000-01-09 00:00:00	2000-01-09	2000-01-09 00:00:00	\N	38000177		0	0	0		0	0	0	188779	0	00025152531	44923712		
34446	2846	920334	2016-08-02	2016-08-02 00:00:00	2016-08-09	2016-08-09 00:00:00	2016-08-09	38000177		0	0	7		0	0	0	189023	0	311995	920334		
45216	3743	1118084	2017-10-23	2017-10-23 00:00:00	2017-10-23	2017-10-23 00:00:00	\N	38000177		0	0	0		0	0	0	248719	0	00025152531	44923712		
12510	270	40213160	1958-10-14	1958-10-14 00:00:00	1958-10-14	1958-10-14 00:00:00	1958-10-14	581452		0	0	0		0	0	0	17993	0	10	40213160		
62383	5193	1118084	2001-08-05	2001-08-05 00:00:00	2001-08-05	2001-08-05 00:00:00	\N	38000177		0	0	0		0	0	0	345227	0	00025152531	44923712		
17716	1468	1127433	1951-10-05	1951-10-05 00:00:00	1951-10-19	1951-10-19 00:00:00	1951-10-19	38000177		0	0	14		0	0	0	97821	0	313782	1127433		
55856	4636	1127433	1962-02-08	1962-02-08 00:00:00	1962-02-22	1962-02-22 00:00:00	1962-02-22	38000177		0	0	14		0	0	0	308978	0	313782	1127433		
55902	4641	40169281	2001-09-06	2001-09-06 00:00:00	2001-09-06	2001-09-06 00:00:00	\N	38000177		0	0	0		0	0	0	309350	0	896209	40169281		
35114	2897	19059056	1962-09-22	1962-09-22 00:00:00	1962-10-06	1962-10-06 00:00:00	1962-10-06	38000177		0	0	14		0	0	0	192892	0	243670	19059056		
21445	1762	19018935	1998-04-09	1998-04-09 00:00:00	1998-04-09	1998-04-09 00:00:00	\N	38000177		0	0	0		0	0	0	117826	0	197604	19018935		
10768	895	19059056	1988-02-03	1988-02-03 00:00:00	1988-02-17	1988-02-17 00:00:00	1988-02-17	38000177		0	0	14		0	0	0	59676	0	243670	19059056		
48548	4021	1713671	1962-03-13	1962-03-13 00:00:00	1962-03-27	1962-03-27 00:00:00	1962-03-27	38000177		0	0	14		0	0	0	267311	0	562251	1713671		
192555	4229	40213198	2017-10-14	2017-10-14 00:00:00	2017-10-14	2017-10-14 00:00:00	2017-10-14	581452		0	0	0		0	0	0	280918	0	133	40213198		
40703	3375	19133905	1988-07-22	1988-07-22 00:00:00	1988-08-04	1988-08-04 00:00:00	1988-08-04	38000177		0	0	13		0	0	0	223881	0	834102	19133905		
204330	4485	40213227	1992-10-22	1992-10-22 00:00:00	1992-10-22	1992-10-22 00:00:00	1992-10-22	581452		0	0	0		0	0	0	298596	0	113	40213227		
49645	4117	1118084	1996-05-29	1996-05-29 00:00:00	1996-05-29	1996-05-29 00:00:00	\N	38000177		0	0	0		0	0	0	273737	0	00025152531	44923712		
154881	3409	40213296	1996-11-14	1996-11-14 00:00:00	1996-11-14	1996-11-14 00:00:00	1996-11-14	581452		0	0	0		0	0	0	226084	0	52	40213296		
150714	3315	40213160	1958-01-04	1958-01-04 00:00:00	1958-01-04	1958-01-04 00:00:00	1958-01-04	581452		0	0	0		0	0	0	220148	0	10	40213160		
176724	3885	40213296	2004-10-22	2004-10-22 00:00:00	2004-10-22	2004-10-22 00:00:00	2004-10-22	581452		0	0	0		0	0	0	258223	0	52	40213296		
50154	4160	1713671	1985-09-13	1985-09-13 00:00:00	1985-09-27	1985-09-27 00:00:00	1985-09-27	38000177		0	0	14		0	0	0	276473	0	562251	1713671		
96019	2105	40213314	1977-12-11	1977-12-11 00:00:00	1977-12-11	1977-12-11 00:00:00	1977-12-11	581452		0	0	0		0	0	0	140230	0	49	40213314		
59351	4932	1127433	1990-09-06	1990-09-06 00:00:00	1990-09-20	1990-09-20 00:00:00	1990-09-20	38000177		0	0	14		0	0	0	327887	0	313782	1127433		
196687	4321	40213160	1963-04-07	1963-04-07 00:00:00	1963-04-07	1963-04-07 00:00:00	1963-04-07	581452		0	0	0		0	0	0	286732	0	10	40213160		
24894	2046	19133905	1991-04-27	1991-04-27 00:00:00	1991-05-05	1991-05-05 00:00:00	1991-05-05	38000177		0	0	8		0	0	0	136182	0	834102	19133905		
64462	1410	40213227	2019-01-09	2019-01-09 00:00:00	2019-01-09	2019-01-09 00:00:00	2019-01-09	581452		0	0	0		0	0	0	93895	0	113	40213227		
13540	1134	19059056	1940-09-23	1940-09-23 00:00:00	1940-10-07	1940-10-07 00:00:00	1940-10-07	38000177		0	0	14		0	0	0	74724	0	243670	19059056		
23125	1906	1127433	2017-05-18	2017-05-18 00:00:00	2017-06-08	2017-06-08 00:00:00	2017-06-08	38000177		0	0	21		0	0	0	126852	0	313782	1127433		
24102	1982	19059056	1933-11-20	1933-11-20 00:00:00	1933-12-20	1933-12-20 00:00:00	1933-12-20	38000177		0	0	30		0	0	0	131971	0	243670	19059056		
24148	1986	1127078	1982-02-24	1982-02-24 00:00:00	1982-03-10	1982-03-10 00:00:00	1982-03-10	38000177		0	0	14		0	0	0	132266	0	282464	1127078		
15557	1297	1127433	2007-10-16	2007-10-16 00:00:00	2007-10-30	2007-10-30 00:00:00	2007-10-30	38000177		0	0	14		0	0	0	85711	0	313782	1127433		
163872	3604	40213160	1985-01-11	1985-01-11 00:00:00	1985-01-11	1985-01-11 00:00:00	1985-01-11	581452		0	0	0		0	0	0	239461	0	10	40213160		
130396	2865	40213227	1999-04-12	1999-04-12 00:00:00	1999-04-12	1999-04-12 00:00:00	1999-04-12	581452		0	0	0		0	0	0	190585	0	113	40213227		
123098	2705	40213227	2013-12-28	2013-12-28 00:00:00	2013-12-28	2013-12-28 00:00:00	2013-12-28	581452		0	0	0		0	0	0	179176	0	113	40213227		
34027	743	40213314	1977-04-10	1977-04-10 00:00:00	1977-04-10	1977-04-10 00:00:00	1977-04-10	581452		0	0	0		0	0	0	49248	0	49	40213314		
32966	720	40213160	1965-05-08	1965-05-08 00:00:00	1965-05-08	1965-05-08 00:00:00	1965-05-08	581452		0	0	0		0	0	0	47671	0	10	40213160		
232888	5117	40213260	2008-03-10	2008-03-10 00:00:00	2008-03-10	2008-03-10 00:00:00	2008-03-10	581452		0	0	0		0	0	0	340114	0	121	40213260		
159452	3509	40213198	2010-04-30	2010-04-30 00:00:00	2010-04-30	2010-04-30 00:00:00	2010-04-30	581452		0	0	0		0	0	0	232699	0	133	40213198		
25228	2077	19078461	1996-10-21	1996-10-21 00:00:00	1996-11-04	1996-11-04 00:00:00	1996-11-04	38000177		0	0	14		0	0	0	138378	0	310965	19078461		
96438	2115	40213160	1962-01-01	1962-01-01 00:00:00	1962-01-01	1962-01-01 00:00:00	1962-01-01	581452		0	0	0		0	0	0	140762	0	10	40213160		
5166	431	1127433	1989-05-04	1989-05-04 00:00:00	1989-05-18	1989-05-18 00:00:00	1989-05-18	38000177		0	0	14		0	0	0	28597	0	313782	1127433		
161728	3558	40213227	1993-06-05	1993-06-05 00:00:00	1993-06-05	1993-06-05 00:00:00	1993-06-05	581452		0	0	0		0	0	0	236184	0	113	40213227		
56103	4657	1713671	1985-03-04	1985-03-04 00:00:00	1985-03-18	1985-03-18 00:00:00	1985-03-18	38000177		0	0	14		0	0	0	310515	0	562251	1713671		
10375	867	1332419	2014-08-12	2014-08-12 00:00:00	2014-08-12	2014-08-12 00:00:00	\N	38000177		0	0	0		0	0	0	57616	0	197361	1332419		
205353	4506	40213227	2004-12-30	2004-12-30 00:00:00	2004-12-30	2004-12-30 00:00:00	2004-12-30	581452		0	0	0		0	0	0	300153	0	113	40213227		
16996	1408	1539411	2015-03-23	2015-03-23 00:00:00	2015-03-23	2015-03-23 00:00:00	\N	38000177		0	0	0		0	0	0	93607	0	312961	1539411		
121819	2677	40213306	1994-07-02	1994-07-02 00:00:00	1994-07-02	1994-07-02 00:00:00	1994-07-02	581452		0	0	0		0	0	0	177406	0	43	40213306		
192402	4227	40213296	1997-11-16	1997-11-16 00:00:00	1997-11-16	1997-11-16 00:00:00	1997-11-16	581452		0	0	0		0	0	0	280818	0	52	40213296		
31542	2616	1127433	1974-06-29	1974-06-29 00:00:00	1974-07-13	1974-07-13 00:00:00	1974-07-13	38000177		0	0	14		0	0	0	172963	0	313782	1127433		
112726	2476	40213227	2018-08-22	2018-08-22 00:00:00	2018-08-22	2018-08-22 00:00:00	2018-08-22	581452		0	0	0		0	0	0	164114	0	113	40213227		
29293	639	40213160	1957-12-14	1957-12-14 00:00:00	1957-12-14	1957-12-14 00:00:00	1957-12-14	581452		0	0	0		0	0	0	42273	0	10	40213160		
54855	4557	46233710	1971-03-09	1971-03-09 00:00:00	1971-03-23	1971-03-23 00:00:00	1971-03-23	38000177		0	0	14		0	0	0	303627	0	1650142	46233710		
187665	4122	40213160	1973-12-26	1973-12-26 00:00:00	1973-12-26	1973-12-26 00:00:00	1973-12-26	581452		0	0	0		0	0	0	274064	0	10	40213160		
124192	2731	40213160	1965-06-21	1965-06-21 00:00:00	1965-06-21	1965-06-21 00:00:00	1965-06-21	581452		0	0	0		0	0	0	180785	0	10	40213160		
91324	2004	40213296	2011-06-07	2011-06-07 00:00:00	2011-06-07	2011-06-07 00:00:00	2011-06-07	581452		0	0	0		0	0	0	133429	0	52	40213296		
42293	3508	1127433	2010-12-25	2010-12-25 00:00:00	2011-01-08	2011-01-08 00:00:00	2011-01-08	38000177		0	0	14		0	0	0	232626	0	313782	1127433		
37315	3083	19059056	1969-09-05	1969-09-05 00:00:00	1969-09-19	1969-09-19 00:00:00	1969-09-19	38000177		0	0	14		0	0	0	205270	0	243670	19059056		
33123	2747	46233988	1976-02-21	1976-02-21 00:00:00	1976-03-06	1976-03-06 00:00:00	1976-03-06	38000177		0	0	14		0	0	0	181662	0	1652673	46233988		
233065	5121	40213227	2015-12-18	2015-12-18 00:00:00	2015-12-18	2015-12-18 00:00:00	2015-12-18	581452		0	0	0		0	0	0	340459	0	113	40213227		
52939	4398	19078461	1990-08-08	1990-08-08 00:00:00	1990-09-07	1990-09-07 00:00:00	1990-09-07	38000177		0	0	30		0	0	0	292433	0	310965	19078461		
173003	3803	40213227	2011-04-20	2011-04-20 00:00:00	2011-04-20	2011-04-20 00:00:00	2011-04-20	581452		0	0	0		0	0	0	252826	0	113	40213227		
101781	2231	40213160	1970-10-17	1970-10-17 00:00:00	1970-10-17	1970-10-17 00:00:00	1970-10-17	581452		0	0	0		0	0	0	148456	0	10	40213160		
40423	3352	19133873	1972-09-22	1972-09-22 00:00:00	1972-10-04	1972-10-04 00:00:00	1972-10-04	38000177		0	0	12		0	0	0	222293	0	834061	19133873		
219976	4828	40213160	1972-04-18	1972-04-18 00:00:00	1972-04-18	1972-04-18 00:00:00	1972-04-18	581452		0	0	0		0	0	0	321245	0	10	40213160		
16623	1378	19059056	1949-09-22	1949-09-22 00:00:00	1949-10-06	1949-10-06 00:00:00	1949-10-06	38000177		0	0	14		0	0	0	91381	0	243670	19059056		
34405	2843	1127433	2001-05-29	2001-05-29 00:00:00	2001-06-12	2001-06-12 00:00:00	2001-06-12	38000177		0	0	14		0	0	0	188780	0	313782	1127433		
34447	2846	1127433	2001-08-24	2001-08-24 00:00:00	2001-08-31	2001-08-31 00:00:00	2001-08-31	38000177		0	0	7		0	0	0	189036	0	313782	1127433		
45217	3743	40229134	1990-05-18	1990-05-18 00:00:00	1990-05-25	1990-05-25 00:00:00	1990-05-25	38000177		0	0	7		0	0	0	248732	0	1043400	40229134		
12515	270	40213227	2019-03-12	2019-03-12 00:00:00	2019-03-12	2019-03-12 00:00:00	2019-03-12	581452		0	0	0		0	0	0	17986	0	113	40213227		
62384	5193	1115171	2008-10-12	2008-10-12 00:00:00	2008-11-02	2008-11-02 00:00:00	2008-11-02	38000177		0	0	21		0	0	0	345177	0	849574	1115171		
17717	1468	19126352	1977-02-02	1977-02-02 00:00:00	1977-02-02	1977-02-02 00:00:00	\N	38000177		0	0	0		0	0	0	97864	0	705129	19126352		
55857	4637	1127078	1980-12-20	1980-12-20 00:00:00	1981-01-24	1981-01-24 00:00:00	1981-01-24	38000177		0	0	35		0	0	0	309044	0	282464	1127078		
55903	4641	19133873	1967-10-14	1967-10-14 00:00:00	1967-10-27	1967-10-27 00:00:00	1967-10-27	38000177		0	0	13		0	0	0	309285	0	834061	19133873		
35115	2897	19129655	1962-09-22	1962-09-22 00:00:00	1962-10-06	1962-10-06 00:00:00	1962-10-06	38000177		0	0	14		0	0	0	192892	0	789980	19129655		
21446	1762	19133905	1985-08-23	1985-08-23 00:00:00	1985-09-05	1985-09-05 00:00:00	1985-09-05	38000177		0	0	13		0	0	0	117807	0	834102	19133905		
10769	895	1713671	2003-09-22	2003-09-22 00:00:00	2003-10-13	2003-10-13 00:00:00	2003-10-13	38000177		0	0	21		0	0	0	59700	0	562251	1713671		
48550	4021	920300	1989-01-31	1989-01-31 00:00:00	1989-02-07	1989-02-07 00:00:00	1989-02-07	38000177		0	0	7		0	0	0	267279	0	311989	920300		
128005	2815	40213227	1996-06-21	1996-06-21 00:00:00	1996-06-21	1996-06-21 00:00:00	1996-06-21	581452		0	0	0		0	0	0	186565	0	113	40213227		
40704	3375	40229134	1983-06-03	1983-06-03 00:00:00	1983-06-17	1983-06-17 00:00:00	1983-06-17	38000177		0	0	14		0	0	0	223898	0	1043400	40229134		
204338	4485	40213160	1955-09-22	1955-09-22 00:00:00	1955-09-22	1955-09-22 00:00:00	1955-09-22	581452		0	0	0		0	0	0	298550	0	10	40213160		
49646	4117	1127433	1998-11-05	1998-11-05 00:00:00	1998-11-12	1998-11-12 00:00:00	1998-11-12	38000177		0	0	7		0	0	0	273682	0	313782	1127433		
154883	3409	40213227	1996-11-14	1996-11-14 00:00:00	1996-11-14	1996-11-14 00:00:00	1996-11-14	581452		0	0	0		0	0	0	226084	0	113	40213227		
112122	2463	40213160	1969-09-18	1969-09-18 00:00:00	1969-09-18	1969-09-18 00:00:00	1969-09-18	581452		0	0	0		0	0	0	163347	0	10	40213160		
176734	3885	40213227	1996-10-11	1996-10-11 00:00:00	1996-10-11	1996-10-11 00:00:00	1996-10-11	581452		0	0	0		0	0	0	258247	0	113	40213227		
50155	4160	1127433	2015-07-09	2015-07-09 00:00:00	2015-07-23	2015-07-23 00:00:00	2015-07-23	38000177		0	0	14		0	0	0	276459	0	313782	1127433		
96021	2105	40213160	1978-12-03	1978-12-03 00:00:00	1978-12-03	1978-12-03 00:00:00	1978-12-03	581452		0	0	0		0	0	0	140268	0	10	40213160		
59352	4933	1127433	1984-09-08	1984-09-08 00:00:00	1984-10-06	1984-10-06 00:00:00	1984-10-06	38000177		0	0	28		0	0	0	327968	0	313782	1127433		
196690	4321	40213160	1967-12-10	1967-12-10 00:00:00	1967-12-10	1967-12-10 00:00:00	1967-12-10	581452		0	0	0		0	0	0	286717	0	10	40213160		
24895	2046	1127433	1969-12-30	1969-12-30 00:00:00	1970-01-29	1970-01-29 00:00:00	1970-01-29	38000177		0	0	30		0	0	0	136098	0	313782	1127433		
64463	1410	40213260	2019-01-09	2019-01-09 00:00:00	2019-01-09	2019-01-09 00:00:00	2019-01-09	581452		0	0	0		0	0	0	93895	0	121	40213260		
13541	1134	1124300	1978-09-09	1978-09-09 00:00:00	1978-09-09	1978-09-09 00:00:00	\N	38000177		0	0	0		0	0	0	74671	0	00781178901	45011828		
23126	1906	19073188	2017-05-18	2017-05-18 00:00:00	2017-06-08	2017-06-08 00:00:00	2017-06-08	38000177		0	0	21		0	0	0	126852	0	308192	19073188		
24103	1982	1713671	1987-09-29	1987-09-29 00:00:00	1987-10-20	1987-10-20 00:00:00	1987-10-20	38000177		0	0	21		0	0	0	132035	0	562251	1713671		
24149	1986	19073183	1982-02-24	1982-02-24 00:00:00	1982-03-10	1982-03-10 00:00:00	1982-03-10	38000177		0	0	14		0	0	0	132266	0	308182	19073183		
81394	1779	40213201	2009-02-26	2009-02-26 00:00:00	2009-02-26	2009-02-26 00:00:00	2009-02-26	581452		0	0	0		0	0	0	119026	0	33	40213201		
163877	3604	40213314	1984-10-12	1984-10-12 00:00:00	1984-10-12	1984-10-12 00:00:00	1984-10-12	581452		0	0	0		0	0	0	239504	0	49	40213314		
130398	2865	40213160	1968-10-07	1968-10-07 00:00:00	1968-10-07	1968-10-07 00:00:00	1968-10-07	581452		0	0	0		0	0	0	190605	0	10	40213160		
123099	2706	40213260	2014-07-15	2014-07-15 00:00:00	2014-07-15	2014-07-15 00:00:00	2014-07-15	581452		0	0	0		0	0	0	179307	0	121	40213260		
34032	743	40213314	1977-10-09	1977-10-09 00:00:00	1977-10-09	1977-10-09 00:00:00	1977-10-09	581452		0	0	0		0	0	0	49285	0	49	40213314		
61904	1352	40213201	2013-06-09	2013-06-09 00:00:00	2013-06-09	2013-06-09 00:00:00	2013-06-09	581452		0	0	0		0	0	0	89579	0	33	40213201		
242388	5322	40213227	1998-03-18	1998-03-18 00:00:00	1998-03-18	1998-03-18 00:00:00	1998-03-18	581452		0	0	0		0	0	0	354255	0	113	40213227		
6864	149	40213201	2007-10-02	2007-10-02 00:00:00	2007-10-02	2007-10-02 00:00:00	2007-10-02	581452		0	0	0		0	0	0	10067	0	33	40213201		
25229	2077	40222846	2005-05-21	2005-05-21 00:00:00	2005-05-21	2005-05-21 00:00:00	\N	38000177		0	0	0		0	0	0	138273	0	996740	40222846		
96442	2115	40213306	1983-12-19	1983-12-19 00:00:00	1983-12-19	1983-12-19 00:00:00	1983-12-19	581452		0	0	0		0	0	0	140747	0	43	40213306		
5167	432	40173590	2001-04-09	2001-04-09 00:00:00	2001-04-09	2001-04-09 00:00:00	\N	38000177		0	0	0		0	0	0	28696	0	904419	40173590		
56039	4653	1127433	1965-07-22	1965-07-22 00:00:00	1965-07-29	1965-07-29 00:00:00	1965-07-29	38000177		0	0	7		0	0	0	310116	0	313782	1127433		
56104	4657	1127433	1987-08-07	1987-08-07 00:00:00	1987-08-21	1987-08-21 00:00:00	1987-08-21	38000177		0	0	14		0	0	0	310551	0	313782	1127433		
10376	867	1127433	1981-09-14	1981-09-14 00:00:00	1981-09-28	1981-09-28 00:00:00	1981-09-28	38000177		0	0	14		0	0	0	57580	0	313782	1127433		
205362	4506	40213160	1955-03-03	1955-03-03 00:00:00	1955-03-03	1955-03-03 00:00:00	1955-03-03	581452		0	0	0		0	0	0	300215	0	10	40213160		
16997	1408	1713671	1959-04-06	1959-04-06 00:00:00	1959-04-27	1959-04-27 00:00:00	1959-04-27	38000177		0	0	21		0	0	0	93637	0	562251	1713671		
121820	2677	40213227	1994-07-02	1994-07-02 00:00:00	1994-07-02	1994-07-02 00:00:00	1994-07-02	581452		0	0	0		0	0	0	177406	0	113	40213227		
192406	4227	40213227	2016-04-17	2016-04-17 00:00:00	2016-04-17	2016-04-17 00:00:00	2016-04-17	581452		0	0	0		0	0	0	280806	0	113	40213227		
31543	2616	1127433	1987-04-24	1987-04-24 00:00:00	1987-05-08	1987-05-08 00:00:00	1987-05-08	38000177		0	0	14		0	0	0	172953	0	313782	1127433		
112729	2476	40213160	1957-01-09	1957-01-09 00:00:00	1957-01-09	1957-01-09 00:00:00	1957-01-09	581452		0	0	0		0	0	0	164103	0	10	40213160		
29295	639	40213198	2018-05-12	2018-05-12 00:00:00	2018-05-12	2018-05-12 00:00:00	2018-05-12	581452		0	0	0		0	0	0	42260	0	133	40213198		
54856	4557	19059056	1971-03-09	1971-03-09 00:00:00	1971-03-23	1971-03-23 00:00:00	1971-03-23	38000177		0	0	14		0	0	0	303627	0	243670	19059056		
187679	4122	40213306	1991-03-20	1991-03-20 00:00:00	1991-03-20	1991-03-20 00:00:00	1991-03-20	581452		0	0	0		0	0	0	274051	0	43	40213306		
124196	2732	40213160	1970-04-16	1970-04-16 00:00:00	1970-04-16	1970-04-16 00:00:00	1970-04-16	581452		0	0	0		0	0	0	180834	0	10	40213160		
91328	2004	40213160	1971-11-09	1971-11-09 00:00:00	1971-11-09	1971-11-09 00:00:00	1971-11-09	581452		0	0	0		0	0	0	133477	0	10	40213160		
42294	3509	19059056	1949-12-26	1949-12-26 00:00:00	1950-01-23	1950-01-23 00:00:00	1950-01-23	38000177		0	0	28		0	0	0	232695	0	243670	19059056		
37316	3083	1127433	2013-02-19	2013-02-19 00:00:00	2013-04-20	2013-04-20 00:00:00	2013-04-20	38000177		0	0	60		0	0	0	205353	0	313782	1127433		
33124	2747	40236446	1983-06-09	1983-06-09 00:00:00	1983-11-10	1983-11-10 00:00:00	1983-11-10	38000177		0	0	154		0	0	0	181716	0	1091392	40236446		
233069	5121	40213227	2005-11-18	2005-11-18 00:00:00	2005-11-18	2005-11-18 00:00:00	2005-11-18	581452		0	0	0		0	0	0	340470	0	113	40213227		
52940	4398	19059056	1960-01-13	1960-01-13 00:00:00	1960-01-27	1960-01-27 00:00:00	1960-01-27	38000177		0	0	14		0	0	0	292455	0	243670	19059056		
173004	3803	40213260	2011-04-20	2011-04-20 00:00:00	2011-04-20	2011-04-20 00:00:00	2011-04-20	581452		0	0	0		0	0	0	252826	0	121	40213260		
101791	2231	40213160	1970-08-15	1970-08-15 00:00:00	1970-08-15	1970-08-15 00:00:00	1970-08-15	581452		0	0	0		0	0	0	148421	0	10	40213160		
40424	3352	19128065	1979-10-15	1979-10-15 00:00:00	1980-10-09	1980-10-09 00:00:00	1980-10-09	38000177		0	0	360		0	0	0	222296	0	749882	19128065		
219978	4828	40213160	1968-01-16	1968-01-16 00:00:00	1968-01-16	1968-01-16 00:00:00	1968-01-16	581452		0	0	0		0	0	0	321242	0	10	40213160		
16624	1378	19006318	1949-09-22	1949-09-22 00:00:00	1949-10-06	1949-10-06 00:00:00	1949-10-06	38000177		0	0	14		0	0	0	91381	0	105078	19006318		
34406	2843	1713671	2015-11-17	2015-11-17 00:00:00	2015-12-01	2015-12-01 00:00:00	2015-12-01	38000177		0	0	14		0	0	0	188765	0	562251	1713671		
34448	2846	1713671	1999-09-19	1999-09-19 00:00:00	1999-10-10	1999-10-10 00:00:00	1999-10-10	38000177		0	0	21		0	0	0	188994	0	562251	1713671		
45218	3743	1127078	1978-07-10	1978-07-10 00:00:00	1978-07-24	1978-07-24 00:00:00	1978-07-24	38000177		0	0	14		0	0	0	248733	0	282464	1127078		
14234	307	40213227	2002-08-24	2002-08-24 00:00:00	2002-08-24	2002-08-24 00:00:00	2002-08-24	581452		0	0	0		0	0	0	20362	0	113	40213227		
62385	5193	19075601	2010-06-10	2010-06-10 00:00:00	2010-06-10	2010-06-10 00:00:00	2010-06-10	38000177		0	0	0		0	0	0	345180	0	309362	19075601		
17718	1468	1127433	1964-11-07	1964-11-07 00:00:00	1964-11-28	1964-11-28 00:00:00	1964-11-28	38000177		0	0	21		0	0	0	97873	0	313782	1127433		
55858	4637	19133873	1980-04-20	1980-04-20 00:00:00	1980-04-30	1980-04-30 00:00:00	1980-04-30	38000177		0	0	10		0	0	0	309021	0	834061	19133873		
55904	4641	1713671	2013-04-28	2013-04-28 00:00:00	2013-05-12	2013-05-12 00:00:00	2013-05-12	38000177		0	0	14		0	0	0	309308	0	562251	1713671		
35116	2897	19133873	1967-07-29	1967-07-29 00:00:00	1967-08-05	1967-08-05 00:00:00	1967-08-05	38000177		0	0	7		0	0	0	192963	0	834061	19133873		
21447	1762	40229134	1967-10-06	1967-10-06 00:00:00	1967-10-20	1967-10-20 00:00:00	1967-10-20	38000177		0	0	14		0	0	0	117847	0	1043400	40229134		
10770	895	1127078	1963-12-16	1963-12-16 00:00:00	1963-12-30	1963-12-30 00:00:00	1963-12-30	38000177		0	0	14		0	0	0	59701	0	282464	1127078		
48551	4021	40236824	1989-01-31	1989-01-31 00:00:00	1989-02-07	1989-02-07 00:00:00	1989-02-07	38000177		0	0	7		0	0	0	267279	0	1094107	40236824		
128009	2815	40213260	2013-04-26	2013-04-26 00:00:00	2013-04-26	2013-04-26 00:00:00	2013-04-26	581452		0	0	0		0	0	0	186534	0	121	40213260		
40705	3375	19128065	1974-01-29	1974-01-29 00:00:00	1975-01-24	1975-01-24 00:00:00	1975-01-24	38000177		0	0	360		0	0	0	223914	0	749882	19128065		
204340	4485	40213227	2002-08-29	2002-08-29 00:00:00	2002-08-29	2002-08-29 00:00:00	2002-08-29	581452		0	0	0		0	0	0	298606	0	113	40213227		
49647	4117	19133873	1964-05-10	1964-05-10 00:00:00	1964-05-19	1964-05-19 00:00:00	1964-05-19	38000177		0	0	9		0	0	0	273690	0	834061	19133873		
154886	3409	40213160	1960-04-07	1960-04-07 00:00:00	1960-04-07	1960-04-07 00:00:00	1960-04-07	581452		0	0	0		0	0	0	226143	0	10	40213160		
112126	2463	40213227	2000-06-22	2000-06-22 00:00:00	2000-06-22	2000-06-22 00:00:00	2000-06-22	581452		0	0	0		0	0	0	163353	0	113	40213227		
176739	3885	40213260	2013-11-15	2013-11-15 00:00:00	2013-11-15	2013-11-15 00:00:00	2013-11-15	581452		0	0	0		0	0	0	258251	0	121	40213260		
50156	4160	19078461	2016-07-08	2016-07-08 00:00:00	2016-08-12	2016-08-12 00:00:00	2016-08-12	38000177		0	0	35		0	0	0	276412	0	310965	19078461		
96026	2105	40213160	1974-11-24	1974-11-24 00:00:00	1974-11-24	1974-11-24 00:00:00	1974-11-24	581452		0	0	0		0	0	0	140239	0	10	40213160		
59353	4933	1713671	1997-11-04	1997-11-04 00:00:00	1997-11-11	1997-11-11 00:00:00	1997-11-11	38000177		0	0	7		0	0	0	327929	0	562251	1713671		
196693	4321	40213306	1985-12-29	1985-12-29 00:00:00	1985-12-29	1985-12-29 00:00:00	1985-12-29	581452		0	0	0		0	0	0	286722	0	43	40213306		
24896	2046	40231925	1969-12-30	1969-12-30 00:00:00	1969-12-30	1969-12-30 00:00:00	\N	38000177		0	0	0		0	0	0	136098	0	1049221	40231925		
64467	1410	40213160	1972-02-16	1972-02-16 00:00:00	1972-02-16	1972-02-16 00:00:00	1972-02-16	581452		0	0	0		0	0	0	93842	0	10	40213160		
13542	1134	19133873	1948-01-30	1948-01-30 00:00:00	1948-02-06	1948-02-06 00:00:00	1948-02-06	38000177		0	0	7		0	0	0	74662	0	834061	19133873		
23127	1906	1124300	1997-09-25	1997-09-25 00:00:00	1997-09-25	1997-09-25 00:00:00	\N	38000177		0	0	0		0	0	0	126927	0	00781178901	45011828		
24104	1982	19078461	2004-05-01	2004-05-01 00:00:00	2004-07-30	2004-07-30 00:00:00	2004-07-30	38000177		0	0	90		0	0	0	131962	0	310965	19078461		
24150	1986	19073188	2009-12-31	2009-12-31 00:00:00	2010-01-14	2010-01-14 00:00:00	2010-01-14	38000177		0	0	14		0	0	0	132267	0	308192	19073188		
81406	1779	40213227	1993-12-02	1993-12-02 00:00:00	1993-12-02	1993-12-02 00:00:00	1993-12-02	581452		0	0	0		0	0	0	119021	0	113	40213227		
163878	3604	40213160	1984-10-12	1984-10-12 00:00:00	1984-10-12	1984-10-12 00:00:00	1984-10-12	581452		0	0	0		0	0	0	239504	0	10	40213160		
130400	2865	40213306	1990-04-02	1990-04-02 00:00:00	1990-04-02	1990-04-02 00:00:00	1990-04-02	581452		0	0	0		0	0	0	190610	0	43	40213306		
123101	2706	40213227	2014-07-15	2014-07-15 00:00:00	2014-07-15	2014-07-15 00:00:00	2014-07-15	581452		0	0	0		0	0	0	179307	0	113	40213227		
34035	743	40213227	1998-02-08	1998-02-08 00:00:00	1998-02-08	1998-02-08 00:00:00	1998-02-08	581452		0	0	0		0	0	0	49230	0	113	40213227		
61906	1352	40213227	2008-05-11	2008-05-11 00:00:00	2008-05-11	2008-05-11 00:00:00	2008-05-11	581452		0	0	0		0	0	0	89543	0	113	40213227		
242404	5322	40213227	2008-05-14	2008-05-14 00:00:00	2008-05-14	2008-05-14 00:00:00	2008-05-14	581452		0	0	0		0	0	0	354200	0	113	40213227		
6884	149	40213227	2002-09-03	2002-09-03 00:00:00	2002-09-03	2002-09-03 00:00:00	2002-09-03	581452		0	0	0		0	0	0	10106	0	113	40213227		
25230	2077	1127433	2001-06-11	2001-06-11 00:00:00	2001-09-09	2001-09-09 00:00:00	2001-09-09	38000177		0	0	90		0	0	0	138379	0	313782	1127433		
96446	2115	40213260	2011-09-26	2011-09-26 00:00:00	2011-09-26	2011-09-26 00:00:00	2011-09-26	581452		0	0	0		0	0	0	140738	0	121	40213260		
5168	432	1127433	1989-12-24	1989-12-24 00:00:00	1990-01-07	1990-01-07 00:00:00	1990-01-07	38000177		0	0	14		0	0	0	28715	0	313782	1127433		
56040	4653	19133873	1964-09-24	1964-09-24 00:00:00	1964-10-04	1964-10-04 00:00:00	1964-10-04	38000177		0	0	10		0	0	0	310166	0	834061	19133873		
56105	4657	1713671	2005-10-09	2005-10-09 00:00:00	2005-10-23	2005-10-23 00:00:00	2005-10-23	38000177		0	0	14		0	0	0	310507	0	562251	1713671		
10377	867	1127433	2018-01-17	2018-01-17 00:00:00	2018-02-21	2018-02-21 00:00:00	2018-02-21	38000177		0	0	35		0	0	0	57585	0	313782	1127433		
205363	4506	40213198	2019-03-21	2019-03-21 00:00:00	2019-03-21	2019-03-21 00:00:00	2019-03-21	581452		0	0	0		0	0	0	300235	0	133	40213198		
16998	1408	1713671	1994-08-11	1994-08-11 00:00:00	1995-02-09	1995-02-09 00:00:00	1995-02-09	38000177		0	0	182		0	0	0	93625	0	562251	1713671		
121823	2677	40213314	1977-03-25	1977-03-25 00:00:00	1977-03-25	1977-03-25 00:00:00	1977-03-25	581452		0	0	0		0	0	0	177397	0	49	40213314		
192407	4227	40213160	1960-01-24	1960-01-24 00:00:00	1960-01-24	1960-01-24 00:00:00	1960-01-24	581452		0	0	0		0	0	0	280828	0	10	40213160		
31544	2616	1127078	1955-08-01	1955-08-01 00:00:00	1955-08-15	1955-08-15 00:00:00	1955-08-15	38000177		0	0	14		0	0	0	172981	0	282464	1127078		
112737	2477	40213296	1998-04-12	1998-04-12 00:00:00	1998-04-12	1998-04-12 00:00:00	1998-04-12	581452		0	0	0		0	0	0	\N	0	52	40213296		
29298	639	40213160	1955-06-11	1955-06-11 00:00:00	1955-06-11	1955-06-11 00:00:00	1955-06-11	581452		0	0	0		0	0	0	42249	0	10	40213160		
54857	4557	1127433	1969-11-12	1969-11-12 00:00:00	1970-01-11	1970-01-11 00:00:00	1970-01-11	38000177		0	0	60		0	0	0	303641	0	313782	1127433		
187687	4122	40213227	2000-04-26	2000-04-26 00:00:00	2000-04-26	2000-04-26 00:00:00	2000-04-26	581452		0	0	0		0	0	0	274026	0	113	40213227		
124199	2732	40213306	1991-10-10	1991-10-10 00:00:00	1991-10-10	1991-10-10 00:00:00	1991-10-10	581452		0	0	0		0	0	0	180905	0	43	40213306		
91331	2004	40213160	1972-02-08	1972-02-08 00:00:00	1972-02-08	1972-02-08 00:00:00	1972-02-08	581452		0	0	0		0	0	0	133457	0	10	40213160		
42295	3509	40236824	1972-02-10	1972-02-10 00:00:00	1972-02-17	1972-02-17 00:00:00	1972-02-17	38000177		0	0	7		0	0	0	232703	0	1094107	40236824		
37317	3083	19133873	1962-01-19	1962-01-19 00:00:00	1962-01-27	1962-01-27 00:00:00	1962-01-27	38000177		0	0	8		0	0	0	205318	0	834061	19133873		
33125	2747	19059056	1980-06-29	1980-06-29 00:00:00	1980-07-20	1980-07-20 00:00:00	1980-07-20	38000177		0	0	21		0	0	0	181718	0	243670	19059056		
233070	5121	40213296	2005-11-18	2005-11-18 00:00:00	2005-11-18	2005-11-18 00:00:00	2005-11-18	581452		0	0	0		0	0	0	340470	0	52	40213296		
52941	4398	19006318	1960-01-13	1960-01-13 00:00:00	1960-01-27	1960-01-27 00:00:00	1960-01-27	38000177		0	0	14		0	0	0	292455	0	105078	19006318		
173007	3803	40213306	1983-09-07	1983-09-07 00:00:00	1983-09-07	1983-09-07 00:00:00	1983-09-07	581452		0	0	0		0	0	0	252822	0	43	40213306		
101799	2232	40213160	1964-01-17	1964-01-17 00:00:00	1964-01-17	1964-01-17 00:00:00	1964-01-17	581452		0	0	0		0	0	0	148529	0	10	40213160		
40425	3352	19133873	1966-11-22	1966-11-22 00:00:00	1966-12-04	1966-12-04 00:00:00	1966-12-04	38000177		0	0	12		0	0	0	222292	0	834061	19133873		
219981	4828	40213306	1989-07-12	1989-07-12 00:00:00	1989-07-12	1989-07-12 00:00:00	1989-07-12	581452		0	0	0		0	0	0	321298	0	43	40213306		
16625	1378	1127433	2013-08-27	2013-08-27 00:00:00	2013-09-10	2013-09-10 00:00:00	2013-09-10	38000177		0	0	14		0	0	0	91320	0	313782	1127433		
34407	2843	1127433	1961-06-11	1961-06-11 00:00:00	1961-06-18	1961-06-18 00:00:00	1961-06-18	38000177		0	0	7		0	0	0	188758	0	313782	1127433		
34449	2846	19006318	1977-10-11	1977-10-11 00:00:00	1977-10-25	1977-10-25 00:00:00	1977-10-25	38000177		0	0	14		0	0	0	188995	0	105078	19006318		
45219	3743	19129655	1978-07-10	1978-07-10 00:00:00	1978-07-24	1978-07-24 00:00:00	1978-07-24	38000177		0	0	14		0	0	0	248733	0	789980	19129655		
14237	307	40213160	1969-11-29	1969-11-29 00:00:00	1969-11-29	1969-11-29 00:00:00	1969-11-29	581452		0	0	0		0	0	0	20344	0	10	40213160		
62386	5193	40220960	2010-06-10	2010-06-10 00:00:00	2010-06-10	2010-06-10 00:00:00	2010-06-10	38000177		0	0	0		0	0	0	345180	0	1804799	40220960		
17719	1468	40229134	1989-07-13	1989-07-13 00:00:00	1989-07-20	1989-07-20 00:00:00	1989-07-20	38000177		0	0	7		0	0	0	97862	0	1043400	40229134		
55859	4637	1127433	1989-08-10	1989-08-10 00:00:00	1989-08-24	1989-08-24 00:00:00	1989-08-24	38000177		0	0	14		0	0	0	309045	0	313782	1127433		
55905	4641	19128065	1985-06-18	1985-06-18 00:00:00	1986-06-13	1986-06-13 00:00:00	1986-06-13	38000177		0	0	360		0	0	0	309289	0	749882	19128065		
35117	2897	1127433	1983-07-28	1983-07-28 00:00:00	1983-08-25	1983-08-25 00:00:00	1983-08-25	38000177		0	0	28		0	0	0	192943	0	313782	1127433		
21448	1762	40236824	2002-12-09	2002-12-09 00:00:00	2002-12-16	2002-12-16 00:00:00	2002-12-16	38000177		0	0	7		0	0	0	117866	0	1094107	40236824		
10771	895	19129655	1963-12-16	1963-12-16 00:00:00	1963-12-30	1963-12-30 00:00:00	1963-12-30	38000177		0	0	14		0	0	0	59701	0	789980	19129655		
48552	4021	1713671	2015-04-05	2015-04-05 00:00:00	2015-04-26	2015-04-26 00:00:00	2015-04-26	38000177		0	0	21		0	0	0	267326	0	562251	1713671		
128012	2815	40213306	1985-07-19	1985-07-19 00:00:00	1985-07-19	1985-07-19 00:00:00	1985-07-19	581452		0	0	0		0	0	0	186529	0	43	40213306		
40707	3375	1118084	1995-09-11	1995-09-11 00:00:00	1995-09-11	1995-09-11 00:00:00	\N	38000177		0	0	0		0	0	0	223880	0	00025152531	44923712		
204345	4485	40213201	2016-11-17	2016-11-17 00:00:00	2016-11-17	2016-11-17 00:00:00	2016-11-17	581452		0	0	0		0	0	0	298616	0	33	40213201		
49651	4119	1127433	2018-04-10	2018-04-10 00:00:00	2018-04-17	2018-04-17 00:00:00	2018-04-17	38000177		0	0	7		0	0	0	273873	0	313782	1127433		
154890	3409	40213296	1998-11-19	1998-11-19 00:00:00	1998-11-19	1998-11-19 00:00:00	1998-11-19	581452		0	0	0		0	0	0	226105	0	52	40213296		
112133	2463	40213306	1991-06-13	1991-06-13 00:00:00	1991-06-13	1991-06-13 00:00:00	1991-06-13	581452		0	0	0		0	0	0	163373	0	43	40213306		
176742	3885	40213227	2014-06-27	2014-06-27 00:00:00	2014-06-27	2014-06-27 00:00:00	2014-06-27	581452		0	0	0		0	0	0	\N	0	113	40213227		
50157	4160	40229134	1964-03-28	1964-03-28 00:00:00	1964-04-11	1964-04-11 00:00:00	1964-04-11	38000177		0	0	14		0	0	0	276414	0	1043400	40229134		
96027	2105	40213160	1975-01-26	1975-01-26 00:00:00	1975-01-26	1975-01-26 00:00:00	1975-01-26	581452		0	0	0		0	0	0	140265	0	10	40213160		
59354	4933	19059056	1974-11-09	1974-11-09 00:00:00	1974-11-30	1974-11-30 00:00:00	1974-11-30	38000177		0	0	21		0	0	0	327965	0	243670	19059056		
50565	1108	40213160	1970-01-07	1970-01-07 00:00:00	1970-01-07	1970-01-07 00:00:00	1970-01-07	581452		0	0	0		0	0	0	72957	0	10	40213160		
24897	2046	19059056	1942-10-11	1942-10-11 00:00:00	1942-10-25	1942-10-25 00:00:00	1942-10-25	38000177		0	0	14		0	0	0	136177	0	243670	19059056		
64471	1410	40213227	1998-06-04	1998-06-04 00:00:00	1998-06-04	1998-06-04 00:00:00	1998-06-04	581452		0	0	0		0	0	0	93890	0	113	40213227		
13543	1134	19059056	1942-02-04	1942-02-04 00:00:00	1942-02-18	1942-02-18 00:00:00	1942-02-18	38000177		0	0	14		0	0	0	74653	0	243670	19059056		
23128	1906	19129655	1965-06-13	1965-06-13 00:00:00	1965-06-27	1965-06-27 00:00:00	1965-06-27	38000177		0	0	14		0	0	0	126856	0	789980	19129655		
24105	1982	19059056	1961-06-24	1961-06-24 00:00:00	1961-07-29	1961-07-29 00:00:00	1961-07-29	38000177		0	0	35		0	0	0	131974	0	243670	19059056		
24151	1986	1115171	2009-12-31	2009-12-31 00:00:00	2010-01-14	2010-01-14 00:00:00	2010-01-14	38000177		0	0	14		0	0	0	132267	0	849574	1115171		
81407	1779	40213198	2010-03-04	2010-03-04 00:00:00	2010-03-04	2010-03-04 00:00:00	2010-03-04	581452		0	0	0		0	0	0	119015	0	133	40213198		
163886	3604	40213227	2017-07-07	2017-07-07 00:00:00	2017-07-07	2017-07-07 00:00:00	2017-07-07	581452		0	0	0		0	0	0	239472	0	113	40213227		
154505	3401	40213227	1992-11-01	1992-11-01 00:00:00	1992-11-01	1992-11-01 00:00:00	1992-11-01	581452		0	0	0		0	0	0	225631	0	113	40213227		
123111	2706	40213160	1968-03-19	1968-03-19 00:00:00	1968-03-19	1968-03-19 00:00:00	1968-03-19	581452		0	0	0		0	0	0	179275	0	10	40213160		
34036	743	40213306	1998-02-08	1998-02-08 00:00:00	1998-02-08	1998-02-08 00:00:00	1998-02-08	581452		0	0	0		0	0	0	49230	0	43	40213306		
61911	1353	40213260	2007-03-12	2007-03-12 00:00:00	2007-03-12	2007-03-12 00:00:00	2007-03-12	581452		0	0	0		0	0	0	89635	0	121	40213260		
242419	5322	40213201	2013-08-21	2013-08-21 00:00:00	2013-08-21	2013-08-21 00:00:00	2013-08-21	581452		0	0	0		0	0	0	354201	0	33	40213201		
6891	149	40213227	2012-09-25	2012-09-25 00:00:00	2012-09-25	2012-09-25 00:00:00	2012-09-25	581452		0	0	0		0	0	0	10101	0	113	40213227		
25231	2077	19077572	2004-07-25	2004-07-25 00:00:00	2004-07-25	2004-07-25 00:00:00	\N	38000177		0	0	0		0	0	0	138324	0	310436	19077572		
166092	3651	40213227	2000-09-28	2000-09-28 00:00:00	2000-09-28	2000-09-28 00:00:00	2000-09-28	581452		0	0	0		0	0	0	243031	0	113	40213227		
5169	432	19018935	2014-06-23	2014-06-23 00:00:00	2014-06-23	2014-06-23 00:00:00	\N	38000177		0	0	0		0	0	0	28655	0	197604	19018935		
56041	4653	19073188	2002-06-17	2002-06-17 00:00:00	2002-07-01	2002-07-01 00:00:00	2002-07-01	38000177		0	0	14		0	0	0	310142	0	308192	19073188		
56106	4657	40229134	1993-05-05	1993-05-05 00:00:00	1993-05-19	1993-05-19 00:00:00	1993-05-19	38000177		0	0	14		0	0	0	310505	0	1043400	40229134		
10378	867	1124300	1966-01-05	1966-01-05 00:00:00	1966-01-05	1966-01-05 00:00:00	\N	38000177		0	0	0		0	0	0	57605	0	00781178901	45011828		
205366	4506	40213227	1996-01-04	1996-01-04 00:00:00	1996-01-04	1996-01-04 00:00:00	1996-01-04	581452		0	0	0		0	0	0	300137	0	113	40213227		
16999	1408	1118084	1981-03-10	1981-03-10 00:00:00	1981-03-10	1981-03-10 00:00:00	\N	38000177		0	0	0		0	0	0	93687	0	00025152531	44923712		
121826	2677	40213160	1977-03-25	1977-03-25 00:00:00	1977-03-25	1977-03-25 00:00:00	1977-03-25	581452		0	0	0		0	0	0	177397	0	10	40213160		
192410	4227	40213160	1955-07-24	1955-07-24 00:00:00	1955-07-24	1955-07-24 00:00:00	1955-07-24	581452		0	0	0		0	0	0	280824	0	10	40213160		
31545	2616	19006318	1955-08-01	1955-08-01 00:00:00	1955-08-15	1955-08-15 00:00:00	1955-08-15	38000177		0	0	14		0	0	0	172981	0	105078	19006318		
112745	2477	40213160	1960-01-03	1960-01-03 00:00:00	1960-01-03	1960-01-03 00:00:00	1960-01-03	581452		0	0	0		0	0	0	164130	0	10	40213160		
29307	639	40213160	1956-06-09	1956-06-09 00:00:00	1956-06-09	1956-06-09 00:00:00	1956-06-09	581452		0	0	0		0	0	0	42272	0	10	40213160		
54858	4557	40165015	1969-11-12	1969-11-12 00:00:00	1969-11-12	1969-11-12 00:00:00	\N	38000177		0	0	0		0	0	0	303641	0	861467	40165015		
187689	4122	40213227	2010-09-29	2010-09-29 00:00:00	2010-09-29	2010-09-29 00:00:00	2010-09-29	581452		0	0	0		0	0	0	274029	0	113	40213227		
124201	2732	40213160	1969-11-13	1969-11-13 00:00:00	1969-11-13	1969-11-13 00:00:00	1969-11-13	581452		0	0	0		0	0	0	180864	0	10	40213160		
91343	2005	40213227	2004-09-04	2004-09-04 00:00:00	2004-09-04	2004-09-04 00:00:00	2004-09-04	581452		0	0	0		0	0	0	133530	0	113	40213227		
42296	3509	920300	1972-02-10	1972-02-10 00:00:00	1972-02-17	1972-02-17 00:00:00	1972-02-17	38000177		0	0	7		0	0	0	232703	0	311989	920300		
37318	3083	40236824	1990-06-01	1990-06-01 00:00:00	1990-06-08	1990-06-08 00:00:00	1990-06-08	38000177		0	0	7		0	0	0	205262	0	1094107	40236824		
33126	2747	1127433	2008-12-09	2008-12-09 00:00:00	2008-12-23	2008-12-23 00:00:00	2008-12-23	38000177		0	0	14		0	0	0	181676	0	313782	1127433		
50635	4208	19059056	1940-05-15	1940-05-15 00:00:00	1940-05-29	1940-05-29 00:00:00	1940-05-29	38000177		0	0	14		0	0	0	279452	0	243670	19059056		
52953	4401	40169216	1973-01-10	1973-01-10 00:00:00	1990-01-20	1990-01-20 00:00:00	1990-01-20	38000177		0	0	6219		0	0	0	292577	0	895994	40169216		
173009	3803	40213306	1982-06-09	1982-06-09 00:00:00	1982-06-09	1982-06-09 00:00:00	1982-06-09	581452		0	0	0		0	0	0	252795	0	43	40213306		
101805	2232	40213160	1963-08-16	1963-08-16 00:00:00	1963-08-16	1963-08-16 00:00:00	1963-08-16	581452		0	0	0		0	0	0	148528	0	10	40213160		
40426	3352	1127433	1984-10-22	1984-10-22 00:00:00	1984-11-12	1984-11-12 00:00:00	1984-11-12	38000177		0	0	21		0	0	0	222260	0	313782	1127433		
219985	4828	40213227	2018-05-16	2018-05-16 00:00:00	2018-05-16	2018-05-16 00:00:00	2018-05-16	581452		0	0	0		0	0	0	321264	0	113	40213227		
16626	1378	1713671	2001-10-17	2001-10-17 00:00:00	2001-10-31	2001-10-31 00:00:00	2001-10-31	38000177		0	0	14		0	0	0	91310	0	562251	1713671		
34408	2843	1127433	1960-02-29	1960-02-29 00:00:00	1960-03-07	1960-03-07 00:00:00	1960-03-07	38000177		0	0	7		0	0	0	188730	0	313782	1127433		
34450	2846	1127078	1977-10-11	1977-10-11 00:00:00	1977-10-25	1977-10-25 00:00:00	1977-10-25	38000177		0	0	14		0	0	0	188995	0	282464	1127078		
45220	3743	1127433	1981-11-22	1981-11-22 00:00:00	1981-11-29	1981-11-29 00:00:00	1981-11-29	38000177		0	0	7		0	0	0	248692	0	313782	1127433		
14240	307	40213227	2010-09-04	2010-09-04 00:00:00	2010-09-04	2010-09-04 00:00:00	2010-09-04	581452		0	0	0		0	0	0	20355	0	113	40213227		
62387	5193	19133873	1975-06-06	1975-06-06 00:00:00	1975-06-14	1975-06-14 00:00:00	1975-06-14	38000177		0	0	8		0	0	0	345179	0	834061	19133873		
17720	1468	1713671	1969-10-24	1969-10-24 00:00:00	1969-10-31	1969-10-31 00:00:00	1969-10-31	38000177		0	0	7		0	0	0	97791	0	562251	1713671		
55860	4637	1127433	1988-05-09	1988-05-09 00:00:00	1988-05-16	1988-05-16 00:00:00	1988-05-16	38000177		0	0	7		0	0	0	309013	0	313782	1127433		
55906	4641	19019979	1975-05-02	1975-05-02 00:00:00	1975-05-16	1975-05-16 00:00:00	1975-05-16	38000177		0	0	14		0	0	0	309299	0	198405	19019979		
35118	2898	1124300	2016-08-29	2016-08-29 00:00:00	2016-08-29	2016-08-29 00:00:00	\N	38000177		0	0	0		0	0	0	193099	0	00781178901	45011828		
646	49	1127433	1997-05-30	1997-05-30 00:00:00	1997-06-13	1997-06-13 00:00:00	1997-06-13	38000177		0	0	14		0	0	0	3562	0	313782	1127433		
10772	895	19075601	1999-01-15	1999-01-15 00:00:00	1999-01-15	1999-01-15 00:00:00	\N	38000177		0	0	0		0	0	0	59666	0	309362	19075601		
48553	4021	19059056	1966-04-10	1966-04-10 00:00:00	1966-05-01	1966-05-01 00:00:00	1966-05-01	38000177		0	0	21		0	0	0	267347	0	243670	19059056		
163270	3592	40213160	1965-10-06	1965-10-06 00:00:00	1965-10-06	1965-10-06 00:00:00	1965-10-06	581452		0	0	0		0	0	0	238603	0	10	40213160		
40708	3375	19133905	1993-03-14	1993-03-14 00:00:00	1993-03-26	1993-03-26 00:00:00	1993-03-26	38000177		0	0	12		0	0	0	223854	0	834102	19133905		
204572	4491	40213227	2007-07-15	2007-07-15 00:00:00	2007-07-15	2007-07-15 00:00:00	2007-07-15	581452		0	0	0		0	0	0	298993	0	113	40213227		
49652	4119	19133873	1949-10-12	1949-10-12 00:00:00	1949-10-23	1949-10-23 00:00:00	1949-10-23	38000177		0	0	11		0	0	0	273792	0	834061	19133873		
154898	3409	40213260	2007-12-20	2007-12-20 00:00:00	2007-12-20	2007-12-20 00:00:00	2007-12-20	581452		0	0	0		0	0	0	226099	0	121	40213260		
112140	2463	40213160	1974-03-21	1974-03-21 00:00:00	1974-03-21	1974-03-21 00:00:00	1974-03-21	581452		0	0	0		0	0	0	163349	0	10	40213160		
84650	1851	40213251	1984-11-29	1984-11-29 00:00:00	1984-11-29	1984-11-29 00:00:00	1984-11-29	581452		0	0	0		0	0	0	123822	0	21	40213251		
50158	4160	19129655	1964-01-26	1964-01-26 00:00:00	1964-02-09	1964-02-09 00:00:00	1964-02-09	38000177		0	0	14		0	0	0	276418	0	789980	19129655		
96029	2105	40213314	1977-06-12	1977-06-12 00:00:00	1977-06-12	1977-06-12 00:00:00	1977-06-12	581452		0	0	0		0	0	0	140211	0	49	40213314		
59355	4933	19078461	1998-10-28	1998-10-28 00:00:00	1998-12-04	1998-12-04 00:00:00	1998-12-04	38000177		0	0	37		0	0	0	327970	0	310965	19078461		
50567	1108	40213296	2013-06-12	2013-06-12 00:00:00	2013-06-12	2013-06-12 00:00:00	2013-06-12	581452		0	0	0		0	0	0	72937	0	52	40213296		
24898	2046	1127433	1951-02-15	1951-02-15 00:00:00	1951-02-22	1951-02-22 00:00:00	1951-02-22	38000177		0	0	7		0	0	0	136099	0	313782	1127433		
64472	1410	40213160	1967-11-22	1967-11-22 00:00:00	1967-11-22	1967-11-22 00:00:00	1967-11-22	581452		0	0	0		0	0	0	93853	0	10	40213160		
13544	1135	1118084	1999-06-05	1999-06-05 00:00:00	1999-06-05	1999-06-05 00:00:00	\N	38000177		0	0	0		0	0	0	74783	0	00025152531	44923712		
23129	1906	1127078	1965-06-13	1965-06-13 00:00:00	1965-06-27	1965-06-27 00:00:00	1965-06-27	38000177		0	0	14		0	0	0	126856	0	282464	1127078		
24106	1982	19133905	1992-10-26	1992-10-26 00:00:00	1992-11-05	1992-11-05 00:00:00	1992-11-05	38000177		0	0	10		0	0	0	132019	0	834102	19133905		
24152	1986	40229134	2005-11-05	2005-11-05 00:00:00	2005-11-12	2005-11-12 00:00:00	2005-11-12	38000177		0	0	7		0	0	0	132249	0	1043400	40229134		
199762	4388	40213296	2008-05-10	2008-05-10 00:00:00	2008-05-10	2008-05-10 00:00:00	2008-05-10	581452		0	0	0		0	0	0	291676	0	52	40213296		
163888	3604	40213227	2005-06-24	2005-06-24 00:00:00	2005-06-24	2005-06-24 00:00:00	2005-06-24	581452		0	0	0		0	0	0	239467	0	113	40213227		
154508	3401	40213227	2000-10-01	2000-10-01 00:00:00	2000-10-01	2000-10-01 00:00:00	2000-10-01	581452		0	0	0		0	0	0	225589	0	113	40213227		
123112	2706	40213296	2004-06-15	2004-06-15 00:00:00	2004-06-15	2004-06-15 00:00:00	2004-06-15	581452		0	0	0		0	0	0	179268	0	52	40213296		
34038	743	40213314	1977-01-09	1977-01-09 00:00:00	1977-01-09	1977-01-09 00:00:00	1977-01-09	581452		0	0	0		0	0	0	49284	0	49	40213314		
4483	372	1127433	1999-05-15	1999-05-15 00:00:00	1999-06-05	1999-06-05 00:00:00	1999-06-05	38000177		0	0	21		0	0	0	24788	0	313782	1127433		
178175	3917	40213227	2000-02-03	2000-02-03 00:00:00	2000-02-03	2000-02-03 00:00:00	2000-02-03	581452		0	0	0		0	0	0	260469	0	113	40213227		
6894	149	40213227	1993-07-13	1993-07-13 00:00:00	1993-07-13	1993-07-13 00:00:00	1993-07-13	581452		0	0	0		0	0	0	10096	0	113	40213227		
25232	2077	1127433	1946-11-09	1946-11-09 00:00:00	1946-11-23	1946-11-23 00:00:00	1946-11-23	38000177		0	0	14		0	0	0	138332	0	313782	1127433		
166096	3651	40213227	2011-07-07	2011-07-07 00:00:00	2011-07-07	2011-07-07 00:00:00	2011-07-07	581452		0	0	0		0	0	0	243020	0	113	40213227		
5170	432	40171902	2014-06-23	2014-06-23 00:00:00	2014-06-23	2014-06-23 00:00:00	\N	38000177		0	0	0		0	0	0	28655	0	897718	40171902		
56042	4653	19078461	2002-06-17	2002-06-17 00:00:00	2002-07-01	2002-07-01 00:00:00	2002-07-01	38000177		0	0	14		0	0	0	310142	0	310965	19078461		
56107	4657	1127078	1961-08-03	1961-08-03 00:00:00	1961-08-17	1961-08-17 00:00:00	1961-08-17	38000177		0	0	14		0	0	0	310492	0	282464	1127078		
10379	867	1115171	1998-09-29	1998-09-29 00:00:00	1998-11-28	1998-11-28 00:00:00	1998-11-28	38000177		0	0	60		0	0	0	57582	0	849574	1115171		
205367	4506	40213296	1996-01-04	1996-01-04 00:00:00	1996-01-04	1996-01-04 00:00:00	1996-01-04	581452		0	0	0		0	0	0	300137	0	52	40213296		
17000	1408	19059056	1947-08-11	1947-08-11 00:00:00	1947-08-25	1947-08-25 00:00:00	1947-08-25	38000177		0	0	14		0	0	0	93595	0	243670	19059056		
86042	1885	40213227	2006-11-14	2006-11-14 00:00:00	2006-11-14	2006-11-14 00:00:00	2006-11-14	581452		0	0	0		0	0	0	125682	0	113	40213227		
192415	4227	40213227	2006-02-19	2006-02-19 00:00:00	2006-02-19	2006-02-19 00:00:00	2006-02-19	581452		0	0	0		0	0	0	280777	0	113	40213227		
31546	2616	1127078	1954-11-28	1954-11-28 00:00:00	1954-12-12	1954-12-12 00:00:00	1954-12-12	38000177		0	0	14		0	0	0	172946	0	282464	1127078		
212607	4662	40213227	2011-10-08	2011-10-08 00:00:00	2011-10-08	2011-10-08 00:00:00	2011-10-08	581452		0	0	0		0	0	0	310768	0	113	40213227		
71946	1572	40213296	2002-06-28	2002-06-28 00:00:00	2002-06-28	2002-06-28 00:00:00	2002-06-28	581452		0	0	0		0	0	0	105615	0	52	40213296		
54859	4557	1713671	2010-01-16	2010-01-16 00:00:00	2010-01-30	2010-01-30 00:00:00	2010-01-30	38000177		0	0	14		0	0	0	303648	0	562251	1713671		
187690	4122	40213296	2010-09-29	2010-09-29 00:00:00	2010-09-29	2010-09-29 00:00:00	2010-09-29	581452		0	0	0		0	0	0	274029	0	52	40213296		
124205	2732	40213296	2009-08-13	2009-08-13 00:00:00	2009-08-13	2009-08-13 00:00:00	2009-08-13	581452		0	0	0		0	0	0	180870	0	52	40213296		
54714	4546	920300	2005-07-15	2005-07-15 00:00:00	2005-07-22	2005-07-22 00:00:00	2005-07-22	38000177		0	0	7		0	0	0	302812	0	311989	920300		
42297	3509	1127433	1961-03-08	1961-03-08 00:00:00	1961-03-22	1961-03-22 00:00:00	1961-03-22	38000177		0	0	14		0	0	0	232782	0	313782	1127433		
37319	3083	920300	1990-06-01	1990-06-01 00:00:00	1990-06-08	1990-06-08 00:00:00	1990-06-08	38000177		0	0	7		0	0	0	205262	0	311989	920300		
33127	2747	19133905	1994-09-23	1994-09-23 00:00:00	1994-10-04	1994-10-04 00:00:00	1994-10-04	38000177		0	0	11		0	0	0	181717	0	834102	19133905		
50636	4208	1127433	1961-02-17	1961-02-17 00:00:00	1961-02-24	1961-02-24 00:00:00	1961-02-24	38000177		0	0	7		0	0	0	279398	0	313782	1127433		
52954	4401	1154615	1973-01-10	1973-01-10 00:00:00	1990-01-20	1990-01-20 00:00:00	1990-01-20	38000177		0	0	6219		0	0	0	292577	0	745679	1154615		
184237	4049	40213227	1993-08-17	1993-08-17 00:00:00	1993-08-17	1993-08-17 00:00:00	1993-08-17	581452		0	0	0		0	0	0	\N	0	113	40213227		
101807	2232	40213260	2014-05-16	2014-05-16 00:00:00	2014-05-16	2014-05-16 00:00:00	2014-05-16	581452		0	0	0		0	0	0	148546	0	121	40213260		
40427	3352	40231925	1984-10-22	1984-10-22 00:00:00	1984-10-22	1984-10-22 00:00:00	\N	38000177		0	0	0		0	0	0	222260	0	1049221	40231925		
219986	4828	40213260	2018-05-16	2018-05-16 00:00:00	2018-05-16	2018-05-16 00:00:00	2018-05-16	581452		0	0	0		0	0	0	321264	0	121	40213260		
16627	1378	19133905	1962-10-29	1962-10-29 00:00:00	1962-11-05	1962-11-05 00:00:00	1962-11-05	38000177		0	0	7		0	0	0	91432	0	834102	19133905		
34409	2844	40229134	1964-11-11	1964-11-11 00:00:00	1964-11-25	1964-11-25 00:00:00	1964-11-25	38000177		0	0	14		0	0	0	188827	0	1043400	40229134		
34451	2846	1127078	1984-02-07	1984-02-07 00:00:00	1984-02-21	1984-02-21 00:00:00	1984-02-21	38000177		0	0	14		0	0	0	188990	0	282464	1127078		
45221	3743	1713671	2008-12-21	2008-12-21 00:00:00	2008-12-28	2008-12-28 00:00:00	2008-12-28	38000177		0	0	7		0	0	0	248706	0	562251	1713671		
14241	307	40213296	2010-09-04	2010-09-04 00:00:00	2010-09-04	2010-09-04 00:00:00	2010-09-04	581452		0	0	0		0	0	0	20355	0	52	40213296		
62388	5193	19018935	2015-09-24	2015-09-24 00:00:00	2015-09-24	2015-09-24 00:00:00	\N	38000177		0	0	0		0	0	0	345235	0	197604	19018935		
17721	1468	40236824	1998-07-07	1998-07-07 00:00:00	1998-07-14	1998-07-14 00:00:00	1998-07-14	38000177		0	0	7		0	0	0	97811	0	1094107	40236824		
55861	4637	1115171	2011-12-25	2011-12-25 00:00:00	2012-01-15	2012-01-15 00:00:00	2012-01-15	38000177		0	0	21		0	0	0	309050	0	849574	1115171		
55907	4641	46233988	1975-05-02	1975-05-02 00:00:00	1975-05-16	1975-05-16 00:00:00	1975-05-16	38000177		0	0	14		0	0	0	309299	0	1652673	46233988		
35119	2898	920300	2015-03-30	2015-03-30 00:00:00	2015-04-06	2015-04-06 00:00:00	2015-04-06	38000177		0	0	7		0	0	0	193099	0	311989	920300		
647	49	1713671	2006-03-26	2006-03-26 00:00:00	2006-04-16	2006-04-16 00:00:00	2006-04-16	38000177		0	0	21		0	0	0	3564	0	562251	1713671		
10773	895	1127433	1980-02-22	1980-02-22 00:00:00	1980-03-07	1980-03-07 00:00:00	1980-03-07	38000177		0	0	14		0	0	0	59719	0	313782	1127433		
48554	4021	40229134	1970-06-24	1970-06-24 00:00:00	1970-07-08	1970-07-08 00:00:00	1970-07-08	38000177		0	0	14		0	0	0	267306	0	1043400	40229134		
163273	3592	40213227	2006-06-07	2006-06-07 00:00:00	2006-06-07	2006-06-07 00:00:00	2006-06-07	581452		0	0	0		0	0	0	238580	0	113	40213227		
40709	3375	1127433	2014-11-23	2014-11-23 00:00:00	2014-12-07	2014-12-07 00:00:00	2014-12-07	38000177		0	0	14		0	0	0	223873	0	313782	1127433		
204578	4491	40213227	2017-09-10	2017-09-10 00:00:00	2017-09-10	2017-09-10 00:00:00	2017-09-10	581452		0	0	0		0	0	0	299008	0	113	40213227		
49653	4119	19133905	2012-05-08	2012-05-08 00:00:00	2012-05-19	2012-05-19 00:00:00	2012-05-19	38000177		0	0	11		0	0	0	273793	0	834102	19133905		
154902	3409	40213160	1955-11-24	1955-11-24 00:00:00	1955-11-24	1955-11-24 00:00:00	1955-11-24	581452		0	0	0		0	0	0	226098	0	10	40213160		
112142	2463	40213296	2009-04-16	2009-04-16 00:00:00	2009-04-16	2009-04-16 00:00:00	2009-04-16	581452		0	0	0		0	0	0	163364	0	52	40213296		
84654	1851	40213306	2001-01-25	2001-01-25 00:00:00	2001-01-25	2001-01-25 00:00:00	2001-01-25	581452		0	0	0		0	0	0	123832	0	43	40213306		
50159	4160	1127078	1964-01-26	1964-01-26 00:00:00	1964-02-09	1964-02-09 00:00:00	1964-02-09	38000177		0	0	14		0	0	0	276418	0	282464	1127078		
96034	2105	40213296	2015-03-15	2015-03-15 00:00:00	2015-03-15	2015-03-15 00:00:00	2015-03-15	581452		0	0	0		0	0	0	140261	0	52	40213296		
59356	4933	1713671	1972-12-26	1972-12-26 00:00:00	1973-04-17	1973-04-17 00:00:00	1973-04-17	38000177		0	0	112		0	0	0	327939	0	562251	1713671		
50578	1108	40213306	1991-10-02	1991-10-02 00:00:00	1991-10-02	1991-10-02 00:00:00	1991-10-02	581452		0	0	0		0	0	0	72964	0	43	40213306		
24899	2046	1713671	1940-07-31	1940-07-31 00:00:00	1940-08-07	1940-08-07 00:00:00	1940-08-07	38000177		0	0	7		0	0	0	136167	0	562251	1713671		
64476	1410	40213296	2007-03-15	2007-03-15 00:00:00	2007-03-15	2007-03-15 00:00:00	2007-03-15	581452		0	0	0		0	0	0	93865	0	52	40213296		
13545	1135	1127433	2014-07-13	2014-07-13 00:00:00	2014-07-27	2014-07-27 00:00:00	2014-07-27	38000177		0	0	14		0	0	0	74773	0	313782	1127433		
23130	1906	1127433	1981-03-16	1981-03-16 00:00:00	1981-03-30	1981-03-30 00:00:00	1981-03-30	38000177		0	0	14		0	0	0	126866	0	313782	1127433		
24107	1982	1332419	1994-11-10	1994-11-10 00:00:00	1994-11-10	1994-11-10 00:00:00	\N	38000177		0	0	0		0	0	0	132066	0	197361	1332419		
24153	1986	1118084	2014-04-30	2014-04-30 00:00:00	2014-04-30	2014-04-30 00:00:00	\N	38000177		0	0	0		0	0	0	132224	0	00025152531	44923712		
199764	4388	40213227	2008-05-10	2008-05-10 00:00:00	2008-05-10	2008-05-10 00:00:00	2008-05-10	581452		0	0	0		0	0	0	291676	0	113	40213227		
163889	3604	40213306	2005-06-24	2005-06-24 00:00:00	2005-06-24	2005-06-24 00:00:00	2005-06-24	581452		0	0	0		0	0	0	239467	0	43	40213306		
154509	3401	40213296	2000-10-01	2000-10-01 00:00:00	2000-10-01	2000-10-01 00:00:00	2000-10-01	581452		0	0	0		0	0	0	225589	0	52	40213296		
123114	2706	40213227	2004-06-15	2004-06-15 00:00:00	2004-06-15	2004-06-15 00:00:00	2004-06-15	581452		0	0	0		0	0	0	179268	0	113	40213227		
34508	754	40213227	2009-03-31	2009-03-31 00:00:00	2009-03-31	2009-03-31 00:00:00	2009-03-31	581452		0	0	0		0	0	0	49864	0	113	40213227		
4484	372	1118084	2004-10-14	2004-10-14 00:00:00	2004-10-14	2004-10-14 00:00:00	\N	38000177		0	0	0		0	0	0	24728	0	00025152531	44923712		
178179	3917	40213296	2008-02-14	2008-02-14 00:00:00	2008-02-14	2008-02-14 00:00:00	2008-02-14	581452		0	0	0		0	0	0	260487	0	52	40213296		
7127	154	40213296	2014-11-27	2014-11-27 00:00:00	2014-11-27	2014-11-27 00:00:00	2014-11-27	581452		0	0	0		0	0	0	10438	0	52	40213296		
35691	2942	19059056	1957-09-20	1957-09-20 00:00:00	1957-10-04	1957-10-04 00:00:00	1957-10-04	38000177		0	0	14		0	0	0	196191	0	243670	19059056		
166101	3651	40213160	1960-02-04	1960-02-04 00:00:00	1960-02-04	1960-02-04 00:00:00	1960-02-04	581452		0	0	0		0	0	0	243032	0	10	40213160		
5171	432	40163554	2014-06-23	2014-06-23 00:00:00	2014-06-23	2014-06-23 00:00:00	\N	38000177		0	0	0		0	0	0	28655	0	855332	40163554		
56043	4653	1118084	2002-10-29	2002-10-29 00:00:00	2002-10-29	2002-10-29 00:00:00	\N	38000177		0	0	0		0	0	0	310142	0	00025152531	44923712		
56108	4657	920334	1990-12-29	1990-12-29 00:00:00	1991-01-05	1991-01-05 00:00:00	1991-01-05	38000177		0	0	7		0	0	0	310504	0	311995	920334		
10380	867	40231925	1998-09-29	1998-09-29 00:00:00	1998-09-29	1998-09-29 00:00:00	\N	38000177		0	0	0		0	0	0	57582	0	1049221	40231925		
205372	4506	40213160	1955-12-01	1955-12-01 00:00:00	1955-12-01	1955-12-01 00:00:00	1955-12-01	581452		0	0	0		0	0	0	300216	0	10	40213160		
17001	1408	19006318	1947-08-11	1947-08-11 00:00:00	1947-08-25	1947-08-25 00:00:00	1947-08-25	38000177		0	0	14		0	0	0	93595	0	105078	19006318		
86044	1885	40213227	1995-05-02	1995-05-02 00:00:00	1995-05-02	1995-05-02 00:00:00	1995-05-02	581452		0	0	0		0	0	0	125710	0	113	40213227		
192416	4227	40213260	2006-02-19	2006-02-19 00:00:00	2006-02-19	2006-02-19 00:00:00	2006-02-19	581452		0	0	0		0	0	0	280777	0	121	40213260		
31547	2616	19006318	1954-11-28	1954-11-28 00:00:00	1954-12-12	1954-12-12 00:00:00	1954-12-12	38000177		0	0	14		0	0	0	172946	0	105078	19006318		
212638	4662	40213227	2001-08-11	2001-08-11 00:00:00	2001-08-11	2001-08-11 00:00:00	2001-08-11	581452		0	0	0		0	0	0	310748	0	113	40213227		
71950	1572	40213160	1962-11-30	1962-11-30 00:00:00	1962-11-30	1962-11-30 00:00:00	1962-11-30	581452		0	0	0		0	0	0	105581	0	10	40213160		
54860	4557	40236824	1952-05-20	1952-05-20 00:00:00	1952-05-27	1952-05-27 00:00:00	1952-05-27	38000177		0	0	7		0	0	0	303653	0	1094107	40236824		
187693	4122	40213296	2009-07-01	2009-07-01 00:00:00	2009-07-01	2009-07-01 00:00:00	2009-07-01	581452		0	0	0		0	0	0	274048	0	52	40213296		
124209	2732	40213160	1970-01-15	1970-01-15 00:00:00	1970-01-15	1970-01-15 00:00:00	1970-01-15	581452		0	0	0		0	0	0	180844	0	10	40213160		
54715	4546	40236824	2005-07-15	2005-07-15 00:00:00	2005-07-22	2005-07-22 00:00:00	2005-07-22	38000177		0	0	7		0	0	0	302812	0	1094107	40236824		
42298	3509	1118084	1987-05-25	1987-05-25 00:00:00	1987-05-25	1987-05-25 00:00:00	\N	38000177		0	0	0		0	0	0	232754	0	00025152531	44923712		
37320	3083	1127078	1955-04-22	1955-04-22 00:00:00	1955-07-21	1955-07-21 00:00:00	1955-07-21	38000177		0	0	90		0	0	0	205268	0	282464	1127078		
33128	2747	1713671	2001-12-31	2001-12-31 00:00:00	2002-01-07	2002-01-07 00:00:00	2002-01-07	38000177		0	0	7		0	0	0	181657	0	562251	1713671		
50637	4208	1118084	1978-10-03	1978-10-03 00:00:00	1978-10-03	1978-10-03 00:00:00	\N	38000177		0	0	0		0	0	0	279433	0	00025152531	44923712		
63413	5267	920300	1994-12-25	1994-12-25 00:00:00	1995-01-01	1995-01-01 00:00:00	1995-01-01	38000177		0	0	7		0	0	0	350356	0	311989	920300		
184241	4049	40213296	2003-04-15	2003-04-15 00:00:00	2003-04-15	2003-04-15 00:00:00	2003-04-15	581452		0	0	0		0	0	0	269202	0	52	40213296		
101809	2232	40213227	2014-05-16	2014-05-16 00:00:00	2014-05-16	2014-05-16 00:00:00	2014-05-16	581452		0	0	0		0	0	0	148546	0	113	40213227		
40428	3352	19075001	1984-10-22	1984-10-22 00:00:00	1984-11-12	1984-11-12 00:00:00	1984-11-12	38000177		0	0	21		0	0	0	222260	0	309097	19075001		
106727	2340	40213296	1999-03-10	1999-03-10 00:00:00	1999-03-10	1999-03-10 00:00:00	1999-03-10	581452		0	0	0		0	0	0	155717	0	52	40213296		
16628	1378	1124300	1981-07-26	1981-07-26 00:00:00	1981-07-26	1981-07-26 00:00:00	\N	38000177		0	0	0		0	0	0	91322	0	00781178901	45011828		
34410	2844	1127433	1960-10-31	1960-10-31 00:00:00	1961-01-29	1961-01-29 00:00:00	1961-01-29	38000177		0	0	90		0	0	0	188892	0	313782	1127433		
34452	2846	19019979	1981-02-22	1981-02-22 00:00:00	1981-05-23	1981-05-23 00:00:00	1981-05-23	38000177		0	0	90		0	0	0	188988	0	198405	19019979		
45222	3743	19128065	1993-07-31	1993-07-31 00:00:00	1994-07-26	1994-07-26 00:00:00	1994-07-26	38000177		0	0	360		0	0	0	248710	0	749882	19128065		
14254	307	40213306	1990-08-11	1990-08-11 00:00:00	1990-08-11	1990-08-11 00:00:00	1990-08-11	581452		0	0	0		0	0	0	20358	0	43	40213306		
62389	5193	40171902	2015-09-24	2015-09-24 00:00:00	2015-09-24	2015-09-24 00:00:00	\N	38000177		0	0	0		0	0	0	345235	0	897718	40171902		
17722	1468	920300	1998-07-07	1998-07-07 00:00:00	1998-07-14	1998-07-14 00:00:00	1998-07-14	38000177		0	0	7		0	0	0	97811	0	311989	920300		
55862	4637	1115171	2003-05-13	2003-05-13 00:00:00	2003-05-27	2003-05-27 00:00:00	2003-05-27	38000177		0	0	14		0	0	0	309047	0	849574	1115171		
55908	4641	1127433	2017-07-20	2017-07-20 00:00:00	2017-08-03	2017-08-03 00:00:00	2017-08-03	38000177		0	0	14		0	0	0	309338	0	313782	1127433		
35120	2898	40236824	2015-03-30	2015-03-30 00:00:00	2015-04-06	2015-04-06 00:00:00	2015-04-06	38000177		0	0	7		0	0	0	193099	0	1094107	40236824		
648	49	40229134	1978-03-10	1978-03-10 00:00:00	1978-03-24	1978-03-24 00:00:00	1978-03-24	38000177		0	0	14		0	0	0	3540	0	1043400	40229134		
21249	1748	19078461	1976-12-26	1976-12-26 00:00:00	1977-01-23	1977-01-23 00:00:00	1977-01-23	38000177		0	0	28		0	0	0	116871	0	310965	19078461		
48555	4021	1127078	1958-10-14	1958-10-14 00:00:00	1958-11-18	1958-11-18 00:00:00	1958-11-18	38000177		0	0	35		0	0	0	267309	0	282464	1127078		
163274	3592	40213296	2006-06-07	2006-06-07 00:00:00	2006-06-07	2006-06-07 00:00:00	2006-06-07	581452		0	0	0		0	0	0	238580	0	52	40213296		
40711	3376	1127433	1961-11-11	1961-11-11 00:00:00	1961-11-25	1961-11-25 00:00:00	1961-11-25	38000177		0	0	14		0	0	0	224007	0	313782	1127433		
215882	4735	40213227	2004-03-18	2004-03-18 00:00:00	2004-03-18	2004-03-18 00:00:00	2004-03-18	581452		0	0	0		0	0	0	315437	0	113	40213227		
49654	4119	1124300	1984-08-26	1984-08-26 00:00:00	1984-08-26	1984-08-26 00:00:00	\N	38000177		0	0	0		0	0	0	273890	0	00781178901	45011828		
739	16	40213160	1972-01-19	1972-01-19 00:00:00	1972-01-19	1972-01-19 00:00:00	1972-01-19	581452		0	0	0		0	0	0	1205	0	10	40213160		
144275	3172	40213160	1977-04-28	1977-04-28 00:00:00	1977-04-28	1977-04-28 00:00:00	1977-04-28	581452		0	0	0		0	0	0	210825	0	10	40213160		
84656	1851	40213227	2000-02-10	2000-02-10 00:00:00	2000-02-10	2000-02-10 00:00:00	2000-02-10	581452		0	0	0		0	0	0	123855	0	113	40213227		
16094	347	40213296	2012-11-25	2012-11-25 00:00:00	2012-11-25	2012-11-25 00:00:00	2012-11-25	581452		0	0	0		0	0	0	23098	0	52	40213296		
96043	2105	40213227	2017-03-19	2017-03-19 00:00:00	2017-03-19	2017-03-19 00:00:00	2017-03-19	581452		0	0	0		0	0	0	140242	0	113	40213227		
59358	4933	1115171	2007-08-19	2007-08-19 00:00:00	2007-09-23	2007-09-23 00:00:00	2007-09-23	38000177		0	0	35		0	0	0	327971	0	849574	1115171		
50583	1108	40213160	1970-04-08	1970-04-08 00:00:00	1970-04-08	1970-04-08 00:00:00	1970-04-08	581452		0	0	0		0	0	0	72989	0	10	40213160		
24900	2046	1545959	2014-04-01	2014-04-01 00:00:00	2014-04-01	2014-04-01 00:00:00	2014-04-01	38000177		0	0	0		0	0	0	136154	0	259255	1545959		
64483	1410	40213160	1967-06-22	1967-06-22 00:00:00	1967-06-22	1967-06-22 00:00:00	1967-06-22	581452		0	0	0		0	0	0	93852	0	10	40213160		
13546	1135	40229134	1992-01-04	1992-01-04 00:00:00	1992-01-18	1992-01-18 00:00:00	1992-01-18	38000177		0	0	14		0	0	0	74763	0	1043400	40229134		
23131	1906	19059056	1963-01-01	1963-01-01 00:00:00	1963-01-15	1963-01-15 00:00:00	1963-01-15	38000177		0	0	14		0	0	0	126881	0	243670	19059056		
24108	1982	19075601	1997-11-27	1997-11-27 00:00:00	2006-10-19	2006-10-19 00:00:00	2006-10-19	38000177		0	0	3248		0	0	0	132050	0	309362	19075601		
24154	1986	1127433	2007-08-25	2007-08-25 00:00:00	2007-09-22	2007-09-22 00:00:00	2007-09-22	38000177		0	0	28		0	0	0	132214	0	313782	1127433		
211045	4628	40213227	2010-10-10	2010-10-10 00:00:00	2010-10-10	2010-10-10 00:00:00	2010-10-10	581452		0	0	0		0	0	0	308365	0	113	40213227		
163890	3604	40213180	2005-06-24	2005-06-24 00:00:00	2005-06-24	2005-06-24 00:00:00	2005-06-24	581452		0	0	0		0	0	0	239467	0	114	40213180		
154510	3401	40213160	1958-12-28	1958-12-28 00:00:00	1958-12-28	1958-12-28 00:00:00	1958-12-28	581452		0	0	0		0	0	0	225618	0	10	40213160		
123126	2706	40213306	1985-04-16	1985-04-16 00:00:00	1985-04-16	1985-04-16 00:00:00	1985-04-16	581452		0	0	0		0	0	0	179279	0	43	40213306		
122796	2699	40213160	1971-04-27	1971-04-27 00:00:00	1971-04-27	1971-04-27 00:00:00	1971-04-27	581452		0	0	0		0	0	0	178723	0	10	40213160		
4485	372	1127433	1994-11-27	1994-11-27 00:00:00	1994-12-04	1994-12-04 00:00:00	1994-12-04	38000177		0	0	7		0	0	0	24715	0	313782	1127433		
178180	3917	40213260	2017-09-07	2017-09-07 00:00:00	2017-09-07	2017-09-07 00:00:00	2017-09-07	581452		0	0	0		0	0	0	260497	0	121	40213260		
7128	154	40213160	1975-05-01	1975-05-01 00:00:00	1975-05-01	1975-05-01 00:00:00	1975-05-01	581452		0	0	0		0	0	0	10462	0	10	40213160		
35692	2942	40169216	1956-08-04	1956-08-04 00:00:00	1956-08-04	1956-08-04 00:00:00	\N	38000177		0	0	0		0	0	0	196086	0	895994	40169216		
166103	3651	40213160	1964-08-06	1964-08-06 00:00:00	1964-08-06	1964-08-06 00:00:00	1964-08-06	581452		0	0	0		0	0	0	243036	0	10	40213160		
5172	432	1127433	1939-01-17	1939-01-17 00:00:00	1939-01-24	1939-01-24 00:00:00	1939-01-24	38000177		0	0	7		0	0	0	28741	0	313782	1127433		
56044	4653	19059056	1959-06-22	1959-06-22 00:00:00	1959-07-06	1959-07-06 00:00:00	1959-07-06	38000177		0	0	14		0	0	0	310141	0	243670	19059056		
9851	209	40213160	1955-01-28	1955-01-28 00:00:00	1955-01-28	1955-01-28 00:00:00	1955-01-28	581452		0	0	0		0	0	0	14292	0	10	40213160		
10381	867	1127433	1971-05-29	1971-05-29 00:00:00	1971-06-12	1971-06-12 00:00:00	1971-06-12	38000177		0	0	14		0	0	0	57577	0	313782	1127433		
205379	4506	40213160	1958-12-04	1958-12-04 00:00:00	1958-12-04	1958-12-04 00:00:00	1958-12-04	581452		0	0	0		0	0	0	300218	0	10	40213160		
17002	1408	19133905	1992-11-20	1992-11-20 00:00:00	1992-12-01	1992-12-01 00:00:00	1992-12-01	38000177		0	0	11		0	0	0	93651	0	834102	19133905		
86045	1885	40213306	1995-05-02	1995-05-02 00:00:00	1995-05-02	1995-05-02 00:00:00	1995-05-02	581452		0	0	0		0	0	0	125710	0	43	40213306		
192418	4227	40213160	1955-05-22	1955-05-22 00:00:00	1955-05-22	1955-05-22 00:00:00	1955-05-22	581452		0	0	0		0	0	0	280830	0	10	40213160		
31548	2616	1127433	2018-12-10	2018-12-10 00:00:00	2018-12-24	2018-12-24 00:00:00	2018-12-24	38000177		0	0	14		0	0	0	172980	0	313782	1127433		
212641	4662	40213198	2015-10-31	2015-10-31 00:00:00	2015-10-31	2015-10-31 00:00:00	2015-10-31	581452		0	0	0		0	0	0	310758	0	133	40213198		
71953	1572	40213227	2013-06-28	2013-06-28 00:00:00	2013-06-28	2013-06-28 00:00:00	2013-06-28	581452		0	0	0		0	0	0	105577	0	113	40213227		
54861	4557	920300	1952-05-20	1952-05-20 00:00:00	1952-05-27	1952-05-27 00:00:00	1952-05-27	38000177		0	0	7		0	0	0	303653	0	311989	920300		
187696	4122	40213160	1969-06-25	1969-06-25 00:00:00	1969-06-25	1969-06-25 00:00:00	1969-06-25	581452		0	0	0		0	0	0	274060	0	10	40213160		
155530	3422	40213160	1967-08-28	1967-08-28 00:00:00	1967-08-28	1967-08-28 00:00:00	1967-08-28	581452		0	0	0		0	0	0	227018	0	10	40213160		
54716	4546	1127433	2012-12-19	2012-12-19 00:00:00	2012-12-26	2012-12-26 00:00:00	2012-12-26	38000177		0	0	7		0	0	0	302801	0	313782	1127433		
42299	3509	40229134	1961-09-20	1961-09-20 00:00:00	1961-09-27	1961-09-27 00:00:00	1961-09-27	38000177		0	0	7		0	0	0	232783	0	1043400	40229134		
37321	3083	19059056	1952-02-23	1952-02-23 00:00:00	1952-03-08	1952-03-08 00:00:00	1952-03-08	38000177		0	0	14		0	0	0	205267	0	243670	19059056		
33129	2747	1115171	2007-02-27	2007-02-27 00:00:00	2007-03-13	2007-03-13 00:00:00	2007-03-13	38000177		0	0	14		0	0	0	181720	0	849574	1115171		
50638	4208	19089061	1972-11-13	1972-11-13 00:00:00	1972-11-27	1972-11-27 00:00:00	1972-11-27	38000177		0	0	14		0	0	0	279445	0	567645	19089061		
63414	5267	40236824	1994-12-25	1994-12-25 00:00:00	1995-01-01	1995-01-01 00:00:00	1995-01-01	38000177		0	0	7		0	0	0	350356	0	1094107	40236824		
184242	4049	40213227	2003-04-15	2003-04-15 00:00:00	2003-04-15	2003-04-15 00:00:00	2003-04-15	581452		0	0	0		0	0	0	269202	0	113	40213227		
101813	2232	40213160	1963-10-18	1963-10-18 00:00:00	1963-10-18	1963-10-18 00:00:00	1963-10-18	581452		0	0	0		0	0	0	148515	0	10	40213160		
40429	3352	19128065	1982-09-29	1982-09-29 00:00:00	1983-09-24	1983-09-24 00:00:00	1983-09-24	38000177		0	0	360		0	0	0	222273	0	749882	19128065		
106735	2340	40213227	2010-03-10	2010-03-10 00:00:00	2010-03-10	2010-03-10 00:00:00	2010-03-10	581452		0	0	0		0	0	0	155728	0	113	40213227		
16629	1378	1127433	2017-07-18	2017-07-18 00:00:00	2017-08-01	2017-08-01 00:00:00	2017-08-01	38000177		0	0	14		0	0	0	91418	0	313782	1127433		
34411	2844	1127433	1978-08-03	1978-08-03 00:00:00	1978-08-10	1978-08-10 00:00:00	1978-08-10	38000177		0	0	7		0	0	0	188866	0	313782	1127433		
34453	2846	1127078	1978-03-26	1978-03-26 00:00:00	1978-04-09	1978-04-09 00:00:00	1978-04-09	38000177		0	0	14		0	0	0	188986	0	282464	1127078		
45223	3743	1127078	1979-07-05	1979-07-05 00:00:00	1979-10-03	1979-10-03 00:00:00	1979-10-03	38000177		0	0	90		0	0	0	248689	0	282464	1127078		
14261	308	40213227	2001-04-17	2001-04-17 00:00:00	2001-04-17	2001-04-17 00:00:00	2001-04-17	581452		0	0	0		0	0	0	20451	0	113	40213227		
62390	5193	40163554	2015-09-24	2015-09-24 00:00:00	2015-09-24	2015-09-24 00:00:00	\N	38000177		0	0	0		0	0	0	345235	0	855332	40163554		
17723	1468	40171902	2015-06-03	2015-06-03 00:00:00	2015-06-03	2015-06-03 00:00:00	\N	38000177		0	0	0		0	0	0	97794	0	897718	40171902		
55863	4637	1118084	2013-04-01	2013-04-01 00:00:00	2013-04-01	2013-04-01 00:00:00	\N	38000177		0	0	0		0	0	0	309061	0	00025152531	44923712		
55909	4641	1713671	2006-08-07	2006-08-07 00:00:00	2006-08-28	2006-08-28 00:00:00	2006-08-28	38000177		0	0	21		0	0	0	309314	0	562251	1713671		
35121	2898	19059056	1982-07-22	1982-07-22 00:00:00	1982-08-05	1982-08-05 00:00:00	1982-08-05	38000177		0	0	14		0	0	0	193111	0	243670	19059056		
649	49	1127078	1978-09-12	1978-09-12 00:00:00	1978-09-26	1978-09-26 00:00:00	1978-09-26	38000177		0	0	14		0	0	0	3535	0	282464	1127078		
22794	495	40213160	1969-01-25	1969-01-25 00:00:00	1969-01-25	1969-01-25 00:00:00	1969-01-25	581452		0	0	0		0	0	0	33045	0	10	40213160		
48557	4021	1115171	2010-02-09	2010-02-09 00:00:00	2010-02-23	2010-02-23 00:00:00	2010-02-23	38000177		0	0	14		0	0	0	267348	0	849574	1115171		
163276	3592	40213160	1965-05-05	1965-05-05 00:00:00	1965-05-05	1965-05-05 00:00:00	1965-05-05	581452		0	0	0		0	0	0	238574	0	10	40213160		
40712	3376	19059056	1964-03-29	1964-03-29 00:00:00	1964-06-27	1964-06-27 00:00:00	1964-06-27	38000177		0	0	90		0	0	0	224000	0	243670	19059056		
215884	4735	40213306	1995-03-09	1995-03-09 00:00:00	1995-03-09	1995-03-09 00:00:00	1995-03-09	581452		0	0	0		0	0	0	315458	0	43	40213306		
49655	4119	19059056	1949-04-27	1949-04-27 00:00:00	1949-06-01	1949-06-01 00:00:00	1949-06-01	38000177		0	0	35		0	0	0	273808	0	243670	19059056		
765	17	40213227	2002-08-19	2002-08-19 00:00:00	2002-08-19	2002-08-19 00:00:00	2002-08-19	581452		0	0	0		0	0	0	1356	0	113	40213227		
144283	3172	40213160	1981-10-29	1981-10-29 00:00:00	1981-10-29	1981-10-29 00:00:00	1981-10-29	581452		0	0	0		0	0	0	210829	0	10	40213160		
84657	1851	40213306	2000-02-10	2000-02-10 00:00:00	2000-02-10	2000-02-10 00:00:00	2000-02-10	581452		0	0	0		0	0	0	123855	0	43	40213306		
16095	347	40213160	1970-01-25	1970-01-25 00:00:00	1970-01-25	1970-01-25 00:00:00	1970-01-25	581452		0	0	0		0	0	0	23071	0	10	40213160		
96045	2105	40213227	1997-03-02	1997-03-02 00:00:00	1997-03-02	1997-03-02 00:00:00	1997-03-02	581452		0	0	0		0	0	0	140274	0	113	40213227		
59359	4933	19059056	1986-08-27	1986-08-27 00:00:00	1986-10-01	1986-10-01 00:00:00	1986-10-01	38000177		0	0	35		0	0	0	327969	0	243670	19059056		
18183	1506	19059056	1964-12-01	1964-12-01 00:00:00	1964-12-15	1964-12-15 00:00:00	1964-12-15	38000177		0	0	14		0	0	0	100394	0	243670	19059056		
35359	2914	19006318	1959-09-01	1959-09-01 00:00:00	1959-09-15	1959-09-15 00:00:00	1959-09-15	38000177		0	0	14		0	0	0	194174	0	105078	19006318		
64485	1411	40213160	1970-11-10	1970-11-10 00:00:00	1970-11-10	1970-11-10 00:00:00	1970-11-10	581452		0	0	0		0	0	0	93925	0	10	40213160		
13547	1135	1127433	1981-01-01	1981-01-01 00:00:00	1981-01-15	1981-01-15 00:00:00	1981-01-15	38000177		0	0	14		0	0	0	74740	0	313782	1127433		
23132	1906	19129655	1963-01-01	1963-01-01 00:00:00	1963-01-15	1963-01-15 00:00:00	1963-01-15	38000177		0	0	14		0	0	0	126881	0	789980	19129655		
24109	1982	19059056	1927-06-25	1927-06-25 00:00:00	1927-07-09	1927-07-09 00:00:00	1927-07-09	38000177		0	0	14		0	0	0	131996	0	243670	19059056		
24155	1986	19019979	1981-05-13	1981-05-13 00:00:00	1981-05-27	1981-05-27 00:00:00	1981-05-27	38000177		0	0	14		0	0	0	132241	0	198405	19019979		
211046	4628	40213296	2010-10-10	2010-10-10 00:00:00	2010-10-10	2010-10-10 00:00:00	2010-10-10	581452		0	0	0		0	0	0	308365	0	52	40213296		
80074	1752	40213227	2000-05-08	2000-05-08 00:00:00	2000-05-08	2000-05-08 00:00:00	2000-05-08	581452		0	0	0		0	0	0	117136	0	113	40213227		
154514	3401	40213227	2009-09-27	2009-09-27 00:00:00	2009-09-27	2009-09-27 00:00:00	2009-09-27	581452		0	0	0		0	0	0	225644	0	113	40213227		
123128	2706	40213227	1996-06-04	1996-06-04 00:00:00	1996-06-04	1996-06-04 00:00:00	1996-06-04	581452		0	0	0		0	0	0	179266	0	113	40213227		
122799	2699	40213227	2012-11-27	2012-11-27 00:00:00	2012-11-27	2012-11-27 00:00:00	2012-11-27	581452		0	0	0		0	0	0	178708	0	113	40213227		
4486	372	19078461	2018-12-22	2018-12-22 00:00:00	2019-02-20	2019-02-20 00:00:00	2019-02-20	38000177		0	0	60		0	0	0	24791	0	310965	19078461		
178184	3917	40213160	1968-02-15	1968-02-15 00:00:00	1968-02-15	1968-02-15 00:00:00	1968-02-15	581452		0	0	0		0	0	0	260475	0	10	40213160		
7132	154	40213160	1975-07-31	1975-07-31 00:00:00	1975-07-31	1975-07-31 00:00:00	1975-07-31	581452		0	0	0		0	0	0	10506	0	10	40213160		
35693	2942	1154615	1956-08-04	1956-08-04 00:00:00	1956-08-04	1956-08-04 00:00:00	\N	38000177		0	0	0		0	0	0	196086	0	745679	1154615		
166110	3651	40213227	1992-01-16	1992-01-16 00:00:00	1992-01-16	1992-01-16 00:00:00	1992-01-16	581452		0	0	0		0	0	0	243028	0	113	40213227		
5173	432	19133873	1939-03-21	1939-03-21 00:00:00	1939-03-31	1939-03-31 00:00:00	1939-03-31	38000177		0	0	10		0	0	0	28747	0	834061	19133873		
56045	4653	19006318	1959-06-22	1959-06-22 00:00:00	1959-07-06	1959-07-06 00:00:00	1959-07-06	38000177		0	0	14		0	0	0	310141	0	105078	19006318		
177527	3901	40213201	2003-01-01	2003-01-01 00:00:00	2003-01-01	2003-01-01 00:00:00	2003-01-01	581452		0	0	0		0	0	0	259365	0	33	40213201		
10382	867	1127433	2018-02-26	2018-02-26 00:00:00	2018-03-12	2018-03-12 00:00:00	2018-03-12	38000177		0	0	14		0	0	0	57550	0	313782	1127433		
112772	2477	40213160	1955-06-05	1955-06-05 00:00:00	1955-06-05	1955-06-05 00:00:00	1955-06-05	581452		0	0	0		0	0	0	164213	0	10	40213160		
17003	1408	1713671	1948-05-16	1948-05-16 00:00:00	1948-06-06	1948-06-06 00:00:00	1948-06-06	38000177		0	0	21		0	0	0	93623	0	562251	1713671		
86046	1885	40213160	1973-08-07	1973-08-07 00:00:00	1973-08-07	1973-08-07 00:00:00	1973-08-07	581452		0	0	0		0	0	0	125717	0	10	40213160		
17067	1412	1713671	1966-03-07	1966-03-07 00:00:00	1966-03-28	1966-03-28 00:00:00	1966-03-28	38000177		0	0	21		0	0	0	94079	0	562251	1713671		
31549	2616	1127433	1975-08-07	1975-08-07 00:00:00	1975-09-11	1975-09-11 00:00:00	1975-09-11	38000177		0	0	35		0	0	0	172964	0	313782	1127433		
212648	4662	40213160	1955-07-16	1955-07-16 00:00:00	1955-07-16	1955-07-16 00:00:00	1955-07-16	581452		0	0	0		0	0	0	310782	0	10	40213160		
71954	1572	40213260	2013-06-28	2013-06-28 00:00:00	2013-06-28	2013-06-28 00:00:00	2013-06-28	581452		0	0	0		0	0	0	105577	0	121	40213260		
54862	4557	19059056	1925-08-20	1925-08-20 00:00:00	1925-09-03	1925-09-03 00:00:00	1925-09-03	38000177		0	0	14		0	0	0	303565	0	243670	19059056		
187698	4122	40213160	1969-09-24	1969-09-24 00:00:00	1969-09-24	1969-09-24 00:00:00	1969-09-24	581452		0	0	0		0	0	0	274075	0	10	40213160		
155539	3422	40213160	1971-11-29	1971-11-29 00:00:00	1971-11-29	1971-11-29 00:00:00	1971-11-29	581452		0	0	0		0	0	0	227010	0	10	40213160		
54717	4546	1124300	2010-10-31	2010-10-31 00:00:00	2010-10-31	2010-10-31 00:00:00	\N	38000177		0	0	0		0	0	0	302827	0	00781178901	45011828		
42300	3509	40229134	1965-05-11	1965-05-11 00:00:00	1965-05-18	1965-05-18 00:00:00	1965-05-18	38000177		0	0	7		0	0	0	232761	0	1043400	40229134		
37322	3083	40231925	1964-02-04	1964-02-04 00:00:00	1964-02-04	1964-02-04 00:00:00	\N	38000177		0	0	0		0	0	0	205269	0	1049221	40231925		
33130	2747	40229134	1984-02-20	1984-02-20 00:00:00	1984-02-27	1984-02-27 00:00:00	1984-02-27	38000177		0	0	7		0	0	0	181655	0	1043400	40229134		
50639	4208	19019273	1972-11-13	1972-11-13 00:00:00	1972-11-27	1972-11-27 00:00:00	1972-11-27	38000177		0	0	14		0	0	0	279445	0	198014	19019273		
63415	5267	1713671	2001-11-25	2001-11-25 00:00:00	2001-12-16	2001-12-16 00:00:00	2001-12-16	38000177		0	0	21		0	0	0	350398	0	562251	1713671		
146689	3226	40213160	1969-03-16	1969-03-16 00:00:00	1969-03-16	1969-03-16 00:00:00	1969-03-16	581452		0	0	0		0	0	0	214499	0	10	40213160		
101816	2232	40213227	1995-05-05	1995-05-05 00:00:00	1995-05-05	1995-05-05 00:00:00	1995-05-05	581452		0	0	0		0	0	0	148508	0	113	40213227		
40430	3352	1124300	2003-07-01	2003-07-01 00:00:00	2003-07-01	2003-07-01 00:00:00	\N	38000177		0	0	0		0	0	0	222270	0	00781178901	45011828		
106736	2340	40213260	2010-03-10	2010-03-10 00:00:00	2010-03-10	2010-03-10 00:00:00	2010-03-10	581452		0	0	0		0	0	0	155728	0	121	40213260		
16630	1378	19008572	1974-06-26	1974-06-26 00:00:00	1974-06-26	1974-06-26 00:00:00	\N	38000177		0	0	0		0	0	0	91434	0	106258	19008572		
34412	2844	1127433	1951-08-22	1951-08-22 00:00:00	1951-08-29	1951-08-29 00:00:00	1951-08-29	38000177		0	0	7		0	0	0	188880	0	313782	1127433		
34454	2846	19133873	1979-06-21	1979-06-21 00:00:00	1979-06-29	1979-06-29 00:00:00	1979-06-29	38000177		0	0	8		0	0	0	188993	0	834061	19133873		
45224	3743	1713671	1992-10-19	1992-10-19 00:00:00	1992-11-09	1992-11-09 00:00:00	1992-11-09	38000177		0	0	21		0	0	0	248695	0	562251	1713671		
14264	308	40213160	1964-01-28	1964-01-28 00:00:00	1964-01-28	1964-01-28 00:00:00	1964-01-28	581452		0	0	0		0	0	0	20433	0	10	40213160		
62391	5193	19133873	1965-09-29	1965-09-29 00:00:00	1965-10-09	1965-10-09 00:00:00	1965-10-09	38000177		0	0	10		0	0	0	345208	0	834061	19133873		
17724	1468	19018935	2015-06-03	2015-06-03 00:00:00	2015-06-03	2015-06-03 00:00:00	\N	38000177		0	0	0		0	0	0	97794	0	197604	19018935		
55864	4637	19019979	1975-12-12	1975-12-12 00:00:00	1976-01-16	1976-01-16 00:00:00	1976-01-16	38000177		0	0	35		0	0	0	309043	0	198405	19019979		
55910	4641	1127433	1981-07-12	1981-07-12 00:00:00	1981-07-26	1981-07-26 00:00:00	1981-07-26	38000177		0	0	14		0	0	0	309304	0	313782	1127433		
35122	2898	19074843	1982-07-22	1982-07-22 00:00:00	1982-08-05	1982-08-05 00:00:00	1982-08-05	38000177		0	0	14		0	0	0	193111	0	309045	19074843		
650	49	19129655	1978-09-12	1978-09-12 00:00:00	1978-09-26	1978-09-26 00:00:00	1978-09-26	38000177		0	0	14		0	0	0	3535	0	789980	19129655		
22798	495	40213260	2018-05-19	2018-05-19 00:00:00	2018-05-19	2018-05-19 00:00:00	2018-05-19	581452		0	0	0		0	0	0	33104	0	121	40213260		
48558	4021	19006318	1955-02-11	1955-02-11 00:00:00	1955-02-25	1955-02-25 00:00:00	1955-02-25	38000177		0	0	14		0	0	0	267317	0	105078	19006318		
163278	3592	40213160	1970-01-07	1970-01-07 00:00:00	1970-01-07	1970-01-07 00:00:00	1970-01-07	581452		0	0	0		0	0	0	238622	0	10	40213160		
40713	3376	19059056	1982-10-21	1982-10-21 00:00:00	1982-11-11	1982-11-11 00:00:00	1982-11-11	38000177		0	0	21		0	0	0	224002	0	243670	19059056		
215886	4735	40213227	1995-03-09	1995-03-09 00:00:00	1995-03-09	1995-03-09 00:00:00	1995-03-09	581452		0	0	0		0	0	0	315458	0	113	40213227		
49656	4119	19059056	1946-02-12	1946-02-12 00:00:00	1946-02-26	1946-02-26 00:00:00	1946-02-26	38000177		0	0	14		0	0	0	273834	0	243670	19059056		
768	17	40213198	2015-12-21	2015-12-21 00:00:00	2015-12-21	2015-12-21 00:00:00	2015-12-21	581452		0	0	0		0	0	0	1295	0	133	40213198		
144290	3172	40213251	1984-11-15	1984-11-15 00:00:00	1984-11-15	1984-11-15 00:00:00	1984-11-15	581452		0	0	0		0	0	0	210847	0	21	40213251		
84661	1851	40213314	1979-02-15	1979-02-15 00:00:00	1979-02-15	1979-02-15 00:00:00	1979-02-15	581452		0	0	0		0	0	0	123818	0	49	40213314		
16101	347	40213160	1974-09-29	1974-09-29 00:00:00	1974-09-29	1974-09-29 00:00:00	1974-09-29	581452		0	0	0		0	0	0	23094	0	10	40213160		
96046	2105	40213306	1997-03-02	1997-03-02 00:00:00	1997-03-02	1997-03-02 00:00:00	1997-03-02	581452		0	0	0		0	0	0	140274	0	43	40213306		
59360	4933	19115351	1978-03-03	1978-03-03 00:00:00	1978-05-12	1978-05-12 00:00:00	1978-05-12	38000177		0	0	70		0	0	0	327966	0	563026	19115351		
18187	1508	1127433	1967-09-13	1967-09-13 00:00:00	1967-09-27	1967-09-27 00:00:00	1967-09-27	38000177		0	0	14		0	0	0	100649	0	313782	1127433		
35360	2914	1118084	1997-03-09	1997-03-09 00:00:00	1997-03-09	1997-03-09 00:00:00	\N	38000177		0	0	0		0	0	0	194232	0	00025152531	44923712		
64488	1411	40213296	2005-12-06	2005-12-06 00:00:00	2005-12-06	2005-12-06 00:00:00	2005-12-06	581452		0	0	0		0	0	0	93949	0	52	40213296		
13548	1135	19006318	1959-04-26	1959-04-26 00:00:00	1959-05-10	1959-05-10 00:00:00	1959-05-10	38000177		0	0	14		0	0	0	74748	0	105078	19006318		
23133	1906	1127433	1980-01-13	1980-01-13 00:00:00	1980-01-20	1980-01-20 00:00:00	1980-01-20	38000177		0	0	7		0	0	0	126872	0	313782	1127433		
24110	1982	1539411	1991-10-24	1991-10-24 00:00:00	1991-10-24	1991-10-24 00:00:00	\N	38000177		0	0	0		0	0	0	132008	0	312961	1539411		
24156	1986	19073183	1981-05-13	1981-05-13 00:00:00	1981-05-27	1981-05-27 00:00:00	1981-05-27	38000177		0	0	14		0	0	0	132241	0	308182	19073183		
211048	4628	40213227	1999-12-12	1999-12-12 00:00:00	1999-12-12	1999-12-12 00:00:00	1999-12-12	581452		0	0	0		0	0	0	308346	0	113	40213227		
80075	1752	40213306	2000-05-08	2000-05-08 00:00:00	2000-05-08	2000-05-08 00:00:00	2000-05-08	581452		0	0	0		0	0	0	117136	0	43	40213306		
154515	3401	40213260	2009-09-27	2009-09-27 00:00:00	2009-09-27	2009-09-27 00:00:00	2009-09-27	581452		0	0	0		0	0	0	225644	0	121	40213260		
123134	2706	40213260	2013-07-09	2013-07-09 00:00:00	2013-07-09	2013-07-09 00:00:00	2013-07-09	581452		0	0	0		0	0	0	179325	0	121	40213260		
122800	2699	40213296	2012-11-27	2012-11-27 00:00:00	2012-11-27	2012-11-27 00:00:00	2012-11-27	581452		0	0	0		0	0	0	178708	0	52	40213296		
4487	372	1127433	2004-04-14	2004-04-14 00:00:00	2004-04-28	2004-04-28 00:00:00	2004-04-28	38000177		0	0	14		0	0	0	24717	0	313782	1127433		
178192	3917	40213160	1967-12-14	1967-12-14 00:00:00	1967-12-14	1967-12-14 00:00:00	1967-12-14	581452		0	0	0		0	0	0	260460	0	10	40213160		
7139	154	40213160	1979-11-01	1979-11-01 00:00:00	1979-11-01	1979-11-01 00:00:00	1979-11-01	581452		0	0	0		0	0	0	10465	0	10	40213160		
35694	2942	1551192	1966-03-23	1966-03-23 00:00:00	1966-03-23	1966-03-23 00:00:00	1966-03-23	38000177		0	0	0		0	0	0	196056	0	312617	1551192		
177409	3899	40213160	1984-12-08	1984-12-08 00:00:00	1984-12-08	1984-12-08 00:00:00	1984-12-08	581452		0	0	0		0	0	0	259254	0	10	40213160		
5174	432	1124300	1973-01-07	1973-01-07 00:00:00	1973-01-07	1973-01-07 00:00:00	\N	38000177		0	0	0		0	0	0	28766	0	00781178901	45011828		
56055	4655	19074679	1996-06-23	1996-06-23 00:00:00	1996-09-01	1996-09-01 00:00:00	1996-09-01	38000177		0	0	70		0	0	0	310388	0	308971	19074679		
177533	3901	40213227	1997-12-03	1997-12-03 00:00:00	1997-12-03	1997-12-03 00:00:00	1997-12-03	581452		0	0	0		0	0	0	259354	0	113	40213227		
10383	867	40222846	2013-06-26	2013-06-26 00:00:00	2013-06-26	2013-06-26 00:00:00	\N	38000177		0	0	0		0	0	0	57544	0	996740	40222846		
112777	2477	40213227	2006-03-05	2006-03-05 00:00:00	2006-03-05	2006-03-05 00:00:00	2006-03-05	581452		0	0	0		0	0	0	164194	0	113	40213227		
17004	1408	19059056	1978-05-10	1978-05-10 00:00:00	1978-07-09	1978-07-09 00:00:00	1978-07-09	38000177		0	0	60		0	0	0	93622	0	243670	19059056		
86055	1885	40213296	2014-11-25	2014-11-25 00:00:00	2014-11-25	2014-11-25 00:00:00	2014-11-25	581452		0	0	0		0	0	0	125684	0	52	40213296		
17068	1412	40229134	2011-01-12	2011-01-12 00:00:00	2011-01-19	2011-01-19 00:00:00	2011-01-19	38000177		0	0	7		0	0	0	93986	0	1043400	40229134		
31550	2616	40173590	2012-01-10	2012-01-10 00:00:00	2012-01-10	2012-01-10 00:00:00	\N	38000177		0	0	0		0	0	0	173007	0	904419	40173590		
27617	2287	19059056	1954-09-10	1954-09-10 00:00:00	1954-10-10	1954-10-10 00:00:00	1954-10-10	38000177		0	0	30		0	0	0	152155	0	243670	19059056		
83237	1819	40213314	1978-08-01	1978-08-01 00:00:00	1978-08-01	1978-08-01 00:00:00	1978-08-01	581452		0	0	0		0	0	0	121692	0	49	40213314		
54863	4557	1127433	1988-07-21	1988-07-21 00:00:00	1988-07-28	1988-07-28 00:00:00	1988-07-28	38000177		0	0	7		0	0	0	303577	0	313782	1127433		
187701	4122	40213160	1969-04-23	1969-04-23 00:00:00	1969-04-23	1969-04-23 00:00:00	1969-04-23	581452		0	0	0		0	0	0	274074	0	10	40213160		
155543	3423	40213160	1979-03-01	1979-03-01 00:00:00	1979-03-01	1979-03-01 00:00:00	1979-03-01	581452		0	0	0		0	0	0	227071	0	10	40213160		
54718	4546	40229134	1994-04-03	1994-04-03 00:00:00	1994-04-10	1994-04-10 00:00:00	1994-04-10	38000177		0	0	7		0	0	0	302781	0	1043400	40229134		
42301	3509	19078461	1989-12-18	1989-12-18 00:00:00	1990-01-15	1990-01-15 00:00:00	1990-01-15	38000177		0	0	28		0	0	0	232793	0	310965	19078461		
37323	3083	1127433	1964-02-04	1964-02-04 00:00:00	1964-05-04	1964-05-04 00:00:00	1964-05-04	38000177		0	0	90		0	0	0	205269	0	313782	1127433		
33131	2747	1127433	1988-12-28	1988-12-28 00:00:00	1989-01-11	1989-01-11 00:00:00	1989-01-11	38000177		0	0	14		0	0	0	181656	0	313782	1127433		
50640	4208	40222846	2009-02-02	2009-02-02 00:00:00	2009-02-02	2009-02-02 00:00:00	\N	38000177		0	0	0		0	0	0	279354	0	996740	40222846		
63417	5267	19008572	1995-12-09	1995-12-09 00:00:00	1995-12-09	1995-12-09 00:00:00	\N	38000177		0	0	0		0	0	0	350362	0	106258	19008572		
102856	2256	40213314	1979-10-17	1979-10-17 00:00:00	1979-10-17	1979-10-17 00:00:00	1979-10-17	581452		0	0	0		0	0	0	149940	0	49	40213314		
101819	2232	40213306	1986-04-25	1986-04-25 00:00:00	1986-04-25	1986-04-25 00:00:00	1986-04-25	581452		0	0	0		0	0	0	148543	0	43	40213306		
40431	3352	40229134	1998-03-31	1998-03-31 00:00:00	1998-04-14	1998-04-14 00:00:00	1998-04-14	38000177		0	0	14		0	0	0	222269	0	1043400	40229134		
106747	2340	40213160	1959-11-11	1959-11-11 00:00:00	1959-11-11	1959-11-11 00:00:00	1959-11-11	581452		0	0	0		0	0	0	155768	0	10	40213160		
16631	1378	1127433	1981-08-10	1981-08-10 00:00:00	1981-09-14	1981-09-14 00:00:00	1981-09-14	38000177		0	0	35		0	0	0	91318	0	313782	1127433		
34413	2844	40173590	2018-07-02	2018-07-02 00:00:00	2018-07-02	2018-07-02 00:00:00	\N	38000177		0	0	0		0	0	0	188899	0	904419	40173590		
34455	2846	1124300	2017-08-28	2017-08-28 00:00:00	2017-08-28	2017-08-28 00:00:00	\N	38000177		0	0	0		0	0	0	189015	0	00781178901	45011828		
45225	3743	1127433	2018-09-26	2018-09-26 00:00:00	2018-10-10	2018-10-10 00:00:00	2018-10-10	38000177		0	0	14		0	0	0	248697	0	313782	1127433		
14265	308	40213296	2001-04-17	2001-04-17 00:00:00	2001-04-17	2001-04-17 00:00:00	2001-04-17	581452		0	0	0		0	0	0	20451	0	52	40213296		
62392	5193	19059056	1964-06-05	1964-06-05 00:00:00	1964-06-19	1964-06-19 00:00:00	1964-06-19	38000177		0	0	14		0	0	0	345240	0	243670	19059056		
17725	1468	40163554	2015-06-03	2015-06-03 00:00:00	2015-06-03	2015-06-03 00:00:00	\N	38000177		0	0	0		0	0	0	97794	0	855332	40163554		
55865	4637	40162522	2008-04-30	2008-04-30 00:00:00	2008-04-30	2008-04-30 00:00:00	\N	38000177		0	0	0		0	0	0	309049	0	857005	40162522		
55911	4641	920300	1987-08-18	1987-08-18 00:00:00	1987-08-25	1987-08-25 00:00:00	1987-08-25	38000177		0	0	7		0	0	0	309286	0	311989	920300		
35123	2898	19019979	1981-04-20	1981-04-20 00:00:00	1981-05-04	1981-05-04 00:00:00	1981-05-04	38000177		0	0	14		0	0	0	193083	0	198405	19019979		
651	49	1713671	2011-11-25	2011-11-25 00:00:00	2011-12-09	2011-12-09 00:00:00	2011-12-09	38000177		0	0	14		0	0	0	3576	0	562251	1713671		
22801	495	40213296	2009-03-28	2009-03-28 00:00:00	2009-03-28	2009-03-28 00:00:00	2009-03-28	581452		0	0	0		0	0	0	33071	0	52	40213296		
48559	4021	19059056	1955-02-11	1955-02-11 00:00:00	1955-02-25	1955-02-25 00:00:00	1955-02-25	38000177		0	0	14		0	0	0	267317	0	243670	19059056		
163284	3592	40213227	1998-05-27	1998-05-27 00:00:00	1998-05-27	1998-05-27 00:00:00	1998-05-27	581452		0	0	0		0	0	0	238626	0	113	40213227		
40715	3376	1124300	1994-05-06	1994-05-06 00:00:00	1994-05-06	1994-05-06 00:00:00	\N	38000177		0	0	0		0	0	0	224034	0	00781178901	45011828		
215888	4735	40213160	1973-09-13	1973-09-13 00:00:00	1973-09-13	1973-09-13 00:00:00	1973-09-13	581452		0	0	0		0	0	0	315449	0	10	40213160		
49657	4119	19006318	1946-02-12	1946-02-12 00:00:00	1946-02-26	1946-02-26 00:00:00	1946-02-26	38000177		0	0	14		0	0	0	273834	0	105078	19006318		
773	17	40213201	2016-12-26	2016-12-26 00:00:00	2016-12-26	2016-12-26 00:00:00	2016-12-26	581452		0	0	0		0	0	0	1330	0	33	40213201		
144296	3172	40213296	2018-01-04	2018-01-04 00:00:00	2018-01-04	2018-01-04 00:00:00	2018-01-04	581452		0	0	0		0	0	0	210859	0	52	40213296		
84664	1851	40213296	2017-12-14	2017-12-14 00:00:00	2017-12-14	2017-12-14 00:00:00	2017-12-14	581452		0	0	0		0	0	0	123857	0	52	40213296		
16107	347	40213160	1970-03-29	1970-03-29 00:00:00	1970-03-29	1970-03-29 00:00:00	1970-03-29	581452		0	0	0		0	0	0	23092	0	10	40213160		
37838	3128	40224805	1995-06-09	1995-06-09 00:00:00	1996-06-03	1996-06-03 00:00:00	1996-06-03	38000177		0	0	360		0	0	0	208177	0	1000126	40224805		
59361	4933	40165015	1998-11-04	1998-11-04 00:00:00	1998-11-04	1998-11-04 00:00:00	\N	38000177		0	0	0		0	0	0	327926	0	861467	40165015		
18188	1508	1713671	1990-03-05	1990-03-05 00:00:00	1990-03-12	1990-03-12 00:00:00	1990-03-12	38000177		0	0	7		0	0	0	100654	0	562251	1713671		
35361	2914	920300	1979-11-10	1979-11-10 00:00:00	1979-11-17	1979-11-17 00:00:00	1979-11-17	38000177		0	0	7		0	0	0	194193	0	311989	920300		
64492	1411	40213160	1966-08-09	1966-08-09 00:00:00	1966-08-09	1966-08-09 00:00:00	1966-08-09	581452		0	0	0		0	0	0	93933	0	10	40213160		
13549	1135	1127078	1959-04-26	1959-04-26 00:00:00	1959-05-10	1959-05-10 00:00:00	1959-05-10	38000177		0	0	14		0	0	0	74748	0	282464	1127078		
23134	1906	40232448	1964-12-02	1964-12-02 00:00:00	1964-12-02	1964-12-02 00:00:00	\N	38000177		0	0	0		0	0	0	126910	0	1049630	40232448		
24111	1982	1118084	1963-08-05	1963-08-05 00:00:00	1963-08-05	1963-08-05 00:00:00	\N	38000177		0	0	0		0	0	0	131951	0	00025152531	44923712		
24157	1987	19059056	1967-10-06	1967-10-06 00:00:00	1967-12-05	1967-12-05 00:00:00	1967-12-05	38000177		0	0	60		0	0	0	132288	0	243670	19059056		
211050	4628	40213160	1973-09-09	1973-09-09 00:00:00	1973-09-09	1973-09-09 00:00:00	1973-09-09	581452		0	0	0		0	0	0	308339	0	10	40213160		
80079	1752	40213160	1982-12-05	1982-12-05 00:00:00	1982-12-05	1982-12-05 00:00:00	1982-12-05	581452		0	0	0		0	0	0	117129	0	10	40213160		
154518	3401	40213296	1998-09-27	1998-09-27 00:00:00	1998-09-27	1998-09-27 00:00:00	1998-09-27	581452		0	0	0		0	0	0	225633	0	52	40213296		
171011	3759	40213160	1965-04-18	1965-04-18 00:00:00	1965-04-18	1965-04-18 00:00:00	1965-04-18	581452		0	0	0		0	0	0	249928	0	10	40213160		
55541	4613	19129144	2015-11-25	2015-11-25 00:00:00	2016-11-19	2016-11-19 00:00:00	2016-11-19	38000177		0	0	360		0	0	0	307255	0	757594	19129144		
4488	372	1127078	1962-05-08	1962-05-08 00:00:00	1962-07-07	1962-07-07 00:00:00	1962-07-07	38000177		0	0	60		0	0	0	24785	0	282464	1127078		
178194	3917	40213160	1972-08-17	1972-08-17 00:00:00	1972-08-17	1972-08-17 00:00:00	1972-08-17	581452		0	0	0		0	0	0	260503	0	10	40213160		
7147	155	40213227	2005-05-13	2005-05-13 00:00:00	2005-05-13	2005-05-13 00:00:00	2005-05-13	581452		0	0	0		0	0	0	10644	0	113	40213227		
35695	2942	19006318	1954-07-24	1954-07-24 00:00:00	1954-08-07	1954-08-07 00:00:00	1954-08-07	38000177		0	0	14		0	0	0	196211	0	105078	19006318		
177410	3899	40213251	1984-12-08	1984-12-08 00:00:00	1984-12-08	1984-12-08 00:00:00	1984-12-08	581452		0	0	0		0	0	0	259254	0	21	40213251		
5175	432	1127433	1979-06-15	1979-06-15 00:00:00	1979-07-20	1979-07-20 00:00:00	1979-07-20	38000177		0	0	35		0	0	0	28714	0	313782	1127433		
56056	4655	1127433	1992-09-03	1992-09-03 00:00:00	1992-09-24	1992-09-24 00:00:00	1992-09-24	38000177		0	0	21		0	0	0	310303	0	313782	1127433		
177538	3901	40213227	2017-03-22	2017-03-22 00:00:00	2017-03-22	2017-03-22 00:00:00	2017-03-22	581452		0	0	0		0	0	0	259370	0	113	40213227		
10384	867	40220960	2016-07-05	2016-07-05 00:00:00	2016-07-05	2016-07-05 00:00:00	2016-07-05	38000177		0	0	0		0	0	0	57590	0	1804799	40220960		
112778	2477	40213260	2006-03-05	2006-03-05 00:00:00	2006-03-05	2006-03-05 00:00:00	2006-03-05	581452		0	0	0		0	0	0	164194	0	121	40213260		
17005	1408	1127433	2007-07-07	2007-07-07 00:00:00	2007-07-21	2007-07-21 00:00:00	2007-07-21	38000177		0	0	14		0	0	0	93593	0	313782	1127433		
86056	1885	40213227	2014-11-25	2014-11-25 00:00:00	2014-11-25	2014-11-25 00:00:00	2014-11-25	581452		0	0	0		0	0	0	125684	0	113	40213227		
17069	1412	1127433	1981-12-08	1981-12-08 00:00:00	1981-12-22	1981-12-22 00:00:00	1981-12-22	38000177		0	0	14		0	0	0	94037	0	313782	1127433		
31551	2616	19078461	1996-02-23	1996-02-23 00:00:00	1996-03-22	1996-03-22 00:00:00	1996-03-22	38000177		0	0	28		0	0	0	172965	0	310965	19078461		
27618	2287	19059056	1945-12-12	1945-12-12 00:00:00	1945-12-26	1945-12-26 00:00:00	1945-12-26	38000177		0	0	14		0	0	0	152096	0	243670	19059056		
83241	1820	40213314	1978-05-16	1978-05-16 00:00:00	1978-05-16	1978-05-16 00:00:00	1978-05-16	581452		0	0	0		0	0	0	121761	0	49	40213314		
54864	4557	19059056	1924-05-27	1924-05-27 00:00:00	1924-06-17	1924-06-17 00:00:00	1924-06-17	38000177		0	0	21		0	0	0	303637	0	243670	19059056		
11039	236	40213227	2012-05-24	2012-05-24 00:00:00	2012-05-24	2012-05-24 00:00:00	2012-05-24	581452		0	0	0		0	0	0	15805	0	113	40213227		
155549	3423	40213296	2014-03-27	2014-03-27 00:00:00	2014-03-27	2014-03-27 00:00:00	2014-03-27	581452		0	0	0		0	0	0	227055	0	52	40213296		
54720	4546	19133905	2015-12-02	2015-12-02 00:00:00	2015-12-09	2015-12-09 00:00:00	2015-12-09	38000177		0	0	7		0	0	0	302818	0	834102	19133905		
42302	3509	19078461	2011-03-26	2011-03-26 00:00:00	2011-06-24	2011-06-24 00:00:00	2011-06-24	38000177		0	0	90		0	0	0	232794	0	310965	19078461		
37324	3083	1127433	1951-05-30	1951-05-30 00:00:00	1951-06-13	1951-06-13 00:00:00	1951-06-13	38000177		0	0	14		0	0	0	205329	0	313782	1127433		
33132	2747	1124300	2009-11-14	2009-11-14 00:00:00	2009-11-14	2009-11-14 00:00:00	\N	38000177		0	0	0		0	0	0	181674	0	00781178901	45011828		
50642	4208	40229134	1943-10-15	1943-10-15 00:00:00	1943-10-29	1943-10-29 00:00:00	1943-10-29	38000177		0	0	14		0	0	0	279431	0	1043400	40229134		
63418	5267	1118084	2006-01-08	2006-01-08 00:00:00	2006-01-08	2006-01-08 00:00:00	\N	38000177		0	0	0		0	0	0	350426	0	00025152531	44923712		
102857	2256	40213314	1979-01-17	1979-01-17 00:00:00	1979-01-17	1979-01-17 00:00:00	1979-01-17	581452		0	0	0		0	0	0	149959	0	49	40213314		
101823	2232	40213260	2013-05-10	2013-05-10 00:00:00	2013-05-10	2013-05-10 00:00:00	2013-05-10	581452		0	0	0		0	0	0	148478	0	121	40213260		
40432	3352	1127078	1976-09-20	1976-09-20 00:00:00	1976-10-04	1976-10-04 00:00:00	1976-10-04	38000177		0	0	14		0	0	0	222308	0	282464	1127078		
106748	2340	40213306	1981-05-07	1981-05-07 00:00:00	1981-05-07	1981-05-07 00:00:00	1981-05-07	581452		0	0	0		0	0	0	155759	0	43	40213306		
16632	1378	1127078	1952-06-29	1952-06-29 00:00:00	1952-07-13	1952-07-13 00:00:00	1952-07-13	38000177		0	0	14		0	0	0	91317	0	282464	1127078		
34414	2844	19133905	1967-02-14	1967-02-14 00:00:00	1967-02-27	1967-02-27 00:00:00	1967-02-27	38000177		0	0	13		0	0	0	188883	0	834102	19133905		
34456	2846	1127078	1982-04-18	1982-04-18 00:00:00	1982-05-18	1982-05-18 00:00:00	1982-05-18	38000177		0	0	30		0	0	0	188989	0	282464	1127078		
45226	3743	19059056	1980-04-14	1980-04-14 00:00:00	1980-04-28	1980-04-28 00:00:00	1980-04-28	38000177		0	0	14		0	0	0	248707	0	243670	19059056		
14266	308	40213296	2003-04-22	2003-04-22 00:00:00	2003-04-22	2003-04-22 00:00:00	2003-04-22	581452		0	0	0		0	0	0	20436	0	52	40213296		
62393	5193	19059056	1965-07-30	1965-07-30 00:00:00	1965-09-28	1965-09-28 00:00:00	1965-09-28	38000177		0	0	60		0	0	0	345176	0	243670	19059056		
17726	1468	40229134	1981-06-16	1981-06-16 00:00:00	1981-06-23	1981-06-23 00:00:00	1981-06-23	38000177		0	0	7		0	0	0	97827	0	1043400	40229134		
55866	4637	1127433	2008-04-30	2008-04-30 00:00:00	2008-05-14	2008-05-14 00:00:00	2008-05-14	38000177		0	0	14		0	0	0	309049	0	313782	1127433		
55912	4641	40236824	1987-08-18	1987-08-18 00:00:00	1987-08-25	1987-08-25 00:00:00	1987-08-25	38000177		0	0	7		0	0	0	309286	0	1094107	40236824		
35124	2898	19073183	1981-04-20	1981-04-20 00:00:00	1981-05-04	1981-05-04 00:00:00	1981-05-04	38000177		0	0	14		0	0	0	193083	0	308182	19073183		
652	49	1127433	2010-04-20	2010-04-20 00:00:00	2010-05-04	2010-05-04 00:00:00	2010-05-04	38000177		0	0	14		0	0	0	3534	0	313782	1127433		
22806	495	40213160	1968-08-24	1968-08-24 00:00:00	1968-08-24	1968-08-24 00:00:00	1968-08-24	581452		0	0	0		0	0	0	33059	0	10	40213160		
48560	4022	1127433	1993-03-26	1993-03-26 00:00:00	1993-04-09	1993-04-09 00:00:00	1993-04-09	38000177		0	0	14		0	0	0	267386	0	313782	1127433		
163286	3592	40213260	2015-01-28	2015-01-28 00:00:00	2015-01-28	2015-01-28 00:00:00	2015-01-28	581452		0	0	0		0	0	0	238578	0	121	40213260		
40716	3376	1127433	1979-10-20	1979-10-20 00:00:00	1979-10-27	1979-10-27 00:00:00	1979-10-27	38000177		0	0	7		0	0	0	223955	0	313782	1127433		
215892	4735	40213227	2015-01-15	2015-01-15 00:00:00	2015-01-15	2015-01-15 00:00:00	2015-01-15	581452		0	0	0		0	0	0	315473	0	113	40213227		
49658	4119	1713671	1946-08-19	1946-08-19 00:00:00	1946-09-09	1946-09-09 00:00:00	1946-09-09	38000177		0	0	21		0	0	0	273790	0	562251	1713671		
778	17	40213227	2012-10-01	2012-10-01 00:00:00	2012-10-01	2012-10-01 00:00:00	2012-10-01	581452		0	0	0		0	0	0	1294	0	113	40213227		
53913	1180	40213296	1999-11-17	1999-11-17 00:00:00	1999-11-17	1999-11-17 00:00:00	1999-11-17	581452		0	0	0		0	0	0	77946	0	52	40213296		
95946	2103	40213296	2014-08-16	2014-08-16 00:00:00	2014-08-16	2014-08-16 00:00:00	2014-08-16	581452		0	0	0		0	0	0	140183	0	52	40213296		
27391	597	40213227	1993-09-13	1993-09-13 00:00:00	1993-09-13	1993-09-13 00:00:00	1993-09-13	581452		0	0	0		0	0	0	39398	0	113	40213227		
37839	3128	19008572	1977-09-08	1977-09-08 00:00:00	1977-09-22	1977-09-22 00:00:00	1977-09-22	38000177		0	0	14		0	0	0	208196	0	106258	19008572		
59362	4933	19059056	1970-12-30	1970-12-30 00:00:00	1971-01-29	1971-01-29 00:00:00	1971-01-29	38000177		0	0	30		0	0	0	327964	0	243670	19059056		
18189	1508	1127433	1967-05-20	1967-05-20 00:00:00	1967-06-10	1967-06-10 00:00:00	1967-06-10	38000177		0	0	21		0	0	0	100547	0	313782	1127433		
35362	2914	40236824	1979-11-10	1979-11-10 00:00:00	1979-11-17	1979-11-17 00:00:00	1979-11-17	38000177		0	0	7		0	0	0	194193	0	1094107	40236824		
64494	1411	40213227	2007-12-11	2007-12-11 00:00:00	2007-12-11	2007-12-11 00:00:00	2007-12-11	581452		0	0	0		0	0	0	93975	0	113	40213227		
13550	1135	1127433	1996-05-09	1996-05-09 00:00:00	1996-05-16	1996-05-16 00:00:00	1996-05-16	38000177		0	0	7		0	0	0	74764	0	313782	1127433		
23137	1908	1127433	2018-03-11	2018-03-11 00:00:00	2018-05-10	2018-05-10 00:00:00	2018-05-10	38000177		0	0	60		0	0	0	126954	0	313782	1127433		
24112	1982	1127433	1960-02-14	1960-02-14 00:00:00	1960-02-21	1960-02-21 00:00:00	1960-02-21	38000177		0	0	7		0	0	0	131988	0	313782	1127433		
24158	1987	40165015	1967-10-06	1967-10-06 00:00:00	1967-10-06	1967-10-06 00:00:00	\N	38000177		0	0	0		0	0	0	132288	0	861467	40165015		
211060	4628	40213296	2008-10-05	2008-10-05 00:00:00	2008-10-05	2008-10-05 00:00:00	2008-10-05	581452		0	0	0		0	0	0	308325	0	52	40213296		
80087	1752	40213314	1978-06-05	1978-06-05 00:00:00	1978-06-05	1978-06-05 00:00:00	1978-06-05	581452		0	0	0		0	0	0	117155	0	49	40213314		
154528	3401	40213260	2008-09-21	2008-09-21 00:00:00	2008-09-21	2008-09-21 00:00:00	2008-09-21	581452		0	0	0		0	0	0	225635	0	121	40213260		
171013	3759	40213160	1969-03-16	1969-03-16 00:00:00	1969-03-16	1969-03-16 00:00:00	1969-03-16	581452		0	0	0		0	0	0	249893	0	10	40213160		
55542	4613	1713671	1995-07-12	1995-07-12 00:00:00	1995-08-02	1995-08-02 00:00:00	1995-08-02	38000177		0	0	21		0	0	0	307267	0	562251	1713671		
35346	2913	1127433	1964-02-20	1964-02-20 00:00:00	1964-02-27	1964-02-27 00:00:00	1964-02-27	38000177		0	0	7		0	0	0	194125	0	313782	1127433		
178204	3917	40213260	2018-09-13	2018-09-13 00:00:00	2018-09-13	2018-09-13 00:00:00	2018-09-13	581452		0	0	0		0	0	0	260459	0	121	40213260		
7154	155	40213260	2006-07-28	2006-07-28 00:00:00	2006-07-28	2006-07-28 00:00:00	2006-07-28	581452		0	0	0		0	0	0	10587	0	121	40213260		
35696	2942	19059056	1954-07-24	1954-07-24 00:00:00	1954-08-07	1954-08-07 00:00:00	1954-08-07	38000177		0	0	14		0	0	0	196211	0	243670	19059056		
219342	4814	40213227	2007-06-25	2007-06-25 00:00:00	2007-06-25	2007-06-25 00:00:00	2007-06-25	581452		0	0	0		0	0	0	320294	0	113	40213227		
5176	432	19059056	1934-12-08	1934-12-08 00:00:00	1934-12-22	1934-12-22 00:00:00	1934-12-22	38000177		0	0	14		0	0	0	28758	0	243670	19059056		
56057	4655	1127078	1965-04-11	1965-04-11 00:00:00	1965-05-02	1965-05-02 00:00:00	1965-05-02	38000177		0	0	21		0	0	0	310299	0	282464	1127078		
172484	3791	40213227	1996-02-24	1996-02-24 00:00:00	1996-02-24	1996-02-24 00:00:00	1996-02-24	581452		0	0	0		0	0	0	252081	0	113	40213227		
10385	867	1713671	1933-03-14	1933-03-14 00:00:00	1933-04-04	1933-04-04 00:00:00	1933-04-04	38000177		0	0	21		0	0	0	57539	0	562251	1713671		
112780	2477	40213227	1997-03-09	1997-03-09 00:00:00	1997-03-09	1997-03-09 00:00:00	1997-03-09	581452		0	0	0		0	0	0	164135	0	113	40213227		
17006	1408	1127433	1956-07-25	1956-07-25 00:00:00	1956-08-01	1956-08-01 00:00:00	1956-08-01	38000177		0	0	7		0	0	0	93641	0	313782	1127433		
86061	1885	40213160	1973-11-06	1973-11-06 00:00:00	1973-11-06	1973-11-06 00:00:00	1973-11-06	581452		0	0	0		0	0	0	125704	0	10	40213160		
17070	1412	1127433	1991-02-08	1991-02-08 00:00:00	1991-02-22	1991-02-22 00:00:00	1991-02-22	38000177		0	0	14		0	0	0	94094	0	313782	1127433		
31552	2616	1127433	1997-03-12	1997-03-12 00:00:00	1997-03-26	1997-03-26 00:00:00	1997-03-26	38000177		0	0	14		0	0	0	172954	0	313782	1127433		
27619	2287	1127433	1958-04-28	1958-04-28 00:00:00	1958-05-05	1958-05-05 00:00:00	1958-05-05	38000177		0	0	7		0	0	0	152097	0	313782	1127433		
83242	1820	40213160	1978-05-16	1978-05-16 00:00:00	1978-05-16	1978-05-16 00:00:00	1978-05-16	581452		0	0	0		0	0	0	121761	0	10	40213160		
54865	4557	1127433	1973-08-23	1973-08-23 00:00:00	1973-09-13	1973-09-13 00:00:00	1973-09-13	38000177		0	0	21		0	0	0	303642	0	313782	1127433		
11043	236	40213227	2002-03-28	2002-03-28 00:00:00	2002-03-28	2002-03-28 00:00:00	2002-03-28	581452		0	0	0		0	0	0	15876	0	113	40213227		
166831	3667	40213227	2009-07-21	2009-07-21 00:00:00	2009-07-21	2009-07-21 00:00:00	2009-07-21	581452		0	0	0		0	0	0	244004	0	113	40213227		
54721	4546	1127433	1973-02-03	1973-02-03 00:00:00	1973-02-17	1973-02-17 00:00:00	1973-02-17	38000177		0	0	14		0	0	0	302810	0	313782	1127433		
42303	3509	19059056	1962-04-18	1962-04-18 00:00:00	1962-05-09	1962-05-09 00:00:00	1962-05-09	38000177		0	0	21		0	0	0	232698	0	243670	19059056		
37326	3083	1127433	1979-06-29	1979-06-29 00:00:00	1979-07-20	1979-07-20 00:00:00	1979-07-20	38000177		0	0	21		0	0	0	205350	0	313782	1127433		
33133	2747	19019979	1978-01-25	1978-01-25 00:00:00	1978-02-08	1978-02-08 00:00:00	1978-02-08	38000177		0	0	14		0	0	0	181663	0	198405	19019979		
50643	4208	40162522	2013-10-04	2013-10-04 00:00:00	2013-10-04	2013-10-04 00:00:00	\N	38000177		0	0	0		0	0	0	279460	0	857005	40162522		
63419	5267	19128065	1986-10-30	1986-10-30 00:00:00	1987-10-25	1987-10-25 00:00:00	1987-10-25	38000177		0	0	360		0	0	0	350403	0	749882	19128065		
102858	2256	40213160	1979-01-17	1979-01-17 00:00:00	1979-01-17	1979-01-17 00:00:00	1979-01-17	581452		0	0	0		0	0	0	149959	0	10	40213160		
101825	2232	40213227	2005-05-20	2005-05-20 00:00:00	2005-05-20	2005-05-20 00:00:00	2005-05-20	581452		0	0	0		0	0	0	148491	0	113	40213227		
40433	3352	46233988	1976-09-20	1976-09-20 00:00:00	1976-10-04	1976-10-04 00:00:00	1976-10-04	38000177		0	0	14		0	0	0	222308	0	1652673	46233988		
106750	2340	40213227	2001-06-21	2001-06-21 00:00:00	2001-06-21	2001-06-21 00:00:00	2001-06-21	581452		0	0	0		0	0	0	155761	0	113	40213227		
16633	1379	19059056	1969-08-15	1969-08-15 00:00:00	1969-08-29	1969-08-29 00:00:00	1969-08-29	38000177		0	0	14		0	0	0	91511	0	243670	19059056		
34415	2844	1127433	1959-09-19	1959-09-19 00:00:00	1959-09-26	1959-09-26 00:00:00	1959-09-26	38000177		0	0	7		0	0	0	188826	0	313782	1127433		
34457	2846	19059056	1973-07-20	1973-07-20 00:00:00	1973-08-03	1973-08-03 00:00:00	1973-08-03	38000177		0	0	14		0	0	0	189039	0	243670	19059056		
45227	3744	19008572	2002-12-28	2002-12-28 00:00:00	2002-12-28	2002-12-28 00:00:00	\N	38000177		0	0	0		0	0	0	248749	0	106258	19008572		
14268	308	40213160	1959-10-27	1959-10-27 00:00:00	1959-10-27	1959-10-27 00:00:00	1959-10-27	581452		0	0	0		0	0	0	20428	0	10	40213160		
62394	5194	19133873	1948-12-15	1948-12-15 00:00:00	1948-12-24	1948-12-24 00:00:00	1948-12-24	38000177		0	0	9		0	0	0	345297	0	834061	19133873		
17728	1468	19078461	1974-02-09	1974-02-09 00:00:00	1974-03-09	1974-03-09 00:00:00	1974-03-09	38000177		0	0	28		0	0	0	97874	0	310965	19078461		
55867	4637	19073188	2008-04-30	2008-04-30 00:00:00	2008-05-14	2008-05-14 00:00:00	2008-05-14	38000177		0	0	14		0	0	0	309049	0	308192	19073188		
55913	4641	1713671	1999-06-02	1999-06-02 00:00:00	1999-06-09	1999-06-09 00:00:00	1999-06-09	38000177		0	0	7		0	0	0	309287	0	562251	1713671		
35125	2898	1551192	1980-03-12	1980-03-12 00:00:00	1980-03-12	1980-03-12 00:00:00	1980-03-12	38000177		0	0	0		0	0	0	192993	0	312617	1551192		
653	49	1713671	1994-08-29	1994-08-29 00:00:00	1994-09-19	1994-09-19 00:00:00	1994-09-19	38000177		0	0	21		0	0	0	3575	0	562251	1713671		
22809	495	40213227	1992-03-07	1992-03-07 00:00:00	1992-03-07	1992-03-07 00:00:00	1992-03-07	581452		0	0	0		0	0	0	33068	0	113	40213227		
48561	4022	1713671	1963-12-30	1963-12-30 00:00:00	1964-01-20	1964-01-20 00:00:00	1964-01-20	38000177		0	0	21		0	0	0	267415	0	562251	1713671		
163294	3592	40213296	2007-04-11	2007-04-11 00:00:00	2007-04-11	2007-04-11 00:00:00	2007-04-11	581452		0	0	0		0	0	0	238642	0	52	40213296		
40717	3376	40231925	2017-10-08	2017-10-08 00:00:00	2017-10-08	2017-10-08 00:00:00	\N	38000177		0	0	0		0	0	0	224003	0	1049221	40231925		
215893	4735	40213296	2015-01-15	2015-01-15 00:00:00	2015-01-15	2015-01-15 00:00:00	2015-01-15	581452		0	0	0		0	0	0	315473	0	52	40213296		
49661	4119	19059056	1964-09-10	1964-09-10 00:00:00	1964-09-24	1964-09-24 00:00:00	1964-09-24	38000177		0	0	14		0	0	0	273809	0	243670	19059056		
784	17	40213160	1955-11-21	1955-11-21 00:00:00	1955-11-21	1955-11-21 00:00:00	1955-11-21	581452		0	0	0		0	0	0	1319	0	10	40213160		
53918	1180	40213160	1956-07-18	1956-07-18 00:00:00	1956-07-18	1956-07-18 00:00:00	1956-07-18	581452		0	0	0		0	0	0	77937	0	10	40213160		
95948	2103	40213227	2014-08-16	2014-08-16 00:00:00	2014-08-16	2014-08-16 00:00:00	2014-08-16	581452		0	0	0		0	0	0	140183	0	113	40213227		
27400	597	40213198	2017-12-04	2017-12-04 00:00:00	2017-12-04	2017-12-04 00:00:00	2017-12-04	581452		0	0	0		0	0	0	39406	0	133	40213198		
37840	3128	19008572	1974-06-29	1974-06-29 00:00:00	1974-07-20	1974-07-20 00:00:00	1974-07-20	38000177		0	0	21		0	0	0	208214	0	106258	19008572		
59363	4933	1118084	2007-06-14	2007-06-14 00:00:00	2007-06-14	2007-06-14 00:00:00	\N	38000177		0	0	0		0	0	0	327951	0	00025152531	44923712		
18190	1508	1127433	2011-09-17	2011-09-17 00:00:00	2011-10-22	2011-10-22 00:00:00	2011-10-22	38000177		0	0	35		0	0	0	100549	0	313782	1127433		
35363	2914	40243436	1986-09-06	1986-09-06 00:00:00	1986-09-06	1986-09-06 00:00:00	1986-09-06	38000177		0	0	0		0	0	0	194195	0	1190795	40243436		
64495	1411	40213296	2007-12-11	2007-12-11 00:00:00	2007-12-11	2007-12-11 00:00:00	2007-12-11	581452		0	0	0		0	0	0	93975	0	52	40213296		
13551	1135	19006318	1959-09-04	1959-09-04 00:00:00	1959-09-18	1959-09-18 00:00:00	1959-09-18	38000177		0	0	14		0	0	0	74743	0	105078	19006318		
23138	1908	46233988	1974-09-26	1974-09-26 00:00:00	1974-10-10	1974-10-10 00:00:00	1974-10-10	38000177		0	0	14		0	0	0	126985	0	1652673	46233988		
62153	5172	19078461	1988-11-16	1988-11-16 00:00:00	1988-11-30	1988-11-30 00:00:00	1988-11-30	38000177		0	0	14		0	0	0	343920	0	310965	19078461		
224785	4935	40213160	1964-12-31	1964-12-31 00:00:00	1964-12-31	1964-12-31 00:00:00	1964-12-31	581452		0	0	0		0	0	0	328099	0	10	40213160		
128623	2829	40213227	2001-09-10	2001-09-10 00:00:00	2001-09-10	2001-09-10 00:00:00	2001-09-10	581452		0	0	0		0	0	0	187602	0	113	40213227		
80088	1752	40213160	1978-06-05	1978-06-05 00:00:00	1978-06-05	1978-06-05 00:00:00	1978-06-05	581452		0	0	0		0	0	0	117155	0	10	40213160		
154530	3401	40213160	1959-05-31	1959-05-31 00:00:00	1959-05-31	1959-05-31 00:00:00	1959-05-31	581452		0	0	0		0	0	0	225598	0	10	40213160		
171014	3759	40213296	2006-08-20	2006-08-20 00:00:00	2006-08-20	2006-08-20 00:00:00	2006-08-20	581452		0	0	0		0	0	0	249943	0	52	40213296		
55543	4613	19059056	1967-10-14	1967-10-14 00:00:00	1967-10-28	1967-10-28 00:00:00	1967-10-28	38000177		0	0	14		0	0	0	307282	0	243670	19059056		
35347	2913	1713671	1949-05-16	1949-05-16 00:00:00	1949-05-23	1949-05-23 00:00:00	1949-05-23	38000177		0	0	7		0	0	0	194092	0	562251	1713671		
178206	3917	40213227	2018-09-13	2018-09-13 00:00:00	2018-09-13	2018-09-13 00:00:00	2018-09-13	581452		0	0	0		0	0	0	260459	0	113	40213227		
7157	155	40213160	1955-07-15	1955-07-15 00:00:00	1955-07-15	1955-07-15 00:00:00	1955-07-15	581452		0	0	0		0	0	0	10540	0	10	40213160		
35697	2942	1127433	1992-04-27	1992-04-27 00:00:00	1992-05-04	1992-05-04 00:00:00	1992-05-04	38000177		0	0	7		0	0	0	196169	0	313782	1127433		
219345	4814	40213227	2017-08-21	2017-08-21 00:00:00	2017-08-21	2017-08-21 00:00:00	2017-08-21	581452		0	0	0		0	0	0	320298	0	113	40213227		
5177	432	19133905	1994-02-20	1994-02-20 00:00:00	1994-03-04	1994-03-04 00:00:00	1994-03-04	38000177		0	0	12		0	0	0	28737	0	834102	19133905		
56058	4655	1127433	1993-06-14	1993-06-14 00:00:00	1993-06-21	1993-06-21 00:00:00	1993-06-21	38000177		0	0	7		0	0	0	310335	0	313782	1127433		
172505	3791	40213201	1983-12-17	1983-12-17 00:00:00	1983-12-17	1983-12-17 00:00:00	1983-12-17	581452		0	0	0		0	0	0	252130	0	33	40213201		
10386	867	1127433	1984-02-02	1984-02-02 00:00:00	1984-02-16	1984-02-16 00:00:00	1984-02-16	38000177		0	0	14		0	0	0	57522	0	313782	1127433		
112781	2477	40213296	1997-03-09	1997-03-09 00:00:00	1997-03-09	1997-03-09 00:00:00	1997-03-09	581452		0	0	0		0	0	0	164135	0	52	40213296		
17007	1408	19059056	1953-12-13	1953-12-13 00:00:00	1953-12-27	1953-12-27 00:00:00	1953-12-27	38000177		0	0	14		0	0	0	93626	0	243670	19059056		
86064	1885	40213160	1973-06-05	1973-06-05 00:00:00	1973-06-05	1973-06-05 00:00:00	1973-06-05	581452		0	0	0		0	0	0	125703	0	10	40213160		
17071	1412	40169216	1963-05-20	1963-05-20 00:00:00	1963-05-20	1963-05-20 00:00:00	\N	38000177		0	0	0		0	0	0	94078	0	895994	40169216		
31553	2616	1127078	1953-09-17	1953-09-17 00:00:00	1953-10-01	1953-10-01 00:00:00	1953-10-01	38000177		0	0	14		0	0	0	172945	0	282464	1127078		
27620	2287	1127433	1960-07-10	1960-07-10 00:00:00	1960-08-14	1960-08-14 00:00:00	1960-08-14	38000177		0	0	35		0	0	0	152148	0	313782	1127433		
83248	1820	40213160	1983-01-18	1983-01-18 00:00:00	1983-01-18	1983-01-18 00:00:00	1983-01-18	581452		0	0	0		0	0	0	121756	0	10	40213160		
54866	4557	40229134	1942-12-20	1942-12-20 00:00:00	1943-01-03	1943-01-03 00:00:00	1943-01-03	38000177		0	0	14		0	0	0	303573	0	1043400	40229134		
11054	236	40213201	2017-06-22	2017-06-22 00:00:00	2017-06-22	2017-06-22 00:00:00	2017-06-22	581452		0	0	0		0	0	0	15880	0	33	40213201		
166832	3667	40213296	2009-07-21	2009-07-21 00:00:00	2009-07-21	2009-07-21 00:00:00	2009-07-21	581452		0	0	0		0	0	0	244004	0	52	40213296		
54723	4546	19128022	1989-05-19	1989-05-19 00:00:00	1990-05-14	1990-05-14 00:00:00	1990-05-14	38000177		0	0	360		0	0	0	302830	0	749785	19128022		
42304	3509	1127433	1984-04-27	1984-04-27 00:00:00	1984-05-18	1984-05-18 00:00:00	1984-05-18	38000177		0	0	21		0	0	0	232792	0	313782	1127433		
37327	3083	1713671	1962-10-25	1962-10-25 00:00:00	1962-11-01	1962-11-01 00:00:00	1962-11-01	38000177		0	0	7		0	0	0	205261	0	562251	1713671		
33134	2747	46233988	1978-01-25	1978-01-25 00:00:00	1978-02-08	1978-02-08 00:00:00	1978-02-08	38000177		0	0	14		0	0	0	181663	0	1652673	46233988		
50644	4208	1115171	2013-10-04	2013-10-04 00:00:00	2013-11-03	2013-11-03 00:00:00	2013-11-03	38000177		0	0	30		0	0	0	279460	0	849574	1115171		
63421	5267	19133873	1971-05-15	1971-05-15 00:00:00	1971-05-27	1971-05-27 00:00:00	1971-05-27	38000177		0	0	12		0	0	0	350352	0	834061	19133873		
102860	2256	40213227	2010-04-28	2010-04-28 00:00:00	2010-04-28	2010-04-28 00:00:00	2010-04-28	581452		0	0	0		0	0	0	149935	0	113	40213227		
101826	2232	40213296	2005-05-20	2005-05-20 00:00:00	2005-05-20	2005-05-20 00:00:00	2005-05-20	581452		0	0	0		0	0	0	148491	0	52	40213296		
40434	3352	19019979	1975-06-28	1975-06-28 00:00:00	1975-07-12	1975-07-12 00:00:00	1975-07-12	38000177		0	0	14		0	0	0	222258	0	198405	19019979		
106751	2340	40213296	2001-06-21	2001-06-21 00:00:00	2001-06-21	2001-06-21 00:00:00	2001-06-21	581452		0	0	0		0	0	0	155761	0	52	40213296		
16635	1379	1127433	1998-02-17	1998-02-17 00:00:00	1998-03-10	1998-03-10 00:00:00	1998-03-10	38000177		0	0	21		0	0	0	91517	0	313782	1127433		
34416	2844	1713671	1959-12-08	1959-12-08 00:00:00	1959-12-22	1959-12-22 00:00:00	1959-12-22	38000177		0	0	14		0	0	0	188881	0	562251	1713671		
34458	2846	1127078	1979-12-30	1979-12-30 00:00:00	1980-03-29	1980-03-29 00:00:00	1980-03-29	38000177		0	0	90		0	0	0	188987	0	282464	1127078		
45228	3744	19078461	2019-01-17	2019-01-17 00:00:00	2019-01-31	2019-01-31 00:00:00	2019-01-31	38000177		0	0	14		0	0	0	248853	0	310965	19078461		
14272	308	40213160	1959-12-29	1959-12-29 00:00:00	1959-12-29	1959-12-29 00:00:00	1959-12-29	581452		0	0	0		0	0	0	20405	0	10	40213160		
62395	5194	1124300	1982-08-26	1982-08-26 00:00:00	1982-08-26	1982-08-26 00:00:00	\N	38000177		0	0	0		0	0	0	345342	0	00781178901	45011828		
17729	1468	19006318	1958-01-29	1958-01-29 00:00:00	1958-02-12	1958-02-12 00:00:00	1958-02-12	38000177		0	0	14		0	0	0	97879	0	105078	19006318		
55868	4637	1127433	2009-05-28	2009-05-28 00:00:00	2009-06-04	2009-06-04 00:00:00	2009-06-04	38000177		0	0	7		0	0	0	309018	0	313782	1127433		
55914	4641	1127433	1978-03-19	1978-03-19 00:00:00	1978-03-26	1978-03-26 00:00:00	1978-03-26	38000177		0	0	7		0	0	0	309295	0	313782	1127433		
35126	2898	19128065	1993-01-12	1993-01-12 00:00:00	1994-01-07	1994-01-07 00:00:00	1994-01-07	38000177		0	0	360		0	0	0	193055	0	749882	19128065		
654	49	19073188	1992-12-15	1992-12-15 00:00:00	1992-12-29	1992-12-29 00:00:00	1992-12-29	38000177		0	0	14		0	0	0	3528	0	308192	19073188		
22810	495	40213306	1992-03-07	1992-03-07 00:00:00	1992-03-07	1992-03-07 00:00:00	1992-03-07	581452		0	0	0		0	0	0	33068	0	43	40213306		
48562	4022	1118084	1999-07-28	1999-07-28 00:00:00	1999-07-28	1999-07-28 00:00:00	\N	38000177		0	0	0		0	0	0	267423	0	00025152531	44923712		
163296	3592	40213227	2016-02-03	2016-02-03 00:00:00	2016-02-03	2016-02-03 00:00:00	2016-02-03	581452		0	0	0		0	0	0	238582	0	113	40213227		
40718	3376	19078461	2017-10-08	2017-10-08 00:00:00	2017-11-07	2017-11-07 00:00:00	2017-11-07	38000177		0	0	30		0	0	0	224003	0	310965	19078461		
1596	35	40213260	2011-01-11	2011-01-11 00:00:00	2011-01-11	2011-01-11 00:00:00	2011-01-11	581452		0	0	0		0	0	0	2444	0	121	40213260		
49663	4119	1127433	1981-04-28	1981-04-28 00:00:00	1981-05-12	1981-05-12 00:00:00	1981-05-12	38000177		0	0	14		0	0	0	273812	0	313782	1127433		
133396	2929	40213314	1977-07-23	1977-07-23 00:00:00	1977-07-23	1977-07-23 00:00:00	1977-07-23	581452		0	0	0		0	0	0	195403	0	49	40213314		
144521	3177	40213227	2008-04-16	2008-04-16 00:00:00	2008-04-16	2008-04-16 00:00:00	2008-04-16	581452		0	0	0		0	0	0	211293	0	113	40213227		
95952	2103	40213160	1973-01-20	1973-01-20 00:00:00	1973-01-20	1973-01-20 00:00:00	1973-01-20	581452		0	0	0		0	0	0	140155	0	10	40213160		
27402	597	40213160	1955-10-10	1955-10-10 00:00:00	1955-10-10	1955-10-10 00:00:00	1955-10-10	581452		0	0	0		0	0	0	39410	0	10	40213160		
37841	3128	1118084	2010-11-02	2010-11-02 00:00:00	2010-11-02	2010-11-02 00:00:00	\N	38000177		0	0	0		0	0	0	208174	0	00025152531	44923712		
59364	4933	19059056	1971-02-28	1971-02-28 00:00:00	1971-03-14	1971-03-14 00:00:00	1971-03-14	38000177		0	0	14		0	0	0	327978	0	243670	19059056		
18191	1508	1118084	1963-12-07	1963-12-07 00:00:00	1963-12-07	1963-12-07 00:00:00	\N	38000177		0	0	0		0	0	0	100571	0	00025152531	44923712		
35364	2914	46275916	1986-09-06	1986-09-06 00:00:00	1986-09-06	1986-09-06 00:00:00	1986-09-06	38000177		0	0	0		0	0	0	194195	0	1660014	46275916		
64499	1411	40213160	1966-05-10	1966-05-10 00:00:00	1966-05-10	1966-05-10 00:00:00	1966-05-10	581452		0	0	0		0	0	0	93922	0	10	40213160		
13552	1135	19059056	1959-09-04	1959-09-04 00:00:00	1959-09-18	1959-09-18 00:00:00	1959-09-18	38000177		0	0	14		0	0	0	74743	0	243670	19059056		
23139	1908	19059056	1974-09-26	1974-09-26 00:00:00	1974-10-10	1974-10-10 00:00:00	1974-10-10	38000177		0	0	14		0	0	0	126985	0	243670	19059056		
62154	5172	1127433	2006-04-30	2006-04-30 00:00:00	2006-05-21	2006-05-21 00:00:00	2006-05-21	38000177		0	0	21		0	0	0	343921	0	313782	1127433		
224788	4935	40213227	2015-12-10	2015-12-10 00:00:00	2015-12-10	2015-12-10 00:00:00	2015-12-10	581452		0	0	0		0	0	0	328152	0	113	40213227		
128629	2829	40213201	2016-12-05	2016-12-05 00:00:00	2016-12-05	2016-12-05 00:00:00	2016-12-05	581452		0	0	0		0	0	0	187628	0	33	40213201		
80090	1752	40213314	1978-04-02	1978-04-02 00:00:00	1978-04-02	1978-04-02 00:00:00	1978-04-02	581452		0	0	0		0	0	0	117143	0	49	40213314		
56611	4696	1713671	1968-12-13	1968-12-13 00:00:00	1968-12-27	1968-12-27 00:00:00	1968-12-27	38000177		0	0	14		0	0	0	312821	0	562251	1713671		
171016	3759	40213227	2006-08-20	2006-08-20 00:00:00	2006-08-20	2006-08-20 00:00:00	2006-08-20	581452		0	0	0		0	0	0	249943	0	113	40213227		
55544	4613	920300	1987-06-26	1987-06-26 00:00:00	1987-07-03	1987-07-03 00:00:00	1987-07-03	38000177		0	0	7		0	0	0	307268	0	311989	920300		
35348	2913	19078461	1988-03-14	1988-03-14 00:00:00	1988-03-28	1988-03-28 00:00:00	1988-03-28	38000177		0	0	14		0	0	0	194139	0	310965	19078461		
178210	3917	40213160	1968-05-16	1968-05-16 00:00:00	1968-05-16	1968-05-16 00:00:00	1968-05-16	581452		0	0	0		0	0	0	260461	0	10	40213160		
236613	5195	40213296	2000-05-17	2000-05-17 00:00:00	2000-05-17	2000-05-17 00:00:00	2000-05-17	581452		0	0	0		0	0	0	345461	0	52	40213296		
35698	2942	19059056	1965-07-26	1965-07-26 00:00:00	1965-08-23	1965-08-23 00:00:00	1965-08-23	38000177		0	0	28		0	0	0	196055	0	243670	19059056		
58143	1273	40213227	2007-10-01	2007-10-01 00:00:00	2007-10-01	2007-10-01 00:00:00	2007-10-01	581452		0	0	0		0	0	0	84005	0	113	40213227		
5196	437	1713671	1985-10-16	1985-10-16 00:00:00	1985-10-30	1985-10-30 00:00:00	1985-10-30	38000177		0	0	14		0	0	0	29028	0	562251	1713671		
56059	4655	19078461	2009-04-28	2009-04-28 00:00:00	2009-05-12	2009-05-12 00:00:00	2009-05-12	38000177		0	0	14		0	0	0	310304	0	310965	19078461		
172510	3791	40213227	2006-08-19	2006-08-19 00:00:00	2006-08-19	2006-08-19 00:00:00	2006-08-19	581452		0	0	0		0	0	0	252119	0	113	40213227		
10387	867	19059056	1931-02-18	1931-02-18 00:00:00	1931-03-11	1931-03-11 00:00:00	1931-03-11	38000177		0	0	21		0	0	0	57579	0	243670	19059056		
112789	2477	40213160	1955-08-07	1955-08-07 00:00:00	1955-08-07	1955-08-07 00:00:00	1955-08-07	581452		0	0	0		0	0	0	164126	0	10	40213160		
17008	1408	19006318	1953-12-13	1953-12-13 00:00:00	1953-12-27	1953-12-27 00:00:00	1953-12-27	38000177		0	0	14		0	0	0	93626	0	105078	19006318		
86067	1885	40213160	1978-02-07	1978-02-07 00:00:00	1978-02-07	1978-02-07 00:00:00	1978-02-07	581452		0	0	0		0	0	0	125678	0	10	40213160		
17072	1412	1154615	1963-05-20	1963-05-20 00:00:00	1963-05-20	1963-05-20 00:00:00	\N	38000177		0	0	0		0	0	0	94078	0	745679	1154615		
31554	2616	19006318	1953-09-17	1953-09-17 00:00:00	1953-10-01	1953-10-01 00:00:00	1953-10-01	38000177		0	0	14		0	0	0	172945	0	105078	19006318		
27621	2287	19078461	1987-12-12	1987-12-12 00:00:00	1988-01-09	1988-01-09 00:00:00	1988-01-09	38000177		0	0	28		0	0	0	152151	0	310965	19078461		
83249	1820	40213314	1978-07-18	1978-07-18 00:00:00	1978-07-18	1978-07-18 00:00:00	1978-07-18	581452		0	0	0		0	0	0	121717	0	49	40213314		
54867	4557	1115171	2017-06-24	2017-06-24 00:00:00	2017-09-22	2017-09-22 00:00:00	2017-09-22	38000177		0	0	90		0	0	0	303645	0	849574	1115171		
11057	236	40213160	1956-03-01	1956-03-01 00:00:00	1956-03-01	1956-03-01 00:00:00	1956-03-01	581452		0	0	0		0	0	0	15799	0	10	40213160		
166838	3667	40213227	2019-01-01	2019-01-01 00:00:00	2019-01-01	2019-01-01 00:00:00	2019-01-01	581452		0	0	0		0	0	0	243999	0	113	40213227		
54724	4546	1127433	1999-01-16	1999-01-16 00:00:00	1999-01-30	1999-01-30 00:00:00	1999-01-30	38000177		0	0	14		0	0	0	302794	0	313782	1127433		
42305	3509	1127078	1953-11-03	1953-11-03 00:00:00	1953-11-17	1953-11-17 00:00:00	1953-11-17	38000177		0	0	14		0	0	0	232696	0	282464	1127078		
37328	3083	1118084	1994-07-07	1994-07-07 00:00:00	1994-07-07	1994-07-07 00:00:00	\N	38000177		0	0	0		0	0	0	205263	0	00025152531	44923712		
33135	2747	1127433	1974-03-05	1974-03-05 00:00:00	1974-03-19	1974-03-19 00:00:00	1974-03-19	38000177		0	0	14		0	0	0	181714	0	313782	1127433		
50645	4208	1127433	1995-04-16	1995-04-16 00:00:00	1995-05-21	1995-05-21 00:00:00	1995-05-21	38000177		0	0	35		0	0	0	279430	0	313782	1127433		
63422	5268	19078461	2008-08-24	2008-08-24 00:00:00	2008-09-23	2008-09-23 00:00:00	2008-09-23	38000177		0	0	30		0	0	0	350491	0	310965	19078461		
102861	2256	40213296	2018-08-15	2018-08-15 00:00:00	2018-08-15	2018-08-15 00:00:00	2018-08-15	581452		0	0	0		0	0	0	149960	0	52	40213296		
234765	5157	40213160	1963-12-19	1963-12-19 00:00:00	1963-12-19	1963-12-19 00:00:00	1963-12-19	581452		0	0	0		0	0	0	342884	0	10	40213160		
40436	3352	1127433	1981-02-10	1981-02-10 00:00:00	1981-03-12	1981-03-12 00:00:00	1981-03-12	38000177		0	0	30		0	0	0	222259	0	313782	1127433		
106760	2340	40213160	1959-06-11	1959-06-11 00:00:00	1959-06-11	1959-06-11 00:00:00	1959-06-11	581452		0	0	0		0	0	0	155767	0	10	40213160		
16636	1379	1124300	1998-11-20	1998-11-20 00:00:00	1998-11-20	1998-11-20 00:00:00	\N	38000177		0	0	0		0	0	0	91517	0	00781178901	45011828		
34417	2844	1118084	1992-01-17	1992-01-17 00:00:00	1992-01-17	1992-01-17 00:00:00	\N	38000177		0	0	0		0	0	0	188860	0	00025152531	44923712		
34459	2847	1127433	1993-03-03	1993-03-03 00:00:00	1993-03-24	1993-03-24 00:00:00	1993-03-24	38000177		0	0	21		0	0	0	189120	0	313782	1127433		
45229	3744	1127433	2016-03-03	2016-03-03 00:00:00	2016-03-10	2016-03-10 00:00:00	2016-03-10	38000177		0	0	7		0	0	0	248835	0	313782	1127433		
7135	600	1118084	1987-08-21	1987-08-21 00:00:00	1987-08-21	1987-08-21 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00025152531	44923712		
62396	5194	1115171	2003-11-03	2003-11-03 00:00:00	2003-12-01	2003-12-01 00:00:00	2003-12-01	38000177		0	0	28		0	0	0	345406	0	849574	1115171		
17730	1468	19059056	1958-01-29	1958-01-29 00:00:00	1958-02-12	1958-02-12 00:00:00	1958-02-12	38000177		0	0	14		0	0	0	97879	0	243670	19059056		
48284	4005	19133905	2013-09-08	2013-09-08 00:00:00	2013-09-19	2013-09-19 00:00:00	2013-09-19	38000177		0	0	11		0	0	0	266119	0	834102	19133905		
55915	4641	1124300	2004-10-21	2004-10-21 00:00:00	2004-10-21	2004-10-21 00:00:00	\N	38000177		0	0	0		0	0	0	309351	0	00781178901	45011828		
35127	2898	40224805	1994-01-07	1994-01-07 00:00:00	1995-01-02	1995-01-02 00:00:00	1995-01-02	38000177		0	0	360		0	0	0	193056	0	1000126	40224805		
655	49	19078461	1992-12-15	1992-12-15 00:00:00	1992-12-29	1992-12-29 00:00:00	1992-12-29	38000177		0	0	14		0	0	0	3528	0	310965	19078461		
238370	5232	40213260	2017-10-07	2017-10-07 00:00:00	2017-10-07	2017-10-07 00:00:00	2017-10-07	581452		0	0	0		0	0	0	348128	0	121	40213260		
48563	4022	19128065	1974-07-09	1974-07-09 00:00:00	1975-07-04	1975-07-04 00:00:00	1975-07-04	38000177		0	0	360		0	0	0	267398	0	749882	19128065		
163297	3592	40213260	2016-02-03	2016-02-03 00:00:00	2016-02-03	2016-02-03 00:00:00	2016-02-03	581452		0	0	0		0	0	0	238582	0	121	40213260		
40719	3376	1127433	1963-10-23	1963-10-23 00:00:00	1963-11-06	1963-11-06 00:00:00	1963-11-06	38000177		0	0	14		0	0	0	223953	0	313782	1127433		
12915	279	40213227	2013-02-01	2013-02-01 00:00:00	2013-02-01	2013-02-01 00:00:00	2013-02-01	581452		0	0	0		0	0	0	18651	0	113	40213227		
49664	4119	19059056	1947-02-24	1947-02-24 00:00:00	1947-03-10	1947-03-10 00:00:00	1947-03-10	38000177		0	0	14		0	0	0	273795	0	243670	19059056		
133399	2929	40213227	2007-10-20	2007-10-20 00:00:00	2007-10-20	2007-10-20 00:00:00	2007-10-20	581452		0	0	0		0	0	0	195386	0	113	40213227		
144555	3177	40213227	1998-02-18	1998-02-18 00:00:00	1998-02-18	1998-02-18 00:00:00	1998-02-18	581452		0	0	0		0	0	0	211287	0	113	40213227		
95953	2103	40213160	1972-08-19	1972-08-19 00:00:00	1972-08-19	1972-08-19 00:00:00	1972-08-19	581452		0	0	0		0	0	0	140169	0	10	40213160		
27403	597	40213160	1956-04-09	1956-04-09 00:00:00	1956-04-09	1956-04-09 00:00:00	1956-04-09	581452		0	0	0		0	0	0	39434	0	10	40213160		
37842	3128	19078461	2007-03-19	2007-03-19 00:00:00	2007-04-09	2007-04-09 00:00:00	2007-04-09	38000177		0	0	21		0	0	0	208170	0	310965	19078461		
59365	4933	46233988	1971-02-28	1971-02-28 00:00:00	1971-03-14	1971-03-14 00:00:00	1971-03-14	38000177		0	0	14		0	0	0	327978	0	1652673	46233988		
18192	1508	19059056	1925-01-03	1925-01-03 00:00:00	1925-01-17	1925-01-17 00:00:00	1925-01-17	38000177		0	0	14		0	0	0	100609	0	243670	19059056		
35365	2914	1310034	1986-09-06	1986-09-06 00:00:00	1986-09-06	1986-09-06 00:00:00	1986-09-06	38000177		0	0	0		0	0	0	194195	0	834357	1310034		
197826	4347	40213160	1966-07-17	1966-07-17 00:00:00	1966-07-17	1966-07-17 00:00:00	1966-07-17	581452		0	0	0		0	0	0	288281	0	10	40213160		
13553	1135	1127433	1981-10-27	1981-10-27 00:00:00	1981-11-26	1981-11-26 00:00:00	1981-11-26	38000177		0	0	30		0	0	0	74762	0	313782	1127433		
23140	1908	1127433	1987-04-09	1987-04-09 00:00:00	1987-04-23	1987-04-23 00:00:00	1987-04-23	38000177		0	0	14		0	0	0	126952	0	313782	1127433		
62155	5172	1127433	2017-05-11	2017-05-11 00:00:00	2017-05-25	2017-05-25 00:00:00	2017-05-25	38000177		0	0	14		0	0	0	343856	0	313782	1127433		
224789	4935	40213260	2015-12-10	2015-12-10 00:00:00	2015-12-10	2015-12-10 00:00:00	2015-12-10	581452		0	0	0		0	0	0	328152	0	121	40213260		
128636	2829	40213227	1992-05-04	1992-05-04 00:00:00	1992-05-04	1992-05-04 00:00:00	1992-05-04	581452		0	0	0		0	0	0	187677	0	113	40213227		
80091	1752	40213160	1978-04-02	1978-04-02 00:00:00	1978-04-02	1978-04-02 00:00:00	1978-04-02	581452		0	0	0		0	0	0	117143	0	10	40213160		
56612	4696	1124300	1985-12-25	1985-12-25 00:00:00	1985-12-25	1985-12-25 00:00:00	\N	38000177		0	0	0		0	0	0	312887	0	00781178901	45011828		
171020	3759	40213306	1987-03-01	1987-03-01 00:00:00	1987-03-01	1987-03-01 00:00:00	1987-03-01	581452		0	0	0		0	0	0	249864	0	43	40213306		
55545	4613	40236824	1987-06-26	1987-06-26 00:00:00	1987-07-03	1987-07-03 00:00:00	1987-07-03	38000177		0	0	7		0	0	0	307268	0	1094107	40236824		
35349	2913	19078461	2002-05-14	2002-05-14 00:00:00	2002-06-04	2002-06-04 00:00:00	2002-06-04	38000177		0	0	21		0	0	0	194108	0	310965	19078461		
178216	3917	40213296	2010-02-18	2010-02-18 00:00:00	2010-02-18	2010-02-18 00:00:00	2010-02-18	581452		0	0	0		0	0	0	260458	0	52	40213296		
7351	159	40213160	1955-03-29	1955-03-29 00:00:00	1955-03-29	1955-03-29 00:00:00	1955-03-29	581452		0	0	0		0	0	0	10878	0	10	40213160		
35699	2942	19008572	1959-05-10	1959-05-10 00:00:00	1959-05-31	1959-05-31 00:00:00	1959-05-31	38000177		0	0	21		0	0	0	196181	0	106258	19008572		
93839	2060	40213296	2006-08-23	2006-08-23 00:00:00	2006-08-23	2006-08-23 00:00:00	2006-08-23	581452		0	0	0		0	0	0	137029	0	52	40213296		
5197	437	1118084	1987-07-22	1987-07-22 00:00:00	1987-07-22	1987-07-22 00:00:00	\N	38000177		0	0	0		0	0	0	29008	0	00025152531	44923712		
56060	4655	1551192	1963-05-22	1963-05-22 00:00:00	1963-05-22	1963-05-22 00:00:00	1963-05-22	38000177		0	0	0		0	0	0	310298	0	312617	1551192		
10317	863	1115171	2003-05-09	2003-05-09 00:00:00	2003-06-13	2003-06-13 00:00:00	2003-06-13	38000177		0	0	35		0	0	0	57180	0	849574	1115171		
10388	867	19078461	2005-04-25	2005-04-25 00:00:00	2005-07-24	2005-07-24 00:00:00	2005-07-24	38000177		0	0	90		0	0	0	57584	0	310965	19078461		
62138	1357	40213160	1975-06-06	1975-06-06 00:00:00	1975-06-06	1975-06-06 00:00:00	1975-06-06	581452		0	0	0		0	0	0	90019	0	10	40213160		
17009	1408	19059056	1959-08-06	1959-08-06 00:00:00	1959-09-03	1959-09-03 00:00:00	1959-09-03	38000177		0	0	28		0	0	0	93620	0	243670	19059056		
10009	213	40213160	1968-01-08	1968-01-08 00:00:00	1968-01-08	1968-01-08 00:00:00	1968-01-08	581452		0	0	0		0	0	0	14479	0	10	40213160		
17073	1412	1127433	2006-11-05	2006-11-05 00:00:00	2006-11-19	2006-11-19 00:00:00	2006-11-19	38000177		0	0	14		0	0	0	93985	0	313782	1127433		
212558	4661	40213251	1984-10-11	1984-10-11 00:00:00	1984-10-11	1984-10-11 00:00:00	1984-10-11	581452		0	0	0		0	0	0	310712	0	21	40213251		
27622	2287	1127433	1984-12-13	1984-12-13 00:00:00	1984-12-20	1984-12-20 00:00:00	1984-12-20	38000177		0	0	7		0	0	0	152099	0	313782	1127433		
83250	1820	40213160	1978-07-18	1978-07-18 00:00:00	1978-07-18	1978-07-18 00:00:00	1978-07-18	581452		0	0	0		0	0	0	121717	0	10	40213160		
54868	4557	19059056	1968-01-31	1968-01-31 00:00:00	1968-02-21	1968-02-21 00:00:00	1968-02-21	38000177		0	0	21		0	0	0	303640	0	243670	19059056		
11063	236	40213198	2016-06-16	2016-06-16 00:00:00	2016-06-16	2016-06-16 00:00:00	2016-06-16	581452		0	0	0		0	0	0	15812	0	133	40213198		
166839	3667	40213260	2019-01-01	2019-01-01 00:00:00	2019-01-01	2019-01-01 00:00:00	2019-01-01	581452		0	0	0		0	0	0	243999	0	121	40213260		
54725	4546	19133873	1984-06-18	1984-06-18 00:00:00	1984-06-27	1984-06-27 00:00:00	1984-06-27	38000177		0	0	9		0	0	0	302822	0	834061	19133873		
42306	3509	19059056	1973-06-10	1973-06-10 00:00:00	1973-06-24	1973-06-24 00:00:00	1973-06-24	38000177		0	0	14		0	0	0	232791	0	243670	19059056		
37329	3083	40236824	1994-07-21	1994-07-21 00:00:00	1994-07-28	1994-07-28 00:00:00	1994-07-28	38000177		0	0	7		0	0	0	205263	0	1094107	40236824		
33136	2747	19133905	1995-09-30	1995-09-30 00:00:00	1995-10-10	1995-10-10 00:00:00	1995-10-10	38000177		0	0	10		0	0	0	181694	0	834102	19133905		
50646	4208	19078461	2012-09-18	2012-09-18 00:00:00	2012-10-09	2012-10-09 00:00:00	2012-10-09	38000177		0	0	21		0	0	0	279459	0	310965	19078461		
63423	5268	40231925	2008-08-24	2008-08-24 00:00:00	2008-08-24	2008-08-24 00:00:00	\N	38000177		0	0	0		0	0	0	350491	0	1049221	40231925		
102867	2256	40213160	1983-07-20	1983-07-20 00:00:00	1983-07-20	1983-07-20 00:00:00	1983-07-20	581452		0	0	0		0	0	0	149943	0	10	40213160		
234771	5157	40213227	1994-09-15	1994-09-15 00:00:00	1994-09-15	1994-09-15 00:00:00	1994-09-15	581452		0	0	0		0	0	0	342891	0	113	40213227		
40437	3352	40169281	2001-12-21	2001-12-21 00:00:00	2001-12-21	2001-12-21 00:00:00	\N	38000177		0	0	0		0	0	0	222304	0	896209	40169281		
106762	2341	40213296	1996-04-11	1996-04-11 00:00:00	1996-04-11	1996-04-11 00:00:00	1996-04-11	581452		0	0	0		0	0	0	155793	0	52	40213296		
16637	1379	19128065	1977-01-24	1977-01-24 00:00:00	1978-01-19	1978-01-19 00:00:00	1978-01-19	38000177		0	0	360		0	0	0	91496	0	749882	19128065		
34418	2844	1127433	1986-09-07	1986-09-07 00:00:00	1986-09-14	1986-09-14 00:00:00	1986-09-14	38000177		0	0	7		0	0	0	188805	0	313782	1127433		
34460	2847	19133873	1968-12-23	1968-12-23 00:00:00	1969-01-05	1969-01-05 00:00:00	1969-01-05	38000177		0	0	13		0	0	0	189108	0	834061	19133873		
45230	3744	1127433	1990-11-08	1990-11-08 00:00:00	1991-02-06	1991-02-06 00:00:00	1991-02-06	38000177		0	0	90		0	0	0	248851	0	313782	1127433		
7136	600	1713671	1992-02-10	1992-02-10 00:00:00	1992-02-17	1992-02-17 00:00:00	1992-02-17	38000177		0	0	7		0	0	0	39641	0	562251	1713671		
62397	5194	19059056	1949-10-21	1949-10-21 00:00:00	1949-11-04	1949-11-04 00:00:00	1949-11-04	38000177		0	0	14		0	0	0	345385	0	243670	19059056		
25607	2105	1713671	2000-06-20	2000-06-20 00:00:00	2000-07-11	2000-07-11 00:00:00	2000-07-11	38000177		0	0	21		0	0	0	140238	0	562251	1713671		
48285	4005	19078461	1999-03-14	1999-03-14 00:00:00	1999-04-04	1999-04-04 00:00:00	1999-04-04	38000177		0	0	21		0	0	0	266085	0	310965	19078461		
55916	4642	1127433	1979-02-07	1979-02-07 00:00:00	1979-03-14	1979-03-14 00:00:00	1979-03-14	38000177		0	0	35		0	0	0	309392	0	313782	1127433		
35128	2898	19128065	1995-01-02	1995-01-02 00:00:00	1995-12-28	1995-12-28 00:00:00	1995-12-28	38000177		0	0	360		0	0	0	193058	0	749882	19128065		
656	49	40165015	1992-12-15	1992-12-15 00:00:00	1992-12-15	1992-12-15 00:00:00	\N	38000177		0	0	0		0	0	0	3528	0	861467	40165015		
238371	5232	40213160	1968-01-13	1968-01-13 00:00:00	1968-01-13	1968-01-13 00:00:00	1968-01-13	581452		0	0	0		0	0	0	348102	0	10	40213160		
48564	4022	19128065	1977-06-23	1977-06-23 00:00:00	1978-06-18	1978-06-18 00:00:00	1978-06-18	38000177		0	0	360		0	0	0	267366	0	749882	19128065		
163299	3593	40213198	2017-06-14	2017-06-14 00:00:00	2017-06-14	2017-06-14 00:00:00	2017-06-14	581452		0	0	0		0	0	0	238652	0	133	40213198		
40720	3376	1713671	1976-01-15	1976-01-15 00:00:00	1976-01-22	1976-01-22 00:00:00	1976-01-22	38000177		0	0	7		0	0	0	223929	0	562251	1713671		
65543	1433	40213227	2011-01-10	2011-01-10 00:00:00	2011-01-10	2011-01-10 00:00:00	2011-01-10	581452		0	0	0		0	0	0	95437	0	113	40213227		
49665	4119	19006318	1947-02-24	1947-02-24 00:00:00	1947-03-10	1947-03-10 00:00:00	1947-03-10	38000177		0	0	14		0	0	0	273795	0	105078	19006318		
133401	2929	40213227	1996-10-05	1996-10-05 00:00:00	1996-10-05	1996-10-05 00:00:00	1996-10-05	581452		0	0	0		0	0	0	195383	0	113	40213227		
123456	2712	40213296	2004-01-06	2004-01-06 00:00:00	2004-01-06	2004-01-06 00:00:00	2004-01-06	581452		0	0	0		0	0	0	179869	0	52	40213296		
95964	2103	40213296	2012-05-19	2012-05-19 00:00:00	2012-05-19	2012-05-19 00:00:00	2012-05-19	581452		0	0	0		0	0	0	140178	0	52	40213296		
27405	597	40213260	2006-10-02	2006-10-02 00:00:00	2006-10-02	2006-10-02 00:00:00	2006-10-02	581452		0	0	0		0	0	0	39404	0	121	40213260		
37843	3128	19133905	2011-01-10	2011-01-10 00:00:00	2011-01-21	2011-01-21 00:00:00	2011-01-21	38000177		0	0	11		0	0	0	208175	0	834102	19133905		
59366	4933	19019979	1980-03-03	1980-03-03 00:00:00	1980-06-01	1980-06-01 00:00:00	1980-06-01	38000177		0	0	90		0	0	0	327967	0	198405	19019979		
18193	1508	19059056	1928-03-24	1928-03-24 00:00:00	1928-04-07	1928-04-07 00:00:00	1928-04-07	38000177		0	0	14		0	0	0	100610	0	243670	19059056		
35366	2914	1127433	1985-07-28	1985-07-28 00:00:00	1985-08-04	1985-08-04 00:00:00	1985-08-04	38000177		0	0	7		0	0	0	194212	0	313782	1127433		
197827	4347	40213160	1966-09-18	1966-09-18 00:00:00	1966-09-18	1966-09-18 00:00:00	1966-09-18	581452		0	0	0		0	0	0	288306	0	10	40213160		
13554	1136	1115171	2007-06-05	2007-06-05 00:00:00	2007-08-04	2007-08-04 00:00:00	2007-08-04	38000177		0	0	60		0	0	0	74856	0	849574	1115171		
23141	1908	1713671	2005-04-20	2005-04-20 00:00:00	2005-05-04	2005-05-04 00:00:00	2005-05-04	38000177		0	0	14		0	0	0	126999	0	562251	1713671		
62156	5172	19059056	1952-10-23	1952-10-23 00:00:00	1952-11-13	1952-11-13 00:00:00	1952-11-13	38000177		0	0	21		0	0	0	343917	0	243670	19059056		
224791	4935	40213306	1987-01-22	1987-01-22 00:00:00	1987-01-22	1987-01-22 00:00:00	1987-01-22	581452		0	0	0		0	0	0	328137	0	43	40213306		
128640	2829	40213227	2011-11-07	2011-11-07 00:00:00	2011-11-07	2011-11-07 00:00:00	2011-11-07	581452		0	0	0		0	0	0	187682	0	113	40213227		
80094	1752	40213160	1978-09-04	1978-09-04 00:00:00	1978-09-04	1978-09-04 00:00:00	1978-09-04	581452		0	0	0		0	0	0	117144	0	10	40213160		
56613	4696	19059056	1953-03-03	1953-03-03 00:00:00	1953-03-17	1953-03-17 00:00:00	1953-03-17	38000177		0	0	14		0	0	0	312827	0	243670	19059056		
171029	3759	40213260	2015-07-26	2015-07-26 00:00:00	2015-07-26	2015-07-26 00:00:00	2015-07-26	581452		0	0	0		0	0	0	249872	0	121	40213260		
55546	4613	40224805	2007-01-06	2007-01-06 00:00:00	2008-01-01	2008-01-01 00:00:00	2008-01-01	38000177		0	0	360		0	0	0	307279	0	1000126	40224805		
35350	2913	19059056	1948-01-14	1948-01-14 00:00:00	1948-02-13	1948-02-13 00:00:00	1948-02-13	38000177		0	0	30		0	0	0	194138	0	243670	19059056		
178217	3917	40213227	2010-02-18	2010-02-18 00:00:00	2010-02-18	2010-02-18 00:00:00	2010-02-18	581452		0	0	0		0	0	0	260458	0	113	40213227		
7358	159	40213227	2015-06-09	2015-06-09 00:00:00	2015-06-09	2015-06-09 00:00:00	2015-06-09	581452		0	0	0		0	0	0	10931	0	113	40213227		
35700	2942	1127433	2007-12-09	2007-12-09 00:00:00	2007-12-16	2007-12-16 00:00:00	2007-12-16	38000177		0	0	7		0	0	0	196209	0	313782	1127433		
93842	2060	40213227	2006-08-23	2006-08-23 00:00:00	2006-08-23	2006-08-23 00:00:00	2006-08-23	581452		0	0	0		0	0	0	137029	0	113	40213227		
5198	437	1713671	1976-01-04	1976-01-04 00:00:00	1976-01-25	1976-01-25 00:00:00	1976-01-25	38000177		0	0	21		0	0	0	29026	0	562251	1713671		
56061	4655	920300	2016-01-12	2016-01-12 00:00:00	2016-01-19	2016-01-19 00:00:00	2016-01-19	38000177		0	0	7		0	0	0	310287	0	311989	920300		
10318	863	40229134	1932-07-23	1932-07-23 00:00:00	1932-07-30	1932-07-30 00:00:00	1932-07-30	38000177		0	0	7		0	0	0	57199	0	1043400	40229134		
10389	867	19077572	2012-07-31	2012-07-31 00:00:00	2012-07-31	2012-07-31 00:00:00	\N	38000177		0	0	0		0	0	0	57615	0	310436	19077572		
62141	1357	40213227	2017-05-05	2017-05-05 00:00:00	2017-05-05	2017-05-05 00:00:00	2017-05-05	581452		0	0	0		0	0	0	90021	0	113	40213227		
17010	1409	1127433	1937-09-07	1937-09-07 00:00:00	1937-09-21	1937-09-21 00:00:00	1937-09-21	38000177		0	0	14		0	0	0	93813	0	313782	1127433		
10018	213	40213260	2017-06-26	2017-06-26 00:00:00	2017-06-26	2017-06-26 00:00:00	2017-06-26	581452		0	0	0		0	0	0	14496	0	121	40213260		
17074	1412	1127433	1975-11-27	1975-11-27 00:00:00	1975-12-11	1975-12-11 00:00:00	1975-12-11	38000177		0	0	14		0	0	0	94081	0	313782	1127433		
212566	4661	40213160	1977-06-23	1977-06-23 00:00:00	1977-06-23	1977-06-23 00:00:00	1977-06-23	581452		0	0	0		0	0	0	310709	0	10	40213160		
27623	2287	1310034	2014-01-24	2014-01-24 00:00:00	2014-01-24	2014-01-24 00:00:00	2014-01-24	38000177		0	0	0		0	0	0	152154	0	834357	1310034		
83254	1820	40213227	2000-04-11	2000-04-11 00:00:00	2000-04-11	2000-04-11 00:00:00	2000-04-11	581452		0	0	0		0	0	0	121707	0	113	40213227		
54869	4557	1127433	1998-06-22	1998-06-22 00:00:00	1998-06-29	1998-06-29 00:00:00	1998-06-29	38000177		0	0	7		0	0	0	303624	0	313782	1127433		
11069	236	40213227	1994-02-03	1994-02-03 00:00:00	1994-02-03	1994-02-03 00:00:00	1994-02-03	581452		0	0	0		0	0	0	15875	0	113	40213227		
166845	3667	40213160	1967-12-19	1967-12-19 00:00:00	1967-12-19	1967-12-19 00:00:00	1967-12-19	581452		0	0	0		0	0	0	243941	0	10	40213160		
54726	4546	19128065	1983-06-20	1983-06-20 00:00:00	1984-06-14	1984-06-14 00:00:00	1984-06-14	38000177		0	0	360		0	0	0	302819	0	749882	19128065		
42307	3509	19133873	1956-06-27	1956-06-27 00:00:00	1956-07-06	1956-07-06 00:00:00	1956-07-06	38000177		0	0	9		0	0	0	232735	0	834061	19133873		
37330	3083	920300	1994-07-21	1994-07-21 00:00:00	1994-07-28	1994-07-28 00:00:00	1994-07-28	38000177		0	0	7		0	0	0	205263	0	311989	920300		
33137	2747	19078461	1990-01-29	1990-01-29 00:00:00	1990-02-26	1990-02-26 00:00:00	1990-02-26	38000177		0	0	28		0	0	0	181719	0	310965	19078461		
50647	4208	1127433	1950-07-26	1950-07-26 00:00:00	1950-08-09	1950-08-09 00:00:00	1950-08-09	38000177		0	0	14		0	0	0	279396	0	313782	1127433		
63424	5268	1127433	1979-05-09	1979-05-09 00:00:00	1979-05-16	1979-05-16 00:00:00	1979-05-16	38000177		0	0	7		0	0	0	350510	0	313782	1127433		
43691	3621	1127433	1924-11-29	1924-11-29 00:00:00	1924-12-13	1924-12-13 00:00:00	1924-12-13	38000177		0	0	14		0	0	0	240635	0	313782	1127433		
234779	5157	40213260	2013-04-11	2013-04-11 00:00:00	2013-04-11	2013-04-11 00:00:00	2013-04-11	581452		0	0	0		0	0	0	342943	0	121	40213260		
40438	3353	19059056	1937-11-19	1937-11-19 00:00:00	1937-12-19	1937-12-19 00:00:00	1937-12-19	38000177		0	0	30		0	0	0	222424	0	243670	19059056		
51631	4289	1127433	2017-05-10	2017-05-10 00:00:00	2017-08-08	2017-08-08 00:00:00	2017-08-08	38000177		0	0	90		0	0	0	284744	0	313782	1127433		
16638	1379	40229134	2000-07-23	2000-07-23 00:00:00	2000-08-06	2000-08-06 00:00:00	2000-08-06	38000177		0	0	14		0	0	0	91495	0	1043400	40229134		
34419	2844	1127433	2019-04-25	2019-04-25 00:00:00	2019-05-25	2019-05-25 00:00:00	2019-05-25	38000177		0	0	30		0	0	0	188893	0	313782	1127433		
34461	2847	1118084	2001-11-18	2001-11-18 00:00:00	2001-11-18	2001-11-18 00:00:00	\N	38000177		0	0	0		0	0	0	189055	0	00025152531	44923712		
77652	1699	40213227	1998-02-15	1998-02-15 00:00:00	1998-02-15	1998-02-15 00:00:00	1998-02-15	581452		0	0	0		0	0	0	113610	0	113	40213227		
7137	600	40229134	1960-06-04	1960-06-04 00:00:00	1960-06-11	1960-06-11 00:00:00	1960-06-11	38000177		0	0	7		0	0	0	39625	0	1043400	40229134		
62399	5194	19059056	1950-10-29	1950-10-29 00:00:00	1950-11-12	1950-11-12 00:00:00	1950-11-12	38000177		0	0	14		0	0	0	345386	0	243670	19059056		
25608	2105	1713671	1982-05-06	1982-05-06 00:00:00	1982-05-13	1982-05-13 00:00:00	1982-05-13	38000177		0	0	7		0	0	0	140243	0	562251	1713671		
48286	4005	1713671	1986-04-08	1986-04-08 00:00:00	1986-04-15	1986-04-15 00:00:00	1986-04-15	38000177		0	0	7		0	0	0	266129	0	562251	1713671		
55917	4642	1551192	1953-08-23	1953-08-23 00:00:00	1953-08-23	1953-08-23 00:00:00	1953-08-23	38000177		0	0	0		0	0	0	309390	0	312617	1551192		
35129	2898	19112599	1980-03-29	1980-03-29 00:00:00	1980-03-29	1980-03-29 00:00:00	\N	38000177		0	0	0		0	0	0	193004	0	477045	19112599		
657	49	19059056	1982-04-16	1982-04-16 00:00:00	1982-05-14	1982-05-14 00:00:00	1982-05-14	38000177		0	0	28		0	0	0	3526	0	243670	19059056		
238373	5232	40213227	2018-10-13	2018-10-13 00:00:00	2018-10-13	2018-10-13 00:00:00	2018-10-13	581452		0	0	0		0	0	0	348113	0	113	40213227		
48565	4022	19078461	2010-06-09	2010-06-09 00:00:00	2010-07-14	2010-07-14 00:00:00	2010-07-14	38000177		0	0	35		0	0	0	267387	0	310965	19078461		
163303	3593	40213201	2018-06-20	2018-06-20 00:00:00	2018-06-20	2018-06-20 00:00:00	2018-06-20	581452		0	0	0		0	0	0	238716	0	33	40213201		
40732	3378	19133905	1977-05-03	1977-05-03 00:00:00	1977-05-16	1977-05-16 00:00:00	1977-05-16	38000177		0	0	13		0	0	0	224123	0	834102	19133905		
65544	1433	40213260	2011-01-10	2011-01-10 00:00:00	2011-01-10	2011-01-10 00:00:00	2011-01-10	581452		0	0	0		0	0	0	95437	0	121	40213260		
49666	4119	19075601	2001-09-29	2001-09-29 00:00:00	2001-09-29	2001-09-29 00:00:00	2001-09-29	38000177		0	0	0		0	0	0	273830	0	309362	19075601		
133402	2929	40213306	1996-10-05	1996-10-05 00:00:00	1996-10-05	1996-10-05 00:00:00	1996-10-05	581452		0	0	0		0	0	0	195383	0	43	40213306		
123459	2712	40213296	2006-01-10	2006-01-10 00:00:00	2006-01-10	2006-01-10 00:00:00	2006-01-10	581452		0	0	0		0	0	0	179857	0	52	40213296		
155129	3414	40213296	2010-09-02	2010-09-02 00:00:00	2010-09-02	2010-09-02 00:00:00	2010-09-02	581452		0	0	0		0	0	0	226458	0	52	40213296		
27409	597	40213160	1955-04-11	1955-04-11 00:00:00	1955-04-11	1955-04-11 00:00:00	1955-04-11	581452		0	0	0		0	0	0	39428	0	10	40213160		
37844	3128	1127433	2009-05-28	2009-05-28 00:00:00	2009-06-25	2009-06-25 00:00:00	2009-06-25	38000177		0	0	28		0	0	0	208171	0	313782	1127433		
59367	4933	19115351	1980-03-13	1980-03-13 00:00:00	1980-07-24	1980-07-24 00:00:00	1980-07-24	38000177		0	0	133		0	0	0	327960	0	563026	19115351		
18194	1508	1115171	2014-10-06	2014-10-06 00:00:00	2015-01-04	2015-01-04 00:00:00	2015-01-04	38000177		0	0	90		0	0	0	100550	0	849574	1115171		
35367	2914	1127433	1991-03-17	1991-03-17 00:00:00	1991-04-07	1991-04-07 00:00:00	1991-04-07	38000177		0	0	21		0	0	0	194196	0	313782	1127433		
65476	1432	40213160	1966-08-09	1966-08-09 00:00:00	1966-08-09	1966-08-09 00:00:00	1966-08-09	581452		0	0	0		0	0	0	95389	0	10	40213160		
13555	1136	1713671	2007-12-30	2007-12-30 00:00:00	2008-01-20	2008-01-20 00:00:00	2008-01-20	38000177		0	0	21		0	0	0	74813	0	562251	1713671		
23142	1908	19073183	1980-01-03	1980-01-03 00:00:00	1980-01-17	1980-01-17 00:00:00	1980-01-17	38000177		0	0	14		0	0	0	126974	0	308182	19073183		
62157	5172	1127433	2013-09-20	2013-09-20 00:00:00	2013-09-27	2013-09-27 00:00:00	2013-09-27	38000177		0	0	7		0	0	0	343865	0	313782	1127433		
224797	4935	40213260	2014-12-04	2014-12-04 00:00:00	2014-12-04	2014-12-04 00:00:00	2014-12-04	581452		0	0	0		0	0	0	328141	0	121	40213260		
128649	2829	40213160	1955-08-15	1955-08-15 00:00:00	1955-08-15	1955-08-15 00:00:00	1955-08-15	581452		0	0	0		0	0	0	187652	0	10	40213160		
80099	1752	40213227	2009-05-18	2009-05-18 00:00:00	2009-05-18	2009-05-18 00:00:00	2009-05-18	581452		0	0	0		0	0	0	117139	0	113	40213227		
56632	4700	19006318	1953-01-11	1953-01-11 00:00:00	1953-01-25	1953-01-25 00:00:00	1953-01-25	38000177		0	0	14		0	0	0	313035	0	105078	19006318		
171031	3759	40213227	2016-07-31	2016-07-31 00:00:00	2016-07-31	2016-07-31 00:00:00	2016-07-31	581452		0	0	0		0	0	0	249878	0	113	40213227		
55547	4613	43012754	1995-03-03	1995-03-03 00:00:00	1996-02-26	1996-02-26 00:00:00	1996-02-26	38000177		0	0	360		0	0	0	307320	0	1366343	43012754		
35351	2913	1713671	1957-11-05	1957-11-05 00:00:00	1957-12-03	1957-12-03 00:00:00	1957-12-03	38000177		0	0	28		0	0	0	194110	0	562251	1713671		
27949	2314	19059056	1952-10-29	1952-10-29 00:00:00	1952-11-12	1952-11-12 00:00:00	1952-11-12	38000177		0	0	14		0	0	0	153857	0	243670	19059056		
216391	4749	40213227	1994-12-24	1994-12-24 00:00:00	1994-12-24	1994-12-24 00:00:00	1994-12-24	581452		0	0	0		0	0	0	316235	0	113	40213227		
35701	2942	1127433	2012-10-25	2012-10-25 00:00:00	2012-11-01	2012-11-01 00:00:00	2012-11-01	38000177		0	0	7		0	0	0	196223	0	313782	1127433		
93845	2060	40213160	1968-11-20	1968-11-20 00:00:00	1968-11-20	1968-11-20 00:00:00	1968-11-20	581452		0	0	0		0	0	0	136988	0	10	40213160		
38004	829	40213314	1977-02-06	1977-02-06 00:00:00	1977-02-06	1977-02-06 00:00:00	1977-02-06	581452		0	0	0		0	0	0	54920	0	49	40213314		
56062	4655	40236824	2016-01-12	2016-01-12 00:00:00	2016-01-19	2016-01-19 00:00:00	2016-01-19	38000177		0	0	7		0	0	0	310287	0	1094107	40236824		
10319	863	19075601	2014-08-07	2014-08-07 00:00:00	2014-08-07	2014-08-07 00:00:00	\N	38000177		0	0	0		0	0	0	57191	0	309362	19075601		
10390	867	1127433	1963-08-31	1963-08-31 00:00:00	1963-09-07	1963-09-07 00:00:00	1963-09-07	38000177		0	0	7		0	0	0	57541	0	313782	1127433		
62142	1357	40213296	2017-05-05	2017-05-05 00:00:00	2017-05-05	2017-05-05 00:00:00	2017-05-05	581452		0	0	0		0	0	0	90021	0	52	40213296		
17011	1409	40229134	1997-11-17	1997-11-17 00:00:00	1997-12-01	1997-12-01 00:00:00	1997-12-01	38000177		0	0	14		0	0	0	93716	0	1043400	40229134		
10023	213	40213260	2018-07-02	2018-07-02 00:00:00	2018-07-02	2018-07-02 00:00:00	2018-07-02	581452		0	0	0		0	0	0	14523	0	121	40213260		
17075	1412	19133873	1969-02-02	1969-02-02 00:00:00	1969-02-10	1969-02-10 00:00:00	1969-02-10	38000177		0	0	8		0	0	0	94091	0	834061	19133873		
212571	4661	40213160	1981-09-24	1981-09-24 00:00:00	1981-09-24	1981-09-24 00:00:00	1981-09-24	581452		0	0	0		0	0	0	310701	0	10	40213160		
27624	2287	40243436	2014-01-24	2014-01-24 00:00:00	2014-01-24	2014-01-24 00:00:00	2014-01-24	38000177		0	0	0		0	0	0	152154	0	1190795	40243436		
83255	1820	40213306	2000-04-11	2000-04-11 00:00:00	2000-04-11	2000-04-11 00:00:00	2000-04-11	581452		0	0	0		0	0	0	121707	0	43	40213306		
54871	4559	19059056	1956-12-04	1956-12-04 00:00:00	1956-12-18	1956-12-18 00:00:00	1956-12-18	38000177		0	0	14		0	0	0	303780	0	243670	19059056		
11078	236	40213160	1955-02-24	1955-02-24 00:00:00	1955-02-24	1955-02-24 00:00:00	1955-02-24	581452		0	0	0		0	0	0	15944	0	10	40213160		
44940	978	40213314	1977-01-21	1977-01-21 00:00:00	1977-01-21	1977-01-21 00:00:00	1977-01-21	581452		0	0	0		0	0	0	65148	0	49	40213314		
54727	4546	1713671	1990-07-29	1990-07-29 00:00:00	1990-08-05	1990-08-05 00:00:00	1990-08-05	38000177		0	0	7		0	0	0	302816	0	562251	1713671		
42308	3509	1713671	2011-06-18	2011-06-18 00:00:00	2011-07-09	2011-07-09 00:00:00	2011-07-09	38000177		0	0	21		0	0	0	232784	0	562251	1713671		
37331	3084	19128022	1992-11-14	1992-11-14 00:00:00	1993-11-09	1993-11-09 00:00:00	1993-11-09	38000177		0	0	360		0	0	0	205370	0	749785	19128022		
33138	2747	40229134	2019-04-30	2019-04-30 00:00:00	2019-05-07	2019-05-07 00:00:00	2019-05-07	38000177		0	0	7		0	0	0	181678	0	1043400	40229134		
50648	4208	1713671	1998-02-09	1998-02-09 00:00:00	1998-03-02	1998-03-02 00:00:00	1998-03-02	38000177		0	0	21		0	0	0	279449	0	562251	1713671		
63425	5268	1713671	2015-08-06	2015-08-06 00:00:00	2015-08-27	2015-08-27 00:00:00	2015-08-27	38000177		0	0	21		0	0	0	350480	0	562251	1713671		
43692	3621	1127433	1972-02-28	1972-02-28 00:00:00	1972-03-06	1972-03-06 00:00:00	1972-03-06	38000177		0	0	7		0	0	0	240611	0	313782	1127433		
234784	5157	40213260	2014-04-17	2014-04-17 00:00:00	2014-04-17	2014-04-17 00:00:00	2014-04-17	581452		0	0	0		0	0	0	342900	0	121	40213260		
40439	3353	1127433	1962-04-23	1962-04-23 00:00:00	1962-04-30	1962-04-30 00:00:00	1962-04-30	38000177		0	0	7		0	0	0	222416	0	313782	1127433		
51632	4289	1127433	2017-11-11	2017-11-11 00:00:00	2017-11-18	2017-11-18 00:00:00	2017-11-18	38000177		0	0	7		0	0	0	284754	0	313782	1127433		
16639	1379	19059056	1987-08-30	1987-08-30 00:00:00	1987-09-13	1987-09-13 00:00:00	1987-09-13	38000177		0	0	14		0	0	0	91515	0	243670	19059056		
34420	2844	40231925	2019-04-25	2019-04-25 00:00:00	2019-04-25	2019-04-25 00:00:00	\N	38000177		0	0	0		0	0	0	188893	0	1049221	40231925		
34462	2847	1127433	2009-06-09	2009-06-09 00:00:00	2009-06-23	2009-06-23 00:00:00	2009-06-23	38000177		0	0	14		0	0	0	189106	0	313782	1127433		
77653	1699	40213160	1966-07-10	1966-07-10 00:00:00	1966-07-10	1966-07-10 00:00:00	1966-07-10	581452		0	0	0		0	0	0	113639	0	10	40213160		
7138	600	920300	1985-01-27	1985-01-27 00:00:00	1985-02-03	1985-02-03 00:00:00	1985-02-03	38000177		0	0	7		0	0	0	39628	0	311989	920300		
62400	5194	19006318	1950-10-29	1950-10-29 00:00:00	1950-11-12	1950-11-12 00:00:00	1950-11-12	38000177		0	0	14		0	0	0	345386	0	105078	19006318		
25609	2105	1127433	1978-11-27	1978-11-27 00:00:00	1978-12-04	1978-12-04 00:00:00	1978-12-04	38000177		0	0	7		0	0	0	140254	0	313782	1127433		
48287	4005	1127078	1971-05-12	1971-05-12 00:00:00	1971-05-26	1971-05-26 00:00:00	1971-05-26	38000177		0	0	14		0	0	0	266081	0	282464	1127078		
55918	4642	1127433	1984-09-09	1984-09-09 00:00:00	1984-09-23	1984-09-23 00:00:00	1984-09-23	38000177		0	0	14		0	0	0	309471	0	313782	1127433		
35130	2898	19128065	1997-12-17	1997-12-17 00:00:00	1998-12-12	1998-12-12 00:00:00	1998-12-12	38000177		0	0	360		0	0	0	193036	0	749882	19128065		
658	49	1127433	1979-12-21	1979-12-21 00:00:00	1980-01-04	1980-01-04 00:00:00	1980-01-04	38000177		0	0	14		0	0	0	3514	0	313782	1127433		
238374	5232	40213260	2018-10-13	2018-10-13 00:00:00	2018-10-13	2018-10-13 00:00:00	2018-10-13	581452		0	0	0		0	0	0	348113	0	121	40213260		
48566	4022	19133873	1968-11-28	1968-11-28 00:00:00	1968-12-06	1968-12-06 00:00:00	1968-12-06	38000177		0	0	8		0	0	0	267396	0	834061	19133873		
163305	3593	40213160	1955-08-24	1955-08-24 00:00:00	1955-08-24	1955-08-24 00:00:00	1955-08-24	581452		0	0	0		0	0	0	238681	0	10	40213160		
40733	3378	1118084	1994-12-03	1994-12-03 00:00:00	1994-12-03	1994-12-03 00:00:00	\N	38000177		0	0	0		0	0	0	224200	0	00025152531	44923712		
65554	1435	40213296	2001-02-24	2001-02-24 00:00:00	2001-02-24	2001-02-24 00:00:00	2001-02-24	581452		0	0	0		0	0	0	95568	0	52	40213296		
49667	4119	40220960	2001-09-29	2001-09-29 00:00:00	2001-09-29	2001-09-29 00:00:00	2001-09-29	38000177		0	0	0		0	0	0	273830	0	1804799	40220960		
133403	2929	40213160	1974-11-23	1974-11-23 00:00:00	1974-11-23	1974-11-23 00:00:00	1974-11-23	581452		0	0	0		0	0	0	195392	0	10	40213160		
123461	2712	40213227	2006-01-10	2006-01-10 00:00:00	2006-01-10	2006-01-10 00:00:00	2006-01-10	581452		0	0	0		0	0	0	179857	0	113	40213227		
155137	3414	40213160	1967-09-07	1967-09-07 00:00:00	1967-09-07	1967-09-07 00:00:00	1967-09-07	581452		0	0	0		0	0	0	226428	0	10	40213160		
113531	2495	40213251	1985-05-14	1985-05-14 00:00:00	1985-05-14	1985-05-14 00:00:00	1985-05-14	581452		0	0	0		0	0	0	165171	0	21	40213251		
37845	3128	1127433	1985-08-11	1985-08-11 00:00:00	1985-11-09	1985-11-09 00:00:00	1985-11-09	38000177		0	0	90		0	0	0	208166	0	313782	1127433		
59372	4935	1713671	1989-09-26	1989-09-26 00:00:00	1989-10-10	1989-10-10 00:00:00	1989-10-10	38000177		0	0	14		0	0	0	328077	0	562251	1713671		
18195	1508	1713671	1980-07-04	1980-07-04 00:00:00	1980-07-18	1980-07-18 00:00:00	1980-07-18	38000177		0	0	14		0	0	0	100573	0	562251	1713671		
35368	2914	19059056	1960-05-07	1960-05-07 00:00:00	1960-05-28	1960-05-28 00:00:00	1960-05-28	38000177		0	0	21		0	0	0	194194	0	243670	19059056		
65478	1432	40213296	2005-04-12	2005-04-12 00:00:00	2005-04-12	2005-04-12 00:00:00	2005-04-12	581452		0	0	0		0	0	0	95379	0	52	40213296		
13556	1136	1127433	1974-08-28	1974-08-28 00:00:00	1974-09-11	1974-09-11 00:00:00	1974-09-11	38000177		0	0	14		0	0	0	74825	0	313782	1127433		
23143	1908	1127078	1980-01-03	1980-01-03 00:00:00	1980-01-17	1980-01-17 00:00:00	1980-01-17	38000177		0	0	14		0	0	0	126974	0	282464	1127078		
62158	5172	1713671	2008-01-05	2008-01-05 00:00:00	2008-01-26	2008-01-26 00:00:00	2008-01-26	38000177		0	0	21		0	0	0	343828	0	562251	1713671		
224800	4935	40213160	1965-06-03	1965-06-03 00:00:00	1965-06-03	1965-06-03 00:00:00	1965-06-03	581452		0	0	0		0	0	0	328100	0	10	40213160		
209163	4587	40213227	1996-06-15	1996-06-15 00:00:00	1996-06-15	1996-06-15 00:00:00	1996-06-15	581452		0	0	0		0	0	0	305540	0	113	40213227		
80101	1752	40213296	2017-12-31	2017-12-31 00:00:00	2017-12-31	2017-12-31 00:00:00	2017-12-31	581452		0	0	0		0	0	0	117160	0	52	40213296		
56633	4700	19059056	1953-01-11	1953-01-11 00:00:00	1953-01-25	1953-01-25 00:00:00	1953-01-25	38000177		0	0	14		0	0	0	313035	0	243670	19059056		
171033	3759	40213260	2016-07-31	2016-07-31 00:00:00	2016-07-31	2016-07-31 00:00:00	2016-07-31	581452		0	0	0		0	0	0	249878	0	121	40213260		
55548	4613	19127922	2003-01-27	2003-01-27 00:00:00	2004-01-22	2004-01-22 00:00:00	2004-01-22	38000177		0	0	360		0	0	0	307321	0	748962	19127922		
35352	2913	1124300	1979-06-05	1979-06-05 00:00:00	1979-06-05	1979-06-05 00:00:00	\N	38000177		0	0	0		0	0	0	194140	0	00781178901	45011828		
27950	2314	19006318	1952-10-29	1952-10-29 00:00:00	1952-11-12	1952-11-12 00:00:00	1952-11-12	38000177		0	0	14		0	0	0	153857	0	105078	19006318		
216392	4749	40213306	1994-12-24	1994-12-24 00:00:00	1994-12-24	1994-12-24 00:00:00	1994-12-24	581452		0	0	0		0	0	0	316235	0	43	40213306		
35702	2942	19059056	1968-04-09	1968-04-09 00:00:00	1968-06-08	1968-06-08 00:00:00	1968-06-08	38000177		0	0	60		0	0	0	196057	0	243670	19059056		
211717	4642	40213160	1955-11-01	1955-11-01 00:00:00	1955-11-01	1955-11-01 00:00:00	1955-11-01	581452		0	0	0		0	0	0	309409	0	10	40213160		
38008	829	40213160	1973-11-25	1973-11-25 00:00:00	1973-11-25	1973-11-25 00:00:00	1973-11-25	581452		0	0	0		0	0	0	54940	0	10	40213160		
56064	4655	1127433	2011-11-27	2011-11-27 00:00:00	2011-12-04	2011-12-04 00:00:00	2011-12-04	38000177		0	0	7		0	0	0	310345	0	313782	1127433		
10320	864	1713671	1925-04-08	1925-04-08 00:00:00	1925-04-29	1925-04-29 00:00:00	1925-04-29	38000177		0	0	21		0	0	0	57259	0	562251	1713671		
10391	867	1127433	2002-06-10	2002-06-10 00:00:00	2002-09-08	2002-09-08 00:00:00	2002-09-08	38000177		0	0	90		0	0	0	57583	0	313782	1127433		
62147	1358	40213296	1997-03-27	1997-03-27 00:00:00	1997-03-27	1997-03-27 00:00:00	1997-03-27	581452		0	0	0		0	0	0	90061	0	52	40213296		
17012	1409	19059056	1922-02-02	1922-02-02 00:00:00	1922-03-09	1922-03-09 00:00:00	1922-03-09	38000177		0	0	35		0	0	0	93830	0	243670	19059056		
21302	462	40213160	1977-05-26	1977-05-26 00:00:00	1977-05-26	1977-05-26 00:00:00	1977-05-26	581452		0	0	0		0	0	0	30894	0	10	40213160		
17076	1412	19059056	1970-06-25	1970-06-25 00:00:00	1970-07-09	1970-07-09 00:00:00	1970-07-09	38000177		0	0	14		0	0	0	94034	0	243670	19059056		
212573	4661	40213314	1977-01-20	1977-01-20 00:00:00	1977-01-20	1977-01-20 00:00:00	1977-01-20	581452		0	0	0		0	0	0	310695	0	49	40213314		
27625	2287	19059056	1944-11-26	1944-11-26 00:00:00	1944-12-17	1944-12-17 00:00:00	1944-12-17	38000177		0	0	21		0	0	0	152095	0	243670	19059056		
83257	1820	40213251	1984-01-17	1984-01-17 00:00:00	1984-01-17	1984-01-17 00:00:00	1984-01-17	581452		0	0	0		0	0	0	\N	0	21	40213251		
54872	4559	19006318	1956-12-04	1956-12-04 00:00:00	1956-12-18	1956-12-18 00:00:00	1956-12-18	38000177		0	0	14		0	0	0	303780	0	105078	19006318		
47057	3899	40229134	2010-10-21	2010-10-21 00:00:00	2010-10-28	2010-10-28 00:00:00	2010-10-28	38000177		0	0	7		0	0	0	259290	0	1043400	40229134		
44947	978	40213160	1976-04-23	1976-04-23 00:00:00	1976-04-23	1976-04-23 00:00:00	1976-04-23	581452		0	0	0		0	0	0	65147	0	10	40213160		
54728	4546	1127433	2004-06-15	2004-06-15 00:00:00	2004-06-22	2004-06-22 00:00:00	2004-06-22	38000177		0	0	7		0	0	0	302817	0	313782	1127433		
42309	3509	19059056	1942-12-12	1942-12-12 00:00:00	1942-12-26	1942-12-26 00:00:00	1942-12-26	38000177		0	0	14		0	0	0	232708	0	243670	19059056		
37332	3084	1127433	2017-04-18	2017-04-18 00:00:00	2017-05-18	2017-05-18 00:00:00	2017-05-18	38000177		0	0	30		0	0	0	205357	0	313782	1127433		
172811	3799	40213160	1972-05-02	1972-05-02 00:00:00	1972-05-02	1972-05-02 00:00:00	1972-05-02	581452		0	0	0		0	0	0	252592	0	10	40213160		
50649	4208	1127433	1941-11-08	1941-11-08 00:00:00	1941-11-22	1941-11-22 00:00:00	1941-11-22	38000177		0	0	14		0	0	0	279441	0	313782	1127433		
63426	5268	1118084	2004-01-04	2004-01-04 00:00:00	2004-01-04	2004-01-04 00:00:00	\N	38000177		0	0	0		0	0	0	350497	0	00025152531	44923712		
43693	3621	40229134	1993-11-01	1993-11-01 00:00:00	1993-11-15	1993-11-15 00:00:00	1993-11-15	38000177		0	0	14		0	0	0	240583	0	1043400	40229134		
234785	5157	40213227	2014-04-17	2014-04-17 00:00:00	2014-04-17	2014-04-17 00:00:00	2014-04-17	581452		0	0	0		0	0	0	342900	0	113	40213227		
40440	3353	19059056	1948-05-16	1948-05-16 00:00:00	1948-06-15	1948-06-15 00:00:00	1948-06-15	38000177		0	0	30		0	0	0	222426	0	243670	19059056		
51633	4289	1127433	2003-12-24	2003-12-24 00:00:00	2003-12-31	2003-12-31 00:00:00	2003-12-31	38000177		0	0	7		0	0	0	284787	0	313782	1127433		
16640	1379	19059056	1970-07-25	1970-07-25 00:00:00	1970-08-24	1970-08-24 00:00:00	1970-08-24	38000177		0	0	30		0	0	0	91512	0	243670	19059056		
34421	2844	40229134	1953-02-07	1953-02-07 00:00:00	1953-02-21	1953-02-21 00:00:00	1953-02-21	38000177		0	0	14		0	0	0	188810	0	1043400	40229134		
34463	2847	1127433	1985-06-12	1985-06-12 00:00:00	1985-06-26	1985-06-26 00:00:00	1985-06-26	38000177		0	0	14		0	0	0	189111	0	313782	1127433		
77656	1699	40213227	2017-04-09	2017-04-09 00:00:00	2017-04-09	2017-04-09 00:00:00	2017-04-09	581452		0	0	0		0	0	0	113668	0	113	40213227		
17597	1454	1118084	2009-11-14	2009-11-14 00:00:00	2009-11-14	2009-11-14 00:00:00	\N	38000177		0	0	0		0	0	0	97028	0	00025152531	44923712		
62401	5194	1127433	2000-05-08	2000-05-08 00:00:00	2000-05-15	2000-05-15 00:00:00	2000-05-15	38000177		0	0	7		0	0	0	345400	0	313782	1127433		
25610	2105	19078461	1994-07-04	1994-07-04 00:00:00	1994-07-18	1994-07-18 00:00:00	1994-07-18	38000177		0	0	14		0	0	0	140214	0	310965	19078461		
48288	4005	1127433	2006-11-23	2006-11-23 00:00:00	2006-12-07	2006-12-07 00:00:00	2006-12-07	38000177		0	0	14		0	0	0	266086	0	313782	1127433		
58775	4883	1127433	1983-03-24	1983-03-24 00:00:00	1983-04-14	1983-04-14 00:00:00	1983-04-14	38000177		0	0	21		0	0	0	324682	0	313782	1127433		
35131	2898	19019979	1982-04-19	1982-04-19 00:00:00	1982-05-03	1982-05-03 00:00:00	1982-05-03	38000177		0	0	14		0	0	0	193100	0	198405	19019979		
659	49	19059056	1976-11-13	1976-11-13 00:00:00	1976-11-27	1976-11-27 00:00:00	1976-11-27	38000177		0	0	14		0	0	0	3577	0	243670	19059056		
238376	5232	40213227	2009-11-28	2009-11-28 00:00:00	2009-11-28	2009-11-28 00:00:00	2009-11-28	581452		0	0	0		0	0	0	348095	0	113	40213227		
48567	4022	920300	1977-08-13	1977-08-13 00:00:00	1977-08-20	1977-08-20 00:00:00	1977-08-20	38000177		0	0	7		0	0	0	267397	0	311989	920300		
185701	4081	40213160	1960-06-20	1960-06-20 00:00:00	1960-06-20	1960-06-20 00:00:00	1960-06-20	581452		0	0	0		0	0	0	271273	0	10	40213160		
40734	3378	1127078	1961-03-01	1961-03-01 00:00:00	1961-03-15	1961-03-15 00:00:00	1961-03-15	38000177		0	0	14		0	0	0	224129	0	282464	1127078		
65562	1435	40213227	2003-03-01	2003-03-01 00:00:00	2003-03-01	2003-03-01 00:00:00	2003-03-01	581452		0	0	0		0	0	0	95544	0	113	40213227		
49668	4119	1127433	2001-10-22	2001-10-22 00:00:00	2001-10-29	2001-10-29 00:00:00	2001-10-29	38000177		0	0	7		0	0	0	273847	0	313782	1127433		
133410	2929	40213314	1977-01-22	1977-01-22 00:00:00	1977-01-22	1977-01-22 00:00:00	1977-01-22	581452		0	0	0		0	0	0	195414	0	49	40213314		
123463	2712	40213160	1964-09-08	1964-09-08 00:00:00	1964-09-08	1964-09-08 00:00:00	1964-09-08	581452		0	0	0		0	0	0	179824	0	10	40213160		
155142	3414	40213227	2000-08-17	2000-08-17 00:00:00	2000-08-17	2000-08-17 00:00:00	2000-08-17	581452		0	0	0		0	0	0	226492	0	113	40213227		
113533	2495	40213160	1985-05-14	1985-05-14 00:00:00	1985-05-14	1985-05-14 00:00:00	1985-05-14	581452		0	0	0		0	0	0	165171	0	10	40213160		
37846	3128	40231925	1985-08-11	1985-08-11 00:00:00	1985-08-11	1985-08-11 00:00:00	\N	38000177		0	0	0		0	0	0	208166	0	1049221	40231925		
59373	4935	40231925	1999-02-14	1999-02-14 00:00:00	1999-02-14	1999-02-14 00:00:00	\N	38000177		0	0	0		0	0	0	328052	0	1049221	40231925		
18196	1508	1713671	2004-04-26	2004-04-26 00:00:00	2004-09-06	2004-09-06 00:00:00	2004-09-06	38000177		0	0	133		0	0	0	100620	0	562251	1713671		
35369	2914	1127078	1958-06-17	1958-06-17 00:00:00	1958-07-01	1958-07-01 00:00:00	1958-07-01	38000177		0	0	14		0	0	0	194215	0	282464	1127078		
65482	1432	40213306	1983-03-15	1983-03-15 00:00:00	1983-03-15	1983-03-15 00:00:00	1983-03-15	581452		0	0	0		0	0	0	95402	0	43	40213306		
13557	1136	1127433	2014-07-08	2014-07-08 00:00:00	2014-07-22	2014-07-22 00:00:00	2014-07-22	38000177		0	0	14		0	0	0	74871	0	313782	1127433		
23144	1908	1118084	2002-12-16	2002-12-16 00:00:00	2002-12-16	2002-12-16 00:00:00	\N	38000177		0	0	0		0	0	0	127003	0	00025152531	44923712		
62159	5172	1127078	1956-08-24	1956-08-24 00:00:00	1956-09-21	1956-09-21 00:00:00	1956-09-21	38000177		0	0	28		0	0	0	343918	0	282464	1127078		
224804	4935	40213160	1969-09-04	1969-09-04 00:00:00	1969-09-04	1969-09-04 00:00:00	1969-09-04	581452		0	0	0		0	0	0	328046	0	10	40213160		
224560	4929	40213296	2002-10-05	2002-10-05 00:00:00	2002-10-05	2002-10-05 00:00:00	2002-10-05	581452		0	0	0		0	0	0	327725	0	52	40213296		
80103	1752	40213314	1979-03-04	1979-03-04 00:00:00	1979-03-04	1979-03-04 00:00:00	1979-03-04	581452		0	0	0		0	0	0	117126	0	49	40213314		
56635	4700	19059056	1952-03-17	1952-03-17 00:00:00	1952-04-07	1952-04-07 00:00:00	1952-04-07	38000177		0	0	21		0	0	0	313115	0	243670	19059056		
171040	3759	40213227	1996-03-10	1996-03-10 00:00:00	1996-03-10	1996-03-10 00:00:00	1996-03-10	581452		0	0	0		0	0	0	249873	0	113	40213227		
55549	4613	1118084	2003-06-27	2003-06-27 00:00:00	2003-06-27	2003-06-27 00:00:00	\N	38000177		0	0	0		0	0	0	307321	0	00025152531	44923712		
35353	2913	1713671	2007-09-20	2007-09-20 00:00:00	2007-09-27	2007-09-27 00:00:00	2007-09-27	38000177		0	0	7		0	0	0	194141	0	562251	1713671		
27951	2314	1127078	1962-12-13	1962-12-13 00:00:00	1962-12-27	1962-12-27 00:00:00	1962-12-27	38000177		0	0	14		0	0	0	153864	0	282464	1127078		
216393	4749	40213160	1973-03-31	1973-03-31 00:00:00	1973-03-31	1973-03-31 00:00:00	1973-03-31	581452		0	0	0		0	0	0	316229	0	10	40213160		
35703	2942	1127433	1983-05-24	1983-05-24 00:00:00	1983-05-31	1983-05-31 00:00:00	1983-05-31	38000177		0	0	7		0	0	0	196132	0	313782	1127433		
211719	4642	40213227	2014-01-28	2014-01-28 00:00:00	2014-01-28	2014-01-28 00:00:00	2014-01-28	581452		0	0	0		0	0	0	309438	0	113	40213227		
38013	829	40213160	1974-02-24	1974-02-24 00:00:00	1974-02-24	1974-02-24 00:00:00	1974-02-24	581452		0	0	0		0	0	0	54898	0	10	40213160		
56065	4655	19078461	2006-10-03	2006-10-03 00:00:00	2006-10-17	2006-10-17 00:00:00	2006-10-17	38000177		0	0	14		0	0	0	310349	0	310965	19078461		
10321	864	1115171	2001-07-11	2001-07-11 00:00:00	2001-09-09	2001-09-09 00:00:00	2001-09-09	38000177		0	0	60		0	0	0	57326	0	849574	1115171		
10402	869	19059056	1979-03-09	1979-03-09 00:00:00	1979-03-23	1979-03-23 00:00:00	1979-03-23	38000177		0	0	14		0	0	0	57781	0	243670	19059056		
62150	1358	40213260	2006-04-27	2006-04-27 00:00:00	2006-04-27	2006-04-27 00:00:00	2006-04-27	581452		0	0	0		0	0	0	90088	0	121	40213260		
17013	1409	1127433	1931-10-14	1931-10-14 00:00:00	1931-10-28	1931-10-28 00:00:00	1931-10-28	38000177		0	0	14		0	0	0	93817	0	313782	1127433		
21305	462	40213160	1976-12-23	1976-12-23 00:00:00	1976-12-23	1976-12-23 00:00:00	1976-12-23	581452		0	0	0		0	0	0	30893	0	10	40213160		
17078	1412	19129655	1964-09-24	1964-09-24 00:00:00	1964-10-08	1964-10-08 00:00:00	1964-10-08	38000177		0	0	14		0	0	0	93991	0	789980	19129655		
212574	4661	40213160	1977-01-20	1977-01-20 00:00:00	1977-01-20	1977-01-20 00:00:00	1977-01-20	581452		0	0	0		0	0	0	310695	0	10	40213160		
27626	2287	19077572	2013-07-12	2013-07-12 00:00:00	2013-07-12	2013-07-12 00:00:00	\N	38000177		0	0	0		0	0	0	152192	0	310436	19077572		
83262	1820	40213296	2018-02-13	2018-02-13 00:00:00	2018-02-13	2018-02-13 00:00:00	2018-02-13	581452		0	0	0		0	0	0	121741	0	52	40213296		
54873	4559	1713671	1976-08-18	1976-08-18 00:00:00	1976-08-25	1976-08-25 00:00:00	1976-08-25	38000177		0	0	7		0	0	0	303792	0	562251	1713671		
47058	3899	40229134	2016-06-06	2016-06-06 00:00:00	2016-06-13	2016-06-13 00:00:00	2016-06-13	38000177		0	0	7		0	0	0	259279	0	1043400	40229134		
44949	978	40213227	2017-08-25	2017-08-25 00:00:00	2017-08-25	2017-08-25 00:00:00	2017-08-25	581452		0	0	0		0	0	0	65120	0	113	40213227		
54729	4547	1127433	1990-11-22	1990-11-22 00:00:00	1990-12-13	1990-12-13 00:00:00	1990-12-13	38000177		0	0	21		0	0	0	302961	0	313782	1127433		
42310	3509	1115171	2015-12-30	2015-12-30 00:00:00	2016-03-29	2016-03-29 00:00:00	2016-03-29	38000177		0	0	90		0	0	0	232795	0	849574	1115171		
37333	3084	1124300	2017-05-02	2017-05-02 00:00:00	2017-05-02	2017-05-02 00:00:00	\N	38000177		0	0	0		0	0	0	205357	0	00781178901	45011828		
172822	3799	40213160	1976-07-27	1976-07-27 00:00:00	1976-07-27	1976-07-27 00:00:00	1976-07-27	581452		0	0	0		0	0	0	252569	0	10	40213160		
50650	4208	1713671	1999-11-28	1999-11-28 00:00:00	1999-12-12	1999-12-12 00:00:00	1999-12-12	38000177		0	0	14		0	0	0	279352	0	562251	1713671		
63428	5268	1127433	2004-08-31	2004-08-31 00:00:00	2004-09-14	2004-09-14 00:00:00	2004-09-14	38000177		0	0	14		0	0	0	350534	0	313782	1127433		
43694	3622	19133873	1925-09-08	1925-09-08 00:00:00	1925-09-20	1925-09-20 00:00:00	1925-09-20	38000177		0	0	12		0	0	0	240774	0	834061	19133873		
234786	5157	40213160	1968-03-21	1968-03-21 00:00:00	1968-03-21	1968-03-21 00:00:00	1968-03-21	581452		0	0	0		0	0	0	342922	0	10	40213160		
40441	3353	1127433	1983-01-18	1983-01-18 00:00:00	1983-02-22	1983-02-22 00:00:00	1983-02-22	38000177		0	0	35		0	0	0	222449	0	313782	1127433		
51634	4289	19059056	1965-03-25	1965-03-25 00:00:00	1965-04-08	1965-04-08 00:00:00	1965-04-08	38000177		0	0	14		0	0	0	284741	0	243670	19059056		
16641	1379	1310034	1987-09-05	1987-09-05 00:00:00	1987-09-05	1987-09-05 00:00:00	1987-09-05	38000177		0	0	0		0	0	0	91516	0	834357	1310034		
34422	2844	1127433	1967-05-24	1967-05-24 00:00:00	1967-05-31	1967-05-31 00:00:00	1967-05-31	38000177		0	0	7		0	0	0	188803	0	313782	1127433		
34465	2847	1127433	1983-10-17	1983-10-17 00:00:00	1983-11-21	1983-11-21 00:00:00	1983-11-21	38000177		0	0	35		0	0	0	189119	0	313782	1127433		
77657	1699	40213260	2017-04-09	2017-04-09 00:00:00	2017-04-09	2017-04-09 00:00:00	2017-04-09	581452		0	0	0		0	0	0	113668	0	121	40213260		
17624	1459	1115171	2006-10-26	2006-10-26 00:00:00	2006-11-16	2006-11-16 00:00:00	2006-11-16	38000177		0	0	21		0	0	0	97249	0	849574	1115171		
62402	5194	19133873	1953-08-03	1953-08-03 00:00:00	1953-08-11	1953-08-11 00:00:00	1953-08-11	38000177		0	0	8		0	0	0	345287	0	834061	19133873		
25611	2105	1127078	1981-02-12	1981-02-12 00:00:00	1981-04-13	1981-04-13 00:00:00	1981-04-13	38000177		0	0	60		0	0	0	140212	0	282464	1127078		
48289	4005	1127433	1971-02-12	1971-02-12 00:00:00	1971-02-19	1971-02-19 00:00:00	1971-02-19	38000177		0	0	7		0	0	0	266124	0	313782	1127433		
58776	4883	19059056	1973-04-24	1973-04-24 00:00:00	1973-06-23	1973-06-23 00:00:00	1973-06-23	38000177		0	0	60		0	0	0	324680	0	243670	19059056		
35132	2898	19073183	1982-04-19	1982-04-19 00:00:00	1982-05-03	1982-05-03 00:00:00	1982-05-03	38000177		0	0	14		0	0	0	193100	0	308182	19073183		
660	49	46233988	1976-11-13	1976-11-13 00:00:00	1976-11-27	1976-11-27 00:00:00	1976-11-27	38000177		0	0	14		0	0	0	3577	0	1652673	46233988		
238377	5232	40213296	2009-11-28	2009-11-28 00:00:00	2009-11-28	2009-11-28 00:00:00	2009-11-28	581452		0	0	0		0	0	0	348095	0	52	40213296		
48568	4022	40236824	1977-08-13	1977-08-13 00:00:00	1977-08-20	1977-08-20 00:00:00	1977-08-20	38000177		0	0	7		0	0	0	267397	0	1094107	40236824		
185706	4081	40213260	2006-07-17	2006-07-17 00:00:00	2006-07-17	2006-07-17 00:00:00	2006-07-17	581452		0	0	0		0	0	0	271241	0	121	40213260		
40735	3378	19007333	1996-07-10	1996-07-10 00:00:00	2000-08-18	2000-08-18 00:00:00	2000-08-18	38000177		0	0	1500		0	0	0	224148	0	105586	19007333		
65563	1435	40213296	2003-03-01	2003-03-01 00:00:00	2003-03-01	2003-03-01 00:00:00	2003-03-01	581452		0	0	0		0	0	0	95544	0	52	40213296		
49669	4119	40236824	1967-08-11	1967-08-11 00:00:00	1967-08-18	1967-08-18 00:00:00	1967-08-18	38000177		0	0	7		0	0	0	273844	0	1094107	40236824		
133413	2929	40213314	1978-01-21	1978-01-21 00:00:00	1978-01-21	1978-01-21 00:00:00	1978-01-21	581452		0	0	0		0	0	0	195399	0	49	40213314		
49621	4116	19019979	1979-07-05	1979-07-05 00:00:00	1979-07-19	1979-07-19 00:00:00	1979-07-19	38000177		0	0	14		0	0	0	273637	0	198405	19019979		
155147	3414	40213306	1990-03-29	1990-03-29 00:00:00	1990-03-29	1990-03-29 00:00:00	1990-03-29	581452		0	0	0		0	0	0	226463	0	43	40213306		
113540	2495	40213251	1984-03-06	1984-03-06 00:00:00	1984-03-06	1984-03-06 00:00:00	1984-03-06	581452		0	0	0		0	0	0	165170	0	21	40213251		
37847	3128	40232448	1978-08-13	1978-08-13 00:00:00	1978-08-13	1978-08-13 00:00:00	\N	38000177		0	0	0		0	0	0	208197	0	1049630	40232448		
59374	4935	1127433	1970-10-24	1970-10-24 00:00:00	1970-11-07	1970-11-07 00:00:00	1970-11-07	38000177		0	0	14		0	0	0	328034	0	313782	1127433		
18197	1508	19133873	1933-09-11	1933-09-11 00:00:00	1933-09-23	1933-09-23 00:00:00	1933-09-23	38000177		0	0	12		0	0	0	100580	0	834061	19133873		
35370	2914	19006318	1958-06-17	1958-06-17 00:00:00	1958-07-01	1958-07-01 00:00:00	1958-07-01	38000177		0	0	14		0	0	0	194215	0	105078	19006318		
65486	1432	40213160	1962-02-06	1962-02-06 00:00:00	1962-02-06	1962-02-06 00:00:00	1962-02-06	581452		0	0	0		0	0	0	95420	0	10	40213160		
13558	1136	1127433	1995-05-26	1995-05-26 00:00:00	1995-06-09	1995-06-09 00:00:00	1995-06-09	38000177		0	0	14		0	0	0	74860	0	313782	1127433		
23145	1908	19129655	1971-01-03	1971-01-03 00:00:00	1971-01-17	1971-01-17 00:00:00	1971-01-17	38000177		0	0	14		0	0	0	126973	0	789980	19129655		
62160	5172	1713671	2004-05-04	2004-05-04 00:00:00	2004-05-25	2004-05-25 00:00:00	2004-05-25	38000177		0	0	21		0	0	0	343855	0	562251	1713671		
224812	4935	40213227	1996-02-01	1996-02-01 00:00:00	1996-02-01	1996-02-01 00:00:00	1996-02-01	581452		0	0	0		0	0	0	328148	0	113	40213227		
224563	4929	40213260	2011-12-17	2011-12-17 00:00:00	2011-12-17	2011-12-17 00:00:00	2011-12-17	581452		0	0	0		0	0	0	327686	0	121	40213260		
80113	1752	40213251	1984-12-16	1984-12-16 00:00:00	1984-12-16	1984-12-16 00:00:00	1984-12-16	581452		0	0	0		0	0	0	117130	0	21	40213251		
56636	4700	1118084	1990-10-24	1990-10-24 00:00:00	1990-10-24	1990-10-24 00:00:00	\N	38000177		0	0	0		0	0	0	313089	0	00025152531	44923712		
95737	2098	40213306	1985-01-16	1985-01-16 00:00:00	1985-01-16	1985-01-16 00:00:00	1985-01-16	581452		0	0	0		0	0	0	139888	0	43	40213306		
55550	4613	19129144	2008-12-26	2008-12-26 00:00:00	2009-12-21	2009-12-21 00:00:00	2009-12-21	38000177		0	0	360		0	0	0	307281	0	757594	19129144		
35354	2914	40229134	1962-09-26	1962-09-26 00:00:00	1962-10-10	1962-10-10 00:00:00	1962-10-10	38000177		0	0	14		0	0	0	194191	0	1043400	40229134		
27952	2314	1127433	1989-12-01	1989-12-01 00:00:00	1989-12-15	1989-12-15 00:00:00	1989-12-15	38000177		0	0	14		0	0	0	153894	0	313782	1127433		
216403	4749	40213314	1977-10-01	1977-10-01 00:00:00	1977-10-01	1977-10-01 00:00:00	1977-10-01	581452		0	0	0		0	0	0	316257	0	49	40213314		
35704	2942	1124300	1998-10-01	1998-10-01 00:00:00	1998-10-01	1998-10-01 00:00:00	\N	38000177		0	0	0		0	0	0	196205	0	00781178901	45011828		
211726	4642	40213227	1994-12-06	1994-12-06 00:00:00	1994-12-06	1994-12-06 00:00:00	1994-12-06	581452		0	0	0		0	0	0	309376	0	113	40213227		
38015	829	40213160	1973-09-23	1973-09-23 00:00:00	1973-09-23	1973-09-23 00:00:00	1973-09-23	581452		0	0	0		0	0	0	54883	0	10	40213160		
56066	4655	19073188	2006-10-03	2006-10-03 00:00:00	2006-10-17	2006-10-17 00:00:00	2006-10-17	38000177		0	0	14		0	0	0	310349	0	308192	19073188		
10322	864	1127433	1925-11-10	1925-11-10 00:00:00	1925-11-17	1925-11-17 00:00:00	1925-11-17	38000177		0	0	7		0	0	0	57293	0	313782	1127433		
10403	869	19073188	1979-03-09	1979-03-09 00:00:00	1979-03-23	1979-03-23 00:00:00	1979-03-23	38000177		0	0	14		0	0	0	57781	0	308192	19073188		
62153	1358	40213160	1958-07-03	1958-07-03 00:00:00	1958-07-03	1958-07-03 00:00:00	1958-07-03	581452		0	0	0		0	0	0	90076	0	10	40213160		
17014	1409	1127433	2006-03-13	2006-03-13 00:00:00	2006-03-27	2006-03-27 00:00:00	2006-03-27	38000177		0	0	14		0	0	0	93775	0	313782	1127433		
20959	1727	35605482	1982-03-24	1982-03-24 00:00:00	1982-03-24	1982-03-24 00:00:00	1982-03-24	38000177		0	0	0		0	0	0	115482	0	1740467	35605482		
17079	1412	1127078	1964-09-24	1964-09-24 00:00:00	1964-10-08	1964-10-08 00:00:00	1964-10-08	38000177		0	0	14		0	0	0	93991	0	282464	1127078		
212575	4661	40213314	1977-03-24	1977-03-24 00:00:00	1977-03-24	1977-03-24 00:00:00	1977-03-24	581452		0	0	0		0	0	0	310690	0	49	40213314		
27627	2287	40163554	2004-05-21	2004-05-21 00:00:00	2004-05-21	2004-05-21 00:00:00	\N	38000177		0	0	0		0	0	0	152146	0	855332	40163554		
83264	1820	40213314	1979-04-17	1979-04-17 00:00:00	1979-04-17	1979-04-17 00:00:00	1979-04-17	581452		0	0	0		0	0	0	121753	0	49	40213314		
54874	4559	40229134	1990-03-09	1990-03-09 00:00:00	1990-03-23	1990-03-23 00:00:00	1990-03-23	38000177		0	0	14		0	0	0	303754	0	1043400	40229134		
47059	3900	19059056	1977-07-11	1977-07-11 00:00:00	1977-08-01	1977-08-01 00:00:00	1977-08-01	38000177		0	0	21		0	0	0	259340	0	243670	19059056		
44950	978	40213296	2017-08-25	2017-08-25 00:00:00	2017-08-25	2017-08-25 00:00:00	2017-08-25	581452		0	0	0		0	0	0	65120	0	52	40213296		
54730	4547	1713671	1938-07-16	1938-07-16 00:00:00	1938-07-30	1938-07-30 00:00:00	1938-07-30	38000177		0	0	14		0	0	0	302858	0	562251	1713671		
42311	3509	19133905	1976-09-21	1976-09-21 00:00:00	1976-10-04	1976-10-04 00:00:00	1976-10-04	38000177		0	0	13		0	0	0	232738	0	834102	19133905		
37334	3084	1127078	1980-08-09	1980-08-09 00:00:00	1980-08-30	1980-08-30 00:00:00	1980-08-30	38000177		0	0	21		0	0	0	205354	0	282464	1127078		
172823	3799	40213306	1994-10-04	1994-10-04 00:00:00	1994-10-04	1994-10-04 00:00:00	1994-10-04	581452		0	0	0		0	0	0	252555	0	43	40213306		
50651	4208	1127433	1960-05-30	1960-05-30 00:00:00	1960-06-13	1960-06-13 00:00:00	1960-06-13	38000177		0	0	14		0	0	0	279426	0	313782	1127433		
63429	5268	19059056	1965-09-25	1965-09-25 00:00:00	1965-10-09	1965-10-09 00:00:00	1965-10-09	38000177		0	0	14		0	0	0	350529	0	243670	19059056		
43695	3622	19059056	1922-12-20	1922-12-20 00:00:00	1923-01-03	1923-01-03 00:00:00	1923-01-03	38000177		0	0	14		0	0	0	240782	0	243670	19059056		
234787	5157	40213306	1985-09-05	1985-09-05 00:00:00	1985-09-05	1985-09-05 00:00:00	1985-09-05	581452		0	0	0		0	0	0	342897	0	43	40213306		
40442	3353	40173590	1995-11-25	1995-11-25 00:00:00	1995-11-25	1995-11-25 00:00:00	\N	38000177		0	0	0		0	0	0	222384	0	904419	40173590		
51641	4291	19073188	1987-06-02	1987-06-02 00:00:00	1987-06-16	1987-06-16 00:00:00	1987-06-16	38000177		0	0	14		0	0	0	284906	0	308192	19073188		
16642	1379	40243436	1987-09-05	1987-09-05 00:00:00	1987-09-05	1987-09-05 00:00:00	1987-09-05	38000177		0	0	0		0	0	0	91516	0	1190795	40243436		
226349	4971	40213227	2006-01-03	2006-01-03 00:00:00	2006-01-03	2006-01-03 00:00:00	2006-01-03	581452		0	0	0		0	0	0	330658	0	113	40213227		
34466	2847	19133905	1989-11-12	1989-11-12 00:00:00	1989-11-19	1989-11-19 00:00:00	1989-11-19	38000177		0	0	7		0	0	0	189112	0	834102	19133905		
77660	1699	40213227	2008-04-13	2008-04-13 00:00:00	2008-04-13	2008-04-13 00:00:00	2008-04-13	581452		0	0	0		0	0	0	113634	0	113	40213227		
17625	1459	1713671	1972-03-26	1972-03-26 00:00:00	1972-04-16	1972-04-16 00:00:00	1972-04-16	38000177		0	0	21		0	0	0	97180	0	562251	1713671		
62403	5194	1127433	1946-06-17	1946-06-17 00:00:00	1946-06-24	1946-06-24 00:00:00	1946-06-24	38000177		0	0	7		0	0	0	345295	0	313782	1127433		
25612	2105	1127078	1974-10-17	1974-10-17 00:00:00	1974-10-31	1974-10-31 00:00:00	1974-10-31	38000177		0	0	14		0	0	0	140245	0	282464	1127078		
48290	4005	40229134	1973-04-10	1973-04-10 00:00:00	1973-04-17	1973-04-17 00:00:00	1973-04-17	38000177		0	0	7		0	0	0	266109	0	1043400	40229134		
58777	4883	40165015	1973-04-24	1973-04-24 00:00:00	1973-04-24	1973-04-24 00:00:00	\N	38000177		0	0	0		0	0	0	324680	0	861467	40165015		
100482	2202	40213296	2015-12-03	2015-12-03 00:00:00	2015-12-03	2015-12-03 00:00:00	2015-12-03	581452		0	0	0		0	0	0	146803	0	52	40213296		
661	49	1124300	2009-06-13	2009-06-13 00:00:00	2009-06-13	2009-06-13 00:00:00	\N	38000177		0	0	0		0	0	0	3548	0	00781178901	45011828		
238385	5233	40213160	1957-04-30	1957-04-30 00:00:00	1957-04-30	1957-04-30 00:00:00	1957-04-30	581452		0	0	0		0	0	0	348193	0	10	40213160		
30167	2501	1127078	1965-06-22	1965-06-22 00:00:00	1965-07-06	1965-07-06 00:00:00	1965-07-06	38000177		0	0	14		0	0	0	165556	0	282464	1127078		
185708	4081	40213227	2006-07-17	2006-07-17 00:00:00	2006-07-17	2006-07-17 00:00:00	2006-07-17	581452		0	0	0		0	0	0	271241	0	113	40213227		
40736	3378	19019273	1996-07-10	1996-07-10 00:00:00	2000-08-18	2000-08-18 00:00:00	2000-08-18	38000177		0	0	1500		0	0	0	224148	0	198014	19019273		
65569	1435	40213160	1961-07-29	1961-07-29 00:00:00	1961-07-29	1961-07-29 00:00:00	1961-07-29	581452		0	0	0		0	0	0	95601	0	10	40213160		
49670	4119	920300	1967-08-11	1967-08-11 00:00:00	1967-08-18	1967-08-18 00:00:00	1967-08-18	38000177		0	0	7		0	0	0	273844	0	311989	920300		
133414	2929	40213160	1975-04-26	1975-04-26 00:00:00	1975-04-26	1975-04-26 00:00:00	1975-04-26	581452		0	0	0		0	0	0	195401	0	10	40213160		
49622	4116	19073183	1979-07-05	1979-07-05 00:00:00	1979-07-19	1979-07-19 00:00:00	1979-07-19	38000177		0	0	14		0	0	0	273637	0	308182	19073183		
155151	3414	40213260	2017-03-30	2017-03-30 00:00:00	2017-03-30	2017-03-30 00:00:00	2017-03-30	581452		0	0	0		0	0	0	226473	0	121	40213260		
113542	2495	40213227	2002-12-03	2002-12-03 00:00:00	2002-12-03	2002-12-03 00:00:00	2002-12-03	581452		0	0	0		0	0	0	165179	0	113	40213227		
37848	3128	19008572	1986-09-10	1986-09-10 00:00:00	1986-09-24	1986-09-24 00:00:00	1986-09-24	38000177		0	0	14		0	0	0	208152	0	106258	19008572		
59375	4935	46233988	1969-01-01	1969-01-01 00:00:00	1969-01-15	1969-01-15 00:00:00	1969-01-15	38000177		0	0	14		0	0	0	328040	0	1652673	46233988		
18198	1508	19059056	1934-03-09	1934-03-09 00:00:00	1934-03-30	1934-03-30 00:00:00	1934-03-30	38000177		0	0	21		0	0	0	100544	0	243670	19059056		
35372	2915	1127433	1974-01-12	1974-01-12 00:00:00	1974-01-26	1974-01-26 00:00:00	1974-01-26	38000177		0	0	14		0	0	0	194303	0	313782	1127433		
65488	1432	40213260	2011-08-30	2011-08-30 00:00:00	2011-08-30	2011-08-30 00:00:00	2011-08-30	581452		0	0	0		0	0	0	95358	0	121	40213260		
13559	1136	40243436	1972-10-07	1972-10-07 00:00:00	1972-10-07	1972-10-07 00:00:00	1972-10-07	38000177		0	0	0		0	0	0	74864	0	1190795	40243436		
23146	1908	19059056	1971-01-03	1971-01-03 00:00:00	1971-01-17	1971-01-17 00:00:00	1971-01-17	38000177		0	0	14		0	0	0	126973	0	243670	19059056		
62161	5172	19133873	1957-01-13	1957-01-13 00:00:00	1957-01-22	1957-01-22 00:00:00	1957-01-22	38000177		0	0	9		0	0	0	343850	0	834061	19133873		
224814	4935	40213160	1965-03-04	1965-03-04 00:00:00	1965-03-04	1965-03-04 00:00:00	1965-03-04	581452		0	0	0		0	0	0	328069	0	10	40213160		
50420	4190	1118084	2013-08-09	2013-08-09 00:00:00	2013-08-09	2013-08-09 00:00:00	\N	38000177		0	0	0		0	0	0	278111	0	00025152531	44923712		
80116	1753	40213160	1965-01-14	1965-01-14 00:00:00	1965-01-14	1965-01-14 00:00:00	1965-01-14	581452		0	0	0		0	0	0	117308	0	10	40213160		
56637	4700	19078461	1998-06-05	1998-06-05 00:00:00	1998-06-19	1998-06-19 00:00:00	1998-06-19	38000177		0	0	14		0	0	0	313117	0	310965	19078461		
107053	2346	40213201	2012-05-09	2012-05-09 00:00:00	2012-05-09	2012-05-09 00:00:00	2012-05-09	581452		0	0	0		0	0	0	156147	0	33	40213201		
55551	4613	1127433	1980-09-10	1980-09-10 00:00:00	1980-10-01	1980-10-01 00:00:00	1980-10-01	38000177		0	0	21		0	0	0	307231	0	313782	1127433		
35355	2914	1127433	2008-06-05	2008-06-05 00:00:00	2008-06-19	2008-06-19 00:00:00	2008-06-19	38000177		0	0	14		0	0	0	194214	0	313782	1127433		
27953	2314	1118084	1987-08-17	1987-08-17 00:00:00	1987-08-17	1987-08-17 00:00:00	\N	38000177		0	0	0		0	0	0	153869	0	00025152531	44923712		
216406	4749	40213160	1977-10-01	1977-10-01 00:00:00	1977-10-01	1977-10-01 00:00:00	1977-10-01	581452		0	0	0		0	0	0	316257	0	10	40213160		
45941	3803	19128065	1977-03-25	1977-03-25 00:00:00	1978-03-20	1978-03-20 00:00:00	1978-03-20	38000177		0	0	360		0	0	0	252810	0	749882	19128065		
211731	4642	40213201	2019-02-26	2019-02-26 00:00:00	2019-02-26	2019-02-26 00:00:00	2019-02-26	581452		0	0	0		0	0	0	309359	0	33	40213201		
38019	829	40213296	2016-01-24	2016-01-24 00:00:00	2016-01-24	2016-01-24 00:00:00	2016-01-24	581452		0	0	0		0	0	0	\N	0	52	40213296		
56068	4655	19133873	1970-03-27	1970-03-27 00:00:00	1970-04-06	1970-04-06 00:00:00	1970-04-06	38000177		0	0	10		0	0	0	310380	0	834061	19133873		
10323	864	1127433	1963-09-26	1963-09-26 00:00:00	1963-10-10	1963-10-10 00:00:00	1963-10-10	38000177		0	0	14		0	0	0	57322	0	313782	1127433		
10404	869	19059056	1952-06-23	1952-06-23 00:00:00	1952-07-07	1952-07-07 00:00:00	1952-07-07	38000177		0	0	14		0	0	0	57725	0	243670	19059056		
62162	1358	40213227	2005-04-21	2005-04-21 00:00:00	2005-04-21	2005-04-21 00:00:00	2005-04-21	581452		0	0	0		0	0	0	90065	0	113	40213227		
17015	1409	1124300	1960-03-04	1960-03-04 00:00:00	1960-03-04	1960-03-04 00:00:00	\N	38000177		0	0	0		0	0	0	93712	0	00781178901	45011828		
20960	1727	35605482	1982-03-25	1982-03-25 00:00:00	1982-03-25	1982-03-25 00:00:00	1982-03-25	38000177		0	0	0		0	0	0	115482	0	1740467	35605482		
17080	1412	1118084	1997-05-24	1997-05-24 00:00:00	1997-05-24	1997-05-24 00:00:00	\N	38000177		0	0	0		0	0	0	94059	0	00025152531	44923712		
212576	4661	40213160	1977-03-24	1977-03-24 00:00:00	1977-03-24	1977-03-24 00:00:00	1977-03-24	581452		0	0	0		0	0	0	310690	0	10	40213160		
27628	2287	40171902	2004-05-21	2004-05-21 00:00:00	2004-05-21	2004-05-21 00:00:00	\N	38000177		0	0	0		0	0	0	152146	0	897718	40171902		
67466	1475	40213227	2016-04-21	2016-04-21 00:00:00	2016-04-21	2016-04-21 00:00:00	2016-04-21	581452		0	0	0		0	0	0	98247	0	113	40213227		
54875	4559	40229134	1981-11-25	1981-11-25 00:00:00	1981-12-09	1981-12-09 00:00:00	1981-12-09	38000177		0	0	14		0	0	0	303788	0	1043400	40229134		
47060	3900	19133873	1967-08-06	1967-08-06 00:00:00	1967-08-16	1967-08-16 00:00:00	1967-08-16	38000177		0	0	10		0	0	0	259323	0	834061	19133873		
44952	978	40213160	1975-11-21	1975-11-21 00:00:00	1975-11-21	1975-11-21 00:00:00	1975-11-21	581452		0	0	0		0	0	0	65146	0	10	40213160		
54731	4547	19059056	1916-10-06	1916-10-06 00:00:00	1916-10-20	1916-10-20 00:00:00	1916-10-20	38000177		0	0	14		0	0	0	302955	0	243670	19059056		
42312	3509	19059056	1943-01-11	1943-01-11 00:00:00	1943-02-01	1943-02-01 00:00:00	1943-02-01	38000177		0	0	21		0	0	0	232694	0	243670	19059056		
37335	3084	40243436	2015-10-21	2015-10-21 00:00:00	2015-10-21	2015-10-21 00:00:00	2015-10-21	38000177		0	0	0		0	0	0	205356	0	1190795	40243436		
172825	3799	40213227	1994-10-04	1994-10-04 00:00:00	1994-10-04	1994-10-04 00:00:00	1994-10-04	581452		0	0	0		0	0	0	252555	0	113	40213227		
50662	4210	19019979	1984-12-18	1984-12-18 00:00:00	1985-03-18	1985-03-18 00:00:00	1985-03-18	38000177		0	0	90		0	0	0	279577	0	198405	19019979		
63430	5268	19006318	1965-09-25	1965-09-25 00:00:00	1965-10-09	1965-10-09 00:00:00	1965-10-09	38000177		0	0	14		0	0	0	350529	0	105078	19006318		
43696	3622	19059056	1927-09-07	1927-09-07 00:00:00	1927-09-21	1927-09-21 00:00:00	1927-09-21	38000177		0	0	14		0	0	0	240783	0	243670	19059056		
234791	5157	40213227	2005-04-21	2005-04-21 00:00:00	2005-04-21	2005-04-21 00:00:00	2005-04-21	581452		0	0	0		0	0	0	342892	0	113	40213227		
40443	3353	19059056	1927-11-12	1927-11-12 00:00:00	1927-11-26	1927-11-26 00:00:00	1927-11-26	38000177		0	0	14		0	0	0	222421	0	243670	19059056		
51642	4291	19078461	1987-06-02	1987-06-02 00:00:00	1987-06-16	1987-06-16 00:00:00	1987-06-16	38000177		0	0	14		0	0	0	284906	0	310965	19078461		
38668	843	40213227	2013-07-13	2013-07-13 00:00:00	2013-07-13	2013-07-13 00:00:00	2013-07-13	581452		0	0	0		0	0	0	55865	0	113	40213227		
226353	4971	40213227	1995-11-07	1995-11-07 00:00:00	1995-11-07	1995-11-07 00:00:00	1995-11-07	581452		0	0	0		0	0	0	330503	0	113	40213227		
34468	2847	1127078	1973-06-13	1973-06-13 00:00:00	1973-07-11	1973-07-11 00:00:00	1973-07-11	38000177		0	0	28		0	0	0	189118	0	282464	1127078		
77661	1699	40213296	2008-04-13	2008-04-13 00:00:00	2008-04-13	2008-04-13 00:00:00	2008-04-13	581452		0	0	0		0	0	0	113634	0	52	40213296		
17626	1459	19059056	1943-02-08	1943-02-08 00:00:00	1943-02-22	1943-02-22 00:00:00	1943-02-22	38000177		0	0	14		0	0	0	97264	0	243670	19059056		
62404	5194	1127433	1958-05-30	1958-05-30 00:00:00	1958-06-06	1958-06-06 00:00:00	1958-06-06	38000177		0	0	7		0	0	0	345288	0	313782	1127433		
25613	2105	19133873	1980-07-31	1980-07-31 00:00:00	1980-08-13	1980-08-13 00:00:00	1980-08-13	38000177		0	0	13		0	0	0	140216	0	834061	19133873		
48291	4005	1127078	1981-05-03	1981-05-03 00:00:00	1981-06-02	1981-06-02 00:00:00	1981-06-02	38000177		0	0	30		0	0	0	266082	0	282464	1127078		
58778	4883	19059056	1951-07-14	1951-07-14 00:00:00	1951-08-18	1951-08-18 00:00:00	1951-08-18	38000177		0	0	35		0	0	0	324679	0	243670	19059056		
100484	2202	40213160	1974-01-17	1974-01-17 00:00:00	1974-01-17	1974-01-17 00:00:00	1974-01-17	581452		0	0	0		0	0	0	146757	0	10	40213160		
662	49	40243436	2003-07-12	2003-07-12 00:00:00	2003-07-12	2003-07-12 00:00:00	2003-07-12	38000177		0	0	0		0	0	0	3529	0	1190795	40243436		
238387	5233	40213227	2018-03-27	2018-03-27 00:00:00	2018-03-27	2018-03-27 00:00:00	2018-03-27	581452		0	0	0		0	0	0	348180	0	113	40213227		
30168	2501	1127433	1981-11-14	1981-11-14 00:00:00	1981-11-21	1981-11-21 00:00:00	1981-11-21	38000177		0	0	7		0	0	0	165537	0	313782	1127433		
185720	4081	40213160	1955-12-19	1955-12-19 00:00:00	1955-12-19	1955-12-19 00:00:00	1955-12-19	581452		0	0	0		0	0	0	271251	0	10	40213160		
40737	3378	1127433	1970-05-05	1970-05-05 00:00:00	1970-05-19	1970-05-19 00:00:00	1970-05-19	38000177		0	0	14		0	0	0	224197	0	313782	1127433		
49808	1091	40213160	1961-05-18	1961-05-18 00:00:00	1961-05-18	1961-05-18 00:00:00	1961-05-18	581452		0	0	0		0	0	0	71667	0	10	40213160		
49679	4121	40169281	1968-05-12	1968-05-12 00:00:00	1968-05-12	1968-05-12 00:00:00	\N	38000177		0	0	0		0	0	0	273972	0	896209	40169281		
133420	2929	40213227	2015-10-31	2015-10-31 00:00:00	2015-10-31	2015-10-31 00:00:00	2015-10-31	581452		0	0	0		0	0	0	195410	0	113	40213227		
49623	4116	19133905	2002-11-12	2002-11-12 00:00:00	2002-11-25	2002-11-25 00:00:00	2002-11-25	38000177		0	0	13		0	0	0	273631	0	834102	19133905		
155155	3415	40213227	2007-11-24	2007-11-24 00:00:00	2007-11-24	2007-11-24 00:00:00	2007-11-24	581452		0	0	0		0	0	0	226516	0	113	40213227		
113543	2495	40213306	2002-12-03	2002-12-03 00:00:00	2002-12-03	2002-12-03 00:00:00	2002-12-03	581452		0	0	0		0	0	0	165179	0	43	40213306		
48307	4006	1115171	1997-12-09	1997-12-09 00:00:00	1998-02-07	1998-02-07 00:00:00	1998-02-07	38000177		0	0	60		0	0	0	266145	0	849574	1115171		
59376	4935	1127078	1969-01-01	1969-01-01 00:00:00	1969-01-15	1969-01-15 00:00:00	1969-01-15	38000177		0	0	14		0	0	0	328040	0	282464	1127078		
18199	1508	19059056	1949-02-23	1949-02-23 00:00:00	1949-05-24	1949-05-24 00:00:00	1949-05-24	38000177		0	0	90		0	0	0	100546	0	243670	19059056		
63244	5255	46233988	1971-10-06	1971-10-06 00:00:00	1971-10-20	1971-10-20 00:00:00	1971-10-20	38000177		0	0	14		0	0	0	349626	0	1652673	46233988		
65496	1433	40213306	1982-11-29	1982-11-29 00:00:00	1982-11-29	1982-11-29 00:00:00	1982-11-29	581452		0	0	0		0	0	0	95435	0	43	40213306		
13560	1136	1310034	1972-10-07	1972-10-07 00:00:00	1972-10-07	1972-10-07 00:00:00	1972-10-07	38000177		0	0	0		0	0	0	74864	0	834357	1310034		
23147	1908	1127433	1993-09-15	1993-09-15 00:00:00	1993-09-22	1993-09-22 00:00:00	1993-09-22	38000177		0	0	7		0	0	0	126997	0	313782	1127433		
62162	5172	1713671	1956-06-23	1956-06-23 00:00:00	1956-07-14	1956-07-14 00:00:00	1956-07-14	38000177		0	0	21		0	0	0	343895	0	562251	1713671		
224817	4935	40213296	2007-11-15	2007-11-15 00:00:00	2007-11-15	2007-11-15 00:00:00	2007-11-15	581452		0	0	0		0	0	0	328151	0	52	40213296		
50421	4190	1127433	2000-08-23	2000-08-23 00:00:00	2000-09-13	2000-09-13 00:00:00	2000-09-13	38000177		0	0	21		0	0	0	278065	0	313782	1127433		
76034	1661	40213160	1960-06-09	1960-06-09 00:00:00	1960-06-09	1960-06-09 00:00:00	1960-06-09	581452		0	0	0		0	0	0	111644	0	10	40213160		
56638	4700	1127433	1963-03-21	1963-03-21 00:00:00	1963-04-04	1963-04-04 00:00:00	1963-04-04	38000177		0	0	14		0	0	0	313023	0	313782	1127433		
60996	5073	19059056	1936-01-08	1936-01-08 00:00:00	1936-01-22	1936-01-22 00:00:00	1936-01-22	38000177		0	0	14		0	0	0	337188	0	243670	19059056		
55552	4613	43012433	2004-01-22	2004-01-22 00:00:00	2005-01-16	2005-01-16 00:00:00	2005-01-16	38000177		0	0	360		0	0	0	307322	0	1367439	43012433		
35356	2914	1127433	1972-12-25	1972-12-25 00:00:00	1973-01-08	1973-01-08 00:00:00	1973-01-08	38000177		0	0	14		0	0	0	194192	0	313782	1127433		
27954	2314	19059056	1958-03-02	1958-03-02 00:00:00	1958-05-31	1958-05-31 00:00:00	1958-05-31	38000177		0	0	90		0	0	0	153862	0	243670	19059056		
216409	4749	40213227	2014-11-01	2014-11-01 00:00:00	2014-11-01	2014-11-01 00:00:00	2014-11-01	581452		0	0	0		0	0	0	316269	0	113	40213227		
45942	3803	19128065	1976-03-30	1976-03-30 00:00:00	1977-03-25	1977-03-25 00:00:00	1977-03-25	38000177		0	0	360		0	0	0	252771	0	749882	19128065		
211733	4642	40213198	2018-02-20	2018-02-20 00:00:00	2018-02-20	2018-02-20 00:00:00	2018-02-20	581452		0	0	0		0	0	0	309440	0	133	40213198		
38021	829	40213227	2005-06-19	2005-06-19 00:00:00	2005-06-19	2005-06-19 00:00:00	2005-06-19	581452		0	0	0		0	0	0	54895	0	113	40213227		
56069	4655	40229134	1998-06-14	1998-06-14 00:00:00	1998-06-28	1998-06-28 00:00:00	1998-06-28	38000177		0	0	14		0	0	0	310369	0	1043400	40229134		
10324	864	19075601	2003-07-28	2003-07-28 00:00:00	2003-07-28	2003-07-28 00:00:00	\N	38000177		0	0	0		0	0	0	57248	0	309362	19075601		
10405	869	19059056	1914-09-16	1914-09-16 00:00:00	1914-09-30	1914-09-30 00:00:00	1914-09-30	38000177		0	0	14		0	0	0	57799	0	243670	19059056		
62178	1358	40213227	2015-06-18	2015-06-18 00:00:00	2015-06-18	2015-06-18 00:00:00	2015-06-18	581452		0	0	0		0	0	0	90052	0	113	40213227		
17016	1409	19133905	1993-05-27	1993-05-27 00:00:00	1993-06-03	1993-06-03 00:00:00	1993-06-03	38000177		0	0	7		0	0	0	93714	0	834102	19133905		
20961	1727	1367571	1982-03-24	1982-03-24 00:00:00	1982-03-24	1982-03-24 00:00:00	1982-03-24	38000177		0	0	0		0	0	0	115482	0	314659	19080464		
17081	1412	19078461	1999-11-30	1999-11-30 00:00:00	1999-12-14	1999-12-14 00:00:00	1999-12-14	38000177		0	0	14		0	0	0	94042	0	310965	19078461		
212578	4661	40213227	2007-12-27	2007-12-27 00:00:00	2007-12-27	2007-12-27 00:00:00	2007-12-27	581452		0	0	0		0	0	0	310667	0	113	40213227		
27629	2287	19018935	2004-05-21	2004-05-21 00:00:00	2004-05-21	2004-05-21 00:00:00	\N	38000177		0	0	0		0	0	0	152146	0	197604	19018935		
67469	1475	40213201	2001-01-25	2001-01-25 00:00:00	2001-01-25	2001-01-25 00:00:00	2001-01-25	581452		0	0	0		0	0	0	98300	0	33	40213201		
54876	4559	19133873	1956-11-18	1956-11-18 00:00:00	1956-11-28	1956-11-28 00:00:00	1956-11-28	38000177		0	0	10		0	0	0	303709	0	834061	19133873		
47061	3900	1115171	2002-05-22	2002-05-22 00:00:00	2002-06-12	2002-06-12 00:00:00	2002-06-12	38000177		0	0	21		0	0	0	259330	0	849574	1115171		
44955	978	40213227	2007-06-22	2007-06-22 00:00:00	2007-06-22	2007-06-22 00:00:00	2007-06-22	581452		0	0	0		0	0	0	65137	0	113	40213227		
54732	4547	1127433	1994-02-02	1994-02-02 00:00:00	1994-02-09	1994-02-09 00:00:00	1994-02-09	38000177		0	0	7		0	0	0	302911	0	313782	1127433		
42313	3509	19006318	1946-02-08	1946-02-08 00:00:00	1946-02-22	1946-02-22 00:00:00	1946-02-22	38000177		0	0	14		0	0	0	232763	0	105078	19006318		
37336	3084	1310034	2015-10-21	2015-10-21 00:00:00	2015-10-21	2015-10-21 00:00:00	2015-10-21	38000177		0	0	0		0	0	0	205356	0	834357	1310034		
172827	3799	40213227	2014-07-29	2014-07-29 00:00:00	2014-07-29	2014-07-29 00:00:00	2014-07-29	581452		0	0	0		0	0	0	252589	0	113	40213227		
50663	4210	1127078	1976-04-29	1976-04-29 00:00:00	1976-05-13	1976-05-13 00:00:00	1976-05-13	38000177		0	0	14		0	0	0	279575	0	282464	1127078		
63431	5268	1127433	2005-08-07	2005-08-07 00:00:00	2005-08-14	2005-08-14 00:00:00	2005-08-14	38000177		0	0	7		0	0	0	350502	0	313782	1127433		
43697	3622	40229134	2005-01-23	2005-01-23 00:00:00	2005-02-06	2005-02-06 00:00:00	2005-02-06	38000177		0	0	14		0	0	0	240678	0	1043400	40229134		
234792	5157	40213296	2005-04-21	2005-04-21 00:00:00	2005-04-21	2005-04-21 00:00:00	2005-04-21	581452		0	0	0		0	0	0	342892	0	52	40213296		
40444	3353	1127433	1947-01-27	1947-01-27 00:00:00	1947-02-03	1947-02-03 00:00:00	1947-02-03	38000177		0	0	7		0	0	0	222414	0	313782	1127433		
51643	4291	1127433	1982-12-08	1982-12-08 00:00:00	1982-12-15	1982-12-15 00:00:00	1982-12-15	38000177		0	0	7		0	0	0	284878	0	313782	1127433		
38676	844	40213160	1966-07-30	1966-07-30 00:00:00	1966-07-30	1966-07-30 00:00:00	1966-07-30	581452		0	0	0		0	0	0	55877	0	10	40213160		
226356	4971	40213227	2016-03-01	2016-03-01 00:00:00	2016-03-01	2016-03-01 00:00:00	2016-03-01	581452		0	0	0		0	0	0	330532	0	113	40213227		
226383	4971	40213201	2000-12-05	2000-12-05 00:00:00	2000-12-05	2000-12-05 00:00:00	2000-12-05	581452		0	0	0		0	0	0	330636	0	33	40213201		
77668	1699	40213160	1966-12-11	1966-12-11 00:00:00	1966-12-11	1966-12-11 00:00:00	1966-12-11	581452		0	0	0		0	0	0	113640	0	10	40213160		
17627	1459	1127433	1990-06-02	1990-06-02 00:00:00	1990-06-16	1990-06-16 00:00:00	1990-06-16	38000177		0	0	14		0	0	0	97263	0	313782	1127433		
62405	5194	19059056	1946-05-17	1946-05-17 00:00:00	1946-05-31	1946-05-31 00:00:00	1946-05-31	38000177		0	0	14		0	0	0	345383	0	243670	19059056		
25614	2105	1118084	2013-01-25	2013-01-25 00:00:00	2013-01-25	2013-01-25 00:00:00	\N	38000177		0	0	0		0	0	0	140257	0	00025152531	44923712		
48292	4005	1127433	1992-09-02	1992-09-02 00:00:00	1992-09-16	1992-09-16 00:00:00	1992-09-16	38000177		0	0	14		0	0	0	266084	0	313782	1127433		
58779	4883	19059056	1947-12-11	1947-12-11 00:00:00	1948-01-01	1948-01-01 00:00:00	1948-01-01	38000177		0	0	21		0	0	0	324678	0	243670	19059056		
100490	2202	40213160	1974-03-21	1974-03-21 00:00:00	1974-03-21	1974-03-21 00:00:00	1974-03-21	581452		0	0	0		0	0	0	146784	0	10	40213160		
663	49	1310034	2003-07-12	2003-07-12 00:00:00	2003-07-12	2003-07-12 00:00:00	2003-07-12	38000177		0	0	0		0	0	0	3529	0	834357	1310034		
238392	5233	40213160	1961-08-01	1961-08-01 00:00:00	1961-08-01	1961-08-01 00:00:00	1961-08-01	581452		0	0	0		0	0	0	348187	0	10	40213160		
30169	2501	1127433	1974-04-07	1974-04-07 00:00:00	1974-05-05	1974-05-05 00:00:00	1974-05-05	38000177		0	0	28		0	0	0	165574	0	313782	1127433		
185724	4081	40213296	1997-12-29	1997-12-29 00:00:00	1997-12-29	1997-12-29 00:00:00	1997-12-29	581452		0	0	0		0	0	0	271279	0	52	40213296		
40738	3378	19059056	1961-09-11	1961-09-11 00:00:00	1961-09-25	1961-09-25 00:00:00	1961-09-25	38000177		0	0	14		0	0	0	224167	0	243670	19059056		
49810	1091	40213160	1956-09-13	1956-09-13 00:00:00	1956-09-13	1956-09-13 00:00:00	1956-09-13	581452		0	0	0		0	0	0	71599	0	10	40213160		
49680	4121	1127433	1928-06-23	1928-06-23 00:00:00	1928-06-30	1928-06-30 00:00:00	1928-06-30	38000177		0	0	7		0	0	0	273957	0	313782	1127433		
133421	2929	40213296	2015-10-31	2015-10-31 00:00:00	2015-10-31	2015-10-31 00:00:00	2015-10-31	581452		0	0	0		0	0	0	195410	0	52	40213296		
49624	4116	1127078	1980-06-21	1980-06-21 00:00:00	1980-07-12	1980-07-12 00:00:00	1980-07-12	38000177		0	0	21		0	0	0	273675	0	282464	1127078		
155157	3415	40213296	2007-11-24	2007-11-24 00:00:00	2007-11-24	2007-11-24 00:00:00	2007-11-24	581452		0	0	0		0	0	0	226516	0	52	40213296		
113548	2495	40213227	2011-12-13	2011-12-13 00:00:00	2011-12-13	2011-12-13 00:00:00	2011-12-13	581452		0	0	0		0	0	0	165182	0	113	40213227		
48308	4006	1713671	2004-04-24	2004-04-24 00:00:00	2004-05-01	2004-05-01 00:00:00	2004-05-01	38000177		0	0	7		0	0	0	266191	0	562251	1713671		
18137	1504	19059056	1959-06-20	1959-06-20 00:00:00	1959-09-18	1959-09-18 00:00:00	1959-09-18	38000177		0	0	90		0	0	0	100217	0	243670	19059056		
18200	1508	40162522	1949-02-23	1949-02-23 00:00:00	1949-02-23	1949-02-23 00:00:00	\N	38000177		0	0	0		0	0	0	100546	0	857005	40162522		
63245	5255	19059056	1971-10-06	1971-10-06 00:00:00	1971-10-20	1971-10-20 00:00:00	1971-10-20	38000177		0	0	14		0	0	0	349626	0	243670	19059056		
65499	1433	40213160	1960-09-12	1960-09-12 00:00:00	1960-09-12	1960-09-12 00:00:00	1960-09-12	581452		0	0	0		0	0	0	95487	0	10	40213160		
13561	1136	46275916	1972-10-07	1972-10-07 00:00:00	1972-10-07	1972-10-07 00:00:00	1972-10-07	38000177		0	0	0		0	0	0	74864	0	1660014	46275916		
23148	1908	19129655	1975-08-16	1975-08-16 00:00:00	1975-08-30	1975-08-30 00:00:00	1975-08-30	38000177		0	0	14		0	0	0	126986	0	789980	19129655		
62163	5172	19006318	1948-06-16	1948-06-16 00:00:00	1948-06-30	1948-06-30 00:00:00	1948-06-30	38000177		0	0	14		0	0	0	343830	0	105078	19006318		
224824	4935	40213227	2005-11-10	2005-11-10 00:00:00	2005-11-10	2005-11-10 00:00:00	2005-11-10	581452		0	0	0		0	0	0	328050	0	113	40213227		
50422	4190	19112599	1976-08-19	1976-08-19 00:00:00	1976-08-19	1976-08-19 00:00:00	\N	38000177		0	0	0		0	0	0	278094	0	477045	19112599		
76036	1661	40213260	2007-07-12	2007-07-12 00:00:00	2007-07-12	2007-07-12 00:00:00	2007-07-12	581452		0	0	0		0	0	0	111679	0	121	40213260		
56639	4700	19133873	1958-01-03	1958-01-03 00:00:00	1958-01-13	1958-01-13 00:00:00	1958-01-13	38000177		0	0	10		0	0	0	313052	0	834061	19133873		
60997	5073	1127433	1963-09-15	1963-09-15 00:00:00	1963-09-22	1963-09-22 00:00:00	1963-09-22	38000177		0	0	7		0	0	0	337232	0	313782	1127433		
55553	4613	40165015	1990-03-13	1990-03-13 00:00:00	1990-03-13	1990-03-13 00:00:00	\N	38000177		0	0	0		0	0	0	307232	0	861467	40165015		
35357	2914	40229134	1977-12-19	1977-12-19 00:00:00	1977-12-26	1977-12-26 00:00:00	1977-12-26	38000177		0	0	7		0	0	0	194173	0	1043400	40229134		
27955	2314	1127433	1984-04-10	1984-04-10 00:00:00	1984-05-08	1984-05-08 00:00:00	1984-05-08	38000177		0	0	28		0	0	0	153867	0	313782	1127433		
216410	4749	40213296	2014-11-01	2014-11-01 00:00:00	2014-11-01	2014-11-01 00:00:00	2014-11-01	581452		0	0	0		0	0	0	316269	0	52	40213296		
45943	3803	40229134	1966-07-12	1966-07-12 00:00:00	1966-07-19	1966-07-19 00:00:00	1966-07-19	38000177		0	0	7		0	0	0	252803	0	1043400	40229134		
211740	4642	40213296	1996-12-10	1996-12-10 00:00:00	1996-12-10	1996-12-10 00:00:00	1996-12-10	581452		0	0	0		0	0	0	309446	0	52	40213296		
38024	829	40213296	2014-09-28	2014-09-28 00:00:00	2014-09-28	2014-09-28 00:00:00	2014-09-28	581452		0	0	0		0	0	0	54938	0	52	40213296		
56070	4655	19115351	1984-02-19	1984-02-19 00:00:00	1984-09-23	1984-09-23 00:00:00	1984-09-23	38000177		0	0	217		0	0	0	310377	0	563026	19115351		
10325	864	1332419	2003-07-28	2003-07-28 00:00:00	2003-07-28	2003-07-28 00:00:00	\N	38000177		0	0	0		0	0	0	57248	0	197361	1332419		
10406	869	1118084	1949-11-23	1949-11-23 00:00:00	1949-11-23	1949-11-23 00:00:00	\N	38000177		0	0	0		0	0	0	57683	0	00025152531	44923712		
240394	5277	40213160	1955-09-14	1955-09-14 00:00:00	1955-09-14	1955-09-14 00:00:00	1955-09-14	581452		0	0	0		0	0	0	350964	0	10	40213160		
17017	1409	19059056	1946-05-23	1946-05-23 00:00:00	1946-07-22	1946-07-22 00:00:00	1946-07-22	38000177		0	0	60		0	0	0	93832	0	243670	19059056		
20962	1727	19079524	1982-03-24	1982-03-24 00:00:00	1982-03-25	1982-03-25 00:00:00	1982-03-25	38000177		0	0	1		0	0	0	115482	0	313002	19079524		
17082	1412	40236824	2010-07-13	2010-07-13 00:00:00	2010-07-20	2010-07-20 00:00:00	2010-07-20	38000177		0	0	7		0	0	0	94017	0	1094107	40236824		
212579	4661	40213314	1977-12-22	1977-12-22 00:00:00	1977-12-22	1977-12-22 00:00:00	1977-12-22	581452		0	0	0		0	0	0	310698	0	49	40213314		
27630	2287	19059056	1965-07-19	1965-07-19 00:00:00	1965-08-09	1965-08-09 00:00:00	1965-08-09	38000177		0	0	21		0	0	0	152149	0	243670	19059056		
130159	2861	40213160	1963-10-14	1963-10-14 00:00:00	1963-10-14	1963-10-14 00:00:00	1963-10-14	581452		0	0	0		0	0	0	190191	0	10	40213160		
83272	1820	40213160	1978-10-17	1978-10-17 00:00:00	1978-10-17	1978-10-17 00:00:00	1978-10-17	581452		0	0	0		0	0	0	121762	0	10	40213160		
47062	3900	1127433	1978-01-08	1978-01-08 00:00:00	1978-01-15	1978-01-15 00:00:00	1978-01-15	38000177		0	0	7		0	0	0	259298	0	313782	1127433		
44957	978	40213160	1980-03-14	1980-03-14 00:00:00	1980-03-14	1980-03-14 00:00:00	1980-03-14	581452		0	0	0		0	0	0	65128	0	10	40213160		
54733	4547	19059056	1918-10-10	1918-10-10 00:00:00	1918-10-31	1918-10-31 00:00:00	1918-10-31	38000177		0	0	21		0	0	0	302956	0	243670	19059056		
42314	3509	19059056	1946-02-08	1946-02-08 00:00:00	1946-02-22	1946-02-22 00:00:00	1946-02-22	38000177		0	0	14		0	0	0	232763	0	243670	19059056		
5743	480	1127433	1941-11-25	1941-11-25 00:00:00	1941-12-02	1941-12-02 00:00:00	1941-12-02	38000177		0	0	7		0	0	0	32084	0	313782	1127433		
172828	3799	40213296	2014-07-29	2014-07-29 00:00:00	2014-07-29	2014-07-29 00:00:00	2014-07-29	581452		0	0	0		0	0	0	252589	0	52	40213296		
50664	4210	1713671	2001-12-04	2001-12-04 00:00:00	2002-01-29	2002-01-29 00:00:00	2002-01-29	38000177		0	0	56		0	0	0	279522	0	562251	1713671		
63432	5268	1127433	1972-03-24	1972-03-24 00:00:00	1972-04-07	1972-04-07 00:00:00	1972-04-07	38000177		0	0	14		0	0	0	350478	0	313782	1127433		
43698	3622	920300	1970-06-16	1970-06-16 00:00:00	1970-06-23	1970-06-23 00:00:00	1970-06-23	38000177		0	0	7		0	0	0	240791	0	311989	920300		
234796	5157	40213160	1963-07-18	1963-07-18 00:00:00	1963-07-18	1963-07-18 00:00:00	1963-07-18	581452		0	0	0		0	0	0	342927	0	10	40213160		
40445	3353	1127433	1955-04-02	1955-04-02 00:00:00	1955-04-16	1955-04-16 00:00:00	1955-04-16	38000177		0	0	14		0	0	0	222390	0	313782	1127433		
51644	4291	1127433	1994-11-03	1994-11-03 00:00:00	1994-11-24	1994-11-24 00:00:00	1994-11-24	38000177		0	0	21		0	0	0	284893	0	313782	1127433		
38681	844	40213227	2008-07-19	2008-07-19 00:00:00	2008-07-19	2008-07-19 00:00:00	2008-07-19	581452		0	0	0		0	0	0	55934	0	113	40213227		
126174	2776	40213160	1975-10-19	1975-10-19 00:00:00	1975-10-19	1975-10-19 00:00:00	1975-10-19	581452		0	0	0		0	0	0	183869	0	10	40213160		
226403	4972	40213201	2017-11-25	2017-11-25 00:00:00	2017-11-25	2017-11-25 00:00:00	2017-11-25	581452		0	0	0		0	0	0	330747	0	33	40213201		
77674	1699	40213160	1971-03-14	1971-03-14 00:00:00	1971-03-14	1971-03-14 00:00:00	1971-03-14	581452		0	0	0		0	0	0	113629	0	10	40213160		
17628	1459	19133873	1949-01-23	1949-01-23 00:00:00	1949-02-04	1949-02-04 00:00:00	1949-02-04	38000177		0	0	12		0	0	0	97260	0	834061	19133873		
62406	5194	19006318	1946-05-17	1946-05-17 00:00:00	1946-05-31	1946-05-31 00:00:00	1946-05-31	38000177		0	0	14		0	0	0	345383	0	105078	19006318		
25615	2105	40229134	2015-03-06	2015-03-06 00:00:00	2015-03-20	2015-03-20 00:00:00	2015-03-20	38000177		0	0	14		0	0	0	140220	0	1043400	40229134		
48293	4005	1713671	1971-08-16	1971-08-16 00:00:00	1971-08-23	1971-08-23 00:00:00	1971-08-23	38000177		0	0	7		0	0	0	266126	0	562251	1713671		
58781	4883	1127433	2006-03-11	2006-03-11 00:00:00	2006-03-18	2006-03-18 00:00:00	2006-03-18	38000177		0	0	7		0	0	0	324690	0	313782	1127433		
100491	2202	40213314	1977-09-15	1977-09-15 00:00:00	1977-09-15	1977-09-15 00:00:00	1977-09-15	581452		0	0	0		0	0	0	146759	0	49	40213314		
664	49	46275916	2003-07-12	2003-07-12 00:00:00	2003-07-12	2003-07-12 00:00:00	2003-07-12	38000177		0	0	0		0	0	0	3529	0	1660014	46275916		
238393	5233	40213296	1996-09-24	1996-09-24 00:00:00	1996-09-24	1996-09-24 00:00:00	1996-09-24	581452		0	0	0		0	0	0	348153	0	52	40213296		
30170	2501	1127433	1996-05-27	1996-05-27 00:00:00	1996-06-10	1996-06-10 00:00:00	1996-06-10	38000177		0	0	14		0	0	0	165538	0	313782	1127433		
185726	4081	40213227	1997-12-29	1997-12-29 00:00:00	1997-12-29	1997-12-29 00:00:00	1997-12-29	581452		0	0	0		0	0	0	271279	0	113	40213227		
40739	3378	1713671	2003-11-10	2003-11-10 00:00:00	2003-11-17	2003-11-17 00:00:00	2003-11-17	38000177		0	0	7		0	0	0	224128	0	562251	1713671		
49814	1091	40213260	2006-11-23	2006-11-23 00:00:00	2006-11-23	2006-11-23 00:00:00	2006-11-23	581452		0	0	0		0	0	0	71747	0	121	40213260		
49681	4121	1127433	1926-02-18	1926-02-18 00:00:00	1926-03-04	1926-03-04 00:00:00	1926-03-04	38000177		0	0	14		0	0	0	273941	0	313782	1127433		
133425	2929	40213160	1979-07-28	1979-07-28 00:00:00	1979-07-28	1979-07-28 00:00:00	1979-07-28	581452		0	0	0		0	0	0	195370	0	10	40213160		
49625	4116	19129655	1969-08-13	1969-08-13 00:00:00	1969-08-27	1969-08-27 00:00:00	1969-08-27	38000177		0	0	14		0	0	0	273634	0	789980	19129655		
155158	3415	40213160	1966-01-15	1966-01-15 00:00:00	1966-01-15	1966-01-15 00:00:00	1966-01-15	581452		0	0	0		0	0	0	226521	0	10	40213160		
113549	2495	40213160	1981-01-06	1981-01-06 00:00:00	1981-01-06	1981-01-06 00:00:00	1981-01-06	581452		0	0	0		0	0	0	165135	0	10	40213160		
48309	4006	19078461	2011-04-30	2011-04-30 00:00:00	2011-05-28	2011-05-28 00:00:00	2011-05-28	38000177		0	0	28		0	0	0	266146	0	310965	19078461		
18138	1504	40236824	2003-07-08	2003-07-08 00:00:00	2003-07-15	2003-07-15 00:00:00	2003-07-15	38000177		0	0	7		0	0	0	100272	0	1094107	40236824		
18201	1508	19059056	1943-01-12	1943-01-12 00:00:00	1943-01-26	1943-01-26 00:00:00	1943-01-26	38000177		0	0	14		0	0	0	100545	0	243670	19059056		
63246	5255	19078461	1996-05-28	1996-05-28 00:00:00	1996-07-02	1996-07-02 00:00:00	1996-07-02	38000177		0	0	35		0	0	0	349702	0	310965	19078461		
65503	1433	40213160	1960-04-11	1960-04-11 00:00:00	1960-04-11	1960-04-11 00:00:00	1960-04-11	581452		0	0	0		0	0	0	95486	0	10	40213160		
13562	1136	40229134	2003-05-22	2003-05-22 00:00:00	2003-06-05	2003-06-05 00:00:00	2003-06-05	38000177		0	0	14		0	0	0	74838	0	1043400	40229134		
23149	1908	19019979	1975-08-16	1975-08-16 00:00:00	1975-08-30	1975-08-30 00:00:00	1975-08-30	38000177		0	0	14		0	0	0	126986	0	198405	19019979		
62164	5172	19059056	1948-06-16	1948-06-16 00:00:00	1948-06-30	1948-06-30 00:00:00	1948-06-30	38000177		0	0	14		0	0	0	343830	0	243670	19059056		
123191	2708	40213260	2006-11-27	2006-11-27 00:00:00	2006-11-27	2006-11-27 00:00:00	2006-11-27	581452		0	0	0		0	0	0	179436	0	121	40213260		
50423	4190	19078461	1987-01-13	1987-01-13 00:00:00	1987-02-03	1987-02-03 00:00:00	1987-02-03	38000177		0	0	21		0	0	0	278064	0	310965	19078461		
76044	1661	40213160	1955-12-08	1955-12-08 00:00:00	1955-12-08	1955-12-08 00:00:00	1955-12-08	581452		0	0	0		0	0	0	111642	0	10	40213160		
56640	4700	1127433	2015-03-13	2015-03-13 00:00:00	2015-03-20	2015-03-20 00:00:00	2015-03-20	38000177		0	0	7		0	0	0	313057	0	313782	1127433		
60998	5073	1713671	1956-02-15	1956-02-15 00:00:00	1956-02-22	1956-02-22 00:00:00	1956-02-22	38000177		0	0	7		0	0	0	337184	0	562251	1713671		
55554	4613	1127433	1990-03-13	1990-03-13 00:00:00	1990-04-12	1990-04-12 00:00:00	1990-04-12	38000177		0	0	30		0	0	0	307232	0	313782	1127433		
35358	2914	19059056	1959-09-01	1959-09-01 00:00:00	1959-09-15	1959-09-15 00:00:00	1959-09-15	38000177		0	0	14		0	0	0	194174	0	243670	19059056		
27956	2314	1127433	1972-04-08	1972-04-08 00:00:00	1972-04-22	1972-04-22 00:00:00	1972-04-22	38000177		0	0	14		0	0	0	153865	0	313782	1127433		
227691	4999	40213160	1961-10-29	1961-10-29 00:00:00	1961-10-29	1961-10-29 00:00:00	1961-10-29	581452		0	0	0		0	0	0	332425	0	10	40213160		
45944	3803	1127433	2011-04-21	2011-04-21 00:00:00	2011-05-05	2011-05-05 00:00:00	2011-05-05	38000177		0	0	14		0	0	0	252802	0	313782	1127433		
211748	4642	40213160	1956-05-01	1956-05-01 00:00:00	1956-05-01	1956-05-01 00:00:00	1956-05-01	581452		0	0	0		0	0	0	309460	0	10	40213160		
38026	829	40213227	2014-09-28	2014-09-28 00:00:00	2014-09-28	2014-09-28 00:00:00	2014-09-28	581452		0	0	0		0	0	0	54938	0	113	40213227		
56071	4655	19074679	1982-12-08	1982-12-08 00:00:00	1983-04-13	1983-04-13 00:00:00	1983-04-13	38000177		0	0	126		0	0	0	310302	0	308971	19074679		
10326	864	1539411	2003-07-28	2003-07-28 00:00:00	2003-07-28	2003-07-28 00:00:00	\N	38000177		0	0	0		0	0	0	57248	0	312961	1539411		
10407	869	1127433	1947-07-19	1947-07-19 00:00:00	1947-07-26	1947-07-26 00:00:00	1947-07-26	38000177		0	0	7		0	0	0	57683	0	313782	1127433		
240396	5277	40213227	2006-01-11	2006-01-11 00:00:00	2006-01-11	2006-01-11 00:00:00	2006-01-11	581452		0	0	0		0	0	0	351002	0	113	40213227		
17018	1409	19078461	2012-09-03	2012-09-03 00:00:00	2012-09-24	2012-09-24 00:00:00	2012-09-24	38000177		0	0	21		0	0	0	93833	0	310965	19078461		
20963	1727	35605858	1982-03-24	1982-03-24 00:00:00	1982-03-25	1982-03-25 00:00:00	1982-03-25	38000177		0	0	1		0	0	0	115482	0	1732136	35605858		
17083	1412	920300	2010-07-13	2010-07-13 00:00:00	2010-07-20	2010-07-20 00:00:00	2010-07-20	38000177		0	0	7		0	0	0	94017	0	311989	920300		
212585	4661	40213296	2018-04-26	2018-04-26 00:00:00	2018-04-26	2018-04-26 00:00:00	2018-04-26	581452		0	0	0		0	0	0	310692	0	52	40213296		
27631	2287	1539411	1991-03-08	1991-03-08 00:00:00	1991-03-08	1991-03-08 00:00:00	\N	38000177		0	0	0		0	0	0	152143	0	312961	1539411		
130162	2861	40213306	1985-11-11	1985-11-11 00:00:00	1985-11-11	1985-11-11 00:00:00	1985-11-11	581452		0	0	0		0	0	0	190230	0	43	40213306		
83279	1820	40213227	2009-12-15	2009-12-15 00:00:00	2009-12-15	2009-12-15 00:00:00	2009-12-15	581452		0	0	0		0	0	0	121736	0	113	40213227		
47063	3900	1118084	1999-02-16	1999-02-16 00:00:00	1999-02-16	1999-02-16 00:00:00	\N	38000177		0	0	0		0	0	0	259317	0	00025152531	44923712		
44961	978	40213296	2015-08-21	2015-08-21 00:00:00	2015-08-21	2015-08-21 00:00:00	2015-08-21	581452		0	0	0		0	0	0	65140	0	52	40213296		
54734	4547	40229134	1965-05-27	1965-05-27 00:00:00	1965-06-03	1965-06-03 00:00:00	1965-06-03	38000177		0	0	7		0	0	0	302934	0	1043400	40229134		
42315	3509	1127433	1954-12-12	1954-12-12 00:00:00	1954-12-26	1954-12-26 00:00:00	1954-12-26	38000177		0	0	14		0	0	0	232697	0	313782	1127433		
5744	480	19133873	1939-11-08	1939-11-08 00:00:00	1939-11-17	1939-11-17 00:00:00	1939-11-17	38000177		0	0	9		0	0	0	32083	0	834061	19133873		
172832	3799	40213160	1972-08-01	1972-08-01 00:00:00	1972-08-01	1972-08-01 00:00:00	1972-08-01	581452		0	0	0		0	0	0	252566	0	10	40213160		
50665	4210	1127078	1979-01-28	1979-01-28 00:00:00	1979-02-18	1979-02-18 00:00:00	1979-02-18	38000177		0	0	21		0	0	0	279576	0	282464	1127078		
178356	3921	40213314	1982-04-21	1982-04-21 00:00:00	1982-04-21	1982-04-21 00:00:00	1982-04-21	581452		0	0	0		0	0	0	260735	0	49	40213314		
43699	3622	40236824	1970-06-16	1970-06-16 00:00:00	1970-06-23	1970-06-23 00:00:00	1970-06-23	38000177		0	0	7		0	0	0	240791	0	1094107	40236824		
234803	5157	40213296	2003-04-17	2003-04-17 00:00:00	2003-04-17	2003-04-17 00:00:00	2003-04-17	581452		0	0	0		0	0	0	342941	0	52	40213296		
40446	3353	1127433	1947-12-14	1947-12-14 00:00:00	1947-12-28	1947-12-28 00:00:00	1947-12-28	38000177		0	0	14		0	0	0	222415	0	313782	1127433		
51645	4291	1127433	1997-10-24	1997-10-24 00:00:00	1997-11-07	1997-11-07 00:00:00	1997-11-07	38000177		0	0	14		0	0	0	284883	0	313782	1127433		
38682	844	40213296	2008-07-19	2008-07-19 00:00:00	2008-07-19	2008-07-19 00:00:00	2008-07-19	581452		0	0	0		0	0	0	55934	0	52	40213296		
126175	2776	40213314	1977-12-18	1977-12-18 00:00:00	1977-12-18	1977-12-18 00:00:00	1977-12-18	581452		0	0	0		0	0	0	183870	0	49	40213314		
226412	4972	40213227	2012-10-27	2012-10-27 00:00:00	2012-10-27	2012-10-27 00:00:00	2012-10-27	581452		0	0	0		0	0	0	330700	0	113	40213227		
77680	1699	40213260	2016-04-03	2016-04-03 00:00:00	2016-04-03	2016-04-03 00:00:00	2016-04-03	581452		0	0	0		0	0	0	113624	0	121	40213260		
17629	1459	19059056	1944-11-29	1944-11-29 00:00:00	1944-12-20	1944-12-20 00:00:00	1944-12-20	38000177		0	0	21		0	0	0	97247	0	243670	19059056		
62407	5194	19059056	1969-03-22	1969-03-22 00:00:00	1969-04-05	1969-04-05 00:00:00	1969-04-05	38000177		0	0	14		0	0	0	345405	0	243670	19059056		
25616	2105	1713671	1989-01-29	1989-01-29 00:00:00	1989-02-12	1989-02-12 00:00:00	1989-02-12	38000177		0	0	14		0	0	0	140218	0	562251	1713671		
48294	4005	1713671	1978-12-22	1978-12-22 00:00:00	1978-12-29	1978-12-29 00:00:00	1978-12-29	38000177		0	0	7		0	0	0	266127	0	562251	1713671		
58783	4883	19133905	1981-12-09	1981-12-09 00:00:00	1981-12-22	1981-12-22 00:00:00	1981-12-22	38000177		0	0	13		0	0	0	324634	0	834102	19133905		
100494	2202	40213306	1995-11-02	1995-11-02 00:00:00	1995-11-02	1995-11-02 00:00:00	1995-11-02	581452		0	0	0		0	0	0	146770	0	43	40213306		
11142	929	40169216	1922-08-10	1922-08-10 00:00:00	1939-07-10	1939-07-10 00:00:00	1939-07-10	38000177		0	0	6178		0	0	0	61818	0	895994	40169216		
238403	5233	40213160	1957-01-29	1957-01-29 00:00:00	1957-01-29	1957-01-29 00:00:00	1957-01-29	581452		0	0	0		0	0	0	348184	0	10	40213160		
30171	2501	19133873	1974-05-27	1974-05-27 00:00:00	1974-06-05	1974-06-05 00:00:00	1974-06-05	38000177		0	0	9		0	0	0	165547	0	834061	19133873		
185727	4081	40213260	2007-07-23	2007-07-23 00:00:00	2007-07-23	2007-07-23 00:00:00	2007-07-23	581452		0	0	0		0	0	0	271281	0	121	40213260		
40740	3378	1310034	2014-05-10	2014-05-10 00:00:00	2014-05-10	2014-05-10 00:00:00	2014-05-10	38000177		0	0	0		0	0	0	224131	0	834357	1310034		
49817	1091	40213227	2018-01-25	2018-01-25 00:00:00	2018-01-25	2018-01-25 00:00:00	2018-01-25	581452		0	0	0		0	0	0	71749	0	113	40213227		
49682	4121	19059056	1925-11-18	1925-11-18 00:00:00	1925-12-09	1925-12-09 00:00:00	1925-12-09	38000177		0	0	21		0	0	0	273928	0	243670	19059056		
133427	2929	40213160	1975-01-25	1975-01-25 00:00:00	1975-01-25	1975-01-25 00:00:00	1975-01-25	581452		0	0	0		0	0	0	195368	0	10	40213160		
49626	4116	19059056	1969-08-13	1969-08-13 00:00:00	1969-08-27	1969-08-27 00:00:00	1969-08-27	38000177		0	0	14		0	0	0	273634	0	243670	19059056		
155162	3415	40213306	1985-11-02	1985-11-02 00:00:00	1985-11-02	1985-11-02 00:00:00	1985-11-02	581452		0	0	0		0	0	0	226510	0	43	40213306		
113551	2495	40213314	1981-01-06	1981-01-06 00:00:00	1981-01-06	1981-01-06 00:00:00	1981-01-06	581452		0	0	0		0	0	0	165135	0	49	40213314		
48310	4006	19129655	1966-03-09	1966-03-09 00:00:00	1966-03-23	1966-03-23 00:00:00	1966-03-23	38000177		0	0	14		0	0	0	266193	0	789980	19129655		
18139	1504	920300	2003-07-08	2003-07-08 00:00:00	2003-07-15	2003-07-15 00:00:00	2003-07-15	38000177		0	0	7		0	0	0	100272	0	311989	920300		
18202	1508	19059056	1924-03-01	1924-03-01 00:00:00	1924-03-15	1924-03-15 00:00:00	1924-03-15	38000177		0	0	14		0	0	0	100608	0	243670	19059056		
4821	403	19133873	1934-03-27	1934-03-27 00:00:00	1934-04-03	1934-04-03 00:00:00	1934-04-03	38000177		0	0	7		0	0	0	26432	0	834061	19133873		
65507	1433	40213260	2010-01-04	2010-01-04 00:00:00	2010-01-04	2010-01-04 00:00:00	2010-01-04	581452		0	0	0		0	0	0	95455	0	121	40213260		
51604	4288	1713671	1952-12-10	1952-12-10 00:00:00	1952-12-24	1952-12-24 00:00:00	1952-12-24	38000177		0	0	14		0	0	0	284713	0	562251	1713671		
23150	1908	1127433	2007-01-14	2007-01-14 00:00:00	2007-01-21	2007-01-21 00:00:00	2007-01-21	38000177		0	0	7		0	0	0	126958	0	313782	1127433		
62174	5174	19059056	1939-01-18	1939-01-18 00:00:00	1939-02-22	1939-02-22 00:00:00	1939-02-22	38000177		0	0	35		0	0	0	344060	0	243670	19059056		
123192	2708	40213160	1955-02-14	1955-02-14 00:00:00	1955-02-14	1955-02-14 00:00:00	1955-02-14	581452		0	0	0		0	0	0	179406	0	10	40213160		
50424	4190	1713671	1995-10-18	1995-10-18 00:00:00	1995-11-01	1995-11-01 00:00:00	1995-11-01	38000177		0	0	14		0	0	0	278070	0	562251	1713671		
76046	1661	40213227	2006-07-06	2006-07-06 00:00:00	2006-07-06	2006-07-06 00:00:00	2006-07-06	581452		0	0	0		0	0	0	111662	0	113	40213227		
56642	4701	920300	2001-12-20	2001-12-20 00:00:00	2001-12-27	2001-12-27 00:00:00	2001-12-27	38000177		0	0	7		0	0	0	313127	0	311989	920300		
60999	5073	1713671	1977-10-04	1977-10-04 00:00:00	1977-12-06	1977-12-06 00:00:00	1977-12-06	38000177		0	0	63		0	0	0	337247	0	562251	1713671		
55555	4613	19127922	2009-12-21	2009-12-21 00:00:00	2010-12-16	2010-12-16 00:00:00	2010-12-16	38000177		0	0	360		0	0	0	307254	0	748962	19127922		
45817	3791	40231925	1982-10-13	1982-10-13 00:00:00	1982-10-13	1982-10-13 00:00:00	\N	38000177		0	0	0		0	0	0	252161	0	1049221	40231925		
27957	2314	40229134	1964-01-02	1964-01-02 00:00:00	1964-01-16	1964-01-16 00:00:00	1964-01-16	38000177		0	0	14		0	0	0	153855	0	1043400	40229134		
227692	4999	40213160	1957-02-24	1957-02-24 00:00:00	1957-02-24	1957-02-24 00:00:00	1957-02-24	581452		0	0	0		0	0	0	332493	0	10	40213160		
45945	3804	1118084	2003-04-16	2003-04-16 00:00:00	2003-04-16	2003-04-16 00:00:00	\N	38000177		0	0	0		0	0	0	252894	0	00025152531	44923712		
27979	609	40213260	2018-12-18	2018-12-18 00:00:00	2018-12-18	2018-12-18 00:00:00	2018-12-18	581452		0	0	0		0	0	0	40455	0	121	40213260		
38038	830	40213296	2001-09-12	2001-09-12 00:00:00	2001-09-12	2001-09-12 00:00:00	2001-09-12	581452		0	0	0		0	0	0	54986	0	52	40213296		
56072	4655	1127433	1982-11-20	1982-11-20 00:00:00	1982-12-25	1982-12-25 00:00:00	1982-12-25	38000177		0	0	35		0	0	0	310301	0	313782	1127433		
10327	864	19126352	2003-07-28	2003-07-28 00:00:00	2003-07-28	2003-07-28 00:00:00	\N	38000177		0	0	0		0	0	0	57248	0	705129	19126352		
10408	869	40229134	1998-08-10	1998-08-10 00:00:00	1998-08-17	1998-08-17 00:00:00	1998-08-17	38000177		0	0	7		0	0	0	57812	0	1043400	40229134		
240397	5277	40213260	2006-01-11	2006-01-11 00:00:00	2006-01-11	2006-01-11 00:00:00	2006-01-11	581452		0	0	0		0	0	0	351002	0	121	40213260		
17019	1409	19133905	1971-04-10	1971-04-10 00:00:00	1971-04-20	1971-04-20 00:00:00	1971-04-20	38000177		0	0	10		0	0	0	93764	0	834102	19133905		
20964	1727	19016749	1982-03-25	1982-03-25 00:00:00	1982-03-25	1982-03-25 00:00:00	1982-03-25	38000177		0	0	0		0	0	0	115482	0	73032	19016749		
17084	1412	1127433	1983-12-12	1983-12-12 00:00:00	1984-01-02	1984-01-02 00:00:00	1984-01-02	38000177		0	0	21		0	0	0	94038	0	313782	1127433		
212587	4661	40213227	2018-04-26	2018-04-26 00:00:00	2018-04-26	2018-04-26 00:00:00	2018-04-26	581452		0	0	0		0	0	0	310692	0	113	40213227		
27632	2287	46275916	2014-01-24	2014-01-24 00:00:00	2014-01-24	2014-01-24 00:00:00	2014-01-24	38000177		0	0	0		0	0	0	152154	0	1660014	46275916		
130164	2861	40213227	1995-05-08	1995-05-08 00:00:00	1995-05-08	1995-05-08 00:00:00	1995-05-08	581452		0	0	0		0	0	0	190254	0	113	40213227		
83285	1821	40213201	2003-09-21	2003-09-21 00:00:00	2003-09-21	2003-09-21 00:00:00	2003-09-21	581452		0	0	0		0	0	0	121824	0	33	40213201		
47064	3900	19128065	1983-06-20	1983-06-20 00:00:00	1984-06-14	1984-06-14 00:00:00	1984-06-14	38000177		0	0	360		0	0	0	259336	0	749882	19128065		
44967	978	40213227	1998-06-12	1998-06-12 00:00:00	1998-06-12	1998-06-12 00:00:00	1998-06-12	581452		0	0	0		0	0	0	65134	0	113	40213227		
54735	4547	1115171	2004-06-02	2004-06-02 00:00:00	2004-07-07	2004-07-07 00:00:00	2004-07-07	38000177		0	0	35		0	0	0	302963	0	849574	1115171		
42316	3510	1127433	1997-08-06	1997-08-06 00:00:00	1997-08-20	1997-08-20 00:00:00	1997-08-20	38000177		0	0	14		0	0	0	232831	0	313782	1127433		
5745	480	40173590	1998-03-18	1998-03-18 00:00:00	1998-03-18	1998-03-18 00:00:00	\N	38000177		0	0	0		0	0	0	32119	0	904419	40173590		
147195	3236	40213227	1995-01-27	1995-01-27 00:00:00	1995-01-27	1995-01-27 00:00:00	1995-01-27	581452		0	0	0		0	0	0	215096	0	113	40213227		
50666	4210	40229134	2014-02-24	2014-02-24 00:00:00	2014-03-03	2014-03-03 00:00:00	2014-03-03	38000177		0	0	7		0	0	0	279565	0	1043400	40229134		
178357	3921	40213160	1982-04-21	1982-04-21 00:00:00	1982-04-21	1982-04-21 00:00:00	1982-04-21	581452		0	0	0		0	0	0	260735	0	10	40213160		
43700	3622	1127433	1948-12-04	1948-12-04 00:00:00	1948-12-11	1948-12-11 00:00:00	1948-12-11	38000177		0	0	7		0	0	0	240769	0	313782	1127433		
30875	673	40213306	1984-01-06	1984-01-06 00:00:00	1984-01-06	1984-01-06 00:00:00	1984-01-06	581452		0	0	0		0	0	0	44514	0	43	40213306		
40447	3353	1127433	2012-06-20	2012-06-20 00:00:00	2012-06-27	2012-06-27 00:00:00	2012-06-27	38000177		0	0	7		0	0	0	222359	0	313782	1127433		
51646	4291	19074841	1997-10-24	1997-10-24 00:00:00	1997-11-07	1997-11-07 00:00:00	1997-11-07	38000177		0	0	14		0	0	0	284883	0	309043	19074841		
38687	844	40213296	2006-07-15	2006-07-15 00:00:00	2006-07-15	2006-07-15 00:00:00	2006-07-15	581452		0	0	0		0	0	0	55884	0	52	40213296		
126178	2776	40213160	1980-06-22	1980-06-22 00:00:00	1980-06-22	1980-06-22 00:00:00	1980-06-22	581452		0	0	0		0	0	0	183799	0	10	40213160		
226419	4972	40213198	2016-11-19	2016-11-19 00:00:00	2016-11-19	2016-11-19 00:00:00	2016-11-19	581452		0	0	0		0	0	0	330720	0	133	40213198		
77683	1699	40213296	2006-04-09	2006-04-09 00:00:00	2006-04-09	2006-04-09 00:00:00	2006-04-09	581452		0	0	0		0	0	0	113622	0	52	40213296		
17630	1459	1713671	2002-12-06	2002-12-06 00:00:00	2003-02-07	2003-02-07 00:00:00	2003-02-07	38000177		0	0	63		0	0	0	97194	0	562251	1713671		
62409	5194	19059056	1948-10-17	1948-10-17 00:00:00	1948-10-31	1948-10-31 00:00:00	1948-10-31	38000177		0	0	14		0	0	0	345384	0	243670	19059056		
25617	2105	1127433	2008-06-04	2008-06-04 00:00:00	2008-06-18	2008-06-18 00:00:00	2008-06-18	38000177		0	0	14		0	0	0	140262	0	313782	1127433		
48295	4005	1127433	1990-05-01	1990-05-01 00:00:00	1990-05-08	1990-05-08 00:00:00	1990-05-08	38000177		0	0	7		0	0	0	266131	0	313782	1127433		
58784	4883	1127433	2008-08-15	2008-08-15 00:00:00	2008-08-29	2008-08-29 00:00:00	2008-08-29	38000177		0	0	14		0	0	0	324643	0	313782	1127433		
100496	2202	40213227	1995-11-02	1995-11-02 00:00:00	1995-11-02	1995-11-02 00:00:00	1995-11-02	581452		0	0	0		0	0	0	146770	0	113	40213227		
11143	929	1154615	1922-08-10	1922-08-10 00:00:00	1939-07-10	1939-07-10 00:00:00	1939-07-10	38000177		0	0	6178		0	0	0	61818	0	745679	1154615		
238405	5233	40213227	2007-09-25	2007-09-25 00:00:00	2007-09-25	2007-09-25 00:00:00	2007-09-25	581452		0	0	0		0	0	0	348167	0	113	40213227		
30172	2501	19078461	1995-09-03	1995-09-03 00:00:00	1995-09-24	1995-09-24 00:00:00	1995-09-24	38000177		0	0	21		0	0	0	165576	0	310965	19078461		
185737	4081	40213296	1995-12-25	1995-12-25 00:00:00	1995-12-25	1995-12-25 00:00:00	1995-12-25	581452		0	0	0		0	0	0	271258	0	52	40213296		
40741	3378	40243436	2014-05-10	2014-05-10 00:00:00	2014-05-10	2014-05-10 00:00:00	2014-05-10	38000177		0	0	0		0	0	0	224131	0	1190795	40243436		
49834	1091	40213296	1999-03-04	1999-03-04 00:00:00	1999-03-04	1999-03-04 00:00:00	1999-03-04	581452		0	0	0		0	0	0	71745	0	52	40213296		
49683	4121	1127433	1934-05-31	1934-05-31 00:00:00	1934-06-14	1934-06-14 00:00:00	1934-06-14	38000177		0	0	14		0	0	0	273994	0	313782	1127433		
133428	2929	40213296	2017-11-04	2017-11-04 00:00:00	2017-11-04	2017-11-04 00:00:00	2017-11-04	581452		0	0	0		0	0	0	195376	0	52	40213296		
49627	4116	1127433	1996-10-30	1996-10-30 00:00:00	1997-01-05	1997-01-05 00:00:00	1997-01-05	38000177		0	0	67		0	0	0	273677	0	313782	1127433		
155164	3415	40213296	2005-11-19	2005-11-19 00:00:00	2005-11-19	2005-11-19 00:00:00	2005-11-19	581452		0	0	0		0	0	0	226540	0	52	40213296		
113560	2495	40213160	1981-03-10	1981-03-10 00:00:00	1981-03-10	1981-03-10 00:00:00	1981-03-10	581452		0	0	0		0	0	0	165126	0	10	40213160		
48311	4006	19059056	1966-03-09	1966-03-09 00:00:00	1966-03-23	1966-03-23 00:00:00	1966-03-23	38000177		0	0	14		0	0	0	266193	0	243670	19059056		
18140	1504	1713671	1944-02-06	1944-02-06 00:00:00	1944-02-27	1944-02-27 00:00:00	1944-02-27	38000177		0	0	21		0	0	0	100236	0	562251	1713671		
18203	1508	19133905	1959-07-07	1959-07-07 00:00:00	1959-07-15	1959-07-15 00:00:00	1959-07-15	38000177		0	0	8		0	0	0	100641	0	834102	19133905		
4822	403	40171902	1992-12-28	1992-12-28 00:00:00	1992-12-28	1992-12-28 00:00:00	\N	38000177		0	0	0		0	0	0	26487	0	897718	40171902		
65513	1433	40213160	1964-12-14	1964-12-14 00:00:00	1964-12-14	1964-12-14 00:00:00	1964-12-14	581452		0	0	0		0	0	0	95467	0	10	40213160		
51605	4288	1127433	1998-12-01	1998-12-01 00:00:00	1998-12-15	1998-12-15 00:00:00	1998-12-15	38000177		0	0	14		0	0	0	284700	0	313782	1127433		
23151	1908	40229134	2014-06-15	2014-06-15 00:00:00	2014-06-29	2014-06-29 00:00:00	2014-06-29	38000177		0	0	14		0	0	0	126972	0	1043400	40229134		
62175	5174	1127433	1954-09-29	1954-09-29 00:00:00	1954-10-13	1954-10-13 00:00:00	1954-10-13	38000177		0	0	14		0	0	0	344064	0	313782	1127433		
123194	2708	40213160	1955-08-15	1955-08-15 00:00:00	1955-08-15	1955-08-15 00:00:00	1955-08-15	581452		0	0	0		0	0	0	179366	0	10	40213160		
50426	4191	40220960	2004-09-17	2004-09-17 00:00:00	2004-09-17	2004-09-17 00:00:00	2004-09-17	38000177		0	0	0		0	0	0	278156	0	1804799	40220960		
76047	1661	40213260	2006-07-06	2006-07-06 00:00:00	2006-07-06	2006-07-06 00:00:00	2006-07-06	581452		0	0	0		0	0	0	111662	0	121	40213260		
56643	4701	40236824	2001-12-20	2001-12-20 00:00:00	2001-12-27	2001-12-27 00:00:00	2001-12-27	38000177		0	0	7		0	0	0	313127	0	1094107	40236824		
61000	5073	19059056	1937-05-15	1937-05-15 00:00:00	1937-05-29	1937-05-29 00:00:00	1937-05-29	38000177		0	0	14		0	0	0	337199	0	243670	19059056		
55556	4613	19059056	1967-04-17	1967-04-17 00:00:00	1967-05-22	1967-05-22 00:00:00	1967-05-22	38000177		0	0	35		0	0	0	307230	0	243670	19059056		
45818	3791	1127433	1982-10-13	1982-10-13 00:00:00	1983-01-11	1983-01-11 00:00:00	1983-01-11	38000177		0	0	90		0	0	0	252161	0	313782	1127433		
27958	2314	1127078	1956-06-25	1956-06-25 00:00:00	1956-07-09	1956-07-09 00:00:00	1956-07-09	38000177		0	0	14		0	0	0	153907	0	282464	1127078		
45397	3756	1127433	1968-12-13	1968-12-13 00:00:00	1968-12-27	1968-12-27 00:00:00	1968-12-27	38000177		0	0	14		0	0	0	249624	0	313782	1127433		
45946	3804	19059056	1962-09-18	1962-09-18 00:00:00	1962-10-18	1962-10-18 00:00:00	1962-10-18	38000177		0	0	30		0	0	0	252857	0	243670	19059056		
27981	609	40213227	2018-12-18	2018-12-18 00:00:00	2018-12-18	2018-12-18 00:00:00	2018-12-18	581452		0	0	0		0	0	0	40455	0	113	40213227		
38040	830	40213227	2001-09-12	2001-09-12 00:00:00	2001-09-12	2001-09-12 00:00:00	2001-09-12	581452		0	0	0		0	0	0	54986	0	113	40213227		
56075	4655	19133873	1962-12-09	1962-12-09 00:00:00	1962-12-19	1962-12-19 00:00:00	1962-12-19	38000177		0	0	10		0	0	0	310263	0	834061	19133873		
10328	864	19059056	1923-08-21	1923-08-21 00:00:00	1923-09-04	1923-09-04 00:00:00	1923-09-04	38000177		0	0	14		0	0	0	57303	0	243670	19059056		
239227	5252	40213227	1999-04-13	1999-04-13 00:00:00	1999-04-13	1999-04-13 00:00:00	1999-04-13	581452		0	0	0		0	0	0	349425	0	113	40213227		
164741	3622	40213227	2003-11-19	2003-11-19 00:00:00	2003-11-19	2003-11-19 00:00:00	2003-11-19	581452		0	0	0		0	0	0	240713	0	113	40213227		
17020	1409	19059056	1928-09-03	1928-09-03 00:00:00	1928-09-24	1928-09-24 00:00:00	1928-09-24	38000177		0	0	21		0	0	0	93831	0	243670	19059056		
20965	1727	19023423	1982-03-25	1982-03-25 00:00:00	1982-03-25	1982-03-25 00:00:00	1982-03-25	38000177		0	0	0		0	0	0	115482	0	200252	19023423		
17085	1412	1127433	2002-02-25	2002-02-25 00:00:00	2002-03-04	2002-03-04 00:00:00	2002-03-04	38000177		0	0	7		0	0	0	93997	0	313782	1127433		
212592	4661	40213306	1998-12-17	1998-12-17 00:00:00	1998-12-17	1998-12-17 00:00:00	1998-12-17	581452		0	0	0		0	0	0	310705	0	43	40213306		
27633	2287	1118084	1982-05-10	1982-05-10 00:00:00	1982-05-10	1982-05-10 00:00:00	\N	38000177		0	0	0		0	0	0	152179	0	00025152531	44923712		
130166	2861	40213296	2004-07-12	2004-07-12 00:00:00	2004-07-12	2004-07-12 00:00:00	2004-07-12	581452		0	0	0		0	0	0	190221	0	52	40213296		
130205	2862	40213160	1972-05-13	1972-05-13 00:00:00	1972-05-13	1972-05-13 00:00:00	1972-05-13	581452		0	0	0		0	0	0	190317	0	10	40213160		
47065	3901	1115171	2012-11-03	2012-11-03 00:00:00	2012-12-08	2012-12-08 00:00:00	2012-12-08	38000177		0	0	35		0	0	0	259389	0	849574	1115171		
44968	978	40213306	1998-06-12	1998-06-12 00:00:00	1998-06-12	1998-06-12 00:00:00	1998-06-12	581452		0	0	0		0	0	0	65134	0	43	40213306		
54736	4547	19059056	1910-04-11	1910-04-11 00:00:00	1910-04-25	1910-04-25 00:00:00	1910-04-25	38000177		0	0	14		0	0	0	302905	0	243670	19059056		
42317	3510	19133873	1935-09-07	1935-09-07 00:00:00	1935-09-18	1935-09-18 00:00:00	1935-09-18	38000177		0	0	11		0	0	0	232959	0	834061	19133873		
5746	480	19008572	1971-05-19	1971-05-19 00:00:00	1971-05-19	1971-05-19 00:00:00	\N	38000177		0	0	0		0	0	0	31987	0	106258	19008572		
147216	3237	40213227	2008-05-07	2008-05-07 00:00:00	2008-05-07	2008-05-07 00:00:00	2008-05-07	581452		0	0	0		0	0	0	215214	0	113	40213227		
50667	4210	19078461	1990-02-20	1990-02-20 00:00:00	1990-03-06	1990-03-06 00:00:00	1990-03-06	38000177		0	0	14		0	0	0	279578	0	310965	19078461		
178362	3921	40213251	1986-10-22	1986-10-22 00:00:00	1986-10-22	1986-10-22 00:00:00	1986-10-22	581452		0	0	0		0	0	0	260737	0	21	40213251		
43701	3622	46275916	1953-04-22	1953-04-22 00:00:00	1953-04-22	1953-04-22 00:00:00	1953-04-22	38000177		0	0	0		0	0	0	240710	0	1660014	46275916		
30878	673	40213227	1995-02-17	1995-02-17 00:00:00	1995-02-17	1995-02-17 00:00:00	1995-02-17	581452		0	0	0		0	0	0	\N	0	113	40213227		
40448	3353	1127433	1998-11-26	1998-11-26 00:00:00	1999-01-25	1999-01-25 00:00:00	1999-01-25	38000177		0	0	60		0	0	0	222452	0	313782	1127433		
51647	4291	1713671	1989-05-30	1989-05-30 00:00:00	1989-06-06	1989-06-06 00:00:00	1989-06-06	38000177		0	0	7		0	0	0	284879	0	562251	1713671		
38694	844	40213160	1966-10-01	1966-10-01 00:00:00	1966-10-01	1966-10-01 00:00:00	1966-10-01	581452		0	0	0		0	0	0	55921	0	10	40213160		
126182	2776	40213160	1975-12-21	1975-12-21 00:00:00	1975-12-21	1975-12-21 00:00:00	1975-12-21	581452		0	0	0		0	0	0	183796	0	10	40213160		
197523	4340	40213160	1973-03-02	1973-03-02 00:00:00	1973-03-02	1973-03-02 00:00:00	1973-03-02	581452		0	0	0		0	0	0	287753	0	10	40213160		
88967	1951	40213306	2004-01-07	2004-01-07 00:00:00	2004-01-07	2004-01-07 00:00:00	2004-01-07	581452		0	0	0		0	0	0	129734	0	43	40213306		
17631	1459	1118084	1976-03-21	1976-03-21 00:00:00	1976-03-21	1976-03-21 00:00:00	\N	38000177		0	0	0		0	0	0	97190	0	00025152531	44923712		
62410	5194	19006318	1948-10-17	1948-10-17 00:00:00	1948-10-31	1948-10-31 00:00:00	1948-10-31	38000177		0	0	14		0	0	0	345384	0	105078	19006318		
25618	2105	19073183	1979-09-29	1979-09-29 00:00:00	1979-10-13	1979-10-13 00:00:00	1979-10-13	38000177		0	0	14		0	0	0	140223	0	308182	19073183		
48296	4005	19133905	1989-01-08	1989-01-08 00:00:00	1989-01-19	1989-01-19 00:00:00	1989-01-19	38000177		0	0	11		0	0	0	266130	0	834102	19133905		
58786	4883	1127433	1987-05-17	1987-05-17 00:00:00	1987-05-24	1987-05-24 00:00:00	1987-05-24	38000177		0	0	7		0	0	0	324702	0	313782	1127433		
100503	2202	40213314	1977-03-17	1977-03-17 00:00:00	1977-03-17	1977-03-17 00:00:00	1977-03-17	581452		0	0	0		0	0	0	146764	0	49	40213314		
11144	929	1713671	1993-02-12	1993-02-12 00:00:00	1993-02-19	1993-02-19 00:00:00	1993-02-19	38000177		0	0	7		0	0	0	61826	0	562251	1713671		
238406	5233	40213260	2007-09-25	2007-09-25 00:00:00	2007-09-25	2007-09-25 00:00:00	2007-09-25	581452		0	0	0		0	0	0	348167	0	121	40213260		
30173	2501	1118084	1995-11-09	1995-11-09 00:00:00	1995-11-09	1995-11-09 00:00:00	\N	38000177		0	0	0		0	0	0	165576	0	00025152531	44923712		
192933	4238	40213296	2001-09-06	2001-09-06 00:00:00	2001-09-06	2001-09-06 00:00:00	2001-09-06	581452		0	0	0		0	0	0	281399	0	52	40213296		
40742	3378	46275916	2014-05-10	2014-05-10 00:00:00	2014-05-10	2014-05-10 00:00:00	2014-05-10	38000177		0	0	0		0	0	0	224131	0	1660014	46275916		
49836	1091	40213227	1999-03-04	1999-03-04 00:00:00	1999-03-04	1999-03-04 00:00:00	1999-03-04	581452		0	0	0		0	0	0	71745	0	113	40213227		
49684	4121	19059056	1986-08-29	1986-08-29 00:00:00	1986-09-26	1986-09-26 00:00:00	1986-09-26	38000177		0	0	28		0	0	0	273965	0	243670	19059056		
118395	2603	40213260	2011-06-01	2011-06-01 00:00:00	2011-06-01	2011-06-01 00:00:00	2011-06-01	581452		0	0	0		0	0	0	172243	0	121	40213260		
49628	4116	40165015	1996-11-06	1996-11-06 00:00:00	1996-11-06	1996-11-06 00:00:00	\N	38000177		0	0	0		0	0	0	273679	0	861467	40165015		
37743	3119	1127433	2000-02-02	2000-02-02 00:00:00	2000-02-16	2000-02-16 00:00:00	2000-02-16	38000177		0	0	14		0	0	0	207588	0	313782	1127433		
113562	2495	40213314	1981-03-10	1981-03-10 00:00:00	1981-03-10	1981-03-10 00:00:00	1981-03-10	581452		0	0	0		0	0	0	165126	0	49	40213314		
48312	4006	19075601	2016-08-02	2016-08-02 00:00:00	2016-08-02	2016-08-02 00:00:00	2016-08-02	38000177		0	0	0		0	0	0	266192	0	309362	19075601		
18141	1504	1127433	1986-04-29	1986-04-29 00:00:00	1986-05-27	1986-05-27 00:00:00	1986-05-27	38000177		0	0	28		0	0	0	100220	0	313782	1127433		
18212	1510	920300	1995-11-18	1995-11-18 00:00:00	1995-11-25	1995-11-25 00:00:00	1995-11-25	38000177		0	0	7		0	0	0	100840	0	311989	920300		
4823	403	19018935	1992-12-28	1992-12-28 00:00:00	1992-12-28	1992-12-28 00:00:00	\N	38000177		0	0	0		0	0	0	26487	0	197604	19018935		
76793	1677	40213160	1969-10-18	1969-10-18 00:00:00	1969-10-18	1969-10-18 00:00:00	1969-10-18	581452		0	0	0		0	0	0	112498	0	10	40213160		
51607	4288	1127433	1955-09-18	1955-09-18 00:00:00	1955-09-25	1955-09-25 00:00:00	1955-09-25	38000177		0	0	7		0	0	0	284714	0	313782	1127433		
23152	1908	1127433	1989-10-27	1989-10-27 00:00:00	1989-11-03	1989-11-03 00:00:00	1989-11-03	38000177		0	0	7		0	0	0	126956	0	313782	1127433		
62176	5174	19059056	1962-08-02	1962-08-02 00:00:00	1962-08-16	1962-08-16 00:00:00	1962-08-16	38000177		0	0	14		0	0	0	344065	0	243670	19059056		
123196	2708	40213227	2015-12-28	2015-12-28 00:00:00	2015-12-28	2015-12-28 00:00:00	2015-12-28	581452		0	0	0		0	0	0	179400	0	113	40213227		
50427	4191	19075601	2004-09-17	2004-09-17 00:00:00	2004-09-17	2004-09-17 00:00:00	2004-09-17	38000177		0	0	0		0	0	0	278156	0	309362	19075601		
76051	1661	40213227	2016-08-11	2016-08-11 00:00:00	2016-08-11	2016-08-11 00:00:00	2016-08-11	581452		0	0	0		0	0	0	\N	0	113	40213227		
56644	4701	1127433	1977-12-27	1977-12-27 00:00:00	1978-01-10	1978-01-10 00:00:00	1978-01-10	38000177		0	0	14		0	0	0	313135	0	313782	1127433		
61001	5073	19133905	1959-09-29	1959-09-29 00:00:00	1959-10-09	1959-10-09 00:00:00	1959-10-09	38000177		0	0	10		0	0	0	337194	0	834102	19133905		
55557	4613	1127433	1996-09-21	1996-09-21 00:00:00	1996-09-28	1996-09-28 00:00:00	1996-09-28	38000177		0	0	7		0	0	0	307272	0	313782	1127433		
45819	3791	1127433	1976-09-19	1976-09-19 00:00:00	1976-09-26	1976-09-26 00:00:00	1976-09-26	38000177		0	0	7		0	0	0	252136	0	313782	1127433		
27959	2314	1127433	1979-08-14	1979-08-14 00:00:00	1979-09-04	1979-09-04 00:00:00	1979-09-04	38000177		0	0	21		0	0	0	153866	0	313782	1127433		
45398	3756	1127433	1988-07-20	1988-07-20 00:00:00	1988-08-10	1988-08-10 00:00:00	1988-08-10	38000177		0	0	21		0	0	0	249663	0	313782	1127433		
45947	3804	40162522	2000-01-28	2000-01-28 00:00:00	2000-01-28	2000-01-28 00:00:00	\N	38000177		0	0	0		0	0	0	252860	0	857005	40162522		
27985	609	40213227	2009-12-22	2009-12-22 00:00:00	2009-12-22	2009-12-22 00:00:00	2009-12-22	581452		0	0	0		0	0	0	40472	0	113	40213227		
38048	830	40213260	2008-11-26	2008-11-26 00:00:00	2008-11-26	2008-11-26 00:00:00	2008-11-26	581452		0	0	0		0	0	0	54987	0	121	40213260		
56076	4655	19078461	1980-01-14	1980-01-14 00:00:00	1980-02-04	1980-02-04 00:00:00	1980-02-04	38000177		0	0	21		0	0	0	310300	0	310965	19078461		
10329	864	836659	1996-08-05	1996-08-05 00:00:00	1996-08-05	1996-08-05 00:00:00	\N	38000177		0	0	0		0	0	0	57256	0	313185	836659		
239228	5252	40213296	1999-04-13	1999-04-13 00:00:00	1999-04-13	1999-04-13 00:00:00	1999-04-13	581452		0	0	0		0	0	0	349425	0	52	40213296		
164753	3623	40213227	1993-07-04	1993-07-04 00:00:00	1993-07-04	1993-07-04 00:00:00	1993-07-04	581452		0	0	0		0	0	0	240857	0	113	40213227		
8749	729	1127433	2001-11-17	2001-11-17 00:00:00	2002-01-16	2002-01-16 00:00:00	2002-01-16	38000177		0	0	60		0	0	0	48366	0	313782	1127433		
20966	1727	42707627	1982-03-25	1982-03-25 00:00:00	1982-03-25	1982-03-25 00:00:00	1982-03-25	38000177		0	0	0		0	0	0	115482	0	1234995	42707627		
17086	1412	1127433	1987-08-14	1987-08-14 00:00:00	1987-09-04	1987-09-04 00:00:00	1987-09-04	38000177		0	0	21		0	0	0	94040	0	313782	1127433		
212594	4661	40213227	1998-12-17	1998-12-17 00:00:00	1998-12-17	1998-12-17 00:00:00	1998-12-17	581452		0	0	0		0	0	0	310705	0	113	40213227		
27634	2287	19078461	2014-01-22	2014-01-22 00:00:00	2014-01-22	2014-01-22 00:00:00	\N	38000177		0	0	0		0	0	0	152153	0	310965	19078461		
130167	2861	40213227	2004-07-12	2004-07-12 00:00:00	2004-07-12	2004-07-12 00:00:00	2004-07-12	581452		0	0	0		0	0	0	190221	0	113	40213227		
130212	2862	40213260	2017-11-10	2017-11-10 00:00:00	2017-11-10	2017-11-10 00:00:00	2017-11-10	581452		0	0	0		0	0	0	190301	0	121	40213260		
47066	3901	1127433	2010-04-28	2010-04-28 00:00:00	2010-05-05	2010-05-05 00:00:00	2010-05-05	38000177		0	0	7		0	0	0	259407	0	313782	1127433		
197351	4337	40213306	1984-09-21	1984-09-21 00:00:00	1984-09-21	1984-09-21 00:00:00	1984-09-21	581452		0	0	0		0	0	0	287576	0	43	40213306		
54737	4547	40162522	1997-09-07	1997-09-07 00:00:00	1997-09-07	1997-09-07 00:00:00	\N	38000177		0	0	0		0	0	0	302962	0	857005	40162522		
42318	3510	1127433	1970-02-12	1970-02-12 00:00:00	1970-02-19	1970-02-19 00:00:00	1970-02-19	38000177		0	0	7		0	0	0	232813	0	313782	1127433		
5747	480	1127433	1995-02-13	1995-02-13 00:00:00	1995-02-27	1995-02-27 00:00:00	1995-02-27	38000177		0	0	14		0	0	0	31982	0	313782	1127433		
127584	2806	40213260	2006-05-04	2006-05-04 00:00:00	2006-05-04	2006-05-04 00:00:00	2006-05-04	581452		0	0	0		0	0	0	185986	0	121	40213260		
50668	4210	19078461	2017-07-17	2017-07-17 00:00:00	2017-07-31	2017-07-31 00:00:00	2017-07-31	38000177		0	0	14		0	0	0	279552	0	310965	19078461		
178363	3921	40213160	1986-10-22	1986-10-22 00:00:00	1986-10-22	1986-10-22 00:00:00	1986-10-22	581452		0	0	0		0	0	0	260737	0	10	40213160		
43702	3622	40243436	1953-04-22	1953-04-22 00:00:00	1953-04-22	1953-04-22 00:00:00	1953-04-22	38000177		0	0	0		0	0	0	240710	0	1190795	40243436		
30883	673	40213296	2003-08-22	2003-08-22 00:00:00	2003-08-22	2003-08-22 00:00:00	2003-08-22	581452		0	0	0		0	0	0	44518	0	52	40213296		
40449	3353	19059056	1930-04-21	1930-04-21 00:00:00	1930-05-05	1930-05-05 00:00:00	1930-05-05	38000177		0	0	14		0	0	0	222393	0	243670	19059056		
51648	4291	19019979	1975-10-25	1975-10-25 00:00:00	1975-11-08	1975-11-08 00:00:00	1975-11-08	38000177		0	0	14		0	0	0	284905	0	198405	19019979		
38697	844	40213160	1966-11-26	1966-11-26 00:00:00	1966-11-26	1966-11-26 00:00:00	1966-11-26	581452		0	0	0		0	0	0	55878	0	10	40213160		
126184	2776	40213227	1997-12-14	1997-12-14 00:00:00	1997-12-14	1997-12-14 00:00:00	1997-12-14	581452		0	0	0		0	0	0	183784	0	113	40213227		
197524	4340	40213296	2013-04-12	2013-04-12 00:00:00	2013-04-12	2013-04-12 00:00:00	2013-04-12	581452		0	0	0		0	0	0	287789	0	52	40213296		
88970	1951	40213314	1981-10-21	1981-10-21 00:00:00	1981-10-21	1981-10-21 00:00:00	1981-10-21	581452		0	0	0		0	0	0	129727	0	49	40213314		
17632	1459	1713671	1972-01-12	1972-01-12 00:00:00	1972-01-19	1972-01-19 00:00:00	1972-01-19	38000177		0	0	7		0	0	0	97179	0	562251	1713671		
67750	1482	40213160	1975-03-29	1975-03-29 00:00:00	1975-03-29	1975-03-29 00:00:00	1975-03-29	581452		0	0	0		0	0	0	98844	0	10	40213160		
25619	2105	1127078	1979-09-29	1979-09-29 00:00:00	1979-10-13	1979-10-13 00:00:00	1979-10-13	38000177		0	0	14		0	0	0	140223	0	282464	1127078		
48297	4005	1127078	1975-02-20	1975-02-20 00:00:00	1975-03-06	1975-03-06 00:00:00	1975-03-06	38000177		0	0	14		0	0	0	266132	0	282464	1127078		
58787	4883	1127433	1975-06-13	1975-06-13 00:00:00	1975-07-04	1975-07-04 00:00:00	1975-07-04	38000177		0	0	21		0	0	0	324681	0	313782	1127433		
100507	2202	40213160	1978-09-21	1978-09-21 00:00:00	1978-09-21	1978-09-21 00:00:00	1978-09-21	581452		0	0	0		0	0	0	146765	0	10	40213160		
11145	929	1539411	1991-12-09	1991-12-09 00:00:00	1991-12-09	1991-12-09 00:00:00	\N	38000177		0	0	0		0	0	0	61856	0	312961	1539411		
238410	5233	40213260	2006-09-19	2006-09-19 00:00:00	2006-09-19	2006-09-19 00:00:00	2006-09-19	581452		0	0	0		0	0	0	348201	0	121	40213260		
30174	2501	19059056	1962-10-23	1962-10-23 00:00:00	1962-11-06	1962-11-06 00:00:00	1962-11-06	38000177		0	0	14		0	0	0	165573	0	243670	19059056		
192954	4239	40213198	2013-12-21	2013-12-21 00:00:00	2013-12-21	2013-12-21 00:00:00	2013-12-21	581452		0	0	0		0	0	0	281523	0	133	40213198		
40743	3378	19078461	2017-04-20	2017-04-20 00:00:00	2017-05-20	2017-05-20 00:00:00	2017-05-20	38000177		0	0	30		0	0	0	224120	0	310965	19078461		
49839	1091	40213160	1956-11-15	1956-11-15 00:00:00	1956-11-15	1956-11-15 00:00:00	1956-11-15	581452		0	0	0		0	0	0	71665	0	10	40213160		
29037	2402	40229134	1998-02-16	1998-02-16 00:00:00	1998-02-23	1998-02-23 00:00:00	1998-02-23	38000177		0	0	7		0	0	0	159620	0	1043400	40229134		
118398	2603	40213227	2011-06-01	2011-06-01 00:00:00	2011-06-01	2011-06-01 00:00:00	2011-06-01	581452		0	0	0		0	0	0	172243	0	113	40213227		
49629	4116	1115171	2004-07-27	2004-07-27 00:00:00	2004-08-17	2004-08-17 00:00:00	2004-08-17	38000177		0	0	21		0	0	0	273678	0	849574	1115171		
37744	3119	19073188	1992-12-03	1992-12-03 00:00:00	1992-12-17	1992-12-17 00:00:00	1992-12-17	38000177		0	0	14		0	0	0	207566	0	308192	19073188		
113566	2495	40213314	1981-12-08	1981-12-08 00:00:00	1981-12-08	1981-12-08 00:00:00	1981-12-08	581452		0	0	0		0	0	0	165127	0	49	40213314		
48313	4006	40220960	2016-08-02	2016-08-02 00:00:00	2016-08-02	2016-08-02 00:00:00	2016-08-02	38000177		0	0	0		0	0	0	266192	0	1804799	40220960		
18142	1504	1127433	1954-05-03	1954-05-03 00:00:00	1954-05-17	1954-05-17 00:00:00	1954-05-17	38000177		0	0	14		0	0	0	100254	0	313782	1127433		
18213	1510	40236824	1995-11-18	1995-11-18 00:00:00	1995-11-25	1995-11-25 00:00:00	1995-11-25	38000177		0	0	7		0	0	0	100840	0	1094107	40236824		
4824	403	40163554	1992-12-28	1992-12-28 00:00:00	1992-12-28	1992-12-28 00:00:00	\N	38000177		0	0	0		0	0	0	26487	0	855332	40163554		
126620	2786	40213201	1989-07-29	1989-07-29 00:00:00	1989-07-29	1989-07-29 00:00:00	1989-07-29	581452		0	0	0		0	0	0	184594	0	33	40213201		
51608	4288	1127078	1954-03-10	1954-03-10 00:00:00	1954-03-24	1954-03-24 00:00:00	1954-03-24	38000177		0	0	14		0	0	0	284655	0	282464	1127078		
23153	1908	19078461	1998-02-24	1998-02-24 00:00:00	1998-05-25	1998-05-25 00:00:00	1998-05-25	38000177		0	0	90		0	0	0	126953	0	310965	19078461		
62177	5174	19078461	2003-05-13	2003-05-13 00:00:00	2003-06-12	2003-06-12 00:00:00	2003-06-12	38000177		0	0	30		0	0	0	344067	0	310965	19078461		
123198	2708	40213296	1997-10-27	1997-10-27 00:00:00	1997-10-27	1997-10-27 00:00:00	1997-10-27	581452		0	0	0		0	0	0	179402	0	52	40213296		
50428	4191	1127078	1961-08-25	1961-08-25 00:00:00	1961-09-08	1961-09-08 00:00:00	1961-09-08	38000177		0	0	14		0	0	0	278174	0	282464	1127078		
188792	4145	40213296	2016-07-17	2016-07-17 00:00:00	2016-07-17	2016-07-17 00:00:00	2016-07-17	581452		0	0	0		0	0	0	275491	0	52	40213296		
56645	4701	1127433	1989-05-05	1989-05-05 00:00:00	1989-06-09	1989-06-09 00:00:00	1989-06-09	38000177		0	0	35		0	0	0	313171	0	313782	1127433		
61002	5073	19059056	1967-08-19	1967-08-19 00:00:00	1967-09-18	1967-09-18 00:00:00	1967-09-18	38000177		0	0	30		0	0	0	337163	0	243670	19059056		
55558	4613	19133679	2012-12-05	2012-12-05 00:00:00	2013-11-30	2013-11-30 00:00:00	2013-11-30	38000177		0	0	360		0	0	0	307286	0	831533	19133679		
45820	3791	19059056	1939-05-20	1939-05-20 00:00:00	1939-06-03	1939-06-03 00:00:00	1939-06-03	38000177		0	0	14		0	0	0	252050	0	243670	19059056		
27960	2314	1127433	1986-05-21	1986-05-21 00:00:00	1986-06-04	1986-06-04 00:00:00	1986-06-04	38000177		0	0	14		0	0	0	153906	0	313782	1127433		
45399	3756	1127433	1946-02-03	1946-02-03 00:00:00	1946-02-10	1946-02-10 00:00:00	1946-02-10	38000177		0	0	7		0	0	0	249639	0	313782	1127433		
45948	3804	1115171	2000-01-28	2000-01-28 00:00:00	2000-02-27	2000-02-27 00:00:00	2000-02-27	38000177		0	0	30		0	0	0	252860	0	849574	1115171		
27986	609	40213296	2009-12-22	2009-12-22 00:00:00	2009-12-22	2009-12-22 00:00:00	2009-12-22	581452		0	0	0		0	0	0	40472	0	52	40213296		
15131	1264	19133873	1953-08-28	1953-08-28 00:00:00	1953-09-10	1953-09-10 00:00:00	1953-09-10	38000177		0	0	13		0	0	0	83336	0	834061	19133873		
56077	4655	1124300	1990-08-28	1990-08-28 00:00:00	1990-08-28	1990-08-28 00:00:00	\N	38000177		0	0	0		0	0	0	310398	0	00781178901	45011828		
10330	864	19059056	1935-12-21	1935-12-21 00:00:00	1936-01-25	1936-01-25 00:00:00	1936-01-25	38000177		0	0	35		0	0	0	57278	0	243670	19059056		
239232	5252	40213160	1958-03-11	1958-03-11 00:00:00	1958-03-11	1958-03-11 00:00:00	1958-03-11	581452		0	0	0		0	0	0	349437	0	10	40213160		
164768	3623	40213227	2000-06-25	2000-06-25 00:00:00	2000-06-25	2000-06-25 00:00:00	2000-06-25	581452		0	0	0		0	0	0	240897	0	113	40213227		
8750	729	40162522	2001-11-17	2001-11-17 00:00:00	2001-11-17	2001-11-17 00:00:00	\N	38000177		0	0	0		0	0	0	48366	0	857005	40162522		
20967	1727	46275444	1982-03-25	1982-03-25 00:00:00	1982-03-25	1982-03-25 00:00:00	1982-03-25	38000177		0	0	0		0	0	0	115482	0	1659149	46275444		
17095	1415	19059056	1984-02-07	1984-02-07 00:00:00	1984-02-21	1984-02-21 00:00:00	1984-02-21	38000177		0	0	14		0	0	0	94212	0	243670	19059056		
212600	4662	40213227	1992-08-15	1992-08-15 00:00:00	1992-08-15	1992-08-15 00:00:00	1992-08-15	581452		0	0	0		0	0	0	310793	0	113	40213227		
27635	2287	19126352	1962-05-04	1962-05-04 00:00:00	2001-01-26	2001-01-26 00:00:00	2001-01-26	38000177		0	0	14147		0	0	0	152138	0	705129	19126352		
130172	2861	40213227	2014-12-22	2014-12-22 00:00:00	2014-12-22	2014-12-22 00:00:00	2014-12-22	581452		0	0	0		0	0	0	190243	0	113	40213227		
130219	2862	40213296	2010-10-23	2010-10-23 00:00:00	2010-10-23	2010-10-23 00:00:00	2010-10-23	581452		0	0	0		0	0	0	190292	0	52	40213296		
47068	3901	1127433	1962-04-12	1962-04-12 00:00:00	1962-04-19	1962-04-19 00:00:00	1962-04-19	38000177		0	0	7		0	0	0	259416	0	313782	1127433		
197352	4337	40213160	1962-02-16	1962-02-16 00:00:00	1962-02-16	1962-02-16 00:00:00	1962-02-16	581452		0	0	0		0	0	0	287582	0	10	40213160		
54738	4547	1127433	1997-09-07	1997-09-07 00:00:00	1997-12-06	1997-12-06 00:00:00	1997-12-06	38000177		0	0	90		0	0	0	302962	0	313782	1127433		
42319	3510	1127433	1935-10-06	1935-10-06 00:00:00	1935-10-13	1935-10-13 00:00:00	1935-10-13	38000177		0	0	7		0	0	0	232960	0	313782	1127433		
5759	482	1127433	1991-05-09	1991-05-09 00:00:00	1991-05-23	1991-05-23 00:00:00	1991-05-23	38000177		0	0	14		0	0	0	32200	0	313782	1127433		
127587	2806	40213160	1955-09-22	1955-09-22 00:00:00	1955-09-22	1955-09-22 00:00:00	1955-09-22	581452		0	0	0		0	0	0	185955	0	10	40213160		
50669	4210	1118084	2016-12-10	2016-12-10 00:00:00	2016-12-10	2016-12-10 00:00:00	\N	38000177		0	0	0		0	0	0	279540	0	00025152531	44923712		
178368	3921	40213227	2004-11-03	2004-11-03 00:00:00	2004-11-03	2004-11-03 00:00:00	2004-11-03	581452		0	0	0		0	0	0	260713	0	113	40213227		
43703	3622	40220960	1991-07-03	1991-07-03 00:00:00	1991-07-03	1991-07-03 00:00:00	1991-07-03	38000177		0	0	0		0	0	0	240809	0	1804799	40220960		
30890	673	40213260	2013-09-20	2013-09-20 00:00:00	2013-09-20	2013-09-20 00:00:00	2013-09-20	581452		0	0	0		0	0	0	44508	0	121	40213260		
40450	3353	1713671	1935-03-10	1935-03-10 00:00:00	1935-03-17	1935-03-17 00:00:00	1935-03-17	38000177		0	0	7		0	0	0	222406	0	562251	1713671		
51649	4291	46233988	1975-10-25	1975-10-25 00:00:00	1975-11-08	1975-11-08 00:00:00	1975-11-08	38000177		0	0	14		0	0	0	284905	0	1652673	46233988		
38702	844	40213227	1998-07-04	1998-07-04 00:00:00	1998-07-04	1998-07-04 00:00:00	1998-07-04	581452		0	0	0		0	0	0	56010	0	113	40213227		
126185	2776	40213306	1997-12-14	1997-12-14 00:00:00	1997-12-14	1997-12-14 00:00:00	1997-12-14	581452		0	0	0		0	0	0	183784	0	43	40213306		
197527	4340	40213314	1977-09-02	1977-09-02 00:00:00	1977-09-02	1977-09-02 00:00:00	1977-09-02	581452		0	0	0		0	0	0	287802	0	49	40213314		
88971	1951	40213160	1981-10-21	1981-10-21 00:00:00	1981-10-21	1981-10-21 00:00:00	1981-10-21	581452		0	0	0		0	0	0	129727	0	10	40213160		
17633	1459	1127433	1997-07-15	1997-07-15 00:00:00	1997-09-13	1997-09-13 00:00:00	1997-09-13	38000177		0	0	60		0	0	0	97248	0	313782	1127433		
67753	1482	40213314	1977-03-26	1977-03-26 00:00:00	1977-03-26	1977-03-26 00:00:00	1977-03-26	581452		0	0	0		0	0	0	98848	0	49	40213314		
25624	2108	19078461	1993-05-02	1993-05-02 00:00:00	1993-05-30	1993-05-30 00:00:00	1993-05-30	38000177		0	0	28		0	0	0	140359	0	310965	19078461		
48298	4005	1124300	2012-03-27	2012-03-27 00:00:00	2012-03-27	2012-03-27 00:00:00	\N	38000177		0	0	0		0	0	0	266068	0	00781178901	45011828		
58788	4883	19133873	1954-01-12	1954-01-12 00:00:00	1954-01-21	1954-01-21 00:00:00	1954-01-21	38000177		0	0	9		0	0	0	324683	0	834061	19133873		
100509	2202	40213296	2013-11-28	2013-11-28 00:00:00	2013-11-28	2013-11-28 00:00:00	2013-11-28	581452		0	0	0		0	0	0	146806	0	52	40213296		
11146	929	40229134	1942-06-13	1942-06-13 00:00:00	1942-06-20	1942-06-20 00:00:00	1942-06-20	38000177		0	0	7		0	0	0	61784	0	1043400	40229134		
21449	1762	920300	2002-12-09	2002-12-09 00:00:00	2002-12-16	2002-12-16 00:00:00	2002-12-16	38000177		0	0	7		0	0	0	117866	0	311989	920300		
30175	2501	1127433	1992-07-17	1992-07-17 00:00:00	1992-07-31	1992-07-31 00:00:00	1992-07-31	38000177		0	0	14		0	0	0	165530	0	313782	1127433		
192955	4239	40213227	1993-02-27	1993-02-27 00:00:00	1993-02-27	1993-02-27 00:00:00	1993-02-27	581452		0	0	0		0	0	0	281457	0	113	40213227		
40744	3378	40162522	2017-04-20	2017-04-20 00:00:00	2017-04-20	2017-04-20 00:00:00	\N	38000177		0	0	0		0	0	0	224120	0	857005	40162522		
49844	1092	40213160	1959-05-15	1959-05-15 00:00:00	1959-05-15	1959-05-15 00:00:00	1959-05-15	581452		0	0	0		0	0	0	71766	0	10	40213160		
29038	2402	1713671	2011-09-16	2011-09-16 00:00:00	2011-10-07	2011-10-07 00:00:00	2011-10-07	38000177		0	0	21		0	0	0	159663	0	562251	1713671		
118404	2603	40213227	2002-06-05	2002-06-05 00:00:00	2002-06-05	2002-06-05 00:00:00	2002-06-05	581452		0	0	0		0	0	0	172220	0	113	40213227		
49630	4116	19059056	1970-09-07	1970-09-07 00:00:00	1970-10-12	1970-10-12 00:00:00	1970-10-12	38000177		0	0	35		0	0	0	273674	0	243670	19059056		
37745	3119	19078461	1992-12-03	1992-12-03 00:00:00	1992-12-17	1992-12-17 00:00:00	1992-12-17	38000177		0	0	14		0	0	0	207566	0	310965	19078461		
113571	2495	40213160	1981-06-09	1981-06-09 00:00:00	1981-06-09	1981-06-09 00:00:00	1981-06-09	581452		0	0	0		0	0	0	165144	0	10	40213160		
48314	4006	1127433	1966-09-18	1966-09-18 00:00:00	1966-10-23	1966-10-23 00:00:00	1966-10-23	38000177		0	0	35		0	0	0	266144	0	313782	1127433		
18143	1504	1713671	1942-10-30	1942-10-30 00:00:00	1942-11-06	1942-11-06 00:00:00	1942-11-06	38000177		0	0	7		0	0	0	100256	0	562251	1713671		
18214	1510	19059056	1978-08-08	1978-08-08 00:00:00	1978-10-14	1978-10-14 00:00:00	1978-10-14	38000177		0	0	67		0	0	0	100789	0	243670	19059056		
4825	403	1127433	1992-11-09	1992-11-09 00:00:00	1992-11-23	1992-11-23 00:00:00	1992-11-23	38000177		0	0	14		0	0	0	26499	0	313782	1127433		
126629	2786	40213227	2014-11-01	2014-11-01 00:00:00	2014-11-01	2014-11-01 00:00:00	2014-11-01	581452		0	0	0		0	0	0	184583	0	113	40213227		
51609	4288	19006318	1954-03-10	1954-03-10 00:00:00	1954-03-24	1954-03-24 00:00:00	1954-03-24	38000177		0	0	14		0	0	0	284655	0	105078	19006318		
69958	1529	40213296	2005-06-27	2005-06-27 00:00:00	2005-06-27	2005-06-27 00:00:00	2005-06-27	581452		0	0	0		0	0	0	102347	0	52	40213296		
62178	5174	19059056	1940-12-13	1940-12-13 00:00:00	1941-01-10	1941-01-10 00:00:00	1941-01-10	38000177		0	0	28		0	0	0	344061	0	243670	19059056		
123203	2708	40213260	2007-12-03	2007-12-03 00:00:00	2007-12-03	2007-12-03 00:00:00	2007-12-03	581452		0	0	0		0	0	0	179427	0	121	40213260		
50429	4191	19129655	1961-08-25	1961-08-25 00:00:00	1961-09-08	1961-09-08 00:00:00	1961-09-08	38000177		0	0	14		0	0	0	278174	0	789980	19129655		
188794	4145	40213227	2016-07-17	2016-07-17 00:00:00	2016-07-17	2016-07-17 00:00:00	2016-07-17	581452		0	0	0		0	0	0	275491	0	113	40213227		
56646	4701	1713671	1989-06-15	1989-06-15 00:00:00	1989-12-21	1989-12-21 00:00:00	1989-12-21	38000177		0	0	189		0	0	0	313160	0	562251	1713671		
61003	5073	40231925	1967-08-19	1967-08-19 00:00:00	1967-08-19	1967-08-19 00:00:00	\N	38000177		0	0	0		0	0	0	337163	0	1049221	40231925		
55559	4613	19133905	2005-10-07	2005-10-07 00:00:00	2005-10-16	2005-10-16 00:00:00	2005-10-16	38000177		0	0	9		0	0	0	307273	0	834102	19133905		
45821	3791	1127433	2003-11-25	2003-11-25 00:00:00	2003-12-02	2003-12-02 00:00:00	2003-12-02	38000177		0	0	7		0	0	0	252057	0	313782	1127433		
27961	2314	1127433	1991-12-04	1991-12-04 00:00:00	1991-12-18	1991-12-18 00:00:00	1991-12-18	38000177		0	0	14		0	0	0	153890	0	313782	1127433		
45400	3756	1127433	1957-07-25	1957-07-25 00:00:00	1957-08-15	1957-08-15 00:00:00	1957-08-15	38000177		0	0	21		0	0	0	249712	0	313782	1127433		
45949	3804	1127433	1991-06-19	1991-06-19 00:00:00	1991-07-03	1991-07-03 00:00:00	1991-07-03	38000177		0	0	14		0	0	0	252882	0	313782	1127433		
27990	609	40213160	1968-03-19	1968-03-19 00:00:00	1968-03-19	1968-03-19 00:00:00	1968-03-19	581452		0	0	0		0	0	0	40419	0	10	40213160		
15132	1265	19128022	1995-05-03	1995-05-03 00:00:00	1996-04-27	1996-04-27 00:00:00	1996-04-27	38000177		0	0	360		0	0	0	83405	0	749785	19128022		
56078	4656	19133768	2008-06-29	2008-06-29 00:00:00	2008-06-29	2008-06-29 00:00:00	2008-06-29	38000177		0	0	0		0	0	0	310471	0	833036	19133768		
10331	864	40231925	1935-12-21	1935-12-21 00:00:00	1935-12-21	1935-12-21 00:00:00	\N	38000177		0	0	0		0	0	0	57278	0	1049221	40231925		
239234	5252	40213227	2008-12-09	2008-12-09 00:00:00	2008-12-09	2008-12-09 00:00:00	2008-12-09	581452		0	0	0		0	0	0	349426	0	113	40213227		
164775	3623	40213227	2011-02-20	2011-02-20 00:00:00	2011-02-20	2011-02-20 00:00:00	2011-02-20	581452		0	0	0		0	0	0	240921	0	113	40213227		
8751	729	19133873	1966-03-09	1966-03-09 00:00:00	1966-03-17	1966-03-17 00:00:00	1966-03-17	38000177		0	0	8		0	0	0	48367	0	834061	19133873		
20968	1727	19078924	1982-03-25	1982-03-25 00:00:00	1982-03-25	1982-03-25 00:00:00	1982-03-25	38000177		0	0	0		0	0	0	115482	0	311700	19078924		
17096	1415	1127433	2005-05-31	2005-05-31 00:00:00	2005-06-28	2005-06-28 00:00:00	2005-06-28	38000177		0	0	28		0	0	0	94226	0	313782	1127433		
212603	4662	40213201	2016-11-05	2016-11-05 00:00:00	2016-11-05	2016-11-05 00:00:00	2016-11-05	581452		0	0	0		0	0	0	310752	0	33	40213201		
27636	2287	19075601	1997-04-11	1997-04-11 00:00:00	2001-01-26	2001-01-26 00:00:00	2001-01-26	38000177		0	0	1386		0	0	0	152162	0	309362	19075601		
130173	2861	40213260	2014-12-22	2014-12-22 00:00:00	2014-12-22	2014-12-22 00:00:00	2014-12-22	581452		0	0	0		0	0	0	190243	0	121	40213260		
130223	2862	40213227	2000-12-01	2000-12-01 00:00:00	2000-12-01	2000-12-01 00:00:00	2000-12-01	581452		0	0	0		0	0	0	190308	0	113	40213227		
47069	3901	1118084	1976-06-26	1976-06-26 00:00:00	1976-06-26	1976-06-26 00:00:00	\N	38000177		0	0	0		0	0	0	259349	0	00025152531	44923712		
197354	4337	40213296	2003-10-17	2003-10-17 00:00:00	2003-10-17	2003-10-17 00:00:00	2003-10-17	581452		0	0	0		0	0	0	287633	0	52	40213296		
54739	4547	1713671	1955-12-06	1955-12-06 00:00:00	1955-12-20	1955-12-20 00:00:00	1955-12-20	38000177		0	0	14		0	0	0	302966	0	562251	1713671		
42320	3510	40173590	2015-11-27	2015-11-27 00:00:00	2015-11-27	2015-11-27 00:00:00	\N	38000177		0	0	0		0	0	0	232847	0	904419	40173590		
5760	482	1127433	1983-06-03	1983-06-03 00:00:00	1983-06-24	1983-06-24 00:00:00	1983-06-24	38000177		0	0	21		0	0	0	32229	0	313782	1127433		
127590	2806	40213227	2004-04-22	2004-04-22 00:00:00	2004-04-22	2004-04-22 00:00:00	2004-04-22	581452		0	0	0		0	0	0	185985	0	113	40213227		
50670	4210	1127433	1991-04-13	1991-04-13 00:00:00	1991-04-27	1991-04-27 00:00:00	1991-04-27	38000177		0	0	14		0	0	0	279520	0	313782	1127433		
178369	3921	40213306	2004-11-03	2004-11-03 00:00:00	2004-11-03	2004-11-03 00:00:00	2004-11-03	581452		0	0	0		0	0	0	260713	0	43	40213306		
43704	3622	40171902	1999-10-27	1999-10-27 00:00:00	1999-10-27	1999-10-27 00:00:00	\N	38000177		0	0	0		0	0	0	240697	0	897718	40171902		
30892	673	40213227	2013-09-20	2013-09-20 00:00:00	2013-09-20	2013-09-20 00:00:00	2013-09-20	581452		0	0	0		0	0	0	44508	0	113	40213227		
40451	3353	19059056	1971-06-20	1971-06-20 00:00:00	1971-07-20	1971-07-20 00:00:00	1971-07-20	38000177		0	0	30		0	0	0	222448	0	243670	19059056		
51650	4291	1115171	2017-01-27	2017-01-27 00:00:00	2017-02-26	2017-02-26 00:00:00	2017-02-26	38000177		0	0	30		0	0	0	284894	0	849574	1115171		
38705	844	40213260	2016-04-23	2016-04-23 00:00:00	2016-04-23	2016-04-23 00:00:00	2016-04-23	581452		0	0	0		0	0	0	55886	0	121	40213260		
231349	5083	40213227	2009-06-15	2009-06-15 00:00:00	2009-06-15	2009-06-15 00:00:00	2009-06-15	581452		0	0	0		0	0	0	337999	0	113	40213227		
197531	4340	40213160	1977-09-02	1977-09-02 00:00:00	1977-09-02	1977-09-02 00:00:00	1977-09-02	581452		0	0	0		0	0	0	287802	0	10	40213160		
88973	1951	40213251	1984-04-18	1984-04-18 00:00:00	1984-04-18	1984-04-18 00:00:00	1984-04-18	581452		0	0	0		0	0	0	129728	0	21	40213251		
17634	1460	19133873	1988-10-05	1988-10-05 00:00:00	1988-10-13	1988-10-13 00:00:00	1988-10-13	38000177		0	0	8		0	0	0	97315	0	834061	19133873		
67757	1482	40213160	1979-09-29	1979-09-29 00:00:00	1979-09-29	1979-09-29 00:00:00	1979-09-29	581452		0	0	0		0	0	0	98810	0	10	40213160		
25625	2108	19059056	1949-11-14	1949-11-14 00:00:00	1949-12-19	1949-12-19 00:00:00	1949-12-19	38000177		0	0	35		0	0	0	140354	0	243670	19059056		
48299	4006	1127433	1981-08-17	1981-08-17 00:00:00	1981-08-31	1981-08-31 00:00:00	1981-08-31	38000177		0	0	14		0	0	0	266139	0	313782	1127433		
58790	4883	19059056	1947-06-14	1947-06-14 00:00:00	1947-06-28	1947-06-28 00:00:00	1947-06-28	38000177		0	0	14		0	0	0	324638	0	243670	19059056		
100510	2202	40213227	2005-11-17	2005-11-17 00:00:00	2005-11-17	2005-11-17 00:00:00	2005-11-17	581452		0	0	0		0	0	0	146797	0	113	40213227		
65945	1443	40213160	1977-12-02	1977-12-02 00:00:00	1977-12-02	1977-12-02 00:00:00	1977-12-02	581452		0	0	0		0	0	0	96230	0	10	40213160		
21450	1762	19075601	2002-12-26	2002-12-26 00:00:00	2002-12-26	2002-12-26 00:00:00	2002-12-26	38000177		0	0	0		0	0	0	117866	0	309362	19075601		
30176	2501	19059056	1979-05-09	1979-05-09 00:00:00	1979-05-30	1979-05-30 00:00:00	1979-05-30	38000177		0	0	21		0	0	0	165575	0	243670	19059056		
204249	4484	40213160	1955-07-21	1955-07-21 00:00:00	1955-07-21	1955-07-21 00:00:00	1955-07-21	581452		0	0	0		0	0	0	298535	0	10	40213160		
40745	3378	1713671	1989-04-06	1989-04-06 00:00:00	1989-04-20	1989-04-20 00:00:00	1989-04-20	38000177		0	0	14		0	0	0	224117	0	562251	1713671		
77156	1686	40213160	1961-06-25	1961-06-25 00:00:00	1961-06-25	1961-06-25 00:00:00	1961-06-25	581452		0	0	0		0	0	0	112976	0	10	40213160		
29039	2402	1127433	1980-02-26	1980-02-26 00:00:00	1980-03-04	1980-03-04 00:00:00	1980-03-04	38000177		0	0	7		0	0	0	159574	0	313782	1127433		
118405	2603	40213296	2002-06-05	2002-06-05 00:00:00	2002-06-05	2002-06-05 00:00:00	2002-06-05	581452		0	0	0		0	0	0	172220	0	52	40213296		
49631	4116	1115171	1994-03-01	1994-03-01 00:00:00	1994-03-15	1994-03-15 00:00:00	1994-03-15	38000177		0	0	14		0	0	0	273676	0	849574	1115171		
37746	3119	1127433	1997-09-12	1997-09-12 00:00:00	1997-10-03	1997-10-03 00:00:00	1997-10-03	38000177		0	0	21		0	0	0	207538	0	313782	1127433		
108831	2387	40213227	2000-09-16	2000-09-16 00:00:00	2000-09-16	2000-09-16 00:00:00	2000-09-16	581452		0	0	0		0	0	0	158789	0	113	40213227		
166497	3660	40213314	1977-07-02	1977-07-02 00:00:00	1977-07-02	1977-07-02 00:00:00	1977-07-02	581452		0	0	0		0	0	0	243574	0	49	40213314		
18144	1504	1127433	1957-04-01	1957-04-01 00:00:00	1957-06-30	1957-06-30 00:00:00	1957-06-30	38000177		0	0	90		0	0	0	100255	0	313782	1127433		
18215	1510	40229134	1995-05-12	1995-05-12 00:00:00	1995-05-26	1995-05-26 00:00:00	1995-05-26	38000177		0	0	14		0	0	0	100808	0	1043400	40229134		
4826	403	1118084	1962-01-03	1962-01-03 00:00:00	1962-01-03	1962-01-03 00:00:00	\N	38000177		0	0	0		0	0	0	26421	0	00025152531	44923712		
117116	2574	40213160	1961-09-13	1961-09-13 00:00:00	1961-09-13	1961-09-13 00:00:00	1961-09-13	581452		0	0	0		0	0	0	170462	0	10	40213160		
51610	4288	19133873	1960-08-22	1960-08-22 00:00:00	1960-08-31	1960-08-31 00:00:00	1960-08-31	38000177		0	0	9		0	0	0	284698	0	834061	19133873		
69960	1529	40213227	2005-06-27	2005-06-27 00:00:00	2005-06-27	2005-06-27 00:00:00	2005-06-27	581452		0	0	0		0	0	0	102347	0	113	40213227		
62179	5174	1127433	2010-08-20	2010-08-20 00:00:00	2010-09-03	2010-09-03 00:00:00	2010-09-03	38000177		0	0	14		0	0	0	344018	0	313782	1127433		
123215	2708	40213160	1955-05-16	1955-05-16 00:00:00	1955-05-16	1955-05-16 00:00:00	1955-05-16	581452		0	0	0		0	0	0	179359	0	10	40213160		
50430	4191	1332419	2010-09-03	2010-09-03 00:00:00	2010-09-03	2010-09-03 00:00:00	\N	38000177		0	0	0		0	0	0	278166	0	197361	1332419		
188797	4145	40213227	1996-12-08	1996-12-08 00:00:00	1996-12-08	1996-12-08 00:00:00	1996-12-08	581452		0	0	0		0	0	0	275556	0	113	40213227		
56647	4701	40220960	2015-04-03	2015-04-03 00:00:00	2015-04-03	2015-04-03 00:00:00	2015-04-03	38000177		0	0	0		0	0	0	313191	0	1804799	40220960		
61004	5073	19126352	2009-08-29	2009-08-29 00:00:00	2009-08-29	2009-08-29 00:00:00	\N	38000177		0	0	0		0	0	0	337182	0	705129	19126352		
55561	4613	1127433	2018-05-21	2018-05-21 00:00:00	2018-06-04	2018-06-04 00:00:00	2018-06-04	38000177		0	0	14		0	0	0	307317	0	313782	1127433		
45822	3791	1713671	1955-09-02	1955-09-02 00:00:00	1955-09-23	1955-09-23 00:00:00	1955-09-23	38000177		0	0	21		0	0	0	252038	0	562251	1713671		
27962	2315	1124300	2012-04-11	2012-04-11 00:00:00	2012-04-11	2012-04-11 00:00:00	\N	38000177		0	0	0		0	0	0	153950	0	00781178901	45011828		
45401	3756	1127078	1950-07-02	1950-07-02 00:00:00	1950-08-01	1950-08-01 00:00:00	1950-08-01	38000177		0	0	30		0	0	0	249710	0	282464	1127078		
45950	3804	1127078	1971-08-02	1971-08-02 00:00:00	1971-08-23	1971-08-23 00:00:00	1971-08-23	38000177		0	0	21		0	0	0	252858	0	282464	1127078		
27993	609	40213306	1990-02-13	1990-02-13 00:00:00	1990-02-13	1990-02-13 00:00:00	1990-02-13	581452		0	0	0		0	0	0	40426	0	43	40213306		
15133	1265	1713671	2008-02-09	2008-02-09 00:00:00	2008-02-16	2008-02-16 00:00:00	2008-02-16	38000177		0	0	7		0	0	0	83422	0	562251	1713671		
56079	4656	1545959	2008-06-29	2008-06-29 00:00:00	2008-06-29	2008-06-29 00:00:00	2008-06-29	38000177		0	0	0		0	0	0	310471	0	259255	1545959		
10332	864	1115171	1997-08-03	1997-08-03 00:00:00	1997-08-31	1997-08-31 00:00:00	1997-08-31	38000177		0	0	28		0	0	0	57325	0	849574	1115171		
239236	5252	40213260	2008-12-09	2008-12-09 00:00:00	2008-12-09	2008-12-09 00:00:00	2008-12-09	581452		0	0	0		0	0	0	349426	0	121	40213260		
164781	3623	40213198	2015-03-15	2015-03-15 00:00:00	2015-03-15	2015-03-15 00:00:00	2015-03-15	581452		0	0	0		0	0	0	240900	0	133	40213198		
8752	729	19059056	1972-02-04	1972-02-04 00:00:00	1972-02-18	1972-02-18 00:00:00	1972-02-18	38000177		0	0	14		0	0	0	48404	0	243670	19059056		
20969	1727	19133873	1954-02-05	1954-02-05 00:00:00	1954-02-13	1954-02-13 00:00:00	1954-02-13	38000177		0	0	8		0	0	0	115524	0	834061	19133873		
17097	1415	1124300	2002-12-09	2002-12-09 00:00:00	2002-12-09	2002-12-09 00:00:00	\N	38000177		0	0	0		0	0	0	94198	0	00781178901	45011828		
76551	1672	40213296	1996-07-17	1996-07-17 00:00:00	1996-07-17	1996-07-17 00:00:00	1996-07-17	581452		0	0	0		0	0	0	112264	0	52	40213296		
27637	2289	19059056	1964-11-24	1964-11-24 00:00:00	1965-01-23	1965-01-23 00:00:00	1965-01-23	38000177		0	0	60		0	0	0	152250	0	243670	19059056		
130182	2861	40213296	2006-07-17	2006-07-17 00:00:00	2006-07-17	2006-07-17 00:00:00	2006-07-17	581452		0	0	0		0	0	0	190232	0	52	40213296		
130226	2862	40213160	1968-02-02	1968-02-02 00:00:00	1968-02-02	1968-02-02 00:00:00	1968-02-02	581452		0	0	0		0	0	0	190286	0	10	40213160		
47070	3901	19074679	1936-03-18	1936-03-18 00:00:00	1936-11-18	1936-11-18 00:00:00	1936-11-18	38000177		0	0	245		0	0	0	259382	0	308971	19074679		
197356	4337	40213227	2003-10-17	2003-10-17 00:00:00	2003-10-17	2003-10-17 00:00:00	2003-10-17	581452		0	0	0		0	0	0	287633	0	113	40213227		
54740	4547	19059056	1933-09-12	1933-09-12 00:00:00	1933-09-26	1933-09-26 00:00:00	1933-09-26	38000177		0	0	14		0	0	0	302957	0	243670	19059056		
42321	3510	1127433	1975-08-05	1975-08-05 00:00:00	1975-08-19	1975-08-19 00:00:00	1975-08-19	38000177		0	0	14		0	0	0	232913	0	313782	1127433		
5761	482	19128022	1994-08-23	1994-08-23 00:00:00	1995-08-18	1995-08-18 00:00:00	1995-08-18	38000177		0	0	360		0	0	0	32220	0	749785	19128022		
127591	2806	40213160	1956-03-22	1956-03-22 00:00:00	1956-03-22	1956-03-22 00:00:00	1956-03-22	581452		0	0	0		0	0	0	185965	0	10	40213160		
50671	4210	40229134	2007-02-02	2007-02-02 00:00:00	2007-02-16	2007-02-16 00:00:00	2007-02-16	38000177		0	0	14		0	0	0	279523	0	1043400	40229134		
178372	3921	40213227	2014-03-12	2014-03-12 00:00:00	2014-03-12	2014-03-12 00:00:00	2014-03-12	581452		0	0	0		0	0	0	260749	0	113	40213227		
43705	3622	19018935	1999-10-27	1999-10-27 00:00:00	1999-10-27	1999-10-27 00:00:00	\N	38000177		0	0	0		0	0	0	240697	0	197604	19018935		
30898	673	40213160	1961-12-29	1961-12-29 00:00:00	1961-12-29	1961-12-29 00:00:00	1961-12-29	581452		0	0	0		0	0	0	44526	0	10	40213160		
40452	3353	40162522	1971-06-20	1971-06-20 00:00:00	1971-06-20	1971-06-20 00:00:00	\N	38000177		0	0	0		0	0	0	222448	0	857005	40162522		
51651	4291	46233988	1974-02-21	1974-02-21 00:00:00	1974-03-07	1974-03-07 00:00:00	1974-03-07	38000177		0	0	14		0	0	0	284904	0	1652673	46233988		
38707	844	40213306	1988-07-02	1988-07-02 00:00:00	1988-07-02	1988-07-02 00:00:00	1988-07-02	581452		0	0	0		0	0	0	55906	0	43	40213306		
231358	5083	40213201	2014-07-14	2014-07-14 00:00:00	2014-07-14	2014-07-14 00:00:00	2014-07-14	581452		0	0	0		0	0	0	338076	0	33	40213201		
197535	4340	40213227	1995-02-10	1995-02-10 00:00:00	1995-02-10	1995-02-10 00:00:00	1995-02-10	581452		0	0	0		0	0	0	287758	0	113	40213227		
17902	387	40213227	1995-11-03	1995-11-03 00:00:00	1995-11-03	1995-11-03 00:00:00	1995-11-03	581452		0	0	0		0	0	0	25469	0	113	40213227		
17635	1460	19078461	1999-10-07	1999-10-07 00:00:00	1999-10-21	1999-10-21 00:00:00	1999-10-21	38000177		0	0	14		0	0	0	97304	0	310965	19078461		
67762	1482	40213160	1975-01-25	1975-01-25 00:00:00	1975-01-25	1975-01-25 00:00:00	1975-01-25	581452		0	0	0		0	0	0	98902	0	10	40213160		
25626	2108	1127433	1951-09-26	1951-09-26 00:00:00	1951-10-10	1951-10-10 00:00:00	1951-10-10	38000177		0	0	14		0	0	0	140313	0	313782	1127433		
48300	4006	1124300	1994-12-25	1994-12-25 00:00:00	1994-12-25	1994-12-25 00:00:00	\N	38000177		0	0	0		0	0	0	266162	0	00781178901	45011828		
58791	4883	19006318	1947-06-14	1947-06-14 00:00:00	1947-06-28	1947-06-28 00:00:00	1947-06-28	38000177		0	0	14		0	0	0	324638	0	105078	19006318		
100513	2202	40213160	1974-06-20	1974-06-20 00:00:00	1974-06-20	1974-06-20 00:00:00	1974-06-20	581452		0	0	0		0	0	0	146758	0	10	40213160		
65947	1443	40213227	1999-06-05	1999-06-05 00:00:00	1999-06-05	1999-06-05 00:00:00	1999-06-05	581452		0	0	0		0	0	0	96219	0	113	40213227		
21451	1762	40220960	2002-12-26	2002-12-26 00:00:00	2002-12-26	2002-12-26 00:00:00	2002-12-26	38000177		0	0	0		0	0	0	117866	0	1804799	40220960		
30177	2501	19059056	1966-08-28	1966-08-28 00:00:00	1966-09-11	1966-09-11 00:00:00	1966-09-11	38000177		0	0	14		0	0	0	165541	0	243670	19059056		
211440	4636	40213227	2007-08-21	2007-08-21 00:00:00	2007-08-21	2007-08-21 00:00:00	2007-08-21	581452		0	0	0		0	0	0	309000	0	113	40213227		
40746	3378	40229134	2000-06-12	2000-06-12 00:00:00	2000-06-26	2000-06-26 00:00:00	2000-06-26	38000177		0	0	14		0	0	0	224150	0	1043400	40229134		
77160	1686	40213160	1966-02-27	1966-02-27 00:00:00	1966-02-27	1966-02-27 00:00:00	1966-02-27	581452		0	0	0		0	0	0	112957	0	10	40213160		
29040	2402	1127078	1983-03-11	1983-03-11 00:00:00	1983-04-08	1983-04-08 00:00:00	1983-04-08	38000177		0	0	28		0	0	0	159668	0	282464	1127078		
118410	2604	40213160	1956-11-17	1956-11-17 00:00:00	1956-11-17	1956-11-17 00:00:00	1956-11-17	581452		0	0	0		0	0	0	172259	0	10	40213160		
49632	4116	1713671	1969-11-17	1969-11-17 00:00:00	1969-12-01	1969-12-01 00:00:00	1969-12-01	38000177		0	0	14		0	0	0	273650	0	562251	1713671		
37776	3123	1127433	1989-10-03	1989-10-03 00:00:00	1989-10-17	1989-10-17 00:00:00	1989-10-17	38000177		0	0	14		0	0	0	207768	0	313782	1127433		
48790	4044	1127433	1971-03-18	1971-03-18 00:00:00	1971-03-25	1971-03-25 00:00:00	1971-03-25	38000177		0	0	7		0	0	0	268948	0	313782	1127433		
166502	3660	40213227	2014-07-19	2014-07-19 00:00:00	2014-07-19	2014-07-19 00:00:00	2014-07-19	581452		0	0	0		0	0	0	243582	0	113	40213227		
18145	1504	40231925	1957-04-01	1957-04-01 00:00:00	1957-04-01	1957-04-01 00:00:00	\N	38000177		0	0	0		0	0	0	100255	0	1049221	40231925		
18216	1510	1115171	2010-01-29	2010-01-29 00:00:00	2010-02-26	2010-02-26 00:00:00	2010-02-26	38000177		0	0	28		0	0	0	100793	0	849574	1115171		
4827	403	1127433	1929-02-11	1929-02-11 00:00:00	1929-02-18	1929-02-18 00:00:00	1929-02-18	38000177		0	0	7		0	0	0	26538	0	313782	1127433		
117120	2574	40213260	2011-01-04	2011-01-04 00:00:00	2011-01-04	2011-01-04 00:00:00	2011-01-04	581452		0	0	0		0	0	0	170505	0	121	40213260		
51611	4288	1127433	2000-08-08	2000-08-08 00:00:00	2000-08-15	2000-08-15 00:00:00	2000-08-15	38000177		0	0	7		0	0	0	284651	0	313782	1127433		
69966	1529	40213160	1962-12-10	1962-12-10 00:00:00	1962-12-10	1962-12-10 00:00:00	1962-12-10	581452		0	0	0		0	0	0	102306	0	10	40213160		
62180	5174	19059056	1947-02-08	1947-02-08 00:00:00	1947-03-10	1947-03-10 00:00:00	1947-03-10	38000177		0	0	30		0	0	0	344063	0	243670	19059056		
123222	2708	40213227	2005-11-21	2005-11-21 00:00:00	2005-11-21	2005-11-21 00:00:00	2005-11-21	581452		0	0	0		0	0	0	179387	0	113	40213227		
50431	4191	1539411	2010-09-03	2010-09-03 00:00:00	2010-09-03	2010-09-03 00:00:00	\N	38000177		0	0	0		0	0	0	278166	0	312961	1539411		
188798	4145	40213306	1996-12-08	1996-12-08 00:00:00	1996-12-08	1996-12-08 00:00:00	1996-12-08	581452		0	0	0		0	0	0	275556	0	43	40213306		
56648	4701	19075601	2015-04-03	2015-04-03 00:00:00	2015-04-03	2015-04-03 00:00:00	2015-04-03	38000177		0	0	0		0	0	0	313191	0	309362	19075601		
61005	5073	19075601	2009-08-29	2009-08-29 00:00:00	2009-08-29	2009-08-29 00:00:00	\N	38000177		0	0	0		0	0	0	337182	0	309362	19075601		
55562	4613	19133679	2006-01-11	2006-01-11 00:00:00	2007-01-06	2007-01-06 00:00:00	2007-01-06	38000177		0	0	360		0	0	0	307323	0	831533	19133679		
45829	3793	1713671	2012-08-24	2012-08-24 00:00:00	2012-08-31	2012-08-31 00:00:00	2012-08-31	38000177		0	0	7		0	0	0	252255	0	562251	1713671		
27963	2315	19073188	1989-10-09	1989-10-09 00:00:00	1989-10-23	1989-10-23 00:00:00	1989-10-23	38000177		0	0	14		0	0	0	153929	0	308192	19073188		
45402	3756	19133873	1948-09-07	1948-09-07 00:00:00	1948-09-16	1948-09-16 00:00:00	1948-09-16	38000177		0	0	9		0	0	0	249668	0	834061	19133873		
45951	3804	19059056	1978-11-14	1978-11-14 00:00:00	1978-12-19	1978-12-19 00:00:00	1978-12-19	38000177		0	0	35		0	0	0	252859	0	243670	19059056		
27999	609	40213160	1972-11-21	1972-11-21 00:00:00	1972-11-21	1972-11-21 00:00:00	1972-11-21	581452		0	0	0		0	0	0	40443	0	10	40213160		
15134	1265	1713671	2001-05-17	2001-05-17 00:00:00	2001-06-07	2001-06-07 00:00:00	2001-06-07	38000177		0	0	21		0	0	0	83415	0	562251	1713671		
56080	4656	1713671	2008-10-29	2008-10-29 00:00:00	2008-11-05	2008-11-05 00:00:00	2008-11-05	38000177		0	0	7		0	0	0	310427	0	562251	1713671		
10333	864	1127433	2002-07-14	2002-07-14 00:00:00	2002-07-21	2002-07-21 00:00:00	2002-07-21	38000177		0	0	7		0	0	0	57302	0	313782	1127433		
239241	5252	40213160	1958-08-12	1958-08-12 00:00:00	1958-08-12	1958-08-12 00:00:00	1958-08-12	581452		0	0	0		0	0	0	349438	0	10	40213160		
101198	2218	40213314	1979-07-31	1979-07-31 00:00:00	1979-07-31	1979-07-31 00:00:00	1979-07-31	581452		0	0	0		0	0	0	147711	0	49	40213314		
8753	730	1124300	2002-11-18	2002-11-18 00:00:00	2002-11-18	2002-11-18 00:00:00	\N	38000177		0	0	0		0	0	0	48452	0	00781178901	45011828		
20971	1727	19078461	2012-11-06	2012-11-06 00:00:00	2012-11-27	2012-11-27 00:00:00	2012-11-27	38000177		0	0	21		0	0	0	115474	0	310965	19078461		
17098	1415	40162522	2004-06-05	2004-06-05 00:00:00	2004-06-05	2004-06-05 00:00:00	\N	38000177		0	0	0		0	0	0	94213	0	857005	40162522		
76554	1672	40213160	1955-04-06	1955-04-06 00:00:00	1955-04-06	1955-04-06 00:00:00	1955-04-06	581452		0	0	0		0	0	0	112268	0	10	40213160		
27638	2289	40173590	2009-12-29	2009-12-29 00:00:00	2009-12-29	2009-12-29 00:00:00	\N	38000177		0	0	0		0	0	0	152245	0	904419	40173590		
130188	2861	40213260	2013-12-16	2013-12-16 00:00:00	2013-12-16	2013-12-16 00:00:00	2013-12-16	581452		0	0	0		0	0	0	190222	0	121	40213260		
130227	2862	40213160	1967-12-01	1967-12-01 00:00:00	1967-12-01	1967-12-01 00:00:00	1967-12-01	581452		0	0	0		0	0	0	190276	0	10	40213160		
47071	3901	19059056	1943-01-25	1943-01-25 00:00:00	1943-02-15	1943-02-15 00:00:00	1943-02-15	38000177		0	0	21		0	0	0	259384	0	243670	19059056		
197365	4337	40213306	1984-03-23	1984-03-23 00:00:00	1984-03-23	1984-03-23 00:00:00	1984-03-23	581452		0	0	0		0	0	0	287632	0	43	40213306		
54741	4547	1713671	1966-06-30	1966-06-30 00:00:00	1966-07-14	1966-07-14 00:00:00	1966-07-14	38000177		0	0	14		0	0	0	302967	0	562251	1713671		
42322	3510	1127433	1982-04-19	1982-04-19 00:00:00	1982-05-03	1982-05-03 00:00:00	1982-05-03	38000177		0	0	14		0	0	0	232799	0	313782	1127433		
5762	482	1118084	2008-09-28	2008-09-28 00:00:00	2008-09-28	2008-09-28 00:00:00	\N	38000177		0	0	0		0	0	0	32212	0	00025152531	44923712		
127602	2806	40213227	1995-04-27	1995-04-27 00:00:00	1995-04-27	1995-04-27 00:00:00	1995-04-27	581452		0	0	0		0	0	0	185932	0	113	40213227		
50672	4210	19078461	1995-10-06	1995-10-06 00:00:00	1995-11-10	1995-11-10 00:00:00	1995-11-10	38000177		0	0	35		0	0	0	279551	0	310965	19078461		
178380	3921	40213160	1982-02-17	1982-02-17 00:00:00	1982-02-17	1982-02-17 00:00:00	1982-02-17	581452		0	0	0		0	0	0	260741	0	10	40213160		
43706	3622	40163554	1999-10-27	1999-10-27 00:00:00	1999-10-27	1999-10-27 00:00:00	\N	38000177		0	0	0		0	0	0	240697	0	855332	40163554		
30901	673	40213160	1962-03-02	1962-03-02 00:00:00	1962-03-02	1962-03-02 00:00:00	1962-03-02	581452		0	0	0		0	0	0	44421	0	10	40213160		
40453	3353	40229134	1976-11-01	1976-11-01 00:00:00	1976-11-08	1976-11-08 00:00:00	1976-11-08	38000177		0	0	7		0	0	0	222382	0	1043400	40229134		
51652	4291	1127078	1974-02-21	1974-02-21 00:00:00	1974-03-07	1974-03-07 00:00:00	1974-03-07	38000177		0	0	14		0	0	0	284904	0	282464	1127078		
38709	844	40213306	1989-04-08	1989-04-08 00:00:00	1989-04-08	1989-04-08 00:00:00	1989-04-08	581452		0	0	0		0	0	0	55907	0	43	40213306		
231360	5083	40213160	1955-11-14	1955-11-14 00:00:00	1955-11-14	1955-11-14 00:00:00	1955-11-14	581452		0	0	0		0	0	0	338059	0	10	40213160		
197536	4340	40213306	1995-02-10	1995-02-10 00:00:00	1995-02-10	1995-02-10 00:00:00	1995-02-10	581452		0	0	0		0	0	0	287758	0	43	40213306		
17903	387	40213306	1995-11-03	1995-11-03 00:00:00	1995-11-03	1995-11-03 00:00:00	1995-11-03	581452		0	0	0		0	0	0	25469	0	43	40213306		
17636	1460	1127433	1991-01-30	1991-01-30 00:00:00	1991-02-06	1991-02-06 00:00:00	1991-02-06	38000177		0	0	7		0	0	0	97279	0	313782	1127433		
67767	1482	40213306	1996-11-09	1996-11-09 00:00:00	1996-11-09	1996-11-09 00:00:00	1996-11-09	581452		0	0	0		0	0	0	98814	0	43	40213306		
25627	2108	1115171	2017-07-23	2017-07-23 00:00:00	2017-09-21	2017-09-21 00:00:00	2017-09-21	38000177		0	0	60		0	0	0	140360	0	849574	1115171		
48301	4006	19133905	1993-07-12	1993-07-12 00:00:00	1993-07-19	1993-07-19 00:00:00	1993-07-19	38000177		0	0	7		0	0	0	266162	0	834102	19133905		
58792	4883	1127433	2004-08-23	2004-08-23 00:00:00	2004-08-30	2004-08-30 00:00:00	2004-08-30	38000177		0	0	7		0	0	0	324642	0	313782	1127433		
65879	1442	40213201	2012-05-08	2012-05-08 00:00:00	2012-05-08	2012-05-08 00:00:00	2012-05-08	581452		0	0	0		0	0	0	96116	0	33	40213201		
65948	1443	40213306	1999-06-05	1999-06-05 00:00:00	1999-06-05	1999-06-05 00:00:00	1999-06-05	581452		0	0	0		0	0	0	96219	0	43	40213306		
21461	1764	1118084	1996-12-12	1996-12-12 00:00:00	1996-12-12	1996-12-12 00:00:00	\N	38000177		0	0	0		0	0	0	117957	0	00025152531	44923712		
30178	2501	19006318	1966-08-28	1966-08-28 00:00:00	1966-09-11	1966-09-11 00:00:00	1966-09-11	38000177		0	0	14		0	0	0	165541	0	105078	19006318		
211461	4636	40213198	2011-09-13	2011-09-13 00:00:00	2011-09-13	2011-09-13 00:00:00	2011-09-13	581452		0	0	0		0	0	0	309002	0	133	40213198		
40747	3378	1127078	1959-12-07	1959-12-07 00:00:00	1959-12-21	1959-12-21 00:00:00	1959-12-21	38000177		0	0	14		0	0	0	224153	0	282464	1127078		
77169	1686	40213296	2004-05-23	2004-05-23 00:00:00	2004-05-23	2004-05-23 00:00:00	2004-05-23	581452		0	0	0		0	0	0	112982	0	52	40213296		
29041	2402	19006318	1977-07-10	1977-07-10 00:00:00	1977-07-24	1977-07-24 00:00:00	1977-07-24	38000177		0	0	14		0	0	0	159625	0	105078	19006318		
118422	2604	40213227	2007-03-17	2007-03-17 00:00:00	2007-03-17	2007-03-17 00:00:00	2007-03-17	581452		0	0	0		0	0	0	172252	0	113	40213227		
49633	4116	1127433	2008-12-23	2008-12-23 00:00:00	2008-12-30	2008-12-30 00:00:00	2008-12-30	38000177		0	0	7		0	0	0	273615	0	313782	1127433		
37777	3123	1150771	1978-02-19	1978-02-19 00:00:00	1978-02-19	1978-02-19 00:00:00	\N	38000177		0	0	0		0	0	0	207805	0	197378	1150771		
48791	4044	1127433	1973-03-09	1973-03-09 00:00:00	1973-03-16	1973-03-16 00:00:00	1973-03-16	38000177		0	0	7		0	0	0	268970	0	313782	1127433		
166503	3660	40213296	2014-07-19	2014-07-19 00:00:00	2014-07-19	2014-07-19 00:00:00	2014-07-19	581452		0	0	0		0	0	0	243582	0	52	40213296		
18146	1504	1118084	1985-01-15	1985-01-15 00:00:00	1985-01-15	1985-01-15 00:00:00	\N	38000177		0	0	0		0	0	0	100286	0	00025152531	44923712		
18217	1510	1127078	1959-10-28	1959-10-28 00:00:00	1959-11-11	1959-11-11 00:00:00	1959-11-11	38000177		0	0	14		0	0	0	100863	0	282464	1127078		
4828	403	19133905	1983-01-31	1983-01-31 00:00:00	1983-02-08	1983-02-08 00:00:00	1983-02-08	38000177		0	0	8		0	0	0	26436	0	834102	19133905		
117122	2574	40213296	2001-01-09	2001-01-09 00:00:00	2001-01-09	2001-01-09 00:00:00	2001-01-09	581452		0	0	0		0	0	0	170484	0	52	40213296		
51612	4288	1118084	1994-09-17	1994-09-17 00:00:00	1994-09-17	1994-09-17 00:00:00	\N	38000177		0	0	0		0	0	0	284732	0	00025152531	44923712		
69967	1529	40213260	2014-05-12	2014-05-12 00:00:00	2014-05-12	2014-05-12 00:00:00	2014-05-12	581452		0	0	0		0	0	0	102350	0	121	40213260		
62181	5174	19059056	1944-12-20	1944-12-20 00:00:00	1945-02-18	1945-02-18 00:00:00	1945-02-18	38000177		0	0	60		0	0	0	344062	0	243670	19059056		
75932	1658	40213227	1993-02-01	1993-02-01 00:00:00	1993-02-01	1993-02-01 00:00:00	1993-02-01	581452		0	0	0		0	0	0	111363	0	113	40213227		
50432	4191	40236824	2010-09-11	2010-09-11 00:00:00	2010-09-18	2010-09-18 00:00:00	2010-09-18	38000177		0	0	7		0	0	0	278166	0	1094107	40236824		
188800	4145	40213314	1978-06-11	1978-06-11 00:00:00	1978-06-11	1978-06-11 00:00:00	1978-06-11	581452		0	0	0		0	0	0	275552	0	49	40213314		
56649	4701	1127433	1990-07-04	1990-07-04 00:00:00	1990-07-25	1990-07-25 00:00:00	1990-07-25	38000177		0	0	21		0	0	0	313172	0	313782	1127433		
61006	5073	1539411	2009-08-29	2009-08-29 00:00:00	2009-08-29	2009-08-29 00:00:00	\N	38000177		0	0	0		0	0	0	337182	0	312961	1539411		
55563	4613	40224805	1993-03-13	1993-03-13 00:00:00	1994-03-08	1994-03-08 00:00:00	1994-03-08	38000177		0	0	360		0	0	0	307319	0	1000126	40224805		
45830	3793	1118084	1982-11-07	1982-11-07 00:00:00	1982-11-07	1982-11-07 00:00:00	\N	38000177		0	0	0		0	0	0	252289	0	00025152531	44923712		
27964	2315	1127433	1989-10-09	1989-10-09 00:00:00	1989-10-23	1989-10-23 00:00:00	1989-10-23	38000177		0	0	14		0	0	0	153929	0	313782	1127433		
45403	3756	19059056	1960-11-25	1960-11-25 00:00:00	1960-12-16	1960-12-16 00:00:00	1960-12-16	38000177		0	0	21		0	0	0	249714	0	243670	19059056		
45952	3804	1713671	1999-08-11	1999-08-11 00:00:00	1999-08-18	1999-08-18 00:00:00	1999-08-18	38000177		0	0	7		0	0	0	252883	0	562251	1713671		
28006	609	40213296	2007-12-18	2007-12-18 00:00:00	2007-12-18	2007-12-18 00:00:00	2007-12-18	581452		0	0	0		0	0	0	40449	0	52	40213296		
15135	1265	1713671	1994-02-08	1994-02-08 00:00:00	1994-02-15	1994-02-15 00:00:00	1994-02-15	38000177		0	0	7		0	0	0	83404	0	562251	1713671		
56081	4656	19059056	1951-08-02	1951-08-02 00:00:00	1951-08-16	1951-08-16 00:00:00	1951-08-16	38000177		0	0	14		0	0	0	310453	0	243670	19059056		
10334	864	40223774	1997-07-31	1997-07-31 00:00:00	1997-07-31	1997-07-31 00:00:00	\N	38000177		0	0	0		0	0	0	57263	0	998582	40223774		
239243	5252	40213160	1958-05-13	1958-05-13 00:00:00	1958-05-13	1958-05-13 00:00:00	1958-05-13	581452		0	0	0		0	0	0	349462	0	10	40213160		
101202	2218	40213251	1984-05-08	1984-05-08 00:00:00	1984-05-08	1984-05-08 00:00:00	1984-05-08	581452		0	0	0		0	0	0	147725	0	21	40213251		
8754	730	19059056	1965-11-02	1965-11-02 00:00:00	1965-12-02	1965-12-02 00:00:00	1965-12-02	38000177		0	0	30		0	0	0	48502	0	243670	19059056		
20972	1727	1118084	1991-12-10	1991-12-10 00:00:00	1991-12-10	1991-12-10 00:00:00	\N	38000177		0	0	0		0	0	0	115556	0	00025152531	44923712		
27557	2283	1115171	2017-09-07	2017-09-07 00:00:00	2017-10-07	2017-10-07 00:00:00	2017-10-07	38000177		0	0	30		0	0	0	151885	0	849574	1115171		
76558	1672	40213227	2015-01-14	2015-01-14 00:00:00	2015-01-14	2015-01-14 00:00:00	2015-01-14	581452		0	0	0		0	0	0	112291	0	113	40213227		
27639	2289	1127433	1977-04-29	1977-04-29 00:00:00	1977-05-06	1977-05-06 00:00:00	1977-05-06	38000177		0	0	7		0	0	0	152267	0	313782	1127433		
130201	2862	40213306	1990-08-11	1990-08-11 00:00:00	1990-08-11	1990-08-11 00:00:00	1990-08-11	581452		0	0	0		0	0	0	190304	0	43	40213306		
130233	2862	40213227	2008-10-18	2008-10-18 00:00:00	2008-10-18	2008-10-18 00:00:00	2008-10-18	581452		0	0	0		0	0	0	190258	0	113	40213227		
47072	3901	1127433	1942-11-14	1942-11-14 00:00:00	1942-11-21	1942-11-21 00:00:00	1942-11-21	38000177		0	0	7		0	0	0	259425	0	313782	1127433		
197369	4337	40213227	1993-10-01	1993-10-01 00:00:00	1993-10-01	1993-10-01 00:00:00	1993-10-01	581452		0	0	0		0	0	0	287608	0	113	40213227		
54742	4547	1124300	1948-08-24	1948-08-24 00:00:00	1948-08-24	1948-08-24 00:00:00	\N	38000177		0	0	0		0	0	0	302901	0	00781178901	45011828		
42323	3510	40229134	1983-01-22	1983-01-22 00:00:00	1983-02-05	1983-02-05 00:00:00	1983-02-05	38000177		0	0	14		0	0	0	232859	0	1043400	40229134		
5763	482	1127433	1985-07-03	1985-07-03 00:00:00	1985-07-10	1985-07-10 00:00:00	1985-07-10	38000177		0	0	7		0	0	0	32257	0	313782	1127433		
127615	2806	40213296	1997-05-01	1997-05-01 00:00:00	1997-05-01	1997-05-01 00:00:00	1997-05-01	581452		0	0	0		0	0	0	185984	0	52	40213296		
50673	4210	19059056	1986-01-07	1986-01-07 00:00:00	1986-01-21	1986-01-21 00:00:00	1986-01-21	38000177		0	0	14		0	0	0	279542	0	243670	19059056		
178381	3921	40213314	1982-02-17	1982-02-17 00:00:00	1982-02-17	1982-02-17 00:00:00	1982-02-17	581452		0	0	0		0	0	0	260741	0	49	40213314		
43707	3622	1118084	1964-11-29	1964-11-29 00:00:00	1964-11-29	1964-11-29 00:00:00	\N	38000177		0	0	0		0	0	0	240832	0	00025152531	44923712		
30904	673	40213260	2012-09-14	2012-09-14 00:00:00	2012-09-14	2012-09-14 00:00:00	2012-09-14	581452		0	0	0		0	0	0	44479	0	121	40213260		
40454	3353	19059056	1943-10-19	1943-10-19 00:00:00	1943-11-09	1943-11-09 00:00:00	1943-11-09	38000177		0	0	21		0	0	0	222425	0	243670	19059056		
51653	4291	19019979	1978-09-28	1978-09-28 00:00:00	1978-12-27	1978-12-27 00:00:00	1978-12-27	38000177		0	0	90		0	0	0	284892	0	198405	19019979		
72208	1578	40213227	1998-04-12	1998-04-12 00:00:00	1998-04-12	1998-04-12 00:00:00	1998-04-12	581452		0	0	0		0	0	0	105984	0	113	40213227		
125673	2765	40213201	2000-09-26	2000-09-26 00:00:00	2000-09-26	2000-09-26 00:00:00	2000-09-26	581452		0	0	0		0	0	0	182968	0	33	40213201		
197537	4340	40213160	1972-12-29	1972-12-29 00:00:00	1972-12-29	1972-12-29 00:00:00	1972-12-29	581452		0	0	0		0	0	0	287765	0	10	40213160		
17907	387	40213314	1977-08-05	1977-08-05 00:00:00	1977-08-05	1977-08-05 00:00:00	1977-08-05	581452		0	0	0		0	0	0	25465	0	49	40213314		
17637	1460	19074843	1982-07-24	1982-07-24 00:00:00	1982-08-07	1982-08-07 00:00:00	1982-08-07	38000177		0	0	14		0	0	0	97273	0	309045	19074843		
67769	1482	40213227	1996-11-09	1996-11-09 00:00:00	1996-11-09	1996-11-09 00:00:00	1996-11-09	581452		0	0	0		0	0	0	98814	0	113	40213227		
25628	2108	1118084	1975-11-13	1975-11-13 00:00:00	1975-11-13	1975-11-13 00:00:00	\N	38000177		0	0	0		0	0	0	140399	0	00025152531	44923712		
48302	4006	40229134	1970-10-05	1970-10-05 00:00:00	1970-10-12	1970-10-12 00:00:00	1970-10-12	38000177		0	0	7		0	0	0	266137	0	1043400	40229134		
58793	4883	1124300	1986-03-31	1986-03-31 00:00:00	1986-03-31	1986-03-31 00:00:00	\N	38000177		0	0	0		0	0	0	324692	0	00781178901	45011828		
65890	1442	40213227	2007-04-10	2007-04-10 00:00:00	2007-04-10	2007-04-10 00:00:00	2007-04-10	581452		0	0	0		0	0	0	96164	0	113	40213227		
65952	1443	40213314	1978-06-03	1978-06-03 00:00:00	1978-06-03	1978-06-03 00:00:00	1978-06-03	581452		0	0	0		0	0	0	96199	0	49	40213314		
21462	1764	1115171	2008-12-01	2008-12-01 00:00:00	2009-02-06	2009-02-06 00:00:00	2009-02-06	38000177		0	0	67		0	0	0	117992	0	849574	1115171		
30179	2501	19059056	1962-09-05	1962-09-05 00:00:00	1962-09-19	1962-09-19 00:00:00	1962-09-19	38000177		0	0	14		0	0	0	165555	0	243670	19059056		
211468	4636	40213227	1997-06-24	1997-06-24 00:00:00	1997-06-24	1997-06-24 00:00:00	1997-06-24	581452		0	0	0		0	0	0	308942	0	113	40213227		
40748	3378	19006318	1959-12-07	1959-12-07 00:00:00	1959-12-21	1959-12-21 00:00:00	1959-12-21	38000177		0	0	14		0	0	0	224153	0	105078	19006318		
7905	662	1127433	1993-10-01	1993-10-01 00:00:00	1993-10-15	1993-10-15 00:00:00	1993-10-15	38000177		0	0	14		0	0	0	43752	0	313782	1127433		
29042	2402	1127078	1977-07-10	1977-07-10 00:00:00	1977-07-24	1977-07-24 00:00:00	1977-07-24	38000177		0	0	14		0	0	0	159625	0	282464	1127078		
118423	2604	40213260	2007-03-17	2007-03-17 00:00:00	2007-03-17	2007-03-17 00:00:00	2007-03-17	581452		0	0	0		0	0	0	172252	0	121	40213260		
49634	4116	1127433	2006-01-28	2006-01-28 00:00:00	2006-02-11	2006-02-11 00:00:00	2006-02-11	38000177		0	0	14		0	0	0	273632	0	313782	1127433		
37778	3123	19019979	1988-09-06	1988-09-06 00:00:00	1988-09-27	1988-09-27 00:00:00	1988-09-27	38000177		0	0	21		0	0	0	207817	0	198405	19019979		
48792	4044	1124300	1993-06-19	1993-06-19 00:00:00	1993-06-19	1993-06-19 00:00:00	\N	38000177		0	0	0		0	0	0	268959	0	00781178901	45011828		
166510	3660	40213160	1973-03-31	1973-03-31 00:00:00	1973-03-31	1973-03-31 00:00:00	1973-03-31	581452		0	0	0		0	0	0	243597	0	10	40213160		
18147	1504	19059056	1942-06-05	1942-06-05 00:00:00	1942-06-19	1942-06-19 00:00:00	1942-06-19	38000177		0	0	14		0	0	0	100282	0	243670	19059056		
18218	1510	19006318	1959-10-28	1959-10-28 00:00:00	1959-11-11	1959-11-11 00:00:00	1959-11-11	38000177		0	0	14		0	0	0	100863	0	105078	19006318		
4829	403	1713671	1950-11-06	1950-11-06 00:00:00	1950-11-13	1950-11-13 00:00:00	1950-11-13	38000177		0	0	7		0	0	0	26492	0	562251	1713671		
117125	2574	40213306	1983-07-13	1983-07-13 00:00:00	1983-07-13	1983-07-13 00:00:00	1983-07-13	581452		0	0	0		0	0	0	170478	0	43	40213306		
51613	4288	1713671	1966-11-16	1966-11-16 00:00:00	1966-11-23	1966-11-23 00:00:00	1966-11-23	38000177		0	0	7		0	0	0	284715	0	562251	1713671		
69969	1529	40213227	2014-05-12	2014-05-12 00:00:00	2014-05-12	2014-05-12 00:00:00	2014-05-12	581452		0	0	0		0	0	0	102350	0	113	40213227		
62182	5174	19059056	1938-08-21	1938-08-21 00:00:00	1938-09-04	1938-09-04 00:00:00	1938-09-04	38000177		0	0	14		0	0	0	344027	0	243670	19059056		
75938	1659	40213306	1991-03-25	1991-03-25 00:00:00	1991-03-25	1991-03-25 00:00:00	1991-03-25	581452		0	0	0		0	0	0	111521	0	43	40213306		
50433	4191	920300	2010-09-11	2010-09-11 00:00:00	2010-09-18	2010-09-18 00:00:00	2010-09-18	38000177		0	0	7		0	0	0	278166	0	311989	920300		
188802	4145	40213160	1974-12-15	1974-12-15 00:00:00	1974-12-15	1974-12-15 00:00:00	1974-12-15	581452		0	0	0		0	0	0	275530	0	10	40213160		
56650	4701	1127078	1971-02-25	1971-02-25 00:00:00	1971-03-11	1971-03-11 00:00:00	1971-03-11	38000177		0	0	14		0	0	0	313139	0	282464	1127078		
61007	5073	1332419	2009-08-29	2009-08-29 00:00:00	2009-08-29	2009-08-29 00:00:00	\N	38000177		0	0	0		0	0	0	337182	0	197361	1332419		
55564	4613	19128065	1982-05-08	1982-05-08 00:00:00	1983-05-03	1983-05-03 00:00:00	1983-05-03	38000177		0	0	360		0	0	0	307275	0	749882	19128065		
45831	3793	1127433	2008-08-07	2008-08-07 00:00:00	2008-08-21	2008-08-21 00:00:00	2008-08-21	38000177		0	0	14		0	0	0	252253	0	313782	1127433		
27965	2315	1127433	2018-10-30	2018-10-30 00:00:00	2018-11-13	2018-11-13 00:00:00	2018-11-13	38000177		0	0	14		0	0	0	153920	0	313782	1127433		
45404	3756	40229134	1943-11-07	1943-11-07 00:00:00	1943-11-21	1943-11-21 00:00:00	1943-11-21	38000177		0	0	14		0	0	0	249608	0	1043400	40229134		
45953	3804	19078461	2018-04-23	2018-04-23 00:00:00	2018-05-28	2018-05-28 00:00:00	2018-05-28	38000177		0	0	35		0	0	0	252862	0	310965	19078461		
28010	609	40213260	2017-12-12	2017-12-12 00:00:00	2017-12-12	2017-12-12 00:00:00	2017-12-12	581452		0	0	0		0	0	0	40451	0	121	40213260		
15136	1265	1118084	2017-12-18	2017-12-18 00:00:00	2017-12-18	2017-12-18 00:00:00	\N	38000177		0	0	0		0	0	0	83392	0	00025152531	44923712		
56082	4656	19006318	1951-08-02	1951-08-02 00:00:00	1951-08-16	1951-08-16 00:00:00	1951-08-16	38000177		0	0	14		0	0	0	310453	0	105078	19006318		
10335	864	19133905	1947-07-19	1947-07-19 00:00:00	1947-07-26	1947-07-26 00:00:00	1947-07-26	38000177		0	0	7		0	0	0	57296	0	834102	19133905		
239248	5252	40213227	2019-06-11	2019-06-11 00:00:00	2019-06-11	2019-06-11 00:00:00	2019-06-11	581452		0	0	0		0	0	0	349403	0	113	40213227		
101206	2218	40213227	2000-07-25	2000-07-25 00:00:00	2000-07-25	2000-07-25 00:00:00	2000-07-25	581452		0	0	0		0	0	0	147729	0	113	40213227		
8755	730	19006318	1958-10-05	1958-10-05 00:00:00	1958-10-19	1958-10-19 00:00:00	1958-10-19	38000177		0	0	14		0	0	0	48468	0	105078	19006318		
20973	1727	1713671	1995-10-29	1995-10-29 00:00:00	1995-11-04	1995-11-04 00:00:00	1995-11-04	38000177		0	0	6		0	0	0	115440	0	562251	1713671		
27558	2283	19078461	1987-02-28	1987-02-28 00:00:00	1987-04-06	1987-04-06 00:00:00	1987-04-06	38000177		0	0	37		0	0	0	151882	0	310965	19078461		
76561	1672	40213198	2019-02-06	2019-02-06 00:00:00	2019-02-06	2019-02-06 00:00:00	2019-02-06	581452		0	0	0		0	0	0	112293	0	133	40213198		
27640	2289	1127433	1961-11-19	1961-11-19 00:00:00	1961-12-10	1961-12-10 00:00:00	1961-12-10	38000177		0	0	21		0	0	0	152249	0	313782	1127433		
41756	911	40213160	1976-06-13	1976-06-13 00:00:00	1976-06-13	1976-06-13 00:00:00	1976-06-13	581452		0	0	0		0	0	0	60501	0	10	40213160		
130234	2862	40213296	2008-10-18	2008-10-18 00:00:00	2008-10-18	2008-10-18 00:00:00	2008-10-18	581452		0	0	0		0	0	0	190258	0	52	40213296		
47073	3901	1127433	1976-01-28	1976-01-28 00:00:00	1976-03-03	1976-03-03 00:00:00	1976-03-03	38000177		0	0	35		0	0	0	259387	0	313782	1127433		
197374	4337	40213260	2011-06-10	2011-06-10 00:00:00	2011-06-10	2011-06-10 00:00:00	2011-06-10	581452		0	0	0		0	0	0	287619	0	121	40213260		
54743	4547	1127433	1982-01-17	1982-01-17 00:00:00	1982-04-17	1982-04-17 00:00:00	1982-04-17	38000177		0	0	90		0	0	0	302959	0	313782	1127433		
42324	3510	19059056	1956-02-16	1956-02-16 00:00:00	1956-03-22	1956-03-22 00:00:00	1956-03-22	38000177		0	0	35		0	0	0	232797	0	243670	19059056		
5764	482	1127078	1979-04-10	1979-04-10 00:00:00	1979-04-24	1979-04-24 00:00:00	1979-04-24	38000177		0	0	14		0	0	0	32216	0	282464	1127078		
57642	1261	40213227	2011-11-19	2011-11-19 00:00:00	2011-11-19	2011-11-19 00:00:00	2011-11-19	581452		0	0	0		0	0	0	83228	0	113	40213227		
50674	4210	19074843	1986-01-07	1986-01-07 00:00:00	1986-01-21	1986-01-21 00:00:00	1986-01-21	38000177		0	0	14		0	0	0	279542	0	309045	19074843		
178384	3921	40213160	1982-07-21	1982-07-21 00:00:00	1982-07-21	1982-07-21 00:00:00	1982-07-21	581452		0	0	0		0	0	0	260742	0	10	40213160		
43708	3622	1115171	2008-11-18	2008-11-18 00:00:00	2008-12-18	2008-12-18 00:00:00	2008-12-18	38000177		0	0	30		0	0	0	240712	0	849574	1115171		
30906	673	40213160	1965-10-08	1965-10-08 00:00:00	1965-10-08	1965-10-08 00:00:00	1965-10-08	581452		0	0	0		0	0	0	44444	0	10	40213160		
40455	3353	1118084	1959-04-08	1959-04-08 00:00:00	1959-04-08	1959-04-08 00:00:00	\N	38000177		0	0	0		0	0	0	222379	0	00025152531	44923712		
51654	4291	1124300	2016-08-29	2016-08-29 00:00:00	2016-08-29	2016-08-29 00:00:00	\N	38000177		0	0	0		0	0	0	284903	0	00781178901	45011828		
72230	1578	40213201	2013-07-07	2013-07-07 00:00:00	2013-07-07	2013-07-07 00:00:00	2013-07-07	581452		0	0	0		0	0	0	105988	0	33	40213201		
125676	2765	40213227	2015-12-22	2015-12-22 00:00:00	2015-12-22	2015-12-22 00:00:00	2015-12-22	581452		0	0	0		0	0	0	182917	0	113	40213227		
126195	2776	40213296	2017-07-23	2017-07-23 00:00:00	2017-07-23	2017-07-23 00:00:00	2017-07-23	581452		0	0	0		0	0	0	183781	0	52	40213296		
17917	388	40213227	2005-09-20	2005-09-20 00:00:00	2005-09-20	2005-09-20 00:00:00	2005-09-20	581452		0	0	0		0	0	0	25548	0	113	40213227		
17638	1460	19059056	1982-07-24	1982-07-24 00:00:00	1982-08-07	1982-08-07 00:00:00	1982-08-07	38000177		0	0	14		0	0	0	97273	0	243670	19059056		
67771	1482	40213227	2005-11-19	2005-11-19 00:00:00	2005-11-19	2005-11-19 00:00:00	2005-11-19	581452		0	0	0		0	0	0	98823	0	113	40213227		
25629	2108	19059056	1986-05-09	1986-05-09 00:00:00	1986-08-07	1986-08-07 00:00:00	1986-08-07	38000177		0	0	90		0	0	0	140357	0	243670	19059056		
48303	4006	1127433	1952-07-23	1952-07-23 00:00:00	1952-08-06	1952-08-06 00:00:00	1952-08-06	38000177		0	0	14		0	0	0	266136	0	313782	1127433		
58794	4884	19019979	1980-12-22	1980-12-22 00:00:00	1981-01-21	1981-01-21 00:00:00	1981-01-21	38000177		0	0	30		0	0	0	324734	0	198405	19019979		
65892	1442	40213198	2011-05-03	2011-05-03 00:00:00	2011-05-03	2011-05-03 00:00:00	2011-05-03	581452		0	0	0		0	0	0	96173	0	133	40213198		
65954	1443	40213251	1984-04-13	1984-04-13 00:00:00	1984-04-13	1984-04-13 00:00:00	1984-04-13	581452		0	0	0		0	0	0	96233	0	21	40213251		
21463	1764	1127433	1995-01-19	1995-01-19 00:00:00	1995-01-26	1995-01-26 00:00:00	1995-01-26	38000177		0	0	7		0	0	0	117983	0	313782	1127433		
30180	2501	19059056	1962-05-26	1962-05-26 00:00:00	1962-06-09	1962-06-09 00:00:00	1962-06-09	38000177		0	0	14		0	0	0	165534	0	243670	19059056		
211472	4637	40213160	1974-09-30	1974-09-30 00:00:00	1974-09-30	1974-09-30 00:00:00	1974-09-30	581452		0	0	0		0	0	0	309070	0	10	40213160		
77383	1691	40213227	2006-06-15	2006-06-15 00:00:00	2006-06-15	2006-06-15 00:00:00	2006-06-15	581452		0	0	0		0	0	0	113317	0	113	40213227		
7906	662	1545959	2012-06-06	2012-06-06 00:00:00	2012-06-06	2012-06-06 00:00:00	2012-06-06	38000177		0	0	0		0	0	0	43754	0	259255	1545959		
29043	2402	46233988	1978-03-20	1978-03-20 00:00:00	1978-04-03	1978-04-03 00:00:00	1978-04-03	38000177		0	0	14		0	0	0	159679	0	1652673	46233988		
118427	2604	40213227	1998-03-21	1998-03-21 00:00:00	1998-03-21	1998-03-21 00:00:00	1998-03-21	581452		0	0	0		0	0	0	172267	0	113	40213227		
60105	4998	40232448	1968-10-29	1968-10-29 00:00:00	1968-10-29	1968-10-29 00:00:00	\N	38000177		0	0	0		0	0	0	332403	0	1049630	40232448		
37779	3123	1519937	2009-03-30	2009-03-30 00:00:00	2010-03-25	2010-03-25 00:00:00	2010-03-25	38000177		0	0	360		0	0	0	207804	0	389221	1519937		
48793	4044	40229134	1975-01-19	1975-01-19 00:00:00	1975-02-02	1975-02-02 00:00:00	1975-02-02	38000177		0	0	14		0	0	0	268922	0	1043400	40229134		
166512	3660	40213160	1972-12-30	1972-12-30 00:00:00	1972-12-30	1972-12-30 00:00:00	1972-12-30	581452		0	0	0		0	0	0	243571	0	10	40213160		
18148	1505	1118084	1992-04-13	1992-04-13 00:00:00	1992-04-13	1992-04-13 00:00:00	\N	38000177		0	0	0		0	0	0	100351	0	00025152531	44923712		
18219	1510	19128065	1978-09-28	1978-09-28 00:00:00	1979-09-23	1979-09-23 00:00:00	1979-09-23	38000177		0	0	360		0	0	0	100797	0	749882	19128065		
4830	403	40229134	1935-01-04	1935-01-04 00:00:00	1935-01-11	1935-01-11 00:00:00	1935-01-11	38000177		0	0	7		0	0	0	26510	0	1043400	40229134		
117133	2574	40213160	1961-04-11	1961-04-11 00:00:00	1961-04-11	1961-04-11 00:00:00	1961-04-11	581452		0	0	0		0	0	0	170461	0	10	40213160		
51614	4289	19059056	1944-06-08	1944-06-08 00:00:00	1944-08-07	1944-08-07 00:00:00	1944-08-07	38000177		0	0	60		0	0	0	284738	0	243670	19059056		
69974	1529	40213160	1962-10-08	1962-10-08 00:00:00	1962-10-08	1962-10-08 00:00:00	1962-10-08	581452		0	0	0		0	0	0	102312	0	10	40213160		
62183	5174	40173590	1997-03-27	1997-03-27 00:00:00	1997-03-27	1997-03-27 00:00:00	\N	38000177		0	0	0		0	0	0	344008	0	904419	40173590		
75946	1659	40213296	2009-03-23	2009-03-23 00:00:00	2009-03-23	2009-03-23 00:00:00	2009-03-23	581452		0	0	0		0	0	0	111508	0	52	40213296		
50434	4191	19126352	2010-09-03	2010-09-03 00:00:00	2010-09-03	2010-09-03 00:00:00	\N	38000177		0	0	0		0	0	0	278166	0	705129	19126352		
188808	4145	40213160	1979-06-17	1979-06-17 00:00:00	1979-06-17	1979-06-17 00:00:00	1979-06-17	581452		0	0	0		0	0	0	275487	0	10	40213160		
56651	4701	19129655	1971-02-25	1971-02-25 00:00:00	1971-03-11	1971-03-11 00:00:00	1971-03-11	38000177		0	0	14		0	0	0	313139	0	789980	19129655		
61008	5073	40171902	2001-07-14	2001-07-14 00:00:00	2001-07-14	2001-07-14 00:00:00	\N	38000177		0	0	0		0	0	0	337206	0	897718	40171902		
55565	4613	19128065	1988-04-06	1988-04-06 00:00:00	1989-04-01	1989-04-01 00:00:00	1989-04-01	38000177		0	0	360		0	0	0	307249	0	749882	19128065		
45832	3793	40173590	1999-05-25	1999-05-25 00:00:00	1999-05-25	1999-05-25 00:00:00	\N	38000177		0	0	0		0	0	0	252236	0	904419	40173590		
27966	2315	1713671	1980-04-21	1980-04-21 00:00:00	1980-05-05	1980-05-05 00:00:00	1980-05-05	38000177		0	0	14		0	0	0	153944	0	562251	1713671		
45405	3756	1127433	1964-07-28	1964-07-28 00:00:00	1964-08-25	1964-08-25 00:00:00	1964-08-25	38000177		0	0	28		0	0	0	249715	0	313782	1127433		
45954	3804	19059056	1964-05-10	1964-05-10 00:00:00	1964-05-24	1964-05-24 00:00:00	1964-05-24	38000177		0	0	14		0	0	0	252897	0	243670	19059056		
28011	609	40213160	1968-05-21	1968-05-21 00:00:00	1968-05-21	1968-05-21 00:00:00	1968-05-21	581452		0	0	0		0	0	0	40436	0	10	40213160		
15137	1265	920300	2017-06-09	2017-06-09 00:00:00	2017-06-16	2017-06-16 00:00:00	2017-06-16	38000177		0	0	7		0	0	0	83416	0	311989	920300		
56083	4656	19059056	1966-11-09	1966-11-09 00:00:00	1967-01-08	1967-01-08 00:00:00	1967-01-08	38000177		0	0	60		0	0	0	310469	0	243670	19059056		
10336	864	1118084	1958-05-04	1958-05-04 00:00:00	1958-05-04	1958-05-04 00:00:00	\N	38000177		0	0	0		0	0	0	57299	0	00025152531	44923712		
239251	5252	40213296	2000-01-18	2000-01-18 00:00:00	2000-01-18	2000-01-18 00:00:00	2000-01-18	581452		0	0	0		0	0	0	\N	0	52	40213296		
101207	2218	40213306	2000-07-25	2000-07-25 00:00:00	2000-07-25	2000-07-25 00:00:00	2000-07-25	581452		0	0	0		0	0	0	147729	0	43	40213306		
8756	730	19059056	1958-10-05	1958-10-05 00:00:00	1958-10-19	1958-10-19 00:00:00	1958-10-19	38000177		0	0	14		0	0	0	48468	0	243670	19059056		
20975	1727	40236824	2002-05-28	2002-05-28 00:00:00	2002-06-04	2002-06-04 00:00:00	2002-06-04	38000177		0	0	7		0	0	0	115417	0	1094107	40236824		
27559	2283	1127433	1960-01-15	1960-01-15 00:00:00	1960-01-29	1960-01-29 00:00:00	1960-01-29	38000177		0	0	14		0	0	0	151878	0	313782	1127433		
76568	1672	40213260	2006-11-29	2006-11-29 00:00:00	2006-11-29	2006-11-29 00:00:00	2006-11-29	581452		0	0	0		0	0	0	112276	0	121	40213260		
27641	2289	19074679	1959-03-19	1959-03-19 00:00:00	1959-09-03	1959-09-03 00:00:00	1959-09-03	38000177		0	0	168		0	0	0	152248	0	308971	19074679		
41758	911	40213227	2018-09-02	2018-09-02 00:00:00	2018-09-02	2018-09-02 00:00:00	2018-09-02	581452		0	0	0		0	0	0	60519	0	113	40213227		
130241	2862	40213160	1968-05-04	1968-05-04 00:00:00	1968-05-04	1968-05-04 00:00:00	1968-05-04	581452		0	0	0		0	0	0	190277	0	10	40213160		
47074	3901	19059056	1958-08-25	1958-08-25 00:00:00	1958-09-08	1958-09-08 00:00:00	1958-09-08	38000177		0	0	14		0	0	0	259385	0	243670	19059056		
197376	4337	40213296	2001-10-12	2001-10-12 00:00:00	2001-10-12	2001-10-12 00:00:00	2001-10-12	581452		0	0	0		0	0	0	287579	0	52	40213296		
54744	4547	1127433	1983-03-13	1983-03-13 00:00:00	1983-04-03	1983-04-03 00:00:00	1983-04-03	38000177		0	0	21		0	0	0	302960	0	313782	1127433		
42325	3510	1118084	1971-11-14	1971-11-14 00:00:00	1971-11-14	1971-11-14 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00025152531	44923712		
5765	482	19073183	1979-04-10	1979-04-10 00:00:00	1979-04-24	1979-04-24 00:00:00	1979-04-24	38000177		0	0	14		0	0	0	32216	0	308182	19073183		
57643	1261	40213296	2011-11-19	2011-11-19 00:00:00	2011-11-19	2011-11-19 00:00:00	2011-11-19	581452		0	0	0		0	0	0	83228	0	52	40213296		
153671	3382	40213260	2013-11-21	2013-11-21 00:00:00	2013-11-21	2013-11-21 00:00:00	2013-11-21	581452		0	0	0		0	0	0	224435	0	121	40213260		
15927	343	40213160	1970-10-10	1970-10-10 00:00:00	1970-10-10	1970-10-10 00:00:00	1970-10-10	581452		0	0	0		0	0	0	22864	0	10	40213160		
43709	3622	1127433	2019-03-26	2019-03-26 00:00:00	2019-04-09	2019-04-09 00:00:00	2019-04-09	38000177		0	0	14		0	0	0	240667	0	313782	1127433		
78155	1709	40213227	2018-04-28	2018-04-28 00:00:00	2018-04-28	2018-04-28 00:00:00	2018-04-28	581452		0	0	0		0	0	0	114308	0	113	40213227		
40456	3353	19133905	1962-05-02	1962-05-02 00:00:00	1962-05-10	1962-05-10 00:00:00	1962-05-10	38000177		0	0	8		0	0	0	222334	0	834102	19133905		
51671	4295	19133905	2018-01-04	2018-01-04 00:00:00	2018-01-15	2018-01-15 00:00:00	2018-01-15	38000177		0	0	11		0	0	0	285075	0	834102	19133905		
72235	1578	40213227	2018-08-05	2018-08-05 00:00:00	2018-08-05	2018-08-05 00:00:00	2018-08-05	581452		0	0	0		0	0	0	105983	0	113	40213227		
113244	2487	40213160	1957-02-10	1957-02-10 00:00:00	1957-02-10	1957-02-10 00:00:00	1957-02-10	581452		0	0	0		0	0	0	164824	0	10	40213160		
137474	3017	40213296	1998-04-24	1998-04-24 00:00:00	1998-04-24	1998-04-24 00:00:00	1998-04-24	581452		0	0	0		0	0	0	201221	0	52	40213296		
17921	388	40213227	1996-08-27	1996-08-27 00:00:00	1996-08-27	1996-08-27 00:00:00	1996-08-27	581452		0	0	0		0	0	0	25533	0	113	40213227		
150719	3315	40213227	1992-02-15	1992-02-15 00:00:00	1992-02-15	1992-02-15 00:00:00	1992-02-15	581452		0	0	0		0	0	0	220163	0	113	40213227		
241941	5312	40213201	2005-01-17	2005-01-17 00:00:00	2005-01-17	2005-01-17 00:00:00	2005-01-17	581452		0	0	0		0	0	0	353236	0	33	40213201		
25630	2108	1713671	2004-12-05	2004-12-05 00:00:00	2004-12-19	2004-12-19 00:00:00	2004-12-19	38000177		0	0	14		0	0	0	140384	0	562251	1713671		
48304	4006	1127433	1951-04-11	1951-04-11 00:00:00	1951-04-25	1951-04-25 00:00:00	1951-04-25	38000177		0	0	14		0	0	0	266135	0	313782	1127433		
58795	4884	1124300	2016-02-28	2016-02-28 00:00:00	2016-02-28	2016-02-28 00:00:00	\N	38000177		0	0	0		0	0	0	324725	0	00781178901	45011828		
65911	1442	40213227	1997-02-11	1997-02-11 00:00:00	1997-02-11	1997-02-11 00:00:00	1997-02-11	581452		0	0	0		0	0	0	96117	0	113	40213227		
65964	1443	40213296	2017-03-25	2017-03-25 00:00:00	2017-03-25	2017-03-25 00:00:00	2017-03-25	581452		0	0	0		0	0	0	96241	0	52	40213296		
21464	1764	40229134	1981-09-24	1981-09-24 00:00:00	1981-10-08	1981-10-08 00:00:00	1981-10-08	38000177		0	0	14		0	0	0	117980	0	1043400	40229134		
30181	2501	19129655	1962-05-26	1962-05-26 00:00:00	1962-06-09	1962-06-09 00:00:00	1962-06-09	38000177		0	0	14		0	0	0	165534	0	789980	19129655		
211474	4637	40213296	2014-06-16	2014-06-16 00:00:00	2014-06-16	2014-06-16 00:00:00	2014-06-16	581452		0	0	0		0	0	0	309066	0	52	40213296		
77387	1691	40213198	2010-07-08	2010-07-08 00:00:00	2010-07-08	2010-07-08 00:00:00	2010-07-08	581452		0	0	0		0	0	0	113319	0	133	40213198		
7907	662	19133768	2012-06-06	2012-06-06 00:00:00	2012-06-06	2012-06-06 00:00:00	2012-06-06	38000177		0	0	0		0	0	0	43754	0	833036	19133768		
29044	2402	1127078	1978-03-20	1978-03-20 00:00:00	1978-04-03	1978-04-03 00:00:00	1978-04-03	38000177		0	0	14		0	0	0	159679	0	282464	1127078		
118428	2604	40213296	1998-03-21	1998-03-21 00:00:00	1998-03-21	1998-03-21 00:00:00	1998-03-21	581452		0	0	0		0	0	0	172267	0	52	40213296		
60106	4998	40169216	1968-10-15	1968-10-15 00:00:00	1984-06-01	1984-06-01 00:00:00	1984-06-01	38000177		0	0	5708		0	0	0	332403	0	895994	40169216		
37780	3123	19059056	1993-07-03	1993-07-03 00:00:00	1993-08-07	1993-08-07 00:00:00	1993-08-07	38000177		0	0	35		0	0	0	207818	0	243670	19059056		
48794	4044	40229134	2008-06-06	2008-06-06 00:00:00	2008-06-13	2008-06-13 00:00:00	2008-06-13	38000177		0	0	7		0	0	0	268923	0	1043400	40229134		
166520	3660	40213227	2003-10-04	2003-10-04 00:00:00	2003-10-04	2003-10-04 00:00:00	2003-10-04	581452		0	0	0		0	0	0	243611	0	113	40213227		
18149	1505	1127433	1995-03-04	1995-03-04 00:00:00	1995-03-25	1995-03-25 00:00:00	1995-03-25	38000177		0	0	21		0	0	0	100383	0	313782	1127433		
18220	1510	1713671	1987-12-20	1987-12-20 00:00:00	1988-01-10	1988-01-10 00:00:00	1988-01-10	38000177		0	0	21		0	0	0	100845	0	562251	1713671		
4831	403	19133873	1932-12-16	1932-12-16 00:00:00	1932-12-28	1932-12-28 00:00:00	1932-12-28	38000177		0	0	12		0	0	0	26431	0	834061	19133873		
117135	2574	40213160	1965-12-14	1965-12-14 00:00:00	1965-12-14	1965-12-14 00:00:00	1965-12-14	581452		0	0	0		0	0	0	170489	0	10	40213160		
51615	4289	40229134	2018-01-18	2018-01-18 00:00:00	2018-01-25	2018-01-25 00:00:00	2018-01-25	38000177		0	0	7		0	0	0	284755	0	1043400	40229134		
69977	1529	40213160	1963-03-11	1963-03-11 00:00:00	1963-03-11	1963-03-11 00:00:00	1963-03-11	581452		0	0	0		0	0	0	102313	0	10	40213160		
62184	5174	40236824	1966-02-20	1966-02-20 00:00:00	1966-02-27	1966-02-27 00:00:00	1966-02-27	38000177		0	0	7		0	0	0	344038	0	1094107	40236824		
75953	1659	40213160	1973-12-17	1973-12-17 00:00:00	1973-12-17	1973-12-17 00:00:00	1973-12-17	581452		0	0	0		0	0	0	111492	0	10	40213160		
50435	4191	19075601	2010-09-03	2010-09-03 00:00:00	2010-09-03	2010-09-03 00:00:00	\N	38000177		0	0	0		0	0	0	278166	0	309362	19075601		
188812	4145	40213296	2014-07-13	2014-07-13 00:00:00	2014-07-13	2014-07-13 00:00:00	2014-07-13	581452		0	0	0		0	0	0	275453	0	52	40213296		
56653	4701	1124300	2011-07-10	2011-07-10 00:00:00	2011-07-10	2011-07-10 00:00:00	\N	38000177		0	0	0		0	0	0	313197	0	00781178901	45011828		
61009	5073	40163554	2001-07-14	2001-07-14 00:00:00	2001-07-14	2001-07-14 00:00:00	\N	38000177		0	0	0		0	0	0	337206	0	855332	40163554		
55566	4613	19129655	1971-08-08	1971-08-08 00:00:00	1971-08-22	1971-08-22 00:00:00	1971-08-22	38000177		0	0	14		0	0	0	307246	0	789980	19129655		
45833	3793	1127433	1994-04-14	1994-04-14 00:00:00	1994-04-21	1994-04-21 00:00:00	1994-04-21	38000177		0	0	7		0	0	0	252233	0	313782	1127433		
27967	2315	1127433	1984-08-23	1984-08-23 00:00:00	1984-08-30	1984-08-30 00:00:00	1984-08-30	38000177		0	0	7		0	0	0	153963	0	313782	1127433		
45406	3756	40169281	2004-05-01	2004-05-01 00:00:00	2004-05-01	2004-05-01 00:00:00	\N	38000177		0	0	0		0	0	0	249706	0	896209	40169281		
45955	3804	19129655	1964-05-10	1964-05-10 00:00:00	1964-05-24	1964-05-24 00:00:00	1964-05-24	38000177		0	0	14		0	0	0	252897	0	789980	19129655		
28019	609	40213160	1968-08-20	1968-08-20 00:00:00	1968-08-20	1968-08-20 00:00:00	1968-08-20	581452		0	0	0		0	0	0	40466	0	10	40213160		
15138	1265	40236824	2017-06-09	2017-06-09 00:00:00	2017-06-16	2017-06-16 00:00:00	2017-06-16	38000177		0	0	7		0	0	0	83416	0	1094107	40236824		
56084	4656	40231925	1966-11-09	1966-11-09 00:00:00	1966-11-09	1966-11-09 00:00:00	\N	38000177		0	0	0		0	0	0	310469	0	1049221	40231925		
10337	864	19133873	1935-03-08	1935-03-08 00:00:00	1935-03-20	1935-03-20 00:00:00	1935-03-20	38000177		0	0	12		0	0	0	57273	0	834061	19133873		
239256	5252	40213306	1982-03-23	1982-03-23 00:00:00	1982-03-23	1982-03-23 00:00:00	1982-03-23	581452		0	0	0		0	0	0	349423	0	43	40213306		
101208	2218	40213314	1978-10-31	1978-10-31 00:00:00	1978-10-31	1978-10-31 00:00:00	1978-10-31	581452		0	0	0		0	0	0	147763	0	49	40213314		
8757	730	19128065	1977-03-09	1977-03-09 00:00:00	1978-03-04	1978-03-04 00:00:00	1978-03-04	38000177		0	0	360		0	0	0	48495	0	749882	19128065		
20976	1727	920300	2002-05-28	2002-05-28 00:00:00	2002-06-04	2002-06-04 00:00:00	2002-06-04	38000177		0	0	7		0	0	0	115417	0	311989	920300		
27560	2283	1127433	1986-06-21	1986-06-21 00:00:00	1986-06-28	1986-06-28 00:00:00	1986-06-28	38000177		0	0	7		0	0	0	151909	0	313782	1127433		
76582	1672	40213160	1956-04-04	1956-04-04 00:00:00	1956-04-04	1956-04-04 00:00:00	1956-04-04	581452		0	0	0		0	0	0	112261	0	10	40213160		
27642	2289	1127433	2018-07-15	2018-07-15 00:00:00	2018-08-19	2018-08-19 00:00:00	2018-08-19	38000177		0	0	35		0	0	0	152255	0	313782	1127433		
41759	911	40213296	2018-09-02	2018-09-02 00:00:00	2018-09-02	2018-09-02 00:00:00	2018-09-02	581452		0	0	0		0	0	0	60519	0	52	40213296		
130242	2862	40213260	2018-11-16	2018-11-16 00:00:00	2018-11-16	2018-11-16 00:00:00	2018-11-16	581452		0	0	0		0	0	0	190268	0	121	40213260		
47075	3901	1127433	2017-07-16	2017-07-16 00:00:00	2017-07-23	2017-07-23 00:00:00	2017-07-23	38000177		0	0	7		0	0	0	259429	0	313782	1127433		
197378	4337	40213160	1961-09-15	1961-09-15 00:00:00	1961-09-15	1961-09-15 00:00:00	1961-09-15	581452		0	0	0		0	0	0	287581	0	10	40213160		
54745	4547	19059056	1943-06-06	1943-06-06 00:00:00	1943-07-11	1943-07-11 00:00:00	1943-07-11	38000177		0	0	35		0	0	0	302958	0	243670	19059056		
42326	3510	1127433	1960-03-31	1960-03-31 00:00:00	1960-04-14	1960-04-14 00:00:00	1960-04-14	38000177		0	0	14		0	0	0	232798	0	313782	1127433		
5766	482	19128022	1990-09-13	1990-09-13 00:00:00	1991-09-08	1991-09-08 00:00:00	1991-09-08	38000177		0	0	360		0	0	0	32219	0	749785	19128022		
57644	1261	40213160	1970-08-22	1970-08-22 00:00:00	1970-08-22	1970-08-22 00:00:00	1970-08-22	581452		0	0	0		0	0	0	83238	0	10	40213160		
153673	3382	40213227	2013-11-21	2013-11-21 00:00:00	2013-11-21	2013-11-21 00:00:00	2013-11-21	581452		0	0	0		0	0	0	224435	0	113	40213227		
29821	2470	40236824	1998-02-20	1998-02-20 00:00:00	1998-02-27	1998-02-27 00:00:00	1998-02-27	38000177		0	0	7		0	0	0	163767	0	1094107	40236824		
43710	3622	19133905	2012-09-04	2012-09-04 00:00:00	2012-09-15	2012-09-15 00:00:00	2012-09-15	38000177		0	0	11		0	0	0	240781	0	834102	19133905		
78160	1709	40213201	2002-11-16	2002-11-16 00:00:00	2002-11-16	2002-11-16 00:00:00	2002-11-16	581452		0	0	0		0	0	0	114327	0	33	40213201		
40457	3353	19059056	1983-12-19	1983-12-19 00:00:00	1984-01-09	1984-01-09 00:00:00	1984-01-09	38000177		0	0	21		0	0	0	222450	0	243670	19059056		
51672	4295	1127078	1982-08-25	1982-08-25 00:00:00	1982-09-08	1982-09-08 00:00:00	1982-09-08	38000177		0	0	14		0	0	0	285076	0	282464	1127078		
72236	1578	40213198	2012-07-01	2012-07-01 00:00:00	2012-07-01	2012-07-01 00:00:00	2012-07-01	581452		0	0	0		0	0	0	106021	0	133	40213198		
113250	2487	40213160	1955-08-07	1955-08-07 00:00:00	1955-08-07	1955-08-07 00:00:00	1955-08-07	581452		0	0	0		0	0	0	164823	0	10	40213160		
137481	3017	40213227	1999-04-02	1999-04-02 00:00:00	1999-04-02	1999-04-02 00:00:00	1999-04-02	581452		0	0	0		0	0	0	201294	0	113	40213227		
17922	388	40213296	1996-08-27	1996-08-27 00:00:00	1996-08-27	1996-08-27 00:00:00	1996-08-27	581452		0	0	0		0	0	0	25533	0	52	40213296		
150726	3315	40213296	1997-05-03	1997-05-03 00:00:00	1997-05-03	1997-05-03 00:00:00	1997-05-03	581452		0	0	0		0	0	0	220197	0	52	40213296		
241956	5312	40213227	1992-11-23	1992-11-23 00:00:00	1992-11-23	1992-11-23 00:00:00	1992-11-23	581452		0	0	0		0	0	0	353244	0	113	40213227		
25631	2108	1713671	1945-12-23	1945-12-23 00:00:00	1946-01-06	1946-01-06 00:00:00	1946-01-06	38000177		0	0	14		0	0	0	140333	0	562251	1713671		
48305	4006	19006318	1950-09-12	1950-09-12 00:00:00	1950-09-26	1950-09-26 00:00:00	1950-09-26	38000177		0	0	14		0	0	0	266184	0	105078	19006318		
58796	4884	19019979	1978-02-22	1978-02-22 00:00:00	1978-03-08	1978-03-08 00:00:00	1978-03-08	38000177		0	0	14		0	0	0	324733	0	198405	19019979		
65919	1442	40213227	2017-06-06	2017-06-06 00:00:00	2017-06-06	2017-06-06 00:00:00	2017-06-06	581452		0	0	0		0	0	0	96122	0	113	40213227		
65965	1443	40213314	1977-09-03	1977-09-03 00:00:00	1977-09-03	1977-09-03 00:00:00	1977-09-03	581452		0	0	0		0	0	0	96198	0	49	40213314		
21465	1764	1127433	1978-11-01	1978-11-01 00:00:00	1978-11-08	1978-11-08 00:00:00	1978-11-08	38000177		0	0	7		0	0	0	117939	0	313782	1127433		
30182	2501	1115171	2019-06-04	2019-06-04 00:00:00	2019-06-18	2019-06-18 00:00:00	2019-06-18	38000177		0	0	14		0	0	0	165578	0	849574	1115171		
211483	4637	40213314	1977-12-26	1977-12-26 00:00:00	1977-12-26	1977-12-26 00:00:00	1977-12-26	581452		0	0	0		0	0	0	309026	0	49	40213314		
77393	1691	40213201	2011-07-14	2011-07-14 00:00:00	2011-07-14	2011-07-14 00:00:00	2011-07-14	581452		0	0	0		0	0	0	113279	0	33	40213201		
7908	662	1713671	1970-09-21	1970-09-21 00:00:00	1970-10-12	1970-10-12 00:00:00	1970-10-12	38000177		0	0	21		0	0	0	43719	0	562251	1713671		
29045	2402	19112599	1977-11-19	1977-11-19 00:00:00	1977-11-19	1977-11-19 00:00:00	\N	38000177		0	0	0		0	0	0	159572	0	477045	19112599		
124406	2736	40213160	1970-04-15	1970-04-15 00:00:00	1970-04-15	1970-04-15 00:00:00	1970-04-15	581452		0	0	0		0	0	0	181132	0	10	40213160		
60107	4998	1154615	1968-10-15	1968-10-15 00:00:00	1984-06-01	1984-06-01 00:00:00	1984-06-01	38000177		0	0	5708		0	0	0	332403	0	745679	1154615		
37781	3123	19128022	1997-06-01	1997-06-01 00:00:00	1998-05-27	1998-05-27 00:00:00	1998-05-27	38000177		0	0	360		0	0	0	207780	0	749785	19128022		
48795	4044	1127433	1961-12-25	1961-12-25 00:00:00	1962-01-08	1962-01-08 00:00:00	1962-01-08	38000177		0	0	14		0	0	0	268937	0	313782	1127433		
166523	3660	40213160	1972-10-28	1972-10-28 00:00:00	1972-10-28	1972-10-28 00:00:00	1972-10-28	581452		0	0	0		0	0	0	243587	0	10	40213160		
18150	1505	1713671	2014-01-17	2014-01-17 00:00:00	2014-03-07	2014-03-07 00:00:00	2014-03-07	38000177		0	0	49		0	0	0	100386	0	562251	1713671		
18222	1510	19078461	1989-06-18	1989-06-18 00:00:00	1989-08-17	1989-08-17 00:00:00	1989-08-17	38000177		0	0	60		0	0	0	100790	0	310965	19078461		
4832	403	1713671	1984-04-14	1984-04-14 00:00:00	1984-04-21	1984-04-21 00:00:00	1984-04-21	38000177		0	0	7		0	0	0	26497	0	562251	1713671		
117144	2574	40213227	1992-07-22	1992-07-22 00:00:00	1992-07-22	1992-07-22 00:00:00	1992-07-22	581452		0	0	0		0	0	0	170481	0	113	40213227		
51616	4289	1127433	1994-06-26	1994-06-26 00:00:00	1994-07-10	1994-07-10 00:00:00	1994-07-10	38000177		0	0	14		0	0	0	284743	0	313782	1127433		
69984	1529	40213260	2013-05-06	2013-05-06 00:00:00	2013-05-06	2013-05-06 00:00:00	2013-05-06	581452		0	0	0		0	0	0	102294	0	121	40213260		
62185	5174	920300	1966-02-20	1966-02-20 00:00:00	1966-02-27	1966-02-27 00:00:00	1966-02-27	38000177		0	0	7		0	0	0	344038	0	311989	920300		
75957	1659	40213227	2011-03-28	2011-03-28 00:00:00	2011-03-28	2011-03-28 00:00:00	2011-03-28	581452		0	0	0		0	0	0	111452	0	113	40213227		
50436	4191	19128065	1976-07-17	1976-07-17 00:00:00	1977-07-12	1977-07-12 00:00:00	1977-07-12	38000177		0	0	360		0	0	0	278130	0	749882	19128065		
67040	1467	40213227	2014-07-27	2014-07-27 00:00:00	2014-07-27	2014-07-27 00:00:00	2014-07-27	581452		0	0	0		0	0	0	97788	0	113	40213227		
56654	4701	1115171	2015-11-11	2015-11-11 00:00:00	2015-12-02	2015-12-02 00:00:00	2015-12-02	38000177		0	0	21		0	0	0	313174	0	849574	1115171		
61010	5073	19018935	2001-07-14	2001-07-14 00:00:00	2001-07-14	2001-07-14 00:00:00	\N	38000177		0	0	0		0	0	0	337206	0	197604	19018935		
55567	4613	19059056	1971-08-08	1971-08-08 00:00:00	1971-08-22	1971-08-22 00:00:00	1971-08-22	38000177		0	0	14		0	0	0	307246	0	243670	19059056		
45834	3793	19059056	1949-12-10	1949-12-10 00:00:00	1950-02-08	1950-02-08 00:00:00	1950-02-08	38000177		0	0	60		0	0	0	252276	0	243670	19059056		
27968	2315	46233988	1978-08-23	1978-08-23 00:00:00	1978-09-06	1978-09-06 00:00:00	1978-09-06	38000177		0	0	14		0	0	0	153964	0	1652673	46233988		
45407	3756	1713671	1985-10-01	1985-10-01 00:00:00	1985-10-15	1985-10-15 00:00:00	1985-10-15	38000177		0	0	14		0	0	0	249642	0	562251	1713671		
45968	3807	1127433	1951-10-27	1951-10-27 00:00:00	1951-11-10	1951-11-10 00:00:00	1951-11-10	38000177		0	0	14		0	0	0	252968	0	313782	1127433		
190783	4191	40213160	1958-04-25	1958-04-25 00:00:00	1958-04-25	1958-04-25 00:00:00	1958-04-25	581452		0	0	0		0	0	0	278167	0	10	40213160		
15139	1265	40232448	1983-06-01	1983-06-01 00:00:00	1983-06-01	1983-06-01 00:00:00	\N	38000177		0	0	0		0	0	0	83413	0	1049630	40232448		
219393	4815	40213296	2011-02-03	2011-02-03 00:00:00	2011-02-03	2011-02-03 00:00:00	2011-02-03	581452		0	0	0		0	0	0	320327	0	52	40213296		
10338	864	19059056	1939-10-06	1939-10-06 00:00:00	1939-10-27	1939-10-27 00:00:00	1939-10-27	38000177		0	0	21		0	0	0	57279	0	243670	19059056		
239264	5252	40213160	1962-11-13	1962-11-13 00:00:00	1962-11-13	1962-11-13 00:00:00	1962-11-13	581452		0	0	0		0	0	0	349405	0	10	40213160		
101210	2218	40213160	1978-10-31	1978-10-31 00:00:00	1978-10-31	1978-10-31 00:00:00	1978-10-31	581452		0	0	0		0	0	0	147763	0	10	40213160		
8758	730	1115171	2000-04-02	2000-04-02 00:00:00	2000-05-07	2000-05-07 00:00:00	2000-05-07	38000177		0	0	35		0	0	0	48503	0	849574	1115171		
20977	1727	40229134	2004-09-10	2004-09-10 00:00:00	2004-09-24	2004-09-24 00:00:00	2004-09-24	38000177		0	0	14		0	0	0	115441	0	1043400	40229134		
27561	2283	19075601	2018-11-19	2018-11-19 00:00:00	2018-11-19	2018-11-19 00:00:00	\N	38000177		0	0	0		0	0	0	151872	0	309362	19075601		
112687	2476	40213296	1996-10-09	1996-10-09 00:00:00	1996-10-09	1996-10-09 00:00:00	1996-10-09	581452		0	0	0		0	0	0	164056	0	52	40213296		
27643	2289	19133873	1953-02-28	1953-02-28 00:00:00	1953-03-10	1953-03-10 00:00:00	1953-03-10	38000177		0	0	10		0	0	0	152215	0	834061	19133873		
41765	911	40213160	1981-02-15	1981-02-15 00:00:00	1981-02-15	1981-02-15 00:00:00	1981-02-15	581452		0	0	0		0	0	0	60499	0	10	40213160		
130244	2862	40213227	2018-11-16	2018-11-16 00:00:00	2018-11-16	2018-11-16 00:00:00	2018-11-16	581452		0	0	0		0	0	0	190268	0	113	40213227		
47076	3901	40229134	1990-06-10	1990-06-10 00:00:00	1990-06-17	1990-06-17 00:00:00	1990-06-17	38000177		0	0	7		0	0	0	259405	0	1043400	40229134		
197383	4337	40213160	1961-11-17	1961-11-17 00:00:00	1961-11-17	1961-11-17 00:00:00	1961-11-17	581452		0	0	0		0	0	0	287568	0	10	40213160		
54746	4547	1713671	2001-07-14	2001-07-14 00:00:00	2001-07-28	2001-07-28 00:00:00	2001-07-28	38000177		0	0	14		0	0	0	302904	0	562251	1713671		
42327	3510	1127433	1951-02-12	1951-02-12 00:00:00	1951-04-13	1951-04-13 00:00:00	1951-04-13	38000177		0	0	60		0	0	0	232796	0	313782	1127433		
5767	482	1127433	2013-12-18	2013-12-18 00:00:00	2014-01-01	2014-01-01 00:00:00	2014-01-01	38000177		0	0	14		0	0	0	32258	0	313782	1127433		
57647	1261	40213306	1990-06-16	1990-06-16 00:00:00	1990-06-16	1990-06-16 00:00:00	1990-06-16	581452		0	0	0		0	0	0	\N	0	43	40213306		
153677	3382	40213260	2012-11-15	2012-11-15 00:00:00	2012-11-15	2012-11-15 00:00:00	2012-11-15	581452		0	0	0		0	0	0	224474	0	121	40213260		
29822	2470	920300	1998-02-20	1998-02-20 00:00:00	1998-02-27	1998-02-27 00:00:00	1998-02-27	38000177		0	0	7		0	0	0	163767	0	311989	920300		
43711	3622	19059056	1925-02-07	1925-02-07 00:00:00	1925-04-08	1925-04-08 00:00:00	1925-04-08	38000177		0	0	60		0	0	0	240709	0	243670	19059056		
127819	2812	40213227	1999-07-26	1999-07-26 00:00:00	1999-07-26	1999-07-26 00:00:00	1999-07-26	581452		0	0	0		0	0	0	\N	0	113	40213227		
40458	3353	40229134	1978-08-02	1978-08-02 00:00:00	1978-08-16	1978-08-16 00:00:00	1978-08-16	38000177		0	0	14		0	0	0	222383	0	1043400	40229134		
51673	4295	1115171	1997-12-18	1997-12-18 00:00:00	1998-01-08	1998-01-08 00:00:00	1998-01-08	38000177		0	0	21		0	0	0	285077	0	849574	1115171		
72253	1578	40213227	2008-06-08	2008-06-08 00:00:00	2008-06-08	2008-06-08 00:00:00	2008-06-08	581452		0	0	0		0	0	0	105953	0	113	40213227		
113252	2487	40213160	1955-02-06	1955-02-06 00:00:00	1955-02-06	1955-02-06 00:00:00	1955-02-06	581452		0	0	0		0	0	0	164815	0	10	40213160		
137482	3017	40213296	1999-04-02	1999-04-02 00:00:00	1999-04-02	1999-04-02 00:00:00	1999-04-02	581452		0	0	0		0	0	0	201294	0	52	40213296		
17925	388	40213227	2016-09-06	2016-09-06 00:00:00	2016-09-06	2016-09-06 00:00:00	2016-09-06	581452		0	0	0		0	0	0	25550	0	113	40213227		
150730	3315	40213260	2007-04-28	2007-04-28 00:00:00	2007-04-28	2007-04-28 00:00:00	2007-04-28	581452		0	0	0		0	0	0	220198	0	121	40213260		
118300	2602	40213227	1999-10-06	1999-10-06 00:00:00	1999-10-06	1999-10-06 00:00:00	1999-10-06	581452		0	0	0		0	0	0	172119	0	113	40213227		
25632	2108	1713671	1955-10-12	1955-10-12 00:00:00	1955-10-19	1955-10-19 00:00:00	1955-10-19	38000177		0	0	7		0	0	0	140394	0	562251	1713671		
48306	4006	1127078	1950-09-12	1950-09-12 00:00:00	1950-09-26	1950-09-26 00:00:00	1950-09-26	38000177		0	0	14		0	0	0	266184	0	282464	1127078		
58797	4884	19078461	2006-12-06	2006-12-06 00:00:00	2006-12-27	2006-12-27 00:00:00	2006-12-27	38000177		0	0	21		0	0	0	324742	0	310965	19078461		
55919	4642	1127433	1965-10-05	1965-10-05 00:00:00	1965-10-12	1965-10-12 00:00:00	1965-10-12	38000177		0	0	7		0	0	0	309356	0	313782	1127433		
238338	5232	40213296	2007-11-24	2007-11-24 00:00:00	2007-11-24	2007-11-24 00:00:00	2007-11-24	581452		0	0	0		0	0	0	348126	0	52	40213296		
21466	1764	1713671	1977-11-01	1977-11-01 00:00:00	1977-11-15	1977-11-15 00:00:00	1977-11-15	38000177		0	0	14		0	0	0	117996	0	562251	1713671		
30183	2501	1127433	1997-06-15	1997-06-15 00:00:00	1997-06-29	1997-06-29 00:00:00	1997-06-29	38000177		0	0	14		0	0	0	165577	0	313782	1127433		
7803	652	1713671	1993-09-03	1993-09-03 00:00:00	1993-09-17	1993-09-17 00:00:00	1993-09-17	38000177		0	0	14		0	0	0	43143	0	562251	1713671		
77402	1692	40213314	1977-01-24	1977-01-24 00:00:00	1977-01-24	1977-01-24 00:00:00	1977-01-24	581452		0	0	0		0	0	0	113329	0	49	40213314		
7909	662	1127433	1989-03-01	1989-03-01 00:00:00	1989-03-15	1989-03-15 00:00:00	1989-03-15	38000177		0	0	14		0	0	0	43743	0	313782	1127433		
29046	2402	1713671	2003-03-01	2003-03-01 00:00:00	2003-03-08	2003-03-08 00:00:00	2003-03-08	38000177		0	0	7		0	0	0	159638	0	562251	1713671		
124413	2736	40213160	1970-01-14	1970-01-14 00:00:00	1970-01-14	1970-01-14 00:00:00	1970-01-14	581452		0	0	0		0	0	0	181108	0	10	40213160		
60108	4998	19008572	1987-08-24	1987-08-24 00:00:00	1987-09-07	1987-09-07 00:00:00	1987-09-07	38000177		0	0	14		0	0	0	332330	0	106258	19008572		
37782	3123	19127922	2002-05-06	2002-05-06 00:00:00	2003-05-01	2003-05-01 00:00:00	2003-05-01	38000177		0	0	360		0	0	0	207839	0	748962	19127922		
48796	4044	1127433	1999-04-29	1999-04-29 00:00:00	1999-05-06	1999-05-06 00:00:00	1999-05-06	38000177		0	0	7		0	0	0	268972	0	313782	1127433		
166531	3660	40213227	1994-09-24	1994-09-24 00:00:00	1994-09-24	1994-09-24 00:00:00	1994-09-24	581452		0	0	0		0	0	0	243578	0	113	40213227		
18151	1505	1127078	1954-12-29	1954-12-29 00:00:00	1955-01-12	1955-01-12 00:00:00	1955-01-12	38000177		0	0	14		0	0	0	100316	0	282464	1127078		
18223	1510	19078461	2014-01-06	2014-01-06 00:00:00	2014-01-20	2014-01-20 00:00:00	2014-01-20	38000177		0	0	14		0	0	0	100794	0	310965	19078461		
4833	403	1713671	1935-08-08	1935-08-08 00:00:00	1935-08-22	1935-08-22 00:00:00	1935-08-22	38000177		0	0	14		0	0	0	26490	0	562251	1713671		
117150	2574	40213296	2003-01-14	2003-01-14 00:00:00	2003-01-14	2003-01-14 00:00:00	2003-01-14	581452		0	0	0		0	0	0	170491	0	52	40213296		
51617	4289	1713671	2001-11-23	2001-11-23 00:00:00	2001-12-14	2001-12-14 00:00:00	2001-12-14	38000177		0	0	21		0	0	0	284766	0	562251	1713671		
44034	959	40213306	1982-01-27	1982-01-27 00:00:00	1982-01-27	1982-01-27 00:00:00	1982-01-27	581452		0	0	0		0	0	0	63758	0	43	40213306		
62186	5174	1127433	1960-10-26	1960-10-26 00:00:00	1960-11-09	1960-11-09 00:00:00	1960-11-09	38000177		0	0	14		0	0	0	344024	0	313782	1127433		
75958	1659	40213296	2011-03-28	2011-03-28 00:00:00	2011-03-28	2011-03-28 00:00:00	2011-03-28	581452		0	0	0		0	0	0	111452	0	52	40213296		
50437	4191	19133905	1977-07-10	1977-07-10 00:00:00	1977-07-22	1977-07-22 00:00:00	1977-07-22	38000177		0	0	12		0	0	0	278126	0	834102	19133905		
67058	1467	40213227	2004-05-30	2004-05-30 00:00:00	2004-05-30	2004-05-30 00:00:00	2004-05-30	581452		0	0	0		0	0	0	97690	0	113	40213227		
56655	4701	1127433	2008-11-02	2008-11-02 00:00:00	2008-11-16	2008-11-16 00:00:00	2008-11-16	38000177		0	0	14		0	0	0	313163	0	313782	1127433		
61011	5073	1127433	1976-11-29	1976-11-29 00:00:00	1976-12-27	1976-12-27 00:00:00	1976-12-27	38000177		0	0	28		0	0	0	337164	0	313782	1127433		
55568	4613	1127433	1996-02-15	1996-02-15 00:00:00	1996-02-22	1996-02-22 00:00:00	1996-02-22	38000177		0	0	7		0	0	0	307260	0	313782	1127433		
45835	3793	19133905	2002-02-06	2002-02-06 00:00:00	2002-02-17	2002-02-17 00:00:00	2002-02-17	38000177		0	0	11		0	0	0	252183	0	834102	19133905		
27969	2315	19059056	1978-08-23	1978-08-23 00:00:00	1978-09-06	1978-09-06 00:00:00	1978-09-06	38000177		0	0	14		0	0	0	153964	0	243670	19059056		
45408	3756	1124300	1976-06-25	1976-06-25 00:00:00	1976-06-25	1976-06-25 00:00:00	\N	38000177		0	0	0		0	0	0	249633	0	00781178901	45011828		
45969	3807	19059056	1949-08-23	1949-08-23 00:00:00	1949-09-06	1949-09-06 00:00:00	1949-09-06	38000177		0	0	14		0	0	0	252980	0	243670	19059056		
202095	4437	40213296	2012-07-04	2012-07-04 00:00:00	2012-07-04	2012-07-04 00:00:00	2012-07-04	581452		0	0	0		0	0	0	294938	0	52	40213296		
15140	1265	19074843	1981-04-06	1981-04-06 00:00:00	1981-04-20	1981-04-20 00:00:00	1981-04-20	38000177		0	0	14		0	0	0	83425	0	309045	19074843		
219396	4815	40213160	1970-08-13	1970-08-13 00:00:00	1970-08-13	1970-08-13 00:00:00	1970-08-13	581452		0	0	0		0	0	0	320332	0	10	40213160		
10339	864	1127433	1988-09-28	1988-09-28 00:00:00	1988-10-19	1988-10-19 00:00:00	1988-10-19	38000177		0	0	21		0	0	0	57324	0	313782	1127433		
105265	2309	40213296	2013-04-12	2013-04-12 00:00:00	2013-04-12	2013-04-12 00:00:00	2013-04-12	581452		0	0	0		0	0	0	153666	0	52	40213296		
18918	410	40213201	2016-02-04	2016-02-04 00:00:00	2016-02-04	2016-02-04 00:00:00	2016-02-04	581452		0	0	0		0	0	0	27251	0	33	40213201		
8759	730	19133873	1973-12-18	1973-12-18 00:00:00	1973-12-28	1973-12-28 00:00:00	1973-12-28	38000177		0	0	10		0	0	0	48457	0	834061	19133873		
20978	1727	1713671	1973-06-26	1973-06-26 00:00:00	1973-07-17	1973-07-17 00:00:00	1973-07-17	38000177		0	0	21		0	0	0	115522	0	562251	1713671		
27562	2283	1539411	2018-11-19	2018-11-19 00:00:00	2018-11-19	2018-11-19 00:00:00	\N	38000177		0	0	0		0	0	0	151872	0	312961	1539411		
112700	2476	40213296	1998-10-14	1998-10-14 00:00:00	1998-10-14	1998-10-14 00:00:00	1998-10-14	581452		0	0	0		0	0	0	164078	0	52	40213296		
27644	2289	19129655	1963-01-19	1963-01-19 00:00:00	1963-02-02	1963-02-02 00:00:00	1963-02-02	38000177		0	0	14		0	0	0	152235	0	789980	19129655		
41768	911	40213314	1977-08-14	1977-08-14 00:00:00	1977-08-14	1977-08-14 00:00:00	1977-08-14	581452		0	0	0		0	0	0	60474	0	49	40213314		
41793	911	40213227	2008-10-12	2008-10-12 00:00:00	2008-10-12	2008-10-12 00:00:00	2008-10-12	581452		0	0	0		0	0	0	60516	0	113	40213227		
47077	3901	1713671	1992-08-17	1992-08-17 00:00:00	1992-08-24	1992-08-24 00:00:00	1992-08-24	38000177		0	0	7		0	0	0	259446	0	562251	1713671		
215229	4720	40213314	1977-07-26	1977-07-26 00:00:00	1977-07-26	1977-07-26 00:00:00	1977-07-26	581452		0	0	0		0	0	0	314354	0	49	40213314		
54747	4547	1127433	2016-10-02	2016-10-02 00:00:00	2016-12-01	2016-12-01 00:00:00	2016-12-01	38000177		0	0	60		0	0	0	302964	0	313782	1127433		
42328	3510	19133873	1952-05-09	1952-05-09 00:00:00	1952-05-17	1952-05-17 00:00:00	1952-05-17	38000177		0	0	8		0	0	0	232962	0	834061	19133873		
5768	482	19128065	1983-10-20	1983-10-20 00:00:00	1984-10-14	1984-10-14 00:00:00	1984-10-14	38000177		0	0	360		0	0	0	32233	0	749882	19128065		
57649	1261	40213306	1990-06-23	1990-06-23 00:00:00	1990-06-23	1990-06-23 00:00:00	1990-06-23	581452		0	0	0		0	0	0	83253	0	43	40213306		
153680	3383	40213180	2005-06-16	2005-06-16 00:00:00	2005-06-16	2005-06-16 00:00:00	2005-06-16	581452		0	0	0		0	0	0	224514	0	114	40213180		
29823	2470	1115171	2015-08-07	2015-08-07 00:00:00	2015-08-28	2015-08-28 00:00:00	2015-08-28	38000177		0	0	21		0	0	0	163797	0	849574	1115171		
43712	3622	1127433	1993-07-20	1993-07-20 00:00:00	1993-07-27	1993-07-27 00:00:00	1993-07-27	38000177		0	0	7		0	0	0	240677	0	313782	1127433		
127849	2812	40213227	1992-12-21	1992-12-21 00:00:00	1992-12-21	1992-12-21 00:00:00	1992-12-21	581452		0	0	0		0	0	0	186338	0	113	40213227		
40459	3353	1127433	1933-03-03	1933-03-03 00:00:00	1933-03-10	1933-03-10 00:00:00	1933-03-10	38000177		0	0	7		0	0	0	222389	0	313782	1127433		
51674	4295	1713671	1995-07-09	1995-07-09 00:00:00	1995-07-23	1995-07-23 00:00:00	1995-07-23	38000177		0	0	14		0	0	0	285062	0	562251	1713671		
4415	366	1127433	1987-01-14	1987-01-14 00:00:00	1987-01-28	1987-01-28 00:00:00	1987-01-28	38000177		0	0	14		0	0	0	24323	0	313782	1127433		
113254	2487	40213296	1996-03-17	1996-03-17 00:00:00	1996-03-17	1996-03-17 00:00:00	1996-03-17	581452		0	0	0		0	0	0	164778	0	52	40213296		
137485	3017	40213160	1962-07-27	1962-07-27 00:00:00	1962-07-27	1962-07-27 00:00:00	1962-07-27	581452		0	0	0		0	0	0	201219	0	10	40213160		
17935	388	40213160	1959-07-28	1959-07-28 00:00:00	1959-07-28	1959-07-28 00:00:00	1959-07-28	581452		0	0	0		0	0	0	25559	0	10	40213160		
31196	680	40213160	1972-09-04	1972-09-04 00:00:00	1972-09-04	1972-09-04 00:00:00	1972-09-04	581452		0	0	0		0	0	0	44978	0	10	40213160		
118313	2602	40213227	1993-06-09	1993-06-09 00:00:00	1993-06-09	1993-06-09 00:00:00	1993-06-09	581452		0	0	0		0	0	0	172128	0	113	40213227		
25633	2108	19018935	2018-12-28	2018-12-28 00:00:00	2018-12-28	2018-12-28 00:00:00	\N	38000177		0	0	0		0	0	0	140382	0	197604	19018935		
58765	4881	19133905	1992-03-16	1992-03-16 00:00:00	1992-03-29	1992-03-29 00:00:00	1992-03-29	38000177		0	0	13		0	0	0	324537	0	834102	19133905		
58798	4884	19133873	1975-11-09	1975-11-09 00:00:00	1975-11-16	1975-11-16 00:00:00	1975-11-16	38000177		0	0	7		0	0	0	324743	0	834061	19133873		
55920	4642	1124300	1991-11-06	1991-11-06 00:00:00	1991-11-06	1991-11-06 00:00:00	\N	38000177		0	0	0		0	0	0	309363	0	00781178901	45011828		
238344	5232	40213160	1968-06-15	1968-06-15 00:00:00	1968-06-15	1968-06-15 00:00:00	1968-06-15	581452		0	0	0		0	0	0	348103	0	10	40213160		
21467	1764	19073188	1993-05-28	1993-05-28 00:00:00	1993-06-18	1993-06-18 00:00:00	1993-06-18	38000177		0	0	21		0	0	0	117990	0	308192	19073188		
30195	2503	1127433	1986-10-10	1986-10-10 00:00:00	1986-11-07	1986-11-07 00:00:00	1986-11-07	38000177		0	0	28		0	0	0	165649	0	313782	1127433		
7804	652	1127433	2017-10-31	2017-10-31 00:00:00	2017-11-21	2017-11-21 00:00:00	2017-11-21	38000177		0	0	21		0	0	0	43130	0	313782	1127433		
77403	1692	40213160	1977-01-24	1977-01-24 00:00:00	1977-01-24	1977-01-24 00:00:00	1977-01-24	581452		0	0	0		0	0	0	113329	0	10	40213160		
7910	662	19078461	2018-02-05	2018-02-05 00:00:00	2018-02-26	2018-02-26 00:00:00	2018-02-26	38000177		0	0	21		0	0	0	43755	0	310965	19078461		
29047	2404	19133905	2003-07-14	2003-07-14 00:00:00	2003-07-21	2003-07-21 00:00:00	2003-07-21	38000177		0	0	7		0	0	0	159713	0	834102	19133905		
124417	2736	40213227	2011-05-18	2011-05-18 00:00:00	2011-05-18	2011-05-18 00:00:00	2011-05-18	581452		0	0	0		0	0	0	181099	0	113	40213227		
60109	4998	19134077	1987-08-24	1987-08-24 00:00:00	1987-09-07	1987-09-07 00:00:00	1987-09-07	38000177		0	0	14		0	0	0	332330	0	835900	19134077		
37783	3123	1551192	1978-02-02	1978-02-02 00:00:00	1978-02-02	1978-02-02 00:00:00	1978-02-02	38000177		0	0	0		0	0	0	207816	0	312617	1551192		
48797	4044	1115171	1997-03-18	1997-03-18 00:00:00	1997-04-08	1997-04-08 00:00:00	1997-04-08	38000177		0	0	21		0	0	0	268991	0	849574	1115171		
166532	3660	40213306	1994-09-24	1994-09-24 00:00:00	1994-09-24	1994-09-24 00:00:00	1994-09-24	581452		0	0	0		0	0	0	243578	0	43	40213306		
18152	1505	19006318	1954-12-29	1954-12-29 00:00:00	1955-01-12	1955-01-12 00:00:00	1955-01-12	38000177		0	0	14		0	0	0	100316	0	105078	19006318		
18224	1510	1713671	1959-01-08	1959-01-08 00:00:00	1959-01-22	1959-01-22 00:00:00	1959-01-22	38000177		0	0	14		0	0	0	100772	0	562251	1713671		
4834	403	19078461	1996-08-02	1996-08-02 00:00:00	1996-08-23	1996-08-23 00:00:00	1996-08-23	38000177		0	0	21		0	0	0	26466	0	310965	19078461		
117152	2574	40213227	2003-01-14	2003-01-14 00:00:00	2003-01-14	2003-01-14 00:00:00	2003-01-14	581452		0	0	0		0	0	0	170491	0	113	40213227		
51618	4289	1127433	1967-01-28	1967-01-28 00:00:00	1967-02-18	1967-02-18 00:00:00	1967-02-18	38000177		0	0	21		0	0	0	284742	0	313782	1127433		
28784	625	40213227	1995-06-27	1995-06-27 00:00:00	1995-06-27	1995-06-27 00:00:00	1995-06-27	581452		0	0	0		0	0	0	41757	0	113	40213227		
62187	5174	1124300	1981-01-07	1981-01-07 00:00:00	1981-01-07	1981-01-07 00:00:00	\N	38000177		0	0	0		0	0	0	343996	0	00781178901	45011828		
75963	1659	40213227	2000-04-03	2000-04-03 00:00:00	2000-04-03	2000-04-03 00:00:00	2000-04-03	581452		0	0	0		0	0	0	111540	0	113	40213227		
50438	4191	40229134	1999-08-15	1999-08-15 00:00:00	1999-08-29	1999-08-29 00:00:00	1999-08-29	38000177		0	0	14		0	0	0	278129	0	1043400	40229134		
67073	1467	40213227	1994-08-28	1994-08-28 00:00:00	1994-08-28	1994-08-28 00:00:00	1994-08-28	581452		0	0	0		0	0	0	97727	0	113	40213227		
56656	4701	40229134	1975-06-06	1975-06-06 00:00:00	1975-06-20	1975-06-20 00:00:00	1975-06-20	38000177		0	0	14		0	0	0	313134	0	1043400	40229134		
61012	5073	19059056	1946-03-07	1946-03-07 00:00:00	1946-04-11	1946-04-11 00:00:00	1946-04-11	38000177		0	0	35		0	0	0	337161	0	243670	19059056		
55569	4613	43012433	2013-11-30	2013-11-30 00:00:00	2014-11-25	2014-11-25 00:00:00	2014-11-25	38000177		0	0	360		0	0	0	307236	0	1367439	43012433		
45836	3793	19059056	1944-12-01	1944-12-01 00:00:00	1945-01-05	1945-01-05 00:00:00	1945-01-05	38000177		0	0	35		0	0	0	252274	0	243670	19059056		
27970	2315	19019979	1984-01-24	1984-01-24 00:00:00	1984-02-21	1984-02-21 00:00:00	1984-02-21	38000177		0	0	28		0	0	0	153945	0	198405	19019979		
45409	3756	19059056	1941-02-19	1941-02-19 00:00:00	1941-03-05	1941-03-05 00:00:00	1941-03-05	38000177		0	0	14		0	0	0	249651	0	243670	19059056		
45970	3807	19006318	1949-08-23	1949-08-23 00:00:00	1949-09-06	1949-09-06 00:00:00	1949-09-06	38000177		0	0	14		0	0	0	252980	0	105078	19006318		
202098	4437	40213160	1973-12-19	1973-12-19 00:00:00	1973-12-19	1973-12-19 00:00:00	1973-12-19	581452		0	0	0		0	0	0	294892	0	10	40213160		
15141	1265	1127078	1981-04-06	1981-04-06 00:00:00	1981-04-20	1981-04-20 00:00:00	1981-04-20	38000177		0	0	14		0	0	0	83425	0	282464	1127078		
219397	4815	40213160	1975-02-13	1975-02-13 00:00:00	1975-02-13	1975-02-13 00:00:00	1975-02-13	581452		0	0	0		0	0	0	320323	0	10	40213160		
10340	864	1127433	1960-03-18	1960-03-18 00:00:00	1960-03-25	1960-03-25 00:00:00	1960-03-25	38000177		0	0	7		0	0	0	57261	0	313782	1127433		
105267	2309	40213227	2015-04-17	2015-04-17 00:00:00	2015-04-17	2015-04-17 00:00:00	2015-04-17	581452		0	0	0		0	0	0	153658	0	113	40213227		
18922	410	40213227	1992-11-19	1992-11-19 00:00:00	1992-11-19	1992-11-19 00:00:00	1992-11-19	581452		0	0	0		0	0	0	27181	0	113	40213227		
8760	730	19006318	1962-02-07	1962-02-07 00:00:00	1962-02-21	1962-02-21 00:00:00	1962-02-21	38000177		0	0	14		0	0	0	48470	0	105078	19006318		
20979	1727	1713671	1952-11-15	1952-11-15 00:00:00	1952-11-22	1952-11-22 00:00:00	1952-11-22	38000177		0	0	7		0	0	0	115512	0	562251	1713671		
27563	2283	1332419	2018-11-19	2018-11-19 00:00:00	2018-11-19	2018-11-19 00:00:00	\N	38000177		0	0	0		0	0	0	151872	0	197361	1332419		
112702	2476	40213227	1998-10-14	1998-10-14 00:00:00	1998-10-14	1998-10-14 00:00:00	1998-10-14	581452		0	0	0		0	0	0	164078	0	113	40213227		
27645	2289	1127433	1963-01-19	1963-01-19 00:00:00	1963-02-02	1963-02-02 00:00:00	1963-02-02	38000177		0	0	14		0	0	0	152235	0	313782	1127433		
41772	911	40213160	1976-08-15	1976-08-15 00:00:00	1976-08-15	1976-08-15 00:00:00	1976-08-15	581452		0	0	0		0	0	0	60495	0	10	40213160		
41796	911	40213227	1998-12-13	1998-12-13 00:00:00	1998-12-13	1998-12-13 00:00:00	1998-12-13	581452		0	0	0		0	0	0	60486	0	113	40213227		
47078	3901	19133873	1939-12-29	1939-12-29 00:00:00	1940-01-06	1940-01-06 00:00:00	1940-01-06	38000177		0	0	8		0	0	0	259341	0	834061	19133873		
215231	4720	40213227	2008-02-26	2008-02-26 00:00:00	2008-02-26	2008-02-26 00:00:00	2008-02-26	581452		0	0	0		0	0	0	314348	0	113	40213227		
54748	4547	1127433	1943-10-17	1943-10-17 00:00:00	1943-10-24	1943-10-24 00:00:00	1943-10-24	38000177		0	0	7		0	0	0	302843	0	313782	1127433		
42329	3510	19133905	1996-05-19	1996-05-19 00:00:00	1996-05-31	1996-05-31 00:00:00	1996-05-31	38000177		0	0	12		0	0	0	232930	0	834102	19133905		
5769	482	19059056	1971-11-12	1971-11-12 00:00:00	1972-02-10	1972-02-10 00:00:00	1972-02-10	38000177		0	0	90		0	0	0	32227	0	243670	19059056		
57651	1261	40213160	1974-12-14	1974-12-14 00:00:00	1974-12-14	1974-12-14 00:00:00	1974-12-14	581452		0	0	0		0	0	0	83158	0	10	40213160		
153684	3383	40213314	1986-09-25	1986-09-25 00:00:00	1986-09-25	1986-09-25 00:00:00	1986-09-25	581452		0	0	0		0	0	0	224507	0	49	40213314		
29824	2470	1127433	2000-01-11	2000-01-11 00:00:00	2000-01-18	2000-01-18 00:00:00	2000-01-18	38000177		0	0	7		0	0	0	163819	0	313782	1127433		
43713	3622	1713671	1970-11-02	1970-11-02 00:00:00	1970-11-09	1970-11-09 00:00:00	1970-11-09	38000177		0	0	7		0	0	0	240792	0	562251	1713671		
57275	4754	1713671	2012-09-04	2012-09-04 00:00:00	2012-09-11	2012-09-11 00:00:00	2012-09-11	38000177		0	0	7		0	0	0	316645	0	562251	1713671		
40460	3353	1127433	1930-03-03	1930-03-03 00:00:00	1930-03-17	1930-03-17 00:00:00	1930-03-17	38000177		0	0	14		0	0	0	222368	0	313782	1127433		
51675	4295	1713671	1975-10-09	1975-10-09 00:00:00	1975-10-30	1975-10-30 00:00:00	1975-10-30	38000177		0	0	21		0	0	0	285061	0	562251	1713671		
4416	366	19059056	1923-01-17	1923-01-17 00:00:00	1923-02-07	1923-02-07 00:00:00	1923-02-07	38000177		0	0	21		0	0	0	24352	0	243670	19059056		
113259	2487	40213227	2014-01-26	2014-01-26 00:00:00	2014-01-26	2014-01-26 00:00:00	2014-01-26	581452		0	0	0		0	0	0	164774	0	113	40213227		
137497	3017	40213260	2008-05-23	2008-05-23 00:00:00	2008-05-23	2008-05-23 00:00:00	2008-05-23	581452		0	0	0		0	0	0	201235	0	121	40213260		
17937	388	40213160	1955-08-23	1955-08-23 00:00:00	1955-08-23	1955-08-23 00:00:00	1955-08-23	581452		0	0	0		0	0	0	25508	0	10	40213160		
31198	680	40213260	2018-01-15	2018-01-15 00:00:00	2018-01-15	2018-01-15 00:00:00	2018-01-15	581452		0	0	0		0	0	0	45068	0	121	40213260		
120482	2649	40213227	2018-07-02	2018-07-02 00:00:00	2018-07-02	2018-07-02 00:00:00	2018-07-02	581452		0	0	0		0	0	0	175320	0	113	40213227		
25634	2108	40171902	2018-12-28	2018-12-28 00:00:00	2018-12-28	2018-12-28 00:00:00	\N	38000177		0	0	0		0	0	0	140382	0	897718	40171902		
58766	4881	19133905	2018-03-14	2018-03-14 00:00:00	2018-03-24	2018-03-24 00:00:00	2018-03-24	38000177		0	0	10		0	0	0	324539	0	834102	19133905		
58799	4884	19129655	1973-03-20	1973-03-20 00:00:00	1973-04-03	1973-04-03 00:00:00	1973-04-03	38000177		0	0	14		0	0	0	324752	0	789980	19129655		
55921	4642	1551192	1957-06-06	1957-06-06 00:00:00	1957-06-06	1957-06-06 00:00:00	1957-06-06	38000177		0	0	0		0	0	0	309391	0	312617	1551192		
238345	5232	40213160	1968-03-16	1968-03-16 00:00:00	1968-03-16	1968-03-16 00:00:00	1968-03-16	581452		0	0	0		0	0	0	348085	0	10	40213160		
21468	1764	1127433	1993-05-28	1993-05-28 00:00:00	1993-06-18	1993-06-18 00:00:00	1993-06-18	38000177		0	0	21		0	0	0	117990	0	313782	1127433		
30196	2503	19129655	1975-03-12	1975-03-12 00:00:00	1975-03-26	1975-03-26 00:00:00	1975-03-26	38000177		0	0	14		0	0	0	165765	0	789980	19129655		
7805	652	1118084	2007-01-14	2007-01-14 00:00:00	2007-01-14	2007-01-14 00:00:00	\N	38000177		0	0	0		0	0	0	43169	0	00025152531	44923712		
77405	1692	40213296	2016-08-22	2016-08-22 00:00:00	2016-08-22	2016-08-22 00:00:00	2016-08-22	581452		0	0	0		0	0	0	113359	0	52	40213296		
7911	662	19075601	1998-03-24	1998-03-24 00:00:00	2012-06-06	2012-06-06 00:00:00	2012-06-06	38000177		0	0	5188		0	0	0	43694	0	309362	19075601		
29048	2404	1124300	2008-04-18	2008-04-18 00:00:00	2008-04-18	2008-04-18 00:00:00	\N	38000177		0	0	0		0	0	0	159732	0	00781178901	45011828		
124418	2736	40213296	2011-05-18	2011-05-18 00:00:00	2011-05-18	2011-05-18 00:00:00	2011-05-18	581452		0	0	0		0	0	0	181099	0	52	40213296		
60110	4998	1713671	2015-03-25	2015-03-25 00:00:00	2015-04-01	2015-04-01 00:00:00	2015-04-01	38000177		0	0	7		0	0	0	332334	0	562251	1713671		
37784	3123	19128065	1991-07-03	1991-07-03 00:00:00	1992-06-27	1992-06-27 00:00:00	1992-06-27	38000177		0	0	360		0	0	0	207772	0	749882	19128065		
48798	4044	1127433	2004-03-12	2004-03-12 00:00:00	2004-03-19	2004-03-19 00:00:00	2004-03-19	38000177		0	0	7		0	0	0	268952	0	313782	1127433		
166542	3661	40213296	2018-08-26	2018-08-26 00:00:00	2018-08-26	2018-08-26 00:00:00	2018-08-26	581452		0	0	0		0	0	0	243677	0	52	40213296		
18153	1505	19059056	1959-05-22	1959-05-22 00:00:00	1959-06-05	1959-06-05 00:00:00	1959-06-05	38000177		0	0	14		0	0	0	100388	0	243670	19059056		
18225	1510	1127433	2005-09-05	2005-09-05 00:00:00	2005-09-12	2005-09-12 00:00:00	2005-09-12	38000177		0	0	7		0	0	0	100861	0	313782	1127433		
4835	403	19059056	1991-08-29	1991-08-29 00:00:00	1991-10-28	1991-10-28 00:00:00	1991-10-28	38000177		0	0	60		0	0	0	26465	0	243670	19059056		
146327	3218	40213260	2006-10-29	2006-10-29 00:00:00	2006-10-29	2006-10-29 00:00:00	2006-10-29	581452		0	0	0		0	0	0	213853	0	121	40213260		
51619	4289	19133873	1944-11-07	1944-11-07 00:00:00	1944-11-19	1944-11-19 00:00:00	1944-11-19	38000177		0	0	12		0	0	0	284762	0	834061	19133873		
28785	625	40213306	1995-06-27	1995-06-27 00:00:00	1995-06-27	1995-06-27 00:00:00	1995-06-27	581452		0	0	0		0	0	0	41757	0	43	40213306		
62188	5174	40229134	1978-11-19	1978-11-19 00:00:00	1978-11-26	1978-11-26 00:00:00	1978-11-26	38000177		0	0	7		0	0	0	344039	0	1043400	40229134		
75965	1659	40213260	2019-03-18	2019-03-18 00:00:00	2019-03-18	2019-03-18 00:00:00	2019-03-18	581452		0	0	0		0	0	0	111526	0	121	40213260		
50439	4191	1127433	1973-08-24	1973-08-24 00:00:00	1973-08-31	1973-08-31 00:00:00	1973-08-31	38000177		0	0	7		0	0	0	278151	0	313782	1127433		
67075	1467	40213201	1999-05-02	1999-05-02 00:00:00	1999-05-02	1999-05-02 00:00:00	1999-05-02	581452		0	0	0		0	0	0	97784	0	33	40213201		
134629	2955	40213227	1992-01-21	1992-01-21 00:00:00	1992-01-21	1992-01-21 00:00:00	1992-01-21	581452		0	0	0		0	0	0	197217	0	113	40213227		
61013	5073	19059056	1937-06-01	1937-06-01 00:00:00	1937-06-22	1937-06-22 00:00:00	1937-06-22	38000177		0	0	21		0	0	0	337160	0	243670	19059056		
55570	4613	19132304	2014-11-25	2014-11-25 00:00:00	2015-11-25	2015-11-25 00:00:00	2015-11-25	38000177		0	0	365		0	0	0	307237	0	807283	19132304		
45837	3793	19059056	1959-05-22	1959-05-22 00:00:00	1959-06-12	1959-06-12 00:00:00	1959-06-12	38000177		0	0	21		0	0	0	252277	0	243670	19059056		
27971	2315	40229134	2002-03-31	2002-03-31 00:00:00	2002-04-07	2002-04-07 00:00:00	2002-04-07	38000177		0	0	7		0	0	0	153918	0	1043400	40229134		
45410	3756	19059056	1944-09-09	1944-09-09 00:00:00	1944-09-23	1944-09-23 00:00:00	1944-09-23	38000177		0	0	14		0	0	0	249613	0	243670	19059056		
45971	3807	19006318	1960-04-03	1960-04-03 00:00:00	1960-04-17	1960-04-17 00:00:00	1960-04-17	38000177		0	0	14		0	0	0	253002	0	105078	19006318		
118570	2609	40213306	1981-05-01	1981-05-01 00:00:00	1981-05-01	1981-05-01 00:00:00	1981-05-01	581452		0	0	0		0	0	0	172528	0	43	40213306		
15142	1265	19019979	1991-04-14	1991-04-14 00:00:00	1991-07-13	1991-07-13 00:00:00	1991-07-13	38000177		0	0	90		0	0	0	83398	0	198405	19019979		
219413	4815	40213160	1970-06-11	1970-06-11 00:00:00	1970-06-11	1970-06-11 00:00:00	1970-06-11	581452		0	0	0		0	0	0	320351	0	10	40213160		
10341	864	19133905	1967-12-16	1967-12-16 00:00:00	1967-12-25	1967-12-25 00:00:00	1967-12-25	38000177		0	0	9		0	0	0	57232	0	834102	19133905		
105268	2309	40213296	2015-04-17	2015-04-17 00:00:00	2015-04-17	2015-04-17 00:00:00	2015-04-17	581452		0	0	0		0	0	0	153658	0	52	40213296		
18927	410	40213160	1955-08-18	1955-08-18 00:00:00	1955-08-18	1955-08-18 00:00:00	1955-08-18	581452		0	0	0		0	0	0	27202	0	10	40213160		
8761	730	1127078	1962-02-07	1962-02-07 00:00:00	1962-02-21	1962-02-21 00:00:00	1962-02-21	38000177		0	0	14		0	0	0	48470	0	282464	1127078		
20989	1729	1115171	2004-03-03	2004-03-03 00:00:00	2004-04-07	2004-04-07 00:00:00	2004-04-07	38000177		0	0	35		0	0	0	115621	0	849574	1115171		
27564	2283	19126352	2018-11-19	2018-11-19 00:00:00	2018-11-19	2018-11-19 00:00:00	\N	38000177		0	0	0		0	0	0	151872	0	705129	19126352		
27571	2283	1713671	1962-10-06	1962-10-06 00:00:00	1962-10-27	1962-10-27 00:00:00	1962-10-27	38000177		0	0	21		0	0	0	151907	0	562251	1713671		
27646	2289	1127433	1955-11-01	1955-11-01 00:00:00	1955-11-15	1955-11-15 00:00:00	1955-11-15	38000177		0	0	14		0	0	0	152260	0	313782	1127433		
41775	911	40213314	1977-05-15	1977-05-15 00:00:00	1977-05-15	1977-05-15 00:00:00	1977-05-15	581452		0	0	0		0	0	0	60496	0	49	40213314		
41797	911	40213306	1998-12-13	1998-12-13 00:00:00	1998-12-13	1998-12-13 00:00:00	1998-12-13	581452		0	0	0		0	0	0	60486	0	43	40213306		
47079	3901	1713671	1954-06-29	1954-06-29 00:00:00	1954-07-20	1954-07-20 00:00:00	1954-07-20	38000177		0	0	21		0	0	0	259403	0	562251	1713671		
215235	4720	40213314	1977-01-25	1977-01-25 00:00:00	1977-01-25	1977-01-25 00:00:00	1977-01-25	581452		0	0	0		0	0	0	314394	0	49	40213314		
54749	4548	1150771	1986-11-07	1986-11-07 00:00:00	1986-11-07	1986-11-07 00:00:00	\N	38000177		0	0	0		0	0	0	303097	0	197378	1150771		
42330	3510	1713671	1973-04-18	1973-04-18 00:00:00	1973-04-25	1973-04-25 00:00:00	1973-04-25	38000177		0	0	7		0	0	0	232904	0	562251	1713671		
5770	482	1127433	1988-05-28	1988-05-28 00:00:00	1988-07-02	1988-07-02 00:00:00	1988-07-02	38000177		0	0	35		0	0	0	32230	0	313782	1127433		
57665	1261	40213227	2001-05-26	2001-05-26 00:00:00	2001-05-26	2001-05-26 00:00:00	2001-05-26	581452		0	0	0		0	0	0	83218	0	113	40213227		
153685	3383	40213160	1986-09-25	1986-09-25 00:00:00	1986-09-25	1986-09-25 00:00:00	1986-09-25	581452		0	0	0		0	0	0	224507	0	10	40213160		
29825	2470	1127433	2007-02-26	2007-02-26 00:00:00	2007-03-12	2007-03-12 00:00:00	2007-03-12	38000177		0	0	14		0	0	0	163820	0	313782	1127433		
43714	3623	19133873	1964-05-01	1964-05-01 00:00:00	1964-05-11	1964-05-11 00:00:00	1964-05-11	38000177		0	0	10		0	0	0	240892	0	834061	19133873		
57276	4754	1127433	1991-06-22	1991-06-22 00:00:00	1991-07-27	1991-07-27 00:00:00	1991-07-27	38000177		0	0	35		0	0	0	316637	0	313782	1127433		
40461	3353	1127433	1991-05-02	1991-05-02 00:00:00	1991-06-06	1991-06-06 00:00:00	1991-06-06	38000177		0	0	35		0	0	0	222451	0	313782	1127433		
51676	4295	1127433	2009-04-09	2009-04-09 00:00:00	2009-04-23	2009-04-23 00:00:00	2009-04-23	38000177		0	0	14		0	0	0	285045	0	313782	1127433		
4417	366	1127433	1949-05-31	1949-05-31 00:00:00	1949-06-07	1949-06-07 00:00:00	1949-06-07	38000177		0	0	7		0	0	0	24383	0	313782	1127433		
113261	2487	40213227	2003-03-09	2003-03-09 00:00:00	2003-03-09	2003-03-09 00:00:00	2003-03-09	581452		0	0	0		0	0	0	164779	0	113	40213227		
137500	3017	40213160	1958-04-25	1958-04-25 00:00:00	1958-04-25	1958-04-25 00:00:00	1958-04-25	581452		0	0	0		0	0	0	201217	0	10	40213160		
17940	388	40213260	2006-09-26	2006-09-26 00:00:00	2006-09-26	2006-09-26 00:00:00	2006-09-26	581452		0	0	0		0	0	0	25535	0	121	40213260		
31202	680	40213296	2007-10-01	2007-10-01 00:00:00	2007-10-01	2007-10-01 00:00:00	2007-10-01	581452		0	0	0		0	0	0	45066	0	52	40213296		
120483	2649	40213160	1958-02-10	1958-02-10 00:00:00	1958-02-10	1958-02-10 00:00:00	1958-02-10	581452		0	0	0		0	0	0	175277	0	10	40213160		
25635	2108	40163554	2018-12-28	2018-12-28 00:00:00	2018-12-28	2018-12-28 00:00:00	\N	38000177		0	0	0		0	0	0	140382	0	855332	40163554		
58767	4881	1127433	1994-04-19	1994-04-19 00:00:00	1994-05-17	1994-05-17 00:00:00	1994-05-17	38000177		0	0	28		0	0	0	324547	0	313782	1127433		
58800	4884	19059056	1973-03-20	1973-03-20 00:00:00	1973-04-03	1973-04-03 00:00:00	1973-04-03	38000177		0	0	14		0	0	0	324752	0	243670	19059056		
55924	4642	1127433	1962-05-08	1962-05-08 00:00:00	1962-05-22	1962-05-22 00:00:00	1962-05-22	38000177		0	0	14		0	0	0	309414	0	313782	1127433		
238347	5232	40213227	2000-12-30	2000-12-30 00:00:00	2000-12-30	2000-12-30 00:00:00	2000-12-30	581452		0	0	0		0	0	0	348092	0	113	40213227		
21469	1764	40231925	1993-05-28	1993-05-28 00:00:00	1993-05-28	1993-05-28 00:00:00	\N	38000177		0	0	0		0	0	0	117990	0	1049221	40231925		
30197	2503	1127078	1975-03-12	1975-03-12 00:00:00	1975-03-26	1975-03-26 00:00:00	1975-03-26	38000177		0	0	14		0	0	0	165765	0	282464	1127078		
7806	652	1127433	1971-08-28	1971-08-28 00:00:00	1971-09-11	1971-09-11 00:00:00	1971-09-11	38000177		0	0	14		0	0	0	43187	0	313782	1127433		
77411	1692	40213160	1981-07-27	1981-07-27 00:00:00	1981-07-27	1981-07-27 00:00:00	1981-07-27	581452		0	0	0		0	0	0	113333	0	10	40213160		
7912	662	19126352	1995-03-21	1995-03-21 00:00:00	2012-06-06	2012-06-06 00:00:00	2012-06-06	38000177		0	0	6287		0	0	0	43693	0	705129	19126352		
29049	2404	19059056	1975-12-04	1975-12-04 00:00:00	1975-12-18	1975-12-18 00:00:00	1975-12-18	38000177		0	0	14		0	0	0	159760	0	243670	19059056		
184117	4045	40213160	1974-07-27	1974-07-27 00:00:00	1974-07-27	1974-07-27 00:00:00	1974-07-27	581452		0	0	0		0	0	0	269018	0	10	40213160		
60111	4998	19078461	2007-03-28	2007-03-28 00:00:00	2007-04-18	2007-04-18 00:00:00	2007-04-18	38000177		0	0	21		0	0	0	332338	0	310965	19078461		
37785	3123	1127433	2016-10-06	2016-10-06 00:00:00	2016-10-13	2016-10-13 00:00:00	2016-10-13	38000177		0	0	7		0	0	0	207837	0	313782	1127433		
48799	4044	19059056	1965-08-05	1965-08-05 00:00:00	1965-09-02	1965-09-02 00:00:00	1965-09-02	38000177		0	0	28		0	0	0	268947	0	243670	19059056		
39714	866	40213227	1992-12-27	1992-12-27 00:00:00	1992-12-27	1992-12-27 00:00:00	1992-12-27	581452		0	0	0		0	0	0	57451	0	113	40213227		
18154	1505	19006318	1959-05-22	1959-05-22 00:00:00	1959-06-05	1959-06-05 00:00:00	1959-06-05	38000177		0	0	14		0	0	0	100388	0	105078	19006318		
18226	1510	40162522	1978-08-15	1978-08-15 00:00:00	1978-08-15	1978-08-15 00:00:00	\N	38000177		0	0	0		0	0	0	100787	0	857005	40162522		
4836	403	19078461	1988-08-14	1988-08-14 00:00:00	1988-09-13	1988-09-13 00:00:00	1988-09-13	38000177		0	0	30		0	0	0	26464	0	310965	19078461		
146340	3218	40213227	2007-11-04	2007-11-04 00:00:00	2007-11-04	2007-11-04 00:00:00	2007-11-04	581452		0	0	0		0	0	0	213842	0	113	40213227		
51620	4289	1713671	1968-12-18	1968-12-18 00:00:00	1968-12-25	1968-12-25 00:00:00	1968-12-25	38000177		0	0	7		0	0	0	284745	0	562251	1713671		
28792	625	40213296	2012-12-11	2012-12-11 00:00:00	2012-12-11	2012-12-11 00:00:00	2012-12-11	581452		0	0	0		0	0	0	41787	0	52	40213296		
62189	5174	19133873	1947-01-07	1947-01-07 00:00:00	1947-01-17	1947-01-17 00:00:00	1947-01-17	38000177		0	0	10		0	0	0	344022	0	834061	19133873		
64265	5334	1127433	1970-10-25	1970-10-25 00:00:00	1970-11-08	1970-11-08 00:00:00	1970-11-08	38000177		0	0	14		0	0	0	355204	0	313782	1127433		
50440	4191	1118084	1996-10-25	1996-10-25 00:00:00	1996-10-25	1996-10-25 00:00:00	\N	38000177		0	0	0		0	0	0	278152	0	00025152531	44923712		
211098	4630	40213227	2016-01-28	2016-01-28 00:00:00	2016-01-28	2016-01-28 00:00:00	2016-01-28	581452		0	0	0		0	0	0	308452	0	113	40213227		
134630	2955	40213306	1992-01-21	1992-01-21 00:00:00	1992-01-21	1992-01-21 00:00:00	1992-01-21	581452		0	0	0		0	0	0	197217	0	43	40213306		
61014	5073	19059056	1936-04-07	1936-04-07 00:00:00	1936-07-06	1936-07-06 00:00:00	1936-07-06	38000177		0	0	90		0	0	0	337159	0	243670	19059056		
55573	4613	19127922	2008-01-01	2008-01-01 00:00:00	2008-12-26	2008-12-26 00:00:00	2008-12-26	38000177		0	0	360		0	0	0	307280	0	748962	19127922		
45838	3793	46233710	1967-05-01	1967-05-01 00:00:00	1967-05-29	1967-05-29 00:00:00	1967-05-29	38000177		0	0	28		0	0	0	252279	0	1650142	46233710		
27987	2318	19128065	1982-12-22	1982-12-22 00:00:00	1983-12-17	1983-12-17 00:00:00	1983-12-17	38000177		0	0	360		0	0	0	154046	0	749882	19128065		
45411	3756	1127433	1958-09-09	1958-09-09 00:00:00	1958-10-07	1958-10-07 00:00:00	1958-10-07	38000177		0	0	28		0	0	0	249713	0	313782	1127433		
45972	3807	1127433	1960-04-03	1960-04-03 00:00:00	1960-04-17	1960-04-17 00:00:00	1960-04-17	38000177		0	0	14		0	0	0	253002	0	313782	1127433		
118572	2609	40213160	1958-10-10	1958-10-10 00:00:00	1958-10-10	1958-10-10 00:00:00	1958-10-10	581452		0	0	0		0	0	0	172505	0	10	40213160		
15143	1265	1713671	1987-12-23	1987-12-23 00:00:00	1988-01-13	1988-01-13 00:00:00	1988-01-13	38000177		0	0	21		0	0	0	83419	0	562251	1713671		
219415	4815	40213227	2001-05-17	2001-05-17 00:00:00	2001-05-17	2001-05-17 00:00:00	2001-05-17	581452		0	0	0		0	0	0	320374	0	113	40213227		
10342	864	1127433	1930-05-07	1930-05-07 00:00:00	1930-05-21	1930-05-21 00:00:00	1930-05-21	38000177		0	0	14		0	0	0	57294	0	313782	1127433		
105277	2309	40213160	1973-12-07	1973-12-07 00:00:00	1973-12-07	1973-12-07 00:00:00	1973-12-07	581452		0	0	0		0	0	0	153669	0	10	40213160		
18929	410	40213227	2011-01-06	2011-01-06 00:00:00	2011-01-06	2011-01-06 00:00:00	2011-01-06	581452		0	0	0		0	0	0	27186	0	113	40213227		
8762	730	19128065	1978-03-04	1978-03-04 00:00:00	1979-02-27	1979-02-27 00:00:00	1979-02-27	38000177		0	0	360		0	0	0	48496	0	749882	19128065		
20990	1729	1127078	1978-07-04	1978-07-04 00:00:00	1978-07-18	1978-07-18 00:00:00	1978-07-18	38000177		0	0	14		0	0	0	115645	0	282464	1127078		
27565	2283	1127433	1988-04-30	1988-04-30 00:00:00	1988-05-21	1988-05-21 00:00:00	1988-05-21	38000177		0	0	21		0	0	0	151883	0	313782	1127433		
27572	2283	1127433	2001-08-07	2001-08-07 00:00:00	2001-08-14	2001-08-14 00:00:00	2001-08-14	38000177		0	0	7		0	0	0	151910	0	313782	1127433		
27647	2289	19115351	1958-10-30	1958-10-30 00:00:00	1958-10-30	1958-10-30 00:00:00	\N	38000177		0	0	0		0	0	0	152263	0	563026	19115351		
41776	911	40213314	1977-02-13	1977-02-13 00:00:00	1977-02-13	1977-02-13 00:00:00	1977-02-13	581452		0	0	0		0	0	0	60513	0	49	40213314		
85030	1860	40213160	1963-10-07	1963-10-07 00:00:00	1963-10-07	1963-10-07 00:00:00	1963-10-07	581452		0	0	0		0	0	0	124391	0	10	40213160		
47080	3901	19059056	1939-01-02	1939-01-02 00:00:00	1939-01-16	1939-01-16 00:00:00	1939-01-16	38000177		0	0	14		0	0	0	259383	0	243670	19059056		
215237	4720	40213160	1977-01-25	1977-01-25 00:00:00	1977-01-25	1977-01-25 00:00:00	1977-01-25	581452		0	0	0		0	0	0	314394	0	10	40213160		
54750	4548	1115171	2010-06-15	2010-06-15 00:00:00	2010-07-06	2010-07-06 00:00:00	2010-07-06	38000177		0	0	21		0	0	0	303027	0	849574	1115171		
52789	4387	19133873	1974-11-13	1974-11-13 00:00:00	1974-11-25	1974-11-25 00:00:00	1974-11-25	38000177		0	0	12		0	0	0	291589	0	834061	19133873		
5771	482	19129655	1974-08-28	1974-08-28 00:00:00	1974-09-11	1974-09-11 00:00:00	1974-09-11	38000177		0	0	14		0	0	0	32218	0	789980	19129655		
57666	1261	40213306	1993-06-26	1993-06-26 00:00:00	1993-06-26	1993-06-26 00:00:00	1993-06-26	581452		0	0	0		0	0	0	83153	0	43	40213306		
153686	3383	40213251	1991-03-28	1991-03-28 00:00:00	1991-03-28	1991-03-28 00:00:00	1991-03-28	581452		0	0	0		0	0	0	224503	0	21	40213251		
29826	2470	1127078	1962-09-25	1962-09-25 00:00:00	1962-10-16	1962-10-16 00:00:00	1962-10-16	38000177		0	0	21		0	0	0	163795	0	282464	1127078		
43715	3623	19059056	1961-02-07	1961-02-07 00:00:00	1961-03-14	1961-03-14 00:00:00	1961-03-14	38000177		0	0	35		0	0	0	240896	0	243670	19059056		
57277	4754	1127433	1971-08-12	1971-08-12 00:00:00	1971-08-26	1971-08-26 00:00:00	1971-08-26	38000177		0	0	14		0	0	0	316640	0	313782	1127433		
40462	3353	19133905	1979-04-14	1979-04-14 00:00:00	1979-04-23	1979-04-23 00:00:00	1979-04-23	38000177		0	0	9		0	0	0	222335	0	834102	19133905		
238239	5230	40213227	2006-11-15	2006-11-15 00:00:00	2006-11-15	2006-11-15 00:00:00	2006-11-15	581452		0	0	0		0	0	0	347968	0	113	40213227		
4418	366	40229134	1966-10-18	1966-10-18 00:00:00	1966-11-01	1966-11-01 00:00:00	1966-11-01	38000177		0	0	14		0	0	0	24321	0	1043400	40229134		
113263	2487	40213160	1956-02-05	1956-02-05 00:00:00	1956-02-05	1956-02-05 00:00:00	1956-02-05	581452		0	0	0		0	0	0	164768	0	10	40213160		
231373	5083	40213198	2013-07-08	2013-07-08 00:00:00	2013-07-08	2013-07-08 00:00:00	2013-07-08	581452		0	0	0		0	0	0	338001	0	133	40213198		
161867	3561	40213227	2001-12-10	2001-12-10 00:00:00	2001-12-10	2001-12-10 00:00:00	2001-12-10	581452		0	0	0		0	0	0	236478	0	113	40213227		
31205	680	40213227	2019-01-21	2019-01-21 00:00:00	2019-01-21	2019-01-21 00:00:00	2019-01-21	581452		0	0	0		0	0	0	45016	0	113	40213227		
120488	2649	40213160	1962-05-14	1962-05-14 00:00:00	1962-05-14	1962-05-14 00:00:00	1962-05-14	581452		0	0	0		0	0	0	175288	0	10	40213160		
25636	2108	1127433	1974-03-09	1974-03-09 00:00:00	1974-03-23	1974-03-23 00:00:00	1974-03-23	38000177		0	0	14		0	0	0	140314	0	313782	1127433		
20461	1683	19059056	1977-05-10	1977-05-10 00:00:00	1977-05-24	1977-05-24 00:00:00	1977-05-24	38000177		0	0	14		0	0	0	112790	0	243670	19059056		
58801	4884	1127078	1974-05-26	1974-05-26 00:00:00	1974-06-09	1974-06-09 00:00:00	1974-06-09	38000177		0	0	14		0	0	0	324783	0	282464	1127078		
55925	4642	19059056	1958-10-01	1958-10-01 00:00:00	1958-10-15	1958-10-15 00:00:00	1958-10-15	38000177		0	0	14		0	0	0	309408	0	243670	19059056		
238351	5232	40213306	1989-12-09	1989-12-09 00:00:00	1989-12-09	1989-12-09 00:00:00	1989-12-09	581452		0	0	0		0	0	0	348111	0	43	40213306		
21470	1764	1713671	1961-06-30	1961-06-30 00:00:00	1961-07-07	1961-07-07 00:00:00	1961-07-07	38000177		0	0	7		0	0	0	117935	0	562251	1713671		
30198	2503	19128022	1991-02-01	1991-02-01 00:00:00	1992-01-27	1992-01-27 00:00:00	1992-01-27	38000177		0	0	360		0	0	0	165675	0	749785	19128022		
7807	652	1127433	2003-01-27	2003-01-27 00:00:00	2003-02-17	2003-02-17 00:00:00	2003-02-17	38000177		0	0	21		0	0	0	43128	0	313782	1127433		
77415	1692	40213314	1977-04-25	1977-04-25 00:00:00	1977-04-25	1977-04-25 00:00:00	1977-04-25	581452		0	0	0		0	0	0	113364	0	49	40213314		
7913	662	1332419	1995-03-21	1995-03-21 00:00:00	1995-03-21	1995-03-21 00:00:00	\N	38000177		0	0	0		0	0	0	43693	0	197361	1332419		
29050	2404	19059056	1968-08-21	1968-08-21 00:00:00	1968-11-19	1968-11-19 00:00:00	1968-11-19	38000177		0	0	90		0	0	0	159758	0	243670	19059056		
184119	4045	40213296	2014-02-22	2014-02-22 00:00:00	2014-02-22	2014-02-22 00:00:00	2014-02-22	581452		0	0	0		0	0	0	269007	0	52	40213296		
60112	4998	1713671	1975-04-12	1975-04-12 00:00:00	1975-04-19	1975-04-19 00:00:00	1975-04-19	38000177		0	0	7		0	0	0	332370	0	562251	1713671		
37786	3123	19129144	2005-04-20	2005-04-20 00:00:00	2006-04-15	2006-04-15 00:00:00	2006-04-15	38000177		0	0	360		0	0	0	207841	0	757594	19129144		
48800	4044	1115171	2017-01-23	2017-01-23 00:00:00	2017-02-27	2017-02-27 00:00:00	2017-02-27	38000177		0	0	35		0	0	0	268992	0	849574	1115171		
39722	866	40213227	2009-09-20	2009-09-20 00:00:00	2009-09-20	2009-09-20 00:00:00	2009-09-20	581452		0	0	0		0	0	0	57462	0	113	40213227		
18155	1505	1127433	1968-06-19	1968-06-19 00:00:00	1968-06-26	1968-06-26 00:00:00	1968-06-26	38000177		0	0	7		0	0	0	100367	0	313782	1127433		
18227	1510	19129655	1974-02-17	1974-02-17 00:00:00	1974-03-03	1974-03-03 00:00:00	1974-03-03	38000177		0	0	14		0	0	0	100776	0	789980	19129655		
4837	403	19059056	1946-03-28	1946-03-28 00:00:00	1946-05-27	1946-05-27 00:00:00	1946-05-27	38000177		0	0	60		0	0	0	26462	0	243670	19059056		
146341	3218	40213260	2007-11-04	2007-11-04 00:00:00	2007-11-04	2007-11-04 00:00:00	2007-11-04	581452		0	0	0		0	0	0	213842	0	121	40213260		
51621	4289	1127078	1952-07-01	1952-07-01 00:00:00	1952-08-30	1952-08-30 00:00:00	1952-08-30	38000177		0	0	60		0	0	0	284740	0	282464	1127078		
28795	625	40213227	2004-07-27	2004-07-27 00:00:00	2004-07-27	2004-07-27 00:00:00	2004-07-27	581452		0	0	0		0	0	0	41730	0	113	40213227		
6665	563	19059056	1986-02-19	1986-02-19 00:00:00	1986-03-12	1986-03-12 00:00:00	1986-03-12	38000177		0	0	21		0	0	0	37272	0	243670	19059056		
64266	5334	19078461	2008-08-24	2008-08-24 00:00:00	2008-09-14	2008-09-14 00:00:00	2008-09-14	38000177		0	0	21		0	0	0	355236	0	310965	19078461		
173897	3823	40213260	2006-10-25	2006-10-25 00:00:00	2006-10-25	2006-10-25 00:00:00	2006-10-25	581452		0	0	0		0	0	0	253981	0	121	40213260		
211107	4630	40213260	2006-12-07	2006-12-07 00:00:00	2006-12-07	2006-12-07 00:00:00	2006-12-07	581452		0	0	0		0	0	0	308451	0	121	40213260		
134631	2955	40213296	2009-08-04	2009-08-04 00:00:00	2009-08-04	2009-08-04 00:00:00	2009-08-04	581452		0	0	0		0	0	0	197272	0	52	40213296		
61015	5073	40222846	2008-06-13	2008-06-13 00:00:00	2008-06-13	2008-06-13 00:00:00	\N	38000177		0	0	0		0	0	0	337248	0	996740	40222846		
34802	2872	19075601	1998-03-31	1998-03-31 00:00:00	1999-08-17	1999-08-17 00:00:00	1999-08-17	38000177		0	0	504		0	0	0	191190	0	309362	19075601		
45839	3793	40162522	1967-05-01	1967-05-01 00:00:00	1967-05-01	1967-05-01 00:00:00	\N	38000177		0	0	0		0	0	0	252279	0	857005	40162522		
27988	2318	1118084	2003-05-01	2003-05-01 00:00:00	2003-05-01	2003-05-01 00:00:00	\N	38000177		0	0	0		0	0	0	154083	0	00025152531	44923712		
45412	3756	1127433	1974-01-01	1974-01-01 00:00:00	1974-01-08	1974-01-08 00:00:00	1974-01-08	38000177		0	0	7		0	0	0	249680	0	313782	1127433		
45973	3807	19133873	1953-07-04	1953-07-04 00:00:00	1953-07-14	1953-07-14 00:00:00	1953-07-14	38000177		0	0	10		0	0	0	252959	0	834061	19133873		
118574	2609	40213160	1959-01-09	1959-01-09 00:00:00	1959-01-09	1959-01-09 00:00:00	1959-01-09	581452		0	0	0		0	0	0	172482	0	10	40213160		
15144	1265	1713671	1989-12-09	1989-12-09 00:00:00	1989-12-23	1989-12-23 00:00:00	1989-12-23	38000177		0	0	14		0	0	0	83414	0	562251	1713671		
219422	4815	40213227	1992-05-07	1992-05-07 00:00:00	1992-05-07	1992-05-07 00:00:00	1992-05-07	581452		0	0	0		0	0	0	320371	0	113	40213227		
10343	864	19059056	1923-12-19	1923-12-19 00:00:00	1924-01-23	1924-01-23 00:00:00	1924-01-23	38000177		0	0	35		0	0	0	57277	0	243670	19059056		
105284	2309	40213160	1978-03-10	1978-03-10 00:00:00	1978-03-10	1978-03-10 00:00:00	1978-03-10	581452		0	0	0		0	0	0	153660	0	10	40213160		
18950	410	40213227	2000-10-19	2000-10-19 00:00:00	2000-10-19	2000-10-19 00:00:00	2000-10-19	581452		0	0	0		0	0	0	27243	0	113	40213227		
8763	730	19059056	1960-05-02	1960-05-02 00:00:00	1960-07-31	1960-07-31 00:00:00	1960-07-31	38000177		0	0	90		0	0	0	48501	0	243670	19059056		
20991	1729	46233988	1978-07-04	1978-07-04 00:00:00	1978-07-18	1978-07-18 00:00:00	1978-07-18	38000177		0	0	14		0	0	0	115645	0	1652673	46233988		
27566	2283	45892894	2019-05-07	2019-05-07 00:00:00	2019-05-07	2019-05-07 00:00:00	\N	38000177		0	0	0		0	0	0	151917	0	1599803	45892894		
27573	2283	1118084	1975-07-21	1975-07-21 00:00:00	1975-07-21	1975-07-21 00:00:00	\N	38000177		0	0	0		0	0	0	151945	0	00025152531	44923712		
27648	2289	19133873	1950-04-04	1950-04-04 00:00:00	1950-04-12	1950-04-12 00:00:00	1950-04-12	38000177		0	0	8		0	0	0	152256	0	834061	19133873		
41777	911	40213296	2016-08-28	2016-08-28 00:00:00	2016-08-28	2016-08-28 00:00:00	2016-08-28	581452		0	0	0		0	0	0	60489	0	52	40213296		
85042	1861	40213314	1983-02-05	1983-02-05 00:00:00	1983-02-05	1983-02-05 00:00:00	1983-02-05	581452		0	0	0		0	0	0	124431	0	49	40213314		
47082	3901	1713671	1955-01-22	1955-01-22 00:00:00	1955-02-12	1955-02-12 00:00:00	1955-02-12	38000177		0	0	21		0	0	0	259342	0	562251	1713671		
215239	4720	40213296	2018-05-15	2018-05-15 00:00:00	2018-05-15	2018-05-15 00:00:00	2018-05-15	581452		0	0	0		0	0	0	314389	0	52	40213296		
54751	4548	1332419	2018-07-03	2018-07-03 00:00:00	2018-07-03	2018-07-03 00:00:00	\N	38000177		0	0	0		0	0	0	303071	0	197361	1332419		
52790	4387	19133905	1990-01-05	1990-01-05 00:00:00	1990-01-17	1990-01-17 00:00:00	1990-01-17	38000177		0	0	12		0	0	0	291601	0	834102	19133905		
5772	482	19059056	1974-08-28	1974-08-28 00:00:00	1974-09-11	1974-09-11 00:00:00	1974-09-11	38000177		0	0	14		0	0	0	32218	0	243670	19059056		
57668	1261	40213227	1993-06-26	1993-06-26 00:00:00	1993-06-26	1993-06-26 00:00:00	1993-06-26	581452		0	0	0		0	0	0	83153	0	113	40213227		
153689	3383	40213160	1991-03-28	1991-03-28 00:00:00	1991-03-28	1991-03-28 00:00:00	1991-03-28	581452		0	0	0		0	0	0	224503	0	10	40213160		
29827	2470	1127078	1960-09-18	1960-09-18 00:00:00	1960-10-02	1960-10-02 00:00:00	1960-10-02	38000177		0	0	14		0	0	0	163822	0	282464	1127078		
43716	3623	1713671	1953-12-30	1953-12-30 00:00:00	1954-01-13	1954-01-13 00:00:00	1954-01-13	38000177		0	0	14		0	0	0	240891	0	562251	1713671		
57278	4754	1118084	2006-02-02	2006-02-02 00:00:00	2006-02-02	2006-02-02 00:00:00	\N	38000177		0	0	0		0	0	0	316609	0	00025152531	44923712		
61821	5143	40229134	1967-03-09	1967-03-09 00:00:00	1967-03-23	1967-03-23 00:00:00	1967-03-23	38000177		0	0	14		0	0	0	341851	0	1043400	40229134		
89528	1964	40213296	2004-09-22	2004-09-22 00:00:00	2004-09-22	2004-09-22 00:00:00	2004-09-22	581452		0	0	0		0	0	0	130610	0	52	40213296		
4419	366	1115171	1995-08-25	1995-08-25 00:00:00	1995-09-29	1995-09-29 00:00:00	1995-09-29	38000177		0	0	35		0	0	0	24354	0	849574	1115171		
51723	4297	19019979	1974-10-28	1974-10-28 00:00:00	1974-11-11	1974-11-11 00:00:00	1974-11-11	38000177		0	0	14		0	0	0	285190	0	198405	19019979		
231380	5083	40213227	1998-11-23	1998-11-23 00:00:00	1998-11-23	1998-11-23 00:00:00	1998-11-23	581452		0	0	0		0	0	0	338044	0	113	40213227		
161878	3561	40213227	1992-10-19	1992-10-19 00:00:00	1992-10-19	1992-10-19 00:00:00	1992-10-19	581452		0	0	0		0	0	0	236444	0	113	40213227		
31206	680	40213260	2019-01-21	2019-01-21 00:00:00	2019-01-21	2019-01-21 00:00:00	2019-01-21	581452		0	0	0		0	0	0	45016	0	121	40213260		
120492	2649	40213160	1957-09-09	1957-09-09 00:00:00	1957-09-09	1957-09-09 00:00:00	1957-09-09	581452		0	0	0		0	0	0	175276	0	10	40213160		
25637	2108	1127433	2006-10-14	2006-10-14 00:00:00	2006-10-28	2006-10-28 00:00:00	2006-10-28	38000177		0	0	14		0	0	0	140385	0	313782	1127433		
20462	1683	46233988	1977-05-10	1977-05-10 00:00:00	1977-05-24	1977-05-24 00:00:00	1977-05-24	38000177		0	0	14		0	0	0	112790	0	1652673	46233988		
58802	4884	46233988	1974-05-26	1974-05-26 00:00:00	1974-06-09	1974-06-09 00:00:00	1974-06-09	38000177		0	0	14		0	0	0	324783	0	1652673	46233988		
55926	4642	1127078	1956-12-04	1956-12-04 00:00:00	1956-12-18	1956-12-18 00:00:00	1956-12-18	38000177		0	0	14		0	0	0	309453	0	282464	1127078		
238360	5232	40213160	1972-09-16	1972-09-16 00:00:00	1972-09-16	1972-09-16 00:00:00	1972-09-16	581452		0	0	0		0	0	0	348107	0	10	40213160		
21471	1764	19129655	1963-10-23	1963-10-23 00:00:00	1963-11-06	1963-11-06 00:00:00	1963-11-06	38000177		0	0	14		0	0	0	117998	0	789980	19129655		
9459	785	1127078	1969-06-15	1969-06-15 00:00:00	1969-06-29	1969-06-29 00:00:00	1969-06-29	38000177		0	0	14		0	0	0	52287	0	282464	1127078		
7808	653	1713671	1989-11-13	1989-11-13 00:00:00	1989-12-04	1989-12-04 00:00:00	1989-12-04	38000177		0	0	21		0	0	0	43215	0	562251	1713671		
77417	1692	40213160	1977-04-25	1977-04-25 00:00:00	1977-04-25	1977-04-25 00:00:00	1977-04-25	581452		0	0	0		0	0	0	113364	0	10	40213160		
7914	662	1539411	1995-03-21	1995-03-21 00:00:00	1995-03-21	1995-03-21 00:00:00	\N	38000177		0	0	0		0	0	0	43693	0	312961	1539411		
39509	3263	1118084	1985-01-27	1985-01-27 00:00:00	1985-01-27	1985-01-27 00:00:00	\N	38000177		0	0	0		0	0	0	216882	0	00025152531	44923712		
184128	4045	40213314	1977-09-24	1977-09-24 00:00:00	1977-09-24	1977-09-24 00:00:00	1977-09-24	581452		0	0	0		0	0	0	269044	0	49	40213314		
60113	4998	1124300	2003-08-16	2003-08-16 00:00:00	2003-08-16	2003-08-16 00:00:00	\N	38000177		0	0	0		0	0	0	332333	0	00781178901	45011828		
37787	3123	19078461	2005-11-02	2005-11-02 00:00:00	2005-12-02	2005-12-02 00:00:00	2005-12-02	38000177		0	0	30		0	0	0	207820	0	310965	19078461		
48801	4044	1713671	1987-07-03	1987-07-03 00:00:00	1987-07-24	1987-07-24 00:00:00	1987-07-24	38000177		0	0	21		0	0	0	268951	0	562251	1713671		
39723	866	40213260	2009-09-20	2009-09-20 00:00:00	2009-09-20	2009-09-20 00:00:00	2009-09-20	581452		0	0	0		0	0	0	57462	0	121	40213260		
18156	1505	1127433	1974-09-02	1974-09-02 00:00:00	1974-09-16	1974-09-16 00:00:00	1974-09-16	38000177		0	0	14		0	0	0	100317	0	313782	1127433		
18228	1510	19078461	1974-02-17	1974-02-17 00:00:00	1974-03-03	1974-03-03 00:00:00	1974-03-03	38000177		0	0	14		0	0	0	100776	0	310965	19078461		
4838	403	40165015	1946-03-28	1946-03-28 00:00:00	1946-03-28	1946-03-28 00:00:00	\N	38000177		0	0	0		0	0	0	26462	0	861467	40165015		
146345	3218	40213296	1996-11-17	1996-11-17 00:00:00	1996-11-17	1996-11-17 00:00:00	1996-11-17	581452		0	0	0		0	0	0	213872	0	52	40213296		
51622	4289	40236824	1984-08-24	1984-08-24 00:00:00	1984-08-31	1984-08-31 00:00:00	1984-08-31	38000177		0	0	7		0	0	0	284746	0	1094107	40236824		
59027	4905	1118084	2016-09-04	2016-09-04 00:00:00	2016-09-04	2016-09-04 00:00:00	\N	38000177		0	0	0		0	0	0	326081	0	00025152531	44923712		
6666	563	19059056	1964-06-11	1964-06-11 00:00:00	1964-06-25	1964-06-25 00:00:00	1964-06-25	38000177		0	0	14		0	0	0	37287	0	243670	19059056		
64267	5334	19129655	1964-10-16	1964-10-16 00:00:00	1964-10-30	1964-10-30 00:00:00	1964-10-30	38000177		0	0	14		0	0	0	355231	0	789980	19129655		
173901	3823	40213296	1997-07-16	1997-07-16 00:00:00	1997-07-16	1997-07-16 00:00:00	1997-07-16	581452		0	0	0		0	0	0	253944	0	52	40213296		
211109	4630	40213227	2006-12-07	2006-12-07 00:00:00	2006-12-07	2006-12-07 00:00:00	2006-12-07	581452		0	0	0		0	0	0	308451	0	113	40213227		
66454	1454	40213160	1972-05-19	1972-05-19 00:00:00	1972-05-19	1972-05-19 00:00:00	1972-05-19	581452		0	0	0		0	0	0	97012	0	10	40213160		
61016	5073	1127433	1970-03-08	1970-03-08 00:00:00	1970-03-15	1970-03-15 00:00:00	1970-03-15	38000177		0	0	7		0	0	0	337246	0	313782	1127433		
34803	2872	1118084	1998-10-11	1998-10-11 00:00:00	1998-10-11	1998-10-11 00:00:00	\N	38000177		0	0	0		0	0	0	191190	0	00025152531	44923712		
45840	3793	1127433	1967-05-01	1967-05-01 00:00:00	1967-05-29	1967-05-29 00:00:00	1967-05-29	38000177		0	0	28		0	0	0	252279	0	313782	1127433		
27989	2318	19128065	1978-01-17	1978-01-17 00:00:00	1979-01-12	1979-01-12 00:00:00	1979-01-12	38000177		0	0	360		0	0	0	154052	0	749882	19128065		
45413	3757	1118084	1985-02-01	1985-02-01 00:00:00	1985-02-01	1985-02-01 00:00:00	\N	38000177		0	0	0		0	0	0	249786	0	00025152531	44923712		
45974	3807	19133873	1952-02-26	1952-02-26 00:00:00	1952-03-10	1952-03-10 00:00:00	1952-03-10	38000177		0	0	13		0	0	0	252976	0	834061	19133873		
118589	2609	40213227	2000-05-26	2000-05-26 00:00:00	2000-05-26	2000-05-26 00:00:00	2000-05-26	581452		0	0	0		0	0	0	172516	0	113	40213227		
15145	1265	1127433	1999-05-02	1999-05-02 00:00:00	1999-05-23	1999-05-23 00:00:00	1999-05-23	38000177		0	0	21		0	0	0	83399	0	313782	1127433		
219423	4815	40213306	1992-05-07	1992-05-07 00:00:00	1992-05-07	1992-05-07 00:00:00	1992-05-07	581452		0	0	0		0	0	0	320371	0	43	40213306		
10344	864	19059056	1946-08-21	1946-08-21 00:00:00	1946-09-25	1946-09-25 00:00:00	1946-09-25	38000177		0	0	35		0	0	0	57280	0	243670	19059056		
80909	1769	40213160	1975-06-04	1975-06-04 00:00:00	1975-06-04	1975-06-04 00:00:00	1975-06-04	581452		0	0	0		0	0	0	118311	0	10	40213160		
40572	884	40213314	1978-11-14	1978-11-14 00:00:00	1978-11-14	1978-11-14 00:00:00	1978-11-14	581452		0	0	0		0	0	0	58872	0	49	40213314		
8764	730	40173590	2017-09-16	2017-09-16 00:00:00	2017-09-16	2017-09-16 00:00:00	\N	38000177		0	0	0		0	0	0	48464	0	904419	40173590		
20992	1729	1124300	2011-08-15	2011-08-15 00:00:00	2011-08-15	2011-08-15 00:00:00	\N	38000177		0	0	0		0	0	0	115641	0	00781178901	45011828		
27567	2283	40231925	1987-03-07	1987-03-07 00:00:00	1987-03-07	1987-03-07 00:00:00	\N	38000177		0	0	0		0	0	0	151886	0	1049221	40231925		
27574	2283	1127433	2003-05-03	2003-05-03 00:00:00	2003-05-24	2003-05-24 00:00:00	2003-05-24	38000177		0	0	21		0	0	0	151884	0	313782	1127433		
27649	2289	19078461	1996-05-29	1996-05-29 00:00:00	1996-06-19	1996-06-19 00:00:00	1996-06-19	38000177		0	0	21		0	0	0	152253	0	310965	19078461		
41787	911	40213160	1976-11-14	1976-11-14 00:00:00	1976-11-14	1976-11-14 00:00:00	1976-11-14	581452		0	0	0		0	0	0	60484	0	10	40213160		
85048	1861	40213160	1982-05-08	1982-05-08 00:00:00	1982-05-08	1982-05-08 00:00:00	1982-05-08	581452		0	0	0		0	0	0	124430	0	10	40213160		
47083	3901	19078461	2002-02-15	2002-02-15 00:00:00	2002-03-01	2002-03-01 00:00:00	2002-03-01	38000177		0	0	14		0	0	0	259388	0	310965	19078461		
215241	4720	40213227	2017-11-28	2017-11-28 00:00:00	2017-11-28	2017-11-28 00:00:00	2017-11-28	581452		0	0	0		0	0	0	314412	0	113	40213227		
54752	4548	1539411	2018-07-03	2018-07-03 00:00:00	2018-07-03	2018-07-03 00:00:00	\N	38000177		0	0	0		0	0	0	303071	0	312961	1539411		
52791	4387	19129655	1967-07-07	1967-07-07 00:00:00	1967-08-04	1967-08-04 00:00:00	1967-08-04	38000177		0	0	28		0	0	0	291619	0	789980	19129655		
5773	482	1127078	1980-09-25	1980-09-25 00:00:00	1980-10-16	1980-10-16 00:00:00	1980-10-16	38000177		0	0	21		0	0	0	32228	0	282464	1127078		
57750	4799	19128065	1979-10-02	1979-10-02 00:00:00	1980-09-26	1980-09-26 00:00:00	1980-09-26	38000177		0	0	360		0	0	0	319267	0	749882	19128065		
153690	3383	40213180	2008-06-19	2008-06-19 00:00:00	2008-06-19	2008-06-19 00:00:00	2008-06-19	581452		0	0	0		0	0	0	224515	0	114	40213180		
29828	2470	19006318	1960-09-18	1960-09-18 00:00:00	1960-10-02	1960-10-02 00:00:00	1960-10-02	38000177		0	0	14		0	0	0	163822	0	105078	19006318		
43717	3623	19078461	2013-01-30	2013-01-30 00:00:00	2013-02-13	2013-02-13 00:00:00	2013-02-13	38000177		0	0	14		0	0	0	240940	0	310965	19078461		
57279	4754	1127433	1994-08-07	1994-08-07 00:00:00	1994-08-21	1994-08-21 00:00:00	1994-08-21	38000177		0	0	14		0	0	0	316643	0	313782	1127433		
61822	5143	1127433	1979-09-12	1979-09-12 00:00:00	1979-10-10	1979-10-10 00:00:00	1979-10-10	38000177		0	0	28		0	0	0	341884	0	313782	1127433		
89529	1964	40213260	2012-10-17	2012-10-17 00:00:00	2012-10-17	2012-10-17 00:00:00	2012-10-17	581452		0	0	0		0	0	0	130611	0	121	40213260		
4420	366	40229134	1983-02-22	1983-02-22 00:00:00	1983-03-08	1983-03-08 00:00:00	1983-03-08	38000177		0	0	14		0	0	0	24342	0	1043400	40229134		
51724	4297	1115171	1999-11-12	1999-11-12 00:00:00	1999-12-03	1999-12-03 00:00:00	1999-12-03	38000177		0	0	21		0	0	0	285149	0	849574	1115171		
125688	2765	40213227	1995-08-29	1995-08-29 00:00:00	1995-08-29	1995-08-29 00:00:00	1995-08-29	581452		0	0	0		0	0	0	182830	0	113	40213227		
43048	939	40213160	1964-12-22	1964-12-22 00:00:00	1964-12-22	1964-12-22 00:00:00	1964-12-22	581452		0	0	0		0	0	0	62435	0	10	40213160		
31209	680	40213306	1989-03-27	1989-03-27 00:00:00	1989-03-27	1989-03-27 00:00:00	1989-03-27	581452		0	0	0		0	0	0	\N	0	43	40213306		
120512	2649	40213296	1998-03-02	1998-03-02 00:00:00	1998-03-02	1998-03-02 00:00:00	1998-03-02	581452		0	0	0		0	0	0	175264	0	52	40213296		
25638	2108	1127433	1947-12-06	1947-12-06 00:00:00	1947-12-20	1947-12-20 00:00:00	1947-12-20	38000177		0	0	14		0	0	0	140334	0	313782	1127433		
20463	1683	19059056	1973-09-09	1973-09-09 00:00:00	1973-09-23	1973-09-23 00:00:00	1973-09-23	38000177		0	0	14		0	0	0	112833	0	243670	19059056		
58803	4884	1713671	1976-10-08	1976-10-08 00:00:00	1976-10-22	1976-10-22 00:00:00	1976-10-22	38000177		0	0	14		0	0	0	324797	0	562251	1713671		
55927	4642	19006318	1956-12-04	1956-12-04 00:00:00	1956-12-18	1956-12-18 00:00:00	1956-12-18	38000177		0	0	14		0	0	0	309453	0	105078	19006318		
9710	207	40213201	2007-01-21	2007-01-21 00:00:00	2007-01-21	2007-01-21 00:00:00	2007-01-21	581452		0	0	0		0	0	0	14085	0	33	40213201		
21472	1764	19059056	1963-10-23	1963-10-23 00:00:00	1963-11-06	1963-11-06 00:00:00	1963-11-06	38000177		0	0	14		0	0	0	117998	0	243670	19059056		
9460	785	19129655	1969-06-15	1969-06-15 00:00:00	1969-06-29	1969-06-29 00:00:00	1969-06-29	38000177		0	0	14		0	0	0	52287	0	789980	19129655		
7809	653	1118084	1990-05-11	1990-05-11 00:00:00	1990-05-11	1990-05-11 00:00:00	\N	38000177		0	0	0		0	0	0	43215	0	00025152531	44923712		
77420	1692	40213306	1998-11-09	1998-11-09 00:00:00	1998-11-09	1998-11-09 00:00:00	1998-11-09	581452		0	0	0		0	0	0	113339	0	43	40213306		
7915	662	19059056	1961-02-17	1961-02-17 00:00:00	1961-03-03	1961-03-03 00:00:00	1961-03-03	38000177		0	0	14		0	0	0	43702	0	243670	19059056		
39510	3263	1713671	1997-04-02	1997-04-02 00:00:00	1997-04-16	1997-04-16 00:00:00	1997-04-16	38000177		0	0	14		0	0	0	216962	0	562251	1713671		
184131	4045	40213160	1974-10-26	1974-10-26 00:00:00	1974-10-26	1974-10-26 00:00:00	1974-10-26	581452		0	0	0		0	0	0	268998	0	10	40213160		
60114	4998	19008572	2007-11-15	2007-11-15 00:00:00	2007-12-06	2007-12-06 00:00:00	2007-12-06	38000177		0	0	21		0	0	0	332383	0	106258	19008572		
37788	3123	19127922	2007-04-10	2007-04-10 00:00:00	2008-04-04	2008-04-04 00:00:00	2008-04-04	38000177		0	0	360		0	0	0	207847	0	748962	19127922		
48802	4045	1118084	2015-04-27	2015-04-27 00:00:00	2015-04-27	2015-04-27 00:00:00	\N	38000177		0	0	0		0	0	0	269007	0	00025152531	44923712		
39726	866	40213296	1999-05-02	1999-05-02 00:00:00	1999-05-02	1999-05-02 00:00:00	1999-05-02	581452		0	0	0		0	0	0	57452	0	52	40213296		
18157	1505	19006318	1974-09-02	1974-09-02 00:00:00	1974-09-16	1974-09-16 00:00:00	1974-09-16	38000177		0	0	14		0	0	0	100317	0	105078	19006318		
50275	4173	19133873	1977-11-23	1977-11-23 00:00:00	1977-12-03	1977-12-03 00:00:00	1977-12-03	38000177		0	0	10		0	0	0	277341	0	834061	19133873		
4839	403	19059056	1924-02-29	1924-02-29 00:00:00	1924-03-14	1924-03-14 00:00:00	1924-03-14	38000177		0	0	14		0	0	0	26411	0	243670	19059056		
146347	3218	40213227	1998-11-22	1998-11-22 00:00:00	1998-11-22	1998-11-22 00:00:00	1998-11-22	581452		0	0	0		0	0	0	213852	0	113	40213227		
51623	4289	920300	1984-08-24	1984-08-24 00:00:00	1984-08-31	1984-08-31 00:00:00	1984-08-31	38000177		0	0	7		0	0	0	284746	0	311989	920300		
59028	4905	19128022	1989-08-12	1989-08-12 00:00:00	1990-08-07	1990-08-07 00:00:00	1990-08-07	38000177		0	0	360		0	0	0	326067	0	749785	19128022		
6667	563	19059056	1970-04-02	1970-04-02 00:00:00	1970-04-23	1970-04-23 00:00:00	1970-04-23	38000177		0	0	21		0	0	0	37270	0	243670	19059056		
64268	5334	1127078	1964-10-16	1964-10-16 00:00:00	1964-10-30	1964-10-30 00:00:00	1964-10-30	38000177		0	0	14		0	0	0	355231	0	282464	1127078		
173903	3823	40213160	1959-09-23	1959-09-23 00:00:00	1959-09-23	1959-09-23 00:00:00	1959-09-23	581452		0	0	0		0	0	0	253956	0	10	40213160		
211110	4630	40213227	1997-03-13	1997-03-13 00:00:00	1997-03-13	1997-03-13 00:00:00	1997-03-13	581452		0	0	0		0	0	0	308468	0	113	40213227		
66458	1454	40213160	1972-02-18	1972-02-18 00:00:00	1972-02-18	1972-02-18 00:00:00	1972-02-18	581452		0	0	0		0	0	0	96994	0	10	40213160		
61017	5073	1124300	1977-05-17	1977-05-17 00:00:00	1977-05-17	1977-05-17 00:00:00	\N	38000177		0	0	0		0	0	0	337222	0	00781178901	45011828		
34804	2872	1539411	1992-03-17	1992-03-17 00:00:00	1992-03-17	1992-03-17 00:00:00	\N	38000177		0	0	0		0	0	0	191178	0	312961	1539411		
45841	3793	1115171	2003-11-16	2003-11-16 00:00:00	2003-12-21	2003-12-21 00:00:00	2003-12-21	38000177		0	0	35		0	0	0	252280	0	849574	1115171		
27990	2318	1127078	1963-08-24	1963-08-24 00:00:00	1963-09-07	1963-09-07 00:00:00	1963-09-07	38000177		0	0	14		0	0	0	154051	0	282464	1127078		
45414	3757	1127433	1959-05-11	1959-05-11 00:00:00	1959-05-25	1959-05-25 00:00:00	1959-05-25	38000177		0	0	14		0	0	0	249767	0	313782	1127433		
45975	3807	19078461	1995-09-04	1995-09-04 00:00:00	1995-09-18	1995-09-18 00:00:00	1995-09-18	38000177		0	0	14		0	0	0	253025	0	310965	19078461		
118590	2609	40213296	2000-05-26	2000-05-26 00:00:00	2000-05-26	2000-05-26 00:00:00	2000-05-26	581452		0	0	0		0	0	0	172516	0	52	40213296		
15146	1266	1127433	2000-06-26	2000-06-26 00:00:00	2000-07-03	2000-07-03 00:00:00	2000-07-03	38000177		0	0	7		0	0	0	83470	0	313782	1127433		
219427	4815	40213296	2012-06-14	2012-06-14 00:00:00	2012-06-14	2012-06-14 00:00:00	2012-06-14	581452		0	0	0		0	0	0	320348	0	52	40213296		
10345	864	19006318	1946-08-21	1946-08-21 00:00:00	1946-09-25	1946-09-25 00:00:00	1946-09-25	38000177		0	0	35		0	0	0	57280	0	105078	19006318		
80913	1769	40213314	1978-03-01	1978-03-01 00:00:00	1978-03-01	1978-03-01 00:00:00	1978-03-01	581452		0	0	0		0	0	0	118329	0	49	40213314		
40575	884	40213160	1977-12-13	1977-12-13 00:00:00	1977-12-13	1977-12-13 00:00:00	1977-12-13	581452		0	0	0		0	0	0	58914	0	10	40213160		
8765	730	19006318	1959-09-17	1959-09-17 00:00:00	1959-10-01	1959-10-01 00:00:00	1959-10-01	38000177		0	0	14		0	0	0	48469	0	105078	19006318		
20993	1729	1127078	1984-06-02	1984-06-02 00:00:00	1984-06-16	1984-06-16 00:00:00	1984-06-16	38000177		0	0	14		0	0	0	115620	0	282464	1127078		
27568	2283	1127433	1941-01-31	1941-01-31 00:00:00	1941-02-07	1941-02-07 00:00:00	1941-02-07	38000177		0	0	7		0	0	0	151905	0	313782	1127433		
27575	2283	19077572	2017-11-13	2017-11-13 00:00:00	2017-11-13	2017-11-13 00:00:00	\N	38000177		0	0	0		0	0	0	151856	0	310436	19077572		
27650	2289	19078461	2000-07-28	2000-07-28 00:00:00	2000-08-18	2000-08-18 00:00:00	2000-08-18	38000177		0	0	21		0	0	0	152254	0	310965	19078461		
73699	1609	40213227	2014-04-03	2014-04-03 00:00:00	2014-04-03	2014-04-03 00:00:00	2014-04-03	581452		0	0	0		0	0	0	108083	0	113	40213227		
85049	1861	40213314	1982-05-08	1982-05-08 00:00:00	1982-05-08	1982-05-08 00:00:00	1982-05-08	581452		0	0	0		0	0	0	124430	0	49	40213314		
47084	3901	40162522	1959-08-04	1959-08-04 00:00:00	1959-08-04	1959-08-04 00:00:00	\N	38000177		0	0	0		0	0	0	259386	0	857005	40162522		
215242	4720	40213296	2017-11-28	2017-11-28 00:00:00	2017-11-28	2017-11-28 00:00:00	2017-11-28	581452		0	0	0		0	0	0	314412	0	52	40213296		
54753	4548	19126352	2018-07-03	2018-07-03 00:00:00	2018-07-03	2018-07-03 00:00:00	\N	38000177		0	0	0		0	0	0	303071	0	705129	19126352		
52792	4387	1127078	1967-07-07	1967-07-07 00:00:00	1967-08-04	1967-08-04 00:00:00	1967-08-04	38000177		0	0	28		0	0	0	291619	0	282464	1127078		
5774	482	19128022	1989-09-18	1989-09-18 00:00:00	1990-09-13	1990-09-13 00:00:00	1990-09-13	38000177		0	0	360		0	0	0	32248	0	749785	19128022		
57751	4799	19133905	1998-08-25	1998-08-25 00:00:00	1998-09-02	1998-09-02 00:00:00	1998-09-02	38000177		0	0	8		0	0	0	319262	0	834102	19133905		
153692	3383	40213227	2008-06-19	2008-06-19 00:00:00	2008-06-19	2008-06-19 00:00:00	2008-06-19	581452		0	0	0		0	0	0	224515	0	113	40213227		
29829	2470	19059056	1968-04-17	1968-04-17 00:00:00	1968-05-15	1968-05-15 00:00:00	1968-05-15	38000177		0	0	28		0	0	0	163796	0	243670	19059056		
43718	3623	1127433	2005-01-06	2005-01-06 00:00:00	2005-01-20	2005-01-20 00:00:00	2005-01-20	38000177		0	0	14		0	0	0	240869	0	313782	1127433		
57280	4755	40229134	2001-03-22	2001-03-22 00:00:00	2001-04-05	2001-04-05 00:00:00	2001-04-05	38000177		0	0	14		0	0	0	316774	0	1043400	40229134		
61823	5143	1127433	1966-10-31	1966-10-31 00:00:00	1966-11-07	1966-11-07 00:00:00	1966-11-07	38000177		0	0	7		0	0	0	341850	0	313782	1127433		
89532	1964	40213227	2012-10-17	2012-10-17 00:00:00	2012-10-17	2012-10-17 00:00:00	2012-10-17	581452		0	0	0		0	0	0	130611	0	113	40213227		
4421	366	1713671	1914-09-05	1914-09-05 00:00:00	1914-11-28	1914-11-28 00:00:00	1914-11-28	38000177		0	0	84		0	0	0	24264	0	562251	1713671		
51725	4297	19059056	1979-11-01	1979-11-01 00:00:00	1979-11-22	1979-11-22 00:00:00	1979-11-22	38000177		0	0	21		0	0	0	285176	0	243670	19059056		
43053	939	40213227	2005-12-13	2005-12-13 00:00:00	2005-12-13	2005-12-13 00:00:00	2005-12-13	581452		0	0	0		0	0	0	62487	0	113	40213227		
31215	680	40213160	1968-06-03	1968-06-03 00:00:00	1968-06-03	1968-06-03 00:00:00	1968-06-03	581452		0	0	0		0	0	0	45057	0	10	40213160		
120514	2649	40213260	2007-12-17	2007-12-17 00:00:00	2007-12-17	2007-12-17 00:00:00	2007-12-17	581452		0	0	0		0	0	0	175309	0	121	40213260		
25639	2108	19059056	1945-03-10	1945-03-10 00:00:00	1945-04-09	1945-04-09 00:00:00	1945-04-09	38000177		0	0	30		0	0	0	140353	0	243670	19059056		
20464	1683	46233988	1973-09-09	1973-09-09 00:00:00	1973-09-23	1973-09-23 00:00:00	1973-09-23	38000177		0	0	14		0	0	0	112833	0	1652673	46233988		
58804	4884	1127433	1989-07-08	1989-07-08 00:00:00	1989-10-06	1989-10-06 00:00:00	1989-10-06	38000177		0	0	90		0	0	0	324736	0	313782	1127433		
55928	4643	19059056	1912-12-27	1912-12-27 00:00:00	1913-01-10	1913-01-10 00:00:00	1913-01-10	38000177		0	0	14		0	0	0	309566	0	243670	19059056		
9723	207	40213227	2012-04-15	2012-04-15 00:00:00	2012-04-15	2012-04-15 00:00:00	2012-04-15	581452		0	0	0		0	0	0	14145	0	113	40213227		
21473	1764	40229134	1968-11-16	1968-11-16 00:00:00	1968-11-30	1968-11-30 00:00:00	1968-11-30	38000177		0	0	14		0	0	0	117936	0	1043400	40229134		
9461	785	1127433	1966-09-24	1966-09-24 00:00:00	1966-10-08	1966-10-08 00:00:00	1966-10-08	38000177		0	0	14		0	0	0	52284	0	313782	1127433		
7810	653	19059056	1971-09-14	1971-09-14 00:00:00	1971-10-05	1971-10-05 00:00:00	1971-10-05	38000177		0	0	21		0	0	0	43262	0	243670	19059056		
77422	1692	40213227	1998-11-09	1998-11-09 00:00:00	1998-11-09	1998-11-09 00:00:00	1998-11-09	581452		0	0	0		0	0	0	113339	0	113	40213227		
7916	662	19006318	1961-02-17	1961-02-17 00:00:00	1961-03-03	1961-03-03 00:00:00	1961-03-03	38000177		0	0	14		0	0	0	43702	0	105078	19006318		
39540	3268	1127433	1974-10-15	1974-10-15 00:00:00	1974-10-29	1974-10-29 00:00:00	1974-10-29	38000177		0	0	14		0	0	0	217201	0	313782	1127433		
94909	2082	40213227	2003-02-13	2003-02-13 00:00:00	2003-02-13	2003-02-13 00:00:00	2003-02-13	581452		0	0	0		0	0	0	138733	0	113	40213227		
27192	592	40213160	1970-08-07	1970-08-07 00:00:00	1970-08-07	1970-08-07 00:00:00	1970-08-07	581452		0	0	0		0	0	0	39117	0	10	40213160		
129467	2846	40213227	1994-08-28	1994-08-28 00:00:00	1994-08-28	1994-08-28 00:00:00	1994-08-28	581452		0	0	0		0	0	0	189018	0	113	40213227		
48803	4045	1127078	1980-01-28	1980-01-28 00:00:00	1980-02-11	1980-02-11 00:00:00	1980-02-11	38000177		0	0	14		0	0	0	269016	0	282464	1127078		
39730	866	40213227	2001-05-06	2001-05-06 00:00:00	2001-05-06	2001-05-06 00:00:00	2001-05-06	581452		0	0	0		0	0	0	57460	0	113	40213227		
18158	1505	1127433	1978-03-25	1978-03-25 00:00:00	1978-04-01	1978-04-01 00:00:00	1978-04-01	38000177		0	0	7		0	0	0	100368	0	313782	1127433		
50276	4173	1713671	1976-06-02	1976-06-02 00:00:00	1976-06-16	1976-06-16 00:00:00	1976-06-16	38000177		0	0	14		0	0	0	277361	0	562251	1713671		
4840	403	19059056	1925-05-01	1925-05-01 00:00:00	1925-05-15	1925-05-15 00:00:00	1925-05-15	38000177		0	0	14		0	0	0	26517	0	243670	19059056		
146348	3218	40213296	1998-11-22	1998-11-22 00:00:00	1998-11-22	1998-11-22 00:00:00	1998-11-22	581452		0	0	0		0	0	0	213852	0	52	40213296		
51624	4289	1127433	1964-05-25	1964-05-25 00:00:00	1964-06-01	1964-06-01 00:00:00	1964-06-01	38000177		0	0	7		0	0	0	284764	0	313782	1127433		
59029	4905	1115171	2018-09-20	2018-09-20 00:00:00	2018-10-04	2018-10-04 00:00:00	2018-10-04	38000177		0	0	14		0	0	0	326059	0	849574	1115171		
6668	563	1713671	1985-11-05	1985-11-05 00:00:00	1985-11-26	1985-11-26 00:00:00	1985-11-26	38000177		0	0	21		0	0	0	37295	0	562251	1713671		
64269	5334	1127433	1986-06-23	1986-06-23 00:00:00	1986-07-21	1986-07-21 00:00:00	1986-07-21	38000177		0	0	28		0	0	0	355192	0	313782	1127433		
173905	3823	40213260	2007-10-31	2007-10-31 00:00:00	2007-10-31	2007-10-31 00:00:00	2007-10-31	581452		0	0	0		0	0	0	253958	0	121	40213260		
211111	4630	40213296	1997-03-13	1997-03-13 00:00:00	1997-03-13	1997-03-13 00:00:00	1997-03-13	581452		0	0	0		0	0	0	308468	0	52	40213296		
66460	1454	40213296	2012-08-31	2012-08-31 00:00:00	2012-08-31	2012-08-31 00:00:00	2012-08-31	581452		0	0	0		0	0	0	97018	0	52	40213296		
61018	5073	19077572	2007-08-18	2007-08-18 00:00:00	2007-08-18	2007-08-18 00:00:00	\N	38000177		0	0	0		0	0	0	337181	0	310436	19077572		
34805	2872	19006318	1954-03-31	1954-03-31 00:00:00	1954-04-14	1954-04-14 00:00:00	1954-04-14	38000177		0	0	14		0	0	0	191194	0	105078	19006318		
45842	3795	19019979	1974-02-08	1974-02-08 00:00:00	1974-02-22	1974-02-22 00:00:00	1974-02-22	38000177		0	0	14		0	0	0	252304	0	198405	19019979		
27991	2318	1713671	1973-04-11	1973-04-11 00:00:00	1973-05-02	1973-05-02 00:00:00	1973-05-02	38000177		0	0	21		0	0	0	154118	0	562251	1713671		
45415	3757	19078461	2004-11-06	2004-11-06 00:00:00	2004-11-20	2004-11-20 00:00:00	2004-11-20	38000177		0	0	14		0	0	0	249763	0	310965	19078461		
45976	3807	40236824	1973-10-16	1973-10-16 00:00:00	1973-10-23	1973-10-23 00:00:00	1973-10-23	38000177		0	0	7		0	0	0	252970	0	1094107	40236824		
118594	2609	40213296	1998-05-22	1998-05-22 00:00:00	1998-05-22	1998-05-22 00:00:00	1998-05-22	581452		0	0	0		0	0	0	172533	0	52	40213296		
15147	1266	19059056	1971-03-19	1971-03-19 00:00:00	1971-04-18	1971-04-18 00:00:00	1971-04-18	38000177		0	0	30		0	0	0	83453	0	243670	19059056		
219429	4815	40213227	2012-06-14	2012-06-14 00:00:00	2012-06-14	2012-06-14 00:00:00	2012-06-14	581452		0	0	0		0	0	0	320348	0	113	40213227		
10346	865	1127433	1992-07-22	1992-07-22 00:00:00	1992-08-05	1992-08-05 00:00:00	1992-08-05	38000177		0	0	14		0	0	0	57438	0	313782	1127433		
80918	1769	40213306	1997-09-17	1997-09-17 00:00:00	1997-09-17	1997-09-17 00:00:00	1997-09-17	581452		0	0	0		0	0	0	118282	0	43	40213306		
40576	884	40213314	1977-12-13	1977-12-13 00:00:00	1977-12-13	1977-12-13 00:00:00	1977-12-13	581452		0	0	0		0	0	0	58914	0	49	40213314		
8766	730	19059056	1959-09-17	1959-09-17 00:00:00	1959-10-01	1959-10-01 00:00:00	1959-10-01	38000177		0	0	14		0	0	0	48469	0	243670	19059056		
20994	1729	19133905	2015-01-03	2015-01-03 00:00:00	2015-01-16	2015-01-16 00:00:00	2015-01-16	38000177		0	0	13		0	0	0	115658	0	834102	19133905		
27569	2283	19006318	1951-04-22	1951-04-22 00:00:00	1951-05-06	1951-05-06 00:00:00	1951-05-06	38000177		0	0	14		0	0	0	151931	0	105078	19006318		
27593	2286	19059056	1967-03-14	1967-03-14 00:00:00	1967-04-11	1967-04-11 00:00:00	1967-04-11	38000177		0	0	28		0	0	0	152090	0	243670	19059056		
27651	2289	1124300	1985-10-08	1985-10-08 00:00:00	1985-10-08	1985-10-08 00:00:00	\N	38000177		0	0	0		0	0	0	152285	0	00781178901	45011828		
73702	1609	40213227	1994-12-14	1994-12-14 00:00:00	1994-12-14	1994-12-14 00:00:00	1994-12-14	581452		0	0	0		0	0	0	108071	0	113	40213227		
138721	3048	40213227	1996-07-17	1996-07-17 00:00:00	1996-07-17	1996-07-17 00:00:00	1996-07-17	581452		0	0	0		0	0	0	202788	0	113	40213227		
47085	3901	1127433	1959-08-04	1959-08-04 00:00:00	1959-08-25	1959-08-25 00:00:00	1959-08-25	38000177		0	0	21		0	0	0	259386	0	313782	1127433		
215245	4720	40213227	1999-02-16	1999-02-16 00:00:00	1999-02-16	1999-02-16 00:00:00	1999-02-16	581452		0	0	0		0	0	0	314345	0	113	40213227		
54754	4548	19075601	2018-07-03	2018-07-03 00:00:00	2018-07-03	2018-07-03 00:00:00	\N	38000177		0	0	0		0	0	0	303071	0	309362	19075601		
235459	5172	40213201	2011-11-29	2011-11-29 00:00:00	2011-11-29	2011-11-29 00:00:00	2011-11-29	581452		0	0	0		0	0	0	343860	0	33	40213201		
5775	482	40236824	1991-11-16	1991-11-16 00:00:00	1991-11-23	1991-11-23 00:00:00	1991-11-23	38000177		0	0	7		0	0	0	32214	0	1094107	40236824		
57752	4799	19128065	1978-10-07	1978-10-07 00:00:00	1979-10-02	1979-10-02 00:00:00	1979-10-02	38000177		0	0	360		0	0	0	319266	0	749882	19128065		
153693	3383	40213306	2008-06-19	2008-06-19 00:00:00	2008-06-19	2008-06-19 00:00:00	2008-06-19	581452		0	0	0		0	0	0	224515	0	43	40213306		
29830	2470	40236824	1994-01-16	1994-01-16 00:00:00	1994-01-23	1994-01-23 00:00:00	1994-01-23	38000177		0	0	7		0	0	0	163818	0	1094107	40236824		
43719	3623	19059056	1952-04-04	1952-04-04 00:00:00	1952-04-18	1952-04-18 00:00:00	1952-04-18	38000177		0	0	14		0	0	0	240925	0	243670	19059056		
57281	4755	19059056	1930-03-01	1930-03-01 00:00:00	1930-03-15	1930-03-15 00:00:00	1930-03-15	38000177		0	0	14		0	0	0	316745	0	243670	19059056		
61824	5143	1713671	1990-03-05	1990-03-05 00:00:00	1990-03-26	1990-03-26 00:00:00	1990-03-26	38000177		0	0	21		0	0	0	341815	0	562251	1713671		
89534	1964	40213306	1983-04-05	1983-04-05 00:00:00	1983-04-05	1983-04-05 00:00:00	1983-04-05	581452		0	0	0		0	0	0	130592	0	43	40213306		
4422	366	1127433	1970-11-13	1970-11-13 00:00:00	1970-11-20	1970-11-20 00:00:00	1970-11-20	38000177		0	0	7		0	0	0	24307	0	313782	1127433		
51726	4297	19059056	1984-03-04	1984-03-04 00:00:00	1984-03-18	1984-03-18 00:00:00	1984-03-18	38000177		0	0	14		0	0	0	285197	0	243670	19059056		
43054	939	40213296	2005-12-13	2005-12-13 00:00:00	2005-12-13	2005-12-13 00:00:00	2005-12-13	581452		0	0	0		0	0	0	62487	0	52	40213296		
31221	680	40213160	1968-03-04	1968-03-04 00:00:00	1968-03-04	1968-03-04 00:00:00	1968-03-04	581452		0	0	0		0	0	0	44975	0	10	40213160		
120519	2649	40213227	1998-09-28	1998-09-28 00:00:00	1998-09-28	1998-09-28 00:00:00	1998-09-28	581452		0	0	0		0	0	0	175328	0	113	40213227		
25640	2108	19059056	1961-07-19	1961-07-19 00:00:00	1961-10-17	1961-10-17 00:00:00	1961-10-17	38000177		0	0	90		0	0	0	140355	0	243670	19059056		
20465	1683	1127433	1987-01-27	1987-01-27 00:00:00	1987-03-03	1987-03-03 00:00:00	1987-03-03	38000177		0	0	35		0	0	0	112769	0	313782	1127433		
58805	4884	40162522	1989-07-08	1989-07-08 00:00:00	1989-07-08	1989-07-08 00:00:00	\N	38000177		0	0	0		0	0	0	324736	0	857005	40162522		
55929	4643	1127433	1963-01-12	1963-01-12 00:00:00	1963-01-19	1963-01-19 00:00:00	1963-01-19	38000177		0	0	7		0	0	0	309591	0	313782	1127433		
9726	207	40213227	2001-12-23	2001-12-23 00:00:00	2001-12-23	2001-12-23 00:00:00	2001-12-23	581452		0	0	0		0	0	0	14167	0	113	40213227		
21474	1764	1127078	1970-07-07	1970-07-07 00:00:00	1970-07-28	1970-07-28 00:00:00	1970-07-28	38000177		0	0	21		0	0	0	117989	0	282464	1127078		
9462	785	1713671	2007-07-21	2007-07-21 00:00:00	2007-08-11	2007-08-11 00:00:00	2007-08-11	38000177		0	0	21		0	0	0	52263	0	562251	1713671		
7811	653	1127433	1971-11-23	1971-11-23 00:00:00	1971-12-07	1971-12-07 00:00:00	1971-12-07	38000177		0	0	14		0	0	0	43259	0	313782	1127433		
77424	1692	40213160	1976-11-22	1976-11-22 00:00:00	1976-11-22	1976-11-22 00:00:00	1976-11-22	581452		0	0	0		0	0	0	113363	0	10	40213160		
7917	662	1713671	1982-09-06	1982-09-06 00:00:00	1982-09-13	1982-09-13 00:00:00	1982-09-13	38000177		0	0	7		0	0	0	43698	0	562251	1713671		
56325	4675	1127433	1988-09-22	1988-09-22 00:00:00	1988-10-06	1988-10-06 00:00:00	1988-10-06	38000177		0	0	14		0	0	0	311433	0	313782	1127433		
94926	2082	40213227	1993-02-11	1993-02-11 00:00:00	1993-02-11	1993-02-11 00:00:00	1993-02-11	581452		0	0	0		0	0	0	138642	0	113	40213227		
27198	592	40213160	1974-11-08	1974-11-08 00:00:00	1974-11-08	1974-11-08 00:00:00	1974-11-08	581452		0	0	0		0	0	0	39103	0	10	40213160		
129468	2846	40213306	1994-08-28	1994-08-28 00:00:00	1994-08-28	1994-08-28 00:00:00	1994-08-28	581452		0	0	0		0	0	0	189018	0	43	40213306		
48804	4045	19074843	1980-01-28	1980-01-28 00:00:00	1980-02-11	1980-02-11 00:00:00	1980-02-11	38000177		0	0	14		0	0	0	269016	0	309045	19074843		
39731	866	40213296	2001-05-06	2001-05-06 00:00:00	2001-05-06	2001-05-06 00:00:00	2001-05-06	581452		0	0	0		0	0	0	57460	0	52	40213296		
18159	1505	40229134	1983-12-02	1983-12-02 00:00:00	1983-12-09	1983-12-09 00:00:00	1983-12-09	38000177		0	0	7		0	0	0	100349	0	1043400	40229134		
50277	4173	40229134	1983-01-03	1983-01-03 00:00:00	1983-01-10	1983-01-10 00:00:00	1983-01-10	38000177		0	0	7		0	0	0	277362	0	1043400	40229134		
4841	403	19059056	1922-07-27	1922-07-27 00:00:00	1922-08-10	1922-08-10 00:00:00	1922-08-10	38000177		0	0	14		0	0	0	26516	0	243670	19059056		
146350	3219	40213160	1980-04-26	1980-04-26 00:00:00	1980-04-26	1980-04-26 00:00:00	1980-04-26	581452		0	0	0		0	0	0	213914	0	10	40213160		
51625	4289	19059056	1951-05-03	1951-05-03 00:00:00	1951-06-07	1951-06-07 00:00:00	1951-06-07	38000177		0	0	35		0	0	0	284739	0	243670	19059056		
59035	4907	19133873	1949-05-20	1949-05-20 00:00:00	1949-05-28	1949-05-28 00:00:00	1949-05-28	38000177		0	0	8		0	0	0	326168	0	834061	19133873		
6669	563	1713671	1980-05-16	1980-05-16 00:00:00	1980-05-30	1980-05-30 00:00:00	1980-05-30	38000177		0	0	14		0	0	0	37294	0	562251	1713671		
64270	5334	1127433	1988-02-01	1988-02-01 00:00:00	1988-02-08	1988-02-08 00:00:00	1988-02-08	38000177		0	0	7		0	0	0	355177	0	313782	1127433		
173910	3823	40213160	1955-03-23	1955-03-23 00:00:00	1955-03-23	1955-03-23 00:00:00	1955-03-23	581452		0	0	0		0	0	0	253954	0	10	40213160		
211118	4630	40213160	1955-10-06	1955-10-06 00:00:00	1955-10-06	1955-10-06 00:00:00	1955-10-06	581452		0	0	0		0	0	0	308443	0	10	40213160		
66462	1454	40213160	1971-12-17	1971-12-17 00:00:00	1971-12-17	1971-12-17 00:00:00	1971-12-17	581452		0	0	0		0	0	0	97021	0	10	40213160		
61022	5076	1118084	1976-04-17	1976-04-17 00:00:00	1976-04-17	1976-04-17 00:00:00	\N	38000177		0	0	0		0	0	0	337387	0	00025152531	44923712		
34806	2872	19059056	1954-03-31	1954-03-31 00:00:00	1954-04-14	1954-04-14 00:00:00	1954-04-14	38000177		0	0	14		0	0	0	191194	0	243670	19059056		
45843	3795	19129655	1974-02-08	1974-02-08 00:00:00	1974-02-22	1974-02-22 00:00:00	1974-02-22	38000177		0	0	14		0	0	0	252304	0	789980	19129655		
27993	2318	1127433	1979-09-01	1979-09-01 00:00:00	1979-09-15	1979-09-15 00:00:00	1979-09-15	38000177		0	0	14		0	0	0	154089	0	313782	1127433		
45416	3757	40229134	2009-08-19	2009-08-19 00:00:00	2009-08-26	2009-08-26 00:00:00	2009-08-26	38000177		0	0	7		0	0	0	249717	0	1043400	40229134		
45977	3807	920300	1973-10-16	1973-10-16 00:00:00	1973-10-23	1973-10-23 00:00:00	1973-10-23	38000177		0	0	7		0	0	0	252970	0	311989	920300		
118602	2609	40213160	1963-02-01	1963-02-01 00:00:00	1963-02-01	1963-02-01 00:00:00	1963-02-01	581452		0	0	0		0	0	0	172523	0	10	40213160		
15149	1266	1127433	1972-03-15	1972-03-15 00:00:00	1972-03-22	1972-03-22 00:00:00	1972-03-22	38000177		0	0	7		0	0	0	83441	0	313782	1127433		
219432	4815	40213160	1970-11-12	1970-11-12 00:00:00	1970-11-12	1970-11-12 00:00:00	1970-11-12	581452		0	0	0		0	0	0	320342	0	10	40213160		
10347	865	1118084	1980-06-02	1980-06-02 00:00:00	1980-06-02	1980-06-02 00:00:00	\N	38000177		0	0	0		0	0	0	57362	0	00025152531	44923712		
80919	1769	40213314	1977-03-02	1977-03-02 00:00:00	1977-03-02	1977-03-02 00:00:00	1977-03-02	581452		0	0	0		0	0	0	118277	0	49	40213314		
40578	884	40213227	1999-10-12	1999-10-12 00:00:00	1999-10-12	1999-10-12 00:00:00	1999-10-12	581452		0	0	0		0	0	0	58963	0	113	40213227		
8767	730	19059056	1959-05-03	1959-05-03 00:00:00	1959-06-07	1959-06-07 00:00:00	1959-06-07	38000177		0	0	35		0	0	0	48500	0	243670	19059056		
20995	1729	1713671	1983-07-16	1983-07-16 00:00:00	1983-07-30	1983-07-30 00:00:00	1983-07-30	38000177		0	0	14		0	0	0	115610	0	562251	1713671		
27570	2283	19059056	1951-04-22	1951-04-22 00:00:00	1951-05-06	1951-05-06 00:00:00	1951-05-06	38000177		0	0	14		0	0	0	151931	0	243670	19059056		
27594	2286	19059056	1959-03-04	1959-03-04 00:00:00	1959-03-18	1959-03-18 00:00:00	1959-03-18	38000177		0	0	14		0	0	0	152062	0	243670	19059056		
27652	2289	1127433	1991-04-03	1991-04-03 00:00:00	1991-04-17	1991-04-17 00:00:00	1991-04-17	38000177		0	0	14		0	0	0	152268	0	313782	1127433		
73707	1609	40213198	2010-03-10	2010-03-10 00:00:00	2010-03-10	2010-03-10 00:00:00	2010-03-10	581452		0	0	0		0	0	0	108075	0	133	40213198		
138723	3048	40213160	1979-04-25	1979-04-25 00:00:00	1979-04-25	1979-04-25 00:00:00	1979-04-25	581452		0	0	0		0	0	0	202803	0	10	40213160		
47086	3901	19006318	1959-08-04	1959-08-04 00:00:00	1959-08-25	1959-08-25 00:00:00	1959-08-25	38000177		0	0	21		0	0	0	259386	0	105078	19006318		
215246	4720	40213306	1999-02-16	1999-02-16 00:00:00	1999-02-16	1999-02-16 00:00:00	1999-02-16	581452		0	0	0		0	0	0	314345	0	43	40213306		
54755	4548	19074843	1995-05-18	1995-05-18 00:00:00	1995-06-01	1995-06-01 00:00:00	1995-06-01	38000177		0	0	14		0	0	0	303042	0	309045	19074843		
235464	5172	40213227	2016-10-18	2016-10-18 00:00:00	2016-10-18	2016-10-18 00:00:00	2016-10-18	581452		0	0	0		0	0	0	343903	0	113	40213227		
5776	482	920300	1991-11-16	1991-11-16 00:00:00	1991-11-23	1991-11-23 00:00:00	1991-11-23	38000177		0	0	7		0	0	0	32214	0	311989	920300		
57753	4799	1127433	2010-01-16	2010-01-16 00:00:00	2010-01-30	2010-01-30 00:00:00	2010-01-30	38000177		0	0	14		0	0	0	319218	0	313782	1127433		
153697	3383	40213160	1986-07-24	1986-07-24 00:00:00	1986-07-24	1986-07-24 00:00:00	1986-07-24	581452		0	0	0		0	0	0	224531	0	10	40213160		
29831	2470	920300	1994-01-16	1994-01-16 00:00:00	1994-01-23	1994-01-23 00:00:00	1994-01-23	38000177		0	0	7		0	0	0	163818	0	311989	920300		
43720	3623	19006318	1952-04-04	1952-04-04 00:00:00	1952-04-18	1952-04-18 00:00:00	1952-04-18	38000177		0	0	14		0	0	0	240925	0	105078	19006318		
57282	4755	1127433	2011-12-15	2011-12-15 00:00:00	2011-12-22	2011-12-22 00:00:00	2011-12-22	38000177		0	0	7		0	0	0	316776	0	313782	1127433		
61825	5144	1127433	1951-08-09	1951-08-09 00:00:00	1951-08-30	1951-08-30 00:00:00	1951-08-30	38000177		0	0	21		0	0	0	341887	0	313782	1127433		
89543	1964	40213160	1961-10-11	1961-10-11 00:00:00	1961-10-11	1961-10-11 00:00:00	1961-10-11	581452		0	0	0		0	0	0	130577	0	10	40213160		
4423	366	19133905	2011-12-23	2011-12-23 00:00:00	2012-01-04	2012-01-04 00:00:00	2012-01-04	38000177		0	0	12		0	0	0	24346	0	834102	19133905		
43061	939	40213160	1964-10-20	1964-10-20 00:00:00	1964-10-20	1964-10-20 00:00:00	1964-10-20	581452		0	0	0		0	0	0	62444	0	10	40213160		
31223	680	40213296	2009-10-05	2009-10-05 00:00:00	2009-10-05	2009-10-05 00:00:00	2009-10-05	581452		0	0	0		0	0	0	45012	0	52	40213296		
120520	2649	40213296	1998-09-28	1998-09-28 00:00:00	1998-09-28	1998-09-28 00:00:00	1998-09-28	581452		0	0	0		0	0	0	175328	0	52	40213296		
25641	2108	1127433	1957-04-12	1957-04-12 00:00:00	1957-04-26	1957-04-26 00:00:00	1957-04-26	38000177		0	0	14		0	0	0	140397	0	313782	1127433		
20466	1683	19078461	2006-11-18	2006-11-18 00:00:00	2006-12-02	2006-12-02 00:00:00	2006-12-02	38000177		0	0	14		0	0	0	112771	0	310965	19078461		
58806	4884	1154615	1975-10-28	1975-10-28 00:00:00	1975-10-28	1975-10-28 00:00:00	\N	38000177		0	0	0		0	0	0	324726	0	745679	1154615		
55930	4643	19059056	1940-08-30	1940-08-30 00:00:00	1940-11-28	1940-11-28 00:00:00	1940-11-28	38000177		0	0	90		0	0	0	309569	0	243670	19059056		
9728	207	40213227	1992-11-01	1992-11-01 00:00:00	1992-11-01	1992-11-01 00:00:00	1992-11-01	581452		0	0	0		0	0	0	14166	0	113	40213227		
21475	1764	1127433	1970-05-27	1970-05-27 00:00:00	1970-06-10	1970-06-10 00:00:00	1970-06-10	38000177		0	0	14		0	0	0	117995	0	313782	1127433		
19921	1635	1310034	2013-03-27	2013-03-27 00:00:00	2013-03-27	2013-03-27 00:00:00	2013-03-27	38000177		0	0	0		0	0	0	109831	0	834357	1310034		
7812	653	1127433	1975-01-21	1975-01-21 00:00:00	1975-01-28	1975-01-28 00:00:00	1975-01-28	38000177		0	0	7		0	0	0	43254	0	313782	1127433		
20010	1642	1713671	2000-07-06	2000-07-06 00:00:00	2000-07-27	2000-07-27 00:00:00	2000-07-27	38000177		0	0	21		0	0	0	110222	0	562251	1713671		
7918	662	1118084	2001-05-29	2001-05-29 00:00:00	2001-05-29	2001-05-29 00:00:00	\N	38000177		0	0	0		0	0	0	43759	0	00025152531	44923712		
56326	4675	19059056	1915-05-12	1915-05-12 00:00:00	1915-05-26	1915-05-26 00:00:00	1915-05-26	38000177		0	0	14		0	0	0	311443	0	243670	19059056		
178610	3926	40213227	1998-11-02	1998-11-02 00:00:00	1998-11-02	1998-11-02 00:00:00	1998-11-02	581452		0	0	0		0	0	0	261000	0	113	40213227		
4752	398	1127433	1948-02-13	1948-02-13 00:00:00	1948-02-27	1948-02-27 00:00:00	1948-02-27	38000177		0	0	14		0	0	0	26085	0	313782	1127433		
129469	2846	40213160	1972-10-01	1972-10-01 00:00:00	1972-10-01	1972-10-01 00:00:00	1972-10-01	581452		0	0	0		0	0	0	189024	0	10	40213160		
39187	856	40213227	2011-06-24	2011-06-24 00:00:00	2011-06-24	2011-06-24 00:00:00	2011-06-24	581452		0	0	0		0	0	0	56551	0	113	40213227		
51019	1117	40213201	2002-03-23	2002-03-23 00:00:00	2002-03-23	2002-03-23 00:00:00	2002-03-23	581452		0	0	0		0	0	0	73655	0	33	40213201		
18160	1505	19059056	1968-04-19	1968-04-19 00:00:00	1968-05-24	1968-05-24 00:00:00	1968-05-24	38000177		0	0	35		0	0	0	100381	0	243670	19059056		
50278	4173	46233710	1977-02-18	1977-02-18 00:00:00	1977-03-04	1977-03-04 00:00:00	1977-03-04	38000177		0	0	14		0	0	0	277344	0	1650142	46233710		
4842	403	19059056	1939-10-10	1939-10-10 00:00:00	1939-10-31	1939-10-31 00:00:00	1939-10-31	38000177		0	0	21		0	0	0	26536	0	243670	19059056		
146351	3219	40213314	1980-04-26	1980-04-26 00:00:00	1980-04-26	1980-04-26 00:00:00	1980-04-26	581452		0	0	0		0	0	0	213914	0	49	40213314		
51626	4289	1118084	1978-09-28	1978-09-28 00:00:00	1978-09-28	1978-09-28 00:00:00	\N	38000177		0	0	0		0	0	0	284737	0	00025152531	44923712		
59037	4907	19073188	1983-07-02	1983-07-02 00:00:00	1983-08-06	1983-08-06 00:00:00	1983-08-06	38000177		0	0	35		0	0	0	326204	0	308192	19073188		
6670	563	19133873	1969-08-15	1969-08-15 00:00:00	1969-08-22	1969-08-22 00:00:00	1969-08-22	38000177		0	0	7		0	0	0	37195	0	834061	19133873		
64271	5334	1127433	1978-04-27	1978-04-27 00:00:00	1978-05-11	1978-05-11 00:00:00	1978-05-11	38000177		0	0	14		0	0	0	355199	0	313782	1127433		
173913	3823	40213160	1955-01-19	1955-01-19 00:00:00	1955-01-19	1955-01-19 00:00:00	1955-01-19	581452		0	0	0		0	0	0	253936	0	10	40213160		
5057	110	40213251	1984-02-12	1984-02-12 00:00:00	1984-02-12	1984-02-12 00:00:00	1984-02-12	581452		0	0	0		0	0	0	7345	0	21	40213251		
200148	4395	40213227	2008-03-14	2008-03-14 00:00:00	2008-03-14	2008-03-14 00:00:00	2008-03-14	581452		0	0	0		0	0	0	292234	0	113	40213227		
61023	5076	19078461	1983-04-05	1983-04-05 00:00:00	1983-04-26	1983-04-26 00:00:00	1983-04-26	38000177		0	0	21		0	0	0	337329	0	310965	19078461		
34807	2872	1127433	1992-07-14	1992-07-14 00:00:00	1992-08-04	1992-08-04 00:00:00	1992-08-04	38000177		0	0	21		0	0	0	191207	0	313782	1127433		
45844	3795	40229134	2004-04-03	2004-04-03 00:00:00	2004-04-17	2004-04-17 00:00:00	2004-04-17	38000177		0	0	14		0	0	0	252301	0	1043400	40229134		
27994	2318	19078461	1984-03-11	1984-03-11 00:00:00	1984-04-08	1984-04-08 00:00:00	1984-04-08	38000177		0	0	28		0	0	0	154116	0	310965	19078461		
45417	3757	19126352	2018-10-17	2018-10-17 00:00:00	2018-10-17	2018-10-17 00:00:00	\N	38000177		0	0	0		0	0	0	249802	0	705129	19126352		
45978	3807	1127433	1958-06-09	1958-06-09 00:00:00	1958-06-23	1958-06-23 00:00:00	1958-06-23	38000177		0	0	14		0	0	0	252997	0	313782	1127433		
118608	2609	40213227	2009-05-08	2009-05-08 00:00:00	2009-05-08	2009-05-08 00:00:00	2009-05-08	581452		0	0	0		0	0	0	172491	0	113	40213227		
15150	1266	1124300	2004-12-20	2004-12-20 00:00:00	2004-12-20	2004-12-20 00:00:00	\N	38000177		0	0	0		0	0	0	83461	0	00781178901	45011828		
219437	4816	40213227	2013-01-21	2013-01-21 00:00:00	2013-01-21	2013-01-21 00:00:00	2013-01-21	581452		0	0	0		0	0	0	320424	0	113	40213227		
10348	865	46233710	1974-03-31	1974-03-31 00:00:00	1974-04-14	1974-04-14 00:00:00	1974-04-14	38000177		0	0	14		0	0	0	57374	0	1650142	46233710		
39465	862	40213227	2001-09-18	2001-09-18 00:00:00	2001-09-18	2001-09-18 00:00:00	2001-09-18	581452		0	0	0		0	0	0	57097	0	113	40213227		
40579	884	40213306	1999-10-12	1999-10-12 00:00:00	1999-10-12	1999-10-12 00:00:00	1999-10-12	581452		0	0	0		0	0	0	58963	0	43	40213306		
8769	730	1127433	1966-04-17	1966-04-17 00:00:00	1966-04-24	1966-04-24 00:00:00	1966-04-24	38000177		0	0	7		0	0	0	48456	0	313782	1127433		
20996	1729	1127433	1985-07-28	1985-07-28 00:00:00	1985-08-11	1985-08-11 00:00:00	1985-08-11	38000177		0	0	14		0	0	0	115643	0	313782	1127433		
212512	4660	40213306	1983-10-30	1983-10-30 00:00:00	1983-10-30	1983-10-30 00:00:00	1983-10-30	581452		0	0	0		0	0	0	310642	0	43	40213306		
27595	2286	19006318	1959-03-04	1959-03-04 00:00:00	1959-03-18	1959-03-18 00:00:00	1959-03-18	38000177		0	0	14		0	0	0	152062	0	105078	19006318		
27653	2289	1127078	1953-06-13	1953-06-13 00:00:00	1953-06-27	1953-06-27 00:00:00	1953-06-27	38000177		0	0	14		0	0	0	152220	0	282464	1127078		
73709	1609	40213201	2010-03-10	2010-03-10 00:00:00	2010-03-10	2010-03-10 00:00:00	2010-03-10	581452		0	0	0		0	0	0	108075	0	33	40213201		
150021	3300	40213314	1982-11-11	1982-11-11 00:00:00	1982-11-11	1982-11-11 00:00:00	1982-11-11	581452		0	0	0		0	0	0	219250	0	49	40213314		
47087	3901	1127433	1993-11-03	1993-11-03 00:00:00	1993-11-17	1993-11-17 00:00:00	1993-11-17	38000177		0	0	14		0	0	0	259447	0	313782	1127433		
215247	4720	40213314	1977-04-26	1977-04-26 00:00:00	1977-04-26	1977-04-26 00:00:00	1977-04-26	581452		0	0	0		0	0	0	314364	0	49	40213314		
54756	4548	19019979	1995-05-18	1995-05-18 00:00:00	1995-06-01	1995-06-01 00:00:00	1995-06-01	38000177		0	0	14		0	0	0	303042	0	198405	19019979		
235465	5172	40213198	2010-11-23	2010-11-23 00:00:00	2010-11-23	2010-11-23 00:00:00	2010-11-23	581452		0	0	0		0	0	0	343901	0	133	40213198		
22500	488	40213227	2016-09-02	2016-09-02 00:00:00	2016-09-02	2016-09-02 00:00:00	2016-09-02	581452		0	0	0		0	0	0	32661	0	113	40213227		
57754	4799	19059056	1972-02-15	1972-02-15 00:00:00	1972-03-07	1972-03-07 00:00:00	1972-03-07	38000177		0	0	21		0	0	0	319244	0	243670	19059056		
153698	3383	40213314	1986-07-24	1986-07-24 00:00:00	1986-07-24	1986-07-24 00:00:00	1986-07-24	581452		0	0	0		0	0	0	224531	0	49	40213314		
29833	2470	1124300	1992-12-21	1992-12-21 00:00:00	1992-12-21	1992-12-21 00:00:00	\N	38000177		0	0	0		0	0	0	163828	0	00781178901	45011828		
43721	3623	1127433	1999-03-14	1999-03-14 00:00:00	1999-04-18	1999-04-18 00:00:00	1999-04-18	38000177		0	0	35		0	0	0	240936	0	313782	1127433		
57283	4755	40236824	1981-11-18	1981-11-18 00:00:00	1981-11-25	1981-11-25 00:00:00	1981-11-25	38000177		0	0	7		0	0	0	316727	0	1094107	40236824		
61826	5144	19078461	2009-11-14	2009-11-14 00:00:00	2009-12-05	2009-12-05 00:00:00	2009-12-05	38000177		0	0	21		0	0	0	341889	0	310965	19078461		
89545	1964	40213227	2002-09-18	2002-09-18 00:00:00	2002-09-18	2002-09-18 00:00:00	2002-09-18	581452		0	0	0		0	0	0	130584	0	113	40213227		
4424	366	40229134	1961-10-03	1961-10-03 00:00:00	1961-10-17	1961-10-17 00:00:00	1961-10-17	38000177		0	0	14		0	0	0	24385	0	1043400	40229134		
43066	939	40213227	1995-09-26	1995-09-26 00:00:00	1995-09-26	1995-09-26 00:00:00	1995-09-26	581452		0	0	0		0	0	0	62452	0	113	40213227		
31225	680	40213227	2009-10-05	2009-10-05 00:00:00	2009-10-05	2009-10-05 00:00:00	2009-10-05	581452		0	0	0		0	0	0	45012	0	113	40213227		
120521	2649	40213160	1957-11-11	1957-11-11 00:00:00	1957-11-11	1957-11-11 00:00:00	1957-11-11	581452		0	0	0		0	0	0	175284	0	10	40213160		
25642	2108	1127433	1946-10-03	1946-10-03 00:00:00	1946-10-10	1946-10-10 00:00:00	1946-10-10	38000177		0	0	7		0	0	0	140312	0	313782	1127433		
20467	1683	1127433	1985-11-03	1985-11-03 00:00:00	1986-02-01	1986-02-01 00:00:00	1986-02-01	38000177		0	0	90		0	0	0	112768	0	313782	1127433		
58807	4884	40169216	1975-10-28	1975-10-28 00:00:00	1975-10-28	1975-10-28 00:00:00	\N	38000177		0	0	0		0	0	0	324726	0	895994	40169216		
55931	4643	40231925	1940-08-30	1940-08-30 00:00:00	1940-08-30	1940-08-30 00:00:00	\N	38000177		0	0	0		0	0	0	309569	0	1049221	40231925		
11447	245	40213227	2007-07-22	2007-07-22 00:00:00	2007-07-22	2007-07-22 00:00:00	2007-07-22	581452		0	0	0		0	0	0	16394	0	113	40213227		
21476	1764	1127078	1960-01-09	1960-01-09 00:00:00	1960-01-23	1960-01-23 00:00:00	1960-01-23	38000177		0	0	14		0	0	0	118007	0	282464	1127078		
19922	1635	40243436	2013-03-27	2013-03-27 00:00:00	2013-03-27	2013-03-27 00:00:00	2013-03-27	38000177		0	0	0		0	0	0	109831	0	1190795	40243436		
7813	653	19059056	1957-09-20	1957-09-20 00:00:00	1957-10-04	1957-10-04 00:00:00	1957-10-04	38000177		0	0	14		0	0	0	43276	0	243670	19059056		
20011	1642	1127433	1978-07-15	1978-07-15 00:00:00	1978-07-22	1978-07-22 00:00:00	1978-07-22	38000177		0	0	7		0	0	0	110255	0	313782	1127433		
211563	4639	40213160	1970-05-29	1970-05-29 00:00:00	1970-05-29	1970-05-29 00:00:00	1970-05-29	581452		0	0	0		0	0	0	309203	0	10	40213160		
56327	4675	1127433	1969-03-23	1969-03-23 00:00:00	1969-04-06	1969-04-06 00:00:00	1969-04-06	38000177		0	0	14		0	0	0	311548	0	313782	1127433		
178622	3926	40213198	2013-07-01	2013-07-01 00:00:00	2013-07-01	2013-07-01 00:00:00	2013-07-01	581452		0	0	0		0	0	0	260934	0	133	40213198		
4753	398	1127433	1925-02-26	1925-02-26 00:00:00	1925-03-05	1925-03-05 00:00:00	1925-03-05	38000177		0	0	7		0	0	0	26067	0	313782	1127433		
129479	2847	40213160	1962-10-21	1962-10-21 00:00:00	1962-10-21	1962-10-21 00:00:00	1962-10-21	581452		0	0	0		0	0	0	189082	0	10	40213160		
39188	856	40213296	2011-06-24	2011-06-24 00:00:00	2011-06-24	2011-06-24 00:00:00	2011-06-24	581452		0	0	0		0	0	0	56551	0	52	40213296		
51027	1117	40213227	2017-06-17	2017-06-17 00:00:00	2017-06-17	2017-06-17 00:00:00	2017-06-17	581452		0	0	0		0	0	0	73659	0	113	40213227		
18163	1506	19133905	1975-12-30	1975-12-30 00:00:00	1976-01-10	1976-01-10 00:00:00	1976-01-10	38000177		0	0	11		0	0	0	100402	0	834102	19133905		
50279	4173	1127433	1977-02-18	1977-02-18 00:00:00	1977-03-04	1977-03-04 00:00:00	1977-03-04	38000177		0	0	14		0	0	0	277344	0	313782	1127433		
4843	403	19059056	1929-07-20	1929-07-20 00:00:00	1929-08-03	1929-08-03 00:00:00	1929-08-03	38000177		0	0	14		0	0	0	26535	0	243670	19059056		
146354	3219	40213314	1981-03-28	1981-03-28 00:00:00	1981-03-28	1981-03-28 00:00:00	1981-03-28	581452		0	0	0		0	0	0	213922	0	49	40213314		
62085	5166	19059056	1955-02-22	1955-02-22 00:00:00	1955-05-23	1955-05-23 00:00:00	1955-05-23	38000177		0	0	90		0	0	0	343399	0	243670	19059056		
59038	4907	40165015	1983-07-02	1983-07-02 00:00:00	1983-07-02	1983-07-02 00:00:00	\N	38000177		0	0	0		0	0	0	326204	0	861467	40165015		
6671	563	19133873	1974-10-28	1974-10-28 00:00:00	1974-11-05	1974-11-05 00:00:00	1974-11-05	38000177		0	0	8		0	0	0	37293	0	834061	19133873		
64272	5334	1118084	2001-01-30	2001-01-30 00:00:00	2001-01-30	2001-01-30 00:00:00	\N	38000177		0	0	0		0	0	0	355195	0	00025152531	44923712		
173919	3823	40213227	2016-06-08	2016-06-08 00:00:00	2016-06-08	2016-06-08 00:00:00	2016-06-08	581452		0	0	0		0	0	0	253946	0	113	40213227		
5061	110	40213227	2007-04-29	2007-04-29 00:00:00	2007-04-29	2007-04-29 00:00:00	2007-04-29	581452		0	0	0		0	0	0	7305	0	113	40213227		
200151	4395	40213160	1955-01-07	1955-01-07 00:00:00	1955-01-07	1955-01-07 00:00:00	1955-01-07	581452		0	0	0		0	0	0	292250	0	10	40213160		
61024	5076	19073188	2004-10-02	2004-10-02 00:00:00	2004-11-06	2004-11-06 00:00:00	2004-11-06	38000177		0	0	35		0	0	0	337330	0	308192	19073188		
34808	2872	19126352	1968-08-06	1968-08-06 00:00:00	1999-08-17	1999-08-17 00:00:00	1999-08-17	38000177		0	0	11333		0	0	0	191199	0	705129	19126352		
45845	3795	19133905	2009-10-06	2009-10-06 00:00:00	2009-10-16	2009-10-16 00:00:00	2009-10-16	38000177		0	0	10		0	0	0	252312	0	834102	19133905		
84406	1846	40213198	2016-02-25	2016-02-25 00:00:00	2016-02-25	2016-02-25 00:00:00	2016-02-25	581452		0	0	0		0	0	0	123425	0	133	40213198		
45418	3757	1332419	2018-10-17	2018-10-17 00:00:00	2018-10-17	2018-10-17 00:00:00	\N	38000177		0	0	0		0	0	0	249802	0	197361	1332419		
45979	3807	19059056	1974-08-25	1974-08-25 00:00:00	1974-10-24	1974-10-24 00:00:00	1974-10-24	38000177		0	0	60		0	0	0	253024	0	243670	19059056		
118609	2609	40213260	2009-05-08	2009-05-08 00:00:00	2009-05-08	2009-05-08 00:00:00	2009-05-08	581452		0	0	0		0	0	0	172491	0	121	40213260		
15151	1266	1127433	1994-11-16	1994-11-16 00:00:00	1994-11-23	1994-11-23 00:00:00	1994-11-23	38000177		0	0	7		0	0	0	83489	0	313782	1127433		
177461	3900	40213160	1972-06-13	1972-06-13 00:00:00	1972-06-13	1972-06-13 00:00:00	1972-06-13	581452		0	0	0		0	0	0	259328	0	10	40213160		
10349	865	1127433	1974-03-31	1974-03-31 00:00:00	1974-04-14	1974-04-14 00:00:00	1974-04-14	38000177		0	0	14		0	0	0	57374	0	313782	1127433		
39470	862	40213306	1990-11-13	1990-11-13 00:00:00	1990-11-13	1990-11-13 00:00:00	1990-11-13	581452		0	0	0		0	0	0	57076	0	43	40213306		
40580	884	40213251	1984-08-28	1984-08-28 00:00:00	1984-08-28	1984-08-28 00:00:00	1984-08-28	581452		0	0	0		0	0	0	58924	0	21	40213251		
8770	730	920300	1978-05-20	1978-05-20 00:00:00	1978-05-27	1978-05-27 00:00:00	1978-05-27	38000177		0	0	7		0	0	0	48486	0	311989	920300		
20997	1729	19078461	2014-02-14	2014-02-14 00:00:00	2014-03-14	2014-03-14 00:00:00	2014-03-14	38000177		0	0	28		0	0	0	115622	0	310965	19078461		
212514	4660	40213160	1961-08-13	1961-08-13 00:00:00	1961-08-13	1961-08-13 00:00:00	1961-08-13	581452		0	0	0		0	0	0	310627	0	10	40213160		
27596	2286	19133905	1998-01-28	1998-01-28 00:00:00	1998-02-06	1998-02-06 00:00:00	1998-02-06	38000177		0	0	9		0	0	0	152068	0	834102	19133905		
27654	2289	19006318	1953-06-13	1953-06-13 00:00:00	1953-06-27	1953-06-27 00:00:00	1953-06-27	38000177		0	0	14		0	0	0	152220	0	105078	19006318		
138677	3047	40213314	1977-07-06	1977-07-06 00:00:00	1977-07-06	1977-07-06 00:00:00	1977-07-06	581452		0	0	0		0	0	0	202735	0	49	40213314		
150023	3300	40213160	1982-11-11	1982-11-11 00:00:00	1982-11-11	1982-11-11 00:00:00	1982-11-11	581452		0	0	0		0	0	0	219250	0	10	40213160		
47088	3901	1115171	2013-10-04	2013-10-04 00:00:00	2013-10-25	2013-10-25 00:00:00	2013-10-25	38000177		0	0	21		0	0	0	259390	0	849574	1115171		
215253	4720	40213160	1976-10-26	1976-10-26 00:00:00	1976-10-26	1976-10-26 00:00:00	1976-10-26	581452		0	0	0		0	0	0	314353	0	10	40213160		
8646	185	40213227	2017-06-18	2017-06-18 00:00:00	2017-06-18	2017-06-18 00:00:00	2017-06-18	581452		0	0	0		0	0	0	12580	0	113	40213227		
49251	1079	40213160	1961-11-26	1961-11-26 00:00:00	1961-11-26	1961-11-26 00:00:00	1961-11-26	581452		0	0	0		0	0	0	70738	0	10	40213160		
22521	488	40213160	1955-03-11	1955-03-11 00:00:00	1955-03-11	1955-03-11 00:00:00	1955-03-11	581452		0	0	0		0	0	0	32696	0	10	40213160		
57756	4799	1310034	2010-05-01	2010-05-01 00:00:00	2010-05-01	2010-05-01 00:00:00	2010-05-01	38000177		0	0	0		0	0	0	319291	0	834357	1310034		
153703	3383	40213227	2017-06-29	2017-06-29 00:00:00	2017-06-29	2017-06-29 00:00:00	2017-06-29	581452		0	0	0		0	0	0	224502	0	113	40213227		
29834	2470	1127433	2014-01-20	2014-01-20 00:00:00	2014-01-27	2014-01-27 00:00:00	2014-01-27	38000177		0	0	7		0	0	0	163780	0	313782	1127433		
43722	3623	1127078	1958-02-02	1958-02-02 00:00:00	1958-02-23	1958-02-23 00:00:00	1958-02-23	38000177		0	0	21		0	0	0	240895	0	282464	1127078		
57284	4755	920300	1981-11-18	1981-11-18 00:00:00	1981-11-25	1981-11-25 00:00:00	1981-11-25	38000177		0	0	7		0	0	0	316727	0	311989	920300		
61827	5144	1127433	1942-02-28	1942-02-28 00:00:00	1942-03-07	1942-03-07 00:00:00	1942-03-07	38000177		0	0	7		0	0	0	341926	0	313782	1127433		
89546	1964	40213296	2002-09-18	2002-09-18 00:00:00	2002-09-18	2002-09-18 00:00:00	2002-09-18	581452		0	0	0		0	0	0	130584	0	52	40213296		
4433	368	1713671	1997-11-16	1997-11-16 00:00:00	1997-11-23	1997-11-23 00:00:00	1997-11-23	38000177		0	0	7		0	0	0	24519	0	562251	1713671		
43068	939	40213260	2014-09-23	2014-09-23 00:00:00	2014-09-23	2014-09-23 00:00:00	2014-09-23	581452		0	0	0		0	0	0	62489	0	121	40213260		
31230	680	40213306	1989-04-03	1989-04-03 00:00:00	1989-04-03	1989-04-03 00:00:00	1989-04-03	581452		0	0	0		0	0	0	45054	0	43	40213306		
154771	3407	40213296	2006-03-10	2006-03-10 00:00:00	2006-03-10	2006-03-10 00:00:00	2006-03-10	581452		0	0	0		0	0	0	225972	0	52	40213296		
25643	2108	1713671	2010-03-01	2010-03-01 00:00:00	2010-03-22	2010-03-22 00:00:00	2010-03-22	38000177		0	0	21		0	0	0	140386	0	562251	1713671		
20468	1683	1118084	2014-01-22	2014-01-22 00:00:00	2014-01-22	2014-01-22 00:00:00	\N	38000177		0	0	0		0	0	0	112785	0	00025152531	44923712		
58808	4884	19019979	1977-05-15	1977-05-15 00:00:00	1977-05-29	1977-05-29 00:00:00	1977-05-29	38000177		0	0	14		0	0	0	324753	0	198405	19019979		
55932	4643	1124300	1944-06-22	1944-06-22 00:00:00	1944-06-22	1944-06-22 00:00:00	\N	38000177		0	0	0		0	0	0	309503	0	00781178901	45011828		
11453	246	40213160	1964-09-24	1964-09-24 00:00:00	1964-09-24	1964-09-24 00:00:00	1964-09-24	581452		0	0	0		0	0	0	\N	0	10	40213160		
21477	1764	1713671	1974-06-01	1974-06-01 00:00:00	1974-07-13	1974-07-13 00:00:00	1974-07-13	38000177		0	0	42		0	0	0	117945	0	562251	1713671		
19923	1635	19059056	1988-01-19	1988-01-19 00:00:00	1988-02-16	1988-02-16 00:00:00	1988-02-16	38000177		0	0	28		0	0	0	109830	0	243670	19059056		
7814	653	19059056	1954-12-21	1954-12-21 00:00:00	1955-01-04	1955-01-04 00:00:00	1955-01-04	38000177		0	0	14		0	0	0	43267	0	243670	19059056		
20012	1642	1127433	1981-08-12	1981-08-12 00:00:00	1981-08-26	1981-08-26 00:00:00	1981-08-26	38000177		0	0	14		0	0	0	110201	0	313782	1127433		
211568	4639	40213160	1970-07-31	1970-07-31 00:00:00	1970-07-31	1970-07-31 00:00:00	1970-07-31	581452		0	0	0		0	0	0	309211	0	10	40213160		
56328	4675	40231925	1946-09-08	1946-09-08 00:00:00	1946-09-08	1946-09-08 00:00:00	\N	38000177		0	0	0		0	0	0	311504	0	1049221	40231925		
3705	308	19059056	1962-02-05	1962-02-05 00:00:00	1962-03-05	1962-03-05 00:00:00	1962-03-05	38000177		0	0	28		0	0	0	20399	0	243670	19059056		
4754	398	19059056	1925-12-22	1925-12-22 00:00:00	1926-01-05	1926-01-05 00:00:00	1926-01-05	38000177		0	0	14		0	0	0	26087	0	243670	19059056		
129481	2847	40213306	1985-06-23	1985-06-23 00:00:00	1985-06-23	1985-06-23 00:00:00	1985-06-23	581452		0	0	0		0	0	0	189090	0	43	40213306		
39189	856	40213160	1969-11-21	1969-11-21 00:00:00	1969-11-21	1969-11-21 00:00:00	1969-11-21	581452		0	0	0		0	0	0	56529	0	10	40213160		
129585	2849	40213227	2001-06-04	2001-06-04 00:00:00	2001-06-04	2001-06-04 00:00:00	2001-06-04	581452		0	0	0		0	0	0	189222	0	113	40213227		
18164	1506	19133905	1980-05-02	1980-05-02 00:00:00	1980-05-12	1980-05-12 00:00:00	1980-05-12	38000177		0	0	10		0	0	0	100414	0	834102	19133905		
50280	4173	1127433	2012-06-18	2012-06-18 00:00:00	2012-07-02	2012-07-02 00:00:00	2012-07-02	38000177		0	0	14		0	0	0	277328	0	313782	1127433		
4844	403	19133873	1936-08-22	1936-08-22 00:00:00	1936-09-04	1936-09-04 00:00:00	1936-09-04	38000177		0	0	13		0	0	0	26532	0	834061	19133873		
146356	3219	40213227	2011-10-15	2011-10-15 00:00:00	2011-10-15	2011-10-15 00:00:00	2011-10-15	581452		0	0	0		0	0	0	213938	0	113	40213227		
62086	5166	1127433	2003-01-18	2003-01-18 00:00:00	2003-01-25	2003-01-25 00:00:00	2003-01-25	38000177		0	0	7		0	0	0	343463	0	313782	1127433		
59039	4907	19078461	1983-07-02	1983-07-02 00:00:00	1983-08-06	1983-08-06 00:00:00	1983-08-06	38000177		0	0	35		0	0	0	326204	0	310965	19078461		
6672	563	19075601	2005-03-13	2005-03-13 00:00:00	2005-03-13	2005-03-13 00:00:00	2005-03-13	38000177		0	0	0		0	0	0	37311	0	309362	19075601		
64274	5334	19133873	1965-10-12	1965-10-12 00:00:00	1965-10-25	1965-10-25 00:00:00	1965-10-25	38000177		0	0	13		0	0	0	355229	0	834061	19133873		
75968	1659	40213160	1969-11-24	1969-11-24 00:00:00	1969-11-24	1969-11-24 00:00:00	1969-11-24	581452		0	0	0		0	0	0	111490	0	10	40213160		
5063	110	40213314	1977-07-24	1977-07-24 00:00:00	1977-07-24	1977-07-24 00:00:00	1977-07-24	581452		0	0	0		0	0	0	7342	0	49	40213314		
148421	3263	40213227	1995-10-31	1995-10-31 00:00:00	1995-10-31	1995-10-31 00:00:00	1995-10-31	581452		0	0	0		0	0	0	216936	0	113	40213227		
61025	5076	1115171	2004-10-02	2004-10-02 00:00:00	2004-11-06	2004-11-06 00:00:00	2004-11-06	38000177		0	0	35		0	0	0	337330	0	849574	1115171		
34830	2876	19129655	1964-08-05	1964-08-05 00:00:00	1964-08-19	1964-08-19 00:00:00	1964-08-19	38000177		0	0	14		0	0	0	191328	0	789980	19129655		
45846	3795	40231925	1993-06-28	1993-06-28 00:00:00	1993-06-28	1993-06-28 00:00:00	\N	38000177		0	0	0		0	0	0	252344	0	1049221	40231925		
84413	1846	40213227	2002-01-03	2002-01-03 00:00:00	2002-01-03	2002-01-03 00:00:00	2002-01-03	581452		0	0	0		0	0	0	123454	0	113	40213227		
45419	3757	1539411	2018-10-17	2018-10-17 00:00:00	2018-10-17	2018-10-17 00:00:00	\N	38000177		0	0	0		0	0	0	249802	0	312961	1539411		
45980	3807	19059056	1948-03-29	1948-03-29 00:00:00	1948-04-12	1948-04-12 00:00:00	1948-04-12	38000177		0	0	14		0	0	0	252963	0	243670	19059056		
232990	5119	40213227	1994-04-19	1994-04-19 00:00:00	1994-04-19	1994-04-19 00:00:00	1994-04-19	581452		0	0	0		0	0	0	340297	0	113	40213227		
15152	1266	1127433	1974-09-09	1974-09-09 00:00:00	1974-09-23	1974-09-23 00:00:00	1974-09-23	38000177		0	0	14		0	0	0	83480	0	313782	1127433		
177467	3900	40213160	1967-12-12	1967-12-12 00:00:00	1967-12-12	1967-12-12 00:00:00	1967-12-12	581452		0	0	0		0	0	0	259325	0	10	40213160		
10350	865	19133873	1955-12-10	1955-12-10 00:00:00	1955-12-23	1955-12-23 00:00:00	1955-12-23	38000177		0	0	13		0	0	0	57359	0	834061	19133873		
39472	862	40213227	1993-11-16	1993-11-16 00:00:00	1993-11-16	1993-11-16 00:00:00	1993-11-16	581452		0	0	0		0	0	0	57096	0	113	40213227		
40585	884	40213160	1978-02-14	1978-02-14 00:00:00	1978-02-14	1978-02-14 00:00:00	1978-02-14	581452		0	0	0		0	0	0	58871	0	10	40213160		
8771	730	40236824	1978-05-20	1978-05-20 00:00:00	1978-05-27	1978-05-27 00:00:00	1978-05-27	38000177		0	0	7		0	0	0	48486	0	1094107	40236824		
188969	4149	40213306	1989-02-24	1989-02-24 00:00:00	1989-02-24	1989-02-24 00:00:00	1989-02-24	581452		0	0	0		0	0	0	275733	0	43	40213306		
212519	4660	40213227	2011-12-11	2011-12-11 00:00:00	2011-12-11	2011-12-11 00:00:00	2011-12-11	581452		0	0	0		0	0	0	310648	0	113	40213227		
27597	2286	19078461	2004-02-24	2004-02-24 00:00:00	2004-03-09	2004-03-09 00:00:00	2004-03-09	38000177		0	0	14		0	0	0	152093	0	310965	19078461		
27655	2289	1127433	1971-11-18	1971-11-18 00:00:00	1971-12-02	1971-12-02 00:00:00	1971-12-02	38000177		0	0	14		0	0	0	152251	0	313782	1127433		
138679	3047	40213160	1977-07-06	1977-07-06 00:00:00	1977-07-06	1977-07-06 00:00:00	1977-07-06	581452		0	0	0		0	0	0	202735	0	10	40213160		
150026	3300	40213314	1983-08-11	1983-08-11 00:00:00	1983-08-11	1983-08-11 00:00:00	1983-08-11	581452		0	0	0		0	0	0	219252	0	49	40213314		
2303	185	19059056	1986-02-25	1986-02-25 00:00:00	1986-03-25	1986-03-25 00:00:00	1986-03-25	38000177		0	0	28		0	0	0	12521	0	243670	19059056		
73753	1609	40213227	2005-02-09	2005-02-09 00:00:00	2005-02-09	2005-02-09 00:00:00	2005-02-09	581452		0	0	0		0	0	0	108082	0	113	40213227		
8649	185	40213227	2008-04-27	2008-04-27 00:00:00	2008-04-27	2008-04-27 00:00:00	2008-04-27	581452		0	0	0		0	0	0	12579	0	113	40213227		
49254	1079	40213160	1966-02-27	1966-02-27 00:00:00	1966-02-27	1966-02-27 00:00:00	1966-02-27	581452		0	0	0		0	0	0	70750	0	10	40213160		
22527	488	40213160	1955-06-10	1955-06-10 00:00:00	1955-06-10	1955-06-10 00:00:00	1955-06-10	581452		0	0	0		0	0	0	32688	0	10	40213160		
57757	4799	40243436	2010-05-01	2010-05-01 00:00:00	2010-05-01	2010-05-01 00:00:00	2010-05-01	38000177		0	0	0		0	0	0	319291	0	1190795	40243436		
153705	3383	40213314	1987-06-25	1987-06-25 00:00:00	1987-06-25	1987-06-25 00:00:00	1987-06-25	581452		0	0	0		0	0	0	224508	0	49	40213314		
29835	2470	19059056	1959-09-11	1959-09-11 00:00:00	1959-09-25	1959-09-25 00:00:00	1959-09-25	38000177		0	0	14		0	0	0	163821	0	243670	19059056		
43723	3623	19078461	2012-03-01	2012-03-01 00:00:00	2012-04-05	2012-04-05 00:00:00	2012-04-05	38000177		0	0	35		0	0	0	240939	0	310965	19078461		
57285	4755	1713671	1928-12-22	1928-12-22 00:00:00	1929-01-12	1929-01-12 00:00:00	1929-01-12	38000177		0	0	21		0	0	0	316680	0	562251	1713671		
61828	5144	40229134	1957-05-25	1957-05-25 00:00:00	1957-06-08	1957-06-08 00:00:00	1957-06-08	38000177		0	0	14		0	0	0	341943	0	1043400	40229134		
89553	1964	40213227	1992-04-15	1992-04-15 00:00:00	1992-04-15	1992-04-15 00:00:00	1992-04-15	581452		0	0	0		0	0	0	130608	0	113	40213227		
4434	368	1127078	1982-03-12	1982-03-12 00:00:00	1982-03-26	1982-03-26 00:00:00	1982-03-26	38000177		0	0	14		0	0	0	24497	0	282464	1127078		
43073	939	40213227	2015-09-29	2015-09-29 00:00:00	2015-09-29	2015-09-29 00:00:00	2015-09-29	581452		0	0	0		0	0	0	62428	0	113	40213227		
31236	680	40213227	1992-04-06	1992-04-06 00:00:00	1992-04-06	1992-04-06 00:00:00	1992-04-06	581452		0	0	0		0	0	0	45055	0	113	40213227		
154777	3407	40213160	1963-05-03	1963-05-03 00:00:00	1963-05-03	1963-05-03 00:00:00	1963-05-03	581452		0	0	0		0	0	0	225936	0	10	40213160		
25644	2108	40165015	1987-06-03	1987-06-03 00:00:00	1987-06-03	1987-06-03 00:00:00	\N	38000177		0	0	0		0	0	0	140358	0	861467	40165015		
20469	1683	19128022	1996-05-21	1996-05-21 00:00:00	1997-05-16	1997-05-16 00:00:00	1997-05-16	38000177		0	0	360		0	0	0	112802	0	749785	19128022		
58809	4884	46233988	1977-05-15	1977-05-15 00:00:00	1977-05-29	1977-05-29 00:00:00	1977-05-29	38000177		0	0	14		0	0	0	324753	0	1652673	46233988		
55933	4643	19059056	1914-02-04	1914-02-04 00:00:00	1914-02-18	1914-02-18 00:00:00	1914-02-18	38000177		0	0	14		0	0	0	309567	0	243670	19059056		
58861	4890	40173590	2000-09-06	2000-09-06 00:00:00	2000-09-06	2000-09-06 00:00:00	\N	38000177		0	0	0		0	0	0	325251	0	904419	40173590		
21478	1764	1115171	2000-09-09	2000-09-09 00:00:00	2000-10-14	2000-10-14 00:00:00	2000-10-14	38000177		0	0	35		0	0	0	117991	0	849574	1115171		
19924	1635	19059056	1975-05-06	1975-05-06 00:00:00	1975-05-20	1975-05-20 00:00:00	1975-05-20	38000177		0	0	14		0	0	0	109823	0	243670	19059056		
7815	653	19006318	1954-12-21	1954-12-21 00:00:00	1955-01-04	1955-01-04 00:00:00	1955-01-04	38000177		0	0	14		0	0	0	43267	0	105078	19006318		
20013	1642	19073188	1981-08-12	1981-08-12 00:00:00	1981-08-26	1981-08-26 00:00:00	1981-08-26	38000177		0	0	14		0	0	0	110201	0	308192	19073188		
211572	4639	40213160	1975-01-31	1975-01-31 00:00:00	1975-01-31	1975-01-31 00:00:00	1975-01-31	581452		0	0	0		0	0	0	309229	0	10	40213160		
56329	4675	19006318	1946-09-08	1946-09-08 00:00:00	1946-09-29	1946-09-29 00:00:00	1946-09-29	38000177		0	0	21		0	0	0	311504	0	105078	19006318		
3706	308	1713671	2013-11-01	2013-11-01 00:00:00	2013-11-15	2013-11-15 00:00:00	2013-11-15	38000177		0	0	14		0	0	0	20426	0	562251	1713671		
4755	398	19059056	1955-07-09	1955-07-09 00:00:00	1955-07-30	1955-07-30 00:00:00	1955-07-30	38000177		0	0	21		0	0	0	26106	0	243670	19059056		
129483	2847	40213160	1962-05-20	1962-05-20 00:00:00	1962-05-20	1962-05-20 00:00:00	1962-05-20	581452		0	0	0		0	0	0	189081	0	10	40213160		
39191	856	40213160	1970-02-20	1970-02-20 00:00:00	1970-02-20	1970-02-20 00:00:00	1970-02-20	581452		0	0	0		0	0	0	56554	0	10	40213160		
129588	2849	40213227	2011-08-01	2011-08-01 00:00:00	2011-08-01	2011-08-01 00:00:00	2011-08-01	581452		0	0	0		0	0	0	189195	0	113	40213227		
18165	1506	19059056	1946-09-30	1946-09-30 00:00:00	1946-10-14	1946-10-14 00:00:00	1946-10-14	38000177		0	0	14		0	0	0	100449	0	243670	19059056		
50281	4173	1713671	2007-09-12	2007-09-12 00:00:00	2007-09-26	2007-09-26 00:00:00	2007-09-26	38000177		0	0	14		0	0	0	277364	0	562251	1713671		
4845	404	19112599	1965-07-04	1965-07-04 00:00:00	1965-07-04	1965-07-04 00:00:00	\N	38000177		0	0	0		0	0	0	26673	0	477045	19112599		
146362	3219	40213306	2002-10-05	2002-10-05 00:00:00	2002-10-05	2002-10-05 00:00:00	2002-10-05	581452		0	0	0		0	0	0	213935	0	43	40213306		
62087	5166	19078461	2008-12-15	2008-12-15 00:00:00	2009-01-12	2009-01-12 00:00:00	2009-01-12	38000177		0	0	28		0	0	0	343404	0	310965	19078461		
59040	4907	19059056	1948-12-18	1948-12-18 00:00:00	1949-01-01	1949-01-01 00:00:00	1949-01-01	38000177		0	0	14		0	0	0	326102	0	243670	19059056		
6673	563	40220960	2005-03-13	2005-03-13 00:00:00	2005-03-13	2005-03-13 00:00:00	2005-03-13	38000177		0	0	0		0	0	0	37311	0	1804799	40220960		
64275	5334	19133873	1976-10-01	1976-10-01 00:00:00	1976-10-11	1976-10-11 00:00:00	1976-10-11	38000177		0	0	10		0	0	0	355230	0	834061	19133873		
75971	1659	40213160	1969-08-25	1969-08-25 00:00:00	1969-08-25	1969-08-25 00:00:00	1969-08-25	581452		0	0	0		0	0	0	111476	0	10	40213160		
5071	110	40213160	1981-01-25	1981-01-25 00:00:00	1981-01-25	1981-01-25 00:00:00	1981-01-25	581452		0	0	0		0	0	0	7321	0	10	40213160		
148426	3263	40213227	2016-03-22	2016-03-22 00:00:00	2016-03-22	2016-03-22 00:00:00	2016-03-22	581452		0	0	0		0	0	0	216880	0	113	40213227		
61026	5076	1127433	1942-02-16	1942-02-16 00:00:00	1942-02-23	1942-02-23 00:00:00	1942-02-23	38000177		0	0	7		0	0	0	337425	0	313782	1127433		
34831	2876	19059056	1964-08-05	1964-08-05 00:00:00	1964-08-19	1964-08-19 00:00:00	1964-08-19	38000177		0	0	14		0	0	0	191328	0	243670	19059056		
45847	3795	1127433	1993-06-28	1993-06-28 00:00:00	1993-07-28	1993-07-28 00:00:00	1993-07-28	38000177		0	0	30		0	0	0	252344	0	313782	1127433		
84428	1846	40213227	1993-01-07	1993-01-07 00:00:00	1993-01-07	1993-01-07 00:00:00	1993-01-07	581452		0	0	0		0	0	0	123467	0	113	40213227		
45420	3757	19075601	2018-10-17	2018-10-17 00:00:00	2018-10-17	2018-10-17 00:00:00	\N	38000177		0	0	0		0	0	0	249802	0	309362	19075601		
45981	3807	19006318	1948-03-29	1948-03-29 00:00:00	1948-04-12	1948-04-12 00:00:00	1948-04-12	38000177		0	0	14		0	0	0	252963	0	105078	19006318		
232992	5119	40213260	2012-05-08	2012-05-08 00:00:00	2012-05-08	2012-05-08 00:00:00	2012-05-08	581452		0	0	0		0	0	0	340398	0	121	40213260		
15153	1266	1127433	2017-12-11	2017-12-11 00:00:00	2017-12-25	2017-12-25 00:00:00	2017-12-25	38000177		0	0	14		0	0	0	83435	0	313782	1127433		
177473	3900	40213160	1967-10-10	1967-10-10 00:00:00	1967-10-10	1967-10-10 00:00:00	1967-10-10	581452		0	0	0		0	0	0	259299	0	10	40213160		
10351	865	1127433	1993-04-11	1993-04-11 00:00:00	1993-04-25	1993-04-25 00:00:00	1993-04-25	38000177		0	0	14		0	0	0	57368	0	313782	1127433		
39473	862	40213306	1993-11-16	1993-11-16 00:00:00	1993-11-16	1993-11-16 00:00:00	1993-11-16	581452		0	0	0		0	0	0	57096	0	43	40213306		
40586	884	40213314	1978-02-14	1978-02-14 00:00:00	1978-02-14	1978-02-14 00:00:00	1978-02-14	581452		0	0	0		0	0	0	58871	0	49	40213314		
8772	730	1713671	1990-06-27	1990-06-27 00:00:00	1990-07-18	1990-07-18 00:00:00	1990-07-18	38000177		0	0	21		0	0	0	48479	0	562251	1713671		
188971	4149	40213227	1998-01-02	1998-01-02 00:00:00	1998-01-02	1998-01-02 00:00:00	1998-01-02	581452		0	0	0		0	0	0	275737	0	113	40213227		
212520	4660	40213260	2011-12-11	2011-12-11 00:00:00	2011-12-11	2011-12-11 00:00:00	2011-12-11	581452		0	0	0		0	0	0	310648	0	121	40213260		
27598	2286	1118084	1996-10-07	1996-10-07 00:00:00	1996-10-07	1996-10-07 00:00:00	\N	38000177		0	0	0		0	0	0	152092	0	00025152531	44923712		
27656	2289	19059056	1957-04-23	1957-04-23 00:00:00	1957-05-14	1957-05-14 00:00:00	1957-05-14	38000177		0	0	21		0	0	0	152262	0	243670	19059056		
138687	3047	40213296	2015-09-30	2015-09-30 00:00:00	2015-09-30	2015-09-30 00:00:00	2015-09-30	581452		0	0	0		0	0	0	202776	0	52	40213296		
150032	3300	40213160	1987-05-14	1987-05-14 00:00:00	1987-05-14	1987-05-14 00:00:00	1987-05-14	581452		0	0	0		0	0	0	219207	0	10	40213160		
2304	185	1127078	1950-11-06	1950-11-06 00:00:00	1950-11-20	1950-11-20 00:00:00	1950-11-20	38000177		0	0	14		0	0	0	12551	0	282464	1127078		
205272	4505	40213201	2003-02-25	2003-02-25 00:00:00	2003-02-25	2003-02-25 00:00:00	2003-02-25	581452		0	0	0		0	0	0	300096	0	33	40213201		
8650	186	40213306	1993-12-26	1993-12-26 00:00:00	1993-12-26	1993-12-26 00:00:00	1993-12-26	581452		0	0	0		0	0	0	12635	0	43	40213306		
49258	1079	40213227	1994-08-14	1994-08-14 00:00:00	1994-08-14	1994-08-14 00:00:00	1994-08-14	581452		0	0	0		0	0	0	70726	0	113	40213227		
22533	488	40213260	2006-04-28	2006-04-28 00:00:00	2006-04-28	2006-04-28 00:00:00	2006-04-28	581452		0	0	0		0	0	0	32683	0	121	40213260		
57758	4799	46275916	2010-05-01	2010-05-01 00:00:00	2010-05-01	2010-05-01 00:00:00	2010-05-01	38000177		0	0	0		0	0	0	319291	0	1660014	46275916		
153706	3383	40213251	1987-06-25	1987-06-25 00:00:00	1987-06-25	1987-06-25 00:00:00	1987-06-25	581452		0	0	0		0	0	0	224508	0	21	40213251		
29836	2470	19006318	1959-09-11	1959-09-11 00:00:00	1959-09-25	1959-09-25 00:00:00	1959-09-25	38000177		0	0	14		0	0	0	163821	0	105078	19006318		
43724	3623	19133873	1956-06-27	1956-06-27 00:00:00	1956-07-10	1956-07-10 00:00:00	1956-07-10	38000177		0	0	13		0	0	0	240887	0	834061	19133873		
57286	4755	19059056	1933-01-24	1933-01-24 00:00:00	1933-02-14	1933-02-14 00:00:00	1933-02-14	38000177		0	0	21		0	0	0	316707	0	243670	19059056		
61829	5144	40229134	1951-04-19	1951-04-19 00:00:00	1951-05-03	1951-05-03 00:00:00	1951-05-03	38000177		0	0	14		0	0	0	341963	0	1043400	40229134		
89554	1964	40213260	2011-10-12	2011-10-12 00:00:00	2011-10-12	2011-10-12 00:00:00	2011-10-12	581452		0	0	0		0	0	0	130598	0	121	40213260		
4435	368	40229134	2008-10-22	2008-10-22 00:00:00	2008-11-05	2008-11-05 00:00:00	2008-11-05	38000177		0	0	14		0	0	0	24485	0	1043400	40229134		
43074	939	40213260	2015-09-29	2015-09-29 00:00:00	2015-09-29	2015-09-29 00:00:00	2015-09-29	581452		0	0	0		0	0	0	62428	0	121	40213260		
116214	2554	40213227	1994-11-03	1994-11-03 00:00:00	1994-11-03	1994-11-03 00:00:00	1994-11-03	581452		0	0	0		0	0	0	169254	0	113	40213227		
154789	3407	40213227	2004-03-05	2004-03-05 00:00:00	2004-03-05	2004-03-05 00:00:00	2004-03-05	581452		0	0	0		0	0	0	225966	0	113	40213227		
25645	2108	1127433	1987-06-03	1987-06-03 00:00:00	1987-09-01	1987-09-01 00:00:00	1987-09-01	38000177		0	0	90		0	0	0	140358	0	313782	1127433		
20479	1685	1127078	1985-05-14	1985-05-14 00:00:00	1985-05-28	1985-05-28 00:00:00	1985-05-28	38000177		0	0	14		0	0	0	112894	0	282464	1127078		
20510	1689	1713671	1943-03-26	1943-03-26 00:00:00	1943-04-02	1943-04-02 00:00:00	1943-04-02	38000177		0	0	7		0	0	0	113117	0	562251	1713671		
55934	4643	1713671	1941-11-20	1941-11-20 00:00:00	1941-12-11	1941-12-11 00:00:00	1941-12-11	38000177		0	0	21		0	0	0	309608	0	562251	1713671		
58862	4890	1127433	1980-05-26	1980-05-26 00:00:00	1980-06-09	1980-06-09 00:00:00	1980-06-09	38000177		0	0	14		0	0	0	325201	0	313782	1127433		
21479	1764	40229134	1992-12-22	1992-12-22 00:00:00	1992-12-29	1992-12-29 00:00:00	1992-12-29	38000177		0	0	7		0	0	0	117982	0	1043400	40229134		
19925	1635	19006318	1975-05-06	1975-05-06 00:00:00	1975-05-20	1975-05-20 00:00:00	1975-05-20	38000177		0	0	14		0	0	0	109823	0	105078	19006318		
7816	653	1127433	1965-12-23	1965-12-23 00:00:00	1966-01-13	1966-01-13 00:00:00	1966-01-13	38000177		0	0	21		0	0	0	43261	0	313782	1127433		
20014	1642	40165015	1981-08-12	1981-08-12 00:00:00	1981-08-12	1981-08-12 00:00:00	\N	38000177		0	0	0		0	0	0	110201	0	861467	40165015		
211575	4639	40213227	2012-03-02	2012-03-02 00:00:00	2012-03-02	2012-03-02 00:00:00	2012-03-02	581452		0	0	0		0	0	0	309222	0	113	40213227		
56330	4675	19059056	1946-09-08	1946-09-08 00:00:00	1946-09-29	1946-09-29 00:00:00	1946-09-29	38000177		0	0	21		0	0	0	311504	0	243670	19059056		
3707	308	1127433	1961-08-11	1961-08-11 00:00:00	1961-08-18	1961-08-18 00:00:00	1961-08-18	38000177		0	0	7		0	0	0	20455	0	313782	1127433		
4756	398	19059056	1957-04-20	1957-04-20 00:00:00	1957-05-18	1957-05-18 00:00:00	1957-05-18	38000177		0	0	28		0	0	0	26069	0	243670	19059056		
129485	2847	40213306	1984-04-15	1984-04-15 00:00:00	1984-04-15	1984-04-15 00:00:00	1984-04-15	581452		0	0	0		0	0	0	189089	0	43	40213306		
39193	856	40213160	1969-09-19	1969-09-19 00:00:00	1969-09-19	1969-09-19 00:00:00	1969-09-19	581452		0	0	0		0	0	0	56542	0	10	40213160		
140876	3093	40213160	1971-10-02	1971-10-02 00:00:00	1971-10-02	1971-10-02 00:00:00	1971-10-02	581452		0	0	0		0	0	0	205932	0	10	40213160		
18166	1506	19006318	1946-09-30	1946-09-30 00:00:00	1946-10-14	1946-10-14 00:00:00	1946-10-14	38000177		0	0	14		0	0	0	100449	0	105078	19006318		
50282	4173	1713671	1965-02-01	1965-02-01 00:00:00	1965-02-22	1965-02-22 00:00:00	1965-02-22	38000177		0	0	21		0	0	0	277360	0	562251	1713671		
4846	404	40229134	2007-01-21	2007-01-21 00:00:00	2007-01-28	2007-01-28 00:00:00	2007-01-28	38000177		0	0	7		0	0	0	26593	0	1043400	40229134		
146364	3219	40213227	2002-10-05	2002-10-05 00:00:00	2002-10-05	2002-10-05 00:00:00	2002-10-05	581452		0	0	0		0	0	0	213935	0	113	40213227		
62088	5166	1127433	1989-05-24	1989-05-24 00:00:00	1989-06-28	1989-06-28 00:00:00	1989-06-28	38000177		0	0	35		0	0	0	343402	0	313782	1127433		
59041	4907	19006318	1948-12-18	1948-12-18 00:00:00	1949-01-01	1949-01-01 00:00:00	1949-01-01	38000177		0	0	14		0	0	0	326102	0	105078	19006318		
6674	563	19078461	1978-01-11	1978-01-11 00:00:00	1978-02-01	1978-02-01 00:00:00	1978-02-01	38000177		0	0	21		0	0	0	37271	0	310965	19078461		
64276	5334	1127433	1967-12-01	1967-12-01 00:00:00	1967-12-08	1967-12-08 00:00:00	1967-12-08	38000177		0	0	7		0	0	0	355203	0	313782	1127433		
75974	1659	40213160	1969-06-23	1969-06-23 00:00:00	1969-06-23	1969-06-23 00:00:00	1969-06-23	581452		0	0	0		0	0	0	111503	0	10	40213160		
5076	110	40213160	1976-10-24	1976-10-24 00:00:00	1976-10-24	1976-10-24 00:00:00	1976-10-24	581452		0	0	0		0	0	0	7341	0	10	40213160		
80124	1753	40213227	1995-06-08	1995-06-08 00:00:00	1995-06-08	1995-06-08 00:00:00	1995-06-08	581452		0	0	0		0	0	0	117313	0	113	40213227		
61027	5076	1127433	1975-11-15	1975-11-15 00:00:00	1975-12-13	1975-12-13 00:00:00	1975-12-13	38000177		0	0	28		0	0	0	337328	0	313782	1127433		
34832	2876	1115171	2016-05-25	2016-05-25 00:00:00	2016-06-15	2016-06-15 00:00:00	2016-06-15	38000177		0	0	21		0	0	0	191394	0	849574	1115171		
45848	3795	1713671	2012-07-28	2012-07-28 00:00:00	2012-08-11	2012-08-11 00:00:00	2012-08-11	38000177		0	0	14		0	0	0	252306	0	562251	1713671		
84439	1846	40213201	2017-03-02	2017-03-02 00:00:00	2017-03-02	2017-03-02 00:00:00	2017-03-02	581452		0	0	0		0	0	0	123406	0	33	40213201		
45421	3757	1713671	1967-07-15	1967-07-15 00:00:00	1967-07-29	1967-07-29 00:00:00	1967-07-29	38000177		0	0	14		0	0	0	249734	0	562251	1713671		
45982	3807	1127433	1965-10-18	1965-10-18 00:00:00	1965-10-25	1965-10-25 00:00:00	1965-10-25	38000177		0	0	7		0	0	0	252961	0	313782	1127433		
232997	5119	40213160	1963-01-15	1963-01-15 00:00:00	1963-01-15	1963-01-15 00:00:00	1963-01-15	581452		0	0	0		0	0	0	340400	0	10	40213160		
15154	1266	19133873	1980-07-31	1980-07-31 00:00:00	1980-08-09	1980-08-09 00:00:00	1980-08-09	38000177		0	0	9		0	0	0	83485	0	834061	19133873		
177479	3900	40213306	1989-09-05	1989-09-05 00:00:00	1989-09-05	1989-09-05 00:00:00	1989-09-05	581452		0	0	0		0	0	0	259314	0	43	40213306		
10352	865	1713671	2010-05-16	2010-05-16 00:00:00	2010-06-06	2010-06-06 00:00:00	2010-06-06	38000177		0	0	21		0	0	0	57441	0	562251	1713671		
39476	862	40213296	2012-06-12	2012-06-12 00:00:00	2012-06-12	2012-06-12 00:00:00	2012-06-12	581452		0	0	0		0	0	0	57079	0	52	40213296		
40595	884	40213296	2017-09-12	2017-09-12 00:00:00	2017-09-12	2017-09-12 00:00:00	2017-09-12	581452		0	0	0		0	0	0	58968	0	52	40213296		
8773	730	1127433	1962-09-16	1962-09-16 00:00:00	1962-09-30	1962-09-30 00:00:00	1962-09-30	38000177		0	0	14		0	0	0	48476	0	313782	1127433		
188972	4149	40213160	1966-08-05	1966-08-05 00:00:00	1966-08-05	1966-08-05 00:00:00	1966-08-05	581452		0	0	0		0	0	0	275716	0	10	40213160		
212522	4660	40213160	1961-03-12	1961-03-12 00:00:00	1961-03-12	1961-03-12 00:00:00	1961-03-12	581452		0	0	0		0	0	0	310626	0	10	40213160		
27599	2286	1115171	1996-01-09	1996-01-09 00:00:00	1996-02-06	1996-02-06 00:00:00	1996-02-06	38000177		0	0	28		0	0	0	152092	0	849574	1115171		
27657	2289	19078461	1975-08-13	1975-08-13 00:00:00	1975-09-17	1975-09-17 00:00:00	1975-09-17	38000177		0	0	35		0	0	0	152252	0	310965	19078461		
138690	3047	40213160	1972-11-01	1972-11-01 00:00:00	1972-11-01	1972-11-01 00:00:00	1972-11-01	581452		0	0	0		0	0	0	202781	0	10	40213160		
150033	3300	40213251	1987-05-14	1987-05-14 00:00:00	1987-05-14	1987-05-14 00:00:00	1987-05-14	581452		0	0	0		0	0	0	219207	0	21	40213251		
2305	185	19006318	1950-11-06	1950-11-06 00:00:00	1950-11-20	1950-11-20 00:00:00	1950-11-20	38000177		0	0	14		0	0	0	12551	0	105078	19006318		
205291	4505	40213227	2018-05-22	2018-05-22 00:00:00	2018-05-22	2018-05-22 00:00:00	2018-05-22	581452		0	0	0		0	0	0	300059	0	113	40213227		
8653	186	40213227	1993-12-26	1993-12-26 00:00:00	1993-12-26	1993-12-26 00:00:00	1993-12-26	581452		0	0	0		0	0	0	12635	0	113	40213227		
49265	1079	40213227	2012-09-23	2012-09-23 00:00:00	2012-09-23	2012-09-23 00:00:00	2012-09-23	581452		0	0	0		0	0	0	70767	0	113	40213227		
22535	488	40213227	2006-04-28	2006-04-28 00:00:00	2006-04-28	2006-04-28 00:00:00	2006-04-28	581452		0	0	0		0	0	0	32683	0	113	40213227		
57759	4799	19006318	1958-04-15	1958-04-15 00:00:00	1958-04-29	1958-04-29 00:00:00	1958-04-29	38000177		0	0	14		0	0	0	319265	0	105078	19006318		
49693	1088	40213314	1977-02-27	1977-02-27 00:00:00	1977-02-27	1977-02-27 00:00:00	1977-02-27	581452		0	0	0		0	0	0	71439	0	49	40213314		
51225	4256	1713671	1980-04-27	1980-04-27 00:00:00	1980-05-04	1980-05-04 00:00:00	1980-05-04	38000177		0	0	7		0	0	0	282583	0	562251	1713671		
43725	3623	19078461	1990-07-31	1990-07-31 00:00:00	1990-08-28	1990-08-28 00:00:00	1990-08-28	38000177		0	0	28		0	0	0	240935	0	310965	19078461		
57287	4755	1118084	1963-09-19	1963-09-19 00:00:00	1963-09-19	1963-09-19 00:00:00	\N	38000177		0	0	0		0	0	0	316660	0	00025152531	44923712		
61830	5144	19059056	1938-04-19	1938-04-19 00:00:00	1938-05-03	1938-05-03 00:00:00	1938-05-03	38000177		0	0	14		0	0	0	341946	0	243670	19059056		
89555	1964	40213160	1961-05-10	1961-05-10 00:00:00	1961-05-10	1961-05-10 00:00:00	1961-05-10	581452		0	0	0		0	0	0	130576	0	10	40213160		
4436	368	19133905	1990-09-29	1990-09-29 00:00:00	1990-10-06	1990-10-06 00:00:00	1990-10-06	38000177		0	0	7		0	0	0	24515	0	834102	19133905		
43082	939	40213306	1986-09-16	1986-09-16 00:00:00	1986-09-16	1986-09-16 00:00:00	1986-09-16	581452		0	0	0		0	0	0	62458	0	43	40213306		
116227	2554	40213227	2004-12-30	2004-12-30 00:00:00	2004-12-30	2004-12-30 00:00:00	2004-12-30	581452		0	0	0		0	0	0	169148	0	113	40213227		
154790	3407	40213296	2004-03-05	2004-03-05 00:00:00	2004-03-05	2004-03-05 00:00:00	2004-03-05	581452		0	0	0		0	0	0	225966	0	52	40213296		
25646	2109	1713671	1975-07-15	1975-07-15 00:00:00	1975-08-05	1975-08-05 00:00:00	1975-08-05	38000177		0	0	21		0	0	0	140410	0	562251	1713671		
20480	1685	19073183	1985-05-14	1985-05-14 00:00:00	1985-05-28	1985-05-28 00:00:00	1985-05-28	38000177		0	0	14		0	0	0	112894	0	308182	19073183		
20511	1689	1127433	1982-03-23	1982-03-23 00:00:00	1982-03-30	1982-03-30 00:00:00	1982-03-30	38000177		0	0	7		0	0	0	113096	0	313782	1127433		
55935	4643	1127433	1956-02-06	1956-02-06 00:00:00	1956-02-13	1956-02-13 00:00:00	1956-02-13	38000177		0	0	7		0	0	0	309590	0	313782	1127433		
58863	4890	19059056	1942-05-13	1942-05-13 00:00:00	1942-06-03	1942-06-03 00:00:00	1942-06-03	38000177		0	0	21		0	0	0	325143	0	243670	19059056		
21480	1764	19059056	1959-11-02	1959-11-02 00:00:00	1959-11-16	1959-11-16 00:00:00	1959-11-16	38000177		0	0	14		0	0	0	117948	0	243670	19059056		
19926	1635	1127078	1976-07-29	1976-07-29 00:00:00	1976-08-19	1976-08-19 00:00:00	1976-08-19	38000177		0	0	21		0	0	0	109829	0	282464	1127078		
7817	653	19129655	1965-12-23	1965-12-23 00:00:00	1966-01-13	1966-01-13 00:00:00	1966-01-13	38000177		0	0	21		0	0	0	43261	0	789980	19129655		
20015	1642	1118084	1990-09-24	1990-09-24 00:00:00	1990-09-24	1990-09-24 00:00:00	\N	38000177		0	0	0		0	0	0	110268	0	00025152531	44923712		
46937	3887	1118084	1990-04-08	1990-04-08 00:00:00	1990-04-08	1990-04-08 00:00:00	\N	38000177		0	0	0		0	0	0	258391	0	00025152531	44923712		
56331	4675	1127433	2006-11-11	2006-11-11 00:00:00	2006-12-11	2006-12-11 00:00:00	2006-12-11	38000177		0	0	30		0	0	0	311448	0	313782	1127433		
3708	308	1127433	1964-11-09	1964-11-09 00:00:00	1964-11-16	1964-11-16 00:00:00	1964-11-16	38000177		0	0	7		0	0	0	20457	0	313782	1127433		
4757	398	40231925	1957-04-20	1957-04-20 00:00:00	1957-04-20	1957-04-20 00:00:00	\N	38000177		0	0	0		0	0	0	26069	0	1049221	40231925		
129500	2847	40213227	1996-01-07	1996-01-07 00:00:00	1996-01-07	1996-01-07 00:00:00	1996-01-07	581452		0	0	0		0	0	0	189076	0	113	40213227		
227356	4992	40213160	1990-04-26	1990-04-26 00:00:00	1990-04-26	1990-04-26 00:00:00	1990-04-26	581452		0	0	0		0	0	0	332094	0	10	40213160		
215867	4735	40213160	1973-04-12	1973-04-12 00:00:00	1973-04-12	1973-04-12 00:00:00	1973-04-12	581452		0	0	0		0	0	0	315448	0	10	40213160		
18169	1506	1115171	1998-03-22	1998-03-22 00:00:00	1998-04-05	1998-04-05 00:00:00	1998-04-05	38000177		0	0	14		0	0	0	100395	0	849574	1115171		
50283	4173	1127078	1964-11-06	1964-11-06 00:00:00	1964-11-20	1964-11-20 00:00:00	1964-11-20	38000177		0	0	14		0	0	0	277332	0	282464	1127078		
4847	404	1713671	1969-11-02	1969-11-02 00:00:00	1969-11-16	1969-11-16 00:00:00	1969-11-16	38000177		0	0	14		0	0	0	26664	0	562251	1713671		
146365	3219	40213160	1980-09-27	1980-09-27 00:00:00	1980-09-27	1980-09-27 00:00:00	1980-09-27	581452		0	0	0		0	0	0	213895	0	10	40213160		
62089	5166	1118084	1985-08-23	1985-08-23 00:00:00	1985-08-23	1985-08-23 00:00:00	\N	38000177		0	0	0		0	0	0	343483	0	00025152531	44923712		
59042	4907	40236824	1985-03-10	1985-03-10 00:00:00	1985-03-17	1985-03-17 00:00:00	1985-03-17	38000177		0	0	7		0	0	0	326173	0	1094107	40236824		
6675	563	1124300	2003-01-18	2003-01-18 00:00:00	2003-01-18	2003-01-18 00:00:00	\N	38000177		0	0	0		0	0	0	37253	0	00781178901	45011828		
64277	5334	1713671	2007-04-05	2007-04-05 00:00:00	2007-04-19	2007-04-19 00:00:00	2007-04-19	38000177		0	0	14		0	0	0	355178	0	562251	1713671		
64311	5337	19078461	2009-06-27	2009-06-27 00:00:00	2009-07-25	2009-07-25 00:00:00	2009-07-25	38000177		0	0	28		0	0	0	355389	0	310965	19078461		
5077	110	40213160	1976-05-23	1976-05-23 00:00:00	1976-05-23	1976-05-23 00:00:00	1976-05-23	581452		0	0	0		0	0	0	7340	0	10	40213160		
80127	1753	40213160	1969-02-13	1969-02-13 00:00:00	1969-02-13	1969-02-13 00:00:00	1969-02-13	581452		0	0	0		0	0	0	117224	0	10	40213160		
61028	5076	46233710	1975-11-15	1975-11-15 00:00:00	1975-12-13	1975-12-13 00:00:00	1975-12-13	38000177		0	0	28		0	0	0	337328	0	1650142	46233710		
34833	2876	19133873	1971-03-03	1971-03-03 00:00:00	1971-03-10	1971-03-10 00:00:00	1971-03-10	38000177		0	0	7		0	0	0	191340	0	834061	19133873		
39255	3242	40229134	1985-04-02	1985-04-02 00:00:00	1985-04-09	1985-04-09 00:00:00	1985-04-09	38000177		0	0	7		0	0	0	215617	0	1043400	40229134		
84442	1846	40213160	1955-12-08	1955-12-08 00:00:00	1955-12-08	1955-12-08 00:00:00	1955-12-08	581452		0	0	0		0	0	0	123450	0	10	40213160		
45422	3757	19059056	1947-02-11	1947-02-11 00:00:00	1947-02-25	1947-02-25 00:00:00	1947-02-25	38000177		0	0	14		0	0	0	249728	0	243670	19059056		
56441	4682	40229134	2008-05-24	2008-05-24 00:00:00	2008-06-07	2008-06-07 00:00:00	2008-06-07	38000177		0	0	14		0	0	0	312025	0	1043400	40229134		
232998	5119	40213296	2002-10-08	2002-10-08 00:00:00	2002-10-08	2002-10-08 00:00:00	2002-10-08	581452		0	0	0		0	0	0	340300	0	52	40213296		
15155	1266	1127433	1984-06-08	1984-06-08 00:00:00	1984-07-13	1984-07-13 00:00:00	1984-07-13	38000177		0	0	35		0	0	0	83455	0	313782	1127433		
177483	3900	40213227	1998-09-15	1998-09-15 00:00:00	1998-09-15	1998-09-15 00:00:00	1998-09-15	581452		0	0	0		0	0	0	259317	0	113	40213227		
10353	865	1127433	2000-01-01	2000-01-01 00:00:00	2000-01-08	2000-01-08 00:00:00	2000-01-08	38000177		0	0	7		0	0	0	57440	0	313782	1127433		
39478	862	40213227	2012-06-12	2012-06-12 00:00:00	2012-06-12	2012-06-12 00:00:00	2012-06-12	581452		0	0	0		0	0	0	57079	0	113	40213227		
40598	884	40213160	1981-10-27	1981-10-27 00:00:00	1981-10-27	1981-10-27 00:00:00	1981-10-27	581452		0	0	0		0	0	0	\N	0	10	40213160		
8775	730	40229134	2013-08-10	2013-08-10 00:00:00	2013-08-24	2013-08-24 00:00:00	2013-08-24	38000177		0	0	14		0	0	0	48494	0	1043400	40229134		
188976	4149	40213260	2016-07-15	2016-07-15 00:00:00	2016-07-15	2016-07-15 00:00:00	2016-07-15	581452		0	0	0		0	0	0	275773	0	121	40213260		
212531	4660	40213160	1965-11-14	1965-11-14 00:00:00	1965-11-14	1965-11-14 00:00:00	1965-11-14	581452		0	0	0		0	0	0	310622	0	10	40213160		
27600	2286	40229134	1969-12-29	1969-12-29 00:00:00	1970-01-05	1970-01-05 00:00:00	1970-01-05	38000177		0	0	7		0	0	0	152059	0	1043400	40229134		
27658	2289	1713671	1968-06-19	1968-06-19 00:00:00	1968-06-26	1968-06-26 00:00:00	1968-06-26	38000177		0	0	7		0	0	0	152261	0	562251	1713671		
138691	3047	40213227	2005-09-14	2005-09-14 00:00:00	2005-09-14	2005-09-14 00:00:00	2005-09-14	581452		0	0	0		0	0	0	202740	0	113	40213227		
150039	3300	40213160	1983-04-14	1983-04-14 00:00:00	1983-04-14	1983-04-14 00:00:00	1983-04-14	581452		0	0	0		0	0	0	219251	0	10	40213160		
2306	185	1127433	1982-05-03	1982-05-03 00:00:00	1982-05-17	1982-05-17 00:00:00	1982-05-17	38000177		0	0	14		0	0	0	12520	0	313782	1127433		
205304	4505	40213227	1998-01-27	1998-01-27 00:00:00	1998-01-27	1998-01-27 00:00:00	1998-01-27	581452		0	0	0		0	0	0	300056	0	113	40213227		
8660	186	40213160	1972-05-01	1972-05-01 00:00:00	1972-05-01	1972-05-01 00:00:00	1972-05-01	581452		0	0	0		0	0	0	12594	0	10	40213160		
49266	1079	40213260	2012-09-23	2012-09-23 00:00:00	2012-09-23	2012-09-23 00:00:00	2012-09-23	581452		0	0	0		0	0	0	70767	0	121	40213260		
39918	870	40213260	2009-12-08	2009-12-08 00:00:00	2009-12-08	2009-12-08 00:00:00	2009-12-08	581452		0	0	0		0	0	0	57827	0	121	40213260		
57760	4799	1127078	1958-04-15	1958-04-15 00:00:00	1958-04-29	1958-04-29 00:00:00	1958-04-29	38000177		0	0	14		0	0	0	319265	0	282464	1127078		
49696	1088	40213160	1977-02-27	1977-02-27 00:00:00	1977-02-27	1977-02-27 00:00:00	1977-02-27	581452		0	0	0		0	0	0	71439	0	10	40213160		
51226	4256	1127078	1954-10-25	1954-10-25 00:00:00	1954-11-08	1954-11-08 00:00:00	1954-11-08	38000177		0	0	14		0	0	0	282586	0	282464	1127078		
43726	3623	40229134	1951-01-12	1951-01-12 00:00:00	1951-01-19	1951-01-19 00:00:00	1951-01-19	38000177		0	0	7		0	0	0	240890	0	1043400	40229134		
57288	4755	1127433	1925-06-06	1925-06-06 00:00:00	1925-06-20	1925-06-20 00:00:00	1925-06-20	38000177		0	0	14		0	0	0	316679	0	313782	1127433		
61831	5144	1118084	1971-09-03	1971-09-03 00:00:00	1971-09-03	1971-09-03 00:00:00	\N	38000177		0	0	0		0	0	0	341919	0	00025152531	44923712		
89557	1964	40213160	1961-07-12	1961-07-12 00:00:00	1961-07-12	1961-07-12 00:00:00	1961-07-12	581452		0	0	0		0	0	0	130557	0	10	40213160		
4437	368	1118084	2004-11-16	2004-11-16 00:00:00	2004-11-16	2004-11-16 00:00:00	\N	38000177		0	0	0		0	0	0	24483	0	00025152531	44923712		
43086	939	40213160	1969-06-24	1969-06-24 00:00:00	1969-06-24	1969-06-24 00:00:00	1969-06-24	581452		0	0	0		0	0	0	62425	0	10	40213160		
116238	2554	40213227	2015-02-26	2015-02-26 00:00:00	2015-02-26	2015-02-26 00:00:00	2015-02-26	581452		0	0	0		0	0	0	169110	0	113	40213227		
154792	3407	40213160	1963-10-04	1963-10-04 00:00:00	1963-10-04	1963-10-04 00:00:00	1963-10-04	581452		0	0	0		0	0	0	225937	0	10	40213160		
25647	2109	19059056	1979-02-04	1979-02-04 00:00:00	1979-02-25	1979-02-25 00:00:00	1979-02-25	38000177		0	0	21		0	0	0	140424	0	243670	19059056		
20481	1685	1127433	1997-10-29	1997-10-29 00:00:00	1997-11-12	1997-11-12 00:00:00	1997-11-12	38000177		0	0	14		0	0	0	112912	0	313782	1127433		
20512	1689	1713671	1993-01-02	1993-01-02 00:00:00	1993-01-09	1993-01-09 00:00:00	1993-01-09	38000177		0	0	7		0	0	0	113122	0	562251	1713671		
55936	4643	1127433	1985-02-03	1985-02-03 00:00:00	1985-03-05	1985-03-05 00:00:00	1985-03-05	38000177		0	0	30		0	0	0	309627	0	313782	1127433		
58864	4890	19078461	2000-10-17	2000-10-17 00:00:00	2000-11-21	2000-11-21 00:00:00	2000-11-21	38000177		0	0	35		0	0	0	325140	0	310965	19078461		
21481	1764	19006318	1959-11-02	1959-11-02 00:00:00	1959-11-16	1959-11-16 00:00:00	1959-11-16	38000177		0	0	14		0	0	0	117948	0	105078	19006318		
19927	1635	1118084	2012-02-21	2012-02-21 00:00:00	2012-02-21	2012-02-21 00:00:00	\N	38000177		0	0	0		0	0	0	109803	0	00025152531	44923712		
7818	653	40162522	1965-12-23	1965-12-23 00:00:00	1965-12-23	1965-12-23 00:00:00	\N	38000177		0	0	0		0	0	0	43261	0	857005	40162522		
20017	1642	40229134	2018-07-05	2018-07-05 00:00:00	2018-07-12	2018-07-12 00:00:00	2018-07-12	38000177		0	0	7		0	0	0	110212	0	1043400	40229134		
46938	3887	19078461	1984-11-14	1984-11-14 00:00:00	1984-11-28	1984-11-28 00:00:00	1984-11-28	38000177		0	0	14		0	0	0	258404	0	310965	19078461		
56332	4675	1127433	1994-07-17	1994-07-17 00:00:00	1994-08-16	1994-08-16 00:00:00	1994-08-16	38000177		0	0	30		0	0	0	311446	0	313782	1127433		
3709	308	1127433	2016-11-25	2016-11-25 00:00:00	2016-12-09	2016-12-09 00:00:00	2016-12-09	38000177		0	0	14		0	0	0	20414	0	313782	1127433		
4758	398	19006318	1957-04-20	1957-04-20 00:00:00	1957-05-18	1957-05-18 00:00:00	1957-05-18	38000177		0	0	28		0	0	0	26069	0	105078	19006318		
129506	2847	40213227	2004-01-18	2004-01-18 00:00:00	2004-01-18	2004-01-18 00:00:00	2004-01-18	581452		0	0	0		0	0	0	189078	0	113	40213227		
227360	4992	40213160	1986-01-23	1986-01-23 00:00:00	1986-01-23	1986-01-23 00:00:00	1986-01-23	581452		0	0	0		0	0	0	332101	0	10	40213160		
215873	4735	40213296	2013-01-10	2013-01-10 00:00:00	2013-01-10	2013-01-10 00:00:00	2013-01-10	581452		0	0	0		0	0	0	315440	0	52	40213296		
18170	1506	40173590	2006-04-01	2006-04-01 00:00:00	2006-04-01	2006-04-01 00:00:00	\N	38000177		0	0	0		0	0	0	100480	0	904419	40173590		
50284	4173	19129655	1964-11-06	1964-11-06 00:00:00	1964-11-20	1964-11-20 00:00:00	1964-11-20	38000177		0	0	14		0	0	0	277332	0	789980	19129655		
4848	404	40229134	1988-02-10	1988-02-10 00:00:00	1988-02-17	1988-02-17 00:00:00	1988-02-17	38000177		0	0	7		0	0	0	26680	0	1043400	40229134		
146371	3219	40213314	1980-06-28	1980-06-28 00:00:00	1980-06-28	1980-06-28 00:00:00	1980-06-28	581452		0	0	0		0	0	0	213921	0	49	40213314		
62090	5166	40229134	2015-05-14	2015-05-14 00:00:00	2015-05-28	2015-05-28 00:00:00	2015-05-28	38000177		0	0	14		0	0	0	343443	0	1043400	40229134		
59043	4907	920300	1985-03-10	1985-03-10 00:00:00	1985-03-17	1985-03-17 00:00:00	1985-03-17	38000177		0	0	7		0	0	0	326173	0	311989	920300		
6676	563	1127078	1969-04-16	1969-04-16 00:00:00	1969-05-07	1969-05-07 00:00:00	1969-05-07	38000177		0	0	21		0	0	0	37269	0	282464	1127078		
64278	5334	40229134	1988-11-06	1988-11-06 00:00:00	1988-11-13	1988-11-13 00:00:00	1988-11-13	38000177		0	0	7		0	0	0	355193	0	1043400	40229134		
64312	5337	1127433	2014-08-31	2014-08-31 00:00:00	2014-09-07	2014-09-07 00:00:00	2014-09-07	38000177		0	0	7		0	0	0	355420	0	313782	1127433		
5079	110	40213306	1998-04-19	1998-04-19 00:00:00	1998-04-19	1998-04-19 00:00:00	1998-04-19	581452		0	0	0		0	0	0	7302	0	43	40213306		
80131	1753	40213260	2014-05-08	2014-05-08 00:00:00	2014-05-08	2014-05-08 00:00:00	2014-05-08	581452		0	0	0		0	0	0	117259	0	121	40213260		
61029	5076	40165015	1975-11-15	1975-11-15 00:00:00	1975-11-15	1975-11-15 00:00:00	\N	38000177		0	0	0		0	0	0	337328	0	861467	40165015		
34834	2876	1127078	1967-05-22	1967-05-22 00:00:00	1967-06-12	1967-06-12 00:00:00	1967-06-12	38000177		0	0	21		0	0	0	191392	0	282464	1127078		
39260	3244	1127433	2007-09-26	2007-09-26 00:00:00	2007-10-03	2007-10-03 00:00:00	2007-10-03	38000177		0	0	7		0	0	0	215719	0	313782	1127433		
209921	4603	40213227	2011-11-03	2011-11-03 00:00:00	2011-11-03	2011-11-03 00:00:00	2011-11-03	581452		0	0	0		0	0	0	306675	0	113	40213227		
45423	3757	19006318	1947-02-11	1947-02-11 00:00:00	1947-02-25	1947-02-25 00:00:00	1947-02-25	38000177		0	0	14		0	0	0	249728	0	105078	19006318		
34017	2813	19059056	1936-07-16	1936-07-16 00:00:00	1936-08-20	1936-08-20 00:00:00	1936-08-20	38000177		0	0	35		0	0	0	186415	0	243670	19059056		
121072	2661	40213160	1969-06-13	1969-06-13 00:00:00	1969-06-13	1969-06-13 00:00:00	1969-06-13	581452		0	0	0		0	0	0	176360	0	10	40213160		
15156	1266	19078461	1991-02-07	1991-02-07 00:00:00	1991-03-14	1991-03-14 00:00:00	1991-03-14	38000177		0	0	35		0	0	0	83456	0	310965	19078461		
177496	3901	40213227	2008-01-30	2008-01-30 00:00:00	2008-01-30	2008-01-30 00:00:00	2008-01-30	581452		0	0	0		0	0	0	259368	0	113	40213227		
10354	865	1713671	2017-07-08	2017-07-08 00:00:00	2017-07-22	2017-07-22 00:00:00	2017-07-22	38000177		0	0	14		0	0	0	57402	0	562251	1713671		
39479	862	40213160	1970-11-10	1970-11-10 00:00:00	1970-11-10	1970-11-10 00:00:00	1970-11-10	581452		0	0	0		0	0	0	57104	0	10	40213160		
40604	884	40213227	2008-10-21	2008-10-21 00:00:00	2008-10-21	2008-10-21 00:00:00	2008-10-21	581452		0	0	0		0	0	0	58966	0	113	40213227		
8781	732	1127433	2000-09-16	2000-09-16 00:00:00	2000-09-30	2000-09-30 00:00:00	2000-09-30	38000177		0	0	14		0	0	0	48575	0	313782	1127433		
188990	4149	40213160	1966-11-04	1966-11-04 00:00:00	1966-11-04	1966-11-04 00:00:00	1966-11-04	581452		0	0	0		0	0	0	275764	0	10	40213160		
212536	4660	40213160	1961-05-14	1961-05-14 00:00:00	1961-05-14	1961-05-14 00:00:00	1961-05-14	581452		0	0	0		0	0	0	310611	0	10	40213160		
27601	2286	1713671	1958-12-03	1958-12-03 00:00:00	1958-12-24	1958-12-24 00:00:00	1958-12-24	38000177		0	0	21		0	0	0	152075	0	562251	1713671		
27659	2289	1127433	2019-06-02	2019-06-02 00:00:00	2019-06-16	2019-06-16 00:00:00	2019-06-16	38000177		0	0	14		0	0	0	152286	0	313782	1127433		
138698	3047	40213227	2013-09-25	2013-09-25 00:00:00	2013-09-25	2013-09-25 00:00:00	2013-09-25	581452		0	0	0		0	0	0	202773	0	113	40213227		
150043	3300	40213314	1983-01-13	1983-01-13 00:00:00	1983-01-13	1983-01-13 00:00:00	1983-01-13	581452		0	0	0		0	0	0	219242	0	49	40213314		
2307	186	1551192	1991-07-18	1991-07-18 00:00:00	1991-07-18	1991-07-18 00:00:00	1991-07-18	38000177		0	0	0		0	0	0	12650	0	312617	1551192		
99347	2175	40213251	1984-01-26	1984-01-26 00:00:00	1984-01-26	1984-01-26 00:00:00	1984-01-26	581452		0	0	0		0	0	0	144992	0	21	40213251		
127471	2804	40213227	2002-10-16	2002-10-16 00:00:00	2002-10-16	2002-10-16 00:00:00	2002-10-16	581452		0	0	0		0	0	0	185892	0	113	40213227		
49275	1079	40213306	1983-05-22	1983-05-22 00:00:00	1983-05-22	1983-05-22 00:00:00	1983-05-22	581452		0	0	0		0	0	0	70779	0	43	40213306		
39921	870	40213160	1960-08-16	1960-08-16 00:00:00	1960-08-16	1960-08-16 00:00:00	1960-08-16	581452		0	0	0		0	0	0	57842	0	10	40213160		
57761	4799	19078461	1983-03-10	1983-03-10 00:00:00	1983-04-14	1983-04-14 00:00:00	1983-04-14	38000177		0	0	35		0	0	0	319246	0	310965	19078461		
49700	1088	40213160	1973-04-08	1973-04-08 00:00:00	1973-04-08	1973-04-08 00:00:00	1973-04-08	581452		0	0	0		0	0	0	71453	0	10	40213160		
51227	4256	19006318	1954-10-25	1954-10-25 00:00:00	1954-11-08	1954-11-08 00:00:00	1954-11-08	38000177		0	0	14		0	0	0	282586	0	105078	19006318		
43727	3623	19059056	1966-03-18	1966-03-18 00:00:00	1966-04-08	1966-04-08 00:00:00	1966-04-08	38000177		0	0	21		0	0	0	240934	0	243670	19059056		
57289	4755	19059056	1928-06-19	1928-06-19 00:00:00	1928-07-03	1928-07-03 00:00:00	1928-07-03	38000177		0	0	14		0	0	0	316744	0	243670	19059056		
61832	5144	1127433	1982-04-15	1982-04-15 00:00:00	1982-04-22	1982-04-22 00:00:00	1982-04-22	38000177		0	0	7		0	0	0	341898	0	313782	1127433		
189823	4168	40213306	1993-06-05	1993-06-05 00:00:00	1993-06-05	1993-06-05 00:00:00	1993-06-05	581452		0	0	0		0	0	0	277021	0	43	40213306		
4438	368	19133905	2008-04-30	2008-04-30 00:00:00	2008-05-07	2008-05-07 00:00:00	2008-05-07	38000177		0	0	7		0	0	0	24516	0	834102	19133905		
43088	939	40213296	2007-12-18	2007-12-18 00:00:00	2007-12-18	2007-12-18 00:00:00	2007-12-18	581452		0	0	0		0	0	0	62460	0	52	40213296		
53751	1176	40213306	1985-08-23	1985-08-23 00:00:00	1985-08-23	1985-08-23 00:00:00	1985-08-23	581452		0	0	0		0	0	0	77579	0	43	40213306		
154798	3407	40213160	1963-07-05	1963-07-05 00:00:00	1963-07-05	1963-07-05 00:00:00	1963-07-05	581452		0	0	0		0	0	0	225963	0	10	40213160		
25648	2109	1118084	2005-12-04	2005-12-04 00:00:00	2005-12-04	2005-12-04 00:00:00	\N	38000177		0	0	0		0	0	0	140421	0	00025152531	44923712		
20482	1685	1127078	1983-08-23	1983-08-23 00:00:00	1983-09-13	1983-09-13 00:00:00	1983-09-13	38000177		0	0	21		0	0	0	112868	0	282464	1127078		
20513	1689	19077572	2019-01-10	2019-01-10 00:00:00	2019-01-10	2019-01-10 00:00:00	\N	38000177		0	0	0		0	0	0	113098	0	310436	19077572		
55937	4643	40229134	1913-05-27	1913-05-27 00:00:00	1913-06-03	1913-06-03 00:00:00	1913-06-03	38000177		0	0	7		0	0	0	309606	0	1043400	40229134		
58865	4890	1115171	1998-09-28	1998-09-28 00:00:00	1998-10-28	1998-10-28 00:00:00	1998-10-28	38000177		0	0	30		0	0	0	325147	0	849574	1115171		
21494	1766	1118084	1996-08-27	1996-08-27 00:00:00	1996-08-27	1996-08-27 00:00:00	\N	38000177		0	0	0		0	0	0	118143	0	00025152531	44923712		
19928	1636	1127433	1983-02-04	1983-02-04 00:00:00	1983-02-18	1983-02-18 00:00:00	1983-02-18	38000177		0	0	14		0	0	0	109899	0	313782	1127433		
7819	654	1127433	2007-05-22	2007-05-22 00:00:00	2007-06-05	2007-06-05 00:00:00	2007-06-05	38000177		0	0	14		0	0	0	43311	0	313782	1127433		
20018	1642	1127433	1951-06-22	1951-06-22 00:00:00	1951-07-06	1951-07-06 00:00:00	1951-07-06	38000177		0	0	14		0	0	0	110247	0	313782	1127433		
46939	3887	19059056	1968-12-08	1968-12-08 00:00:00	1969-01-07	1969-01-07 00:00:00	1969-01-07	38000177		0	0	30		0	0	0	258364	0	243670	19059056		
56333	4675	1713671	1926-11-10	1926-11-10 00:00:00	1926-12-01	1926-12-01 00:00:00	1926-12-01	38000177		0	0	21		0	0	0	311544	0	562251	1713671		
3710	308	1127433	2006-04-07	2006-04-07 00:00:00	2006-04-21	2006-04-21 00:00:00	2006-04-21	38000177		0	0	14		0	0	0	20412	0	313782	1127433		
4759	398	19059056	1941-08-30	1941-08-30 00:00:00	1941-09-20	1941-09-20 00:00:00	1941-09-20	38000177		0	0	21		0	0	0	26105	0	243670	19059056		
129507	2847	40213296	2004-01-18	2004-01-18 00:00:00	2004-01-18	2004-01-18 00:00:00	2004-01-18	581452		0	0	0		0	0	0	189078	0	52	40213296		
227366	4992	40213314	1985-08-22	1985-08-22 00:00:00	1985-08-22	1985-08-22 00:00:00	1985-08-22	581452		0	0	0		0	0	0	332100	0	49	40213314		
227153	4988	40213227	2014-06-24	2014-06-24 00:00:00	2014-06-24	2014-06-24 00:00:00	2014-06-24	581452		0	0	0		0	0	0	331810	0	113	40213227		
18171	1506	19133873	1948-10-22	1948-10-22 00:00:00	1948-11-01	1948-11-01 00:00:00	1948-11-01	38000177		0	0	10		0	0	0	100445	0	834061	19133873		
50285	4173	1127078	1967-03-11	1967-03-11 00:00:00	1967-03-25	1967-03-25 00:00:00	1967-03-25	38000177		0	0	14		0	0	0	277333	0	282464	1127078		
4849	404	19059056	1962-06-04	1962-06-04 00:00:00	1962-07-09	1962-07-09 00:00:00	1962-07-09	38000177		0	0	35		0	0	0	26661	0	243670	19059056		
197653	4343	40213160	1959-09-28	1959-09-28 00:00:00	1959-09-28	1959-09-28 00:00:00	1959-09-28	581452		0	0	0		0	0	0	288022	0	10	40213160		
62091	5166	19133873	1953-04-06	1953-04-06 00:00:00	1953-04-15	1953-04-15 00:00:00	1953-04-15	38000177		0	0	9		0	0	0	343414	0	834061	19133873		
59045	4907	1118084	1984-09-10	1984-09-10 00:00:00	1984-09-10	1984-09-10 00:00:00	\N	38000177		0	0	0		0	0	0	326158	0	00025152531	44923712		
6677	563	40232448	1985-05-03	1985-05-03 00:00:00	1985-05-03	1985-05-03 00:00:00	\N	38000177		0	0	0		0	0	0	37276	0	1049630	40232448		
64279	5334	19133905	2008-11-25	2008-11-25 00:00:00	2008-12-07	2008-12-07 00:00:00	2008-12-07	38000177		0	0	12		0	0	0	355198	0	834102	19133905		
64313	5337	1127078	1981-07-24	1981-07-24 00:00:00	1981-08-23	1981-08-23 00:00:00	1981-08-23	38000177		0	0	30		0	0	0	355387	0	282464	1127078		
5081	110	40213227	1998-04-19	1998-04-19 00:00:00	1998-04-19	1998-04-19 00:00:00	1998-04-19	581452		0	0	0		0	0	0	7302	0	113	40213227		
80133	1753	40213160	1964-10-15	1964-10-15 00:00:00	1964-10-15	1964-10-15 00:00:00	1964-10-15	581452		0	0	0		0	0	0	117281	0	10	40213160		
61030	5076	19078461	2005-09-02	2005-09-02 00:00:00	2005-11-01	2005-11-01 00:00:00	2005-11-01	38000177		0	0	60		0	0	0	337331	0	310965	19078461		
34835	2876	40162522	2011-03-23	2011-03-23 00:00:00	2011-03-23	2011-03-23 00:00:00	\N	38000177		0	0	0		0	0	0	191393	0	857005	40162522		
39261	3244	920334	2013-05-20	2013-05-20 00:00:00	2013-05-27	2013-05-27 00:00:00	2013-05-27	38000177		0	0	7		0	0	0	215721	0	311995	920334		
209924	4603	40213227	1992-07-16	1992-07-16 00:00:00	1992-07-16	1992-07-16 00:00:00	1992-07-16	581452		0	0	0		0	0	0	306613	0	113	40213227		
45424	3757	1127078	1956-08-22	1956-08-22 00:00:00	1956-09-19	1956-09-19 00:00:00	1956-09-19	38000177		0	0	28		0	0	0	249761	0	282464	1127078		
34018	2813	1539411	2017-03-03	2017-03-03 00:00:00	2017-03-03	2017-03-03 00:00:00	\N	38000177		0	0	0		0	0	0	186469	0	312961	1539411		
121081	2661	40213306	1987-03-13	1987-03-13 00:00:00	1987-03-13	1987-03-13 00:00:00	1987-03-13	581452		0	0	0		0	0	0	176307	0	43	40213306		
15157	1266	1127433	2004-12-11	2004-12-11 00:00:00	2004-12-18	2004-12-18 00:00:00	2004-12-18	38000177		0	0	7		0	0	0	83503	0	313782	1127433		
10293	863	1713671	1963-04-07	1963-04-07 00:00:00	1963-04-21	1963-04-21 00:00:00	1963-04-21	38000177		0	0	14		0	0	0	57175	0	562251	1713671		
10355	865	1127433	1983-01-13	1983-01-13 00:00:00	1983-02-03	1983-02-03 00:00:00	1983-02-03	38000177		0	0	21		0	0	0	57367	0	313782	1127433		
213332	4677	40213296	1999-01-08	1999-01-08 00:00:00	1999-01-08	1999-01-08 00:00:00	1999-01-08	581452		0	0	0		0	0	0	311708	0	52	40213296		
40390	879	40213201	2018-05-14	2018-05-14 00:00:00	2018-05-14	2018-05-14 00:00:00	2018-05-14	581452		0	0	0		0	0	0	58577	0	33	40213201		
8782	732	19133905	2008-08-09	2008-08-09 00:00:00	2008-08-18	2008-08-18 00:00:00	2008-08-18	38000177		0	0	9		0	0	0	48572	0	834102	19133905		
188992	4149	40213227	2017-07-21	2017-07-21 00:00:00	2017-07-21	2017-07-21 00:00:00	2017-07-21	581452		0	0	0		0	0	0	275739	0	113	40213227		
212544	4660	40213296	2000-12-10	2000-12-10 00:00:00	2000-12-10	2000-12-10 00:00:00	2000-12-10	581452		0	0	0		0	0	0	310616	0	52	40213296		
27602	2286	1127078	1957-11-01	1957-11-01 00:00:00	1957-11-15	1957-11-15 00:00:00	1957-11-15	38000177		0	0	14		0	0	0	152061	0	282464	1127078		
27660	2290	1127433	1976-11-13	1976-11-13 00:00:00	1976-11-27	1976-11-27 00:00:00	1976-11-27	38000177		0	0	14		0	0	0	152336	0	313782	1127433		
138699	3047	40213296	2013-09-25	2013-09-25 00:00:00	2013-09-25	2013-09-25 00:00:00	2013-09-25	581452		0	0	0		0	0	0	202773	0	52	40213296		
91669	2012	40213160	1957-07-12	1957-07-12 00:00:00	1957-07-12	1957-07-12 00:00:00	1957-07-12	581452		0	0	0		0	0	0	133910	0	10	40213160		
2308	186	1127433	1995-06-21	1995-06-21 00:00:00	1995-06-28	1995-06-28 00:00:00	1995-06-28	38000177		0	0	7		0	0	0	12627	0	313782	1127433		
99349	2175	40213160	1976-05-06	1976-05-06 00:00:00	1976-05-06	1976-05-06 00:00:00	1976-05-06	581452		0	0	0		0	0	0	144987	0	10	40213160		
31899	695	40213306	1990-08-27	1990-08-27 00:00:00	1990-08-27	1990-08-27 00:00:00	1990-08-27	581452		0	0	0		0	0	0	46044	0	43	40213306		
49284	1079	40213160	1961-08-27	1961-08-27 00:00:00	1961-08-27	1961-08-27 00:00:00	1961-08-27	581452		0	0	0		0	0	0	70760	0	10	40213160		
39925	870	40213306	1982-11-09	1982-11-09 00:00:00	1982-11-09	1982-11-09 00:00:00	1982-11-09	581452		0	0	0		0	0	0	57836	0	43	40213306		
57762	4799	40236824	1986-12-14	1986-12-14 00:00:00	1986-12-21	1986-12-21 00:00:00	1986-12-21	38000177		0	0	7		0	0	0	319285	0	1094107	40236824		
49704	1088	40213160	1972-11-05	1972-11-05 00:00:00	1972-11-05	1972-11-05 00:00:00	1972-11-05	581452		0	0	0		0	0	0	71450	0	10	40213160		
51228	4256	35605482	1963-11-14	1963-11-14 00:00:00	1963-11-14	1963-11-14 00:00:00	1963-11-14	38000177		0	0	0		0	0	0	282589	0	1740467	35605482		
43728	3623	1118084	1988-07-24	1988-07-24 00:00:00	1988-07-24	1988-07-24 00:00:00	\N	38000177		0	0	0		0	0	0	240906	0	00025152531	44923712		
57290	4755	19059056	1945-03-13	1945-03-13 00:00:00	1945-03-27	1945-03-27 00:00:00	1945-03-27	38000177		0	0	14		0	0	0	316709	0	243670	19059056		
61833	5144	1127433	2013-05-08	2013-05-08 00:00:00	2013-05-15	2013-05-15 00:00:00	2013-05-15	38000177		0	0	7		0	0	0	341901	0	313782	1127433		
189825	4168	40213227	1993-06-05	1993-06-05 00:00:00	1993-06-05	1993-06-05 00:00:00	1993-06-05	581452		0	0	0		0	0	0	277021	0	113	40213227		
4439	369	42902245	2001-11-17	2001-11-17 00:00:00	2002-11-12	2002-11-12 00:00:00	2002-11-12	38000177		0	0	360		0	0	0	24536	0	1359133	42902245		
162713	3578	40213314	1977-07-13	1977-07-13 00:00:00	1977-07-13	1977-07-13 00:00:00	1977-07-13	581452		0	0	0		0	0	0	237879	0	49	40213314		
53755	1176	40213260	2012-10-19	2012-10-19 00:00:00	2012-10-19	2012-10-19 00:00:00	2012-10-19	581452		0	0	0		0	0	0	77586	0	121	40213260		
154800	3407	40213260	2013-03-29	2013-03-29 00:00:00	2013-03-29	2013-03-29 00:00:00	2013-03-29	581452		0	0	0		0	0	0	225974	0	121	40213260		
25649	2109	1713671	1996-09-12	1996-09-12 00:00:00	1996-10-03	1996-10-03 00:00:00	1996-10-03	38000177		0	0	21		0	0	0	140432	0	562251	1713671		
20483	1685	1713671	2001-01-24	2001-01-24 00:00:00	2001-02-14	2001-02-14 00:00:00	2001-02-14	38000177		0	0	21		0	0	0	112884	0	562251	1713671		
20514	1689	1127433	1992-02-04	1992-02-04 00:00:00	1992-02-18	1992-02-18 00:00:00	1992-02-18	38000177		0	0	14		0	0	0	113157	0	313782	1127433		
55938	4643	1127433	1916-04-19	1916-04-19 00:00:00	1916-04-26	1916-04-26 00:00:00	1916-04-26	38000177		0	0	7		0	0	0	309600	0	313782	1127433		
58866	4890	1127433	1976-04-09	1976-04-09 00:00:00	1976-04-16	1976-04-16 00:00:00	1976-04-16	38000177		0	0	7		0	0	0	325082	0	313782	1127433		
11147	929	1713671	2003-08-04	2003-08-04 00:00:00	2003-08-18	2003-08-18 00:00:00	2003-08-18	38000177		0	0	14		0	0	0	61841	0	562251	1713671		
19929	1636	1127433	1994-06-13	1994-06-13 00:00:00	1994-06-20	1994-06-20 00:00:00	1994-06-20	38000177		0	0	7		0	0	0	109862	0	313782	1127433		
7820	654	1127078	1964-02-06	1964-02-06 00:00:00	1964-02-20	1964-02-20 00:00:00	1964-02-20	38000177		0	0	14		0	0	0	43323	0	282464	1127078		
20019	1642	19128065	1974-04-01	1974-04-01 00:00:00	1975-03-27	1975-03-27 00:00:00	1975-03-27	38000177		0	0	360		0	0	0	110215	0	749882	19128065		
46940	3887	1127078	1960-05-03	1960-05-03 00:00:00	1960-05-24	1960-05-24 00:00:00	1960-05-24	38000177		0	0	21		0	0	0	258363	0	282464	1127078		
56334	4675	19059056	1916-05-01	1916-05-01 00:00:00	1916-05-15	1916-05-15 00:00:00	1916-05-15	38000177		0	0	14		0	0	0	311483	0	243670	19059056		
3711	308	19059056	1976-01-21	1976-01-21 00:00:00	1976-02-11	1976-02-11 00:00:00	1976-02-11	38000177		0	0	21		0	0	0	20400	0	243670	19059056		
4760	398	19059056	1966-08-29	1966-08-29 00:00:00	1966-09-26	1966-09-26 00:00:00	1966-09-26	38000177		0	0	28		0	0	0	26070	0	243670	19059056		
39619	865	40213227	2002-09-25	2002-09-25 00:00:00	2002-09-25	2002-09-25 00:00:00	2002-09-25	581452		0	0	0		0	0	0	57386	0	113	40213227		
227367	4992	40213160	1985-08-22	1985-08-22 00:00:00	1985-08-22	1985-08-22 00:00:00	1985-08-22	581452		0	0	0		0	0	0	332100	0	10	40213160		
227155	4988	40213160	1955-09-27	1955-09-27 00:00:00	1955-09-27	1955-09-27 00:00:00	1955-09-27	581452		0	0	0		0	0	0	331857	0	10	40213160		
18172	1506	1118084	1985-08-06	1985-08-06 00:00:00	1985-08-06	1985-08-06 00:00:00	\N	38000177		0	0	0		0	0	0	100478	0	00025152531	44923712		
50286	4173	19129655	1967-03-11	1967-03-11 00:00:00	1967-03-25	1967-03-25 00:00:00	1967-03-25	38000177		0	0	14		0	0	0	277333	0	789980	19129655		
4850	404	40236446	1970-06-12	1970-06-12 00:00:00	1971-11-05	1971-11-05 00:00:00	1971-11-05	38000177		0	0	511		0	0	0	26675	0	1091392	40236446		
197655	4343	40213260	2007-11-05	2007-11-05 00:00:00	2007-11-05	2007-11-05 00:00:00	2007-11-05	581452		0	0	0		0	0	0	288062	0	121	40213260		
62092	5166	1127433	1969-10-31	1969-10-31 00:00:00	1969-11-07	1969-11-07 00:00:00	1969-11-07	38000177		0	0	7		0	0	0	343438	0	313782	1127433		
59046	4907	19059056	1964-06-27	1964-06-27 00:00:00	1964-07-11	1964-07-11 00:00:00	1964-07-11	38000177		0	0	14		0	0	0	326202	0	243670	19059056		
6678	564	1713671	2015-01-25	2015-01-25 00:00:00	2015-02-01	2015-02-01 00:00:00	2015-02-01	38000177		0	0	7		0	0	0	37362	0	562251	1713671		
64280	5334	19129655	1966-10-19	1966-10-19 00:00:00	1966-11-02	1966-11-02 00:00:00	1966-11-02	38000177		0	0	14		0	0	0	355232	0	789980	19129655		
64314	5337	19019979	1974-12-15	1974-12-15 00:00:00	1974-12-29	1974-12-29 00:00:00	1974-12-29	38000177		0	0	14		0	0	0	355486	0	198405	19019979		
5082	110	40213314	1977-04-24	1977-04-24 00:00:00	1977-04-24	1977-04-24 00:00:00	1977-04-24	581452		0	0	0		0	0	0	7319	0	49	40213314		
80146	1753	40213227	2015-05-14	2015-05-14 00:00:00	2015-05-14	2015-05-14 00:00:00	2015-05-14	581452		0	0	0		0	0	0	117268	0	113	40213227		
61031	5076	1127433	1951-09-04	1951-09-04 00:00:00	1951-09-18	1951-09-18 00:00:00	1951-09-18	38000177		0	0	14		0	0	0	337409	0	313782	1127433		
34836	2876	1127433	2011-03-23	2011-03-23 00:00:00	2011-05-22	2011-05-22 00:00:00	2011-05-22	38000177		0	0	60		0	0	0	191393	0	313782	1127433		
39262	3244	1127078	1974-04-13	1974-04-13 00:00:00	1974-05-04	1974-05-04 00:00:00	1974-05-04	38000177		0	0	21		0	0	0	215744	0	282464	1127078		
209935	4603	40213201	1997-08-14	1997-08-14 00:00:00	1997-08-14	1997-08-14 00:00:00	1997-08-14	581452		0	0	0		0	0	0	306630	0	33	40213201		
45425	3757	1127433	2004-11-20	2004-11-20 00:00:00	2004-12-04	2004-12-04 00:00:00	2004-12-04	38000177		0	0	14		0	0	0	249780	0	313782	1127433		
34019	2813	19075601	2017-03-03	2017-03-03 00:00:00	2017-03-03	2017-03-03 00:00:00	\N	38000177		0	0	0		0	0	0	186469	0	309362	19075601		
121083	2661	40213160	1965-05-21	1965-05-21 00:00:00	1965-05-21	1965-05-21 00:00:00	1965-05-21	581452		0	0	0		0	0	0	176357	0	10	40213160		
15158	1266	40229134	1992-07-21	1992-07-21 00:00:00	1992-08-04	1992-08-04 00:00:00	1992-08-04	38000177		0	0	14		0	0	0	83487	0	1043400	40229134		
10294	863	19126352	1961-08-24	1961-08-24 00:00:00	1961-08-24	1961-08-24 00:00:00	\N	38000177		0	0	0		0	0	0	57211	0	705129	19126352		
10356	865	19078461	1998-12-25	1998-12-25 00:00:00	1999-01-15	1999-01-15 00:00:00	1999-01-15	38000177		0	0	21		0	0	0	57369	0	310965	19078461		
213333	4677	40213160	1958-05-23	1958-05-23 00:00:00	1958-05-23	1958-05-23 00:00:00	1958-05-23	581452		0	0	0		0	0	0	311673	0	10	40213160		
182296	4005	40213296	2010-06-05	2010-06-05 00:00:00	2010-06-05	2010-06-05 00:00:00	2010-06-05	581452		0	0	0		0	0	0	266068	0	52	40213296		
8783	732	1127078	1977-03-18	1977-03-18 00:00:00	1977-04-15	1977-04-15 00:00:00	1977-04-15	38000177		0	0	28		0	0	0	48595	0	282464	1127078		
188993	4149	40213260	2017-07-21	2017-07-21 00:00:00	2017-07-21	2017-07-21 00:00:00	2017-07-21	581452		0	0	0		0	0	0	275739	0	121	40213260		
212549	4660	40213260	2010-12-05	2010-12-05 00:00:00	2010-12-05	2010-12-05 00:00:00	2010-12-05	581452		0	0	0		0	0	0	310618	0	121	40213260		
27603	2286	19006318	1957-11-01	1957-11-01 00:00:00	1957-11-15	1957-11-15 00:00:00	1957-11-15	38000177		0	0	14		0	0	0	152061	0	105078	19006318		
27661	2290	1127433	1988-02-28	1988-02-28 00:00:00	1988-04-28	1988-04-28 00:00:00	1988-04-28	38000177		0	0	60		0	0	0	152337	0	313782	1127433		
138703	3047	40213160	1973-01-03	1973-01-03 00:00:00	1973-01-03	1973-01-03 00:00:00	1973-01-03	581452		0	0	0		0	0	0	202732	0	10	40213160		
91673	2012	40213160	1957-05-10	1957-05-10 00:00:00	1957-05-10	1957-05-10 00:00:00	1957-05-10	581452		0	0	0		0	0	0	133881	0	10	40213160		
2309	186	1551192	1972-11-16	1972-11-16 00:00:00	1972-11-16	1972-11-16 00:00:00	1972-11-16	38000177		0	0	0		0	0	0	12647	0	312617	1551192		
99354	2175	40213227	1999-09-30	1999-09-30 00:00:00	1999-09-30	1999-09-30 00:00:00	1999-09-30	581452		0	0	0		0	0	0	145030	0	113	40213227		
31901	695	40213227	2010-11-01	2010-11-01 00:00:00	2010-11-01	2010-11-01 00:00:00	2010-11-01	581452		0	0	0		0	0	0	46047	0	113	40213227		
4424	95	40213227	2009-04-30	2009-04-30 00:00:00	2009-04-30	2009-04-30 00:00:00	2009-04-30	581452		0	0	0		0	0	0	6446	0	113	40213227		
33308	727	40213227	1994-04-29	1994-04-29 00:00:00	1994-04-29	1994-04-29 00:00:00	1994-04-29	581452		0	0	0		0	0	0	48190	0	113	40213227		
57763	4799	920300	1986-12-14	1986-12-14 00:00:00	1986-12-21	1986-12-21 00:00:00	1986-12-21	38000177		0	0	7		0	0	0	319285	0	311989	920300		
49709	1088	40213160	1973-01-07	1973-01-07 00:00:00	1973-01-07	1973-01-07 00:00:00	1973-01-07	581452		0	0	0		0	0	0	71465	0	10	40213160		
51229	4256	35605482	1963-11-14	1963-11-14 00:00:00	1963-11-14	1963-11-14 00:00:00	1963-11-14	38000177		0	0	0		0	0	0	282589	0	1740467	35605482		
43729	3623	1713671	1989-07-20	1989-07-20 00:00:00	1989-07-27	1989-07-27 00:00:00	1989-07-27	38000177		0	0	7		0	0	0	240924	0	562251	1713671		
57291	4755	1713671	2013-11-04	2013-11-04 00:00:00	2013-11-25	2013-11-25 00:00:00	2013-11-25	38000177		0	0	21		0	0	0	316765	0	562251	1713671		
61834	5144	1127433	1962-06-21	1962-06-21 00:00:00	1962-06-28	1962-06-28 00:00:00	1962-06-28	38000177		0	0	7		0	0	0	341965	0	313782	1127433		
189827	4168	40213160	1971-07-10	1971-07-10 00:00:00	1971-07-10	1971-07-10 00:00:00	1971-07-10	581452		0	0	0		0	0	0	277027	0	10	40213160		
4440	369	19128065	1994-12-24	1994-12-24 00:00:00	1995-12-19	1995-12-19 00:00:00	1995-12-19	38000177		0	0	360		0	0	0	24544	0	749882	19128065		
162714	3578	40213160	1977-07-13	1977-07-13 00:00:00	1977-07-13	1977-07-13 00:00:00	1977-07-13	581452		0	0	0		0	0	0	237879	0	10	40213160		
53756	1176	40213260	2013-10-25	2013-10-25 00:00:00	2013-10-25	2013-10-25 00:00:00	2013-10-25	581452		0	0	0		0	0	0	77580	0	121	40213260		
154802	3407	40213306	1984-02-10	1984-02-10 00:00:00	1984-02-10	1984-02-10 00:00:00	1984-02-10	581452		0	0	0		0	0	0	225993	0	43	40213306		
25650	2109	1127078	1973-10-18	1973-10-18 00:00:00	1973-11-01	1973-11-01 00:00:00	1973-11-01	38000177		0	0	14		0	0	0	140433	0	282464	1127078		
20484	1685	1127433	1985-09-13	1985-09-13 00:00:00	1985-09-27	1985-09-27 00:00:00	1985-09-27	38000177		0	0	14		0	0	0	112870	0	313782	1127433		
20515	1689	19133873	1945-12-03	1945-12-03 00:00:00	1945-12-12	1945-12-12 00:00:00	1945-12-12	38000177		0	0	9		0	0	0	113137	0	834061	19133873		
55939	4643	19059056	1946-05-01	1946-05-01 00:00:00	1946-05-31	1946-05-31 00:00:00	1946-05-31	38000177		0	0	30		0	0	0	309571	0	243670	19059056		
58867	4890	920334	1976-12-13	1976-12-13 00:00:00	1976-12-20	1976-12-20 00:00:00	1976-12-20	38000177		0	0	7		0	0	0	325200	0	311995	920334		
11148	929	1713671	1930-12-27	1930-12-27 00:00:00	1931-01-03	1931-01-03 00:00:00	1931-01-03	38000177		0	0	7		0	0	0	61803	0	562251	1713671		
19930	1636	1127433	2016-04-23	2016-04-23 00:00:00	2016-06-22	2016-06-22 00:00:00	2016-06-22	38000177		0	0	60		0	0	0	109885	0	313782	1127433		
7821	654	19006318	1964-02-06	1964-02-06 00:00:00	1964-02-20	1964-02-20 00:00:00	1964-02-20	38000177		0	0	14		0	0	0	43323	0	105078	19006318		
20020	1642	1713671	1977-08-09	1977-08-09 00:00:00	1977-08-16	1977-08-16 00:00:00	1977-08-16	38000177		0	0	7		0	0	0	110249	0	562251	1713671		
46941	3887	920300	1977-07-16	1977-07-16 00:00:00	1977-07-23	1977-07-23 00:00:00	1977-07-23	38000177		0	0	7		0	0	0	258341	0	311989	920300		
56335	4675	19059056	1941-01-09	1941-01-09 00:00:00	1941-02-06	1941-02-06 00:00:00	1941-02-06	38000177		0	0	28		0	0	0	311503	0	243670	19059056		
3712	308	19133873	1963-12-30	1963-12-30 00:00:00	1964-01-08	1964-01-08 00:00:00	1964-01-08	38000177		0	0	9		0	0	0	20456	0	834061	19133873		
4761	398	19126352	1947-12-06	1947-12-06 00:00:00	1967-02-11	1967-02-11 00:00:00	1967-02-11	38000177		0	0	7007		0	0	0	26073	0	705129	19126352		
39623	865	40213201	2007-10-24	2007-10-24 00:00:00	2007-10-24	2007-10-24 00:00:00	2007-10-24	581452		0	0	0		0	0	0	57424	0	33	40213201		
200560	4405	40213260	2014-02-17	2014-02-17 00:00:00	2014-02-17	2014-02-17 00:00:00	2014-02-17	581452		0	0	0		0	0	0	292818	0	121	40213260		
227164	4988	40213260	2006-05-09	2006-05-09 00:00:00	2006-05-09	2006-05-09 00:00:00	2006-05-09	581452		0	0	0		0	0	0	331836	0	121	40213260		
18173	1506	40171902	2011-04-30	2011-04-30 00:00:00	2011-04-30	2011-04-30 00:00:00	\N	38000177		0	0	0		0	0	0	100439	0	897718	40171902		
50287	4173	19078461	2008-08-17	2008-08-17 00:00:00	2008-09-07	2008-09-07 00:00:00	2008-09-07	38000177		0	0	21		0	0	0	277375	0	310965	19078461		
4851	404	19128065	1975-06-06	1975-06-06 00:00:00	1976-05-31	1976-05-31 00:00:00	1976-05-31	38000177		0	0	360		0	0	0	26612	0	749882	19128065		
197658	4343	40213227	2005-10-24	2005-10-24 00:00:00	2005-10-24	2005-10-24 00:00:00	2005-10-24	581452		0	0	0		0	0	0	288016	0	113	40213227		
62093	5166	19059056	1966-05-25	1966-05-25 00:00:00	1966-08-23	1966-08-23 00:00:00	1966-08-23	38000177		0	0	90		0	0	0	343400	0	243670	19059056		
59047	4907	40173590	2016-05-14	2016-05-14 00:00:00	2016-05-14	2016-05-14 00:00:00	\N	38000177		0	0	0		0	0	0	326156	0	904419	40173590		
6679	564	19078461	2006-08-19	2006-08-19 00:00:00	2006-09-09	2006-09-09 00:00:00	2006-09-09	38000177		0	0	21		0	0	0	37342	0	310965	19078461		
64281	5334	19059056	1966-10-19	1966-10-19 00:00:00	1966-11-02	1966-11-02 00:00:00	1966-11-02	38000177		0	0	14		0	0	0	355232	0	243670	19059056		
64315	5337	46233988	1974-12-15	1974-12-15 00:00:00	1974-12-29	1974-12-29 00:00:00	1974-12-29	38000177		0	0	14		0	0	0	355486	0	1652673	46233988		
5091	110	40213296	2019-02-24	2019-02-24 00:00:00	2019-02-24	2019-02-24 00:00:00	2019-02-24	581452		0	0	0		0	0	0	7332	0	52	40213296		
80147	1753	40213260	2015-05-14	2015-05-14 00:00:00	2015-05-14	2015-05-14 00:00:00	2015-05-14	581452		0	0	0		0	0	0	117268	0	121	40213260		
61032	5076	40229134	2003-01-09	2003-01-09 00:00:00	2003-01-23	2003-01-23 00:00:00	2003-01-23	38000177		0	0	14		0	0	0	337399	0	1043400	40229134		
34837	2876	1713671	1977-09-01	1977-09-01 00:00:00	1977-09-15	1977-09-15 00:00:00	1977-09-15	38000177		0	0	14		0	0	0	191341	0	562251	1713671		
39263	3244	19128022	1994-03-09	1994-03-09 00:00:00	1995-03-04	1995-03-04 00:00:00	1995-03-04	38000177		0	0	360		0	0	0	215724	0	749785	19128022		
209948	4604	40213160	1969-02-09	1969-02-09 00:00:00	1969-02-09	1969-02-09 00:00:00	1969-02-09	581452		0	0	0		0	0	0	306739	0	10	40213160		
45426	3757	40229134	1973-01-12	1973-01-12 00:00:00	1973-01-19	1973-01-19 00:00:00	1973-01-19	38000177		0	0	7		0	0	0	249726	0	1043400	40229134		
34020	2813	1332419	2017-03-03	2017-03-03 00:00:00	2017-03-03	2017-03-03 00:00:00	\N	38000177		0	0	0		0	0	0	186469	0	197361	1332419		
121094	2661	40213227	2006-09-22	2006-09-22 00:00:00	2006-09-22	2006-09-22 00:00:00	2006-09-22	581452		0	0	0		0	0	0	176344	0	113	40213227		
15159	1267	1127433	1955-10-21	1955-10-21 00:00:00	1955-10-28	1955-10-28 00:00:00	1955-10-28	38000177		0	0	7		0	0	0	83517	0	313782	1127433		
10295	863	19059056	1944-12-20	1944-12-20 00:00:00	1945-01-10	1945-01-10 00:00:00	1945-01-10	38000177		0	0	21		0	0	0	57176	0	243670	19059056		
10357	865	1127433	1972-07-28	1972-07-28 00:00:00	1972-08-04	1972-08-04 00:00:00	1972-08-04	38000177		0	0	7		0	0	0	57400	0	313782	1127433		
213342	4677	40213160	1958-08-22	1958-08-22 00:00:00	1958-08-22	1958-08-22 00:00:00	1958-08-22	581452		0	0	0		0	0	0	311659	0	10	40213160		
182304	4005	40213306	1990-05-12	1990-05-12 00:00:00	1990-05-12	1990-05-12 00:00:00	1990-05-12	581452		0	0	0		0	0	0	266075	0	43	40213306		
8784	732	40229134	1984-05-11	1984-05-11 00:00:00	1984-05-25	1984-05-25 00:00:00	1984-05-25	38000177		0	0	14		0	0	0	48582	0	1043400	40229134		
188997	4149	40213296	2009-06-26	2009-06-26 00:00:00	2009-06-26	2009-06-26 00:00:00	2009-06-26	581452		0	0	0		0	0	0	275738	0	52	40213296		
182904	4019	40213160	1967-11-07	1967-11-07 00:00:00	1967-11-07	1967-11-07 00:00:00	1967-11-07	581452		0	0	0		0	0	0	267134	0	10	40213160		
27604	2286	46233710	1973-08-26	1973-08-26 00:00:00	1973-09-09	1973-09-09 00:00:00	1973-09-09	38000177		0	0	14		0	0	0	152071	0	1650142	46233710		
27662	2290	40165015	1988-02-28	1988-02-28 00:00:00	1988-02-28	1988-02-28 00:00:00	\N	38000177		0	0	0		0	0	0	152337	0	861467	40165015		
138705	3047	40213160	1973-04-04	1973-04-04 00:00:00	1973-04-04	1973-04-04 00:00:00	1973-04-04	581452		0	0	0		0	0	0	202782	0	10	40213160		
91684	2012	40213227	2019-01-25	2019-01-25 00:00:00	2019-01-25	2019-01-25 00:00:00	2019-01-25	581452		0	0	0		0	0	0	133924	0	113	40213227		
2310	186	19008572	1977-12-01	1977-12-01 00:00:00	1977-12-22	1977-12-22 00:00:00	1977-12-22	38000177		0	0	21		0	0	0	12624	0	106258	19008572		
99355	2175	40213306	1999-09-30	1999-09-30 00:00:00	1999-09-30	1999-09-30 00:00:00	1999-09-30	581452		0	0	0		0	0	0	145030	0	43	40213306		
31902	695	40213296	2010-11-01	2010-11-01 00:00:00	2010-11-01	2010-11-01 00:00:00	2010-11-01	581452		0	0	0		0	0	0	46047	0	52	40213296		
4425	95	40213260	2009-04-30	2009-04-30 00:00:00	2009-04-30	2009-04-30 00:00:00	2009-04-30	581452		0	0	0		0	0	0	6446	0	121	40213260		
33338	728	40213160	1955-04-30	1955-04-30 00:00:00	1955-04-30	1955-04-30 00:00:00	1955-04-30	581452		0	0	0		0	0	0	48360	0	10	40213160		
57764	4799	19078461	1977-01-10	1977-01-10 00:00:00	1977-03-11	1977-03-11 00:00:00	1977-03-11	38000177		0	0	60		0	0	0	319245	0	310965	19078461		
49713	1088	40213227	2004-02-01	2004-02-01 00:00:00	2004-02-01	2004-02-01 00:00:00	2004-02-01	581452		0	0	0		0	0	0	71432	0	113	40213227		
51230	4256	19079524	1963-11-14	1963-11-14 00:00:00	1963-11-15	1963-11-15 00:00:00	1963-11-15	38000177		0	0	1		0	0	0	282589	0	313002	19079524		
43730	3623	1127433	2011-04-15	2011-04-15 00:00:00	2011-05-06	2011-05-06 00:00:00	2011-05-06	38000177		0	0	21		0	0	0	240938	0	313782	1127433		
214872	4712	40213260	2018-03-23	2018-03-23 00:00:00	2018-03-23	2018-03-23 00:00:00	2018-03-23	581452		0	0	0		0	0	0	313779	0	121	40213260		
61835	5144	1127433	1961-06-17	1961-06-17 00:00:00	1961-06-24	1961-06-24 00:00:00	1961-06-24	38000177		0	0	7		0	0	0	341944	0	313782	1127433		
189829	4168	40213227	2002-06-15	2002-06-15 00:00:00	2002-06-15	2002-06-15 00:00:00	2002-06-15	581452		0	0	0		0	0	0	277033	0	113	40213227		
4441	369	1127433	1993-11-19	1993-11-19 00:00:00	1993-12-03	1993-12-03 00:00:00	1993-12-03	38000177		0	0	14		0	0	0	24578	0	313782	1127433		
162719	3578	40213160	1972-11-08	1972-11-08 00:00:00	1972-11-08	1972-11-08 00:00:00	1972-11-08	581452		0	0	0		0	0	0	237897	0	10	40213160		
53761	1176	40213227	1996-05-24	1996-05-24 00:00:00	1996-05-24	1996-05-24 00:00:00	1996-05-24	581452		0	0	0		0	0	0	77662	0	113	40213227		
154805	3407	40213227	2014-04-04	2014-04-04 00:00:00	2014-04-04	2014-04-04 00:00:00	2014-04-04	581452		0	0	0		0	0	0	225945	0	113	40213227		
25651	2109	19006318	1973-10-18	1973-10-18 00:00:00	1973-11-01	1973-11-01 00:00:00	1973-11-01	38000177		0	0	14		0	0	0	140433	0	105078	19006318		
20485	1685	1127433	2014-12-13	2014-12-13 00:00:00	2015-01-10	2015-01-10 00:00:00	2015-01-10	38000177		0	0	28		0	0	0	112882	0	313782	1127433		
20516	1689	1713671	2008-02-12	2008-02-12 00:00:00	2008-02-26	2008-02-26 00:00:00	2008-02-26	38000177		0	0	14		0	0	0	113071	0	562251	1713671		
55940	4643	1127433	1937-10-04	1937-10-04 00:00:00	1937-10-11	1937-10-11 00:00:00	1937-10-11	38000177		0	0	7		0	0	0	309536	0	313782	1127433		
58868	4890	1713671	1926-11-09	1926-11-09 00:00:00	1926-11-30	1926-11-30 00:00:00	1926-11-30	38000177		0	0	21		0	0	0	325079	0	562251	1713671		
11149	929	40229134	1934-08-16	1934-08-16 00:00:00	1934-08-23	1934-08-23 00:00:00	1934-08-23	38000177		0	0	7		0	0	0	61820	0	1043400	40229134		
19931	1636	19133873	1966-12-07	1966-12-07 00:00:00	1966-12-20	1966-12-20 00:00:00	1966-12-20	38000177		0	0	13		0	0	0	109897	0	834061	19133873		
7822	654	1713671	1981-03-16	1981-03-16 00:00:00	1981-03-23	1981-03-23 00:00:00	1981-03-23	38000177		0	0	7		0	0	0	43294	0	562251	1713671		
20022	1642	19075601	2008-06-17	2008-06-17 00:00:00	2008-06-17	2008-06-17 00:00:00	2008-06-17	38000177		0	0	0		0	0	0	110265	0	309362	19075601		
46942	3887	40236824	1977-07-16	1977-07-16 00:00:00	1977-07-23	1977-07-23 00:00:00	1977-07-23	38000177		0	0	7		0	0	0	258341	0	1094107	40236824		
56336	4675	19059056	1949-04-16	1949-04-16 00:00:00	1949-05-16	1949-05-16 00:00:00	1949-05-16	38000177		0	0	30		0	0	0	311505	0	243670	19059056		
3713	308	19059056	1964-11-21	1964-11-21 00:00:00	1964-12-05	1964-12-05 00:00:00	1964-12-05	38000177		0	0	14		0	0	0	20427	0	243670	19059056		
4762	398	19133873	1940-04-08	1940-04-08 00:00:00	1940-04-18	1940-04-18 00:00:00	1940-04-18	38000177		0	0	10		0	0	0	26068	0	834061	19133873		
39631	865	40213227	1992-04-29	1992-04-29 00:00:00	1992-04-29	1992-04-29 00:00:00	1992-04-29	581452		0	0	0		0	0	0	57383	0	113	40213227		
200573	4405	40213227	2015-02-23	2015-02-23 00:00:00	2015-02-23	2015-02-23 00:00:00	2015-02-23	581452		0	0	0		0	0	0	292846	0	113	40213227		
227167	4988	40213296	1997-05-06	1997-05-06 00:00:00	1997-05-06	1997-05-06 00:00:00	1997-05-06	581452		0	0	0		0	0	0	331842	0	52	40213296		
18174	1506	19018935	2011-04-30	2011-04-30 00:00:00	2011-04-30	2011-04-30 00:00:00	\N	38000177		0	0	0		0	0	0	100439	0	197604	19018935		
50288	4173	19059056	1973-03-24	1973-03-24 00:00:00	1973-04-23	1973-04-23 00:00:00	1973-04-23	38000177		0	0	30		0	0	0	277373	0	243670	19059056		
4853	404	40229134	2011-11-10	2011-11-10 00:00:00	2011-11-17	2011-11-17 00:00:00	2011-11-17	38000177		0	0	7		0	0	0	26594	0	1043400	40229134		
197661	4343	40213296	1997-01-20	1997-01-20 00:00:00	1997-01-20	1997-01-20 00:00:00	1997-01-20	581452		0	0	0		0	0	0	288069	0	52	40213296		
62094	5166	40165015	1966-05-25	1966-05-25 00:00:00	1966-05-25	1966-05-25 00:00:00	\N	38000177		0	0	0		0	0	0	343400	0	861467	40165015		
59048	4907	40229134	1982-04-28	1982-04-28 00:00:00	1982-05-05	1982-05-05 00:00:00	1982-05-05	38000177		0	0	7		0	0	0	326135	0	1043400	40229134		
6680	564	1118084	1995-10-30	1995-10-30 00:00:00	1995-10-30	1995-10-30 00:00:00	\N	38000177		0	0	0		0	0	0	37325	0	00025152531	44923712		
64282	5334	19073188	1983-09-21	1983-09-21 00:00:00	1983-10-05	1983-10-05 00:00:00	1983-10-05	38000177		0	0	14		0	0	0	355202	0	308192	19073188		
59587	1305	40213260	2014-07-10	2014-07-10 00:00:00	2014-07-10	2014-07-10 00:00:00	2014-07-10	581452		0	0	0		0	0	0	86156	0	121	40213260		
5094	110	40213314	1977-01-23	1977-01-23 00:00:00	1977-01-23	1977-01-23 00:00:00	1977-01-23	581452		0	0	0		0	0	0	7297	0	49	40213314		
80148	1753	40213306	1986-05-29	1986-05-29 00:00:00	1986-05-29	1986-05-29 00:00:00	1986-05-29	581452		0	0	0		0	0	0	117231	0	43	40213306		
61033	5076	1127433	2009-04-02	2009-04-02 00:00:00	2009-04-09	2009-04-09 00:00:00	2009-04-09	38000177		0	0	7		0	0	0	337401	0	313782	1127433		
34839	2876	19129655	1966-09-07	1966-09-07 00:00:00	1966-09-21	1966-09-21 00:00:00	1966-09-21	38000177		0	0	14		0	0	0	191331	0	789980	19129655		
39264	3244	19059056	1980-04-02	1980-04-02 00:00:00	1980-04-23	1980-04-23 00:00:00	1980-04-23	38000177		0	0	21		0	0	0	215745	0	243670	19059056		
209952	4604	40213296	2007-05-27	2007-05-27 00:00:00	2007-05-27	2007-05-27 00:00:00	2007-05-27	581452		0	0	0		0	0	0	306725	0	52	40213296		
45427	3757	19059056	1957-09-14	1957-09-14 00:00:00	1957-12-13	1957-12-13 00:00:00	1957-12-13	38000177		0	0	90		0	0	0	249762	0	243670	19059056		
34021	2813	19126352	2017-03-03	2017-03-03 00:00:00	2017-03-03	2017-03-03 00:00:00	\N	38000177		0	0	0		0	0	0	186469	0	705129	19126352		
211357	4634	40213260	2012-11-08	2012-11-08 00:00:00	2012-11-08	2012-11-08 00:00:00	2012-11-08	581452		0	0	0		0	0	0	308869	0	121	40213260		
15161	1267	1127433	1969-10-18	1969-10-18 00:00:00	1969-11-01	1969-11-01 00:00:00	1969-11-01	38000177		0	0	14		0	0	0	83515	0	313782	1127433		
10296	863	1127433	1953-12-24	1953-12-24 00:00:00	1954-01-21	1954-01-21 00:00:00	1954-01-21	38000177		0	0	28		0	0	0	57177	0	313782	1127433		
10358	865	1127433	1945-09-01	1945-09-01 00:00:00	1945-09-08	1945-09-08 00:00:00	1945-09-08	38000177		0	0	7		0	0	0	57392	0	313782	1127433		
213352	4678	40213160	1955-09-06	1955-09-06 00:00:00	1955-09-06	1955-09-06 00:00:00	1955-09-06	581452		0	0	0		0	0	0	311766	0	10	40213160		
182309	4005	40213160	1974-02-23	1974-02-23 00:00:00	1974-02-23	1974-02-23 00:00:00	1974-02-23	581452		0	0	0		0	0	0	266093	0	10	40213160		
8785	732	40229134	2009-06-04	2009-06-04 00:00:00	2009-06-18	2009-06-18 00:00:00	2009-06-18	38000177		0	0	14		0	0	0	48543	0	1043400	40229134		
189002	4149	40213160	1966-06-03	1966-06-03 00:00:00	1966-06-03	1966-06-03 00:00:00	1966-06-03	581452		0	0	0		0	0	0	275748	0	10	40213160		
182916	4019	40213296	2005-03-22	2005-03-22 00:00:00	2005-03-22	2005-03-22 00:00:00	2005-03-22	581452		0	0	0		0	0	0	267186	0	52	40213296		
27605	2286	19059056	1973-08-26	1973-08-26 00:00:00	1973-09-09	1973-09-09 00:00:00	1973-09-09	38000177		0	0	14		0	0	0	152071	0	243670	19059056		
87892	1928	40213160	1971-11-10	1971-11-10 00:00:00	1971-11-10	1971-11-10 00:00:00	1971-11-10	581452		0	0	0		0	0	0	128374	0	10	40213160		
138713	3047	40213227	1995-04-19	1995-04-19 00:00:00	1995-04-19	1995-04-19 00:00:00	1995-04-19	581452		0	0	0		0	0	0	202769	0	113	40213227		
91692	2012	40213260	2007-02-02	2007-02-02 00:00:00	2007-02-02	2007-02-02 00:00:00	2007-02-02	581452		0	0	0		0	0	0	133892	0	121	40213260		
2311	186	40232448	1973-12-11	1973-12-11 00:00:00	1973-12-11	1973-12-11 00:00:00	\N	38000177		0	0	0		0	0	0	12613	0	1049630	40232448		
99358	2176	40213160	1957-01-28	1957-01-28 00:00:00	1957-01-28	1957-01-28 00:00:00	1957-01-28	581452		0	0	0		0	0	0	145087	0	10	40213160		
31908	695	40213227	1999-11-01	1999-11-01 00:00:00	1999-11-01	1999-11-01 00:00:00	1999-11-01	581452		0	0	0		0	0	0	46027	0	113	40213227		
4430	95	40213227	2019-06-27	2019-06-27 00:00:00	2019-06-27	2019-06-27 00:00:00	2019-06-27	581452		0	0	0		0	0	0	6398	0	113	40213227		
49360	4094	19133905	2004-09-16	2004-09-16 00:00:00	2004-09-23	2004-09-23 00:00:00	2004-09-23	38000177		0	0	7		0	0	0	272116	0	834102	19133905		
57765	4799	1127078	1969-04-17	1969-04-17 00:00:00	1969-05-01	1969-05-01 00:00:00	1969-05-01	38000177		0	0	14		0	0	0	319242	0	282464	1127078		
175826	3865	40213160	1961-06-08	1961-06-08 00:00:00	1961-06-08	1961-06-08 00:00:00	1961-06-08	581452		0	0	0		0	0	0	256601	0	10	40213160		
51231	4256	1367571	1963-11-14	1963-11-14 00:00:00	1963-11-14	1963-11-14 00:00:00	1963-11-14	38000177		0	0	0		0	0	0	282589	0	314659	19080464		
43731	3623	19059056	1954-06-10	1954-06-10 00:00:00	1954-06-24	1954-06-24 00:00:00	1954-06-24	38000177		0	0	14		0	0	0	240872	0	243670	19059056		
214876	4712	40213306	1990-09-21	1990-09-21 00:00:00	1990-09-21	1990-09-21 00:00:00	1990-09-21	581452		0	0	0		0	0	0	313803	0	43	40213306		
61836	5144	19059056	1968-07-01	1968-07-01 00:00:00	1968-07-22	1968-07-22 00:00:00	1968-07-22	38000177		0	0	21		0	0	0	341888	0	243670	19059056		
189834	4168	40213160	1971-09-11	1971-09-11 00:00:00	1971-09-11	1971-09-11 00:00:00	1971-09-11	581452		0	0	0		0	0	0	277013	0	10	40213160		
4442	369	19073183	1982-03-22	1982-03-22 00:00:00	1982-04-05	1982-04-05 00:00:00	1982-04-05	38000177		0	0	14		0	0	0	24534	0	308182	19073183		
162722	3578	40213227	1994-10-05	1994-10-05 00:00:00	1994-10-05	1994-10-05 00:00:00	1994-10-05	581452		0	0	0		0	0	0	237884	0	113	40213227		
53766	1176	40213160	1967-09-29	1967-09-29 00:00:00	1967-09-29	1967-09-29 00:00:00	1967-09-29	581452		0	0	0		0	0	0	77719	0	10	40213160		
154806	3407	40213260	2014-04-04	2014-04-04 00:00:00	2014-04-04	2014-04-04 00:00:00	2014-04-04	581452		0	0	0		0	0	0	225945	0	121	40213260		
25652	2109	1127433	1994-05-21	1994-05-21 00:00:00	1994-06-04	1994-06-04 00:00:00	1994-06-04	38000177		0	0	14		0	0	0	140426	0	313782	1127433		
20486	1685	1118084	2015-10-19	2015-10-19 00:00:00	2015-10-19	2015-10-19 00:00:00	\N	38000177		0	0	0		0	0	0	112882	0	00025152531	44923712		
20517	1689	19078461	1986-02-14	1986-02-14 00:00:00	1986-03-07	1986-03-07 00:00:00	1986-03-07	38000177		0	0	21		0	0	0	113090	0	310965	19078461		
55941	4643	1127433	1958-02-27	1958-02-27 00:00:00	1958-03-27	1958-03-27 00:00:00	1958-03-27	38000177		0	0	28		0	0	0	309624	0	313782	1127433		
58869	4890	19059056	1925-07-26	1925-07-26 00:00:00	1925-08-09	1925-08-09 00:00:00	1925-08-09	38000177		0	0	14		0	0	0	325216	0	243670	19059056		
11150	929	19073188	1997-07-09	1997-07-09 00:00:00	1997-07-23	1997-07-23 00:00:00	1997-07-23	38000177		0	0	14		0	0	0	61763	0	308192	19073188		
19932	1636	1127433	2002-04-07	2002-04-07 00:00:00	2002-05-07	2002-05-07 00:00:00	2002-05-07	38000177		0	0	30		0	0	0	109883	0	313782	1127433		
7823	654	40229134	2010-03-03	2010-03-03 00:00:00	2010-03-10	2010-03-10 00:00:00	2010-03-10	38000177		0	0	7		0	0	0	43295	0	1043400	40229134		
20023	1642	40220960	2008-06-17	2008-06-17 00:00:00	2008-06-17	2008-06-17 00:00:00	2008-06-17	38000177		0	0	0		0	0	0	110265	0	1804799	40220960		
46943	3887	1127078	1957-06-20	1957-06-20 00:00:00	1957-07-18	1957-07-18 00:00:00	1957-07-18	38000177		0	0	28		0	0	0	258362	0	282464	1127078		
56337	4675	1127433	1953-09-11	1953-09-11 00:00:00	1953-09-25	1953-09-25 00:00:00	1953-09-25	38000177		0	0	14		0	0	0	311429	0	313782	1127433		
3714	308	19129655	1964-11-21	1964-11-21 00:00:00	1964-12-05	1964-12-05 00:00:00	1964-12-05	38000177		0	0	14		0	0	0	20427	0	789980	19129655		
4763	398	1118084	1962-03-08	1962-03-08 00:00:00	1962-03-08	1962-03-08 00:00:00	\N	38000177		0	0	0		0	0	0	26095	0	00025152531	44923712		
154960	3410	40213260	2015-04-22	2015-04-22 00:00:00	2015-04-22	2015-04-22 00:00:00	2015-04-22	581452		0	0	0		0	0	0	226187	0	121	40213260		
200574	4405	40213260	2015-02-23	2015-02-23 00:00:00	2015-02-23	2015-02-23 00:00:00	2015-02-23	581452		0	0	0		0	0	0	292846	0	121	40213260		
227176	4988	40213227	2004-04-27	2004-04-27 00:00:00	2004-04-27	2004-04-27 00:00:00	2004-04-27	581452		0	0	0		0	0	0	331843	0	113	40213227		
18175	1506	40163554	2011-04-30	2011-04-30 00:00:00	2011-04-30	2011-04-30 00:00:00	\N	38000177		0	0	0		0	0	0	100439	0	855332	40163554		
60757	5051	1118084	2013-12-30	2013-12-30 00:00:00	2013-12-30	2013-12-30 00:00:00	\N	38000177		0	0	0		0	0	0	335949	0	00025152531	44923712		
4854	404	19078461	1983-01-20	1983-01-20 00:00:00	1983-02-03	1983-02-03 00:00:00	1983-02-03	38000177		0	0	14		0	0	0	26662	0	310965	19078461		
197670	4343	40213160	1955-01-24	1955-01-24 00:00:00	1955-01-24	1955-01-24 00:00:00	1955-01-24	581452		0	0	0		0	0	0	288040	0	10	40213160		
62095	5166	19059056	1992-03-14	1992-03-14 00:00:00	1992-06-12	1992-06-12 00:00:00	1992-06-12	38000177		0	0	90		0	0	0	343403	0	243670	19059056		
59050	4907	1127433	2008-03-18	2008-03-18 00:00:00	2008-04-01	2008-04-01 00:00:00	2008-04-01	38000177		0	0	14		0	0	0	326161	0	313782	1127433		
6681	564	1713671	1984-08-07	1984-08-07 00:00:00	1984-08-14	1984-08-14 00:00:00	1984-08-14	38000177		0	0	7		0	0	0	37330	0	562251	1713671		
64283	5334	1127433	1983-09-21	1983-09-21 00:00:00	1983-10-05	1983-10-05 00:00:00	1983-10-05	38000177		0	0	14		0	0	0	355202	0	313782	1127433		
59592	1305	40213227	2006-07-20	2006-07-20 00:00:00	2006-07-20	2006-07-20 00:00:00	2006-07-20	581452		0	0	0		0	0	0	86122	0	113	40213227		
5095	110	40213160	1976-07-25	1976-07-25 00:00:00	1976-07-25	1976-07-25 00:00:00	1976-07-25	581452		0	0	0		0	0	0	7318	0	10	40213160		
80150	1753	40213160	1964-08-13	1964-08-13 00:00:00	1964-08-13	1964-08-13 00:00:00	1964-08-13	581452		0	0	0		0	0	0	117242	0	10	40213160		
61034	5076	19059056	1952-08-02	1952-08-02 00:00:00	1952-08-16	1952-08-16 00:00:00	1952-08-16	38000177		0	0	14		0	0	0	337342	0	243670	19059056		
34840	2876	19059056	1966-09-07	1966-09-07 00:00:00	1966-09-21	1966-09-21 00:00:00	1966-09-21	38000177		0	0	14		0	0	0	191331	0	243670	19059056		
39265	3244	19128022	1992-03-19	1992-03-19 00:00:00	1993-03-14	1993-03-14 00:00:00	1993-03-14	38000177		0	0	360		0	0	0	215723	0	749785	19128022		
209953	4604	40213160	1964-06-07	1964-06-07 00:00:00	1964-06-07	1964-06-07 00:00:00	1964-06-07	581452		0	0	0		0	0	0	306730	0	10	40213160		
45441	3759	40229134	1977-11-14	1977-11-14 00:00:00	1977-11-28	1977-11-28 00:00:00	1977-11-28	38000177		0	0	14		0	0	0	249947	0	1043400	40229134		
34022	2813	40229134	1980-06-14	1980-06-14 00:00:00	1980-06-21	1980-06-21 00:00:00	1980-06-21	38000177		0	0	7		0	0	0	186432	0	1043400	40229134		
211359	4634	40213306	1984-11-29	1984-11-29 00:00:00	1984-11-29	1984-11-29 00:00:00	1984-11-29	581452		0	0	0		0	0	0	308845	0	43	40213306		
15162	1267	1127433	1995-02-27	1995-02-27 00:00:00	1995-03-29	1995-03-29 00:00:00	1995-03-29	38000177		0	0	30		0	0	0	83568	0	313782	1127433		
10297	863	40220960	2004-09-30	2004-09-30 00:00:00	2004-09-30	2004-09-30 00:00:00	2004-09-30	38000177		0	0	0		0	0	0	57227	0	1804799	40220960		
10359	865	1127433	1957-06-05	1957-06-05 00:00:00	1957-06-12	1957-06-12 00:00:00	1957-06-12	38000177		0	0	7		0	0	0	57414	0	313782	1127433		
213355	4678	40213260	2006-10-10	2006-10-10 00:00:00	2006-10-10	2006-10-10 00:00:00	2006-10-10	581452		0	0	0		0	0	0	311796	0	121	40213260		
182318	4005	40213260	2019-06-29	2019-06-29 00:00:00	2019-06-29	2019-06-29 00:00:00	2019-06-29	581452		0	0	0		0	0	0	266070	0	121	40213260		
8786	732	19128022	1989-03-25	1989-03-25 00:00:00	1990-03-20	1990-03-20 00:00:00	1990-03-20	38000177		0	0	360		0	0	0	48545	0	749785	19128022		
116709	2564	40213160	1977-01-29	1977-01-29 00:00:00	1977-01-29	1977-01-29 00:00:00	1977-01-29	581452		0	0	0		0	0	0	169855	0	10	40213160		
182918	4019	40213227	2005-03-22	2005-03-22 00:00:00	2005-03-22	2005-03-22 00:00:00	2005-03-22	581452		0	0	0		0	0	0	267186	0	113	40213227		
27606	2287	19059056	1940-12-26	1940-12-26 00:00:00	1941-01-16	1941-01-16 00:00:00	1941-01-16	38000177		0	0	21		0	0	0	152094	0	243670	19059056		
87895	1928	40213296	2015-06-17	2015-06-17 00:00:00	2015-06-17	2015-06-17 00:00:00	2015-06-17	581452		0	0	0		0	0	0	128310	0	52	40213296		
138714	3047	40213306	1995-04-19	1995-04-19 00:00:00	1995-04-19	1995-04-19 00:00:00	1995-04-19	581452		0	0	0		0	0	0	202769	0	43	40213306		
91701	2012	40213296	1997-02-07	1997-02-07 00:00:00	1997-02-07	1997-02-07 00:00:00	1997-02-07	581452		0	0	0		0	0	0	133890	0	52	40213296		
2312	186	1127433	1991-01-11	1991-01-11 00:00:00	1991-01-25	1991-01-25 00:00:00	1991-01-25	38000177		0	0	14		0	0	0	12637	0	313782	1127433		
99368	2176	40213260	2006-08-21	2006-08-21 00:00:00	2006-08-21	2006-08-21 00:00:00	2006-08-21	581452		0	0	0		0	0	0	145133	0	121	40213260		
31913	695	40213227	1993-08-30	1993-08-30 00:00:00	1993-08-30	1993-08-30 00:00:00	1993-08-30	581452		0	0	0		0	0	0	46045	0	113	40213227		
4445	96	40213201	1991-03-30	1991-03-30 00:00:00	1991-03-30	1991-03-30 00:00:00	1991-03-30	581452		0	0	0		0	0	0	6483	0	33	40213201		
49361	4094	19133873	1968-03-31	1968-03-31 00:00:00	1968-04-11	1968-04-11 00:00:00	1968-04-11	38000177		0	0	11		0	0	0	272121	0	834061	19133873		
57766	4799	1127433	1971-04-07	1971-04-07 00:00:00	1971-04-14	1971-04-14 00:00:00	1971-04-14	38000177		0	0	7		0	0	0	319205	0	313782	1127433		
175828	3865	40213227	2017-10-05	2017-10-05 00:00:00	2017-10-05	2017-10-05 00:00:00	2017-10-05	581452		0	0	0		0	0	0	256575	0	113	40213227		
51232	4256	19016749	1963-11-14	1963-11-14 00:00:00	1963-11-14	1963-11-14 00:00:00	1963-11-14	38000177		0	0	0		0	0	0	282589	0	73032	19016749		
43732	3623	19006318	1954-06-10	1954-06-10 00:00:00	1954-06-24	1954-06-24 00:00:00	1954-06-24	38000177		0	0	14		0	0	0	240872	0	105078	19006318		
214889	4713	40213160	1966-09-16	1966-09-16 00:00:00	1966-09-16	1966-09-16 00:00:00	1966-09-16	581452		0	0	0		0	0	0	313873	0	10	40213160		
61837	5144	45892894	2016-03-20	2016-03-20 00:00:00	2016-03-20	2016-03-20 00:00:00	\N	38000177		0	0	0		0	0	0	341894	0	1599803	45892894		
189842	4168	40213296	2011-04-09	2011-04-09 00:00:00	2011-04-09	2011-04-09 00:00:00	2011-04-09	581452		0	0	0		0	0	0	277063	0	52	40213296		
4443	369	19059056	1982-03-22	1982-03-22 00:00:00	1982-04-05	1982-04-05 00:00:00	1982-04-05	38000177		0	0	14		0	0	0	24534	0	243670	19059056		
162723	3578	40213306	1994-10-05	1994-10-05 00:00:00	1994-10-05	1994-10-05 00:00:00	1994-10-05	581452		0	0	0		0	0	0	237884	0	43	40213306		
53770	1177	40213160	1963-08-05	1963-08-05 00:00:00	1963-08-05	1963-08-05 00:00:00	1963-08-05	581452		0	0	0		0	0	0	77778	0	10	40213160		
147852	3250	40213160	1967-11-14	1967-11-14 00:00:00	1967-11-14	1967-11-14 00:00:00	1967-11-14	581452		0	0	0		0	0	0	216062	0	10	40213160		
31297	682	40213296	2010-12-29	2010-12-29 00:00:00	2010-12-29	2010-12-29 00:00:00	2010-12-29	581452		0	0	0		0	0	0	45155	0	52	40213296		
20487	1685	19019979	1989-09-11	1989-09-11 00:00:00	1989-09-25	1989-09-25 00:00:00	1989-09-25	38000177		0	0	14		0	0	0	112869	0	198405	19019979		
20518	1689	19059056	1964-10-23	1964-10-23 00:00:00	1964-11-06	1964-11-06 00:00:00	1964-11-06	38000177		0	0	14		0	0	0	113089	0	243670	19059056		
55942	4643	1127433	1978-12-07	1978-12-07 00:00:00	1979-02-05	1979-02-05 00:00:00	1979-02-05	38000177		0	0	60		0	0	0	309626	0	313782	1127433		
58870	4890	1115171	2015-05-07	2015-05-07 00:00:00	2015-05-21	2015-05-21 00:00:00	2015-05-21	38000177		0	0	14		0	0	0	325141	0	849574	1115171		
11151	929	1127433	1997-07-09	1997-07-09 00:00:00	1997-07-23	1997-07-23 00:00:00	1997-07-23	38000177		0	0	14		0	0	0	61763	0	313782	1127433		
19933	1636	19129655	1963-04-10	1963-04-10 00:00:00	1963-04-24	1963-04-24 00:00:00	1963-04-24	38000177		0	0	14		0	0	0	109915	0	789980	19129655		
7824	654	1118084	2001-07-26	2001-07-26 00:00:00	2001-07-26	2001-07-26 00:00:00	\N	38000177		0	0	0		0	0	0	43290	0	00025152531	44923712		
20041	1646	1118084	1982-03-05	1982-03-05 00:00:00	1982-03-05	1982-03-05 00:00:00	\N	38000177		0	0	0		0	0	0	110381	0	00025152531	44923712		
46944	3887	1127433	1973-05-08	1973-05-08 00:00:00	1973-05-22	1973-05-22 00:00:00	1973-05-22	38000177		0	0	14		0	0	0	258339	0	313782	1127433		
56338	4675	1127433	2007-12-06	2007-12-06 00:00:00	2008-01-05	2008-01-05 00:00:00	2008-01-05	38000177		0	0	30		0	0	0	311449	0	313782	1127433		
3715	308	1127433	1963-01-11	1963-01-11 00:00:00	1963-01-18	1963-01-18 00:00:00	1963-01-18	38000177		0	0	7		0	0	0	20421	0	313782	1127433		
4764	398	1127433	1927-08-23	1927-08-23 00:00:00	1927-08-30	1927-08-30 00:00:00	1927-08-30	38000177		0	0	7		0	0	0	26053	0	313782	1127433		
154962	3410	40213227	2015-04-22	2015-04-22 00:00:00	2015-04-22	2015-04-22 00:00:00	2015-04-22	581452		0	0	0		0	0	0	226187	0	113	40213227		
200581	4405	40213296	2006-05-22	2006-05-22 00:00:00	2006-05-22	2006-05-22 00:00:00	2006-05-22	581452		0	0	0		0	0	0	292836	0	52	40213296		
39199	856	40213160	1974-05-24	1974-05-24 00:00:00	1974-05-24	1974-05-24 00:00:00	1974-05-24	581452		0	0	0		0	0	0	56532	0	10	40213160		
18177	1506	19075601	2012-10-13	2012-10-13 00:00:00	2012-10-13	2012-10-13 00:00:00	2012-10-13	38000177		0	0	0		0	0	0	100408	0	309362	19075601		
60758	5051	1150771	1978-10-04	1978-10-04 00:00:00	1978-10-04	1978-10-04 00:00:00	\N	38000177		0	0	0		0	0	0	335893	0	197378	1150771		
4855	404	1118084	2001-12-21	2001-12-21 00:00:00	2001-12-21	2001-12-21 00:00:00	\N	38000177		0	0	0		0	0	0	26552	0	00025152531	44923712		
197672	4343	40213227	2015-12-21	2015-12-21 00:00:00	2015-12-21	2015-12-21 00:00:00	2015-12-21	581452		0	0	0		0	0	0	288006	0	113	40213227		
199589	4384	40213227	2019-01-07	2019-01-07 00:00:00	2019-01-07	2019-01-07 00:00:00	2019-01-07	581452		0	0	0		0	0	0	291374	0	113	40213227		
59051	4907	1127433	1959-10-28	1959-10-28 00:00:00	1959-11-04	1959-11-04 00:00:00	1959-11-04	38000177		0	0	7		0	0	0	326128	0	313782	1127433		
6682	564	40236824	1992-01-21	1992-01-21 00:00:00	1992-01-28	1992-01-28 00:00:00	1992-01-28	38000177		0	0	7		0	0	0	37383	0	1094107	40236824		
64285	5334	1713671	1984-06-26	1984-06-26 00:00:00	1984-07-03	1984-07-03 00:00:00	1984-07-03	38000177		0	0	7		0	0	0	355205	0	562251	1713671		
59593	1305	40213296	2006-07-20	2006-07-20 00:00:00	2006-07-20	2006-07-20 00:00:00	2006-07-20	581452		0	0	0		0	0	0	86122	0	52	40213296		
5098	110	40213227	2017-02-19	2017-02-19 00:00:00	2017-02-19	2017-02-19 00:00:00	2017-02-19	581452		0	0	0		0	0	0	7350	0	113	40213227		
80153	1753	40213296	2006-05-04	2006-05-04 00:00:00	2006-05-04	2006-05-04 00:00:00	2006-05-04	581452		0	0	0		0	0	0	117266	0	52	40213296		
61035	5076	1127433	1988-03-13	1988-03-13 00:00:00	1988-03-27	1988-03-27 00:00:00	1988-03-27	38000177		0	0	14		0	0	0	337422	0	313782	1127433		
34841	2876	40169281	1992-08-06	1992-08-06 00:00:00	1992-08-06	1992-08-06 00:00:00	\N	38000177		0	0	0		0	0	0	191373	0	896209	40169281		
39266	3244	1127433	1996-09-10	1996-09-10 00:00:00	1996-09-17	1996-09-17 00:00:00	1996-09-17	38000177		0	0	7		0	0	0	215701	0	313782	1127433		
209963	4604	40213306	1987-11-01	1987-11-01 00:00:00	1987-11-01	1987-11-01 00:00:00	1987-11-01	581452		0	0	0		0	0	0	306753	0	43	40213306		
45442	3759	40232448	1983-08-31	1983-08-31 00:00:00	1983-08-31	1983-08-31 00:00:00	\N	38000177		0	0	0		0	0	0	249968	0	1049630	40232448		
34023	2813	19133873	1947-05-21	1947-05-21 00:00:00	1947-06-03	1947-06-03 00:00:00	1947-06-03	38000177		0	0	13		0	0	0	186408	0	834061	19133873		
240659	5283	40213296	2016-04-26	2016-04-26 00:00:00	2016-04-26	2016-04-26 00:00:00	2016-04-26	581452		0	0	0		0	0	0	351429	0	52	40213296		
15163	1267	1127433	1981-01-17	1981-01-17 00:00:00	1981-01-31	1981-01-31 00:00:00	1981-01-31	38000177		0	0	14		0	0	0	83599	0	313782	1127433		
10298	863	19075601	2005-06-16	2005-06-16 00:00:00	2014-07-03	2014-07-03 00:00:00	2014-07-03	38000177		0	0	3304		0	0	0	57189	0	309362	19075601		
10360	866	19133905	2015-12-16	2015-12-16 00:00:00	2015-12-27	2015-12-27 00:00:00	2015-12-27	38000177		0	0	11		0	0	0	57492	0	834102	19133905		
213366	4678	40213227	2005-10-04	2005-10-04 00:00:00	2005-10-04	2005-10-04 00:00:00	2005-10-04	581452		0	0	0		0	0	0	311785	0	113	40213227		
182321	4005	40213160	1970-02-28	1970-02-28 00:00:00	1970-02-28	1970-02-28 00:00:00	1970-02-28	581452		0	0	0		0	0	0	266089	0	10	40213160		
8787	732	1124300	2015-11-19	2015-11-19 00:00:00	2015-11-19	2015-11-19 00:00:00	\N	38000177		0	0	0		0	0	0	48560	0	00781178901	45011828		
119286	2622	40213201	1997-09-13	1997-09-13 00:00:00	1997-09-13	1997-09-13 00:00:00	1997-09-13	581452		0	0	0		0	0	0	173509	0	33	40213201		
182919	4019	40213160	1963-05-07	1963-05-07 00:00:00	1963-05-07	1963-05-07 00:00:00	1963-05-07	581452		0	0	0		0	0	0	267143	0	10	40213160		
27607	2287	1332419	1994-03-25	1994-03-25 00:00:00	1994-03-25	1994-03-25 00:00:00	\N	38000177		0	0	0		0	0	0	152169	0	197361	1332419		
87897	1928	40213160	1972-01-12	1972-01-12 00:00:00	1972-01-12	1972-01-12 00:00:00	1972-01-12	581452		0	0	0		0	0	0	128342	0	10	40213160		
138719	3048	40213306	1996-07-17	1996-07-17 00:00:00	1996-07-17	1996-07-17 00:00:00	1996-07-17	581452		0	0	0		0	0	0	202788	0	43	40213306		
91703	2013	40213160	1956-08-25	1956-08-25 00:00:00	1956-08-25	1956-08-25 00:00:00	1956-08-25	581452		0	0	0		0	0	0	133962	0	10	40213160		
2313	186	1127078	1981-09-30	1981-09-30 00:00:00	1981-10-29	1981-10-29 00:00:00	1981-10-29	38000177		0	0	29		0	0	0	12649	0	282464	1127078		
99374	2176	40213227	2007-08-27	2007-08-27 00:00:00	2007-08-27	2007-08-27 00:00:00	2007-08-27	581452		0	0	0		0	0	0	145149	0	113	40213227		
31918	695	40213160	1969-06-30	1969-06-30 00:00:00	1969-06-30	1969-06-30 00:00:00	1969-06-30	581452		0	0	0		0	0	0	46019	0	10	40213160		
4454	96	40213227	1996-04-27	1996-04-27 00:00:00	1996-04-27	1996-04-27 00:00:00	1996-04-27	581452		0	0	0		0	0	0	6496	0	113	40213227		
49362	4094	1118084	1991-02-26	1991-02-26 00:00:00	1991-02-26	1991-02-26 00:00:00	\N	38000177		0	0	0		0	0	0	272169	0	00025152531	44923712		
57768	4799	40229134	1963-12-16	1963-12-16 00:00:00	1963-12-23	1963-12-23 00:00:00	1963-12-23	38000177		0	0	7		0	0	0	319284	0	1043400	40229134		
175838	3865	40213160	1956-12-06	1956-12-06 00:00:00	1956-12-06	1956-12-06 00:00:00	1956-12-06	581452		0	0	0		0	0	0	256597	0	10	40213160		
51233	4256	19078924	1963-11-14	1963-11-14 00:00:00	1963-11-14	1963-11-14 00:00:00	1963-11-14	38000177		0	0	0		0	0	0	282589	0	311700	19078924		
43733	3624	19006318	1950-08-31	1950-08-31 00:00:00	1950-09-14	1950-09-14 00:00:00	1950-09-14	38000177		0	0	14		0	0	0	240973	0	105078	19006318		
214898	4713	40213296	2006-01-13	2006-01-13 00:00:00	2006-01-13	2006-01-13 00:00:00	2006-01-13	581452		0	0	0		0	0	0	313813	0	52	40213296		
61838	5144	19077572	2014-09-27	2014-09-27 00:00:00	2014-09-27	2014-09-27 00:00:00	\N	38000177		0	0	0		0	0	0	341914	0	310436	19077572		
189851	4168	40213160	1971-12-11	1971-12-11 00:00:00	1971-12-11	1971-12-11 00:00:00	1971-12-11	581452		0	0	0		0	0	0	277028	0	10	40213160		
4444	369	1127433	1997-02-15	1997-02-15 00:00:00	1997-03-01	1997-03-01 00:00:00	1997-03-01	38000177		0	0	14		0	0	0	24579	0	313782	1127433		
162725	3578	40213227	2003-10-15	2003-10-15 00:00:00	2003-10-15	2003-10-15 00:00:00	2003-10-15	581452		0	0	0		0	0	0	237893	0	113	40213227		
53773	1177	40213296	2003-07-14	2003-07-14 00:00:00	2003-07-14	2003-07-14 00:00:00	2003-07-14	581452		0	0	0		0	0	0	77741	0	52	40213296		
273	6	40213160	1968-12-10	1968-12-10 00:00:00	1968-12-10	1968-12-10 00:00:00	1968-12-10	581452		0	0	0		0	0	0	576	0	10	40213160		
31302	682	40213160	1975-10-29	1975-10-29 00:00:00	1975-10-29	1975-10-29 00:00:00	1975-10-29	581452		0	0	0		0	0	0	45179	0	10	40213160		
20488	1686	1127433	1980-06-15	1980-06-15 00:00:00	1980-06-29	1980-06-29 00:00:00	1980-06-29	38000177		0	0	14		0	0	0	112922	0	313782	1127433		
20519	1689	1713671	1973-02-19	1973-02-19 00:00:00	1973-03-12	1973-03-12 00:00:00	1973-03-12	38000177		0	0	21		0	0	0	113095	0	562251	1713671		
58817	4886	19133873	1972-01-16	1972-01-16 00:00:00	1972-01-28	1972-01-28 00:00:00	1972-01-28	38000177		0	0	12		0	0	0	324936	0	834061	19133873		
58871	4890	1127433	1971-01-29	1971-01-29 00:00:00	1971-02-05	1971-02-05 00:00:00	1971-02-05	38000177		0	0	7		0	0	0	325183	0	313782	1127433		
11152	929	19126352	1990-12-03	1990-12-03 00:00:00	2005-10-10	2005-10-10 00:00:00	2005-10-10	38000177		0	0	5425		0	0	0	61800	0	705129	19126352		
19934	1636	19059056	1963-04-10	1963-04-10 00:00:00	1963-04-24	1963-04-24 00:00:00	1963-04-24	38000177		0	0	14		0	0	0	109915	0	243670	19059056		
7825	654	19133873	1971-07-31	1971-07-31 00:00:00	1971-08-07	1971-08-07 00:00:00	1971-08-07	38000177		0	0	7		0	0	0	43337	0	834061	19133873		
20042	1646	1127433	2014-02-10	2014-02-10 00:00:00	2014-02-24	2014-02-24 00:00:00	2014-02-24	38000177		0	0	14		0	0	0	110394	0	313782	1127433		
46949	3889	1127433	1958-04-16	1958-04-16 00:00:00	1958-04-23	1958-04-23 00:00:00	1958-04-23	38000177		0	0	7		0	0	0	258453	0	313782	1127433		
56339	4675	1127433	1972-06-16	1972-06-16 00:00:00	1972-06-30	1972-06-30 00:00:00	1972-06-30	38000177		0	0	14		0	0	0	311497	0	313782	1127433		
3716	308	1127433	1996-04-04	1996-04-04 00:00:00	1996-04-18	1996-04-18 00:00:00	1996-04-18	38000177		0	0	14		0	0	0	20423	0	313782	1127433		
4765	399	19006318	1957-03-23	1957-03-23 00:00:00	1957-04-06	1957-04-06 00:00:00	1957-04-06	38000177		0	0	14		0	0	0	26141	0	105078	19006318		
154964	3410	40213160	1964-07-22	1964-07-22 00:00:00	1964-07-22	1964-07-22 00:00:00	1964-07-22	581452		0	0	0		0	0	0	226180	0	10	40213160		
200583	4405	40213227	2006-05-22	2006-05-22 00:00:00	2006-05-22	2006-05-22 00:00:00	2006-05-22	581452		0	0	0		0	0	0	292836	0	113	40213227		
236983	5203	40213201	2001-11-21	2001-11-21 00:00:00	2001-11-21	2001-11-21 00:00:00	2001-11-21	581452		0	0	0		0	0	0	346076	0	33	40213201		
18178	1506	40220960	2012-10-13	2012-10-13 00:00:00	2012-10-13	2012-10-13 00:00:00	2012-10-13	38000177		0	0	0		0	0	0	100408	0	1804799	40220960		
60759	5051	1127433	1998-07-08	1998-07-08 00:00:00	1998-07-22	1998-07-22 00:00:00	1998-07-22	38000177		0	0	14		0	0	0	335890	0	313782	1127433		
4856	404	1127433	1965-03-22	1965-03-22 00:00:00	1965-04-05	1965-04-05 00:00:00	1965-04-05	38000177		0	0	14		0	0	0	26576	0	313782	1127433		
197676	4343	40213260	2006-10-30	2006-10-30 00:00:00	2006-10-30	2006-10-30 00:00:00	2006-10-30	581452		0	0	0		0	0	0	288019	0	121	40213260		
199590	4384	40213260	2019-01-07	2019-01-07 00:00:00	2019-01-07	2019-01-07 00:00:00	2019-01-07	581452		0	0	0		0	0	0	291374	0	121	40213260		
59052	4907	1713671	1982-01-10	1982-01-10 00:00:00	1982-03-07	1982-03-07 00:00:00	1982-03-07	38000177		0	0	56		0	0	0	326131	0	562251	1713671		
6683	564	920300	1992-01-21	1992-01-21 00:00:00	1992-01-28	1992-01-28 00:00:00	1992-01-28	38000177		0	0	7		0	0	0	37383	0	311989	920300		
64286	5335	1118084	1992-10-01	1992-10-01 00:00:00	1992-10-01	1992-10-01 00:00:00	\N	38000177		0	0	0		0	0	0	355279	0	00025152531	44923712		
59596	1305	40213227	2015-07-16	2015-07-16 00:00:00	2015-07-16	2015-07-16 00:00:00	2015-07-16	581452		0	0	0		0	0	0	86115	0	113	40213227		
66772	1461	40213160	1967-04-06	1967-04-06 00:00:00	1967-04-06	1967-04-06 00:00:00	1967-04-06	581452		0	0	0		0	0	0	97331	0	10	40213160		
80155	1753	40213227	2006-05-04	2006-05-04 00:00:00	2006-05-04	2006-05-04 00:00:00	2006-05-04	581452		0	0	0		0	0	0	117266	0	113	40213227		
61036	5076	19059056	1938-06-06	1938-06-06 00:00:00	1938-06-20	1938-06-20 00:00:00	1938-06-20	38000177		0	0	14		0	0	0	337335	0	243670	19059056		
34843	2876	1127433	1981-07-08	1981-07-08 00:00:00	1981-07-15	1981-07-15 00:00:00	1981-07-15	38000177		0	0	7		0	0	0	191362	0	313782	1127433		
39267	3244	1127433	1985-09-14	1985-09-14 00:00:00	1985-09-28	1985-09-28 00:00:00	1985-09-28	38000177		0	0	14		0	0	0	215689	0	313782	1127433		
109654	2409	40213296	2018-10-07	2018-10-07 00:00:00	2018-10-07	2018-10-07 00:00:00	2018-10-07	581452		0	0	0		0	0	0	159935	0	52	40213296		
87782	1925	40213198	2010-02-27	2010-02-27 00:00:00	2010-02-27	2010-02-27 00:00:00	2010-02-27	581452		0	0	0		0	0	0	128182	0	133	40213198		
34024	2813	1713671	1944-03-09	1944-03-09 00:00:00	1944-03-30	1944-03-30 00:00:00	1944-03-30	38000177		0	0	21		0	0	0	186376	0	562251	1713671		
240660	5283	40213314	1977-08-16	1977-08-16 00:00:00	1977-08-16	1977-08-16 00:00:00	1977-08-16	581452		0	0	0		0	0	0	351445	0	49	40213314		
15165	1267	1127433	1990-01-25	1990-01-25 00:00:00	1990-02-08	1990-02-08 00:00:00	1990-02-08	38000177		0	0	14		0	0	0	83519	0	313782	1127433		
10299	863	19059056	1923-07-09	1923-07-09 00:00:00	1923-07-23	1923-07-23 00:00:00	1923-07-23	38000177		0	0	14		0	0	0	57205	0	243670	19059056		
10361	866	1713671	2000-03-16	2000-03-16 00:00:00	2000-03-30	2000-03-30 00:00:00	2000-03-30	38000177		0	0	14		0	0	0	57446	0	562251	1713671		
224652	4932	40213160	1958-07-24	1958-07-24 00:00:00	1958-07-24	1958-07-24 00:00:00	1958-07-24	581452		0	0	0		0	0	0	327843	0	10	40213160		
182324	4005	40213227	2002-05-25	2002-05-25 00:00:00	2002-05-25	2002-05-25 00:00:00	2002-05-25	581452		0	0	0		0	0	0	266079	0	113	40213227		
8788	732	1127433	1988-12-27	1988-12-27 00:00:00	1989-01-10	1989-01-10 00:00:00	1989-01-10	38000177		0	0	14		0	0	0	48574	0	313782	1127433		
119297	2622	40213227	2011-12-03	2011-12-03 00:00:00	2011-12-03	2011-12-03 00:00:00	2011-12-03	581452		0	0	0		0	0	0	173423	0	113	40213227		
182923	4019	40213306	1985-03-26	1985-03-26 00:00:00	1985-03-26	1985-03-26 00:00:00	1985-03-26	581452		0	0	0		0	0	0	267191	0	43	40213306		
27608	2287	19133905	1970-02-17	1970-02-17 00:00:00	1970-03-01	1970-03-01 00:00:00	1970-03-01	38000177		0	0	12		0	0	0	152102	0	834102	19133905		
87903	1928	40213227	1993-06-16	1993-06-16 00:00:00	1993-06-16	1993-06-16 00:00:00	1993-06-16	581452		0	0	0		0	0	0	\N	0	113	40213227		
80344	1758	40213296	2002-08-30	2002-08-30 00:00:00	2002-08-30	2002-08-30 00:00:00	2002-08-30	581452		0	0	0		0	0	0	117528	0	52	40213296		
105600	2318	40213296	2003-02-01	2003-02-01 00:00:00	2003-02-01	2003-02-01 00:00:00	2003-02-01	581452		0	0	0		0	0	0	154083	0	52	40213296		
2314	186	1551192	1975-01-09	1975-01-09 00:00:00	1975-01-09	1975-01-09 00:00:00	1975-01-09	38000177		0	0	0		0	0	0	12648	0	312617	1551192		
99375	2176	40213260	2007-08-27	2007-08-27 00:00:00	2007-08-27	2007-08-27 00:00:00	2007-08-27	581452		0	0	0		0	0	0	145149	0	121	40213260		
31924	695	40213160	1969-01-27	1969-01-27 00:00:00	1969-01-27	1969-01-27 00:00:00	1969-01-27	581452		0	0	0		0	0	0	46010	0	10	40213160		
19179	1585	19078461	1990-04-19	1990-04-19 00:00:00	1990-05-03	1990-05-03 00:00:00	1990-05-03	38000177		0	0	14		0	0	0	106350	0	310965	19078461		
49363	4094	1713671	1961-11-18	1961-11-18 00:00:00	1961-12-02	1961-12-02 00:00:00	1961-12-02	38000177		0	0	14		0	0	0	272140	0	562251	1713671		
202801	4452	40213160	1955-11-11	1955-11-11 00:00:00	1955-11-11	1955-11-11 00:00:00	1955-11-11	581452		0	0	0		0	0	0	296302	0	10	40213160		
175856	3866	40213198	2015-01-13	2015-01-13 00:00:00	2015-01-13	2015-01-13 00:00:00	2015-01-13	581452		0	0	0		0	0	0	256711	0	133	40213198		
51234	4256	40220386	1963-11-14	1963-11-14 00:00:00	1963-11-14	1963-11-14 00:00:00	1963-11-14	38000177		0	0	0		0	0	0	282589	0	1808217	40220386		
43734	3624	1127078	1950-08-31	1950-08-31 00:00:00	1950-09-14	1950-09-14 00:00:00	1950-09-14	38000177		0	0	14		0	0	0	240973	0	282464	1127078		
214899	4713	40213296	2008-01-18	2008-01-18 00:00:00	2008-01-18	2008-01-18 00:00:00	2008-01-18	581452		0	0	0		0	0	0	313868	0	52	40213296		
61839	5144	1127433	2017-06-03	2017-06-03 00:00:00	2017-06-17	2017-06-17 00:00:00	2017-06-17	38000177		0	0	14		0	0	0	341895	0	313782	1127433		
189852	4168	40213160	1976-03-13	1976-03-13 00:00:00	1976-03-13	1976-03-13 00:00:00	1976-03-13	581452		0	0	0		0	0	0	277016	0	10	40213160		
4445	369	1713671	2012-05-05	2012-05-05 00:00:00	2012-05-12	2012-05-12 00:00:00	2012-05-12	38000177		0	0	7		0	0	0	24566	0	562251	1713671		
162726	3578	40213296	2015-05-27	2015-05-27 00:00:00	2015-05-27	2015-05-27 00:00:00	2015-05-27	581452		0	0	0		0	0	0	237851	0	52	40213296		
53782	1177	40213227	1995-05-29	1995-05-29 00:00:00	1995-05-29	1995-05-29 00:00:00	1995-05-29	581452		0	0	0		0	0	0	77774	0	113	40213227		
278	6	40213227	1995-03-14	1995-03-14 00:00:00	1995-03-14	1995-03-14 00:00:00	1995-03-14	581452		0	0	0		0	0	0	594	0	113	40213227		
31305	682	40213160	1971-02-24	1971-02-24 00:00:00	1971-02-24	1971-02-24 00:00:00	1971-02-24	581452		0	0	0		0	0	0	45149	0	10	40213160		
20489	1686	1127433	1976-11-27	1976-11-27 00:00:00	1976-12-04	1976-12-04 00:00:00	1976-12-04	38000177		0	0	7		0	0	0	112932	0	313782	1127433		
20520	1689	1127078	1952-07-28	1952-07-28 00:00:00	1952-09-26	1952-09-26 00:00:00	1952-09-26	38000177		0	0	60		0	0	0	113088	0	282464	1127078		
58818	4886	1127433	1996-10-13	1996-10-13 00:00:00	1996-10-20	1996-10-20 00:00:00	1996-10-20	38000177		0	0	7		0	0	0	324879	0	313782	1127433		
58872	4890	19078461	1981-12-26	1981-12-26 00:00:00	1982-02-24	1982-02-24 00:00:00	1982-02-24	38000177		0	0	60		0	0	0	325146	0	310965	19078461		
11153	929	19059056	1919-09-03	1919-09-03 00:00:00	1919-09-17	1919-09-17 00:00:00	1919-09-17	38000177		0	0	14		0	0	0	61842	0	243670	19059056		
19935	1636	19059056	1960-03-15	1960-03-15 00:00:00	1960-03-29	1960-03-29 00:00:00	1960-03-29	38000177		0	0	14		0	0	0	109921	0	243670	19059056		
7826	654	1127433	2018-08-26	2018-08-26 00:00:00	2018-09-02	2018-09-02 00:00:00	2018-09-02	38000177		0	0	7		0	0	0	43298	0	313782	1127433		
20043	1646	19006318	1956-12-06	1956-12-06 00:00:00	1956-12-20	1956-12-20 00:00:00	1956-12-20	38000177		0	0	14		0	0	0	110376	0	105078	19006318		
46950	3889	1713671	1952-01-02	1952-01-02 00:00:00	1952-01-09	1952-01-09 00:00:00	1952-01-09	38000177		0	0	7		0	0	0	258469	0	562251	1713671		
56340	4675	1713671	2000-06-16	2000-06-16 00:00:00	2000-06-30	2000-06-30 00:00:00	2000-06-30	38000177		0	0	14		0	0	0	311435	0	562251	1713671		
3717	308	1124300	1999-02-26	1999-02-26 00:00:00	1999-02-26	1999-02-26 00:00:00	\N	38000177		0	0	0		0	0	0	20423	0	00781178901	45011828		
4766	399	19059056	1957-03-23	1957-03-23 00:00:00	1957-04-06	1957-04-06 00:00:00	1957-04-06	38000177		0	0	14		0	0	0	26141	0	243670	19059056		
154966	3410	40213160	1964-12-23	1964-12-23 00:00:00	1964-12-23	1964-12-23 00:00:00	1964-12-23	581452		0	0	0		0	0	0	226181	0	10	40213160		
200586	4405	40213160	1964-10-26	1964-10-26 00:00:00	1964-10-26	1964-10-26 00:00:00	1964-10-26	581452		0	0	0		0	0	0	292812	0	10	40213160		
132418	2909	40213227	2006-07-09	2006-07-09 00:00:00	2006-07-09	2006-07-09 00:00:00	2006-07-09	581452		0	0	0		0	0	0	193928	0	113	40213227		
18179	1506	19059056	1949-01-30	1949-01-30 00:00:00	1949-02-13	1949-02-13 00:00:00	1949-02-13	38000177		0	0	14		0	0	0	100404	0	243670	19059056		
60760	5051	40229134	1992-05-18	1992-05-18 00:00:00	1992-06-01	1992-06-01 00:00:00	1992-06-01	38000177		0	0	14		0	0	0	335931	0	1043400	40229134		
4857	404	1127433	2001-11-07	2001-11-07 00:00:00	2001-11-21	2001-11-21 00:00:00	2001-11-21	38000177		0	0	14		0	0	0	26609	0	313782	1127433		
197692	4343	40213160	1955-06-27	1955-06-27 00:00:00	1955-06-27	1955-06-27 00:00:00	1955-06-27	581452		0	0	0		0	0	0	288014	0	10	40213160		
199596	4384	40213160	1967-12-25	1967-12-25 00:00:00	1967-12-25	1967-12-25 00:00:00	1967-12-25	581452		0	0	0		0	0	0	291422	0	10	40213160		
59053	4907	40229134	1949-09-16	1949-09-16 00:00:00	1949-09-30	1949-09-30 00:00:00	1949-09-30	38000177		0	0	14		0	0	0	326099	0	1043400	40229134		
6684	564	1115171	2007-09-04	2007-09-04 00:00:00	2007-09-25	2007-09-25 00:00:00	2007-09-25	38000177		0	0	21		0	0	0	37343	0	849574	1115171		
64287	5335	1713671	2004-11-27	2004-11-27 00:00:00	2004-12-11	2004-12-11 00:00:00	2004-12-11	38000177		0	0	14		0	0	0	355305	0	562251	1713671		
59597	1305	40213260	2015-07-16	2015-07-16 00:00:00	2015-07-16	2015-07-16 00:00:00	2015-07-16	581452		0	0	0		0	0	0	86115	0	121	40213260		
66777	1461	40213160	1967-07-06	1967-07-06 00:00:00	1967-07-06	1967-07-06 00:00:00	1967-07-06	581452		0	0	0		0	0	0	97340	0	10	40213160		
76060	1661	40213160	1955-10-06	1955-10-06 00:00:00	1955-10-06	1955-10-06 00:00:00	1955-10-06	581452		0	0	0		0	0	0	111696	0	10	40213160		
59627	1305	40213160	1964-12-17	1964-12-17 00:00:00	1964-12-17	1964-12-17 00:00:00	1964-12-17	581452		0	0	0		0	0	0	86142	0	10	40213160		
34844	2876	40236824	2004-10-24	2004-10-24 00:00:00	2004-10-31	2004-10-31 00:00:00	2004-10-31	38000177		0	0	7		0	0	0	191358	0	1094107	40236824		
39268	3244	1594382	1991-05-02	1991-05-02 00:00:00	1991-05-02	1991-05-02 00:00:00	\N	38000177		0	0	0		0	0	0	215732	0	1870230	1594382		
109660	2409	40213160	1979-06-10	1979-06-10 00:00:00	1979-06-10	1979-06-10 00:00:00	1979-06-10	581452		0	0	0		0	0	0	159905	0	10	40213160		
87784	1925	40213227	2016-04-02	2016-04-02 00:00:00	2016-04-02	2016-04-02 00:00:00	2016-04-02	581452		0	0	0		0	0	0	128159	0	113	40213227		
34025	2813	1713671	2011-05-18	2011-05-18 00:00:00	2011-06-01	2011-06-01 00:00:00	2011-06-01	38000177		0	0	14		0	0	0	186410	0	562251	1713671		
240662	5283	40213160	1972-12-12	1972-12-12 00:00:00	1972-12-12	1972-12-12 00:00:00	1972-12-12	581452		0	0	0		0	0	0	351462	0	10	40213160		
15166	1267	19133873	1961-06-29	1961-06-29 00:00:00	1961-07-10	1961-07-10 00:00:00	1961-07-10	38000177		0	0	11		0	0	0	83514	0	834061	19133873		
10300	863	1124300	1964-10-26	1964-10-26 00:00:00	1964-10-26	1964-10-26 00:00:00	\N	38000177		0	0	0		0	0	0	57129	0	00781178901	45011828		
10362	866	19059056	1962-10-23	1962-10-23 00:00:00	1962-11-06	1962-11-06 00:00:00	1962-11-06	38000177		0	0	14		0	0	0	57468	0	243670	19059056		
130038	2859	40213201	2008-09-15	2008-09-15 00:00:00	2008-09-15	2008-09-15 00:00:00	2008-09-15	581452		0	0	0		0	0	0	189973	0	33	40213201		
182326	4005	40213160	1969-09-27	1969-09-27 00:00:00	1969-09-27	1969-09-27 00:00:00	1969-09-27	581452		0	0	0		0	0	0	266133	0	10	40213160		
8789	732	1127433	1986-07-18	1986-07-18 00:00:00	1986-08-01	1986-08-01 00:00:00	1986-08-01	38000177		0	0	14		0	0	0	48573	0	313782	1127433		
50873	1115	40213227	1992-07-20	1992-07-20 00:00:00	1992-07-20	1992-07-20 00:00:00	1992-07-20	581452		0	0	0		0	0	0	73355	0	113	40213227		
182926	4019	40213296	2003-03-18	2003-03-18 00:00:00	2003-03-18	2003-03-18 00:00:00	2003-03-18	581452		0	0	0		0	0	0	267125	0	52	40213296		
27609	2287	19133768	2001-01-26	2001-01-26 00:00:00	2001-01-26	2001-01-26 00:00:00	2001-01-26	38000177		0	0	0		0	0	0	152152	0	833036	19133768		
87904	1928	40213306	1993-06-16	1993-06-16 00:00:00	1993-06-16	1993-06-16 00:00:00	1993-06-16	581452		0	0	0		0	0	0	\N	0	43	40213306		
80346	1758	40213227	2002-08-30	2002-08-30 00:00:00	2002-08-30	2002-08-30 00:00:00	2002-08-30	581452		0	0	0		0	0	0	117528	0	113	40213227		
105605	2318	40213227	2014-11-01	2014-11-01 00:00:00	2014-11-01	2014-11-01 00:00:00	2014-11-01	581452		0	0	0		0	0	0	154078	0	113	40213227		
2315	186	19133873	1984-11-15	1984-11-15 00:00:00	1984-11-23	1984-11-23 00:00:00	1984-11-23	38000177		0	0	8		0	0	0	12607	0	834061	19133873		
180078	3958	40213227	2011-08-21	2011-08-21 00:00:00	2011-08-21	2011-08-21 00:00:00	2011-08-21	581452		0	0	0		0	0	0	263153	0	113	40213227		
31926	695	40213260	2018-11-26	2018-11-26 00:00:00	2018-11-26	2018-11-26 00:00:00	2018-11-26	581452		0	0	0		0	0	0	46031	0	121	40213260		
19180	1585	1713671	1942-05-28	1942-05-28 00:00:00	1942-06-04	1942-06-04 00:00:00	1942-06-04	38000177		0	0	7		0	0	0	106297	0	562251	1713671		
49364	4094	1127433	2010-09-02	2010-09-02 00:00:00	2010-09-09	2010-09-09 00:00:00	2010-09-09	38000177		0	0	7		0	0	0	272126	0	313782	1127433		
202805	4452	40213260	2006-06-09	2006-06-09 00:00:00	2006-06-09	2006-06-09 00:00:00	2006-06-09	581452		0	0	0		0	0	0	296270	0	121	40213260		
175859	3866	40213227	2000-10-17	2000-10-17 00:00:00	2000-10-17	2000-10-17 00:00:00	2000-10-17	581452		0	0	0		0	0	0	256699	0	113	40213227		
51235	4256	42707627	1963-11-14	1963-11-14 00:00:00	1963-11-14	1963-11-14 00:00:00	1963-11-14	38000177		0	0	0		0	0	0	282589	0	1234995	42707627		
43735	3624	1127433	1983-08-02	1983-08-02 00:00:00	1983-08-09	1983-08-09 00:00:00	1983-08-09	38000177		0	0	7		0	0	0	240945	0	313782	1127433		
214901	4713	40213227	2008-01-18	2008-01-18 00:00:00	2008-01-18	2008-01-18 00:00:00	2008-01-18	581452		0	0	0		0	0	0	313868	0	113	40213227		
61840	5145	1713671	1990-01-23	1990-01-23 00:00:00	1990-02-06	1990-02-06 00:00:00	1990-02-06	38000177		0	0	14		0	0	0	342034	0	562251	1713671		
189857	4168	40213227	2013-04-13	2013-04-13 00:00:00	2013-04-13	2013-04-13 00:00:00	2013-04-13	581452		0	0	0		0	0	0	277056	0	113	40213227		
4446	369	42902245	1998-12-03	1998-12-03 00:00:00	1999-11-28	1999-11-28 00:00:00	1999-11-28	38000177		0	0	360		0	0	0	24545	0	1359133	42902245		
162728	3578	40213227	2015-05-27	2015-05-27 00:00:00	2015-05-27	2015-05-27 00:00:00	2015-05-27	581452		0	0	0		0	0	0	237851	0	113	40213227		
53786	1177	40213306	1986-05-26	1986-05-26 00:00:00	1986-05-26	1986-05-26 00:00:00	1986-05-26	581452		0	0	0		0	0	0	77740	0	43	40213306		
283	6	40213160	1964-09-08	1964-09-08 00:00:00	1964-09-08	1964-09-08 00:00:00	1964-09-08	581452		0	0	0		0	0	0	546	0	10	40213160		
31313	682	40213306	1993-04-21	1993-04-21 00:00:00	1993-04-21	1993-04-21 00:00:00	1993-04-21	581452		0	0	0		0	0	0	45175	0	43	40213306		
20490	1686	1713671	2018-02-22	2018-02-22 00:00:00	2018-03-08	2018-03-08 00:00:00	2018-03-08	38000177		0	0	14		0	0	0	112925	0	562251	1713671		
20521	1689	1127433	1986-06-08	1986-06-08 00:00:00	1986-06-22	1986-06-22 00:00:00	1986-06-22	38000177		0	0	14		0	0	0	113121	0	313782	1127433		
58819	4886	19006318	1968-05-23	1968-05-23 00:00:00	1968-06-06	1968-06-06 00:00:00	1968-06-06	38000177		0	0	14		0	0	0	324892	0	105078	19006318		
58873	4890	40162522	1972-02-17	1972-02-17 00:00:00	1972-02-17	1972-02-17 00:00:00	\N	38000177		0	0	0		0	0	0	325255	0	857005	40162522		
11154	929	1332419	1994-12-26	1994-12-26 00:00:00	1994-12-26	1994-12-26 00:00:00	\N	38000177		0	0	0		0	0	0	61770	0	197361	1332419		
19936	1636	1118084	2000-06-13	2000-06-13 00:00:00	2000-06-13	2000-06-13 00:00:00	\N	38000177		0	0	0		0	0	0	109904	0	00025152531	44923712		
142538	3132	40213160	1963-10-13	1963-10-13 00:00:00	1963-10-13	1963-10-13 00:00:00	1963-10-13	581452		0	0	0		0	0	0	208411	0	10	40213160		
20044	1646	1127433	1956-12-06	1956-12-06 00:00:00	1956-12-20	1956-12-20 00:00:00	1956-12-20	38000177		0	0	14		0	0	0	110376	0	313782	1127433		
46951	3889	19133905	1966-02-25	1966-02-25 00:00:00	1966-03-07	1966-03-07 00:00:00	1966-03-07	38000177		0	0	10		0	0	0	258478	0	834102	19133905		
56341	4675	1127433	1923-01-01	1923-01-01 00:00:00	1923-01-15	1923-01-15 00:00:00	1923-01-15	38000177		0	0	14		0	0	0	311492	0	313782	1127433		
3724	310	19059056	1961-11-26	1961-11-26 00:00:00	1962-02-24	1962-02-24 00:00:00	1962-02-24	38000177		0	0	90		0	0	0	20496	0	243670	19059056		
4767	399	40162522	1969-02-23	1969-02-23 00:00:00	1969-02-23	1969-02-23 00:00:00	\N	38000177		0	0	0		0	0	0	26235	0	857005	40162522		
215762	4732	40213260	2007-08-05	2007-08-05 00:00:00	2007-08-05	2007-08-05 00:00:00	2007-08-05	581452		0	0	0		0	0	0	315284	0	121	40213260		
200588	4405	40213227	1995-05-29	1995-05-29 00:00:00	1995-05-29	1995-05-29 00:00:00	1995-05-29	581452		0	0	0		0	0	0	292844	0	113	40213227		
15343	1281	40236446	1981-12-31	1981-12-31 00:00:00	1988-01-09	1988-01-09 00:00:00	1988-01-09	38000177		0	0	2200		0	0	0	84694	0	1091392	40236446		
18180	1506	19006318	1949-01-30	1949-01-30 00:00:00	1949-02-13	1949-02-13 00:00:00	1949-02-13	38000177		0	0	14		0	0	0	100404	0	105078	19006318		
60761	5051	1713671	1983-04-10	1983-04-10 00:00:00	1983-04-17	1983-04-17 00:00:00	1983-04-17	38000177		0	0	7		0	0	0	335898	0	562251	1713671		
4859	404	1127433	2007-12-24	2007-12-24 00:00:00	2008-01-07	2008-01-07 00:00:00	2008-01-07	38000177		0	0	14		0	0	0	26663	0	313782	1127433		
84131	1840	40213314	1978-03-25	1978-03-25 00:00:00	1978-03-25	1978-03-25 00:00:00	1978-03-25	581452		0	0	0		0	0	0	122801	0	49	40213314		
199598	4384	40213296	2007-04-23	2007-04-23 00:00:00	2007-04-23	2007-04-23 00:00:00	2007-04-23	581452		0	0	0		0	0	0	291382	0	52	40213296		
59054	4907	19059056	1953-03-27	1953-03-27 00:00:00	1953-05-26	1953-05-26 00:00:00	1953-05-26	38000177		0	0	60		0	0	0	326194	0	243670	19059056		
6685	564	1127433	1980-06-10	1980-06-10 00:00:00	1980-07-15	1980-07-15 00:00:00	1980-07-15	38000177		0	0	35		0	0	0	37340	0	313782	1127433		
64288	5335	1127433	1975-08-18	1975-08-18 00:00:00	1975-09-01	1975-09-01 00:00:00	1975-09-01	38000177		0	0	14		0	0	0	355239	0	313782	1127433		
59600	1305	40213227	1995-09-28	1995-09-28 00:00:00	1995-09-28	1995-09-28 00:00:00	1995-09-28	581452		0	0	0		0	0	0	86151	0	113	40213227		
66779	1461	40213296	2006-11-02	2006-11-02 00:00:00	2006-11-02	2006-11-02 00:00:00	2006-11-02	581452		0	0	0		0	0	0	97361	0	52	40213296		
76068	1661	40213160	1956-03-08	1956-03-08 00:00:00	1956-03-08	1956-03-08 00:00:00	1956-03-08	581452		0	0	0		0	0	0	111631	0	10	40213160		
59631	1306	40213227	2007-08-15	2007-08-15 00:00:00	2007-08-15	2007-08-15 00:00:00	2007-08-15	581452		0	0	0		0	0	0	86177	0	113	40213227		
34845	2876	1118084	2004-12-18	2004-12-18 00:00:00	2004-12-18	2004-12-18 00:00:00	\N	38000177		0	0	0		0	0	0	191358	0	00025152531	44923712		
39269	3244	1150837	1991-05-02	1991-05-02 00:00:00	1991-05-02	1991-05-02 00:00:00	\N	38000177		0	0	0		0	0	0	215732	0	141918	1150837		
109662	2409	40213227	2000-12-17	2000-12-17 00:00:00	2000-12-17	2000-12-17 00:00:00	2000-12-17	581452		0	0	0		0	0	0	159928	0	113	40213227		
87791	1926	40213227	2003-01-18	2003-01-18 00:00:00	2003-01-18	2003-01-18 00:00:00	2003-01-18	581452		0	0	0		0	0	0	128215	0	113	40213227		
34026	2813	19018935	2013-10-18	2013-10-18 00:00:00	2013-10-18	2013-10-18 00:00:00	\N	38000177		0	0	0		0	0	0	186458	0	197604	19018935		
240674	5283	40213160	1973-02-13	1973-02-13 00:00:00	1973-02-13	1973-02-13 00:00:00	1973-02-13	581452		0	0	0		0	0	0	351469	0	10	40213160		
15167	1267	1713671	1961-01-13	1961-01-13 00:00:00	1961-01-27	1961-01-27 00:00:00	1961-01-27	38000177		0	0	14		0	0	0	83513	0	562251	1713671		
10301	863	1713671	1994-02-12	1994-02-12 00:00:00	1994-02-19	1994-02-19 00:00:00	1994-02-19	38000177		0	0	7		0	0	0	57169	0	562251	1713671		
93949	2062	40213201	2012-11-17	2012-11-17 00:00:00	2012-11-17	2012-11-17 00:00:00	2012-11-17	581452		0	0	0		0	0	0	137120	0	33	40213201		
130045	2859	40213198	2010-09-27	2010-09-27 00:00:00	2010-09-27	2010-09-27 00:00:00	2010-09-27	581452		0	0	0		0	0	0	189978	0	133	40213198		
182330	4006	40213160	1955-08-16	1955-08-16 00:00:00	1955-08-16	1955-08-16 00:00:00	1955-08-16	581452		0	0	0		0	0	0	266150	0	10	40213160		
8790	732	1713671	2010-11-05	2010-11-05 00:00:00	2010-11-12	2010-11-12 00:00:00	2010-11-12	38000177		0	0	7		0	0	0	48580	0	562251	1713671		
50876	1115	40213198	2013-09-16	2013-09-16 00:00:00	2013-09-16	2013-09-16 00:00:00	2013-09-16	581452		0	0	0		0	0	0	73498	0	133	40213198		
182931	4019	40213227	2014-02-11	2014-02-11 00:00:00	2014-02-11	2014-02-11 00:00:00	2014-02-11	581452		0	0	0		0	0	0	267142	0	113	40213227		
27610	2287	1545959	2001-01-26	2001-01-26 00:00:00	2001-01-26	2001-01-26 00:00:00	2001-01-26	38000177		0	0	0		0	0	0	152152	0	259255	1545959		
87911	1928	40213160	1972-04-12	1972-04-12 00:00:00	1972-04-12	1972-04-12 00:00:00	1972-04-12	581452		0	0	0		0	0	0	128375	0	10	40213160		
80350	1758	40213296	2000-08-25	2000-08-25 00:00:00	2000-08-25	2000-08-25 00:00:00	2000-08-25	581452		0	0	0		0	0	0	117517	0	52	40213296		
105606	2318	40213260	2013-01-26	2013-01-26 00:00:00	2013-01-26	2013-01-26 00:00:00	2013-01-26	581452		0	0	0		0	0	0	154085	0	121	40213260		
2316	186	19128065	1990-10-23	1990-10-23 00:00:00	1991-10-18	1991-10-18 00:00:00	1991-10-18	38000177		0	0	360		0	0	0	12592	0	749882	19128065		
180079	3958	40213260	2011-08-21	2011-08-21 00:00:00	2011-08-21	2011-08-21 00:00:00	2011-08-21	581452		0	0	0		0	0	0	263153	0	121	40213260		
31929	695	40213296	2008-10-27	2008-10-27 00:00:00	2008-10-27	2008-10-27 00:00:00	2008-10-27	581452		0	0	0		0	0	0	45998	0	52	40213296		
19181	1585	1124300	1966-02-04	1966-02-04 00:00:00	1966-02-04	1966-02-04 00:00:00	\N	38000177		0	0	0		0	0	0	106356	0	00781178901	45011828		
49365	4094	1713671	1997-10-26	1997-10-26 00:00:00	1997-11-09	1997-11-09 00:00:00	1997-11-09	38000177		0	0	14		0	0	0	272175	0	562251	1713671		
202807	4452	40213227	2006-06-09	2006-06-09 00:00:00	2006-06-09	2006-06-09 00:00:00	2006-06-09	581452		0	0	0		0	0	0	296270	0	113	40213227		
175867	3866	40213227	2010-12-21	2010-12-21 00:00:00	2010-12-21	2010-12-21 00:00:00	2010-12-21	581452		0	0	0		0	0	0	256717	0	113	40213227		
51236	4256	35605858	1963-11-14	1963-11-14 00:00:00	1963-11-14	1963-11-14 00:00:00	1963-11-14	38000177		0	0	0		0	0	0	282589	0	1732136	35605858		
43736	3624	19006318	1948-08-04	1948-08-04 00:00:00	1948-08-18	1948-08-18 00:00:00	1948-08-18	38000177		0	0	14		0	0	0	240972	0	105078	19006318		
214904	4713	40213227	2017-01-13	2017-01-13 00:00:00	2017-01-13	2017-01-13 00:00:00	2017-01-13	581452		0	0	0		0	0	0	313844	0	113	40213227		
61841	5145	1118084	1991-04-24	1991-04-24 00:00:00	1991-04-24	1991-04-24 00:00:00	\N	38000177		0	0	0		0	0	0	342034	0	00025152531	44923712		
189858	4168	40213296	2013-04-13	2013-04-13 00:00:00	2013-04-13	2013-04-13 00:00:00	2013-04-13	581452		0	0	0		0	0	0	277056	0	52	40213296		
4447	369	1127433	2014-09-18	2014-09-18 00:00:00	2014-10-02	2014-10-02 00:00:00	2014-10-02	38000177		0	0	14		0	0	0	24525	0	313782	1127433		
162729	3578	40213160	1973-01-10	1973-01-10 00:00:00	1973-01-10	1973-01-10 00:00:00	1973-01-10	581452		0	0	0		0	0	0	237871	0	10	40213160		
53788	1177	40213260	2014-05-05	2014-05-05 00:00:00	2014-05-05	2014-05-05 00:00:00	2014-05-05	581452		0	0	0		0	0	0	77744	0	121	40213260		
290	6	40213227	2006-01-10	2006-01-10 00:00:00	2006-01-10	2006-01-10 00:00:00	2006-01-10	581452		0	0	0		0	0	0	597	0	113	40213227		
31315	682	40213227	1993-04-21	1993-04-21 00:00:00	1993-04-21	1993-04-21 00:00:00	1993-04-21	581452		0	0	0		0	0	0	45175	0	113	40213227		
20491	1686	19059056	1964-08-30	1964-08-30 00:00:00	1964-09-13	1964-09-13 00:00:00	1964-09-13	38000177		0	0	14		0	0	0	112975	0	243670	19059056		
20522	1689	40229134	1959-10-21	1959-10-21 00:00:00	1959-11-04	1959-11-04 00:00:00	1959-11-04	38000177		0	0	14		0	0	0	113078	0	1043400	40229134		
58820	4886	1127078	1968-05-23	1968-05-23 00:00:00	1968-06-06	1968-06-06 00:00:00	1968-06-06	38000177		0	0	14		0	0	0	324892	0	282464	1127078		
58874	4890	1713671	1998-02-17	1998-02-17 00:00:00	1998-03-03	1998-03-03 00:00:00	1998-03-03	38000177		0	0	14		0	0	0	325249	0	562251	1713671		
11155	929	19059056	1924-08-15	1924-08-15 00:00:00	1924-08-29	1924-08-29 00:00:00	1924-08-29	38000177		0	0	14		0	0	0	61762	0	243670	19059056		
19937	1636	40229134	1963-08-03	1963-08-03 00:00:00	1963-08-10	1963-08-10 00:00:00	1963-08-10	38000177		0	0	7		0	0	0	109861	0	1043400	40229134		
204481	4488	40213227	2018-12-14	2018-12-14 00:00:00	2018-12-14	2018-12-14 00:00:00	2018-12-14	581452		0	0	0		0	0	0	298786	0	113	40213227		
20045	1646	1127433	1946-01-14	1946-01-14 00:00:00	1946-01-28	1946-01-28 00:00:00	1946-01-28	38000177		0	0	14		0	0	0	110352	0	313782	1127433		
46952	3889	1124300	1976-03-21	1976-03-21 00:00:00	1976-03-21	1976-03-21 00:00:00	\N	38000177		0	0	0		0	0	0	258465	0	00781178901	45011828		
56342	4675	1127433	1971-11-28	1971-11-28 00:00:00	1971-12-05	1971-12-05 00:00:00	1971-12-05	38000177		0	0	7		0	0	0	311549	0	313782	1127433		
3725	310	1713671	1973-10-26	1973-10-26 00:00:00	1973-11-23	1973-11-23 00:00:00	1973-11-23	38000177		0	0	28		0	0	0	20559	0	562251	1713671		
4768	399	19059056	1969-02-23	1969-02-23 00:00:00	1969-03-25	1969-03-25 00:00:00	1969-03-25	38000177		0	0	30		0	0	0	26235	0	243670	19059056		
215764	4732	40213160	1956-01-01	1956-01-01 00:00:00	1956-01-01	1956-01-01 00:00:00	1956-01-01	581452		0	0	0		0	0	0	315292	0	10	40213160		
200591	4405	40213296	2004-05-17	2004-05-17 00:00:00	2004-05-17	2004-05-17 00:00:00	2004-05-17	581452		0	0	0		0	0	0	292817	0	52	40213296		
15344	1281	1713671	1991-09-07	1991-09-07 00:00:00	1992-01-25	1992-01-25 00:00:00	1992-01-25	38000177		0	0	140		0	0	0	84664	0	562251	1713671		
18181	1506	19133905	1972-09-05	1972-09-05 00:00:00	1972-09-15	1972-09-15 00:00:00	1972-09-15	38000177		0	0	10		0	0	0	100398	0	834102	19133905		
60762	5051	1713671	1997-08-06	1997-08-06 00:00:00	1997-08-20	1997-08-20 00:00:00	1997-08-20	38000177		0	0	14		0	0	0	335837	0	562251	1713671		
4860	406	1127433	1987-06-15	1987-06-15 00:00:00	1987-06-29	1987-06-29 00:00:00	1987-06-29	38000177		0	0	14		0	0	0	26814	0	313782	1127433		
84133	1840	40213227	2006-08-05	2006-08-05 00:00:00	2006-08-05	2006-08-05 00:00:00	2006-08-05	581452		0	0	0		0	0	0	122810	0	113	40213227		
199602	4384	40213227	1998-12-21	1998-12-21 00:00:00	1998-12-21	1998-12-21 00:00:00	1998-12-21	581452		0	0	0		0	0	0	291375	0	113	40213227		
59055	4907	1713671	2005-07-29	2005-07-29 00:00:00	2005-08-05	2005-08-05 00:00:00	2005-08-05	38000177		0	0	7		0	0	0	326101	0	562251	1713671		
6686	564	1713671	1975-04-28	1975-04-28 00:00:00	1975-05-19	1975-05-19 00:00:00	1975-05-19	38000177		0	0	21		0	0	0	37365	0	562251	1713671		
64289	5335	1127433	1981-09-29	1981-09-29 00:00:00	1981-10-27	1981-10-27 00:00:00	1981-10-27	38000177		0	0	28		0	0	0	355240	0	313782	1127433		
72891	1593	40213227	1995-11-02	1995-11-02 00:00:00	1995-11-02	1995-11-02 00:00:00	1995-11-02	581452		0	0	0		0	0	0	106935	0	113	40213227		
66785	1461	40213227	1998-01-08	1998-01-08 00:00:00	1998-01-08	1998-01-08 00:00:00	1998-01-08	581452		0	0	0		0	0	0	97358	0	113	40213227		
76071	1661	40213227	1998-02-26	1998-02-26 00:00:00	1998-02-26	1998-02-26 00:00:00	1998-02-26	581452		0	0	0		0	0	0	111704	0	113	40213227		
59632	1306	40213260	2007-08-15	2007-08-15 00:00:00	2007-08-15	2007-08-15 00:00:00	2007-08-15	581452		0	0	0		0	0	0	86177	0	121	40213260		
34846	2876	920300	2004-10-24	2004-10-24 00:00:00	2004-10-31	2004-10-31 00:00:00	2004-10-31	38000177		0	0	7		0	0	0	191358	0	311989	920300		
39270	3244	19078461	1997-05-24	1997-05-24 00:00:00	1997-06-28	1997-06-28 00:00:00	1997-06-28	38000177		0	0	35		0	0	0	215746	0	310965	19078461		
109663	2409	40213306	2000-12-17	2000-12-17 00:00:00	2000-12-17	2000-12-17 00:00:00	2000-12-17	581452		0	0	0		0	0	0	159928	0	43	40213306		
87799	1926	40213227	1992-08-15	1992-08-15 00:00:00	1992-08-15	1992-08-15 00:00:00	1992-08-15	581452		0	0	0		0	0	0	128229	0	113	40213227		
34027	2813	40171902	2013-10-18	2013-10-18 00:00:00	2013-10-18	2013-10-18 00:00:00	\N	38000177		0	0	0		0	0	0	186458	0	897718	40171902		
240677	5283	40213296	2014-04-22	2014-04-22 00:00:00	2014-04-22	2014-04-22 00:00:00	2014-04-22	581452		0	0	0		0	0	0	351475	0	52	40213296		
15168	1267	40236824	1996-05-27	1996-05-27 00:00:00	1996-06-03	1996-06-03 00:00:00	1996-06-03	38000177		0	0	7		0	0	0	83575	0	1094107	40236824		
10302	863	19059056	1923-01-24	1923-01-24 00:00:00	1923-02-07	1923-02-07 00:00:00	1923-02-07	38000177		0	0	14		0	0	0	57145	0	243670	19059056		
93954	2062	40213198	2011-11-12	2011-11-12 00:00:00	2011-11-12	2011-11-12 00:00:00	2011-11-12	581452		0	0	0		0	0	0	137138	0	133	40213198		
130058	2859	40213227	1993-06-21	1993-06-21 00:00:00	1993-06-21	1993-06-21 00:00:00	1993-06-21	581452		0	0	0		0	0	0	189976	0	113	40213227		
93143	2044	40213260	2011-10-15	2011-10-15 00:00:00	2011-10-15	2011-10-15 00:00:00	2011-10-15	581452		0	0	0		0	0	0	135990	0	121	40213260		
8791	733	1127433	1992-01-08	1992-01-08 00:00:00	1992-02-05	1992-02-05 00:00:00	1992-02-05	38000177		0	0	28		0	0	0	48598	0	313782	1127433		
50882	1115	40213227	1999-08-16	1999-08-16 00:00:00	1999-08-16	1999-08-16 00:00:00	1999-08-16	581452		0	0	0		0	0	0	73356	0	113	40213227		
182932	4019	40213260	2014-02-11	2014-02-11 00:00:00	2014-02-11	2014-02-11 00:00:00	2014-02-11	581452		0	0	0		0	0	0	267142	0	121	40213260		
27611	2287	19075601	2001-05-04	2001-05-04 00:00:00	2001-05-04	2001-05-04 00:00:00	\N	38000177		0	0	0		0	0	0	152164	0	309362	19075601		
87912	1928	40213296	2013-06-12	2013-06-12 00:00:00	2013-06-12	2013-06-12 00:00:00	2013-06-12	581452		0	0	0		0	0	0	128330	0	52	40213296		
80354	1758	40213227	1992-05-22	1992-05-22 00:00:00	1992-05-22	1992-05-22 00:00:00	1992-05-22	581452		0	0	0		0	0	0	117516	0	113	40213227		
149964	3298	40213160	1972-01-23	1972-01-23 00:00:00	1972-01-23	1972-01-23 00:00:00	1972-01-23	581452		0	0	0		0	0	0	219166	0	10	40213160		
2317	186	40236824	2012-12-22	2012-12-22 00:00:00	2012-12-29	2012-12-29 00:00:00	2012-12-29	38000177		0	0	7		0	0	0	12599	0	1094107	40236824		
180085	3958	40213160	1960-11-20	1960-11-20 00:00:00	1960-11-20	1960-11-20 00:00:00	1960-11-20	581452		0	0	0		0	0	0	263151	0	10	40213160		
31931	695	40213160	1969-03-31	1969-03-31 00:00:00	1969-03-31	1969-03-31 00:00:00	1969-03-31	581452		0	0	0		0	0	0	46034	0	10	40213160		
19182	1585	40165015	1959-12-09	1959-12-09 00:00:00	1959-12-09	1959-12-09 00:00:00	\N	38000177		0	0	0		0	0	0	106347	0	861467	40165015		
49366	4094	19133873	1957-10-15	1957-10-15 00:00:00	1957-10-24	1957-10-24 00:00:00	1957-10-24	38000177		0	0	9		0	0	0	272113	0	834061	19133873		
214087	4694	40213251	1984-01-15	1984-01-15 00:00:00	1984-01-15	1984-01-15 00:00:00	1984-01-15	581452		0	0	0		0	0	0	312724	0	21	40213251		
153081	3370	40213160	1973-06-03	1973-06-03 00:00:00	1973-06-03	1973-06-03 00:00:00	1973-06-03	581452		0	0	0		0	0	0	223475	0	10	40213160		
51237	4256	782047	1963-11-14	1963-11-14 00:00:00	1963-11-14	1963-11-14 00:00:00	1963-11-14	38000177		0	0	0		0	0	0	282589	0	542347	782047		
66080	1446	40213227	2016-09-27	2016-09-27 00:00:00	2016-09-27	2016-09-27 00:00:00	2016-09-27	581452		0	0	0		0	0	0	96396	0	113	40213227		
214905	4713	40213260	2017-01-13	2017-01-13 00:00:00	2017-01-13	2017-01-13 00:00:00	2017-01-13	581452		0	0	0		0	0	0	313844	0	121	40213260		
61842	5145	19059056	1960-11-07	1960-11-07 00:00:00	1960-11-21	1960-11-21 00:00:00	1960-11-21	38000177		0	0	14		0	0	0	342067	0	243670	19059056		
97655	2140	40213201	2017-09-06	2017-09-06 00:00:00	2017-09-06	2017-09-06 00:00:00	2017-09-06	581452		0	0	0		0	0	0	142525	0	33	40213201		
4448	369	1127433	2009-03-22	2009-03-22 00:00:00	2009-03-29	2009-03-29 00:00:00	2009-03-29	38000177		0	0	7		0	0	0	24529	0	313782	1127433		
26297	2164	1127433	1979-05-12	1979-05-12 00:00:00	1979-05-26	1979-05-26 00:00:00	1979-05-26	38000177		0	0	14		0	0	0	144136	0	313782	1127433		
53790	1177	40213227	2014-05-05	2014-05-05 00:00:00	2014-05-05	2014-05-05 00:00:00	2014-05-05	581452		0	0	0		0	0	0	77744	0	113	40213227		
291	6	40213296	2006-01-10	2006-01-10 00:00:00	2006-01-10	2006-01-10 00:00:00	2006-01-10	581452		0	0	0		0	0	0	597	0	52	40213296		
31317	682	40213227	2002-05-01	2002-05-01 00:00:00	2002-05-01	2002-05-01 00:00:00	2002-05-01	581452		0	0	0		0	0	0	45201	0	113	40213227		
20492	1686	19133905	1991-10-23	1991-10-23 00:00:00	1991-11-01	1991-11-01 00:00:00	1991-11-01	38000177		0	0	9		0	0	0	112933	0	834102	19133905		
20523	1689	1118084	1984-05-06	1984-05-06 00:00:00	1984-05-06	1984-05-06 00:00:00	\N	38000177		0	0	0		0	0	0	113101	0	00025152531	44923712		
58821	4886	1118084	2002-04-15	2002-04-15 00:00:00	2002-04-15	2002-04-15 00:00:00	\N	38000177		0	0	0		0	0	0	324945	0	00025152531	44923712		
58875	4890	19059056	1924-08-24	1924-08-24 00:00:00	1924-09-07	1924-09-07 00:00:00	1924-09-07	38000177		0	0	14		0	0	0	325191	0	243670	19059056		
11156	929	19059056	1947-05-23	1947-05-23 00:00:00	1947-06-27	1947-06-27 00:00:00	1947-06-27	38000177		0	0	35		0	0	0	61755	0	243670	19059056		
19938	1636	1127078	1967-05-13	1967-05-13 00:00:00	1967-06-10	1967-06-10 00:00:00	1967-06-10	38000177		0	0	28		0	0	0	109882	0	282464	1127078		
204482	4488	40213296	2018-12-14	2018-12-14 00:00:00	2018-12-14	2018-12-14 00:00:00	2018-12-14	581452		0	0	0		0	0	0	298786	0	52	40213296		
20046	1646	19059056	1943-09-16	1943-09-16 00:00:00	1943-10-07	1943-10-07 00:00:00	1943-10-07	38000177		0	0	21		0	0	0	110447	0	243670	19059056		
46953	3889	1127433	2004-03-09	2004-03-09 00:00:00	2004-03-16	2004-03-16 00:00:00	2004-03-16	38000177		0	0	7		0	0	0	258456	0	313782	1127433		
56343	4675	1713671	2007-08-29	2007-08-29 00:00:00	2007-09-12	2007-09-12 00:00:00	2007-09-12	38000177		0	0	14		0	0	0	311442	0	562251	1713671		
3726	310	19133905	1998-01-28	1998-01-28 00:00:00	1998-02-08	1998-02-08 00:00:00	1998-02-08	38000177		0	0	11		0	0	0	20508	0	834102	19133905		
4769	399	40232448	1958-04-23	1958-04-23 00:00:00	1958-04-23	1958-04-23 00:00:00	\N	38000177		0	0	0		0	0	0	26107	0	1049630	40232448		
215766	4732	40213160	1955-10-30	1955-10-30 00:00:00	1955-10-30	1955-10-30 00:00:00	1955-10-30	581452		0	0	0		0	0	0	315255	0	10	40213160		
200592	4405	40213160	1968-11-04	1968-11-04 00:00:00	1968-11-04	1968-11-04 00:00:00	1968-11-04	581452		0	0	0		0	0	0	292803	0	10	40213160		
15345	1281	1115171	2002-10-12	2002-10-12 00:00:00	2002-11-02	2002-11-02 00:00:00	2002-11-02	38000177		0	0	21		0	0	0	84704	0	849574	1115171		
18182	1506	1127078	1952-08-29	1952-08-29 00:00:00	1952-10-05	1952-10-05 00:00:00	1952-10-05	38000177		0	0	37		0	0	0	100393	0	282464	1127078		
60763	5051	19075001	1983-09-15	1983-09-15 00:00:00	1983-09-29	1983-09-29 00:00:00	1983-09-29	38000177		0	0	14		0	0	0	335892	0	309097	19075001		
4861	406	1124300	1996-06-27	1996-06-27 00:00:00	1996-06-27	1996-06-27 00:00:00	\N	38000177		0	0	0		0	0	0	26865	0	00781178901	45011828		
162386	3571	40213160	1972-05-02	1972-05-02 00:00:00	1972-05-02	1972-05-02 00:00:00	1972-05-02	581452		0	0	0		0	0	0	237366	0	10	40213160		
199603	4384	40213160	1967-07-24	1967-07-24 00:00:00	1967-07-24	1967-07-24 00:00:00	1967-07-24	581452		0	0	0		0	0	0	291421	0	10	40213160		
59056	4907	1127433	2004-09-07	2004-09-07 00:00:00	2004-09-14	2004-09-14 00:00:00	2004-09-14	38000177		0	0	7		0	0	0	326175	0	313782	1127433		
6687	564	40236824	1991-11-10	1991-11-10 00:00:00	1991-11-17	1991-11-17 00:00:00	1991-11-17	38000177		0	0	7		0	0	0	37324	0	1094107	40236824		
64290	5335	1713671	1973-05-18	1973-05-18 00:00:00	1973-06-08	1973-06-08 00:00:00	1973-06-08	38000177		0	0	21		0	0	0	355260	0	562251	1713671		
72893	1593	40213227	2005-12-29	2005-12-29 00:00:00	2005-12-29	2005-12-29 00:00:00	2005-12-29	581452		0	0	0		0	0	0	106883	0	113	40213227		
66787	1461	40213227	2017-11-02	2017-11-02 00:00:00	2017-11-02	2017-11-02 00:00:00	2017-11-02	581452		0	0	0		0	0	0	97378	0	113	40213227		
76072	1661	40213296	1998-02-26	1998-02-26 00:00:00	1998-02-26	1998-02-26 00:00:00	1998-02-26	581452		0	0	0		0	0	0	111704	0	52	40213296		
59651	1306	40213160	1957-04-17	1957-04-17 00:00:00	1957-04-17	1957-04-17 00:00:00	1957-04-17	581452		0	0	0		0	0	0	86206	0	10	40213160		
199860	4390	40213260	2010-01-15	2010-01-15 00:00:00	2010-01-15	2010-01-15 00:00:00	2010-01-15	581452		0	0	0		0	0	0	291869	0	121	40213260		
39271	3244	19128065	1995-03-04	1995-03-04 00:00:00	1996-02-27	1996-02-27 00:00:00	1996-02-27	38000177		0	0	360		0	0	0	215690	0	749882	19128065		
109666	2409	40213314	1979-12-09	1979-12-09 00:00:00	1979-12-09	1979-12-09 00:00:00	1979-12-09	581452		0	0	0		0	0	0	159948	0	49	40213314		
87800	1926	40213306	1992-08-15	1992-08-15 00:00:00	1992-08-15	1992-08-15 00:00:00	1992-08-15	581452		0	0	0		0	0	0	128229	0	43	40213306		
34028	2813	40163554	2013-10-18	2013-10-18 00:00:00	2013-10-18	2013-10-18 00:00:00	\N	38000177		0	0	0		0	0	0	186458	0	855332	40163554		
240679	5283	40213227	2014-04-22	2014-04-22 00:00:00	2014-04-22	2014-04-22 00:00:00	2014-04-22	581452		0	0	0		0	0	0	351475	0	113	40213227		
15169	1267	920300	1996-05-27	1996-05-27 00:00:00	1996-06-03	1996-06-03 00:00:00	1996-06-03	38000177		0	0	7		0	0	0	83575	0	311989	920300		
10303	863	40220960	2014-07-03	2014-07-03 00:00:00	2014-07-03	2014-07-03 00:00:00	2014-07-03	38000177		0	0	0		0	0	0	57181	0	1804799	40220960		
93957	2062	40213227	1997-08-23	1997-08-23 00:00:00	1997-08-23	1997-08-23 00:00:00	1997-08-23	581452		0	0	0		0	0	0	137146	0	113	40213227		
130069	2859	40213227	2003-08-18	2003-08-18 00:00:00	2003-08-18	2003-08-18 00:00:00	2003-08-18	581452		0	0	0		0	0	0	190043	0	113	40213227		
93145	2044	40213227	2012-10-20	2012-10-20 00:00:00	2012-10-20	2012-10-20 00:00:00	2012-10-20	581452		0	0	0		0	0	0	136022	0	113	40213227		
8792	733	19059056	1948-07-29	1948-07-29 00:00:00	1948-08-26	1948-08-26 00:00:00	1948-08-26	38000177		0	0	28		0	0	0	48596	0	243670	19059056		
50884	1115	40213201	2014-11-17	2014-11-17 00:00:00	2014-11-17	2014-11-17 00:00:00	2014-11-17	581452		0	0	0		0	0	0	73402	0	33	40213201		
182933	4019	40213160	1963-03-05	1963-03-05 00:00:00	1963-03-05	1963-03-05 00:00:00	1963-03-05	581452		0	0	0		0	0	0	267155	0	10	40213160		
27612	2287	19126352	2001-05-04	2001-05-04 00:00:00	2001-05-04	2001-05-04 00:00:00	\N	38000177		0	0	0		0	0	0	152164	0	705129	19126352		
87914	1928	40213227	2013-06-12	2013-06-12 00:00:00	2013-06-12	2013-06-12 00:00:00	2013-06-12	581452		0	0	0		0	0	0	128330	0	113	40213227		
80365	1758	40213160	1965-07-30	1965-07-30 00:00:00	1965-07-30	1965-07-30 00:00:00	1965-07-30	581452		0	0	0		0	0	0	117524	0	10	40213160		
149970	3298	40213227	2003-06-29	2003-06-29 00:00:00	2003-06-29	2003-06-29 00:00:00	2003-06-29	581452		0	0	0		0	0	0	219159	0	113	40213227		
2318	186	920300	2012-12-22	2012-12-22 00:00:00	2012-12-29	2012-12-29 00:00:00	2012-12-29	38000177		0	0	7		0	0	0	12599	0	311989	920300		
180088	3958	40213160	1961-01-22	1961-01-22 00:00:00	1961-01-22	1961-01-22 00:00:00	1961-01-22	581452		0	0	0		0	0	0	263159	0	10	40213160		
196127	4309	40213160	1955-04-13	1955-04-13 00:00:00	1955-04-13	1955-04-13 00:00:00	1955-04-13	581452		0	0	0		0	0	0	285874	0	10	40213160		
19183	1585	19059056	1959-12-09	1959-12-09 00:00:00	1959-12-23	1959-12-23 00:00:00	1959-12-23	38000177		0	0	14		0	0	0	106347	0	243670	19059056		
49367	4094	19059056	1959-09-02	1959-09-02 00:00:00	1959-11-01	1959-11-01 00:00:00	1959-11-01	38000177		0	0	60		0	0	0	272189	0	243670	19059056		
214088	4694	40213314	1981-11-15	1981-11-15 00:00:00	1981-11-15	1981-11-15 00:00:00	1981-11-15	581452		0	0	0		0	0	0	312776	0	49	40213314		
153083	3370	40213227	1994-11-27	1994-11-27 00:00:00	1994-11-27	1994-11-27 00:00:00	1994-11-27	581452		0	0	0		0	0	0	223446	0	113	40213227		
51238	4256	46275444	1963-11-14	1963-11-14 00:00:00	1963-11-14	1963-11-14 00:00:00	1963-11-14	38000177		0	0	0		0	0	0	282589	0	1659149	46275444		
66081	1446	40213251	1988-10-11	1988-10-11 00:00:00	1988-10-11	1988-10-11 00:00:00	1988-10-11	581452		0	0	0		0	0	0	96408	0	21	40213251		
214906	4713	40213160	1966-06-17	1966-06-17 00:00:00	1966-06-17	1966-06-17 00:00:00	1966-06-17	581452		0	0	0		0	0	0	313817	0	10	40213160		
61843	5145	19006318	1959-03-14	1959-03-14 00:00:00	1959-03-28	1959-03-28 00:00:00	1959-03-28	38000177		0	0	14		0	0	0	342031	0	105078	19006318		
97657	2140	40213160	1955-05-11	1955-05-11 00:00:00	1955-05-11	1955-05-11 00:00:00	1955-05-11	581452		0	0	0		0	0	0	142575	0	10	40213160		
4449	369	42902245	1999-11-28	1999-11-28 00:00:00	2000-11-22	2000-11-22 00:00:00	2000-11-22	38000177		0	0	360		0	0	0	24546	0	1359133	42902245		
26298	2164	1127433	2018-12-26	2018-12-26 00:00:00	2019-01-09	2019-01-09 00:00:00	2019-01-09	38000177		0	0	14		0	0	0	144126	0	313782	1127433		
53791	1177	40213306	1983-05-23	1983-05-23 00:00:00	1983-05-23	1983-05-23 00:00:00	1983-05-23	581452		0	0	0		0	0	0	77771	0	43	40213306		
293	6	40213160	1964-04-07	1964-04-07 00:00:00	1964-04-07	1964-04-07 00:00:00	1964-04-07	581452		0	0	0		0	0	0	545	0	10	40213160		
31322	682	40213296	2013-01-02	2013-01-02 00:00:00	2013-01-02	2013-01-02 00:00:00	2013-01-02	581452		0	0	0		0	0	0	45204	0	52	40213296		
20493	1686	1713671	1998-05-03	1998-05-03 00:00:00	1998-07-19	1998-07-19 00:00:00	1998-07-19	38000177		0	0	77		0	0	0	112934	0	562251	1713671		
20524	1689	19133873	1953-01-07	1953-01-07 00:00:00	1953-01-19	1953-01-19 00:00:00	1953-01-19	38000177		0	0	12		0	0	0	113066	0	834061	19133873		
58822	4886	40236824	1987-09-27	1987-09-27 00:00:00	1987-10-04	1987-10-04 00:00:00	1987-10-04	38000177		0	0	7		0	0	0	324876	0	1094107	40236824		
58876	4890	1127433	1951-06-16	1951-06-16 00:00:00	1951-06-30	1951-06-30 00:00:00	1951-06-30	38000177		0	0	14		0	0	0	325196	0	313782	1127433		
11157	929	19006318	1947-05-23	1947-05-23 00:00:00	1947-06-27	1947-06-27 00:00:00	1947-06-27	38000177		0	0	35		0	0	0	61755	0	105078	19006318		
19939	1636	1127433	2019-02-16	2019-02-16 00:00:00	2019-03-02	2019-03-02 00:00:00	2019-03-02	38000177		0	0	14		0	0	0	109872	0	313782	1127433		
204484	4488	40213160	1981-01-02	1981-01-02 00:00:00	1981-01-02	1981-01-02 00:00:00	1981-01-02	581452		0	0	0		0	0	0	298816	0	10	40213160		
20047	1646	1127433	2010-12-12	2010-12-12 00:00:00	2010-12-19	2010-12-19 00:00:00	2010-12-19	38000177		0	0	7		0	0	0	110382	0	313782	1127433		
46954	3889	1127433	2010-05-04	2010-05-04 00:00:00	2010-05-18	2010-05-18 00:00:00	2010-05-18	38000177		0	0	14		0	0	0	258518	0	313782	1127433		
56344	4675	19059056	1917-01-01	1917-01-01 00:00:00	1917-01-15	1917-01-15 00:00:00	1917-01-15	38000177		0	0	14		0	0	0	311502	0	243670	19059056		
3727	310	1713671	1952-08-08	1952-08-08 00:00:00	1953-01-16	1953-01-16 00:00:00	1953-01-16	38000177		0	0	161		0	0	0	20501	0	562251	1713671		
4770	399	19133905	1979-09-17	1979-09-17 00:00:00	1979-09-27	1979-09-27 00:00:00	1979-09-27	38000177		0	0	10		0	0	0	26253	0	834102	19133905		
215775	4732	40213227	2006-07-30	2006-07-30 00:00:00	2006-07-30	2006-07-30 00:00:00	2006-07-30	581452		0	0	0		0	0	0	315304	0	113	40213227		
200601	4405	40213306	1986-05-19	1986-05-19 00:00:00	1986-05-19	1986-05-19 00:00:00	1986-05-19	581452		0	0	0		0	0	0	292823	0	43	40213306		
15346	1281	1127433	1997-11-30	1997-11-30 00:00:00	1997-12-07	1997-12-07 00:00:00	1997-12-07	38000177		0	0	7		0	0	0	84687	0	313782	1127433		
50229	4167	19133873	1981-11-18	1981-11-18 00:00:00	1981-11-29	1981-11-29 00:00:00	1981-11-29	38000177		0	0	11		0	0	0	276980	0	834061	19133873		
60764	5051	1127433	1986-10-09	1986-10-09 00:00:00	1986-10-16	1986-10-16 00:00:00	1986-10-16	38000177		0	0	7		0	0	0	335895	0	313782	1127433		
4862	406	1127433	1966-02-06	1966-02-06 00:00:00	1966-02-20	1966-02-20 00:00:00	1966-02-20	38000177		0	0	14		0	0	0	26829	0	313782	1127433		
162396	3571	40213160	1972-02-01	1972-02-01 00:00:00	1972-02-01	1972-02-01 00:00:00	1972-02-01	581452		0	0	0		0	0	0	237307	0	10	40213160		
199606	4384	40213227	2008-12-08	2008-12-08 00:00:00	2008-12-08	2008-12-08 00:00:00	2008-12-08	581452		0	0	0		0	0	0	291372	0	113	40213227		
59057	4907	1127433	1951-02-21	1951-02-21 00:00:00	1951-03-07	1951-03-07 00:00:00	1951-03-07	38000177		0	0	14		0	0	0	326169	0	313782	1127433		
6688	564	40169281	1991-10-24	1991-10-24 00:00:00	1991-10-24	1991-10-24 00:00:00	\N	38000177		0	0	0		0	0	0	37324	0	896209	40169281		
64291	5335	1127433	1980-03-30	1980-03-30 00:00:00	1980-04-06	1980-04-06 00:00:00	1980-04-06	38000177		0	0	7		0	0	0	355304	0	313782	1127433		
198372	4359	40213227	2004-07-14	2004-07-14 00:00:00	2004-07-14	2004-07-14 00:00:00	2004-07-14	581452		0	0	0		0	0	0	289204	0	113	40213227		
66788	1461	40213260	2017-11-02	2017-11-02 00:00:00	2017-11-02	2017-11-02 00:00:00	2017-11-02	581452		0	0	0		0	0	0	97378	0	121	40213260		
76074	1661	40213296	1996-02-22	1996-02-22 00:00:00	1996-02-22	1996-02-22 00:00:00	1996-02-22	581452		0	0	0		0	0	0	111678	0	52	40213296		
59661	1306	40213160	1961-06-07	1961-06-07 00:00:00	1961-06-07	1961-06-07 00:00:00	1961-06-07	581452		0	0	0		0	0	0	86226	0	10	40213160		
199864	4390	40213160	1963-12-06	1963-12-06 00:00:00	1963-12-06	1963-12-06 00:00:00	1963-12-06	581452		0	0	0		0	0	0	291863	0	10	40213160		
39272	3244	1124300	2013-07-27	2013-07-27 00:00:00	2013-07-27	2013-07-27 00:00:00	\N	38000177		0	0	0		0	0	0	215733	0	00781178901	45011828		
109670	2409	40213251	1984-09-16	1984-09-16 00:00:00	1984-09-16	1984-09-16 00:00:00	1984-09-16	581452		0	0	0		0	0	0	159908	0	21	40213251		
87803	1926	40213296	2013-02-02	2013-02-02 00:00:00	2013-02-02	2013-02-02 00:00:00	2013-02-02	581452		0	0	0		0	0	0	128222	0	52	40213296		
34029	2813	1127433	1940-05-27	1940-05-27 00:00:00	1940-06-03	1940-06-03 00:00:00	1940-06-03	38000177		0	0	7		0	0	0	186406	0	313782	1127433		
240691	5283	40213306	1996-08-20	1996-08-20 00:00:00	1996-08-20	1996-08-20 00:00:00	1996-08-20	581452		0	0	0		0	0	0	351452	0	43	40213306		
15170	1267	1127433	2004-02-26	2004-02-26 00:00:00	2004-03-11	2004-03-11 00:00:00	2004-03-11	38000177		0	0	14		0	0	0	83521	0	313782	1127433		
10304	863	1332419	1994-04-14	1994-04-14 00:00:00	1994-04-14	1994-04-14 00:00:00	\N	38000177		0	0	0		0	0	0	57186	0	197361	1332419		
105255	2309	40213160	1973-09-07	1973-09-07 00:00:00	1973-09-07	1973-09-07 00:00:00	1973-09-07	581452		0	0	0		0	0	0	153654	0	10	40213160		
3872	84	40213227	1995-08-10	1995-08-10 00:00:00	1995-08-10	1995-08-10 00:00:00	1995-08-10	581452		0	0	0		0	0	0	\N	0	113	40213227		
93146	2044	40213260	2012-10-20	2012-10-20 00:00:00	2012-10-20	2012-10-20 00:00:00	2012-10-20	581452		0	0	0		0	0	0	136022	0	121	40213260		
8793	733	1115171	2016-05-03	2016-05-03 00:00:00	2016-05-17	2016-05-17 00:00:00	2016-05-17	38000177		0	0	14		0	0	0	48611	0	849574	1115171		
50892	1115	40213227	2009-12-21	2009-12-21 00:00:00	2009-12-21	2009-12-21 00:00:00	2009-12-21	581452		0	0	0		0	0	0	73398	0	113	40213227		
182935	4019	40213260	2013-03-19	2013-03-19 00:00:00	2013-03-19	2013-03-19 00:00:00	2013-03-19	581452		0	0	0		0	0	0	267150	0	121	40213260		
27613	2287	1127433	1969-07-19	1969-07-19 00:00:00	1969-08-18	1969-08-18 00:00:00	1969-08-18	38000177		0	0	30		0	0	0	152150	0	313782	1127433		
144076	3167	40213160	1965-05-16	1965-05-16 00:00:00	1965-05-16	1965-05-16 00:00:00	1965-05-16	581452		0	0	0		0	0	0	210575	0	10	40213160		
80367	1758	40213160	1960-11-25	1960-11-25 00:00:00	1960-11-25	1960-11-25 00:00:00	1960-11-25	581452		0	0	0		0	0	0	117560	0	10	40213160		
149976	3298	40213296	2011-09-18	2011-09-18 00:00:00	2011-09-18	2011-09-18 00:00:00	2011-09-18	581452		0	0	0		0	0	0	219139	0	52	40213296		
2319	186	1713671	1982-05-10	1982-05-10 00:00:00	1982-05-17	1982-05-17 00:00:00	1982-05-17	38000177		0	0	7		0	0	0	12614	0	562251	1713671		
180090	3958	40213227	1992-03-29	1992-03-29 00:00:00	1992-03-29	1992-03-29 00:00:00	1992-03-29	581452		0	0	0		0	0	0	263168	0	113	40213227		
196131	4309	40213227	2005-09-28	2005-09-28 00:00:00	2005-09-28	2005-09-28 00:00:00	2005-09-28	581452		0	0	0		0	0	0	285882	0	113	40213227		
19184	1585	19006318	1959-12-09	1959-12-09 00:00:00	1959-12-23	1959-12-23 00:00:00	1959-12-23	38000177		0	0	14		0	0	0	106347	0	105078	19006318		
49368	4094	40229134	1974-09-08	1974-09-08 00:00:00	1974-09-22	1974-09-22 00:00:00	1974-09-22	38000177		0	0	14		0	0	0	272123	0	1043400	40229134		
214089	4694	40213160	1981-11-15	1981-11-15 00:00:00	1981-11-15	1981-11-15 00:00:00	1981-11-15	581452		0	0	0		0	0	0	312776	0	10	40213160		
153084	3370	40213306	1994-11-27	1994-11-27 00:00:00	1994-11-27	1994-11-27 00:00:00	1994-11-27	581452		0	0	0		0	0	0	223446	0	43	40213306		
51239	4256	19133873	1956-12-14	1956-12-14 00:00:00	1956-12-26	1956-12-26 00:00:00	1956-12-26	38000177		0	0	12		0	0	0	282606	0	834061	19133873		
66084	1446	40213160	1988-10-11	1988-10-11 00:00:00	1988-10-11	1988-10-11 00:00:00	1988-10-11	581452		0	0	0		0	0	0	96408	0	10	40213160		
214912	4713	40213227	1997-07-18	1997-07-18 00:00:00	1997-07-18	1997-07-18 00:00:00	1997-07-18	581452		0	0	0		0	0	0	313810	0	113	40213227		
61844	5145	19059056	1959-03-14	1959-03-14 00:00:00	1959-03-28	1959-03-28 00:00:00	1959-03-28	38000177		0	0	14		0	0	0	342031	0	243670	19059056		
97662	2140	40213160	1955-08-24	1955-08-24 00:00:00	1955-08-24	1955-08-24 00:00:00	1955-08-24	581452		0	0	0		0	0	0	142534	0	10	40213160		
4450	369	1127433	2013-03-07	2013-03-07 00:00:00	2013-03-28	2013-03-28 00:00:00	2013-03-28	38000177		0	0	21		0	0	0	24580	0	313782	1127433		
26299	2164	1127078	1982-10-07	1982-10-07 00:00:00	1982-10-28	1982-10-28 00:00:00	1982-10-28	38000177		0	0	21		0	0	0	144122	0	282464	1127078		
69275	1516	40213201	2004-04-05	2004-04-05 00:00:00	2004-04-05	2004-04-05 00:00:00	2004-04-05	581452		0	0	0		0	0	0	101333	0	33	40213201		
298	6	40213160	1964-06-09	1964-06-09 00:00:00	1964-06-09	1964-06-09 00:00:00	1964-06-09	581452		0	0	0		0	0	0	574	0	10	40213160		
31324	682	40213227	2013-01-02	2013-01-02 00:00:00	2013-01-02	2013-01-02 00:00:00	2013-01-02	581452		0	0	0		0	0	0	45204	0	113	40213227		
20494	1686	1118084	1999-04-29	1999-04-29 00:00:00	1999-04-29	1999-04-29 00:00:00	\N	38000177		0	0	0		0	0	0	112974	0	00025152531	44923712		
20525	1689	1127433	2019-03-28	2019-03-28 00:00:00	2019-05-02	2019-05-02 00:00:00	2019-05-02	38000177		0	0	35		0	0	0	113158	0	313782	1127433		
58823	4886	920300	1987-09-27	1987-09-27 00:00:00	1987-10-04	1987-10-04 00:00:00	1987-10-04	38000177		0	0	7		0	0	0	324876	0	311989	920300		
58877	4890	1127433	1938-10-12	1938-10-12 00:00:00	1938-10-26	1938-10-26 00:00:00	1938-10-26	38000177		0	0	14		0	0	0	325195	0	313782	1127433		
11158	929	40162522	1947-05-23	1947-05-23 00:00:00	1947-05-23	1947-05-23 00:00:00	\N	38000177		0	0	0		0	0	0	61755	0	857005	40162522		
19940	1636	19006318	1959-08-31	1959-08-31 00:00:00	1959-09-14	1959-09-14 00:00:00	1959-09-14	38000177		0	0	14		0	0	0	109863	0	105078	19006318		
204487	4488	40213314	1977-12-09	1977-12-09 00:00:00	1977-12-09	1977-12-09 00:00:00	1977-12-09	581452		0	0	0		0	0	0	298800	0	49	40213314		
20048	1646	19059056	1946-01-03	1946-01-03 00:00:00	1946-01-17	1946-01-17 00:00:00	1946-01-17	38000177		0	0	14		0	0	0	110439	0	243670	19059056		
46955	3889	1713671	2010-01-15	2010-01-15 00:00:00	2010-01-29	2010-01-29 00:00:00	2010-01-29	38000177		0	0	14		0	0	0	258471	0	562251	1713671		
56345	4675	1713671	1964-03-03	1964-03-03 00:00:00	1964-03-10	1964-03-10 00:00:00	1964-03-10	38000177		0	0	7		0	0	0	311496	0	562251	1713671		
3728	310	19078461	2014-03-05	2014-03-05 00:00:00	2014-03-26	2014-03-26 00:00:00	2014-03-26	38000177		0	0	21		0	0	0	20499	0	310965	19078461		
4771	399	1713671	2000-10-18	2000-10-18 00:00:00	2000-11-08	2000-11-08 00:00:00	2000-11-08	38000177		0	0	21		0	0	0	26125	0	562251	1713671		
215776	4732	40213260	2006-07-30	2006-07-30 00:00:00	2006-07-30	2006-07-30 00:00:00	2006-07-30	581452		0	0	0		0	0	0	315304	0	121	40213260		
200605	4406	40213201	2008-02-23	2008-02-23 00:00:00	2008-02-23	2008-02-23 00:00:00	2008-02-23	581452		0	0	0		0	0	0	292930	0	33	40213201		
15347	1281	1127078	1975-06-12	1975-06-12 00:00:00	1975-06-26	1975-06-26 00:00:00	1975-06-26	38000177		0	0	14		0	0	0	84699	0	282464	1127078		
50230	4168	19133873	1973-04-26	1973-04-26 00:00:00	1973-05-08	1973-05-08 00:00:00	1973-05-08	38000177		0	0	12		0	0	0	277038	0	834061	19133873		
60765	5051	19019979	1987-12-02	1987-12-02 00:00:00	1987-12-23	1987-12-23 00:00:00	1987-12-23	38000177		0	0	21		0	0	0	335905	0	198405	19019979		
4863	406	1713671	1965-04-26	1965-04-26 00:00:00	1965-05-10	1965-05-10 00:00:00	1965-05-10	38000177		0	0	14		0	0	0	26828	0	562251	1713671		
162398	3571	40213160	1976-08-03	1976-08-03 00:00:00	1976-08-03	1976-08-03 00:00:00	1976-08-03	581452		0	0	0		0	0	0	237311	0	10	40213160		
199607	4384	40213296	2008-12-08	2008-12-08 00:00:00	2008-12-08	2008-12-08 00:00:00	2008-12-08	581452		0	0	0		0	0	0	291372	0	52	40213296		
59059	4907	19059056	1950-05-03	1950-05-03 00:00:00	1950-05-17	1950-05-17 00:00:00	1950-05-17	38000177		0	0	14		0	0	0	326179	0	243670	19059056		
6689	564	920300	1991-11-10	1991-11-10 00:00:00	1991-11-17	1991-11-17 00:00:00	1991-11-17	38000177		0	0	7		0	0	0	37324	0	311989	920300		
64292	5335	19059056	1964-03-22	1964-03-22 00:00:00	1964-04-12	1964-04-12 00:00:00	1964-04-12	38000177		0	0	21		0	0	0	355237	0	243670	19059056		
198391	4359	40213201	2009-08-12	2009-08-12 00:00:00	2009-08-12	2009-08-12 00:00:00	2009-08-12	581452		0	0	0		0	0	0	289219	0	33	40213201		
66794	1461	40213260	2016-10-27	2016-10-27 00:00:00	2016-10-27	2016-10-27 00:00:00	2016-10-27	581452		0	0	0		0	0	0	97363	0	121	40213260		
87375	1917	40213227	1992-08-30	1992-08-30 00:00:00	1992-08-30	1992-08-30 00:00:00	1992-08-30	581452		0	0	0		0	0	0	127557	0	113	40213227		
59663	1306	40213260	2006-08-09	2006-08-09 00:00:00	2006-08-09	2006-08-09 00:00:00	2006-08-09	581452		0	0	0		0	0	0	86223	0	121	40213260		
199878	4390	40213227	2011-01-21	2011-01-21 00:00:00	2011-01-21	2011-01-21 00:00:00	2011-01-21	581452		0	0	0		0	0	0	291833	0	113	40213227		
39273	3244	40236824	2013-05-13	2013-05-13 00:00:00	2013-05-27	2013-05-27 00:00:00	2013-05-27	38000177		0	0	14		0	0	0	215715	0	1094107	40236824		
109673	2409	40213227	2011-06-26	2011-06-26 00:00:00	2011-06-26	2011-06-26 00:00:00	2011-06-26	581452		0	0	0		0	0	0	159930	0	113	40213227		
87805	1926	40213227	2013-02-02	2013-02-02 00:00:00	2013-02-02	2013-02-02 00:00:00	2013-02-02	581452		0	0	0		0	0	0	128222	0	113	40213227		
34030	2813	1713671	1939-10-11	1939-10-11 00:00:00	1939-10-25	1939-10-25 00:00:00	1939-10-25	38000177		0	0	14		0	0	0	186430	0	562251	1713671		
240693	5283	40213227	1995-07-25	1995-07-25 00:00:00	1995-07-25	1995-07-25 00:00:00	1995-07-25	581452		0	0	0		0	0	0	351451	0	113	40213227		
15171	1267	19128065	1974-03-24	1974-03-24 00:00:00	1975-03-19	1975-03-19 00:00:00	1975-03-19	38000177		0	0	360		0	0	0	83537	0	749882	19128065		
10305	863	19075601	1997-05-01	1997-05-01 00:00:00	2004-09-30	2004-09-30 00:00:00	2004-09-30	38000177		0	0	2709		0	0	0	57115	0	309362	19075601		
105259	2309	40213160	1973-07-06	1973-07-06 00:00:00	1973-07-06	1973-07-06 00:00:00	1973-07-06	581452		0	0	0		0	0	0	153668	0	10	40213160		
3873	84	40213306	1995-08-10	1995-08-10 00:00:00	1995-08-10	1995-08-10 00:00:00	1995-08-10	581452		0	0	0		0	0	0	\N	0	43	40213306		
93151	2044	40213160	1962-06-23	1962-06-23 00:00:00	1962-06-23	1962-06-23 00:00:00	1962-06-23	581452		0	0	0		0	0	0	136013	0	10	40213160		
8794	733	19075001	2016-05-03	2016-05-03 00:00:00	2016-05-17	2016-05-17 00:00:00	2016-05-17	38000177		0	0	14		0	0	0	48611	0	309097	19075001		
201192	4418	40213227	2003-01-03	2003-01-03 00:00:00	2003-01-03	2003-01-03 00:00:00	2003-01-03	581452		0	0	0		0	0	0	293774	0	113	40213227		
168881	3714	40213227	2013-12-25	2013-12-25 00:00:00	2013-12-25	2013-12-25 00:00:00	2013-12-25	581452		0	0	0		0	0	0	246841	0	113	40213227		
27614	2287	1127433	1981-01-06	1981-01-06 00:00:00	1981-01-20	1981-01-20 00:00:00	1981-01-20	38000177		0	0	14		0	0	0	152133	0	313782	1127433		
144088	3167	40213306	1983-02-20	1983-02-20 00:00:00	1983-02-20	1983-02-20 00:00:00	1983-02-20	581452		0	0	0		0	0	0	210524	0	43	40213306		
91650	2012	40213160	1962-01-12	1962-01-12 00:00:00	1962-01-12	1962-01-12 00:00:00	1962-01-12	581452		0	0	0		0	0	0	133870	0	10	40213160		
149981	3298	40213160	1976-07-25	1976-07-25 00:00:00	1976-07-25	1976-07-25 00:00:00	1976-07-25	581452		0	0	0		0	0	0	219170	0	10	40213160		
2320	186	19128022	1989-10-28	1989-10-28 00:00:00	1990-10-23	1990-10-23 00:00:00	1990-10-23	38000177		0	0	360		0	0	0	12611	0	749785	19128022		
180419	3966	40213296	2006-12-16	2006-12-16 00:00:00	2006-12-16	2006-12-16 00:00:00	2006-12-16	581452		0	0	0		0	0	0	263671	0	52	40213296		
196132	4309	40213160	1955-01-12	1955-01-12 00:00:00	1955-01-12	1955-01-12 00:00:00	1955-01-12	581452		0	0	0		0	0	0	285902	0	10	40213160		
19185	1585	40229134	1976-03-26	1976-03-26 00:00:00	1976-04-09	1976-04-09 00:00:00	1976-04-09	38000177		0	0	14		0	0	0	106274	0	1043400	40229134		
49369	4094	1127433	1959-12-17	1959-12-17 00:00:00	1959-12-24	1959-12-24 00:00:00	1959-12-24	38000177		0	0	7		0	0	0	272115	0	313782	1127433		
214093	4694	40213314	1982-01-17	1982-01-17 00:00:00	1982-01-17	1982-01-17 00:00:00	1982-01-17	581452		0	0	0		0	0	0	312717	0	49	40213314		
153090	3370	40213160	1973-03-04	1973-03-04 00:00:00	1973-03-04	1973-03-04 00:00:00	1973-03-04	581452		0	0	0		0	0	0	223489	0	10	40213160		
51240	4256	1127433	2009-12-26	2009-12-26 00:00:00	2010-02-01	2010-02-01 00:00:00	2010-02-01	38000177		0	0	37		0	0	0	282635	0	313782	1127433		
66086	1446	40213314	1984-02-07	1984-02-07 00:00:00	1984-02-07	1984-02-07 00:00:00	1984-02-07	581452		0	0	0		0	0	0	96398	0	49	40213314		
225542	4952	40213160	1970-11-28	1970-11-28 00:00:00	1970-11-28	1970-11-28 00:00:00	1970-11-28	581452		0	0	0		0	0	0	329160	0	10	40213160		
61845	5145	19133873	1967-10-08	1967-10-08 00:00:00	1967-10-18	1967-10-18 00:00:00	1967-10-18	38000177		0	0	10		0	0	0	342026	0	834061	19133873		
97673	2140	40213227	2012-08-08	2012-08-08 00:00:00	2012-08-08	2012-08-08 00:00:00	2012-08-08	581452		0	0	0		0	0	0	142541	0	113	40213227		
4451	369	1118084	2016-10-14	2016-10-14 00:00:00	2016-10-14	2016-10-14 00:00:00	\N	38000177		0	0	0		0	0	0	24542	0	00025152531	44923712		
26300	2164	1127433	1991-10-01	1991-10-01 00:00:00	1991-10-08	1991-10-08 00:00:00	1991-10-08	38000177		0	0	7		0	0	0	144160	0	313782	1127433		
144170	3168	40213314	1981-03-28	1981-03-28 00:00:00	1981-03-28	1981-03-28 00:00:00	1981-03-28	581452		0	0	0		0	0	0	210626	0	49	40213314		
300	6	40213306	1986-03-04	1986-03-04 00:00:00	1986-03-04	1986-03-04 00:00:00	1986-03-04	581452		0	0	0		0	0	0	591	0	43	40213306		
4680	101	40213227	2018-08-10	2018-08-10 00:00:00	2018-08-10	2018-08-10 00:00:00	2018-08-10	581452		0	0	0		0	0	0	6879	0	113	40213227		
20495	1686	1713671	1998-09-23	1998-09-23 00:00:00	1998-10-14	1998-10-14 00:00:00	1998-10-14	38000177		0	0	21		0	0	0	112974	0	562251	1713671		
20526	1689	1127433	1975-02-19	1975-02-19 00:00:00	1975-02-26	1975-02-26 00:00:00	1975-02-26	38000177		0	0	7		0	0	0	113067	0	313782	1127433		
58824	4886	1127433	1978-09-28	1978-09-28 00:00:00	1978-10-26	1978-10-26 00:00:00	1978-10-26	38000177		0	0	28		0	0	0	324932	0	313782	1127433		
58878	4890	19008572	1946-11-23	1946-11-23 00:00:00	1946-11-23	1946-11-23 00:00:00	\N	38000177		0	0	0		0	0	0	325181	0	106258	19008572		
11159	929	1118084	1961-08-13	1961-08-13 00:00:00	1961-08-13	1961-08-13 00:00:00	\N	38000177		0	0	0		0	0	0	61866	0	00025152531	44923712		
19941	1636	1127078	1959-08-31	1959-08-31 00:00:00	1959-09-14	1959-09-14 00:00:00	1959-09-14	38000177		0	0	14		0	0	0	109863	0	282464	1127078		
204490	4488	40213227	2007-08-10	2007-08-10 00:00:00	2007-08-10	2007-08-10 00:00:00	2007-08-10	581452		0	0	0		0	0	0	298827	0	113	40213227		
20049	1646	40229134	1941-05-30	1941-05-30 00:00:00	1941-06-13	1941-06-13 00:00:00	1941-06-13	38000177		0	0	14		0	0	0	110379	0	1043400	40229134		
46956	3889	1127433	1964-02-23	1964-02-23 00:00:00	1964-03-08	1964-03-08 00:00:00	1964-03-08	38000177		0	0	14		0	0	0	258477	0	313782	1127433		
56346	4675	40229134	1960-06-02	1960-06-02 00:00:00	1960-06-16	1960-06-16 00:00:00	1960-06-16	38000177		0	0	14		0	0	0	311547	0	1043400	40229134		
3729	310	19059056	1955-02-17	1955-02-17 00:00:00	1955-03-03	1955-03-03 00:00:00	1955-03-03	38000177		0	0	14		0	0	0	20495	0	243670	19059056		
4772	399	1127433	1972-03-09	1972-03-09 00:00:00	1972-03-30	1972-03-30 00:00:00	1972-03-30	38000177		0	0	21		0	0	0	26236	0	313782	1127433		
236862	5200	40213160	1960-07-27	1960-07-27 00:00:00	1960-07-27	1960-07-27 00:00:00	1960-07-27	581452		0	0	0		0	0	0	345817	0	10	40213160		
146863	3230	40213260	2007-09-05	2007-09-05 00:00:00	2007-09-05	2007-09-05 00:00:00	2007-09-05	581452		0	0	0		0	0	0	214648	0	121	40213260		
15348	1281	19129655	1975-06-12	1975-06-12 00:00:00	1975-06-26	1975-06-26 00:00:00	1975-06-26	38000177		0	0	14		0	0	0	84699	0	789980	19129655		
50231	4168	19006318	1973-12-18	1973-12-18 00:00:00	1974-01-01	1974-01-01 00:00:00	1974-01-01	38000177		0	0	14		0	0	0	277040	0	105078	19006318		
60766	5051	1127078	1983-08-25	1983-08-25 00:00:00	1983-09-29	1983-09-29 00:00:00	1983-09-29	38000177		0	0	35		0	0	0	335904	0	282464	1127078		
4864	406	1127433	2014-10-08	2014-10-08 00:00:00	2014-10-22	2014-10-22 00:00:00	2014-10-22	38000177		0	0	14		0	0	0	26857	0	313782	1127433		
162403	3571	40213306	1994-08-16	1994-08-16 00:00:00	1994-08-16	1994-08-16 00:00:00	1994-08-16	581452		0	0	0		0	0	0	237398	0	43	40213306		
199610	4384	40213160	1967-09-25	1967-09-25 00:00:00	1967-09-25	1967-09-25 00:00:00	1967-09-25	581452		0	0	0		0	0	0	291394	0	10	40213160		
59060	4907	19133905	1992-09-14	1992-09-14 00:00:00	1992-09-24	1992-09-24 00:00:00	1992-09-24	38000177		0	0	10		0	0	0	326100	0	834102	19133905		
6691	564	1713671	2012-08-09	2012-08-09 00:00:00	2012-08-23	2012-08-23 00:00:00	2012-08-23	38000177		0	0	14		0	0	0	37368	0	562251	1713671		
64293	5335	40236446	1966-08-19	1966-08-19 00:00:00	1968-04-05	1968-04-05 00:00:00	1968-04-05	38000177		0	0	595		0	0	0	355277	0	1091392	40236446		
198406	4359	40213227	2014-09-10	2014-09-10 00:00:00	2014-09-10	2014-09-10 00:00:00	2014-09-10	581452		0	0	0		0	0	0	289186	0	113	40213227		
66797	1461	40213296	2008-11-06	2008-11-06 00:00:00	2008-11-06	2008-11-06 00:00:00	2008-11-06	581452		0	0	0		0	0	0	97348	0	52	40213296		
87379	1917	40213227	2000-09-24	2000-09-24 00:00:00	2000-09-24	2000-09-24 00:00:00	2000-09-24	581452		0	0	0		0	0	0	127573	0	113	40213227		
59668	1306	40213160	1957-01-16	1957-01-16 00:00:00	1957-01-16	1957-01-16 00:00:00	1957-01-16	581452		0	0	0		0	0	0	86186	0	10	40213160		
199879	4390	40213260	2011-01-21	2011-01-21 00:00:00	2011-01-21	2011-01-21 00:00:00	2011-01-21	581452		0	0	0		0	0	0	291833	0	121	40213260		
39274	3244	920300	2013-05-13	2013-05-13 00:00:00	2013-05-20	2013-05-20 00:00:00	2013-05-20	38000177		0	0	7		0	0	0	215715	0	311989	920300		
109678	2409	40213314	1979-01-07	1979-01-07 00:00:00	1979-01-07	1979-01-07 00:00:00	1979-01-07	581452		0	0	0		0	0	0	159904	0	49	40213314		
87813	1926	40213160	1975-03-22	1975-03-22 00:00:00	1975-03-22	1975-03-22 00:00:00	1975-03-22	581452		0	0	0		0	0	0	128261	0	10	40213160		
44519	3686	1127433	1985-02-25	1985-02-25 00:00:00	1985-03-04	1985-03-04 00:00:00	1985-03-04	38000177		0	0	7		0	0	0	245083	0	313782	1127433		
240694	5283	40213306	1995-07-25	1995-07-25 00:00:00	1995-07-25	1995-07-25 00:00:00	1995-07-25	581452		0	0	0		0	0	0	351451	0	43	40213306		
15172	1267	19059056	1954-02-27	1954-02-27 00:00:00	1954-03-13	1954-03-13 00:00:00	1954-03-13	38000177		0	0	14		0	0	0	83564	0	243670	19059056		
10306	863	1127433	1967-08-11	1967-08-11 00:00:00	1967-08-25	1967-08-25 00:00:00	1967-08-25	38000177		0	0	14		0	0	0	57178	0	313782	1127433		
105263	2309	40213314	1977-03-04	1977-03-04 00:00:00	1977-03-04	1977-03-04 00:00:00	1977-03-04	581452		0	0	0		0	0	0	153670	0	49	40213314		
3874	84	40213296	2014-03-20	2014-03-20 00:00:00	2014-03-20	2014-03-20 00:00:00	2014-03-20	581452		0	0	0		0	0	0	5705	0	52	40213296		
93154	2044	40213160	1966-09-24	1966-09-24 00:00:00	1966-09-24	1966-09-24 00:00:00	1966-09-24	581452		0	0	0		0	0	0	135984	0	10	40213160		
239548	5258	40213260	2008-07-30	2008-07-30 00:00:00	2008-07-30	2008-07-30 00:00:00	2008-07-30	581452		0	0	0		0	0	0	349921	0	121	40213260		
212502	4660	40213227	2002-12-15	2002-12-15 00:00:00	2002-12-15	2002-12-15 00:00:00	2002-12-15	581452		0	0	0		0	0	0	310634	0	113	40213227		
50907	1115	40213160	1955-07-18	1955-07-18 00:00:00	1955-07-18	1955-07-18 00:00:00	1955-07-18	581452		0	0	0		0	0	0	73473	0	10	40213160		
27615	2287	19133905	1969-09-06	1969-09-06 00:00:00	1969-09-17	1969-09-17 00:00:00	1969-09-17	38000177		0	0	11		0	0	0	152101	0	834102	19133905		
144092	3167	40213227	1993-11-21	1993-11-21 00:00:00	1993-11-21	1993-11-21 00:00:00	1993-11-21	581452		0	0	0		0	0	0	210559	0	113	40213227		
91654	2012	40213227	2008-02-08	2008-02-08 00:00:00	2008-02-08	2008-02-08 00:00:00	2008-02-08	581452		0	0	0		0	0	0	133853	0	113	40213227		
149984	3298	40213306	1994-06-19	1994-06-19 00:00:00	1994-06-19	1994-06-19 00:00:00	1994-06-19	581452		0	0	0		0	0	0	219156	0	43	40213306		
2321	186	1115171	2005-02-25	2005-02-25 00:00:00	2005-03-18	2005-03-18 00:00:00	2005-03-18	38000177		0	0	21		0	0	0	12652	0	849574	1115171		
180423	3966	40213160	1967-08-19	1967-08-19 00:00:00	1967-08-19	1967-08-19 00:00:00	1967-08-19	581452		0	0	0		0	0	0	263655	0	10	40213160		
196134	4309	40213160	1955-07-13	1955-07-13 00:00:00	1955-07-13	1955-07-13 00:00:00	1955-07-13	581452		0	0	0		0	0	0	285936	0	10	40213160		
19186	1585	19059056	1930-02-23	1930-02-23 00:00:00	1930-03-09	1930-03-09 00:00:00	1930-03-09	38000177		0	0	14		0	0	0	106307	0	243670	19059056		
49370	4094	1713671	2006-09-28	2006-09-28 00:00:00	2006-10-12	2006-10-12 00:00:00	2006-10-12	38000177		0	0	14		0	0	0	272117	0	562251	1713671		
214094	4694	40213160	1982-01-17	1982-01-17 00:00:00	1982-01-17	1982-01-17 00:00:00	1982-01-17	581452		0	0	0		0	0	0	312717	0	10	40213160		
153094	3370	40213227	2003-11-09	2003-11-09 00:00:00	2003-11-09	2003-11-09 00:00:00	2003-11-09	581452		0	0	0		0	0	0	223491	0	113	40213227		
51241	4256	1127433	1985-11-21	1985-11-21 00:00:00	1985-11-28	1985-11-28 00:00:00	1985-11-28	38000177		0	0	7		0	0	0	282584	0	313782	1127433		
66087	1446	40213160	1984-02-07	1984-02-07 00:00:00	1984-02-07	1984-02-07 00:00:00	1984-02-07	581452		0	0	0		0	0	0	96398	0	10	40213160		
225544	4952	40213160	1970-06-27	1970-06-27 00:00:00	1970-06-27	1970-06-27 00:00:00	1970-06-27	581452		0	0	0		0	0	0	329159	0	10	40213160		
61846	5145	1713671	1969-04-07	1969-04-07 00:00:00	1969-04-21	1969-04-21 00:00:00	1969-04-21	38000177		0	0	14		0	0	0	342001	0	562251	1713671		
97680	2140	40213227	1993-06-16	1993-06-16 00:00:00	1993-06-16	1993-06-16 00:00:00	1993-06-16	581452		0	0	0		0	0	0	142511	0	113	40213227		
4452	369	1127433	1990-05-11	1990-05-11 00:00:00	1990-05-25	1990-05-25 00:00:00	1990-05-25	38000177		0	0	14		0	0	0	24535	0	313782	1127433		
26301	2164	1127433	1992-02-07	1992-02-07 00:00:00	1992-02-14	1992-02-14 00:00:00	1992-02-14	38000177		0	0	7		0	0	0	144161	0	313782	1127433		
144199	3170	40213160	1955-12-02	1955-12-02 00:00:00	1955-12-02	1955-12-02 00:00:00	1955-12-02	581452		0	0	0		0	0	0	210738	0	10	40213160		
301	7	40213160	1969-04-16	1969-04-16 00:00:00	1969-04-16	1969-04-16 00:00:00	1969-04-16	581452		0	0	0		0	0	0	627	0	10	40213160		
4700	101	40213227	2008-06-13	2008-06-13 00:00:00	2008-06-13	2008-06-13 00:00:00	2008-06-13	581452		0	0	0		0	0	0	6872	0	113	40213227		
20496	1686	19059056	1978-03-20	1978-03-20 00:00:00	1978-04-24	1978-04-24 00:00:00	1978-04-24	38000177		0	0	35		0	0	0	112989	0	243670	19059056		
20527	1689	1127433	2000-09-20	2000-09-20 00:00:00	2000-10-04	2000-10-04 00:00:00	2000-10-04	38000177		0	0	14		0	0	0	113123	0	313782	1127433		
58825	4886	19059056	1968-07-22	1968-07-22 00:00:00	1968-10-20	1968-10-20 00:00:00	1968-10-20	38000177		0	0	90		0	0	0	324929	0	243670	19059056		
58879	4890	1118084	1957-07-02	1957-07-02 00:00:00	1957-07-02	1957-07-02 00:00:00	\N	38000177		0	0	0		0	0	0	325176	0	00025152531	44923712		
11160	929	1127433	1963-08-24	1963-08-24 00:00:00	1963-09-07	1963-09-07 00:00:00	1963-09-07	38000177		0	0	14		0	0	0	61808	0	313782	1127433		
19942	1636	1127433	2012-01-15	2012-01-15 00:00:00	2012-02-14	2012-02-14 00:00:00	2012-02-14	38000177		0	0	30		0	0	0	109884	0	313782	1127433		
204491	4488	40213306	1998-07-31	1998-07-31 00:00:00	1998-07-31	1998-07-31 00:00:00	1998-07-31	581452		0	0	0		0	0	0	298809	0	43	40213306		
20050	1646	40229134	2018-03-23	2018-03-23 00:00:00	2018-04-06	2018-04-06 00:00:00	2018-04-06	38000177		0	0	14		0	0	0	110438	0	1043400	40229134		
46957	3889	1713671	1994-10-23	1994-10-23 00:00:00	1994-11-06	1994-11-06 00:00:00	1994-11-06	38000177		0	0	14		0	0	0	258454	0	562251	1713671		
56347	4675	1127433	1945-10-14	1945-10-14 00:00:00	1945-10-21	1945-10-21 00:00:00	1945-10-21	38000177		0	0	7		0	0	0	311494	0	313782	1127433		
3730	310	1118084	1984-02-25	1984-02-25 00:00:00	1984-02-25	1984-02-25 00:00:00	\N	38000177		0	0	0		0	0	0	20524	0	00025152531	44923712		
4773	399	1127433	1959-09-11	1959-09-11 00:00:00	1959-09-25	1959-09-25 00:00:00	1959-09-25	38000177		0	0	14		0	0	0	26118	0	313782	1127433		
236877	5200	40213227	2006-08-23	2006-08-23 00:00:00	2006-08-23	2006-08-23 00:00:00	2006-08-23	581452		0	0	0		0	0	0	345889	0	113	40213227		
146877	3230	40213160	1956-05-02	1956-05-02 00:00:00	1956-05-02	1956-05-02 00:00:00	1956-05-02	581452		0	0	0		0	0	0	214690	0	10	40213160		
15349	1281	1713671	2018-01-29	2018-01-29 00:00:00	2018-02-19	2018-02-19 00:00:00	2018-02-19	38000177		0	0	21		0	0	0	84688	0	562251	1713671		
50232	4168	1127078	1973-12-18	1973-12-18 00:00:00	1974-01-01	1974-01-01 00:00:00	1974-01-01	38000177		0	0	14		0	0	0	277040	0	282464	1127078		
60767	5051	1127433	1996-12-05	1996-12-05 00:00:00	1997-01-02	1997-01-02 00:00:00	1997-01-02	38000177		0	0	28		0	0	0	335906	0	313782	1127433		
4865	406	1127433	2011-05-23	2011-05-23 00:00:00	2011-05-30	2011-05-30 00:00:00	2011-05-30	38000177		0	0	7		0	0	0	26856	0	313782	1127433		
162405	3571	40213227	1994-08-16	1994-08-16 00:00:00	1994-08-16	1994-08-16 00:00:00	1994-08-16	581452		0	0	0		0	0	0	237398	0	113	40213227		
199618	4384	40213160	1972-03-27	1972-03-27 00:00:00	1972-03-27	1972-03-27 00:00:00	1972-03-27	581452		0	0	0		0	0	0	291387	0	10	40213160		
59061	4907	1713671	1974-07-14	1974-07-14 00:00:00	1974-10-13	1974-10-13 00:00:00	1974-10-13	38000177		0	0	91		0	0	0	326171	0	562251	1713671		
6692	564	19078461	1996-06-21	1996-06-21 00:00:00	1996-07-12	1996-07-12 00:00:00	1996-07-12	38000177		0	0	21		0	0	0	37341	0	310965	19078461		
64294	5335	19059056	1972-06-29	1972-06-29 00:00:00	1972-08-03	1972-08-03 00:00:00	1972-08-03	38000177		0	0	35		0	0	0	355238	0	243670	19059056		
167361	3680	40213314	1979-07-10	1979-07-10 00:00:00	1979-07-10	1979-07-10 00:00:00	1979-07-10	581452		0	0	0		0	0	0	244716	0	49	40213314		
66799	1461	40213227	2008-11-06	2008-11-06 00:00:00	2008-11-06	2008-11-06 00:00:00	2008-11-06	581452		0	0	0		0	0	0	97348	0	113	40213227		
214084	4694	40213160	1982-02-14	1982-02-14 00:00:00	1982-02-14	1982-02-14 00:00:00	1982-02-14	581452		0	0	0		0	0	0	\N	0	10	40213160		
59671	1306	40213296	1997-06-11	1997-06-11 00:00:00	1997-06-11	1997-06-11 00:00:00	1997-06-11	581452		0	0	0		0	0	0	86249	0	52	40213296		
199885	4390	40213160	1959-07-17	1959-07-17 00:00:00	1959-07-17	1959-07-17 00:00:00	1959-07-17	581452		0	0	0		0	0	0	291925	0	10	40213160		
39275	3244	19008572	1991-04-24	1991-04-24 00:00:00	1991-04-24	1991-04-24 00:00:00	\N	38000177		0	0	0		0	0	0	215718	0	106258	19008572		
109679	2409	40213160	1979-01-07	1979-01-07 00:00:00	1979-01-07	1979-01-07 00:00:00	1979-01-07	581452		0	0	0		0	0	0	159904	0	10	40213160		
49805	4131	19133905	1996-09-07	1996-09-07 00:00:00	1996-09-17	1996-09-17 00:00:00	1996-09-17	38000177		0	0	10		0	0	0	274684	0	834102	19133905		
44520	3686	19078461	1991-01-18	1991-01-18 00:00:00	1991-04-18	1991-04-18 00:00:00	1991-04-18	38000177		0	0	90		0	0	0	245052	0	310965	19078461		
240697	5283	40213227	2004-09-14	2004-09-14 00:00:00	2004-09-14	2004-09-14 00:00:00	2004-09-14	581452		0	0	0		0	0	0	351427	0	113	40213227		
15173	1267	19128065	1976-03-13	1976-03-13 00:00:00	1977-03-08	1977-03-08 00:00:00	1977-03-08	38000177		0	0	360		0	0	0	83524	0	749882	19128065		
10307	863	1539411	1991-03-28	1991-03-28 00:00:00	1991-03-28	1991-03-28 00:00:00	\N	38000177		0	0	0		0	0	0	57137	0	312961	1539411		
130024	2859	40213227	2013-10-14	2013-10-14 00:00:00	2013-10-14	2013-10-14 00:00:00	2013-10-14	581452		0	0	0		0	0	0	190018	0	113	40213227		
3876	84	40213314	1977-07-07	1977-07-07 00:00:00	1977-07-07	1977-07-07 00:00:00	1977-07-07	581452		0	0	0		0	0	0	5691	0	49	40213314		
93166	2044	40213160	1962-03-24	1962-03-24 00:00:00	1962-03-24	1962-03-24 00:00:00	1962-03-24	581452		0	0	0		0	0	0	136031	0	10	40213160		
239551	5258	40213296	2001-11-21	2001-11-21 00:00:00	2001-11-21	2001-11-21 00:00:00	2001-11-21	581452		0	0	0		0	0	0	349904	0	52	40213296		
212504	4660	40213227	1992-01-12	1992-01-12 00:00:00	1992-01-12	1992-01-12 00:00:00	1992-01-12	581452		0	0	0		0	0	0	310644	0	113	40213227		
50933	1116	40213306	1988-02-12	1988-02-12 00:00:00	1988-02-12	1988-02-12 00:00:00	1988-02-12	581452		0	0	0		0	0	0	73536	0	43	40213306		
27616	2287	40231925	1954-09-10	1954-09-10 00:00:00	1954-09-10	1954-09-10 00:00:00	\N	38000177		0	0	0		0	0	0	152155	0	1049221	40231925		
210078	4606	40213227	2003-09-04	2003-09-04 00:00:00	2003-09-04	2003-09-04 00:00:00	2003-09-04	581452		0	0	0		0	0	0	306863	0	113	40213227		
91655	2012	40213260	2008-02-08	2008-02-08 00:00:00	2008-02-08	2008-02-08 00:00:00	2008-02-08	581452		0	0	0		0	0	0	133853	0	121	40213260		
149986	3298	40213227	1994-06-19	1994-06-19 00:00:00	1994-06-19	1994-06-19 00:00:00	1994-06-19	581452		0	0	0		0	0	0	219156	0	113	40213227		
2322	186	19073188	2009-07-05	2009-07-05 00:00:00	2009-07-19	2009-07-19 00:00:00	2009-07-19	38000177		0	0	14		0	0	0	12600	0	308192	19073188		
180425	3966	40213160	1967-03-18	1967-03-18 00:00:00	1967-03-18	1967-03-18 00:00:00	1967-03-18	581452		0	0	0		0	0	0	263697	0	10	40213160		
74720	1632	40213227	1993-08-02	1993-08-02 00:00:00	1993-08-02	1993-08-02 00:00:00	1993-08-02	581452		0	0	0		0	0	0	109634	0	113	40213227		
19187	1585	19059056	1950-10-06	1950-10-06 00:00:00	1950-10-27	1950-10-27 00:00:00	1950-10-27	38000177		0	0	21		0	0	0	106346	0	243670	19059056		
49371	4094	19059056	1967-03-24	1967-03-24 00:00:00	1967-04-21	1967-04-21 00:00:00	1967-04-21	38000177		0	0	28		0	0	0	272151	0	243670	19059056		
226688	4977	40213160	1960-05-28	1960-05-28 00:00:00	1960-05-28	1960-05-28 00:00:00	1960-05-28	581452		0	0	0		0	0	0	331164	0	10	40213160		
153099	3370	40213296	2013-05-26	2013-05-26 00:00:00	2013-05-26	2013-05-26 00:00:00	2013-05-26	581452		0	0	0		0	0	0	223495	0	52	40213296		
51242	4256	1713671	2011-12-26	2011-12-26 00:00:00	2012-01-02	2012-01-02 00:00:00	2012-01-02	38000177		0	0	7		0	0	0	282612	0	562251	1713671		
66098	1446	40213227	2006-01-03	2006-01-03 00:00:00	2006-01-03	2006-01-03 00:00:00	2006-01-03	581452		0	0	0		0	0	0	96413	0	113	40213227		
225548	4952	40213227	2001-08-04	2001-08-04 00:00:00	2001-08-04	2001-08-04 00:00:00	2001-08-04	581452		0	0	0		0	0	0	329140	0	113	40213227		
61847	5145	46275916	2018-01-13	2018-01-13 00:00:00	2018-01-13	2018-01-13 00:00:00	2018-01-13	38000177		0	0	0		0	0	0	342080	0	1660014	46275916		
97683	2140	40213227	2002-06-12	2002-06-12 00:00:00	2002-06-12	2002-06-12 00:00:00	2002-06-12	581452		0	0	0		0	0	0	142521	0	113	40213227		
4453	369	19019979	1982-01-21	1982-01-21 00:00:00	1982-03-22	1982-03-22 00:00:00	1982-03-22	38000177		0	0	60		0	0	0	24554	0	198405	19019979		
26302	2164	1713671	1984-02-02	1984-02-02 00:00:00	1984-02-23	1984-02-23 00:00:00	1984-02-23	38000177		0	0	21		0	0	0	144159	0	562251	1713671		
9865	826	1713671	2009-06-10	2009-06-10 00:00:00	2009-07-01	2009-07-01 00:00:00	2009-07-01	38000177		0	0	21		0	0	0	54720	0	562251	1713671		
303	7	40213160	1969-02-12	1969-02-12 00:00:00	1969-02-12	1969-02-12 00:00:00	1969-02-12	581452		0	0	0		0	0	0	646	0	10	40213160		
4704	101	40213227	1998-04-17	1998-04-17 00:00:00	1998-04-17	1998-04-17 00:00:00	1998-04-17	581452		0	0	0		0	0	0	6874	0	113	40213227		
20497	1686	19133873	1969-03-11	1969-03-11 00:00:00	1969-03-21	1969-03-21 00:00:00	1969-03-21	38000177		0	0	10		0	0	0	112931	0	834061	19133873		
20528	1690	1115171	2009-12-27	2009-12-27 00:00:00	2010-01-17	2010-01-17 00:00:00	2010-01-17	38000177		0	0	21		0	0	0	113161	0	849574	1115171		
58826	4886	1127078	1970-11-09	1970-11-09 00:00:00	1971-02-07	1971-02-07 00:00:00	1971-02-07	38000177		0	0	90		0	0	0	324930	0	282464	1127078		
58880	4890	1713671	1928-10-29	1928-10-29 00:00:00	1928-11-19	1928-11-19 00:00:00	1928-11-19	38000177		0	0	21		0	0	0	325080	0	562251	1713671		
11161	929	19133873	1925-02-07	1925-02-07 00:00:00	1925-02-20	1925-02-20 00:00:00	1925-02-20	38000177		0	0	13		0	0	0	61804	0	834061	19133873		
19943	1636	19006318	1956-04-10	1956-04-10 00:00:00	1956-04-24	1956-04-24 00:00:00	1956-04-24	38000177		0	0	14		0	0	0	109873	0	105078	19006318		
204493	4488	40213227	1998-07-31	1998-07-31 00:00:00	1998-07-31	1998-07-31 00:00:00	1998-07-31	581452		0	0	0		0	0	0	298809	0	113	40213227		
20051	1646	1127433	1948-02-18	1948-02-18 00:00:00	1948-03-03	1948-03-03 00:00:00	1948-03-03	38000177		0	0	14		0	0	0	110380	0	313782	1127433		
46958	3889	19059056	1941-06-23	1941-06-23 00:00:00	1941-07-07	1941-07-07 00:00:00	1941-07-07	38000177		0	0	14		0	0	0	258497	0	243670	19059056		
56348	4675	40229134	1930-05-20	1930-05-20 00:00:00	1930-06-03	1930-06-03 00:00:00	1930-06-03	38000177		0	0	14		0	0	0	311493	0	1043400	40229134		
3731	310	1713671	1983-01-04	1983-01-04 00:00:00	1983-01-25	1983-01-25 00:00:00	1983-01-25	38000177		0	0	21		0	0	0	20524	0	562251	1713671		
4774	399	19059056	1960-01-07	1960-01-07 00:00:00	1960-02-11	1960-02-11 00:00:00	1960-02-11	38000177		0	0	35		0	0	0	26233	0	243670	19059056		
236878	5200	40213260	2006-08-23	2006-08-23 00:00:00	2006-08-23	2006-08-23 00:00:00	2006-08-23	581452		0	0	0		0	0	0	345889	0	121	40213260		
146889	3230	40213160	1960-08-03	1960-08-03 00:00:00	1960-08-03	1960-08-03 00:00:00	1960-08-03	581452		0	0	0		0	0	0	214709	0	10	40213160		
15350	1281	1115171	2008-10-31	2008-10-31 00:00:00	2008-11-28	2008-11-28 00:00:00	2008-11-28	38000177		0	0	28		0	0	0	84705	0	849574	1115171		
50233	4168	1118084	2010-06-12	2010-06-12 00:00:00	2010-06-12	2010-06-12 00:00:00	\N	38000177		0	0	0		0	0	0	277055	0	00025152531	44923712		
60771	5053	1115171	2004-03-15	2004-03-15 00:00:00	2004-04-12	2004-04-12 00:00:00	2004-04-12	38000177		0	0	28		0	0	0	336022	0	849574	1115171		
4866	406	1713671	2008-10-29	2008-10-29 00:00:00	2008-11-19	2008-11-19 00:00:00	2008-11-19	38000177		0	0	21		0	0	0	26773	0	562251	1713671		
162411	3571	40213160	1971-11-30	1971-11-30 00:00:00	1971-11-30	1971-11-30 00:00:00	1971-11-30	581452		0	0	0		0	0	0	237365	0	10	40213160		
107527	2357	40213227	2010-03-02	2010-03-02 00:00:00	2010-03-02	2010-03-02 00:00:00	2010-03-02	581452		0	0	0		0	0	0	157061	0	113	40213227		
59065	4909	1127433	1993-01-08	1993-01-08 00:00:00	1993-02-05	1993-02-05 00:00:00	1993-02-05	38000177		0	0	28		0	0	0	326278	0	313782	1127433		
6693	564	19133873	1960-01-01	1960-01-01 00:00:00	1960-01-10	1960-01-10 00:00:00	1960-01-10	38000177		0	0	9		0	0	0	37356	0	834061	19133873		
64306	5337	40232448	1974-03-14	1974-03-14 00:00:00	1974-03-14	1974-03-14 00:00:00	\N	38000177		0	0	0		0	0	0	355393	0	1049630	40232448		
167362	3680	40213160	1979-07-10	1979-07-10 00:00:00	1979-07-10	1979-07-10 00:00:00	1979-07-10	581452		0	0	0		0	0	0	244716	0	10	40213160		
66802	1461	40213306	1988-12-29	1988-12-29 00:00:00	1988-12-29	1988-12-29 00:00:00	1988-12-29	581452		0	0	0		0	0	0	97346	0	43	40213306		
225402	4949	40213160	1973-05-31	1973-05-31 00:00:00	1973-05-31	1973-05-31 00:00:00	1973-05-31	581452		0	0	0		0	0	0	329031	0	10	40213160		
242687	5328	40213227	1992-10-07	1992-10-07 00:00:00	1992-10-07	1992-10-07 00:00:00	1992-10-07	581452		0	0	0		0	0	0	354598	0	113	40213227		
171085	3761	40213160	1961-04-01	1961-04-01 00:00:00	1961-04-01	1961-04-01 00:00:00	1961-04-01	581452		0	0	0		0	0	0	250103	0	10	40213160		
39276	3244	19128022	1991-03-25	1991-03-25 00:00:00	1992-03-19	1992-03-19 00:00:00	1992-03-19	38000177		0	0	360		0	0	0	215702	0	749785	19128022		
175664	3862	40213160	1956-05-09	1956-05-09 00:00:00	1956-05-09	1956-05-09 00:00:00	1956-05-09	581452		0	0	0		0	0	0	256432	0	10	40213160		
49806	4131	19128065	1999-04-22	1999-04-22 00:00:00	2000-04-16	2000-04-16 00:00:00	2000-04-16	38000177		0	0	360		0	0	0	274688	0	749882	19128065		
33022	2739	1127433	1969-07-24	1969-07-24 00:00:00	1969-07-31	1969-07-31 00:00:00	1969-07-31	38000177		0	0	7		0	0	0	181187	0	313782	1127433		
240698	5283	40213160	1973-05-15	1973-05-15 00:00:00	1973-05-15	1973-05-15 00:00:00	1973-05-15	581452		0	0	0		0	0	0	351463	0	10	40213160		
15174	1267	1713671	1960-06-01	1960-06-01 00:00:00	1960-06-08	1960-06-08 00:00:00	1960-06-08	38000177		0	0	7		0	0	0	83596	0	562251	1713671		
10308	863	1127433	2018-02-10	2018-02-10 00:00:00	2018-02-24	2018-02-24 00:00:00	2018-02-24	38000177		0	0	14		0	0	0	57144	0	313782	1127433		
107272	2351	40213227	2009-09-19	2009-09-19 00:00:00	2009-09-19	2009-09-19 00:00:00	2009-09-19	581452		0	0	0		0	0	0	156543	0	113	40213227		
3881	84	40213160	1979-01-11	1979-01-11 00:00:00	1979-01-11	1979-01-11 00:00:00	1979-01-11	581452		0	0	0		0	0	0	5692	0	10	40213160		
110653	2431	40213227	2012-10-31	2012-10-31 00:00:00	2012-10-31	2012-10-31 00:00:00	2012-10-31	581452		0	0	0		0	0	0	161225	0	113	40213227		
239552	5258	40213160	1959-04-08	1959-04-08 00:00:00	1959-04-08	1959-04-08 00:00:00	1959-04-08	581452		0	0	0		0	0	0	349896	0	10	40213160		
212507	4660	40213296	2002-12-15	2002-12-15 00:00:00	2002-12-15	2002-12-15 00:00:00	2002-12-15	581452		0	0	0		0	0	0	310634	0	52	40213296		
50938	1116	40213160	1970-11-20	1970-11-20 00:00:00	1970-11-20	1970-11-20 00:00:00	1970-11-20	581452		0	0	0		0	0	0	73557	0	10	40213160		
157274	3462	40213227	2002-02-22	2002-02-22 00:00:00	2002-02-22	2002-02-22 00:00:00	2002-02-22	581452		0	0	0		0	0	0	229767	0	113	40213227		
210079	4606	40213306	2003-09-04	2003-09-04 00:00:00	2003-09-04	2003-09-04 00:00:00	2003-09-04	581452		0	0	0		0	0	0	306863	0	43	40213306		
91658	2012	40213227	1999-02-12	1999-02-12 00:00:00	1999-02-12	1999-02-12 00:00:00	1999-02-12	581452		0	0	0		0	0	0	133879	0	113	40213227		
149988	3298	40213296	2013-09-22	2013-09-22 00:00:00	2013-09-22	2013-09-22 00:00:00	2013-09-22	581452		0	0	0		0	0	0	219124	0	52	40213296		
2323	186	1118084	2010-07-05	2010-07-05 00:00:00	2010-07-05	2010-07-05 00:00:00	\N	38000177		0	0	0		0	0	0	12600	0	00025152531	44923712		
180429	3966	40213160	1971-07-10	1971-07-10 00:00:00	1971-07-10	1971-07-10 00:00:00	1971-07-10	581452		0	0	0		0	0	0	263700	0	10	40213160		
74725	1632	40213201	2018-04-09	2018-04-09 00:00:00	2018-04-09	2018-04-09 00:00:00	2018-04-09	581452		0	0	0		0	0	0	109596	0	33	40213201		
19188	1585	19059056	1935-03-16	1935-03-16 00:00:00	1935-03-30	1935-03-30 00:00:00	1935-03-30	38000177		0	0	14		0	0	0	106309	0	243670	19059056		
49372	4094	19059056	1963-03-15	1963-03-15 00:00:00	1963-03-29	1963-03-29 00:00:00	1963-03-29	38000177		0	0	14		0	0	0	272133	0	243670	19059056		
226691	4977	40213227	1993-08-21	1993-08-21 00:00:00	1993-08-21	1993-08-21 00:00:00	1993-08-21	581452		0	0	0		0	0	0	331148	0	113	40213227		
153112	3371	40213314	1977-07-22	1977-07-22 00:00:00	1977-07-22	1977-07-22 00:00:00	1977-07-22	581452		0	0	0		0	0	0	223661	0	49	40213314		
51243	4256	1127433	1991-06-01	1991-06-01 00:00:00	1991-06-15	1991-06-15 00:00:00	1991-06-15	38000177		0	0	14		0	0	0	282611	0	313782	1127433		
5033	419	1127433	1952-02-13	1952-02-13 00:00:00	1952-02-27	1952-02-27 00:00:00	1952-02-27	38000177		0	0	14		0	0	0	27753	0	313782	1127433		
225552	4952	40213296	2010-03-27	2010-03-27 00:00:00	2010-03-27	2010-03-27 00:00:00	2010-03-27	581452		0	0	0		0	0	0	329170	0	52	40213296		
61848	5145	1310034	2018-01-13	2018-01-13 00:00:00	2018-01-13	2018-01-13 00:00:00	2018-01-13	38000177		0	0	0		0	0	0	342080	0	834357	1310034		
143227	3147	40213227	1992-01-27	1992-01-27 00:00:00	1992-01-27	1992-01-27 00:00:00	1992-01-27	581452		0	0	0		0	0	0	209385	0	113	40213227		
4454	370	19074841	1979-08-09	1979-08-09 00:00:00	1979-09-13	1979-09-13 00:00:00	1979-09-13	38000177		0	0	35		0	0	0	24584	0	309043	19074841		
26303	2164	1118084	2012-08-05	2012-08-05 00:00:00	2012-08-05	2012-08-05 00:00:00	\N	38000177		0	0	0		0	0	0	144157	0	00025152531	44923712		
9866	826	1115171	2013-09-26	2013-09-26 00:00:00	2013-12-25	2013-12-25 00:00:00	2013-12-25	38000177		0	0	90		0	0	0	54739	0	849574	1115171		
309	7	40213227	2000-01-19	2000-01-19 00:00:00	2000-01-19	2000-01-19 00:00:00	2000-01-19	581452		0	0	0		0	0	0	644	0	113	40213227		
4708	101	40213201	1993-06-25	1993-06-25 00:00:00	1993-06-25	1993-06-25 00:00:00	1993-06-25	581452		0	0	0		0	0	0	6952	0	33	40213201		
148976	3277	40213160	1963-08-16	1963-08-16 00:00:00	1963-08-16	1963-08-16 00:00:00	1963-08-16	581452		0	0	0		0	0	0	217716	0	10	40213160		
20529	1690	19128022	1998-08-03	1998-08-03 00:00:00	1999-07-29	1999-07-29 00:00:00	1999-07-29	38000177		0	0	360		0	0	0	113210	0	749785	19128022		
58827	4886	19059056	1973-08-25	1973-08-25 00:00:00	1973-10-24	1973-10-24 00:00:00	1973-10-24	38000177		0	0	60		0	0	0	324931	0	243670	19059056		
58881	4890	1713671	1956-11-25	1956-11-25 00:00:00	1956-12-16	1956-12-16 00:00:00	1956-12-16	38000177		0	0	21		0	0	0	325197	0	562251	1713671		
11162	929	19078461	1977-05-20	1977-05-20 00:00:00	1977-06-03	1977-06-03 00:00:00	1977-06-03	38000177		0	0	14		0	0	0	61756	0	310965	19078461		
19944	1636	1127078	1956-04-10	1956-04-10 00:00:00	1956-04-24	1956-04-24 00:00:00	1956-04-24	38000177		0	0	14		0	0	0	109873	0	282464	1127078		
121470	2669	40213160	1977-08-17	1977-08-17 00:00:00	1977-08-17	1977-08-17 00:00:00	1977-08-17	581452		0	0	0		0	0	0	176791	0	10	40213160		
20052	1646	19059056	1973-03-03	1973-03-03 00:00:00	1973-03-17	1973-03-17 00:00:00	1973-03-17	38000177		0	0	14		0	0	0	110448	0	243670	19059056		
46959	3889	19059056	1949-06-11	1949-06-11 00:00:00	1949-07-02	1949-07-02 00:00:00	1949-07-02	38000177		0	0	21		0	0	0	258516	0	243670	19059056		
56349	4675	1124300	1948-01-09	1948-01-09 00:00:00	1948-01-09	1948-01-09 00:00:00	\N	38000177		0	0	0		0	0	0	311546	0	00781178901	45011828		
3732	310	1713671	1957-10-31	1957-10-31 00:00:00	1957-11-21	1957-11-21 00:00:00	1957-11-21	38000177		0	0	21		0	0	0	20558	0	562251	1713671		
4775	399	1127433	1980-07-16	1980-07-16 00:00:00	1980-09-14	1980-09-14 00:00:00	1980-09-14	38000177		0	0	60		0	0	0	26237	0	313782	1127433		
236886	5200	40213227	1997-08-27	1997-08-27 00:00:00	1997-08-27	1997-08-27 00:00:00	1997-08-27	581452		0	0	0		0	0	0	345804	0	113	40213227		
146895	3230	40213227	2006-08-30	2006-08-30 00:00:00	2006-08-30	2006-08-30 00:00:00	2006-08-30	581452		0	0	0		0	0	0	214684	0	113	40213227		
15351	1282	1127078	1980-06-25	1980-06-25 00:00:00	1980-09-23	1980-09-23 00:00:00	1980-09-23	38000177		0	0	90		0	0	0	84708	0	282464	1127078		
50234	4168	1713671	1981-07-03	1981-07-03 00:00:00	1981-07-17	1981-07-17 00:00:00	1981-07-17	38000177		0	0	14		0	0	0	277023	0	562251	1713671		
60772	5053	40229134	2018-07-21	2018-07-21 00:00:00	2018-07-28	2018-07-28 00:00:00	2018-07-28	38000177		0	0	7		0	0	0	336031	0	1043400	40229134		
43152	3576	1127078	1969-07-28	1969-07-28 00:00:00	1969-08-11	1969-08-11 00:00:00	1969-08-11	38000177		0	0	14		0	0	0	237719	0	282464	1127078		
162413	3571	40213296	2012-05-01	2012-05-01 00:00:00	2012-05-01	2012-05-01 00:00:00	2012-05-01	581452		0	0	0		0	0	0	237401	0	52	40213296		
107541	2357	40213227	1992-12-08	1992-12-08 00:00:00	1992-12-08	1992-12-08 00:00:00	1992-12-08	581452		0	0	0		0	0	0	157082	0	113	40213227		
59066	4909	19019979	1975-07-16	1975-07-16 00:00:00	1975-07-30	1975-07-30 00:00:00	1975-07-30	38000177		0	0	14		0	0	0	326245	0	198405	19019979		
6694	564	1127078	1956-07-16	1956-07-16 00:00:00	1956-07-30	1956-07-30 00:00:00	1956-07-30	38000177		0	0	14		0	0	0	37384	0	282464	1127078		
64307	5337	1118084	2010-09-30	2010-09-30 00:00:00	2010-09-30	2010-09-30 00:00:00	\N	38000177		0	0	0		0	0	0	355492	0	00025152531	44923712		
167364	3680	40213314	1980-06-10	1980-06-10 00:00:00	1980-06-10	1980-06-10 00:00:00	1980-06-10	581452		0	0	0		0	0	0	244730	0	49	40213314		
66804	1461	40213160	1967-02-02	1967-02-02 00:00:00	1967-02-02	1967-02-02 00:00:00	1967-02-02	581452		0	0	0		0	0	0	97352	0	10	40213160		
67097	1468	40213227	2001-03-14	2001-03-14 00:00:00	2001-03-14	2001-03-14 00:00:00	2001-03-14	581452		0	0	0		0	0	0	97806	0	113	40213227		
242710	5328	40213227	2001-01-31	2001-01-31 00:00:00	2001-01-31	2001-01-31 00:00:00	2001-01-31	581452		0	0	0		0	0	0	354699	0	113	40213227		
171090	3761	40213160	1956-07-28	1956-07-28 00:00:00	1956-07-28	1956-07-28 00:00:00	1956-07-28	581452		0	0	0		0	0	0	250079	0	10	40213160		
39278	3246	1115171	2010-01-03	2010-01-03 00:00:00	2010-01-31	2010-01-31 00:00:00	2010-01-31	38000177		0	0	28		0	0	0	215821	0	849574	1115171		
175675	3862	40213160	1956-10-10	1956-10-10 00:00:00	1956-10-10	1956-10-10 00:00:00	1956-10-10	581452		0	0	0		0	0	0	256433	0	10	40213160		
49810	4133	19128022	1996-06-25	1996-06-25 00:00:00	1997-06-20	1997-06-20 00:00:00	1997-06-20	38000177		0	0	360		0	0	0	274791	0	749785	19128022		
33024	2739	19133873	1960-03-25	1960-03-25 00:00:00	1960-04-07	1960-04-07 00:00:00	1960-04-07	38000177		0	0	13		0	0	0	181209	0	834061	19133873		
95823	2100	40213198	2010-01-11	2010-01-11 00:00:00	2010-01-11	2010-01-11 00:00:00	2010-01-11	581452		0	0	0		0	0	0	139997	0	133	40213198		
15175	1267	19133905	2016-01-21	2016-01-21 00:00:00	2016-02-02	2016-02-02 00:00:00	2016-02-02	38000177		0	0	12		0	0	0	83552	0	834102	19133905		
10309	863	19133873	1923-04-14	1923-04-14 00:00:00	1923-04-21	1923-04-21 00:00:00	1923-04-21	38000177		0	0	7		0	0	0	57160	0	834061	19133873		
107276	2351	40213227	1992-08-01	1992-08-01 00:00:00	1992-08-01	1992-08-01 00:00:00	1992-08-01	581452		0	0	0		0	0	0	156529	0	113	40213227		
3884	84	40213160	1974-11-21	1974-11-21 00:00:00	1974-11-21	1974-11-21 00:00:00	1974-11-21	581452		0	0	0		0	0	0	5662	0	10	40213160		
110654	2431	40213296	2012-10-31	2012-10-31 00:00:00	2012-10-31	2012-10-31 00:00:00	2012-10-31	581452		0	0	0		0	0	0	161225	0	52	40213296		
239574	5258	40213160	1963-07-10	1963-07-10 00:00:00	1963-07-10	1963-07-10 00:00:00	1963-07-10	581452		0	0	0		0	0	0	349927	0	10	40213160		
119804	2633	40213160	1955-10-13	1955-10-13 00:00:00	1955-10-13	1955-10-13 00:00:00	1955-10-13	581452		0	0	0		0	0	0	174205	0	10	40213160		
193720	4256	40213227	2003-10-12	2003-10-12 00:00:00	2003-10-12	2003-10-12 00:00:00	2003-10-12	581452		0	0	0		0	0	0	282591	0	113	40213227		
157275	3462	40213296	2002-02-22	2002-02-22 00:00:00	2002-02-22	2002-02-22 00:00:00	2002-02-22	581452		0	0	0		0	0	0	229767	0	52	40213296		
210080	4606	40213160	1982-07-15	1982-07-15 00:00:00	1982-07-15	1982-07-15 00:00:00	1982-07-15	581452		0	0	0		0	0	0	306824	0	10	40213160		
91659	2012	40213296	1999-02-12	1999-02-12 00:00:00	1999-02-12	1999-02-12 00:00:00	1999-02-12	581452		0	0	0		0	0	0	133879	0	52	40213296		
149990	3298	40213227	2013-09-22	2013-09-22 00:00:00	2013-09-22	2013-09-22 00:00:00	2013-09-22	581452		0	0	0		0	0	0	219124	0	113	40213227		
2324	186	19078461	2009-07-05	2009-07-05 00:00:00	2009-07-19	2009-07-19 00:00:00	2009-07-19	38000177		0	0	14		0	0	0	12600	0	310965	19078461		
180432	3966	40213227	2008-12-20	2008-12-20 00:00:00	2008-12-20	2008-12-20 00:00:00	2008-12-20	581452		0	0	0		0	0	0	263667	0	113	40213227		
206859	4538	40213227	2014-07-18	2014-07-18 00:00:00	2014-07-18	2014-07-18 00:00:00	2014-07-18	581452		0	0	0		0	0	0	302367	0	113	40213227		
19189	1585	19059056	1931-01-01	1931-01-01 00:00:00	1931-01-15	1931-01-15 00:00:00	1931-01-15	38000177		0	0	14		0	0	0	106308	0	243670	19059056		
49373	4094	19129655	1963-03-15	1963-03-15 00:00:00	1963-03-29	1963-03-29 00:00:00	1963-03-29	38000177		0	0	14		0	0	0	272133	0	789980	19129655		
226693	4977	40213296	2002-07-06	2002-07-06 00:00:00	2002-07-06	2002-07-06 00:00:00	2002-07-06	581452		0	0	0		0	0	0	331175	0	52	40213296		
153115	3371	40213306	1999-08-20	1999-08-20 00:00:00	1999-08-20	1999-08-20 00:00:00	1999-08-20	581452		0	0	0		0	0	0	223551	0	43	40213306		
51244	4256	40162522	2010-01-02	2010-01-02 00:00:00	2010-01-02	2010-01-02 00:00:00	\N	38000177		0	0	0		0	0	0	282590	0	857005	40162522		
5034	419	19078461	1988-12-08	1988-12-08 00:00:00	1989-01-12	1989-01-12 00:00:00	1989-01-12	38000177		0	0	35		0	0	0	27760	0	310965	19078461		
225554	4952	40213160	1970-08-29	1970-08-29 00:00:00	1970-08-29	1970-08-29 00:00:00	1970-08-29	581452		0	0	0		0	0	0	329145	0	10	40213160		
61849	5145	40243436	2018-01-13	2018-01-13 00:00:00	2018-01-13	2018-01-13 00:00:00	2018-01-13	38000177		0	0	0		0	0	0	342080	0	1190795	40243436		
143239	3147	40213201	2013-05-13	2013-05-13 00:00:00	2013-05-13	2013-05-13 00:00:00	2013-05-13	581452		0	0	0		0	0	0	209410	0	33	40213201		
4455	370	1127433	1979-08-09	1979-08-09 00:00:00	1979-09-13	1979-09-13 00:00:00	1979-09-13	38000177		0	0	35		0	0	0	24584	0	313782	1127433		
26304	2164	19078461	2014-05-04	2014-05-04 00:00:00	2014-05-18	2014-05-18 00:00:00	2014-05-18	38000177		0	0	14		0	0	0	144125	0	310965	19078461		
9867	826	19129655	1963-11-18	1963-11-18 00:00:00	1963-12-02	1963-12-02 00:00:00	1963-12-02	38000177		0	0	14		0	0	0	54708	0	789980	19129655		
312	7	40213160	1973-10-17	1973-10-17 00:00:00	1973-10-17	1973-10-17 00:00:00	1973-10-17	581452		0	0	0		0	0	0	636	0	10	40213160		
116293	2555	40213227	1992-02-05	1992-02-05 00:00:00	1992-02-05	1992-02-05 00:00:00	1992-02-05	581452		0	0	0		0	0	0	169296	0	113	40213227		
148980	3277	40213160	1967-11-17	1967-11-17 00:00:00	1967-11-17	1967-11-17 00:00:00	1967-11-17	581452		0	0	0		0	0	0	217734	0	10	40213160		
20530	1690	1713671	2012-08-15	2012-08-15 00:00:00	2012-10-17	2012-10-17 00:00:00	2012-10-17	38000177		0	0	63		0	0	0	113177	0	562251	1713671		
58828	4886	40229134	2005-04-06	2005-04-06 00:00:00	2005-04-20	2005-04-20 00:00:00	2005-04-20	38000177		0	0	14		0	0	0	324880	0	1043400	40229134		
58882	4890	1127433	1965-10-31	1965-10-31 00:00:00	1965-11-14	1965-11-14 00:00:00	1965-11-14	38000177		0	0	14		0	0	0	325198	0	313782	1127433		
11163	929	1127433	1967-11-16	1967-11-16 00:00:00	1967-11-30	1967-11-30 00:00:00	1967-11-30	38000177		0	0	14		0	0	0	61840	0	313782	1127433		
19945	1636	1127433	1975-07-20	1975-07-20 00:00:00	1975-07-27	1975-07-27 00:00:00	1975-07-27	38000177		0	0	7		0	0	0	109912	0	313782	1127433		
13672	295	40213198	2014-09-10	2014-09-10 00:00:00	2014-09-10	2014-09-10 00:00:00	2014-09-10	581452		0	0	0		0	0	0	19569	0	133	40213198		
20053	1646	19078461	2017-12-31	2017-12-31 00:00:00	2018-01-14	2018-01-14 00:00:00	2018-01-14	38000177		0	0	14		0	0	0	110431	0	310965	19078461		
46960	3889	19059056	1961-12-26	1961-12-26 00:00:00	1962-01-16	1962-01-16 00:00:00	1962-01-16	38000177		0	0	21		0	0	0	258517	0	243670	19059056		
56350	4675	1713671	1947-09-25	1947-09-25 00:00:00	1947-10-16	1947-10-16 00:00:00	1947-10-16	38000177		0	0	21		0	0	0	311546	0	562251	1713671		
3733	310	19059056	1951-09-06	1951-09-06 00:00:00	1951-09-20	1951-09-20 00:00:00	1951-09-20	38000177		0	0	14		0	0	0	20525	0	243670	19059056		
4776	399	1127433	1986-06-15	1986-06-15 00:00:00	1986-07-06	1986-07-06 00:00:00	1986-07-06	38000177		0	0	21		0	0	0	26238	0	313782	1127433		
236887	5200	40213296	1997-08-27	1997-08-27 00:00:00	1997-08-27	1997-08-27 00:00:00	1997-08-27	581452		0	0	0		0	0	0	345804	0	52	40213296		
146896	3230	40213260	2006-08-30	2006-08-30 00:00:00	2006-08-30	2006-08-30 00:00:00	2006-08-30	581452		0	0	0		0	0	0	214684	0	121	40213260		
15352	1282	19073183	1980-09-09	1980-09-09 00:00:00	1980-09-23	1980-09-23 00:00:00	1980-09-23	38000177		0	0	14		0	0	0	84741	0	308182	19073183		
50235	4168	1713671	1998-08-31	1998-08-31 00:00:00	1998-09-07	1998-09-07 00:00:00	1998-09-07	38000177		0	0	7		0	0	0	277039	0	562251	1713671		
60773	5053	1713671	1989-06-13	1989-06-13 00:00:00	1989-06-20	1989-06-20 00:00:00	1989-06-20	38000177		0	0	7		0	0	0	336041	0	562251	1713671		
43153	3576	19129655	1969-07-28	1969-07-28 00:00:00	1969-08-11	1969-08-11 00:00:00	1969-08-11	38000177		0	0	14		0	0	0	237719	0	789980	19129655		
162415	3571	40213227	2004-04-20	2004-04-20 00:00:00	2004-04-20	2004-04-20 00:00:00	2004-04-20	581452		0	0	0		0	0	0	237388	0	113	40213227		
107564	2357	40213227	2000-01-18	2000-01-18 00:00:00	2000-01-18	2000-01-18 00:00:00	2000-01-18	581452		0	0	0		0	0	0	157069	0	113	40213227		
59067	4909	19129655	1975-07-16	1975-07-16 00:00:00	1975-07-30	1975-07-30 00:00:00	1975-07-30	38000177		0	0	14		0	0	0	326245	0	789980	19129655		
6695	564	19006318	1956-07-16	1956-07-16 00:00:00	1956-07-30	1956-07-30 00:00:00	1956-07-30	38000177		0	0	14		0	0	0	37384	0	105078	19006318		
64308	5337	19059056	1971-12-14	1971-12-14 00:00:00	1971-12-28	1971-12-28 00:00:00	1971-12-28	38000177		0	0	14		0	0	0	355466	0	243670	19059056		
178644	3927	40213227	2008-04-01	2008-04-01 00:00:00	2008-04-01	2008-04-01 00:00:00	2008-04-01	581452		0	0	0		0	0	0	261026	0	113	40213227		
189514	4160	40213296	2002-07-11	2002-07-11 00:00:00	2002-07-11	2002-07-11 00:00:00	2002-07-11	581452		0	0	0		0	0	0	276434	0	52	40213296		
67110	1468	40213160	1955-06-01	1955-06-01 00:00:00	1955-06-01	1955-06-01 00:00:00	1955-06-01	581452		0	0	0		0	0	0	97884	0	10	40213160		
1973	43	40213160	1957-08-26	1957-08-26 00:00:00	1957-08-26	1957-08-26 00:00:00	1957-08-26	581452		0	0	0		0	0	0	3178	0	10	40213160		
171100	3761	40213227	1998-06-27	1998-06-27 00:00:00	1998-06-27	1998-06-27 00:00:00	1998-06-27	581452		0	0	0		0	0	0	250044	0	113	40213227		
39279	3246	19059056	1990-04-27	1990-04-27 00:00:00	1990-05-18	1990-05-18 00:00:00	1990-05-18	38000177		0	0	21		0	0	0	215820	0	243670	19059056		
175682	3862	40213260	2006-02-01	2006-02-01 00:00:00	2006-02-01	2006-02-01 00:00:00	2006-02-01	581452		0	0	0		0	0	0	256447	0	121	40213260		
49811	4133	1127433	1985-04-15	1985-04-15 00:00:00	1985-04-22	1985-04-22 00:00:00	1985-04-22	38000177		0	0	7		0	0	0	274764	0	313782	1127433		
33026	2739	19077572	2009-04-22	2009-04-22 00:00:00	2009-04-22	2009-04-22 00:00:00	\N	38000177		0	0	0		0	0	0	181247	0	310436	19077572		
95825	2100	40213201	2010-01-11	2010-01-11 00:00:00	2010-01-11	2010-01-11 00:00:00	2010-01-11	581452		0	0	0		0	0	0	139997	0	33	40213201		
15176	1267	19059056	1968-03-29	1968-03-29 00:00:00	1968-04-19	1968-04-19 00:00:00	1968-04-19	38000177		0	0	21		0	0	0	83566	0	243670	19059056		
10310	863	1127433	1985-03-23	1985-03-23 00:00:00	1985-04-13	1985-04-13 00:00:00	1985-04-13	38000177		0	0	21		0	0	0	57179	0	313782	1127433		
193199	4243	40213260	2018-01-19	2018-01-19 00:00:00	2018-01-19	2018-01-19 00:00:00	2018-01-19	581452		0	0	0		0	0	0	281807	0	121	40213260		
3892	84	40213227	2005-07-28	2005-07-28 00:00:00	2005-07-28	2005-07-28 00:00:00	2005-07-28	581452		0	0	0		0	0	0	5686	0	113	40213227		
110656	2431	40213227	2004-10-20	2004-10-20 00:00:00	2004-10-20	2004-10-20 00:00:00	2004-10-20	581452		0	0	0		0	0	0	161186	0	113	40213227		
239575	5258	40213160	1958-11-05	1958-11-05 00:00:00	1958-11-05	1958-11-05 00:00:00	1958-11-05	581452		0	0	0		0	0	0	349895	0	10	40213160		
15320	331	40213227	1996-07-04	1996-07-04 00:00:00	1996-07-04	1996-07-04 00:00:00	1996-07-04	581452		0	0	0		0	0	0	21869	0	113	40213227		
193734	4256	40213160	1956-03-11	1956-03-11 00:00:00	1956-03-11	1956-03-11 00:00:00	1956-03-11	581452		0	0	0		0	0	0	282628	0	10	40213160		
157286	3462	40213160	1965-09-03	1965-09-03 00:00:00	1965-09-03	1965-09-03 00:00:00	1965-09-03	581452		0	0	0		0	0	0	229722	0	10	40213160		
210081	4606	40213314	1982-07-15	1982-07-15 00:00:00	1982-07-15	1982-07-15 00:00:00	1982-07-15	581452		0	0	0		0	0	0	306824	0	49	40213314		
91664	2012	40213160	1957-10-11	1957-10-11 00:00:00	1957-10-11	1957-10-11 00:00:00	1957-10-11	581452		0	0	0		0	0	0	133882	0	10	40213160		
63440	1387	40213227	1992-03-31	1992-03-31 00:00:00	1992-03-31	1992-03-31 00:00:00	1992-03-31	581452		0	0	0		0	0	0	92083	0	113	40213227		
12783	1076	1713671	2008-04-01	2008-04-01 00:00:00	2008-04-15	2008-04-15 00:00:00	2008-04-15	38000177		0	0	14		0	0	0	70522	0	562251	1713671		
191713	4212	40213227	2011-11-11	2011-11-11 00:00:00	2011-11-11	2011-11-11 00:00:00	2011-11-11	581452		0	0	0		0	0	0	279678	0	113	40213227		
22508	1850	1713671	1993-09-12	1993-09-12 00:00:00	1993-09-19	1993-09-19 00:00:00	1993-09-19	38000177		0	0	7		0	0	0	123757	0	562251	1713671		
19190	1585	19075001	1987-04-12	1987-04-12 00:00:00	1987-04-26	1987-04-26 00:00:00	1987-04-26	38000177		0	0	14		0	0	0	106336	0	309097	19075001		
49374	4094	40229134	1958-09-09	1958-09-09 00:00:00	1958-09-23	1958-09-23 00:00:00	1958-09-23	38000177		0	0	14		0	0	0	272138	0	1043400	40229134		
226695	4977	40213227	2002-07-06	2002-07-06 00:00:00	2002-07-06	2002-07-06 00:00:00	2002-07-06	581452		0	0	0		0	0	0	331175	0	113	40213227		
153116	3371	40213314	1977-01-21	1977-01-21 00:00:00	1977-01-21	1977-01-21 00:00:00	1977-01-21	581452		0	0	0		0	0	0	223543	0	49	40213314		
51245	4256	19059056	1957-08-29	1957-08-29 00:00:00	1957-09-12	1957-09-12 00:00:00	1957-09-12	38000177		0	0	14		0	0	0	282613	0	243670	19059056		
5035	419	19059056	1979-12-26	1979-12-26 00:00:00	1980-03-25	1980-03-25 00:00:00	1980-03-25	38000177		0	0	90		0	0	0	27712	0	243670	19059056		
225564	4952	40213160	1974-10-19	1974-10-19 00:00:00	1974-10-19	1974-10-19 00:00:00	1974-10-19	581452		0	0	0		0	0	0	329134	0	10	40213160		
61850	5145	40236824	1978-10-21	1978-10-21 00:00:00	1978-10-28	1978-10-28 00:00:00	1978-10-28	38000177		0	0	7		0	0	0	342033	0	1094107	40236824		
143241	3147	40213227	2008-04-14	2008-04-14 00:00:00	2008-04-14	2008-04-14 00:00:00	2008-04-14	581452		0	0	0		0	0	0	209388	0	113	40213227		
4456	370	40162522	1979-08-09	1979-08-09 00:00:00	1979-08-09	1979-08-09 00:00:00	\N	38000177		0	0	0		0	0	0	24584	0	857005	40162522		
26305	2164	1127433	1978-08-30	1978-08-30 00:00:00	1978-09-13	1978-09-13 00:00:00	1978-09-13	38000177		0	0	14		0	0	0	144180	0	313782	1127433		
9868	826	1127078	1963-11-18	1963-11-18 00:00:00	1963-12-02	1963-12-02 00:00:00	1963-12-02	38000177		0	0	14		0	0	0	54708	0	282464	1127078		
164949	3626	40213227	2005-06-04	2005-06-04 00:00:00	2005-06-04	2005-06-04 00:00:00	2005-06-04	581452		0	0	0		0	0	0	241174	0	113	40213227		
116297	2555	40213160	1955-02-16	1955-02-16 00:00:00	1955-02-16	1955-02-16 00:00:00	1955-02-16	581452		0	0	0		0	0	0	169301	0	10	40213160		
148985	3277	40213296	2004-04-02	2004-04-02 00:00:00	2004-04-02	2004-04-02 00:00:00	2004-04-02	581452		0	0	0		0	0	0	217707	0	52	40213296		
20531	1690	19128022	1997-08-08	1997-08-08 00:00:00	1998-08-03	1998-08-03 00:00:00	1998-08-03	38000177		0	0	360		0	0	0	113209	0	749785	19128022		
58829	4886	40231925	1982-06-07	1982-06-07 00:00:00	1982-06-07	1982-06-07 00:00:00	\N	38000177		0	0	0		0	0	0	324933	0	1049221	40231925		
58883	4890	40236824	1979-01-24	1979-01-24 00:00:00	1979-01-31	1979-01-31 00:00:00	1979-01-31	38000177		0	0	7		0	0	0	325065	0	1094107	40236824		
11164	929	19059056	1932-07-26	1932-07-26 00:00:00	1932-08-09	1932-08-09 00:00:00	1932-08-09	38000177		0	0	14		0	0	0	61754	0	243670	19059056		
19946	1636	19133873	1969-05-09	1969-05-09 00:00:00	1969-05-19	1969-05-19 00:00:00	1969-05-19	38000177		0	0	10		0	0	0	109898	0	834061	19133873		
13676	295	40213227	1992-05-27	1992-05-27 00:00:00	1992-05-27	1992-05-27 00:00:00	1992-05-27	581452		0	0	0		0	0	0	19564	0	113	40213227		
20054	1646	19073188	2017-12-31	2017-12-31 00:00:00	2018-01-14	2018-01-14 00:00:00	2018-01-14	38000177		0	0	14		0	0	0	110431	0	308192	19073188		
46961	3889	19078461	2018-05-06	2018-05-06 00:00:00	2018-05-27	2018-05-27 00:00:00	2018-05-27	38000177		0	0	21		0	0	0	258519	0	310965	19078461		
56351	4675	40163554	1998-11-29	1998-11-29 00:00:00	1998-11-29	1998-11-29 00:00:00	\N	38000177		0	0	0		0	0	0	311529	0	855332	40163554		
3734	310	19006318	1951-09-06	1951-09-06 00:00:00	1951-09-20	1951-09-20 00:00:00	1951-09-20	38000177		0	0	14		0	0	0	20525	0	105078	19006318		
4777	399	1118084	1997-05-07	1997-05-07 00:00:00	1997-05-07	1997-05-07 00:00:00	\N	38000177		0	0	0		0	0	0	26231	0	00025152531	44923712		
236888	5200	40213160	1956-01-25	1956-01-25 00:00:00	1956-01-25	1956-01-25 00:00:00	1956-01-25	581452		0	0	0		0	0	0	345815	0	10	40213160		
146900	3230	40213160	1956-02-01	1956-02-01 00:00:00	1956-02-01	1956-02-01 00:00:00	1956-02-01	581452		0	0	0		0	0	0	214674	0	10	40213160		
15353	1282	1713671	2015-02-10	2015-02-10 00:00:00	2015-02-24	2015-02-24 00:00:00	2015-02-24	38000177		0	0	14		0	0	0	84724	0	562251	1713671		
50236	4168	1127433	1973-12-20	1973-12-20 00:00:00	1974-01-03	1974-01-03 00:00:00	1974-01-03	38000177		0	0	14		0	0	0	277042	0	313782	1127433		
60774	5053	1127433	1979-08-27	1979-08-27 00:00:00	1979-09-10	1979-09-10 00:00:00	1979-09-10	38000177		0	0	14		0	0	0	335990	0	313782	1127433		
43155	3576	1713671	1995-08-17	1995-08-17 00:00:00	1995-08-24	1995-08-24 00:00:00	1995-08-24	38000177		0	0	7		0	0	0	237717	0	562251	1713671		
162427	3572	40213260	2006-03-22	2006-03-22 00:00:00	2006-03-22	2006-03-22 00:00:00	2006-03-22	581452		0	0	0		0	0	0	237513	0	121	40213260		
107566	2357	40213201	2005-02-01	2005-02-01 00:00:00	2005-02-01	2005-02-01 00:00:00	2005-02-01	581452		0	0	0		0	0	0	157085	0	33	40213201		
59068	4909	1118084	2008-08-26	2008-08-26 00:00:00	2008-08-26	2008-08-26 00:00:00	\N	38000177		0	0	0		0	0	0	326265	0	00025152531	44923712		
6696	565	1124300	1994-09-28	1994-09-28 00:00:00	1994-09-28	1994-09-28 00:00:00	\N	38000177		0	0	0		0	0	0	37439	0	00781178901	45011828		
64309	5337	19129655	1971-12-14	1971-12-14 00:00:00	1971-12-28	1971-12-28 00:00:00	1971-12-28	38000177		0	0	14		0	0	0	355466	0	789980	19129655		
178648	3927	40213227	2018-05-29	2018-05-29 00:00:00	2018-05-29	2018-05-29 00:00:00	2018-05-29	581452		0	0	0		0	0	0	261057	0	113	40213227		
189520	4160	40213260	2014-06-19	2014-06-19 00:00:00	2014-06-19	2014-06-19 00:00:00	2014-06-19	581452		0	0	0		0	0	0	276410	0	121	40213260		
67116	1468	40213227	1993-07-14	1993-07-14 00:00:00	1993-07-14	1993-07-14 00:00:00	1993-07-14	581452		0	0	0		0	0	0	97837	0	113	40213227		
242186	5317	40213160	1973-05-16	1973-05-16 00:00:00	1973-05-16	1973-05-16 00:00:00	1973-05-16	581452		0	0	0		0	0	0	353622	0	10	40213160		
171101	3761	40213296	1998-06-27	1998-06-27 00:00:00	1998-06-27	1998-06-27 00:00:00	1998-06-27	581452		0	0	0		0	0	0	250044	0	52	40213296		
39280	3246	1127433	2009-05-16	2009-05-16 00:00:00	2009-05-30	2009-05-30 00:00:00	2009-05-30	38000177		0	0	14		0	0	0	215780	0	313782	1127433		
175683	3862	40213296	1998-02-11	1998-02-11 00:00:00	1998-02-11	1998-02-11 00:00:00	1998-02-11	581452		0	0	0		0	0	0	256410	0	52	40213296		
49812	4133	19078461	2005-10-31	2005-10-31 00:00:00	2005-11-14	2005-11-14 00:00:00	2005-11-14	38000177		0	0	14		0	0	0	274782	0	310965	19078461		
33027	2739	1127433	1986-07-23	1986-07-23 00:00:00	1986-08-06	1986-08-06 00:00:00	1986-08-06	38000177		0	0	14		0	0	0	181239	0	313782	1127433		
95833	2100	40213227	2015-02-09	2015-02-09 00:00:00	2015-02-09	2015-02-09 00:00:00	2015-02-09	581452		0	0	0		0	0	0	139955	0	113	40213227		
50805	4222	19006318	1951-09-21	1951-09-21 00:00:00	1951-10-05	1951-10-05 00:00:00	1951-10-05	38000177		0	0	14		0	0	0	280288	0	105078	19006318		
10311	863	19059056	1943-08-10	1943-08-10 00:00:00	1943-08-24	1943-08-24 00:00:00	1943-08-24	38000177		0	0	14		0	0	0	57202	0	243670	19059056		
219439	4816	40213160	1982-07-19	1982-07-19 00:00:00	1982-07-19	1982-07-19 00:00:00	1982-07-19	581452		0	0	0		0	0	0	320416	0	10	40213160		
3897	84	40213160	1974-06-20	1974-06-20 00:00:00	1974-06-20	1974-06-20 00:00:00	1974-06-20	581452		0	0	0		0	0	0	5661	0	10	40213160		
110662	2431	40213160	1976-06-30	1976-06-30 00:00:00	1976-06-30	1976-06-30 00:00:00	1976-06-30	581452		0	0	0		0	0	0	161220	0	10	40213160		
239578	5258	40213260	2009-08-05	2009-08-05 00:00:00	2009-08-05	2009-08-05 00:00:00	2009-08-05	581452		0	0	0		0	0	0	349906	0	121	40213260		
15329	331	40213201	2002-01-17	2002-01-17 00:00:00	2002-01-17	2002-01-17 00:00:00	2002-01-17	581452		0	0	0		0	0	0	21846	0	33	40213201		
193738	4256	40213198	2017-12-31	2017-12-31 00:00:00	2017-12-31	2017-12-31 00:00:00	2017-12-31	581452		0	0	0		0	0	0	282645	0	133	40213198		
157294	3462	40213160	1961-06-02	1961-06-02 00:00:00	1961-06-02	1961-06-02 00:00:00	1961-06-02	581452		0	0	0		0	0	0	229744	0	10	40213160		
210090	4606	40213251	1984-01-12	1984-01-12 00:00:00	1984-01-12	1984-01-12 00:00:00	1984-01-12	581452		0	0	0		0	0	0	306826	0	21	40213251		
105518	2315	40213314	1977-10-08	1977-10-08 00:00:00	1977-10-08	1977-10-08 00:00:00	1977-10-08	581452		0	0	0		0	0	0	153923	0	49	40213314		
63441	1387	40213306	1992-03-31	1992-03-31 00:00:00	1992-03-31	1992-03-31 00:00:00	1992-03-31	581452		0	0	0		0	0	0	92083	0	43	40213306		
12784	1076	1127078	1980-10-01	1980-10-01 00:00:00	1980-12-30	1980-12-30 00:00:00	1980-12-30	38000177		0	0	90		0	0	0	70552	0	282464	1127078		
191714	4212	40213296	2011-11-11	2011-11-11 00:00:00	2011-11-11	2011-11-11 00:00:00	2011-11-11	581452		0	0	0		0	0	0	279678	0	52	40213296		
22509	1850	1127433	1976-09-26	1976-09-26 00:00:00	1976-10-17	1976-10-17 00:00:00	1976-10-17	38000177		0	0	21		0	0	0	123734	0	313782	1127433		
19191	1585	1127433	1987-04-12	1987-04-12 00:00:00	1987-04-26	1987-04-26 00:00:00	1987-04-26	38000177		0	0	14		0	0	0	106336	0	313782	1127433		
49375	4094	1115171	2017-10-25	2017-10-25 00:00:00	2017-11-08	2017-11-08 00:00:00	2017-11-08	38000177		0	0	14		0	0	0	272152	0	849574	1115171		
218285	4791	40213160	1967-08-31	1967-08-31 00:00:00	1967-08-31	1967-08-31 00:00:00	1967-08-31	581452		0	0	0		0	0	0	318794	0	10	40213160		
153117	3371	40213160	1976-01-23	1976-01-23 00:00:00	1976-01-23	1976-01-23 00:00:00	1976-01-23	581452		0	0	0		0	0	0	223659	0	10	40213160		
51246	4256	19006318	1957-08-29	1957-08-29 00:00:00	1957-09-12	1957-09-12 00:00:00	1957-09-12	38000177		0	0	14		0	0	0	282613	0	105078	19006318		
5036	419	19059056	1991-07-01	1991-07-01 00:00:00	1991-07-31	1991-07-31 00:00:00	1991-07-31	38000177		0	0	30		0	0	0	27761	0	243670	19059056		
76081	1662	40213227	2006-03-24	2006-03-24 00:00:00	2006-03-24	2006-03-24 00:00:00	2006-03-24	581452		0	0	0		0	0	0	111750	0	113	40213227		
61851	5145	920300	1978-10-21	1978-10-21 00:00:00	1978-10-28	1978-10-28 00:00:00	1978-10-28	38000177		0	0	7		0	0	0	342033	0	311989	920300		
143243	3147	40213227	2018-06-11	2018-06-11 00:00:00	2018-06-11	2018-06-11 00:00:00	2018-06-11	581452		0	0	0		0	0	0	209350	0	113	40213227		
4457	370	1127078	1971-10-06	1971-10-06 00:00:00	1971-10-20	1971-10-20 00:00:00	1971-10-20	38000177		0	0	14		0	0	0	24583	0	282464	1127078		
26306	2164	1127433	2006-09-22	2006-09-22 00:00:00	2006-10-13	2006-10-13 00:00:00	2006-10-13	38000177		0	0	21		0	0	0	144124	0	313782	1127433		
9869	826	1127433	1993-03-16	1993-03-16 00:00:00	1993-03-30	1993-03-30 00:00:00	1993-03-30	38000177		0	0	14		0	0	0	54698	0	313782	1127433		
164951	3626	40213160	1974-11-30	1974-11-30 00:00:00	1974-11-30	1974-11-30 00:00:00	1974-11-30	581452		0	0	0		0	0	0	241128	0	10	40213160		
116308	2555	40213201	2016-09-08	2016-09-08 00:00:00	2016-09-08	2016-09-08 00:00:00	2016-09-08	581452		0	0	0		0	0	0	169311	0	33	40213201		
148986	3277	40213260	2014-05-02	2014-05-02 00:00:00	2014-05-02	2014-05-02 00:00:00	2014-05-02	581452		0	0	0		0	0	0	217709	0	121	40213260		
20532	1690	19128022	1995-08-19	1995-08-19 00:00:00	1996-08-13	1996-08-13 00:00:00	1996-08-13	38000177		0	0	360		0	0	0	113222	0	749785	19128022		
58830	4886	1127433	1982-06-07	1982-06-07 00:00:00	1982-09-05	1982-09-05 00:00:00	1982-09-05	38000177		0	0	90		0	0	0	324933	0	313782	1127433		
58884	4890	920300	1979-01-24	1979-01-24 00:00:00	1979-01-31	1979-01-31 00:00:00	1979-01-31	38000177		0	0	7		0	0	0	325065	0	311989	920300		
11165	929	19075601	1998-01-12	1998-01-12 00:00:00	2005-10-10	2005-10-10 00:00:00	2005-10-10	38000177		0	0	2828		0	0	0	61872	0	309362	19075601		
52267	4348	1118084	2015-01-01	2015-01-01 00:00:00	2015-01-01	2015-01-01 00:00:00	\N	38000177		0	0	0		0	0	0	288359	0	00025152531	44923712		
133028	2921	40213227	1992-06-30	1992-06-30 00:00:00	1992-06-30	1992-06-30 00:00:00	1992-06-30	581452		0	0	0		0	0	0	194758	0	113	40213227		
62821	5222	1127433	2009-10-15	2009-10-15 00:00:00	2009-10-29	2009-10-29 00:00:00	2009-10-29	38000177		0	0	14		0	0	0	347502	0	313782	1127433		
46962	3889	1713671	2018-12-16	2018-12-16 00:00:00	2018-12-23	2018-12-23 00:00:00	2018-12-23	38000177		0	0	7		0	0	0	258506	0	562251	1713671		
56352	4675	19018935	1998-11-29	1998-11-29 00:00:00	1998-11-29	1998-11-29 00:00:00	\N	38000177		0	0	0		0	0	0	311529	0	197604	19018935		
3735	310	1127433	1972-09-08	1972-09-08 00:00:00	1972-09-15	1972-09-15 00:00:00	1972-09-15	38000177		0	0	7		0	0	0	20504	0	313782	1127433		
4778	399	1127433	1999-03-30	1999-03-30 00:00:00	1999-05-04	1999-05-04 00:00:00	1999-05-04	38000177		0	0	35		0	0	0	26239	0	313782	1127433		
236891	5201	40213160	1978-07-12	1978-07-12 00:00:00	1978-07-12	1978-07-12 00:00:00	1978-07-12	581452		0	0	0		0	0	0	345978	0	10	40213160		
146904	3230	40213227	1997-09-03	1997-09-03 00:00:00	1997-09-03	1997-09-03 00:00:00	1997-09-03	581452		0	0	0		0	0	0	214664	0	113	40213227		
15354	1282	1118084	2015-07-13	2015-07-13 00:00:00	2015-07-13	2015-07-13 00:00:00	\N	38000177		0	0	0		0	0	0	84724	0	00025152531	44923712		
50237	4168	1713671	1977-09-10	1977-09-10 00:00:00	1977-09-17	1977-09-17 00:00:00	1977-09-17	38000177		0	0	7		0	0	0	277036	0	562251	1713671		
60775	5053	19078461	2013-09-22	2013-09-22 00:00:00	2013-10-13	2013-10-13 00:00:00	2013-10-13	38000177		0	0	21		0	0	0	336023	0	310965	19078461		
43156	3576	1124300	2000-05-21	2000-05-21 00:00:00	2000-05-21	2000-05-21 00:00:00	\N	38000177		0	0	0		0	0	0	237736	0	00781178901	45011828		
202483	4446	40213227	2011-07-05	2011-07-05 00:00:00	2011-07-05	2011-07-05 00:00:00	2011-07-05	581452		0	0	0		0	0	0	295682	0	113	40213227		
31390	2602	1127433	1959-08-18	1959-08-18 00:00:00	1959-08-25	1959-08-25 00:00:00	1959-08-25	38000177		0	0	7		0	0	0	172106	0	313782	1127433		
59069	4909	40236824	1999-07-08	1999-07-08 00:00:00	1999-07-15	1999-07-15 00:00:00	1999-07-15	38000177		0	0	7		0	0	0	326257	0	1094107	40236824		
6697	565	19006318	1963-05-15	1963-05-15 00:00:00	1963-05-29	1963-05-29 00:00:00	1963-05-29	38000177		0	0	14		0	0	0	37407	0	105078	19006318		
64310	5337	19059056	1973-10-04	1973-10-04 00:00:00	1973-11-03	1973-11-03 00:00:00	1973-11-03	38000177		0	0	30		0	0	0	355386	0	243670	19059056		
178652	3927	40213201	2013-04-30	2013-04-30 00:00:00	2013-04-30	2013-04-30 00:00:00	2013-04-30	581452		0	0	0		0	0	0	261039	0	33	40213201		
189521	4160	40213227	2014-06-19	2014-06-19 00:00:00	2014-06-19	2014-06-19 00:00:00	2014-06-19	581452		0	0	0		0	0	0	276410	0	113	40213227		
67120	1468	40213227	2011-05-11	2011-05-11 00:00:00	2011-05-11	2011-05-11 00:00:00	2011-05-11	581452		0	0	0		0	0	0	97840	0	113	40213227		
166765	3666	40213296	2000-01-06	2000-01-06 00:00:00	2000-01-06	2000-01-06 00:00:00	2000-01-06	581452		0	0	0		0	0	0	243929	0	52	40213296		
107073	2346	40213227	2007-04-11	2007-04-11 00:00:00	2007-04-11	2007-04-11 00:00:00	2007-04-11	581452		0	0	0		0	0	0	156187	0	113	40213227		
39281	3246	1118084	2016-12-31	2016-12-31 00:00:00	2016-12-31	2016-12-31 00:00:00	\N	38000177		0	0	0		0	0	0	215778	0	00025152531	44923712		
175685	3862	40213227	1998-02-11	1998-02-11 00:00:00	1998-02-11	1998-02-11 00:00:00	1998-02-11	581452		0	0	0		0	0	0	256410	0	113	40213227		
49813	4133	1127433	2005-05-02	2005-05-02 00:00:00	2005-05-16	2005-05-16 00:00:00	2005-05-16	38000177		0	0	14		0	0	0	274786	0	313782	1127433		
33028	2739	1127078	1956-05-31	1956-05-31 00:00:00	1956-06-14	1956-06-14 00:00:00	1956-06-14	38000177		0	0	14		0	0	0	181190	0	282464	1127078		
204162	4482	40213227	1992-02-15	1992-02-15 00:00:00	1992-02-15	1992-02-15 00:00:00	1992-02-15	581452		0	0	0		0	0	0	298330	0	113	40213227		
50806	4222	19059056	1951-09-21	1951-09-21 00:00:00	1951-10-05	1951-10-05 00:00:00	1951-10-05	38000177		0	0	14		0	0	0	280288	0	243670	19059056		
10312	863	19059056	1930-02-16	1930-02-16 00:00:00	1930-03-09	1930-03-09 00:00:00	1930-03-09	38000177		0	0	21		0	0	0	57206	0	243670	19059056		
219446	4816	40213251	1986-10-20	1986-10-20 00:00:00	1986-10-20	1986-10-20 00:00:00	1986-10-20	581452		0	0	0		0	0	0	320409	0	21	40213251		
3901	84	40213306	1996-11-14	1996-11-14 00:00:00	1996-11-14	1996-11-14 00:00:00	1996-11-14	581452		0	0	0		0	0	0	\N	0	43	40213306		
121722	2675	40213306	1983-07-03	1983-07-03 00:00:00	1983-07-03	1983-07-03 00:00:00	1983-07-03	581452		0	0	0		0	0	0	177294	0	43	40213306		
239579	5258	40213227	2009-08-05	2009-08-05 00:00:00	2009-08-05	2009-08-05 00:00:00	2009-08-05	581452		0	0	0		0	0	0	349906	0	113	40213227		
242188	5317	40213296	2016-09-21	2016-09-21 00:00:00	2016-09-21	2016-09-21 00:00:00	2016-09-21	581452		0	0	0		0	0	0	353644	0	52	40213296		
193741	4256	40213160	1957-09-15	1957-09-15 00:00:00	1957-09-15	1957-09-15 00:00:00	1957-09-15	581452		0	0	0		0	0	0	282629	0	10	40213160		
157297	3462	40213227	1992-11-27	1992-11-27 00:00:00	1992-11-27	1992-11-27 00:00:00	1992-11-27	581452		0	0	0		0	0	0	229766	0	113	40213227		
210097	4607	40213160	1976-10-21	1976-10-21 00:00:00	1976-10-21	1976-10-21 00:00:00	1976-10-21	581452		0	0	0		0	0	0	306899	0	10	40213160		
105519	2315	40213160	1977-10-08	1977-10-08 00:00:00	1977-10-08	1977-10-08 00:00:00	1977-10-08	581452		0	0	0		0	0	0	153923	0	10	40213160		
63446	1387	40213160	1969-07-08	1969-07-08 00:00:00	1969-07-08	1969-07-08 00:00:00	1969-07-08	581452		0	0	0		0	0	0	92054	0	10	40213160		
12785	1076	19128022	1994-04-01	1994-04-01 00:00:00	1995-03-27	1995-03-27 00:00:00	1995-03-27	38000177		0	0	360		0	0	0	70523	0	749785	19128022		
191717	4212	40213160	1974-10-11	1974-10-11 00:00:00	1974-10-11	1974-10-11 00:00:00	1974-10-11	581452		0	0	0		0	0	0	279640	0	10	40213160		
22510	1850	19059056	1961-12-23	1961-12-23 00:00:00	1962-02-21	1962-02-21 00:00:00	1962-02-21	38000177		0	0	60		0	0	0	123732	0	243670	19059056		
19192	1585	1127433	1949-02-15	1949-02-15 00:00:00	1949-02-22	1949-02-22 00:00:00	1949-02-22	38000177		0	0	7		0	0	0	106303	0	313782	1127433		
49376	4094	40229134	1992-09-27	1992-09-27 00:00:00	1992-10-04	1992-10-04 00:00:00	1992-10-04	38000177		0	0	7		0	0	0	272125	0	1043400	40229134		
218287	4791	40213160	1967-11-02	1967-11-02 00:00:00	1967-11-02	1967-11-02 00:00:00	1967-11-02	581452		0	0	0		0	0	0	318786	0	10	40213160		
153121	3371	40213227	1998-01-23	1998-01-23 00:00:00	1998-01-23	1998-01-23 00:00:00	1998-01-23	581452		0	0	0		0	0	0	223587	0	113	40213227		
51267	4260	19133873	1940-05-02	1940-05-02 00:00:00	1940-05-15	1940-05-15 00:00:00	1940-05-15	38000177		0	0	13		0	0	0	282808	0	834061	19133873		
5037	419	19059056	1923-11-15	1923-11-15 00:00:00	1923-11-29	1923-11-29 00:00:00	1923-11-29	38000177		0	0	14		0	0	0	27708	0	243670	19059056		
76082	1662	40213296	2006-03-24	2006-03-24 00:00:00	2006-03-24	2006-03-24 00:00:00	2006-03-24	581452		0	0	0		0	0	0	111750	0	52	40213296		
61852	5145	40231925	1979-08-26	1979-08-26 00:00:00	1979-08-26	1979-08-26 00:00:00	\N	38000177		0	0	0		0	0	0	342078	0	1049221	40231925		
136300	2992	40213296	1997-12-05	1997-12-05 00:00:00	1997-12-05	1997-12-05 00:00:00	1997-12-05	581452		0	0	0		0	0	0	199723	0	52	40213296		
4458	370	46233988	1970-03-15	1970-03-15 00:00:00	1970-03-29	1970-03-29 00:00:00	1970-03-29	38000177		0	0	14		0	0	0	24601	0	1652673	46233988		
26307	2164	46233988	1973-08-25	1973-08-25 00:00:00	1973-09-08	1973-09-08 00:00:00	1973-09-08	38000177		0	0	14		0	0	0	144127	0	1652673	46233988		
9871	826	1713671	1989-11-02	1989-11-02 00:00:00	1989-11-16	1989-11-16 00:00:00	1989-11-16	38000177		0	0	14		0	0	0	54703	0	562251	1713671		
164956	3626	40213160	1974-08-31	1974-08-31 00:00:00	1974-08-31	1974-08-31 00:00:00	1974-08-31	581452		0	0	0		0	0	0	241159	0	10	40213160		
116323	2555	40213227	2011-04-28	2011-04-28 00:00:00	2011-04-28	2011-04-28 00:00:00	2011-04-28	581452		0	0	0		0	0	0	169283	0	113	40213227		
148990	3277	40213227	2004-04-02	2004-04-02 00:00:00	2004-04-02	2004-04-02 00:00:00	2004-04-02	581452		0	0	0		0	0	0	217707	0	113	40213227		
20533	1690	19128065	1991-09-09	1991-09-09 00:00:00	1992-09-03	1992-09-03 00:00:00	1992-09-03	38000177		0	0	360		0	0	0	113189	0	749882	19128065		
58831	4886	1127433	1979-09-25	1979-09-25 00:00:00	1979-10-02	1979-10-02 00:00:00	1979-10-02	38000177		0	0	7		0	0	0	324940	0	313782	1127433		
58885	4890	19059056	1927-01-11	1927-01-11 00:00:00	1927-02-01	1927-02-01 00:00:00	1927-02-01	38000177		0	0	21		0	0	0	325142	0	243670	19059056		
11166	929	19133905	1965-10-04	1965-10-04 00:00:00	1965-10-17	1965-10-17 00:00:00	1965-10-17	38000177		0	0	13		0	0	0	61824	0	834102	19133905		
52268	4348	1154615	1985-10-27	1985-10-27 00:00:00	1985-10-27	1985-10-27 00:00:00	\N	38000177		0	0	0		0	0	0	288327	0	745679	1154615		
133029	2921	40213201	2006-09-19	2006-09-19 00:00:00	2006-09-19	2006-09-19 00:00:00	2006-09-19	581452		0	0	0		0	0	0	194749	0	33	40213201		
62822	5222	19133873	1922-12-21	1922-12-21 00:00:00	1922-12-30	1922-12-30 00:00:00	1922-12-30	38000177		0	0	9		0	0	0	347509	0	834061	19133873		
46963	3889	1127433	1954-02-03	1954-02-03 00:00:00	1954-02-10	1954-02-10 00:00:00	1954-02-10	38000177		0	0	7		0	0	0	258452	0	313782	1127433		
56353	4675	40171902	1998-11-29	1998-11-29 00:00:00	1998-11-29	1998-11-29 00:00:00	\N	38000177		0	0	0		0	0	0	311529	0	897718	40171902		
3736	310	1127433	1981-06-14	1981-06-14 00:00:00	1981-07-05	1981-07-05 00:00:00	1981-07-05	38000177		0	0	21		0	0	0	20497	0	313782	1127433		
4779	399	40229134	2016-12-01	2016-12-01 00:00:00	2016-12-15	2016-12-15 00:00:00	2016-12-15	38000177		0	0	14		0	0	0	26156	0	1043400	40229134		
236892	5201	40213314	1978-07-12	1978-07-12 00:00:00	1978-07-12	1978-07-12 00:00:00	1978-07-12	581452		0	0	0		0	0	0	345978	0	49	40213314		
146905	3230	40213296	1997-09-03	1997-09-03 00:00:00	1997-09-03	1997-09-03 00:00:00	1997-09-03	581452		0	0	0		0	0	0	214664	0	52	40213296		
15355	1282	19128065	1993-03-22	1993-03-22 00:00:00	1994-03-17	1994-03-17 00:00:00	1994-03-17	38000177		0	0	360		0	0	0	84761	0	749882	19128065		
50272	4173	19133873	1974-03-03	1974-03-03 00:00:00	1974-03-11	1974-03-11 00:00:00	1974-03-11	38000177		0	0	8		0	0	0	277369	0	834061	19133873		
60776	5053	1127433	1992-07-18	1992-07-18 00:00:00	1992-08-01	1992-08-01 00:00:00	1992-08-01	38000177		0	0	14		0	0	0	336020	0	313782	1127433		
43157	3576	1127433	1994-11-19	1994-11-19 00:00:00	1994-11-26	1994-11-26 00:00:00	1994-11-26	38000177		0	0	7		0	0	0	237711	0	313782	1127433		
202485	4446	40213260	2011-07-05	2011-07-05 00:00:00	2011-07-05	2011-07-05 00:00:00	2011-07-05	581452		0	0	0		0	0	0	295682	0	121	40213260		
31391	2602	40243436	1964-11-04	1964-11-04 00:00:00	1964-11-04	1964-11-04 00:00:00	1964-11-04	38000177		0	0	0		0	0	0	172145	0	1190795	40243436		
59070	4909	920300	1999-07-08	1999-07-08 00:00:00	1999-07-15	1999-07-15 00:00:00	1999-07-15	38000177		0	0	7		0	0	0	326257	0	311989	920300		
6698	565	1127078	1963-05-15	1963-05-15 00:00:00	1963-05-29	1963-05-29 00:00:00	1963-05-29	38000177		0	0	14		0	0	0	37407	0	282464	1127078		
128610	2829	40213198	2015-11-30	2015-11-30 00:00:00	2015-11-30	2015-11-30 00:00:00	2015-11-30	581452		0	0	0		0	0	0	187684	0	133	40213198		
178679	3927	40213198	2012-04-24	2012-04-24 00:00:00	2012-04-24	2012-04-24 00:00:00	2012-04-24	581452		0	0	0		0	0	0	261028	0	133	40213198		
189523	4160	40213160	1962-10-11	1962-10-11 00:00:00	1962-10-11	1962-10-11 00:00:00	1962-10-11	581452		0	0	0		0	0	0	276477	0	10	40213160		
211127	4630	40213160	1959-03-19	1959-03-19 00:00:00	1959-03-19	1959-03-19 00:00:00	1959-03-19	581452		0	0	0		0	0	0	308454	0	10	40213160		
166772	3666	40213227	2002-01-10	2002-01-10 00:00:00	2002-01-10	2002-01-10 00:00:00	2002-01-10	581452		0	0	0		0	0	0	243871	0	113	40213227		
107075	2347	40213160	1969-03-10	1969-03-10 00:00:00	1969-03-10	1969-03-10 00:00:00	1969-03-10	581452		0	0	0		0	0	0	156228	0	10	40213160		
39282	3246	1127433	2012-07-29	2012-07-29 00:00:00	2012-08-05	2012-08-05 00:00:00	2012-08-05	38000177		0	0	7		0	0	0	215792	0	313782	1127433		
105964	2325	40213160	1971-07-08	1971-07-08 00:00:00	1971-07-08	1971-07-08 00:00:00	1971-07-08	581452		0	0	0		0	0	0	154624	0	10	40213160		
49814	4133	1127433	2004-11-14	2004-11-14 00:00:00	2004-12-05	2004-12-05 00:00:00	2004-12-05	38000177		0	0	21		0	0	0	274781	0	313782	1127433		
33029	2739	19006318	1956-05-31	1956-05-31 00:00:00	1956-06-14	1956-06-14 00:00:00	1956-06-14	38000177		0	0	14		0	0	0	181190	0	105078	19006318		
187064	4109	40213227	2016-04-05	2016-04-05 00:00:00	2016-04-05	2016-04-05 00:00:00	2016-04-05	581452		0	0	0		0	0	0	273223	0	113	40213227		
50807	4222	40236824	1970-07-05	1970-07-05 00:00:00	1970-07-12	1970-07-12 00:00:00	1970-07-12	38000177		0	0	7		0	0	0	280339	0	1094107	40236824		
10313	863	19018935	1981-01-29	1981-01-29 00:00:00	1981-01-29	1981-01-29 00:00:00	\N	38000177		0	0	0		0	0	0	57216	0	197604	19018935		
219449	4816	40213160	1986-10-20	1986-10-20 00:00:00	1986-10-20	1986-10-20 00:00:00	1986-10-20	581452		0	0	0		0	0	0	320409	0	10	40213160		
3904	84	40213227	2016-03-24	2016-03-24 00:00:00	2016-03-24	2016-03-24 00:00:00	2016-03-24	581452		0	0	0		0	0	0	5648	0	113	40213227		
121727	2675	40213227	1993-02-28	1993-02-28 00:00:00	1993-02-28	1993-02-28 00:00:00	1993-02-28	581452		0	0	0		0	0	0	177295	0	113	40213227		
239582	5258	40213227	1999-11-17	1999-11-17 00:00:00	1999-11-17	1999-11-17 00:00:00	1999-11-17	581452		0	0	0		0	0	0	349903	0	113	40213227		
242193	5317	40213160	1973-03-14	1973-03-14 00:00:00	1973-03-14	1973-03-14 00:00:00	1973-03-14	581452		0	0	0		0	0	0	353641	0	10	40213160		
193746	4256	40213160	1955-03-13	1955-03-13 00:00:00	1955-03-13	1955-03-13 00:00:00	1955-03-13	581452		0	0	0		0	0	0	282597	0	10	40213160		
157301	3462	40213306	1983-11-18	1983-11-18 00:00:00	1983-11-18	1983-11-18 00:00:00	1983-11-18	581452		0	0	0		0	0	0	229751	0	43	40213306		
210105	4607	40213227	2004-01-29	2004-01-29 00:00:00	2004-01-29	2004-01-29 00:00:00	2004-01-29	581452		0	0	0		0	0	0	306931	0	113	40213227		
105523	2315	40213160	1982-04-10	1982-04-10 00:00:00	1982-04-10	1982-04-10 00:00:00	1982-04-10	581452		0	0	0		0	0	0	153927	0	10	40213160		
55136	1208	40213201	2006-01-17	2006-01-17 00:00:00	2006-01-17	2006-01-17 00:00:00	2006-01-17	581452		0	0	0		0	0	0	79386	0	33	40213201		
12786	1076	1127433	1974-05-07	1974-05-07 00:00:00	1974-05-14	1974-05-14 00:00:00	1974-05-14	38000177		0	0	7		0	0	0	70563	0	313782	1127433		
32892	719	40213227	2003-08-15	2003-08-15 00:00:00	2003-08-15	2003-08-15 00:00:00	2003-08-15	581452		0	0	0		0	0	0	47581	0	113	40213227		
22511	1850	1118084	1998-07-22	1998-07-22 00:00:00	1998-07-22	1998-07-22 00:00:00	\N	38000177		0	0	0		0	0	0	123742	0	00025152531	44923712		
19193	1585	1127433	1960-11-17	1960-11-17 00:00:00	1960-12-01	1960-12-01 00:00:00	1960-12-01	38000177		0	0	14		0	0	0	106348	0	313782	1127433		
13305	1115	1127433	2000-10-11	2000-10-11 00:00:00	2000-10-25	2000-10-25 00:00:00	2000-10-25	38000177		0	0	14		0	0	0	73373	0	313782	1127433		
218288	4791	40213160	1972-03-23	1972-03-23 00:00:00	1972-03-23	1972-03-23 00:00:00	1972-03-23	581452		0	0	0		0	0	0	318763	0	10	40213160		
153122	3371	40213306	1998-01-23	1998-01-23 00:00:00	1998-01-23	1998-01-23 00:00:00	1998-01-23	581452		0	0	0		0	0	0	223587	0	43	40213306		
51268	4260	1713671	1973-10-28	1973-10-28 00:00:00	1973-11-18	1973-11-18 00:00:00	1973-11-18	38000177		0	0	21		0	0	0	282784	0	562251	1713671		
5038	419	19059056	1969-07-21	1969-07-21 00:00:00	1969-08-20	1969-08-20 00:00:00	1969-08-20	38000177		0	0	30		0	0	0	27711	0	243670	19059056		
76088	1662	40213296	2004-03-19	2004-03-19 00:00:00	2004-03-19	2004-03-19 00:00:00	2004-03-19	581452		0	0	0		0	0	0	111765	0	52	40213296		
61853	5145	19059056	1979-08-26	1979-08-26 00:00:00	1979-09-23	1979-09-23 00:00:00	1979-09-23	38000177		0	0	28		0	0	0	342078	0	243670	19059056		
136304	2992	40213227	1997-12-05	1997-12-05 00:00:00	1997-12-05	1997-12-05 00:00:00	1997-12-05	581452		0	0	0		0	0	0	199723	0	113	40213227		
4459	370	1127078	1970-03-15	1970-03-15 00:00:00	1970-03-29	1970-03-29 00:00:00	1970-03-29	38000177		0	0	14		0	0	0	24601	0	282464	1127078		
26308	2164	19059056	1973-08-25	1973-08-25 00:00:00	1973-09-08	1973-09-08 00:00:00	1973-09-08	38000177		0	0	14		0	0	0	144127	0	243670	19059056		
9872	826	19078461	2014-10-21	2014-10-21 00:00:00	2014-11-04	2014-11-04 00:00:00	2014-11-04	38000177		0	0	14		0	0	0	54740	0	310965	19078461		
164959	3626	40213160	1979-03-03	1979-03-03 00:00:00	1979-03-03	1979-03-03 00:00:00	1979-03-03	581452		0	0	0		0	0	0	241144	0	10	40213160		
116329	2556	40213160	1968-04-01	1968-04-01 00:00:00	1968-04-01	1968-04-01 00:00:00	1968-04-01	581452		0	0	0		0	0	0	169422	0	10	40213160		
148992	3277	40213227	2014-05-02	2014-05-02 00:00:00	2014-05-02	2014-05-02 00:00:00	2014-05-02	581452		0	0	0		0	0	0	217709	0	113	40213227		
20534	1690	19128065	1994-08-24	1994-08-24 00:00:00	1995-08-19	1995-08-19 00:00:00	1995-08-19	38000177		0	0	360		0	0	0	113191	0	749882	19128065		
58832	4886	40229134	1984-03-10	1984-03-10 00:00:00	1984-03-17	1984-03-17 00:00:00	1984-03-17	38000177		0	0	7		0	0	0	324937	0	1043400	40229134		
58886	4890	19059056	1972-02-10	1972-02-10 00:00:00	1972-03-18	1972-03-18 00:00:00	1972-03-18	38000177		0	0	37		0	0	0	325145	0	243670	19059056		
11167	929	19078461	1992-09-12	1992-09-12 00:00:00	1992-09-26	1992-09-26 00:00:00	1992-09-26	38000177		0	0	14		0	0	0	61758	0	310965	19078461		
52269	4348	40169216	1985-10-27	1985-10-27 00:00:00	1985-10-27	1985-10-27 00:00:00	\N	38000177		0	0	0		0	0	0	288327	0	895994	40169216		
133033	2921	40213227	2001-08-21	2001-08-21 00:00:00	2001-08-21	2001-08-21 00:00:00	2001-08-21	581452		0	0	0		0	0	0	194759	0	113	40213227		
62823	5222	1127433	1973-07-09	1973-07-09 00:00:00	1973-07-16	1973-07-16 00:00:00	1973-07-16	38000177		0	0	7		0	0	0	347386	0	313782	1127433		
46964	3889	1127433	1943-11-12	1943-11-12 00:00:00	1943-11-26	1943-11-26 00:00:00	1943-11-26	38000177		0	0	14		0	0	0	258496	0	313782	1127433		
56354	4675	19078461	2012-07-12	2012-07-12 00:00:00	2012-09-10	2012-09-10 00:00:00	2012-09-10	38000177		0	0	60		0	0	0	311450	0	310965	19078461		
3737	310	40229134	1952-02-04	1952-02-04 00:00:00	1952-02-18	1952-02-18 00:00:00	1952-02-18	38000177		0	0	14		0	0	0	20500	0	1043400	40229134		
4780	399	1713671	1977-04-02	1977-04-02 00:00:00	1977-04-23	1977-04-23 00:00:00	1977-04-23	38000177		0	0	21		0	0	0	26174	0	562251	1713671		
39132	855	40213296	1996-11-29	1996-11-29 00:00:00	1996-11-29	1996-11-29 00:00:00	1996-11-29	581452		0	0	0		0	0	0	56493	0	52	40213296		
61326	1340	40213227	1992-10-18	1992-10-18 00:00:00	1992-10-18	1992-10-18 00:00:00	1992-10-18	581452		0	0	0		0	0	0	88891	0	113	40213227		
15356	1282	19128065	1991-04-02	1991-04-02 00:00:00	1992-03-27	1992-03-27 00:00:00	1992-03-27	38000177		0	0	360		0	0	0	84759	0	749882	19128065		
50273	4173	1127078	1964-06-09	1964-06-09 00:00:00	1964-08-08	1964-08-08 00:00:00	1964-08-08	38000177		0	0	60		0	0	0	277372	0	282464	1127078		
60777	5053	1127433	1991-06-24	1991-06-24 00:00:00	1991-08-23	1991-08-23 00:00:00	1991-08-23	38000177		0	0	60		0	0	0	336019	0	313782	1127433		
43158	3576	1127433	1991-04-04	1991-04-04 00:00:00	1991-04-25	1991-04-25 00:00:00	1991-04-25	38000177		0	0	21		0	0	0	237712	0	313782	1127433		
202492	4446	40213227	1992-03-24	1992-03-24 00:00:00	1992-03-24	1992-03-24 00:00:00	1992-03-24	581452		0	0	0		0	0	0	295674	0	113	40213227		
31392	2602	46275916	1964-11-04	1964-11-04 00:00:00	1964-11-04	1964-11-04 00:00:00	1964-11-04	38000177		0	0	0		0	0	0	172145	0	1660014	46275916		
59071	4909	40236824	2003-08-30	2003-08-30 00:00:00	2003-09-06	2003-09-06 00:00:00	2003-09-06	38000177		0	0	7		0	0	0	326226	0	1094107	40236824		
6699	565	1127433	1960-12-07	1960-12-07 00:00:00	1960-12-14	1960-12-14 00:00:00	1960-12-14	38000177		0	0	7		0	0	0	37459	0	313782	1127433		
213943	4691	40213296	2000-05-13	2000-05-13 00:00:00	2000-05-13	2000-05-13 00:00:00	2000-05-13	581452		0	0	0		0	0	0	312593	0	52	40213296		
152820	3364	40213160	1976-09-30	1976-09-30 00:00:00	1976-09-30	1976-09-30 00:00:00	1976-09-30	581452		0	0	0		0	0	0	223025	0	10	40213160		
205963	4520	40213227	1992-01-11	1992-01-11 00:00:00	1992-01-11	1992-01-11 00:00:00	1992-01-11	581452		0	0	0		0	0	0	300935	0	113	40213227		
211141	4630	40213160	1955-07-07	1955-07-07 00:00:00	1955-07-07	1955-07-07 00:00:00	1955-07-07	581452		0	0	0		0	0	0	308512	0	10	40213160		
166773	3666	40213296	2002-01-10	2002-01-10 00:00:00	2002-01-10	2002-01-10 00:00:00	2002-01-10	581452		0	0	0		0	0	0	243871	0	52	40213296		
107078	2347	40213306	1990-02-12	1990-02-12 00:00:00	1990-02-12	1990-02-12 00:00:00	1990-02-12	581452		0	0	0		0	0	0	156271	0	43	40213306		
39283	3246	40229134	2002-10-10	2002-10-10 00:00:00	2002-10-17	2002-10-17 00:00:00	2002-10-17	38000177		0	0	7		0	0	0	215779	0	1043400	40229134		
241380	5299	40213160	1971-09-19	1971-09-19 00:00:00	1971-09-19	1971-09-19 00:00:00	1971-09-19	581452		0	0	0		0	0	0	352549	0	10	40213160		
49815	4133	1713671	2002-09-05	2002-09-05 00:00:00	2002-09-19	2002-09-19 00:00:00	2002-09-19	38000177		0	0	14		0	0	0	274798	0	562251	1713671		
33030	2739	1127433	1988-06-26	1988-06-26 00:00:00	1988-08-25	1988-08-25 00:00:00	1988-08-25	38000177		0	0	60		0	0	0	181240	0	313782	1127433		
187068	4109	40213160	1969-10-07	1969-10-07 00:00:00	1969-10-07	1969-10-07 00:00:00	1969-10-07	581452		0	0	0		0	0	0	\N	0	10	40213160		
50808	4222	920300	1970-07-05	1970-07-05 00:00:00	1970-07-12	1970-07-12 00:00:00	1970-07-12	38000177		0	0	7		0	0	0	280339	0	311989	920300		
10314	863	40171902	1981-01-29	1981-01-29 00:00:00	1981-01-29	1981-01-29 00:00:00	\N	38000177		0	0	0		0	0	0	57216	0	897718	40171902		
219454	4816	40213251	1984-04-16	1984-04-16 00:00:00	1984-04-16	1984-04-16 00:00:00	1984-04-16	581452		0	0	0		0	0	0	320444	0	21	40213251		
3905	84	40213296	2016-03-24	2016-03-24 00:00:00	2016-03-24	2016-03-24 00:00:00	2016-03-24	581452		0	0	0		0	0	0	5648	0	52	40213296		
121729	2675	40213160	1966-01-09	1966-01-09 00:00:00	1966-01-09	1966-01-09 00:00:00	1966-01-09	581452		0	0	0		0	0	0	177258	0	10	40213160		
239583	5258	40213296	1999-11-17	1999-11-17 00:00:00	1999-11-17	1999-11-17 00:00:00	1999-11-17	581452		0	0	0		0	0	0	349903	0	52	40213296		
242195	5317	40213227	2004-02-25	2004-02-25 00:00:00	2004-02-25	2004-02-25 00:00:00	2004-02-25	581452		0	0	0		0	0	0	353659	0	113	40213227		
193749	4256	40213160	1955-09-11	1955-09-11 00:00:00	1955-09-11	1955-09-11 00:00:00	1955-09-11	581452		0	0	0		0	0	0	282574	0	10	40213160		
157307	3462	40213296	2004-02-27	2004-02-27 00:00:00	2004-02-27	2004-02-27 00:00:00	2004-02-27	581452		0	0	0		0	0	0	229753	0	52	40213296		
210111	4607	40213160	1972-04-27	1972-04-27 00:00:00	1972-04-27	1972-04-27 00:00:00	1972-04-27	581452		0	0	0		0	0	0	306923	0	10	40213160		
221117	4852	40213227	1992-07-03	1992-07-03 00:00:00	1992-07-03	1992-07-03 00:00:00	1992-07-03	581452		0	0	0		0	0	0	322861	0	113	40213227		
55162	1208	40213227	2001-12-25	2001-12-25 00:00:00	2001-12-25	2001-12-25 00:00:00	2001-12-25	581452		0	0	0		0	0	0	79354	0	113	40213227		
12787	1076	19128022	1998-03-11	1998-03-11 00:00:00	1999-03-06	1999-03-06 00:00:00	1999-03-06	38000177		0	0	360		0	0	0	70526	0	749785	19128022		
32893	719	40213306	2003-08-15	2003-08-15 00:00:00	2003-08-15	2003-08-15 00:00:00	2003-08-15	581452		0	0	0		0	0	0	47581	0	43	40213306		
22512	1850	40229134	1973-10-17	1973-10-17 00:00:00	1973-10-31	1973-10-31 00:00:00	1973-10-31	38000177		0	0	14		0	0	0	123752	0	1043400	40229134		
19194	1586	1127433	1972-07-10	1972-07-10 00:00:00	1972-07-24	1972-07-24 00:00:00	1972-07-24	38000177		0	0	14		0	0	0	106392	0	313782	1127433		
13306	1115	1127433	1964-10-09	1964-10-09 00:00:00	1964-10-30	1964-10-30 00:00:00	1964-10-30	38000177		0	0	21		0	0	0	73386	0	313782	1127433		
218294	4791	40213160	1968-02-01	1968-02-01 00:00:00	1968-02-01	1968-02-01 00:00:00	1968-02-01	581452		0	0	0		0	0	0	318795	0	10	40213160		
153124	3371	40213314	1978-01-20	1978-01-20 00:00:00	1978-01-20	1978-01-20 00:00:00	1978-01-20	581452		0	0	0		0	0	0	223631	0	49	40213314		
51269	4260	1713671	2010-02-23	2010-02-23 00:00:00	2010-03-02	2010-03-02 00:00:00	2010-03-02	38000177		0	0	7		0	0	0	282789	0	562251	1713671		
5039	419	19059056	1916-06-22	1916-06-22 00:00:00	1916-07-06	1916-07-06 00:00:00	1916-07-06	38000177		0	0	14		0	0	0	27763	0	243670	19059056		
76089	1662	40213160	1964-08-21	1964-08-21 00:00:00	1964-08-21	1964-08-21 00:00:00	1964-08-21	581452		0	0	0		0	0	0	111720	0	10	40213160		
61854	5145	19073188	1979-08-26	1979-08-26 00:00:00	1979-09-23	1979-09-23 00:00:00	1979-09-23	38000177		0	0	28		0	0	0	342078	0	308192	19073188		
136308	2992	40213160	1957-03-29	1957-03-29 00:00:00	1957-03-29	1957-03-29 00:00:00	1957-03-29	581452		0	0	0		0	0	0	199691	0	10	40213160		
4460	370	1127433	2002-10-12	2002-10-12 00:00:00	2002-11-02	2002-11-02 00:00:00	2002-11-02	38000177		0	0	21		0	0	0	24586	0	313782	1127433		
26309	2165	19078461	2003-01-13	2003-01-13 00:00:00	2003-02-12	2003-02-12 00:00:00	2003-02-12	38000177		0	0	30		0	0	0	144207	0	310965	19078461		
9873	826	40220960	1988-06-09	1988-06-09 00:00:00	1988-06-09	1988-06-09 00:00:00	1988-06-09	38000177		0	0	0		0	0	0	54769	0	1804799	40220960		
237544	5215	40213227	1992-05-25	1992-05-25 00:00:00	1992-05-25	1992-05-25 00:00:00	1992-05-25	581452		0	0	0		0	0	0	346873	0	113	40213227		
42912	936	40213260	2011-10-07	2011-10-07 00:00:00	2011-10-07	2011-10-07 00:00:00	2011-10-07	581452		0	0	0		0	0	0	62283	0	121	40213260		
148995	3277	40213306	1985-06-14	1985-06-14 00:00:00	1985-06-14	1985-06-14 00:00:00	1985-06-14	581452		0	0	0		0	0	0	217741	0	43	40213306		
20535	1690	19128022	1992-09-03	1992-09-03 00:00:00	1993-08-29	1993-08-29 00:00:00	1993-08-29	38000177		0	0	360		0	0	0	113190	0	749785	19128022		
58833	4886	1127433	1989-08-12	1989-08-12 00:00:00	1989-08-26	1989-08-26 00:00:00	1989-08-26	38000177		0	0	14		0	0	0	324889	0	313782	1127433		
58887	4890	1127433	1969-04-12	1969-04-12 00:00:00	1969-04-26	1969-04-26 00:00:00	1969-04-26	38000177		0	0	14		0	0	0	325144	0	313782	1127433		
11168	929	19133768	2005-10-10	2005-10-10 00:00:00	2005-10-10	2005-10-10 00:00:00	2005-10-10	38000177		0	0	0		0	0	0	61759	0	833036	19133768		
52270	4349	1127078	1984-11-21	1984-11-21 00:00:00	1985-02-19	1985-02-19 00:00:00	1985-02-19	38000177		0	0	90		0	0	0	288399	0	282464	1127078		
133056	2921	40213227	2011-10-18	2011-10-18 00:00:00	2011-10-18	2011-10-18 00:00:00	2011-10-18	581452		0	0	0		0	0	0	194706	0	113	40213227		
62824	5222	19059056	1919-10-24	1919-10-24 00:00:00	1919-11-07	1919-11-07 00:00:00	1919-11-07	38000177		0	0	14		0	0	0	347431	0	243670	19059056		
46965	3889	40163554	2003-10-12	2003-10-12 00:00:00	2003-10-12	2003-10-12 00:00:00	\N	38000177		0	0	0		0	0	0	258492	0	855332	40163554		
56355	4676	40236824	1996-08-25	1996-08-25 00:00:00	1996-09-01	1996-09-01 00:00:00	1996-09-01	38000177		0	0	7		0	0	0	311597	0	1094107	40236824		
3738	310	1127433	2002-07-15	2002-07-15 00:00:00	2002-08-05	2002-08-05 00:00:00	2002-08-05	38000177		0	0	21		0	0	0	20498	0	313782	1127433		
4781	399	1127433	1968-03-30	1968-03-30 00:00:00	1968-04-29	1968-04-29 00:00:00	1968-04-29	38000177		0	0	30		0	0	0	26234	0	313782	1127433		
39138	855	40213227	1998-12-04	1998-12-04 00:00:00	1998-12-04	1998-12-04 00:00:00	1998-12-04	581452		0	0	0		0	0	0	56512	0	113	40213227		
58318	1276	40213227	2018-04-27	2018-04-27 00:00:00	2018-04-27	2018-04-27 00:00:00	2018-04-27	581452		0	0	0		0	0	0	84240	0	113	40213227		
15357	1282	19128022	1992-03-27	1992-03-27 00:00:00	1993-03-22	1993-03-22 00:00:00	1993-03-22	38000177		0	0	360		0	0	0	84760	0	749785	19128022		
50274	4173	1118084	2002-10-23	2002-10-23 00:00:00	2002-10-23	2002-10-23 00:00:00	\N	38000177		0	0	0		0	0	0	277357	0	00025152531	44923712		
60778	5053	1127433	2001-07-15	2001-07-15 00:00:00	2001-07-29	2001-07-29 00:00:00	2001-07-29	38000177		0	0	14		0	0	0	336021	0	313782	1127433		
43159	3576	1127433	2005-11-12	2005-11-12 00:00:00	2005-11-19	2005-11-19 00:00:00	2005-11-19	38000177		0	0	7		0	0	0	237749	0	313782	1127433		
202493	4446	40213160	1961-03-07	1961-03-07 00:00:00	1961-03-07	1961-03-07 00:00:00	1961-03-07	581452		0	0	0		0	0	0	295653	0	10	40213160		
31393	2602	1310034	1964-11-04	1964-11-04 00:00:00	1964-11-04	1964-11-04 00:00:00	1964-11-04	38000177		0	0	0		0	0	0	172145	0	834357	1310034		
59072	4909	920300	2003-08-30	2003-08-30 00:00:00	2003-09-06	2003-09-06 00:00:00	2003-09-06	38000177		0	0	7		0	0	0	326226	0	311989	920300		
6700	565	1127433	1967-12-12	1967-12-12 00:00:00	1967-12-19	1967-12-19 00:00:00	1967-12-19	38000177		0	0	7		0	0	0	37435	0	313782	1127433		
213956	4691	40213227	2002-05-18	2002-05-18 00:00:00	2002-05-18	2002-05-18 00:00:00	2002-05-18	581452		0	0	0		0	0	0	312559	0	113	40213227		
152822	3364	40213314	1977-09-01	1977-09-01 00:00:00	1977-09-01	1977-09-01 00:00:00	1977-09-01	581452		0	0	0		0	0	0	223094	0	49	40213314		
205981	4521	40213201	1984-07-05	1984-07-05 00:00:00	1984-07-05	1984-07-05 00:00:00	1984-07-05	581452		0	0	0		0	0	0	301089	0	33	40213201		
211144	4630	40213160	1955-05-05	1955-05-05 00:00:00	1955-05-05	1955-05-05 00:00:00	1955-05-05	581452		0	0	0		0	0	0	308478	0	10	40213160		
166775	3666	40213160	1960-09-08	1960-09-08 00:00:00	1960-09-08	1960-09-08 00:00:00	1960-09-08	581452		0	0	0		0	0	0	243865	0	10	40213160		
107083	2347	40213227	1993-02-15	1993-02-15 00:00:00	1993-02-15	1993-02-15 00:00:00	1993-02-15	581452		0	0	0		0	0	0	156272	0	113	40213227		
39284	3246	19073183	1981-05-14	1981-05-14 00:00:00	1981-05-28	1981-05-28 00:00:00	1981-05-28	38000177		0	0	14		0	0	0	215794	0	308182	19073183		
241383	5299	40213296	2011-06-19	2011-06-19 00:00:00	2011-06-19	2011-06-19 00:00:00	2011-06-19	581452		0	0	0		0	0	0	352496	0	52	40213296		
49816	4133	42902245	1998-06-15	1998-06-15 00:00:00	1999-06-10	1999-06-10 00:00:00	1999-06-10	38000177		0	0	360		0	0	0	274749	0	1359133	42902245		
33031	2739	40222846	2010-02-16	2010-02-16 00:00:00	2010-02-16	2010-02-16 00:00:00	\N	38000177		0	0	0		0	0	0	181264	0	996740	40222846		
187073	4109	40213306	1987-05-26	1987-05-26 00:00:00	1987-05-26	1987-05-26 00:00:00	1987-05-26	581452		0	0	0		0	0	0	273167	0	43	40213306		
50809	4222	1118084	1987-01-28	1987-01-28 00:00:00	1987-01-28	1987-01-28 00:00:00	\N	38000177		0	0	0		0	0	0	280298	0	00025152531	44923712		
10315	863	40163554	1981-01-29	1981-01-29 00:00:00	1981-01-29	1981-01-29 00:00:00	\N	38000177		0	0	0		0	0	0	57216	0	855332	40163554		
222772	4890	40213201	1986-06-18	1986-06-18 00:00:00	1986-06-18	1986-06-18 00:00:00	1986-06-18	581452		0	0	0		0	0	0	325069	0	33	40213201		
3906	84	40213314	1977-01-06	1977-01-06 00:00:00	1977-01-06	1977-01-06 00:00:00	1977-01-06	581452		0	0	0		0	0	0	5668	0	49	40213314		
121731	2675	40213306	1984-06-24	1984-06-24 00:00:00	1984-06-24	1984-06-24 00:00:00	1984-06-24	581452		0	0	0		0	0	0	177263	0	43	40213306		
145851	3207	40213160	1959-08-20	1959-08-20 00:00:00	1959-08-20	1959-08-20 00:00:00	1959-08-20	581452		0	0	0		0	0	0	213186	0	10	40213160		
118698	2611	40213227	2012-08-30	2012-08-30 00:00:00	2012-08-30	2012-08-30 00:00:00	2012-08-30	581452		0	0	0		0	0	0	172695	0	113	40213227		
218025	4784	40213227	2000-03-25	2000-03-25 00:00:00	2000-03-25	2000-03-25 00:00:00	2000-03-25	581452		0	0	0		0	0	0	318437	0	113	40213227		
157308	3462	40213260	2012-03-23	2012-03-23 00:00:00	2012-03-23	2012-03-23 00:00:00	2012-03-23	581452		0	0	0		0	0	0	229691	0	121	40213260		
210114	4607	40213227	1995-01-19	1995-01-19 00:00:00	1995-01-19	1995-01-19 00:00:00	1995-01-19	581452		0	0	0		0	0	0	306887	0	113	40213227		
221127	4852	40213201	2014-10-03	2014-10-03 00:00:00	2014-10-03	2014-10-03 00:00:00	2014-10-03	581452		0	0	0		0	0	0	322843	0	33	40213201		
55169	1209	40213296	2017-09-14	2017-09-14 00:00:00	2017-09-14	2017-09-14 00:00:00	2017-09-14	581452		0	0	0		0	0	0	79465	0	52	40213296		
12788	1076	1713671	2003-01-02	2003-01-02 00:00:00	2003-01-23	2003-01-23 00:00:00	2003-01-23	38000177		0	0	21		0	0	0	70567	0	562251	1713671		
32895	719	40213160	1981-07-24	1981-07-24 00:00:00	1981-07-24	1981-07-24 00:00:00	1981-07-24	581452		0	0	0		0	0	0	47586	0	10	40213160		
22514	1850	1713671	1974-09-13	1974-09-13 00:00:00	1974-10-04	1974-10-04 00:00:00	1974-10-04	38000177		0	0	21		0	0	0	123753	0	562251	1713671		
19195	1586	1124300	1974-10-19	1974-10-19 00:00:00	1974-10-19	1974-10-19 00:00:00	\N	38000177		0	0	0		0	0	0	106392	0	00781178901	45011828		
13307	1116	19059056	1969-10-20	1969-10-20 00:00:00	1969-11-24	1969-11-24 00:00:00	1969-11-24	38000177		0	0	35		0	0	0	73540	0	243670	19059056		
218302	4791	40213227	2000-08-03	2000-08-03 00:00:00	2000-08-03	2000-08-03 00:00:00	2000-08-03	581452		0	0	0		0	0	0	318807	0	113	40213227		
199215	4376	40213227	2012-01-03	2012-01-03 00:00:00	2012-01-03	2012-01-03 00:00:00	2012-01-03	581452		0	0	0		0	0	0	290822	0	113	40213227		
51270	4260	19077572	2018-10-30	2018-10-30 00:00:00	2018-10-30	2018-10-30 00:00:00	\N	38000177		0	0	0		0	0	0	282851	0	310436	19077572		
5040	419	1118084	1954-08-08	1954-08-08 00:00:00	1954-08-08	1954-08-08 00:00:00	\N	38000177		0	0	0		0	0	0	27754	0	00025152531	44923712		
76091	1662	40213160	1964-11-20	1964-11-20 00:00:00	1964-11-20	1964-11-20 00:00:00	1964-11-20	581452		0	0	0		0	0	0	111725	0	10	40213160		
61855	5145	1127433	1968-04-04	1968-04-04 00:00:00	1968-04-25	1968-04-25 00:00:00	1968-04-25	38000177		0	0	21		0	0	0	342077	0	313782	1127433		
136312	2992	40213227	2007-07-27	2007-07-27 00:00:00	2007-07-27	2007-07-27 00:00:00	2007-07-27	581452		0	0	0		0	0	0	199717	0	113	40213227		
53835	4475	1127433	2016-01-19	2016-01-19 00:00:00	2016-02-02	2016-02-02 00:00:00	2016-02-02	38000177		0	0	14		0	0	0	297711	0	313782	1127433		
26310	2165	19059056	1961-03-26	1961-03-26 00:00:00	1961-05-25	1961-05-25 00:00:00	1961-05-25	38000177		0	0	60		0	0	0	144274	0	243670	19059056		
9880	828	1127078	1954-06-12	1954-06-12 00:00:00	1954-06-26	1954-06-26 00:00:00	1954-06-26	38000177		0	0	14		0	0	0	54857	0	282464	1127078		
237554	5215	40213227	2011-08-29	2011-08-29 00:00:00	2011-08-29	2011-08-29 00:00:00	2011-08-29	581452		0	0	0		0	0	0	346908	0	113	40213227		
42915	936	40213296	2002-11-08	2002-11-08 00:00:00	2002-11-08	2002-11-08 00:00:00	2002-11-08	581452		0	0	0		0	0	0	62282	0	52	40213296		
148997	3277	40213160	1963-03-15	1963-03-15 00:00:00	1963-03-15	1963-03-15 00:00:00	1963-03-15	581452		0	0	0		0	0	0	217715	0	10	40213160		
20536	1690	1118084	2009-12-12	2009-12-12 00:00:00	2009-12-12	2009-12-12 00:00:00	\N	38000177		0	0	0		0	0	0	113197	0	00025152531	44923712		
58834	4886	1127433	2017-12-16	2017-12-16 00:00:00	2017-12-23	2017-12-23 00:00:00	2017-12-23	38000177		0	0	7		0	0	0	324881	0	313782	1127433		
31057	2574	1127433	1976-02-19	1976-02-19 00:00:00	1976-03-04	1976-03-04 00:00:00	1976-03-04	38000177		0	0	14		0	0	0	170494	0	313782	1127433		
11169	929	1545959	2005-10-10	2005-10-10 00:00:00	2005-10-10	2005-10-10 00:00:00	2005-10-10	38000177		0	0	0		0	0	0	61759	0	259255	1545959		
52271	4349	19133873	1992-07-14	1992-07-14 00:00:00	1992-07-23	1992-07-23 00:00:00	1992-07-23	38000177		0	0	9		0	0	0	288431	0	834061	19133873		
172655	3795	40213160	1973-05-22	1973-05-22 00:00:00	1973-05-22	1973-05-22 00:00:00	1973-05-22	581452		0	0	0		0	0	0	252327	0	10	40213160		
62825	5222	1127433	2015-07-21	2015-07-21 00:00:00	2015-08-04	2015-08-04 00:00:00	2015-08-04	38000177		0	0	14		0	0	0	347503	0	313782	1127433		
46966	3889	19018935	2003-10-12	2003-10-12 00:00:00	2003-10-12	2003-10-12 00:00:00	\N	38000177		0	0	0		0	0	0	258492	0	197604	19018935		
56356	4676	920300	1996-08-25	1996-08-25 00:00:00	1996-09-01	1996-09-01 00:00:00	1996-09-01	38000177		0	0	7		0	0	0	311597	0	311989	920300		
3739	311	19078461	2014-02-17	2014-02-17 00:00:00	2014-03-03	2014-03-03 00:00:00	2014-03-03	38000177		0	0	14		0	0	0	20655	0	310965	19078461		
207674	4557	40213227	2011-12-11	2011-12-11 00:00:00	2011-12-11	2011-12-11 00:00:00	2011-12-11	581452		0	0	0		0	0	0	303682	0	113	40213227		
39139	855	40213296	1998-12-04	1998-12-04 00:00:00	1998-12-04	1998-12-04 00:00:00	1998-12-04	581452		0	0	0		0	0	0	56512	0	52	40213296		
58322	1276	40213260	2007-03-09	2007-03-09 00:00:00	2007-03-09	2007-03-09 00:00:00	2007-03-09	581452		0	0	0		0	0	0	84162	0	121	40213260		
15358	1282	1115171	2010-10-16	2010-10-16 00:00:00	2010-11-06	2010-11-06 00:00:00	2010-11-06	38000177		0	0	21		0	0	0	84737	0	849574	1115171		
205018	4500	40213227	1992-10-28	1992-10-28 00:00:00	1992-10-28	1992-10-28 00:00:00	1992-10-28	581452		0	0	0		0	0	0	299671	0	113	40213227		
53179	4418	1127433	2018-11-29	2018-11-29 00:00:00	2018-12-13	2018-12-13 00:00:00	2018-12-13	38000177		0	0	14		0	0	0	293765	0	313782	1127433		
53619	4456	40236824	2008-06-25	2008-06-25 00:00:00	2008-07-02	2008-07-02 00:00:00	2008-07-02	38000177		0	0	7		0	0	0	296577	0	1094107	40236824		
202504	4446	40213306	1983-03-15	1983-03-15 00:00:00	1983-03-15	1983-03-15 00:00:00	1983-03-15	581452		0	0	0		0	0	0	295679	0	43	40213306		
31395	2602	40173590	2009-03-25	2009-03-25 00:00:00	2009-03-25	2009-03-25 00:00:00	\N	38000177		0	0	0		0	0	0	172092	0	904419	40173590		
62032	1355	40213296	2003-08-15	2003-08-15 00:00:00	2003-08-15	2003-08-15 00:00:00	2003-08-15	581452		0	0	0		0	0	0	89820	0	52	40213296		
6701	565	1127433	1962-10-07	1962-10-07 00:00:00	1962-10-21	1962-10-21 00:00:00	1962-10-21	38000177		0	0	14		0	0	0	37434	0	313782	1127433		
213957	4691	40213296	2002-05-18	2002-05-18 00:00:00	2002-05-18	2002-05-18 00:00:00	2002-05-18	581452		0	0	0		0	0	0	312559	0	52	40213296		
152829	3364	40213314	1977-06-02	1977-06-02 00:00:00	1977-06-02	1977-06-02 00:00:00	1977-06-02	581452		0	0	0		0	0	0	223075	0	49	40213314		
205985	4521	40213227	1992-01-30	1992-01-30 00:00:00	1992-01-30	1992-01-30 00:00:00	1992-01-30	581452		0	0	0		0	0	0	300981	0	113	40213227		
211148	4630	40213260	2007-12-13	2007-12-13 00:00:00	2007-12-13	2007-12-13 00:00:00	2007-12-13	581452		0	0	0		0	0	0	308502	0	121	40213260		
166783	3666	40213160	1960-06-09	1960-06-09 00:00:00	1960-06-09	1960-06-09 00:00:00	1960-06-09	581452		0	0	0		0	0	0	243920	0	10	40213160		
107085	2347	40213296	2012-02-20	2012-02-20 00:00:00	2012-02-20	2012-02-20 00:00:00	2012-02-20	581452		0	0	0		0	0	0	156248	0	52	40213296		
39285	3246	1127078	1981-05-14	1981-05-14 00:00:00	1981-05-28	1981-05-28 00:00:00	1981-05-28	38000177		0	0	14		0	0	0	215794	0	282464	1127078		
241389	5299	40213227	1993-12-12	1993-12-12 00:00:00	1993-12-12	1993-12-12 00:00:00	1993-12-12	581452		0	0	0		0	0	0	352556	0	113	40213227		
49817	4133	19128065	1991-07-22	1991-07-22 00:00:00	1992-07-16	1992-07-16 00:00:00	1992-07-16	38000177		0	0	360		0	0	0	274805	0	749882	19128065		
33032	2740	1118084	2010-04-19	2010-04-19 00:00:00	2010-04-19	2010-04-19 00:00:00	\N	38000177		0	0	0		0	0	0	181319	0	00025152531	44923712		
187075	4109	40213306	1987-05-12	1987-05-12 00:00:00	1987-05-12	1987-05-12 00:00:00	1987-05-12	581452		0	0	0		0	0	0	273158	0	43	40213306		
50810	4222	19078461	1998-07-29	1998-07-29 00:00:00	1998-08-26	1998-08-26 00:00:00	1998-08-26	38000177		0	0	28		0	0	0	280338	0	310965	19078461		
10316	863	19059056	1922-07-14	1922-07-14 00:00:00	1922-07-28	1922-07-28 00:00:00	1922-07-28	38000177		0	0	14		0	0	0	57170	0	243670	19059056		
222789	4890	40213227	2010-12-15	2010-12-15 00:00:00	2010-12-15	2010-12-15 00:00:00	2010-12-15	581452		0	0	0		0	0	0	325179	0	113	40213227		
3911	84	40213306	1995-08-17	1995-08-17 00:00:00	1995-08-17	1995-08-17 00:00:00	1995-08-17	581452		0	0	0		0	0	0	5644	0	43	40213306		
121736	2675	40213160	1961-10-08	1961-10-08 00:00:00	1961-10-08	1961-10-08 00:00:00	1961-10-08	581452		0	0	0		0	0	0	177247	0	10	40213160		
145856	3208	40213160	1972-12-22	1972-12-22 00:00:00	1972-12-22	1972-12-22 00:00:00	1972-12-22	581452		0	0	0		0	0	0	213261	0	10	40213160		
118705	2611	40213160	1955-07-07	1955-07-07 00:00:00	1955-07-07	1955-07-07 00:00:00	1955-07-07	581452		0	0	0		0	0	0	\N	0	10	40213160		
218028	4784	40213227	2010-05-29	2010-05-29 00:00:00	2010-05-29	2010-05-29 00:00:00	2010-05-29	581452		0	0	0		0	0	0	318438	0	113	40213227		
194230	4268	40213227	2006-09-18	2006-09-18 00:00:00	2006-09-18	2006-09-18 00:00:00	2006-09-18	581452		0	0	0		0	0	0	283285	0	113	40213227		
210115	4607	40213306	1995-01-19	1995-01-19 00:00:00	1995-01-19	1995-01-19 00:00:00	1995-01-19	581452		0	0	0		0	0	0	306887	0	43	40213306		
221135	4852	40213227	2009-09-04	2009-09-04 00:00:00	2009-09-04	2009-09-04 00:00:00	2009-09-04	581452		0	0	0		0	0	0	322864	0	113	40213227		
79889	1748	40213201	2013-03-23	2013-03-23 00:00:00	2013-03-23	2013-03-23 00:00:00	2013-03-23	581452		0	0	0		0	0	0	116894	0	33	40213201		
12789	1076	19133873	1981-05-31	1981-05-31 00:00:00	1981-06-11	1981-06-11 00:00:00	1981-06-11	38000177		0	0	11		0	0	0	70546	0	834061	19133873		
32900	719	40213251	1984-04-20	1984-04-20 00:00:00	1984-04-20	1984-04-20 00:00:00	1984-04-20	581452		0	0	0		0	0	0	47597	0	21	40213251		
22515	1850	1127433	2006-11-29	2006-11-29 00:00:00	2006-12-13	2006-12-13 00:00:00	2006-12-13	38000177		0	0	14		0	0	0	123779	0	313782	1127433		
19196	1586	1127433	1966-05-14	1966-05-14 00:00:00	1966-05-21	1966-05-21 00:00:00	1966-05-21	38000177		0	0	7		0	0	0	106391	0	313782	1127433		
13308	1116	1118084	2007-01-19	2007-01-19 00:00:00	2007-01-19	2007-01-19 00:00:00	\N	38000177		0	0	0		0	0	0	73524	0	00025152531	44923712		
218307	4791	40213296	2010-08-19	2010-08-19 00:00:00	2010-08-19	2010-08-19 00:00:00	2010-08-19	581452		0	0	0		0	0	0	318790	0	52	40213296		
199220	4376	40213201	1986-08-12	1986-08-12 00:00:00	1986-08-12	1986-08-12 00:00:00	1986-08-12	581452		0	0	0		0	0	0	290798	0	33	40213201		
233079	5121	40213160	1964-11-27	1964-11-27 00:00:00	1964-11-27	1964-11-27 00:00:00	1964-11-27	581452		0	0	0		0	0	0	340476	0	10	40213160		
5041	419	1127433	1987-03-08	1987-03-08 00:00:00	1987-03-22	1987-03-22 00:00:00	1987-03-22	38000177		0	0	14		0	0	0	27759	0	313782	1127433		
76093	1662	40213227	2015-03-20	2015-03-20 00:00:00	2015-03-20	2015-03-20 00:00:00	2015-03-20	581452		0	0	0		0	0	0	111741	0	113	40213227		
61856	5145	1127433	2001-11-26	2001-11-26 00:00:00	2002-01-25	2002-01-25 00:00:00	2002-01-25	38000177		0	0	60		0	0	0	342079	0	313782	1127433		
136313	2992	40213260	2007-07-27	2007-07-27 00:00:00	2007-07-27	2007-07-27 00:00:00	2007-07-27	581452		0	0	0		0	0	0	199717	0	121	40213260		
53836	4475	1127433	1994-03-28	1994-03-28 00:00:00	1994-04-28	1994-04-28 00:00:00	1994-04-28	38000177		0	0	31		0	0	0	297715	0	313782	1127433		
26311	2165	1127433	1957-10-14	1957-10-14 00:00:00	1957-10-21	1957-10-21 00:00:00	1957-10-21	38000177		0	0	7		0	0	0	144187	0	313782	1127433		
9881	828	19006318	1954-06-12	1954-06-12 00:00:00	1954-06-26	1954-06-26 00:00:00	1954-06-26	38000177		0	0	14		0	0	0	54857	0	105078	19006318		
119615	2630	40213227	2011-10-16	2011-10-16 00:00:00	2011-10-16	2011-10-16 00:00:00	2011-10-16	581452		0	0	0		0	0	0	173974	0	113	40213227		
42918	936	40213227	2002-11-08	2002-11-08 00:00:00	2002-11-08	2002-11-08 00:00:00	2002-11-08	581452		0	0	0		0	0	0	62282	0	113	40213227		
149006	3277	40213160	1963-05-17	1963-05-17 00:00:00	1963-05-17	1963-05-17 00:00:00	1963-05-17	581452		0	0	0		0	0	0	217703	0	10	40213160		
20537	1690	19133873	1979-12-31	1979-12-31 00:00:00	1980-01-12	1980-01-12 00:00:00	1980-01-12	38000177		0	0	12		0	0	0	113207	0	834061	19133873		
58855	4890	19018935	2009-12-09	2009-12-09 00:00:00	2009-12-09	2009-12-09 00:00:00	\N	38000177		0	0	0		0	0	0	325166	0	197604	19018935		
31058	2574	19059056	1973-01-30	1973-01-30 00:00:00	1973-03-06	1973-03-06 00:00:00	1973-03-06	38000177		0	0	35		0	0	0	170493	0	243670	19059056		
11179	931	19078461	1978-10-13	1978-10-13 00:00:00	1978-10-27	1978-10-27 00:00:00	1978-10-27	38000177		0	0	14		0	0	0	61961	0	310965	19078461		
11193	931	1127078	1964-05-28	1964-05-28 00:00:00	1964-06-11	1964-06-11 00:00:00	1964-06-11	38000177		0	0	14		0	0	0	61957	0	282464	1127078		
172660	3795	40213160	1978-01-24	1978-01-24 00:00:00	1978-01-24	1978-01-24 00:00:00	1978-01-24	581452		0	0	0		0	0	0	252340	0	10	40213160		
62826	5222	1713671	1933-10-29	1933-10-29 00:00:00	1933-11-05	1933-11-05 00:00:00	1933-11-05	38000177		0	0	7		0	0	0	347405	0	562251	1713671		
46967	3889	40171902	2003-10-12	2003-10-12 00:00:00	2003-10-12	2003-10-12 00:00:00	\N	38000177		0	0	0		0	0	0	258492	0	897718	40171902		
56357	4676	19019979	1981-08-21	1981-08-21 00:00:00	1981-09-20	1981-09-20 00:00:00	1981-09-20	38000177		0	0	30		0	0	0	311618	0	198405	19019979		
3740	311	1127433	2008-01-04	2008-01-04 00:00:00	2008-01-18	2008-01-18 00:00:00	2008-01-18	38000177		0	0	14		0	0	0	20588	0	313782	1127433		
207696	4557	40213201	1986-06-22	1986-06-22 00:00:00	1986-06-22	1986-06-22 00:00:00	1986-06-22	581452		0	0	0		0	0	0	303600	0	33	40213201		
39142	855	40213160	1957-08-02	1957-08-02 00:00:00	1957-08-02	1957-08-02 00:00:00	1957-08-02	581452		0	0	0		0	0	0	56497	0	10	40213160		
41906	914	40213227	2006-07-31	2006-07-31 00:00:00	2006-07-31	2006-07-31 00:00:00	2006-07-31	581452		0	0	0		0	0	0	60728	0	113	40213227		
15359	1282	19112599	1977-08-12	1977-08-12 00:00:00	1977-08-12	1977-08-12 00:00:00	\N	38000177		0	0	0		0	0	0	84719	0	477045	19112599		
205022	4500	40213306	1983-11-16	1983-11-16 00:00:00	1983-11-16	1983-11-16 00:00:00	1983-11-16	581452		0	0	0		0	0	0	299628	0	43	40213306		
53180	4418	1127078	1952-07-21	1952-07-21 00:00:00	1952-08-11	1952-08-11 00:00:00	1952-08-11	38000177		0	0	21		0	0	0	293693	0	282464	1127078		
53620	4456	920300	2008-06-25	2008-06-25 00:00:00	2008-07-02	2008-07-02 00:00:00	2008-07-02	38000177		0	0	7		0	0	0	296577	0	311989	920300		
202508	4446	40213160	1964-12-15	1964-12-15 00:00:00	1964-12-15	1964-12-15 00:00:00	1964-12-15	581452		0	0	0		0	0	0	295655	0	10	40213160		
31396	2602	19078461	2014-02-27	2014-02-27 00:00:00	2014-03-13	2014-03-13 00:00:00	2014-03-13	38000177		0	0	14		0	0	0	172147	0	310965	19078461		
62036	1355	40213160	1968-03-01	1968-03-01 00:00:00	1968-03-01	1968-03-01 00:00:00	1968-03-01	581452		0	0	0		0	0	0	89806	0	10	40213160		
6702	565	19006318	1958-07-19	1958-07-19 00:00:00	1958-08-02	1958-08-02 00:00:00	1958-08-02	38000177		0	0	14		0	0	0	37419	0	105078	19006318		
213959	4691	40213227	1992-01-04	1992-01-04 00:00:00	1992-01-04	1992-01-04 00:00:00	1992-01-04	581452		0	0	0		0	0	0	312567	0	113	40213227		
152832	3364	40213227	2007-09-06	2007-09-06 00:00:00	2007-09-06	2007-09-06 00:00:00	2007-09-06	581452		0	0	0		0	0	0	223048	0	113	40213227		
73495	1605	40213201	2003-01-26	2003-01-26 00:00:00	2003-01-26	2003-01-26 00:00:00	2003-01-26	581452		0	0	0		0	0	0	107721	0	33	40213201		
211156	4631	40213201	1983-05-06	1983-05-06 00:00:00	1983-05-06	1983-05-06 00:00:00	1983-05-06	581452		0	0	0		0	0	0	308664	0	33	40213201		
166786	3666	40213306	1982-07-08	1982-07-08 00:00:00	1982-07-08	1982-07-08 00:00:00	1982-07-08	581452		0	0	0		0	0	0	243906	0	43	40213306		
107093	2347	40213160	1973-11-12	1973-11-12 00:00:00	1973-11-12	1973-11-12 00:00:00	1973-11-12	581452		0	0	0		0	0	0	156240	0	10	40213160		
39286	3246	1127433	2013-07-03	2013-07-03 00:00:00	2013-07-10	2013-07-10 00:00:00	2013-07-10	38000177		0	0	7		0	0	0	215806	0	313782	1127433		
241390	5299	40213306	1993-12-12	1993-12-12 00:00:00	1993-12-12	1993-12-12 00:00:00	1993-12-12	581452		0	0	0		0	0	0	352556	0	43	40213306		
49818	4133	1713671	1999-01-04	1999-01-04 00:00:00	1999-01-18	1999-01-18 00:00:00	1999-01-18	38000177		0	0	14		0	0	0	274785	0	562251	1713671		
33033	2740	19128065	1985-11-21	1985-11-21 00:00:00	1986-11-16	1986-11-16 00:00:00	1986-11-16	38000177		0	0	360		0	0	0	181295	0	749882	19128065		
187078	4109	40213296	2005-05-17	2005-05-17 00:00:00	2005-05-17	2005-05-17 00:00:00	2005-05-17	581452		0	0	0		0	0	0	273160	0	52	40213296		
50811	4222	40229134	1956-03-12	1956-03-12 00:00:00	1956-03-19	1956-03-19 00:00:00	1956-03-19	38000177		0	0	7		0	0	0	280302	0	1043400	40229134		
172429	3790	40213160	1968-06-10	1968-06-10 00:00:00	1968-06-10	1968-06-10 00:00:00	1968-06-10	581452		0	0	0		0	0	0	251987	0	10	40213160		
222791	4890	40213227	1992-07-22	1992-07-22 00:00:00	1992-07-22	1992-07-22 00:00:00	1992-07-22	581452		0	0	0		0	0	0	325238	0	113	40213227		
3914	84	40213314	1978-01-05	1978-01-05 00:00:00	1978-01-05	1978-01-05 00:00:00	1978-01-05	581452		0	0	0		0	0	0	5699	0	49	40213314		
121745	2675	40213260	2011-01-30	2011-01-30 00:00:00	2011-01-30	2011-01-30 00:00:00	2011-01-30	581452		0	0	0		0	0	0	177299	0	121	40213260		
145859	3208	40213306	1990-03-16	1990-03-16 00:00:00	1990-03-16	1990-03-16 00:00:00	1990-03-16	581452		0	0	0		0	0	0	213240	0	43	40213306		
118711	2611	40213227	2003-06-19	2003-06-19 00:00:00	2003-06-19	2003-06-19 00:00:00	2003-06-19	581452		0	0	0		0	0	0	172664	0	113	40213227		
218034	4784	40213160	1955-10-29	1955-10-29 00:00:00	1955-10-29	1955-10-29 00:00:00	1955-10-29	581452		0	0	0		0	0	0	318464	0	10	40213160		
194231	4268	40213260	2006-09-18	2006-09-18 00:00:00	2006-09-18	2006-09-18 00:00:00	2006-09-18	581452		0	0	0		0	0	0	283285	0	121	40213260		
210121	4607	40213296	2012-02-09	2012-02-09 00:00:00	2012-02-09	2012-02-09 00:00:00	2012-02-09	581452		0	0	0		0	0	0	306932	0	52	40213296		
221137	4852	40213227	1998-11-12	1998-11-12 00:00:00	1998-11-12	1998-11-12 00:00:00	1998-11-12	581452		0	0	0		0	0	0	322809	0	113	40213227		
79898	1748	40213198	2011-12-31	2011-12-31 00:00:00	2011-12-31	2011-12-31 00:00:00	2011-12-31	581452		0	0	0		0	0	0	116908	0	133	40213198		
12790	1076	19128065	1988-05-02	1988-05-02 00:00:00	1989-04-27	1989-04-27 00:00:00	1989-04-27	38000177		0	0	360		0	0	0	70551	0	749882	19128065		
32906	719	40213251	1985-10-25	1985-10-25 00:00:00	1985-10-25	1985-10-25 00:00:00	1985-10-25	581452		0	0	0		0	0	0	47598	0	21	40213251		
22516	1850	1127433	1999-02-20	1999-02-20 00:00:00	1999-02-27	1999-02-27 00:00:00	1999-02-27	38000177		0	0	7		0	0	0	123729	0	313782	1127433		
19197	1586	40236824	1966-04-12	1966-04-12 00:00:00	1966-04-19	1966-04-19 00:00:00	1966-04-19	38000177		0	0	7		0	0	0	106385	0	1094107	40236824		
13309	1116	19059056	1970-07-01	1970-07-01 00:00:00	1970-07-15	1970-07-15 00:00:00	1970-07-15	38000177		0	0	14		0	0	0	73525	0	243670	19059056		
218315	4791	40213260	2017-09-07	2017-09-07 00:00:00	2017-09-07	2017-09-07 00:00:00	2017-09-07	581452		0	0	0		0	0	0	318785	0	121	40213260		
233083	5121	40213160	1969-05-30	1969-05-30 00:00:00	1969-05-30	1969-05-30 00:00:00	1969-05-30	581452		0	0	0		0	0	0	340489	0	10	40213160		
5047	421	19059056	1977-09-02	1977-09-02 00:00:00	1977-10-02	1977-10-02 00:00:00	1977-10-02	38000177		0	0	30		0	0	0	27878	0	243670	19059056		
76096	1662	40213260	2014-03-14	2014-03-14 00:00:00	2014-03-14	2014-03-14 00:00:00	2014-03-14	581452		0	0	0		0	0	0	111767	0	121	40213260		
61857	5145	1127433	2000-02-18	2000-02-18 00:00:00	2000-02-25	2000-02-25 00:00:00	2000-02-25	38000177		0	0	7		0	0	0	342006	0	313782	1127433		
136315	2992	40213160	1961-06-30	1961-06-30 00:00:00	1961-06-30	1961-06-30 00:00:00	1961-06-30	581452		0	0	0		0	0	0	199759	0	10	40213160		
53837	4475	1713671	2017-08-04	2017-08-04 00:00:00	2017-08-11	2017-08-11 00:00:00	2017-08-11	38000177		0	0	7		0	0	0	297712	0	562251	1713671		
26312	2165	1127433	2009-12-14	2009-12-14 00:00:00	2010-01-13	2010-01-13 00:00:00	2010-01-13	38000177		0	0	30		0	0	0	144219	0	313782	1127433		
9882	828	19075601	2005-06-14	2005-06-14 00:00:00	2005-06-14	2005-06-14 00:00:00	2005-06-14	38000177		0	0	0		0	0	0	54823	0	309362	19075601		
119616	2630	40213260	2011-10-16	2011-10-16 00:00:00	2011-10-16	2011-10-16 00:00:00	2011-10-16	581452		0	0	0		0	0	0	173974	0	121	40213260		
42920	936	40213160	1965-10-08	1965-10-08 00:00:00	1965-10-08	1965-10-08 00:00:00	1965-10-08	581452		0	0	0		0	0	0	62241	0	10	40213160		
149009	3277	40213227	1996-03-22	1996-03-22 00:00:00	1996-03-22	1996-03-22 00:00:00	1996-03-22	581452		0	0	0		0	0	0	217679	0	113	40213227		
20538	1690	19128022	1996-08-13	1996-08-13 00:00:00	1997-08-08	1997-08-08 00:00:00	1997-08-08	38000177		0	0	360		0	0	0	113223	0	749785	19128022		
58856	4890	40171902	2009-12-09	2009-12-09 00:00:00	2009-12-09	2009-12-09 00:00:00	\N	38000177		0	0	0		0	0	0	325166	0	897718	40171902		
31059	2574	1127433	1978-12-31	1978-12-31 00:00:00	1979-01-14	1979-01-14 00:00:00	1979-01-14	38000177		0	0	14		0	0	0	170485	0	313782	1127433		
11180	931	1127433	1975-06-09	1975-06-09 00:00:00	1975-06-23	1975-06-23 00:00:00	1975-06-23	38000177		0	0	14		0	0	0	61936	0	313782	1127433		
11194	931	1127433	1965-12-20	1965-12-20 00:00:00	1965-12-27	1965-12-27 00:00:00	1965-12-27	38000177		0	0	7		0	0	0	61926	0	313782	1127433		
172668	3795	40213227	2004-04-27	2004-04-27 00:00:00	2004-04-27	2004-04-27 00:00:00	2004-04-27	581452		0	0	0		0	0	0	252349	0	113	40213227		
62827	5222	1127433	1935-02-21	1935-02-21 00:00:00	1935-02-28	1935-02-28 00:00:00	1935-02-28	38000177		0	0	7		0	0	0	347385	0	313782	1127433		
46969	3890	1127433	1976-09-07	1976-09-07 00:00:00	1976-09-21	1976-09-21 00:00:00	1976-09-21	38000177		0	0	14		0	0	0	258592	0	313782	1127433		
56358	4676	40229134	2014-10-29	2014-10-29 00:00:00	2014-11-12	2014-11-12 00:00:00	2014-11-12	38000177		0	0	14		0	0	0	311598	0	1043400	40229134		
3741	311	1127433	1986-09-09	1986-09-09 00:00:00	1986-09-16	1986-09-16 00:00:00	1986-09-16	38000177		0	0	7		0	0	0	20628	0	313782	1127433		
120985	2659	40213160	1974-10-02	1974-10-02 00:00:00	1974-10-02	1974-10-02 00:00:00	1974-10-02	581452		0	0	0		0	0	0	176137	0	10	40213160		
39144	855	40213160	1961-11-03	1961-11-03 00:00:00	1961-11-03	1961-11-03 00:00:00	1961-11-03	581452		0	0	0		0	0	0	56473	0	10	40213160		
41919	914	40213227	2016-09-26	2016-09-26 00:00:00	2016-09-26	2016-09-26 00:00:00	2016-09-26	581452		0	0	0		0	0	0	60782	0	113	40213227		
15360	1282	40236824	1998-05-05	1998-05-05 00:00:00	1998-05-12	1998-05-12 00:00:00	1998-05-12	38000177		0	0	7		0	0	0	84758	0	1094107	40236824		
205026	4500	40213227	2012-09-19	2012-09-19 00:00:00	2012-09-19	2012-09-19 00:00:00	2012-09-19	581452		0	0	0		0	0	0	299641	0	113	40213227		
53181	4418	19133905	1996-10-09	1996-10-09 00:00:00	1996-10-22	1996-10-22 00:00:00	1996-10-22	38000177		0	0	13		0	0	0	293720	0	834102	19133905		
53621	4456	19059056	1965-06-18	1965-06-18 00:00:00	1965-08-17	1965-08-17 00:00:00	1965-08-17	38000177		0	0	60		0	0	0	296616	0	243670	19059056		
202509	4446	40213227	2002-07-09	2002-07-09 00:00:00	2002-07-09	2002-07-09 00:00:00	2002-07-09	581452		0	0	0		0	0	0	295677	0	113	40213227		
31397	2602	1127433	1992-01-03	1992-01-03 00:00:00	1992-01-24	1992-01-24 00:00:00	1992-01-24	38000177		0	0	21		0	0	0	172146	0	313782	1127433		
62042	1355	40213260	2014-08-15	2014-08-15 00:00:00	2014-08-15	2014-08-15 00:00:00	2014-08-15	581452		0	0	0		0	0	0	89848	0	121	40213260		
6703	565	19059056	1958-07-19	1958-07-19 00:00:00	1958-08-02	1958-08-02 00:00:00	1958-08-02	38000177		0	0	14		0	0	0	37419	0	243670	19059056		
213961	4691	40213260	2010-05-08	2010-05-08 00:00:00	2010-05-08	2010-05-08 00:00:00	2010-05-08	581452		0	0	0		0	0	0	312607	0	121	40213260		
152834	3364	40213227	2018-10-11	2018-10-11 00:00:00	2018-10-11	2018-10-11 00:00:00	2018-10-11	581452		0	0	0		0	0	0	223056	0	113	40213227		
73510	1605	40213227	1997-09-28	1997-09-28 00:00:00	1997-09-28	1997-09-28 00:00:00	1997-09-28	581452		0	0	0		0	0	0	107775	0	113	40213227		
5099	110	40213296	2017-02-19	2017-02-19 00:00:00	2017-02-19	2017-02-19 00:00:00	2017-02-19	581452		0	0	0		0	0	0	7350	0	52	40213296		
166793	3666	40213160	1964-12-10	1964-12-10 00:00:00	1964-12-10	1964-12-10 00:00:00	1964-12-10	581452		0	0	0		0	0	0	243924	0	10	40213160		
107101	2347	40213227	2010-02-15	2010-02-15 00:00:00	2010-02-15	2010-02-15 00:00:00	2010-02-15	581452		0	0	0		0	0	0	156283	0	113	40213227		
39287	3246	40236446	1989-10-19	1989-10-19 00:00:00	1997-10-27	1997-10-27 00:00:00	1997-10-27	38000177		0	0	2930		0	0	0	215790	0	1091392	40236446		
241393	5299	40213227	2003-05-04	2003-05-04 00:00:00	2003-05-04	2003-05-04 00:00:00	2003-05-04	581452		0	0	0		0	0	0	352506	0	113	40213227		
49819	4133	19133873	1981-03-08	1981-03-08 00:00:00	1981-03-18	1981-03-18 00:00:00	1981-03-18	38000177		0	0	10		0	0	0	274784	0	834061	19133873		
43522	3609	1127078	1977-02-16	1977-02-16 00:00:00	1977-03-02	1977-03-02 00:00:00	1977-03-02	38000177		0	0	14		0	0	0	239771	0	282464	1127078		
187081	4109	40213260	2014-12-02	2014-12-02 00:00:00	2014-12-02	2014-12-02 00:00:00	2014-12-02	581452		0	0	0		0	0	0	273195	0	121	40213260		
50812	4222	19006318	1951-03-08	1951-03-08 00:00:00	1951-03-22	1951-03-22 00:00:00	1951-03-22	38000177		0	0	14		0	0	0	280341	0	105078	19006318		
172434	3790	40213227	2015-06-08	2015-06-08 00:00:00	2015-06-08	2015-06-08 00:00:00	2015-06-08	581452		0	0	0		0	0	0	252018	0	113	40213227		
222803	4890	40213227	2001-09-12	2001-09-12 00:00:00	2001-09-12	2001-09-12 00:00:00	2001-09-12	581452		0	0	0		0	0	0	325073	0	113	40213227		
107283	2351	40213160	1955-07-09	1955-07-09 00:00:00	1955-07-09	1955-07-09 00:00:00	1955-07-09	581452		0	0	0		0	0	0	156568	0	10	40213160		
9917	211	40213260	2018-01-04	2018-01-04 00:00:00	2018-01-04	2018-01-04 00:00:00	2018-01-04	581452		0	0	0		0	0	0	14387	0	121	40213260		
145863	3208	40213227	2019-01-18	2019-01-18 00:00:00	2019-01-18	2019-01-18 00:00:00	2019-01-18	581452		0	0	0		0	0	0	213234	0	113	40213227		
118722	2611	40213201	2017-09-28	2017-09-28 00:00:00	2017-09-28	2017-09-28 00:00:00	2017-09-28	581452		0	0	0		0	0	0	172667	0	33	40213201		
21356	464	40213227	1994-07-19	1994-07-19 00:00:00	1994-07-19	1994-07-19 00:00:00	1994-07-19	581452		0	0	0		0	0	0	30966	0	113	40213227		
194235	4268	40213227	2017-01-16	2017-01-16 00:00:00	2017-01-16	2017-01-16 00:00:00	2017-01-16	581452		0	0	0		0	0	0	283297	0	113	40213227		
157310	3462	40213227	2012-03-23	2012-03-23 00:00:00	2012-03-23	2012-03-23 00:00:00	2012-03-23	581452		0	0	0		0	0	0	229691	0	113	40213227		
221153	4853	40213260	2013-05-15	2013-05-15 00:00:00	2013-05-15	2013-05-15 00:00:00	2013-05-15	581452		0	0	0		0	0	0	322923	0	121	40213260		
79905	1748	40213227	2017-11-04	2017-11-04 00:00:00	2017-11-04	2017-11-04 00:00:00	2017-11-04	581452		0	0	0		0	0	0	116839	0	113	40213227		
12791	1076	19128022	1995-03-27	1995-03-27 00:00:00	1996-03-21	1996-03-21 00:00:00	1996-03-21	38000177		0	0	360		0	0	0	70524	0	749785	19128022		
32908	719	40213160	1985-10-25	1985-10-25 00:00:00	1985-10-25	1985-10-25 00:00:00	1985-10-25	581452		0	0	0		0	0	0	47598	0	10	40213160		
22517	1850	1713671	1959-04-09	1959-04-09 00:00:00	1959-04-23	1959-04-23 00:00:00	1959-04-23	38000177		0	0	14		0	0	0	123746	0	562251	1713671		
19198	1586	1713671	1961-09-13	1961-09-13 00:00:00	1961-09-27	1961-09-27 00:00:00	1961-09-27	38000177		0	0	14		0	0	0	106452	0	562251	1713671		
13310	1116	46233988	1970-07-01	1970-07-01 00:00:00	1970-07-15	1970-07-15 00:00:00	1970-07-15	38000177		0	0	14		0	0	0	73525	0	1652673	46233988		
218317	4791	40213306	1989-11-02	1989-11-02 00:00:00	1989-11-02	1989-11-02 00:00:00	1989-11-02	581452		0	0	0		0	0	0	318803	0	43	40213306		
233087	5121	40213227	1997-11-07	1997-11-07 00:00:00	1997-11-07	1997-11-07 00:00:00	1997-11-07	581452		0	0	0		0	0	0	340469	0	113	40213227		
5048	421	40231925	1977-09-02	1977-09-02 00:00:00	1977-09-02	1977-09-02 00:00:00	\N	38000177		0	0	0		0	0	0	27878	0	1049221	40231925		
76097	1662	40213260	2015-03-20	2015-03-20 00:00:00	2015-03-20	2015-03-20 00:00:00	2015-03-20	581452		0	0	0		0	0	0	111741	0	121	40213260		
61858	5145	1127433	1999-02-08	1999-02-08 00:00:00	1999-02-22	1999-02-22 00:00:00	1999-02-22	38000177		0	0	14		0	0	0	342011	0	313782	1127433		
136323	2992	40213160	1956-10-26	1956-10-26 00:00:00	1956-10-26	1956-10-26 00:00:00	1956-10-26	581452		0	0	0		0	0	0	199690	0	10	40213160		
53838	4475	19059056	1987-06-04	1987-06-04 00:00:00	1987-06-18	1987-06-18 00:00:00	1987-06-18	38000177		0	0	14		0	0	0	297726	0	243670	19059056		
26313	2165	1118084	1991-09-15	1991-09-15 00:00:00	1991-09-15	1991-09-15 00:00:00	\N	38000177		0	0	0		0	0	0	144208	0	00025152531	44923712		
9883	828	40220960	2005-06-14	2005-06-14 00:00:00	2005-06-14	2005-06-14 00:00:00	2005-06-14	38000177		0	0	0		0	0	0	54823	0	1804799	40220960		
233340	5127	40213227	2017-03-10	2017-03-10 00:00:00	2017-03-10	2017-03-10 00:00:00	2017-03-10	581452		0	0	0		0	0	0	340906	0	113	40213227		
42938	936	40213306	1982-12-31	1982-12-31 00:00:00	1982-12-31	1982-12-31 00:00:00	1982-12-31	581452		0	0	0		0	0	0	62293	0	43	40213306		
149011	3277	40213260	2013-04-26	2013-04-26 00:00:00	2013-04-26	2013-04-26 00:00:00	2013-04-26	581452		0	0	0		0	0	0	217713	0	121	40213260		
20539	1690	19019979	1978-05-10	1978-05-10 00:00:00	1978-08-08	1978-08-08 00:00:00	1978-08-08	38000177		0	0	90		0	0	0	113159	0	198405	19019979		
58857	4890	40163554	2009-12-09	2009-12-09 00:00:00	2009-12-09	2009-12-09 00:00:00	\N	38000177		0	0	0		0	0	0	325166	0	855332	40163554		
31060	2576	1127433	2018-09-05	2018-09-05 00:00:00	2018-09-12	2018-09-12 00:00:00	2018-09-12	38000177		0	0	7		0	0	0	170561	0	313782	1127433		
11181	931	40229134	2009-07-26	2009-07-26 00:00:00	2009-08-09	2009-08-09 00:00:00	2009-08-09	38000177		0	0	14		0	0	0	61947	0	1043400	40229134		
11195	931	1127433	1975-12-30	1975-12-30 00:00:00	1976-01-27	1976-01-27 00:00:00	1976-01-27	38000177		0	0	28		0	0	0	61960	0	313782	1127433		
172674	3796	40213227	2018-11-20	2018-11-20 00:00:00	2018-11-20	2018-11-20 00:00:00	2018-11-20	581452		0	0	0		0	0	0	252366	0	113	40213227		
62828	5222	40163554	2004-02-12	2004-02-12 00:00:00	2004-02-12	2004-02-12 00:00:00	\N	38000177		0	0	0		0	0	0	347466	0	855332	40163554		
46970	3890	1127433	1962-09-29	1962-09-29 00:00:00	1962-10-13	1962-10-13 00:00:00	1962-10-13	38000177		0	0	14		0	0	0	258557	0	313782	1127433		
56359	4676	1127433	2002-11-04	2002-11-04 00:00:00	2002-11-25	2002-11-25 00:00:00	2002-11-25	38000177		0	0	21		0	0	0	311621	0	313782	1127433		
3742	311	19133873	1991-03-31	1991-03-31 00:00:00	1991-04-07	1991-04-07 00:00:00	1991-04-07	38000177		0	0	7		0	0	0	20630	0	834061	19133873		
120992	2659	40213160	1978-12-06	1978-12-06 00:00:00	1978-12-06	1978-12-06 00:00:00	1978-12-06	581452		0	0	0		0	0	0	176141	0	10	40213160		
88904	1950	40213227	1992-09-24	1992-09-24 00:00:00	1992-09-24	1992-09-24 00:00:00	1992-09-24	581452		0	0	0		0	0	0	129681	0	113	40213227		
93067	2043	40213227	2006-09-17	2006-09-17 00:00:00	2006-09-17	2006-09-17 00:00:00	2006-09-17	581452		0	0	0		0	0	0	135948	0	113	40213227		
15361	1282	920300	1998-05-05	1998-05-05 00:00:00	1998-05-12	1998-05-12 00:00:00	1998-05-12	38000177		0	0	7		0	0	0	84758	0	311989	920300		
205027	4500	40213260	2012-09-19	2012-09-19 00:00:00	2012-09-19	2012-09-19 00:00:00	2012-09-19	581452		0	0	0		0	0	0	299641	0	121	40213260		
53182	4418	1124300	1993-05-07	1993-05-07 00:00:00	1993-05-07	1993-05-07 00:00:00	\N	38000177		0	0	0		0	0	0	293731	0	00781178901	45011828		
131572	2891	40213227	2015-12-03	2015-12-03 00:00:00	2015-12-03	2015-12-03 00:00:00	2015-12-03	581452		0	0	0		0	0	0	192322	0	113	40213227		
202510	4446	40213296	2002-07-09	2002-07-09 00:00:00	2002-07-09	2002-07-09 00:00:00	2002-07-09	581452		0	0	0		0	0	0	295677	0	52	40213296		
31398	2602	1127078	1954-07-30	1954-07-30 00:00:00	1954-08-20	1954-08-20 00:00:00	1954-08-20	38000177		0	0	21		0	0	0	172143	0	282464	1127078		
62044	1355	40213227	2014-08-15	2014-08-15 00:00:00	2014-08-15	2014-08-15 00:00:00	2014-08-15	581452		0	0	0		0	0	0	89848	0	113	40213227		
6704	565	1713671	1982-08-31	1982-08-31 00:00:00	1982-09-14	1982-09-14 00:00:00	1982-09-14	38000177		0	0	14		0	0	0	37438	0	562251	1713671		
213962	4691	40213160	1965-04-17	1965-04-17 00:00:00	1965-04-17	1965-04-17 00:00:00	1965-04-17	581452		0	0	0		0	0	0	312552	0	10	40213160		
152835	3364	40213296	2018-10-11	2018-10-11 00:00:00	2018-10-11	2018-10-11 00:00:00	2018-10-11	581452		0	0	0		0	0	0	223056	0	52	40213296		
204842	4496	40213198	2012-05-10	2012-05-10 00:00:00	2012-05-10	2012-05-10 00:00:00	2012-05-10	581452		0	0	0		0	0	0	299286	0	133	40213198		
5103	111	40213296	2015-05-08	2015-05-08 00:00:00	2015-05-08	2015-05-08 00:00:00	2015-05-08	581452		0	0	0		0	0	0	7411	0	52	40213296		
166799	3666	40213260	2009-12-31	2009-12-31 00:00:00	2009-12-31	2009-12-31 00:00:00	2009-12-31	581452		0	0	0		0	0	0	243931	0	121	40213260		
107102	2347	40213296	2010-02-15	2010-02-15 00:00:00	2010-02-15	2010-02-15 00:00:00	2010-02-15	581452		0	0	0		0	0	0	156283	0	52	40213296		
39288	3246	40229134	1982-02-10	1982-02-10 00:00:00	1982-02-17	1982-02-17 00:00:00	1982-02-17	38000177		0	0	7		0	0	0	215803	0	1043400	40229134		
241398	5299	40213227	2013-06-23	2013-06-23 00:00:00	2013-06-23	2013-06-23 00:00:00	2013-06-23	581452		0	0	0		0	0	0	352532	0	113	40213227		
49820	4133	19059056	1978-05-21	1978-05-21 00:00:00	1978-06-04	1978-06-04 00:00:00	1978-06-04	38000177		0	0	14		0	0	0	274779	0	243670	19059056		
43523	3609	46233988	1977-02-16	1977-02-16 00:00:00	1977-03-02	1977-03-02 00:00:00	1977-03-02	38000177		0	0	14		0	0	0	239771	0	1652673	46233988		
187083	4109	40213227	1996-11-05	1996-11-05 00:00:00	1996-11-05	1996-11-05 00:00:00	1996-11-05	581452		0	0	0		0	0	0	273171	0	113	40213227		
50813	4222	19059056	1951-03-08	1951-03-08 00:00:00	1951-03-22	1951-03-22 00:00:00	1951-03-22	38000177		0	0	14		0	0	0	280341	0	243670	19059056		
172435	3790	40213260	2015-06-08	2015-06-08 00:00:00	2015-06-08	2015-06-08 00:00:00	2015-06-08	581452		0	0	0		0	0	0	252018	0	121	40213260		
223129	4898	40213260	2006-04-05	2006-04-05 00:00:00	2006-04-05	2006-04-05 00:00:00	2006-04-05	581452		0	0	0		0	0	0	325687	0	121	40213260		
107310	2351	40213227	1999-07-24	1999-07-24 00:00:00	1999-07-24	1999-07-24 00:00:00	1999-07-24	581452		0	0	0		0	0	0	156530	0	113	40213227		
9925	211	40213160	1968-03-21	1968-03-21 00:00:00	1968-03-21	1968-03-21 00:00:00	1968-03-21	581452		0	0	0		0	0	0	14356	0	10	40213160		
145864	3208	40213260	2019-01-18	2019-01-18 00:00:00	2019-01-18	2019-01-18 00:00:00	2019-01-18	581452		0	0	0		0	0	0	213234	0	121	40213260		
204665	4492	40213227	2008-04-29	2008-04-29 00:00:00	2008-04-29	2008-04-29 00:00:00	2008-04-29	581452		0	0	0		0	0	0	299126	0	113	40213227		
21357	464	40213306	1994-07-19	1994-07-19 00:00:00	1994-07-19	1994-07-19 00:00:00	1994-07-19	581452		0	0	0		0	0	0	30966	0	43	40213306		
194237	4268	40213296	1996-05-06	1996-05-06 00:00:00	1996-05-06	1996-05-06 00:00:00	1996-05-06	581452		0	0	0		0	0	0	283257	0	52	40213296		
157311	3462	40213160	1961-03-03	1961-03-03 00:00:00	1961-03-03	1961-03-03 00:00:00	1961-03-03	581452		0	0	0		0	0	0	229718	0	10	40213160		
43806	954	40213314	1977-09-18	1977-09-18 00:00:00	1977-09-18	1977-09-18 00:00:00	1977-09-18	581452		0	0	0		0	0	0	63361	0	49	40213314		
79916	1748	40213227	1997-10-11	1997-10-11 00:00:00	1997-10-11	1997-10-11 00:00:00	1997-10-11	581452		0	0	0		0	0	0	116901	0	113	40213227		
12792	1076	19128022	1997-03-16	1997-03-16 00:00:00	1998-03-11	1998-03-11 00:00:00	1998-03-11	38000177		0	0	360		0	0	0	70525	0	749785	19128022		
32914	719	40213314	1981-04-24	1981-04-24 00:00:00	1981-04-24	1981-04-24 00:00:00	1981-04-24	581452		0	0	0		0	0	0	47607	0	49	40213314		
22518	1850	1127078	1959-01-24	1959-01-24 00:00:00	1959-02-07	1959-02-07 00:00:00	1959-02-07	38000177		0	0	14		0	0	0	123731	0	282464	1127078		
19199	1586	40236824	1966-06-19	1966-06-19 00:00:00	1966-06-26	1966-06-26 00:00:00	1966-06-26	38000177		0	0	7		0	0	0	\N	0	1094107	40236824		
13311	1116	19078461	1996-02-20	1996-02-20 00:00:00	1996-04-20	1996-04-20 00:00:00	1996-04-20	38000177		0	0	60		0	0	0	73509	0	310965	19078461		
110808	2435	40213296	2013-02-08	2013-02-08 00:00:00	2013-02-08	2013-02-08 00:00:00	2013-02-08	581452		0	0	0		0	0	0	161431	0	52	40213296		
130666	2871	40213198	2016-03-07	2016-03-07 00:00:00	2016-03-07	2016-03-07 00:00:00	2016-03-07	581452		0	0	0		0	0	0	191061	0	133	40213198		
5049	421	19059056	1972-03-10	1972-03-10 00:00:00	1972-03-31	1972-03-31 00:00:00	1972-03-31	38000177		0	0	21		0	0	0	27877	0	243670	19059056		
76105	1662	40213160	1969-02-21	1969-02-21 00:00:00	1969-02-21	1969-02-21 00:00:00	1969-02-21	581452		0	0	0		0	0	0	111745	0	10	40213160		
61859	5145	19073188	1999-02-08	1999-02-08 00:00:00	1999-02-22	1999-02-22 00:00:00	1999-02-22	38000177		0	0	14		0	0	0	342011	0	308192	19073188		
136327	2992	40213296	1999-12-10	1999-12-10 00:00:00	1999-12-10	1999-12-10 00:00:00	1999-12-10	581452		0	0	0		0	0	0	199715	0	52	40213296		
53839	4475	19075001	1987-06-04	1987-06-04 00:00:00	1987-06-18	1987-06-18 00:00:00	1987-06-18	38000177		0	0	14		0	0	0	297726	0	309097	19075001		
26314	2165	40162522	1989-09-23	1989-09-23 00:00:00	1989-09-23	1989-09-23 00:00:00	\N	38000177		0	0	0		0	0	0	144208	0	857005	40162522		
9884	828	1127433	2000-01-13	2000-01-13 00:00:00	2000-01-27	2000-01-27 00:00:00	2000-01-27	38000177		0	0	14		0	0	0	54844	0	313782	1127433		
233341	5127	40213260	2017-03-10	2017-03-10 00:00:00	2017-03-10	2017-03-10 00:00:00	2017-03-10	581452		0	0	0		0	0	0	340906	0	121	40213260		
42942	936	40213227	2012-10-12	2012-10-12 00:00:00	2012-10-12	2012-10-12 00:00:00	2012-10-12	581452		0	0	0		0	0	0	62298	0	113	40213227		
149014	3277	40213296	2006-04-07	2006-04-07 00:00:00	2006-04-07	2006-04-07 00:00:00	2006-04-07	581452		0	0	0		0	0	0	217729	0	52	40213296		
20540	1690	1127433	1985-05-05	1985-05-05 00:00:00	1985-05-12	1985-05-12 00:00:00	1985-05-12	38000177		0	0	7		0	0	0	113219	0	313782	1127433		
58858	4890	40236824	1976-12-06	1976-12-06 00:00:00	1976-12-20	1976-12-20 00:00:00	1976-12-20	38000177		0	0	14		0	0	0	325083	0	1094107	40236824		
31061	2576	19133873	1982-01-28	1982-01-28 00:00:00	1982-02-08	1982-02-08 00:00:00	1982-02-08	38000177		0	0	11		0	0	0	170538	0	834061	19133873		
11182	931	19133873	1965-11-20	1965-11-20 00:00:00	1965-11-30	1965-11-30 00:00:00	1965-11-30	38000177		0	0	10		0	0	0	61967	0	834061	19133873		
11196	931	19133873	1966-01-01	1966-01-01 00:00:00	1966-01-09	1966-01-09 00:00:00	1966-01-09	38000177		0	0	8		0	0	0	61968	0	834061	19133873		
172675	3796	40213260	2018-11-20	2018-11-20 00:00:00	2018-11-20	2018-11-20 00:00:00	2018-11-20	581452		0	0	0		0	0	0	252366	0	121	40213260		
62829	5222	19018935	2004-02-12	2004-02-12 00:00:00	2004-02-12	2004-02-12 00:00:00	\N	38000177		0	0	0		0	0	0	347466	0	197604	19018935		
46971	3890	19133873	1960-03-16	1960-03-16 00:00:00	1960-03-29	1960-03-29 00:00:00	1960-03-29	38000177		0	0	13		0	0	0	258548	0	834061	19133873		
56360	4676	1127078	1982-11-03	1982-11-03 00:00:00	1982-11-17	1982-11-17 00:00:00	1982-11-17	38000177		0	0	14		0	0	0	311600	0	282464	1127078		
3743	311	1124300	2011-10-06	2011-10-06 00:00:00	2011-10-06	2011-10-06 00:00:00	\N	38000177		0	0	0		0	0	0	20647	0	00781178901	45011828		
120995	2659	40213227	2006-05-10	2006-05-10 00:00:00	2006-05-10	2006-05-10 00:00:00	2006-05-10	581452		0	0	0		0	0	0	176173	0	113	40213227		
88913	1950	40213227	2012-01-12	2012-01-12 00:00:00	2012-01-12	2012-01-12 00:00:00	2012-01-12	581452		0	0	0		0	0	0	129663	0	113	40213227		
93068	2043	40213260	2006-09-17	2006-09-17 00:00:00	2006-09-17	2006-09-17 00:00:00	2006-09-17	581452		0	0	0		0	0	0	135948	0	121	40213260		
15362	1282	1713671	1993-10-28	1993-10-28 00:00:00	1993-11-04	1993-11-04 00:00:00	1993-11-04	38000177		0	0	7		0	0	0	84754	0	562251	1713671		
205031	4500	40213296	2001-09-19	2001-09-19 00:00:00	2001-09-19	2001-09-19 00:00:00	2001-09-19	581452		0	0	0		0	0	0	299629	0	52	40213296		
53183	4418	40229134	1979-10-22	1979-10-22 00:00:00	1979-10-29	1979-10-29 00:00:00	1979-10-29	38000177		0	0	7		0	0	0	293750	0	1043400	40229134		
131573	2891	40213296	2015-12-03	2015-12-03 00:00:00	2015-12-03	2015-12-03 00:00:00	2015-12-03	581452		0	0	0		0	0	0	192322	0	52	40213296		
202513	4446	40213160	1960-12-06	1960-12-06 00:00:00	1960-12-06	1960-12-06 00:00:00	1960-12-06	581452		0	0	0		0	0	0	295661	0	10	40213160		
31399	2603	1713671	1968-03-10	1968-03-10 00:00:00	1968-03-31	1968-03-31 00:00:00	1968-03-31	38000177		0	0	21		0	0	0	172193	0	562251	1713671		
62047	1355	40213260	2013-08-09	2013-08-09 00:00:00	2013-08-09	2013-08-09 00:00:00	2013-08-09	581452		0	0	0		0	0	0	89822	0	121	40213260		
6705	565	1127433	1980-07-14	1980-07-14 00:00:00	1980-07-28	1980-07-28 00:00:00	1980-07-28	38000177		0	0	14		0	0	0	37405	0	313782	1127433		
213970	4691	40213160	1960-08-13	1960-08-13 00:00:00	1960-08-13	1960-08-13 00:00:00	1960-08-13	581452		0	0	0		0	0	0	312541	0	10	40213160		
152839	3364	40213306	1998-08-27	1998-08-27 00:00:00	1998-08-27	1998-08-27 00:00:00	1998-08-27	581452		0	0	0		0	0	0	223133	0	43	40213306		
204874	4497	40213227	2017-12-05	2017-12-05 00:00:00	2017-12-05	2017-12-05 00:00:00	2017-12-05	581452		0	0	0		0	0	0	299414	0	113	40213227		
5107	111	40213306	1997-07-04	1997-07-04 00:00:00	1997-07-04	1997-07-04 00:00:00	1997-07-04	581452		0	0	0		0	0	0	7399	0	43	40213306		
230963	5076	40213227	1991-12-31	1991-12-31 00:00:00	1991-12-31	1991-12-31 00:00:00	1991-12-31	581452		0	0	0		0	0	0	337318	0	113	40213227		
107104	2347	40213160	1969-05-12	1969-05-12 00:00:00	1969-05-12	1969-05-12 00:00:00	1969-05-12	581452		0	0	0		0	0	0	156238	0	10	40213160		
39289	3246	19073183	1984-08-15	1984-08-15 00:00:00	1984-08-26	1984-08-26 00:00:00	1984-08-26	38000177		0	0	11		0	0	0	215796	0	308182	19073183		
241399	5299	40213296	2013-06-23	2013-06-23 00:00:00	2013-06-23	2013-06-23 00:00:00	2013-06-23	581452		0	0	0		0	0	0	352532	0	52	40213296		
49821	4133	46233988	1978-05-21	1978-05-21 00:00:00	1978-06-04	1978-06-04 00:00:00	1978-06-04	38000177		0	0	14		0	0	0	274779	0	1652673	46233988		
43524	3609	19078461	1992-01-16	1992-01-16 00:00:00	1992-02-06	1992-02-06 00:00:00	1992-02-06	38000177		0	0	21		0	0	0	239788	0	310965	19078461		
187091	4109	40213160	1965-08-10	1965-08-10 00:00:00	1965-08-10	1965-08-10 00:00:00	1965-08-10	581452		0	0	0		0	0	0	273162	0	10	40213160		
50814	4222	1713671	1998-05-19	1998-05-19 00:00:00	1998-05-26	1998-05-26 00:00:00	1998-05-26	38000177		0	0	7		0	0	0	280307	0	562251	1713671		
172440	3790	40213296	2003-07-07	2003-07-07 00:00:00	2003-07-07	2003-07-07 00:00:00	2003-07-07	581452		0	0	0		0	0	0	252006	0	52	40213296		
223135	4898	40213227	2014-05-21	2014-05-21 00:00:00	2014-05-21	2014-05-21 00:00:00	2014-05-21	581452		0	0	0		0	0	0	325720	0	113	40213227		
107320	2351	40213198	2013-10-12	2013-10-12 00:00:00	2013-10-12	2013-10-12 00:00:00	2013-10-12	581452		0	0	0		0	0	0	156545	0	133	40213198		
9927	211	40213296	2010-12-16	2010-12-16 00:00:00	2010-12-16	2010-12-16 00:00:00	2010-12-16	581452		0	0	0		0	0	0	14410	0	52	40213296		
145869	3208	40213160	1968-09-20	1968-09-20 00:00:00	1968-09-20	1968-09-20 00:00:00	1968-09-20	581452		0	0	0		0	0	0	213224	0	10	40213160		
204682	4493	40213160	1983-03-01	1983-03-01 00:00:00	1983-03-01	1983-03-01 00:00:00	1983-03-01	581452		0	0	0		0	0	0	299145	0	10	40213160		
21366	464	40213160	1972-08-22	1972-08-22 00:00:00	1972-08-22	1972-08-22 00:00:00	1972-08-22	581452		0	0	0		0	0	0	30956	0	10	40213160		
194245	4268	40213160	1956-05-21	1956-05-21 00:00:00	1956-05-21	1956-05-21 00:00:00	1956-05-21	581452		0	0	0		0	0	0	283299	0	10	40213160		
157320	3462	40213260	2011-03-18	2011-03-18 00:00:00	2011-03-18	2011-03-18 00:00:00	2011-03-18	581452		0	0	0		0	0	0	229726	0	121	40213260		
43809	954	40213227	2016-04-24	2016-04-24 00:00:00	2016-04-24	2016-04-24 00:00:00	2016-04-24	581452		0	0	0		0	0	0	63402	0	113	40213227		
79926	1748	40213227	2007-12-08	2007-12-08 00:00:00	2007-12-08	2007-12-08 00:00:00	2007-12-08	581452		0	0	0		0	0	0	116840	0	113	40213227		
12793	1076	19128022	1999-03-06	1999-03-06 00:00:00	2000-02-29	2000-02-29 00:00:00	2000-02-29	38000177		0	0	360		0	0	0	70527	0	749785	19128022		
32918	719	40213160	1981-02-20	1981-02-20 00:00:00	1981-02-20	1981-02-20 00:00:00	1981-02-20	581452		0	0	0		0	0	0	47585	0	10	40213160		
22519	1850	1127078	1963-01-17	1963-01-17 00:00:00	1963-02-07	1963-02-07 00:00:00	1963-02-07	38000177		0	0	21		0	0	0	123733	0	282464	1127078		
19200	1586	920300	1966-06-19	1966-06-19 00:00:00	1966-06-26	1966-06-26 00:00:00	1966-06-26	38000177		0	0	7		0	0	0	\N	0	311989	920300		
13312	1116	19059056	1967-02-03	1967-02-03 00:00:00	1967-02-17	1967-02-17 00:00:00	1967-02-17	38000177		0	0	14		0	0	0	73551	0	243670	19059056		
110811	2435	40213227	2004-11-12	2004-11-12 00:00:00	2004-11-12	2004-11-12 00:00:00	2004-11-12	581452		0	0	0		0	0	0	161386	0	113	40213227		
130669	2871	40213227	1992-12-21	1992-12-21 00:00:00	1992-12-21	1992-12-21 00:00:00	1992-12-21	581452		0	0	0		0	0	0	191140	0	113	40213227		
5050	421	1127433	1999-07-09	1999-07-09 00:00:00	1999-07-30	1999-07-30 00:00:00	1999-07-30	38000177		0	0	21		0	0	0	27879	0	313782	1127433		
76117	1662	40213160	1964-06-19	1964-06-19 00:00:00	1964-06-19	1964-06-19 00:00:00	1964-06-19	581452		0	0	0		0	0	0	111724	0	10	40213160		
61860	5145	40236824	1979-01-13	1979-01-13 00:00:00	1979-01-20	1979-01-20 00:00:00	1979-01-20	38000177		0	0	7		0	0	0	342039	0	1094107	40236824		
136340	2993	40213296	2010-06-19	2010-06-19 00:00:00	2010-06-19	2010-06-19 00:00:00	2010-06-19	581452		0	0	0		0	0	0	199776	0	52	40213296		
53840	4475	1127078	1983-08-24	1983-08-24 00:00:00	1983-09-23	1983-09-23 00:00:00	1983-09-23	38000177		0	0	30		0	0	0	297713	0	282464	1127078		
26315	2165	19059056	1962-04-20	1962-04-20 00:00:00	1962-05-11	1962-05-11 00:00:00	1962-05-11	38000177		0	0	21		0	0	0	144275	0	243670	19059056		
9885	828	19059056	1965-06-14	1965-06-14 00:00:00	1965-09-12	1965-09-12 00:00:00	1965-09-12	38000177		0	0	90		0	0	0	54862	0	243670	19059056		
233343	5127	40213296	2009-02-13	2009-02-13 00:00:00	2009-02-13	2009-02-13 00:00:00	2009-02-13	581452		0	0	0		0	0	0	340864	0	52	40213296		
42943	936	40213260	2012-10-12	2012-10-12 00:00:00	2012-10-12	2012-10-12 00:00:00	2012-10-12	581452		0	0	0		0	0	0	62298	0	121	40213260		
137193	3011	40213227	2006-04-11	2006-04-11 00:00:00	2006-04-11	2006-04-11 00:00:00	2006-04-11	581452		0	0	0		0	0	0	200813	0	113	40213227		
20541	1690	1127433	2002-07-03	2002-07-03 00:00:00	2002-08-07	2002-08-07 00:00:00	2002-08-07	38000177		0	0	35		0	0	0	113160	0	313782	1127433		
58859	4890	920300	1976-12-06	1976-12-06 00:00:00	1976-12-13	1976-12-13 00:00:00	1976-12-13	38000177		0	0	7		0	0	0	325083	0	311989	920300		
31062	2576	1118084	2019-04-12	2019-04-12 00:00:00	2019-04-12	2019-04-12 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00025152531	44923712		
11183	931	19059056	1965-05-07	1965-05-07 00:00:00	1965-05-21	1965-05-21 00:00:00	1965-05-21	38000177		0	0	14		0	0	0	61958	0	243670	19059056		
11197	931	1713671	2015-12-09	2015-12-09 00:00:00	2015-12-23	2015-12-23 00:00:00	2015-12-23	38000177		0	0	14		0	0	0	61930	0	562251	1713671		
172678	3796	40213160	1968-07-23	1968-07-23 00:00:00	1968-07-23	1968-07-23 00:00:00	1968-07-23	581452		0	0	0		0	0	0	252415	0	10	40213160		
62830	5222	40171902	2004-02-12	2004-02-12 00:00:00	2004-02-12	2004-02-12 00:00:00	\N	38000177		0	0	0		0	0	0	347466	0	897718	40171902		
46972	3890	1127078	1955-07-07	1955-07-07 00:00:00	1955-07-21	1955-07-21 00:00:00	1955-07-21	38000177		0	0	14		0	0	0	258570	0	282464	1127078		
56361	4676	19074843	1982-11-03	1982-11-03 00:00:00	1982-11-17	1982-11-17 00:00:00	1982-11-17	38000177		0	0	14		0	0	0	311600	0	309045	19074843		
3744	311	1127433	2016-09-18	2016-09-18 00:00:00	2016-10-23	2016-10-23 00:00:00	2016-10-23	38000177		0	0	35		0	0	0	20656	0	313782	1127433		
120999	2659	40213160	1974-12-04	1974-12-04 00:00:00	1974-12-04	1974-12-04 00:00:00	1974-12-04	581452		0	0	0		0	0	0	176123	0	10	40213160		
837	18	40213227	2017-01-04	2017-01-04 00:00:00	2017-01-04	2017-01-04 00:00:00	2017-01-04	581452		0	0	0		0	0	0	1444	0	113	40213227		
93071	2043	40213160	1960-08-21	1960-08-21 00:00:00	1960-08-21	1960-08-21 00:00:00	1960-08-21	581452		0	0	0		0	0	0	135882	0	10	40213160		
15363	1282	19019979	1977-03-29	1977-03-29 00:00:00	1977-04-12	1977-04-12 00:00:00	1977-04-12	38000177		0	0	14		0	0	0	84707	0	198405	19019979		
205035	4500	40213296	2003-09-24	2003-09-24 00:00:00	2003-09-24	2003-09-24 00:00:00	2003-09-24	581452		0	0	0		0	0	0	299653	0	52	40213296		
53184	4418	1127078	1955-01-07	1955-01-07 00:00:00	1955-01-21	1955-01-21 00:00:00	1955-01-21	38000177		0	0	14		0	0	0	293706	0	282464	1127078		
131578	2891	40213160	1974-05-02	1974-05-02 00:00:00	1974-05-02	1974-05-02 00:00:00	1974-05-02	581452		0	0	0		0	0	0	192330	0	10	40213160		
202519	4446	40213160	1960-10-04	1960-10-04 00:00:00	1960-10-04	1960-10-04 00:00:00	1960-10-04	581452		0	0	0		0	0	0	295652	0	10	40213160		
31400	2603	19006318	1960-10-22	1960-10-22 00:00:00	1960-11-05	1960-11-05 00:00:00	1960-11-05	38000177		0	0	14		0	0	0	172235	0	105078	19006318		
62052	1355	40213306	1986-03-07	1986-03-07 00:00:00	1986-03-07	1986-03-07 00:00:00	1986-03-07	581452		0	0	0		0	0	0	89818	0	43	40213306		
6706	565	19006318	1958-10-31	1958-10-31 00:00:00	1958-11-14	1958-11-14 00:00:00	1958-11-14	38000177		0	0	14		0	0	0	37441	0	105078	19006318		
213978	4691	40213227	2011-05-14	2011-05-14 00:00:00	2011-05-14	2011-05-14 00:00:00	2011-05-14	581452		0	0	0		0	0	0	312582	0	113	40213227		
152841	3364	40213227	1998-08-27	1998-08-27 00:00:00	1998-08-27	1998-08-27 00:00:00	1998-08-27	581452		0	0	0		0	0	0	223133	0	113	40213227		
160883	3540	40213160	1974-10-07	1974-10-07 00:00:00	1974-10-07	1974-10-07 00:00:00	1974-10-07	581452		0	0	0		0	0	0	235138	0	10	40213160		
5109	111	40213227	1997-07-04	1997-07-04 00:00:00	1997-07-04	1997-07-04 00:00:00	1997-07-04	581452		0	0	0		0	0	0	7399	0	113	40213227		
230988	5076	40213227	2000-02-15	2000-02-15 00:00:00	2000-02-15	2000-02-15 00:00:00	2000-02-15	581452		0	0	0		0	0	0	337350	0	113	40213227		
61037	5076	19059056	1946-09-22	1946-09-22 00:00:00	1946-10-27	1946-10-27 00:00:00	1946-10-27	38000177		0	0	35		0	0	0	337326	0	243670	19059056		
39290	3246	19019979	1981-10-28	1981-10-28 00:00:00	1981-11-11	1981-11-11 00:00:00	1981-11-11	38000177		0	0	14		0	0	0	215795	0	198405	19019979		
241401	5299	40213160	1972-02-20	1972-02-20 00:00:00	1972-02-20	1972-02-20 00:00:00	1972-02-20	581452		0	0	0		0	0	0	352511	0	10	40213160		
49822	4133	1127433	2012-07-10	2012-07-10 00:00:00	2012-07-31	2012-07-31 00:00:00	2012-07-31	38000177		0	0	21		0	0	0	274816	0	313782	1127433		
55010	4569	1713671	1989-08-23	1989-08-23 00:00:00	1989-09-13	1989-09-13 00:00:00	1989-09-13	38000177		0	0	21		0	0	0	304370	0	562251	1713671		
187099	4109	40213296	2007-05-22	2007-05-22 00:00:00	2007-05-22	2007-05-22 00:00:00	2007-05-22	581452		0	0	0		0	0	0	273193	0	52	40213296		
50815	4223	40162522	1973-05-01	1973-05-01 00:00:00	1973-05-01	1973-05-01 00:00:00	\N	38000177		0	0	0		0	0	0	280379	0	857005	40162522		
172446	3790	40213160	1963-12-09	1963-12-09 00:00:00	1963-12-09	1963-12-09 00:00:00	1963-12-09	581452		0	0	0		0	0	0	252024	0	10	40213160		
223145	4898	40213201	2019-06-19	2019-06-19 00:00:00	2019-06-19	2019-06-19 00:00:00	2019-06-19	581452		0	0	0		0	0	0	325722	0	33	40213201		
107323	2351	40213201	2014-10-18	2014-10-18 00:00:00	2014-10-18	2014-10-18 00:00:00	2014-10-18	581452		0	0	0		0	0	0	156534	0	33	40213201		
9930	211	40213227	2000-08-17	2000-08-17 00:00:00	2000-08-17	2000-08-17 00:00:00	2000-08-17	581452		0	0	0		0	0	0	14385	0	113	40213227		
145875	3208	40213296	2008-01-18	2008-01-18 00:00:00	2008-01-18	2008-01-18 00:00:00	2008-01-18	581452		0	0	0		0	0	0	213281	0	52	40213296		
204685	4493	40213160	1987-06-02	1987-06-02 00:00:00	1987-06-02	1987-06-02 00:00:00	1987-06-02	581452		0	0	0		0	0	0	299149	0	10	40213160		
21368	464	40213160	1973-01-23	1973-01-23 00:00:00	1973-01-23	1973-01-23 00:00:00	1973-01-23	581452		0	0	0		0	0	0	30957	0	10	40213160		
194253	4268	40213260	2007-09-24	2007-09-24 00:00:00	2007-09-24	2007-09-24 00:00:00	2007-09-24	581452		0	0	0		0	0	0	283260	0	121	40213260		
157323	3462	40213160	1960-12-30	1960-12-30 00:00:00	1960-12-30	1960-12-30 00:00:00	1960-12-30	581452		0	0	0		0	0	0	229759	0	10	40213160		
43810	954	40213296	2016-04-24	2016-04-24 00:00:00	2016-04-24	2016-04-24 00:00:00	2016-04-24	581452		0	0	0		0	0	0	63402	0	52	40213296		
221155	4853	40213227	2013-05-15	2013-05-15 00:00:00	2013-05-15	2013-05-15 00:00:00	2013-05-15	581452		0	0	0		0	0	0	322923	0	113	40213227		
12794	1076	19019979	1981-12-25	1981-12-25 00:00:00	1982-02-23	1982-02-23 00:00:00	1982-02-23	38000177		0	0	60		0	0	0	70553	0	198405	19019979		
32919	719	40213160	1981-04-24	1981-04-24 00:00:00	1981-04-24	1981-04-24 00:00:00	1981-04-24	581452		0	0	0		0	0	0	47607	0	10	40213160		
22520	1850	19059056	1957-12-09	1957-12-09 00:00:00	1957-12-30	1957-12-30 00:00:00	1957-12-30	38000177		0	0	21		0	0	0	123730	0	243670	19059056		
19201	1586	19126352	1966-05-22	1966-05-22 00:00:00	1966-05-22	1966-05-22 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	705129	19126352		
13313	1116	46233988	1967-02-03	1967-02-03 00:00:00	1967-02-17	1967-02-17 00:00:00	1967-02-17	38000177		0	0	14		0	0	0	73551	0	1652673	46233988		
110812	2435	40213160	1973-07-20	1973-07-20 00:00:00	1973-07-20	1973-07-20 00:00:00	1973-07-20	581452		0	0	0		0	0	0	161391	0	10	40213160		
141949	3118	40213227	1992-12-20	1992-12-20 00:00:00	1992-12-20	1992-12-20 00:00:00	1992-12-20	581452		0	0	0		0	0	0	207452	0	113	40213227		
5052	421	1127078	1966-07-11	1966-07-11 00:00:00	1966-07-25	1966-07-25 00:00:00	1966-07-25	38000177		0	0	14		0	0	0	27883	0	282464	1127078		
76122	1662	40213306	1987-02-20	1987-02-20 00:00:00	1987-02-20	1987-02-20 00:00:00	1987-02-20	581452		0	0	0		0	0	0	111731	0	43	40213306		
61861	5145	920300	1979-01-13	1979-01-13 00:00:00	1979-01-20	1979-01-20 00:00:00	1979-01-20	38000177		0	0	7		0	0	0	342039	0	311989	920300		
136342	2993	40213160	1975-05-24	1975-05-24 00:00:00	1975-05-24	1975-05-24 00:00:00	1975-05-24	581452		0	0	0		0	0	0	199812	0	10	40213160		
53841	4475	1127078	1988-08-27	1988-08-27 00:00:00	1988-10-26	1988-10-26 00:00:00	1988-10-26	38000177		0	0	60		0	0	0	297714	0	282464	1127078		
26316	2165	40229134	2014-07-03	2014-07-03 00:00:00	2014-07-10	2014-07-10 00:00:00	2014-07-10	38000177		0	0	7		0	0	0	144191	0	1043400	40229134		
9886	828	1713671	1957-12-28	1957-12-28 00:00:00	1958-01-04	1958-01-04 00:00:00	1958-01-04	38000177		0	0	7		0	0	0	54815	0	562251	1713671		
233348	5127	40213160	1970-08-21	1970-08-21 00:00:00	1970-08-21	1970-08-21 00:00:00	1970-08-21	581452		0	0	0		0	0	0	340880	0	10	40213160		
65161	1426	40213160	1955-02-15	1955-02-15 00:00:00	1955-02-15	1955-02-15 00:00:00	1955-02-15	581452		0	0	0		0	0	0	94824	0	10	40213160		
137195	3011	40213306	1997-04-08	1997-04-08 00:00:00	1997-04-08	1997-04-08 00:00:00	1997-04-08	581452		0	0	0		0	0	0	200810	0	43	40213306		
20542	1691	19133873	1951-01-11	1951-01-11 00:00:00	1951-01-24	1951-01-24 00:00:00	1951-01-24	38000177		0	0	13		0	0	0	113255	0	834061	19133873		
58860	4890	19133873	1934-08-15	1934-08-15 00:00:00	1934-08-28	1934-08-28 00:00:00	1934-08-28	38000177		0	0	13		0	0	0	325062	0	834061	19133873		
31063	2576	19128065	1998-10-09	1998-10-09 00:00:00	1999-10-04	1999-10-04 00:00:00	1999-10-04	38000177		0	0	360		0	0	0	170553	0	749882	19128065		
11184	931	1127433	1975-09-17	1975-09-17 00:00:00	1975-10-01	1975-10-01 00:00:00	1975-10-01	38000177		0	0	14		0	0	0	61982	0	313782	1127433		
11198	932	19059056	1971-01-15	1971-01-15 00:00:00	1971-02-14	1971-02-14 00:00:00	1971-02-14	38000177		0	0	30		0	0	0	62026	0	243670	19059056		
172683	3796	40213160	1968-04-23	1968-04-23 00:00:00	1968-04-23	1968-04-23 00:00:00	1968-04-23	581452		0	0	0		0	0	0	252382	0	10	40213160		
62831	5222	1127433	1983-10-13	1983-10-13 00:00:00	1983-10-27	1983-10-27 00:00:00	1983-10-27	38000177		0	0	14		0	0	0	347356	0	313782	1127433		
46973	3890	19006318	1955-07-07	1955-07-07 00:00:00	1955-07-21	1955-07-21 00:00:00	1955-07-21	38000177		0	0	14		0	0	0	258570	0	105078	19006318		
56362	4676	19078461	1997-12-25	1997-12-25 00:00:00	1998-01-29	1998-01-29 00:00:00	1998-01-29	38000177		0	0	35		0	0	0	311619	0	310965	19078461		
3745	311	1127078	1978-05-22	1978-05-22 00:00:00	1978-06-12	1978-06-12 00:00:00	1978-06-12	38000177		0	0	21		0	0	0	20650	0	282464	1127078		
838	18	40213260	2017-01-04	2017-01-04 00:00:00	2017-01-04	2017-01-04 00:00:00	2017-01-04	581452		0	0	0		0	0	0	1444	0	121	40213260		
93076	2043	40213160	1956-02-19	1956-02-19 00:00:00	1956-02-19	1956-02-19 00:00:00	1956-02-19	581452		0	0	0		0	0	0	135899	0	10	40213160		
15364	1282	1127433	1985-09-14	1985-09-14 00:00:00	1985-09-28	1985-09-28 00:00:00	1985-09-28	38000177		0	0	14		0	0	0	84752	0	313782	1127433		
205037	4500	40213227	2003-09-24	2003-09-24 00:00:00	2003-09-24	2003-09-24 00:00:00	2003-09-24	581452		0	0	0		0	0	0	299653	0	113	40213227		
53185	4418	19006318	1955-01-07	1955-01-07 00:00:00	1955-01-21	1955-01-21 00:00:00	1955-01-21	38000177		0	0	14		0	0	0	293706	0	105078	19006318		
131589	2892	40213314	1977-07-01	1977-07-01 00:00:00	1977-07-01	1977-07-01 00:00:00	1977-07-01	581452		0	0	0		0	0	0	192427	0	49	40213314		
202523	4446	40213296	2000-07-04	2000-07-04 00:00:00	2000-07-04	2000-07-04 00:00:00	2000-07-04	581452		0	0	0		0	0	0	295643	0	52	40213296		
31401	2603	1127078	1960-10-22	1960-10-22 00:00:00	1960-11-05	1960-11-05 00:00:00	1960-11-05	38000177		0	0	14		0	0	0	172235	0	282464	1127078		
62054	1355	40213160	1963-11-15	1963-11-15 00:00:00	1963-11-15	1963-11-15 00:00:00	1963-11-15	581452		0	0	0		0	0	0	89803	0	10	40213160		
6707	565	19059056	1958-10-31	1958-10-31 00:00:00	1958-11-14	1958-11-14 00:00:00	1958-11-14	38000177		0	0	14		0	0	0	37441	0	243670	19059056		
213979	4691	40213260	2011-05-14	2011-05-14 00:00:00	2011-05-14	2011-05-14 00:00:00	2011-05-14	581452		0	0	0		0	0	0	312582	0	121	40213260		
152843	3364	40213251	1984-06-21	1984-06-21 00:00:00	1984-06-21	1984-06-21 00:00:00	1984-06-21	581452		0	0	0		0	0	0	223083	0	21	40213251		
160885	3540	40213227	2006-11-13	2006-11-13 00:00:00	2006-11-13	2006-11-13 00:00:00	2006-11-13	581452		0	0	0		0	0	0	235161	0	113	40213227		
5116	111	40213160	1976-01-09	1976-01-09 00:00:00	1976-01-09	1976-01-09 00:00:00	1976-01-09	581452		0	0	0		0	0	0	7387	0	10	40213160		
230996	5076	40213227	2019-06-04	2019-06-04 00:00:00	2019-06-04	2019-06-04 00:00:00	2019-06-04	581452		0	0	0		0	0	0	337325	0	113	40213227		
61038	5076	19059056	1947-11-21	1947-11-21 00:00:00	1947-12-12	1947-12-12 00:00:00	1947-12-12	38000177		0	0	21		0	0	0	337327	0	243670	19059056		
39291	3246	19073183	1981-10-28	1981-10-28 00:00:00	1981-11-11	1981-11-11 00:00:00	1981-11-11	38000177		0	0	14		0	0	0	215795	0	308182	19073183		
241405	5299	40213160	1971-11-21	1971-11-21 00:00:00	1971-11-21	1971-11-21 00:00:00	1971-11-21	581452		0	0	0		0	0	0	352497	0	10	40213160		
49823	4133	1124300	2009-10-10	2009-10-10 00:00:00	2009-10-10	2009-10-10 00:00:00	\N	38000177		0	0	0		0	0	0	274812	0	00781178901	45011828		
55011	4569	1127078	1964-12-08	1964-12-08 00:00:00	1964-12-22	1964-12-22 00:00:00	1964-12-22	38000177		0	0	14		0	0	0	304401	0	282464	1127078		
187101	4109	40213227	2007-05-22	2007-05-22 00:00:00	2007-05-22	2007-05-22 00:00:00	2007-05-22	581452		0	0	0		0	0	0	273193	0	113	40213227		
50816	4223	19059056	1973-05-01	1973-05-01 00:00:00	1973-05-31	1973-05-31 00:00:00	1973-05-31	38000177		0	0	30		0	0	0	280379	0	243670	19059056		
172447	3790	40213160	1964-03-09	1964-03-09 00:00:00	1964-03-09	1964-03-09 00:00:00	1964-03-09	581452		0	0	0		0	0	0	252005	0	10	40213160		
223149	4898	40213227	1995-09-13	1995-09-13 00:00:00	1995-09-13	1995-09-13 00:00:00	1995-09-13	581452		0	0	0		0	0	0	325717	0	113	40213227		
107325	2352	40213296	2012-03-19	2012-03-19 00:00:00	2012-03-19	2012-03-19 00:00:00	2012-03-19	581452		0	0	0		0	0	0	156614	0	52	40213296		
9934	211	40213227	2019-01-10	2019-01-10 00:00:00	2019-01-10	2019-01-10 00:00:00	2019-01-10	581452		0	0	0		0	0	0	14404	0	113	40213227		
145876	3208	40213296	2010-01-22	2010-01-22 00:00:00	2010-01-22	2010-01-22 00:00:00	2010-01-22	581452		0	0	0		0	0	0	213282	0	52	40213296		
204686	4493	40213251	1987-06-02	1987-06-02 00:00:00	1987-06-02	1987-06-02 00:00:00	1987-06-02	581452		0	0	0		0	0	0	299149	0	21	40213251		
21371	464	40213296	2012-05-22	2012-05-22 00:00:00	2012-05-22	2012-05-22 00:00:00	2012-05-22	581452		0	0	0		0	0	0	30998	0	52	40213296		
194256	4268	40213227	1998-05-11	1998-05-11 00:00:00	1998-05-11	1998-05-11 00:00:00	1998-05-11	581452		0	0	0		0	0	0	283295	0	113	40213227		
168628	3707	40213227	2010-09-13	2010-09-13 00:00:00	2010-09-13	2010-09-13 00:00:00	2010-09-13	581452		0	0	0		0	0	0	246428	0	113	40213227		
43811	954	40213314	1978-03-19	1978-03-19 00:00:00	1978-03-19	1978-03-19 00:00:00	1978-03-19	581452		0	0	0		0	0	0	63405	0	49	40213314		
221165	4853	40213306	1984-07-11	1984-07-11 00:00:00	1984-07-11	1984-07-11 00:00:00	1984-07-11	581452		0	0	0		0	0	0	322941	0	43	40213306		
12795	1077	1127433	2006-03-04	2006-03-04 00:00:00	2006-04-08	2006-04-08 00:00:00	2006-04-08	38000177		0	0	35		0	0	0	70603	0	313782	1127433		
32920	719	40213314	1981-02-20	1981-02-20 00:00:00	1981-02-20	1981-02-20 00:00:00	1981-02-20	581452		0	0	0		0	0	0	47585	0	49	40213314		
22521	1850	1713671	1972-06-28	1972-06-28 00:00:00	1972-07-19	1972-07-19 00:00:00	1972-07-19	38000177		0	0	21		0	0	0	123778	0	562251	1713671		
19202	1586	19006318	1953-04-27	1953-04-27 00:00:00	1953-05-11	1953-05-11 00:00:00	1953-05-11	38000177		0	0	14		0	0	0	106432	0	105078	19006318		
13314	1116	1127433	1997-09-25	1997-09-25 00:00:00	1997-10-02	1997-10-02 00:00:00	1997-10-02	38000177		0	0	7		0	0	0	73550	0	313782	1127433		
110816	2435	40213227	2014-03-14	2014-03-14 00:00:00	2014-03-14	2014-03-14 00:00:00	2014-03-14	581452		0	0	0		0	0	0	161388	0	113	40213227		
141961	3119	40213296	2014-06-23	2014-06-23 00:00:00	2014-06-23	2014-06-23 00:00:00	2014-06-23	581452		0	0	0		0	0	0	207559	0	52	40213296		
5053	421	19129655	1966-07-11	1966-07-11 00:00:00	1966-07-25	1966-07-25 00:00:00	1966-07-25	38000177		0	0	14		0	0	0	27883	0	789980	19129655		
238147	5228	40213201	2001-09-20	2001-09-20 00:00:00	2001-09-20	2001-09-20 00:00:00	2001-09-20	581452		0	0	0		0	0	0	347845	0	33	40213201		
61862	5145	19006318	1958-06-26	1958-06-26 00:00:00	1958-07-10	1958-07-10 00:00:00	1958-07-10	38000177		0	0	14		0	0	0	342037	0	105078	19006318		
229473	5043	40213296	2015-10-02	2015-10-02 00:00:00	2015-10-02	2015-10-02 00:00:00	2015-10-02	581452		0	0	0		0	0	0	335175	0	52	40213296		
53842	4475	1127433	1992-10-06	1992-10-06 00:00:00	1992-10-13	1992-10-13 00:00:00	1992-10-13	38000177		0	0	7		0	0	0	297738	0	313782	1127433		
62949	1377	40213160	1980-08-12	1980-08-12 00:00:00	1980-08-12	1980-08-12 00:00:00	1980-08-12	581452		0	0	0		0	0	0	91276	0	10	40213160		
9887	828	40165015	1971-04-21	1971-04-21 00:00:00	1971-04-21	1971-04-21 00:00:00	\N	38000177		0	0	0		0	0	0	54874	0	861467	40165015		
233352	5127	40213160	1966-05-20	1966-05-20 00:00:00	1966-05-20	1966-05-20 00:00:00	1966-05-20	581452		0	0	0		0	0	0	340847	0	10	40213160		
69338	1517	40213201	2004-02-02	2004-02-02 00:00:00	2004-02-02	2004-02-02 00:00:00	2004-02-02	581452		0	0	0		0	0	0	101402	0	33	40213201		
137197	3011	40213227	1997-04-08	1997-04-08 00:00:00	1997-04-08	1997-04-08 00:00:00	1997-04-08	581452		0	0	0		0	0	0	200810	0	113	40213227		
20543	1691	1127433	1970-06-29	1970-06-29 00:00:00	1970-07-13	1970-07-13 00:00:00	1970-07-13	38000177		0	0	14		0	0	0	113262	0	313782	1127433		
11397	245	40213227	1998-05-31	1998-05-31 00:00:00	1998-05-31	1998-05-31 00:00:00	1998-05-31	581452		0	0	0		0	0	0	16415	0	113	40213227		
31064	2576	19133873	1993-09-27	1993-09-27 00:00:00	1993-10-06	1993-10-06 00:00:00	1993-10-06	38000177		0	0	9		0	0	0	170557	0	834061	19133873		
11185	931	1539411	2015-10-16	2015-10-16 00:00:00	2015-10-16	2015-10-16 00:00:00	\N	38000177		0	0	0		0	0	0	62003	0	312961	1539411		
11199	932	40231925	2017-05-25	2017-05-25 00:00:00	2017-05-25	2017-05-25 00:00:00	\N	38000177		0	0	0		0	0	0	62055	0	1049221	40231925		
172688	3796	40213296	2007-11-20	2007-11-20 00:00:00	2007-11-20	2007-11-20 00:00:00	2007-11-20	581452		0	0	0		0	0	0	252409	0	52	40213296		
62832	5222	40229134	1977-04-29	1977-04-29 00:00:00	1977-05-13	1977-05-13 00:00:00	1977-05-13	38000177		0	0	14		0	0	0	347355	0	1043400	40229134		
46974	3890	1118084	1993-01-28	1993-01-28 00:00:00	1993-01-28	1993-01-28 00:00:00	\N	38000177		0	0	0		0	0	0	258569	0	00025152531	44923712		
56363	4676	1127078	1981-11-19	1981-11-19 00:00:00	1981-12-03	1981-12-03 00:00:00	1981-12-03	38000177		0	0	14		0	0	0	311604	0	282464	1127078		
3746	311	19133905	2016-01-11	2016-01-11 00:00:00	2016-01-22	2016-01-22 00:00:00	2016-01-22	38000177		0	0	11		0	0	0	20618	0	834102	19133905		
843	18	40213160	1966-04-27	1966-04-27 00:00:00	1966-04-27	1966-04-27 00:00:00	1966-04-27	581452		0	0	0		0	0	0	1398	0	10	40213160		
104360	2289	40213227	2011-01-04	2011-01-04 00:00:00	2011-01-04	2011-01-04 00:00:00	2011-01-04	581452		0	0	0		0	0	0	152280	0	113	40213227		
15365	1282	1551192	1994-03-31	1994-03-31 00:00:00	1994-03-31	1994-03-31 00:00:00	1994-03-31	38000177		0	0	0		0	0	0	84736	0	312617	1551192		
205039	4500	40213260	2011-09-14	2011-09-14 00:00:00	2011-09-14	2011-09-14 00:00:00	2011-09-14	581452		0	0	0		0	0	0	299630	0	121	40213260		
53186	4418	1127078	1956-05-22	1956-05-22 00:00:00	1956-06-12	1956-06-12 00:00:00	1956-06-12	38000177		0	0	21		0	0	0	293695	0	282464	1127078		
131592	2892	40213160	1977-07-01	1977-07-01 00:00:00	1977-07-01	1977-07-01 00:00:00	1977-07-01	581452		0	0	0		0	0	0	192427	0	10	40213160		
202527	4447	40213201	2018-01-30	2018-01-30 00:00:00	2018-01-30	2018-01-30 00:00:00	2018-01-30	581452		0	0	0		0	0	0	295798	0	33	40213201		
31402	2603	1127433	1983-01-30	1983-01-30 00:00:00	1983-04-30	1983-04-30 00:00:00	1983-04-30	38000177		0	0	90		0	0	0	172182	0	313782	1127433		
62055	1355	40213227	1995-03-17	1995-03-17 00:00:00	1995-03-17	1995-03-17 00:00:00	1995-03-17	581452		0	0	0		0	0	0	89789	0	113	40213227		
6708	565	19006318	1962-06-13	1962-06-13 00:00:00	1962-06-27	1962-06-27 00:00:00	1962-06-27	38000177		0	0	14		0	0	0	37424	0	105078	19006318		
213983	4691	40213160	1960-10-15	1960-10-15 00:00:00	1960-10-15	1960-10-15 00:00:00	1960-10-15	581452		0	0	0		0	0	0	312590	0	10	40213160		
152846	3364	40213296	2016-10-06	2016-10-06 00:00:00	2016-10-06	2016-10-06 00:00:00	2016-10-06	581452		0	0	0		0	0	0	223085	0	52	40213296		
160888	3540	40213160	1974-05-06	1974-05-06 00:00:00	1974-05-06	1974-05-06 00:00:00	1974-05-06	581452		0	0	0		0	0	0	235137	0	10	40213160		
5123	111	40213314	1978-04-07	1978-04-07 00:00:00	1978-04-07	1978-04-07 00:00:00	1978-04-07	581452		0	0	0		0	0	0	7389	0	49	40213314		
230998	5076	40213201	2005-02-01	2005-02-01 00:00:00	2005-02-01	2005-02-01 00:00:00	2005-02-01	581452		0	0	0		0	0	0	337394	0	33	40213201		
61039	5077	19074679	2018-06-20	2018-06-20 00:00:00	2019-01-16	2019-01-16 00:00:00	2019-01-16	38000177		0	0	210		0	0	0	337486	0	308971	19074679		
39292	3246	19059056	1984-06-27	1984-06-27 00:00:00	1984-08-26	1984-08-26 00:00:00	1984-08-26	38000177		0	0	60		0	0	0	215819	0	243670	19059056		
222587	4886	40213306	1989-08-21	1989-08-21 00:00:00	1989-08-21	1989-08-21 00:00:00	1989-08-21	581452		0	0	0		0	0	0	324885	0	43	40213306		
49824	4133	19128065	1990-07-27	1990-07-27 00:00:00	1991-07-22	1991-07-22 00:00:00	1991-07-22	38000177		0	0	360		0	0	0	274804	0	749882	19128065		
55012	4569	40229134	1999-02-02	1999-02-02 00:00:00	1999-02-16	1999-02-16 00:00:00	1999-02-16	38000177		0	0	14		0	0	0	304400	0	1043400	40229134		
187102	4109	40213306	1987-05-19	1987-05-19 00:00:00	1987-05-19	1987-05-19 00:00:00	1987-05-19	581452		0	0	0		0	0	0	\N	0	43	40213306		
50817	4223	1127433	1971-09-18	1971-09-18 00:00:00	1971-10-02	1971-10-02 00:00:00	1971-10-02	38000177		0	0	14		0	0	0	280413	0	313782	1127433		
172450	3790	40213306	1986-04-21	1986-04-21 00:00:00	1986-04-21	1986-04-21 00:00:00	1986-04-21	581452		0	0	0		0	0	0	252033	0	43	40213306		
223152	4898	40213296	1997-09-17	1997-09-17 00:00:00	1997-09-17	1997-09-17 00:00:00	1997-09-17	581452		0	0	0		0	0	0	325734	0	52	40213296		
223172	4898	40213198	2018-06-13	2018-06-13 00:00:00	2018-06-13	2018-06-13 00:00:00	2018-06-13	581452		0	0	0		0	0	0	325740	0	133	40213198		
9935	211	40213260	2019-01-10	2019-01-10 00:00:00	2019-01-10	2019-01-10 00:00:00	2019-01-10	581452		0	0	0		0	0	0	14404	0	121	40213260		
145878	3208	40213227	2010-01-22	2010-01-22 00:00:00	2010-01-22	2010-01-22 00:00:00	2010-01-22	581452		0	0	0		0	0	0	213282	0	113	40213227		
204692	4493	40213227	2013-07-30	2013-07-30 00:00:00	2013-07-30	2013-07-30 00:00:00	2013-07-30	581452		0	0	0		0	0	0	299184	0	113	40213227		
134153	2945	40213227	1996-07-23	1996-07-23 00:00:00	1996-07-23	1996-07-23 00:00:00	1996-07-23	581452		0	0	0		0	0	0	196493	0	113	40213227		
194257	4268	40213296	1998-05-11	1998-05-11 00:00:00	1998-05-11	1998-05-11 00:00:00	1998-05-11	581452		0	0	0		0	0	0	283295	0	52	40213296		
168629	3707	40213296	2010-09-13	2010-09-13 00:00:00	2010-09-13	2010-09-13 00:00:00	2010-09-13	581452		0	0	0		0	0	0	246428	0	52	40213296		
149952	3298	40213160	1971-11-21	1971-11-21 00:00:00	1971-11-21	1971-11-21 00:00:00	1971-11-21	581452		0	0	0		0	0	0	219149	0	10	40213160		
221168	4853	40213260	2012-05-09	2012-05-09 00:00:00	2012-05-09	2012-05-09 00:00:00	2012-05-09	581452		0	0	0		0	0	0	322877	0	121	40213260		
12796	1077	19133905	1996-02-05	1996-02-05 00:00:00	1996-02-13	1996-02-13 00:00:00	1996-02-13	38000177		0	0	8		0	0	0	70636	0	834102	19133905		
32925	719	40213227	2013-04-26	2013-04-26 00:00:00	2013-04-26	2013-04-26 00:00:00	2013-04-26	581452		0	0	0		0	0	0	47556	0	113	40213227		
22522	1850	19133905	1984-10-06	1984-10-06 00:00:00	1984-10-14	1984-10-14 00:00:00	1984-10-14	38000177		0	0	8		0	0	0	123755	0	834102	19133905		
19203	1586	19059056	1953-04-27	1953-04-27 00:00:00	1953-05-11	1953-05-11 00:00:00	1953-05-11	38000177		0	0	14		0	0	0	106432	0	243670	19059056		
13315	1116	19078461	1993-03-23	1993-03-23 00:00:00	1993-04-06	1993-04-06 00:00:00	1993-04-06	38000177		0	0	14		0	0	0	73508	0	310965	19078461		
110817	2435	40213296	2014-03-14	2014-03-14 00:00:00	2014-03-14	2014-03-14 00:00:00	2014-03-14	581452		0	0	0		0	0	0	161388	0	52	40213296		
141963	3119	40213227	1996-08-19	1996-08-19 00:00:00	1996-08-19	1996-08-19 00:00:00	1996-08-19	581452		0	0	0		0	0	0	207581	0	113	40213227		
5056	421	1124300	2001-04-28	2001-04-28 00:00:00	2001-04-28	2001-04-28 00:00:00	\N	38000177		0	0	0		0	0	0	27874	0	00781178901	45011828		
238149	5228	40213227	2017-05-25	2017-05-25 00:00:00	2017-05-25	2017-05-25 00:00:00	2017-05-25	581452		0	0	0		0	0	0	347849	0	113	40213227		
61863	5145	19059056	1958-06-26	1958-06-26 00:00:00	1958-07-10	1958-07-10 00:00:00	1958-07-10	38000177		0	0	14		0	0	0	342037	0	243670	19059056		
229478	5043	40213160	1974-03-22	1974-03-22 00:00:00	1974-03-22	1974-03-22 00:00:00	1974-03-22	581452		0	0	0		0	0	0	335140	0	10	40213160		
53843	4475	1124300	2013-09-30	2013-09-30 00:00:00	2013-09-30	2013-09-30 00:00:00	\N	38000177		0	0	0		0	0	0	297710	0	00781178901	45011828		
62952	1377	40213314	1981-02-10	1981-02-10 00:00:00	1981-02-10	1981-02-10 00:00:00	1981-02-10	581452		0	0	0		0	0	0	91261	0	49	40213314		
9888	828	19059056	1971-04-14	1971-04-14 00:00:00	1971-06-20	1971-06-20 00:00:00	1971-06-20	38000177		0	0	67		0	0	0	54863	0	243670	19059056		
102406	2244	40213160	1956-06-29	1956-06-29 00:00:00	1956-06-29	1956-06-29 00:00:00	1956-06-29	581452		0	0	0		0	0	0	149443	0	10	40213160		
69345	1517	40213227	1999-01-04	1999-01-04 00:00:00	1999-01-04	1999-01-04 00:00:00	1999-01-04	581452		0	0	0		0	0	0	101444	0	113	40213227		
137200	3011	40213296	2018-05-29	2018-05-29 00:00:00	2018-05-29	2018-05-29 00:00:00	2018-05-29	581452		0	0	0		0	0	0	200816	0	52	40213296		
20547	1691	1115171	2015-12-24	2015-12-24 00:00:00	2016-01-07	2016-01-07 00:00:00	2016-01-07	38000177		0	0	14		0	0	0	113271	0	849574	1115171		
11430	245	40213201	1983-05-22	1983-05-22 00:00:00	1983-05-22	1983-05-22 00:00:00	1983-05-22	581452		0	0	0		0	0	0	16381	0	33	40213201		
31065	2576	19128065	1993-11-04	1993-11-04 00:00:00	1994-10-30	1994-10-30 00:00:00	1994-10-30	38000177		0	0	360		0	0	0	170531	0	749882	19128065		
11186	931	1332419	2015-10-16	2015-10-16 00:00:00	2015-10-16	2015-10-16 00:00:00	\N	38000177		0	0	0		0	0	0	62003	0	197361	1332419		
11200	932	1127433	2017-05-25	2017-05-25 00:00:00	2017-08-23	2017-08-23 00:00:00	2017-08-23	38000177		0	0	90		0	0	0	62055	0	313782	1127433		
172695	3796	40213306	1990-05-22	1990-05-22 00:00:00	1990-05-22	1990-05-22 00:00:00	1990-05-22	581452		0	0	0		0	0	0	252403	0	43	40213306		
62833	5222	40169281	1999-01-14	1999-01-14 00:00:00	1999-01-14	1999-01-14 00:00:00	\N	38000177		0	0	0		0	0	0	347528	0	896209	40169281		
46975	3891	1713671	1984-06-13	1984-06-13 00:00:00	1984-06-20	1984-06-20 00:00:00	1984-06-20	38000177		0	0	7		0	0	0	258721	0	562251	1713671		
56364	4676	19073183	1981-11-19	1981-11-19 00:00:00	1981-12-03	1981-12-03 00:00:00	1981-12-03	38000177		0	0	14		0	0	0	311604	0	308182	19073183		
3747	311	1115171	2004-08-24	2004-08-24 00:00:00	2004-09-07	2004-09-07 00:00:00	2004-09-07	38000177		0	0	14		0	0	0	20654	0	849574	1115171		
848	18	40213160	1966-02-23	1966-02-23 00:00:00	1966-02-23	1966-02-23 00:00:00	1966-02-23	581452		0	0	0		0	0	0	1391	0	10	40213160		
104377	2289	40213160	1955-09-20	1955-09-20 00:00:00	1955-09-20	1955-09-20 00:00:00	1955-09-20	581452		0	0	0		0	0	0	152273	0	10	40213160		
15366	1282	1551192	1991-06-14	1991-06-14 00:00:00	1991-06-14	1991-06-14 00:00:00	1991-06-14	38000177		0	0	0		0	0	0	84709	0	312617	1551192		
205057	4500	40213160	1962-05-23	1962-05-23 00:00:00	1962-05-23	1962-05-23 00:00:00	1962-05-23	581452		0	0	0		0	0	0	299555	0	10	40213160		
53187	4418	40165015	2006-10-07	2006-10-07 00:00:00	2006-10-07	2006-10-07 00:00:00	\N	38000177		0	0	0		0	0	0	293793	0	861467	40165015		
131595	2892	40213296	2013-07-19	2013-07-19 00:00:00	2013-07-19	2013-07-19 00:00:00	2013-07-19	581452		0	0	0		0	0	0	192450	0	52	40213296		
39713	3285	1127078	1970-11-10	1970-11-10 00:00:00	1970-11-24	1970-11-24 00:00:00	1970-11-24	38000177		0	0	14		0	0	0	218178	0	282464	1127078		
31403	2603	40165015	1983-01-30	1983-01-30 00:00:00	1983-01-30	1983-01-30 00:00:00	\N	38000177		0	0	0		0	0	0	172182	0	861467	40165015		
62061	1356	40213160	1976-01-16	1976-01-16 00:00:00	1976-01-16	1976-01-16 00:00:00	1976-01-16	581452		0	0	0		0	0	0	89921	0	10	40213160		
6709	565	1127078	1962-06-13	1962-06-13 00:00:00	1962-06-27	1962-06-27 00:00:00	1962-06-27	38000177		0	0	14		0	0	0	37424	0	282464	1127078		
209129	4587	40213201	2001-07-14	2001-07-14 00:00:00	2001-07-14	2001-07-14 00:00:00	2001-07-14	581452		0	0	0		0	0	0	305626	0	33	40213201		
152857	3365	40213306	1986-09-19	1986-09-19 00:00:00	1986-09-19	1986-09-19 00:00:00	1986-09-19	581452		0	0	0		0	0	0	223226	0	43	40213306		
160893	3540	40213314	1978-01-02	1978-01-02 00:00:00	1978-01-02	1978-01-02 00:00:00	1978-01-02	581452		0	0	0		0	0	0	235140	0	49	40213314		
5125	111	40213160	1975-08-08	1975-08-08 00:00:00	1975-08-08	1975-08-08 00:00:00	1975-08-08	581452		0	0	0		0	0	0	7393	0	10	40213160		
17353	1438	19006318	1954-05-31	1954-05-31 00:00:00	1954-06-14	1954-06-14 00:00:00	1954-06-14	38000177		0	0	14		0	0	0	95811	0	105078	19006318		
61040	5077	1127433	2014-05-18	2014-05-18 00:00:00	2014-05-25	2014-05-25 00:00:00	2014-05-25	38000177		0	0	7		0	0	0	337447	0	313782	1127433		
39293	3246	1127433	1984-12-14	1984-12-14 00:00:00	1984-12-21	1984-12-21 00:00:00	1984-12-21	38000177		0	0	7		0	0	0	215804	0	313782	1127433		
222592	4886	40213160	1966-05-16	1966-05-16 00:00:00	1966-05-16	1966-05-16 00:00:00	1966-05-16	581452		0	0	0		0	0	0	324918	0	10	40213160		
49825	4134	19059056	1955-06-16	1955-06-16 00:00:00	1955-07-21	1955-07-21 00:00:00	1955-07-21	38000177		0	0	35		0	0	0	274818	0	243670	19059056		
55013	4569	1124300	2002-08-01	2002-08-01 00:00:00	2002-08-01	2002-08-01 00:00:00	\N	38000177		0	0	0		0	0	0	304391	0	00781178901	45011828		
234005	5142	40213227	2017-01-10	2017-01-10 00:00:00	2017-01-10	2017-01-10 00:00:00	2017-01-10	581452		0	0	0		0	0	0	341789	0	113	40213227		
50818	4223	1127433	2019-04-26	2019-04-26 00:00:00	2019-05-17	2019-05-17 00:00:00	2019-05-17	38000177		0	0	21		0	0	0	280367	0	313782	1127433		
172452	3790	40213227	2005-05-09	2005-05-09 00:00:00	2005-05-09	2005-05-09 00:00:00	2005-05-09	581452		0	0	0		0	0	0	252035	0	113	40213227		
223159	4898	40213227	2004-03-24	2004-03-24 00:00:00	2004-03-24	2004-03-24 00:00:00	2004-03-24	581452		0	0	0		0	0	0	325686	0	113	40213227		
223177	4898	40213160	1955-01-26	1955-01-26 00:00:00	1955-01-26	1955-01-26 00:00:00	1955-01-26	581452		0	0	0		0	0	0	325679	0	10	40213160		
9938	211	40213227	2008-12-11	2008-12-11 00:00:00	2008-12-11	2008-12-11 00:00:00	2008-12-11	581452		0	0	0		0	0	0	14402	0	113	40213227		
145880	3208	40213160	1968-04-19	1968-04-19 00:00:00	1968-04-19	1968-04-19 00:00:00	1968-04-19	581452		0	0	0		0	0	0	213223	0	10	40213160		
204694	4493	40213314	1983-08-30	1983-08-30 00:00:00	1983-08-30	1983-08-30 00:00:00	1983-08-30	581452		0	0	0		0	0	0	299157	0	49	40213314		
134158	2945	40213227	2006-09-19	2006-09-19 00:00:00	2006-09-19	2006-09-19 00:00:00	2006-09-19	581452		0	0	0		0	0	0	196505	0	113	40213227		
50944	1116	40213160	1966-08-19	1966-08-19 00:00:00	1966-08-19	1966-08-19 00:00:00	1966-08-19	581452		0	0	0		0	0	0	73515	0	10	40213160		
194272	4269	40213227	1999-12-15	1999-12-15 00:00:00	1999-12-15	1999-12-15 00:00:00	1999-12-15	581452		0	0	0		0	0	0	283347	0	113	40213227		
149954	3298	40213160	1972-04-23	1972-04-23 00:00:00	1972-04-23	1972-04-23 00:00:00	1972-04-23	581452		0	0	0		0	0	0	219127	0	10	40213160		
221172	4853	40213160	1967-04-19	1967-04-19 00:00:00	1967-04-19	1967-04-19 00:00:00	1967-04-19	581452		0	0	0		0	0	0	322917	0	10	40213160		
12797	1077	1713671	1977-07-13	1977-07-13 00:00:00	1977-07-27	1977-07-27 00:00:00	1977-07-27	38000177		0	0	14		0	0	0	70589	0	562251	1713671		
142693	3134	40213227	2003-01-23	2003-01-23 00:00:00	2003-01-23	2003-01-23 00:00:00	2003-01-23	581452		0	0	0		0	0	0	208550	0	113	40213227		
22523	1850	19133873	1969-05-14	1969-05-14 00:00:00	1969-05-24	1969-05-24 00:00:00	1969-05-24	38000177		0	0	10		0	0	0	123724	0	834061	19133873		
19204	1586	19059056	1967-04-26	1967-04-26 00:00:00	1967-05-10	1967-05-10 00:00:00	1967-05-10	38000177		0	0	14		0	0	0	106389	0	243670	19059056		
13316	1116	1713671	1966-05-17	1966-05-17 00:00:00	1966-05-24	1966-05-24 00:00:00	1966-05-24	38000177		0	0	7		0	0	0	73523	0	562251	1713671		
110818	2435	40213160	1973-02-16	1973-02-16 00:00:00	1973-02-16	1973-02-16 00:00:00	1973-02-16	581452		0	0	0		0	0	0	161414	0	10	40213160		
141964	3119	40213306	1996-08-19	1996-08-19 00:00:00	1996-08-19	1996-08-19 00:00:00	1996-08-19	581452		0	0	0		0	0	0	207581	0	43	40213306		
5057	421	1713671	2009-03-22	2009-03-22 00:00:00	2009-04-12	2009-04-12 00:00:00	2009-04-12	38000177		0	0	21		0	0	0	27892	0	562251	1713671		
238174	5229	40213306	1984-02-08	1984-02-08 00:00:00	1984-02-08	1984-02-08 00:00:00	1984-02-08	581452		0	0	0		0	0	0	347920	0	43	40213306		
61866	5146	1124300	1979-02-13	1979-02-13 00:00:00	1979-02-13	1979-02-13 00:00:00	\N	38000177		0	0	0		0	0	0	342155	0	00781178901	45011828		
240773	5285	40213201	2009-09-27	2009-09-27 00:00:00	2009-09-27	2009-09-27 00:00:00	2009-09-27	581452		0	0	0		0	0	0	351715	0	33	40213201		
53844	4475	1713671	2004-06-12	2004-06-12 00:00:00	2004-06-26	2004-06-26 00:00:00	2004-06-26	38000177		0	0	14		0	0	0	297725	0	562251	1713671		
62956	1377	40213227	2002-02-05	2002-02-05 00:00:00	2002-02-05	2002-02-05 00:00:00	2002-02-05	581452		0	0	0		0	0	0	91267	0	113	40213227		
9889	828	19078461	1999-10-21	1999-10-21 00:00:00	1999-11-04	1999-11-04 00:00:00	1999-11-04	38000177		0	0	14		0	0	0	54865	0	310965	19078461		
102407	2244	40213198	2018-10-19	2018-10-19 00:00:00	2018-10-19	2018-10-19 00:00:00	2018-10-19	581452		0	0	0		0	0	0	149432	0	133	40213198		
69367	1517	40213227	2019-04-29	2019-04-29 00:00:00	2019-04-29	2019-04-29 00:00:00	2019-04-29	581452		0	0	0		0	0	0	101406	0	113	40213227		
137203	3011	40213160	1979-06-19	1979-06-19 00:00:00	1979-06-19	1979-06-19 00:00:00	1979-06-19	581452		0	0	0		0	0	0	200806	0	10	40213160		
20548	1691	19078461	2014-12-08	2014-12-08 00:00:00	2014-12-29	2014-12-29 00:00:00	2014-12-29	38000177		0	0	21		0	0	0	113254	0	310965	19078461		
7546	162	40213227	2010-10-26	2010-10-26 00:00:00	2010-10-26	2010-10-26 00:00:00	2010-10-26	581452		0	0	0		0	0	0	11134	0	113	40213227		
31066	2576	19128065	1994-10-30	1994-10-30 00:00:00	1995-10-25	1995-10-25 00:00:00	1995-10-25	38000177		0	0	360		0	0	0	170532	0	749882	19128065		
11187	931	19075601	2015-10-16	2015-10-16 00:00:00	2015-10-16	2015-10-16 00:00:00	\N	38000177		0	0	0		0	0	0	62003	0	309362	19075601		
11201	932	1127078	1975-08-22	1975-08-22 00:00:00	1975-09-05	1975-09-05 00:00:00	1975-09-05	38000177		0	0	14		0	0	0	62027	0	282464	1127078		
109459	2402	40213227	2007-11-26	2007-11-26 00:00:00	2007-11-26	2007-11-26 00:00:00	2007-11-26	581452		0	0	0		0	0	0	159613	0	113	40213227		
62834	5222	1124300	1961-03-25	1961-03-25 00:00:00	1961-03-25	1961-03-25 00:00:00	\N	38000177		0	0	0		0	0	0	347443	0	00781178901	45011828		
46976	3891	1713671	1984-04-23	1984-04-23 00:00:00	1984-05-07	1984-05-07 00:00:00	1984-05-07	38000177		0	0	14		0	0	0	258720	0	562251	1713671		
56365	4676	19128022	1993-07-29	1993-07-29 00:00:00	1994-07-24	1994-07-24 00:00:00	1994-07-24	38000177		0	0	360		0	0	0	311605	0	749785	19128022		
3748	311	40229134	1993-11-10	1993-11-10 00:00:00	1993-11-17	1993-11-17 00:00:00	1993-11-17	38000177		0	0	7		0	0	0	20637	0	1043400	40229134		
849	18	40213160	1970-10-28	1970-10-28 00:00:00	1970-10-28	1970-10-28 00:00:00	1970-10-28	581452		0	0	0		0	0	0	1436	0	10	40213160		
154093	3392	40213296	2007-01-06	2007-01-06 00:00:00	2007-01-06	2007-01-06 00:00:00	2007-01-06	581452		0	0	0		0	0	0	224953	0	52	40213296		
15367	1282	1713671	1987-05-05	1987-05-05 00:00:00	1987-05-26	1987-05-26 00:00:00	1987-05-26	38000177		0	0	21		0	0	0	84753	0	562251	1713671		
205059	4500	40213160	1962-02-21	1962-02-21 00:00:00	1962-02-21	1962-02-21 00:00:00	1962-02-21	581452		0	0	0		0	0	0	299588	0	10	40213160		
53188	4418	1127433	1996-12-07	1996-12-07 00:00:00	1996-12-21	1996-12-21 00:00:00	1996-12-21	38000177		0	0	14		0	0	0	293704	0	313782	1127433		
131596	2892	40213160	1973-01-05	1973-01-05 00:00:00	1973-01-05	1973-01-05 00:00:00	1973-01-05	581452		0	0	0		0	0	0	192404	0	10	40213160		
39714	3285	1127433	1962-07-28	1962-07-28 00:00:00	1962-08-04	1962-08-04 00:00:00	1962-08-04	38000177		0	0	7		0	0	0	218218	0	313782	1127433		
31405	2603	19059056	1962-11-23	1962-11-23 00:00:00	1962-12-07	1962-12-07 00:00:00	1962-12-07	38000177		0	0	14		0	0	0	172236	0	243670	19059056		
62066	1356	40213296	2012-10-05	2012-10-05 00:00:00	2012-10-05	2012-10-05 00:00:00	2012-10-05	581452		0	0	0		0	0	0	89962	0	52	40213296		
6710	565	19133873	1974-01-13	1974-01-13 00:00:00	1974-01-25	1974-01-25 00:00:00	1974-01-25	38000177		0	0	12		0	0	0	37437	0	834061	19133873		
209152	4587	40213227	2006-07-29	2006-07-29 00:00:00	2006-07-29	2006-07-29 00:00:00	2006-07-29	581452		0	0	0		0	0	0	305628	0	113	40213227		
152859	3365	40213227	1995-09-29	1995-09-29 00:00:00	1995-09-29	1995-09-29 00:00:00	1995-09-29	581452		0	0	0		0	0	0	223221	0	113	40213227		
160896	3540	40213306	1994-10-31	1994-10-31 00:00:00	1994-10-31	1994-10-31 00:00:00	1994-10-31	581452		0	0	0		0	0	0	235119	0	43	40213306		
5126	111	40213314	1977-10-07	1977-10-07 00:00:00	1977-10-07	1977-10-07 00:00:00	1977-10-07	581452		0	0	0		0	0	0	7394	0	49	40213314		
17354	1438	19059056	1954-05-31	1954-05-31 00:00:00	1954-06-14	1954-06-14 00:00:00	1954-06-14	38000177		0	0	14		0	0	0	95811	0	243670	19059056		
61041	5077	19129655	1973-11-30	1973-11-30 00:00:00	1973-12-14	1973-12-14 00:00:00	1973-12-14	38000177		0	0	14		0	0	0	337450	0	789980	19129655		
134461	2951	40213227	2000-11-26	2000-11-26 00:00:00	2000-11-26	2000-11-26 00:00:00	2000-11-26	581452		0	0	0		0	0	0	197043	0	113	40213227		
222594	4886	40213227	1996-11-18	1996-11-18 00:00:00	1996-11-18	1996-11-18 00:00:00	1996-11-18	581452		0	0	0		0	0	0	324922	0	113	40213227		
49826	4134	1127433	1987-05-24	1987-05-24 00:00:00	1987-06-07	1987-06-07 00:00:00	1987-06-07	38000177		0	0	14		0	0	0	274863	0	313782	1127433		
55014	4569	1127433	1968-11-03	1968-11-03 00:00:00	1968-11-10	1968-11-10 00:00:00	1968-11-10	38000177		0	0	7		0	0	0	304351	0	313782	1127433		
234028	5143	40213227	1993-07-14	1993-07-14 00:00:00	1993-07-14	1993-07-14 00:00:00	1993-07-14	581452		0	0	0		0	0	0	341869	0	113	40213227		
50819	4223	1127433	1979-05-16	1979-05-16 00:00:00	1979-05-23	1979-05-23 00:00:00	1979-05-23	38000177		0	0	7		0	0	0	280426	0	313782	1127433		
172453	3790	40213296	2005-05-09	2005-05-09 00:00:00	2005-05-09	2005-05-09 00:00:00	2005-05-09	581452		0	0	0		0	0	0	252035	0	52	40213296		
223164	4898	40213160	1958-01-29	1958-01-29 00:00:00	1958-01-29	1958-01-29 00:00:00	1958-01-29	581452		0	0	0		0	0	0	325747	0	10	40213160		
223181	4898	40213160	1955-07-27	1955-07-27 00:00:00	1955-07-27	1955-07-27 00:00:00	1955-07-27	581452		0	0	0		0	0	0	325702	0	10	40213160		
9939	211	40213296	2008-12-11	2008-12-11 00:00:00	2008-12-11	2008-12-11 00:00:00	2008-12-11	581452		0	0	0		0	0	0	14402	0	52	40213296		
157163	3458	40213227	2001-10-19	2001-10-19 00:00:00	2001-10-19	2001-10-19 00:00:00	2001-10-19	581452		0	0	0		0	0	0	229477	0	113	40213227		
204704	4493	40213251	1984-05-29	1984-05-29 00:00:00	1984-05-29	1984-05-29 00:00:00	1984-05-29	581452		0	0	0		0	0	0	299158	0	21	40213251		
134161	2945	40213198	2011-01-25	2011-01-25 00:00:00	2011-01-25	2011-01-25 00:00:00	2011-01-25	581452		0	0	0		0	0	0	196483	0	133	40213198		
50946	1116	40213260	2016-07-29	2016-07-29 00:00:00	2016-07-29	2016-07-29 00:00:00	2016-07-29	581452		0	0	0		0	0	0	73548	0	121	40213260		
194274	4269	40213296	2008-05-07	2008-05-07 00:00:00	2008-05-07	2008-05-07 00:00:00	2008-05-07	581452		0	0	0		0	0	0	283337	0	52	40213296		
2549	57	40213296	2005-03-14	2005-03-14 00:00:00	2005-03-14	2005-03-14 00:00:00	2005-03-14	581452		0	0	0		0	0	0	3886	0	52	40213296		
221175	4853	40213296	2002-07-31	2002-07-31 00:00:00	2002-07-31	2002-07-31 00:00:00	2002-07-31	581452		0	0	0		0	0	0	322911	0	52	40213296		
12798	1077	1127433	1958-11-18	1958-11-18 00:00:00	1958-11-25	1958-11-25 00:00:00	1958-11-25	38000177		0	0	7		0	0	0	70585	0	313782	1127433		
142697	3134	40213227	1992-11-26	1992-11-26 00:00:00	1992-11-26	1992-11-26 00:00:00	1992-11-26	581452		0	0	0		0	0	0	208614	0	113	40213227		
22524	1850	40229134	1979-10-05	1979-10-05 00:00:00	1979-10-19	1979-10-19 00:00:00	1979-10-19	38000177		0	0	14		0	0	0	123754	0	1043400	40229134		
19205	1586	19075601	1997-10-05	1997-10-05 00:00:00	1997-10-05	1997-10-05 00:00:00	\N	38000177		0	0	0		0	0	0	106416	0	309362	19075601		
13317	1116	19133873	1972-12-04	1972-12-04 00:00:00	1972-12-16	1972-12-16 00:00:00	1972-12-16	38000177		0	0	12		0	0	0	73549	0	834061	19133873		
110823	2435	40213160	1973-04-20	1973-04-20 00:00:00	1973-04-20	1973-04-20 00:00:00	1973-04-20	581452		0	0	0		0	0	0	161424	0	10	40213160		
141965	3119	40213227	2005-08-29	2005-08-29 00:00:00	2005-08-29	2005-08-29 00:00:00	2005-08-29	581452		0	0	0		0	0	0	207556	0	113	40213227		
5058	422	1127433	1976-12-08	1976-12-08 00:00:00	1976-12-22	1976-12-22 00:00:00	1976-12-22	38000177		0	0	14		0	0	0	27951	0	313782	1127433		
238181	5229	40213227	1993-02-17	1993-02-17 00:00:00	1993-02-17	1993-02-17 00:00:00	1993-02-17	581452		0	0	0		0	0	0	347933	0	113	40213227		
95406	2091	40213160	1969-07-19	1969-07-19 00:00:00	1969-07-19	1969-07-19 00:00:00	1969-07-19	581452		0	0	0		0	0	0	139449	0	10	40213160		
240782	5285	40213227	2014-09-07	2014-09-07 00:00:00	2014-09-07	2014-09-07 00:00:00	2014-09-07	581452		0	0	0		0	0	0	351717	0	113	40213227		
53845	4475	19078461	2008-05-14	2008-05-14 00:00:00	2008-06-04	2008-06-04 00:00:00	2008-06-04	38000177		0	0	21		0	0	0	297717	0	310965	19078461		
62957	1377	40213306	2002-02-05	2002-02-05 00:00:00	2002-02-05	2002-02-05 00:00:00	2002-02-05	581452		0	0	0		0	0	0	91267	0	43	40213306		
9890	828	1118084	1992-11-29	1992-11-29 00:00:00	1992-11-29	1992-11-29 00:00:00	\N	38000177		0	0	0		0	0	0	54821	0	00025152531	44923712		
102423	2244	40213296	1997-08-08	1997-08-08 00:00:00	1997-08-08	1997-08-08 00:00:00	1997-08-08	581452		0	0	0		0	0	0	149439	0	52	40213296		
144270	3172	40213314	1977-06-30	1977-06-30 00:00:00	1977-06-30	1977-06-30 00:00:00	1977-06-30	581452		0	0	0		0	0	0	210839	0	49	40213314		
7292	158	40213227	2008-05-17	2008-05-17 00:00:00	2008-05-17	2008-05-17 00:00:00	2008-05-17	581452		0	0	0		0	0	0	10777	0	113	40213227		
20549	1691	1713671	1957-06-14	1957-06-14 00:00:00	1957-06-21	1957-06-21 00:00:00	1957-06-21	38000177		0	0	7		0	0	0	113257	0	562251	1713671		
7559	162	40213227	2000-08-29	2000-08-29 00:00:00	2000-08-29	2000-08-29 00:00:00	2000-08-29	581452		0	0	0		0	0	0	11169	0	113	40213227		
31067	2576	42902245	2000-09-28	2000-09-28 00:00:00	2001-09-23	2001-09-23 00:00:00	2001-09-23	38000177		0	0	360		0	0	0	170554	0	1359133	42902245		
11188	931	19126352	2015-10-16	2015-10-16 00:00:00	2015-10-16	2015-10-16 00:00:00	\N	38000177		0	0	0		0	0	0	62003	0	705129	19126352		
11202	932	19059056	1986-04-10	1986-04-10 00:00:00	1986-05-08	1986-05-08 00:00:00	1986-05-08	38000177		0	0	28		0	0	0	62054	0	243670	19059056		
109461	2402	40213314	1977-11-21	1977-11-21 00:00:00	1977-11-21	1977-11-21 00:00:00	1977-11-21	581452		0	0	0		0	0	0	159642	0	49	40213314		
62835	5222	1127433	1947-12-21	1947-12-21 00:00:00	1948-01-04	1948-01-04 00:00:00	1948-01-04	38000177		0	0	14		0	0	0	347408	0	313782	1127433		
46977	3891	40232448	1983-11-05	1983-11-05 00:00:00	1983-11-05	1983-11-05 00:00:00	\N	38000177		0	0	0		0	0	0	258719	0	1049630	40232448		
56366	4676	19128022	1994-07-24	1994-07-24 00:00:00	1995-07-19	1995-07-19 00:00:00	1995-07-19	38000177		0	0	360		0	0	0	311606	0	749785	19128022		
3749	311	1127078	1987-09-23	1987-09-23 00:00:00	1987-12-22	1987-12-22 00:00:00	1987-12-22	38000177		0	0	90		0	0	0	20651	0	282464	1127078		
853	19	40213198	2014-04-27	2014-04-27 00:00:00	2014-04-27	2014-04-27 00:00:00	2014-04-27	581452		0	0	0		0	0	0	1480	0	133	40213198		
154095	3392	40213160	1967-04-08	1967-04-08 00:00:00	1967-04-08	1967-04-08 00:00:00	1967-04-08	581452		0	0	0		0	0	0	224936	0	10	40213160		
15368	1283	1127078	1967-01-01	1967-01-01 00:00:00	1967-01-15	1967-01-15 00:00:00	1967-01-15	38000177		0	0	14		0	0	0	84821	0	282464	1127078		
27462	598	40213227	2006-05-26	2006-05-26 00:00:00	2006-05-26	2006-05-26 00:00:00	2006-05-26	581452		0	0	0		0	0	0	39490	0	113	40213227		
3419	283	19133873	1985-01-23	1985-01-23 00:00:00	1985-02-02	1985-02-02 00:00:00	1985-02-02	38000177		0	0	10		0	0	0	18835	0	834061	19133873		
131599	2892	40213160	1973-06-08	1973-06-08 00:00:00	1973-06-08	1973-06-08 00:00:00	1973-06-08	581452		0	0	0		0	0	0	192405	0	10	40213160		
39715	3285	19133905	1978-11-13	1978-11-13 00:00:00	1978-11-22	1978-11-22 00:00:00	1978-11-22	38000177		0	0	9		0	0	0	218211	0	834102	19133905		
31406	2603	19129655	1962-11-23	1962-11-23 00:00:00	1962-12-07	1962-12-07 00:00:00	1962-12-07	38000177		0	0	14		0	0	0	172236	0	789980	19129655		
62068	1356	40213227	2012-10-05	2012-10-05 00:00:00	2012-10-05	2012-10-05 00:00:00	2012-10-05	581452		0	0	0		0	0	0	89962	0	113	40213227		
118902	2615	40213227	2019-06-23	2019-06-23 00:00:00	2019-06-23	2019-06-23 00:00:00	2019-06-23	581452		0	0	0		0	0	0	172881	0	113	40213227		
84278	1844	40213260	2009-04-07	2009-04-07 00:00:00	2009-04-07	2009-04-07 00:00:00	2009-04-07	581452		0	0	0		0	0	0	123148	0	121	40213260		
152860	3365	40213160	1965-03-26	1965-03-26 00:00:00	1965-03-26	1965-03-26 00:00:00	1965-03-26	581452		0	0	0		0	0	0	223215	0	10	40213160		
160897	3540	40213314	1977-01-03	1977-01-03 00:00:00	1977-01-03	1977-01-03 00:00:00	1977-01-03	581452		0	0	0		0	0	0	235128	0	49	40213314		
5127	111	40213314	1977-04-08	1977-04-08 00:00:00	1977-04-08	1977-04-08 00:00:00	1977-04-08	581452		0	0	0		0	0	0	7357	0	49	40213314		
17355	1438	1127433	2017-04-29	2017-04-29 00:00:00	2017-05-13	2017-05-13 00:00:00	2017-05-13	38000177		0	0	14		0	0	0	95806	0	313782	1127433		
61042	5077	1127078	1973-11-30	1973-11-30 00:00:00	1973-12-14	1973-12-14 00:00:00	1973-12-14	38000177		0	0	14		0	0	0	337450	0	282464	1127078		
134462	2951	40213296	2000-11-26	2000-11-26 00:00:00	2000-11-26	2000-11-26 00:00:00	2000-11-26	581452		0	0	0		0	0	0	197043	0	52	40213296		
222599	4886	40213296	2008-11-17	2008-11-17 00:00:00	2008-11-17	2008-11-17 00:00:00	2008-11-17	581452		0	0	0		0	0	0	324927	0	52	40213296		
49827	4134	1127433	2017-06-13	2017-06-13 00:00:00	2017-06-20	2017-06-20 00:00:00	2017-06-20	38000177		0	0	7		0	0	0	274864	0	313782	1127433		
55015	4569	1713671	1971-01-14	1971-01-14 00:00:00	1971-01-21	1971-01-21 00:00:00	1971-01-21	38000177		0	0	7		0	0	0	304398	0	562251	1713671		
234029	5143	40213160	1959-03-18	1959-03-18 00:00:00	1959-03-18	1959-03-18 00:00:00	1959-03-18	581452		0	0	0		0	0	0	341819	0	10	40213160		
50820	4223	19129655	1962-11-01	1962-11-01 00:00:00	1962-11-15	1962-11-15 00:00:00	1962-11-15	38000177		0	0	14		0	0	0	280385	0	789980	19129655		
227852	5002	40213160	1976-07-16	1976-07-16 00:00:00	1976-07-16	1976-07-16 00:00:00	1976-07-16	581452		0	0	0		0	0	0	332720	0	10	40213160		
223167	4898	40213160	1956-01-25	1956-01-25 00:00:00	1956-01-25	1956-01-25 00:00:00	1956-01-25	581452		0	0	0		0	0	0	325728	0	10	40213160		
223200	4899	40213227	1992-10-06	1992-10-06 00:00:00	1992-10-06	1992-10-06 00:00:00	1992-10-06	581452		0	0	0		0	0	0	325860	0	113	40213227		
9941	211	40213160	1968-01-18	1968-01-18 00:00:00	1968-01-18	1968-01-18 00:00:00	1968-01-18	581452		0	0	0		0	0	0	14377	0	10	40213160		
157165	3458	40213306	2001-10-19	2001-10-19 00:00:00	2001-10-19	2001-10-19 00:00:00	2001-10-19	581452		0	0	0		0	0	0	229477	0	43	40213306		
227036	4986	40213198	2015-07-19	2015-07-19 00:00:00	2015-07-19	2015-07-19 00:00:00	2015-07-19	581452		0	0	0		0	0	0	331674	0	133	40213198		
134184	2945	40213201	2012-01-31	2012-01-31 00:00:00	2012-01-31	2012-01-31 00:00:00	2012-01-31	581452		0	0	0		0	0	0	196519	0	33	40213201		
50950	1116	40213227	1997-02-21	1997-02-21 00:00:00	1997-02-21	1997-02-21 00:00:00	1997-02-21	581452		0	0	0		0	0	0	73559	0	113	40213227		
194285	4269	40213227	2010-05-12	2010-05-12 00:00:00	2010-05-12	2010-05-12 00:00:00	2010-05-12	581452		0	0	0		0	0	0	283349	0	113	40213227		
2553	57	40213306	1982-01-11	1982-01-11 00:00:00	1982-01-11	1982-01-11 00:00:00	1982-01-11	581452		0	0	0		0	0	0	3825	0	43	40213306		
221180	4853	40213160	1962-08-15	1962-08-15 00:00:00	1962-08-15	1962-08-15 00:00:00	1962-08-15	581452		0	0	0		0	0	0	322904	0	10	40213160		
12799	1077	1713671	1999-11-26	1999-11-26 00:00:00	1999-12-10	1999-12-10 00:00:00	1999-12-10	38000177		0	0	14		0	0	0	70595	0	562251	1713671		
142710	3135	40213227	2014-06-12	2014-06-12 00:00:00	2014-06-12	2014-06-12 00:00:00	2014-06-12	581452		0	0	0		0	0	0	208664	0	113	40213227		
22525	1850	19059056	1962-05-17	1962-05-17 00:00:00	1962-05-31	1962-05-31 00:00:00	1962-05-31	38000177		0	0	14		0	0	0	123770	0	243670	19059056		
19206	1586	1127433	1954-10-20	1954-10-20 00:00:00	1954-11-03	1954-11-03 00:00:00	1954-11-03	38000177		0	0	14		0	0	0	106449	0	313782	1127433		
13318	1117	1127433	1982-05-16	1982-05-16 00:00:00	1982-06-13	1982-06-13 00:00:00	1982-06-13	38000177		0	0	28		0	0	0	73618	0	313782	1127433		
110837	2435	40213314	1977-10-21	1977-10-21 00:00:00	1977-10-21	1977-10-21 00:00:00	1977-10-21	581452		0	0	0		0	0	0	161428	0	49	40213314		
141969	3119	40213314	1977-11-20	1977-11-20 00:00:00	1977-11-20	1977-11-20 00:00:00	1977-11-20	581452		0	0	0		0	0	0	207544	0	49	40213314		
5059	422	920300	1984-03-18	1984-03-18 00:00:00	1984-03-25	1984-03-25 00:00:00	1984-03-25	38000177		0	0	7		0	0	0	27925	0	311989	920300		
238191	5229	40213160	1962-08-15	1962-08-15 00:00:00	1962-08-15	1962-08-15 00:00:00	1962-08-15	581452		0	0	0		0	0	0	347914	0	10	40213160		
106686	2339	40213306	1995-03-21	1995-03-21 00:00:00	1995-03-21	1995-03-21 00:00:00	1995-03-21	581452		0	0	0		0	0	0	155673	0	43	40213306		
240786	5285	40213227	2004-02-08	2004-02-08 00:00:00	2004-02-08	2004-02-08 00:00:00	2004-02-08	581452		0	0	0		0	0	0	351644	0	113	40213227		
53846	4475	1127433	2012-09-10	2012-09-10 00:00:00	2012-09-17	2012-09-17 00:00:00	2012-09-17	38000177		0	0	7		0	0	0	297706	0	313782	1127433		
62958	1377	40213160	1980-05-13	1980-05-13 00:00:00	1980-05-13	1980-05-13 00:00:00	1980-05-13	581452		0	0	0		0	0	0	91260	0	10	40213160		
9891	829	19128022	1989-06-07	1989-06-07 00:00:00	1990-06-02	1990-06-02 00:00:00	1990-06-02	38000177		0	0	360		0	0	0	54933	0	749785	19128022		
102426	2244	40213227	2004-07-30	2004-07-30 00:00:00	2004-07-30	2004-07-30 00:00:00	2004-07-30	581452		0	0	0		0	0	0	149440	0	113	40213227		
144271	3172	40213160	1977-06-30	1977-06-30 00:00:00	1977-06-30	1977-06-30 00:00:00	1977-06-30	581452		0	0	0		0	0	0	210839	0	10	40213160		
23888	518	40213296	2010-07-06	2010-07-06 00:00:00	2010-07-06	2010-07-06 00:00:00	2010-07-06	581452		0	0	0		0	0	0	34626	0	52	40213296		
20551	1691	19059056	1950-01-30	1950-01-30 00:00:00	1950-02-13	1950-02-13 00:00:00	1950-02-13	38000177		0	0	14		0	0	0	113263	0	243670	19059056		
7579	163	40213306	1988-08-30	1988-08-30 00:00:00	1988-08-30	1988-08-30 00:00:00	1988-08-30	581452		0	0	0		0	0	0	11227	0	43	40213306		
31068	2576	19128022	2001-09-23	2001-09-23 00:00:00	2002-09-18	2002-09-18 00:00:00	2002-09-18	38000177		0	0	360		0	0	0	170555	0	749785	19128022		
11189	931	1118084	2000-03-25	2000-03-25 00:00:00	2000-03-25	2000-03-25 00:00:00	\N	38000177		0	0	0		0	0	0	61980	0	00025152531	44923712		
11203	932	1118084	2002-07-06	2002-07-06 00:00:00	2002-07-06	2002-07-06 00:00:00	\N	38000177		0	0	0		0	0	0	62037	0	00025152531	44923712		
109468	2402	40213227	1998-02-23	1998-02-23 00:00:00	1998-02-23	1998-02-23 00:00:00	1998-02-23	581452		0	0	0		0	0	0	\N	0	113	40213227		
62836	5222	19059056	1920-02-23	1920-02-23 00:00:00	1920-03-08	1920-03-08 00:00:00	1920-03-08	38000177		0	0	14		0	0	0	347432	0	243670	19059056		
46978	3891	1713671	1998-08-09	1998-08-09 00:00:00	1998-08-30	1998-08-30 00:00:00	1998-08-30	38000177		0	0	21		0	0	0	258674	0	562251	1713671		
56367	4676	1118084	2018-09-11	2018-09-11 00:00:00	2018-09-11	2018-09-11 00:00:00	\N	38000177		0	0	0		0	0	0	311636	0	00025152531	44923712		
3750	312	1118084	2017-03-28	2017-03-28 00:00:00	2017-03-28	2017-03-28 00:00:00	\N	38000177		0	0	0		0	0	0	20700	0	00025152531	44923712		
860	19	40213227	2000-02-06	2000-02-06 00:00:00	2000-02-06	2000-02-06 00:00:00	2000-02-06	581452		0	0	0		0	0	0	1469	0	113	40213227		
154096	3392	40213160	1967-06-10	1967-06-10 00:00:00	1967-06-10	1967-06-10 00:00:00	1967-06-10	581452		0	0	0		0	0	0	224980	0	10	40213160		
15370	1283	35605482	1972-04-22	1972-04-22 00:00:00	1972-04-22	1972-04-22 00:00:00	1972-04-22	38000177		0	0	0		0	0	0	84823	0	1740467	35605482		
27463	598	40213314	1978-02-24	1978-02-24 00:00:00	1978-02-24	1978-02-24 00:00:00	1978-02-24	581452		0	0	0		0	0	0	39515	0	49	40213314		
3420	283	1127433	1993-05-27	1993-05-27 00:00:00	1993-06-10	1993-06-10 00:00:00	1993-06-10	38000177		0	0	14		0	0	0	18826	0	313782	1127433		
131603	2892	40213227	2005-07-08	2005-07-08 00:00:00	2005-07-08	2005-07-08 00:00:00	2005-07-08	581452		0	0	0		0	0	0	192441	0	113	40213227		
39716	3285	1127078	1962-06-27	1962-06-27 00:00:00	1962-07-11	1962-07-11 00:00:00	1962-07-11	38000177		0	0	14		0	0	0	218176	0	282464	1127078		
31407	2603	1713671	1961-05-29	1961-05-29 00:00:00	1961-06-19	1961-06-19 00:00:00	1961-06-19	38000177		0	0	21		0	0	0	172166	0	562251	1713671		
197883	4348	40213160	1986-04-09	1986-04-09 00:00:00	1986-04-09	1986-04-09 00:00:00	1986-04-09	581452		0	0	0		0	0	0	288363	0	10	40213160		
118908	2615	40213201	2014-05-25	2014-05-25 00:00:00	2014-05-25	2014-05-25 00:00:00	2014-05-25	581452		0	0	0		0	0	0	172893	0	33	40213201		
84286	1844	40213227	2010-06-22	2010-06-22 00:00:00	2010-06-22	2010-06-22 00:00:00	2010-06-22	581452		0	0	0		0	0	0	123202	0	113	40213227		
178906	3934	40213227	2000-01-19	2000-01-19 00:00:00	2000-01-19	2000-01-19 00:00:00	2000-01-19	581452		0	0	0		0	0	0	261462	0	113	40213227		
160899	3540	40213314	1977-07-04	1977-07-04 00:00:00	1977-07-04	1977-07-04 00:00:00	1977-07-04	581452		0	0	0		0	0	0	235157	0	49	40213314		
5131	111	40213227	2006-07-14	2006-07-14 00:00:00	2006-07-14	2006-07-14 00:00:00	2006-07-14	581452		0	0	0		0	0	0	7402	0	113	40213227		
17356	1438	1127433	1965-09-07	1965-09-07 00:00:00	1965-09-14	1965-09-14 00:00:00	1965-09-14	38000177		0	0	7		0	0	0	95779	0	313782	1127433		
61043	5077	40229134	1971-02-16	1971-02-16 00:00:00	1971-03-02	1971-03-02 00:00:00	1971-03-02	38000177		0	0	14		0	0	0	337448	0	1043400	40229134		
134465	2951	40213296	1998-11-22	1998-11-22 00:00:00	1998-11-22	1998-11-22 00:00:00	1998-11-22	581452		0	0	0		0	0	0	197068	0	52	40213296		
222601	4886	40213306	1989-08-28	1989-08-28 00:00:00	1989-08-28	1989-08-28 00:00:00	1989-08-28	581452		0	0	0		0	0	0	\N	0	43	40213306		
49828	4134	1127433	1972-01-06	1972-01-06 00:00:00	1972-01-13	1972-01-13 00:00:00	1972-01-13	38000177		0	0	7		0	0	0	274844	0	313782	1127433		
55016	4569	1127433	1963-04-19	1963-04-19 00:00:00	1963-04-26	1963-04-26 00:00:00	1963-04-26	38000177		0	0	7		0	0	0	304369	0	313782	1127433		
234035	5143	40213306	1982-03-10	1982-03-10 00:00:00	1982-03-10	1982-03-10 00:00:00	1982-03-10	581452		0	0	0		0	0	0	\N	0	43	40213306		
50821	4223	1127078	1962-11-01	1962-11-01 00:00:00	1962-11-15	1962-11-15 00:00:00	1962-11-15	38000177		0	0	14		0	0	0	280385	0	282464	1127078		
227855	5002	40213227	2018-04-20	2018-04-20 00:00:00	2018-04-20	2018-04-20 00:00:00	2018-04-20	581452		0	0	0		0	0	0	332700	0	113	40213227		
213292	4677	40213227	2009-02-06	2009-02-06 00:00:00	2009-02-06	2009-02-06 00:00:00	2009-02-06	581452		0	0	0		0	0	0	311684	0	113	40213227		
223212	4899	40213201	1986-09-02	1986-09-02 00:00:00	1986-09-02	1986-09-02 00:00:00	1986-09-02	581452		0	0	0		0	0	0	325848	0	33	40213201		
9943	211	40213160	1968-06-20	1968-06-20 00:00:00	1968-06-20	1968-06-20 00:00:00	1968-06-20	581452		0	0	0		0	0	0	14378	0	10	40213160		
206645	4534	40213227	2005-03-02	2005-03-02 00:00:00	2005-03-02	2005-03-02 00:00:00	2005-03-02	581452		0	0	0		0	0	0	302032	0	113	40213227		
227039	4986	40213160	1955-04-03	1955-04-03 00:00:00	1955-04-03	1955-04-03 00:00:00	1955-04-03	581452		0	0	0		0	0	0	331644	0	10	40213160		
126251	2777	40213227	1994-07-22	1994-07-22 00:00:00	1994-07-22	1994-07-22 00:00:00	1994-07-22	581452		0	0	0		0	0	0	183891	0	113	40213227		
50951	1116	40213296	2008-09-12	2008-09-12 00:00:00	2008-09-12	2008-09-12 00:00:00	2008-09-12	581452		0	0	0		0	0	0	73539	0	52	40213296		
194286	4269	40213296	2010-05-12	2010-05-12 00:00:00	2010-05-12	2010-05-12 00:00:00	2010-05-12	581452		0	0	0		0	0	0	283349	0	52	40213296		
2555	57	40213160	1962-02-26	1962-02-26 00:00:00	1962-02-26	1962-02-26 00:00:00	1962-02-26	581452		0	0	0		0	0	0	3854	0	10	40213160		
221184	4853	40213160	1963-01-16	1963-01-16 00:00:00	1963-01-16	1963-01-16 00:00:00	1963-01-16	581452		0	0	0		0	0	0	322931	0	10	40213160		
12800	1077	19059056	1963-10-16	1963-10-16 00:00:00	1964-01-14	1964-01-14 00:00:00	1964-01-14	38000177		0	0	90		0	0	0	70602	0	243670	19059056		
142711	3135	40213260	2014-06-12	2014-06-12 00:00:00	2014-06-12	2014-06-12 00:00:00	2014-06-12	581452		0	0	0		0	0	0	208664	0	121	40213260		
22526	1850	19129655	1962-05-17	1962-05-17 00:00:00	1962-05-31	1962-05-31 00:00:00	1962-05-31	38000177		0	0	14		0	0	0	123770	0	789980	19129655		
19207	1586	40173590	1999-10-17	1999-10-17 00:00:00	1999-10-17	1999-10-17 00:00:00	\N	38000177		0	0	0		0	0	0	106378	0	904419	40173590		
13319	1117	19059056	1943-10-03	1943-10-03 00:00:00	1943-10-24	1943-10-24 00:00:00	1943-10-24	38000177		0	0	21		0	0	0	73616	0	243670	19059056		
191888	4217	40213160	1959-04-22	1959-04-22 00:00:00	1959-04-22	1959-04-22 00:00:00	1959-04-22	581452		0	0	0		0	0	0	280010	0	10	40213160		
141974	3119	40213314	1978-05-22	1978-05-22 00:00:00	1978-05-22	1978-05-22 00:00:00	1978-05-22	581452		0	0	0		0	0	0	207570	0	49	40213314		
5060	422	40236824	1984-03-18	1984-03-18 00:00:00	1984-04-01	1984-04-01 00:00:00	1984-04-01	38000177		0	0	14		0	0	0	27925	0	1094107	40236824		
67891	1486	40213227	2006-09-24	2006-09-24 00:00:00	2006-09-24	2006-09-24 00:00:00	2006-09-24	581452		0	0	0		0	0	0	99068	0	113	40213227		
106689	2339	40213227	2004-03-30	2004-03-30 00:00:00	2004-03-30	2004-03-30 00:00:00	2004-03-30	581452		0	0	0		0	0	0	155627	0	113	40213227		
61323	5101	1713671	1979-11-29	1979-11-29 00:00:00	1979-12-06	1979-12-06 00:00:00	1979-12-06	38000177		0	0	7		0	0	0	338970	0	562251	1713671		
53848	4476	19128065	1976-02-15	1976-02-15 00:00:00	1977-02-09	1977-02-09 00:00:00	1977-02-09	38000177		0	0	360		0	0	0	297858	0	749882	19128065		
62959	1377	40213314	1980-05-13	1980-05-13 00:00:00	1980-05-13	1980-05-13 00:00:00	1980-05-13	581452		0	0	0		0	0	0	91260	0	49	40213314		
9892	829	19133873	1973-12-16	1973-12-16 00:00:00	1973-12-23	1973-12-23 00:00:00	1973-12-23	38000177		0	0	7		0	0	0	54877	0	834061	19133873		
188526	4139	40213160	1971-02-12	1971-02-12 00:00:00	1971-02-12	1971-02-12 00:00:00	1971-02-12	581452		0	0	0		0	0	0	275161	0	10	40213160		
144274	3172	40213314	1977-04-28	1977-04-28 00:00:00	1977-04-28	1977-04-28 00:00:00	1977-04-28	581452		0	0	0		0	0	0	210825	0	49	40213314		
145299	3195	40213160	1955-10-17	1955-10-17 00:00:00	1955-10-17	1955-10-17 00:00:00	1955-10-17	581452		0	0	0		0	0	0	212523	0	10	40213160		
20552	1691	19006318	1950-01-30	1950-01-30 00:00:00	1950-02-13	1950-02-13 00:00:00	1950-02-13	38000177		0	0	14		0	0	0	113263	0	105078	19006318		
7585	163	40213296	2006-07-04	2006-07-04 00:00:00	2006-07-04	2006-07-04 00:00:00	2006-07-04	581452		0	0	0		0	0	0	11239	0	52	40213296		
31069	2576	19073183	1981-12-11	1981-12-11 00:00:00	1981-12-25	1981-12-25 00:00:00	1981-12-25	38000177		0	0	14		0	0	0	170542	0	308182	19073183		
11190	931	19006318	1963-01-04	1963-01-04 00:00:00	1963-01-18	1963-01-18 00:00:00	1963-01-18	38000177		0	0	14		0	0	0	61931	0	105078	19006318		
11204	933	19059056	1983-10-11	1983-10-11 00:00:00	1983-11-01	1983-11-01 00:00:00	1983-11-01	38000177		0	0	21		0	0	0	62058	0	243670	19059056		
109469	2402	40213306	1998-02-23	1998-02-23 00:00:00	1998-02-23	1998-02-23 00:00:00	1998-02-23	581452		0	0	0		0	0	0	\N	0	43	40213306		
62837	5222	19059056	1937-06-18	1937-06-18 00:00:00	1937-07-09	1937-07-09 00:00:00	1937-07-09	38000177		0	0	21		0	0	0	347505	0	243670	19059056		
57437	4764	1127433	1998-07-17	1998-07-17 00:00:00	1998-07-31	1998-07-31 00:00:00	1998-07-31	38000177		0	0	14		0	0	0	317484	0	313782	1127433		
56368	4676	19128022	1995-07-19	1995-07-19 00:00:00	1996-07-13	1996-07-13 00:00:00	1996-07-13	38000177		0	0	360		0	0	0	311607	0	749785	19128022		
52375	1146	40213160	1963-12-26	1963-12-26 00:00:00	1963-12-26	1963-12-26 00:00:00	1963-12-26	581452		0	0	0		0	0	0	75680	0	10	40213160		
179654	3949	40213160	1969-06-23	1969-06-23 00:00:00	1969-06-23	1969-06-23 00:00:00	1969-06-23	581452		0	0	0		0	0	0	262498	0	10	40213160		
154101	3392	40213160	1971-11-13	1971-11-13 00:00:00	1971-11-13	1971-11-13 00:00:00	1971-11-13	581452		0	0	0		0	0	0	224964	0	10	40213160		
15371	1283	35605482	1972-04-22	1972-04-22 00:00:00	1972-04-22	1972-04-22 00:00:00	1972-04-22	38000177		0	0	0		0	0	0	84823	0	1740467	35605482		
27466	598	40213160	1975-05-30	1975-05-30 00:00:00	1975-05-30	1975-05-30 00:00:00	1975-05-30	581452		0	0	0		0	0	0	39506	0	10	40213160		
3421	283	19019979	1986-12-29	1986-12-29 00:00:00	1987-01-19	1987-01-19 00:00:00	1987-01-19	38000177		0	0	21		0	0	0	18879	0	198405	19019979		
148043	3254	40213227	2014-12-07	2014-12-07 00:00:00	2014-12-07	2014-12-07 00:00:00	2014-12-07	581452		0	0	0		0	0	0	216428	0	113	40213227		
39717	3285	19006318	1962-06-27	1962-06-27 00:00:00	1962-07-11	1962-07-11 00:00:00	1962-07-11	38000177		0	0	14		0	0	0	218176	0	105078	19006318		
31408	2603	19133873	1965-09-16	1965-09-16 00:00:00	1965-09-28	1965-09-28 00:00:00	1965-09-28	38000177		0	0	12		0	0	0	172168	0	834061	19133873		
197885	4348	40213251	1986-04-09	1986-04-09 00:00:00	1986-04-09	1986-04-09 00:00:00	1986-04-09	581452		0	0	0		0	0	0	288363	0	21	40213251		
118929	2616	40213227	2003-04-08	2003-04-08 00:00:00	2003-04-08	2003-04-08 00:00:00	2003-04-08	581452		0	0	0		0	0	0	172948	0	113	40213227		
84287	1844	40213260	2010-06-22	2010-06-22 00:00:00	2010-06-22	2010-06-22 00:00:00	2010-06-22	581452		0	0	0		0	0	0	123202	0	121	40213260		
178917	3934	40213227	1992-12-09	1992-12-09 00:00:00	1992-12-09	1992-12-09 00:00:00	1992-12-09	581452		0	0	0		0	0	0	261428	0	113	40213227		
160901	3540	40213160	1974-07-08	1974-07-08 00:00:00	1974-07-08	1974-07-08 00:00:00	1974-07-08	581452		0	0	0		0	0	0	235127	0	10	40213160		
5134	111	40213160	1980-04-11	1980-04-11 00:00:00	1980-04-11	1980-04-11 00:00:00	1980-04-11	581452		0	0	0		0	0	0	7358	0	10	40213160		
17357	1438	1118084	1986-04-29	1986-04-29 00:00:00	1986-04-29	1986-04-29 00:00:00	\N	38000177		0	0	0		0	0	0	95827	0	00025152531	44923712		
61044	5077	1127433	2006-02-10	2006-02-10 00:00:00	2006-02-17	2006-02-17 00:00:00	2006-02-17	38000177		0	0	7		0	0	0	337467	0	313782	1127433		
134468	2951	40213227	2009-11-22	2009-11-22 00:00:00	2009-11-22	2009-11-22 00:00:00	2009-11-22	581452		0	0	0		0	0	0	197040	0	113	40213227		
222603	4886	40213306	1987-11-09	1987-11-09 00:00:00	1987-11-09	1987-11-09 00:00:00	1987-11-09	581452		0	0	0		0	0	0	324873	0	43	40213306		
49829	4134	19078461	2014-09-23	2014-09-23 00:00:00	2014-10-07	2014-10-07 00:00:00	2014-10-07	38000177		0	0	14		0	0	0	274822	0	310965	19078461		
55017	4569	1127433	1997-10-16	1997-10-16 00:00:00	1997-11-20	1997-11-20 00:00:00	1997-11-20	38000177		0	0	35		0	0	0	304397	0	313782	1127433		
234042	5143	40213260	2010-02-03	2010-02-03 00:00:00	2010-02-03	2010-02-03 00:00:00	2010-02-03	581452		0	0	0		0	0	0	341800	0	121	40213260		
50822	4223	1118084	1989-08-05	1989-08-05 00:00:00	1989-08-05	1989-08-05 00:00:00	\N	38000177		0	0	0		0	0	0	280436	0	00025152531	44923712		
227856	5002	40213296	2018-04-20	2018-04-20 00:00:00	2018-04-20	2018-04-20 00:00:00	2018-04-20	581452		0	0	0		0	0	0	332700	0	52	40213296		
213293	4677	40213260	2009-02-06	2009-02-06 00:00:00	2009-02-06	2009-02-06 00:00:00	2009-02-06	581452		0	0	0		0	0	0	311684	0	121	40213260		
234492	5151	40213227	1997-11-07	1997-11-07 00:00:00	1997-11-07	1997-11-07 00:00:00	1997-11-07	581452		0	0	0		0	0	0	342517	0	113	40213227		
9947	211	40213160	1972-08-17	1972-08-17 00:00:00	1972-08-17	1972-08-17 00:00:00	1972-08-17	581452		0	0	0		0	0	0	14365	0	10	40213160		
206658	4534	40213201	2010-03-31	2010-03-31 00:00:00	2010-03-31	2010-03-31 00:00:00	2010-03-31	581452		0	0	0		0	0	0	302063	0	33	40213201		
234588	5153	40213201	2011-03-30	2011-03-30 00:00:00	2011-03-30	2011-03-30 00:00:00	2011-03-30	581452		0	0	0		0	0	0	342695	0	33	40213201		
126253	2777	40213306	1982-07-09	1982-07-09 00:00:00	1982-07-09	1982-07-09 00:00:00	1982-07-09	581452		0	0	0		0	0	0	183887	0	43	40213306		
50953	1116	40213227	2008-09-12	2008-09-12 00:00:00	2008-09-12	2008-09-12 00:00:00	2008-09-12	581452		0	0	0		0	0	0	73539	0	113	40213227		
194295	4269	40213160	1968-10-09	1968-10-09 00:00:00	1968-10-09	1968-10-09 00:00:00	1968-10-09	581452		0	0	0		0	0	0	283308	0	10	40213160		
2558	57	40213160	1961-09-25	1961-09-25 00:00:00	1961-09-25	1961-09-25 00:00:00	1961-09-25	581452		0	0	0		0	0	0	3853	0	10	40213160		
221187	4853	40213227	2004-08-04	2004-08-04 00:00:00	2004-08-04	2004-08-04 00:00:00	2004-08-04	581452		0	0	0		0	0	0	322899	0	113	40213227		
12801	1077	19059056	1947-05-13	1947-05-13 00:00:00	1947-05-27	1947-05-27 00:00:00	1947-05-27	38000177		0	0	14		0	0	0	70637	0	243670	19059056		
142715	3135	40213227	2005-08-18	2005-08-18 00:00:00	2005-08-18	2005-08-18 00:00:00	2005-08-18	581452		0	0	0		0	0	0	208719	0	113	40213227		
22528	1851	19074679	1992-01-09	1992-01-09 00:00:00	1992-06-25	1992-06-25 00:00:00	1992-06-25	38000177		0	0	168		0	0	0	123851	0	308971	19074679		
19208	1586	920300	1966-04-12	1966-04-12 00:00:00	1966-04-19	1966-04-19 00:00:00	1966-04-19	38000177		0	0	7		0	0	0	106385	0	311989	920300		
13320	1117	19059056	1937-11-12	1937-11-12 00:00:00	1937-12-03	1937-12-03 00:00:00	1937-12-03	38000177		0	0	21		0	0	0	73615	0	243670	19059056		
203168	4460	40213201	2007-02-26	2007-02-26 00:00:00	2007-02-26	2007-02-26 00:00:00	2007-02-26	581452		0	0	0		0	0	0	296783	0	33	40213201		
141976	3119	40213160	1974-11-24	1974-11-24 00:00:00	1974-11-24	1974-11-24 00:00:00	1974-11-24	581452		0	0	0		0	0	0	207541	0	10	40213160		
5061	422	1713671	2014-12-06	2014-12-06 00:00:00	2015-02-28	2015-02-28 00:00:00	2015-02-28	38000177		0	0	84		0	0	0	27911	0	562251	1713671		
67892	1486	40213260	2006-09-24	2006-09-24 00:00:00	2006-09-24	2006-09-24 00:00:00	2006-09-24	581452		0	0	0		0	0	0	99068	0	121	40213260		
106690	2339	40213160	1973-01-30	1973-01-30 00:00:00	1973-01-30	1973-01-30 00:00:00	1973-01-30	581452		0	0	0		0	0	0	155635	0	10	40213160		
61324	5101	1127433	1997-12-23	1997-12-23 00:00:00	1998-01-06	1998-01-06 00:00:00	1998-01-06	38000177		0	0	14		0	0	0	338952	0	313782	1127433		
53849	4476	1124300	2000-02-29	2000-02-29 00:00:00	2000-02-29	2000-02-29 00:00:00	\N	38000177		0	0	0		0	0	0	297875	0	00781178901	45011828		
62967	1377	40213227	2011-12-13	2011-12-13 00:00:00	2011-12-13	2011-12-13 00:00:00	2011-12-13	581452		0	0	0		0	0	0	91284	0	113	40213227		
9893	829	1127433	2012-03-29	2012-03-29 00:00:00	2012-05-28	2012-05-28 00:00:00	2012-05-28	38000177		0	0	60		0	0	0	54896	0	313782	1127433		
188527	4139	40213296	2012-11-16	2012-11-16 00:00:00	2012-11-16	2012-11-16 00:00:00	2012-11-16	581452		0	0	0		0	0	0	275142	0	52	40213296		
155552	3423	40213227	2016-03-31	2016-03-31 00:00:00	2016-03-31	2016-03-31 00:00:00	2016-03-31	581452		0	0	0		0	0	0	227089	0	113	40213227		
25649	559	40213160	1973-05-21	1973-05-21 00:00:00	1973-05-21	1973-05-21 00:00:00	1973-05-21	581452		0	0	0		0	0	0	37090	0	10	40213160		
149032	3278	40213227	1994-09-05	1994-09-05 00:00:00	1994-09-05	1994-09-05 00:00:00	1994-09-05	581452		0	0	0		0	0	0	217771	0	113	40213227		
7586	163	40213160	1966-12-06	1966-12-06 00:00:00	1966-12-06	1966-12-06 00:00:00	1966-12-06	581452		0	0	0		0	0	0	11217	0	10	40213160		
31070	2576	1127078	1981-12-11	1981-12-11 00:00:00	1981-12-25	1981-12-25 00:00:00	1981-12-25	38000177		0	0	14		0	0	0	170542	0	282464	1127078		
11191	931	19059056	1963-01-04	1963-01-04 00:00:00	1963-01-18	1963-01-18 00:00:00	1963-01-18	38000177		0	0	14		0	0	0	61931	0	243670	19059056		
11205	933	1127078	1981-09-30	1981-09-30 00:00:00	1981-10-21	1981-10-21 00:00:00	1981-10-21	38000177		0	0	21		0	0	0	62057	0	282464	1127078		
109474	2402	40213251	1984-02-27	1984-02-27 00:00:00	1984-02-27	1984-02-27 00:00:00	1984-02-27	581452		0	0	0		0	0	0	\N	0	21	40213251		
62838	5222	19059056	1926-04-03	1926-04-03 00:00:00	1926-04-17	1926-04-17 00:00:00	1926-04-17	38000177		0	0	14		0	0	0	347507	0	243670	19059056		
57438	4764	1713671	2018-05-12	2018-05-12 00:00:00	2018-05-19	2018-05-19 00:00:00	2018-05-19	38000177		0	0	7		0	0	0	317499	0	562251	1713671		
56369	4677	19059056	1966-03-01	1966-03-01 00:00:00	1966-03-29	1966-03-29 00:00:00	1966-03-29	38000177		0	0	28		0	0	0	311665	0	243670	19059056		
52379	1146	40213260	2009-01-15	2009-01-15 00:00:00	2009-01-15	2009-01-15 00:00:00	2009-01-15	581452		0	0	0		0	0	0	75733	0	121	40213260		
179659	3950	40213160	1975-09-11	1975-09-11 00:00:00	1975-09-11	1975-09-11 00:00:00	1975-09-11	581452		0	0	0		0	0	0	262549	0	10	40213160		
154103	3392	40213227	2018-07-14	2018-07-14 00:00:00	2018-07-14	2018-07-14 00:00:00	2018-07-14	581452		0	0	0		0	0	0	224975	0	113	40213227		
15372	1283	19078219	1972-04-22	1972-04-22 00:00:00	1972-04-22	1972-04-22 00:00:00	1972-04-22	38000177		0	0	0		0	0	0	84823	0	56795	19078219		
27467	598	40213160	1974-12-27	1974-12-27 00:00:00	1974-12-27	1974-12-27 00:00:00	1974-12-27	581452		0	0	0		0	0	0	39505	0	10	40213160		
3422	283	19078461	2010-10-29	2010-10-29 00:00:00	2010-11-12	2010-11-12 00:00:00	2010-11-12	38000177		0	0	14		0	0	0	18885	0	310965	19078461		
148046	3254	40213160	1968-11-10	1968-11-10 00:00:00	1968-11-10	1968-11-10 00:00:00	1968-11-10	581452		0	0	0		0	0	0	216405	0	10	40213160		
39718	3285	46275916	2011-03-12	2011-03-12 00:00:00	2011-03-12	2011-03-12 00:00:00	2011-03-12	38000177		0	0	0		0	0	0	218180	0	1660014	46275916		
31409	2603	40174880	2014-05-12	2014-05-12 00:00:00	2014-05-12	2014-05-12 00:00:00	\N	38000177		0	0	0		0	0	0	172225	0	966222	40174880		
197893	4348	40213160	1982-06-30	1982-06-30 00:00:00	1982-06-30	1982-06-30 00:00:00	1982-06-30	581452		0	0	0		0	0	0	288313	0	10	40213160		
118931	2616	40213160	1956-11-06	1956-11-06 00:00:00	1956-11-06	1956-11-06 00:00:00	1956-11-06	581452		0	0	0		0	0	0	172998	0	10	40213160		
84300	1844	40213160	1959-12-15	1959-12-15 00:00:00	1959-12-15	1959-12-15 00:00:00	1959-12-15	581452		0	0	0		0	0	0	123189	0	10	40213160		
178920	3934	40213201	2005-02-16	2005-02-16 00:00:00	2005-02-16	2005-02-16 00:00:00	2005-02-16	581452		0	0	0		0	0	0	261435	0	33	40213201		
160912	3541	40213227	1998-10-19	1998-10-19 00:00:00	1998-10-19	1998-10-19 00:00:00	1998-10-19	581452		0	0	0		0	0	0	235218	0	113	40213227		
5140	111	40213227	2017-05-12	2017-05-12 00:00:00	2017-05-12	2017-05-12 00:00:00	2017-05-12	581452		0	0	0		0	0	0	7416	0	113	40213227		
17358	1438	1713671	1958-04-21	1958-04-21 00:00:00	1958-05-05	1958-05-05 00:00:00	1958-05-05	38000177		0	0	14		0	0	0	95778	0	562251	1713671		
61045	5077	1127433	1998-12-12	1998-12-12 00:00:00	1998-12-19	1998-12-19 00:00:00	1998-12-19	38000177		0	0	7		0	0	0	337444	0	313782	1127433		
134469	2951	40213260	2009-11-22	2009-11-22 00:00:00	2009-11-22	2009-11-22 00:00:00	2009-11-22	581452		0	0	0		0	0	0	197040	0	121	40213260		
222609	4886	40213227	2016-12-12	2016-12-12 00:00:00	2016-12-12	2016-12-12 00:00:00	2016-12-12	581452		0	0	0		0	0	0	324925	0	113	40213227		
49830	4134	19133905	1985-08-18	1985-08-18 00:00:00	1985-08-29	1985-08-29 00:00:00	1985-08-29	38000177		0	0	11		0	0	0	274897	0	834102	19133905		
55018	4569	19073188	1997-10-16	1997-10-16 00:00:00	1997-11-20	1997-11-20 00:00:00	1997-11-20	38000177		0	0	35		0	0	0	304397	0	308192	19073188		
234043	5143	40213227	2010-02-03	2010-02-03 00:00:00	2010-02-03	2010-02-03 00:00:00	2010-02-03	581452		0	0	0		0	0	0	341800	0	113	40213227		
50823	4223	19133873	1971-06-22	1971-06-22 00:00:00	1971-07-03	1971-07-03 00:00:00	1971-07-03	38000177		0	0	11		0	0	0	280424	0	834061	19133873		
239146	5249	40213227	1992-06-07	1992-06-07 00:00:00	1992-06-07	1992-06-07 00:00:00	1992-06-07	581452		0	0	0		0	0	0	349222	0	113	40213227		
213296	4677	40213227	2019-05-31	2019-05-31 00:00:00	2019-05-31	2019-05-31 00:00:00	2019-05-31	581452		0	0	0		0	0	0	311686	0	113	40213227		
232796	5116	40213227	1998-04-02	1998-04-02 00:00:00	1998-04-02	1998-04-02 00:00:00	1998-04-02	581452		0	0	0		0	0	0	\N	0	113	40213227		
9949	211	40213306	1989-11-09	1989-11-09 00:00:00	1989-11-09	1989-11-09 00:00:00	1989-11-09	581452		0	0	0		0	0	0	14362	0	43	40213306		
206659	4534	40213198	2010-03-31	2010-03-31 00:00:00	2010-03-31	2010-03-31 00:00:00	2010-03-31	581452		0	0	0		0	0	0	302063	0	133	40213198		
234590	5153	40213227	2016-04-27	2016-04-27 00:00:00	2016-04-27	2016-04-27 00:00:00	2016-04-27	581452		0	0	0		0	0	0	342715	0	113	40213227		
126258	2777	40213160	1960-12-08	1960-12-08 00:00:00	1960-12-08	1960-12-08 00:00:00	1960-12-08	581452		0	0	0		0	0	0	183958	0	10	40213160		
50955	1116	40213160	1966-05-20	1966-05-20 00:00:00	1966-05-20	1966-05-20 00:00:00	1966-05-20	581452		0	0	0		0	0	0	73553	0	10	40213160		
194297	4269	40213306	1990-12-05	1990-12-05 00:00:00	1990-12-05	1990-12-05 00:00:00	1990-12-05	581452		0	0	0		0	0	0	283344	0	43	40213306		
2560	57	40213227	2013-04-08	2013-04-08 00:00:00	2013-04-08	2013-04-08 00:00:00	2013-04-08	581452		0	0	0		0	0	0	3867	0	113	40213227		
221188	4853	40213296	2004-08-04	2004-08-04 00:00:00	2004-08-04	2004-08-04 00:00:00	2004-08-04	581452		0	0	0		0	0	0	322899	0	52	40213296		
12802	1077	19006318	1947-05-13	1947-05-13 00:00:00	1947-05-27	1947-05-27 00:00:00	1947-05-27	38000177		0	0	14		0	0	0	70637	0	105078	19006318		
142716	3135	40213296	2005-08-18	2005-08-18 00:00:00	2005-08-18	2005-08-18 00:00:00	2005-08-18	581452		0	0	0		0	0	0	208719	0	52	40213296		
22530	1851	1115171	1997-09-24	1997-09-24 00:00:00	1997-10-08	1997-10-08 00:00:00	1997-10-08	38000177		0	0	14		0	0	0	123826	0	849574	1115171		
19209	1586	1127433	1964-03-12	1964-03-12 00:00:00	1964-05-11	1964-05-11 00:00:00	1964-05-11	38000177		0	0	60		0	0	0	106388	0	313782	1127433		
13321	1117	1713671	1988-03-27	1988-03-27 00:00:00	1988-04-03	1988-04-03 00:00:00	1988-04-03	38000177		0	0	7		0	0	0	73572	0	562251	1713671		
68058	1490	40213227	1992-01-02	1992-01-02 00:00:00	1992-01-02	1992-01-02 00:00:00	1992-01-02	581452		0	0	0		0	0	0	99383	0	113	40213227		
95263	2088	40213227	1992-08-11	1992-08-11 00:00:00	1992-08-11	1992-08-11 00:00:00	1992-08-11	581452		0	0	0		0	0	0	139237	0	113	40213227		
5062	422	19133905	2016-04-28	2016-04-28 00:00:00	2016-05-11	2016-05-11 00:00:00	2016-05-11	38000177		0	0	13		0	0	0	27942	0	834102	19133905		
67893	1486	40213260	2007-09-30	2007-09-30 00:00:00	2007-09-30	2007-09-30 00:00:00	2007-09-30	581452		0	0	0		0	0	0	99072	0	121	40213260		
106700	2339	40213160	1973-05-01	1973-05-01 00:00:00	1973-05-01	1973-05-01 00:00:00	1973-05-01	581452		0	0	0		0	0	0	155699	0	10	40213160		
61325	5101	1127433	2016-03-29	2016-03-29 00:00:00	2016-05-03	2016-05-03 00:00:00	2016-05-03	38000177		0	0	35		0	0	0	338979	0	313782	1127433		
53850	4476	40229134	2003-03-08	2003-03-08 00:00:00	2003-03-22	2003-03-22 00:00:00	2003-03-22	38000177		0	0	14		0	0	0	297857	0	1043400	40229134		
62975	1378	40213227	2015-11-10	2015-11-10 00:00:00	2015-11-10	2015-11-10 00:00:00	2015-11-10	581452		0	0	0		0	0	0	91355	0	113	40213227		
9894	829	40162522	2012-03-29	2012-03-29 00:00:00	2012-03-29	2012-03-29 00:00:00	\N	38000177		0	0	0		0	0	0	54896	0	857005	40162522		
188529	4139	40213227	2012-11-16	2012-11-16 00:00:00	2012-11-16	2012-11-16 00:00:00	2012-11-16	581452		0	0	0		0	0	0	275142	0	113	40213227		
155553	3423	40213296	2016-03-31	2016-03-31 00:00:00	2016-03-31	2016-03-31 00:00:00	2016-03-31	581452		0	0	0		0	0	0	227089	0	52	40213296		
25651	559	40213227	1992-02-10	1992-02-10 00:00:00	1992-02-10	1992-02-10 00:00:00	1992-02-10	581452		0	0	0		0	0	0	37060	0	113	40213227		
149044	3278	40213160	1965-03-29	1965-03-29 00:00:00	1965-03-29	1965-03-29 00:00:00	1965-03-29	581452		0	0	0		0	0	0	217793	0	10	40213160		
7588	163	40213227	1997-09-09	1997-09-09 00:00:00	1997-09-09	1997-09-09 00:00:00	1997-09-09	581452		0	0	0		0	0	0	11209	0	113	40213227		
31071	2576	19073183	1980-10-03	1980-10-03 00:00:00	1980-10-17	1980-10-17 00:00:00	1980-10-17	38000177		0	0	14		0	0	0	170541	0	308182	19073183		
11192	931	19078461	1974-01-04	1974-01-04 00:00:00	1974-02-08	1974-02-08 00:00:00	1974-02-08	38000177		0	0	35		0	0	0	61959	0	310965	19078461		
11206	933	1127078	1975-04-14	1975-04-14 00:00:00	1975-05-05	1975-05-05 00:00:00	1975-05-05	38000177		0	0	21		0	0	0	62056	0	282464	1127078		
109476	2402	40213314	1977-05-23	1977-05-23 00:00:00	1977-05-23	1977-05-23 00:00:00	1977-05-23	581452		0	0	0		0	0	0	159704	0	49	40213314		
62839	5222	1127433	2016-05-15	2016-05-15 00:00:00	2016-06-12	2016-06-12 00:00:00	2016-06-12	38000177		0	0	28		0	0	0	347506	0	313782	1127433		
57439	4764	1127433	1981-11-11	1981-11-11 00:00:00	1981-11-25	1981-11-25 00:00:00	1981-11-25	38000177		0	0	14		0	0	0	317482	0	313782	1127433		
56370	4677	40229134	1981-03-02	1981-03-02 00:00:00	1981-03-16	1981-03-16 00:00:00	1981-03-16	38000177		0	0	14		0	0	0	311653	0	1043400	40229134		
52385	1146	40213296	1999-01-21	1999-01-21 00:00:00	1999-01-21	1999-01-21 00:00:00	1999-01-21	581452		0	0	0		0	0	0	75705	0	52	40213296		
179667	3950	40213296	2012-10-11	2012-10-11 00:00:00	2012-10-11	2012-10-11 00:00:00	2012-10-11	581452		0	0	0		0	0	0	262560	0	52	40213296		
154104	3392	40213260	2018-07-14	2018-07-14 00:00:00	2018-07-14	2018-07-14 00:00:00	2018-07-14	581452		0	0	0		0	0	0	224975	0	121	40213260		
15373	1283	19079524	1972-04-22	1972-04-22 00:00:00	1972-04-28	1972-04-28 00:00:00	1972-04-28	38000177		0	0	6		0	0	0	84823	0	313002	19079524		
27474	598	40213314	1977-08-26	1977-08-26 00:00:00	1977-08-26	1977-08-26 00:00:00	1977-08-26	581452		0	0	0		0	0	0	39482	0	49	40213314		
3423	283	19133873	1984-02-15	1984-02-15 00:00:00	1984-02-25	1984-02-25 00:00:00	1984-02-25	38000177		0	0	10		0	0	0	18859	0	834061	19133873		
148052	3254	40213160	1964-05-10	1964-05-10 00:00:00	1964-05-10	1964-05-10 00:00:00	1964-05-10	581452		0	0	0		0	0	0	216401	0	10	40213160		
39719	3285	1310034	2011-03-12	2011-03-12 00:00:00	2011-03-12	2011-03-12 00:00:00	2011-03-12	38000177		0	0	0		0	0	0	218180	0	834357	1310034		
31410	2603	40229134	1980-02-11	1980-02-11 00:00:00	1980-02-25	1980-02-25 00:00:00	1980-02-25	38000177		0	0	14		0	0	0	172232	0	1043400	40229134		
197894	4348	40213160	1982-03-31	1982-03-31 00:00:00	1982-03-31	1982-03-31 00:00:00	1982-03-31	581452		0	0	0		0	0	0	288351	0	10	40213160		
118933	2616	40213227	1994-04-26	1994-04-26 00:00:00	1994-04-26	1994-04-26 00:00:00	1994-04-26	581452		0	0	0		0	0	0	172973	0	113	40213227		
84301	1844	40213160	1959-09-15	1959-09-15 00:00:00	1959-09-15	1959-09-15 00:00:00	1959-09-15	581452		0	0	0		0	0	0	123142	0	10	40213160		
178948	3934	40213227	2010-03-17	2010-03-17 00:00:00	2010-03-17	2010-03-17 00:00:00	2010-03-17	581452		0	0	0		0	0	0	261445	0	113	40213227		
160914	3541	40213260	2017-08-07	2017-08-07 00:00:00	2017-08-07	2017-08-07 00:00:00	2017-08-07	581452		0	0	0		0	0	0	235221	0	121	40213260		
5141	111	40213296	2017-05-12	2017-05-12 00:00:00	2017-05-12	2017-05-12 00:00:00	2017-05-12	581452		0	0	0		0	0	0	7416	0	52	40213296		
17359	1438	19006318	1953-12-08	1953-12-08 00:00:00	1953-12-22	1953-12-22 00:00:00	1953-12-22	38000177		0	0	14		0	0	0	95840	0	105078	19006318		
61046	5077	19115351	2017-03-04	2017-03-04 00:00:00	2017-09-09	2017-09-09 00:00:00	2017-09-09	38000177		0	0	189		0	0	0	337490	0	563026	19115351		
134476	2951	40213260	2008-11-16	2008-11-16 00:00:00	2008-11-16	2008-11-16 00:00:00	2008-11-16	581452		0	0	0		0	0	0	197070	0	121	40213260		
222610	4886	40213260	2016-12-12	2016-12-12 00:00:00	2016-12-12	2016-12-12 00:00:00	2016-12-12	581452		0	0	0		0	0	0	324925	0	121	40213260		
49831	4134	1127433	1976-12-19	1976-12-19 00:00:00	1977-01-02	1977-01-02 00:00:00	1977-01-02	38000177		0	0	14		0	0	0	274846	0	313782	1127433		
55019	4569	40165015	1997-10-16	1997-10-16 00:00:00	1997-10-16	1997-10-16 00:00:00	\N	38000177		0	0	0		0	0	0	304397	0	861467	40165015		
234044	5143	40213260	2009-01-28	2009-01-28 00:00:00	2009-01-28	2009-01-28 00:00:00	2009-01-28	581452		0	0	0		0	0	0	341828	0	121	40213260		
50824	4223	19129655	1961-11-25	1961-11-25 00:00:00	1961-12-09	1961-12-09 00:00:00	1961-12-09	38000177		0	0	14		0	0	0	280384	0	789980	19129655		
69506	1520	40213227	1997-11-23	1997-11-23 00:00:00	1997-11-23	1997-11-23 00:00:00	1997-11-23	581452		0	0	0		0	0	0	101680	0	113	40213227		
213301	4677	40213306	1981-03-13	1981-03-13 00:00:00	1981-03-13	1981-03-13 00:00:00	1981-03-13	581452		0	0	0		0	0	0	311715	0	43	40213306		
232798	5116	40213160	1969-01-09	1969-01-09 00:00:00	1969-01-09	1969-01-09 00:00:00	1969-01-09	581452		0	0	0		0	0	0	\N	0	10	40213160		
9957	212	40213227	1992-10-31	1992-10-31 00:00:00	1992-10-31	1992-10-31 00:00:00	1992-10-31	581452		0	0	0		0	0	0	14426	0	113	40213227		
39891	869	40213227	1995-05-05	1995-05-05 00:00:00	1995-05-05	1995-05-05 00:00:00	1995-05-05	581452		0	0	0		0	0	0	57715	0	113	40213227		
234597	5153	40213227	2006-03-01	2006-03-01 00:00:00	2006-03-01	2006-03-01 00:00:00	2006-03-01	581452		0	0	0		0	0	0	342725	0	113	40213227		
126259	2777	40213160	1965-03-11	1965-03-11 00:00:00	1965-03-11	1965-03-11 00:00:00	1965-03-11	581452		0	0	0		0	0	0	183898	0	10	40213160		
50957	1116	40213160	1966-03-18	1966-03-18 00:00:00	1966-03-18	1966-03-18 00:00:00	1966-03-18	581452		0	0	0		0	0	0	73514	0	10	40213160		
194300	4269	40213160	1969-01-08	1969-01-08 00:00:00	1969-01-08	1969-01-08 00:00:00	1969-01-08	581452		0	0	0		0	0	0	283360	0	10	40213160		
2561	57	40213260	2013-04-08	2013-04-08 00:00:00	2013-04-08	2013-04-08 00:00:00	2013-04-08	581452		0	0	0		0	0	0	3867	0	121	40213260		
221194	4853	40213160	1962-10-17	1962-10-17 00:00:00	1962-10-17	1962-10-17 00:00:00	1962-10-17	581452		0	0	0		0	0	0	322882	0	10	40213160		
12803	1077	40229134	1983-10-06	1983-10-06 00:00:00	1983-10-13	1983-10-13 00:00:00	1983-10-13	38000177		0	0	7		0	0	0	70651	0	1043400	40229134		
156984	3454	40213160	1983-08-15	1983-08-15 00:00:00	1983-08-15	1983-08-15 00:00:00	1983-08-15	581452		0	0	0		0	0	0	229178	0	10	40213160		
22531	1851	1127078	1980-02-26	1980-02-26 00:00:00	1980-03-11	1980-03-11 00:00:00	1980-03-11	38000177		0	0	14		0	0	0	123842	0	282464	1127078		
19210	1586	40162522	1964-03-12	1964-03-12 00:00:00	1964-03-12	1964-03-12 00:00:00	\N	38000177		0	0	0		0	0	0	106388	0	857005	40162522		
13322	1117	1713671	2012-09-23	2012-09-23 00:00:00	2012-10-07	2012-10-07 00:00:00	2012-10-07	38000177		0	0	14		0	0	0	73645	0	562251	1713671		
216740	4756	40213201	2009-10-10	2009-10-10 00:00:00	2009-10-10	2009-10-10 00:00:00	2009-10-10	581452		0	0	0		0	0	0	316859	0	33	40213201		
95264	2088	40213227	2000-06-06	2000-06-06 00:00:00	2000-06-06	2000-06-06 00:00:00	2000-06-06	581452		0	0	0		0	0	0	139172	0	113	40213227		
5063	422	1124300	2000-12-20	2000-12-20 00:00:00	2000-12-20	2000-12-20 00:00:00	\N	38000177		0	0	0		0	0	0	27927	0	00781178901	45011828		
67901	1486	40213296	1998-08-30	1998-08-30 00:00:00	1998-08-30	1998-08-30 00:00:00	1998-08-30	581452		0	0	0		0	0	0	99067	0	52	40213296		
106703	2339	40213296	2012-12-25	2012-12-25 00:00:00	2012-12-25	2012-12-25 00:00:00	2012-12-25	581452		0	0	0		0	0	0	155657	0	52	40213296		
61326	5101	19059056	1962-02-01	1962-02-01 00:00:00	1962-02-15	1962-02-15 00:00:00	1962-02-15	38000177		0	0	14		0	0	0	338953	0	243670	19059056		
53851	4476	46275916	1975-05-04	1975-05-04 00:00:00	1975-05-04	1975-05-04 00:00:00	1975-05-04	38000177		0	0	0		0	0	0	297897	0	1660014	46275916		
133819	2939	40213198	2018-09-04	2018-09-04 00:00:00	2018-09-04	2018-09-04 00:00:00	2018-09-04	581452		0	0	0		0	0	0	195997	0	133	40213198		
9895	829	1118084	2010-03-30	2010-03-30 00:00:00	2010-03-30	2010-03-30 00:00:00	\N	38000177		0	0	0		0	0	0	54936	0	00025152531	44923712		
188532	4139	40213296	2010-11-12	2010-11-12 00:00:00	2010-11-12	2010-11-12 00:00:00	2010-11-12	581452		0	0	0		0	0	0	275152	0	52	40213296		
155557	3423	40213160	1974-06-27	1974-06-27 00:00:00	1974-06-27	1974-06-27 00:00:00	1974-06-27	581452		0	0	0		0	0	0	227061	0	10	40213160		
25652	559	40213306	1992-02-10	1992-02-10 00:00:00	1992-02-10	1992-02-10 00:00:00	1992-02-10	581452		0	0	0		0	0	0	37060	0	43	40213306		
149048	3278	40213227	2011-04-25	2011-04-25 00:00:00	2011-04-25	2011-04-25 00:00:00	2011-04-25	581452		0	0	0		0	0	0	217752	0	113	40213227		
20553	1691	1127433	2005-06-01	2005-06-01 00:00:00	2005-06-08	2005-06-08 00:00:00	2005-06-08	38000177		0	0	7		0	0	0	113236	0	313782	1127433		
31072	2576	19019979	1980-10-03	1980-10-03 00:00:00	1980-10-17	1980-10-17 00:00:00	1980-10-17	38000177		0	0	14		0	0	0	170541	0	198405	19019979		
1433	32	40213198	2010-09-22	2010-09-22 00:00:00	2010-09-22	2010-09-22 00:00:00	2010-09-22	581452		0	0	0		0	0	0	2222	0	133	40213198		
11207	933	1124300	2011-07-09	2011-07-09 00:00:00	2011-07-09	2011-07-09 00:00:00	\N	38000177		0	0	0		0	0	0	62093	0	00781178901	45011828		
109479	2402	40213160	1977-05-23	1977-05-23 00:00:00	1977-05-23	1977-05-23 00:00:00	1977-05-23	581452		0	0	0		0	0	0	159704	0	10	40213160		
62840	5222	19008572	1946-07-24	1946-07-24 00:00:00	1946-07-24	1946-07-24 00:00:00	\N	38000177		0	0	0		0	0	0	347353	0	106258	19008572		
46808	1022	40213260	2015-04-07	2015-04-07 00:00:00	2015-04-07	2015-04-07 00:00:00	2015-04-07	581452		0	0	0		0	0	0	67218	0	121	40213260		
15932	343	40213296	2012-02-11	2012-02-11 00:00:00	2012-02-11	2012-02-11 00:00:00	2012-02-11	581452		0	0	0		0	0	0	22952	0	52	40213296		
52404	1146	40213227	1993-12-09	1993-12-09 00:00:00	1993-12-09	1993-12-09 00:00:00	1993-12-09	581452		0	0	0		0	0	0	75728	0	113	40213227		
179670	3950	40213227	2012-10-11	2012-10-11 00:00:00	2012-10-11	2012-10-11 00:00:00	2012-10-11	581452		0	0	0		0	0	0	262560	0	113	40213227		
165402	3636	40213160	1973-03-23	1973-03-23 00:00:00	1973-03-23	1973-03-23 00:00:00	1973-03-23	581452		0	0	0		0	0	0	241846	0	10	40213160		
15374	1283	19023398	1972-04-22	1972-04-22 00:00:00	1972-04-22	1972-04-22 00:00:00	1972-04-22	38000177		0	0	0		0	0	0	84823	0	200243	19023398		
236993	5203	40213227	1996-10-16	1996-10-16 00:00:00	1996-10-16	1996-10-16 00:00:00	1996-10-16	581452		0	0	0		0	0	0	346069	0	113	40213227		
3424	283	19128022	1997-08-13	1997-08-13 00:00:00	1998-08-08	1998-08-08 00:00:00	1998-08-08	38000177		0	0	360		0	0	0	18867	0	749785	19128022		
124994	2750	40213227	2005-02-16	2005-02-16 00:00:00	2005-02-16	2005-02-16 00:00:00	2005-02-16	581452		0	0	0		0	0	0	181954	0	113	40213227		
39720	3285	40243436	2011-03-12	2011-03-12 00:00:00	2011-03-12	2011-03-12 00:00:00	2011-03-12	38000177		0	0	0		0	0	0	218180	0	1190795	40243436		
31412	2603	19128065	1977-05-06	1977-05-06 00:00:00	1978-05-01	1978-05-01 00:00:00	1978-05-01	38000177		0	0	360		0	0	0	172198	0	749882	19128065		
197895	4348	40213314	1982-03-31	1982-03-31 00:00:00	1982-03-31	1982-03-31 00:00:00	1982-03-31	581452		0	0	0		0	0	0	288351	0	49	40213314		
118935	2616	40213198	2017-02-07	2017-02-07 00:00:00	2017-02-07	2017-02-07 00:00:00	2017-02-07	581452		0	0	0		0	0	0	172952	0	133	40213198		
84307	1844	40213227	2001-11-06	2001-11-06 00:00:00	2001-11-06	2001-11-06 00:00:00	2001-11-06	581452		0	0	0		0	0	0	123168	0	113	40213227		
167858	3691	40213227	1997-02-07	1997-02-07 00:00:00	1997-02-07	1997-02-07 00:00:00	1997-02-07	581452		0	0	0		0	0	0	245315	0	113	40213227		
160915	3541	40213160	1967-11-13	1967-11-13 00:00:00	1967-11-13	1967-11-13 00:00:00	1967-11-13	581452		0	0	0		0	0	0	235196	0	10	40213160		
5142	111	40213160	1975-10-10	1975-10-10 00:00:00	1975-10-10	1975-10-10 00:00:00	1975-10-10	581452		0	0	0		0	0	0	7367	0	10	40213160		
17360	1438	1127078	1953-12-08	1953-12-08 00:00:00	1953-12-22	1953-12-22 00:00:00	1953-12-22	38000177		0	0	14		0	0	0	95840	0	282464	1127078		
61047	5077	1713671	1977-08-20	1977-08-20 00:00:00	1977-09-03	1977-09-03 00:00:00	1977-09-03	38000177		0	0	14		0	0	0	337465	0	562251	1713671		
134480	2951	40213306	1981-05-31	1981-05-31 00:00:00	1981-05-31	1981-05-31 00:00:00	1981-05-31	581452		0	0	0		0	0	0	197056	0	43	40213306		
222618	4886	40213260	2015-12-07	2015-12-07 00:00:00	2015-12-07	2015-12-07 00:00:00	2015-12-07	581452		0	0	0		0	0	0	324947	0	121	40213260		
49832	4134	1127433	2019-05-13	2019-05-13 00:00:00	2019-05-20	2019-05-20 00:00:00	2019-05-20	38000177		0	0	7		0	0	0	274833	0	313782	1127433		
55020	4570	19059056	1939-11-22	1939-11-22 00:00:00	1939-12-06	1939-12-06 00:00:00	1939-12-06	38000177		0	0	14		0	0	0	304468	0	243670	19059056		
234046	5143	40213160	1959-05-20	1959-05-20 00:00:00	1959-05-20	1959-05-20 00:00:00	1959-05-20	581452		0	0	0		0	0	0	341804	0	10	40213160		
50825	4223	19059056	1961-11-25	1961-11-25 00:00:00	1961-12-09	1961-12-09 00:00:00	1961-12-09	38000177		0	0	14		0	0	0	280384	0	243670	19059056		
69524	1520	40213201	2002-09-29	2002-09-29 00:00:00	2002-09-29	2002-09-29 00:00:00	2002-09-29	581452		0	0	0		0	0	0	101683	0	33	40213201		
213311	4677	40213160	1962-11-23	1962-11-23 00:00:00	1962-11-23	1962-11-23 00:00:00	1962-11-23	581452		0	0	0		0	0	0	311677	0	10	40213160		
232803	5116	40213227	2006-05-12	2006-05-12 00:00:00	2006-05-12	2006-05-12 00:00:00	2006-05-12	581452		0	0	0		0	0	0	339927	0	113	40213227		
9958	212	40213306	1992-10-31	1992-10-31 00:00:00	1992-10-31	1992-10-31 00:00:00	1992-10-31	581452		0	0	0		0	0	0	14426	0	43	40213306		
39906	870	40213227	1994-11-22	1994-11-22 00:00:00	1994-11-22	1994-11-22 00:00:00	1994-11-22	581452		0	0	0		0	0	0	57896	0	113	40213227		
234601	5153	40213227	1996-01-03	1996-01-03 00:00:00	1996-01-03	1996-01-03 00:00:00	1996-01-03	581452		0	0	0		0	0	0	342710	0	113	40213227		
126265	2777	40213296	2000-04-07	2000-04-07 00:00:00	2000-04-07	2000-04-07 00:00:00	2000-04-07	581452		0	0	0		0	0	0	183919	0	52	40213296		
50964	1116	40213296	2006-09-08	2006-09-08 00:00:00	2006-09-08	2006-09-08 00:00:00	2006-09-08	581452		0	0	0		0	0	0	73560	0	52	40213296		
194301	4269	40213160	1973-04-11	1973-04-11 00:00:00	1973-04-11	1973-04-11 00:00:00	1973-04-11	581452		0	0	0		0	0	0	283312	0	10	40213160		
2571	57	40213227	1995-02-27	1995-02-27 00:00:00	1995-02-27	1995-02-27 00:00:00	1995-02-27	581452		0	0	0		0	0	0	3838	0	113	40213227		
221196	4853	40213227	1993-07-21	1993-07-21 00:00:00	1993-07-21	1993-07-21 00:00:00	1993-07-21	581452		0	0	0		0	0	0	322910	0	113	40213227		
12804	1077	1127433	1950-08-27	1950-08-27 00:00:00	1950-09-10	1950-09-10 00:00:00	1950-09-10	38000177		0	0	14		0	0	0	70641	0	313782	1127433		
156989	3454	40213314	1984-05-14	1984-05-14 00:00:00	1984-05-14	1984-05-14 00:00:00	1984-05-14	581452		0	0	0		0	0	0	229156	0	49	40213314		
22532	1851	19073183	1980-02-26	1980-02-26 00:00:00	1980-03-11	1980-03-11 00:00:00	1980-03-11	38000177		0	0	14		0	0	0	123842	0	308182	19073183		
19211	1586	1713671	1947-11-04	1947-11-04 00:00:00	1947-11-18	1947-11-18 00:00:00	1947-11-18	38000177		0	0	14		0	0	0	106384	0	562251	1713671		
13323	1117	1127433	1980-04-12	1980-04-12 00:00:00	1980-04-26	1980-04-26 00:00:00	1980-04-26	38000177		0	0	14		0	0	0	73617	0	313782	1127433		
216757	4756	40213227	1995-07-22	1995-07-22 00:00:00	1995-07-22	1995-07-22 00:00:00	1995-07-22	581452		0	0	0		0	0	0	316874	0	113	40213227		
50685	4212	40165015	1984-01-14	1984-01-14 00:00:00	1984-01-14	1984-01-14 00:00:00	\N	38000177		0	0	0		0	0	0	279652	0	861467	40165015		
5064	422	19128065	1977-12-11	1977-12-11 00:00:00	1978-12-06	1978-12-06 00:00:00	1978-12-06	38000177		0	0	360		0	0	0	27913	0	749882	19128065		
67904	1486	40213160	1955-12-18	1955-12-18 00:00:00	1955-12-18	1955-12-18 00:00:00	1955-12-18	581452		0	0	0		0	0	0	99081	0	10	40213160		
106708	2340	40213160	1964-02-12	1964-02-12 00:00:00	1964-02-12	1964-02-12 00:00:00	1964-02-12	581452		0	0	0		0	0	0	155753	0	10	40213160		
61327	5101	19129655	1962-02-01	1962-02-01 00:00:00	1962-02-15	1962-02-15 00:00:00	1962-02-15	38000177		0	0	14		0	0	0	338953	0	789980	19129655		
53852	4476	40243436	1975-05-04	1975-05-04 00:00:00	1975-05-04	1975-05-04 00:00:00	1975-05-04	38000177		0	0	0		0	0	0	297897	0	1190795	40243436		
133823	2939	40213160	1955-12-27	1955-12-27 00:00:00	1955-12-27	1955-12-27 00:00:00	1955-12-27	581452		0	0	0		0	0	0	195933	0	10	40213160		
9896	829	40229134	2016-01-13	2016-01-13 00:00:00	2016-01-20	2016-01-20 00:00:00	2016-01-20	38000177		0	0	7		0	0	0	54930	0	1043400	40229134		
188533	4139	40213306	1993-01-08	1993-01-08 00:00:00	1993-01-08	1993-01-08 00:00:00	1993-01-08	581452		0	0	0		0	0	0	275125	0	43	40213306		
155562	3423	40213160	1974-11-28	1974-11-28 00:00:00	1974-11-28	1974-11-28 00:00:00	1974-11-28	581452		0	0	0		0	0	0	227079	0	10	40213160		
25656	559	40213160	1969-01-27	1969-01-27 00:00:00	1969-01-27	1969-01-27 00:00:00	1969-01-27	581452		0	0	0		0	0	0	37112	0	10	40213160		
149049	3278	40213260	2011-04-25	2011-04-25 00:00:00	2011-04-25	2011-04-25 00:00:00	2011-04-25	581452		0	0	0		0	0	0	217752	0	121	40213260		
20554	1691	1118084	1985-07-23	1985-07-23 00:00:00	1985-07-23	1985-07-23 00:00:00	\N	38000177		0	0	0		0	0	0	113247	0	00025152531	44923712		
31073	2576	1127433	1993-10-25	1993-10-25 00:00:00	1993-11-15	1993-11-15 00:00:00	1993-11-15	38000177		0	0	21		0	0	0	170548	0	313782	1127433		
1435	32	40213201	2010-09-22	2010-09-22 00:00:00	2010-09-22	2010-09-22 00:00:00	2010-09-22	581452		0	0	0		0	0	0	2222	0	33	40213201		
11208	933	1713671	2009-10-17	2009-10-17 00:00:00	2009-10-24	2009-10-24 00:00:00	2009-10-24	38000177		0	0	7		0	0	0	62071	0	562251	1713671		
109484	2402	40213306	1998-11-16	1998-11-16 00:00:00	1998-11-16	1998-11-16 00:00:00	1998-11-16	581452		0	0	0		0	0	0	159610	0	43	40213306		
62841	5222	19059056	1928-02-06	1928-02-06 00:00:00	1928-03-07	1928-03-07 00:00:00	1928-03-07	38000177		0	0	30		0	0	0	347508	0	243670	19059056		
46811	1022	40213260	2014-04-01	2014-04-01 00:00:00	2014-04-01	2014-04-01 00:00:00	2014-04-01	581452		0	0	0		0	0	0	67267	0	121	40213260		
15936	343	40213227	2002-03-30	2002-03-30 00:00:00	2002-03-30	2002-03-30 00:00:00	2002-03-30	581452		0	0	0		0	0	0	22937	0	113	40213227		
52407	1146	40213160	1959-06-25	1959-06-25 00:00:00	1959-06-25	1959-06-25 00:00:00	1959-06-25	581452		0	0	0		0	0	0	75676	0	10	40213160		
179672	3950	40213160	1971-03-11	1971-03-11 00:00:00	1971-03-11	1971-03-11 00:00:00	1971-03-11	581452		0	0	0		0	0	0	262535	0	10	40213160		
165406	3636	40213227	1993-11-26	1993-11-26 00:00:00	1993-11-26	1993-11-26 00:00:00	1993-11-26	581452		0	0	0		0	0	0	\N	0	113	40213227		
15375	1283	1367571	1972-04-22	1972-04-22 00:00:00	1972-04-22	1972-04-22 00:00:00	1972-04-22	38000177		0	0	0		0	0	0	84823	0	314659	19080464		
7703	165	40213160	1973-05-23	1973-05-23 00:00:00	1973-05-23	1973-05-23 00:00:00	1973-05-23	581452		0	0	0		0	0	0	11338	0	10	40213160		
3425	283	1713671	2004-03-06	2004-03-06 00:00:00	2004-03-13	2004-03-13 00:00:00	2004-03-13	38000177		0	0	7		0	0	0	18830	0	562251	1713671		
125018	2750	40213201	1989-07-19	1989-07-19 00:00:00	1989-07-19	1989-07-19 00:00:00	1989-07-19	581452		0	0	0		0	0	0	181864	0	33	40213201		
39721	3285	19059056	1964-05-17	1964-05-17 00:00:00	1964-06-14	1964-06-14 00:00:00	1964-06-14	38000177		0	0	28		0	0	0	218177	0	243670	19059056		
31413	2603	19133905	1988-10-12	1988-10-12 00:00:00	1988-10-22	1988-10-22 00:00:00	1988-10-22	38000177		0	0	10		0	0	0	172224	0	834102	19133905		
197900	4348	40213227	2013-07-31	2013-07-31 00:00:00	2013-07-31	2013-07-31 00:00:00	2013-07-31	581452		0	0	0		0	0	0	288372	0	113	40213227		
118939	2616	40213260	2006-04-25	2006-04-25 00:00:00	2006-04-25	2006-04-25 00:00:00	2006-04-25	581452		0	0	0		0	0	0	173006	0	121	40213260		
84308	1844	40213296	2001-11-06	2001-11-06 00:00:00	2001-11-06	2001-11-06 00:00:00	2001-11-06	581452		0	0	0		0	0	0	123168	0	52	40213296		
86809	1903	40213160	1962-09-25	1962-09-25 00:00:00	1962-09-25	1962-09-25 00:00:00	1962-09-25	581452		0	0	0		0	0	0	126682	0	10	40213160		
160917	3541	40213160	1968-04-15	1968-04-15 00:00:00	1968-04-15	1968-04-15 00:00:00	1968-04-15	581452		0	0	0		0	0	0	235197	0	10	40213160		
46556	1017	40213227	1993-05-16	1993-05-16 00:00:00	1993-05-16	1993-05-16 00:00:00	1993-05-16	581452		0	0	0		0	0	0	66973	0	113	40213227		
17361	1438	1127433	1975-04-17	1975-04-17 00:00:00	1975-05-01	1975-05-01 00:00:00	1975-05-01	38000177		0	0	14		0	0	0	95849	0	313782	1127433		
61048	5077	1127078	1973-10-31	1973-10-31 00:00:00	1973-11-14	1973-11-14 00:00:00	1973-11-14	38000177		0	0	14		0	0	0	337488	0	282464	1127078		
134489	2951	40213160	1959-07-26	1959-07-26 00:00:00	1959-07-26	1959-07-26 00:00:00	1959-07-26	581452		0	0	0		0	0	0	197061	0	10	40213160		
222624	4886	40213160	1970-08-17	1970-08-17 00:00:00	1970-08-17	1970-08-17 00:00:00	1970-08-17	581452		0	0	0		0	0	0	324900	0	10	40213160		
49833	4134	1124300	1988-11-15	1988-11-15 00:00:00	1988-11-15	1988-11-15 00:00:00	\N	38000177		0	0	0		0	0	0	274901	0	00781178901	45011828		
55021	4570	1127433	1997-05-31	1997-05-31 00:00:00	1997-06-07	1997-06-07 00:00:00	1997-06-07	38000177		0	0	7		0	0	0	304464	0	313782	1127433		
201639	4428	40213160	1955-11-10	1955-11-10 00:00:00	1955-11-10	1955-11-10 00:00:00	1955-11-10	581452		0	0	0		0	0	0	294373	0	10	40213160		
50826	4223	1127433	1973-02-27	1973-02-27 00:00:00	1973-03-06	1973-03-06 00:00:00	1973-03-06	38000177		0	0	7		0	0	0	280392	0	313782	1127433		
69527	1520	40213227	2017-12-24	2017-12-24 00:00:00	2017-12-24	2017-12-24 00:00:00	2017-12-24	581452		0	0	0		0	0	0	101666	0	113	40213227		
213315	4677	40213160	1958-03-21	1958-03-21 00:00:00	1958-03-21	1958-03-21 00:00:00	1958-03-21	581452		0	0	0		0	0	0	311658	0	10	40213160		
232804	5116	40213296	2006-05-12	2006-05-12 00:00:00	2006-05-12	2006-05-12 00:00:00	2006-05-12	581452		0	0	0		0	0	0	339927	0	52	40213296		
183867	4040	40213160	1976-05-17	1976-05-17 00:00:00	1976-05-17	1976-05-17 00:00:00	1976-05-17	581452		0	0	0		0	0	0	268674	0	10	40213160		
81986	1791	40213160	1955-08-04	1955-08-04 00:00:00	1955-08-04	1955-08-04 00:00:00	1955-08-04	581452		0	0	0		0	0	0	120017	0	10	40213160		
224521	4929	40213160	1962-05-26	1962-05-26 00:00:00	1962-05-26	1962-05-26 00:00:00	1962-05-26	581452		0	0	0		0	0	0	327691	0	10	40213160		
126268	2777	40213160	1960-09-09	1960-09-09 00:00:00	1960-09-09	1960-09-09 00:00:00	1960-09-09	581452		0	0	0		0	0	0	183972	0	10	40213160		
50968	1116	40213260	2015-12-11	2015-12-11 00:00:00	2015-12-11	2015-12-11 00:00:00	2015-12-11	581452		0	0	0		0	0	0	73547	0	121	40213260		
194307	4269	40213160	1968-08-07	1968-08-07 00:00:00	1968-08-07	1968-08-07 00:00:00	1968-08-07	581452		0	0	0		0	0	0	283359	0	10	40213160		
2576	57	40213306	1983-12-12	1983-12-12 00:00:00	1983-12-12	1983-12-12 00:00:00	1983-12-12	581452		0	0	0		0	0	0	3883	0	43	40213306		
116048	2550	40213160	1987-12-20	1987-12-20 00:00:00	1987-12-20	1987-12-20 00:00:00	1987-12-20	581452		0	0	0		0	0	0	168814	0	10	40213160		
12805	1077	1118084	1979-11-26	1979-11-26 00:00:00	1979-11-26	1979-11-26 00:00:00	\N	38000177		0	0	0		0	0	0	70590	0	00025152531	44923712		
156990	3454	40213251	1984-05-14	1984-05-14 00:00:00	1984-05-14	1984-05-14 00:00:00	1984-05-14	581452		0	0	0		0	0	0	229156	0	21	40213251		
22533	1851	19115351	1991-01-03	1991-01-03 00:00:00	1991-05-23	1991-05-23 00:00:00	1991-05-23	38000177		0	0	140		0	0	0	123845	0	563026	19115351		
19212	1586	1539411	1991-09-01	1991-09-01 00:00:00	1991-09-01	1991-09-01 00:00:00	\N	38000177		0	0	0		0	0	0	106422	0	312961	1539411		
13324	1117	1127433	2002-06-30	2002-06-30 00:00:00	2002-07-07	2002-07-07 00:00:00	2002-07-07	38000177		0	0	7		0	0	0	73566	0	313782	1127433		
216764	4756	40213198	2010-10-16	2010-10-16 00:00:00	2010-10-16	2010-10-16 00:00:00	2010-10-16	581452		0	0	0		0	0	0	316852	0	133	40213198		
50686	4212	1127433	1984-01-14	1984-01-14 00:00:00	1984-03-14	1984-03-14 00:00:00	1984-03-14	38000177		0	0	60		0	0	0	279652	0	313782	1127433		
5065	422	920334	1984-03-25	1984-03-25 00:00:00	1984-04-01	1984-04-01 00:00:00	1984-04-01	38000177		0	0	7		0	0	0	27908	0	311995	920334		
67906	1486	40213160	1960-04-24	1960-04-24 00:00:00	1960-04-24	1960-04-24 00:00:00	1960-04-24	581452		0	0	0		0	0	0	99106	0	10	40213160		
106712	2340	40213227	1993-05-20	1993-05-20 00:00:00	1993-05-20	1993-05-20 00:00:00	1993-05-20	581452		0	0	0		0	0	0	155715	0	113	40213227		
61328	5101	1127433	1991-02-20	1991-02-20 00:00:00	1991-03-20	1991-03-20 00:00:00	1991-03-20	38000177		0	0	28		0	0	0	338975	0	313782	1127433		
53853	4476	1310034	1975-05-04	1975-05-04 00:00:00	1975-05-04	1975-05-04 00:00:00	1975-05-04	38000177		0	0	0		0	0	0	297897	0	834357	1310034		
133825	2939	40213227	1994-11-01	1994-11-01 00:00:00	1994-11-01	1994-11-01 00:00:00	1994-11-01	581452		0	0	0		0	0	0	195991	0	113	40213227		
9897	829	19133873	1983-05-19	1983-05-19 00:00:00	1983-05-31	1983-05-31 00:00:00	1983-05-31	38000177		0	0	12		0	0	0	54878	0	834061	19133873		
188535	4139	40213227	1993-01-08	1993-01-08 00:00:00	1993-01-08	1993-01-08 00:00:00	1993-01-08	581452		0	0	0		0	0	0	275125	0	113	40213227		
155564	3423	40213160	1974-08-29	1974-08-29 00:00:00	1974-08-29	1974-08-29 00:00:00	1974-08-29	581452		0	0	0		0	0	0	227067	0	10	40213160		
25660	559	40213306	1989-02-06	1989-02-06 00:00:00	1989-02-06	1989-02-06 00:00:00	1989-02-06	581452		0	0	0		0	0	0	37087	0	43	40213306		
149051	3278	40213296	2000-04-24	2000-04-24 00:00:00	2000-04-24	2000-04-24 00:00:00	2000-04-24	581452		0	0	0		0	0	0	217776	0	52	40213296		
20555	1691	1713671	2000-10-14	2000-10-14 00:00:00	2000-11-04	2000-11-04 00:00:00	2000-11-04	38000177		0	0	21		0	0	0	113225	0	562251	1713671		
31074	2576	1127433	2002-12-09	2002-12-09 00:00:00	2002-12-16	2002-12-16 00:00:00	2002-12-16	38000177		0	0	7		0	0	0	170540	0	313782	1127433		
160435	3530	40213160	1960-01-01	1960-01-01 00:00:00	1960-01-01	1960-01-01 00:00:00	1960-01-01	581452		0	0	0		0	0	0	234481	0	10	40213160		
11209	933	19059056	1986-11-15	1986-11-15 00:00:00	1986-12-13	1986-12-13 00:00:00	1986-12-13	38000177		0	0	28		0	0	0	62059	0	243670	19059056		
109489	2404	40213227	1998-05-03	1998-05-03 00:00:00	1998-05-03	1998-05-03 00:00:00	1998-05-03	581452		0	0	0		0	0	0	159737	0	113	40213227		
62842	5222	19059056	1919-03-11	1919-03-11 00:00:00	1919-03-25	1919-03-25 00:00:00	1919-03-25	38000177		0	0	14		0	0	0	347504	0	243670	19059056		
46819	1022	40213160	1964-09-08	1964-09-08 00:00:00	1964-09-08	1964-09-08 00:00:00	1964-09-08	581452		0	0	0		0	0	0	67226	0	10	40213160		
15940	343	40213227	1992-05-16	1992-05-16 00:00:00	1992-05-16	1992-05-16 00:00:00	1992-05-16	581452		0	0	0		0	0	0	22980	0	113	40213227		
52410	1146	40213160	1959-04-23	1959-04-23 00:00:00	1959-04-23	1959-04-23 00:00:00	1959-04-23	581452		0	0	0		0	0	0	75724	0	10	40213160		
179679	3950	40213227	1993-05-06	1993-05-06 00:00:00	1993-05-06	1993-05-06 00:00:00	1993-05-06	581452		0	0	0		0	0	0	262558	0	113	40213227		
165407	3636	40213306	1993-11-26	1993-11-26 00:00:00	1993-11-26	1993-11-26 00:00:00	1993-11-26	581452		0	0	0		0	0	0	\N	0	43	40213306		
15376	1283	19078924	1972-04-22	1972-04-22 00:00:00	1972-04-22	1972-04-22 00:00:00	1972-04-22	38000177		0	0	0		0	0	0	84823	0	311700	19078924		
7707	165	40213160	1968-11-20	1968-11-20 00:00:00	1968-11-20	1968-11-20 00:00:00	1968-11-20	581452		0	0	0		0	0	0	11334	0	10	40213160		
3431	285	1127433	2010-06-15	2010-06-15 00:00:00	2010-07-20	2010-07-20 00:00:00	2010-07-20	38000177		0	0	35		0	0	0	19036	0	313782	1127433		
125027	2750	40213227	1994-08-17	1994-08-17 00:00:00	1994-08-17	1994-08-17 00:00:00	1994-08-17	581452		0	0	0		0	0	0	181867	0	113	40213227		
39722	3285	19133873	1963-01-26	1963-01-26 00:00:00	1963-02-04	1963-02-04 00:00:00	1963-02-04	38000177		0	0	9		0	0	0	218170	0	834061	19133873		
31415	2603	1118084	1996-09-03	1996-09-03 00:00:00	1996-09-03	1996-09-03 00:00:00	\N	38000177		0	0	0		0	0	0	172194	0	00025152531	44923712		
197901	4348	40213251	1984-02-22	1984-02-22 00:00:00	1984-02-22	1984-02-22 00:00:00	1984-02-22	581452		0	0	0		0	0	0	288334	0	21	40213251		
19251	419	40213227	1993-04-18	1993-04-18 00:00:00	1993-04-18	1993-04-18 00:00:00	1993-04-18	581452		0	0	0		0	0	0	27806	0	113	40213227		
173861	3822	40213227	1996-01-08	1996-01-08 00:00:00	1996-01-08	1996-01-08 00:00:00	1996-01-08	581452		0	0	0		0	0	0	253823	0	113	40213227		
86811	1903	40213306	1985-01-08	1985-01-08 00:00:00	1985-01-08	1985-01-08 00:00:00	1985-01-08	581452		0	0	0		0	0	0	126676	0	43	40213306		
172201	3786	40213260	2009-09-01	2009-09-01 00:00:00	2009-09-01	2009-09-01 00:00:00	2009-09-01	581452		0	0	0		0	0	0	251695	0	121	40213260		
46559	1017	40213296	1998-06-21	1998-06-21 00:00:00	1998-06-21	1998-06-21 00:00:00	1998-06-21	581452		0	0	0		0	0	0	66998	0	52	40213296		
17363	1438	1127433	1955-04-21	1955-04-21 00:00:00	1955-04-28	1955-04-28 00:00:00	1955-04-28	38000177		0	0	7		0	0	0	95777	0	313782	1127433		
61049	5077	1124300	2002-10-29	2002-10-29 00:00:00	2002-10-29	2002-10-29 00:00:00	\N	38000177		0	0	0		0	0	0	337438	0	00781178901	45011828		
17424	376	40213227	1993-01-14	1993-01-14 00:00:00	1993-01-14	1993-01-14 00:00:00	1993-01-14	581452		0	0	0		0	0	0	24949	0	113	40213227		
170382	3746	40213227	2005-01-27	2005-01-27 00:00:00	2005-01-27	2005-01-27 00:00:00	2005-01-27	581452		0	0	0		0	0	0	249018	0	113	40213227		
49834	4134	1127078	1956-07-15	1956-07-15 00:00:00	1956-07-29	1956-07-29 00:00:00	1956-07-29	38000177		0	0	14		0	0	0	274819	0	282464	1127078		
55022	4570	19133905	2002-11-09	2002-11-09 00:00:00	2002-11-22	2002-11-22 00:00:00	2002-11-22	38000177		0	0	13		0	0	0	304458	0	834102	19133905		
201878	4432	40213160	1962-06-05	1962-06-05 00:00:00	1962-06-05	1962-06-05 00:00:00	1962-06-05	581452		0	0	0		0	0	0	294602	0	10	40213160		
50827	4223	1127433	1976-11-19	1976-11-19 00:00:00	1976-11-26	1976-11-26 00:00:00	1976-11-26	38000177		0	0	7		0	0	0	280359	0	313782	1127433		
69542	1520	40213227	2007-10-28	2007-10-28 00:00:00	2007-10-28	2007-10-28 00:00:00	2007-10-28	581452		0	0	0		0	0	0	101647	0	113	40213227		
213319	4677	40213296	2001-01-12	2001-01-12 00:00:00	2001-01-12	2001-01-12 00:00:00	2001-01-12	581452		0	0	0		0	0	0	311692	0	52	40213296		
232808	5116	40213260	2014-05-30	2014-05-30 00:00:00	2014-05-30	2014-05-30 00:00:00	2014-05-30	581452		0	0	0		0	0	0	339928	0	121	40213260		
183869	4040	40213314	1977-01-17	1977-01-17 00:00:00	1977-01-17	1977-01-17 00:00:00	1977-01-17	581452		0	0	0		0	0	0	268687	0	49	40213314		
81987	1791	40213260	2006-07-20	2006-07-20 00:00:00	2006-07-20	2006-07-20 00:00:00	2006-07-20	581452		0	0	0		0	0	0	120080	0	121	40213260		
234234	5146	40213227	2007-10-08	2007-10-08 00:00:00	2007-10-08	2007-10-08 00:00:00	2007-10-08	581452		0	0	0		0	0	0	342123	0	113	40213227		
126273	2778	40213160	1981-10-03	1981-10-03 00:00:00	1981-10-03	1981-10-03 00:00:00	1981-10-03	581452		0	0	0		0	0	0	184058	0	10	40213160		
50978	1116	40213227	2017-08-04	2017-08-04 00:00:00	2017-08-04	2017-08-04 00:00:00	2017-08-04	581452		0	0	0		0	0	0	73507	0	113	40213227		
194310	4269	40213227	2019-05-08	2019-05-08 00:00:00	2019-05-08	2019-05-08 00:00:00	2019-05-08	581452		0	0	0		0	0	0	283321	0	113	40213227		
2580	57	40213160	1966-05-30	1966-05-30 00:00:00	1966-05-30	1966-05-30 00:00:00	1966-05-30	581452		0	0	0		0	0	0	3860	0	10	40213160		
116050	2550	40213251	1987-12-20	1987-12-20 00:00:00	1987-12-20	1987-12-20 00:00:00	1987-12-20	581452		0	0	0		0	0	0	168814	0	21	40213251		
12806	1077	19078461	2007-05-03	2007-05-03 00:00:00	2007-05-17	2007-05-17 00:00:00	2007-05-17	38000177		0	0	14		0	0	0	70604	0	310965	19078461		
156997	3455	40213296	2013-04-22	2013-04-22 00:00:00	2013-04-22	2013-04-22 00:00:00	2013-04-22	581452		0	0	0		0	0	0	229200	0	52	40213296		
22534	1851	19115351	1994-01-20	1994-01-20 00:00:00	1994-01-20	1994-01-20 00:00:00	\N	38000177		0	0	0		0	0	0	123852	0	563026	19115351		
19214	1586	1127433	2008-07-03	2008-07-03 00:00:00	2008-09-01	2008-09-01 00:00:00	2008-09-01	38000177		0	0	60		0	0	0	106390	0	313782	1127433		
13325	1117	1127433	1974-05-03	1974-05-03 00:00:00	1974-05-10	1974-05-10 00:00:00	1974-05-10	38000177		0	0	7		0	0	0	73569	0	313782	1127433		
115351	2535	40213306	1983-03-06	1983-03-06 00:00:00	1983-03-06	1983-03-06 00:00:00	1983-03-06	581452		0	0	0		0	0	0	167506	0	43	40213306		
50687	4212	19133873	1977-01-23	1977-01-23 00:00:00	1977-02-01	1977-02-01 00:00:00	1977-02-01	38000177		0	0	9		0	0	0	279680	0	834061	19133873		
5066	422	19128065	1974-01-01	1974-01-01 00:00:00	1974-12-27	1974-12-27 00:00:00	1974-12-27	38000177		0	0	360		0	0	0	27955	0	749882	19128065		
229741	5049	40213260	2013-02-06	2013-02-06 00:00:00	2013-02-06	2013-02-06 00:00:00	2013-02-06	581452		0	0	0		0	0	0	335617	0	121	40213260		
106713	2340	40213160	1959-08-13	1959-08-13 00:00:00	1959-08-13	1959-08-13 00:00:00	1959-08-13	581452		0	0	0		0	0	0	155733	0	10	40213160		
61329	5101	1127433	2002-12-17	2002-12-17 00:00:00	2003-01-16	2003-01-16 00:00:00	2003-01-16	38000177		0	0	30		0	0	0	338977	0	313782	1127433		
53854	4476	1127433	2001-12-25	2001-12-25 00:00:00	2002-01-15	2002-01-15 00:00:00	2002-01-15	38000177		0	0	21		0	0	0	297899	0	313782	1127433		
133831	2939	40213260	2006-06-27	2006-06-27 00:00:00	2006-06-27	2006-06-27 00:00:00	2006-06-27	581452		0	0	0		0	0	0	195967	0	121	40213260		
9898	829	19128022	1991-05-28	1991-05-28 00:00:00	1992-05-22	1992-05-22 00:00:00	1992-05-22	38000177		0	0	360		0	0	0	54881	0	749785	19128022		
169623	3730	40213160	1955-03-10	1955-03-10 00:00:00	1955-03-10	1955-03-10 00:00:00	1955-03-10	581452		0	0	0		0	0	0	247813	0	10	40213160		
155573	3423	40213227	2005-05-19	2005-05-19 00:00:00	2005-05-19	2005-05-19 00:00:00	2005-05-19	581452		0	0	0		0	0	0	227074	0	113	40213227		
25664	559	40213260	2018-10-22	2018-10-22 00:00:00	2018-10-22	2018-10-22 00:00:00	2018-10-22	581452		0	0	0		0	0	0	37049	0	121	40213260		
149052	3278	40213160	1960-09-26	1960-09-26 00:00:00	1960-09-26	1960-09-26 00:00:00	1960-09-26	581452		0	0	0		0	0	0	217789	0	10	40213160		
20557	1691	19078461	1977-06-25	1977-06-25 00:00:00	1977-08-24	1977-08-24 00:00:00	1977-08-24	38000177		0	0	60		0	0	0	113253	0	310965	19078461		
31075	2576	1115171	2015-04-24	2015-04-24 00:00:00	2015-05-15	2015-05-15 00:00:00	2015-05-15	38000177		0	0	21		0	0	0	170549	0	849574	1115171		
160438	3531	40213227	1999-06-23	1999-06-23 00:00:00	1999-06-23	1999-06-23 00:00:00	1999-06-23	581452		0	0	0		0	0	0	234537	0	113	40213227		
11210	933	19019979	1977-08-18	1977-08-18 00:00:00	1977-09-01	1977-09-01 00:00:00	1977-09-01	38000177		0	0	14		0	0	0	62064	0	198405	19019979		
109498	2404	40213306	1987-05-24	1987-05-24 00:00:00	1987-05-24	1987-05-24 00:00:00	1987-05-24	581452		0	0	0		0	0	0	159746	0	43	40213306		
62843	5222	1127433	1924-01-15	1924-01-15 00:00:00	1924-01-22	1924-01-22 00:00:00	1924-01-22	38000177		0	0	7		0	0	0	347362	0	313782	1127433		
142592	3133	40213227	1998-03-04	1998-03-04 00:00:00	1998-03-04	1998-03-04 00:00:00	1998-03-04	581452		0	0	0		0	0	0	208452	0	113	40213227		
15941	343	40213306	1992-05-16	1992-05-16 00:00:00	1992-05-16	1992-05-16 00:00:00	1992-05-16	581452		0	0	0		0	0	0	22980	0	43	40213306		
52418	1146	40213306	1981-11-26	1981-11-26 00:00:00	1981-11-26	1981-11-26 00:00:00	1981-11-26	581452		0	0	0		0	0	0	75685	0	43	40213306		
179680	3950	40213306	1993-05-06	1993-05-06 00:00:00	1993-05-06	1993-05-06 00:00:00	1993-05-06	581452		0	0	0		0	0	0	262558	0	43	40213306		
52986	1159	40213160	1981-04-04	1981-04-04 00:00:00	1981-04-04	1981-04-04 00:00:00	1981-04-04	581452		0	0	0		0	0	0	76545	0	10	40213160		
15377	1283	40220386	1972-04-22	1972-04-22 00:00:00	1972-04-22	1972-04-22 00:00:00	1972-04-22	38000177		0	0	0		0	0	0	84823	0	1808217	40220386		
7709	165	40213296	2008-06-18	2008-06-18 00:00:00	2008-06-18	2008-06-18 00:00:00	2008-06-18	581452		0	0	0		0	0	0	11347	0	52	40213296		
3432	285	1127433	1982-09-19	1982-09-19 00:00:00	1982-10-10	1982-10-10 00:00:00	1982-10-10	38000177		0	0	21		0	0	0	19035	0	313782	1127433		
216412	4749	40213296	2012-10-27	2012-10-27 00:00:00	2012-10-27	2012-10-27 00:00:00	2012-10-27	581452		0	0	0		0	0	0	316280	0	52	40213296		
39723	3285	1124300	1997-11-25	1997-11-25 00:00:00	1997-11-25	1997-11-25 00:00:00	\N	38000177		0	0	0		0	0	0	218221	0	00781178901	45011828		
31416	2603	19128065	1979-04-26	1979-04-26 00:00:00	1980-04-20	1980-04-20 00:00:00	1980-04-20	38000177		0	0	360		0	0	0	172199	0	749882	19128065		
197906	4348	40213160	1982-01-27	1982-01-27 00:00:00	1982-01-27	1982-01-27 00:00:00	1982-01-27	581452		0	0	0		0	0	0	288361	0	10	40213160		
83017	1814	40213227	2012-02-11	2012-02-11 00:00:00	2012-02-11	2012-02-11 00:00:00	2012-02-11	581452		0	0	0		0	0	0	121373	0	113	40213227		
173867	3823	40213160	1955-06-22	1955-06-22 00:00:00	1955-06-22	1955-06-22 00:00:00	1955-06-22	581452		0	0	0		0	0	0	253937	0	10	40213160		
86814	1903	40213160	1963-02-26	1963-02-26 00:00:00	1963-02-26	1963-02-26 00:00:00	1963-02-26	581452		0	0	0		0	0	0	126683	0	10	40213160		
172202	3786	40213160	1959-03-17	1959-03-17 00:00:00	1959-03-17	1959-03-17 00:00:00	1959-03-17	581452		0	0	0		0	0	0	251719	0	10	40213160		
46561	1017	40213160	1958-11-23	1958-11-23 00:00:00	1958-11-23	1958-11-23 00:00:00	1958-11-23	581452		0	0	0		0	0	0	66940	0	10	40213160		
17364	1438	1127433	1980-09-01	1980-09-01 00:00:00	1980-09-22	1980-09-22 00:00:00	1980-09-22	38000177		0	0	21		0	0	0	95850	0	313782	1127433		
61050	5078	19075001	1983-06-12	1983-06-12 00:00:00	1983-06-22	1983-06-22 00:00:00	1983-06-22	38000177		0	0	10		0	0	0	337581	0	309097	19075001		
17426	376	40213160	1966-04-07	1966-04-07 00:00:00	1966-04-07	1966-04-07 00:00:00	1966-04-07	581452		0	0	0		0	0	0	24879	0	10	40213160		
170393	3746	40213201	2010-02-25	2010-02-25 00:00:00	2010-02-25	2010-02-25 00:00:00	2010-02-25	581452		0	0	0		0	0	0	249061	0	33	40213201		
49835	4134	1713671	1980-07-11	1980-07-11 00:00:00	1980-08-01	1980-08-01 00:00:00	1980-08-01	38000177		0	0	21		0	0	0	274831	0	562251	1713671		
55023	4570	19059056	1941-03-21	1941-03-21 00:00:00	1941-04-04	1941-04-04 00:00:00	1941-04-04	38000177		0	0	14		0	0	0	304431	0	243670	19059056		
212433	4657	40213160	1961-06-16	1961-06-16 00:00:00	1961-06-16	1961-06-16 00:00:00	1961-06-16	581452		0	0	0		0	0	0	310521	0	10	40213160		
50828	4223	1127433	1966-07-08	1966-07-08 00:00:00	1966-07-15	1966-07-15 00:00:00	1966-07-15	38000177		0	0	7		0	0	0	280391	0	313782	1127433		
189688	4165	40213227	1993-02-21	1993-02-21 00:00:00	1993-02-21	1993-02-21 00:00:00	1993-02-21	581452		0	0	0		0	0	0	276752	0	113	40213227		
213324	4677	40213260	2008-02-01	2008-02-01 00:00:00	2008-02-01	2008-02-01 00:00:00	2008-02-01	581452		0	0	0		0	0	0	311719	0	121	40213260		
232826	5116	40213160	1964-11-05	1964-11-05 00:00:00	1964-11-05	1964-11-05 00:00:00	1964-11-05	581452		0	0	0		0	0	0	339945	0	10	40213160		
183877	4040	40213160	1980-12-08	1980-12-08 00:00:00	1980-12-08	1980-12-08 00:00:00	1980-12-08	581452		0	0	0		0	0	0	268698	0	10	40213160		
81989	1791	40213227	2006-07-20	2006-07-20 00:00:00	2006-07-20	2006-07-20 00:00:00	2006-07-20	581452		0	0	0		0	0	0	120080	0	113	40213227		
234244	5146	40213201	2013-06-10	2013-06-10 00:00:00	2013-06-10	2013-06-10 00:00:00	2013-06-10	581452		0	0	0		0	0	0	342126	0	33	40213201		
126275	2778	40213160	1977-07-02	1977-07-02 00:00:00	1977-07-02	1977-07-02 00:00:00	1977-07-02	581452		0	0	0		0	0	0	184071	0	10	40213160		
168904	3714	40213201	1989-08-09	1989-08-09 00:00:00	1989-08-09	1989-08-09 00:00:00	1989-08-09	581452		0	0	0		0	0	0	246869	0	33	40213201		
194311	4269	40213260	2019-05-08	2019-05-08 00:00:00	2019-05-08	2019-05-08 00:00:00	2019-05-08	581452		0	0	0		0	0	0	283321	0	121	40213260		
2582	57	40213260	2012-04-02	2012-04-02 00:00:00	2012-04-02	2012-04-02 00:00:00	2012-04-02	581452		0	0	0		0	0	0	3827	0	121	40213260		
116052	2550	40213314	1983-04-24	1983-04-24 00:00:00	1983-04-24	1983-04-24 00:00:00	1983-04-24	581452		0	0	0		0	0	0	168796	0	49	40213314		
2663	212	1127433	1980-08-27	1980-08-27 00:00:00	1980-09-03	1980-09-03 00:00:00	1980-09-03	38000177		0	0	7		0	0	0	14466	0	313782	1127433		
157004	3455	40213227	2011-04-18	2011-04-18 00:00:00	2011-04-18	2011-04-18 00:00:00	2011-04-18	581452		0	0	0		0	0	0	229231	0	113	40213227		
22535	1851	19075601	2017-12-28	2017-12-28 00:00:00	2017-12-28	2017-12-28 00:00:00	2017-12-28	38000177		0	0	0		0	0	0	123857	0	309362	19075601		
19215	1586	1332419	1994-09-18	1994-09-18 00:00:00	1994-09-18	1994-09-18 00:00:00	\N	38000177		0	0	0		0	0	0	106455	0	197361	1332419		
13326	1117	19059056	1936-09-18	1936-09-18 00:00:00	1936-10-02	1936-10-02 00:00:00	1936-10-02	38000177		0	0	14		0	0	0	73574	0	243670	19059056		
115357	2535	40213160	1961-04-09	1961-04-09 00:00:00	1961-04-09	1961-04-09 00:00:00	1961-04-09	581452		0	0	0		0	0	0	167499	0	10	40213160		
50688	4212	40229134	1995-01-28	1995-01-28 00:00:00	1995-02-11	1995-02-11 00:00:00	1995-02-11	38000177		0	0	14		0	0	0	279653	0	1043400	40229134		
5067	422	920300	1982-01-31	1982-01-31 00:00:00	1982-02-07	1982-02-07 00:00:00	1982-02-07	38000177		0	0	7		0	0	0	27953	0	311989	920300		
229743	5049	40213227	2013-02-06	2013-02-06 00:00:00	2013-02-06	2013-02-06 00:00:00	2013-02-06	581452		0	0	0		0	0	0	335617	0	113	40213227		
106722	2340	40213260	2009-03-04	2009-03-04 00:00:00	2009-03-04	2009-03-04 00:00:00	2009-03-04	581452		0	0	0		0	0	0	155719	0	121	40213260		
61330	5101	40165015	2002-12-17	2002-12-17 00:00:00	2002-12-17	2002-12-17 00:00:00	\N	38000177		0	0	0		0	0	0	338977	0	861467	40165015		
53855	4476	1551192	1972-12-22	1972-12-22 00:00:00	1972-12-22	1972-12-22 00:00:00	1972-12-22	38000177		0	0	0		0	0	0	297896	0	312617	1551192		
133843	2939	40213160	1957-12-31	1957-12-31 00:00:00	1957-12-31	1957-12-31 00:00:00	1957-12-31	581452		0	0	0		0	0	0	195960	0	10	40213160		
9899	829	40229134	1977-01-28	1977-01-28 00:00:00	1977-02-04	1977-02-04 00:00:00	1977-02-04	38000177		0	0	7		0	0	0	54923	0	1043400	40229134		
169624	3730	40213160	1955-09-08	1955-09-08 00:00:00	1955-09-08	1955-09-08 00:00:00	1955-09-08	581452		0	0	0		0	0	0	247860	0	10	40213160		
155574	3423	40213227	1996-05-09	1996-05-09 00:00:00	1996-05-09	1996-05-09 00:00:00	1996-05-09	581452		0	0	0		0	0	0	227087	0	113	40213227		
25667	559	40213306	1988-11-14	1988-11-14 00:00:00	1988-11-14	1988-11-14 00:00:00	1988-11-14	581452		0	0	0		0	0	0	37086	0	43	40213306		
149054	3278	40213306	1982-06-21	1982-06-21 00:00:00	1982-06-21	1982-06-21 00:00:00	1982-06-21	581452		0	0	0		0	0	0	217767	0	43	40213306		
20558	1691	19059056	1953-01-27	1953-01-27 00:00:00	1953-03-03	1953-03-03 00:00:00	1953-03-03	38000177		0	0	35		0	0	0	113252	0	243670	19059056		
31076	2576	1127433	2017-04-04	2017-04-04 00:00:00	2017-04-18	2017-04-18 00:00:00	2017-04-18	38000177		0	0	14		0	0	0	170550	0	313782	1127433		
160445	3531	40213160	1967-12-06	1967-12-06 00:00:00	1967-12-06	1967-12-06 00:00:00	1967-12-06	581452		0	0	0		0	0	0	234565	0	10	40213160		
11211	933	46233988	1977-08-18	1977-08-18 00:00:00	1977-09-01	1977-09-01 00:00:00	1977-09-01	38000177		0	0	14		0	0	0	62064	0	1652673	46233988		
109500	2404	40213296	2006-05-14	2006-05-14 00:00:00	2006-05-14	2006-05-14 00:00:00	2006-05-14	581452		0	0	0		0	0	0	159732	0	52	40213296		
62844	5222	1713671	1959-12-05	1959-12-05 00:00:00	1959-12-26	1959-12-26 00:00:00	1959-12-26	38000177		0	0	21		0	0	0	347409	0	562251	1713671		
142593	3133	40213296	1998-03-04	1998-03-04 00:00:00	1998-03-04	1998-03-04 00:00:00	1998-03-04	581452		0	0	0		0	0	0	208452	0	52	40213296		
15943	343	40213296	2010-02-06	2010-02-06 00:00:00	2010-02-06	2010-02-06 00:00:00	2010-02-06	581452		0	0	0		0	0	0	22915	0	52	40213296		
52420	1146	40213160	1959-09-24	1959-09-24 00:00:00	1959-09-24	1959-09-24 00:00:00	1959-09-24	581452		0	0	0		0	0	0	75697	0	10	40213160		
179687	3950	40213160	1971-06-10	1971-06-10 00:00:00	1971-06-10	1971-06-10 00:00:00	1971-06-10	581452		0	0	0		0	0	0	262570	0	10	40213160		
18561	1535	19129655	1978-05-03	1978-05-03 00:00:00	1978-05-17	1978-05-17 00:00:00	1978-05-17	38000177		0	0	14		0	0	0	102757	0	789980	19129655		
15378	1283	42707627	1972-04-22	1972-04-22 00:00:00	1972-04-22	1972-04-22 00:00:00	1972-04-22	38000177		0	0	0		0	0	0	84823	0	1234995	42707627		
7716	165	40213306	1990-06-27	1990-06-27 00:00:00	1990-06-27	1990-06-27 00:00:00	1990-06-27	581452		0	0	0		0	0	0	11366	0	43	40213306		
3433	285	1127433	1984-11-09	1984-11-09 00:00:00	1984-11-23	1984-11-23 00:00:00	1984-11-23	38000177		0	0	14		0	0	0	18918	0	313782	1127433		
216415	4749	40213160	1973-01-27	1973-01-27 00:00:00	1973-01-27	1973-01-27 00:00:00	1973-01-27	581452		0	0	0		0	0	0	316262	0	10	40213160		
39724	3285	1127433	1981-04-15	1981-04-15 00:00:00	1981-04-29	1981-04-29 00:00:00	1981-04-29	38000177		0	0	14		0	0	0	218213	0	313782	1127433		
31417	2603	19078461	2012-03-28	2012-03-28 00:00:00	2012-04-18	2012-04-18 00:00:00	2012-04-18	38000177		0	0	21		0	0	0	172169	0	310965	19078461		
197907	4348	40213314	1982-01-27	1982-01-27 00:00:00	1982-01-27	1982-01-27 00:00:00	1982-01-27	581452		0	0	0		0	0	0	288361	0	49	40213314		
83023	1814	40213201	2007-01-13	2007-01-13 00:00:00	2007-01-13	2007-01-13 00:00:00	2007-01-13	581452		0	0	0		0	0	0	121438	0	33	40213201		
173881	3823	40213227	2005-10-19	2005-10-19 00:00:00	2005-10-19	2005-10-19 00:00:00	2005-10-19	581452		0	0	0		0	0	0	253957	0	113	40213227		
98094	2149	40213160	1964-04-18	1964-04-18 00:00:00	1964-04-18	1964-04-18 00:00:00	1964-04-18	581452		0	0	0		0	0	0	143085	0	10	40213160		
242102	5316	40213160	1957-04-29	1957-04-29 00:00:00	1957-04-29	1957-04-29 00:00:00	1957-04-29	581452		0	0	0		0	0	0	353571	0	10	40213160		
46564	1017	40213160	1963-05-26	1963-05-26 00:00:00	1963-05-26	1963-05-26 00:00:00	1963-05-26	581452		0	0	0		0	0	0	66993	0	10	40213160		
17365	1438	1127433	1992-05-18	1992-05-18 00:00:00	1992-05-25	1992-05-25 00:00:00	1992-05-25	38000177		0	0	7		0	0	0	95808	0	313782	1127433		
61051	5078	1127433	1983-05-23	1983-05-23 00:00:00	1983-06-22	1983-06-22 00:00:00	1983-06-22	38000177		0	0	30		0	0	0	337526	0	313782	1127433		
17431	377	40213160	1971-09-30	1971-09-30 00:00:00	1971-09-30	1971-09-30 00:00:00	1971-09-30	581452		0	0	0		0	0	0	25019	0	10	40213160		
170394	3746	40213198	2010-02-25	2010-02-25 00:00:00	2010-02-25	2010-02-25 00:00:00	2010-02-25	581452		0	0	0		0	0	0	249061	0	133	40213198		
49836	4134	1713671	2003-09-22	2003-09-22 00:00:00	2003-10-13	2003-10-13 00:00:00	2003-10-13	38000177		0	0	21		0	0	0	274829	0	562251	1713671		
55024	4570	1713671	1973-03-24	1973-03-24 00:00:00	1973-04-14	1973-04-14 00:00:00	1973-04-14	38000177		0	0	21		0	0	0	304451	0	562251	1713671		
212442	4657	40213306	1982-12-10	1982-12-10 00:00:00	1982-12-10	1982-12-10 00:00:00	1982-12-10	581452		0	0	0		0	0	0	310537	0	43	40213306		
50829	4223	19059056	1960-07-27	1960-07-27 00:00:00	1960-08-10	1960-08-10 00:00:00	1960-08-10	38000177		0	0	14		0	0	0	280361	0	243670	19059056		
189711	4165	40213227	2003-04-20	2003-04-20 00:00:00	2003-04-20	2003-04-20 00:00:00	2003-04-20	581452		0	0	0		0	0	0	276787	0	113	40213227		
213331	4677	40213227	1999-01-08	1999-01-08 00:00:00	1999-01-08	1999-01-08 00:00:00	1999-01-08	581452		0	0	0		0	0	0	311708	0	113	40213227		
232830	5116	40213296	2008-05-16	2008-05-16 00:00:00	2008-05-16	2008-05-16 00:00:00	2008-05-16	581452		0	0	0		0	0	0	339937	0	52	40213296		
183879	4040	40213314	1977-07-18	1977-07-18 00:00:00	1977-07-18	1977-07-18 00:00:00	1977-07-18	581452		0	0	0		0	0	0	268676	0	49	40213314		
81991	1791	40213296	1998-07-02	1998-07-02 00:00:00	1998-07-02	1998-07-02 00:00:00	1998-07-02	581452		0	0	0		0	0	0	120079	0	52	40213296		
234248	5146	40213227	1997-08-11	1997-08-11 00:00:00	1997-08-11	1997-08-11 00:00:00	1997-08-11	581452		0	0	0		0	0	0	342091	0	113	40213227		
126279	2778	40213314	1977-12-31	1977-12-31 00:00:00	1977-12-31	1977-12-31 00:00:00	1977-12-31	581452		0	0	0		0	0	0	184055	0	49	40213314		
168924	3714	40213227	2003-10-29	2003-10-29 00:00:00	2003-10-29	2003-10-29 00:00:00	2003-10-29	581452		0	0	0		0	0	0	246874	0	113	40213227		
194313	4269	40213260	2018-05-02	2018-05-02 00:00:00	2018-05-02	2018-05-02 00:00:00	2018-05-02	581452		0	0	0		0	0	0	283339	0	121	40213260		
2588	57	40213227	2003-03-10	2003-03-10 00:00:00	2003-03-10	2003-03-10 00:00:00	2003-03-10	581452		0	0	0		0	0	0	3865	0	113	40213227		
116053	2550	40213160	1983-04-24	1983-04-24 00:00:00	1983-04-24	1983-04-24 00:00:00	1983-04-24	581452		0	0	0		0	0	0	168796	0	10	40213160		
2664	213	19128065	1983-04-17	1983-04-17 00:00:00	1984-04-11	1984-04-11 00:00:00	1984-04-11	38000177		0	0	360		0	0	0	14515	0	749882	19128065		
157005	3455	40213296	2011-04-18	2011-04-18 00:00:00	2011-04-18	2011-04-18 00:00:00	2011-04-18	581452		0	0	0		0	0	0	229231	0	52	40213296		
22536	1851	40220960	2017-12-28	2017-12-28 00:00:00	2017-12-28	2017-12-28 00:00:00	2017-12-28	38000177		0	0	0		0	0	0	123857	0	1804799	40220960		
19216	1586	1127433	1997-02-26	1997-02-26 00:00:00	1997-03-05	1997-03-05 00:00:00	1997-03-05	38000177		0	0	7		0	0	0	106439	0	313782	1127433		
13327	1117	1118084	1978-09-28	1978-09-28 00:00:00	1978-09-28	1978-09-28 00:00:00	\N	38000177		0	0	0		0	0	0	73599	0	00025152531	44923712		
115363	2535	40213227	1992-03-15	1992-03-15 00:00:00	1992-03-15	1992-03-15 00:00:00	1992-03-15	581452		0	0	0		0	0	0	167490	0	113	40213227		
50689	4212	1127078	1981-01-31	1981-01-31 00:00:00	1981-04-01	1981-04-01 00:00:00	1981-04-01	38000177		0	0	60		0	0	0	279650	0	282464	1127078		
5068	422	40236824	1982-01-31	1982-01-31 00:00:00	1982-02-07	1982-02-07 00:00:00	1982-02-07	38000177		0	0	7		0	0	0	27953	0	1094107	40236824		
229746	5049	40213296	2002-02-06	2002-02-06 00:00:00	2002-02-06	2002-02-06 00:00:00	2002-02-06	581452		0	0	0		0	0	0	335572	0	52	40213296		
61289	5099	1127433	2017-02-16	2017-02-16 00:00:00	2017-03-02	2017-03-02 00:00:00	2017-03-02	38000177		0	0	14		0	0	0	338864	0	313782	1127433		
61331	5101	1127433	1971-04-16	1971-04-16 00:00:00	1971-04-30	1971-04-30 00:00:00	1971-04-30	38000177		0	0	14		0	0	0	338992	0	313782	1127433		
53856	4476	19078461	1990-04-06	1990-04-06 00:00:00	1990-04-27	1990-04-27 00:00:00	1990-04-27	38000177		0	0	21		0	0	0	297898	0	310965	19078461		
133846	2939	40213160	1955-06-28	1955-06-28 00:00:00	1955-06-28	1955-06-28 00:00:00	1955-06-28	581452		0	0	0		0	0	0	195980	0	10	40213160		
9900	829	1127078	1980-03-12	1980-03-12 00:00:00	1980-04-16	1980-04-16 00:00:00	1980-04-16	38000177		0	0	35		0	0	0	54906	0	282464	1127078		
169631	3730	40213198	2019-04-18	2019-04-18 00:00:00	2019-04-18	2019-04-18 00:00:00	2019-04-18	581452		0	0	0		0	0	0	247826	0	133	40213198		
155575	3423	40213306	1996-05-09	1996-05-09 00:00:00	1996-05-09	1996-05-09 00:00:00	1996-05-09	581452		0	0	0		0	0	0	227087	0	43	40213306		
25672	559	40213227	2001-02-19	2001-02-19 00:00:00	2001-02-19	2001-02-19 00:00:00	2001-02-19	581452		0	0	0		0	0	0	37063	0	113	40213227		
149059	3278	40213227	2002-04-29	2002-04-29 00:00:00	2002-04-29	2002-04-29 00:00:00	2002-04-29	581452		0	0	0		0	0	0	217808	0	113	40213227		
20559	1691	19059056	1946-01-04	1946-01-04 00:00:00	1946-01-18	1946-01-18 00:00:00	1946-01-18	38000177		0	0	14		0	0	0	113291	0	243670	19059056		
31077	2577	19133873	1976-01-15	1976-01-15 00:00:00	1976-01-23	1976-01-23 00:00:00	1976-01-23	38000177		0	0	8		0	0	0	170619	0	834061	19133873		
160449	3531	40213306	1987-06-10	1987-06-10 00:00:00	1987-06-10	1987-06-10 00:00:00	1987-06-10	581452		0	0	0		0	0	0	234534	0	43	40213306		
11212	933	1127433	1991-08-19	1991-08-19 00:00:00	1991-09-16	1991-09-16 00:00:00	1991-09-16	38000177		0	0	28		0	0	0	62060	0	313782	1127433		
101651	2228	40213160	1955-01-15	1955-01-15 00:00:00	1955-01-15	1955-01-15 00:00:00	1955-01-15	581452		0	0	0		0	0	0	148227	0	10	40213160		
62845	5222	1127433	1928-10-28	1928-10-28 00:00:00	1928-11-11	1928-11-11 00:00:00	1928-11-11	38000177		0	0	14		0	0	0	347384	0	313782	1127433		
142600	3133	40213260	2006-02-22	2006-02-22 00:00:00	2006-02-22	2006-02-22 00:00:00	2006-02-22	581452		0	0	0		0	0	0	208495	0	121	40213260		
15950	343	40213160	1970-07-11	1970-07-11 00:00:00	1970-07-11	1970-07-11 00:00:00	1970-07-11	581452		0	0	0		0	0	0	22957	0	10	40213160		
3631	299	1127433	2011-11-27	2011-11-27 00:00:00	2011-12-04	2011-12-04 00:00:00	2011-12-04	38000177		0	0	7		0	0	0	19993	0	313782	1127433		
179693	3950	40213227	2001-12-20	2001-12-20 00:00:00	2001-12-20	2001-12-20 00:00:00	2001-12-20	581452		0	0	0		0	0	0	\N	0	113	40213227		
18562	1535	19133905	1997-01-22	1997-01-22 00:00:00	1997-01-29	1997-01-29 00:00:00	1997-01-29	38000177		0	0	7		0	0	0	102752	0	834102	19133905		
15379	1283	35605858	1972-04-22	1972-04-22 00:00:00	1972-04-22	1972-04-22 00:00:00	1972-04-22	38000177		0	0	0		0	0	0	84823	0	1732136	35605858		
24490	533	40213227	2004-08-04	2004-08-04 00:00:00	2004-08-04	2004-08-04 00:00:00	2004-08-04	581452		0	0	0		0	0	0	35381	0	113	40213227		
3434	285	1118084	2006-07-30	2006-07-30 00:00:00	2006-07-30	2006-07-30 00:00:00	\N	38000177		0	0	0		0	0	0	19031	0	00025152531	44923712		
216424	4749	40213160	1973-06-30	1973-06-30 00:00:00	1973-06-30	1973-06-30 00:00:00	1973-06-30	581452		0	0	0		0	0	0	316263	0	10	40213160		
39725	3285	1127433	1980-06-04	1980-06-04 00:00:00	1980-06-18	1980-06-18 00:00:00	1980-06-18	38000177		0	0	14		0	0	0	218179	0	313782	1127433		
31418	2603	1127433	1975-05-07	1975-05-07 00:00:00	1975-06-11	1975-06-11 00:00:00	1975-06-11	38000177		0	0	35		0	0	0	172181	0	313782	1127433		
197915	4349	40213160	1983-08-11	1983-08-11 00:00:00	1983-08-11	1983-08-11 00:00:00	1983-08-11	581452		0	0	0		0	0	0	288394	0	10	40213160		
83032	1814	40213227	1992-10-24	1992-10-24 00:00:00	1992-10-24	1992-10-24 00:00:00	1992-10-24	581452		0	0	0		0	0	0	121460	0	113	40213227		
173884	3823	40213227	1996-10-23	1996-10-23 00:00:00	1996-10-23	1996-10-23 00:00:00	1996-10-23	581452		0	0	0		0	0	0	253979	0	113	40213227		
98099	2149	40213160	1959-12-26	1959-12-26 00:00:00	1959-12-26	1959-12-26 00:00:00	1959-12-26	581452		0	0	0		0	0	0	143068	0	10	40213160		
242104	5316	40213260	2006-08-21	2006-08-21 00:00:00	2006-08-21	2006-08-21 00:00:00	2006-08-21	581452		0	0	0		0	0	0	353557	0	121	40213260		
46566	1017	40213227	2009-06-21	2009-06-21 00:00:00	2009-06-21	2009-06-21 00:00:00	2009-06-21	581452		0	0	0		0	0	0	66945	0	113	40213227		
17366	1438	19133905	2009-01-13	2009-01-13 00:00:00	2009-01-21	2009-01-21 00:00:00	2009-01-21	38000177		0	0	8		0	0	0	95830	0	834102	19133905		
61052	5078	1127433	1988-05-31	1988-05-31 00:00:00	1988-06-21	1988-06-21 00:00:00	1988-06-21	38000177		0	0	21		0	0	0	337627	0	313782	1127433		
17434	377	40213160	1967-05-11	1967-05-11 00:00:00	1967-05-11	1967-05-11 00:00:00	1967-05-11	581452		0	0	0		0	0	0	25015	0	10	40213160		
170408	3746	40213227	1995-05-25	1995-05-25 00:00:00	1995-05-25	1995-05-25 00:00:00	1995-05-25	581452		0	0	0		0	0	0	249004	0	113	40213227		
49837	4134	1713671	1976-02-18	1976-02-18 00:00:00	1976-02-25	1976-02-25 00:00:00	1976-02-25	38000177		0	0	7		0	0	0	274845	0	562251	1713671		
55025	4570	1127433	2003-08-10	2003-08-10 00:00:00	2003-09-09	2003-09-09 00:00:00	2003-09-09	38000177		0	0	30		0	0	0	304492	0	313782	1127433		
212446	4657	40213160	1961-03-17	1961-03-17 00:00:00	1961-03-17	1961-03-17 00:00:00	1961-03-17	581452		0	0	0		0	0	0	310555	0	10	40213160		
50830	4223	19133873	1969-11-15	1969-11-15 00:00:00	1969-11-26	1969-11-26 00:00:00	1969-11-26	38000177		0	0	11		0	0	0	280358	0	834061	19133873		
28068	610	40213227	2013-09-05	2013-09-05 00:00:00	2013-09-05	2013-09-05 00:00:00	2013-09-05	581452		0	0	0		0	0	0	40542	0	113	40213227		
202204	4439	40213227	2005-12-14	2005-12-14 00:00:00	2005-12-14	2005-12-14 00:00:00	2005-12-14	581452		0	0	0		0	0	0	295091	0	113	40213227		
232832	5116	40213227	2015-06-05	2015-06-05 00:00:00	2015-06-05	2015-06-05 00:00:00	2015-06-05	581452		0	0	0		0	0	0	339998	0	113	40213227		
183880	4040	40213160	1976-07-19	1976-07-19 00:00:00	1976-07-19	1976-07-19 00:00:00	1976-07-19	581452		0	0	0		0	0	0	268694	0	10	40213160		
82003	1791	40213227	2016-05-05	2016-05-05 00:00:00	2016-05-05	2016-05-05 00:00:00	2016-05-05	581452		0	0	0		0	0	0	120087	0	113	40213227		
198666	4365	40213227	2013-01-27	2013-01-27 00:00:00	2013-01-27	2013-01-27 00:00:00	2013-01-27	581452		0	0	0		0	0	0	289583	0	113	40213227		
126284	2778	40213314	1977-01-29	1977-01-29 00:00:00	1977-01-29	1977-01-29 00:00:00	1977-01-29	581452		0	0	0		0	0	0	184070	0	49	40213314		
168929	3714	40213227	1993-09-01	1993-09-01 00:00:00	1993-09-01	1993-09-01 00:00:00	1993-09-01	581452		0	0	0		0	0	0	246814	0	113	40213227		
185881	4084	40213306	1983-10-30	1983-10-30 00:00:00	1983-10-30	1983-10-30 00:00:00	1983-10-30	581452		0	0	0		0	0	0	271393	0	43	40213306		
2589	57	40213296	2003-03-10	2003-03-10 00:00:00	2003-03-10	2003-03-10 00:00:00	2003-03-10	581452		0	0	0		0	0	0	3865	0	52	40213296		
116054	2550	40213180	2005-10-02	2005-10-02 00:00:00	2005-10-02	2005-10-02 00:00:00	2005-10-02	581452		0	0	0		0	0	0	168805	0	114	40213180		
2665	213	1127433	2004-06-16	2004-06-16 00:00:00	2004-06-23	2004-06-23 00:00:00	2004-06-23	38000177		0	0	7		0	0	0	14524	0	313782	1127433		
157007	3455	40213227	2003-04-07	2003-04-07 00:00:00	2003-04-07	2003-04-07 00:00:00	2003-04-07	581452		0	0	0		0	0	0	229225	0	113	40213227		
22538	1851	40229134	2014-10-12	2014-10-12 00:00:00	2014-10-19	2014-10-19 00:00:00	2014-10-19	38000177		0	0	7		0	0	0	123817	0	1043400	40229134		
19217	1586	1127433	1954-06-21	1954-06-21 00:00:00	1954-07-19	1954-07-19 00:00:00	1954-07-19	38000177		0	0	28		0	0	0	106386	0	313782	1127433		
13328	1117	1127433	1984-05-03	1984-05-03 00:00:00	1984-05-24	1984-05-24 00:00:00	1984-05-24	38000177		0	0	21		0	0	0	73619	0	313782	1127433		
115367	2535	40213227	2012-01-08	2012-01-08 00:00:00	2012-01-08	2012-01-08 00:00:00	2012-01-08	581452		0	0	0		0	0	0	167493	0	113	40213227		
50690	4212	1713671	2013-02-11	2013-02-11 00:00:00	2013-03-04	2013-03-04 00:00:00	2013-03-04	38000177		0	0	21		0	0	0	279665	0	562251	1713671		
5069	422	19059056	1967-01-28	1967-01-28 00:00:00	1967-04-28	1967-04-28 00:00:00	1967-04-28	38000177		0	0	90		0	0	0	27940	0	243670	19059056		
229750	5049	40213160	1962-05-09	1962-05-09 00:00:00	1962-05-09	1962-05-09 00:00:00	1962-05-09	581452		0	0	0		0	0	0	335565	0	10	40213160		
61290	5099	19133905	1972-11-04	1972-11-04 00:00:00	1972-11-16	1972-11-16 00:00:00	1972-11-16	38000177		0	0	12		0	0	0	338838	0	834102	19133905		
61332	5101	1127433	1973-08-23	1973-08-23 00:00:00	1973-09-06	1973-09-06 00:00:00	1973-09-06	38000177		0	0	14		0	0	0	338962	0	313782	1127433		
53857	4476	1127433	1992-05-25	1992-05-25 00:00:00	1992-06-01	1992-06-01 00:00:00	1992-06-01	38000177		0	0	7		0	0	0	297852	0	313782	1127433		
133848	2939	40213160	1956-06-26	1956-06-26 00:00:00	1956-06-26	1956-06-26 00:00:00	1956-06-26	581452		0	0	0		0	0	0	195959	0	10	40213160		
9901	829	19133905	2006-09-13	2006-09-13 00:00:00	2006-09-23	2006-09-23 00:00:00	2006-09-23	38000177		0	0	10		0	0	0	54929	0	834102	19133905		
169633	3730	40213160	1959-03-12	1959-03-12 00:00:00	1959-03-12	1959-03-12 00:00:00	1959-03-12	581452		0	0	0		0	0	0	247838	0	10	40213160		
20421	1679	19133905	2012-06-30	2012-06-30 00:00:00	2012-07-13	2012-07-13 00:00:00	2012-07-13	38000177		0	0	13		0	0	0	112592	0	834102	19133905		
166132	3651	40213306	1981-10-29	1981-10-29 00:00:00	1981-10-29	1981-10-29 00:00:00	1981-10-29	581452		0	0	0		0	0	0	243063	0	43	40213306		
149060	3278	40213296	2002-04-29	2002-04-29 00:00:00	2002-04-29	2002-04-29 00:00:00	2002-04-29	581452		0	0	0		0	0	0	217808	0	52	40213296		
20560	1691	19006318	1946-01-04	1946-01-04 00:00:00	1946-01-18	1946-01-18 00:00:00	1946-01-18	38000177		0	0	14		0	0	0	113291	0	105078	19006318		
31078	2577	19008572	1995-04-22	1995-04-22 00:00:00	1995-05-06	1995-05-06 00:00:00	1995-05-06	38000177		0	0	14		0	0	0	170640	0	106258	19008572		
160457	3531	40213160	1972-03-08	1972-03-08 00:00:00	1972-03-08	1972-03-08 00:00:00	1972-03-08	581452		0	0	0		0	0	0	234549	0	10	40213160		
11213	933	1127078	1974-03-20	1974-03-20 00:00:00	1974-04-03	1974-04-03 00:00:00	1974-04-03	38000177		0	0	14		0	0	0	62074	0	282464	1127078		
101654	2228	40213227	2018-12-15	2018-12-15 00:00:00	2018-12-15	2018-12-15 00:00:00	2018-12-15	581452		0	0	0		0	0	0	148255	0	113	40213227		
62846	5223	1127433	1997-08-01	1997-08-01 00:00:00	1997-08-08	1997-08-08 00:00:00	1997-08-08	38000177		0	0	7		0	0	0	347588	0	313782	1127433		
142604	3133	40213160	1961-02-01	1961-02-01 00:00:00	1961-02-01	1961-02-01 00:00:00	1961-02-01	581452		0	0	0		0	0	0	208463	0	10	40213160		
40795	3382	19059056	1965-12-17	1965-12-17 00:00:00	1966-01-07	1966-01-07 00:00:00	1966-01-07	38000177		0	0	21		0	0	0	224400	0	243670	19059056		
3632	299	19133873	1962-04-09	1962-04-09 00:00:00	1962-04-17	1962-04-17 00:00:00	1962-04-17	38000177		0	0	8		0	0	0	20012	0	834061	19133873		
179697	3950	40213296	2010-10-07	2010-10-07 00:00:00	2010-10-07	2010-10-07 00:00:00	2010-10-07	581452		0	0	0		0	0	0	262574	0	52	40213296		
18563	1535	19133905	1999-10-19	1999-10-19 00:00:00	1999-10-28	1999-10-28 00:00:00	1999-10-28	38000177		0	0	9		0	0	0	102739	0	834102	19133905		
15380	1283	46275444	1972-04-22	1972-04-22 00:00:00	1972-04-22	1972-04-22 00:00:00	1972-04-22	38000177		0	0	0		0	0	0	84823	0	1659149	46275444		
24491	533	40213296	2004-08-04	2004-08-04 00:00:00	2004-08-04	2004-08-04 00:00:00	2004-08-04	581452		0	0	0		0	0	0	35381	0	52	40213296		
3435	285	19133873	1971-08-20	1971-08-20 00:00:00	1971-09-01	1971-09-01 00:00:00	1971-09-01	38000177		0	0	12		0	0	0	19003	0	834061	19133873		
216425	4750	40213306	1985-05-01	1985-05-01 00:00:00	1985-05-01	1985-05-01 00:00:00	1985-05-01	581452		0	0	0		0	0	0	316328	0	43	40213306		
39726	3285	1127433	1996-02-26	1996-02-26 00:00:00	1996-03-11	1996-03-11 00:00:00	1996-03-11	38000177		0	0	14		0	0	0	218231	0	313782	1127433		
31419	2604	1127078	1962-01-08	1962-01-08 00:00:00	1962-01-22	1962-01-22 00:00:00	1962-01-22	38000177		0	0	14		0	0	0	172311	0	282464	1127078		
76848	1679	40213296	2009-10-06	2009-10-06 00:00:00	2009-10-06	2009-10-06 00:00:00	2009-10-06	581452		0	0	0		0	0	0	112619	0	52	40213296		
47308	1032	40213227	2012-11-18	2012-11-18 00:00:00	2012-11-18	2012-11-18 00:00:00	2012-11-18	581452		0	0	0		0	0	0	67890	0	113	40213227		
173885	3823	40213296	1996-10-23	1996-10-23 00:00:00	1996-10-23	1996-10-23 00:00:00	1996-10-23	581452		0	0	0		0	0	0	253979	0	52	40213296		
98104	2149	40213227	2010-04-24	2010-04-24 00:00:00	2010-04-24	2010-04-24 00:00:00	2010-04-24	581452		0	0	0		0	0	0	143142	0	113	40213227		
242106	5316	40213227	2017-09-18	2017-09-18 00:00:00	2017-09-18	2017-09-18 00:00:00	2017-09-18	581452		0	0	0		0	0	0	353564	0	113	40213227		
46567	1017	40213260	2009-06-21	2009-06-21 00:00:00	2009-06-21	2009-06-21 00:00:00	2009-06-21	581452		0	0	0		0	0	0	66945	0	121	40213260		
17367	1438	1127433	1952-04-19	1952-04-19 00:00:00	1952-05-03	1952-05-03 00:00:00	1952-05-03	38000177		0	0	14		0	0	0	95801	0	313782	1127433		
61053	5078	19075601	1997-06-02	1997-06-02 00:00:00	1997-06-02	1997-06-02 00:00:00	\N	38000177		0	0	0		0	0	0	337589	0	309362	19075601		
17446	377	40213296	2010-07-29	2010-07-29 00:00:00	2010-07-29	2010-07-29 00:00:00	2010-07-29	581452		0	0	0		0	0	0	24963	0	52	40213296		
151459	3332	40213227	2011-12-13	2011-12-13 00:00:00	2011-12-13	2011-12-13 00:00:00	2011-12-13	581452		0	0	0		0	0	0	221059	0	113	40213227		
49838	4134	19059056	1960-09-06	1960-09-06 00:00:00	1960-11-05	1960-11-05 00:00:00	1960-11-05	38000177		0	0	60		0	0	0	274821	0	243670	19059056		
55026	4570	1127433	1954-11-20	1954-11-20 00:00:00	1954-12-04	1954-12-04 00:00:00	1954-12-04	38000177		0	0	14		0	0	0	304490	0	313782	1127433		
212450	4657	40213296	2004-01-16	2004-01-16 00:00:00	2004-01-16	2004-01-16 00:00:00	2004-01-16	581452		0	0	0		0	0	0	310545	0	52	40213296		
50831	4223	19006318	1958-08-18	1958-08-18 00:00:00	1958-09-01	1958-09-01 00:00:00	1958-09-01	38000177		0	0	14		0	0	0	280382	0	105078	19006318		
28069	610	40213260	2013-09-05	2013-09-05 00:00:00	2013-09-05	2013-09-05 00:00:00	2013-09-05	581452		0	0	0		0	0	0	40542	0	121	40213260		
232833	5116	40213260	2015-06-05	2015-06-05 00:00:00	2015-06-05	2015-06-05 00:00:00	2015-06-05	581452		0	0	0		0	0	0	339998	0	121	40213260		
183883	4040	40213296	2019-03-18	2019-03-18 00:00:00	2019-03-18	2019-03-18 00:00:00	2019-03-18	581452		0	0	0		0	0	0	268712	0	52	40213296		
82009	1791	40213160	1959-11-05	1959-11-05 00:00:00	1959-11-05	1959-11-05 00:00:00	1959-11-05	581452		0	0	0		0	0	0	120019	0	10	40213160		
198688	4365	40213160	1956-07-02	1956-07-02 00:00:00	1956-07-02	1956-07-02 00:00:00	1956-07-02	581452		0	0	0		0	0	0	289568	0	10	40213160		
126285	2778	40213160	1977-01-29	1977-01-29 00:00:00	1977-01-29	1977-01-29 00:00:00	1977-01-29	581452		0	0	0		0	0	0	184070	0	10	40213160		
185845	4084	40213260	2012-03-25	2012-03-25 00:00:00	2012-03-25	2012-03-25 00:00:00	2012-03-25	581452		0	0	0		0	0	0	271372	0	121	40213260		
185884	4084	40213227	2013-03-31	2013-03-31 00:00:00	2013-03-31	2013-03-31 00:00:00	2013-03-31	581452		0	0	0		0	0	0	271424	0	113	40213227		
63412	1387	40213160	1969-12-09	1969-12-09 00:00:00	1969-12-09	1969-12-09 00:00:00	1969-12-09	581452		0	0	0		0	0	0	92055	0	10	40213160		
116056	2550	40213227	2005-10-02	2005-10-02 00:00:00	2005-10-02	2005-10-02 00:00:00	2005-10-02	581452		0	0	0		0	0	0	168805	0	113	40213227		
2666	213	1713671	2009-06-23	2009-06-23 00:00:00	2009-07-14	2009-07-14 00:00:00	2009-07-14	38000177		0	0	21		0	0	0	14512	0	562251	1713671		
157009	3455	40213160	1974-05-06	1974-05-06 00:00:00	1974-05-06	1974-05-06 00:00:00	1974-05-06	581452		0	0	0		0	0	0	229256	0	10	40213160		
22539	1851	40169281	2012-07-19	2012-07-19 00:00:00	2012-07-19	2012-07-19 00:00:00	\N	38000177		0	0	0		0	0	0	123836	0	896209	40169281		
19218	1586	40229134	2001-10-15	2001-10-15 00:00:00	2001-10-22	2001-10-22 00:00:00	2001-10-22	38000177		0	0	7		0	0	0	106463	0	1043400	40229134		
13329	1117	40229134	1986-07-06	1986-07-06 00:00:00	1986-07-20	1986-07-20 00:00:00	1986-07-20	38000177		0	0	14		0	0	0	73571	0	1043400	40229134		
115368	2535	40213260	2012-01-08	2012-01-08 00:00:00	2012-01-08	2012-01-08 00:00:00	2012-01-08	581452		0	0	0		0	0	0	167493	0	121	40213260		
50691	4212	1127433	1983-10-20	1983-10-20 00:00:00	1983-10-27	1983-10-27 00:00:00	1983-10-27	38000177		0	0	7		0	0	0	279682	0	313782	1127433		
5070	422	19133905	2009-07-02	2009-07-02 00:00:00	2009-07-11	2009-07-11 00:00:00	2009-07-11	38000177		0	0	9		0	0	0	27910	0	834102	19133905		
229757	5049	40213306	1984-05-30	1984-05-30 00:00:00	1984-05-30	1984-05-30 00:00:00	1984-05-30	581452		0	0	0		0	0	0	335598	0	43	40213306		
61291	5099	19133905	1999-02-27	1999-02-27 00:00:00	1999-03-11	1999-03-11 00:00:00	1999-03-11	38000177		0	0	12		0	0	0	338891	0	834102	19133905		
61337	5103	19059056	1962-02-20	1962-02-20 00:00:00	1962-03-13	1962-03-13 00:00:00	1962-03-13	38000177		0	0	21		0	0	0	339105	0	243670	19059056		
53858	4476	1127433	1962-04-21	1962-04-21 00:00:00	1962-05-05	1962-05-05 00:00:00	1962-05-05	38000177		0	0	14		0	0	0	297891	0	313782	1127433		
133852	2939	40213296	1996-11-05	1996-11-05 00:00:00	1996-11-05	1996-11-05 00:00:00	1996-11-05	581452		0	0	0		0	0	0	195924	0	52	40213296		
9902	829	19133873	1987-04-23	1987-04-23 00:00:00	1987-04-30	1987-04-30 00:00:00	1987-04-30	38000177		0	0	7		0	0	0	54926	0	834061	19133873		
169637	3730	40213260	2006-04-13	2006-04-13 00:00:00	2006-04-13	2006-04-13 00:00:00	2006-04-13	581452		0	0	0		0	0	0	247869	0	121	40213260		
20422	1679	1127433	2019-02-17	2019-02-17 00:00:00	2019-02-24	2019-02-24 00:00:00	2019-02-24	38000177		0	0	7		0	0	0	112593	0	313782	1127433		
166137	3651	40213160	1959-12-03	1959-12-03 00:00:00	1959-12-03	1959-12-03 00:00:00	1959-12-03	581452		0	0	0		0	0	0	243055	0	10	40213160		
137261	3013	40213227	2012-06-05	2012-06-05 00:00:00	2012-06-05	2012-06-05 00:00:00	2012-06-05	581452		0	0	0		0	0	0	200930	0	113	40213227		
20562	1691	19133873	1951-07-27	1951-07-27 00:00:00	1951-08-08	1951-08-08 00:00:00	1951-08-08	38000177		0	0	12		0	0	0	113261	0	834061	19133873		
31079	2577	19134077	1995-04-22	1995-04-22 00:00:00	1995-05-06	1995-05-06 00:00:00	1995-05-06	38000177		0	0	14		0	0	0	170640	0	835900	19134077		
160464	3531	40213227	2009-07-08	2009-07-08 00:00:00	2009-07-08	2009-07-08 00:00:00	2009-07-08	581452		0	0	0		0	0	0	234583	0	113	40213227		
11214	933	19129655	1974-03-20	1974-03-20 00:00:00	1974-04-03	1974-04-03 00:00:00	1974-04-03	38000177		0	0	14		0	0	0	62074	0	789980	19129655		
101659	2228	40213227	1998-01-24	1998-01-24 00:00:00	1998-01-24	1998-01-24 00:00:00	1998-01-24	581452		0	0	0		0	0	0	148232	0	113	40213227		
62847	5223	46233988	1970-09-06	1970-09-06 00:00:00	1970-09-20	1970-09-20 00:00:00	1970-09-20	38000177		0	0	14		0	0	0	347594	0	1652673	46233988		
142609	3133	40213160	1956-08-01	1956-08-01 00:00:00	1956-08-01	1956-08-01 00:00:00	1956-08-01	581452		0	0	0		0	0	0	208461	0	10	40213160		
40798	3382	1127433	1962-05-18	1962-05-18 00:00:00	1962-05-25	1962-05-25 00:00:00	1962-05-25	38000177		0	0	7		0	0	0	224411	0	313782	1127433		
3633	299	1127433	1975-01-31	1975-01-31 00:00:00	1975-02-07	1975-02-07 00:00:00	1975-02-07	38000177		0	0	7		0	0	0	20024	0	313782	1127433		
129776	2853	40213296	2005-04-19	2005-04-19 00:00:00	2005-04-19	2005-04-19 00:00:00	2005-04-19	581452		0	0	0		0	0	0	189579	0	52	40213296		
18564	1535	40165015	2008-02-16	2008-02-16 00:00:00	2008-02-16	2008-02-16 00:00:00	\N	38000177		0	0	0		0	0	0	102748	0	861467	40165015		
15381	1283	1127433	1989-01-19	1989-01-19 00:00:00	1989-02-02	1989-02-02 00:00:00	1989-02-02	38000177		0	0	14		0	0	0	84824	0	313782	1127433		
24502	533	40213160	1963-04-10	1963-04-10 00:00:00	1963-04-10	1963-04-10 00:00:00	1963-04-10	581452		0	0	0		0	0	0	35500	0	10	40213160		
3436	285	19075001	2009-08-28	2009-08-28 00:00:00	2009-09-11	2009-09-11 00:00:00	2009-09-11	38000177		0	0	14		0	0	0	18985	0	309097	19075001		
216430	4750	40213227	2014-04-16	2014-04-16 00:00:00	2014-04-16	2014-04-16 00:00:00	2014-04-16	581452		0	0	0		0	0	0	316378	0	113	40213227		
39733	3287	1713671	1971-06-07	1971-06-07 00:00:00	1971-08-30	1971-08-30 00:00:00	1971-08-30	38000177		0	0	84		0	0	0	218329	0	562251	1713671		
31420	2604	19006318	1957-10-15	1957-10-15 00:00:00	1957-10-29	1957-10-29 00:00:00	1957-10-29	38000177		0	0	14		0	0	0	172317	0	105078	19006318		
76851	1679	40213160	1970-06-09	1970-06-09 00:00:00	1970-06-09	1970-06-09 00:00:00	1970-06-09	581452		0	0	0		0	0	0	112575	0	10	40213160		
47311	1032	40213227	1993-08-29	1993-08-29 00:00:00	1993-08-29	1993-08-29 00:00:00	1993-08-29	581452		0	0	0		0	0	0	67882	0	113	40213227		
218498	4795	40213227	2007-11-14	2007-11-14 00:00:00	2007-11-14	2007-11-14 00:00:00	2007-11-14	581452		0	0	0		0	0	0	319049	0	113	40213227		
98105	2149	40213160	1959-08-29	1959-08-29 00:00:00	1959-08-29	1959-08-29 00:00:00	1959-08-29	581452		0	0	0		0	0	0	\N	0	10	40213160		
242112	5316	40213227	1998-08-31	1998-08-31 00:00:00	1998-08-31	1998-08-31 00:00:00	1998-08-31	581452		0	0	0		0	0	0	353583	0	113	40213227		
46569	1017	40213260	2008-06-15	2008-06-15 00:00:00	2008-06-15	2008-06-15 00:00:00	2008-06-15	581452		0	0	0		0	0	0	66965	0	121	40213260		
17368	1438	40229134	1965-12-15	1965-12-15 00:00:00	1965-12-29	1965-12-29 00:00:00	1965-12-29	38000177		0	0	14		0	0	0	95838	0	1043400	40229134		
61054	5078	40169216	1914-05-07	1914-05-07 00:00:00	1914-05-07	1914-05-07 00:00:00	\N	38000177		0	0	0		0	0	0	337642	0	895994	40169216		
17449	377	40213160	1967-10-12	1967-10-12 00:00:00	1967-10-12	1967-10-12 00:00:00	1967-10-12	581452		0	0	0		0	0	0	25016	0	10	40213160		
151460	3332	40213260	2011-12-13	2011-12-13 00:00:00	2011-12-13	2011-12-13 00:00:00	2011-12-13	581452		0	0	0		0	0	0	221059	0	121	40213260		
49839	4134	1713671	1961-07-09	1961-07-09 00:00:00	1961-07-30	1961-07-30 00:00:00	1961-07-30	38000177		0	0	21		0	0	0	274823	0	562251	1713671		
55027	4570	19059056	1937-09-20	1937-09-20 00:00:00	1937-10-04	1937-10-04 00:00:00	1937-10-04	38000177		0	0	14		0	0	0	304467	0	243670	19059056		
50832	4223	1127078	1958-08-18	1958-08-18 00:00:00	1958-09-01	1958-09-01 00:00:00	1958-09-01	38000177		0	0	14		0	0	0	280382	0	282464	1127078		
28073	610	40213227	1996-06-06	1996-06-06 00:00:00	1996-06-06	1996-06-06 00:00:00	1996-06-06	581452		0	0	0		0	0	0	40562	0	113	40213227		
232835	5116	40213160	1964-09-04	1964-09-04 00:00:00	1964-09-04	1964-09-04 00:00:00	1964-09-04	581452		0	0	0		0	0	0	339914	0	10	40213160		
183885	4040	40213227	2017-03-13	2017-03-13 00:00:00	2017-03-13	2017-03-13 00:00:00	2017-03-13	581452		0	0	0		0	0	0	268683	0	113	40213227		
58083	4826	19133905	1990-04-20	1990-04-20 00:00:00	1990-04-27	1990-04-27 00:00:00	1990-04-27	38000177		0	0	7		0	0	0	321016	0	834102	19133905		
209977	4604	40213260	2014-04-13	2014-04-13 00:00:00	2014-04-13	2014-04-13 00:00:00	2014-04-13	581452		0	0	0		0	0	0	306758	0	121	40213260		
126292	2778	40213160	1977-04-02	1977-04-02 00:00:00	1977-04-02	1977-04-02 00:00:00	1977-04-02	581452		0	0	0		0	0	0	183979	0	10	40213160		
185849	4084	40213160	1966-07-31	1966-07-31 00:00:00	1966-07-31	1966-07-31 00:00:00	1966-07-31	581452		0	0	0		0	0	0	271381	0	10	40213160		
185885	4084	40213260	2013-03-31	2013-03-31 00:00:00	2013-03-31	2013-03-31 00:00:00	2013-03-31	581452		0	0	0		0	0	0	271424	0	121	40213260		
63416	1387	40213160	1974-03-12	1974-03-12 00:00:00	1974-03-12	1974-03-12 00:00:00	1974-03-12	581452		0	0	0		0	0	0	91968	0	10	40213160		
116057	2550	40213306	2005-10-02	2005-10-02 00:00:00	2005-10-02	2005-10-02 00:00:00	2005-10-02	581452		0	0	0		0	0	0	168805	0	43	40213306		
2667	213	1127433	2016-06-09	2016-06-09 00:00:00	2016-06-23	2016-06-23 00:00:00	2016-06-23	38000177		0	0	14		0	0	0	14527	0	313782	1127433		
157015	3455	40213160	1969-09-01	1969-09-01 00:00:00	1969-09-01	1969-09-01 00:00:00	1969-09-01	581452		0	0	0		0	0	0	229210	0	10	40213160		
22540	1851	1118084	2016-07-16	2016-07-16 00:00:00	2016-07-16	2016-07-16 00:00:00	\N	38000177		0	0	0		0	0	0	123837	0	00025152531	44923712		
19219	1586	19059056	1961-04-13	1961-04-13 00:00:00	1961-04-27	1961-04-27 00:00:00	1961-04-27	38000177		0	0	14		0	0	0	106387	0	243670	19059056		
13330	1118	1118084	2014-05-19	2014-05-19 00:00:00	2014-05-19	2014-05-19 00:00:00	\N	38000177		0	0	0		0	0	0	73745	0	00025152531	44923712		
115370	2535	40213160	1961-09-10	1961-09-10 00:00:00	1961-09-10	1961-09-10 00:00:00	1961-09-10	581452		0	0	0		0	0	0	167539	0	10	40213160		
50692	4212	46233988	1970-07-28	1970-07-28 00:00:00	1970-08-11	1970-08-11 00:00:00	1970-08-11	38000177		0	0	14		0	0	0	279626	0	1652673	46233988		
5072	422	1127433	1983-01-04	1983-01-04 00:00:00	1983-01-18	1983-01-18 00:00:00	1983-01-18	38000177		0	0	14		0	0	0	27957	0	313782	1127433		
229760	5049	40213227	2004-02-11	2004-02-11 00:00:00	2004-02-11	2004-02-11 00:00:00	2004-02-11	581452		0	0	0		0	0	0	335555	0	113	40213227		
61292	5099	1713671	2000-01-06	2000-01-06 00:00:00	2000-01-27	2000-01-27 00:00:00	2000-01-27	38000177		0	0	21		0	0	0	338841	0	562251	1713671		
61338	5103	19059056	1957-12-15	1957-12-15 00:00:00	1958-01-12	1958-01-12 00:00:00	1958-01-12	38000177		0	0	28		0	0	0	339104	0	243670	19059056		
53859	4476	19059056	1968-08-15	1968-08-15 00:00:00	1968-11-13	1968-11-13 00:00:00	1968-11-13	38000177		0	0	90		0	0	0	297894	0	243670	19059056		
226164	4967	40213227	2012-06-04	2012-06-04 00:00:00	2012-06-04	2012-06-04 00:00:00	2012-06-04	581452		0	0	0		0	0	0	330181	0	113	40213227		
9903	829	19133873	1984-04-26	1984-04-26 00:00:00	1984-05-06	1984-05-06 00:00:00	1984-05-06	38000177		0	0	10		0	0	0	54905	0	834061	19133873		
169640	3730	40213296	1996-04-11	1996-04-11 00:00:00	1996-04-11	1996-04-11 00:00:00	1996-04-11	581452		0	0	0		0	0	0	247852	0	52	40213296		
20423	1679	40165015	1989-07-01	1989-07-01 00:00:00	1989-07-01	1989-07-01 00:00:00	\N	38000177		0	0	0		0	0	0	112586	0	861467	40165015		
166140	3652	40213314	1977-02-13	1977-02-13 00:00:00	1977-02-13	1977-02-13 00:00:00	1977-02-13	581452		0	0	0		0	0	0	243089	0	49	40213314		
137268	3013	40213227	1992-09-08	1992-09-08 00:00:00	1992-09-08	1992-09-08 00:00:00	1992-09-08	581452		0	0	0		0	0	0	200904	0	113	40213227		
20563	1692	1118084	2017-01-23	2017-01-23 00:00:00	2017-01-23	2017-01-23 00:00:00	\N	38000177		0	0	0		0	0	0	113359	0	00025152531	44923712		
31080	2577	1127433	1988-09-21	1988-09-21 00:00:00	1988-10-05	1988-10-05 00:00:00	1988-10-05	38000177		0	0	14		0	0	0	170650	0	313782	1127433		
160465	3531	40213296	2009-07-08	2009-07-08 00:00:00	2009-07-08	2009-07-08 00:00:00	2009-07-08	581452		0	0	0		0	0	0	234583	0	52	40213296		
11215	933	1115171	2014-10-15	2014-10-15 00:00:00	2014-11-05	2014-11-05 00:00:00	2014-11-05	38000177		0	0	21		0	0	0	62062	0	849574	1115171		
112952	2481	40213160	1974-06-30	1974-06-30 00:00:00	1974-06-30	1974-06-30 00:00:00	1974-06-30	581452		0	0	0		0	0	0	164383	0	10	40213160		
62848	5223	19059056	1970-09-06	1970-09-06 00:00:00	1970-09-20	1970-09-20 00:00:00	1970-09-20	38000177		0	0	14		0	0	0	347594	0	243670	19059056		
142619	3133	40213227	2017-04-26	2017-04-26 00:00:00	2017-04-26	2017-04-26 00:00:00	2017-04-26	581452		0	0	0		0	0	0	208498	0	113	40213227		
40799	3382	1127078	1963-12-07	1963-12-07 00:00:00	1963-12-28	1963-12-28 00:00:00	1963-12-28	38000177		0	0	21		0	0	0	224399	0	282464	1127078		
3634	299	40169281	2014-12-27	2014-12-27 00:00:00	2014-12-27	2014-12-27 00:00:00	\N	38000177		0	0	0		0	0	0	19981	0	896209	40169281		
129777	2853	40213160	1966-03-01	1966-03-01 00:00:00	1966-03-01	1966-03-01 00:00:00	1966-03-01	581452		0	0	0		0	0	0	189529	0	10	40213160		
18565	1535	1115171	2008-02-16	2008-02-16 00:00:00	2008-05-16	2008-05-16 00:00:00	2008-05-16	38000177		0	0	90		0	0	0	102748	0	849574	1115171		
15383	1283	1115171	2010-07-26	2010-07-26 00:00:00	2010-08-16	2010-08-16 00:00:00	2010-08-16	38000177		0	0	21		0	0	0	84826	0	849574	1115171		
24508	533	40213227	1994-02-16	1994-02-16 00:00:00	1994-02-16	1994-02-16 00:00:00	1994-02-16	581452		0	0	0		0	0	0	35443	0	113	40213227		
3437	285	1115171	2009-08-28	2009-08-28 00:00:00	2009-09-11	2009-09-11 00:00:00	2009-09-11	38000177		0	0	14		0	0	0	18985	0	849574	1115171		
216431	4750	40213260	2014-04-16	2014-04-16 00:00:00	2014-04-16	2014-04-16 00:00:00	2014-04-16	581452		0	0	0		0	0	0	316378	0	121	40213260		
39734	3287	1127433	2009-07-31	2009-07-31 00:00:00	2009-08-07	2009-08-07 00:00:00	2009-08-07	38000177		0	0	7		0	0	0	218392	0	313782	1127433		
31421	2604	1127078	1957-10-15	1957-10-15 00:00:00	1957-10-29	1957-10-29 00:00:00	1957-10-29	38000177		0	0	14		0	0	0	172317	0	282464	1127078		
76855	1679	40213227	2011-10-11	2011-10-11 00:00:00	2011-10-11	2011-10-11 00:00:00	2011-10-11	581452		0	0	0		0	0	0	112611	0	113	40213227		
47313	1032	40213198	2016-12-11	2016-12-11 00:00:00	2016-12-11	2016-12-11 00:00:00	2016-12-11	581452		0	0	0		0	0	0	67892	0	133	40213198		
218506	4795	40213296	2005-11-09	2005-11-09 00:00:00	2005-11-09	2005-11-09 00:00:00	2005-11-09	581452		0	0	0		0	0	0	319048	0	52	40213296		
98115	2149	40213306	1981-09-19	1981-09-19 00:00:00	1981-09-19	1981-09-19 00:00:00	1981-09-19	581452		0	0	0		0	0	0	143137	0	43	40213306		
242113	5316	40213296	1998-08-31	1998-08-31 00:00:00	1998-08-31	1998-08-31 00:00:00	1998-08-31	581452		0	0	0		0	0	0	353583	0	52	40213296		
46570	1017	40213160	1959-02-22	1959-02-22 00:00:00	1959-02-22	1959-02-22 00:00:00	1959-02-22	581452		0	0	0		0	0	0	66957	0	10	40213160		
17370	1439	1127433	1979-07-20	1979-07-20 00:00:00	1979-08-03	1979-08-03 00:00:00	1979-08-03	38000177		0	0	14		0	0	0	95882	0	313782	1127433		
61055	5078	1154615	1914-05-07	1914-05-07 00:00:00	1914-05-07	1914-05-07 00:00:00	\N	38000177		0	0	0		0	0	0	337642	0	745679	1154615		
17451	377	40213260	2017-02-02	2017-02-02 00:00:00	2017-02-02	2017-02-02 00:00:00	2017-02-02	581452		0	0	0		0	0	0	25001	0	121	40213260		
151464	3332	40213160	1961-03-14	1961-03-14 00:00:00	1961-03-14	1961-03-14 00:00:00	1961-03-14	581452		0	0	0		0	0	0	221079	0	10	40213160		
49840	4134	19059056	1959-08-13	1959-08-13 00:00:00	1959-10-12	1959-10-12 00:00:00	1959-10-12	38000177		0	0	60		0	0	0	274820	0	243670	19059056		
55028	4570	40229134	1991-12-21	1991-12-21 00:00:00	1991-12-28	1991-12-28 00:00:00	1991-12-28	38000177		0	0	7		0	0	0	304427	0	1043400	40229134		
50833	4223	19006318	1959-02-01	1959-02-01 00:00:00	1959-02-15	1959-02-15 00:00:00	1959-02-15	38000177		0	0	14		0	0	0	280383	0	105078	19006318		
202159	4439	40213227	1996-12-18	1996-12-18 00:00:00	1996-12-18	1996-12-18 00:00:00	1996-12-18	581452		0	0	0		0	0	0	295090	0	113	40213227		
232838	5116	40213306	1986-07-11	1986-07-11 00:00:00	1986-07-11	1986-07-11 00:00:00	1986-07-11	581452		0	0	0		0	0	0	339936	0	43	40213306		
183886	4040	40213296	2017-03-13	2017-03-13 00:00:00	2017-03-13	2017-03-13 00:00:00	2017-03-13	581452		0	0	0		0	0	0	268683	0	52	40213296		
58084	4826	19059056	1951-09-07	1951-09-07 00:00:00	1951-09-21	1951-09-21 00:00:00	1951-09-21	38000177		0	0	14		0	0	0	321046	0	243670	19059056		
209982	4604	40213227	1997-09-28	1997-09-28 00:00:00	1997-09-28	1997-09-28 00:00:00	1997-09-28	581452		0	0	0		0	0	0	306754	0	113	40213227		
126293	2778	40213314	1977-04-02	1977-04-02 00:00:00	1977-04-02	1977-04-02 00:00:00	1977-04-02	581452		0	0	0		0	0	0	183979	0	49	40213314		
185852	4084	40213296	2001-08-26	2001-08-26 00:00:00	2001-08-26	2001-08-26 00:00:00	2001-08-26	581452		0	0	0		0	0	0	271412	0	52	40213296		
185896	4085	40213296	1999-05-08	1999-05-08 00:00:00	1999-05-08	1999-05-08 00:00:00	1999-05-08	581452		0	0	0		0	0	0	271529	0	52	40213296		
63426	1387	40213227	2011-04-26	2011-04-26 00:00:00	2011-04-26	2011-04-26 00:00:00	2011-04-26	581452		0	0	0		0	0	0	91984	0	113	40213227		
116059	2550	40213227	2014-10-12	2014-10-12 00:00:00	2014-10-12	2014-10-12 00:00:00	2014-10-12	581452		0	0	0		0	0	0	168830	0	113	40213227		
2668	213	1713671	1968-12-30	1968-12-30 00:00:00	1969-01-06	1969-01-06 00:00:00	1969-01-06	38000177		0	0	7		0	0	0	14510	0	562251	1713671		
157019	3455	40213306	1991-03-25	1991-03-25 00:00:00	1991-03-25	1991-03-25 00:00:00	1991-03-25	581452		0	0	0		0	0	0	229230	0	43	40213306		
22541	1851	1127078	1982-11-01	1982-11-01 00:00:00	1982-11-15	1982-11-15 00:00:00	1982-11-15	38000177		0	0	14		0	0	0	123811	0	282464	1127078		
40583	3364	19128022	1991-06-16	1991-06-16 00:00:00	1992-06-10	1992-06-10 00:00:00	1992-06-10	38000177		0	0	360		0	0	0	223096	0	749785	19128022		
13331	1118	1127078	1980-06-06	1980-06-06 00:00:00	1980-06-20	1980-06-20 00:00:00	1980-06-20	38000177		0	0	14		0	0	0	73702	0	282464	1127078		
64439	1410	40213227	2009-03-19	2009-03-19 00:00:00	2009-03-19	2009-03-19 00:00:00	2009-03-19	581452		0	0	0		0	0	0	93846	0	113	40213227		
50693	4212	19059056	1970-07-28	1970-07-28 00:00:00	1970-08-11	1970-08-11 00:00:00	1970-08-11	38000177		0	0	14		0	0	0	279626	0	243670	19059056		
5073	422	19074841	1983-01-04	1983-01-04 00:00:00	1983-01-18	1983-01-18 00:00:00	1983-01-18	38000177		0	0	14		0	0	0	27957	0	309043	19074841		
229761	5049	40213296	2004-02-11	2004-02-11 00:00:00	2004-02-11	2004-02-11 00:00:00	2004-02-11	581452		0	0	0		0	0	0	335555	0	52	40213296		
61293	5099	40231925	1989-02-23	1989-02-23 00:00:00	1989-02-23	1989-02-23 00:00:00	\N	38000177		0	0	0		0	0	0	338867	0	1049221	40231925		
61339	5103	19075601	2014-02-03	2014-02-03 00:00:00	2014-02-03	2014-02-03 00:00:00	\N	38000177		0	0	0		0	0	0	339080	0	309362	19075601		
53860	4476	19128065	1981-01-19	1981-01-19 00:00:00	1982-01-14	1982-01-14 00:00:00	1982-01-14	38000177		0	0	360		0	0	0	297772	0	749882	19128065		
226165	4967	40213260	2012-06-04	2012-06-04 00:00:00	2012-06-04	2012-06-04 00:00:00	2012-06-04	581452		0	0	0		0	0	0	330181	0	121	40213260		
9904	830	1713671	1985-08-18	1985-08-18 00:00:00	1985-09-01	1985-09-01 00:00:00	1985-09-01	38000177		0	0	14		0	0	0	54969	0	562251	1713671		
169642	3730	40213227	1996-04-11	1996-04-11 00:00:00	1996-04-11	1996-04-11 00:00:00	1996-04-11	581452		0	0	0		0	0	0	247852	0	113	40213227		
20424	1679	1127433	1989-07-01	1989-07-01 00:00:00	1989-09-29	1989-09-29 00:00:00	1989-09-29	38000177		0	0	90		0	0	0	112586	0	313782	1127433		
166144	3652	40213160	1978-08-20	1978-08-20 00:00:00	1978-08-20	1978-08-20 00:00:00	1978-08-20	581452		0	0	0		0	0	0	243090	0	10	40213160		
137280	3013	40213198	2016-06-28	2016-06-28 00:00:00	2016-06-28	2016-06-28 00:00:00	2016-06-28	581452		0	0	0		0	0	0	200893	0	133	40213198		
20564	1692	1127433	1982-08-17	1982-08-17 00:00:00	1982-08-24	1982-08-24 00:00:00	1982-08-24	38000177		0	0	7		0	0	0	113345	0	313782	1127433		
31081	2577	1551192	1991-02-07	1991-02-07 00:00:00	1991-02-07	1991-02-07 00:00:00	1991-02-07	38000177		0	0	0		0	0	0	170635	0	312617	1551192		
160466	3531	40213160	1967-07-05	1967-07-05 00:00:00	1967-07-05	1967-07-05 00:00:00	1967-07-05	581452		0	0	0		0	0	0	234523	0	10	40213160		
11231	935	40165015	1961-08-26	1961-08-26 00:00:00	1961-08-26	1961-08-26 00:00:00	\N	38000177		0	0	0		0	0	0	62226	0	861467	40165015		
112955	2481	40213227	2000-12-17	2000-12-17 00:00:00	2000-12-17	2000-12-17 00:00:00	2000-12-17	581452		0	0	0		0	0	0	164416	0	113	40213227		
62849	5223	1127433	2019-01-11	2019-01-11 00:00:00	2019-02-01	2019-02-01 00:00:00	2019-02-01	38000177		0	0	21		0	0	0	347547	0	313782	1127433		
142621	3133	40213227	2007-02-28	2007-02-28 00:00:00	2007-02-28	2007-02-28 00:00:00	2007-02-28	581452		0	0	0		0	0	0	208515	0	113	40213227		
40800	3382	19133873	1968-07-28	1968-07-28 00:00:00	1968-08-07	1968-08-07 00:00:00	1968-08-07	38000177		0	0	10		0	0	0	224417	0	834061	19133873		
3635	299	19128065	1975-12-06	1975-12-06 00:00:00	1976-11-30	1976-11-30 00:00:00	1976-11-30	38000177		0	0	360		0	0	0	20018	0	749882	19128065		
129783	2853	40213227	2003-04-15	2003-04-15 00:00:00	2003-04-15	2003-04-15 00:00:00	2003-04-15	581452		0	0	0		0	0	0	189576	0	113	40213227		
18566	1535	1118084	2013-04-14	2013-04-14 00:00:00	2013-04-14	2013-04-14 00:00:00	\N	38000177		0	0	0		0	0	0	102738	0	00025152531	44923712		
15384	1283	1127433	1984-12-31	1984-12-31 00:00:00	1985-01-14	1985-01-14 00:00:00	1985-01-14	38000177		0	0	14		0	0	0	84798	0	313782	1127433		
24510	533	40213306	1985-02-06	1985-02-06 00:00:00	1985-02-06	1985-02-06 00:00:00	1985-02-06	581452		0	0	0		0	0	0	35380	0	43	40213306		
3438	286	19059056	1929-06-26	1929-06-26 00:00:00	1929-07-10	1929-07-10 00:00:00	1929-07-10	38000177		0	0	14		0	0	0	19072	0	243670	19059056		
165911	3647	40213201	2003-01-22	2003-01-22 00:00:00	2003-01-22	2003-01-22 00:00:00	2003-01-22	581452		0	0	0		0	0	0	242681	0	33	40213201		
39735	3287	19059056	1946-04-01	1946-04-01 00:00:00	1946-04-15	1946-04-15 00:00:00	1946-04-15	38000177		0	0	14		0	0	0	218394	0	243670	19059056		
31422	2604	19059056	1973-01-24	1973-01-24 00:00:00	1973-02-28	1973-02-28 00:00:00	1973-02-28	38000177		0	0	35		0	0	0	172312	0	243670	19059056		
76856	1679	40213296	2011-10-11	2011-10-11 00:00:00	2011-10-11	2011-10-11 00:00:00	2011-10-11	581452		0	0	0		0	0	0	112611	0	52	40213296		
47323	1032	40213160	1955-09-18	1955-09-18 00:00:00	1955-09-18	1955-09-18 00:00:00	1955-09-18	581452		0	0	0		0	0	0	67913	0	10	40213160		
218509	4795	40213160	1966-02-09	1966-02-09 00:00:00	1966-02-09	1966-02-09 00:00:00	1966-02-09	581452		0	0	0		0	0	0	318995	0	10	40213160		
242045	5314	40213227	2012-02-24	2012-02-24 00:00:00	2012-02-24	2012-02-24 00:00:00	2012-02-24	581452		0	0	0		0	0	0	353404	0	113	40213227		
242117	5316	40213160	1957-01-28	1957-01-28 00:00:00	1957-01-28	1957-01-28 00:00:00	1957-01-28	581452		0	0	0		0	0	0	353578	0	10	40213160		
46574	1017	40213227	2000-06-25	2000-06-25 00:00:00	2000-06-25	2000-06-25 00:00:00	2000-06-25	581452		0	0	0		0	0	0	66974	0	113	40213227		
17371	1439	1127078	1979-09-16	1979-09-16 00:00:00	1979-09-30	1979-09-30 00:00:00	1979-09-30	38000177		0	0	14		0	0	0	95881	0	282464	1127078		
61056	5078	1539411	1991-05-27	1991-05-27 00:00:00	1991-05-27	1991-05-27 00:00:00	\N	38000177		0	0	0		0	0	0	337587	0	312961	1539411		
17452	377	40213306	1989-03-02	1989-03-02 00:00:00	1989-03-02	1989-03-02 00:00:00	1989-03-02	581452		0	0	0		0	0	0	24999	0	43	40213306		
151477	3332	40213260	2010-12-07	2010-12-07 00:00:00	2010-12-07	2010-12-07 00:00:00	2010-12-07	581452		0	0	0		0	0	0	221113	0	121	40213260		
49841	4134	1127078	1953-05-13	1953-05-13 00:00:00	1953-05-27	1953-05-27 00:00:00	1953-05-27	38000177		0	0	14		0	0	0	274817	0	282464	1127078		
55029	4570	19059056	1961-11-27	1961-11-27 00:00:00	1961-12-18	1961-12-18 00:00:00	1961-12-18	38000177		0	0	21		0	0	0	304491	0	243670	19059056		
50834	4223	19059056	1959-02-01	1959-02-01 00:00:00	1959-02-15	1959-02-15 00:00:00	1959-02-15	38000177		0	0	14		0	0	0	280383	0	243670	19059056		
202160	4439	40213296	1996-12-18	1996-12-18 00:00:00	1996-12-18	1996-12-18 00:00:00	1996-12-18	581452		0	0	0		0	0	0	295090	0	52	40213296		
193279	4246	40213160	1967-08-09	1967-08-09 00:00:00	1967-08-09	1967-08-09 00:00:00	1967-08-09	581452		0	0	0		0	0	0	281972	0	10	40213160		
183888	4040	40213160	1976-10-18	1976-10-18 00:00:00	1976-10-18	1976-10-18 00:00:00	1976-10-18	581452		0	0	0		0	0	0	268675	0	10	40213160		
58085	4826	1127433	1996-05-10	1996-05-10 00:00:00	1996-05-17	1996-05-17 00:00:00	1996-05-17	38000177		0	0	7		0	0	0	321031	0	313782	1127433		
126294	2778	40213251	1984-10-20	1984-10-20 00:00:00	1984-10-20	1984-10-20 00:00:00	1984-10-20	581452		0	0	0		0	0	0	184048	0	21	40213251		
185861	4084	40213227	1992-11-08	1992-11-08 00:00:00	1992-11-08	1992-11-08 00:00:00	1992-11-08	581452		0	0	0		0	0	0	271429	0	113	40213227		
185906	4085	40213160	1959-03-14	1959-03-14 00:00:00	1959-03-14	1959-03-14 00:00:00	1959-03-14	581452		0	0	0		0	0	0	271444	0	10	40213160		
63427	1387	40213296	2011-04-26	2011-04-26 00:00:00	2011-04-26	2011-04-26 00:00:00	2011-04-26	581452		0	0	0		0	0	0	91984	0	52	40213296		
116061	2550	40213314	1984-03-25	1984-03-25 00:00:00	1984-03-25	1984-03-25 00:00:00	1984-03-25	581452		0	0	0		0	0	0	168812	0	49	40213314		
2669	213	19128065	1982-04-22	1982-04-22 00:00:00	1983-04-17	1983-04-17 00:00:00	1983-04-17	38000177		0	0	360		0	0	0	14514	0	749882	19128065		
157024	3455	40213160	1969-11-03	1969-11-03 00:00:00	1969-11-03	1969-11-03 00:00:00	1969-11-03	581452		0	0	0		0	0	0	229252	0	10	40213160		
22542	1851	19073183	1982-11-01	1982-11-01 00:00:00	1982-11-15	1982-11-15 00:00:00	1982-11-15	38000177		0	0	14		0	0	0	123811	0	308182	19073183		
40584	3364	19128022	1994-05-31	1994-05-31 00:00:00	1995-05-26	1995-05-26 00:00:00	1995-05-26	38000177		0	0	360		0	0	0	223099	0	749785	19128022		
13332	1118	1127433	1996-07-26	1996-07-26 00:00:00	1996-08-16	1996-08-16 00:00:00	1996-08-16	38000177		0	0	21		0	0	0	73704	0	313782	1127433		
64440	1410	40213296	2009-03-19	2009-03-19 00:00:00	2009-03-19	2009-03-19 00:00:00	2009-03-19	581452		0	0	0		0	0	0	93846	0	52	40213296		
50694	4212	19059056	1982-02-25	1982-02-25 00:00:00	1982-03-25	1982-03-25 00:00:00	1982-03-25	38000177		0	0	28		0	0	0	279651	0	243670	19059056		
5074	422	40173590	2019-04-27	2019-04-27 00:00:00	2019-04-27	2019-04-27 00:00:00	\N	38000177		0	0	0		0	0	0	27964	0	904419	40173590		
229763	5049	40213227	1995-01-25	1995-01-25 00:00:00	1995-01-25	1995-01-25 00:00:00	1995-01-25	581452		0	0	0		0	0	0	335600	0	113	40213227		
61294	5099	19073188	1989-02-23	1989-02-23 00:00:00	1989-03-09	1989-03-09 00:00:00	1989-03-09	38000177		0	0	14		0	0	0	338867	0	308192	19073188		
61340	5103	1332419	2014-02-03	2014-02-03 00:00:00	2014-02-03	2014-02-03 00:00:00	\N	38000177		0	0	0		0	0	0	339080	0	197361	1332419		
53861	4476	920300	1992-04-11	1992-04-11 00:00:00	1992-04-18	1992-04-18 00:00:00	1992-04-18	38000177		0	0	7		0	0	0	297795	0	311989	920300		
226171	4967	40213160	1961-09-04	1961-09-04 00:00:00	1961-09-04	1961-09-04 00:00:00	1961-09-04	581452		0	0	0		0	0	0	330167	0	10	40213160		
9905	830	19059056	1970-08-30	1970-08-30 00:00:00	1970-09-20	1970-09-20 00:00:00	1970-09-20	38000177		0	0	21		0	0	0	55006	0	243670	19059056		
169644	3730	40213260	2007-02-01	2007-02-01 00:00:00	2007-02-01	2007-02-01 00:00:00	2007-02-01	581452		0	0	0		0	0	0	\N	0	121	40213260		
20425	1679	1127433	2013-03-27	2013-03-27 00:00:00	2013-04-17	2013-04-17 00:00:00	2013-04-17	38000177		0	0	21		0	0	0	112587	0	313782	1127433		
166148	3652	40213296	2013-09-15	2013-09-15 00:00:00	2013-09-15	2013-09-15 00:00:00	2013-09-15	581452		0	0	0		0	0	0	243142	0	52	40213296		
74456	1626	40213201	2001-09-30	2001-09-30 00:00:00	2001-09-30	2001-09-30 00:00:00	2001-09-30	581452		0	0	0		0	0	0	109236	0	33	40213201		
20565	1692	19128022	1991-08-08	1991-08-08 00:00:00	1992-08-02	1992-08-02 00:00:00	1992-08-02	38000177		0	0	360		0	0	0	113353	0	749785	19128022		
31082	2577	19008572	2013-10-18	2013-10-18 00:00:00	2013-11-08	2013-11-08 00:00:00	2013-11-08	38000177		0	0	21		0	0	0	170642	0	106258	19008572		
160471	3531	40213260	2017-03-29	2017-03-29 00:00:00	2017-03-29	2017-03-29 00:00:00	2017-03-29	581452		0	0	0		0	0	0	234584	0	121	40213260		
11232	935	1127433	1961-08-26	1961-08-26 00:00:00	1961-09-25	1961-09-25 00:00:00	1961-09-25	38000177		0	0	30		0	0	0	62226	0	313782	1127433		
112959	2481	40213160	1969-12-28	1969-12-28 00:00:00	1969-12-28	1969-12-28 00:00:00	1969-12-28	581452		0	0	0		0	0	0	164379	0	10	40213160		
62850	5223	1127078	1971-10-28	1971-10-28 00:00:00	1971-11-11	1971-11-11 00:00:00	1971-11-11	38000177		0	0	14		0	0	0	347596	0	282464	1127078		
142622	3133	40213260	2007-02-28	2007-02-28 00:00:00	2007-02-28	2007-02-28 00:00:00	2007-02-28	581452		0	0	0		0	0	0	208515	0	121	40213260		
40801	3382	1115171	2005-07-11	2005-07-11 00:00:00	2005-08-01	2005-08-01 00:00:00	2005-08-01	38000177		0	0	21		0	0	0	224402	0	849574	1115171		
3636	299	40229134	2017-06-06	2017-06-06 00:00:00	2017-06-20	2017-06-20 00:00:00	2017-06-20	38000177		0	0	14		0	0	0	19994	0	1043400	40229134		
129784	2853	40213296	2003-04-15	2003-04-15 00:00:00	2003-04-15	2003-04-15 00:00:00	2003-04-15	581452		0	0	0		0	0	0	189576	0	52	40213296		
18567	1535	1713671	1981-11-03	1981-11-03 00:00:00	1981-11-10	1981-11-10 00:00:00	1981-11-10	38000177		0	0	7		0	0	0	102700	0	562251	1713671		
15385	1283	1713671	2000-09-03	2000-09-03 00:00:00	2000-09-10	2000-09-10 00:00:00	2000-09-10	38000177		0	0	7		0	0	0	84850	0	562251	1713671		
72676	1588	40213260	2012-04-01	2012-04-01 00:00:00	2012-04-01	2012-04-01 00:00:00	2012-04-01	581452		0	0	0		0	0	0	106564	0	121	40213260		
3439	286	1127433	1976-10-04	1976-10-04 00:00:00	1976-11-10	1976-11-10 00:00:00	1976-11-10	38000177		0	0	37		0	0	0	19038	0	313782	1127433		
51513	4282	1713671	2013-10-31	2013-10-31 00:00:00	2013-11-14	2013-11-14 00:00:00	2013-11-14	38000177		0	0	14		0	0	0	284199	0	562251	1713671		
39736	3287	1118084	1980-04-17	1980-04-17 00:00:00	1980-04-17	1980-04-17 00:00:00	\N	38000177		0	0	0		0	0	0	218342	0	00025152531	44923712		
31423	2604	1127433	1997-08-19	1997-08-19 00:00:00	1997-09-16	1997-09-16 00:00:00	1997-09-16	38000177		0	0	28		0	0	0	172314	0	313782	1127433		
76863	1679	40213306	1991-11-12	1991-11-12 00:00:00	1991-11-12	1991-11-12 00:00:00	1991-11-12	581452		0	0	0		0	0	0	112605	0	43	40213306		
47330	1033	40213227	1993-10-28	1993-10-28 00:00:00	1993-10-28	1993-10-28 00:00:00	1993-10-28	581452		0	0	0		0	0	0	68003	0	113	40213227		
218511	4795	40213227	1997-07-09	1997-07-09 00:00:00	1997-07-09	1997-07-09 00:00:00	1997-07-09	581452		0	0	0		0	0	0	319007	0	113	40213227		
242058	5314	40213227	2001-12-28	2001-12-28 00:00:00	2001-12-28	2001-12-28 00:00:00	2001-12-28	581452		0	0	0		0	0	0	353377	0	113	40213227		
242121	5316	40213160	1961-07-31	1961-07-31 00:00:00	1961-07-31	1961-07-31 00:00:00	1961-07-31	581452		0	0	0		0	0	0	353591	0	10	40213160		
46575	1017	40213296	2000-06-25	2000-06-25 00:00:00	2000-06-25	2000-06-25 00:00:00	2000-06-25	581452		0	0	0		0	0	0	66974	0	52	40213296		
17372	1439	19133873	1985-01-05	1985-01-05 00:00:00	1985-01-12	1985-01-12 00:00:00	1985-01-12	38000177		0	0	7		0	0	0	95917	0	834061	19133873		
61057	5078	19059056	1942-02-17	1942-02-17 00:00:00	1942-03-10	1942-03-10 00:00:00	1942-03-10	38000177		0	0	21		0	0	0	337522	0	243670	19059056		
17461	377	40213160	1967-07-13	1967-07-13 00:00:00	1967-07-13	1967-07-13 00:00:00	1967-07-13	581452		0	0	0		0	0	0	25023	0	10	40213160		
151478	3332	40213160	1961-05-16	1961-05-16 00:00:00	1961-05-16	1961-05-16 00:00:00	1961-05-16	581452		0	0	0		0	0	0	221054	0	10	40213160		
49842	4134	1713671	1979-09-15	1979-09-15 00:00:00	1979-10-06	1979-10-06 00:00:00	1979-10-06	38000177		0	0	21		0	0	0	274825	0	562251	1713671		
55030	4570	40173590	1997-01-25	1997-01-25 00:00:00	1997-01-25	1997-01-25 00:00:00	\N	38000177		0	0	0		0	0	0	304494	0	904419	40173590		
50835	4223	19133873	1968-07-14	1968-07-14 00:00:00	1968-07-21	1968-07-21 00:00:00	1968-07-21	38000177		0	0	7		0	0	0	280357	0	834061	19133873		
202166	4439	40213160	1959-11-18	1959-11-18 00:00:00	1959-11-18	1959-11-18 00:00:00	1959-11-18	581452		0	0	0		0	0	0	295115	0	10	40213160		
193283	4246	40213306	1989-04-05	1989-04-05 00:00:00	1989-04-05	1989-04-05 00:00:00	1989-04-05	581452		0	0	0		0	0	0	281980	0	43	40213306		
10409	869	1127433	1960-09-04	1960-09-04 00:00:00	1960-09-11	1960-09-11 00:00:00	1960-09-11	38000177		0	0	7		0	0	0	57810	0	313782	1127433		
58086	4826	19059056	1969-01-19	1969-01-19 00:00:00	1969-03-20	1969-03-20 00:00:00	1969-03-20	38000177		0	0	60		0	0	0	320986	0	243670	19059056		
216776	4756	40213227	2014-11-08	2014-11-08 00:00:00	2014-11-08	2014-11-08 00:00:00	2014-11-08	581452		0	0	0		0	0	0	316854	0	113	40213227		
185863	4084	40213160	1962-01-28	1962-01-28 00:00:00	1962-01-28	1962-01-28 00:00:00	1962-01-28	581452		0	0	0		0	0	0	271407	0	10	40213160		
185907	4085	40213260	2009-10-10	2009-10-10 00:00:00	2009-10-10	2009-10-10 00:00:00	2009-10-10	581452		0	0	0		0	0	0	271531	0	121	40213260		
63429	1387	40213296	2009-04-21	2009-04-21 00:00:00	2009-04-21	2009-04-21 00:00:00	2009-04-21	581452		0	0	0		0	0	0	92085	0	52	40213296		
116062	2550	40213251	1984-03-25	1984-03-25 00:00:00	1984-03-25	1984-03-25 00:00:00	1984-03-25	581452		0	0	0		0	0	0	168812	0	21	40213251		
2670	213	19129655	1970-11-11	1970-11-11 00:00:00	1970-11-25	1970-11-25 00:00:00	1970-11-25	38000177		0	0	14		0	0	0	14513	0	789980	19129655		
128282	2822	40213314	1977-03-02	1977-03-02 00:00:00	1977-03-02	1977-03-02 00:00:00	1977-03-02	581452		0	0	0		0	0	0	187001	0	49	40213314		
22543	1851	19074679	1989-12-28	1989-12-28 00:00:00	1990-06-07	1990-06-07 00:00:00	1990-06-07	38000177		0	0	161		0	0	0	123850	0	308971	19074679		
40585	3364	1713671	2017-03-09	2017-03-09 00:00:00	2017-03-16	2017-03-16 00:00:00	2017-03-16	38000177		0	0	7		0	0	0	223024	0	562251	1713671		
13333	1118	920300	2000-09-06	2000-09-06 00:00:00	2000-09-13	2000-09-13 00:00:00	2000-09-13	38000177		0	0	7		0	0	0	73682	0	311989	920300		
75725	1655	40213227	2013-11-01	2013-11-01 00:00:00	2013-11-01	2013-11-01 00:00:00	2013-11-01	581452		0	0	0		0	0	0	111040	0	113	40213227		
50695	4212	1124300	2010-02-03	2010-02-03 00:00:00	2010-02-03	2010-02-03 00:00:00	\N	38000177		0	0	0		0	0	0	279637	0	00781178901	45011828		
138987	3053	40213251	1984-06-16	1984-06-16 00:00:00	1984-06-16	1984-06-16 00:00:00	1984-06-16	581452		0	0	0		0	0	0	203098	0	21	40213251		
229764	5049	40213260	2012-02-01	2012-02-01 00:00:00	2012-02-01	2012-02-01 00:00:00	2012-02-01	581452		0	0	0		0	0	0	335606	0	121	40213260		
61295	5099	1127433	1989-02-23	1989-02-23 00:00:00	1989-03-09	1989-03-09 00:00:00	1989-03-09	38000177		0	0	14		0	0	0	338867	0	313782	1127433		
61341	5103	1539411	2014-02-03	2014-02-03 00:00:00	2014-02-03	2014-02-03 00:00:00	\N	38000177		0	0	0		0	0	0	339080	0	312961	1539411		
53862	4476	40236824	1992-04-11	1992-04-11 00:00:00	1992-04-18	1992-04-18 00:00:00	1992-04-18	38000177		0	0	7		0	0	0	297795	0	1094107	40236824		
226175	4967	40213160	1966-05-09	1966-05-09 00:00:00	1966-05-09	1966-05-09 00:00:00	1966-05-09	581452		0	0	0		0	0	0	330151	0	10	40213160		
9906	830	1118084	1995-08-04	1995-08-04 00:00:00	1995-08-04	1995-08-04 00:00:00	\N	38000177		0	0	0		0	0	0	54953	0	00025152531	44923712		
169655	3730	40213227	2016-03-31	2016-03-31 00:00:00	2016-03-31	2016-03-31 00:00:00	2016-03-31	581452		0	0	0		0	0	0	247830	0	113	40213227		
20426	1679	1127433	2009-04-04	2009-04-04 00:00:00	2009-04-11	2009-04-11 00:00:00	2009-04-11	38000177		0	0	7		0	0	0	112591	0	313782	1127433		
166152	3652	40213227	2005-06-12	2005-06-12 00:00:00	2005-06-12	2005-06-12 00:00:00	2005-06-12	581452		0	0	0		0	0	0	243109	0	113	40213227		
74458	1626	40213227	2006-10-29	2006-10-29 00:00:00	2006-10-29	2006-10-29 00:00:00	2006-10-29	581452		0	0	0		0	0	0	109219	0	113	40213227		
20568	1692	19115351	1982-08-15	1982-08-15 00:00:00	1982-12-19	1982-12-19 00:00:00	1982-12-19	38000177		0	0	126		0	0	0	113360	0	563026	19115351		
31083	2577	19134077	2013-10-18	2013-10-18 00:00:00	2013-11-08	2013-11-08 00:00:00	2013-11-08	38000177		0	0	21		0	0	0	170642	0	835900	19134077		
160472	3531	40213306	1990-06-13	1990-06-13 00:00:00	1990-06-13	1990-06-13 00:00:00	1990-06-13	581452		0	0	0		0	0	0	234579	0	43	40213306		
11233	935	40220960	1994-05-25	1994-05-25 00:00:00	1994-05-25	1994-05-25 00:00:00	1994-05-25	38000177		0	0	0		0	0	0	62162	0	1804799	40220960		
112966	2481	40213160	1970-03-29	1970-03-29 00:00:00	1970-03-29	1970-03-29 00:00:00	1970-03-29	581452		0	0	0		0	0	0	164358	0	10	40213160		
62851	5223	46233988	1971-10-28	1971-10-28 00:00:00	1971-11-11	1971-11-11 00:00:00	1971-11-11	38000177		0	0	14		0	0	0	347596	0	1652673	46233988		
88091	1933	40213227	1992-08-14	1992-08-14 00:00:00	1992-08-14	1992-08-14 00:00:00	1992-08-14	581452		0	0	0		0	0	0	128556	0	113	40213227		
40802	3382	19078461	2018-06-24	2018-06-24 00:00:00	2018-07-08	2018-07-08 00:00:00	2018-07-08	38000177		0	0	14		0	0	0	224461	0	310965	19078461		
3637	299	19128065	1978-11-20	1978-11-20 00:00:00	1979-11-15	1979-11-15 00:00:00	1979-11-15	38000177		0	0	360		0	0	0	19960	0	749882	19128065		
129789	2853	40213160	1962-04-10	1962-04-10 00:00:00	1962-04-10	1962-04-10 00:00:00	1962-04-10	581452		0	0	0		0	0	0	189516	0	10	40213160		
18568	1535	1127433	1989-01-03	1989-01-03 00:00:00	1989-01-17	1989-01-17 00:00:00	1989-01-17	38000177		0	0	14		0	0	0	102750	0	313782	1127433		
15386	1283	40165015	1971-06-23	1971-06-23 00:00:00	1971-06-23	1971-06-23 00:00:00	\N	38000177		0	0	0		0	0	0	84822	0	861467	40165015		
72678	1588	40213227	2012-04-01	2012-04-01 00:00:00	2012-04-01	2012-04-01 00:00:00	2012-04-01	581452		0	0	0		0	0	0	106564	0	113	40213227		
3440	286	19078461	2013-07-09	2013-07-09 00:00:00	2013-07-23	2013-07-23 00:00:00	2013-07-23	38000177		0	0	14		0	0	0	19045	0	310965	19078461		
51514	4282	19059056	1966-10-03	1966-10-03 00:00:00	1966-10-17	1966-10-17 00:00:00	1966-10-17	38000177		0	0	14		0	0	0	284200	0	243670	19059056		
39737	3287	1127433	1966-12-10	1966-12-10 00:00:00	1966-12-31	1966-12-31 00:00:00	1966-12-31	38000177		0	0	21		0	0	0	218351	0	313782	1127433		
31424	2604	1127433	1966-02-18	1966-02-18 00:00:00	1966-03-04	1966-03-04 00:00:00	1966-03-04	38000177		0	0	14		0	0	0	172253	0	313782	1127433		
76877	1679	40213160	1974-08-13	1974-08-13 00:00:00	1974-08-13	1974-08-13 00:00:00	1974-08-13	581452		0	0	0		0	0	0	\N	0	10	40213160		
47331	1033	40213306	1993-10-28	1993-10-28 00:00:00	1993-10-28	1993-10-28 00:00:00	1993-10-28	581452		0	0	0		0	0	0	68003	0	43	40213306		
158780	3495	40213227	2007-02-28	2007-02-28 00:00:00	2007-02-28	2007-02-28 00:00:00	2007-02-28	581452		0	0	0		0	0	0	231824	0	113	40213227		
242071	5314	40213160	1955-11-04	1955-11-04 00:00:00	1955-11-04	1955-11-04 00:00:00	1955-11-04	581452		0	0	0		0	0	0	353438	0	10	40213160		
242129	5316	40213227	2007-08-27	2007-08-27 00:00:00	2007-08-27	2007-08-27 00:00:00	2007-08-27	581452		0	0	0		0	0	0	353597	0	113	40213227		
46581	1018	40213160	1971-06-21	1971-06-21 00:00:00	1971-06-21	1971-06-21 00:00:00	1971-06-21	581452		0	0	0		0	0	0	67034	0	10	40213160		
17373	1439	19073183	1982-06-09	1982-06-09 00:00:00	1982-06-23	1982-06-23 00:00:00	1982-06-23	38000177		0	0	14		0	0	0	95924	0	308182	19073183		
61058	5078	1127433	1973-04-22	1973-04-22 00:00:00	1973-05-06	1973-05-06 00:00:00	1973-05-06	38000177		0	0	14		0	0	0	337503	0	313782	1127433		
17467	377	40213227	2009-01-01	2009-01-01 00:00:00	2009-01-01	2009-01-01 00:00:00	2009-01-01	581452		0	0	0		0	0	0	25007	0	113	40213227		
151487	3332	40213160	1965-11-16	1965-11-16 00:00:00	1965-11-16	1965-11-16 00:00:00	1965-11-16	581452		0	0	0		0	0	0	221115	0	10	40213160		
98861	2165	40213296	1996-06-11	1996-06-11 00:00:00	1996-06-11	1996-06-11 00:00:00	1996-06-11	581452		0	0	0		0	0	0	144261	0	52	40213296		
55031	4570	1124300	1972-08-02	1972-08-02 00:00:00	1972-08-02	1972-08-02 00:00:00	\N	38000177		0	0	0		0	0	0	304424	0	00781178901	45011828		
50836	4223	19059056	1975-04-21	1975-04-21 00:00:00	1975-05-12	1975-05-12 00:00:00	1975-05-12	38000177		0	0	21		0	0	0	280364	0	243670	19059056		
202168	4439	40213160	1955-08-17	1955-08-17 00:00:00	1955-08-17	1955-08-17 00:00:00	1955-08-17	581452		0	0	0		0	0	0	295151	0	10	40213160		
193288	4246	40213296	2009-09-02	2009-09-02 00:00:00	2009-09-02	2009-09-02 00:00:00	2009-09-02	581452		0	0	0		0	0	0	281968	0	52	40213296		
10410	869	19059056	1914-01-11	1914-01-11 00:00:00	1914-01-25	1914-01-25 00:00:00	1914-01-25	38000177		0	0	14		0	0	0	57796	0	243670	19059056		
58087	4826	1713671	1996-02-23	1996-02-23 00:00:00	1996-03-15	1996-03-15 00:00:00	1996-03-15	38000177		0	0	21		0	0	0	321030	0	562251	1713671		
216782	4757	40213227	2017-05-31	2017-05-31 00:00:00	2017-05-31	2017-05-31 00:00:00	2017-05-31	581452		0	0	0		0	0	0	316941	0	113	40213227		
185864	4084	40213160	1961-11-26	1961-11-26 00:00:00	1961-11-26	1961-11-26 00:00:00	1961-11-26	581452		0	0	0		0	0	0	271414	0	10	40213160		
185911	4085	40213227	2009-10-10	2009-10-10 00:00:00	2009-10-10	2009-10-10 00:00:00	2009-10-10	581452		0	0	0		0	0	0	271531	0	113	40213227		
63431	1387	40213260	2019-04-02	2019-04-02 00:00:00	2019-04-02	2019-04-02 00:00:00	2019-04-02	581452		0	0	0		0	0	0	91985	0	121	40213260		
101928	2235	40213260	2005-12-28	2005-12-28 00:00:00	2005-12-28	2005-12-28 00:00:00	2005-12-28	581452		0	0	0		0	0	0	148630	0	121	40213260		
2671	213	1127078	1970-11-11	1970-11-11 00:00:00	1970-11-25	1970-11-25 00:00:00	1970-11-25	38000177		0	0	14		0	0	0	14513	0	282464	1127078		
128288	2822	40213160	1976-06-02	1976-06-02 00:00:00	1976-06-02	1976-06-02 00:00:00	1976-06-02	581452		0	0	0		0	0	0	187000	0	10	40213160		
22544	1851	1127433	2000-11-08	2000-11-08 00:00:00	2000-11-15	2000-11-15 00:00:00	2000-11-15	38000177		0	0	7		0	0	0	123858	0	313782	1127433		
40586	3364	1127433	2012-07-29	2012-07-29 00:00:00	2012-08-26	2012-08-26 00:00:00	2012-08-26	38000177		0	0	28		0	0	0	223108	0	313782	1127433		
13334	1118	40236824	2000-09-06	2000-09-06 00:00:00	2000-09-13	2000-09-13 00:00:00	2000-09-13	38000177		0	0	7		0	0	0	73682	0	1094107	40236824		
75726	1655	40213296	2013-11-01	2013-11-01 00:00:00	2013-11-01	2013-11-01 00:00:00	2013-11-01	581452		0	0	0		0	0	0	111040	0	52	40213296		
50696	4212	1127433	2014-12-18	2014-12-18 00:00:00	2015-01-01	2015-01-01 00:00:00	2015-01-01	38000177		0	0	14		0	0	0	279666	0	313782	1127433		
147068	3234	40213160	1955-05-03	1955-05-03 00:00:00	1955-05-03	1955-05-03 00:00:00	1955-05-03	581452		0	0	0		0	0	0	214953	0	10	40213160		
228656	5022	40213227	2019-01-07	2019-01-07 00:00:00	2019-01-07	2019-01-07 00:00:00	2019-01-07	581452		0	0	0		0	0	0	333691	0	113	40213227		
61297	5099	19133873	1950-05-20	1950-05-20 00:00:00	1950-05-31	1950-05-31 00:00:00	1950-05-31	38000177		0	0	11		0	0	0	338861	0	834061	19133873		
61342	5103	19126352	2014-02-03	2014-02-03 00:00:00	2014-02-03	2014-02-03 00:00:00	\N	38000177		0	0	0		0	0	0	339080	0	705129	19126352		
53863	4476	1713671	1990-01-01	1990-01-01 00:00:00	1990-01-15	1990-01-15 00:00:00	1990-01-15	38000177		0	0	14		0	0	0	297829	0	562251	1713671		
226178	4967	40213260	2011-05-30	2011-05-30 00:00:00	2011-05-30	2011-05-30 00:00:00	2011-05-30	581452		0	0	0		0	0	0	330200	0	121	40213260		
9907	830	19059056	1961-04-14	1961-04-14 00:00:00	1961-04-28	1961-04-28 00:00:00	1961-04-28	38000177		0	0	14		0	0	0	54970	0	243670	19059056		
188020	4129	40213227	1992-05-11	1992-05-11 00:00:00	1992-05-11	1992-05-11 00:00:00	1992-05-11	581452		0	0	0		0	0	0	274514	0	113	40213227		
20427	1679	19019979	1974-01-02	1974-01-02 00:00:00	1974-01-16	1974-01-16 00:00:00	1974-01-16	38000177		0	0	14		0	0	0	112562	0	198405	19019979		
166155	3652	40213314	1977-08-14	1977-08-14 00:00:00	1977-08-14	1977-08-14 00:00:00	1977-08-14	581452		0	0	0		0	0	0	243094	0	49	40213314		
85744	1878	40213160	1980-02-23	1980-02-23 00:00:00	1980-02-23	1980-02-23 00:00:00	1980-02-23	581452		0	0	0		0	0	0	125342	0	10	40213160		
20569	1692	1713671	2000-08-05	2000-08-05 00:00:00	2000-08-12	2000-08-12 00:00:00	2000-08-12	38000177		0	0	7		0	0	0	113349	0	562251	1713671		
31084	2577	19008572	1983-04-05	1983-04-05 00:00:00	1983-04-26	1983-04-26 00:00:00	1983-04-26	38000177		0	0	21		0	0	0	170605	0	106258	19008572		
160475	3531	40213160	1967-09-06	1967-09-06 00:00:00	1967-09-06	1967-09-06 00:00:00	1967-09-06	581452		0	0	0		0	0	0	234546	0	10	40213160		
11234	935	1713671	1992-08-28	1992-08-28 00:00:00	1992-10-30	1992-10-30 00:00:00	1992-10-30	38000177		0	0	63		0	0	0	62201	0	562251	1713671		
112968	2481	40213306	1991-12-08	1991-12-08 00:00:00	1991-12-08	1991-12-08 00:00:00	1991-12-08	581452		0	0	0		0	0	0	164419	0	43	40213306		
62852	5223	1127433	1996-06-21	1996-06-21 00:00:00	1996-07-26	1996-07-26 00:00:00	1996-07-26	38000177		0	0	35		0	0	0	347545	0	313782	1127433		
88106	1933	40213160	1958-11-07	1958-11-07 00:00:00	1958-11-07	1958-11-07 00:00:00	1958-11-07	581452		0	0	0		0	0	0	128588	0	10	40213160		
40803	3382	19006318	1963-02-10	1963-02-10 00:00:00	1963-02-24	1963-02-24 00:00:00	1963-02-24	38000177		0	0	14		0	0	0	224440	0	105078	19006318		
3638	299	1127433	2015-07-29	2015-07-29 00:00:00	2015-08-26	2015-08-26 00:00:00	2015-08-26	38000177		0	0	28		0	0	0	20004	0	313782	1127433		
129793	2853	40213227	1993-02-16	1993-02-16 00:00:00	1993-02-16	1993-02-16 00:00:00	1993-02-16	581452		0	0	0		0	0	0	\N	0	113	40213227		
18569	1535	40229134	1980-09-20	1980-09-20 00:00:00	1980-09-27	1980-09-27 00:00:00	1980-09-27	38000177		0	0	7		0	0	0	102749	0	1043400	40229134		
15387	1283	1127433	1971-06-23	1971-06-23 00:00:00	1971-08-22	1971-08-22 00:00:00	1971-08-22	38000177		0	0	60		0	0	0	84822	0	313782	1127433		
72681	1588	40213306	1984-10-07	1984-10-07 00:00:00	1984-10-07	1984-10-07 00:00:00	1984-10-07	581452		0	0	0		0	0	0	\N	0	43	40213306		
3441	286	1127433	1978-12-30	1978-12-30 00:00:00	1979-02-05	1979-02-05 00:00:00	1979-02-05	38000177		0	0	37		0	0	0	19040	0	313782	1127433		
51515	4282	19129655	1966-10-03	1966-10-03 00:00:00	1966-10-17	1966-10-17 00:00:00	1966-10-17	38000177		0	0	14		0	0	0	284200	0	789980	19129655		
39738	3287	46275916	1967-07-10	1967-07-10 00:00:00	1967-07-10	1967-07-10 00:00:00	1967-07-10	38000177		0	0	0		0	0	0	218352	0	1660014	46275916		
31425	2604	19078461	1986-05-21	1986-05-21 00:00:00	1986-06-18	1986-06-18 00:00:00	1986-06-18	38000177		0	0	28		0	0	0	172313	0	310965	19078461		
76878	1679	40213160	1970-01-06	1970-01-06 00:00:00	1970-01-06	1970-01-06 00:00:00	1970-01-06	581452		0	0	0		0	0	0	112563	0	10	40213160		
47336	1033	40213160	1976-08-05	1976-08-05 00:00:00	1976-08-05	1976-08-05 00:00:00	1976-08-05	581452		0	0	0		0	0	0	67999	0	10	40213160		
158781	3495	40213296	2007-02-28	2007-02-28 00:00:00	2007-02-28	2007-02-28 00:00:00	2007-02-28	581452		0	0	0		0	0	0	231824	0	52	40213296		
219544	4819	40213160	1959-12-29	1959-12-29 00:00:00	1959-12-29	1959-12-29 00:00:00	1959-12-29	581452		0	0	0		0	0	0	320561	0	10	40213160		
242130	5316	40213260	2007-08-27	2007-08-27 00:00:00	2007-08-27	2007-08-27 00:00:00	2007-08-27	581452		0	0	0		0	0	0	353597	0	121	40213260		
200847	4411	40213227	2016-10-03	2016-10-03 00:00:00	2016-10-03	2016-10-03 00:00:00	2016-10-03	581452		0	0	0		0	0	0	293208	0	113	40213227		
17374	1439	1127078	1982-06-09	1982-06-09 00:00:00	1982-06-23	1982-06-23 00:00:00	1982-06-23	38000177		0	0	14		0	0	0	95924	0	282464	1127078		
61059	5078	1118084	1945-06-06	1945-06-06 00:00:00	1945-06-06	1945-06-06 00:00:00	\N	38000177		0	0	0		0	0	0	337594	0	00025152531	44923712		
57819	4804	19128065	1998-02-09	1998-02-09 00:00:00	1999-02-04	1999-02-04 00:00:00	1999-02-04	38000177		0	0	360		0	0	0	319589	0	749882	19128065		
151489	3332	40213306	1983-02-08	1983-02-08 00:00:00	1983-02-08	1983-02-08 00:00:00	1983-02-08	581452		0	0	0		0	0	0	221086	0	43	40213306		
98862	2165	40213227	1996-06-11	1996-06-11 00:00:00	1996-06-11	1996-06-11 00:00:00	1996-06-11	581452		0	0	0		0	0	0	144261	0	113	40213227		
55032	4570	19059056	1942-10-24	1942-10-24 00:00:00	1942-12-23	1942-12-23 00:00:00	1942-12-23	38000177		0	0	60		0	0	0	304452	0	243670	19059056		
50837	4223	19078461	2004-05-23	2004-05-23 00:00:00	2004-06-13	2004-06-13 00:00:00	2004-06-13	38000177		0	0	21		0	0	0	280366	0	310965	19078461		
202177	4439	40213160	1955-03-16	1955-03-16 00:00:00	1955-03-16	1955-03-16 00:00:00	1955-03-16	581452		0	0	0		0	0	0	295150	0	10	40213160		
215589	4729	40213227	2014-02-07	2014-02-07 00:00:00	2014-02-07	2014-02-07 00:00:00	2014-02-07	581452		0	0	0		0	0	0	315064	0	113	40213227		
10411	869	19018935	1993-04-23	1993-04-23 00:00:00	1993-04-23	1993-04-23 00:00:00	\N	38000177		0	0	0		0	0	0	57714	0	197604	19018935		
58088	4826	1713671	1994-12-16	1994-12-16 00:00:00	1994-12-23	1994-12-23 00:00:00	1994-12-23	38000177		0	0	7		0	0	0	321005	0	562251	1713671		
216791	4757	40213160	1956-07-04	1956-07-04 00:00:00	1956-07-04	1956-07-04 00:00:00	1956-07-04	581452		0	0	0		0	0	0	316898	0	10	40213160		
185868	4084	40213227	2003-08-31	2003-08-31 00:00:00	2003-08-31	2003-08-31 00:00:00	2003-08-31	581452		0	0	0		0	0	0	271371	0	113	40213227		
185912	4085	40213160	1959-06-13	1959-06-13 00:00:00	1959-06-13	1959-06-13 00:00:00	1959-06-13	581452		0	0	0		0	0	0	271460	0	10	40213160		
63434	1387	40213227	2000-09-05	2000-09-05 00:00:00	2000-09-05	2000-09-05 00:00:00	2000-09-05	581452		0	0	0		0	0	0	\N	0	113	40213227		
101937	2235	40213227	1993-12-15	1993-12-15 00:00:00	1993-12-15	1993-12-15 00:00:00	1993-12-15	581452		0	0	0		0	0	0	148629	0	113	40213227		
2672	213	1713671	2013-03-27	2013-03-27 00:00:00	2013-04-03	2013-04-03 00:00:00	2013-04-03	38000177		0	0	7		0	0	0	14478	0	562251	1713671		
128290	2822	40213314	1977-06-01	1977-06-01 00:00:00	1977-06-01	1977-06-01 00:00:00	1977-06-01	581452		0	0	0		0	0	0	186990	0	49	40213314		
56616	1239	40213160	1970-10-01	1970-10-01 00:00:00	1970-10-01	1970-10-01 00:00:00	1970-10-01	581452		0	0	0		0	0	0	81647	0	10	40213160		
40587	3364	40232448	1977-10-02	1977-10-02 00:00:00	1977-10-02	1977-10-02 00:00:00	\N	38000177		0	0	0		0	0	0	223078	0	1049630	40232448		
13335	1118	1115171	2001-02-21	2001-02-21 00:00:00	2001-03-21	2001-03-21 00:00:00	2001-03-21	38000177		0	0	28		0	0	0	73717	0	849574	1115171		
75733	1655	40213227	1993-11-12	1993-11-12 00:00:00	1993-11-12	1993-11-12 00:00:00	1993-11-12	581452		0	0	0		0	0	0	111002	0	113	40213227		
50707	4214	1127433	1998-10-24	1998-10-24 00:00:00	1998-10-31	1998-10-31 00:00:00	1998-10-31	38000177		0	0	7		0	0	0	279762	0	313782	1127433		
147074	3234	40213227	2008-12-29	2008-12-29 00:00:00	2008-12-29	2008-12-29 00:00:00	2008-12-29	581452		0	0	0		0	0	0	214944	0	113	40213227		
228657	5022	40213260	2019-01-07	2019-01-07 00:00:00	2019-01-07	2019-01-07 00:00:00	2019-01-07	581452		0	0	0		0	0	0	333691	0	121	40213260		
61298	5099	1713671	1949-03-09	1949-03-09 00:00:00	1949-03-16	1949-03-16 00:00:00	1949-03-16	38000177		0	0	7		0	0	0	338860	0	562251	1713671		
61343	5103	1127433	1967-12-29	1967-12-29 00:00:00	1968-01-05	1968-01-05 00:00:00	1968-01-05	38000177		0	0	7		0	0	0	339065	0	313782	1127433		
53864	4476	1127433	2008-08-03	2008-08-03 00:00:00	2008-08-10	2008-08-10 00:00:00	2008-08-10	38000177		0	0	7		0	0	0	297801	0	313782	1127433		
226180	4967	40213296	2001-06-04	2001-06-04 00:00:00	2001-06-04	2001-06-04 00:00:00	2001-06-04	581452		0	0	0		0	0	0	330198	0	52	40213296		
9908	830	19129655	1961-04-14	1961-04-14 00:00:00	1961-04-28	1961-04-28 00:00:00	1961-04-28	38000177		0	0	14		0	0	0	54970	0	789980	19129655		
188028	4129	40213201	2014-06-16	2014-06-16 00:00:00	2014-06-16	2014-06-16 00:00:00	2014-06-16	581452		0	0	0		0	0	0	274467	0	33	40213201		
20428	1679	19129655	1974-01-02	1974-01-02 00:00:00	1974-01-16	1974-01-16 00:00:00	1974-01-16	38000177		0	0	14		0	0	0	112562	0	789980	19129655		
166162	3652	40213160	1973-12-16	1973-12-16 00:00:00	1973-12-16	1973-12-16 00:00:00	1973-12-16	581452		0	0	0		0	0	0	243133	0	10	40213160		
85749	1878	40213227	2017-04-30	2017-04-30 00:00:00	2017-04-30	2017-04-30 00:00:00	2017-04-30	581452		0	0	0		0	0	0	125345	0	113	40213227		
20570	1692	19128022	1993-07-28	1993-07-28 00:00:00	1994-07-23	1994-07-23 00:00:00	1994-07-23	38000177		0	0	360		0	0	0	113326	0	749785	19128022		
31085	2577	19008572	1980-02-23	1980-02-23 00:00:00	1980-03-15	1980-03-15 00:00:00	1980-03-15	38000177		0	0	21		0	0	0	170649	0	106258	19008572		
31103	2578	1124300	2008-04-04	2008-04-04 00:00:00	2008-04-04	2008-04-04 00:00:00	\N	38000177		0	0	0		0	0	0	170753	0	00781178901	45011828		
11235	935	19133873	1946-02-19	1946-02-19 00:00:00	1946-02-26	1946-02-26 00:00:00	1946-02-26	38000177		0	0	7		0	0	0	62217	0	834061	19133873		
187908	4127	40213227	2018-10-28	2018-10-28 00:00:00	2018-10-28	2018-10-28 00:00:00	2018-10-28	581452		0	0	0		0	0	0	274382	0	113	40213227		
62853	5223	1118084	2004-10-27	2004-10-27 00:00:00	2004-10-27	2004-10-27 00:00:00	\N	38000177		0	0	0		0	0	0	347553	0	00025152531	44923712		
88108	1933	40213227	2000-06-09	2000-06-09 00:00:00	2000-06-09	2000-06-09 00:00:00	2000-06-09	581452		0	0	0		0	0	0	128584	0	113	40213227		
40804	3382	19059056	1963-02-10	1963-02-10 00:00:00	1963-02-24	1963-02-24 00:00:00	1963-02-24	38000177		0	0	14		0	0	0	224440	0	243670	19059056		
3639	299	40163554	2018-06-30	2018-06-30 00:00:00	2018-06-30	2018-06-30 00:00:00	\N	38000177		0	0	0		0	0	0	19986	0	855332	40163554		
124480	2739	40213160	1958-02-26	1958-02-26 00:00:00	1958-02-26	1958-02-26 00:00:00	1958-02-26	581452		0	0	0		0	0	0	181231	0	10	40213160		
18570	1535	40229134	1998-03-29	1998-03-29 00:00:00	1998-04-05	1998-04-05 00:00:00	1998-04-05	38000177		0	0	7		0	0	0	102753	0	1043400	40229134		
15388	1283	19128065	1976-02-25	1976-02-25 00:00:00	1977-02-19	1977-02-19 00:00:00	1977-02-19	38000177		0	0	360		0	0	0	84788	0	749882	19128065		
72686	1588	40213260	2011-03-27	2011-03-27 00:00:00	2011-03-27	2011-03-27 00:00:00	2011-03-27	581452		0	0	0		0	0	0	106609	0	121	40213260		
3442	286	40165015	1976-10-11	1976-10-11 00:00:00	1976-10-11	1976-10-11 00:00:00	\N	38000177		0	0	0		0	0	0	19088	0	861467	40165015		
51516	4282	19059056	1969-02-01	1969-02-01 00:00:00	1969-02-15	1969-02-15 00:00:00	1969-02-15	38000177		0	0	14		0	0	0	284163	0	243670	19059056		
39739	3287	40243436	1967-07-10	1967-07-10 00:00:00	1967-07-10	1967-07-10 00:00:00	1967-07-10	38000177		0	0	0		0	0	0	218352	0	1190795	40243436		
31426	2604	19006318	1957-04-04	1957-04-04 00:00:00	1957-04-18	1957-04-18 00:00:00	1957-04-18	38000177		0	0	14		0	0	0	172280	0	105078	19006318		
76880	1679	40213160	1970-03-10	1970-03-10 00:00:00	1970-03-10	1970-03-10 00:00:00	1970-03-10	581452		0	0	0		0	0	0	112594	0	10	40213160		
47338	1033	40213227	2013-08-15	2013-08-15 00:00:00	2013-08-15	2013-08-15 00:00:00	2013-08-15	581452		0	0	0		0	0	0	68029	0	113	40213227		
158783	3495	40213160	1966-02-23	1966-02-23 00:00:00	1966-02-23	1966-02-23 00:00:00	1966-02-23	581452		0	0	0		0	0	0	231831	0	10	40213160		
219546	4819	40213227	2001-10-02	2001-10-02 00:00:00	2001-10-02	2001-10-02 00:00:00	2001-10-02	581452		0	0	0		0	0	0	320541	0	113	40213227		
242134	5316	40213160	1956-11-26	1956-11-26 00:00:00	1956-11-26	1956-11-26 00:00:00	1956-11-26	581452		0	0	0		0	0	0	353570	0	10	40213160		
200859	4411	40213198	2010-08-30	2010-08-30 00:00:00	2010-08-30	2010-08-30 00:00:00	2010-08-30	581452		0	0	0		0	0	0	293224	0	133	40213198		
17375	1439	19078461	1991-10-29	1991-10-29 00:00:00	1992-01-27	1992-01-27 00:00:00	1992-01-27	38000177		0	0	90		0	0	0	95876	0	310965	19078461		
61060	5078	1127433	1987-06-01	1987-06-01 00:00:00	1987-07-06	1987-07-06 00:00:00	1987-07-06	38000177		0	0	35		0	0	0	337527	0	313782	1127433		
57820	4804	19128022	1992-03-12	1992-03-12 00:00:00	1993-03-07	1993-03-07 00:00:00	1993-03-07	38000177		0	0	360		0	0	0	319646	0	749785	19128022		
190196	4176	40213227	1992-07-02	1992-07-02 00:00:00	1992-07-02	1992-07-02 00:00:00	1992-07-02	581452		0	0	0		0	0	0	277463	0	113	40213227		
98865	2165	40213160	1955-05-10	1955-05-10 00:00:00	1955-05-10	1955-05-10 00:00:00	1955-05-10	581452		0	0	0		0	0	0	144229	0	10	40213160		
55033	4570	1713671	1958-10-04	1958-10-04 00:00:00	1958-10-18	1958-10-18 00:00:00	1958-10-18	38000177		0	0	14		0	0	0	304455	0	562251	1713671		
50838	4223	1127433	1997-05-16	1997-05-16 00:00:00	1997-05-30	1997-05-30 00:00:00	1997-05-30	38000177		0	0	14		0	0	0	280365	0	313782	1127433		
202185	4439	40213260	2007-12-26	2007-12-26 00:00:00	2007-12-26	2007-12-26 00:00:00	2007-12-26	581452		0	0	0		0	0	0	295092	0	121	40213260		
215590	4729	40213260	2014-02-07	2014-02-07 00:00:00	2014-02-07	2014-02-07 00:00:00	2014-02-07	581452		0	0	0		0	0	0	315064	0	121	40213260		
10412	869	40171902	1993-04-23	1993-04-23 00:00:00	1993-04-23	1993-04-23 00:00:00	\N	38000177		0	0	0		0	0	0	57714	0	897718	40171902		
58089	4826	1713671	2005-10-16	2005-10-16 00:00:00	2005-10-30	2005-10-30 00:00:00	2005-10-30	38000177		0	0	14		0	0	0	321044	0	562251	1713671		
216799	4757	40213227	2007-04-04	2007-04-04 00:00:00	2007-04-04	2007-04-04 00:00:00	2007-04-04	581452		0	0	0		0	0	0	316958	0	113	40213227		
185869	4084	40213296	2003-08-31	2003-08-31 00:00:00	2003-08-31	2003-08-31 00:00:00	2003-08-31	581452		0	0	0		0	0	0	271371	0	52	40213296		
50999	1117	40213227	1997-02-22	1997-02-22 00:00:00	1997-02-22	1997-02-22 00:00:00	1997-02-22	581452		0	0	0		0	0	0	73661	0	113	40213227		
63436	1387	40213160	1969-09-09	1969-09-09 00:00:00	1969-09-09	1969-09-09 00:00:00	1969-09-09	581452		0	0	0		0	0	0	91965	0	10	40213160		
101938	2235	40213160	1955-05-11	1955-05-11 00:00:00	1955-05-11	1955-05-11 00:00:00	1955-05-11	581452		0	0	0		0	0	0	148684	0	10	40213160		
2673	213	1127433	2013-10-01	2013-10-01 00:00:00	2013-10-15	2013-10-15 00:00:00	2013-10-15	38000177		0	0	14		0	0	0	14503	0	313782	1127433		
128291	2822	40213227	1999-10-13	1999-10-13 00:00:00	1999-10-13	1999-10-13 00:00:00	1999-10-13	581452		0	0	0		0	0	0	187024	0	113	40213227		
56620	1239	40213296	2012-07-05	2012-07-05 00:00:00	2012-07-05	2012-07-05 00:00:00	2012-07-05	581452		0	0	0		0	0	0	81682	0	52	40213296		
40588	3364	42902245	1998-05-10	1998-05-10 00:00:00	1999-05-05	1999-05-05 00:00:00	1999-05-05	38000177		0	0	360		0	0	0	223074	0	1359133	42902245		
13336	1118	19128022	1995-06-28	1995-06-28 00:00:00	1996-06-22	1996-06-22 00:00:00	1996-06-22	38000177		0	0	360		0	0	0	73708	0	749785	19128022		
75734	1655	40213306	1993-11-12	1993-11-12 00:00:00	1993-11-12	1993-11-12 00:00:00	1993-11-12	581452		0	0	0		0	0	0	111002	0	43	40213306		
50708	4214	19133905	2008-01-17	2008-01-17 00:00:00	2008-01-27	2008-01-27 00:00:00	2008-01-27	38000177		0	0	10		0	0	0	279796	0	834102	19133905		
57786	1265	40213160	1985-02-10	1985-02-10 00:00:00	1985-02-10	1985-02-10 00:00:00	1985-02-10	581452		0	0	0		0	0	0	83409	0	10	40213160		
228662	5023	40213296	2016-03-06	2016-03-06 00:00:00	2016-03-06	2016-03-06 00:00:00	2016-03-06	581452		0	0	0		0	0	0	333797	0	52	40213296		
61299	5099	1127433	1969-02-13	1969-02-13 00:00:00	1969-02-27	1969-02-27 00:00:00	1969-02-27	38000177		0	0	14		0	0	0	338868	0	313782	1127433		
61344	5103	1713671	2019-03-31	2019-03-31 00:00:00	2019-04-14	2019-04-14 00:00:00	2019-04-14	38000177		0	0	14		0	0	0	339122	0	562251	1713671		
53865	4476	19059056	1971-06-01	1971-06-01 00:00:00	1971-06-15	1971-06-15 00:00:00	1971-06-15	38000177		0	0	14		0	0	0	297895	0	243670	19059056		
226188	4967	40213306	1983-07-11	1983-07-11 00:00:00	1983-07-11	1983-07-11 00:00:00	1983-07-11	581452		0	0	0		0	0	0	330177	0	43	40213306		
9909	830	19133905	2016-09-21	2016-09-21 00:00:00	2016-09-30	2016-09-30 00:00:00	2016-09-30	38000177		0	0	9		0	0	0	55013	0	834102	19133905		
188032	4129	40213160	1955-04-18	1955-04-18 00:00:00	1955-04-18	1955-04-18 00:00:00	1955-04-18	581452		0	0	0		0	0	0	274461	0	10	40213160		
20429	1679	1127078	1973-09-09	1973-09-09 00:00:00	1973-09-23	1973-09-23 00:00:00	1973-09-23	38000177		0	0	14		0	0	0	112585	0	282464	1127078		
166165	3652	40213160	1974-02-17	1974-02-17 00:00:00	1974-02-17	1974-02-17 00:00:00	1974-02-17	581452		0	0	0		0	0	0	243126	0	10	40213160		
85750	1878	40213296	2017-04-30	2017-04-30 00:00:00	2017-04-30	2017-04-30 00:00:00	2017-04-30	581452		0	0	0		0	0	0	125345	0	52	40213296		
20571	1692	1713671	2016-04-24	2016-04-24 00:00:00	2016-05-08	2016-05-08 00:00:00	2016-05-08	38000177		0	0	14		0	0	0	113362	0	562251	1713671		
31086	2577	19008572	1989-11-22	1989-11-22 00:00:00	1989-12-13	1989-12-13 00:00:00	1989-12-13	38000177		0	0	21		0	0	0	170587	0	106258	19008572		
31104	2578	40229134	2008-03-06	2008-03-06 00:00:00	2008-03-20	2008-03-20 00:00:00	2008-03-20	38000177		0	0	14		0	0	0	170753	0	1043400	40229134		
11236	935	19059056	1936-04-09	1936-04-09 00:00:00	1936-07-08	1936-07-08 00:00:00	1936-07-08	38000177		0	0	90		0	0	0	62225	0	243670	19059056		
187910	4127	40213227	2008-08-31	2008-08-31 00:00:00	2008-08-31	2008-08-31 00:00:00	2008-08-31	581452		0	0	0		0	0	0	274396	0	113	40213227		
62854	5223	19133873	1972-06-08	1972-06-08 00:00:00	1972-06-17	1972-06-17 00:00:00	1972-06-17	38000177		0	0	9		0	0	0	347586	0	834061	19133873		
88109	1933	40213296	2000-06-09	2000-06-09 00:00:00	2000-06-09	2000-06-09 00:00:00	2000-06-09	581452		0	0	0		0	0	0	128584	0	52	40213296		
40805	3382	1713671	1998-10-14	1998-10-14 00:00:00	1998-10-28	1998-10-28 00:00:00	1998-10-28	38000177		0	0	14		0	0	0	224420	0	562251	1713671		
3640	299	19018935	2018-06-30	2018-06-30 00:00:00	2018-06-30	2018-06-30 00:00:00	\N	38000177		0	0	0		0	0	0	19986	0	197604	19018935		
124483	2739	40213227	1995-03-29	1995-03-29 00:00:00	1995-03-29	1995-03-29 00:00:00	1995-03-29	581452		0	0	0		0	0	0	181243	0	113	40213227		
18571	1535	1127078	1979-10-03	1979-10-03 00:00:00	1979-10-17	1979-10-17 00:00:00	1979-10-17	38000177		0	0	14		0	0	0	102704	0	282464	1127078		
12212	263	40213160	1959-05-31	1959-05-31 00:00:00	1959-05-31	1959-05-31 00:00:00	1959-05-31	581452		0	0	0		0	0	0	17431	0	10	40213160		
72689	1588	40213160	1961-03-12	1961-03-12 00:00:00	1961-03-12	1961-03-12 00:00:00	1961-03-12	581452		0	0	0		0	0	0	106620	0	10	40213160		
3443	286	1127433	1975-10-26	1975-10-26 00:00:00	1975-11-09	1975-11-09 00:00:00	1975-11-09	38000177		0	0	14		0	0	0	19037	0	313782	1127433		
51517	4282	46233988	1969-02-01	1969-02-01 00:00:00	1969-02-15	1969-02-15 00:00:00	1969-02-15	38000177		0	0	14		0	0	0	284163	0	1652673	46233988		
39740	3287	1310034	1967-07-10	1967-07-10 00:00:00	1967-07-10	1967-07-10 00:00:00	1967-07-10	38000177		0	0	0		0	0	0	218352	0	834357	1310034		
31427	2604	19059056	1957-04-04	1957-04-04 00:00:00	1957-04-18	1957-04-18 00:00:00	1957-04-18	38000177		0	0	14		0	0	0	172280	0	243670	19059056		
76882	1679	40213227	2000-11-21	2000-11-21 00:00:00	2000-11-21	2000-11-21 00:00:00	2000-11-21	581452		0	0	0		0	0	0	112584	0	113	40213227		
47339	1033	40213296	2013-08-15	2013-08-15 00:00:00	2013-08-15	2013-08-15 00:00:00	2013-08-15	581452		0	0	0		0	0	0	68029	0	52	40213296		
158791	3495	40213227	1999-02-17	1999-02-17 00:00:00	1999-02-17	1999-02-17 00:00:00	1999-02-17	581452		0	0	0		0	0	0	231823	0	113	40213227		
219547	4819	40213296	2001-10-02	2001-10-02 00:00:00	2001-10-02	2001-10-02 00:00:00	2001-10-02	581452		0	0	0		0	0	0	320541	0	52	40213296		
219591	4820	40213260	2006-01-26	2006-01-26 00:00:00	2006-01-26	2006-01-26 00:00:00	2006-01-26	581452		0	0	0		0	0	0	320628	0	121	40213260		
200878	4411	40213227	1996-04-22	1996-04-22 00:00:00	1996-04-22	1996-04-22 00:00:00	1996-04-22	581452		0	0	0		0	0	0	293196	0	113	40213227		
17376	1439	40229134	2003-07-20	2003-07-20 00:00:00	2003-07-27	2003-07-27 00:00:00	2003-07-27	38000177		0	0	7		0	0	0	95880	0	1043400	40229134		
61061	5078	1713671	1915-07-27	1915-07-27 00:00:00	1915-08-17	1915-08-17 00:00:00	1915-08-17	38000177		0	0	21		0	0	0	337563	0	562251	1713671		
57821	4804	1127433	1994-08-07	1994-08-07 00:00:00	1994-08-14	1994-08-14 00:00:00	1994-08-14	38000177		0	0	7		0	0	0	319563	0	313782	1127433		
229246	5037	40213314	1978-04-26	1978-04-26 00:00:00	1978-04-26	1978-04-26 00:00:00	1978-04-26	581452		0	0	0		0	0	0	334792	0	49	40213314		
98871	2165	40213227	2015-07-14	2015-07-14 00:00:00	2015-07-14	2015-07-14 00:00:00	2015-07-14	581452		0	0	0		0	0	0	144264	0	113	40213227		
55034	4570	19133873	1947-07-29	1947-07-29 00:00:00	1947-08-11	1947-08-11 00:00:00	1947-08-11	38000177		0	0	13		0	0	0	304509	0	834061	19133873		
50839	4223	19059056	1972-04-06	1972-04-06 00:00:00	1972-07-05	1972-07-05 00:00:00	1972-07-05	38000177		0	0	90		0	0	0	280378	0	243670	19059056		
202187	4439	40213260	2006-12-20	2006-12-20 00:00:00	2006-12-20	2006-12-20 00:00:00	2006-12-20	581452		0	0	0		0	0	0	295083	0	121	40213260		
215592	4729	40213306	1985-01-04	1985-01-04 00:00:00	1985-01-04	1985-01-04 00:00:00	1985-01-04	581452		0	0	0		0	0	0	\N	0	43	40213306		
10413	869	40163554	1993-04-23	1993-04-23 00:00:00	1993-04-23	1993-04-23 00:00:00	\N	38000177		0	0	0		0	0	0	57714	0	855332	40163554		
58090	4826	19059056	1967-11-26	1967-11-26 00:00:00	1967-12-26	1967-12-26 00:00:00	1967-12-26	38000177		0	0	30		0	0	0	320985	0	243670	19059056		
216800	4757	40213260	2007-04-04	2007-04-04 00:00:00	2007-04-04	2007-04-04 00:00:00	2007-04-04	581452		0	0	0		0	0	0	316958	0	121	40213260		
185874	4084	40213160	1962-04-29	1962-04-29 00:00:00	1962-04-29	1962-04-29 00:00:00	1962-04-29	581452		0	0	0		0	0	0	271415	0	10	40213160		
51012	1117	40213227	2007-04-21	2007-04-21 00:00:00	2007-04-21	2007-04-21 00:00:00	2007-04-21	581452		0	0	0		0	0	0	73640	0	113	40213227		
47840	1046	40213296	2011-05-15	2011-05-15 00:00:00	2011-05-15	2011-05-15 00:00:00	2011-05-15	581452		0	0	0		0	0	0	68694	0	52	40213296		
101953	2235	40213227	2002-12-11	2002-12-11 00:00:00	2002-12-11	2002-12-11 00:00:00	2002-12-11	581452		0	0	0		0	0	0	148665	0	113	40213227		
2674	213	1127433	1993-06-27	1993-06-27 00:00:00	1993-08-01	1993-08-01 00:00:00	1993-08-01	38000177		0	0	35		0	0	0	14536	0	313782	1127433		
128292	2822	40213306	1999-10-13	1999-10-13 00:00:00	1999-10-13	1999-10-13 00:00:00	1999-10-13	581452		0	0	0		0	0	0	187024	0	43	40213306		
56623	1239	40213227	1992-08-27	1992-08-27 00:00:00	1992-08-27	1992-08-27 00:00:00	1992-08-27	581452		0	0	0		0	0	0	81680	0	113	40213227		
40589	3364	920300	2007-07-11	2007-07-11 00:00:00	2007-07-18	2007-07-18 00:00:00	2007-07-18	38000177		0	0	7		0	0	0	223090	0	311989	920300		
13337	1118	19073188	1990-06-03	1990-06-03 00:00:00	1990-06-17	1990-06-17 00:00:00	1990-06-17	38000177		0	0	14		0	0	0	73752	0	308192	19073188		
75736	1655	40213160	1972-03-10	1972-03-10 00:00:00	1972-03-10	1972-03-10 00:00:00	1972-03-10	581452		0	0	0		0	0	0	110986	0	10	40213160		
50709	4214	1118084	2005-07-13	2005-07-13 00:00:00	2005-07-13	2005-07-13 00:00:00	\N	38000177		0	0	0		0	0	0	279795	0	00025152531	44923712		
57787	1265	40213251	1985-02-10	1985-02-10 00:00:00	1985-02-10	1985-02-10 00:00:00	1985-02-10	581452		0	0	0		0	0	0	83409	0	21	40213251		
228663	5023	40213227	1994-09-18	1994-09-18 00:00:00	1994-09-18	1994-09-18 00:00:00	1994-09-18	581452		0	0	0		0	0	0	\N	0	113	40213227		
61300	5099	1118084	1978-09-18	1978-09-18 00:00:00	1978-09-18	1978-09-18 00:00:00	\N	38000177		0	0	0		0	0	0	338902	0	00025152531	44923712		
61345	5103	1118084	1985-02-12	1985-02-12 00:00:00	1985-02-12	1985-02-12 00:00:00	\N	38000177		0	0	0		0	0	0	339098	0	00025152531	44923712		
53866	4476	920300	1989-03-10	1989-03-10 00:00:00	1989-03-17	1989-03-17 00:00:00	1989-03-17	38000177		0	0	7		0	0	0	297828	0	311989	920300		
226191	4967	40213227	2003-06-09	2003-06-09 00:00:00	2003-06-09	2003-06-09 00:00:00	2003-06-09	581452		0	0	0		0	0	0	330189	0	113	40213227		
9910	830	1127433	1981-09-22	1981-09-22 00:00:00	1981-10-06	1981-10-06 00:00:00	1981-10-06	38000177		0	0	14		0	0	0	55008	0	313782	1127433		
188044	4129	40213227	1999-05-03	1999-05-03 00:00:00	1999-05-03	1999-05-03 00:00:00	1999-05-03	581452		0	0	0		0	0	0	274515	0	113	40213227		
20430	1679	1118084	2009-06-12	2009-06-12 00:00:00	2009-06-12	2009-06-12 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00025152531	44923712		
166168	3652	40213227	1996-06-02	1996-06-02 00:00:00	1996-06-02	1996-06-02 00:00:00	1996-06-02	581452		0	0	0		0	0	0	243140	0	113	40213227		
85752	1878	40213160	1975-08-24	1975-08-24 00:00:00	1975-08-24	1975-08-24 00:00:00	1975-08-24	581452		0	0	0		0	0	0	125339	0	10	40213160		
20581	1695	40236824	2018-04-24	2018-04-24 00:00:00	2018-05-08	2018-05-08 00:00:00	2018-05-08	38000177		0	0	14		0	0	0	113492	0	1094107	40236824		
31087	2577	40229134	1992-01-17	1992-01-17 00:00:00	1992-01-31	1992-01-31 00:00:00	1992-01-31	38000177		0	0	14		0	0	0	170675	0	1043400	40229134		
31105	2579	1127433	2006-01-14	2006-01-14 00:00:00	2006-01-28	2006-01-28 00:00:00	2006-01-28	38000177		0	0	14		0	0	0	170850	0	313782	1127433		
11237	935	19059056	1976-11-05	1976-11-05 00:00:00	1976-11-19	1976-11-19 00:00:00	1976-11-19	38000177		0	0	14		0	0	0	62227	0	243670	19059056		
121925	2680	40213227	1993-09-09	1993-09-09 00:00:00	1993-09-09	1993-09-09 00:00:00	1993-09-09	581452		0	0	0		0	0	0	177577	0	113	40213227		
62855	5223	19128065	1983-01-11	1983-01-11 00:00:00	1984-01-06	1984-01-06 00:00:00	1984-01-06	38000177		0	0	360		0	0	0	347568	0	749882	19128065		
88116	1933	40213260	2008-05-30	2008-05-30 00:00:00	2008-05-30	2008-05-30 00:00:00	2008-05-30	581452		0	0	0		0	0	0	128560	0	121	40213260		
40806	3383	19127904	2011-02-15	2011-02-15 00:00:00	2012-02-10	2012-02-10 00:00:00	2012-02-10	38000177		0	0	360		0	0	0	224487	0	748856	19127904		
3641	299	40171902	2018-06-30	2018-06-30 00:00:00	2018-06-30	2018-06-30 00:00:00	\N	38000177		0	0	0		0	0	0	19986	0	897718	40171902		
124496	2739	40213296	1997-04-02	1997-04-02 00:00:00	1997-04-02	1997-04-02 00:00:00	1997-04-02	581452		0	0	0		0	0	0	181236	0	52	40213296		
18572	1535	19073183	1979-10-03	1979-10-03 00:00:00	1979-10-17	1979-10-17 00:00:00	1979-10-17	38000177		0	0	14		0	0	0	102704	0	308182	19073183		
12214	263	40213160	1955-03-06	1955-03-06 00:00:00	1955-03-06	1955-03-06 00:00:00	1955-03-06	581452		0	0	0		0	0	0	\N	0	10	40213160		
72697	1588	40213160	1961-05-14	1961-05-14 00:00:00	1961-05-14	1961-05-14 00:00:00	1961-05-14	581452		0	0	0		0	0	0	106594	0	10	40213160		
3444	286	1127433	1973-07-19	1973-07-19 00:00:00	1973-07-26	1973-07-26 00:00:00	1973-07-26	38000177		0	0	7		0	0	0	19119	0	313782	1127433		
51518	4282	19059056	1970-02-14	1970-02-14 00:00:00	1970-03-16	1970-03-16 00:00:00	1970-03-16	38000177		0	0	30		0	0	0	284192	0	243670	19059056		
39741	3287	1713671	1981-04-12	1981-04-12 00:00:00	1981-04-26	1981-04-26 00:00:00	1981-04-26	38000177		0	0	14		0	0	0	218293	0	562251	1713671		
31428	2604	1127433	2000-07-02	2000-07-02 00:00:00	2000-07-16	2000-07-16 00:00:00	2000-07-16	38000177		0	0	14		0	0	0	172315	0	313782	1127433		
64552	1412	40213296	2002-03-09	2002-03-09 00:00:00	2002-03-09	2002-03-09 00:00:00	2002-03-09	581452		0	0	0		0	0	0	\N	0	52	40213296		
47343	1033	40213160	1972-01-13	1972-01-13 00:00:00	1972-01-13	1972-01-13 00:00:00	1972-01-13	581452		0	0	0		0	0	0	68020	0	10	40213160		
158793	3495	40213260	2016-11-09	2016-11-09 00:00:00	2016-11-09	2016-11-09 00:00:00	2016-11-09	581452		0	0	0		0	0	0	231841	0	121	40213260		
219564	4819	40213260	2010-09-28	2010-09-28 00:00:00	2010-09-28	2010-09-28 00:00:00	2010-09-28	581452		0	0	0		0	0	0	320551	0	121	40213260		
219593	4820	40213160	1956-07-05	1956-07-05 00:00:00	1956-07-05	1956-07-05 00:00:00	1956-07-05	581452		0	0	0		0	0	0	320609	0	10	40213160		
206005	4521	40213227	1999-06-03	1999-06-03 00:00:00	1999-06-03	1999-06-03 00:00:00	1999-06-03	581452		0	0	0		0	0	0	301022	0	113	40213227		
17377	1439	1118084	2018-12-26	2018-12-26 00:00:00	2018-12-26	2018-12-26 00:00:00	\N	38000177		0	0	0		0	0	0	95886	0	00025152531	44923712		
61062	5078	19126352	1980-07-07	1980-07-07 00:00:00	1980-07-07	1980-07-07 00:00:00	\N	38000177		0	0	0		0	0	0	337584	0	705129	19126352		
57822	4804	1551192	1990-09-10	1990-09-10 00:00:00	1990-09-10	1990-09-10 00:00:00	1990-09-10	38000177		0	0	0		0	0	0	319591	0	312617	1551192		
229251	5037	40213160	1977-10-26	1977-10-26 00:00:00	1977-10-26	1977-10-26 00:00:00	1977-10-26	581452		0	0	0		0	0	0	334802	0	10	40213160		
98873	2165	40213160	1959-04-28	1959-04-28 00:00:00	1959-04-28	1959-04-28 00:00:00	1959-04-28	581452		0	0	0		0	0	0	144232	0	10	40213160		
55035	4570	1127433	1964-08-30	1964-08-30 00:00:00	1964-09-13	1964-09-13 00:00:00	1964-09-13	38000177		0	0	14		0	0	0	304482	0	313782	1127433		
50840	4224	1127078	1950-11-14	1950-11-14 00:00:00	1951-01-20	1951-01-20 00:00:00	1951-01-20	38000177		0	0	67		0	0	0	280589	0	282464	1127078		
202190	4439	40213227	2016-02-10	2016-02-10 00:00:00	2016-02-10	2016-02-10 00:00:00	2016-02-10	581452		0	0	0		0	0	0	295118	0	113	40213227		
215595	4729	40213306	1985-05-24	1985-05-24 00:00:00	1985-05-24	1985-05-24 00:00:00	1985-05-24	581452		0	0	0		0	0	0	315061	0	43	40213306		
10414	869	19059056	1915-12-02	1915-12-02 00:00:00	1915-12-16	1915-12-16 00:00:00	1915-12-16	38000177		0	0	14		0	0	0	57768	0	243670	19059056		
58091	4826	19073188	2019-05-18	2019-05-18 00:00:00	2019-06-22	2019-06-22 00:00:00	2019-06-22	38000177		0	0	35		0	0	0	320988	0	308192	19073188		
216805	4757	40213227	1998-09-30	1998-09-30 00:00:00	1998-09-30	1998-09-30 00:00:00	1998-09-30	581452		0	0	0		0	0	0	316919	0	113	40213227		
21377	464	40213227	2003-07-29	2003-07-29 00:00:00	2003-07-29	2003-07-29 00:00:00	2003-07-29	581452		0	0	0		0	0	0	30969	0	113	40213227		
62293	1360	40213160	1976-06-13	1976-06-13 00:00:00	1976-06-13	1976-06-13 00:00:00	1976-06-13	581452		0	0	0		0	0	0	90287	0	10	40213160		
47854	1046	40213227	2003-03-30	2003-03-30 00:00:00	2003-03-30	2003-03-30 00:00:00	2003-03-30	581452		0	0	0		0	0	0	68659	0	113	40213227		
47870	1046	40213306	1993-11-28	1993-11-28 00:00:00	1993-11-28	1993-11-28 00:00:00	1993-11-28	581452		0	0	0		0	0	0	68657	0	43	40213306		
2675	213	1127433	1988-05-10	1988-05-10 00:00:00	1988-05-24	1988-05-24 00:00:00	1988-05-24	38000177		0	0	14		0	0	0	14535	0	313782	1127433		
128297	2822	40213227	2007-09-19	2007-09-19 00:00:00	2007-09-19	2007-09-19 00:00:00	2007-09-19	581452		0	0	0		0	0	0	187025	0	113	40213227		
56624	1239	40213306	1992-08-27	1992-08-27 00:00:00	1992-08-27	1992-08-27 00:00:00	1992-08-27	581452		0	0	0		0	0	0	81680	0	43	40213306		
40590	3364	40236824	2007-07-11	2007-07-11 00:00:00	2007-07-18	2007-07-18 00:00:00	2007-07-18	38000177		0	0	7		0	0	0	223090	0	1094107	40236824		
13338	1118	1127433	1990-06-03	1990-06-03 00:00:00	1990-06-17	1990-06-17 00:00:00	1990-06-17	38000177		0	0	14		0	0	0	73752	0	313782	1127433		
75740	1655	40213160	1972-01-07	1972-01-07 00:00:00	1972-01-07	1972-01-07 00:00:00	1972-01-07	581452		0	0	0		0	0	0	111013	0	10	40213160		
50710	4214	1127433	1981-12-13	1981-12-13 00:00:00	1981-12-20	1981-12-20 00:00:00	1981-12-20	38000177		0	0	7		0	0	0	279773	0	313782	1127433		
57789	1265	40213227	2011-07-03	2011-07-03 00:00:00	2011-07-03	2011-07-03 00:00:00	2011-07-03	581452		0	0	0		0	0	0	83395	0	113	40213227		
228664	5023	40213306	1994-09-18	1994-09-18 00:00:00	1994-09-18	1994-09-18 00:00:00	1994-09-18	581452		0	0	0		0	0	0	\N	0	43	40213306		
61301	5099	40229134	1949-10-01	1949-10-01 00:00:00	1949-10-08	1949-10-08 00:00:00	1949-10-08	38000177		0	0	7		0	0	0	338829	0	1043400	40229134		
61346	5103	1713671	1948-04-10	1948-04-10 00:00:00	1948-04-24	1948-04-24 00:00:00	1948-04-24	38000177		0	0	14		0	0	0	339092	0	562251	1713671		
53867	4476	40236824	1989-03-10	1989-03-10 00:00:00	1989-03-17	1989-03-17 00:00:00	1989-03-17	38000177		0	0	7		0	0	0	297828	0	1094107	40236824		
226193	4967	40213160	1961-11-06	1961-11-06 00:00:00	1961-11-06	1961-11-06 00:00:00	1961-11-06	581452		0	0	0		0	0	0	330148	0	10	40213160		
77692	1699	40213306	1988-06-05	1988-06-05 00:00:00	1988-06-05	1988-06-05 00:00:00	1988-06-05	581452		0	0	0		0	0	0	113608	0	43	40213306		
188049	4129	40213227	2010-03-15	2010-03-15 00:00:00	2010-03-15	2010-03-15 00:00:00	2010-03-15	581452		0	0	0		0	0	0	274489	0	113	40213227		
20431	1679	19133873	1974-08-06	1974-08-06 00:00:00	1974-08-17	1974-08-17 00:00:00	1974-08-17	38000177		0	0	11		0	0	0	112588	0	834061	19133873		
166169	3652	40213306	1996-06-02	1996-06-02 00:00:00	1996-06-02	1996-06-02 00:00:00	1996-06-02	581452		0	0	0		0	0	0	243140	0	43	40213306		
85754	1878	40213314	1977-08-21	1977-08-21 00:00:00	1977-08-21	1977-08-21 00:00:00	1977-08-21	581452		0	0	0		0	0	0	125333	0	49	40213314		
20582	1695	920300	2018-04-24	2018-04-24 00:00:00	2018-05-01	2018-05-01 00:00:00	2018-05-01	38000177		0	0	7		0	0	0	113492	0	311989	920300		
31088	2577	1115171	2013-02-02	2013-02-02 00:00:00	2013-02-23	2013-02-23 00:00:00	2013-02-23	38000177		0	0	21		0	0	0	170636	0	849574	1115171		
31106	2579	920300	1987-06-17	1987-06-17 00:00:00	1987-06-24	1987-06-24 00:00:00	1987-06-24	38000177		0	0	7		0	0	0	170794	0	311989	920300		
11238	935	40171902	1990-05-09	1990-05-09 00:00:00	1990-05-09	1990-05-09 00:00:00	\N	38000177		0	0	0		0	0	0	62238	0	897718	40171902		
121926	2680	40213306	1993-09-09	1993-09-09 00:00:00	1993-09-09	1993-09-09 00:00:00	1993-09-09	581452		0	0	0		0	0	0	177577	0	43	40213306		
62856	5223	1127433	1974-05-11	1974-05-11 00:00:00	1974-05-25	1974-05-25 00:00:00	1974-05-25	38000177		0	0	14		0	0	0	347589	0	313782	1127433		
88119	1933	40213160	1959-02-06	1959-02-06 00:00:00	1959-02-06	1959-02-06 00:00:00	1959-02-06	581452		0	0	0		0	0	0	128568	0	10	40213160		
40807	3383	19127904	2005-03-18	2005-03-18 00:00:00	2006-03-13	2006-03-13 00:00:00	2006-03-13	38000177		0	0	360		0	0	0	224526	0	748856	19127904		
3642	300	1127433	1973-02-19	1973-02-19 00:00:00	1973-03-05	1973-03-05 00:00:00	1973-03-05	38000177		0	0	14		0	0	0	20070	0	313782	1127433		
124499	2739	40213160	1955-08-24	1955-08-24 00:00:00	1955-08-24	1955-08-24 00:00:00	1955-08-24	581452		0	0	0		0	0	0	181199	0	10	40213160		
18573	1535	19078461	1999-09-10	1999-09-10 00:00:00	1999-10-01	1999-10-01 00:00:00	1999-10-01	38000177		0	0	21		0	0	0	102747	0	310965	19078461		
12222	263	40213260	2007-07-08	2007-07-08 00:00:00	2007-07-08	2007-07-08 00:00:00	2007-07-08	581452		0	0	0		0	0	0	17465	0	121	40213260		
72698	1588	40213296	2003-06-22	2003-06-22 00:00:00	2003-06-22	2003-06-22 00:00:00	2003-06-22	581452		0	0	0		0	0	0	106588	0	52	40213296		
3445	286	19133873	1934-02-04	1934-02-04 00:00:00	1934-02-17	1934-02-17 00:00:00	1934-02-17	38000177		0	0	13		0	0	0	19089	0	834061	19133873		
51520	4282	19075601	2007-10-10	2007-10-10 00:00:00	2007-10-10	2007-10-10 00:00:00	2007-10-10	38000177		0	0	0		0	0	0	284176	0	309362	19075601		
39742	3287	1127433	1965-02-20	1965-02-20 00:00:00	1965-03-20	1965-03-20 00:00:00	1965-03-20	38000177		0	0	28		0	0	0	218350	0	313782	1127433		
31429	2604	19133905	1991-02-28	1991-02-28 00:00:00	1991-03-11	1991-03-11 00:00:00	1991-03-11	38000177		0	0	11		0	0	0	172255	0	834102	19133905		
64556	1412	40213160	1962-01-20	1962-01-20 00:00:00	1962-01-20	1962-01-20 00:00:00	1962-01-20	581452		0	0	0		0	0	0	94002	0	10	40213160		
14413	311	40213314	1978-01-03	1978-01-03 00:00:00	1978-01-03	1978-01-03 00:00:00	1978-01-03	581452		0	0	0		0	0	0	20621	0	49	40213314		
158795	3495	40213227	2016-11-09	2016-11-09 00:00:00	2016-11-09	2016-11-09 00:00:00	2016-11-09	581452		0	0	0		0	0	0	231841	0	113	40213227		
219566	4819	40213227	2010-09-28	2010-09-28 00:00:00	2010-09-28	2010-09-28 00:00:00	2010-09-28	581452		0	0	0		0	0	0	320551	0	113	40213227		
219595	4820	40213160	1960-10-06	1960-10-06 00:00:00	1960-10-06	1960-10-06 00:00:00	1960-10-06	581452		0	0	0		0	0	0	320602	0	10	40213160		
204884	4497	40213160	1957-03-05	1957-03-05 00:00:00	1957-03-05	1957-03-05 00:00:00	1957-03-05	581452		0	0	0		0	0	0	299388	0	10	40213160		
17378	1439	1713671	1980-10-05	1980-10-05 00:00:00	1980-10-19	1980-10-19 00:00:00	1980-10-19	38000177		0	0	14		0	0	0	95897	0	562251	1713671		
61063	5078	1127433	1981-03-06	1981-03-06 00:00:00	1981-04-03	1981-04-03 00:00:00	1981-04-03	38000177		0	0	28		0	0	0	337525	0	313782	1127433		
57823	4804	1118084	2013-06-25	2013-06-25 00:00:00	2013-06-25	2013-06-25 00:00:00	\N	38000177		0	0	0		0	0	0	319575	0	00025152531	44923712		
229255	5037	40213227	2008-06-11	2008-06-11 00:00:00	2008-06-11	2008-06-11 00:00:00	2008-06-11	581452		0	0	0		0	0	0	334768	0	113	40213227		
98880	2165	40213227	2005-06-07	2005-06-07 00:00:00	2005-06-07	2005-06-07 00:00:00	2005-06-07	581452		0	0	0		0	0	0	144251	0	113	40213227		
55036	4570	40220960	1991-09-21	1991-09-21 00:00:00	1991-09-21	1991-09-21 00:00:00	1991-09-21	38000177		0	0	0		0	0	0	304477	0	1804799	40220960		
50841	4224	1713671	1959-04-08	1959-04-08 00:00:00	1959-04-29	1959-04-29 00:00:00	1959-04-29	38000177		0	0	21		0	0	0	280486	0	562251	1713671		
202191	4439	40213160	1955-05-18	1955-05-18 00:00:00	1955-05-18	1955-05-18 00:00:00	1955-05-18	581452		0	0	0		0	0	0	295111	0	10	40213160		
215598	4729	40213160	1963-05-10	1963-05-10 00:00:00	1963-05-10	1963-05-10 00:00:00	1963-05-10	581452		0	0	0		0	0	0	315093	0	10	40213160		
10415	869	19059056	1947-05-01	1947-05-01 00:00:00	1947-05-15	1947-05-15 00:00:00	1947-05-15	38000177		0	0	14		0	0	0	57780	0	243670	19059056		
58092	4826	40162522	2019-05-18	2019-05-18 00:00:00	2019-05-18	2019-05-18 00:00:00	\N	38000177		0	0	0		0	0	0	320988	0	857005	40162522		
216806	4757	40213296	1998-09-30	1998-09-30 00:00:00	1998-09-30	1998-09-30 00:00:00	1998-09-30	581452		0	0	0		0	0	0	316919	0	52	40213296		
21378	464	40213160	1972-10-24	1972-10-24 00:00:00	1972-10-24	1972-10-24 00:00:00	1972-10-24	581452		0	0	0		0	0	0	30984	0	10	40213160		
134243	2947	40213160	1975-01-28	1975-01-28 00:00:00	1975-01-28	1975-01-28 00:00:00	1975-01-28	581452		0	0	0		0	0	0	196718	0	10	40213160		
47855	1046	40213160	1971-08-15	1971-08-15 00:00:00	1971-08-15	1971-08-15 00:00:00	1971-08-15	581452		0	0	0		0	0	0	68664	0	10	40213160		
47872	1046	40213227	1993-11-28	1993-11-28 00:00:00	1993-11-28	1993-11-28 00:00:00	1993-11-28	581452		0	0	0		0	0	0	68657	0	113	40213227		
2676	213	1118084	2003-09-09	2003-09-09 00:00:00	2003-09-09	2003-09-09 00:00:00	\N	38000177		0	0	0		0	0	0	14501	0	00025152531	44923712		
128299	2822	40213160	1980-06-11	1980-06-11 00:00:00	1980-06-11	1980-06-11 00:00:00	1980-06-11	581452		0	0	0		0	0	0	187016	0	10	40213160		
56628	1239	40213160	1970-12-03	1970-12-03 00:00:00	1970-12-03	1970-12-03 00:00:00	1970-12-03	581452		0	0	0		0	0	0	81629	0	10	40213160		
40591	3364	19133873	1982-12-05	1982-12-05 00:00:00	1982-12-18	1982-12-18 00:00:00	1982-12-18	38000177		0	0	13		0	0	0	223080	0	834061	19133873		
13339	1118	19074679	1983-08-10	1983-08-10 00:00:00	1983-11-23	1983-11-23 00:00:00	1983-11-23	38000177		0	0	105		0	0	0	73703	0	308971	19074679		
75743	1655	40213227	2002-11-22	2002-11-22 00:00:00	2002-11-22	2002-11-22 00:00:00	2002-11-22	581452		0	0	0		0	0	0	111038	0	113	40213227		
50711	4214	46233988	1978-06-23	1978-06-23 00:00:00	1978-07-07	1978-07-07 00:00:00	1978-07-07	38000177		0	0	14		0	0	0	279776	0	1652673	46233988		
57791	1265	40213314	1981-07-19	1981-07-19 00:00:00	1981-07-19	1981-07-19 00:00:00	1981-07-19	581452		0	0	0		0	0	0	83378	0	49	40213314		
228676	5023	40213160	1977-07-17	1977-07-17 00:00:00	1977-07-17	1977-07-17 00:00:00	1977-07-17	581452		0	0	0		0	0	0	333732	0	10	40213160		
61303	5099	1127433	1953-10-18	1953-10-18 00:00:00	1953-11-01	1953-11-01 00:00:00	1953-11-01	38000177		0	0	14		0	0	0	338835	0	313782	1127433		
61347	5103	1127433	1944-02-09	1944-02-09 00:00:00	1944-02-23	1944-02-23 00:00:00	1944-02-23	38000177		0	0	14		0	0	0	339059	0	313782	1127433		
53868	4476	19112599	1964-03-10	1964-03-10 00:00:00	1964-03-10	1964-03-10 00:00:00	\N	38000177		0	0	0		0	0	0	297890	0	477045	19112599		
226194	4967	40213296	2003-06-09	2003-06-09 00:00:00	2003-06-09	2003-06-09 00:00:00	2003-06-09	581452		0	0	0		0	0	0	330189	0	52	40213296		
49197	1077	40213201	2012-11-02	2012-11-02 00:00:00	2012-11-02	2012-11-02 00:00:00	2012-11-02	581452		0	0	0		0	0	0	70669	0	33	40213201		
90783	1992	40213160	1975-08-31	1975-08-31 00:00:00	1975-08-31	1975-08-31 00:00:00	1975-08-31	581452		0	0	0		0	0	0	132721	0	10	40213160		
20432	1679	46233988	1973-06-30	1973-06-30 00:00:00	1973-07-14	1973-07-14 00:00:00	1973-07-14	38000177		0	0	14		0	0	0	112561	0	1652673	46233988		
166170	3652	40213296	2015-03-15	2015-03-15 00:00:00	2015-03-15	2015-03-15 00:00:00	2015-03-15	581452		0	0	0		0	0	0	243143	0	52	40213296		
85757	1878	40213314	1977-02-19	1977-02-19 00:00:00	1977-02-19	1977-02-19 00:00:00	1977-02-19	581452		0	0	0		0	0	0	125341	0	49	40213314		
20583	1695	920334	2018-05-01	2018-05-01 00:00:00	2018-05-08	2018-05-08 00:00:00	2018-05-08	38000177		0	0	7		0	0	0	113448	0	311995	920334		
31089	2577	19059056	1986-07-03	1986-07-03 00:00:00	1986-07-24	1986-07-24 00:00:00	1986-07-24	38000177		0	0	21		0	0	0	170634	0	243670	19059056		
31107	2579	40236824	1987-06-17	1987-06-17 00:00:00	1987-06-24	1987-06-24 00:00:00	1987-06-24	38000177		0	0	7		0	0	0	170794	0	1094107	40236824		
7685	165	40213227	1992-09-30	1992-09-30 00:00:00	1992-09-30	1992-09-30 00:00:00	1992-09-30	581452		0	0	0		0	0	0	\N	0	113	40213227		
121931	2680	40213160	1972-06-15	1972-06-15 00:00:00	1972-06-15	1972-06-15 00:00:00	1972-06-15	581452		0	0	0		0	0	0	177566	0	10	40213160		
62857	5223	1127433	1970-10-20	1970-10-20 00:00:00	1970-10-27	1970-10-27 00:00:00	1970-10-27	38000177		0	0	7		0	0	0	347548	0	313782	1127433		
88123	1933	40213160	1963-05-10	1963-05-10 00:00:00	1963-05-10	1963-05-10 00:00:00	1963-05-10	581452		0	0	0		0	0	0	128592	0	10	40213160		
40808	3383	19128263	2007-03-08	2007-03-08 00:00:00	2008-03-02	2008-03-02 00:00:00	2008-03-02	38000177		0	0	360		0	0	0	224527	0	751905	19128263		
3643	300	19128065	1987-03-16	1987-03-16 00:00:00	1988-03-10	1988-03-10 00:00:00	1988-03-10	38000177		0	0	360		0	0	0	20058	0	749882	19128065		
124507	2739	40213227	2014-05-21	2014-05-21 00:00:00	2014-05-21	2014-05-21 00:00:00	2014-05-21	581452		0	0	0		0	0	0	181270	0	113	40213227		
18574	1536	19059056	1971-02-01	1971-02-01 00:00:00	1971-03-01	1971-03-01 00:00:00	1971-03-01	38000177		0	0	28		0	0	0	102790	0	243670	19059056		
12236	263	40213160	1955-02-27	1955-02-27 00:00:00	1955-02-27	1955-02-27 00:00:00	1955-02-27	581452		0	0	0		0	0	0	17450	0	10	40213160		
72700	1588	40213227	2003-06-22	2003-06-22 00:00:00	2003-06-22	2003-06-22 00:00:00	2003-06-22	581452		0	0	0		0	0	0	106588	0	113	40213227		
3446	286	19078461	2008-01-09	2008-01-09 00:00:00	2008-02-06	2008-02-06 00:00:00	2008-02-06	38000177		0	0	28		0	0	0	19044	0	310965	19078461		
51521	4282	40220960	2007-10-10	2007-10-10 00:00:00	2007-10-10	2007-10-10 00:00:00	2007-10-10	38000177		0	0	0		0	0	0	284176	0	1804799	40220960		
39743	3287	1713671	1996-12-20	1996-12-20 00:00:00	1997-01-10	1997-01-10 00:00:00	1997-01-10	38000177		0	0	21		0	0	0	218332	0	562251	1713671		
31430	2604	1127433	1978-10-03	1978-10-03 00:00:00	1978-10-10	1978-10-10 00:00:00	1978-10-10	38000177		0	0	7		0	0	0	172247	0	313782	1127433		
64558	1412	40213160	1965-11-20	1965-11-20 00:00:00	1965-11-20	1965-11-20 00:00:00	1965-11-20	581452		0	0	0		0	0	0	94073	0	10	40213160		
14414	311	40213160	1978-01-03	1978-01-03 00:00:00	1978-01-03	1978-01-03 00:00:00	1978-01-03	581452		0	0	0		0	0	0	20621	0	10	40213160		
158796	3495	40213160	1970-05-27	1970-05-27 00:00:00	1970-05-27	1970-05-27 00:00:00	1970-05-27	581452		0	0	0		0	0	0	231835	0	10	40213160		
219568	4819	40213160	1960-05-31	1960-05-31 00:00:00	1960-05-31	1960-05-31 00:00:00	1960-05-31	581452		0	0	0		0	0	0	320562	0	10	40213160		
219596	4820	40213160	1956-04-05	1956-04-05 00:00:00	1956-04-05	1956-04-05 00:00:00	1956-04-05	581452		0	0	0		0	0	0	320635	0	10	40213160		
204886	4497	40213160	1957-06-04	1957-06-04 00:00:00	1957-06-04	1957-06-04 00:00:00	1957-06-04	581452		0	0	0		0	0	0	299427	0	10	40213160		
17379	1439	19059056	1978-12-06	1978-12-06 00:00:00	1978-12-20	1978-12-20 00:00:00	1978-12-20	38000177		0	0	14		0	0	0	95900	0	243670	19059056		
61064	5078	1332419	1994-05-16	1994-05-16 00:00:00	1994-05-16	1994-05-16 00:00:00	\N	38000177		0	0	0		0	0	0	337655	0	197361	1332419		
57824	4805	1127433	1983-07-07	1983-07-07 00:00:00	1983-07-21	1983-07-21 00:00:00	1983-07-21	38000177		0	0	14		0	0	0	319686	0	313782	1127433		
229256	5037	40213314	1977-05-25	1977-05-25 00:00:00	1977-05-25	1977-05-25 00:00:00	1977-05-25	581452		0	0	0		0	0	0	334801	0	49	40213314		
98883	2165	40213260	2007-06-19	2007-06-19 00:00:00	2007-06-19	2007-06-19 00:00:00	2007-06-19	581452		0	0	0		0	0	0	144252	0	121	40213260		
55037	4570	1127433	1985-05-15	1985-05-15 00:00:00	1985-05-29	1985-05-29 00:00:00	1985-05-29	38000177		0	0	14		0	0	0	304483	0	313782	1127433		
50842	4224	19059056	1956-01-24	1956-01-24 00:00:00	1956-02-07	1956-02-07 00:00:00	1956-02-07	38000177		0	0	14		0	0	0	280590	0	243670	19059056		
118662	2610	40213260	2007-07-07	2007-07-07 00:00:00	2007-07-07	2007-07-07 00:00:00	2007-07-07	581452		0	0	0		0	0	0	172561	0	121	40213260		
215599	4729	40213160	1963-07-12	1963-07-12 00:00:00	1963-07-12	1963-07-12 00:00:00	1963-07-12	581452		0	0	0		0	0	0	315053	0	10	40213160		
10416	869	19006318	1947-05-01	1947-05-01 00:00:00	1947-05-15	1947-05-15 00:00:00	1947-05-15	38000177		0	0	14		0	0	0	57780	0	105078	19006318		
58093	4826	19078461	2019-05-18	2019-05-18 00:00:00	2019-06-22	2019-06-22 00:00:00	2019-06-22	38000177		0	0	35		0	0	0	320988	0	310965	19078461		
209984	4604	40213160	1964-08-09	1964-08-09 00:00:00	1964-08-09	1964-08-09 00:00:00	1964-08-09	581452		0	0	0		0	0	0	306737	0	10	40213160		
21384	464	40213227	2014-05-27	2014-05-27 00:00:00	2014-05-27	2014-05-27 00:00:00	2014-05-27	581452		0	0	0		0	0	0	30972	0	113	40213227		
134248	2947	40213296	2014-05-28	2014-05-28 00:00:00	2014-05-28	2014-05-28 00:00:00	2014-05-28	581452		0	0	0		0	0	0	196697	0	52	40213296		
47858	1046	40213160	1971-10-17	1971-10-17 00:00:00	1971-10-17	1971-10-17 00:00:00	1971-10-17	581452		0	0	0		0	0	0	68682	0	10	40213160		
47875	1046	40213160	1976-04-18	1976-04-18 00:00:00	1976-04-18	1976-04-18 00:00:00	1976-04-18	581452		0	0	0		0	0	0	68652	0	10	40213160		
2677	213	1115171	2015-11-04	2015-11-04 00:00:00	2015-11-25	2015-11-25 00:00:00	2015-11-25	38000177		0	0	21		0	0	0	14497	0	849574	1115171		
128300	2822	40213314	1977-11-30	1977-11-30 00:00:00	1977-11-30	1977-11-30 00:00:00	1977-11-30	581452		0	0	0		0	0	0	187002	0	49	40213314		
56632	1239	40213227	2001-09-06	2001-09-06 00:00:00	2001-09-06	2001-09-06 00:00:00	2001-09-06	581452		0	0	0		0	0	0	81655	0	113	40213227		
40592	3364	19128022	1992-06-10	1992-06-10 00:00:00	1993-06-05	1993-06-05 00:00:00	1993-06-05	38000177		0	0	360		0	0	0	223097	0	749785	19128022		
13340	1118	920300	2003-12-29	2003-12-29 00:00:00	2004-01-05	2004-01-05 00:00:00	2004-01-05	38000177		0	0	7		0	0	0	73675	0	311989	920300		
75746	1655	40213160	1976-05-14	1976-05-14 00:00:00	1976-05-14	1976-05-14 00:00:00	1976-05-14	581452		0	0	0		0	0	0	111048	0	10	40213160		
50712	4214	1127078	1978-06-23	1978-06-23 00:00:00	1978-07-07	1978-07-07 00:00:00	1978-07-07	38000177		0	0	14		0	0	0	279776	0	282464	1127078		
57794	1265	40213314	1980-10-19	1980-10-19 00:00:00	1980-10-19	1980-10-19 00:00:00	1980-10-19	581452		0	0	0		0	0	0	83377	0	49	40213314		
228677	5023	40213314	1977-07-17	1977-07-17 00:00:00	1977-07-17	1977-07-17 00:00:00	1977-07-17	581452		0	0	0		0	0	0	333732	0	49	40213314		
61305	5099	1127433	1978-11-27	1978-11-27 00:00:00	1978-12-18	1978-12-18 00:00:00	1978-12-18	38000177		0	0	21		0	0	0	338866	0	313782	1127433		
61348	5103	1127433	1950-01-23	1950-01-23 00:00:00	1950-01-30	1950-01-30 00:00:00	1950-01-30	38000177		0	0	7		0	0	0	339046	0	313782	1127433		
53869	4477	1118084	2005-08-27	2005-08-27 00:00:00	2005-08-27	2005-08-27 00:00:00	\N	38000177		0	0	0		0	0	0	297975	0	00025152531	44923712		
93752	2058	40213160	1967-07-05	1967-07-05 00:00:00	1967-07-05	1967-07-05 00:00:00	1967-07-05	581452		0	0	0		0	0	0	136810	0	10	40213160		
60504	1322	40213227	1994-06-22	1994-06-22 00:00:00	1994-06-22	1994-06-22 00:00:00	1994-06-22	581452		0	0	0		0	0	0	87701	0	113	40213227		
90791	1992	40213227	2017-12-31	2017-12-31 00:00:00	2017-12-31	2017-12-31 00:00:00	2017-12-31	581452		0	0	0		0	0	0	132764	0	113	40213227		
20433	1679	19059056	1973-06-30	1973-06-30 00:00:00	1973-07-14	1973-07-14 00:00:00	1973-07-14	38000177		0	0	14		0	0	0	112561	0	243670	19059056		
166172	3652	40213227	2015-03-15	2015-03-15 00:00:00	2015-03-15	2015-03-15 00:00:00	2015-03-15	581452		0	0	0		0	0	0	243143	0	113	40213227		
85760	1878	40213160	1975-06-22	1975-06-22 00:00:00	1975-06-22	1975-06-22 00:00:00	1975-06-22	581452		0	0	0		0	0	0	125332	0	10	40213160		
20584	1695	1127433	1999-09-01	1999-09-01 00:00:00	1999-09-08	1999-09-08 00:00:00	1999-09-08	38000177		0	0	7		0	0	0	113487	0	313782	1127433		
31090	2577	1118084	2012-03-18	2012-03-18 00:00:00	2012-03-18	2012-03-18 00:00:00	\N	38000177		0	0	0		0	0	0	170670	0	00025152531	44923712		
31108	2579	19059056	1961-08-31	1961-08-31 00:00:00	1961-09-30	1961-09-30 00:00:00	1961-09-30	38000177		0	0	30		0	0	0	170790	0	243670	19059056		
7686	165	40213260	2018-06-27	2018-06-27 00:00:00	2018-06-27	2018-06-27 00:00:00	2018-06-27	581452		0	0	0		0	0	0	11369	0	121	40213260		
121933	2680	40213314	1977-01-06	1977-01-06 00:00:00	1977-01-06	1977-01-06 00:00:00	1977-01-06	581452		0	0	0		0	0	0	177552	0	49	40213314		
62858	5223	1127078	1970-12-30	1970-12-30 00:00:00	1971-01-13	1971-01-13 00:00:00	1971-01-13	38000177		0	0	14		0	0	0	347595	0	282464	1127078		
88125	1933	40213260	2009-06-05	2009-06-05 00:00:00	2009-06-05	2009-06-05 00:00:00	2009-06-05	581452		0	0	0		0	0	0	128574	0	121	40213260		
40809	3383	40224805	2010-02-20	2010-02-20 00:00:00	2011-02-15	2011-02-15 00:00:00	2011-02-15	38000177		0	0	360		0	0	0	224485	0	1000126	40224805		
3644	300	1115171	2004-02-05	2004-02-05 00:00:00	2004-03-04	2004-03-04 00:00:00	2004-03-04	38000177		0	0	28		0	0	0	20040	0	849574	1115171		
124510	2739	40213160	1956-02-22	1956-02-22 00:00:00	1956-02-22	1956-02-22 00:00:00	1956-02-22	581452		0	0	0		0	0	0	181250	0	10	40213160		
18575	1536	1713671	1964-05-30	1964-05-30 00:00:00	1964-06-20	1964-06-20 00:00:00	1964-06-20	38000177		0	0	21		0	0	0	102777	0	562251	1713671		
191021	4197	40213314	1986-02-23	1986-02-23 00:00:00	1986-02-23	1986-02-23 00:00:00	1986-02-23	581452		0	0	0		0	0	0	278504	0	49	40213314		
72703	1588	40213306	1983-10-16	1983-10-16 00:00:00	1983-10-16	1983-10-16 00:00:00	1983-10-16	581452		0	0	0		0	0	0	106569	0	43	40213306		
3447	286	40229134	1982-03-16	1982-03-16 00:00:00	1982-03-30	1982-03-30 00:00:00	1982-03-30	38000177		0	0	14		0	0	0	19120	0	1043400	40229134		
51523	4282	1118084	2004-10-13	2004-10-13 00:00:00	2004-10-13	2004-10-13 00:00:00	\N	38000177		0	0	0		0	0	0	284216	0	00025152531	44923712		
39744	3287	40162522	1988-11-12	1988-11-12 00:00:00	1988-11-12	1988-11-12 00:00:00	\N	38000177		0	0	0		0	0	0	218312	0	857005	40162522		
31431	2604	19133905	1994-07-27	1994-07-27 00:00:00	1994-08-07	1994-08-07 00:00:00	1994-08-07	38000177		0	0	11		0	0	0	172301	0	834102	19133905		
64560	1412	40213227	2012-12-08	2012-12-08 00:00:00	2012-12-08	2012-12-08 00:00:00	2012-12-08	581452		0	0	0		0	0	0	94050	0	113	40213227		
14416	311	40213160	1978-04-04	1978-04-04 00:00:00	1978-04-04	1978-04-04 00:00:00	1978-04-04	581452		0	0	0		0	0	0	20639	0	10	40213160		
158799	3495	40213296	2008-10-15	2008-10-15 00:00:00	2008-10-15	2008-10-15 00:00:00	2008-10-15	581452		0	0	0		0	0	0	231825	0	52	40213296		
219571	4819	40213260	2009-09-22	2009-09-22 00:00:00	2009-09-22	2009-09-22 00:00:00	2009-09-22	581452		0	0	0		0	0	0	320556	0	121	40213260		
219598	4820	40213160	1956-02-02	1956-02-02 00:00:00	1956-02-02	1956-02-02 00:00:00	1956-02-02	581452		0	0	0		0	0	0	320672	0	10	40213160		
204893	4497	40213160	1961-09-05	1961-09-05 00:00:00	1961-09-05	1961-09-05 00:00:00	1961-09-05	581452		0	0	0		0	0	0	299408	0	10	40213160		
17380	1439	19129655	1978-12-06	1978-12-06 00:00:00	1978-12-20	1978-12-20 00:00:00	1978-12-20	38000177		0	0	14		0	0	0	95900	0	789980	19129655		
61065	5078	1127433	1956-05-25	1956-05-25 00:00:00	1956-06-15	1956-06-15 00:00:00	1956-06-15	38000177		0	0	21		0	0	0	337523	0	313782	1127433		
57825	4805	1127433	1999-08-12	1999-08-12 00:00:00	1999-08-26	1999-08-26 00:00:00	1999-08-26	38000177		0	0	14		0	0	0	319681	0	313782	1127433		
229257	5037	40213160	1977-05-25	1977-05-25 00:00:00	1977-05-25	1977-05-25 00:00:00	1977-05-25	581452		0	0	0		0	0	0	334801	0	10	40213160		
211259	4633	40213260	2008-11-25	2008-11-25 00:00:00	2008-11-25	2008-11-25 00:00:00	2008-11-25	581452		0	0	0		0	0	0	308772	0	121	40213260		
55038	4570	19133905	1976-12-16	1976-12-16 00:00:00	1976-12-27	1976-12-27 00:00:00	1976-12-27	38000177		0	0	11		0	0	0	304461	0	834102	19133905		
50843	4224	1127433	2019-03-30	2019-03-30 00:00:00	2019-04-13	2019-04-13 00:00:00	2019-04-13	38000177		0	0	14		0	0	0	280555	0	313782	1127433		
118668	2611	40213160	1956-06-28	1956-06-28 00:00:00	1956-06-28	1956-06-28 00:00:00	1956-06-28	581452		0	0	0		0	0	0	172638	0	10	40213160		
215606	4729	40213160	1968-01-12	1968-01-12 00:00:00	1968-01-12	1968-01-12 00:00:00	1968-01-12	581452		0	0	0		0	0	0	315058	0	10	40213160		
10417	869	40220960	2006-09-29	2006-09-29 00:00:00	2006-09-29	2006-09-29 00:00:00	2006-09-29	38000177		0	0	0		0	0	0	57814	0	1804799	40220960		
58094	4826	19133905	1992-04-17	1992-04-17 00:00:00	1992-04-28	1992-04-28 00:00:00	1992-04-28	38000177		0	0	11		0	0	0	320943	0	834102	19133905		
209986	4604	40213296	2005-10-09	2005-10-09 00:00:00	2005-10-09	2005-10-09 00:00:00	2005-10-09	581452		0	0	0		0	0	0	306724	0	52	40213296		
21385	464	40213296	2014-05-27	2014-05-27 00:00:00	2014-05-27	2014-05-27 00:00:00	2014-05-27	581452		0	0	0		0	0	0	30972	0	52	40213296		
134250	2947	40213227	2016-06-01	2016-06-01 00:00:00	2016-06-01	2016-06-01 00:00:00	2016-06-01	581452		0	0	0		0	0	0	196724	0	113	40213227		
47860	1046	40213227	2013-05-19	2013-05-19 00:00:00	2013-05-19	2013-05-19 00:00:00	2013-05-19	581452		0	0	0		0	0	0	68670	0	113	40213227		
47880	1046	40213160	1972-01-16	1972-01-16 00:00:00	1972-01-16	1972-01-16 00:00:00	1972-01-16	581452		0	0	0		0	0	0	68708	0	10	40213160		
2678	213	19133873	1967-12-01	1967-12-01 00:00:00	1967-12-12	1967-12-12 00:00:00	1967-12-12	38000177		0	0	11		0	0	0	14498	0	834061	19133873		
128309	2822	40213296	2015-12-30	2015-12-30 00:00:00	2015-12-30	2015-12-30 00:00:00	2015-12-30	581452		0	0	0		0	0	0	187028	0	52	40213296		
59285	1297	40213306	2001-01-07	2001-01-07 00:00:00	2001-01-07	2001-01-07 00:00:00	2001-01-07	581452		0	0	0		0	0	0	\N	0	43	40213306		
40593	3364	1115171	1994-12-01	1994-12-01 00:00:00	1995-03-01	1995-03-01 00:00:00	1995-03-01	38000177		0	0	90		0	0	0	223107	0	849574	1115171		
13341	1118	40236824	2003-12-29	2003-12-29 00:00:00	2004-01-12	2004-01-12 00:00:00	2004-01-12	38000177		0	0	14		0	0	0	73675	0	1094107	40236824		
180236	3961	40213227	2004-04-27	2004-04-27 00:00:00	2004-04-27	2004-04-27 00:00:00	2004-04-27	581452		0	0	0		0	0	0	263336	0	113	40213227		
50713	4214	19133873	1990-03-08	1990-03-08 00:00:00	1990-03-20	1990-03-20 00:00:00	1990-03-20	38000177		0	0	12		0	0	0	279759	0	834061	19133873		
57795	1265	40213160	1980-10-19	1980-10-19 00:00:00	1980-10-19	1980-10-19 00:00:00	1980-10-19	581452		0	0	0		0	0	0	83377	0	10	40213160		
228686	5023	40213306	1994-09-25	1994-09-25 00:00:00	1994-09-25	1994-09-25 00:00:00	1994-09-25	581452		0	0	0		0	0	0	333791	0	43	40213306		
61307	5099	19133905	2017-04-07	2017-04-07 00:00:00	2017-04-16	2017-04-16 00:00:00	2017-04-16	38000177		0	0	9		0	0	0	338843	0	834102	19133905		
61349	5103	19059056	1946-07-25	1946-07-25 00:00:00	1946-08-15	1946-08-15 00:00:00	1946-08-15	38000177		0	0	21		0	0	0	339102	0	243670	19059056		
53870	4477	19133873	1975-08-28	1975-08-28 00:00:00	1975-09-04	1975-09-04 00:00:00	1975-09-04	38000177		0	0	7		0	0	0	297941	0	834061	19133873		
128976	2836	40213251	1984-02-06	1984-02-06 00:00:00	1984-02-06	1984-02-06 00:00:00	1984-02-06	581452		0	0	0		0	0	0	188363	0	21	40213251		
195893	4304	40213227	2017-12-24	2017-12-24 00:00:00	2017-12-24	2017-12-24 00:00:00	2017-12-24	581452		0	0	0		0	0	0	285478	0	113	40213227		
90792	1992	40213296	2017-12-31	2017-12-31 00:00:00	2017-12-31	2017-12-31 00:00:00	2017-12-31	581452		0	0	0		0	0	0	132764	0	52	40213296		
20434	1679	19133905	2001-11-09	2001-11-09 00:00:00	2001-11-22	2001-11-22 00:00:00	2001-11-22	38000177		0	0	13		0	0	0	112566	0	834102	19133905		
166176	3652	40213160	1974-05-19	1974-05-19 00:00:00	1974-05-19	1974-05-19 00:00:00	1974-05-19	581452		0	0	0		0	0	0	243134	0	10	40213160		
85762	1878	40213306	1997-05-04	1997-05-04 00:00:00	1997-05-04	1997-05-04 00:00:00	1997-05-04	581452		0	0	0		0	0	0	125302	0	43	40213306		
31043	2572	19128065	1986-06-05	1986-06-05 00:00:00	1987-05-31	1987-05-31 00:00:00	1987-05-31	38000177		0	0	360		0	0	0	170392	0	749882	19128065		
31091	2577	46233988	1976-08-24	1976-08-24 00:00:00	1976-09-07	1976-09-07 00:00:00	1976-09-07	38000177		0	0	14		0	0	0	170707	0	1652673	46233988		
31109	2579	920300	1981-05-07	1981-05-07 00:00:00	1981-05-14	1981-05-14 00:00:00	1981-05-14	38000177		0	0	7		0	0	0	170771	0	311989	920300		
7695	165	40213160	1968-09-18	1968-09-18 00:00:00	1968-09-18	1968-09-18 00:00:00	1968-09-18	581452		0	0	0		0	0	0	11357	0	10	40213160		
121934	2680	40213160	1977-01-06	1977-01-06 00:00:00	1977-01-06	1977-01-06 00:00:00	1977-01-06	581452		0	0	0		0	0	0	177552	0	10	40213160		
62859	5223	19006318	1970-12-30	1970-12-30 00:00:00	1971-01-13	1971-01-13 00:00:00	1971-01-13	38000177		0	0	14		0	0	0	347595	0	105078	19006318		
88126	1933	40213227	2009-06-05	2009-06-05 00:00:00	2009-06-05	2009-06-05 00:00:00	2009-06-05	581452		0	0	0		0	0	0	128574	0	113	40213227		
40810	3383	1713671	1993-10-13	1993-10-13 00:00:00	1993-10-27	1993-10-27 00:00:00	1993-10-27	38000177		0	0	14		0	0	0	224478	0	562251	1713671		
3645	300	1127433	2007-08-21	2007-08-21 00:00:00	2007-08-28	2007-08-28 00:00:00	2007-08-28	38000177		0	0	7		0	0	0	20076	0	313782	1127433		
124519	2739	40213227	2004-03-24	2004-03-24 00:00:00	2004-03-24	2004-03-24 00:00:00	2004-03-24	581452		0	0	0		0	0	0	181226	0	113	40213227		
18576	1536	1713671	1967-02-14	1967-02-14 00:00:00	1967-02-21	1967-02-21 00:00:00	1967-02-21	38000177		0	0	7		0	0	0	102797	0	562251	1713671		
191022	4197	40213160	1986-02-23	1986-02-23 00:00:00	1986-02-23	1986-02-23 00:00:00	1986-02-23	581452		0	0	0		0	0	0	278504	0	10	40213160		
72706	1588	40213160	1965-11-14	1965-11-14 00:00:00	1965-11-14	1965-11-14 00:00:00	1965-11-14	581452		0	0	0		0	0	0	106596	0	10	40213160		
3448	286	19078461	2017-06-02	2017-06-02 00:00:00	2017-08-31	2017-08-31 00:00:00	2017-08-31	38000177		0	0	90		0	0	0	19047	0	310965	19078461		
51524	4282	40236824	2008-04-26	2008-04-26 00:00:00	2008-05-03	2008-05-03 00:00:00	2008-05-03	38000177		0	0	7		0	0	0	284190	0	1094107	40236824		
39745	3287	19078461	1988-11-12	1988-11-12 00:00:00	1988-12-12	1988-12-12 00:00:00	1988-12-12	38000177		0	0	30		0	0	0	218312	0	310965	19078461		
31432	2604	1118084	1997-08-12	1997-08-12 00:00:00	1997-08-12	1997-08-12 00:00:00	\N	38000177		0	0	0		0	0	0	172277	0	00025152531	44923712		
64561	1412	40213260	2012-12-08	2012-12-08 00:00:00	2012-12-08	2012-12-08 00:00:00	2012-12-08	581452		0	0	0		0	0	0	94050	0	121	40213260		
14421	311	40213227	2019-01-29	2019-01-29 00:00:00	2019-01-29	2019-01-29 00:00:00	2019-01-29	581452		0	0	0		0	0	0	20611	0	113	40213227		
59519	1303	40213227	2007-06-03	2007-06-03 00:00:00	2007-06-03	2007-06-03 00:00:00	2007-06-03	581452		0	0	0		0	0	0	86055	0	113	40213227		
219577	4819	40213296	1999-09-28	1999-09-28 00:00:00	1999-09-28	1999-09-28 00:00:00	1999-09-28	581452		0	0	0		0	0	0	320534	0	52	40213296		
219615	4820	40213227	2007-02-01	2007-02-01 00:00:00	2007-02-01	2007-02-01 00:00:00	2007-02-01	581452		0	0	0		0	0	0	320600	0	113	40213227		
204904	4497	40213260	2007-05-22	2007-05-22 00:00:00	2007-05-22	2007-05-22 00:00:00	2007-05-22	581452		0	0	0		0	0	0	299413	0	121	40213260		
17381	1439	1127433	1978-03-13	1978-03-13 00:00:00	1978-03-27	1978-03-27 00:00:00	1978-03-27	38000177		0	0	14		0	0	0	95916	0	313782	1127433		
61066	5078	1127433	1956-10-03	1956-10-03 00:00:00	1956-10-17	1956-10-17 00:00:00	1956-10-17	38000177		0	0	14		0	0	0	337540	0	313782	1127433		
57826	4805	1127433	2003-08-28	2003-08-28 00:00:00	2003-09-04	2003-09-04 00:00:00	2003-09-04	38000177		0	0	7		0	0	0	319735	0	313782	1127433		
239492	5257	40213251	1984-02-29	1984-02-29 00:00:00	1984-02-29	1984-02-29 00:00:00	1984-02-29	581452		0	0	0		0	0	0	349796	0	21	40213251		
211267	4633	40213227	2009-12-01	2009-12-01 00:00:00	2009-12-01	2009-12-01 00:00:00	2009-12-01	581452		0	0	0		0	0	0	308816	0	113	40213227		
55039	4570	19133873	1944-05-03	1944-05-03 00:00:00	1944-05-14	1944-05-14 00:00:00	1944-05-14	38000177		0	0	11		0	0	0	304459	0	834061	19133873		
50844	4224	19112599	1951-01-29	1951-01-29 00:00:00	1951-01-29	1951-01-29 00:00:00	\N	38000177		0	0	0		0	0	0	280442	0	477045	19112599		
118673	2611	40213160	1955-06-23	1955-06-23 00:00:00	1955-06-23	1955-06-23 00:00:00	1955-06-23	581452		0	0	0		0	0	0	172706	0	10	40213160		
215617	4729	40213227	2005-02-11	2005-02-11 00:00:00	2005-02-11	2005-02-11 00:00:00	2005-02-11	581452		0	0	0		0	0	0	315071	0	113	40213227		
10418	869	19075601	2006-09-29	2006-09-29 00:00:00	2006-09-29	2006-09-29 00:00:00	2006-09-29	38000177		0	0	0		0	0	0	57814	0	309362	19075601		
58095	4826	1127078	1960-04-22	1960-04-22 00:00:00	1960-05-06	1960-05-06 00:00:00	1960-05-06	38000177		0	0	14		0	0	0	320984	0	282464	1127078		
209988	4604	40213227	2005-10-09	2005-10-09 00:00:00	2005-10-09	2005-10-09 00:00:00	2005-10-09	581452		0	0	0		0	0	0	306724	0	113	40213227		
21392	464	40213314	1977-04-26	1977-04-26 00:00:00	1977-04-26	1977-04-26 00:00:00	1977-04-26	581452		0	0	0		0	0	0	30987	0	49	40213314		
145539	3200	40213227	2008-04-03	2008-04-03 00:00:00	2008-04-03	2008-04-03 00:00:00	2008-04-03	581452		0	0	0		0	0	0	212851	0	113	40213227		
47861	1046	40213296	2013-05-19	2013-05-19 00:00:00	2013-05-19	2013-05-19 00:00:00	2013-05-19	581452		0	0	0		0	0	0	68670	0	52	40213296		
34813	760	40213160	1965-08-04	1965-08-04 00:00:00	1965-08-04	1965-08-04 00:00:00	1965-08-04	581452		0	0	0		0	0	0	50468	0	10	40213160		
2697	217	1713671	1982-05-28	1982-05-28 00:00:00	1982-06-18	1982-06-18 00:00:00	1982-06-18	38000177		0	0	21		0	0	0	14647	0	562251	1713671		
128314	2822	40213227	2018-01-03	2018-01-03 00:00:00	2018-01-03	2018-01-03 00:00:00	2018-01-03	581452		0	0	0		0	0	0	187010	0	113	40213227		
59289	1297	40213296	2018-11-11	2018-11-11 00:00:00	2018-11-11	2018-11-11 00:00:00	2018-11-11	581452		0	0	0		0	0	0	85731	0	52	40213296		
40594	3364	40162522	1994-12-01	1994-12-01 00:00:00	1994-12-01	1994-12-01 00:00:00	\N	38000177		0	0	0		0	0	0	223107	0	857005	40162522		
13342	1118	920300	2000-11-08	2000-11-08 00:00:00	2000-11-15	2000-11-15 00:00:00	2000-11-15	38000177		0	0	7		0	0	0	73706	0	311989	920300		
180240	3961	40213314	1977-01-18	1977-01-18 00:00:00	1977-01-18	1977-01-18 00:00:00	1977-01-18	581452		0	0	0		0	0	0	263376	0	49	40213314		
50714	4214	19126352	2018-12-18	2018-12-18 00:00:00	2018-12-18	2018-12-18 00:00:00	\N	38000177		0	0	0		0	0	0	279771	0	705129	19126352		
57799	1265	40213227	2002-06-23	2002-06-23 00:00:00	2002-06-23	2002-06-23 00:00:00	2002-06-23	581452		0	0	0		0	0	0	83386	0	113	40213227		
228689	5023	40213160	1973-01-14	1973-01-14 00:00:00	1973-01-14	1973-01-14 00:00:00	1973-01-14	581452		0	0	0		0	0	0	333728	0	10	40213160		
61308	5099	40236824	1989-03-25	1989-03-25 00:00:00	1989-04-01	1989-04-01 00:00:00	1989-04-01	38000177		0	0	7		0	0	0	338870	0	1094107	40236824		
61350	5103	40229134	1992-07-21	1992-07-21 00:00:00	1992-08-04	1992-08-04 00:00:00	1992-08-04	38000177		0	0	14		0	0	0	339099	0	1043400	40229134		
53871	4477	19059056	1967-08-30	1967-08-30 00:00:00	1967-09-29	1967-09-29 00:00:00	1967-09-29	38000177		0	0	30		0	0	0	297911	0	243670	19059056		
128977	2836	40213251	1985-08-12	1985-08-12 00:00:00	1985-08-12	1985-08-12 00:00:00	1985-08-12	581452		0	0	0		0	0	0	188393	0	21	40213251		
195894	4304	40213260	2017-12-24	2017-12-24 00:00:00	2017-12-24	2017-12-24 00:00:00	2017-12-24	581452		0	0	0		0	0	0	285478	0	121	40213260		
90795	1992	40213160	1980-03-02	1980-03-02 00:00:00	1980-03-02	1980-03-02 00:00:00	1980-03-02	581452		0	0	0		0	0	0	132723	0	10	40213160		
20435	1679	1127078	1971-10-20	1971-10-20 00:00:00	1971-11-03	1971-11-03 00:00:00	1971-11-03	38000177		0	0	14		0	0	0	112600	0	282464	1127078		
181652	3991	40213198	2010-12-25	2010-12-25 00:00:00	2010-12-25	2010-12-25 00:00:00	2010-12-25	581452		0	0	0		0	0	0	265334	0	133	40213198		
85766	1878	40213314	1978-02-18	1978-02-18 00:00:00	1978-02-18	1978-02-18 00:00:00	1978-02-18	581452		0	0	0		0	0	0	125308	0	49	40213314		
31044	2572	1115171	2011-10-17	2011-10-17 00:00:00	2011-11-07	2011-11-07 00:00:00	2011-11-07	38000177		0	0	21		0	0	0	170369	0	849574	1115171		
31092	2577	19019979	1976-08-24	1976-08-24 00:00:00	1976-09-07	1976-09-07 00:00:00	1976-09-07	38000177		0	0	14		0	0	0	170707	0	198405	19019979		
31110	2579	40236824	1981-05-07	1981-05-07 00:00:00	1981-05-14	1981-05-14 00:00:00	1981-05-14	38000177		0	0	7		0	0	0	170771	0	1094107	40236824		
18980	411	40213227	2010-02-27	2010-02-27 00:00:00	2010-02-27	2010-02-27 00:00:00	2010-02-27	581452		0	0	0		0	0	0	27380	0	113	40213227		
121944	2680	40213227	2013-11-14	2013-11-14 00:00:00	2013-11-14	2013-11-14 00:00:00	2013-11-14	581452		0	0	0		0	0	0	177589	0	113	40213227		
62860	5223	1127433	1968-06-20	1968-06-20 00:00:00	1968-07-04	1968-07-04 00:00:00	1968-07-04	38000177		0	0	14		0	0	0	347585	0	313782	1127433		
25367	2087	19126352	2001-07-18	2001-07-18 00:00:00	2001-07-18	2001-07-18 00:00:00	\N	38000177		0	0	0		0	0	0	139117	0	705129	19126352		
40811	3383	19128065	2002-04-03	2002-04-03 00:00:00	2003-03-29	2003-03-29 00:00:00	2003-03-29	38000177		0	0	360		0	0	0	224518	0	749882	19128065		
3646	300	1713671	1995-01-20	1995-01-20 00:00:00	1995-01-27	1995-01-27 00:00:00	1995-01-27	38000177		0	0	7		0	0	0	20053	0	562251	1713671		
124521	2739	40213160	1955-02-23	1955-02-23 00:00:00	1955-02-23	1955-02-23 00:00:00	1955-02-23	581452		0	0	0		0	0	0	181195	0	10	40213160		
18577	1536	1127433	1919-09-17	1919-09-17 00:00:00	1919-09-24	1919-09-24 00:00:00	1919-09-24	38000177		0	0	7		0	0	0	102819	0	313782	1127433		
191024	4197	40213314	1985-12-22	1985-12-22 00:00:00	1985-12-22	1985-12-22 00:00:00	1985-12-22	581452		0	0	0		0	0	0	278517	0	49	40213314		
72714	1588	40213227	1992-03-29	1992-03-29 00:00:00	1992-03-29	1992-03-29 00:00:00	1992-03-29	581452		0	0	0		0	0	0	106605	0	113	40213227		
3449	286	1127433	1943-01-01	1943-01-01 00:00:00	1943-01-08	1943-01-08 00:00:00	1943-01-08	38000177		0	0	7		0	0	0	19052	0	313782	1127433		
51525	4282	920300	2008-04-26	2008-04-26 00:00:00	2008-05-03	2008-05-03 00:00:00	2008-05-03	38000177		0	0	7		0	0	0	284190	0	311989	920300		
39746	3287	1713671	2012-05-24	2012-05-24 00:00:00	2012-06-14	2012-06-14 00:00:00	2012-06-14	38000177		0	0	21		0	0	0	218368	0	562251	1713671		
31433	2604	1713671	1969-03-17	1969-03-17 00:00:00	1969-04-07	1969-04-07 00:00:00	1969-04-07	38000177		0	0	21		0	0	0	172246	0	562251	1713671		
64563	1412	40213160	1961-08-19	1961-08-19 00:00:00	1961-08-19	1961-08-19 00:00:00	1961-08-19	581452		0	0	0		0	0	0	94001	0	10	40213160		
14422	311	40213296	2019-01-29	2019-01-29 00:00:00	2019-01-29	2019-01-29 00:00:00	2019-01-29	581452		0	0	0		0	0	0	20611	0	52	40213296		
59520	1303	40213314	1977-02-27	1977-02-27 00:00:00	1977-02-27	1977-02-27 00:00:00	1977-02-27	581452		0	0	0		0	0	0	86037	0	49	40213314		
219581	4819	40213227	1993-12-14	1993-12-14 00:00:00	1993-12-14	1993-12-14 00:00:00	1993-12-14	581452		0	0	0		0	0	0	320533	0	113	40213227		
219616	4820	40213260	2007-02-01	2007-02-01 00:00:00	2007-02-01	2007-02-01 00:00:00	2007-02-01	581452		0	0	0		0	0	0	320600	0	121	40213260		
204906	4497	40213296	1998-04-28	1998-04-28 00:00:00	1998-04-28	1998-04-28 00:00:00	1998-04-28	581452		0	0	0		0	0	0	299393	0	52	40213296		
17382	1439	19128065	1995-07-20	1995-07-20 00:00:00	1996-07-14	1996-07-14 00:00:00	1996-07-14	38000177		0	0	360		0	0	0	95925	0	749882	19128065		
61067	5078	1115171	1998-09-27	1998-09-27 00:00:00	1998-10-18	1998-10-18 00:00:00	1998-10-18	38000177		0	0	21		0	0	0	337631	0	849574	1115171		
57827	4805	1127433	2019-02-13	2019-02-13 00:00:00	2019-02-20	2019-02-20 00:00:00	2019-02-20	38000177		0	0	7		0	0	0	319687	0	313782	1127433		
239494	5257	40213314	1978-08-23	1978-08-23 00:00:00	1978-08-23	1978-08-23 00:00:00	1978-08-23	581452		0	0	0		0	0	0	349801	0	49	40213314		
211268	4633	40213260	2009-12-01	2009-12-01 00:00:00	2009-12-01	2009-12-01 00:00:00	2009-12-01	581452		0	0	0		0	0	0	308816	0	121	40213260		
55040	4570	1127433	1957-12-05	1957-12-05 00:00:00	1957-12-19	1957-12-19 00:00:00	1957-12-19	38000177		0	0	14		0	0	0	304434	0	313782	1127433		
50845	4224	1127433	2008-12-14	2008-12-14 00:00:00	2008-12-21	2008-12-21 00:00:00	2008-12-21	38000177		0	0	7		0	0	0	280541	0	313782	1127433		
129956	2857	40213227	2015-09-10	2015-09-10 00:00:00	2015-09-10	2015-09-10 00:00:00	2015-09-10	581452		0	0	0		0	0	0	189735	0	113	40213227		
215618	4729	40213296	2005-02-11	2005-02-11 00:00:00	2005-02-11	2005-02-11 00:00:00	2005-02-11	581452		0	0	0		0	0	0	315071	0	52	40213296		
10419	869	19059056	1947-02-06	1947-02-06 00:00:00	1947-02-20	1947-02-20 00:00:00	1947-02-20	38000177		0	0	14		0	0	0	57724	0	243670	19059056		
58096	4826	1118084	1986-04-16	1986-04-16 00:00:00	1986-04-16	1986-04-16 00:00:00	\N	38000177		0	0	0		0	0	0	320922	0	00025152531	44923712		
209990	4604	40213227	2015-04-19	2015-04-19 00:00:00	2015-04-19	2015-04-19 00:00:00	2015-04-19	581452		0	0	0		0	0	0	306710	0	113	40213227		
21394	464	40213160	1977-04-26	1977-04-26 00:00:00	1977-04-26	1977-04-26 00:00:00	1977-04-26	581452		0	0	0		0	0	0	30987	0	10	40213160		
145544	3200	40213201	2013-05-02	2013-05-02 00:00:00	2013-05-02	2013-05-02 00:00:00	2013-05-02	581452		0	0	0		0	0	0	212870	0	33	40213201		
115995	2548	40213160	1966-05-08	1966-05-08 00:00:00	1966-05-08	1966-05-08 00:00:00	1966-05-08	581452		0	0	0		0	0	0	168725	0	10	40213160		
34826	760	40213160	1969-11-26	1969-11-26 00:00:00	1969-11-26	1969-11-26 00:00:00	1969-11-26	581452		0	0	0		0	0	0	50485	0	10	40213160		
2698	217	19133873	1979-12-27	1979-12-27 00:00:00	1980-01-04	1980-01-04 00:00:00	1980-01-04	38000177		0	0	8		0	0	0	14636	0	834061	19133873		
128315	2822	40213296	2018-01-03	2018-01-03 00:00:00	2018-01-03	2018-01-03 00:00:00	2018-01-03	581452		0	0	0		0	0	0	187010	0	52	40213296		
59296	1297	40213251	1984-09-30	1984-09-30 00:00:00	1984-09-30	1984-09-30 00:00:00	1984-09-30	581452		0	0	0		0	0	0	85746	0	21	40213251		
40595	3364	19128022	1993-06-05	1993-06-05 00:00:00	1994-05-31	1994-05-31 00:00:00	1994-05-31	38000177		0	0	360		0	0	0	223098	0	749785	19128022		
13343	1118	40236824	2000-11-08	2000-11-08 00:00:00	2000-11-15	2000-11-15 00:00:00	2000-11-15	38000177		0	0	7		0	0	0	73706	0	1094107	40236824		
180246	3961	40213160	1973-05-22	1973-05-22 00:00:00	1973-05-22	1973-05-22 00:00:00	1973-05-22	581452		0	0	0		0	0	0	263374	0	10	40213160		
50715	4214	1332419	2018-12-18	2018-12-18 00:00:00	2018-12-18	2018-12-18 00:00:00	\N	38000177		0	0	0		0	0	0	279771	0	197361	1332419		
57800	1265	40213306	2002-06-23	2002-06-23 00:00:00	2002-06-23	2002-06-23 00:00:00	2002-06-23	581452		0	0	0		0	0	0	83386	0	43	40213306		
228695	5023	40213160	1972-11-12	1972-11-12 00:00:00	1972-11-12	1972-11-12 00:00:00	1972-11-12	581452		0	0	0		0	0	0	333781	0	10	40213160		
61309	5099	920300	1989-03-25	1989-03-25 00:00:00	1989-04-01	1989-04-01 00:00:00	1989-04-01	38000177		0	0	7		0	0	0	338870	0	311989	920300		
61351	5103	19059056	1944-08-06	1944-08-06 00:00:00	1944-09-03	1944-09-03 00:00:00	1944-09-03	38000177		0	0	28		0	0	0	339101	0	243670	19059056		
53872	4477	1127433	1978-10-01	1978-10-01 00:00:00	1978-10-22	1978-10-22 00:00:00	1978-10-22	38000177		0	0	21		0	0	0	297913	0	313782	1127433		
128980	2836	40213160	1985-08-12	1985-08-12 00:00:00	1985-08-12	1985-08-12 00:00:00	1985-08-12	581452		0	0	0		0	0	0	188393	0	10	40213160		
195897	4304	40213227	1999-11-14	1999-11-14 00:00:00	1999-11-14	1999-11-14 00:00:00	1999-11-14	581452		0	0	0		0	0	0	285467	0	113	40213227		
90799	1992	40213160	1975-06-29	1975-06-29 00:00:00	1975-06-29	1975-06-29 00:00:00	1975-06-29	581452		0	0	0		0	0	0	132647	0	10	40213160		
20436	1679	1713671	1985-10-17	1985-10-17 00:00:00	1985-11-07	1985-11-07 00:00:00	1985-11-07	38000177		0	0	21		0	0	0	112589	0	562251	1713671		
181670	3991	40213201	2011-12-31	2011-12-31 00:00:00	2011-12-31	2011-12-31 00:00:00	2011-12-31	581452		0	0	0		0	0	0	265405	0	33	40213201		
85770	1878	40213227	1996-08-11	1996-08-11 00:00:00	1996-08-11	1996-08-11 00:00:00	1996-08-11	581452		0	0	0		0	0	0	\N	0	113	40213227		
31052	2574	1127433	1982-08-31	1982-08-31 00:00:00	1982-09-28	1982-09-28 00:00:00	1982-09-28	38000177		0	0	28		0	0	0	170495	0	313782	1127433		
31093	2577	19008572	2012-10-04	2012-10-04 00:00:00	2012-10-18	2012-10-18 00:00:00	2012-10-18	38000177		0	0	14		0	0	0	170641	0	106258	19008572		
31111	2579	19133873	1962-11-13	1962-11-13 00:00:00	1962-11-25	1962-11-25 00:00:00	1962-11-25	38000177		0	0	12		0	0	0	170846	0	834061	19133873		
18985	411	40213160	1963-12-07	1963-12-07 00:00:00	1963-12-07	1963-12-07 00:00:00	1963-12-07	581452		0	0	0		0	0	0	\N	0	10	40213160		
121945	2680	40213296	2013-11-14	2013-11-14 00:00:00	2013-11-14	2013-11-14 00:00:00	2013-11-14	581452		0	0	0		0	0	0	177589	0	52	40213296		
62861	5223	1127433	1978-02-08	1978-02-08 00:00:00	1978-02-22	1978-02-22 00:00:00	1978-02-22	38000177		0	0	14		0	0	0	347590	0	313782	1127433		
25368	2087	1539411	2001-07-18	2001-07-18 00:00:00	2001-07-18	2001-07-18 00:00:00	\N	38000177		0	0	0		0	0	0	139117	0	312961	1539411		
40812	3383	1124300	2018-06-03	2018-06-03 00:00:00	2018-06-03	2018-06-03 00:00:00	\N	38000177		0	0	0		0	0	0	224502	0	00781178901	45011828		
3647	300	46233988	1973-04-18	1973-04-18 00:00:00	1973-05-02	1973-05-02 00:00:00	1973-05-02	38000177		0	0	14		0	0	0	20056	0	1652673	46233988		
195507	4295	40213160	1972-05-31	1972-05-31 00:00:00	1972-05-31	1972-05-31 00:00:00	1972-05-31	581452		0	0	0		0	0	0	285054	0	10	40213160		
18578	1536	40169281	1967-02-26	1967-02-26 00:00:00	1967-02-26	1967-02-26 00:00:00	\N	38000177		0	0	0		0	0	0	102844	0	896209	40169281		
191025	4197	40213160	1985-12-22	1985-12-22 00:00:00	1985-12-22	1985-12-22 00:00:00	1985-12-22	581452		0	0	0		0	0	0	278517	0	10	40213160		
69684	1523	40213296	1998-04-21	1998-04-21 00:00:00	1998-04-21	1998-04-21 00:00:00	1998-04-21	581452		0	0	0		0	0	0	101877	0	52	40213296		
3450	286	1127433	1995-12-27	1995-12-27 00:00:00	1996-01-10	1996-01-10 00:00:00	1996-01-10	38000177		0	0	14		0	0	0	19054	0	313782	1127433		
51526	4282	1127433	1977-09-06	1977-09-06 00:00:00	1977-09-13	1977-09-13 00:00:00	1977-09-13	38000177		0	0	7		0	0	0	284196	0	313782	1127433		
39747	3287	40236824	1988-08-10	1988-08-10 00:00:00	1988-08-17	1988-08-17 00:00:00	1988-08-17	38000177		0	0	7		0	0	0	218390	0	1094107	40236824		
31434	2604	1127433	2011-05-19	2011-05-19 00:00:00	2011-05-26	2011-05-26 00:00:00	2011-05-26	38000177		0	0	7		0	0	0	172316	0	313782	1127433		
64570	1412	40213306	1983-09-10	1983-09-10 00:00:00	1983-09-10	1983-09-10 00:00:00	1983-09-10	581452		0	0	0		0	0	0	94077	0	43	40213306		
14423	311	40213314	1978-10-03	1978-10-03 00:00:00	1978-10-03	1978-10-03 00:00:00	1978-10-03	581452		0	0	0		0	0	0	20593	0	49	40213314		
59521	1303	40213160	1976-08-29	1976-08-29 00:00:00	1976-08-29	1976-08-29 00:00:00	1976-08-29	581452		0	0	0		0	0	0	86039	0	10	40213160		
219587	4820	40213296	1997-01-02	1997-01-02 00:00:00	1997-01-02	1997-01-02 00:00:00	1997-01-02	581452		0	0	0		0	0	0	320593	0	52	40213296		
219628	4820	40213227	2017-06-22	2017-06-22 00:00:00	2017-06-22	2017-06-22 00:00:00	2017-06-22	581452		0	0	0		0	0	0	320625	0	113	40213227		
204908	4497	40213227	1998-04-28	1998-04-28 00:00:00	1998-04-28	1998-04-28 00:00:00	1998-04-28	581452		0	0	0		0	0	0	299393	0	113	40213227		
17383	1439	40229134	2019-05-12	2019-05-12 00:00:00	2019-05-26	2019-05-26 00:00:00	2019-05-26	38000177		0	0	14		0	0	0	95907	0	1043400	40229134		
61068	5078	19078461	1997-09-02	1997-09-02 00:00:00	1997-10-02	1997-10-02 00:00:00	1997-10-02	38000177		0	0	30		0	0	0	337629	0	310965	19078461		
57828	4805	1124300	2003-07-01	2003-07-01 00:00:00	2003-07-01	2003-07-01 00:00:00	\N	38000177		0	0	0		0	0	0	319709	0	00781178901	45011828		
239495	5257	40213160	1978-08-23	1978-08-23 00:00:00	1978-08-23	1978-08-23 00:00:00	1978-08-23	581452		0	0	0		0	0	0	349801	0	10	40213160		
211279	4633	40213296	1999-08-24	1999-08-24 00:00:00	1999-08-24	1999-08-24 00:00:00	1999-08-24	581452		0	0	0		0	0	0	308787	0	52	40213296		
55041	4570	19006318	1957-12-05	1957-12-05 00:00:00	1957-12-19	1957-12-19 00:00:00	1957-12-19	38000177		0	0	14		0	0	0	304434	0	105078	19006318		
50846	4224	1127433	1973-12-15	1973-12-15 00:00:00	1973-12-29	1973-12-29 00:00:00	1973-12-29	38000177		0	0	14		0	0	0	280532	0	313782	1127433		
129964	2858	40213227	2002-03-12	2002-03-12 00:00:00	2002-03-12	2002-03-12 00:00:00	2002-03-12	581452		0	0	0		0	0	0	189832	0	113	40213227		
215623	4729	40213296	2003-02-07	2003-02-07 00:00:00	2003-02-07	2003-02-07 00:00:00	2003-02-07	581452		0	0	0		0	0	0	315115	0	52	40213296		
10420	869	19059056	1936-10-10	1936-10-10 00:00:00	1936-10-31	1936-10-31 00:00:00	1936-10-31	38000177		0	0	21		0	0	0	57722	0	243670	19059056		
58097	4826	1127433	2002-11-22	2002-11-22 00:00:00	2002-12-13	2002-12-13 00:00:00	2002-12-13	38000177		0	0	21		0	0	0	320987	0	313782	1127433		
209991	4604	40213260	2015-04-19	2015-04-19 00:00:00	2015-04-19	2015-04-19 00:00:00	2015-04-19	581452		0	0	0		0	0	0	306710	0	121	40213260		
119907	2636	40213227	1994-07-01	1994-07-01 00:00:00	1994-07-01	1994-07-01 00:00:00	1994-07-01	581452		0	0	0		0	0	0	174449	0	113	40213227		
145558	3200	40213227	2018-05-31	2018-05-31 00:00:00	2018-05-31	2018-05-31 00:00:00	2018-05-31	581452		0	0	0		0	0	0	212823	0	113	40213227		
116000	2548	40213260	2016-01-31	2016-01-31 00:00:00	2016-01-31	2016-01-31 00:00:00	2016-01-31	581452		0	0	0		0	0	0	168691	0	121	40213260		
34828	760	40213306	1987-02-18	1987-02-18 00:00:00	1987-02-18	1987-02-18 00:00:00	1987-02-18	581452		0	0	0		0	0	0	50519	0	43	40213306		
2699	217	1127433	2016-03-06	2016-03-06 00:00:00	2016-03-13	2016-03-13 00:00:00	2016-03-13	38000177		0	0	7		0	0	0	14655	0	313782	1127433		
128316	2822	40213160	1976-03-31	1976-03-31 00:00:00	1976-03-31	1976-03-31 00:00:00	1976-03-31	581452		0	0	0		0	0	0	187013	0	10	40213160		
59308	1297	40213227	2010-10-31	2010-10-31 00:00:00	2010-10-31	2010-10-31 00:00:00	2010-10-31	581452		0	0	0		0	0	0	85753	0	113	40213227		
40596	3364	19133905	2013-10-18	2013-10-18 00:00:00	2013-10-30	2013-10-30 00:00:00	2013-10-30	38000177		0	0	12		0	0	0	223065	0	834102	19133905		
13344	1118	920334	2004-01-05	2004-01-05 00:00:00	2004-01-12	2004-01-12 00:00:00	2004-01-12	38000177		0	0	7		0	0	0	73679	0	311995	920334		
180251	3961	40213160	1973-10-23	1973-10-23 00:00:00	1973-10-23	1973-10-23 00:00:00	1973-10-23	581452		0	0	0		0	0	0	263341	0	10	40213160		
50716	4214	1539411	2018-12-18	2018-12-18 00:00:00	2018-12-18	2018-12-18 00:00:00	\N	38000177		0	0	0		0	0	0	279771	0	312961	1539411		
57805	1265	40213251	1984-02-05	1984-02-05 00:00:00	1984-02-05	1984-02-05 00:00:00	1984-02-05	581452		0	0	0		0	0	0	83388	0	21	40213251		
228697	5023	40213227	2014-03-02	2014-03-02 00:00:00	2014-03-02	2014-03-02 00:00:00	2014-03-02	581452		0	0	0		0	0	0	333794	0	113	40213227		
61315	5101	1127078	1962-07-01	1962-07-01 00:00:00	1962-07-22	1962-07-22 00:00:00	1962-07-22	38000177		0	0	21		0	0	0	338974	0	282464	1127078		
61352	5103	1127433	1993-06-28	1993-06-28 00:00:00	1993-08-27	1993-08-27 00:00:00	1993-08-27	38000177		0	0	60		0	0	0	339106	0	313782	1127433		
53873	4477	1127078	1970-10-13	1970-10-13 00:00:00	1970-11-12	1970-11-12 00:00:00	1970-11-12	38000177		0	0	30		0	0	0	297912	0	282464	1127078		
128981	2836	40213314	1981-11-09	1981-11-09 00:00:00	1981-11-09	1981-11-09 00:00:00	1981-11-09	581452		0	0	0		0	0	0	188391	0	49	40213314		
195901	4304	40213160	1967-05-21	1967-05-21 00:00:00	1967-05-21	1967-05-21 00:00:00	1967-05-21	581452		0	0	0		0	0	0	285490	0	10	40213160		
90801	1992	40213314	1977-02-27	1977-02-27 00:00:00	1977-02-27	1977-02-27 00:00:00	1977-02-27	581452		0	0	0		0	0	0	132760	0	49	40213314		
20455	1683	1127078	1981-04-30	1981-04-30 00:00:00	1981-05-28	1981-05-28 00:00:00	1981-05-28	38000177		0	0	28		0	0	0	112767	0	282464	1127078		
181677	3991	40213227	2017-01-28	2017-01-28 00:00:00	2017-01-28	2017-01-28 00:00:00	2017-01-28	581452		0	0	0		0	0	0	265316	0	113	40213227		
7296	158	40213201	2013-06-15	2013-06-15 00:00:00	2013-06-15	2013-06-15 00:00:00	2013-06-15	581452		0	0	0		0	0	0	10853	0	33	40213201		
31053	2574	19133873	1975-05-04	1975-05-04 00:00:00	1975-05-16	1975-05-16 00:00:00	1975-05-16	38000177		0	0	12		0	0	0	170507	0	834061	19133873		
31094	2577	19134077	2012-10-04	2012-10-04 00:00:00	2012-10-18	2012-10-18 00:00:00	2012-10-18	38000177		0	0	14		0	0	0	170641	0	835900	19134077		
31113	2579	1127433	1996-10-06	1996-10-06 00:00:00	1996-10-13	1996-10-13 00:00:00	1996-10-13	38000177		0	0	7		0	0	0	170772	0	313782	1127433		
18986	411	40213260	2010-02-27	2010-02-27 00:00:00	2010-02-27	2010-02-27 00:00:00	2010-02-27	581452		0	0	0		0	0	0	27380	0	121	40213260		
121955	2680	40213227	2005-11-03	2005-11-03 00:00:00	2005-11-03	2005-11-03 00:00:00	2005-11-03	581452		0	0	0		0	0	0	177593	0	113	40213227		
62862	5223	1127433	2010-10-17	2010-10-17 00:00:00	2010-10-31	2010-10-31 00:00:00	2010-10-31	38000177		0	0	14		0	0	0	347531	0	313782	1127433		
25369	2087	19075601	2001-07-18	2001-07-18 00:00:00	2011-06-15	2011-06-15 00:00:00	2011-06-15	38000177		0	0	3619		0	0	0	139117	0	309362	19075601		
40813	3383	1127078	1995-09-27	1995-09-27 00:00:00	1995-10-18	1995-10-18 00:00:00	1995-10-18	38000177		0	0	21		0	0	0	224492	0	282464	1127078		
3648	300	1127078	1973-04-18	1973-04-18 00:00:00	1973-05-02	1973-05-02 00:00:00	1973-05-02	38000177		0	0	14		0	0	0	20056	0	282464	1127078		
195515	4295	40213160	1976-07-28	1976-07-28 00:00:00	1976-07-28	1976-07-28 00:00:00	1976-07-28	581452		0	0	0		0	0	0	285086	0	10	40213160		
18579	1536	19059056	1944-03-10	1944-03-10 00:00:00	1944-03-24	1944-03-24 00:00:00	1944-03-24	38000177		0	0	14		0	0	0	102789	0	243670	19059056		
191031	4197	40213227	2016-11-27	2016-11-27 00:00:00	2016-11-27	2016-11-27 00:00:00	2016-11-27	581452		0	0	0		0	0	0	278533	0	113	40213227		
69687	1523	40213227	1998-04-21	1998-04-21 00:00:00	1998-04-21	1998-04-21 00:00:00	1998-04-21	581452		0	0	0		0	0	0	101877	0	113	40213227		
3451	286	1115171	2006-10-16	2006-10-16 00:00:00	2006-12-15	2006-12-15 00:00:00	2006-12-15	38000177		0	0	60		0	0	0	19043	0	849574	1115171		
51527	4282	1713671	1998-07-26	1998-07-26 00:00:00	1998-08-02	1998-08-02 00:00:00	1998-08-02	38000177		0	0	7		0	0	0	284161	0	562251	1713671		
39748	3287	920300	1988-08-10	1988-08-10 00:00:00	1988-08-17	1988-08-17 00:00:00	1988-08-17	38000177		0	0	7		0	0	0	218390	0	311989	920300		
19192	418	40213160	1962-09-03	1962-09-03 00:00:00	1962-09-03	1962-09-03 00:00:00	1962-09-03	581452		0	0	0		0	0	0	27586	0	10	40213160		
64575	1412	40213227	1993-05-08	1993-05-08 00:00:00	1993-05-08	1993-05-08 00:00:00	1993-05-08	581452		0	0	0		0	0	0	94097	0	113	40213227		
14429	311	40213251	1984-07-17	1984-07-17 00:00:00	1984-07-17	1984-07-17 00:00:00	1984-07-17	581452		0	0	0		0	0	0	20613	0	21	40213251		
59530	1303	40213296	2018-06-03	2018-06-03 00:00:00	2018-06-03	2018-06-03 00:00:00	2018-06-03	581452		0	0	0		0	0	0	86033	0	52	40213296		
219589	4820	40213227	1997-01-02	1997-01-02 00:00:00	1997-01-02	1997-01-02 00:00:00	1997-01-02	581452		0	0	0		0	0	0	320593	0	113	40213227		
80409	1759	40213227	2018-10-01	2018-10-01 00:00:00	2018-10-01	2018-10-01 00:00:00	2018-10-01	581452		0	0	0		0	0	0	117598	0	113	40213227		
204915	4497	40213260	2008-05-27	2008-05-27 00:00:00	2008-05-27	2008-05-27 00:00:00	2008-05-27	581452		0	0	0		0	0	0	299376	0	121	40213260		
17384	1439	1127433	2006-08-30	2006-08-30 00:00:00	2006-09-13	2006-09-13 00:00:00	2006-09-13	38000177		0	0	14		0	0	0	95921	0	313782	1127433		
61069	5078	1713671	1982-06-14	1982-06-14 00:00:00	1982-06-28	1982-06-28 00:00:00	1982-06-28	38000177		0	0	14		0	0	0	337544	0	562251	1713671		
57829	4805	19078461	2016-10-24	2016-10-24 00:00:00	2016-11-14	2016-11-14 00:00:00	2016-11-14	38000177		0	0	21		0	0	0	319732	0	310965	19078461		
239496	5257	40213314	1979-05-23	1979-05-23 00:00:00	1979-05-23	1979-05-23 00:00:00	1979-05-23	581452		0	0	0		0	0	0	349802	0	49	40213314		
211288	4633	40213160	1959-03-03	1959-03-03 00:00:00	1959-03-03	1959-03-03 00:00:00	1959-03-03	581452		0	0	0		0	0	0	308752	0	10	40213160		
55042	4571	19133873	1958-02-09	1958-02-09 00:00:00	1958-02-19	1958-02-19 00:00:00	1958-02-19	38000177		0	0	10		0	0	0	304556	0	834061	19133873		
56499	4689	1127433	1993-12-29	1993-12-29 00:00:00	1994-01-12	1994-01-12 00:00:00	1994-01-12	38000177		0	0	14		0	0	0	312404	0	313782	1127433		
129980	2858	40213227	1992-03-03	1992-03-03 00:00:00	1992-03-03	1992-03-03 00:00:00	1992-03-03	581452		0	0	0		0	0	0	189772	0	113	40213227		
213551	4682	40213160	1980-05-25	1980-05-25 00:00:00	1980-05-25	1980-05-25 00:00:00	1980-05-25	581452		0	0	0		0	0	0	312017	0	10	40213160		
10421	869	19059056	1937-11-25	1937-11-25 00:00:00	1938-02-23	1938-02-23 00:00:00	1938-02-23	38000177		0	0	90		0	0	0	57723	0	243670	19059056		
58098	4826	1127433	1991-11-07	1991-11-07 00:00:00	1991-11-21	1991-11-21 00:00:00	1991-11-21	38000177		0	0	14		0	0	0	320946	0	313782	1127433		
209996	4604	40213160	1964-11-08	1964-11-08 00:00:00	1964-11-08	1964-11-08 00:00:00	1964-11-08	581452		0	0	0		0	0	0	306731	0	10	40213160		
119908	2636	40213296	2002-04-26	2002-04-26 00:00:00	2002-04-26	2002-04-26 00:00:00	2002-04-26	581452		0	0	0		0	0	0	174481	0	52	40213296		
126344	2779	40213160	1975-10-26	1975-10-26 00:00:00	1975-10-26	1975-10-26 00:00:00	1975-10-26	581452		0	0	0		0	0	0	184147	0	10	40213160		
101868	2233	40213160	1972-10-10	1972-10-10 00:00:00	1972-10-10	1972-10-10 00:00:00	1972-10-10	581452		0	0	0		0	0	0	148589	0	10	40213160		
34832	760	40213160	1965-03-03	1965-03-03 00:00:00	1965-03-03	1965-03-03 00:00:00	1965-03-03	581452		0	0	0		0	0	0	50467	0	10	40213160		
2700	217	1127433	2010-09-16	2010-09-16 00:00:00	2010-09-30	2010-09-30 00:00:00	2010-09-30	38000177		0	0	14		0	0	0	14685	0	313782	1127433		
128320	2822	40213306	1996-10-09	1996-10-09 00:00:00	1996-10-09	1996-10-09 00:00:00	1996-10-09	581452		0	0	0		0	0	0	187023	0	43	40213306		
59310	1297	40213314	1979-01-21	1979-01-21 00:00:00	1979-01-21	1979-01-21 00:00:00	1979-01-21	581452		0	0	0		0	0	0	85741	0	49	40213314		
40597	3364	19008572	2000-06-26	2000-06-26 00:00:00	2000-06-26	2000-06-26 00:00:00	\N	38000177		0	0	0		0	0	0	223064	0	106258	19008572		
13345	1118	40169216	1976-08-18	1976-08-18 00:00:00	1976-08-18	1976-08-18 00:00:00	\N	38000177		0	0	0		0	0	0	73680	0	895994	40169216		
168463	3703	40213306	1991-01-26	1991-01-26 00:00:00	1991-01-26	1991-01-26 00:00:00	1991-01-26	581452		0	0	0		0	0	0	246200	0	43	40213306		
50717	4214	19075601	2018-12-18	2018-12-18 00:00:00	2018-12-18	2018-12-18 00:00:00	\N	38000177		0	0	0		0	0	0	279771	0	309362	19075601		
57815	1265	40213314	1980-08-17	1980-08-17 00:00:00	1980-08-17	1980-08-17 00:00:00	1980-08-17	581452		0	0	0		0	0	0	83373	0	49	40213314		
228698	5023	40213296	2014-03-02	2014-03-02 00:00:00	2014-03-02	2014-03-02 00:00:00	2014-03-02	581452		0	0	0		0	0	0	333794	0	52	40213296		
61316	5101	1118084	1998-10-10	1998-10-10 00:00:00	1998-10-10	1998-10-10 00:00:00	\N	38000177		0	0	0		0	0	0	339008	0	00025152531	44923712		
61353	5103	1127433	1956-01-25	1956-01-25 00:00:00	1956-03-25	1956-03-25 00:00:00	1956-03-25	38000177		0	0	60		0	0	0	339103	0	313782	1127433		
53874	4477	1713671	2002-12-13	2002-12-13 00:00:00	2002-12-20	2002-12-20 00:00:00	2002-12-20	38000177		0	0	7		0	0	0	297942	0	562251	1713671		
128985	2836	40213160	1981-05-11	1981-05-11 00:00:00	1981-05-11	1981-05-11 00:00:00	1981-05-11	581452		0	0	0		0	0	0	188358	0	10	40213160		
195905	4305	40213227	2009-11-20	2009-11-20 00:00:00	2009-11-20	2009-11-20 00:00:00	2009-11-20	581452		0	0	0		0	0	0	285547	0	113	40213227		
90804	1992	40213227	2006-12-31	2006-12-31 00:00:00	2006-12-31	2006-12-31 00:00:00	2006-12-31	581452		0	0	0		0	0	0	132744	0	113	40213227		
20456	1683	40165015	2012-10-01	2012-10-01 00:00:00	2012-10-01	2012-10-01 00:00:00	\N	38000177		0	0	0		0	0	0	112772	0	861467	40165015		
181681	3991	40213227	2006-12-02	2006-12-02 00:00:00	2006-12-02	2006-12-02 00:00:00	2006-12-02	581452		0	0	0		0	0	0	265350	0	113	40213227		
7303	158	40213198	2012-06-09	2012-06-09 00:00:00	2012-06-09	2012-06-09 00:00:00	2012-06-09	581452		0	0	0		0	0	0	10779	0	133	40213198		
31054	2574	1118084	2005-05-08	2005-05-08 00:00:00	2005-05-08	2005-05-08 00:00:00	\N	38000177		0	0	0		0	0	0	170470	0	00025152531	44923712		
31095	2577	40232448	1975-06-02	1975-06-02 00:00:00	1975-06-02	1975-06-02 00:00:00	\N	38000177		0	0	0		0	0	0	170612	0	1049630	40232448		
31114	2579	1713671	1967-12-07	1967-12-07 00:00:00	1967-12-21	1967-12-21 00:00:00	1967-12-21	38000177		0	0	14		0	0	0	170809	0	562251	1713671		
18991	411	40213160	1959-10-31	1959-10-31 00:00:00	1959-10-31	1959-10-31 00:00:00	1959-10-31	581452		0	0	0		0	0	0	27341	0	10	40213160		
121956	2680	40213160	1972-08-17	1972-08-17 00:00:00	1972-08-17	1972-08-17 00:00:00	1972-08-17	581452		0	0	0		0	0	0	177580	0	10	40213160		
173711	3820	40213160	1965-07-30	1965-07-30 00:00:00	1965-07-30	1965-07-30 00:00:00	1965-07-30	581452		0	0	0		0	0	0	253608	0	10	40213160		
25370	2087	1332419	2001-07-18	2001-07-18 00:00:00	2001-07-18	2001-07-18 00:00:00	\N	38000177		0	0	0		0	0	0	139117	0	197361	1332419		
40814	3383	1127433	2014-11-07	2014-11-07 00:00:00	2014-11-28	2014-11-28 00:00:00	2014-11-28	38000177		0	0	21		0	0	0	224493	0	313782	1127433		
3649	300	19133873	1982-08-31	1982-08-31 00:00:00	1982-09-09	1982-09-09 00:00:00	1982-09-09	38000177		0	0	9		0	0	0	20074	0	834061	19133873		
195526	4295	40213227	2013-10-02	2013-10-02 00:00:00	2013-10-02	2013-10-02 00:00:00	2013-10-02	581452		0	0	0		0	0	0	285078	0	113	40213227		
18580	1536	1118084	1945-05-09	1945-05-09 00:00:00	1945-05-09	1945-05-09 00:00:00	\N	38000177		0	0	0		0	0	0	102789	0	00025152531	44923712		
144849	3183	40213306	2003-03-09	2003-03-09 00:00:00	2003-03-09	2003-03-09 00:00:00	2003-03-09	581452		0	0	0		0	0	0	211951	0	43	40213306		
69690	1523	40213296	1996-04-16	1996-04-16 00:00:00	1996-04-16	1996-04-16 00:00:00	1996-04-16	581452		0	0	0		0	0	0	101844	0	52	40213296		
3452	286	40229134	1934-05-22	1934-05-22 00:00:00	1934-05-29	1934-05-29 00:00:00	1934-05-29	38000177		0	0	7		0	0	0	19082	0	1043400	40229134		
51528	4282	1127433	1983-12-24	1983-12-24 00:00:00	1984-01-07	1984-01-07 00:00:00	1984-01-07	38000177		0	0	14		0	0	0	284171	0	313782	1127433		
39749	3287	19059056	1949-02-01	1949-02-01 00:00:00	1949-02-15	1949-02-15 00:00:00	1949-02-15	38000177		0	0	14		0	0	0	218295	0	243670	19059056		
19195	418	40213227	2008-11-17	2008-11-17 00:00:00	2008-11-17	2008-11-17 00:00:00	2008-11-17	581452		0	0	0		0	0	0	27680	0	113	40213227		
64583	1412	40213227	2003-05-24	2003-05-24 00:00:00	2003-05-24	2003-05-24 00:00:00	2003-05-24	581452		0	0	0		0	0	0	94007	0	113	40213227		
14432	311	40213227	2011-01-18	2011-01-18 00:00:00	2011-01-18	2011-01-18 00:00:00	2011-01-18	581452		0	0	0		0	0	0	20647	0	113	40213227		
59532	1303	40213227	2018-06-03	2018-06-03 00:00:00	2018-06-03	2018-06-03 00:00:00	2018-06-03	581452		0	0	0		0	0	0	86033	0	113	40213227		
229838	5051	40213314	1979-02-01	1979-02-01 00:00:00	1979-02-01	1979-02-01 00:00:00	1979-02-01	581452		0	0	0		0	0	0	335912	0	49	40213314		
80413	1759	40213227	2006-02-06	2006-02-06 00:00:00	2006-02-06	2006-02-06 00:00:00	2006-02-06	581452		0	0	0		0	0	0	\N	0	113	40213227		
204917	4497	40213227	2008-05-27	2008-05-27 00:00:00	2008-05-27	2008-05-27 00:00:00	2008-05-27	581452		0	0	0		0	0	0	299376	0	113	40213227		
17387	1441	19008572	1974-03-06	1974-03-06 00:00:00	1974-03-27	1974-03-27 00:00:00	1974-03-27	38000177		0	0	21		0	0	0	95977	0	106258	19008572		
61070	5078	19133905	1962-04-14	1962-04-14 00:00:00	1962-04-21	1962-04-21 00:00:00	1962-04-21	38000177		0	0	7		0	0	0	337498	0	834102	19133905		
57830	4805	1127078	1972-05-04	1972-05-04 00:00:00	1972-05-18	1972-05-18 00:00:00	1972-05-18	38000177		0	0	14		0	0	0	319731	0	282464	1127078		
212297	4655	40213227	2010-07-25	2010-07-25 00:00:00	2010-07-25	2010-07-25 00:00:00	2010-07-25	581452		0	0	0		0	0	0	310275	0	113	40213227		
211289	4633	40213160	1959-05-05	1959-05-05 00:00:00	1959-05-05	1959-05-05 00:00:00	1959-05-05	581452		0	0	0		0	0	0	308773	0	10	40213160		
115573	2540	40213227	1998-12-22	1998-12-22 00:00:00	1998-12-22	1998-12-22 00:00:00	1998-12-22	581452		0	0	0		0	0	0	167968	0	113	40213227		
56500	4689	1127433	1998-10-01	1998-10-01 00:00:00	1998-10-15	1998-10-15 00:00:00	1998-10-15	38000177		0	0	14		0	0	0	312379	0	313782	1127433		
121143	2662	40213160	1983-04-07	1983-04-07 00:00:00	1983-04-07	1983-04-07 00:00:00	1983-04-07	581452		0	0	0		0	0	0	176399	0	10	40213160		
213553	4682	40213227	2010-11-28	2010-11-28 00:00:00	2010-11-28	2010-11-28 00:00:00	2010-11-28	581452		0	0	0		0	0	0	311991	0	113	40213227		
10422	869	1127433	1980-06-30	1980-06-30 00:00:00	1980-07-14	1980-07-14 00:00:00	1980-07-14	38000177		0	0	14		0	0	0	57767	0	313782	1127433		
58099	4826	1713671	1954-03-03	1954-03-03 00:00:00	1954-03-17	1954-03-17 00:00:00	1954-03-17	38000177		0	0	14		0	0	0	320920	0	562251	1713671		
215005	4715	40213160	1955-07-20	1955-07-20 00:00:00	1955-07-20	1955-07-20 00:00:00	1955-07-20	581452		0	0	0		0	0	0	313908	0	10	40213160		
119910	2636	40213227	2002-04-26	2002-04-26 00:00:00	2002-04-26	2002-04-26 00:00:00	2002-04-26	581452		0	0	0		0	0	0	174481	0	113	40213227		
126346	2779	40213227	2002-05-26	2002-05-26 00:00:00	2002-05-26	2002-05-26 00:00:00	2002-05-26	581452		0	0	0		0	0	0	184197	0	113	40213227		
101873	2233	40213160	1972-07-11	1972-07-11 00:00:00	1972-07-11	1972-07-11 00:00:00	1972-07-11	581452		0	0	0		0	0	0	148566	0	10	40213160		
34836	760	40213227	1995-12-20	1995-12-20 00:00:00	1995-12-20	1995-12-20 00:00:00	1995-12-20	581452		0	0	0		0	0	0	50480	0	113	40213227		
2701	217	1713671	1994-05-21	1994-05-21 00:00:00	1994-06-11	1994-06-11 00:00:00	1994-06-11	38000177		0	0	21		0	0	0	14648	0	562251	1713671		
128323	2822	40213160	1976-09-01	1976-09-01 00:00:00	1976-09-01	1976-09-01 00:00:00	1976-09-01	581452		0	0	0		0	0	0	187014	0	10	40213160		
59311	1297	40213160	1979-01-21	1979-01-21 00:00:00	1979-01-21	1979-01-21 00:00:00	1979-01-21	581452		0	0	0		0	0	0	85741	0	10	40213160		
40598	3365	1127433	2001-05-06	2001-05-06 00:00:00	2001-05-13	2001-05-13 00:00:00	2001-05-13	38000177		0	0	7		0	0	0	223156	0	313782	1127433		
13346	1118	1154615	1976-08-18	1976-08-18 00:00:00	1976-08-18	1976-08-18 00:00:00	\N	38000177		0	0	0		0	0	0	73680	0	745679	1154615		
168464	3703	40213260	2018-11-24	2018-11-24 00:00:00	2018-11-24	2018-11-24 00:00:00	2018-11-24	581452		0	0	0		0	0	0	246268	0	121	40213260		
50718	4214	1127078	1975-11-13	1975-11-13 00:00:00	1975-11-27	1975-11-27 00:00:00	1975-11-27	38000177		0	0	14		0	0	0	279803	0	282464	1127078		
57816	1265	40213160	1980-08-17	1980-08-17 00:00:00	1980-08-17	1980-08-17 00:00:00	1980-08-17	581452		0	0	0		0	0	0	83373	0	10	40213160		
156541	3444	40213227	2010-02-01	2010-02-01 00:00:00	2010-02-01	2010-02-01 00:00:00	2010-02-01	581452		0	0	0		0	0	0	228609	0	113	40213227		
61318	5101	1127433	1994-04-26	1994-04-26 00:00:00	1994-05-03	1994-05-03 00:00:00	1994-05-03	38000177		0	0	7		0	0	0	338965	0	313782	1127433		
61354	5103	40162522	1956-01-25	1956-01-25 00:00:00	1956-01-25	1956-01-25 00:00:00	\N	38000177		0	0	0		0	0	0	339103	0	857005	40162522		
53875	4477	40162522	2012-07-02	2012-07-02 00:00:00	2012-07-02	2012-07-02 00:00:00	\N	38000177		0	0	0		0	0	0	297940	0	857005	40162522		
128994	2836	40213227	2011-11-28	2011-11-28 00:00:00	2011-11-28	2011-11-28 00:00:00	2011-11-28	581452		0	0	0		0	0	0	188382	0	113	40213227		
62324	5189	1713671	1980-09-28	1980-09-28 00:00:00	1980-10-05	1980-10-05 00:00:00	1980-10-05	38000177		0	0	7		0	0	0	344916	0	562251	1713671		
90807	1992	40213314	1978-02-26	1978-02-26 00:00:00	1978-02-26	1978-02-26 00:00:00	1978-02-26	581452		0	0	0		0	0	0	132650	0	49	40213314		
20457	1683	1115171	2012-10-01	2012-10-01 00:00:00	2012-11-30	2012-11-30 00:00:00	2012-11-30	38000177		0	0	60		0	0	0	112772	0	849574	1115171		
192966	4239	40213227	1999-10-02	1999-10-02 00:00:00	1999-10-02	1999-10-02 00:00:00	1999-10-02	581452		0	0	0		0	0	0	281552	0	113	40213227		
7308	158	40213227	2018-04-28	2018-04-28 00:00:00	2018-04-28	2018-04-28 00:00:00	2018-04-28	581452		0	0	0		0	0	0	10780	0	113	40213227		
31055	2574	1127078	1961-05-04	1961-05-04 00:00:00	1961-05-18	1961-05-18 00:00:00	1961-05-18	38000177		0	0	14		0	0	0	170510	0	282464	1127078		
31096	2578	40229134	1972-12-31	1972-12-31 00:00:00	1973-01-07	1973-01-07 00:00:00	1973-01-07	38000177		0	0	7		0	0	0	170752	0	1043400	40229134		
31115	2579	19059056	1953-11-11	1953-11-11 00:00:00	1953-11-25	1953-11-25 00:00:00	1953-11-25	38000177		0	0	14		0	0	0	170851	0	243670	19059056		
18996	411	40213227	2001-03-03	2001-03-03 00:00:00	2001-03-03	2001-03-03 00:00:00	2001-03-03	581452		0	0	0		0	0	0	27320	0	113	40213227		
15690	338	40213227	1998-06-17	1998-06-17 00:00:00	1998-06-17	1998-06-17 00:00:00	1998-06-17	581452		0	0	0		0	0	0	22477	0	113	40213227		
173719	3820	40213306	1987-10-23	1987-10-23 00:00:00	1987-10-23	1987-10-23 00:00:00	1987-10-23	581452		0	0	0		0	0	0	253638	0	43	40213306		
25371	2087	1127433	1955-09-07	1955-09-07 00:00:00	1955-09-21	1955-09-21 00:00:00	1955-09-21	38000177		0	0	14		0	0	0	139029	0	313782	1127433		
40815	3383	19059056	1988-04-06	1988-04-06 00:00:00	1988-05-06	1988-05-06 00:00:00	1988-05-06	38000177		0	0	30		0	0	0	224491	0	243670	19059056		
3650	300	19128065	1988-03-10	1988-03-10 00:00:00	1989-03-05	1989-03-05 00:00:00	1989-03-05	38000177		0	0	360		0	0	0	20059	0	749882	19128065		
195527	4295	40213296	2013-10-02	2013-10-02 00:00:00	2013-10-02	2013-10-02 00:00:00	2013-10-02	581452		0	0	0		0	0	0	285078	0	52	40213296		
18581	1536	1127433	1964-02-03	1964-02-03 00:00:00	1964-02-10	1964-02-10 00:00:00	1964-02-10	38000177		0	0	7		0	0	0	102793	0	313782	1127433		
144851	3183	40213227	2003-03-09	2003-03-09 00:00:00	2003-03-09	2003-03-09 00:00:00	2003-03-09	581452		0	0	0		0	0	0	211951	0	113	40213227		
69691	1523	40213160	1956-07-17	1956-07-17 00:00:00	1956-07-17	1956-07-17 00:00:00	1956-07-17	581452		0	0	0		0	0	0	101826	0	10	40213160		
3453	286	19078461	1993-01-22	1993-01-22 00:00:00	1993-02-26	1993-02-26 00:00:00	1993-02-26	38000177		0	0	35		0	0	0	19041	0	310965	19078461		
51529	4282	19073188	1983-12-24	1983-12-24 00:00:00	1984-01-07	1984-01-07 00:00:00	1984-01-07	38000177		0	0	14		0	0	0	284171	0	308192	19073188		
219266	4812	40213227	2016-08-24	2016-08-24 00:00:00	2016-08-24	2016-08-24 00:00:00	2016-08-24	581452		0	0	0		0	0	0	320166	0	113	40213227		
19196	418	40213260	2007-11-12	2007-11-12 00:00:00	2007-11-12	2007-11-12 00:00:00	2007-11-12	581452		0	0	0		0	0	0	27627	0	121	40213260		
126716	2788	40213314	1978-06-25	1978-06-25 00:00:00	1978-06-25	1978-06-25 00:00:00	1978-06-25	581452		0	0	0		0	0	0	184738	0	49	40213314		
14437	311	40213306	1999-12-14	1999-12-14 00:00:00	1999-12-14	1999-12-14 00:00:00	1999-12-14	581452		0	0	0		0	0	0	20598	0	43	40213306		
59533	1303	40213160	1976-10-31	1976-10-31 00:00:00	1976-10-31	1976-10-31 00:00:00	1976-10-31	581452		0	0	0		0	0	0	86036	0	10	40213160		
229844	5051	40213296	2017-11-30	2017-11-30 00:00:00	2017-11-30	2017-11-30 00:00:00	2017-11-30	581452		0	0	0		0	0	0	335882	0	52	40213296		
80414	1759	40213180	2006-02-06	2006-02-06 00:00:00	2006-02-06	2006-02-06 00:00:00	2006-02-06	581452		0	0	0		0	0	0	\N	0	114	40213180		
204918	4497	40213160	1957-01-01	1957-01-01 00:00:00	1957-01-01	1957-01-01 00:00:00	1957-01-01	581452		0	0	0		0	0	0	299426	0	10	40213160		
17388	1441	1127433	2008-10-25	2008-10-25 00:00:00	2008-11-01	2008-11-01 00:00:00	2008-11-01	38000177		0	0	7		0	0	0	96055	0	313782	1127433		
61071	5078	1713671	1939-09-02	1939-09-02 00:00:00	1939-09-23	1939-09-23 00:00:00	1939-09-23	38000177		0	0	21		0	0	0	337637	0	562251	1713671		
57831	4805	1127433	1996-03-30	1996-03-30 00:00:00	1996-04-13	1996-04-13 00:00:00	1996-04-13	38000177		0	0	14		0	0	0	319672	0	313782	1127433		
212298	4655	40213260	2010-07-25	2010-07-25 00:00:00	2010-07-25	2010-07-25 00:00:00	2010-07-25	581452		0	0	0		0	0	0	310275	0	121	40213260		
211290	4633	40213296	2001-08-28	2001-08-28 00:00:00	2001-08-28	2001-08-28 00:00:00	2001-08-28	581452		0	0	0		0	0	0	308815	0	52	40213296		
70318	1538	40213201	1996-06-17	1996-06-17 00:00:00	1996-06-17	1996-06-17 00:00:00	1996-06-17	581452		0	0	0		0	0	0	103106	0	33	40213201		
56501	4689	19133873	1981-01-08	1981-01-08 00:00:00	1981-01-21	1981-01-21 00:00:00	1981-01-21	38000177		0	0	13		0	0	0	312439	0	834061	19133873		
121145	2662	40213306	2000-11-23	2000-11-23 00:00:00	2000-11-23	2000-11-23 00:00:00	2000-11-23	581452		0	0	0		0	0	0	176425	0	43	40213306		
213557	4682	40213306	2001-11-18	2001-11-18 00:00:00	2001-11-18	2001-11-18 00:00:00	2001-11-18	581452		0	0	0		0	0	0	311998	0	43	40213306		
10423	869	19059056	1920-12-19	1920-12-19 00:00:00	1921-01-02	1921-01-02 00:00:00	1921-01-02	38000177		0	0	14		0	0	0	57769	0	243670	19059056		
540	12	40213306	1986-10-29	1986-10-29 00:00:00	1986-10-29	1986-10-29 00:00:00	1986-10-29	581452		0	0	0		0	0	0	1010	0	43	40213306		
215013	4715	40213227	2002-08-14	2002-08-14 00:00:00	2002-08-14	2002-08-14 00:00:00	2002-08-14	581452		0	0	0		0	0	0	313952	0	113	40213227		
119916	2636	40213306	1982-06-18	1982-06-18 00:00:00	1982-06-18	1982-06-18 00:00:00	1982-06-18	581452		0	0	0		0	0	0	174443	0	43	40213306		
126355	2780	40213227	2007-01-24	2007-01-24 00:00:00	2007-01-24	2007-01-24 00:00:00	2007-01-24	581452		0	0	0		0	0	0	184286	0	113	40213227		
101876	2233	40213160	1972-05-09	1972-05-09 00:00:00	1972-05-09	1972-05-09 00:00:00	1972-05-09	581452		0	0	0		0	0	0	148588	0	10	40213160		
34840	760	40213227	2015-12-02	2015-12-02 00:00:00	2015-12-02	2015-12-02 00:00:00	2015-12-02	581452		0	0	0		0	0	0	50472	0	113	40213227		
2702	217	1127433	1993-09-30	1993-09-30 00:00:00	1993-10-28	1993-10-28 00:00:00	1993-10-28	38000177		0	0	28		0	0	0	14640	0	313782	1127433		
137803	3026	40213227	1997-02-02	1997-02-02 00:00:00	1997-02-02	1997-02-02 00:00:00	1997-02-02	581452		0	0	0		0	0	0	201724	0	113	40213227		
59312	1297	40213314	1979-10-21	1979-10-21 00:00:00	1979-10-21	1979-10-21 00:00:00	1979-10-21	581452		0	0	0		0	0	0	85742	0	49	40213314		
40599	3365	1127078	1968-03-28	1968-03-28 00:00:00	1968-05-02	1968-05-02 00:00:00	1968-05-02	38000177		0	0	35		0	0	0	223178	0	282464	1127078		
13347	1118	19128022	1992-07-13	1992-07-13 00:00:00	1993-07-08	1993-07-08 00:00:00	1993-07-08	38000177		0	0	360		0	0	0	73754	0	749785	19128022		
168466	3703	40213227	2001-03-24	2001-03-24 00:00:00	2001-03-24	2001-03-24 00:00:00	2001-03-24	581452		0	0	0		0	0	0	246189	0	113	40213227		
50719	4214	19006318	1975-11-13	1975-11-13 00:00:00	1975-11-27	1975-11-27 00:00:00	1975-11-27	38000177		0	0	14		0	0	0	279803	0	105078	19006318		
69096	1511	40213160	1970-02-01	1970-02-01 00:00:00	1970-02-01	1970-02-01 00:00:00	1970-02-01	581452		0	0	0		0	0	0	100867	0	10	40213160		
160730	3537	40213160	1961-12-03	1961-12-03 00:00:00	1961-12-03	1961-12-03 00:00:00	1961-12-03	581452		0	0	0		0	0	0	234899	0	10	40213160		
61319	5101	1127433	2004-09-07	2004-09-07 00:00:00	2004-09-28	2004-09-28 00:00:00	2004-09-28	38000177		0	0	21		0	0	0	338978	0	313782	1127433		
61355	5103	1115171	2014-12-05	2014-12-05 00:00:00	2015-01-02	2015-01-02 00:00:00	2015-01-02	38000177		0	0	28		0	0	0	339091	0	849574	1115171		
53877	4477	19128065	1978-11-12	1978-11-12 00:00:00	1979-11-07	1979-11-07 00:00:00	1979-11-07	38000177		0	0	360		0	0	0	297944	0	749882	19128065		
128999	2836	40213227	2002-11-18	2002-11-18 00:00:00	2002-11-18	2002-11-18 00:00:00	2002-11-18	581452		0	0	0		0	0	0	188369	0	113	40213227		
62326	5189	40229134	1970-04-05	1970-04-05 00:00:00	1970-04-19	1970-04-19 00:00:00	1970-04-19	38000177		0	0	14		0	0	0	344903	0	1043400	40229134		
90810	1992	40213227	1997-12-21	1997-12-21 00:00:00	1997-12-21	1997-12-21 00:00:00	1997-12-21	581452		0	0	0		0	0	0	132741	0	113	40213227		
20458	1683	40229134	1998-12-28	1998-12-28 00:00:00	1999-01-04	1999-01-04 00:00:00	1999-01-04	38000177		0	0	7		0	0	0	112800	0	1043400	40229134		
181380	3986	40213306	1983-10-28	1983-10-28 00:00:00	1983-10-28	1983-10-28 00:00:00	1983-10-28	581452		0	0	0		0	0	0	264997	0	43	40213306		
7329	158	40213227	1998-01-10	1998-01-10 00:00:00	1998-01-10	1998-01-10 00:00:00	1998-01-10	581452		0	0	0		0	0	0	10834	0	113	40213227		
31056	2574	19129655	1961-05-04	1961-05-04 00:00:00	1961-05-18	1961-05-18 00:00:00	1961-05-18	38000177		0	0	14		0	0	0	170510	0	789980	19129655		
31097	2578	1127433	1990-12-10	1990-12-10 00:00:00	1990-12-24	1990-12-24 00:00:00	1990-12-24	38000177		0	0	14		0	0	0	170763	0	313782	1127433		
31116	2579	19006318	1953-11-11	1953-11-11 00:00:00	1953-11-25	1953-11-25 00:00:00	1953-11-25	38000177		0	0	14		0	0	0	170851	0	105078	19006318		
18997	411	40213296	2001-03-03	2001-03-03 00:00:00	2001-03-03	2001-03-03 00:00:00	2001-03-03	581452		0	0	0		0	0	0	27320	0	52	40213296		
15696	338	40213227	2009-04-29	2009-04-29 00:00:00	2009-04-29	2009-04-29 00:00:00	2009-04-29	581452		0	0	0		0	0	0	22572	0	113	40213227		
173722	3820	40213260	2014-11-21	2014-11-21 00:00:00	2014-11-21	2014-11-21 00:00:00	2014-11-21	581452		0	0	0		0	0	0	253647	0	121	40213260		
25372	2087	1127433	1923-08-16	1923-08-16 00:00:00	1923-08-23	1923-08-23 00:00:00	1923-08-23	38000177		0	0	7		0	0	0	139038	0	313782	1127433		
40816	3383	19073183	1989-05-31	1989-05-31 00:00:00	1989-06-14	1989-06-14 00:00:00	1989-06-14	38000177		0	0	14		0	0	0	224479	0	308182	19073183		
3651	300	1124300	2009-11-30	2009-11-30 00:00:00	2009-11-30	2009-11-30 00:00:00	\N	38000177		0	0	0		0	0	0	20038	0	00781178901	45011828		
241693	5306	40213160	1969-04-27	1969-04-27 00:00:00	1969-04-27	1969-04-27 00:00:00	1969-04-27	581452		0	0	0		0	0	0	352940	0	10	40213160		
18582	1536	19059056	1926-11-10	1926-11-10 00:00:00	1927-01-09	1927-01-09 00:00:00	1927-01-09	38000177		0	0	60		0	0	0	102788	0	243670	19059056		
144853	3183	40213314	1981-07-19	1981-07-19 00:00:00	1981-07-19	1981-07-19 00:00:00	1981-07-19	581452		0	0	0		0	0	0	211911	0	49	40213314		
69692	1523	40213160	1956-09-18	1956-09-18 00:00:00	1956-09-18	1956-09-18 00:00:00	1956-09-18	581452		0	0	0		0	0	0	101889	0	10	40213160		
3454	286	1127433	2016-05-08	2016-05-08 00:00:00	2016-08-06	2016-08-06 00:00:00	2016-08-06	38000177		0	0	90		0	0	0	19046	0	313782	1127433		
51530	4282	1713671	1989-11-22	1989-11-22 00:00:00	1989-12-06	1989-12-06 00:00:00	1989-12-06	38000177		0	0	14		0	0	0	284167	0	562251	1713671		
230553	5066	40213306	1989-06-10	1989-06-10 00:00:00	1989-06-10	1989-06-10 00:00:00	1989-06-10	581452		0	0	0		0	0	0	336810	0	43	40213306		
19197	418	40213260	2008-11-17	2008-11-17 00:00:00	2008-11-17	2008-11-17 00:00:00	2008-11-17	581452		0	0	0		0	0	0	27680	0	121	40213260		
126717	2788	40213160	1978-06-25	1978-06-25 00:00:00	1978-06-25	1978-06-25 00:00:00	1978-06-25	581452		0	0	0		0	0	0	184738	0	10	40213160		
14439	311	40213227	1999-12-14	1999-12-14 00:00:00	1999-12-14	1999-12-14 00:00:00	1999-12-14	581452		0	0	0		0	0	0	20598	0	113	40213227		
59535	1303	40213160	1981-03-01	1981-03-01 00:00:00	1981-03-01	1981-03-01 00:00:00	1981-03-01	581452		0	0	0		0	0	0	86043	0	10	40213160		
229850	5051	40213160	1982-11-04	1982-11-04 00:00:00	1982-11-04	1982-11-04 00:00:00	1982-11-04	581452		0	0	0		0	0	0	335915	0	10	40213160		
80415	1759	40213306	2006-02-06	2006-02-06 00:00:00	2006-02-06	2006-02-06 00:00:00	2006-02-06	581452		0	0	0		0	0	0	\N	0	43	40213306		
204921	4497	40213296	2000-05-02	2000-05-02 00:00:00	2000-05-02	2000-05-02 00:00:00	2000-05-02	581452		0	0	0		0	0	0	299375	0	52	40213296		
17389	1441	19128065	1988-05-16	1988-05-16 00:00:00	1989-05-11	1989-05-11 00:00:00	1989-05-11	38000177		0	0	360		0	0	0	96014	0	749882	19128065		
61072	5079	19133905	1985-01-20	1985-01-20 00:00:00	1985-01-29	1985-01-29 00:00:00	1985-01-29	38000177		0	0	9		0	0	0	337704	0	834102	19133905		
57832	4805	19126352	2017-10-27	2017-10-27 00:00:00	2017-10-27	2017-10-27 00:00:00	\N	38000177		0	0	0		0	0	0	319730	0	705129	19126352		
212305	4655	40213296	2002-06-30	2002-06-30 00:00:00	2002-06-30	2002-06-30 00:00:00	2002-06-30	581452		0	0	0		0	0	0	310389	0	52	40213296		
211292	4633	40213227	2001-08-28	2001-08-28 00:00:00	2001-08-28	2001-08-28 00:00:00	2001-08-28	581452		0	0	0		0	0	0	308815	0	113	40213227		
70321	1538	40213227	2001-06-25	2001-06-25 00:00:00	2001-06-25	2001-06-25 00:00:00	2001-06-25	581452		0	0	0		0	0	0	\N	0	113	40213227		
56502	4689	40220960	1993-03-02	1993-03-02 00:00:00	1993-03-02	1993-03-02 00:00:00	1993-03-02	38000177		0	0	0		0	0	0	312415	0	1804799	40220960		
121147	2662	40213227	2000-11-23	2000-11-23 00:00:00	2000-11-23	2000-11-23 00:00:00	2000-11-23	581452		0	0	0		0	0	0	176425	0	113	40213227		
213558	4682	40213314	1980-02-24	1980-02-24 00:00:00	1980-02-24	1980-02-24 00:00:00	1980-02-24	581452		0	0	0		0	0	0	312027	0	49	40213314		
10424	869	40229134	1997-04-04	1997-04-04 00:00:00	1997-04-18	1997-04-18 00:00:00	1997-04-18	38000177		0	0	14		0	0	0	57754	0	1043400	40229134		
544	12	40213296	2005-11-16	2005-11-16 00:00:00	2005-11-16	2005-11-16 00:00:00	2005-11-16	581452		0	0	0		0	0	0	1049	0	52	40213296		
217108	4763	40213160	1955-08-02	1955-08-02 00:00:00	1955-08-02	1955-08-02 00:00:00	1955-08-02	581452		0	0	0		0	0	0	317445	0	10	40213160		
119918	2636	40213160	1965-03-26	1965-03-26 00:00:00	1965-03-26	1965-03-26 00:00:00	1965-03-26	581452		0	0	0		0	0	0	174477	0	10	40213160		
126359	2780	40213260	2007-01-24	2007-01-24 00:00:00	2007-01-24	2007-01-24 00:00:00	2007-01-24	581452		0	0	0		0	0	0	184286	0	121	40213260		
101878	2233	40213227	2003-02-25	2003-02-25 00:00:00	2003-02-25	2003-02-25 00:00:00	2003-02-25	581452		0	0	0		0	0	0	148552	0	113	40213227		
34841	760	40213260	2015-12-02	2015-12-02 00:00:00	2015-12-02	2015-12-02 00:00:00	2015-12-02	581452		0	0	0		0	0	0	50472	0	121	40213260		
2703	217	1118084	2017-07-11	2017-07-11 00:00:00	2017-07-11	2017-07-11 00:00:00	\N	38000177		0	0	0		0	0	0	14670	0	00025152531	44923712		
137804	3026	40213296	1997-02-02	1997-02-02 00:00:00	1997-02-02	1997-02-02 00:00:00	1997-02-02	581452		0	0	0		0	0	0	201724	0	52	40213296		
133663	2935	40213160	1976-12-15	1976-12-15 00:00:00	1976-12-15	1976-12-15 00:00:00	1976-12-15	581452		0	0	0		0	0	0	195731	0	10	40213160		
40600	3365	19133873	1973-11-01	1973-11-01 00:00:00	1973-11-14	1973-11-14 00:00:00	1973-11-14	38000177		0	0	13		0	0	0	223172	0	834061	19133873		
13348	1118	19112599	1978-09-01	1978-09-01 00:00:00	1978-09-01	1978-09-01 00:00:00	\N	38000177		0	0	0		0	0	0	73726	0	477045	19112599		
168481	3703	40213160	1973-11-03	1973-11-03 00:00:00	1973-11-03	1973-11-03 00:00:00	1973-11-03	581452		0	0	0		0	0	0	246281	0	10	40213160		
50720	4214	40229134	2005-03-09	2005-03-09 00:00:00	2005-03-16	2005-03-16 00:00:00	2005-03-16	38000177		0	0	7		0	0	0	279795	0	1043400	40229134		
218944	4805	40213306	1984-06-29	1984-06-29 00:00:00	1984-06-29	1984-06-29 00:00:00	1984-06-29	581452		0	0	0		0	0	0	319717	0	43	40213306		
160733	3537	40213260	2011-06-26	2011-06-26 00:00:00	2011-06-26	2011-06-26 00:00:00	2011-06-26	581452		0	0	0		0	0	0	234924	0	121	40213260		
61320	5101	920300	1996-01-18	1996-01-18 00:00:00	1996-01-25	1996-01-25 00:00:00	1996-01-25	38000177		0	0	7		0	0	0	338993	0	311989	920300		
61356	5104	19073183	1980-09-09	1980-09-09 00:00:00	1980-09-23	1980-09-23 00:00:00	1980-09-23	38000177		0	0	14		0	0	0	339179	0	308182	19073183		
53878	4477	19133873	1971-11-24	1971-11-24 00:00:00	1971-12-05	1971-12-05 00:00:00	1971-12-05	38000177		0	0	11		0	0	0	297963	0	834061	19133873		
129000	2836	40213306	2002-11-18	2002-11-18 00:00:00	2002-11-18	2002-11-18 00:00:00	2002-11-18	581452		0	0	0		0	0	0	188369	0	43	40213306		
62327	5189	40229134	1972-01-15	1972-01-15 00:00:00	1972-01-22	1972-01-22 00:00:00	1972-01-22	38000177		0	0	7		0	0	0	344941	0	1043400	40229134		
90811	1992	40213306	1997-12-21	1997-12-21 00:00:00	1997-12-21	1997-12-21 00:00:00	1997-12-21	581452		0	0	0		0	0	0	132741	0	43	40213306		
20459	1683	19128065	1985-07-18	1985-07-18 00:00:00	1986-07-13	1986-07-13 00:00:00	1986-07-13	38000177		0	0	360		0	0	0	112807	0	749882	19128065		
181387	3986	40213160	1966-08-05	1966-08-05 00:00:00	1966-08-05	1966-08-05 00:00:00	1966-08-05	581452		0	0	0		0	0	0	265009	0	10	40213160		
23936	520	40213227	1992-11-19	1992-11-19 00:00:00	1992-11-19	1992-11-19 00:00:00	1992-11-19	581452		0	0	0		0	0	0	34708	0	113	40213227		
149063	3278	40213160	1960-12-26	1960-12-26 00:00:00	1960-12-26	1960-12-26 00:00:00	1960-12-26	581452		0	0	0		0	0	0	217758	0	10	40213160		
31098	2578	19078461	2003-04-06	2003-04-06 00:00:00	2003-04-20	2003-04-20 00:00:00	2003-04-20	38000177		0	0	14		0	0	0	170738	0	310965	19078461		
31117	2579	1127433	2000-03-31	2000-03-31 00:00:00	2000-04-14	2000-04-14 00:00:00	2000-04-14	38000177		0	0	14		0	0	0	170773	0	313782	1127433		
19000	411	40213306	1981-12-26	1981-12-26 00:00:00	1981-12-26	1981-12-26 00:00:00	1981-12-26	581452		0	0	0		0	0	0	27330	0	43	40213306		
15697	338	40213296	2009-04-29	2009-04-29 00:00:00	2009-04-29	2009-04-29 00:00:00	2009-04-29	581452		0	0	0		0	0	0	22572	0	52	40213296		
173726	3820	40213296	2004-11-26	2004-11-26 00:00:00	2004-11-26	2004-11-26 00:00:00	2004-11-26	581452		0	0	0		0	0	0	253678	0	52	40213296		
25373	2087	40229134	2009-10-13	2009-10-13 00:00:00	2009-10-27	2009-10-27 00:00:00	2009-10-27	38000177		0	0	14		0	0	0	139033	0	1043400	40229134		
40817	3383	1127078	1989-05-31	1989-05-31 00:00:00	1989-06-14	1989-06-14 00:00:00	1989-06-14	38000177		0	0	14		0	0	0	224479	0	282464	1127078		
3652	300	1127433	2005-06-16	2005-06-16 00:00:00	2005-06-30	2005-06-30 00:00:00	2005-06-30	38000177		0	0	14		0	0	0	20072	0	313782	1127433		
241701	5306	40213160	1973-12-30	1973-12-30 00:00:00	1973-12-30	1973-12-30 00:00:00	1973-12-30	581452		0	0	0		0	0	0	352930	0	10	40213160		
18583	1536	1127433	1917-12-28	1917-12-28 00:00:00	1918-01-11	1918-01-11 00:00:00	1918-01-11	38000177		0	0	14		0	0	0	102795	0	313782	1127433		
144854	3183	40213160	1981-07-19	1981-07-19 00:00:00	1981-07-19	1981-07-19 00:00:00	1981-07-19	581452		0	0	0		0	0	0	211911	0	10	40213160		
69706	1524	40213260	2017-04-20	2017-04-20 00:00:00	2017-04-20	2017-04-20 00:00:00	2017-04-20	581452		0	0	0		0	0	0	101932	0	121	40213260		
3455	286	40229134	1928-08-05	1928-08-05 00:00:00	1928-08-19	1928-08-19 00:00:00	1928-08-19	38000177		0	0	14		0	0	0	19050	0	1043400	40229134		
51531	4282	40229134	2014-10-30	2014-10-30 00:00:00	2014-11-06	2014-11-06 00:00:00	2014-11-06	38000177		0	0	7		0	0	0	284219	0	1043400	40229134		
230559	5066	40213227	2018-04-14	2018-04-14 00:00:00	2018-04-14	2018-04-14 00:00:00	2018-04-14	581452		0	0	0		0	0	0	336802	0	113	40213227		
53284	4428	1127433	1985-05-31	1985-05-31 00:00:00	1985-06-14	1985-06-14 00:00:00	1985-06-14	38000177		0	0	14		0	0	0	294350	0	313782	1127433		
126719	2788	40213160	1978-08-27	1978-08-27 00:00:00	1978-08-27	1978-08-27 00:00:00	1978-08-27	581452		0	0	0		0	0	0	184707	0	10	40213160		
14446	312	40213227	2003-03-24	2003-03-24 00:00:00	2003-03-24	2003-03-24 00:00:00	2003-03-24	581452		0	0	0		0	0	0	20697	0	113	40213227		
59541	1303	40213314	1977-05-29	1977-05-29 00:00:00	1977-05-29	1977-05-29 00:00:00	1977-05-29	581452		0	0	0		0	0	0	86041	0	49	40213314		
229853	5051	40213306	2000-06-29	2000-06-29 00:00:00	2000-06-29	2000-06-29 00:00:00	2000-06-29	581452		0	0	0		0	0	0	335917	0	43	40213306		
80424	1759	40213160	1985-09-09	1985-09-09 00:00:00	1985-09-09	1985-09-09 00:00:00	1985-09-09	581452		0	0	0		0	0	0	117640	0	10	40213160		
204927	4498	40213296	2017-05-30	2017-05-30 00:00:00	2017-05-30	2017-05-30 00:00:00	2017-05-30	581452		0	0	0		0	0	0	299500	0	52	40213296		
17391	1441	1118084	2012-11-26	2012-11-26 00:00:00	2012-11-26	2012-11-26 00:00:00	\N	38000177		0	0	0		0	0	0	96071	0	00025152531	44923712		
61073	5079	40229134	1970-12-22	1970-12-22 00:00:00	1970-12-29	1970-12-29 00:00:00	1970-12-29	38000177		0	0	7		0	0	0	337673	0	1043400	40229134		
57833	4805	19075601	2017-10-27	2017-10-27 00:00:00	2017-10-27	2017-10-27 00:00:00	\N	38000177		0	0	0		0	0	0	319730	0	309362	19075601		
212313	4655	40213160	1959-05-24	1959-05-24 00:00:00	1959-05-24	1959-05-24 00:00:00	1959-05-24	581452		0	0	0		0	0	0	310404	0	10	40213160		
211295	4633	40213160	1963-08-27	1963-08-27 00:00:00	1963-08-27	1963-08-27 00:00:00	1963-08-27	581452		0	0	0		0	0	0	308784	0	10	40213160		
70323	1538	40213227	2012-05-28	2012-05-28 00:00:00	2012-05-28	2012-05-28 00:00:00	2012-05-28	581452		0	0	0		0	0	0	103085	0	113	40213227		
56503	4689	1115171	1994-08-07	1994-08-07 00:00:00	1994-08-28	1994-08-28 00:00:00	1994-08-28	38000177		0	0	21		0	0	0	312393	0	849574	1115171		
121158	2662	40213160	1978-08-04	1978-08-04 00:00:00	1978-08-04	1978-08-04 00:00:00	1978-08-04	581452		0	0	0		0	0	0	176411	0	10	40213160		
213559	4682	40213160	1980-02-24	1980-02-24 00:00:00	1980-02-24	1980-02-24 00:00:00	1980-02-24	581452		0	0	0		0	0	0	312027	0	10	40213160		
10425	869	1127433	1992-04-11	1992-04-11 00:00:00	1992-04-18	1992-04-18 00:00:00	1992-04-18	38000177		0	0	7		0	0	0	57793	0	313782	1127433		
546	12	40213227	2005-11-16	2005-11-16 00:00:00	2005-11-16	2005-11-16 00:00:00	2005-11-16	581452		0	0	0		0	0	0	1049	0	113	40213227		
217118	4763	40213227	1992-09-01	1992-09-01 00:00:00	1992-09-01	1992-09-01 00:00:00	1992-09-01	581452		0	0	0		0	0	0	317437	0	113	40213227		
119927	2636	40213296	2000-04-21	2000-04-21 00:00:00	2000-04-21	2000-04-21 00:00:00	2000-04-21	581452		0	0	0		0	0	0	174451	0	52	40213296		
126370	2780	40213160	1956-06-27	1956-06-27 00:00:00	1956-06-27	1956-06-27 00:00:00	1956-06-27	581452		0	0	0		0	0	0	184225	0	10	40213160		
101885	2233	40213227	2013-06-11	2013-06-11 00:00:00	2013-06-11	2013-06-11 00:00:00	2013-06-11	581452		0	0	0		0	0	0	148555	0	113	40213227		
34852	760	40213160	1965-05-05	1965-05-05 00:00:00	1965-05-05	1965-05-05 00:00:00	1965-05-05	581452		0	0	0		0	0	0	50511	0	10	40213160		
2704	217	1127433	1997-09-04	1997-09-04 00:00:00	1997-09-11	1997-09-11 00:00:00	1997-09-11	38000177		0	0	7		0	0	0	14649	0	313782	1127433		
137824	3026	40213160	1959-12-06	1959-12-06 00:00:00	1959-12-06	1959-12-06 00:00:00	1959-12-06	581452		0	0	0		0	0	0	201785	0	10	40213160		
133669	2935	40213227	2018-02-28	2018-02-28 00:00:00	2018-02-28	2018-02-28 00:00:00	2018-02-28	581452		0	0	0		0	0	0	195716	0	113	40213227		
40601	3365	40229134	2012-08-14	2012-08-14 00:00:00	2012-08-21	2012-08-21 00:00:00	2012-08-21	38000177		0	0	7		0	0	0	223174	0	1043400	40229134		
13349	1118	19128065	1991-07-19	1991-07-19 00:00:00	1992-07-13	1992-07-13 00:00:00	1992-07-13	38000177		0	0	360		0	0	0	73753	0	749882	19128065		
168483	3703	40213160	1969-08-02	1969-08-02 00:00:00	1969-08-02	1969-08-02 00:00:00	1969-08-02	581452		0	0	0		0	0	0	246299	0	10	40213160		
153717	3383	40213160	1986-12-25	1986-12-25 00:00:00	1986-12-25	1986-12-25 00:00:00	1986-12-25	581452		0	0	0		0	0	0	224489	0	10	40213160		
218953	4805	40213160	1962-08-03	1962-08-03 00:00:00	1962-08-03	1962-08-03 00:00:00	1962-08-03	581452		0	0	0		0	0	0	319673	0	10	40213160		
160736	3537	40213227	2012-07-01	2012-07-01 00:00:00	2012-07-01	2012-07-01 00:00:00	2012-07-01	581452		0	0	0		0	0	0	234978	0	113	40213227		
61321	5101	40236824	1996-01-18	1996-01-18 00:00:00	1996-01-25	1996-01-25 00:00:00	1996-01-25	38000177		0	0	7		0	0	0	338993	0	1094107	40236824		
61357	5104	19019979	1980-09-09	1980-09-09 00:00:00	1980-09-23	1980-09-23 00:00:00	1980-09-23	38000177		0	0	14		0	0	0	339179	0	198405	19019979		
53880	4477	1127433	2012-06-25	2012-06-25 00:00:00	2012-08-31	2012-08-31 00:00:00	2012-08-31	38000177		0	0	67		0	0	0	297915	0	313782	1127433		
129009	2837	40213160	1967-01-11	1967-01-11 00:00:00	1967-01-11	1967-01-11 00:00:00	1967-01-11	581452		0	0	0		0	0	0	188479	0	10	40213160		
62328	5189	40220960	2007-09-09	2007-09-09 00:00:00	2007-09-09	2007-09-09 00:00:00	2007-09-09	38000177		0	0	0		0	0	0	344938	0	1804799	40220960		
90817	1992	40213160	1975-11-30	1975-11-30 00:00:00	1975-11-30	1975-11-30 00:00:00	1975-11-30	581452		0	0	0		0	0	0	132648	0	10	40213160		
20460	1683	19128022	1990-06-22	1990-06-22 00:00:00	1991-06-17	1991-06-17 00:00:00	1991-06-17	38000177		0	0	360		0	0	0	112819	0	749785	19128022		
181393	3986	40213227	2003-07-11	2003-07-11 00:00:00	2003-07-11	2003-07-11 00:00:00	2003-07-11	581452		0	0	0		0	0	0	264974	0	113	40213227		
23940	520	40213227	2001-11-15	2001-11-15 00:00:00	2001-11-15	2001-11-15 00:00:00	2001-11-15	581452		0	0	0		0	0	0	34740	0	113	40213227		
149068	3278	40213160	1960-07-25	1960-07-25 00:00:00	1960-07-25	1960-07-25 00:00:00	1960-07-25	581452		0	0	0		0	0	0	217781	0	10	40213160		
31099	2578	19075001	2003-04-06	2003-04-06 00:00:00	2003-04-20	2003-04-20 00:00:00	2003-04-20	38000177		0	0	14		0	0	0	170738	0	309097	19075001		
31118	2579	19133873	1956-05-01	1956-05-01 00:00:00	1956-05-14	1956-05-14 00:00:00	1956-05-14	38000177		0	0	13		0	0	0	170769	0	834061	19133873		
37185	812	40213306	1985-09-14	1985-09-14 00:00:00	1985-09-14	1985-09-14 00:00:00	1985-09-14	581452		0	0	0		0	0	0	53894	0	43	40213306		
15699	338	40213160	1967-09-27	1967-09-27 00:00:00	1967-09-27	1967-09-27 00:00:00	1967-09-27	581452		0	0	0		0	0	0	22503	0	10	40213160		
173734	3820	40213227	2006-12-01	2006-12-01 00:00:00	2006-12-01	2006-12-01 00:00:00	2006-12-01	581452		0	0	0		0	0	0	253640	0	113	40213227		
25374	2087	1118084	1956-04-18	1956-04-18 00:00:00	1956-04-18	1956-04-18 00:00:00	\N	38000177		0	0	0		0	0	0	139068	0	00025152531	44923712		
40818	3383	42902245	2004-03-23	2004-03-23 00:00:00	2005-03-18	2005-03-18 00:00:00	2005-03-18	38000177		0	0	360		0	0	0	224525	0	1359133	42902245		
14112	1180	1127433	1983-04-09	1983-04-09 00:00:00	1983-04-16	1983-04-16 00:00:00	1983-04-16	38000177		0	0	7		0	0	0	77904	0	313782	1127433		
241705	5306	40213260	2019-01-20	2019-01-20 00:00:00	2019-01-20	2019-01-20 00:00:00	2019-01-20	581452		0	0	0		0	0	0	352936	0	121	40213260		
18584	1536	1713671	1913-01-27	1913-01-27 00:00:00	1913-02-03	1913-02-03 00:00:00	1913-02-03	38000177		0	0	7		0	0	0	102791	0	562251	1713671		
144856	3183	40213227	2013-12-15	2013-12-15 00:00:00	2013-12-15	2013-12-15 00:00:00	2013-12-15	581452		0	0	0		0	0	0	211927	0	113	40213227		
69711	1524	40213306	1988-03-03	1988-03-03 00:00:00	1988-03-03	1988-03-03 00:00:00	1988-03-03	581452		0	0	0		0	0	0	101905	0	43	40213306		
3456	286	1124300	1970-08-08	1970-08-08 00:00:00	1970-08-08	1970-08-08 00:00:00	\N	38000177		0	0	0		0	0	0	19115	0	00781178901	45011828		
51532	4283	1118084	1990-12-15	1990-12-15 00:00:00	1990-12-15	1990-12-15 00:00:00	\N	38000177		0	0	0		0	0	0	284270	0	00025152531	44923712		
230560	5066	40213260	2018-04-14	2018-04-14 00:00:00	2018-04-14	2018-04-14 00:00:00	2018-04-14	581452		0	0	0		0	0	0	336802	0	121	40213260		
53285	4428	40229134	1983-08-31	1983-08-31 00:00:00	1983-09-07	1983-09-07 00:00:00	1983-09-07	38000177		0	0	7		0	0	0	294349	0	1043400	40229134		
126720	2788	40213314	1978-08-27	1978-08-27 00:00:00	1978-08-27	1978-08-27 00:00:00	1978-08-27	581452		0	0	0		0	0	0	184707	0	49	40213314		
14448	312	40213160	1972-10-02	1972-10-02 00:00:00	1972-10-02	1972-10-02 00:00:00	1972-10-02	581452		0	0	0		0	0	0	20664	0	10	40213160		
59543	1303	40213314	1977-01-30	1977-01-30 00:00:00	1977-01-30	1977-01-30 00:00:00	1977-01-30	581452		0	0	0		0	0	0	86040	0	49	40213314		
229855	5051	40213227	2000-06-29	2000-06-29 00:00:00	2000-06-29	2000-06-29 00:00:00	2000-06-29	581452		0	0	0		0	0	0	335917	0	113	40213227		
80428	1759	40213160	1985-04-08	1985-04-08 00:00:00	1985-04-08	1985-04-08 00:00:00	1985-04-08	581452		0	0	0		0	0	0	117587	0	10	40213160		
200665	4406	40213227	2013-03-23	2013-03-23 00:00:00	2013-03-23	2013-03-23 00:00:00	2013-03-23	581452		0	0	0		0	0	0	292880	0	113	40213227		
17392	1441	19008572	1978-02-09	1978-02-09 00:00:00	1978-02-23	1978-02-23 00:00:00	1978-02-23	38000177		0	0	14		0	0	0	95979	0	106258	19008572		
61074	5079	1127433	1981-08-24	1981-08-24 00:00:00	1981-09-14	1981-09-14 00:00:00	1981-09-14	38000177		0	0	21		0	0	0	337688	0	313782	1127433		
57834	4805	1539411	2017-10-27	2017-10-27 00:00:00	2017-10-27	2017-10-27 00:00:00	\N	38000177		0	0	0		0	0	0	319730	0	312961	1539411		
212323	4655	40213160	1963-11-24	1963-11-24 00:00:00	1963-11-24	1963-11-24 00:00:00	1963-11-24	581452		0	0	0		0	0	0	310407	0	10	40213160		
211298	4633	40213160	1959-08-04	1959-08-04 00:00:00	1959-08-04	1959-08-04 00:00:00	1959-08-04	581452		0	0	0		0	0	0	308806	0	10	40213160		
56504	4689	19128065	1986-04-09	1986-04-09 00:00:00	1987-04-04	1987-04-04 00:00:00	1987-04-04	38000177		0	0	360		0	0	0	312383	0	749882	19128065		
121159	2662	40213314	1978-08-04	1978-08-04 00:00:00	1978-08-04	1978-08-04 00:00:00	1978-08-04	581452		0	0	0		0	0	0	176411	0	49	40213314		
10426	869	19078461	1975-09-05	1975-09-05 00:00:00	1975-09-26	1975-09-26 00:00:00	1975-09-26	38000177		0	0	21		0	0	0	57726	0	310965	19078461		
553	12	40213160	1968-01-10	1968-01-10 00:00:00	1968-01-10	1968-01-10 00:00:00	1968-01-10	581452		0	0	0		0	0	0	1009	0	10	40213160		
217123	4763	40213201	2017-06-20	2017-06-20 00:00:00	2017-06-20	2017-06-20 00:00:00	2017-06-20	581452		0	0	0		0	0	0	317442	0	33	40213201		
126299	2778	40213227	1998-12-26	1998-12-26 00:00:00	1998-12-26	1998-12-26 00:00:00	1998-12-26	581452		0	0	0		0	0	0	184083	0	113	40213227		
137660	3022	40213296	2016-03-04	2016-03-04 00:00:00	2016-03-04	2016-03-04 00:00:00	2016-03-04	581452		0	0	0		0	0	0	201465	0	52	40213296		
101886	2233	40213296	2013-06-11	2013-06-11 00:00:00	2013-06-11	2013-06-11 00:00:00	2013-06-11	581452		0	0	0		0	0	0	148555	0	52	40213296		
34854	760	40213227	2006-12-06	2006-12-06 00:00:00	2006-12-06	2006-12-06 00:00:00	2006-12-06	581452		0	0	0		0	0	0	50483	0	113	40213227		
2705	217	40229134	1981-05-08	1981-05-08 00:00:00	1981-05-22	1981-05-22 00:00:00	1981-05-22	38000177		0	0	14		0	0	0	14637	0	1043400	40229134		
137825	3026	40213160	1955-04-03	1955-04-03 00:00:00	1955-04-03	1955-04-03 00:00:00	1955-04-03	581452		0	0	0		0	0	0	201744	0	10	40213160		
133670	2935	40213296	2018-02-28	2018-02-28 00:00:00	2018-02-28	2018-02-28 00:00:00	2018-02-28	581452		0	0	0		0	0	0	195716	0	52	40213296		
40602	3365	1115171	2017-02-14	2017-02-14 00:00:00	2017-03-07	2017-03-07 00:00:00	2017-03-07	38000177		0	0	21		0	0	0	223179	0	849574	1115171		
13350	1118	19128022	1997-06-17	1997-06-17 00:00:00	1998-06-12	1998-06-12 00:00:00	1998-06-12	38000177		0	0	360		0	0	0	73709	0	749785	19128022		
160206	3526	40213227	2001-05-08	2001-05-08 00:00:00	2001-05-08	2001-05-08 00:00:00	2001-05-08	581452		0	0	0		0	0	0	233959	0	113	40213227		
49716	1088	40213296	2012-08-05	2012-08-05 00:00:00	2012-08-05	2012-08-05 00:00:00	2012-08-05	581452		0	0	0		0	0	0	71415	0	52	40213296		
218955	4805	40213160	1962-10-05	1962-10-05 00:00:00	1962-10-05	1962-10-05 00:00:00	1962-10-05	581452		0	0	0		0	0	0	319688	0	10	40213160		
160741	3537	40213306	1983-09-18	1983-09-18 00:00:00	1983-09-18	1983-09-18 00:00:00	1983-09-18	581452		0	0	0		0	0	0	234917	0	43	40213306		
61322	5101	19128065	1974-12-05	1974-12-05 00:00:00	1975-11-30	1975-11-30 00:00:00	1975-11-30	38000177		0	0	360		0	0	0	338996	0	749882	19128065		
61358	5104	1713671	2011-11-29	2011-11-29 00:00:00	2011-12-20	2011-12-20 00:00:00	2011-12-20	38000177		0	0	21		0	0	0	339177	0	562251	1713671		
53549	4451	40229134	1974-12-27	1974-12-27 00:00:00	1975-01-03	1975-01-03 00:00:00	1975-01-03	38000177		0	0	7		0	0	0	296098	0	1043400	40229134		
129018	2837	40213260	2016-08-03	2016-08-03 00:00:00	2016-08-03	2016-08-03 00:00:00	2016-08-03	581452		0	0	0		0	0	0	188434	0	121	40213260		
62329	5189	19075601	2007-09-09	2007-09-09 00:00:00	2007-09-09	2007-09-09 00:00:00	2007-09-09	38000177		0	0	0		0	0	0	344938	0	309362	19075601		
194595	4276	40213198	2018-03-22	2018-03-22 00:00:00	2018-03-22	2018-03-22 00:00:00	2018-03-22	581452		0	0	0		0	0	0	283785	0	133	40213198		
5227	114	40213160	1972-06-19	1972-06-19 00:00:00	1972-06-19	1972-06-19 00:00:00	1972-06-19	581452		0	0	0		0	0	0	7520	0	10	40213160		
181394	3986	40213296	2003-07-11	2003-07-11 00:00:00	2003-07-11	2003-07-11 00:00:00	2003-07-11	581452		0	0	0		0	0	0	264974	0	52	40213296		
23955	520	40213201	2017-02-09	2017-02-09 00:00:00	2017-02-09	2017-02-09 00:00:00	2017-02-09	581452		0	0	0		0	0	0	34722	0	33	40213201		
149071	3278	40213260	2010-04-19	2010-04-19 00:00:00	2010-04-19	2010-04-19 00:00:00	2010-04-19	581452		0	0	0		0	0	0	217778	0	121	40213260		
31101	2578	1127433	1971-12-21	1971-12-21 00:00:00	1971-12-28	1971-12-28 00:00:00	1971-12-28	38000177		0	0	7		0	0	0	170751	0	313782	1127433		
31119	2579	1118084	1992-04-30	1992-04-30 00:00:00	1992-04-30	1992-04-30 00:00:00	\N	38000177		0	0	0		0	0	0	170842	0	00025152531	44923712		
37187	812	40213160	1963-10-19	1963-10-19 00:00:00	1963-10-19	1963-10-19 00:00:00	1963-10-19	581452		0	0	0		0	0	0	53857	0	10	40213160		
15707	338	40213227	2018-04-25	2018-04-25 00:00:00	2018-04-25	2018-04-25 00:00:00	2018-04-25	581452		0	0	0		0	0	0	22481	0	113	40213227		
173735	3820	40213296	2006-12-01	2006-12-01 00:00:00	2006-12-01	2006-12-01 00:00:00	2006-12-01	581452		0	0	0		0	0	0	253640	0	52	40213296		
25375	2087	1127433	2009-08-06	2009-08-06 00:00:00	2009-08-13	2009-08-13 00:00:00	2009-08-13	38000177		0	0	7		0	0	0	139011	0	313782	1127433		
40831	3386	40236446	1976-11-29	1976-11-29 00:00:00	1986-12-07	1986-12-07 00:00:00	1986-12-07	38000177		0	0	3660		0	0	0	224644	0	1091392	40236446		
14113	1180	1127078	1956-09-08	1956-09-08 00:00:00	1956-09-22	1956-09-22 00:00:00	1956-09-22	38000177		0	0	14		0	0	0	77901	0	282464	1127078		
241708	5306	40213227	2011-01-30	2011-01-30 00:00:00	2011-01-30	2011-01-30 00:00:00	2011-01-30	581452		0	0	0		0	0	0	352984	0	113	40213227		
18585	1536	19059056	1912-08-25	1912-08-25 00:00:00	1912-09-08	1912-09-08 00:00:00	1912-09-08	38000177		0	0	14		0	0	0	102799	0	243670	19059056		
144865	3184	40213160	1966-02-10	1966-02-10 00:00:00	1966-02-10	1966-02-10 00:00:00	1966-02-10	581452		0	0	0		0	0	0	212013	0	10	40213160		
69713	1524	40213227	2008-03-27	2008-03-27 00:00:00	2008-03-27	2008-03-27 00:00:00	2008-03-27	581452		0	0	0		0	0	0	101902	0	113	40213227		
3457	286	19059056	1929-01-30	1929-01-30 00:00:00	1929-02-13	1929-02-13 00:00:00	1929-02-13	38000177		0	0	14		0	0	0	19141	0	243670	19059056		
51533	4283	1127433	1964-11-03	1964-11-03 00:00:00	1964-11-17	1964-11-17 00:00:00	1964-11-17	38000177		0	0	14		0	0	0	284307	0	313782	1127433		
230561	5067	40213160	1974-09-08	1974-09-08 00:00:00	1974-09-08	1974-09-08 00:00:00	1974-09-08	581452		0	0	0		0	0	0	336883	0	10	40213160		
53286	4428	1118084	1991-05-04	1991-05-04 00:00:00	1991-05-04	1991-05-04 00:00:00	\N	38000177		0	0	0		0	0	0	294359	0	00025152531	44923712		
126722	2788	40213160	1978-11-26	1978-11-26 00:00:00	1978-11-26	1978-11-26 00:00:00	1978-11-26	581452		0	0	0		0	0	0	184739	0	10	40213160		
62583	1368	40213160	1956-11-28	1956-11-28 00:00:00	1956-11-28	1956-11-28 00:00:00	1956-11-28	581452		0	0	0		0	0	0	90668	0	10	40213160		
59545	1303	40213160	1977-01-30	1977-01-30 00:00:00	1977-01-30	1977-01-30 00:00:00	1977-01-30	581452		0	0	0		0	0	0	86040	0	10	40213160		
229856	5051	40213160	1978-05-04	1978-05-04 00:00:00	1978-05-04	1978-05-04 00:00:00	1978-05-04	581452		0	0	0		0	0	0	335911	0	10	40213160		
80429	1759	40213314	1985-04-08	1985-04-08 00:00:00	1985-04-08	1985-04-08 00:00:00	1985-04-08	581452		0	0	0		0	0	0	117587	0	49	40213314		
172205	3786	40213296	2002-04-02	2002-04-02 00:00:00	2002-04-02	2002-04-02 00:00:00	2002-04-02	581452		0	0	0		0	0	0	251728	0	52	40213296		
17393	1441	1310034	1985-11-11	1985-11-11 00:00:00	1985-11-11	1985-11-11 00:00:00	1985-11-11	38000177		0	0	0		0	0	0	95949	0	834357	1310034		
61075	5079	19129655	1969-08-27	1969-08-27 00:00:00	1969-09-10	1969-09-10 00:00:00	1969-09-10	38000177		0	0	14		0	0	0	337675	0	789980	19129655		
57835	4805	1332419	2017-10-27	2017-10-27 00:00:00	2017-10-27	2017-10-27 00:00:00	\N	38000177		0	0	0		0	0	0	319730	0	197361	1332419		
212325	4655	40213260	2009-07-19	2009-07-19 00:00:00	2009-07-19	2009-07-19 00:00:00	2009-07-19	581452		0	0	0		0	0	0	310284	0	121	40213260		
211299	4633	40213306	1981-09-08	1981-09-08 00:00:00	1981-09-08	1981-09-08 00:00:00	1981-09-08	581452		0	0	0		0	0	0	308811	0	43	40213306		
56505	4689	1127433	2005-12-27	2005-12-27 00:00:00	2006-01-17	2006-01-17 00:00:00	2006-01-17	38000177		0	0	21		0	0	0	312394	0	313782	1127433		
121165	2662	40213251	1984-04-12	1984-04-12 00:00:00	1984-04-12	1984-04-12 00:00:00	1984-04-12	581452		0	0	0		0	0	0	176414	0	21	40213251		
10427	869	40220960	2012-04-20	2012-04-20 00:00:00	2012-04-20	2012-04-20 00:00:00	2012-04-20	38000177		0	0	0		0	0	0	57727	0	1804799	40220960		
558	12	40213227	2014-02-05	2014-02-05 00:00:00	2014-02-05	2014-02-05 00:00:00	2014-02-05	581452		0	0	0		0	0	0	1000	0	113	40213227		
228411	5017	40213160	1980-04-19	1980-04-19 00:00:00	1980-04-19	1980-04-19 00:00:00	1980-04-19	581452		0	0	0		0	0	0	333450	0	10	40213160		
126300	2778	40213306	1998-12-26	1998-12-26 00:00:00	1998-12-26	1998-12-26 00:00:00	1998-12-26	581452		0	0	0		0	0	0	184083	0	43	40213306		
137662	3022	40213227	1994-06-24	1994-06-24 00:00:00	1994-06-24	1994-06-24 00:00:00	1994-06-24	581452		0	0	0		0	0	0	201462	0	113	40213227		
34766	759	40213227	2016-05-04	2016-05-04 00:00:00	2016-05-04	2016-05-04 00:00:00	2016-05-04	581452		0	0	0		0	0	0	50371	0	113	40213227		
34855	760	40213296	2006-12-06	2006-12-06 00:00:00	2006-12-06	2006-12-06 00:00:00	2006-12-06	581452		0	0	0		0	0	0	50483	0	52	40213296		
2706	217	19059056	1979-08-15	1979-08-15 00:00:00	1979-08-29	1979-08-29 00:00:00	1979-08-29	38000177		0	0	14		0	0	0	14686	0	243670	19059056		
137827	3026	40213227	2016-03-27	2016-03-27 00:00:00	2016-03-27	2016-03-27 00:00:00	2016-03-27	581452		0	0	0		0	0	0	201755	0	113	40213227		
133672	2935	40213314	1977-03-16	1977-03-16 00:00:00	1977-03-16	1977-03-16 00:00:00	1977-03-16	581452		0	0	0		0	0	0	195719	0	49	40213314		
40603	3365	1115171	2005-08-11	2005-08-11 00:00:00	2005-08-25	2005-08-25 00:00:00	2005-08-25	38000177		0	0	14		0	0	0	223157	0	849574	1115171		
96516	2116	40213201	2016-02-08	2016-02-08 00:00:00	2016-02-08	2016-02-08 00:00:00	2016-02-08	581452		0	0	0		0	0	0	140838	0	33	40213201		
160222	3526	40213201	2016-01-19	2016-01-19 00:00:00	2016-01-19	2016-01-19 00:00:00	2016-01-19	581452		0	0	0		0	0	0	233964	0	33	40213201		
49726	1088	40213227	1994-11-27	1994-11-27 00:00:00	1994-11-27	1994-11-27 00:00:00	1994-11-27	581452		0	0	0		0	0	0	71445	0	113	40213227		
218959	4805	40213227	2003-09-05	2003-09-05 00:00:00	2003-09-05	2003-09-05 00:00:00	2003-09-05	581452		0	0	0		0	0	0	319724	0	113	40213227		
220260	4834	40213306	1982-07-18	1982-07-18 00:00:00	1982-07-18	1982-07-18 00:00:00	1982-07-18	581452		0	0	0		0	0	0	321583	0	43	40213306		
165133	3630	40213227	2016-09-28	2016-09-28 00:00:00	2016-09-28	2016-09-28 00:00:00	2016-09-28	581452		0	0	0		0	0	0	241537	0	113	40213227		
61359	5104	19074843	1980-06-29	1980-06-29 00:00:00	1980-07-13	1980-07-13 00:00:00	1980-07-13	38000177		0	0	14		0	0	0	339216	0	309045	19074843		
53550	4451	1713671	1963-02-11	1963-02-11 00:00:00	1963-03-04	1963-03-04 00:00:00	1963-03-04	38000177		0	0	21		0	0	0	296200	0	562251	1713671		
129021	2837	40213296	2006-10-18	2006-10-18 00:00:00	2006-10-18	2006-10-18 00:00:00	2006-10-18	581452		0	0	0		0	0	0	188471	0	52	40213296		
62330	5189	1713671	1957-01-16	1957-01-16 00:00:00	1957-02-06	1957-02-06 00:00:00	1957-02-06	38000177		0	0	21		0	0	0	344915	0	562251	1713671		
194597	4276	40213160	1955-06-02	1955-06-02 00:00:00	1955-06-02	1955-06-02 00:00:00	1955-06-02	581452		0	0	0		0	0	0	283765	0	10	40213160		
67777	1482	40213160	1975-06-28	1975-06-28 00:00:00	1975-06-28	1975-06-28 00:00:00	1975-06-28	581452		0	0	0		0	0	0	98903	0	10	40213160		
181396	3986	40213227	1995-06-30	1995-06-30 00:00:00	1995-06-30	1995-06-30 00:00:00	1995-06-30	581452		0	0	0		0	0	0	264998	0	113	40213227		
23960	520	40213160	1955-10-20	1955-10-20 00:00:00	1955-10-20	1955-10-20 00:00:00	1955-10-20	581452		0	0	0		0	0	0	34680	0	10	40213160		
149077	3279	40213160	1955-03-08	1955-03-08 00:00:00	1955-03-08	1955-03-08 00:00:00	1955-03-08	581452		0	0	0		0	0	0	217926	0	10	40213160		
31102	2578	1115171	2015-06-16	2015-06-16 00:00:00	2015-07-14	2015-07-14 00:00:00	2015-07-14	38000177		0	0	28		0	0	0	170764	0	849574	1115171		
31120	2579	40229134	1961-05-05	1961-05-05 00:00:00	1961-05-12	1961-05-12 00:00:00	1961-05-12	38000177		0	0	7		0	0	0	170807	0	1043400	40229134		
37189	812	40213227	2014-08-09	2014-08-09 00:00:00	2014-08-09	2014-08-09 00:00:00	2014-08-09	581452		0	0	0		0	0	0	53845	0	113	40213227		
15708	338	40213260	2018-04-25	2018-04-25 00:00:00	2018-04-25	2018-04-25 00:00:00	2018-04-25	581452		0	0	0		0	0	0	22481	0	121	40213260		
173743	3820	40213160	1965-02-26	1965-02-26 00:00:00	1965-02-26	1965-02-26 00:00:00	1965-02-26	581452		0	0	0		0	0	0	253607	0	10	40213160		
25376	2087	40229134	1941-06-07	1941-06-07 00:00:00	1941-06-21	1941-06-21 00:00:00	1941-06-21	38000177		0	0	14		0	0	0	139133	0	1043400	40229134		
40832	3386	19078461	1984-12-31	1984-12-31 00:00:00	1985-03-01	1985-03-01 00:00:00	1985-03-01	38000177		0	0	60		0	0	0	224629	0	310965	19078461		
14114	1180	19006318	1956-09-08	1956-09-08 00:00:00	1956-09-22	1956-09-22 00:00:00	1956-09-22	38000177		0	0	14		0	0	0	77901	0	105078	19006318		
241709	5306	40213296	2011-01-30	2011-01-30 00:00:00	2011-01-30	2011-01-30 00:00:00	2011-01-30	581452		0	0	0		0	0	0	352984	0	52	40213296		
18586	1536	19133873	1915-04-14	1915-04-14 00:00:00	1915-04-22	1915-04-22 00:00:00	1915-04-22	38000177		0	0	8		0	0	0	102792	0	834061	19133873		
144866	3184	40213306	1983-05-05	1983-05-05 00:00:00	1983-05-05	1983-05-05 00:00:00	1983-05-05	581452		0	0	0		0	0	0	211986	0	43	40213306		
69714	1524	40213296	2008-03-27	2008-03-27 00:00:00	2008-03-27	2008-03-27 00:00:00	2008-03-27	581452		0	0	0		0	0	0	101902	0	52	40213296		
3458	286	19078461	2019-05-23	2019-05-23 00:00:00	2019-06-13	2019-06-13 00:00:00	2019-06-13	38000177		0	0	21		0	0	0	19048	0	310965	19078461		
51534	4283	1127433	1967-03-09	1967-03-09 00:00:00	1967-03-16	1967-03-16 00:00:00	1967-03-16	38000177		0	0	7		0	0	0	284262	0	313782	1127433		
230564	5067	40213227	2005-09-18	2005-09-18 00:00:00	2005-09-18	2005-09-18 00:00:00	2005-09-18	581452		0	0	0		0	0	0	336824	0	113	40213227		
63746	5298	19078461	2003-11-27	2003-11-27 00:00:00	2003-12-11	2003-12-11 00:00:00	2003-12-11	38000177		0	0	14		0	0	0	352439	0	310965	19078461		
117205	2576	40213160	1980-07-17	1980-07-17 00:00:00	1980-07-17	1980-07-17 00:00:00	1980-07-17	581452		0	0	0		0	0	0	170534	0	10	40213160		
62585	1368	40213227	2007-03-28	2007-03-28 00:00:00	2007-03-28	2007-03-28 00:00:00	2007-03-28	581452		0	0	0		0	0	0	90694	0	113	40213227		
59552	1303	40213296	2016-05-29	2016-05-29 00:00:00	2016-05-29	2016-05-29 00:00:00	2016-05-29	581452		0	0	0		0	0	0	86025	0	52	40213296		
229857	5051	40213314	1978-05-04	1978-05-04 00:00:00	1978-05-04	1978-05-04 00:00:00	1978-05-04	581452		0	0	0		0	0	0	335911	0	49	40213314		
80430	1759	40213251	1989-12-11	1989-12-11 00:00:00	1989-12-11	1989-12-11 00:00:00	1989-12-11	581452		0	0	0		0	0	0	117630	0	21	40213251		
172209	3786	40213306	1981-04-21	1981-04-21 00:00:00	1981-04-21	1981-04-21 00:00:00	1981-04-21	581452		0	0	0		0	0	0	\N	0	43	40213306		
17394	1441	40243436	1985-11-11	1985-11-11 00:00:00	1985-11-11	1985-11-11 00:00:00	1985-11-11	38000177		0	0	0		0	0	0	95949	0	1190795	40243436		
61076	5079	19006318	1970-12-11	1970-12-11 00:00:00	1970-12-25	1970-12-25 00:00:00	1970-12-25	38000177		0	0	14		0	0	0	337679	0	105078	19006318		
57836	4805	1713671	1981-03-20	1981-03-20 00:00:00	1981-04-10	1981-04-10 00:00:00	1981-04-10	38000177		0	0	21		0	0	0	319685	0	562251	1713671		
212329	4655	40213306	1981-02-15	1981-02-15 00:00:00	1981-02-15	1981-02-15 00:00:00	1981-02-15	581452		0	0	0		0	0	0	310376	0	43	40213306		
182490	4009	40213227	1992-01-28	1992-01-28 00:00:00	1992-01-28	1992-01-28 00:00:00	1992-01-28	581452		0	0	0		0	0	0	266436	0	113	40213227		
56506	4689	1127078	1969-04-29	1969-04-29 00:00:00	1969-05-13	1969-05-13 00:00:00	1969-05-13	38000177		0	0	14		0	0	0	312416	0	282464	1127078		
121175	2663	40213260	2013-09-01	2013-09-01 00:00:00	2013-09-01	2013-09-01 00:00:00	2013-09-01	581452		0	0	0		0	0	0	176490	0	121	40213260		
10428	869	19075601	2012-04-20	2012-04-20 00:00:00	2012-04-20	2012-04-20 00:00:00	2012-04-20	38000177		0	0	0		0	0	0	57727	0	309362	19075601		
559	12	40213260	2014-02-05	2014-02-05 00:00:00	2014-02-05	2014-02-05 00:00:00	2014-02-05	581452		0	0	0		0	0	0	1000	0	121	40213260		
228412	5017	40213314	1980-04-19	1980-04-19 00:00:00	1980-04-19	1980-04-19 00:00:00	1980-04-19	581452		0	0	0		0	0	0	333450	0	49	40213314		
126306	2778	40213296	2017-09-16	2017-09-16 00:00:00	2017-09-16	2017-09-16 00:00:00	2017-09-16	581452		0	0	0		0	0	0	184061	0	52	40213296		
137663	3022	40213306	1994-06-24	1994-06-24 00:00:00	1994-06-24	1994-06-24 00:00:00	1994-06-24	581452		0	0	0		0	0	0	201462	0	43	40213306		
34767	759	40213198	2010-03-31	2010-03-31 00:00:00	2010-03-31	2010-03-31 00:00:00	2010-03-31	581452		0	0	0		0	0	0	50408	0	133	40213198		
63271	1384	40213227	2013-10-15	2013-10-15 00:00:00	2013-10-15	2013-10-15 00:00:00	2013-10-15	581452		0	0	0		0	0	0	91770	0	113	40213227		
2707	217	19073183	1979-08-15	1979-08-15 00:00:00	1979-08-29	1979-08-29 00:00:00	1979-08-29	38000177		0	0	14		0	0	0	14686	0	308182	19073183		
137828	3026	40213160	1955-06-05	1955-06-05 00:00:00	1955-06-05	1955-06-05 00:00:00	1955-06-05	581452		0	0	0		0	0	0	201772	0	10	40213160		
133675	2935	40213160	1976-07-14	1976-07-14 00:00:00	1976-07-14	1976-07-14 00:00:00	1976-07-14	581452		0	0	0		0	0	0	195730	0	10	40213160		
40604	3365	1118084	2006-01-23	2006-01-23 00:00:00	2006-01-23	2006-01-23 00:00:00	\N	38000177		0	0	0		0	0	0	223157	0	00025152531	44923712		
96519	2116	40213227	2011-01-10	2011-01-10 00:00:00	2011-01-10	2011-01-10 00:00:00	2011-01-10	581452		0	0	0		0	0	0	140835	0	113	40213227		
160223	3526	40213160	1955-12-13	1955-12-13 00:00:00	1955-12-13	1955-12-13 00:00:00	1955-12-13	581452		0	0	0		0	0	0	233934	0	10	40213160		
49727	1088	40213306	1994-11-27	1994-11-27 00:00:00	1994-11-27	1994-11-27 00:00:00	1994-11-27	581452		0	0	0		0	0	0	71445	0	43	40213306		
218960	4805	40213296	2003-09-05	2003-09-05 00:00:00	2003-09-05	2003-09-05 00:00:00	2003-09-05	581452		0	0	0		0	0	0	319724	0	52	40213296		
220271	4834	40213227	1994-07-31	1994-07-31 00:00:00	1994-07-31	1994-07-31 00:00:00	1994-07-31	581452		0	0	0		0	0	0	321564	0	113	40213227		
165142	3630	40213160	1960-03-23	1960-03-23 00:00:00	1960-03-23	1960-03-23 00:00:00	1960-03-23	581452		0	0	0		0	0	0	241510	0	10	40213160		
61360	5104	1127078	1980-06-29	1980-06-29 00:00:00	1980-07-13	1980-07-13 00:00:00	1980-07-13	38000177		0	0	14		0	0	0	339216	0	282464	1127078		
53551	4451	1713671	1969-09-04	1969-09-04 00:00:00	1969-09-18	1969-09-18 00:00:00	1969-09-18	38000177		0	0	14		0	0	0	296148	0	562251	1713671		
240425	5278	40213306	1990-05-11	1990-05-11 00:00:00	1990-05-11	1990-05-11 00:00:00	1990-05-11	581452		0	0	0		0	0	0	351111	0	43	40213306		
62332	5189	1127433	1978-08-19	1978-08-19 00:00:00	1978-09-23	1978-09-23 00:00:00	1978-09-23	38000177		0	0	35		0	0	0	344899	0	313782	1127433		
194604	4276	40213160	1955-12-01	1955-12-01 00:00:00	1955-12-01	1955-12-01 00:00:00	1955-12-01	581452		0	0	0		0	0	0	283781	0	10	40213160		
67780	1482	40213314	1978-03-25	1978-03-25 00:00:00	1978-03-25	1978-03-25 00:00:00	1978-03-25	581452		0	0	0		0	0	0	98809	0	49	40213314		
181397	3986	40213160	1961-12-01	1961-12-01 00:00:00	1961-12-01	1961-12-01 00:00:00	1961-12-01	581452		0	0	0		0	0	0	264968	0	10	40213160		
23973	520	40213227	2012-01-12	2012-01-12 00:00:00	2012-01-12	2012-01-12 00:00:00	2012-01-12	581452		0	0	0		0	0	0	34690	0	113	40213227		
149083	3279	40213260	2007-10-16	2007-10-16 00:00:00	2007-10-16	2007-10-16 00:00:00	2007-10-16	581452		0	0	0		0	0	0	217879	0	121	40213260		
61700	1348	40213227	1992-11-02	1992-11-02 00:00:00	1992-11-02	1992-11-02 00:00:00	1992-11-02	581452		0	0	0		0	0	0	89356	0	113	40213227		
31121	2580	46275916	1979-05-07	1979-05-07 00:00:00	1979-05-07	1979-05-07 00:00:00	1979-05-07	38000177		0	0	0		0	0	0	170920	0	1660014	46275916		
37190	812	40213260	2014-08-09	2014-08-09 00:00:00	2014-08-09	2014-08-09 00:00:00	2014-08-09	581452		0	0	0		0	0	0	53845	0	121	40213260		
15711	338	40213160	1972-03-22	1972-03-22 00:00:00	1972-03-22	1972-03-22 00:00:00	1972-03-22	581452		0	0	0		0	0	0	22549	0	10	40213160		
73143	1598	40213260	2009-01-26	2009-01-26 00:00:00	2009-01-26	2009-01-26 00:00:00	2009-01-26	581452		0	0	0		0	0	0	107237	0	121	40213260		
25377	2087	19133905	1951-06-21	1951-06-21 00:00:00	1951-06-29	1951-06-29 00:00:00	1951-06-29	38000177		0	0	8		0	0	0	139028	0	834102	19133905		
40833	3386	40162522	1984-12-31	1984-12-31 00:00:00	1984-12-31	1984-12-31 00:00:00	\N	38000177		0	0	0		0	0	0	224629	0	857005	40162522		
14115	1180	19059056	1986-12-28	1986-12-28 00:00:00	1987-02-01	1987-02-01 00:00:00	1987-02-01	38000177		0	0	35		0	0	0	77961	0	243670	19059056		
95018	2084	40213260	2012-11-21	2012-11-21 00:00:00	2012-11-21	2012-11-21 00:00:00	2012-11-21	581452		0	0	0		0	0	0	138871	0	121	40213260		
18587	1536	40229134	1919-02-08	1919-02-08 00:00:00	1919-02-22	1919-02-22 00:00:00	1919-02-22	38000177		0	0	14		0	0	0	102814	0	1043400	40229134		
144876	3184	40213160	1961-08-10	1961-08-10 00:00:00	1961-08-10	1961-08-10 00:00:00	1961-08-10	581452		0	0	0		0	0	0	212010	0	10	40213160		
69716	1524	40213227	2018-04-26	2018-04-26 00:00:00	2018-04-26	2018-04-26 00:00:00	2018-04-26	581452		0	0	0		0	0	0	101904	0	113	40213227		
3459	287	1713671	1994-08-02	1994-08-02 00:00:00	1994-08-09	1994-08-09 00:00:00	1994-08-09	38000177		0	0	7		0	0	0	19181	0	562251	1713671		
51535	4283	19059056	1959-02-08	1959-02-08 00:00:00	1959-05-09	1959-05-09 00:00:00	1959-05-09	38000177		0	0	90		0	0	0	284280	0	243670	19059056		
230567	5067	40213314	1977-11-06	1977-11-06 00:00:00	1977-11-06	1977-11-06 00:00:00	1977-11-06	581452		0	0	0		0	0	0	336898	0	49	40213314		
63747	5298	1127433	1963-10-10	1963-10-10 00:00:00	1963-10-24	1963-10-24 00:00:00	1963-10-24	38000177		0	0	14		0	0	0	352409	0	313782	1127433		
117207	2576	40213314	1981-01-15	1981-01-15 00:00:00	1981-01-15	1981-01-15 00:00:00	1981-01-15	581452		0	0	0		0	0	0	170567	0	49	40213314		
62586	1368	40213260	2007-03-28	2007-03-28 00:00:00	2007-03-28	2007-03-28 00:00:00	2007-03-28	581452		0	0	0		0	0	0	90694	0	121	40213260		
59553	1303	40213306	1998-05-24	1998-05-24 00:00:00	1998-05-24	1998-05-24 00:00:00	1998-05-24	581452		0	0	0		0	0	0	86052	0	43	40213306		
229858	5051	40213314	1978-03-02	1978-03-02 00:00:00	1978-03-02	1978-03-02 00:00:00	1978-03-02	581452		0	0	0		0	0	0	335941	0	49	40213314		
80433	1759	40213160	1989-12-11	1989-12-11 00:00:00	1989-12-11	1989-12-11 00:00:00	1989-12-11	581452		0	0	0		0	0	0	117630	0	10	40213160		
172215	3786	40213160	1959-05-19	1959-05-19 00:00:00	1959-05-19	1959-05-19 00:00:00	1959-05-19	581452		0	0	0		0	0	0	251703	0	10	40213160		
17395	1441	46275916	1985-11-11	1985-11-11 00:00:00	1985-11-11	1985-11-11 00:00:00	1985-11-11	38000177		0	0	0		0	0	0	95949	0	1660014	46275916		
61077	5079	1127078	1970-12-11	1970-12-11 00:00:00	1970-12-25	1970-12-25 00:00:00	1970-12-25	38000177		0	0	14		0	0	0	337679	0	282464	1127078		
57837	4805	1713671	1986-01-22	1986-01-22 00:00:00	1986-02-05	1986-02-05 00:00:00	1986-02-05	38000177		0	0	14		0	0	0	319680	0	562251	1713671		
212331	4655	40213160	1959-03-22	1959-03-22 00:00:00	1959-03-22	1959-03-22 00:00:00	1959-03-22	581452		0	0	0		0	0	0	310350	0	10	40213160		
182493	4009	40213227	2002-02-26	2002-02-26 00:00:00	2002-02-26	2002-02-26 00:00:00	2002-02-26	581452		0	0	0		0	0	0	266438	0	113	40213227		
56507	4689	19006318	1969-04-29	1969-04-29 00:00:00	1969-05-13	1969-05-13 00:00:00	1969-05-13	38000177		0	0	14		0	0	0	312416	0	105078	19006318		
121178	2663	40213296	2003-09-07	2003-09-07 00:00:00	2003-09-07	2003-09-07 00:00:00	2003-09-07	581452		0	0	0		0	0	0	176500	0	52	40213296		
10429	869	19133905	1970-06-25	1970-06-25 00:00:00	1970-07-02	1970-07-02 00:00:00	1970-07-02	38000177		0	0	7		0	0	0	57791	0	834102	19133905		
122791	2699	40213306	1993-01-19	1993-01-19 00:00:00	1993-01-19	1993-01-19 00:00:00	1993-01-19	581452		0	0	0		0	0	0	178731	0	43	40213306		
228413	5017	40213160	1980-06-21	1980-06-21 00:00:00	1980-06-21	1980-06-21 00:00:00	1980-06-21	581452		0	0	0		0	0	0	333443	0	10	40213160		
126311	2778	40213227	2008-01-05	2008-01-05 00:00:00	2008-01-05	2008-01-05 00:00:00	2008-01-05	581452		0	0	0		0	0	0	184086	0	113	40213227		
116821	2567	40213227	2006-12-30	2006-12-30 00:00:00	2006-12-30	2006-12-30 00:00:00	2006-12-30	581452		0	0	0		0	0	0	170069	0	113	40213227		
34779	759	40213227	1996-01-10	1996-01-10 00:00:00	1996-01-10	1996-01-10 00:00:00	1996-01-10	581452		0	0	0		0	0	0	50366	0	113	40213227		
63275	1384	40213251	1984-02-21	1984-02-21 00:00:00	1984-02-21	1984-02-21 00:00:00	1984-02-21	581452		0	0	0		0	0	0	91735	0	21	40213251		
2708	217	1127433	2013-06-15	2013-06-15 00:00:00	2013-07-13	2013-07-13 00:00:00	2013-07-13	38000177		0	0	28		0	0	0	14642	0	313782	1127433		
137830	3026	40213160	1955-09-04	1955-09-04 00:00:00	1955-09-04	1955-09-04 00:00:00	1955-09-04	581452		0	0	0		0	0	0	201780	0	10	40213160		
133676	2935	40213314	1977-09-14	1977-09-14 00:00:00	1977-09-14	1977-09-14 00:00:00	1977-09-14	581452		0	0	0		0	0	0	195732	0	49	40213314		
40611	3367	1127433	2001-05-24	2001-05-24 00:00:00	2001-06-07	2001-06-07 00:00:00	2001-06-07	38000177		0	0	14		0	0	0	223298	0	313782	1127433		
96525	2116	40213227	1992-04-20	1992-04-20 00:00:00	1992-04-20	1992-04-20 00:00:00	1992-04-20	581452		0	0	0		0	0	0	140801	0	113	40213227		
160232	3527	40213296	2001-07-19	2001-07-19 00:00:00	2001-07-19	2001-07-19 00:00:00	2001-07-19	581452		0	0	0		0	0	0	234042	0	52	40213296		
49730	1088	40213227	2014-08-10	2014-08-10 00:00:00	2014-08-10	2014-08-10 00:00:00	2014-08-10	581452		0	0	0		0	0	0	71470	0	113	40213227		
218962	4805	40213160	1963-01-04	1963-01-04 00:00:00	1963-01-04	1963-01-04 00:00:00	1963-01-04	581452		0	0	0		0	0	0	319674	0	10	40213160		
220274	4834	40213160	1960-08-21	1960-08-21 00:00:00	1960-08-21	1960-08-21 00:00:00	1960-08-21	581452		0	0	0		0	0	0	321609	0	10	40213160		
165148	3630	40213160	1955-12-21	1955-12-21 00:00:00	1955-12-21	1955-12-21 00:00:00	1955-12-21	581452		0	0	0		0	0	0	241519	0	10	40213160		
61361	5104	1713671	1991-09-09	1991-09-09 00:00:00	1991-09-23	1991-09-23 00:00:00	1991-09-23	38000177		0	0	14		0	0	0	339155	0	562251	1713671		
53552	4452	19078461	1978-03-23	1978-03-23 00:00:00	1978-04-06	1978-04-06 00:00:00	1978-04-06	38000177		0	0	14		0	0	0	296345	0	310965	19078461		
240428	5278	40213306	1990-05-04	1990-05-04 00:00:00	1990-05-04	1990-05-04 00:00:00	1990-05-04	581452		0	0	0		0	0	0	\N	0	43	40213306		
62333	5189	19133873	1966-07-06	1966-07-06 00:00:00	1966-07-19	1966-07-19 00:00:00	1966-07-19	38000177		0	0	13		0	0	0	344902	0	834061	19133873		
194610	4276	40213227	2004-01-01	2004-01-01 00:00:00	2004-01-01	2004-01-01 00:00:00	2004-01-01	581452		0	0	0		0	0	0	283798	0	113	40213227		
67783	1482	40213296	2014-10-25	2014-10-25 00:00:00	2014-10-25	2014-10-25 00:00:00	2014-10-25	581452		0	0	0		0	0	0	98826	0	52	40213296		
181412	3986	40213227	2013-08-09	2013-08-09 00:00:00	2013-08-09	2013-08-09 00:00:00	2013-08-09	581452		0	0	0		0	0	0	264976	0	113	40213227		
95151	2087	40213227	2009-08-12	2009-08-12 00:00:00	2009-08-12	2009-08-12 00:00:00	2009-08-12	581452		0	0	0		0	0	0	\N	0	113	40213227		
149091	3279	40213227	2005-10-04	2005-10-04 00:00:00	2005-10-04	2005-10-04 00:00:00	2005-10-04	581452		0	0	0		0	0	0	217878	0	113	40213227		
7591	163	40213160	1971-06-08	1971-06-08 00:00:00	1971-06-08	1971-06-08 00:00:00	1971-06-08	581452		0	0	0		0	0	0	11221	0	10	40213160		
31122	2580	1310034	1979-05-07	1979-05-07 00:00:00	1979-05-07	1979-05-07 00:00:00	1979-05-07	38000177		0	0	0		0	0	0	170920	0	834357	1310034		
37197	812	40213227	1994-09-24	1994-09-24 00:00:00	1994-09-24	1994-09-24 00:00:00	1994-09-24	581452		0	0	0		0	0	0	53841	0	113	40213227		
15713	338	40213160	1967-07-26	1967-07-26 00:00:00	1967-07-26	1967-07-26 00:00:00	1967-07-26	581452		0	0	0		0	0	0	22589	0	10	40213160		
73145	1598	40213227	2009-01-26	2009-01-26 00:00:00	2009-01-26	2009-01-26 00:00:00	2009-01-26	581452		0	0	0		0	0	0	107237	0	113	40213227		
25378	2087	1127433	1974-03-04	1974-03-04 00:00:00	1974-03-18	1974-03-18 00:00:00	1974-03-18	38000177		0	0	14		0	0	0	139101	0	313782	1127433		
40834	3386	19128065	1984-11-17	1984-11-17 00:00:00	1985-11-12	1985-11-12 00:00:00	1985-11-12	38000177		0	0	360		0	0	0	224620	0	749882	19128065		
14116	1180	1127433	1977-07-31	1977-07-31 00:00:00	1977-08-07	1977-08-07 00:00:00	1977-08-07	38000177		0	0	7		0	0	0	77924	0	313782	1127433		
95020	2084	40213160	1963-06-19	1963-06-19 00:00:00	1963-06-19	1963-06-19 00:00:00	1963-06-19	581452		0	0	0		0	0	0	138866	0	10	40213160		
18588	1536	19059056	1913-12-02	1913-12-02 00:00:00	1913-12-16	1913-12-16 00:00:00	1913-12-16	38000177		0	0	14		0	0	0	102821	0	243670	19059056		
144880	3184	40213227	2004-02-05	2004-02-05 00:00:00	2004-02-05	2004-02-05 00:00:00	2004-02-05	581452		0	0	0		0	0	0	212025	0	113	40213227		
69717	1524	40213260	2018-04-26	2018-04-26 00:00:00	2018-04-26	2018-04-26 00:00:00	2018-04-26	581452		0	0	0		0	0	0	101904	0	121	40213260		
3460	287	19133905	2003-02-16	2003-02-16 00:00:00	2003-02-25	2003-02-25 00:00:00	2003-02-25	38000177		0	0	9		0	0	0	19208	0	834102	19133905		
51536	4283	1127078	1953-10-30	1953-10-30 00:00:00	1954-01-28	1954-01-28 00:00:00	1954-01-28	38000177		0	0	90		0	0	0	284278	0	282464	1127078		
230573	5067	40213160	1979-05-13	1979-05-13 00:00:00	1979-05-13	1979-05-13 00:00:00	1979-05-13	581452		0	0	0		0	0	0	336899	0	10	40213160		
63748	5298	1713671	1963-11-21	1963-11-21 00:00:00	1963-12-05	1963-12-05 00:00:00	1963-12-05	38000177		0	0	14		0	0	0	352410	0	562251	1713671		
117221	2576	40213227	2011-11-17	2011-11-17 00:00:00	2011-11-17	2011-11-17 00:00:00	2011-11-17	581452		0	0	0		0	0	0	170584	0	113	40213227		
53761	4470	19059056	1972-02-08	1972-02-08 00:00:00	1972-02-22	1972-02-22 00:00:00	1972-02-22	38000177		0	0	14		0	0	0	297364	0	243670	19059056		
59555	1303	40213227	1998-05-24	1998-05-24 00:00:00	1998-05-24	1998-05-24 00:00:00	1998-05-24	581452		0	0	0		0	0	0	86052	0	113	40213227		
229859	5051	40213160	1978-03-02	1978-03-02 00:00:00	1978-03-02	1978-03-02 00:00:00	1978-03-02	581452		0	0	0		0	0	0	335941	0	10	40213160		
80437	1760	40213160	1977-11-27	1977-11-27 00:00:00	1977-11-27	1977-11-27 00:00:00	1977-11-27	581452		0	0	0		0	0	0	117664	0	10	40213160		
172222	3786	40213306	1982-07-20	1982-07-20 00:00:00	1982-07-20	1982-07-20 00:00:00	1982-07-20	581452		0	0	0		0	0	0	251725	0	43	40213306		
17396	1441	40231925	1994-10-02	1994-10-02 00:00:00	1994-10-02	1994-10-02 00:00:00	\N	38000177		0	0	0		0	0	0	95951	0	1049221	40231925		
61078	5079	19059056	1969-07-28	1969-07-28 00:00:00	1969-09-10	1969-09-10 00:00:00	1969-09-10	38000177		0	0	44		0	0	0	337687	0	243670	19059056		
57845	4807	1127433	1957-10-24	1957-10-24 00:00:00	1957-11-07	1957-11-07 00:00:00	1957-11-07	38000177		0	0	14		0	0	0	319855	0	313782	1127433		
212334	4655	40213296	2000-06-25	2000-06-25 00:00:00	2000-06-25	2000-06-25 00:00:00	2000-06-25	581452		0	0	0		0	0	0	310273	0	52	40213296		
182495	4009	40213160	1955-06-08	1955-06-08 00:00:00	1955-06-08	1955-06-08 00:00:00	1955-06-08	581452		0	0	0		0	0	0	266399	0	10	40213160		
56508	4689	920300	2012-05-26	2012-05-26 00:00:00	2012-06-02	2012-06-02 00:00:00	2012-06-02	38000177		0	0	7		0	0	0	312381	0	311989	920300		
121180	2663	40213227	2014-09-07	2014-09-07 00:00:00	2014-09-07	2014-09-07 00:00:00	2014-09-07	581452		0	0	0		0	0	0	176465	0	113	40213227		
10430	869	19133905	1961-01-02	1961-01-02 00:00:00	1961-01-09	1961-01-09 00:00:00	1961-01-09	38000177		0	0	7		0	0	0	57750	0	834102	19133905		
122794	2699	40213227	1993-01-19	1993-01-19 00:00:00	1993-01-19	1993-01-19 00:00:00	1993-01-19	581452		0	0	0		0	0	0	178731	0	113	40213227		
228414	5017	40213314	1980-06-21	1980-06-21 00:00:00	1980-06-21	1980-06-21 00:00:00	1980-06-21	581452		0	0	0		0	0	0	333443	0	49	40213314		
126319	2779	40213160	1971-07-25	1971-07-25 00:00:00	1971-07-25	1971-07-25 00:00:00	1971-07-25	581452		0	0	0		0	0	0	184159	0	10	40213160		
116822	2567	40213314	1977-07-02	1977-07-02 00:00:00	1977-07-02	1977-07-02 00:00:00	1977-07-02	581452		0	0	0		0	0	0	170073	0	49	40213314		
34800	759	40213201	2011-04-06	2011-04-06 00:00:00	2011-04-06	2011-04-06 00:00:00	2011-04-06	581452		0	0	0		0	0	0	50425	0	33	40213201		
63285	1384	40213314	1982-08-24	1982-08-24 00:00:00	1982-08-24	1982-08-24 00:00:00	1982-08-24	581452		0	0	0		0	0	0	91757	0	49	40213314		
38711	3199	1118084	2009-06-11	2009-06-11 00:00:00	2009-06-11	2009-06-11 00:00:00	\N	38000177		0	0	0		0	0	0	212778	0	00025152531	44923712		
149109	3279	40213160	1955-06-07	1955-06-07 00:00:00	1955-06-07	1955-06-07 00:00:00	1955-06-07	581452		0	0	0		0	0	0	217891	0	10	40213160		
133682	2936	40213227	2014-03-29	2014-03-29 00:00:00	2014-03-29	2014-03-29 00:00:00	2014-03-29	581452		0	0	0		0	0	0	195815	0	113	40213227		
40612	3367	1127433	1997-07-06	1997-07-06 00:00:00	1997-07-20	1997-07-20 00:00:00	1997-07-20	38000177		0	0	14		0	0	0	223282	0	313782	1127433		
160234	3527	40213160	1961-10-19	1961-10-19 00:00:00	1961-10-19	1961-10-19 00:00:00	1961-10-19	581452		0	0	0		0	0	0	234141	0	10	40213160		
49731	1088	40213296	2014-08-10	2014-08-10 00:00:00	2014-08-10	2014-08-10 00:00:00	2014-08-10	581452		0	0	0		0	0	0	71470	0	52	40213296		
218968	4805	40213306	1985-09-06	1985-09-06 00:00:00	1985-09-06	1985-09-06 00:00:00	1985-09-06	581452		0	0	0		0	0	0	319718	0	43	40213306		
220276	4834	40213227	2011-08-21	2011-08-21 00:00:00	2011-08-21	2011-08-21 00:00:00	2011-08-21	581452		0	0	0		0	0	0	321568	0	113	40213227		
165151	3630	40213160	1955-09-21	1955-09-21 00:00:00	1955-09-21	1955-09-21 00:00:00	1955-09-21	581452		0	0	0		0	0	0	241507	0	10	40213160		
61362	5104	19019979	1987-04-08	1987-04-08 00:00:00	1987-07-07	1987-07-07 00:00:00	1987-07-07	38000177		0	0	90		0	0	0	339183	0	198405	19019979		
53553	4452	1127433	1995-02-06	1995-02-06 00:00:00	1995-04-07	1995-04-07 00:00:00	1995-04-07	38000177		0	0	60		0	0	0	296346	0	313782	1127433		
240438	5278	40213227	2010-05-21	2010-05-21 00:00:00	2010-05-21	2010-05-21 00:00:00	2010-05-21	581452		0	0	0		0	0	0	351063	0	113	40213227		
62334	5189	1124300	1998-10-28	1998-10-28 00:00:00	1998-10-28	1998-10-28 00:00:00	\N	38000177		0	0	0		0	0	0	344911	0	00781178901	45011828		
194612	4276	40213201	2019-03-28	2019-03-28 00:00:00	2019-03-28	2019-03-28 00:00:00	2019-03-28	581452		0	0	0		0	0	0	283803	0	33	40213201		
67786	1482	40213227	2016-10-29	2016-10-29 00:00:00	2016-10-29	2016-10-29 00:00:00	2016-10-29	581452		0	0	0		0	0	0	98827	0	113	40213227		
181413	3986	40213260	2013-08-09	2013-08-09 00:00:00	2013-08-09	2013-08-09 00:00:00	2013-08-09	581452		0	0	0		0	0	0	264976	0	121	40213260		
95162	2087	40213227	1999-07-07	1999-07-07 00:00:00	1999-07-07	1999-07-07 00:00:00	1999-07-07	581452		0	0	0		0	0	0	139116	0	113	40213227		
149097	3279	40213160	1955-09-06	1955-09-06 00:00:00	1955-09-06	1955-09-06 00:00:00	1955-09-06	581452		0	0	0		0	0	0	217943	0	10	40213160		
7592	163	40213260	2017-07-04	2017-07-04 00:00:00	2017-07-04	2017-07-04 00:00:00	2017-07-04	581452		0	0	0		0	0	0	11213	0	121	40213260		
31123	2580	40243436	1979-05-07	1979-05-07 00:00:00	1979-05-07	1979-05-07 00:00:00	1979-05-07	38000177		0	0	0		0	0	0	170920	0	1190795	40243436		
70137	1533	40213160	1971-04-06	1971-04-06 00:00:00	1971-04-06	1971-04-06 00:00:00	1971-04-06	581452		0	0	0		0	0	0	102639	0	10	40213160		
15715	338	40213296	2007-04-25	2007-04-25 00:00:00	2007-04-25	2007-04-25 00:00:00	2007-04-25	581452		0	0	0		0	0	0	22517	0	52	40213296		
73151	1598	40213260	2008-01-21	2008-01-21 00:00:00	2008-01-21	2008-01-21 00:00:00	2008-01-21	581452		0	0	0		0	0	0	107266	0	121	40213260		
25379	2087	40174880	1968-05-30	1968-05-30 00:00:00	1968-05-30	1968-05-30 00:00:00	\N	38000177		0	0	0		0	0	0	139031	0	966222	40174880		
40835	3386	19059056	1970-10-22	1970-10-22 00:00:00	1970-11-05	1970-11-05 00:00:00	1970-11-05	38000177		0	0	14		0	0	0	224643	0	243670	19059056		
14117	1180	19059056	1963-12-31	1963-12-31 00:00:00	1964-03-30	1964-03-30 00:00:00	1964-03-30	38000177		0	0	90		0	0	0	77959	0	243670	19059056		
95028	2084	40213160	1967-09-20	1967-09-20 00:00:00	1967-09-20	1967-09-20 00:00:00	1967-09-20	581452		0	0	0		0	0	0	138845	0	10	40213160		
18589	1536	19133905	1968-10-29	1968-10-29 00:00:00	1968-11-09	1968-11-09 00:00:00	1968-11-09	38000177		0	0	11		0	0	0	102779	0	834102	19133905		
144885	3184	40213260	2011-03-03	2011-03-03 00:00:00	2011-03-03	2011-03-03 00:00:00	2011-03-03	581452		0	0	0		0	0	0	212026	0	121	40213260		
69722	1524	40213296	2010-04-01	2010-04-01 00:00:00	2010-04-01	2010-04-01 00:00:00	2010-04-01	581452		0	0	0		0	0	0	101906	0	52	40213296		
3461	287	19078461	1995-03-05	1995-03-05 00:00:00	1995-03-19	1995-03-19 00:00:00	1995-03-19	38000177		0	0	14		0	0	0	19218	0	310965	19078461		
51537	4283	19059056	1973-10-22	1973-10-22 00:00:00	1973-11-19	1973-11-19 00:00:00	1973-11-19	38000177		0	0	28		0	0	0	284275	0	243670	19059056		
230575	5067	40213227	1996-09-08	1996-09-08 00:00:00	1996-09-08	1996-09-08 00:00:00	1996-09-08	581452		0	0	0		0	0	0	336859	0	113	40213227		
63749	5298	19059056	1991-08-11	1991-08-11 00:00:00	1991-09-01	1991-09-01 00:00:00	1991-09-01	38000177		0	0	21		0	0	0	352438	0	243670	19059056		
117222	2576	40213306	2002-11-07	2002-11-07 00:00:00	2002-11-07	2002-11-07 00:00:00	2002-11-07	581452		0	0	0		0	0	0	170581	0	43	40213306		
53762	4470	46233988	1972-02-08	1972-02-08 00:00:00	1972-02-22	1972-02-22 00:00:00	1972-02-22	38000177		0	0	14		0	0	0	297364	0	1652673	46233988		
59556	1303	40213251	1984-03-18	1984-03-18 00:00:00	1984-03-18	1984-03-18 00:00:00	1984-03-18	581452		0	0	0		0	0	0	86048	0	21	40213251		
224300	4924	40213160	1978-08-23	1978-08-23 00:00:00	1978-08-23	1978-08-23 00:00:00	1978-08-23	581452		0	0	0		0	0	0	327178	0	10	40213160		
80438	1760	40213314	1977-11-27	1977-11-27 00:00:00	1977-11-27	1977-11-27 00:00:00	1977-11-27	581452		0	0	0		0	0	0	117664	0	49	40213314		
172224	3786	40213160	1963-11-19	1963-11-19 00:00:00	1963-11-19	1963-11-19 00:00:00	1963-11-19	581452		0	0	0		0	0	0	251650	0	10	40213160		
17397	1441	1115171	1994-10-02	1994-10-02 00:00:00	1994-11-06	1994-11-06 00:00:00	1994-11-06	38000177		0	0	35		0	0	0	95951	0	849574	1115171		
61079	5079	1127433	1999-11-08	1999-11-08 00:00:00	1999-11-22	1999-11-22 00:00:00	1999-11-22	38000177		0	0	14		0	0	0	337678	0	313782	1127433		
57846	4807	40173590	2006-03-09	2006-03-09 00:00:00	2006-03-09	2006-03-09 00:00:00	\N	38000177		0	0	0		0	0	0	319872	0	904419	40173590		
212336	4655	40213227	2000-06-25	2000-06-25 00:00:00	2000-06-25	2000-06-25 00:00:00	2000-06-25	581452		0	0	0		0	0	0	310273	0	113	40213227		
56923	4724	1115171	2011-03-06	2011-03-06 00:00:00	2011-05-05	2011-05-05 00:00:00	2011-05-05	38000177		0	0	60		0	0	0	314862	0	849574	1115171		
56509	4689	40236824	2012-05-26	2012-05-26 00:00:00	2012-06-02	2012-06-02 00:00:00	2012-06-02	38000177		0	0	7		0	0	0	312381	0	1094107	40236824		
121181	2663	40213260	2014-09-07	2014-09-07 00:00:00	2014-09-07	2014-09-07 00:00:00	2014-09-07	581452		0	0	0		0	0	0	176465	0	121	40213260		
10431	870	1124300	1998-08-20	1998-08-20 00:00:00	1998-08-20	1998-08-20 00:00:00	\N	38000177		0	0	0		0	0	0	57897	0	00781178901	45011828		
134082	2944	40213296	2004-01-18	2004-01-18 00:00:00	2004-01-18	2004-01-18 00:00:00	2004-01-18	581452		0	0	0		0	0	0	196399	0	52	40213296		
228424	5017	40213314	1981-03-21	1981-03-21 00:00:00	1981-03-21	1981-03-21 00:00:00	1981-03-21	581452		0	0	0		0	0	0	333444	0	49	40213314		
126326	2779	40213160	1971-04-25	1971-04-25 00:00:00	1971-04-25	1971-04-25 00:00:00	1971-04-25	581452		0	0	0		0	0	0	184204	0	10	40213160		
116829	2567	40213160	1976-04-03	1976-04-03 00:00:00	1976-04-03	1976-04-03 00:00:00	1976-04-03	581452		0	0	0		0	0	0	170055	0	10	40213160		
63220	1382	40213227	2009-08-19	2009-08-19 00:00:00	2009-08-19	2009-08-19 00:00:00	2009-08-19	581452		0	0	0		0	0	0	91663	0	113	40213227		
63286	1384	40213160	1982-08-24	1982-08-24 00:00:00	1982-08-24	1982-08-24 00:00:00	1982-08-24	581452		0	0	0		0	0	0	91757	0	10	40213160		
149124	3279	40213160	1959-07-21	1959-07-21 00:00:00	1959-07-21	1959-07-21 00:00:00	1959-07-21	581452		0	0	0		0	0	0	217945	0	10	40213160		
133683	2936	40213260	2014-03-29	2014-03-29 00:00:00	2014-03-29	2014-03-29 00:00:00	2014-03-29	581452		0	0	0		0	0	0	195815	0	121	40213260		
40613	3367	19078461	1994-06-17	1994-06-17 00:00:00	1994-07-22	1994-07-22 00:00:00	1994-07-22	38000177		0	0	35		0	0	0	223281	0	310965	19078461		
160241	3527	40213306	1983-08-04	1983-08-04 00:00:00	1983-08-04	1983-08-04 00:00:00	1983-08-04	581452		0	0	0		0	0	0	234040	0	43	40213306		
175874	3866	40213160	1955-09-27	1955-09-27 00:00:00	1955-09-27	1955-09-27 00:00:00	1955-09-27	581452		0	0	0		0	0	0	256693	0	10	40213160		
218973	4805	40213160	1967-04-07	1967-04-07 00:00:00	1967-04-07	1967-04-07 00:00:00	1967-04-07	581452		0	0	0		0	0	0	319690	0	10	40213160		
220277	4834	40213260	2010-08-15	2010-08-15 00:00:00	2010-08-15	2010-08-15 00:00:00	2010-08-15	581452		0	0	0		0	0	0	321579	0	121	40213260		
165162	3630	40213160	1955-07-20	1955-07-20 00:00:00	1955-07-20	1955-07-20 00:00:00	1955-07-20	581452		0	0	0		0	0	0	241518	0	10	40213160		
61363	5104	1118084	2017-06-15	2017-06-15 00:00:00	2017-06-15	2017-06-15 00:00:00	\N	38000177		0	0	0		0	0	0	339192	0	00025152531	44923712		
53554	4452	40165015	1995-02-06	1995-02-06 00:00:00	1995-02-06	1995-02-06 00:00:00	\N	38000177		0	0	0		0	0	0	296346	0	861467	40165015		
240439	5278	40213296	2010-05-21	2010-05-21 00:00:00	2010-05-21	2010-05-21 00:00:00	2010-05-21	581452		0	0	0		0	0	0	351063	0	52	40213296		
62335	5189	19078461	2018-07-25	2018-07-25 00:00:00	2018-08-15	2018-08-15 00:00:00	2018-08-15	38000177		0	0	21		0	0	0	344900	0	310965	19078461		
194621	4276	40213160	1956-05-31	1956-05-31 00:00:00	1956-05-31	1956-05-31 00:00:00	1956-05-31	581452		0	0	0		0	0	0	283786	0	10	40213160		
67787	1482	40213296	2016-10-29	2016-10-29 00:00:00	2016-10-29	2016-10-29 00:00:00	2016-10-29	581452		0	0	0		0	0	0	98827	0	52	40213296		
181418	3986	40213160	1962-05-04	1962-05-04 00:00:00	1962-05-04	1962-05-04 00:00:00	1962-05-04	581452		0	0	0		0	0	0	264991	0	10	40213160		
95172	2087	40213201	1985-04-03	1985-04-03 00:00:00	1985-04-03	1985-04-03 00:00:00	1985-04-03	581452		0	0	0		0	0	0	139155	0	33	40213201		
149098	3279	40213260	2006-10-10	2006-10-10 00:00:00	2006-10-10	2006-10-10 00:00:00	2006-10-10	581452		0	0	0		0	0	0	217830	0	121	40213260		
7594	163	40213227	2017-07-04	2017-07-04 00:00:00	2017-07-04	2017-07-04 00:00:00	2017-07-04	581452		0	0	0		0	0	0	11213	0	113	40213227		
31124	2580	40229134	1989-07-29	1989-07-29 00:00:00	1989-08-12	1989-08-12 00:00:00	1989-08-12	38000177		0	0	14		0	0	0	170923	0	1043400	40229134		
70147	1533	40213227	2002-03-12	2002-03-12 00:00:00	2002-03-12	2002-03-12 00:00:00	2002-03-12	581452		0	0	0		0	0	0	102686	0	113	40213227		
15723	339	40213160	1987-07-25	1987-07-25 00:00:00	1987-07-25	1987-07-25 00:00:00	1987-07-25	581452		0	0	0		0	0	0	22648	0	10	40213160		
73154	1598	40213160	1958-09-29	1958-09-29 00:00:00	1958-09-29	1958-09-29 00:00:00	1958-09-29	581452		0	0	0		0	0	0	107252	0	10	40213160		
25380	2087	1127433	2004-01-20	2004-01-20 00:00:00	2004-02-03	2004-02-03 00:00:00	2004-02-03	38000177		0	0	14		0	0	0	139049	0	313782	1127433		
40836	3386	46233988	1970-10-22	1970-10-22 00:00:00	1970-11-05	1970-11-05 00:00:00	1970-11-05	38000177		0	0	14		0	0	0	224643	0	1652673	46233988		
14118	1180	1127433	2010-09-28	2010-09-28 00:00:00	2010-11-27	2010-11-27 00:00:00	2010-11-27	38000177		0	0	60		0	0	0	77962	0	313782	1127433		
3797	316	1127433	2006-08-31	2006-08-31 00:00:00	2006-10-30	2006-10-30 00:00:00	2006-10-30	38000177		0	0	60		0	0	0	20891	0	313782	1127433		
18590	1537	1127433	2010-12-29	2010-12-29 00:00:00	2011-01-05	2011-01-05 00:00:00	2011-01-05	38000177		0	0	7		0	0	0	102862	0	313782	1127433		
144887	3184	40213227	1992-08-06	1992-08-06 00:00:00	1992-08-06	1992-08-06 00:00:00	1992-08-06	581452		0	0	0		0	0	0	212021	0	113	40213227		
69726	1524	40213227	2000-03-16	2000-03-16 00:00:00	2000-03-16	2000-03-16 00:00:00	2000-03-16	581452		0	0	0		0	0	0	101949	0	113	40213227		
3462	287	1127433	2014-08-28	2014-08-28 00:00:00	2014-09-04	2014-09-04 00:00:00	2014-09-04	38000177		0	0	7		0	0	0	19191	0	313782	1127433		
51539	4283	1127078	1955-11-26	1955-11-26 00:00:00	1956-01-25	1956-01-25 00:00:00	1956-01-25	38000177		0	0	60		0	0	0	284277	0	282464	1127078		
230576	5067	40213306	1996-09-08	1996-09-08 00:00:00	1996-09-08	1996-09-08 00:00:00	1996-09-08	581452		0	0	0		0	0	0	336859	0	43	40213306		
63750	5298	40229134	1993-03-07	1993-03-07 00:00:00	1993-03-14	1993-03-14 00:00:00	1993-03-14	38000177		0	0	7		0	0	0	352424	0	1043400	40229134		
117224	2576	40213227	2002-11-07	2002-11-07 00:00:00	2002-11-07	2002-11-07 00:00:00	2002-11-07	581452		0	0	0		0	0	0	170581	0	113	40213227		
53763	4471	1118084	1998-05-18	1998-05-18 00:00:00	1998-05-18	1998-05-18 00:00:00	\N	38000177		0	0	0		0	0	0	297426	0	00025152531	44923712		
61529	1345	40213160	1966-08-23	1966-08-23 00:00:00	1966-08-23	1966-08-23 00:00:00	1966-08-23	581452		0	0	0		0	0	0	89108	0	10	40213160		
224310	4924	40213160	1982-09-22	1982-09-22 00:00:00	1982-09-22	1982-09-22 00:00:00	1982-09-22	581452		0	0	0		0	0	0	327181	0	10	40213160		
80442	1760	40213227	2009-06-28	2009-06-28 00:00:00	2009-06-28	2009-06-28 00:00:00	2009-06-28	581452		0	0	0		0	0	0	117700	0	113	40213227		
172228	3786	40213227	2010-09-07	2010-09-07 00:00:00	2010-09-07	2010-09-07 00:00:00	2010-09-07	581452		0	0	0		0	0	0	251678	0	113	40213227		
17398	1441	19073188	1994-10-02	1994-10-02 00:00:00	1994-11-06	1994-11-06 00:00:00	1994-11-06	38000177		0	0	35		0	0	0	95951	0	308192	19073188		
61080	5079	1118084	2008-05-19	2008-05-19 00:00:00	2008-05-19	2008-05-19 00:00:00	\N	38000177		0	0	0		0	0	0	337711	0	00025152531	44923712		
57847	4807	40236824	2002-04-21	2002-04-21 00:00:00	2002-04-28	2002-04-28 00:00:00	2002-04-28	38000177		0	0	7		0	0	0	319858	0	1094107	40236824		
212337	4655	40213227	1993-02-28	1993-02-28 00:00:00	1993-02-28	1993-02-28 00:00:00	1993-02-28	581452		0	0	0		0	0	0	310412	0	113	40213227		
56925	4724	19134077	1986-01-05	1986-01-05 00:00:00	1986-01-19	1986-01-19 00:00:00	1986-01-19	38000177		0	0	14		0	0	0	314663	0	835900	19134077		
56511	4689	1127078	1972-01-13	1972-01-13 00:00:00	1972-02-03	1972-02-03 00:00:00	1972-02-03	38000177		0	0	21		0	0	0	312392	0	282464	1127078		
234094	5144	40213227	1998-06-27	1998-06-27 00:00:00	1998-06-27	1998-06-27 00:00:00	1998-06-27	581452		0	0	0		0	0	0	341977	0	113	40213227		
10432	870	19059056	1978-02-01	1978-02-01 00:00:00	1978-02-15	1978-02-15 00:00:00	1978-02-15	38000177		0	0	14		0	0	0	57892	0	243670	19059056		
134083	2944	40213160	1964-11-01	1964-11-01 00:00:00	1964-11-01	1964-11-01 00:00:00	1964-11-01	581452		0	0	0		0	0	0	196432	0	10	40213160		
169127	3719	40213160	1963-04-16	1963-04-16 00:00:00	1963-04-16	1963-04-16 00:00:00	1963-04-16	581452		0	0	0		0	0	0	247223	0	10	40213160		
126330	2779	40213296	2010-11-21	2010-11-21 00:00:00	2010-11-21	2010-11-21 00:00:00	2010-11-21	581452		0	0	0		0	0	0	184200	0	52	40213296		
116830	2567	40213160	1980-05-17	1980-05-17 00:00:00	1980-05-17	1980-05-17 00:00:00	1980-05-17	581452		0	0	0		0	0	0	170075	0	10	40213160		
11857	987	19059056	1970-08-01	1970-08-01 00:00:00	1970-09-05	1970-09-05 00:00:00	1970-09-05	38000177		0	0	35		0	0	0	65520	0	243670	19059056		
63288	1384	40213160	1987-02-24	1987-02-24 00:00:00	1987-02-24	1987-02-24 00:00:00	1987-02-24	581452		0	0	0		0	0	0	91759	0	10	40213160		
226560	4975	40213160	1959-12-17	1959-12-17 00:00:00	1959-12-17	1959-12-17 00:00:00	1959-12-17	581452		0	0	0		0	0	0	330910	0	10	40213160		
133685	2936	40213160	1962-11-10	1962-11-10 00:00:00	1962-11-10	1962-11-10 00:00:00	1962-11-10	581452		0	0	0		0	0	0	195749	0	10	40213160		
40614	3367	1127433	1992-04-23	1992-04-23 00:00:00	1992-04-30	1992-04-30 00:00:00	1992-04-30	38000177		0	0	7		0	0	0	223308	0	313782	1127433		
160246	3527	40213160	1961-12-21	1961-12-21 00:00:00	1961-12-21	1961-12-21 00:00:00	1961-12-21	581452		0	0	0		0	0	0	234025	0	10	40213160		
175886	3866	40213227	1993-10-26	1993-10-26 00:00:00	1993-10-26	1993-10-26 00:00:00	1993-10-26	581452		0	0	0		0	0	0	256698	0	113	40213227		
229353	5041	40213227	2002-02-05	2002-02-05 00:00:00	2002-02-05	2002-02-05 00:00:00	2002-02-05	581452		0	0	0		0	0	0	334923	0	113	40213227		
220278	4834	40213260	2011-08-21	2011-08-21 00:00:00	2011-08-21	2011-08-21 00:00:00	2011-08-21	581452		0	0	0		0	0	0	321568	0	121	40213260		
165168	3630	40213260	2007-04-25	2007-04-25 00:00:00	2007-04-25	2007-04-25 00:00:00	2007-04-25	581452		0	0	0		0	0	0	241534	0	121	40213260		
61364	5104	19075001	1988-07-31	1988-07-31 00:00:00	1988-08-21	1988-08-21 00:00:00	1988-08-21	38000177		0	0	21		0	0	0	339184	0	309097	19075001		
53555	4452	19133873	1955-11-03	1955-11-03 00:00:00	1955-11-16	1955-11-16 00:00:00	1955-11-16	38000177		0	0	13		0	0	0	296242	0	834061	19133873		
240445	5278	40213227	1993-05-14	1993-05-14 00:00:00	1993-05-14	1993-05-14 00:00:00	1993-05-14	581452		0	0	0		0	0	0	351112	0	113	40213227		
62336	5190	19078461	1986-03-17	1986-03-17 00:00:00	1986-03-31	1986-03-31 00:00:00	1986-03-31	38000177		0	0	14		0	0	0	345052	0	310965	19078461		
194633	4276	40213260	2006-01-12	2006-01-12 00:00:00	2006-01-12	2006-01-12 00:00:00	2006-01-12	581452		0	0	0		0	0	0	283799	0	121	40213260		
67788	1482	40213314	1977-09-24	1977-09-24 00:00:00	1977-09-24	1977-09-24 00:00:00	1977-09-24	581452		0	0	0		0	0	0	98818	0	49	40213314		
181421	3987	40213260	2006-01-07	2006-01-07 00:00:00	2006-01-07	2006-01-07 00:00:00	2006-01-07	581452		0	0	0		0	0	0	265050	0	121	40213260		
145315	3195	40213227	2010-11-22	2010-11-22 00:00:00	2010-11-22	2010-11-22 00:00:00	2010-11-22	581452		0	0	0		0	0	0	212560	0	113	40213227		
149101	3279	40213296	1996-10-08	1996-10-08 00:00:00	1996-10-08	1996-10-08 00:00:00	1996-10-08	581452		0	0	0		0	0	0	217821	0	52	40213296		
7598	163	40213260	2016-06-28	2016-06-28 00:00:00	2016-06-28	2016-06-28 00:00:00	2016-06-28	581452		0	0	0		0	0	0	11241	0	121	40213260		
31125	2580	40236824	1980-07-05	1980-07-05 00:00:00	1980-07-12	1980-07-12 00:00:00	1980-07-12	38000177		0	0	7		0	0	0	170908	0	1094107	40236824		
70156	1533	40213160	1971-09-07	1971-09-07 00:00:00	1971-09-07	1971-09-07 00:00:00	1971-09-07	581452		0	0	0		0	0	0	102651	0	10	40213160		
15724	339	40213251	1987-07-25	1987-07-25 00:00:00	1987-07-25	1987-07-25 00:00:00	1987-07-25	581452		0	0	0		0	0	0	22648	0	21	40213251		
73163	1599	40213296	2002-05-20	2002-05-20 00:00:00	2002-05-20	2002-05-20 00:00:00	2002-05-20	581452		0	0	0		0	0	0	107327	0	52	40213296		
25381	2087	19075601	2011-11-09	2011-11-09 00:00:00	2016-08-03	2016-08-03 00:00:00	2016-08-03	38000177		0	0	1729		0	0	0	139161	0	309362	19075601		
51295	4261	1118084	1954-09-25	1954-09-25 00:00:00	1954-09-25	1954-09-25 00:00:00	\N	38000177		0	0	0		0	0	0	282905	0	00025152531	44923712		
14119	1180	40162522	2010-09-28	2010-09-28 00:00:00	2010-09-28	2010-09-28 00:00:00	\N	38000177		0	0	0		0	0	0	77962	0	857005	40162522		
3798	316	1713671	1934-03-22	1934-03-22 00:00:00	1934-04-26	1934-04-26 00:00:00	1934-04-26	38000177		0	0	35		0	0	0	20893	0	562251	1713671		
18591	1537	19006318	1960-08-12	1960-08-12 00:00:00	1960-08-26	1960-08-26 00:00:00	1960-08-26	38000177		0	0	14		0	0	0	102897	0	105078	19006318		
195601	4297	40213296	2013-02-16	2013-02-16 00:00:00	2013-02-16	2013-02-16 00:00:00	2013-02-16	581452		0	0	0		0	0	0	285158	0	52	40213296		
69728	1524	40213160	1967-04-20	1967-04-20 00:00:00	1967-04-20	1967-04-20 00:00:00	1967-04-20	581452		0	0	0		0	0	0	101937	0	10	40213160		
3463	287	19133873	1993-07-01	1993-07-01 00:00:00	1993-07-09	1993-07-09 00:00:00	1993-07-09	38000177		0	0	8		0	0	0	19188	0	834061	19133873		
51540	4283	1127078	1961-06-27	1961-06-27 00:00:00	1961-07-27	1961-07-27 00:00:00	1961-07-27	38000177		0	0	30		0	0	0	284274	0	282464	1127078		
230581	5067	40213160	1975-02-09	1975-02-09 00:00:00	1975-02-09	1975-02-09 00:00:00	1975-02-09	581452		0	0	0		0	0	0	336884	0	10	40213160		
63751	5298	1127433	1986-07-24	1986-07-24 00:00:00	1986-08-07	1986-08-07 00:00:00	1986-08-07	38000177		0	0	14		0	0	0	352437	0	313782	1127433		
117227	2576	40213314	1980-04-17	1980-04-17 00:00:00	1980-04-17	1980-04-17 00:00:00	1980-04-17	581452		0	0	0		0	0	0	170566	0	49	40213314		
53765	4471	40220960	2001-01-08	2001-01-08 00:00:00	2001-01-08	2001-01-08 00:00:00	2001-01-08	38000177		0	0	0		0	0	0	297427	0	1804799	40220960		
61532	1345	40213260	2016-03-29	2016-03-29 00:00:00	2016-03-29	2016-03-29 00:00:00	2016-03-29	581452		0	0	0		0	0	0	89143	0	121	40213260		
224318	4924	40213296	2018-06-27	2018-06-27 00:00:00	2018-06-27	2018-06-27 00:00:00	2018-06-27	581452		0	0	0		0	0	0	327162	0	52	40213296		
80444	1760	40213160	1977-09-25	1977-09-25 00:00:00	1977-09-25	1977-09-25 00:00:00	1977-09-25	581452		0	0	0		0	0	0	117680	0	10	40213160		
172229	3786	40213260	2010-09-07	2010-09-07 00:00:00	2010-09-07	2010-09-07 00:00:00	2010-09-07	581452		0	0	0		0	0	0	251678	0	121	40213260		
225409	4949	40213314	1977-09-01	1977-09-01 00:00:00	1977-09-01	1977-09-01 00:00:00	1977-09-01	581452		0	0	0		0	0	0	329017	0	49	40213314		
59674	1306	40213160	1956-11-14	1956-11-14 00:00:00	1956-11-14	1956-11-14 00:00:00	1956-11-14	581452		0	0	0		0	0	0	86245	0	10	40213160		
196766	4324	40213160	1961-11-19	1961-11-19 00:00:00	1961-11-19	1961-11-19 00:00:00	1961-11-19	581452		0	0	0		0	0	0	286815	0	10	40213160		
56926	4724	19008572	1986-01-05	1986-01-05 00:00:00	1986-01-19	1986-01-19 00:00:00	1986-01-19	38000177		0	0	14		0	0	0	314663	0	106258	19008572		
56512	4689	19133873	1968-07-07	1968-07-07 00:00:00	1968-07-15	1968-07-15 00:00:00	1968-07-15	38000177		0	0	8		0	0	0	312443	0	834061	19133873		
234109	5144	40213201	2003-07-26	2003-07-26 00:00:00	2003-07-26	2003-07-26 00:00:00	2003-07-26	581452		0	0	0		0	0	0	341907	0	33	40213201		
10433	870	19129655	1963-07-20	1963-07-20 00:00:00	1963-08-03	1963-08-03 00:00:00	1963-08-03	38000177		0	0	14		0	0	0	57866	0	789980	19129655		
134088	2944	40213227	2011-10-23	2011-10-23 00:00:00	2011-10-23	2011-10-23 00:00:00	2011-10-23	581452		0	0	0		0	0	0	196391	0	113	40213227		
169128	3719	40213160	1967-12-19	1967-12-19 00:00:00	1967-12-19	1967-12-19 00:00:00	1967-12-19	581452		0	0	0		0	0	0	247214	0	10	40213160		
126334	2779	40213227	1993-05-16	1993-05-16 00:00:00	1993-05-16	1993-05-16 00:00:00	1993-05-16	581452		0	0	0		0	0	0	184187	0	113	40213227		
116838	2567	40213314	1977-01-01	1977-01-01 00:00:00	1977-01-01	1977-01-01 00:00:00	1977-01-01	581452		0	0	0		0	0	0	170056	0	49	40213314		
11858	987	19129655	1970-08-01	1970-08-01 00:00:00	1970-09-05	1970-09-05 00:00:00	1970-09-05	38000177		0	0	35		0	0	0	65520	0	789980	19129655		
63289	1384	40213251	1987-02-24	1987-02-24 00:00:00	1987-02-24	1987-02-24 00:00:00	1987-02-24	581452		0	0	0		0	0	0	91759	0	21	40213251		
226563	4975	40213227	2001-12-06	2001-12-06 00:00:00	2001-12-06	2001-12-06 00:00:00	2001-12-06	581452		0	0	0		0	0	0	\N	0	113	40213227		
133686	2936	40213296	2002-06-08	2002-06-08 00:00:00	2002-06-08	2002-06-08 00:00:00	2002-06-08	581452		0	0	0		0	0	0	195813	0	52	40213296		
40615	3367	19078461	2010-10-10	2010-10-10 00:00:00	2010-10-24	2010-10-24 00:00:00	2010-10-24	38000177		0	0	14		0	0	0	223284	0	310965	19078461		
160248	3527	40213160	1966-05-19	1966-05-19 00:00:00	1966-05-19	1966-05-19 00:00:00	1966-05-19	581452		0	0	0		0	0	0	234029	0	10	40213160		
175896	3866	40213201	2016-01-19	2016-01-19 00:00:00	2016-01-19	2016-01-19 00:00:00	2016-01-19	581452		0	0	0		0	0	0	256746	0	33	40213201		
229357	5041	40213227	2012-02-28	2012-02-28 00:00:00	2012-02-28	2012-02-28 00:00:00	2012-02-28	581452		0	0	0		0	0	0	334961	0	113	40213227		
220297	4835	40213160	1970-08-06	1970-08-06 00:00:00	1970-08-06	1970-08-06 00:00:00	1970-08-06	581452		0	0	0		0	0	0	321658	0	10	40213160		
187286	4113	40213296	2000-06-05	2000-06-05 00:00:00	2000-06-05	2000-06-05 00:00:00	2000-06-05	581452		0	0	0		0	0	0	273416	0	52	40213296		
61365	5104	19019979	1988-07-31	1988-07-31 00:00:00	1988-08-21	1988-08-21 00:00:00	1988-08-21	38000177		0	0	21		0	0	0	339184	0	198405	19019979		
53556	4452	920300	1978-07-10	1978-07-10 00:00:00	1978-07-17	1978-07-17 00:00:00	1978-07-17	38000177		0	0	7		0	0	0	296248	0	311989	920300		
240446	5278	40213160	1974-04-19	1974-04-19 00:00:00	1974-04-19	1974-04-19 00:00:00	1974-04-19	581452		0	0	0		0	0	0	351088	0	10	40213160		
62338	5190	19078461	1988-01-20	1988-01-20 00:00:00	1988-02-03	1988-02-03 00:00:00	1988-02-03	38000177		0	0	14		0	0	0	345053	0	310965	19078461		
181572	3989	40213201	1994-02-21	1994-02-21 00:00:00	1994-02-21	1994-02-21 00:00:00	1994-02-21	581452		0	0	0		0	0	0	265224	0	33	40213201		
212733	4665	40213314	1981-11-21	1981-11-21 00:00:00	1981-11-21	1981-11-21 00:00:00	1981-11-21	581452		0	0	0		0	0	0	310905	0	49	40213314		
119665	2631	40213198	2016-10-23	2016-10-23 00:00:00	2016-10-23	2016-10-23 00:00:00	2016-10-23	581452		0	0	0		0	0	0	174038	0	133	40213198		
145327	3195	40213227	2000-08-14	2000-08-14 00:00:00	2000-08-14	2000-08-14 00:00:00	2000-08-14	581452		0	0	0		0	0	0	212537	0	113	40213227		
149103	3279	40213227	1996-10-08	1996-10-08 00:00:00	1996-10-08	1996-10-08 00:00:00	1996-10-08	581452		0	0	0		0	0	0	217821	0	113	40213227		
7603	163	40213227	2008-09-16	2008-09-16 00:00:00	2008-09-16	2008-09-16 00:00:00	2008-09-16	581452		0	0	0		0	0	0	11212	0	113	40213227		
31126	2580	920300	1980-07-05	1980-07-05 00:00:00	1980-07-12	1980-07-12 00:00:00	1980-07-12	38000177		0	0	7		0	0	0	170908	0	311989	920300		
70166	1535	40213227	2009-09-14	2009-09-14 00:00:00	2009-09-14	2009-09-14 00:00:00	2009-09-14	581452		0	0	0		0	0	0	102737	0	113	40213227		
106929	2344	40213160	1966-11-21	1966-11-21 00:00:00	1966-11-21	1966-11-21 00:00:00	1966-11-21	581452		0	0	0		0	0	0	156055	0	10	40213160		
73165	1599	40213227	2002-05-20	2002-05-20 00:00:00	2002-05-20	2002-05-20 00:00:00	2002-05-20	581452		0	0	0		0	0	0	107327	0	113	40213227		
25382	2087	40220960	2011-06-15	2011-06-15 00:00:00	2011-06-15	2011-06-15 00:00:00	2011-06-15	38000177		0	0	0		0	0	0	139063	0	1804799	40220960		
30559	2535	46233988	1970-10-11	1970-10-11 00:00:00	1970-11-08	1970-11-08 00:00:00	1970-11-08	38000177		0	0	28		0	0	0	167519	0	1652673	46233988		
14120	1180	1118084	1990-05-23	1990-05-23 00:00:00	1990-05-23	1990-05-23 00:00:00	\N	38000177		0	0	0		0	0	0	77925	0	00025152531	44923712		
3799	316	1127433	1987-03-23	1987-03-23 00:00:00	1987-04-13	1987-04-13 00:00:00	1987-04-13	38000177		0	0	21		0	0	0	20890	0	313782	1127433		
18592	1537	19059056	1960-08-12	1960-08-12 00:00:00	1960-08-26	1960-08-26 00:00:00	1960-08-26	38000177		0	0	14		0	0	0	102897	0	243670	19059056		
195604	4297	40213227	2015-02-21	2015-02-21 00:00:00	2015-02-21	2015-02-21 00:00:00	2015-02-21	581452		0	0	0		0	0	0	285174	0	113	40213227		
104427	2290	40213160	1957-01-05	1957-01-05 00:00:00	1957-01-05	1957-01-05 00:00:00	1957-01-05	581452		0	0	0		0	0	0	152321	0	10	40213160		
3464	287	1124300	2013-04-25	2013-04-25 00:00:00	2013-04-25	2013-04-25 00:00:00	\N	38000177		0	0	0		0	0	0	19209	0	00781178901	45011828		
51542	4283	19133905	1970-09-15	1970-09-15 00:00:00	1970-09-25	1970-09-25 00:00:00	1970-09-25	38000177		0	0	10		0	0	0	284236	0	834102	19133905		
207049	4543	40213227	2010-12-04	2010-12-04 00:00:00	2010-12-04	2010-12-04 00:00:00	2010-12-04	581452		0	0	0		0	0	0	302614	0	113	40213227		
63752	5298	19059056	1975-12-21	1975-12-21 00:00:00	1976-01-18	1976-01-18 00:00:00	1976-01-18	38000177		0	0	28		0	0	0	352436	0	243670	19059056		
117228	2576	40213160	1980-04-17	1980-04-17 00:00:00	1980-04-17	1980-04-17 00:00:00	1980-04-17	581452		0	0	0		0	0	0	170566	0	10	40213160		
53766	4471	19075601	2001-01-08	2001-01-08 00:00:00	2001-01-08	2001-01-08 00:00:00	2001-01-08	38000177		0	0	0		0	0	0	297427	0	309362	19075601		
61540	1345	40213296	2008-03-25	2008-03-25 00:00:00	2008-03-25	2008-03-25 00:00:00	2008-03-25	581452		0	0	0		0	0	0	89151	0	52	40213296		
224322	4924	40213227	2000-08-16	2000-08-16 00:00:00	2000-08-16	2000-08-16 00:00:00	2000-08-16	581452		0	0	0		0	0	0	327241	0	113	40213227		
80445	1760	40213314	1977-09-25	1977-09-25 00:00:00	1977-09-25	1977-09-25 00:00:00	1977-09-25	581452		0	0	0		0	0	0	117680	0	49	40213314		
172230	3786	40213227	1992-03-17	1992-03-17 00:00:00	1992-03-17	1992-03-17 00:00:00	1992-03-17	581452		0	0	0		0	0	0	251674	0	113	40213227		
225411	4949	40213160	1977-09-01	1977-09-01 00:00:00	1977-09-01	1977-09-01 00:00:00	1977-09-01	581452		0	0	0		0	0	0	329017	0	10	40213160		
59679	1306	40213227	2017-10-11	2017-10-11 00:00:00	2017-10-11	2017-10-11 00:00:00	2017-10-11	581452		0	0	0		0	0	0	86237	0	113	40213227		
232029	5099	40213201	2009-06-06	2009-06-06 00:00:00	2009-06-06	2009-06-06 00:00:00	2009-06-06	581452		0	0	0		0	0	0	338817	0	33	40213201		
56928	4724	1713671	1977-03-31	1977-03-31 00:00:00	1977-04-14	1977-04-14 00:00:00	1977-04-14	38000177		0	0	14		0	0	0	314770	0	562251	1713671		
56513	4689	19078461	2014-03-06	2014-03-06 00:00:00	2014-03-28	2014-03-28 00:00:00	2014-03-28	38000177		0	0	22		0	0	0	312395	0	310965	19078461		
234124	5144	40213227	2019-03-23	2019-03-23 00:00:00	2019-03-23	2019-03-23 00:00:00	2019-03-23	581452		0	0	0		0	0	0	\N	0	113	40213227		
10434	870	19059056	1963-07-20	1963-07-20 00:00:00	1963-08-03	1963-08-03 00:00:00	1963-08-03	38000177		0	0	14		0	0	0	57866	0	243670	19059056		
134092	2944	40213306	1981-09-13	1981-09-13 00:00:00	1981-09-13	1981-09-13 00:00:00	1981-09-13	581452		0	0	0		0	0	0	196421	0	43	40213306		
169132	3719	40213306	1985-05-21	1985-05-21 00:00:00	1985-05-21	1985-05-21 00:00:00	1985-05-21	581452		0	0	0		0	0	0	247228	0	43	40213306		
126335	2779	40213306	1993-05-16	1993-05-16 00:00:00	1993-05-16	1993-05-16 00:00:00	1993-05-16	581452		0	0	0		0	0	0	184187	0	43	40213306		
116842	2567	40213314	1977-12-31	1977-12-31 00:00:00	1977-12-31	1977-12-31 00:00:00	1977-12-31	581452		0	0	0		0	0	0	170086	0	49	40213314		
11860	987	1127433	2018-05-15	2018-05-15 00:00:00	2018-05-29	2018-05-29 00:00:00	2018-05-29	38000177		0	0	14		0	0	0	65602	0	313782	1127433		
63292	1384	40213227	2004-10-05	2004-10-05 00:00:00	2004-10-05	2004-10-05 00:00:00	2004-10-05	581452		0	0	0		0	0	0	91763	0	113	40213227		
226564	4975	40213296	2001-12-06	2001-12-06 00:00:00	2001-12-06	2001-12-06 00:00:00	2001-12-06	581452		0	0	0		0	0	0	\N	0	52	40213296		
133702	2936	40213260	2013-03-23	2013-03-23 00:00:00	2013-03-23	2013-03-23 00:00:00	2013-03-23	581452		0	0	0		0	0	0	195806	0	121	40213260		
40616	3367	40229134	1965-12-19	1965-12-19 00:00:00	1966-01-02	1966-01-02 00:00:00	1966-01-02	38000177		0	0	14		0	0	0	223299	0	1043400	40229134		
56401	1235	40213160	1980-05-05	1980-05-05 00:00:00	1980-05-05	1980-05-05 00:00:00	1980-05-05	581452		0	0	0		0	0	0	81331	0	10	40213160		
153129	3371	40213160	1976-04-23	1976-04-23 00:00:00	1976-04-23	1976-04-23 00:00:00	1976-04-23	581452		0	0	0		0	0	0	223643	0	10	40213160		
229358	5041	40213296	2012-02-28	2012-02-28 00:00:00	2012-02-28	2012-02-28 00:00:00	2012-02-28	581452		0	0	0		0	0	0	334961	0	52	40213296		
220301	4835	40213160	1971-01-06	1971-01-06 00:00:00	1971-01-06	1971-01-06 00:00:00	1971-01-06	581452		0	0	0		0	0	0	321645	0	10	40213160		
187288	4113	40213160	1958-09-22	1958-09-22 00:00:00	1958-09-22	1958-09-22 00:00:00	1958-09-22	581452		0	0	0		0	0	0	273423	0	10	40213160		
61366	5104	19019979	1986-05-29	1986-05-29 00:00:00	1986-06-12	1986-06-12 00:00:00	1986-06-12	38000177		0	0	14		0	0	0	339182	0	198405	19019979		
53557	4452	40236824	1978-07-10	1978-07-10 00:00:00	1978-07-17	1978-07-17 00:00:00	1978-07-17	38000177		0	0	7		0	0	0	296248	0	1094107	40236824		
240452	5278	40213160	1969-08-15	1969-08-15 00:00:00	1969-08-15	1969-08-15 00:00:00	1969-08-15	581452		0	0	0		0	0	0	351056	0	10	40213160		
62339	5190	1713671	1962-02-23	1962-02-23 00:00:00	1962-03-09	1962-03-09 00:00:00	1962-03-09	38000177		0	0	14		0	0	0	344972	0	562251	1713671		
181574	3989	40213227	1992-03-30	1992-03-30 00:00:00	1992-03-30	1992-03-30 00:00:00	1992-03-30	581452		0	0	0		0	0	0	265208	0	113	40213227		
212734	4665	40213160	1981-11-21	1981-11-21 00:00:00	1981-11-21	1981-11-21 00:00:00	1981-11-21	581452		0	0	0		0	0	0	310905	0	10	40213160		
119672	2631	40213227	2002-05-19	2002-05-19 00:00:00	2002-05-19	2002-05-19 00:00:00	2002-05-19	581452		0	0	0		0	0	0	174097	0	113	40213227		
145330	3195	40213201	2014-12-15	2014-12-15 00:00:00	2014-12-15	2014-12-15 00:00:00	2014-12-15	581452		0	0	0		0	0	0	212531	0	33	40213201		
95199	2087	40213227	1992-05-27	1992-05-27 00:00:00	1992-05-27	1992-05-27 00:00:00	1992-05-27	581452		0	0	0		0	0	0	139156	0	113	40213227		
7604	163	40213296	2008-09-16	2008-09-16 00:00:00	2008-09-16	2008-09-16 00:00:00	2008-09-16	581452		0	0	0		0	0	0	11212	0	52	40213296		
31127	2580	19128065	1977-05-10	1977-05-10 00:00:00	1978-05-05	1978-05-05 00:00:00	1978-05-05	38000177		0	0	360		0	0	0	170869	0	749882	19128065		
70168	1535	40213296	2018-04-09	2018-04-09 00:00:00	2018-04-09	2018-04-09 00:00:00	2018-04-09	581452		0	0	0		0	0	0	102722	0	52	40213296		
106940	2344	40213227	2008-03-24	2008-03-24 00:00:00	2008-03-24	2008-03-24 00:00:00	2008-03-24	581452		0	0	0		0	0	0	156076	0	113	40213227		
73167	1599	40213227	1994-12-26	1994-12-26 00:00:00	1994-12-26	1994-12-26 00:00:00	1994-12-26	581452		0	0	0		0	0	0	107307	0	113	40213227		
25383	2087	40220960	2016-08-03	2016-08-03 00:00:00	2016-08-03	2016-08-03 00:00:00	2016-08-03	38000177		0	0	0		0	0	0	139131	0	1804799	40220960		
30560	2535	19133873	1962-10-08	1962-10-08 00:00:00	1962-10-16	1962-10-16 00:00:00	1962-10-16	38000177		0	0	8		0	0	0	167489	0	834061	19133873		
14121	1180	19059056	1968-01-09	1968-01-09 00:00:00	1968-02-06	1968-02-06 00:00:00	1968-02-06	38000177		0	0	28		0	0	0	77960	0	243670	19059056		
3800	316	1115171	2014-02-20	2014-02-20 00:00:00	2014-03-06	2014-03-06 00:00:00	2014-03-06	38000177		0	0	14		0	0	0	20985	0	849574	1115171		
29051	2404	1127433	1998-08-10	1998-08-10 00:00:00	1998-08-31	1998-08-31 00:00:00	1998-08-31	38000177		0	0	21		0	0	0	159763	0	313782	1127433		
195605	4297	40213296	2015-02-21	2015-02-21 00:00:00	2015-02-21	2015-02-21 00:00:00	2015-02-21	581452		0	0	0		0	0	0	285174	0	52	40213296		
104428	2290	40213160	1957-06-08	1957-06-08 00:00:00	1957-06-08	1957-06-08 00:00:00	1957-06-08	581452		0	0	0		0	0	0	152364	0	10	40213160		
53375	4436	1713671	1970-12-03	1970-12-03 00:00:00	1970-12-24	1970-12-24 00:00:00	1970-12-24	38000177		0	0	21		0	0	0	294874	0	562251	1713671		
51543	4283	19133905	1990-09-11	1990-09-11 00:00:00	1990-09-24	1990-09-24 00:00:00	1990-09-24	38000177		0	0	13		0	0	0	284263	0	834102	19133905		
207058	4543	40213160	1980-02-16	1980-02-16 00:00:00	1980-02-16	1980-02-16 00:00:00	1980-02-16	581452		0	0	0		0	0	0	302609	0	10	40213160		
63753	5298	40229134	1942-03-20	1942-03-20 00:00:00	1942-04-03	1942-04-03 00:00:00	1942-04-03	38000177		0	0	14		0	0	0	352441	0	1043400	40229134		
117238	2577	40213227	2005-02-19	2005-02-19 00:00:00	2005-02-19	2005-02-19 00:00:00	2005-02-19	581452		0	0	0		0	0	0	170668	0	113	40213227		
53767	4471	40229134	1963-11-14	1963-11-14 00:00:00	1963-11-21	1963-11-21 00:00:00	1963-11-21	38000177		0	0	7		0	0	0	297444	0	1043400	40229134		
61542	1345	40213227	2008-03-25	2008-03-25 00:00:00	2008-03-25	2008-03-25 00:00:00	2008-03-25	581452		0	0	0		0	0	0	89151	0	113	40213227		
224323	4924	40213306	2000-08-16	2000-08-16 00:00:00	2000-08-16	2000-08-16 00:00:00	2000-08-16	581452		0	0	0		0	0	0	327241	0	43	40213306		
80447	1760	40213296	2017-07-09	2017-07-09 00:00:00	2017-07-09	2017-07-09 00:00:00	2017-07-09	581452		0	0	0		0	0	0	117659	0	52	40213296		
172244	3786	40213160	1959-08-18	1959-08-18 00:00:00	1959-08-18	1959-08-18 00:00:00	1959-08-18	581452		0	0	0		0	0	0	251720	0	10	40213160		
225414	4949	40213296	2012-09-27	2012-09-27 00:00:00	2012-09-27	2012-09-27 00:00:00	2012-09-27	581452		0	0	0		0	0	0	329008	0	52	40213296		
59680	1306	40213227	1999-06-16	1999-06-16 00:00:00	1999-06-16	1999-06-16 00:00:00	1999-06-16	581452		0	0	0		0	0	0	86175	0	113	40213227		
220863	4847	40213227	2005-02-16	2005-02-16 00:00:00	2005-02-16	2005-02-16 00:00:00	2005-02-16	581452		0	0	0		0	0	0	322458	0	113	40213227		
56929	4724	1124300	1977-12-14	1977-12-14 00:00:00	1977-12-14	1977-12-14 00:00:00	\N	38000177		0	0	0		0	0	0	314770	0	00781178901	45011828		
56514	4689	1713671	1986-03-22	1986-03-22 00:00:00	1986-04-12	1986-04-12 00:00:00	1986-04-12	38000177		0	0	21		0	0	0	312442	0	562251	1713671		
234129	5144	40213227	2008-08-23	2008-08-23 00:00:00	2008-08-23	2008-08-23 00:00:00	2008-08-23	581452		0	0	0		0	0	0	341939	0	113	40213227		
10435	870	1127433	1975-10-08	1975-10-08 00:00:00	1975-10-15	1975-10-15 00:00:00	1975-10-15	38000177		0	0	7		0	0	0	57908	0	313782	1127433		
134096	2944	40213227	2002-01-13	2002-01-13 00:00:00	2002-01-13	2002-01-13 00:00:00	2002-01-13	581452		0	0	0		0	0	0	196389	0	113	40213227		
169135	3719	40213306	1986-11-25	1986-11-25 00:00:00	1986-11-25	1986-11-25 00:00:00	1986-11-25	581452		0	0	0		0	0	0	247178	0	43	40213306		
126338	2779	40213227	2012-11-25	2012-11-25 00:00:00	2012-11-25	2012-11-25 00:00:00	2012-11-25	581452		0	0	0		0	0	0	184208	0	113	40213227		
116843	2567	40213160	1976-01-03	1976-01-03 00:00:00	1976-01-03	1976-01-03 00:00:00	1976-01-03	581452		0	0	0		0	0	0	170071	0	10	40213160		
11861	987	1127433	1970-09-29	1970-09-29 00:00:00	1970-10-13	1970-10-13 00:00:00	1970-10-13	38000177		0	0	14		0	0	0	65597	0	313782	1127433		
63293	1384	40213306	2004-10-05	2004-10-05 00:00:00	2004-10-05	2004-10-05 00:00:00	2004-10-05	581452		0	0	0		0	0	0	91763	0	43	40213306		
226566	4975	40213296	2000-06-22	2000-06-22 00:00:00	2000-06-22	2000-06-22 00:00:00	2000-06-22	581452		0	0	0		0	0	0	330893	0	52	40213296		
133704	2936	40213306	1984-12-29	1984-12-29 00:00:00	1984-12-29	1984-12-29 00:00:00	1984-12-29	581452		0	0	0		0	0	0	195809	0	43	40213306		
40617	3367	19059056	1968-02-06	1968-02-06 00:00:00	1968-02-20	1968-02-20 00:00:00	1968-02-20	38000177		0	0	14		0	0	0	223332	0	243670	19059056		
56403	1235	40213160	1976-02-02	1976-02-02 00:00:00	1976-02-02	1976-02-02 00:00:00	1976-02-02	581452		0	0	0		0	0	0	81352	0	10	40213160		
153135	3371	40213227	2016-09-09	2016-09-09 00:00:00	2016-09-09	2016-09-09 00:00:00	2016-09-09	581452		0	0	0		0	0	0	223664	0	113	40213227		
229360	5041	40213227	1993-01-26	1993-01-26 00:00:00	1993-01-26	1993-01-26 00:00:00	1993-01-26	581452		0	0	0		0	0	0	334959	0	113	40213227		
220304	4835	40213160	1975-04-10	1975-04-10 00:00:00	1975-04-10	1975-04-10 00:00:00	1975-04-10	581452		0	0	0		0	0	0	321625	0	10	40213160		
187290	4113	40213160	1963-03-25	1963-03-25 00:00:00	1963-03-25	1963-03-25 00:00:00	1963-03-25	581452		0	0	0		0	0	0	273411	0	10	40213160		
96743	2122	40213227	2007-07-14	2007-07-14 00:00:00	2007-07-14	2007-07-14 00:00:00	2007-07-14	581452		0	0	0		0	0	0	141211	0	113	40213227		
53558	4452	1124300	1996-11-14	1996-11-14 00:00:00	1996-11-14	1996-11-14 00:00:00	\N	38000177		0	0	0		0	0	0	296268	0	00781178901	45011828		
240455	5278	40213160	1969-10-17	1969-10-17 00:00:00	1969-10-17	1969-10-17 00:00:00	1969-10-17	581452		0	0	0		0	0	0	351084	0	10	40213160		
62340	5190	1127433	1993-04-20	1993-04-20 00:00:00	1993-05-04	1993-05-04 00:00:00	1993-05-04	38000177		0	0	14		0	0	0	344977	0	313782	1127433		
170047	3739	40213260	2018-03-05	2018-03-05 00:00:00	2018-03-05	2018-03-05 00:00:00	2018-03-05	581452		0	0	0		0	0	0	248420	0	121	40213260		
120525	2649	40213227	2008-12-22	2008-12-22 00:00:00	2008-12-22	2008-12-22 00:00:00	2008-12-22	581452		0	0	0		0	0	0	175317	0	113	40213227		
119679	2631	40213160	1955-04-17	1955-04-17 00:00:00	1955-04-17	1955-04-17 00:00:00	1955-04-17	581452		0	0	0		0	0	0	174059	0	10	40213160		
145333	3195	40213198	2013-12-09	2013-12-09 00:00:00	2013-12-09	2013-12-09 00:00:00	2013-12-09	581452		0	0	0		0	0	0	212584	0	133	40213198		
156646	3446	40213227	1995-08-07	1995-08-07 00:00:00	1995-08-07	1995-08-07 00:00:00	1995-08-07	581452		0	0	0		0	0	0	228821	0	113	40213227		
7606	163	40213160	1966-10-04	1966-10-04 00:00:00	1966-10-04	1966-10-04 00:00:00	1966-10-04	581452		0	0	0		0	0	0	11181	0	10	40213160		
31128	2580	1127433	2015-08-21	2015-08-21 00:00:00	2015-08-28	2015-08-28 00:00:00	2015-08-28	38000177		0	0	7		0	0	0	170868	0	313782	1127433		
81446	1780	40213227	2007-06-26	2007-06-26 00:00:00	2007-06-26	2007-06-26 00:00:00	2007-06-26	581452		0	0	0		0	0	0	119173	0	113	40213227		
106941	2344	40213296	2008-03-24	2008-03-24 00:00:00	2008-03-24	2008-03-24 00:00:00	2008-03-24	581452		0	0	0		0	0	0	156076	0	52	40213296		
73174	1599	40213160	1960-08-15	1960-08-15 00:00:00	1960-08-15	1960-08-15 00:00:00	1960-08-15	581452		0	0	0		0	0	0	107296	0	10	40213160		
25384	2087	19078461	2015-01-03	2015-01-03 00:00:00	2015-04-03	2015-04-03 00:00:00	2015-04-03	38000177		0	0	90		0	0	0	139105	0	310965	19078461		
30561	2535	40229134	1979-02-28	1979-02-28 00:00:00	1979-03-14	1979-03-14 00:00:00	1979-03-14	38000177		0	0	14		0	0	0	167552	0	1043400	40229134		
14122	1180	40229134	1961-03-18	1961-03-18 00:00:00	1961-03-25	1961-03-25 00:00:00	1961-03-25	38000177		0	0	7		0	0	0	77894	0	1043400	40229134		
3801	316	1124300	1962-09-12	1962-09-12 00:00:00	1962-09-12	1962-09-12 00:00:00	\N	38000177		0	0	0		0	0	0	20909	0	00781178901	45011828		
29052	2404	19059056	1968-01-06	1968-01-06 00:00:00	1968-01-20	1968-01-20 00:00:00	1968-01-20	38000177		0	0	14		0	0	0	159770	0	243670	19059056		
195609	4297	40213227	1995-03-18	1995-03-18 00:00:00	1995-03-18	1995-03-18 00:00:00	1995-03-18	581452		0	0	0		0	0	0	285156	0	113	40213227		
104441	2290	40213296	1998-06-27	1998-06-27 00:00:00	1998-06-27	1998-06-27 00:00:00	1998-06-27	581452		0	0	0		0	0	0	152350	0	52	40213296		
53376	4436	40162522	2017-06-29	2017-06-29 00:00:00	2017-06-29	2017-06-29 00:00:00	\N	38000177		0	0	0		0	0	0	294884	0	857005	40162522		
51546	4283	19059056	1956-12-20	1956-12-20 00:00:00	1957-03-20	1957-03-20 00:00:00	1957-03-20	38000177		0	0	90		0	0	0	284279	0	243670	19059056		
207059	4543	40213314	1980-02-16	1980-02-16 00:00:00	1980-02-16	1980-02-16 00:00:00	1980-02-16	581452		0	0	0		0	0	0	302609	0	49	40213314		
63754	5298	1713671	1988-03-15	1988-03-15 00:00:00	1988-03-29	1988-03-29 00:00:00	1988-03-29	38000177		0	0	14		0	0	0	352413	0	562251	1713671		
117243	2577	40213160	1974-01-19	1974-01-19 00:00:00	1974-01-19	1974-01-19 00:00:00	1974-01-19	581452		0	0	0		0	0	0	170644	0	10	40213160		
53768	4471	19008572	1984-07-13	1984-07-13 00:00:00	1984-07-13	1984-07-13 00:00:00	\N	38000177		0	0	0		0	0	0	297453	0	106258	19008572		
61543	1345	40213296	2006-03-21	2006-03-21 00:00:00	2006-03-21	2006-03-21 00:00:00	2006-03-21	581452		0	0	0		0	0	0	89164	0	52	40213296		
224326	4924	40213314	1978-05-24	1978-05-24 00:00:00	1978-05-24	1978-05-24 00:00:00	1978-05-24	581452		0	0	0		0	0	0	327280	0	49	40213314		
80450	1760	40213160	1978-02-26	1978-02-26 00:00:00	1978-02-26	1978-02-26 00:00:00	1978-02-26	581452		0	0	0		0	0	0	117681	0	10	40213160		
73533	1606	40213227	2011-03-07	2011-03-07 00:00:00	2011-03-07	2011-03-07 00:00:00	2011-03-07	581452		0	0	0		0	0	0	107841	0	113	40213227		
225419	4949	40213227	2003-12-04	2003-12-04 00:00:00	2003-12-04	2003-12-04 00:00:00	2003-12-04	581452		0	0	0		0	0	0	329020	0	113	40213227		
59681	1306	40213296	1999-06-16	1999-06-16 00:00:00	1999-06-16	1999-06-16 00:00:00	1999-06-16	581452		0	0	0		0	0	0	86175	0	52	40213296		
220882	4847	40213227	2015-04-08	2015-04-08 00:00:00	2015-04-08	2015-04-08 00:00:00	2015-04-08	581452		0	0	0		0	0	0	322421	0	113	40213227		
56930	4724	1713671	1971-05-17	1971-05-17 00:00:00	1971-06-07	1971-06-07 00:00:00	1971-06-07	38000177		0	0	21		0	0	0	314681	0	562251	1713671		
56515	4689	19078461	2017-02-09	2017-02-09 00:00:00	2017-04-11	2017-04-11 00:00:00	2017-04-11	38000177		0	0	61		0	0	0	312396	0	310965	19078461		
3782	82	40213227	2012-05-15	2012-05-15 00:00:00	2012-05-15	2012-05-15 00:00:00	2012-05-15	581452		0	0	0		0	0	0	5601	0	113	40213227		
10436	870	1127078	1965-12-01	1965-12-01 00:00:00	1965-12-15	1965-12-15 00:00:00	1965-12-15	38000177		0	0	14		0	0	0	57867	0	282464	1127078		
134097	2944	40213296	2002-01-13	2002-01-13 00:00:00	2002-01-13	2002-01-13 00:00:00	2002-01-13	581452		0	0	0		0	0	0	196389	0	52	40213296		
169144	3719	40213160	1963-06-18	1963-06-18 00:00:00	1963-06-18	1963-06-18 00:00:00	1963-06-18	581452		0	0	0		0	0	0	247153	0	10	40213160		
126339	2779	40213296	2012-11-25	2012-11-25 00:00:00	2012-11-25	2012-11-25 00:00:00	2012-11-25	581452		0	0	0		0	0	0	184208	0	52	40213296		
116844	2567	40213160	1975-11-01	1975-11-01 00:00:00	1975-11-01	1975-11-01 00:00:00	1975-11-01	581452		0	0	0		0	0	0	170085	0	10	40213160		
11862	987	1127433	1954-01-28	1954-01-28 00:00:00	1954-02-11	1954-02-11 00:00:00	1954-02-11	38000177		0	0	14		0	0	0	65598	0	313782	1127433		
63294	1384	40213314	1982-06-22	1982-06-22 00:00:00	1982-06-22	1982-06-22 00:00:00	1982-06-22	581452		0	0	0		0	0	0	91739	0	49	40213314		
226568	4975	40213160	1964-06-18	1964-06-18 00:00:00	1964-06-18	1964-06-18 00:00:00	1964-06-18	581452		0	0	0		0	0	0	330898	0	10	40213160		
133706	2936	40213160	1962-09-08	1962-09-08 00:00:00	1962-09-08	1962-09-08 00:00:00	1962-09-08	581452		0	0	0		0	0	0	195759	0	10	40213160		
40618	3367	1127433	2000-08-18	2000-08-18 00:00:00	2000-08-25	2000-08-25 00:00:00	2000-08-25	38000177		0	0	7		0	0	0	223309	0	313782	1127433		
56405	1235	40213296	2015-06-01	2015-06-01 00:00:00	2015-06-01	2015-06-01 00:00:00	2015-06-01	581452		0	0	0		0	0	0	81347	0	52	40213296		
153136	3371	40213296	2016-09-09	2016-09-09 00:00:00	2016-09-09	2016-09-09 00:00:00	2016-09-09	581452		0	0	0		0	0	0	223664	0	52	40213296		
229361	5041	40213306	1993-01-26	1993-01-26 00:00:00	1993-01-26	1993-01-26 00:00:00	1993-01-26	581452		0	0	0		0	0	0	334959	0	43	40213306		
167615	3686	40213160	1972-10-02	1972-10-02 00:00:00	1972-10-02	1972-10-02 00:00:00	1972-10-02	581452		0	0	0		0	0	0	\N	0	10	40213160		
187291	4113	40213160	1958-07-14	1958-07-14 00:00:00	1958-07-14	1958-07-14 00:00:00	1958-07-14	581452		0	0	0		0	0	0	273431	0	10	40213160		
96751	2122	40213227	1996-05-25	1996-05-25 00:00:00	1996-05-25	1996-05-25 00:00:00	1996-05-25	581452		0	0	0		0	0	0	141227	0	113	40213227		
53560	4452	19059056	1971-05-15	1971-05-15 00:00:00	1971-05-29	1971-05-29 00:00:00	1971-05-29	38000177		0	0	14		0	0	0	296344	0	243670	19059056		
240458	5278	40213160	1970-01-16	1970-01-16 00:00:00	1970-01-16	1970-01-16 00:00:00	1970-01-16	581452		0	0	0		0	0	0	351057	0	10	40213160		
62341	5190	19073188	1993-04-20	1993-04-20 00:00:00	1993-05-04	1993-05-04 00:00:00	1993-05-04	38000177		0	0	14		0	0	0	344977	0	308192	19073188		
84005	1837	40213160	1960-10-21	1960-10-21 00:00:00	1960-10-21	1960-10-21 00:00:00	1960-10-21	581452		0	0	0		0	0	0	122720	0	10	40213160		
120526	2649	40213260	2008-12-22	2008-12-22 00:00:00	2008-12-22	2008-12-22 00:00:00	2008-12-22	581452		0	0	0		0	0	0	175317	0	121	40213260		
119688	2631	40213160	1956-04-22	1956-04-22 00:00:00	1956-04-22	1956-04-22 00:00:00	1956-04-22	581452		0	0	0		0	0	0	174076	0	10	40213160		
145340	3195	40213227	1992-07-20	1992-07-20 00:00:00	1992-07-20	1992-07-20 00:00:00	1992-07-20	581452		0	0	0		0	0	0	212536	0	113	40213227		
156659	3446	40213227	2015-10-12	2015-10-12 00:00:00	2015-10-12	2015-10-12 00:00:00	2015-10-12	581452		0	0	0		0	0	0	228802	0	113	40213227		
7618	163	40213160	1967-03-07	1967-03-07 00:00:00	1967-03-07	1967-03-07 00:00:00	1967-03-07	581452		0	0	0		0	0	0	11195	0	10	40213160		
31129	2580	40229134	1991-10-03	1991-10-03 00:00:00	1991-10-10	1991-10-10 00:00:00	1991-10-10	38000177		0	0	7		0	0	0	170882	0	1043400	40229134		
81447	1780	40213296	2007-06-26	2007-06-26 00:00:00	2007-06-26	2007-06-26 00:00:00	2007-06-26	581452		0	0	0		0	0	0	119173	0	52	40213296		
106945	2344	40213160	1970-11-30	1970-11-30 00:00:00	1970-11-30	1970-11-30 00:00:00	1970-11-30	581452		0	0	0		0	0	0	156037	0	10	40213160		
73177	1599	40213227	2011-05-16	2011-05-16 00:00:00	2011-05-16	2011-05-16 00:00:00	2011-05-16	581452		0	0	0		0	0	0	107346	0	113	40213227		
25385	2087	19059056	1989-04-19	1989-04-19 00:00:00	1989-07-18	1989-07-18 00:00:00	1989-07-18	38000177		0	0	90		0	0	0	139103	0	243670	19059056		
30562	2535	40229134	1998-10-26	1998-10-26 00:00:00	1998-11-02	1998-11-02 00:00:00	1998-11-02	38000177		0	0	7		0	0	0	167495	0	1043400	40229134		
163593	3598	40213227	2005-04-03	2005-04-03 00:00:00	2005-04-03	2005-04-03 00:00:00	2005-04-03	581452		0	0	0		0	0	0	238976	0	113	40213227		
3802	316	40231925	1975-12-21	1975-12-21 00:00:00	1975-12-21	1975-12-21 00:00:00	\N	38000177		0	0	0		0	0	0	20892	0	1049221	40231925		
29053	2404	19129655	1968-01-06	1968-01-06 00:00:00	1968-01-20	1968-01-20 00:00:00	1968-01-20	38000177		0	0	14		0	0	0	159770	0	789980	19129655		
195610	4297	40213306	1995-03-18	1995-03-18 00:00:00	1995-03-18	1995-03-18 00:00:00	1995-03-18	581452		0	0	0		0	0	0	285156	0	43	40213306		
104443	2290	40213227	1998-06-27	1998-06-27 00:00:00	1998-06-27	1998-06-27 00:00:00	1998-06-27	581452		0	0	0		0	0	0	152350	0	113	40213227		
53377	4436	43012036	1984-06-17	1984-06-17 00:00:00	1984-06-17	1984-06-17 00:00:00	\N	38000177		0	0	0		0	0	0	294875	0	1363309	43012036		
51547	4283	1127433	1981-12-29	1981-12-29 00:00:00	1982-01-12	1982-01-12 00:00:00	1982-01-12	38000177		0	0	14		0	0	0	284231	0	313782	1127433		
207061	4543	40213160	1980-05-17	1980-05-17 00:00:00	1980-05-17	1980-05-17 00:00:00	1980-05-17	581452		0	0	0		0	0	0	302580	0	10	40213160		
63755	5298	1127433	2013-07-29	2013-07-29 00:00:00	2013-08-05	2013-08-05 00:00:00	2013-08-05	38000177		0	0	7		0	0	0	352464	0	313782	1127433		
111814	2456	40213296	1998-10-18	1998-10-18 00:00:00	1998-10-18	1998-10-18 00:00:00	1998-10-18	581452		0	0	0		0	0	0	162808	0	52	40213296		
53769	4471	19059056	1963-03-28	1963-03-28 00:00:00	1963-04-11	1963-04-11 00:00:00	1963-04-11	38000177		0	0	14		0	0	0	297435	0	243670	19059056		
61547	1345	40213306	1988-10-04	1988-10-04 00:00:00	1988-10-04	1988-10-04 00:00:00	1988-10-04	581452		0	0	0		0	0	0	89115	0	43	40213306		
224327	4924	40213160	1978-05-24	1978-05-24 00:00:00	1978-05-24	1978-05-24 00:00:00	1978-05-24	581452		0	0	0		0	0	0	327280	0	10	40213160		
80451	1760	40213251	1984-04-01	1984-04-01 00:00:00	1984-04-01	1984-04-01 00:00:00	1984-04-01	581452		0	0	0		0	0	0	117667	0	21	40213251		
73540	1606	40213227	1992-04-20	1992-04-20 00:00:00	1992-04-20	1992-04-20 00:00:00	1992-04-20	581452		0	0	0		0	0	0	107882	0	113	40213227		
225423	4949	40213160	1972-12-28	1972-12-28 00:00:00	1972-12-28	1972-12-28 00:00:00	1972-12-28	581452		0	0	0		0	0	0	329053	0	10	40213160		
1979	43	40213227	2008-08-25	2008-08-25 00:00:00	2008-08-25	2008-08-25 00:00:00	2008-08-25	581452		0	0	0		0	0	0	3171	0	113	40213227		
56931	4724	19006318	1946-11-26	1946-11-26 00:00:00	1946-12-10	1946-12-10 00:00:00	1946-12-10	38000177		0	0	14		0	0	0	314800	0	105078	19006318		
56516	4689	1127433	1981-07-27	1981-07-27 00:00:00	1981-08-03	1981-08-03 00:00:00	1981-08-03	38000177		0	0	7		0	0	0	312441	0	313782	1127433		
3783	82	40213260	2012-05-15	2012-05-15 00:00:00	2012-05-15	2012-05-15 00:00:00	2012-05-15	581452		0	0	0		0	0	0	5601	0	121	40213260		
10438	870	40165015	1993-04-02	1993-04-02 00:00:00	1993-04-02	1993-04-02 00:00:00	\N	38000177		0	0	0		0	0	0	57849	0	861467	40165015		
134100	2944	40213260	2010-10-17	2010-10-17 00:00:00	2010-10-17	2010-10-17 00:00:00	2010-10-17	581452		0	0	0		0	0	0	196400	0	121	40213260		
169146	3719	40213160	1963-09-17	1963-09-17 00:00:00	1963-09-17	1963-09-17 00:00:00	1963-09-17	581452		0	0	0		0	0	0	247224	0	10	40213160		
126340	2779	40213160	1971-02-21	1971-02-21 00:00:00	1971-02-21	1971-02-21 00:00:00	1971-02-21	581452		0	0	0		0	0	0	184158	0	10	40213160		
228494	5018	40213227	1992-04-30	1992-04-30 00:00:00	1992-04-30	1992-04-30 00:00:00	1992-04-30	581452		0	0	0		0	0	0	333465	0	113	40213227		
11891	992	1127433	2009-12-25	2009-12-25 00:00:00	2010-03-25	2010-03-25 00:00:00	2010-03-25	38000177		0	0	90		0	0	0	65751	0	313782	1127433		
63295	1384	40213160	1982-06-22	1982-06-22 00:00:00	1982-06-22	1982-06-22 00:00:00	1982-06-22	581452		0	0	0		0	0	0	91739	0	10	40213160		
226569	4975	40213306	1983-06-02	1983-06-02 00:00:00	1983-06-02	1983-06-02 00:00:00	1983-06-02	581452		0	0	0		0	0	0	330890	0	43	40213306		
123855	2724	40213227	2016-04-24	2016-04-24 00:00:00	2016-04-24	2016-04-24 00:00:00	2016-04-24	581452		0	0	0		0	0	0	180519	0	113	40213227		
40619	3367	1124300	2002-10-10	2002-10-10 00:00:00	2002-10-10	2002-10-10 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00781178901	45011828		
153139	3371	40213160	1980-07-25	1980-07-25 00:00:00	1980-07-25	1980-07-25 00:00:00	1980-07-25	581452		0	0	0		0	0	0	223663	0	10	40213160		
229366	5041	40213160	1971-05-04	1971-05-04 00:00:00	1971-05-04	1971-05-04 00:00:00	1971-05-04	581452		0	0	0		0	0	0	334930	0	10	40213160		
167618	3686	40213306	1991-12-09	1991-12-09 00:00:00	1991-12-09	1991-12-09 00:00:00	1991-12-09	581452		0	0	0		0	0	0	245045	0	43	40213306		
210678	4621	40213296	2016-08-01	2016-08-01 00:00:00	2016-08-01	2016-08-01 00:00:00	2016-08-01	581452		0	0	0		0	0	0	307739	0	52	40213296		
96752	2122	40213306	1996-05-25	1996-05-25 00:00:00	1996-05-25	1996-05-25 00:00:00	1996-05-25	581452		0	0	0		0	0	0	141227	0	43	40213306		
53561	4452	19059056	1958-08-16	1958-08-16 00:00:00	1958-08-30	1958-08-30 00:00:00	1958-08-30	38000177		0	0	14		0	0	0	296342	0	243670	19059056		
240459	5278	40213260	2019-06-14	2019-06-14 00:00:00	2019-06-14	2019-06-14 00:00:00	2019-06-14	581452		0	0	0		0	0	0	351065	0	121	40213260		
62342	5190	1713671	1987-05-30	1987-05-30 00:00:00	1987-06-06	1987-06-06 00:00:00	1987-06-06	38000177		0	0	7		0	0	0	345042	0	562251	1713671		
84016	1837	40213160	1961-01-20	1961-01-20 00:00:00	1961-01-20	1961-01-20 00:00:00	1961-01-20	581452		0	0	0		0	0	0	122732	0	10	40213160		
101133	2217	40213227	2013-02-01	2013-02-01 00:00:00	2013-02-01	2013-02-01 00:00:00	2013-02-01	581452		0	0	0		0	0	0	147646	0	113	40213227		
119696	2631	40213227	1993-05-23	1993-05-23 00:00:00	1993-05-23	1993-05-23 00:00:00	1993-05-23	581452		0	0	0		0	0	0	174096	0	113	40213227		
192973	4239	40213201	2014-12-27	2014-12-27 00:00:00	2014-12-27	2014-12-27 00:00:00	2014-12-27	581452		0	0	0		0	0	0	281462	0	33	40213201		
85771	1878	40213306	1996-08-11	1996-08-11 00:00:00	1996-08-11	1996-08-11 00:00:00	1996-08-11	581452		0	0	0		0	0	0	\N	0	43	40213306		
7622	164	40213260	2017-05-22	2017-05-22 00:00:00	2017-05-22	2017-05-22 00:00:00	2017-05-22	581452		0	0	0		0	0	0	11277	0	121	40213260		
31131	2580	1127433	2005-05-13	2005-05-13 00:00:00	2005-05-20	2005-05-20 00:00:00	2005-05-20	38000177		0	0	7		0	0	0	170883	0	313782	1127433		
81453	1780	40213160	1966-02-22	1966-02-22 00:00:00	1966-02-22	1966-02-22 00:00:00	1966-02-22	581452		0	0	0		0	0	0	119099	0	10	40213160		
106947	2344	40213160	1966-08-22	1966-08-22 00:00:00	1966-08-22	1966-08-22 00:00:00	1966-08-22	581452		0	0	0		0	0	0	156044	0	10	40213160		
73178	1599	40213260	2011-05-16	2011-05-16 00:00:00	2011-05-16	2011-05-16 00:00:00	2011-05-16	581452		0	0	0		0	0	0	107346	0	121	40213260		
25386	2087	40231925	1989-04-19	1989-04-19 00:00:00	1989-04-19	1989-04-19 00:00:00	\N	38000177		0	0	0		0	0	0	139103	0	1049221	40231925		
30563	2535	40220960	2000-08-27	2000-08-27 00:00:00	2000-08-27	2000-08-27 00:00:00	2000-08-27	38000177		0	0	0		0	0	0	167496	0	1804799	40220960		
163597	3599	40213160	1967-01-13	1967-01-13 00:00:00	1967-01-13	1967-01-13 00:00:00	1967-01-13	581452		0	0	0		0	0	0	239056	0	10	40213160		
3803	316	1127433	1975-12-14	1975-12-14 00:00:00	1976-02-19	1976-02-19 00:00:00	1976-02-19	38000177		0	0	67		0	0	0	20889	0	313782	1127433		
29054	2404	1713671	1987-11-30	1987-11-30 00:00:00	1987-12-21	1987-12-21 00:00:00	1987-12-21	38000177		0	0	21		0	0	0	159772	0	562251	1713671		
195615	4297	40213160	1973-04-14	1973-04-14 00:00:00	1973-04-14	1973-04-14 00:00:00	1973-04-14	581452		0	0	0		0	0	0	285203	0	10	40213160		
104455	2291	40213260	2011-10-06	2011-10-06 00:00:00	2011-10-06	2011-10-06 00:00:00	2011-10-06	581452		0	0	0		0	0	0	152414	0	121	40213260		
53378	4437	19133873	1984-03-15	1984-03-15 00:00:00	1984-03-25	1984-03-25 00:00:00	1984-03-25	38000177		0	0	10		0	0	0	294942	0	834061	19133873		
51548	4284	1127433	1996-01-31	1996-01-31 00:00:00	1996-02-07	1996-02-07 00:00:00	1996-02-07	38000177		0	0	7		0	0	0	284330	0	313782	1127433		
207064	4543	40213160	1979-12-15	1979-12-15 00:00:00	1979-12-15	1979-12-15 00:00:00	1979-12-15	581452		0	0	0		0	0	0	302618	0	10	40213160		
63756	5298	19077572	2011-07-24	2011-07-24 00:00:00	2011-07-24	2011-07-24 00:00:00	\N	38000177		0	0	0		0	0	0	352403	0	310436	19077572		
23758	515	40213198	2010-02-06	2010-02-06 00:00:00	2010-02-06	2010-02-06 00:00:00	2010-02-06	581452		0	0	0		0	0	0	34399	0	133	40213198		
53770	4471	19129655	1963-03-28	1963-03-28 00:00:00	1963-04-11	1963-04-11 00:00:00	1963-04-11	38000177		0	0	14		0	0	0	297435	0	789980	19129655		
61550	1345	40213260	2017-04-04	2017-04-04 00:00:00	2017-04-04	2017-04-04 00:00:00	2017-04-04	581452		0	0	0		0	0	0	89153	0	121	40213260		
224332	4924	40213227	2011-06-08	2011-06-08 00:00:00	2011-06-08	2011-06-08 00:00:00	2011-06-08	581452		0	0	0		0	0	0	\N	0	113	40213227		
228027	5007	40213314	1983-07-03	1983-07-03 00:00:00	1983-07-03	1983-07-03 00:00:00	1983-07-03	581452		0	0	0		0	0	0	333013	0	49	40213314		
73541	1606	40213160	1955-12-19	1955-12-19 00:00:00	1955-12-19	1955-12-19 00:00:00	1955-12-19	581452		0	0	0		0	0	0	107787	0	10	40213160		
225425	4949	40213227	2014-10-02	2014-10-02 00:00:00	2014-10-02	2014-10-02 00:00:00	2014-10-02	581452		0	0	0		0	0	0	329022	0	113	40213227		
1980	43	40213260	2008-08-25	2008-08-25 00:00:00	2008-08-25	2008-08-25 00:00:00	2008-08-25	581452		0	0	0		0	0	0	3171	0	121	40213260		
56932	4724	19059056	1946-11-26	1946-11-26 00:00:00	1946-12-10	1946-12-10 00:00:00	1946-12-10	38000177		0	0	14		0	0	0	314800	0	243670	19059056		
56517	4689	1713671	1998-01-07	1998-01-07 00:00:00	1998-01-28	1998-01-28 00:00:00	1998-01-28	38000177		0	0	21		0	0	0	312431	0	562251	1713671		
3784	82	40213296	2003-04-01	2003-04-01 00:00:00	2003-04-01	2003-04-01 00:00:00	2003-04-01	581452		0	0	0		0	0	0	5599	0	52	40213296		
10439	870	1127433	1993-04-02	1993-04-02 00:00:00	1993-07-01	1993-07-01 00:00:00	1993-07-01	38000177		0	0	90		0	0	0	57849	0	313782	1127433		
17767	384	40213260	2012-03-05	2012-03-05 00:00:00	2012-03-05	2012-03-05 00:00:00	2012-03-05	581452		0	0	0		0	0	0	25325	0	121	40213260		
169151	3719	40213260	2014-01-14	2014-01-14 00:00:00	2014-01-14	2014-01-14 00:00:00	2014-01-14	581452		0	0	0		0	0	0	247230	0	121	40213260		
134240	2947	40213314	1978-04-25	1978-04-25 00:00:00	1978-04-25	1978-04-25 00:00:00	1978-04-25	581452		0	0	0		0	0	0	196685	0	49	40213314		
228496	5018	40213227	2011-09-15	2011-09-15 00:00:00	2011-09-15	2011-09-15 00:00:00	2011-09-15	581452		0	0	0		0	0	0	333556	0	113	40213227		
11892	992	40165015	2009-12-25	2009-12-25 00:00:00	2009-12-25	2009-12-25 00:00:00	\N	38000177		0	0	0		0	0	0	65751	0	861467	40165015		
63298	1384	40213314	1983-05-24	1983-05-24 00:00:00	1983-05-24	1983-05-24 00:00:00	1983-05-24	581452		0	0	0		0	0	0	91758	0	49	40213314		
226573	4975	40213160	1959-10-15	1959-10-15 00:00:00	1959-10-15	1959-10-15 00:00:00	1959-10-15	581452		0	0	0		0	0	0	330874	0	10	40213160		
123859	2724	40213160	1955-05-01	1955-05-01 00:00:00	1955-05-01	1955-05-01 00:00:00	1955-05-01	581452		0	0	0		0	0	0	180489	0	10	40213160		
40620	3367	1127433	2015-05-01	2015-05-01 00:00:00	2015-05-22	2015-05-22 00:00:00	2015-05-22	38000177		0	0	21		0	0	0	223285	0	313782	1127433		
153143	3371	40213160	1975-11-21	1975-11-21 00:00:00	1975-11-21	1975-11-21 00:00:00	1975-11-21	581452		0	0	0		0	0	0	223642	0	10	40213160		
229368	5041	40213296	2012-03-06	2012-03-06 00:00:00	2012-03-06	2012-03-06 00:00:00	2012-03-06	581452		0	0	0		0	0	0	334927	0	52	40213296		
167626	3686	40213160	1968-02-26	1968-02-26 00:00:00	1968-02-26	1968-02-26 00:00:00	1968-02-26	581452		0	0	0		0	0	0	245030	0	10	40213160		
210679	4621	40213314	1977-10-03	1977-10-03 00:00:00	1977-10-03	1977-10-03 00:00:00	1977-10-03	581452		0	0	0		0	0	0	307761	0	49	40213314		
96754	2122	40213314	1977-09-24	1977-09-24 00:00:00	1977-09-24	1977-09-24 00:00:00	1977-09-24	581452		0	0	0		0	0	0	141205	0	49	40213314		
53562	4452	1127433	1970-05-29	1970-05-29 00:00:00	1970-06-19	1970-06-19 00:00:00	1970-06-19	38000177		0	0	21		0	0	0	296343	0	313782	1127433		
108561	2381	40213227	2008-02-13	2008-02-13 00:00:00	2008-02-13	2008-02-13 00:00:00	2008-02-13	581452		0	0	0		0	0	0	158270	0	113	40213227		
62343	5190	40229134	1998-07-21	1998-07-21 00:00:00	1998-08-04	1998-08-04 00:00:00	1998-08-04	38000177		0	0	14		0	0	0	345031	0	1043400	40229134		
84019	1837	40213296	2001-11-23	2001-11-23 00:00:00	2001-11-23	2001-11-23 00:00:00	2001-11-23	581452		0	0	0		0	0	0	122749	0	52	40213296		
112413	2469	40213160	1976-07-18	1976-07-18 00:00:00	1976-07-18	1976-07-18 00:00:00	1976-07-18	581452		0	0	0		0	0	0	163755	0	10	40213160		
119708	2631	40213227	2012-09-30	2012-09-30 00:00:00	2012-09-30	2012-09-30 00:00:00	2012-09-30	581452		0	0	0		0	0	0	174036	0	113	40213227		
192987	4239	40213227	2009-11-28	2009-11-28 00:00:00	2009-11-28	2009-11-28 00:00:00	2009-11-28	581452		0	0	0		0	0	0	281489	0	113	40213227		
85790	1879	40213260	2009-07-11	2009-07-11 00:00:00	2009-07-11	2009-07-11 00:00:00	2009-07-11	581452		0	0	0		0	0	0	125429	0	121	40213260		
7624	164	40213227	2017-05-22	2017-05-22 00:00:00	2017-05-22	2017-05-22 00:00:00	2017-05-22	581452		0	0	0		0	0	0	11277	0	113	40213227		
31132	2580	19075601	1998-02-23	1998-02-23 00:00:00	1998-02-23	1998-02-23 00:00:00	\N	38000177		0	0	0		0	0	0	170866	0	309362	19075601		
125303	2757	40213160	1978-01-06	1978-01-06 00:00:00	1978-01-06	1978-01-06 00:00:00	1978-01-06	581452		0	0	0		0	0	0	182382	0	10	40213160		
106951	2344	40213260	2017-03-20	2017-03-20 00:00:00	2017-03-20	2017-03-20 00:00:00	2017-03-20	581452		0	0	0		0	0	0	156069	0	121	40213260		
73180	1599	40213160	1960-10-17	1960-10-17 00:00:00	1960-10-17	1960-10-17 00:00:00	1960-10-17	581452		0	0	0		0	0	0	107302	0	10	40213160		
25387	2087	1713671	2012-04-02	2012-04-02 00:00:00	2012-04-23	2012-04-23 00:00:00	2012-04-23	38000177		0	0	21		0	0	0	139140	0	562251	1713671		
30564	2535	1118084	1999-03-13	1999-03-13 00:00:00	1999-03-13	1999-03-13 00:00:00	\N	38000177		0	0	0		0	0	0	167496	0	00025152531	44923712		
163599	3599	40213296	2006-05-12	2006-05-12 00:00:00	2006-05-12	2006-05-12 00:00:00	2006-05-12	581452		0	0	0		0	0	0	239044	0	52	40213296		
3804	316	1127433	2016-03-26	2016-03-26 00:00:00	2016-04-02	2016-04-02 00:00:00	2016-04-02	38000177		0	0	7		0	0	0	20866	0	313782	1127433		
29055	2404	19078461	1980-06-24	1980-06-24 00:00:00	1980-07-15	1980-07-15 00:00:00	1980-07-15	38000177		0	0	21		0	0	0	159761	0	310965	19078461		
195621	4297	40213160	1977-12-17	1977-12-17 00:00:00	1977-12-17	1977-12-17 00:00:00	1977-12-17	581452		0	0	0		0	0	0	285169	0	10	40213160		
104467	2291	40213296	2001-03-22	2001-03-22 00:00:00	2001-03-22	2001-03-22 00:00:00	2001-03-22	581452		0	0	0		0	0	0	152503	0	52	40213296		
53379	4437	19006318	1969-10-05	1969-10-05 00:00:00	1969-10-19	1969-10-19 00:00:00	1969-10-19	38000177		0	0	14		0	0	0	294926	0	105078	19006318		
51549	4284	1127433	1979-12-29	1979-12-29 00:00:00	1980-01-12	1980-01-12 00:00:00	1980-01-12	38000177		0	0	14		0	0	0	284327	0	313782	1127433		
207065	4543	40213314	1979-12-15	1979-12-15 00:00:00	1979-12-15	1979-12-15 00:00:00	1979-12-15	581452		0	0	0		0	0	0	302618	0	49	40213314		
63757	5298	1124300	1973-12-06	1973-12-06 00:00:00	1973-12-06	1973-12-06 00:00:00	\N	38000177		0	0	0		0	0	0	352412	0	00781178901	45011828		
84188	1842	40213260	2016-07-15	2016-07-15 00:00:00	2016-07-15	2016-07-15 00:00:00	2016-07-15	581452		0	0	0		0	0	0	122976	0	121	40213260		
53771	4471	1127433	1962-07-03	1962-07-03 00:00:00	1962-07-10	1962-07-10 00:00:00	1962-07-10	38000177		0	0	7		0	0	0	297450	0	313782	1127433		
61552	1345	40213227	2017-04-04	2017-04-04 00:00:00	2017-04-04	2017-04-04 00:00:00	2017-04-04	581452		0	0	0		0	0	0	89153	0	113	40213227		
224333	4924	40213314	1978-03-22	1978-03-22 00:00:00	1978-03-22	1978-03-22 00:00:00	1978-03-22	581452		0	0	0		0	0	0	327203	0	49	40213314		
228028	5007	40213160	1983-07-03	1983-07-03 00:00:00	1983-07-03	1983-07-03 00:00:00	1983-07-03	581452		0	0	0		0	0	0	333013	0	10	40213160		
73552	1606	40213198	2015-05-18	2015-05-18 00:00:00	2015-05-18	2015-05-18 00:00:00	2015-05-18	581452		0	0	0		0	0	0	107888	0	133	40213198		
225427	4949	40213296	2014-10-02	2014-10-02 00:00:00	2014-10-02	2014-10-02 00:00:00	2014-10-02	581452		0	0	0		0	0	0	329022	0	52	40213296		
1984	43	40213227	1998-07-27	1998-07-27 00:00:00	1998-07-27	1998-07-27 00:00:00	1998-07-27	581452		0	0	0		0	0	0	3169	0	113	40213227		
56933	4724	40229134	2005-06-13	2005-06-13 00:00:00	2005-06-20	2005-06-20 00:00:00	2005-06-20	38000177		0	0	7		0	0	0	314718	0	1043400	40229134		
56518	4689	19128065	1981-05-06	1981-05-06 00:00:00	1982-05-01	1982-05-01 00:00:00	1982-05-01	38000177		0	0	360		0	0	0	312432	0	749882	19128065		
3786	82	40213227	2003-04-01	2003-04-01 00:00:00	2003-04-01	2003-04-01 00:00:00	2003-04-01	581452		0	0	0		0	0	0	5599	0	113	40213227		
10440	870	19128065	1987-09-22	1987-09-22 00:00:00	1988-09-16	1988-09-16 00:00:00	1988-09-16	38000177		0	0	360		0	0	0	57840	0	749882	19128065		
17769	384	40213160	1961-02-06	1961-02-06 00:00:00	1961-02-06	1961-02-06 00:00:00	1961-02-06	581452		0	0	0		0	0	0	25296	0	10	40213160		
169153	3719	40213227	2014-01-14	2014-01-14 00:00:00	2014-01-14	2014-01-14 00:00:00	2014-01-14	581452		0	0	0		0	0	0	247230	0	113	40213227		
210047	4606	40213160	1982-05-13	1982-05-13 00:00:00	1982-05-13	1982-05-13 00:00:00	1982-05-13	581452		0	0	0		0	0	0	306843	0	10	40213160		
228499	5018	40213201	2006-07-20	2006-07-20 00:00:00	2006-07-20	2006-07-20 00:00:00	2006-07-20	581452		0	0	0		0	0	0	333553	0	33	40213201		
11893	992	1127433	1962-12-08	1962-12-08 00:00:00	1962-12-15	1962-12-15 00:00:00	1962-12-15	38000177		0	0	7		0	0	0	65745	0	313782	1127433		
63305	1384	40213160	1982-11-23	1982-11-23 00:00:00	1982-11-23	1982-11-23 00:00:00	1982-11-23	581452		0	0	0		0	0	0	91740	0	10	40213160		
226576	4975	40213160	1960-03-17	1960-03-17 00:00:00	1960-03-17	1960-03-17 00:00:00	1960-03-17	581452		0	0	0		0	0	0	330884	0	10	40213160		
144740	3181	40213227	2003-07-04	2003-07-04 00:00:00	2003-07-04	2003-07-04 00:00:00	2003-07-04	581452		0	0	0		0	0	0	211702	0	113	40213227		
40621	3367	40229134	2009-10-06	2009-10-06 00:00:00	2009-10-13	2009-10-13 00:00:00	2009-10-13	38000177		0	0	7		0	0	0	223288	0	1043400	40229134		
153145	3371	40213296	2018-09-14	2018-09-14 00:00:00	2018-09-14	2018-09-14 00:00:00	2018-09-14	581452		0	0	0		0	0	0	223581	0	52	40213296		
229371	5041	40213160	1971-03-02	1971-03-02 00:00:00	1971-03-02	1971-03-02 00:00:00	1971-03-02	581452		0	0	0		0	0	0	334965	0	10	40213160		
167629	3686	40213296	2008-12-29	2008-12-29 00:00:00	2008-12-29	2008-12-29 00:00:00	2008-12-29	581452		0	0	0		0	0	0	245046	0	52	40213296		
221981	4872	40213201	1983-10-25	1983-10-25 00:00:00	1983-10-25	1983-10-25 00:00:00	1983-10-25	581452		0	0	0		0	0	0	324046	0	33	40213201		
96757	2122	40213314	1977-03-26	1977-03-26 00:00:00	1977-03-26	1977-03-26 00:00:00	1977-03-26	581452		0	0	0		0	0	0	141199	0	49	40213314		
53563	4452	19133873	1958-05-07	1958-05-07 00:00:00	1958-05-17	1958-05-17 00:00:00	1958-05-17	38000177		0	0	10		0	0	0	296244	0	834061	19133873		
34470	2847	1127433	1989-12-20	1989-12-20 00:00:00	1990-01-03	1990-01-03 00:00:00	1990-01-03	38000177		0	0	14		0	0	0	189105	0	313782	1127433		
62344	5190	1127433	2015-02-11	2015-02-11 00:00:00	2015-03-11	2015-03-11 00:00:00	2015-03-11	38000177		0	0	28		0	0	0	345055	0	313782	1127433		
84021	1837	40213227	2001-11-23	2001-11-23 00:00:00	2001-11-23	2001-11-23 00:00:00	2001-11-23	581452		0	0	0		0	0	0	122749	0	113	40213227		
112421	2470	40213227	2009-12-21	2009-12-21 00:00:00	2009-12-21	2009-12-21 00:00:00	2009-12-21	581452		0	0	0		0	0	0	163783	0	113	40213227		
188629	4142	40213314	1981-11-22	1981-11-22 00:00:00	1981-11-22	1981-11-22 00:00:00	1981-11-22	581452		0	0	0		0	0	0	275294	0	49	40213314		
192989	4239	40213160	1955-11-26	1955-11-26 00:00:00	1955-11-26	1955-11-26 00:00:00	1955-11-26	581452		0	0	0		0	0	0	281439	0	10	40213160		
85792	1879	40213160	1959-06-13	1959-06-13 00:00:00	1959-06-13	1959-06-13 00:00:00	1959-06-13	581452		0	0	0		0	0	0	125396	0	10	40213160		
7626	164	40213160	1966-09-12	1966-09-12 00:00:00	1966-09-12	1966-09-12 00:00:00	1966-09-12	581452		0	0	0		0	0	0	11291	0	10	40213160		
31133	2580	40229134	1963-07-15	1963-07-15 00:00:00	1963-07-29	1963-07-29 00:00:00	1963-07-29	38000177		0	0	14		0	0	0	170921	0	1043400	40229134		
125309	2757	40213227	2014-07-25	2014-07-25 00:00:00	2014-07-25	2014-07-25 00:00:00	2014-07-25	581452		0	0	0		0	0	0	182360	0	113	40213227		
106953	2344	40213227	2017-03-20	2017-03-20 00:00:00	2017-03-20	2017-03-20 00:00:00	2017-03-20	581452		0	0	0		0	0	0	156069	0	113	40213227		
73184	1599	40213306	1982-07-05	1982-07-05 00:00:00	1982-07-05	1982-07-05 00:00:00	1982-07-05	581452		0	0	0		0	0	0	107315	0	43	40213306		
25388	2087	1115171	1997-02-06	1997-02-06 00:00:00	1997-04-07	1997-04-07 00:00:00	1997-04-07	38000177		0	0	60		0	0	0	139104	0	849574	1115171		
30565	2535	19075601	2000-08-27	2000-08-27 00:00:00	2000-08-27	2000-08-27 00:00:00	2000-08-27	38000177		0	0	0		0	0	0	167496	0	309362	19075601		
199336	4379	40213260	2019-06-18	2019-06-18 00:00:00	2019-06-18	2019-06-18 00:00:00	2019-06-18	581452		0	0	0		0	0	0	290968	0	121	40213260		
3805	316	1713671	1928-02-07	1928-02-07 00:00:00	1928-02-14	1928-02-14 00:00:00	1928-02-14	38000177		0	0	7		0	0	0	20957	0	562251	1713671		
29056	2404	19133873	1979-11-07	1979-11-07 00:00:00	1979-11-16	1979-11-16 00:00:00	1979-11-16	38000177		0	0	9		0	0	0	159712	0	834061	19133873		
124572	2740	40213160	1973-11-20	1973-11-20 00:00:00	1973-11-20	1973-11-20 00:00:00	1973-11-20	581452		0	0	0		0	0	0	181289	0	10	40213160		
165461	3637	40213296	1999-07-27	1999-07-27 00:00:00	1999-07-27	1999-07-27 00:00:00	1999-07-27	581452		0	0	0		0	0	0	241883	0	52	40213296		
53380	4437	1127078	1969-10-05	1969-10-05 00:00:00	1969-10-19	1969-10-19 00:00:00	1969-10-19	38000177		0	0	14		0	0	0	294926	0	282464	1127078		
51550	4284	1127433	2003-02-16	2003-02-16 00:00:00	2003-03-09	2003-03-09 00:00:00	2003-03-09	38000177		0	0	21		0	0	0	284386	0	313782	1127433		
207074	4543	40213251	1984-04-21	1984-04-21 00:00:00	1984-04-21	1984-04-21 00:00:00	1984-04-21	581452		0	0	0		0	0	0	\N	0	21	40213251		
63758	5298	1127433	1943-01-26	1943-01-26 00:00:00	1943-02-09	1943-02-09 00:00:00	1943-02-09	38000177		0	0	14		0	0	0	352442	0	313782	1127433		
84196	1842	40213306	1987-08-28	1987-08-28 00:00:00	1987-08-28	1987-08-28 00:00:00	1987-08-28	581452		0	0	0		0	0	0	122941	0	43	40213306		
53772	4471	1713671	1986-04-24	1986-04-24 00:00:00	1986-05-15	1986-05-15 00:00:00	1986-05-15	38000177		0	0	21		0	0	0	297447	0	562251	1713671		
61556	1345	40213227	1997-10-14	1997-10-14 00:00:00	1997-10-14	1997-10-14 00:00:00	1997-10-14	581452		0	0	0		0	0	0	89140	0	113	40213227		
224334	4924	40213160	1978-03-22	1978-03-22 00:00:00	1978-03-22	1978-03-22 00:00:00	1978-03-22	581452		0	0	0		0	0	0	327203	0	10	40213160		
188430	4137	40213160	1966-01-05	1966-01-05 00:00:00	1966-01-05	1966-01-05 00:00:00	1966-01-05	581452		0	0	0		0	0	0	275037	0	10	40213160		
73566	1606	40213201	2016-05-23	2016-05-23 00:00:00	2016-05-23	2016-05-23 00:00:00	2016-05-23	581452		0	0	0		0	0	0	107833	0	33	40213201		
225428	4949	40213306	1994-11-24	1994-11-24 00:00:00	1994-11-24	1994-11-24 00:00:00	1994-11-24	581452		0	0	0		0	0	0	329026	0	43	40213306		
1985	43	40213296	1998-07-27	1998-07-27 00:00:00	1998-07-27	1998-07-27 00:00:00	1998-07-27	581452		0	0	0		0	0	0	3169	0	52	40213296		
56934	4724	19008572	1975-10-12	1975-10-12 00:00:00	1975-10-26	1975-10-26 00:00:00	1975-10-26	38000177		0	0	14		0	0	0	314722	0	106258	19008572		
56519	4689	1118084	2007-10-12	2007-10-12 00:00:00	2007-10-12	2007-10-12 00:00:00	\N	38000177		0	0	0		0	0	0	312450	0	00025152531	44923712		
3789	82	40213160	1961-11-28	1961-11-28 00:00:00	1961-11-28	1961-11-28 00:00:00	1961-11-28	581452		0	0	0		0	0	0	5555	0	10	40213160		
10441	870	1127433	1962-09-24	1962-09-24 00:00:00	1962-10-01	1962-10-01 00:00:00	1962-10-01	38000177		0	0	7		0	0	0	57905	0	313782	1127433		
17774	384	40213160	1965-05-10	1965-05-10 00:00:00	1965-05-10	1965-05-10 00:00:00	1965-05-10	581452		0	0	0		0	0	0	25317	0	10	40213160		
169154	3719	40213296	2003-12-16	2003-12-16 00:00:00	2003-12-16	2003-12-16 00:00:00	2003-12-16	581452		0	0	0		0	0	0	247187	0	52	40213296		
210048	4606	40213314	1982-05-13	1982-05-13 00:00:00	1982-05-13	1982-05-13 00:00:00	1982-05-13	581452		0	0	0		0	0	0	306843	0	49	40213314		
180485	3967	40213227	2011-08-14	2011-08-14 00:00:00	2011-08-14	2011-08-14 00:00:00	2011-08-14	581452		0	0	0		0	0	0	263788	0	113	40213227		
11894	992	1127433	2015-03-29	2015-03-29 00:00:00	2015-05-03	2015-05-03 00:00:00	2015-05-03	38000177		0	0	35		0	0	0	65819	0	313782	1127433		
63311	1385	40213160	1965-04-23	1965-04-23 00:00:00	1965-04-23	1965-04-23 00:00:00	1965-04-23	581452		0	0	0		0	0	0	91796	0	10	40213160		
226579	4975	40213306	1981-08-20	1981-08-20 00:00:00	1981-08-20	1981-08-20 00:00:00	1981-08-20	581452		0	0	0		0	0	0	330913	0	43	40213306		
144742	3181	40213160	1956-04-20	1956-04-20 00:00:00	1956-04-20	1956-04-20 00:00:00	1956-04-20	581452		0	0	0		0	0	0	\N	0	10	40213160		
40622	3367	19078461	1993-05-25	1993-05-25 00:00:00	1993-06-22	1993-06-22 00:00:00	1993-06-22	38000177		0	0	28		0	0	0	223280	0	310965	19078461		
153147	3371	40213227	2008-08-29	2008-08-29 00:00:00	2008-08-29	2008-08-29 00:00:00	2008-08-29	581452		0	0	0		0	0	0	223666	0	113	40213227		
229379	5041	40213160	1971-08-03	1971-08-03 00:00:00	1971-08-03	1971-08-03 00:00:00	1971-08-03	581452		0	0	0		0	0	0	334966	0	10	40213160		
167630	3686	40213227	2008-12-29	2008-12-29 00:00:00	2008-12-29	2008-12-29 00:00:00	2008-12-29	581452		0	0	0		0	0	0	245046	0	113	40213227		
221988	4872	40213227	1996-01-02	1996-01-02 00:00:00	1996-01-02	1996-01-02 00:00:00	1996-01-02	581452		0	0	0		0	0	0	323981	0	113	40213227		
96759	2122	40213227	2015-10-31	2015-10-31 00:00:00	2015-10-31	2015-10-31 00:00:00	2015-10-31	581452		0	0	0		0	0	0	141228	0	113	40213227		
53564	4452	1127433	1964-04-18	1964-04-18 00:00:00	1964-04-25	1964-04-25 00:00:00	1964-04-25	38000177		0	0	7		0	0	0	296225	0	313782	1127433		
34471	2847	1713671	1980-08-24	1980-08-24 00:00:00	1980-09-07	1980-09-07 00:00:00	1980-09-07	38000177		0	0	14		0	0	0	189053	0	562251	1713671		
62345	5190	19059056	1969-04-01	1969-04-01 00:00:00	1969-05-31	1969-05-31 00:00:00	1969-05-31	38000177		0	0	60		0	0	0	345059	0	243670	19059056		
84025	1837	40213296	2003-11-28	2003-11-28 00:00:00	2003-11-28	2003-11-28 00:00:00	2003-11-28	581452		0	0	0		0	0	0	122680	0	52	40213296		
112422	2470	40213260	2009-12-21	2009-12-21 00:00:00	2009-12-21	2009-12-21 00:00:00	2009-12-21	581452		0	0	0		0	0	0	163783	0	121	40213260		
188630	4142	40213160	1981-11-22	1981-11-22 00:00:00	1981-11-22	1981-11-22 00:00:00	1981-11-22	581452		0	0	0		0	0	0	275294	0	10	40213160		
192999	4240	40213227	2002-09-23	2002-09-23 00:00:00	2002-09-23	2002-09-23 00:00:00	2002-09-23	581452		0	0	0		0	0	0	281632	0	113	40213227		
85796	1879	40213160	1959-01-10	1959-01-10 00:00:00	1959-01-10	1959-01-10 00:00:00	1959-01-10	581452		0	0	0		0	0	0	125395	0	10	40213160		
7629	164	40213160	1966-06-13	1966-06-13 00:00:00	1966-06-13	1966-06-13 00:00:00	1966-06-13	581452		0	0	0		0	0	0	11266	0	10	40213160		
31134	2580	19133905	1995-02-16	1995-02-16 00:00:00	1995-03-01	1995-03-01 00:00:00	1995-03-01	38000177		0	0	13		0	0	0	170930	0	834102	19133905		
125310	2757	40213296	2014-07-25	2014-07-25 00:00:00	2014-07-25	2014-07-25 00:00:00	2014-07-25	581452		0	0	0		0	0	0	182360	0	52	40213296		
106964	2344	40213260	2016-03-14	2016-03-14 00:00:00	2016-03-14	2016-03-14 00:00:00	2016-03-14	581452		0	0	0		0	0	0	156030	0	121	40213260		
73188	1599	40213160	1965-04-12	1965-04-12 00:00:00	1965-04-12	1965-04-12 00:00:00	1965-04-12	581452		0	0	0		0	0	0	107358	0	10	40213160		
25389	2087	19078461	1977-09-28	1977-09-28 00:00:00	1977-10-19	1977-10-19 00:00:00	1977-10-19	38000177		0	0	21		0	0	0	139102	0	310965	19078461		
30566	2535	1127433	2003-11-24	2003-11-24 00:00:00	2003-12-01	2003-12-01 00:00:00	2003-12-01	38000177		0	0	7		0	0	0	167555	0	313782	1127433		
199347	4379	40213160	1969-11-25	1969-11-25 00:00:00	1969-11-25	1969-11-25 00:00:00	1969-11-25	581452		0	0	0		0	0	0	290943	0	10	40213160		
14278	1197	1124300	2015-05-16	2015-05-16 00:00:00	2015-05-16	2015-05-16 00:00:00	\N	38000177		0	0	0		0	0	0	78863	0	00781178901	45011828		
29057	2404	19059056	1974-01-22	1974-01-22 00:00:00	1974-02-12	1974-02-12 00:00:00	1974-02-12	38000177		0	0	21		0	0	0	159759	0	243670	19059056		
190053	4173	40213227	2014-08-20	2014-08-20 00:00:00	2014-08-20	2014-08-20 00:00:00	2014-08-20	581452		0	0	0		0	0	0	277326	0	113	40213227		
165463	3637	40213260	2009-07-21	2009-07-21 00:00:00	2009-07-21	2009-07-21 00:00:00	2009-07-21	581452		0	0	0		0	0	0	241885	0	121	40213260		
53381	4437	19078461	2018-02-20	2018-02-20 00:00:00	2018-03-13	2018-03-13 00:00:00	2018-03-13	38000177		0	0	21		0	0	0	294911	0	310965	19078461		
51551	4284	1127433	1965-11-04	1965-11-04 00:00:00	1965-11-11	1965-11-11 00:00:00	1965-11-11	38000177		0	0	7		0	0	0	284381	0	313782	1127433		
207076	4543	40213160	1984-04-21	1984-04-21 00:00:00	1984-04-21	1984-04-21 00:00:00	1984-04-21	581452		0	0	0		0	0	0	\N	0	10	40213160		
63759	5298	40222846	2013-06-13	2013-06-13 00:00:00	2013-06-13	2013-06-13 00:00:00	\N	38000177		0	0	0		0	0	0	352427	0	996740	40222846		
84198	1842	40213160	1965-11-26	1965-11-26 00:00:00	1965-11-26	1965-11-26 00:00:00	1965-11-26	581452		0	0	0		0	0	0	122947	0	10	40213160		
53773	4471	1713671	1975-05-16	1975-05-16 00:00:00	1975-05-23	1975-05-23 00:00:00	1975-05-23	38000177		0	0	7		0	0	0	297430	0	562251	1713671		
61563	1345	40213160	1966-11-22	1966-11-22 00:00:00	1966-11-22	1966-11-22 00:00:00	1966-11-22	581452		0	0	0		0	0	0	89131	0	10	40213160		
224337	4924	40213314	1979-02-21	1979-02-21 00:00:00	1979-02-21	1979-02-21 00:00:00	1979-02-21	581452		0	0	0		0	0	0	327237	0	49	40213314		
188438	4137	40213160	1961-05-03	1961-05-03 00:00:00	1961-05-03	1961-05-03 00:00:00	1961-05-03	581452		0	0	0		0	0	0	274996	0	10	40213160		
84848	1855	40213296	2016-11-18	2016-11-18 00:00:00	2016-11-18	2016-11-18 00:00:00	2016-11-18	581452		0	0	0		0	0	0	124190	0	52	40213296		
225429	4949	40213160	1973-03-01	1973-03-01 00:00:00	1973-03-01	1973-03-01 00:00:00	1973-03-01	581452		0	0	0		0	0	0	329014	0	10	40213160		
1991	43	40213227	2018-10-22	2018-10-22 00:00:00	2018-10-22	2018-10-22 00:00:00	2018-10-22	581452		0	0	0		0	0	0	3223	0	113	40213227		
56935	4724	19008572	1965-05-28	1965-05-28 00:00:00	1965-06-11	1965-06-11 00:00:00	1965-06-11	38000177		0	0	14		0	0	0	314748	0	106258	19008572		
56520	4689	19128065	1990-03-19	1990-03-19 00:00:00	1991-03-14	1991-03-14 00:00:00	1991-03-14	38000177		0	0	360		0	0	0	312424	0	749882	19128065		
3796	82	40213306	1983-05-24	1983-05-24 00:00:00	1983-05-24	1983-05-24 00:00:00	1983-05-24	581452		0	0	0		0	0	0	5566	0	43	40213306		
10443	870	1127078	1971-10-06	1971-10-06 00:00:00	1971-11-05	1971-11-05 00:00:00	1971-11-05	38000177		0	0	30		0	0	0	57891	0	282464	1127078		
8205	685	1127433	2005-05-23	2005-05-23 00:00:00	2005-06-13	2005-06-13 00:00:00	2005-06-13	38000177		0	0	21		0	0	0	45307	0	313782	1127433		
180433	3966	40213296	2008-12-20	2008-12-20 00:00:00	2008-12-20	2008-12-20 00:00:00	2008-12-20	581452		0	0	0		0	0	0	263667	0	52	40213296		
210051	4606	40213314	1983-04-14	1983-04-14 00:00:00	1983-04-14	1983-04-14 00:00:00	1983-04-14	581452		0	0	0		0	0	0	306825	0	49	40213314		
180486	3967	40213260	2011-08-14	2011-08-14 00:00:00	2011-08-14	2011-08-14 00:00:00	2011-08-14	581452		0	0	0		0	0	0	263788	0	121	40213260		
11895	992	1124300	1987-07-31	1987-07-31 00:00:00	1987-07-31	1987-07-31 00:00:00	\N	38000177		0	0	0		0	0	0	65798	0	00781178901	45011828		
11903	992	19078461	1993-03-26	1993-03-26 00:00:00	1993-04-23	1993-04-23 00:00:00	1993-04-23	38000177		0	0	28		0	0	0	65749	0	310965	19078461		
226587	4975	40213260	2010-07-22	2010-07-22 00:00:00	2010-07-22	2010-07-22 00:00:00	2010-07-22	581452		0	0	0		0	0	0	330858	0	121	40213260		
144761	3181	40213227	1994-01-07	1994-01-07 00:00:00	1994-01-07	1994-01-07 00:00:00	1994-01-07	581452		0	0	0		0	0	0	211641	0	113	40213227		
40623	3367	40229134	2017-08-17	2017-08-17 00:00:00	2017-08-24	2017-08-24 00:00:00	2017-08-24	38000177		0	0	7		0	0	0	223343	0	1043400	40229134		
55764	1222	40213260	2006-03-22	2006-03-22 00:00:00	2006-03-22	2006-03-22 00:00:00	2006-03-22	581452		0	0	0		0	0	0	80361	0	121	40213260		
167639	3686	40213160	1968-07-29	1968-07-29 00:00:00	1968-07-29	1968-07-29 00:00:00	1968-07-29	581452		0	0	0		0	0	0	245031	0	10	40213160		
96760	2122	40213296	2015-10-31	2015-10-31 00:00:00	2015-10-31	2015-10-31 00:00:00	2015-10-31	581452		0	0	0		0	0	0	141228	0	52	40213296		
53565	4452	1127078	1956-06-27	1956-06-27 00:00:00	1956-09-25	1956-09-25 00:00:00	1956-09-25	38000177		0	0	90		0	0	0	296341	0	282464	1127078		
34472	2847	19133873	1975-03-09	1975-03-09 00:00:00	1975-03-18	1975-03-18 00:00:00	1975-03-18	38000177		0	0	9		0	0	0	189052	0	834061	19133873		
62346	5190	19059056	1965-03-09	1965-03-09 00:00:00	1965-03-23	1965-03-23 00:00:00	1965-03-23	38000177		0	0	14		0	0	0	345058	0	243670	19059056		
84031	1837	40213227	1993-11-12	1993-11-12 00:00:00	1993-11-12	1993-11-12 00:00:00	1993-11-12	581452		0	0	0		0	0	0	122661	0	113	40213227		
112424	2470	40213160	1963-11-25	1963-11-25 00:00:00	1963-11-25	1963-11-25 00:00:00	1963-11-25	581452		0	0	0		0	0	0	163789	0	10	40213160		
188637	4142	40213314	1982-08-22	1982-08-22 00:00:00	1982-08-22	1982-08-22 00:00:00	1982-08-22	581452		0	0	0		0	0	0	275295	0	49	40213314		
188655	4142	40213306	2003-07-20	2003-07-20 00:00:00	2003-07-20	2003-07-20 00:00:00	2003-07-20	581452		0	0	0		0	0	0	275336	0	43	40213306		
85799	1879	40213227	2010-07-17	2010-07-17 00:00:00	2010-07-17	2010-07-17 00:00:00	2010-07-17	581452		0	0	0		0	0	0	125425	0	113	40213227		
7630	164	40213296	2009-04-27	2009-04-27 00:00:00	2009-04-27	2009-04-27 00:00:00	2009-04-27	581452		0	0	0		0	0	0	11262	0	52	40213296		
31135	2580	1127078	1961-04-24	1961-04-24 00:00:00	1961-05-08	1961-05-08 00:00:00	1961-05-08	38000177		0	0	14		0	0	0	170931	0	282464	1127078		
125314	2757	40213296	2016-07-29	2016-07-29 00:00:00	2016-07-29	2016-07-29 00:00:00	2016-07-29	581452		0	0	0		0	0	0	182378	0	52	40213296		
106965	2344	40213296	2006-03-20	2006-03-20 00:00:00	2006-03-20	2006-03-20 00:00:00	2006-03-20	581452		0	0	0		0	0	0	156050	0	52	40213296		
19678	1618	1127433	1986-01-09	1986-01-09 00:00:00	1986-01-23	1986-01-23 00:00:00	1986-01-23	38000177		0	0	14		0	0	0	108800	0	313782	1127433		
25390	2087	1127433	1938-04-16	1938-04-16 00:00:00	1938-04-23	1938-04-23 00:00:00	1938-04-23	38000177		0	0	7		0	0	0	139027	0	313782	1127433		
30567	2535	19059056	1961-03-02	1961-03-02 00:00:00	1961-03-16	1961-03-16 00:00:00	1961-03-16	38000177		0	0	14		0	0	0	167524	0	243670	19059056		
199350	4379	40213296	2009-06-23	2009-06-23 00:00:00	2009-06-23	2009-06-23 00:00:00	2009-06-23	581452		0	0	0		0	0	0	290966	0	52	40213296		
14279	1197	1127078	1988-10-30	1988-10-30 00:00:00	1988-11-27	1988-11-27 00:00:00	1988-11-27	38000177		0	0	28		0	0	0	78849	0	282464	1127078		
29058	2404	1127078	1966-05-04	1966-05-04 00:00:00	1966-05-18	1966-05-18 00:00:00	1966-05-18	38000177		0	0	14		0	0	0	159752	0	282464	1127078		
190055	4173	40213160	1964-01-22	1964-01-22 00:00:00	1964-01-22	1964-01-22 00:00:00	1964-01-22	581452		0	0	0		0	0	0	277367	0	10	40213160		
165465	3637	40213260	2010-07-27	2010-07-27 00:00:00	2010-07-27	2010-07-27 00:00:00	2010-07-27	581452		0	0	0		0	0	0	241932	0	121	40213260		
53382	4437	1118084	2010-11-14	2010-11-14 00:00:00	2010-11-14	2010-11-14 00:00:00	\N	38000177		0	0	0		0	0	0	294915	0	00025152531	44923712		
51552	4284	1124300	1976-07-17	1976-07-17 00:00:00	1976-07-17	1976-07-17 00:00:00	\N	38000177		0	0	0		0	0	0	284344	0	00781178901	45011828		
207078	4543	40213306	2001-11-24	2001-11-24 00:00:00	2001-11-24	2001-11-24 00:00:00	2001-11-24	581452		0	0	0		0	0	0	302577	0	43	40213306		
63760	5299	1127433	1979-09-30	1979-09-30 00:00:00	1979-10-07	1979-10-07 00:00:00	1979-10-07	38000177		0	0	7		0	0	0	352494	0	313782	1127433		
84202	1842	40213227	1999-04-09	1999-04-09 00:00:00	1999-04-09	1999-04-09 00:00:00	1999-04-09	581452		0	0	0		0	0	0	122974	0	113	40213227		
53774	4471	19133873	1975-04-27	1975-04-27 00:00:00	1975-05-09	1975-05-09 00:00:00	1975-05-09	38000177		0	0	12		0	0	0	297429	0	834061	19133873		
61566	1345	40213160	1966-06-21	1966-06-21 00:00:00	1966-06-21	1966-06-21 00:00:00	1966-06-21	581452		0	0	0		0	0	0	89130	0	10	40213160		
224341	4924	40213251	1984-10-03	1984-10-03 00:00:00	1984-10-03	1984-10-03 00:00:00	1984-10-03	581452		0	0	0		0	0	0	327182	0	21	40213251		
188440	4137	40213160	1961-10-04	1961-10-04 00:00:00	1961-10-04	1961-10-04 00:00:00	1961-10-04	581452		0	0	0		0	0	0	274987	0	10	40213160		
80456	1760	40213160	1982-03-21	1982-03-21 00:00:00	1982-03-21	1982-03-21 00:00:00	1982-03-21	581452		0	0	0		0	0	0	117666	0	10	40213160		
225432	4949	40213227	1994-11-24	1994-11-24 00:00:00	1994-11-24	1994-11-24 00:00:00	1994-11-24	581452		0	0	0		0	0	0	329026	0	113	40213227		
2006	43	40213296	2000-07-31	2000-07-31 00:00:00	2000-07-31	2000-07-31 00:00:00	2000-07-31	581452		0	0	0		0	0	0	3210	0	52	40213296		
56936	4724	19134077	1988-06-09	1988-06-09 00:00:00	1988-06-23	1988-06-23 00:00:00	1988-06-23	38000177		0	0	14		0	0	0	314723	0	835900	19134077		
56521	4689	46233988	1969-11-13	1969-11-13 00:00:00	1969-11-27	1969-11-27 00:00:00	1969-11-27	38000177		0	0	14		0	0	0	312417	0	1652673	46233988		
3800	82	40213160	1961-08-29	1961-08-29 00:00:00	1961-08-29	1961-08-29 00:00:00	1961-08-29	581452		0	0	0		0	0	0	5587	0	10	40213160		
10444	870	19128065	1986-09-27	1986-09-27 00:00:00	1987-09-22	1987-09-22 00:00:00	1987-09-22	38000177		0	0	360		0	0	0	57839	0	749882	19128065		
8206	685	1127433	1980-04-15	1980-04-15 00:00:00	1980-05-20	1980-05-20 00:00:00	1980-05-20	38000177		0	0	35		0	0	0	45304	0	313782	1127433		
224528	4929	40213227	1994-09-24	1994-09-24 00:00:00	1994-09-24	1994-09-24 00:00:00	1994-09-24	581452		0	0	0		0	0	0	327713	0	113	40213227		
210057	4606	40213180	2006-09-07	2006-09-07 00:00:00	2006-09-07	2006-09-07 00:00:00	2006-09-07	581452		0	0	0		0	0	0	306864	0	114	40213180		
180488	3967	40213160	1960-10-09	1960-10-09 00:00:00	1960-10-09	1960-10-09 00:00:00	1960-10-09	581452		0	0	0		0	0	0	263780	0	10	40213160		
11897	992	19059056	1955-05-15	1955-05-15 00:00:00	1955-05-29	1955-05-29 00:00:00	1955-05-29	38000177		0	0	14		0	0	0	65775	0	243670	19059056		
11904	992	1127078	1956-07-25	1956-07-25 00:00:00	1956-08-08	1956-08-08 00:00:00	1956-08-08	38000177		0	0	14		0	0	0	65776	0	282464	1127078		
226589	4975	40213227	2010-07-22	2010-07-22 00:00:00	2010-07-22	2010-07-22 00:00:00	2010-07-22	581452		0	0	0		0	0	0	330858	0	113	40213227		
144772	3181	40213296	1996-01-12	1996-01-12 00:00:00	1996-01-12	1996-01-12 00:00:00	1996-01-12	581452		0	0	0		0	0	0	211790	0	52	40213296		
40624	3367	1127433	1976-02-24	1976-02-24 00:00:00	1976-04-24	1976-04-24 00:00:00	1976-04-24	38000177		0	0	60		0	0	0	223279	0	313782	1127433		
55770	1222	40213198	2018-10-03	2018-10-03 00:00:00	2018-10-03	2018-10-03 00:00:00	2018-10-03	581452		0	0	0		0	0	0	80364	0	133	40213198		
167641	3686	40213260	2018-03-12	2018-03-12 00:00:00	2018-03-12	2018-03-12 00:00:00	2018-03-12	581452		0	0	0		0	0	0	245064	0	121	40213260		
96763	2122	40213160	1974-03-30	1974-03-30 00:00:00	1974-03-30	1974-03-30 00:00:00	1974-03-30	581452		0	0	0		0	0	0	141177	0	10	40213160		
53566	4452	1127433	1987-07-15	1987-07-15 00:00:00	1987-07-22	1987-07-22 00:00:00	1987-07-22	38000177		0	0	7		0	0	0	296249	0	313782	1127433		
34483	2849	19059056	1921-09-22	1921-09-22 00:00:00	1921-10-06	1921-10-06 00:00:00	1921-10-06	38000177		0	0	14		0	0	0	189273	0	243670	19059056		
62347	5190	1127433	1971-05-21	1971-05-21 00:00:00	1971-06-04	1971-06-04 00:00:00	1971-06-04	38000177		0	0	14		0	0	0	345051	0	313782	1127433		
84036	1837	40213160	1960-08-19	1960-08-19 00:00:00	1960-08-19	1960-08-19 00:00:00	1960-08-19	581452		0	0	0		0	0	0	122690	0	10	40213160		
112425	2470	40213160	1959-03-23	1959-03-23 00:00:00	1959-03-23	1959-03-23 00:00:00	1959-03-23	581452		0	0	0		0	0	0	163823	0	10	40213160		
188639	4142	40213251	1986-05-25	1986-05-25 00:00:00	1986-05-25	1986-05-25 00:00:00	1986-05-25	581452		0	0	0		0	0	0	275298	0	21	40213251		
188657	4142	40213227	2003-07-20	2003-07-20 00:00:00	2003-07-20	2003-07-20 00:00:00	2003-07-20	581452		0	0	0		0	0	0	275336	0	113	40213227		
85800	1879	40213260	2010-07-17	2010-07-17 00:00:00	2010-07-17	2010-07-17 00:00:00	2010-07-17	581452		0	0	0		0	0	0	125425	0	121	40213260		
7633	164	40213260	2016-05-16	2016-05-16 00:00:00	2016-05-16	2016-05-16 00:00:00	2016-05-16	581452		0	0	0		0	0	0	11263	0	121	40213260		
31136	2580	19128065	1975-05-21	1975-05-21 00:00:00	1976-05-15	1976-05-15 00:00:00	1976-05-15	38000177		0	0	360		0	0	0	170860	0	749882	19128065		
125319	2757	40213160	1973-07-13	1973-07-13 00:00:00	1973-07-13	1973-07-13 00:00:00	1973-07-13	581452		0	0	0		0	0	0	182333	0	10	40213160		
213462	4680	40213227	1992-12-05	1992-12-05 00:00:00	1992-12-05	1992-12-05 00:00:00	1992-12-05	581452		0	0	0		0	0	0	311858	0	113	40213227		
19679	1618	1127433	1992-12-21	1992-12-21 00:00:00	1993-01-04	1993-01-04 00:00:00	1993-01-04	38000177		0	0	14		0	0	0	108827	0	313782	1127433		
25391	2087	19059056	1927-09-23	1927-09-23 00:00:00	1927-10-23	1927-10-23 00:00:00	1927-10-23	38000177		0	0	30		0	0	0	139099	0	243670	19059056		
30568	2535	1713671	2015-04-03	2015-04-03 00:00:00	2015-04-17	2015-04-17 00:00:00	2015-04-17	38000177		0	0	14		0	0	0	167537	0	562251	1713671		
199353	4379	40213306	1991-12-17	1991-12-17 00:00:00	1991-12-17	1991-12-17 00:00:00	1991-12-17	581452		0	0	0		0	0	0	290960	0	43	40213306		
14280	1197	1127078	1987-01-18	1987-01-18 00:00:00	1987-02-08	1987-02-08 00:00:00	1987-02-08	38000177		0	0	21		0	0	0	78848	0	282464	1127078		
29059	2404	19006318	1966-05-04	1966-05-04 00:00:00	1966-05-18	1966-05-18 00:00:00	1966-05-18	38000177		0	0	14		0	0	0	159752	0	105078	19006318		
190060	4173	40213260	2013-08-14	2013-08-14 00:00:00	2013-08-14	2013-08-14 00:00:00	2013-08-14	581452		0	0	0		0	0	0	277310	0	121	40213260		
165467	3637	40213227	2010-07-27	2010-07-27 00:00:00	2010-07-27	2010-07-27 00:00:00	2010-07-27	581452		0	0	0		0	0	0	241932	0	113	40213227		
53383	4437	19129655	1970-06-15	1970-06-15 00:00:00	1970-06-29	1970-06-29 00:00:00	1970-06-29	38000177		0	0	14		0	0	0	294917	0	789980	19129655		
51553	4284	19133873	1951-04-02	1951-04-02 00:00:00	1951-04-13	1951-04-13 00:00:00	1951-04-13	38000177		0	0	11		0	0	0	284364	0	834061	19133873		
207080	4543	40213227	2001-11-24	2001-11-24 00:00:00	2001-11-24	2001-11-24 00:00:00	2001-11-24	581452		0	0	0		0	0	0	302577	0	113	40213227		
63761	5299	19074679	2011-09-18	2011-09-18 00:00:00	2011-09-18	2011-09-18 00:00:00	\N	38000177		0	0	0		0	0	0	352526	0	308971	19074679		
84205	1842	40213160	1966-01-28	1966-01-28 00:00:00	1966-01-28	1966-01-28 00:00:00	1966-01-28	581452		0	0	0		0	0	0	122969	0	10	40213160		
53775	4471	19078461	1996-04-03	1996-04-03 00:00:00	1996-06-02	1996-06-02 00:00:00	1996-06-02	38000177		0	0	60		0	0	0	297400	0	310965	19078461		
61570	1345	40213160	1971-02-23	1971-02-23 00:00:00	1971-02-23	1971-02-23 00:00:00	1971-02-23	581452		0	0	0		0	0	0	89112	0	10	40213160		
80461	1760	40213314	1978-08-27	1978-08-27 00:00:00	1978-08-27	1978-08-27 00:00:00	1978-08-27	581452		0	0	0		0	0	0	117647	0	49	40213314		
179237	3941	40213160	1963-10-01	1963-10-01 00:00:00	1963-10-01	1963-10-01 00:00:00	1963-10-01	581452		0	0	0		0	0	0	262051	0	10	40213160		
2011	43	40213260	2007-08-20	2007-08-20 00:00:00	2007-08-20	2007-08-20 00:00:00	2007-08-20	581452		0	0	0		0	0	0	3220	0	121	40213260		
56937	4724	19008572	1988-06-09	1988-06-09 00:00:00	1988-06-23	1988-06-23 00:00:00	1988-06-23	38000177		0	0	14		0	0	0	314723	0	106258	19008572		
56522	4689	19059056	1969-11-13	1969-11-13 00:00:00	1969-11-27	1969-11-27 00:00:00	1969-11-27	38000177		0	0	14		0	0	0	312417	0	243670	19059056		
3805	82	40213160	1966-03-01	1966-03-01 00:00:00	1966-03-01	1966-03-01 00:00:00	1966-03-01	581452		0	0	0		0	0	0	5590	0	10	40213160		
10445	870	19133873	1970-04-17	1970-04-17 00:00:00	1970-04-30	1970-04-30 00:00:00	1970-04-30	38000177		0	0	13		0	0	0	57904	0	834061	19133873		
8207	685	1127078	1968-02-05	1968-02-05 00:00:00	1968-02-19	1968-02-19 00:00:00	1968-02-19	38000177		0	0	14		0	0	0	45334	0	282464	1127078		
224534	4929	40213160	1962-08-25	1962-08-25 00:00:00	1962-08-25	1962-08-25 00:00:00	1962-08-25	581452		0	0	0		0	0	0	327674	0	10	40213160		
210059	4606	40213160	1987-01-15	1987-01-15 00:00:00	1987-01-15	1987-01-15 00:00:00	1987-01-15	581452		0	0	0		0	0	0	306827	0	10	40213160		
180494	3967	40213306	1983-01-30	1983-01-30 00:00:00	1983-01-30	1983-01-30 00:00:00	1983-01-30	581452		0	0	0		0	0	0	263740	0	43	40213306		
11898	992	19006318	1955-05-15	1955-05-15 00:00:00	1955-05-29	1955-05-29 00:00:00	1955-05-29	38000177		0	0	14		0	0	0	65775	0	105078	19006318		
11905	992	19006318	1956-07-25	1956-07-25 00:00:00	1956-08-08	1956-08-08 00:00:00	1956-08-08	38000177		0	0	14		0	0	0	65776	0	105078	19006318		
226597	4975	40213227	1992-06-11	1992-06-11 00:00:00	1992-06-11	1992-06-11 00:00:00	1992-06-11	581452		0	0	0		0	0	0	330861	0	113	40213227		
98420	2155	40213227	2008-04-30	2008-04-30 00:00:00	2008-04-30	2008-04-30 00:00:00	2008-04-30	581452		0	0	0		0	0	0	143652	0	113	40213227		
40625	3367	40165015	1976-02-24	1976-02-24 00:00:00	1976-02-24	1976-02-24 00:00:00	\N	38000177		0	0	0		0	0	0	223279	0	861467	40165015		
55774	1222	40213227	2005-03-16	2005-03-16 00:00:00	2005-03-16	2005-03-16 00:00:00	2005-03-16	581452		0	0	0		0	0	0	80390	0	113	40213227		
167645	3686	40213296	2011-01-03	2011-01-03 00:00:00	2011-01-03	2011-01-03 00:00:00	2011-01-03	581452		0	0	0		0	0	0	245062	0	52	40213296		
96766	2122	40213160	1974-01-26	1974-01-26 00:00:00	1974-01-26	1974-01-26 00:00:00	1974-01-26	581452		0	0	0		0	0	0	141198	0	10	40213160		
53567	4452	1127433	1977-01-28	1977-01-28 00:00:00	1977-02-04	1977-02-04 00:00:00	1977-02-04	38000177		0	0	7		0	0	0	296273	0	313782	1127433		
34484	2849	1115171	2004-04-28	2004-04-28 00:00:00	2004-06-27	2004-06-27 00:00:00	2004-06-27	38000177		0	0	60		0	0	0	189297	0	849574	1115171		
62348	5190	1127433	2009-03-20	2009-03-20 00:00:00	2009-04-03	2009-04-03 00:00:00	2009-04-03	38000177		0	0	14		0	0	0	344996	0	313782	1127433		
90038	1976	40213180	2005-02-21	2005-02-21 00:00:00	2005-02-21	2005-02-21 00:00:00	2005-02-21	581452		0	0	0		0	0	0	131418	0	114	40213180		
112430	2470	40213306	1981-02-16	1981-02-16 00:00:00	1981-02-16	1981-02-16 00:00:00	1981-02-16	581452		0	0	0		0	0	0	163813	0	43	40213306		
188641	4142	40213160	1986-05-25	1986-05-25 00:00:00	1986-05-25	1986-05-25 00:00:00	1986-05-25	581452		0	0	0		0	0	0	275298	0	10	40213160		
188658	4142	40213306	2003-09-07	2003-09-07 00:00:00	2003-09-07	2003-09-07 00:00:00	2003-09-07	581452		0	0	0		0	0	0	275302	0	43	40213306		
85810	1879	40213227	2000-06-17	2000-06-17 00:00:00	2000-06-17	2000-06-17 00:00:00	2000-06-17	581452		0	0	0		0	0	0	125423	0	113	40213227		
7636	164	40213160	1966-04-11	1966-04-11 00:00:00	1966-04-11	1966-04-11 00:00:00	1966-04-11	581452		0	0	0		0	0	0	11307	0	10	40213160		
31137	2580	1332419	1995-02-20	1995-02-20 00:00:00	1995-02-20	1995-02-20 00:00:00	\N	38000177		0	0	0		0	0	0	170916	0	197361	1332419		
125322	2757	40213314	1976-12-31	1976-12-31 00:00:00	1976-12-31	1976-12-31 00:00:00	1976-12-31	581452		0	0	0		0	0	0	182341	0	49	40213314		
167151	3675	40213260	2017-12-11	2017-12-11 00:00:00	2017-12-11	2017-12-11 00:00:00	2017-12-11	581452		0	0	0		0	0	0	244473	0	121	40213260		
19680	1618	19128022	1990-04-27	1990-04-27 00:00:00	1991-04-22	1991-04-22 00:00:00	1991-04-22	38000177		0	0	360		0	0	0	108788	0	749785	19128022		
25392	2087	19059056	1950-11-21	1950-11-21 00:00:00	1950-12-05	1950-12-05 00:00:00	1950-12-05	38000177		0	0	14		0	0	0	139100	0	243670	19059056		
30569	2535	1127433	2015-02-02	2015-02-02 00:00:00	2015-02-16	2015-02-16 00:00:00	2015-02-16	38000177		0	0	14		0	0	0	167523	0	313782	1127433		
199355	4379	40213227	2000-12-26	2000-12-26 00:00:00	2000-12-26	2000-12-26 00:00:00	2000-12-26	581452		0	0	0		0	0	0	290963	0	113	40213227		
14281	1197	40229134	1997-11-04	1997-11-04 00:00:00	1997-11-11	1997-11-11 00:00:00	1997-11-11	38000177		0	0	7		0	0	0	78843	0	1043400	40229134		
29060	2404	1127433	1987-05-15	1987-05-15 00:00:00	1987-05-22	1987-05-22 00:00:00	1987-05-22	38000177		0	0	7		0	0	0	159771	0	313782	1127433		
190063	4173	40213160	1968-04-17	1968-04-17 00:00:00	1968-04-17	1968-04-17 00:00:00	1968-04-17	581452		0	0	0		0	0	0	277338	0	10	40213160		
165476	3638	40213160	1964-01-09	1964-01-09 00:00:00	1964-01-09	1964-01-09 00:00:00	1964-01-09	581452		0	0	0		0	0	0	241949	0	10	40213160		
53384	4437	19059056	1970-06-15	1970-06-15 00:00:00	1970-06-29	1970-06-29 00:00:00	1970-06-29	38000177		0	0	14		0	0	0	294917	0	243670	19059056		
51554	4284	19133905	2011-09-29	2011-09-29 00:00:00	2011-10-07	2011-10-07 00:00:00	2011-10-07	38000177		0	0	8		0	0	0	284395	0	834102	19133905		
207082	4543	40213251	1984-08-18	1984-08-18 00:00:00	1984-08-18	1984-08-18 00:00:00	1984-08-18	581452		0	0	0		0	0	0	302612	0	21	40213251		
63762	5299	1115171	2018-12-17	2018-12-17 00:00:00	2019-01-07	2019-01-07 00:00:00	2019-01-07	38000177		0	0	21		0	0	0	352489	0	849574	1115171		
84207	1842	40213260	2017-07-21	2017-07-21 00:00:00	2017-07-21	2017-07-21 00:00:00	2017-07-21	581452		0	0	0		0	0	0	122981	0	121	40213260		
53776	4471	40165015	1996-04-03	1996-04-03 00:00:00	1996-04-03	1996-04-03 00:00:00	\N	38000177		0	0	0		0	0	0	297400	0	861467	40165015		
167351	3680	40213160	1979-12-11	1979-12-11 00:00:00	1979-12-11	1979-12-11 00:00:00	1979-12-11	581452		0	0	0		0	0	0	244717	0	10	40213160		
80471	1760	40213227	2000-06-18	2000-06-18 00:00:00	2000-06-18	2000-06-18 00:00:00	2000-06-18	581452		0	0	0		0	0	0	117652	0	113	40213227		
179241	3941	40213160	1967-11-14	1967-11-14 00:00:00	1967-11-14	1967-11-14 00:00:00	1967-11-14	581452		0	0	0		0	0	0	262066	0	10	40213160		
2015	43	40213160	1957-03-25	1957-03-25 00:00:00	1957-03-25	1957-03-25 00:00:00	1957-03-25	581452		0	0	0		0	0	0	3177	0	10	40213160		
56938	4724	19059056	1942-03-03	1942-03-03 00:00:00	1942-03-17	1942-03-17 00:00:00	1942-03-17	38000177		0	0	14		0	0	0	314817	0	243670	19059056		
56523	4689	19128065	1983-04-26	1983-04-26 00:00:00	1984-04-19	1984-04-19 00:00:00	1984-04-19	38000177		0	0	359		0	0	0	312433	0	749882	19128065		
3819	82	40213260	2011-05-10	2011-05-10 00:00:00	2011-05-10	2011-05-10 00:00:00	2011-05-10	581452		0	0	0		0	0	0	5552	0	121	40213260		
10446	870	19133905	2011-11-23	2011-11-23 00:00:00	2011-12-04	2011-12-04 00:00:00	2011-12-04	38000177		0	0	11		0	0	0	57855	0	834102	19133905		
8208	685	19006318	1968-02-05	1968-02-05 00:00:00	1968-02-19	1968-02-19 00:00:00	1968-02-19	38000177		0	0	14		0	0	0	45334	0	105078	19006318		
224539	4929	40213296	2004-10-09	2004-10-09 00:00:00	2004-10-09	2004-10-09 00:00:00	2004-10-09	581452		0	0	0		0	0	0	327685	0	52	40213296		
210060	4606	40213251	1987-01-15	1987-01-15 00:00:00	1987-01-15	1987-01-15 00:00:00	1987-01-15	581452		0	0	0		0	0	0	306827	0	21	40213251		
180495	3967	40213160	1961-01-08	1961-01-08 00:00:00	1961-01-08	1961-01-08 00:00:00	1961-01-08	581452		0	0	0		0	0	0	263715	0	10	40213160		
11899	992	1127433	1987-07-01	1987-07-01 00:00:00	1987-07-15	1987-07-15 00:00:00	1987-07-15	38000177		0	0	14		0	0	0	65771	0	313782	1127433		
11907	992	1127433	1997-02-01	1997-02-01 00:00:00	1997-04-02	1997-04-02 00:00:00	1997-04-02	38000177		0	0	60		0	0	0	65750	0	313782	1127433		
239942	5267	40213227	2008-10-05	2008-10-05 00:00:00	2008-10-05	2008-10-05 00:00:00	2008-10-05	581452		0	0	0		0	0	0	\N	0	113	40213227		
98436	2155	40213227	1997-08-13	1997-08-13 00:00:00	1997-08-13	1997-08-13 00:00:00	1997-08-13	581452		0	0	0		0	0	0	143625	0	113	40213227		
61157	5086	1127078	1978-04-02	1978-04-02 00:00:00	1978-05-02	1978-05-02 00:00:00	1978-05-02	38000177		0	0	30		0	0	0	338199	0	282464	1127078		
55778	1222	40213160	1955-08-03	1955-08-03 00:00:00	1955-08-03	1955-08-03 00:00:00	1955-08-03	581452		0	0	0		0	0	0	80375	0	10	40213160		
167648	3686	40213306	1990-03-19	1990-03-19 00:00:00	1990-03-19	1990-03-19 00:00:00	1990-03-19	581452		0	0	0		0	0	0	245044	0	43	40213306		
96769	2122	40213160	1978-09-30	1978-09-30 00:00:00	1978-09-30	1978-09-30 00:00:00	1978-09-30	581452		0	0	0		0	0	0	141179	0	10	40213160		
53572	4454	1127433	1998-02-17	1998-02-17 00:00:00	1998-04-18	1998-04-18 00:00:00	1998-04-18	38000177		0	0	60		0	0	0	296502	0	313782	1127433		
34485	2849	19059056	1937-08-13	1937-08-13 00:00:00	1937-09-03	1937-09-03 00:00:00	1937-09-03	38000177		0	0	21		0	0	0	189292	0	243670	19059056		
62349	5190	19133873	1974-10-21	1974-10-21 00:00:00	1974-10-31	1974-10-31 00:00:00	1974-10-31	38000177		0	0	10		0	0	0	344974	0	834061	19133873		
90040	1976	40213306	2003-12-08	2003-12-08 00:00:00	2003-12-08	2003-12-08 00:00:00	2003-12-08	581452		0	0	0		0	0	0	\N	0	43	40213306		
129600	2849	40213201	1986-03-03	1986-03-03 00:00:00	1986-03-03	1986-03-03 00:00:00	1986-03-03	581452		0	0	0		0	0	0	189282	0	33	40213201		
188646	4142	40213160	1982-02-21	1982-02-21 00:00:00	1982-02-21	1982-02-21 00:00:00	1982-02-21	581452		0	0	0		0	0	0	275329	0	10	40213160		
199944	4391	40213227	2012-06-08	2012-06-08 00:00:00	2012-06-08	2012-06-08 00:00:00	2012-06-08	581452		0	0	0		0	0	0	291995	0	113	40213227		
85811	1879	40213296	2000-06-17	2000-06-17 00:00:00	2000-06-17	2000-06-17 00:00:00	2000-06-17	581452		0	0	0		0	0	0	125423	0	52	40213296		
160388	3529	40213227	1995-06-14	1995-06-14 00:00:00	1995-06-14	1995-06-14 00:00:00	1995-06-14	581452		0	0	0		0	0	0	234329	0	113	40213227		
31138	2580	19126352	1963-05-20	1963-05-20 00:00:00	1963-05-20	1963-05-20 00:00:00	\N	38000177		0	0	0		0	0	0	170875	0	705129	19126352		
125324	2757	40213306	1995-03-31	1995-03-31 00:00:00	1995-03-31	1995-03-31 00:00:00	1995-03-31	581452		0	0	0		0	0	0	182346	0	43	40213306		
167153	3675	40213160	1967-07-24	1967-07-24 00:00:00	1967-07-24	1967-07-24 00:00:00	1967-07-24	581452		0	0	0		0	0	0	244480	0	10	40213160		
19701	1622	19128065	1994-04-22	1994-04-22 00:00:00	1995-04-17	1995-04-17 00:00:00	1995-04-17	38000177		0	0	360		0	0	0	108958	0	749882	19128065		
25393	2087	1127433	1936-09-15	1936-09-15 00:00:00	1936-09-22	1936-09-22 00:00:00	1936-09-22	38000177		0	0	7		0	0	0	139026	0	313782	1127433		
30570	2535	19133905	1994-12-04	1994-12-04 00:00:00	1994-12-13	1994-12-13 00:00:00	1994-12-13	38000177		0	0	9		0	0	0	167554	0	834102	19133905		
199356	4379	40213160	1969-09-23	1969-09-23 00:00:00	1969-09-23	1969-09-23 00:00:00	1969-09-23	581452		0	0	0		0	0	0	290976	0	10	40213160		
14282	1197	19133873	1981-12-17	1981-12-17 00:00:00	1981-12-27	1981-12-27 00:00:00	1981-12-27	38000177		0	0	10		0	0	0	78842	0	834061	19133873		
29061	2404	1127433	1986-11-11	1986-11-11 00:00:00	1986-12-11	1986-12-11 00:00:00	1986-12-11	38000177		0	0	30		0	0	0	159762	0	313782	1127433		
190068	4173	40213160	1963-11-20	1963-11-20 00:00:00	1963-11-20	1963-11-20 00:00:00	1963-11-20	581452		0	0	0		0	0	0	277334	0	10	40213160		
165478	3638	40213260	2013-05-02	2013-05-02 00:00:00	2013-05-02	2013-05-02 00:00:00	2013-05-02	581452		0	0	0		0	0	0	241963	0	121	40213260		
53385	4437	1127433	1976-08-31	1976-08-31 00:00:00	1976-09-07	1976-09-07 00:00:00	1976-09-07	38000177		0	0	7		0	0	0	294930	0	313782	1127433		
51555	4284	19133905	1981-11-13	1981-11-13 00:00:00	1981-11-25	1981-11-25 00:00:00	1981-11-25	38000177		0	0	12		0	0	0	284328	0	834102	19133905		
136034	2987	40213306	1993-03-08	1993-03-08 00:00:00	1993-03-08	1993-03-08 00:00:00	1993-03-08	581452		0	0	0		0	0	0	199408	0	43	40213306		
63763	5299	19074679	2009-05-10	2009-05-10 00:00:00	2009-10-25	2009-10-25 00:00:00	2009-10-25	38000177		0	0	168		0	0	0	352491	0	308971	19074679		
84209	1842	40213227	2017-07-21	2017-07-21 00:00:00	2017-07-21	2017-07-21 00:00:00	2017-07-21	581452		0	0	0		0	0	0	122981	0	113	40213227		
53777	4471	19128065	1979-06-12	1979-06-12 00:00:00	1980-06-06	1980-06-06 00:00:00	1980-06-06	38000177		0	0	360		0	0	0	297449	0	749882	19128065		
167354	3680	40213314	1979-09-11	1979-09-11 00:00:00	1979-09-11	1979-09-11 00:00:00	1979-09-11	581452		0	0	0		0	0	0	244698	0	49	40213314		
80472	1760	40213306	2000-06-18	2000-06-18 00:00:00	2000-06-18	2000-06-18 00:00:00	2000-06-18	581452		0	0	0		0	0	0	117652	0	43	40213306		
179242	3941	40213160	1963-07-02	1963-07-02 00:00:00	1963-07-02	1963-07-02 00:00:00	1963-07-02	581452		0	0	0		0	0	0	262001	0	10	40213160		
2017	43	40213160	1957-05-27	1957-05-27 00:00:00	1957-05-27	1957-05-27 00:00:00	1957-05-27	581452		0	0	0		0	0	0	3152	0	10	40213160		
37552	820	40213306	1986-08-07	1986-08-07 00:00:00	1986-08-07	1986-08-07 00:00:00	1986-08-07	581452		0	0	0		0	0	0	54344	0	43	40213306		
56524	4690	19059056	1971-11-18	1971-11-18 00:00:00	1971-12-02	1971-12-02 00:00:00	1971-12-02	38000177		0	0	14		0	0	0	312490	0	243670	19059056		
3821	82	40213160	1961-06-27	1961-06-27 00:00:00	1961-06-27	1961-06-27 00:00:00	1961-06-27	581452		0	0	0		0	0	0	5582	0	10	40213160		
10447	870	1127433	1977-09-15	1977-09-15 00:00:00	1977-09-22	1977-09-22 00:00:00	1977-09-22	38000177		0	0	7		0	0	0	57885	0	313782	1127433		
8209	685	1713671	2016-01-11	2016-01-11 00:00:00	2016-01-25	2016-01-25 00:00:00	2016-01-25	38000177		0	0	14		0	0	0	45279	0	562251	1713671		
224541	4929	40213227	2004-10-09	2004-10-09 00:00:00	2004-10-09	2004-10-09 00:00:00	2004-10-09	581452		0	0	0		0	0	0	327685	0	113	40213227		
210063	4606	40213227	2013-06-13	2013-06-13 00:00:00	2013-06-13	2013-06-13 00:00:00	2013-06-13	581452		0	0	0		0	0	0	306870	0	113	40213227		
180500	3967	40213296	2000-05-07	2000-05-07 00:00:00	2000-05-07	2000-05-07 00:00:00	2000-05-07	581452		0	0	0		0	0	0	263742	0	52	40213296		
11900	992	40229134	1956-09-07	1956-09-07 00:00:00	1956-09-21	1956-09-21 00:00:00	1956-09-21	38000177		0	0	14		0	0	0	65727	0	1043400	40229134		
11908	992	920334	2005-09-23	2005-09-23 00:00:00	2005-09-30	2005-09-30 00:00:00	2005-09-30	38000177		0	0	7		0	0	0	65808	0	311995	920334		
239943	5267	40213296	2008-10-05	2008-10-05 00:00:00	2008-10-05	2008-10-05 00:00:00	2008-10-05	581452		0	0	0		0	0	0	\N	0	52	40213296		
109729	2411	40213160	1969-06-12	1969-06-12 00:00:00	1969-06-12	1969-06-12 00:00:00	1969-06-12	581452		0	0	0		0	0	0	160021	0	10	40213160		
61158	5086	1127433	2017-05-23	2017-05-23 00:00:00	2017-05-30	2017-05-30 00:00:00	2017-05-30	38000177		0	0	7		0	0	0	338183	0	313782	1127433		
55784	1222	40213227	1995-02-15	1995-02-15 00:00:00	1995-02-15	1995-02-15 00:00:00	1995-02-15	581452		0	0	0		0	0	0	80383	0	113	40213227		
121320	2666	40213198	2016-08-14	2016-08-14 00:00:00	2016-08-14	2016-08-14 00:00:00	2016-08-14	581452		0	0	0		0	0	0	176659	0	133	40213198		
96775	2122	40213160	1974-06-29	1974-06-29 00:00:00	1974-06-29	1974-06-29 00:00:00	1974-06-29	581452		0	0	0		0	0	0	141219	0	10	40213160		
53573	4454	40229134	1932-10-04	1932-10-04 00:00:00	1932-10-18	1932-10-18 00:00:00	1932-10-18	38000177		0	0	14		0	0	0	296413	0	1043400	40229134		
34486	2849	1118084	1959-04-16	1959-04-16 00:00:00	1959-04-16	1959-04-16 00:00:00	\N	38000177		0	0	0		0	0	0	189254	0	00025152531	44923712		
62350	5190	1127078	1962-06-02	1962-06-02 00:00:00	1962-06-23	1962-06-23 00:00:00	1962-06-23	38000177		0	0	21		0	0	0	345057	0	282464	1127078		
90045	1976	40213314	1983-05-30	1983-05-30 00:00:00	1983-05-30	1983-05-30 00:00:00	1983-05-30	581452		0	0	0		0	0	0	131388	0	49	40213314		
129633	2849	40213227	1992-06-22	1992-06-22 00:00:00	1992-06-22	1992-06-22 00:00:00	1992-06-22	581452		0	0	0		0	0	0	189231	0	113	40213227		
188647	4142	40213314	1981-09-20	1981-09-20 00:00:00	1981-09-20	1981-09-20 00:00:00	1981-09-20	581452		0	0	0		0	0	0	275328	0	49	40213314		
181426	3987	40213160	1955-06-04	1955-06-04 00:00:00	1955-06-04	1955-06-04 00:00:00	1955-06-04	581452		0	0	0		0	0	0	265075	0	10	40213160		
85813	1879	40213160	1959-03-14	1959-03-14 00:00:00	1959-03-14	1959-03-14 00:00:00	1959-03-14	581452		0	0	0		0	0	0	125419	0	10	40213160		
160395	3529	40213227	2015-10-07	2015-10-07 00:00:00	2015-10-07	2015-10-07 00:00:00	2015-10-07	581452		0	0	0		0	0	0	234432	0	113	40213227		
31139	2580	1127433	2012-06-14	2012-06-14 00:00:00	2012-06-28	2012-06-28 00:00:00	2012-06-28	38000177		0	0	14		0	0	0	170910	0	313782	1127433		
125326	2757	40213227	1995-03-31	1995-03-31 00:00:00	1995-03-31	1995-03-31 00:00:00	1995-03-31	581452		0	0	0		0	0	0	182346	0	113	40213227		
167159	3675	40213160	1967-12-25	1967-12-25 00:00:00	1967-12-25	1967-12-25 00:00:00	1967-12-25	581452		0	0	0		0	0	0	244481	0	10	40213160		
19702	1622	40224805	1997-04-06	1997-04-06 00:00:00	1998-04-01	1998-04-01 00:00:00	1998-04-01	38000177		0	0	360		0	0	0	108976	0	1000126	40224805		
25394	2087	19075601	2016-12-07	2016-12-07 00:00:00	2016-12-07	2016-12-07 00:00:00	\N	38000177		0	0	0		0	0	0	139097	0	309362	19075601		
30571	2535	19133873	1972-09-09	1972-09-09 00:00:00	1972-09-18	1972-09-18 00:00:00	1972-09-18	38000177		0	0	9		0	0	0	167482	0	834061	19133873		
199359	4379	40213160	1970-02-24	1970-02-24 00:00:00	1970-02-24	1970-02-24 00:00:00	1970-02-24	581452		0	0	0		0	0	0	290977	0	10	40213160		
14283	1197	40229134	1980-08-23	1980-08-23 00:00:00	1980-09-06	1980-09-06 00:00:00	1980-09-06	38000177		0	0	14		0	0	0	78865	0	1043400	40229134		
29062	2404	40220960	1997-07-13	1997-07-13 00:00:00	1997-07-13	1997-07-13 00:00:00	1997-07-13	38000177		0	0	0		0	0	0	159736	0	1804799	40220960		
14347	1205	19129655	1965-08-05	1965-08-05 00:00:00	1965-08-19	1965-08-19 00:00:00	1965-08-19	38000177		0	0	14		0	0	0	79148	0	789980	19129655		
165484	3638	40213260	2014-05-08	2014-05-08 00:00:00	2014-05-08	2014-05-08 00:00:00	2014-05-08	581452		0	0	0		0	0	0	242024	0	121	40213260		
53386	4437	19133873	1976-10-01	1976-10-01 00:00:00	1976-10-08	1976-10-08 00:00:00	1976-10-08	38000177		0	0	7		0	0	0	294941	0	834061	19133873		
51556	4284	19006318	1947-07-01	1947-07-01 00:00:00	1947-07-15	1947-07-15 00:00:00	1947-07-15	38000177		0	0	14		0	0	0	284382	0	105078	19006318		
147347	3240	40213227	2007-07-25	2007-07-25 00:00:00	2007-07-25	2007-07-25 00:00:00	2007-07-25	581452		0	0	0		0	0	0	215426	0	113	40213227		
63764	5299	1127433	2000-04-20	2000-04-20 00:00:00	2000-05-04	2000-05-04 00:00:00	2000-05-04	38000177		0	0	14		0	0	0	352529	0	313782	1127433		
84215	1842	40213296	2009-06-26	2009-06-26 00:00:00	2009-06-26	2009-06-26 00:00:00	2009-06-26	581452		0	0	0		0	0	0	122942	0	52	40213296		
53779	4471	1713671	1969-11-09	1969-11-09 00:00:00	1969-11-23	1969-11-23 00:00:00	1969-11-23	38000177		0	0	14		0	0	0	297452	0	562251	1713671		
167357	3680	40213160	1979-09-11	1979-09-11 00:00:00	1979-09-11	1979-09-11 00:00:00	1979-09-11	581452		0	0	0		0	0	0	244698	0	10	40213160		
80483	1761	40213227	1994-01-09	1994-01-09 00:00:00	1994-01-09	1994-01-09 00:00:00	1994-01-09	581452		0	0	0		0	0	0	117733	0	113	40213227		
179244	3941	40213227	2005-07-05	2005-07-05 00:00:00	2005-07-05	2005-07-05 00:00:00	2005-07-05	581452		0	0	0		0	0	0	262015	0	113	40213227		
2021	43	40213160	1961-11-27	1961-11-27 00:00:00	1961-11-27	1961-11-27 00:00:00	1961-11-27	581452		0	0	0		0	0	0	3198	0	10	40213160		
37557	820	40213227	2007-01-25	2007-01-25 00:00:00	2007-01-25	2007-01-25 00:00:00	2007-01-25	581452		0	0	0		0	0	0	54348	0	113	40213227		
56525	4690	19059056	1959-02-24	1959-02-24 00:00:00	1959-04-25	1959-04-25 00:00:00	1959-04-25	38000177		0	0	60		0	0	0	312519	0	243670	19059056		
3822	82	40213296	2001-03-27	2001-03-27 00:00:00	2001-03-27	2001-03-27 00:00:00	2001-03-27	581452		0	0	0		0	0	0	5561	0	52	40213296		
10448	870	1127433	2008-03-10	2008-03-10 00:00:00	2008-03-24	2008-03-24 00:00:00	2008-03-24	38000177		0	0	14		0	0	0	57854	0	313782	1127433		
8210	686	1127433	1963-07-11	1963-07-11 00:00:00	1963-08-15	1963-08-15 00:00:00	1963-08-15	38000177		0	0	35		0	0	0	45424	0	313782	1127433		
224543	4929	40213160	1966-11-26	1966-11-26 00:00:00	1966-11-26	1966-11-26 00:00:00	1966-11-26	581452		0	0	0		0	0	0	327677	0	10	40213160		
210065	4606	40213160	1982-10-14	1982-10-14 00:00:00	1982-10-14	1982-10-14 00:00:00	1982-10-14	581452		0	0	0		0	0	0	306834	0	10	40213160		
180503	3967	40213296	2002-05-12	2002-05-12 00:00:00	2002-05-12	2002-05-12 00:00:00	2002-05-12	581452		0	0	0		0	0	0	263747	0	52	40213296		
11901	992	1127433	1960-07-03	1960-07-03 00:00:00	1960-07-10	1960-07-10 00:00:00	1960-07-10	38000177		0	0	7		0	0	0	65764	0	313782	1127433		
11910	992	40236824	2005-09-16	2005-09-16 00:00:00	2005-09-30	2005-09-30 00:00:00	2005-09-30	38000177		0	0	14		0	0	0	65741	0	1094107	40236824		
239946	5267	40213306	1989-02-05	1989-02-05 00:00:00	1989-02-05	1989-02-05 00:00:00	1989-02-05	581452		0	0	0		0	0	0	350452	0	43	40213306		
103935	2280	40213260	2019-06-05	2019-06-05 00:00:00	2019-06-05	2019-06-05 00:00:00	2019-06-05	581452		0	0	0		0	0	0	151641	0	121	40213260		
61159	5086	19133873	1980-02-16	1980-02-16 00:00:00	1980-02-27	1980-02-27 00:00:00	1980-02-27	38000177		0	0	11		0	0	0	338196	0	834061	19133873		
55789	1222	40213160	1958-08-06	1958-08-06 00:00:00	1958-08-06	1958-08-06 00:00:00	1958-08-06	581452		0	0	0		0	0	0	80377	0	10	40213160		
121328	2666	40213227	2012-07-22	2012-07-22 00:00:00	2012-07-22	2012-07-22 00:00:00	2012-07-22	581452		0	0	0		0	0	0	176657	0	113	40213227		
96780	2122	40213296	2013-10-26	2013-10-26 00:00:00	2013-10-26	2013-10-26 00:00:00	2013-10-26	581452		0	0	0		0	0	0	141175	0	52	40213296		
53574	4454	1118084	1963-06-08	1963-06-08 00:00:00	1963-06-08	1963-06-08 00:00:00	\N	38000177		0	0	0		0	0	0	296474	0	00025152531	44923712		
34487	2849	1127433	1928-09-27	1928-09-27 00:00:00	1928-10-04	1928-10-04 00:00:00	1928-10-04	38000177		0	0	7		0	0	0	189300	0	313782	1127433		
62352	5190	1127433	1990-10-05	1990-10-05 00:00:00	1990-10-19	1990-10-19 00:00:00	1990-10-19	38000177		0	0	14		0	0	0	344994	0	313782	1127433		
90046	1976	40213160	1983-05-30	1983-05-30 00:00:00	1983-05-30	1983-05-30 00:00:00	1983-05-30	581452		0	0	0		0	0	0	131388	0	10	40213160		
154813	3407	40213306	1987-02-13	1987-02-13 00:00:00	1987-02-13	1987-02-13 00:00:00	1987-02-13	581452		0	0	0		0	0	0	225994	0	43	40213306		
188648	4142	40213160	1981-09-20	1981-09-20 00:00:00	1981-09-20	1981-09-20 00:00:00	1981-09-20	581452		0	0	0		0	0	0	275328	0	10	40213160		
181428	3987	40213198	2019-03-23	2019-03-23 00:00:00	2019-03-23	2019-03-23 00:00:00	2019-03-23	581452		0	0	0		0	0	0	265053	0	133	40213198		
85815	1879	40213160	1963-09-14	1963-09-14 00:00:00	1963-09-14	1963-09-14 00:00:00	1963-09-14	581452		0	0	0		0	0	0	125421	0	10	40213160		
160396	3529	40213198	2010-09-08	2010-09-08 00:00:00	2010-09-08	2010-09-08 00:00:00	2010-09-08	581452		0	0	0		0	0	0	234333	0	133	40213198		
31140	2580	1127433	1980-01-03	1980-01-03 00:00:00	1980-01-17	1980-01-17 00:00:00	1980-01-17	38000177		0	0	14		0	0	0	170880	0	313782	1127433		
9516	202	40213227	2009-11-28	2009-11-28 00:00:00	2009-11-28	2009-11-28 00:00:00	2009-11-28	581452		0	0	0		0	0	0	13828	0	113	40213227		
167161	3675	40213296	2007-04-23	2007-04-23 00:00:00	2007-04-23	2007-04-23 00:00:00	2007-04-23	581452		0	0	0		0	0	0	244471	0	52	40213296		
19703	1622	19128065	1995-04-17	1995-04-17 00:00:00	1996-04-11	1996-04-11 00:00:00	1996-04-11	38000177		0	0	360		0	0	0	108961	0	749882	19128065		
25395	2087	40173590	1998-07-01	1998-07-01 00:00:00	1998-07-01	1998-07-01 00:00:00	\N	38000177		0	0	0		0	0	0	139057	0	904419	40173590		
30574	2537	1127078	1952-05-22	1952-05-22 00:00:00	1952-06-12	1952-06-12 00:00:00	1952-06-12	38000177		0	0	21		0	0	0	167643	0	282464	1127078		
199365	4380	40213160	1969-03-31	1969-03-31 00:00:00	1969-03-31	1969-03-31 00:00:00	1969-03-31	581452		0	0	0		0	0	0	291012	0	10	40213160		
14300	1201	1127433	1987-06-26	1987-06-26 00:00:00	1987-07-10	1987-07-10 00:00:00	1987-07-10	38000177		0	0	14		0	0	0	79019	0	313782	1127433		
29063	2404	19075601	1997-07-13	1997-07-13 00:00:00	1997-07-13	1997-07-13 00:00:00	1997-07-13	38000177		0	0	0		0	0	0	159736	0	309362	19075601		
14348	1205	19059056	1965-08-05	1965-08-05 00:00:00	1965-08-19	1965-08-19 00:00:00	1965-08-19	38000177		0	0	14		0	0	0	79148	0	243670	19059056		
165486	3638	40213227	2014-05-08	2014-05-08 00:00:00	2014-05-08	2014-05-08 00:00:00	2014-05-08	581452		0	0	0		0	0	0	242024	0	113	40213227		
53387	4437	1713671	1971-05-06	1971-05-06 00:00:00	1971-05-27	1971-05-27 00:00:00	1971-05-27	38000177		0	0	21		0	0	0	294929	0	562251	1713671		
2967	239	19059056	1970-07-26	1970-07-26 00:00:00	1970-08-09	1970-08-09 00:00:00	1970-08-09	38000177		0	0	14		0	0	0	16052	0	243670	19059056		
147352	3240	40213227	1997-01-29	1997-01-29 00:00:00	1997-01-29	1997-01-29 00:00:00	1997-01-29	581452		0	0	0		0	0	0	215374	0	113	40213227		
63765	5299	46233988	1973-10-30	1973-10-30 00:00:00	1973-11-13	1973-11-13 00:00:00	1973-11-13	38000177		0	0	14		0	0	0	352530	0	1652673	46233988		
84225	1842	40213160	1970-07-31	1970-07-31 00:00:00	1970-07-31	1970-07-31 00:00:00	1970-07-31	581452		0	0	0		0	0	0	122983	0	10	40213160		
53780	4472	1713671	1966-07-14	1966-07-14 00:00:00	1966-07-21	1966-07-21 00:00:00	1966-07-21	38000177		0	0	7		0	0	0	297482	0	562251	1713671		
169831	3734	40213227	2010-06-26	2010-06-26 00:00:00	2010-06-26	2010-06-26 00:00:00	2010-06-26	581452		0	0	0		0	0	0	248137	0	113	40213227		
80488	1761	40213160	1955-08-01	1955-08-01 00:00:00	1955-08-01	1955-08-01 00:00:00	1955-08-01	581452		0	0	0		0	0	0	117792	0	10	40213160		
179245	3941	40213296	2005-07-05	2005-07-05 00:00:00	2005-07-05	2005-07-05 00:00:00	2005-07-05	581452		0	0	0		0	0	0	262015	0	52	40213296		
166807	3667	40213160	1968-03-19	1968-03-19 00:00:00	1968-03-19	1968-03-19 00:00:00	1968-03-19	581452		0	0	0		0	0	0	243951	0	10	40213160		
37558	820	40213296	2007-01-25	2007-01-25 00:00:00	2007-01-25	2007-01-25 00:00:00	2007-01-25	581452		0	0	0		0	0	0	54348	0	52	40213296		
56526	4690	40229134	1978-10-14	1978-10-14 00:00:00	1978-10-28	1978-10-28 00:00:00	1978-10-28	38000177		0	0	14		0	0	0	312515	0	1043400	40229134		
95925	2103	40213160	1972-10-21	1972-10-21 00:00:00	1972-10-21	1972-10-21 00:00:00	1972-10-21	581452		0	0	0		0	0	0	140129	0	10	40213160		
10450	870	40229134	1979-05-19	1979-05-19 00:00:00	1979-05-26	1979-05-26 00:00:00	1979-05-26	38000177		0	0	7		0	0	0	57863	0	1043400	40229134		
8211	686	1713671	1969-10-26	1969-10-26 00:00:00	1969-11-02	1969-11-02 00:00:00	1969-11-02	38000177		0	0	7		0	0	0	45418	0	562251	1713671		
227046	4986	40213227	2011-06-26	2011-06-26 00:00:00	2011-06-26	2011-06-26 00:00:00	2011-06-26	581452		0	0	0		0	0	0	331672	0	113	40213227		
116785	2566	40213227	2011-02-22	2011-02-22 00:00:00	2011-02-22	2011-02-22 00:00:00	2011-02-22	581452		0	0	0		0	0	0	169971	0	113	40213227		
180505	3967	40213227	2002-05-12	2002-05-12 00:00:00	2002-05-12	2002-05-12 00:00:00	2002-05-12	581452		0	0	0		0	0	0	263747	0	113	40213227		
11902	992	1127433	1971-09-14	1971-09-14 00:00:00	1971-09-21	1971-09-21 00:00:00	1971-09-21	38000177		0	0	7		0	0	0	65766	0	313782	1127433		
11911	992	920300	2005-09-16	2005-09-16 00:00:00	2005-09-23	2005-09-23 00:00:00	2005-09-23	38000177		0	0	7		0	0	0	65741	0	311989	920300		
239947	5267	40213160	1967-03-12	1967-03-12 00:00:00	1967-03-12	1967-03-12 00:00:00	1967-03-12	581452		0	0	0		0	0	0	350444	0	10	40213160		
103938	2280	40213227	2011-01-26	2011-01-26 00:00:00	2011-01-26	2011-01-26 00:00:00	2011-01-26	581452		0	0	0		0	0	0	151601	0	113	40213227		
61160	5086	40229134	2009-04-30	2009-04-30 00:00:00	2009-05-14	2009-05-14 00:00:00	2009-05-14	38000177		0	0	14		0	0	0	338159	0	1043400	40229134		
55791	1222	40213296	1997-02-19	1997-02-19 00:00:00	1997-02-19	1997-02-19 00:00:00	1997-02-19	581452		0	0	0		0	0	0	80412	0	52	40213296		
121330	2666	40213201	2017-08-20	2017-08-20 00:00:00	2017-08-20	2017-08-20 00:00:00	2017-08-20	581452		0	0	0		0	0	0	176620	0	33	40213201		
162600	3576	40213227	2017-12-23	2017-12-23 00:00:00	2017-12-23	2017-12-23 00:00:00	2017-12-23	581452		0	0	0		0	0	0	237708	0	113	40213227		
53575	4454	19059056	1933-06-20	1933-06-20 00:00:00	1933-07-11	1933-07-11 00:00:00	1933-07-11	38000177		0	0	21		0	0	0	296493	0	243670	19059056		
34488	2849	1115171	2017-10-17	2017-10-17 00:00:00	2018-01-15	2018-01-15 00:00:00	2018-01-15	38000177		0	0	90		0	0	0	189298	0	849574	1115171		
62353	5190	1713671	1965-01-27	1965-01-27 00:00:00	1965-02-10	1965-02-10 00:00:00	1965-02-10	38000177		0	0	14		0	0	0	344971	0	562251	1713671		
187416	4116	40213227	2011-01-06	2011-01-06 00:00:00	2011-01-06	2011-01-06 00:00:00	2011-01-06	581452		0	0	0		0	0	0	273664	0	113	40213227		
154815	3407	40213227	1996-02-23	1996-02-23 00:00:00	1996-02-23	1996-02-23 00:00:00	1996-02-23	581452		0	0	0		0	0	0	225941	0	113	40213227		
188651	4142	40213251	1984-05-20	1984-05-20 00:00:00	1984-05-20	1984-05-20 00:00:00	1984-05-20	581452		0	0	0		0	0	0	275309	0	21	40213251		
181431	3987	40213160	1958-12-06	1958-12-06 00:00:00	1958-12-06	1958-12-06 00:00:00	1958-12-06	581452		0	0	0		0	0	0	265102	0	10	40213160		
23979	520	40213198	2016-02-04	2016-02-04 00:00:00	2016-02-04	2016-02-04 00:00:00	2016-02-04	581452		0	0	0		0	0	0	34705	0	133	40213198		
160398	3529	40213201	2010-09-08	2010-09-08 00:00:00	2010-09-08	2010-09-08 00:00:00	2010-09-08	581452		0	0	0		0	0	0	234333	0	33	40213201		
31142	2580	1127078	1962-10-07	1962-10-07 00:00:00	1962-10-21	1962-10-21 00:00:00	1962-10-21	38000177		0	0	14		0	0	0	170897	0	282464	1127078		
38877	3214	19019979	1976-09-14	1976-09-14 00:00:00	1976-09-28	1976-09-28 00:00:00	1976-09-28	38000177		0	0	14		0	0	0	213540	0	198405	19019979		
167165	3675	40213296	2009-04-27	2009-04-27 00:00:00	2009-04-27	2009-04-27 00:00:00	2009-04-27	581452		0	0	0		0	0	0	244417	0	52	40213296		
19704	1622	1127433	1995-11-14	1995-11-14 00:00:00	1995-11-28	1995-11-28 00:00:00	1995-11-28	38000177		0	0	14		0	0	0	108970	0	313782	1127433		
25396	2087	1713671	2007-06-12	2007-06-12 00:00:00	2007-06-19	2007-06-19 00:00:00	2007-06-19	38000177		0	0	7		0	0	0	139126	0	562251	1713671		
30575	2537	19133873	1957-01-09	1957-01-09 00:00:00	1957-01-17	1957-01-17 00:00:00	1957-01-17	38000177		0	0	8		0	0	0	167711	0	834061	19133873		
199372	4380	40213306	1986-08-04	1986-08-04 00:00:00	1986-08-04	1986-08-04 00:00:00	1986-08-04	581452		0	0	0		0	0	0	291054	0	43	40213306		
236287	5189	40213160	1960-05-01	1960-05-01 00:00:00	1960-05-01	1960-05-01 00:00:00	1960-05-01	581452		0	0	0		0	0	0	344924	0	10	40213160		
88663	1945	40213296	2012-11-04	2012-11-04 00:00:00	2012-11-04	2012-11-04 00:00:00	2012-11-04	581452		0	0	0		0	0	0	129239	0	52	40213296		
14349	1205	19133873	1963-04-07	1963-04-07 00:00:00	1963-04-17	1963-04-17 00:00:00	1963-04-17	38000177		0	0	10		0	0	0	79183	0	834061	19133873		
165497	3638	40213160	1968-04-11	1968-04-11 00:00:00	1968-04-11	1968-04-11 00:00:00	1968-04-11	581452		0	0	0		0	0	0	242003	0	10	40213160		
53407	4439	1713671	2005-08-17	2005-08-17 00:00:00	2005-09-07	2005-09-07 00:00:00	2005-09-07	38000177		0	0	21		0	0	0	295124	0	562251	1713671		
13458	1128	1127078	1971-07-28	1971-07-28 00:00:00	1971-08-11	1971-08-11 00:00:00	1971-08-11	38000177		0	0	14		0	0	0	74335	0	282464	1127078		
175585	3860	40213160	1972-12-16	1972-12-16 00:00:00	1972-12-16	1972-12-16 00:00:00	1972-12-16	581452		0	0	0		0	0	0	256301	0	10	40213160		
63766	5299	1127078	1973-10-30	1973-10-30 00:00:00	1973-11-13	1973-11-13 00:00:00	1973-11-13	38000177		0	0	14		0	0	0	352530	0	282464	1127078		
84227	1842	40213160	1966-04-29	1966-04-29 00:00:00	1966-04-29	1966-04-29 00:00:00	1966-04-29	581452		0	0	0		0	0	0	122948	0	10	40213160		
53781	4472	1713671	1969-03-16	1969-03-16 00:00:00	1969-03-23	1969-03-23 00:00:00	1969-03-23	38000177		0	0	7		0	0	0	297524	0	562251	1713671		
169835	3734	40213198	2013-12-14	2013-12-14 00:00:00	2013-12-14	2013-12-14 00:00:00	2013-12-14	581452		0	0	0		0	0	0	248187	0	133	40213198		
80490	1761	40213260	2006-11-19	2006-11-19 00:00:00	2006-11-19	2006-11-19 00:00:00	2006-11-19	581452		0	0	0		0	0	0	117795	0	121	40213260		
179248	3941	40213260	2013-01-22	2013-01-22 00:00:00	2013-01-22	2013-01-22 00:00:00	2013-01-22	581452		0	0	0		0	0	0	262025	0	121	40213260		
166812	3667	40213160	1972-06-13	1972-06-13 00:00:00	1972-06-13	1972-06-13 00:00:00	1972-06-13	581452		0	0	0		0	0	0	243962	0	10	40213160		
25155	2070	40165015	1988-02-07	1988-02-07 00:00:00	1988-02-07	1988-02-07 00:00:00	\N	38000177		0	0	0		0	0	0	137727	0	861467	40165015		
56527	4690	1124300	2001-03-20	2001-03-20 00:00:00	2001-03-20	2001-03-20 00:00:00	\N	38000177		0	0	0		0	0	0	312493	0	00781178901	45011828		
95927	2103	40213227	1994-05-14	1994-05-14 00:00:00	1994-05-14	1994-05-14 00:00:00	1994-05-14	581452		0	0	0		0	0	0	140146	0	113	40213227		
10451	870	19128065	1988-09-16	1988-09-16 00:00:00	1989-09-11	1989-09-11 00:00:00	1989-09-11	38000177		0	0	360		0	0	0	57841	0	749882	19128065		
8212	686	19059056	1954-02-27	1954-02-27 00:00:00	1954-03-29	1954-03-29 00:00:00	1954-03-29	38000177		0	0	30		0	0	0	45423	0	243670	19059056		
227064	4986	40213201	2016-08-14	2016-08-14 00:00:00	2016-08-14	2016-08-14 00:00:00	2016-08-14	581452		0	0	0		0	0	0	331675	0	33	40213201		
116792	2566	40213227	1992-11-10	1992-11-10 00:00:00	1992-11-10	1992-11-10 00:00:00	1992-11-10	581452		0	0	0		0	0	0	169989	0	113	40213227		
180512	3967	40213227	1992-02-09	1992-02-09 00:00:00	1992-02-09	1992-02-09 00:00:00	1992-02-09	581452		0	0	0		0	0	0	263724	0	113	40213227		
31807	693	40213198	2016-11-29	2016-11-29 00:00:00	2016-11-29	2016-11-29 00:00:00	2016-11-29	581452		0	0	0		0	0	0	45935	0	133	40213198		
11920	994	19133905	2007-02-06	2007-02-06 00:00:00	2007-02-15	2007-02-15 00:00:00	2007-02-15	38000177		0	0	9		0	0	0	65892	0	834102	19133905		
239952	5267	40213160	1967-05-14	1967-05-14 00:00:00	1967-05-14	1967-05-14 00:00:00	1967-05-14	581452		0	0	0		0	0	0	350418	0	10	40213160		
103939	2280	40213296	2011-01-26	2011-01-26 00:00:00	2011-01-26	2011-01-26 00:00:00	2011-01-26	581452		0	0	0		0	0	0	151601	0	52	40213296		
61161	5086	19128065	1986-09-06	1986-09-06 00:00:00	1987-09-01	1987-09-01 00:00:00	1987-09-01	38000177		0	0	360		0	0	0	338161	0	749882	19128065		
55794	1222	40213160	1955-02-02	1955-02-02 00:00:00	1955-02-02	1955-02-02 00:00:00	1955-02-02	581452		0	0	0		0	0	0	80440	0	10	40213160		
63481	5276	1127433	1969-12-24	1969-12-24 00:00:00	1969-12-31	1969-12-31 00:00:00	1969-12-31	38000177		0	0	7		0	0	0	350904	0	313782	1127433		
162601	3576	40213260	2017-12-23	2017-12-23 00:00:00	2017-12-23	2017-12-23 00:00:00	2017-12-23	581452		0	0	0		0	0	0	237708	0	121	40213260		
53576	4454	1127433	2005-09-20	2005-09-20 00:00:00	2005-10-04	2005-10-04 00:00:00	2005-10-04	38000177		0	0	14		0	0	0	296418	0	313782	1127433		
34489	2849	19133873	1927-04-08	1927-04-08 00:00:00	1927-04-17	1927-04-17 00:00:00	1927-04-17	38000177		0	0	9		0	0	0	189246	0	834061	19133873		
62354	5190	1124300	1991-11-12	1991-11-12 00:00:00	1991-11-12	1991-11-12 00:00:00	\N	38000177		0	0	0		0	0	0	344995	0	00781178901	45011828		
187425	4116	40213227	1999-12-30	1999-12-30 00:00:00	1999-12-30	1999-12-30 00:00:00	1999-12-30	581452		0	0	0		0	0	0	273649	0	113	40213227		
154818	3407	40213160	1968-01-05	1968-01-05 00:00:00	1968-01-05	1968-01-05 00:00:00	1968-01-05	581452		0	0	0		0	0	0	225989	0	10	40213160		
242873	5331	40213296	2003-08-06	2003-08-06 00:00:00	2003-08-06	2003-08-06 00:00:00	2003-08-06	581452		0	0	0		0	0	0	354941	0	52	40213296		
181434	3987	40213227	2005-01-01	2005-01-01 00:00:00	2005-01-01	2005-01-01 00:00:00	2005-01-01	581452		0	0	0		0	0	0	265057	0	113	40213227		
181107	3980	40213296	2016-09-04	2016-09-04 00:00:00	2016-09-04	2016-09-04 00:00:00	2016-09-04	581452		0	0	0		0	0	0	264603	0	52	40213296		
160401	3530	40213306	1981-11-27	1981-11-27 00:00:00	1981-11-27	1981-11-27 00:00:00	1981-11-27	581452		0	0	0		0	0	0	234469	0	43	40213306		
31143	2580	19006318	1962-10-07	1962-10-07 00:00:00	1962-10-21	1962-10-21 00:00:00	1962-10-21	38000177		0	0	14		0	0	0	170897	0	105078	19006318		
38878	3214	46233988	1976-09-14	1976-09-14 00:00:00	1976-09-28	1976-09-28 00:00:00	1976-09-28	38000177		0	0	14		0	0	0	213540	0	1652673	46233988		
167167	3675	40213227	2009-04-27	2009-04-27 00:00:00	2009-04-27	2009-04-27 00:00:00	2009-04-27	581452		0	0	0		0	0	0	244417	0	113	40213227		
19705	1622	19128022	1992-05-02	1992-05-02 00:00:00	1993-04-27	1993-04-27 00:00:00	1993-04-27	38000177		0	0	360		0	0	0	108955	0	749785	19128022		
25397	2088	19059056	1910-02-14	1910-02-14 00:00:00	1910-02-28	1910-02-28 00:00:00	1910-02-28	38000177		0	0	14		0	0	0	139296	0	243670	19059056		
30576	2537	19078461	1991-03-11	1991-03-11 00:00:00	1991-04-01	1991-04-01 00:00:00	1991-04-01	38000177		0	0	21		0	0	0	167706	0	310965	19078461		
199373	4380	40213296	2004-04-26	2004-04-26 00:00:00	2004-04-26	2004-04-26 00:00:00	2004-04-26	581452		0	0	0		0	0	0	291005	0	52	40213296		
236302	5189	40213160	1955-10-30	1955-10-30 00:00:00	1955-10-30	1955-10-30 00:00:00	1955-10-30	581452		0	0	0		0	0	0	344936	0	10	40213160		
88665	1945	40213227	2012-11-04	2012-11-04 00:00:00	2012-11-04	2012-11-04 00:00:00	2012-11-04	581452		0	0	0		0	0	0	129239	0	113	40213227		
14350	1206	1127433	1991-03-04	1991-03-04 00:00:00	1991-03-18	1991-03-18 00:00:00	1991-03-18	38000177		0	0	14		0	0	0	79261	0	313782	1127433		
165499	3638	40213296	2003-05-08	2003-05-08 00:00:00	2003-05-08	2003-05-08 00:00:00	2003-05-08	581452		0	0	0		0	0	0	242017	0	52	40213296		
53408	4439	1118084	1995-04-12	1995-04-12 00:00:00	1995-04-12	1995-04-12 00:00:00	\N	38000177		0	0	0		0	0	0	295097	0	00025152531	44923712		
13459	1128	19133905	1987-01-21	1987-01-21 00:00:00	1987-02-03	1987-02-03 00:00:00	1987-02-03	38000177		0	0	13		0	0	0	74316	0	834102	19133905		
175586	3860	40213160	1977-06-18	1977-06-18 00:00:00	1977-06-18	1977-06-18 00:00:00	1977-06-18	581452		0	0	0		0	0	0	256304	0	10	40213160		
63767	5299	19078461	1994-09-10	1994-09-10 00:00:00	1994-09-24	1994-09-24 00:00:00	1994-09-24	38000177		0	0	14		0	0	0	352524	0	310965	19078461		
202592	4448	40213227	2005-04-21	2005-04-21 00:00:00	2005-04-21	2005-04-21 00:00:00	2005-04-21	581452		0	0	0		0	0	0	295865	0	113	40213227		
53782	4472	1127433	2005-11-13	2005-11-13 00:00:00	2006-01-12	2006-01-12 00:00:00	2006-01-12	38000177		0	0	60		0	0	0	297546	0	313782	1127433		
169838	3734	40213160	1955-02-05	1955-02-05 00:00:00	1955-02-05	1955-02-05 00:00:00	1955-02-05	581452		0	0	0		0	0	0	\N	0	10	40213160		
80492	1761	40213160	1957-08-05	1957-08-05 00:00:00	1957-08-05	1957-08-05 00:00:00	1957-08-05	581452		0	0	0		0	0	0	117794	0	10	40213160		
179250	3941	40213160	1963-04-30	1963-04-30 00:00:00	1963-04-30	1963-04-30 00:00:00	1963-04-30	581452		0	0	0		0	0	0	262050	0	10	40213160		
166816	3667	40213306	1989-08-22	1989-08-22 00:00:00	1989-08-22	1989-08-22 00:00:00	1989-08-22	581452		0	0	0		0	0	0	244003	0	43	40213306		
25156	2071	19059056	1977-02-13	1977-02-13 00:00:00	1977-03-15	1977-03-15 00:00:00	1977-03-15	38000177		0	0	30		0	0	0	137802	0	243670	19059056		
56528	4690	19059056	1958-03-31	1958-03-31 00:00:00	1958-04-14	1958-04-14 00:00:00	1958-04-14	38000177		0	0	14		0	0	0	312458	0	243670	19059056		
95928	2103	40213306	1994-05-14	1994-05-14 00:00:00	1994-05-14	1994-05-14 00:00:00	1994-05-14	581452		0	0	0		0	0	0	140146	0	43	40213306		
10452	870	19078461	2006-08-01	2006-08-01 00:00:00	2006-08-15	2006-08-15 00:00:00	2006-08-15	38000177		0	0	14		0	0	0	57887	0	310965	19078461		
8213	686	1127433	1976-07-30	1976-07-30 00:00:00	1976-08-06	1976-08-06 00:00:00	1976-08-06	38000177		0	0	7		0	0	0	45440	0	313782	1127433		
227081	4986	40213227	2001-04-29	2001-04-29 00:00:00	2001-04-29	2001-04-29 00:00:00	2001-04-29	581452		0	0	0		0	0	0	331638	0	113	40213227		
116794	2566	40213227	2000-12-26	2000-12-26 00:00:00	2000-12-26	2000-12-26 00:00:00	2000-12-26	581452		0	0	0		0	0	0	169959	0	113	40213227		
180517	3967	40213260	2010-08-08	2010-08-08 00:00:00	2010-08-08	2010-08-08 00:00:00	2010-08-08	581452		0	0	0		0	0	0	263748	0	121	40213260		
195401	4291	40213227	2005-02-25	2005-02-25 00:00:00	2005-02-25	2005-02-25 00:00:00	2005-02-25	581452		0	0	0		0	0	0	284918	0	113	40213227		
11921	994	1118084	1998-10-30	1998-10-30 00:00:00	1998-10-30	1998-10-30 00:00:00	\N	38000177		0	0	0		0	0	0	65874	0	00025152531	44923712		
239954	5267	40213296	2006-12-10	2006-12-10 00:00:00	2006-12-10	2006-12-10 00:00:00	2006-12-10	581452		0	0	0		0	0	0	350427	0	52	40213296		
103941	2280	40213160	1969-11-12	1969-11-12 00:00:00	1969-11-12	1969-11-12 00:00:00	1969-11-12	581452		0	0	0		0	0	0	151675	0	10	40213160		
61162	5086	46233988	1974-02-24	1974-02-24 00:00:00	1974-03-10	1974-03-10 00:00:00	1974-03-10	38000177		0	0	14		0	0	0	338162	0	1652673	46233988		
229691	5048	40213227	2000-03-10	2000-03-10 00:00:00	2000-03-10	2000-03-10 00:00:00	2000-03-10	581452		0	0	0		0	0	0	335415	0	113	40213227		
63482	5276	19133873	1962-10-26	1962-10-26 00:00:00	1962-11-08	1962-11-08 00:00:00	1962-11-08	38000177		0	0	13		0	0	0	350903	0	834061	19133873		
162602	3576	40213160	1966-06-25	1966-06-25 00:00:00	1966-06-25	1966-06-25 00:00:00	1966-06-25	581452		0	0	0		0	0	0	237724	0	10	40213160		
53577	4454	1115171	1996-02-28	1996-02-28 00:00:00	1996-03-29	1996-03-29 00:00:00	1996-03-29	38000177		0	0	30		0	0	0	296501	0	849574	1115171		
34490	2849	1127433	1984-10-26	1984-10-26 00:00:00	1984-11-09	1984-11-09 00:00:00	1984-11-09	38000177		0	0	14		0	0	0	189294	0	313782	1127433		
62355	5190	1713671	1991-10-22	1991-10-22 00:00:00	1991-11-05	1991-11-05 00:00:00	1991-11-05	38000177		0	0	14		0	0	0	344995	0	562251	1713671		
187429	4116	40213296	2008-10-23	2008-10-23 00:00:00	2008-10-23	2008-10-23 00:00:00	2008-10-23	581452		0	0	0		0	0	0	273622	0	52	40213296		
154822	3408	40213306	1991-09-09	1991-09-09 00:00:00	1991-09-09	1991-09-09 00:00:00	1991-09-09	581452		0	0	0		0	0	0	226018	0	43	40213306		
242882	5331	40213306	1987-08-19	1987-08-19 00:00:00	1987-08-19	1987-08-19 00:00:00	1987-08-19	581452		0	0	0		0	0	0	354958	0	43	40213306		
181440	3987	40213227	1996-06-22	1996-06-22 00:00:00	1996-06-22	1996-06-22 00:00:00	1996-06-22	581452		0	0	0		0	0	0	265106	0	113	40213227		
181109	3980	40213227	2016-09-04	2016-09-04 00:00:00	2016-09-04	2016-09-04 00:00:00	2016-09-04	581452		0	0	0		0	0	0	264603	0	113	40213227		
160411	3530	40213296	2001-05-04	2001-05-04 00:00:00	2001-05-04	2001-05-04 00:00:00	2001-05-04	581452		0	0	0		0	0	0	234514	0	52	40213296		
31144	2580	1118084	1995-01-16	1995-01-16 00:00:00	1995-01-16	1995-01-16 00:00:00	\N	38000177		0	0	0		0	0	0	170891	0	00025152531	44923712		
38879	3214	1713671	2018-11-27	2018-11-27 00:00:00	2018-12-18	2018-12-18 00:00:00	2018-12-18	38000177		0	0	21		0	0	0	213528	0	562251	1713671		
167171	3675	40213227	2019-03-18	2019-03-18 00:00:00	2019-03-18	2019-03-18 00:00:00	2019-03-18	581452		0	0	0		0	0	0	244419	0	113	40213227		
19706	1622	19128022	1999-03-27	1999-03-27 00:00:00	2000-03-21	2000-03-21 00:00:00	2000-03-21	38000177		0	0	360		0	0	0	109043	0	749785	19128022		
25398	2088	1127433	1973-04-21	1973-04-21 00:00:00	1973-04-28	1973-04-28 00:00:00	1973-04-28	38000177		0	0	7		0	0	0	139264	0	313782	1127433		
30577	2537	19112599	1951-09-06	1951-09-06 00:00:00	1951-09-06	1951-09-06 00:00:00	\N	38000177		0	0	0		0	0	0	167662	0	477045	19112599		
183306	4027	40213160	1978-10-14	1978-10-14 00:00:00	1978-10-14	1978-10-14 00:00:00	1978-10-14	581452		0	0	0		0	0	0	267908	0	10	40213160		
236304	5189	40213296	1997-06-01	1997-06-01 00:00:00	1997-06-01	1997-06-01 00:00:00	1997-06-01	581452		0	0	0		0	0	0	344911	0	52	40213296		
88673	1945	40213227	2002-02-09	2002-02-09 00:00:00	2002-02-09	2002-02-09 00:00:00	2002-02-09	581452		0	0	0		0	0	0	129236	0	113	40213227		
14351	1206	1127433	2001-02-12	2001-02-12 00:00:00	2001-02-19	2001-02-19 00:00:00	2001-02-19	38000177		0	0	7		0	0	0	79238	0	313782	1127433		
165501	3638	40213306	1985-06-27	1985-06-27 00:00:00	1985-06-27	1985-06-27 00:00:00	1985-06-27	581452		0	0	0		0	0	0	242021	0	43	40213306		
53409	4439	19059056	1955-03-08	1955-03-08 00:00:00	1955-03-22	1955-03-22 00:00:00	1955-03-22	38000177		0	0	14		0	0	0	295125	0	243670	19059056		
13460	1128	1713671	1991-08-23	1991-08-23 00:00:00	1991-09-06	1991-09-06 00:00:00	1991-09-06	38000177		0	0	14		0	0	0	74330	0	562251	1713671		
175588	3860	40213314	1977-06-18	1977-06-18 00:00:00	1977-06-18	1977-06-18 00:00:00	1977-06-18	581452		0	0	0		0	0	0	256304	0	49	40213314		
63768	5299	19128022	1989-05-19	1989-05-19 00:00:00	1990-05-14	1990-05-14 00:00:00	1990-05-14	38000177		0	0	360		0	0	0	352537	0	749785	19128022		
202595	4448	40213260	2006-04-27	2006-04-27 00:00:00	2006-04-27	2006-04-27 00:00:00	2006-04-27	581452		0	0	0		0	0	0	295892	0	121	40213260		
53783	4472	19133768	2015-10-03	2015-10-03 00:00:00	2015-10-03	2015-10-03 00:00:00	2015-10-03	38000177		0	0	0		0	0	0	297547	0	833036	19133768		
169863	3734	40213227	1999-07-24	1999-07-24 00:00:00	1999-07-24	1999-07-24 00:00:00	1999-07-24	581452		0	0	0		0	0	0	248105	0	113	40213227		
80497	1761	40213160	1955-01-30	1955-01-30 00:00:00	1955-01-30	1955-01-30 00:00:00	1955-01-30	581452		0	0	0		0	0	0	117749	0	10	40213160		
179252	3941	40213227	2014-01-28	2014-01-28 00:00:00	2014-01-28	2014-01-28 00:00:00	2014-01-28	581452		0	0	0		0	0	0	262054	0	113	40213227		
166819	3667	40213296	2007-07-17	2007-07-17 00:00:00	2007-07-17	2007-07-17 00:00:00	2007-07-17	581452		0	0	0		0	0	0	243997	0	52	40213296		
25157	2071	1127433	1993-04-22	1993-04-22 00:00:00	1993-04-29	1993-04-29 00:00:00	1993-04-29	38000177		0	0	7		0	0	0	137790	0	313782	1127433		
56529	4690	19006318	1958-03-31	1958-03-31 00:00:00	1958-04-14	1958-04-14 00:00:00	1958-04-14	38000177		0	0	14		0	0	0	312458	0	105078	19006318		
95935	2103	40213227	2003-05-24	2003-05-24 00:00:00	2003-05-24	2003-05-24 00:00:00	2003-05-24	581452		0	0	0		0	0	0	140149	0	113	40213227		
10453	870	19075001	2006-08-01	2006-08-01 00:00:00	2006-08-15	2006-08-15 00:00:00	2006-08-15	38000177		0	0	14		0	0	0	57887	0	309097	19075001		
8214	686	1713671	1989-01-29	1989-01-29 00:00:00	1989-02-12	1989-02-12 00:00:00	1989-02-12	38000177		0	0	14		0	0	0	45397	0	562251	1713671		
227086	4986	40213227	1993-04-04	1993-04-04 00:00:00	1993-04-04	1993-04-04 00:00:00	1993-04-04	581452		0	0	0		0	0	0	331667	0	113	40213227		
116798	2566	40213201	2006-01-24	2006-01-24 00:00:00	2006-01-24	2006-01-24 00:00:00	2006-01-24	581452		0	0	0		0	0	0	169992	0	33	40213201		
180521	3967	40213160	1960-08-07	1960-08-07 00:00:00	1960-08-07	1960-08-07 00:00:00	1960-08-07	581452		0	0	0		0	0	0	263785	0	10	40213160		
195404	4291	40213160	1974-05-03	1974-05-03 00:00:00	1974-05-03	1974-05-03 00:00:00	1974-05-03	581452		0	0	0		0	0	0	284896	0	10	40213160		
11922	994	1127433	1969-10-29	1969-10-29 00:00:00	1969-11-05	1969-11-05 00:00:00	1969-11-05	38000177		0	0	7		0	0	0	65891	0	313782	1127433		
239962	5267	40213227	2017-12-10	2017-12-10 00:00:00	2017-12-10	2017-12-10 00:00:00	2017-12-10	581452		0	0	0		0	0	0	350407	0	113	40213227		
103945	2280	40213160	1974-05-15	1974-05-15 00:00:00	1974-05-15	1974-05-15 00:00:00	1974-05-15	581452		0	0	0		0	0	0	151679	0	10	40213160		
61163	5086	19059056	1974-02-24	1974-02-24 00:00:00	1974-03-10	1974-03-10 00:00:00	1974-03-10	38000177		0	0	14		0	0	0	338162	0	243670	19059056		
229692	5048	40213296	2000-03-10	2000-03-10 00:00:00	2000-03-10	2000-03-10 00:00:00	2000-03-10	581452		0	0	0		0	0	0	335415	0	52	40213296		
63483	5276	40171902	2009-12-27	2009-12-27 00:00:00	2009-12-27	2009-12-27 00:00:00	\N	38000177		0	0	0		0	0	0	350871	0	897718	40171902		
162604	3576	40213260	2016-12-17	2016-12-17 00:00:00	2016-12-17	2016-12-17 00:00:00	2016-12-17	581452		0	0	0		0	0	0	237759	0	121	40213260		
53578	4454	1127433	1955-11-08	1955-11-08 00:00:00	1955-11-22	1955-11-22 00:00:00	1955-11-22	38000177		0	0	14		0	0	0	296466	0	313782	1127433		
34491	2849	1127433	1972-12-13	1972-12-13 00:00:00	1972-12-20	1972-12-20 00:00:00	1972-12-20	38000177		0	0	7		0	0	0	189205	0	313782	1127433		
62356	5191	1713671	2007-04-06	2007-04-06 00:00:00	2007-04-20	2007-04-20 00:00:00	2007-04-20	38000177		0	0	14		0	0	0	345100	0	562251	1713671		
187430	4116	40213160	1969-06-26	1969-06-26 00:00:00	1969-06-26	1969-06-26 00:00:00	1969-06-26	581452		0	0	0		0	0	0	273653	0	10	40213160		
154828	3408	40213296	2011-07-18	2011-07-18 00:00:00	2011-07-18	2011-07-18 00:00:00	2011-07-18	581452		0	0	0		0	0	0	226019	0	52	40213296		
161111	3545	40213160	1971-08-11	1971-08-11 00:00:00	1971-08-11	1971-08-11 00:00:00	1971-08-11	581452		0	0	0		0	0	0	235465	0	10	40213160		
181441	3987	40213296	1996-06-22	1996-06-22 00:00:00	1996-06-22	1996-06-22 00:00:00	1996-06-22	581452		0	0	0		0	0	0	265106	0	52	40213296		
181111	3980	40213160	1975-04-06	1975-04-06 00:00:00	1975-04-06	1975-04-06 00:00:00	1975-04-06	581452		0	0	0		0	0	0	264599	0	10	40213160		
160413	3530	40213227	2001-05-04	2001-05-04 00:00:00	2001-05-04	2001-05-04 00:00:00	2001-05-04	581452		0	0	0		0	0	0	234514	0	113	40213227		
31145	2580	1539411	1992-08-17	1992-08-17 00:00:00	1992-08-17	1992-08-17 00:00:00	\N	38000177		0	0	0		0	0	0	170891	0	312961	1539411		
38880	3214	1713671	1979-01-17	1979-01-17 00:00:00	1979-02-07	1979-02-07 00:00:00	1979-02-07	38000177		0	0	21		0	0	0	213523	0	562251	1713671		
167172	3675	40213260	2017-07-10	2017-07-10 00:00:00	2017-07-10	2017-07-10 00:00:00	2017-07-10	581452		0	0	0		0	0	0	244472	0	121	40213260		
19707	1622	40229134	1982-03-09	1982-03-09 00:00:00	1982-03-23	1982-03-23 00:00:00	1982-03-23	38000177		0	0	14		0	0	0	108969	0	1043400	40229134		
35857	2951	1713671	2006-11-29	2006-11-29 00:00:00	2006-12-20	2006-12-20 00:00:00	2006-12-20	38000177		0	0	21		0	0	0	197034	0	562251	1713671		
30578	2537	1127078	1950-11-16	1950-11-16 00:00:00	1950-11-30	1950-11-30 00:00:00	1950-11-30	38000177		0	0	14		0	0	0	167766	0	282464	1127078		
174753	3843	40213227	2001-06-10	2001-06-10 00:00:00	2001-06-10	2001-06-10 00:00:00	2001-06-10	581452		0	0	0		0	0	0	255090	0	113	40213227		
236306	5189	40213227	1997-06-01	1997-06-01 00:00:00	1997-06-01	1997-06-01 00:00:00	1997-06-01	581452		0	0	0		0	0	0	344911	0	113	40213227		
88677	1945	40213160	1971-05-09	1971-05-09 00:00:00	1971-05-09	1971-05-09 00:00:00	1971-05-09	581452		0	0	0		0	0	0	129211	0	10	40213160		
14352	1206	1127078	1964-11-06	1964-11-06 00:00:00	1964-11-20	1964-11-20 00:00:00	1964-11-20	38000177		0	0	14		0	0	0	79254	0	282464	1127078		
41974	915	40213296	2002-01-05	2002-01-05 00:00:00	2002-01-05	2002-01-05 00:00:00	2002-01-05	581452		0	0	0		0	0	0	60796	0	52	40213296		
53410	4439	19006318	1955-03-08	1955-03-08 00:00:00	1955-03-22	1955-03-22 00:00:00	1955-03-22	38000177		0	0	14		0	0	0	295125	0	105078	19006318		
13461	1128	1127433	2017-01-23	2017-01-23 00:00:00	2017-01-30	2017-01-30 00:00:00	2017-01-30	38000177		0	0	7		0	0	0	74318	0	313782	1127433		
175593	3860	40213227	2003-11-15	2003-11-15 00:00:00	2003-11-15	2003-11-15 00:00:00	2003-11-15	581452		0	0	0		0	0	0	256298	0	113	40213227		
63770	5299	19115351	2003-05-04	2003-05-04 00:00:00	2003-07-20	2003-07-20 00:00:00	2003-07-20	38000177		0	0	77		0	0	0	352506	0	563026	19115351		
202608	4448	40213227	1996-09-26	1996-09-26 00:00:00	1996-09-26	1996-09-26 00:00:00	1996-09-26	581452		0	0	0		0	0	0	295872	0	113	40213227		
53784	4472	1545959	2015-10-03	2015-10-03 00:00:00	2015-10-03	2015-10-03 00:00:00	2015-10-03	38000177		0	0	0		0	0	0	297547	0	259255	1545959		
169866	3734	40213201	2014-12-20	2014-12-20 00:00:00	2014-12-20	2014-12-20 00:00:00	2014-12-20	581452		0	0	0		0	0	0	248168	0	33	40213201		
182606	4013	40213314	1978-04-23	1978-04-23 00:00:00	1978-04-23	1978-04-23 00:00:00	1978-04-23	581452		0	0	0		0	0	0	266654	0	49	40213314		
179253	3941	40213260	2014-01-28	2014-01-28 00:00:00	2014-01-28	2014-01-28 00:00:00	2014-01-28	581452		0	0	0		0	0	0	262054	0	121	40213260		
166822	3667	40213227	1998-09-01	1998-09-01 00:00:00	1998-09-01	1998-09-01 00:00:00	1998-09-01	581452		0	0	0		0	0	0	243968	0	113	40213227		
25158	2071	40229134	1972-10-08	1972-10-08 00:00:00	1972-10-22	1972-10-22 00:00:00	1972-10-22	38000177		0	0	14		0	0	0	137821	0	1043400	40229134		
56531	4690	19133905	2008-05-03	2008-05-03 00:00:00	2008-05-12	2008-05-12 00:00:00	2008-05-12	38000177		0	0	9		0	0	0	312538	0	834102	19133905		
95942	2103	40213160	1977-04-23	1977-04-23 00:00:00	1977-04-23	1977-04-23 00:00:00	1977-04-23	581452		0	0	0		0	0	0	140132	0	10	40213160		
10454	870	1127433	2002-11-11	2002-11-11 00:00:00	2002-12-02	2002-12-02 00:00:00	2002-12-02	38000177		0	0	21		0	0	0	57851	0	313782	1127433		
8215	686	19078461	1976-01-08	1976-01-08 00:00:00	1976-01-22	1976-01-22 00:00:00	1976-01-22	38000177		0	0	14		0	0	0	45425	0	310965	19078461		
204708	4493	40213314	1982-11-30	1982-11-30 00:00:00	1982-11-30	1982-11-30 00:00:00	1982-11-30	581452		0	0	0		0	0	0	299172	0	49	40213314		
116803	2567	40213227	2017-08-05	2017-08-05 00:00:00	2017-08-05	2017-08-05 00:00:00	2017-08-05	581452		0	0	0		0	0	0	170060	0	113	40213227		
216855	4758	40213260	2008-06-29	2008-06-29 00:00:00	2008-06-29	2008-06-29 00:00:00	2008-06-29	581452		0	0	0		0	0	0	317037	0	121	40213260		
122203	2685	40213201	2009-04-16	2009-04-16 00:00:00	2009-04-16	2009-04-16 00:00:00	2009-04-16	581452		0	0	0		0	0	0	177964	0	33	40213201		
11923	994	1127433	2002-06-16	2002-06-16 00:00:00	2002-06-30	2002-06-30 00:00:00	2002-06-30	38000177		0	0	14		0	0	0	65894	0	313782	1127433		
239963	5267	40213260	2017-12-10	2017-12-10 00:00:00	2017-12-10	2017-12-10 00:00:00	2017-12-10	581452		0	0	0		0	0	0	350407	0	121	40213260		
103952	2280	40213227	1993-04-14	1993-04-14 00:00:00	1993-04-14	1993-04-14 00:00:00	1993-04-14	581452		0	0	0		0	0	0	\N	0	113	40213227		
61164	5086	46233988	1972-10-26	1972-10-26 00:00:00	1972-11-09	1972-11-09 00:00:00	1972-11-09	38000177		0	0	14		0	0	0	338185	0	1652673	46233988		
229698	5048	40213160	1959-01-30	1959-01-30 00:00:00	1959-01-30	1959-01-30 00:00:00	1959-01-30	581452		0	0	0		0	0	0	335447	0	10	40213160		
63484	5276	40163554	2009-12-27	2009-12-27 00:00:00	2009-12-27	2009-12-27 00:00:00	\N	38000177		0	0	0		0	0	0	350871	0	855332	40163554		
162607	3576	40213306	1988-02-13	1988-02-13 00:00:00	1988-02-13	1988-02-13 00:00:00	1988-02-13	581452		0	0	0		0	0	0	237733	0	43	40213306		
53579	4454	19059056	1945-04-30	1945-04-30 00:00:00	1945-05-14	1945-05-14 00:00:00	1945-05-14	38000177		0	0	14		0	0	0	296495	0	243670	19059056		
34492	2849	1127433	1921-07-26	1921-07-26 00:00:00	1921-08-09	1921-08-09 00:00:00	1921-08-09	38000177		0	0	14		0	0	0	189213	0	313782	1127433		
62357	5191	1127433	2002-11-07	2002-11-07 00:00:00	2002-11-21	2002-11-21 00:00:00	2002-11-21	38000177		0	0	14		0	0	0	345120	0	313782	1127433		
187434	4117	40213160	1963-03-22	1963-03-22 00:00:00	1963-03-22	1963-03-22 00:00:00	1963-03-22	581452		0	0	0		0	0	0	273717	0	10	40213160		
154830	3408	40213227	2011-07-18	2011-07-18 00:00:00	2011-07-18	2011-07-18 00:00:00	2011-07-18	581452		0	0	0		0	0	0	226019	0	113	40213227		
161112	3545	40213160	1971-06-09	1971-06-09 00:00:00	1971-06-09	1971-06-09 00:00:00	1971-06-09	581452		0	0	0		0	0	0	235455	0	10	40213160		
181444	3987	40213160	1955-03-05	1955-03-05 00:00:00	1955-03-05	1955-03-05 00:00:00	1955-03-05	581452		0	0	0		0	0	0	265099	0	10	40213160		
181112	3980	40213160	1975-02-02	1975-02-02 00:00:00	1975-02-02	1975-02-02 00:00:00	1975-02-02	581452		0	0	0		0	0	0	264590	0	10	40213160		
160415	3530	40213227	1993-07-16	1993-07-16 00:00:00	1993-07-16	1993-07-16 00:00:00	1993-07-16	581452		0	0	0		0	0	0	\N	0	113	40213227		
7642	164	40213306	1986-08-04	1986-08-04 00:00:00	1986-08-04	1986-08-04 00:00:00	1986-08-04	581452		0	0	0		0	0	0	\N	0	43	40213306		
38881	3214	1118084	2008-11-27	2008-11-27 00:00:00	2008-11-27	2008-11-27 00:00:00	\N	38000177		0	0	0		0	0	0	213548	0	00025152531	44923712		
167176	3675	40213160	1972-03-27	1972-03-27 00:00:00	1972-03-27	1972-03-27 00:00:00	1972-03-27	581452		0	0	0		0	0	0	244441	0	10	40213160		
19708	1622	1115171	1998-11-17	1998-11-17 00:00:00	1998-12-08	1998-12-08 00:00:00	1998-12-08	38000177		0	0	21		0	0	0	108935	0	849574	1115171		
35859	2951	19059056	1963-10-21	1963-10-21 00:00:00	1964-01-19	1964-01-19 00:00:00	1964-01-19	38000177		0	0	90		0	0	0	197007	0	243670	19059056		
30579	2537	19006318	1950-11-16	1950-11-16 00:00:00	1950-11-30	1950-11-30 00:00:00	1950-11-30	38000177		0	0	14		0	0	0	167766	0	105078	19006318		
174757	3843	40213160	1969-08-17	1969-08-17 00:00:00	1969-08-17	1969-08-17 00:00:00	1969-08-17	581452		0	0	0		0	0	0	255115	0	10	40213160		
236309	5189	40213227	2016-07-24	2016-07-24 00:00:00	2016-07-24	2016-07-24 00:00:00	2016-07-24	581452		0	0	0		0	0	0	344939	0	113	40213227		
88680	1945	40213227	1993-01-30	1993-01-30 00:00:00	1993-01-30	1993-01-30 00:00:00	1993-01-30	581452		0	0	0		0	0	0	129226	0	113	40213227		
14353	1206	19006318	1964-11-06	1964-11-06 00:00:00	1964-11-20	1964-11-20 00:00:00	1964-11-20	38000177		0	0	14		0	0	0	79254	0	105078	19006318		
41976	915	40213227	2011-02-12	2011-02-12 00:00:00	2011-02-12	2011-02-12 00:00:00	2011-02-12	581452		0	0	0		0	0	0	60812	0	113	40213227		
53411	4439	1713671	2012-06-07	2012-06-07 00:00:00	2012-06-14	2012-06-14 00:00:00	2012-06-14	38000177		0	0	7		0	0	0	295149	0	562251	1713671		
13462	1128	1127433	1979-04-29	1979-04-29 00:00:00	1979-05-13	1979-05-13 00:00:00	1979-05-13	38000177		0	0	14		0	0	0	74329	0	313782	1127433		
175596	3860	40213160	1973-03-17	1973-03-17 00:00:00	1973-03-17	1973-03-17 00:00:00	1973-03-17	581452		0	0	0		0	0	0	256333	0	10	40213160		
63771	5299	1127078	1974-09-09	1974-09-09 00:00:00	1974-09-23	1974-09-23 00:00:00	1974-09-23	38000177		0	0	14		0	0	0	352546	0	282464	1127078		
202609	4448	40213296	1996-09-26	1996-09-26 00:00:00	1996-09-26	1996-09-26 00:00:00	1996-09-26	581452		0	0	0		0	0	0	295872	0	52	40213296		
64246	5333	40223774	1997-07-07	1997-07-07 00:00:00	1997-07-07	1997-07-07 00:00:00	\N	38000177		0	0	0		0	0	0	355149	0	998582	40223774		
152777	3363	40213227	1993-03-12	1993-03-12 00:00:00	1993-03-12	1993-03-12 00:00:00	1993-03-12	581452		0	0	0		0	0	0	222980	0	113	40213227		
182607	4013	40213160	1979-10-28	1979-10-28 00:00:00	1979-10-28	1979-10-28 00:00:00	1979-10-28	581452		0	0	0		0	0	0	266637	0	10	40213160		
179256	3941	40213227	1995-06-20	1995-06-20 00:00:00	1995-06-20	1995-06-20 00:00:00	1995-06-20	581452		0	0	0		0	0	0	262035	0	113	40213227		
166823	3667	40213160	1967-10-17	1967-10-17 00:00:00	1967-10-17	1967-10-17 00:00:00	1967-10-17	581452		0	0	0		0	0	0	243950	0	10	40213160		
25159	2071	1127433	1976-12-08	1976-12-08 00:00:00	1976-12-15	1976-12-15 00:00:00	1976-12-15	38000177		0	0	7		0	0	0	137789	0	313782	1127433		
56532	4690	920300	2012-08-26	2012-08-26 00:00:00	2012-09-02	2012-09-02 00:00:00	2012-09-02	38000177		0	0	7		0	0	0	312495	0	311989	920300		
95944	2103	40213314	1977-04-23	1977-04-23 00:00:00	1977-04-23	1977-04-23 00:00:00	1977-04-23	581452		0	0	0		0	0	0	140132	0	49	40213314		
239267	5252	40213260	2007-12-04	2007-12-04 00:00:00	2007-12-04	2007-12-04 00:00:00	2007-12-04	581452		0	0	0		0	0	0	349472	0	121	40213260		
8216	686	1713671	1959-03-08	1959-03-08 00:00:00	1959-03-15	1959-03-15 00:00:00	1959-03-15	38000177		0	0	7		0	0	0	45380	0	562251	1713671		
204709	4493	40213160	1982-11-30	1982-11-30 00:00:00	1982-11-30	1982-11-30 00:00:00	1982-11-30	581452		0	0	0		0	0	0	299172	0	10	40213160		
116804	2567	40213296	2017-08-05	2017-08-05 00:00:00	2017-08-05	2017-08-05 00:00:00	2017-08-05	581452		0	0	0		0	0	0	170060	0	52	40213296		
216872	4758	40213160	1958-06-15	1958-06-15 00:00:00	1958-06-15	1958-06-15 00:00:00	1958-06-15	581452		0	0	0		0	0	0	316999	0	10	40213160		
122212	2686	40213260	2006-10-15	2006-10-15 00:00:00	2006-10-15	2006-10-15 00:00:00	2006-10-15	581452		0	0	0		0	0	0	177990	0	121	40213260		
11924	994	19129655	1962-08-05	1962-08-05 00:00:00	1962-08-19	1962-08-19 00:00:00	1962-08-19	38000177		0	0	14		0	0	0	65914	0	789980	19129655		
239964	5267	40213160	1967-08-13	1967-08-13 00:00:00	1967-08-13	1967-08-13 00:00:00	1967-08-13	581452		0	0	0		0	0	0	350445	0	10	40213160		
103954	2280	40213306	1993-04-14	1993-04-14 00:00:00	1993-04-14	1993-04-14 00:00:00	1993-04-14	581452		0	0	0		0	0	0	\N	0	43	40213306		
61165	5086	1127078	1972-10-26	1972-10-26 00:00:00	1972-11-09	1972-11-09 00:00:00	1972-11-09	38000177		0	0	14		0	0	0	338185	0	282464	1127078		
229706	5048	40213160	1963-08-02	1963-08-02 00:00:00	1963-08-02	1963-08-02 00:00:00	1963-08-02	581452		0	0	0		0	0	0	335410	0	10	40213160		
63485	5276	19018935	2009-12-27	2009-12-27 00:00:00	2009-12-27	2009-12-27 00:00:00	\N	38000177		0	0	0		0	0	0	350871	0	197604	19018935		
162613	3576	40213160	1970-12-26	1970-12-26 00:00:00	1970-12-26	1970-12-26 00:00:00	1970-12-26	581452		0	0	0		0	0	0	237728	0	10	40213160		
53580	4454	40229134	1985-12-08	1985-12-08 00:00:00	1985-12-15	1985-12-15 00:00:00	1985-12-15	38000177		0	0	7		0	0	0	296417	0	1043400	40229134		
34493	2849	19078461	1987-09-25	1987-09-25 00:00:00	1987-12-24	1987-12-24 00:00:00	1987-12-24	38000177		0	0	90		0	0	0	189295	0	310965	19078461		
62358	5191	19128065	1988-07-26	1988-07-26 00:00:00	1989-07-21	1989-07-21 00:00:00	1989-07-21	38000177		0	0	360		0	0	0	345110	0	749882	19128065		
187435	4117	40213160	1963-05-24	1963-05-24 00:00:00	1963-05-24	1963-05-24 00:00:00	1963-05-24	581452		0	0	0		0	0	0	273700	0	10	40213160		
166117	3651	40213260	2010-07-01	2010-07-01 00:00:00	2010-07-01	2010-07-01 00:00:00	2010-07-01	581452		0	0	0		0	0	0	243014	0	121	40213260		
161116	3545	40213296	2011-03-09	2011-03-09 00:00:00	2011-03-09	2011-03-09 00:00:00	2011-03-09	581452		0	0	0		0	0	0	235462	0	52	40213296		
181463	3987	40213160	1955-12-03	1955-12-03 00:00:00	1955-12-03	1955-12-03 00:00:00	1955-12-03	581452		0	0	0		0	0	0	265100	0	10	40213160		
151806	3339	40213296	2003-09-23	2003-09-23 00:00:00	2003-09-23	2003-09-23 00:00:00	2003-09-23	581452		0	0	0		0	0	0	221474	0	52	40213296		
160416	3530	40213160	1959-10-02	1959-10-02 00:00:00	1959-10-02	1959-10-02 00:00:00	1959-10-02	581452		0	0	0		0	0	0	234505	0	10	40213160		
7645	164	40213160	1970-12-14	1970-12-14 00:00:00	1970-12-14	1970-12-14 00:00:00	1970-12-14	581452		0	0	0		0	0	0	11257	0	10	40213160		
38882	3214	19019979	1982-12-17	1982-12-17 00:00:00	1982-12-31	1982-12-31 00:00:00	1982-12-31	38000177		0	0	14		0	0	0	213494	0	198405	19019979		
231855	5095	40213260	2016-05-09	2016-05-09 00:00:00	2016-05-09	2016-05-09 00:00:00	2016-05-09	581452		0	0	0		0	0	0	338559	0	121	40213260		
19709	1622	1127433	1978-04-07	1978-04-07 00:00:00	1978-04-21	1978-04-21 00:00:00	1978-04-21	38000177		0	0	14		0	0	0	109006	0	313782	1127433		
35860	2951	19078461	1986-04-07	1986-04-07 00:00:00	1986-05-07	1986-05-07 00:00:00	1986-05-07	38000177		0	0	30		0	0	0	197009	0	310965	19078461		
30580	2537	1118084	1990-01-23	1990-01-23 00:00:00	1990-01-23	1990-01-23 00:00:00	\N	38000177		0	0	0		0	0	0	167694	0	00025152531	44923712		
174771	3843	40213160	1969-03-16	1969-03-16 00:00:00	1969-03-16	1969-03-16 00:00:00	1969-03-16	581452		0	0	0		0	0	0	255114	0	10	40213160		
236311	5189	40213160	1956-01-29	1956-01-29 00:00:00	1956-01-29	1956-01-29 00:00:00	1956-01-29	581452		0	0	0		0	0	0	344919	0	10	40213160		
88681	1945	40213306	1993-01-30	1993-01-30 00:00:00	1993-01-30	1993-01-30 00:00:00	1993-01-30	581452		0	0	0		0	0	0	129226	0	43	40213306		
14354	1206	1127433	1990-01-24	1990-01-24 00:00:00	1990-02-07	1990-02-07 00:00:00	1990-02-07	38000177		0	0	14		0	0	0	79260	0	313782	1127433		
41977	915	40213260	2011-02-12	2011-02-12 00:00:00	2011-02-12	2011-02-12 00:00:00	2011-02-12	581452		0	0	0		0	0	0	60812	0	121	40213260		
53412	4439	19133873	1961-12-19	1961-12-19 00:00:00	1961-12-26	1961-12-26 00:00:00	1961-12-26	38000177		0	0	7		0	0	0	295121	0	834061	19133873		
13463	1128	1115171	2016-03-16	2016-03-16 00:00:00	2016-04-13	2016-04-13 00:00:00	2016-04-13	38000177		0	0	28		0	0	0	74346	0	849574	1115171		
175597	3860	40213306	1994-11-05	1994-11-05 00:00:00	1994-11-05	1994-11-05 00:00:00	1994-11-05	581452		0	0	0		0	0	0	256295	0	43	40213306		
63772	5299	19129655	1974-09-09	1974-09-09 00:00:00	1974-09-23	1974-09-23 00:00:00	1974-09-23	38000177		0	0	14		0	0	0	352546	0	789980	19129655		
202613	4448	40213160	1959-03-26	1959-03-26 00:00:00	1959-03-26	1959-03-26 00:00:00	1959-03-26	581452		0	0	0		0	0	0	295885	0	10	40213160		
64247	5333	1127433	1960-03-09	1960-03-09 00:00:00	1960-03-23	1960-03-23 00:00:00	1960-03-23	38000177		0	0	14		0	0	0	355146	0	313782	1127433		
152790	3363	40213198	2016-05-27	2016-05-27 00:00:00	2016-05-27	2016-05-27 00:00:00	2016-05-27	581452		0	0	0		0	0	0	222975	0	133	40213198		
182610	4013	40213160	1975-04-27	1975-04-27 00:00:00	1975-04-27	1975-04-27 00:00:00	1975-04-27	581452		0	0	0		0	0	0	266634	0	10	40213160		
179258	3941	40213306	1986-06-10	1986-06-10 00:00:00	1986-06-10	1986-06-10 00:00:00	1986-06-10	581452		0	0	0		0	0	0	262013	0	43	40213306		
166827	3667	40213260	2017-12-26	2017-12-26 00:00:00	2017-12-26	2017-12-26 00:00:00	2017-12-26	581452		0	0	0		0	0	0	243974	0	121	40213260		
25160	2071	1127433	1989-01-19	1989-01-19 00:00:00	1989-01-26	1989-01-26 00:00:00	1989-01-26	38000177		0	0	7		0	0	0	137806	0	313782	1127433		
56533	4690	40236824	2012-08-26	2012-08-26 00:00:00	2012-09-09	2012-09-09 00:00:00	2012-09-09	38000177		0	0	14		0	0	0	312495	0	1094107	40236824		
193157	4243	40213160	1968-09-27	1968-09-27 00:00:00	1968-09-27	1968-09-27 00:00:00	1968-09-27	581452		0	0	0		0	0	0	281846	0	10	40213160		
239296	5253	40213160	1960-11-19	1960-11-19 00:00:00	1960-11-19	1960-11-19 00:00:00	1960-11-19	581452		0	0	0		0	0	0	349498	0	10	40213160		
8217	686	19059056	1948-01-30	1948-01-30 00:00:00	1948-02-13	1948-02-13 00:00:00	1948-02-13	38000177		0	0	14		0	0	0	45420	0	243670	19059056		
204715	4493	40213314	1982-09-28	1982-09-28 00:00:00	1982-09-28	1982-09-28 00:00:00	1982-09-28	581452		0	0	0		0	0	0	299144	0	49	40213314		
116808	2567	40213227	1997-12-20	1997-12-20 00:00:00	1997-12-20	1997-12-20 00:00:00	1997-12-20	581452		0	0	0		0	0	0	170066	0	113	40213227		
216874	4758	40213160	1963-02-17	1963-02-17 00:00:00	1963-02-17	1963-02-17 00:00:00	1963-02-17	581452		0	0	0		0	0	0	317014	0	10	40213160		
122220	2686	40213296	1996-10-06	1996-10-06 00:00:00	1996-10-06	1996-10-06 00:00:00	1996-10-06	581452		0	0	0		0	0	0	178044	0	52	40213296		
11925	994	19059056	1962-08-05	1962-08-05 00:00:00	1962-08-19	1962-08-19 00:00:00	1962-08-19	38000177		0	0	14		0	0	0	65914	0	243670	19059056		
239968	5267	40213260	2016-12-04	2016-12-04 00:00:00	2016-12-04	2016-12-04 00:00:00	2016-12-04	581452		0	0	0		0	0	0	350475	0	121	40213260		
103957	2280	40213306	1993-04-21	1993-04-21 00:00:00	1993-04-21	1993-04-21 00:00:00	1993-04-21	581452		0	0	0		0	0	0	151623	0	43	40213306		
119199	2621	40213296	1999-02-27	1999-02-27 00:00:00	1999-02-27	1999-02-27 00:00:00	1999-02-27	581452		0	0	0		0	0	0	173388	0	52	40213296		
229711	5048	40213227	1992-09-04	1992-09-04 00:00:00	1992-09-04	1992-09-04 00:00:00	1992-09-04	581452		0	0	0		0	0	0	\N	0	113	40213227		
63486	5276	1118084	1998-03-25	1998-03-25 00:00:00	1998-03-25	1998-03-25 00:00:00	\N	38000177		0	0	0		0	0	0	350952	0	00025152531	44923712		
158092	3481	40213314	1977-08-06	1977-08-06 00:00:00	1977-08-06	1977-08-06 00:00:00	1977-08-06	581452		0	0	0		0	0	0	230840	0	49	40213314		
53581	4454	1127433	2000-05-07	2000-05-07 00:00:00	2000-05-28	2000-05-28 00:00:00	2000-05-28	38000177		0	0	21		0	0	0	296503	0	313782	1127433		
34494	2849	40165015	1987-09-25	1987-09-25 00:00:00	1987-09-25	1987-09-25 00:00:00	\N	38000177		0	0	0		0	0	0	189295	0	861467	40165015		
62359	5191	40229134	2014-09-03	2014-09-03 00:00:00	2014-09-10	2014-09-10 00:00:00	2014-09-10	38000177		0	0	7		0	0	0	345090	0	1043400	40229134		
187436	4117	40213296	2002-12-20	2002-12-20 00:00:00	2002-12-20	2002-12-20 00:00:00	2002-12-20	581452		0	0	0		0	0	0	273709	0	52	40213296		
166119	3651	40213260	2009-10-15	2009-10-15 00:00:00	2009-10-15	2009-10-15 00:00:00	2009-10-15	581452		0	0	0		0	0	0	\N	0	121	40213260		
161123	3545	40213160	1976-02-11	1976-02-11 00:00:00	1976-02-11	1976-02-11 00:00:00	1976-02-11	581452		0	0	0		0	0	0	235487	0	10	40213160		
174197	3830	40213160	1982-01-24	1982-01-24 00:00:00	1982-01-24	1982-01-24 00:00:00	1982-01-24	581452		0	0	0		0	0	0	254303	0	10	40213160		
151808	3339	40213160	1960-06-21	1960-06-21 00:00:00	1960-06-21	1960-06-21 00:00:00	1960-06-21	581452		0	0	0		0	0	0	221491	0	10	40213160		
160423	3530	40213296	1999-04-30	1999-04-30 00:00:00	1999-04-30	1999-04-30 00:00:00	1999-04-30	581452		0	0	0		0	0	0	234477	0	52	40213296		
7654	164	40213306	1988-01-04	1988-01-04 00:00:00	1988-01-04	1988-01-04 00:00:00	1988-01-04	581452		0	0	0		0	0	0	11261	0	43	40213306		
38883	3214	1127433	1991-05-02	1991-05-02 00:00:00	1991-05-16	1991-05-16 00:00:00	1991-05-16	38000177		0	0	14		0	0	0	213497	0	313782	1127433		
231861	5095	40213227	1997-07-14	1997-07-14 00:00:00	1997-07-14	1997-07-14 00:00:00	1997-07-14	581452		0	0	0		0	0	0	338543	0	113	40213227		
19710	1622	19128065	1988-05-23	1988-05-23 00:00:00	1989-05-18	1989-05-18 00:00:00	1989-05-18	38000177		0	0	360		0	0	0	108972	0	749882	19128065		
35861	2951	40162522	1986-04-07	1986-04-07 00:00:00	1986-04-07	1986-04-07 00:00:00	\N	38000177		0	0	0		0	0	0	197009	0	857005	40162522		
30581	2537	19059056	1949-04-22	1949-04-22 00:00:00	1949-05-06	1949-05-06 00:00:00	1949-05-06	38000177		0	0	14		0	0	0	167743	0	243670	19059056		
139474	3064	40213227	2017-05-18	2017-05-18 00:00:00	2017-05-18	2017-05-18 00:00:00	2017-05-18	581452		0	0	0		0	0	0	203914	0	113	40213227		
236314	5190	40213227	1998-07-31	1998-07-31 00:00:00	1998-07-31	1998-07-31 00:00:00	1998-07-31	581452		0	0	0		0	0	0	\N	0	113	40213227		
88707	1946	40213227	2007-12-01	2007-12-01 00:00:00	2007-12-01	2007-12-01 00:00:00	2007-12-01	581452		0	0	0		0	0	0	129363	0	113	40213227		
14355	1206	1127433	2011-03-11	2011-03-11 00:00:00	2011-03-18	2011-03-18 00:00:00	2011-03-18	38000177		0	0	7		0	0	0	79241	0	313782	1127433		
41983	915	40213227	1994-10-29	1994-10-29 00:00:00	1994-10-29	1994-10-29 00:00:00	1994-10-29	581452		0	0	0		0	0	0	60795	0	113	40213227		
53413	4439	1127433	1999-02-18	1999-02-18 00:00:00	1999-03-04	1999-03-04 00:00:00	1999-03-04	38000177		0	0	14		0	0	0	295123	0	313782	1127433		
13464	1128	19059056	1970-05-17	1970-05-17 00:00:00	1970-05-31	1970-05-31 00:00:00	1970-05-31	38000177		0	0	14		0	0	0	74334	0	243670	19059056		
175599	3860	40213227	1994-11-05	1994-11-05 00:00:00	1994-11-05	1994-11-05 00:00:00	1994-11-05	581452		0	0	0		0	0	0	256295	0	113	40213227		
63774	5299	19128065	1986-06-04	1986-06-04 00:00:00	1987-05-30	1987-05-30 00:00:00	1987-05-30	38000177		0	0	360		0	0	0	352534	0	749882	19128065		
202616	4448	40213227	2015-06-18	2015-06-18 00:00:00	2015-06-18	2015-06-18 00:00:00	2015-06-18	581452		0	0	0		0	0	0	295894	0	113	40213227		
64248	5333	19078461	1990-03-30	1990-03-30 00:00:00	1990-05-04	1990-05-04 00:00:00	1990-05-04	38000177		0	0	35		0	0	0	355122	0	310965	19078461		
152798	3363	40213227	2012-05-04	2012-05-04 00:00:00	2012-05-04	2012-05-04 00:00:00	2012-05-04	581452		0	0	0		0	0	0	222973	0	113	40213227		
182611	4013	40213296	2014-11-23	2014-11-23 00:00:00	2014-11-23	2014-11-23 00:00:00	2014-11-23	581452		0	0	0		0	0	0	266663	0	52	40213296		
179270	3941	40213296	2003-07-01	2003-07-01 00:00:00	2003-07-01	2003-07-01 00:00:00	2003-07-01	581452		0	0	0		0	0	0	262036	0	52	40213296		
178121	3916	40213296	2018-10-10	2018-10-10 00:00:00	2018-10-10	2018-10-10 00:00:00	2018-10-10	581452		0	0	0		0	0	0	260293	0	52	40213296		
25161	2071	1127078	1973-03-06	1973-03-06 00:00:00	1973-05-05	1973-05-05 00:00:00	1973-05-05	38000177		0	0	60		0	0	0	137801	0	282464	1127078		
56534	4690	1127433	1993-05-20	1993-05-20 00:00:00	1993-06-03	1993-06-03 00:00:00	1993-06-03	38000177		0	0	14		0	0	0	312469	0	313782	1127433		
193159	4243	40213160	1968-04-26	1968-04-26 00:00:00	1968-04-26	1968-04-26 00:00:00	1968-04-26	581452		0	0	0		0	0	0	281845	0	10	40213160		
239298	5253	40213260	2007-12-22	2007-12-22 00:00:00	2007-12-22	2007-12-22 00:00:00	2007-12-22	581452		0	0	0		0	0	0	349567	0	121	40213260		
8218	686	19006318	1948-01-30	1948-01-30 00:00:00	1948-02-13	1948-02-13 00:00:00	1948-02-13	38000177		0	0	14		0	0	0	45420	0	105078	19006318		
204716	4493	40213160	1982-09-28	1982-09-28 00:00:00	1982-09-28	1982-09-28 00:00:00	1982-09-28	581452		0	0	0		0	0	0	299144	0	10	40213160		
116809	2567	40213306	1997-12-20	1997-12-20 00:00:00	1997-12-20	1997-12-20 00:00:00	1997-12-20	581452		0	0	0		0	0	0	170066	0	43	40213306		
216879	4758	40213160	1958-08-17	1958-08-17 00:00:00	1958-08-17	1958-08-17 00:00:00	1958-08-17	581452		0	0	0		0	0	0	317032	0	10	40213160		
122228	2686	40213160	1956-11-11	1956-11-11 00:00:00	1956-11-11	1956-11-11 00:00:00	1956-11-11	581452		0	0	0		0	0	0	\N	0	10	40213160		
221450	4859	40213260	2006-05-07	2006-05-07 00:00:00	2006-05-07	2006-05-07 00:00:00	2006-05-07	581452		0	0	0		0	0	0	323203	0	121	40213260		
239972	5267	40213227	1998-02-15	1998-02-15 00:00:00	1998-02-15	1998-02-15 00:00:00	1998-02-15	581452		0	0	0		0	0	0	350394	0	113	40213227		
103959	2280	40213160	1969-09-10	1969-09-10 00:00:00	1969-09-10	1969-09-10 00:00:00	1969-09-10	581452		0	0	0		0	0	0	151595	0	10	40213160		
119201	2621	40213227	1999-02-27	1999-02-27 00:00:00	1999-02-27	1999-02-27 00:00:00	1999-02-27	581452		0	0	0		0	0	0	173388	0	113	40213227		
229717	5048	40213227	2010-04-09	2010-04-09 00:00:00	2010-04-09	2010-04-09 00:00:00	2010-04-09	581452		0	0	0		0	0	0	335417	0	113	40213227		
63487	5276	19128065	1975-12-26	1975-12-26 00:00:00	1976-12-20	1976-12-20 00:00:00	1976-12-20	38000177		0	0	360		0	0	0	350908	0	749882	19128065		
158093	3481	40213160	1977-08-06	1977-08-06 00:00:00	1977-08-06	1977-08-06 00:00:00	1977-08-06	581452		0	0	0		0	0	0	230840	0	10	40213160		
53582	4454	1713671	1922-01-24	1922-01-24 00:00:00	1922-02-14	1922-02-14 00:00:00	1922-02-14	38000177		0	0	21		0	0	0	296461	0	562251	1713671		
34495	2849	19059056	1933-11-18	1933-11-18 00:00:00	1933-12-02	1933-12-02 00:00:00	1933-12-02	38000177		0	0	14		0	0	0	189291	0	243670	19059056		
62361	5191	1127433	1993-01-22	1993-01-22 00:00:00	1993-01-29	1993-01-29 00:00:00	1993-01-29	38000177		0	0	7		0	0	0	345118	0	313782	1127433		
187440	4117	40213306	1985-02-15	1985-02-15 00:00:00	1985-02-15	1985-02-15 00:00:00	1985-02-15	581452		0	0	0		0	0	0	273739	0	43	40213306		
166123	3651	40213296	2002-10-03	2002-10-03 00:00:00	2002-10-03	2002-10-03 00:00:00	2002-10-03	581452		0	0	0		0	0	0	243038	0	52	40213296		
161125	3545	40213227	1993-05-05	1993-05-05 00:00:00	1993-05-05	1993-05-05 00:00:00	1993-05-05	581452		0	0	0		0	0	0	235478	0	113	40213227		
174198	3830	40213314	1982-01-24	1982-01-24 00:00:00	1982-01-24	1982-01-24 00:00:00	1982-01-24	581452		0	0	0		0	0	0	254303	0	49	40213314		
151811	3339	40213227	2001-09-18	2001-09-18 00:00:00	2001-09-18	2001-09-18 00:00:00	2001-09-18	581452		0	0	0		0	0	0	221524	0	113	40213227		
160427	3530	40213160	1959-07-31	1959-07-31 00:00:00	1959-07-31	1959-07-31 00:00:00	1959-07-31	581452		0	0	0		0	0	0	234501	0	10	40213160		
7657	164	40213227	1999-04-12	1999-04-12 00:00:00	1999-04-12	1999-04-12 00:00:00	1999-04-12	581452		0	0	0		0	0	0	11252	0	113	40213227		
38884	3214	19073188	1991-05-02	1991-05-02 00:00:00	1991-05-16	1991-05-16 00:00:00	1991-05-16	38000177		0	0	14		0	0	0	213497	0	308192	19073188		
231865	5095	40213306	1988-07-04	1988-07-04 00:00:00	1988-07-04	1988-07-04 00:00:00	1988-07-04	581452		0	0	0		0	0	0	338511	0	43	40213306		
19711	1622	1127433	2002-06-12	2002-06-12 00:00:00	2002-06-26	2002-06-26 00:00:00	2002-06-26	38000177		0	0	14		0	0	0	108998	0	313782	1127433		
35862	2951	19078461	1983-08-07	1983-08-07 00:00:00	1983-08-21	1983-08-21 00:00:00	1983-08-21	38000177		0	0	14		0	0	0	197008	0	310965	19078461		
30582	2537	19006318	1949-04-22	1949-04-22 00:00:00	1949-05-06	1949-05-06 00:00:00	1949-05-06	38000177		0	0	14		0	0	0	167743	0	105078	19006318		
139481	3064	40213201	2002-02-21	2002-02-21 00:00:00	2002-02-21	2002-02-21 00:00:00	2002-02-21	581452		0	0	0		0	0	0	203909	0	33	40213201		
236315	5190	40213296	1998-07-31	1998-07-31 00:00:00	1998-07-31	1998-07-31 00:00:00	1998-07-31	581452		0	0	0		0	0	0	\N	0	52	40213296		
185255	4071	40213227	2013-11-28	2013-11-28 00:00:00	2013-11-28	2013-11-28 00:00:00	2013-11-28	581452		0	0	0		0	0	0	270596	0	113	40213227		
14356	1206	19059056	1965-07-17	1965-07-17 00:00:00	1965-07-31	1965-07-31 00:00:00	1965-07-31	38000177		0	0	14		0	0	0	79250	0	243670	19059056		
41994	915	40213306	1982-10-16	1982-10-16 00:00:00	1982-10-16	1982-10-16 00:00:00	1982-10-16	581452		0	0	0		0	0	0	60855	0	43	40213306		
53414	4439	1127433	2002-03-01	2002-03-01 00:00:00	2002-03-22	2002-03-22 00:00:00	2002-03-22	38000177		0	0	21		0	0	0	295082	0	313782	1127433		
13465	1128	19006318	1970-05-17	1970-05-17 00:00:00	1970-05-31	1970-05-31 00:00:00	1970-05-31	38000177		0	0	14		0	0	0	74334	0	105078	19006318		
186877	4105	40213227	2008-09-06	2008-09-06 00:00:00	2008-09-06	2008-09-06 00:00:00	2008-09-06	581452		0	0	0		0	0	0	272743	0	113	40213227		
63775	5299	19128065	1988-05-24	1988-05-24 00:00:00	1989-05-19	1989-05-19 00:00:00	1989-05-19	38000177		0	0	360		0	0	0	352536	0	749882	19128065		
202617	4448	40213160	1955-03-24	1955-03-24 00:00:00	1955-03-24	1955-03-24 00:00:00	1955-03-24	581452		0	0	0		0	0	0	295823	0	10	40213160		
64249	5333	1127433	1993-12-20	1993-12-20 00:00:00	1994-01-03	1994-01-03 00:00:00	1994-01-03	38000177		0	0	14		0	0	0	355094	0	313782	1127433		
152803	3363	40213160	1956-02-10	1956-02-10 00:00:00	1956-02-10	1956-02-10 00:00:00	1956-02-10	581452		0	0	0		0	0	0	223013	0	10	40213160		
182613	4013	40213160	1975-07-27	1975-07-27 00:00:00	1975-07-27	1975-07-27 00:00:00	1975-07-27	581452		0	0	0		0	0	0	266686	0	10	40213160		
94506	2073	40213306	1985-01-11	1985-01-11 00:00:00	1985-01-11	1985-01-11 00:00:00	1985-01-11	581452		0	0	0		0	0	0	137909	0	43	40213306		
178128	3916	40213306	2001-12-05	2001-12-05 00:00:00	2001-12-05	2001-12-05 00:00:00	2001-12-05	581452		0	0	0		0	0	0	\N	0	43	40213306		
25163	2071	19128065	1980-06-07	1980-06-07 00:00:00	1981-06-02	1981-06-02 00:00:00	1981-06-02	38000177		0	0	360		0	0	0	137831	0	749882	19128065		
56535	4690	1127433	1980-02-09	1980-02-09 00:00:00	1980-02-23	1980-02-23 00:00:00	1980-02-23	38000177		0	0	14		0	0	0	312492	0	313782	1127433		
193163	4243	40213160	1968-06-28	1968-06-28 00:00:00	1968-06-28	1968-06-28 00:00:00	1968-06-28	581452		0	0	0		0	0	0	281854	0	10	40213160		
239305	5253	40213160	1956-05-19	1956-05-19 00:00:00	1956-05-19	1956-05-19 00:00:00	1956-05-19	581452		0	0	0		0	0	0	349494	0	10	40213160		
8219	686	1713671	1968-01-19	1968-01-19 00:00:00	1968-01-26	1968-01-26 00:00:00	1968-01-26	38000177		0	0	7		0	0	0	45383	0	562251	1713671		
204718	4493	40213227	2004-07-20	2004-07-20 00:00:00	2004-07-20	2004-07-20 00:00:00	2004-07-20	581452		0	0	0		0	0	0	299181	0	113	40213227		
116812	2567	40213296	2015-08-01	2015-08-01 00:00:00	2015-08-01	2015-08-01 00:00:00	2015-08-01	581452		0	0	0		0	0	0	170092	0	52	40213296		
216880	4758	40213160	1958-11-16	1958-11-16 00:00:00	1958-11-16	1958-11-16 00:00:00	1958-11-16	581452		0	0	0		0	0	0	317011	0	10	40213160		
122234	2686	40213227	2014-09-07	2014-09-07 00:00:00	2014-09-07	2014-09-07 00:00:00	2014-09-07	581452		0	0	0		0	0	0	178027	0	113	40213227		
221462	4859	40213227	2015-06-28	2015-06-28 00:00:00	2015-06-28	2015-06-28 00:00:00	2015-06-28	581452		0	0	0		0	0	0	323282	0	113	40213227		
239979	5267	40213160	1971-11-14	1971-11-14 00:00:00	1971-11-14	1971-11-14 00:00:00	1971-11-14	581452		0	0	0		0	0	0	350422	0	10	40213160		
103967	2280	40213227	2002-07-17	2002-07-17 00:00:00	2002-07-17	2002-07-17 00:00:00	2002-07-17	581452		0	0	0		0	0	0	\N	0	113	40213227		
119203	2621	40213160	1961-08-05	1961-08-05 00:00:00	1961-08-05	1961-08-05 00:00:00	1961-08-05	581452		0	0	0		0	0	0	173359	0	10	40213160		
229718	5048	40213260	2010-04-09	2010-04-09 00:00:00	2010-04-09	2010-04-09 00:00:00	2010-04-09	581452		0	0	0		0	0	0	335417	0	121	40213260		
63488	5276	19128065	1978-12-10	1978-12-10 00:00:00	1979-12-05	1979-12-05 00:00:00	1979-12-05	38000177		0	0	360		0	0	0	350909	0	749882	19128065		
158095	3481	40213227	2008-07-12	2008-07-12 00:00:00	2008-07-12	2008-07-12 00:00:00	2008-07-12	581452		0	0	0		0	0	0	230882	0	113	40213227		
53583	4454	40163554	2006-10-07	2006-10-07 00:00:00	2006-10-07	2006-10-07 00:00:00	\N	38000177		0	0	0		0	0	0	296468	0	855332	40163554		
34496	2849	1127433	2003-05-04	2003-05-04 00:00:00	2003-07-03	2003-07-03 00:00:00	2003-07-03	38000177		0	0	60		0	0	0	189296	0	313782	1127433		
62362	5191	40236824	2018-09-06	2018-09-06 00:00:00	2018-09-13	2018-09-13 00:00:00	2018-09-13	38000177		0	0	7		0	0	0	345109	0	1094107	40236824		
187445	4117	40213227	1994-02-25	1994-02-25 00:00:00	1994-02-25	1994-02-25 00:00:00	1994-02-25	581452		0	0	0		0	0	0	273706	0	113	40213227		
159191	3504	40213227	1993-11-12	1993-11-12 00:00:00	1993-11-12	1993-11-12 00:00:00	1993-11-12	581452		0	0	0		0	0	0	232277	0	113	40213227		
161126	3545	40213306	1993-05-05	1993-05-05 00:00:00	1993-05-05	1993-05-05 00:00:00	1993-05-05	581452		0	0	0		0	0	0	235478	0	43	40213306		
174202	3830	40213160	1982-04-26	1982-04-26 00:00:00	1982-04-26	1982-04-26 00:00:00	1982-04-26	581452		0	0	0		0	0	0	254324	0	10	40213160		
151812	3339	40213296	2001-09-18	2001-09-18 00:00:00	2001-09-18	2001-09-18 00:00:00	2001-09-18	581452		0	0	0		0	0	0	221524	0	52	40213296		
160430	3530	40213160	1964-03-27	1964-03-27 00:00:00	1964-03-27	1964-03-27 00:00:00	1964-03-27	581452		0	0	0		0	0	0	234494	0	10	40213160		
7661	164	40213227	2007-04-23	2007-04-23 00:00:00	2007-04-23	2007-04-23 00:00:00	2007-04-23	581452		0	0	0		0	0	0	11276	0	113	40213227		
38885	3214	40231925	1991-05-02	1991-05-02 00:00:00	1991-05-02	1991-05-02 00:00:00	\N	38000177		0	0	0		0	0	0	213497	0	1049221	40231925		
231867	5095	40213160	1965-06-14	1965-06-14 00:00:00	1965-06-14	1965-06-14 00:00:00	1965-06-14	581452		0	0	0		0	0	0	338502	0	10	40213160		
19712	1622	40229134	2015-04-08	2015-04-08 00:00:00	2015-04-22	2015-04-22 00:00:00	2015-04-22	38000177		0	0	14		0	0	0	108971	0	1043400	40229134		
35865	2953	19133873	1993-11-02	1993-11-02 00:00:00	1993-11-11	1993-11-11 00:00:00	1993-11-11	38000177		0	0	9		0	0	0	197129	0	834061	19133873		
30583	2537	40169216	1950-08-23	1950-08-23 00:00:00	1950-08-23	1950-08-23 00:00:00	\N	38000177		0	0	0		0	0	0	167752	0	895994	40169216		
139494	3064	40213227	1997-01-23	1997-01-23 00:00:00	1997-01-23	1997-01-23 00:00:00	1997-01-23	581452		0	0	0		0	0	0	203907	0	113	40213227		
236324	5190	40213227	2018-10-05	2018-10-05 00:00:00	2018-10-05	2018-10-05 00:00:00	2018-10-05	581452		0	0	0		0	0	0	344990	0	113	40213227		
185257	4071	40213296	1996-09-12	1996-09-12 00:00:00	1996-09-12	1996-09-12 00:00:00	1996-09-12	581452		0	0	0		0	0	0	270638	0	52	40213296		
14357	1206	19129655	1965-07-17	1965-07-17 00:00:00	1965-07-31	1965-07-31 00:00:00	1965-07-31	38000177		0	0	14		0	0	0	79250	0	789980	19129655		
41997	915	40213160	1964-12-05	1964-12-05 00:00:00	1964-12-05	1964-12-05 00:00:00	1964-12-05	581452		0	0	0		0	0	0	60821	0	10	40213160		
53415	4439	40229134	1989-07-08	1989-07-08 00:00:00	1989-07-22	1989-07-22 00:00:00	1989-07-22	38000177		0	0	14		0	0	0	295127	0	1043400	40229134		
13466	1128	1118084	2006-04-08	2006-04-08 00:00:00	2006-04-08	2006-04-08 00:00:00	\N	38000177		0	0	0		0	0	0	74307	0	00025152531	44923712		
186889	4105	40213201	2014-03-29	2014-03-29 00:00:00	2014-03-29	2014-03-29 00:00:00	2014-03-29	581452		0	0	0		0	0	0	272703	0	33	40213201		
63776	5299	1124300	2007-01-20	2007-01-20 00:00:00	2007-01-20	2007-01-20 00:00:00	\N	38000177		0	0	0		0	0	0	352490	0	00781178901	45011828		
202618	4448	40213160	1955-09-22	1955-09-22 00:00:00	1955-09-22	1955-09-22 00:00:00	1955-09-22	581452		0	0	0		0	0	0	295833	0	10	40213160		
64250	5333	836659	1996-01-14	1996-01-14 00:00:00	1996-01-14	1996-01-14 00:00:00	\N	38000177		0	0	0		0	0	0	355117	0	313185	836659		
152811	3364	40213160	1976-12-02	1976-12-02 00:00:00	1976-12-02	1976-12-02 00:00:00	1976-12-02	581452		0	0	0		0	0	0	223093	0	10	40213160		
182617	4013	40213314	1977-10-23	1977-10-23 00:00:00	1977-10-23	1977-10-23 00:00:00	1977-10-23	581452		0	0	0		0	0	0	266688	0	49	40213314		
37234	812	40213160	1964-03-21	1964-03-21 00:00:00	1964-03-21	1964-03-21 00:00:00	1964-03-21	581452		0	0	0		0	0	0	53858	0	10	40213160		
17399	1441	1127078	1974-01-20	1974-01-20 00:00:00	1974-02-19	1974-02-19 00:00:00	1974-02-19	38000177		0	0	30		0	0	0	95947	0	282464	1127078		
25164	2071	19059056	1970-02-20	1970-02-20 00:00:00	1970-05-21	1970-05-21 00:00:00	1970-05-21	38000177		0	0	90		0	0	0	137800	0	243670	19059056		
56536	4690	920300	2010-07-10	2010-07-10 00:00:00	2010-07-17	2010-07-17 00:00:00	2010-07-17	38000177		0	0	7		0	0	0	312518	0	311989	920300		
193166	4243	40213227	2019-03-29	2019-03-29 00:00:00	2019-03-29	2019-03-29 00:00:00	2019-03-29	581452		0	0	0		0	0	0	281808	0	113	40213227		
239307	5253	40213227	2017-05-13	2017-05-13 00:00:00	2017-05-13	2017-05-13 00:00:00	2017-05-13	581452		0	0	0		0	0	0	349515	0	113	40213227		
8220	686	1118084	1980-12-22	1980-12-22 00:00:00	1980-12-22	1980-12-22 00:00:00	\N	38000177		0	0	0		0	0	0	45407	0	00025152531	44923712		
204719	4493	40213306	2004-07-20	2004-07-20 00:00:00	2004-07-20	2004-07-20 00:00:00	2004-07-20	581452		0	0	0		0	0	0	299181	0	43	40213306		
216813	4757	40213160	1956-12-05	1956-12-05 00:00:00	1956-12-05	1956-12-05 00:00:00	1956-12-05	581452		0	0	0		0	0	0	316883	0	10	40213160		
216891	4759	40213306	2000-08-22	2000-08-22 00:00:00	2000-08-22	2000-08-22 00:00:00	2000-08-22	581452		0	0	0		0	0	0	317110	0	43	40213306		
122241	2686	40213227	2003-09-28	2003-09-28 00:00:00	2003-09-28	2003-09-28 00:00:00	2003-09-28	581452		0	0	0		0	0	0	178045	0	113	40213227		
221464	4859	40213160	1955-04-03	1955-04-03 00:00:00	1955-04-03	1955-04-03 00:00:00	1955-04-03	581452		0	0	0		0	0	0	323256	0	10	40213160		
235386	5170	40213306	1991-03-01	1991-03-01 00:00:00	1991-03-01	1991-03-01 00:00:00	1991-03-01	581452		0	0	0		0	0	0	343749	0	43	40213306		
103969	2280	40213306	1991-11-06	1991-11-06 00:00:00	1991-11-06	1991-11-06 00:00:00	1991-11-06	581452		0	0	0		0	0	0	151638	0	43	40213306		
119214	2621	40213160	1957-05-04	1957-05-04 00:00:00	1957-05-04	1957-05-04 00:00:00	1957-05-04	581452		0	0	0		0	0	0	173342	0	10	40213160		
229719	5048	40213160	1959-04-03	1959-04-03 00:00:00	1959-04-03	1959-04-03 00:00:00	1959-04-03	581452		0	0	0		0	0	0	335433	0	10	40213160		
63489	5276	1713671	2001-02-05	2001-02-05 00:00:00	2001-02-19	2001-02-19 00:00:00	2001-02-19	38000177		0	0	14		0	0	0	350876	0	562251	1713671		
158101	3481	40213160	1982-04-10	1982-04-10 00:00:00	1982-04-10	1982-04-10 00:00:00	1982-04-10	581452		0	0	0		0	0	0	230844	0	10	40213160		
53584	4454	40171902	2006-10-07	2006-10-07 00:00:00	2006-10-07	2006-10-07 00:00:00	\N	38000177		0	0	0		0	0	0	296468	0	897718	40171902		
34497	2849	1127433	1933-01-13	1933-01-13 00:00:00	1933-01-20	1933-01-20 00:00:00	1933-01-20	38000177		0	0	7		0	0	0	189276	0	313782	1127433		
62363	5191	920300	2018-09-06	2018-09-06 00:00:00	2018-09-13	2018-09-13 00:00:00	2018-09-13	38000177		0	0	7		0	0	0	345109	0	311989	920300		
187451	4117	40213160	1963-08-23	1963-08-23 00:00:00	1963-08-23	1963-08-23 00:00:00	1963-08-23	581452		0	0	0		0	0	0	273718	0	10	40213160		
159193	3504	40213227	2004-01-09	2004-01-09 00:00:00	2004-01-09	2004-01-09 00:00:00	2004-01-09	581452		0	0	0		0	0	0	232356	0	113	40213227		
161127	3545	40213160	1971-11-10	1971-11-10 00:00:00	1971-11-10	1971-11-10 00:00:00	1971-11-10	581452		0	0	0		0	0	0	235485	0	10	40213160		
174212	3831	40213260	2007-01-07	2007-01-07 00:00:00	2007-01-07	2007-01-07 00:00:00	2007-01-07	581452		0	0	0		0	0	0	254343	0	121	40213260		
151815	3339	40213227	1993-06-29	1993-06-29 00:00:00	1993-06-29	1993-06-29 00:00:00	1993-06-29	581452		0	0	0		0	0	0	221511	0	113	40213227		
148632	3268	40213227	2000-12-15	2000-12-15 00:00:00	2000-12-15	2000-12-15 00:00:00	2000-12-15	581452		0	0	0		0	0	0	217209	0	113	40213227		
7662	164	40213296	2007-04-23	2007-04-23 00:00:00	2007-04-23	2007-04-23 00:00:00	2007-04-23	581452		0	0	0		0	0	0	11276	0	52	40213296		
38887	3214	1127433	2003-12-31	2003-12-31 00:00:00	2004-01-07	2004-01-07 00:00:00	2004-01-07	38000177		0	0	7		0	0	0	213550	0	313782	1127433		
231870	5095	40213160	1969-12-15	1969-12-15 00:00:00	1969-12-15	1969-12-15 00:00:00	1969-12-15	581452		0	0	0		0	0	0	338505	0	10	40213160		
19713	1622	42902245	2001-03-22	2001-03-22 00:00:00	2002-03-17	2002-03-17 00:00:00	2002-03-17	38000177		0	0	360		0	0	0	108980	0	1359133	42902245		
35866	2953	19075001	1986-04-25	1986-04-25 00:00:00	1986-05-09	1986-05-09 00:00:00	1986-05-09	38000177		0	0	14		0	0	0	197127	0	309097	19075001		
30584	2537	1154615	1950-08-23	1950-08-23 00:00:00	1950-08-23	1950-08-23 00:00:00	\N	38000177		0	0	0		0	0	0	167752	0	745679	1154615		
139499	3064	40213227	2007-03-22	2007-03-22 00:00:00	2007-03-22	2007-03-22 00:00:00	2007-03-22	581452		0	0	0		0	0	0	203884	0	113	40213227		
225212	4945	40213227	1996-11-21	1996-11-21 00:00:00	1996-11-21	1996-11-21 00:00:00	1996-11-21	581452		0	0	0		0	0	0	328694	0	113	40213227		
185263	4071	40213160	1956-03-08	1956-03-08 00:00:00	1956-03-08	1956-03-08 00:00:00	1956-03-08	581452		0	0	0		0	0	0	270647	0	10	40213160		
14358	1206	1150837	1988-02-28	1988-02-28 00:00:00	1988-02-28	1988-02-28 00:00:00	\N	38000177		0	0	0		0	0	0	79246	0	141918	1150837		
42000	915	40213160	1960-09-03	1960-09-03 00:00:00	1960-09-03	1960-09-03 00:00:00	1960-09-03	581452		0	0	0		0	0	0	60847	0	10	40213160		
53416	4439	1127078	1955-07-17	1955-07-17 00:00:00	1955-07-31	1955-07-31 00:00:00	1955-07-31	38000177		0	0	14		0	0	0	295128	0	282464	1127078		
13467	1128	1127433	1975-02-21	1975-02-21 00:00:00	1975-02-28	1975-02-28 00:00:00	1975-02-28	38000177		0	0	7		0	0	0	74348	0	313782	1127433		
48053	1051	40213260	2015-02-10	2015-02-10 00:00:00	2015-02-10	2015-02-10 00:00:00	2015-02-10	581452		0	0	0		0	0	0	68902	0	121	40213260		
63777	5299	19074679	2006-05-07	2006-05-07 00:00:00	2006-12-31	2006-12-31 00:00:00	2006-12-31	38000177		0	0	238		0	0	0	352490	0	308971	19074679		
39799	3293	1127433	1960-12-12	1960-12-12 00:00:00	1960-12-19	1960-12-19 00:00:00	1960-12-19	38000177		0	0	7		0	0	0	218679	0	313782	1127433		
64251	5333	1124300	1986-08-13	1986-08-13 00:00:00	1986-08-13	1986-08-13 00:00:00	\N	38000177		0	0	0		0	0	0	355092	0	00781178901	45011828		
152812	3364	40213314	1977-03-03	1977-03-03 00:00:00	1977-03-03	1977-03-03 00:00:00	1977-03-03	581452		0	0	0		0	0	0	223026	0	49	40213314		
182619	4013	40213160	1975-02-23	1975-02-23 00:00:00	1975-02-23	1975-02-23 00:00:00	1975-02-23	581452		0	0	0		0	0	0	266685	0	10	40213160		
98227	2151	40213227	1999-09-15	1999-09-15 00:00:00	1999-09-15	1999-09-15 00:00:00	1999-09-15	581452		0	0	0		0	0	0	143267	0	113	40213227		
17400	1441	1115171	1994-01-03	1994-01-03 00:00:00	1994-01-17	1994-01-17 00:00:00	1994-01-17	38000177		0	0	14		0	0	0	96015	0	849574	1115171		
25165	2071	1118084	2004-05-22	2004-05-22 00:00:00	2004-05-22	2004-05-22 00:00:00	\N	38000177		0	0	0		0	0	0	137826	0	00025152531	44923712		
193167	4243	40213260	2019-03-29	2019-03-29 00:00:00	2019-03-29	2019-03-29 00:00:00	2019-03-29	581452		0	0	0		0	0	0	281808	0	121	40213260		
119221	2621	40213227	2018-05-19	2018-05-19 00:00:00	2018-05-19	2018-05-19 00:00:00	2018-05-19	581452		0	0	0		0	0	0	173349	0	113	40213227		
8221	686	19133905	1967-06-12	1967-06-12 00:00:00	1967-06-19	1967-06-19 00:00:00	1967-06-19	38000177		0	0	7		0	0	0	45382	0	834102	19133905		
234297	5148	40213260	2011-01-10	2011-01-10 00:00:00	2011-01-10	2011-01-10 00:00:00	2011-01-10	581452		0	0	0		0	0	0	342260	0	121	40213260		
216815	4757	40213296	1996-09-25	1996-09-25 00:00:00	1996-09-25	1996-09-25 00:00:00	1996-09-25	581452		0	0	0		0	0	0	316956	0	52	40213296		
216895	4759	40213160	1977-02-22	1977-02-22 00:00:00	1977-02-22	1977-02-22 00:00:00	1977-02-22	581452		0	0	0		0	0	0	317049	0	10	40213160		
122244	2686	40213160	1956-02-26	1956-02-26 00:00:00	1956-02-26	1956-02-26 00:00:00	1956-02-26	581452		0	0	0		0	0	0	178010	0	10	40213160		
221470	4860	40213306	2000-12-22	2000-12-22 00:00:00	2000-12-22	2000-12-22 00:00:00	2000-12-22	581452		0	0	0		0	0	0	323320	0	43	40213306		
229562	5045	40213160	1960-12-10	1960-12-10 00:00:00	1960-12-10	1960-12-10 00:00:00	1960-12-10	581452		0	0	0		0	0	0	335270	0	10	40213160		
130510	2868	40213296	2002-10-16	2002-10-16 00:00:00	2002-10-16	2002-10-16 00:00:00	2002-10-16	581452		0	0	0		0	0	0	190783	0	52	40213296		
229723	5049	40213160	1966-05-18	1966-05-18 00:00:00	1966-05-18	1966-05-18 00:00:00	1966-05-18	581452		0	0	0		0	0	0	\N	0	10	40213160		
63490	5276	1127433	1960-06-08	1960-06-08 00:00:00	1960-06-22	1960-06-22 00:00:00	1960-06-22	38000177		0	0	14		0	0	0	350922	0	313782	1127433		
171763	3776	40213314	1977-05-07	1977-05-07 00:00:00	1977-05-07	1977-05-07 00:00:00	1977-05-07	581452		0	0	0		0	0	0	250963	0	49	40213314		
53585	4454	19018935	2006-10-07	2006-10-07 00:00:00	2006-10-07	2006-10-07 00:00:00	\N	38000177		0	0	0		0	0	0	296468	0	197604	19018935		
34498	2849	19059056	1964-05-14	1964-05-14 00:00:00	1964-06-13	1964-06-13 00:00:00	1964-06-13	38000177		0	0	30		0	0	0	189293	0	243670	19059056		
62364	5191	19059056	1981-05-20	1981-05-20 00:00:00	1981-06-03	1981-06-03 00:00:00	1981-06-03	38000177		0	0	14		0	0	0	345062	0	243670	19059056		
210163	4608	40213227	2005-12-22	2005-12-22 00:00:00	2005-12-22	2005-12-22 00:00:00	2005-12-22	581452		0	0	0		0	0	0	307060	0	113	40213227		
159196	3504	40213201	1988-10-14	1988-10-14 00:00:00	1988-10-14	1988-10-14 00:00:00	1988-10-14	581452		0	0	0		0	0	0	232363	0	33	40213201		
161132	3545	40213227	2003-02-26	2003-02-26 00:00:00	2003-02-26	2003-02-26 00:00:00	2003-02-26	581452		0	0	0		0	0	0	235441	0	113	40213227		
174220	3831	40213160	1955-05-08	1955-05-08 00:00:00	1955-05-08	1955-05-08 00:00:00	1955-05-08	581452		0	0	0		0	0	0	254332	0	10	40213160		
151836	3342	40213227	1992-11-18	1992-11-18 00:00:00	1992-11-18	1992-11-18 00:00:00	1992-11-18	581452		0	0	0		0	0	0	221659	0	113	40213227		
148642	3268	40213160	1974-06-21	1974-06-21 00:00:00	1974-06-21	1974-06-21 00:00:00	1974-06-21	581452		0	0	0		0	0	0	217179	0	10	40213160		
7672	165	40213227	2010-06-23	2010-06-23 00:00:00	2010-06-23	2010-06-23 00:00:00	2010-06-23	581452		0	0	0		0	0	0	11346	0	113	40213227		
38888	3214	19078461	2005-10-29	2005-10-29 00:00:00	2005-11-26	2005-11-26 00:00:00	2005-11-26	38000177		0	0	28		0	0	0	213498	0	310965	19078461		
231873	5096	40213306	1989-05-11	1989-05-11 00:00:00	1989-05-11	1989-05-11 00:00:00	1989-05-11	581452		0	0	0		0	0	0	338591	0	43	40213306		
19714	1622	19128022	1996-04-11	1996-04-11 00:00:00	1997-04-06	1997-04-06 00:00:00	1997-04-06	38000177		0	0	360		0	0	0	108963	0	749785	19128022		
35867	2953	1127078	1986-04-25	1986-04-25 00:00:00	1986-05-09	1986-05-09 00:00:00	1986-05-09	38000177		0	0	14		0	0	0	197127	0	282464	1127078		
30585	2537	1127433	2006-10-08	2006-10-08 00:00:00	2006-10-22	2006-10-22 00:00:00	2006-10-22	38000177		0	0	14		0	0	0	167675	0	313782	1127433		
213849	4689	40213160	1972-04-18	1972-04-18 00:00:00	1972-04-18	1972-04-18 00:00:00	1972-04-18	581452		0	0	0		0	0	0	312436	0	10	40213160		
225217	4945	40213227	2005-05-05	2005-05-05 00:00:00	2005-05-05	2005-05-05 00:00:00	2005-05-05	581452		0	0	0		0	0	0	328700	0	113	40213227		
196553	4319	40213227	2008-12-31	2008-12-31 00:00:00	2008-12-31	2008-12-31 00:00:00	2008-12-31	581452		0	0	0		0	0	0	286591	0	113	40213227		
14359	1206	1594382	1988-02-28	1988-02-28 00:00:00	1988-02-28	1988-02-28 00:00:00	\N	38000177		0	0	0		0	0	0	79246	0	1870230	1594382		
77134	1686	40213227	2002-05-19	2002-05-19 00:00:00	2002-05-19	2002-05-19 00:00:00	2002-05-19	581452		0	0	0		0	0	0	112948	0	113	40213227		
53417	4439	19006318	1955-07-17	1955-07-17 00:00:00	1955-07-31	1955-07-31 00:00:00	1955-07-31	38000177		0	0	14		0	0	0	295128	0	105078	19006318		
188204	4133	40213227	1999-06-11	1999-06-11 00:00:00	1999-06-11	1999-06-11 00:00:00	1999-06-11	581452		0	0	0		0	0	0	274761	0	113	40213227		
48054	1051	40213227	1996-10-08	1996-10-08 00:00:00	1996-10-08	1996-10-08 00:00:00	1996-10-08	581452		0	0	0		0	0	0	68898	0	113	40213227		
63778	5299	1713671	1978-06-11	1978-06-11 00:00:00	1978-07-02	1978-07-02 00:00:00	1978-07-02	38000177		0	0	21		0	0	0	352493	0	562251	1713671		
39800	3293	1118084	1950-04-26	1950-04-26 00:00:00	1950-04-26	1950-04-26 00:00:00	\N	38000177		0	0	0		0	0	0	218672	0	00025152531	44923712		
64252	5333	1127433	1993-08-27	1993-08-27 00:00:00	1993-09-03	1993-09-03 00:00:00	1993-09-03	38000177		0	0	7		0	0	0	355148	0	313782	1127433		
152814	3364	40213160	1977-03-03	1977-03-03 00:00:00	1977-03-03	1977-03-03 00:00:00	1977-03-03	581452		0	0	0		0	0	0	223026	0	10	40213160		
182622	4013	40213296	2016-11-27	2016-11-27 00:00:00	2016-11-27	2016-11-27 00:00:00	2016-11-27	581452		0	0	0		0	0	0	266646	0	52	40213296		
98261	2152	40213227	1993-03-27	1993-03-27 00:00:00	1993-03-27	1993-03-27 00:00:00	1993-03-27	581452		0	0	0		0	0	0	143386	0	113	40213227		
17401	1441	19073188	1994-01-03	1994-01-03 00:00:00	1994-01-17	1994-01-17 00:00:00	1994-01-17	38000177		0	0	14		0	0	0	96015	0	308192	19073188		
25166	2071	1127078	1968-04-01	1968-04-01 00:00:00	1968-04-15	1968-04-15 00:00:00	1968-04-15	38000177		0	0	14		0	0	0	137791	0	282464	1127078		
193169	4243	40213160	1972-12-29	1972-12-29 00:00:00	1972-12-29	1972-12-29 00:00:00	1972-12-29	581452		0	0	0		0	0	0	281856	0	10	40213160		
119228	2621	40213160	1956-12-01	1956-12-01 00:00:00	1956-12-01	1956-12-01 00:00:00	1956-12-01	581452		0	0	0		0	0	0	173341	0	10	40213160		
8222	686	19059056	1971-03-17	1971-03-17 00:00:00	1971-03-31	1971-03-31 00:00:00	1971-03-31	38000177		0	0	14		0	0	0	45441	0	243670	19059056		
234302	5148	40213160	1960-05-24	1960-05-24 00:00:00	1960-05-24	1960-05-24 00:00:00	1960-05-24	581452		0	0	0		0	0	0	342268	0	10	40213160		
216817	4757	40213160	1956-09-05	1956-09-05 00:00:00	1956-09-05	1956-09-05 00:00:00	1956-09-05	581452		0	0	0		0	0	0	316907	0	10	40213160		
216896	4759	40213314	1977-02-22	1977-02-22 00:00:00	1977-02-22	1977-02-22 00:00:00	1977-02-22	581452		0	0	0		0	0	0	317049	0	49	40213314		
112374	2469	40213227	2013-08-11	2013-08-11 00:00:00	2013-08-11	2013-08-11 00:00:00	2013-08-11	581452		0	0	0		0	0	0	163709	0	113	40213227		
221472	4860	40213227	2000-12-22	2000-12-22 00:00:00	2000-12-22	2000-12-22 00:00:00	2000-12-22	581452		0	0	0		0	0	0	323320	0	113	40213227		
229567	5045	40213306	1982-07-24	1982-07-24 00:00:00	1982-07-24	1982-07-24 00:00:00	1982-07-24	581452		0	0	0		0	0	0	335251	0	43	40213306		
130512	2868	40213160	1963-06-19	1963-06-19 00:00:00	1963-06-19	1963-06-19 00:00:00	1963-06-19	581452		0	0	0		0	0	0	190777	0	10	40213160		
229730	5049	40213160	1962-10-10	1962-10-10 00:00:00	1962-10-10	1962-10-10 00:00:00	1962-10-10	581452		0	0	0		0	0	0	335566	0	10	40213160		
63491	5276	19006318	1958-02-18	1958-02-18 00:00:00	1958-03-04	1958-03-04 00:00:00	1958-03-04	38000177		0	0	14		0	0	0	350880	0	105078	19006318		
171767	3776	40213227	2004-08-14	2004-08-14 00:00:00	2004-08-14	2004-08-14 00:00:00	2004-08-14	581452		0	0	0		0	0	0	250976	0	113	40213227		
53586	4454	1713671	1991-01-14	1991-01-14 00:00:00	1991-02-04	1991-02-04 00:00:00	1991-02-04	38000177		0	0	21		0	0	0	296403	0	562251	1713671		
197586	4342	40213227	2008-09-12	2008-09-12 00:00:00	2008-09-12	2008-09-12 00:00:00	2008-09-12	581452		0	0	0		0	0	0	287869	0	113	40213227		
67690	1480	40213160	1966-09-30	1966-09-30 00:00:00	1966-09-30	1966-09-30 00:00:00	1966-09-30	581452		0	0	0		0	0	0	98756	0	10	40213160		
210172	4608	40213160	1955-08-25	1955-08-25 00:00:00	1955-08-25	1955-08-25 00:00:00	1955-08-25	581452		0	0	0		0	0	0	307009	0	10	40213160		
159206	3505	40213227	2008-04-04	2008-04-04 00:00:00	2008-04-04	2008-04-04 00:00:00	2008-04-04	581452		0	0	0		0	0	0	232479	0	113	40213227		
161138	3545	40213227	2013-03-13	2013-03-13 00:00:00	2013-03-13	2013-03-13 00:00:00	2013-03-13	581452		0	0	0		0	0	0	235480	0	113	40213227		
174228	3831	40213160	1955-08-07	1955-08-07 00:00:00	1955-08-07	1955-08-07 00:00:00	1955-08-07	581452		0	0	0		0	0	0	254378	0	10	40213160		
26972	587	40213251	1984-03-07	1984-03-07 00:00:00	1984-03-07	1984-03-07 00:00:00	1984-03-07	581452		0	0	0		0	0	0	38897	0	21	40213251		
148647	3268	40213160	1970-03-20	1970-03-20 00:00:00	1970-03-20	1970-03-20 00:00:00	1970-03-20	581452		0	0	0		0	0	0	217217	0	10	40213160		
7673	165	40213296	2010-06-23	2010-06-23 00:00:00	2010-06-23	2010-06-23 00:00:00	2010-06-23	581452		0	0	0		0	0	0	11346	0	52	40213296		
38889	3214	19078461	1988-07-02	1988-07-02 00:00:00	1988-07-16	1988-07-16 00:00:00	1988-07-16	38000177		0	0	14		0	0	0	213496	0	310965	19078461		
231877	5096	40213260	2017-04-13	2017-04-13 00:00:00	2017-04-13	2017-04-13 00:00:00	2017-04-13	581452		0	0	0		0	0	0	338625	0	121	40213260		
19715	1622	19127922	2002-03-17	2002-03-17 00:00:00	2003-03-12	2003-03-12 00:00:00	2003-03-12	38000177		0	0	360		0	0	0	109046	0	748962	19127922		
35868	2953	19073188	2019-03-28	2019-03-28 00:00:00	2019-04-11	2019-04-11 00:00:00	2019-04-11	38000177		0	0	14		0	0	0	197137	0	308192	19073188		
30586	2537	19059056	1948-08-11	1948-08-11 00:00:00	1948-08-25	1948-08-25 00:00:00	1948-08-25	38000177		0	0	14		0	0	0	167742	0	243670	19059056		
213854	4689	40213227	1998-10-07	1998-10-07 00:00:00	1998-10-07	1998-10-07 00:00:00	1998-10-07	581452		0	0	0		0	0	0	\N	0	113	40213227		
225224	4945	40213160	1955-07-07	1955-07-07 00:00:00	1955-07-07	1955-07-07 00:00:00	1955-07-07	581452		0	0	0		0	0	0	328674	0	10	40213160		
196554	4319	40213306	1998-09-30	1998-09-30 00:00:00	1998-09-30	1998-09-30 00:00:00	1998-09-30	581452		0	0	0		0	0	0	\N	0	43	40213306		
14360	1206	46233988	1969-05-01	1969-05-01 00:00:00	1969-05-15	1969-05-15 00:00:00	1969-05-15	38000177		0	0	14		0	0	0	79234	0	1652673	46233988		
77135	1686	40213296	2002-05-19	2002-05-19 00:00:00	2002-05-19	2002-05-19 00:00:00	2002-05-19	581452		0	0	0		0	0	0	112948	0	52	40213296		
51804	4308	1713671	1988-05-29	1988-05-29 00:00:00	1988-06-05	1988-06-05 00:00:00	1988-06-05	38000177		0	0	7		0	0	0	285830	0	562251	1713671		
188205	4133	40213306	1999-06-11	1999-06-11 00:00:00	1999-06-11	1999-06-11 00:00:00	1999-06-11	581452		0	0	0		0	0	0	274761	0	43	40213306		
48065	1051	40213306	1987-04-21	1987-04-21 00:00:00	1987-04-21	1987-04-21 00:00:00	1987-04-21	581452		0	0	0		0	0	0	68922	0	43	40213306		
63779	5299	19115351	2011-06-19	2011-06-19 00:00:00	2012-01-22	2012-01-22 00:00:00	2012-01-22	38000177		0	0	217		0	0	0	352496	0	563026	19115351		
39801	3293	1713671	1999-03-05	1999-03-05 00:00:00	1999-03-26	1999-03-26 00:00:00	1999-03-26	38000177		0	0	21		0	0	0	218736	0	562251	1713671		
64253	5333	40229134	1955-12-06	1955-12-06 00:00:00	1955-12-20	1955-12-20 00:00:00	1955-12-20	38000177		0	0	14		0	0	0	355145	0	1043400	40229134		
152815	3364	40213160	1981-06-04	1981-06-04 00:00:00	1981-06-04	1981-06-04 00:00:00	1981-06-04	581452		0	0	0		0	0	0	223095	0	10	40213160		
182624	4013	40213227	2016-11-27	2016-11-27 00:00:00	2016-11-27	2016-11-27 00:00:00	2016-11-27	581452		0	0	0		0	0	0	266646	0	113	40213227		
98263	2152	40213227	2003-05-24	2003-05-24 00:00:00	2003-05-24	2003-05-24 00:00:00	2003-05-24	581452		0	0	0		0	0	0	143352	0	113	40213227		
17402	1441	1127433	1976-10-08	1976-10-08 00:00:00	1976-10-22	1976-10-22 00:00:00	1976-10-22	38000177		0	0	14		0	0	0	96029	0	313782	1127433		
25167	2071	1115171	2005-12-13	2005-12-13 00:00:00	2006-01-03	2006-01-03 00:00:00	2006-01-03	38000177		0	0	21		0	0	0	137788	0	849574	1115171		
193172	4243	40213296	2008-01-25	2008-01-25 00:00:00	2008-01-25	2008-01-25 00:00:00	2008-01-25	581452		0	0	0		0	0	0	281805	0	52	40213296		
119231	2621	40213296	1997-02-22	1997-02-22 00:00:00	1997-02-22	1997-02-22 00:00:00	1997-02-22	581452		0	0	0		0	0	0	173364	0	52	40213296		
8223	686	19129655	1971-03-17	1971-03-17 00:00:00	1971-03-31	1971-03-31 00:00:00	1971-03-31	38000177		0	0	14		0	0	0	45441	0	789980	19129655		
234308	5148	40213227	1993-12-06	1993-12-06 00:00:00	1993-12-06	1993-12-06 00:00:00	1993-12-06	581452		0	0	0		0	0	0	342288	0	113	40213227		
216824	4757	40213260	2006-03-29	2006-03-29 00:00:00	2006-03-29	2006-03-29 00:00:00	2006-03-29	581452		0	0	0		0	0	0	316938	0	121	40213260		
227137	4987	40213160	1960-03-01	1960-03-01 00:00:00	1960-03-01	1960-03-01 00:00:00	1960-03-01	581452		0	0	0		0	0	0	331770	0	10	40213160		
112375	2469	40213296	2013-08-11	2013-08-11 00:00:00	2013-08-11	2013-08-11 00:00:00	2013-08-11	581452		0	0	0		0	0	0	163709	0	52	40213296		
221474	4860	40213251	1984-09-14	1984-09-14 00:00:00	1984-09-14	1984-09-14 00:00:00	1984-09-14	581452		0	0	0		0	0	0	323303	0	21	40213251		
229580	5046	40213296	2000-01-24	2000-01-24 00:00:00	2000-01-24	2000-01-24 00:00:00	2000-01-24	581452		0	0	0		0	0	0	335335	0	52	40213296		
130513	2868	40213160	1967-09-20	1967-09-20 00:00:00	1967-09-20	1967-09-20 00:00:00	1967-09-20	581452		0	0	0		0	0	0	190770	0	10	40213160		
229732	5049	40213160	1962-07-11	1962-07-11 00:00:00	1962-07-11	1962-07-11 00:00:00	1962-07-11	581452		0	0	0		0	0	0	335581	0	10	40213160		
63492	5276	19059056	1958-02-18	1958-02-18 00:00:00	1958-03-04	1958-03-04 00:00:00	1958-03-04	38000177		0	0	14		0	0	0	350880	0	243670	19059056		
171769	3776	40213160	1973-11-10	1973-11-10 00:00:00	1973-11-10	1973-11-10 00:00:00	1973-11-10	581452		0	0	0		0	0	0	250987	0	10	40213160		
53587	4454	1127433	1934-02-20	1934-02-20 00:00:00	1934-03-06	1934-03-06 00:00:00	1934-03-06	38000177		0	0	14		0	0	0	296370	0	313782	1127433		
197587	4342	40213260	2008-09-12	2008-09-12 00:00:00	2008-09-12	2008-09-12 00:00:00	2008-09-12	581452		0	0	0		0	0	0	287869	0	121	40213260		
67691	1480	40213160	1966-04-29	1966-04-29 00:00:00	1966-04-29	1966-04-29 00:00:00	1966-04-29	581452		0	0	0		0	0	0	98755	0	10	40213160		
210177	4608	40213160	1955-05-26	1955-05-26 00:00:00	1955-05-26	1955-05-26 00:00:00	1955-05-26	581452		0	0	0		0	0	0	307048	0	10	40213160		
159211	3505	40213227	2018-05-04	2018-05-04 00:00:00	2018-05-04	2018-05-04 00:00:00	2018-05-04	581452		0	0	0		0	0	0	\N	0	113	40213227		
161139	3545	40213296	2013-03-13	2013-03-13 00:00:00	2013-03-13	2013-03-13 00:00:00	2013-03-13	581452		0	0	0		0	0	0	235480	0	52	40213296		
174232	3831	40213227	2016-04-17	2016-04-17 00:00:00	2016-04-17	2016-04-17 00:00:00	2016-04-17	581452		0	0	0		0	0	0	254354	0	113	40213227		
26976	587	40213227	2000-05-24	2000-05-24 00:00:00	2000-05-24	2000-05-24 00:00:00	2000-05-24	581452		0	0	0		0	0	0	38886	0	113	40213227		
148651	3268	40213160	1969-12-19	1969-12-19 00:00:00	1969-12-19	1969-12-19 00:00:00	1969-12-19	581452		0	0	0		0	0	0	217168	0	10	40213160		
7676	165	40213160	1969-02-19	1969-02-19 00:00:00	1969-02-19	1969-02-19 00:00:00	1969-02-19	581452		0	0	0		0	0	0	11358	0	10	40213160		
38890	3214	46233988	1972-11-11	1972-11-11 00:00:00	1972-11-25	1972-11-25 00:00:00	1972-11-25	38000177		0	0	14		0	0	0	213529	0	1652673	46233988		
231880	5096	40213160	1967-12-21	1967-12-21 00:00:00	1967-12-21	1967-12-21 00:00:00	1967-12-21	581452		0	0	0		0	0	0	338617	0	10	40213160		
19716	1622	1127433	2000-10-28	2000-10-28 00:00:00	2000-12-02	2000-12-02 00:00:00	2000-12-02	38000177		0	0	35		0	0	0	108936	0	313782	1127433		
35869	2953	1115171	2019-03-28	2019-03-28 00:00:00	2019-04-11	2019-04-11 00:00:00	2019-04-11	38000177		0	0	14		0	0	0	197137	0	849574	1115171		
30587	2537	19059056	1957-11-13	1957-11-13 00:00:00	1957-12-04	1957-12-04 00:00:00	1957-12-04	38000177		0	0	21		0	0	0	167645	0	243670	19059056		
213859	4689	40213296	2008-01-22	2008-01-22 00:00:00	2008-01-22	2008-01-22 00:00:00	2008-01-22	581452		0	0	0		0	0	0	312401	0	52	40213296		
225227	4945	40213160	1955-04-07	1955-04-07 00:00:00	1955-04-07	1955-04-07 00:00:00	1955-04-07	581452		0	0	0		0	0	0	328712	0	10	40213160		
196557	4319	40213227	1999-12-22	1999-12-22 00:00:00	1999-12-22	1999-12-22 00:00:00	1999-12-22	581452		0	0	0		0	0	0	286588	0	113	40213227		
14361	1206	1127078	1969-05-01	1969-05-01 00:00:00	1969-05-15	1969-05-15 00:00:00	1969-05-15	38000177		0	0	14		0	0	0	79234	0	282464	1127078		
77138	1686	40213260	2011-06-12	2011-06-12 00:00:00	2011-06-12	2011-06-12 00:00:00	2011-06-12	581452		0	0	0		0	0	0	112972	0	121	40213260		
51805	4308	920300	1953-09-16	1953-09-16 00:00:00	1953-09-23	1953-09-23 00:00:00	1953-09-23	38000177		0	0	7		0	0	0	285742	0	311989	920300		
188207	4133	40213227	2018-12-14	2018-12-14 00:00:00	2018-12-14	2018-12-14 00:00:00	2018-12-14	581452		0	0	0		0	0	0	274811	0	113	40213227		
48070	1051	40213227	2007-08-28	2007-08-28 00:00:00	2007-08-28	2007-08-28 00:00:00	2007-08-28	581452		0	0	0		0	0	0	68893	0	113	40213227		
63781	5299	40236446	1980-06-10	1980-06-10 00:00:00	1981-03-17	1981-03-17 00:00:00	1981-03-17	38000177		0	0	280		0	0	0	352507	0	1091392	40236446		
39802	3293	40231925	1996-11-07	1996-11-07 00:00:00	1996-11-07	1996-11-07 00:00:00	\N	38000177		0	0	0		0	0	0	218695	0	1049221	40231925		
64254	5333	40229134	1954-05-10	1954-05-10 00:00:00	1954-05-24	1954-05-24 00:00:00	1954-05-24	38000177		0	0	14		0	0	0	355091	0	1043400	40229134		
178858	3932	40213160	1978-03-27	1978-03-27 00:00:00	1978-03-27	1978-03-27 00:00:00	1978-03-27	581452		0	0	0		0	0	0	261371	0	10	40213160		
182627	4013	40213227	1997-05-25	1997-05-25 00:00:00	1997-05-25	1997-05-25 00:00:00	1997-05-25	581452		0	0	0		0	0	0	266658	0	113	40213227		
164239	3612	40213260	2009-12-20	2009-12-20 00:00:00	2009-12-20	2009-12-20 00:00:00	2009-12-20	581452		0	0	0		0	0	0	239984	0	121	40213260		
17403	1441	19019979	1974-02-19	1974-02-19 00:00:00	1974-03-05	1974-03-05 00:00:00	1974-03-05	38000177		0	0	14		0	0	0	96036	0	198405	19019979		
25172	2073	1127433	1984-12-30	1984-12-30 00:00:00	1985-01-06	1985-01-06 00:00:00	1985-01-06	38000177		0	0	7		0	0	0	137899	0	313782	1127433		
193179	4243	40213227	1999-11-19	1999-11-19 00:00:00	1999-11-19	1999-11-19 00:00:00	1999-11-19	581452		0	0	0		0	0	0	281810	0	113	40213227		
119235	2621	40213160	1957-02-02	1957-02-02 00:00:00	1957-02-02	1957-02-02 00:00:00	1957-02-02	581452		0	0	0		0	0	0	173355	0	10	40213160		
8224	686	1127078	1951-01-03	1951-01-03 00:00:00	1951-01-17	1951-01-17 00:00:00	1951-01-17	38000177		0	0	14		0	0	0	45385	0	282464	1127078		
216826	4757	40213160	1961-03-08	1961-03-08 00:00:00	1961-03-08	1961-03-08 00:00:00	1961-03-08	581452		0	0	0		0	0	0	316943	0	10	40213160		
227140	4987	40213160	1964-09-01	1964-09-01 00:00:00	1964-09-01	1964-09-01 00:00:00	1964-09-01	581452		0	0	0		0	0	0	331780	0	10	40213160		
112380	2469	40213227	2002-09-01	2002-09-01 00:00:00	2002-09-01	2002-09-01 00:00:00	2002-09-01	581452		0	0	0		0	0	0	163706	0	113	40213227		
221486	4860	40213160	1983-09-09	1983-09-09 00:00:00	1983-09-09	1983-09-09 00:00:00	1983-09-09	581452		0	0	0		0	0	0	323329	0	10	40213160		
229582	5046	40213227	2000-01-24	2000-01-24 00:00:00	2000-01-24	2000-01-24 00:00:00	2000-01-24	581452		0	0	0		0	0	0	335335	0	113	40213227		
83843	1834	40213201	2012-07-08	2012-07-08 00:00:00	2012-07-08	2012-07-08 00:00:00	2012-07-08	581452		0	0	0		0	0	0	122468	0	33	40213201		
126802	2790	40213160	1955-06-30	1955-06-30 00:00:00	1955-06-30	1955-06-30 00:00:00	1955-06-30	581452		0	0	0		0	0	0	184909	0	10	40213160		
63493	5276	1127433	1975-07-31	1975-07-31 00:00:00	1975-08-21	1975-08-21 00:00:00	1975-08-21	38000177		0	0	21		0	0	0	350946	0	313782	1127433		
171778	3776	40213227	2015-06-13	2015-06-13 00:00:00	2015-06-13	2015-06-13 00:00:00	2015-06-13	581452		0	0	0		0	0	0	250977	0	113	40213227		
53588	4454	19059056	1938-05-16	1938-05-16 00:00:00	1938-06-06	1938-06-06 00:00:00	1938-06-06	38000177		0	0	21		0	0	0	296494	0	243670	19059056		
197597	4342	40213260	2007-09-07	2007-09-07 00:00:00	2007-09-07	2007-09-07 00:00:00	2007-09-07	581452		0	0	0		0	0	0	287903	0	121	40213260		
67695	1480	40213160	1966-07-01	1966-07-01 00:00:00	1966-07-01	1966-07-01 00:00:00	1966-07-01	581452		0	0	0		0	0	0	98746	0	10	40213160		
210181	4608	40213260	2008-01-03	2008-01-03 00:00:00	2008-01-03	2008-01-03 00:00:00	2008-01-03	581452		0	0	0		0	0	0	306942	0	121	40213260		
318	7	40213160	1969-07-16	1969-07-16 00:00:00	1969-07-16	1969-07-16 00:00:00	1969-07-16	581452		0	0	0		0	0	0	613	0	10	40213160		
86626	1900	40213160	1964-01-13	1964-01-13 00:00:00	1964-01-13	1964-01-13 00:00:00	1964-01-13	581452		0	0	0		0	0	0	126509	0	10	40213160		
174234	3831	40213160	1955-02-06	1955-02-06 00:00:00	1955-02-06	1955-02-06 00:00:00	1955-02-06	581452		0	0	0		0	0	0	254360	0	10	40213160		
26977	587	40213306	2000-05-24	2000-05-24 00:00:00	2000-05-24	2000-05-24 00:00:00	2000-05-24	581452		0	0	0		0	0	0	38886	0	43	40213306		
148652	3268	40213296	2011-07-22	2011-07-22 00:00:00	2011-07-22	2011-07-22 00:00:00	2011-07-22	581452		0	0	0		0	0	0	217211	0	52	40213296		
7681	165	40213227	1999-07-07	1999-07-07 00:00:00	1999-07-07	1999-07-07 00:00:00	1999-07-07	581452		0	0	0		0	0	0	11351	0	113	40213227		
38891	3214	1127078	1972-11-11	1972-11-11 00:00:00	1972-11-25	1972-11-25 00:00:00	1972-11-25	38000177		0	0	14		0	0	0	213529	0	282464	1127078		
231885	5096	40213227	1999-11-25	1999-11-25 00:00:00	1999-11-25	1999-11-25 00:00:00	1999-11-25	581452		0	0	0		0	0	0	338574	0	113	40213227		
19717	1622	1127433	1998-10-29	1998-10-29 00:00:00	1998-11-05	1998-11-05 00:00:00	1998-11-05	38000177		0	0	7		0	0	0	109031	0	313782	1127433		
35870	2953	1127433	1999-02-18	1999-02-18 00:00:00	1999-02-25	1999-02-25 00:00:00	1999-02-25	38000177		0	0	7		0	0	0	197147	0	313782	1127433		
30588	2537	19075601	1998-09-06	1998-09-06 00:00:00	1998-09-06	1998-09-06 00:00:00	1998-09-06	38000177		0	0	0		0	0	0	167610	0	309362	19075601		
213862	4689	40213306	1990-04-04	1990-04-04 00:00:00	1990-04-04	1990-04-04 00:00:00	1990-04-04	581452		0	0	0		0	0	0	312399	0	43	40213306		
225239	4945	40213227	2015-07-02	2015-07-02 00:00:00	2015-07-02	2015-07-02 00:00:00	2015-07-02	581452		0	0	0		0	0	0	328690	0	113	40213227		
196558	4319	40213306	1999-12-22	1999-12-22 00:00:00	1999-12-22	1999-12-22 00:00:00	1999-12-22	581452		0	0	0		0	0	0	286588	0	43	40213306		
14362	1206	19008572	1988-02-14	1988-02-14 00:00:00	1988-02-14	1988-02-14 00:00:00	\N	38000177		0	0	0		0	0	0	79237	0	106258	19008572		
77140	1686	40213160	1961-11-26	1961-11-26 00:00:00	1961-11-26	1961-11-26 00:00:00	1961-11-26	581452		0	0	0		0	0	0	112926	0	10	40213160		
51806	4308	40236824	1953-09-16	1953-09-16 00:00:00	1953-09-23	1953-09-23 00:00:00	1953-09-23	38000177		0	0	7		0	0	0	285742	0	1094107	40236824		
188208	4133	40213296	2018-12-14	2018-12-14 00:00:00	2018-12-14	2018-12-14 00:00:00	2018-12-14	581452		0	0	0		0	0	0	274811	0	52	40213296		
50068	1097	40213227	2000-07-20	2000-07-20 00:00:00	2000-07-20	2000-07-20 00:00:00	2000-07-20	581452		0	0	0		0	0	0	71986	0	113	40213227		
63782	5299	19059056	1988-11-10	1988-11-10 00:00:00	1989-01-09	1989-01-09 00:00:00	1989-01-09	38000177		0	0	60		0	0	0	352523	0	243670	19059056		
39803	3293	19078461	1996-11-07	1996-11-07 00:00:00	1997-02-05	1997-02-05 00:00:00	1997-02-05	38000177		0	0	90		0	0	0	218695	0	310965	19078461		
64255	5333	19059056	1962-12-22	1962-12-22 00:00:00	1963-02-20	1963-02-20 00:00:00	1963-02-20	38000177		0	0	60		0	0	0	355121	0	243670	19059056		
178860	3932	40213296	2013-11-25	2013-11-25 00:00:00	2013-11-25	2013-11-25 00:00:00	2013-11-25	581452		0	0	0		0	0	0	\N	0	52	40213296		
182628	4013	40213306	1997-05-25	1997-05-25 00:00:00	1997-05-25	1997-05-25 00:00:00	1997-05-25	581452		0	0	0		0	0	0	266658	0	43	40213306		
164241	3612	40213160	1960-08-28	1960-08-28 00:00:00	1960-08-28	1960-08-28 00:00:00	1960-08-28	581452		0	0	0		0	0	0	239976	0	10	40213160		
17404	1441	1115171	2018-11-05	2018-11-05 00:00:00	2018-11-26	2018-11-26 00:00:00	2018-11-26	38000177		0	0	21		0	0	0	95955	0	849574	1115171		
25173	2073	1713671	1966-12-03	1966-12-03 00:00:00	1966-12-17	1966-12-17 00:00:00	1966-12-17	38000177		0	0	14		0	0	0	137933	0	562251	1713671		
193181	4243	40213227	1993-01-08	1993-01-08 00:00:00	1993-01-08	1993-01-08 00:00:00	1993-01-08	581452		0	0	0		0	0	0	281809	0	113	40213227		
105325	2311	40213227	1994-10-29	1994-10-29 00:00:00	1994-10-29	1994-10-29 00:00:00	1994-10-29	581452		0	0	0		0	0	0	153716	0	113	40213227		
8225	686	19006318	1951-01-03	1951-01-03 00:00:00	1951-01-17	1951-01-17 00:00:00	1951-01-17	38000177		0	0	14		0	0	0	45385	0	105078	19006318		
216844	4758	40213296	2001-06-10	2001-06-10 00:00:00	2001-06-10	2001-06-10 00:00:00	2001-06-10	581452		0	0	0		0	0	0	317019	0	52	40213296		
227144	4988	40213160	1958-04-01	1958-04-01 00:00:00	1958-04-01	1958-04-01 00:00:00	1958-04-01	581452		0	0	0		0	0	0	331814	0	10	40213160		
112389	2469	40213227	1993-04-18	1993-04-18 00:00:00	1993-04-18	1993-04-18 00:00:00	1993-04-18	581452		0	0	0		0	0	0	163744	0	113	40213227		
221490	4860	40213160	1979-06-08	1979-06-08 00:00:00	1979-06-08	1979-06-08 00:00:00	1979-06-08	581452		0	0	0		0	0	0	323333	0	10	40213160		
229596	5046	40213227	2009-04-21	2009-04-21 00:00:00	2009-04-21	2009-04-21 00:00:00	2009-04-21	581452		0	0	0		0	0	0	335336	0	113	40213227		
40039	3313	19059056	1960-07-23	1960-07-23 00:00:00	1960-08-22	1960-08-22 00:00:00	1960-08-22	38000177		0	0	30		0	0	0	219995	0	243670	19059056		
126805	2790	40213160	1956-06-28	1956-06-28 00:00:00	1956-06-28	1956-06-28 00:00:00	1956-06-28	581452		0	0	0		0	0	0	184881	0	10	40213160		
63494	5276	1127433	1962-06-13	1962-06-13 00:00:00	1962-06-27	1962-06-27 00:00:00	1962-06-27	38000177		0	0	14		0	0	0	350902	0	313782	1127433		
171779	3776	40213296	2015-06-13	2015-06-13 00:00:00	2015-06-13	2015-06-13 00:00:00	2015-06-13	581452		0	0	0		0	0	0	250977	0	52	40213296		
53589	4454	1539411	2004-05-15	2004-05-15 00:00:00	2004-05-15	2004-05-15 00:00:00	\N	38000177		0	0	0		0	0	0	296432	0	312961	1539411		
197601	4342	40213296	1997-07-11	1997-07-11 00:00:00	1997-07-11	1997-07-11 00:00:00	1997-07-11	581452		0	0	0		0	0	0	287983	0	52	40213296		
67700	1480	40213160	1970-09-18	1970-09-18 00:00:00	1970-09-18	1970-09-18 00:00:00	1970-09-18	581452		0	0	0		0	0	0	98712	0	10	40213160		
210189	4608	40213227	2016-02-18	2016-02-18 00:00:00	2016-02-18	2016-02-18 00:00:00	2016-02-18	581452		0	0	0		0	0	0	307092	0	113	40213227		
327	7	40213296	2009-08-05	2009-08-05 00:00:00	2009-08-05	2009-08-05 00:00:00	2009-08-05	581452		0	0	0		0	0	0	645	0	52	40213296		
86630	1900	40213227	2006-01-02	2006-01-02 00:00:00	2006-01-02	2006-01-02 00:00:00	2006-01-02	581452		0	0	0		0	0	0	126504	0	113	40213227		
209072	4586	40213227	1999-01-24	1999-01-24 00:00:00	1999-01-24	1999-01-24 00:00:00	1999-01-24	581452		0	0	0		0	0	0	305458	0	113	40213227		
26982	587	40213160	1983-02-23	1983-02-23 00:00:00	1983-02-23	1983-02-23 00:00:00	1983-02-23	581452		0	0	0		0	0	0	\N	0	10	40213160		
85820	1879	40213296	2002-06-22	2002-06-22 00:00:00	2002-06-22	2002-06-22 00:00:00	2002-06-22	581452		0	0	0		0	0	0	125363	0	52	40213296		
148654	3268	40213227	2011-07-22	2011-07-22 00:00:00	2011-07-22	2011-07-22 00:00:00	2011-07-22	581452		0	0	0		0	0	0	217211	0	113	40213227		
38892	3214	40229134	2017-05-17	2017-05-17 00:00:00	2017-05-24	2017-05-24 00:00:00	2017-05-24	38000177		0	0	7		0	0	0	213553	0	1043400	40229134		
231891	5096	40213296	2007-12-06	2007-12-06 00:00:00	2007-12-06	2007-12-06 00:00:00	2007-12-06	581452		0	0	0		0	0	0	338623	0	52	40213296		
19718	1622	19128022	1991-05-08	1991-05-08 00:00:00	1992-05-02	1992-05-02 00:00:00	1992-05-02	38000177		0	0	360		0	0	0	109000	0	749785	19128022		
81549	1782	40213198	2018-04-17	2018-04-17 00:00:00	2018-04-17	2018-04-17 00:00:00	2018-04-17	581452		0	0	0		0	0	0	119369	0	133	40213198		
30589	2537	40220960	1998-09-06	1998-09-06 00:00:00	1998-09-06	1998-09-06 00:00:00	1998-09-06	38000177		0	0	0		0	0	0	167610	0	1804799	40220960		
213863	4689	40213296	2010-01-26	2010-01-26 00:00:00	2010-01-26	2010-01-26 00:00:00	2010-01-26	581452		0	0	0		0	0	0	312376	0	52	40213296		
225249	4945	40213260	2007-05-17	2007-05-17 00:00:00	2007-05-17	2007-05-17 00:00:00	2007-05-17	581452		0	0	0		0	0	0	328706	0	121	40213260		
196560	4319	40213160	1978-08-16	1978-08-16 00:00:00	1978-08-16	1978-08-16 00:00:00	1978-08-16	581452		0	0	0		0	0	0	286618	0	10	40213160		
14363	1206	1127433	1998-08-08	1998-08-08 00:00:00	1998-08-29	1998-08-29 00:00:00	1998-08-29	38000177		0	0	21		0	0	0	79262	0	313782	1127433		
77145	1686	40213306	1983-07-03	1983-07-03 00:00:00	1983-07-03	1983-07-03 00:00:00	1983-07-03	581452		0	0	0		0	0	0	112968	0	43	40213306		
51807	4308	920300	1958-11-05	1958-11-05 00:00:00	1958-11-12	1958-11-12 00:00:00	1958-11-12	38000177		0	0	7		0	0	0	285756	0	311989	920300		
188213	4133	40213160	1981-03-13	1981-03-13 00:00:00	1981-03-13	1981-03-13 00:00:00	1981-03-13	581452		0	0	0		0	0	0	274757	0	10	40213160		
50071	1097	40213160	1969-12-04	1969-12-04 00:00:00	1969-12-04	1969-12-04 00:00:00	1969-12-04	581452		0	0	0		0	0	0	71975	0	10	40213160		
63784	5300	1713671	1975-12-16	1975-12-16 00:00:00	1975-12-23	1975-12-23 00:00:00	1975-12-23	38000177		0	0	7		0	0	0	352603	0	562251	1713671		
39804	3293	19133905	1940-02-14	1940-02-14 00:00:00	1940-02-23	1940-02-23 00:00:00	1940-02-23	38000177		0	0	9		0	0	0	218661	0	834102	19133905		
64256	5333	40231925	1962-12-22	1962-12-22 00:00:00	1962-12-22	1962-12-22 00:00:00	\N	38000177		0	0	0		0	0	0	355121	0	1049221	40231925		
178862	3932	40213227	1995-07-24	1995-07-24 00:00:00	1995-07-24	1995-07-24 00:00:00	1995-07-24	581452		0	0	0		0	0	0	261407	0	113	40213227		
164246	3612	40213296	2000-01-16	2000-01-16 00:00:00	2000-01-16	2000-01-16 00:00:00	2000-01-16	581452		0	0	0		0	0	0	239995	0	52	40213296		
17405	1441	1127433	1993-10-10	1993-10-10 00:00:00	1993-10-24	1993-10-24 00:00:00	1993-10-24	38000177		0	0	14		0	0	0	96050	0	313782	1127433		
25174	2073	1124300	2003-12-22	2003-12-22 00:00:00	2003-12-22	2003-12-22 00:00:00	\N	38000177		0	0	0		0	0	0	137914	0	00781178901	45011828		
193188	4243	40213227	2010-01-29	2010-01-29 00:00:00	2010-01-29	2010-01-29 00:00:00	2010-01-29	581452		0	0	0		0	0	0	281867	0	113	40213227		
105330	2311	40213160	1964-10-10	1964-10-10 00:00:00	1964-10-10	1964-10-10 00:00:00	1964-10-10	581452		0	0	0		0	0	0	153723	0	10	40213160		
8226	686	1127433	1958-11-04	1958-11-04 00:00:00	1958-11-18	1958-11-18 00:00:00	1958-11-18	38000177		0	0	14		0	0	0	45394	0	313782	1127433		
216847	4758	40213227	1999-06-06	1999-06-06 00:00:00	1999-06-06	1999-06-06 00:00:00	1999-06-06	581452		0	0	0		0	0	0	316992	0	113	40213227		
227148	4988	40213160	1955-03-29	1955-03-29 00:00:00	1955-03-29	1955-03-29 00:00:00	1955-03-29	581452		0	0	0		0	0	0	331863	0	10	40213160		
112391	2469	40213306	1993-04-18	1993-04-18 00:00:00	1993-04-18	1993-04-18 00:00:00	1993-04-18	581452		0	0	0		0	0	0	163744	0	43	40213306		
31811	693	40213227	2012-11-06	2012-11-06 00:00:00	2012-11-06	2012-11-06 00:00:00	2012-11-06	581452		0	0	0		0	0	0	45883	0	113	40213227		
229597	5046	40213260	2009-04-21	2009-04-21 00:00:00	2009-04-21	2009-04-21 00:00:00	2009-04-21	581452		0	0	0		0	0	0	335336	0	121	40213260		
40040	3313	19059056	1957-07-28	1957-07-28 00:00:00	1957-08-11	1957-08-11 00:00:00	1957-08-11	38000177		0	0	14		0	0	0	220036	0	243670	19059056		
110933	2437	40213296	2005-06-06	2005-06-06 00:00:00	2005-06-06	2005-06-06 00:00:00	2005-06-06	581452		0	0	0		0	0	0	161679	0	52	40213296		
63495	5276	19078461	1994-05-13	1994-05-13 00:00:00	1994-06-03	1994-06-03 00:00:00	1994-06-03	38000177		0	0	21		0	0	0	350948	0	310965	19078461		
171783	3777	40213227	2007-04-12	2007-04-12 00:00:00	2007-04-12	2007-04-12 00:00:00	2007-04-12	581452		0	0	0		0	0	0	251013	0	113	40213227		
53590	4454	19059056	1948-12-24	1948-12-24 00:00:00	1949-01-21	1949-01-21 00:00:00	1949-01-21	38000177		0	0	28		0	0	0	296497	0	243670	19059056		
197604	4342	40213160	1957-12-13	1957-12-13 00:00:00	1957-12-13	1957-12-13 00:00:00	1957-12-13	581452		0	0	0		0	0	0	287890	0	10	40213160		
67703	1480	40213306	1988-01-22	1988-01-22 00:00:00	1988-01-22	1988-01-22 00:00:00	1988-01-22	581452		0	0	0		0	0	0	98729	0	43	40213306		
194939	4283	40213227	2012-12-22	2012-12-22 00:00:00	2012-12-22	2012-12-22 00:00:00	2012-12-22	581452		0	0	0		0	0	0	284318	0	113	40213227		
335	7	40213306	1991-01-09	1991-01-09 00:00:00	1991-01-09	1991-01-09 00:00:00	1991-01-09	581452		0	0	0		0	0	0	641	0	43	40213306		
86632	1900	40213296	2006-01-02	2006-01-02 00:00:00	2006-01-02	2006-01-02 00:00:00	2006-01-02	581452		0	0	0		0	0	0	126504	0	52	40213296		
220381	4837	40213198	2014-12-23	2014-12-23 00:00:00	2014-12-23	2014-12-23 00:00:00	2014-12-23	581452		0	0	0		0	0	0	321802	0	133	40213198		
26988	587	40213160	1978-11-29	1978-11-29 00:00:00	1978-11-29	1978-11-29 00:00:00	1978-11-29	581452		0	0	0		0	0	0	38868	0	10	40213160		
85825	1879	40213227	1992-06-06	1992-06-06 00:00:00	1992-06-06	1992-06-06 00:00:00	1992-06-06	581452		0	0	0		0	0	0	125375	0	113	40213227		
148656	3268	40213160	1969-10-17	1969-10-17 00:00:00	1969-10-17	1969-10-17 00:00:00	1969-10-17	581452		0	0	0		0	0	0	217177	0	10	40213160		
38893	3215	1127433	1981-09-24	1981-09-24 00:00:00	1981-10-01	1981-10-01 00:00:00	1981-10-01	38000177		0	0	7		0	0	0	213680	0	313782	1127433		
231897	5096	40213160	1967-07-20	1967-07-20 00:00:00	1967-07-20	1967-07-20 00:00:00	1967-07-20	581452		0	0	0		0	0	0	338616	0	10	40213160		
19719	1622	1127433	2011-11-05	2011-11-05 00:00:00	2011-11-26	2011-11-26 00:00:00	2011-11-26	38000177		0	0	21		0	0	0	108937	0	313782	1127433		
81565	1782	40213160	1955-08-23	1955-08-23 00:00:00	1955-08-23	1955-08-23 00:00:00	1955-08-23	581452		0	0	0		0	0	0	119287	0	10	40213160		
30590	2537	19115351	1961-06-25	1961-06-25 00:00:00	1961-10-22	1961-10-22 00:00:00	1961-10-22	38000177		0	0	119		0	0	0	167686	0	563026	19115351		
213866	4689	40213227	2010-01-26	2010-01-26 00:00:00	2010-01-26	2010-01-26 00:00:00	2010-01-26	581452		0	0	0		0	0	0	312376	0	113	40213227		
225253	4945	40213160	1955-01-06	1955-01-06 00:00:00	1955-01-06	1955-01-06 00:00:00	1955-01-06	581452		0	0	0		0	0	0	328683	0	10	40213160		
196561	4319	40213296	2017-12-13	2017-12-13 00:00:00	2017-12-13	2017-12-13 00:00:00	2017-12-13	581452		0	0	0		0	0	0	286610	0	52	40213296		
14364	1206	1118084	1999-10-19	1999-10-19 00:00:00	1999-10-19	1999-10-19 00:00:00	\N	38000177		0	0	0		0	0	0	79262	0	00025152531	44923712		
196626	4320	40213160	1970-07-05	1970-07-05 00:00:00	1970-07-05	1970-07-05 00:00:00	1970-07-05	581452		0	0	0		0	0	0	286687	0	10	40213160		
51808	4308	40236824	1958-11-05	1958-11-05 00:00:00	1958-11-12	1958-11-12 00:00:00	1958-11-12	38000177		0	0	7		0	0	0	285756	0	1094107	40236824		
188215	4133	40213160	1976-11-05	1976-11-05 00:00:00	1976-11-05	1976-11-05 00:00:00	1976-11-05	581452		0	0	0		0	0	0	274806	0	10	40213160		
50080	1097	40213306	1991-07-11	1991-07-11 00:00:00	1991-07-11	1991-07-11 00:00:00	1991-07-11	581452		0	0	0		0	0	0	71983	0	43	40213306		
82907	1812	40213160	1960-09-05	1960-09-05 00:00:00	1960-09-05	1960-09-05 00:00:00	1960-09-05	581452		0	0	0		0	0	0	121237	0	10	40213160		
39805	3293	19133905	1958-05-22	1958-05-22 00:00:00	1958-06-04	1958-06-04 00:00:00	1958-06-04	38000177		0	0	13		0	0	0	218702	0	834102	19133905		
64257	5333	19059056	1950-12-25	1950-12-25 00:00:00	1951-01-08	1951-01-08 00:00:00	1951-01-08	38000177		0	0	14		0	0	0	355151	0	243670	19059056		
178864	3932	40213306	1995-07-24	1995-07-24 00:00:00	1995-07-24	1995-07-24 00:00:00	1995-07-24	581452		0	0	0		0	0	0	261407	0	43	40213306		
164247	3612	40213296	2002-01-20	2002-01-20 00:00:00	2002-01-20	2002-01-20 00:00:00	2002-01-20	581452		0	0	0		0	0	0	240011	0	52	40213296		
17406	1441	19078461	1999-06-13	1999-06-13 00:00:00	1999-07-18	1999-07-18 00:00:00	1999-07-18	38000177		0	0	35		0	0	0	95953	0	310965	19078461		
25175	2073	1127433	1978-04-27	1978-04-27 00:00:00	1978-05-18	1978-05-18 00:00:00	1978-05-18	38000177		0	0	21		0	0	0	137883	0	313782	1127433		
193189	4243	40213296	2010-01-29	2010-01-29 00:00:00	2010-01-29	2010-01-29 00:00:00	2010-01-29	581452		0	0	0		0	0	0	281867	0	52	40213296		
105337	2311	40213306	1982-10-16	1982-10-16 00:00:00	1982-10-16	1982-10-16 00:00:00	1982-10-16	581452		0	0	0		0	0	0	153734	0	43	40213306		
8227	686	1127433	1966-06-18	1966-06-18 00:00:00	1966-06-25	1966-06-25 00:00:00	1966-06-25	38000177		0	0	7		0	0	0	45438	0	313782	1127433		
216848	4758	40213296	1999-06-06	1999-06-06 00:00:00	1999-06-06	1999-06-06 00:00:00	1999-06-06	581452		0	0	0		0	0	0	316992	0	52	40213296		
225073	4942	40213160	1955-04-07	1955-04-07 00:00:00	1955-04-07	1955-04-07 00:00:00	1955-04-07	581452		0	0	0		0	0	0	328472	0	10	40213160		
112393	2469	40213306	1993-08-22	1993-08-22 00:00:00	1993-08-22	1993-08-22 00:00:00	1993-08-22	581452		0	0	0		0	0	0	163703	0	43	40213306		
31813	693	40213201	2017-12-05	2017-12-05 00:00:00	2017-12-05	2017-12-05 00:00:00	2017-12-05	581452		0	0	0		0	0	0	45907	0	33	40213201		
40041	3313	19006318	1957-07-28	1957-07-28 00:00:00	1957-08-11	1957-08-11 00:00:00	1957-08-11	38000177		0	0	14		0	0	0	220036	0	105078	19006318		
110935	2437	40213296	2003-06-02	2003-06-02 00:00:00	2003-06-02	2003-06-02 00:00:00	2003-06-02	581452		0	0	0		0	0	0	161676	0	52	40213296		
63496	5276	40236824	1975-02-23	1975-02-23 00:00:00	1975-03-02	1975-03-02 00:00:00	1975-03-02	38000177		0	0	7		0	0	0	350924	0	1094107	40236824		
171784	3777	40213306	2007-04-12	2007-04-12 00:00:00	2007-04-12	2007-04-12 00:00:00	2007-04-12	581452		0	0	0		0	0	0	251013	0	43	40213306		
53591	4454	19059056	1932-04-26	1932-04-26 00:00:00	1932-06-25	1932-06-25 00:00:00	1932-06-25	38000177		0	0	60		0	0	0	296492	0	243670	19059056		
130857	2876	40213260	2013-10-10	2013-10-10 00:00:00	2013-10-10	2013-10-10 00:00:00	2013-10-10	581452		0	0	0		0	0	0	191355	0	121	40213260		
109169	2395	40213227	1993-04-30	1993-04-30 00:00:00	1993-04-30	1993-04-30 00:00:00	1993-04-30	581452		0	0	0		0	0	0	159231	0	113	40213227		
194942	4283	40213198	2017-01-14	2017-01-14 00:00:00	2017-01-14	2017-01-14 00:00:00	2017-01-14	581452		0	0	0		0	0	0	284306	0	133	40213198		
337	7	40213260	2018-11-07	2018-11-07 00:00:00	2018-11-07	2018-11-07 00:00:00	2018-11-07	581452		0	0	0		0	0	0	655	0	121	40213260		
97914	2145	40213306	1986-09-06	1986-09-06 00:00:00	1986-09-06	1986-09-06 00:00:00	1986-09-06	581452		0	0	0		0	0	0	142829	0	43	40213306		
220383	4837	40213201	2014-12-23	2014-12-23 00:00:00	2014-12-23	2014-12-23 00:00:00	2014-12-23	581452		0	0	0		0	0	0	321802	0	33	40213201		
26993	588	40213160	1981-10-07	1981-10-07 00:00:00	1981-10-07	1981-10-07 00:00:00	1981-10-07	581452		0	0	0		0	0	0	38953	0	10	40213160		
116623	2563	40213160	1971-02-28	1971-02-28 00:00:00	1971-02-28	1971-02-28 00:00:00	1971-02-28	581452		0	0	0		0	0	0	169799	0	10	40213160		
148664	3268	40213306	1991-12-06	1991-12-06 00:00:00	1991-12-06	1991-12-06 00:00:00	1991-12-06	581452		0	0	0		0	0	0	217206	0	43	40213306		
38894	3215	1118084	2018-01-11	2018-01-11 00:00:00	2018-01-11	2018-01-11 00:00:00	\N	38000177		0	0	0		0	0	0	213628	0	00025152531	44923712		
210345	4613	40213260	2017-05-28	2017-05-28 00:00:00	2017-05-28	2017-05-28 00:00:00	2017-05-28	581452		0	0	0		0	0	0	307296	0	121	40213260		
19720	1622	1124300	2012-12-08	2012-12-08 00:00:00	2012-12-08	2012-12-08 00:00:00	\N	38000177		0	0	0		0	0	0	108937	0	00781178901	45011828		
81572	1782	40213160	1955-05-03	1955-05-03 00:00:00	1955-05-03	1955-05-03 00:00:00	1955-05-03	581452		0	0	0		0	0	0	119286	0	10	40213160		
62909	5228	19059056	1972-03-19	1972-03-19 00:00:00	1972-04-23	1972-04-23 00:00:00	1972-04-23	38000177		0	0	35		0	0	0	347861	0	243670	19059056		
213879	4690	40213160	1956-11-17	1956-11-17 00:00:00	1956-11-17	1956-11-17 00:00:00	1956-11-17	581452		0	0	0		0	0	0	312528	0	10	40213160		
225257	4945	40213160	1959-04-09	1959-04-09 00:00:00	1959-04-09	1959-04-09 00:00:00	1959-04-09	581452		0	0	0		0	0	0	328676	0	10	40213160		
196567	4319	40213314	1979-02-14	1979-02-14 00:00:00	1979-02-14	1979-02-14 00:00:00	1979-02-14	581452		0	0	0		0	0	0	286622	0	49	40213314		
14365	1206	1127433	1998-07-19	1998-07-19 00:00:00	1998-07-26	1998-07-26 00:00:00	1998-07-26	38000177		0	0	7		0	0	0	79232	0	313782	1127433		
196632	4320	40213296	2010-04-04	2010-04-04 00:00:00	2010-04-04	2010-04-04 00:00:00	2010-04-04	581452		0	0	0		0	0	0	286657	0	52	40213296		
51809	4308	40169216	1915-08-28	1915-08-28 00:00:00	1915-08-28	1915-08-28 00:00:00	\N	38000177		0	0	0		0	0	0	285714	0	895994	40169216		
188221	4133	40213314	1977-01-07	1977-01-07 00:00:00	1977-01-07	1977-01-07 00:00:00	1977-01-07	581452		0	0	0		0	0	0	274754	0	49	40213314		
50083	1098	40213260	2006-12-16	2006-12-16 00:00:00	2006-12-16	2006-12-16 00:00:00	2006-12-16	581452		0	0	0		0	0	0	72080	0	121	40213260		
82912	1812	40213160	1960-12-05	1960-12-05 00:00:00	1960-12-05	1960-12-05 00:00:00	1960-12-05	581452		0	0	0		0	0	0	121262	0	10	40213160		
39806	3293	19075601	2006-11-25	2006-11-25 00:00:00	2006-11-25	2006-11-25 00:00:00	2006-11-25	38000177		0	0	0		0	0	0	218743	0	309362	19075601		
64258	5333	19006318	1950-12-25	1950-12-25 00:00:00	1951-01-08	1951-01-08 00:00:00	1951-01-08	38000177		0	0	14		0	0	0	355151	0	105078	19006318		
178866	3932	40213227	2004-08-02	2004-08-02 00:00:00	2004-08-02	2004-08-02 00:00:00	2004-08-02	581452		0	0	0		0	0	0	261377	0	113	40213227		
164249	3612	40213227	2002-01-20	2002-01-20 00:00:00	2002-01-20	2002-01-20 00:00:00	2002-01-20	581452		0	0	0		0	0	0	240011	0	113	40213227		
17407	1441	19078461	2013-11-01	2013-11-01 00:00:00	2013-12-31	2013-12-31 00:00:00	2013-12-31	38000177		0	0	60		0	0	0	95954	0	310965	19078461		
25176	2073	1713671	1969-05-13	1969-05-13 00:00:00	1969-05-20	1969-05-20 00:00:00	1969-05-20	38000177		0	0	7		0	0	0	137897	0	562251	1713671		
193193	4243	40213306	1990-01-05	1990-01-05 00:00:00	1990-01-05	1990-01-05 00:00:00	1990-01-05	581452		0	0	0		0	0	0	281838	0	43	40213306		
105338	2311	40213260	2010-01-30	2010-01-30 00:00:00	2010-01-30	2010-01-30 00:00:00	2010-01-30	581452		0	0	0		0	0	0	153704	0	121	40213260		
8228	686	1115171	1994-07-17	1994-07-17 00:00:00	1994-08-21	1994-08-21 00:00:00	1994-08-21	38000177		0	0	35		0	0	0	45442	0	849574	1115171		
216851	4758	40213227	2009-07-05	2009-07-05 00:00:00	2009-07-05	2009-07-05 00:00:00	2009-07-05	581452		0	0	0		0	0	0	317021	0	113	40213227		
151674	3337	40213306	1991-09-16	1991-09-16 00:00:00	1991-09-16	1991-09-16 00:00:00	1991-09-16	581452		0	0	0		0	0	0	\N	0	43	40213306		
31825	693	40213227	1993-04-06	1993-04-06 00:00:00	1993-04-06	1993-04-06 00:00:00	1993-04-06	581452		0	0	0		0	0	0	45902	0	113	40213227		
40044	3313	19133873	1956-07-17	1956-07-17 00:00:00	1956-07-25	1956-07-25 00:00:00	1956-07-25	38000177		0	0	8		0	0	0	219985	0	834061	19133873		
110937	2437	40213227	2003-06-02	2003-06-02 00:00:00	2003-06-02	2003-06-02 00:00:00	2003-06-02	581452		0	0	0		0	0	0	161676	0	113	40213227		
63497	5276	920300	1975-02-23	1975-02-23 00:00:00	1975-03-02	1975-03-02 00:00:00	1975-03-02	38000177		0	0	7		0	0	0	350924	0	311989	920300		
171785	3777	40213180	2007-04-12	2007-04-12 00:00:00	2007-04-12	2007-04-12 00:00:00	2007-04-12	581452		0	0	0		0	0	0	251013	0	114	40213180		
53592	4454	1127433	2007-03-23	2007-03-23 00:00:00	2007-05-22	2007-05-22 00:00:00	2007-05-22	38000177		0	0	60		0	0	0	296504	0	313782	1127433		
130861	2876	40213160	1964-06-18	1964-06-18 00:00:00	1964-06-18	1964-06-18 00:00:00	1964-06-18	581452		0	0	0		0	0	0	191332	0	10	40213160		
109172	2395	40213260	2009-02-13	2009-02-13 00:00:00	2009-02-13	2009-02-13 00:00:00	2009-02-13	581452		0	0	0		0	0	0	159235	0	121	40213260		
194958	4283	40213201	2018-01-20	2018-01-20 00:00:00	2018-01-20	2018-01-20 00:00:00	2018-01-20	581452		0	0	0		0	0	0	284295	0	33	40213201		
341	7	40213296	2011-08-10	2011-08-10 00:00:00	2011-08-10	2011-08-10 00:00:00	2011-08-10	581452		0	0	0		0	0	0	619	0	52	40213296		
97916	2145	40213160	1968-07-06	1968-07-06 00:00:00	1968-07-06	1968-07-06 00:00:00	1968-07-06	581452		0	0	0		0	0	0	142798	0	10	40213160		
97974	2147	40213260	2006-10-21	2006-10-21 00:00:00	2006-10-21	2006-10-21 00:00:00	2006-10-21	581452		0	0	0		0	0	0	142938	0	121	40213260		
27001	588	40213160	1981-05-06	1981-05-06 00:00:00	1981-05-06	1981-05-06 00:00:00	1981-05-06	581452		0	0	0		0	0	0	38939	0	10	40213160		
116625	2563	40213160	1970-11-29	1970-11-29 00:00:00	1970-11-29	1970-11-29 00:00:00	1970-11-29	581452		0	0	0		0	0	0	169808	0	10	40213160		
148666	3268	40213296	2009-07-17	2009-07-17 00:00:00	2009-07-17	2009-07-17 00:00:00	2009-07-17	581452		0	0	0		0	0	0	217184	0	52	40213296		
38895	3215	40229134	1982-01-31	1982-01-31 00:00:00	1982-02-07	1982-02-07 00:00:00	1982-02-07	38000177		0	0	7		0	0	0	213664	0	1043400	40229134		
210347	4613	40213227	2017-05-28	2017-05-28 00:00:00	2017-05-28	2017-05-28 00:00:00	2017-05-28	581452		0	0	0		0	0	0	307296	0	113	40213227		
19721	1622	40224805	1993-04-27	1993-04-27 00:00:00	1994-04-22	1994-04-22 00:00:00	1994-04-22	38000177		0	0	360		0	0	0	108956	0	1000126	40224805		
81578	1782	40213260	2006-02-07	2006-02-07 00:00:00	2006-02-07	2006-02-07 00:00:00	2006-02-07	581452		0	0	0		0	0	0	119294	0	121	40213260		
62910	5228	1127433	1937-01-11	1937-01-11 00:00:00	1937-01-18	1937-01-18 00:00:00	1937-01-18	38000177		0	0	7		0	0	0	347777	0	313782	1127433		
171496	3769	40213201	2015-09-27	2015-09-27 00:00:00	2015-09-27	2015-09-27 00:00:00	2015-09-27	581452		0	0	0		0	0	0	250560	0	33	40213201		
14182	1188	19133873	1987-09-29	1987-09-29 00:00:00	1987-10-06	1987-10-06 00:00:00	1987-10-06	38000177		0	0	7		0	0	0	78259	0	834061	19133873		
196570	4319	40213314	1978-05-17	1978-05-17 00:00:00	1978-05-17	1978-05-17 00:00:00	1978-05-17	581452		0	0	0		0	0	0	286621	0	49	40213314		
14366	1206	1127433	1993-11-12	1993-11-12 00:00:00	1993-11-26	1993-11-26 00:00:00	1993-11-26	38000177		0	0	14		0	0	0	79248	0	313782	1127433		
196637	4320	40213227	2001-04-08	2001-04-08 00:00:00	2001-04-08	2001-04-08 00:00:00	2001-04-08	581452		0	0	0		0	0	0	286674	0	113	40213227		
51810	4308	1154615	1915-08-28	1915-08-28 00:00:00	1915-08-28	1915-08-28 00:00:00	\N	38000177		0	0	0		0	0	0	285714	0	745679	1154615		
188222	4133	40213160	1977-01-07	1977-01-07 00:00:00	1977-01-07	1977-01-07 00:00:00	1977-01-07	581452		0	0	0		0	0	0	274754	0	10	40213160		
50085	1098	40213227	2006-12-16	2006-12-16 00:00:00	2006-12-16	2006-12-16 00:00:00	2006-12-16	581452		0	0	0		0	0	0	72080	0	113	40213227		
82928	1812	40213306	1983-03-14	1983-03-14 00:00:00	1983-03-14	1983-03-14 00:00:00	1983-03-14	581452		0	0	0		0	0	0	121273	0	43	40213306		
39807	3293	40220960	2006-11-25	2006-11-25 00:00:00	2006-11-25	2006-11-25 00:00:00	2006-11-25	38000177		0	0	0		0	0	0	218743	0	1804799	40220960		
64259	5333	19133905	1987-09-01	1987-09-01 00:00:00	1987-09-10	1987-09-10 00:00:00	1987-09-10	38000177		0	0	9		0	0	0	355130	0	834102	19133905		
178870	3932	40213227	2014-10-20	2014-10-20 00:00:00	2014-10-20	2014-10-20 00:00:00	2014-10-20	581452		0	0	0		0	0	0	261395	0	113	40213227		
164252	3612	40213227	2010-12-26	2010-12-26 00:00:00	2010-12-26	2010-12-26 00:00:00	2010-12-26	581452		0	0	0		0	0	0	239997	0	113	40213227		
17409	1442	1127433	2017-06-13	2017-06-13 00:00:00	2017-06-27	2017-06-27 00:00:00	2017-06-27	38000177		0	0	14		0	0	0	96189	0	313782	1127433		
25177	2073	1127433	1982-04-07	1982-04-07 00:00:00	1982-04-14	1982-04-14 00:00:00	1982-04-14	38000177		0	0	7		0	0	0	137934	0	313782	1127433		
223628	4909	40213160	1975-11-24	1975-11-24 00:00:00	1975-11-24	1975-11-24 00:00:00	1975-11-24	581452		0	0	0		0	0	0	326266	0	10	40213160		
105344	2311	40213227	2002-02-09	2002-02-09 00:00:00	2002-02-09	2002-02-09 00:00:00	2002-02-09	581452		0	0	0		0	0	0	153764	0	113	40213227		
8231	687	1551192	1969-06-09	1969-06-09 00:00:00	1969-06-09	1969-06-09 00:00:00	1969-06-09	38000177		0	0	0		0	0	0	45482	0	312617	1551192		
216852	4758	40213260	2009-07-05	2009-07-05 00:00:00	2009-07-05	2009-07-05 00:00:00	2009-07-05	581452		0	0	0		0	0	0	317021	0	121	40213260		
151675	3337	40213160	1969-09-15	1969-09-15 00:00:00	1969-09-15	1969-09-15 00:00:00	1969-09-15	581452		0	0	0		0	0	0	221364	0	10	40213160		
31830	693	40213160	1955-09-27	1955-09-27 00:00:00	1955-09-27	1955-09-27 00:00:00	1955-09-27	581452		0	0	0		0	0	0	45954	0	10	40213160		
40046	3313	1127433	1958-08-05	1958-08-05 00:00:00	1958-08-12	1958-08-12 00:00:00	1958-08-12	38000177		0	0	7		0	0	0	219986	0	313782	1127433		
110942	2437	40213160	1962-04-16	1962-04-16 00:00:00	1962-04-16	1962-04-16 00:00:00	1962-04-16	581452		0	0	0		0	0	0	161697	0	10	40213160		
63498	5276	1115171	2015-05-14	2015-05-14 00:00:00	2015-06-20	2015-06-20 00:00:00	2015-06-20	38000177		0	0	37		0	0	0	350921	0	849574	1115171		
171788	3777	40213227	2016-04-21	2016-04-21 00:00:00	2016-04-21	2016-04-21 00:00:00	2016-04-21	581452		0	0	0		0	0	0	251040	0	113	40213227		
53593	4454	19059056	1927-01-23	1927-01-23 00:00:00	1927-04-23	1927-04-23 00:00:00	1927-04-23	38000177		0	0	90		0	0	0	296491	0	243670	19059056		
130862	2876	40213160	1964-03-19	1964-03-19 00:00:00	1964-03-19	1964-03-19 00:00:00	1964-03-19	581452		0	0	0		0	0	0	191345	0	10	40213160		
109176	2395	40213296	1999-02-19	1999-02-19 00:00:00	1999-02-19	1999-02-19 00:00:00	1999-02-19	581452		0	0	0		0	0	0	159233	0	52	40213296		
194960	4283	40213160	1956-03-24	1956-03-24 00:00:00	1956-03-24	1956-03-24 00:00:00	1956-03-24	581452		0	0	0		0	0	0	284243	0	10	40213160		
342	7	40213227	2011-08-10	2011-08-10 00:00:00	2011-08-10	2011-08-10 00:00:00	2011-08-10	581452		0	0	0		0	0	0	619	0	113	40213227		
97919	2145	40213260	2013-12-21	2013-12-21 00:00:00	2013-12-21	2013-12-21 00:00:00	2013-12-21	581452		0	0	0		0	0	0	142822	0	121	40213260		
97984	2147	40213296	1997-02-21	1997-02-21 00:00:00	1997-02-21	1997-02-21 00:00:00	1997-02-21	581452		0	0	0		0	0	0	142911	0	52	40213296		
27002	588	40213314	1981-05-06	1981-05-06 00:00:00	1981-05-06	1981-05-06 00:00:00	1981-05-06	581452		0	0	0		0	0	0	38939	0	49	40213314		
116628	2563	40213296	2011-03-13	2011-03-13 00:00:00	2011-03-13	2011-03-13 00:00:00	2011-03-13	581452		0	0	0		0	0	0	169767	0	52	40213296		
177628	3904	40213314	1979-05-31	1979-05-31 00:00:00	1979-05-31	1979-05-31 00:00:00	1979-05-31	581452		0	0	0		0	0	0	259616	0	49	40213314		
38896	3215	1127433	1979-02-27	1979-02-27 00:00:00	1979-03-06	1979-03-06 00:00:00	1979-03-06	38000177		0	0	7		0	0	0	213669	0	313782	1127433		
210348	4613	40213296	2009-03-15	2009-03-15 00:00:00	2009-03-15	2009-03-15 00:00:00	2009-03-15	581452		0	0	0		0	0	0	307304	0	52	40213296		
19722	1622	19133873	1989-01-21	1989-01-21 00:00:00	1989-01-31	1989-01-31 00:00:00	1989-01-31	38000177		0	0	10		0	0	0	108945	0	834061	19133873		
81580	1782	40213227	2014-03-25	2014-03-25 00:00:00	2014-03-25	2014-03-25 00:00:00	2014-03-25	581452		0	0	0		0	0	0	119355	0	113	40213227		
62911	5228	1127433	2007-11-16	2007-11-16 00:00:00	2007-11-30	2007-11-30 00:00:00	2007-11-30	38000177		0	0	14		0	0	0	347862	0	313782	1127433		
171498	3769	40213227	2010-08-29	2010-08-29 00:00:00	2010-08-29	2010-08-29 00:00:00	2010-08-29	581452		0	0	0		0	0	0	250568	0	113	40213227		
14183	1188	19019979	1983-09-17	1983-09-17 00:00:00	1983-11-16	1983-11-16 00:00:00	1983-11-16	38000177		0	0	60		0	0	0	78276	0	198405	19019979		
196572	4319	40213160	1978-05-17	1978-05-17 00:00:00	1978-05-17	1978-05-17 00:00:00	1978-05-17	581452		0	0	0		0	0	0	286621	0	10	40213160		
14367	1206	1713671	1965-01-10	1965-01-10 00:00:00	1965-01-17	1965-01-17 00:00:00	1965-01-17	38000177		0	0	7		0	0	0	79252	0	562251	1713671		
196639	4320	40213160	1975-03-09	1975-03-09 00:00:00	1975-03-09	1975-03-09 00:00:00	1975-03-09	581452		0	0	0		0	0	0	286643	0	10	40213160		
51811	4308	19133873	1916-12-29	1916-12-29 00:00:00	1917-01-05	1917-01-05 00:00:00	1917-01-05	38000177		0	0	7		0	0	0	285732	0	834061	19133873		
188224	4133	40213227	2008-06-20	2008-06-20 00:00:00	2008-06-20	2008-06-20 00:00:00	2008-06-20	581452		0	0	0		0	0	0	274812	0	113	40213227		
50089	1098	40213227	2017-02-11	2017-02-11 00:00:00	2017-02-11	2017-02-11 00:00:00	2017-02-11	581452		0	0	0		0	0	0	72104	0	113	40213227		
82930	1812	40213227	2001-07-16	2001-07-16 00:00:00	2001-07-16	2001-07-16 00:00:00	2001-07-16	581452		0	0	0		0	0	0	121286	0	113	40213227		
39808	3293	19059056	1917-04-19	1917-04-19 00:00:00	1917-05-03	1917-05-03 00:00:00	1917-05-03	38000177		0	0	14		0	0	0	218710	0	243670	19059056		
64260	5333	1713671	1999-01-27	1999-01-27 00:00:00	1999-02-10	1999-02-10 00:00:00	1999-02-10	38000177		0	0	14		0	0	0	355150	0	562251	1713671		
178871	3932	40213296	2014-10-20	2014-10-20 00:00:00	2014-10-20	2014-10-20 00:00:00	2014-10-20	581452		0	0	0		0	0	0	261395	0	52	40213296		
164253	3612	40213260	2010-12-26	2010-12-26 00:00:00	2010-12-26	2010-12-26 00:00:00	2010-12-26	581452		0	0	0		0	0	0	239997	0	121	40213260		
17410	1442	19078461	1975-07-03	1975-07-03 00:00:00	1975-07-24	1975-07-24 00:00:00	1975-07-24	38000177		0	0	21		0	0	0	96186	0	310965	19078461		
25178	2073	1127433	1986-09-03	1986-09-03 00:00:00	1986-09-24	1986-09-24 00:00:00	1986-09-24	38000177		0	0	21		0	0	0	137886	0	313782	1127433		
223634	4909	40213314	1978-05-22	1978-05-22 00:00:00	1978-05-22	1978-05-22 00:00:00	1978-05-22	581452		0	0	0		0	0	0	326230	0	49	40213314		
105345	2311	40213296	2002-02-09	2002-02-09 00:00:00	2002-02-09	2002-02-09 00:00:00	2002-02-09	581452		0	0	0		0	0	0	153764	0	52	40213296		
8232	687	40169216	1970-01-27	1970-01-27 00:00:00	1970-01-27	1970-01-27 00:00:00	\N	38000177		0	0	0		0	0	0	45459	0	895994	40169216		
228430	5017	40213160	1980-09-20	1980-09-20 00:00:00	1980-09-20	1980-09-20 00:00:00	1980-09-20	581452		0	0	0		0	0	0	333451	0	10	40213160		
151677	3337	40213227	2000-08-21	2000-08-21 00:00:00	2000-08-21	2000-08-21 00:00:00	2000-08-21	581452		0	0	0		0	0	0	221398	0	113	40213227		
31853	693	40213227	2002-01-08	2002-01-08 00:00:00	2002-01-08	2002-01-08 00:00:00	2002-01-08	581452		0	0	0		0	0	0	45932	0	113	40213227		
40047	3313	19078461	2010-11-03	2010-11-03 00:00:00	2010-11-17	2010-11-17 00:00:00	2010-11-17	38000177		0	0	14		0	0	0	219998	0	310965	19078461		
110954	2437	40213227	1992-10-19	1992-10-19 00:00:00	1992-10-19	1992-10-19 00:00:00	1992-10-19	581452		0	0	0		0	0	0	161673	0	113	40213227		
63499	5276	46233710	1970-10-04	1970-10-04 00:00:00	1970-10-25	1970-10-25 00:00:00	1970-10-25	38000177		0	0	21		0	0	0	350945	0	1650142	46233710		
171792	3777	40213251	1989-04-06	1989-04-06 00:00:00	1989-04-06	1989-04-06 00:00:00	1989-04-06	581452		0	0	0		0	0	0	251020	0	21	40213251		
53594	4454	1127433	2018-02-23	2018-02-23 00:00:00	2018-05-24	2018-05-24 00:00:00	2018-05-24	38000177		0	0	90		0	0	0	296460	0	313782	1127433		
130871	2876	40213260	2014-10-16	2014-10-16 00:00:00	2014-10-16	2014-10-16 00:00:00	2014-10-16	581452		0	0	0		0	0	0	191354	0	121	40213260		
109182	2395	40213227	2010-02-19	2010-02-19 00:00:00	2010-02-19	2010-02-19 00:00:00	2010-02-19	581452		0	0	0		0	0	0	159254	0	113	40213227		
11636	249	40213160	1982-01-30	1982-01-30 00:00:00	1982-01-30	1982-01-30 00:00:00	1982-01-30	581452		0	0	0		0	0	0	16760	0	10	40213160		
97922	2145	40213296	2004-10-09	2004-10-09 00:00:00	2004-10-09	2004-10-09 00:00:00	2004-10-09	581452		0	0	0		0	0	0	142831	0	52	40213296		
97988	2147	40213201	2018-12-28	2018-12-28 00:00:00	2018-12-28	2018-12-28 00:00:00	2018-12-28	581452		0	0	0		0	0	0	142979	0	33	40213201		
27006	588	40213227	2003-06-11	2003-06-11 00:00:00	2003-06-11	2003-06-11 00:00:00	2003-06-11	581452		0	0	0		0	0	0	38964	0	113	40213227		
116631	2563	40213306	1994-02-20	1994-02-20 00:00:00	1994-02-20	1994-02-20 00:00:00	1994-02-20	581452		0	0	0		0	0	0	169769	0	43	40213306		
177629	3904	40213160	1979-05-31	1979-05-31 00:00:00	1979-05-31	1979-05-31 00:00:00	1979-05-31	581452		0	0	0		0	0	0	259616	0	10	40213160		
38897	3215	40162522	1995-01-02	1995-01-02 00:00:00	1995-01-02	1995-01-02 00:00:00	\N	38000177		0	0	0		0	0	0	213684	0	857005	40162522		
210350	4613	40213227	2009-03-15	2009-03-15 00:00:00	2009-03-15	2009-03-15 00:00:00	2009-03-15	581452		0	0	0		0	0	0	307304	0	113	40213227		
4580	99	40213296	1998-11-21	1998-11-21 00:00:00	1998-11-21	1998-11-21 00:00:00	1998-11-21	581452		0	0	0		0	0	0	6747	0	52	40213296		
81583	1782	40213160	1957-08-27	1957-08-27 00:00:00	1957-08-27	1957-08-27 00:00:00	1957-08-27	581452		0	0	0		0	0	0	119352	0	10	40213160		
62912	5228	40229134	1949-03-10	1949-03-10 00:00:00	1949-03-24	1949-03-24 00:00:00	1949-03-24	38000177		0	0	14		0	0	0	347778	0	1043400	40229134		
171505	3771	40213296	2005-04-05	2005-04-05 00:00:00	2005-04-05	2005-04-05 00:00:00	2005-04-05	581452		0	0	0		0	0	0	250643	0	52	40213296		
14184	1188	1118084	2013-03-13	2013-03-13 00:00:00	2013-03-13	2013-03-13 00:00:00	\N	38000177		0	0	0		0	0	0	78294	0	00025152531	44923712		
99591	2180	40213160	1983-09-10	1983-09-10 00:00:00	1983-09-10	1983-09-10 00:00:00	1983-09-10	581452		0	0	0		0	0	0	145438	0	10	40213160		
14368	1206	1127433	1979-11-19	1979-11-19 00:00:00	1979-11-26	1979-11-26 00:00:00	1979-11-26	38000177		0	0	7		0	0	0	79245	0	313782	1127433		
196643	4321	40213160	1963-09-08	1963-09-08 00:00:00	1963-09-08	1963-09-08 00:00:00	1963-09-08	581452		0	0	0		0	0	0	286733	0	10	40213160		
51812	4308	1713671	1938-10-11	1938-10-11 00:00:00	1938-10-25	1938-10-25 00:00:00	1938-10-25	38000177		0	0	14		0	0	0	285749	0	562251	1713671		
188227	4133	40213314	1977-04-08	1977-04-08 00:00:00	1977-04-08	1977-04-08 00:00:00	1977-04-08	581452		0	0	0		0	0	0	274750	0	49	40213314		
50092	1098	40213160	1956-05-19	1956-05-19 00:00:00	1956-05-19	1956-05-19 00:00:00	1956-05-19	581452		0	0	0		0	0	0	72047	0	10	40213160		
82931	1812	40213296	2001-07-16	2001-07-16 00:00:00	2001-07-16	2001-07-16 00:00:00	2001-07-16	581452		0	0	0		0	0	0	121286	0	52	40213296		
39809	3293	40229134	1912-08-14	1912-08-14 00:00:00	1912-08-28	1912-08-28 00:00:00	1912-08-28	38000177		0	0	14		0	0	0	218744	0	1043400	40229134		
64261	5333	1127078	1952-07-04	1952-07-04 00:00:00	1952-07-18	1952-07-18 00:00:00	1952-07-18	38000177		0	0	14		0	0	0	355156	0	282464	1127078		
178880	3932	40213314	1977-03-21	1977-03-21 00:00:00	1977-03-21	1977-03-21 00:00:00	1977-03-21	581452		0	0	0		0	0	0	261389	0	49	40213314		
164263	3613	40213251	1984-01-22	1984-01-22 00:00:00	1984-01-22	1984-01-22 00:00:00	1984-01-22	581452		0	0	0		0	0	0	240037	0	21	40213251		
17411	1442	19006318	1948-02-25	1948-02-25 00:00:00	1948-03-10	1948-03-10 00:00:00	1948-03-10	38000177		0	0	14		0	0	0	96108	0	105078	19006318		
25179	2073	40229134	2007-11-18	2007-11-18 00:00:00	2007-11-25	2007-11-25 00:00:00	2007-11-25	38000177		0	0	7		0	0	0	137924	0	1043400	40229134		
223635	4909	40213227	2006-08-28	2006-08-28 00:00:00	2006-08-28	2006-08-28 00:00:00	2006-08-28	581452		0	0	0		0	0	0	326238	0	113	40213227		
105348	2311	40213160	1960-10-08	1960-10-08 00:00:00	1960-10-08	1960-10-08 00:00:00	1960-10-08	581452		0	0	0		0	0	0	153727	0	10	40213160		
8233	687	1154615	1970-01-27	1970-01-27 00:00:00	1970-01-27	1970-01-27 00:00:00	\N	38000177		0	0	0		0	0	0	45459	0	745679	1154615		
228433	5017	40213227	2011-08-27	2011-08-27 00:00:00	2011-08-27	2011-08-27 00:00:00	2011-08-27	581452		0	0	0		0	0	0	333459	0	113	40213227		
151680	3337	40213306	1991-08-12	1991-08-12 00:00:00	1991-08-12	1991-08-12 00:00:00	1991-08-12	581452		0	0	0		0	0	0	221379	0	43	40213306		
122247	2686	40213160	1955-02-27	1955-02-27 00:00:00	1955-02-27	1955-02-27 00:00:00	1955-02-27	581452		0	0	0		0	0	0	178002	0	10	40213160		
40048	3313	19133873	1958-02-18	1958-02-18 00:00:00	1958-02-27	1958-02-27 00:00:00	1958-02-27	38000177		0	0	9		0	0	0	219976	0	834061	19133873		
110960	2437	40213260	2013-07-01	2013-07-01 00:00:00	2013-07-01	2013-07-01 00:00:00	2013-07-01	581452		0	0	0		0	0	0	161655	0	121	40213260		
63500	5276	40165015	1970-10-04	1970-10-04 00:00:00	1970-10-04	1970-10-04 00:00:00	\N	38000177		0	0	0		0	0	0	350945	0	861467	40165015		
171794	3777	40213160	1989-04-06	1989-04-06 00:00:00	1989-04-06	1989-04-06 00:00:00	1989-04-06	581452		0	0	0		0	0	0	251020	0	10	40213160		
87046	1908	40213296	2010-08-22	2010-08-22 00:00:00	2010-08-22	2010-08-22 00:00:00	2010-08-22	581452		0	0	0		0	0	0	127013	0	52	40213296		
130873	2876	40213227	2014-10-16	2014-10-16 00:00:00	2014-10-16	2014-10-16 00:00:00	2014-10-16	581452		0	0	0		0	0	0	191354	0	113	40213227		
109183	2395	40213260	2010-02-19	2010-02-19 00:00:00	2010-02-19	2010-02-19 00:00:00	2010-02-19	581452		0	0	0		0	0	0	159254	0	121	40213260		
165028	3628	40213201	1983-02-12	1983-02-12 00:00:00	1983-02-12	1983-02-12 00:00:00	1983-02-12	581452		0	0	0		0	0	0	241417	0	33	40213201		
176317	3876	40213160	1968-01-29	1968-01-29 00:00:00	1968-01-29	1968-01-29 00:00:00	1968-01-29	581452		0	0	0		0	0	0	257528	0	10	40213160		
97991	2147	40213160	1955-09-03	1955-09-03 00:00:00	1955-09-03	1955-09-03 00:00:00	1955-09-03	581452		0	0	0		0	0	0	142932	0	10	40213160		
27007	588	40213306	2003-06-11	2003-06-11 00:00:00	2003-06-11	2003-06-11 00:00:00	2003-06-11	581452		0	0	0		0	0	0	38964	0	43	40213306		
27016	588	40213227	2012-06-20	2012-06-20 00:00:00	2012-06-20	2012-06-20 00:00:00	2012-06-20	581452		0	0	0		0	0	0	38958	0	113	40213227		
177630	3904	40213251	1984-02-02	1984-02-02 00:00:00	1984-02-02	1984-02-02 00:00:00	1984-02-02	581452		0	0	0		0	0	0	259603	0	21	40213251		
38898	3215	1127433	1995-01-02	1995-01-02 00:00:00	1995-02-01	1995-02-01 00:00:00	1995-02-01	38000177		0	0	30		0	0	0	213684	0	313782	1127433		
210358	4613	40213160	1967-01-29	1967-01-29 00:00:00	1967-01-29	1967-01-29 00:00:00	1967-01-29	581452		0	0	0		0	0	0	307257	0	10	40213160		
106684	2339	40213227	1995-03-21	1995-03-21 00:00:00	1995-03-21	1995-03-21 00:00:00	1995-03-21	581452		0	0	0		0	0	0	155673	0	113	40213227		
81585	1782	40213227	2004-01-27	2004-01-27 00:00:00	2004-01-27	2004-01-27 00:00:00	2004-01-27	581452		0	0	0		0	0	0	119303	0	113	40213227		
62913	5229	1713671	1967-09-14	1967-09-14 00:00:00	1967-10-05	1967-10-05 00:00:00	1967-10-05	38000177		0	0	21		0	0	0	347923	0	562251	1713671		
171507	3771	40213227	2005-04-05	2005-04-05 00:00:00	2005-04-05	2005-04-05 00:00:00	2005-04-05	581452		0	0	0		0	0	0	250643	0	113	40213227		
14185	1188	1127433	2015-12-28	2015-12-28 00:00:00	2016-01-18	2016-01-18 00:00:00	2016-01-18	38000177		0	0	21		0	0	0	78303	0	313782	1127433		
99592	2180	40213314	1979-12-08	1979-12-08 00:00:00	1979-12-08	1979-12-08 00:00:00	1979-12-08	581452		0	0	0		0	0	0	145411	0	49	40213314		
14376	1208	1713671	1971-12-22	1971-12-22 00:00:00	1971-12-29	1971-12-29 00:00:00	1971-12-29	38000177		0	0	7		0	0	0	79394	0	562251	1713671		
196658	4321	40213227	1994-04-03	1994-04-03 00:00:00	1994-04-03	1994-04-03 00:00:00	1994-04-03	581452		0	0	0		0	0	0	286745	0	113	40213227		
51813	4308	19074841	1981-10-09	1981-10-09 00:00:00	1981-11-06	1981-11-06 00:00:00	1981-11-06	38000177		0	0	28		0	0	0	285721	0	309043	19074841		
188230	4133	40213160	1977-04-08	1977-04-08 00:00:00	1977-04-08	1977-04-08 00:00:00	1977-04-08	581452		0	0	0		0	0	0	274750	0	10	40213160		
50100	1098	40213160	1956-03-17	1956-03-17 00:00:00	1956-03-17	1956-03-17 00:00:00	1956-03-17	581452		0	0	0		0	0	0	72086	0	10	40213160		
82935	1812	40213160	1965-03-08	1965-03-08 00:00:00	1965-03-08	1965-03-08 00:00:00	1965-03-08	581452		0	0	0		0	0	0	121241	0	10	40213160		
39810	3293	1713671	1941-11-24	1941-11-24 00:00:00	1941-12-15	1941-12-15 00:00:00	1941-12-15	38000177		0	0	21		0	0	0	218662	0	562251	1713671		
64262	5333	19006318	1952-07-04	1952-07-04 00:00:00	1952-07-18	1952-07-18 00:00:00	1952-07-18	38000177		0	0	14		0	0	0	355156	0	105078	19006318		
178885	3932	40213160	1974-02-04	1974-02-04 00:00:00	1974-02-04	1974-02-04 00:00:00	1974-02-04	581452		0	0	0		0	0	0	261364	0	10	40213160		
164268	3613	40213296	2018-02-04	2018-02-04 00:00:00	2018-02-04	2018-02-04 00:00:00	2018-02-04	581452		0	0	0		0	0	0	240020	0	52	40213296		
17412	1442	19059056	1948-02-25	1948-02-25 00:00:00	1948-03-10	1948-03-10 00:00:00	1948-03-10	38000177		0	0	14		0	0	0	96108	0	243670	19059056		
25180	2073	19133905	2015-07-08	2015-07-08 00:00:00	2015-07-17	2015-07-17 00:00:00	2015-07-17	38000177		0	0	9		0	0	0	137925	0	834102	19133905		
213250	4676	40213227	2011-02-24	2011-02-24 00:00:00	2011-02-24	2011-02-24 00:00:00	2011-02-24	581452		0	0	0		0	0	0	311632	0	113	40213227		
105352	2311	40213296	2000-02-05	2000-02-05 00:00:00	2000-02-05	2000-02-05 00:00:00	2000-02-05	581452		0	0	0		0	0	0	153702	0	52	40213296		
8234	687	1118084	2001-04-07	2001-04-07 00:00:00	2001-04-07	2001-04-07 00:00:00	\N	38000177		0	0	0		0	0	0	45563	0	00025152531	44923712		
228434	5017	40213227	2002-08-17	2002-08-17 00:00:00	2002-08-17	2002-08-17 00:00:00	2002-08-17	581452		0	0	0		0	0	0	333421	0	113	40213227		
151687	3337	40213160	1969-11-17	1969-11-17 00:00:00	1969-11-17	1969-11-17 00:00:00	1969-11-17	581452		0	0	0		0	0	0	221406	0	10	40213160		
122251	2686	40213201	2018-09-30	2018-09-30 00:00:00	2018-09-30	2018-09-30 00:00:00	2018-09-30	581452		0	0	0		0	0	0	178076	0	33	40213201		
40049	3313	19059056	1956-03-16	1956-03-16 00:00:00	1956-03-30	1956-03-30 00:00:00	1956-03-30	38000177		0	0	14		0	0	0	219989	0	243670	19059056		
110962	2437	40213227	2013-07-01	2013-07-01 00:00:00	2013-07-01	2013-07-01 00:00:00	2013-07-01	581452		0	0	0		0	0	0	161655	0	113	40213227		
63501	5276	19059056	1970-10-04	1970-10-04 00:00:00	1970-10-25	1970-10-25 00:00:00	1970-10-25	38000177		0	0	21		0	0	0	350945	0	243670	19059056		
171798	3777	40213314	1985-07-04	1985-07-04 00:00:00	1985-07-04	1985-07-04 00:00:00	1985-07-04	581452		0	0	0		0	0	0	251018	0	49	40213314		
130886	2876	40213227	1995-08-10	1995-08-10 00:00:00	1995-08-10	1995-08-10 00:00:00	1995-08-10	581452		0	0	0		0	0	0	191386	0	113	40213227		
109189	2395	40213160	1959-07-24	1959-07-24 00:00:00	1959-07-24	1959-07-24 00:00:00	1959-07-24	581452		0	0	0		0	0	0	159225	0	10	40213160		
165034	3628	40213227	1995-10-14	1995-10-14 00:00:00	1995-10-14	1995-10-14 00:00:00	1995-10-14	581452		0	0	0		0	0	0	241329	0	113	40213227		
176318	3876	40213160	1967-08-28	1967-08-28 00:00:00	1967-08-28	1967-08-28 00:00:00	1967-08-28	581452		0	0	0		0	0	0	257461	0	10	40213160		
97993	2147	40213160	1955-03-04	1955-03-04 00:00:00	1955-03-04	1955-03-04 00:00:00	1955-03-04	581452		0	0	0		0	0	0	142995	0	10	40213160		
193037	4240	40213227	2012-11-19	2012-11-19 00:00:00	2012-11-19	2012-11-19 00:00:00	2012-11-19	581452		0	0	0		0	0	0	281639	0	113	40213227		
27017	588	40213314	1982-03-03	1982-03-03 00:00:00	1982-03-03	1982-03-03 00:00:00	1982-03-03	581452		0	0	0		0	0	0	38944	0	49	40213314		
177633	3904	40213160	1984-02-02	1984-02-02 00:00:00	1984-02-02	1984-02-02 00:00:00	1984-02-02	581452		0	0	0		0	0	0	259603	0	10	40213160		
38899	3215	19075601	2009-04-06	2009-04-06 00:00:00	2009-04-06	2009-04-06 00:00:00	\N	38000177		0	0	0		0	0	0	213639	0	309362	19075601		
210363	4613	40213160	1966-08-28	1966-08-28 00:00:00	1966-08-28	1966-08-28 00:00:00	1966-08-28	581452		0	0	0		0	0	0	307256	0	10	40213160		
117988	2594	40213306	1997-07-23	1997-07-23 00:00:00	1997-07-23	1997-07-23 00:00:00	1997-07-23	581452		0	0	0		0	0	0	171739	0	43	40213306		
81588	1782	40213160	1956-02-21	1956-02-21 00:00:00	1956-02-21	1956-02-21 00:00:00	1956-02-21	581452		0	0	0		0	0	0	119314	0	10	40213160		
62914	5229	19129655	1964-11-09	1964-11-09 00:00:00	1964-11-23	1964-11-23 00:00:00	1964-11-23	38000177		0	0	14		0	0	0	347876	0	789980	19129655		
171511	3771	40213160	1964-10-06	1964-10-06 00:00:00	1964-10-06	1964-10-06 00:00:00	1964-10-06	581452		0	0	0		0	0	0	250614	0	10	40213160		
14186	1189	1713671	1980-11-09	1980-11-09 00:00:00	1980-11-23	1980-11-23 00:00:00	1980-11-23	38000177		0	0	14		0	0	0	78352	0	562251	1713671		
215417	4724	40213201	2008-01-02	2008-01-02 00:00:00	2008-01-02	2008-01-02 00:00:00	2008-01-02	581452		0	0	0		0	0	0	314708	0	33	40213201		
14377	1208	19133873	1945-05-02	1945-05-02 00:00:00	1945-05-09	1945-05-09 00:00:00	1945-05-09	38000177		0	0	7		0	0	0	79342	0	834061	19133873		
196659	4321	40213227	2004-10-17	2004-10-17 00:00:00	2004-10-17	2004-10-17 00:00:00	2004-10-17	581452		0	0	0		0	0	0	286740	0	113	40213227		
51814	4308	1127433	1981-10-09	1981-10-09 00:00:00	1981-11-06	1981-11-06 00:00:00	1981-11-06	38000177		0	0	28		0	0	0	285721	0	313782	1127433		
188236	4133	40213296	2016-12-09	2016-12-09 00:00:00	2016-12-09	2016-12-09 00:00:00	2016-12-09	581452		0	0	0		0	0	0	274815	0	52	40213296		
50107	1098	40213160	1956-08-18	1956-08-18 00:00:00	1956-08-18	1956-08-18 00:00:00	1956-08-18	581452		0	0	0		0	0	0	72039	0	10	40213160		
178017	3913	40213306	1985-06-06	1985-06-06 00:00:00	1985-06-06	1985-06-06 00:00:00	1985-06-06	581452		0	0	0		0	0	0	260082	0	43	40213306		
39811	3293	1127433	1990-12-25	1990-12-25 00:00:00	1991-01-08	1991-01-08 00:00:00	1991-01-08	38000177		0	0	14		0	0	0	218668	0	313782	1127433		
64263	5334	40229134	2018-12-07	2018-12-07 00:00:00	2018-12-21	2018-12-21 00:00:00	2018-12-21	38000177		0	0	14		0	0	0	355180	0	1043400	40229134		
178886	3932	40213160	1973-11-05	1973-11-05 00:00:00	1973-11-05	1973-11-05 00:00:00	1973-11-05	581452		0	0	0		0	0	0	261381	0	10	40213160		
164270	3613	40213227	2018-02-04	2018-02-04 00:00:00	2018-02-04	2018-02-04 00:00:00	2018-02-04	581452		0	0	0		0	0	0	240020	0	113	40213227		
17413	1442	1127433	1968-12-02	1968-12-02 00:00:00	1968-12-16	1968-12-16 00:00:00	1968-12-16	38000177		0	0	14		0	0	0	96144	0	313782	1127433		
25181	2073	19006318	1973-11-19	1973-11-19 00:00:00	1973-12-03	1973-12-03 00:00:00	1973-12-03	38000177		0	0	14		0	0	0	137943	0	105078	19006318		
213252	4676	40213314	1979-11-08	1979-11-08 00:00:00	1979-11-08	1979-11-08 00:00:00	1979-11-08	581452		0	0	0		0	0	0	311614	0	49	40213314		
105355	2311	40213227	2011-02-05	2011-02-05 00:00:00	2011-02-05	2011-02-05 00:00:00	2011-02-05	581452		0	0	0		0	0	0	153761	0	113	40213227		
8235	687	19059056	1971-11-13	1971-11-13 00:00:00	1971-11-27	1971-11-27 00:00:00	1971-11-27	38000177		0	0	14		0	0	0	45523	0	243670	19059056		
228435	5017	40213306	2002-08-17	2002-08-17 00:00:00	2002-08-17	2002-08-17 00:00:00	2002-08-17	581452		0	0	0		0	0	0	333421	0	43	40213306		
151692	3337	40213306	1991-09-09	1991-09-09 00:00:00	1991-09-09	1991-09-09 00:00:00	1991-09-09	581452		0	0	0		0	0	0	\N	0	43	40213306		
122253	2686	40213227	1994-10-02	1994-10-02 00:00:00	1994-10-02	1994-10-02 00:00:00	1994-10-02	581452		0	0	0		0	0	0	177988	0	113	40213227		
40050	3313	19006318	1956-03-16	1956-03-16 00:00:00	1956-03-30	1956-03-30 00:00:00	1956-03-30	38000177		0	0	14		0	0	0	219989	0	105078	19006318		
110968	2438	40213314	1980-11-30	1980-11-30 00:00:00	1980-11-30	1980-11-30 00:00:00	1980-11-30	581452		0	0	0		0	0	0	161751	0	49	40213314		
63502	5276	1127433	2012-08-19	2012-08-19 00:00:00	2012-09-02	2012-09-02 00:00:00	2012-09-02	38000177		0	0	14		0	0	0	350879	0	313782	1127433		
171799	3777	40213251	1985-07-04	1985-07-04 00:00:00	1985-07-04	1985-07-04 00:00:00	1985-07-04	581452		0	0	0		0	0	0	251018	0	21	40213251		
130888	2876	40213160	1964-01-16	1964-01-16 00:00:00	1964-01-16	1964-01-16 00:00:00	1964-01-16	581452		0	0	0		0	0	0	191361	0	10	40213160		
92009	2020	40213160	1975-10-11	1975-10-11 00:00:00	1975-10-11	1975-10-11 00:00:00	1975-10-11	581452		0	0	0		0	0	0	134300	0	10	40213160		
165036	3628	40213227	2006-05-06	2006-05-06 00:00:00	2006-05-06	2006-05-06 00:00:00	2006-05-06	581452		0	0	0		0	0	0	241319	0	113	40213227		
176320	3876	40213227	2000-03-13	2000-03-13 00:00:00	2000-03-13	2000-03-13 00:00:00	2000-03-13	581452		0	0	0		0	0	0	257535	0	113	40213227		
4178	90	40213227	2012-02-28	2012-02-28 00:00:00	2012-02-28	2012-02-28 00:00:00	2012-02-28	581452		0	0	0		0	0	0	6046	0	113	40213227		
193045	4240	40213227	1992-07-27	1992-07-27 00:00:00	1992-07-27	1992-07-27 00:00:00	1992-07-27	581452		0	0	0		0	0	0	281602	0	113	40213227		
27020	588	40213160	1981-07-08	1981-07-08 00:00:00	1981-07-08	1981-07-08 00:00:00	1981-07-08	581452		0	0	0		0	0	0	38920	0	10	40213160		
177635	3904	40213227	2010-06-10	2010-06-10 00:00:00	2010-06-10	2010-06-10 00:00:00	2010-06-10	581452		0	0	0		0	0	0	259637	0	113	40213227		
38900	3215	19126352	2009-04-06	2009-04-06 00:00:00	2009-04-06	2009-04-06 00:00:00	\N	38000177		0	0	0		0	0	0	213639	0	705129	19126352		
210365	4613	40213296	2007-03-11	2007-03-11 00:00:00	2007-03-11	2007-03-11 00:00:00	2007-03-11	581452		0	0	0		0	0	0	307330	0	52	40213296		
117990	2594	40213227	1997-07-23	1997-07-23 00:00:00	1997-07-23	1997-07-23 00:00:00	1997-07-23	581452		0	0	0		0	0	0	171739	0	113	40213227		
81590	1783	40213296	2000-08-28	2000-08-28 00:00:00	2000-08-28	2000-08-28 00:00:00	2000-08-28	581452		0	0	0		0	0	0	119398	0	52	40213296		
5729	124	40213306	2007-02-19	2007-02-19 00:00:00	2007-02-19	2007-02-19 00:00:00	2007-02-19	581452		0	0	0		0	0	0	8342	0	43	40213306		
171515	3771	40213227	2015-02-03	2015-02-03 00:00:00	2015-02-03	2015-02-03 00:00:00	2015-02-03	581452		0	0	0		0	0	0	250628	0	113	40213227		
14187	1189	1127078	1964-09-27	1964-09-27 00:00:00	1964-11-26	1964-11-26 00:00:00	1964-11-26	38000177		0	0	60		0	0	0	78324	0	282464	1127078		
215425	4724	40213227	2013-01-30	2013-01-30 00:00:00	2013-01-30	2013-01-30 00:00:00	2013-01-30	581452		0	0	0		0	0	0	314848	0	113	40213227		
14378	1208	1124300	1975-01-31	1975-01-31 00:00:00	1975-01-31	1975-01-31 00:00:00	\N	38000177		0	0	0		0	0	0	79409	0	00781178901	45011828		
196660	4321	40213296	2004-10-17	2004-10-17 00:00:00	2004-10-17	2004-10-17 00:00:00	2004-10-17	581452		0	0	0		0	0	0	286740	0	52	40213296		
51815	4308	40231925	1981-10-09	1981-10-09 00:00:00	1981-10-09	1981-10-09 00:00:00	\N	38000177		0	0	0		0	0	0	285721	0	1049221	40231925		
188241	4133	40213251	1984-03-30	1984-03-30 00:00:00	1984-03-30	1984-03-30 00:00:00	1984-03-30	581452		0	0	0		0	0	0	274753	0	21	40213251		
50113	1098	40213160	1960-11-19	1960-11-19 00:00:00	1960-11-19	1960-11-19 00:00:00	1960-11-19	581452		0	0	0		0	0	0	72051	0	10	40213160		
178020	3913	40213227	2014-08-07	2014-08-07 00:00:00	2014-08-07	2014-08-07 00:00:00	2014-08-07	581452		0	0	0		0	0	0	260206	0	113	40213227		
39812	3293	19078461	1984-10-29	1984-10-29 00:00:00	1984-11-26	1984-11-26 00:00:00	1984-11-26	38000177		0	0	28		0	0	0	218667	0	310965	19078461		
64264	5334	19128065	1980-02-05	1980-02-05 00:00:00	1981-01-30	1981-01-30 00:00:00	1981-01-30	38000177		0	0	360		0	0	0	355200	0	749882	19128065		
155303	3418	40213227	2005-10-09	2005-10-09 00:00:00	2005-10-09	2005-10-09 00:00:00	2005-10-09	581452		0	0	0		0	0	0	226795	0	113	40213227		
164274	3613	40213160	1981-01-04	1981-01-04 00:00:00	1981-01-04	1981-01-04 00:00:00	1981-01-04	581452		0	0	0		0	0	0	240015	0	10	40213160		
17414	1442	19078461	2012-09-07	2012-09-07 00:00:00	2012-12-06	2012-12-06 00:00:00	2012-12-06	38000177		0	0	90		0	0	0	96188	0	310965	19078461		
25182	2073	1127078	1973-11-19	1973-11-19 00:00:00	1973-12-03	1973-12-03 00:00:00	1973-12-03	38000177		0	0	14		0	0	0	137943	0	282464	1127078		
213253	4676	40213160	1979-11-08	1979-11-08 00:00:00	1979-11-08	1979-11-08 00:00:00	1979-11-08	581452		0	0	0		0	0	0	311614	0	10	40213160		
80921	1769	40213227	1997-09-17	1997-09-17 00:00:00	1997-09-17	1997-09-17 00:00:00	1997-09-17	581452		0	0	0		0	0	0	118282	0	113	40213227		
8236	687	1713671	2014-03-01	2014-03-01 00:00:00	2014-03-15	2014-03-15 00:00:00	2014-03-15	38000177		0	0	14		0	0	0	45557	0	562251	1713671		
228447	5017	40213160	1984-12-22	1984-12-22 00:00:00	1984-12-22	1984-12-22 00:00:00	1984-12-22	581452		0	0	0		0	0	0	333455	0	10	40213160		
151695	3337	40213260	2019-06-10	2019-06-10 00:00:00	2019-06-10	2019-06-10 00:00:00	2019-06-10	581452		0	0	0		0	0	0	221358	0	121	40213260		
122254	2686	40213198	2017-09-24	2017-09-24 00:00:00	2017-09-24	2017-09-24 00:00:00	2017-09-24	581452		0	0	0		0	0	0	177994	0	133	40213198		
40051	3313	40229134	1971-10-17	1971-10-17 00:00:00	1971-10-24	1971-10-24 00:00:00	1971-10-24	38000177		0	0	7		0	0	0	219978	0	1043400	40229134		
110969	2438	40213160	1980-11-30	1980-11-30 00:00:00	1980-11-30	1980-11-30 00:00:00	1980-11-30	581452		0	0	0		0	0	0	161751	0	10	40213160		
63503	5276	1127078	1965-08-10	1965-08-10 00:00:00	1965-08-31	1965-08-31 00:00:00	1965-08-31	38000177		0	0	21		0	0	0	350944	0	282464	1127078		
171803	3777	40213160	1985-01-03	1985-01-03 00:00:00	1985-01-03	1985-01-03 00:00:00	1985-01-03	581452		0	0	0		0	0	0	251016	0	10	40213160		
130890	2876	40213296	2003-10-16	2003-10-16 00:00:00	2003-10-16	2003-10-16 00:00:00	2003-10-16	581452		0	0	0		0	0	0	191352	0	52	40213296		
92013	2020	40213296	2011-01-22	2011-01-22 00:00:00	2011-01-22	2011-01-22 00:00:00	2011-01-22	581452		0	0	0		0	0	0	134303	0	52	40213296		
233388	5128	40213227	2007-11-07	2007-11-07 00:00:00	2007-11-07	2007-11-07 00:00:00	2007-11-07	581452		0	0	0		0	0	0	340991	0	113	40213227		
176322	3876	40213260	2018-05-28	2018-05-28 00:00:00	2018-05-28	2018-05-28 00:00:00	2018-05-28	581452		0	0	0		0	0	0	257487	0	121	40213260		
4179	90	40213260	2012-02-28	2012-02-28 00:00:00	2012-02-28	2012-02-28 00:00:00	2012-02-28	581452		0	0	0		0	0	0	6046	0	121	40213260		
193056	4240	40213201	2007-10-22	2007-10-22 00:00:00	2007-10-22	2007-10-22 00:00:00	2007-10-22	581452		0	0	0		0	0	0	281586	0	33	40213201		
27021	588	40213314	1981-07-08	1981-07-08 00:00:00	1981-07-08	1981-07-08 00:00:00	1981-07-08	581452		0	0	0		0	0	0	38920	0	49	40213314		
177637	3904	40213314	1979-08-02	1979-08-02 00:00:00	1979-08-02	1979-08-02 00:00:00	1979-08-02	581452		0	0	0		0	0	0	259615	0	49	40213314		
38901	3215	1332419	2009-04-06	2009-04-06 00:00:00	2009-04-06	2009-04-06 00:00:00	\N	38000177		0	0	0		0	0	0	213639	0	197361	1332419		
210369	4613	40213160	1971-05-02	1971-05-02 00:00:00	1971-05-02	1971-05-02 00:00:00	1971-05-02	581452		0	0	0		0	0	0	307251	0	10	40213160		
118003	2594	40213227	2008-05-07	2008-05-07 00:00:00	2008-05-07	2008-05-07 00:00:00	2008-05-07	581452		0	0	0		0	0	0	171694	0	113	40213227		
81592	1783	40213227	2000-08-28	2000-08-28 00:00:00	2000-08-28	2000-08-28 00:00:00	2000-08-28	581452		0	0	0		0	0	0	119398	0	113	40213227		
5732	124	40213160	1984-11-12	1984-11-12 00:00:00	1984-11-12	1984-11-12 00:00:00	1984-11-12	581452		0	0	0		0	0	0	8210	0	10	40213160		
171516	3771	40213260	2015-02-03	2015-02-03 00:00:00	2015-02-03	2015-02-03 00:00:00	2015-02-03	581452		0	0	0		0	0	0	250628	0	121	40213260		
14188	1189	19019979	1975-07-02	1975-07-02 00:00:00	1975-08-01	1975-08-01 00:00:00	1975-08-01	38000177		0	0	30		0	0	0	78325	0	198405	19019979		
215430	4724	40213227	2002-12-04	2002-12-04 00:00:00	2002-12-04	2002-12-04 00:00:00	2002-12-04	581452		0	0	0		0	0	0	314674	0	113	40213227		
14379	1208	40163554	1993-11-09	1993-11-09 00:00:00	1993-11-09	1993-11-09 00:00:00	\N	38000177		0	0	0		0	0	0	79360	0	855332	40163554		
196662	4321	40213160	1963-06-09	1963-06-09 00:00:00	1963-06-09	1963-06-09 00:00:00	1963-06-09	581452		0	0	0		0	0	0	286765	0	10	40213160		
51816	4308	1713671	1943-01-08	1943-01-08 00:00:00	1943-01-15	1943-01-15 00:00:00	1943-01-15	38000177		0	0	7		0	0	0	285754	0	562251	1713671		
188243	4133	40213314	1977-10-07	1977-10-07 00:00:00	1977-10-07	1977-10-07 00:00:00	1977-10-07	581452		0	0	0		0	0	0	274755	0	49	40213314		
155853	3430	40213160	1962-03-24	1962-03-24 00:00:00	1962-03-24	1962-03-24 00:00:00	1962-03-24	581452		0	0	0		0	0	0	227346	0	10	40213160		
178021	3913	40213260	2014-08-07	2014-08-07 00:00:00	2014-08-07	2014-08-07 00:00:00	2014-08-07	581452		0	0	0		0	0	0	260206	0	121	40213260		
39813	3293	19059056	1944-02-27	1944-02-27 00:00:00	1944-03-28	1944-03-28 00:00:00	1944-03-28	38000177		0	0	30		0	0	0	218665	0	243670	19059056		
152435	3355	40213260	2013-10-11	2013-10-11 00:00:00	2013-10-11	2013-10-11 00:00:00	2013-10-11	581452		0	0	0		0	0	0	222529	0	121	40213260		
155342	3418	40213201	2010-01-10	2010-01-10 00:00:00	2010-01-10	2010-01-10 00:00:00	2010-01-10	581452		0	0	0		0	0	0	226738	0	33	40213201		
164277	3613	40213296	2016-01-31	2016-01-31 00:00:00	2016-01-31	2016-01-31 00:00:00	2016-01-31	581452		0	0	0		0	0	0	240040	0	52	40213296		
17415	1442	1127433	2006-08-23	2006-08-23 00:00:00	2006-08-30	2006-08-30 00:00:00	2006-08-30	38000177		0	0	7		0	0	0	96150	0	313782	1127433		
25183	2073	1127433	1979-05-13	1979-05-13 00:00:00	1979-06-12	1979-06-12 00:00:00	1979-06-12	38000177		0	0	30		0	0	0	137884	0	313782	1127433		
213260	4676	40213314	1980-10-09	1980-10-09 00:00:00	1980-10-09	1980-10-09 00:00:00	1980-10-09	581452		0	0	0		0	0	0	311602	0	49	40213314		
80924	1769	40213296	2016-10-05	2016-10-05 00:00:00	2016-10-05	2016-10-05 00:00:00	2016-10-05	581452		0	0	0		0	0	0	118321	0	52	40213296		
8237	687	1127433	1983-12-21	1983-12-21 00:00:00	1984-01-04	1984-01-04 00:00:00	1984-01-04	38000177		0	0	14		0	0	0	45530	0	313782	1127433		
228449	5017	40213251	1984-12-22	1984-12-22 00:00:00	1984-12-22	1984-12-22 00:00:00	1984-12-22	581452		0	0	0		0	0	0	333455	0	21	40213251		
151698	3337	40213160	1974-05-20	1974-05-20 00:00:00	1974-05-20	1974-05-20 00:00:00	1974-05-20	581452		0	0	0		0	0	0	221410	0	10	40213160		
133551	2933	40213160	1955-01-31	1955-01-31 00:00:00	1955-01-31	1955-01-31 00:00:00	1955-01-31	581452		0	0	0		0	0	0	195599	0	10	40213160		
40052	3313	1124300	1991-12-28	1991-12-28 00:00:00	1991-12-28	1991-12-28 00:00:00	\N	38000177		0	0	0		0	0	0	220020	0	00781178901	45011828		
110974	2438	40213227	2003-03-30	2003-03-30 00:00:00	2003-03-30	2003-03-30 00:00:00	2003-03-30	581452		0	0	0		0	0	0	161762	0	113	40213227		
63504	5277	40229134	1990-09-21	1990-09-21 00:00:00	1990-10-05	1990-10-05 00:00:00	1990-10-05	38000177		0	0	14		0	0	0	351042	0	1043400	40229134		
158733	3494	40213160	1964-07-16	1964-07-16 00:00:00	1964-07-16	1964-07-16 00:00:00	1964-07-16	581452		0	0	0		0	0	0	231785	0	10	40213160		
130894	2876	40213296	2005-10-20	2005-10-20 00:00:00	2005-10-20	2005-10-20 00:00:00	2005-10-20	581452		0	0	0		0	0	0	191389	0	52	40213296		
92015	2020	40213227	2002-01-12	2002-01-12 00:00:00	2002-01-12	2002-01-12 00:00:00	2002-01-12	581452		0	0	0		0	0	0	134302	0	113	40213227		
233399	5128	40213227	2017-09-20	2017-09-20 00:00:00	2017-09-20	2017-09-20 00:00:00	2017-09-20	581452		0	0	0		0	0	0	340994	0	113	40213227		
176324	3876	40213227	2018-05-28	2018-05-28 00:00:00	2018-05-28	2018-05-28 00:00:00	2018-05-28	581452		0	0	0		0	0	0	257487	0	113	40213227		
4187	90	40213227	1993-06-29	1993-06-29 00:00:00	1993-06-29	1993-06-29 00:00:00	1993-06-29	581452		0	0	0		0	0	0	5995	0	113	40213227		
193060	4241	40213160	1965-04-06	1965-04-06 00:00:00	1965-04-06	1965-04-06 00:00:00	1965-04-06	581452		0	0	0		0	0	0	281733	0	10	40213160		
27027	588	40213251	1985-12-04	1985-12-04 00:00:00	1985-12-04	1985-12-04 00:00:00	1985-12-04	581452		0	0	0		0	0	0	38947	0	21	40213251		
116633	2563	40213227	1994-02-20	1994-02-20 00:00:00	1994-02-20	1994-02-20 00:00:00	1994-02-20	581452		0	0	0		0	0	0	169769	0	113	40213227		
38902	3215	1539411	2009-04-06	2009-04-06 00:00:00	2009-04-06	2009-04-06 00:00:00	\N	38000177		0	0	0		0	0	0	213639	0	312961	1539411		
210376	4613	40213306	1989-01-29	1989-01-29 00:00:00	1989-01-29	1989-01-29 00:00:00	1989-01-29	581452		0	0	0		0	0	0	307303	0	43	40213306		
118004	2594	40213160	1975-08-06	1975-08-06 00:00:00	1975-08-06	1975-08-06 00:00:00	1975-08-06	581452		0	0	0		0	0	0	171717	0	10	40213160		
173746	3820	40213227	2015-11-27	2015-11-27 00:00:00	2015-11-27	2015-11-27 00:00:00	2015-11-27	581452		0	0	0		0	0	0	253641	0	113	40213227		
5743	124	40213314	1984-08-14	1984-08-14 00:00:00	1984-08-14	1984-08-14 00:00:00	1984-08-14	581452		0	0	0		0	0	0	8232	0	49	40213314		
171520	3771	40213227	1995-08-08	1995-08-08 00:00:00	1995-08-08	1995-08-08 00:00:00	1995-08-08	581452		0	0	0		0	0	0	250641	0	113	40213227		
14189	1189	19078461	1980-03-07	1980-03-07 00:00:00	1980-03-28	1980-03-28 00:00:00	1980-03-28	38000177		0	0	21		0	0	0	78326	0	310965	19078461		
215451	4724	40213227	1993-02-10	1993-02-10 00:00:00	1993-02-10	1993-02-10 00:00:00	1993-02-10	581452		0	0	0		0	0	0	314755	0	113	40213227		
14380	1208	19018935	1993-11-09	1993-11-09 00:00:00	1993-11-09	1993-11-09 00:00:00	\N	38000177		0	0	0		0	0	0	79360	0	197604	19018935		
196667	4321	40213227	2014-11-16	2014-11-16 00:00:00	2014-11-16	2014-11-16 00:00:00	2014-11-16	581452		0	0	0		0	0	0	286767	0	113	40213227		
51817	4308	19133905	1938-04-16	1938-04-16 00:00:00	1938-04-26	1938-04-26 00:00:00	1938-04-26	38000177		0	0	10		0	0	0	285766	0	834102	19133905		
227270	4990	40213227	1994-06-01	1994-06-01 00:00:00	1994-06-01	1994-06-01 00:00:00	1994-06-01	581452		0	0	0		0	0	0	331979	0	113	40213227		
155857	3430	40213296	2005-03-26	2005-03-26 00:00:00	2005-03-26	2005-03-26 00:00:00	2005-03-26	581452		0	0	0		0	0	0	227340	0	52	40213296		
178028	3913	40213160	1963-01-24	1963-01-24 00:00:00	1963-01-24	1963-01-24 00:00:00	1963-01-24	581452		0	0	0		0	0	0	260140	0	10	40213160		
39814	3293	1127433	1998-10-02	1998-10-02 00:00:00	1998-10-16	1998-10-16 00:00:00	1998-10-16	38000177		0	0	14		0	0	0	218735	0	313782	1127433		
152441	3355	40213227	2004-10-15	2004-10-15 00:00:00	2004-10-15	2004-10-15 00:00:00	2004-10-15	581452		0	0	0		0	0	0	222503	0	113	40213227		
155343	3418	40213198	2010-01-10	2010-01-10 00:00:00	2010-01-10	2010-01-10 00:00:00	2010-01-10	581452		0	0	0		0	0	0	226738	0	133	40213198		
140735	3090	40213296	2001-01-29	2001-01-29 00:00:00	2001-01-29	2001-01-29 00:00:00	2001-01-29	581452		0	0	0		0	0	0	205742	0	52	40213296		
17416	1442	1127433	1955-01-21	1955-01-21 00:00:00	1955-02-04	1955-02-04 00:00:00	1955-02-04	38000177		0	0	14		0	0	0	96142	0	313782	1127433		
25184	2073	1127433	1987-09-25	1987-09-25 00:00:00	1987-10-02	1987-10-02 00:00:00	1987-10-02	38000177		0	0	7		0	0	0	137887	0	313782	1127433		
213271	4676	40213251	1984-11-22	1984-11-22 00:00:00	1984-11-22	1984-11-22 00:00:00	1984-11-22	581452		0	0	0		0	0	0	311591	0	21	40213251		
80926	1769	40213227	2016-10-05	2016-10-05 00:00:00	2016-10-05	2016-10-05 00:00:00	2016-10-05	581452		0	0	0		0	0	0	118321	0	113	40213227		
8238	687	1127433	1974-12-12	1974-12-12 00:00:00	1974-12-26	1974-12-26 00:00:00	1974-12-26	38000177		0	0	14		0	0	0	45460	0	313782	1127433		
228474	5018	40213227	2001-06-21	2001-06-21 00:00:00	2001-06-21	2001-06-21 00:00:00	2001-06-21	581452		0	0	0		0	0	0	333485	0	113	40213227		
151703	3337	40213296	2009-06-15	2009-06-15 00:00:00	2009-06-15	2009-06-15 00:00:00	2009-06-15	581452		0	0	0		0	0	0	221401	0	52	40213296		
133555	2933	40213260	2006-09-11	2006-09-11 00:00:00	2006-09-11	2006-09-11 00:00:00	2006-09-11	581452		0	0	0		0	0	0	195591	0	121	40213260		
40054	3313	1127433	1967-01-29	1967-01-29 00:00:00	1967-02-12	1967-02-12 00:00:00	1967-02-12	38000177		0	0	14		0	0	0	219977	0	313782	1127433		
110975	2438	40213306	2003-03-30	2003-03-30 00:00:00	2003-03-30	2003-03-30 00:00:00	2003-03-30	581452		0	0	0		0	0	0	161762	0	43	40213306		
63505	5277	1127078	1961-10-30	1961-10-30 00:00:00	1961-12-04	1961-12-04 00:00:00	1961-12-04	38000177		0	0	35		0	0	0	350975	0	282464	1127078		
158745	3494	40213227	2001-05-03	2001-05-03 00:00:00	2001-05-03	2001-05-03 00:00:00	2001-05-03	581452		0	0	0		0	0	0	231734	0	113	40213227		
130896	2876	40213227	2005-10-20	2005-10-20 00:00:00	2005-10-20	2005-10-20 00:00:00	2005-10-20	581452		0	0	0		0	0	0	191389	0	113	40213227		
92020	2020	40213160	1971-07-10	1971-07-10 00:00:00	1971-07-10	1971-07-10 00:00:00	1971-07-10	581452		0	0	0		0	0	0	134272	0	10	40213160		
233415	5128	40213227	1998-02-25	1998-02-25 00:00:00	1998-02-25	1998-02-25 00:00:00	1998-02-25	581452		0	0	0		0	0	0	341026	0	113	40213227		
176330	3876	40213160	1967-10-30	1967-10-30 00:00:00	1967-10-30	1967-10-30 00:00:00	1967-10-30	581452		0	0	0		0	0	0	257420	0	10	40213160		
190876	4194	40213160	1976-08-02	1976-08-02 00:00:00	1976-08-02	1976-08-02 00:00:00	1976-08-02	581452		0	0	0		0	0	0	278373	0	10	40213160		
193063	4241	40213296	2008-09-16	2008-09-16 00:00:00	2008-09-16	2008-09-16 00:00:00	2008-09-16	581452		0	0	0		0	0	0	281745	0	52	40213296		
27029	588	40213160	1985-12-04	1985-12-04 00:00:00	1985-12-04	1985-12-04 00:00:00	1985-12-04	581452		0	0	0		0	0	0	38947	0	10	40213160		
116641	2563	40213306	1991-02-17	1991-02-17 00:00:00	1991-02-17	1991-02-17 00:00:00	1991-02-17	581452		0	0	0		0	0	0	169785	0	43	40213306		
38903	3215	46233988	1978-06-30	1978-06-30 00:00:00	1978-07-14	1978-07-14 00:00:00	1978-07-14	38000177		0	0	14		0	0	0	213569	0	1652673	46233988		
210380	4613	40213260	2016-05-22	2016-05-22 00:00:00	2016-05-22	2016-05-22 00:00:00	2016-05-22	581452		0	0	0		0	0	0	307305	0	121	40213260		
139236	3059	40213160	1970-12-27	1970-12-27 00:00:00	1970-12-27	1970-12-27 00:00:00	1970-12-27	581452		0	0	0		0	0	0	203478	0	10	40213160		
173747	3820	40213260	2015-11-27	2015-11-27 00:00:00	2015-11-27	2015-11-27 00:00:00	2015-11-27	581452		0	0	0		0	0	0	253641	0	121	40213260		
5746	124	40213160	1984-08-14	1984-08-14 00:00:00	1984-08-14	1984-08-14 00:00:00	1984-08-14	581452		0	0	0		0	0	0	8232	0	10	40213160		
171525	3771	40213160	1964-05-05	1964-05-05 00:00:00	1964-05-05	1964-05-05 00:00:00	1964-05-05	581452		0	0	0		0	0	0	250613	0	10	40213160		
14190	1189	19129655	1968-11-05	1968-11-05 00:00:00	1968-11-19	1968-11-19 00:00:00	1968-11-19	38000177		0	0	14		0	0	0	78355	0	789980	19129655		
215457	4724	40213198	2010-01-13	2010-01-13 00:00:00	2010-01-13	2010-01-13 00:00:00	2010-01-13	581452		0	0	0		0	0	0	314709	0	133	40213198		
14381	1208	40171902	1993-11-09	1993-11-09 00:00:00	1993-11-09	1993-11-09 00:00:00	\N	38000177		0	0	0		0	0	0	79360	0	897718	40171902		
29112	2411	40229134	2014-11-09	2014-11-09 00:00:00	2014-11-16	2014-11-16 00:00:00	2014-11-16	38000177		0	0	7		0	0	0	159989	0	1043400	40229134		
51818	4308	1127433	1956-11-14	1956-11-14 00:00:00	1956-11-21	1956-11-21 00:00:00	1956-11-21	38000177		0	0	7		0	0	0	285751	0	313782	1127433		
227274	4990	40213160	1967-01-25	1967-01-25 00:00:00	1967-01-25	1967-01-25 00:00:00	1967-01-25	581452		0	0	0		0	0	0	331996	0	10	40213160		
155862	3430	40213227	1995-03-11	1995-03-11 00:00:00	1995-03-11	1995-03-11 00:00:00	1995-03-11	581452		0	0	0		0	0	0	227369	0	113	40213227		
178032	3913	40213160	1963-03-28	1963-03-28 00:00:00	1963-03-28	1963-03-28 00:00:00	1963-03-28	581452		0	0	0		0	0	0	260192	0	10	40213160		
39815	3293	1127433	2005-06-23	2005-06-23 00:00:00	2005-07-23	2005-07-23 00:00:00	2005-07-23	38000177		0	0	30		0	0	0	218697	0	313782	1127433		
152442	3355	40213296	2004-10-15	2004-10-15 00:00:00	2004-10-15	2004-10-15 00:00:00	2004-10-15	581452		0	0	0		0	0	0	222503	0	52	40213296		
167767	3689	40213198	2015-04-27	2015-04-27 00:00:00	2015-04-27	2015-04-27 00:00:00	2015-04-27	581452		0	0	0		0	0	0	245198	0	133	40213198		
140740	3090	40213306	1983-05-02	1983-05-02 00:00:00	1983-05-02	1983-05-02 00:00:00	1983-05-02	581452		0	0	0		0	0	0	205722	0	43	40213306		
17417	1442	1118084	1980-12-18	1980-12-18 00:00:00	1980-12-18	1980-12-18 00:00:00	\N	38000177		0	0	0		0	0	0	96133	0	00025152531	44923712		
25185	2073	19078461	1987-06-21	1987-06-21 00:00:00	1987-07-05	1987-07-05 00:00:00	1987-07-05	38000177		0	0	14		0	0	0	137937	0	310965	19078461		
213273	4676	40213160	1983-11-17	1983-11-17 00:00:00	1983-11-17	1983-11-17 00:00:00	1983-11-17	581452		0	0	0		0	0	0	311641	0	10	40213160		
80928	1769	40213314	1977-08-31	1977-08-31 00:00:00	1977-08-31	1977-08-31 00:00:00	1977-08-31	581452		0	0	0		0	0	0	118291	0	49	40213314		
8239	687	1551192	1977-05-03	1977-05-03 00:00:00	1977-05-03	1977-05-03 00:00:00	1977-05-03	38000177		0	0	0		0	0	0	45487	0	312617	1551192		
180438	3966	40213306	1989-11-25	1989-11-25 00:00:00	1989-11-25	1989-11-25 00:00:00	1989-11-25	581452		0	0	0		0	0	0	263682	0	43	40213306		
151709	3337	40213296	2010-08-02	2010-08-02 00:00:00	2010-08-02	2010-08-02 00:00:00	2010-08-02	581452		0	0	0		0	0	0	\N	0	52	40213296		
133565	2933	40213227	2005-09-05	2005-09-05 00:00:00	2005-09-05	2005-09-05 00:00:00	2005-09-05	581452		0	0	0		0	0	0	195611	0	113	40213227		
40055	3314	19078461	2012-04-18	2012-04-18 00:00:00	2012-05-09	2012-05-09 00:00:00	2012-05-09	38000177		0	0	21		0	0	0	220128	0	310965	19078461		
68196	1493	40213227	2008-04-29	2008-04-29 00:00:00	2008-04-29	2008-04-29 00:00:00	2008-04-29	581452		0	0	0		0	0	0	99584	0	113	40213227		
63506	5277	19059056	1955-12-31	1955-12-31 00:00:00	1956-02-29	1956-02-29 00:00:00	1956-02-29	38000177		0	0	60		0	0	0	350974	0	243670	19059056		
158746	3494	40213296	2001-05-03	2001-05-03 00:00:00	2001-05-03	2001-05-03 00:00:00	2001-05-03	581452		0	0	0		0	0	0	231734	0	52	40213296		
137530	3019	40213314	1978-07-12	1978-07-12 00:00:00	1978-07-12	1978-07-12 00:00:00	1978-07-12	581452		0	0	0		0	0	0	201357	0	49	40213314		
164905	3625	40213160	1956-06-19	1956-06-19 00:00:00	1956-06-19	1956-06-19 00:00:00	1956-06-19	581452		0	0	0		0	0	0	241081	0	10	40213160		
119619	2630	40213306	1982-08-29	1982-08-29 00:00:00	1982-08-29	1982-08-29 00:00:00	1982-08-29	581452		0	0	0		0	0	0	173958	0	43	40213306		
176333	3876	40213227	2009-06-01	2009-06-01 00:00:00	2009-06-01	2009-06-01 00:00:00	2009-06-01	581452		0	0	0		0	0	0	257423	0	113	40213227		
190881	4194	40213160	1976-10-04	1976-10-04 00:00:00	1976-10-04	1976-10-04 00:00:00	1976-10-04	581452		0	0	0		0	0	0	278398	0	10	40213160		
199977	4392	40213227	2010-10-15	2010-10-15 00:00:00	2010-10-15	2010-10-15 00:00:00	2010-10-15	581452		0	0	0		0	0	0	292043	0	113	40213227		
38307	836	40213296	2018-09-09	2018-09-09 00:00:00	2018-09-09	2018-09-09 00:00:00	2018-09-09	581452		0	0	0		0	0	0	55303	0	52	40213296		
116646	2563	40213227	2013-03-17	2013-03-17 00:00:00	2013-03-17	2013-03-17 00:00:00	2013-03-17	581452		0	0	0		0	0	0	169813	0	113	40213227		
38904	3215	19059056	1978-06-30	1978-06-30 00:00:00	1978-07-14	1978-07-14 00:00:00	1978-07-14	38000177		0	0	14		0	0	0	213569	0	243670	19059056		
210929	4625	40213160	1961-01-25	1961-01-25 00:00:00	1961-01-25	1961-01-25 00:00:00	1961-01-25	581452		0	0	0		0	0	0	308118	0	10	40213160		
139242	3059	40213227	1992-11-15	1992-11-15 00:00:00	1992-11-15	1992-11-15 00:00:00	1992-11-15	581452		0	0	0		0	0	0	203535	0	113	40213227		
173750	3820	40213160	1968-11-22	1968-11-22 00:00:00	1968-11-22	1968-11-22 00:00:00	1968-11-22	581452		0	0	0		0	0	0	253625	0	10	40213160		
5747	124	40213314	1985-05-14	1985-05-14 00:00:00	1985-05-14	1985-05-14 00:00:00	1985-05-14	581452		0	0	0		0	0	0	8233	0	49	40213314		
126406	2780	40213160	1956-09-26	1956-09-26 00:00:00	1956-09-26	1956-09-26 00:00:00	1956-09-26	581452		0	0	0		0	0	0	184213	0	10	40213160		
14191	1189	1127078	1968-11-05	1968-11-05 00:00:00	1968-11-19	1968-11-19 00:00:00	1968-11-19	38000177		0	0	14		0	0	0	78355	0	282464	1127078		
46513	3852	19078461	1995-01-20	1995-01-20 00:00:00	1995-02-03	1995-02-03 00:00:00	1995-02-03	38000177		0	0	14		0	0	0	255632	0	310965	19078461		
14382	1208	19006318	1945-08-11	1945-08-11 00:00:00	1945-08-25	1945-08-25 00:00:00	1945-08-25	38000177		0	0	14		0	0	0	79369	0	105078	19006318		
29113	2411	19129655	1967-07-01	1967-07-01 00:00:00	1967-07-15	1967-07-15 00:00:00	1967-07-15	38000177		0	0	14		0	0	0	160014	0	789980	19129655		
51819	4308	1118084	1947-12-31	1947-12-31 00:00:00	1947-12-31	1947-12-31 00:00:00	\N	38000177		0	0	0		0	0	0	285755	0	00025152531	44923712		
227281	4990	40213227	2003-10-29	2003-10-29 00:00:00	2003-10-29	2003-10-29 00:00:00	2003-10-29	581452		0	0	0		0	0	0	331934	0	113	40213227		
155866	3431	40213160	1967-09-20	1967-09-20 00:00:00	1967-09-20	1967-09-20 00:00:00	1967-09-20	581452		0	0	0		0	0	0	227465	0	10	40213160		
178034	3913	40213296	2002-10-24	2002-10-24 00:00:00	2002-10-24	2002-10-24 00:00:00	2002-10-24	581452		0	0	0		0	0	0	260163	0	52	40213296		
39816	3294	1127433	2015-08-13	2015-08-13 00:00:00	2015-08-27	2015-08-27 00:00:00	2015-08-27	38000177		0	0	14		0	0	0	218823	0	313782	1127433		
81237	1776	40213227	2007-11-03	2007-11-03 00:00:00	2007-11-03	2007-11-03 00:00:00	2007-11-03	581452		0	0	0		0	0	0	118840	0	113	40213227		
167796	3689	40213160	1955-01-09	1955-01-09 00:00:00	1955-01-09	1955-01-09 00:00:00	1955-01-09	581452		0	0	0		0	0	0	245180	0	10	40213160		
140746	3090	40213227	2002-08-12	2002-08-12 00:00:00	2002-08-12	2002-08-12 00:00:00	2002-08-12	581452		0	0	0		0	0	0	205725	0	113	40213227		
17418	1442	1127433	1973-04-09	1973-04-09 00:00:00	1973-04-16	1973-04-16 00:00:00	1973-04-16	38000177		0	0	7		0	0	0	96106	0	313782	1127433		
25186	2073	19074841	1987-06-21	1987-06-21 00:00:00	1987-07-05	1987-07-05 00:00:00	1987-07-05	38000177		0	0	14		0	0	0	137937	0	309043	19074841		
213277	4676	40213160	1980-01-10	1980-01-10 00:00:00	1980-01-10	1980-01-10 00:00:00	1980-01-10	581452		0	0	0		0	0	0	311601	0	10	40213160		
80933	1770	40213314	1979-06-17	1979-06-17 00:00:00	1979-06-17	1979-06-17 00:00:00	1979-06-17	581452		0	0	0		0	0	0	118356	0	49	40213314		
8240	687	19059056	1984-07-20	1984-07-20 00:00:00	1984-09-18	1984-09-18 00:00:00	1984-09-18	38000177		0	0	60		0	0	0	45490	0	243670	19059056		
180440	3966	40213160	1967-05-20	1967-05-20 00:00:00	1967-05-20	1967-05-20 00:00:00	1967-05-20	581452		0	0	0		0	0	0	263691	0	10	40213160		
151711	3337	40213227	2010-08-02	2010-08-02 00:00:00	2010-08-02	2010-08-02 00:00:00	2010-08-02	581452		0	0	0		0	0	0	\N	0	113	40213227		
112402	2469	40213296	2011-08-07	2011-08-07 00:00:00	2011-08-07	2011-08-07 00:00:00	2011-08-07	581452		0	0	0		0	0	0	163740	0	52	40213296		
40056	3314	19059056	1976-08-25	1976-08-25 00:00:00	1976-11-22	1976-11-22 00:00:00	1976-11-22	38000177		0	0	89		0	0	0	220084	0	243670	19059056		
68199	1493	40213296	1998-10-06	1998-10-06 00:00:00	1998-10-06	1998-10-06 00:00:00	1998-10-06	581452		0	0	0		0	0	0	99508	0	52	40213296		
63507	5277	1118084	1997-09-06	1997-09-06 00:00:00	1997-09-06	1997-09-06 00:00:00	\N	38000177		0	0	0		0	0	0	350977	0	00025152531	44923712		
158747	3494	40213260	2011-08-11	2011-08-11 00:00:00	2011-08-11	2011-08-11 00:00:00	2011-08-11	581452		0	0	0		0	0	0	231736	0	121	40213260		
137534	3019	40213227	2008-07-16	2008-07-16 00:00:00	2008-07-16	2008-07-16 00:00:00	2008-07-16	581452		0	0	0		0	0	0	201344	0	113	40213227		
164911	3625	40213296	1997-09-30	1997-09-30 00:00:00	1997-09-30	1997-09-30 00:00:00	1997-09-30	581452		0	0	0		0	0	0	241102	0	52	40213296		
119623	2630	40213260	2010-10-10	2010-10-10 00:00:00	2010-10-10	2010-10-10 00:00:00	2010-10-10	581452		0	0	0		0	0	0	173994	0	121	40213260		
176334	3876	40213296	2009-06-01	2009-06-01 00:00:00	2009-06-01	2009-06-01 00:00:00	2009-06-01	581452		0	0	0		0	0	0	257423	0	52	40213296		
190887	4194	40213160	1981-04-05	1981-04-05 00:00:00	1981-04-05	1981-04-05 00:00:00	1981-04-05	581452		0	0	0		0	0	0	278413	0	10	40213160		
199983	4392	40213227	2001-10-05	2001-10-05 00:00:00	2001-10-05	2001-10-05 00:00:00	2001-10-05	581452		0	0	0		0	0	0	292040	0	113	40213227		
38313	836	40213160	1983-08-14	1983-08-14 00:00:00	1983-08-14	1983-08-14 00:00:00	1983-08-14	581452		0	0	0		0	0	0	55291	0	10	40213160		
116647	2563	40213296	2013-03-17	2013-03-17 00:00:00	2013-03-17	2013-03-17 00:00:00	2013-03-17	581452		0	0	0		0	0	0	169813	0	52	40213296		
38905	3215	1713671	1988-12-10	1988-12-10 00:00:00	1988-12-31	1988-12-31 00:00:00	1988-12-31	38000177		0	0	21		0	0	0	213562	0	562251	1713671		
210935	4625	40213160	1965-04-28	1965-04-28 00:00:00	1965-04-28	1965-04-28 00:00:00	1965-04-28	581452		0	0	0		0	0	0	308080	0	10	40213160		
139243	3059	40213306	1992-11-15	1992-11-15 00:00:00	1992-11-15	1992-11-15 00:00:00	1992-11-15	581452		0	0	0		0	0	0	203535	0	43	40213306		
173754	3820	40213160	1965-04-30	1965-04-30 00:00:00	1965-04-30	1965-04-30 00:00:00	1965-04-30	581452		0	0	0		0	0	0	253623	0	10	40213160		
5748	124	40213251	1985-05-14	1985-05-14 00:00:00	1985-05-14	1985-05-14 00:00:00	1985-05-14	581452		0	0	0		0	0	0	8233	0	21	40213251		
126415	2781	40213160	1980-12-05	1980-12-05 00:00:00	1980-12-05	1980-12-05 00:00:00	1980-12-05	581452		0	0	0		0	0	0	184334	0	10	40213160		
14192	1189	1118084	2005-05-10	2005-05-10 00:00:00	2005-05-10	2005-05-10 00:00:00	\N	38000177		0	0	0		0	0	0	78320	0	00025152531	44923712		
46514	3852	1127433	2013-05-05	2013-05-05 00:00:00	2013-05-19	2013-05-19 00:00:00	2013-05-19	38000177		0	0	14		0	0	0	255617	0	313782	1127433		
14383	1208	19059056	1945-08-11	1945-08-11 00:00:00	1945-08-25	1945-08-25 00:00:00	1945-08-25	38000177		0	0	14		0	0	0	79369	0	243670	19059056		
29114	2411	1127078	1967-07-01	1967-07-01 00:00:00	1967-07-15	1967-07-15 00:00:00	1967-07-15	38000177		0	0	14		0	0	0	160014	0	282464	1127078		
51820	4308	1127433	1988-07-10	1988-07-10 00:00:00	1988-07-24	1988-07-24 00:00:00	1988-07-24	38000177		0	0	14		0	0	0	285837	0	313782	1127433		
227282	4990	40213296	2003-10-29	2003-10-29 00:00:00	2003-10-29	2003-10-29 00:00:00	2003-10-29	581452		0	0	0		0	0	0	331934	0	52	40213296		
155870	3431	40213306	1986-06-25	1986-06-25 00:00:00	1986-06-25	1986-06-25 00:00:00	1986-06-25	581452		0	0	0		0	0	0	227431	0	43	40213306		
178037	3913	40213227	2004-07-08	2004-07-08 00:00:00	2004-07-08	2004-07-08 00:00:00	2004-07-08	581452		0	0	0		0	0	0	260204	0	113	40213227		
39817	3294	19078461	2010-06-30	2010-06-30 00:00:00	2010-07-28	2010-07-28 00:00:00	2010-07-28	38000177		0	0	28		0	0	0	218851	0	310965	19078461		
81241	1776	40213201	1983-06-18	1983-06-18 00:00:00	1983-06-18	1983-06-18 00:00:00	1983-06-18	581452		0	0	0		0	0	0	118861	0	33	40213201		
167804	3689	40213201	2016-05-02	2016-05-02 00:00:00	2016-05-02	2016-05-02 00:00:00	2016-05-02	581452		0	0	0		0	0	0	245164	0	33	40213201		
140747	3090	40213296	2002-08-12	2002-08-12 00:00:00	2002-08-12	2002-08-12 00:00:00	2002-08-12	581452		0	0	0		0	0	0	205725	0	52	40213296		
17419	1442	1115171	2004-12-18	2004-12-18 00:00:00	2005-02-16	2005-02-16 00:00:00	2005-02-16	38000177		0	0	60		0	0	0	96187	0	849574	1115171		
25187	2073	19075601	2012-04-13	2012-04-13 00:00:00	2012-04-13	2012-04-13 00:00:00	2012-04-13	38000177		0	0	0		0	0	0	137922	0	309362	19075601		
213278	4676	40213314	1980-01-10	1980-01-10 00:00:00	1980-01-10	1980-01-10 00:00:00	1980-01-10	581452		0	0	0		0	0	0	311601	0	49	40213314		
80940	1770	40213227	2012-05-13	2012-05-13 00:00:00	2012-05-13	2012-05-13 00:00:00	2012-05-13	581452		0	0	0		0	0	0	118385	0	113	40213227		
8241	687	40165015	1981-07-06	1981-07-06 00:00:00	1981-07-06	1981-07-06 00:00:00	\N	38000177		0	0	0		0	0	0	45488	0	861467	40165015		
180451	3966	40213260	2016-12-10	2016-12-10 00:00:00	2016-12-10	2016-12-10 00:00:00	2016-12-10	581452		0	0	0		0	0	0	263638	0	121	40213260		
133274	2926	40213160	1981-12-25	1981-12-25 00:00:00	1981-12-25	1981-12-25 00:00:00	1981-12-25	581452		0	0	0		0	0	0	195165	0	10	40213160		
112404	2469	40213160	1972-04-16	1972-04-16 00:00:00	1972-04-16	1972-04-16 00:00:00	1972-04-16	581452		0	0	0		0	0	0	163721	0	10	40213160		
40057	3314	40231925	1976-08-25	1976-08-25 00:00:00	1976-08-25	1976-08-25 00:00:00	\N	38000177		0	0	0		0	0	0	220084	0	1049221	40231925		
79480	1739	40213160	1968-09-19	1968-09-19 00:00:00	1968-09-19	1968-09-19 00:00:00	1968-09-19	581452		0	0	0		0	0	0	116184	0	10	40213160		
63508	5277	1115171	1996-12-14	1996-12-14 00:00:00	1996-12-28	1996-12-28 00:00:00	1996-12-28	38000177		0	0	14		0	0	0	350977	0	849574	1115171		
158749	3494	40213227	2011-08-11	2011-08-11 00:00:00	2011-08-11	2011-08-11 00:00:00	2011-08-11	581452		0	0	0		0	0	0	231736	0	113	40213227		
137536	3019	40213306	1999-07-07	1999-07-07 00:00:00	1999-07-07	1999-07-07 00:00:00	1999-07-07	581452		0	0	0		0	0	0	201326	0	43	40213306		
164919	3626	40213296	2014-04-26	2014-04-26 00:00:00	2014-04-26	2014-04-26 00:00:00	2014-04-26	581452		0	0	0		0	0	0	241169	0	52	40213296		
119625	2630	40213227	2001-12-30	2001-12-30 00:00:00	2001-12-30	2001-12-30 00:00:00	2001-12-30	581452		0	0	0		0	0	0	174006	0	113	40213227		
4147	90	40213160	1961-10-31	1961-10-31 00:00:00	1961-10-31	1961-10-31 00:00:00	1961-10-31	581452		0	0	0		0	0	0	6008	0	10	40213160		
190890	4194	40213251	1984-04-22	1984-04-22 00:00:00	1984-04-22	1984-04-22 00:00:00	1984-04-22	581452		0	0	0		0	0	0	278377	0	21	40213251		
199984	4392	40213306	2001-10-05	2001-10-05 00:00:00	2001-10-05	2001-10-05 00:00:00	2001-10-05	581452		0	0	0		0	0	0	292040	0	43	40213306		
38317	836	40213160	1978-12-10	1978-12-10 00:00:00	1978-12-10	1978-12-10 00:00:00	1978-12-10	581452		0	0	0		0	0	0	55316	0	10	40213160		
116651	2563	40213160	1975-06-01	1975-06-01 00:00:00	1975-06-01	1975-06-01 00:00:00	1975-06-01	581452		0	0	0		0	0	0	169811	0	10	40213160		
38906	3215	19008572	2002-10-08	2002-10-08 00:00:00	2002-10-08	2002-10-08 00:00:00	\N	38000177		0	0	0		0	0	0	213564	0	106258	19008572		
210947	4626	40213160	1976-02-09	1976-02-09 00:00:00	1976-02-09	1976-02-09 00:00:00	1976-02-09	581452		0	0	0		0	0	0	308190	0	10	40213160		
139254	3059	40213227	2001-11-18	2001-11-18 00:00:00	2001-11-18	2001-11-18 00:00:00	2001-11-18	581452		0	0	0		0	0	0	\N	0	113	40213227		
173756	3820	40213227	1996-11-01	1996-11-01 00:00:00	1996-11-01	1996-11-01 00:00:00	1996-11-01	581452		0	0	0		0	0	0	253675	0	113	40213227		
38139	3157	1127078	1957-10-29	1957-10-29 00:00:00	1957-11-12	1957-11-12 00:00:00	1957-11-12	38000177		0	0	14		0	0	0	209867	0	282464	1127078		
126417	2781	40213227	2002-10-11	2002-10-11 00:00:00	2002-10-11	2002-10-11 00:00:00	2002-10-11	581452		0	0	0		0	0	0	184301	0	113	40213227		
14193	1189	19133905	2004-01-29	2004-01-29 00:00:00	2004-02-11	2004-02-11 00:00:00	2004-02-11	38000177		0	0	13		0	0	0	78320	0	834102	19133905		
46515	3852	1127433	1964-12-28	1964-12-28 00:00:00	1965-01-27	1965-01-27 00:00:00	1965-01-27	38000177		0	0	30		0	0	0	255631	0	313782	1127433		
14384	1208	1713671	2006-01-20	2006-01-20 00:00:00	2006-02-03	2006-02-03 00:00:00	2006-02-03	38000177		0	0	14		0	0	0	79395	0	562251	1713671		
29115	2412	1127433	1990-11-02	1990-11-02 00:00:00	1990-11-16	1990-11-16 00:00:00	1990-11-16	38000177		0	0	14		0	0	0	160096	0	313782	1127433		
51821	4308	1127433	1913-11-15	1913-11-15 00:00:00	1913-11-22	1913-11-22 00:00:00	1913-11-22	38000177		0	0	7		0	0	0	285738	0	313782	1127433		
227283	4990	40213160	1962-05-02	1962-05-02 00:00:00	1962-05-02	1962-05-02 00:00:00	1962-05-02	581452		0	0	0		0	0	0	332007	0	10	40213160		
155872	3431	40213306	1983-06-22	1983-06-22 00:00:00	1983-06-22	1983-06-22 00:00:00	1983-06-22	581452		0	0	0		0	0	0	227430	0	43	40213306		
178038	3913	40213296	2004-07-08	2004-07-08 00:00:00	2004-07-08	2004-07-08 00:00:00	2004-07-08	581452		0	0	0		0	0	0	260204	0	52	40213296		
39818	3294	1124300	1985-11-23	1985-11-23 00:00:00	1985-11-23	1985-11-23 00:00:00	\N	38000177		0	0	0		0	0	0	218844	0	00781178901	45011828		
99964	2190	40213160	1955-01-10	1955-01-10 00:00:00	1955-01-10	1955-01-10 00:00:00	1955-01-10	581452		0	0	0		0	0	0	146035	0	10	40213160		
86769	1902	40213227	1994-12-04	1994-12-04 00:00:00	1994-12-04	1994-12-04 00:00:00	1994-12-04	581452		0	0	0		0	0	0	126602	0	113	40213227		
140749	3090	40213160	1961-10-02	1961-10-02 00:00:00	1961-10-02	1961-10-02 00:00:00	1961-10-02	581452		0	0	0		0	0	0	205761	0	10	40213160		
17420	1442	1127433	1963-01-25	1963-01-25 00:00:00	1963-02-01	1963-02-01 00:00:00	1963-02-01	38000177		0	0	7		0	0	0	96145	0	313782	1127433		
25188	2073	40220960	2012-04-13	2012-04-13 00:00:00	2012-04-13	2012-04-13 00:00:00	2012-04-13	38000177		0	0	0		0	0	0	137922	0	1804799	40220960		
213280	4676	40213227	2002-02-14	2002-02-14 00:00:00	2002-02-14	2002-02-14 00:00:00	2002-02-14	581452		0	0	0		0	0	0	311596	0	113	40213227		
80942	1770	40213160	1979-02-18	1979-02-18 00:00:00	1979-02-18	1979-02-18 00:00:00	1979-02-18	581452		0	0	0		0	0	0	118355	0	10	40213160		
8242	687	1127433	1981-07-06	1981-07-06 00:00:00	1981-10-04	1981-10-04 00:00:00	1981-10-04	38000177		0	0	90		0	0	0	45488	0	313782	1127433		
180456	3966	40213227	2017-12-30	2017-12-30 00:00:00	2017-12-30	2017-12-30 00:00:00	2017-12-30	581452		0	0	0		0	0	0	263668	0	113	40213227		
133275	2926	40213314	1981-12-25	1981-12-25 00:00:00	1981-12-25	1981-12-25 00:00:00	1981-12-25	581452		0	0	0		0	0	0	195165	0	49	40213314		
112409	2469	40213160	1972-01-09	1972-01-09 00:00:00	1972-01-09	1972-01-09 00:00:00	1972-01-09	581452		0	0	0		0	0	0	163751	0	10	40213160		
40058	3314	40236824	2009-10-11	2009-10-11 00:00:00	2009-10-18	2009-10-18 00:00:00	2009-10-18	38000177		0	0	7		0	0	0	220093	0	1094107	40236824		
75849	1657	40213227	1995-01-04	1995-01-04 00:00:00	1995-01-04	1995-01-04 00:00:00	1995-01-04	581452		0	0	0		0	0	0	111205	0	113	40213227		
63509	5277	19133873	1968-09-26	1968-09-26 00:00:00	1968-10-09	1968-10-09 00:00:00	1968-10-09	38000177		0	0	13		0	0	0	351041	0	834061	19133873		
158752	3494	40213296	2003-05-08	2003-05-08 00:00:00	2003-05-08	2003-05-08 00:00:00	2003-05-08	581452		0	0	0		0	0	0	231791	0	52	40213296		
137538	3019	40213227	1999-07-07	1999-07-07 00:00:00	1999-07-07	1999-07-07 00:00:00	1999-07-07	581452		0	0	0		0	0	0	201326	0	113	40213227		
164921	3626	40213227	1996-05-25	1996-05-25 00:00:00	1996-05-25	1996-05-25 00:00:00	1996-05-25	581452		0	0	0		0	0	0	241167	0	113	40213227		
119626	2630	40213296	2001-12-30	2001-12-30 00:00:00	2001-12-30	2001-12-30 00:00:00	2001-12-30	581452		0	0	0		0	0	0	174006	0	52	40213296		
4154	90	40213160	1961-05-30	1961-05-30 00:00:00	1961-05-30	1961-05-30 00:00:00	1961-05-30	581452		0	0	0		0	0	0	6007	0	10	40213160		
190893	4194	40213227	2017-07-10	2017-07-10 00:00:00	2017-07-10	2017-07-10 00:00:00	2017-07-10	581452		0	0	0		0	0	0	278383	0	113	40213227		
199988	4392	40213160	1980-04-11	1980-04-11 00:00:00	1980-04-11	1980-04-11 00:00:00	1980-04-11	581452		0	0	0		0	0	0	292076	0	10	40213160		
38318	836	40213314	1978-12-10	1978-12-10 00:00:00	1978-12-10	1978-12-10 00:00:00	1978-12-10	581452		0	0	0		0	0	0	55316	0	49	40213314		
116659	2563	40213227	2003-03-02	2003-03-02 00:00:00	2003-03-02	2003-03-02 00:00:00	2003-03-02	581452		0	0	0		0	0	0	169772	0	113	40213227		
38907	3215	40229134	2000-03-21	2000-03-21 00:00:00	2000-03-28	2000-03-28 00:00:00	2000-03-28	38000177		0	0	7		0	0	0	213670	0	1043400	40229134		
210949	4626	40213314	1977-10-10	1977-10-10 00:00:00	1977-10-10	1977-10-10 00:00:00	1977-10-10	581452		0	0	0		0	0	0	308256	0	49	40213314		
153927	3389	40213160	1958-12-08	1958-12-08 00:00:00	1958-12-08	1958-12-08 00:00:00	1958-12-08	581452		0	0	0		0	0	0	224807	0	10	40213160		
100708	2206	40213160	1972-08-11	1972-08-11 00:00:00	1972-08-11	1972-08-11 00:00:00	1972-08-11	581452		0	0	0		0	0	0	147016	0	10	40213160		
38140	3157	920300	2008-07-25	2008-07-25 00:00:00	2008-08-01	2008-08-01 00:00:00	2008-08-01	38000177		0	0	7		0	0	0	209837	0	311989	920300		
126418	2781	40213306	2002-10-11	2002-10-11 00:00:00	2002-10-11	2002-10-11 00:00:00	2002-10-11	581452		0	0	0		0	0	0	184301	0	43	40213306		
14194	1189	1713671	2012-11-07	2012-11-07 00:00:00	2012-11-28	2012-11-28 00:00:00	2012-11-28	38000177		0	0	21		0	0	0	78354	0	562251	1713671		
46516	3852	19133905	1993-04-17	1993-04-17 00:00:00	1993-04-30	1993-04-30 00:00:00	1993-04-30	38000177		0	0	13		0	0	0	255753	0	834102	19133905		
14385	1208	1127433	1961-12-21	1961-12-21 00:00:00	1962-02-19	1962-02-19 00:00:00	1962-02-19	38000177		0	0	60		0	0	0	79376	0	313782	1127433		
29116	2412	1127433	1982-11-16	1982-11-16 00:00:00	1982-12-14	1982-12-14 00:00:00	1982-12-14	38000177		0	0	28		0	0	0	160095	0	313782	1127433		
51822	4308	19059056	1913-10-23	1913-10-23 00:00:00	1913-11-06	1913-11-06 00:00:00	1913-11-06	38000177		0	0	14		0	0	0	285816	0	243670	19059056		
227290	4990	40213160	1962-10-03	1962-10-03 00:00:00	1962-10-03	1962-10-03 00:00:00	1962-10-03	581452		0	0	0		0	0	0	331925	0	10	40213160		
155884	3431	40213160	1963-01-16	1963-01-16 00:00:00	1963-01-16	1963-01-16 00:00:00	1963-01-16	581452		0	0	0		0	0	0	227406	0	10	40213160		
178041	3913	40213160	1967-03-09	1967-03-09 00:00:00	1967-03-09	1967-03-09 00:00:00	1967-03-09	581452		0	0	0		0	0	0	260200	0	10	40213160		
39819	3294	1115171	2017-08-20	2017-08-20 00:00:00	2017-09-19	2017-09-19 00:00:00	2017-09-19	38000177		0	0	30		0	0	0	218853	0	849574	1115171		
99967	2190	40213201	2016-08-08	2016-08-08 00:00:00	2016-08-08	2016-08-08 00:00:00	2016-08-08	581452		0	0	0		0	0	0	146078	0	33	40213201		
86776	1903	40213260	2012-06-19	2012-06-19 00:00:00	2012-06-19	2012-06-19 00:00:00	2012-06-19	581452		0	0	0		0	0	0	126703	0	121	40213260		
140754	3090	40213160	1966-01-10	1966-01-10 00:00:00	1966-01-10	1966-01-10 00:00:00	1966-01-10	581452		0	0	0		0	0	0	205736	0	10	40213160		
17421	1442	1127433	2005-03-11	2005-03-11 00:00:00	2005-03-18	2005-03-18 00:00:00	2005-03-18	38000177		0	0	7		0	0	0	96140	0	313782	1127433		
25195	2075	40229134	2019-04-03	2019-04-03 00:00:00	2019-04-10	2019-04-10 00:00:00	2019-04-10	38000177		0	0	7		0	0	0	138032	0	1043400	40229134		
213281	4676	40213306	2002-02-14	2002-02-14 00:00:00	2002-02-14	2002-02-14 00:00:00	2002-02-14	581452		0	0	0		0	0	0	311596	0	43	40213306		
80949	1770	40213227	2001-02-04	2001-02-04 00:00:00	2001-02-04	2001-02-04 00:00:00	2001-02-04	581452		0	0	0		0	0	0	118381	0	113	40213227		
8243	687	19112599	1969-02-10	1969-02-10 00:00:00	1969-02-10	1969-02-10 00:00:00	\N	38000177		0	0	0		0	0	0	45510	0	477045	19112599		
180457	3966	40213260	2017-12-30	2017-12-30 00:00:00	2017-12-30	2017-12-30 00:00:00	2017-12-30	581452		0	0	0		0	0	0	263668	0	121	40213260		
133276	2926	40213314	1982-11-26	1982-11-26 00:00:00	1982-11-26	1982-11-26 00:00:00	1982-11-26	581452		0	0	0		0	0	0	195186	0	49	40213314		
112410	2469	40213160	1971-11-07	1971-11-07 00:00:00	1971-11-07	1971-11-07 00:00:00	1971-11-07	581452		0	0	0		0	0	0	163737	0	10	40213160		
40059	3314	920300	2009-10-11	2009-10-11 00:00:00	2009-10-18	2009-10-18 00:00:00	2009-10-18	38000177		0	0	7		0	0	0	220093	0	311989	920300		
75854	1657	40213201	2010-03-31	2010-03-31 00:00:00	2010-03-31	2010-03-31 00:00:00	2010-03-31	581452		0	0	0		0	0	0	111194	0	33	40213201		
63510	5277	1127433	1970-02-17	1970-02-17 00:00:00	1970-03-03	1970-03-03 00:00:00	1970-03-03	38000177		0	0	14		0	0	0	350959	0	313782	1127433		
158759	3494	40213260	2010-08-05	2010-08-05 00:00:00	2010-08-05	2010-08-05 00:00:00	2010-08-05	581452		0	0	0		0	0	0	231764	0	121	40213260		
137541	3019	40213160	1982-04-14	1982-04-14 00:00:00	1982-04-14	1982-04-14 00:00:00	1982-04-14	581452		0	0	0		0	0	0	201360	0	10	40213160		
164922	3626	40213306	1996-05-25	1996-05-25 00:00:00	1996-05-25	1996-05-25 00:00:00	1996-05-25	581452		0	0	0		0	0	0	241167	0	43	40213306		
119631	2630	40213160	1964-11-29	1964-11-29 00:00:00	1964-11-29	1964-11-29 00:00:00	1964-11-29	581452		0	0	0		0	0	0	173966	0	10	40213160		
4157	90	40213160	1966-02-01	1966-02-01 00:00:00	1966-02-01	1966-02-01 00:00:00	1966-02-01	581452		0	0	0		0	0	0	6034	0	10	40213160		
190894	4194	40213296	2017-07-10	2017-07-10 00:00:00	2017-07-10	2017-07-10 00:00:00	2017-07-10	581452		0	0	0		0	0	0	278383	0	52	40213296		
199999	4392	40213314	1980-01-11	1980-01-11 00:00:00	1980-01-11	1980-01-11 00:00:00	1980-01-11	581452		0	0	0		0	0	0	292031	0	49	40213314		
38320	836	40213314	1979-11-11	1979-11-11 00:00:00	1979-11-11	1979-11-11 00:00:00	1979-11-11	581452		0	0	0		0	0	0	55289	0	49	40213314		
116661	2563	40213160	1970-09-27	1970-09-27 00:00:00	1970-09-27	1970-09-27 00:00:00	1970-09-27	581452		0	0	0		0	0	0	169798	0	10	40213160		
38908	3215	1594382	2002-10-26	2002-10-26 00:00:00	2002-10-26	2002-10-26 00:00:00	\N	38000177		0	0	0		0	0	0	213667	0	1870230	1594382		
210951	4626	40213160	1976-07-12	1976-07-12 00:00:00	1976-07-12	1976-07-12 00:00:00	1976-07-12	581452		0	0	0		0	0	0	308198	0	10	40213160		
153932	3389	40213296	1998-09-07	1998-09-07 00:00:00	1998-09-07	1998-09-07 00:00:00	1998-09-07	581452		0	0	0		0	0	0	224803	0	52	40213296		
100710	2206	40213227	2014-05-16	2014-05-16 00:00:00	2014-05-16	2014-05-16 00:00:00	2014-05-16	581452		0	0	0		0	0	0	147029	0	113	40213227		
38141	3157	40236824	2008-07-25	2008-07-25 00:00:00	2008-08-01	2008-08-01 00:00:00	2008-08-01	38000177		0	0	7		0	0	0	209837	0	1094107	40236824		
126421	2781	40213251	1985-03-08	1985-03-08 00:00:00	1985-03-08	1985-03-08 00:00:00	1985-03-08	581452		0	0	0		0	0	0	184327	0	21	40213251		
14195	1189	19133905	2010-11-17	2010-11-17 00:00:00	2010-11-24	2010-11-24 00:00:00	2010-11-24	38000177		0	0	7		0	0	0	78306	0	834102	19133905		
46517	3852	1127433	2003-09-19	2003-09-19 00:00:00	2003-10-10	2003-10-10 00:00:00	2003-10-10	38000177		0	0	21		0	0	0	255633	0	313782	1127433		
14386	1208	40162522	1961-12-21	1961-12-21 00:00:00	1961-12-21	1961-12-21 00:00:00	\N	38000177		0	0	0		0	0	0	79376	0	857005	40162522		
29117	2412	19059056	1952-06-05	1952-06-05 00:00:00	1952-06-26	1952-06-26 00:00:00	1952-06-26	38000177		0	0	21		0	0	0	160094	0	243670	19059056		
51823	4308	40229134	1992-08-29	1992-08-29 00:00:00	1992-09-05	1992-09-05 00:00:00	1992-09-05	38000177		0	0	7		0	0	0	285814	0	1043400	40229134		
227293	4990	40213260	2012-01-25	2012-01-25 00:00:00	2012-01-25	2012-01-25 00:00:00	2012-01-25	581452		0	0	0		0	0	0	331922	0	121	40213260		
155887	3431	40213160	1963-03-20	1963-03-20 00:00:00	1963-03-20	1963-03-20 00:00:00	1963-03-20	581452		0	0	0		0	0	0	227461	0	10	40213160		
178045	3913	40213260	2013-08-01	2013-08-01 00:00:00	2013-08-01	2013-08-01 00:00:00	2013-08-01	581452		0	0	0		0	0	0	260209	0	121	40213260		
39820	3294	40162522	2017-08-20	2017-08-20 00:00:00	2017-08-20	2017-08-20 00:00:00	\N	38000177		0	0	0		0	0	0	218853	0	857005	40162522		
99972	2190	40213227	1992-05-18	1992-05-18 00:00:00	1992-05-18	1992-05-18 00:00:00	1992-05-18	581452		0	0	0		0	0	0	146057	0	113	40213227		
86779	1903	40213296	2002-06-25	2002-06-25 00:00:00	2002-06-25	2002-06-25 00:00:00	2002-06-25	581452		0	0	0		0	0	0	126701	0	52	40213296		
140758	3090	40213227	1992-05-11	1992-05-11 00:00:00	1992-05-11	1992-05-11 00:00:00	1992-05-11	581452		0	0	0		0	0	0	205739	0	113	40213227		
17422	1442	40236824	1974-03-11	1974-03-11 00:00:00	1974-03-18	1974-03-18 00:00:00	1974-03-18	38000177		0	0	7		0	0	0	96135	0	1094107	40236824		
25196	2075	19078461	2012-06-01	2012-06-01 00:00:00	2012-06-29	2012-06-29 00:00:00	2012-06-29	38000177		0	0	28		0	0	0	138002	0	310965	19078461		
213285	4676	40213160	1980-04-10	1980-04-10 00:00:00	1980-04-10	1980-04-10 00:00:00	1980-04-10	581452		0	0	0		0	0	0	311615	0	10	40213160		
80950	1770	40213306	2001-02-04	2001-02-04 00:00:00	2001-02-04	2001-02-04 00:00:00	2001-02-04	581452		0	0	0		0	0	0	118381	0	43	40213306		
8244	687	19078461	1993-04-04	1993-04-04 00:00:00	1993-04-18	1993-04-18 00:00:00	1993-04-18	38000177		0	0	14		0	0	0	45492	0	310965	19078461		
180462	3966	40213227	1998-12-05	1998-12-05 00:00:00	1998-12-05	1998-12-05 00:00:00	1998-12-05	581452		0	0	0		0	0	0	263670	0	113	40213227		
133279	2926	40213314	1982-02-26	1982-02-26 00:00:00	1982-02-26	1982-02-26 00:00:00	1982-02-26	581452		0	0	0		0	0	0	195185	0	49	40213314		
133320	2927	40213227	2013-09-06	2013-09-06 00:00:00	2013-09-06	2013-09-06 00:00:00	2013-09-06	581452		0	0	0		0	0	0	195225	0	113	40213227		
40061	3314	19006318	1964-01-30	1964-01-30 00:00:00	1964-02-13	1964-02-13 00:00:00	1964-02-13	38000177		0	0	14		0	0	0	220090	0	105078	19006318		
75857	1657	40213198	2010-03-31	2010-03-31 00:00:00	2010-03-31	2010-03-31 00:00:00	2010-03-31	581452		0	0	0		0	0	0	111194	0	133	40213198		
63511	5277	1713671	1963-12-06	1963-12-06 00:00:00	1963-12-13	1963-12-13 00:00:00	1963-12-13	38000177		0	0	7		0	0	0	350972	0	562251	1713671		
158761	3495	40213306	1987-08-26	1987-08-26 00:00:00	1987-08-26	1987-08-26 00:00:00	1987-08-26	581452		0	0	0		0	0	0	231858	0	43	40213306		
137550	3019	40213314	1977-08-10	1977-08-10 00:00:00	1977-08-10	1977-08-10 00:00:00	1977-08-10	581452		0	0	0		0	0	0	201355	0	49	40213314		
164923	3626	40213227	2016-04-30	2016-04-30 00:00:00	2016-04-30	2016-04-30 00:00:00	2016-04-30	581452		0	0	0		0	0	0	241163	0	113	40213227		
119637	2630	40213160	1960-05-29	1960-05-29 00:00:00	1960-05-29	1960-05-29 00:00:00	1960-05-29	581452		0	0	0		0	0	0	173938	0	10	40213160		
4163	90	40213296	2001-07-10	2001-07-10 00:00:00	2001-07-10	2001-07-10 00:00:00	2001-07-10	581452		0	0	0		0	0	0	6001	0	52	40213296		
190898	4194	40213227	2007-07-09	2007-07-09 00:00:00	2007-07-09	2007-07-09 00:00:00	2007-07-09	581452		0	0	0		0	0	0	278397	0	113	40213227		
200000	4392	40213160	1980-01-11	1980-01-11 00:00:00	1980-01-11	1980-01-11 00:00:00	1980-01-11	581452		0	0	0		0	0	0	292031	0	10	40213160		
38325	836	40213314	1979-02-11	1979-02-11 00:00:00	1979-02-11	1979-02-11 00:00:00	1979-02-11	581452		0	0	0		0	0	0	55288	0	49	40213314		
116672	2564	40213160	1981-08-01	1981-08-01 00:00:00	1981-08-01	1981-08-01 00:00:00	1981-08-01	581452		0	0	0		0	0	0	169857	0	10	40213160		
38909	3215	40223834	2002-10-26	2002-10-26 00:00:00	2002-10-26	2002-10-26 00:00:00	\N	38000177		0	0	0		0	0	0	213667	0	997501	40223834		
210954	4626	40213296	2017-11-13	2017-11-13 00:00:00	2017-11-13	2017-11-13 00:00:00	2017-11-13	581452		0	0	0		0	0	0	308151	0	52	40213296		
153934	3389	40213227	1992-11-16	1992-11-16 00:00:00	1992-11-16	1992-11-16 00:00:00	1992-11-16	581452		0	0	0		0	0	0	224769	0	113	40213227		
100711	2206	40213296	2014-05-16	2014-05-16 00:00:00	2014-05-16	2014-05-16 00:00:00	2014-05-16	581452		0	0	0		0	0	0	147029	0	52	40213296		
38142	3157	1124300	1986-05-12	1986-05-12 00:00:00	1986-05-12	1986-05-12 00:00:00	\N	38000177		0	0	0		0	0	0	209846	0	00781178901	45011828		
126427	2781	40213160	1985-03-08	1985-03-08 00:00:00	1985-03-08	1985-03-08 00:00:00	1985-03-08	581452		0	0	0		0	0	0	184327	0	10	40213160		
14196	1189	19128065	1977-11-28	1977-11-28 00:00:00	1978-11-23	1978-11-23 00:00:00	1978-11-23	38000177		0	0	360		0	0	0	78307	0	749882	19128065		
46518	3852	1118084	1990-03-17	1990-03-17 00:00:00	1990-03-17	1990-03-17 00:00:00	\N	38000177		0	0	0		0	0	0	255651	0	00025152531	44923712		
14387	1208	1713671	1991-10-25	1991-10-25 00:00:00	1991-11-01	1991-11-01 00:00:00	1991-11-01	38000177		0	0	7		0	0	0	79344	0	562251	1713671		
29118	2412	1713671	1970-07-23	1970-07-23 00:00:00	1970-08-13	1970-08-13 00:00:00	1970-08-13	38000177		0	0	21		0	0	0	160076	0	562251	1713671		
51824	4308	1127433	1973-01-22	1973-01-22 00:00:00	1973-01-29	1973-01-29 00:00:00	1973-01-29	38000177		0	0	7		0	0	0	285833	0	313782	1127433		
227301	4991	40213160	1971-10-16	1971-10-16 00:00:00	1971-10-16	1971-10-16 00:00:00	1971-10-16	581452		0	0	0		0	0	0	332062	0	10	40213160		
155891	3431	40213160	1963-06-19	1963-06-19 00:00:00	1963-06-19	1963-06-19 00:00:00	1963-06-19	581452		0	0	0		0	0	0	227432	0	10	40213160		
63971	5314	1127433	1962-08-03	1962-08-03 00:00:00	1962-08-10	1962-08-10 00:00:00	1962-08-10	38000177		0	0	7		0	0	0	353395	0	313782	1127433		
39821	3294	1127433	2008-09-09	2008-09-09 00:00:00	2008-09-16	2008-09-16 00:00:00	2008-09-16	38000177		0	0	7		0	0	0	218822	0	313782	1127433		
99977	2190	40213227	2001-05-14	2001-05-14 00:00:00	2001-05-14	2001-05-14 00:00:00	2001-05-14	581452		0	0	0		0	0	0	146073	0	113	40213227		
86789	1903	40213227	2004-06-29	2004-06-29 00:00:00	2004-06-29	2004-06-29 00:00:00	2004-06-29	581452		0	0	0		0	0	0	126677	0	113	40213227		
140761	3090	40213160	1961-05-01	1961-05-01 00:00:00	1961-05-01	1961-05-01 00:00:00	1961-05-01	581452		0	0	0		0	0	0	205760	0	10	40213160		
17423	1442	920300	1974-03-11	1974-03-11 00:00:00	1974-03-18	1974-03-18 00:00:00	1974-03-18	38000177		0	0	7		0	0	0	96135	0	311989	920300		
25197	2075	1127433	1993-05-08	1993-05-08 00:00:00	1993-05-22	1993-05-22 00:00:00	1993-05-22	38000177		0	0	14		0	0	0	138107	0	313782	1127433		
223810	4913	40213306	1991-06-26	1991-06-26 00:00:00	1991-06-26	1991-06-26 00:00:00	1991-06-26	581452		0	0	0		0	0	0	326548	0	43	40213306		
80952	1770	40213314	1978-09-17	1978-09-17 00:00:00	1978-09-17	1978-09-17 00:00:00	1978-09-17	581452		0	0	0		0	0	0	118354	0	49	40213314		
8245	687	19128065	1988-12-06	1988-12-06 00:00:00	1989-12-01	1989-12-01 00:00:00	1989-12-01	38000177		0	0	360		0	0	0	45524	0	749882	19128065		
180477	3967	40213160	1965-04-11	1965-04-11 00:00:00	1965-04-11	1965-04-11 00:00:00	1965-04-11	581452		0	0	0		0	0	0	263728	0	10	40213160		
133280	2926	40213160	1982-02-26	1982-02-26 00:00:00	1982-02-26	1982-02-26 00:00:00	1982-02-26	581452		0	0	0		0	0	0	195185	0	10	40213160		
133336	2927	40213227	2003-06-27	2003-06-27 00:00:00	2003-06-27	2003-06-27 00:00:00	2003-06-27	581452		0	0	0		0	0	0	195222	0	113	40213227		
40062	3314	1127078	1964-01-30	1964-01-30 00:00:00	1964-02-13	1964-02-13 00:00:00	1964-02-13	38000177		0	0	14		0	0	0	220090	0	282464	1127078		
75862	1657	40213227	2005-03-02	2005-03-02 00:00:00	2005-03-02	2005-03-02 00:00:00	2005-03-02	581452		0	0	0		0	0	0	111170	0	113	40213227		
63512	5277	1713671	1982-08-09	1982-08-09 00:00:00	1982-08-30	1982-08-30 00:00:00	1982-08-30	38000177		0	0	21		0	0	0	350960	0	562251	1713671		
158762	3495	40213260	2015-11-04	2015-11-04 00:00:00	2015-11-04	2015-11-04 00:00:00	2015-11-04	581452		0	0	0		0	0	0	231844	0	121	40213260		
137551	3019	40213160	1977-08-10	1977-08-10 00:00:00	1977-08-10	1977-08-10 00:00:00	1977-08-10	581452		0	0	0		0	0	0	201355	0	10	40213160		
164924	3626	40213296	2016-04-30	2016-04-30 00:00:00	2016-04-30	2016-04-30 00:00:00	2016-04-30	581452		0	0	0		0	0	0	241163	0	52	40213296		
119641	2630	40213160	1960-03-27	1960-03-27 00:00:00	1960-03-27	1960-03-27 00:00:00	1960-03-27	581452		0	0	0		0	0	0	174022	0	10	40213160		
4166	90	40213296	2003-07-15	2003-07-15 00:00:00	2003-07-15	2003-07-15 00:00:00	2003-07-15	581452		0	0	0		0	0	0	6038	0	52	40213296		
190901	4194	40213314	1977-04-03	1977-04-03 00:00:00	1977-04-03	1977-04-03 00:00:00	1977-04-03	581452		0	0	0		0	0	0	278385	0	49	40213314		
200004	4392	40213314	1980-10-10	1980-10-10 00:00:00	1980-10-10	1980-10-10 00:00:00	1980-10-10	581452		0	0	0		0	0	0	292032	0	49	40213314		
38326	836	40213160	1979-02-11	1979-02-11 00:00:00	1979-02-11	1979-02-11 00:00:00	1979-02-11	581452		0	0	0		0	0	0	55288	0	10	40213160		
151899	3343	40213314	1977-08-14	1977-08-14 00:00:00	1977-08-14	1977-08-14 00:00:00	1977-08-14	581452		0	0	0		0	0	0	221875	0	49	40213314		
38910	3215	1127433	2016-07-21	2016-07-21 00:00:00	2016-08-04	2016-08-04 00:00:00	2016-08-04	38000177		0	0	14		0	0	0	213581	0	313782	1127433		
210956	4626	40213227	2017-11-13	2017-11-13 00:00:00	2017-11-13	2017-11-13 00:00:00	2017-11-13	581452		0	0	0		0	0	0	308151	0	113	40213227		
153935	3389	40213296	2000-09-11	2000-09-11 00:00:00	2000-09-11	2000-09-11 00:00:00	2000-09-11	581452		0	0	0		0	0	0	224757	0	52	40213296		
100712	2206	40213296	2012-05-11	2012-05-11 00:00:00	2012-05-11	2012-05-11 00:00:00	2012-05-11	581452		0	0	0		0	0	0	147037	0	52	40213296		
38143	3157	19078461	2011-02-12	2011-02-12 00:00:00	2011-03-05	2011-03-05 00:00:00	2011-03-05	38000177		0	0	21		0	0	0	209881	0	310965	19078461		
126428	2781	40213251	1984-03-02	1984-03-02 00:00:00	1984-03-02	1984-03-02 00:00:00	1984-03-02	581452		0	0	0		0	0	0	184336	0	21	40213251		
14221	1193	19059056	1951-11-14	1951-11-14 00:00:00	1952-01-13	1952-01-13 00:00:00	1952-01-13	38000177		0	0	60		0	0	0	78617	0	243670	19059056		
46544	3856	19128065	1992-09-03	1992-09-03 00:00:00	1993-08-29	1993-08-29 00:00:00	1993-08-29	38000177		0	0	360		0	0	0	255909	0	749882	19128065		
14388	1208	19059056	1941-03-20	1941-03-20 00:00:00	1941-04-03	1941-04-03 00:00:00	1941-04-03	38000177		0	0	14		0	0	0	79337	0	243670	19059056		
29119	2412	1713671	2018-10-15	2018-10-15 00:00:00	2018-10-22	2018-10-22 00:00:00	2018-10-22	38000177		0	0	7		0	0	0	160035	0	562251	1713671		
51825	4308	19059056	1921-10-03	1921-10-03 00:00:00	1921-10-24	1921-10-24 00:00:00	1921-10-24	38000177		0	0	21		0	0	0	285771	0	243670	19059056		
227304	4991	40213160	1972-03-18	1972-03-18 00:00:00	1972-03-18	1972-03-18 00:00:00	1972-03-18	581452		0	0	0		0	0	0	332063	0	10	40213160		
155896	3431	40213227	1996-09-11	1996-09-11 00:00:00	1996-09-11	1996-09-11 00:00:00	1996-09-11	581452		0	0	0		0	0	0	227410	0	113	40213227		
63972	5314	40229134	1959-05-12	1959-05-12 00:00:00	1959-05-19	1959-05-19 00:00:00	1959-05-19	38000177		0	0	7		0	0	0	353393	0	1043400	40229134		
39822	3294	19133905	1993-09-29	1993-09-29 00:00:00	1993-10-09	1993-10-09 00:00:00	1993-10-09	38000177		0	0	10		0	0	0	218832	0	834102	19133905		
99994	2190	40213227	2011-07-11	2011-07-11 00:00:00	2011-07-11	2011-07-11 00:00:00	2011-07-11	581452		0	0	0		0	0	0	146023	0	113	40213227		
86790	1903	40213296	2004-06-29	2004-06-29 00:00:00	2004-06-29	2004-06-29 00:00:00	2004-06-29	581452		0	0	0		0	0	0	126677	0	52	40213296		
140768	3090	40213160	1961-07-03	1961-07-03 00:00:00	1961-07-03	1961-07-03 00:00:00	1961-07-03	581452		0	0	0		0	0	0	205710	0	10	40213160		
17424	1442	40174880	2016-01-19	2016-01-19 00:00:00	2016-01-19	2016-01-19 00:00:00	\N	38000177		0	0	0		0	0	0	96178	0	966222	40174880		
25198	2075	19078461	2019-04-15	2019-04-15 00:00:00	2019-04-15	2019-04-15 00:00:00	\N	38000177		0	0	0		0	0	0	138004	0	310965	19078461		
223813	4913	40213227	2012-02-01	2012-02-01 00:00:00	2012-02-01	2012-02-01 00:00:00	2012-02-01	581452		0	0	0		0	0	0	326554	0	113	40213227		
80953	1770	40213160	1978-09-17	1978-09-17 00:00:00	1978-09-17	1978-09-17 00:00:00	1978-09-17	581452		0	0	0		0	0	0	118354	0	10	40213160		
8248	687	19078461	2013-09-02	2013-09-02 00:00:00	2013-09-30	2013-09-30 00:00:00	2013-09-30	38000177		0	0	28		0	0	0	45497	0	310965	19078461		
227093	4987	40213306	1981-11-24	1981-11-24 00:00:00	1981-11-24	1981-11-24 00:00:00	1981-11-24	581452		0	0	0		0	0	0	331722	0	43	40213306		
133294	2927	40213198	2010-08-20	2010-08-20 00:00:00	2010-08-20	2010-08-20 00:00:00	2010-08-20	581452		0	0	0		0	0	0	195238	0	133	40213198		
133344	2927	40213201	2008-08-08	2008-08-08 00:00:00	2008-08-08	2008-08-08 00:00:00	2008-08-08	581452		0	0	0		0	0	0	195237	0	33	40213201		
40063	3314	1713671	2006-11-15	2006-11-15 00:00:00	2006-11-22	2006-11-22 00:00:00	2006-11-22	38000177		0	0	7		0	0	0	220092	0	562251	1713671		
191675	4212	40213306	1993-10-15	1993-10-15 00:00:00	1993-10-15	1993-10-15 00:00:00	1993-10-15	581452		0	0	0		0	0	0	279673	0	43	40213306		
63513	5277	1127433	1998-08-05	1998-08-05 00:00:00	1998-08-12	1998-08-12 00:00:00	1998-08-12	38000177		0	0	7		0	0	0	351032	0	313782	1127433		
158765	3495	40213160	1965-09-22	1965-09-22 00:00:00	1965-09-22	1965-09-22 00:00:00	1965-09-22	581452		0	0	0		0	0	0	231808	0	10	40213160		
137553	3019	40213251	1984-04-25	1984-04-25 00:00:00	1984-04-25	1984-04-25 00:00:00	1984-04-25	581452		0	0	0		0	0	0	201317	0	21	40213251		
164928	3626	40213314	1977-02-26	1977-02-26 00:00:00	1977-02-26	1977-02-26 00:00:00	1977-02-26	581452		0	0	0		0	0	0	241154	0	49	40213314		
119648	2630	40213160	1960-08-28	1960-08-28 00:00:00	1960-08-28	1960-08-28 00:00:00	1960-08-28	581452		0	0	0		0	0	0	174023	0	10	40213160		
4168	90	40213227	2003-07-15	2003-07-15 00:00:00	2003-07-15	2003-07-15 00:00:00	2003-07-15	581452		0	0	0		0	0	0	6038	0	113	40213227		
190904	4194	40213306	1998-06-29	1998-06-29 00:00:00	1998-06-29	1998-06-29 00:00:00	1998-06-29	581452		0	0	0		0	0	0	278394	0	43	40213306		
200007	4392	40213251	1984-07-13	1984-07-13 00:00:00	1984-07-13	1984-07-13 00:00:00	1984-07-13	581452		0	0	0		0	0	0	292034	0	21	40213251		
38328	836	40213306	2001-02-04	2001-02-04 00:00:00	2001-02-04	2001-02-04 00:00:00	2001-02-04	581452		0	0	0		0	0	0	55348	0	43	40213306		
151903	3343	40213160	1976-09-12	1976-09-12 00:00:00	1976-09-12	1976-09-12 00:00:00	1976-09-12	581452		0	0	0		0	0	0	221766	0	10	40213160		
38911	3215	19078461	2003-10-17	2003-10-17 00:00:00	2003-10-31	2003-10-31 00:00:00	2003-10-31	38000177		0	0	14		0	0	0	213685	0	310965	19078461		
210958	4626	40213314	1977-04-11	1977-04-11 00:00:00	1977-04-11	1977-04-11 00:00:00	1977-04-11	581452		0	0	0		0	0	0	308199	0	49	40213314		
153937	3389	40213227	2000-09-11	2000-09-11 00:00:00	2000-09-11	2000-09-11 00:00:00	2000-09-11	581452		0	0	0		0	0	0	224757	0	113	40213227		
100717	2207	40213227	2013-02-21	2013-02-21 00:00:00	2013-02-21	2013-02-21 00:00:00	2013-02-21	581452		0	0	0		0	0	0	147077	0	113	40213227		
38144	3157	19133873	1965-12-20	1965-12-20 00:00:00	1965-12-28	1965-12-28 00:00:00	1965-12-28	38000177		0	0	8		0	0	0	209814	0	834061	19133873		
126432	2781	40213314	1981-06-05	1981-06-05 00:00:00	1981-06-05	1981-06-05 00:00:00	1981-06-05	581452		0	0	0		0	0	0	184324	0	49	40213314		
14222	1193	1127433	2017-08-01	2017-08-01 00:00:00	2017-08-15	2017-08-15 00:00:00	2017-08-15	38000177		0	0	14		0	0	0	78628	0	313782	1127433		
46545	3856	1124300	2012-02-05	2012-02-05 00:00:00	2012-02-05	2012-02-05 00:00:00	\N	38000177		0	0	0		0	0	0	255947	0	00781178901	45011828		
14389	1208	19059056	1941-09-16	1941-09-16 00:00:00	1941-10-07	1941-10-07 00:00:00	1941-10-07	38000177		0	0	21		0	0	0	79375	0	243670	19059056		
29121	2412	1127433	2009-06-11	2009-06-11 00:00:00	2009-06-18	2009-06-18 00:00:00	2009-06-18	38000177		0	0	7		0	0	0	160097	0	313782	1127433		
51826	4308	19059056	1925-05-06	1925-05-06 00:00:00	1925-08-04	1925-08-04 00:00:00	1925-08-04	38000177		0	0	90		0	0	0	285772	0	243670	19059056		
227309	4991	40213227	2003-02-15	2003-02-15 00:00:00	2003-02-15	2003-02-15 00:00:00	2003-02-15	581452		0	0	0		0	0	0	332042	0	113	40213227		
141313	3103	40213314	1977-11-22	1977-11-22 00:00:00	1977-11-22	1977-11-22 00:00:00	1977-11-22	581452		0	0	0		0	0	0	206442	0	49	40213314		
63973	5314	1713671	1971-11-24	1971-11-24 00:00:00	1971-12-08	1971-12-08 00:00:00	1971-12-08	38000177		0	0	14		0	0	0	353397	0	562251	1713671		
39823	3294	1713671	1952-03-15	1952-03-15 00:00:00	1952-03-22	1952-03-22 00:00:00	1952-03-22	38000177		0	0	7		0	0	0	218805	0	562251	1713671		
238736	5240	40213227	2000-11-28	2000-11-28 00:00:00	2000-11-28	2000-11-28 00:00:00	2000-11-28	581452		0	0	0		0	0	0	348707	0	113	40213227		
86794	1903	40213227	1994-01-18	1994-01-18 00:00:00	1994-01-18	1994-01-18 00:00:00	1994-01-18	581452		0	0	0		0	0	0	126695	0	113	40213227		
170231	3743	40213160	1981-11-29	1981-11-29 00:00:00	1981-11-29	1981-11-29 00:00:00	1981-11-29	581452		0	0	0		0	0	0	248723	0	10	40213160		
17425	1442	1713671	1995-01-17	1995-01-17 00:00:00	1995-01-31	1995-01-31 00:00:00	1995-01-31	38000177		0	0	14		0	0	0	96148	0	562251	1713671		
25199	2075	40231925	2019-04-15	2019-04-15 00:00:00	2019-04-15	2019-04-15 00:00:00	\N	38000177		0	0	0		0	0	0	138004	0	1049221	40231925		
223815	4913	40213160	1970-01-21	1970-01-21 00:00:00	1970-01-21	1970-01-21 00:00:00	1970-01-21	581452		0	0	0		0	0	0	326503	0	10	40213160		
80954	1770	40213160	1983-03-20	1983-03-20 00:00:00	1983-03-20	1983-03-20 00:00:00	1983-03-20	581452		0	0	0		0	0	0	118388	0	10	40213160		
8249	687	46233988	1968-01-16	1968-01-16 00:00:00	1968-01-30	1968-01-30 00:00:00	1968-01-30	38000177		0	0	14		0	0	0	45534	0	1652673	46233988		
227107	4987	40213260	2010-02-16	2010-02-16 00:00:00	2010-02-16	2010-02-16 00:00:00	2010-02-16	581452		0	0	0		0	0	0	331748	0	121	40213260		
133300	2927	40213227	1993-04-30	1993-04-30 00:00:00	1993-04-30	1993-04-30 00:00:00	1993-04-30	581452		0	0	0		0	0	0	195290	0	113	40213227		
144637	3179	40213227	2001-05-12	2001-05-12 00:00:00	2001-05-12	2001-05-12 00:00:00	2001-05-12	581452		0	0	0		0	0	0	211525	0	113	40213227		
40064	3314	1118084	2003-07-20	2003-07-20 00:00:00	2003-07-20	2003-07-20 00:00:00	\N	38000177		0	0	0		0	0	0	220105	0	00025152531	44923712		
191677	4212	40213227	1993-10-15	1993-10-15 00:00:00	1993-10-15	1993-10-15 00:00:00	1993-10-15	581452		0	0	0		0	0	0	279673	0	113	40213227		
63514	5277	1127078	1963-11-24	1963-11-24 00:00:00	1963-12-08	1963-12-08 00:00:00	1963-12-08	38000177		0	0	14		0	0	0	350976	0	282464	1127078		
158766	3495	40213160	1965-11-24	1965-11-24 00:00:00	1965-11-24	1965-11-24 00:00:00	1965-11-24	581452		0	0	0		0	0	0	231849	0	10	40213160		
231418	5085	40213227	2007-11-22	2007-11-22 00:00:00	2007-11-22	2007-11-22 00:00:00	2007-11-22	581452		0	0	0		0	0	0	338135	0	113	40213227		
164936	3626	40213314	1978-02-25	1978-02-25 00:00:00	1978-02-25	1978-02-25 00:00:00	1978-02-25	581452		0	0	0		0	0	0	241129	0	49	40213314		
119651	2630	40213296	1999-12-26	1999-12-26 00:00:00	1999-12-26	1999-12-26 00:00:00	1999-12-26	581452		0	0	0		0	0	0	173973	0	52	40213296		
4172	90	40213260	2011-02-22	2011-02-22 00:00:00	2011-02-22	2011-02-22 00:00:00	2011-02-22	581452		0	0	0		0	0	0	6040	0	121	40213260		
190906	4194	40213227	1998-06-29	1998-06-29 00:00:00	1998-06-29	1998-06-29 00:00:00	1998-06-29	581452		0	0	0		0	0	0	278394	0	113	40213227		
200009	4392	40213160	1984-07-13	1984-07-13 00:00:00	1984-07-13	1984-07-13 00:00:00	1984-07-13	581452		0	0	0		0	0	0	292034	0	10	40213160		
38333	836	40213227	2000-11-05	2000-11-05 00:00:00	2000-11-05	2000-11-05 00:00:00	2000-11-05	581452		0	0	0		0	0	0	55350	0	113	40213227		
151906	3343	40213296	2016-08-07	2016-08-07 00:00:00	2016-08-07	2016-08-07 00:00:00	2016-08-07	581452		0	0	0		0	0	0	221710	0	52	40213296		
38912	3215	19074843	1980-06-02	1980-06-02 00:00:00	1980-06-16	1980-06-16 00:00:00	1980-06-16	38000177		0	0	14		0	0	0	213621	0	309045	19074843		
210962	4626	40213160	1980-10-13	1980-10-13 00:00:00	1980-10-13	1980-10-13 00:00:00	1980-10-13	581452		0	0	0		0	0	0	308257	0	10	40213160		
153940	3389	40213227	2009-09-07	2009-09-07 00:00:00	2009-09-07	2009-09-07 00:00:00	2009-09-07	581452		0	0	0		0	0	0	224815	0	113	40213227		
100719	2207	40213160	1981-01-01	1981-01-01 00:00:00	1981-01-01	1981-01-01 00:00:00	1981-01-01	581452		0	0	0		0	0	0	147090	0	10	40213160		
38145	3157	19006318	1955-07-01	1955-07-01 00:00:00	1955-07-15	1955-07-15 00:00:00	1955-07-15	38000177		0	0	14		0	0	0	209886	0	105078	19006318		
126441	2781	40213160	1980-09-05	1980-09-05 00:00:00	1980-09-05	1980-09-05 00:00:00	1980-09-05	581452		0	0	0		0	0	0	184323	0	10	40213160		
14223	1193	19059056	1965-05-12	1965-05-12 00:00:00	1965-05-26	1965-05-26 00:00:00	1965-05-26	38000177		0	0	14		0	0	0	78622	0	243670	19059056		
46546	3856	1127433	1984-06-18	1984-06-18 00:00:00	1984-06-25	1984-06-25 00:00:00	1984-06-25	38000177		0	0	7		0	0	0	255921	0	313782	1127433		
14390	1209	1127078	1981-11-07	1981-11-07 00:00:00	1981-11-21	1981-11-21 00:00:00	1981-11-21	38000177		0	0	14		0	0	0	79436	0	282464	1127078		
29122	2412	40229134	1985-10-20	1985-10-20 00:00:00	1985-10-27	1985-10-27 00:00:00	1985-10-27	38000177		0	0	7		0	0	0	160034	0	1043400	40229134		
51827	4308	1713671	1981-10-07	1981-10-07 00:00:00	1981-10-28	1981-10-28 00:00:00	1981-10-28	38000177		0	0	21		0	0	0	285824	0	562251	1713671		
227311	4991	40213227	1994-02-05	1994-02-05 00:00:00	1994-02-05	1994-02-05 00:00:00	1994-02-05	581452		0	0	0		0	0	0	332050	0	113	40213227		
141314	3103	40213160	1977-11-22	1977-11-22 00:00:00	1977-11-22	1977-11-22 00:00:00	1977-11-22	581452		0	0	0		0	0	0	206442	0	10	40213160		
63974	5314	19006318	1951-09-20	1951-09-20 00:00:00	1951-10-04	1951-10-04 00:00:00	1951-10-04	38000177		0	0	14		0	0	0	353413	0	105078	19006318		
39824	3295	1713671	1971-04-14	1971-04-14 00:00:00	1971-04-28	1971-04-28 00:00:00	1971-04-28	38000177		0	0	14		0	0	0	218967	0	562251	1713671		
238738	5240	40213227	2011-01-25	2011-01-25 00:00:00	2011-01-25	2011-01-25 00:00:00	2011-01-25	581452		0	0	0		0	0	0	348666	0	113	40213227		
86798	1903	40213160	1967-05-30	1967-05-30 00:00:00	1967-05-30	1967-05-30 00:00:00	1967-05-30	581452		0	0	0		0	0	0	126732	0	10	40213160		
170234	3743	40213227	2018-10-07	2018-10-07 00:00:00	2018-10-07	2018-10-07 00:00:00	2018-10-07	581452		0	0	0		0	0	0	\N	0	113	40213227		
17426	1443	1127433	1983-03-25	1983-03-25 00:00:00	1983-04-08	1983-04-08 00:00:00	1983-04-08	38000177		0	0	14		0	0	0	96201	0	313782	1127433		
25200	2075	1127433	2017-05-04	2017-05-04 00:00:00	2017-05-25	2017-05-25 00:00:00	2017-05-25	38000177		0	0	21		0	0	0	138003	0	313782	1127433		
223821	4913	40213260	2019-05-15	2019-05-15 00:00:00	2019-05-15	2019-05-15 00:00:00	2019-05-15	581452		0	0	0		0	0	0	326569	0	121	40213260		
80957	1770	40213251	1984-03-18	1984-03-18 00:00:00	1984-03-18	1984-03-18 00:00:00	1984-03-18	581452		0	0	0		0	0	0	\N	0	21	40213251		
8250	687	1127078	1968-01-16	1968-01-16 00:00:00	1968-01-30	1968-01-30 00:00:00	1968-01-30	38000177		0	0	14		0	0	0	45534	0	282464	1127078		
227111	4987	40213160	1960-05-31	1960-05-31 00:00:00	1960-05-31	1960-05-31 00:00:00	1960-05-31	581452		0	0	0		0	0	0	331714	0	10	40213160		
86950	1906	40213306	1981-10-04	1981-10-04 00:00:00	1981-10-04	1981-10-04 00:00:00	1981-10-04	581452		0	0	0		0	0	0	126898	0	43	40213306		
98279	2152	40213227	2013-03-23	2013-03-23 00:00:00	2013-03-23	2013-03-23 00:00:00	2013-03-23	581452		0	0	0		0	0	0	143402	0	113	40213227		
40065	3314	1127433	1986-08-05	1986-08-05 00:00:00	1986-08-12	1986-08-12 00:00:00	1986-08-12	38000177		0	0	7		0	0	0	220076	0	313782	1127433		
191681	4212	40213306	1991-11-29	1991-11-29 00:00:00	1991-11-29	1991-11-29 00:00:00	1991-11-29	581452		0	0	0		0	0	0	279675	0	43	40213306		
63515	5277	1713671	2009-08-07	2009-08-07 00:00:00	2009-08-21	2009-08-21 00:00:00	2009-08-21	38000177		0	0	14		0	0	0	351033	0	562251	1713671		
165175	3631	40213160	1975-05-08	1975-05-08 00:00:00	1975-05-08	1975-05-08 00:00:00	1975-05-08	581452		0	0	0		0	0	0	241596	0	10	40213160		
231420	5085	40213314	1977-02-17	1977-02-17 00:00:00	1977-02-17	1977-02-17 00:00:00	1977-02-17	581452		0	0	0		0	0	0	338117	0	49	40213314		
164938	3626	40213160	1974-06-29	1974-06-29 00:00:00	1974-06-29	1974-06-29 00:00:00	1974-06-29	581452		0	0	0		0	0	0	241127	0	10	40213160		
119655	2630	40213227	1994-09-11	1994-09-11 00:00:00	1994-09-11	1994-09-11 00:00:00	1994-09-11	581452		0	0	0		0	0	0	174004	0	113	40213227		
4173	90	40213160	1961-08-01	1961-08-01 00:00:00	1961-08-01	1961-08-01 00:00:00	1961-08-01	581452		0	0	0		0	0	0	6055	0	10	40213160		
201968	4435	40213160	1961-09-11	1961-09-11 00:00:00	1961-09-11	1961-09-11 00:00:00	1961-09-11	581452		0	0	0		0	0	0	294809	0	10	40213160		
200013	4392	40213314	1979-11-09	1979-11-09 00:00:00	1979-11-09	1979-11-09 00:00:00	1979-11-09	581452		0	0	0		0	0	0	292064	0	49	40213314		
38334	836	40213306	2000-11-05	2000-11-05 00:00:00	2000-11-05	2000-11-05 00:00:00	2000-11-05	581452		0	0	0		0	0	0	55350	0	43	40213306		
151909	3343	40213306	1999-05-09	1999-05-09 00:00:00	1999-05-09	1999-05-09 00:00:00	1999-05-09	581452		0	0	0		0	0	0	\N	0	43	40213306		
38913	3215	1127078	1980-06-02	1980-06-02 00:00:00	1980-06-16	1980-06-16 00:00:00	1980-06-16	38000177		0	0	14		0	0	0	213621	0	282464	1127078		
210965	4626	40213227	1997-12-22	1997-12-22 00:00:00	1997-12-22	1997-12-22 00:00:00	1997-12-22	581452		0	0	0		0	0	0	308149	0	113	40213227		
83478	1826	40213227	1999-04-20	1999-04-20 00:00:00	1999-04-20	1999-04-20 00:00:00	1999-04-20	581452		0	0	0		0	0	0	\N	0	113	40213227		
100722	2207	40213314	1981-07-02	1981-07-02 00:00:00	1981-07-02	1981-07-02 00:00:00	1981-07-02	581452		0	0	0		0	0	0	147087	0	49	40213314		
38146	3157	1127078	1955-07-01	1955-07-01 00:00:00	1955-07-15	1955-07-15 00:00:00	1955-07-15	38000177		0	0	14		0	0	0	209886	0	282464	1127078		
126442	2781	40213314	1980-09-05	1980-09-05 00:00:00	1980-09-05	1980-09-05 00:00:00	1980-09-05	581452		0	0	0		0	0	0	184323	0	49	40213314		
14224	1193	19059056	1984-10-27	1984-10-27 00:00:00	1984-12-01	1984-12-01 00:00:00	1984-12-01	38000177		0	0	35		0	0	0	78626	0	243670	19059056		
46547	3856	19128065	1989-09-19	1989-09-19 00:00:00	1990-09-14	1990-09-14 00:00:00	1990-09-14	38000177		0	0	360		0	0	0	255894	0	749882	19128065		
14391	1209	19073183	1981-11-07	1981-11-07 00:00:00	1981-11-21	1981-11-21 00:00:00	1981-11-21	38000177		0	0	14		0	0	0	79436	0	308182	19073183		
29123	2412	1118084	1994-12-01	1994-12-01 00:00:00	1994-12-01	1994-12-01 00:00:00	\N	38000177		0	0	0		0	0	0	160054	0	00025152531	44923712		
51828	4308	19059056	1912-10-20	1912-10-20 00:00:00	1912-11-03	1912-11-03 00:00:00	1912-11-03	38000177		0	0	14		0	0	0	285831	0	243670	19059056		
227312	4991	40213306	1994-02-05	1994-02-05 00:00:00	1994-02-05	1994-02-05 00:00:00	1994-02-05	581452		0	0	0		0	0	0	332050	0	43	40213306		
141350	3105	40213296	2010-02-01	2010-02-01 00:00:00	2010-02-01	2010-02-01 00:00:00	2010-02-01	581452		0	0	0		0	0	0	206519	0	52	40213296		
63975	5314	1127078	1951-09-20	1951-09-20 00:00:00	1951-10-04	1951-10-04 00:00:00	1951-10-04	38000177		0	0	14		0	0	0	353413	0	282464	1127078		
39825	3295	19078461	2009-02-23	2009-02-23 00:00:00	2009-03-25	2009-03-25 00:00:00	2009-03-25	38000177		0	0	30		0	0	0	218897	0	310965	19078461		
238743	5241	40213160	1962-09-04	1962-09-04 00:00:00	1962-09-04	1962-09-04 00:00:00	1962-09-04	581452		0	0	0		0	0	0	348761	0	10	40213160		
242020	5314	40213198	2016-03-18	2016-03-18 00:00:00	2016-03-18	2016-03-18 00:00:00	2016-03-18	581452		0	0	0		0	0	0	353406	0	133	40213198		
170235	3743	40213296	2018-10-07	2018-10-07 00:00:00	2018-10-07	2018-10-07 00:00:00	2018-10-07	581452		0	0	0		0	0	0	\N	0	52	40213296		
17427	1443	1124300	2014-05-31	2014-05-31 00:00:00	2014-05-31	2014-05-31 00:00:00	\N	38000177		0	0	0		0	0	0	96227	0	00781178901	45011828		
107199	2349	40213160	1977-03-20	1977-03-20 00:00:00	1977-03-20	1977-03-20 00:00:00	1977-03-20	581452		0	0	0		0	0	0	156371	0	10	40213160		
223827	4913	40213160	1969-08-20	1969-08-20 00:00:00	1969-08-20	1969-08-20 00:00:00	1969-08-20	581452		0	0	0		0	0	0	326502	0	10	40213160		
39484	862	40213296	2010-06-08	2010-06-08 00:00:00	2010-06-08	2010-06-08 00:00:00	2010-06-08	581452		0	0	0		0	0	0	57061	0	52	40213296		
203645	4471	40213296	2000-07-17	2000-07-17 00:00:00	2000-07-17	2000-07-17 00:00:00	2000-07-17	581452		0	0	0		0	0	0	297427	0	52	40213296		
227114	4987	40213296	1999-09-28	1999-09-28 00:00:00	1999-09-28	1999-09-28 00:00:00	1999-09-28	581452		0	0	0		0	0	0	331731	0	52	40213296		
86955	1906	40213160	1965-10-24	1965-10-24 00:00:00	1965-10-24	1965-10-24 00:00:00	1965-10-24	581452		0	0	0		0	0	0	126862	0	10	40213160		
98284	2152	40213201	1988-02-27	1988-02-27 00:00:00	1988-02-27	1988-02-27 00:00:00	1988-02-27	581452		0	0	0		0	0	0	143364	0	33	40213201		
40066	3314	40236824	2015-11-29	2015-11-29 00:00:00	2015-12-06	2015-12-06 00:00:00	2015-12-06	38000177		0	0	7		0	0	0	220089	0	1094107	40236824		
191691	4212	40213296	2009-11-06	2009-11-06 00:00:00	2009-11-06	2009-11-06 00:00:00	2009-11-06	581452		0	0	0		0	0	0	279637	0	52	40213296		
63516	5277	19059056	1956-07-28	1956-07-28 00:00:00	1956-08-11	1956-08-11 00:00:00	1956-08-11	38000177		0	0	14		0	0	0	351034	0	243670	19059056		
165182	3631	40213160	1975-08-07	1975-08-07 00:00:00	1975-08-07	1975-08-07 00:00:00	1975-08-07	581452		0	0	0		0	0	0	241624	0	10	40213160		
231421	5085	40213160	1977-02-17	1977-02-17 00:00:00	1977-02-17	1977-02-17 00:00:00	1977-02-17	581452		0	0	0		0	0	0	338117	0	10	40213160		
164941	3626	40213314	1977-08-27	1977-08-27 00:00:00	1977-08-27	1977-08-27 00:00:00	1977-08-27	581452		0	0	0		0	0	0	241143	0	49	40213314		
169660	3730	40213160	1955-06-09	1955-06-09 00:00:00	1955-06-09	1955-06-09 00:00:00	1955-06-09	581452		0	0	0		0	0	0	247835	0	10	40213160		
4176	90	40213306	1983-04-26	1983-04-26 00:00:00	1983-04-26	1983-04-26 00:00:00	1983-04-26	581452		0	0	0		0	0	0	6042	0	43	40213306		
201969	4435	40213260	2011-05-09	2011-05-09 00:00:00	2011-05-09	2011-05-09 00:00:00	2011-05-09	581452		0	0	0		0	0	0	294770	0	121	40213260		
200014	4392	40213160	1979-11-09	1979-11-09 00:00:00	1979-11-09	1979-11-09 00:00:00	1979-11-09	581452		0	0	0		0	0	0	292064	0	10	40213160		
38335	836	40213251	1984-08-19	1984-08-19 00:00:00	1984-08-19	1984-08-19 00:00:00	1984-08-19	581452		0	0	0		0	0	0	55319	0	21	40213251		
151910	3343	40213160	1976-11-14	1976-11-14 00:00:00	1976-11-14	1976-11-14 00:00:00	1976-11-14	581452		0	0	0		0	0	0	221790	0	10	40213160		
38914	3215	1127433	1997-10-24	1997-10-24 00:00:00	1997-10-31	1997-10-31 00:00:00	1997-10-31	38000177		0	0	7		0	0	0	213666	0	313782	1127433		
210966	4626	40213306	1997-12-22	1997-12-22 00:00:00	1997-12-22	1997-12-22 00:00:00	1997-12-22	581452		0	0	0		0	0	0	308149	0	43	40213306		
83496	1826	40213227	2009-04-07	2009-04-07 00:00:00	2009-04-07	2009-04-07 00:00:00	2009-04-07	581452		0	0	0		0	0	0	122096	0	113	40213227		
100736	2207	40213251	1985-04-04	1985-04-04 00:00:00	1985-04-04	1985-04-04 00:00:00	1985-04-04	581452		0	0	0		0	0	0	147069	0	21	40213251		
38147	3157	1115171	2000-08-17	2000-08-17 00:00:00	2000-09-07	2000-09-07 00:00:00	2000-09-07	38000177		0	0	21		0	0	0	209880	0	849574	1115171		
126448	2781	40213160	1980-07-04	1980-07-04 00:00:00	1980-07-04	1980-07-04 00:00:00	1980-07-04	581452		0	0	0		0	0	0	184333	0	10	40213160		
14225	1193	1127433	1979-12-05	1979-12-05 00:00:00	1979-12-12	1979-12-12 00:00:00	1979-12-12	38000177		0	0	7		0	0	0	78667	0	313782	1127433		
46548	3856	1127078	1976-01-04	1976-01-04 00:00:00	1976-01-18	1976-01-18 00:00:00	1976-01-18	38000177		0	0	14		0	0	0	255897	0	282464	1127078		
14392	1209	1127078	1978-07-16	1978-07-16 00:00:00	1978-07-30	1978-07-30 00:00:00	1978-07-30	38000177		0	0	14		0	0	0	79424	0	282464	1127078		
29124	2412	19133873	1955-08-12	1955-08-12 00:00:00	1955-08-24	1955-08-24 00:00:00	1955-08-24	38000177		0	0	12		0	0	0	160032	0	834061	19133873		
51829	4309	1127433	2018-12-28	2018-12-28 00:00:00	2019-01-04	2019-01-04 00:00:00	2019-01-04	38000177		0	0	7		0	0	0	285890	0	313782	1127433		
71539	1565	40213296	2004-09-19	2004-09-19 00:00:00	2004-09-19	2004-09-19 00:00:00	2004-09-19	581452		0	0	0		0	0	0	104927	0	52	40213296		
141353	3105	40213227	2001-04-09	2001-04-09 00:00:00	2001-04-09	2001-04-09 00:00:00	2001-04-09	581452		0	0	0		0	0	0	206515	0	113	40213227		
63976	5314	1118084	1992-10-04	1992-10-04 00:00:00	1992-10-04	1992-10-04 00:00:00	\N	38000177		0	0	0		0	0	0	353375	0	00025152531	44923712		
39826	3295	1118084	1983-03-22	1983-03-22 00:00:00	1983-03-22	1983-03-22 00:00:00	\N	38000177		0	0	0		0	0	0	218971	0	00025152531	44923712		
238749	5241	40213260	2012-03-27	2012-03-27 00:00:00	2012-03-27	2012-03-27 00:00:00	2012-03-27	581452		0	0	0		0	0	0	348739	0	121	40213260		
242023	5314	40213227	1993-12-03	1993-12-03 00:00:00	1993-12-03	1993-12-03 00:00:00	1993-12-03	581452		0	0	0		0	0	0	353452	0	113	40213227		
170237	3743	40213227	1999-11-21	1999-11-21 00:00:00	1999-11-21	1999-11-21 00:00:00	1999-11-21	581452		0	0	0		0	0	0	248727	0	113	40213227		
17428	1443	19128022	1994-03-06	1994-03-06 00:00:00	1995-03-01	1995-03-01 00:00:00	1995-03-01	38000177		0	0	360		0	0	0	96229	0	749785	19128022		
107201	2349	40213314	1977-03-20	1977-03-20 00:00:00	1977-03-20	1977-03-20 00:00:00	1977-03-20	581452		0	0	0		0	0	0	156371	0	49	40213314		
223829	4913	40213160	1974-04-03	1974-04-03 00:00:00	1974-04-03	1974-04-03 00:00:00	1974-04-03	581452		0	0	0		0	0	0	326505	0	10	40213160		
39493	862	40213160	1975-04-01	1975-04-01 00:00:00	1975-04-01	1975-04-01 00:00:00	1975-04-01	581452		0	0	0		0	0	0	57069	0	10	40213160		
203646	4471	40213160	1960-10-17	1960-10-17 00:00:00	1960-10-17	1960-10-17 00:00:00	1960-10-17	581452		0	0	0		0	0	0	297436	0	10	40213160		
227118	4987	40213227	1993-12-07	1993-12-07 00:00:00	1993-12-07	1993-12-07 00:00:00	1993-12-07	581452		0	0	0		0	0	0	331785	0	113	40213227		
86964	1906	40213160	1961-04-22	1961-04-22 00:00:00	1961-04-22	1961-04-22 00:00:00	1961-04-22	581452		0	0	0		0	0	0	126858	0	10	40213160		
97552	2138	40213296	1996-09-29	1996-09-29 00:00:00	1996-09-29	1996-09-29 00:00:00	1996-09-29	581452		0	0	0		0	0	0	142405	0	52	40213296		
40067	3314	920300	2015-11-29	2015-11-29 00:00:00	2015-12-06	2015-12-06 00:00:00	2015-12-06	38000177		0	0	7		0	0	0	220089	0	311989	920300		
63566	1390	40213227	1997-03-13	1997-03-13 00:00:00	1997-03-13	1997-03-13 00:00:00	1997-03-13	581452		0	0	0		0	0	0	92280	0	113	40213227		
63517	5277	19006318	1956-07-28	1956-07-28 00:00:00	1956-08-11	1956-08-11 00:00:00	1956-08-11	38000177		0	0	14		0	0	0	351034	0	105078	19006318		
165185	3631	40213160	1975-03-06	1975-03-06 00:00:00	1975-03-06	1975-03-06 00:00:00	1975-03-06	581452		0	0	0		0	0	0	241623	0	10	40213160		
231425	5085	40213227	2018-09-20	2018-09-20 00:00:00	2018-09-20	2018-09-20 00:00:00	2018-09-20	581452		0	0	0		0	0	0	338099	0	113	40213227		
214574	4705	40213227	2004-03-18	2004-03-18 00:00:00	2004-03-18	2004-03-18 00:00:00	2004-03-18	581452		0	0	0		0	0	0	313463	0	113	40213227		
169671	3730	40213227	2005-04-07	2005-04-07 00:00:00	2005-04-07	2005-04-07 00:00:00	2005-04-07	581452		0	0	0		0	0	0	247821	0	113	40213227		
190869	4194	40213314	1977-01-02	1977-01-02 00:00:00	1977-01-02	1977-01-02 00:00:00	1977-01-02	581452		0	0	0		0	0	0	278374	0	49	40213314		
201976	4435	40213160	1961-06-12	1961-06-12 00:00:00	1961-06-12	1961-06-12 00:00:00	1961-06-12	581452		0	0	0		0	0	0	294785	0	10	40213160		
200019	4393	40213251	1989-04-28	1989-04-28 00:00:00	1989-04-28	1989-04-28 00:00:00	1989-04-28	581452		0	0	0		0	0	0	292123	0	21	40213251		
38338	836	40213160	1979-05-13	1979-05-13 00:00:00	1979-05-13	1979-05-13 00:00:00	1979-05-13	581452		0	0	0		0	0	0	55342	0	10	40213160		
151913	3343	40213227	1998-07-12	1998-07-12 00:00:00	1998-07-12	1998-07-12 00:00:00	1998-07-12	581452		0	0	0		0	0	0	221738	0	113	40213227		
38915	3216	1713671	2005-09-04	2005-09-04 00:00:00	2005-09-18	2005-09-18 00:00:00	2005-09-18	38000177		0	0	14		0	0	0	213714	0	562251	1713671		
210967	4626	40213314	1977-01-10	1977-01-10 00:00:00	1977-01-10	1977-01-10 00:00:00	1977-01-10	581452		0	0	0		0	0	0	308255	0	49	40213314		
92276	2026	40213201	2018-04-20	2018-04-20 00:00:00	2018-04-20	2018-04-20 00:00:00	2018-04-20	581452		0	0	0		0	0	0	134842	0	33	40213201		
100738	2207	40213160	1985-04-04	1985-04-04 00:00:00	1985-04-04	1985-04-04 00:00:00	1985-04-04	581452		0	0	0		0	0	0	147069	0	10	40213160		
38149	3157	19006318	1952-12-31	1952-12-31 00:00:00	1953-01-14	1953-01-14 00:00:00	1953-01-14	38000177		0	0	14		0	0	0	209848	0	105078	19006318		
126449	2781	40213314	1980-07-04	1980-07-04 00:00:00	1980-07-04	1980-07-04 00:00:00	1980-07-04	581452		0	0	0		0	0	0	184333	0	49	40213314		
14226	1193	40229134	2008-07-08	2008-07-08 00:00:00	2008-07-15	2008-07-15 00:00:00	2008-07-15	38000177		0	0	7		0	0	0	78606	0	1043400	40229134		
46549	3856	46233988	1976-01-04	1976-01-04 00:00:00	1976-01-18	1976-01-18 00:00:00	1976-01-18	38000177		0	0	14		0	0	0	255897	0	1652673	46233988		
63845	1397	40213227	2008-12-26	2008-12-26 00:00:00	2008-12-26	2008-12-26 00:00:00	2008-12-26	581452		0	0	0		0	0	0	\N	0	113	40213227		
29125	2412	19059056	1951-05-21	1951-05-21 00:00:00	1951-06-11	1951-06-11 00:00:00	1951-06-11	38000177		0	0	21		0	0	0	160093	0	243670	19059056		
51830	4309	1118084	1994-01-16	1994-01-16 00:00:00	1994-01-16	1994-01-16 00:00:00	\N	38000177		0	0	0		0	0	0	285932	0	00025152531	44923712		
71546	1565	40213260	2014-09-14	2014-09-14 00:00:00	2014-09-14	2014-09-14 00:00:00	2014-09-14	581452		0	0	0		0	0	0	104957	0	121	40213260		
167396	3680	40213306	1999-11-30	1999-11-30 00:00:00	1999-11-30	1999-11-30 00:00:00	1999-11-30	581452		0	0	0		0	0	0	244687	0	43	40213306		
63978	5314	1713671	1977-11-15	1977-11-15 00:00:00	1977-12-06	1977-12-06 00:00:00	1977-12-06	38000177		0	0	21		0	0	0	353388	0	562251	1713671		
39827	3295	19059056	1957-12-18	1957-12-18 00:00:00	1958-01-01	1958-01-01 00:00:00	1958-01-01	38000177		0	0	14		0	0	0	218895	0	243670	19059056		
238752	5241	40213160	1962-07-03	1962-07-03 00:00:00	1962-07-03	1962-07-03 00:00:00	1962-07-03	581452		0	0	0		0	0	0	348774	0	10	40213160		
242025	5314	40213201	2017-03-24	2017-03-24 00:00:00	2017-03-24	2017-03-24 00:00:00	2017-03-24	581452		0	0	0		0	0	0	353428	0	33	40213201		
170238	3743	40213306	1999-11-21	1999-11-21 00:00:00	1999-11-21	1999-11-21 00:00:00	1999-11-21	581452		0	0	0		0	0	0	248727	0	43	40213306		
17429	1443	19128065	1993-03-11	1993-03-11 00:00:00	1994-03-06	1994-03-06 00:00:00	1994-03-06	38000177		0	0	360		0	0	0	96228	0	749882	19128065		
107203	2349	40213296	2014-04-20	2014-04-20 00:00:00	2014-04-20	2014-04-20 00:00:00	2014-04-20	581452		0	0	0		0	0	0	156375	0	52	40213296		
223832	4913	40213227	2002-01-02	2002-01-02 00:00:00	2002-01-02	2002-01-02 00:00:00	2002-01-02	581452		0	0	0		0	0	0	326552	0	113	40213227		
39497	862	40213160	1970-09-08	1970-09-08 00:00:00	1970-09-08	1970-09-08 00:00:00	1970-09-08	581452		0	0	0		0	0	0	57046	0	10	40213160		
203648	4471	40213227	1994-09-26	1994-09-26 00:00:00	1994-09-26	1994-09-26 00:00:00	1994-09-26	581452		0	0	0		0	0	0	297410	0	113	40213227		
227127	4987	40213160	1959-12-29	1959-12-29 00:00:00	1959-12-29	1959-12-29 00:00:00	1959-12-29	581452		0	0	0		0	0	0	331713	0	10	40213160		
86967	1906	40213306	1981-04-04	1981-04-04 00:00:00	1981-04-04	1981-04-04 00:00:00	1981-04-04	581452		0	0	0		0	0	0	126892	0	43	40213306		
97554	2138	40213227	1996-09-29	1996-09-29 00:00:00	1996-09-29	1996-09-29 00:00:00	1996-09-29	581452		0	0	0		0	0	0	142405	0	113	40213227		
40068	3314	40236446	1969-09-06	1969-09-06 00:00:00	1980-09-13	1980-09-13 00:00:00	1980-09-13	38000177		0	0	4025		0	0	0	220117	0	1091392	40236446		
63570	1390	40213160	1970-12-10	1970-12-10 00:00:00	1970-12-10	1970-12-10 00:00:00	1970-12-10	581452		0	0	0		0	0	0	92235	0	10	40213160		
63518	5277	1713671	1972-03-05	1972-03-05 00:00:00	1972-03-26	1972-03-26 00:00:00	1972-03-26	38000177		0	0	21		0	0	0	351022	0	562251	1713671		
165189	3631	40213296	2016-12-08	2016-12-08 00:00:00	2016-12-08	2016-12-08 00:00:00	2016-12-08	581452		0	0	0		0	0	0	241579	0	52	40213296		
231426	5085	40213296	2018-09-20	2018-09-20 00:00:00	2018-09-20	2018-09-20 00:00:00	2018-09-20	581452		0	0	0		0	0	0	338099	0	52	40213296		
214586	4705	40213227	1995-03-09	1995-03-09 00:00:00	1995-03-09	1995-03-09 00:00:00	1995-03-09	581452		0	0	0		0	0	0	313464	0	113	40213227		
169673	3731	40213160	1978-11-04	1978-11-04 00:00:00	1978-11-04	1978-11-04 00:00:00	1978-11-04	581452		0	0	0		0	0	0	247928	0	10	40213160		
190871	4194	40213160	1977-01-02	1977-01-02 00:00:00	1977-01-02	1977-01-02 00:00:00	1977-01-02	581452		0	0	0		0	0	0	278374	0	10	40213160		
201990	4435	40213160	1965-12-13	1965-12-13 00:00:00	1965-12-13	1965-12-13 00:00:00	1965-12-13	581452		0	0	0		0	0	0	294789	0	10	40213160		
200022	4393	40213160	1989-04-28	1989-04-28 00:00:00	1989-04-28	1989-04-28 00:00:00	1989-04-28	581452		0	0	0		0	0	0	292123	0	10	40213160		
151878	3342	40213227	2001-03-07	2001-03-07 00:00:00	2001-03-07	2001-03-07 00:00:00	2001-03-07	581452		0	0	0		0	0	0	221614	0	113	40213227		
151916	3343	40213306	1998-07-12	1998-07-12 00:00:00	1998-07-12	1998-07-12 00:00:00	1998-07-12	581452		0	0	0		0	0	0	221738	0	43	40213306		
38916	3216	1127078	1961-08-14	1961-08-14 00:00:00	1961-09-04	1961-09-04 00:00:00	1961-09-04	38000177		0	0	21		0	0	0	213706	0	282464	1127078		
197048	4330	40213201	2012-03-24	2012-03-24 00:00:00	2012-03-24	2012-03-24 00:00:00	2012-03-24	581452		0	0	0		0	0	0	287225	0	33	40213201		
92279	2026	40213160	1955-06-17	1955-06-17 00:00:00	1955-06-17	1955-06-17 00:00:00	1955-06-17	581452		0	0	0		0	0	0	134846	0	10	40213160		
100748	2207	40213160	1980-10-02	1980-10-02 00:00:00	1980-10-02	1980-10-02 00:00:00	1980-10-02	581452		0	0	0		0	0	0	147086	0	10	40213160		
38150	3157	19059056	1952-12-31	1952-12-31 00:00:00	1953-01-14	1953-01-14 00:00:00	1953-01-14	38000177		0	0	14		0	0	0	209848	0	243670	19059056		
197161	4333	40213227	2004-09-02	2004-09-02 00:00:00	2004-09-02	2004-09-02 00:00:00	2004-09-02	581452		0	0	0		0	0	0	287361	0	113	40213227		
102679	2250	40213160	1956-11-14	1956-11-14 00:00:00	1956-11-14	1956-11-14 00:00:00	1956-11-14	581452		0	0	0		0	0	0	149636	0	10	40213160		
46550	3856	19128022	1991-09-09	1991-09-09 00:00:00	1992-09-03	1992-09-03 00:00:00	1992-09-03	38000177		0	0	360		0	0	0	255895	0	749785	19128022		
63849	1397	40213314	1977-02-25	1977-02-25 00:00:00	1977-02-25	1977-02-25 00:00:00	1977-02-25	581452		0	0	0		0	0	0	92778	0	49	40213314		
29126	2412	19059056	1951-02-20	1951-02-20 00:00:00	1951-03-06	1951-03-06 00:00:00	1951-03-06	38000177		0	0	14		0	0	0	160080	0	243670	19059056		
51831	4309	1713671	1996-03-11	1996-03-11 00:00:00	1996-03-18	1996-03-18 00:00:00	1996-03-18	38000177		0	0	7		0	0	0	285892	0	562251	1713671		
71550	1565	40213227	1998-03-22	1998-03-22 00:00:00	1998-03-22	1998-03-22 00:00:00	1998-03-22	581452		0	0	0		0	0	0	\N	0	113	40213227		
143845	3161	40213201	2017-08-30	2017-08-30 00:00:00	2017-08-30	2017-08-30 00:00:00	2017-08-30	581452		0	0	0		0	0	0	210257	0	33	40213201		
63980	5314	1127433	1997-05-05	1997-05-05 00:00:00	1997-05-26	1997-05-26 00:00:00	1997-05-26	38000177		0	0	21		0	0	0	353457	0	313782	1127433		
39828	3295	19059056	1964-11-25	1964-11-25 00:00:00	1964-12-16	1964-12-16 00:00:00	1964-12-16	38000177		0	0	21		0	0	0	218896	0	243670	19059056		
238753	5241	40213227	2013-04-02	2013-04-02 00:00:00	2013-04-02	2013-04-02 00:00:00	2013-04-02	581452		0	0	0		0	0	0	348794	0	113	40213227		
219534	4819	40213160	1960-03-01	1960-03-01 00:00:00	1960-03-01	1960-03-01 00:00:00	1960-03-01	581452		0	0	0		0	0	0	320526	0	10	40213160		
170240	3743	40213296	2017-08-20	2017-08-20 00:00:00	2017-08-20	2017-08-20 00:00:00	2017-08-20	581452		0	0	0		0	0	0	248719	0	52	40213296		
17430	1443	19074843	1981-06-03	1981-06-03 00:00:00	1981-06-17	1981-06-17 00:00:00	1981-06-17	38000177		0	0	14		0	0	0	96204	0	309045	19074843		
107205	2349	40213227	2014-04-20	2014-04-20 00:00:00	2014-04-20	2014-04-20 00:00:00	2014-04-20	581452		0	0	0		0	0	0	156375	0	113	40213227		
39499	862	40213160	1971-02-09	1971-02-09 00:00:00	1971-02-09	1971-02-09 00:00:00	1971-02-09	581452		0	0	0		0	0	0	57047	0	10	40213160		
203651	4471	40213160	1960-12-19	1960-12-19 00:00:00	1960-12-19	1960-12-19 00:00:00	1960-12-19	581452		0	0	0		0	0	0	297412	0	10	40213160		
227129	4987	40213227	2011-02-22	2011-02-22 00:00:00	2011-02-22	2011-02-22 00:00:00	2011-02-22	581452		0	0	0		0	0	0	331752	0	113	40213227		
86969	1906	40213227	1993-10-17	1993-10-17 00:00:00	1993-10-17	1993-10-17 00:00:00	1993-10-17	581452		0	0	0		0	0	0	126922	0	113	40213227		
108834	2387	40213227	2011-03-05	2011-03-05 00:00:00	2011-03-05	2011-03-05 00:00:00	2011-03-05	581452		0	0	0		0	0	0	158774	0	113	40213227		
40069	3314	1127433	2007-07-16	2007-07-16 00:00:00	2007-07-30	2007-07-30 00:00:00	2007-07-30	38000177		0	0	14		0	0	0	220067	0	313782	1127433		
63572	1390	40213160	1966-06-09	1966-06-09 00:00:00	1966-06-09	1966-06-09 00:00:00	1966-06-09	581452		0	0	0		0	0	0	92232	0	10	40213160		
63519	5277	19078461	2018-07-06	2018-07-06 00:00:00	2018-07-20	2018-07-20 00:00:00	2018-07-20	38000177		0	0	14		0	0	0	350979	0	310965	19078461		
165191	3631	40213227	2016-12-08	2016-12-08 00:00:00	2016-12-08	2016-12-08 00:00:00	2016-12-08	581452		0	0	0		0	0	0	241579	0	113	40213227		
231428	5085	40213160	1977-05-19	1977-05-19 00:00:00	1977-05-19	1977-05-19 00:00:00	1977-05-19	581452		0	0	0		0	0	0	338095	0	10	40213160		
214587	4705	40213306	1995-03-09	1995-03-09 00:00:00	1995-03-09	1995-03-09 00:00:00	1995-03-09	581452		0	0	0		0	0	0	313464	0	43	40213306		
169676	3731	40213160	1974-03-30	1974-03-30 00:00:00	1974-03-30	1974-03-30 00:00:00	1974-03-30	581452		0	0	0		0	0	0	247953	0	10	40213160		
190874	4194	40213314	1977-07-04	1977-07-04 00:00:00	1977-07-04	1977-07-04 00:00:00	1977-07-04	581452		0	0	0		0	0	0	278399	0	49	40213314		
199429	4381	40213260	2015-07-28	2015-07-28 00:00:00	2015-07-28	2015-07-28 00:00:00	2015-07-28	581452		0	0	0		0	0	0	291129	0	121	40213260		
181471	3987	40213227	2015-02-28	2015-02-28 00:00:00	2015-02-28	2015-02-28 00:00:00	2015-02-28	581452		0	0	0		0	0	0	265051	0	113	40213227		
151894	3343	40213314	1977-05-15	1977-05-15 00:00:00	1977-05-15	1977-05-15 00:00:00	1977-05-15	581452		0	0	0		0	0	0	221746	0	49	40213314		
151920	3343	40213227	2018-03-25	2018-03-25 00:00:00	2018-03-25	2018-03-25 00:00:00	2018-03-25	581452		0	0	0		0	0	0	221842	0	113	40213227		
38917	3216	1127433	1959-10-26	1959-10-26 00:00:00	1959-11-09	1959-11-09 00:00:00	1959-11-09	38000177		0	0	14		0	0	0	213750	0	313782	1127433		
197053	4330	40213227	2017-10-14	2017-10-14 00:00:00	2017-10-14	2017-10-14 00:00:00	2017-10-14	581452		0	0	0		0	0	0	287180	0	113	40213227		
92281	2026	40213296	1996-01-26	1996-01-26 00:00:00	1996-01-26	1996-01-26 00:00:00	1996-01-26	581452		0	0	0		0	0	0	134838	0	52	40213296		
100749	2207	40213314	1980-10-02	1980-10-02 00:00:00	1980-10-02	1980-10-02 00:00:00	1980-10-02	581452		0	0	0		0	0	0	147086	0	49	40213314		
38153	3157	40229134	1984-06-17	1984-06-17 00:00:00	1984-07-01	1984-07-01 00:00:00	1984-07-01	38000177		0	0	14		0	0	0	209845	0	1043400	40229134		
197174	4333	40213227	1995-12-21	1995-12-21 00:00:00	1995-12-21	1995-12-21 00:00:00	1995-12-21	581452		0	0	0		0	0	0	\N	0	113	40213227		
102680	2250	40213260	2006-03-08	2006-03-08 00:00:00	2006-03-08	2006-03-08 00:00:00	2006-03-08	581452		0	0	0		0	0	0	149649	0	121	40213260		
46551	3856	1127433	1975-06-27	1975-06-27 00:00:00	1975-07-04	1975-07-04 00:00:00	1975-07-04	38000177		0	0	7		0	0	0	255906	0	313782	1127433		
63850	1397	40213160	1977-02-25	1977-02-25 00:00:00	1977-02-25	1977-02-25 00:00:00	1977-02-25	581452		0	0	0		0	0	0	92778	0	10	40213160		
29127	2412	19006318	1951-02-20	1951-02-20 00:00:00	1951-03-06	1951-03-06 00:00:00	1951-03-06	38000177		0	0	14		0	0	0	160080	0	105078	19006318		
51832	4309	1115171	1994-08-02	1994-08-02 00:00:00	1994-09-06	1994-09-06 00:00:00	1994-09-06	38000177		0	0	35		0	0	0	285946	0	849574	1115171		
71562	1565	40213306	1986-09-28	1986-09-28 00:00:00	1986-09-28	1986-09-28 00:00:00	1986-09-28	581452		0	0	0		0	0	0	104906	0	43	40213306		
143848	3161	40213160	1956-04-25	1956-04-25 00:00:00	1956-04-25	1956-04-25 00:00:00	1956-04-25	581452		0	0	0		0	0	0	210227	0	10	40213160		
63981	5314	1127433	1986-11-12	1986-11-12 00:00:00	1986-11-19	1986-11-19 00:00:00	1986-11-19	38000177		0	0	7		0	0	0	353390	0	313782	1127433		
39829	3295	1127433	1997-11-01	1997-11-01 00:00:00	1997-11-15	1997-11-15 00:00:00	1997-11-15	38000177		0	0	14		0	0	0	218973	0	313782	1127433		
238754	5241	40213260	2013-04-02	2013-04-02 00:00:00	2013-04-02	2013-04-02 00:00:00	2013-04-02	581452		0	0	0		0	0	0	348794	0	121	40213260		
219537	4819	40213160	1964-04-28	1964-04-28 00:00:00	1964-04-28	1964-04-28 00:00:00	1964-04-28	581452		0	0	0		0	0	0	320569	0	10	40213160		
170242	3743	40213251	1984-12-16	1984-12-16 00:00:00	1984-12-16	1984-12-16 00:00:00	1984-12-16	581452		0	0	0		0	0	0	248703	0	21	40213251		
27889	2307	19006318	1966-08-25	1966-08-25 00:00:00	1966-09-08	1966-09-08 00:00:00	1966-09-08	38000177		0	0	14		0	0	0	153531	0	105078	19006318		
107207	2349	40213160	1972-09-17	1972-09-17 00:00:00	1972-09-17	1972-09-17 00:00:00	1972-09-17	581452		0	0	0		0	0	0	156430	0	10	40213160		
39511	863	40213227	1993-04-08	1993-04-08 00:00:00	1993-04-08	1993-04-08 00:00:00	1993-04-08	581452		0	0	0		0	0	0	57138	0	113	40213227		
203660	4471	40213160	1965-06-21	1965-06-21 00:00:00	1965-06-21	1965-06-21 00:00:00	1965-06-21	581452		0	0	0		0	0	0	297415	0	10	40213160		
227131	4987	40213260	2011-02-22	2011-02-22 00:00:00	2011-02-22	2011-02-22 00:00:00	2011-02-22	581452		0	0	0		0	0	0	331752	0	121	40213260		
86972	1906	40213160	1961-07-23	1961-07-23 00:00:00	1961-07-23	1961-07-23 00:00:00	1961-07-23	581452		0	0	0		0	0	0	126882	0	10	40213160		
108835	2387	40213296	2011-03-05	2011-03-05 00:00:00	2011-03-05	2011-03-05 00:00:00	2011-03-05	581452		0	0	0		0	0	0	158774	0	52	40213296		
40070	3314	19133873	1980-04-30	1980-04-30 00:00:00	1980-05-10	1980-05-10 00:00:00	1980-05-10	38000177		0	0	10		0	0	0	220075	0	834061	19133873		
63574	1390	40213160	1966-04-07	1966-04-07 00:00:00	1966-04-07	1966-04-07 00:00:00	1966-04-07	581452		0	0	0		0	0	0	92264	0	10	40213160		
63520	5277	1713671	1983-07-01	1983-07-01 00:00:00	1983-07-22	1983-07-22 00:00:00	1983-07-22	38000177		0	0	21		0	0	0	351023	0	562251	1713671		
165194	3631	40213227	1997-03-13	1997-03-13 00:00:00	1997-03-13	1997-03-13 00:00:00	1997-03-13	581452		0	0	0		0	0	0	241574	0	113	40213227		
231429	5085	40213314	1977-05-19	1977-05-19 00:00:00	1977-05-19	1977-05-19 00:00:00	1977-05-19	581452		0	0	0		0	0	0	338095	0	49	40213314		
214590	4705	40213160	1972-09-21	1972-09-21 00:00:00	1972-09-21	1972-09-21 00:00:00	1972-09-21	581452		0	0	0		0	0	0	313495	0	10	40213160		
169681	3731	40213160	1974-06-01	1974-06-01 00:00:00	1974-06-01	1974-06-01 00:00:00	1974-06-01	581452		0	0	0		0	0	0	247903	0	10	40213160		
201913	4433	40213227	1992-04-04	1992-04-04 00:00:00	1992-04-04	1992-04-04 00:00:00	1992-04-04	581452		0	0	0		0	0	0	294709	0	113	40213227		
199431	4381	40213227	2015-07-28	2015-07-28 00:00:00	2015-07-28	2015-07-28 00:00:00	2015-07-28	581452		0	0	0		0	0	0	291129	0	113	40213227		
181475	3987	40213260	2007-01-13	2007-01-13 00:00:00	2007-01-13	2007-01-13 00:00:00	2007-01-13	581452		0	0	0		0	0	0	265058	0	121	40213260		
151897	3343	40213306	1999-05-16	1999-05-16 00:00:00	1999-05-16	1999-05-16 00:00:00	1999-05-16	581452		0	0	0		0	0	0	221793	0	43	40213306		
151921	3343	40213296	2018-03-25	2018-03-25 00:00:00	2018-03-25	2018-03-25 00:00:00	2018-03-25	581452		0	0	0		0	0	0	221842	0	52	40213296		
38918	3216	1127078	1955-02-17	1955-02-17 00:00:00	1955-03-03	1955-03-03 00:00:00	1955-03-03	38000177		0	0	14		0	0	0	213755	0	282464	1127078		
197078	4330	40213227	2007-02-24	2007-02-24 00:00:00	2007-02-24	2007-02-24 00:00:00	2007-02-24	581452		0	0	0		0	0	0	287209	0	113	40213227		
92282	2026	40213160	1955-12-16	1955-12-16 00:00:00	1955-12-16	1955-12-16 00:00:00	1955-12-16	581452		0	0	0		0	0	0	134862	0	10	40213160		
100750	2207	40213306	2002-06-27	2002-06-27 00:00:00	2002-06-27	2002-06-27 00:00:00	2002-06-27	581452		0	0	0		0	0	0	147107	0	43	40213306		
38154	3157	19059056	1960-03-22	1960-03-22 00:00:00	1960-06-20	1960-06-20 00:00:00	1960-06-20	38000177		0	0	90		0	0	0	209877	0	243670	19059056		
197190	4333	40213260	2006-09-14	2006-09-14 00:00:00	2006-09-14	2006-09-14 00:00:00	2006-09-14	581452		0	0	0		0	0	0	287369	0	121	40213260		
237302	5210	40213160	1972-08-15	1972-08-15 00:00:00	1972-08-15	1972-08-15 00:00:00	1972-08-15	581452		0	0	0		0	0	0	346456	0	10	40213160		
46552	3856	1127433	1991-06-21	1991-06-21 00:00:00	1991-07-05	1991-07-05 00:00:00	1991-07-05	38000177		0	0	14		0	0	0	255896	0	313782	1127433		
63852	1397	40213160	1981-10-30	1981-10-30 00:00:00	1981-10-30	1981-10-30 00:00:00	1981-10-30	581452		0	0	0		0	0	0	92740	0	10	40213160		
29128	2412	1713671	2008-02-14	2008-02-14 00:00:00	2008-03-06	2008-03-06 00:00:00	2008-03-06	38000177		0	0	21		0	0	0	160059	0	562251	1713671		
51833	4309	40229134	1981-08-05	1981-08-05 00:00:00	1981-08-12	1981-08-12 00:00:00	1981-08-12	38000177		0	0	7		0	0	0	285891	0	1043400	40229134		
71563	1565	40213160	1965-02-21	1965-02-21 00:00:00	1965-02-21	1965-02-21 00:00:00	1965-02-21	581452		0	0	0		0	0	0	104943	0	10	40213160		
143860	3161	40213227	2012-08-01	2012-08-01 00:00:00	2012-08-01	2012-08-01 00:00:00	2012-08-01	581452		0	0	0		0	0	0	210239	0	113	40213227		
63982	5314	920300	1979-12-21	1979-12-21 00:00:00	1979-12-28	1979-12-28 00:00:00	1979-12-28	38000177		0	0	7		0	0	0	353421	0	311989	920300		
39830	3295	19133905	1978-11-10	1978-11-10 00:00:00	1978-11-18	1978-11-18 00:00:00	1978-11-18	38000177		0	0	8		0	0	0	218970	0	834102	19133905		
238757	5241	40213227	2003-04-15	2003-04-15 00:00:00	2003-04-15	2003-04-15 00:00:00	2003-04-15	581452		0	0	0		0	0	0	348749	0	113	40213227		
219542	4819	40213306	1982-02-02	1982-02-02 00:00:00	1982-02-02	1982-02-02 00:00:00	1982-02-02	581452		0	0	0		0	0	0	320547	0	43	40213306		
170246	3743	40213314	1977-11-20	1977-11-20 00:00:00	1977-11-20	1977-11-20 00:00:00	1977-11-20	581452		0	0	0		0	0	0	248698	0	49	40213314		
27891	2307	19128065	1986-08-20	1986-08-20 00:00:00	1987-08-15	1987-08-15 00:00:00	1987-08-15	38000177		0	0	360		0	0	0	153501	0	749882	19128065		
107210	2349	40213306	1994-06-12	1994-06-12 00:00:00	1994-06-12	1994-06-12 00:00:00	1994-06-12	581452		0	0	0		0	0	0	156389	0	43	40213306		
130091	2860	40213227	2003-08-08	2003-08-08 00:00:00	2003-08-08	2003-08-08 00:00:00	2003-08-08	581452		0	0	0		0	0	0	190143	0	113	40213227		
203662	4471	40213160	1961-03-20	1961-03-20 00:00:00	1961-03-20	1961-03-20 00:00:00	1961-03-20	581452		0	0	0		0	0	0	297454	0	10	40213160		
227133	4987	40213227	2001-10-02	2001-10-02 00:00:00	2001-10-02	2001-10-02 00:00:00	2001-10-02	581452		0	0	0		0	0	0	331746	0	113	40213227		
97537	2138	40213160	1955-01-16	1955-01-16 00:00:00	1955-01-16	1955-01-16 00:00:00	1955-01-16	581452		0	0	0		0	0	0	142381	0	10	40213160		
108843	2387	40213160	1974-02-02	1974-02-02 00:00:00	1974-02-02	1974-02-02 00:00:00	1974-02-02	581452		0	0	0		0	0	0	158751	0	10	40213160		
40071	3314	1127433	2019-01-18	2019-01-18 00:00:00	2019-01-25	2019-01-25 00:00:00	2019-01-25	38000177		0	0	7		0	0	0	220094	0	313782	1127433		
63576	1390	40213260	2015-12-31	2015-12-31 00:00:00	2015-12-31	2015-12-31 00:00:00	2015-12-31	581452		0	0	0		0	0	0	92245	0	121	40213260		
63522	5278	1124300	2013-10-15	2013-10-15 00:00:00	2013-10-15	2013-10-15 00:00:00	\N	38000177		0	0	0		0	0	0	351079	0	00781178901	45011828		
165195	3631	40213306	1997-03-13	1997-03-13 00:00:00	1997-03-13	1997-03-13 00:00:00	1997-03-13	581452		0	0	0		0	0	0	241574	0	43	40213306		
231431	5085	40213251	1984-09-06	1984-09-06 00:00:00	1984-09-06	1984-09-06 00:00:00	1984-09-06	581452		0	0	0		0	0	0	338124	0	21	40213251		
214593	4705	40213314	1977-03-24	1977-03-24 00:00:00	1977-03-24	1977-03-24 00:00:00	1977-03-24	581452		0	0	0		0	0	0	313500	0	49	40213314		
169684	3731	40213314	1977-05-28	1977-05-28 00:00:00	1977-05-28	1977-05-28 00:00:00	1977-05-28	581452		0	0	0		0	0	0	247890	0	49	40213314		
201917	4433	40213227	2010-07-17	2010-07-17 00:00:00	2010-07-17	2010-07-17 00:00:00	2010-07-17	581452		0	0	0		0	0	0	294654	0	113	40213227		
199436	4381	40213227	2005-06-28	2005-06-28 00:00:00	2005-06-28	2005-06-28 00:00:00	2005-06-28	581452		0	0	0		0	0	0	291140	0	113	40213227		
192784	4235	40213160	1984-02-09	1984-02-09 00:00:00	1984-02-09	1984-02-09 00:00:00	1984-02-09	581452		0	0	0		0	0	0	281190	0	10	40213160		
193068	4241	40213160	1965-02-02	1965-02-02 00:00:00	1965-02-02	1965-02-02 00:00:00	1965-02-02	581452		0	0	0		0	0	0	281739	0	10	40213160		
151927	3343	40213314	1977-02-13	1977-02-13 00:00:00	1977-02-13	1977-02-13 00:00:00	1977-02-13	581452		0	0	0		0	0	0	221767	0	49	40213314		
38919	3216	19006318	1955-02-17	1955-02-17 00:00:00	1955-03-03	1955-03-03 00:00:00	1955-03-03	38000177		0	0	14		0	0	0	213755	0	105078	19006318		
208357	4570	40213201	2003-03-01	2003-03-01 00:00:00	2003-03-01	2003-03-01 00:00:00	2003-03-01	581452		0	0	0		0	0	0	304480	0	33	40213201		
92287	2026	40213198	2017-04-14	2017-04-14 00:00:00	2017-04-14	2017-04-14 00:00:00	2017-04-14	581452		0	0	0		0	0	0	134825	0	133	40213198		
100752	2207	40213227	2002-06-27	2002-06-27 00:00:00	2002-06-27	2002-06-27 00:00:00	2002-06-27	581452		0	0	0		0	0	0	147107	0	113	40213227		
38155	3157	19059056	1953-07-29	1953-07-29 00:00:00	1953-08-26	1953-08-26 00:00:00	1953-08-26	38000177		0	0	28		0	0	0	209876	0	243670	19059056		
197195	4333	40213160	1955-08-04	1955-08-04 00:00:00	1955-08-04	1955-08-04 00:00:00	1955-08-04	581452		0	0	0		0	0	0	287432	0	10	40213160		
237304	5210	40213160	1972-05-16	1972-05-16 00:00:00	1972-05-16	1972-05-16 00:00:00	1972-05-16	581452		0	0	0		0	0	0	346460	0	10	40213160		
46553	3856	19133873	1976-10-18	1976-10-18 00:00:00	1976-10-25	1976-10-25 00:00:00	1976-10-25	38000177		0	0	7		0	0	0	255907	0	834061	19133873		
63860	1397	40213227	1999-02-26	1999-02-26 00:00:00	1999-02-26	1999-02-26 00:00:00	1999-02-26	581452		0	0	0		0	0	0	92800	0	113	40213227		
29143	2414	1127433	1975-05-24	1975-05-24 00:00:00	1975-06-07	1975-06-07 00:00:00	1975-06-07	38000177		0	0	14		0	0	0	160251	0	313782	1127433		
51834	4309	19129655	1963-09-27	1963-09-27 00:00:00	1963-10-11	1963-10-11 00:00:00	1963-10-11	38000177		0	0	14		0	0	0	285897	0	789980	19129655		
71570	1565	40213160	1969-08-24	1969-08-24 00:00:00	1969-08-24	1969-08-24 00:00:00	1969-08-24	581452		0	0	0		0	0	0	104947	0	10	40213160		
143865	3161	40213227	2002-06-05	2002-06-05 00:00:00	2002-06-05	2002-06-05 00:00:00	2002-06-05	581452		0	0	0		0	0	0	210196	0	113	40213227		
63983	5314	40236824	1979-12-21	1979-12-21 00:00:00	1979-12-28	1979-12-28 00:00:00	1979-12-28	38000177		0	0	7		0	0	0	353421	0	1094107	40236824		
39831	3295	1713671	1965-12-18	1965-12-18 00:00:00	1966-01-01	1966-01-01 00:00:00	1966-01-01	38000177		0	0	14		0	0	0	218925	0	562251	1713671		
238758	5241	40213296	2003-04-15	2003-04-15 00:00:00	2003-04-15	2003-04-15 00:00:00	2003-04-15	581452		0	0	0		0	0	0	348749	0	52	40213296		
212981	4670	40213160	1955-06-08	1955-06-08 00:00:00	1955-06-08	1955-06-08 00:00:00	1955-06-08	581452		0	0	0		0	0	0	311181	0	10	40213160		
170247	3743	40213160	1977-11-20	1977-11-20 00:00:00	1977-11-20	1977-11-20 00:00:00	1977-11-20	581452		0	0	0		0	0	0	248698	0	10	40213160		
27892	2307	1713671	1989-12-09	1989-12-09 00:00:00	1989-12-23	1989-12-23 00:00:00	1989-12-23	38000177		0	0	14		0	0	0	153528	0	562251	1713671		
107212	2349	40213227	1994-06-12	1994-06-12 00:00:00	1994-06-12	1994-06-12 00:00:00	1994-06-12	581452		0	0	0		0	0	0	156389	0	113	40213227		
130111	2860	40213198	2010-10-15	2010-10-15 00:00:00	2010-10-15	2010-10-15 00:00:00	2010-10-15	581452		0	0	0		0	0	0	190100	0	133	40213198		
203665	4471	40213306	1982-09-13	1982-09-13 00:00:00	1982-09-13	1982-09-13 00:00:00	1982-09-13	581452		0	0	0		0	0	0	297423	0	43	40213306		
227134	4987	40213296	2001-10-02	2001-10-02 00:00:00	2001-10-02	2001-10-02 00:00:00	2001-10-02	581452		0	0	0		0	0	0	331746	0	52	40213296		
92489	2030	40213260	2012-04-22	2012-04-22 00:00:00	2012-04-22	2012-04-22 00:00:00	2012-04-22	581452		0	0	0		0	0	0	135092	0	121	40213260		
108845	2387	40213296	2009-02-28	2009-02-28 00:00:00	2009-02-28	2009-02-28 00:00:00	2009-02-28	581452		0	0	0		0	0	0	158787	0	52	40213296		
40072	3314	1713671	1964-10-04	1964-10-04 00:00:00	1964-10-25	1964-10-25 00:00:00	1964-10-25	38000177		0	0	21		0	0	0	220065	0	562251	1713671		
63580	1390	40213227	2017-01-05	2017-01-05 00:00:00	2017-01-05	2017-01-05 00:00:00	2017-01-05	581452		0	0	0		0	0	0	92289	0	113	40213227		
63523	5278	19059056	1984-12-16	1984-12-16 00:00:00	1985-02-14	1985-02-14 00:00:00	1985-02-14	38000177		0	0	60		0	0	0	351129	0	243670	19059056		
165197	3631	40213227	2006-03-23	2006-03-23 00:00:00	2006-03-23	2006-03-23 00:00:00	2006-03-23	581452		0	0	0		0	0	0	241577	0	113	40213227		
231439	5085	40213296	2016-09-15	2016-09-15 00:00:00	2016-09-15	2016-09-15 00:00:00	2016-09-15	581452		0	0	0		0	0	0	338127	0	52	40213296		
214596	4705	40213160	1977-03-24	1977-03-24 00:00:00	1977-03-24	1977-03-24 00:00:00	1977-03-24	581452		0	0	0		0	0	0	313500	0	10	40213160		
169689	3731	40213227	1996-03-02	1996-03-02 00:00:00	1996-03-02	1996-03-02 00:00:00	1996-03-02	581452		0	0	0		0	0	0	247898	0	113	40213227		
201931	4433	40213201	2005-06-18	2005-06-18 00:00:00	2005-06-18	2005-06-18 00:00:00	2005-06-18	581452		0	0	0		0	0	0	294684	0	33	40213201		
199437	4381	40213296	2005-06-28	2005-06-28 00:00:00	2005-06-28	2005-06-28 00:00:00	2005-06-28	581452		0	0	0		0	0	0	291140	0	52	40213296		
192786	4235	40213251	1984-02-09	1984-02-09 00:00:00	1984-02-09	1984-02-09 00:00:00	1984-02-09	581452		0	0	0		0	0	0	281190	0	21	40213251		
193071	4241	40213160	1969-10-07	1969-10-07 00:00:00	1969-10-07	1969-10-07 00:00:00	1969-10-07	581452		0	0	0		0	0	0	281720	0	10	40213160		
151930	3343	40213160	1977-02-13	1977-02-13 00:00:00	1977-02-13	1977-02-13 00:00:00	1977-02-13	581452		0	0	0		0	0	0	221767	0	10	40213160		
38920	3216	19059056	1958-06-01	1958-06-01 00:00:00	1958-07-31	1958-07-31 00:00:00	1958-07-31	38000177		0	0	60		0	0	0	213705	0	243670	19059056		
208363	4570	40213227	2018-05-26	2018-05-26 00:00:00	2018-05-26	2018-05-26 00:00:00	2018-05-26	581452		0	0	0		0	0	0	304523	0	113	40213227		
92291	2026	40213227	1994-01-21	1994-01-21 00:00:00	1994-01-21	1994-01-21 00:00:00	1994-01-21	581452		0	0	0		0	0	0	134819	0	113	40213227		
139262	3059	40213160	1975-03-30	1975-03-30 00:00:00	1975-03-30	1975-03-30 00:00:00	1975-03-30	581452		0	0	0		0	0	0	203521	0	10	40213160		
38156	3157	40231925	1964-07-29	1964-07-29 00:00:00	1964-07-29	1964-07-29 00:00:00	\N	38000177		0	0	0		0	0	0	209878	0	1049221	40231925		
197200	4333	40213198	2018-11-22	2018-11-22 00:00:00	2018-11-22	2018-11-22 00:00:00	2018-11-22	581452		0	0	0		0	0	0	287408	0	133	40213198		
237308	5210	40213160	1976-11-16	1976-11-16 00:00:00	1976-11-16	1976-11-16 00:00:00	1976-11-16	581452		0	0	0		0	0	0	346463	0	10	40213160		
46554	3856	1713671	1992-03-08	1992-03-08 00:00:00	1992-03-22	1992-03-22 00:00:00	1992-03-22	38000177		0	0	14		0	0	0	255923	0	562251	1713671		
63861	1397	40213306	1999-02-26	1999-02-26 00:00:00	1999-02-26	1999-02-26 00:00:00	1999-02-26	581452		0	0	0		0	0	0	92800	0	43	40213306		
29144	2414	40229134	1954-05-30	1954-05-30 00:00:00	1954-06-13	1954-06-13 00:00:00	1954-06-13	38000177		0	0	14		0	0	0	160168	0	1043400	40229134		
51835	4309	1127078	1963-09-27	1963-09-27 00:00:00	1963-10-11	1963-10-11 00:00:00	1963-10-11	38000177		0	0	14		0	0	0	285897	0	282464	1127078		
71572	1565	40213260	2015-09-20	2015-09-20 00:00:00	2015-09-20	2015-09-20 00:00:00	2015-09-20	581452		0	0	0		0	0	0	104964	0	121	40213260		
143869	3161	40213198	2016-08-24	2016-08-24 00:00:00	2016-08-24	2016-08-24 00:00:00	2016-08-24	581452		0	0	0		0	0	0	210210	0	133	40213198		
63984	5314	1127433	1976-10-04	1976-10-04 00:00:00	1976-10-18	1976-10-18 00:00:00	1976-10-18	38000177		0	0	14		0	0	0	353408	0	313782	1127433		
39832	3295	1127433	1960-05-24	1960-05-24 00:00:00	1960-06-07	1960-06-07 00:00:00	1960-06-07	38000177		0	0	14		0	0	0	218924	0	313782	1127433		
238762	5241	40213160	1967-03-07	1967-03-07 00:00:00	1967-03-07	1967-03-07 00:00:00	1967-03-07	581452		0	0	0		0	0	0	348781	0	10	40213160		
212987	4670	40213227	2005-08-17	2005-08-17 00:00:00	2005-08-17	2005-08-17 00:00:00	2005-08-17	581452		0	0	0		0	0	0	311145	0	113	40213227		
170250	3743	40213160	1978-01-22	1978-01-22 00:00:00	1978-01-22	1978-01-22 00:00:00	1978-01-22	581452		0	0	0		0	0	0	248736	0	10	40213160		
27893	2307	19128065	1982-09-10	1982-09-10 00:00:00	1983-09-05	1983-09-05 00:00:00	1983-09-05	38000177		0	0	360		0	0	0	153533	0	749882	19128065		
229293	5039	40213160	1974-10-29	1974-10-29 00:00:00	1974-10-29	1974-10-29 00:00:00	1974-10-29	581452		0	0	0		0	0	0	334859	0	10	40213160		
130117	2860	40213201	2008-10-03	2008-10-03 00:00:00	2008-10-03	2008-10-03 00:00:00	2008-10-03	581452		0	0	0		0	0	0	190146	0	33	40213201		
29783	649	40213227	2019-02-19	2019-02-19 00:00:00	2019-02-19	2019-02-19 00:00:00	2019-02-19	581452		0	0	0		0	0	0	42973	0	113	40213227		
92497	2030	40213160	1962-07-29	1962-07-29 00:00:00	1962-07-29	1962-07-29 00:00:00	1962-07-29	581452		0	0	0		0	0	0	135147	0	10	40213160		
40073	3314	19133905	1989-06-24	1989-06-24 00:00:00	1989-07-07	1989-07-07 00:00:00	1989-07-07	38000177		0	0	13		0	0	0	220077	0	834102	19133905		
63581	1390	40213260	2017-01-05	2017-01-05 00:00:00	2017-01-05	2017-01-05 00:00:00	2017-01-05	581452		0	0	0		0	0	0	92289	0	121	40213260		
63524	5278	40231925	1984-12-16	1984-12-16 00:00:00	1984-12-16	1984-12-16 00:00:00	\N	38000177		0	0	0		0	0	0	351129	0	1049221	40231925		
165203	3631	40213160	1979-09-27	1979-09-27 00:00:00	1979-09-27	1979-09-27 00:00:00	1979-09-27	581452		0	0	0		0	0	0	241622	0	10	40213160		
231444	5085	40213160	1981-08-20	1981-08-20 00:00:00	1981-08-20	1981-08-20 00:00:00	1981-08-20	581452		0	0	0		0	0	0	338103	0	10	40213160		
214598	4705	40213160	1973-02-22	1973-02-22 00:00:00	1973-02-22	1973-02-22 00:00:00	1973-02-22	581452		0	0	0		0	0	0	313496	0	10	40213160		
169690	3731	40213306	1996-03-02	1996-03-02 00:00:00	1996-03-02	1996-03-02 00:00:00	1996-03-02	581452		0	0	0		0	0	0	247898	0	43	40213306		
201933	4433	40213227	2000-05-20	2000-05-20 00:00:00	2000-05-20	2000-05-20 00:00:00	2000-05-20	581452		0	0	0		0	0	0	294742	0	113	40213227		
199443	4381	40213227	1996-06-04	1996-06-04 00:00:00	1996-06-04	1996-06-04 00:00:00	1996-06-04	581452		0	0	0		0	0	0	291124	0	113	40213227		
192790	4235	40213306	2002-01-03	2002-01-03 00:00:00	2002-01-03	2002-01-03 00:00:00	2002-01-03	581452		0	0	0		0	0	0	281200	0	43	40213306		
193074	4241	40213306	1987-03-03	1987-03-03 00:00:00	1987-03-03	1987-03-03 00:00:00	1987-03-03	581452		0	0	0		0	0	0	281725	0	43	40213306		
151936	3343	40213160	1981-05-17	1981-05-17 00:00:00	1981-05-17	1981-05-17 00:00:00	1981-05-17	581452		0	0	0		0	0	0	221878	0	10	40213160		
38921	3216	19059056	1956-03-26	1956-03-26 00:00:00	1956-04-09	1956-04-09 00:00:00	1956-04-09	38000177		0	0	14		0	0	0	213716	0	243670	19059056		
235600	5174	40213227	2018-10-11	2018-10-11 00:00:00	2018-10-11	2018-10-11 00:00:00	2018-10-11	581452		0	0	0		0	0	0	344015	0	113	40213227		
90700	1990	40213227	2017-06-02	2017-06-02 00:00:00	2017-06-02	2017-06-02 00:00:00	2017-06-02	581452		0	0	0		0	0	0	132523	0	113	40213227		
150545	3311	40213160	1961-03-01	1961-03-01 00:00:00	1961-03-01	1961-03-01 00:00:00	1961-03-01	581452		0	0	0		0	0	0	219820	0	10	40213160		
38157	3157	1127433	1964-07-29	1964-07-29 00:00:00	1964-10-27	1964-10-27 00:00:00	1964-10-27	38000177		0	0	90		0	0	0	209878	0	313782	1127433		
197204	4333	40213160	1956-02-02	1956-02-02 00:00:00	1956-02-02	1956-02-02 00:00:00	1956-02-02	581452		0	0	0		0	0	0	287393	0	10	40213160		
210697	4621	40213160	1976-11-01	1976-11-01 00:00:00	1976-11-01	1976-11-01 00:00:00	1976-11-01	581452		0	0	0		0	0	0	307751	0	10	40213160		
46555	3856	19133873	1983-01-04	1983-01-04 00:00:00	1983-01-11	1983-01-11 00:00:00	1983-01-11	38000177		0	0	7		0	0	0	255920	0	834061	19133873		
63863	1397	40213296	2018-02-09	2018-02-09 00:00:00	2018-02-09	2018-02-09 00:00:00	2018-02-09	581452		0	0	0		0	0	0	\N	0	52	40213296		
29145	2414	19133905	1940-07-07	1940-07-07 00:00:00	1940-07-16	1940-07-16 00:00:00	1940-07-16	38000177		0	0	9		0	0	0	160274	0	834102	19133905		
51836	4309	40229134	1963-01-20	1963-01-20 00:00:00	1963-02-03	1963-02-03 00:00:00	1963-02-03	38000177		0	0	14		0	0	0	285894	0	1043400	40229134		
71574	1565	40213227	2015-09-20	2015-09-20 00:00:00	2015-09-20	2015-09-20 00:00:00	2015-09-20	581452		0	0	0		0	0	0	104964	0	113	40213227		
156327	3440	40213198	2010-08-31	2010-08-31 00:00:00	2010-08-31	2010-08-31 00:00:00	2010-08-31	581452		0	0	0		0	0	0	228315	0	133	40213198		
63985	5315	19059056	1920-09-18	1920-09-18 00:00:00	1920-10-02	1920-10-02 00:00:00	1920-10-02	38000177		0	0	14		0	0	0	353534	0	243670	19059056		
39833	3295	19059056	1952-01-19	1952-01-19 00:00:00	1952-02-18	1952-02-18 00:00:00	1952-02-18	38000177		0	0	30		0	0	0	218894	0	243670	19059056		
238767	5241	40213227	1993-06-08	1993-06-08 00:00:00	1993-06-08	1993-06-08 00:00:00	1993-06-08	581452		0	0	0		0	0	0	348767	0	113	40213227		
212989	4670	40213296	1997-07-23	1997-07-23 00:00:00	1997-07-23	1997-07-23 00:00:00	1997-07-23	581452		0	0	0		0	0	0	311190	0	52	40213296		
170252	3743	40213314	1978-01-22	1978-01-22 00:00:00	1978-01-22	1978-01-22 00:00:00	1978-01-22	581452		0	0	0		0	0	0	248736	0	49	40213314		
27894	2307	1127078	1963-06-25	1963-06-25 00:00:00	1963-07-09	1963-07-09 00:00:00	1963-07-09	38000177		0	0	14		0	0	0	153530	0	282464	1127078		
3916	84	40213160	1974-08-22	1974-08-22 00:00:00	1974-08-22	1974-08-22 00:00:00	1974-08-22	581452		0	0	0		0	0	0	5688	0	10	40213160		
29784	649	40213260	2019-02-19	2019-02-19 00:00:00	2019-02-19	2019-02-19 00:00:00	2019-02-19	581452		0	0	0		0	0	0	42973	0	121	40213260		
92499	2030	40213227	1993-07-04	1993-07-04 00:00:00	1993-07-04	1993-07-04 00:00:00	1993-07-04	581452		0	0	0		0	0	0	135154	0	113	40213227		
40074	3314	40229134	2008-12-21	2008-12-21 00:00:00	2009-01-04	2009-01-04 00:00:00	2009-01-04	38000177		0	0	14		0	0	0	220087	0	1043400	40229134		
63586	1390	40213296	2006-01-05	2006-01-05 00:00:00	2006-01-05	2006-01-05 00:00:00	2006-01-05	581452		0	0	0		0	0	0	92243	0	52	40213296		
63525	5278	1127078	1971-06-28	1971-06-28 00:00:00	1971-09-26	1971-09-26 00:00:00	1971-09-26	38000177		0	0	90		0	0	0	351125	0	282464	1127078		
165207	3631	40213314	1977-11-03	1977-11-03 00:00:00	1977-11-03	1977-11-03 00:00:00	1977-11-03	581452		0	0	0		0	0	0	241626	0	49	40213314		
62273	5184	1124300	2001-05-01	2001-05-01 00:00:00	2001-05-01	2001-05-01 00:00:00	\N	38000177		0	0	0		0	0	0	344581	0	00781178901	45011828		
226	5	40213227	1999-10-06	1999-10-06 00:00:00	1999-10-06	1999-10-06 00:00:00	1999-10-06	581452		0	0	0		0	0	0	463	0	113	40213227		
188062	4129	40213198	2013-06-10	2013-06-10 00:00:00	2013-06-10	2013-06-10 00:00:00	2013-06-10	581452		0	0	0		0	0	0	274505	0	133	40213198		
188099	4130	40213306	1987-01-22	1987-01-22 00:00:00	1987-01-22	1987-01-22 00:00:00	1987-01-22	581452		0	0	0		0	0	0	274572	0	43	40213306		
199445	4381	40213160	1964-09-08	1964-09-08 00:00:00	1964-09-08	1964-09-08 00:00:00	1964-09-08	581452		0	0	0		0	0	0	291097	0	10	40213160		
174239	3831	40213160	1959-03-29	1959-03-29 00:00:00	1959-03-29	1959-03-29 00:00:00	1959-03-29	581452		0	0	0		0	0	0	254387	0	10	40213160		
193084	4241	40213296	2006-09-12	2006-09-12 00:00:00	2006-09-12	2006-09-12 00:00:00	2006-09-12	581452		0	0	0		0	0	0	281715	0	52	40213296		
151940	3343	40213227	2008-07-27	2008-07-27 00:00:00	2008-07-27	2008-07-27 00:00:00	2008-07-27	581452		0	0	0		0	0	0	221819	0	113	40213227		
38922	3216	19006318	1956-03-26	1956-03-26 00:00:00	1956-04-09	1956-04-09 00:00:00	1956-04-09	38000177		0	0	14		0	0	0	213716	0	105078	19006318		
235602	5174	40213227	2008-05-29	2008-05-29 00:00:00	2008-05-29	2008-05-29 00:00:00	2008-05-29	581452		0	0	0		0	0	0	343986	0	113	40213227		
90701	1990	40213260	2017-06-02	2017-06-02 00:00:00	2017-06-02	2017-06-02 00:00:00	2017-06-02	581452		0	0	0		0	0	0	132523	0	121	40213260		
132847	2917	40213201	2002-11-27	2002-11-27 00:00:00	2002-11-27	2002-11-27 00:00:00	2002-11-27	581452		0	0	0		0	0	0	194491	0	33	40213201		
38158	3157	19073188	2011-12-09	2011-12-09 00:00:00	2011-12-23	2011-12-23 00:00:00	2011-12-23	38000177		0	0	14		0	0	0	209887	0	308192	19073188		
34667	757	40213201	1983-02-20	1983-02-20 00:00:00	1983-02-20	1983-02-20 00:00:00	1983-02-20	581452		0	0	0		0	0	0	50271	0	33	40213201		
210703	4621	40213160	1977-01-03	1977-01-03 00:00:00	1977-01-03	1977-01-03 00:00:00	1977-01-03	581452		0	0	0		0	0	0	307750	0	10	40213160		
46556	3856	1713671	1975-04-04	1975-04-04 00:00:00	1975-04-11	1975-04-11 00:00:00	1975-04-11	38000177		0	0	7		0	0	0	255905	0	562251	1713671		
63864	1397	40213227	2018-02-09	2018-02-09 00:00:00	2018-02-09	2018-02-09 00:00:00	2018-02-09	581452		0	0	0		0	0	0	\N	0	113	40213227		
29146	2414	19133768	1994-05-26	1994-05-26 00:00:00	1994-05-26	1994-05-26 00:00:00	1994-05-26	38000177		0	0	0		0	0	0	160252	0	833036	19133768		
51837	4309	19059056	1954-12-02	1954-12-02 00:00:00	1954-12-16	1954-12-16 00:00:00	1954-12-16	38000177		0	0	14		0	0	0	285872	0	243670	19059056		
71578	1565	40213160	1965-05-23	1965-05-23 00:00:00	1965-05-23	1965-05-23 00:00:00	1965-05-23	581452		0	0	0		0	0	0	104899	0	10	40213160		
156334	3440	40213201	2008-08-19	2008-08-19 00:00:00	2008-08-19	2008-08-19 00:00:00	2008-08-19	581452		0	0	0		0	0	0	228314	0	33	40213201		
63986	5315	19059056	1916-09-16	1916-09-16 00:00:00	1916-09-30	1916-09-30 00:00:00	1916-09-30	38000177		0	0	14		0	0	0	353529	0	243670	19059056		
39834	3295	19059056	1944-03-31	1944-03-31 00:00:00	1944-04-14	1944-04-14 00:00:00	1944-04-14	38000177		0	0	14		0	0	0	218975	0	243670	19059056		
238774	5241	40213296	2005-04-19	2005-04-19 00:00:00	2005-04-19	2005-04-19 00:00:00	2005-04-19	581452		0	0	0		0	0	0	348793	0	52	40213296		
212996	4670	40213160	1955-09-07	1955-09-07 00:00:00	1955-09-07	1955-09-07 00:00:00	1955-09-07	581452		0	0	0		0	0	0	311198	0	10	40213160		
170264	3744	40213296	2011-11-13	2011-11-13 00:00:00	2011-11-13	2011-11-13 00:00:00	2011-11-13	581452		0	0	0		0	0	0	248812	0	52	40213296		
27895	2307	1127433	1993-01-20	1993-01-20 00:00:00	1993-02-03	1993-02-03 00:00:00	1993-02-03	38000177		0	0	14		0	0	0	153486	0	313782	1127433		
107327	2352	40213227	2012-03-19	2012-03-19 00:00:00	2012-03-19	2012-03-19 00:00:00	2012-03-19	581452		0	0	0		0	0	0	156614	0	113	40213227		
29786	649	40213160	1973-01-23	1973-01-23 00:00:00	1973-01-23	1973-01-23 00:00:00	1973-01-23	581452		0	0	0		0	0	0	42986	0	10	40213160		
92504	2030	40213296	2003-01-26	2003-01-26 00:00:00	2003-01-26	2003-01-26 00:00:00	2003-01-26	581452		0	0	0		0	0	0	135100	0	52	40213296		
40075	3314	1127433	1999-08-01	1999-08-01 00:00:00	1999-08-08	1999-08-08 00:00:00	1999-08-08	38000177		0	0	7		0	0	0	220078	0	313782	1127433		
63588	1390	40213306	1988-03-03	1988-03-03 00:00:00	1988-03-03	1988-03-03 00:00:00	1988-03-03	581452		0	0	0		0	0	0	92277	0	43	40213306		
63526	5278	1127433	1981-06-07	1981-06-07 00:00:00	1981-06-14	1981-06-14 00:00:00	1981-06-14	38000177		0	0	7		0	0	0	351055	0	313782	1127433		
165209	3631	40213314	1978-05-04	1978-05-04 00:00:00	1978-05-04	1978-05-04 00:00:00	1978-05-04	581452		0	0	0		0	0	0	241621	0	49	40213314		
62274	5184	1127433	2010-02-18	2010-02-18 00:00:00	2010-03-04	2010-03-04 00:00:00	2010-03-04	38000177		0	0	14		0	0	0	344582	0	313782	1127433		
228	5	40213306	1990-09-26	1990-09-26 00:00:00	1990-09-26	1990-09-26 00:00:00	1990-09-26	581452		0	0	0		0	0	0	460	0	43	40213306		
188066	4130	40213306	1986-08-14	1986-08-14 00:00:00	1986-08-14	1986-08-14 00:00:00	1986-08-14	581452		0	0	0		0	0	0	\N	0	43	40213306		
188101	4130	40213260	2016-05-19	2016-05-19 00:00:00	2016-05-19	2016-05-19 00:00:00	2016-05-19	581452		0	0	0		0	0	0	274605	0	121	40213260		
199452	4381	40213306	1986-07-08	1986-07-08 00:00:00	1986-07-08	1986-07-08 00:00:00	1986-07-08	581452		0	0	0		0	0	0	291087	0	43	40213306		
174244	3831	40213227	1995-11-12	1995-11-12 00:00:00	1995-11-12	1995-11-12 00:00:00	1995-11-12	581452		0	0	0		0	0	0	254341	0	113	40213227		
193085	4241	40213227	2006-09-12	2006-09-12 00:00:00	2006-09-12	2006-09-12 00:00:00	2006-09-12	581452		0	0	0		0	0	0	281715	0	113	40213227		
38341	836	40213227	2010-02-14	2010-02-14 00:00:00	2010-02-14	2010-02-14 00:00:00	2010-02-14	581452		0	0	0		0	0	0	55302	0	113	40213227		
23149	502	40213227	1998-01-17	1998-01-17 00:00:00	1998-01-17	1998-01-17 00:00:00	1998-01-17	581452		0	0	0		0	0	0	33619	0	113	40213227		
235606	5174	40213201	2003-05-01	2003-05-01 00:00:00	2003-05-01	2003-05-01 00:00:00	2003-05-01	581452		0	0	0		0	0	0	343977	0	33	40213201		
90707	1990	40213306	1988-12-30	1988-12-30 00:00:00	1988-12-30	1988-12-30 00:00:00	1988-12-30	581452		0	0	0		0	0	0	132516	0	43	40213306		
92296	2026	40213227	2013-03-22	2013-03-22 00:00:00	2013-03-22	2013-03-22 00:00:00	2013-03-22	581452		0	0	0		0	0	0	134836	0	113	40213227		
38159	3157	19078461	2011-12-09	2011-12-09 00:00:00	2011-12-23	2011-12-23 00:00:00	2011-12-23	38000177		0	0	14		0	0	0	209887	0	310965	19078461		
34671	757	40213227	1996-06-16	1996-06-16 00:00:00	1996-06-16	1996-06-16 00:00:00	1996-06-16	581452		0	0	0		0	0	0	50230	0	113	40213227		
210704	4621	40213314	1977-01-03	1977-01-03 00:00:00	1977-01-03	1977-01-03 00:00:00	1977-01-03	581452		0	0	0		0	0	0	307750	0	49	40213314		
46557	3856	1127078	1975-05-26	1975-05-26 00:00:00	1975-06-09	1975-06-09 00:00:00	1975-06-09	38000177		0	0	14		0	0	0	255936	0	282464	1127078		
63867	1397	40213314	1978-01-27	1978-01-27 00:00:00	1978-01-27	1978-01-27 00:00:00	1978-01-27	581452		0	0	0		0	0	0	92739	0	49	40213314		
29147	2414	40229134	1950-06-10	1950-06-10 00:00:00	1950-06-24	1950-06-24 00:00:00	1950-06-24	38000177		0	0	14		0	0	0	160195	0	1043400	40229134		
51838	4309	19006318	1954-12-02	1954-12-02 00:00:00	1954-12-16	1954-12-16 00:00:00	1954-12-16	38000177		0	0	14		0	0	0	285872	0	105078	19006318		
71580	1565	40213160	1964-12-20	1964-12-20 00:00:00	1964-12-20	1964-12-20 00:00:00	1964-12-20	581452		0	0	0		0	0	0	104974	0	10	40213160		
156339	3440	40213227	2013-09-17	2013-09-17 00:00:00	2013-09-17	2013-09-17 00:00:00	2013-09-17	581452		0	0	0		0	0	0	228309	0	113	40213227		
63987	5315	1127433	1942-01-04	1942-01-04 00:00:00	1942-01-18	1942-01-18 00:00:00	1942-01-18	38000177		0	0	14		0	0	0	353528	0	313782	1127433		
39835	3295	19018935	1990-10-08	1990-10-08 00:00:00	1990-10-08	1990-10-08 00:00:00	\N	38000177		0	0	0		0	0	0	218937	0	197604	19018935		
122513	2693	40213260	2008-10-14	2008-10-14 00:00:00	2008-10-14	2008-10-14 00:00:00	2008-10-14	581452		0	0	0		0	0	0	178449	0	121	40213260		
213002	4670	40213227	2015-10-14	2015-10-14 00:00:00	2015-10-14	2015-10-14 00:00:00	2015-10-14	581452		0	0	0		0	0	0	311224	0	113	40213227		
170266	3744	40213227	2011-11-13	2011-11-13 00:00:00	2011-11-13	2011-11-13 00:00:00	2011-11-13	581452		0	0	0		0	0	0	248812	0	113	40213227		
231010	5076	40213227	2009-04-07	2009-04-07 00:00:00	2009-04-07	2009-04-07 00:00:00	2009-04-07	581452		0	0	0		0	0	0	337411	0	113	40213227		
107338	2352	40213160	1975-08-04	1975-08-04 00:00:00	1975-08-04	1975-08-04 00:00:00	1975-08-04	581452		0	0	0		0	0	0	156746	0	10	40213160		
29789	649	40213227	2010-02-23	2010-02-23 00:00:00	2010-02-23	2010-02-23 00:00:00	2010-02-23	581452		0	0	0		0	0	0	42998	0	113	40213227		
92506	2030	40213296	2005-01-30	2005-01-30 00:00:00	2005-01-30	2005-01-30 00:00:00	2005-01-30	581452		0	0	0		0	0	0	135101	0	52	40213296		
40076	3315	19078461	1983-03-08	1983-03-08 00:00:00	1983-03-22	1983-03-22 00:00:00	1983-03-22	38000177		0	0	14		0	0	0	220131	0	310965	19078461		
179897	3955	40213296	1996-02-10	1996-02-10 00:00:00	1996-02-10	1996-02-10 00:00:00	1996-02-10	581452		0	0	0		0	0	0	262843	0	52	40213296		
60799	1328	40213227	2017-04-20	2017-04-20 00:00:00	2017-04-20	2017-04-20 00:00:00	2017-04-20	581452		0	0	0		0	0	0	88174	0	113	40213227		
165210	3631	40213314	1977-05-05	1977-05-05 00:00:00	1977-05-05	1977-05-05 00:00:00	1977-05-05	581452		0	0	0		0	0	0	241587	0	49	40213314		
62275	5184	40229134	1984-01-07	1984-01-07 00:00:00	1984-01-21	1984-01-21 00:00:00	1984-01-21	38000177		0	0	14		0	0	0	344566	0	1043400	40229134		
233	5	40213160	1973-03-28	1973-03-28 00:00:00	1973-03-28	1973-03-28 00:00:00	1973-03-28	581452		0	0	0		0	0	0	489	0	10	40213160		
188069	4130	40213160	1969-10-30	1969-10-30 00:00:00	1969-10-30	1969-10-30 00:00:00	1969-10-30	581452		0	0	0		0	0	0	274574	0	10	40213160		
188103	4130	40213227	2016-05-19	2016-05-19 00:00:00	2016-05-19	2016-05-19 00:00:00	2016-05-19	581452		0	0	0		0	0	0	274605	0	113	40213227		
199456	4381	40213160	1964-11-10	1964-11-10 00:00:00	1964-11-10	1964-11-10 00:00:00	1964-11-10	581452		0	0	0		0	0	0	291079	0	10	40213160		
174249	3831	40213296	1997-11-16	1997-11-16 00:00:00	1997-11-16	1997-11-16 00:00:00	1997-11-16	581452		0	0	0		0	0	0	254338	0	52	40213296		
193087	4241	40213160	1965-07-06	1965-07-06 00:00:00	1965-07-06	1965-07-06 00:00:00	1965-07-06	581452		0	0	0		0	0	0	281695	0	10	40213160		
218724	4800	40213160	1971-02-04	1971-02-04 00:00:00	1971-02-04	1971-02-04 00:00:00	1971-02-04	581452		0	0	0		0	0	0	319309	0	10	40213160		
23158	502	40213198	2012-04-07	2012-04-07 00:00:00	2012-04-07	2012-04-07 00:00:00	2012-04-07	581452		0	0	0		0	0	0	33608	0	133	40213198		
90711	1990	40213160	1971-05-21	1971-05-21 00:00:00	1971-05-21	1971-05-21 00:00:00	1971-05-21	581452		0	0	0		0	0	0	132543	0	10	40213160		
92299	2026	40213160	1956-12-21	1956-12-21 00:00:00	1956-12-21	1956-12-21 00:00:00	1956-12-21	581452		0	0	0		0	0	0	134847	0	10	40213160		
38160	3158	1713671	1957-03-24	1957-03-24 00:00:00	1957-04-07	1957-04-07 00:00:00	1957-04-07	38000177		0	0	14		0	0	0	210008	0	562251	1713671		
25155	549	40213160	1955-06-22	1955-06-22 00:00:00	1955-06-22	1955-06-22 00:00:00	1955-06-22	581452		0	0	0		0	0	0	36429	0	10	40213160		
210706	4621	40213227	2018-08-06	2018-08-06 00:00:00	2018-08-06	2018-08-06 00:00:00	2018-08-06	581452		0	0	0		0	0	0	307768	0	113	40213227		
46558	3856	46233988	1975-05-26	1975-05-26 00:00:00	1975-06-09	1975-06-09 00:00:00	1975-06-09	38000177		0	0	14		0	0	0	255936	0	1652673	46233988		
63870	1397	40213160	1977-04-29	1977-04-29 00:00:00	1977-04-29	1977-04-29 00:00:00	1977-04-29	581452		0	0	0		0	0	0	92738	0	10	40213160		
29148	2414	40229134	1989-07-08	1989-07-08 00:00:00	1989-07-22	1989-07-22 00:00:00	1989-07-22	38000177		0	0	14		0	0	0	160225	0	1043400	40229134		
51839	4309	1713671	1969-11-30	1969-11-30 00:00:00	1969-12-07	1969-12-07 00:00:00	1969-12-07	38000177		0	0	7		0	0	0	285895	0	562251	1713671		
2960	65	40213160	1967-07-07	1967-07-07 00:00:00	1967-07-07	1967-07-07 00:00:00	1967-07-07	581452		0	0	0		0	0	0	4401	0	10	40213160		
220094	4831	40213160	1961-10-05	1961-10-05 00:00:00	1961-10-05	1961-10-05 00:00:00	1961-10-05	581452		0	0	0		0	0	0	321437	0	10	40213160		
63988	5315	1118084	1957-03-25	1957-03-25 00:00:00	1957-03-25	1957-03-25 00:00:00	\N	38000177		0	0	0		0	0	0	353514	0	00025152531	44923712		
39836	3295	40163554	1990-10-08	1990-10-08 00:00:00	1990-10-08	1990-10-08 00:00:00	\N	38000177		0	0	0		0	0	0	218937	0	855332	40163554		
122516	2693	40213306	1981-05-19	1981-05-19 00:00:00	1981-05-19	1981-05-19 00:00:00	1981-05-19	581452		0	0	0		0	0	0	178444	0	43	40213306		
213006	4670	40213260	2007-08-29	2007-08-29 00:00:00	2007-08-29	2007-08-29 00:00:00	2007-08-29	581452		0	0	0		0	0	0	311146	0	121	40213260		
170275	3744	40213227	1992-11-22	1992-11-22 00:00:00	1992-11-22	1992-11-22 00:00:00	1992-11-22	581452		0	0	0		0	0	0	248847	0	113	40213227		
231028	5077	40213296	2006-02-22	2006-02-22 00:00:00	2006-02-22	2006-02-22 00:00:00	2006-02-22	581452		0	0	0		0	0	0	\N	0	52	40213296		
107341	2352	40213306	1993-02-15	1993-02-15 00:00:00	1993-02-15	1993-02-15 00:00:00	1993-02-15	581452		0	0	0		0	0	0	\N	0	43	40213306		
29790	649	40213296	2010-02-23	2010-02-23 00:00:00	2010-02-23	2010-02-23 00:00:00	2010-02-23	581452		0	0	0		0	0	0	42998	0	52	40213296		
92508	2030	40213227	2005-01-30	2005-01-30 00:00:00	2005-01-30	2005-01-30 00:00:00	2005-01-30	581452		0	0	0		0	0	0	135101	0	113	40213227		
40077	3315	19059056	1968-06-28	1968-06-28 00:00:00	1968-08-02	1968-08-02 00:00:00	1968-08-02	38000177		0	0	35		0	0	0	220129	0	243670	19059056		
179900	3955	40213260	2006-02-04	2006-02-04 00:00:00	2006-02-04	2006-02-04 00:00:00	2006-02-04	581452		0	0	0		0	0	0	262896	0	121	40213260		
40387	3347	1713671	2007-03-20	2007-03-20 00:00:00	2007-04-10	2007-04-10 00:00:00	2007-04-10	38000177		0	0	21		0	0	0	222040	0	562251	1713671		
165214	3631	40213296	2014-12-04	2014-12-04 00:00:00	2014-12-04	2014-12-04 00:00:00	2014-12-04	581452		0	0	0		0	0	0	241611	0	52	40213296		
62276	5184	1127433	1990-08-07	1990-08-07 00:00:00	1990-09-11	1990-09-11 00:00:00	1990-09-11	38000177		0	0	35		0	0	0	344594	0	313782	1127433		
235	5	40213227	2010-08-04	2010-08-04 00:00:00	2010-08-04	2010-08-04 00:00:00	2010-08-04	581452		0	0	0		0	0	0	499	0	113	40213227		
188072	4130	40213306	1986-08-07	1986-08-07 00:00:00	1986-08-07	1986-08-07 00:00:00	1986-08-07	581452		0	0	0		0	0	0	\N	0	43	40213306		
188105	4130	40213260	2015-05-14	2015-05-14 00:00:00	2015-05-14	2015-05-14 00:00:00	2015-05-14	581452		0	0	0		0	0	0	274551	0	121	40213260		
199458	4381	40213160	1969-05-13	1969-05-13 00:00:00	1969-05-13	1969-05-13 00:00:00	1969-05-13	581452		0	0	0		0	0	0	291133	0	10	40213160		
174260	3831	40213227	2006-01-01	2006-01-01 00:00:00	2006-01-01	2006-01-01 00:00:00	2006-01-01	581452		0	0	0		0	0	0	254395	0	113	40213227		
193092	4241	40213260	2015-10-06	2015-10-06 00:00:00	2015-10-06	2015-10-06 00:00:00	2015-10-06	581452		0	0	0		0	0	0	281755	0	121	40213260		
218731	4800	40213160	1971-07-09	1971-07-09 00:00:00	1971-07-09	1971-07-09 00:00:00	1971-07-09	581452		0	0	0		0	0	0	319310	0	10	40213160		
23161	502	40213227	2018-11-03	2018-11-03 00:00:00	2018-11-03	2018-11-03 00:00:00	2018-11-03	581452		0	0	0		0	0	0	33632	0	113	40213227		
90715	1990	40213160	1967-02-03	1967-02-03 00:00:00	1967-02-03	1967-02-03 00:00:00	1967-02-03	581452		0	0	0		0	0	0	132541	0	10	40213160		
92305	2026	40213227	2003-01-17	2003-01-17 00:00:00	2003-01-17	2003-01-17 00:00:00	2003-01-17	581452		0	0	0		0	0	0	134839	0	113	40213227		
38161	3158	19075601	2002-01-10	2002-01-10 00:00:00	2002-01-10	2002-01-10 00:00:00	2002-01-10	38000177		0	0	0		0	0	0	209966	0	309362	19075601		
25157	549	40213160	1957-06-26	1957-06-26 00:00:00	1957-06-26	1957-06-26 00:00:00	1957-06-26	581452		0	0	0		0	0	0	36404	0	10	40213160		
210707	4621	40213296	2018-08-06	2018-08-06 00:00:00	2018-08-06	2018-08-06 00:00:00	2018-08-06	581452		0	0	0		0	0	0	307768	0	52	40213296		
23	1	40213201	2015-04-30	2015-04-30 00:00:00	2015-04-30	2015-04-30 00:00:00	2015-04-30	581452		0	0	0		0	0	0	61	0	33	40213201		
63871	1397	40213314	1977-04-29	1977-04-29 00:00:00	1977-04-29	1977-04-29 00:00:00	1977-04-29	581452		0	0	0		0	0	0	92738	0	49	40213314		
29149	2414	1713671	1927-06-25	1927-06-25 00:00:00	1927-07-09	1927-07-09 00:00:00	1927-07-09	38000177		0	0	14		0	0	0	160219	0	562251	1713671		
51840	4309	1127433	1970-11-30	1970-11-30 00:00:00	1970-12-14	1970-12-14 00:00:00	1970-12-14	38000177		0	0	14		0	0	0	285935	0	313782	1127433		
2964	65	40213160	1967-09-08	1967-09-08 00:00:00	1967-09-08	1967-09-08 00:00:00	1967-09-08	581452		0	0	0		0	0	0	4427	0	10	40213160		
220097	4831	40213260	2012-02-02	2012-02-02 00:00:00	2012-02-02	2012-02-02 00:00:00	2012-02-02	581452		0	0	0		0	0	0	321461	0	121	40213260		
63989	5315	19126352	1967-12-10	1967-12-10 00:00:00	1979-04-15	1979-04-15 00:00:00	1979-04-15	38000177		0	0	4144		0	0	0	353479	0	705129	19126352		
39837	3295	40171902	1990-10-08	1990-10-08 00:00:00	1990-10-08	1990-10-08 00:00:00	\N	38000177		0	0	0		0	0	0	218937	0	897718	40171902		
122527	2693	40213227	1993-06-01	1993-06-01 00:00:00	1993-06-01	1993-06-01 00:00:00	1993-06-01	581452		0	0	0		0	0	0	178414	0	113	40213227		
224294	4924	40213306	2000-10-04	2000-10-04 00:00:00	2000-10-04	2000-10-04 00:00:00	2000-10-04	581452		0	0	0		0	0	0	327187	0	43	40213306		
140036	3076	40213227	1993-06-16	1993-06-16 00:00:00	1993-06-16	1993-06-16 00:00:00	1993-06-16	581452		0	0	0		0	0	0	204680	0	113	40213227		
231034	5077	40213227	2007-08-22	2007-08-22 00:00:00	2007-08-22	2007-08-22 00:00:00	2007-08-22	581452		0	0	0		0	0	0	337462	0	113	40213227		
107346	2352	40213306	1993-02-22	1993-02-22 00:00:00	1993-02-22	1993-02-22 00:00:00	1993-02-22	581452		0	0	0		0	0	0	\N	0	43	40213306		
29791	649	40213227	1999-07-20	1999-07-20 00:00:00	1999-07-20	1999-07-20 00:00:00	1999-07-20	581452		0	0	0		0	0	0	43006	0	113	40213227		
92510	2030	40213306	1984-06-17	1984-06-17 00:00:00	1984-06-17	1984-06-17 00:00:00	1984-06-17	581452		0	0	0		0	0	0	135098	0	43	40213306		
40078	3315	40165015	2006-09-24	2006-09-24 00:00:00	2006-09-24	2006-09-24 00:00:00	\N	38000177		0	0	0		0	0	0	220134	0	861467	40165015		
40388	3347	920300	2005-06-11	2005-06-11 00:00:00	2005-06-18	2005-06-18 00:00:00	2005-06-18	38000177		0	0	7		0	0	0	222024	0	311989	920300		
158462	3488	40213160	1959-01-30	1959-01-30 00:00:00	1959-01-30	1959-01-30 00:00:00	1959-01-30	581452		0	0	0		0	0	0	231351	0	10	40213160		
62277	5184	19007333	2017-06-06	2017-06-06 00:00:00	2017-06-06	2017-06-06 00:00:00	\N	38000177		0	0	0		0	0	0	344568	0	105586	19007333		
236	5	40213296	2010-08-04	2010-08-04 00:00:00	2010-08-04	2010-08-04 00:00:00	2010-08-04	581452		0	0	0		0	0	0	499	0	52	40213296		
188079	4130	40213227	2006-11-30	2006-11-30 00:00:00	2006-11-30	2006-11-30 00:00:00	2006-11-30	581452		0	0	0		0	0	0	274656	0	113	40213227		
188110	4130	40213296	2004-11-25	2004-11-25 00:00:00	2004-11-25	2004-11-25 00:00:00	2004-11-25	581452		0	0	0		0	0	0	274578	0	52	40213296		
199460	4381	40213260	2014-07-22	2014-07-22 00:00:00	2014-07-22	2014-07-22 00:00:00	2014-07-22	581452		0	0	0		0	0	0	291126	0	121	40213260		
174261	3831	40213260	2006-01-01	2006-01-01 00:00:00	2006-01-01	2006-01-01 00:00:00	2006-01-01	581452		0	0	0		0	0	0	254395	0	121	40213260		
193096	4241	40213260	2016-10-11	2016-10-11 00:00:00	2016-10-11	2016-10-11 00:00:00	2016-10-11	581452		0	0	0		0	0	0	281717	0	121	40213260		
218737	4800	40213306	1993-07-09	1993-07-09 00:00:00	1993-07-09	1993-07-09 00:00:00	1993-07-09	581452		0	0	0		0	0	0	319318	0	43	40213306		
23169	502	40213201	2013-04-13	2013-04-13 00:00:00	2013-04-13	2013-04-13 00:00:00	2013-04-13	581452		0	0	0		0	0	0	33580	0	33	40213201		
90717	1990	40213160	1966-09-02	1966-09-02 00:00:00	1966-09-02	1966-09-02 00:00:00	1966-09-02	581452		0	0	0		0	0	0	132540	0	10	40213160		
92310	2026	40213260	2006-02-03	2006-02-03 00:00:00	2006-02-03	2006-02-03 00:00:00	2006-02-03	581452		0	0	0		0	0	0	134783	0	121	40213260		
38162	3158	40220960	2002-01-10	2002-01-10 00:00:00	2002-01-10	2002-01-10 00:00:00	2002-01-10	38000177		0	0	0		0	0	0	209966	0	1804799	40220960		
25167	549	40213198	2017-09-27	2017-09-27 00:00:00	2017-09-27	2017-09-27 00:00:00	2017-09-27	581452		0	0	0		0	0	0	36398	0	133	40213198		
210709	4621	40213251	1984-07-23	1984-07-23 00:00:00	1984-07-23	1984-07-23 00:00:00	1984-07-23	581452		0	0	0		0	0	0	307734	0	21	40213251		
26	1	40213160	1955-01-13	1955-01-13 00:00:00	1955-01-13	1955-01-13 00:00:00	1955-01-13	581452		0	0	0		0	0	0	68	0	10	40213160		
63876	1397	40213251	1984-11-16	1984-11-16 00:00:00	1984-11-16	1984-11-16 00:00:00	1984-11-16	581452		0	0	0		0	0	0	92829	0	21	40213251		
29150	2414	19133873	1921-08-18	1921-08-18 00:00:00	1921-08-31	1921-08-31 00:00:00	1921-08-31	38000177		0	0	13		0	0	0	160218	0	834061	19133873		
51841	4309	19129655	1970-11-30	1970-11-30 00:00:00	1970-12-14	1970-12-14 00:00:00	1970-12-14	38000177		0	0	14		0	0	0	285935	0	789980	19129655		
2966	65	40213160	1967-12-08	1967-12-08 00:00:00	1967-12-08	1967-12-08 00:00:00	1967-12-08	581452		0	0	0		0	0	0	4435	0	10	40213160		
220108	4831	40213260	2013-02-07	2013-02-07 00:00:00	2013-02-07	2013-02-07 00:00:00	2013-02-07	581452		0	0	0		0	0	0	321415	0	121	40213260		
63990	5315	1127433	1957-09-09	1957-09-09 00:00:00	1957-09-23	1957-09-23 00:00:00	1957-09-23	38000177		0	0	14		0	0	0	353501	0	313782	1127433		
39838	3295	1127433	1956-04-07	1956-04-07 00:00:00	1956-04-14	1956-04-14 00:00:00	1956-04-14	38000177		0	0	7		0	0	0	218877	0	313782	1127433		
122532	2693	40213160	1959-03-24	1959-03-24 00:00:00	1959-03-24	1959-03-24 00:00:00	1959-03-24	581452		0	0	0		0	0	0	178395	0	10	40213160		
224297	4924	40213306	2001-04-04	2001-04-04 00:00:00	2001-04-04	2001-04-04 00:00:00	2001-04-04	581452		0	0	0		0	0	0	327242	0	43	40213306		
140039	3076	40213201	2015-09-02	2015-09-02 00:00:00	2015-09-02	2015-09-02 00:00:00	2015-09-02	581452		0	0	0		0	0	0	204639	0	33	40213201		
231036	5077	40213160	1965-08-25	1965-08-25 00:00:00	1965-08-25	1965-08-25 00:00:00	1965-08-25	581452		0	0	0		0	0	0	337452	0	10	40213160		
107348	2352	40213160	1971-02-01	1971-02-01 00:00:00	1971-02-01	1971-02-01 00:00:00	1971-02-01	581452		0	0	0		0	0	0	156743	0	10	40213160		
29799	649	40213306	1990-07-10	1990-07-10 00:00:00	1990-07-10	1990-07-10 00:00:00	1990-07-10	581452		0	0	0		0	0	0	43003	0	43	40213306		
92516	2030	40213160	1967-04-02	1967-04-02 00:00:00	1967-04-02	1967-04-02 00:00:00	1967-04-02	581452		0	0	0		0	0	0	135130	0	10	40213160		
40079	3315	1118084	1990-10-11	1990-10-11 00:00:00	1990-10-11	1990-10-11 00:00:00	\N	38000177		0	0	0		0	0	0	220207	0	00025152531	44923712		
40389	3347	40236824	2005-06-11	2005-06-11 00:00:00	2005-06-18	2005-06-18 00:00:00	2005-06-18	38000177		0	0	7		0	0	0	222024	0	1094107	40236824		
158470	3488	40213260	2007-02-23	2007-02-23 00:00:00	2007-02-23	2007-02-23 00:00:00	2007-02-23	581452		0	0	0		0	0	0	231376	0	121	40213260		
62278	5184	19019273	2017-06-06	2017-06-06 00:00:00	2017-06-06	2017-06-06 00:00:00	\N	38000177		0	0	0		0	0	0	344568	0	198014	19019273		
238	5	40213296	2008-07-30	2008-07-30 00:00:00	2008-07-30	2008-07-30 00:00:00	2008-07-30	581452		0	0	0		0	0	0	466	0	52	40213296		
188080	4130	40213296	2006-11-30	2006-11-30 00:00:00	2006-11-30	2006-11-30 00:00:00	2006-11-30	581452		0	0	0		0	0	0	274656	0	52	40213296		
188114	4130	40213160	1965-07-29	1965-07-29 00:00:00	1965-07-29	1965-07-29 00:00:00	1965-07-29	581452		0	0	0		0	0	0	274648	0	10	40213160		
187554	4119	40213227	1995-07-29	1995-07-29 00:00:00	1995-07-29	1995-07-29 00:00:00	1995-07-29	581452		0	0	0		0	0	0	273806	0	113	40213227		
174265	3832	40213180	2006-02-09	2006-02-09 00:00:00	2006-02-09	2006-02-09 00:00:00	2006-02-09	581452		0	0	0		0	0	0	254431	0	114	40213180		
193098	4241	40213227	2016-10-11	2016-10-11 00:00:00	2016-10-11	2016-10-11 00:00:00	2016-10-11	581452		0	0	0		0	0	0	281717	0	113	40213227		
218738	4800	40213227	1993-07-09	1993-07-09 00:00:00	1993-07-09	1993-07-09 00:00:00	1993-07-09	581452		0	0	0		0	0	0	319318	0	113	40213227		
131531	2890	40213160	1962-08-17	1962-08-17 00:00:00	1962-08-17	1962-08-17 00:00:00	1962-08-17	581452		0	0	0		0	0	0	192204	0	10	40213160		
90731	1991	40213227	1994-10-17	1994-10-17 00:00:00	1994-10-17	1994-10-17 00:00:00	1994-10-17	581452		0	0	0		0	0	0	132600	0	113	40213227		
92322	2027	40213227	2002-11-08	2002-11-08 00:00:00	2002-11-08	2002-11-08 00:00:00	2002-11-08	581452		0	0	0		0	0	0	\N	0	113	40213227		
38163	3158	1713671	2001-07-08	2001-07-08 00:00:00	2001-07-15	2001-07-15 00:00:00	2001-07-15	38000177		0	0	7		0	0	0	209966	0	562251	1713671		
25170	549	40213227	2004-06-30	2004-06-30 00:00:00	2004-06-30	2004-06-30 00:00:00	2004-06-30	581452		0	0	0		0	0	0	36436	0	113	40213227		
210713	4621	40213314	1977-04-04	1977-04-04 00:00:00	1977-04-04	1977-04-04 00:00:00	1977-04-04	581452		0	0	0		0	0	0	307731	0	49	40213314		
42	1	40213227	1993-02-11	1993-02-11 00:00:00	1993-02-11	1993-02-11 00:00:00	1993-02-11	581452		0	0	0		0	0	0	19	0	113	40213227		
106354	2332	40213296	1997-04-26	1997-04-26 00:00:00	1997-04-26	1997-04-26 00:00:00	1997-04-26	581452		0	0	0		0	0	0	155055	0	52	40213296		
29151	2414	40223774	1997-08-24	1997-08-24 00:00:00	1997-08-24	1997-08-24 00:00:00	\N	38000177		0	0	0		0	0	0	160199	0	998582	40223774		
51842	4309	19059056	1967-10-25	1967-10-25 00:00:00	1967-11-22	1967-11-22 00:00:00	1967-11-22	38000177		0	0	28		0	0	0	285944	0	243670	19059056		
2978	66	40213260	2009-05-22	2009-05-22 00:00:00	2009-05-22	2009-05-22 00:00:00	2009-05-22	581452		0	0	0		0	0	0	4472	0	121	40213260		
220110	4831	40213227	2013-02-07	2013-02-07 00:00:00	2013-02-07	2013-02-07 00:00:00	2013-02-07	581452		0	0	0		0	0	0	321415	0	113	40213227		
63991	5315	1127433	1949-10-23	1949-10-23 00:00:00	1949-11-06	1949-11-06 00:00:00	1949-11-06	38000177		0	0	14		0	0	0	353533	0	313782	1127433		
39839	3295	1713671	1947-03-13	1947-03-13 00:00:00	1947-03-20	1947-03-20 00:00:00	1947-03-20	38000177		0	0	7		0	0	0	218916	0	562251	1713671		
122534	2693	40213160	1959-06-23	1959-06-23 00:00:00	1959-06-23	1959-06-23 00:00:00	1959-06-23	581452		0	0	0		0	0	0	178431	0	10	40213160		
140057	3076	40213160	1955-05-18	1955-05-18 00:00:00	1955-05-18	1955-05-18 00:00:00	1955-05-18	581452		0	0	0		0	0	0	204668	0	10	40213160		
231040	5077	40213160	1965-06-23	1965-06-23 00:00:00	1965-06-23	1965-06-23 00:00:00	1965-06-23	581452		0	0	0		0	0	0	337492	0	10	40213160		
107352	2352	40213227	2004-03-08	2004-03-08 00:00:00	2004-03-08	2004-03-08 00:00:00	2004-03-08	581452		0	0	0		0	0	0	156632	0	113	40213227		
29801	649	40213160	1968-05-21	1968-05-21 00:00:00	1968-05-21	1968-05-21 00:00:00	1968-05-21	581452		0	0	0		0	0	0	43011	0	10	40213160		
210122	4607	40213160	1972-09-28	1972-09-28 00:00:00	1972-09-28	1972-09-28 00:00:00	1972-09-28	581452		0	0	0		0	0	0	306924	0	10	40213160		
40080	3315	1127433	2006-09-17	2006-09-17 00:00:00	2006-10-24	2006-10-24 00:00:00	2006-10-24	38000177		0	0	37		0	0	0	220132	0	313782	1127433		
40390	3347	1115171	2008-06-10	2008-06-10 00:00:00	2008-07-01	2008-07-01 00:00:00	2008-07-01	38000177		0	0	21		0	0	0	222021	0	849574	1115171		
158474	3488	40213160	1955-01-28	1955-01-28 00:00:00	1955-01-28	1955-01-28 00:00:00	1955-01-28	581452		0	0	0		0	0	0	231391	0	10	40213160		
62279	5185	19059056	1949-08-01	1949-08-01 00:00:00	1949-08-15	1949-08-15 00:00:00	1949-08-15	38000177		0	0	14		0	0	0	344600	0	243670	19059056		
241	5	40213160	1969-04-02	1969-04-02 00:00:00	1969-04-02	1969-04-02 00:00:00	1969-04-02	581452		0	0	0		0	0	0	530	0	10	40213160		
188091	4130	40213227	1996-07-25	1996-07-25 00:00:00	1996-07-25	1996-07-25 00:00:00	1996-07-25	581452		0	0	0		0	0	0	274601	0	113	40213227		
188117	4130	40213160	1965-04-29	1965-04-29 00:00:00	1965-04-29	1965-04-29 00:00:00	1965-04-29	581452		0	0	0		0	0	0	274612	0	10	40213160		
187585	4119	40213227	2015-11-14	2015-11-14 00:00:00	2015-11-14	2015-11-14 00:00:00	2015-11-14	581452		0	0	0		0	0	0	273863	0	113	40213227		
174266	3832	40213306	2006-02-09	2006-02-09 00:00:00	2006-02-09	2006-02-09 00:00:00	2006-02-09	581452		0	0	0		0	0	0	254431	0	43	40213306		
193103	4241	40213227	1996-02-13	1996-02-13 00:00:00	1996-02-13	1996-02-13 00:00:00	1996-02-13	581452		0	0	0		0	0	0	281765	0	113	40213227		
174337	3833	40213260	2016-04-06	2016-04-06 00:00:00	2016-04-06	2016-04-06 00:00:00	2016-04-06	581452		0	0	0		0	0	0	254509	0	121	40213260		
131534	2890	40213160	1962-05-18	1962-05-18 00:00:00	1962-05-18	1962-05-18 00:00:00	1962-05-18	581452		0	0	0		0	0	0	192248	0	10	40213160		
90733	1991	40213227	2004-12-13	2004-12-13 00:00:00	2004-12-13	2004-12-13 00:00:00	2004-12-13	581452		0	0	0		0	0	0	132583	0	113	40213227		
92323	2027	40213296	2002-11-08	2002-11-08 00:00:00	2002-11-08	2002-11-08 00:00:00	2002-11-08	581452		0	0	0		0	0	0	\N	0	52	40213296		
38164	3158	19059056	1964-05-22	1964-05-22 00:00:00	1964-06-21	1964-06-21 00:00:00	1964-06-21	38000177		0	0	30		0	0	0	209945	0	243670	19059056		
229009	5031	40213227	1992-08-29	1992-08-29 00:00:00	1992-08-29	1992-08-29 00:00:00	1992-08-29	581452		0	0	0		0	0	0	334295	0	113	40213227		
210714	4621	40213160	1977-04-04	1977-04-04 00:00:00	1977-04-04	1977-04-04 00:00:00	1977-04-04	581452		0	0	0		0	0	0	307731	0	10	40213160		
162058	3565	40213227	1995-03-11	1995-03-11 00:00:00	1995-03-11	1995-03-11 00:00:00	1995-03-11	581452		0	0	0		0	0	0	236794	0	113	40213227		
106356	2332	40213160	1957-10-05	1957-10-05 00:00:00	1957-10-05	1957-10-05 00:00:00	1957-10-05	581452		0	0	0		0	0	0	155088	0	10	40213160		
29152	2414	40163554	1994-08-18	1994-08-18 00:00:00	1994-08-18	1994-08-18 00:00:00	\N	38000177		0	0	0		0	0	0	160263	0	855332	40163554		
9468	787	1713671	1985-08-05	1985-08-05 00:00:00	1985-08-19	1985-08-19 00:00:00	1985-08-19	38000177		0	0	14		0	0	0	52347	0	562251	1713671		
2980	66	40213296	2002-05-03	2002-05-03 00:00:00	2002-05-03	2002-05-03 00:00:00	2002-05-03	581452		0	0	0		0	0	0	4483	0	52	40213296		
220116	4831	40213160	1962-01-04	1962-01-04 00:00:00	1962-01-04	1962-01-04 00:00:00	1962-01-04	581452		0	0	0		0	0	0	321422	0	10	40213160		
63992	5315	19133905	1944-04-19	1944-04-19 00:00:00	1944-05-02	1944-05-02 00:00:00	1944-05-02	38000177		0	0	13		0	0	0	353500	0	834102	19133905		
39840	3295	1127433	1944-06-01	1944-06-01 00:00:00	1944-06-08	1944-06-08 00:00:00	1944-06-08	38000177		0	0	7		0	0	0	218872	0	313782	1127433		
122535	2693	40213227	2000-10-24	2000-10-24 00:00:00	2000-10-24	2000-10-24 00:00:00	2000-10-24	581452		0	0	0		0	0	0	178416	0	113	40213227		
140058	3076	40213227	2010-08-04	2010-08-04 00:00:00	2010-08-04	2010-08-04 00:00:00	2010-08-04	581452		0	0	0		0	0	0	204656	0	113	40213227		
231043	5077	40213260	2015-06-03	2015-06-03 00:00:00	2015-06-03	2015-06-03 00:00:00	2015-06-03	581452		0	0	0		0	0	0	337441	0	121	40213260		
107355	2352	40213160	1971-05-03	1971-05-03 00:00:00	1971-05-03	1971-05-03 00:00:00	1971-05-03	581452		0	0	0		0	0	0	156606	0	10	40213160		
29808	649	40213296	2008-02-19	2008-02-19 00:00:00	2008-02-19	2008-02-19 00:00:00	2008-02-19	581452		0	0	0		0	0	0	42975	0	52	40213296		
210124	4607	40213160	1972-06-29	1972-06-29 00:00:00	1972-06-29	1972-06-29 00:00:00	1972-06-29	581452		0	0	0		0	0	0	306914	0	10	40213160		
40081	3315	40236824	2004-05-15	2004-05-15 00:00:00	2004-05-22	2004-05-22 00:00:00	2004-05-22	38000177		0	0	7		0	0	0	220144	0	1094107	40236824		
40391	3347	1127433	1982-02-18	1982-02-18 00:00:00	1982-02-25	1982-02-25 00:00:00	1982-02-25	38000177		0	0	7		0	0	0	222068	0	313782	1127433		
158486	3489	40213227	1995-03-18	1995-03-18 00:00:00	1995-03-18	1995-03-18 00:00:00	1995-03-18	581452		0	0	0		0	0	0	231431	0	113	40213227		
62280	5185	19078461	2002-11-26	2002-11-26 00:00:00	2003-01-02	2003-01-02 00:00:00	2003-01-02	38000177		0	0	37		0	0	0	344725	0	310965	19078461		
243	5	40213160	1969-01-01	1969-01-01 00:00:00	1969-01-01	1969-01-01 00:00:00	1969-01-01	581452		0	0	0		0	0	0	447	0	10	40213160		
188094	4130	40213160	1965-02-25	1965-02-25 00:00:00	1965-02-25	1965-02-25 00:00:00	1965-02-25	581452		0	0	0		0	0	0	274564	0	10	40213160		
188122	4131	40213314	1977-08-19	1977-08-19 00:00:00	1977-08-19	1977-08-19 00:00:00	1977-08-19	581452		0	0	0		0	0	0	274724	0	49	40213314		
29446	642	40213227	1996-12-15	1996-12-15 00:00:00	1996-12-15	1996-12-15 00:00:00	1996-12-15	581452		0	0	0		0	0	0	42534	0	113	40213227		
174269	3832	40213227	2006-02-09	2006-02-09 00:00:00	2006-02-09	2006-02-09 00:00:00	2006-02-09	581452		0	0	0		0	0	0	254431	0	113	40213227		
131117	2882	40213227	2013-08-23	2013-08-23 00:00:00	2013-08-23	2013-08-23 00:00:00	2013-08-23	581452		0	0	0		0	0	0	191718	0	113	40213227		
174339	3833	40213296	2009-03-18	2009-03-18 00:00:00	2009-03-18	2009-03-18 00:00:00	2009-03-18	581452		0	0	0		0	0	0	254487	0	52	40213296		
131537	2891	40213314	1977-10-27	1977-10-27 00:00:00	1977-10-27	1977-10-27 00:00:00	1977-10-27	581452		0	0	0		0	0	0	192386	0	49	40213314		
163462	3595	40213227	2000-11-16	2000-11-16 00:00:00	2000-11-16	2000-11-16 00:00:00	2000-11-16	581452		0	0	0		0	0	0	238865	0	113	40213227		
92331	2027	40213227	2012-03-23	2012-03-23 00:00:00	2012-03-23	2012-03-23 00:00:00	2012-03-23	581452		0	0	0		0	0	0	134895	0	113	40213227		
38165	3158	19133873	1949-12-24	1949-12-24 00:00:00	1949-12-31	1949-12-31 00:00:00	1949-12-31	38000177		0	0	7		0	0	0	209993	0	834061	19133873		
208525	4574	40213260	2006-03-17	2006-03-17 00:00:00	2006-03-17	2006-03-17 00:00:00	2006-03-17	581452		0	0	0		0	0	0	304714	0	121	40213260		
210724	4622	40213160	1961-01-05	1961-01-05 00:00:00	1961-01-05	1961-01-05 00:00:00	1961-01-05	581452		0	0	0		0	0	0	307804	0	10	40213160		
162087	3565	40213201	2010-12-11	2010-12-11 00:00:00	2010-12-11	2010-12-11 00:00:00	2010-12-11	581452		0	0	0		0	0	0	236764	0	33	40213201		
106358	2332	40213260	2007-04-21	2007-04-21 00:00:00	2007-04-21	2007-04-21 00:00:00	2007-04-21	581452		0	0	0		0	0	0	155057	0	121	40213260		
29153	2414	19018935	1994-08-18	1994-08-18 00:00:00	1994-08-18	1994-08-18 00:00:00	\N	38000177		0	0	0		0	0	0	160263	0	197604	19018935		
9469	787	19133873	1988-06-14	1988-06-14 00:00:00	1988-06-26	1988-06-26 00:00:00	1988-06-26	38000177		0	0	12		0	0	0	52348	0	834061	19133873		
2986	66	40213260	2010-05-28	2010-05-28 00:00:00	2010-05-28	2010-05-28 00:00:00	2010-05-28	581452		0	0	0		0	0	0	4466	0	121	40213260		
220118	4831	40213227	2003-01-09	2003-01-09 00:00:00	2003-01-09	2003-01-09 00:00:00	2003-01-09	581452		0	0	0		0	0	0	321413	0	113	40213227		
63993	5315	19059056	1917-10-22	1917-10-22 00:00:00	1917-11-05	1917-11-05 00:00:00	1917-11-05	38000177		0	0	14		0	0	0	353530	0	243670	19059056		
230642	5068	40213227	1992-08-22	1992-08-22 00:00:00	1992-08-22	1992-08-22 00:00:00	1992-08-22	581452		0	0	0		0	0	0	336909	0	113	40213227		
122536	2693	40213296	2000-10-24	2000-10-24 00:00:00	2000-10-24	2000-10-24 00:00:00	2000-10-24	581452		0	0	0		0	0	0	178416	0	52	40213296		
140062	3077	40213227	1994-07-27	1994-07-27 00:00:00	1994-07-27	1994-07-27 00:00:00	1994-07-27	581452		0	0	0		0	0	0	204777	0	113	40213227		
84322	1844	40213227	1994-01-04	1994-01-04 00:00:00	1994-01-04	1994-01-04 00:00:00	1994-01-04	581452		0	0	0		0	0	0	123164	0	113	40213227		
107358	2352	40213160	1971-04-05	1971-04-05 00:00:00	1971-04-05	1971-04-05 00:00:00	1971-04-05	581452		0	0	0		0	0	0	156607	0	10	40213160		
47479	1036	40213160	1974-08-16	1974-08-16 00:00:00	1974-08-16	1974-08-16 00:00:00	1974-08-16	581452		0	0	0		0	0	0	68128	0	10	40213160		
210126	4607	40213227	2014-02-13	2014-02-13 00:00:00	2014-02-13	2014-02-13 00:00:00	2014-02-13	581452		0	0	0		0	0	0	306907	0	113	40213227		
40082	3315	920300	2004-05-15	2004-05-15 00:00:00	2004-05-22	2004-05-22 00:00:00	2004-05-22	38000177		0	0	7		0	0	0	220144	0	311989	920300		
40392	3347	1127433	2005-04-29	2005-04-29 00:00:00	2005-05-27	2005-05-27 00:00:00	2005-05-27	38000177		0	0	28		0	0	0	222020	0	313782	1127433		
158487	3489	40213306	1995-03-18	1995-03-18 00:00:00	1995-03-18	1995-03-18 00:00:00	1995-03-18	581452		0	0	0		0	0	0	231431	0	43	40213306		
62281	5185	46275916	1961-11-13	1961-11-13 00:00:00	1961-11-13	1961-11-13 00:00:00	1961-11-13	38000177		0	0	0		0	0	0	344602	0	1660014	46275916		
251	5	40213160	1968-10-30	1968-10-30 00:00:00	1968-10-30	1968-10-30 00:00:00	1968-10-30	581452		0	0	0		0	0	0	529	0	10	40213160		
194638	4276	40213160	1957-12-05	1957-12-05 00:00:00	1957-12-05	1957-12-05 00:00:00	1957-12-05	581452		0	0	0		0	0	0	283787	0	10	40213160		
199409	4380	40213260	2014-04-21	2014-04-21 00:00:00	2014-04-21	2014-04-21 00:00:00	2014-04-21	581452		0	0	0		0	0	0	291007	0	121	40213260		
212785	4666	40213160	1972-10-09	1972-10-09 00:00:00	1972-10-09	1972-10-09 00:00:00	1972-10-09	581452		0	0	0		0	0	0	310937	0	10	40213160		
174273	3832	40213160	1984-09-20	1984-09-20 00:00:00	1984-09-20	1984-09-20 00:00:00	1984-09-20	581452		0	0	0		0	0	0	254418	0	10	40213160		
131118	2882	40213296	2013-08-23	2013-08-23 00:00:00	2013-08-23	2013-08-23 00:00:00	2013-08-23	581452		0	0	0		0	0	0	191718	0	52	40213296		
174346	3833	40213227	2007-03-14	2007-03-14 00:00:00	2007-03-14	2007-03-14 00:00:00	2007-03-14	581452		0	0	0		0	0	0	254547	0	113	40213227		
131539	2891	40213160	1974-02-28	1974-02-28 00:00:00	1974-02-28	1974-02-28 00:00:00	1974-02-28	581452		0	0	0		0	0	0	192292	0	10	40213160		
143629	3157	40213227	2014-02-07	2014-02-07 00:00:00	2014-02-07	2014-02-07 00:00:00	2014-02-07	581452		0	0	0		0	0	0	209829	0	113	40213227		
92332	2027	40213260	2012-03-23	2012-03-23 00:00:00	2012-03-23	2012-03-23 00:00:00	2012-03-23	581452		0	0	0		0	0	0	134895	0	121	40213260		
38166	3158	1127433	1979-02-12	1979-02-12 00:00:00	1979-02-26	1979-02-26 00:00:00	1979-02-26	38000177		0	0	14		0	0	0	209916	0	313782	1127433		
208528	4574	40213160	1956-11-23	1956-11-23 00:00:00	1956-11-23	1956-11-23 00:00:00	1956-11-23	581452		0	0	0		0	0	0	304751	0	10	40213160		
210727	4622	40213160	1956-10-04	1956-10-04 00:00:00	1956-10-04	1956-10-04 00:00:00	1956-10-04	581452		0	0	0		0	0	0	307785	0	10	40213160		
112223	2466	40213251	1984-09-02	1984-09-02 00:00:00	1984-09-02	1984-09-02 00:00:00	1984-09-02	581452		0	0	0		0	0	0	163496	0	21	40213251		
106359	2332	40213260	2008-04-26	2008-04-26 00:00:00	2008-04-26	2008-04-26 00:00:00	2008-04-26	581452		0	0	0		0	0	0	155096	0	121	40213260		
29154	2414	19126352	1994-08-18	1994-08-18 00:00:00	2000-04-27	2000-04-27 00:00:00	2000-04-27	38000177		0	0	2079		0	0	0	160263	0	705129	19126352		
9470	787	1127078	1979-07-11	1979-07-11 00:00:00	1979-08-15	1979-08-15 00:00:00	1979-08-15	38000177		0	0	35		0	0	0	52344	0	282464	1127078		
2988	66	40213227	2010-05-28	2010-05-28 00:00:00	2010-05-28	2010-05-28 00:00:00	2010-05-28	581452		0	0	0		0	0	0	4466	0	113	40213227		
220119	4831	40213296	2003-01-09	2003-01-09 00:00:00	2003-01-09	2003-01-09 00:00:00	2003-01-09	581452		0	0	0		0	0	0	321413	0	52	40213296		
63994	5315	1127433	1977-03-02	1977-03-02 00:00:00	1977-03-16	1977-03-16 00:00:00	1977-03-16	38000177		0	0	14		0	0	0	353504	0	313782	1127433		
230656	5068	40213201	1997-09-20	1997-09-20 00:00:00	1997-09-20	1997-09-20 00:00:00	1997-09-20	581452		0	0	0		0	0	0	336972	0	33	40213201		
122539	2693	40213227	2009-10-20	2009-10-20 00:00:00	2009-10-20	2009-10-20 00:00:00	2009-10-20	581452		0	0	0		0	0	0	178390	0	113	40213227		
140065	3077	40213160	1955-05-04	1955-05-04 00:00:00	1955-05-04	1955-05-04 00:00:00	1955-05-04	581452		0	0	0		0	0	0	204772	0	10	40213160		
84324	1844	40213160	1963-06-25	1963-06-25 00:00:00	1963-06-25	1963-06-25 00:00:00	1963-06-25	581452		0	0	0		0	0	0	\N	0	10	40213160		
107369	2352	40213296	2013-02-18	2013-02-18 00:00:00	2013-02-18	2013-02-18 00:00:00	2013-02-18	581452		0	0	0		0	0	0	\N	0	52	40213296		
30051	654	40213306	1984-04-20	1984-04-20 00:00:00	1984-04-20	1984-04-20 00:00:00	1984-04-20	581452		0	0	0		0	0	0	43305	0	43	40213306		
210127	4607	40213296	2014-02-13	2014-02-13 00:00:00	2014-02-13	2014-02-13 00:00:00	2014-02-13	581452		0	0	0		0	0	0	306907	0	52	40213296		
40084	3315	19078461	2013-12-16	2013-12-16 00:00:00	2014-01-20	2014-01-20 00:00:00	2014-01-20	38000177		0	0	35		0	0	0	220133	0	310965	19078461		
40393	3347	1127433	1993-10-22	1993-10-22 00:00:00	1993-11-28	1993-11-28 00:00:00	1993-11-28	38000177		0	0	37		0	0	0	222019	0	313782	1127433		
158488	3489	40213160	1977-10-08	1977-10-08 00:00:00	1977-10-08	1977-10-08 00:00:00	1977-10-08	581452		0	0	0		0	0	0	231444	0	10	40213160		
62282	5185	40243436	1961-11-13	1961-11-13 00:00:00	1961-11-13	1961-11-13 00:00:00	1961-11-13	38000177		0	0	0		0	0	0	344602	0	1190795	40243436		
254	5	40213260	2018-08-29	2018-08-29 00:00:00	2018-08-29	2018-08-29 00:00:00	2018-08-29	581452		0	0	0		0	0	0	467	0	121	40213260		
194641	4276	40213227	2014-02-27	2014-02-27 00:00:00	2014-02-27	2014-02-27 00:00:00	2014-02-27	581452		0	0	0		0	0	0	283810	0	113	40213227		
199415	4381	40213160	1965-02-09	1965-02-09 00:00:00	1965-02-09	1965-02-09 00:00:00	1965-02-09	581452		0	0	0		0	0	0	291115	0	10	40213160		
212786	4666	40213314	1977-06-13	1977-06-13 00:00:00	1977-06-13	1977-06-13 00:00:00	1977-06-13	581452		0	0	0		0	0	0	310926	0	49	40213314		
174275	3832	40213160	1984-06-21	1984-06-21 00:00:00	1984-06-21	1984-06-21 00:00:00	1984-06-21	581452		0	0	0		0	0	0	254456	0	10	40213160		
192797	4235	40213314	1979-06-07	1979-06-07 00:00:00	1979-06-07	1979-06-07 00:00:00	1979-06-07	581452		0	0	0		0	0	0	281204	0	49	40213314		
185639	4080	40213160	1965-09-07	1965-09-07 00:00:00	1965-09-07	1965-09-07 00:00:00	1965-09-07	581452		0	0	0		0	0	0	271171	0	10	40213160		
131541	2891	40213314	1977-04-28	1977-04-28 00:00:00	1977-04-28	1977-04-28 00:00:00	1977-04-28	581452		0	0	0		0	0	0	192303	0	49	40213314		
143634	3157	40213160	1955-12-09	1955-12-09 00:00:00	1955-12-09	1955-12-09 00:00:00	1955-12-09	581452		0	0	0		0	0	0	209896	0	10	40213160		
92339	2027	40213160	1961-08-25	1961-08-25 00:00:00	1961-08-25	1961-08-25 00:00:00	1961-08-25	581452		0	0	0		0	0	0	134898	0	10	40213160		
38167	3158	1713671	2000-03-15	2000-03-15 00:00:00	2000-04-05	2000-04-05 00:00:00	2000-04-05	38000177		0	0	21		0	0	0	209960	0	562251	1713671		
208532	4574	40213260	2007-01-12	2007-01-12 00:00:00	2007-01-12	2007-01-12 00:00:00	2007-01-12	581452		0	0	0		0	0	0	\N	0	121	40213260		
210730	4622	40213227	2017-03-30	2017-03-30 00:00:00	2017-03-30	2017-03-30 00:00:00	2017-03-30	581452		0	0	0		0	0	0	307818	0	113	40213227		
112226	2466	40213160	1984-09-02	1984-09-02 00:00:00	1984-09-02	1984-09-02 00:00:00	1984-09-02	581452		0	0	0		0	0	0	163496	0	10	40213160		
106361	2332	40213227	2008-04-26	2008-04-26 00:00:00	2008-04-26	2008-04-26 00:00:00	2008-04-26	581452		0	0	0		0	0	0	155096	0	113	40213227		
29155	2414	1332419	1994-08-18	1994-08-18 00:00:00	1994-08-18	1994-08-18 00:00:00	\N	38000177		0	0	0		0	0	0	160263	0	197361	1332419		
9471	787	1127433	1978-02-17	1978-02-17 00:00:00	1978-02-24	1978-02-24 00:00:00	1978-02-24	38000177		0	0	7		0	0	0	52360	0	313782	1127433		
2990	66	40213160	1958-12-05	1958-12-05 00:00:00	1958-12-05	1958-12-05 00:00:00	1958-12-05	581452		0	0	0		0	0	0	4479	0	10	40213160		
220122	4831	40213306	1983-08-11	1983-08-11 00:00:00	1983-08-11	1983-08-11 00:00:00	1983-08-11	581452		0	0	0		0	0	0	321446	0	43	40213306		
63995	5315	40229134	1945-02-14	1945-02-14 00:00:00	1945-02-28	1945-02-28 00:00:00	1945-02-28	38000177		0	0	14		0	0	0	353462	0	1043400	40229134		
230659	5068	40213227	2002-10-19	2002-10-19 00:00:00	2002-10-19	2002-10-19 00:00:00	2002-10-19	581452		0	0	0		0	0	0	336919	0	113	40213227		
122540	2693	40213260	2009-10-20	2009-10-20 00:00:00	2009-10-20	2009-10-20 00:00:00	2009-10-20	581452		0	0	0		0	0	0	178390	0	121	40213260		
140068	3077	40213160	1956-05-02	1956-05-02 00:00:00	1956-05-02	1956-05-02 00:00:00	1956-05-02	581452		0	0	0		0	0	0	204754	0	10	40213160		
84327	1844	40213296	1999-11-02	1999-11-02 00:00:00	1999-11-02	1999-11-02 00:00:00	1999-11-02	581452		0	0	0		0	0	0	123146	0	52	40213296		
230829	5073	40213201	2001-07-14	2001-07-14 00:00:00	2001-07-14	2001-07-14 00:00:00	2001-07-14	581452		0	0	0		0	0	0	337206	0	33	40213201		
30071	655	40213306	1982-04-24	1982-04-24 00:00:00	1982-04-24	1982-04-24 00:00:00	1982-04-24	581452		0	0	0		0	0	0	43358	0	43	40213306		
210137	4608	40213227	1996-12-26	1996-12-26 00:00:00	1996-12-26	1996-12-26 00:00:00	1996-12-26	581452		0	0	0		0	0	0	307017	0	113	40213227		
199076	4374	40213314	1977-08-04	1977-08-04 00:00:00	1977-08-04	1977-08-04 00:00:00	1977-08-04	581452		0	0	0		0	0	0	290536	0	49	40213314		
40395	3347	40165015	1993-10-29	1993-10-29 00:00:00	1993-10-29	1993-10-29 00:00:00	\N	38000177		0	0	0		0	0	0	222016	0	861467	40165015		
158489	3489	40213314	1977-10-08	1977-10-08 00:00:00	1977-10-08	1977-10-08 00:00:00	1977-10-08	581452		0	0	0		0	0	0	231444	0	49	40213314		
62283	5185	1127433	1989-01-01	1989-01-01 00:00:00	1989-04-01	1989-04-01 00:00:00	1989-04-01	38000177		0	0	90		0	0	0	344603	0	313782	1127433		
269	6	40213296	2004-01-06	2004-01-06 00:00:00	2004-01-06	2004-01-06 00:00:00	2004-01-06	581452		0	0	0		0	0	0	580	0	52	40213296		
181641	3991	40213227	1996-10-05	1996-10-05 00:00:00	1996-10-05	1996-10-05 00:00:00	1996-10-05	581452		0	0	0		0	0	0	265363	0	113	40213227		
199418	4381	40213296	2007-07-03	2007-07-03 00:00:00	2007-07-03	2007-07-03 00:00:00	2007-07-03	581452		0	0	0		0	0	0	291141	0	52	40213296		
212789	4666	40213160	1977-06-13	1977-06-13 00:00:00	1977-06-13	1977-06-13 00:00:00	1977-06-13	581452		0	0	0		0	0	0	310926	0	10	40213160		
174276	3832	40213314	1984-06-21	1984-06-21 00:00:00	1984-06-21	1984-06-21 00:00:00	1984-06-21	581452		0	0	0		0	0	0	254456	0	49	40213314		
192798	4235	40213160	1979-06-07	1979-06-07 00:00:00	1979-06-07	1979-06-07 00:00:00	1979-06-07	581452		0	0	0		0	0	0	281204	0	10	40213160		
185647	4080	40213160	1970-05-12	1970-05-12 00:00:00	1970-05-12	1970-05-12 00:00:00	1970-05-12	581452		0	0	0		0	0	0	271207	0	10	40213160		
131548	2891	40213227	2006-10-12	2006-10-12 00:00:00	2006-10-12	2006-10-12 00:00:00	2006-10-12	581452		0	0	0		0	0	0	192361	0	113	40213227		
143637	3157	40213227	2003-07-11	2003-07-11 00:00:00	2003-07-11	2003-07-11 00:00:00	2003-07-11	581452		0	0	0		0	0	0	209820	0	113	40213227		
42463	925	40213160	1969-08-08	1969-08-08 00:00:00	1969-08-08	1969-08-08 00:00:00	1969-08-08	581452		0	0	0		0	0	0	61608	0	10	40213160		
38168	3158	1127433	1974-05-03	1974-05-03 00:00:00	1974-05-17	1974-05-17 00:00:00	1974-05-17	38000177		0	0	14		0	0	0	209948	0	313782	1127433		
208533	4574	40213296	1998-03-27	1998-03-27 00:00:00	1998-03-27	1998-03-27 00:00:00	1998-03-27	581452		0	0	0		0	0	0	304737	0	52	40213296		
210733	4622	40213296	1998-01-29	1998-01-29 00:00:00	1998-01-29	1998-01-29 00:00:00	1998-01-29	581452		0	0	0		0	0	0	307792	0	52	40213296		
112228	2466	40213227	2013-05-12	2013-05-12 00:00:00	2013-05-12	2013-05-12 00:00:00	2013-05-12	581452		0	0	0		0	0	0	163487	0	113	40213227		
106366	2332	40213227	1992-02-01	1992-02-01 00:00:00	1992-02-01	1992-02-01 00:00:00	1992-02-01	581452		0	0	0		0	0	0	155054	0	113	40213227		
29156	2414	40171902	1994-08-18	1994-08-18 00:00:00	1994-08-18	1994-08-18 00:00:00	\N	38000177		0	0	0		0	0	0	160263	0	897718	40171902		
9472	787	1118084	2017-01-07	2017-01-07 00:00:00	2017-01-07	2017-01-07 00:00:00	\N	38000177		0	0	0		0	0	0	52349	0	00025152531	44923712		
2992	66	40213227	2000-04-28	2000-04-28 00:00:00	2000-04-28	2000-04-28 00:00:00	2000-04-28	581452		0	0	0		0	0	0	4464	0	113	40213227		
75334	1646	40213201	2007-03-03	2007-03-03 00:00:00	2007-03-03	2007-03-03 00:00:00	2007-03-03	581452		0	0	0		0	0	0	110355	0	33	40213201		
63996	5315	19059056	1919-06-18	1919-06-18 00:00:00	1919-07-02	1919-07-02 00:00:00	1919-07-02	38000177		0	0	14		0	0	0	353531	0	243670	19059056		
162481	3573	40213227	1994-08-27	1994-08-27 00:00:00	1994-08-27	1994-08-27 00:00:00	1994-08-27	581452		0	0	0		0	0	0	237619	0	113	40213227		
122549	2693	40213296	1998-10-20	1998-10-20 00:00:00	1998-10-20	1998-10-20 00:00:00	1998-10-20	581452		0	0	0		0	0	0	178447	0	52	40213296		
181307	3984	40213160	1955-03-02	1955-03-02 00:00:00	1955-03-02	1955-03-02 00:00:00	1955-03-02	581452		0	0	0		0	0	0	264848	0	10	40213160		
84328	1844	40213160	1959-07-14	1959-07-14 00:00:00	1959-07-14	1959-07-14 00:00:00	1959-07-14	581452		0	0	0		0	0	0	123188	0	10	40213160		
234493	5151	40213296	1997-11-07	1997-11-07 00:00:00	1997-11-07	1997-11-07 00:00:00	1997-11-07	581452		0	0	0		0	0	0	342517	0	52	40213296		
30072	655	40213296	2003-11-01	2003-11-01 00:00:00	2003-11-01	2003-11-01 00:00:00	2003-11-01	581452		0	0	0		0	0	0	43380	0	52	40213296		
210138	4608	40213296	1996-12-26	1996-12-26 00:00:00	1996-12-26	1996-12-26 00:00:00	1996-12-26	581452		0	0	0		0	0	0	307017	0	52	40213296		
199079	4374	40213306	1999-05-13	1999-05-13 00:00:00	1999-05-13	1999-05-13 00:00:00	1999-05-13	581452		0	0	0		0	0	0	290530	0	43	40213306		
40396	3347	19078461	2011-02-16	2011-02-16 00:00:00	2011-04-17	2011-04-17 00:00:00	2011-04-17	38000177		0	0	60		0	0	0	222022	0	310965	19078461		
158493	3489	40213160	1973-07-07	1973-07-07 00:00:00	1973-07-07	1973-07-07 00:00:00	1973-07-07	581452		0	0	0		0	0	0	231478	0	10	40213160		
62284	5185	40162522	1989-01-01	1989-01-01 00:00:00	1989-01-01	1989-01-01 00:00:00	\N	38000177		0	0	0		0	0	0	344603	0	857005	40162522		
147804	3249	40213260	2007-07-15	2007-07-15 00:00:00	2007-07-15	2007-07-15 00:00:00	2007-07-15	581452		0	0	0		0	0	0	215984	0	121	40213260		
181372	3986	40213296	2005-07-15	2005-07-15 00:00:00	2005-07-15	2005-07-15 00:00:00	2005-07-15	581452		0	0	0		0	0	0	264975	0	52	40213296		
84115	1840	40213160	1975-12-27	1975-12-27 00:00:00	1975-12-27	1975-12-27 00:00:00	1975-12-27	581452		0	0	0		0	0	0	122838	0	10	40213160		
212790	4666	40213160	1972-12-11	1972-12-11 00:00:00	1972-12-11	1972-12-11 00:00:00	1972-12-11	581452		0	0	0		0	0	0	310922	0	10	40213160		
2236	49	40213227	2014-06-28	2014-06-28 00:00:00	2014-06-28	2014-06-28 00:00:00	2014-06-28	581452		0	0	0		0	0	0	3524	0	113	40213227		
192807	4235	40213160	1979-11-08	1979-11-08 00:00:00	1979-11-08	1979-11-08 00:00:00	1979-11-08	581452		0	0	0		0	0	0	281179	0	10	40213160		
185649	4080	40213227	2007-01-30	2007-01-30 00:00:00	2007-01-30	2007-01-30 00:00:00	2007-01-30	581452		0	0	0		0	0	0	\N	0	113	40213227		
131553	2891	40213227	1996-01-25	1996-01-25 00:00:00	1996-01-25	1996-01-25 00:00:00	1996-01-25	581452		0	0	0		0	0	0	192320	0	113	40213227		
143644	3157	40213198	2018-03-02	2018-03-02 00:00:00	2018-03-02	2018-03-02 00:00:00	2018-03-02	581452		0	0	0		0	0	0	209819	0	133	40213198		
42466	925	40213227	2011-05-20	2011-05-20 00:00:00	2011-05-20	2011-05-20 00:00:00	2011-05-20	581452		0	0	0		0	0	0	61597	0	113	40213227		
38169	3158	19059056	1963-04-14	1963-04-14 00:00:00	1963-04-28	1963-04-28 00:00:00	1963-04-28	38000177		0	0	14		0	0	0	209944	0	243670	19059056		
210735	4622	40213227	1998-01-29	1998-01-29 00:00:00	1998-01-29	1998-01-29 00:00:00	1998-01-29	581452		0	0	0		0	0	0	307792	0	113	40213227		
112232	2466	40213160	1980-06-01	1980-06-01 00:00:00	1980-06-01	1980-06-01 00:00:00	1980-06-01	581452		0	0	0		0	0	0	163511	0	10	40213160		
106380	2333	40213227	1992-04-28	1992-04-28 00:00:00	1992-04-28	1992-04-28 00:00:00	1992-04-28	581452		0	0	0		0	0	0	155232	0	113	40213227		
215506	4725	40213227	2006-03-13	2006-03-13 00:00:00	2006-03-13	2006-03-13 00:00:00	2006-03-13	581452		0	0	0		0	0	0	314928	0	113	40213227		
9473	788	1713671	2013-04-24	2013-04-24 00:00:00	2013-05-08	2013-05-08 00:00:00	2013-05-08	38000177		0	0	14		0	0	0	52433	0	562251	1713671		
2993	66	40213296	2000-04-28	2000-04-28 00:00:00	2000-04-28	2000-04-28 00:00:00	2000-04-28	581452		0	0	0		0	0	0	4464	0	52	40213296		
75336	1646	40213227	1992-12-12	1992-12-12 00:00:00	1992-12-12	1992-12-12 00:00:00	1992-12-12	581452		0	0	0		0	0	0	110405	0	113	40213227		
63997	5316	40229134	2014-12-10	2014-12-10 00:00:00	2014-12-24	2014-12-24 00:00:00	2014-12-24	38000177		0	0	14		0	0	0	353543	0	1043400	40229134		
162504	3573	40213227	2004-10-23	2004-10-23 00:00:00	2004-10-23	2004-10-23 00:00:00	2004-10-23	581452		0	0	0		0	0	0	237598	0	113	40213227		
29556	644	40213314	1977-09-28	1977-09-28 00:00:00	1977-09-28	1977-09-28 00:00:00	1977-09-28	581452		0	0	0		0	0	0	42640	0	49	40213314		
181308	3984	40213260	2007-01-10	2007-01-10 00:00:00	2007-01-10	2007-01-10 00:00:00	2007-01-10	581452		0	0	0		0	0	0	264869	0	121	40213260		
84331	1844	40213306	1981-12-22	1981-12-22 00:00:00	1981-12-22	1981-12-22 00:00:00	1981-12-22	581452		0	0	0		0	0	0	123198	0	43	40213306		
234501	5151	40213160	1957-04-12	1957-04-12 00:00:00	1957-04-12	1957-04-12 00:00:00	1957-04-12	581452		0	0	0		0	0	0	342563	0	10	40213160		
385	30	46233988	1972-04-06	1972-04-06 00:00:00	1972-04-20	1972-04-20 00:00:00	1972-04-20	38000177		0	0	14		0	0	0	2115	0	1652673	46233988		
221424	4859	40213227	1996-05-05	1996-05-05 00:00:00	1996-05-05	1996-05-05 00:00:00	1996-05-05	581452		0	0	0		0	0	0	323201	0	113	40213227		
199081	4374	40213227	1999-05-13	1999-05-13 00:00:00	1999-05-13	1999-05-13 00:00:00	1999-05-13	581452		0	0	0		0	0	0	290530	0	113	40213227		
40397	3347	1713671	1961-11-12	1961-11-12 00:00:00	1961-12-03	1961-12-03 00:00:00	1961-12-03	38000177		0	0	21		0	0	0	222067	0	562251	1713671		
158498	3489	40213227	2004-03-27	2004-03-27 00:00:00	2004-03-27	2004-03-27 00:00:00	2004-03-27	581452		0	0	0		0	0	0	231439	0	113	40213227		
62285	5185	1127433	1965-09-17	1965-09-17 00:00:00	1965-09-24	1965-09-24 00:00:00	1965-09-24	38000177		0	0	7		0	0	0	344651	0	313782	1127433		
147810	3249	40213227	1999-07-25	1999-07-25 00:00:00	1999-07-25	1999-07-25 00:00:00	1999-07-25	581452		0	0	0		0	0	0	215954	0	113	40213227		
181375	3986	40213160	1962-02-02	1962-02-02 00:00:00	1962-02-02	1962-02-02 00:00:00	1962-02-02	581452		0	0	0		0	0	0	264989	0	10	40213160		
84123	1840	40213227	1997-07-26	1997-07-26 00:00:00	1997-07-26	1997-07-26 00:00:00	1997-07-26	581452		0	0	0		0	0	0	122844	0	113	40213227		
212793	4666	40213227	2013-07-29	2013-07-29 00:00:00	2013-07-29	2013-07-29 00:00:00	2013-07-29	581452		0	0	0		0	0	0	310967	0	113	40213227		
2237	49	40213296	2014-06-28	2014-06-28 00:00:00	2014-06-28	2014-06-28 00:00:00	2014-06-28	581452		0	0	0		0	0	0	3524	0	52	40213296		
192809	4235	40213227	2011-01-13	2011-01-13 00:00:00	2011-01-13	2011-01-13 00:00:00	2011-01-13	581452		0	0	0		0	0	0	281203	0	113	40213227		
185650	4080	40213296	2007-01-30	2007-01-30 00:00:00	2007-01-30	2007-01-30 00:00:00	2007-01-30	581452		0	0	0		0	0	0	\N	0	52	40213296		
131554	2891	40213306	1996-01-25	1996-01-25 00:00:00	1996-01-25	1996-01-25 00:00:00	1996-01-25	581452		0	0	0		0	0	0	192320	0	43	40213306		
143646	3157	40213201	2019-03-08	2019-03-08 00:00:00	2019-03-08	2019-03-08 00:00:00	2019-03-08	581452		0	0	0		0	0	0	209834	0	33	40213201		
42467	925	40213296	2011-05-20	2011-05-20 00:00:00	2011-05-20	2011-05-20 00:00:00	2011-05-20	581452		0	0	0		0	0	0	61597	0	52	40213296		
94299	2069	40213198	2017-05-15	2017-05-15 00:00:00	2017-05-15	2017-05-15 00:00:00	2017-05-15	581452		0	0	0		0	0	0	137565	0	133	40213198		
123516	2715	40213227	1997-03-27	1997-03-27 00:00:00	1997-03-27	1997-03-27 00:00:00	1997-03-27	581452		0	0	0		0	0	0	\N	0	113	40213227		
175047	3849	40213227	2014-11-27	2014-11-27 00:00:00	2014-11-27	2014-11-27 00:00:00	2014-11-27	581452		0	0	0		0	0	0	255417	0	113	40213227		
215510	4725	40213160	1979-05-28	1979-05-28 00:00:00	1979-05-28	1979-05-28 00:00:00	1979-05-28	581452		0	0	0		0	0	0	314899	0	10	40213160		
9474	788	19006318	1972-01-28	1972-01-28 00:00:00	1972-02-11	1972-02-11 00:00:00	1972-02-11	38000177		0	0	14		0	0	0	52434	0	105078	19006318		
18098	392	40213296	2015-07-10	2015-07-10 00:00:00	2015-07-10	2015-07-10 00:00:00	2015-07-10	581452		0	0	0		0	0	0	25752	0	52	40213296		
63998	5316	1310034	1984-01-02	1984-01-02 00:00:00	1984-01-02	1984-01-02 00:00:00	1984-01-02	38000177		0	0	0		0	0	0	353608	0	834357	1310034		
162510	3573	40213227	2014-07-12	2014-07-12 00:00:00	2014-07-12	2014-07-12 00:00:00	2014-07-12	581452		0	0	0		0	0	0	237643	0	113	40213227		
29559	644	40213160	1980-10-01	1980-10-01 00:00:00	1980-10-01	1980-10-01 00:00:00	1980-10-01	581452		0	0	0		0	0	0	42642	0	10	40213160		
181312	3984	40213260	2006-01-04	2006-01-04 00:00:00	2006-01-04	2006-01-04 00:00:00	2006-01-04	581452		0	0	0		0	0	0	264857	0	121	40213260		
84338	1845	40213306	1984-03-14	1984-03-14 00:00:00	1984-03-14	1984-03-14 00:00:00	1984-03-14	581452		0	0	0		0	0	0	123378	0	43	40213306		
234510	5152	40213160	1970-04-12	1970-04-12 00:00:00	1970-04-12	1970-04-12 00:00:00	1970-04-12	581452		0	0	0		0	0	0	342639	0	10	40213160		
386	30	1127433	1998-04-21	1998-04-21 00:00:00	1998-05-05	1998-05-05 00:00:00	1998-05-05	38000177		0	0	14		0	0	0	2129	0	313782	1127433		
221432	4859	40213160	1955-07-03	1955-07-03 00:00:00	1955-07-03	1955-07-03 00:00:00	1955-07-03	581452		0	0	0		0	0	0	323216	0	10	40213160		
199087	4374	40213227	2009-08-13	2009-08-13 00:00:00	2009-08-13	2009-08-13 00:00:00	2009-08-13	581452		0	0	0		0	0	0	290551	0	113	40213227		
40398	3347	1713671	2001-04-20	2001-04-20 00:00:00	2001-05-11	2001-05-11 00:00:00	2001-05-11	38000177		0	0	21		0	0	0	222081	0	562251	1713671		
222008	4873	40213251	1984-07-13	1984-07-13 00:00:00	1984-07-13	1984-07-13 00:00:00	1984-07-13	581452		0	0	0		0	0	0	324107	0	21	40213251		
62286	5185	19078461	2010-09-22	2010-09-22 00:00:00	2010-11-21	2010-11-21 00:00:00	2010-11-21	38000177		0	0	60		0	0	0	344726	0	310965	19078461		
147811	3249	40213296	1999-07-25	1999-07-25 00:00:00	1999-07-25	1999-07-25 00:00:00	1999-07-25	581452		0	0	0		0	0	0	215954	0	52	40213296		
181378	3986	40213260	2012-08-03	2012-08-03 00:00:00	2012-08-03	2012-08-03 00:00:00	2012-08-03	581452		0	0	0		0	0	0	264960	0	121	40213260		
84124	1840	40213306	1997-07-26	1997-07-26 00:00:00	1997-07-26	1997-07-26 00:00:00	1997-07-26	581452		0	0	0		0	0	0	122844	0	43	40213306		
212794	4666	40213296	2013-07-29	2013-07-29 00:00:00	2013-07-29	2013-07-29 00:00:00	2013-07-29	581452		0	0	0		0	0	0	310967	0	52	40213296		
2239	49	40213160	1973-06-16	1973-06-16 00:00:00	1973-06-16	1973-06-16 00:00:00	1973-06-16	581452		0	0	0		0	0	0	3537	0	10	40213160		
200024	4393	40213227	2018-05-04	2018-05-04 00:00:00	2018-05-04	2018-05-04 00:00:00	2018-05-04	581452		0	0	0		0	0	0	292114	0	113	40213227		
131125	2882	40213314	1977-04-22	1977-04-22 00:00:00	1977-04-22	1977-04-22 00:00:00	1977-04-22	581452		0	0	0		0	0	0	191733	0	49	40213314		
131558	2891	40213160	1974-08-01	1974-08-01 00:00:00	1974-08-01	1974-08-01 00:00:00	1974-08-01	581452		0	0	0		0	0	0	192293	0	10	40213160		
143653	3157	40213296	1996-07-19	1996-07-19 00:00:00	1996-07-19	1996-07-19 00:00:00	1996-07-19	581452		0	0	0		0	0	0	209874	0	52	40213296		
42483	925	40213306	1991-03-08	1991-03-08 00:00:00	1991-03-08	1991-03-08 00:00:00	1991-03-08	581452		0	0	0		0	0	0	61591	0	43	40213306		
94304	2069	40213227	1994-02-27	1994-02-27 00:00:00	1994-02-27	1994-02-27 00:00:00	1994-02-27	581452		0	0	0		0	0	0	137574	0	113	40213227		
123523	2715	40213160	1966-06-23	1966-06-23 00:00:00	1966-06-23	1966-06-23 00:00:00	1966-06-23	581452		0	0	0		0	0	0	179988	0	10	40213160		
175048	3849	40213160	1968-10-31	1968-10-31 00:00:00	1968-10-31	1968-10-31 00:00:00	1968-10-31	581452		0	0	0		0	0	0	255385	0	10	40213160		
215511	4725	40213160	1974-12-30	1974-12-30 00:00:00	1974-12-30	1974-12-30 00:00:00	1974-12-30	581452		0	0	0		0	0	0	314897	0	10	40213160		
9475	788	19059056	1972-01-28	1972-01-28 00:00:00	1972-02-11	1972-02-11 00:00:00	1972-02-11	38000177		0	0	14		0	0	0	52434	0	243670	19059056		
18099	392	40213314	1977-06-10	1977-06-10 00:00:00	1977-06-10	1977-06-10 00:00:00	1977-06-10	581452		0	0	0		0	0	0	25709	0	49	40213314		
63999	5316	40243436	1984-01-02	1984-01-02 00:00:00	1984-01-02	1984-01-02 00:00:00	1984-01-02	38000177		0	0	0		0	0	0	353608	0	1190795	40243436		
162512	3573	40213201	1989-07-29	1989-07-29 00:00:00	1989-07-29	1989-07-29 00:00:00	1989-07-29	581452		0	0	0		0	0	0	237550	0	33	40213201		
29568	644	40213227	2017-06-07	2017-06-07 00:00:00	2017-06-07	2017-06-07 00:00:00	2017-06-07	581452		0	0	0		0	0	0	42633	0	113	40213227		
181313	3984	40213160	1958-04-02	1958-04-02 00:00:00	1958-04-02	1958-04-02 00:00:00	1958-04-02	581452		0	0	0		0	0	0	264830	0	10	40213160		
84339	1845	40213296	2001-04-25	2001-04-25 00:00:00	2001-04-25	2001-04-25 00:00:00	2001-04-25	581452		0	0	0		0	0	0	123380	0	52	40213296		
234516	5152	40213227	1992-03-15	1992-03-15 00:00:00	1992-03-15	1992-03-15 00:00:00	1992-03-15	581452		0	0	0		0	0	0	342613	0	113	40213227		
401	32	1127433	1998-10-02	1998-10-02 00:00:00	1998-10-09	1998-10-09 00:00:00	1998-10-09	38000177		0	0	7		0	0	0	2200	0	313782	1127433		
221435	4859	40213160	1959-04-05	1959-04-05 00:00:00	1959-04-05	1959-04-05 00:00:00	1959-04-05	581452		0	0	0		0	0	0	323217	0	10	40213160		
199088	4374	40213314	1977-05-05	1977-05-05 00:00:00	1977-05-05	1977-05-05 00:00:00	1977-05-05	581452		0	0	0		0	0	0	290514	0	49	40213314		
40399	3347	1127433	1986-02-26	1986-02-26 00:00:00	1986-03-12	1986-03-12 00:00:00	1986-03-12	38000177		0	0	14		0	0	0	222017	0	313782	1127433		
222015	4873	40213227	2017-09-22	2017-09-22 00:00:00	2017-09-22	2017-09-22 00:00:00	2017-09-22	581452		0	0	0		0	0	0	324111	0	113	40213227		
62287	5185	19075001	2009-09-06	2009-09-06 00:00:00	2009-09-20	2009-09-20 00:00:00	2009-09-20	38000177		0	0	14		0	0	0	344703	0	309097	19075001		
147824	3250	40213296	2003-01-14	2003-01-14 00:00:00	2003-01-14	2003-01-14 00:00:00	2003-01-14	581452		0	0	0		0	0	0	216087	0	52	40213296		
90080	1977	40213227	2001-03-29	2001-03-29 00:00:00	2001-03-29	2001-03-29 00:00:00	2001-03-29	581452		0	0	0		0	0	0	131566	0	113	40213227		
84125	1840	40213314	1977-03-26	1977-03-26 00:00:00	1977-03-26	1977-03-26 00:00:00	1977-03-26	581452		0	0	0		0	0	0	122849	0	49	40213314		
212807	4666	40213296	2015-08-03	2015-08-03 00:00:00	2015-08-03	2015-08-03 00:00:00	2015-08-03	581452		0	0	0		0	0	0	310931	0	52	40213296		
2241	49	40213160	1973-02-10	1973-02-10 00:00:00	1973-02-10	1973-02-10 00:00:00	1973-02-10	581452		0	0	0		0	0	0	3541	0	10	40213160		
200028	4393	40213160	1984-10-26	1984-10-26 00:00:00	1984-10-26	1984-10-26 00:00:00	1984-10-26	581452		0	0	0		0	0	0	292120	0	10	40213160		
131126	2882	40213160	1977-04-22	1977-04-22 00:00:00	1977-04-22	1977-04-22 00:00:00	1977-04-22	581452		0	0	0		0	0	0	191733	0	10	40213160		
131561	2891	40213160	1978-11-02	1978-11-02 00:00:00	1978-11-02	1978-11-02 00:00:00	1978-11-02	581452		0	0	0		0	0	0	192304	0	10	40213160		
143661	3157	40213160	1956-06-08	1956-06-08 00:00:00	1956-06-08	1956-06-08 00:00:00	1956-06-08	581452		0	0	0		0	0	0	209855	0	10	40213160		
112038	2461	40213227	1998-01-13	1998-01-13 00:00:00	1998-01-13	1998-01-13 00:00:00	1998-01-13	581452		0	0	0		0	0	0	163151	0	113	40213227		
94308	2069	40213160	1955-06-27	1955-06-27 00:00:00	1955-06-27	1955-06-27 00:00:00	1955-06-27	581452		0	0	0		0	0	0	137602	0	10	40213160		
123528	2715	40213227	2017-01-19	2017-01-19 00:00:00	2017-01-19	2017-01-19 00:00:00	2017-01-19	581452		0	0	0		0	0	0	180045	0	113	40213227		
175052	3849	40213160	1964-07-30	1964-07-30 00:00:00	1964-07-30	1964-07-30 00:00:00	1964-07-30	581452		0	0	0		0	0	0	255436	0	10	40213160		
99695	2184	40213306	1989-04-19	1989-04-19 00:00:00	1989-04-19	1989-04-19 00:00:00	1989-04-19	581452		0	0	0		0	0	0	145575	0	43	40213306		
9476	788	1127433	1998-11-08	1998-11-08 00:00:00	1998-11-22	1998-11-22 00:00:00	1998-11-22	38000177		0	0	14		0	0	0	52395	0	313782	1127433		
18102	392	40213227	2017-07-14	2017-07-14 00:00:00	2017-07-14	2017-07-14 00:00:00	2017-07-14	581452		0	0	0		0	0	0	25730	0	113	40213227		
64000	5316	46275916	1984-01-02	1984-01-02 00:00:00	1984-01-02	1984-01-02 00:00:00	1984-01-02	38000177		0	0	0		0	0	0	353608	0	1660014	46275916		
147407	3241	40213260	2011-03-31	2011-03-31 00:00:00	2011-03-31	2011-03-31 00:00:00	2011-03-31	581452		0	0	0		0	0	0	215589	0	121	40213260		
29569	644	40213296	2017-06-07	2017-06-07 00:00:00	2017-06-07	2017-06-07 00:00:00	2017-06-07	581452		0	0	0		0	0	0	42633	0	52	40213296		
181316	3984	40213227	2004-12-29	2004-12-29 00:00:00	2004-12-29	2004-12-29 00:00:00	2004-12-29	581452		0	0	0		0	0	0	264868	0	113	40213227		
84346	1845	40213227	1993-03-24	1993-03-24 00:00:00	1993-03-24	1993-03-24 00:00:00	1993-03-24	581452		0	0	0		0	0	0	123318	0	113	40213227		
234517	5152	40213306	1992-03-15	1992-03-15 00:00:00	1992-03-15	1992-03-15 00:00:00	1992-03-15	581452		0	0	0		0	0	0	342613	0	43	40213306		
402	32	19007333	2000-10-12	2000-10-12 00:00:00	2004-09-21	2004-09-21 00:00:00	2004-09-21	38000177		0	0	1440		0	0	0	2271	0	105586	19007333		
199090	4374	40213160	1976-11-04	1976-11-04 00:00:00	1976-11-04	1976-11-04 00:00:00	1976-11-04	581452		0	0	0		0	0	0	290535	0	10	40213160		
40400	3347	1127433	1990-10-17	1990-10-17 00:00:00	1990-11-07	1990-11-07 00:00:00	1990-11-07	38000177		0	0	21		0	0	0	222018	0	313782	1127433		
222016	4873	40213296	2017-09-22	2017-09-22 00:00:00	2017-09-22	2017-09-22 00:00:00	2017-09-22	581452		0	0	0		0	0	0	324111	0	52	40213296		
62288	5185	1115171	2009-09-06	2009-09-06 00:00:00	2009-09-20	2009-09-20 00:00:00	2009-09-20	38000177		0	0	14		0	0	0	344703	0	849574	1115171		
147826	3250	40213306	1985-02-05	1985-02-05 00:00:00	1985-02-05	1985-02-05 00:00:00	1985-02-05	581452		0	0	0		0	0	0	216072	0	43	40213306		
90082	1977	40213227	1992-02-06	1992-02-06 00:00:00	1992-02-06	1992-02-06 00:00:00	1992-02-06	581452		0	0	0		0	0	0	131466	0	113	40213227		
84128	1840	40213160	1975-07-26	1975-07-26 00:00:00	1975-07-26	1975-07-26 00:00:00	1975-07-26	581452		0	0	0		0	0	0	122828	0	10	40213160		
212808	4666	40213160	1973-03-12	1973-03-12 00:00:00	1973-03-12	1973-03-12 00:00:00	1973-03-12	581452		0	0	0		0	0	0	310938	0	10	40213160		
2248	49	40213227	2006-06-17	2006-06-17 00:00:00	2006-06-17	2006-06-17 00:00:00	2006-06-17	581452		0	0	0		0	0	0	3548	0	113	40213227		
200029	4393	40213314	1984-10-26	1984-10-26 00:00:00	1984-10-26	1984-10-26 00:00:00	1984-10-26	581452		0	0	0		0	0	0	292120	0	49	40213314		
131128	2882	40213160	1972-08-18	1972-08-18 00:00:00	1972-08-18	1972-08-18 00:00:00	1972-08-18	581452		0	0	0		0	0	0	191743	0	10	40213160		
162346	3570	40213227	2000-03-19	2000-03-19 00:00:00	2000-03-19	2000-03-19 00:00:00	2000-03-19	581452		0	0	0		0	0	0	237242	0	113	40213227		
143666	3157	40213260	2006-07-28	2006-07-28 00:00:00	2006-07-28	2006-07-28 00:00:00	2006-07-28	581452		0	0	0		0	0	0	209816	0	121	40213260		
112041	2461	40213160	1971-10-12	1971-10-12 00:00:00	1971-10-12	1971-10-12 00:00:00	1971-10-12	581452		0	0	0		0	0	0	163163	0	10	40213160		
94314	2070	40213306	1987-10-12	1987-10-12 00:00:00	1987-10-12	1987-10-12 00:00:00	1987-10-12	581452		0	0	0		0	0	0	137650	0	43	40213306		
123529	2715	40213260	2017-01-19	2017-01-19 00:00:00	2017-01-19	2017-01-19 00:00:00	2017-01-19	581452		0	0	0		0	0	0	180045	0	121	40213260		
175053	3849	40213260	2014-11-27	2014-11-27 00:00:00	2014-11-27	2014-11-27 00:00:00	2014-11-27	581452		0	0	0		0	0	0	255417	0	121	40213260		
99697	2184	40213227	2018-06-27	2018-06-27 00:00:00	2018-06-27	2018-06-27 00:00:00	2018-06-27	581452		0	0	0		0	0	0	145566	0	113	40213227		
9477	788	1115171	2015-08-01	2015-08-01 00:00:00	2015-08-22	2015-08-22 00:00:00	2015-08-22	38000177		0	0	21		0	0	0	52454	0	849574	1115171		
18103	392	40213296	2017-07-14	2017-07-14 00:00:00	2017-07-14	2017-07-14 00:00:00	2017-07-14	581452		0	0	0		0	0	0	25730	0	52	40213296		
64001	5316	19133873	1963-06-28	1963-06-28 00:00:00	1963-07-08	1963-07-08 00:00:00	1963-07-08	38000177		0	0	10		0	0	0	353575	0	834061	19133873		
147411	3241	40213260	2012-04-05	2012-04-05 00:00:00	2012-04-05	2012-04-05 00:00:00	2012-04-05	581452		0	0	0		0	0	0	215584	0	121	40213260		
29573	644	40213227	2006-11-15	2006-11-15 00:00:00	2006-11-15	2006-11-15 00:00:00	2006-11-15	581452		0	0	0		0	0	0	42671	0	113	40213227		
185311	4072	40213227	1995-10-28	1995-10-28 00:00:00	1995-10-28	1995-10-28 00:00:00	1995-10-28	581452		0	0	0		0	0	0	\N	0	113	40213227		
84350	1845	40213227	2003-04-30	2003-04-30 00:00:00	2003-04-30	2003-04-30 00:00:00	2003-04-30	581452		0	0	0		0	0	0	123289	0	113	40213227		
234523	5152	40213160	1970-09-13	1970-09-13 00:00:00	1970-09-13	1970-09-13 00:00:00	1970-09-13	581452		0	0	0		0	0	0	342643	0	10	40213160		
403	32	19019273	2000-10-12	2000-10-12 00:00:00	2004-09-21	2004-09-21 00:00:00	2004-09-21	38000177		0	0	1440		0	0	0	2271	0	198014	19019273		
199095	4374	40213160	1980-09-25	1980-09-25 00:00:00	1980-09-25	1980-09-25 00:00:00	1980-09-25	581452		0	0	0		0	0	0	\N	0	10	40213160		
40401	3347	1127433	1984-12-13	1984-12-13 00:00:00	1984-12-27	1984-12-27 00:00:00	1984-12-27	38000177		0	0	14		0	0	0	222037	0	313782	1127433		
222019	4873	40213314	1977-09-23	1977-09-23 00:00:00	1977-09-23	1977-09-23 00:00:00	1977-09-23	581452		0	0	0		0	0	0	324118	0	49	40213314		
62289	5185	19133873	1948-06-19	1948-06-19 00:00:00	1948-07-01	1948-07-01 00:00:00	1948-07-01	38000177		0	0	12		0	0	0	344634	0	834061	19133873		
147827	3250	40213160	1963-04-16	1963-04-16 00:00:00	1963-04-16	1963-04-16 00:00:00	1963-04-16	581452		0	0	0		0	0	0	216066	0	10	40213160		
187462	4117	40213227	2004-12-24	2004-12-24 00:00:00	2004-12-24	2004-12-24 00:00:00	2004-12-24	581452		0	0	0		0	0	0	273741	0	113	40213227		
95410	2091	40213227	1996-01-06	1996-01-06 00:00:00	1996-01-06	1996-01-06 00:00:00	1996-01-06	581452		0	0	0		0	0	0	\N	0	113	40213227		
212814	4666	40213227	1993-09-06	1993-09-06 00:00:00	1993-09-06	1993-09-06 00:00:00	1993-09-06	581452		0	0	0		0	0	0	310968	0	113	40213227		
2250	49	40213314	1977-09-17	1977-09-17 00:00:00	1977-09-17	1977-09-17 00:00:00	1977-09-17	581452		0	0	0		0	0	0	3544	0	49	40213314		
200032	4393	40213160	1984-08-24	1984-08-24 00:00:00	1984-08-24	1984-08-24 00:00:00	1984-08-24	581452		0	0	0		0	0	0	292092	0	10	40213160		
131131	2882	40213160	1973-01-19	1973-01-19 00:00:00	1973-01-19	1973-01-19 00:00:00	1973-01-19	581452		0	0	0		0	0	0	191728	0	10	40213160		
9127	759	1127433	1962-10-03	1962-10-03 00:00:00	1962-10-17	1962-10-17 00:00:00	1962-10-17	38000177		0	0	14		0	0	0	50435	0	313782	1127433		
27601	601	40213160	1970-07-26	1970-07-26 00:00:00	1970-07-26	1970-07-26 00:00:00	1970-07-26	581452		0	0	0		0	0	0	39745	0	10	40213160		
112043	2461	40213306	1989-01-03	1989-01-03 00:00:00	1989-01-03	1989-01-03 00:00:00	1989-01-03	581452		0	0	0		0	0	0	163194	0	43	40213306		
94317	2070	40213306	1986-10-27	1986-10-27 00:00:00	1986-10-27	1986-10-27 00:00:00	1986-10-27	581452		0	0	0		0	0	0	\N	0	43	40213306		
123533	2715	40213160	1966-09-29	1966-09-29 00:00:00	1966-09-29	1966-09-29 00:00:00	1966-09-29	581452		0	0	0		0	0	0	180018	0	10	40213160		
175054	3849	40213306	1983-12-15	1983-12-15 00:00:00	1983-12-15	1983-12-15 00:00:00	1983-12-15	581452		0	0	0		0	0	0	255424	0	43	40213306		
99698	2184	40213260	2018-06-27	2018-06-27 00:00:00	2018-06-27	2018-06-27 00:00:00	2018-06-27	581452		0	0	0		0	0	0	145566	0	121	40213260		
9478	788	1713671	2000-02-24	2000-02-24 00:00:00	2000-03-16	2000-03-16 00:00:00	2000-03-16	38000177		0	0	21		0	0	0	52397	0	562251	1713671		
18111	392	40213160	1975-10-10	1975-10-10 00:00:00	1975-10-10	1975-10-10 00:00:00	1975-10-10	581452		0	0	0		0	0	0	25742	0	10	40213160		
64002	5316	1118084	1995-05-23	1995-05-23 00:00:00	1995-05-23	1995-05-23 00:00:00	\N	38000177		0	0	0		0	0	0	353554	0	00025152531	44923712		
147412	3241	40213227	2012-04-05	2012-04-05 00:00:00	2012-04-05	2012-04-05 00:00:00	2012-04-05	581452		0	0	0		0	0	0	215584	0	113	40213227		
29574	644	40213160	1976-01-28	1976-01-28 00:00:00	1976-01-28	1976-01-28 00:00:00	1976-01-28	581452		0	0	0		0	0	0	42649	0	10	40213160		
185312	4072	40213306	1995-10-28	1995-10-28 00:00:00	1995-10-28	1995-10-28 00:00:00	1995-10-28	581452		0	0	0		0	0	0	\N	0	43	40213306		
84351	1845	40213296	2003-04-30	2003-04-30 00:00:00	2003-04-30	2003-04-30 00:00:00	2003-04-30	581452		0	0	0		0	0	0	123289	0	52	40213296		
234529	5152	40213296	2010-02-07	2010-02-07 00:00:00	2010-02-07	2010-02-07 00:00:00	2010-02-07	581452		0	0	0		0	0	0	342634	0	52	40213296		
404	32	1127433	2002-07-21	2002-07-21 00:00:00	2002-07-28	2002-07-28 00:00:00	2002-07-28	38000177		0	0	7		0	0	0	2201	0	313782	1127433		
199097	4374	40213227	2017-08-24	2017-08-24 00:00:00	2017-08-24	2017-08-24 00:00:00	2017-08-24	581452		0	0	0		0	0	0	290539	0	113	40213227		
40402	3347	1127433	2002-08-31	2002-08-31 00:00:00	2002-09-14	2002-09-14 00:00:00	2002-09-14	38000177		0	0	14		0	0	0	222082	0	313782	1127433		
222021	4873	40213314	1977-06-24	1977-06-24 00:00:00	1977-06-24	1977-06-24 00:00:00	1977-06-24	581452		0	0	0		0	0	0	324130	0	49	40213314		
62290	5185	19133873	1950-07-09	1950-07-09 00:00:00	1950-07-17	1950-07-17 00:00:00	1950-07-17	38000177		0	0	8		0	0	0	344649	0	834061	19133873		
147831	3250	40213227	2005-01-18	2005-01-18 00:00:00	2005-01-18	2005-01-18 00:00:00	2005-01-18	581452		0	0	0		0	0	0	216047	0	113	40213227		
187463	4117	40213296	2004-12-24	2004-12-24 00:00:00	2004-12-24	2004-12-24 00:00:00	2004-12-24	581452		0	0	0		0	0	0	273741	0	52	40213296		
187541	4119	40213201	2010-10-16	2010-10-16 00:00:00	2010-10-16	2010-10-16 00:00:00	2010-10-16	581452		0	0	0		0	0	0	273831	0	33	40213201		
212815	4666	40213306	1993-09-06	1993-09-06 00:00:00	1993-09-06	1993-09-06 00:00:00	1993-09-06	581452		0	0	0		0	0	0	310968	0	43	40213306		
129751	2853	40213160	1961-11-07	1961-11-07 00:00:00	1961-11-07	1961-11-07 00:00:00	1961-11-07	581452		0	0	0		0	0	0	189515	0	10	40213160		
200033	4393	40213314	1984-08-24	1984-08-24 00:00:00	1984-08-24	1984-08-24 00:00:00	1984-08-24	581452		0	0	0		0	0	0	292092	0	49	40213314		
131132	2882	40213160	1972-10-20	1972-10-20 00:00:00	1972-10-20	1972-10-20 00:00:00	1972-10-20	581452		0	0	0		0	0	0	191714	0	10	40213160		
9128	759	19059056	1969-03-28	1969-03-28 00:00:00	1969-04-18	1969-04-18 00:00:00	1969-04-18	38000177		0	0	21		0	0	0	50358	0	243670	19059056		
27606	601	40213227	2011-11-27	2011-11-27 00:00:00	2011-11-27	2011-11-27 00:00:00	2011-11-27	581452		0	0	0		0	0	0	39719	0	113	40213227		
112050	2462	40213296	2001-10-14	2001-10-14 00:00:00	2001-10-14	2001-10-14 00:00:00	2001-10-14	581452		0	0	0		0	0	0	163239	0	52	40213296		
94320	2070	40213160	1965-07-05	1965-07-05 00:00:00	1965-07-05	1965-07-05 00:00:00	1965-07-05	581452		0	0	0		0	0	0	137661	0	10	40213160		
103802	2277	40213160	1966-05-15	1966-05-15 00:00:00	1966-05-15	1966-05-15 00:00:00	1966-05-15	581452		0	0	0		0	0	0	151379	0	10	40213160		
186344	4094	40213260	2008-09-18	2008-09-18 00:00:00	2008-09-18	2008-09-18 00:00:00	2008-09-18	581452		0	0	0		0	0	0	272187	0	121	40213260		
110981	2438	40213160	1981-03-01	1981-03-01 00:00:00	1981-03-01	1981-03-01 00:00:00	1981-03-01	581452		0	0	0		0	0	0	161743	0	10	40213160		
9479	788	1118084	2012-11-18	2012-11-18 00:00:00	2012-11-18	2012-11-18 00:00:00	\N	38000177		0	0	0		0	0	0	52430	0	00025152531	44923712		
18114	392	40213160	1976-03-12	1976-03-12 00:00:00	1976-03-12	1976-03-12 00:00:00	1976-03-12	581452		0	0	0		0	0	0	25722	0	10	40213160		
64003	5316	19133873	1957-07-17	1957-07-17 00:00:00	1957-07-28	1957-07-28 00:00:00	1957-07-28	38000177		0	0	11		0	0	0	353603	0	834061	19133873		
147415	3241	40213227	1992-05-21	1992-05-21 00:00:00	1992-05-21	1992-05-21 00:00:00	1992-05-21	581452		0	0	0		0	0	0	215543	0	113	40213227		
29580	644	40213227	1998-07-15	1998-07-15 00:00:00	1998-07-15	1998-07-15 00:00:00	1998-07-15	581452		0	0	0		0	0	0	42630	0	113	40213227		
185313	4072	40213296	2017-11-18	2017-11-18 00:00:00	2017-11-18	2017-11-18 00:00:00	2017-11-18	581452		0	0	0		0	0	0	270727	0	52	40213296		
84352	1845	40213260	2011-04-20	2011-04-20 00:00:00	2011-04-20	2011-04-20 00:00:00	2011-04-20	581452		0	0	0		0	0	0	123382	0	121	40213260		
234531	5152	40213160	1974-12-22	1974-12-22 00:00:00	1974-12-22	1974-12-22 00:00:00	1974-12-22	581452		0	0	0		0	0	0	342624	0	10	40213160		
405	32	1127433	1986-07-05	1986-07-05 00:00:00	1986-07-19	1986-07-19 00:00:00	1986-07-19	38000177		0	0	14		0	0	0	2270	0	313782	1127433		
199098	4374	40213296	2017-08-24	2017-08-24 00:00:00	2017-08-24	2017-08-24 00:00:00	2017-08-24	581452		0	0	0		0	0	0	290539	0	52	40213296		
40404	3347	1118084	1992-06-19	1992-06-19 00:00:00	1992-06-19	1992-06-19 00:00:00	\N	38000177		0	0	0		0	0	0	222095	0	00025152531	44923712		
222022	4873	40213306	1998-09-18	1998-09-18 00:00:00	1998-09-18	1998-09-18 00:00:00	1998-09-18	581452		0	0	0		0	0	0	324138	0	43	40213306		
147832	3250	40213296	2005-01-18	2005-01-18 00:00:00	2005-01-18	2005-01-18 00:00:00	2005-01-18	581452		0	0	0		0	0	0	216047	0	52	40213296		
187471	4117	40213160	1967-11-24	1967-11-24 00:00:00	1967-11-24	1967-11-24 00:00:00	1967-11-24	581452		0	0	0		0	0	0	273728	0	10	40213160		
187542	4119	40213198	2010-10-16	2010-10-16 00:00:00	2010-10-16	2010-10-16 00:00:00	2010-10-16	581452		0	0	0		0	0	0	273831	0	133	40213198		
212816	4666	40213227	2005-07-18	2005-07-18 00:00:00	2005-07-18	2005-07-18 00:00:00	2005-07-18	581452		0	0	0		0	0	0	310966	0	113	40213227		
129753	2853	40213306	1984-06-12	1984-06-12 00:00:00	1984-06-12	1984-06-12 00:00:00	1984-06-12	581452		0	0	0		0	0	0	189573	0	43	40213306		
200043	4393	40213160	1985-01-25	1985-01-25 00:00:00	1985-01-25	1985-01-25 00:00:00	1985-01-25	581452		0	0	0		0	0	0	292093	0	10	40213160		
131134	2882	40213306	1993-12-24	1993-12-24 00:00:00	1993-12-24	1993-12-24 00:00:00	1993-12-24	581452		0	0	0		0	0	0	191694	0	43	40213306		
9129	759	1115171	2016-11-17	2016-11-17 00:00:00	2017-01-16	2017-01-16 00:00:00	2017-01-16	38000177		0	0	60		0	0	0	50364	0	849574	1115171		
27607	601	40213296	2011-11-27	2011-11-27 00:00:00	2011-11-27	2011-11-27 00:00:00	2011-11-27	581452		0	0	0		0	0	0	39719	0	52	40213296		
123353	2711	40213227	1992-02-24	1992-02-24 00:00:00	1992-02-24	1992-02-24 00:00:00	1992-02-24	581452		0	0	0		0	0	0	\N	0	113	40213227		
171577	3772	40213296	2009-02-21	2009-02-21 00:00:00	2009-02-21	2009-02-21 00:00:00	2009-02-21	581452		0	0	0		0	0	0	250747	0	52	40213296		
103804	2277	40213160	1970-08-16	1970-08-16 00:00:00	1970-08-16	1970-08-16 00:00:00	1970-08-16	581452		0	0	0		0	0	0	151381	0	10	40213160		
186347	4094	40213227	2008-09-18	2008-09-18 00:00:00	2008-09-18	2008-09-18 00:00:00	2008-09-18	581452		0	0	0		0	0	0	272187	0	113	40213227		
110983	2438	40213314	1981-08-30	1981-08-30 00:00:00	1981-08-30	1981-08-30 00:00:00	1981-08-30	581452		0	0	0		0	0	0	161731	0	49	40213314		
9480	788	19133873	1970-11-06	1970-11-06 00:00:00	1970-11-16	1970-11-16 00:00:00	1970-11-16	38000177		0	0	10		0	0	0	52392	0	834061	19133873		
18118	393	40213160	1957-09-18	1957-09-18 00:00:00	1957-09-18	1957-09-18 00:00:00	1957-09-18	581452		0	0	0		0	0	0	25821	0	10	40213160		
64004	5316	19059056	1960-11-16	1960-11-16 00:00:00	1960-11-30	1960-11-30 00:00:00	1960-11-30	38000177		0	0	14		0	0	0	353569	0	243670	19059056		
147418	3241	40213296	2001-04-05	2001-04-05 00:00:00	2001-04-05	2001-04-05 00:00:00	2001-04-05	581452		0	0	0		0	0	0	215588	0	52	40213296		
29582	644	40213306	1998-07-15	1998-07-15 00:00:00	1998-07-15	1998-07-15 00:00:00	1998-07-15	581452		0	0	0		0	0	0	42630	0	43	40213306		
185314	4072	40213314	1978-02-11	1978-02-11 00:00:00	1978-02-11	1978-02-11 00:00:00	1978-02-11	581452		0	0	0		0	0	0	270722	0	49	40213314		
84355	1845	40213160	1961-12-27	1961-12-27 00:00:00	1961-12-27	1961-12-27 00:00:00	1961-12-27	581452		0	0	0		0	0	0	123337	0	10	40213160		
198597	4364	40213160	1955-12-11	1955-12-11 00:00:00	1955-12-11	1955-12-11 00:00:00	1955-12-11	581452		0	0	0		0	0	0	289427	0	10	40213160		
406	32	1127433	1991-03-22	1991-03-22 00:00:00	1991-04-12	1991-04-12 00:00:00	1991-04-12	38000177		0	0	21		0	0	0	2281	0	313782	1127433		
199118	4375	40213227	2019-03-10	2019-03-10 00:00:00	2019-03-10	2019-03-10 00:00:00	2019-03-10	581452		0	0	0		0	0	0	290652	0	113	40213227		
61789	5142	1713671	1981-11-28	1981-11-28 00:00:00	1981-12-19	1981-12-19 00:00:00	1981-12-19	38000177		0	0	21		0	0	0	341769	0	562251	1713671		
222024	4873	40213227	1998-09-18	1998-09-18 00:00:00	1998-09-18	1998-09-18 00:00:00	1998-09-18	581452		0	0	0		0	0	0	324138	0	113	40213227		
147834	3250	40213160	1963-06-18	1963-06-18 00:00:00	1963-06-18	1963-06-18 00:00:00	1963-06-18	581452		0	0	0		0	0	0	216058	0	10	40213160		
187475	4117	40213227	2014-07-18	2014-07-18 00:00:00	2014-07-18	2014-07-18 00:00:00	2014-07-18	581452		0	0	0		0	0	0	273714	0	113	40213227		
187551	4119	40213227	2005-09-17	2005-09-17 00:00:00	2005-09-17	2005-09-17 00:00:00	2005-09-17	581452		0	0	0		0	0	0	273819	0	113	40213227		
185542	4078	40213160	1956-07-16	1956-07-16 00:00:00	1956-07-16	1956-07-16 00:00:00	1956-07-16	581452		0	0	0		0	0	0	271021	0	10	40213160		
129757	2853	40213160	1962-01-09	1962-01-09 00:00:00	1962-01-09	1962-01-09 00:00:00	1962-01-09	581452		0	0	0		0	0	0	189509	0	10	40213160		
200048	4393	40213314	1985-07-26	1985-07-26 00:00:00	1985-07-26	1985-07-26 00:00:00	1985-07-26	581452		0	0	0		0	0	0	292121	0	49	40213314		
131139	2882	40213227	1993-12-17	1993-12-17 00:00:00	1993-12-17	1993-12-17 00:00:00	1993-12-17	581452		0	0	0		0	0	0	\N	0	113	40213227		
9130	759	40165015	2016-11-17	2016-11-17 00:00:00	2016-11-17	2016-11-17 00:00:00	\N	38000177		0	0	0		0	0	0	50364	0	861467	40165015		
27611	601	40213227	2001-08-26	2001-08-26 00:00:00	2001-08-26	2001-08-26 00:00:00	2001-08-26	581452		0	0	0		0	0	0	39715	0	113	40213227		
123354	2711	40213160	1955-05-23	1955-05-23 00:00:00	1955-05-23	1955-05-23 00:00:00	1955-05-23	581452		0	0	0		0	0	0	179804	0	10	40213160		
171584	3772	40213160	1974-01-26	1974-01-26 00:00:00	1974-01-26	1974-01-26 00:00:00	1974-01-26	581452		0	0	0		0	0	0	250752	0	10	40213160		
103808	2277	40213227	2016-09-11	2016-09-11 00:00:00	2016-09-11	2016-09-11 00:00:00	2016-09-11	581452		0	0	0		0	0	0	151338	0	113	40213227		
186353	4094	40213296	1997-10-16	1997-10-16 00:00:00	1997-10-16	1997-10-16 00:00:00	1997-10-16	581452		0	0	0		0	0	0	272170	0	52	40213296		
110988	2438	40213160	1980-09-28	1980-09-28 00:00:00	1980-09-28	1980-09-28 00:00:00	1980-09-28	581452		0	0	0		0	0	0	161742	0	10	40213160		
9481	788	19078461	1985-09-16	1985-09-16 00:00:00	1985-10-07	1985-10-07 00:00:00	1985-10-07	38000177		0	0	21		0	0	0	52452	0	310965	19078461		
18124	393	40213160	1957-06-19	1957-06-19 00:00:00	1957-06-19	1957-06-19 00:00:00	1957-06-19	581452		0	0	0		0	0	0	25831	0	10	40213160		
64005	5316	19006318	1960-11-16	1960-11-16 00:00:00	1960-11-30	1960-11-30 00:00:00	1960-11-30	38000177		0	0	14		0	0	0	353569	0	105078	19006318		
147425	3241	40213160	1961-12-07	1961-12-07 00:00:00	1961-12-07	1961-12-07 00:00:00	1961-12-07	581452		0	0	0		0	0	0	215535	0	10	40213160		
29584	644	40213296	2019-06-12	2019-06-12 00:00:00	2019-06-12	2019-06-12 00:00:00	2019-06-12	581452		0	0	0		0	0	0	42674	0	52	40213296		
185316	4072	40213227	2015-11-14	2015-11-14 00:00:00	2015-11-14	2015-11-14 00:00:00	2015-11-14	581452		0	0	0		0	0	0	270717	0	113	40213227		
84358	1845	40213160	1961-09-27	1961-09-27 00:00:00	1961-09-27	1961-09-27 00:00:00	1961-09-27	581452		0	0	0		0	0	0	123303	0	10	40213160		
198606	4364	40213198	2016-07-24	2016-07-24 00:00:00	2016-07-24	2016-07-24 00:00:00	2016-07-24	581452		0	0	0		0	0	0	289446	0	133	40213198		
407	32	1127433	1944-06-24	1944-06-24 00:00:00	1944-07-01	1944-07-01 00:00:00	1944-07-01	38000177		0	0	7		0	0	0	2260	0	313782	1127433		
142253	3125	40213227	1993-07-08	1993-07-08 00:00:00	1993-07-08	1993-07-08 00:00:00	1993-07-08	581452		0	0	0		0	0	0	208014	0	113	40213227		
61790	5142	19133905	1973-08-06	1973-08-06 00:00:00	1973-08-17	1973-08-17 00:00:00	1973-08-17	38000177		0	0	11		0	0	0	341768	0	834102	19133905		
222028	4873	40213296	2017-12-01	2017-12-01 00:00:00	2017-12-01	2017-12-01 00:00:00	2017-12-01	581452		0	0	0		0	0	0	\N	0	52	40213296		
147839	3250	40213160	1963-09-17	1963-09-17 00:00:00	1963-09-17	1963-09-17 00:00:00	1963-09-17	581452		0	0	0		0	0	0	216078	0	10	40213160		
187476	4117	40213260	2014-07-18	2014-07-18 00:00:00	2014-07-18	2014-07-18 00:00:00	2014-07-18	581452		0	0	0		0	0	0	273714	0	121	40213260		
155578	3423	40213314	1977-08-25	1977-08-25 00:00:00	1977-08-25	1977-08-25 00:00:00	1977-08-25	581452		0	0	0		0	0	0	227070	0	49	40213314		
185547	4078	40213198	2017-04-24	2017-04-24 00:00:00	2017-04-24	2017-04-24 00:00:00	2017-04-24	581452		0	0	0		0	0	0	271044	0	133	40213198		
129769	2853	40213260	2012-05-08	2012-05-08 00:00:00	2012-05-08	2012-05-08 00:00:00	2012-05-08	581452		0	0	0		0	0	0	189564	0	121	40213260		
200049	4393	40213251	1985-07-26	1985-07-26 00:00:00	1985-07-26	1985-07-26 00:00:00	1985-07-26	581452		0	0	0		0	0	0	292121	0	21	40213251		
131140	2882	40213306	1993-12-17	1993-12-17 00:00:00	1993-12-17	1993-12-17 00:00:00	1993-12-17	581452		0	0	0		0	0	0	\N	0	43	40213306		
19589	1611	40229134	2011-10-12	2011-10-12 00:00:00	2011-10-19	2011-10-19 00:00:00	2011-10-19	38000177		0	0	7		0	0	0	108327	0	1043400	40229134		
27614	601	40213296	2009-11-22	2009-11-22 00:00:00	2009-11-22	2009-11-22 00:00:00	2009-11-22	581452		0	0	0		0	0	0	39679	0	52	40213296		
4649	387	19128065	1988-08-22	1988-08-22 00:00:00	1989-08-17	1989-08-17 00:00:00	1989-08-17	38000177		0	0	360		0	0	0	25449	0	749882	19128065		
171588	3772	40213160	1969-07-26	1969-07-26 00:00:00	1969-07-26	1969-07-26 00:00:00	1969-07-26	581452		0	0	0		0	0	0	250749	0	10	40213160		
103809	2277	40213260	2016-09-11	2016-09-11 00:00:00	2016-09-11	2016-09-11 00:00:00	2016-09-11	581452		0	0	0		0	0	0	151338	0	121	40213260		
186361	4094	40213227	1999-10-21	1999-10-21 00:00:00	1999-10-21	1999-10-21 00:00:00	1999-10-21	581452		0	0	0		0	0	0	272186	0	113	40213227		
110989	2438	40213314	1980-09-28	1980-09-28 00:00:00	1980-09-28	1980-09-28 00:00:00	1980-09-28	581452		0	0	0		0	0	0	161742	0	49	40213314		
9482	788	19006318	1973-04-06	1973-04-06 00:00:00	1973-04-20	1973-04-20 00:00:00	1973-04-20	38000177		0	0	14		0	0	0	52435	0	105078	19006318		
18127	393	40213260	2007-10-10	2007-10-10 00:00:00	2007-10-10	2007-10-10 00:00:00	2007-10-10	581452		0	0	0		0	0	0	25806	0	121	40213260		
64006	5316	1127078	1966-09-27	1966-09-27 00:00:00	1966-10-18	1966-10-18 00:00:00	1966-10-18	38000177		0	0	21		0	0	0	353607	0	282464	1127078		
147433	3241	40213296	2003-04-10	2003-04-10 00:00:00	2003-04-10	2003-04-10 00:00:00	2003-04-10	581452		0	0	0		0	0	0	215464	0	52	40213296		
115979	2548	40213306	1988-05-08	1988-05-08 00:00:00	1988-05-08	1988-05-08 00:00:00	1988-05-08	581452		0	0	0		0	0	0	168708	0	43	40213306		
185317	4072	40213296	2015-11-14	2015-11-14 00:00:00	2015-11-14	2015-11-14 00:00:00	2015-11-14	581452		0	0	0		0	0	0	270717	0	52	40213296		
209845	4602	40213251	1984-04-30	1984-04-30 00:00:00	1984-04-30	1984-04-30 00:00:00	1984-04-30	581452		0	0	0		0	0	0	306527	0	21	40213251		
232841	5116	40213160	1965-02-04	1965-02-04 00:00:00	1965-02-04	1965-02-04 00:00:00	1965-02-04	581452		0	0	0		0	0	0	339976	0	10	40213160		
408	32	1713671	1991-06-01	1991-06-01 00:00:00	1991-06-15	1991-06-15 00:00:00	1991-06-15	38000177		0	0	14		0	0	0	2199	0	562251	1713671		
142255	3125	40213227	2012-08-30	2012-08-30 00:00:00	2012-08-30	2012-08-30 00:00:00	2012-08-30	581452		0	0	0		0	0	0	207982	0	113	40213227		
61791	5142	1118084	1985-03-19	1985-03-19 00:00:00	1985-03-19	1985-03-19 00:00:00	\N	38000177		0	0	0		0	0	0	341761	0	00025152531	44923712		
222030	4873	40213160	1976-12-24	1976-12-24 00:00:00	1976-12-24	1976-12-24 00:00:00	1976-12-24	581452		0	0	0		0	0	0	324117	0	10	40213160		
147843	3250	40213306	1986-08-26	1986-08-26 00:00:00	1986-08-26	1986-08-26 00:00:00	1986-08-26	581452		0	0	0		0	0	0	\N	0	43	40213306		
187483	4117	40213260	2013-07-12	2013-07-12 00:00:00	2013-07-12	2013-07-12 00:00:00	2013-07-12	581452		0	0	0		0	0	0	273689	0	121	40213260		
155580	3423	40213314	1978-02-23	1978-02-23 00:00:00	1978-02-23	1978-02-23 00:00:00	1978-02-23	581452		0	0	0		0	0	0	227051	0	49	40213314		
185555	4078	40213227	2003-02-03	2003-02-03 00:00:00	2003-02-03	2003-02-03 00:00:00	2003-02-03	581452		0	0	0		0	0	0	271011	0	113	40213227		
121554	2672	40213227	2002-01-06	2002-01-06 00:00:00	2002-01-06	2002-01-06 00:00:00	2002-01-06	581452		0	0	0		0	0	0	176964	0	113	40213227		
200056	4393	40213227	2006-04-21	2006-04-21 00:00:00	2006-04-21	2006-04-21 00:00:00	2006-04-21	581452		0	0	0		0	0	0	292099	0	113	40213227		
131146	2882	40213227	2005-08-12	2005-08-12 00:00:00	2005-08-12	2005-08-12 00:00:00	2005-08-12	581452		0	0	0		0	0	0	191688	0	113	40213227		
19590	1611	19075601	2017-04-09	2017-04-09 00:00:00	2017-04-09	2017-04-09 00:00:00	2017-04-09	38000177		0	0	0		0	0	0	108330	0	309362	19075601		
27618	601	40213306	1992-08-16	1992-08-16 00:00:00	1992-08-16	1992-08-16 00:00:00	1992-08-16	581452		0	0	0		0	0	0	39712	0	43	40213306		
4650	387	1115171	2011-03-27	2011-03-27 00:00:00	2011-05-01	2011-05-01 00:00:00	2011-05-01	38000177		0	0	35		0	0	0	25459	0	849574	1115171		
171591	3772	40213227	2000-04-29	2000-04-29 00:00:00	2000-04-29	2000-04-29 00:00:00	2000-04-29	581452		0	0	0		0	0	0	250727	0	113	40213227		
103811	2277	40213260	2015-09-06	2015-09-06 00:00:00	2015-09-06	2015-09-06 00:00:00	2015-09-06	581452		0	0	0		0	0	0	151348	0	121	40213260		
186363	4094	40213296	1999-10-21	1999-10-21 00:00:00	1999-10-21	1999-10-21 00:00:00	1999-10-21	581452		0	0	0		0	0	0	272186	0	52	40213296		
110993	2438	40213251	1984-12-30	1984-12-30 00:00:00	1984-12-30	1984-12-30 00:00:00	1984-12-30	581452		0	0	0		0	0	0	161734	0	21	40213251		
9483	788	19059056	1973-04-06	1973-04-06 00:00:00	1973-04-20	1973-04-20 00:00:00	1973-04-20	38000177		0	0	14		0	0	0	52435	0	243670	19059056		
18128	393	40213160	1957-04-17	1957-04-17 00:00:00	1957-04-17	1957-04-17 00:00:00	1957-04-17	581452		0	0	0		0	0	0	25820	0	10	40213160		
64007	5316	1127078	1957-08-15	1957-08-15 00:00:00	1957-08-29	1957-08-29 00:00:00	1957-08-29	38000177		0	0	14		0	0	0	353567	0	282464	1127078		
147435	3241	40213227	2003-04-10	2003-04-10 00:00:00	2003-04-10	2003-04-10 00:00:00	2003-04-10	581452		0	0	0		0	0	0	215464	0	113	40213227		
115986	2548	40213227	2007-10-14	2007-10-14 00:00:00	2007-10-14	2007-10-14 00:00:00	2007-10-14	581452		0	0	0		0	0	0	168722	0	113	40213227		
185322	4072	40213160	1975-02-15	1975-02-15 00:00:00	1975-02-15	1975-02-15 00:00:00	1975-02-15	581452		0	0	0		0	0	0	270673	0	10	40213160		
209849	4602	40213160	1982-04-19	1982-04-19 00:00:00	1982-04-19	1982-04-19 00:00:00	1982-04-19	581452		0	0	0		0	0	0	306548	0	10	40213160		
232845	5117	40213160	1963-02-18	1963-02-18 00:00:00	1963-02-18	1963-02-18 00:00:00	1963-02-18	581452		0	0	0		0	0	0	340056	0	10	40213160		
409	32	19059056	1947-08-07	1947-08-07 00:00:00	1947-08-21	1947-08-21 00:00:00	1947-08-21	38000177		0	0	14		0	0	0	2274	0	243670	19059056		
142256	3125	40213160	1956-06-07	1956-06-07 00:00:00	1956-06-07	1956-06-07 00:00:00	1956-06-07	581452		0	0	0		0	0	0	207999	0	10	40213160		
61792	5142	1127433	1999-03-30	1999-03-30 00:00:00	1999-04-13	1999-04-13 00:00:00	1999-04-13	38000177		0	0	14		0	0	0	341726	0	313782	1127433		
222031	4873	40213160	1976-10-22	1976-10-22 00:00:00	1976-10-22	1976-10-22 00:00:00	1976-10-22	581452		0	0	0		0	0	0	324100	0	10	40213160		
147846	3250	40213227	1994-02-15	1994-02-15 00:00:00	1994-02-15	1994-02-15 00:00:00	1994-02-15	581452		0	0	0		0	0	0	216084	0	113	40213227		
194978	4283	40213160	1955-03-19	1955-03-19 00:00:00	1955-03-19	1955-03-19 00:00:00	1955-03-19	581452		0	0	0		0	0	0	284299	0	10	40213160		
155582	3423	40213314	1977-02-24	1977-02-24 00:00:00	1977-02-24	1977-02-24 00:00:00	1977-02-24	581452		0	0	0		0	0	0	227081	0	49	40213314		
185560	4078	40213160	1955-01-10	1955-01-10 00:00:00	1955-01-10	1955-01-10 00:00:00	1955-01-10	581452		0	0	0		0	0	0	270999	0	10	40213160		
121565	2672	40213227	2012-03-04	2012-03-04 00:00:00	2012-03-04	2012-03-04 00:00:00	2012-03-04	581452		0	0	0		0	0	0	176968	0	113	40213227		
200057	4393	40213306	2006-04-21	2006-04-21 00:00:00	2006-04-21	2006-04-21 00:00:00	2006-04-21	581452		0	0	0		0	0	0	292099	0	43	40213306		
131152	2882	40213296	2015-08-28	2015-08-28 00:00:00	2015-08-28	2015-08-28 00:00:00	2015-08-28	581452		0	0	0		0	0	0	191739	0	52	40213296		
19591	1611	40220960	2017-04-09	2017-04-09 00:00:00	2017-04-09	2017-04-09 00:00:00	2017-04-09	38000177		0	0	0		0	0	0	108330	0	1804799	40220960		
27620	601	40213227	1992-08-16	1992-08-16 00:00:00	1992-08-16	1992-08-16 00:00:00	1992-08-16	581452		0	0	0		0	0	0	39712	0	113	40213227		
4651	387	1127433	1975-08-22	1975-08-22 00:00:00	1975-09-05	1975-09-05 00:00:00	1975-09-05	38000177		0	0	14		0	0	0	25447	0	313782	1127433		
171596	3773	40213306	1982-07-02	1982-07-02 00:00:00	1982-07-02	1982-07-02 00:00:00	1982-07-02	581452		0	0	0		0	0	0	250788	0	43	40213306		
103813	2277	40213296	2005-09-11	2005-09-11 00:00:00	2005-09-11	2005-09-11 00:00:00	2005-09-11	581452		0	0	0		0	0	0	151360	0	52	40213296		
24735	2033	1127433	1959-05-11	1959-05-11 00:00:00	1959-05-25	1959-05-25 00:00:00	1959-05-25	38000177		0	0	14		0	0	0	135329	0	313782	1127433		
110995	2438	40213160	1984-12-30	1984-12-30 00:00:00	1984-12-30	1984-12-30 00:00:00	1984-12-30	581452		0	0	0		0	0	0	161734	0	10	40213160		
9484	789	1127433	1995-12-01	1995-12-01 00:00:00	1995-12-15	1995-12-15 00:00:00	1995-12-15	38000177		0	0	14		0	0	0	52511	0	313782	1127433		
18133	393	40213296	1998-09-16	1998-09-16 00:00:00	1998-09-16	1998-09-16 00:00:00	1998-09-16	581452		0	0	0		0	0	0	25783	0	52	40213296		
64008	5316	19006318	1957-08-15	1957-08-15 00:00:00	1957-08-29	1957-08-29 00:00:00	1957-08-29	38000177		0	0	14		0	0	0	353567	0	105078	19006318		
147437	3241	40213160	1961-09-07	1961-09-07 00:00:00	1961-09-07	1961-09-07 00:00:00	1961-09-07	581452		0	0	0		0	0	0	215548	0	10	40213160		
115987	2548	40213296	2007-10-14	2007-10-14 00:00:00	2007-10-14	2007-10-14 00:00:00	2007-10-14	581452		0	0	0		0	0	0	168722	0	52	40213296		
185323	4072	40213160	1974-12-14	1974-12-14 00:00:00	1974-12-14	1974-12-14 00:00:00	1974-12-14	581452		0	0	0		0	0	0	270699	0	10	40213160		
209853	4602	40213227	1999-05-10	1999-05-10 00:00:00	1999-05-10	1999-05-10 00:00:00	1999-05-10	581452		0	0	0		0	0	0	306565	0	113	40213227		
232851	5117	40213160	1958-06-16	1958-06-16 00:00:00	1958-06-16	1958-06-16 00:00:00	1958-06-16	581452		0	0	0		0	0	0	340134	0	10	40213160		
410	32	19006318	1947-08-07	1947-08-07 00:00:00	1947-08-21	1947-08-21 00:00:00	1947-08-21	38000177		0	0	14		0	0	0	2274	0	105078	19006318		
142261	3125	40213227	2002-07-04	2002-07-04 00:00:00	2002-07-04	2002-07-04 00:00:00	2002-07-04	581452		0	0	0		0	0	0	207941	0	113	40213227		
61793	5142	1127433	1988-07-10	1988-07-10 00:00:00	1988-07-17	1988-07-17 00:00:00	1988-07-17	38000177		0	0	7		0	0	0	341709	0	313782	1127433		
222043	4873	40213227	2007-09-28	2007-09-28 00:00:00	2007-09-28	2007-09-28 00:00:00	2007-09-28	581452		0	0	0		0	0	0	324110	0	113	40213227		
108255	2373	40213260	2006-01-19	2006-01-19 00:00:00	2006-01-19	2006-01-19 00:00:00	2006-01-19	581452		0	0	0		0	0	0	157907	0	121	40213260		
194981	4283	40213227	1992-09-26	1992-09-26 00:00:00	1992-09-26	1992-09-26 00:00:00	1992-09-26	581452		0	0	0		0	0	0	284305	0	113	40213227		
195016	4284	40213201	2009-03-05	2009-03-05 00:00:00	2009-03-05	2009-03-05 00:00:00	2009-03-05	581452		0	0	0		0	0	0	284351	0	33	40213201		
185566	4078	40213227	2013-04-01	2013-04-01 00:00:00	2013-04-01	2013-04-01 00:00:00	2013-04-01	581452		0	0	0		0	0	0	271052	0	113	40213227		
121573	2672	40213198	2016-10-23	2016-10-23 00:00:00	2016-10-23	2016-10-23 00:00:00	2016-10-23	581452		0	0	0		0	0	0	177001	0	133	40213198		
200058	4393	40213180	2006-04-21	2006-04-21 00:00:00	2006-04-21	2006-04-21 00:00:00	2006-04-21	581452		0	0	0		0	0	0	292099	0	114	40213180		
131159	2883	40213160	1969-02-05	1969-02-05 00:00:00	1969-02-05	1969-02-05 00:00:00	1969-02-05	581452		0	0	0		0	0	0	191761	0	10	40213160		
19592	1612	1127433	1976-02-06	1976-02-06 00:00:00	1976-02-20	1976-02-20 00:00:00	1976-02-20	38000177		0	0	14		0	0	0	108358	0	313782	1127433		
196215	4312	40213306	1982-10-27	1982-10-27 00:00:00	1982-10-27	1982-10-27 00:00:00	1982-10-27	581452		0	0	0		0	0	0	\N	0	43	40213306		
4652	387	40229134	1980-04-16	1980-04-16 00:00:00	1980-04-23	1980-04-23 00:00:00	1980-04-23	38000177		0	0	7		0	0	0	25488	0	1043400	40229134		
171598	3773	40213227	1999-07-23	1999-07-23 00:00:00	1999-07-23	1999-07-23 00:00:00	1999-07-23	581452		0	0	0		0	0	0	250798	0	113	40213227		
103815	2277	40213160	1966-02-13	1966-02-13 00:00:00	1966-02-13	1966-02-13 00:00:00	1966-02-13	581452		0	0	0		0	0	0	151356	0	10	40213160		
24736	2033	1124300	1995-02-25	1995-02-25 00:00:00	1995-02-25	1995-02-25 00:00:00	\N	38000177		0	0	0		0	0	0	135277	0	00781178901	45011828		
111005	2438	40213227	2012-04-08	2012-04-08 00:00:00	2012-04-08	2012-04-08 00:00:00	2012-04-08	581452		0	0	0		0	0	0	161765	0	113	40213227		
9485	789	1115171	2000-06-25	2000-06-25 00:00:00	2000-07-09	2000-07-09 00:00:00	2000-07-09	38000177		0	0	14		0	0	0	52460	0	849574	1115171		
18135	393	40213227	1998-09-16	1998-09-16 00:00:00	1998-09-16	1998-09-16 00:00:00	1998-09-16	581452		0	0	0		0	0	0	25783	0	113	40213227		
64009	5316	1127433	2011-08-04	2011-08-04 00:00:00	2011-08-18	2011-08-18 00:00:00	2011-08-18	38000177		0	0	14		0	0	0	353586	0	313782	1127433		
147444	3241	40213160	1961-07-06	1961-07-06 00:00:00	1961-07-06	1961-07-06 00:00:00	1961-07-06	581452		0	0	0		0	0	0	215514	0	10	40213160		
127273	2799	40213160	1985-03-13	1985-03-13 00:00:00	1985-03-13	1985-03-13 00:00:00	1985-03-13	581452		0	0	0		0	0	0	185490	0	10	40213160		
185325	4072	40213306	1998-01-24	1998-01-24 00:00:00	1998-01-24	1998-01-24 00:00:00	1998-01-24	581452		0	0	0		0	0	0	270705	0	43	40213306		
209854	4602	40213306	1999-05-10	1999-05-10 00:00:00	1999-05-10	1999-05-10 00:00:00	1999-05-10	581452		0	0	0		0	0	0	306565	0	43	40213306		
232862	5117	40213296	1999-02-01	1999-02-01 00:00:00	1999-02-01	1999-02-01 00:00:00	1999-02-01	581452		0	0	0		0	0	0	340028	0	52	40213296		
411	32	1118084	1987-04-04	1987-04-04 00:00:00	1987-04-04	1987-04-04 00:00:00	\N	38000177		0	0	0		0	0	0	2198	0	00025152531	44923712		
142279	3125	40213198	2016-09-22	2016-09-22 00:00:00	2016-09-22	2016-09-22 00:00:00	2016-09-22	581452		0	0	0		0	0	0	207962	0	133	40213198		
61794	5142	19075601	1997-09-23	1997-09-23 00:00:00	2012-04-03	2012-04-03 00:00:00	2012-04-03	38000177		0	0	5306		0	0	0	341743	0	309362	19075601		
61206	1338	40213227	1995-04-20	1995-04-20 00:00:00	1995-04-20	1995-04-20 00:00:00	1995-04-20	581452		0	0	0		0	0	0	88725	0	113	40213227		
108257	2373	40213296	1996-06-20	1996-06-20 00:00:00	1996-06-20	1996-06-20 00:00:00	1996-06-20	581452		0	0	0		0	0	0	157892	0	52	40213296		
194984	4283	40213227	2002-10-26	2002-10-26 00:00:00	2002-10-26	2002-10-26 00:00:00	2002-10-26	581452		0	0	0		0	0	0	284282	0	113	40213227		
195017	4284	40213227	2004-02-05	2004-02-05 00:00:00	2004-02-05	2004-02-05 00:00:00	2004-02-05	581452		0	0	0		0	0	0	284343	0	113	40213227		
185578	4078	40213160	1955-07-11	1955-07-11 00:00:00	1955-07-11	1955-07-11 00:00:00	1955-07-11	581452		0	0	0		0	0	0	271000	0	10	40213160		
121581	2672	40213227	1992-08-09	1992-08-09 00:00:00	1992-08-09	1992-08-09 00:00:00	1992-08-09	581452		0	0	0		0	0	0	176930	0	113	40213227		
200060	4394	40213160	1975-02-10	1975-02-10 00:00:00	1975-02-10	1975-02-10 00:00:00	1975-02-10	581452		0	0	0		0	0	0	292160	0	10	40213160		
131163	2883	40213227	2005-04-13	2005-04-13 00:00:00	2005-04-13	2005-04-13 00:00:00	2005-04-13	581452		0	0	0		0	0	0	191809	0	113	40213227		
19593	1612	19059056	1971-05-20	1971-05-20 00:00:00	1971-06-03	1971-06-03 00:00:00	1971-06-03	38000177		0	0	14		0	0	0	108357	0	243670	19059056		
196220	4312	40213260	2009-12-02	2009-12-02 00:00:00	2009-12-02	2009-12-02 00:00:00	2009-12-02	581452		0	0	0		0	0	0	286104	0	121	40213260		
4653	387	19059056	1977-12-22	1977-12-22 00:00:00	1978-01-05	1978-01-05 00:00:00	1978-01-05	38000177		0	0	14		0	0	0	25492	0	243670	19059056		
171599	3773	40213296	1999-07-23	1999-07-23 00:00:00	1999-07-23	1999-07-23 00:00:00	1999-07-23	581452		0	0	0		0	0	0	250798	0	52	40213296		
103818	2277	40213160	1965-12-12	1965-12-12 00:00:00	1965-12-12	1965-12-12 00:00:00	1965-12-12	581452		0	0	0		0	0	0	151378	0	10	40213160		
24737	2033	19078461	2006-11-29	2006-11-29 00:00:00	2006-12-27	2006-12-27 00:00:00	2006-12-27	38000177		0	0	28		0	0	0	135299	0	310965	19078461		
88760	1947	40213227	1999-10-24	1999-10-24 00:00:00	1999-10-24	1999-10-24 00:00:00	1999-10-24	581452		0	0	0		0	0	0	129396	0	113	40213227		
9486	789	1127433	1992-03-18	1992-03-18 00:00:00	1992-04-08	1992-04-08 00:00:00	1992-04-08	38000177		0	0	21		0	0	0	52459	0	313782	1127433		
88499	1941	40213160	1973-07-26	1973-07-26 00:00:00	1973-07-26	1973-07-26 00:00:00	1973-07-26	581452		0	0	0		0	0	0	129044	0	10	40213160		
64010	5316	19078461	1993-03-30	1993-03-30 00:00:00	1993-04-13	1993-04-13 00:00:00	1993-04-13	38000177		0	0	14		0	0	0	353609	0	310965	19078461		
48144	1053	40213160	1976-05-07	1976-05-07 00:00:00	1976-05-07	1976-05-07 00:00:00	1976-05-07	581452		0	0	0		0	0	0	69061	0	10	40213160		
127274	2799	40213251	1985-03-13	1985-03-13 00:00:00	1985-03-13	1985-03-13 00:00:00	1985-03-13	581452		0	0	0		0	0	0	185490	0	21	40213251		
185327	4072	40213160	1979-08-18	1979-08-18 00:00:00	1979-08-18	1979-08-18 00:00:00	1979-08-18	581452		0	0	0		0	0	0	270723	0	10	40213160		
209855	4602	40213296	2017-07-31	2017-07-31 00:00:00	2017-07-31	2017-07-31 00:00:00	2017-07-31	581452		0	0	0		0	0	0	306566	0	52	40213296		
232865	5117	40213160	1958-08-18	1958-08-18 00:00:00	1958-08-18	1958-08-18 00:00:00	1958-08-18	581452		0	0	0		0	0	0	340100	0	10	40213160		
412	32	19059056	1951-07-17	1951-07-17 00:00:00	1951-09-15	1951-09-15 00:00:00	1951-09-15	38000177		0	0	60		0	0	0	2234	0	243670	19059056		
38256	834	40213296	1996-07-15	1996-07-15 00:00:00	1996-07-15	1996-07-15 00:00:00	1996-07-15	581452		0	0	0		0	0	0	55166	0	52	40213296		
61795	5142	40229134	1963-11-12	1963-11-12 00:00:00	1963-11-26	1963-11-26 00:00:00	1963-11-26	38000177		0	0	14		0	0	0	341706	0	1043400	40229134		
172098	3783	40213227	1992-08-21	1992-08-21 00:00:00	1992-08-21	1992-08-21 00:00:00	1992-08-21	581452		0	0	0		0	0	0	251395	0	113	40213227		
108261	2373	40213160	1961-01-05	1961-01-05 00:00:00	1961-01-05	1961-01-05 00:00:00	1961-01-05	581452		0	0	0		0	0	0	157932	0	10	40213160		
194995	4284	40213198	2010-03-11	2010-03-11 00:00:00	2010-03-11	2010-03-11 00:00:00	2010-03-11	581452		0	0	0		0	0	0	284321	0	133	40213198		
195029	4284	40213227	2014-04-03	2014-04-03 00:00:00	2014-04-03	2014-04-03 00:00:00	2014-04-03	581452		0	0	0		0	0	0	284323	0	113	40213227		
121588	2672	40213201	2017-10-29	2017-10-29 00:00:00	2017-10-29	2017-10-29 00:00:00	2017-10-29	581452		0	0	0		0	0	0	176995	0	33	40213201		
174284	3832	40213314	1985-03-21	1985-03-21 00:00:00	1985-03-21	1985-03-21 00:00:00	1985-03-21	581452		0	0	0		0	0	0	254457	0	49	40213314		
131164	2883	40213296	2005-04-13	2005-04-13 00:00:00	2005-04-13	2005-04-13 00:00:00	2005-04-13	581452		0	0	0		0	0	0	191809	0	52	40213296		
19594	1612	1154615	1966-08-06	1966-08-06 00:00:00	1982-12-14	1982-12-14 00:00:00	1982-12-14	38000177		0	0	5974		0	0	0	108381	0	745679	1154615		
196223	4312	40213227	2010-12-08	2010-12-08 00:00:00	2010-12-08	2010-12-08 00:00:00	2010-12-08	581452		0	0	0		0	0	0	286178	0	113	40213227		
4654	387	19129655	1977-12-22	1977-12-22 00:00:00	1978-01-05	1978-01-05 00:00:00	1978-01-05	38000177		0	0	14		0	0	0	25492	0	789980	19129655		
171604	3773	40213160	1963-04-12	1963-04-12 00:00:00	1963-04-12	1963-04-12 00:00:00	1963-04-12	581452		0	0	0		0	0	0	250774	0	10	40213160		
144360	3174	40213251	1984-05-18	1984-05-18 00:00:00	1984-05-18	1984-05-18 00:00:00	1984-05-18	581452		0	0	0		0	0	0	210964	0	21	40213251		
24738	2033	1127433	1980-08-03	1980-08-03 00:00:00	1980-08-17	1980-08-17 00:00:00	1980-08-17	38000177		0	0	14		0	0	0	135376	0	313782	1127433		
88773	1947	40213227	1993-08-29	1993-08-29 00:00:00	1993-08-29	1993-08-29 00:00:00	1993-08-29	581452		0	0	0		0	0	0	129458	0	113	40213227		
45609	3776	1115171	1994-12-30	1994-12-30 00:00:00	1995-01-13	1995-01-13 00:00:00	1995-01-13	38000177		0	0	14		0	0	0	250980	0	849574	1115171		
88501	1941	40213227	2015-02-26	2015-02-26 00:00:00	2015-02-26	2015-02-26 00:00:00	2015-02-26	581452		0	0	0		0	0	0	129070	0	113	40213227		
64011	5316	1127078	1958-10-23	1958-10-23 00:00:00	1958-11-06	1958-11-06 00:00:00	1958-11-06	38000177		0	0	14		0	0	0	353568	0	282464	1127078		
48149	1053	40213227	2010-01-22	2010-01-22 00:00:00	2010-01-22	2010-01-22 00:00:00	2010-01-22	581452		0	0	0		0	0	0	69001	0	113	40213227		
127277	2799	40213314	1980-07-09	1980-07-09 00:00:00	1980-07-09	1980-07-09 00:00:00	1980-07-09	581452		0	0	0		0	0	0	185480	0	49	40213314		
70974	1553	40213160	1967-11-17	1967-11-17 00:00:00	1967-11-17	1967-11-17 00:00:00	1967-11-17	581452		0	0	0		0	0	0	103976	0	10	40213160		
209858	4602	40213227	2008-05-19	2008-05-19 00:00:00	2008-05-19	2008-05-19 00:00:00	2008-05-19	581452		0	0	0		0	0	0	306579	0	113	40213227		
232870	5117	40213160	1958-11-17	1958-11-17 00:00:00	1958-11-17	1958-11-17 00:00:00	1958-11-17	581452		0	0	0		0	0	0	340135	0	10	40213160		
413	32	1127433	2003-07-09	2003-07-09 00:00:00	2003-07-23	2003-07-23 00:00:00	2003-07-23	38000177		0	0	14		0	0	0	2202	0	313782	1127433		
164416	3616	40213227	2019-05-07	2019-05-07 00:00:00	2019-05-07	2019-05-07 00:00:00	2019-05-07	581452		0	0	0		0	0	0	240249	0	113	40213227		
61796	5142	46233710	1978-01-23	1978-01-23 00:00:00	1978-02-27	1978-02-27 00:00:00	1978-02-27	38000177		0	0	35		0	0	0	341696	0	1650142	46233710		
172125	3784	40213227	1992-08-18	1992-08-18 00:00:00	1992-08-18	1992-08-18 00:00:00	1992-08-18	581452		0	0	0		0	0	0	251535	0	113	40213227		
108263	2373	40213160	1956-06-28	1956-06-28 00:00:00	1956-06-28	1956-06-28 00:00:00	1956-06-28	581452		0	0	0		0	0	0	157963	0	10	40213160		
241958	5312	40213227	1999-12-20	1999-12-20 00:00:00	1999-12-20	1999-12-20 00:00:00	1999-12-20	581452		0	0	0		0	0	0	353241	0	113	40213227		
195051	4284	40213227	1993-12-09	1993-12-09 00:00:00	1993-12-09	1993-12-09 00:00:00	1993-12-09	581452		0	0	0		0	0	0	284347	0	113	40213227		
161201	3547	40213296	2010-07-19	2010-07-19 00:00:00	2010-07-19	2010-07-19 00:00:00	2010-07-19	581452		0	0	0		0	0	0	235554	0	52	40213296		
174285	3832	40213251	1985-03-21	1985-03-21 00:00:00	1985-03-21	1985-03-21 00:00:00	1985-03-21	581452		0	0	0		0	0	0	254457	0	21	40213251		
131165	2883	40213306	1986-04-23	1986-04-23 00:00:00	1986-04-23	1986-04-23 00:00:00	1986-04-23	581452		0	0	0		0	0	0	191754	0	43	40213306		
19595	1612	40169216	1966-08-06	1966-08-06 00:00:00	1982-12-14	1982-12-14 00:00:00	1982-12-14	38000177		0	0	5974		0	0	0	108381	0	895994	40169216		
196224	4312	40213260	2010-12-08	2010-12-08 00:00:00	2010-12-08	2010-12-08 00:00:00	2010-12-08	581452		0	0	0		0	0	0	286178	0	121	40213260		
196249	4312	40213160	1960-05-25	1960-05-25 00:00:00	1960-05-25	1960-05-25 00:00:00	1960-05-25	581452		0	0	0		0	0	0	286114	0	10	40213160		
171616	3773	40213260	2009-07-10	2009-07-10 00:00:00	2009-07-10	2009-07-10 00:00:00	2009-07-10	581452		0	0	0		0	0	0	250837	0	121	40213260		
144363	3174	40213160	1981-08-21	1981-08-21 00:00:00	1981-08-21	1981-08-21 00:00:00	1981-08-21	581452		0	0	0		0	0	0	210969	0	10	40213160		
24739	2034	1713671	1968-01-10	1968-01-10 00:00:00	1968-01-24	1968-01-24 00:00:00	1968-01-24	38000177		0	0	14		0	0	0	135492	0	562251	1713671		
88780	1947	40213198	2014-07-20	2014-07-20 00:00:00	2014-07-20	2014-07-20 00:00:00	2014-07-20	581452		0	0	0		0	0	0	129487	0	133	40213198		
45610	3776	1124300	2007-09-12	2007-09-12 00:00:00	2007-09-12	2007-09-12 00:00:00	\N	38000177		0	0	0		0	0	0	250967	0	00781178901	45011828		
88502	1941	40213296	2015-02-26	2015-02-26 00:00:00	2015-02-26	2015-02-26 00:00:00	2015-02-26	581452		0	0	0		0	0	0	129070	0	52	40213296		
64012	5316	19078461	1998-10-14	1998-10-14 00:00:00	1998-11-04	1998-11-04 00:00:00	1998-11-04	38000177		0	0	21		0	0	0	353610	0	310965	19078461		
186959	4106	40213198	2010-09-24	2010-09-24 00:00:00	2010-09-24	2010-09-24 00:00:00	2010-09-24	581452		0	0	0		0	0	0	272830	0	133	40213198		
127278	2799	40213160	1980-07-09	1980-07-09 00:00:00	1980-07-09	1980-07-09 00:00:00	1980-07-09	581452		0	0	0		0	0	0	185480	0	10	40213160		
70977	1553	40213160	1967-06-16	1967-06-16 00:00:00	1967-06-16	1967-06-16 00:00:00	1967-06-16	581452		0	0	0		0	0	0	103975	0	10	40213160		
209866	4602	40213314	1977-10-17	1977-10-17 00:00:00	1977-10-17	1977-10-17 00:00:00	1977-10-17	581452		0	0	0		0	0	0	306545	0	49	40213314		
193290	4246	40213227	2009-09-02	2009-09-02 00:00:00	2009-09-02	2009-09-02 00:00:00	2009-09-02	581452		0	0	0		0	0	0	281968	0	113	40213227		
414	32	1127433	1956-03-20	1956-03-20 00:00:00	1956-04-10	1956-04-10 00:00:00	1956-04-10	38000177		0	0	21		0	0	0	2236	0	313782	1127433		
164418	3616	40213160	1963-02-05	1963-02-05 00:00:00	1963-02-05	1963-02-05 00:00:00	1963-02-05	581452		0	0	0		0	0	0	240278	0	10	40213160		
61797	5142	1127433	1978-01-23	1978-01-23 00:00:00	1978-02-27	1978-02-27 00:00:00	1978-02-27	38000177		0	0	35		0	0	0	341696	0	313782	1127433		
108275	2373	40213160	1956-09-27	1956-09-27 00:00:00	1956-09-27	1956-09-27 00:00:00	1956-09-27	581452		0	0	0		0	0	0	157928	0	10	40213160		
237877	5222	40213201	1983-10-20	1983-10-20 00:00:00	1983-10-20	1983-10-20 00:00:00	1983-10-20	581452		0	0	0		0	0	0	347524	0	33	40213201		
185498	4077	40213296	2011-11-28	2011-11-28 00:00:00	2011-11-28	2011-11-28 00:00:00	2011-11-28	581452		0	0	0		0	0	0	270925	0	52	40213296		
161206	3547	40213160	1970-10-19	1970-10-19 00:00:00	1970-10-19	1970-10-19 00:00:00	1970-10-19	581452		0	0	0		0	0	0	235572	0	10	40213160		
174295	3832	40213227	2015-02-19	2015-02-19 00:00:00	2015-02-19	2015-02-19 00:00:00	2015-02-19	581452		0	0	0		0	0	0	254434	0	113	40213227		
200071	4394	40213160	1970-06-08	1970-06-08 00:00:00	1970-06-08	1970-06-08 00:00:00	1970-06-08	581452		0	0	0		0	0	0	292139	0	10	40213160		
19596	1612	1713671	1980-11-28	1980-11-28 00:00:00	1980-12-12	1980-12-12 00:00:00	1980-12-12	38000177		0	0	14		0	0	0	108364	0	562251	1713671		
196226	4312	40213306	1981-09-16	1981-09-16 00:00:00	1981-09-16	1981-09-16 00:00:00	1981-09-16	581452		0	0	0		0	0	0	286116	0	43	40213306		
196260	4312	40213296	2000-05-10	2000-05-10 00:00:00	2000-05-10	2000-05-10 00:00:00	2000-05-10	581452		0	0	0		0	0	0	286101	0	52	40213296		
171618	3773	40213227	2009-07-10	2009-07-10 00:00:00	2009-07-10	2009-07-10 00:00:00	2009-07-10	581452		0	0	0		0	0	0	250837	0	113	40213227		
144364	3174	40213314	1982-02-19	1982-02-19 00:00:00	1982-02-19	1982-02-19 00:00:00	1982-02-19	581452		0	0	0		0	0	0	210962	0	49	40213314		
24740	2034	1127433	1987-01-26	1987-01-26 00:00:00	1987-03-02	1987-03-02 00:00:00	1987-03-02	38000177		0	0	35		0	0	0	135488	0	313782	1127433		
100066	2192	40213260	2007-06-07	2007-06-07 00:00:00	2007-06-07	2007-06-07 00:00:00	2007-06-07	581452		0	0	0		0	0	0	146242	0	121	40213260		
45611	3776	19128065	1988-05-24	1988-05-24 00:00:00	1989-05-19	1989-05-19 00:00:00	1989-05-19	38000177		0	0	360		0	0	0	250960	0	749882	19128065		
88505	1941	40213160	1973-10-25	1973-10-25 00:00:00	1973-10-25	1973-10-25 00:00:00	1973-10-25	581452		0	0	0		0	0	0	129094	0	10	40213160		
64013	5317	1118084	2014-05-20	2014-05-20 00:00:00	2014-05-20	2014-05-20 00:00:00	\N	38000177		0	0	0		0	0	0	353675	0	00025152531	44923712		
186961	4106	40213201	2010-09-24	2010-09-24 00:00:00	2010-09-24	2010-09-24 00:00:00	2010-09-24	581452		0	0	0		0	0	0	272830	0	33	40213201		
127280	2799	40213251	1984-03-07	1984-03-07 00:00:00	1984-03-07	1984-03-07 00:00:00	1984-03-07	581452		0	0	0		0	0	0	185510	0	21	40213251		
70979	1553	40213227	1999-01-08	1999-01-08 00:00:00	1999-01-08	1999-01-08 00:00:00	1999-01-08	581452		0	0	0		0	0	0	103948	0	113	40213227		
209867	4602	40213160	1977-10-17	1977-10-17 00:00:00	1977-10-17	1977-10-17 00:00:00	1977-10-17	581452		0	0	0		0	0	0	306545	0	10	40213160		
193298	4246	40213260	2016-12-28	2016-12-28 00:00:00	2016-12-28	2016-12-28 00:00:00	2016-12-28	581452		0	0	0		0	0	0	281934	0	121	40213260		
415	32	19077572	2006-08-30	2006-08-30 00:00:00	2006-08-30	2006-08-30 00:00:00	\N	38000177		0	0	0		0	0	0	2220	0	310436	19077572		
164419	3616	40213296	2000-03-07	2000-03-07 00:00:00	2000-03-07	2000-03-07 00:00:00	2000-03-07	581452		0	0	0		0	0	0	240257	0	52	40213296		
61798	5142	40229134	1972-07-25	1972-07-25 00:00:00	1972-08-01	1972-08-01 00:00:00	1972-08-01	38000177		0	0	7		0	0	0	341708	0	1043400	40229134		
91084	1999	40213160	1982-09-24	1982-09-24 00:00:00	1982-09-24	1982-09-24 00:00:00	1982-09-24	581452		0	0	0		0	0	0	133048	0	10	40213160		
185501	4077	40213160	1971-10-11	1971-10-11 00:00:00	1971-10-11	1971-10-11 00:00:00	1971-10-11	581452		0	0	0		0	0	0	270918	0	10	40213160		
161209	3547	40213160	1971-03-22	1971-03-22 00:00:00	1971-03-22	1971-03-22 00:00:00	1971-03-22	581452		0	0	0		0	0	0	235573	0	10	40213160		
174296	3832	40213160	1984-04-19	1984-04-19 00:00:00	1984-04-19	1984-04-19 00:00:00	1984-04-19	581452		0	0	0		0	0	0	254475	0	10	40213160		
200073	4394	40213296	2010-03-08	2010-03-08 00:00:00	2010-03-08	2010-03-08 00:00:00	2010-03-08	581452		0	0	0		0	0	0	292165	0	52	40213296		
19597	1612	1127433	1965-09-19	1965-09-19 00:00:00	1965-09-26	1965-09-26 00:00:00	1965-09-26	38000177		0	0	7		0	0	0	108380	0	313782	1127433		
196227	4312	40213296	2001-11-07	2001-11-07 00:00:00	2001-11-07	2001-11-07 00:00:00	2001-11-07	581452		0	0	0		0	0	0	286102	0	52	40213296		
196266	4312	40213160	1964-08-19	1964-08-19 00:00:00	1964-08-19	1964-08-19 00:00:00	1964-08-19	581452		0	0	0		0	0	0	286188	0	10	40213160		
171620	3773	40213160	1959-01-09	1959-01-09 00:00:00	1959-01-09	1959-01-09 00:00:00	1959-01-09	581452		0	0	0		0	0	0	250781	0	10	40213160		
144377	3174	40213160	1981-03-20	1981-03-20 00:00:00	1981-03-20	1981-03-20 00:00:00	1981-03-20	581452		0	0	0		0	0	0	210968	0	10	40213160		
24741	2034	1713671	1955-04-27	1955-04-27 00:00:00	1955-05-11	1955-05-11 00:00:00	1955-05-11	38000177		0	0	14		0	0	0	135448	0	562251	1713671		
100076	2192	40213160	1955-03-31	1955-03-31 00:00:00	1955-03-31	1955-03-31 00:00:00	1955-03-31	581452		0	0	0		0	0	0	146209	0	10	40213160		
45612	3776	1115171	2017-03-25	2017-03-25 00:00:00	2017-04-15	2017-04-15 00:00:00	2017-04-15	38000177		0	0	21		0	0	0	250982	0	849574	1115171		
88507	1941	40213227	2004-04-08	2004-04-08 00:00:00	2004-04-08	2004-04-08 00:00:00	2004-04-08	581452		0	0	0		0	0	0	129078	0	113	40213227		
64014	5317	19133873	1983-12-22	1983-12-22 00:00:00	1983-12-29	1983-12-29 00:00:00	1983-12-29	38000177		0	0	7		0	0	0	353650	0	834061	19133873		
186966	4106	40213227	2015-10-23	2015-10-23 00:00:00	2015-10-23	2015-10-23 00:00:00	2015-10-23	581452		0	0	0		0	0	0	272857	0	113	40213227		
127284	2799	40213227	2011-06-15	2011-06-15 00:00:00	2011-06-15	2011-06-15 00:00:00	2011-06-15	581452		0	0	0		0	0	0	185497	0	113	40213227		
70983	1553	40213260	2017-03-10	2017-03-10 00:00:00	2017-03-10	2017-03-10 00:00:00	2017-03-10	581452		0	0	0		0	0	0	103990	0	121	40213260		
209870	4602	40213314	1978-07-17	1978-07-17 00:00:00	1978-07-17	1978-07-17 00:00:00	1978-07-17	581452		0	0	0		0	0	0	306546	0	49	40213314		
193300	4246	40213227	1998-05-20	1998-05-20 00:00:00	1998-05-20	1998-05-20 00:00:00	1998-05-20	581452		0	0	0		0	0	0	281982	0	113	40213227		
416	32	1127433	1966-02-08	1966-02-08 00:00:00	1966-02-22	1966-02-22 00:00:00	1966-02-22	38000177		0	0	14		0	0	0	2243	0	313782	1127433		
164421	3616	40213227	2000-03-07	2000-03-07 00:00:00	2000-03-07	2000-03-07 00:00:00	2000-03-07	581452		0	0	0		0	0	0	240257	0	113	40213227		
61799	5142	1545959	2012-04-03	2012-04-03 00:00:00	2012-04-03	2012-04-03 00:00:00	2012-04-03	38000177		0	0	0		0	0	0	341697	0	259255	1545959		
91086	1999	40213227	2008-12-26	2008-12-26 00:00:00	2008-12-26	2008-12-26 00:00:00	2008-12-26	581452		0	0	0		0	0	0	133084	0	113	40213227		
185506	4077	40213160	1971-07-12	1971-07-12 00:00:00	1971-07-12	1971-07-12 00:00:00	1971-07-12	581452		0	0	0		0	0	0	270902	0	10	40213160		
161218	3547	40213227	1992-09-14	1992-09-14 00:00:00	1992-09-14	1992-09-14 00:00:00	1992-09-14	581452		0	0	0		0	0	0	235603	0	113	40213227		
174297	3832	40213314	1984-04-19	1984-04-19 00:00:00	1984-04-19	1984-04-19 00:00:00	1984-04-19	581452		0	0	0		0	0	0	254475	0	49	40213314		
200078	4394	40213227	1992-06-29	1992-06-29 00:00:00	1992-06-29	1992-06-29 00:00:00	1992-06-29	581452		0	0	0		0	0	0	292164	0	113	40213227		
19598	1612	1127433	1982-01-19	1982-01-19 00:00:00	1982-02-02	1982-02-02 00:00:00	1982-02-02	38000177		0	0	14		0	0	0	108359	0	313782	1127433		
196229	4312	40213227	2001-11-07	2001-11-07 00:00:00	2001-11-07	2001-11-07 00:00:00	2001-11-07	581452		0	0	0		0	0	0	286102	0	113	40213227		
196275	4313	40213201	2014-06-07	2014-06-07 00:00:00	2014-06-07	2014-06-07 00:00:00	2014-06-07	581452		0	0	0		0	0	0	286237	0	33	40213201		
174821	3844	40213160	1955-08-05	1955-08-05 00:00:00	1955-08-05	1955-08-05 00:00:00	1955-08-05	581452		0	0	0		0	0	0	255148	0	10	40213160		
144378	3174	40213314	1981-03-20	1981-03-20 00:00:00	1981-03-20	1981-03-20 00:00:00	1981-03-20	581452		0	0	0		0	0	0	210968	0	49	40213314		
24742	2034	1539411	2004-11-10	2004-11-10 00:00:00	2004-11-10	2004-11-10 00:00:00	\N	38000177		0	0	0		0	0	0	135499	0	312961	1539411		
162145	3566	40213201	2017-09-04	2017-09-04 00:00:00	2017-09-04	2017-09-04 00:00:00	2017-09-04	581452		0	0	0		0	0	0	236881	0	33	40213201		
45613	3776	19078461	2010-11-20	2010-11-20 00:00:00	2011-01-26	2011-01-26 00:00:00	2011-01-26	38000177		0	0	67		0	0	0	250981	0	310965	19078461		
88508	1941	40213314	1977-01-20	1977-01-20 00:00:00	1977-01-20	1977-01-20 00:00:00	1977-01-20	581452		0	0	0		0	0	0	129096	0	49	40213314		
64015	5317	1127433	1976-03-08	1976-03-08 00:00:00	1976-03-22	1976-03-22 00:00:00	1976-03-22	38000177		0	0	14		0	0	0	353656	0	313782	1127433		
186975	4107	40213296	2012-01-09	2012-01-09 00:00:00	2012-01-09	2012-01-09 00:00:00	2012-01-09	581452		0	0	0		0	0	0	272927	0	52	40213296		
127293	2799	40213227	2002-06-05	2002-06-05 00:00:00	2002-06-05	2002-06-05 00:00:00	2002-06-05	581452		0	0	0		0	0	0	185494	0	113	40213227		
70985	1553	40213227	2018-03-16	2018-03-16 00:00:00	2018-03-16	2018-03-16 00:00:00	2018-03-16	581452		0	0	0		0	0	0	103946	0	113	40213227		
179279	3941	40213306	1985-09-17	1985-09-17 00:00:00	1985-09-17	1985-09-17 00:00:00	1985-09-17	581452		0	0	0		0	0	0	262052	0	43	40213306		
193301	4246	40213160	1967-05-10	1967-05-10 00:00:00	1967-05-10	1967-05-10 00:00:00	1967-05-10	581452		0	0	0		0	0	0	281941	0	10	40213160		
417	32	1127433	1959-04-25	1959-04-25 00:00:00	1959-05-09	1959-05-09 00:00:00	1959-05-09	38000177		0	0	14		0	0	0	2237	0	313782	1127433		
164423	3616	40213160	1958-08-05	1958-08-05 00:00:00	1958-08-05	1958-08-05 00:00:00	1958-08-05	581452		0	0	0		0	0	0	240275	0	10	40213160		
61800	5142	19133768	2012-04-03	2012-04-03 00:00:00	2012-04-03	2012-04-03 00:00:00	2012-04-03	38000177		0	0	0		0	0	0	341697	0	833036	19133768		
91090	1999	40213314	1978-12-01	1978-12-01 00:00:00	1978-12-01	1978-12-01 00:00:00	1978-12-01	581452		0	0	0		0	0	0	133063	0	49	40213314		
185511	4077	40213160	1975-03-31	1975-03-31 00:00:00	1975-03-31	1975-03-31 00:00:00	1975-03-31	581452		0	0	0		0	0	0	\N	0	10	40213160		
161219	3547	40213306	1992-09-14	1992-09-14 00:00:00	1992-09-14	1992-09-14 00:00:00	1992-09-14	581452		0	0	0		0	0	0	235603	0	43	40213306		
174299	3832	40213251	1988-12-22	1988-12-22 00:00:00	1988-12-22	1988-12-22 00:00:00	1988-12-22	581452		0	0	0		0	0	0	254462	0	21	40213251		
200079	4394	40213306	1992-06-29	1992-06-29 00:00:00	1992-06-29	1992-06-29 00:00:00	1992-06-29	581452		0	0	0		0	0	0	292164	0	43	40213306		
19599	1612	19075601	2014-04-16	2014-04-16 00:00:00	2014-04-16	2014-04-16 00:00:00	2014-04-16	38000177		0	0	0		0	0	0	108401	0	309362	19075601		
196231	4312	40213227	1993-04-07	1993-04-07 00:00:00	1993-04-07	1993-04-07 00:00:00	1993-04-07	581452		0	0	0		0	0	0	286100	0	113	40213227		
196285	4313	40213227	1998-07-25	1998-07-25 00:00:00	1998-07-25	1998-07-25 00:00:00	1998-07-25	581452		0	0	0		0	0	0	286233	0	113	40213227		
174827	3844	40213227	2013-11-01	2013-11-01 00:00:00	2013-11-01	2013-11-01 00:00:00	2013-11-01	581452		0	0	0		0	0	0	255208	0	113	40213227		
144383	3174	40213227	2012-02-10	2012-02-10 00:00:00	2012-02-10	2012-02-10 00:00:00	2012-02-10	581452		0	0	0		0	0	0	210998	0	113	40213227		
24743	2034	19075601	2004-11-10	2004-11-10 00:00:00	2018-01-17	2018-01-17 00:00:00	2018-01-17	38000177		0	0	4816		0	0	0	135499	0	309362	19075601		
162153	3566	40213227	2012-09-17	2012-09-17 00:00:00	2012-09-17	2012-09-17 00:00:00	2012-09-17	581452		0	0	0		0	0	0	236839	0	113	40213227		
45614	3776	1127433	1991-12-25	1991-12-25 00:00:00	1992-01-15	1992-01-15 00:00:00	1992-01-15	38000177		0	0	21		0	0	0	250979	0	313782	1127433		
88513	1941	40213296	2013-02-21	2013-02-21 00:00:00	2013-02-21	2013-02-21 00:00:00	2013-02-21	581452		0	0	0		0	0	0	129062	0	52	40213296		
64016	5317	1127433	1973-11-03	1973-11-03 00:00:00	1973-11-17	1973-11-17 00:00:00	1973-11-17	38000177		0	0	14		0	0	0	353647	0	313782	1127433		
186982	4107	40213306	1995-01-30	1995-01-30 00:00:00	1995-01-30	1995-01-30 00:00:00	1995-01-30	581452		0	0	0		0	0	0	272920	0	43	40213306		
127294	2799	40213306	2002-06-05	2002-06-05 00:00:00	2002-06-05	2002-06-05 00:00:00	2002-06-05	581452		0	0	0		0	0	0	185494	0	43	40213306		
70986	1553	40213260	2018-03-16	2018-03-16 00:00:00	2018-03-16	2018-03-16 00:00:00	2018-03-16	581452		0	0	0		0	0	0	103946	0	121	40213260		
179286	3942	40213227	2009-07-02	2009-07-02 00:00:00	2009-07-02	2009-07-02 00:00:00	2009-07-02	581452		0	0	0		0	0	0	262073	0	113	40213227		
193308	4246	40213296	2007-08-29	2007-08-29 00:00:00	2007-08-29	2007-08-29 00:00:00	2007-08-29	581452		0	0	0		0	0	0	281932	0	52	40213296		
418	32	19059056	1955-04-27	1955-04-27 00:00:00	1955-05-25	1955-05-25 00:00:00	1955-05-25	38000177		0	0	28		0	0	0	2235	0	243670	19059056		
164425	3616	40213260	2008-02-26	2008-02-26 00:00:00	2008-02-26	2008-02-26 00:00:00	2008-02-26	581452		0	0	0		0	0	0	240289	0	121	40213260		
61801	5142	19059056	1970-09-04	1970-09-04 00:00:00	1970-09-18	1970-09-18 00:00:00	1970-09-18	38000177		0	0	14		0	0	0	341694	0	243670	19059056		
91097	1999	40213227	1999-12-17	1999-12-17 00:00:00	1999-12-17	1999-12-17 00:00:00	1999-12-17	581452		0	0	0		0	0	0	133081	0	113	40213227		
185515	4077	40213160	1971-05-10	1971-05-10 00:00:00	1971-05-10	1971-05-10 00:00:00	1971-05-10	581452		0	0	0		0	0	0	270917	0	10	40213160		
161220	3547	40213160	1970-12-21	1970-12-21 00:00:00	1970-12-21	1970-12-21 00:00:00	1970-12-21	581452		0	0	0		0	0	0	235597	0	10	40213160		
174301	3832	40213160	1988-12-22	1988-12-22 00:00:00	1988-12-22	1988-12-22 00:00:00	1988-12-22	581452		0	0	0		0	0	0	254462	0	10	40213160		
200087	4394	40213227	2001-07-09	2001-07-09 00:00:00	2001-07-09	2001-07-09 00:00:00	2001-07-09	581452		0	0	0		0	0	0	292182	0	113	40213227		
19600	1612	40220960	2014-04-16	2014-04-16 00:00:00	2014-04-16	2014-04-16 00:00:00	2014-04-16	38000177		0	0	0		0	0	0	108401	0	1804799	40220960		
196233	4312	40213160	1960-02-24	1960-02-24 00:00:00	1960-02-24	1960-02-24 00:00:00	1960-02-24	581452		0	0	0		0	0	0	286062	0	10	40213160		
77429	1692	40213227	2018-08-27	2018-08-27 00:00:00	2018-08-27	2018-08-27 00:00:00	2018-08-27	581452		0	0	0		0	0	0	113370	0	113	40213227		
174828	3844	40213198	2017-11-24	2017-11-24 00:00:00	2017-11-24	2017-11-24 00:00:00	2017-11-24	581452		0	0	0		0	0	0	255183	0	133	40213198		
144386	3174	40213227	2003-01-31	2003-01-31 00:00:00	2003-01-31	2003-01-31 00:00:00	2003-01-31	581452		0	0	0		0	0	0	210995	0	113	40213227		
24744	2034	1332419	2004-11-10	2004-11-10 00:00:00	2004-11-10	2004-11-10 00:00:00	\N	38000177		0	0	0		0	0	0	135499	0	197361	1332419		
162162	3566	40213160	1956-07-02	1956-07-02 00:00:00	1956-07-02	1956-07-02 00:00:00	1956-07-02	581452		0	0	0		0	0	0	236856	0	10	40213160		
45615	3776	1127433	2006-10-08	2006-10-08 00:00:00	2006-10-15	2006-10-15 00:00:00	2006-10-15	38000177		0	0	7		0	0	0	250984	0	313782	1127433		
140979	3096	40213160	1964-05-31	1964-05-31 00:00:00	1964-05-31	1964-05-31 00:00:00	1964-05-31	581452		0	0	0		0	0	0	206039	0	10	40213160		
35931	784	40213227	2001-07-21	2001-07-21 00:00:00	2001-07-21	2001-07-21 00:00:00	2001-07-21	581452		0	0	0		0	0	0	52237	0	113	40213227		
186984	4107	40213227	1994-05-23	1994-05-23 00:00:00	1994-05-23	1994-05-23 00:00:00	1994-05-23	581452		0	0	0		0	0	0	272887	0	113	40213227		
129247	2842	40213260	2009-03-26	2009-03-26 00:00:00	2009-03-26	2009-03-26 00:00:00	2009-03-26	581452		0	0	0		0	0	0	188682	0	121	40213260		
70993	1553	40213160	1971-10-15	1971-10-15 00:00:00	1971-10-15	1971-10-15 00:00:00	1971-10-15	581452		0	0	0		0	0	0	103942	0	10	40213160		
179291	3942	40213227	2000-06-22	2000-06-22 00:00:00	2000-06-22	2000-06-22 00:00:00	2000-06-22	581452		0	0	0		0	0	0	262083	0	113	40213227		
193316	4246	40213160	1971-11-17	1971-11-17 00:00:00	1971-11-17	1971-11-17 00:00:00	1971-11-17	581452		0	0	0		0	0	0	281975	0	10	40213160		
419	32	40222846	2007-07-26	2007-07-26 00:00:00	2007-07-26	2007-07-26 00:00:00	\N	38000177		0	0	0		0	0	0	2272	0	996740	40222846		
164438	3616	40213296	1998-03-03	1998-03-03 00:00:00	1998-03-03	1998-03-03 00:00:00	1998-03-03	581452		0	0	0		0	0	0	240287	0	52	40213296		
61802	5142	19126352	2012-12-18	2012-12-18 00:00:00	2012-12-18	2012-12-18 00:00:00	\N	38000177		0	0	0		0	0	0	341787	0	705129	19126352		
91098	1999	40213306	1999-12-17	1999-12-17 00:00:00	1999-12-17	1999-12-17 00:00:00	1999-12-17	581452		0	0	0		0	0	0	133081	0	43	40213306		
185517	4077	40213227	2002-11-25	2002-11-25 00:00:00	2002-11-25	2002-11-25 00:00:00	2002-11-25	581452		0	0	0		0	0	0	270940	0	113	40213227		
161226	3547	40213160	1975-06-23	1975-06-23 00:00:00	1975-06-23	1975-06-23 00:00:00	1975-06-23	581452		0	0	0		0	0	0	235558	0	10	40213160		
174304	3833	40213160	1966-04-06	1966-04-06 00:00:00	1966-04-06	1966-04-06 00:00:00	1966-04-06	581452		0	0	0		0	0	0	254489	0	10	40213160		
200088	4394	40213160	1970-08-10	1970-08-10 00:00:00	1970-08-10	1970-08-10 00:00:00	1970-08-10	581452		0	0	0		0	0	0	292158	0	10	40213160		
19601	1612	19059056	1966-11-11	1966-11-11 00:00:00	1966-11-25	1966-11-25 00:00:00	1966-11-25	38000177		0	0	14		0	0	0	108391	0	243670	19059056		
196238	4312	40213160	1959-12-23	1959-12-23 00:00:00	1959-12-23	1959-12-23 00:00:00	1959-12-23	581452		0	0	0		0	0	0	286113	0	10	40213160		
77430	1692	40213296	2018-08-27	2018-08-27 00:00:00	2018-08-27	2018-08-27 00:00:00	2018-08-27	581452		0	0	0		0	0	0	113370	0	52	40213296		
174834	3844	40213227	2003-09-05	2003-09-05 00:00:00	2003-09-05	2003-09-05 00:00:00	2003-09-05	581452		0	0	0		0	0	0	255172	0	113	40213227		
144387	3174	40213306	2003-01-31	2003-01-31 00:00:00	2003-01-31	2003-01-31 00:00:00	2003-01-31	581452		0	0	0		0	0	0	210995	0	43	40213306		
24745	2034	19126352	2004-11-10	2004-11-10 00:00:00	2004-11-10	2004-11-10 00:00:00	\N	38000177		0	0	0		0	0	0	135499	0	705129	19126352		
162171	3567	40213160	1967-10-05	1967-10-05 00:00:00	1967-10-05	1967-10-05 00:00:00	1967-10-05	581452		0	0	0		0	0	0	236995	0	10	40213160		
45616	3777	1713671	1996-07-27	1996-07-27 00:00:00	1996-11-30	1996-11-30 00:00:00	1996-11-30	38000177		0	0	126		0	0	0	251002	0	562251	1713671		
140980	3096	40213160	1964-08-30	1964-08-30 00:00:00	1964-08-30	1964-08-30 00:00:00	1964-08-30	581452		0	0	0		0	0	0	206082	0	10	40213160		
35932	784	40213296	2001-07-21	2001-07-21 00:00:00	2001-07-21	2001-07-21 00:00:00	2001-07-21	581452		0	0	0		0	0	0	52237	0	52	40213296		
186985	4107	40213306	1994-05-23	1994-05-23 00:00:00	1994-05-23	1994-05-23 00:00:00	1994-05-23	581452		0	0	0		0	0	0	272887	0	43	40213306		
129248	2842	40213160	1959-01-01	1959-01-01 00:00:00	1959-01-01	1959-01-01 00:00:00	1959-01-01	581452		0	0	0		0	0	0	188705	0	10	40213160		
70999	1553	40213227	2009-03-20	2009-03-20 00:00:00	2009-03-20	2009-03-20 00:00:00	2009-03-20	581452		0	0	0		0	0	0	103951	0	113	40213227		
179292	3942	40213306	2000-06-22	2000-06-22 00:00:00	2000-06-22	2000-06-22 00:00:00	2000-06-22	581452		0	0	0		0	0	0	262083	0	43	40213306		
193319	4246	40213227	2018-01-03	2018-01-03 00:00:00	2018-01-03	2018-01-03 00:00:00	2018-01-03	581452		0	0	0		0	0	0	281966	0	113	40213227		
114881	2524	40213227	2000-06-24	2000-06-24 00:00:00	2000-06-24	2000-06-24 00:00:00	2000-06-24	581452		0	0	0		0	0	0	166931	0	113	40213227		
164442	3616	40213160	1958-11-04	1958-11-04 00:00:00	1958-11-04	1958-11-04 00:00:00	1958-11-04	581452		0	0	0		0	0	0	240301	0	10	40213160		
61803	5142	19075601	2012-12-18	2012-12-18 00:00:00	2012-12-18	2012-12-18 00:00:00	\N	38000177		0	0	0		0	0	0	341787	0	309362	19075601		
91101	1999	40213314	1977-12-30	1977-12-30 00:00:00	1977-12-30	1977-12-30 00:00:00	1977-12-30	581452		0	0	0		0	0	0	133044	0	49	40213314		
185523	4077	40213227	2013-07-29	2013-07-29 00:00:00	2013-07-29	2013-07-29 00:00:00	2013-07-29	581452		0	0	0		0	0	0	270946	0	113	40213227		
161236	3547	40213227	2012-07-23	2012-07-23 00:00:00	2012-07-23	2012-07-23 00:00:00	2012-07-23	581452		0	0	0		0	0	0	235579	0	113	40213227		
174307	3833	40213227	2017-04-12	2017-04-12 00:00:00	2017-04-12	2017-04-12 00:00:00	2017-04-12	581452		0	0	0		0	0	0	254549	0	113	40213227		
200094	4394	40213227	2012-03-12	2012-03-12 00:00:00	2012-03-12	2012-03-12 00:00:00	2012-03-12	581452		0	0	0		0	0	0	292189	0	113	40213227		
19602	1612	19129655	1966-11-11	1966-11-11 00:00:00	1966-11-25	1966-11-25 00:00:00	1966-11-25	38000177		0	0	14		0	0	0	108391	0	789980	19129655		
28153	613	40213227	2007-03-16	2007-03-16 00:00:00	2007-03-16	2007-03-16 00:00:00	2007-03-16	581452		0	0	0		0	0	0	40720	0	113	40213227		
77437	1692	40213314	1977-10-24	1977-10-24 00:00:00	1977-10-24	1977-10-24 00:00:00	1977-10-24	581452		0	0	0		0	0	0	113330	0	49	40213314		
174837	3844	40213227	1994-09-09	1994-09-09 00:00:00	1994-09-09	1994-09-09 00:00:00	1994-09-09	581452		0	0	0		0	0	0	255184	0	113	40213227		
144390	3174	40213251	1985-11-22	1985-11-22 00:00:00	1985-11-22	1985-11-22 00:00:00	1985-11-22	581452		0	0	0		0	0	0	210965	0	21	40213251		
24746	2034	19059056	1940-12-14	1940-12-14 00:00:00	1941-02-12	1941-02-12 00:00:00	1941-02-12	38000177		0	0	60		0	0	0	135486	0	243670	19059056		
173452	3814	40213160	1975-03-09	1975-03-09 00:00:00	1975-03-09	1975-03-09 00:00:00	1975-03-09	581452		0	0	0		0	0	0	253393	0	10	40213160		
45617	3777	1127078	1992-04-21	1992-04-21 00:00:00	1992-05-05	1992-05-05 00:00:00	1992-05-05	38000177		0	0	14		0	0	0	251033	0	282464	1127078		
140987	3096	40213306	1986-02-23	1986-02-23 00:00:00	1986-02-23	1986-02-23 00:00:00	1986-02-23	581452		0	0	0		0	0	0	206061	0	43	40213306		
35946	784	40213160	1959-10-10	1959-10-10 00:00:00	1959-10-10	1959-10-10 00:00:00	1959-10-10	581452		0	0	0		0	0	0	52183	0	10	40213160		
186989	4107	40213160	1971-05-17	1971-05-17 00:00:00	1971-05-17	1971-05-17 00:00:00	1971-05-17	581452		0	0	0		0	0	0	272874	0	10	40213160		
129249	2842	40213160	1959-03-05	1959-03-05 00:00:00	1959-03-05	1959-03-05 00:00:00	1959-03-05	581452		0	0	0		0	0	0	188684	0	10	40213160		
71000	1553	40213296	2009-03-20	2009-03-20 00:00:00	2009-03-20	2009-03-20 00:00:00	2009-03-20	581452		0	0	0		0	0	0	103951	0	52	40213296		
179293	3942	40213160	1978-09-28	1978-09-28 00:00:00	1978-09-28	1978-09-28 00:00:00	1978-09-28	581452		0	0	0		0	0	0	262102	0	10	40213160		
204607	4491	40213198	2011-08-07	2011-08-07 00:00:00	2011-08-07	2011-08-07 00:00:00	2011-08-07	581452		0	0	0		0	0	0	298954	0	133	40213198		
114888	2524	40213227	1993-07-03	1993-07-03 00:00:00	1993-07-03	1993-07-03 00:00:00	1993-07-03	581452		0	0	0		0	0	0	166930	0	113	40213227		
164449	3616	40213227	2009-03-03	2009-03-03 00:00:00	2009-03-03	2009-03-03 00:00:00	2009-03-03	581452		0	0	0		0	0	0	240320	0	113	40213227		
61804	5142	19059056	1976-04-19	1976-04-19 00:00:00	1976-05-03	1976-05-03 00:00:00	1976-05-03	38000177		0	0	14		0	0	0	341695	0	243670	19059056		
91102	1999	40213160	1977-12-30	1977-12-30 00:00:00	1977-12-30	1977-12-30 00:00:00	1977-12-30	581452		0	0	0		0	0	0	133044	0	10	40213160		
185524	4077	40213296	2013-07-29	2013-07-29 00:00:00	2013-07-29	2013-07-29 00:00:00	2013-07-29	581452		0	0	0		0	0	0	270946	0	52	40213296		
161237	3547	40213296	2012-07-23	2012-07-23 00:00:00	2012-07-23	2012-07-23 00:00:00	2012-07-23	581452		0	0	0		0	0	0	235579	0	52	40213296		
174308	3833	40213260	2017-04-12	2017-04-12 00:00:00	2017-04-12	2017-04-12 00:00:00	2017-04-12	581452		0	0	0		0	0	0	254549	0	121	40213260		
200095	4394	40213296	2012-03-12	2012-03-12 00:00:00	2012-03-12	2012-03-12 00:00:00	2012-03-12	581452		0	0	0		0	0	0	292189	0	52	40213296		
19603	1612	1713671	1997-02-06	1997-02-06 00:00:00	1997-02-13	1997-02-13 00:00:00	1997-02-13	38000177		0	0	7		0	0	0	108365	0	562251	1713671		
58156	4831	1118084	2002-08-05	2002-08-05 00:00:00	2002-08-05	2002-08-05 00:00:00	\N	38000177		0	0	0		0	0	0	321469	0	00025152531	44923712		
77441	1692	40213227	2007-11-19	2007-11-19 00:00:00	2007-11-19	2007-11-19 00:00:00	2007-11-19	581452		0	0	0		0	0	0	113342	0	113	40213227		
174842	3844	40213260	2006-09-22	2006-09-22 00:00:00	2006-09-22	2006-09-22 00:00:00	2006-09-22	581452		0	0	0		0	0	0	255180	0	121	40213260		
164075	3609	40213160	1975-05-09	1975-05-09 00:00:00	1975-05-09	1975-05-09 00:00:00	1975-05-09	581452		0	0	0		0	0	0	239794	0	10	40213160		
24747	2034	40229134	1996-09-15	1996-09-15 00:00:00	1996-09-29	1996-09-29 00:00:00	1996-09-29	38000177		0	0	14		0	0	0	135464	0	1043400	40229134		
173456	3814	40213306	1998-01-18	1998-01-18 00:00:00	1998-01-18	1998-01-18 00:00:00	1998-01-18	581452		0	0	0		0	0	0	253383	0	43	40213306		
45618	3777	19019979	1990-04-25	1990-04-25 00:00:00	1990-07-01	1990-07-01 00:00:00	1990-07-01	38000177		0	0	67		0	0	0	251032	0	198405	19019979		
140989	3096	40213160	1968-12-01	1968-12-01 00:00:00	1968-12-01	1968-12-01 00:00:00	1968-12-01	581452		0	0	0		0	0	0	206042	0	10	40213160		
35948	784	40213227	2010-10-30	2010-10-30 00:00:00	2010-10-30	2010-10-30 00:00:00	2010-10-30	581452		0	0	0		0	0	0	52195	0	113	40213227		
186991	4107	40213227	2004-02-09	2004-02-09 00:00:00	2004-02-09	2004-02-09 00:00:00	2004-02-09	581452		0	0	0		0	0	0	272923	0	113	40213227		
129252	2842	40213160	1963-09-05	1963-09-05 00:00:00	1963-09-05	1963-09-05 00:00:00	1963-09-05	581452		0	0	0		0	0	0	188658	0	10	40213160		
71003	1553	40213296	2007-03-16	2007-03-16 00:00:00	2007-03-16	2007-03-16 00:00:00	2007-03-16	581452		0	0	0		0	0	0	103988	0	52	40213296		
179294	3942	40213314	1978-09-28	1978-09-28 00:00:00	1978-09-28	1978-09-28 00:00:00	1978-09-28	581452		0	0	0		0	0	0	262102	0	49	40213314		
215629	4729	40213260	2013-02-01	2013-02-01 00:00:00	2013-02-01	2013-02-01 00:00:00	2013-02-01	581452		0	0	0		0	0	0	315117	0	121	40213260		
114893	2524	40213160	1955-06-04	1955-06-04 00:00:00	1955-06-04	1955-06-04 00:00:00	1955-06-04	581452		0	0	0		0	0	0	166883	0	10	40213160		
164450	3616	40213260	2009-03-03	2009-03-03 00:00:00	2009-03-03	2009-03-03 00:00:00	2009-03-03	581452		0	0	0		0	0	0	240320	0	121	40213260		
61805	5142	1127433	2014-06-18	2014-06-18 00:00:00	2014-08-17	2014-08-17 00:00:00	2014-08-17	38000177		0	0	60		0	0	0	341699	0	313782	1127433		
102397	2244	40213227	1995-08-04	1995-08-04 00:00:00	1995-08-04	1995-08-04 00:00:00	1995-08-04	581452		0	0	0		0	0	0	149417	0	113	40213227		
185528	4077	40213227	1993-11-15	1993-11-15 00:00:00	1993-11-15	1993-11-15 00:00:00	1993-11-15	581452		0	0	0		0	0	0	270937	0	113	40213227		
98000	2147	40213227	2003-10-04	2003-10-04 00:00:00	2003-10-04	2003-10-04 00:00:00	2003-10-04	581452		0	0	0		0	0	0	142975	0	113	40213227		
174313	3833	40213227	1997-11-05	1997-11-05 00:00:00	1997-11-05	1997-11-05 00:00:00	1997-11-05	581452		0	0	0		0	0	0	254546	0	113	40213227		
200098	4394	40213160	1970-11-09	1970-11-09 00:00:00	1970-11-09	1970-11-09 00:00:00	1970-11-09	581452		0	0	0		0	0	0	292169	0	10	40213160		
19604	1612	1118084	2003-05-07	2003-05-07 00:00:00	2003-05-07	2003-05-07 00:00:00	\N	38000177		0	0	0		0	0	0	108375	0	00025152531	44923712		
58157	4831	19133873	1973-02-25	1973-02-25 00:00:00	1973-03-06	1973-03-06 00:00:00	1973-03-06	38000177		0	0	9		0	0	0	321429	0	834061	19133873		
91216	2002	40213306	1996-02-15	1996-02-15 00:00:00	1996-02-15	1996-02-15 00:00:00	1996-02-15	581452		0	0	0		0	0	0	133327	0	43	40213306		
174846	3844	40213160	1957-08-09	1957-08-09 00:00:00	1957-08-09	1957-08-09 00:00:00	1957-08-09	581452		0	0	0		0	0	0	255140	0	10	40213160		
164077	3609	40213296	2014-12-05	2014-12-05 00:00:00	2014-12-05	2014-12-05 00:00:00	2014-12-05	581452		0	0	0		0	0	0	239801	0	52	40213296		
24748	2034	40165015	2011-09-02	2011-09-02 00:00:00	2011-09-02	2011-09-02 00:00:00	\N	38000177		0	0	0		0	0	0	135432	0	861467	40165015		
144437	3175	40213296	1996-12-10	1996-12-10 00:00:00	1996-12-10	1996-12-10 00:00:00	1996-12-10	581452		0	0	0		0	0	0	211072	0	52	40213296		
45619	3777	1127433	2000-03-05	2000-03-05 00:00:00	2000-03-12	2000-03-12 00:00:00	2000-03-12	38000177		0	0	7		0	0	0	251025	0	313782	1127433		
140993	3096	40213227	1995-03-05	1995-03-05 00:00:00	1995-03-05	1995-03-05 00:00:00	1995-03-05	581452		0	0	0		0	0	0	206047	0	113	40213227		
35949	784	40213260	2010-10-30	2010-10-30 00:00:00	2010-10-30	2010-10-30 00:00:00	2010-10-30	581452		0	0	0		0	0	0	52195	0	121	40213260		
186995	4107	40213160	1971-07-19	1971-07-19 00:00:00	1971-07-19	1971-07-19 00:00:00	1971-07-19	581452		0	0	0		0	0	0	272912	0	10	40213160		
129254	2842	40213160	1959-06-04	1959-06-04 00:00:00	1959-06-04	1959-06-04 00:00:00	1959-06-04	581452		0	0	0		0	0	0	188706	0	10	40213160		
71008	1553	40213160	1967-08-18	1967-08-18 00:00:00	1967-08-18	1967-08-18 00:00:00	1967-08-18	581452		0	0	0		0	0	0	103957	0	10	40213160		
179297	3942	40213160	1983-03-31	1983-03-31 00:00:00	1983-03-31	1983-03-31 00:00:00	1983-03-31	581452		0	0	0		0	0	0	262091	0	10	40213160		
215633	4729	40213160	1963-10-11	1963-10-11 00:00:00	1963-10-11	1963-10-11 00:00:00	1963-10-11	581452		0	0	0		0	0	0	315094	0	10	40213160		
114908	2525	40213306	1996-03-08	1996-03-08 00:00:00	1996-03-08	1996-03-08 00:00:00	1996-03-08	581452		0	0	0		0	0	0	166959	0	43	40213306		
232656	5113	40213160	1969-11-22	1969-11-22 00:00:00	1969-11-22	1969-11-22 00:00:00	1969-11-22	581452		0	0	0		0	0	0	339720	0	10	40213160		
61806	5142	19126352	1995-09-12	1995-09-12 00:00:00	2012-04-03	2012-04-03 00:00:00	2012-04-03	38000177		0	0	6048		0	0	0	341783	0	705129	19126352		
102403	2244	40213160	1958-07-04	1958-07-04 00:00:00	1958-07-04	1958-07-04 00:00:00	1958-07-04	581452		0	0	0		0	0	0	149434	0	10	40213160		
185529	4077	40213306	1993-11-15	1993-11-15 00:00:00	1993-11-15	1993-11-15 00:00:00	1993-11-15	581452		0	0	0		0	0	0	270937	0	43	40213306		
98002	2147	40213227	2013-11-29	2013-11-29 00:00:00	2013-11-29	2013-11-29 00:00:00	2013-11-29	581452		0	0	0		0	0	0	142968	0	113	40213227		
174316	3833	40213160	1970-07-29	1970-07-29 00:00:00	1970-07-29	1970-07-29 00:00:00	1970-07-29	581452		0	0	0		0	0	0	254492	0	10	40213160		
200106	4395	40213198	2012-04-06	2012-04-06 00:00:00	2012-04-06	2012-04-06 00:00:00	2012-04-06	581452		0	0	0		0	0	0	292278	0	133	40213198		
19605	1613	1127433	1959-12-17	1959-12-17 00:00:00	1959-12-24	1959-12-24 00:00:00	1959-12-24	38000177		0	0	7		0	0	0	108480	0	313782	1127433		
58158	4831	1713671	1981-01-08	1981-01-08 00:00:00	1981-01-15	1981-01-15 00:00:00	1981-01-15	38000177		0	0	7		0	0	0	321477	0	562251	1713671		
91219	2002	40213296	2015-05-07	2015-05-07 00:00:00	2015-05-07	2015-05-07 00:00:00	2015-05-07	581452		0	0	0		0	0	0	133330	0	52	40213296		
139556	3065	40213160	1972-08-17	1972-08-17 00:00:00	1972-08-17	1972-08-17 00:00:00	1972-08-17	581452		0	0	0		0	0	0	204009	0	10	40213160		
164080	3609	40213314	1978-05-05	1978-05-05 00:00:00	1978-05-05	1978-05-05 00:00:00	1978-05-05	581452		0	0	0		0	0	0	239775	0	49	40213314		
24749	2034	40229134	2006-05-19	2006-05-19 00:00:00	2006-05-26	2006-05-26 00:00:00	2006-05-26	38000177		0	0	7		0	0	0	135517	0	1043400	40229134		
144439	3175	40213227	2005-02-15	2005-02-15 00:00:00	2005-02-15	2005-02-15 00:00:00	2005-02-15	581452		0	0	0		0	0	0	211080	0	113	40213227		
45620	3777	1118084	2018-07-02	2018-07-02 00:00:00	2018-07-02	2018-07-02 00:00:00	\N	38000177		0	0	0		0	0	0	251040	0	00025152531	44923712		
141000	3096	40213227	2005-09-18	2005-09-18 00:00:00	2005-09-18	2005-09-18 00:00:00	2005-09-18	581452		0	0	0		0	0	0	206114	0	113	40213227		
35953	784	40213306	1981-10-17	1981-10-17 00:00:00	1981-10-17	1981-10-17 00:00:00	1981-10-17	581452		0	0	0		0	0	0	52235	0	43	40213306		
167225	3676	40213227	2012-11-22	2012-11-22 00:00:00	2012-11-22	2012-11-22 00:00:00	2012-11-22	581452		0	0	0		0	0	0	244541	0	113	40213227		
129259	2843	40213260	2008-10-23	2008-10-23 00:00:00	2008-10-23	2008-10-23 00:00:00	2008-10-23	581452		0	0	0		0	0	0	188773	0	121	40213260		
71011	1553	40213306	1989-12-29	1989-12-29 00:00:00	1989-12-29	1989-12-29 00:00:00	1989-12-29	581452		0	0	0		0	0	0	103945	0	43	40213306		
179301	3942	40213160	1978-07-27	1978-07-27 00:00:00	1978-07-27	1978-07-27 00:00:00	1978-07-27	581452		0	0	0		0	0	0	262079	0	10	40213160		
215638	4729	40213227	1994-06-03	1994-06-03 00:00:00	1994-06-03	1994-06-03 00:00:00	1994-06-03	581452		0	0	0		0	0	0	315078	0	113	40213227		
114910	2525	40213227	1996-03-08	1996-03-08 00:00:00	1996-03-08	1996-03-08 00:00:00	1996-03-08	581452		0	0	0		0	0	0	166959	0	113	40213227		
232661	5113	40213296	2009-03-21	2009-03-21 00:00:00	2009-03-21	2009-03-21 00:00:00	2009-03-21	581452		0	0	0		0	0	0	339700	0	52	40213296		
61807	5142	1539411	1995-09-12	1995-09-12 00:00:00	1995-09-12	1995-09-12 00:00:00	\N	38000177		0	0	0		0	0	0	341783	0	312961	1539411		
174077	3827	40213296	1996-11-29	1996-11-29 00:00:00	1996-11-29	1996-11-29 00:00:00	1996-11-29	581452		0	0	0		0	0	0	254164	0	52	40213296		
29362	640	40213198	2012-08-13	2012-08-13 00:00:00	2012-08-13	2012-08-13 00:00:00	2012-08-13	581452		0	0	0		0	0	0	42401	0	133	40213198		
98009	2147	40213160	1957-09-07	1957-09-07 00:00:00	1957-09-07	1957-09-07 00:00:00	1957-09-07	581452		0	0	0		0	0	0	142957	0	10	40213160		
174319	3833	40213160	1966-07-06	1966-07-06 00:00:00	1966-07-06	1966-07-06 00:00:00	1966-07-06	581452		0	0	0		0	0	0	254502	0	10	40213160		
200110	4395	40213201	2013-04-12	2013-04-12 00:00:00	2013-04-12	2013-04-12 00:00:00	2013-04-12	581452		0	0	0		0	0	0	292209	0	33	40213201		
19606	1613	1127078	1954-10-12	1954-10-12 00:00:00	1954-10-26	1954-10-26 00:00:00	1954-10-26	38000177		0	0	14		0	0	0	108444	0	282464	1127078		
58159	4831	19133873	1966-08-14	1966-08-14 00:00:00	1966-08-27	1966-08-27 00:00:00	1966-08-27	38000177		0	0	13		0	0	0	321428	0	834061	19133873		
91220	2002	40213314	1977-08-18	1977-08-18 00:00:00	1977-08-18	1977-08-18 00:00:00	1977-08-18	581452		0	0	0		0	0	0	133366	0	49	40213314		
139594	3067	40213227	2011-06-14	2011-06-14 00:00:00	2011-06-14	2011-06-14 00:00:00	2011-06-14	581452		0	0	0		0	0	0	204196	0	113	40213227		
164082	3609	40213227	2016-12-09	2016-12-09 00:00:00	2016-12-09	2016-12-09 00:00:00	2016-12-09	581452		0	0	0		0	0	0	239768	0	113	40213227		
24750	2034	40229134	1939-12-22	1939-12-22 00:00:00	1939-12-29	1939-12-29 00:00:00	1939-12-29	38000177		0	0	7		0	0	0	135433	0	1043400	40229134		
155732	3427	40213227	2017-04-12	2017-04-12 00:00:00	2017-04-12	2017-04-12 00:00:00	2017-04-12	581452		0	0	0		0	0	0	227243	0	113	40213227		
45621	3777	19019979	1987-07-10	1987-07-10 00:00:00	1987-07-24	1987-07-24 00:00:00	1987-07-24	38000177		0	0	14		0	0	0	251046	0	198405	19019979		
141001	3096	40213296	2005-09-18	2005-09-18 00:00:00	2005-09-18	2005-09-18 00:00:00	2005-09-18	581452		0	0	0		0	0	0	206114	0	52	40213296		
35958	784	40213260	2009-10-24	2009-10-24 00:00:00	2009-10-24	2009-10-24 00:00:00	2009-10-24	581452		0	0	0		0	0	0	52239	0	121	40213260		
167226	3676	40213296	2012-11-22	2012-11-22 00:00:00	2012-11-22	2012-11-22 00:00:00	2012-11-22	581452		0	0	0		0	0	0	244541	0	52	40213296		
129263	2843	40213160	1958-11-13	1958-11-13 00:00:00	1958-11-13	1958-11-13 00:00:00	1958-11-13	581452		0	0	0		0	0	0	188734	0	10	40213160		
229142	5035	40213227	1992-04-27	1992-04-27 00:00:00	1992-04-27	1992-04-27 00:00:00	1992-04-27	581452		0	0	0		0	0	0	334637	0	113	40213227		
179302	3942	40213314	1978-07-27	1978-07-27 00:00:00	1978-07-27	1978-07-27 00:00:00	1978-07-27	581452		0	0	0		0	0	0	262079	0	49	40213314		
234142	5145	40213160	1960-08-20	1960-08-20 00:00:00	1960-08-20	1960-08-20 00:00:00	1960-08-20	581452		0	0	0		0	0	0	341995	0	10	40213160		
114912	2525	40213314	1977-12-09	1977-12-09 00:00:00	1977-12-09	1977-12-09 00:00:00	1977-12-09	581452		0	0	0		0	0	0	166937	0	49	40213314		
61808	5142	1332419	1995-09-12	1995-09-12 00:00:00	1995-09-12	1995-09-12 00:00:00	\N	38000177		0	0	0		0	0	0	341783	0	197361	1332419		
174087	3827	40213160	1961-08-11	1961-08-11 00:00:00	1961-08-11	1961-08-11 00:00:00	1961-08-11	581452		0	0	0		0	0	0	254200	0	10	40213160		
29371	640	40213201	2013-08-19	2013-08-19 00:00:00	2013-08-19	2013-08-19 00:00:00	2013-08-19	581452		0	0	0		0	0	0	42338	0	33	40213201		
98018	2147	40213198	2017-12-22	2017-12-22 00:00:00	2017-12-22	2017-12-22 00:00:00	2017-12-22	581452		0	0	0		0	0	0	142970	0	133	40213198		
174325	3833	40213306	1988-10-26	1988-10-26 00:00:00	1988-10-26	1988-10-26 00:00:00	1988-10-26	581452		0	0	0		0	0	0	254497	0	43	40213306		
204427	4487	40213160	1955-03-04	1955-03-04 00:00:00	1955-03-04	1955-03-04 00:00:00	1955-03-04	581452		0	0	0		0	0	0	298741	0	10	40213160		
19607	1613	19006318	1954-10-12	1954-10-12 00:00:00	1954-10-26	1954-10-26 00:00:00	1954-10-26	38000177		0	0	14		0	0	0	108444	0	105078	19006318		
58160	4831	1115171	2019-02-16	2019-02-16 00:00:00	2019-03-02	2019-03-02 00:00:00	2019-03-02	38000177		0	0	14		0	0	0	321482	0	849574	1115171		
91228	2002	40213160	1975-11-20	1975-11-20 00:00:00	1975-11-20	1975-11-20 00:00:00	1975-11-20	581452		0	0	0		0	0	0	133337	0	10	40213160		
139598	3067	40213201	2006-11-14	2006-11-14 00:00:00	2006-11-14	2006-11-14 00:00:00	2006-11-14	581452		0	0	0		0	0	0	204203	0	33	40213201		
164083	3609	40213296	2016-12-09	2016-12-09 00:00:00	2016-12-09	2016-12-09 00:00:00	2016-12-09	581452		0	0	0		0	0	0	239768	0	52	40213296		
24751	2034	19133905	2006-06-22	2006-06-22 00:00:00	2006-07-04	2006-07-04 00:00:00	2006-07-04	38000177		0	0	12		0	0	0	135450	0	834102	19133905		
155737	3427	40213260	2016-04-06	2016-04-06 00:00:00	2016-04-06	2016-04-06 00:00:00	2016-04-06	581452		0	0	0		0	0	0	227225	0	121	40213260		
45622	3777	19074843	1987-07-10	1987-07-10 00:00:00	1987-07-24	1987-07-24 00:00:00	1987-07-24	38000177		0	0	14		0	0	0	251046	0	309045	19074843		
141006	3096	40213260	2015-10-18	2015-10-18 00:00:00	2015-10-18	2015-10-18 00:00:00	2015-10-18	581452		0	0	0		0	0	0	206074	0	121	40213260		
35961	784	40213160	1959-08-08	1959-08-08 00:00:00	1959-08-08	1959-08-08 00:00:00	1959-08-08	581452		0	0	0		0	0	0	52223	0	10	40213160		
167228	3676	40213227	2002-07-11	2002-07-11 00:00:00	2002-07-11	2002-07-11 00:00:00	2002-07-11	581452		0	0	0		0	0	0	244522	0	113	40213227		
129269	2843	40213227	2000-01-20	2000-01-20 00:00:00	2000-01-20	2000-01-20 00:00:00	2000-01-20	581452		0	0	0		0	0	0	188753	0	113	40213227		
229149	5035	40213227	2001-06-18	2001-06-18 00:00:00	2001-06-18	2001-06-18 00:00:00	2001-06-18	581452		0	0	0		0	0	0	334600	0	113	40213227		
179317	3942	40213314	1979-06-28	1979-06-28 00:00:00	1979-06-28	1979-06-28 00:00:00	1979-06-28	581452		0	0	0		0	0	0	262103	0	49	40213314		
234148	5145	40213260	2006-06-24	2006-06-24 00:00:00	2006-06-24	2006-06-24 00:00:00	2006-06-24	581452		0	0	0		0	0	0	342022	0	121	40213260		
114915	2525	40213160	1974-06-14	1974-06-14 00:00:00	1974-06-14	1974-06-14 00:00:00	1974-06-14	581452		0	0	0		0	0	0	166981	0	10	40213160		
61809	5142	1127433	1965-07-02	1965-07-02 00:00:00	1965-09-30	1965-09-30 00:00:00	1965-09-30	38000177		0	0	90		0	0	0	341693	0	313782	1127433		
174097	3827	40213296	1998-12-04	1998-12-04 00:00:00	1998-12-04	1998-12-04 00:00:00	1998-12-04	581452		0	0	0		0	0	0	254229	0	52	40213296		
29378	640	40213227	2008-07-21	2008-07-21 00:00:00	2008-07-21	2008-07-21 00:00:00	2008-07-21	581452		0	0	0		0	0	0	42399	0	113	40213227		
98028	2147	40213227	1995-02-17	1995-02-17 00:00:00	1995-02-17	1995-02-17 00:00:00	1995-02-17	581452		0	0	0		0	0	0	142910	0	113	40213227		
110056	2418	40213227	2015-09-15	2015-09-15 00:00:00	2015-09-15	2015-09-15 00:00:00	2015-09-15	581452		0	0	0		0	0	0	160437	0	113	40213227		
204431	4487	40213227	2009-11-20	2009-11-20 00:00:00	2009-11-20	2009-11-20 00:00:00	2009-11-20	581452		0	0	0		0	0	0	298778	0	113	40213227		
19608	1613	19059056	1955-03-23	1955-03-23 00:00:00	1955-04-06	1955-04-06 00:00:00	1955-04-06	38000177		0	0	14		0	0	0	108458	0	243670	19059056		
58161	4831	1127433	2009-10-17	2009-10-17 00:00:00	2009-11-21	2009-11-21 00:00:00	2009-11-21	38000177		0	0	35		0	0	0	321466	0	313782	1127433		
91233	2002	40213160	1980-02-21	1980-02-21 00:00:00	1980-02-21	1980-02-21 00:00:00	1980-02-21	581452		0	0	0		0	0	0	133358	0	10	40213160		
126499	2782	40213201	1986-03-19	1986-03-19 00:00:00	1986-03-19	1986-03-19 00:00:00	1986-03-19	581452		0	0	0		0	0	0	184402	0	33	40213201		
164093	3609	40213160	1979-11-09	1979-11-09 00:00:00	1979-11-09	1979-11-09 00:00:00	1979-11-09	581452		0	0	0		0	0	0	239776	0	10	40213160		
24752	2034	19078461	2006-02-25	2006-02-25 00:00:00	2006-03-25	2006-03-25 00:00:00	2006-03-25	38000177		0	0	28		0	0	0	135429	0	310965	19078461		
155744	3428	40213227	2008-06-04	2008-06-04 00:00:00	2008-06-04	2008-06-04 00:00:00	2008-06-04	581452		0	0	0		0	0	0	227314	0	113	40213227		
45623	3777	1127433	2012-04-09	2012-04-09 00:00:00	2012-04-23	2012-04-23 00:00:00	2012-04-23	38000177		0	0	14		0	0	0	251026	0	313782	1127433		
141008	3096	40213227	2015-10-18	2015-10-18 00:00:00	2015-10-18	2015-10-18 00:00:00	2015-10-18	581452		0	0	0		0	0	0	206074	0	113	40213227		
35969	785	40213296	2003-12-14	2003-12-14 00:00:00	2003-12-14	2003-12-14 00:00:00	2003-12-14	581452		0	0	0		0	0	0	52253	0	52	40213296		
167233	3676	40213227	1993-07-01	1993-07-01 00:00:00	1993-07-01	1993-07-01 00:00:00	1993-07-01	581452		0	0	0		0	0	0	244519	0	113	40213227		
129270	2843	40213296	2000-01-20	2000-01-20 00:00:00	2000-01-20	2000-01-20 00:00:00	2000-01-20	581452		0	0	0		0	0	0	188753	0	52	40213296		
243007	5334	40213160	1964-05-27	1964-05-27 00:00:00	1964-05-27	1964-05-27 00:00:00	1964-05-27	581452		0	0	0		0	0	0	355197	0	10	40213160		
179319	3942	40213160	1978-12-28	1978-12-28 00:00:00	1978-12-28	1978-12-28 00:00:00	1978-12-28	581452		0	0	0		0	0	0	262080	0	10	40213160		
234153	5145	40213296	1997-03-22	1997-03-22 00:00:00	1997-03-22	1997-03-22 00:00:00	1997-03-22	581452		0	0	0		0	0	0	341999	0	52	40213296		
114917	2525	40213314	1977-06-10	1977-06-10 00:00:00	1977-06-10	1977-06-10 00:00:00	1977-06-10	581452		0	0	0		0	0	0	166984	0	49	40213314		
61810	5142	40231925	1965-07-02	1965-07-02 00:00:00	1965-07-02	1965-07-02 00:00:00	\N	38000177		0	0	0		0	0	0	341693	0	1049221	40231925		
174099	3827	40213227	1998-12-04	1998-12-04 00:00:00	1998-12-04	1998-12-04 00:00:00	1998-12-04	581452		0	0	0		0	0	0	254229	0	113	40213227		
29388	640	40213227	2018-09-17	2018-09-17 00:00:00	2018-09-17	2018-09-17 00:00:00	2018-09-17	581452		0	0	0		0	0	0	42419	0	113	40213227		
98029	2147	40213160	1956-03-02	1956-03-02 00:00:00	1956-03-02	1956-03-02 00:00:00	1956-03-02	581452		0	0	0		0	0	0	142956	0	10	40213160		
110057	2418	40213296	2015-09-15	2015-09-15 00:00:00	2015-09-15	2015-09-15 00:00:00	2015-09-15	581452		0	0	0		0	0	0	160437	0	52	40213296		
231806	5094	40213160	1983-04-11	1983-04-11 00:00:00	1983-04-11	1983-04-11 00:00:00	1983-04-11	581452		0	0	0		0	0	0	338483	0	10	40213160		
19609	1613	19006318	1955-03-23	1955-03-23 00:00:00	1955-04-06	1955-04-06 00:00:00	1955-04-06	38000177		0	0	14		0	0	0	108458	0	105078	19006318		
58162	4831	19059056	1971-04-05	1971-04-05 00:00:00	1971-05-10	1971-05-10 00:00:00	1971-05-10	38000177		0	0	35		0	0	0	321464	0	243670	19059056		
91236	2002	40213227	2008-08-14	2008-08-14 00:00:00	2008-08-14	2008-08-14 00:00:00	2008-08-14	581452		0	0	0		0	0	0	133362	0	113	40213227		
136880	3004	40213160	1955-09-13	1955-09-13 00:00:00	1955-09-13	1955-09-13 00:00:00	1955-09-13	581452		0	0	0		0	0	0	200509	0	10	40213160		
164097	3609	40213314	1977-05-06	1977-05-06 00:00:00	1977-05-06	1977-05-06 00:00:00	1977-05-06	581452		0	0	0		0	0	0	239758	0	49	40213314		
24753	2034	1115171	2016-11-04	2016-11-04 00:00:00	2017-01-03	2017-01-03 00:00:00	2017-01-03	38000177		0	0	60		0	0	0	135431	0	849574	1115171		
155745	3428	40213296	2008-06-04	2008-06-04 00:00:00	2008-06-04	2008-06-04 00:00:00	2008-06-04	581452		0	0	0		0	0	0	227314	0	52	40213296		
45624	3777	19078461	2005-01-27	2005-01-27 00:00:00	2005-02-24	2005-02-24 00:00:00	2005-02-24	38000177		0	0	28		0	0	0	251034	0	310965	19078461		
141010	3096	40213296	2007-09-23	2007-09-23 00:00:00	2007-09-23	2007-09-23 00:00:00	2007-09-23	581452		0	0	0		0	0	0	206048	0	52	40213296		
14346	310	40213201	2016-02-20	2016-02-20 00:00:00	2016-02-20	2016-02-20 00:00:00	2016-02-20	581452		0	0	0		0	0	0	20541	0	33	40213201		
167234	3676	40213306	1993-07-01	1993-07-01 00:00:00	1993-07-01	1993-07-01 00:00:00	1993-07-01	581452		0	0	0		0	0	0	244519	0	43	40213306		
129271	2843	40213160	1959-04-16	1959-04-16 00:00:00	1959-04-16	1959-04-16 00:00:00	1959-04-16	581452		0	0	0		0	0	0	188795	0	10	40213160		
243011	5335	40213260	2009-08-27	2009-08-27 00:00:00	2009-08-27	2009-08-27 00:00:00	2009-08-27	581452		0	0	0		0	0	0	355289	0	121	40213260		
164282	3613	40213160	1976-05-02	1976-05-02 00:00:00	1976-05-02	1976-05-02 00:00:00	1976-05-02	581452		0	0	0		0	0	0	240044	0	10	40213160		
234155	5145	40213227	1997-03-22	1997-03-22 00:00:00	1997-03-22	1997-03-22 00:00:00	1997-03-22	581452		0	0	0		0	0	0	341999	0	113	40213227		
126197	2776	40213227	2017-07-23	2017-07-23 00:00:00	2017-07-23	2017-07-23 00:00:00	2017-07-23	581452		0	0	0		0	0	0	183781	0	113	40213227		
61811	5142	1127433	2013-07-23	2013-07-23 00:00:00	2013-08-22	2013-08-22 00:00:00	2013-08-22	38000177		0	0	30		0	0	0	341698	0	313782	1127433		
174105	3827	40213160	1957-08-02	1957-08-02 00:00:00	1957-08-02	1957-08-02 00:00:00	1957-08-02	581452		0	0	0		0	0	0	254170	0	10	40213160		
29391	640	40213227	1998-05-25	1998-05-25 00:00:00	1998-05-25	1998-05-25 00:00:00	1998-05-25	581452		0	0	0		0	0	0	42333	0	113	40213227		
90206	1980	40213227	2004-05-30	2004-05-30 00:00:00	2004-05-30	2004-05-30 00:00:00	2004-05-30	581452		0	0	0		0	0	0	131776	0	113	40213227		
110061	2418	40213160	1973-12-11	1973-12-11 00:00:00	1973-12-11	1973-12-11 00:00:00	1973-12-11	581452		0	0	0		0	0	0	160432	0	10	40213160		
231807	5094	40213314	1978-10-09	1978-10-09 00:00:00	1978-10-09	1978-10-09 00:00:00	1978-10-09	581452		0	0	0		0	0	0	338450	0	49	40213314		
19610	1613	1127433	1961-01-27	1961-01-27 00:00:00	1961-02-03	1961-02-03 00:00:00	1961-02-03	38000177		0	0	7		0	0	0	108467	0	313782	1127433		
58163	4831	40229134	2015-01-15	2015-01-15 00:00:00	2015-01-22	2015-01-22 00:00:00	2015-01-22	38000177		0	0	7		0	0	0	321431	0	1043400	40229134		
91237	2002	40213160	1975-08-21	1975-08-21 00:00:00	1975-08-21	1975-08-21 00:00:00	1975-08-21	581452		0	0	0		0	0	0	133348	0	10	40213160		
136887	3004	40213227	2001-10-09	2001-10-09 00:00:00	2001-10-09	2001-10-09 00:00:00	2001-10-09	581452		0	0	0		0	0	0	200438	0	113	40213227		
164117	3610	40213227	1995-05-13	1995-05-13 00:00:00	1995-05-13	1995-05-13 00:00:00	1995-05-13	581452		0	0	0		0	0	0	239804	0	113	40213227		
24754	2034	40220960	2018-01-17	2018-01-17 00:00:00	2018-01-17	2018-01-17 00:00:00	2018-01-17	38000177		0	0	0		0	0	0	135443	0	1804799	40220960		
155749	3428	40213296	2006-05-31	2006-05-31 00:00:00	2006-05-31	2006-05-31 00:00:00	2006-05-31	581452		0	0	0		0	0	0	227282	0	52	40213296		
45625	3777	40231925	2005-01-27	2005-01-27 00:00:00	2005-01-27	2005-01-27 00:00:00	\N	38000177		0	0	0		0	0	0	251034	0	1049221	40231925		
141014	3096	40213160	1964-03-29	1964-03-29 00:00:00	1964-03-29	1964-03-29 00:00:00	1964-03-29	581452		0	0	0		0	0	0	206081	0	10	40213160		
14350	310	40213160	1955-01-08	1955-01-08 00:00:00	1955-01-08	1955-01-08 00:00:00	1955-01-08	581452		0	0	0		0	0	0	20514	0	10	40213160		
167263	3678	40213160	1977-02-28	1977-02-28 00:00:00	1977-02-28	1977-02-28 00:00:00	1977-02-28	581452		0	0	0		0	0	0	244611	0	10	40213160		
177024	3890	40213227	1993-10-05	1993-10-05 00:00:00	1993-10-05	1993-10-05 00:00:00	1993-10-05	581452		0	0	0		0	0	0	258584	0	113	40213227		
243013	5335	40213227	2009-08-27	2009-08-27 00:00:00	2009-08-27	2009-08-27 00:00:00	2009-08-27	581452		0	0	0		0	0	0	355289	0	113	40213227		
164285	3613	40213314	1977-01-02	1977-01-02 00:00:00	1977-01-02	1977-01-02 00:00:00	1977-01-02	581452		0	0	0		0	0	0	240025	0	49	40213314		
234156	5145	40213296	1999-03-27	1999-03-27 00:00:00	1999-03-27	1999-03-27 00:00:00	1999-03-27	581452		0	0	0		0	0	0	342055	0	52	40213296		
126200	2776	40213314	1977-06-19	1977-06-19 00:00:00	1977-06-19	1977-06-19 00:00:00	1977-06-19	581452		0	0	0		0	0	0	183798	0	49	40213314		
61812	5143	1127078	1965-04-07	1965-04-07 00:00:00	1965-05-07	1965-05-07 00:00:00	1965-05-07	38000177		0	0	30		0	0	0	341882	0	282464	1127078		
174107	3827	40213260	2006-11-24	2006-11-24 00:00:00	2006-11-24	2006-11-24 00:00:00	2006-11-24	581452		0	0	0		0	0	0	254166	0	121	40213260		
212738	4665	40213314	1982-10-23	1982-10-23 00:00:00	1982-10-23	1982-10-23 00:00:00	1982-10-23	581452		0	0	0		0	0	0	310878	0	49	40213314		
90210	1980	40213296	2016-02-14	2016-02-14 00:00:00	2016-02-14	2016-02-14 00:00:00	2016-02-14	581452		0	0	0		0	0	0	131848	0	52	40213296		
110063	2418	40213227	2005-06-28	2005-06-28 00:00:00	2005-06-28	2005-06-28 00:00:00	2005-06-28	581452		0	0	0		0	0	0	160476	0	113	40213227		
206479	4531	40213227	1995-11-04	1995-11-04 00:00:00	1995-11-04	1995-11-04 00:00:00	1995-11-04	581452		0	0	0		0	0	0	301776	0	113	40213227		
19611	1613	40236824	1994-07-14	1994-07-14 00:00:00	1994-07-28	1994-07-28 00:00:00	1994-07-28	38000177		0	0	14		0	0	0	108484	0	1094107	40236824		
58164	4831	19006318	1964-09-08	1964-09-08 00:00:00	1964-09-22	1964-09-22 00:00:00	1964-09-22	38000177		0	0	14		0	0	0	321450	0	105078	19006318		
91242	2002	40213314	1978-02-16	1978-02-16 00:00:00	1978-02-16	1978-02-16 00:00:00	1978-02-16	581452		0	0	0		0	0	0	133384	0	49	40213314		
243408	5343	40213314	1983-06-12	1983-06-12 00:00:00	1983-06-12	1983-06-12 00:00:00	1983-06-12	581452		0	0	0		0	0	0	355948	0	49	40213314		
155912	3432	40213227	2013-01-11	2013-01-11 00:00:00	2013-01-11	2013-01-11 00:00:00	2013-01-11	581452		0	0	0		0	0	0	227558	0	113	40213227		
24755	2034	1127433	1958-02-13	1958-02-13 00:00:00	1958-02-27	1958-02-27 00:00:00	1958-02-27	38000177		0	0	14		0	0	0	135487	0	313782	1127433		
155755	3428	40213260	2017-05-31	2017-05-31 00:00:00	2017-05-31	2017-05-31 00:00:00	2017-05-31	581452		0	0	0		0	0	0	227299	0	121	40213260		
45626	3777	19075001	2005-01-27	2005-01-27 00:00:00	2005-02-24	2005-02-24 00:00:00	2005-02-24	38000177		0	0	28		0	0	0	251034	0	309097	19075001		
51139	1120	40213160	1958-08-11	1958-08-11 00:00:00	1958-08-11	1958-08-11 00:00:00	1958-08-11	581452		0	0	0		0	0	0	73832	0	10	40213160		
14365	310	40213227	1992-10-31	1992-10-31 00:00:00	1992-10-31	1992-10-31 00:00:00	1992-10-31	581452		0	0	0		0	0	0	20518	0	113	40213227		
167264	3678	40213314	1977-02-28	1977-02-28 00:00:00	1977-02-28	1977-02-28 00:00:00	1977-02-28	581452		0	0	0		0	0	0	244611	0	49	40213314		
177026	3890	40213160	1955-06-28	1955-06-28 00:00:00	1955-06-28	1955-06-28 00:00:00	1955-06-28	581452		0	0	0		0	0	0	258563	0	10	40213160		
243015	5335	40213227	1992-04-23	1992-04-23 00:00:00	1992-04-23	1992-04-23 00:00:00	1992-04-23	581452		0	0	0		0	0	0	355279	0	113	40213227		
164289	3613	40213227	2007-04-08	2007-04-08 00:00:00	2007-04-08	2007-04-08 00:00:00	2007-04-08	581452		0	0	0		0	0	0	240059	0	113	40213227		
234171	5145	40213160	1956-05-19	1956-05-19 00:00:00	1956-05-19	1956-05-19 00:00:00	1956-05-19	581452		0	0	0		0	0	0	342013	0	10	40213160		
126202	2776	40213296	2015-07-19	2015-07-19 00:00:00	2015-07-19	2015-07-19 00:00:00	2015-07-19	581452		0	0	0		0	0	0	183787	0	52	40213296		
61813	5143	1118084	2000-10-20	2000-10-20 00:00:00	2000-10-20	2000-10-20 00:00:00	\N	38000177		0	0	0		0	0	0	341877	0	00025152531	44923712		
233314	5127	40213160	1965-12-17	1965-12-17 00:00:00	1965-12-17	1965-12-17 00:00:00	1965-12-17	581452		0	0	0		0	0	0	340897	0	10	40213160		
212743	4665	40213227	2013-04-13	2013-04-13 00:00:00	2013-04-13	2013-04-13 00:00:00	2013-04-13	581452		0	0	0		0	0	0	310896	0	113	40213227		
90216	1980	40213160	1973-02-18	1973-02-18 00:00:00	1973-02-18	1973-02-18 00:00:00	1973-02-18	581452		0	0	0		0	0	0	131836	0	10	40213160		
110068	2418	40213296	2013-09-10	2013-09-10 00:00:00	2013-09-10	2013-09-10 00:00:00	2013-09-10	581452		0	0	0		0	0	0	160480	0	52	40213296		
206502	4531	40213201	1983-12-17	1983-12-17 00:00:00	1983-12-17	1983-12-17 00:00:00	1983-12-17	581452		0	0	0		0	0	0	301721	0	33	40213201		
19612	1613	920300	1994-07-14	1994-07-14 00:00:00	1994-07-21	1994-07-21 00:00:00	1994-07-21	38000177		0	0	7		0	0	0	108484	0	311989	920300		
58165	4831	19059056	1964-09-08	1964-09-08 00:00:00	1964-09-22	1964-09-22 00:00:00	1964-09-22	38000177		0	0	14		0	0	0	321450	0	243670	19059056		
91245	2002	40213227	2017-05-11	2017-05-11 00:00:00	2017-05-11	2017-05-11 00:00:00	2017-05-11	581452		0	0	0		0	0	0	133371	0	113	40213227		
243409	5343	40213160	1983-06-12	1983-06-12 00:00:00	1983-06-12	1983-06-12 00:00:00	1983-06-12	581452		0	0	0		0	0	0	355948	0	10	40213160		
155916	3432	40213160	1955-04-15	1955-04-15 00:00:00	1955-04-15	1955-04-15 00:00:00	1955-04-15	581452		0	0	0		0	0	0	227537	0	10	40213160		
24756	2034	1127433	1996-09-10	1996-09-10 00:00:00	1996-10-10	1996-10-10 00:00:00	1996-10-10	38000177		0	0	30		0	0	0	135489	0	313782	1127433		
155757	3428	40213227	2017-05-31	2017-05-31 00:00:00	2017-05-31	2017-05-31 00:00:00	2017-05-31	581452		0	0	0		0	0	0	227299	0	113	40213227		
45627	3778	1713671	1997-01-12	1997-01-12 00:00:00	1997-02-02	1997-02-02 00:00:00	1997-02-02	38000177		0	0	21		0	0	0	251058	0	562251	1713671		
51142	1120	40213160	1962-04-16	1962-04-16 00:00:00	1962-04-16	1962-04-16 00:00:00	1962-04-16	581452		0	0	0		0	0	0	73855	0	10	40213160		
53672	4462	920300	1984-03-08	1984-03-08 00:00:00	1984-03-15	1984-03-15 00:00:00	1984-03-15	38000177		0	0	7		0	0	0	296941	0	311989	920300		
169742	3732	40213296	1997-01-26	1997-01-26 00:00:00	1997-01-26	1997-01-26 00:00:00	1997-01-26	581452		0	0	0		0	0	0	247965	0	52	40213296		
177029	3890	40213160	1956-06-26	1956-06-26 00:00:00	1956-06-26	1956-06-26 00:00:00	1956-06-26	581452		0	0	0		0	0	0	258581	0	10	40213160		
243020	5335	40213296	2001-07-12	2001-07-12 00:00:00	2001-07-12	2001-07-12 00:00:00	2001-07-12	581452		0	0	0		0	0	0	355299	0	52	40213296		
164290	3613	40213314	1977-04-03	1977-04-03 00:00:00	1977-04-03	1977-04-03 00:00:00	1977-04-03	581452		0	0	0		0	0	0	240013	0	49	40213314		
234175	5145	40213227	2017-08-26	2017-08-26 00:00:00	2017-08-26	2017-08-26 00:00:00	2017-08-26	581452		0	0	0		0	0	0	342066	0	113	40213227		
169029	3717	40213227	2007-06-09	2007-06-09 00:00:00	2007-06-09	2007-06-09 00:00:00	2007-06-09	581452		0	0	0		0	0	0	247071	0	113	40213227		
61814	5143	1127433	1976-10-06	1976-10-06 00:00:00	1976-10-27	1976-10-27 00:00:00	1976-10-27	38000177		0	0	21		0	0	0	341883	0	313782	1127433		
233321	5127	40213227	1999-01-29	1999-01-29 00:00:00	1999-01-29	1999-01-29 00:00:00	1999-01-29	581452		0	0	0		0	0	0	340872	0	113	40213227		
212746	4665	40213251	1984-01-21	1984-01-21 00:00:00	1984-01-21	1984-01-21 00:00:00	1984-01-21	581452		0	0	0		0	0	0	310868	0	21	40213251		
176425	3879	40213227	2001-02-15	2001-02-15 00:00:00	2001-02-15	2001-02-15 00:00:00	2001-02-15	581452		0	0	0		0	0	0	257703	0	113	40213227		
110073	2418	40213314	1977-02-08	1977-02-08 00:00:00	1977-02-08	1977-02-08 00:00:00	1977-02-08	581452		0	0	0		0	0	0	160428	0	49	40213314		
206508	4531	40213227	2005-12-31	2005-12-31 00:00:00	2005-12-31	2005-12-31 00:00:00	2005-12-31	581452		0	0	0		0	0	0	301825	0	113	40213227		
19613	1613	1118084	1992-06-19	1992-06-19 00:00:00	1992-06-19	1992-06-19 00:00:00	\N	38000177		0	0	0		0	0	0	108478	0	00025152531	44923712		
58166	4831	19133905	1980-07-31	1980-07-31 00:00:00	1980-08-09	1980-08-09 00:00:00	1980-08-09	38000177		0	0	9		0	0	0	321419	0	834102	19133905		
91246	2002	40213296	2017-05-11	2017-05-11 00:00:00	2017-05-11	2017-05-11 00:00:00	2017-05-11	581452		0	0	0		0	0	0	133371	0	52	40213296		
46025	1004	40213160	1963-03-21	1963-03-21 00:00:00	1963-03-21	1963-03-21 00:00:00	1963-03-21	581452		0	0	0		0	0	0	66387	0	10	40213160		
155918	3432	40213227	1993-11-19	1993-11-19 00:00:00	1993-11-19	1993-11-19 00:00:00	1993-11-19	581452		0	0	0		0	0	0	227517	0	113	40213227		
24757	2034	1118084	1963-09-25	1963-09-25 00:00:00	1963-09-25	1963-09-25 00:00:00	\N	38000177		0	0	0		0	0	0	135458	0	00025152531	44923712		
155758	3428	40213160	1966-11-02	1966-11-02 00:00:00	1966-11-02	1966-11-02 00:00:00	1966-11-02	581452		0	0	0		0	0	0	227305	0	10	40213160		
45628	3778	1127433	2003-01-15	2003-01-15 00:00:00	2003-01-22	2003-01-22 00:00:00	2003-01-22	38000177		0	0	7		0	0	0	251061	0	313782	1127433		
51146	1120	40213160	1958-05-12	1958-05-12 00:00:00	1958-05-12	1958-05-12 00:00:00	1958-05-12	581452		0	0	0		0	0	0	73792	0	10	40213160		
53673	4462	40236824	1984-03-08	1984-03-08 00:00:00	1984-03-15	1984-03-15 00:00:00	1984-03-15	38000177		0	0	7		0	0	0	296941	0	1094107	40236824		
169744	3732	40213227	1997-01-26	1997-01-26 00:00:00	1997-01-26	1997-01-26 00:00:00	1997-01-26	581452		0	0	0		0	0	0	247965	0	113	40213227		
177031	3890	40213227	2003-11-04	2003-11-04 00:00:00	2003-11-04	2003-11-04 00:00:00	2003-11-04	581452		0	0	0		0	0	0	258624	0	113	40213227		
243022	5335	40213227	2000-05-04	2000-05-04 00:00:00	2000-05-04	2000-05-04 00:00:00	2000-05-04	581452		0	0	0		0	0	0	355282	0	113	40213227		
164292	3613	40213160	1976-07-04	1976-07-04 00:00:00	1976-07-04	1976-07-04 00:00:00	1976-07-04	581452		0	0	0		0	0	0	240049	0	10	40213160		
234177	5145	40213160	1956-02-18	1956-02-18 00:00:00	1956-02-18	1956-02-18 00:00:00	1956-02-18	581452		0	0	0		0	0	0	342009	0	10	40213160		
169031	3717	40213160	1981-04-18	1981-04-18 00:00:00	1981-04-18	1981-04-18 00:00:00	1981-04-18	581452		0	0	0		0	0	0	247057	0	10	40213160		
61815	5143	40229134	1968-04-20	1968-04-20 00:00:00	1968-05-04	1968-05-04 00:00:00	1968-05-04	38000177		0	0	14		0	0	0	341852	0	1043400	40229134		
233322	5127	40213160	1966-02-18	1966-02-18 00:00:00	1966-02-18	1966-02-18 00:00:00	1966-02-18	581452		0	0	0		0	0	0	340893	0	10	40213160		
212751	4665	40213314	1982-01-23	1982-01-23 00:00:00	1982-01-23	1982-01-23 00:00:00	1982-01-23	581452		0	0	0		0	0	0	310877	0	49	40213314		
176427	3879	40213201	2006-03-16	2006-03-16 00:00:00	2006-03-16	2006-03-16 00:00:00	2006-03-16	581452		0	0	0		0	0	0	257685	0	33	40213201		
110077	2418	40213160	1978-08-15	1978-08-15 00:00:00	1978-08-15	1978-08-15 00:00:00	1978-08-15	581452		0	0	0		0	0	0	160452	0	10	40213160		
123895	2724	40213296	1997-05-04	1997-05-04 00:00:00	1997-05-04	1997-05-04 00:00:00	1997-05-04	581452		0	0	0		0	0	0	180510	0	52	40213296		
19614	1613	19128065	1974-04-10	1974-04-10 00:00:00	1975-04-05	1975-04-05 00:00:00	1975-04-05	38000177		0	0	360		0	0	0	108446	0	749882	19128065		
58167	4831	40229134	1991-12-18	1991-12-18 00:00:00	1992-01-01	1992-01-01 00:00:00	1992-01-01	38000177		0	0	14		0	0	0	321435	0	1043400	40229134		
91249	2002	40213160	1975-06-19	1975-06-19 00:00:00	1975-06-19	1975-06-19 00:00:00	1975-06-19	581452		0	0	0		0	0	0	133336	0	10	40213160		
46041	1004	40213160	1963-01-17	1963-01-17 00:00:00	1963-01-17	1963-01-17 00:00:00	1963-01-17	581452		0	0	0		0	0	0	66361	0	10	40213160		
155928	3432	40213227	2002-11-15	2002-11-15 00:00:00	2002-11-15	2002-11-15 00:00:00	2002-11-15	581452		0	0	0		0	0	0	227542	0	113	40213227		
24758	2034	1127433	1995-07-14	1995-07-14 00:00:00	1995-07-21	1995-07-21 00:00:00	1995-07-21	38000177		0	0	7		0	0	0	135413	0	313782	1127433		
46605	3859	19059056	1923-05-14	1923-05-14 00:00:00	1923-05-28	1923-05-28 00:00:00	1923-05-28	38000177		0	0	14		0	0	0	256178	0	243670	19059056		
45629	3778	1118084	2000-01-14	2000-01-14 00:00:00	2000-01-14	2000-01-14 00:00:00	\N	38000177		0	0	0		0	0	0	251060	0	00025152531	44923712		
51149	1120	40213160	1958-03-10	1958-03-10 00:00:00	1958-03-10	1958-03-10 00:00:00	1958-03-10	581452		0	0	0		0	0	0	73852	0	10	40213160		
53674	4462	1118084	1990-09-12	1990-09-12 00:00:00	1990-09-12	1990-09-12 00:00:00	\N	38000177		0	0	0		0	0	0	\N	0	00025152531	44923712		
169754	3732	40213260	2006-02-19	2006-02-19 00:00:00	2006-02-19	2006-02-19 00:00:00	2006-02-19	581452		0	0	0		0	0	0	247976	0	121	40213260		
135144	2966	40213227	2003-11-22	2003-11-22 00:00:00	2003-11-22	2003-11-22 00:00:00	2003-11-22	581452		0	0	0		0	0	0	198075	0	113	40213227		
243023	5335	40213296	2000-05-04	2000-05-04 00:00:00	2000-05-04	2000-05-04 00:00:00	2000-05-04	581452		0	0	0		0	0	0	355282	0	52	40213296		
164296	3613	40213227	1998-03-29	1998-03-29 00:00:00	1998-03-29	1998-03-29 00:00:00	1998-03-29	581452		0	0	0		0	0	0	240056	0	113	40213227		
234179	5145	40213160	1955-12-17	1955-12-17 00:00:00	1955-12-17	1955-12-17 00:00:00	1955-12-17	581452		0	0	0		0	0	0	342012	0	10	40213160		
169033	3717	40213160	1976-10-16	1976-10-16 00:00:00	1976-10-16	1976-10-16 00:00:00	1976-10-16	581452		0	0	0		0	0	0	247054	0	10	40213160		
61816	5143	1127433	1982-03-01	1982-03-01 00:00:00	1982-03-15	1982-03-15 00:00:00	1982-03-15	38000177		0	0	14		0	0	0	341795	0	313782	1127433		
233324	5127	40213306	1988-03-04	1988-03-04 00:00:00	1988-03-04	1988-03-04 00:00:00	1988-03-04	581452		0	0	0		0	0	0	340902	0	43	40213306		
212752	4665	40213160	1982-01-23	1982-01-23 00:00:00	1982-01-23	1982-01-23 00:00:00	1982-01-23	581452		0	0	0		0	0	0	310877	0	10	40213160		
110482	2427	40213227	2013-10-22	2013-10-22 00:00:00	2013-10-22	2013-10-22 00:00:00	2013-10-22	581452		0	0	0		0	0	0	160998	0	113	40213227		
110079	2418	40213314	1977-08-09	1977-08-09 00:00:00	1977-08-09	1977-08-09 00:00:00	1977-08-09	581452		0	0	0		0	0	0	160434	0	49	40213314		
123903	2724	40213160	1955-01-30	1955-01-30 00:00:00	1955-01-30	1955-01-30 00:00:00	1955-01-30	581452		0	0	0		0	0	0	180467	0	10	40213160		
19615	1613	19059056	1958-01-07	1958-01-07 00:00:00	1958-01-21	1958-01-21 00:00:00	1958-01-21	38000177		0	0	14		0	0	0	108501	0	243670	19059056		
58168	4831	1115171	2015-05-24	2015-05-24 00:00:00	2015-06-07	2015-06-07 00:00:00	2015-06-07	38000177		0	0	14		0	0	0	321481	0	849574	1115171		
91250	2002	40213227	1999-02-18	1999-02-18 00:00:00	1999-02-18	1999-02-18 00:00:00	1999-02-18	581452		0	0	0		0	0	0	133328	0	113	40213227		
46048	1005	40213296	2007-10-02	2007-10-02 00:00:00	2007-10-02	2007-10-02 00:00:00	2007-10-02	581452		0	0	0		0	0	0	66459	0	52	40213296		
134826	2959	40213160	1971-06-01	1971-06-01 00:00:00	1971-06-01	1971-06-01 00:00:00	1971-06-01	581452		0	0	0		0	0	0	197465	0	10	40213160		
24759	2034	1713671	2003-05-03	2003-05-03 00:00:00	2003-05-17	2003-05-17 00:00:00	2003-05-17	38000177		0	0	14		0	0	0	135414	0	562251	1713671		
46606	3859	1127433	1926-12-25	1926-12-25 00:00:00	1927-01-08	1927-01-08 00:00:00	1927-01-08	38000177		0	0	14		0	0	0	256173	0	313782	1127433		
45630	3778	19129655	1965-11-28	1965-11-28 00:00:00	1965-12-12	1965-12-12 00:00:00	1965-12-12	38000177		0	0	14		0	0	0	251082	0	789980	19129655		
51153	1120	40213296	1997-12-08	1997-12-08 00:00:00	1997-12-08	1997-12-08 00:00:00	1997-12-08	581452		0	0	0		0	0	0	73805	0	52	40213296		
53675	4462	1127078	1956-09-09	1956-09-09 00:00:00	1956-09-23	1956-09-23 00:00:00	1956-09-23	38000177		0	0	14		0	0	0	296917	0	282464	1127078		
169757	3732	40213160	1956-03-25	1956-03-25 00:00:00	1956-03-25	1956-03-25 00:00:00	1956-03-25	581452		0	0	0		0	0	0	247959	0	10	40213160		
135145	2966	40213296	2003-11-22	2003-11-22 00:00:00	2003-11-22	2003-11-22 00:00:00	2003-11-22	581452		0	0	0		0	0	0	198075	0	52	40213296		
243026	5335	40213160	1959-01-29	1959-01-29 00:00:00	1959-01-29	1959-01-29 00:00:00	1959-01-29	581452		0	0	0		0	0	0	355306	0	10	40213160		
164297	3613	40213306	1998-03-29	1998-03-29 00:00:00	1998-03-29	1998-03-29 00:00:00	1998-03-29	581452		0	0	0		0	0	0	240056	0	43	40213306		
132594	2913	40213198	2011-06-11	2011-06-11 00:00:00	2011-06-11	2011-06-11 00:00:00	2011-06-11	581452		0	0	0		0	0	0	194090	0	133	40213198		
169035	3717	40213227	1998-05-30	1998-05-30 00:00:00	1998-05-30	1998-05-30 00:00:00	1998-05-30	581452		0	0	0		0	0	0	247062	0	113	40213227		
61817	5143	1127433	1992-04-04	1992-04-04 00:00:00	1992-04-25	1992-04-25 00:00:00	1992-04-25	38000177		0	0	21		0	0	0	341885	0	313782	1127433		
233327	5127	40213306	1989-07-07	1989-07-07 00:00:00	1989-07-07	1989-07-07 00:00:00	1989-07-07	581452		0	0	0		0	0	0	\N	0	43	40213306		
212753	4665	40213160	1982-04-24	1982-04-24 00:00:00	1982-04-24	1982-04-24 00:00:00	1982-04-24	581452		0	0	0		0	0	0	310906	0	10	40213160		
110499	2427	40213201	2008-09-23	2008-09-23 00:00:00	2008-09-23	2008-09-23 00:00:00	2008-09-23	581452		0	0	0		0	0	0	161052	0	33	40213201		
110082	2418	40213160	1974-05-14	1974-05-14 00:00:00	1974-05-14	1974-05-14 00:00:00	1974-05-14	581452		0	0	0		0	0	0	160457	0	10	40213160		
123904	2724	40213160	1955-07-31	1955-07-31 00:00:00	1955-07-31	1955-07-31 00:00:00	1955-07-31	581452		0	0	0		0	0	0	180501	0	10	40213160		
19616	1613	19006318	1958-01-07	1958-01-07 00:00:00	1958-01-21	1958-01-21 00:00:00	1958-01-21	38000177		0	0	14		0	0	0	108501	0	105078	19006318		
58169	4831	19129655	1965-11-25	1965-11-25 00:00:00	1965-12-09	1965-12-09 00:00:00	1965-12-09	38000177		0	0	14		0	0	0	321451	0	789980	19129655		
91251	2002	40213306	1999-02-18	1999-02-18 00:00:00	1999-02-18	1999-02-18 00:00:00	1999-02-18	581452		0	0	0		0	0	0	133328	0	43	40213306		
46050	1005	40213227	1999-09-21	1999-09-21 00:00:00	1999-09-21	1999-09-21 00:00:00	1999-09-21	581452		0	0	0		0	0	0	66458	0	113	40213227		
134830	2959	40213160	1971-08-31	1971-08-31 00:00:00	1971-08-31	1971-08-31 00:00:00	1971-08-31	581452		0	0	0		0	0	0	197504	0	10	40213160		
24760	2034	1115171	2011-08-26	2011-08-26 00:00:00	2011-11-01	2011-11-01 00:00:00	2011-11-01	38000177		0	0	67		0	0	0	135430	0	849574	1115171		
46607	3859	1127433	1954-10-15	1954-10-15 00:00:00	1954-10-22	1954-10-22 00:00:00	1954-10-22	38000177		0	0	7		0	0	0	256206	0	313782	1127433		
45631	3778	1127078	1965-11-28	1965-11-28 00:00:00	1965-12-12	1965-12-12 00:00:00	1965-12-12	38000177		0	0	14		0	0	0	251082	0	282464	1127078		
51156	1120	40213260	2007-12-03	2007-12-03 00:00:00	2007-12-03	2007-12-03 00:00:00	2007-12-03	581452		0	0	0		0	0	0	73807	0	121	40213260		
53676	4462	19006318	1956-09-09	1956-09-09 00:00:00	1956-09-23	1956-09-23 00:00:00	1956-09-23	38000177		0	0	14		0	0	0	296917	0	105078	19006318		
169769	3733	40213227	2007-01-23	2007-01-23 00:00:00	2007-01-23	2007-01-23 00:00:00	2007-01-23	581452		0	0	0		0	0	0	248065	0	113	40213227		
146448	3221	40213306	1986-05-31	1986-05-31 00:00:00	1986-05-31	1986-05-31 00:00:00	1986-05-31	581452		0	0	0		0	0	0	214050	0	43	40213306		
243035	5335	40213260	2008-08-21	2008-08-21 00:00:00	2008-08-21	2008-08-21 00:00:00	2008-08-21	581452		0	0	0		0	0	0	355275	0	121	40213260		
164299	3613	40213314	1977-07-03	1977-07-03 00:00:00	1977-07-03	1977-07-03 00:00:00	1977-07-03	581452		0	0	0		0	0	0	240035	0	49	40213314		
213146	4674	40213260	2018-10-16	2018-10-16 00:00:00	2018-10-16	2018-10-16 00:00:00	2018-10-16	581452		0	0	0		0	0	0	311394	0	121	40213260		
169036	3717	40213306	1998-05-30	1998-05-30 00:00:00	1998-05-30	1998-05-30 00:00:00	1998-05-30	581452		0	0	0		0	0	0	247062	0	43	40213306		
61818	5143	1713671	1986-05-11	1986-05-11 00:00:00	1986-05-18	1986-05-18 00:00:00	1986-05-18	38000177		0	0	7		0	0	0	341813	0	562251	1713671		
233333	5127	40213227	2007-02-09	2007-02-09 00:00:00	2007-02-09	2007-02-09 00:00:00	2007-02-09	581452		0	0	0		0	0	0	340904	0	113	40213227		
212767	4665	40213227	2004-04-03	2004-04-03 00:00:00	2004-04-03	2004-04-03 00:00:00	2004-04-03	581452		0	0	0		0	0	0	310873	0	113	40213227		
110502	2427	40213198	2010-10-05	2010-10-05 00:00:00	2010-10-05	2010-10-05 00:00:00	2010-10-05	581452		0	0	0		0	0	0	161015	0	133	40213198		
121367	2666	40213227	2002-06-30	2002-06-30 00:00:00	2002-06-30	2002-06-30 00:00:00	2002-06-30	581452		0	0	0		0	0	0	176617	0	113	40213227		
123906	2724	40213160	1959-05-03	1959-05-03 00:00:00	1959-05-03	1959-05-03 00:00:00	1959-05-03	581452		0	0	0		0	0	0	180504	0	10	40213160		
19617	1613	19078461	2002-03-04	2002-03-04 00:00:00	2002-03-18	2002-03-18 00:00:00	2002-03-18	38000177		0	0	14		0	0	0	108497	0	310965	19078461		
58170	4831	19059056	1965-11-25	1965-11-25 00:00:00	1965-12-09	1965-12-09 00:00:00	1965-12-09	38000177		0	0	14		0	0	0	321451	0	243670	19059056		
91254	2002	40213314	1977-02-17	1977-02-17 00:00:00	1977-02-17	1977-02-17 00:00:00	1977-02-17	581452		0	0	0		0	0	0	133350	0	49	40213314		
46055	1005	40213160	1967-05-30	1967-05-30 00:00:00	1967-05-30	1967-05-30 00:00:00	1967-05-30	581452		0	0	0		0	0	0	66462	0	10	40213160		
134832	2959	40213227	2002-03-05	2002-03-05 00:00:00	2002-03-05	2002-03-05 00:00:00	2002-03-05	581452		0	0	0		0	0	0	197525	0	113	40213227		
24761	2034	1127433	1999-07-27	1999-07-27 00:00:00	1999-08-31	1999-08-31 00:00:00	1999-08-31	38000177		0	0	35		0	0	0	135490	0	313782	1127433		
46608	3859	19059056	1936-12-01	1936-12-01 00:00:00	1936-12-31	1936-12-31 00:00:00	1936-12-31	38000177		0	0	30		0	0	0	256264	0	243670	19059056		
45632	3778	19078461	2003-12-09	2003-12-09 00:00:00	2003-12-23	2003-12-23 00:00:00	2003-12-23	38000177		0	0	14		0	0	0	251059	0	310965	19078461		
69779	1525	40213160	1964-04-09	1964-04-09 00:00:00	1964-04-09	1964-04-09 00:00:00	1964-04-09	581452		0	0	0		0	0	0	101994	0	10	40213160		
53677	4462	1115171	2006-12-23	2006-12-23 00:00:00	2007-01-20	2007-01-20 00:00:00	2007-01-20	38000177		0	0	28		0	0	0	296901	0	849574	1115171		
169770	3733	40213160	1976-02-17	1976-02-17 00:00:00	1976-02-17	1976-02-17 00:00:00	1976-02-17	581452		0	0	0		0	0	0	248033	0	10	40213160		
146456	3221	40213296	2003-06-21	2003-06-21 00:00:00	2003-06-21	2003-06-21 00:00:00	2003-06-21	581452		0	0	0		0	0	0	214076	0	52	40213296		
243040	5335	40213160	1963-08-01	1963-08-01 00:00:00	1963-08-01	1963-08-01 00:00:00	1963-08-01	581452		0	0	0		0	0	0	355309	0	10	40213160		
164302	3613	40213160	1976-10-03	1976-10-03 00:00:00	1976-10-03	1976-10-03 00:00:00	1976-10-03	581452		0	0	0		0	0	0	240034	0	10	40213160		
213153	4674	40213160	1969-04-29	1969-04-29 00:00:00	1969-04-29	1969-04-29 00:00:00	1969-04-29	581452		0	0	0		0	0	0	311421	0	10	40213160		
169045	3717	40213160	1977-01-15	1977-01-15 00:00:00	1977-01-15	1977-01-15 00:00:00	1977-01-15	581452		0	0	0		0	0	0	246993	0	10	40213160		
61819	5143	1127433	1986-06-25	1986-06-25 00:00:00	1986-07-09	1986-07-09 00:00:00	1986-07-09	38000177		0	0	14		0	0	0	341814	0	313782	1127433		
233334	5127	40213296	2007-02-09	2007-02-09 00:00:00	2007-02-09	2007-02-09 00:00:00	2007-02-09	581452		0	0	0		0	0	0	340904	0	52	40213296		
212768	4665	40213306	2004-04-03	2004-04-03 00:00:00	2004-04-03	2004-04-03 00:00:00	2004-04-03	581452		0	0	0		0	0	0	310873	0	43	40213306		
201994	4435	40213306	1982-03-22	1982-03-22 00:00:00	1982-03-22	1982-03-22 00:00:00	1982-03-22	581452		0	0	0		0	0	0	294766	0	43	40213306		
123876	2724	40213227	2006-02-26	2006-02-26 00:00:00	2006-02-26	2006-02-26 00:00:00	2006-02-26	581452		0	0	0		0	0	0	180538	0	113	40213227		
141120	3098	40213296	1998-09-28	1998-09-28 00:00:00	1998-09-28	1998-09-28 00:00:00	1998-09-28	581452		0	0	0		0	0	0	206177	0	52	40213296		
19618	1613	40229134	1962-07-02	1962-07-02 00:00:00	1962-07-09	1962-07-09 00:00:00	1962-07-09	38000177		0	0	7		0	0	0	108468	0	1043400	40229134		
58178	4834	19059056	1969-02-27	1969-02-27 00:00:00	1969-04-03	1969-04-03 00:00:00	1969-04-03	38000177		0	0	35		0	0	0	321545	0	243670	19059056		
122016	2682	40213227	2005-06-24	2005-06-24 00:00:00	2005-06-24	2005-06-24 00:00:00	2005-06-24	581452		0	0	0		0	0	0	177736	0	113	40213227		
46062	1005	40213260	2018-11-20	2018-11-20 00:00:00	2018-11-20	2018-11-20 00:00:00	2018-11-20	581452		0	0	0		0	0	0	66472	0	121	40213260		
134839	2959	40213160	1971-03-30	1971-03-30 00:00:00	1971-03-30	1971-03-30 00:00:00	1971-03-30	581452		0	0	0		0	0	0	197585	0	10	40213160		
24762	2034	1127433	1954-12-20	1954-12-20 00:00:00	1954-12-27	1954-12-27 00:00:00	1954-12-27	38000177		0	0	7		0	0	0	135447	0	313782	1127433		
46609	3860	1127078	1980-05-27	1980-05-27 00:00:00	1980-07-01	1980-07-01 00:00:00	1980-07-01	38000177		0	0	35		0	0	0	256336	0	282464	1127078		
45633	3778	1713671	1966-04-06	1966-04-06 00:00:00	1966-04-27	1966-04-27 00:00:00	1966-04-27	38000177		0	0	21		0	0	0	251056	0	562251	1713671		
69788	1525	40213160	1964-01-09	1964-01-09 00:00:00	1964-01-09	1964-01-09 00:00:00	1964-01-09	581452		0	0	0		0	0	0	102028	0	10	40213160		
53678	4462	1713671	1965-08-14	1965-08-14 00:00:00	1965-09-04	1965-09-04 00:00:00	1965-09-04	38000177		0	0	21		0	0	0	296932	0	562251	1713671		
169777	3733	40213227	1998-01-13	1998-01-13 00:00:00	1998-01-13	1998-01-13 00:00:00	1998-01-13	581452		0	0	0		0	0	0	248039	0	113	40213227		
64804	1418	40213296	2012-09-03	2012-09-03 00:00:00	2012-09-03	2012-09-03 00:00:00	2012-09-03	581452		0	0	0		0	0	0	94456	0	52	40213296		
220711	4844	40213260	2010-03-04	2010-03-04 00:00:00	2010-03-04	2010-03-04 00:00:00	2010-03-04	581452		0	0	0		0	0	0	322249	0	121	40213260		
164306	3614	40213227	2000-07-02	2000-07-02 00:00:00	2000-07-02	2000-07-02 00:00:00	2000-07-02	581452		0	0	0		0	0	0	240124	0	113	40213227		
224656	4932	40213160	1958-02-20	1958-02-20 00:00:00	1958-02-20	1958-02-20 00:00:00	1958-02-20	581452		0	0	0		0	0	0	327830	0	10	40213160		
169046	3717	40213314	1977-01-15	1977-01-15 00:00:00	1977-01-15	1977-01-15 00:00:00	1977-01-15	581452		0	0	0		0	0	0	246993	0	49	40213314		
61820	5143	1127433	2006-01-01	2006-01-01 00:00:00	2006-01-15	2006-01-15 00:00:00	2006-01-15	38000177		0	0	14		0	0	0	341818	0	313782	1127433		
233335	5127	40213260	2016-03-04	2016-03-04 00:00:00	2016-03-04	2016-03-04 00:00:00	2016-03-04	581452		0	0	0		0	0	0	340885	0	121	40213260		
212772	4665	40213160	1986-07-26	1986-07-26 00:00:00	1986-07-26	1986-07-26 00:00:00	1986-07-26	581452		0	0	0		0	0	0	310912	0	10	40213160		
202000	4435	40213160	1961-04-10	1961-04-10 00:00:00	1961-04-10	1961-04-10 00:00:00	1961-04-10	581452		0	0	0		0	0	0	294808	0	10	40213160		
123877	2724	40213260	2006-02-26	2006-02-26 00:00:00	2006-02-26	2006-02-26 00:00:00	2006-02-26	581452		0	0	0		0	0	0	180538	0	121	40213260		
141127	3100	40213160	1955-12-01	1955-12-01 00:00:00	1955-12-01	1955-12-01 00:00:00	1955-12-01	581452		0	0	0		0	0	0	206262	0	10	40213160		
19619	1613	40229134	1966-03-04	1966-03-04 00:00:00	1966-03-11	1966-03-11 00:00:00	1966-03-11	38000177		0	0	7		0	0	0	108437	0	1043400	40229134		
58179	4834	1115171	2001-06-05	2001-06-05 00:00:00	2001-07-10	2001-07-10 00:00:00	2001-07-10	38000177		0	0	35		0	0	0	321549	0	849574	1115171		
122021	2682	40213227	1996-06-14	1996-06-14 00:00:00	1996-06-14	1996-06-14 00:00:00	1996-06-14	581452		0	0	0		0	0	0	177751	0	113	40213227		
46064	1005	40213227	2018-11-20	2018-11-20 00:00:00	2018-11-20	2018-11-20 00:00:00	2018-11-20	581452		0	0	0		0	0	0	66472	0	113	40213227		
134848	2959	40213306	1993-02-23	1993-02-23 00:00:00	1993-02-23	1993-02-23 00:00:00	1993-02-23	581452		0	0	0		0	0	0	197592	0	43	40213306		
24763	2034	19133905	1991-07-28	1991-07-28 00:00:00	1991-08-09	1991-08-09 00:00:00	1991-08-09	38000177		0	0	12		0	0	0	135462	0	834102	19133905		
46610	3860	19133873	1986-09-04	1986-09-04 00:00:00	1986-09-17	1986-09-17 00:00:00	1986-09-17	38000177		0	0	13		0	0	0	256281	0	834061	19133873		
45634	3779	19133873	1970-07-07	1970-07-07 00:00:00	1970-07-18	1970-07-18 00:00:00	1970-07-18	38000177		0	0	11		0	0	0	251110	0	834061	19133873		
69793	1525	40213296	2003-08-07	2003-08-07 00:00:00	2003-08-07	2003-08-07 00:00:00	2003-08-07	581452		0	0	0		0	0	0	101985	0	52	40213296		
53679	4462	19059056	1955-12-30	1955-12-30 00:00:00	1956-01-13	1956-01-13 00:00:00	1956-01-13	38000177		0	0	14		0	0	0	296896	0	243670	19059056		
169778	3733	40213306	1998-01-13	1998-01-13 00:00:00	1998-01-13	1998-01-13 00:00:00	1998-01-13	581452		0	0	0		0	0	0	248039	0	43	40213306		
64808	1418	40213160	1973-05-07	1973-05-07 00:00:00	1973-05-07	1973-05-07 00:00:00	1973-05-07	581452		0	0	0		0	0	0	94438	0	10	40213160		
220713	4844	40213227	2010-03-04	2010-03-04 00:00:00	2010-03-04	2010-03-04 00:00:00	2010-03-04	581452		0	0	0		0	0	0	322249	0	113	40213227		
164308	3614	40213227	2010-11-14	2010-11-14 00:00:00	2010-11-14	2010-11-14 00:00:00	2010-11-14	581452		0	0	0		0	0	0	\N	0	113	40213227		
224665	4932	40213260	2007-11-15	2007-11-15 00:00:00	2007-11-15	2007-11-15 00:00:00	2007-11-15	581452		0	0	0		0	0	0	327800	0	121	40213260		
169049	3717	40213314	1977-04-16	1977-04-16 00:00:00	1977-04-16	1977-04-16 00:00:00	1977-04-16	581452		0	0	0		0	0	0	247029	0	49	40213314		
233164	5123	40213314	1980-08-04	1980-08-04 00:00:00	1980-08-04	1980-08-04 00:00:00	1980-08-04	581452		0	0	0		0	0	0	340676	0	49	40213314		
188494	4139	40213160	1971-07-16	1971-07-16 00:00:00	1971-07-16	1971-07-16 00:00:00	1971-07-16	581452		0	0	0		0	0	0	275162	0	10	40213160		
212773	4665	40213251	1986-07-26	1986-07-26 00:00:00	1986-07-26	1986-07-26 00:00:00	1986-07-26	581452		0	0	0		0	0	0	310912	0	21	40213251		
202003	4435	40213227	2002-04-15	2002-04-15 00:00:00	2002-04-15	2002-04-15 00:00:00	2002-04-15	581452		0	0	0		0	0	0	294776	0	113	40213227		
123883	2724	40213260	2007-03-04	2007-03-04 00:00:00	2007-03-04	2007-03-04 00:00:00	2007-03-04	581452		0	0	0		0	0	0	180439	0	121	40213260		
141131	3100	40213227	2002-07-25	2002-07-25 00:00:00	2002-07-25	2002-07-25 00:00:00	2002-07-25	581452		0	0	0		0	0	0	206293	0	113	40213227		
19620	1613	920334	1994-07-21	1994-07-21 00:00:00	1994-07-28	1994-07-28 00:00:00	1994-07-28	38000177		0	0	7		0	0	0	108440	0	311995	920334		
58180	4834	40229134	1999-07-10	1999-07-10 00:00:00	1999-07-17	1999-07-17 00:00:00	1999-07-17	38000177		0	0	7		0	0	0	321561	0	1043400	40229134		
122022	2682	40213306	1996-06-14	1996-06-14 00:00:00	1996-06-14	1996-06-14 00:00:00	1996-06-14	581452		0	0	0		0	0	0	177751	0	43	40213306		
46068	1005	40213306	1989-07-25	1989-07-25 00:00:00	1989-07-25	1989-07-25 00:00:00	1989-07-25	581452		0	0	0		0	0	0	66470	0	43	40213306		
134850	2959	40213227	1993-02-23	1993-02-23 00:00:00	1993-02-23	1993-02-23 00:00:00	1993-02-23	581452		0	0	0		0	0	0	197592	0	113	40213227		
114075	2507	40213296	2009-03-17	2009-03-17 00:00:00	2009-03-17	2009-03-17 00:00:00	2009-03-17	581452		0	0	0		0	0	0	165958	0	52	40213296		
46611	3860	1127433	1985-02-05	1985-02-05 00:00:00	1985-03-05	1985-03-05 00:00:00	1985-03-05	38000177		0	0	28		0	0	0	256337	0	313782	1127433		
45636	3779	19019979	1975-02-07	1975-02-07 00:00:00	1975-02-21	1975-02-21 00:00:00	1975-02-21	38000177		0	0	14		0	0	0	251109	0	198405	19019979		
69801	1526	40213160	1972-09-07	1972-09-07 00:00:00	1972-09-07	1972-09-07 00:00:00	1972-09-07	581452		0	0	0		0	0	0	102088	0	10	40213160		
53680	4462	19006318	1955-12-30	1955-12-30 00:00:00	1956-01-13	1956-01-13 00:00:00	1956-01-13	38000177		0	0	14		0	0	0	296896	0	105078	19006318		
169780	3733	40213314	1977-10-18	1977-10-18 00:00:00	1977-10-18	1977-10-18 00:00:00	1977-10-18	581452		0	0	0		0	0	0	248084	0	49	40213314		
64816	1418	40213306	1994-10-31	1994-10-31 00:00:00	1994-10-31	1994-10-31 00:00:00	1994-10-31	581452		0	0	0		0	0	0	94444	0	43	40213306		
220715	4844	40213260	2009-02-26	2009-02-26 00:00:00	2009-02-26	2009-02-26 00:00:00	2009-02-26	581452		0	0	0		0	0	0	322303	0	121	40213260		
37282	814	40213227	2002-09-14	2002-09-14 00:00:00	2002-09-14	2002-09-14 00:00:00	2002-09-14	581452		0	0	0		0	0	0	53963	0	113	40213227		
224673	4932	40213260	2008-11-20	2008-11-20 00:00:00	2008-11-20	2008-11-20 00:00:00	2008-11-20	581452		0	0	0		0	0	0	327841	0	121	40213260		
169051	3717	40213160	1976-08-14	1976-08-14 00:00:00	1976-08-14	1976-08-14 00:00:00	1976-08-14	581452		0	0	0		0	0	0	247005	0	10	40213160		
233169	5123	40213227	2011-05-02	2011-05-02 00:00:00	2011-05-02	2011-05-02 00:00:00	2011-05-02	581452		0	0	0		0	0	0	340682	0	113	40213227		
188499	4139	40213227	2002-01-18	2002-01-18 00:00:00	2002-01-18	2002-01-18 00:00:00	2002-01-18	581452		0	0	0		0	0	0	275149	0	113	40213227		
202004	4435	40213296	2002-04-15	2002-04-15 00:00:00	2002-04-15	2002-04-15 00:00:00	2002-04-15	581452		0	0	0		0	0	0	294776	0	52	40213296		
123894	2724	40213227	1997-05-04	1997-05-04 00:00:00	1997-05-04	1997-05-04 00:00:00	1997-05-04	581452		0	0	0		0	0	0	180510	0	113	40213227		
141132	3100	40213227	1992-06-25	1992-06-25 00:00:00	1992-06-25	1992-06-25 00:00:00	1992-06-25	581452		0	0	0		0	0	0	206291	0	113	40213227		
19621	1613	40236824	1990-06-04	1990-06-04 00:00:00	1990-06-11	1990-06-11 00:00:00	1990-06-11	38000177		0	0	7		0	0	0	108499	0	1094107	40236824		
58181	4834	19129655	1962-06-21	1962-06-21 00:00:00	1962-07-05	1962-07-05 00:00:00	1962-07-05	38000177		0	0	14		0	0	0	321554	0	789980	19129655		
122033	2682	40213314	1977-03-11	1977-03-11 00:00:00	1977-03-11	1977-03-11 00:00:00	1977-03-11	581452		0	0	0		0	0	0	177746	0	49	40213314		
25227	550	40213227	2001-03-14	2001-03-14 00:00:00	2001-03-14	2001-03-14 00:00:00	2001-03-14	581452		0	0	0		0	0	0	36502	0	113	40213227		
134853	2959	40213227	2013-01-01	2013-01-01 00:00:00	2013-01-01	2013-01-01 00:00:00	2013-01-01	581452		0	0	0		0	0	0	197527	0	113	40213227		
114077	2507	40213227	2009-03-17	2009-03-17 00:00:00	2009-03-17	2009-03-17 00:00:00	2009-03-17	581452		0	0	0		0	0	0	165958	0	113	40213227		
46612	3860	1713671	2001-07-26	2001-07-26 00:00:00	2001-08-16	2001-08-16 00:00:00	2001-08-16	38000177		0	0	21		0	0	0	256282	0	562251	1713671		
45637	3779	46233988	1975-02-07	1975-02-07 00:00:00	1975-02-21	1975-02-21 00:00:00	1975-02-21	38000177		0	0	14		0	0	0	251109	0	1652673	46233988		
69803	1526	40213227	1994-03-03	1994-03-03 00:00:00	1994-03-03	1994-03-03 00:00:00	1994-03-03	581452		0	0	0		0	0	0	102073	0	113	40213227		
53681	4462	1127433	1972-06-03	1972-06-03 00:00:00	1972-06-24	1972-06-24 00:00:00	1972-06-24	38000177		0	0	21		0	0	0	296900	0	313782	1127433		
169783	3733	40213296	2015-11-17	2015-11-17 00:00:00	2015-11-17	2015-11-17 00:00:00	2015-11-17	581452		0	0	0		0	0	0	248054	0	52	40213296		
64818	1418	40213227	1994-10-31	1994-10-31 00:00:00	1994-10-31	1994-10-31 00:00:00	1994-10-31	581452		0	0	0		0	0	0	94444	0	113	40213227		
220719	4844	40213227	1993-01-21	1993-01-21 00:00:00	1993-01-21	1993-01-21 00:00:00	1993-01-21	581452		0	0	0		0	0	0	322216	0	113	40213227		
37283	814	40213306	2002-09-14	2002-09-14 00:00:00	2002-09-14	2002-09-14 00:00:00	2002-09-14	581452		0	0	0		0	0	0	53963	0	43	40213306		
224675	4932	40213227	2008-11-20	2008-11-20 00:00:00	2008-11-20	2008-11-20 00:00:00	2008-11-20	581452		0	0	0		0	0	0	327841	0	113	40213227		
169052	3717	40213251	1984-05-05	1984-05-05 00:00:00	1984-05-05	1984-05-05 00:00:00	1984-05-05	581452		0	0	0		0	0	0	246982	0	21	40213251		
233170	5123	40213314	1979-11-05	1979-11-05 00:00:00	1979-11-05	1979-11-05 00:00:00	1979-11-05	581452		0	0	0		0	0	0	340675	0	49	40213314		
188509	4139	40213160	1971-04-16	1971-04-16 00:00:00	1971-04-16	1971-04-16 00:00:00	1971-04-16	581452		0	0	0		0	0	0	275116	0	10	40213160		
202005	4435	40213227	1994-04-04	1994-04-04 00:00:00	1994-04-04	1994-04-04 00:00:00	1994-04-04	581452		0	0	0		0	0	0	294793	0	113	40213227		
141071	3098	40213160	1959-03-02	1959-03-02 00:00:00	1959-03-02	1959-03-02 00:00:00	1959-03-02	581452		0	0	0		0	0	0	206152	0	10	40213160		
141134	3100	40213198	2016-04-14	2016-04-14 00:00:00	2016-04-14	2016-04-14 00:00:00	2016-04-14	581452		0	0	0		0	0	0	206238	0	133	40213198		
19622	1613	920300	1990-06-04	1990-06-04 00:00:00	1990-06-11	1990-06-11 00:00:00	1990-06-11	38000177		0	0	7		0	0	0	108499	0	311989	920300		
58182	4834	1127078	1962-06-21	1962-06-21 00:00:00	1962-07-05	1962-07-05 00:00:00	1962-07-05	38000177		0	0	14		0	0	0	321554	0	282464	1127078		
122036	2682	40213296	2014-12-19	2014-12-19 00:00:00	2014-12-19	2014-12-19 00:00:00	2014-12-19	581452		0	0	0		0	0	0	177723	0	52	40213296		
25235	550	40213201	1986-04-30	1986-04-30 00:00:00	1986-04-30	1986-04-30 00:00:00	1986-04-30	581452		0	0	0		0	0	0	36513	0	33	40213201		
134854	2959	40213296	2013-01-01	2013-01-01 00:00:00	2013-01-01	2013-01-01 00:00:00	2013-01-01	581452		0	0	0		0	0	0	197527	0	52	40213296		
114079	2507	40213260	2018-04-10	2018-04-10 00:00:00	2018-04-10	2018-04-10 00:00:00	2018-04-10	581452		0	0	0		0	0	0	165977	0	121	40213260		
46613	3860	1118084	2007-03-22	2007-03-22 00:00:00	2007-03-22	2007-03-22 00:00:00	\N	38000177		0	0	0		0	0	0	256316	0	00025152531	44923712		
45638	3779	1115171	2012-06-20	2012-06-20 00:00:00	2012-07-18	2012-07-18 00:00:00	2012-07-18	38000177		0	0	28		0	0	0	251148	0	849574	1115171		
69804	1526	40213306	1994-03-03	1994-03-03 00:00:00	1994-03-03	1994-03-03 00:00:00	1994-03-03	581452		0	0	0		0	0	0	102073	0	43	40213306		
53683	4462	40169281	1999-04-01	1999-04-01 00:00:00	1999-04-01	1999-04-01 00:00:00	\N	38000177		0	0	0		0	0	0	296872	0	896209	40169281		
141406	3106	40213198	2016-01-25	2016-01-25 00:00:00	2016-01-25	2016-01-25 00:00:00	2016-01-25	581452		0	0	0		0	0	0	206576	0	133	40213198		
64819	1418	40213160	1972-12-04	1972-12-04 00:00:00	1972-12-04	1972-12-04 00:00:00	1972-12-04	581452		0	0	0		0	0	0	94437	0	10	40213160		
220727	4844	40213160	1959-11-05	1959-11-05 00:00:00	1959-11-05	1959-11-05 00:00:00	1959-11-05	581452		0	0	0		0	0	0	322325	0	10	40213160		
37285	814	40213227	2012-05-05	2012-05-05 00:00:00	2012-05-05	2012-05-05 00:00:00	2012-05-05	581452		0	0	0		0	0	0	53968	0	113	40213227		
224681	4932	40213296	2001-05-03	2001-05-03 00:00:00	2001-05-03	2001-05-03 00:00:00	2001-05-03	581452		0	0	0		0	0	0	327836	0	52	40213296		
169055	3717	40213314	1977-07-09	1977-07-09 00:00:00	1977-07-09	1977-07-09 00:00:00	1977-07-09	581452		0	0	0		0	0	0	246967	0	49	40213314		
233171	5123	40213160	1979-11-05	1979-11-05 00:00:00	1979-11-05	1979-11-05 00:00:00	1979-11-05	581452		0	0	0		0	0	0	340675	0	10	40213160		
188510	4139	40213160	1975-10-17	1975-10-17 00:00:00	1975-10-17	1975-10-17 00:00:00	1975-10-17	581452		0	0	0		0	0	0	275120	0	10	40213160		
202012	4435	40213296	2004-04-19	2004-04-19 00:00:00	2004-04-19	2004-04-19 00:00:00	2004-04-19	581452		0	0	0		0	0	0	294797	0	52	40213296		
141073	3098	40213227	2000-10-02	2000-10-02 00:00:00	2000-10-02	2000-10-02 00:00:00	2000-10-02	581452		0	0	0		0	0	0	206161	0	113	40213227		
141137	3100	40213201	2017-04-20	2017-04-20 00:00:00	2017-04-20	2017-04-20 00:00:00	2017-04-20	581452		0	0	0		0	0	0	206253	0	33	40213201		
19623	1613	1127433	1973-03-30	1973-03-30 00:00:00	1973-04-13	1973-04-13 00:00:00	1973-04-13	38000177		0	0	14		0	0	0	108481	0	313782	1127433		
58183	4834	1713671	1968-11-06	1968-11-06 00:00:00	1968-11-13	1968-11-13 00:00:00	1968-11-13	38000177		0	0	7		0	0	0	321560	0	562251	1713671		
122039	2682	40213160	1973-09-21	1973-09-21 00:00:00	1973-09-21	1973-09-21 00:00:00	1973-09-21	581452		0	0	0		0	0	0	177760	0	10	40213160		
125290	2757	40213160	1973-05-11	1973-05-11 00:00:00	1973-05-11	1973-05-11 00:00:00	1973-05-11	581452		0	0	0		0	0	0	182338	0	10	40213160		
134858	2960	40213227	1997-02-20	1997-02-20 00:00:00	1997-02-20	1997-02-20 00:00:00	1997-02-20	581452		0	0	0		0	0	0	197650	0	113	40213227		
114090	2507	40213227	2019-04-16	2019-04-16 00:00:00	2019-04-16	2019-04-16 00:00:00	2019-04-16	581452		0	0	0		0	0	0	165963	0	113	40213227		
46614	3860	1127433	2014-02-07	2014-02-07 00:00:00	2014-02-14	2014-02-14 00:00:00	2014-02-14	38000177		0	0	7		0	0	0	256283	0	313782	1127433		
45639	3779	1118084	2003-01-16	2003-01-16 00:00:00	2003-01-16	2003-01-16 00:00:00	\N	38000177		0	0	0		0	0	0	251160	0	00025152531	44923712		
69805	1526	40213160	1972-06-08	1972-06-08 00:00:00	1972-06-08	1972-06-08 00:00:00	1972-06-08	581452		0	0	0		0	0	0	102065	0	10	40213160		
53684	4462	19128065	1978-12-09	1978-12-09 00:00:00	1979-12-04	1979-12-04 00:00:00	1979-12-04	38000177		0	0	360		0	0	0	296927	0	749882	19128065		
152696	3362	40213227	2019-01-30	2019-01-30 00:00:00	2019-01-30	2019-01-30 00:00:00	2019-01-30	581452		0	0	0		0	0	0	222870	0	113	40213227		
64821	1418	40213227	2014-09-08	2014-09-08 00:00:00	2014-09-08	2014-09-08 00:00:00	2014-09-08	581452		0	0	0		0	0	0	94408	0	113	40213227		
220734	4844	40213306	1981-08-06	1981-08-06 00:00:00	1981-08-06	1981-08-06 00:00:00	1981-08-06	581452		0	0	0		0	0	0	322243	0	43	40213306		
37287	814	40213314	1980-10-18	1980-10-18 00:00:00	1980-10-18	1980-10-18 00:00:00	1980-10-18	581452		0	0	0		0	0	0	53958	0	49	40213314		
224686	4932	40213160	1962-10-25	1962-10-25 00:00:00	1962-10-25	1962-10-25 00:00:00	1962-10-25	581452		0	0	0		0	0	0	327909	0	10	40213160		
169058	3717	40213296	2016-05-14	2016-05-14 00:00:00	2016-05-14	2016-05-14 00:00:00	2016-05-14	581452		0	0	0		0	0	0	247033	0	52	40213296		
233174	5123	40213296	2019-06-03	2019-06-03 00:00:00	2019-06-03	2019-06-03 00:00:00	2019-06-03	581452		0	0	0		0	0	0	340674	0	52	40213296		
79464	1739	40213227	2010-04-22	2010-04-22 00:00:00	2010-04-22	2010-04-22 00:00:00	2010-04-22	581452		0	0	0		0	0	0	116181	0	113	40213227		
202017	4435	40213260	2012-05-14	2012-05-14 00:00:00	2012-05-14	2012-05-14 00:00:00	2012-05-14	581452		0	0	0		0	0	0	294778	0	121	40213260		
141075	3098	40213260	2009-09-28	2009-09-28 00:00:00	2009-09-28	2009-09-28 00:00:00	2009-09-28	581452		0	0	0		0	0	0	206172	0	121	40213260		
141152	3100	40213227	2012-03-22	2012-03-22 00:00:00	2012-03-22	2012-03-22 00:00:00	2012-03-22	581452		0	0	0		0	0	0	206295	0	113	40213227		
19624	1613	40229134	1987-10-28	1987-10-28 00:00:00	1987-11-04	1987-11-04 00:00:00	1987-11-04	38000177		0	0	7		0	0	0	108439	0	1043400	40229134		
58185	4834	19078461	2008-12-30	2008-12-30 00:00:00	2009-01-20	2009-01-20 00:00:00	2009-01-20	38000177		0	0	21		0	0	0	321550	0	310965	19078461		
122041	2682	40213227	2014-07-25	2014-07-25 00:00:00	2014-07-25	2014-07-25 00:00:00	2014-07-25	581452		0	0	0		0	0	0	\N	0	113	40213227		
125292	2757	40213160	1973-10-12	1973-10-12 00:00:00	1973-10-12	1973-10-12 00:00:00	1973-10-12	581452		0	0	0		0	0	0	182339	0	10	40213160		
134859	2960	40213296	1997-02-20	1997-02-20 00:00:00	1997-02-20	1997-02-20 00:00:00	1997-02-20	581452		0	0	0		0	0	0	197650	0	52	40213296		
57102	1250	40213198	2018-06-18	2018-06-18 00:00:00	2018-06-18	2018-06-18 00:00:00	2018-06-18	581452		0	0	0		0	0	0	82332	0	133	40213198		
46615	3860	1127433	1994-02-21	1994-02-21 00:00:00	1994-03-07	1994-03-07 00:00:00	1994-03-07	38000177		0	0	14		0	0	0	256339	0	313782	1127433		
45640	3779	19128065	1988-03-10	1988-03-10 00:00:00	1989-03-05	1989-03-05 00:00:00	1989-03-05	38000177		0	0	360		0	0	0	251138	0	749882	19128065		
81097	1773	40213160	1955-07-31	1955-07-31 00:00:00	1955-07-31	1955-07-31 00:00:00	1955-07-31	581452		0	0	0		0	0	0	118627	0	10	40213160		
53686	4462	1127433	1997-05-20	1997-05-20 00:00:00	1997-06-03	1997-06-03 00:00:00	1997-06-03	38000177		0	0	14		0	0	0	296893	0	313782	1127433		
152699	3362	40213296	1999-03-03	1999-03-03 00:00:00	1999-03-03	1999-03-03 00:00:00	1999-03-03	581452		0	0	0		0	0	0	222856	0	52	40213296		
64822	1418	40213160	1977-08-08	1977-08-08 00:00:00	1977-08-08	1977-08-08 00:00:00	1977-08-08	581452		0	0	0		0	0	0	94460	0	10	40213160		
220747	4844	40213160	1964-02-06	1964-02-06 00:00:00	1964-02-06	1964-02-06 00:00:00	1964-02-06	581452		0	0	0		0	0	0	322224	0	10	40213160		
140816	3092	40213160	1955-11-02	1955-11-02 00:00:00	1955-11-02	1955-11-02 00:00:00	1955-11-02	581452		0	0	0		0	0	0	205872	0	10	40213160		
224687	4932	40213160	1958-04-24	1958-04-24 00:00:00	1958-04-24	1958-04-24 00:00:00	1958-04-24	581452		0	0	0		0	0	0	327906	0	10	40213160		
169060	3717	40213227	2018-05-19	2018-05-19 00:00:00	2018-05-19	2018-05-19 00:00:00	2018-05-19	581452		0	0	0		0	0	0	247074	0	113	40213227		
233175	5123	40213314	1979-09-03	1979-09-03 00:00:00	1979-09-03	1979-09-03 00:00:00	1979-09-03	581452		0	0	0		0	0	0	340660	0	49	40213314		
79465	1739	40213296	2010-04-22	2010-04-22 00:00:00	2010-04-22	2010-04-22 00:00:00	2010-04-22	581452		0	0	0		0	0	0	116181	0	52	40213296		
202018	4435	40213227	2012-05-14	2012-05-14 00:00:00	2012-05-14	2012-05-14 00:00:00	2012-05-14	581452		0	0	0		0	0	0	294778	0	113	40213227		
141077	3098	40213227	2009-09-28	2009-09-28 00:00:00	2009-09-28	2009-09-28 00:00:00	2009-09-28	581452		0	0	0		0	0	0	206172	0	113	40213227		
121646	2673	40213314	1977-05-16	1977-05-16 00:00:00	1977-05-16	1977-05-16 00:00:00	1977-05-16	581452		0	0	0		0	0	0	177064	0	49	40213314		
19625	1613	1127433	1979-10-13	1979-10-13 00:00:00	1979-10-20	1979-10-20 00:00:00	1979-10-20	38000177		0	0	7		0	0	0	108438	0	313782	1127433		
58186	4834	19129655	1964-10-10	1964-10-10 00:00:00	1964-10-24	1964-10-24 00:00:00	1964-10-24	38000177		0	0	14		0	0	0	321555	0	789980	19129655		
208538	4574	40213227	1998-03-27	1998-03-27 00:00:00	1998-03-27	1998-03-27 00:00:00	1998-03-27	581452		0	0	0		0	0	0	304737	0	113	40213227		
134860	2960	40213160	1955-05-12	1955-05-12 00:00:00	1955-05-12	1955-05-12 00:00:00	1955-05-12	581452		0	0	0		0	0	0	197688	0	10	40213160		
105664	2319	40213160	1955-02-12	1955-02-12 00:00:00	1955-02-12	1955-02-12 00:00:00	1955-02-12	581452		0	0	0		0	0	0	154139	0	10	40213160		
46616	3860	19133873	1984-12-03	1984-12-03 00:00:00	1984-12-10	1984-12-10 00:00:00	1984-12-10	38000177		0	0	7		0	0	0	256319	0	834061	19133873		
45641	3779	40229134	1975-08-07	1975-08-07 00:00:00	1975-08-14	1975-08-14 00:00:00	1975-08-14	38000177		0	0	7		0	0	0	251144	0	1043400	40229134		
177749	3906	40213227	2004-09-15	2004-09-15 00:00:00	2004-09-15	2004-09-15 00:00:00	2004-09-15	581452		0	0	0		0	0	0	259686	0	113	40213227		
53689	4462	1127433	1978-09-02	1978-09-02 00:00:00	1978-09-16	1978-09-16 00:00:00	1978-09-16	38000177		0	0	14		0	0	0	296914	0	313782	1127433		
152701	3362	40213227	1999-03-03	1999-03-03 00:00:00	1999-03-03	1999-03-03 00:00:00	1999-03-03	581452		0	0	0		0	0	0	222856	0	113	40213227		
64823	1418	40213314	1977-08-08	1977-08-08 00:00:00	1977-08-08	1977-08-08 00:00:00	1977-08-08	581452		0	0	0		0	0	0	94460	0	49	40213314		
220750	4844	40213296	1999-07-08	1999-07-08 00:00:00	1999-07-08	1999-07-08 00:00:00	1999-07-08	581452		0	0	0		0	0	0	322301	0	52	40213296		
140817	3092	40213160	1956-01-04	1956-01-04 00:00:00	1956-01-04	1956-01-04 00:00:00	1956-01-04	581452		0	0	0		0	0	0	205845	0	10	40213160		
213574	4682	40213314	1979-12-23	1979-12-23 00:00:00	1979-12-23	1979-12-23 00:00:00	1979-12-23	581452		0	0	0		0	0	0	312026	0	49	40213314		
169061	3717	40213296	2018-05-19	2018-05-19 00:00:00	2018-05-19	2018-05-19 00:00:00	2018-05-19	581452		0	0	0		0	0	0	247074	0	52	40213296		
233179	5123	40213160	1979-09-03	1979-09-03 00:00:00	1979-09-03	1979-09-03 00:00:00	1979-09-03	581452		0	0	0		0	0	0	340660	0	10	40213160		
79470	1739	40213306	1990-07-12	1990-07-12 00:00:00	1990-07-12	1990-07-12 00:00:00	1990-07-12	581452		0	0	0		0	0	0	116231	0	43	40213306		
202021	4436	40213160	1965-11-05	1965-11-05 00:00:00	1965-11-05	1965-11-05 00:00:00	1965-11-05	581452		0	0	0		0	0	0	294859	0	10	40213160		
141079	3098	40213227	1993-01-18	1993-01-18 00:00:00	1993-01-18	1993-01-18 00:00:00	1993-01-18	581452		0	0	0		0	0	0	206213	0	113	40213227		
121647	2673	40213160	1977-05-16	1977-05-16 00:00:00	1977-05-16	1977-05-16 00:00:00	1977-05-16	581452		0	0	0		0	0	0	177064	0	10	40213160		
19626	1613	19128065	1975-04-05	1975-04-05 00:00:00	1976-03-30	1976-03-30 00:00:00	1976-03-30	38000177		0	0	360		0	0	0	108447	0	749882	19128065		
58187	4834	1127078	1964-10-10	1964-10-10 00:00:00	1964-10-24	1964-10-24 00:00:00	1964-10-24	38000177		0	0	14		0	0	0	321555	0	282464	1127078		
208542	4574	40213296	1996-03-22	1996-03-22 00:00:00	1996-03-22	1996-03-22 00:00:00	1996-03-22	581452		0	0	0		0	0	0	304722	0	52	40213296		
134864	2960	40213260	2006-02-09	2006-02-09 00:00:00	2006-02-09	2006-02-09 00:00:00	2006-02-09	581452		0	0	0		0	0	0	197668	0	121	40213260		
105676	2319	40213227	1999-02-13	1999-02-13 00:00:00	1999-02-13	1999-02-13 00:00:00	1999-02-13	581452		0	0	0		0	0	0	154168	0	113	40213227		
46617	3860	1127433	1985-12-30	1985-12-30 00:00:00	1986-02-03	1986-02-03 00:00:00	1986-02-03	38000177		0	0	35		0	0	0	256338	0	313782	1127433		
45642	3779	1713671	2001-08-15	2001-08-15 00:00:00	2001-08-29	2001-08-29 00:00:00	2001-08-29	38000177		0	0	14		0	0	0	251126	0	562251	1713671		
117783	2589	40213160	1983-08-30	1983-08-30 00:00:00	1983-08-30	1983-08-30 00:00:00	1983-08-30	581452		0	0	0		0	0	0	171340	0	10	40213160		
53690	4462	19128065	1974-12-30	1974-12-30 00:00:00	1975-12-25	1975-12-25 00:00:00	1975-12-25	38000177		0	0	360		0	0	0	296899	0	749882	19128065		
152702	3362	40213160	1957-07-31	1957-07-31 00:00:00	1957-07-31	1957-07-31 00:00:00	1957-07-31	581452		0	0	0		0	0	0	222903	0	10	40213160		
64826	1418	40213160	1973-02-05	1973-02-05 00:00:00	1973-02-05	1973-02-05 00:00:00	1973-02-05	581452		0	0	0		0	0	0	94429	0	10	40213160		
239393	5255	40213296	1999-12-30	1999-12-30 00:00:00	1999-12-30	1999-12-30 00:00:00	1999-12-30	581452		0	0	0		0	0	0	349691	0	52	40213296		
170276	3744	40213306	1992-11-22	1992-11-22 00:00:00	1992-11-22	1992-11-22 00:00:00	1992-11-22	581452		0	0	0		0	0	0	248847	0	43	40213306		
213575	4682	40213160	1979-12-23	1979-12-23 00:00:00	1979-12-23	1979-12-23 00:00:00	1979-12-23	581452		0	0	0		0	0	0	312026	0	10	40213160		
100856	2210	40213227	1998-01-04	1998-01-04 00:00:00	1998-01-04	1998-01-04 00:00:00	1998-01-04	581452		0	0	0		0	0	0	147249	0	113	40213227		
95361	2090	40213160	1966-09-07	1966-09-07 00:00:00	1966-09-07	1966-09-07 00:00:00	1966-09-07	581452		0	0	0		0	0	0	139410	0	10	40213160		
79474	1739	40213260	2019-02-07	2019-02-07 00:00:00	2019-02-07	2019-02-07 00:00:00	2019-02-07	581452		0	0	0		0	0	0	116182	0	121	40213260		
202025	4436	40213227	1996-08-09	1996-08-09 00:00:00	1996-08-09	1996-08-09 00:00:00	1996-08-09	581452		0	0	0		0	0	0	294845	0	113	40213227		
141080	3098	40213296	2000-10-02	2000-10-02 00:00:00	2000-10-02	2000-10-02 00:00:00	2000-10-02	581452		0	0	0		0	0	0	206161	0	52	40213296		
121655	2674	40213306	1993-07-02	1993-07-02 00:00:00	1993-07-02	1993-07-02 00:00:00	1993-07-02	581452		0	0	0		0	0	0	177203	0	43	40213306		
102386	2244	40213160	1955-12-30	1955-12-30 00:00:00	1955-12-30	1955-12-30 00:00:00	1955-12-30	581452		0	0	0		0	0	0	149453	0	10	40213160		
58188	4834	19128065	1974-05-12	1974-05-12 00:00:00	1975-05-07	1975-05-07 00:00:00	1975-05-07	38000177		0	0	360		0	0	0	321608	0	749882	19128065		
208545	4574	40213160	1956-06-22	1956-06-22 00:00:00	1956-06-22	1956-06-22 00:00:00	1956-06-22	581452		0	0	0		0	0	0	304750	0	10	40213160		
60083	1315	40213296	1999-06-15	1999-06-15 00:00:00	1999-06-15	1999-06-15 00:00:00	1999-06-15	581452		0	0	0		0	0	0	87099	0	52	40213296		
105685	2319	40213201	2013-09-21	2013-09-21 00:00:00	2013-09-21	2013-09-21 00:00:00	2013-09-21	581452		0	0	0		0	0	0	154201	0	33	40213201		
46618	3860	1713671	2018-11-16	2018-11-16 00:00:00	2018-11-30	2018-11-30 00:00:00	2018-11-30	38000177		0	0	14		0	0	0	256290	0	562251	1713671		
45643	3779	1115171	2003-06-10	2003-06-10 00:00:00	2003-07-08	2003-07-08 00:00:00	2003-07-08	38000177		0	0	28		0	0	0	251147	0	849574	1115171		
117792	2589	40213160	1983-06-28	1983-06-28 00:00:00	1983-06-28	1983-06-28 00:00:00	1983-06-28	581452		0	0	0		0	0	0	171350	0	10	40213160		
53701	4465	1118084	2010-09-04	2010-09-04 00:00:00	2010-09-04	2010-09-04 00:00:00	\N	38000177		0	0	0		0	0	0	297041	0	00025152531	44923712		
152708	3362	40213227	2008-12-03	2008-12-03 00:00:00	2008-12-03	2008-12-03 00:00:00	2008-12-03	581452		0	0	0		0	0	0	222858	0	113	40213227		
64827	1418	40213296	2014-09-08	2014-09-08 00:00:00	2014-09-08	2014-09-08 00:00:00	2014-09-08	581452		0	0	0		0	0	0	94408	0	52	40213296		
239396	5255	40213160	1960-06-02	1960-06-02 00:00:00	1960-06-02	1960-06-02 00:00:00	1960-06-02	581452		0	0	0		0	0	0	349672	0	10	40213160		
170277	3744	40213160	1970-06-07	1970-06-07 00:00:00	1970-06-07	1970-06-07 00:00:00	1970-06-07	581452		0	0	0		0	0	0	248787	0	10	40213160		
213580	4682	40213314	1980-11-23	1980-11-23 00:00:00	1980-11-23	1980-11-23 00:00:00	1980-11-23	581452		0	0	0		0	0	0	312008	0	49	40213314		
100862	2210	40213227	2008-06-15	2008-06-15 00:00:00	2008-06-15	2008-06-15 00:00:00	2008-06-15	581452		0	0	0		0	0	0	147183	0	113	40213227		
95363	2090	40213160	1967-02-08	1967-02-08 00:00:00	1967-02-08	1967-02-08 00:00:00	1967-02-08	581452		0	0	0		0	0	0	139379	0	10	40213160		
90764	1991	40213201	2010-01-11	2010-01-11 00:00:00	2010-01-11	2010-01-11 00:00:00	2010-01-11	581452		0	0	0		0	0	0	132576	0	33	40213201		
202027	4436	40213227	2007-06-08	2007-06-08 00:00:00	2007-06-08	2007-06-08 00:00:00	2007-06-08	581452		0	0	0		0	0	0	294873	0	113	40213227		
141089	3098	40213160	1958-12-29	1958-12-29 00:00:00	1958-12-29	1958-12-29 00:00:00	1958-12-29	581452		0	0	0		0	0	0	206153	0	10	40213160		
121657	2674	40213227	1993-07-02	1993-07-02 00:00:00	1993-07-02	1993-07-02 00:00:00	1993-07-02	581452		0	0	0		0	0	0	177203	0	113	40213227		
113683	2498	40213227	1994-03-26	1994-03-26 00:00:00	1994-03-26	1994-03-26 00:00:00	1994-03-26	581452		0	0	0		0	0	0	165388	0	113	40213227		
58189	4834	1118084	2003-04-25	2003-04-25 00:00:00	2003-04-25	2003-04-25 00:00:00	\N	38000177		0	0	0		0	0	0	321566	0	00025152531	44923712		
208547	4574	40213227	2017-03-17	2017-03-17 00:00:00	2017-03-17	2017-03-17 00:00:00	2017-03-17	581452		0	0	0		0	0	0	304692	0	113	40213227		
60090	1315	40213296	2001-06-19	2001-06-19 00:00:00	2001-06-19	2001-06-19 00:00:00	2001-06-19	581452		0	0	0		0	0	0	87112	0	52	40213296		
105695	2319	40213198	2012-09-15	2012-09-15 00:00:00	2012-09-15	2012-09-15 00:00:00	2012-09-15	581452		0	0	0		0	0	0	154239	0	133	40213198		
46619	3860	1127433	1986-09-24	1986-09-24 00:00:00	1986-10-01	1986-10-01 00:00:00	1986-10-01	38000177		0	0	7		0	0	0	256329	0	313782	1127433		
56109	4657	1115171	2002-01-07	2002-01-07 00:00:00	2002-01-28	2002-01-28 00:00:00	2002-01-28	38000177		0	0	21		0	0	0	310511	0	849574	1115171		
117793	2589	40213314	1983-06-28	1983-06-28 00:00:00	1983-06-28	1983-06-28 00:00:00	1983-06-28	581452		0	0	0		0	0	0	171350	0	49	40213314		
53702	4465	1127078	1977-07-04	1977-07-04 00:00:00	1977-07-25	1977-07-25 00:00:00	1977-07-25	38000177		0	0	21		0	0	0	297075	0	282464	1127078		
152709	3362	40213260	2008-12-03	2008-12-03 00:00:00	2008-12-03	2008-12-03 00:00:00	2008-12-03	581452		0	0	0		0	0	0	222858	0	121	40213260		
64840	1418	40213227	2003-11-10	2003-11-10 00:00:00	2003-11-10	2003-11-10 00:00:00	2003-11-10	581452		0	0	0		0	0	0	94453	0	113	40213227		
170281	3744	40213160	1970-04-05	1970-04-05 00:00:00	1970-04-05	1970-04-05 00:00:00	1970-04-05	581452		0	0	0		0	0	0	248810	0	10	40213160		
100866	2210	40213201	2003-05-18	2003-05-18 00:00:00	2003-05-18	2003-05-18 00:00:00	2003-05-18	581452		0	0	0		0	0	0	147250	0	33	40213201		
95369	2091	40213160	1965-04-24	1965-04-24 00:00:00	1965-04-24	1965-04-24 00:00:00	1965-04-24	581452		0	0	0		0	0	0	139478	0	10	40213160		
90765	1991	40213198	2010-01-11	2010-01-11 00:00:00	2010-01-11	2010-01-11 00:00:00	2010-01-11	581452		0	0	0		0	0	0	132576	0	133	40213198		
202028	4436	40213296	2007-06-08	2007-06-08 00:00:00	2007-06-08	2007-06-08 00:00:00	2007-06-08	581452		0	0	0		0	0	0	294873	0	52	40213296		
141092	3098	40213260	2008-09-22	2008-09-22 00:00:00	2008-09-22	2008-09-22 00:00:00	2008-09-22	581452		0	0	0		0	0	0	206179	0	121	40213260		
121659	2674	40213296	2011-04-29	2011-04-29 00:00:00	2011-04-29	2011-04-29 00:00:00	2011-04-29	581452		0	0	0		0	0	0	177192	0	52	40213296		
113684	2498	40213306	1994-03-26	1994-03-26 00:00:00	1994-03-26	1994-03-26 00:00:00	1994-03-26	581452		0	0	0		0	0	0	165388	0	43	40213306		
58190	4834	1127433	1994-02-21	1994-02-21 00:00:00	1994-03-14	1994-03-14 00:00:00	1994-03-14	38000177		0	0	21		0	0	0	321548	0	313782	1127433		
208552	4574	40213160	1956-08-24	1956-08-24 00:00:00	1956-08-24	1956-08-24 00:00:00	1956-08-24	581452		0	0	0		0	0	0	304708	0	10	40213160		
60092	1315	40213227	2001-06-19	2001-06-19 00:00:00	2001-06-19	2001-06-19 00:00:00	2001-06-19	581452		0	0	0		0	0	0	87112	0	113	40213227		
194764	4279	40213227	2011-06-10	2011-06-10 00:00:00	2011-06-10	2011-06-10 00:00:00	2011-06-10	581452		0	0	0		0	0	0	283989	0	113	40213227		
46628	3862	19059056	1957-12-22	1957-12-22 00:00:00	1958-01-05	1958-01-05 00:00:00	1958-01-05	38000177		0	0	14		0	0	0	256397	0	243670	19059056		
56110	4657	19133905	1982-05-25	1982-05-25 00:00:00	1982-06-03	1982-06-03 00:00:00	1982-06-03	38000177		0	0	9		0	0	0	310561	0	834102	19133905		
117809	2590	40213160	1967-09-26	1967-09-26 00:00:00	1967-09-26	1967-09-26 00:00:00	1967-09-26	581452		0	0	0		0	0	0	171392	0	10	40213160		
53703	4465	1127433	1986-09-17	1986-09-17 00:00:00	1986-09-24	1986-09-24 00:00:00	1986-09-24	38000177		0	0	7		0	0	0	297039	0	313782	1127433		
152723	3362	40213160	1961-12-27	1961-12-27 00:00:00	1961-12-27	1961-12-27 00:00:00	1961-12-27	581452		0	0	0		0	0	0	222907	0	10	40213160		
197923	4349	40213251	1987-11-12	1987-11-12 00:00:00	1987-11-12	1987-11-12 00:00:00	1987-11-12	581452		0	0	0		0	0	0	288412	0	21	40213251		
170288	3744	40213160	1974-07-07	1974-07-07 00:00:00	1974-07-07	1974-07-07 00:00:00	1974-07-07	581452		0	0	0		0	0	0	248789	0	10	40213160		
100883	2210	40213227	2018-08-12	2018-08-12 00:00:00	2018-08-12	2018-08-12 00:00:00	2018-08-12	581452		0	0	0		0	0	0	147181	0	113	40213227		
95370	2091	40213160	1965-02-20	1965-02-20 00:00:00	1965-02-20	1965-02-20 00:00:00	1965-02-20	581452		0	0	0		0	0	0	139446	0	10	40213160		
90780	1992	40213314	1977-08-28	1977-08-28 00:00:00	1977-08-28	1977-08-28 00:00:00	1977-08-28	581452		0	0	0		0	0	0	132749	0	49	40213314		
202033	4436	40213160	1970-05-08	1970-05-08 00:00:00	1970-05-08	1970-05-08 00:00:00	1970-05-08	581452		0	0	0		0	0	0	294863	0	10	40213160		
141094	3098	40213160	1963-09-02	1963-09-02 00:00:00	1963-09-02	1963-09-02 00:00:00	1963-09-02	581452		0	0	0		0	0	0	206187	0	10	40213160		
121666	2674	40213160	1971-10-08	1971-10-08 00:00:00	1971-10-08	1971-10-08 00:00:00	1971-10-08	581452		0	0	0		0	0	0	177194	0	10	40213160		
113689	2498	40213160	1972-03-18	1972-03-18 00:00:00	1972-03-18	1972-03-18 00:00:00	1972-03-18	581452		0	0	0		0	0	0	165425	0	10	40213160		
58191	4834	1127433	1983-09-13	1983-09-13 00:00:00	1983-09-27	1983-09-27 00:00:00	1983-09-27	38000177		0	0	14		0	0	0	321551	0	313782	1127433		
208554	4574	40213227	2008-01-25	2008-01-25 00:00:00	2008-01-25	2008-01-25 00:00:00	2008-01-25	581452		0	0	0		0	0	0	304745	0	113	40213227		
60095	1315	40213306	1982-03-16	1982-03-16 00:00:00	1982-03-16	1982-03-16 00:00:00	1982-03-16	581452		0	0	0		0	0	0	87109	0	43	40213306		
182945	4020	40213160	1961-02-09	1961-02-09 00:00:00	1961-02-09	1961-02-09 00:00:00	1961-02-09	581452		0	0	0		0	0	0	267231	0	10	40213160		
46629	3862	19006318	1957-12-22	1957-12-22 00:00:00	1958-01-05	1958-01-05 00:00:00	1958-01-05	38000177		0	0	14		0	0	0	256397	0	105078	19006318		
56111	4657	1115171	1995-06-06	1995-06-06 00:00:00	1995-07-13	1995-07-13 00:00:00	1995-07-13	38000177		0	0	37		0	0	0	310510	0	849574	1115171		
117811	2590	40213160	1963-03-26	1963-03-26 00:00:00	1963-03-26	1963-03-26 00:00:00	1963-03-26	581452		0	0	0		0	0	0	171389	0	10	40213160		
53704	4465	1127433	1987-05-04	1987-05-04 00:00:00	1987-06-03	1987-06-03 00:00:00	1987-06-03	38000177		0	0	30		0	0	0	297076	0	313782	1127433		
155236	3417	40213227	1992-04-25	1992-04-25 00:00:00	1992-04-25	1992-04-25 00:00:00	1992-04-25	581452		0	0	0		0	0	0	226590	0	113	40213227		
197924	4349	40213160	1987-11-12	1987-11-12 00:00:00	1987-11-12	1987-11-12 00:00:00	1987-11-12	581452		0	0	0		0	0	0	288412	0	10	40213160		
170299	3744	40213227	2001-01-28	2001-01-28 00:00:00	2001-01-28	2001-01-28 00:00:00	2001-01-28	581452		0	0	0		0	0	0	248823	0	113	40213227		
127200	2798	40213160	1956-03-18	1956-03-18 00:00:00	1956-03-18	1956-03-18 00:00:00	1956-03-18	581452		0	0	0		0	0	0	185409	0	10	40213160		
95371	2091	40213227	2007-07-14	2007-07-14 00:00:00	2007-07-14	2007-07-14 00:00:00	2007-07-14	581452		0	0	0		0	0	0	139470	0	113	40213227		
90782	1992	40213296	2015-12-27	2015-12-27 00:00:00	2015-12-27	2015-12-27 00:00:00	2015-12-27	581452		0	0	0		0	0	0	132707	0	52	40213296		
202034	4436	40213306	1987-07-31	1987-07-31 00:00:00	1987-07-31	1987-07-31 00:00:00	1987-07-31	581452		0	0	0		0	0	0	294844	0	43	40213306		
141099	3098	40213160	1959-06-01	1959-06-01 00:00:00	1959-06-01	1959-06-01 00:00:00	1959-06-01	581452		0	0	0		0	0	0	206154	0	10	40213160		
121670	2674	40213160	1976-04-09	1976-04-09 00:00:00	1976-04-09	1976-04-09 00:00:00	1976-04-09	581452		0	0	0		0	0	0	177197	0	10	40213160		
113690	2498	40213160	1971-10-16	1971-10-16 00:00:00	1971-10-16	1971-10-16 00:00:00	1971-10-16	581452		0	0	0		0	0	0	165410	0	10	40213160		
58192	4834	19059056	1962-02-04	1962-02-04 00:00:00	1962-02-18	1962-02-18 00:00:00	1962-02-18	38000177		0	0	14		0	0	0	321570	0	243670	19059056		
208567	4574	40213160	1960-12-02	1960-12-02 00:00:00	1960-12-02	1960-12-02 00:00:00	1960-12-02	581452		0	0	0		0	0	0	304729	0	10	40213160		
60097	1315	40213260	2009-06-09	2009-06-09 00:00:00	2009-06-09	2009-06-09 00:00:00	2009-06-09	581452		0	0	0		0	0	0	87101	0	121	40213260		
182953	4020	40213227	1998-03-26	1998-03-26 00:00:00	1998-03-26	1998-03-26 00:00:00	1998-03-26	581452		0	0	0		0	0	0	267261	0	113	40213227		
46630	3862	40229134	1995-04-20	1995-04-20 00:00:00	1995-05-04	1995-05-04 00:00:00	1995-05-04	38000177		0	0	14		0	0	0	256381	0	1043400	40229134		
56112	4657	1124300	1999-02-15	1999-02-15 00:00:00	1999-02-15	1999-02-15 00:00:00	\N	38000177		0	0	0		0	0	0	310568	0	00781178901	45011828		
117812	2590	40213160	1963-06-25	1963-06-25 00:00:00	1963-06-25	1963-06-25 00:00:00	1963-06-25	581452		0	0	0		0	0	0	171362	0	10	40213160		
53705	4465	46233988	1976-01-11	1976-01-11 00:00:00	1976-01-25	1976-01-25 00:00:00	1976-01-25	38000177		0	0	14		0	0	0	297077	0	1652673	46233988		
156399	3442	40213160	1960-11-20	1960-11-20 00:00:00	1960-11-20	1960-11-20 00:00:00	1960-11-20	581452		0	0	0		0	0	0	228388	0	10	40213160		
197925	4349	40213314	1983-05-12	1983-05-12 00:00:00	1983-05-12	1983-05-12 00:00:00	1983-05-12	581452		0	0	0		0	0	0	288392	0	49	40213314		
170303	3744	40213160	1970-09-06	1970-09-06 00:00:00	1970-09-06	1970-09-06 00:00:00	1970-09-06	581452		0	0	0		0	0	0	248758	0	10	40213160		
127204	2798	40213227	2004-10-17	2004-10-17 00:00:00	2004-10-17	2004-10-17 00:00:00	2004-10-17	581452		0	0	0		0	0	0	185436	0	113	40213227		
95372	2091	40213296	2007-07-14	2007-07-14 00:00:00	2007-07-14	2007-07-14 00:00:00	2007-07-14	581452		0	0	0		0	0	0	139470	0	52	40213296		
183275	4026	40213306	1981-08-09	1981-08-09 00:00:00	1981-08-09	1981-08-09 00:00:00	1981-08-09	581452		0	0	0		0	0	0	\N	0	43	40213306		
202037	4436	40213160	1965-09-03	1965-09-03 00:00:00	1965-09-03	1965-09-03 00:00:00	1965-09-03	581452		0	0	0		0	0	0	294837	0	10	40213160		
141104	3098	40213306	1981-01-05	1981-01-05 00:00:00	1981-01-05	1981-01-05 00:00:00	1981-01-05	581452		0	0	0		0	0	0	206160	0	43	40213306		
121674	2674	40213227	2013-05-03	2013-05-03 00:00:00	2013-05-03	2013-05-03 00:00:00	2013-05-03	581452		0	0	0		0	0	0	177181	0	113	40213227		
113694	2498	40213160	1975-12-27	1975-12-27 00:00:00	1975-12-27	1975-12-27 00:00:00	1975-12-27	581452		0	0	0		0	0	0	165413	0	10	40213160		
58193	4834	19059056	1971-03-24	1971-03-24 00:00:00	1971-04-23	1971-04-23 00:00:00	1971-04-23	38000177		0	0	30		0	0	0	321546	0	243670	19059056		
219874	4826	40213227	2012-08-18	2012-08-18 00:00:00	2012-08-18	2012-08-18 00:00:00	2012-08-18	581452		0	0	0		0	0	0	320958	0	113	40213227		
60107	1315	40213227	1994-03-29	1994-03-29 00:00:00	1994-03-29	1994-03-29 00:00:00	1994-03-29	581452		0	0	0		0	0	0	87124	0	113	40213227		
182954	4020	40213296	1998-03-26	1998-03-26 00:00:00	1998-03-26	1998-03-26 00:00:00	1998-03-26	581452		0	0	0		0	0	0	267261	0	52	40213296		
46631	3862	1118084	1995-06-11	1995-06-11 00:00:00	1995-06-11	1995-06-11 00:00:00	\N	38000177		0	0	0		0	0	0	256381	0	00025152531	44923712		
7329	613	1127433	2007-08-07	2007-08-07 00:00:00	2007-08-21	2007-08-21 00:00:00	2007-08-21	38000177		0	0	14		0	0	0	40749	0	313782	1127433		
212060	4649	40213227	2010-05-10	2010-05-10 00:00:00	2010-05-10	2010-05-10 00:00:00	2010-05-10	581452		0	0	0		0	0	0	310043	0	113	40213227		
53706	4465	19059056	1976-01-11	1976-01-11 00:00:00	1976-01-25	1976-01-25 00:00:00	1976-01-25	38000177		0	0	14		0	0	0	297077	0	243670	19059056		
156404	3442	40213296	2000-06-18	2000-06-18 00:00:00	2000-06-18	2000-06-18 00:00:00	2000-06-18	581452		0	0	0		0	0	0	228424	0	52	40213296		
197926	4349	40213160	1983-05-12	1983-05-12 00:00:00	1983-05-12	1983-05-12 00:00:00	1983-05-12	581452		0	0	0		0	0	0	288392	0	10	40213160		
170307	3744	40213296	2013-11-17	2013-11-17 00:00:00	2013-11-17	2013-11-17 00:00:00	2013-11-17	581452		0	0	0		0	0	0	248767	0	52	40213296		
127207	2798	40213160	1958-09-21	1958-09-21 00:00:00	1958-09-21	1958-09-21 00:00:00	1958-09-21	581452		0	0	0		0	0	0	185420	0	10	40213160		
95377	2091	40213306	1987-11-28	1987-11-28 00:00:00	1987-11-28	1987-11-28 00:00:00	1987-11-28	581452		0	0	0		0	0	0	139465	0	43	40213306		
183277	4026	40213306	1981-01-04	1981-01-04 00:00:00	1981-01-04	1981-01-04 00:00:00	1981-01-04	581452		0	0	0		0	0	0	\N	0	43	40213306		
199466	4381	40213306	1987-11-03	1987-11-03 00:00:00	1987-11-03	1987-11-03 00:00:00	1987-11-03	581452		0	0	0		0	0	0	291139	0	43	40213306		
121601	2672	40213160	1955-11-06	1955-11-06 00:00:00	1955-11-06	1955-11-06 00:00:00	1955-11-06	581452		0	0	0		0	0	0	176903	0	10	40213160		
121675	2674	40213296	2013-05-03	2013-05-03 00:00:00	2013-05-03	2013-05-03 00:00:00	2013-05-03	581452		0	0	0		0	0	0	177181	0	52	40213296		
113699	2498	40213227	2003-04-05	2003-04-05 00:00:00	2003-04-05	2003-04-05 00:00:00	2003-04-05	581452		0	0	0		0	0	0	165419	0	113	40213227		
58194	4834	40236824	2016-06-14	2016-06-14 00:00:00	2016-06-21	2016-06-21 00:00:00	2016-06-21	38000177		0	0	7		0	0	0	321553	0	1094107	40236824		
219876	4826	40213160	1955-05-14	1955-05-14 00:00:00	1955-05-14	1955-05-14 00:00:00	1955-05-14	581452		0	0	0		0	0	0	321008	0	10	40213160		
60110	1315	40213160	1959-11-17	1959-11-17 00:00:00	1959-11-17	1959-11-17 00:00:00	1959-11-17	581452		0	0	0		0	0	0	87072	0	10	40213160		
182964	4020	40213260	2006-03-02	2006-03-02 00:00:00	2006-03-02	2006-03-02 00:00:00	2006-03-02	581452		0	0	0		0	0	0	267253	0	121	40213260		
46632	3862	1127433	1977-05-12	1977-05-12 00:00:00	1977-05-19	1977-05-19 00:00:00	1977-05-19	38000177		0	0	7		0	0	0	256438	0	313782	1127433		
7330	613	1115171	2002-04-18	2002-04-18 00:00:00	2002-05-02	2002-05-02 00:00:00	2002-05-02	38000177		0	0	14		0	0	0	40695	0	849574	1115171		
212061	4649	40213296	2010-05-10	2010-05-10 00:00:00	2010-05-10	2010-05-10 00:00:00	2010-05-10	581452		0	0	0		0	0	0	310043	0	52	40213296		
53707	4465	1713671	2011-10-27	2011-10-27 00:00:00	2011-11-17	2011-11-17 00:00:00	2011-11-17	38000177		0	0	21		0	0	0	297088	0	562251	1713671		
156407	3442	40213160	1961-02-19	1961-02-19 00:00:00	1961-02-19	1961-02-19 00:00:00	1961-02-19	581452		0	0	0		0	0	0	228433	0	10	40213160		
197930	4349	40213180	2005-02-03	2005-02-03 00:00:00	2005-02-03	2005-02-03 00:00:00	2005-02-03	581452		0	0	0		0	0	0	288407	0	114	40213180		
170317	3745	40213227	2011-09-07	2011-09-07 00:00:00	2011-09-07	2011-09-07 00:00:00	2011-09-07	581452		0	0	0		0	0	0	248964	0	113	40213227		
671	53	1127433	1988-02-26	1988-02-26 00:00:00	1988-04-26	1988-04-26 00:00:00	1988-04-26	38000177		0	0	60		0	0	0	3684	0	313782	1127433		
95381	2091	40213160	1965-07-24	1965-07-24 00:00:00	1965-07-24	1965-07-24 00:00:00	1965-07-24	581452		0	0	0		0	0	0	139447	0	10	40213160		
183279	4026	40213296	2000-04-30	2000-04-30 00:00:00	2000-04-30	2000-04-30 00:00:00	2000-04-30	581452		0	0	0		0	0	0	267654	0	52	40213296		
199473	4382	40213201	2019-05-06	2019-05-06 00:00:00	2019-05-06	2019-05-06 00:00:00	2019-05-06	581452		0	0	0		0	0	0	291166	0	33	40213201		
121604	2673	40213160	1977-10-17	1977-10-17 00:00:00	1977-10-17	1977-10-17 00:00:00	1977-10-17	581452		0	0	0		0	0	0	177166	0	10	40213160		
121683	2674	40213160	1972-01-07	1972-01-07 00:00:00	1972-01-07	1972-01-07 00:00:00	1972-01-07	581452		0	0	0		0	0	0	177212	0	10	40213160		
113701	2498	40213296	2011-07-16	2011-07-16 00:00:00	2011-07-16	2011-07-16 00:00:00	2011-07-16	581452		0	0	0		0	0	0	165422	0	52	40213296		
58195	4834	920300	2016-06-14	2016-06-14 00:00:00	2016-06-21	2016-06-21 00:00:00	2016-06-21	38000177		0	0	7		0	0	0	321553	0	311989	920300		
219886	4826	40213201	2017-09-16	2017-09-16 00:00:00	2017-09-16	2017-09-16 00:00:00	2017-09-16	581452		0	0	0		0	0	0	320983	0	33	40213201		
60111	1315	40213160	1959-09-15	1959-09-15 00:00:00	1959-09-15	1959-09-15 00:00:00	1959-09-15	581452		0	0	0		0	0	0	87082	0	10	40213160		
182975	4020	40213227	2017-05-04	2017-05-04 00:00:00	2017-05-04	2017-05-04 00:00:00	2017-05-04	581452		0	0	0		0	0	0	267264	0	113	40213227		
46633	3862	19078461	2011-04-13	2011-04-13 00:00:00	2011-05-04	2011-05-04 00:00:00	2011-05-04	38000177		0	0	21		0	0	0	256460	0	310965	19078461		
7331	613	40236824	1987-12-19	1987-12-19 00:00:00	1987-12-26	1987-12-26 00:00:00	1987-12-26	38000177		0	0	7		0	0	0	40735	0	1094107	40236824		
212066	4649	40213160	1969-07-21	1969-07-21 00:00:00	1969-07-21	1969-07-21 00:00:00	1969-07-21	581452		0	0	0		0	0	0	309984	0	10	40213160		
53708	4466	19078461	2016-09-04	2016-09-04 00:00:00	2016-09-18	2016-09-18 00:00:00	2016-09-18	38000177		0	0	14		0	0	0	297159	0	310965	19078461		
156409	3442	40213160	1965-03-28	1965-03-28 00:00:00	1965-03-28	1965-03-28 00:00:00	1965-03-28	581452		0	0	0		0	0	0	228436	0	10	40213160		
197932	4349	40213227	2005-02-03	2005-02-03 00:00:00	2005-02-03	2005-02-03 00:00:00	2005-02-03	581452		0	0	0		0	0	0	288407	0	113	40213227		
140083	3077	40213160	1955-11-02	1955-11-02 00:00:00	1955-11-02	1955-11-02 00:00:00	1955-11-02	581452		0	0	0		0	0	0	204774	0	10	40213160		
672	53	40162522	1988-02-26	1988-02-26 00:00:00	1988-02-26	1988-02-26 00:00:00	\N	38000177		0	0	0		0	0	0	3684	0	857005	40162522		
95384	2091	40213227	2015-11-21	2015-11-21 00:00:00	2015-11-21	2015-11-21 00:00:00	2015-11-21	581452		0	0	0		0	0	0	139467	0	113	40213227		
183281	4026	40213227	2019-03-17	2019-03-17 00:00:00	2019-03-17	2019-03-17 00:00:00	2019-03-17	581452		0	0	0		0	0	0	267720	0	113	40213227		
199478	4382	40213260	2006-01-16	2006-01-16 00:00:00	2006-01-16	2006-01-16 00:00:00	2006-01-16	581452		0	0	0		0	0	0	291161	0	121	40213260		
121606	2673	40213306	1999-12-06	1999-12-06 00:00:00	1999-12-06	1999-12-06 00:00:00	1999-12-06	581452		0	0	0		0	0	0	177125	0	43	40213306		
121688	2674	40213227	2002-07-12	2002-07-12 00:00:00	2002-07-12	2002-07-12 00:00:00	2002-07-12	581452		0	0	0		0	0	0	177190	0	113	40213227		
106591	2337	40213160	1963-12-24	1963-12-24 00:00:00	1963-12-24	1963-12-24 00:00:00	1963-12-24	581452		0	0	0		0	0	0	155509	0	10	40213160		
58196	4835	19059056	1974-03-10	1974-03-10 00:00:00	1974-04-09	1974-04-09 00:00:00	1974-04-09	38000177		0	0	30		0	0	0	321633	0	243670	19059056		
219894	4826	40213160	1956-05-19	1956-05-19 00:00:00	1956-05-19	1956-05-19 00:00:00	1956-05-19	581452		0	0	0		0	0	0	320995	0	10	40213160		
60113	1315	40213160	1960-02-16	1960-02-16 00:00:00	1960-02-16	1960-02-16 00:00:00	1960-02-16	581452		0	0	0		0	0	0	87083	0	10	40213160		
182978	4020	40213296	1996-03-21	1996-03-21 00:00:00	1996-03-21	1996-03-21 00:00:00	1996-03-21	581452		0	0	0		0	0	0	267241	0	52	40213296		
46634	3862	1115171	2013-11-19	2013-11-19 00:00:00	2013-12-03	2013-12-03 00:00:00	2013-12-03	38000177		0	0	14		0	0	0	256461	0	849574	1115171		
7332	613	920300	1987-12-19	1987-12-19 00:00:00	1987-12-26	1987-12-26 00:00:00	1987-12-26	38000177		0	0	7		0	0	0	40735	0	311989	920300		
104517	2292	40213296	2007-09-14	2007-09-14 00:00:00	2007-09-14	2007-09-14 00:00:00	2007-09-14	581452		0	0	0		0	0	0	152579	0	52	40213296		
53709	4466	1127433	1996-07-16	1996-07-16 00:00:00	1996-07-30	1996-07-30 00:00:00	1996-07-30	38000177		0	0	14		0	0	0	297156	0	313782	1127433		
156415	3442	40213260	2011-06-19	2011-06-19 00:00:00	2011-06-19	2011-06-19 00:00:00	2011-06-19	581452		0	0	0		0	0	0	228398	0	121	40213260		
197933	4349	40213306	2005-02-03	2005-02-03 00:00:00	2005-02-03	2005-02-03 00:00:00	2005-02-03	581452		0	0	0		0	0	0	288407	0	43	40213306		
140085	3077	40213160	1957-05-08	1957-05-08 00:00:00	1957-05-08	1957-05-08 00:00:00	1957-05-08	581452		0	0	0		0	0	0	204775	0	10	40213160		
673	53	19059056	1967-01-02	1967-01-02 00:00:00	1967-01-16	1967-01-16 00:00:00	1967-01-16	38000177		0	0	14		0	0	0	3698	0	243670	19059056		
95385	2091	40213260	2015-11-21	2015-11-21 00:00:00	2015-11-21	2015-11-21 00:00:00	2015-11-21	581452		0	0	0		0	0	0	139467	0	121	40213260		
183287	4026	40213227	2009-02-22	2009-02-22 00:00:00	2009-02-22	2009-02-22 00:00:00	2009-02-22	581452		0	0	0		0	0	0	267609	0	113	40213227		
199482	4382	40213227	1995-11-20	1995-11-20 00:00:00	1995-11-20	1995-11-20 00:00:00	1995-11-20	581452		0	0	0		0	0	0	291282	0	113	40213227		
121608	2673	40213227	1999-12-06	1999-12-06 00:00:00	1999-12-06	1999-12-06 00:00:00	1999-12-06	581452		0	0	0		0	0	0	177125	0	113	40213227		
172579	3793	40213227	2011-04-12	2011-04-12 00:00:00	2011-04-12	2011-04-12 00:00:00	2011-04-12	581452		0	0	0		0	0	0	252239	0	113	40213227		
106595	2337	40213306	1985-09-17	1985-09-17 00:00:00	1985-09-17	1985-09-17 00:00:00	1985-09-17	581452		0	0	0		0	0	0	155515	0	43	40213306		
21355	1756	1118084	2013-05-18	2013-05-18 00:00:00	2013-05-18	2013-05-18 00:00:00	\N	38000177		0	0	0		0	0	0	117422	0	00025152531	44923712		
219900	4826	40213198	2016-09-10	2016-09-10 00:00:00	2016-09-10	2016-09-10 00:00:00	2016-09-10	581452		0	0	0		0	0	0	321023	0	133	40213198		
60119	1315	40213160	1964-03-10	1964-03-10 00:00:00	1964-03-10	1964-03-10 00:00:00	1964-03-10	581452		0	0	0		0	0	0	87121	0	10	40213160		
182982	4020	40213160	1956-11-08	1956-11-08 00:00:00	1956-11-08	1956-11-08 00:00:00	1956-11-08	581452		0	0	0		0	0	0	267211	0	10	40213160		
46635	3862	1713671	2005-07-20	2005-07-20 00:00:00	2005-08-03	2005-08-03 00:00:00	2005-08-03	38000177		0	0	14		0	0	0	256395	0	562251	1713671		
7333	613	40236824	1995-03-20	1995-03-20 00:00:00	1995-03-27	1995-03-27 00:00:00	1995-03-27	38000177		0	0	7		0	0	0	40762	0	1094107	40236824		
104525	2292	40213260	2014-02-07	2014-02-07 00:00:00	2014-02-07	2014-02-07 00:00:00	2014-02-07	581452		0	0	0		0	0	0	152590	0	121	40213260		
53710	4466	19133873	1976-02-09	1976-02-09 00:00:00	1976-02-18	1976-02-18 00:00:00	1976-02-18	38000177		0	0	9		0	0	0	297092	0	834061	19133873		
156417	3442	40213227	2011-06-19	2011-06-19 00:00:00	2011-06-19	2011-06-19 00:00:00	2011-06-19	581452		0	0	0		0	0	0	228398	0	113	40213227		
197936	4349	40213314	1984-02-09	1984-02-09 00:00:00	1984-02-09	1984-02-09 00:00:00	1984-02-09	581452		0	0	0		0	0	0	288409	0	49	40213314		
140094	3077	40213198	2017-06-28	2017-06-28 00:00:00	2017-06-28	2017-06-28 00:00:00	2017-06-28	581452		0	0	0		0	0	0	204786	0	133	40213198		
674	53	19006318	1967-01-02	1967-01-02 00:00:00	1967-01-16	1967-01-16 00:00:00	1967-01-16	38000177		0	0	14		0	0	0	3698	0	105078	19006318		
95389	2091	40213296	2005-07-09	2005-07-09 00:00:00	2005-07-09	2005-07-09 00:00:00	2005-07-09	581452		0	0	0		0	0	0	139469	0	52	40213296		
183288	4026	40213260	2009-02-22	2009-02-22 00:00:00	2009-02-22	2009-02-22 00:00:00	2009-02-22	581452		0	0	0		0	0	0	267609	0	121	40213260		
199483	4382	40213160	1955-09-05	1955-09-05 00:00:00	1955-09-05	1955-09-05 00:00:00	1955-09-05	581452		0	0	0		0	0	0	\N	0	10	40213160		
121610	2673	40213314	1977-07-18	1977-07-18 00:00:00	1977-07-18	1977-07-18 00:00:00	1977-07-18	581452		0	0	0		0	0	0	177118	0	49	40213314		
172583	3793	40213227	2000-05-30	2000-05-30 00:00:00	2000-05-30	2000-05-30 00:00:00	2000-05-30	581452		0	0	0		0	0	0	252290	0	113	40213227		
106599	2337	40213160	1968-06-25	1968-06-25 00:00:00	1968-06-25	1968-06-25 00:00:00	1968-06-25	581452		0	0	0		0	0	0	155512	0	10	40213160		
21356	1756	40229134	2008-02-19	2008-02-19 00:00:00	2008-02-26	2008-02-26 00:00:00	2008-02-26	38000177		0	0	7		0	0	0	117462	0	1043400	40229134		
219904	4827	40213227	1992-11-19	1992-11-19 00:00:00	1992-11-19	1992-11-19 00:00:00	1992-11-19	581452		0	0	0		0	0	0	321222	0	113	40213227		
60122	1315	40213227	2010-06-15	2010-06-15 00:00:00	2010-06-15	2010-06-15 00:00:00	2010-06-15	581452		0	0	0		0	0	0	87094	0	113	40213227		
182984	4020	40213260	2007-03-08	2007-03-08 00:00:00	2007-03-08	2007-03-08 00:00:00	2007-03-08	581452		0	0	0		0	0	0	267243	0	121	40213260		
46637	3864	1127433	1974-08-08	1974-08-08 00:00:00	1974-08-15	1974-08-15 00:00:00	1974-08-15	38000177		0	0	7		0	0	0	256527	0	313782	1127433		
7334	613	920300	1995-03-20	1995-03-20 00:00:00	1995-03-27	1995-03-27 00:00:00	1995-03-27	38000177		0	0	7		0	0	0	40762	0	311989	920300		
104528	2292	40213227	2005-09-09	2005-09-09 00:00:00	2005-09-09	2005-09-09 00:00:00	2005-09-09	581452		0	0	0		0	0	0	152624	0	113	40213227		
53711	4466	1713671	2013-05-13	2013-05-13 00:00:00	2013-05-27	2013-05-27 00:00:00	2013-05-27	38000177		0	0	14		0	0	0	297100	0	562251	1713671		
156419	3442	40213306	1982-06-20	1982-06-20 00:00:00	1982-06-20	1982-06-20 00:00:00	1982-06-20	581452		0	0	0		0	0	0	228438	0	43	40213306		
197937	4349	40213251	1984-02-09	1984-02-09 00:00:00	1984-02-09	1984-02-09 00:00:00	1984-02-09	581452		0	0	0		0	0	0	288409	0	21	40213251		
140096	3077	40213296	1996-07-31	1996-07-31 00:00:00	1996-07-31	1996-07-31 00:00:00	1996-07-31	581452		0	0	0		0	0	0	204731	0	52	40213296		
675	53	1713671	2001-05-31	2001-05-31 00:00:00	2001-06-14	2001-06-14 00:00:00	2001-06-14	38000177		0	0	14		0	0	0	3638	0	562251	1713671		
95393	2091	40213260	2014-11-15	2014-11-15 00:00:00	2014-11-15	2014-11-15 00:00:00	2014-11-15	581452		0	0	0		0	0	0	139491	0	121	40213260		
183289	4026	40213160	1958-05-04	1958-05-04 00:00:00	1958-05-04	1958-05-04 00:00:00	1958-05-04	581452		0	0	0		0	0	0	267748	0	10	40213160		
199484	4382	40213160	1955-06-06	1955-06-06 00:00:00	1955-06-06	1955-06-06 00:00:00	1955-06-06	581452		0	0	0		0	0	0	291234	0	10	40213160		
121611	2673	40213160	1977-07-18	1977-07-18 00:00:00	1977-07-18	1977-07-18 00:00:00	1977-07-18	581452		0	0	0		0	0	0	177118	0	10	40213160		
172594	3793	40213201	2006-03-14	2006-03-14 00:00:00	2006-03-14	2006-03-14 00:00:00	2006-03-14	581452		0	0	0		0	0	0	252225	0	33	40213201		
106609	2337	40213160	1964-03-24	1964-03-24 00:00:00	1964-03-24	1964-03-24 00:00:00	1964-03-24	581452		0	0	0		0	0	0	155494	0	10	40213160		
21357	1756	40165015	2017-07-11	2017-07-11 00:00:00	2017-07-11	2017-07-11 00:00:00	\N	38000177		0	0	0		0	0	0	117446	0	861467	40165015		
207784	4559	40213198	2010-06-29	2010-06-29 00:00:00	2010-06-29	2010-06-29 00:00:00	2010-06-29	581452		0	0	0		0	0	0	303765	0	133	40213198		
182986	4020	40213227	2007-03-08	2007-03-08 00:00:00	2007-03-08	2007-03-08 00:00:00	2007-03-08	581452		0	0	0		0	0	0	267243	0	113	40213227		
46638	3864	1713671	1967-09-02	1967-09-02 00:00:00	1967-09-23	1967-09-23 00:00:00	1967-09-23	38000177		0	0	21		0	0	0	256526	0	562251	1713671		
7335	613	19059056	1937-10-05	1937-10-05 00:00:00	1937-10-19	1937-10-19 00:00:00	1937-10-19	38000177		0	0	14		0	0	0	40751	0	243670	19059056		
104529	2292	40213296	2005-09-09	2005-09-09 00:00:00	2005-09-09	2005-09-09 00:00:00	2005-09-09	581452		0	0	0		0	0	0	152624	0	52	40213296		
53712	4466	1124300	2008-02-09	2008-02-09 00:00:00	2008-02-09	2008-02-09 00:00:00	\N	38000177		0	0	0		0	0	0	297147	0	00781178901	45011828		
156424	3442	40213227	1994-07-03	1994-07-03 00:00:00	1994-07-03	1994-07-03 00:00:00	1994-07-03	581452		0	0	0		0	0	0	228407	0	113	40213227		
197947	4349	40213314	1983-03-10	1983-03-10 00:00:00	1983-03-10	1983-03-10 00:00:00	1983-03-10	581452		0	0	0		0	0	0	288393	0	49	40213314		
140100	3077	40213201	2018-07-04	2018-07-04 00:00:00	2018-07-04	2018-07-04 00:00:00	2018-07-04	581452		0	0	0		0	0	0	204739	0	33	40213201		
676	53	19059056	1967-09-16	1967-09-16 00:00:00	1967-09-30	1967-09-30 00:00:00	1967-09-30	38000177		0	0	14		0	0	0	3699	0	243670	19059056		
95398	2091	40213306	1984-11-17	1984-11-17 00:00:00	1984-11-17	1984-11-17 00:00:00	1984-11-17	581452		0	0	0		0	0	0	\N	0	43	40213306		
183293	4027	40213306	1994-05-07	1994-05-07 00:00:00	1994-05-07	1994-05-07 00:00:00	1994-05-07	581452		0	0	0		0	0	0	267818	0	43	40213306		
199486	4382	40213160	1955-08-29	1955-08-29 00:00:00	1955-08-29	1955-08-29 00:00:00	1955-08-29	581452		0	0	0		0	0	0	\N	0	10	40213160		
121614	2673	40213227	2018-12-03	2018-12-03 00:00:00	2018-12-03	2018-12-03 00:00:00	2018-12-03	581452		0	0	0		0	0	0	177130	0	113	40213227		
172601	3793	40213227	1992-05-19	1992-05-19 00:00:00	1992-05-19	1992-05-19 00:00:00	1992-05-19	581452		0	0	0		0	0	0	252210	0	113	40213227		
106612	2337	40213227	2014-08-19	2014-08-19 00:00:00	2014-08-19	2014-08-19 00:00:00	2014-08-19	581452		0	0	0		0	0	0	155504	0	113	40213227		
21358	1756	1115171	2017-07-11	2017-07-11 00:00:00	2017-10-09	2017-10-09 00:00:00	2017-10-09	38000177		0	0	90		0	0	0	117446	0	849574	1115171		
207787	4559	40213227	2006-06-06	2006-06-06 00:00:00	2006-06-06	2006-06-06 00:00:00	2006-06-06	581452		0	0	0		0	0	0	303763	0	113	40213227		
186205	4090	40213227	2003-05-26	2003-05-26 00:00:00	2003-05-26	2003-05-26 00:00:00	2003-05-26	581452		0	0	0		0	0	0	271899	0	113	40213227		
46639	3864	1127433	1966-11-03	1966-11-03 00:00:00	1966-11-17	1966-11-17 00:00:00	1966-11-17	38000177		0	0	14		0	0	0	256514	0	313782	1127433		
7336	613	19133905	1970-01-03	1970-01-03 00:00:00	1970-01-11	1970-01-11 00:00:00	1970-01-11	38000177		0	0	8		0	0	0	40727	0	834102	19133905		
104531	2292	40213160	1964-04-24	1964-04-24 00:00:00	1964-04-24	1964-04-24 00:00:00	1964-04-24	581452		0	0	0		0	0	0	152628	0	10	40213160		
53713	4466	1127078	1977-07-31	1977-07-31 00:00:00	1977-08-14	1977-08-14 00:00:00	1977-08-14	38000177		0	0	14		0	0	0	297118	0	282464	1127078		
156433	3442	40213227	2002-06-23	2002-06-23 00:00:00	2002-06-23	2002-06-23 00:00:00	2002-06-23	581452		0	0	0		0	0	0	228452	0	113	40213227		
197948	4349	40213160	1983-03-10	1983-03-10 00:00:00	1983-03-10	1983-03-10 00:00:00	1983-03-10	581452		0	0	0		0	0	0	288393	0	10	40213160		
140104	3077	40213227	2013-11-20	2013-11-20 00:00:00	2013-11-20	2013-11-20 00:00:00	2013-11-20	581452		0	0	0		0	0	0	204737	0	113	40213227		
677	53	46233988	1967-09-16	1967-09-16 00:00:00	1967-09-30	1967-09-30 00:00:00	1967-09-30	38000177		0	0	14		0	0	0	3699	0	1652673	46233988		
50785	4220	1118084	1977-04-05	1977-04-05 00:00:00	1977-04-05	1977-04-05 00:00:00	\N	38000177		0	0	0		0	0	0	280166	0	00025152531	44923712		
194575	4275	40213227	2011-08-08	2011-08-08 00:00:00	2011-08-08	2011-08-08 00:00:00	2011-08-08	581452		0	0	0		0	0	0	283712	0	113	40213227		
199493	4382	40213160	1957-12-09	1957-12-09 00:00:00	1957-12-09	1957-12-09 00:00:00	1957-12-09	581452		0	0	0		0	0	0	291247	0	10	40213160		
121615	2673	40213296	2018-12-03	2018-12-03 00:00:00	2018-12-03	2018-12-03 00:00:00	2018-12-03	581452		0	0	0		0	0	0	177130	0	52	40213296		
98092	2149	40213260	2009-04-18	2009-04-18 00:00:00	2009-04-18	2009-04-18 00:00:00	2009-04-18	581452		0	0	0		0	0	0	143116	0	121	40213260		
106613	2337	40213260	2014-08-19	2014-08-19 00:00:00	2014-08-19	2014-08-19 00:00:00	2014-08-19	581452		0	0	0		0	0	0	155504	0	121	40213260		
21364	1758	19128065	1976-08-05	1976-08-05 00:00:00	1977-07-31	1977-07-31 00:00:00	1977-07-31	38000177		0	0	360		0	0	0	117507	0	749882	19128065		
207793	4559	40213227	2016-08-02	2016-08-02 00:00:00	2016-08-02	2016-08-02 00:00:00	2016-08-02	581452		0	0	0		0	0	0	303802	0	113	40213227		
186208	4091	40213306	1990-11-25	1990-11-25 00:00:00	1990-11-25	1990-11-25 00:00:00	1990-11-25	581452		0	0	0		0	0	0	271961	0	43	40213306		
46640	3864	19078461	1978-08-30	1978-08-30 00:00:00	1978-10-04	1978-10-04 00:00:00	1978-10-04	38000177		0	0	35		0	0	0	256525	0	310965	19078461		
7337	613	19133873	1949-08-07	1949-08-07 00:00:00	1949-08-18	1949-08-18 00:00:00	1949-08-18	38000177		0	0	11		0	0	0	40758	0	834061	19133873		
104534	2292	40213160	1968-11-15	1968-11-15 00:00:00	1968-11-15	1968-11-15 00:00:00	1968-11-15	581452		0	0	0		0	0	0	152584	0	10	40213160		
53714	4466	46233988	1977-07-31	1977-07-31 00:00:00	1977-08-14	1977-08-14 00:00:00	1977-08-14	38000177		0	0	14		0	0	0	297118	0	1652673	46233988		
156434	3442	40213296	2002-06-23	2002-06-23 00:00:00	2002-06-23	2002-06-23 00:00:00	2002-06-23	581452		0	0	0		0	0	0	228452	0	52	40213296		
197952	4349	40213227	2014-02-13	2014-02-13 00:00:00	2014-02-13	2014-02-13 00:00:00	2014-02-13	581452		0	0	0		0	0	0	288429	0	113	40213227		
140105	3077	40213260	2006-06-21	2006-06-21 00:00:00	2006-06-21	2006-06-21 00:00:00	2006-06-21	581452		0	0	0		0	0	0	204732	0	121	40213260		
678	53	1127078	1962-12-13	1962-12-13 00:00:00	1962-12-27	1962-12-27 00:00:00	1962-12-27	38000177		0	0	14		0	0	0	3697	0	282464	1127078		
50786	4220	40229134	2012-07-26	2012-07-26 00:00:00	2012-08-09	2012-08-09 00:00:00	2012-08-09	38000177		0	0	14		0	0	0	280203	0	1043400	40229134		
194587	4276	40213227	1994-08-25	1994-08-25 00:00:00	1994-08-25	1994-08-25 00:00:00	1994-08-25	581452		0	0	0		0	0	0	283757	0	113	40213227		
199496	4382	40213227	2004-01-05	2004-01-05 00:00:00	2004-01-05	2004-01-05 00:00:00	2004-01-05	581452		0	0	0		0	0	0	291220	0	113	40213227		
121618	2673	40213314	1978-04-17	1978-04-17 00:00:00	1978-04-17	1978-04-17 00:00:00	1978-04-17	581452		0	0	0		0	0	0	177119	0	49	40213314		
187780	4124	40213227	2015-06-27	2015-06-27 00:00:00	2015-06-27	2015-06-27 00:00:00	2015-06-27	581452		0	0	0		0	0	0	274172	0	113	40213227		
106614	2337	40213260	2013-08-13	2013-08-13 00:00:00	2013-08-13	2013-08-13 00:00:00	2013-08-13	581452		0	0	0		0	0	0	155533	0	121	40213260		
21365	1758	1127433	1973-02-12	1973-02-12 00:00:00	1973-02-26	1973-02-26 00:00:00	1973-02-26	38000177		0	0	14		0	0	0	117556	0	313782	1127433		
38561	841	40213160	1956-01-04	1956-01-04 00:00:00	1956-01-04	1956-01-04 00:00:00	1956-01-04	581452		0	0	0		0	0	0	55552	0	10	40213160		
186213	4091	40213160	1972-11-26	1972-11-26 00:00:00	1972-11-26	1972-11-26 00:00:00	1972-11-26	581452		0	0	0		0	0	0	271973	0	10	40213160		
46641	3864	1127433	2003-05-25	2003-05-25 00:00:00	2003-06-01	2003-06-01 00:00:00	2003-06-01	38000177		0	0	7		0	0	0	256479	0	313782	1127433		
7338	613	40229134	1951-07-25	1951-07-25 00:00:00	1951-08-01	1951-08-01 00:00:00	1951-08-01	38000177		0	0	7		0	0	0	40717	0	1043400	40229134		
115832	2545	40213227	1996-08-22	1996-08-22 00:00:00	1996-08-22	1996-08-22 00:00:00	1996-08-22	581452		0	0	0		0	0	0	168450	0	113	40213227		
238640	5239	40213306	1988-01-27	1988-01-27 00:00:00	1988-01-27	1988-01-27 00:00:00	1988-01-27	581452		0	0	0		0	0	0	348601	0	43	40213306		
156438	3442	40213160	1960-09-18	1960-09-18 00:00:00	1960-09-18	1960-09-18 00:00:00	1960-09-18	581452		0	0	0		0	0	0	228432	0	10	40213160		
140112	3077	40213227	2003-06-04	2003-06-04 00:00:00	2003-06-04	2003-06-04 00:00:00	2003-06-04	581452		0	0	0		0	0	0	204759	0	113	40213227		
679	53	19006318	1962-12-13	1962-12-13 00:00:00	1962-12-27	1962-12-27 00:00:00	1962-12-27	38000177		0	0	14		0	0	0	3697	0	105078	19006318		
50787	4220	40229134	1986-03-09	1986-03-09 00:00:00	1986-03-23	1986-03-23 00:00:00	1986-03-23	38000177		0	0	14		0	0	0	280198	0	1043400	40229134		
181537	3989	40213227	1998-11-23	1998-11-23 00:00:00	1998-11-23	1998-11-23 00:00:00	1998-11-23	581452		0	0	0		0	0	0	265212	0	113	40213227		
199500	4382	40213227	2014-08-04	2014-08-04 00:00:00	2014-08-04	2014-08-04 00:00:00	2014-08-04	581452		0	0	0		0	0	0	291229	0	113	40213227		
121624	2673	40213251	1984-01-30	1984-01-30 00:00:00	1984-01-30	1984-01-30 00:00:00	1984-01-30	581452		0	0	0		0	0	0	177122	0	21	40213251		
187781	4124	40213296	2015-06-27	2015-06-27 00:00:00	2015-06-27	2015-06-27 00:00:00	2015-06-27	581452		0	0	0		0	0	0	274172	0	52	40213296		
106616	2337	40213227	1994-09-27	1994-09-27 00:00:00	1994-09-27	1994-09-27 00:00:00	1994-09-27	581452		0	0	0		0	0	0	155518	0	113	40213227		
21366	1758	1127433	2004-02-01	2004-02-01 00:00:00	2004-02-08	2004-02-08 00:00:00	2004-02-08	38000177		0	0	7		0	0	0	117545	0	313782	1127433		
38566	841	40213160	1955-12-21	1955-12-21 00:00:00	1955-12-21	1955-12-21 00:00:00	1955-12-21	581452		0	0	0		0	0	0	55530	0	10	40213160		
186219	4091	40213227	2018-12-02	2018-12-02 00:00:00	2018-12-02	2018-12-02 00:00:00	2018-12-02	581452		0	0	0		0	0	0	271968	0	113	40213227		
46642	3864	1118084	2007-12-16	2007-12-16 00:00:00	2007-12-16	2007-12-16 00:00:00	\N	38000177		0	0	0		0	0	0	256497	0	00025152531	44923712		
7339	613	1713671	2002-02-12	2002-02-12 00:00:00	2002-03-05	2002-03-05 00:00:00	2002-03-05	38000177		0	0	21		0	0	0	40730	0	562251	1713671		
165560	3639	40213227	2004-01-31	2004-01-31 00:00:00	2004-01-31	2004-01-31 00:00:00	2004-01-31	581452		0	0	0		0	0	0	242079	0	113	40213227		
238643	5239	40213160	1966-03-02	1966-03-02 00:00:00	1966-03-02	1966-03-02 00:00:00	1966-03-02	581452		0	0	0		0	0	0	348594	0	10	40213160		
231451	5085	40213314	1977-11-17	1977-11-17 00:00:00	1977-11-17	1977-11-17 00:00:00	1977-11-17	581452		0	0	0		0	0	0	338102	0	49	40213314		
243054	5335	40213160	1959-04-30	1959-04-30 00:00:00	1959-04-30	1959-04-30 00:00:00	1959-04-30	581452		0	0	0		0	0	0	355318	0	10	40213160		
680	53	1127433	1992-11-06	1992-11-06 00:00:00	1992-11-20	1992-11-20 00:00:00	1992-11-20	38000177		0	0	14		0	0	0	3654	0	313782	1127433		
50788	4220	1127433	1992-03-29	1992-03-29 00:00:00	1992-04-05	1992-04-05 00:00:00	1992-04-05	38000177		0	0	7		0	0	0	280209	0	313782	1127433		
181543	3989	40213227	2019-02-04	2019-02-04 00:00:00	2019-02-04	2019-02-04 00:00:00	2019-02-04	581452		0	0	0		0	0	0	265216	0	113	40213227		
199509	4382	40213198	2018-04-30	2018-04-30 00:00:00	2018-04-30	2018-04-30 00:00:00	2018-04-30	581452		0	0	0		0	0	0	291206	0	133	40213198		
121628	2673	40213227	2010-11-22	2010-11-22 00:00:00	2010-11-22	2010-11-22 00:00:00	2010-11-22	581452		0	0	0		0	0	0	177137	0	113	40213227		
187788	4124	40213160	1972-12-02	1972-12-02 00:00:00	1972-12-02	1972-12-02 00:00:00	1972-12-02	581452		0	0	0		0	0	0	274163	0	10	40213160		
147580	3244	40213160	1978-03-29	1978-03-29 00:00:00	1978-03-29	1978-03-29 00:00:00	1978-03-29	581452		0	0	0		0	0	0	215740	0	10	40213160		
21367	1758	19133873	1974-11-02	1974-11-02 00:00:00	1974-11-13	1974-11-13 00:00:00	1974-11-13	38000177		0	0	11		0	0	0	117504	0	834061	19133873		
38576	842	40213227	1992-06-13	1992-06-13 00:00:00	1992-06-13	1992-06-13 00:00:00	1992-06-13	581452		0	0	0		0	0	0	55670	0	113	40213227		
186220	4091	40213260	2018-12-02	2018-12-02 00:00:00	2018-12-02	2018-12-02 00:00:00	2018-12-02	581452		0	0	0		0	0	0	271968	0	121	40213260		
46643	3864	19059056	1969-03-20	1969-03-20 00:00:00	1969-04-03	1969-04-03 00:00:00	1969-04-03	38000177		0	0	14		0	0	0	256510	0	243670	19059056		
7340	613	1124300	1977-01-23	1977-01-23 00:00:00	1977-01-23	1977-01-23 00:00:00	\N	38000177		0	0	0		0	0	0	40685	0	00781178901	45011828		
165569	3639	40213227	1993-06-05	1993-06-05 00:00:00	1993-06-05	1993-06-05 00:00:00	1993-06-05	581452		0	0	0		0	0	0	242041	0	113	40213227		
238651	5239	40213227	2008-10-08	2008-10-08 00:00:00	2008-10-08	2008-10-08 00:00:00	2008-10-08	581452		0	0	0		0	0	0	348545	0	113	40213227		
231453	5085	40213160	1976-12-16	1976-12-16 00:00:00	1976-12-16	1976-12-16 00:00:00	1976-12-16	581452		0	0	0		0	0	0	338094	0	10	40213160		
243058	5335	40213160	1958-11-27	1958-11-27 00:00:00	1958-11-27	1958-11-27 00:00:00	1958-11-27	581452		0	0	0		0	0	0	355317	0	10	40213160		
681	53	19019979	1974-05-05	1974-05-05 00:00:00	1974-06-04	1974-06-04 00:00:00	1974-06-04	38000177		0	0	30		0	0	0	3633	0	198405	19019979		
50789	4220	19059056	1944-02-18	1944-02-18 00:00:00	1944-03-03	1944-03-03 00:00:00	1944-03-03	38000177		0	0	14		0	0	0	280229	0	243670	19059056		
181546	3989	40213227	2009-01-19	2009-01-19 00:00:00	2009-01-19	2009-01-19 00:00:00	2009-01-19	581452		0	0	0		0	0	0	265190	0	113	40213227		
220406	4837	40213227	2010-11-30	2010-11-30 00:00:00	2010-11-30	2010-11-30 00:00:00	2010-11-30	581452		0	0	0		0	0	0	321800	0	113	40213227		
121639	2673	40213160	1982-01-18	1982-01-18 00:00:00	1982-01-18	1982-01-18 00:00:00	1982-01-18	581452		0	0	0		0	0	0	177121	0	10	40213160		
187790	4124	40213227	2005-06-11	2005-06-11 00:00:00	2005-06-11	2005-06-11 00:00:00	2005-06-11	581452		0	0	0		0	0	0	274191	0	113	40213227		
147584	3244	40213160	1973-12-26	1973-12-26 00:00:00	1973-12-26	1973-12-26 00:00:00	1973-12-26	581452		0	0	0		0	0	0	215681	0	10	40213160		
21368	1758	1127433	2013-01-22	2013-01-22 00:00:00	2013-02-05	2013-02-05 00:00:00	2013-02-05	38000177		0	0	14		0	0	0	117548	0	313782	1127433		
38594	842	40213227	2001-08-04	2001-08-04 00:00:00	2001-08-04	2001-08-04 00:00:00	2001-08-04	581452		0	0	0		0	0	0	55671	0	113	40213227		
186221	4091	40213306	1990-11-18	1990-11-18 00:00:00	1990-11-18	1990-11-18 00:00:00	1990-11-18	581452		0	0	0		0	0	0	\N	0	43	40213306		
46644	3864	19006318	1969-03-20	1969-03-20 00:00:00	1969-04-03	1969-04-03 00:00:00	1969-04-03	38000177		0	0	14		0	0	0	256510	0	105078	19006318		
7341	614	1713671	1991-04-19	1991-04-19 00:00:00	1991-04-26	1991-04-26 00:00:00	1991-04-26	38000177		0	0	7		0	0	0	40858	0	562251	1713671		
176854	3887	40213160	1956-12-03	1956-12-03 00:00:00	1956-12-03	1956-12-03 00:00:00	1956-12-03	581452		0	0	0		0	0	0	258369	0	10	40213160		
238652	5239	40213296	2008-10-08	2008-10-08 00:00:00	2008-10-08	2008-10-08 00:00:00	2008-10-08	581452		0	0	0		0	0	0	348545	0	52	40213296		
231458	5085	40213227	1998-11-12	1998-11-12 00:00:00	1998-11-12	1998-11-12 00:00:00	1998-11-12	581452		0	0	0		0	0	0	338132	0	113	40213227		
241316	5298	40213201	2006-06-25	2006-06-25 00:00:00	2006-06-25	2006-06-25 00:00:00	2006-06-25	581452		0	0	0		0	0	0	352462	0	33	40213201		
682	53	1127433	1976-01-25	1976-01-25 00:00:00	1976-02-29	1976-02-29 00:00:00	1976-02-29	38000177		0	0	35		0	0	0	3634	0	313782	1127433		
50790	4220	19059056	1947-05-22	1947-05-22 00:00:00	1947-06-05	1947-06-05 00:00:00	1947-06-05	38000177		0	0	14		0	0	0	280230	0	243670	19059056		
169968	3736	40213160	1955-11-16	1955-11-16 00:00:00	1955-11-16	1955-11-16 00:00:00	1955-11-16	581452		0	0	0		0	0	0	248280	0	10	40213160		
220410	4837	40213160	1955-12-13	1955-12-13 00:00:00	1955-12-13	1955-12-13 00:00:00	1955-12-13	581452		0	0	0		0	0	0	321786	0	10	40213160		
2253	49	40213160	1977-09-17	1977-09-17 00:00:00	1977-09-17	1977-09-17 00:00:00	1977-09-17	581452		0	0	0		0	0	0	3544	0	10	40213160		
187791	4124	40213160	1972-09-30	1972-09-30 00:00:00	1972-09-30	1972-09-30 00:00:00	1972-09-30	581452		0	0	0		0	0	0	274195	0	10	40213160		
139123	3056	40213160	1957-06-07	1957-06-07 00:00:00	1957-06-07	1957-06-07 00:00:00	1957-06-07	581452		0	0	0		0	0	0	203262	0	10	40213160		
21369	1758	19078461	2000-01-11	2000-01-11 00:00:00	2000-02-15	2000-02-15 00:00:00	2000-02-15	38000177		0	0	35		0	0	0	117558	0	310965	19078461		
234316	5148	40213296	2003-12-22	2003-12-22 00:00:00	2003-12-22	2003-12-22 00:00:00	2003-12-22	581452		0	0	0		0	0	0	342240	0	52	40213296		
186225	4091	40213227	1999-12-05	1999-12-05 00:00:00	1999-12-05	1999-12-05 00:00:00	1999-12-05	581452		0	0	0		0	0	0	271964	0	113	40213227		
46645	3865	1713671	1982-02-01	1982-02-01 00:00:00	1982-02-08	1982-02-08 00:00:00	1982-02-08	38000177		0	0	7		0	0	0	256581	0	562251	1713671		
7342	614	19059056	1970-04-27	1970-04-27 00:00:00	1970-07-26	1970-07-26 00:00:00	1970-07-26	38000177		0	0	90		0	0	0	40847	0	243670	19059056		
176866	3887	40213227	2018-06-11	2018-06-11 00:00:00	2018-06-11	2018-06-11 00:00:00	2018-06-11	581452		0	0	0		0	0	0	258395	0	113	40213227		
238658	5239	40213296	2006-10-04	2006-10-04 00:00:00	2006-10-04	2006-10-04 00:00:00	2006-10-04	581452		0	0	0		0	0	0	348582	0	52	40213296		
231459	5085	40213306	1998-11-12	1998-11-12 00:00:00	1998-11-12	1998-11-12 00:00:00	1998-11-12	581452		0	0	0		0	0	0	338132	0	43	40213306		
241321	5298	40213227	1992-03-08	1992-03-08 00:00:00	1992-03-08	1992-03-08 00:00:00	1992-03-08	581452		0	0	0		0	0	0	352451	0	113	40213227		
683	53	1124300	1999-12-24	1999-12-24 00:00:00	1999-12-24	1999-12-24 00:00:00	\N	38000177		0	0	0		0	0	0	3670	0	00781178901	45011828		
50791	4220	19006318	1947-05-22	1947-05-22 00:00:00	1947-06-05	1947-06-05 00:00:00	1947-06-05	38000177		0	0	14		0	0	0	280230	0	105078	19006318		
83991	1837	40213260	2010-12-17	2010-12-17 00:00:00	2010-12-17	2010-12-17 00:00:00	2010-12-17	581452		0	0	0		0	0	0	122710	0	121	40213260		
220420	4837	40213227	1993-01-05	1993-01-05 00:00:00	1993-01-05	1993-01-05 00:00:00	1993-01-05	581452		0	0	0		0	0	0	321790	0	113	40213227		
2263	49	40213296	2016-07-02	2016-07-02 00:00:00	2016-07-02	2016-07-02 00:00:00	2016-07-02	581452		0	0	0		0	0	0	3557	0	52	40213296		
187799	4124	40213306	1996-06-01	1996-06-01 00:00:00	1996-06-01	1996-06-01 00:00:00	1996-06-01	581452		0	0	0		0	0	0	274171	0	43	40213306		
139148	3057	40213227	1998-03-09	1998-03-09 00:00:00	1998-03-09	1998-03-09 00:00:00	1998-03-09	581452		0	0	0		0	0	0	203404	0	113	40213227		
21370	1758	1127433	1988-06-07	1988-06-07 00:00:00	1988-07-12	1988-07-12 00:00:00	1988-07-12	38000177		0	0	35		0	0	0	117557	0	313782	1127433		
234318	5148	40213227	2001-12-17	2001-12-17 00:00:00	2001-12-17	2001-12-17 00:00:00	2001-12-17	581452		0	0	0		0	0	0	342291	0	113	40213227		
186227	4091	40213227	2009-12-20	2009-12-20 00:00:00	2009-12-20	2009-12-20 00:00:00	2009-12-20	581452		0	0	0		0	0	0	272007	0	113	40213227		
46646	3865	40165015	1969-06-20	1969-06-20 00:00:00	1969-06-20	1969-06-20 00:00:00	\N	38000177		0	0	0		0	0	0	256555	0	861467	40165015		
7343	614	1127433	1986-12-18	1986-12-18 00:00:00	1987-01-08	1987-01-08 00:00:00	1987-01-08	38000177		0	0	21		0	0	0	40850	0	313782	1127433		
176870	3887	40213160	1957-03-04	1957-03-04 00:00:00	1957-03-04	1957-03-04 00:00:00	1957-03-04	581452		0	0	0		0	0	0	258353	0	10	40213160		
238663	5239	40213160	1966-08-03	1966-08-03 00:00:00	1966-08-03	1966-08-03 00:00:00	1966-08-03	581452		0	0	0		0	0	0	348574	0	10	40213160		
231466	5086	40213296	2009-10-01	2009-10-01 00:00:00	2009-10-01	2009-10-01 00:00:00	2009-10-01	581452		0	0	0		0	0	0	338180	0	52	40213296		
241327	5298	40213227	2001-05-27	2001-05-27 00:00:00	2001-05-27	2001-05-27 00:00:00	2001-05-27	581452		0	0	0		0	0	0	352484	0	113	40213227		
684	53	19133873	1967-11-29	1967-11-29 00:00:00	1967-12-09	1967-12-09 00:00:00	1967-12-09	38000177		0	0	10		0	0	0	3660	0	834061	19133873		
50792	4220	19078461	2012-08-10	2012-08-10 00:00:00	2012-11-08	2012-11-08 00:00:00	2012-11-08	38000177		0	0	90		0	0	0	280153	0	310965	19078461		
83992	1837	40213260	2011-12-23	2011-12-23 00:00:00	2011-12-23	2011-12-23 00:00:00	2011-12-23	581452		0	0	0		0	0	0	122696	0	121	40213260		
220431	4837	40213227	1999-12-28	1999-12-28 00:00:00	1999-12-28	1999-12-28 00:00:00	1999-12-28	581452		0	0	0		0	0	0	321791	0	113	40213227		
2270	49	40213160	1973-03-17	1973-03-17 00:00:00	1973-03-17	1973-03-17 00:00:00	1973-03-17	581452		0	0	0		0	0	0	3566	0	10	40213160		
187802	4124	40213160	1973-03-03	1973-03-03 00:00:00	1973-03-03	1973-03-03 00:00:00	1973-03-03	581452		0	0	0		0	0	0	274196	0	10	40213160		
139157	3057	40213201	2003-04-07	2003-04-07 00:00:00	2003-04-07	2003-04-07 00:00:00	2003-04-07	581452		0	0	0		0	0	0	203428	0	33	40213201		
21371	1758	1118084	2002-09-28	2002-09-28 00:00:00	2002-09-28	2002-09-28 00:00:00	\N	38000177		0	0	0		0	0	0	117528	0	00025152531	44923712		
234319	5148	40213296	2001-12-17	2001-12-17 00:00:00	2001-12-17	2001-12-17 00:00:00	2001-12-17	581452		0	0	0		0	0	0	342291	0	52	40213296		
186228	4091	40213296	2009-12-20	2009-12-20 00:00:00	2009-12-20	2009-12-20 00:00:00	2009-12-20	581452		0	0	0		0	0	0	272007	0	52	40213296		
57105	4738	1127433	1922-12-17	1922-12-17 00:00:00	1922-12-24	1922-12-24 00:00:00	1922-12-24	38000177		0	0	7		0	0	0	315621	0	313782	1127433		
7344	614	19059056	1963-10-31	1963-10-31 00:00:00	1963-11-14	1963-11-14 00:00:00	1963-11-14	38000177		0	0	14		0	0	0	40822	0	243670	19059056		
176872	3887	40213227	1997-09-29	1997-09-29 00:00:00	1997-09-29	1997-09-29 00:00:00	1997-09-29	581452		0	0	0		0	0	0	258400	0	113	40213227		
238666	5239	40213160	1966-05-04	1966-05-04 00:00:00	1966-05-04	1966-05-04 00:00:00	1966-05-04	581452		0	0	0		0	0	0	348586	0	10	40213160		
231475	5086	40213160	1970-01-01	1970-01-01 00:00:00	1970-01-01	1970-01-01 00:00:00	1970-01-01	581452		0	0	0		0	0	0	338148	0	10	40213160		
229157	5035	40213201	1996-12-16	1996-12-16 00:00:00	1996-12-16	1996-12-16 00:00:00	1996-12-16	581452		0	0	0		0	0	0	\N	0	33	40213201		
685	53	19059056	1965-05-01	1965-05-01 00:00:00	1965-05-22	1965-05-22 00:00:00	1965-05-22	38000177		0	0	21		0	0	0	3631	0	243670	19059056		
50793	4220	40162522	2012-08-10	2012-08-10 00:00:00	2012-08-10	2012-08-10 00:00:00	\N	38000177		0	0	0		0	0	0	280153	0	857005	40162522		
83994	1837	40213227	2011-12-23	2011-12-23 00:00:00	2011-12-23	2011-12-23 00:00:00	2011-12-23	581452		0	0	0		0	0	0	122696	0	113	40213227		
95504	2094	40213227	2015-06-21	2015-06-21 00:00:00	2015-06-21	2015-06-21 00:00:00	2015-06-21	581452		0	0	0		0	0	0	139600	0	113	40213227		
2272	49	40213227	1995-06-10	1995-06-10 00:00:00	1995-06-10	1995-06-10 00:00:00	1995-06-10	581452		0	0	0		0	0	0	3560	0	113	40213227		
187804	4124	40213296	2013-06-22	2013-06-22 00:00:00	2013-06-22	2013-06-22 00:00:00	2013-06-22	581452		0	0	0		0	0	0	274203	0	52	40213296		
206188	4525	40213260	2018-01-31	2018-01-31 00:00:00	2018-01-31	2018-01-31 00:00:00	2018-01-31	581452		0	0	0		0	0	0	301287	0	121	40213260		
21372	1758	1713671	2016-03-18	2016-03-18 00:00:00	2016-04-08	2016-04-08 00:00:00	2016-04-08	38000177		0	0	21		0	0	0	117549	0	562251	1713671		
234325	5148	40213260	2012-01-16	2012-01-16 00:00:00	2012-01-16	2012-01-16 00:00:00	2012-01-16	581452		0	0	0		0	0	0	342241	0	121	40213260		
186229	4091	40213160	1968-05-05	1968-05-05 00:00:00	1968-05-05	1968-05-05 00:00:00	1968-05-05	581452		0	0	0		0	0	0	271953	0	10	40213160		
57106	4738	40236824	1937-11-11	1937-11-11 00:00:00	1937-11-25	1937-11-25 00:00:00	1937-11-25	38000177		0	0	14		0	0	0	315645	0	1094107	40236824		
7345	614	1127433	1990-12-09	1990-12-09 00:00:00	1990-12-16	1990-12-16 00:00:00	1990-12-16	38000177		0	0	7		0	0	0	40857	0	313782	1127433		
176873	3887	40213296	1997-09-29	1997-09-29 00:00:00	1997-09-29	1997-09-29 00:00:00	1997-09-29	581452		0	0	0		0	0	0	258400	0	52	40213296		
238671	5239	40213260	2016-11-30	2016-11-30 00:00:00	2016-11-30	2016-11-30 00:00:00	2016-11-30	581452		0	0	0		0	0	0	348546	0	121	40213260		
231476	5086	40213227	2011-10-06	2011-10-06 00:00:00	2011-10-06	2011-10-06 00:00:00	2011-10-06	581452		0	0	0		0	0	0	338175	0	113	40213227		
229165	5035	40213227	2011-08-15	2011-08-15 00:00:00	2011-08-15	2011-08-15 00:00:00	2011-08-15	581452		0	0	0		0	0	0	334646	0	113	40213227		
706	57	19059056	1982-12-31	1982-12-31 00:00:00	1983-01-21	1983-01-21 00:00:00	1983-01-21	38000177		0	0	21		0	0	0	3821	0	243670	19059056		
50794	4220	1127433	1962-01-16	1962-01-16 00:00:00	1962-01-23	1962-01-23 00:00:00	1962-01-23	38000177		0	0	7		0	0	0	280185	0	313782	1127433		
83998	1837	40213160	1965-01-15	1965-01-15 00:00:00	1965-01-15	1965-01-15 00:00:00	1965-01-15	581452		0	0	0		0	0	0	122741	0	10	40213160		
198882	4370	40213160	1959-02-25	1959-02-25 00:00:00	1959-02-25	1959-02-25 00:00:00	1959-02-25	581452		0	0	0		0	0	0	290130	0	10	40213160		
2273	49	40213306	1995-06-10	1995-06-10 00:00:00	1995-06-10	1995-06-10 00:00:00	1995-06-10	581452		0	0	0		0	0	0	3560	0	43	40213306		
187806	4125	40213160	1972-08-29	1972-08-29 00:00:00	1972-08-29	1972-08-29 00:00:00	1972-08-29	581452		0	0	0		0	0	0	274235	0	10	40213160		
206196	4525	40213160	1968-10-09	1968-10-09 00:00:00	1968-10-09	1968-10-09 00:00:00	1968-10-09	581452		0	0	0		0	0	0	301306	0	10	40213160		
21373	1758	19059056	1962-11-07	1962-11-07 00:00:00	1962-11-21	1962-11-21 00:00:00	1962-11-21	38000177		0	0	14		0	0	0	117559	0	243670	19059056		
234327	5148	40213227	2012-01-16	2012-01-16 00:00:00	2012-01-16	2012-01-16 00:00:00	2012-01-16	581452		0	0	0		0	0	0	342241	0	113	40213227		
186233	4091	40213260	2017-11-26	2017-11-26 00:00:00	2017-11-26	2017-11-26 00:00:00	2017-11-26	581452		0	0	0		0	0	0	271984	0	121	40213260		
57107	4738	920300	1937-11-11	1937-11-11 00:00:00	1937-11-18	1937-11-18 00:00:00	1937-11-18	38000177		0	0	7		0	0	0	315645	0	311989	920300		
7346	614	19059056	1964-06-05	1964-06-05 00:00:00	1964-06-19	1964-06-19 00:00:00	1964-06-19	38000177		0	0	14		0	0	0	40823	0	243670	19059056		
53365	1169	40213227	2007-08-13	2007-08-13 00:00:00	2007-08-13	2007-08-13 00:00:00	2007-08-13	581452		0	0	0		0	0	0	77055	0	113	40213227		
238673	5239	40213227	2016-11-30	2016-11-30 00:00:00	2016-11-30	2016-11-30 00:00:00	2016-11-30	581452		0	0	0		0	0	0	348546	0	113	40213227		
231477	5086	40213296	2011-10-06	2011-10-06 00:00:00	2011-10-06	2011-10-06 00:00:00	2011-10-06	581452		0	0	0		0	0	0	338175	0	52	40213296		
222498	4884	40213160	1973-03-31	1973-03-31 00:00:00	1973-03-31	1973-03-31 00:00:00	1973-03-31	581452		0	0	0		0	0	0	324813	0	10	40213160		
707	57	40229134	1982-01-01	1982-01-01 00:00:00	1982-01-08	1982-01-08 00:00:00	1982-01-08	38000177		0	0	7		0	0	0	3824	0	1043400	40229134		
50795	4220	1127433	1995-01-21	1995-01-21 00:00:00	1995-01-28	1995-01-28 00:00:00	1995-01-28	38000177		0	0	7		0	0	0	280223	0	313782	1127433		
84002	1837	40213306	1983-01-28	1983-01-28 00:00:00	1983-01-28	1983-01-28 00:00:00	1983-01-28	581452		0	0	0		0	0	0	122747	0	43	40213306		
198892	4370	40213260	2009-11-25	2009-11-25 00:00:00	2009-11-25	2009-11-25 00:00:00	2009-11-25	581452		0	0	0		0	0	0	290098	0	121	40213260		
161240	3547	40213227	2001-09-24	2001-09-24 00:00:00	2001-09-24	2001-09-24 00:00:00	2001-09-24	581452		0	0	0		0	0	0	235551	0	113	40213227		
187807	4125	40213296	2007-09-25	2007-09-25 00:00:00	2007-09-25	2007-09-25 00:00:00	2007-09-25	581452		0	0	0		0	0	0	274242	0	52	40213296		
206202	4525	40213260	2019-02-06	2019-02-06 00:00:00	2019-02-06	2019-02-06 00:00:00	2019-02-06	581452		0	0	0		0	0	0	301279	0	121	40213260		
21374	1758	19006318	1962-11-07	1962-11-07 00:00:00	1962-11-21	1962-11-21 00:00:00	1962-11-21	38000177		0	0	14		0	0	0	117559	0	105078	19006318		
234331	5148	40213160	1960-07-26	1960-07-26 00:00:00	1960-07-26	1960-07-26 00:00:00	1960-07-26	581452		0	0	0		0	0	0	342251	0	10	40213160		
150939	3320	40213160	1968-03-24	1968-03-24 00:00:00	1968-03-24	1968-03-24 00:00:00	1968-03-24	581452		0	0	0		0	0	0	220450	0	10	40213160		
57108	4738	1124300	1944-12-27	1944-12-27 00:00:00	1944-12-27	1944-12-27 00:00:00	\N	38000177		0	0	0		0	0	0	315659	0	00781178901	45011828		
7347	614	19006318	1964-06-05	1964-06-05 00:00:00	1964-06-19	1964-06-19 00:00:00	1964-06-19	38000177		0	0	14		0	0	0	40823	0	105078	19006318		
53380	1169	40213227	1997-06-16	1997-06-16 00:00:00	1997-06-16	1997-06-16 00:00:00	1997-06-16	581452		0	0	0		0	0	0	77000	0	113	40213227		
238676	5239	40213260	2015-11-25	2015-11-25 00:00:00	2015-11-25	2015-11-25 00:00:00	2015-11-25	581452		0	0	0		0	0	0	348554	0	121	40213260		
231480	5086	40213160	1970-06-04	1970-06-04 00:00:00	1970-06-04	1970-06-04 00:00:00	1970-06-04	581452		0	0	0		0	0	0	338149	0	10	40213160		
222499	4884	40213160	1977-10-22	1977-10-22 00:00:00	1977-10-22	1977-10-22 00:00:00	1977-10-22	581452		0	0	0		0	0	0	324764	0	10	40213160		
708	57	1127433	1986-07-31	1986-07-31 00:00:00	1986-08-14	1986-08-14 00:00:00	1986-08-14	38000177		0	0	14		0	0	0	3868	0	313782	1127433		
50796	4220	1127433	1995-04-21	1995-04-21 00:00:00	1995-05-12	1995-05-12 00:00:00	1995-05-12	38000177		0	0	21		0	0	0	280152	0	313782	1127433		
183602	4033	40213306	1991-12-16	1991-12-16 00:00:00	1991-12-16	1991-12-16 00:00:00	1991-12-16	581452		0	0	0		0	0	0	268306	0	43	40213306		
198894	4370	40213227	2009-11-25	2009-11-25 00:00:00	2009-11-25	2009-11-25 00:00:00	2009-11-25	581452		0	0	0		0	0	0	290098	0	113	40213227		
101520	2226	40213201	2008-05-02	2008-05-02 00:00:00	2008-05-02	2008-05-02 00:00:00	2008-05-02	581452		0	0	0		0	0	0	148131	0	33	40213201		
187814	4125	40213160	1968-02-27	1968-02-27 00:00:00	1968-02-27	1968-02-27 00:00:00	1968-02-27	581452		0	0	0		0	0	0	274232	0	10	40213160		
206203	4525	40213227	2019-02-06	2019-02-06 00:00:00	2019-02-06	2019-02-06 00:00:00	2019-02-06	581452		0	0	0		0	0	0	301279	0	113	40213227		
21375	1758	40236824	2008-09-04	2008-09-04 00:00:00	2008-09-11	2008-09-11 00:00:00	2008-09-11	38000177		0	0	7		0	0	0	117547	0	1094107	40236824		
234335	5148	40213306	1982-05-25	1982-05-25 00:00:00	1982-05-25	1982-05-25 00:00:00	1982-05-25	581452		0	0	0		0	0	0	342286	0	43	40213306		
150946	3320	40213296	2003-08-31	2003-08-31 00:00:00	2003-08-31	2003-08-31 00:00:00	2003-08-31	581452		0	0	0		0	0	0	220475	0	52	40213296		
175447	3857	40213227	2015-07-14	2015-07-14 00:00:00	2015-07-14	2015-07-14 00:00:00	2015-07-14	581452		0	0	0		0	0	0	255999	0	113	40213227		
7348	614	19078461	1981-04-20	1981-04-20 00:00:00	1981-05-18	1981-05-18 00:00:00	1981-05-18	38000177		0	0	28		0	0	0	40849	0	310965	19078461		
50648	1110	40213251	1987-02-23	1987-02-23 00:00:00	1987-02-23	1987-02-23 00:00:00	1987-02-23	581452		0	0	0		0	0	0	73131	0	21	40213251		
62496	1367	40213227	1996-07-12	1996-07-12 00:00:00	1996-07-12	1996-07-12 00:00:00	1996-07-12	581452		0	0	0		0	0	0	90615	0	113	40213227		
231488	5086	40213160	1974-09-05	1974-09-05 00:00:00	1974-09-05	1974-09-05 00:00:00	1974-09-05	581452		0	0	0		0	0	0	338191	0	10	40213160		
222505	4884	40213160	1973-06-30	1973-06-30 00:00:00	1973-06-30	1973-06-30 00:00:00	1973-06-30	581452		0	0	0		0	0	0	324761	0	10	40213160		
709	57	1127433	1982-07-09	1982-07-09 00:00:00	1982-07-23	1982-07-23 00:00:00	1982-07-23	38000177		0	0	14		0	0	0	3849	0	313782	1127433		
61255	5096	19128065	1988-03-03	1988-03-03 00:00:00	1989-02-26	1989-02-26 00:00:00	1989-02-26	38000177		0	0	360		0	0	0	338605	0	749882	19128065		
183613	4033	40213160	1970-01-19	1970-01-19 00:00:00	1970-01-19	1970-01-19 00:00:00	1970-01-19	581452		0	0	0		0	0	0	268374	0	10	40213160		
198900	4370	40213296	1998-11-25	1998-11-25 00:00:00	1998-11-25	1998-11-25 00:00:00	1998-11-25	581452		0	0	0		0	0	0	290137	0	52	40213296		
101524	2226	40213227	1993-04-02	1993-04-02 00:00:00	1993-04-02	1993-04-02 00:00:00	1993-04-02	581452		0	0	0		0	0	0	148112	0	113	40213227		
187815	4125	40213260	2017-09-19	2017-09-19 00:00:00	2017-09-19	2017-09-19 00:00:00	2017-09-19	581452		0	0	0		0	0	0	274244	0	121	40213260		
206206	4525	40213160	1968-05-08	1968-05-08 00:00:00	1968-05-08	1968-05-08 00:00:00	1968-05-08	581452		0	0	0		0	0	0	301264	0	10	40213160		
21376	1758	920300	2008-09-04	2008-09-04 00:00:00	2008-09-11	2008-09-11 00:00:00	2008-09-11	38000177		0	0	7		0	0	0	117547	0	311989	920300		
234338	5148	40213160	1960-10-25	1960-10-25 00:00:00	1960-10-25	1960-10-25 00:00:00	1960-10-25	581452		0	0	0		0	0	0	342269	0	10	40213160		
150951	3320	40213160	1963-12-01	1963-12-01 00:00:00	1963-12-01	1963-12-01 00:00:00	1963-12-01	581452		0	0	0		0	0	0	220460	0	10	40213160		
175452	3857	40213227	1995-01-10	1995-01-10 00:00:00	1995-01-10	1995-01-10 00:00:00	1995-01-10	581452		0	0	0		0	0	0	256055	0	113	40213227		
7349	614	19059056	1968-05-07	1968-05-07 00:00:00	1968-06-06	1968-06-06 00:00:00	1968-06-06	38000177		0	0	30		0	0	0	40846	0	243670	19059056		
50651	1110	40213160	1987-02-23	1987-02-23 00:00:00	1987-02-23	1987-02-23 00:00:00	1987-02-23	581452		0	0	0		0	0	0	73131	0	10	40213160		
62498	1367	40213227	2016-10-21	2016-10-21 00:00:00	2016-10-21	2016-10-21 00:00:00	2016-10-21	581452		0	0	0		0	0	0	90647	0	113	40213227		
231493	5086	40213227	2000-12-07	2000-12-07 00:00:00	2000-12-07	2000-12-07 00:00:00	2000-12-07	581452		0	0	0		0	0	0	338177	0	113	40213227		
222512	4884	40213227	1995-04-08	1995-04-08 00:00:00	1995-04-08	1995-04-08 00:00:00	1995-04-08	581452		0	0	0		0	0	0	324791	0	113	40213227		
710	57	1115171	2007-01-15	2007-01-15 00:00:00	2007-01-29	2007-01-29 00:00:00	2007-01-29	38000177		0	0	14		0	0	0	3890	0	849574	1115171		
61256	5096	40229134	1993-11-07	1993-11-07 00:00:00	1993-11-21	1993-11-21 00:00:00	1993-11-21	38000177		0	0	14		0	0	0	338586	0	1043400	40229134		
176095	3871	40213160	1962-12-19	1962-12-19 00:00:00	1962-12-19	1962-12-19 00:00:00	1962-12-19	581452		0	0	0		0	0	0	257060	0	10	40213160		
198906	4370	40213160	1959-07-29	1959-07-29 00:00:00	1959-07-29	1959-07-29 00:00:00	1959-07-29	581452		0	0	0		0	0	0	290131	0	10	40213160		
101531	2226	40213227	2013-05-31	2013-05-31 00:00:00	2013-05-31	2013-05-31 00:00:00	2013-05-31	581452		0	0	0		0	0	0	148115	0	113	40213227		
101563	2226	40213227	2003-04-04	2003-04-04 00:00:00	2003-04-04	2003-04-04 00:00:00	2003-04-04	581452		0	0	0		0	0	0	148081	0	113	40213227		
217486	4773	40213306	1981-01-01	1981-01-01 00:00:00	1981-01-01	1981-01-01 00:00:00	1981-01-01	581452		0	0	0		0	0	0	317880	0	43	40213306		
21377	1759	1127433	2001-09-25	2001-09-25 00:00:00	2001-10-02	2001-10-02 00:00:00	2001-10-02	38000177		0	0	7		0	0	0	117606	0	313782	1127433		
234343	5148	40213160	1965-01-25	1965-01-25 00:00:00	1965-01-25	1965-01-25 00:00:00	1965-01-25	581452		0	0	0		0	0	0	342255	0	10	40213160		
150953	3320	40213227	2005-09-04	2005-09-04 00:00:00	2005-09-04	2005-09-04 00:00:00	2005-09-04	581452		0	0	0		0	0	0	220482	0	113	40213227		
175459	3857	40213227	2005-08-16	2005-08-16 00:00:00	2005-08-16	2005-08-16 00:00:00	2005-08-16	581452		0	0	0		0	0	0	256002	0	113	40213227		
7350	614	19059056	1971-08-20	1971-08-20 00:00:00	1971-09-10	1971-09-10 00:00:00	1971-09-10	38000177		0	0	21		0	0	0	40848	0	243670	19059056		
50653	1110	40213160	1982-08-23	1982-08-23 00:00:00	1982-08-23	1982-08-23 00:00:00	1982-08-23	581452		0	0	0		0	0	0	73080	0	10	40213160		
62499	1367	40213260	2016-10-21	2016-10-21 00:00:00	2016-10-21	2016-10-21 00:00:00	2016-10-21	581452		0	0	0		0	0	0	90647	0	121	40213260		
86667	1900	40213306	1986-02-03	1986-02-03 00:00:00	1986-02-03	1986-02-03 00:00:00	1986-02-03	581452		0	0	0		0	0	0	126502	0	43	40213306		
222513	4884	40213306	1995-04-08	1995-04-08 00:00:00	1995-04-08	1995-04-08 00:00:00	1995-04-08	581452		0	0	0		0	0	0	324791	0	43	40213306		
711	57	19078461	1976-08-13	1976-08-13 00:00:00	1976-09-03	1976-09-03 00:00:00	1976-09-03	38000177		0	0	21		0	0	0	3820	0	310965	19078461		
61257	5096	1124300	2008-08-20	2008-08-20 00:00:00	2008-08-20	2008-08-20 00:00:00	\N	38000177		0	0	0		0	0	0	338623	0	00781178901	45011828		
176097	3871	40213296	2004-09-22	2004-09-22 00:00:00	2004-09-22	2004-09-22 00:00:00	2004-09-22	581452		0	0	0		0	0	0	257014	0	52	40213296		
198909	4370	40213260	2008-11-19	2008-11-19 00:00:00	2008-11-19	2008-11-19 00:00:00	2008-11-19	581452		0	0	0		0	0	0	290110	0	121	40213260		
101544	2226	40213198	2010-05-14	2010-05-14 00:00:00	2010-05-14	2010-05-14 00:00:00	2010-05-14	581452		0	0	0		0	0	0	148167	0	133	40213198		
110556	2428	40213227	1996-08-27	1996-08-27 00:00:00	1996-08-27	1996-08-27 00:00:00	1996-08-27	581452		0	0	0		0	0	0	161118	0	113	40213227		
217488	4773	40213260	2008-12-25	2008-12-25 00:00:00	2008-12-25	2008-12-25 00:00:00	2008-12-25	581452		0	0	0		0	0	0	317887	0	121	40213260		
21378	1759	19129144	2006-11-16	2006-11-16 00:00:00	2007-11-11	2007-11-11 00:00:00	2007-11-11	38000177		0	0	360		0	0	0	117582	0	757594	19129144		
15310	1280	1127433	1976-03-04	1976-03-04 00:00:00	1976-04-03	1976-04-03 00:00:00	1976-04-03	38000177		0	0	30		0	0	0	84571	0	313782	1127433		
150955	3320	40213296	2005-09-04	2005-09-04 00:00:00	2005-09-04	2005-09-04 00:00:00	2005-09-04	581452		0	0	0		0	0	0	220482	0	52	40213296		
136	3	40213201	1983-04-11	1983-04-11 00:00:00	1983-04-11	1983-04-11 00:00:00	1983-04-11	581452		0	0	0		0	0	0	289	0	33	40213201		
7351	614	1127433	1992-05-11	1992-05-11 00:00:00	1992-06-08	1992-06-08 00:00:00	1992-06-08	38000177		0	0	28		0	0	0	40852	0	313782	1127433		
50654	1110	40213314	1982-08-23	1982-08-23 00:00:00	1982-08-23	1982-08-23 00:00:00	1982-08-23	581452		0	0	0		0	0	0	73080	0	49	40213314		
62502	1367	40213306	1987-07-03	1987-07-03 00:00:00	1987-07-03	1987-07-03 00:00:00	1987-07-03	581452		0	0	0		0	0	0	90654	0	43	40213306		
212888	4668	40213260	2007-01-23	2007-01-23 00:00:00	2007-01-23	2007-01-23 00:00:00	2007-01-23	581452		0	0	0		0	0	0	311064	0	121	40213260		
222522	4884	40213227	2014-11-01	2014-11-01 00:00:00	2014-11-01	2014-11-01 00:00:00	2014-11-01	581452		0	0	0		0	0	0	324725	0	113	40213227		
712	57	19059056	1971-02-27	1971-02-27 00:00:00	1971-03-13	1971-03-13 00:00:00	1971-03-13	38000177		0	0	14		0	0	0	3819	0	243670	19059056		
61258	5096	1127433	1971-03-25	1971-03-25 00:00:00	1971-04-08	1971-04-08 00:00:00	1971-04-08	38000177		0	0	14		0	0	0	338581	0	313782	1127433		
176099	3871	40213227	2004-09-22	2004-09-22 00:00:00	2004-09-22	2004-09-22 00:00:00	2004-09-22	581452		0	0	0		0	0	0	257014	0	113	40213227		
198911	4370	40213227	1993-05-26	1993-05-26 00:00:00	1993-05-26	1993-05-26 00:00:00	1993-05-26	581452		0	0	0		0	0	0	290135	0	113	40213227		
176472	3879	40213227	2011-04-14	2011-04-14 00:00:00	2011-04-14	2011-04-14 00:00:00	2011-04-14	581452		0	0	0		0	0	0	257679	0	113	40213227		
110557	2428	40213306	1996-08-27	1996-08-27 00:00:00	1996-08-27	1996-08-27 00:00:00	1996-08-27	581452		0	0	0		0	0	0	161118	0	43	40213306		
217496	4773	40213227	1993-01-14	1993-01-14 00:00:00	1993-01-14	1993-01-14 00:00:00	1993-01-14	581452		0	0	0		0	0	0	317884	0	113	40213227		
21379	1759	1127078	1993-02-17	1993-02-17 00:00:00	1993-03-10	1993-03-10 00:00:00	1993-03-10	38000177		0	0	21		0	0	0	117599	0	282464	1127078		
15311	1280	40165015	1976-03-04	1976-03-04 00:00:00	1976-03-04	1976-03-04 00:00:00	\N	38000177		0	0	0		0	0	0	84571	0	861467	40165015		
150956	3320	40213306	1985-12-29	1985-12-29 00:00:00	1985-12-29	1985-12-29 00:00:00	1985-12-29	581452		0	0	0		0	0	0	220480	0	43	40213306		
148	3	40213227	2007-08-27	2007-08-27 00:00:00	2007-08-27	2007-08-27 00:00:00	2007-08-27	581452		0	0	0		0	0	0	310	0	113	40213227		
7352	614	1127433	1994-05-31	1994-05-31 00:00:00	1994-06-07	1994-06-07 00:00:00	1994-06-07	38000177		0	0	7		0	0	0	40859	0	313782	1127433		
208000	4562	40213227	2002-03-30	2002-03-30 00:00:00	2002-03-30	2002-03-30 00:00:00	2002-03-30	581452		0	0	0		0	0	0	304062	0	113	40213227		
62509	1367	40213260	2015-10-16	2015-10-16 00:00:00	2015-10-16	2015-10-16 00:00:00	2015-10-16	581452		0	0	0		0	0	0	90592	0	121	40213260		
212893	4668	40213296	1996-06-25	1996-06-25 00:00:00	1996-06-25	1996-06-25 00:00:00	1996-06-25	581452		0	0	0		0	0	0	311048	0	52	40213296		
222523	4884	40213296	2014-11-01	2014-11-01 00:00:00	2014-11-01	2014-11-01 00:00:00	2014-11-01	581452		0	0	0		0	0	0	324725	0	52	40213296		
713	57	1127433	2013-02-24	2013-02-24 00:00:00	2013-03-10	2013-03-10 00:00:00	2013-03-10	38000177		0	0	14		0	0	0	3852	0	313782	1127433		
61259	5097	1713671	1993-10-01	1993-10-01 00:00:00	1993-10-15	1993-10-15 00:00:00	1993-10-15	38000177		0	0	14		0	0	0	338677	0	562251	1713671		
176104	3871	40213160	1967-08-23	1967-08-23 00:00:00	1967-08-23	1967-08-23 00:00:00	1967-08-23	581452		0	0	0		0	0	0	257043	0	10	40213160		
198913	4370	40213296	2000-11-29	2000-11-29 00:00:00	2000-11-29	2000-11-29 00:00:00	2000-11-29	581452		0	0	0		0	0	0	290115	0	52	40213296		
176479	3879	40213227	1992-12-31	1992-12-31 00:00:00	1992-12-31	1992-12-31 00:00:00	1992-12-31	581452		0	0	0		0	0	0	257682	0	113	40213227		
110562	2428	40213160	1979-06-05	1979-06-05 00:00:00	1979-06-05	1979-06-05 00:00:00	1979-06-05	581452		0	0	0		0	0	0	161114	0	10	40213160		
217498	4773	40213227	2009-12-31	2009-12-31 00:00:00	2009-12-31	2009-12-31 00:00:00	2009-12-31	581452		0	0	0		0	0	0	317919	0	113	40213227		
21380	1759	1127433	1993-12-16	1993-12-16 00:00:00	1993-12-23	1993-12-23 00:00:00	1993-12-23	38000177		0	0	7		0	0	0	117605	0	313782	1127433		
15312	1280	1127433	1970-06-04	1970-06-04 00:00:00	1970-06-18	1970-06-18 00:00:00	1970-06-18	38000177		0	0	14		0	0	0	84615	0	313782	1127433		
150960	3320	40213260	2013-08-25	2013-08-25 00:00:00	2013-08-25	2013-08-25 00:00:00	2013-08-25	581452		0	0	0		0	0	0	220477	0	121	40213260		
234416	5150	40213227	1992-08-27	1992-08-27 00:00:00	1992-08-27	1992-08-27 00:00:00	1992-08-27	581452		0	0	0		0	0	0	342340	0	113	40213227		
7353	614	1124300	2000-06-08	2000-06-08 00:00:00	2000-06-08	2000-06-08 00:00:00	\N	38000177		0	0	0		0	0	0	40821	0	00781178901	45011828		
208007	4563	40213160	1968-11-22	1968-11-22 00:00:00	1968-11-22	1968-11-22 00:00:00	1968-11-22	581452		0	0	0		0	0	0	304135	0	10	40213160		
62512	1367	40213296	2006-06-23	2006-06-23 00:00:00	2006-06-23	2006-06-23 00:00:00	2006-06-23	581452		0	0	0		0	0	0	90627	0	52	40213296		
212894	4668	40213227	1996-06-25	1996-06-25 00:00:00	1996-06-25	1996-06-25 00:00:00	1996-06-25	581452		0	0	0		0	0	0	311048	0	113	40213227		
220648	4843	40213160	1966-09-20	1966-09-20 00:00:00	1966-09-20	1966-09-20 00:00:00	1966-09-20	581452		0	0	0		0	0	0	322140	0	10	40213160		
714	57	1118084	1997-04-01	1997-04-01 00:00:00	1997-04-01	1997-04-01 00:00:00	\N	38000177		0	0	0		0	0	0	3838	0	00025152531	44923712		
61260	5097	19008572	1992-07-02	1992-07-02 00:00:00	1992-07-02	1992-07-02 00:00:00	\N	38000177		0	0	0		0	0	0	338657	0	106258	19008572		
176109	3871	40213227	2013-09-18	2013-09-18 00:00:00	2013-09-18	2013-09-18 00:00:00	2013-09-18	581452		0	0	0		0	0	0	257029	0	113	40213227		
198915	4370	40213227	2000-11-29	2000-11-29 00:00:00	2000-11-29	2000-11-29 00:00:00	2000-11-29	581452		0	0	0		0	0	0	290115	0	113	40213227		
187773	4124	40213160	1977-05-28	1977-05-28 00:00:00	1977-05-28	1977-05-28 00:00:00	1977-05-28	581452		0	0	0		0	0	0	274159	0	10	40213160		
15622	337	40213160	1959-12-30	1959-12-30 00:00:00	1959-12-30	1959-12-30 00:00:00	1959-12-30	581452		0	0	0		0	0	0	22435	0	10	40213160		
217499	4773	40213260	2009-12-31	2009-12-31 00:00:00	2009-12-31	2009-12-31 00:00:00	2009-12-31	581452		0	0	0		0	0	0	317919	0	121	40213260		
21381	1759	1127433	2006-01-29	2006-01-29 00:00:00	2006-02-05	2006-02-05 00:00:00	2006-02-05	38000177		0	0	7		0	0	0	117576	0	313782	1127433		
15313	1280	1127433	1975-03-05	1975-03-05 00:00:00	1975-04-02	1975-04-02 00:00:00	1975-04-02	38000177		0	0	28		0	0	0	84526	0	313782	1127433		
137901	3028	40213160	1964-04-02	1964-04-02 00:00:00	1964-04-02	1964-04-02 00:00:00	1964-04-02	581452		0	0	0		0	0	0	201920	0	10	40213160		
234433	5150	40213227	2000-10-05	2000-10-05 00:00:00	2000-10-05	2000-10-05 00:00:00	2000-10-05	581452		0	0	0		0	0	0	342386	0	113	40213227		
7354	615	19059056	1944-11-19	1944-11-19 00:00:00	1944-12-17	1944-12-17 00:00:00	1944-12-17	38000177		0	0	28		0	0	0	41041	0	243670	19059056		
208009	4563	40213296	2005-12-23	2005-12-23 00:00:00	2005-12-23	2005-12-23 00:00:00	2005-12-23	581452		0	0	0		0	0	0	304089	0	52	40213296		
62514	1367	40213227	2006-06-23	2006-06-23 00:00:00	2006-06-23	2006-06-23 00:00:00	2006-06-23	581452		0	0	0		0	0	0	90627	0	113	40213227		
212899	4668	40213296	1998-06-30	1998-06-30 00:00:00	1998-06-30	1998-06-30 00:00:00	1998-06-30	581452		0	0	0		0	0	0	311108	0	52	40213296		
220657	4843	40213227	1993-05-25	1993-05-25 00:00:00	1993-05-25	1993-05-25 00:00:00	1993-05-25	581452		0	0	0		0	0	0	322167	0	113	40213227		
715	57	40229134	1992-02-19	1992-02-19 00:00:00	1992-02-26	1992-02-26 00:00:00	1992-02-26	38000177		0	0	7		0	0	0	3850	0	1043400	40229134		
61261	5097	1594382	1992-07-19	1992-07-19 00:00:00	1992-07-19	1992-07-19 00:00:00	\N	38000177		0	0	0		0	0	0	338637	0	1870230	1594382		
176110	3871	40213260	2013-09-18	2013-09-18 00:00:00	2013-09-18	2013-09-18 00:00:00	2013-09-18	581452		0	0	0		0	0	0	257029	0	121	40213260		
198916	4370	40213160	1963-10-30	1963-10-30 00:00:00	1963-10-30	1963-10-30 00:00:00	1963-10-30	581452		0	0	0		0	0	0	290092	0	10	40213160		
110511	2427	40213227	1993-01-19	1993-01-19 00:00:00	1993-01-19	1993-01-19 00:00:00	1993-01-19	581452		0	0	0		0	0	0	161023	0	113	40213227		
15623	337	40213160	1960-03-02	1960-03-02 00:00:00	1960-03-02	1960-03-02 00:00:00	1960-03-02	581452		0	0	0		0	0	0	22461	0	10	40213160		
217502	4773	40213296	1998-12-31	1998-12-31 00:00:00	1998-12-31	1998-12-31 00:00:00	1998-12-31	581452		0	0	0		0	0	0	317885	0	52	40213296		
21382	1759	19073183	1986-01-25	1986-01-25 00:00:00	1986-02-08	1986-02-08 00:00:00	1986-02-08	38000177		0	0	14		0	0	0	117609	0	308182	19073183		
15314	1280	19019273	1994-06-23	1994-06-23 00:00:00	1998-12-29	1998-12-29 00:00:00	1998-12-29	38000177		0	0	1650		0	0	0	84546	0	198014	19019273		
137906	3028	40213160	1959-07-30	1959-07-30 00:00:00	1959-07-30	1959-07-30 00:00:00	1959-07-30	581452		0	0	0		0	0	0	201898	0	10	40213160		
234445	5150	40213227	2010-12-02	2010-12-02 00:00:00	2010-12-02	2010-12-02 00:00:00	2010-12-02	581452		0	0	0		0	0	0	342457	0	113	40213227		
7355	615	1713671	1917-07-19	1917-07-19 00:00:00	1917-07-26	1917-07-26 00:00:00	1917-07-26	38000177		0	0	7		0	0	0	40864	0	562251	1713671		
208011	4563	40213227	2005-12-23	2005-12-23 00:00:00	2005-12-23	2005-12-23 00:00:00	2005-12-23	581452		0	0	0		0	0	0	304089	0	113	40213227		
62520	1367	40213160	1970-04-10	1970-04-10 00:00:00	1970-04-10	1970-04-10 00:00:00	1970-04-10	581452		0	0	0		0	0	0	90639	0	10	40213160		
212905	4668	40213227	2006-01-17	2006-01-17 00:00:00	2006-01-17	2006-01-17 00:00:00	2006-01-17	581452		0	0	0		0	0	0	311051	0	113	40213227		
220661	4843	40213160	1962-07-31	1962-07-31 00:00:00	1962-07-31	1962-07-31 00:00:00	1962-07-31	581452		0	0	0		0	0	0	322123	0	10	40213160		
716	57	40236446	1973-06-16	1973-06-16 00:00:00	1979-06-25	1979-06-25 00:00:00	1979-06-25	38000177		0	0	2200		0	0	0	3845	0	1091392	40236446		
61262	5097	1107882	1992-07-19	1992-07-19 00:00:00	1992-07-19	1992-07-19 00:00:00	\N	38000177		0	0	0		0	0	0	338637	0	311372	1107882		
187414	4116	40213296	2011-01-06	2011-01-06 00:00:00	2011-01-06	2011-01-06 00:00:00	2011-01-06	581452		0	0	0		0	0	0	273664	0	52	40213296		
155699	3427	40213296	2009-09-16	2009-09-16 00:00:00	2009-09-16	2009-09-16 00:00:00	2009-09-16	581452		0	0	0		0	0	0	227240	0	52	40213296		
110517	2427	40213227	2003-10-14	2003-10-14 00:00:00	2003-10-14	2003-10-14 00:00:00	2003-10-14	581452		0	0	0		0	0	0	161026	0	113	40213227		
15627	337	40213160	1960-06-01	1960-06-01 00:00:00	1960-06-01	1960-06-01 00:00:00	1960-06-01	581452		0	0	0		0	0	0	22436	0	10	40213160		
217509	4773	40213160	1959-09-03	1959-09-03 00:00:00	1959-09-03	1959-09-03 00:00:00	1959-09-03	581452		0	0	0		0	0	0	317857	0	10	40213160		
21383	1759	19019979	1986-01-25	1986-01-25 00:00:00	1986-02-08	1986-02-08 00:00:00	1986-02-08	38000177		0	0	14		0	0	0	117609	0	198405	19019979		
15315	1280	19007333	1994-06-23	1994-06-23 00:00:00	1998-12-29	1998-12-29 00:00:00	1998-12-29	38000177		0	0	1650		0	0	0	84546	0	105586	19007333		
234401	5150	40213201	2005-11-03	2005-11-03 00:00:00	2005-11-03	2005-11-03 00:00:00	2005-11-03	581452		0	0	0		0	0	0	342434	0	33	40213201		
65348	1430	40213227	2005-10-18	2005-10-18 00:00:00	2005-10-18	2005-10-18 00:00:00	2005-10-18	581452		0	0	0		0	0	0	95173	0	113	40213227		
7356	615	1713671	2009-10-20	2009-10-20 00:00:00	2009-11-10	2009-11-10 00:00:00	2009-11-10	38000177		0	0	21		0	0	0	40919	0	562251	1713671		
208013	4563	40213227	2014-12-19	2014-12-19 00:00:00	2014-12-19	2014-12-19 00:00:00	2014-12-19	581452		0	0	0		0	0	0	304124	0	113	40213227		
62525	1367	40213160	1965-08-06	1965-08-06 00:00:00	1965-08-06	1965-08-06 00:00:00	1965-08-06	581452		0	0	0		0	0	0	90605	0	10	40213160		
212906	4668	40213260	2006-01-17	2006-01-17 00:00:00	2006-01-17	2006-01-17 00:00:00	2006-01-17	581452		0	0	0		0	0	0	311051	0	121	40213260		
220751	4844	40213160	1959-08-06	1959-08-06 00:00:00	1959-08-06	1959-08-06 00:00:00	1959-08-06	581452		0	0	0		0	0	0	322221	0	10	40213160		
217016	4761	40213314	1981-07-13	1981-07-13 00:00:00	1981-07-13	1981-07-13 00:00:00	1981-07-13	581452		0	0	0		0	0	0	317293	0	49	40213314		
61263	5097	1127078	1979-02-23	1979-02-23 00:00:00	1979-03-16	1979-03-16 00:00:00	1979-03-16	38000177		0	0	21		0	0	0	338713	0	282464	1127078		
210147	4608	40213160	1955-03-24	1955-03-24 00:00:00	1955-03-24	1955-03-24 00:00:00	1955-03-24	581452		0	0	0		0	0	0	306961	0	10	40213160		
155703	3427	40213160	1966-09-14	1966-09-14 00:00:00	1966-09-14	1966-09-14 00:00:00	1966-09-14	581452		0	0	0		0	0	0	227215	0	10	40213160		
110521	2428	40213160	1974-10-01	1974-10-01 00:00:00	1974-10-01	1974-10-01 00:00:00	1974-10-01	581452		0	0	0		0	0	0	161070	0	10	40213160		
15631	337	40213227	1994-08-17	1994-08-17 00:00:00	1994-08-17	1994-08-17 00:00:00	1994-08-17	581452		0	0	0		0	0	0	22410	0	113	40213227		
72109	1576	40213160	1968-06-15	1968-06-15 00:00:00	1968-06-15	1968-06-15 00:00:00	1968-06-15	581452		0	0	0		0	0	0	105808	0	10	40213160		
21384	1759	920334	2017-02-06	2017-02-06 00:00:00	2017-02-13	2017-02-13 00:00:00	2017-02-13	38000177		0	0	7		0	0	0	117578	0	311995	920334		
15316	1280	40229134	1964-03-16	1964-03-16 00:00:00	1964-03-23	1964-03-23 00:00:00	1964-03-23	38000177		0	0	7		0	0	0	84573	0	1043400	40229134		
148249	3259	40213227	1997-09-19	1997-09-19 00:00:00	1997-09-19	1997-09-19 00:00:00	1997-09-19	581452		0	0	0		0	0	0	216678	0	113	40213227		
65358	1430	40213227	2014-12-09	2014-12-09 00:00:00	2014-12-09	2014-12-09 00:00:00	2014-12-09	581452		0	0	0		0	0	0	95125	0	113	40213227		
7357	615	40173590	2000-09-09	2000-09-09 00:00:00	2000-09-09	2000-09-09 00:00:00	\N	38000177		0	0	0		0	0	0	40882	0	904419	40173590		
208014	4563	40213260	2014-12-19	2014-12-19 00:00:00	2014-12-19	2014-12-19 00:00:00	2014-12-19	581452		0	0	0		0	0	0	304124	0	121	40213260		
62527	1367	40213296	2005-06-10	2005-06-10 00:00:00	2005-06-10	2005-06-10 00:00:00	2005-06-10	581452		0	0	0		0	0	0	90617	0	52	40213296		
212909	4668	40213160	1959-12-22	1959-12-22 00:00:00	1959-12-22	1959-12-22 00:00:00	1959-12-22	581452		0	0	0		0	0	0	311042	0	10	40213160		
220754	4844	40213160	1959-06-04	1959-06-04 00:00:00	1959-06-04	1959-06-04 00:00:00	1959-06-04	581452		0	0	0		0	0	0	322324	0	10	40213160		
217019	4761	40213314	1980-10-13	1980-10-13 00:00:00	1980-10-13	1980-10-13 00:00:00	1980-10-13	581452		0	0	0		0	0	0	317292	0	49	40213314		
61264	5097	1127433	2009-01-11	2009-01-11 00:00:00	2009-01-18	2009-01-18 00:00:00	2009-01-18	38000177		0	0	7		0	0	0	338745	0	313782	1127433		
210154	4608	40213160	1959-10-22	1959-10-22 00:00:00	1959-10-22	1959-10-22 00:00:00	1959-10-22	581452		0	0	0		0	0	0	307052	0	10	40213160		
155706	3427	40213306	1989-02-22	1989-02-22 00:00:00	1989-02-22	1989-02-22 00:00:00	1989-02-22	581452		0	0	0		0	0	0	227239	0	43	40213306		
110525	2428	40213314	1977-05-31	1977-05-31 00:00:00	1977-05-31	1977-05-31 00:00:00	1977-05-31	581452		0	0	0		0	0	0	161106	0	49	40213314		
15635	337	40213227	2010-09-29	2010-09-29 00:00:00	2010-09-29	2010-09-29 00:00:00	2010-09-29	581452		0	0	0		0	0	0	22413	0	113	40213227		
72112	1576	40213306	1989-12-09	1989-12-09 00:00:00	1989-12-09	1989-12-09 00:00:00	1989-12-09	581452		0	0	0		0	0	0	105814	0	43	40213306		
21385	1759	42902245	1998-12-28	1998-12-28 00:00:00	1999-12-23	1999-12-23 00:00:00	1999-12-23	38000177		0	0	360		0	0	0	117635	0	1359133	42902245		
15317	1280	19059056	1964-08-24	1964-08-24 00:00:00	1964-09-28	1964-09-28 00:00:00	1964-09-28	38000177		0	0	35		0	0	0	84525	0	243670	19059056		
148255	3259	40213160	1966-02-04	1966-02-04 00:00:00	1966-02-04	1966-02-04 00:00:00	1966-02-04	581452		0	0	0		0	0	0	216666	0	10	40213160		
65378	1430	40213201	2010-11-16	2010-11-16 00:00:00	2010-11-16	2010-11-16 00:00:00	2010-11-16	581452		0	0	0		0	0	0	95116	0	33	40213201		
7358	615	1115171	2003-02-21	2003-02-21 00:00:00	2003-03-23	2003-03-23 00:00:00	2003-03-23	38000177		0	0	30		0	0	0	41047	0	849574	1115171		
208018	4563	40213227	1995-09-01	1995-09-01 00:00:00	1995-09-01	1995-09-01 00:00:00	1995-09-01	581452		0	0	0		0	0	0	304086	0	113	40213227		
62532	1367	40213160	1966-01-07	1966-01-07 00:00:00	1966-01-07	1966-01-07 00:00:00	1966-01-07	581452		0	0	0		0	0	0	90606	0	10	40213160		
212912	4668	40213160	1955-04-19	1955-04-19 00:00:00	1955-04-19	1955-04-19 00:00:00	1955-04-19	581452		0	0	0		0	0	0	311093	0	10	40213160		
200753	4409	40213227	2008-10-16	2008-10-16 00:00:00	2008-10-16	2008-10-16 00:00:00	2008-10-16	581452		0	0	0		0	0	0	\N	0	113	40213227		
217020	4761	40213160	1980-10-13	1980-10-13 00:00:00	1980-10-13	1980-10-13 00:00:00	1980-10-13	581452		0	0	0		0	0	0	317292	0	10	40213160		
61265	5097	40229134	1983-05-05	1983-05-05 00:00:00	1983-05-19	1983-05-19 00:00:00	1983-05-19	38000177		0	0	14		0	0	0	338629	0	1043400	40229134		
210159	4608	40213260	2006-12-28	2006-12-28 00:00:00	2006-12-28	2006-12-28 00:00:00	2006-12-28	581452		0	0	0		0	0	0	307090	0	121	40213260		
155713	3427	40213227	1999-09-01	1999-09-01 00:00:00	1999-09-01	1999-09-01 00:00:00	1999-09-01	581452		0	0	0		0	0	0	227221	0	113	40213227		
110529	2428	40213296	2018-03-27	2018-03-27 00:00:00	2018-03-27	2018-03-27 00:00:00	2018-03-27	581452		0	0	0		0	0	0	161122	0	52	40213296		
15636	337	40213260	2010-09-29	2010-09-29 00:00:00	2010-09-29	2010-09-29 00:00:00	2010-09-29	581452		0	0	0		0	0	0	22413	0	121	40213260		
72116	1576	40213160	1968-03-16	1968-03-16 00:00:00	1968-03-16	1968-03-16 00:00:00	1968-03-16	581452		0	0	0		0	0	0	105798	0	10	40213160		
21386	1759	1127433	2012-09-15	2012-09-15 00:00:00	2012-09-22	2012-09-22 00:00:00	2012-09-22	38000177		0	0	7		0	0	0	117625	0	313782	1127433		
15318	1280	1127433	2011-12-13	2011-12-13 00:00:00	2011-12-20	2011-12-20 00:00:00	2011-12-20	38000177		0	0	7		0	0	0	84607	0	313782	1127433		
148258	3259	40213227	2007-11-09	2007-11-09 00:00:00	2007-11-09	2007-11-09 00:00:00	2007-11-09	581452		0	0	0		0	0	0	216652	0	113	40213227		
65379	1430	40213198	2010-11-16	2010-11-16 00:00:00	2010-11-16	2010-11-16 00:00:00	2010-11-16	581452		0	0	0		0	0	0	95116	0	133	40213198		
7359	615	40162522	2003-02-21	2003-02-21 00:00:00	2003-02-21	2003-02-21 00:00:00	\N	38000177		0	0	0		0	0	0	41047	0	857005	40162522		
208019	4563	40213160	1964-03-20	1964-03-20 00:00:00	1964-03-20	1964-03-20 00:00:00	1964-03-20	581452		0	0	0		0	0	0	304097	0	10	40213160		
152360	3353	40213201	1991-11-02	1991-11-02 00:00:00	1991-11-02	1991-11-02 00:00:00	1991-11-02	581452		0	0	0		0	0	0	222436	0	33	40213201		
200754	4409	40213296	2008-10-16	2008-10-16 00:00:00	2008-10-16	2008-10-16 00:00:00	2008-10-16	581452		0	0	0		0	0	0	\N	0	52	40213296		
217021	4761	40213314	1980-08-11	1980-08-11 00:00:00	1980-08-11	1980-08-11 00:00:00	1980-08-11	581452		0	0	0		0	0	0	317253	0	49	40213314		
61266	5097	19059056	1972-09-18	1972-09-18 00:00:00	1972-10-02	1972-10-02 00:00:00	1972-10-02	38000177		0	0	14		0	0	0	338689	0	243670	19059056		
243136	5337	40213160	1975-02-02	1975-02-02 00:00:00	1975-02-02	1975-02-02 00:00:00	1975-02-02	581452		0	0	0		0	0	0	355380	0	10	40213160		
29474	642	40213227	2016-01-17	2016-01-17 00:00:00	2016-01-17	2016-01-17 00:00:00	2016-01-17	581452		0	0	0		0	0	0	42516	0	113	40213227		
110531	2428	40213296	2016-03-22	2016-03-22 00:00:00	2016-03-22	2016-03-22 00:00:00	2016-03-22	581452		0	0	0		0	0	0	161092	0	52	40213296		
202291	4442	40213227	2012-08-27	2012-08-27 00:00:00	2012-08-27	2012-08-27 00:00:00	2012-08-27	581452		0	0	0		0	0	0	295308	0	113	40213227		
72118	1576	40213227	2018-10-13	2018-10-13 00:00:00	2018-10-13	2018-10-13 00:00:00	2018-10-13	581452		0	0	0		0	0	0	105772	0	113	40213227		
21387	1759	42902245	2003-12-02	2003-12-02 00:00:00	2004-11-26	2004-11-26 00:00:00	2004-11-26	38000177		0	0	360		0	0	0	117579	0	1359133	42902245		
15319	1280	40236824	2012-08-11	2012-08-11 00:00:00	2012-08-18	2012-08-18 00:00:00	2012-08-18	38000177		0	0	7		0	0	0	84535	0	1094107	40236824		
148259	3259	40213296	2007-11-09	2007-11-09 00:00:00	2007-11-09	2007-11-09 00:00:00	2007-11-09	581452		0	0	0		0	0	0	216652	0	52	40213296		
134913	2961	40213160	1972-01-01	1972-01-01 00:00:00	1972-01-01	1972-01-01 00:00:00	1972-01-01	581452		0	0	0		0	0	0	197730	0	10	40213160		
7360	615	19133873	1911-07-20	1911-07-20 00:00:00	1911-07-31	1911-07-31 00:00:00	1911-07-31	38000177		0	0	11		0	0	0	40862	0	834061	19133873		
64444	1410	40213260	2018-01-03	2018-01-03 00:00:00	2018-01-03	2018-01-03 00:00:00	2018-01-03	581452		0	0	0		0	0	0	93908	0	121	40213260		
152372	3353	40213227	1996-11-30	1996-11-30 00:00:00	1996-11-30	1996-11-30 00:00:00	1996-11-30	581452		0	0	0		0	0	0	222372	0	113	40213227		
200758	4409	40213260	2017-10-12	2017-10-12 00:00:00	2017-10-12	2017-10-12 00:00:00	2017-10-12	581452		0	0	0		0	0	0	293106	0	121	40213260		
217022	4761	40213160	1980-08-11	1980-08-11 00:00:00	1980-08-11	1980-08-11 00:00:00	1980-08-11	581452		0	0	0		0	0	0	317253	0	10	40213160		
61267	5097	19129655	1972-09-18	1972-09-18 00:00:00	1972-10-02	1972-10-02 00:00:00	1972-10-02	38000177		0	0	14		0	0	0	338689	0	789980	19129655		
243147	5337	40213160	1970-08-02	1970-08-02 00:00:00	1970-08-02	1970-08-02 00:00:00	1970-08-02	581452		0	0	0		0	0	0	355376	0	10	40213160		
29477	642	40213227	2006-09-03	2006-09-03 00:00:00	2006-09-03	2006-09-03 00:00:00	2006-09-03	581452		0	0	0		0	0	0	42520	0	113	40213227		
110533	2428	40213227	2016-03-22	2016-03-22 00:00:00	2016-03-22	2016-03-22 00:00:00	2016-03-22	581452		0	0	0		0	0	0	161092	0	113	40213227		
202292	4442	40213160	1981-11-23	1981-11-23 00:00:00	1981-11-23	1981-11-23 00:00:00	1981-11-23	581452		0	0	0		0	0	0	295298	0	10	40213160		
72119	1576	40213260	2018-10-13	2018-10-13 00:00:00	2018-10-13	2018-10-13 00:00:00	2018-10-13	581452		0	0	0		0	0	0	105772	0	121	40213260		
21388	1759	19073183	1987-11-30	1987-11-30 00:00:00	1987-12-14	1987-12-14 00:00:00	1987-12-14	38000177		0	0	14		0	0	0	117626	0	308182	19073183		
15320	1280	920300	2012-08-11	2012-08-11 00:00:00	2012-08-18	2012-08-18 00:00:00	2012-08-18	38000177		0	0	7		0	0	0	84535	0	311989	920300		
148267	3260	40213160	1960-09-10	1960-09-10 00:00:00	1960-09-10	1960-09-10 00:00:00	1960-09-10	581452		0	0	0		0	0	0	216710	0	10	40213160		
134915	2961	40213160	1972-06-04	1972-06-04 00:00:00	1972-06-04	1972-06-04 00:00:00	1972-06-04	581452		0	0	0		0	0	0	197731	0	10	40213160		
7361	615	19078461	2019-06-27	2019-06-27 00:00:00	2019-06-27	2019-06-27 00:00:00	\N	38000177		0	0	0		0	0	0	41048	0	310965	19078461		
64445	1410	40213160	1967-08-24	1967-08-24 00:00:00	1967-08-24	1967-08-24 00:00:00	1967-08-24	581452		0	0	0		0	0	0	93901	0	10	40213160		
111144	2442	40213296	2012-07-02	2012-07-02 00:00:00	2012-07-02	2012-07-02 00:00:00	2012-07-02	581452		0	0	0		0	0	0	\N	0	52	40213296		
200760	4409	40213227	2018-10-18	2018-10-18 00:00:00	2018-10-18	2018-10-18 00:00:00	2018-10-18	581452		0	0	0		0	0	0	293137	0	113	40213227		
217031	4761	40213227	2003-03-17	2003-03-17 00:00:00	2003-03-17	2003-03-17 00:00:00	2003-03-17	581452		0	0	0		0	0	0	317243	0	113	40213227		
61268	5097	19006318	1969-11-24	1969-11-24 00:00:00	1969-12-08	1969-12-08 00:00:00	1969-12-08	38000177		0	0	14		0	0	0	338697	0	105078	19006318		
29491	642	40213201	2001-01-07	2001-01-07 00:00:00	2001-01-07	2001-01-07 00:00:00	2001-01-07	581452		0	0	0		0	0	0	42479	0	33	40213201		
110534	2428	40213160	1974-12-03	1974-12-03 00:00:00	1974-12-03	1974-12-03 00:00:00	1974-12-03	581452		0	0	0		0	0	0	161088	0	10	40213160		
202293	4442	40213314	1981-11-23	1981-11-23 00:00:00	1981-11-23	1981-11-23 00:00:00	1981-11-23	581452		0	0	0		0	0	0	295298	0	49	40213314		
72121	1576	40213160	1968-01-13	1968-01-13 00:00:00	1968-01-13	1968-01-13 00:00:00	1968-01-13	581452		0	0	0		0	0	0	105807	0	10	40213160		
21389	1759	1127078	1987-11-30	1987-11-30 00:00:00	1987-12-14	1987-12-14 00:00:00	1987-12-14	38000177		0	0	14		0	0	0	117626	0	282464	1127078		
15321	1280	1127433	1975-12-23	1975-12-23 00:00:00	1976-01-06	1976-01-06 00:00:00	1976-01-06	38000177		0	0	14		0	0	0	84605	0	313782	1127433		
148272	3260	40213160	1960-12-10	1960-12-10 00:00:00	1960-12-10	1960-12-10 00:00:00	1960-12-10	581452		0	0	0		0	0	0	216725	0	10	40213160		
134921	2961	40213160	1972-03-04	1972-03-04 00:00:00	1972-03-04	1972-03-04 00:00:00	1972-03-04	581452		0	0	0		0	0	0	197716	0	10	40213160		
7362	615	1127433	1995-01-29	1995-01-29 00:00:00	1995-04-29	1995-04-29 00:00:00	1995-04-29	38000177		0	0	90		0	0	0	41044	0	313782	1127433		
64458	1410	40213306	1989-05-25	1989-05-25 00:00:00	1989-05-25	1989-05-25 00:00:00	1989-05-25	581452		0	0	0		0	0	0	93864	0	43	40213306		
111146	2442	40213160	1971-09-27	1971-09-27 00:00:00	1971-09-27	1971-09-27 00:00:00	1971-09-27	581452		0	0	0		0	0	0	161948	0	10	40213160		
200761	4409	40213260	2018-10-18	2018-10-18 00:00:00	2018-10-18	2018-10-18 00:00:00	2018-10-18	581452		0	0	0		0	0	0	293137	0	121	40213260		
217032	4761	40213306	2003-03-17	2003-03-17 00:00:00	2003-03-17	2003-03-17 00:00:00	2003-03-17	581452		0	0	0		0	0	0	317243	0	43	40213306		
61269	5097	1127078	1969-11-24	1969-11-24 00:00:00	1969-12-08	1969-12-08 00:00:00	1969-12-08	38000177		0	0	14		0	0	0	338697	0	282464	1127078		
206389	4529	40213296	2003-11-23	2003-11-23 00:00:00	2003-11-23	2003-11-23 00:00:00	2003-11-23	581452		0	0	0		0	0	0	301555	0	52	40213296		
110537	2428	40213314	1978-05-30	1978-05-30 00:00:00	1978-05-30	1978-05-30 00:00:00	1978-05-30	581452		0	0	0		0	0	0	161072	0	49	40213314		
202294	4442	40213251	1984-05-21	1984-05-21 00:00:00	1984-05-21	1984-05-21 00:00:00	1984-05-21	581452		0	0	0		0	0	0	295326	0	21	40213251		
72125	1576	40213260	2017-10-07	2017-10-07 00:00:00	2017-10-07	2017-10-07 00:00:00	2017-10-07	581452		0	0	0		0	0	0	105781	0	121	40213260		
21390	1759	42902245	2000-12-17	2000-12-17 00:00:00	2001-12-12	2001-12-12 00:00:00	2001-12-12	38000177		0	0	360		0	0	0	117636	0	1359133	42902245		
15322	1280	1713671	1987-05-03	1987-05-03 00:00:00	1987-05-24	1987-05-24 00:00:00	1987-05-24	38000177		0	0	21		0	0	0	84531	0	562251	1713671		
148274	3260	40213306	1983-02-12	1983-02-12 00:00:00	1983-02-12	1983-02-12 00:00:00	1983-02-12	581452		0	0	0		0	0	0	216774	0	43	40213306		
134924	2961	40213227	2003-07-20	2003-07-20 00:00:00	2003-07-20	2003-07-20 00:00:00	2003-07-20	581452		0	0	0		0	0	0	197725	0	113	40213227		
7363	615	19059056	1915-03-27	1915-03-27 00:00:00	1915-04-10	1915-04-10 00:00:00	1915-04-10	38000177		0	0	14		0	0	0	40863	0	243670	19059056		
111151	2442	40213296	2012-01-23	2012-01-23 00:00:00	2012-01-23	2012-01-23 00:00:00	2012-01-23	581452		0	0	0		0	0	0	161956	0	52	40213296		
200764	4409	40213160	1971-11-25	1971-11-25 00:00:00	1971-11-25	1971-11-25 00:00:00	1971-11-25	581452		0	0	0		0	0	0	293065	0	10	40213160		
217033	4761	40213251	1985-04-15	1985-04-15 00:00:00	1985-04-15	1985-04-15 00:00:00	1985-04-15	581452		0	0	0		0	0	0	317296	0	21	40213251		
61270	5097	46233988	1968-01-22	1968-01-22 00:00:00	1968-02-05	1968-02-05 00:00:00	1968-02-05	38000177		0	0	14		0	0	0	338746	0	1652673	46233988		
206392	4529	40213260	2013-11-17	2013-11-17 00:00:00	2013-11-17	2013-11-17 00:00:00	2013-11-17	581452		0	0	0		0	0	0	301557	0	121	40213260		
110542	2428	40213160	1975-03-04	1975-03-04 00:00:00	1975-03-04	1975-03-04 00:00:00	1975-03-04	581452		0	0	0		0	0	0	161104	0	10	40213160		
202309	4442	40213160	1982-02-22	1982-02-22 00:00:00	1982-02-22	1982-02-22 00:00:00	1982-02-22	581452		0	0	0		0	0	0	295324	0	10	40213160		
72128	1576	40213227	1998-12-19	1998-12-19 00:00:00	1998-12-19	1998-12-19 00:00:00	1998-12-19	581452		0	0	0		0	0	0	105827	0	113	40213227		
21391	1759	40236824	2017-01-30	2017-01-30 00:00:00	2017-02-13	2017-02-13 00:00:00	2017-02-13	38000177		0	0	14		0	0	0	117577	0	1094107	40236824		
15323	1280	40229134	1955-07-15	1955-07-15 00:00:00	1955-07-29	1955-07-29 00:00:00	1955-07-29	38000177		0	0	14		0	0	0	84550	0	1043400	40229134		
148282	3260	40213306	1982-06-05	1982-06-05 00:00:00	1982-06-05	1982-06-05 00:00:00	1982-06-05	581452		0	0	0		0	0	0	216699	0	43	40213306		
134926	2961	40213306	1994-07-10	1994-07-10 00:00:00	1994-07-10	1994-07-10 00:00:00	1994-07-10	581452		0	0	0		0	0	0	197738	0	43	40213306		
7364	615	1127433	1965-05-01	1965-05-01 00:00:00	1965-05-22	1965-05-22 00:00:00	1965-05-22	38000177		0	0	21		0	0	0	41042	0	313782	1127433		
18209	394	40213227	1992-11-09	1992-11-09 00:00:00	1992-11-09	1992-11-09 00:00:00	1992-11-09	581452		0	0	0		0	0	0	25883	0	113	40213227		
200767	4409	40213160	1967-09-28	1967-09-28 00:00:00	1967-09-28	1967-09-28 00:00:00	1967-09-28	581452		0	0	0		0	0	0	293114	0	10	40213160		
217035	4761	40213160	1985-04-15	1985-04-15 00:00:00	1985-04-15	1985-04-15 00:00:00	1985-04-15	581452		0	0	0		0	0	0	317296	0	10	40213160		
61271	5097	19059056	1968-01-22	1968-01-22 00:00:00	1968-02-05	1968-02-05 00:00:00	1968-02-05	38000177		0	0	14		0	0	0	338746	0	243670	19059056		
206396	4529	40213160	1964-07-26	1964-07-26 00:00:00	1964-07-26	1964-07-26 00:00:00	1964-07-26	581452		0	0	0		0	0	0	301595	0	10	40213160		
110544	2428	40213314	1977-11-29	1977-11-29 00:00:00	1977-11-29	1977-11-29 00:00:00	1977-11-29	581452		0	0	0		0	0	0	161101	0	49	40213314		
202315	4442	40213227	2003-08-18	2003-08-18 00:00:00	2003-08-18	2003-08-18 00:00:00	2003-08-18	581452		0	0	0		0	0	0	295305	0	113	40213227		
72133	1576	40213160	1972-09-16	1972-09-16 00:00:00	1972-09-16	1972-09-16 00:00:00	1972-09-16	581452		0	0	0		0	0	0	105828	0	10	40213160		
21392	1759	920300	2017-01-30	2017-01-30 00:00:00	2017-02-06	2017-02-06 00:00:00	2017-02-06	38000177		0	0	7		0	0	0	117577	0	311989	920300		
15324	1280	19133905	2016-12-14	2016-12-14 00:00:00	2016-12-23	2016-12-23 00:00:00	2016-12-23	38000177		0	0	9		0	0	0	84536	0	834102	19133905		
148289	3260	40213227	1992-10-24	1992-10-24 00:00:00	1992-10-24	1992-10-24 00:00:00	1992-10-24	581452		0	0	0		0	0	0	216742	0	113	40213227		
134929	2961	40213296	2011-10-02	2011-10-02 00:00:00	2011-10-02	2011-10-02 00:00:00	2011-10-02	581452		0	0	0		0	0	0	197765	0	52	40213296		
7365	615	40236824	1958-02-20	1958-02-20 00:00:00	1958-02-27	1958-02-27 00:00:00	1958-02-27	38000177		0	0	7		0	0	0	40996	0	1094107	40236824		
18214	395	40213306	1982-03-02	1982-03-02 00:00:00	1982-03-02	1982-03-02 00:00:00	1982-03-02	581452		0	0	0		0	0	0	25969	0	43	40213306		
200768	4409	40213306	1989-02-16	1989-02-16 00:00:00	1989-02-16	1989-02-16 00:00:00	1989-02-16	581452		0	0	0		0	0	0	293100	0	43	40213306		
62180	1358	40213227	1995-03-23	1995-03-23 00:00:00	1995-03-23	1995-03-23 00:00:00	1995-03-23	581452		0	0	0		0	0	0	90063	0	113	40213227		
61272	5097	1118084	2005-08-05	2005-08-05 00:00:00	2005-08-05	2005-08-05 00:00:00	\N	38000177		0	0	0		0	0	0	338726	0	00025152531	44923712		
206400	4529	40213160	1968-10-20	1968-10-20 00:00:00	1968-10-20	1968-10-20 00:00:00	1968-10-20	581452		0	0	0		0	0	0	301576	0	10	40213160		
110553	2428	40213227	2005-09-06	2005-09-06 00:00:00	2005-09-06	2005-09-06 00:00:00	2005-09-06	581452		0	0	0		0	0	0	161121	0	113	40213227		
202316	4442	40213306	2003-08-18	2003-08-18 00:00:00	2003-08-18	2003-08-18 00:00:00	2003-08-18	581452		0	0	0		0	0	0	295305	0	43	40213306		
153824	3386	40213260	2018-12-02	2018-12-02 00:00:00	2018-12-02	2018-12-02 00:00:00	2018-12-02	581452		0	0	0		0	0	0	224668	0	121	40213260		
21393	1759	19127922	2002-12-07	2002-12-07 00:00:00	2003-12-02	2003-12-02 00:00:00	2003-12-02	38000177		0	0	360		0	0	0	117637	0	748962	19127922		
15325	1280	19133873	1952-03-03	1952-03-03 00:00:00	1952-03-10	1952-03-10 00:00:00	1952-03-10	38000177		0	0	7		0	0	0	84572	0	834061	19133873		
148293	3260	40213160	1960-07-09	1960-07-09 00:00:00	1960-07-09	1960-07-09 00:00:00	1960-07-09	581452		0	0	0		0	0	0	216724	0	10	40213160		
134937	2961	40213160	1976-09-05	1976-09-05 00:00:00	1976-09-05	1976-09-05 00:00:00	1976-09-05	581452		0	0	0		0	0	0	197718	0	10	40213160		
7366	615	920300	1958-02-20	1958-02-20 00:00:00	1958-02-27	1958-02-27 00:00:00	1958-02-27	38000177		0	0	7		0	0	0	40996	0	311989	920300		
18220	395	40213296	2002-02-26	2002-02-26 00:00:00	2002-02-26	2002-02-26 00:00:00	2002-02-26	581452		0	0	0		0	0	0	25997	0	52	40213296		
200771	4409	40213160	1967-06-29	1967-06-29 00:00:00	1967-06-29	1967-06-29 00:00:00	1967-06-29	581452		0	0	0		0	0	0	293062	0	10	40213160		
62182	1358	40213260	2007-05-03	2007-05-03 00:00:00	2007-05-03	2007-05-03 00:00:00	2007-05-03	581452		0	0	0		0	0	0	90066	0	121	40213260		
165091	3629	40213260	2007-12-03	2007-12-03 00:00:00	2007-12-03	2007-12-03 00:00:00	2007-12-03	581452		0	0	0		0	0	0	241484	0	121	40213260		
206406	4529	40213160	1964-02-23	1964-02-23 00:00:00	1964-02-23	1964-02-23 00:00:00	1964-02-23	581452		0	0	0		0	0	0	301594	0	10	40213160		
206434	4530	40213160	1968-08-24	1968-08-24 00:00:00	1968-08-24	1968-08-24 00:00:00	1968-08-24	581452		0	0	0		0	0	0	301634	0	10	40213160		
202322	4442	40213314	1982-08-23	1982-08-23 00:00:00	1982-08-23	1982-08-23 00:00:00	1982-08-23	581452		0	0	0		0	0	0	295299	0	49	40213314		
153827	3386	40213296	2008-12-07	2008-12-07 00:00:00	2008-12-07	2008-12-07 00:00:00	2008-12-07	581452		0	0	0		0	0	0	224666	0	52	40213296		
21394	1759	19128263	2007-11-11	2007-11-11 00:00:00	2008-11-05	2008-11-05 00:00:00	2008-11-05	38000177		0	0	360		0	0	0	117601	0	751905	19128263		
15326	1280	1713671	1993-04-26	1993-04-26 00:00:00	1993-05-03	1993-05-03 00:00:00	1993-05-03	38000177		0	0	7		0	0	0	84534	0	562251	1713671		
136631	3000	40213198	2013-05-31	2013-05-31 00:00:00	2013-05-31	2013-05-31 00:00:00	2013-05-31	581452		0	0	0		0	0	0	200221	0	133	40213198		
134938	2961	40213306	1993-11-27	1993-11-27 00:00:00	1993-11-27	1993-11-27 00:00:00	1993-11-27	581452		0	0	0		0	0	0	197722	0	43	40213306		
7367	615	19078461	1999-03-30	1999-03-30 00:00:00	1999-04-13	1999-04-13 00:00:00	1999-04-13	38000177		0	0	14		0	0	0	41046	0	310965	19078461		
18222	395	40213227	2002-02-26	2002-02-26 00:00:00	2002-02-26	2002-02-26 00:00:00	2002-02-26	581452		0	0	0		0	0	0	25997	0	113	40213227		
200774	4409	40213296	2007-01-25	2007-01-25 00:00:00	2007-01-25	2007-01-25 00:00:00	2007-01-25	581452		0	0	0		0	0	0	293104	0	52	40213296		
62185	1358	40213160	1955-06-30	1955-06-30 00:00:00	1955-06-30	1955-06-30 00:00:00	1955-06-30	581452		0	0	0		0	0	0	90074	0	10	40213160		
165097	3629	40213160	1956-07-30	1956-07-30 00:00:00	1956-07-30	1956-07-30 00:00:00	1956-07-30	581452		0	0	0		0	0	0	241477	0	10	40213160		
206412	4529	40213306	1985-12-01	1985-12-01 00:00:00	1985-12-01	1985-12-01 00:00:00	1985-12-01	581452		0	0	0		0	0	0	301589	0	43	40213306		
206435	4530	40213227	1999-07-31	1999-07-31 00:00:00	1999-07-31	1999-07-31 00:00:00	1999-07-31	581452		0	0	0		0	0	0	301641	0	113	40213227		
202324	4442	40213160	1986-05-26	1986-05-26 00:00:00	1986-05-26	1986-05-26 00:00:00	1986-05-26	581452		0	0	0		0	0	0	295301	0	10	40213160		
153828	3386	40213160	1969-05-11	1969-05-11 00:00:00	1969-05-11	1969-05-11 00:00:00	1969-05-11	581452		0	0	0		0	0	0	224660	0	10	40213160		
21395	1759	40224805	2005-11-21	2005-11-21 00:00:00	2006-11-16	2006-11-16 00:00:00	2006-11-16	38000177		0	0	360		0	0	0	117580	0	1000126	40224805		
15327	1280	19059056	1956-07-07	1956-07-07 00:00:00	1956-07-21	1956-07-21 00:00:00	1956-07-21	38000177		0	0	14		0	0	0	84537	0	243670	19059056		
136636	3000	40213201	2014-06-06	2014-06-06 00:00:00	2014-06-06	2014-06-06 00:00:00	2014-06-06	581452		0	0	0		0	0	0	200229	0	33	40213201		
134940	2961	40213227	1993-11-27	1993-11-27 00:00:00	1993-11-27	1993-11-27 00:00:00	1993-11-27	581452		0	0	0		0	0	0	197722	0	113	40213227		
7368	615	40229134	1982-05-22	1982-05-22 00:00:00	1982-06-05	1982-06-05 00:00:00	1982-06-05	38000177		0	0	14		0	0	0	40913	0	1043400	40229134		
18224	395	40213160	1960-10-25	1960-10-25 00:00:00	1960-10-25	1960-10-25 00:00:00	1960-10-25	581452		0	0	0		0	0	0	25934	0	10	40213160		
200794	4409	40213227	1998-02-26	1998-02-26 00:00:00	1998-02-26	1998-02-26 00:00:00	1998-02-26	581452		0	0	0		0	0	0	293103	0	113	40213227		
62189	1358	40213160	1955-12-29	1955-12-29 00:00:00	1955-12-29	1955-12-29 00:00:00	1955-12-29	581452		0	0	0		0	0	0	90101	0	10	40213160		
165100	3629	40213227	1997-12-01	1997-12-01 00:00:00	1997-12-01	1997-12-01 00:00:00	1997-12-01	581452		0	0	0		0	0	0	241483	0	113	40213227		
206419	4530	40213227	2019-05-25	2019-05-25 00:00:00	2019-05-25	2019-05-25 00:00:00	2019-05-25	581452		0	0	0		0	0	0	301645	0	113	40213227		
206440	4530	40213306	1990-07-21	1990-07-21 00:00:00	1990-07-21	1990-07-21 00:00:00	1990-07-21	581452		0	0	0		0	0	0	301675	0	43	40213306		
202326	4442	40213251	1986-05-26	1986-05-26 00:00:00	1986-05-26	1986-05-26 00:00:00	1986-05-26	581452		0	0	0		0	0	0	295301	0	21	40213251		
153835	3386	40213227	2000-03-05	2000-03-05 00:00:00	2000-03-05	2000-03-05 00:00:00	2000-03-05	581452		0	0	0		0	0	0	224655	0	113	40213227		
21396	1759	19128009	2008-11-05	2008-11-05 00:00:00	2009-02-23	2009-02-23 00:00:00	2009-02-23	38000177		0	0	110		0	0	0	117602	0	749762	19128009		
15328	1280	19078461	2017-04-28	2017-04-28 00:00:00	2017-05-12	2017-05-12 00:00:00	2017-05-12	38000177		0	0	14		0	0	0	84527	0	310965	19078461		
136639	3000	40213227	2009-05-08	2009-05-08 00:00:00	2009-05-08	2009-05-08 00:00:00	2009-05-08	581452		0	0	0		0	0	0	200173	0	113	40213227		
134942	2961	40213227	2013-10-06	2013-10-06 00:00:00	2013-10-06	2013-10-06 00:00:00	2013-10-06	581452		0	0	0		0	0	0	197746	0	113	40213227		
7369	615	1551192	1926-12-24	1926-12-24 00:00:00	1926-12-24	1926-12-24 00:00:00	1926-12-24	38000177		0	0	0		0	0	0	41040	0	312617	1551192		
18228	395	40213160	1965-01-26	1965-01-26 00:00:00	1965-01-26	1965-01-26 00:00:00	1965-01-26	581452		0	0	0		0	0	0	25962	0	10	40213160		
200795	4409	40213160	1967-04-27	1967-04-27 00:00:00	1967-04-27	1967-04-27 00:00:00	1967-04-27	581452		0	0	0		0	0	0	293113	0	10	40213160		
62196	1358	40213160	1956-06-28	1956-06-28 00:00:00	1956-06-28	1956-06-28 00:00:00	1956-06-28	581452		0	0	0		0	0	0	90093	0	10	40213160		
165101	3629	40213296	1997-12-01	1997-12-01 00:00:00	1997-12-01	1997-12-01 00:00:00	1997-12-01	581452		0	0	0		0	0	0	241483	0	52	40213296		
206420	4530	40213260	2019-05-25	2019-05-25 00:00:00	2019-05-25	2019-05-25 00:00:00	2019-05-25	581452		0	0	0		0	0	0	301645	0	121	40213260		
206443	4530	40213260	2018-05-19	2018-05-19 00:00:00	2018-05-19	2018-05-19 00:00:00	2018-05-19	581452		0	0	0		0	0	0	301663	0	121	40213260		
202328	4442	40213160	1981-09-21	1981-09-21 00:00:00	1981-09-21	1981-09-21 00:00:00	1981-09-21	581452		0	0	0		0	0	0	295323	0	10	40213160		
153839	3386	40213160	1969-08-10	1969-08-10 00:00:00	1969-08-10	1969-08-10 00:00:00	1969-08-10	581452		0	0	0		0	0	0	224638	0	10	40213160		
21397	1759	40229134	2005-06-25	2005-06-25 00:00:00	2005-07-02	2005-07-02 00:00:00	2005-07-02	38000177		0	0	7		0	0	0	117607	0	1043400	40229134		
15329	1280	1124300	1988-03-11	1988-03-11 00:00:00	1988-03-11	1988-03-11 00:00:00	\N	38000177		0	0	0		0	0	0	84566	0	00781178901	45011828		
136659	3000	40213227	1999-04-23	1999-04-23 00:00:00	1999-04-23	1999-04-23 00:00:00	1999-04-23	581452		0	0	0		0	0	0	200214	0	113	40213227		
134943	2961	40213296	2013-10-06	2013-10-06 00:00:00	2013-10-06	2013-10-06 00:00:00	2013-10-06	581452		0	0	0		0	0	0	197746	0	52	40213296		
7370	615	1127433	1933-06-28	1933-06-28 00:00:00	1933-07-05	1933-07-05 00:00:00	1933-07-05	38000177		0	0	7		0	0	0	40995	0	313782	1127433		
111519	2450	40213160	1955-12-15	1955-12-15 00:00:00	1955-12-15	1955-12-15 00:00:00	1955-12-15	581452		0	0	0		0	0	0	162480	0	10	40213160		
200926	4412	40213227	2015-06-19	2015-06-19 00:00:00	2015-06-19	2015-06-19 00:00:00	2015-06-19	581452		0	0	0		0	0	0	293312	0	113	40213227		
62205	1359	40213227	1992-05-26	1992-05-26 00:00:00	1992-05-26	1992-05-26 00:00:00	1992-05-26	581452		0	0	0		0	0	0	90174	0	113	40213227		
165107	3629	40213160	1956-02-27	1956-02-27 00:00:00	1956-02-27	1956-02-27 00:00:00	1956-02-27	581452		0	0	0		0	0	0	241460	0	10	40213160		
206424	4530	40213227	2010-05-29	2010-05-29 00:00:00	2010-05-29	2010-05-29 00:00:00	2010-05-29	581452		0	0	0		0	0	0	301643	0	113	40213227		
206444	4530	40213160	1968-10-26	1968-10-26 00:00:00	1968-10-26	1968-10-26 00:00:00	1968-10-26	581452		0	0	0		0	0	0	301668	0	10	40213160		
202329	4442	40213314	1981-09-21	1981-09-21 00:00:00	1981-09-21	1981-09-21 00:00:00	1981-09-21	581452		0	0	0		0	0	0	295323	0	49	40213314		
90608	1989	40213296	1996-05-10	1996-05-10 00:00:00	1996-05-10	1996-05-10 00:00:00	1996-05-10	581452		0	0	0		0	0	0	132452	0	52	40213296		
21398	1759	1118084	2019-03-08	2019-03-08 00:00:00	2019-03-08	2019-03-08 00:00:00	\N	38000177		0	0	0		0	0	0	117598	0	00025152531	44923712		
15330	1280	19078461	1978-03-28	1978-03-28 00:00:00	1978-04-11	1978-04-11 00:00:00	1978-04-11	38000177		0	0	14		0	0	0	84547	0	310965	19078461		
208628	4576	40213296	1998-06-24	1998-06-24 00:00:00	1998-06-24	1998-06-24 00:00:00	1998-06-24	581452		0	0	0		0	0	0	304825	0	52	40213296		
156018	3434	40213201	2014-07-03	2014-07-03 00:00:00	2014-07-03	2014-07-03 00:00:00	2014-07-03	581452		0	0	0		0	0	0	227767	0	33	40213201		
7371	615	1713671	2017-03-07	2017-03-07 00:00:00	2017-03-14	2017-03-14 00:00:00	2017-03-14	38000177		0	0	7		0	0	0	40988	0	562251	1713671		
111524	2450	40213201	2017-09-21	2017-09-21 00:00:00	2017-09-21	2017-09-21 00:00:00	2017-09-21	581452		0	0	0		0	0	0	162515	0	33	40213201		
200927	4412	40213260	2015-06-19	2015-06-19 00:00:00	2015-06-19	2015-06-19 00:00:00	2015-06-19	581452		0	0	0		0	0	0	293312	0	121	40213260		
164794	3623	40213160	1955-01-30	1955-01-30 00:00:00	1955-01-30	1955-01-30 00:00:00	1955-01-30	581452		0	0	0		0	0	0	240862	0	10	40213160		
165119	3630	40213296	1997-04-23	1997-04-23 00:00:00	1997-04-23	1997-04-23 00:00:00	1997-04-23	581452		0	0	0		0	0	0	241533	0	52	40213296		
206425	4530	40213296	2010-05-29	2010-05-29 00:00:00	2010-05-29	2010-05-29 00:00:00	2010-05-29	581452		0	0	0		0	0	0	301643	0	52	40213296		
206447	4530	40213296	2008-05-24	2008-05-24 00:00:00	2008-05-24	2008-05-24 00:00:00	2008-05-24	581452		0	0	0		0	0	0	301680	0	52	40213296		
202088	4437	40213160	1969-09-17	1969-09-17 00:00:00	1969-09-17	1969-09-17 00:00:00	1969-09-17	581452		0	0	0		0	0	0	294928	0	10	40213160		
90613	1989	40213227	2003-02-21	2003-02-21 00:00:00	2003-02-21	2003-02-21 00:00:00	2003-02-21	581452		0	0	0		0	0	0	132415	0	113	40213227		
21399	1759	19073183	1990-02-26	1990-02-26 00:00:00	1990-03-12	1990-03-12 00:00:00	1990-03-12	38000177		0	0	14		0	0	0	117627	0	308182	19073183		
15331	1280	1713671	1971-04-26	1971-04-26 00:00:00	1971-05-03	1971-05-03 00:00:00	1971-05-03	38000177		0	0	7		0	0	0	84555	0	562251	1713671		
208639	4576	40213227	2016-09-14	2016-09-14 00:00:00	2016-09-14	2016-09-14 00:00:00	2016-09-14	581452		0	0	0		0	0	0	304816	0	113	40213227		
71446	1563	40213160	1956-09-29	1956-09-29 00:00:00	1956-09-29	1956-09-29 00:00:00	1956-09-29	581452		0	0	0		0	0	0	104654	0	10	40213160		
7372	615	19133905	1929-07-17	1929-07-17 00:00:00	1929-07-26	1929-07-26 00:00:00	1929-07-26	38000177		0	0	9		0	0	0	40994	0	834102	19133905		
111538	2450	40213227	2002-06-27	2002-06-27 00:00:00	2002-06-27	2002-06-27 00:00:00	2002-06-27	581452		0	0	0		0	0	0	162522	0	113	40213227		
200932	4412	40213227	1995-01-20	1995-01-20 00:00:00	1995-01-20	1995-01-20 00:00:00	1995-01-20	581452		0	0	0		0	0	0	293308	0	113	40213227		
164798	3623	40213201	2016-03-20	2016-03-20 00:00:00	2016-03-20	2016-03-20 00:00:00	2016-03-20	581452		0	0	0		0	0	0	240932	0	33	40213201		
165120	3630	40213260	2006-04-19	2006-04-19 00:00:00	2006-04-19	2006-04-19 00:00:00	2006-04-19	581452		0	0	0		0	0	0	241503	0	121	40213260		
206427	4530	40213160	1973-04-28	1973-04-28 00:00:00	1973-04-28	1973-04-28 00:00:00	1973-04-28	581452		0	0	0		0	0	0	301671	0	10	40213160		
206461	4530	40213160	1969-01-25	1969-01-25 00:00:00	1969-01-25	1969-01-25 00:00:00	1969-01-25	581452		0	0	0		0	0	0	301650	0	10	40213160		
202090	4437	40213160	1969-06-18	1969-06-18 00:00:00	1969-06-18	1969-06-18 00:00:00	1969-06-18	581452		0	0	0		0	0	0	294918	0	10	40213160		
90618	1989	40213227	1994-05-06	1994-05-06 00:00:00	1994-05-06	1994-05-06 00:00:00	1994-05-06	581452		0	0	0		0	0	0	132414	0	113	40213227		
21400	1759	1127078	1990-02-26	1990-02-26 00:00:00	1990-03-12	1990-03-12 00:00:00	1990-03-12	38000177		0	0	14		0	0	0	117627	0	282464	1127078		
15332	1280	1713671	1977-10-07	1977-10-07 00:00:00	1977-10-28	1977-10-28 00:00:00	1977-10-28	38000177		0	0	21		0	0	0	84545	0	562251	1713671		
208653	4576	40213160	1955-02-02	1955-02-02 00:00:00	1955-02-02	1955-02-02 00:00:00	1955-02-02	581452		0	0	0		0	0	0	304819	0	10	40213160		
71452	1563	40213227	2018-04-14	2018-04-14 00:00:00	2018-04-14	2018-04-14 00:00:00	2018-04-14	581452		0	0	0		0	0	0	104710	0	113	40213227		
7373	615	1713671	2015-08-16	2015-08-16 00:00:00	2015-09-06	2015-09-06 00:00:00	2015-09-06	38000177		0	0	21		0	0	0	40987	0	562251	1713671		
177846	3909	40213227	1992-11-06	1992-11-06 00:00:00	1992-11-06	1992-11-06 00:00:00	1992-11-06	581452		0	0	0		0	0	0	259897	0	113	40213227		
200935	4412	40213160	1968-07-12	1968-07-12 00:00:00	1968-07-12	1968-07-12 00:00:00	1968-07-12	581452		0	0	0		0	0	0	293322	0	10	40213160		
164801	3624	40213227	2018-07-05	2018-07-05 00:00:00	2018-07-05	2018-07-05 00:00:00	2018-07-05	581452		0	0	0		0	0	0	241022	0	113	40213227		
165123	3630	40213227	1997-04-23	1997-04-23 00:00:00	1997-04-23	1997-04-23 00:00:00	1997-04-23	581452		0	0	0		0	0	0	241533	0	113	40213227		
221634	4865	40213160	1974-05-08	1974-05-08 00:00:00	1974-05-08	1974-05-08 00:00:00	1974-05-08	581452		0	0	0		0	0	0	323498	0	10	40213160		
202046	4436	40213160	1966-02-04	1966-02-04 00:00:00	1966-02-04	1966-02-04 00:00:00	1966-02-04	581452		0	0	0		0	0	0	294838	0	10	40213160		
213375	4678	40213160	1959-09-08	1959-09-08 00:00:00	1959-09-08	1959-09-08 00:00:00	1959-09-08	581452		0	0	0		0	0	0	311746	0	10	40213160		
90619	1989	40213198	2017-05-12	2017-05-12 00:00:00	2017-05-12	2017-05-12 00:00:00	2017-05-12	581452		0	0	0		0	0	0	132432	0	133	40213198		
32062	2657	1118084	2000-05-19	2000-05-19 00:00:00	2000-05-19	2000-05-19 00:00:00	\N	38000177		0	0	0		0	0	0	175936	0	00025152531	44923712		
15333	1281	1124300	2005-11-10	2005-11-10 00:00:00	2005-11-10	2005-11-10 00:00:00	\N	38000177		0	0	0		0	0	0	84653	0	00781178901	45011828		
210817	4623	40213227	2010-05-18	2010-05-18 00:00:00	2010-05-18	2010-05-18 00:00:00	2010-05-18	581452		0	0	0		0	0	0	307896	0	113	40213227		
71466	1563	40213160	1957-03-02	1957-03-02 00:00:00	1957-03-02	1957-03-02 00:00:00	1957-03-02	581452		0	0	0		0	0	0	104655	0	10	40213160		
7374	615	19078461	1996-04-23	1996-04-23 00:00:00	1996-05-14	1996-05-14 00:00:00	1996-05-14	38000177		0	0	21		0	0	0	41045	0	310965	19078461		
177857	3909	40213160	1962-01-26	1962-01-26 00:00:00	1962-01-26	1962-01-26 00:00:00	1962-01-26	581452		0	0	0		0	0	0	259858	0	10	40213160		
200939	4412	40213306	1986-01-10	1986-01-10 00:00:00	1986-01-10	1986-01-10 00:00:00	1986-01-10	581452		0	0	0		0	0	0	293301	0	43	40213306		
164822	3624	40213227	1997-07-10	1997-07-10 00:00:00	1997-07-10	1997-07-10 00:00:00	1997-07-10	581452		0	0	0		0	0	0	241015	0	113	40213227		
165125	3630	40213227	2006-04-19	2006-04-19 00:00:00	2006-04-19	2006-04-19 00:00:00	2006-04-19	581452		0	0	0		0	0	0	241503	0	113	40213227		
221635	4865	40213306	1996-09-25	1996-09-25 00:00:00	1996-09-25	1996-09-25 00:00:00	1996-09-25	581452		0	0	0		0	0	0	323517	0	43	40213306		
202052	4436	40213260	2015-05-29	2015-05-29 00:00:00	2015-05-29	2015-05-29 00:00:00	2015-05-29	581452		0	0	0		0	0	0	294850	0	121	40213260		
213379	4678	40213227	2015-12-01	2015-12-01 00:00:00	2015-12-01	2015-12-01 00:00:00	2015-12-01	581452		0	0	0		0	0	0	311787	0	113	40213227		
90623	1989	40213260	2006-03-10	2006-03-10 00:00:00	2006-03-10	2006-03-10 00:00:00	2006-03-10	581452		0	0	0		0	0	0	132430	0	121	40213260		
32063	2657	40165015	2016-01-23	2016-01-23 00:00:00	2016-01-23	2016-01-23 00:00:00	\N	38000177		0	0	0		0	0	0	175934	0	861467	40165015		
15334	1281	1127433	1978-06-22	1978-06-22 00:00:00	1978-07-06	1978-07-06 00:00:00	1978-07-06	38000177		0	0	14		0	0	0	84685	0	313782	1127433		
236380	5191	40213227	1992-10-22	1992-10-22 00:00:00	1992-10-22	1992-10-22 00:00:00	1992-10-22	581452		0	0	0		0	0	0	345080	0	113	40213227		
71473	1563	40213160	1956-12-01	1956-12-01 00:00:00	1956-12-01	1956-12-01 00:00:00	1956-12-01	581452		0	0	0		0	0	0	104644	0	10	40213160		
3045	67	40213160	1971-06-27	1971-06-27 00:00:00	1971-06-27	1971-06-27 00:00:00	1971-06-27	581452		0	0	0		0	0	0	4541	0	10	40213160		
177867	3909	40213260	2012-01-13	2012-01-13 00:00:00	2012-01-13	2012-01-13 00:00:00	2012-01-13	581452		0	0	0		0	0	0	259836	0	121	40213260		
200949	4413	40213160	1965-09-23	1965-09-23 00:00:00	1965-09-23	1965-09-23 00:00:00	1965-09-23	581452		0	0	0		0	0	0	\N	0	10	40213160		
101246	2220	40213227	1993-08-18	1993-08-18 00:00:00	1993-08-18	1993-08-18 00:00:00	1993-08-18	581452		0	0	0		0	0	0	147836	0	113	40213227		
61083	1335	40213296	2018-11-26	2018-11-26 00:00:00	2018-11-26	2018-11-26 00:00:00	2018-11-26	581452		0	0	0		0	0	0	88593	0	52	40213296		
221637	4865	40213227	1996-09-25	1996-09-25 00:00:00	1996-09-25	1996-09-25 00:00:00	1996-09-25	581452		0	0	0		0	0	0	323517	0	113	40213227		
202062	4436	40213227	2016-06-03	2016-06-03 00:00:00	2016-06-03	2016-06-03 00:00:00	2016-06-03	581452		0	0	0		0	0	0	294870	0	113	40213227		
213383	4678	40213160	1955-06-07	1955-06-07 00:00:00	1955-06-07	1955-06-07 00:00:00	1955-06-07	581452		0	0	0		0	0	0	311734	0	10	40213160		
90634	1989	40213201	2018-05-18	2018-05-18 00:00:00	2018-05-18	2018-05-18 00:00:00	2018-05-18	581452		0	0	0		0	0	0	132456	0	33	40213201		
32064	2657	1115171	2011-07-11	2011-07-11 00:00:00	2011-07-25	2011-07-25 00:00:00	2011-07-25	38000177		0	0	14		0	0	0	175939	0	849574	1115171		
15335	1281	1127433	1984-06-18	1984-06-18 00:00:00	1984-08-17	1984-08-17 00:00:00	1984-08-17	38000177		0	0	60		0	0	0	84703	0	313782	1127433		
236381	5191	40213306	1992-10-22	1992-10-22 00:00:00	1992-10-22	1992-10-22 00:00:00	1992-10-22	581452		0	0	0		0	0	0	345080	0	43	40213306		
71478	1563	40213227	1997-07-26	1997-07-26 00:00:00	1997-07-26	1997-07-26 00:00:00	1997-07-26	581452		0	0	0		0	0	0	104663	0	113	40213227		
3048	67	40213227	2001-11-04	2001-11-04 00:00:00	2001-11-04	2001-11-04 00:00:00	2001-11-04	581452		0	0	0		0	0	0	4576	0	113	40213227		
177869	3909	40213296	2004-12-24	2004-12-24 00:00:00	2004-12-24	2004-12-24 00:00:00	2004-12-24	581452		0	0	0		0	0	0	259885	0	52	40213296		
200953	4413	40213227	2011-12-15	2011-12-15 00:00:00	2011-12-15	2011-12-15 00:00:00	2011-12-15	581452		0	0	0		0	0	0	293444	0	113	40213227		
101270	2220	40213227	2003-10-15	2003-10-15 00:00:00	2003-10-15	2003-10-15 00:00:00	2003-10-15	581452		0	0	0		0	0	0	147786	0	113	40213227		
61084	1335	40213160	1979-04-30	1979-04-30 00:00:00	1979-04-30	1979-04-30 00:00:00	1979-04-30	581452		0	0	0		0	0	0	88597	0	10	40213160		
221639	4865	40213160	1974-10-09	1974-10-09 00:00:00	1974-10-09	1974-10-09 00:00:00	1974-10-09	581452		0	0	0		0	0	0	323511	0	10	40213160		
202063	4436	40213260	2016-06-03	2016-06-03 00:00:00	2016-06-03	2016-06-03 00:00:00	2016-06-03	581452		0	0	0		0	0	0	294870	0	121	40213260		
213394	4678	40213160	1955-03-08	1955-03-08 00:00:00	1955-03-08	1955-03-08 00:00:00	1955-03-08	581452		0	0	0		0	0	0	311743	0	10	40213160		
90639	1989	40213160	1957-02-15	1957-02-15 00:00:00	1957-02-15	1957-02-15 00:00:00	1957-02-15	581452		0	0	0		0	0	0	132397	0	10	40213160		
32065	2657	19073188	2011-07-11	2011-07-11 00:00:00	2011-07-25	2011-07-25 00:00:00	2011-07-25	38000177		0	0	14		0	0	0	175939	0	308192	19073188		
15336	1281	1310034	2012-07-21	2012-07-21 00:00:00	2012-07-21	2012-07-21 00:00:00	2012-07-21	38000177		0	0	0		0	0	0	84706	0	834357	1310034		
236385	5191	40213296	2010-11-25	2010-11-25 00:00:00	2010-11-25	2010-11-25 00:00:00	2010-11-25	581452		0	0	0		0	0	0	345107	0	52	40213296		
71479	1563	40213296	1997-07-26	1997-07-26 00:00:00	1997-07-26	1997-07-26 00:00:00	1997-07-26	581452		0	0	0		0	0	0	104663	0	52	40213296		
3054	67	40213306	1992-10-25	1992-10-25 00:00:00	1992-10-25	1992-10-25 00:00:00	1992-10-25	581452		0	0	0		0	0	0	4558	0	43	40213306		
177873	3909	40213306	1983-10-28	1983-10-28 00:00:00	1983-10-28	1983-10-28 00:00:00	1983-10-28	581452		0	0	0		0	0	0	259878	0	43	40213306		
200954	4413	40213260	2011-12-15	2011-12-15 00:00:00	2011-12-15	2011-12-15 00:00:00	2011-12-15	581452		0	0	0		0	0	0	293444	0	121	40213260		
101279	2220	40213227	2014-03-19	2014-03-19 00:00:00	2014-03-19	2014-03-19 00:00:00	2014-03-19	581452		0	0	0		0	0	0	147788	0	113	40213227		
61085	1335	40213314	1979-04-30	1979-04-30 00:00:00	1979-04-30	1979-04-30 00:00:00	1979-04-30	581452		0	0	0		0	0	0	88597	0	49	40213314		
221640	4865	40213296	2017-08-16	2017-08-16 00:00:00	2017-08-16	2017-08-16 00:00:00	2017-08-16	581452		0	0	0		0	0	0	323539	0	52	40213296		
202065	4436	40213296	2005-06-03	2005-06-03 00:00:00	2005-06-03	2005-06-03 00:00:00	2005-06-03	581452		0	0	0		0	0	0	294848	0	52	40213296		
213396	4678	40213260	2007-10-16	2007-10-16 00:00:00	2007-10-16	2007-10-16 00:00:00	2007-10-16	581452		0	0	0		0	0	0	311774	0	121	40213260		
90644	1989	40213160	1956-02-10	1956-02-10 00:00:00	1956-02-10	1956-02-10 00:00:00	1956-02-10	581452		0	0	0		0	0	0	132466	0	10	40213160		
32066	2657	1115171	2016-01-16	2016-01-16 00:00:00	2016-02-22	2016-02-22 00:00:00	2016-02-22	38000177		0	0	37		0	0	0	175951	0	849574	1115171		
15337	1281	40243436	2012-07-21	2012-07-21 00:00:00	2012-07-21	2012-07-21 00:00:00	2012-07-21	38000177		0	0	0		0	0	0	84706	0	1190795	40243436		
236386	5191	40213296	2012-11-29	2012-11-29 00:00:00	2012-11-29	2012-11-29 00:00:00	2012-11-29	581452		0	0	0		0	0	0	345070	0	52	40213296		
71487	1563	40213260	2006-08-26	2006-08-26 00:00:00	2006-08-26	2006-08-26 00:00:00	2006-08-26	581452		0	0	0		0	0	0	104682	0	121	40213260		
3058	67	40213296	2012-10-28	2012-10-28 00:00:00	2012-10-28	2012-10-28 00:00:00	2012-10-28	581452		0	0	0		0	0	0	4573	0	52	40213296		
177875	3909	40213160	1961-11-24	1961-11-24 00:00:00	1961-11-24	1961-11-24 00:00:00	1961-11-24	581452		0	0	0		0	0	0	259872	0	10	40213160		
200956	4413	40213160	1961-03-16	1961-03-16 00:00:00	1961-03-16	1961-03-16 00:00:00	1961-03-16	581452		0	0	0		0	0	0	293493	0	10	40213160		
18964	411	40213306	1982-03-06	1982-03-06 00:00:00	1982-03-06	1982-03-06 00:00:00	1982-03-06	581452		0	0	0		0	0	0	27389	0	43	40213306		
61087	1335	40213227	2001-10-22	2001-10-22 00:00:00	2001-10-22	2001-10-22 00:00:00	2001-10-22	581452		0	0	0		0	0	0	88591	0	113	40213227		
221643	4865	40213314	1977-07-06	1977-07-06 00:00:00	1977-07-06	1977-07-06 00:00:00	1977-07-06	581452		0	0	0		0	0	0	323527	0	49	40213314		
202069	4437	40213227	2010-06-30	2010-06-30 00:00:00	2010-06-30	2010-06-30 00:00:00	2010-06-30	581452		0	0	0		0	0	0	294915	0	113	40213227		
213399	4678	40213227	1996-10-08	1996-10-08 00:00:00	1996-10-08	1996-10-08 00:00:00	1996-10-08	581452		0	0	0		0	0	0	311799	0	113	40213227		
90648	1989	40213160	1955-08-12	1955-08-12 00:00:00	1955-08-12	1955-08-12 00:00:00	1955-08-12	581452		0	0	0		0	0	0	132471	0	10	40213160		
32067	2657	40243436	1970-09-05	1970-09-05 00:00:00	1970-09-05	1970-09-05 00:00:00	1970-09-05	38000177		0	0	0		0	0	0	175949	0	1190795	40243436		
15338	1281	46275916	2012-07-21	2012-07-21 00:00:00	2012-07-21	2012-07-21 00:00:00	2012-07-21	38000177		0	0	0		0	0	0	84706	0	1660014	46275916		
236388	5191	40213227	2012-11-29	2012-11-29 00:00:00	2012-11-29	2012-11-29 00:00:00	2012-11-29	581452		0	0	0		0	0	0	345070	0	113	40213227		
71489	1563	40213227	2007-09-01	2007-09-01 00:00:00	2007-09-01	2007-09-01 00:00:00	2007-09-01	581452		0	0	0		0	0	0	104722	0	113	40213227		
3060	67	40213227	2012-10-28	2012-10-28 00:00:00	2012-10-28	2012-10-28 00:00:00	2012-10-28	581452		0	0	0		0	0	0	4573	0	113	40213227		
238926	5245	40213314	1977-12-04	1977-12-04 00:00:00	1977-12-04	1977-12-04 00:00:00	1977-12-04	581452		0	0	0		0	0	0	349010	0	49	40213314		
200958	4413	40213160	1961-05-18	1961-05-18 00:00:00	1961-05-18	1961-05-18 00:00:00	1961-05-18	581452		0	0	0		0	0	0	293482	0	10	40213160		
18965	411	40213160	1959-08-01	1959-08-01 00:00:00	1959-08-01	1959-08-01 00:00:00	1959-08-01	581452		0	0	0		0	0	0	27273	0	10	40213160		
61088	1335	40213306	2001-10-22	2001-10-22 00:00:00	2001-10-22	2001-10-22 00:00:00	2001-10-22	581452		0	0	0		0	0	0	88591	0	43	40213306		
221645	4865	40213314	1977-01-05	1977-01-05 00:00:00	1977-01-05	1977-01-05 00:00:00	1977-01-05	581452		0	0	0		0	0	0	323548	0	49	40213314		
202070	4437	40213296	2010-06-30	2010-06-30 00:00:00	2010-06-30	2010-06-30 00:00:00	2010-06-30	581452		0	0	0		0	0	0	294915	0	52	40213296		
213400	4678	40213296	1996-10-08	1996-10-08 00:00:00	1996-10-08	1996-10-08 00:00:00	1996-10-08	581452		0	0	0		0	0	0	311799	0	52	40213296		
80888	1769	40213160	1975-01-01	1975-01-01 00:00:00	1975-01-01	1975-01-01 00:00:00	1975-01-01	581452		0	0	0		0	0	0	118310	0	10	40213160		
32068	2657	1310034	1970-09-05	1970-09-05 00:00:00	1970-09-05	1970-09-05 00:00:00	1970-09-05	38000177		0	0	0		0	0	0	175949	0	834357	1310034		
15339	1281	19059056	1972-02-22	1972-02-22 00:00:00	1972-03-07	1972-03-07 00:00:00	1972-03-07	38000177		0	0	14		0	0	0	84666	0	243670	19059056		
236397	5191	40213160	1975-07-31	1975-07-31 00:00:00	1975-07-31	1975-07-31 00:00:00	1975-07-31	581452		0	0	0		0	0	0	345075	0	10	40213160		
71490	1563	40213260	2007-09-01	2007-09-01 00:00:00	2007-09-01	2007-09-01 00:00:00	2007-09-01	581452		0	0	0		0	0	0	104722	0	121	40213260		
3065	67	40213160	1975-09-28	1975-09-28 00:00:00	1975-09-28	1975-09-28 00:00:00	1975-09-28	581452		0	0	0		0	0	0	4520	0	10	40213160		
238929	5245	40213160	1978-12-10	1978-12-10 00:00:00	1978-12-10	1978-12-10 00:00:00	1978-12-10	581452		0	0	0		0	0	0	348998	0	10	40213160		
200961	4413	40213260	2010-12-09	2010-12-09 00:00:00	2010-12-09	2010-12-09 00:00:00	2010-12-09	581452		0	0	0		0	0	0	293451	0	121	40213260		
18968	411	40213306	1982-01-02	1982-01-02 00:00:00	1982-01-02	1982-01-02 00:00:00	1982-01-02	581452		0	0	0		0	0	0	27300	0	43	40213306		
61098	1335	40213160	1983-07-25	1983-07-25 00:00:00	1983-07-25	1983-07-25 00:00:00	1983-07-25	581452		0	0	0		0	0	0	88587	0	10	40213160		
221651	4865	40213227	2005-05-04	2005-05-04 00:00:00	2005-05-04	2005-05-04 00:00:00	2005-05-04	581452		0	0	0		0	0	0	\N	0	113	40213227		
202079	4437	40213160	1969-04-16	1969-04-16 00:00:00	1969-04-16	1969-04-16 00:00:00	1969-04-16	581452		0	0	0		0	0	0	294927	0	10	40213160		
106879	2343	40213227	2017-07-01	2017-07-01 00:00:00	2017-07-01	2017-07-01 00:00:00	2017-07-01	581452		0	0	0		0	0	0	156006	0	113	40213227		
80889	1769	40213160	1975-03-05	1975-03-05 00:00:00	1975-03-05	1975-03-05 00:00:00	1975-03-05	581452		0	0	0		0	0	0	118326	0	10	40213160		
32069	2657	46275916	1970-09-05	1970-09-05 00:00:00	1970-09-05	1970-09-05 00:00:00	1970-09-05	38000177		0	0	0		0	0	0	175949	0	1660014	46275916		
15340	1281	19129655	1972-02-22	1972-02-22 00:00:00	1972-03-07	1972-03-07 00:00:00	1972-03-07	38000177		0	0	14		0	0	0	84666	0	789980	19129655		
236402	5191	40213306	1993-02-04	1993-02-04 00:00:00	1993-02-04	1993-02-04 00:00:00	1993-02-04	581452		0	0	0		0	0	0	345083	0	43	40213306		
38653	843	40213160	1982-10-09	1982-10-09 00:00:00	1982-10-09	1982-10-09 00:00:00	1982-10-09	581452		0	0	0		0	0	0	55798	0	10	40213160		
3069	67	40213296	2010-10-24	2010-10-24 00:00:00	2010-10-24	2010-10-24 00:00:00	2010-10-24	581452		0	0	0		0	0	0	4577	0	52	40213296		
238934	5245	40213227	2006-01-08	2006-01-08 00:00:00	2006-01-08	2006-01-08 00:00:00	2006-01-08	581452		0	0	0		0	0	0	348931	0	113	40213227		
200968	4413	40213160	1961-08-17	1961-08-17 00:00:00	1961-08-17	1961-08-17 00:00:00	1961-08-17	581452		0	0	0		0	0	0	293431	0	10	40213160		
40613	884	40213160	1978-05-16	1978-05-16 00:00:00	1978-05-16	1978-05-16 00:00:00	1978-05-16	581452		0	0	0		0	0	0	58915	0	10	40213160		
61113	1335	40213227	2010-06-07	2010-06-07 00:00:00	2010-06-07	2010-06-07 00:00:00	2010-06-07	581452		0	0	0		0	0	0	88570	0	113	40213227		
221654	4865	40213160	1979-01-10	1979-01-10 00:00:00	1979-01-10	1979-01-10 00:00:00	1979-01-10	581452		0	0	0		0	0	0	323528	0	10	40213160		
202081	4437	40213306	1991-04-17	1991-04-17 00:00:00	1991-04-17	1991-04-17 00:00:00	1991-04-17	581452		0	0	0		0	0	0	294896	0	43	40213306		
167040	3672	40213227	1995-02-27	1995-02-27 00:00:00	1995-02-27	1995-02-27 00:00:00	1995-02-27	581452		0	0	0		0	0	0	244268	0	113	40213227		
80895	1769	40213227	2006-09-27	2006-09-27 00:00:00	2006-09-27	2006-09-27 00:00:00	2006-09-27	581452		0	0	0		0	0	0	118317	0	113	40213227		
32070	2657	19133905	1989-08-15	1989-08-15 00:00:00	1989-08-23	1989-08-23 00:00:00	1989-08-23	38000177		0	0	8		0	0	0	175973	0	834102	19133905		
15341	1281	19059056	1973-12-02	1973-12-02 00:00:00	1973-12-16	1973-12-16 00:00:00	1973-12-16	38000177		0	0	14		0	0	0	84667	0	243670	19059056		
236403	5191	40213160	1970-11-26	1970-11-26 00:00:00	1970-11-26	1970-11-26 00:00:00	1970-11-26	581452		0	0	0		0	0	0	345094	0	10	40213160		
38654	843	40213251	1984-04-07	1984-04-07 00:00:00	1984-04-07	1984-04-07 00:00:00	1984-04-07	581452		0	0	0		0	0	0	55800	0	21	40213251		
23661	1947	19078461	1976-04-07	1976-04-07 00:00:00	1976-07-06	1976-07-06 00:00:00	1976-07-06	38000177		0	0	90		0	0	0	129466	0	310965	19078461		
238950	5245	40213296	2014-01-19	2014-01-19 00:00:00	2014-01-19	2014-01-19 00:00:00	2014-01-19	581452		0	0	0		0	0	0	349037	0	52	40213296		
239400	5255	40213227	2010-12-30	2010-12-30 00:00:00	2010-12-30	2010-12-30 00:00:00	2010-12-30	581452		0	0	0		0	0	0	349696	0	113	40213227		
61114	1335	40213314	1980-01-28	1980-01-28 00:00:00	1980-01-28	1980-01-28 00:00:00	1980-01-28	581452		0	0	0		0	0	0	88547	0	49	40213314		
221663	4865	40213314	1978-01-04	1978-01-04 00:00:00	1978-01-04	1978-01-04 00:00:00	1978-01-04	581452		0	0	0		0	0	0	323512	0	49	40213314		
95527	2094	40213227	1995-02-26	1995-02-26 00:00:00	1995-02-26	1995-02-26 00:00:00	1995-02-26	581452		0	0	0		0	0	0	139655	0	113	40213227		
167046	3672	40213160	1963-06-24	1963-06-24 00:00:00	1963-06-24	1963-06-24 00:00:00	1963-06-24	581452		0	0	0		0	0	0	244276	0	10	40213160		
80901	1769	40213296	2014-10-01	2014-10-01 00:00:00	2014-10-01	2014-10-01 00:00:00	2014-10-01	581452		0	0	0		0	0	0	118334	0	52	40213296		
32081	2659	19133873	1979-01-03	1979-01-03 00:00:00	1979-01-16	1979-01-16 00:00:00	1979-01-16	38000177		0	0	13		0	0	0	176118	0	834061	19133873		
15342	1281	19006318	1973-12-02	1973-12-02 00:00:00	1973-12-16	1973-12-16 00:00:00	1973-12-16	38000177		0	0	14		0	0	0	84667	0	105078	19006318		
236406	5191	40213160	1971-04-29	1971-04-29 00:00:00	1971-04-29	1971-04-29 00:00:00	1971-04-29	581452		0	0	0		0	0	0	345095	0	10	40213160		
38659	843	40213160	1982-08-07	1982-08-07 00:00:00	1982-08-07	1982-08-07 00:00:00	1982-08-07	581452		0	0	0		0	0	0	55816	0	10	40213160		
23662	1947	964261	1961-10-14	1961-10-14 00:00:00	1961-10-14	1961-10-14 00:00:00	\N	38000177		0	0	0		0	0	0	129425	0	2001499	964261		
238952	5245	40213227	2016-01-24	2016-01-24 00:00:00	2016-01-24	2016-01-24 00:00:00	2016-01-24	581452		0	0	0		0	0	0	349005	0	113	40213227		
239401	5255	40213260	2010-12-30	2010-12-30 00:00:00	2010-12-30	2010-12-30 00:00:00	2010-12-30	581452		0	0	0		0	0	0	349696	0	121	40213260		
61118	1335	40213251	1984-07-30	1984-07-30 00:00:00	1984-07-30	1984-07-30 00:00:00	1984-07-30	581452		0	0	0		0	0	0	88549	0	21	40213251		
221667	4865	40213160	1974-07-10	1974-07-10 00:00:00	1974-07-10	1974-07-10 00:00:00	1974-07-10	581452		0	0	0		0	0	0	323524	0	10	40213160		
95541	2094	40213201	2010-05-23	2010-05-23 00:00:00	2010-05-23	2010-05-23 00:00:00	2010-05-23	581452		0	0	0		0	0	0	139622	0	33	40213201		
167049	3672	40213306	1986-02-17	1986-02-17 00:00:00	1986-02-17	1986-02-17 00:00:00	1986-02-17	581452		0	0	0		0	0	0	244283	0	43	40213306		
80903	1769	40213160	1979-06-20	1979-06-20 00:00:00	1979-06-20	1979-06-20 00:00:00	1979-06-20	581452		0	0	0		0	0	0	118292	0	10	40213160		
32082	2659	1127433	2006-07-18	2006-07-18 00:00:00	2006-08-01	2006-08-01 00:00:00	2006-08-01	38000177		0	0	14		0	0	0	176121	0	313782	1127433		
60161	5000	1127433	2007-06-12	2007-06-12 00:00:00	2007-06-26	2007-06-26 00:00:00	2007-06-26	38000177		0	0	14		0	0	0	332528	0	313782	1127433		
236408	5191	40213160	1971-01-28	1971-01-28 00:00:00	1971-01-28	1971-01-28 00:00:00	1971-01-28	581452		0	0	0		0	0	0	345071	0	10	40213160		
38660	843	40213314	1982-08-07	1982-08-07 00:00:00	1982-08-07	1982-08-07 00:00:00	1982-08-07	581452		0	0	0		0	0	0	55816	0	49	40213314		
23663	1947	1127433	1968-02-01	1968-02-01 00:00:00	1968-02-15	1968-02-15 00:00:00	1968-02-15	38000177		0	0	14		0	0	0	129469	0	313782	1127433		
238953	5245	40213296	2016-01-24	2016-01-24 00:00:00	2016-01-24	2016-01-24 00:00:00	2016-01-24	581452		0	0	0		0	0	0	349005	0	52	40213296		
239403	5255	40213296	2002-01-03	2002-01-03 00:00:00	2002-01-03	2002-01-03 00:00:00	2002-01-03	581452		0	0	0		0	0	0	349661	0	52	40213296		
187241	4113	40213160	1958-12-22	1958-12-22 00:00:00	1958-12-22	1958-12-22 00:00:00	1958-12-22	581452		0	0	0		0	0	0	273432	0	10	40213160		
221668	4865	40213227	2015-08-12	2015-08-12 00:00:00	2015-08-12	2015-08-12 00:00:00	2015-08-12	581452		0	0	0		0	0	0	323541	0	113	40213227		
95542	2094	40213198	2010-05-23	2010-05-23 00:00:00	2010-05-23	2010-05-23 00:00:00	2010-05-23	581452		0	0	0		0	0	0	139622	0	133	40213198		
167051	3672	40213227	2005-07-11	2005-07-11 00:00:00	2005-07-11	2005-07-11 00:00:00	2005-07-11	581452		0	0	0		0	0	0	244321	0	113	40213227		
218810	4802	40213227	2016-05-08	2016-05-08 00:00:00	2016-05-08	2016-05-08 00:00:00	2016-05-08	581452		0	0	0		0	0	0	319426	0	113	40213227		
32083	2659	1127078	1976-09-13	1976-09-13 00:00:00	1976-09-27	1976-09-27 00:00:00	1976-09-27	38000177		0	0	14		0	0	0	176153	0	282464	1127078		
60162	5000	45892894	2017-11-09	2017-11-09 00:00:00	2017-11-09	2017-11-09 00:00:00	\N	38000177		0	0	0		0	0	0	332517	0	1599803	45892894		
241806	5309	40213227	1993-04-26	1993-04-26 00:00:00	1993-04-26	1993-04-26 00:00:00	1993-04-26	581452		0	0	0		0	0	0	353093	0	113	40213227		
38663	843	40213227	2004-07-03	2004-07-03 00:00:00	2004-07-03	2004-07-03 00:00:00	2004-07-03	581452		0	0	0		0	0	0	55823	0	113	40213227		
23664	1947	40229134	1950-02-11	1950-02-11 00:00:00	1950-02-25	1950-02-25 00:00:00	1950-02-25	38000177		0	0	14		0	0	0	129423	0	1043400	40229134		
238954	5245	40213160	1974-06-09	1974-06-09 00:00:00	1974-06-09	1974-06-09 00:00:00	1974-06-09	581452		0	0	0		0	0	0	349049	0	10	40213160		
239405	5255	40213227	2002-01-03	2002-01-03 00:00:00	2002-01-03	2002-01-03 00:00:00	2002-01-03	581452		0	0	0		0	0	0	349661	0	113	40213227		
187246	4113	40213260	2008-04-07	2008-04-07 00:00:00	2008-04-07	2008-04-07 00:00:00	2008-04-07	581452		0	0	0		0	0	0	273417	0	121	40213260		
185591	4078	40213201	2018-04-30	2018-04-30 00:00:00	2018-04-30	2018-04-30 00:00:00	2018-04-30	581452		0	0	0		0	0	0	270973	0	33	40213201		
95547	2094	40213227	2005-04-24	2005-04-24 00:00:00	2005-04-24	2005-04-24 00:00:00	2005-04-24	581452		0	0	0		0	0	0	139579	0	113	40213227		
167052	3672	40213296	2005-07-11	2005-07-11 00:00:00	2005-07-11	2005-07-11 00:00:00	2005-07-11	581452		0	0	0		0	0	0	244321	0	52	40213296		
218811	4802	40213260	2016-05-08	2016-05-08 00:00:00	2016-05-08	2016-05-08 00:00:00	2016-05-08	581452		0	0	0		0	0	0	319426	0	121	40213260		
32084	2659	46233988	1976-09-13	1976-09-13 00:00:00	1976-09-27	1976-09-27 00:00:00	1976-09-27	38000177		0	0	14		0	0	0	176153	0	1652673	46233988		
60163	5000	1127433	1980-08-17	1980-08-17 00:00:00	1980-09-14	1980-09-14 00:00:00	1980-09-14	38000177		0	0	28		0	0	0	332551	0	313782	1127433		
241820	5309	40213201	2017-05-01	2017-05-01 00:00:00	2017-05-01	2017-05-01 00:00:00	2017-05-01	581452		0	0	0		0	0	0	353113	0	33	40213201		
38664	843	40213306	2004-07-03	2004-07-03 00:00:00	2004-07-03	2004-07-03 00:00:00	2004-07-03	581452		0	0	0		0	0	0	55823	0	43	40213306		
23665	1947	19133873	1956-06-17	1956-06-17 00:00:00	1956-06-25	1956-06-25 00:00:00	1956-06-25	38000177		0	0	8		0	0	0	129432	0	834061	19133873		
115886	2546	40213314	1978-03-03	1978-03-03 00:00:00	1978-03-03	1978-03-03 00:00:00	1978-03-03	581452		0	0	0		0	0	0	168484	0	49	40213314		
239410	5255	40213160	1964-07-30	1964-07-30 00:00:00	1964-07-30	1964-07-30 00:00:00	1964-07-30	581452		0	0	0		0	0	0	349649	0	10	40213160		
187248	4113	40213296	1998-06-01	1998-06-01 00:00:00	1998-06-01	1998-06-01 00:00:00	1998-06-01	581452		0	0	0		0	0	0	273447	0	52	40213296		
185593	4078	40213227	1993-01-04	1993-01-04 00:00:00	1993-01-04	1993-01-04 00:00:00	1993-01-04	581452		0	0	0		0	0	0	271009	0	113	40213227		
198927	4370	40213160	1959-04-29	1959-04-29 00:00:00	1959-04-29	1959-04-29 00:00:00	1959-04-29	581452		0	0	0		0	0	0	290123	0	10	40213160		
167056	3672	40213260	2013-03-18	2013-03-18 00:00:00	2013-03-18	2013-03-18 00:00:00	2013-03-18	581452		0	0	0		0	0	0	244273	0	121	40213260		
218814	4802	40213296	2004-09-19	2004-09-19 00:00:00	2004-09-19	2004-09-19 00:00:00	2004-09-19	581452		0	0	0		0	0	0	319480	0	52	40213296		
32085	2659	1124300	2006-07-08	2006-07-08 00:00:00	2006-07-08	2006-07-08 00:00:00	\N	38000177		0	0	0		0	0	0	176173	0	00781178901	45011828		
60164	5000	19059056	1943-06-28	1943-06-28 00:00:00	1943-07-12	1943-07-12 00:00:00	1943-07-12	38000177		0	0	14		0	0	0	332549	0	243670	19059056		
2865	63	40213160	1956-05-24	1956-05-24 00:00:00	1956-05-24	1956-05-24 00:00:00	1956-05-24	581452		0	0	0		0	0	0	4246	0	10	40213160		
23666	1947	1127433	1979-04-05	1979-04-05 00:00:00	1979-04-12	1979-04-12 00:00:00	1979-04-12	38000177		0	0	7		0	0	0	129470	0	313782	1127433		
115896	2546	40213314	1977-09-02	1977-09-02 00:00:00	1977-09-02	1977-09-02 00:00:00	1977-09-02	581452		0	0	0		0	0	0	168513	0	49	40213314		
239415	5255	40213160	1960-09-01	1960-09-01 00:00:00	1960-09-01	1960-09-01 00:00:00	1960-09-01	581452		0	0	0		0	0	0	349638	0	10	40213160		
187263	4113	40213306	1981-06-08	1981-06-08 00:00:00	1981-06-08	1981-06-08 00:00:00	1981-06-08	581452		0	0	0		0	0	0	273406	0	43	40213306		
198932	4370	40213306	1981-09-02	1981-09-02 00:00:00	1981-09-02	1981-09-02 00:00:00	1981-09-02	581452		0	0	0		0	0	0	290095	0	43	40213306		
167062	3672	40213160	1963-08-26	1963-08-26 00:00:00	1963-08-26	1963-08-26 00:00:00	1963-08-26	581452		0	0	0		0	0	0	244311	0	10	40213160		
218819	4802	40213160	1965-02-20	1965-02-20 00:00:00	1965-02-20	1965-02-20 00:00:00	1965-02-20	581452		0	0	0		0	0	0	319463	0	10	40213160		
32086	2659	19019979	1979-06-19	1979-06-19 00:00:00	1979-09-17	1979-09-17 00:00:00	1979-09-17	38000177		0	0	90		0	0	0	176147	0	198405	19019979		
60165	5000	1713671	1950-12-06	1950-12-06 00:00:00	1950-12-27	1950-12-27 00:00:00	1950-12-27	38000177		0	0	21		0	0	0	332543	0	562251	1713671		
2871	63	40213227	2006-12-20	2006-12-20 00:00:00	2006-12-20	2006-12-20 00:00:00	2006-12-20	581452		0	0	0		0	0	0	4279	0	113	40213227		
23667	1947	1127078	1954-03-20	1954-03-20 00:00:00	1954-04-03	1954-04-03 00:00:00	1954-04-03	38000177		0	0	14		0	0	0	129464	0	282464	1127078		
115897	2546	40213306	1997-09-26	1997-09-26 00:00:00	1997-09-26	1997-09-26 00:00:00	1997-09-26	581452		0	0	0		0	0	0	168478	0	43	40213306		
239420	5255	40213160	1960-03-31	1960-03-31 00:00:00	1960-03-31	1960-03-31 00:00:00	1960-03-31	581452		0	0	0		0	0	0	349678	0	10	40213160		
187268	4113	40213227	2019-06-10	2019-06-10 00:00:00	2019-06-10	2019-06-10 00:00:00	2019-06-10	581452		0	0	0		0	0	0	273438	0	113	40213227		
155716	3427	40213160	1966-12-14	1966-12-14 00:00:00	1966-12-14	1966-12-14 00:00:00	1966-12-14	581452		0	0	0		0	0	0	227191	0	10	40213160		
167064	3672	40213227	2014-03-24	2014-03-24 00:00:00	2014-03-24	2014-03-24 00:00:00	2014-03-24	581452		0	0	0		0	0	0	244323	0	113	40213227		
218824	4802	40213227	2006-09-24	2006-09-24 00:00:00	2006-09-24	2006-09-24 00:00:00	2006-09-24	581452		0	0	0		0	0	0	319430	0	113	40213227		
32087	2659	40162522	2017-02-20	2017-02-20 00:00:00	2017-02-20	2017-02-20 00:00:00	\N	38000177		0	0	0		0	0	0	176149	0	857005	40162522		
60166	5000	1713671	2013-06-03	2013-06-03 00:00:00	2013-06-10	2013-06-10 00:00:00	2013-06-10	38000177		0	0	7		0	0	0	332548	0	562251	1713671		
2872	63	40213260	2006-12-20	2006-12-20 00:00:00	2006-12-20	2006-12-20 00:00:00	2006-12-20	581452		0	0	0		0	0	0	4279	0	121	40213260		
23668	1947	1127433	2012-08-10	2012-08-10 00:00:00	2012-09-07	2012-09-07 00:00:00	2012-09-07	38000177		0	0	28		0	0	0	129394	0	313782	1127433		
115899	2546	40213227	1997-09-26	1997-09-26 00:00:00	1997-09-26	1997-09-26 00:00:00	1997-09-26	581452		0	0	0		0	0	0	168478	0	113	40213227		
239425	5255	40213306	1982-09-23	1982-09-23 00:00:00	1982-09-23	1982-09-23 00:00:00	1982-09-23	581452		0	0	0		0	0	0	349653	0	43	40213306		
187277	4113	40213227	2009-04-13	2009-04-13 00:00:00	2009-04-13	2009-04-13 00:00:00	2009-04-13	581452		0	0	0		0	0	0	273451	0	113	40213227		
155719	3427	40213160	1966-07-13	1966-07-13 00:00:00	1966-07-13	1966-07-13 00:00:00	1966-07-13	581452		0	0	0		0	0	0	227190	0	10	40213160		
167065	3672	40213260	2014-03-24	2014-03-24 00:00:00	2014-03-24	2014-03-24 00:00:00	2014-03-24	581452		0	0	0		0	0	0	244323	0	121	40213260		
218825	4802	40213296	2006-09-24	2006-09-24 00:00:00	2006-09-24	2006-09-24 00:00:00	2006-09-24	581452		0	0	0		0	0	0	319430	0	52	40213296		
32088	2659	1127433	2017-02-20	2017-02-20 00:00:00	2017-04-21	2017-04-21 00:00:00	2017-04-21	38000177		0	0	60		0	0	0	176149	0	313782	1127433		
60167	5000	19077572	2016-08-16	2016-08-16 00:00:00	2016-08-16	2016-08-16 00:00:00	\N	38000177		0	0	0		0	0	0	332575	0	310436	19077572		
2885	64	40213296	2016-11-02	2016-11-02 00:00:00	2016-11-02	2016-11-02 00:00:00	2016-11-02	581452		0	0	0		0	0	0	4358	0	52	40213296		
23669	1947	40173590	2009-06-21	2009-06-21 00:00:00	2009-06-21	2009-06-21 00:00:00	\N	38000177		0	0	0		0	0	0	129400	0	904419	40173590		
115901	2546	40213160	1975-07-04	1975-07-04 00:00:00	1975-07-04	1975-07-04 00:00:00	1975-07-04	581452		0	0	0		0	0	0	168469	0	10	40213160		
239429	5255	40213260	2009-12-24	2009-12-24 00:00:00	2009-12-24	2009-12-24 00:00:00	2009-12-24	581452		0	0	0		0	0	0	349693	0	121	40213260		
187279	4113	40213260	2009-04-13	2009-04-13 00:00:00	2009-04-13	2009-04-13 00:00:00	2009-04-13	581452		0	0	0		0	0	0	273451	0	121	40213260		
155724	3427	40213160	1971-03-17	1971-03-17 00:00:00	1971-03-17	1971-03-17 00:00:00	1971-03-17	581452		0	0	0		0	0	0	227233	0	10	40213160		
167071	3672	40213160	1968-02-26	1968-02-26 00:00:00	1968-02-26	1968-02-26 00:00:00	1968-02-26	581452		0	0	0		0	0	0	244315	0	10	40213160		
218831	4802	40213306	1986-11-29	1986-11-29 00:00:00	1986-11-29	1986-11-29 00:00:00	1986-11-29	581452		0	0	0		0	0	0	319451	0	43	40213306		
32089	2659	19019979	1977-09-08	1977-09-08 00:00:00	1977-10-06	1977-10-06 00:00:00	1977-10-06	38000177		0	0	28		0	0	0	176145	0	198405	19019979		
60168	5000	1127433	1979-01-28	1979-01-28 00:00:00	1979-02-04	1979-02-04 00:00:00	1979-02-04	38000177		0	0	7		0	0	0	332540	0	313782	1127433		
2888	64	40213227	2016-11-02	2016-11-02 00:00:00	2016-11-02	2016-11-02 00:00:00	2016-11-02	581452		0	0	0		0	0	0	4358	0	113	40213227		
23670	1947	1127078	1952-12-25	1952-12-25 00:00:00	1953-01-08	1953-01-08 00:00:00	1953-01-08	38000177		0	0	14		0	0	0	129439	0	282464	1127078		
115902	2546	40213314	1977-03-04	1977-03-04 00:00:00	1977-03-04	1977-03-04 00:00:00	1977-03-04	581452		0	0	0		0	0	0	168501	0	49	40213314		
239432	5255	40213227	1994-08-11	1994-08-11 00:00:00	1994-08-11	1994-08-11 00:00:00	1994-08-11	581452		0	0	0		0	0	0	349659	0	113	40213227		
187285	4113	40213227	2000-06-05	2000-06-05 00:00:00	2000-06-05	2000-06-05 00:00:00	2000-06-05	581452		0	0	0		0	0	0	273416	0	113	40213227		
155726	3427	40213296	2007-09-12	2007-09-12 00:00:00	2007-09-12	2007-09-12 00:00:00	2007-09-12	581452		0	0	0		0	0	0	227223	0	52	40213296		
167074	3672	40213306	1985-09-09	1985-09-09 00:00:00	1985-09-09	1985-09-09 00:00:00	1985-09-09	581452		0	0	0		0	0	0	244320	0	43	40213306		
218833	4802	40213160	1964-12-19	1964-12-19 00:00:00	1964-12-19	1964-12-19 00:00:00	1964-12-19	581452		0	0	0		0	0	0	319467	0	10	40213160		
32090	2659	19078461	2015-03-12	2015-03-12 00:00:00	2015-04-02	2015-04-02 00:00:00	2015-04-02	38000177		0	0	21		0	0	0	176148	0	310965	19078461		
60169	5000	1127433	1953-04-08	1953-04-08 00:00:00	1953-04-15	1953-04-15 00:00:00	1953-04-15	38000177		0	0	7		0	0	0	332512	0	313782	1127433		
2889	64	40213314	1978-03-29	1978-03-29 00:00:00	1978-03-29	1978-03-29 00:00:00	1978-03-29	581452		0	0	0		0	0	0	4339	0	49	40213314		
23671	1947	19006318	1952-12-25	1952-12-25 00:00:00	1953-01-08	1953-01-08 00:00:00	1953-01-08	38000177		0	0	14		0	0	0	129439	0	105078	19006318		
115906	2546	40213296	2019-01-25	2019-01-25 00:00:00	2019-01-25	2019-01-25 00:00:00	2019-01-25	581452		0	0	0		0	0	0	168498	0	52	40213296		
239442	5256	40213260	2010-10-08	2010-10-08 00:00:00	2010-10-08	2010-10-08 00:00:00	2010-10-08	581452		0	0	0		0	0	0	349757	0	121	40213260		
164525	3618	40213227	1992-03-14	1992-03-14 00:00:00	1992-03-14	1992-03-14 00:00:00	1992-03-14	581452		0	0	0		0	0	0	240351	0	113	40213227		
155728	3427	40213227	2007-09-12	2007-09-12 00:00:00	2007-09-12	2007-09-12 00:00:00	2007-09-12	581452		0	0	0		0	0	0	227223	0	113	40213227		
167080	3672	40213160	1963-11-25	1963-11-25 00:00:00	1963-11-25	1963-11-25 00:00:00	1963-11-25	581452		0	0	0		0	0	0	244277	0	10	40213160		
218835	4802	40213160	1965-05-23	1965-05-23 00:00:00	1965-05-23	1965-05-23 00:00:00	1965-05-23	581452		0	0	0		0	0	0	319468	0	10	40213160		
30129	656	40213260	2015-06-20	2015-06-20 00:00:00	2015-06-20	2015-06-20 00:00:00	2015-06-20	581452		0	0	0		0	0	0	43503	0	121	40213260		
60170	5001	1118084	1997-01-03	1997-01-03 00:00:00	1997-01-03	1997-01-03 00:00:00	\N	38000177		0	0	0		0	0	0	332664	0	00025152531	44923712		
2890	64	40213160	1975-01-29	1975-01-29 00:00:00	1975-01-29	1975-01-29 00:00:00	1975-01-29	581452		0	0	0		0	0	0	4371	0	10	40213160		
23672	1947	920300	1976-11-04	1976-11-04 00:00:00	1976-11-11	1976-11-11 00:00:00	1976-11-11	38000177		0	0	7		0	0	0	129428	0	311989	920300		
117898	2591	40213227	2003-01-22	2003-01-22 00:00:00	2003-01-22	2003-01-22 00:00:00	2003-01-22	581452		0	0	0		0	0	0	171535	0	113	40213227		
155730	3427	40213260	2017-04-12	2017-04-12 00:00:00	2017-04-12	2017-04-12 00:00:00	2017-04-12	581452		0	0	0		0	0	0	227243	0	121	40213260		
40854	890	40213227	1993-08-13	1993-08-13 00:00:00	1993-08-13	1993-08-13 00:00:00	1993-08-13	581452		0	0	0		0	0	0	59365	0	113	40213227		
152083	3347	40213160	1959-01-17	1959-01-17 00:00:00	1959-01-17	1959-01-17 00:00:00	1959-01-17	581452		0	0	0		0	0	0	222029	0	10	40213160		
30131	656	40213227	2015-06-20	2015-06-20 00:00:00	2015-06-20	2015-06-20 00:00:00	2015-06-20	581452		0	0	0		0	0	0	43503	0	113	40213227		
60171	5001	1713671	1974-02-05	1974-02-05 00:00:00	1974-02-12	1974-02-12 00:00:00	1974-02-12	38000177		0	0	7		0	0	0	332617	0	562251	1713671		
2893	64	40213227	1997-04-30	1997-04-30 00:00:00	1997-04-30	1997-04-30 00:00:00	1997-04-30	581452		0	0	0		0	0	0	4344	0	113	40213227		
23673	1947	40236824	1976-11-04	1976-11-04 00:00:00	1976-11-11	1976-11-11 00:00:00	1976-11-11	38000177		0	0	7		0	0	0	129428	0	1094107	40236824		
176937	3889	40213227	2009-02-08	2009-02-08 00:00:00	2009-02-08	2009-02-08 00:00:00	2009-02-08	581452		0	0	0		0	0	0	258545	0	113	40213227		
167037	3672	40213296	2003-03-24	2003-03-24 00:00:00	2003-03-24	2003-03-24 00:00:00	2003-03-24	581452		0	0	0		0	0	0	244267	0	52	40213296		
40858	890	40213227	2010-06-04	2010-06-04 00:00:00	2010-06-04	2010-06-04 00:00:00	2010-06-04	581452		0	0	0		0	0	0	59345	0	113	40213227		
152084	3347	40213296	1996-03-16	1996-03-16 00:00:00	1996-03-16	1996-03-16 00:00:00	1996-03-16	581452		0	0	0		0	0	0	222097	0	52	40213296		
30132	656	40213227	2006-06-03	2006-06-03 00:00:00	2006-06-03	2006-06-03 00:00:00	2006-06-03	581452		0	0	0		0	0	0	43457	0	113	40213227		
60172	5001	1127433	1993-09-24	1993-09-24 00:00:00	1993-10-15	1993-10-15 00:00:00	1993-10-15	38000177		0	0	21		0	0	0	332671	0	313782	1127433		
2894	64	40213306	1997-04-30	1997-04-30 00:00:00	1997-04-30	1997-04-30 00:00:00	1997-04-30	581452		0	0	0		0	0	0	4344	0	43	40213306		
23674	1947	1127433	1986-12-20	1986-12-20 00:00:00	1986-12-27	1986-12-27 00:00:00	1986-12-27	38000177		0	0	7		0	0	0	129435	0	313782	1127433		
176963	3889	40213201	2003-10-12	2003-10-12 00:00:00	2003-10-12	2003-10-12 00:00:00	2003-10-12	581452		0	0	0		0	0	0	258492	0	33	40213201		
221669	4865	40213296	2015-08-12	2015-08-12 00:00:00	2015-08-12	2015-08-12 00:00:00	2015-08-12	581452		0	0	0		0	0	0	323541	0	52	40213296		
40859	890	40213260	2010-06-04	2010-06-04 00:00:00	2010-06-04	2010-06-04 00:00:00	2010-06-04	581452		0	0	0		0	0	0	59345	0	121	40213260		
152086	3347	40213227	1996-03-16	1996-03-16 00:00:00	1996-03-16	1996-03-16 00:00:00	1996-03-16	581452		0	0	0		0	0	0	222097	0	113	40213227		
30133	656	40213296	2006-06-03	2006-06-03 00:00:00	2006-06-03	2006-06-03 00:00:00	2006-06-03	581452		0	0	0		0	0	0	43457	0	52	40213296		
60173	5001	19059056	1975-04-25	1975-04-25 00:00:00	1975-07-01	1975-07-01 00:00:00	1975-07-01	38000177		0	0	67		0	0	0	332670	0	243670	19059056		
2897	64	40213160	1975-07-02	1975-07-02 00:00:00	1975-07-02	1975-07-02 00:00:00	1975-07-02	581452		0	0	0		0	0	0	4334	0	10	40213160		
23675	1947	1127433	1991-08-17	1991-08-17 00:00:00	1991-08-31	1991-08-31 00:00:00	1991-08-31	38000177		0	0	14		0	0	0	129468	0	313782	1127433		
199536	4383	40213160	1969-07-26	1969-07-26 00:00:00	1969-07-26	1969-07-26 00:00:00	1969-07-26	581452		0	0	0		0	0	0	291308	0	10	40213160		
40864	890	40213160	1960-02-05	1960-02-05 00:00:00	1960-02-05	1960-02-05 00:00:00	1960-02-05	581452		0	0	0		0	0	0	59337	0	10	40213160		
152095	3347	40213160	1955-07-23	1955-07-23 00:00:00	1955-07-23	1955-07-23 00:00:00	1955-07-23	581452		0	0	0		0	0	0	222071	0	10	40213160		
30139	656	40213296	2004-05-29	2004-05-29 00:00:00	2004-05-29	2004-05-29 00:00:00	2004-05-29	581452		0	0	0		0	0	0	43502	0	52	40213296		
60174	5001	1127433	2000-06-07	2000-06-07 00:00:00	2000-06-21	2000-06-21 00:00:00	2000-06-21	38000177		0	0	14		0	0	0	332655	0	313782	1127433		
2900	64	40213296	2014-10-29	2014-10-29 00:00:00	2014-10-29	2014-10-29 00:00:00	2014-10-29	581452		0	0	0		0	0	0	4361	0	52	40213296		
23676	1947	1118084	1989-10-22	1989-10-22 00:00:00	1989-10-22	1989-10-22 00:00:00	\N	38000177		0	0	0		0	0	0	129387	0	00025152531	44923712		
199540	4383	40213296	2010-11-27	2010-11-27 00:00:00	2010-11-27	2010-11-27 00:00:00	2010-11-27	581452		0	0	0		0	0	0	291348	0	52	40213296		
198979	4372	40213314	1981-07-16	1981-07-16 00:00:00	1981-07-16	1981-07-16 00:00:00	1981-07-16	581452		0	0	0		0	0	0	290215	0	49	40213314		
152098	3347	40213160	1955-01-22	1955-01-22 00:00:00	1955-01-22	1955-01-22 00:00:00	1955-01-22	581452		0	0	0		0	0	0	222026	0	10	40213160		
30150	656	40213160	1964-06-13	1964-06-13 00:00:00	1964-06-13	1964-06-13 00:00:00	1964-06-13	581452		0	0	0		0	0	0	43449	0	10	40213160		
60175	5001	40229134	2006-12-19	2006-12-19 00:00:00	2006-12-26	2006-12-26 00:00:00	2006-12-26	38000177		0	0	7		0	0	0	332638	0	1043400	40229134		
100347	2199	40213306	2001-09-23	2001-09-23 00:00:00	2001-09-23	2001-09-23 00:00:00	2001-09-23	581452		0	0	0		0	0	0	146576	0	43	40213306		
23677	1947	1127433	1951-12-17	1951-12-17 00:00:00	1951-12-24	1951-12-24 00:00:00	1951-12-24	38000177		0	0	7		0	0	0	129391	0	313782	1127433		
199541	4383	40213306	1991-07-27	1991-07-27 00:00:00	1991-07-27	1991-07-27 00:00:00	1991-07-27	581452		0	0	0		0	0	0	291296	0	43	40213306		
198984	4372	40213227	2004-02-19	2004-02-19 00:00:00	2004-02-19	2004-02-19 00:00:00	2004-02-19	581452		0	0	0		0	0	0	290280	0	113	40213227		
152103	3347	40213227	2015-11-07	2015-11-07 00:00:00	2015-11-07	2015-11-07 00:00:00	2015-11-07	581452		0	0	0		0	0	0	222101	0	113	40213227		
30153	656	40213160	1964-04-11	1964-04-11 00:00:00	1964-04-11	1964-04-11 00:00:00	1964-04-11	581452		0	0	0		0	0	0	43475	0	10	40213160		
60176	5001	40229134	1965-02-11	1965-02-11 00:00:00	1965-02-18	1965-02-18 00:00:00	1965-02-18	38000177		0	0	7		0	0	0	332616	0	1043400	40229134		
12249	264	40213160	1955-07-01	1955-07-01 00:00:00	1955-07-01	1955-07-01 00:00:00	1955-07-01	581452		0	0	0		0	0	0	17518	0	10	40213160		
23698	1950	19133873	1951-04-08	1951-04-08 00:00:00	1951-04-17	1951-04-17 00:00:00	1951-04-17	38000177		0	0	9		0	0	0	129710	0	834061	19133873		
199543	4383	40213227	2010-11-27	2010-11-27 00:00:00	2010-11-27	2010-11-27 00:00:00	2010-11-27	581452		0	0	0		0	0	0	291348	0	113	40213227		
198985	4372	40213306	2004-02-19	2004-02-19 00:00:00	2004-02-19	2004-02-19 00:00:00	2004-02-19	581452		0	0	0		0	0	0	290280	0	43	40213306		
152107	3347	40213296	1998-03-21	1998-03-21 00:00:00	1998-03-21	1998-03-21 00:00:00	1998-03-21	581452		0	0	0		0	0	0	222076	0	52	40213296		
30155	656	40213306	1986-03-08	1986-03-08 00:00:00	1986-03-08	1986-03-08 00:00:00	1986-03-08	581452		0	0	0		0	0	0	43438	0	43	40213306		
60177	5001	1127078	1961-10-14	1961-10-14 00:00:00	1961-10-28	1961-10-28 00:00:00	1961-10-28	38000177		0	0	14		0	0	0	332658	0	282464	1127078		
23699	1950	40169281	1985-01-10	1985-01-10 00:00:00	1985-01-10	1985-01-10 00:00:00	\N	38000177		0	0	0		0	0	0	129690	0	896209	40169281		
199545	4383	40213227	2000-03-18	2000-03-18 00:00:00	2000-03-18	2000-03-18 00:00:00	2000-03-18	581452		0	0	0		0	0	0	\N	0	113	40213227		
198989	4372	40213251	1984-02-02	1984-02-02 00:00:00	1984-02-02	1984-02-02 00:00:00	1984-02-02	581452		0	0	0		0	0	0	290296	0	21	40213251		
152109	3347	40213260	2007-09-22	2007-09-22 00:00:00	2007-09-22	2007-09-22 00:00:00	2007-09-22	581452		0	0	0		0	0	0	222050	0	121	40213260		
30157	656	40213160	1968-12-14	1968-12-14 00:00:00	1968-12-14	1968-12-14 00:00:00	1968-12-14	581452		0	0	0		0	0	0	43453	0	10	40213160		
60178	5001	40229134	1961-01-19	1961-01-19 00:00:00	1961-02-02	1961-02-02 00:00:00	1961-02-02	38000177		0	0	14		0	0	0	332615	0	1043400	40229134		
23700	1950	40173590	2011-01-06	2011-01-06 00:00:00	2011-01-06	2011-01-06 00:00:00	\N	38000177		0	0	0		0	0	0	129709	0	904419	40173590		
199551	4383	40213260	2018-11-17	2018-11-17 00:00:00	2018-11-17	2018-11-17 00:00:00	2018-11-17	581452		0	0	0		0	0	0	291317	0	121	40213260		
198994	4372	40213160	1981-01-15	1981-01-15 00:00:00	1981-01-15	1981-01-15 00:00:00	1981-01-15	581452		0	0	0		0	0	0	290310	0	10	40213160		
152119	3347	40213227	2005-09-10	2005-09-10 00:00:00	2005-09-10	2005-09-10 00:00:00	2005-09-10	581452		0	0	0		0	0	0	222057	0	113	40213227		
82777	1809	40213160	1963-05-22	1963-05-22 00:00:00	1963-05-22	1963-05-22 00:00:00	1963-05-22	581452		0	0	0		0	0	0	121143	0	10	40213160		
60179	5001	19133873	1969-12-19	1969-12-19 00:00:00	1969-12-27	1969-12-27 00:00:00	1969-12-27	38000177		0	0	8		0	0	0	332647	0	834061	19133873		
23701	1950	1127433	1998-12-09	1998-12-09 00:00:00	1998-12-16	1998-12-16 00:00:00	1998-12-16	38000177		0	0	7		0	0	0	129667	0	313782	1127433		
199555	4383	40213160	1969-04-26	1969-04-26 00:00:00	1969-04-26	1969-04-26 00:00:00	1969-04-26	581452		0	0	0		0	0	0	291340	0	10	40213160		
198995	4372	40213314	1980-10-16	1980-10-16 00:00:00	1980-10-16	1980-10-16 00:00:00	1980-10-16	581452		0	0	0		0	0	0	290214	0	49	40213314		
152120	3347	40213160	1955-04-23	1955-04-23 00:00:00	1955-04-23	1955-04-23 00:00:00	1955-04-23	581452		0	0	0		0	0	0	222043	0	10	40213160		
82779	1809	40213160	1967-11-22	1967-11-22 00:00:00	1967-11-22	1967-11-22 00:00:00	1967-11-22	581452		0	0	0		0	0	0	121147	0	10	40213160		
60180	5001	1127078	1970-01-30	1970-01-30 00:00:00	1970-02-20	1970-02-20 00:00:00	1970-02-20	38000177		0	0	21		0	0	0	332684	0	282464	1127078		
23702	1950	1127433	1988-08-29	1988-08-29 00:00:00	1988-09-19	1988-09-19 00:00:00	1988-09-19	38000177		0	0	21		0	0	0	129716	0	313782	1127433		
196932	4328	40213160	1975-05-14	1975-05-14 00:00:00	1975-05-14	1975-05-14 00:00:00	1975-05-14	581452		0	0	0		0	0	0	287034	0	10	40213160		
198996	4372	40213160	1980-10-16	1980-10-16 00:00:00	1980-10-16	1980-10-16 00:00:00	1980-10-16	581452		0	0	0		0	0	0	290214	0	10	40213160		
132252	2905	40213160	1967-03-06	1967-03-06 00:00:00	1967-03-06	1967-03-06 00:00:00	1967-03-06	581452		0	0	0		0	0	0	193546	0	10	40213160		
82781	1809	40213296	2002-12-18	2002-12-18 00:00:00	2002-12-18	2002-12-18 00:00:00	2002-12-18	581452		0	0	0		0	0	0	121135	0	52	40213296		
60181	5001	19059056	1973-05-05	1973-05-05 00:00:00	1973-06-04	1973-06-04 00:00:00	1973-06-04	38000177		0	0	30		0	0	0	332685	0	243670	19059056		
23703	1950	19059056	1944-06-23	1944-06-23 00:00:00	1944-07-07	1944-07-07 00:00:00	1944-07-07	38000177		0	0	14		0	0	0	129633	0	243670	19059056		
196934	4328	40213306	1993-03-10	1993-03-10 00:00:00	1993-03-10	1993-03-10 00:00:00	1993-03-10	581452		0	0	0		0	0	0	287065	0	43	40213306		
199008	4372	40213251	1985-02-07	1985-02-07 00:00:00	1985-02-07	1985-02-07 00:00:00	1985-02-07	581452		0	0	0		0	0	0	290313	0	21	40213251		
132254	2905	40213306	1989-01-30	1989-01-30 00:00:00	1989-01-30	1989-01-30 00:00:00	1989-01-30	581452		0	0	0		0	0	0	193557	0	43	40213306		
82786	1809	40213227	2004-12-22	2004-12-22 00:00:00	2004-12-22	2004-12-22 00:00:00	2004-12-22	581452		0	0	0		0	0	0	121107	0	113	40213227		
60182	5001	40165015	1973-05-05	1973-05-05 00:00:00	1973-05-05	1973-05-05 00:00:00	\N	38000177		0	0	0		0	0	0	332685	0	861467	40165015		
23704	1950	1127433	1956-06-20	1956-06-20 00:00:00	1956-07-18	1956-07-18 00:00:00	1956-07-18	38000177		0	0	28		0	0	0	129714	0	313782	1127433		
196938	4328	40213227	1993-03-10	1993-03-10 00:00:00	1993-03-10	1993-03-10 00:00:00	1993-03-10	581452		0	0	0		0	0	0	287065	0	113	40213227		
199011	4372	40213160	1985-02-07	1985-02-07 00:00:00	1985-02-07	1985-02-07 00:00:00	1985-02-07	581452		0	0	0		0	0	0	290313	0	10	40213160		
132256	2905	40213227	2017-12-04	2017-12-04 00:00:00	2017-12-04	2017-12-04 00:00:00	2017-12-04	581452		0	0	0		0	0	0	193594	0	113	40213227		
82787	1809	40213296	2004-12-22	2004-12-22 00:00:00	2004-12-22	2004-12-22 00:00:00	2004-12-22	581452		0	0	0		0	0	0	121107	0	52	40213296		
60183	5002	19078461	1988-07-05	1988-07-05 00:00:00	1988-08-09	1988-08-09 00:00:00	1988-08-09	38000177		0	0	35		0	0	0	332712	0	310965	19078461		
23705	1950	19078461	2016-01-26	2016-01-26 00:00:00	2016-03-26	2016-03-26 00:00:00	2016-03-26	38000177		0	0	60		0	0	0	129717	0	310965	19078461		
196942	4328	40213160	1970-09-09	1970-09-09 00:00:00	1970-09-09	1970-09-09 00:00:00	1970-09-09	581452		0	0	0		0	0	0	287040	0	10	40213160		
199012	4372	40213160	1980-08-14	1980-08-14 00:00:00	1980-08-14	1980-08-14 00:00:00	1980-08-14	581452		0	0	0		0	0	0	290234	0	10	40213160		
132257	2905	40213260	2017-12-04	2017-12-04 00:00:00	2017-12-04	2017-12-04 00:00:00	2017-12-04	581452		0	0	0		0	0	0	193594	0	121	40213260		
82790	1809	40213227	1994-02-23	1994-02-23 00:00:00	1994-02-23	1994-02-23 00:00:00	1994-02-23	581452		0	0	0		0	0	0	121106	0	113	40213227		
60184	5002	46233988	1970-06-10	1970-06-10 00:00:00	1976-10-20	1976-10-20 00:00:00	1976-10-20	38000177		0	0	2324		0	0	0	332705	0	1652673	46233988		
23706	1950	40165015	2016-01-26	2016-01-26 00:00:00	2016-01-26	2016-01-26 00:00:00	\N	38000177		0	0	0		0	0	0	129717	0	861467	40165015		
196945	4328	40213160	1971-02-10	1971-02-10 00:00:00	1971-02-10	1971-02-10 00:00:00	1971-02-10	581452		0	0	0		0	0	0	287041	0	10	40213160		
199013	4372	40213314	1980-08-14	1980-08-14 00:00:00	1980-08-14	1980-08-14 00:00:00	1980-08-14	581452		0	0	0		0	0	0	290234	0	49	40213314		
132259	2905	40213160	1971-11-08	1971-11-08 00:00:00	1971-11-08	1971-11-08 00:00:00	1971-11-08	581452		0	0	0		0	0	0	193570	0	10	40213160		
82794	1809	40213160	1963-08-21	1963-08-21 00:00:00	1963-08-21	1963-08-21 00:00:00	1963-08-21	581452		0	0	0		0	0	0	121101	0	10	40213160		
60185	5002	19019979	1976-10-06	1976-10-06 00:00:00	1976-10-20	1976-10-20 00:00:00	1976-10-20	38000177		0	0	14		0	0	0	332705	0	198405	19019979		
62066	5165	40229134	1970-09-09	1970-09-09 00:00:00	1970-09-16	1970-09-16 00:00:00	1970-09-16	38000177		0	0	7		0	0	0	343255	0	1043400	40229134		
199014	4372	40213227	2012-10-18	2012-10-18 00:00:00	2012-10-18	2012-10-18 00:00:00	2012-10-18	581452		0	0	0		0	0	0	290283	0	113	40213227		
132264	2905	40213160	1967-05-08	1967-05-08 00:00:00	1967-05-08	1967-05-08 00:00:00	1967-05-08	581452		0	0	0		0	0	0	193588	0	10	40213160		
177745	3906	40213198	2010-10-20	2010-10-20 00:00:00	2010-10-20	2010-10-20 00:00:00	2010-10-20	581452		0	0	0		0	0	0	259706	0	133	40213198		
60186	5002	19129655	1977-09-13	1977-09-13 00:00:00	1977-09-27	1977-09-27 00:00:00	1977-09-27	38000177		0	0	14		0	0	0	332718	0	789980	19129655		
62067	5165	19133873	1973-02-15	1973-02-15 00:00:00	1973-02-27	1973-02-27 00:00:00	1973-02-27	38000177		0	0	12		0	0	0	343289	0	834061	19133873		
199559	4383	40213296	2008-11-22	2008-11-22 00:00:00	2008-11-22	2008-11-22 00:00:00	2008-11-22	581452		0	0	0		0	0	0	291315	0	52	40213296		
132266	2905	40213227	2009-07-06	2009-07-06 00:00:00	2009-07-06	2009-07-06 00:00:00	2009-07-06	581452		0	0	0		0	0	0	193584	0	113	40213227		
11285	939	40229134	1989-11-02	1989-11-02 00:00:00	1989-11-09	1989-11-09 00:00:00	1989-11-09	38000177		0	0	7		0	0	0	62439	0	1043400	40229134		
60187	5002	1127078	1977-09-13	1977-09-13 00:00:00	1977-09-27	1977-09-27 00:00:00	1977-09-27	38000177		0	0	14		0	0	0	332718	0	282464	1127078		
62068	5165	1118084	2008-02-20	2008-02-20 00:00:00	2008-02-20	2008-02-20 00:00:00	\N	38000177		0	0	0		0	0	0	343395	0	00025152531	44923712		
199563	4383	40213160	1969-02-22	1969-02-22 00:00:00	1969-02-22	1969-02-22 00:00:00	1969-02-22	581452		0	0	0		0	0	0	291331	0	10	40213160		
132269	2906	40213201	1990-06-23	1990-06-23 00:00:00	1990-06-23	1990-06-23 00:00:00	1990-06-23	581452		0	0	0		0	0	0	193684	0	33	40213201		
11286	939	1127433	2014-09-13	2014-09-13 00:00:00	2014-09-20	2014-09-20 00:00:00	2014-09-20	38000177		0	0	7		0	0	0	62443	0	313782	1127433		
60188	5002	1124300	2019-03-15	2019-03-15 00:00:00	2019-03-15	2019-03-15 00:00:00	\N	38000177		0	0	0		0	0	0	332700	0	00781178901	45011828		
62069	5165	1115171	2011-09-16	2011-09-16 00:00:00	2011-10-21	2011-10-21 00:00:00	2011-10-21	38000177		0	0	35		0	0	0	343398	0	849574	1115171		
199569	4383	40213160	1973-10-27	1973-10-27 00:00:00	1973-10-27	1973-10-27 00:00:00	1973-10-27	581452		0	0	0		0	0	0	291343	0	10	40213160		
16229	350	40213260	2009-11-13	2009-11-13 00:00:00	2009-11-13	2009-11-13 00:00:00	2009-11-13	581452		0	0	0		0	0	0	23337	0	121	40213260		
11287	939	1127433	2001-06-05	2001-06-05 00:00:00	2001-06-19	2001-06-19 00:00:00	2001-06-19	38000177		0	0	14		0	0	0	62432	0	313782	1127433		
62070	5165	1127433	1974-12-26	1974-12-26 00:00:00	1975-01-02	1975-01-02 00:00:00	1975-01-02	38000177		0	0	7		0	0	0	343268	0	313782	1127433		
199577	4384	40213260	2018-01-01	2018-01-01 00:00:00	2018-01-01	2018-01-01 00:00:00	2018-01-01	581452		0	0	0		0	0	0	291417	0	121	40213260		
16234	350	40213160	1960-02-26	1960-02-26 00:00:00	1960-02-26	1960-02-26 00:00:00	1960-02-26	581452		0	0	0		0	0	0	23269	0	10	40213160		
11288	939	1127078	1966-06-04	1966-06-04 00:00:00	1966-06-18	1966-06-18 00:00:00	1966-06-18	38000177		0	0	14		0	0	0	62478	0	282464	1127078		
62071	5165	1127433	1993-04-29	1993-04-29 00:00:00	1993-05-06	1993-05-06 00:00:00	1993-05-06	38000177		0	0	7		0	0	0	343347	0	313782	1127433		
199579	4384	40213306	1989-12-11	1989-12-11 00:00:00	1989-12-11	1989-12-11 00:00:00	1989-12-11	581452		0	0	0		0	0	0	291370	0	43	40213306		
16235	350	40213227	2010-11-19	2010-11-19 00:00:00	2010-11-19	2010-11-19 00:00:00	2010-11-19	581452		0	0	0		0	0	0	23305	0	113	40213227		
21747	1786	1713671	1982-04-07	1982-04-07 00:00:00	1982-04-21	1982-04-21 00:00:00	1982-04-21	38000177		0	0	14		0	0	0	119733	0	562251	1713671		
62073	5165	1713671	2010-11-09	2010-11-09 00:00:00	2010-11-16	2010-11-16 00:00:00	2010-11-16	38000177		0	0	7		0	0	0	343295	0	562251	1713671		
224207	4922	40213227	2007-08-07	2007-08-07 00:00:00	2007-08-07	2007-08-07 00:00:00	2007-08-07	581452		0	0	0		0	0	0	\N	0	113	40213227		
16236	350	40213260	2010-11-19	2010-11-19 00:00:00	2010-11-19	2010-11-19 00:00:00	2010-11-19	581452		0	0	0		0	0	0	23305	0	121	40213260		
21748	1786	1127433	1959-03-05	1959-03-05 00:00:00	1959-06-03	1959-06-03 00:00:00	1959-06-03	38000177		0	0	90		0	0	0	119704	0	313782	1127433		
62074	5165	40236824	1989-12-31	1989-12-31 00:00:00	1990-01-07	1990-01-07 00:00:00	1990-01-07	38000177		0	0	7		0	0	0	343257	0	1094107	40236824		
224209	4922	40213296	2016-08-09	2016-08-09 00:00:00	2016-08-09	2016-08-09 00:00:00	2016-08-09	581452		0	0	0		0	0	0	327058	0	52	40213296		
16245	350	40213160	1960-05-27	1960-05-27 00:00:00	1960-05-27	1960-05-27 00:00:00	1960-05-27	581452		0	0	0		0	0	0	23316	0	10	40213160		
21749	1786	40229134	1965-06-02	1965-06-02 00:00:00	1965-06-16	1965-06-16 00:00:00	1965-06-16	38000177		0	0	14		0	0	0	119730	0	1043400	40229134		
62075	5165	920300	1989-12-31	1989-12-31 00:00:00	1990-01-07	1990-01-07 00:00:00	1990-01-07	38000177		0	0	7		0	0	0	343257	0	311989	920300		
224213	4922	40213314	1977-10-11	1977-10-11 00:00:00	1977-10-11	1977-10-11 00:00:00	1977-10-11	581452		0	0	0		0	0	0	326994	0	49	40213314		
16256	350	40213296	1999-11-19	1999-11-19 00:00:00	1999-11-19	1999-11-19 00:00:00	1999-11-19	581452		0	0	0		0	0	0	23335	0	52	40213296		
21750	1786	1127433	2007-11-05	2007-11-05 00:00:00	2007-11-19	2007-11-19 00:00:00	2007-11-19	38000177		0	0	14		0	0	0	119695	0	313782	1127433		
62076	5165	19133873	1969-05-31	1969-05-31 00:00:00	1969-06-09	1969-06-09 00:00:00	1969-06-09	38000177		0	0	9		0	0	0	343277	0	834061	19133873		
224215	4922	40213227	2018-08-14	2018-08-14 00:00:00	2018-08-14	2018-08-14 00:00:00	2018-08-14	581452		0	0	0		0	0	0	327043	0	113	40213227		
16264	350	40213160	1964-08-28	1964-08-28 00:00:00	1964-08-28	1964-08-28 00:00:00	1964-08-28	581452		0	0	0		0	0	0	23266	0	10	40213160		
21751	1786	19059056	1947-12-03	1947-12-03 00:00:00	1947-12-17	1947-12-17 00:00:00	1947-12-17	38000177		0	0	14		0	0	0	119740	0	243670	19059056		
62077	5165	19078461	2008-03-21	2008-03-21 00:00:00	2008-04-04	2008-04-04 00:00:00	2008-04-04	38000177		0	0	14		0	0	0	343397	0	310965	19078461		
224216	4922	40213296	2018-08-14	2018-08-14 00:00:00	2018-08-14	2018-08-14 00:00:00	2018-08-14	581452		0	0	0		0	0	0	327043	0	52	40213296		
16272	351	40213227	2009-05-19	2009-05-19 00:00:00	2009-05-19	2009-05-19 00:00:00	2009-05-19	581452		0	0	0		0	0	0	23355	0	113	40213227		
21752	1786	19006318	1947-12-03	1947-12-03 00:00:00	1947-12-17	1947-12-17 00:00:00	1947-12-17	38000177		0	0	14		0	0	0	119740	0	105078	19006318		
1993	159	19078461	2013-11-06	2013-11-06 00:00:00	2013-12-11	2013-12-11 00:00:00	2013-12-11	38000177		0	0	35		0	0	0	10923	0	310965	19078461		
224218	4922	40213160	1977-04-12	1977-04-12 00:00:00	1977-04-12	1977-04-12 00:00:00	1977-04-12	581452		0	0	0		0	0	0	327062	0	10	40213160		
170735	3754	40213160	1959-09-15	1959-09-15 00:00:00	1959-09-15	1959-09-15 00:00:00	1959-09-15	581452		0	0	0		0	0	0	249410	0	10	40213160		
21754	1786	1713671	1964-08-07	1964-08-07 00:00:00	1964-08-21	1964-08-21 00:00:00	1964-08-21	38000177		0	0	14		0	0	0	119729	0	562251	1713671		
1994	159	1332419	1994-01-25	1994-01-25 00:00:00	1994-01-25	1994-01-25 00:00:00	\N	38000177		0	0	0		0	0	0	10911	0	197361	1332419		
224219	4922	40213314	1977-04-12	1977-04-12 00:00:00	1977-04-12	1977-04-12 00:00:00	1977-04-12	581452		0	0	0		0	0	0	327062	0	49	40213314		
170740	3754	40213296	2002-12-17	2002-12-17 00:00:00	2002-12-17	2002-12-17 00:00:00	2002-12-17	581452		0	0	0		0	0	0	249481	0	52	40213296		
21756	1786	1713671	1962-06-21	1962-06-21 00:00:00	1962-07-12	1962-07-12 00:00:00	1962-07-12	38000177		0	0	21		0	0	0	119683	0	562251	1713671		
1995	159	1124300	1989-08-28	1989-08-28 00:00:00	1989-08-28	1989-08-28 00:00:00	\N	38000177		0	0	0		0	0	0	10902	0	00781178901	45011828		
224223	4922	40213227	1999-02-16	1999-02-16 00:00:00	1999-02-16	1999-02-16 00:00:00	1999-02-16	581452		0	0	0		0	0	0	326980	0	113	40213227		
170743	3754	40213160	1959-06-16	1959-06-16 00:00:00	1959-06-16	1959-06-16 00:00:00	1959-06-16	581452		0	0	0		0	0	0	249467	0	10	40213160		
21757	1786	1127433	2001-02-22	2001-02-22 00:00:00	2001-03-15	2001-03-15 00:00:00	2001-03-15	38000177		0	0	21		0	0	0	119707	0	313782	1127433		
1996	159	19075601	1997-08-26	1997-08-26 00:00:00	1997-08-26	1997-08-26 00:00:00	\N	38000177		0	0	0		0	0	0	10885	0	309362	19075601		
224224	4922	40213306	1999-02-16	1999-02-16 00:00:00	1999-02-16	1999-02-16 00:00:00	1999-02-16	581452		0	0	0		0	0	0	326980	0	43	40213306		
170750	3754	40213306	1981-01-06	1981-01-06 00:00:00	1981-01-06	1981-01-06 00:00:00	1981-01-06	581452		0	0	0		0	0	0	249448	0	43	40213306		
21759	1786	40231925	1986-07-11	1986-07-11 00:00:00	1986-07-11	1986-07-11 00:00:00	\N	38000177		0	0	0		0	0	0	119706	0	1049221	40231925		
1997	159	19126352	1985-03-19	1985-03-19 00:00:00	1985-03-19	1985-03-19 00:00:00	\N	38000177		0	0	0		0	0	0	10901	0	705129	19126352		
224228	4922	40213160	1981-07-14	1981-07-14 00:00:00	1981-07-14	1981-07-14 00:00:00	1981-07-14	581452		0	0	0		0	0	0	326997	0	10	40213160		
170760	3754	40213227	2011-01-11	2011-01-11 00:00:00	2011-01-11	2011-01-11 00:00:00	2011-01-11	581452		0	0	0		0	0	0	249482	0	113	40213227		
21760	1786	19078461	1986-07-11	1986-07-11 00:00:00	1986-10-09	1986-10-09 00:00:00	1986-10-09	38000177		0	0	90		0	0	0	119706	0	310965	19078461		
1998	159	19133873	1968-08-29	1968-08-29 00:00:00	1968-09-05	1968-09-05 00:00:00	1968-09-05	38000177		0	0	7		0	0	0	10855	0	834061	19133873		
224237	4922	40213160	1977-01-11	1977-01-11 00:00:00	1977-01-11	1977-01-11 00:00:00	1977-01-11	581452		0	0	0		0	0	0	326993	0	10	40213160		
170761	3754	40213260	2011-01-11	2011-01-11 00:00:00	2011-01-11	2011-01-11 00:00:00	2011-01-11	581452		0	0	0		0	0	0	249482	0	121	40213260		
21761	1786	19133873	1959-12-18	1959-12-18 00:00:00	1959-12-26	1959-12-26 00:00:00	1959-12-26	38000177		0	0	8		0	0	0	119682	0	834061	19133873		
224238	4922	40213314	1977-01-11	1977-01-11 00:00:00	1977-01-11	1977-01-11 00:00:00	1977-01-11	581452		0	0	0		0	0	0	326993	0	49	40213314		
170762	3754	40213227	2000-12-12	2000-12-12 00:00:00	2000-12-12	2000-12-12 00:00:00	2000-12-12	581452		0	0	0		0	0	0	249560	0	113	40213227		
21762	1786	19078461	2014-04-06	2014-04-06 00:00:00	2014-04-20	2014-04-20 00:00:00	2014-04-20	38000177		0	0	14		0	0	0	119708	0	310965	19078461		
224240	4922	40213160	1976-11-09	1976-11-09 00:00:00	1976-11-09	1976-11-09 00:00:00	1976-11-09	581452		0	0	0		0	0	0	327061	0	10	40213160		
170763	3754	40213296	2000-12-12	2000-12-12 00:00:00	2000-12-12	2000-12-12 00:00:00	2000-12-12	581452		0	0	0		0	0	0	249560	0	52	40213296		
21763	1786	1118084	1984-12-08	1984-12-08 00:00:00	1984-12-08	1984-12-08 00:00:00	\N	38000177		0	0	0		0	0	0	119752	0	00025152531	44923712		
196955	4328	40213296	2013-08-28	2013-08-28 00:00:00	2013-08-28	2013-08-28 00:00:00	2013-08-28	581452		0	0	0		0	0	0	287027	0	52	40213296		
18791	408	40213260	2012-08-01	2012-08-01 00:00:00	2012-08-01	2012-08-01 00:00:00	2012-08-01	581452		0	0	0		0	0	0	26937	0	121	40213260		
21764	1786	1127433	1970-11-02	1970-11-02 00:00:00	1971-01-01	1971-01-01 00:00:00	1971-01-01	38000177		0	0	60		0	0	0	119705	0	313782	1127433		
196960	4328	40213227	2003-01-15	2003-01-15 00:00:00	2003-01-15	2003-01-15 00:00:00	2003-01-15	581452		0	0	0		0	0	0	287054	0	113	40213227		
18793	408	40213227	2012-08-01	2012-08-01 00:00:00	2012-08-01	2012-08-01 00:00:00	2012-08-01	581452		0	0	0		0	0	0	26937	0	113	40213227		
21769	1788	1115171	2012-10-19	2012-10-19 00:00:00	2012-11-16	2012-11-16 00:00:00	2012-11-16	38000177		0	0	28		0	0	0	119837	0	849574	1115171		
196966	4328	40213306	1994-01-05	1994-01-05 00:00:00	1994-01-05	1994-01-05 00:00:00	1994-01-05	581452		0	0	0		0	0	0	287026	0	43	40213306		
18795	408	40213296	2003-05-07	2003-05-07 00:00:00	2003-05-07	2003-05-07 00:00:00	2003-05-07	581452		0	0	0		0	0	0	\N	0	52	40213296		
21770	1788	1127433	2010-03-09	2010-03-09 00:00:00	2010-03-16	2010-03-16 00:00:00	2010-03-16	38000177		0	0	7		0	0	0	119813	0	313782	1127433		
196972	4328	40213160	1970-11-11	1970-11-11 00:00:00	1970-11-11	1970-11-11 00:00:00	1970-11-11	581452		0	0	0		0	0	0	287021	0	10	40213160		
16748	362	40213160	1986-03-04	1986-03-04 00:00:00	1986-03-04	1986-03-04 00:00:00	1986-03-04	581452		0	0	0		0	0	0	24035	0	10	40213160		
21771	1788	1127433	2007-01-16	2007-01-16 00:00:00	2007-01-23	2007-01-23 00:00:00	2007-01-23	38000177		0	0	7		0	0	0	119830	0	313782	1127433		
196974	4328	40213296	2011-08-24	2011-08-24 00:00:00	2011-08-24	2011-08-24 00:00:00	2011-08-24	581452		0	0	0		0	0	0	287055	0	52	40213296		
16749	362	40213251	1986-03-04	1986-03-04 00:00:00	1986-03-04	1986-03-04 00:00:00	1986-03-04	581452		0	0	0		0	0	0	24035	0	21	40213251		
21772	1788	19059056	1963-10-06	1963-10-06 00:00:00	1963-11-10	1963-11-10 00:00:00	1963-11-10	38000177		0	0	35		0	0	0	119833	0	243670	19059056		
196976	4328	40213227	2011-08-24	2011-08-24 00:00:00	2011-08-24	2011-08-24 00:00:00	2011-08-24	581452		0	0	0		0	0	0	287055	0	113	40213227		
16753	362	40213314	1982-06-01	1982-06-01 00:00:00	1982-06-01	1982-06-01 00:00:00	1982-06-01	581452		0	0	0		0	0	0	24032	0	49	40213314		
21773	1788	1124300	2004-12-24	2004-12-24 00:00:00	2004-12-24	2004-12-24 00:00:00	\N	38000177		0	0	0		0	0	0	119854	0	00781178901	45011828		
196984	4329	40213314	1978-09-11	1978-09-11 00:00:00	1978-09-11	1978-09-11 00:00:00	1978-09-11	581452		0	0	0		0	0	0	287167	0	49	40213314		
16758	362	40213227	2004-01-20	2004-01-20 00:00:00	2004-01-20	2004-01-20 00:00:00	2004-01-20	581452		0	0	0		0	0	0	24038	0	113	40213227		
21774	1788	19078461	2008-11-18	2008-11-18 00:00:00	2008-12-09	2008-12-09 00:00:00	2008-12-09	38000177		0	0	21		0	0	0	119836	0	310965	19078461		
196985	4329	40213160	1978-09-11	1978-09-11 00:00:00	1978-09-11	1978-09-11 00:00:00	1978-09-11	581452		0	0	0		0	0	0	287167	0	10	40213160		
16759	362	40213314	1981-07-28	1981-07-28 00:00:00	1981-07-28	1981-07-28 00:00:00	1981-07-28	581452		0	0	0		0	0	0	24057	0	49	40213314		
21775	1788	1127433	2011-10-09	2011-10-09 00:00:00	2011-10-16	2011-10-16 00:00:00	2011-10-16	38000177		0	0	7		0	0	0	119814	0	313782	1127433		
196986	4329	40213314	1978-07-10	1978-07-10 00:00:00	1978-07-10	1978-07-10 00:00:00	1978-07-10	581452		0	0	0		0	0	0	287138	0	49	40213314		
16760	362	40213306	2004-01-20	2004-01-20 00:00:00	2004-01-20	2004-01-20 00:00:00	2004-01-20	581452		0	0	0		0	0	0	24038	0	43	40213306		
21776	1788	1127433	1990-07-21	1990-07-21 00:00:00	1990-08-11	1990-08-11 00:00:00	1990-08-11	38000177		0	0	21		0	0	0	119834	0	313782	1127433		
196987	4329	40213160	1978-07-10	1978-07-10 00:00:00	1978-07-10	1978-07-10 00:00:00	1978-07-10	581452		0	0	0		0	0	0	287138	0	10	40213160		
16761	362	40213160	1981-07-28	1981-07-28 00:00:00	1981-07-28	1981-07-28 00:00:00	1981-07-28	581452		0	0	0		0	0	0	24057	0	10	40213160		
21777	1788	1115171	1999-05-26	1999-05-26 00:00:00	1999-06-09	1999-06-09 00:00:00	1999-06-09	38000177		0	0	14		0	0	0	119835	0	849574	1115171		
196989	4329	40213227	2010-02-07	2010-02-07 00:00:00	2010-02-07	2010-02-07 00:00:00	2010-02-07	581452		0	0	0		0	0	0	287102	0	113	40213227		
16763	362	40213227	2013-01-29	2013-01-29 00:00:00	2013-01-29	2013-01-29 00:00:00	2013-01-29	581452		0	0	0		0	0	0	24040	0	113	40213227		
21778	1788	40220960	2018-05-24	2018-05-24 00:00:00	2018-05-24	2018-05-24 00:00:00	2018-05-24	38000177		0	0	0		0	0	0	119803	0	1804799	40220960		
196996	4329	40213314	1979-06-11	1979-06-11 00:00:00	1979-06-11	1979-06-11 00:00:00	1979-06-11	581452		0	0	0		0	0	0	287088	0	49	40213314		
16764	362	40213160	1981-09-01	1981-09-01 00:00:00	1981-09-01	1981-09-01 00:00:00	1981-09-01	581452		0	0	0		0	0	0	24042	0	10	40213160		
21779	1788	19075601	2018-05-24	2018-05-24 00:00:00	2018-05-24	2018-05-24 00:00:00	2018-05-24	38000177		0	0	0		0	0	0	119803	0	309362	19075601		
16765	362	40213314	1981-09-01	1981-09-01 00:00:00	1981-09-01	1981-09-01 00:00:00	1981-09-01	581452		0	0	0		0	0	0	24042	0	49	40213314		
21780	1788	1127433	1991-07-12	1991-07-12 00:00:00	1991-07-26	1991-07-26 00:00:00	1991-07-26	38000177		0	0	14		0	0	0	119843	0	313782	1127433		
16766	362	40213251	1984-02-28	1984-02-28 00:00:00	1984-02-28	1984-02-28 00:00:00	1984-02-28	581452		0	0	0		0	0	0	24045	0	21	40213251		
21781	1788	19129655	1977-09-22	1977-09-22 00:00:00	1977-10-06	1977-10-06 00:00:00	1977-10-06	38000177		0	0	14		0	0	0	119805	0	789980	19129655		
16780	362	40213160	1981-12-01	1981-12-01 00:00:00	1981-12-01	1981-12-01 00:00:00	1981-12-01	581452		0	0	0		0	0	0	24043	0	10	40213160		
21782	1788	1127433	1977-09-22	1977-09-22 00:00:00	1977-10-06	1977-10-06 00:00:00	1977-10-06	38000177		0	0	14		0	0	0	119805	0	313782	1127433		
47604	3946	1127433	1972-06-01	1972-06-01 00:00:00	1972-06-15	1972-06-15 00:00:00	1972-06-15	38000177		0	0	14		0	0	0	262353	0	313782	1127433		
21783	1789	19133873	1985-03-07	1985-03-07 00:00:00	1985-03-15	1985-03-15 00:00:00	1985-03-15	38000177		0	0	8		0	0	0	119883	0	834061	19133873		
47605	3946	19133905	1989-07-22	1989-07-22 00:00:00	1989-08-04	1989-08-04 00:00:00	1989-08-04	38000177		0	0	13		0	0	0	262315	0	834102	19133905		
21784	1789	1127433	2014-11-16	2014-11-16 00:00:00	2014-11-30	2014-11-30 00:00:00	2014-11-30	38000177		0	0	14		0	0	0	119893	0	313782	1127433		
47606	3946	1713671	1992-06-28	1992-06-28 00:00:00	1992-07-12	1992-07-12 00:00:00	1992-07-12	38000177		0	0	14		0	0	0	262342	0	562251	1713671		
21785	1789	1127078	1978-11-08	1978-11-08 00:00:00	1978-11-29	1978-11-29 00:00:00	1978-11-29	38000177		0	0	21		0	0	0	119897	0	282464	1127078		
47607	3946	1127433	1970-04-01	1970-04-01 00:00:00	1970-04-15	1970-04-15 00:00:00	1970-04-15	38000177		0	0	14		0	0	0	262340	0	313782	1127433		
21786	1789	1551192	1976-02-22	1976-02-22 00:00:00	1976-02-22	1976-02-22 00:00:00	1976-02-22	38000177		0	0	0		0	0	0	119896	0	312617	1551192		
47608	3946	1713671	1973-04-22	1973-04-22 00:00:00	1973-04-29	1973-04-29 00:00:00	1973-04-29	38000177		0	0	7		0	0	0	262313	0	562251	1713671		
21787	1789	1127433	2018-06-13	2018-06-13 00:00:00	2018-06-27	2018-06-27 00:00:00	2018-06-27	38000177		0	0	14		0	0	0	119878	0	313782	1127433		
47609	3946	19078461	2007-07-12	2007-07-12 00:00:00	2007-08-02	2007-08-02 00:00:00	2007-08-02	38000177		0	0	21		0	0	0	262355	0	310965	19078461		
21788	1789	40229134	1988-04-21	1988-04-21 00:00:00	1988-05-05	1988-05-05 00:00:00	1988-05-05	38000177		0	0	14		0	0	0	119862	0	1043400	40229134		
47610	3946	1127433	1999-01-04	1999-01-04 00:00:00	1999-01-11	1999-01-11 00:00:00	1999-01-11	38000177		0	0	7		0	0	0	262343	0	313782	1127433		
47611	3946	1118084	2003-02-25	2003-02-25 00:00:00	2003-02-25	2003-02-25 00:00:00	\N	38000177		0	0	0		0	0	0	262326	0	00025152531	44923712		
47612	3946	1713671	1988-09-28	1988-09-28 00:00:00	1988-10-12	1988-10-12 00:00:00	1988-10-12	38000177		0	0	14		0	0	0	262356	0	562251	1713671		
47613	3946	19059056	1964-01-01	1964-01-01 00:00:00	1964-01-15	1964-01-15 00:00:00	1964-01-15	38000177		0	0	14		0	0	0	262352	0	243670	19059056		
47631	3949	40236446	1977-03-15	1977-03-15 00:00:00	1979-04-03	1979-04-03 00:00:00	1979-04-03	38000177		0	0	749		0	0	0	262476	0	1091392	40236446		
47632	3949	19078461	2009-12-12	2009-12-12 00:00:00	2009-12-26	2009-12-26 00:00:00	2009-12-26	38000177		0	0	14		0	0	0	262520	0	310965	19078461		
47633	3949	1118084	2003-07-27	2003-07-27 00:00:00	2003-07-27	2003-07-27 00:00:00	\N	38000177		0	0	0		0	0	0	262511	0	00025152531	44923712		
47634	3949	1127433	2003-01-28	2003-01-28 00:00:00	2003-02-04	2003-02-04 00:00:00	2003-02-04	38000177		0	0	7		0	0	0	262511	0	313782	1127433		
47635	3949	19019979	1980-01-19	1980-01-19 00:00:00	1980-03-19	1980-03-19 00:00:00	1980-03-19	38000177		0	0	60		0	0	0	262519	0	198405	19019979		
47636	3949	1713671	1994-12-14	1994-12-14 00:00:00	1994-12-21	1994-12-21 00:00:00	1994-12-21	38000177		0	0	7		0	0	0	262494	0	562251	1713671		
47637	3949	1127433	1976-01-11	1976-01-11 00:00:00	1976-01-18	1976-01-18 00:00:00	1976-01-18	38000177		0	0	7		0	0	0	262439	0	313782	1127433		
47638	3950	1118084	2014-12-04	2014-12-04 00:00:00	2014-12-04	2014-12-04 00:00:00	\N	38000177		0	0	0		0	0	0	262580	0	00025152531	44923712		
47639	3950	19059056	1971-09-26	1971-09-26 00:00:00	1971-12-25	1971-12-25 00:00:00	1971-12-25	38000177		0	0	90		0	0	0	262521	0	243670	19059056		
47640	3950	40229134	2001-12-11	2001-12-11 00:00:00	2001-12-25	2001-12-25 00:00:00	2001-12-25	38000177		0	0	14		0	0	0	262591	0	1043400	40229134		
47641	3950	1127078	1981-06-17	1981-06-17 00:00:00	1981-07-22	1981-07-22 00:00:00	1981-07-22	38000177		0	0	35		0	0	0	262524	0	282464	1127078		
47642	3950	1127433	2016-05-12	2016-05-12 00:00:00	2016-05-26	2016-05-26 00:00:00	2016-05-26	38000177		0	0	14		0	0	0	262533	0	313782	1127433		
58101	4827	1124300	1991-01-17	1991-01-17 00:00:00	1991-01-17	1991-01-17 00:00:00	\N	38000177		0	0	0		0	0	0	321119	0	00781178901	45011828		
58102	4827	1127433	1995-02-02	1995-02-02 00:00:00	1995-02-09	1995-02-09 00:00:00	1995-02-09	38000177		0	0	7		0	0	0	321094	0	313782	1127433		
58103	4827	19059056	1970-12-18	1970-12-18 00:00:00	1971-01-01	1971-01-01 00:00:00	1971-01-01	38000177		0	0	14		0	0	0	321145	0	243670	19059056		
58104	4827	1127433	1990-01-21	1990-01-21 00:00:00	1990-02-20	1990-02-20 00:00:00	1990-02-20	38000177		0	0	30		0	0	0	321147	0	313782	1127433		
132082	2902	40213198	2012-04-06	2012-04-06 00:00:00	2012-04-06	2012-04-06 00:00:00	2012-04-06	581452		0	0	0		0	0	0	193355	0	133	40213198		
132095	2902	40213227	1997-07-11	1997-07-11 00:00:00	1997-07-11	1997-07-11 00:00:00	1997-07-11	581452		0	0	0		0	0	0	193279	0	113	40213227		
82701	1808	40213296	2002-02-12	2002-02-12 00:00:00	2002-02-12	2002-02-12 00:00:00	2002-02-12	581452		0	0	0		0	0	0	121056	0	52	40213296		
82703	1808	40213227	2004-02-17	2004-02-17 00:00:00	2004-02-17	2004-02-17 00:00:00	2004-02-17	581452		0	0	0		0	0	0	121078	0	113	40213227		
82704	1808	40213296	2004-02-17	2004-02-17 00:00:00	2004-02-17	2004-02-17 00:00:00	2004-02-17	581452		0	0	0		0	0	0	121078	0	52	40213296		
82706	1808	40213260	2012-02-07	2012-02-07 00:00:00	2012-02-07	2012-02-07 00:00:00	2012-02-07	581452		0	0	0		0	0	0	121080	0	121	40213260		
82710	1808	40213227	1993-10-19	1993-10-19 00:00:00	1993-10-19	1993-10-19 00:00:00	1993-10-19	581452		0	0	0		0	0	0	121032	0	113	40213227		
82712	1808	40213160	1967-01-10	1967-01-10 00:00:00	1967-01-10	1967-01-10 00:00:00	1967-01-10	581452		0	0	0		0	0	0	121012	0	10	40213160		
82713	1808	40213260	2013-02-12	2013-02-12 00:00:00	2013-02-12	2013-02-12 00:00:00	2013-02-12	581452		0	0	0		0	0	0	121035	0	121	40213260		
82715	1808	40213227	2013-02-12	2013-02-12 00:00:00	2013-02-12	2013-02-12 00:00:00	2013-02-12	581452		0	0	0		0	0	0	121035	0	113	40213227		
82723	1808	40213160	1962-07-17	1962-07-17 00:00:00	1962-07-17	1962-07-17 00:00:00	1962-07-17	581452		0	0	0		0	0	0	121037	0	10	40213160		
177638	3904	40213160	1979-08-02	1979-08-02 00:00:00	1979-08-02	1979-08-02 00:00:00	1979-08-02	581452		0	0	0		0	0	0	259615	0	10	40213160		
177646	3904	40213227	2001-05-31	2001-05-31 00:00:00	2001-05-31	2001-05-31 00:00:00	2001-05-31	581452		0	0	0		0	0	0	259634	0	113	40213227		
177647	3904	40213306	2001-05-31	2001-05-31 00:00:00	2001-05-31	2001-05-31 00:00:00	2001-05-31	581452		0	0	0		0	0	0	259634	0	43	40213306		
177653	3904	40213160	1979-11-01	1979-11-01 00:00:00	1979-11-01	1979-11-01 00:00:00	1979-11-01	581452		0	0	0		0	0	0	259629	0	10	40213160		
\.


--
-- TOC entry 3899 (class 0 OID 3185532)
-- Dependencies: 221
-- Data for Name: drug_strength; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".drug_strength (drug_concept_id, ingredient_concept_id, amount_value, amount_unit_concept_id, numerator_value, numerator_unit_concept_id, denominator_value, denominator_unit_concept_id, box_size, valid_start_date, valid_end_date, invalid_reason) FROM stdin;
\.


--
-- TOC entry 3900 (class 0 OID 3185538)
-- Dependencies: 222
-- Data for Name: fact_relationship; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".fact_relationship (domain_concept_id_1, fact_id_1, domain_concept_id_2, fact_id_2, relationship_concept_id) FROM stdin;
\.


--
-- TOC entry 3901 (class 0 OID 3185541)
-- Dependencies: 223
-- Data for Name: location; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".location (location_id, address_1, address_2, city, state, zip, county, location_source_value) FROM stdin;
\.


--
-- TOC entry 3902 (class 0 OID 3185544)
-- Dependencies: 224
-- Data for Name: measurement; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".measurement (measurement_id, person_id, measurement_concept_id, measurement_date, measurement_datetime, measurement_time, measurement_type_concept_id, operator_concept_id, value_as_number, value_as_concept_id, unit_concept_id, range_low, range_high, provider_id, visit_occurrence_id, visit_detail_id, measurement_source_value, measurement_source_concept_id, unit_source_value, value_source_value) FROM stdin;
10204	974	3006322	1998-10-03	1998-10-03 00:00:00	1998-10-03	5001	0	\N	0	0	\N	\N	0	64994	0	8331-1	3006322		
4182	129	4024958	2004-10-04	2004-10-04 00:00:00	2004-10-04	5001	0	\N	0	0	\N	\N	0	8712	0	117015009	4024958		
90388	2790	4024958	1994-01-17	1994-01-17 00:00:00	1994-01-17	5001	0	\N	0	0	\N	\N	0	184877	0	117015009	4024958		
20211	1850	3006322	1969-05-14	1969-05-14 00:00:00	1969-05-14	5001	0	\N	0	0	\N	\N	0	123724	0	8331-1	3006322		
15652	489	4024958	1976-12-26	1976-12-26 00:00:00	1976-12-26	5001	0	\N	0	0	\N	\N	0	32717	0	117015009	4024958		
15744	492	4024958	1961-03-23	1961-03-23 00:00:00	1961-03-23	5001	0	\N	0	0	\N	\N	0	32937	0	117015009	4024958		
27099	844	4052083	1993-10-03	1993-10-03 00:00:00	1993-10-03	5001	0	\N	0	0	\N	\N	0	55873	0	23426006	4052083		
27166	847	4024958	2008-05-22	2008-05-22 00:00:00	2008-05-22	5001	0	\N	0	0	\N	\N	0	56099	0	117015009	4024958		
82693	2554	4024958	2005-09-24	2005-09-24 00:00:00	2005-09-24	5001	0	\N	0	0	\N	\N	0	169222	0	117015009	4024958		
91609	2827	4052083	1984-03-23	1984-03-23 00:00:00	1984-03-23	5001	0	\N	0	0	\N	\N	0	187518	0	23426006	4052083		
16098	502	4024958	1990-12-06	1990-12-06 00:00:00	1990-12-06	5001	0	\N	0	0	\N	\N	0	33583	0	117015009	4024958		
105494	3248	4024958	1959-04-19	1959-04-19 00:00:00	1959-04-19	5001	0	\N	0	0	\N	\N	0	215852	0	117015009	4024958		
120214	3707	4052083	1984-09-10	1984-09-10 00:00:00	1984-09-10	5001	0	\N	0	0	\N	\N	0	246459	0	23426006	4052083		
131598	4053	4052083	2015-12-29	2015-12-29 00:00:00	2015-12-29	5001	0	\N	0	0	\N	\N	0	269468	0	23426006	4052083		
51154	1553	4052083	1969-03-30	1969-03-30 00:00:00	1969-03-30	5001	0	\N	0	0	\N	\N	0	103991	0	23426006	4052083		
143022	4392	4024958	1991-06-15	1991-06-15 00:00:00	1991-06-15	5001	0	\N	0	0	\N	\N	0	292069	0	117015009	4024958		
71606	2191	4024958	1979-01-16	1979-01-16 00:00:00	1979-01-16	5001	0	\N	0	0	\N	\N	0	146129	0	117015009	4024958		
154507	4738	4052083	1917-11-05	1917-11-05 00:00:00	1917-11-05	5001	0	\N	0	0	\N	\N	0	315640	0	23426006	4052083		
7327	232	4024958	2007-11-11	2007-11-11 00:00:00	2007-11-11	5001	0	\N	0	0	\N	\N	0	15601	0	117015009	4024958		
151288	4637	4024958	1993-12-11	1993-12-11 00:00:00	1993-12-11	5001	0	\N	0	0	\N	\N	0	309012	0	117015009	4024958		
15818	495	4024958	2009-05-25	2009-05-25 00:00:00	2009-05-25	5001	0	\N	0	0	\N	\N	0	33074	0	117015009	4024958		
40237	3745	3011505	2017-10-11	2017-10-11 00:00:00	2017-10-11	5001	0	\N	0	0	\N	\N	0	248896	0	19926-5	3011505		
30220	936	4052083	2010-09-23	2010-09-23 00:00:00	2010-09-23	5001	0	\N	0	0	\N	\N	0	62288	0	23426006	4052083		
41633	1285	4024958	1972-06-19	1972-06-19 00:00:00	1972-06-19	5001	0	\N	0	0	\N	\N	0	85020	0	117015009	4024958		
40495	1259	4024958	1962-06-06	1962-06-06 00:00:00	1962-06-06	5001	0	\N	0	0	\N	\N	0	82972	0	117015009	4024958		
134674	4149	4024958	1988-02-13	1988-02-13 00:00:00	1988-02-13	5001	0	\N	0	0	\N	\N	0	275706	0	117015009	4024958		
134000	4125	4052083	2017-11-03	2017-11-03 00:00:00	2017-11-03	5001	0	\N	0	0	\N	\N	0	274219	0	23426006	4052083		
141652	4366	4024958	1991-11-23	1991-11-23 00:00:00	1991-11-23	5001	0	\N	0	0	\N	\N	0	289680	0	117015009	4024958		
145416	4462	4133840	2006-02-09	2006-02-09 00:00:00	2006-02-09	5001	0	\N	0	0	\N	\N	0	296879	0	127783003	4133840		
157543	4843	4024958	1981-12-22	1981-12-22 00:00:00	1981-12-22	5001	0	\N	0	0	\N	\N	0	322150	0	117015009	4024958		
157573	4843	4052083	1963-03-18	1963-03-18 00:00:00	1963-03-18	5001	0	\N	0	0	\N	\N	0	322148	0	23426006	4052083		
157675	4844	4052083	1990-01-12	1990-01-12 00:00:00	1990-01-12	5001	0	\N	0	0	\N	\N	0	322178	0	23426006	4052083		
67162	2062	4052083	1951-12-03	1951-12-03 00:00:00	1951-12-03	5001	0	\N	0	0	\N	\N	0	137109	0	23426006	4052083		
11883	377	4024958	1985-02-01	1985-02-01 00:00:00	1985-02-01	5001	0	\N	0	0	\N	\N	0	25010	0	117015009	4024958		
78600	2414	4052083	1982-03-07	1982-03-07 00:00:00	1982-03-07	5001	0	\N	0	0	\N	\N	0	160224	0	23426006	4052083		
44546	4113	3006322	1991-09-03	1991-09-03 00:00:00	1991-09-03	5001	0	\N	0	0	\N	\N	0	273460	0	8331-1	3006322		
78748	2419	4024958	1971-07-09	1971-07-09 00:00:00	1971-07-09	5001	0	\N	0	0	\N	\N	0	160629	0	117015009	4024958		
90100	2782	4024958	1956-01-04	1956-01-04 00:00:00	1956-01-04	5001	0	\N	0	0	\N	\N	0	184361	0	117015009	4024958		
121738	3756	4052083	1970-04-07	1970-04-07 00:00:00	1970-04-07	5001	0	\N	0	0	\N	\N	0	249679	0	23426006	4052083		
30464	946	4024958	2015-02-23	2015-02-23 00:00:00	2015-02-23	5001	0	\N	0	0	\N	\N	0	62815	0	117015009	4024958		
133208	4105	4024958	2010-02-24	2010-02-24 00:00:00	2010-02-24	5001	0	\N	0	0	\N	\N	0	272731	0	117015009	4024958		
67777	2077	4052083	1952-02-26	1952-02-26 00:00:00	1952-02-26	5001	0	\N	0	0	\N	\N	0	138267	0	23426006	4052083		
149064	4570	4024958	1976-12-16	1976-12-16 00:00:00	1976-12-16	5001	0	\N	0	0	\N	\N	0	304461	0	117015009	4024958		
79202	2436	4024958	1920-08-03	1920-08-03 00:00:00	1920-08-03	5001	0	\N	0	0	\N	\N	0	161484	0	117015009	4024958		
43727	1348	4024958	1948-06-25	1948-06-25 00:00:00	1948-06-25	5001	0	\N	0	0	\N	\N	0	89335	0	117015009	4024958		
79020	2428	4024958	1984-08-03	1984-08-03 00:00:00	1984-08-03	5001	0	\N	0	0	\N	\N	0	161082	0	117015009	4024958		
171958	5279	4024958	1957-05-17	1957-05-17 00:00:00	1957-05-17	5001	0	\N	0	0	\N	\N	0	351230	0	117015009	4024958		
9852	929	3006322	1943-02-03	1943-02-03 00:00:00	1943-02-03	5001	0	\N	0	0	\N	\N	0	61837	0	8331-1	3006322		
101865	3129	4024958	2009-04-09	2009-04-09 00:00:00	2009-04-09	5001	0	\N	0	0	\N	\N	0	208251	0	117015009	4024958		
11269	1083	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	71173	0	6833-8	3023430		
50707	4623	3015076	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	307872	0	6248-9	3015076		
4804	457	3006322	2008-11-17	2008-11-17 00:00:00	2008-11-17	5001	0	\N	0	0	\N	\N	0	30570	0	8331-1	3006322		
15966	1459	3006322	2015-06-11	2015-06-11 00:00:00	2015-06-11	5001	0	\N	0	0	\N	\N	0	97219	0	8331-1	3006322		
34151	3114	3006322	1966-10-26	1966-10-26 00:00:00	1966-10-26	5001	0	\N	0	0	\N	\N	0	207120	0	8331-1	3006322		
45551	4202	3006322	2016-04-10	2016-04-10 00:00:00	2016-04-10	5001	0	\N	0	0	\N	\N	0	278969	0	8331-1	3006322		
27282	2534	3021226	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	167387	0	6246-3	3021226		
82949	2559	4024958	1968-01-15	1968-01-15 00:00:00	1968-01-15	5001	0	\N	0	0	\N	\N	0	169603	0	117015009	4024958		
83019	2563	4052083	1991-02-12	1991-02-12 00:00:00	1991-02-12	5001	0	\N	0	0	\N	\N	0	169806	0	23426006	4052083		
23808	2189	3006322	2003-04-01	2003-04-01 00:00:00	2003-04-01	5001	0	\N	0	0	\N	\N	0	145921	0	8331-1	3006322		
111538	3444	4024958	1961-07-06	1961-07-06 00:00:00	1961-07-06	5001	0	\N	0	0	\N	\N	0	228521	0	117015009	4024958		
105842	3258	4052083	1990-12-23	1990-12-23 00:00:00	1990-12-23	5001	0	\N	0	0	\N	\N	0	216559	0	23426006	4052083		
105906	3259	4024958	2003-05-22	2003-05-22 00:00:00	2003-05-22	5001	0	\N	0	0	\N	\N	0	216686	0	117015009	4024958		
160864	4942	4024958	1979-04-15	1979-04-15 00:00:00	1979-04-15	5001	0	\N	0	0	\N	\N	0	328523	0	117015009	4024958		
4232	419	3051031	1912-10-27	1912-10-27 00:00:00	1912-10-27	5001	0	\N	0	0	\N	\N	0	27738	0	46240-8	3051031		
10205	974	3006322	2010-08-14	2010-08-14 00:00:00	2010-08-14	5001	0	\N	0	0	\N	\N	0	64952	0	8331-1	3006322		
4194	129	4024958	1987-01-20	1987-01-20 00:00:00	1987-01-20	5001	0	\N	0	0	\N	\N	0	8706	0	117015009	4024958		
101684	3123	4052083	2005-01-28	2005-01-28 00:00:00	2005-01-28	5001	0	\N	0	0	\N	\N	0	207796	0	23426006	4052083		
20212	1850	3006322	2013-06-01	2013-06-01 00:00:00	2013-06-01	5001	0	\N	0	0	\N	\N	0	123769	0	8331-1	3006322		
15662	489	4024958	2010-06-28	2010-06-28 00:00:00	2010-06-28	5001	0	\N	0	0	\N	\N	0	32805	0	117015009	4024958		
15751	492	4024958	2016-03-31	2016-03-31 00:00:00	2016-03-31	5001	0	\N	0	0	\N	\N	0	32954	0	117015009	4024958		
4534	140	4024958	1999-08-12	1999-08-12 00:00:00	1999-08-12	5001	0	\N	0	0	\N	\N	0	9354	0	117015009	4024958		
27175	847	4052083	2007-11-30	2007-11-30 00:00:00	2007-11-30	5001	0	\N	0	0	\N	\N	0	56122	0	23426006	4052083		
93981	2893	4024958	1978-04-27	1978-04-27 00:00:00	1978-04-27	5001	0	\N	0	0	\N	\N	0	192500	0	117015009	4024958		
43081	1325	4052083	1966-01-03	1966-01-03 00:00:00	1966-01-03	5001	0	\N	0	0	\N	\N	0	87982	0	23426006	4052083		
16101	502	4052083	1979-06-01	1979-06-01 00:00:00	1979-06-01	5001	0	\N	0	0	\N	\N	0	33634	0	23426006	4052083		
105498	3248	4024958	2017-03-08	2017-03-08 00:00:00	2017-03-08	5001	0	\N	0	0	\N	\N	0	215929	0	117015009	4024958		
120220	3707	4052083	2002-08-23	2002-08-23 00:00:00	2002-08-23	5001	0	\N	0	0	\N	\N	0	246462	0	23426006	4052083		
131625	4055	4024958	1984-08-17	1984-08-17 00:00:00	1984-08-17	5001	0	\N	0	0	\N	\N	0	269526	0	117015009	4024958		
51157	1553	4052083	1979-11-09	1979-11-09 00:00:00	1979-11-09	5001	0	\N	0	0	\N	\N	0	103954	0	23426006	4052083		
143023	4392	4052083	2017-02-22	2017-02-22 00:00:00	2017-02-22	5001	0	\N	0	0	\N	\N	0	292052	0	23426006	4052083		
71613	2191	4024958	1971-12-13	1971-12-13 00:00:00	1971-12-13	5001	0	\N	0	0	\N	\N	0	146086	0	117015009	4024958		
154520	4739	4024958	1948-02-18	1948-02-18 00:00:00	1948-02-18	5001	0	\N	0	0	\N	\N	0	315684	0	117015009	4024958		
18683	587	4052083	1983-02-17	1983-02-17 00:00:00	1983-02-17	5001	0	\N	0	0	\N	\N	0	38901	0	23426006	4052083		
117801	3626	4024958	1980-04-24	1980-04-24 00:00:00	1980-04-24	5001	0	\N	0	0	\N	\N	0	241130	0	117015009	4024958		
15819	495	4052083	1998-12-08	1998-12-08 00:00:00	1998-12-08	5001	0	\N	0	0	\N	\N	0	33083	0	23426006	4052083		
40238	3745	3011505	1997-06-18	1997-06-18 00:00:00	1997-06-18	5001	0	\N	0	0	\N	\N	0	248966	0	19926-5	3011505		
30228	936	4052083	1992-03-12	1992-03-12 00:00:00	1992-03-12	5001	0	\N	0	0	\N	\N	0	62287	0	23426006	4052083		
51678	4732	3006322	1957-04-16	1957-04-16 00:00:00	1957-04-16	5001	0	\N	0	0	\N	\N	0	315278	0	8331-1	3006322		
27344	857	4133840	1996-09-29	1996-09-29 00:00:00	1996-09-29	5001	0	\N	0	0	\N	\N	0	56585	0	127783003	4133840		
134675	4149	4024958	2012-09-21	2012-09-21 00:00:00	2012-09-21	5001	0	\N	0	0	\N	\N	0	275707	0	117015009	4024958		
134036	4127	4024958	1967-10-13	1967-10-13 00:00:00	1967-10-13	5001	0	\N	0	0	\N	\N	0	274313	0	117015009	4024958		
32904	1024	4052083	1995-02-21	1995-02-21 00:00:00	1995-02-21	5001	0	\N	0	0	\N	\N	0	67475	0	23426006	4052083		
145418	4462	4133840	1999-04-01	1999-04-01 00:00:00	1999-04-01	5001	0	\N	0	0	\N	\N	0	296872	0	127783003	4133840		
8858	280	4024958	1962-08-09	1962-08-09 00:00:00	1962-08-09	5001	0	\N	0	0	\N	\N	0	18674	0	117015009	4024958		
157593	4844	4052083	1976-05-14	1976-05-14 00:00:00	1976-05-14	5001	0	\N	0	0	\N	\N	0	322286	0	23426006	4052083		
20330	639	4024958	1982-09-29	1982-09-29 00:00:00	1982-09-29	5001	0	\N	0	0	\N	\N	0	42302	0	117015009	4024958		
67170	2062	4024958	1965-01-12	1965-01-12 00:00:00	1965-01-12	5001	0	\N	0	0	\N	\N	0	137167	0	117015009	4024958		
11886	377	4052083	1998-06-06	1998-06-06 00:00:00	1998-06-06	5001	0	\N	0	0	\N	\N	0	24958	0	23426006	4052083		
78608	2414	4052083	1950-06-10	1950-06-10 00:00:00	1950-06-10	5001	0	\N	0	0	\N	\N	0	160195	0	23426006	4052083		
44547	4113	3006322	1972-02-27	1972-02-27 00:00:00	1972-02-27	5001	0	\N	0	0	\N	\N	0	273394	0	8331-1	3006322		
78757	2419	4052083	1948-07-03	1948-07-03 00:00:00	1948-07-03	5001	0	\N	0	0	\N	\N	0	160510	0	23426006	4052083		
90114	2782	4024958	1935-12-19	1935-12-19 00:00:00	1935-12-19	5001	0	\N	0	0	\N	\N	0	184343	0	117015009	4024958		
121739	3756	4024958	1947-01-22	1947-01-22 00:00:00	1947-01-22	5001	0	\N	0	0	\N	\N	0	249640	0	117015009	4024958		
30467	946	4052083	1969-03-22	1969-03-22 00:00:00	1969-03-22	5001	0	\N	0	0	\N	\N	0	62773	0	23426006	4052083		
133215	4105	4052083	1993-06-20	1993-06-20 00:00:00	1993-06-20	5001	0	\N	0	0	\N	\N	0	272710	0	23426006	4052083		
67807	2077	4052083	1946-11-09	1946-11-09 00:00:00	1946-11-09	5001	0	\N	0	0	\N	\N	0	138332	0	23426006	4052083		
149066	4570	4024958	2002-11-09	2002-11-09 00:00:00	2002-11-09	5001	0	\N	0	0	\N	\N	0	304458	0	117015009	4024958		
79206	2436	4052083	2014-12-08	2014-12-08 00:00:00	2014-12-08	5001	0	\N	0	0	\N	\N	0	161454	0	23426006	4052083		
43731	1348	4024958	1985-11-29	1985-11-29 00:00:00	1985-11-29	5001	0	\N	0	0	\N	\N	0	89295	0	117015009	4024958		
79026	2428	4024958	1989-04-21	1989-04-21 00:00:00	1989-04-21	5001	0	\N	0	0	\N	\N	0	161083	0	117015009	4024958		
171962	5279	4052083	1974-04-14	1974-04-14 00:00:00	1974-04-14	5001	0	\N	0	0	\N	\N	0	351203	0	23426006	4052083		
9853	929	3006322	1946-01-01	1946-01-01 00:00:00	1946-01-01	5001	0	\N	0	0	\N	\N	0	61785	0	8331-1	3006322		
101870	3129	4024958	2012-05-05	2012-05-05 00:00:00	2012-05-05	5001	0	\N	0	0	\N	\N	0	208256	0	117015009	4024958		
11270	1083	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	71173	0	6085-5	3001247		
50708	4623	3014599	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	307872	0	6106-9	3014599		
4805	457	3006322	2016-05-17	2016-05-17 00:00:00	2016-05-17	5001	0	\N	0	0	\N	\N	0	30560	0	8331-1	3006322		
15967	1459	3006322	1958-07-18	1958-07-18 00:00:00	1958-07-18	5001	0	\N	0	0	\N	\N	0	97178	0	8331-1	3006322		
34152	3114	3006322	1958-01-19	1958-01-19 00:00:00	1958-01-19	5001	0	\N	0	0	\N	\N	0	207142	0	8331-1	3006322		
45552	4202	3006322	1981-12-30	1981-12-30 00:00:00	1981-12-30	5001	0	\N	0	0	\N	\N	0	278982	0	8331-1	3006322		
27283	2534	3014599	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	167387	0	6106-9	3014599		
82983	2561	4024958	2018-03-06	2018-03-06 00:00:00	2018-03-06	5001	0	\N	0	0	\N	\N	0	169674	0	117015009	4024958		
83031	2563	4024958	1998-04-21	1998-04-21 00:00:00	1998-04-21	5001	0	\N	0	0	\N	\N	0	169797	0	117015009	4024958		
23809	2189	3019406	2010-02-17	2010-02-17 00:00:00	2010-02-17	5001	0	\N	0	0	\N	\N	0	145893	0	6158-0	3019406		
138187	4260	4024958	1981-07-01	1981-07-01 00:00:00	1981-07-01	5001	0	\N	0	0	\N	\N	0	282805	0	117015009	4024958		
105844	3258	4024958	1991-04-27	1991-04-27 00:00:00	1991-04-27	5001	0	\N	0	0	\N	\N	0	216560	0	117015009	4024958		
105911	3259	4052083	1977-07-15	1977-07-15 00:00:00	1977-07-15	5001	0	\N	0	0	\N	\N	0	216684	0	23426006	4052083		
160900	4943	4024958	1999-05-29	1999-05-29 00:00:00	1999-05-29	5001	0	\N	0	0	\N	\N	0	328575	0	117015009	4024958		
4233	419	46235214	1912-10-27	1912-10-27 00:00:00	1912-10-27	5001	0	\N	0	0	\N	\N	0	27738	0	76690-7	46235214		
10206	975	3006322	1985-10-12	1985-10-12 00:00:00	1985-10-12	5001	0	\N	0	0	\N	\N	0	65034	0	8331-1	3006322		
165082	5068	4024958	1931-08-20	1931-08-20 00:00:00	1931-08-20	5001	0	\N	0	0	\N	\N	0	336967	0	117015009	4024958		
169488	5200	4052083	1961-04-18	1961-04-18 00:00:00	1961-04-18	5001	0	\N	0	0	\N	\N	0	345865	0	23426006	4052083		
20213	1850	3006322	1984-10-06	1984-10-06 00:00:00	1984-10-06	5001	0	\N	0	0	\N	\N	0	123755	0	8331-1	3006322		
15666	489	4024958	1993-10-12	1993-10-12 00:00:00	1993-10-12	5001	0	\N	0	0	\N	\N	0	32788	0	117015009	4024958		
27047	844	4024958	1978-05-30	1978-05-30 00:00:00	1978-05-30	5001	0	\N	0	0	\N	\N	0	55951	0	117015009	4024958		
4555	140	4052083	1986-12-05	1986-12-05 00:00:00	1986-12-05	5001	0	\N	0	0	\N	\N	0	9408	0	23426006	4052083		
27178	847	4024958	1992-01-23	1992-01-23 00:00:00	1992-01-23	5001	0	\N	0	0	\N	\N	0	56092	0	117015009	4024958		
93993	2893	4024958	1952-01-18	1952-01-18 00:00:00	1952-01-18	5001	0	\N	0	0	\N	\N	0	192453	0	117015009	4024958		
43083	1325	4052083	1970-11-18	1970-11-18 00:00:00	1970-11-18	5001	0	\N	0	0	\N	\N	0	87983	0	23426006	4052083		
16107	502	4052083	1955-03-31	1955-03-31 00:00:00	1955-03-31	5001	0	\N	0	0	\N	\N	0	33598	0	23426006	4052083		
105502	3248	4024958	1955-08-14	1955-08-14 00:00:00	1955-08-14	5001	0	\N	0	0	\N	\N	0	215918	0	117015009	4024958		
120223	3707	4024958	2014-06-20	2014-06-20 00:00:00	2014-06-20	5001	0	\N	0	0	\N	\N	0	246465	0	117015009	4024958		
131629	4055	4024958	2007-05-20	2007-05-20 00:00:00	2007-05-20	5001	0	\N	0	0	\N	\N	0	269510	0	117015009	4024958		
51166	1553	4052083	1982-10-03	1982-10-03 00:00:00	1982-10-03	5001	0	\N	0	0	\N	\N	0	103978	0	23426006	4052083		
143024	4392	4024958	1991-05-06	1991-05-06 00:00:00	1991-05-06	5001	0	\N	0	0	\N	\N	0	292059	0	117015009	4024958		
71624	2191	4024958	1995-03-31	1995-03-31 00:00:00	1995-03-31	5001	0	\N	0	0	\N	\N	0	146130	0	117015009	4024958		
154521	4739	4052083	1919-06-09	1919-06-09 00:00:00	1919-06-09	5001	0	\N	0	0	\N	\N	0	315680	0	23426006	4052083		
28714	2657	3006322	2002-02-25	2002-02-25 00:00:00	2002-02-25	5001	0	\N	0	0	\N	\N	0	175955	0	8331-1	3006322		
26827	2483	3011505	1985-06-01	1985-06-01 00:00:00	1985-06-01	5001	0	\N	0	0	\N	\N	0	164532	0	19926-5	3011505		
19421	1776	3006322	2014-09-29	2014-09-29 00:00:00	2014-09-29	5001	0	\N	0	0	\N	\N	0	118780	0	8331-1	3006322		
40239	3745	3011505	1996-06-12	1996-06-12 00:00:00	1996-06-12	5001	0	\N	0	0	\N	\N	0	248959	0	19926-5	3011505		
30251	938	4052083	1993-12-21	1993-12-21 00:00:00	1993-12-21	5001	0	\N	0	0	\N	\N	0	62381	0	23426006	4052083		
51679	4732	3006322	2007-08-23	2007-08-23 00:00:00	2007-08-23	5001	0	\N	0	0	\N	\N	0	315254	0	8331-1	3006322		
27348	857	4133840	2010-04-18	2010-04-18 00:00:00	2010-04-18	5001	0	\N	0	0	\N	\N	0	56631	0	127783003	4133840		
146724	4501	4052083	1983-01-31	1983-01-31 00:00:00	1983-01-31	5001	0	\N	0	0	\N	\N	0	299705	0	23426006	4052083		
134047	4127	4052083	1973-06-24	1973-06-24 00:00:00	1973-06-24	5001	0	\N	0	0	\N	\N	0	274371	0	23426006	4052083		
32912	1024	4052083	1992-02-10	1992-02-10 00:00:00	1992-02-10	5001	0	\N	0	0	\N	\N	0	67444	0	23426006	4052083		
145422	4462	4133840	2015-04-02	2015-04-02 00:00:00	2015-04-02	5001	0	\N	0	0	\N	\N	0	296874	0	127783003	4133840		
8865	280	4052083	1981-01-08	1981-01-08 00:00:00	1981-01-08	5001	0	\N	0	0	\N	\N	0	18716	0	23426006	4052083		
157601	4844	4052083	1994-06-25	1994-06-25 00:00:00	1994-06-25	5001	0	\N	0	0	\N	\N	0	322217	0	23426006	4052083		
20334	639	4052083	1998-11-27	1998-11-27 00:00:00	1998-11-27	5001	0	\N	0	0	\N	\N	0	42311	0	23426006	4052083		
67185	2062	4024958	1948-07-09	1948-07-09 00:00:00	1948-07-09	5001	0	\N	0	0	\N	\N	0	137163	0	117015009	4024958		
11908	379	4052083	2016-07-28	2016-07-28 00:00:00	2016-07-28	5001	0	\N	0	0	\N	\N	0	25060	0	23426006	4052083		
78609	2414	4024958	1961-12-27	1961-12-27 00:00:00	1961-12-27	5001	0	\N	0	0	\N	\N	0	160196	0	117015009	4024958		
44548	4113	3006322	1986-05-21	1986-05-21 00:00:00	1986-05-21	5001	0	\N	0	0	\N	\N	0	273459	0	8331-1	3006322		
78759	2419	4024958	1970-08-01	1970-08-01 00:00:00	1970-08-01	5001	0	\N	0	0	\N	\N	0	160511	0	117015009	4024958		
90119	2782	4024958	1953-02-07	1953-02-07 00:00:00	1953-02-07	5001	0	\N	0	0	\N	\N	0	184419	0	117015009	4024958		
121741	3756	4133840	2006-05-13	2006-05-13 00:00:00	2006-05-13	5001	0	\N	0	0	\N	\N	0	249707	0	127783003	4133840		
30479	946	4024958	1967-10-30	1967-10-30 00:00:00	1967-10-30	5001	0	\N	0	0	\N	\N	0	62768	0	117015009	4024958		
133219	4105	4052083	1950-08-04	1950-08-04 00:00:00	1950-08-04	5001	0	\N	0	0	\N	\N	0	272720	0	23426006	4052083		
67823	2077	4052083	1942-06-08	1942-06-08 00:00:00	1942-06-08	5001	0	\N	0	0	\N	\N	0	138238	0	23426006	4052083		
149078	4570	4052083	1985-05-15	1985-05-15 00:00:00	1985-05-15	5001	0	\N	0	0	\N	\N	0	304483	0	23426006	4052083		
79217	2436	4052083	1970-10-25	1970-10-25 00:00:00	1970-10-25	5001	0	\N	0	0	\N	\N	0	161580	0	23426006	4052083		
43734	1348	4052083	1947-07-10	1947-07-10 00:00:00	1947-07-10	5001	0	\N	0	0	\N	\N	0	89291	0	23426006	4052083		
79062	2431	4052083	1992-09-29	1992-09-29 00:00:00	1992-09-29	5001	0	\N	0	0	\N	\N	0	161236	0	23426006	4052083		
171964	5279	4052083	1988-05-15	1988-05-15 00:00:00	1988-05-15	5001	0	\N	0	0	\N	\N	0	351186	0	23426006	4052083		
9854	929	3006322	1965-10-04	1965-10-04 00:00:00	1965-10-04	5001	0	\N	0	0	\N	\N	0	61824	0	8331-1	3006322		
101875	3129	4052083	1972-02-13	1972-02-13 00:00:00	1972-02-13	5001	0	\N	0	0	\N	\N	0	208287	0	23426006	4052083		
11271	1083	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	71173	0	6189-5	3006734		
50709	4623	3006322	1959-02-28	1959-02-28 00:00:00	1959-02-28	5001	0	\N	0	0	\N	\N	0	307928	0	8331-1	3006322		
4806	457	3006322	1961-03-27	1961-03-27 00:00:00	1961-03-27	5001	0	\N	0	0	\N	\N	0	30569	0	8331-1	3006322		
15968	1459	3006322	1948-11-09	1948-11-09 00:00:00	1948-11-09	5001	0	\N	0	0	\N	\N	0	97233	0	8331-1	3006322		
34153	3115	3006322	2001-08-15	2001-08-15 00:00:00	2001-08-15	5001	0	\N	0	0	\N	\N	0	207210	0	8331-1	3006322		
45553	4202	3006322	1972-01-13	1972-01-13 00:00:00	1972-01-13	5001	0	\N	0	0	\N	\N	0	278934	0	8331-1	3006322		
27284	2534	3006451	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	167387	0	6273-7	3006451		
82999	2561	4052083	1984-03-21	1984-03-21 00:00:00	1984-03-21	5001	0	\N	0	0	\N	\N	0	169706	0	23426006	4052083		
83036	2563	4024958	1972-10-11	1972-10-11 00:00:00	1972-10-11	5001	0	\N	0	0	\N	\N	0	169795	0	117015009	4024958		
23810	2189	3006451	2010-02-17	2010-02-17 00:00:00	2010-02-17	5001	0	\N	0	0	\N	\N	0	145893	0	6273-7	3006451		
37194	3427	3006322	1974-07-24	1974-07-24 00:00:00	1974-07-24	5001	0	\N	0	0	\N	\N	0	227209	0	8331-1	3006322		
105856	3258	4024958	2005-11-27	2005-11-27 00:00:00	2005-11-27	5001	0	\N	0	0	\N	\N	0	216557	0	117015009	4024958		
105921	3260	4024958	2003-03-31	2003-03-31 00:00:00	2003-03-31	5001	0	\N	0	0	\N	\N	0	216708	0	117015009	4024958		
160903	4943	4024958	1984-04-11	1984-04-11 00:00:00	1984-04-11	5001	0	\N	0	0	\N	\N	0	328539	0	117015009	4024958		
4234	419	40766240	1913-11-21	1913-11-21 00:00:00	1913-11-21	5001	0	\N	0	0	\N	\N	0	27685	0	63513-6	40766240		
10207	975	3006322	2004-02-15	2004-02-15 00:00:00	2004-02-15	5001	0	\N	0	0	\N	\N	0	65003	0	8331-1	3006322		
165100	5068	4024958	1973-07-07	1973-07-07 00:00:00	1973-07-07	5001	0	\N	0	0	\N	\N	0	336971	0	117015009	4024958		
169508	5200	4052083	1968-05-24	1968-05-24 00:00:00	1968-05-24	5001	0	\N	0	0	\N	\N	0	345866	0	23426006	4052083		
20214	1850	3006322	2005-05-01	2005-05-01 00:00:00	2005-05-01	5001	0	\N	0	0	\N	\N	0	123768	0	8331-1	3006322		
3147	299	40766240	1963-05-08	1963-05-08 00:00:00	1963-05-08	5001	0	\N	0	0	\N	\N	0	20006	0	63513-6	40766240		
27080	844	4024958	2005-05-04	2005-05-04 00:00:00	2005-05-04	5001	0	\N	0	0	\N	\N	0	55966	0	117015009	4024958		
14588	1356	3023430	1995-02-23	1995-02-23 00:00:00	1995-02-23	5001	0	\N	0	0	\N	\N	0	89888	0	6833-8	3023430		
27206	850	4024958	1955-09-06	1955-09-06 00:00:00	1955-09-06	5001	0	\N	0	0	\N	\N	0	56188	0	117015009	4024958		
93997	2893	4024958	1980-11-25	1980-11-25 00:00:00	1980-11-25	5001	0	\N	0	0	\N	\N	0	192532	0	117015009	4024958		
38608	1202	4024958	1982-12-27	1982-12-27 00:00:00	1982-12-27	5001	0	\N	0	0	\N	\N	0	79065	0	117015009	4024958		
27390	858	4024958	1997-12-22	1997-12-22 00:00:00	1997-12-22	5001	0	\N	0	0	\N	\N	0	56689	0	117015009	4024958		
105519	3248	4024958	1951-08-12	1951-08-12 00:00:00	1951-08-12	5001	0	\N	0	0	\N	\N	0	215892	0	117015009	4024958		
120237	3708	4052083	1984-07-20	1984-07-20 00:00:00	1984-07-20	5001	0	\N	0	0	\N	\N	0	246565	0	23426006	4052083		
131642	4055	4052083	1979-09-29	1979-09-29 00:00:00	1979-09-29	5001	0	\N	0	0	\N	\N	0	269509	0	23426006	4052083		
46032	4246	3051031	1977-11-20	1977-11-20 00:00:00	1977-11-20	5001	0	\N	0	0	\N	\N	0	281970	0	46240-8	3051031		
143045	4392	4052083	2003-11-27	2003-11-27 00:00:00	2003-11-27	5001	0	\N	0	0	\N	\N	0	292050	0	23426006	4052083		
71628	2191	4024958	1984-01-29	1984-01-29 00:00:00	1984-01-29	5001	0	\N	0	0	\N	\N	0	146114	0	117015009	4024958		
154523	4739	4024958	1947-11-05	1947-11-05 00:00:00	1947-11-05	5001	0	\N	0	0	\N	\N	0	315754	0	117015009	4024958		
28715	2657	3006322	2018-07-13	2018-07-13 00:00:00	2018-07-13	5001	0	\N	0	0	\N	\N	0	175938	0	8331-1	3006322		
26828	2483	3011505	1977-05-21	1977-05-21 00:00:00	1977-05-21	5001	0	\N	0	0	\N	\N	0	164507	0	19926-5	3011505		
19422	1776	3006322	1983-03-18	1983-03-18 00:00:00	1983-03-18	5001	0	\N	0	0	\N	\N	0	118784	0	8331-1	3006322		
40240	3745	3011505	2002-07-17	2002-07-17 00:00:00	2002-07-17	5001	0	\N	0	0	\N	\N	0	248892	0	19926-5	3011505		
41535	1283	4052083	1984-12-31	1984-12-31 00:00:00	1984-12-31	5001	0	\N	0	0	\N	\N	0	84798	0	23426006	4052083		
51680	4732	3006322	1985-02-10	1985-02-10 00:00:00	1985-02-10	5001	0	\N	0	0	\N	\N	0	315245	0	8331-1	3006322		
27349	857	4133840	2011-04-24	2011-04-24 00:00:00	2011-04-24	5001	0	\N	0	0	\N	\N	0	56642	0	127783003	4133840		
146727	4501	4052083	1979-11-25	1979-11-25 00:00:00	1979-11-25	5001	0	\N	0	0	\N	\N	0	299704	0	23426006	4052083		
32865	1024	4052083	1955-07-17	1955-07-17 00:00:00	1955-07-17	5001	0	\N	0	0	\N	\N	0	67398	0	23426006	4052083		
32913	1024	4133840	2019-06-16	2019-06-16 00:00:00	2019-06-16	5001	0	\N	0	0	\N	\N	0	67448	0	127783003	4133840		
145424	4462	4133840	2009-02-26	2009-02-26 00:00:00	2009-02-26	5001	0	\N	0	0	\N	\N	0	296908	0	127783003	4133840		
8927	283	4024958	1984-02-15	1984-02-15 00:00:00	1984-02-15	5001	0	\N	0	0	\N	\N	0	18859	0	117015009	4024958		
157634	4844	4052083	1993-10-19	1993-10-19 00:00:00	1993-10-19	5001	0	\N	0	0	\N	\N	0	322266	0	23426006	4052083		
20336	639	4024958	1974-05-16	1974-05-16 00:00:00	1974-05-16	5001	0	\N	0	0	\N	\N	0	42290	0	117015009	4024958		
67187	2062	4024958	1953-09-26	1953-09-26 00:00:00	1953-09-26	5001	0	\N	0	0	\N	\N	0	137123	0	117015009	4024958		
11912	379	4024958	1992-10-11	1992-10-11 00:00:00	1992-10-11	5001	0	\N	0	0	\N	\N	0	25068	0	117015009	4024958		
78635	2414	4024958	1964-11-23	1964-11-23 00:00:00	1964-11-23	5001	0	\N	0	0	\N	\N	0	160169	0	117015009	4024958		
44549	4113	3006322	1984-05-05	1984-05-05 00:00:00	1984-05-05	5001	0	\N	0	0	\N	\N	0	273458	0	8331-1	3006322		
90064	2780	4052083	1979-05-05	1979-05-05 00:00:00	1979-05-05	5001	0	\N	0	0	\N	\N	0	184235	0	23426006	4052083		
90128	2782	4052083	1962-11-19	1962-11-19 00:00:00	1962-11-19	5001	0	\N	0	0	\N	\N	0	184345	0	23426006	4052083		
121748	3756	4133840	2018-07-21	2018-07-21 00:00:00	2018-07-21	5001	0	\N	0	0	\N	\N	0	249694	0	127783003	4133840		
9478	299	4024958	1965-10-29	1965-10-29 00:00:00	1965-10-29	5001	0	\N	0	0	\N	\N	0	20022	0	117015009	4024958		
133221	4105	4024958	1969-01-28	1969-01-28 00:00:00	1969-01-28	5001	0	\N	0	0	\N	\N	0	272697	0	117015009	4024958		
77511	2380	4052083	2010-09-23	2010-09-23 00:00:00	2010-09-23	5001	0	\N	0	0	\N	\N	0	158191	0	23426006	4052083		
149097	4571	4052083	2000-08-03	2000-08-03 00:00:00	2000-08-03	5001	0	\N	0	0	\N	\N	0	304592	0	23426006	4052083		
79262	2436	4052083	1942-10-28	1942-10-28 00:00:00	1942-10-28	5001	0	\N	0	0	\N	\N	0	161513	0	23426006	4052083		
43740	1348	4024958	1914-06-18	1914-06-18 00:00:00	1914-06-18	5001	0	\N	0	0	\N	\N	0	89331	0	117015009	4024958		
79066	2431	4024958	1999-01-18	1999-01-18 00:00:00	1999-01-18	5001	0	\N	0	0	\N	\N	0	161215	0	117015009	4024958		
171972	5279	4024958	1968-04-16	1968-04-16 00:00:00	1968-04-16	5001	0	\N	0	0	\N	\N	0	351233	0	117015009	4024958		
9855	929	3006322	1956-07-24	1956-07-24 00:00:00	1956-07-24	5001	0	\N	0	0	\N	\N	0	61806	0	8331-1	3006322		
101882	3129	4052083	2006-12-25	2006-12-25 00:00:00	2006-12-25	5001	0	\N	0	0	\N	\N	0	208291	0	23426006	4052083		
11272	1083	3006322	1969-02-06	1969-02-06 00:00:00	1969-02-06	5001	0	\N	0	0	\N	\N	0	71067	0	8331-1	3006322		
50710	4623	3006322	1964-02-11	1964-02-11 00:00:00	1964-02-11	5001	0	\N	0	0	\N	\N	0	307929	0	8331-1	3006322		
4807	457	3049273	2009-05-14	2009-05-14 00:00:00	2009-05-14	5001	0	\N	0	0	\N	\N	0	30594	0	38265-5	3049273		
15969	1459	3006322	1981-10-28	1981-10-28 00:00:00	1981-10-28	5001	0	\N	0	0	\N	\N	0	97262	0	8331-1	3006322		
34154	3115	3006322	1974-03-15	1974-03-15 00:00:00	1974-03-15	5001	0	\N	0	0	\N	\N	0	207225	0	8331-1	3006322		
45554	4202	3006322	1990-09-29	1990-09-29 00:00:00	1990-09-29	5001	0	\N	0	0	\N	\N	0	278967	0	8331-1	3006322		
27285	2534	3027231	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	167387	0	6276-0	3027231		
83297	2572	4052083	2015-02-04	2015-02-04 00:00:00	2015-02-04	5001	0	\N	0	0	\N	\N	0	170377	0	23426006	4052083		
83045	2564	4052083	2002-09-24	2002-09-24 00:00:00	2002-09-24	5001	0	\N	0	0	\N	\N	0	169836	0	23426006	4052083		
23811	2189	3000876	2010-02-17	2010-02-17 00:00:00	2010-02-17	5001	0	\N	0	0	\N	\N	0	145893	0	6082-2	3000876		
37195	3427	3006322	2005-04-21	2005-04-21 00:00:00	2005-04-21	5001	0	\N	0	0	\N	\N	0	227198	0	8331-1	3006322		
105868	3258	4024958	1992-01-04	1992-01-04 00:00:00	1992-01-04	5001	0	\N	0	0	\N	\N	0	216553	0	117015009	4024958		
105929	3260	4052083	1998-02-07	1998-02-07 00:00:00	1998-02-07	5001	0	\N	0	0	\N	\N	0	216755	0	23426006	4052083		
160909	4943	4024958	1967-04-14	1967-04-14 00:00:00	1967-04-14	5001	0	\N	0	0	\N	\N	0	328564	0	117015009	4024958		
4236	419	40758406	1913-11-21	1913-11-21 00:00:00	1913-11-21	5001	0	\N	0	0	\N	\N	0	27685	0	55277-8	40758406		
10208	975	3006322	1967-10-03	1967-10-03 00:00:00	1967-10-03	5001	0	\N	0	0	\N	\N	0	65029	0	8331-1	3006322		
37828	3488	3011505	2014-04-04	2014-04-04 00:00:00	2014-04-04	5001	0	\N	0	0	\N	\N	0	231426	0	19926-5	3011505		
20735	651	4024958	1983-09-05	1983-09-05 00:00:00	1983-09-05	5001	0	\N	0	0	\N	\N	0	43104	0	117015009	4024958		
20215	1851	3006322	1995-12-17	1995-12-17 00:00:00	1995-12-17	5001	0	\N	0	0	\N	\N	0	123809	0	8331-1	3006322		
3149	299	3051031	1963-05-08	1963-05-08 00:00:00	1963-05-08	5001	0	\N	0	0	\N	\N	0	20006	0	46240-8	3051031		
14507	1355	40766240	1966-02-04	1966-02-04 00:00:00	1966-02-04	5001	0	\N	0	0	\N	\N	0	89794	0	63513-6	40766240		
14589	1356	3021226	1995-02-23	1995-02-23 00:00:00	1995-02-23	5001	0	\N	0	0	\N	\N	0	89888	0	6246-3	3021226		
38488	1194	4024958	1960-10-23	1960-10-23 00:00:00	1960-10-23	5001	0	\N	0	0	\N	\N	0	78685	0	117015009	4024958		
93998	2893	4052083	1946-05-18	1946-05-18 00:00:00	1946-05-18	5001	0	\N	0	0	\N	\N	0	192497	0	23426006	4052083		
38610	1202	4024958	1992-08-07	1992-08-07 00:00:00	1992-08-07	5001	0	\N	0	0	\N	\N	0	79070	0	117015009	4024958		
27421	859	4052083	1976-11-02	1976-11-02 00:00:00	1976-11-02	5001	0	\N	0	0	\N	\N	0	56753	0	23426006	4052083		
105527	3248	4024958	2007-04-03	2007-04-03 00:00:00	2007-04-03	5001	0	\N	0	0	\N	\N	0	215857	0	117015009	4024958		
120242	3708	4024958	1983-04-16	1983-04-16 00:00:00	1983-04-16	5001	0	\N	0	0	\N	\N	0	246502	0	117015009	4024958		
131645	4055	4052083	1970-05-01	1970-05-01 00:00:00	1970-05-01	5001	0	\N	0	0	\N	\N	0	269525	0	23426006	4052083		
46033	4246	46235214	1977-11-20	1977-11-20 00:00:00	1977-11-20	5001	0	\N	0	0	\N	\N	0	281970	0	76690-7	46235214		
143053	4393	4052083	2006-04-12	2006-04-12 00:00:00	2006-04-12	5001	0	\N	0	0	\N	\N	0	292089	0	23426006	4052083		
71631	2192	4052083	1975-06-30	1975-06-30 00:00:00	1975-06-30	5001	0	\N	0	0	\N	\N	0	146170	0	23426006	4052083		
35941	3301	3006322	2005-02-07	2005-02-07 00:00:00	2005-02-07	5001	0	\N	0	0	\N	\N	0	219268	0	8331-1	3006322		
28771	2659	3006322	2005-01-03	2005-01-03 00:00:00	2005-01-03	5001	0	\N	0	0	\N	\N	0	176158	0	8331-1	3006322		
26829	2483	3011505	1987-06-06	1987-06-06 00:00:00	1987-06-06	5001	0	\N	0	0	\N	\N	0	164503	0	19926-5	3011505		
19423	1776	3006322	1974-05-21	1974-05-21 00:00:00	1974-05-21	5001	0	\N	0	0	\N	\N	0	118774	0	8331-1	3006322		
40241	3745	3049273	1990-05-09	1990-05-09 00:00:00	1990-05-09	5001	0	\N	0	0	\N	\N	0	248869	0	38265-5	3049273		
41537	1283	4024958	1994-11-12	1994-11-12 00:00:00	1994-11-12	5001	0	\N	0	0	\N	\N	0	84829	0	117015009	4024958		
51681	4732	3006322	1966-08-07	1966-08-07 00:00:00	1966-08-07	5001	0	\N	0	0	\N	\N	0	315296	0	8331-1	3006322		
27350	857	4133840	2014-05-11	2014-05-11 00:00:00	2014-05-11	5001	0	\N	0	0	\N	\N	0	56633	0	127783003	4133840		
42385	3913	3001488	1981-11-09	1981-11-09 00:00:00	1981-11-09	5001	0	\N	0	0	\N	\N	0	260154	0	7258-7	3001488		
32884	1024	4024958	1999-01-30	1999-01-30 00:00:00	1999-01-30	5001	0	\N	0	0	\N	\N	0	67476	0	117015009	4024958		
44215	1360	4024958	1993-12-11	1993-12-11 00:00:00	1993-12-11	5001	0	\N	0	0	\N	\N	0	90282	0	117015009	4024958		
145425	4462	4024958	1967-09-01	1967-09-01 00:00:00	1967-09-01	5001	0	\N	0	0	\N	\N	0	296910	0	117015009	4024958		
8929	283	4052083	1993-05-27	1993-05-27 00:00:00	1993-05-27	5001	0	\N	0	0	\N	\N	0	18826	0	23426006	4052083		
157640	4844	4052083	2001-09-12	2001-09-12 00:00:00	2001-09-12	5001	0	\N	0	0	\N	\N	0	322218	0	23426006	4052083		
20340	639	4052083	2009-03-11	2009-03-11 00:00:00	2009-03-11	5001	0	\N	0	0	\N	\N	0	42245	0	23426006	4052083		
67191	2062	4024958	1984-08-15	1984-08-15 00:00:00	1984-08-15	5001	0	\N	0	0	\N	\N	0	137125	0	117015009	4024958		
11920	379	4024958	1984-09-09	1984-09-09 00:00:00	1984-09-09	5001	0	\N	0	0	\N	\N	0	25063	0	117015009	4024958		
78640	2414	4052083	1919-05-31	1919-05-31 00:00:00	1919-05-31	5001	0	\N	0	0	\N	\N	0	160273	0	23426006	4052083		
44550	4113	3006322	1985-02-11	1985-02-11 00:00:00	1985-02-11	5001	0	\N	0	0	\N	\N	0	273421	0	8331-1	3006322		
90067	2780	4024958	1958-10-17	1958-10-17 00:00:00	1958-10-17	5001	0	\N	0	0	\N	\N	0	184218	0	117015009	4024958		
90132	2782	4024958	1922-02-08	1922-02-08 00:00:00	1922-02-08	5001	0	\N	0	0	\N	\N	0	184439	0	117015009	4024958		
121755	3756	4133840	2005-05-07	2005-05-07 00:00:00	2005-05-07	5001	0	\N	0	0	\N	\N	0	249690	0	127783003	4133840		
20768	652	4024958	1995-06-16	1995-06-16 00:00:00	1995-06-16	5001	0	\N	0	0	\N	\N	0	43161	0	117015009	4024958		
133225	4105	4052083	1957-05-14	1957-05-14 00:00:00	1957-05-14	5001	0	\N	0	0	\N	\N	0	272696	0	23426006	4052083		
77522	2380	4052083	1950-06-28	1950-06-28 00:00:00	1950-06-28	5001	0	\N	0	0	\N	\N	0	158225	0	23426006	4052083		
57728	1762	4133840	2017-04-27	2017-04-27 00:00:00	2017-04-27	5001	0	\N	0	0	\N	\N	0	117859	0	127783003	4133840		
130394	4017	4024958	1939-03-18	1939-03-18 00:00:00	1939-03-18	5001	0	\N	0	0	\N	\N	0	266964	0	117015009	4024958		
43745	1348	4024958	1979-07-22	1979-07-22 00:00:00	1979-07-22	5001	0	\N	0	0	\N	\N	0	89339	0	117015009	4024958		
79067	2431	4024958	1972-07-19	1972-07-19 00:00:00	1972-07-19	5001	0	\N	0	0	\N	\N	0	161201	0	117015009	4024958		
171975	5279	4052083	1975-08-07	1975-08-07 00:00:00	1975-08-07	5001	0	\N	0	0	\N	\N	0	351146	0	23426006	4052083		
9856	929	3006322	1958-12-25	1958-12-25 00:00:00	1958-12-25	5001	0	\N	0	0	\N	\N	0	61807	0	8331-1	3006322		
9934	949	3051031	1959-08-14	1959-08-14 00:00:00	1959-08-14	5001	0	\N	0	0	\N	\N	0	62984	0	46240-8	3051031		
11273	1084	3006322	1990-02-14	1990-02-14 00:00:00	1990-02-14	5001	0	\N	0	0	\N	\N	0	71210	0	8331-1	3006322		
50711	4623	3006322	1973-10-21	1973-10-21 00:00:00	1973-10-21	5001	0	\N	0	0	\N	\N	0	307898	0	8331-1	3006322		
4808	457	3006322	1964-12-22	1964-12-22 00:00:00	1964-12-22	5001	0	\N	0	0	\N	\N	0	30556	0	8331-1	3006322		
15970	1459	3006322	1949-01-23	1949-01-23 00:00:00	1949-01-23	5001	0	\N	0	0	\N	\N	0	97260	0	8331-1	3006322		
34155	3115	3006322	1987-03-20	1987-03-20 00:00:00	1987-03-20	5001	0	\N	0	0	\N	\N	0	207201	0	8331-1	3006322		
45555	4202	3006322	2008-11-02	2008-11-02 00:00:00	2008-11-02	5001	0	\N	0	0	\N	\N	0	278936	0	8331-1	3006322		
27286	2534	3036780	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	167387	0	6095-4	3036780		
83332	2574	4024958	1972-02-09	1972-02-09 00:00:00	1972-02-09	5001	0	\N	0	0	\N	\N	0	170450	0	117015009	4024958		
94336	2899	4024958	1973-01-15	1973-01-15 00:00:00	1973-01-15	5001	0	\N	0	0	\N	\N	0	193116	0	117015009	4024958		
23812	2189	3036780	2010-02-17	2010-02-17 00:00:00	2010-02-17	5001	0	\N	0	0	\N	\N	0	145893	0	6095-4	3036780		
37196	3428	3006322	2009-10-15	2009-10-15 00:00:00	2009-10-15	5001	0	\N	0	0	\N	\N	0	227252	0	8331-1	3006322		
105882	3258	4052083	1989-08-22	1989-08-22 00:00:00	1989-08-22	5001	0	\N	0	0	\N	\N	0	216555	0	23426006	4052083		
105932	3260	4052083	1994-03-31	1994-03-31 00:00:00	1994-03-31	5001	0	\N	0	0	\N	\N	0	216706	0	23426006	4052083		
160919	4943	4024958	2017-05-02	2017-05-02 00:00:00	2017-05-02	5001	0	\N	0	0	\N	\N	0	328577	0	117015009	4024958		
4238	419	3051031	1913-11-21	1913-11-21 00:00:00	1913-11-21	5001	0	\N	0	0	\N	\N	0	27685	0	46240-8	3051031		
10209	975	3006322	2004-11-27	2004-11-27 00:00:00	2004-11-27	5001	0	\N	0	0	\N	\N	0	65004	0	8331-1	3006322		
37829	3488	3011505	1996-01-26	1996-01-26 00:00:00	1996-01-26	5001	0	\N	0	0	\N	\N	0	231397	0	19926-5	3011505		
20746	652	4052083	1973-11-07	1973-11-07 00:00:00	1973-11-07	5001	0	\N	0	0	\N	\N	0	43157	0	23426006	4052083		
20216	1851	3011505	2017-12-14	2017-12-14 00:00:00	2017-12-14	5001	0	\N	0	0	\N	\N	0	123857	0	19926-5	3011505		
3150	299	40758406	1963-05-08	1963-05-08 00:00:00	1963-05-08	5001	0	\N	0	0	\N	\N	0	20006	0	55277-8	40758406		
14508	1355	40758406	1966-02-04	1966-02-04 00:00:00	1966-02-04	5001	0	\N	0	0	\N	\N	0	89794	0	55277-8	40758406		
14590	1356	3027231	1995-02-23	1995-02-23 00:00:00	1995-02-23	5001	0	\N	0	0	\N	\N	0	89888	0	6276-0	3027231		
4580	141	4024958	1991-01-26	1991-01-26 00:00:00	1991-01-26	5001	0	\N	0	0	\N	\N	0	9448	0	117015009	4024958		
93999	2893	4052083	1949-05-25	1949-05-25 00:00:00	1949-05-25	5001	0	\N	0	0	\N	\N	0	192451	0	23426006	4052083		
38613	1202	4052083	2019-05-23	2019-05-23 00:00:00	2019-05-23	5001	0	\N	0	0	\N	\N	0	79083	0	23426006	4052083		
27434	859	4024958	1996-09-08	1996-09-08 00:00:00	1996-09-08	5001	0	\N	0	0	\N	\N	0	56814	0	117015009	4024958		
105536	3248	4024958	1954-03-08	1954-03-08 00:00:00	1954-03-08	5001	0	\N	0	0	\N	\N	0	215928	0	117015009	4024958		
120251	3708	4024958	1992-05-12	1992-05-12 00:00:00	1992-05-12	5001	0	\N	0	0	\N	\N	0	246520	0	117015009	4024958		
131646	4055	4024958	2001-10-26	2001-10-26 00:00:00	2001-10-26	5001	0	\N	0	0	\N	\N	0	269538	0	117015009	4024958		
46036	4246	40766240	1977-11-20	1977-11-20 00:00:00	1977-11-20	5001	0	\N	0	0	\N	\N	0	281970	0	63513-6	40766240		
143069	4393	4024958	1998-08-02	1998-08-02 00:00:00	1998-08-02	5001	0	\N	0	0	\N	\N	0	292104	0	117015009	4024958		
71639	2192	4024958	1959-01-16	1959-01-16 00:00:00	1959-01-16	5001	0	\N	0	0	\N	\N	0	146220	0	117015009	4024958		
35942	3301	3006322	1939-11-27	1939-11-27 00:00:00	1939-11-27	5001	0	\N	0	0	\N	\N	0	219303	0	8331-1	3006322		
28772	2659	3006322	1979-01-03	1979-01-03 00:00:00	1979-01-03	5001	0	\N	0	0	\N	\N	0	176118	0	8331-1	3006322		
26830	2483	3006322	1981-04-06	1981-04-06 00:00:00	1981-04-06	5001	0	\N	0	0	\N	\N	0	164491	0	8331-1	3006322		
19424	1776	3006322	2019-05-17	2019-05-17 00:00:00	2019-05-17	5001	0	\N	0	0	\N	\N	0	118795	0	8331-1	3006322		
40242	3745	3011505	1993-05-26	1993-05-26 00:00:00	1993-05-26	5001	0	\N	0	0	\N	\N	0	248891	0	19926-5	3011505		
41546	1283	4024958	2012-07-20	2012-07-20 00:00:00	2012-07-20	5001	0	\N	0	0	\N	\N	0	84800	0	117015009	4024958		
51682	4732	3006322	2018-01-10	2018-01-10 00:00:00	2018-01-10	5001	0	\N	0	0	\N	\N	0	315288	0	8331-1	3006322		
27351	857	4133840	2016-05-22	2016-05-22 00:00:00	2016-05-22	5001	0	\N	0	0	\N	\N	0	56590	0	127783003	4133840		
42386	3913	3006734	1981-11-09	1981-11-09 00:00:00	1981-11-09	5001	0	\N	0	0	\N	\N	0	260154	0	6189-5	3006734		
130220	4014	4024958	1976-05-29	1976-05-29 00:00:00	1976-05-29	5001	0	\N	0	0	\N	\N	0	266694	0	117015009	4024958		
44220	1360	4052083	1981-02-07	1981-02-07 00:00:00	1981-02-07	5001	0	\N	0	0	\N	\N	0	90275	0	23426006	4052083		
145430	4462	4133840	2017-04-13	2017-04-13 00:00:00	2017-04-13	5001	0	\N	0	0	\N	\N	0	296875	0	127783003	4133840		
169560	5203	4024958	1940-11-16	1940-11-16 00:00:00	1940-11-16	5001	0	\N	0	0	\N	\N	0	346100	0	117015009	4024958		
20286	636	4052083	2017-03-19	2017-03-19 00:00:00	2017-03-19	5001	0	\N	0	0	\N	\N	0	42158	0	23426006	4052083		
20342	639	4052083	1983-02-01	1983-02-01 00:00:00	1983-02-01	5001	0	\N	0	0	\N	\N	0	42303	0	23426006	4052083		
67211	2063	4024958	1987-12-21	1987-12-21 00:00:00	1987-12-21	5001	0	\N	0	0	\N	\N	0	137205	0	117015009	4024958		
11926	379	4052083	1985-06-06	1985-06-06 00:00:00	1985-06-06	5001	0	\N	0	0	\N	\N	0	25064	0	23426006	4052083		
78641	2414	4052083	1981-10-29	1981-10-29 00:00:00	1981-10-29	5001	0	\N	0	0	\N	\N	0	160223	0	23426006	4052083		
55849	5119	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	340316	0	6075-6	3005136		
90070	2780	4024958	1958-06-10	1958-06-10 00:00:00	1958-06-10	5001	0	\N	0	0	\N	\N	0	184233	0	117015009	4024958		
90147	2782	4052083	1987-06-20	1987-06-20 00:00:00	1987-06-20	5001	0	\N	0	0	\N	\N	0	184423	0	23426006	4052083		
121758	3756	4133840	2014-06-28	2014-06-28 00:00:00	2014-06-28	5001	0	\N	0	0	\N	\N	0	249692	0	127783003	4133840		
20773	653	4024958	2008-12-15	2008-12-15 00:00:00	2008-12-15	5001	0	\N	0	0	\N	\N	0	43274	0	117015009	4024958		
133226	4105	4052083	1995-09-13	1995-09-13 00:00:00	1995-09-13	5001	0	\N	0	0	\N	\N	0	272776	0	23426006	4052083		
77524	2380	4052083	1960-04-20	1960-04-20 00:00:00	1960-04-20	5001	0	\N	0	0	\N	\N	0	158184	0	23426006	4052083		
57733	1762	4133840	2016-04-21	2016-04-21 00:00:00	2016-04-21	5001	0	\N	0	0	\N	\N	0	117832	0	127783003	4133840		
130397	4018	4024958	1987-06-09	1987-06-09 00:00:00	1987-06-09	5001	0	\N	0	0	\N	\N	0	267065	0	117015009	4024958		
43747	1348	4052083	1920-03-15	1920-03-15 00:00:00	1920-03-15	5001	0	\N	0	0	\N	\N	0	89360	0	23426006	4052083		
79076	2431	4024958	1996-02-20	1996-02-20 00:00:00	1996-02-20	5001	0	\N	0	0	\N	\N	0	161190	0	117015009	4024958		
171980	5279	4052083	1954-05-16	1954-05-16 00:00:00	1954-05-16	5001	0	\N	0	0	\N	\N	0	351181	0	23426006	4052083		
9860	931	3006322	1993-04-02	1993-04-02 00:00:00	1993-04-02	5001	0	\N	0	0	\N	\N	0	61979	0	8331-1	3006322		
9935	949	46235214	1959-08-14	1959-08-14 00:00:00	1959-08-14	5001	0	\N	0	0	\N	\N	0	62984	0	76690-7	46235214		
11274	1084	3006322	1996-09-05	1996-09-05 00:00:00	1996-09-05	5001	0	\N	0	0	\N	\N	0	71205	0	8331-1	3006322		
50712	4623	3006322	1931-06-06	1931-06-06 00:00:00	1931-06-06	5001	0	\N	0	0	\N	\N	0	307860	0	8331-1	3006322		
4809	458	3006322	1986-05-18	1986-05-18 00:00:00	1986-05-18	5001	0	\N	0	0	\N	\N	0	30666	0	8331-1	3006322		
15971	1459	3049273	1997-07-15	1997-07-15 00:00:00	1997-07-15	5001	0	\N	0	0	\N	\N	0	97248	0	38265-5	3049273		
34160	3117	40758406	2002-02-20	2002-02-20 00:00:00	2002-02-20	5001	0	\N	0	0	\N	\N	0	207389	0	55277-8	40758406		
45556	4202	40769179	1971-08-25	1971-08-25 00:00:00	1971-08-25	5001	0	\N	0	0	\N	\N	0	278930	0	66519-0	40769179		
27287	2534	3001488	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	167387	0	7258-7	3001488		
83345	2574	4024958	1976-06-11	1976-06-11 00:00:00	1976-06-11	5001	0	\N	0	0	\N	\N	0	170459	0	117015009	4024958		
94344	2899	4052083	2017-08-27	2017-08-27 00:00:00	2017-08-27	5001	0	\N	0	0	\N	\N	0	193183	0	23426006	4052083		
23813	2189	3012494	2010-02-17	2010-02-17 00:00:00	2010-02-17	5001	0	\N	0	0	\N	\N	0	145893	0	6206-7	3012494		
37197	3428	3006322	1970-06-05	1970-06-05 00:00:00	1970-06-05	5001	0	\N	0	0	\N	\N	0	227248	0	8331-1	3006322		
105888	3259	4024958	1990-08-17	1990-08-17 00:00:00	1990-08-17	5001	0	\N	0	0	\N	\N	0	216644	0	117015009	4024958		
105936	3260	4024958	1974-07-21	1974-07-21 00:00:00	1974-07-21	5001	0	\N	0	0	\N	\N	0	216729	0	117015009	4024958		
78347	2402	4024958	1984-02-19	1984-02-19 00:00:00	1984-02-19	5001	0	\N	0	0	\N	\N	0	159616	0	117015009	4024958		
4239	419	46235214	1913-11-21	1913-11-21 00:00:00	1913-11-21	5001	0	\N	0	0	\N	\N	0	27685	0	76690-7	46235214		
172477	5291	4052083	1996-08-01	1996-08-01 00:00:00	1996-08-01	5001	0	\N	0	0	\N	\N	0	352066	0	23426006	4052083		
37830	3488	3011505	2002-02-01	2002-02-01 00:00:00	2002-02-01	5001	0	\N	0	0	\N	\N	0	231399	0	19926-5	3011505		
20747	652	4024958	1998-06-13	1998-06-13 00:00:00	1998-06-13	5001	0	\N	0	0	\N	\N	0	43162	0	117015009	4024958		
20217	1851	3011505	2009-07-16	2009-07-16 00:00:00	2009-07-16	5001	0	\N	0	0	\N	\N	0	123835	0	19926-5	3011505		
3151	300	3006322	1988-07-10	1988-07-10 00:00:00	1988-07-10	5001	0	\N	0	0	\N	\N	0	20075	0	8331-1	3006322		
14510	1355	40766240	2006-12-21	2006-12-21 00:00:00	2006-12-21	5001	0	\N	0	0	\N	\N	0	89799	0	63513-6	40766240		
14591	1356	3036780	1995-02-23	1995-02-23 00:00:00	1995-02-23	5001	0	\N	0	0	\N	\N	0	89888	0	6095-4	3036780		
4586	141	4052083	1987-03-16	1987-03-16 00:00:00	1987-03-16	5001	0	\N	0	0	\N	\N	0	9437	0	23426006	4052083		
94008	2894	4024958	1925-06-29	1925-06-29 00:00:00	1925-06-29	5001	0	\N	0	0	\N	\N	0	192632	0	117015009	4024958		
38623	1202	4024958	2004-02-22	2004-02-22 00:00:00	2004-02-22	5001	0	\N	0	0	\N	\N	0	79081	0	117015009	4024958		
37520	3462	3006322	1996-08-23	1996-08-23 00:00:00	1996-08-23	5001	0	\N	0	0	\N	\N	0	229734	0	8331-1	3006322		
54526	1655	4024958	2000-10-19	2000-10-19 00:00:00	2000-10-19	5001	0	\N	0	0	\N	\N	0	110984	0	117015009	4024958		
29376	911	4024958	2012-03-13	2012-03-13 00:00:00	2012-03-13	5001	0	\N	0	0	\N	\N	0	60482	0	117015009	4024958		
28080	2583	3006322	1991-04-16	1991-04-16 00:00:00	1991-04-16	5001	0	\N	0	0	\N	\N	0	171033	0	8331-1	3006322		
46037	4246	40758406	1977-11-20	1977-11-20 00:00:00	1977-11-20	5001	0	\N	0	0	\N	\N	0	281970	0	55277-8	40758406		
40850	1267	4052083	1955-10-21	1955-10-21 00:00:00	1955-10-21	5001	0	\N	0	0	\N	\N	0	83517	0	23426006	4052083		
71644	2192	4024958	1975-06-20	1975-06-20 00:00:00	1975-06-20	5001	0	\N	0	0	\N	\N	0	146208	0	117015009	4024958		
35943	3301	3006322	1970-08-22	1970-08-22 00:00:00	1970-08-22	5001	0	\N	0	0	\N	\N	0	219329	0	8331-1	3006322		
28775	2661	3006322	2009-07-05	2009-07-05 00:00:00	2009-07-05	5001	0	\N	0	0	\N	\N	0	176312	0	8331-1	3006322		
26831	2483	3011505	1968-05-11	1968-05-11 00:00:00	1968-05-11	5001	0	\N	0	0	\N	\N	0	164504	0	19926-5	3011505		
19425	1776	3006322	1923-07-07	1923-07-07 00:00:00	1923-07-07	5001	0	\N	0	0	\N	\N	0	118771	0	8331-1	3006322		
40243	3745	3011505	2007-08-15	2007-08-15 00:00:00	2007-08-15	5001	0	\N	0	0	\N	\N	0	248962	0	19926-5	3011505		
51596	4724	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	314724	0	6248-9	3015076		
51690	4735	3006322	1985-08-01	1985-08-01 00:00:00	1985-08-01	5001	0	\N	0	0	\N	\N	0	315414	0	8331-1	3006322		
27354	857	4133840	1994-09-25	1994-09-25 00:00:00	1994-09-25	5001	0	\N	0	0	\N	\N	0	56630	0	127783003	4133840		
42387	3913	3000876	1981-11-09	1981-11-09 00:00:00	1981-11-09	5001	0	\N	0	0	\N	\N	0	260154	0	6082-2	3000876		
38792	1209	4024958	1978-04-10	1978-04-10 00:00:00	1978-04-10	5001	0	\N	0	0	\N	\N	0	79471	0	117015009	4024958		
44235	1360	4024958	2016-03-28	2016-03-28 00:00:00	2016-03-28	5001	0	\N	0	0	\N	\N	0	90252	0	117015009	4024958		
145432	4462	4133840	2018-04-19	2018-04-19 00:00:00	2018-04-19	5001	0	\N	0	0	\N	\N	0	296926	0	127783003	4133840		
169567	5203	4052083	1973-08-03	1973-08-03 00:00:00	1973-08-03	5001	0	\N	0	0	\N	\N	0	346123	0	23426006	4052083		
20294	636	4052083	1998-11-16	1998-11-16 00:00:00	1998-11-16	5001	0	\N	0	0	\N	\N	0	42104	0	23426006	4052083		
20350	639	4052083	1965-05-01	1965-05-01 00:00:00	1965-05-01	5001	0	\N	0	0	\N	\N	0	42310	0	23426006	4052083		
67212	2063	4024958	1985-01-09	1985-01-09 00:00:00	1985-01-09	5001	0	\N	0	0	\N	\N	0	137218	0	117015009	4024958		
11928	380	4052083	2009-08-25	2009-08-25 00:00:00	2009-08-25	5001	0	\N	0	0	\N	\N	0	25153	0	23426006	4052083		
33372	1039	4024958	2003-08-05	2003-08-05 00:00:00	2003-08-05	5001	0	\N	0	0	\N	\N	0	68375	0	117015009	4024958		
55850	5119	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	340316	0	6206-7	3012494		
90089	2781	4052083	2014-01-18	2014-01-18 00:00:00	2014-01-18	5001	0	\N	0	0	\N	\N	0	184315	0	23426006	4052083		
90157	2782	4024958	1957-08-10	1957-08-10 00:00:00	1957-08-10	5001	0	\N	0	0	\N	\N	0	184420	0	117015009	4024958		
121760	3756	4133840	2010-06-05	2010-06-05 00:00:00	2010-06-05	5001	0	\N	0	0	\N	\N	0	249677	0	127783003	4133840		
20774	653	4024958	1978-03-13	1978-03-13 00:00:00	1978-03-13	5001	0	\N	0	0	\N	\N	0	43255	0	117015009	4024958		
133235	4105	4024958	1973-11-15	1973-11-15 00:00:00	1973-11-15	5001	0	\N	0	0	\N	\N	0	272759	0	117015009	4024958		
77540	2381	4024958	2004-01-12	2004-01-12 00:00:00	2004-01-12	5001	0	\N	0	0	\N	\N	0	158299	0	117015009	4024958		
57735	1762	4133840	2018-05-03	2018-05-03 00:00:00	2018-05-03	5001	0	\N	0	0	\N	\N	0	117835	0	127783003	4133840		
130420	4018	4052083	1990-05-04	1990-05-04 00:00:00	1990-05-04	5001	0	\N	0	0	\N	\N	0	267054	0	23426006	4052083		
43756	1348	4024958	1918-09-09	1918-09-09 00:00:00	1918-09-09	5001	0	\N	0	0	\N	\N	0	89280	0	117015009	4024958		
90642	2798	4052083	2005-09-27	2005-09-27 00:00:00	2005-09-27	5001	0	\N	0	0	\N	\N	0	185446	0	23426006	4052083		
9848	929	3006322	1925-02-07	1925-02-07 00:00:00	1925-02-07	5001	0	\N	0	0	\N	\N	0	61804	0	8331-1	3006322		
9861	931	3006322	1995-02-01	1995-02-01 00:00:00	1995-02-01	5001	0	\N	0	0	\N	\N	0	61938	0	8331-1	3006322		
9936	949	3011505	1998-03-30	1998-03-30 00:00:00	1998-03-30	5001	0	\N	0	0	\N	\N	0	63015	0	19926-5	3011505		
11275	1084	3006322	1995-04-02	1995-04-02 00:00:00	1995-04-02	5001	0	\N	0	0	\N	\N	0	71211	0	8331-1	3006322		
50713	4623	3006322	1996-05-08	1996-05-08 00:00:00	1996-05-08	5001	0	\N	0	0	\N	\N	0	307991	0	8331-1	3006322		
4810	458	3006322	1978-03-31	1978-03-31 00:00:00	1978-03-31	5001	0	\N	0	0	\N	\N	0	30629	0	8331-1	3006322		
15972	1460	3006322	1988-10-05	1988-10-05 00:00:00	1988-10-05	5001	0	\N	0	0	\N	\N	0	97315	0	8331-1	3006322		
34162	3117	46235214	2002-02-20	2002-02-20 00:00:00	2002-02-20	5001	0	\N	0	0	\N	\N	0	207389	0	76690-7	46235214		
45557	4202	40769189	1971-08-25	1971-08-25 00:00:00	1971-08-25	5001	0	\N	0	0	\N	\N	0	278930	0	66529-9	40769189		
27288	2534	3019406	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	167387	0	6158-0	3019406		
83359	2576	4024958	1997-03-22	1997-03-22 00:00:00	1997-03-22	5001	0	\N	0	0	\N	\N	0	170559	0	117015009	4024958		
94348	2899	4024958	1951-09-17	1951-09-17 00:00:00	1951-09-17	5001	0	\N	0	0	\N	\N	0	193177	0	117015009	4024958		
23814	2189	3001488	2010-02-17	2010-02-17 00:00:00	2010-02-17	5001	0	\N	0	0	\N	\N	0	145893	0	7258-7	3001488		
37200	3428	3006322	1999-04-17	1999-04-17 00:00:00	1999-04-17	5001	0	\N	0	0	\N	\N	0	227267	0	8331-1	3006322		
105892	3259	4024958	2008-03-08	2008-03-08 00:00:00	2008-03-08	5001	0	\N	0	0	\N	\N	0	216653	0	117015009	4024958		
105946	3260	4024958	1999-02-03	1999-02-03 00:00:00	1999-02-03	5001	0	\N	0	0	\N	\N	0	216707	0	117015009	4024958		
78374	2402	4024958	1977-08-10	1977-08-10 00:00:00	1977-08-10	5001	0	\N	0	0	\N	\N	0	159615	0	117015009	4024958		
4240	419	3051031	1913-04-25	1913-04-25 00:00:00	1913-04-25	5001	0	\N	0	0	\N	\N	0	27783	0	46240-8	3051031		
172478	5291	4024958	2000-09-09	2000-09-09 00:00:00	2000-09-09	5001	0	\N	0	0	\N	\N	0	352075	0	117015009	4024958		
37831	3488	3011505	2000-01-28	2000-01-28 00:00:00	2000-01-28	5001	0	\N	0	0	\N	\N	0	231374	0	19926-5	3011505		
20752	652	4052083	2004-12-02	2004-12-02 00:00:00	2004-12-02	5001	0	\N	0	0	\N	\N	0	43182	0	23426006	4052083		
20218	1851	3006322	1992-09-23	1992-09-23 00:00:00	1992-09-23	5001	0	\N	0	0	\N	\N	0	123838	0	8331-1	3006322		
3152	300	3006322	2002-11-03	2002-11-03 00:00:00	2002-11-03	5001	0	\N	0	0	\N	\N	0	20054	0	8331-1	3006322		
14511	1355	3051031	2006-12-21	2006-12-21 00:00:00	2006-12-21	5001	0	\N	0	0	\N	\N	0	89799	0	46240-8	3051031		
14592	1356	3005136	1995-02-23	1995-02-23 00:00:00	1995-02-23	5001	0	\N	0	0	\N	\N	0	89888	0	6075-6	3005136		
4636	143	4052083	2000-08-16	2000-08-16 00:00:00	2000-08-16	5001	0	\N	0	0	\N	\N	0	9573	0	23426006	4052083		
60520	1846	4024958	1956-03-03	1956-03-03 00:00:00	1956-03-03	5001	0	\N	0	0	\N	\N	0	123429	0	117015009	4024958		
38628	1202	4024958	2006-03-23	2006-03-23 00:00:00	2006-03-23	5001	0	\N	0	0	\N	\N	0	79067	0	117015009	4024958		
37521	3462	3006322	1969-05-20	1969-05-20 00:00:00	1969-05-20	5001	0	\N	0	0	\N	\N	0	229730	0	8331-1	3006322		
54532	1655	4024958	1992-09-16	1992-09-16 00:00:00	1992-09-16	5001	0	\N	0	0	\N	\N	0	110993	0	117015009	4024958		
29384	911	4024958	1978-11-26	1978-11-26 00:00:00	1978-11-26	5001	0	\N	0	0	\N	\N	0	60526	0	117015009	4024958		
28081	2583	3006322	1980-09-29	1980-09-29 00:00:00	1980-09-29	5001	0	\N	0	0	\N	\N	0	171024	0	8331-1	3006322		
46038	4246	3051031	1977-01-24	1977-01-24 00:00:00	1977-01-24	5001	0	\N	0	0	\N	\N	0	281920	0	46240-8	3051031		
40853	1267	4024958	1954-10-26	1954-10-26 00:00:00	1954-10-26	5001	0	\N	0	0	\N	\N	0	83516	0	117015009	4024958		
71650	2192	4024958	1992-04-28	1992-04-28 00:00:00	1992-04-28	5001	0	\N	0	0	\N	\N	0	146173	0	117015009	4024958		
35944	3301	3049273	2011-05-31	2011-05-31 00:00:00	2011-05-31	5001	0	\N	0	0	\N	\N	0	219287	0	38265-5	3049273		
28776	2661	3006322	1976-10-21	1976-10-21 00:00:00	1976-10-21	5001	0	\N	0	0	\N	\N	0	176296	0	8331-1	3006322		
26833	2483	3011505	1971-05-15	1971-05-15 00:00:00	1971-05-15	5001	0	\N	0	0	\N	\N	0	164505	0	19926-5	3011505		
19426	1776	3049273	1992-12-03	1992-12-03 00:00:00	1992-12-03	5001	0	\N	0	0	\N	\N	0	118805	0	38265-5	3049273		
40244	3745	3011505	2000-07-05	2000-07-05 00:00:00	2000-07-05	5001	0	\N	0	0	\N	\N	0	248961	0	19926-5	3011505		
51597	4724	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	314724	0	6273-7	3006451		
51691	4735	3006322	1974-08-30	1974-08-30 00:00:00	1974-08-30	5001	0	\N	0	0	\N	\N	0	315455	0	8331-1	3006322		
27356	857	4133840	2013-05-05	2013-05-05 00:00:00	2013-05-05	5001	0	\N	0	0	\N	\N	0	56643	0	127783003	4133840		
42390	3916	3006322	2019-04-04	2019-04-04 00:00:00	2019-04-04	5001	0	\N	0	0	\N	\N	0	260302	0	8331-1	3006322		
38800	1209	4024958	2009-11-16	2009-11-16 00:00:00	2009-11-16	5001	0	\N	0	0	\N	\N	0	79423	0	117015009	4024958		
44236	1360	4024958	1985-04-17	1985-04-17 00:00:00	1985-04-17	5001	0	\N	0	0	\N	\N	0	90233	0	117015009	4024958		
145435	4462	4133840	1990-09-20	1990-09-20 00:00:00	1990-09-20	5001	0	\N	0	0	\N	\N	0	296905	0	127783003	4133840		
169572	5203	4052083	1996-10-10	1996-10-10 00:00:00	1996-10-10	5001	0	\N	0	0	\N	\N	0	346114	0	23426006	4052083		
169640	5206	4024958	1985-10-27	1985-10-27 00:00:00	1985-10-27	5001	0	\N	0	0	\N	\N	0	346264	0	117015009	4024958		
20354	639	4052083	2008-02-16	2008-02-16 00:00:00	2008-02-16	5001	0	\N	0	0	\N	\N	0	42312	0	23426006	4052083		
67213	2063	4052083	2018-08-06	2018-08-06 00:00:00	2018-08-06	5001	0	\N	0	0	\N	\N	0	137251	0	23426006	4052083		
87501	2704	4024958	1973-07-07	1973-07-07 00:00:00	1973-07-07	5001	0	\N	0	0	\N	\N	0	179148	0	117015009	4024958		
67931	2080	4024958	2008-11-14	2008-11-14 00:00:00	2008-11-14	5001	0	\N	0	0	\N	\N	0	138599	0	117015009	4024958		
55851	5119	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	340316	0	6106-9	3014599		
90093	2781	4052083	1985-05-02	1985-05-02 00:00:00	1985-05-02	5001	0	\N	0	0	\N	\N	0	184291	0	23426006	4052083		
90167	2782	4024958	1932-07-28	1932-07-28 00:00:00	1932-07-28	5001	0	\N	0	0	\N	\N	0	184441	0	117015009	4024958		
121763	3756	4052083	1946-02-03	1946-02-03 00:00:00	1946-02-03	5001	0	\N	0	0	\N	\N	0	249639	0	23426006	4052083		
20782	653	4024958	1989-10-30	1989-10-30 00:00:00	1989-10-30	5001	0	\N	0	0	\N	\N	0	43260	0	117015009	4024958		
133252	4106	4024958	1985-01-25	1985-01-25 00:00:00	1985-01-25	5001	0	\N	0	0	\N	\N	0	272864	0	117015009	4024958		
77545	2381	4024958	1951-09-26	1951-09-26 00:00:00	1951-09-26	5001	0	\N	0	0	\N	\N	0	158314	0	117015009	4024958		
57740	1762	4024958	1967-08-25	1967-08-25 00:00:00	1967-08-25	5001	0	\N	0	0	\N	\N	0	117846	0	117015009	4024958		
130426	4019	4024958	2012-02-22	2012-02-22 00:00:00	2012-02-22	5001	0	\N	0	0	\N	\N	0	267152	0	117015009	4024958		
43757	1348	4024958	1954-08-06	1954-08-06 00:00:00	1954-08-06	5001	0	\N	0	0	\N	\N	0	89336	0	117015009	4024958		
90656	2798	4024958	1958-10-16	1958-10-16 00:00:00	1958-10-16	5001	0	\N	0	0	\N	\N	0	185455	0	117015009	4024958		
9849	929	3006322	1937-06-19	1937-06-19 00:00:00	1937-06-19	5001	0	\N	0	0	\N	\N	0	61821	0	8331-1	3006322		
9862	931	3006322	1965-11-20	1965-11-20 00:00:00	1965-11-20	5001	0	\N	0	0	\N	\N	0	61967	0	8331-1	3006322		
9937	949	3011505	2001-09-24	2001-09-24 00:00:00	2001-09-24	5001	0	\N	0	0	\N	\N	0	63059	0	19926-5	3011505		
11276	1084	3006322	1979-08-30	1979-08-30 00:00:00	1979-08-30	5001	0	\N	0	0	\N	\N	0	71237	0	8331-1	3006322		
50716	4625	3006322	2015-12-28	2015-12-28 00:00:00	2015-12-28	5001	0	\N	0	0	\N	\N	0	308108	0	8331-1	3006322		
4811	458	3006322	1981-01-04	1981-01-04 00:00:00	1981-01-04	5001	0	\N	0	0	\N	\N	0	30665	0	8331-1	3006322		
15973	1460	3006322	1983-04-21	1983-04-21 00:00:00	1983-04-21	5001	0	\N	0	0	\N	\N	0	97307	0	8331-1	3006322		
34164	3117	40766240	2002-02-20	2002-02-20 00:00:00	2002-02-20	5001	0	\N	0	0	\N	\N	0	207389	0	63513-6	40766240		
45558	4202	40769194	1971-08-25	1971-08-25 00:00:00	1971-08-25	5001	0	\N	0	0	\N	\N	0	278930	0	66534-9	40769194		
27289	2534	3000876	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	167387	0	6082-2	3000876		
83360	2576	4052083	2002-12-09	2002-12-09 00:00:00	2002-12-09	5001	0	\N	0	0	\N	\N	0	170540	0	23426006	4052083		
83410	2577	4024958	1975-07-03	1975-07-03 00:00:00	1975-07-03	5001	0	\N	0	0	\N	\N	0	170613	0	117015009	4024958		
23815	2189	3001247	2010-02-17	2010-02-17 00:00:00	2010-02-17	5001	0	\N	0	0	\N	\N	0	145893	0	6085-5	3001247		
37201	3428	3006322	2007-05-15	2007-05-15 00:00:00	2007-05-15	5001	0	\N	0	0	\N	\N	0	227268	0	8331-1	3006322		
105900	3259	4024958	1980-11-12	1980-11-12 00:00:00	1980-11-12	5001	0	\N	0	0	\N	\N	0	216643	0	117015009	4024958		
117246	3614	4024958	1958-06-11	1958-06-11 00:00:00	1958-06-11	5001	0	\N	0	0	\N	\N	0	240136	0	117015009	4024958		
4139	409	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	27073	0	6189-5	3006734		
4242	419	46235214	1913-04-25	1913-04-25 00:00:00	1913-04-25	5001	0	\N	0	0	\N	\N	0	27783	0	76690-7	46235214		
8614	823	3006322	1950-02-25	1950-02-25 00:00:00	1950-02-25	5001	0	\N	0	0	\N	\N	0	54561	0	8331-1	3006322		
37832	3488	3011505	2008-02-29	2008-02-29 00:00:00	2008-02-29	5001	0	\N	0	0	\N	\N	0	231411	0	19926-5	3011505		
32089	992	4052083	1962-12-08	1962-12-08 00:00:00	1962-12-08	5001	0	\N	0	0	\N	\N	0	65745	0	23426006	4052083		
31780	2902	3006322	1997-08-01	1997-08-01 00:00:00	1997-08-01	5001	0	\N	0	0	\N	\N	0	193299	0	8331-1	3006322		
3153	300	3006322	1982-08-31	1982-08-31 00:00:00	1982-08-31	5001	0	\N	0	0	\N	\N	0	20074	0	8331-1	3006322		
14512	1355	46235214	2006-12-21	2006-12-21 00:00:00	2006-12-21	5001	0	\N	0	0	\N	\N	0	89799	0	76690-7	46235214		
14593	1356	3000876	1995-02-23	1995-02-23 00:00:00	1995-02-23	5001	0	\N	0	0	\N	\N	0	89888	0	6082-2	3000876		
4639	144	4024958	2000-09-23	2000-09-23 00:00:00	2000-09-23	5001	0	\N	0	0	\N	\N	0	9622	0	117015009	4024958		
60535	1846	4052083	2002-11-30	2002-11-30 00:00:00	2002-11-30	5001	0	\N	0	0	\N	\N	0	123460	0	23426006	4052083		
49955	1518	4024958	1992-05-09	1992-05-09 00:00:00	1992-05-09	5001	0	\N	0	0	\N	\N	0	101528	0	117015009	4024958		
37522	3462	3006322	2016-10-18	2016-10-18 00:00:00	2016-10-18	5001	0	\N	0	0	\N	\N	0	229737	0	8331-1	3006322		
54550	1656	4024958	1992-07-14	1992-07-14 00:00:00	1992-07-14	5001	0	\N	0	0	\N	\N	0	111067	0	117015009	4024958		
29389	911	4052083	2003-12-23	2003-12-23 00:00:00	2003-12-23	5001	0	\N	0	0	\N	\N	0	60491	0	23426006	4052083		
28082	2583	3006322	1973-02-01	1973-02-01 00:00:00	1973-02-01	5001	0	\N	0	0	\N	\N	0	171048	0	8331-1	3006322		
46039	4246	40758406	1977-01-24	1977-01-24 00:00:00	1977-01-24	5001	0	\N	0	0	\N	\N	0	281920	0	55277-8	40758406		
40865	1267	4024958	2016-01-21	2016-01-21 00:00:00	2016-01-21	5001	0	\N	0	0	\N	\N	0	83552	0	117015009	4024958		
71658	2192	4024958	1986-06-02	1986-06-02 00:00:00	1986-06-02	5001	0	\N	0	0	\N	\N	0	146180	0	117015009	4024958		
35945	3301	3006322	1984-06-06	1984-06-06 00:00:00	1984-06-06	5001	0	\N	0	0	\N	\N	0	219265	0	8331-1	3006322		
28777	2661	3006322	1974-10-19	1974-10-19 00:00:00	1974-10-19	5001	0	\N	0	0	\N	\N	0	176382	0	8331-1	3006322		
26834	2483	3011505	1983-05-28	1983-05-28 00:00:00	1983-05-28	5001	0	\N	0	0	\N	\N	0	164509	0	19926-5	3011505		
19427	1776	3006322	1964-08-26	1964-08-26 00:00:00	1964-08-26	5001	0	\N	0	0	\N	\N	0	118864	0	8331-1	3006322		
40245	3745	3011505	2005-08-03	2005-08-03 00:00:00	2005-08-03	5001	0	\N	0	0	\N	\N	0	248973	0	19926-5	3011505		
51598	4724	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	314724	0	6246-3	3021226		
51692	4735	3006322	1994-02-26	1994-02-26 00:00:00	1994-02-26	5001	0	\N	0	0	\N	\N	0	315425	0	8331-1	3006322		
27358	857	4133840	1998-10-04	1998-10-04 00:00:00	1998-10-04	5001	0	\N	0	0	\N	\N	0	56640	0	127783003	4133840		
42391	3916	3027231	1979-04-17	1979-04-17 00:00:00	1979-04-17	5001	0	\N	0	0	\N	\N	0	260278	0	6276-0	3027231		
38824	1211	4024958	1966-09-11	1966-09-11 00:00:00	1966-09-11	5001	0	\N	0	0	\N	\N	0	79535	0	117015009	4024958		
44237	1360	4052083	2015-09-29	2015-09-29 00:00:00	2015-09-29	5001	0	\N	0	0	\N	\N	0	90268	0	23426006	4052083		
145437	4462	4133840	1995-03-23	1995-03-23 00:00:00	1995-03-23	5001	0	\N	0	0	\N	\N	0	296920	0	127783003	4133840		
169573	5203	4024958	1950-02-04	1950-02-04 00:00:00	1950-02-04	5001	0	\N	0	0	\N	\N	0	346054	0	117015009	4024958		
169643	5206	4052083	1980-11-25	1980-11-25 00:00:00	1980-11-25	5001	0	\N	0	0	\N	\N	0	346254	0	23426006	4052083		
20362	640	4052083	1992-04-24	1992-04-24 00:00:00	1992-04-24	5001	0	\N	0	0	\N	\N	0	42370	0	23426006	4052083		
10315	331	4024958	1944-01-19	1944-01-19 00:00:00	1944-01-19	5001	0	\N	0	0	\N	\N	0	21815	0	117015009	4024958		
87508	2704	4024958	2002-07-16	2002-07-16 00:00:00	2002-07-16	5001	0	\N	0	0	\N	\N	0	179151	0	117015009	4024958		
67935	2080	4024958	1990-06-12	1990-06-12 00:00:00	1990-06-12	5001	0	\N	0	0	\N	\N	0	138535	0	117015009	4024958		
55852	5119	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	340316	0	6158-0	3019406		
33173	1033	4024958	1983-05-16	1983-05-16 00:00:00	1983-05-16	5001	0	\N	0	0	\N	\N	0	67971	0	117015009	4024958		
33256	1036	4024958	2013-07-17	2013-07-17 00:00:00	2013-07-17	5001	0	\N	0	0	\N	\N	0	68121	0	117015009	4024958		
121770	3756	4133840	2013-06-22	2013-06-22 00:00:00	2013-06-22	5001	0	\N	0	0	\N	\N	0	249662	0	127783003	4133840		
20785	653	4024958	1983-01-16	1983-01-16 00:00:00	1983-01-16	5001	0	\N	0	0	\N	\N	0	43221	0	117015009	4024958		
150186	4606	4052083	1987-09-07	1987-09-07 00:00:00	1987-09-07	5001	0	\N	0	0	\N	\N	0	306831	0	23426006	4052083		
77551	2381	4024958	1941-12-01	1941-12-01 00:00:00	1941-12-01	5001	0	\N	0	0	\N	\N	0	158284	0	117015009	4024958		
57743	1762	4133840	1984-02-09	1984-02-09 00:00:00	1984-02-09	5001	0	\N	0	0	\N	\N	0	117842	0	127783003	4133840		
130441	4019	4024958	1973-07-15	1973-07-15 00:00:00	1973-07-15	5001	0	\N	0	0	\N	\N	0	267120	0	117015009	4024958		
43761	1348	4024958	1972-06-01	1972-06-01 00:00:00	1972-06-01	5001	0	\N	0	0	\N	\N	0	89294	0	117015009	4024958		
90657	2798	4052083	1977-12-27	1977-12-27 00:00:00	1977-12-27	5001	0	\N	0	0	\N	\N	0	185452	0	23426006	4052083		
9851	929	3006322	1979-01-09	1979-01-09 00:00:00	1979-01-09	5001	0	\N	0	0	\N	\N	0	61825	0	8331-1	3006322		
9863	931	3006322	1966-01-01	1966-01-01 00:00:00	1966-01-01	5001	0	\N	0	0	\N	\N	0	61968	0	8331-1	3006322		
9938	949	3011505	1990-03-19	1990-03-19 00:00:00	1990-03-19	5001	0	\N	0	0	\N	\N	0	63036	0	19926-5	3011505		
11277	1085	3006322	1976-05-16	1976-05-16 00:00:00	1976-05-16	5001	0	\N	0	0	\N	\N	0	71251	0	8331-1	3006322		
50717	4625	3006322	2017-05-31	2017-05-31 00:00:00	2017-05-31	5001	0	\N	0	0	\N	\N	0	308074	0	8331-1	3006322		
4812	458	3006322	1974-04-09	1974-04-09 00:00:00	1974-04-09	5001	0	\N	0	0	\N	\N	0	30614	0	8331-1	3006322		
15974	1461	3006322	2005-05-20	2005-05-20 00:00:00	2005-05-20	5001	0	\N	0	0	\N	\N	0	97327	0	8331-1	3006322		
34165	3117	3051031	2002-02-20	2002-02-20 00:00:00	2002-02-20	5001	0	\N	0	0	\N	\N	0	207389	0	46240-8	3051031		
45559	4202	40769184	1971-08-25	1971-08-25 00:00:00	1971-08-25	5001	0	\N	0	0	\N	\N	0	278930	0	66524-0	40769184		
27290	2534	3001247	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	167387	0	6085-5	3001247		
83376	2576	4024958	1982-04-11	1982-04-11 00:00:00	1982-04-11	5001	0	\N	0	0	\N	\N	0	170526	0	117015009	4024958		
94694	2909	4024958	1997-02-08	1997-02-08 00:00:00	1997-02-08	5001	0	\N	0	0	\N	\N	0	193846	0	117015009	4024958		
23816	2189	3015076	2010-02-17	2010-02-17 00:00:00	2010-02-17	5001	0	\N	0	0	\N	\N	0	145893	0	6248-9	3015076		
37203	3430	3011505	2017-05-13	2017-05-13 00:00:00	2017-05-13	5001	0	\N	0	0	\N	\N	0	227341	0	19926-5	3011505		
106229	3270	4024958	2006-12-20	2006-12-20 00:00:00	2006-12-20	5001	0	\N	0	0	\N	\N	0	217331	0	117015009	4024958		
117249	3614	4024958	1967-07-06	1967-07-06 00:00:00	1967-07-06	5001	0	\N	0	0	\N	\N	0	240142	0	117015009	4024958		
4140	409	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	27073	0	6833-8	3023430		
4243	419	40758406	1913-04-25	1913-04-25 00:00:00	1913-04-25	5001	0	\N	0	0	\N	\N	0	27783	0	55277-8	40758406		
8615	823	3011505	2011-12-26	2011-12-26 00:00:00	2011-12-26	5001	0	\N	0	0	\N	\N	0	54600	0	19926-5	3011505		
37833	3488	3011505	1994-01-21	1994-01-21 00:00:00	1994-01-21	5001	0	\N	0	0	\N	\N	0	231414	0	19926-5	3011505		
58991	1794	4052083	2014-11-15	2014-11-15 00:00:00	2014-11-15	5001	0	\N	0	0	\N	\N	0	120331	0	23426006	4052083		
31781	2902	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	193352	0	6833-8	3023430		
3154	300	3006322	2007-12-20	2007-12-20 00:00:00	2007-12-20	5001	0	\N	0	0	\N	\N	0	20055	0	8331-1	3006322		
14514	1355	40758406	2006-12-21	2006-12-21 00:00:00	2006-12-21	5001	0	\N	0	0	\N	\N	0	89799	0	55277-8	40758406		
14594	1356	3020655	1995-02-23	1995-02-23 00:00:00	1995-02-23	5001	0	\N	0	0	\N	\N	0	89888	0	6844-5	3020655		
14670	1361	3006322	1954-10-02	1954-10-02 00:00:00	1954-10-02	5001	0	\N	0	0	\N	\N	0	90344	0	8331-1	3006322		
60540	1847	4052083	1926-12-24	1926-12-24 00:00:00	1926-12-24	5001	0	\N	0	0	\N	\N	0	123586	0	23426006	4052083		
49958	1518	4024958	1994-03-12	1994-03-12 00:00:00	1994-03-12	5001	0	\N	0	0	\N	\N	0	101538	0	117015009	4024958		
37523	3462	3006322	1987-08-16	1987-08-16 00:00:00	1987-08-16	5001	0	\N	0	0	\N	\N	0	229741	0	8331-1	3006322		
54562	1656	4052083	1994-06-01	1994-06-01 00:00:00	1994-06-01	5001	0	\N	0	0	\N	\N	0	111055	0	23426006	4052083		
29395	911	4024958	2008-12-02	2008-12-02 00:00:00	2008-12-02	5001	0	\N	0	0	\N	\N	0	60493	0	117015009	4024958		
28083	2583	3006322	1973-12-10	1973-12-10 00:00:00	1973-12-10	5001	0	\N	0	0	\N	\N	0	171057	0	8331-1	3006322		
46041	4246	40766240	1977-01-24	1977-01-24 00:00:00	1977-01-24	5001	0	\N	0	0	\N	\N	0	281920	0	63513-6	40766240		
40866	1267	4052083	1960-12-17	1960-12-17 00:00:00	1960-12-17	5001	0	\N	0	0	\N	\N	0	83560	0	23426006	4052083		
71670	2192	4024958	2013-10-15	2013-10-15 00:00:00	2013-10-15	5001	0	\N	0	0	\N	\N	0	146176	0	117015009	4024958		
35949	3304	3006322	1985-10-13	1985-10-13 00:00:00	1985-10-13	5001	0	\N	0	0	\N	\N	0	219450	0	8331-1	3006322		
28778	2661	3006322	1966-02-07	1966-02-07 00:00:00	1966-02-07	5001	0	\N	0	0	\N	\N	0	176266	0	8331-1	3006322		
26835	2483	3006322	1980-05-27	1980-05-27 00:00:00	1980-05-27	5001	0	\N	0	0	\N	\N	0	164516	0	8331-1	3006322		
19428	1776	3002385	1984-10-13	1984-10-13 00:00:00	1984-10-13	5001	0	\N	0	0	\N	\N	0	118804	0	30385-9	3002385		
40246	3745	3011505	2006-08-09	2006-08-09 00:00:00	2006-08-09	5001	0	\N	0	0	\N	\N	0	248894	0	19926-5	3011505		
51599	4724	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	314724	0	6082-2	3000876		
51693	4735	3006322	1989-10-20	1989-10-20 00:00:00	1989-10-20	5001	0	\N	0	0	\N	\N	0	315456	0	8331-1	3006322		
27361	857	4133840	2015-05-17	2015-05-17 00:00:00	2015-05-17	5001	0	\N	0	0	\N	\N	0	56627	0	127783003	4133840		
42392	3916	3001488	1979-04-17	1979-04-17 00:00:00	1979-04-17	5001	0	\N	0	0	\N	\N	0	260278	0	7258-7	3001488		
50129	1524	4024958	2003-04-19	2003-04-19 00:00:00	2003-04-19	5001	0	\N	0	0	\N	\N	0	101955	0	117015009	4024958		
44238	1360	4052083	2009-11-12	2009-11-12 00:00:00	2009-11-12	5001	0	\N	0	0	\N	\N	0	90267	0	23426006	4052083		
145440	4462	4133840	1993-03-18	1993-03-18 00:00:00	1993-03-18	5001	0	\N	0	0	\N	\N	0	296877	0	127783003	4133840		
169579	5203	4052083	1961-09-15	1961-09-15 00:00:00	1961-09-15	5001	0	\N	0	0	\N	\N	0	346121	0	23426006	4052083		
169645	5206	4024958	1999-06-23	1999-06-23 00:00:00	1999-06-23	5001	0	\N	0	0	\N	\N	0	346258	0	117015009	4024958		
20364	640	4052083	1960-03-26	1960-03-26 00:00:00	1960-03-26	5001	0	\N	0	0	\N	\N	0	42368	0	23426006	4052083		
10337	332	4024958	1969-06-15	1969-06-15 00:00:00	1969-06-15	5001	0	\N	0	0	\N	\N	0	21993	0	117015009	4024958		
87510	2705	4052083	2017-08-19	2017-08-19 00:00:00	2017-08-19	5001	0	\N	0	0	\N	\N	0	179225	0	23426006	4052083		
67949	2080	4024958	1985-12-21	1985-12-21 00:00:00	1985-12-21	5001	0	\N	0	0	\N	\N	0	138533	0	117015009	4024958		
55853	5119	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	340316	0	6248-9	3015076		
33175	1033	4052083	1974-07-22	1974-07-22 00:00:00	1974-07-22	5001	0	\N	0	0	\N	\N	0	67970	0	23426006	4052083		
33271	1036	4052083	1995-07-26	1995-07-26 00:00:00	1995-07-26	5001	0	\N	0	0	\N	\N	0	68147	0	23426006	4052083		
121772	3756	4133840	2009-05-30	2009-05-30 00:00:00	2009-05-30	5001	0	\N	0	0	\N	\N	0	249660	0	127783003	4133840		
20789	653	4052083	1971-11-23	1971-11-23 00:00:00	1971-11-23	5001	0	\N	0	0	\N	\N	0	43259	0	23426006	4052083		
150202	4606	4024958	1996-08-22	1996-08-22 00:00:00	1996-08-22	5001	0	\N	0	0	\N	\N	0	306840	0	117015009	4024958		
77558	2381	4024958	1968-12-26	1968-12-26 00:00:00	1968-12-26	5001	0	\N	0	0	\N	\N	0	158295	0	117015009	4024958		
57746	1762	4133840	2006-02-23	2006-02-23 00:00:00	2006-02-23	5001	0	\N	0	0	\N	\N	0	117857	0	127783003	4133840		
130448	4019	4024958	1993-12-16	1993-12-16 00:00:00	1993-12-16	5001	0	\N	0	0	\N	\N	0	267151	0	117015009	4024958		
43768	1348	4052083	1942-09-03	1942-09-03 00:00:00	1942-09-03	5001	0	\N	0	0	\N	\N	0	89361	0	23426006	4052083		
90659	2798	4024958	1996-05-01	1996-05-01 00:00:00	1996-05-01	5001	0	\N	0	0	\N	\N	0	185462	0	117015009	4024958		
80610	2487	4052083	1993-09-30	1993-09-30 00:00:00	1993-09-30	5001	0	\N	0	0	\N	\N	0	164762	0	23426006	4052083		
9864	931	3006322	1966-08-08	1966-08-08 00:00:00	1966-08-08	5001	0	\N	0	0	\N	\N	0	61927	0	8331-1	3006322		
9939	949	3011505	1989-09-04	1989-09-04 00:00:00	1989-09-04	5001	0	\N	0	0	\N	\N	0	63035	0	19926-5	3011505		
22555	2070	3006322	2018-02-04	2018-02-04 00:00:00	2018-02-04	5001	0	\N	0	0	\N	\N	0	137765	0	8331-1	3006322		
50718	4626	3000876	1997-11-21	1997-11-21 00:00:00	1997-11-21	5001	0	\N	0	0	\N	\N	0	308259	0	6082-2	3000876		
4813	458	3006322	1978-05-10	1978-05-10 00:00:00	1978-05-10	5001	0	\N	0	0	\N	\N	0	30664	0	8331-1	3006322		
15975	1461	3006322	1968-09-17	1968-09-17 00:00:00	1968-09-17	5001	0	\N	0	0	\N	\N	0	97364	0	8331-1	3006322		
34166	3117	40758406	2001-10-23	2001-10-23 00:00:00	2001-10-23	5001	0	\N	0	0	\N	\N	0	207370	0	55277-8	40758406		
45565	4204	3006322	2016-02-28	2016-02-28 00:00:00	2016-02-28	5001	0	\N	0	0	\N	\N	0	279115	0	8331-1	3006322		
27291	2534	3020655	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	167387	0	6844-5	3020655		
72216	2213	4024958	1982-01-01	1982-01-01 00:00:00	1982-01-01	5001	0	\N	0	0	\N	\N	0	147389	0	117015009	4024958		
94695	2909	4133840	1994-05-01	1994-05-01 00:00:00	1994-05-01	5001	0	\N	0	0	\N	\N	0	193867	0	127783003	4133840		
23817	2189	3021226	2010-02-17	2010-02-17 00:00:00	2010-02-17	5001	0	\N	0	0	\N	\N	0	145893	0	6246-3	3021226		
37204	3430	3011505	2014-04-26	2014-04-26 00:00:00	2014-04-26	5001	0	\N	0	0	\N	\N	0	227377	0	19926-5	3011505		
106241	3270	4024958	1976-04-25	1976-04-25 00:00:00	1976-04-25	5001	0	\N	0	0	\N	\N	0	217300	0	117015009	4024958		
117251	3614	4052083	1952-03-13	1952-03-13 00:00:00	1952-03-13	5001	0	\N	0	0	\N	\N	0	240146	0	23426006	4052083		
4141	409	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	27073	0	7258-7	3001488		
4245	419	40766240	1913-04-25	1913-04-25 00:00:00	1913-04-25	5001	0	\N	0	0	\N	\N	0	27783	0	63513-6	40766240		
8616	823	3011505	2015-01-12	2015-01-12 00:00:00	2015-01-12	5001	0	\N	0	0	\N	\N	0	54583	0	19926-5	3011505		
37834	3488	3011505	2007-02-23	2007-02-23 00:00:00	2007-02-23	5001	0	\N	0	0	\N	\N	0	231376	0	19926-5	3011505		
58992	1794	4024958	2000-08-16	2000-08-16 00:00:00	2000-08-16	5001	0	\N	0	0	\N	\N	0	120308	0	117015009	4024958		
31782	2902	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	193352	0	6844-5	3020655		
3194	304	3006322	2005-09-14	2005-09-14 00:00:00	2005-09-14	5001	0	\N	0	0	\N	\N	0	20254	0	8331-1	3006322		
14515	1355	46235214	1966-04-05	1966-04-05 00:00:00	1966-04-05	5001	0	\N	0	0	\N	\N	0	89836	0	76690-7	46235214		
14595	1356	3001247	1995-02-23	1995-02-23 00:00:00	1995-02-23	5001	0	\N	0	0	\N	\N	0	89888	0	6085-5	3001247		
14671	1361	3049273	1999-10-31	1999-10-31 00:00:00	1999-10-31	5001	0	\N	0	0	\N	\N	0	90292	0	38265-5	3049273		
60543	1847	4052083	1931-08-15	1931-08-15 00:00:00	1931-08-15	5001	0	\N	0	0	\N	\N	0	123573	0	23426006	4052083		
49963	1518	4024958	1956-10-05	1956-10-05 00:00:00	1956-10-05	5001	0	\N	0	0	\N	\N	0	101526	0	117015009	4024958		
37524	3462	3006322	1975-01-27	1975-01-27 00:00:00	1975-01-27	5001	0	\N	0	0	\N	\N	0	229682	0	8331-1	3006322		
37577	3464	3001488	2009-05-29	2009-05-29 00:00:00	2009-05-29	5001	0	\N	0	0	\N	\N	0	229905	0	7258-7	3001488		
29398	911	4024958	1984-04-10	1984-04-10 00:00:00	1984-04-10	5001	0	\N	0	0	\N	\N	0	60527	0	117015009	4024958		
28101	2586	3006322	1989-07-22	1989-07-22 00:00:00	1989-07-22	5001	0	\N	0	0	\N	\N	0	171197	0	8331-1	3006322		
46043	4246	46235214	1977-01-24	1977-01-24 00:00:00	1977-01-24	5001	0	\N	0	0	\N	\N	0	281920	0	76690-7	46235214		
39528	3658	3006322	1986-08-16	1986-08-16 00:00:00	1986-08-16	5001	0	\N	0	0	\N	\N	0	243480	0	8331-1	3006322		
71673	2192	4024958	1963-04-12	1963-04-12 00:00:00	1963-04-12	5001	0	\N	0	0	\N	\N	0	146195	0	117015009	4024958		
35950	3304	3006322	1998-11-27	1998-11-27 00:00:00	1998-11-27	5001	0	\N	0	0	\N	\N	0	219463	0	8331-1	3006322		
28779	2661	3006322	1966-08-21	1966-08-21 00:00:00	1966-08-21	5001	0	\N	0	0	\N	\N	0	176322	0	8331-1	3006322		
26836	2483	3009542	1952-03-02	1952-03-02 00:00:00	1952-03-02	5001	0	\N	0	0	\N	\N	0	164522	0	20570-8	3009542		
19429	1776	3020630	1984-10-13	1984-10-13 00:00:00	1984-10-13	5001	0	\N	0	0	\N	\N	0	118804	0	2885-2	3020630		
40247	3745	3011505	2009-08-26	2009-08-26 00:00:00	2009-08-26	5001	0	\N	0	0	\N	\N	0	248963	0	19926-5	3011505		
51600	4724	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	314797	0	6085-5	3001247		
51694	4735	3006322	1990-12-30	1990-12-30 00:00:00	1990-12-30	5001	0	\N	0	0	\N	\N	0	315442	0	8331-1	3006322		
27362	857	4133840	1992-09-20	1992-09-20 00:00:00	1992-09-20	5001	0	\N	0	0	\N	\N	0	56664	0	127783003	4133840		
42393	3916	3006322	1979-11-18	1979-11-18 00:00:00	1979-11-18	5001	0	\N	0	0	\N	\N	0	260279	0	8331-1	3006322		
50131	1524	4052083	1988-02-23	1988-02-23 00:00:00	1988-02-23	5001	0	\N	0	0	\N	\N	0	101953	0	23426006	4052083		
44240	1361	4024958	1980-10-06	1980-10-06 00:00:00	1980-10-06	5001	0	\N	0	0	\N	\N	0	90345	0	117015009	4024958		
145444	4462	4133840	2014-03-27	2014-03-27 00:00:00	2014-03-27	5001	0	\N	0	0	\N	\N	0	296924	0	127783003	4133840		
89924	2778	4024958	1994-05-06	1994-05-06 00:00:00	1994-05-06	5001	0	\N	0	0	\N	\N	0	184044	0	117015009	4024958		
169654	5206	4024958	1995-11-15	1995-11-15 00:00:00	1995-11-15	5001	0	\N	0	0	\N	\N	0	346271	0	117015009	4024958		
20367	640	4052083	1973-05-07	1973-05-07 00:00:00	1973-05-07	5001	0	\N	0	0	\N	\N	0	42342	0	23426006	4052083		
10342	332	4052083	1993-12-29	1993-12-29 00:00:00	1993-12-29	5001	0	\N	0	0	\N	\N	0	21921	0	23426006	4052083		
87522	2705	4052083	2011-11-24	2011-11-24 00:00:00	2011-11-24	5001	0	\N	0	0	\N	\N	0	179224	0	23426006	4052083		
67966	2082	4024958	1949-06-12	1949-06-12 00:00:00	1949-06-12	5001	0	\N	0	0	\N	\N	0	138706	0	117015009	4024958		
55854	5119	3006322	1964-11-26	1964-11-26 00:00:00	1964-11-26	5001	0	\N	0	0	\N	\N	0	340292	0	8331-1	3006322		
33227	1036	4052083	1998-03-20	1998-03-20 00:00:00	1998-03-20	5001	0	\N	0	0	\N	\N	0	68118	0	23426006	4052083		
33287	1036	4024958	1981-03-23	1981-03-23 00:00:00	1981-03-23	5001	0	\N	0	0	\N	\N	0	68096	0	117015009	4024958		
121773	3756	4133840	2008-05-24	2008-05-24 00:00:00	2008-05-24	5001	0	\N	0	0	\N	\N	0	249676	0	127783003	4133840		
20793	653	4024958	1959-02-01	1959-02-01 00:00:00	1959-02-01	5001	0	\N	0	0	\N	\N	0	43257	0	117015009	4024958		
150206	4607	4024958	1984-03-18	1984-03-18 00:00:00	1984-03-18	5001	0	\N	0	0	\N	\N	0	306894	0	117015009	4024958		
77562	2381	4024958	1938-08-08	1938-08-08 00:00:00	1938-08-08	5001	0	\N	0	0	\N	\N	0	158283	0	117015009	4024958		
57748	1762	4133840	2008-03-06	2008-03-06 00:00:00	2008-03-06	5001	0	\N	0	0	\N	\N	0	117858	0	127783003	4133840		
130456	4019	4052083	1974-01-29	1974-01-29 00:00:00	1974-01-29	5001	0	\N	0	0	\N	\N	0	267136	0	23426006	4052083		
48456	4442	3006322	1999-11-23	1999-11-23 00:00:00	1999-11-23	5001	0	\N	0	0	\N	\N	0	295287	0	8331-1	3006322		
90660	2798	4052083	1963-06-23	1963-06-23 00:00:00	1963-06-23	5001	0	\N	0	0	\N	\N	0	185444	0	23426006	4052083		
80614	2487	4024958	1966-03-16	1966-03-16 00:00:00	1966-03-16	5001	0	\N	0	0	\N	\N	0	164812	0	117015009	4024958		
9865	931	3006322	2006-04-19	2006-04-19 00:00:00	2006-04-19	5001	0	\N	0	0	\N	\N	0	61928	0	8331-1	3006322		
9940	949	3011505	1983-08-29	1983-08-29 00:00:00	1983-08-29	5001	0	\N	0	0	\N	\N	0	62997	0	19926-5	3011505		
22556	2070	3006322	2016-08-02	2016-08-02 00:00:00	2016-08-02	5001	0	\N	0	0	\N	\N	0	137733	0	8331-1	3006322		
50719	4626	3015076	1997-11-21	1997-11-21 00:00:00	1997-11-21	5001	0	\N	0	0	\N	\N	0	308259	0	6248-9	3015076		
4814	458	3000963	2012-08-03	2012-08-03 00:00:00	2012-08-03	5001	0	\N	0	0	\N	\N	0	30640	0	718-7	3000963		
16011	1464	3000963	1965-11-30	1965-11-30 00:00:00	1965-11-30	5001	0	\N	0	0	\N	\N	0	97538	0	718-7	3000963		
34167	3117	46235214	2001-10-23	2001-10-23 00:00:00	2001-10-23	5001	0	\N	0	0	\N	\N	0	207370	0	76690-7	46235214		
45566	4204	3006322	1980-11-21	1980-11-21 00:00:00	1980-11-21	5001	0	\N	0	0	\N	\N	0	279069	0	8331-1	3006322		
27292	2534	3023430	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	167387	0	6833-8	3023430		
72226	2213	4052083	1975-07-07	1975-07-07 00:00:00	1975-07-07	5001	0	\N	0	0	\N	\N	0	147359	0	23426006	4052083		
94697	2909	4133840	2002-06-16	2002-06-16 00:00:00	2002-06-16	5001	0	\N	0	0	\N	\N	0	193855	0	127783003	4133840		
23818	2189	3005136	2010-02-17	2010-02-17 00:00:00	2010-02-17	5001	0	\N	0	0	\N	\N	0	145893	0	6075-6	3005136		
37205	3430	3011505	2018-05-19	2018-05-19 00:00:00	2018-05-19	5001	0	\N	0	0	\N	\N	0	227330	0	19926-5	3011505		
95096	2919	4024958	2007-12-09	2007-12-09 00:00:00	2007-12-09	5001	0	\N	0	0	\N	\N	0	194578	0	117015009	4024958		
117252	3614	4133840	2009-12-13	2009-12-13 00:00:00	2009-12-13	5001	0	\N	0	0	\N	\N	0	240127	0	127783003	4133840		
4142	409	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	27073	0	6095-4	3036780		
4246	419	3006322	1941-06-17	1941-06-17 00:00:00	1941-06-17	5001	0	\N	0	0	\N	\N	0	27687	0	8331-1	3006322		
8617	823	3011505	2016-01-18	2016-01-18 00:00:00	2016-01-18	5001	0	\N	0	0	\N	\N	0	54527	0	19926-5	3011505		
37835	3488	3011505	2017-04-21	2017-04-21 00:00:00	2017-04-21	5001	0	\N	0	0	\N	\N	0	231401	0	19926-5	3011505		
58997	1794	4052083	1978-07-29	1978-07-29 00:00:00	1978-07-29	5001	0	\N	0	0	\N	\N	0	120302	0	23426006	4052083		
31783	2902	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	193352	0	6075-6	3005136		
3195	304	3006322	1966-03-29	1966-03-29 00:00:00	1966-03-29	5001	0	\N	0	0	\N	\N	0	20247	0	8331-1	3006322		
14516	1355	3051031	1966-04-05	1966-04-05 00:00:00	1966-04-05	5001	0	\N	0	0	\N	\N	0	89836	0	46240-8	3051031		
14596	1356	3015076	1995-02-23	1995-02-23 00:00:00	1995-02-23	5001	0	\N	0	0	\N	\N	0	89888	0	6248-9	3015076		
14673	1365	3006322	2013-04-06	2013-04-06 00:00:00	2013-04-06	5001	0	\N	0	0	\N	\N	0	90465	0	8331-1	3006322		
60548	1847	4024958	1922-11-24	1922-11-24 00:00:00	1922-11-24	5001	0	\N	0	0	\N	\N	0	123583	0	117015009	4024958		
80513	2483	4133840	1985-06-01	1985-06-01 00:00:00	1985-06-01	5001	0	\N	0	0	\N	\N	0	164532	0	127783003	4133840		
37525	3462	3006322	1990-06-15	1990-06-15 00:00:00	1990-06-15	5001	0	\N	0	0	\N	\N	0	229683	0	8331-1	3006322		
37578	3464	3006734	2009-05-29	2009-05-29 00:00:00	2009-05-29	5001	0	\N	0	0	\N	\N	0	229905	0	6189-5	3006734		
27998	2570	3049273	1946-09-23	1946-09-23 00:00:00	1946-09-23	5001	0	\N	0	0	\N	\N	0	170196	0	38265-5	3049273		
28102	2586	3006322	2004-07-28	2004-07-28 00:00:00	2004-07-28	5001	0	\N	0	0	\N	\N	0	171176	0	8331-1	3006322		
46044	4246	3006322	2002-04-03	2002-04-03 00:00:00	2002-04-03	5001	0	\N	0	0	\N	\N	0	281957	0	8331-1	3006322		
39529	3658	3006322	1968-09-25	1968-09-25 00:00:00	1968-09-25	5001	0	\N	0	0	\N	\N	0	243457	0	8331-1	3006322		
57517	5283	3006322	1999-03-20	1999-03-20 00:00:00	1999-03-20	5001	0	\N	0	0	\N	\N	0	351421	0	8331-1	3006322		
35951	3304	3006322	1989-03-05	1989-03-05 00:00:00	1989-03-05	5001	0	\N	0	0	\N	\N	0	219427	0	8331-1	3006322		
28780	2661	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	176331	0	6844-5	3020655		
26837	2483	3000963	1952-03-02	1952-03-02 00:00:00	1952-03-02	5001	0	\N	0	0	\N	\N	0	164522	0	718-7	3000963		
19430	1776	3015632	1984-10-13	1984-10-13 00:00:00	1984-10-13	5001	0	\N	0	0	\N	\N	0	118804	0	2028-9	3015632		
40248	3745	3011505	1994-06-01	1994-06-01 00:00:00	1994-06-01	5001	0	\N	0	0	\N	\N	0	248958	0	19926-5	3011505		
51601	4724	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	314797	0	6189-5	3006734		
51695	4735	3006322	1980-05-14	1980-05-14 00:00:00	1980-05-14	5001	0	\N	0	0	\N	\N	0	315413	0	8331-1	3006322		
27363	857	4052083	1967-04-14	1967-04-14 00:00:00	1967-04-14	5001	0	\N	0	0	\N	\N	0	56635	0	23426006	4052083		
42394	3916	3006322	1983-05-18	1983-05-18 00:00:00	1983-05-18	5001	0	\N	0	0	\N	\N	0	260256	0	8331-1	3006322		
50132	1524	4024958	2004-05-27	2004-05-27 00:00:00	2004-05-27	5001	0	\N	0	0	\N	\N	0	101934	0	117015009	4024958		
44242	1361	4024958	1955-09-06	1955-09-06 00:00:00	1955-09-06	5001	0	\N	0	0	\N	\N	0	90366	0	117015009	4024958		
145447	4462	4133840	2008-02-21	2008-02-21 00:00:00	2008-02-21	5001	0	\N	0	0	\N	\N	0	296880	0	127783003	4133840		
21211	1960	3049273	2007-01-26	2007-01-26 00:00:00	2007-01-26	5001	0	\N	0	0	\N	\N	0	130333	0	38265-5	3049273		
169657	5206	4024958	1983-10-28	1983-10-28 00:00:00	1983-10-28	5001	0	\N	0	0	\N	\N	0	346263	0	117015009	4024958		
20375	640	4052083	1974-01-11	1974-01-11 00:00:00	1974-01-11	5001	0	\N	0	0	\N	\N	0	42351	0	23426006	4052083		
10357	332	4052083	2019-03-30	2019-03-30 00:00:00	2019-03-30	5001	0	\N	0	0	\N	\N	0	21938	0	23426006	4052083		
87529	2705	4052083	1969-07-09	1969-07-09 00:00:00	1969-07-09	5001	0	\N	0	0	\N	\N	0	179221	0	23426006	4052083		
67997	2082	4024958	1944-05-27	1944-05-27 00:00:00	1944-05-27	5001	0	\N	0	0	\N	\N	0	138696	0	117015009	4024958		
55856	5121	3006322	2017-03-22	2017-03-22 00:00:00	2017-03-22	5001	0	\N	0	0	\N	\N	0	340512	0	8331-1	3006322		
44789	1378	4024958	1967-03-15	1967-03-15 00:00:00	1967-03-15	5001	0	\N	0	0	\N	\N	0	91294	0	117015009	4024958		
44881	1378	4133840	2013-10-29	2013-10-29 00:00:00	2013-10-29	5001	0	\N	0	0	\N	\N	0	91354	0	127783003	4133840		
121776	3756	4133840	2004-05-01	2004-05-01 00:00:00	2004-05-01	5001	0	\N	0	0	\N	\N	0	249706	0	127783003	4133840		
20796	653	4024958	1988-02-29	1988-02-29 00:00:00	1988-02-29	5001	0	\N	0	0	\N	\N	0	43223	0	117015009	4024958		
150214	4607	4024958	1976-10-12	1976-10-12 00:00:00	1976-10-12	5001	0	\N	0	0	\N	\N	0	306893	0	117015009	4024958		
77567	2381	4024958	1955-06-26	1955-06-26 00:00:00	1955-06-26	5001	0	\N	0	0	\N	\N	0	158316	0	117015009	4024958		
57752	1762	4133840	2000-04-20	2000-04-20 00:00:00	2000-04-20	5001	0	\N	0	0	\N	\N	0	117820	0	127783003	4133840		
130459	4019	4052083	2012-03-06	2012-03-06 00:00:00	2012-03-06	5001	0	\N	0	0	\N	\N	0	267141	0	23426006	4052083		
130482	4020	4052083	1965-02-23	1965-02-23 00:00:00	1965-02-23	5001	0	\N	0	0	\N	\N	0	267266	0	23426006	4052083		
90679	2799	4024958	1986-06-02	1986-06-02 00:00:00	1986-06-02	5001	0	\N	0	0	\N	\N	0	185504	0	117015009	4024958		
80622	2487	4052083	1980-11-17	1980-11-17 00:00:00	1980-11-17	5001	0	\N	0	0	\N	\N	0	164802	0	23426006	4052083		
9866	932	3006322	2003-05-29	2003-05-29 00:00:00	2003-05-29	5001	0	\N	0	0	\N	\N	0	62014	0	8331-1	3006322		
9941	949	3011505	1989-09-25	1989-09-25 00:00:00	1989-09-25	5001	0	\N	0	0	\N	\N	0	63043	0	19926-5	3011505		
22557	2070	3006322	1986-10-17	1986-10-17 00:00:00	1986-10-17	5001	0	\N	0	0	\N	\N	0	137751	0	8331-1	3006322		
50720	4626	3027231	1997-11-21	1997-11-21 00:00:00	1997-11-21	5001	0	\N	0	0	\N	\N	0	308259	0	6276-0	3027231		
4815	458	3009542	2012-08-03	2012-08-03 00:00:00	2012-08-03	5001	0	\N	0	0	\N	\N	0	30640	0	20570-8	3009542		
16012	1464	3009542	1965-11-30	1965-11-30 00:00:00	1965-11-30	5001	0	\N	0	0	\N	\N	0	97538	0	20570-8	3009542		
34169	3117	40766240	2001-10-23	2001-10-23 00:00:00	2001-10-23	5001	0	\N	0	0	\N	\N	0	207370	0	63513-6	40766240		
45567	4204	3006322	1987-06-12	1987-06-12 00:00:00	1987-06-12	5001	0	\N	0	0	\N	\N	0	279070	0	8331-1	3006322		
27293	2534	3015076	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	167387	0	6248-9	3015076		
72243	2213	4052083	1980-11-15	1980-11-15 00:00:00	1980-11-15	5001	0	\N	0	0	\N	\N	0	147355	0	23426006	4052083		
94699	2909	4133840	2001-06-10	2001-06-10 00:00:00	2001-06-10	5001	0	\N	0	0	\N	\N	0	193878	0	127783003	4133840		
23819	2189	3027231	2010-02-17	2010-02-17 00:00:00	2010-02-17	5001	0	\N	0	0	\N	\N	0	145893	0	6276-0	3027231		
37206	3430	3011505	2001-03-17	2001-03-17 00:00:00	2001-03-17	5001	0	\N	0	0	\N	\N	0	227371	0	19926-5	3011505		
95097	2919	4133840	2012-11-17	2012-11-17 00:00:00	2012-11-17	5001	0	\N	0	0	\N	\N	0	194636	0	127783003	4133840		
117254	3614	4133840	2008-11-16	2008-11-16 00:00:00	2008-11-16	5001	0	\N	0	0	\N	\N	0	240126	0	127783003	4133840		
4143	409	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	27073	0	6206-7	3012494		
4247	419	40766240	1912-09-27	1912-09-27 00:00:00	1912-09-27	5001	0	\N	0	0	\N	\N	0	27714	0	63513-6	40766240		
8618	823	3049273	2005-01-17	2005-01-17 00:00:00	2005-01-17	5001	0	\N	0	0	\N	\N	0	54579	0	38265-5	3049273		
37836	3488	3011505	2016-04-15	2016-04-15 00:00:00	2016-04-15	5001	0	\N	0	0	\N	\N	0	231379	0	19926-5	3011505		
59007	1794	4024958	1986-12-15	1986-12-15 00:00:00	1986-12-15	5001	0	\N	0	0	\N	\N	0	120307	0	117015009	4024958		
31784	2902	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	193352	0	6248-9	3015076		
3196	304	3006322	2009-11-04	2009-11-04 00:00:00	2009-11-04	5001	0	\N	0	0	\N	\N	0	20258	0	8331-1	3006322		
14519	1355	40766240	1966-04-05	1966-04-05 00:00:00	1966-04-05	5001	0	\N	0	0	\N	\N	0	89836	0	63513-6	40766240		
14597	1356	3001488	1995-02-23	1995-02-23 00:00:00	1995-02-23	5001	0	\N	0	0	\N	\N	0	89888	0	7258-7	3001488		
14674	1365	3006322	1988-10-19	1988-10-19 00:00:00	1988-10-19	5001	0	\N	0	0	\N	\N	0	90528	0	8331-1	3006322		
60558	1847	4024958	1960-09-10	1960-09-10 00:00:00	1960-09-10	5001	0	\N	0	0	\N	\N	0	123514	0	117015009	4024958		
80515	2483	4133840	1968-05-11	1968-05-11 00:00:00	1968-05-11	5001	0	\N	0	0	\N	\N	0	164504	0	127783003	4133840		
37526	3462	3006322	1961-11-18	1961-11-18 00:00:00	1961-11-18	5001	0	\N	0	0	\N	\N	0	229710	0	8331-1	3006322		
37579	3464	3036780	2009-05-29	2009-05-29 00:00:00	2009-05-29	5001	0	\N	0	0	\N	\N	0	229905	0	6095-4	3036780		
27999	2570	3006322	1947-12-29	1947-12-29 00:00:00	1947-12-29	5001	0	\N	0	0	\N	\N	0	170165	0	8331-1	3006322		
28103	2586	3006322	1973-11-18	1973-11-18 00:00:00	1973-11-18	5001	0	\N	0	0	\N	\N	0	171162	0	8331-1	3006322		
46045	4246	3006322	2002-08-17	2002-08-17 00:00:00	2002-08-17	5001	0	\N	0	0	\N	\N	0	281952	0	8331-1	3006322		
39530	3658	3006322	1969-05-07	1969-05-07 00:00:00	1969-05-07	5001	0	\N	0	0	\N	\N	0	243496	0	8331-1	3006322		
57518	5283	3006322	1981-02-22	1981-02-22 00:00:00	1981-02-22	5001	0	\N	0	0	\N	\N	0	351411	0	8331-1	3006322		
35959	3307	3006322	1991-11-06	1991-11-06 00:00:00	1991-11-06	5001	0	\N	0	0	\N	\N	0	219558	0	8331-1	3006322		
28781	2661	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	176331	0	6082-2	3000876		
26838	2483	3011505	1974-05-18	1974-05-18 00:00:00	1974-05-18	5001	0	\N	0	0	\N	\N	0	164506	0	19926-5	3011505		
19431	1776	3007461	1984-10-13	1984-10-13 00:00:00	1984-10-13	5001	0	\N	0	0	\N	\N	0	118804	0	26515-7	3007461		
40249	3745	3011505	2004-07-28	2004-07-28 00:00:00	2004-07-28	5001	0	\N	0	0	\N	\N	0	248893	0	19926-5	3011505		
51602	4724	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	314797	0	6106-9	3014599		
51696	4736	3006322	1973-01-15	1973-01-15 00:00:00	1973-01-15	5001	0	\N	0	0	\N	\N	0	315481	0	8331-1	3006322		
27365	857	4133840	1990-03-11	1990-03-11 00:00:00	1990-03-11	5001	0	\N	0	0	\N	\N	0	56584	0	127783003	4133840		
42395	3916	3006322	1979-09-03	1979-09-03 00:00:00	1979-09-03	5001	0	\N	0	0	\N	\N	0	260251	0	8331-1	3006322		
50139	1524	4024958	1969-01-04	1969-01-04 00:00:00	1969-01-04	5001	0	\N	0	0	\N	\N	0	101915	0	117015009	4024958		
145349	4460	4052083	2006-08-24	2006-08-24 00:00:00	2006-08-24	5001	0	\N	0	0	\N	\N	0	296827	0	23426006	4052083		
145449	4462	4133840	1997-03-27	1997-03-27 00:00:00	1997-03-27	5001	0	\N	0	0	\N	\N	0	296906	0	127783003	4133840		
21212	1960	3006322	1987-10-15	1987-10-15 00:00:00	1987-10-15	5001	0	\N	0	0	\N	\N	0	130375	0	8331-1	3006322		
169675	5207	4024958	1990-03-07	1990-03-07 00:00:00	1990-03-07	5001	0	\N	0	0	\N	\N	0	346315	0	117015009	4024958		
7588	726	3006322	1978-06-24	1978-06-24 00:00:00	1978-06-24	5001	0	\N	0	0	\N	\N	0	48060	0	8331-1	3006322		
21934	689	4052083	2010-03-27	2010-03-27 00:00:00	2010-03-27	5001	0	\N	0	0	\N	\N	0	45694	0	23426006	4052083		
98820	3026	4052083	1971-01-22	1971-01-22 00:00:00	1971-01-22	5001	0	\N	0	0	\N	\N	0	201759	0	23426006	4052083		
68146	2087	4024958	1922-08-21	1922-08-21 00:00:00	1922-08-21	5001	0	\N	0	0	\N	\N	0	139037	0	117015009	4024958		
55857	5121	3006322	1965-09-13	1965-09-13 00:00:00	1965-09-13	5001	0	\N	0	0	\N	\N	0	340472	0	8331-1	3006322		
44802	1378	4133840	2006-09-19	2006-09-19 00:00:00	2006-09-19	5001	0	\N	0	0	\N	\N	0	91343	0	127783003	4133840		
44884	1378	4133840	2005-03-22	2005-03-22 00:00:00	2005-03-22	5001	0	\N	0	0	\N	\N	0	91342	0	127783003	4133840		
121789	3757	4024958	1968-07-13	1968-07-13 00:00:00	1968-07-13	5001	0	\N	0	0	\N	\N	0	249768	0	117015009	4024958		
20798	653	4024958	1960-07-07	1960-07-07 00:00:00	1960-07-07	5001	0	\N	0	0	\N	\N	0	43251	0	117015009	4024958		
150217	4607	4024958	2011-12-04	2011-12-04 00:00:00	2011-12-04	5001	0	\N	0	0	\N	\N	0	306922	0	117015009	4024958		
77568	2381	4024958	1953-10-23	1953-10-23 00:00:00	1953-10-23	5001	0	\N	0	0	\N	\N	0	158315	0	117015009	4024958		
57757	1762	4133840	1996-03-28	1996-03-28 00:00:00	1996-03-28	5001	0	\N	0	0	\N	\N	0	117825	0	127783003	4133840		
130461	4020	4024958	1979-04-04	1979-04-04 00:00:00	1979-04-04	5001	0	\N	0	0	\N	\N	0	267219	0	117015009	4024958		
130485	4020	4024958	1979-07-15	1979-07-15 00:00:00	1979-07-15	5001	0	\N	0	0	\N	\N	0	267197	0	117015009	4024958		
125234	3865	4052083	1977-07-10	1977-07-10 00:00:00	1977-07-10	5001	0	\N	0	0	\N	\N	0	256579	0	23426006	4052083		
80626	2487	4052083	1965-06-24	1965-06-24 00:00:00	1965-06-24	5001	0	\N	0	0	\N	\N	0	164788	0	23426006	4052083		
9869	935	3006322	1991-10-12	1991-10-12 00:00:00	1991-10-12	5001	0	\N	0	0	\N	\N	0	62167	0	8331-1	3006322		
9942	949	3011505	2007-10-29	2007-10-29 00:00:00	2007-10-29	5001	0	\N	0	0	\N	\N	0	63040	0	19926-5	3011505		
22558	2070	3027231	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	137655	0	6276-0	3027231		
50721	4626	3020655	1997-11-21	1997-11-21 00:00:00	1997-11-21	5001	0	\N	0	0	\N	\N	0	308259	0	6844-5	3020655		
4816	459	3006322	1995-06-15	1995-06-15 00:00:00	1995-06-15	5001	0	\N	0	0	\N	\N	0	30676	0	8331-1	3006322		
16013	1464	3006322	2002-06-01	2002-06-01 00:00:00	2002-06-01	5001	0	\N	0	0	\N	\N	0	97550	0	8331-1	3006322		
34170	3117	3051031	2001-10-23	2001-10-23 00:00:00	2001-10-23	5001	0	\N	0	0	\N	\N	0	207370	0	46240-8	3051031		
45568	4204	3006322	1967-12-19	1967-12-19 00:00:00	1967-12-19	5001	0	\N	0	0	\N	\N	0	279074	0	8331-1	3006322		
27294	2534	3005136	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	167387	0	6075-6	3005136		
72244	2213	4052083	2003-04-05	2003-04-05 00:00:00	2003-04-05	5001	0	\N	0	0	\N	\N	0	147390	0	23426006	4052083		
94704	2909	4133840	2003-06-22	2003-06-22 00:00:00	2003-06-22	5001	0	\N	0	0	\N	\N	0	193879	0	127783003	4133840		
23820	2189	3014599	2010-02-17	2010-02-17 00:00:00	2010-02-17	5001	0	\N	0	0	\N	\N	0	145893	0	6106-9	3014599		
37207	3430	3011505	2005-03-26	2005-03-26 00:00:00	2005-03-26	5001	0	\N	0	0	\N	\N	0	227340	0	19926-5	3011505		
95099	2919	4133840	2007-10-06	2007-10-06 00:00:00	2007-10-06	5001	0	\N	0	0	\N	\N	0	194619	0	127783003	4133840		
117257	3614	4133840	2006-11-05	2006-11-05 00:00:00	2006-11-05	5001	0	\N	0	0	\N	\N	0	240125	0	127783003	4133840		
4144	409	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	27073	0	6106-9	3014599		
4248	419	40758406	1912-09-27	1912-09-27 00:00:00	1912-09-27	5001	0	\N	0	0	\N	\N	0	27714	0	55277-8	40758406		
8619	823	3011505	2017-01-23	2017-01-23 00:00:00	2017-01-23	5001	0	\N	0	0	\N	\N	0	54584	0	19926-5	3011505		
37837	3488	3006322	1993-03-19	1993-03-19 00:00:00	1993-03-19	5001	0	\N	0	0	\N	\N	0	231383	0	8331-1	3006322		
59041	1796	4024958	1980-04-30	1980-04-30 00:00:00	1980-04-30	5001	0	\N	0	0	\N	\N	0	120379	0	117015009	4024958		
31785	2902	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	193352	0	6106-9	3014599		
3197	304	3006322	1960-11-16	1960-11-16 00:00:00	1960-11-16	5001	0	\N	0	0	\N	\N	0	20245	0	8331-1	3006322		
14520	1355	40758406	1966-04-05	1966-04-05 00:00:00	1966-04-05	5001	0	\N	0	0	\N	\N	0	89836	0	55277-8	40758406		
14598	1356	3006322	1988-01-06	1988-01-06 00:00:00	1988-01-06	5001	0	\N	0	0	\N	\N	0	89886	0	8331-1	3006322		
14675	1365	3006322	1965-11-10	1965-11-10 00:00:00	1965-11-10	5001	0	\N	0	0	\N	\N	0	90415	0	8331-1	3006322		
60563	1847	4052083	1949-05-10	1949-05-10 00:00:00	1949-05-10	5001	0	\N	0	0	\N	\N	0	123575	0	23426006	4052083		
80517	2483	4133840	1980-05-24	1980-05-24 00:00:00	1980-05-24	5001	0	\N	0	0	\N	\N	0	164508	0	127783003	4133840		
37527	3462	3006322	1980-11-09	1980-11-09 00:00:00	1980-11-09	5001	0	\N	0	0	\N	\N	0	229712	0	8331-1	3006322		
37580	3464	3001247	2009-05-29	2009-05-29 00:00:00	2009-05-29	5001	0	\N	0	0	\N	\N	0	229905	0	6085-5	3001247		
28000	2570	3006322	1957-05-19	1957-05-19 00:00:00	1957-05-19	5001	0	\N	0	0	\N	\N	0	170266	0	8331-1	3006322		
39391	3644	3006322	1970-02-13	1970-02-13 00:00:00	1970-02-13	5001	0	\N	0	0	\N	\N	0	242493	0	8331-1	3006322		
46046	4246	46235214	1977-08-22	1977-08-22 00:00:00	1977-08-22	5001	0	\N	0	0	\N	\N	0	281969	0	76690-7	46235214		
39533	3660	3006322	1976-11-30	1976-11-30 00:00:00	1976-11-30	5001	0	\N	0	0	\N	\N	0	243583	0	8331-1	3006322		
57519	5283	3006322	2009-04-09	2009-04-09 00:00:00	2009-04-09	5001	0	\N	0	0	\N	\N	0	351459	0	8331-1	3006322		
35960	3307	3006322	1968-08-25	1968-08-25 00:00:00	1968-08-25	5001	0	\N	0	0	\N	\N	0	219579	0	8331-1	3006322		
28782	2661	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	176331	0	6248-9	3015076		
26839	2483	3011505	1980-05-24	1980-05-24 00:00:00	1980-05-24	5001	0	\N	0	0	\N	\N	0	164508	0	19926-5	3011505		
19432	1776	3024731	1984-10-13	1984-10-13 00:00:00	1984-10-13	5001	0	\N	0	0	\N	\N	0	118804	0	30428-7	3024731		
40250	3745	3011505	1992-05-20	1992-05-20 00:00:00	1992-05-20	5001	0	\N	0	0	\N	\N	0	248870	0	19926-5	3011505		
51603	4724	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	314797	0	6158-0	3019406		
51697	4736	46235214	1973-11-14	1973-11-14 00:00:00	1973-11-14	5001	0	\N	0	0	\N	\N	0	315512	0	76690-7	46235214		
27367	857	4133840	2000-03-05	2000-03-05 00:00:00	2000-03-05	5001	0	\N	0	0	\N	\N	0	56586	0	127783003	4133840		
42396	3916	3001247	1995-04-12	1995-04-12 00:00:00	1995-04-12	5001	0	\N	0	0	\N	\N	0	260286	0	6085-5	3001247		
50140	1524	4024958	1997-06-27	1997-06-27 00:00:00	1997-06-27	5001	0	\N	0	0	\N	\N	0	101919	0	117015009	4024958		
145394	4462	4133840	2001-04-05	2001-04-05 00:00:00	2001-04-05	5001	0	\N	0	0	\N	\N	0	296878	0	127783003	4133840		
145493	4465	4024958	2009-01-31	2009-01-31 00:00:00	2009-01-31	5001	0	\N	0	0	\N	\N	0	297087	0	117015009	4024958		
21216	1962	3006322	1992-04-13	1992-04-13 00:00:00	1992-04-13	5001	0	\N	0	0	\N	\N	0	130490	0	8331-1	3006322		
169679	5207	4052083	1967-01-15	1967-01-15 00:00:00	1967-01-15	5001	0	\N	0	0	\N	\N	0	346335	0	23426006	4052083		
7589	727	3049273	1974-03-23	1974-03-23 00:00:00	1974-03-23	5001	0	\N	0	0	\N	\N	0	48207	0	38265-5	3049273		
21935	689	4024958	1991-02-18	1991-02-18 00:00:00	1991-02-18	5001	0	\N	0	0	\N	\N	0	45610	0	117015009	4024958		
98825	3026	4052083	1955-03-25	1955-03-25 00:00:00	1955-03-25	5001	0	\N	0	0	\N	\N	0	201803	0	23426006	4052083		
68150	2087	4024958	1927-02-11	1927-02-11 00:00:00	1927-02-11	5001	0	\N	0	0	\N	\N	0	139012	0	117015009	4024958		
55858	5121	3006322	2012-03-10	2012-03-10 00:00:00	2012-03-10	5001	0	\N	0	0	\N	\N	0	340511	0	8331-1	3006322		
44808	1378	4133840	2006-03-28	2006-03-28 00:00:00	2006-03-28	5001	0	\N	0	0	\N	\N	0	91428	0	127783003	4133840		
44889	1378	4052083	1950-12-18	1950-12-18 00:00:00	1950-12-18	5001	0	\N	0	0	\N	\N	0	91362	0	23426006	4052083		
121791	3757	4024958	1952-09-26	1952-09-26 00:00:00	1952-09-26	5001	0	\N	0	0	\N	\N	0	249725	0	117015009	4024958		
147170	4513	4024958	1994-05-14	1994-05-14 00:00:00	1994-05-14	5001	0	\N	0	0	\N	\N	0	300546	0	117015009	4024958		
150224	4607	4052083	1998-01-04	1998-01-04 00:00:00	1998-01-04	5001	0	\N	0	0	\N	\N	0	306896	0	23426006	4052083		
52733	1599	4024958	1987-02-26	1987-02-26 00:00:00	1987-02-26	5001	0	\N	0	0	\N	\N	0	107293	0	117015009	4024958		
57760	1762	4133840	2010-03-18	2010-03-18 00:00:00	2010-03-18	5001	0	\N	0	0	\N	\N	0	117810	0	127783003	4133840		
130463	4020	4024958	1991-03-08	1991-03-08 00:00:00	1991-03-08	5001	0	\N	0	0	\N	\N	0	267256	0	117015009	4024958		
130491	4020	4024958	1975-10-06	1975-10-06 00:00:00	1975-10-06	5001	0	\N	0	0	\N	\N	0	267196	0	117015009	4024958		
125240	3865	4052083	2009-08-06	2009-08-06 00:00:00	2009-08-06	5001	0	\N	0	0	\N	\N	0	256677	0	23426006	4052083		
80635	2487	4024958	1963-08-19	1963-08-19 00:00:00	1963-08-19	5001	0	\N	0	0	\N	\N	0	164787	0	117015009	4024958		
9870	935	3006322	1946-02-19	1946-02-19 00:00:00	1946-02-19	5001	0	\N	0	0	\N	\N	0	62217	0	8331-1	3006322		
9943	949	3011505	2013-12-02	2013-12-02 00:00:00	2013-12-02	5001	0	\N	0	0	\N	\N	0	63017	0	19926-5	3011505		
22559	2070	3005136	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	137655	0	6075-6	3005136		
50722	4626	3019406	1997-11-21	1997-11-21 00:00:00	1997-11-21	5001	0	\N	0	0	\N	\N	0	308259	0	6158-0	3019406		
4817	459	3006322	1998-08-25	1998-08-25 00:00:00	1998-08-25	5001	0	\N	0	0	\N	\N	0	30706	0	8331-1	3006322		
16014	1464	3006322	1998-03-08	1998-03-08 00:00:00	1998-03-08	5001	0	\N	0	0	\N	\N	0	97549	0	8331-1	3006322		
34172	3117	3051031	2002-01-21	2002-01-21 00:00:00	2002-01-21	5001	0	\N	0	0	\N	\N	0	207371	0	46240-8	3051031		
45569	4204	3006322	1962-10-29	1962-10-29 00:00:00	1962-10-29	5001	0	\N	0	0	\N	\N	0	279113	0	8331-1	3006322		
27295	2534	3012494	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	167387	0	6206-7	3012494		
72250	2213	4024958	1987-03-19	1987-03-19 00:00:00	1987-03-19	5001	0	\N	0	0	\N	\N	0	147377	0	117015009	4024958		
94705	2909	4133840	2000-06-04	2000-06-04 00:00:00	2000-06-04	5001	0	\N	0	0	\N	\N	0	193854	0	127783003	4133840		
23821	2189	3023430	2010-02-17	2010-02-17 00:00:00	2010-02-17	5001	0	\N	0	0	\N	\N	0	145893	0	6833-8	3023430		
37208	3430	3011505	2012-04-14	2012-04-14 00:00:00	2012-04-14	5001	0	\N	0	0	\N	\N	0	227376	0	19926-5	3011505		
95104	2919	4133840	2006-09-30	2006-09-30 00:00:00	2006-09-30	5001	0	\N	0	0	\N	\N	0	194624	0	127783003	4133840		
117259	3614	4133840	2009-12-06	2009-12-06 00:00:00	2009-12-06	5001	0	\N	0	0	\N	\N	0	240068	0	127783003	4133840		
4145	409	3006322	2006-12-14	2006-12-14 00:00:00	2006-12-14	5001	0	\N	0	0	\N	\N	0	27011	0	8331-1	3006322		
4249	419	46235214	1912-09-27	1912-09-27 00:00:00	1912-09-27	5001	0	\N	0	0	\N	\N	0	27714	0	76690-7	46235214		
8620	823	3006322	1969-02-14	1969-02-14 00:00:00	1969-02-14	5001	0	\N	0	0	\N	\N	0	54530	0	8331-1	3006322		
37838	3490	3006322	1950-04-22	1950-04-22 00:00:00	1950-04-22	5001	0	\N	0	0	\N	\N	0	231493	0	8331-1	3006322		
59046	1796	4024958	1987-01-18	1987-01-18 00:00:00	1987-01-18	5001	0	\N	0	0	\N	\N	0	120400	0	117015009	4024958		
31786	2902	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	193352	0	6158-0	3019406		
3198	304	3006322	2018-12-27	2018-12-27 00:00:00	2018-12-27	5001	0	\N	0	0	\N	\N	0	20204	0	8331-1	3006322		
14521	1355	3006322	1987-09-08	1987-09-08 00:00:00	1987-09-08	5001	0	\N	0	0	\N	\N	0	89779	0	8331-1	3006322		
14599	1356	3000876	1998-08-27	1998-08-27 00:00:00	1998-08-27	5001	0	\N	0	0	\N	\N	0	89944	0	6082-2	3000876		
14676	1365	3006322	2007-11-22	2007-11-22 00:00:00	2007-11-22	5001	0	\N	0	0	\N	\N	0	90507	0	8331-1	3006322		
60565	1847	4024958	1923-11-03	1923-11-03 00:00:00	1923-11-03	5001	0	\N	0	0	\N	\N	0	123584	0	117015009	4024958		
80521	2483	4133840	1971-05-15	1971-05-15 00:00:00	1971-05-15	5001	0	\N	0	0	\N	\N	0	164505	0	127783003	4133840		
39565	1228	4052083	1989-03-06	1989-03-06 00:00:00	1989-03-06	5001	0	\N	0	0	\N	\N	0	80918	0	23426006	4052083		
37581	3464	3021226	2009-05-29	2009-05-29 00:00:00	2009-05-29	5001	0	\N	0	0	\N	\N	0	229905	0	6246-3	3021226		
28001	2570	3006322	1945-04-05	1945-04-05 00:00:00	1945-04-05	5001	0	\N	0	0	\N	\N	0	170163	0	8331-1	3006322		
39392	3644	3006322	1978-02-13	1978-02-13 00:00:00	1978-02-13	5001	0	\N	0	0	\N	\N	0	242482	0	8331-1	3006322		
46047	4246	3051031	1977-08-22	1977-08-22 00:00:00	1977-08-22	5001	0	\N	0	0	\N	\N	0	281969	0	46240-8	3051031		
39534	3660	3006322	1978-02-04	1978-02-04 00:00:00	1978-02-04	5001	0	\N	0	0	\N	\N	0	243584	0	8331-1	3006322		
57520	5283	3006322	1996-08-17	1996-08-17 00:00:00	1996-08-17	5001	0	\N	0	0	\N	\N	0	351420	0	8331-1	3006322		
35961	3307	3006322	1967-07-16	1967-07-16 00:00:00	1967-07-16	5001	0	\N	0	0	\N	\N	0	219550	0	8331-1	3006322		
28783	2661	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	176331	0	6276-0	3027231		
26840	2483	3011505	1966-05-07	1966-05-07 00:00:00	1966-05-07	5001	0	\N	0	0	\N	\N	0	164490	0	19926-5	3011505		
19433	1776	3010813	1984-10-13	1984-10-13 00:00:00	1984-10-13	5001	0	\N	0	0	\N	\N	0	118804	0	26464-8	3010813		
40251	3745	3011505	2008-08-20	2008-08-20 00:00:00	2008-08-20	5001	0	\N	0	0	\N	\N	0	248968	0	19926-5	3011505		
51604	4724	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	314797	0	6095-4	3036780		
51698	4736	3051031	1973-11-14	1973-11-14 00:00:00	1973-11-14	5001	0	\N	0	0	\N	\N	0	315512	0	46240-8	3051031		
27370	857	4133840	2009-04-12	2009-04-12 00:00:00	2009-04-12	5001	0	\N	0	0	\N	\N	0	56641	0	127783003	4133840		
42397	3916	3006734	1995-04-12	1995-04-12 00:00:00	1995-04-12	5001	0	\N	0	0	\N	\N	0	260286	0	6189-5	3006734		
107643	3320	4024958	2012-10-01	2012-10-01 00:00:00	2012-10-01	5001	0	\N	0	0	\N	\N	0	220446	0	117015009	4024958		
145396	4462	4133840	2012-03-15	2012-03-15 00:00:00	2012-03-15	5001	0	\N	0	0	\N	\N	0	296923	0	127783003	4133840		
50296	1528	4024958	1964-09-12	1964-09-12 00:00:00	1964-09-12	5001	0	\N	0	0	\N	\N	0	102261	0	117015009	4024958		
21217	1962	3006322	1972-08-05	1972-08-05 00:00:00	1972-08-05	5001	0	\N	0	0	\N	\N	0	130456	0	8331-1	3006322		
7519	720	3006322	1992-06-18	1992-06-18 00:00:00	1992-06-18	5001	0	\N	0	0	\N	\N	0	47617	0	8331-1	3006322		
7590	727	3006322	1916-11-11	1916-11-11 00:00:00	1916-11-11	5001	0	\N	0	0	\N	\N	0	48238	0	8331-1	3006322		
21956	691	4052083	2008-01-25	2008-01-25 00:00:00	2008-01-25	5001	0	\N	0	0	\N	\N	0	45778	0	23426006	4052083		
98841	3026	4024958	2018-08-26	2018-08-26 00:00:00	2018-08-26	5001	0	\N	0	0	\N	\N	0	201793	0	117015009	4024958		
68157	2087	4052083	1955-09-07	1955-09-07 00:00:00	1955-09-07	5001	0	\N	0	0	\N	\N	0	139029	0	23426006	4052083		
55859	5121	3006322	1981-10-29	1981-10-29 00:00:00	1981-10-29	5001	0	\N	0	0	\N	\N	0	340474	0	8331-1	3006322		
44810	1378	4133840	2011-10-18	2011-10-18 00:00:00	2011-10-18	5001	0	\N	0	0	\N	\N	0	91353	0	127783003	4133840		
44892	1378	4052083	1968-01-10	1968-01-10 00:00:00	1968-01-10	5001	0	\N	0	0	\N	\N	0	91433	0	23426006	4052083		
121792	3757	4052083	1959-05-11	1959-05-11 00:00:00	1959-05-11	5001	0	\N	0	0	\N	\N	0	249767	0	23426006	4052083		
147184	4513	4052083	1986-12-14	1986-12-14 00:00:00	1986-12-14	5001	0	\N	0	0	\N	\N	0	300583	0	23426006	4052083		
66152	2028	4024958	1971-10-19	1971-10-19 00:00:00	1971-10-19	5001	0	\N	0	0	\N	\N	0	134991	0	117015009	4024958		
52737	1599	4052083	1972-11-19	1972-11-19 00:00:00	1972-11-19	5001	0	\N	0	0	\N	\N	0	107291	0	23426006	4052083		
57764	1762	4133840	2002-01-31	2002-01-31 00:00:00	2002-01-31	5001	0	\N	0	0	\N	\N	0	117821	0	127783003	4133840		
98630	3020	4133840	2017-03-01	2017-03-01 00:00:00	2017-03-01	5001	0	\N	0	0	\N	\N	0	201378	0	127783003	4133840		
98678	3022	4024958	1990-05-20	1990-05-20 00:00:00	1990-05-20	5001	0	\N	0	0	\N	\N	0	201444	0	117015009	4024958		
125285	3866	4052083	1984-04-12	1984-04-12 00:00:00	1984-04-12	5001	0	\N	0	0	\N	\N	0	256732	0	23426006	4052083		
69452	2130	4052083	1994-05-13	1994-05-13 00:00:00	1994-05-13	5001	0	\N	0	0	\N	\N	0	141729	0	23426006	4052083		
9872	935	3006322	1954-07-15	1954-07-15 00:00:00	1954-07-15	5001	0	\N	0	0	\N	\N	0	62218	0	8331-1	3006322		
9944	949	3011505	2016-12-19	2016-12-19 00:00:00	2016-12-19	5001	0	\N	0	0	\N	\N	0	63002	0	19926-5	3011505		
22560	2070	3015076	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	137655	0	6248-9	3015076		
50723	4626	3023430	1997-11-21	1997-11-21 00:00:00	1997-11-21	5001	0	\N	0	0	\N	\N	0	308259	0	6833-8	3023430		
4818	459	3006322	1998-07-16	1998-07-16 00:00:00	1998-07-16	5001	0	\N	0	0	\N	\N	0	30680	0	8331-1	3006322		
16015	1464	3006322	1965-01-08	1965-01-08 00:00:00	1965-01-08	5001	0	\N	0	0	\N	\N	0	97547	0	8331-1	3006322		
34174	3117	40758406	2002-01-21	2002-01-21 00:00:00	2002-01-21	5001	0	\N	0	0	\N	\N	0	207371	0	55277-8	40758406		
45570	4204	3006322	1999-05-02	1999-05-02 00:00:00	1999-05-02	5001	0	\N	0	0	\N	\N	0	279121	0	8331-1	3006322		
27296	2534	3006734	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	167387	0	6189-5	3006734		
24889	2283	3006322	1978-10-22	1978-10-22 00:00:00	1978-10-22	5001	0	\N	0	0	\N	\N	0	151913	0	8331-1	3006322		
94708	2909	4133840	1992-04-26	1992-04-26 00:00:00	1992-04-26	5001	0	\N	0	0	\N	\N	0	193920	0	127783003	4133840		
19861	1821	3006322	1959-10-13	1959-10-13 00:00:00	1959-10-13	5001	0	\N	0	0	\N	\N	0	121817	0	8331-1	3006322		
37209	3430	3011505	2009-04-04	2009-04-04 00:00:00	2009-04-04	5001	0	\N	0	0	\N	\N	0	227372	0	19926-5	3011505		
95124	2921	4133840	2004-09-07	2004-09-07 00:00:00	2004-09-07	5001	0	\N	0	0	\N	\N	0	194748	0	127783003	4133840		
106286	3272	4024958	1982-11-17	1982-11-17 00:00:00	1982-11-17	5001	0	\N	0	0	\N	\N	0	217440	0	117015009	4024958		
4146	409	3006322	2015-06-11	2015-06-11 00:00:00	2015-06-11	5001	0	\N	0	0	\N	\N	0	27013	0	8331-1	3006322		
4250	419	3051031	1912-09-27	1912-09-27 00:00:00	1912-09-27	5001	0	\N	0	0	\N	\N	0	27714	0	46240-8	3051031		
8621	823	3011505	2009-02-09	2009-02-09 00:00:00	2009-02-09	5001	0	\N	0	0	\N	\N	0	54598	0	19926-5	3011505		
37839	3490	3006322	1987-11-16	1987-11-16 00:00:00	1987-11-16	5001	0	\N	0	0	\N	\N	0	231594	0	8331-1	3006322		
59047	1796	4024958	2014-11-01	2014-11-01 00:00:00	2014-11-01	5001	0	\N	0	0	\N	\N	0	120401	0	117015009	4024958		
31787	2902	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	193352	0	6273-7	3006451		
3200	307	3006322	2005-05-08	2005-05-08 00:00:00	2005-05-08	5001	0	\N	0	0	\N	\N	0	20378	0	8331-1	3006322		
14522	1355	3051031	1965-12-06	1965-12-06 00:00:00	1965-12-06	5001	0	\N	0	0	\N	\N	0	89777	0	46240-8	3051031		
14600	1356	3001488	1998-08-27	1998-08-27 00:00:00	1998-08-27	5001	0	\N	0	0	\N	\N	0	89944	0	7258-7	3001488		
25989	2387	3006322	1990-12-30	1990-12-30 00:00:00	1990-12-30	5001	0	\N	0	0	\N	\N	0	158739	0	8331-1	3006322		
60569	1847	4024958	1926-09-03	1926-09-03 00:00:00	1926-09-03	5001	0	\N	0	0	\N	\N	0	123585	0	117015009	4024958		
80523	2483	4133840	1974-05-18	1974-05-18 00:00:00	1974-05-18	5001	0	\N	0	0	\N	\N	0	164506	0	127783003	4133840		
39566	1228	4052083	1984-10-13	1984-10-13 00:00:00	1984-10-13	5001	0	\N	0	0	\N	\N	0	80874	0	23426006	4052083		
37582	3464	3023430	2009-05-29	2009-05-29 00:00:00	2009-05-29	5001	0	\N	0	0	\N	\N	0	229905	0	6833-8	3023430		
28002	2570	3006322	1991-12-29	1991-12-29 00:00:00	1991-12-29	5001	0	\N	0	0	\N	\N	0	170180	0	8331-1	3006322		
39393	3644	3006322	1947-11-21	1947-11-21 00:00:00	1947-11-21	5001	0	\N	0	0	\N	\N	0	242471	0	8331-1	3006322		
46050	4246	40766240	1977-08-22	1977-08-22 00:00:00	1977-08-22	5001	0	\N	0	0	\N	\N	0	281969	0	63513-6	40766240		
39535	3660	3006322	1988-01-27	1988-01-27 00:00:00	1988-01-27	5001	0	\N	0	0	\N	\N	0	243563	0	8331-1	3006322		
57521	5284	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	351596	0	6082-2	3000876		
35962	3307	3006322	1995-05-03	1995-05-03 00:00:00	1995-05-03	5001	0	\N	0	0	\N	\N	0	219616	0	8331-1	3006322		
28784	2661	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	176331	0	6095-4	3036780		
38165	3518	3006322	1987-05-16	1987-05-16 00:00:00	1987-05-16	5001	0	\N	0	0	\N	\N	0	233556	0	8331-1	3006322		
19434	1776	3004501	1984-10-13	1984-10-13 00:00:00	1984-10-13	5001	0	\N	0	0	\N	\N	0	118804	0	2345-7	3004501		
40252	3745	3011505	2015-09-30	2015-09-30 00:00:00	2015-09-30	5001	0	\N	0	0	\N	\N	0	248895	0	19926-5	3011505		
51605	4724	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	314797	0	6206-7	3012494		
51700	4736	40758406	1973-11-14	1973-11-14 00:00:00	1973-11-14	5001	0	\N	0	0	\N	\N	0	315512	0	55277-8	40758406		
27371	857	4133840	2004-03-14	2004-03-14 00:00:00	2004-03-14	5001	0	\N	0	0	\N	\N	0	56624	0	127783003	4133840		
42398	3916	3023430	1995-04-12	1995-04-12 00:00:00	1995-04-12	5001	0	\N	0	0	\N	\N	0	260286	0	6833-8	3023430		
107653	3320	4052083	2015-06-30	2015-06-30 00:00:00	2015-06-30	5001	0	\N	0	0	\N	\N	0	220447	0	23426006	4052083		
145399	4462	4133840	2013-03-21	2013-03-21 00:00:00	2013-03-21	5001	0	\N	0	0	\N	\N	0	296873	0	127783003	4133840		
44258	1361	4024958	1979-04-01	1979-04-01 00:00:00	1979-04-01	5001	0	\N	0	0	\N	\N	0	90367	0	117015009	4024958		
21218	1962	3006322	1985-02-10	1985-02-10 00:00:00	1985-02-10	5001	0	\N	0	0	\N	\N	0	130489	0	8331-1	3006322		
7520	720	3006322	2005-07-08	2005-07-08 00:00:00	2005-07-08	5001	0	\N	0	0	\N	\N	0	47669	0	8331-1	3006322		
7595	727	3049273	1991-04-23	1991-04-23 00:00:00	1991-04-23	5001	0	\N	0	0	\N	\N	0	48209	0	38265-5	3049273		
21959	691	4024958	1999-05-24	1999-05-24 00:00:00	1999-05-24	5001	0	\N	0	0	\N	\N	0	45777	0	117015009	4024958		
98845	3026	4024958	1992-02-19	1992-02-19 00:00:00	1992-02-19	5001	0	\N	0	0	\N	\N	0	201767	0	117015009	4024958		
68164	2087	4024958	1959-10-19	1959-10-19 00:00:00	1959-10-19	5001	0	\N	0	0	\N	\N	0	139044	0	117015009	4024958		
55860	5121	3006322	2006-10-29	2006-10-29 00:00:00	2006-10-29	5001	0	\N	0	0	\N	\N	0	340475	0	8331-1	3006322		
44812	1378	4133840	2014-11-04	2014-11-04 00:00:00	2014-11-04	5001	0	\N	0	0	\N	\N	0	91444	0	127783003	4133840		
44894	1378	4133840	2015-11-10	2015-11-10 00:00:00	2015-11-10	5001	0	\N	0	0	\N	\N	0	91355	0	127783003	4133840		
121810	3757	4052083	2009-08-19	2009-08-19 00:00:00	2009-08-19	5001	0	\N	0	0	\N	\N	0	249717	0	23426006	4052083		
147188	4513	4024958	2014-07-07	2014-07-07 00:00:00	2014-07-07	5001	0	\N	0	0	\N	\N	0	300566	0	117015009	4024958		
66172	2028	4052083	1959-03-29	1959-03-29 00:00:00	1959-03-29	5001	0	\N	0	0	\N	\N	0	135006	0	23426006	4052083		
52751	1599	4024958	1991-12-18	1991-12-18 00:00:00	1991-12-18	5001	0	\N	0	0	\N	\N	0	107330	0	117015009	4024958		
57769	1762	4133840	1997-04-03	1997-04-03 00:00:00	1997-04-03	5001	0	\N	0	0	\N	\N	0	117845	0	127783003	4133840		
98631	3020	4133840	2009-01-14	2009-01-14 00:00:00	2009-01-14	5001	0	\N	0	0	\N	\N	0	201432	0	127783003	4133840		
98717	3023	4052083	2017-06-26	2017-06-26 00:00:00	2017-06-26	5001	0	\N	0	0	\N	\N	0	201520	0	23426006	4052083		
125295	3866	4052083	2009-12-03	2009-12-03 00:00:00	2009-12-03	5001	0	\N	0	0	\N	\N	0	256736	0	23426006	4052083		
80761	2495	4052083	1990-09-28	1990-09-28 00:00:00	1990-09-28	5001	0	\N	0	0	\N	\N	0	165151	0	23426006	4052083		
9873	936	3006322	1992-03-16	1992-03-16 00:00:00	1992-03-16	5001	0	\N	0	0	\N	\N	0	62265	0	8331-1	3006322		
9945	949	3011505	2000-04-03	2000-04-03 00:00:00	2000-04-03	5001	0	\N	0	0	\N	\N	0	63034	0	19926-5	3011505		
22561	2070	3014599	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	137655	0	6106-9	3014599		
50724	4626	3001247	1997-11-21	1997-11-21 00:00:00	1997-11-21	5001	0	\N	0	0	\N	\N	0	308259	0	6085-5	3001247		
4819	459	3006322	1995-05-03	1995-05-03 00:00:00	1995-05-03	5001	0	\N	0	0	\N	\N	0	30679	0	8331-1	3006322		
16016	1464	3006322	1972-08-23	1972-08-23 00:00:00	1972-08-23	5001	0	\N	0	0	\N	\N	0	97511	0	8331-1	3006322		
34175	3117	46235214	2002-01-21	2002-01-21 00:00:00	2002-01-21	5001	0	\N	0	0	\N	\N	0	207371	0	76690-7	46235214		
45571	4204	3006322	1995-10-06	1995-10-06 00:00:00	1995-10-06	5001	0	\N	0	0	\N	\N	0	279072	0	8331-1	3006322		
27297	2534	3006322	2008-08-16	2008-08-16 00:00:00	2008-08-16	5001	0	\N	0	0	\N	\N	0	167389	0	8331-1	3006322		
24890	2283	3006322	1940-01-07	1940-01-07 00:00:00	1940-01-07	5001	0	\N	0	0	\N	\N	0	151873	0	8331-1	3006322		
83604	2583	4024958	1978-02-28	1978-02-28 00:00:00	1978-02-28	5001	0	\N	0	0	\N	\N	0	171025	0	117015009	4024958		
19862	1821	3006322	1966-05-03	1966-05-03 00:00:00	1966-05-03	5001	0	\N	0	0	\N	\N	0	121832	0	8331-1	3006322		
37210	3430	3011505	2013-04-20	2013-04-20 00:00:00	2013-04-20	5001	0	\N	0	0	\N	\N	0	227337	0	19926-5	3011505		
95125	2921	4133840	1996-07-23	1996-07-23 00:00:00	1996-07-23	5001	0	\N	0	0	\N	\N	0	194702	0	127783003	4133840		
106295	3272	4052083	1988-01-07	1988-01-07 00:00:00	1988-01-07	5001	0	\N	0	0	\N	\N	0	217441	0	23426006	4052083		
4147	409	3006322	1968-12-03	1968-12-03 00:00:00	1968-12-03	5001	0	\N	0	0	\N	\N	0	27071	0	8331-1	3006322		
4253	419	40758406	1913-06-24	1913-06-24 00:00:00	1913-06-24	5001	0	\N	0	0	\N	\N	0	27716	0	55277-8	40758406		
8622	823	3006322	2011-01-13	2011-01-13 00:00:00	2011-01-13	5001	0	\N	0	0	\N	\N	0	54589	0	8331-1	3006322		
37840	3490	3049273	2005-11-11	2005-11-11 00:00:00	2005-11-11	5001	0	\N	0	0	\N	\N	0	231570	0	38265-5	3049273		
59049	1796	4024958	1986-11-07	1986-11-07 00:00:00	1986-11-07	5001	0	\N	0	0	\N	\N	0	120409	0	117015009	4024958		
31788	2902	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	193352	0	6276-0	3027231		
3201	307	3006322	2007-03-13	2007-03-13 00:00:00	2007-03-13	5001	0	\N	0	0	\N	\N	0	20335	0	8331-1	3006322		
14523	1355	46235214	1965-12-06	1965-12-06 00:00:00	1965-12-06	5001	0	\N	0	0	\N	\N	0	89777	0	76690-7	46235214		
14601	1356	3001247	1998-08-27	1998-08-27 00:00:00	1998-08-27	5001	0	\N	0	0	\N	\N	0	89944	0	6085-5	3001247		
25990	2389	3006322	2013-12-03	2013-12-03 00:00:00	2013-12-03	5001	0	\N	0	0	\N	\N	0	158876	0	8331-1	3006322		
60574	1847	4024958	1922-02-18	1922-02-18 00:00:00	1922-02-18	5001	0	\N	0	0	\N	\N	0	123582	0	117015009	4024958		
91863	2832	4024958	1989-11-17	1989-11-17 00:00:00	1989-11-17	5001	0	\N	0	0	\N	\N	0	187944	0	117015009	4024958		
39578	1229	4052083	2005-07-29	2005-07-29 00:00:00	2005-07-29	5001	0	\N	0	0	\N	\N	0	80958	0	23426006	4052083		
37583	3464	3020655	2009-05-29	2009-05-29 00:00:00	2009-05-29	5001	0	\N	0	0	\N	\N	0	229905	0	6844-5	3020655		
28009	2572	3006322	1979-08-05	1979-08-05 00:00:00	1979-08-05	5001	0	\N	0	0	\N	\N	0	170388	0	8331-1	3006322		
39394	3644	3006322	1959-06-02	1959-06-02 00:00:00	1959-06-02	5001	0	\N	0	0	\N	\N	0	242473	0	8331-1	3006322		
46051	4246	40758406	1977-08-22	1977-08-22 00:00:00	1977-08-22	5001	0	\N	0	0	\N	\N	0	281969	0	55277-8	40758406		
39536	3660	3006322	2010-07-16	2010-07-16 00:00:00	2010-07-16	5001	0	\N	0	0	\N	\N	0	243560	0	8331-1	3006322		
57522	5284	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	351596	0	6206-7	3012494		
35963	3308	3006322	1949-05-04	1949-05-04 00:00:00	1949-05-04	5001	0	\N	0	0	\N	\N	0	219662	0	8331-1	3006322		
28785	2661	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	176331	0	6158-0	3019406		
38166	3518	3006322	1963-02-05	1963-02-05 00:00:00	1963-02-05	5001	0	\N	0	0	\N	\N	0	233551	0	8331-1	3006322		
19435	1776	3019550	1984-10-13	1984-10-13 00:00:00	1984-10-13	5001	0	\N	0	0	\N	\N	0	118804	0	2951-2	3019550		
40253	3745	3006322	1955-12-29	1955-12-29 00:00:00	1955-12-29	5001	0	\N	0	0	\N	\N	0	248912	0	8331-1	3006322		
51606	4724	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	314797	0	6075-6	3005136		
51701	4736	40766240	1973-11-14	1973-11-14 00:00:00	1973-11-14	5001	0	\N	0	0	\N	\N	0	315512	0	63513-6	40766240		
27372	857	4133840	2003-03-09	2003-03-09 00:00:00	2003-03-09	5001	0	\N	0	0	\N	\N	0	56587	0	127783003	4133840		
42399	3916	3006451	1995-04-12	1995-04-12 00:00:00	1995-04-12	5001	0	\N	0	0	\N	\N	0	260286	0	6273-7	3006451		
107655	3320	4052083	1970-02-13	1970-02-13 00:00:00	1970-02-13	5001	0	\N	0	0	\N	\N	0	220443	0	23426006	4052083		
145401	4462	4133840	2005-02-03	2005-02-03 00:00:00	2005-02-03	5001	0	\N	0	0	\N	\N	0	296922	0	127783003	4133840		
44260	1361	4024958	1951-11-01	1951-11-01 00:00:00	1951-11-01	5001	0	\N	0	0	\N	\N	0	90369	0	117015009	4024958		
21219	1962	3006322	1968-06-13	1968-06-13 00:00:00	1968-06-13	5001	0	\N	0	0	\N	\N	0	130508	0	8331-1	3006322		
7521	720	3006322	2001-09-13	2001-09-13 00:00:00	2001-09-13	5001	0	\N	0	0	\N	\N	0	47618	0	8331-1	3006322		
7596	727	3049273	1993-04-23	1993-04-23 00:00:00	1993-04-23	5001	0	\N	0	0	\N	\N	0	48159	0	38265-5	3049273		
56491	1724	4024958	1984-05-07	1984-05-07 00:00:00	1984-05-07	5001	0	\N	0	0	\N	\N	0	115299	0	117015009	4024958		
716	17	4024958	1958-11-30	1958-11-30 00:00:00	1958-11-30	5001	0	\N	0	0	\N	\N	0	1285	0	117015009	4024958		
68175	2087	4052083	2009-10-13	2009-10-13 00:00:00	2009-10-13	5001	0	\N	0	0	\N	\N	0	139033	0	23426006	4052083		
124246	3836	4024958	1981-06-15	1981-06-15 00:00:00	1981-06-15	5001	0	\N	0	0	\N	\N	0	254736	0	117015009	4024958		
44817	1378	4133840	2007-09-25	2007-09-25 00:00:00	2007-09-25	5001	0	\N	0	0	\N	\N	0	91429	0	127783003	4133840		
44895	1379	4133840	2019-04-27	2019-04-27 00:00:00	2019-04-27	5001	0	\N	0	0	\N	\N	0	91525	0	127783003	4133840		
121811	3757	4024958	1947-01-15	1947-01-15 00:00:00	1947-01-15	5001	0	\N	0	0	\N	\N	0	249732	0	117015009	4024958		
7713	245	4024958	1987-10-18	1987-10-18 00:00:00	1987-10-18	5001	0	\N	0	0	\N	\N	0	16427	0	117015009	4024958		
66183	2028	4052083	1980-01-18	1980-01-18 00:00:00	1980-01-18	5001	0	\N	0	0	\N	\N	0	134993	0	23426006	4052083		
52752	1599	4052083	1962-09-28	1962-09-28 00:00:00	1962-09-28	5001	0	\N	0	0	\N	\N	0	107321	0	23426006	4052083		
57770	1762	4133840	1986-02-13	1986-02-13 00:00:00	1986-02-13	5001	0	\N	0	0	\N	\N	0	117818	0	127783003	4133840		
98633	3020	4024958	1959-03-27	1959-03-27 00:00:00	1959-03-27	5001	0	\N	0	0	\N	\N	0	201364	0	117015009	4024958		
25850	2373	3006322	1957-06-14	1957-06-14 00:00:00	1957-06-14	5001	0	\N	0	0	\N	\N	0	157953	0	8331-1	3006322		
125296	3866	4024958	1973-07-12	1973-07-12 00:00:00	1973-07-12	5001	0	\N	0	0	\N	\N	0	256685	0	117015009	4024958		
80762	2495	4052083	1985-05-08	1985-05-08 00:00:00	1985-05-08	5001	0	\N	0	0	\N	\N	0	165123	0	23426006	4052083		
9874	938	3006322	1980-04-15	1980-04-15 00:00:00	1980-04-15	5001	0	\N	0	0	\N	\N	0	62349	0	8331-1	3006322		
9946	949	3011505	2019-05-20	2019-05-20 00:00:00	2019-05-20	5001	0	\N	0	0	\N	\N	0	63020	0	19926-5	3011505		
22562	2070	3012494	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	137655	0	6206-7	3012494		
50725	4626	3036780	1997-11-21	1997-11-21 00:00:00	1997-11-21	5001	0	\N	0	0	\N	\N	0	308259	0	6095-4	3036780		
4820	459	3006322	1985-11-11	1985-11-11 00:00:00	1985-11-11	5001	0	\N	0	0	\N	\N	0	30678	0	8331-1	3006322		
16017	1464	3006322	1975-11-21	1975-11-21 00:00:00	1975-11-21	5001	0	\N	0	0	\N	\N	0	97512	0	8331-1	3006322		
34177	3117	40766240	2002-01-21	2002-01-21 00:00:00	2002-01-21	5001	0	\N	0	0	\N	\N	0	207371	0	63513-6	40766240		
45572	4204	3006322	1955-12-20	1955-12-20 00:00:00	1955-12-20	5001	0	\N	0	0	\N	\N	0	279068	0	8331-1	3006322		
27298	2534	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	167435	0	6158-0	3019406		
24891	2283	3006322	1998-12-24	1998-12-24 00:00:00	1998-12-24	5001	0	\N	0	0	\N	\N	0	151914	0	8331-1	3006322		
83614	2583	4024958	1980-09-29	1980-09-29 00:00:00	1980-09-29	5001	0	\N	0	0	\N	\N	0	171024	0	117015009	4024958		
19863	1821	3006322	1972-12-22	1972-12-22 00:00:00	1972-12-22	5001	0	\N	0	0	\N	\N	0	121853	0	8331-1	3006322		
37211	3430	3011505	1998-03-14	1998-03-14 00:00:00	1998-03-14	5001	0	\N	0	0	\N	\N	0	227370	0	19926-5	3011505		
95127	2921	4133840	1999-08-10	1999-08-10 00:00:00	1999-08-10	5001	0	\N	0	0	\N	\N	0	194742	0	127783003	4133840		
3224	97	4133840	1997-08-11	1997-08-11 00:00:00	1997-08-11	5001	0	\N	0	0	\N	\N	0	6636	0	127783003	4133840		
4148	410	3006322	2001-11-01	2001-11-01 00:00:00	2001-11-01	5001	0	\N	0	0	\N	\N	0	27174	0	8331-1	3006322		
4254	419	46235214	1913-06-24	1913-06-24 00:00:00	1913-06-24	5001	0	\N	0	0	\N	\N	0	27716	0	76690-7	46235214		
8623	823	3011505	2009-12-14	2009-12-14 00:00:00	2009-12-14	5001	0	\N	0	0	\N	\N	0	54599	0	19926-5	3011505		
37841	3490	3006322	1975-05-09	1975-05-09 00:00:00	1975-05-09	5001	0	\N	0	0	\N	\N	0	231501	0	8331-1	3006322		
20055	1843	3019406	1982-09-26	1982-09-26 00:00:00	1982-09-26	5001	0	\N	0	0	\N	\N	0	123101	0	6158-0	3019406		
31789	2902	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	193352	0	6246-3	3021226		
3202	307	3006322	1969-09-20	1969-09-20 00:00:00	1969-09-20	5001	0	\N	0	0	\N	\N	0	20367	0	8331-1	3006322		
14526	1355	40766240	1965-12-06	1965-12-06 00:00:00	1965-12-06	5001	0	\N	0	0	\N	\N	0	89777	0	63513-6	40766240		
14602	1356	3020655	1998-08-27	1998-08-27 00:00:00	1998-08-27	5001	0	\N	0	0	\N	\N	0	89944	0	6844-5	3020655		
25991	2389	3006322	1979-06-10	1979-06-10 00:00:00	1979-06-10	5001	0	\N	0	0	\N	\N	0	158834	0	8331-1	3006322		
60583	1848	4024958	1973-10-30	1973-10-30 00:00:00	1973-10-30	5001	0	\N	0	0	\N	\N	0	123683	0	117015009	4024958		
30407	2782	3006322	1983-03-26	1983-03-26 00:00:00	1983-03-26	5001	0	\N	0	0	\N	\N	0	184346	0	8331-1	3006322		
39586	1229	4052083	2001-04-17	2001-04-17 00:00:00	2001-04-17	5001	0	\N	0	0	\N	\N	0	80982	0	23426006	4052083		
37584	3464	3005136	2009-05-29	2009-05-29 00:00:00	2009-05-29	5001	0	\N	0	0	\N	\N	0	229905	0	6075-6	3005136		
28010	2572	3006322	1996-04-17	1996-04-17 00:00:00	1996-04-17	5001	0	\N	0	0	\N	\N	0	170376	0	8331-1	3006322		
39413	3647	3006322	1946-08-22	1946-08-22 00:00:00	1946-08-22	5001	0	\N	0	0	\N	\N	0	242619	0	8331-1	3006322		
46052	4246	3006322	1967-05-01	1967-05-01 00:00:00	1967-05-01	5001	0	\N	0	0	\N	\N	0	281984	0	8331-1	3006322		
39537	3661	3006322	1986-07-04	1986-07-04 00:00:00	1986-07-04	5001	0	\N	0	0	\N	\N	0	243673	0	8331-1	3006322		
57523	5284	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	351596	0	7258-7	3001488		
35964	3308	3006322	1950-08-14	1950-08-14 00:00:00	1950-08-14	5001	0	\N	0	0	\N	\N	0	219657	0	8331-1	3006322		
28786	2661	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	176331	0	6085-5	3001247		
38167	3518	3006322	1982-10-05	1982-10-05 00:00:00	1982-10-05	5001	0	\N	0	0	\N	\N	0	233555	0	8331-1	3006322		
19436	1776	3000963	1984-10-13	1984-10-13 00:00:00	1984-10-13	5001	0	\N	0	0	\N	\N	0	118804	0	718-7	3000963		
40254	3745	3011505	2018-10-17	2018-10-17 00:00:00	2018-10-17	5001	0	\N	0	0	\N	\N	0	248976	0	19926-5	3011505		
51607	4724	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	314797	0	7258-7	3001488		
51703	4736	3006322	2016-10-22	2016-10-22 00:00:00	2016-10-22	5001	0	\N	0	0	\N	\N	0	315486	0	8331-1	3006322		
27374	857	4133840	2006-03-26	2006-03-26 00:00:00	2006-03-26	5001	0	\N	0	0	\N	\N	0	56625	0	127783003	4133840		
42400	3916	3021226	1995-04-12	1995-04-12 00:00:00	1995-04-12	5001	0	\N	0	0	\N	\N	0	260286	0	6246-3	3021226		
107658	3320	4052083	1967-03-09	1967-03-09 00:00:00	1967-03-09	5001	0	\N	0	0	\N	\N	0	220436	0	23426006	4052083		
145403	4462	4133840	2010-03-04	2010-03-04 00:00:00	2010-03-04	5001	0	\N	0	0	\N	\N	0	296881	0	127783003	4133840		
44277	1361	4052083	2008-08-28	2008-08-28 00:00:00	2008-08-28	5001	0	\N	0	0	\N	\N	0	90374	0	23426006	4052083		
21220	1962	3006322	2015-08-20	2015-08-20 00:00:00	2015-08-20	5001	0	\N	0	0	\N	\N	0	130514	0	8331-1	3006322		
7522	720	3006322	1986-11-05	1986-11-05 00:00:00	1986-11-05	5001	0	\N	0	0	\N	\N	0	47631	0	8331-1	3006322		
7597	727	3049273	1988-08-06	1988-08-06 00:00:00	1988-08-06	5001	0	\N	0	0	\N	\N	0	48208	0	38265-5	3049273		
56500	1724	4024958	2016-07-23	2016-07-23 00:00:00	2016-07-23	5001	0	\N	0	0	\N	\N	0	115244	0	117015009	4024958		
11998	384	4052083	1966-04-30	1966-04-30 00:00:00	1966-04-30	5001	0	\N	0	0	\N	\N	0	25336	0	23426006	4052083		
28695	887	4052083	2007-06-12	2007-06-12 00:00:00	2007-06-12	5001	0	\N	0	0	\N	\N	0	59144	0	23426006	4052083		
124248	3836	4052083	2007-10-22	2007-10-22 00:00:00	2007-10-22	5001	0	\N	0	0	\N	\N	0	254709	0	23426006	4052083		
44822	1378	4133840	1999-07-20	1999-07-20 00:00:00	1999-07-20	5001	0	\N	0	0	\N	\N	0	91349	0	127783003	4133840		
44899	1379	4133840	2016-04-09	2016-04-09 00:00:00	2016-04-09	5001	0	\N	0	0	\N	\N	0	91508	0	127783003	4133840		
19054	601	4024958	1984-08-09	1984-08-09 00:00:00	1984-08-09	5001	0	\N	0	0	\N	\N	0	39656	0	117015009	4024958		
7726	246	4133840	2003-04-10	2003-04-10 00:00:00	2003-04-10	5001	0	\N	0	0	\N	\N	0	16542	0	127783003	4133840		
66193	2028	4052083	1967-04-02	1967-04-02 00:00:00	1967-04-02	5001	0	\N	0	0	\N	\N	0	134990	0	23426006	4052083		
52755	1600	4024958	1967-08-04	1967-08-04 00:00:00	1967-08-04	5001	0	\N	0	0	\N	\N	0	107409	0	117015009	4024958		
57772	1762	4133840	2003-02-06	2003-02-06 00:00:00	2003-02-06	5001	0	\N	0	0	\N	\N	0	117828	0	127783003	4133840		
98635	3020	4133840	2014-02-12	2014-02-12 00:00:00	2014-02-12	5001	0	\N	0	0	\N	\N	0	201387	0	127783003	4133840		
25851	2373	3006322	1988-07-17	1988-07-17 00:00:00	1988-07-17	5001	0	\N	0	0	\N	\N	0	157899	0	8331-1	3006322		
125299	3866	4052083	2003-04-28	2003-04-28 00:00:00	2003-04-28	5001	0	\N	0	0	\N	\N	0	256762	0	23426006	4052083		
80776	2495	4052083	2013-12-20	2013-12-20 00:00:00	2013-12-20	5001	0	\N	0	0	\N	\N	0	165133	0	23426006	4052083		
9875	938	3006322	1957-11-01	1957-11-01 00:00:00	1957-11-01	5001	0	\N	0	0	\N	\N	0	62315	0	8331-1	3006322		
9947	949	3011505	2012-11-26	2012-11-26 00:00:00	2012-11-26	5001	0	\N	0	0	\N	\N	0	63000	0	19926-5	3011505		
22563	2070	3019406	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	137655	0	6158-0	3019406		
50726	4626	3001488	1997-11-21	1997-11-21 00:00:00	1997-11-21	5001	0	\N	0	0	\N	\N	0	308259	0	7258-7	3001488		
4824	461	3006322	1969-06-28	1969-06-28 00:00:00	1969-06-28	5001	0	\N	0	0	\N	\N	0	30829	0	8331-1	3006322		
16018	1464	3006322	1968-05-03	1968-05-03 00:00:00	1968-05-03	5001	0	\N	0	0	\N	\N	0	97533	0	8331-1	3006322		
34178	3117	3006322	1979-01-04	1979-01-04 00:00:00	1979-01-04	5001	0	\N	0	0	\N	\N	0	207332	0	8331-1	3006322		
45573	4204	3006322	1983-05-21	1983-05-21 00:00:00	1983-05-21	5001	0	\N	0	0	\N	\N	0	279114	0	8331-1	3006322		
27299	2534	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	167435	0	6082-2	3000876		
24892	2283	3006322	1948-07-17	1948-07-17 00:00:00	1948-07-17	5001	0	\N	0	0	\N	\N	0	151847	0	8331-1	3006322		
83648	2586	4052083	1983-12-11	1983-12-11 00:00:00	1983-12-11	5001	0	\N	0	0	\N	\N	0	171144	0	23426006	4052083		
19864	1821	3006322	1983-02-12	1983-02-12 00:00:00	1983-02-12	5001	0	\N	0	0	\N	\N	0	121814	0	8331-1	3006322		
37212	3430	3011505	2011-04-09	2011-04-09 00:00:00	2011-04-09	5001	0	\N	0	0	\N	\N	0	227336	0	19926-5	3011505		
95130	2921	4133840	2003-09-02	2003-09-02 00:00:00	2003-09-02	5001	0	\N	0	0	\N	\N	0	194760	0	127783003	4133840		
3225	97	4133840	2005-06-13	2005-06-13 00:00:00	2005-06-13	5001	0	\N	0	0	\N	\N	0	6638	0	127783003	4133840		
4149	410	3006322	1972-10-15	1972-10-15 00:00:00	1972-10-15	5001	0	\N	0	0	\N	\N	0	27189	0	8331-1	3006322		
4255	419	3051031	1913-06-24	1913-06-24 00:00:00	1913-06-24	5001	0	\N	0	0	\N	\N	0	27716	0	46240-8	3051031		
8624	825	3009542	1970-09-12	1970-09-12 00:00:00	1970-09-12	5001	0	\N	0	0	\N	\N	0	54664	0	20570-8	3009542		
37842	3490	3006322	1969-08-24	1969-08-24 00:00:00	1969-08-24	5001	0	\N	0	0	\N	\N	0	231489	0	8331-1	3006322		
20056	1843	3020655	1982-09-26	1982-09-26 00:00:00	1982-09-26	5001	0	\N	0	0	\N	\N	0	123101	0	6844-5	3020655		
31790	2902	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	193352	0	6085-5	3001247		
3203	307	3006322	1981-02-02	1981-02-02 00:00:00	1981-02-02	5001	0	\N	0	0	\N	\N	0	20333	0	8331-1	3006322		
14527	1355	40758406	1965-12-06	1965-12-06 00:00:00	1965-12-06	5001	0	\N	0	0	\N	\N	0	89777	0	55277-8	40758406		
14603	1356	3015076	1998-08-27	1998-08-27 00:00:00	1998-08-27	5001	0	\N	0	0	\N	\N	0	89944	0	6248-9	3015076		
25992	2389	3006322	2007-10-25	2007-10-25 00:00:00	2007-10-25	5001	0	\N	0	0	\N	\N	0	158847	0	8331-1	3006322		
28821	2666	3006322	1952-05-13	1952-05-13 00:00:00	1952-05-13	5001	0	\N	0	0	\N	\N	0	176621	0	8331-1	3006322		
30408	2782	3006322	1995-04-01	1995-04-01 00:00:00	1995-04-01	5001	0	\N	0	0	\N	\N	0	184349	0	8331-1	3006322		
91635	2827	4024958	1926-10-16	1926-10-16 00:00:00	1926-10-16	5001	0	\N	0	0	\N	\N	0	187516	0	117015009	4024958		
37585	3464	3000876	2009-05-29	2009-05-29 00:00:00	2009-05-29	5001	0	\N	0	0	\N	\N	0	229905	0	6082-2	3000876		
28011	2572	3006322	2014-05-28	2014-05-28 00:00:00	2014-05-28	5001	0	\N	0	0	\N	\N	0	170364	0	8331-1	3006322		
39414	3647	3006322	1979-05-27	1979-05-27 00:00:00	1979-05-27	5001	0	\N	0	0	\N	\N	0	242622	0	8331-1	3006322		
46053	4246	3051031	1978-01-19	1978-01-19 00:00:00	1978-01-19	5001	0	\N	0	0	\N	\N	0	281940	0	46240-8	3051031		
39538	3661	3006322	1992-08-09	1992-08-09 00:00:00	1992-08-09	5001	0	\N	0	0	\N	\N	0	243620	0	8331-1	3006322		
57524	5284	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	351596	0	6085-5	3001247		
35965	3308	3006322	1960-11-14	1960-11-14 00:00:00	1960-11-14	5001	0	\N	0	0	\N	\N	0	219664	0	8331-1	3006322		
28787	2661	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	176331	0	6246-3	3021226		
38168	3518	3006322	1983-02-12	1983-02-12 00:00:00	1983-02-12	5001	0	\N	0	0	\N	\N	0	233593	0	8331-1	3006322		
19437	1776	3045716	1984-10-13	1984-10-13 00:00:00	1984-10-13	5001	0	\N	0	0	\N	\N	0	118804	0	33037-3	3045716		
40255	3745	3011505	2001-07-11	2001-07-11 00:00:00	2001-07-11	5001	0	\N	0	0	\N	\N	0	248871	0	19926-5	3011505		
51608	4724	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	314797	0	6833-8	3023430		
51704	4736	3006322	1998-08-12	1998-08-12 00:00:00	1998-08-12	5001	0	\N	0	0	\N	\N	0	315502	0	8331-1	3006322		
27378	857	4133840	2008-04-06	2008-04-06 00:00:00	2008-04-06	5001	0	\N	0	0	\N	\N	0	56626	0	127783003	4133840		
42401	3916	3005136	1995-04-12	1995-04-12 00:00:00	1995-04-12	5001	0	\N	0	0	\N	\N	0	260286	0	6075-6	3005136		
107659	3320	4052083	2000-12-10	2000-12-10 00:00:00	2000-12-10	5001	0	\N	0	0	\N	\N	0	220486	0	23426006	4052083		
145406	4462	4133840	2011-03-10	2011-03-10 00:00:00	2011-03-10	5001	0	\N	0	0	\N	\N	0	296909	0	127783003	4133840		
44312	1365	4024958	1965-11-10	1965-11-10 00:00:00	1965-11-10	5001	0	\N	0	0	\N	\N	0	90415	0	117015009	4024958		
21221	1962	3006322	2014-07-11	2014-07-11 00:00:00	2014-07-11	5001	0	\N	0	0	\N	\N	0	130512	0	8331-1	3006322		
7523	720	3006322	2019-05-21	2019-05-21 00:00:00	2019-05-21	5001	0	\N	0	0	\N	\N	0	47620	0	8331-1	3006322		
7598	727	3006322	1920-02-06	1920-02-06 00:00:00	1920-02-06	5001	0	\N	0	0	\N	\N	0	48175	0	8331-1	3006322		
56513	1724	4052083	1975-02-20	1975-02-20 00:00:00	1975-02-20	5001	0	\N	0	0	\N	\N	0	115298	0	23426006	4052083		
12004	384	4024958	1965-10-03	1965-10-03 00:00:00	1965-10-03	5001	0	\N	0	0	\N	\N	0	25291	0	117015009	4024958		
28700	887	4024958	2019-06-24	2019-06-24 00:00:00	2019-06-24	5001	0	\N	0	0	\N	\N	0	59145	0	117015009	4024958		
124249	3836	4024958	2015-03-18	2015-03-18 00:00:00	2015-03-18	5001	0	\N	0	0	\N	\N	0	254738	0	117015009	4024958		
44826	1378	4133840	2017-07-25	2017-07-25 00:00:00	2017-07-25	5001	0	\N	0	0	\N	\N	0	91345	0	127783003	4133840		
44900	1379	4133840	2005-02-19	2005-02-19 00:00:00	2005-02-19	5001	0	\N	0	0	\N	\N	0	91450	0	127783003	4133840		
19062	601	4024958	2007-06-21	2007-06-21 00:00:00	2007-06-21	5001	0	\N	0	0	\N	\N	0	39742	0	117015009	4024958		
7731	246	4133840	2010-04-29	2010-04-29 00:00:00	2010-04-29	5001	0	\N	0	0	\N	\N	0	16514	0	127783003	4133840		
27711	864	4052083	1925-11-10	1925-11-10 00:00:00	1925-11-10	5001	0	\N	0	0	\N	\N	0	57293	0	23426006	4052083		
52761	1600	4052083	2008-08-06	2008-08-06 00:00:00	2008-08-06	5001	0	\N	0	0	\N	\N	0	107371	0	23426006	4052083		
57777	1762	4133840	1994-03-17	1994-03-17 00:00:00	1994-03-17	5001	0	\N	0	0	\N	\N	0	117824	0	127783003	4133840		
98637	3020	4133840	2019-03-13	2019-03-13 00:00:00	2019-03-13	5001	0	\N	0	0	\N	\N	0	201410	0	127783003	4133840		
25852	2373	3006322	1972-01-30	1972-01-30 00:00:00	1972-01-30	5001	0	\N	0	0	\N	\N	0	157948	0	8331-1	3006322		
37233	3432	3049273	2007-09-10	2007-09-10 00:00:00	2007-09-10	5001	0	\N	0	0	\N	\N	0	227490	0	38265-5	3049273		
80777	2495	4024958	1987-05-30	1987-05-30 00:00:00	1987-05-30	5001	0	\N	0	0	\N	\N	0	165124	0	117015009	4024958		
9876	938	3006322	1973-06-05	1973-06-05 00:00:00	1973-06-05	5001	0	\N	0	0	\N	\N	0	62347	0	8331-1	3006322		
9948	949	3011505	2018-05-14	2018-05-14 00:00:00	2018-05-14	5001	0	\N	0	0	\N	\N	0	63003	0	19926-5	3011505		
22564	2070	3006734	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	137655	0	6189-5	3006734		
50727	4626	3006734	1997-11-21	1997-11-21 00:00:00	1997-11-21	5001	0	\N	0	0	\N	\N	0	308259	0	6189-5	3006734		
4825	461	3006322	1966-08-01	1966-08-01 00:00:00	1966-08-01	5001	0	\N	0	0	\N	\N	0	30826	0	8331-1	3006322		
16019	1464	3006322	2016-07-26	2016-07-26 00:00:00	2016-07-26	5001	0	\N	0	0	\N	\N	0	97514	0	8331-1	3006322		
34179	3117	46235214	2002-03-22	2002-03-22 00:00:00	2002-03-22	5001	0	\N	0	0	\N	\N	0	207343	0	76690-7	46235214		
45574	4204	3006322	2010-12-15	2010-12-15 00:00:00	2010-12-15	5001	0	\N	0	0	\N	\N	0	279083	0	8331-1	3006322		
27300	2534	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	167435	0	6085-5	3001247		
24893	2283	3049273	2017-09-07	2017-09-07 00:00:00	2017-09-07	5001	0	\N	0	0	\N	\N	0	151885	0	38265-5	3049273		
24955	2291	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	152546	0	6158-0	3019406		
19865	1821	3006322	1964-07-30	1964-07-30 00:00:00	1964-07-30	5001	0	\N	0	0	\N	\N	0	121769	0	8331-1	3006322		
37213	3430	3011505	2003-03-22	2003-03-22 00:00:00	2003-03-22	5001	0	\N	0	0	\N	\N	0	227335	0	19926-5	3011505		
95132	2921	4133840	2005-09-13	2005-09-13 00:00:00	2005-09-13	5001	0	\N	0	0	\N	\N	0	194761	0	127783003	4133840		
3226	97	4133840	2015-08-10	2015-08-10 00:00:00	2015-08-10	5001	0	\N	0	0	\N	\N	0	6613	0	127783003	4133840		
4150	410	3006322	1957-07-24	1957-07-24 00:00:00	1957-07-24	5001	0	\N	0	0	\N	\N	0	27188	0	8331-1	3006322		
4256	419	3049273	1979-12-26	1979-12-26 00:00:00	1979-12-26	5001	0	\N	0	0	\N	\N	0	27712	0	38265-5	3049273		
8625	825	3000963	1970-09-12	1970-09-12 00:00:00	1970-09-12	5001	0	\N	0	0	\N	\N	0	54664	0	718-7	3000963		
37852	3494	3011505	2012-10-25	2012-10-25 00:00:00	2012-10-25	5001	0	\N	0	0	\N	\N	0	231755	0	19926-5	3011505		
20057	1843	3014599	1982-09-26	1982-09-26 00:00:00	1982-09-26	5001	0	\N	0	0	\N	\N	0	123101	0	6106-9	3014599		
31791	2902	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	193352	0	6189-5	3006734		
3204	308	3006322	1963-12-30	1963-12-30 00:00:00	1963-12-30	5001	0	\N	0	0	\N	\N	0	20456	0	8331-1	3006322		
14528	1355	40758406	1966-06-04	1966-06-04 00:00:00	1966-06-04	5001	0	\N	0	0	\N	\N	0	89853	0	55277-8	40758406		
14604	1356	3036780	1998-08-27	1998-08-27 00:00:00	1998-08-27	5001	0	\N	0	0	\N	\N	0	89944	0	6095-4	3036780		
25994	2392	3011505	1990-04-06	1990-04-06 00:00:00	1990-04-06	5001	0	\N	0	0	\N	\N	0	159006	0	19926-5	3011505		
28822	2666	3006322	1954-08-15	1954-08-15 00:00:00	1954-08-15	5001	0	\N	0	0	\N	\N	0	176602	0	8331-1	3006322		
30409	2782	3006322	1967-09-04	1967-09-04 00:00:00	1967-09-04	5001	0	\N	0	0	\N	\N	0	184362	0	8331-1	3006322		
91893	2832	4024958	1988-04-15	1988-04-15 00:00:00	1988-04-15	5001	0	\N	0	0	\N	\N	0	187884	0	117015009	4024958		
37586	3464	3014599	2009-05-29	2009-05-29 00:00:00	2009-05-29	5001	0	\N	0	0	\N	\N	0	229905	0	6106-9	3014599		
28013	2574	3006322	1975-05-04	1975-05-04 00:00:00	1975-05-04	5001	0	\N	0	0	\N	\N	0	170507	0	8331-1	3006322		
39415	3647	3006322	1989-10-13	1989-10-13 00:00:00	1989-10-13	5001	0	\N	0	0	\N	\N	0	242719	0	8331-1	3006322		
46054	4246	40758406	1978-01-19	1978-01-19 00:00:00	1978-01-19	5001	0	\N	0	0	\N	\N	0	281940	0	55277-8	40758406		
39539	3661	3006322	2002-08-29	2002-08-29 00:00:00	2002-08-29	5001	0	\N	0	0	\N	\N	0	243684	0	8331-1	3006322		
57525	5284	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	351596	0	6246-3	3021226		
35966	3308	3006322	1977-08-03	1977-08-03 00:00:00	1977-08-03	5001	0	\N	0	0	\N	\N	0	219639	0	8331-1	3006322		
28788	2661	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	176331	0	6075-6	3005136		
38169	3518	3006322	1984-03-20	1984-03-20 00:00:00	1984-03-20	5001	0	\N	0	0	\N	\N	0	233594	0	8331-1	3006322		
19438	1776	3023103	1984-10-13	1984-10-13 00:00:00	1984-10-13	5001	0	\N	0	0	\N	\N	0	118804	0	2823-3	3023103		
40256	3745	3011505	1995-06-07	1995-06-07 00:00:00	1995-06-07	5001	0	\N	0	0	\N	\N	0	248933	0	19926-5	3011505		
51609	4724	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	314797	0	6844-5	3020655		
51706	4738	3006322	1915-12-17	1915-12-17 00:00:00	1915-12-17	5001	0	\N	0	0	\N	\N	0	315662	0	8331-1	3006322		
27381	857	4133840	2012-04-29	2012-04-29 00:00:00	2012-04-29	5001	0	\N	0	0	\N	\N	0	56632	0	127783003	4133840		
42402	3916	3012494	1995-04-12	1995-04-12 00:00:00	1995-04-12	5001	0	\N	0	0	\N	\N	0	260286	0	6206-7	3012494		
107672	3321	4052083	2013-02-16	2013-02-16 00:00:00	2013-02-16	5001	0	\N	0	0	\N	\N	0	220496	0	23426006	4052083		
145409	4462	4133840	2003-04-10	2003-04-10 00:00:00	2003-04-10	5001	0	\N	0	0	\N	\N	0	296921	0	127783003	4133840		
44331	1365	4052083	1993-10-19	1993-10-19 00:00:00	1993-10-19	5001	0	\N	0	0	\N	\N	0	90505	0	23426006	4052083		
21222	1962	3006322	1993-08-20	1993-08-20 00:00:00	1993-08-20	5001	0	\N	0	0	\N	\N	0	130501	0	8331-1	3006322		
7530	722	3006322	1980-09-10	1980-09-10 00:00:00	1980-09-10	5001	0	\N	0	0	\N	\N	0	47746	0	8331-1	3006322		
7599	727	3006322	1934-05-07	1934-05-07 00:00:00	1934-05-07	5001	0	\N	0	0	\N	\N	0	48250	0	8331-1	3006322		
56519	1724	4024958	1953-01-10	1953-01-10 00:00:00	1953-01-10	5001	0	\N	0	0	\N	\N	0	115240	0	117015009	4024958		
12007	384	4024958	2012-10-29	2012-10-29 00:00:00	2012-10-29	5001	0	\N	0	0	\N	\N	0	25339	0	117015009	4024958		
28712	887	4052083	1982-04-15	1982-04-15 00:00:00	1982-04-15	5001	0	\N	0	0	\N	\N	0	59109	0	23426006	4052083		
124250	3836	4052083	1997-11-09	1997-11-09 00:00:00	1997-11-09	5001	0	\N	0	0	\N	\N	0	254708	0	23426006	4052083		
44833	1378	4133840	2009-10-06	2009-10-06 00:00:00	2009-10-06	5001	0	\N	0	0	\N	\N	0	91352	0	127783003	4133840		
44901	1379	4133840	2009-02-28	2009-02-28 00:00:00	2009-02-28	5001	0	\N	0	0	\N	\N	0	91471	0	127783003	4133840		
34852	1088	4024958	2008-02-25	2008-02-25 00:00:00	2008-02-25	5001	0	\N	0	0	\N	\N	0	71418	0	117015009	4024958		
7733	246	4133840	1998-09-03	1998-09-03 00:00:00	1998-09-03	5001	0	\N	0	0	\N	\N	0	16565	0	127783003	4133840		
27714	864	4024958	1947-07-19	1947-07-19 00:00:00	1947-07-19	5001	0	\N	0	0	\N	\N	0	57296	0	117015009	4024958		
52782	1600	4052083	1965-04-17	1965-04-17 00:00:00	1965-04-17	5001	0	\N	0	0	\N	\N	0	107432	0	23426006	4052083		
57780	1762	4133840	1990-02-22	1990-02-22 00:00:00	1990-02-22	5001	0	\N	0	0	\N	\N	0	117874	0	127783003	4133840		
98640	3020	4052083	1991-12-19	1991-12-19 00:00:00	1991-12-19	5001	0	\N	0	0	\N	\N	0	201393	0	23426006	4052083		
25853	2373	3006322	1962-07-03	1962-07-03 00:00:00	1962-07-03	5001	0	\N	0	0	\N	\N	0	157954	0	8331-1	3006322		
37234	3432	3006322	2017-08-31	2017-08-31 00:00:00	2017-08-31	5001	0	\N	0	0	\N	\N	0	227500	0	8331-1	3006322		
80786	2495	4024958	2010-10-06	2010-10-06 00:00:00	2010-10-06	5001	0	\N	0	0	\N	\N	0	165137	0	117015009	4024958		
9877	938	3006322	1969-04-15	1969-04-15 00:00:00	1969-04-15	5001	0	\N	0	0	\N	\N	0	62326	0	8331-1	3006322		
9949	949	3011505	2014-12-08	2014-12-08 00:00:00	2014-12-08	5001	0	\N	0	0	\N	\N	0	63001	0	19926-5	3011505		
22565	2070	3020655	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	137655	0	6844-5	3020655		
50728	4626	3006451	1997-11-21	1997-11-21 00:00:00	1997-11-21	5001	0	\N	0	0	\N	\N	0	308259	0	6273-7	3006451		
4826	461	3049273	2018-12-18	2018-12-18 00:00:00	2018-12-18	5001	0	\N	0	0	\N	\N	0	30847	0	38265-5	3049273		
16139	1475	3006322	1941-04-02	1941-04-02 00:00:00	1941-04-02	5001	0	\N	0	0	\N	\N	0	98268	0	8331-1	3006322		
34181	3117	40766240	2002-03-22	2002-03-22 00:00:00	2002-03-22	5001	0	\N	0	0	\N	\N	0	207343	0	63513-6	40766240		
45575	4205	3006322	1988-08-17	1988-08-17 00:00:00	1988-08-17	5001	0	\N	0	0	\N	\N	0	279156	0	8331-1	3006322		
27301	2534	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	167435	0	6844-5	3020655		
24894	2283	3006322	1980-02-23	1980-02-23 00:00:00	1980-02-23	5001	0	\N	0	0	\N	\N	0	151908	0	8331-1	3006322		
24956	2291	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	152546	0	6095-4	3036780		
19866	1821	3006322	1954-09-30	1954-09-30 00:00:00	1954-09-30	5001	0	\N	0	0	\N	\N	0	121851	0	8331-1	3006322		
37214	3430	3011505	2007-03-31	2007-03-31 00:00:00	2007-03-31	5001	0	\N	0	0	\N	\N	0	227375	0	19926-5	3011505		
95136	2921	4133840	2001-08-21	2001-08-21 00:00:00	2001-08-21	5001	0	\N	0	0	\N	\N	0	194759	0	127783003	4133840		
3229	97	4133840	1987-08-03	1987-08-03 00:00:00	1987-08-03	5001	0	\N	0	0	\N	\N	0	6660	0	127783003	4133840		
4151	410	3006322	1975-09-12	1975-09-12 00:00:00	1975-09-12	5001	0	\N	0	0	\N	\N	0	27172	0	8331-1	3006322		
4257	419	40758406	1913-08-23	1913-08-23 00:00:00	1913-08-23	5001	0	\N	0	0	\N	\N	0	27684	0	55277-8	40758406		
8626	825	3006322	2002-03-26	2002-03-26 00:00:00	2002-03-26	5001	0	\N	0	0	\N	\N	0	54642	0	8331-1	3006322		
37853	3494	3006322	1967-04-22	1967-04-22 00:00:00	1967-04-22	5001	0	\N	0	0	\N	\N	0	231719	0	8331-1	3006322		
20058	1843	3001247	1982-09-26	1982-09-26 00:00:00	1982-09-26	5001	0	\N	0	0	\N	\N	0	123101	0	6085-5	3001247		
31792	2902	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	193352	0	7258-7	3001488		
3205	308	3006322	2012-01-25	2012-01-25 00:00:00	2012-01-25	5001	0	\N	0	0	\N	\N	0	20425	0	8331-1	3006322		
14531	1355	40766240	1966-06-04	1966-06-04 00:00:00	1966-06-04	5001	0	\N	0	0	\N	\N	0	89853	0	63513-6	40766240		
14605	1356	3021226	1998-08-27	1998-08-27 00:00:00	1998-08-27	5001	0	\N	0	0	\N	\N	0	89944	0	6246-3	3021226		
25995	2392	3011505	1988-03-25	1988-03-25 00:00:00	1988-03-25	5001	0	\N	0	0	\N	\N	0	159059	0	19926-5	3011505		
28823	2666	3006322	2016-12-21	2016-12-21 00:00:00	2016-12-21	5001	0	\N	0	0	\N	\N	0	176606	0	8331-1	3006322		
30410	2782	3006322	1940-11-04	1940-11-04 00:00:00	1940-11-04	5001	0	\N	0	0	\N	\N	0	184434	0	8331-1	3006322		
91931	2833	4052083	2011-08-28	2011-08-28 00:00:00	2011-08-28	5001	0	\N	0	0	\N	\N	0	188025	0	23426006	4052083		
37587	3464	3019406	2009-05-29	2009-05-29 00:00:00	2009-05-29	5001	0	\N	0	0	\N	\N	0	229905	0	6158-0	3019406		
28014	2574	3006322	1976-06-11	1976-06-11 00:00:00	1976-06-11	5001	0	\N	0	0	\N	\N	0	170459	0	8331-1	3006322		
39416	3647	3006322	1940-08-05	1940-08-05 00:00:00	1940-08-05	5001	0	\N	0	0	\N	\N	0	242595	0	8331-1	3006322		
46056	4246	40766240	1978-01-19	1978-01-19 00:00:00	1978-01-19	5001	0	\N	0	0	\N	\N	0	281940	0	63513-6	40766240		
50837	4637	3006322	1993-12-11	1993-12-11 00:00:00	1993-12-11	5001	0	\N	0	0	\N	\N	0	309012	0	8331-1	3006322		
57526	5284	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	351596	0	6844-5	3020655		
35968	3308	3006322	1957-06-20	1957-06-20 00:00:00	1957-06-20	5001	0	\N	0	0	\N	\N	0	219663	0	8331-1	3006322		
28789	2661	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	176331	0	6106-9	3014599		
36299	3337	46235214	1971-10-07	1971-10-07 00:00:00	1971-10-07	5001	0	\N	0	0	\N	\N	0	221403	0	76690-7	46235214		
19439	1776	3013682	1984-10-13	1984-10-13 00:00:00	1984-10-13	5001	0	\N	0	0	\N	\N	0	118804	0	3094-0	3013682		
40257	3745	3011505	1999-06-30	1999-06-30 00:00:00	1999-06-30	5001	0	\N	0	0	\N	\N	0	248967	0	19926-5	3011505		
51610	4724	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	314797	0	6082-2	3000876		
51707	4739	3006322	1960-12-06	1960-12-06 00:00:00	1960-12-06	5001	0	\N	0	0	\N	\N	0	315685	0	8331-1	3006322		
27382	857	4133840	1992-03-15	1992-03-15 00:00:00	1992-03-15	5001	0	\N	0	0	\N	\N	0	56639	0	127783003	4133840		
42403	3916	3014599	1995-04-12	1995-04-12 00:00:00	1995-04-12	5001	0	\N	0	0	\N	\N	0	260286	0	6106-9	3014599		
42937	3966	3006322	2016-12-15	2016-12-15 00:00:00	2016-12-15	5001	0	\N	0	0	\N	\N	0	263632	0	8331-1	3006322		
145410	4462	4133840	2007-02-15	2007-02-15 00:00:00	2007-02-15	5001	0	\N	0	0	\N	\N	0	296907	0	127783003	4133840		
54363	4971	3011505	2001-12-11	2001-12-11 00:00:00	2001-12-11	5001	0	\N	0	0	\N	\N	0	330580	0	19926-5	3011505		
21223	1962	3006322	1967-10-04	1967-10-04 00:00:00	1967-10-04	5001	0	\N	0	0	\N	\N	0	130488	0	8331-1	3006322		
7531	722	3006322	1974-07-16	1974-07-16 00:00:00	1974-07-16	5001	0	\N	0	0	\N	\N	0	47772	0	8331-1	3006322		
7601	727	3006322	2007-12-20	2007-12-20 00:00:00	2007-12-20	5001	0	\N	0	0	\N	\N	0	48177	0	8331-1	3006322		
56521	1724	4024958	2013-04-29	2013-04-29 00:00:00	2013-04-29	5001	0	\N	0	0	\N	\N	0	115281	0	117015009	4024958		
12015	384	4024958	1971-05-14	1971-05-14 00:00:00	1971-05-14	5001	0	\N	0	0	\N	\N	0	25308	0	117015009	4024958		
7003	672	3006322	1972-12-01	1972-12-01 00:00:00	1972-12-01	5001	0	\N	0	0	\N	\N	0	44370	0	8331-1	3006322		
124307	3839	4024958	1981-11-01	1981-11-01 00:00:00	1981-11-01	5001	0	\N	0	0	\N	\N	0	254921	0	117015009	4024958		
44834	1378	4133840	2000-07-25	2000-07-25 00:00:00	2000-07-25	5001	0	\N	0	0	\N	\N	0	91440	0	127783003	4133840		
44902	1379	4133840	2011-03-12	2011-03-12 00:00:00	2011-03-12	5001	0	\N	0	0	\N	\N	0	91472	0	127783003	4133840		
34853	1088	4024958	2005-08-24	2005-08-24 00:00:00	2005-08-24	5001	0	\N	0	0	\N	\N	0	71447	0	117015009	4024958		
7737	246	4133840	2011-05-05	2011-05-05 00:00:00	2011-05-05	5001	0	\N	0	0	\N	\N	0	16568	0	127783003	4133840		
27726	864	4052083	1930-05-07	1930-05-07 00:00:00	1930-05-07	5001	0	\N	0	0	\N	\N	0	57294	0	23426006	4052083		
43356	1333	4052083	1974-10-29	1974-10-29 00:00:00	1974-10-29	5001	0	\N	0	0	\N	\N	0	88452	0	23426006	4052083		
57782	1762	4133840	2001-01-25	2001-01-25 00:00:00	2001-01-25	5001	0	\N	0	0	\N	\N	0	117876	0	127783003	4133840		
98644	3020	4133840	2016-02-24	2016-02-24 00:00:00	2016-02-24	5001	0	\N	0	0	\N	\N	0	201388	0	127783003	4133840		
25863	2380	3006322	1989-11-26	1989-11-26 00:00:00	1989-11-26	5001	0	\N	0	0	\N	\N	0	158188	0	8331-1	3006322		
37235	3432	3006322	2008-04-13	2008-04-13 00:00:00	2008-04-13	5001	0	\N	0	0	\N	\N	0	227546	0	8331-1	3006322		
23948	752	4052083	2008-10-10	2008-10-10 00:00:00	2008-10-10	5001	0	\N	0	0	\N	\N	0	49680	0	23426006	4052083		
9878	938	3049273	2015-10-22	2015-10-22 00:00:00	2015-10-22	5001	0	\N	0	0	\N	\N	0	62331	0	38265-5	3049273		
9950	949	46235214	1959-06-15	1959-06-15 00:00:00	1959-06-15	5001	0	\N	0	0	\N	\N	0	63024	0	76690-7	46235214		
22566	2070	3023430	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	137655	0	6833-8	3023430		
50729	4626	3012494	1997-11-21	1997-11-21 00:00:00	1997-11-21	5001	0	\N	0	0	\N	\N	0	308259	0	6206-7	3012494		
4827	461	3006322	1988-05-31	1988-05-31 00:00:00	1988-05-31	5001	0	\N	0	0	\N	\N	0	30780	0	8331-1	3006322		
16140	1475	3006322	2002-01-06	2002-01-06 00:00:00	2002-01-06	5001	0	\N	0	0	\N	\N	0	98261	0	8331-1	3006322		
34182	3117	40758406	2002-03-22	2002-03-22 00:00:00	2002-03-22	5001	0	\N	0	0	\N	\N	0	207343	0	55277-8	40758406		
45576	4205	3001488	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	279161	0	7258-7	3001488		
27302	2534	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	167435	0	6833-8	3023430		
24897	2283	3006322	1943-01-29	1943-01-29 00:00:00	1943-01-29	5001	0	\N	0	0	\N	\N	0	151874	0	8331-1	3006322		
24957	2291	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	152546	0	6276-0	3027231		
31147	2849	3006322	1939-04-16	1939-04-16 00:00:00	1939-04-16	5001	0	\N	0	0	\N	\N	0	189277	0	8331-1	3006322		
37215	3430	3011505	1992-03-07	1992-03-07 00:00:00	1992-03-07	5001	0	\N	0	0	\N	\N	0	227368	0	19926-5	3011505		
95139	2921	4133840	2018-11-27	2018-11-27 00:00:00	2018-11-27	5001	0	\N	0	0	\N	\N	0	194720	0	127783003	4133840		
3232	97	4133840	1989-08-07	1989-08-07 00:00:00	1989-08-07	5001	0	\N	0	0	\N	\N	0	6608	0	127783003	4133840		
4152	410	3049273	2019-02-06	2019-02-06 00:00:00	2019-02-06	5001	0	\N	0	0	\N	\N	0	27159	0	38265-5	3049273		
4259	419	40766240	1913-08-23	1913-08-23 00:00:00	1913-08-23	5001	0	\N	0	0	\N	\N	0	27684	0	63513-6	40766240		
8627	825	3006322	1982-09-13	1982-09-13 00:00:00	1982-09-13	5001	0	\N	0	0	\N	\N	0	54692	0	8331-1	3006322		
37854	3494	3006322	1997-08-22	1997-08-22 00:00:00	1997-08-22	5001	0	\N	0	0	\N	\N	0	231722	0	8331-1	3006322		
20059	1843	3006734	1982-09-26	1982-09-26 00:00:00	1982-09-26	5001	0	\N	0	0	\N	\N	0	123101	0	6189-5	3006734		
31793	2902	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	193352	0	6095-4	3036780		
3206	308	3006322	1980-11-29	1980-11-29 00:00:00	1980-11-29	5001	0	\N	0	0	\N	\N	0	20401	0	8331-1	3006322		
14532	1355	3051031	1966-06-04	1966-06-04 00:00:00	1966-06-04	5001	0	\N	0	0	\N	\N	0	89853	0	46240-8	3051031		
14606	1356	3012494	1998-08-27	1998-08-27 00:00:00	1998-08-27	5001	0	\N	0	0	\N	\N	0	89944	0	6206-7	3012494		
25996	2392	3011505	2012-08-10	2012-08-10 00:00:00	2012-08-10	5001	0	\N	0	0	\N	\N	0	158975	0	19926-5	3011505		
28824	2666	3006322	1980-04-05	1980-04-05 00:00:00	1980-04-05	5001	0	\N	0	0	\N	\N	0	176648	0	8331-1	3006322		
30412	2782	3006322	1953-02-07	1953-02-07 00:00:00	1953-02-07	5001	0	\N	0	0	\N	\N	0	184419	0	8331-1	3006322		
91932	2833	4024958	1936-12-09	1936-12-09 00:00:00	1936-12-09	5001	0	\N	0	0	\N	\N	0	188097	0	117015009	4024958		
37588	3464	3012494	2009-05-29	2009-05-29 00:00:00	2009-05-29	5001	0	\N	0	0	\N	\N	0	229905	0	6206-7	3012494		
28015	2574	3006322	1996-12-04	1996-12-04 00:00:00	1996-12-04	5001	0	\N	0	0	\N	\N	0	170508	0	8331-1	3006322		
39417	3647	3006322	1978-02-20	1978-02-20 00:00:00	1978-02-20	5001	0	\N	0	0	\N	\N	0	242718	0	8331-1	3006322		
46057	4246	46235214	1978-01-19	1978-01-19 00:00:00	1978-01-19	5001	0	\N	0	0	\N	\N	0	281940	0	76690-7	46235214		
50838	4637	3006322	1990-07-21	1990-07-21 00:00:00	1990-07-21	5001	0	\N	0	0	\N	\N	0	309014	0	8331-1	3006322		
57527	5284	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	351596	0	6095-4	3036780		
35973	3311	3006322	2011-09-12	2011-09-12 00:00:00	2011-09-12	5001	0	\N	0	0	\N	\N	0	219769	0	8331-1	3006322		
28790	2661	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	176331	0	7258-7	3001488		
36300	3337	40766240	1971-10-07	1971-10-07 00:00:00	1971-10-07	5001	0	\N	0	0	\N	\N	0	221403	0	63513-6	40766240		
19440	1776	3026361	1984-10-13	1984-10-13 00:00:00	1984-10-13	5001	0	\N	0	0	\N	\N	0	118804	0	26453-1	3026361		
40258	3745	3011505	2016-10-05	2016-10-05 00:00:00	2016-10-05	5001	0	\N	0	0	\N	\N	0	248975	0	19926-5	3011505		
51611	4724	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	314797	0	6276-0	3027231		
51708	4739	3006322	1984-07-14	1984-07-14 00:00:00	1984-07-14	5001	0	\N	0	0	\N	\N	0	315688	0	8331-1	3006322		
38670	1205	4052083	2016-10-06	2016-10-06 00:00:00	2016-10-06	5001	0	\N	0	0	\N	\N	0	79203	0	23426006	4052083		
42404	3916	3019406	1995-04-12	1995-04-12 00:00:00	1995-04-12	5001	0	\N	0	0	\N	\N	0	260286	0	6158-0	3019406		
42938	3966	3006322	1975-09-08	1975-09-08 00:00:00	1975-09-08	5001	0	\N	0	0	\N	\N	0	263630	0	8331-1	3006322		
145414	4462	4133840	2016-04-07	2016-04-07 00:00:00	2016-04-07	5001	0	\N	0	0	\N	\N	0	296925	0	127783003	4133840		
54364	4971	3006322	1982-07-22	1982-07-22 00:00:00	1982-07-22	5001	0	\N	0	0	\N	\N	0	330588	0	8331-1	3006322		
21224	1962	3006322	1966-10-28	1966-10-28 00:00:00	1966-10-28	5001	0	\N	0	0	\N	\N	0	130455	0	8331-1	3006322		
7532	722	3006322	2007-12-10	2007-12-10 00:00:00	2007-12-10	5001	0	\N	0	0	\N	\N	0	47790	0	8331-1	3006322		
7602	728	3006322	1963-11-09	1963-11-09 00:00:00	1963-11-09	5001	0	\N	0	0	\N	\N	0	48335	0	8331-1	3006322		
56552	1727	4133840	1999-03-31	1999-03-31 00:00:00	1999-03-31	5001	0	\N	0	0	\N	\N	0	115511	0	127783003	4133840		
12017	384	4052083	2014-04-18	2014-04-18 00:00:00	2014-04-18	5001	0	\N	0	0	\N	\N	0	25349	0	23426006	4052083		
7004	672	3006322	1995-04-27	1995-04-27 00:00:00	1995-04-27	5001	0	\N	0	0	\N	\N	0	44351	0	8331-1	3006322		
124310	3839	4052083	1957-09-17	1957-09-17 00:00:00	1957-09-17	5001	0	\N	0	0	\N	\N	0	254870	0	23426006	4052083		
44840	1378	4133840	2010-10-12	2010-10-12 00:00:00	2010-10-12	5001	0	\N	0	0	\N	\N	0	91319	0	127783003	4133840		
44909	1379	4133840	2010-03-06	2010-03-06 00:00:00	2010-03-06	5001	0	\N	0	0	\N	\N	0	91451	0	127783003	4133840		
34855	1088	4052083	1985-06-23	1985-06-23 00:00:00	1985-06-23	5001	0	\N	0	0	\N	\N	0	71461	0	23426006	4052083		
7738	246	4024958	1986-08-10	1986-08-10 00:00:00	1986-08-10	5001	0	\N	0	0	\N	\N	0	16580	0	117015009	4024958		
27727	864	4052083	2002-07-14	2002-07-14 00:00:00	2002-07-14	5001	0	\N	0	0	\N	\N	0	57302	0	23426006	4052083		
43359	1333	4052083	1970-02-13	1970-02-13 00:00:00	1970-02-13	5001	0	\N	0	0	\N	\N	0	88404	0	23426006	4052083		
57785	1762	4133840	1982-02-04	1982-02-04 00:00:00	1982-02-04	5001	0	\N	0	0	\N	\N	0	117873	0	127783003	4133840		
98646	3020	4133840	2001-01-17	2001-01-17 00:00:00	2001-01-17	5001	0	\N	0	0	\N	\N	0	201407	0	127783003	4133840		
25864	2380	3006322	1951-11-19	1951-11-19 00:00:00	1951-11-19	5001	0	\N	0	0	\N	\N	0	158174	0	8331-1	3006322		
37238	3434	3006322	1964-01-19	1964-01-19 00:00:00	1964-01-19	5001	0	\N	0	0	\N	\N	0	227694	0	8331-1	3006322		
23952	752	4024958	1960-06-03	1960-06-03 00:00:00	1960-06-03	5001	0	\N	0	0	\N	\N	0	49654	0	117015009	4024958		
9879	938	3006322	1990-06-01	1990-06-01 00:00:00	1990-06-01	5001	0	\N	0	0	\N	\N	0	62320	0	8331-1	3006322		
9952	949	40758406	1959-06-15	1959-06-15 00:00:00	1959-06-15	5001	0	\N	0	0	\N	\N	0	63024	0	55277-8	40758406		
22567	2070	3000876	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	137655	0	6082-2	3000876		
50730	4626	3021226	1997-11-21	1997-11-21 00:00:00	1997-11-21	5001	0	\N	0	0	\N	\N	0	308259	0	6246-3	3021226		
4828	461	3006322	1992-03-26	1992-03-26 00:00:00	1992-03-26	5001	0	\N	0	0	\N	\N	0	30815	0	8331-1	3006322		
16141	1475	3006322	2002-11-14	2002-11-14 00:00:00	2002-11-14	5001	0	\N	0	0	\N	\N	0	98262	0	8331-1	3006322		
34183	3117	3051031	2002-03-22	2002-03-22 00:00:00	2002-03-22	5001	0	\N	0	0	\N	\N	0	207343	0	46240-8	3051031		
45577	4205	3036780	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	279161	0	6095-4	3036780		
27303	2534	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	167435	0	6246-3	3021226		
24916	2286	3006322	2012-06-24	2012-06-24 00:00:00	2012-06-24	5001	0	\N	0	0	\N	\N	0	152060	0	8331-1	3006322		
24958	2291	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	152546	0	6106-9	3014599		
31148	2849	3006322	2003-03-02	2003-03-02 00:00:00	2003-03-02	5001	0	\N	0	0	\N	\N	0	189272	0	8331-1	3006322		
37216	3430	3011505	1995-03-11	1995-03-11 00:00:00	1995-03-11	5001	0	\N	0	0	\N	\N	0	227369	0	19926-5	3011505		
95141	2921	4133840	2000-08-15	2000-08-15 00:00:00	2000-08-15	5001	0	\N	0	0	\N	\N	0	194746	0	127783003	4133840		
3234	97	4133840	1993-07-19	1993-07-19 00:00:00	1993-07-19	5001	0	\N	0	0	\N	\N	0	6626	0	127783003	4133840		
4153	410	3006322	1990-05-08	1990-05-08 00:00:00	1990-05-08	5001	0	\N	0	0	\N	\N	0	27192	0	8331-1	3006322		
4261	419	3051031	1913-08-23	1913-08-23 00:00:00	1913-08-23	5001	0	\N	0	0	\N	\N	0	27684	0	46240-8	3051031		
8628	825	3006322	1994-06-22	1994-06-22 00:00:00	1994-06-22	5001	0	\N	0	0	\N	\N	0	54641	0	8331-1	3006322		
37855	3494	3011505	2015-11-12	2015-11-12 00:00:00	2015-11-12	5001	0	\N	0	0	\N	\N	0	231792	0	19926-5	3011505		
20060	1843	3021226	1994-08-24	1994-08-24 00:00:00	1994-08-24	5001	0	\N	0	0	\N	\N	0	123018	0	6246-3	3021226		
31794	2902	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	193352	0	6206-7	3012494		
3207	308	3006322	1966-04-01	1966-04-01 00:00:00	1966-04-01	5001	0	\N	0	0	\N	\N	0	20422	0	8331-1	3006322		
14533	1355	46235214	1966-06-04	1966-06-04 00:00:00	1966-06-04	5001	0	\N	0	0	\N	\N	0	89853	0	76690-7	46235214		
14607	1356	3019406	1998-08-27	1998-08-27 00:00:00	1998-08-27	5001	0	\N	0	0	\N	\N	0	89944	0	6158-0	3019406		
25997	2392	3011505	2005-07-01	2005-07-01 00:00:00	2005-07-01	5001	0	\N	0	0	\N	\N	0	158996	0	19926-5	3011505		
28825	2666	3006322	1975-07-20	1975-07-20 00:00:00	1975-07-20	5001	0	\N	0	0	\N	\N	0	176660	0	8331-1	3006322		
30414	2782	3006322	1958-07-22	1958-07-22 00:00:00	1958-07-22	5001	0	\N	0	0	\N	\N	0	184344	0	8331-1	3006322		
91933	2833	4024958	1940-04-03	1940-04-03 00:00:00	1940-04-03	5001	0	\N	0	0	\N	\N	0	188087	0	117015009	4024958		
37589	3464	3015076	2009-05-29	2009-05-29 00:00:00	2009-05-29	5001	0	\N	0	0	\N	\N	0	229905	0	6248-9	3015076		
28016	2574	3006322	1972-02-09	1972-02-09 00:00:00	1972-02-09	5001	0	\N	0	0	\N	\N	0	170450	0	8331-1	3006322		
39418	3647	3006322	1943-06-30	1943-06-30 00:00:00	1943-06-30	5001	0	\N	0	0	\N	\N	0	242678	0	8331-1	3006322		
46059	4246	3006322	1974-01-16	1974-01-16 00:00:00	1974-01-16	5001	0	\N	0	0	\N	\N	0	281986	0	8331-1	3006322		
50839	4637	3006322	1988-04-22	1988-04-22 00:00:00	1988-04-22	5001	0	\N	0	0	\N	\N	0	309034	0	8331-1	3006322		
57528	5284	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	351596	0	6833-8	3023430		
35974	3311	3005136	1993-10-01	1993-10-01 00:00:00	1993-10-01	5001	0	\N	0	0	\N	\N	0	219768	0	6075-6	3005136		
28791	2661	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	176331	0	6189-5	3006734		
36301	3337	40758406	1971-10-07	1971-10-07 00:00:00	1971-10-07	5001	0	\N	0	0	\N	\N	0	221403	0	55277-8	40758406		
19441	1776	3006923	1984-10-13	1984-10-13 00:00:00	1984-10-13	5001	0	\N	0	0	\N	\N	0	118804	0	1742-6	3006923		
40259	3745	3011505	2014-09-24	2014-09-24 00:00:00	2014-09-24	5001	0	\N	0	0	\N	\N	0	248974	0	19926-5	3011505		
51612	4724	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	314797	0	6248-9	3015076		
51709	4739	3006322	1947-11-05	1947-11-05 00:00:00	1947-11-05	5001	0	\N	0	0	\N	\N	0	315754	0	8331-1	3006322		
38674	1205	4024958	1963-04-07	1963-04-07 00:00:00	1963-04-07	5001	0	\N	0	0	\N	\N	0	79183	0	117015009	4024958		
42405	3916	3015076	1995-04-12	1995-04-12 00:00:00	1995-04-12	5001	0	\N	0	0	\N	\N	0	260286	0	6248-9	3015076		
42939	3966	3006322	2015-07-13	2015-07-13 00:00:00	2015-07-13	5001	0	\N	0	0	\N	\N	0	263652	0	8331-1	3006322		
54281	4964	3049273	2015-09-27	2015-09-27 00:00:00	2015-09-27	5001	0	\N	0	0	\N	\N	0	329972	0	38265-5	3049273		
54365	4971	3011505	2012-02-07	2012-02-07 00:00:00	2012-02-07	5001	0	\N	0	0	\N	\N	0	330554	0	19926-5	3011505		
21227	1964	3006322	1961-10-01	1961-10-01 00:00:00	1961-10-01	5001	0	\N	0	0	\N	\N	0	130554	0	8331-1	3006322		
7533	722	3006322	1997-08-21	1997-08-21 00:00:00	1997-08-21	5001	0	\N	0	0	\N	\N	0	47766	0	8331-1	3006322		
7603	728	3006322	1997-04-20	1997-04-20 00:00:00	1997-04-20	5001	0	\N	0	0	\N	\N	0	48332	0	8331-1	3006322		
56555	1727	4133840	2001-04-12	2001-04-12 00:00:00	2001-04-12	5001	0	\N	0	0	\N	\N	0	115475	0	127783003	4133840		
12056	387	4052083	1980-04-16	1980-04-16 00:00:00	1980-04-16	5001	0	\N	0	0	\N	\N	0	25488	0	23426006	4052083		
7005	673	3006322	1995-02-09	1995-02-09 00:00:00	1995-02-09	5001	0	\N	0	0	\N	\N	0	44466	0	8331-1	3006322		
110278	3403	4024958	2011-04-11	2011-04-11 00:00:00	2011-04-11	5001	0	\N	0	0	\N	\N	0	225758	0	117015009	4024958		
44846	1378	4133840	2018-07-31	2018-07-31 00:00:00	2018-07-31	5001	0	\N	0	0	\N	\N	0	91431	0	127783003	4133840		
44910	1379	4133840	2015-04-04	2015-04-04 00:00:00	2015-04-04	5001	0	\N	0	0	\N	\N	0	91523	0	127783003	4133840		
34864	1088	4052083	2001-01-18	2001-01-18 00:00:00	2001-01-18	5001	0	\N	0	0	\N	\N	0	71463	0	23426006	4052083		
7741	246	4133840	2017-06-08	2017-06-08 00:00:00	2017-06-08	5001	0	\N	0	0	\N	\N	0	16544	0	127783003	4133840		
27743	864	4024958	1973-01-01	1973-01-01 00:00:00	1973-01-01	5001	0	\N	0	0	\N	\N	0	57312	0	117015009	4024958		
43369	1333	4024958	1969-04-02	1969-04-02 00:00:00	1969-04-02	5001	0	\N	0	0	\N	\N	0	88441	0	117015009	4024958		
57789	1762	4133840	1970-10-15	1970-10-15 00:00:00	1970-10-15	5001	0	\N	0	0	\N	\N	0	117815	0	127783003	4133840		
98649	3020	4133840	2018-03-07	2018-03-07 00:00:00	2018-03-07	5001	0	\N	0	0	\N	\N	0	201389	0	127783003	4133840		
25865	2380	3006322	2013-07-03	2013-07-03 00:00:00	2013-07-03	5001	0	\N	0	0	\N	\N	0	158213	0	8331-1	3006322		
37239	3434	3006322	1994-05-20	1994-05-20 00:00:00	1994-05-20	5001	0	\N	0	0	\N	\N	0	227728	0	8331-1	3006322		
23961	752	4052083	2014-05-07	2014-05-07 00:00:00	2014-05-07	5001	0	\N	0	0	\N	\N	0	49739	0	23426006	4052083		
9880	938	3006322	1949-02-01	1949-02-01 00:00:00	1949-02-01	5001	0	\N	0	0	\N	\N	0	62408	0	8331-1	3006322		
9954	949	40766240	1959-06-15	1959-06-15 00:00:00	1959-06-15	5001	0	\N	0	0	\N	\N	0	63024	0	63513-6	40766240		
22568	2070	3001488	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	137655	0	7258-7	3001488		
50731	4626	3005136	1997-11-21	1997-11-21 00:00:00	1997-11-21	5001	0	\N	0	0	\N	\N	0	308259	0	6075-6	3005136		
4829	461	3006322	1950-12-17	1950-12-17 00:00:00	1950-12-17	5001	0	\N	0	0	\N	\N	0	30825	0	8331-1	3006322		
16142	1475	3006322	1980-05-03	1980-05-03 00:00:00	1980-05-03	5001	0	\N	0	0	\N	\N	0	98271	0	8331-1	3006322		
34185	3117	46235214	2001-11-22	2001-11-22 00:00:00	2001-11-22	5001	0	\N	0	0	\N	\N	0	207388	0	76690-7	46235214		
45578	4205	3021226	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	279161	0	6246-3	3021226		
27304	2534	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	167435	0	6106-9	3014599		
24917	2286	3006322	1998-01-28	1998-01-28 00:00:00	1998-01-28	5001	0	\N	0	0	\N	\N	0	152068	0	8331-1	3006322		
24959	2291	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	152546	0	6206-7	3012494		
31219	2853	3006322	1993-02-13	1993-02-13 00:00:00	1993-02-13	5001	0	\N	0	0	\N	\N	0	189513	0	8331-1	3006322		
37217	3430	3006322	2017-04-23	2017-04-23 00:00:00	2017-04-23	5001	0	\N	0	0	\N	\N	0	227396	0	8331-1	3006322		
95142	2921	4133840	1985-05-21	1985-05-21 00:00:00	1985-05-21	5001	0	\N	0	0	\N	\N	0	194739	0	127783003	4133840		
3235	97	4133840	1998-08-17	1998-08-17 00:00:00	1998-08-17	5001	0	\N	0	0	\N	\N	0	6662	0	127783003	4133840		
4154	410	3006322	1996-12-16	1996-12-16 00:00:00	1996-12-16	5001	0	\N	0	0	\N	\N	0	27218	0	8331-1	3006322		
4262	419	46235214	1913-08-23	1913-08-23 00:00:00	1913-08-23	5001	0	\N	0	0	\N	\N	0	27684	0	76690-7	46235214		
8629	826	3049273	2013-09-26	2013-09-26 00:00:00	2013-09-26	5001	0	\N	0	0	\N	\N	0	54739	0	38265-5	3049273		
37856	3494	3006322	1964-10-23	1964-10-23 00:00:00	1964-10-23	5001	0	\N	0	0	\N	\N	0	231771	0	8331-1	3006322		
20061	1843	3006451	1994-08-24	1994-08-24 00:00:00	1994-08-24	5001	0	\N	0	0	\N	\N	0	123018	0	6273-7	3006451		
31795	2902	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	193352	0	6082-2	3000876		
3208	310	3006322	2002-09-17	2002-09-17 00:00:00	2002-09-17	5001	0	\N	0	0	\N	\N	0	20509	0	8331-1	3006322		
14534	1355	3006322	2017-10-02	2017-10-02 00:00:00	2017-10-02	5001	0	\N	0	0	\N	\N	0	89858	0	8331-1	3006322		
14608	1356	3014599	1998-08-27	1998-08-27 00:00:00	1998-08-27	5001	0	\N	0	0	\N	\N	0	89944	0	6106-9	3014599		
25998	2392	3011505	2015-10-16	2015-10-16 00:00:00	2015-10-16	5001	0	\N	0	0	\N	\N	0	159069	0	19926-5	3011505		
28826	2666	3006322	1992-08-08	1992-08-08 00:00:00	1992-08-08	5001	0	\N	0	0	\N	\N	0	176662	0	8331-1	3006322		
30416	2782	3006322	1959-10-30	1959-10-30 00:00:00	1959-10-30	5001	0	\N	0	0	\N	\N	0	184436	0	8331-1	3006322		
91934	2833	4024958	1978-06-13	1978-06-13 00:00:00	1978-06-13	5001	0	\N	0	0	\N	\N	0	188022	0	117015009	4024958		
37590	3464	3006451	2009-05-29	2009-05-29 00:00:00	2009-05-29	5001	0	\N	0	0	\N	\N	0	229905	0	6273-7	3006451		
28017	2576	3006322	1997-03-22	1997-03-22 00:00:00	1997-03-22	5001	0	\N	0	0	\N	\N	0	170559	0	8331-1	3006322		
147645	4526	4052083	1968-04-03	1968-04-03 00:00:00	1968-04-03	5001	0	\N	0	0	\N	\N	0	301352	0	23426006	4052083		
46060	4246	3051031	1977-04-24	1977-04-24 00:00:00	1977-04-24	5001	0	\N	0	0	\N	\N	0	281921	0	46240-8	3051031		
50840	4637	3006322	1980-04-20	1980-04-20 00:00:00	1980-04-20	5001	0	\N	0	0	\N	\N	0	309021	0	8331-1	3006322		
57529	5284	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	351596	0	6189-5	3006734		
35975	3311	3015076	1993-10-01	1993-10-01 00:00:00	1993-10-01	5001	0	\N	0	0	\N	\N	0	219768	0	6248-9	3015076		
28792	2661	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	176331	0	6833-8	3023430		
36302	3337	3051031	1971-10-07	1971-10-07 00:00:00	1971-10-07	5001	0	\N	0	0	\N	\N	0	221403	0	46240-8	3051031		
19442	1776	3006906	1984-10-13	1984-10-13 00:00:00	1984-10-13	5001	0	\N	0	0	\N	\N	0	118804	0	17861-6	3006906		
40260	3745	3011505	1998-06-24	1998-06-24 00:00:00	1998-06-24	5001	0	\N	0	0	\N	\N	0	248960	0	19926-5	3011505		
51613	4724	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	314797	0	6273-7	3006451		
51710	4739	3006322	1937-09-18	1937-09-18 00:00:00	1937-09-18	5001	0	\N	0	0	\N	\N	0	315700	0	8331-1	3006322		
38675	1205	4052083	1964-12-26	1964-12-26 00:00:00	1964-12-26	5001	0	\N	0	0	\N	\N	0	79184	0	23426006	4052083		
42406	3916	3027231	1995-04-12	1995-04-12 00:00:00	1995-04-12	5001	0	\N	0	0	\N	\N	0	260286	0	6276-0	3027231		
42940	3966	3006322	2004-09-25	2004-09-25 00:00:00	2004-09-25	5001	0	\N	0	0	\N	\N	0	263695	0	8331-1	3006322		
54282	4964	3006322	2013-02-07	2013-02-07 00:00:00	2013-02-07	5001	0	\N	0	0	\N	\N	0	330032	0	8331-1	3006322		
54366	4971	3011505	2013-02-12	2013-02-12 00:00:00	2013-02-12	5001	0	\N	0	0	\N	\N	0	330582	0	19926-5	3011505		
21228	1964	3006322	1979-10-07	1979-10-07 00:00:00	1979-10-07	5001	0	\N	0	0	\N	\N	0	130555	0	8331-1	3006322		
7534	722	3006322	1980-05-30	1980-05-30 00:00:00	1980-05-30	5001	0	\N	0	0	\N	\N	0	47742	0	8331-1	3006322		
7604	728	3006322	1994-04-26	1994-04-26 00:00:00	1994-04-26	5001	0	\N	0	0	\N	\N	0	48341	0	8331-1	3006322		
56559	1727	4133840	2007-10-04	2007-10-04 00:00:00	2007-10-04	5001	0	\N	0	0	\N	\N	0	115452	0	127783003	4133840		
168380	5168	4024958	2000-04-20	2000-04-20 00:00:00	2000-04-20	5001	0	\N	0	0	\N	\N	0	343648	0	117015009	4024958		
7006	673	3006322	1987-05-10	1987-05-10 00:00:00	1987-05-10	5001	0	\N	0	0	\N	\N	0	44522	0	8331-1	3006322		
110280	3403	4024958	1997-06-15	1997-06-15 00:00:00	1997-06-15	5001	0	\N	0	0	\N	\N	0	225756	0	117015009	4024958		
44848	1378	4133840	2016-11-15	2016-11-15 00:00:00	2016-11-15	5001	0	\N	0	0	\N	\N	0	91430	0	127783003	4133840		
44911	1379	4024958	1961-06-11	1961-06-11 00:00:00	1961-06-11	5001	0	\N	0	0	\N	\N	0	91489	0	117015009	4024958		
34867	1088	4024958	2005-07-08	2005-07-08 00:00:00	2005-07-08	5001	0	\N	0	0	\N	\N	0	71408	0	117015009	4024958		
7742	246	4024958	1962-11-12	1962-11-12 00:00:00	1962-11-12	5001	0	\N	0	0	\N	\N	0	16518	0	117015009	4024958		
27744	864	4024958	1967-12-16	1967-12-16 00:00:00	1967-12-16	5001	0	\N	0	0	\N	\N	0	57232	0	117015009	4024958		
43372	1333	4024958	2011-11-23	2011-11-23 00:00:00	2011-11-23	5001	0	\N	0	0	\N	\N	0	88420	0	117015009	4024958		
57791	1762	4133840	1988-02-18	1988-02-18 00:00:00	1988-02-18	5001	0	\N	0	0	\N	\N	0	117890	0	127783003	4133840		
98650	3020	4133840	2008-01-09	2008-01-09 00:00:00	2008-01-09	5001	0	\N	0	0	\N	\N	0	201408	0	127783003	4133840		
25866	2380	3006322	1981-09-27	1981-09-27 00:00:00	1981-09-27	5001	0	\N	0	0	\N	\N	0	158186	0	8331-1	3006322		
37240	3434	3006322	1994-07-30	1994-07-30 00:00:00	1994-07-30	5001	0	\N	0	0	\N	\N	0	227746	0	8331-1	3006322		
23963	752	4052083	1971-07-25	1971-07-25 00:00:00	1971-07-25	5001	0	\N	0	0	\N	\N	0	49717	0	23426006	4052083		
9881	939	3006322	1997-11-01	1997-11-01 00:00:00	1997-11-01	5001	0	\N	0	0	\N	\N	0	62440	0	8331-1	3006322		
9955	949	3051031	1959-06-15	1959-06-15 00:00:00	1959-06-15	5001	0	\N	0	0	\N	\N	0	63024	0	46240-8	3051031		
22569	2070	3001247	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	137655	0	6085-5	3001247		
50732	4626	3014599	1997-11-21	1997-11-21 00:00:00	1997-11-21	5001	0	\N	0	0	\N	\N	0	308259	0	6106-9	3014599		
4830	461	3006322	1958-03-06	1958-03-06 00:00:00	1958-03-06	5001	0	\N	0	0	\N	\N	0	30828	0	8331-1	3006322		
16143	1475	3006322	1997-11-17	1997-11-17 00:00:00	1997-11-17	5001	0	\N	0	0	\N	\N	0	98317	0	8331-1	3006322		
34187	3117	40766240	2001-11-22	2001-11-22 00:00:00	2001-11-22	5001	0	\N	0	0	\N	\N	0	207388	0	63513-6	40766240		
45579	4205	3023430	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	279161	0	6833-8	3023430		
27305	2534	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	167435	0	6273-7	3006451		
24918	2286	3006322	1980-10-17	1980-10-17 00:00:00	1980-10-17	5001	0	\N	0	0	\N	\N	0	152025	0	8331-1	3006322		
24960	2291	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	152546	0	6075-6	3005136		
55872	1703	4052083	1949-08-10	1949-08-10 00:00:00	1949-08-10	5001	0	\N	0	0	\N	\N	0	113914	0	23426006	4052083		
37218	3430	3011505	2019-05-25	2019-05-25 00:00:00	2019-05-25	5001	0	\N	0	0	\N	\N	0	227339	0	19926-5	3011505		
95146	2921	4133840	2007-09-25	2007-09-25 00:00:00	2007-09-25	5001	0	\N	0	0	\N	\N	0	194704	0	127783003	4133840		
3236	97	4024958	1945-07-22	1945-07-22 00:00:00	1945-07-22	5001	0	\N	0	0	\N	\N	0	6650	0	117015009	4024958		
4155	411	3021226	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	27261	0	6246-3	3021226		
4263	419	40758406	1913-03-26	1913-03-26 00:00:00	1913-03-26	5001	0	\N	0	0	\N	\N	0	27715	0	55277-8	40758406		
8630	826	3006322	1967-01-04	1967-01-04 00:00:00	1967-01-04	5001	0	\N	0	0	\N	\N	0	54712	0	8331-1	3006322		
37857	3494	3006322	1996-12-13	1996-12-13 00:00:00	1996-12-13	5001	0	\N	0	0	\N	\N	0	231772	0	8331-1	3006322		
20062	1843	3000876	1994-08-24	1994-08-24 00:00:00	1994-08-24	5001	0	\N	0	0	\N	\N	0	123018	0	6082-2	3000876		
31796	2902	3006322	1954-01-25	1954-01-25 00:00:00	1954-01-25	5001	0	\N	0	0	\N	\N	0	193263	0	8331-1	3006322		
3209	310	3006322	1997-02-19	1997-02-19 00:00:00	1997-02-19	5001	0	\N	0	0	\N	\N	0	20510	0	8331-1	3006322		
14535	1355	3006322	1998-09-25	1998-09-25 00:00:00	1998-09-25	5001	0	\N	0	0	\N	\N	0	89798	0	8331-1	3006322		
14609	1356	3023430	1998-08-27	1998-08-27 00:00:00	1998-08-27	5001	0	\N	0	0	\N	\N	0	89944	0	6833-8	3023430		
25999	2392	3011505	1951-10-12	1951-10-12 00:00:00	1951-10-12	5001	0	\N	0	0	\N	\N	0	158998	0	19926-5	3011505		
28827	2666	3006322	1961-11-20	1961-11-20 00:00:00	1961-11-20	5001	0	\N	0	0	\N	\N	0	176605	0	8331-1	3006322		
30417	2782	3006322	1957-08-10	1957-08-10 00:00:00	1957-08-10	5001	0	\N	0	0	\N	\N	0	184420	0	8331-1	3006322		
91936	2833	4052083	1947-06-15	1947-06-15 00:00:00	1947-06-15	5001	0	\N	0	0	\N	\N	0	188034	0	23426006	4052083		
48869	4472	3006322	1978-06-18	1978-06-18 00:00:00	1978-06-18	5001	0	\N	0	0	\N	\N	0	297485	0	8331-1	3006322		
28018	2576	40758406	1980-12-07	1980-12-07 00:00:00	1980-12-07	5001	0	\N	0	0	\N	\N	0	170551	0	55277-8	40758406		
147648	4526	4024958	2006-06-26	2006-06-26 00:00:00	2006-06-26	5001	0	\N	0	0	\N	\N	0	301333	0	117015009	4024958		
46061	4246	40758406	1977-04-24	1977-04-24 00:00:00	1977-04-24	5001	0	\N	0	0	\N	\N	0	281921	0	55277-8	40758406		
50841	4637	3006322	1993-06-28	1993-06-28 00:00:00	1993-06-28	5001	0	\N	0	0	\N	\N	0	309016	0	8331-1	3006322		
57530	5284	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	351596	0	6273-7	3006451		
35976	3311	3012494	1993-10-01	1993-10-01 00:00:00	1993-10-01	5001	0	\N	0	0	\N	\N	0	219768	0	6206-7	3012494		
28793	2661	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	176331	0	6273-7	3006451		
36304	3337	3051031	1971-08-08	1971-08-08 00:00:00	1971-08-08	5001	0	\N	0	0	\N	\N	0	221386	0	46240-8	3051031		
19443	1776	21494966	1984-10-13	1984-10-13 00:00:00	1984-10-13	5001	0	\N	0	0	\N	\N	0	118804	0	80271-0	21494966		
40261	3745	3011505	2003-07-23	2003-07-23 00:00:00	2003-07-23	5001	0	\N	0	0	\N	\N	0	248972	0	19926-5	3011505		
51614	4724	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	314797	0	6246-3	3021226		
51711	4739	3051031	1920-01-24	1920-01-24 00:00:00	1920-01-24	5001	0	\N	0	0	\N	\N	0	315750	0	46240-8	3051031		
38684	1206	4052083	2001-02-12	2001-02-12 00:00:00	2001-02-12	5001	0	\N	0	0	\N	\N	0	79238	0	23426006	4052083		
42407	3916	3020655	1995-04-12	1995-04-12 00:00:00	1995-04-12	5001	0	\N	0	0	\N	\N	0	260286	0	6844-5	3020655		
42941	3966	3006322	1989-11-02	1989-11-02 00:00:00	1989-11-02	5001	0	\N	0	0	\N	\N	0	263634	0	8331-1	3006322		
54283	4964	3006322	1980-05-11	1980-05-11 00:00:00	1980-05-11	5001	0	\N	0	0	\N	\N	0	330005	0	8331-1	3006322		
54367	4971	3006322	1954-07-07	1954-07-07 00:00:00	1954-07-07	5001	0	\N	0	0	\N	\N	0	330649	0	8331-1	3006322		
21229	1964	3006322	2004-08-08	2004-08-08 00:00:00	2004-08-08	5001	0	\N	0	0	\N	\N	0	130556	0	8331-1	3006322		
7535	723	3006322	2018-02-20	2018-02-20 00:00:00	2018-02-20	5001	0	\N	0	0	\N	\N	0	47837	0	8331-1	3006322		
7605	728	3006322	1966-04-10	1966-04-10 00:00:00	1966-04-10	5001	0	\N	0	0	\N	\N	0	48331	0	8331-1	3006322		
67843	2077	4024958	1961-05-31	1961-05-31 00:00:00	1961-05-31	5001	0	\N	0	0	\N	\N	0	138283	0	117015009	4024958		
168386	5169	4052083	1984-11-25	1984-11-25 00:00:00	1984-11-25	5001	0	\N	0	0	\N	\N	0	343690	0	23426006	4052083		
7007	675	3006322	1996-09-10	1996-09-10 00:00:00	1996-09-10	5001	0	\N	0	0	\N	\N	0	44604	0	8331-1	3006322		
7539	239	4024958	1970-06-17	1970-06-17 00:00:00	1970-06-17	5001	0	\N	0	0	\N	\N	0	16035	0	117015009	4024958		
44856	1378	4133840	2012-10-23	2012-10-23 00:00:00	2012-10-23	5001	0	\N	0	0	\N	\N	0	91443	0	127783003	4133840		
44912	1379	4133840	2007-02-24	2007-02-24 00:00:00	2007-02-24	5001	0	\N	0	0	\N	\N	0	91507	0	127783003	4133840		
46197	1409	4024958	1939-06-29	1939-06-29 00:00:00	1939-06-29	5001	0	\N	0	0	\N	\N	0	93819	0	117015009	4024958		
7743	246	4133840	2014-05-22	2014-05-22 00:00:00	2014-05-22	5001	0	\N	0	0	\N	\N	0	16516	0	127783003	4133840		
39025	1214	4024958	1952-09-25	1952-09-25 00:00:00	1952-09-25	5001	0	\N	0	0	\N	\N	0	79995	0	117015009	4024958		
43413	1335	4024958	1983-07-14	1983-07-14 00:00:00	1983-07-14	5001	0	\N	0	0	\N	\N	0	88605	0	117015009	4024958		
57792	1762	4133840	1993-03-11	1993-03-11 00:00:00	1993-03-11	5001	0	\N	0	0	\N	\N	0	117843	0	127783003	4133840		
98651	3020	4133840	2005-09-14	2005-09-14 00:00:00	2005-09-14	5001	0	\N	0	0	\N	\N	0	201403	0	127783003	4133840		
25867	2381	3006322	1942-10-09	1942-10-09 00:00:00	1942-10-09	5001	0	\N	0	0	\N	\N	0	158285	0	8331-1	3006322		
37241	3434	3006322	1961-08-16	1961-08-16 00:00:00	1961-08-16	5001	0	\N	0	0	\N	\N	0	227687	0	8331-1	3006322		
23969	752	4052083	2017-12-01	2017-12-01 00:00:00	2017-12-01	5001	0	\N	0	0	\N	\N	0	49683	0	23426006	4052083		
9882	939	3006322	1980-09-19	1980-09-19 00:00:00	1980-09-19	5001	0	\N	0	0	\N	\N	0	62464	0	8331-1	3006322		
9956	949	3011505	2008-11-03	2008-11-03 00:00:00	2008-11-03	5001	0	\N	0	0	\N	\N	0	63055	0	19926-5	3011505		
22570	2070	3036780	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	137655	0	6095-4	3036780		
50733	4626	3006322	1990-09-18	1990-09-18 00:00:00	1990-09-18	5001	0	\N	0	0	\N	\N	0	308233	0	8331-1	3006322		
4831	461	3006322	1954-07-15	1954-07-15 00:00:00	1954-07-15	5001	0	\N	0	0	\N	\N	0	30806	0	8331-1	3006322		
16144	1475	3006322	1959-12-06	1959-12-06 00:00:00	1959-12-06	5001	0	\N	0	0	\N	\N	0	98217	0	8331-1	3006322		
34188	3117	3051031	2001-11-22	2001-11-22 00:00:00	2001-11-22	5001	0	\N	0	0	\N	\N	0	207388	0	46240-8	3051031		
45580	4205	3019406	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	279161	0	6158-0	3019406		
27306	2534	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	167435	0	6276-0	3027231		
24919	2286	3006322	1972-04-17	1972-04-17 00:00:00	1972-04-17	5001	0	\N	0	0	\N	\N	0	152076	0	8331-1	3006322		
24961	2291	3006322	2011-10-02	2011-10-02 00:00:00	2011-10-02	5001	0	\N	0	0	\N	\N	0	152506	0	8331-1	3006322		
55887	1703	4024958	1961-08-22	1961-08-22 00:00:00	1961-08-22	5001	0	\N	0	0	\N	\N	0	113921	0	117015009	4024958		
37219	3430	3011505	1989-03-04	1989-03-04 00:00:00	1989-03-04	5001	0	\N	0	0	\N	\N	0	227354	0	19926-5	3011505		
95147	2921	4133840	2014-11-04	2014-11-04 00:00:00	2014-11-04	5001	0	\N	0	0	\N	\N	0	194762	0	127783003	4133840		
3237	97	4133840	1996-08-05	1996-08-05 00:00:00	1996-08-05	5001	0	\N	0	0	\N	\N	0	6661	0	127783003	4133840		
4156	411	3006451	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	27261	0	6273-7	3006451		
4264	419	40766240	1913-03-26	1913-03-26 00:00:00	1913-03-26	5001	0	\N	0	0	\N	\N	0	27715	0	63513-6	40766240		
8631	826	3006322	2006-04-05	2006-04-05 00:00:00	2006-04-05	5001	0	\N	0	0	\N	\N	0	54700	0	8331-1	3006322		
37858	3494	3011505	2016-11-17	2016-11-17 00:00:00	2016-11-17	5001	0	\N	0	0	\N	\N	0	231738	0	19926-5	3011505		
20063	1843	3015076	1994-08-24	1994-08-24 00:00:00	1994-08-24	5001	0	\N	0	0	\N	\N	0	123018	0	6248-9	3015076		
31797	2902	3006322	1986-03-17	1986-03-17 00:00:00	1986-03-17	5001	0	\N	0	0	\N	\N	0	193274	0	8331-1	3006322		
3210	310	3006322	1998-01-28	1998-01-28 00:00:00	1998-01-28	5001	0	\N	0	0	\N	\N	0	20508	0	8331-1	3006322		
14536	1355	3051031	1965-10-07	1965-10-07 00:00:00	1965-10-07	5001	0	\N	0	0	\N	\N	0	89781	0	46240-8	3051031		
14610	1356	3006734	1998-08-27	1998-08-27 00:00:00	1998-08-27	5001	0	\N	0	0	\N	\N	0	89944	0	6189-5	3006734		
26000	2392	3011505	1974-03-15	1974-03-15 00:00:00	1974-03-15	5001	0	\N	0	0	\N	\N	0	159075	0	19926-5	3011505		
28828	2666	3006322	2000-06-08	2000-06-08 00:00:00	2000-06-08	5001	0	\N	0	0	\N	\N	0	176649	0	8331-1	3006322		
30418	2782	3049273	2000-03-22	2000-03-22 00:00:00	2000-03-22	5001	0	\N	0	0	\N	\N	0	184397	0	38265-5	3049273		
66529	2041	4024958	1968-04-18	1968-04-18 00:00:00	1968-04-18	5001	0	\N	0	0	\N	\N	0	135865	0	117015009	4024958		
48870	4472	3006322	1958-09-25	1958-09-25 00:00:00	1958-09-25	5001	0	\N	0	0	\N	\N	0	297493	0	8331-1	3006322		
28019	2576	46235214	1980-12-07	1980-12-07 00:00:00	1980-12-07	5001	0	\N	0	0	\N	\N	0	170551	0	76690-7	46235214		
147659	4526	4052083	1962-10-23	1962-10-23 00:00:00	1962-10-23	5001	0	\N	0	0	\N	\N	0	301351	0	23426006	4052083		
46064	4246	40766240	1977-04-24	1977-04-24 00:00:00	1977-04-24	5001	0	\N	0	0	\N	\N	0	281921	0	63513-6	40766240		
159112	4890	4052083	1980-05-26	1980-05-26 00:00:00	1980-05-26	5001	0	\N	0	0	\N	\N	0	325201	0	23426006	4052083		
57531	5284	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	351596	0	6106-9	3014599		
35977	3311	3019406	1993-10-01	1993-10-01 00:00:00	1993-10-01	5001	0	\N	0	0	\N	\N	0	219768	0	6158-0	3019406		
28794	2661	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	176331	0	6206-7	3012494		
36305	3337	40758406	1971-08-08	1971-08-08 00:00:00	1971-08-08	5001	0	\N	0	0	\N	\N	0	221386	0	55277-8	40758406		
19444	1776	3014576	1984-10-13	1984-10-13 00:00:00	1984-10-13	5001	0	\N	0	0	\N	\N	0	118804	0	2075-0	3014576		
40262	3745	3006322	1941-07-30	1941-07-30 00:00:00	1941-07-30	5001	0	\N	0	0	\N	\N	0	248954	0	8331-1	3006322		
51615	4724	40769194	1942-03-16	1942-03-16 00:00:00	1942-03-16	5001	0	\N	0	0	\N	\N	0	314737	0	66534-9	40769194		
51714	4739	46235214	1920-01-24	1920-01-24 00:00:00	1920-01-24	5001	0	\N	0	0	\N	\N	0	315750	0	76690-7	46235214		
38691	1206	4052083	1998-07-19	1998-07-19 00:00:00	1998-07-19	5001	0	\N	0	0	\N	\N	0	79232	0	23426006	4052083		
42408	3916	3001488	1995-04-12	1995-04-12 00:00:00	1995-04-12	5001	0	\N	0	0	\N	\N	0	260286	0	7258-7	3001488		
42942	3966	3006322	1976-03-19	1976-03-19 00:00:00	1976-03-19	5001	0	\N	0	0	\N	\N	0	263631	0	8331-1	3006322		
54284	4964	3006322	1990-08-29	1990-08-29 00:00:00	1990-08-29	5001	0	\N	0	0	\N	\N	0	330007	0	8331-1	3006322		
54368	4971	3011505	2006-01-03	2006-01-03 00:00:00	2006-01-03	5001	0	\N	0	0	\N	\N	0	330658	0	19926-5	3011505		
21230	1965	3006322	2009-06-16	2009-06-16 00:00:00	2009-06-16	5001	0	\N	0	0	\N	\N	0	130646	0	8331-1	3006322		
7536	723	3006322	2011-10-29	2011-10-29 00:00:00	2011-10-29	5001	0	\N	0	0	\N	\N	0	47807	0	8331-1	3006322		
7606	728	3006322	2003-10-13	2003-10-13 00:00:00	2003-10-13	5001	0	\N	0	0	\N	\N	0	48344	0	8331-1	3006322		
56697	1729	4052083	1985-07-28	1985-07-28 00:00:00	1985-07-28	5001	0	\N	0	0	\N	\N	0	115643	0	23426006	4052083		
168397	5169	4052083	1977-12-24	1977-12-24 00:00:00	1977-12-24	5001	0	\N	0	0	\N	\N	0	343730	0	23426006	4052083		
7008	675	3000963	1981-02-08	1981-02-08 00:00:00	1981-02-08	5001	0	\N	0	0	\N	\N	0	44708	0	718-7	3000963		
7564	239	4052083	1988-09-01	1988-09-01 00:00:00	1988-09-01	5001	0	\N	0	0	\N	\N	0	16059	0	23426006	4052083		
44861	1378	4133840	2003-03-11	2003-03-11 00:00:00	2003-03-11	5001	0	\N	0	0	\N	\N	0	91351	0	127783003	4133840		
44915	1379	4024958	1964-09-09	1964-09-09 00:00:00	1964-09-09	5001	0	\N	0	0	\N	\N	0	91490	0	117015009	4024958		
46204	1409	4052083	1931-10-14	1931-10-14 00:00:00	1931-10-14	5001	0	\N	0	0	\N	\N	0	93817	0	23426006	4052083		
7744	246	4133840	2016-06-02	2016-06-02 00:00:00	2016-06-02	5001	0	\N	0	0	\N	\N	0	16573	0	127783003	4133840		
39028	1214	4052083	1993-05-19	1993-05-19 00:00:00	1993-05-19	5001	0	\N	0	0	\N	\N	0	79906	0	23426006	4052083		
43414	1335	4024958	2010-03-20	2010-03-20 00:00:00	2010-03-20	5001	0	\N	0	0	\N	\N	0	88560	0	117015009	4024958		
57795	1762	4133840	2011-03-24	2011-03-24 00:00:00	2011-03-24	5001	0	\N	0	0	\N	\N	0	117822	0	127783003	4133840		
98654	3020	4133840	2013-02-06	2013-02-06 00:00:00	2013-02-06	5001	0	\N	0	0	\N	\N	0	201376	0	127783003	4133840		
25868	2381	3006322	1980-09-17	1980-09-17 00:00:00	1980-09-17	5001	0	\N	0	0	\N	\N	0	158297	0	8331-1	3006322		
37242	3434	3006322	1964-04-05	1964-04-05 00:00:00	1964-04-05	5001	0	\N	0	0	\N	\N	0	227695	0	8331-1	3006322		
23973	752	4024958	1985-11-21	1985-11-21 00:00:00	1985-11-21	5001	0	\N	0	0	\N	\N	0	49655	0	117015009	4024958		
9883	939	3006322	2004-02-08	2004-02-08 00:00:00	2004-02-08	5001	0	\N	0	0	\N	\N	0	62468	0	8331-1	3006322		
9957	949	3011505	1996-03-25	1996-03-25 00:00:00	1996-03-25	5001	0	\N	0	0	\N	\N	0	63038	0	19926-5	3011505		
22571	2070	3021226	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	137655	0	6246-3	3021226		
50734	4626	40769189	1997-11-07	1997-11-07 00:00:00	1997-11-07	5001	0	\N	0	0	\N	\N	0	308178	0	66529-9	40769189		
4832	461	3006322	2015-11-05	2015-11-05 00:00:00	2015-11-05	5001	0	\N	0	0	\N	\N	0	30818	0	8331-1	3006322		
16145	1475	3006322	1934-11-23	1934-11-23 00:00:00	1934-11-23	5001	0	\N	0	0	\N	\N	0	98215	0	8331-1	3006322		
45467	4200	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	278741	0	6833-8	3023430		
45581	4205	3015076	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	279161	0	6248-9	3015076		
27307	2534	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	167435	0	6095-4	3036780		
24921	2287	3049273	2014-01-22	2014-01-22 00:00:00	2014-01-22	5001	0	\N	0	0	\N	\N	0	152153	0	38265-5	3049273		
24962	2291	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	152470	0	6095-4	3036780		
55891	1703	4024958	1995-09-06	1995-09-06 00:00:00	1995-09-06	5001	0	\N	0	0	\N	\N	0	113863	0	117015009	4024958		
37220	3430	3011505	2015-05-02	2015-05-02 00:00:00	2015-05-02	5001	0	\N	0	0	\N	\N	0	227356	0	19926-5	3011505		
95150	2921	4133840	1990-06-19	1990-06-19 00:00:00	1990-06-19	5001	0	\N	0	0	\N	\N	0	194757	0	127783003	4133840		
3238	97	4133840	1994-07-25	1994-07-25 00:00:00	1994-07-25	5001	0	\N	0	0	\N	\N	0	6609	0	127783003	4133840		
4157	411	3014599	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	27261	0	6106-9	3014599		
4266	419	46235214	1913-03-26	1913-03-26 00:00:00	1913-03-26	5001	0	\N	0	0	\N	\N	0	27715	0	76690-7	46235214		
8632	826	3006322	2019-01-07	2019-01-07 00:00:00	2019-01-07	5001	0	\N	0	0	\N	\N	0	54707	0	8331-1	3006322		
37859	3494	3011505	2003-07-17	2003-07-17 00:00:00	2003-07-17	5001	0	\N	0	0	\N	\N	0	231762	0	19926-5	3011505		
20064	1843	3027231	1994-08-24	1994-08-24 00:00:00	1994-08-24	5001	0	\N	0	0	\N	\N	0	123018	0	6276-0	3027231		
31798	2902	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	193380	0	6833-8	3023430		
3211	310	3006322	1976-11-25	1976-11-25 00:00:00	1976-11-25	5001	0	\N	0	0	\N	\N	0	20505	0	8331-1	3006322		
14537	1355	46235214	1965-10-07	1965-10-07 00:00:00	1965-10-07	5001	0	\N	0	0	\N	\N	0	89781	0	76690-7	46235214		
14611	1356	3005136	1998-08-27	1998-08-27 00:00:00	1998-08-27	5001	0	\N	0	0	\N	\N	0	89944	0	6075-6	3005136		
26001	2392	3011505	1989-03-31	1989-03-31 00:00:00	1989-03-31	5001	0	\N	0	0	\N	\N	0	159005	0	19926-5	3011505		
28835	2669	40758406	1979-05-02	1979-05-02 00:00:00	1979-05-02	5001	0	\N	0	0	\N	\N	0	176782	0	55277-8	40758406		
30419	2782	3006322	1922-02-08	1922-02-08 00:00:00	1922-02-08	5001	0	\N	0	0	\N	\N	0	184439	0	8331-1	3006322		
66543	2041	4024958	1974-05-31	1974-05-31 00:00:00	1974-05-31	5001	0	\N	0	0	\N	\N	0	135789	0	117015009	4024958		
48871	4472	3006322	1971-05-14	1971-05-14 00:00:00	1971-05-14	5001	0	\N	0	0	\N	\N	0	297495	0	8331-1	3006322		
28022	2576	3051031	1980-12-07	1980-12-07 00:00:00	1980-12-07	5001	0	\N	0	0	\N	\N	0	170551	0	46240-8	3051031		
147665	4526	4052083	1989-02-04	1989-02-04 00:00:00	1989-02-04	5001	0	\N	0	0	\N	\N	0	301380	0	23426006	4052083		
46065	4246	46235214	1977-04-24	1977-04-24 00:00:00	1977-04-24	5001	0	\N	0	0	\N	\N	0	281921	0	76690-7	46235214		
170418	5228	4024958	1956-09-30	1956-09-30 00:00:00	1956-09-30	5001	0	\N	0	0	\N	\N	0	347784	0	117015009	4024958		
57532	5284	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	351596	0	6248-9	3015076		
35978	3311	3006451	1993-10-01	1993-10-01 00:00:00	1993-10-01	5001	0	\N	0	0	\N	\N	0	219768	0	6273-7	3006451		
28795	2661	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	176385	0	7258-7	3001488		
36306	3337	40766240	1971-08-08	1971-08-08 00:00:00	1971-08-08	5001	0	\N	0	0	\N	\N	0	221386	0	63513-6	40766240		
19445	1776	3035995	1984-10-13	1984-10-13 00:00:00	1984-10-13	5001	0	\N	0	0	\N	\N	0	118804	0	6768-6	3035995		
40263	3746	3006322	1969-06-11	1969-06-11 00:00:00	1969-06-11	5001	0	\N	0	0	\N	\N	0	248984	0	8331-1	3006322		
51616	4724	40769184	1942-03-16	1942-03-16 00:00:00	1942-03-16	5001	0	\N	0	0	\N	\N	0	314737	0	66524-0	40769184		
51715	4739	40758406	1920-01-24	1920-01-24 00:00:00	1920-01-24	5001	0	\N	0	0	\N	\N	0	315750	0	55277-8	40758406		
38694	1206	4024958	1995-05-02	1995-05-02 00:00:00	1995-05-02	5001	0	\N	0	0	\N	\N	0	79249	0	117015009	4024958		
42409	3916	3036780	1995-04-12	1995-04-12 00:00:00	1995-04-12	5001	0	\N	0	0	\N	\N	0	260286	0	6095-4	3036780		
42943	3966	3006322	1968-12-30	1968-12-30 00:00:00	1968-12-30	5001	0	\N	0	0	\N	\N	0	263709	0	8331-1	3006322		
54285	4964	3006322	1966-09-12	1966-09-12 00:00:00	1966-09-12	5001	0	\N	0	0	\N	\N	0	330004	0	8331-1	3006322		
54369	4971	3011505	2018-04-03	2018-04-03 00:00:00	2018-04-03	5001	0	\N	0	0	\N	\N	0	330661	0	19926-5	3011505		
21231	1965	3006322	1974-05-26	1974-05-26 00:00:00	1974-05-26	5001	0	\N	0	0	\N	\N	0	130651	0	8331-1	3006322		
7537	723	3006322	2011-08-17	2011-08-17 00:00:00	2011-08-17	5001	0	\N	0	0	\N	\N	0	47845	0	8331-1	3006322		
7607	728	3006322	1997-06-30	1997-06-30 00:00:00	1997-06-30	5001	0	\N	0	0	\N	\N	0	48333	0	8331-1	3006322		
32734	2966	3000876	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	198088	0	6082-2	3000876		
168398	5169	4024958	1997-01-28	1997-01-28 00:00:00	1997-01-28	5001	0	\N	0	0	\N	\N	0	343691	0	117015009	4024958		
7009	675	3009542	1981-02-08	1981-02-08 00:00:00	1981-02-08	5001	0	\N	0	0	\N	\N	0	44708	0	20570-8	3009542		
6410	603	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	39910	0	6844-5	3020655		
44867	1378	4133840	2001-02-27	2001-02-27 00:00:00	2001-02-27	5001	0	\N	0	0	\N	\N	0	91309	0	127783003	4133840		
44916	1379	4133840	2000-08-12	2000-08-12 00:00:00	2000-08-12	5001	0	\N	0	0	\N	\N	0	91449	0	127783003	4133840		
17892	1626	3011505	2009-11-15	2009-11-15 00:00:00	2009-11-15	5001	0	\N	0	0	\N	\N	0	109227	0	19926-5	3011505		
7747	246	4024958	1984-12-03	1984-12-03 00:00:00	1984-12-03	5001	0	\N	0	0	\N	\N	0	16589	0	117015009	4024958		
39031	1214	4024958	1942-12-27	1942-12-27 00:00:00	1942-12-27	5001	0	\N	0	0	\N	\N	0	79993	0	117015009	4024958		
43416	1335	4024958	1982-02-04	1982-02-04 00:00:00	1982-02-04	5001	0	\N	0	0	\N	\N	0	88561	0	117015009	4024958		
57800	1762	4133840	2005-02-17	2005-02-17 00:00:00	2005-02-17	5001	0	\N	0	0	\N	\N	0	117829	0	127783003	4133840		
98656	3020	4133840	2005-01-26	2005-01-26 00:00:00	2005-01-26	5001	0	\N	0	0	\N	\N	0	201402	0	127783003	4133840		
25869	2381	3006322	1945-12-16	1945-12-16 00:00:00	1945-12-16	5001	0	\N	0	0	\N	\N	0	158292	0	8331-1	3006322		
37243	3434	3006322	1989-09-29	1989-09-29 00:00:00	1989-09-29	5001	0	\N	0	0	\N	\N	0	227691	0	8331-1	3006322		
23978	752	4024958	1983-11-22	1983-11-22 00:00:00	1983-11-22	5001	0	\N	0	0	\N	\N	0	49678	0	117015009	4024958		
9884	940	3006322	1971-07-11	1971-07-11 00:00:00	1971-07-11	5001	0	\N	0	0	\N	\N	0	62492	0	8331-1	3006322		
9958	949	3011505	2005-10-24	2005-10-24 00:00:00	2005-10-24	5001	0	\N	0	0	\N	\N	0	62999	0	19926-5	3011505		
22572	2070	3006451	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	137655	0	6273-7	3006451		
50735	4626	40769179	1997-11-07	1997-11-07 00:00:00	1997-11-07	5001	0	\N	0	0	\N	\N	0	308178	0	66519-0	40769179		
4833	462	3006322	1999-02-20	1999-02-20 00:00:00	1999-02-20	5001	0	\N	0	0	\N	\N	0	30892	0	8331-1	3006322		
16146	1475	3049273	2005-02-17	2005-02-17 00:00:00	2005-02-17	5001	0	\N	0	0	\N	\N	0	98302	0	38265-5	3049273		
45468	4200	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	278741	0	6273-7	3006451		
45582	4205	3005136	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	279161	0	6075-6	3005136		
27308	2534	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	167435	0	6248-9	3015076		
24922	2287	3006322	1999-01-24	1999-01-24 00:00:00	1999-01-24	5001	0	\N	0	0	\N	\N	0	152120	0	8331-1	3006322		
24963	2291	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	152470	0	6206-7	3012494		
147745	4529	4133840	2015-11-29	2015-11-29 00:00:00	2015-11-29	5001	0	\N	0	0	\N	\N	0	301558	0	127783003	4133840		
37221	3430	3011505	2016-05-07	2016-05-07 00:00:00	2016-05-07	5001	0	\N	0	0	\N	\N	0	227373	0	19926-5	3011505		
95152	2921	4133840	2015-11-10	2015-11-10 00:00:00	2015-11-10	5001	0	\N	0	0	\N	\N	0	194751	0	127783003	4133840		
3240	97	4024958	1943-09-19	1943-09-19 00:00:00	1943-09-19	5001	0	\N	0	0	\N	\N	0	6575	0	117015009	4024958		
4158	411	3019406	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	27261	0	6158-0	3019406		
4268	419	3051031	1913-03-26	1913-03-26 00:00:00	1913-03-26	5001	0	\N	0	0	\N	\N	0	27715	0	46240-8	3051031		
8633	826	3006322	1998-12-30	1998-12-30 00:00:00	1998-12-30	5001	0	\N	0	0	\N	\N	0	54705	0	8331-1	3006322		
37860	3494	3011505	2010-08-05	2010-08-05 00:00:00	2010-08-05	5001	0	\N	0	0	\N	\N	0	231764	0	19926-5	3011505		
20065	1843	3001488	1994-08-24	1994-08-24 00:00:00	1994-08-24	5001	0	\N	0	0	\N	\N	0	123018	0	7258-7	3001488		
31799	2902	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	193380	0	6844-5	3020655		
3212	311	3006322	2016-07-22	2016-07-22 00:00:00	2016-07-22	5001	0	\N	0	0	\N	\N	0	20619	0	8331-1	3006322		
14540	1355	40766240	1965-10-07	1965-10-07 00:00:00	1965-10-07	5001	0	\N	0	0	\N	\N	0	89781	0	63513-6	40766240		
14612	1356	3006451	1998-08-27	1998-08-27 00:00:00	1998-08-27	5001	0	\N	0	0	\N	\N	0	89944	0	6273-7	3006451		
26002	2392	3011505	1986-03-14	1986-03-14 00:00:00	1986-03-14	5001	0	\N	0	0	\N	\N	0	159058	0	19926-5	3011505		
28836	2669	46235214	1979-05-02	1979-05-02 00:00:00	1979-05-02	5001	0	\N	0	0	\N	\N	0	176782	0	76690-7	46235214		
30425	2786	3006322	2014-10-21	2014-10-21 00:00:00	2014-10-21	5001	0	\N	0	0	\N	\N	0	184539	0	8331-1	3006322		
66544	2041	4024958	1992-02-13	1992-02-13 00:00:00	1992-02-13	5001	0	\N	0	0	\N	\N	0	135859	0	117015009	4024958		
48872	4472	3006322	2005-04-09	2005-04-09 00:00:00	2005-04-09	5001	0	\N	0	0	\N	\N	0	297487	0	8331-1	3006322		
28023	2576	40766240	1980-12-07	1980-12-07 00:00:00	1980-12-07	5001	0	\N	0	0	\N	\N	0	170551	0	63513-6	40766240		
147670	4527	4024958	1986-03-28	1986-03-28 00:00:00	1986-03-28	5001	0	\N	0	0	\N	\N	0	301426	0	117015009	4024958		
46066	4246	3006322	1973-05-10	1973-05-10 00:00:00	1973-05-10	5001	0	\N	0	0	\N	\N	0	281955	0	8331-1	3006322		
170419	5228	4052083	1958-08-10	1958-08-10 00:00:00	1958-08-10	5001	0	\N	0	0	\N	\N	0	347775	0	23426006	4052083		
57533	5284	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	351596	0	6158-0	3019406		
35979	3311	3027231	1993-10-01	1993-10-01 00:00:00	1993-10-01	5001	0	\N	0	0	\N	\N	0	219768	0	6276-0	3027231		
52045	4776	3006322	1999-02-11	1999-02-11 00:00:00	1999-02-11	5001	0	\N	0	0	\N	\N	0	317994	0	8331-1	3006322		
36307	3337	46235214	1971-08-08	1971-08-08 00:00:00	1971-08-08	5001	0	\N	0	0	\N	\N	0	221386	0	76690-7	46235214		
19446	1776	3027970	1984-10-13	1984-10-13 00:00:00	1984-10-13	5001	0	\N	0	0	\N	\N	0	118804	0	10834-0	3027970		
40264	3746	3049273	2014-06-12	2014-06-12 00:00:00	2014-06-12	5001	0	\N	0	0	\N	\N	0	249073	0	38265-5	3049273		
51617	4724	40769179	1942-03-16	1942-03-16 00:00:00	1942-03-16	5001	0	\N	0	0	\N	\N	0	314737	0	66519-0	40769179		
51716	4739	40766240	1920-01-24	1920-01-24 00:00:00	1920-01-24	5001	0	\N	0	0	\N	\N	0	315750	0	63513-6	40766240		
4046	126	4024958	1950-09-16	1950-09-16 00:00:00	1950-09-16	5001	0	\N	0	0	\N	\N	0	8407	0	117015009	4024958		
42410	3916	3000876	1995-04-12	1995-04-12 00:00:00	1995-04-12	5001	0	\N	0	0	\N	\N	0	260286	0	6082-2	3000876		
42944	3966	3006322	1978-08-20	1978-08-20 00:00:00	1978-08-20	5001	0	\N	0	0	\N	\N	0	263704	0	8331-1	3006322		
54286	4964	3006322	1970-04-20	1970-04-20 00:00:00	1970-04-20	5001	0	\N	0	0	\N	\N	0	329988	0	8331-1	3006322		
54370	4971	3006322	2008-10-04	2008-10-04 00:00:00	2008-10-04	5001	0	\N	0	0	\N	\N	0	330537	0	8331-1	3006322		
21232	1965	3006322	1990-04-11	1990-04-11 00:00:00	1990-04-11	5001	0	\N	0	0	\N	\N	0	130617	0	8331-1	3006322		
7538	723	3049273	2013-12-21	2013-12-21 00:00:00	2013-12-21	5001	0	\N	0	0	\N	\N	0	47822	0	38265-5	3049273		
7608	728	3006322	2015-06-28	2015-06-28 00:00:00	2015-06-28	5001	0	\N	0	0	\N	\N	0	48358	0	8331-1	3006322		
32735	2966	3006451	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	198088	0	6273-7	3006451		
168407	5169	4052083	1997-01-20	1997-01-20 00:00:00	1997-01-20	5001	0	\N	0	0	\N	\N	0	343684	0	23426006	4052083		
7010	675	3006322	2018-11-08	2018-11-08 00:00:00	2018-11-08	5001	0	\N	0	0	\N	\N	0	44611	0	8331-1	3006322		
6411	603	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	39910	0	7258-7	3001488		
44868	1378	4133840	2004-03-16	2004-03-16 00:00:00	2004-03-16	5001	0	\N	0	0	\N	\N	0	91325	0	127783003	4133840		
44917	1379	4133840	2018-04-21	2018-04-21 00:00:00	2018-04-21	5001	0	\N	0	0	\N	\N	0	91465	0	127783003	4133840		
17893	1626	3011505	2006-10-29	2006-10-29 00:00:00	2006-10-29	5001	0	\N	0	0	\N	\N	0	109219	0	19926-5	3011505		
7748	246	4133840	2000-09-07	2000-09-07 00:00:00	2000-09-07	5001	0	\N	0	0	\N	\N	0	16541	0	127783003	4133840		
39040	1214	4052083	1954-02-17	1954-02-17 00:00:00	1954-02-17	5001	0	\N	0	0	\N	\N	0	79947	0	23426006	4052083		
43430	1335	4052083	1981-07-08	1981-07-08 00:00:00	1981-07-08	5001	0	\N	0	0	\N	\N	0	88604	0	23426006	4052083		
57805	1762	4133840	2019-05-09	2019-05-09 00:00:00	2019-05-09	5001	0	\N	0	0	\N	\N	0	117860	0	127783003	4133840		
98657	3020	4133840	2010-01-20	2010-01-20 00:00:00	2010-01-20	5001	0	\N	0	0	\N	\N	0	201409	0	127783003	4133840		
25870	2381	3006322	1953-10-23	1953-10-23 00:00:00	1953-10-23	5001	0	\N	0	0	\N	\N	0	158315	0	8331-1	3006322		
37244	3435	3006322	2002-12-17	2002-12-17 00:00:00	2002-12-17	5001	0	\N	0	0	\N	\N	0	227771	0	8331-1	3006322		
35275	1099	4052083	1955-02-27	1955-02-27 00:00:00	1955-02-27	5001	0	\N	0	0	\N	\N	0	72172	0	23426006	4052083		
9885	940	3006322	1964-05-05	1964-05-05 00:00:00	1964-05-05	5001	0	\N	0	0	\N	\N	0	62538	0	8331-1	3006322		
9959	949	40758406	1959-05-16	1959-05-16 00:00:00	1959-05-16	5001	0	\N	0	0	\N	\N	0	62983	0	55277-8	40758406		
22573	2070	3006322	1988-03-20	1988-03-20 00:00:00	1988-03-20	5001	0	\N	0	0	\N	\N	0	137766	0	8331-1	3006322		
50736	4626	40769184	1997-11-07	1997-11-07 00:00:00	1997-11-07	5001	0	\N	0	0	\N	\N	0	308178	0	66524-0	40769184		
50783	4628	3005136	1986-10-24	1986-10-24 00:00:00	1986-10-24	5001	0	\N	0	0	\N	\N	0	308311	0	6075-6	3005136		
16147	1476	3006322	1992-08-02	1992-08-02 00:00:00	1992-08-02	5001	0	\N	0	0	\N	\N	0	98379	0	8331-1	3006322		
45469	4200	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	278741	0	6248-9	3015076		
45583	4205	3014599	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	279161	0	6106-9	3014599		
27309	2534	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	167435	0	6075-6	3005136		
24923	2287	3006322	2000-08-01	2000-08-01 00:00:00	2000-08-01	5001	0	\N	0	0	\N	\N	0	152134	0	8331-1	3006322		
24964	2291	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	152470	0	6075-6	3005136		
147747	4529	4133840	2018-12-16	2018-12-16 00:00:00	2018-12-16	5001	0	\N	0	0	\N	\N	0	301581	0	127783003	4133840		
37222	3431	3006322	1987-01-24	1987-01-24 00:00:00	1987-01-24	5001	0	\N	0	0	\N	\N	0	227471	0	8331-1	3006322		
95155	2921	4133840	2006-09-19	2006-09-19 00:00:00	2006-09-19	5001	0	\N	0	0	\N	\N	0	194749	0	127783003	4133840		
3242	97	4133840	2001-05-21	2001-05-21 00:00:00	2001-05-21	5001	0	\N	0	0	\N	\N	0	6628	0	127783003	4133840		
4159	411	3000876	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	27261	0	6082-2	3000876		
4271	419	3049273	1992-04-12	1992-04-12 00:00:00	1992-04-12	5001	0	\N	0	0	\N	\N	0	27774	0	38265-5	3049273		
8635	828	3006322	1956-04-06	1956-04-06 00:00:00	1956-04-06	5001	0	\N	0	0	\N	\N	0	54813	0	8331-1	3006322		
37861	3494	3011505	2013-10-31	2013-10-31 00:00:00	2013-10-31	5001	0	\N	0	0	\N	\N	0	231765	0	19926-5	3011505		
20066	1843	3023430	1994-08-24	1994-08-24 00:00:00	1994-08-24	5001	0	\N	0	0	\N	\N	0	123018	0	6833-8	3023430		
31800	2902	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	193380	0	6075-6	3005136		
3213	311	3006322	1980-09-10	1980-09-10 00:00:00	1980-09-10	5001	0	\N	0	0	\N	\N	0	20583	0	8331-1	3006322		
14541	1355	40758406	1965-10-07	1965-10-07 00:00:00	1965-10-07	5001	0	\N	0	0	\N	\N	0	89781	0	55277-8	40758406		
14613	1356	3027231	1998-08-27	1998-08-27 00:00:00	1998-08-27	5001	0	\N	0	0	\N	\N	0	89944	0	6276-0	3027231		
26003	2392	3049273	1986-03-14	1986-03-14 00:00:00	1986-03-14	5001	0	\N	0	0	\N	\N	0	159058	0	38265-5	3049273		
28838	2669	40766240	1979-05-02	1979-05-02 00:00:00	1979-05-02	5001	0	\N	0	0	\N	\N	0	176782	0	63513-6	40766240		
30429	2786	3049273	1993-08-21	1993-08-21 00:00:00	1993-08-21	5001	0	\N	0	0	\N	\N	0	184659	0	38265-5	3049273		
66573	2043	4024958	1978-10-21	1978-10-21 00:00:00	1978-10-21	5001	0	\N	0	0	\N	\N	0	135873	0	117015009	4024958		
48873	4473	3006322	1979-02-14	1979-02-14 00:00:00	1979-02-14	5001	0	\N	0	0	\N	\N	0	297586	0	8331-1	3006322		
28024	2576	3006322	1982-01-28	1982-01-28 00:00:00	1982-01-28	5001	0	\N	0	0	\N	\N	0	170538	0	8331-1	3006322		
147671	4527	4052083	1963-08-26	1963-08-26 00:00:00	1963-08-26	5001	0	\N	0	0	\N	\N	0	301420	0	23426006	4052083		
46067	4247	3006322	1995-07-16	1995-07-16 00:00:00	1995-07-16	5001	0	\N	0	0	\N	\N	0	282100	0	8331-1	3006322		
170440	5228	4052083	1949-03-10	1949-03-10 00:00:00	1949-03-10	5001	0	\N	0	0	\N	\N	0	347778	0	23426006	4052083		
57534	5284	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	351596	0	6075-6	3005136		
47270	4355	3006322	2002-02-28	2002-02-28 00:00:00	2002-02-28	5001	0	\N	0	0	\N	\N	0	288993	0	8331-1	3006322		
52046	4776	3006322	1988-10-21	1988-10-21 00:00:00	1988-10-21	5001	0	\N	0	0	\N	\N	0	318006	0	8331-1	3006322		
36309	3337	3006322	1972-03-28	1972-03-28 00:00:00	1972-03-28	5001	0	\N	0	0	\N	\N	0	221420	0	8331-1	3006322		
19447	1776	3009542	1984-10-13	1984-10-13 00:00:00	1984-10-13	5001	0	\N	0	0	\N	\N	0	118804	0	20570-8	3009542		
40265	3746	3006322	1990-02-17	1990-02-17 00:00:00	1990-02-17	5001	0	\N	0	0	\N	\N	0	249043	0	8331-1	3006322		
51618	4724	40769189	1942-03-16	1942-03-16 00:00:00	1942-03-16	5001	0	\N	0	0	\N	\N	0	314737	0	66529-9	40769189		
51717	4739	3006322	1916-10-22	1916-10-22 00:00:00	1916-10-22	5001	0	\N	0	0	\N	\N	0	315749	0	8331-1	3006322		
4073	126	4052083	1978-11-07	1978-11-07 00:00:00	1978-11-07	5001	0	\N	0	0	\N	\N	0	8460	0	23426006	4052083		
42411	3916	3036780	1979-04-17	1979-04-17 00:00:00	1979-04-17	5001	0	\N	0	0	\N	\N	0	260278	0	6095-4	3036780		
42945	3967	3006322	1994-12-14	1994-12-14 00:00:00	1994-12-14	5001	0	\N	0	0	\N	\N	0	263765	0	8331-1	3006322		
54287	4964	3006322	2000-05-31	2000-05-31 00:00:00	2000-05-31	5001	0	\N	0	0	\N	\N	0	329986	0	8331-1	3006322		
54371	4971	3006322	1995-08-18	1995-08-18 00:00:00	1995-08-18	5001	0	\N	0	0	\N	\N	0	330654	0	8331-1	3006322		
21233	1966	3006322	1992-09-19	1992-09-19 00:00:00	1992-09-19	5001	0	\N	0	0	\N	\N	0	130717	0	8331-1	3006322		
7539	723	3006322	2014-02-25	2014-02-25 00:00:00	2014-02-25	5001	0	\N	0	0	\N	\N	0	47836	0	8331-1	3006322		
7609	729	3006322	2014-07-30	2014-07-30 00:00:00	2014-07-30	5001	0	\N	0	0	\N	\N	0	48398	0	8331-1	3006322		
32736	2966	3005136	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	198088	0	6075-6	3005136		
6276	587	3006322	2004-05-08	2004-05-08 00:00:00	2004-05-08	5001	0	\N	0	0	\N	\N	0	38865	0	8331-1	3006322		
7011	675	3006322	2013-12-19	2013-12-19 00:00:00	2013-12-19	5001	0	\N	0	0	\N	\N	0	44591	0	8331-1	3006322		
6412	603	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	39910	0	6085-5	3001247		
44869	1378	4052083	1964-09-26	1964-09-26 00:00:00	1964-09-26	5001	0	\N	0	0	\N	\N	0	91293	0	23426006	4052083		
44919	1379	4024958	2002-07-05	2002-07-05 00:00:00	2002-07-05	5001	0	\N	0	0	\N	\N	0	91460	0	117015009	4024958		
17894	1626	3011505	2000-09-24	2000-09-24 00:00:00	2000-09-24	5001	0	\N	0	0	\N	\N	0	109226	0	19926-5	3011505		
7750	246	4133840	2007-04-19	2007-04-19 00:00:00	2007-04-19	5001	0	\N	0	0	\N	\N	0	16572	0	127783003	4133840		
39049	1214	4024958	2009-12-31	2009-12-31 00:00:00	2009-12-31	5001	0	\N	0	0	\N	\N	0	79926	0	117015009	4024958		
133275	4106	4024958	1986-10-03	1986-10-03 00:00:00	1986-10-03	5001	0	\N	0	0	\N	\N	0	272836	0	117015009	4024958		
57806	1762	4133840	1992-03-05	1992-03-05 00:00:00	1992-03-05	5001	0	\N	0	0	\N	\N	0	117823	0	127783003	4133840		
98660	3020	4024958	1975-08-27	1975-08-27 00:00:00	1975-08-27	5001	0	\N	0	0	\N	\N	0	201390	0	117015009	4024958		
25871	2381	3006322	1955-06-26	1955-06-26 00:00:00	1955-06-26	5001	0	\N	0	0	\N	\N	0	158316	0	8331-1	3006322		
37245	3435	3006322	2014-09-26	2014-09-26 00:00:00	2014-09-26	5001	0	\N	0	0	\N	\N	0	227778	0	8331-1	3006322		
58465	1779	4052083	2009-10-25	2009-10-25 00:00:00	2009-10-25	5001	0	\N	0	0	\N	\N	0	119000	0	23426006	4052083		
9886	940	3006322	1972-03-19	1972-03-19 00:00:00	1972-03-19	5001	0	\N	0	0	\N	\N	0	62550	0	8331-1	3006322		
9961	949	40766240	1959-05-16	1959-05-16 00:00:00	1959-05-16	5001	0	\N	0	0	\N	\N	0	62983	0	63513-6	40766240		
22574	2070	3021226	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	137700	0	6246-3	3021226		
50737	4626	40769194	1997-11-07	1997-11-07 00:00:00	1997-11-07	5001	0	\N	0	0	\N	\N	0	308178	0	66534-9	40769194		
50784	4628	3014599	1986-10-24	1986-10-24 00:00:00	1986-10-24	5001	0	\N	0	0	\N	\N	0	308311	0	6106-9	3014599		
16148	1476	3006322	1961-11-28	1961-11-28 00:00:00	1961-11-28	5001	0	\N	0	0	\N	\N	0	98537	0	8331-1	3006322		
45470	4200	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	278741	0	6276-0	3027231		
45584	4205	3006451	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	279161	0	6273-7	3006451		
27310	2534	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	167435	0	6206-7	3012494		
24924	2287	3006322	1969-09-06	1969-09-06 00:00:00	1969-09-06	5001	0	\N	0	0	\N	\N	0	152101	0	8331-1	3006322		
24965	2291	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	152470	0	6276-0	3027231		
147748	4529	4133840	2001-02-11	2001-02-11 00:00:00	2001-02-11	5001	0	\N	0	0	\N	\N	0	301563	0	127783003	4133840		
37223	3431	3006322	1993-08-31	1993-08-31 00:00:00	1993-08-31	5001	0	\N	0	0	\N	\N	0	227400	0	8331-1	3006322		
95158	2921	4133840	1994-07-12	1994-07-12 00:00:00	1994-07-12	5001	0	\N	0	0	\N	\N	0	194701	0	127783003	4133840		
3244	97	4133840	2011-07-18	2011-07-18 00:00:00	2011-07-18	5001	0	\N	0	0	\N	\N	0	6611	0	127783003	4133840		
4160	411	3005136	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	27261	0	6075-6	3005136		
4272	419	46235214	1913-07-24	1913-07-24 00:00:00	1913-07-24	5001	0	\N	0	0	\N	\N	0	27784	0	76690-7	46235214		
8636	828	3006322	1994-07-28	1994-07-28 00:00:00	1994-07-28	5001	0	\N	0	0	\N	\N	0	54843	0	8331-1	3006322		
37862	3494	3011505	2007-07-26	2007-07-26 00:00:00	2007-07-26	5001	0	\N	0	0	\N	\N	0	231753	0	19926-5	3011505		
20067	1843	3020655	1994-08-24	1994-08-24 00:00:00	1994-08-24	5001	0	\N	0	0	\N	\N	0	123018	0	6844-5	3020655		
31801	2902	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	193380	0	6248-9	3015076		
3214	311	3006322	2005-10-23	2005-10-23 00:00:00	2005-10-23	5001	0	\N	0	0	\N	\N	0	20603	0	8331-1	3006322		
14542	1355	3051031	1965-09-07	1965-09-07 00:00:00	1965-09-07	5001	0	\N	0	0	\N	\N	0	89776	0	46240-8	3051031		
14614	1356	40769194	1995-02-07	1995-02-07 00:00:00	1995-02-07	5001	0	\N	0	0	\N	\N	0	89887	0	66534-9	40769194		
26004	2392	3006322	2012-10-18	2012-10-18 00:00:00	2012-10-18	5001	0	\N	0	0	\N	\N	0	159028	0	8331-1	3006322		
28840	2669	3051031	1979-05-02	1979-05-02 00:00:00	1979-05-02	5001	0	\N	0	0	\N	\N	0	176782	0	46240-8	3051031		
30430	2786	3006322	1961-08-07	1961-08-07 00:00:00	1961-08-07	5001	0	\N	0	0	\N	\N	0	184602	0	8331-1	3006322		
66574	2043	4052083	1966-09-15	1966-09-15 00:00:00	1966-09-15	5001	0	\N	0	0	\N	\N	0	135927	0	23426006	4052083		
48874	4473	3006322	1987-01-27	1987-01-27 00:00:00	1987-01-27	5001	0	\N	0	0	\N	\N	0	297612	0	8331-1	3006322		
28025	2576	3006322	1993-09-27	1993-09-27 00:00:00	1993-09-27	5001	0	\N	0	0	\N	\N	0	170557	0	8331-1	3006322		
147675	4527	4052083	1980-05-06	1980-05-06 00:00:00	1980-05-06	5001	0	\N	0	0	\N	\N	0	301413	0	23426006	4052083		
46068	4247	3006322	2019-03-28	2019-03-28 00:00:00	2019-03-28	5001	0	\N	0	0	\N	\N	0	282077	0	8331-1	3006322		
170442	5228	4024958	2015-05-03	2015-05-03 00:00:00	2015-05-03	5001	0	\N	0	0	\N	\N	0	347856	0	117015009	4024958		
57535	5284	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	351596	0	6276-0	3027231		
47271	4355	3006322	2007-04-20	2007-04-20 00:00:00	2007-04-20	5001	0	\N	0	0	\N	\N	0	288966	0	8331-1	3006322		
52047	4777	3006322	1964-03-14	1964-03-14 00:00:00	1964-03-14	5001	0	\N	0	0	\N	\N	0	318080	0	8331-1	3006322		
36310	3337	3051031	2012-11-25	2012-11-25 00:00:00	2012-11-25	5001	0	\N	0	0	\N	\N	0	221372	0	46240-8	3051031		
19448	1776	3016723	1984-10-13	1984-10-13 00:00:00	1984-10-13	5001	0	\N	0	0	\N	\N	0	118804	0	2160-0	3016723		
40266	3746	3006322	1970-07-18	1970-07-18 00:00:00	1970-07-18	5001	0	\N	0	0	\N	\N	0	249040	0	8331-1	3006322		
51619	4725	3006451	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	314894	0	6273-7	3006451		
51718	4739	3006322	1920-08-16	1920-08-16 00:00:00	1920-08-16	5001	0	\N	0	0	\N	\N	0	315681	0	8331-1	3006322		
40677	1261	4133840	2005-07-09	2005-07-09 00:00:00	2005-07-09	5001	0	\N	0	0	\N	\N	0	83130	0	127783003	4133840		
42412	3916	3000876	1979-04-17	1979-04-17 00:00:00	1979-04-17	5001	0	\N	0	0	\N	\N	0	260278	0	6082-2	3000876		
42946	3967	3006322	1964-03-14	1964-03-14 00:00:00	1964-03-14	5001	0	\N	0	0	\N	\N	0	263766	0	8331-1	3006322		
54288	4964	3006322	1991-12-07	1991-12-07 00:00:00	1991-12-07	5001	0	\N	0	0	\N	\N	0	329991	0	8331-1	3006322		
54372	4971	3011505	2002-12-17	2002-12-17 00:00:00	2002-12-17	5001	0	\N	0	0	\N	\N	0	330504	0	19926-5	3011505		
21234	1966	3006322	1973-04-25	1973-04-25 00:00:00	1973-04-25	5001	0	\N	0	0	\N	\N	0	130671	0	8331-1	3006322		
90020	2779	4024958	1996-12-02	1996-12-02 00:00:00	1996-12-02	5001	0	\N	0	0	\N	\N	0	184164	0	117015009	4024958		
7610	729	3006322	1969-07-01	1969-07-01 00:00:00	1969-07-01	5001	0	\N	0	0	\N	\N	0	48397	0	8331-1	3006322		
32737	2966	3015076	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	198088	0	6248-9	3015076		
6277	587	3006322	2009-06-23	2009-06-23 00:00:00	2009-06-23	5001	0	\N	0	0	\N	\N	0	38891	0	8331-1	3006322		
7012	675	3006322	1959-04-06	1959-04-06 00:00:00	1959-04-06	5001	0	\N	0	0	\N	\N	0	44575	0	8331-1	3006322		
6413	603	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	39910	0	6189-5	3006734		
79405	2442	4024958	1979-12-18	1979-12-18 00:00:00	1979-12-18	5001	0	\N	0	0	\N	\N	0	162010	0	117015009	4024958		
44920	1379	4133840	2017-04-15	2017-04-15 00:00:00	2017-04-15	5001	0	\N	0	0	\N	\N	0	91524	0	127783003	4133840		
17895	1626	3011505	2001-09-30	2001-09-30 00:00:00	2001-09-30	5001	0	\N	0	0	\N	\N	0	109236	0	19926-5	3011505		
7752	246	4024958	1970-11-26	1970-11-26 00:00:00	1970-11-26	5001	0	\N	0	0	\N	\N	0	16523	0	117015009	4024958		
39050	1214	4024958	1967-09-19	1967-09-19 00:00:00	1967-09-19	5001	0	\N	0	0	\N	\N	0	79999	0	117015009	4024958		
133276	4106	4024958	2007-04-09	2007-04-09 00:00:00	2007-04-09	5001	0	\N	0	0	\N	\N	0	272787	0	117015009	4024958		
57808	1762	4133840	1981-02-05	1981-02-05 00:00:00	1981-02-05	5001	0	\N	0	0	\N	\N	0	117817	0	127783003	4133840		
98663	3020	4052083	1959-02-23	1959-02-23 00:00:00	1959-02-23	5001	0	\N	0	0	\N	\N	0	201363	0	23426006	4052083		
25872	2381	3006322	2012-11-25	2012-11-25 00:00:00	2012-11-25	5001	0	\N	0	0	\N	\N	0	158335	0	8331-1	3006322		
37246	3435	3006322	1994-02-18	1994-02-18 00:00:00	1994-02-18	5001	0	\N	0	0	\N	\N	0	227776	0	8331-1	3006322		
58486	1780	4052083	1974-08-28	1974-08-28 00:00:00	1974-08-28	5001	0	\N	0	0	\N	\N	0	119168	0	23426006	4052083		
9914	946	3006322	1967-10-30	1967-10-30 00:00:00	1967-10-30	5001	0	\N	0	0	\N	\N	0	62768	0	8331-1	3006322		
9962	949	3051031	1959-05-16	1959-05-16 00:00:00	1959-05-16	5001	0	\N	0	0	\N	\N	0	62983	0	46240-8	3051031		
22575	2070	3006451	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	137700	0	6273-7	3006451		
50738	4626	3001247	1997-11-21	1997-11-21 00:00:00	1997-11-21	5001	0	\N	0	0	\N	\N	0	308259	0	6085-5	3001247		
50785	4628	3023430	1986-10-24	1986-10-24 00:00:00	1986-10-24	5001	0	\N	0	0	\N	\N	0	308311	0	6833-8	3023430		
16149	1476	3049273	2004-12-02	2004-12-02 00:00:00	2004-12-02	5001	0	\N	0	0	\N	\N	0	98458	0	38265-5	3049273		
45471	4200	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	278741	0	6158-0	3019406		
45585	4205	3027231	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	279161	0	6276-0	3027231		
27311	2534	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	167435	0	6189-5	3006734		
24925	2287	3006322	2008-12-31	2008-12-31 00:00:00	2008-12-31	5001	0	\N	0	0	\N	\N	0	152194	0	8331-1	3006322		
24966	2291	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	152470	0	6106-9	3014599		
147749	4529	4133840	1995-02-05	1995-02-05 00:00:00	1995-02-05	5001	0	\N	0	0	\N	\N	0	301561	0	127783003	4133840		
37224	3431	3006322	1972-05-01	1972-05-01 00:00:00	1972-05-01	5001	0	\N	0	0	\N	\N	0	227458	0	8331-1	3006322		
95163	2921	4133840	2017-11-21	2017-11-21 00:00:00	2017-11-21	5001	0	\N	0	0	\N	\N	0	194752	0	127783003	4133840		
3249	97	4133840	2009-07-06	2009-07-06 00:00:00	2009-07-06	5001	0	\N	0	0	\N	\N	0	6640	0	127783003	4133840		
4161	411	3015076	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	27261	0	6248-9	3015076		
4274	419	3051031	1913-07-24	1913-07-24 00:00:00	1913-07-24	5001	0	\N	0	0	\N	\N	0	27784	0	46240-8	3051031		
8638	828	3006322	1979-06-19	1979-06-19 00:00:00	1979-06-19	5001	0	\N	0	0	\N	\N	0	54852	0	8331-1	3006322		
37863	3494	3006322	1962-02-22	1962-02-22 00:00:00	1962-02-22	5001	0	\N	0	0	\N	\N	0	231770	0	8331-1	3006322		
20068	1843	3012494	1994-08-24	1994-08-24 00:00:00	1994-08-24	5001	0	\N	0	0	\N	\N	0	123018	0	6206-7	3012494		
31802	2902	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	193380	0	6106-9	3014599		
3215	311	3006322	2016-01-11	2016-01-11 00:00:00	2016-01-11	5001	0	\N	0	0	\N	\N	0	20618	0	8331-1	3006322		
14543	1355	46235214	1965-09-07	1965-09-07 00:00:00	1965-09-07	5001	0	\N	0	0	\N	\N	0	89776	0	76690-7	46235214		
14615	1356	40769184	1995-02-07	1995-02-07 00:00:00	1995-02-07	5001	0	\N	0	0	\N	\N	0	89887	0	66524-0	40769184		
26005	2392	3011505	2002-06-14	2002-06-14 00:00:00	2002-06-14	5001	0	\N	0	0	\N	\N	0	158979	0	19926-5	3011505		
28842	2669	3051031	2011-02-18	2011-02-18 00:00:00	2011-02-18	5001	0	\N	0	0	\N	\N	0	176766	0	46240-8	3051031		
16024	499	4052083	1997-03-17	1997-03-17 00:00:00	1997-03-17	5001	0	\N	0	0	\N	\N	0	33336	0	23426006	4052083		
56124	5148	3006322	1983-12-23	1983-12-23 00:00:00	1983-12-23	5001	0	\N	0	0	\N	\N	0	342229	0	8331-1	3006322		
48875	4473	3006322	1993-06-05	1993-06-05 00:00:00	1993-06-05	5001	0	\N	0	0	\N	\N	0	297595	0	8331-1	3006322		
28026	2576	3006322	1982-04-11	1982-04-11 00:00:00	1982-04-11	5001	0	\N	0	0	\N	\N	0	170526	0	8331-1	3006322		
148482	4548	4024958	1998-01-03	1998-01-03 00:00:00	1998-01-03	5001	0	\N	0	0	\N	\N	0	302999	0	117015009	4024958		
46069	4247	3006322	2000-12-01	2000-12-01 00:00:00	2000-12-01	5001	0	\N	0	0	\N	\N	0	282021	0	8331-1	3006322		
170443	5228	4052083	1937-01-11	1937-01-11 00:00:00	1937-01-11	5001	0	\N	0	0	\N	\N	0	347777	0	23426006	4052083		
57536	5284	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	351551	0	6082-2	3000876		
47272	4355	3006322	2009-11-19	2009-11-19 00:00:00	2009-11-19	5001	0	\N	0	0	\N	\N	0	288995	0	8331-1	3006322		
52048	4777	3049273	1974-11-29	1974-11-29 00:00:00	1974-11-29	5001	0	\N	0	0	\N	\N	0	318095	0	38265-5	3049273		
36311	3337	40766240	2012-11-25	2012-11-25 00:00:00	2012-11-25	5001	0	\N	0	0	\N	\N	0	221372	0	63513-6	40766240		
19449	1776	3024561	1984-10-13	1984-10-13 00:00:00	1984-10-13	5001	0	\N	0	0	\N	\N	0	118804	0	1751-7	3024561		
40267	3746	3006322	2013-06-01	2013-06-01 00:00:00	2013-06-01	5001	0	\N	0	0	\N	\N	0	249044	0	8331-1	3006322		
51620	4725	3000876	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	314894	0	6082-2	3000876		
51719	4739	3006322	1924-04-12	1924-04-12 00:00:00	1924-04-12	5001	0	\N	0	0	\N	\N	0	315733	0	8331-1	3006322		
40690	1264	4133840	2009-10-30	2009-10-30 00:00:00	2009-10-30	5001	0	\N	0	0	\N	\N	0	83305	0	127783003	4133840		
42413	3916	3005136	1979-04-17	1979-04-17 00:00:00	1979-04-17	5001	0	\N	0	0	\N	\N	0	260278	0	6075-6	3005136		
42947	3968	3006322	1996-01-12	1996-01-12 00:00:00	1996-01-12	5001	0	\N	0	0	\N	\N	0	263928	0	8331-1	3006322		
54289	4964	3006322	1968-01-16	1968-01-16 00:00:00	1968-01-16	5001	0	\N	0	0	\N	\N	0	330031	0	8331-1	3006322		
54373	4971	3006322	2001-08-01	2001-08-01 00:00:00	2001-08-01	5001	0	\N	0	0	\N	\N	0	330655	0	8331-1	3006322		
21235	1966	3006322	1989-11-06	1989-11-06 00:00:00	1989-11-06	5001	0	\N	0	0	\N	\N	0	130715	0	8331-1	3006322		
90032	2779	4052083	1988-12-11	1988-12-11 00:00:00	1988-12-11	5001	0	\N	0	0	\N	\N	0	184094	0	23426006	4052083		
7611	729	3006322	2015-12-03	2015-12-03 00:00:00	2015-12-03	5001	0	\N	0	0	\N	\N	0	48413	0	8331-1	3006322		
32738	2966	3012494	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	198088	0	6206-7	3012494		
6278	588	3006322	2016-02-13	2016-02-13 00:00:00	2016-02-13	5001	0	\N	0	0	\N	\N	0	38936	0	8331-1	3006322		
7013	675	3006322	1968-01-31	1968-01-31 00:00:00	1968-01-31	5001	0	\N	0	0	\N	\N	0	44688	0	8331-1	3006322		
6414	603	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	39910	0	6075-6	3005136		
79419	2442	4024958	1978-05-30	1978-05-30 00:00:00	1978-05-30	5001	0	\N	0	0	\N	\N	0	161919	0	117015009	4024958		
79456	2443	4024958	2016-11-02	2016-11-02 00:00:00	2016-11-02	5001	0	\N	0	0	\N	\N	0	162061	0	117015009	4024958		
17896	1626	3011505	2002-10-06	2002-10-06 00:00:00	2002-10-06	5001	0	\N	0	0	\N	\N	0	109217	0	19926-5	3011505		
7753	246	4133840	2001-04-05	2001-04-05 00:00:00	2001-04-05	5001	0	\N	0	0	\N	\N	0	16606	0	127783003	4133840		
39058	1214	4024958	1947-02-14	1947-02-14 00:00:00	1947-02-14	5001	0	\N	0	0	\N	\N	0	79994	0	117015009	4024958		
133281	4107	4024958	1995-01-21	1995-01-21 00:00:00	1995-01-21	5001	0	\N	0	0	\N	\N	0	272890	0	117015009	4024958		
57826	1762	4133840	1978-10-05	1978-10-05 00:00:00	1978-10-05	5001	0	\N	0	0	\N	\N	0	117840	0	127783003	4133840		
98664	3020	4133840	2007-01-03	2007-01-03 00:00:00	2007-01-03	5001	0	\N	0	0	\N	\N	0	201431	0	127783003	4133840		
25873	2381	3006322	1968-12-26	1968-12-26 00:00:00	1968-12-26	5001	0	\N	0	0	\N	\N	0	158295	0	8331-1	3006322		
37247	3436	3006322	1967-06-03	1967-06-03 00:00:00	1967-06-03	5001	0	\N	0	0	\N	\N	0	227890	0	8331-1	3006322		
58498	1780	4024958	1972-01-27	1972-01-27 00:00:00	1972-01-27	5001	0	\N	0	0	\N	\N	0	119110	0	117015009	4024958		
9915	946	3006322	1979-07-16	1979-07-16 00:00:00	1979-07-16	5001	0	\N	0	0	\N	\N	0	62804	0	8331-1	3006322		
9964	949	46235214	1959-05-16	1959-05-16 00:00:00	1959-05-16	5001	0	\N	0	0	\N	\N	0	62983	0	76690-7	46235214		
22576	2070	3012494	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	137700	0	6206-7	3012494		
50739	4626	3000876	1997-11-21	1997-11-21 00:00:00	1997-11-21	5001	0	\N	0	0	\N	\N	0	308259	0	6082-2	3000876		
50786	4628	3006734	1986-10-24	1986-10-24 00:00:00	1986-10-24	5001	0	\N	0	0	\N	\N	0	308311	0	6189-5	3006734		
16150	1476	3006322	1997-07-22	1997-07-22 00:00:00	1997-07-22	5001	0	\N	0	0	\N	\N	0	98496	0	8331-1	3006322		
45472	4200	3006322	1995-08-13	1995-08-13 00:00:00	1995-08-13	5001	0	\N	0	0	\N	\N	0	278770	0	8331-1	3006322		
45586	4205	3006734	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	279161	0	6189-5	3006734		
27312	2534	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	167435	0	7258-7	3001488		
24926	2287	3006322	1957-08-02	1957-08-02 00:00:00	1957-08-02	5001	0	\N	0	0	\N	\N	0	152168	0	8331-1	3006322		
24967	2291	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	152470	0	6248-9	3015076		
147751	4529	4133840	1998-02-08	1998-02-08 00:00:00	1998-02-08	5001	0	\N	0	0	\N	\N	0	301562	0	127783003	4133840		
37225	3431	3006322	1967-10-15	1967-10-15 00:00:00	1967-10-15	5001	0	\N	0	0	\N	\N	0	227446	0	8331-1	3006322		
95165	2921	4133840	2011-10-18	2011-10-18 00:00:00	2011-10-18	5001	0	\N	0	0	\N	\N	0	194706	0	127783003	4133840		
3250	97	4133840	2000-07-17	2000-07-17 00:00:00	2000-07-17	5001	0	\N	0	0	\N	\N	0	6627	0	127783003	4133840		
4162	411	3001488	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	27261	0	7258-7	3001488		
4275	419	40758406	1913-07-24	1913-07-24 00:00:00	1913-07-24	5001	0	\N	0	0	\N	\N	0	27784	0	55277-8	40758406		
8639	828	3006322	1986-05-26	1986-05-26 00:00:00	1986-05-26	5001	0	\N	0	0	\N	\N	0	54840	0	8331-1	3006322		
37864	3494	3011505	1999-04-29	1999-04-29 00:00:00	1999-04-29	5001	0	\N	0	0	\N	\N	0	231752	0	19926-5	3011505		
20069	1843	3005136	1994-08-24	1994-08-24 00:00:00	1994-08-24	5001	0	\N	0	0	\N	\N	0	123018	0	6075-6	3005136		
31803	2902	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	193380	0	6158-0	3019406		
3216	311	3006322	1991-03-31	1991-03-31 00:00:00	1991-03-31	5001	0	\N	0	0	\N	\N	0	20630	0	8331-1	3006322		
14546	1355	40766240	1965-09-07	1965-09-07 00:00:00	1965-09-07	5001	0	\N	0	0	\N	\N	0	89776	0	63513-6	40766240		
14616	1356	40769179	1995-02-07	1995-02-07 00:00:00	1995-02-07	5001	0	\N	0	0	\N	\N	0	89887	0	66519-0	40769179		
26006	2392	3011505	1996-05-10	1996-05-10 00:00:00	1996-05-10	5001	0	\N	0	0	\N	\N	0	159063	0	19926-5	3011505		
28843	2669	46235214	2011-02-18	2011-02-18 00:00:00	2011-02-18	5001	0	\N	0	0	\N	\N	0	176766	0	76690-7	46235214		
16047	500	4052083	1966-06-27	1966-06-27 00:00:00	1966-06-27	5001	0	\N	0	0	\N	\N	0	33486	0	23426006	4052083		
56125	5148	3006322	1981-02-26	1981-02-26 00:00:00	1981-02-26	5001	0	\N	0	0	\N	\N	0	342226	0	8331-1	3006322		
48876	4473	3006322	1981-09-15	1981-09-15 00:00:00	1981-09-15	5001	0	\N	0	0	\N	\N	0	297611	0	8331-1	3006322		
28027	2577	3027231	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	170596	0	6276-0	3027231		
148486	4548	4052083	2016-04-17	2016-04-17 00:00:00	2016-04-17	5001	0	\N	0	0	\N	\N	0	303054	0	23426006	4052083		
46070	4247	3006322	2018-07-15	2018-07-15 00:00:00	2018-07-15	5001	0	\N	0	0	\N	\N	0	282065	0	8331-1	3006322		
24142	2217	3006322	1993-11-01	1993-11-01 00:00:00	1993-11-01	5001	0	\N	0	0	\N	\N	0	147670	0	8331-1	3006322		
57537	5284	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	351551	0	6206-7	3012494		
47281	4359	3006322	2006-06-14	2006-06-14 00:00:00	2006-06-14	5001	0	\N	0	0	\N	\N	0	289179	0	8331-1	3006322		
52049	4777	3006322	1967-12-26	1967-12-26 00:00:00	1967-12-26	5001	0	\N	0	0	\N	\N	0	318081	0	8331-1	3006322		
36312	3337	46235214	2012-11-25	2012-11-25 00:00:00	2012-11-25	5001	0	\N	0	0	\N	\N	0	221372	0	76690-7	46235214		
19450	1776	3028833	1984-10-13	1984-10-13 00:00:00	1984-10-13	5001	0	\N	0	0	\N	\N	0	118804	0	42719-5	3028833		
40268	3746	3006322	1956-03-06	1956-03-06 00:00:00	1956-03-06	5001	0	\N	0	0	\N	\N	0	249038	0	8331-1	3006322		
51621	4725	3015076	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	314894	0	6248-9	3015076		
51721	4739	3006322	1957-03-16	1957-03-16 00:00:00	1957-03-16	5001	0	\N	0	0	\N	\N	0	315741	0	8331-1	3006322		
40692	1264	4133840	1986-05-02	1986-05-02 00:00:00	1986-05-02	5001	0	\N	0	0	\N	\N	0	83300	0	127783003	4133840		
42414	3916	3012494	1979-04-17	1979-04-17 00:00:00	1979-04-17	5001	0	\N	0	0	\N	\N	0	260278	0	6206-7	3012494		
42948	3968	3049273	1994-01-21	1994-01-21 00:00:00	1994-01-21	5001	0	\N	0	0	\N	\N	0	263869	0	38265-5	3049273		
54290	4964	3000963	2016-01-30	2016-01-30 00:00:00	2016-01-30	5001	0	\N	0	0	\N	\N	0	329971	0	718-7	3000963		
54374	4971	3011505	2004-12-28	2004-12-28 00:00:00	2004-12-28	5001	0	\N	0	0	\N	\N	0	330505	0	19926-5	3011505		
21236	1966	3006322	1991-12-10	1991-12-10 00:00:00	1991-12-10	5001	0	\N	0	0	\N	\N	0	130672	0	8331-1	3006322		
101342	3114	4024958	1958-01-19	1958-01-19 00:00:00	1958-01-19	5001	0	\N	0	0	\N	\N	0	207142	0	117015009	4024958		
7612	729	3006322	1966-03-09	1966-03-09 00:00:00	1966-03-09	5001	0	\N	0	0	\N	\N	0	48367	0	8331-1	3006322		
32739	2966	3027231	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	198088	0	6276-0	3027231		
6279	588	3000963	1984-01-28	1984-01-28 00:00:00	1984-01-28	5001	0	\N	0	0	\N	\N	0	38930	0	718-7	3000963		
7014	675	3049273	2013-11-05	2013-11-05 00:00:00	2013-11-05	5001	0	\N	0	0	\N	\N	0	44646	0	38265-5	3049273		
6415	603	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	39910	0	6248-9	3015076		
79422	2442	4024958	2008-09-29	2008-09-29 00:00:00	2008-09-29	5001	0	\N	0	0	\N	\N	0	161933	0	117015009	4024958		
79458	2443	4024958	1980-08-20	1980-08-20 00:00:00	1980-08-20	5001	0	\N	0	0	\N	\N	0	162038	0	117015009	4024958		
17897	1626	3011505	2004-10-17	2004-10-17 00:00:00	2004-10-17	5001	0	\N	0	0	\N	\N	0	109218	0	19926-5	3011505		
7754	246	4052083	2003-05-23	2003-05-23 00:00:00	2003-05-23	5001	0	\N	0	0	\N	\N	0	16506	0	23426006	4052083		
39059	1214	4052083	1978-05-31	1978-05-31 00:00:00	1978-05-31	5001	0	\N	0	0	\N	\N	0	79991	0	23426006	4052083		
133299	4107	4024958	2004-10-25	2004-10-25 00:00:00	2004-10-25	5001	0	\N	0	0	\N	\N	0	272929	0	117015009	4024958		
57828	1762	4133840	1973-10-18	1973-10-18 00:00:00	1973-10-18	5001	0	\N	0	0	\N	\N	0	117816	0	127783003	4133840		
14491	1353	3006322	2011-03-27	2011-03-27 00:00:00	2011-03-27	5001	0	\N	0	0	\N	\N	0	89663	0	8331-1	3006322		
25874	2381	3006322	1941-12-01	1941-12-01 00:00:00	1941-12-01	5001	0	\N	0	0	\N	\N	0	158284	0	8331-1	3006322		
37248	3436	3006322	1968-05-11	1968-05-11 00:00:00	1968-05-11	5001	0	\N	0	0	\N	\N	0	227857	0	8331-1	3006322		
58500	1780	4052083	1983-02-06	1983-02-06 00:00:00	1983-02-06	5001	0	\N	0	0	\N	\N	0	119152	0	23426006	4052083		
9916	946	3006322	2015-02-23	2015-02-23 00:00:00	2015-02-23	5001	0	\N	0	0	\N	\N	0	62815	0	8331-1	3006322		
9965	949	3011505	1993-03-22	1993-03-22 00:00:00	1993-03-22	5001	0	\N	0	0	\N	\N	0	63037	0	19926-5	3011505		
22577	2070	3019406	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	137700	0	6158-0	3019406		
50740	4626	3015076	1997-11-21	1997-11-21 00:00:00	1997-11-21	5001	0	\N	0	0	\N	\N	0	308259	0	6248-9	3015076		
50787	4628	3001488	1986-10-24	1986-10-24 00:00:00	1986-10-24	5001	0	\N	0	0	\N	\N	0	308311	0	7258-7	3001488		
16151	1476	3006322	2005-09-20	2005-09-20 00:00:00	2005-09-20	5001	0	\N	0	0	\N	\N	0	98500	0	8331-1	3006322		
45689	4217	3006322	1989-02-22	1989-02-22 00:00:00	1989-02-22	5001	0	\N	0	0	\N	\N	0	279949	0	8331-1	3006322		
45587	4205	3012494	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	279161	0	6206-7	3012494		
27313	2535	3006322	1962-10-08	1962-10-08 00:00:00	1962-10-08	5001	0	\N	0	0	\N	\N	0	167489	0	8331-1	3006322		
24928	2287	3006322	1988-02-29	1988-02-29 00:00:00	1988-02-29	5001	0	\N	0	0	\N	\N	0	152193	0	8331-1	3006322		
24968	2291	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	152470	0	6273-7	3006451		
147753	4529	4133840	2013-11-17	2013-11-17 00:00:00	2013-11-17	5001	0	\N	0	0	\N	\N	0	301557	0	127783003	4133840		
37226	3431	3006322	1968-09-23	1968-09-23 00:00:00	1968-09-23	5001	0	\N	0	0	\N	\N	0	227447	0	8331-1	3006322		
95167	2921	4133840	1998-08-04	1998-08-04 00:00:00	1998-08-04	5001	0	\N	0	0	\N	\N	0	194703	0	127783003	4133840		
3252	97	4133840	2002-05-27	2002-05-27 00:00:00	2002-05-27	5001	0	\N	0	0	\N	\N	0	6610	0	127783003	4133840		
4163	411	3020655	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	27261	0	6844-5	3020655		
4276	419	40766240	1913-07-24	1913-07-24 00:00:00	1913-07-24	5001	0	\N	0	0	\N	\N	0	27784	0	63513-6	40766240		
8640	829	3006322	2006-09-13	2006-09-13 00:00:00	2006-09-13	5001	0	\N	0	0	\N	\N	0	54929	0	8331-1	3006322		
37865	3494	3011505	2014-11-06	2014-11-06 00:00:00	2014-11-06	5001	0	\N	0	0	\N	\N	0	231737	0	19926-5	3011505		
20070	1843	3001247	1994-08-24	1994-08-24 00:00:00	1994-08-24	5001	0	\N	0	0	\N	\N	0	123018	0	6085-5	3001247		
31804	2902	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	193380	0	6273-7	3006451		
3217	312	3006322	2018-03-06	2018-03-06 00:00:00	2018-03-06	5001	0	\N	0	0	\N	\N	0	20695	0	8331-1	3006322		
14547	1355	40758406	1965-09-07	1965-09-07 00:00:00	1965-09-07	5001	0	\N	0	0	\N	\N	0	89776	0	55277-8	40758406		
14617	1356	40769189	1995-02-07	1995-02-07 00:00:00	1995-02-07	5001	0	\N	0	0	\N	\N	0	89887	0	66529-9	40769189		
26007	2392	3011505	1979-11-23	1979-11-23 00:00:00	1979-11-23	5001	0	\N	0	0	\N	\N	0	159077	0	19926-5	3011505		
28844	2669	40758406	2011-02-18	2011-02-18 00:00:00	2011-02-18	5001	0	\N	0	0	\N	\N	0	176766	0	55277-8	40758406		
16063	500	4024958	1977-01-13	1977-01-13 00:00:00	1977-01-13	5001	0	\N	0	0	\N	\N	0	33520	0	117015009	4024958		
56126	5150	3006322	2007-01-03	2007-01-03 00:00:00	2007-01-03	5001	0	\N	0	0	\N	\N	0	342431	0	8331-1	3006322		
48877	4473	3006322	2018-10-20	2018-10-20 00:00:00	2018-10-20	5001	0	\N	0	0	\N	\N	0	297567	0	8331-1	3006322		
28028	2577	3006451	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	170596	0	6273-7	3006451		
148512	4548	4052083	1988-10-15	1988-10-15 00:00:00	1988-10-15	5001	0	\N	0	0	\N	\N	0	303016	0	23426006	4052083		
46083	4250	3049273	2016-05-31	2016-05-31 00:00:00	2016-05-31	5001	0	\N	0	0	\N	\N	0	282265	0	38265-5	3049273		
24143	2218	3006322	1988-01-18	1988-01-18 00:00:00	1988-01-18	5001	0	\N	0	0	\N	\N	0	147701	0	8331-1	3006322		
57538	5284	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	351551	0	6246-3	3021226		
47282	4359	3049273	2012-06-17	2012-06-17 00:00:00	2012-06-17	5001	0	\N	0	0	\N	\N	0	289214	0	38265-5	3049273		
52050	4777	3006322	1964-07-29	1964-07-29 00:00:00	1964-07-29	5001	0	\N	0	0	\N	\N	0	318057	0	8331-1	3006322		
36313	3337	40758406	2012-11-25	2012-11-25 00:00:00	2012-11-25	5001	0	\N	0	0	\N	\N	0	221372	0	55277-8	40758406		
19451	1776	3013721	1984-10-13	1984-10-13 00:00:00	1984-10-13	5001	0	\N	0	0	\N	\N	0	118804	0	1920-8	3013721		
40269	3746	3049273	2012-11-02	2012-11-02 00:00:00	2012-11-02	5001	0	\N	0	0	\N	\N	0	249066	0	38265-5	3049273		
51622	4725	3012494	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	314894	0	6206-7	3012494		
51722	4739	3006322	1948-02-18	1948-02-18 00:00:00	1948-02-18	5001	0	\N	0	0	\N	\N	0	315684	0	8331-1	3006322		
40696	1264	4133840	2013-11-22	2013-11-22 00:00:00	2013-11-22	5001	0	\N	0	0	\N	\N	0	83280	0	127783003	4133840		
42415	3916	3014599	1979-04-17	1979-04-17 00:00:00	1979-04-17	5001	0	\N	0	0	\N	\N	0	260278	0	6106-9	3014599		
42949	3968	3006322	1977-07-18	1977-07-18 00:00:00	1977-07-18	5001	0	\N	0	0	\N	\N	0	263852	0	8331-1	3006322		
54291	4964	3009542	2016-01-30	2016-01-30 00:00:00	2016-01-30	5001	0	\N	0	0	\N	\N	0	329971	0	20570-8	3009542		
54375	4971	3011505	2016-03-01	2016-03-01 00:00:00	2016-03-01	5001	0	\N	0	0	\N	\N	0	330532	0	19926-5	3011505		
21237	1966	3006322	2006-08-24	2006-08-24 00:00:00	2006-08-24	5001	0	\N	0	0	\N	\N	0	130702	0	8331-1	3006322		
101343	3114	4024958	1966-10-26	1966-10-26 00:00:00	1966-10-26	5001	0	\N	0	0	\N	\N	0	207120	0	117015009	4024958		
7613	729	3006322	1984-09-21	1984-09-21 00:00:00	1984-09-21	5001	0	\N	0	0	\N	\N	0	48427	0	8331-1	3006322		
32740	2966	3019406	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	198088	0	6158-0	3019406		
6280	588	3009542	1984-01-28	1984-01-28 00:00:00	1984-01-28	5001	0	\N	0	0	\N	\N	0	38930	0	20570-8	3009542		
7015	675	3006322	1956-12-03	1956-12-03 00:00:00	1956-12-03	5001	0	\N	0	0	\N	\N	0	44715	0	8331-1	3006322		
6416	603	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	39910	0	6158-0	3019406		
79424	2442	4024958	1978-12-06	1978-12-06 00:00:00	1978-12-06	5001	0	\N	0	0	\N	\N	0	161920	0	117015009	4024958		
79462	2443	4052083	1963-10-22	1963-10-22 00:00:00	1963-10-22	5001	0	\N	0	0	\N	\N	0	162025	0	23426006	4052083		
17898	1626	3011505	2005-10-23	2005-10-23 00:00:00	2005-10-23	5001	0	\N	0	0	\N	\N	0	109201	0	19926-5	3011505		
7756	246	4133840	2015-05-28	2015-05-28 00:00:00	2015-05-28	5001	0	\N	0	0	\N	\N	0	16543	0	127783003	4133840		
32006	987	4052083	2018-05-15	2018-05-15 00:00:00	2018-05-15	5001	0	\N	0	0	\N	\N	0	65602	0	23426006	4052083		
133309	4107	4024958	1987-04-18	1987-04-18 00:00:00	1987-04-18	5001	0	\N	0	0	\N	\N	0	272928	0	117015009	4024958		
57830	1762	4024958	1985-08-23	1985-08-23 00:00:00	1985-08-23	5001	0	\N	0	0	\N	\N	0	117807	0	117015009	4024958		
14492	1353	3006322	2001-09-09	2001-09-09 00:00:00	2001-09-09	5001	0	\N	0	0	\N	\N	0	89662	0	8331-1	3006322		
25876	2381	3006322	2007-10-08	2007-10-08 00:00:00	2007-10-08	5001	0	\N	0	0	\N	\N	0	158300	0	8331-1	3006322		
37249	3436	3006322	1987-04-06	1987-04-06 00:00:00	1987-04-06	5001	0	\N	0	0	\N	\N	0	227894	0	8331-1	3006322		
58505	1780	4052083	1988-11-30	1988-11-30 00:00:00	1988-11-30	5001	0	\N	0	0	\N	\N	0	119154	0	23426006	4052083		
9917	947	3006322	1974-02-22	1974-02-22 00:00:00	1974-02-22	5001	0	\N	0	0	\N	\N	0	62894	0	8331-1	3006322		
9966	949	3011505	2010-11-15	2010-11-15 00:00:00	2010-11-15	5001	0	\N	0	0	\N	\N	0	63056	0	19926-5	3011505		
22578	2070	3036780	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	137700	0	6095-4	3036780		
50741	4626	3014599	1997-11-21	1997-11-21 00:00:00	1997-11-21	5001	0	\N	0	0	\N	\N	0	308259	0	6106-9	3014599		
50788	4628	3000876	1986-10-24	1986-10-24 00:00:00	1986-10-24	5001	0	\N	0	0	\N	\N	0	308311	0	6082-2	3000876		
16152	1476	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	98383	0	6273-7	3006451		
45690	4217	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	279980	0	6833-8	3023430		
45588	4205	3001247	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	279161	0	6085-5	3001247		
27314	2535	3006322	1998-12-26	1998-12-26 00:00:00	1998-12-26	5001	0	\N	0	0	\N	\N	0	167496	0	8331-1	3006322		
24929	2287	3006322	1998-02-17	1998-02-17 00:00:00	1998-02-17	5001	0	\N	0	0	\N	\N	0	152119	0	8331-1	3006322		
24969	2291	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	152470	0	6082-2	3000876		
147756	4529	4024958	1972-11-23	1972-11-23 00:00:00	1972-11-23	5001	0	\N	0	0	\N	\N	0	301549	0	117015009	4024958		
37227	3431	3006322	1971-11-19	1971-11-19 00:00:00	1971-11-19	5001	0	\N	0	0	\N	\N	0	227457	0	8331-1	3006322		
95172	2921	4133840	2016-11-15	2016-11-15 00:00:00	2016-11-15	5001	0	\N	0	0	\N	\N	0	194719	0	127783003	4133840		
3265	99	4024958	1967-10-11	1967-10-11 00:00:00	1967-10-11	5001	0	\N	0	0	\N	\N	0	6718	0	117015009	4024958		
4164	411	3001247	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	27261	0	6085-5	3001247		
4278	419	3049273	1964-09-15	1964-09-15 00:00:00	1964-09-15	5001	0	\N	0	0	\N	\N	0	27710	0	38265-5	3049273		
8641	829	3006322	1998-02-14	1998-02-14 00:00:00	1998-02-14	5001	0	\N	0	0	\N	\N	0	54927	0	8331-1	3006322		
37866	3494	3006322	2012-10-17	2012-10-17 00:00:00	2012-10-17	5001	0	\N	0	0	\N	\N	0	231773	0	8331-1	3006322		
20071	1843	3006734	1994-08-24	1994-08-24 00:00:00	1994-08-24	5001	0	\N	0	0	\N	\N	0	123018	0	6189-5	3006734		
31805	2902	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	193380	0	6276-0	3027231		
3218	312	3006322	1997-02-25	1997-02-25 00:00:00	1997-02-25	5001	0	\N	0	0	\N	\N	0	20691	0	8331-1	3006322		
14548	1355	46235214	1966-09-02	1966-09-02 00:00:00	1966-09-02	5001	0	\N	0	0	\N	\N	0	89854	0	76690-7	46235214		
14618	1356	3000876	1995-02-23	1995-02-23 00:00:00	1995-02-23	5001	0	\N	0	0	\N	\N	0	89888	0	6082-2	3000876		
26008	2392	3011505	2014-10-10	2014-10-10 00:00:00	2014-10-10	5001	0	\N	0	0	\N	\N	0	158976	0	19926-5	3011505		
28846	2669	40766240	2011-02-18	2011-02-18 00:00:00	2011-02-18	5001	0	\N	0	0	\N	\N	0	176766	0	63513-6	40766240		
37433	3446	3006322	1984-04-29	1984-04-29 00:00:00	1984-04-29	5001	0	\N	0	0	\N	\N	0	228810	0	8331-1	3006322		
56127	5150	3006322	1939-04-17	1939-04-17 00:00:00	1939-04-17	5001	0	\N	0	0	\N	\N	0	342370	0	8331-1	3006322		
48878	4473	3006322	2002-07-03	2002-07-03 00:00:00	2002-07-03	5001	0	\N	0	0	\N	\N	0	297588	0	8331-1	3006322		
28029	2577	3021226	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	170596	0	6246-3	3021226		
55361	5073	3006322	1996-04-30	1996-04-30 00:00:00	1996-04-30	5001	0	\N	0	0	\N	\N	0	337186	0	8331-1	3006322		
46084	4250	3006322	2001-08-28	2001-08-28 00:00:00	2001-08-28	5001	0	\N	0	0	\N	\N	0	282293	0	8331-1	3006322		
24144	2218	3006322	1978-12-22	1978-12-22 00:00:00	1978-12-22	5001	0	\N	0	0	\N	\N	0	147732	0	8331-1	3006322		
57539	5284	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	351551	0	6833-8	3023430		
47283	4359	3049273	2013-09-04	2013-09-04 00:00:00	2013-09-04	5001	0	\N	0	0	\N	\N	0	289209	0	38265-5	3049273		
52051	4777	3006322	1990-06-15	1990-06-15 00:00:00	1990-06-15	5001	0	\N	0	0	\N	\N	0	318084	0	8331-1	3006322		
36316	3337	40758406	2013-01-24	2013-01-24 00:00:00	2013-01-24	5001	0	\N	0	0	\N	\N	0	221391	0	55277-8	40758406		
19452	1776	3006322	1921-08-06	1921-08-06 00:00:00	1921-08-06	5001	0	\N	0	0	\N	\N	0	118770	0	8331-1	3006322		
51553	4719	3012494	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	314290	0	6206-7	3012494		
51623	4725	3001247	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	314894	0	6085-5	3001247		
51728	4745	3006322	2018-03-18	2018-03-18 00:00:00	2018-03-18	5001	0	\N	0	0	\N	\N	0	316003	0	8331-1	3006322		
40698	1264	4133840	2010-11-05	2010-11-05 00:00:00	2010-11-05	5001	0	\N	0	0	\N	\N	0	83291	0	127783003	4133840		
42416	3916	3019406	1979-04-17	1979-04-17 00:00:00	1979-04-17	5001	0	\N	0	0	\N	\N	0	260278	0	6158-0	3019406		
42950	3968	3006322	1985-05-02	1985-05-02 00:00:00	1985-05-02	5001	0	\N	0	0	\N	\N	0	263839	0	8331-1	3006322		
54296	4967	3006322	1970-01-16	1970-01-16 00:00:00	1970-01-16	5001	0	\N	0	0	\N	\N	0	330156	0	8331-1	3006322		
54376	4971	3011505	2009-01-20	2009-01-20 00:00:00	2009-01-20	5001	0	\N	0	0	\N	\N	0	330531	0	19926-5	3011505		
21238	1967	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	130834	0	6248-9	3015076		
32625	2959	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	197575	0	6276-0	3027231		
7614	730	3006322	1984-05-08	1984-05-08 00:00:00	1984-05-08	5001	0	\N	0	0	\N	\N	0	48478	0	8331-1	3006322		
32741	2966	3001488	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	198088	0	7258-7	3001488		
6281	588	3006322	1995-03-20	1995-03-20 00:00:00	1995-03-20	5001	0	\N	0	0	\N	\N	0	38933	0	8331-1	3006322		
7018	677	3006322	2018-01-01	2018-01-01 00:00:00	2018-01-01	5001	0	\N	0	0	\N	\N	0	44822	0	8331-1	3006322		
6417	603	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	39910	0	6082-2	3000876		
79444	2443	4024958	1986-03-04	1986-03-04 00:00:00	1986-03-04	5001	0	\N	0	0	\N	\N	0	162073	0	117015009	4024958		
79471	2444	4024958	1973-12-03	1973-12-03 00:00:00	1973-12-03	5001	0	\N	0	0	\N	\N	0	162110	0	117015009	4024958		
17900	1626	3011505	2008-11-09	2008-11-09 00:00:00	2008-11-09	5001	0	\N	0	0	\N	\N	0	109237	0	19926-5	3011505		
7758	246	4133840	2018-06-14	2018-06-14 00:00:00	2018-06-14	5001	0	\N	0	0	\N	\N	0	16574	0	127783003	4133840		
32014	987	4052083	1991-10-01	1991-10-01 00:00:00	1991-10-01	5001	0	\N	0	0	\N	\N	0	65600	0	23426006	4052083		
14342	1345	40758406	1993-01-02	1993-01-02 00:00:00	1993-01-02	5001	0	\N	0	0	\N	\N	0	89126	0	55277-8	40758406		
57847	1764	4052083	1970-05-27	1970-05-27 00:00:00	1970-05-27	5001	0	\N	0	0	\N	\N	0	117995	0	23426006	4052083		
14493	1353	3006322	1980-12-26	1980-12-26 00:00:00	1980-12-26	5001	0	\N	0	0	\N	\N	0	89660	0	8331-1	3006322		
25877	2381	3006322	1992-05-01	1992-05-01 00:00:00	1992-05-01	5001	0	\N	0	0	\N	\N	0	158350	0	8331-1	3006322		
37250	3436	3006322	1987-01-23	1987-01-23 00:00:00	1987-01-23	5001	0	\N	0	0	\N	\N	0	227863	0	8331-1	3006322		
42782	1317	4133840	2005-12-02	2005-12-02 00:00:00	2005-12-02	5001	0	\N	0	0	\N	\N	0	87315	0	127783003	4133840		
9918	947	3006322	1976-06-27	1976-06-27 00:00:00	1976-06-27	5001	0	\N	0	0	\N	\N	0	62900	0	8331-1	3006322		
9967	949	3006322	1975-03-01	1975-03-01 00:00:00	1975-03-01	5001	0	\N	0	0	\N	\N	0	63025	0	8331-1	3006322		
22579	2070	3001247	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	137700	0	6085-5	3001247		
50742	4626	3036780	1997-11-21	1997-11-21 00:00:00	1997-11-21	5001	0	\N	0	0	\N	\N	0	308259	0	6095-4	3036780		
50789	4628	3020655	1986-10-24	1986-10-24 00:00:00	1986-10-24	5001	0	\N	0	0	\N	\N	0	308311	0	6844-5	3020655		
16153	1476	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	98383	0	6158-0	3019406		
45691	4217	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	279980	0	6095-4	3036780		
45589	4205	3020655	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	279161	0	6844-5	3020655		
27315	2535	3006322	1994-12-04	1994-12-04 00:00:00	1994-12-04	5001	0	\N	0	0	\N	\N	0	167554	0	8331-1	3006322		
24930	2287	3006322	1970-02-17	1970-02-17 00:00:00	1970-02-17	5001	0	\N	0	0	\N	\N	0	152102	0	8331-1	3006322		
24970	2291	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	152470	0	6844-5	3020655		
147757	4529	4024958	1965-11-08	1965-11-08 00:00:00	1965-11-08	5001	0	\N	0	0	\N	\N	0	301566	0	117015009	4024958		
37229	3432	3006322	2001-06-06	2001-06-06 00:00:00	2001-06-06	5001	0	\N	0	0	\N	\N	0	227545	0	8331-1	3006322		
95175	2921	4133840	2013-10-29	2013-10-29 00:00:00	2013-10-29	5001	0	\N	0	0	\N	\N	0	194750	0	127783003	4133840		
3266	99	4133840	2000-11-25	2000-11-25 00:00:00	2000-11-25	5001	0	\N	0	0	\N	\N	0	6766	0	127783003	4133840		
4165	411	3006734	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	27261	0	6189-5	3006734		
4279	419	3006322	1950-05-16	1950-05-16 00:00:00	1950-05-16	5001	0	\N	0	0	\N	\N	0	27688	0	8331-1	3006322		
8642	829	3006322	1973-12-16	1973-12-16 00:00:00	1973-12-16	5001	0	\N	0	0	\N	\N	0	54877	0	8331-1	3006322		
37867	3494	3006322	2015-12-12	2015-12-12 00:00:00	2015-12-12	5001	0	\N	0	0	\N	\N	0	231743	0	8331-1	3006322		
20072	1843	3014599	1994-08-24	1994-08-24 00:00:00	1994-08-24	5001	0	\N	0	0	\N	\N	0	123018	0	6106-9	3014599		
31806	2902	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	193380	0	6246-3	3021226		
3219	312	3006322	2003-03-12	2003-03-12 00:00:00	2003-03-12	5001	0	\N	0	0	\N	\N	0	20714	0	8331-1	3006322		
14551	1355	40766240	1966-09-02	1966-09-02 00:00:00	1966-09-02	5001	0	\N	0	0	\N	\N	0	89854	0	63513-6	40766240		
14619	1356	3015076	1995-02-23	1995-02-23 00:00:00	1995-02-23	5001	0	\N	0	0	\N	\N	0	89888	0	6248-9	3015076		
26009	2392	3011505	1984-03-02	1984-03-02 00:00:00	1984-03-02	5001	0	\N	0	0	\N	\N	0	159080	0	19926-5	3011505		
28847	2669	3006322	1982-02-14	1982-02-14 00:00:00	1982-02-14	5001	0	\N	0	0	\N	\N	0	176785	0	8331-1	3006322		
37434	3446	3006322	1990-07-14	1990-07-14 00:00:00	1990-07-14	5001	0	\N	0	0	\N	\N	0	228811	0	8331-1	3006322		
56128	5150	3006322	2010-09-24	2010-09-24 00:00:00	2010-09-24	5001	0	\N	0	0	\N	\N	0	342465	0	8331-1	3006322		
48879	4474	3006322	2011-11-14	2011-11-14 00:00:00	2011-11-14	5001	0	\N	0	0	\N	\N	0	297633	0	8331-1	3006322		
28030	2577	3005136	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	170596	0	6075-6	3005136		
55362	5073	3006322	1943-02-16	1943-02-16 00:00:00	1943-02-16	5001	0	\N	0	0	\N	\N	0	337229	0	8331-1	3006322		
46085	4250	3006322	2002-12-04	2002-12-04 00:00:00	2002-12-04	5001	0	\N	0	0	\N	\N	0	282294	0	8331-1	3006322		
24145	2218	3006734	1979-03-30	1979-03-30 00:00:00	1979-03-30	5001	0	\N	0	0	\N	\N	0	147700	0	6189-5	3006734		
57540	5284	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	351551	0	6189-5	3006734		
47284	4359	3006322	1963-01-06	1963-01-06 00:00:00	1963-01-06	5001	0	\N	0	0	\N	\N	0	289261	0	8331-1	3006322		
52052	4777	3006322	1970-05-29	1970-05-29 00:00:00	1970-05-29	5001	0	\N	0	0	\N	\N	0	318056	0	8331-1	3006322		
36317	3337	46235214	2013-01-24	2013-01-24 00:00:00	2013-01-24	5001	0	\N	0	0	\N	\N	0	221391	0	76690-7	46235214		
19453	1776	3006322	1926-08-30	1926-08-30 00:00:00	1926-08-30	5001	0	\N	0	0	\N	\N	0	118777	0	8331-1	3006322		
51554	4719	3015076	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	314290	0	6248-9	3015076		
51624	4725	3001488	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	314894	0	7258-7	3001488		
51729	4745	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	316007	0	6833-8	3023430		
40700	1264	4133840	1990-01-12	1990-01-12 00:00:00	1990-01-12	5001	0	\N	0	0	\N	\N	0	83356	0	127783003	4133840		
42417	3916	3015076	1979-04-17	1979-04-17 00:00:00	1979-04-17	5001	0	\N	0	0	\N	\N	0	260278	0	6248-9	3015076		
42951	3968	3006322	1923-11-24	1923-11-24 00:00:00	1923-11-24	5001	0	\N	0	0	\N	\N	0	263895	0	8331-1	3006322		
54297	4967	3006322	1993-04-10	1993-04-10 00:00:00	1993-04-10	5001	0	\N	0	0	\N	\N	0	330185	0	8331-1	3006322		
54377	4971	3011505	2014-02-18	2014-02-18 00:00:00	2014-02-18	5001	0	\N	0	0	\N	\N	0	330555	0	19926-5	3011505		
21239	1967	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	130834	0	6273-7	3006451		
32626	2959	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	197575	0	6273-7	3006451		
7615	730	3006322	1973-12-18	1973-12-18 00:00:00	1973-12-18	5001	0	\N	0	0	\N	\N	0	48457	0	8331-1	3006322		
32742	2966	3006734	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	198088	0	6189-5	3006734		
172586	5295	4052083	1939-11-22	1939-11-22 00:00:00	1939-11-22	5001	0	\N	0	0	\N	\N	0	352279	0	23426006	4052083		
7019	677	3006322	1972-03-22	1972-03-22 00:00:00	1972-03-22	5001	0	\N	0	0	\N	\N	0	44806	0	8331-1	3006322		
6418	603	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	39910	0	6833-8	3023430		
79551	2447	4133840	2014-10-08	2014-10-08 00:00:00	2014-10-08	5001	0	\N	0	0	\N	\N	0	162330	0	127783003	4133840		
79475	2444	4052083	2011-01-18	2011-01-18 00:00:00	2011-01-18	5001	0	\N	0	0	\N	\N	0	162168	0	23426006	4052083		
29178	2686	46235214	2003-03-08	2003-03-08 00:00:00	2003-03-08	5001	0	\N	0	0	\N	\N	0	178052	0	76690-7	46235214		
7759	246	4024958	1972-04-28	1972-04-28 00:00:00	1972-04-28	5001	0	\N	0	0	\N	\N	0	16588	0	117015009	4024958		
32016	987	4052083	2003-03-18	2003-03-18 00:00:00	2003-03-18	5001	0	\N	0	0	\N	\N	0	65585	0	23426006	4052083		
14344	1345	3051031	1993-01-02	1993-01-02 00:00:00	1993-01-02	5001	0	\N	0	0	\N	\N	0	89126	0	46240-8	3051031		
57848	1764	4052083	1981-09-24	1981-09-24 00:00:00	1981-09-24	5001	0	\N	0	0	\N	\N	0	117980	0	23426006	4052083		
14494	1354	3006322	2000-11-17	2000-11-17 00:00:00	2000-11-17	5001	0	\N	0	0	\N	\N	0	89767	0	8331-1	3006322		
25878	2381	3006322	1973-03-17	1973-03-17 00:00:00	1973-03-17	5001	0	\N	0	0	\N	\N	0	158317	0	8331-1	3006322		
37251	3436	3006322	1963-04-13	1963-04-13 00:00:00	1963-04-13	5001	0	\N	0	0	\N	\N	0	227872	0	8331-1	3006322		
42785	1317	4133840	1997-07-11	1997-07-11 00:00:00	1997-07-11	5001	0	\N	0	0	\N	\N	0	87328	0	127783003	4133840		
9919	947	3006322	2006-06-06	2006-06-06 00:00:00	2006-06-06	5001	0	\N	0	0	\N	\N	0	62846	0	8331-1	3006322		
9968	949	3011505	2015-12-14	2015-12-14 00:00:00	2015-12-14	5001	0	\N	0	0	\N	\N	0	63018	0	19926-5	3011505		
22580	2070	3014599	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	137700	0	6106-9	3014599		
50743	4626	3019406	1997-11-21	1997-11-21 00:00:00	1997-11-21	5001	0	\N	0	0	\N	\N	0	308259	0	6158-0	3019406		
50790	4628	3001247	1986-10-24	1986-10-24 00:00:00	1986-10-24	5001	0	\N	0	0	\N	\N	0	308311	0	6085-5	3001247		
16154	1476	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	98383	0	6075-6	3005136		
45692	4217	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	279980	0	7258-7	3001488		
45590	4205	3000876	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	279161	0	6082-2	3000876		
27316	2535	3006322	1961-10-29	1961-10-29 00:00:00	1961-10-29	5001	0	\N	0	0	\N	\N	0	167488	0	8331-1	3006322		
24931	2289	3006322	2013-08-07	2013-08-07 00:00:00	2013-08-07	5001	0	\N	0	0	\N	\N	0	152234	0	8331-1	3006322		
24971	2291	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	152470	0	6189-5	3006734		
147762	4529	4133840	2005-11-27	2005-11-27 00:00:00	2005-11-27	5001	0	\N	0	0	\N	\N	0	301580	0	127783003	4133840		
37230	3432	3006322	1995-10-20	1995-10-20 00:00:00	1995-10-20	5001	0	\N	0	0	\N	\N	0	227563	0	8331-1	3006322		
36481	3352	3006322	1972-04-09	1972-04-09 00:00:00	1972-04-09	5001	0	\N	0	0	\N	\N	0	222305	0	8331-1	3006322		
3268	99	4133840	2013-08-10	2013-08-10 00:00:00	2013-08-10	5001	0	\N	0	0	\N	\N	0	6750	0	127783003	4133840		
4166	411	3036780	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	27261	0	6095-4	3036780		
4283	419	3049273	1991-07-01	1991-07-01 00:00:00	1991-07-01	5001	0	\N	0	0	\N	\N	0	27761	0	38265-5	3049273		
8643	829	3006322	1987-04-23	1987-04-23 00:00:00	1987-04-23	5001	0	\N	0	0	\N	\N	0	54926	0	8331-1	3006322		
37868	3494	3011505	2009-07-30	2009-07-30 00:00:00	2009-07-30	5001	0	\N	0	0	\N	\N	0	231735	0	19926-5	3011505		
20073	1843	3019406	1994-08-24	1994-08-24 00:00:00	1994-08-24	5001	0	\N	0	0	\N	\N	0	123018	0	6158-0	3019406		
31807	2902	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	193380	0	6085-5	3001247		
3220	312	3006322	1975-01-12	1975-01-12 00:00:00	1975-01-12	5001	0	\N	0	0	\N	\N	0	20670	0	8331-1	3006322		
14552	1355	40758406	1966-09-02	1966-09-02 00:00:00	1966-09-02	5001	0	\N	0	0	\N	\N	0	89854	0	55277-8	40758406		
14620	1356	3001247	1995-02-23	1995-02-23 00:00:00	1995-02-23	5001	0	\N	0	0	\N	\N	0	89888	0	6085-5	3001247		
26010	2392	3011505	2007-07-13	2007-07-13 00:00:00	2007-07-13	5001	0	\N	0	0	\N	\N	0	159065	0	19926-5	3011505		
28848	2669	46235214	1978-07-06	1978-07-06 00:00:00	1978-07-06	5001	0	\N	0	0	\N	\N	0	176811	0	76690-7	46235214		
37435	3446	3006322	1982-11-22	1982-11-22 00:00:00	1982-11-22	5001	0	\N	0	0	\N	\N	0	228787	0	8331-1	3006322		
56129	5150	3006322	1952-01-02	1952-01-02 00:00:00	1952-01-02	5001	0	\N	0	0	\N	\N	0	342372	0	8331-1	3006322		
48880	4474	3006322	1998-04-01	1998-04-01 00:00:00	1998-04-01	5001	0	\N	0	0	\N	\N	0	297654	0	8331-1	3006322		
28031	2577	3012494	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	170596	0	6206-7	3012494		
55363	5073	3006322	1941-01-12	1941-01-12 00:00:00	1941-01-12	5001	0	\N	0	0	\N	\N	0	337193	0	8331-1	3006322		
46086	4250	3049273	2015-04-07	2015-04-07 00:00:00	2015-04-07	5001	0	\N	0	0	\N	\N	0	282264	0	38265-5	3049273		
24146	2218	3006451	1979-03-30	1979-03-30 00:00:00	1979-03-30	5001	0	\N	0	0	\N	\N	0	147700	0	6273-7	3006451		
57541	5284	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	351551	0	6273-7	3006451		
47285	4359	3006322	1950-01-20	1950-01-20 00:00:00	1950-01-20	5001	0	\N	0	0	\N	\N	0	289187	0	8331-1	3006322		
52053	4777	3006322	1981-11-12	1981-11-12 00:00:00	1981-11-12	5001	0	\N	0	0	\N	\N	0	318083	0	8331-1	3006322		
36318	3337	3051031	2013-01-24	2013-01-24 00:00:00	2013-01-24	5001	0	\N	0	0	\N	\N	0	221391	0	46240-8	3051031		
19454	1776	3049273	2006-10-28	2006-10-28 00:00:00	2006-10-28	5001	0	\N	0	0	\N	\N	0	118881	0	38265-5	3049273		
51555	4719	3019406	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	314290	0	6158-0	3019406		
51625	4725	3021226	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	314894	0	6246-3	3021226		
51730	4745	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	316007	0	6844-5	3020655		
40704	1264	4133840	2019-06-07	2019-06-07 00:00:00	2019-06-07	5001	0	\N	0	0	\N	\N	0	83295	0	127783003	4133840		
42418	3916	3001247	1979-04-17	1979-04-17 00:00:00	1979-04-17	5001	0	\N	0	0	\N	\N	0	260278	0	6085-5	3001247		
42952	3968	3006322	1979-01-23	1979-01-23 00:00:00	1979-01-23	5001	0	\N	0	0	\N	\N	0	263838	0	8331-1	3006322		
54298	4967	3006322	1961-12-27	1961-12-27 00:00:00	1961-12-27	5001	0	\N	0	0	\N	\N	0	330133	0	8331-1	3006322		
54378	4971	3011505	2018-03-13	2018-03-13 00:00:00	2018-03-13	5001	0	\N	0	0	\N	\N	0	330533	0	19926-5	3011505		
21240	1967	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	130834	0	6075-6	3005136		
32627	2959	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	197575	0	6206-7	3012494		
7616	730	3006322	2012-03-21	2012-03-21 00:00:00	2012-03-21	5001	0	\N	0	0	\N	\N	0	48504	0	8331-1	3006322		
32743	2966	3036780	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	198088	0	6095-4	3036780		
172643	5298	4024958	1954-03-19	1954-03-19 00:00:00	1954-03-19	5001	0	\N	0	0	\N	\N	0	352418	0	117015009	4024958		
7020	677	3006322	1962-01-31	1962-01-31 00:00:00	1962-01-31	5001	0	\N	0	0	\N	\N	0	44783	0	8331-1	3006322		
6419	603	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	39910	0	6095-4	3036780		
79569	2448	4024958	2000-03-30	2000-03-30 00:00:00	2000-03-30	5001	0	\N	0	0	\N	\N	0	162366	0	117015009	4024958		
90760	2801	4052083	1930-08-06	1930-08-06 00:00:00	1930-08-06	5001	0	\N	0	0	\N	\N	0	185591	0	23426006	4052083		
29179	2686	3006322	2016-04-08	2016-04-08 00:00:00	2016-04-08	5001	0	\N	0	0	\N	\N	0	178000	0	8331-1	3006322		
7760	246	4133840	2019-06-20	2019-06-20 00:00:00	2019-06-20	5001	0	\N	0	0	\N	\N	0	16517	0	127783003	4133840		
32017	987	4024958	1956-04-20	1956-04-20 00:00:00	1956-04-20	5001	0	\N	0	0	\N	\N	0	65599	0	117015009	4024958		
14345	1345	46235214	1993-01-02	1993-01-02 00:00:00	1993-01-02	5001	0	\N	0	0	\N	\N	0	89126	0	76690-7	46235214		
57854	1764	4024958	2002-06-08	2002-06-08 00:00:00	2002-06-08	5001	0	\N	0	0	\N	\N	0	117941	0	117015009	4024958		
14495	1354	3006322	1980-02-28	1980-02-28 00:00:00	1980-02-28	5001	0	\N	0	0	\N	\N	0	89722	0	8331-1	3006322		
25879	2381	3006322	2004-01-12	2004-01-12 00:00:00	2004-01-12	5001	0	\N	0	0	\N	\N	0	158299	0	8331-1	3006322		
37252	3436	3006322	1975-03-16	1975-03-16 00:00:00	1975-03-16	5001	0	\N	0	0	\N	\N	0	227859	0	8331-1	3006322		
42787	1317	4133840	2010-12-31	2010-12-31 00:00:00	2010-12-31	5001	0	\N	0	0	\N	\N	0	87301	0	127783003	4133840		
9920	948	3006322	2015-12-30	2015-12-30 00:00:00	2015-12-30	5001	0	\N	0	0	\N	\N	0	62920	0	8331-1	3006322		
9969	949	3011505	1986-09-01	1986-09-01 00:00:00	1986-09-01	5001	0	\N	0	0	\N	\N	0	62998	0	19926-5	3011505		
22581	2070	3006734	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	137700	0	6189-5	3006734		
50744	4626	3005136	1997-11-21	1997-11-21 00:00:00	1997-11-21	5001	0	\N	0	0	\N	\N	0	308259	0	6075-6	3005136		
50791	4628	3006322	1992-10-31	1992-10-31 00:00:00	1992-10-31	5001	0	\N	0	0	\N	\N	0	308357	0	8331-1	3006322		
16155	1476	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	98383	0	6248-9	3015076		
45693	4217	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	279980	0	6246-3	3021226		
45591	4205	3006322	1978-03-11	1978-03-11 00:00:00	1978-03-11	5001	0	\N	0	0	\N	\N	0	279164	0	8331-1	3006322		
27317	2535	3006322	1969-02-15	1969-02-15 00:00:00	1969-02-15	5001	0	\N	0	0	\N	\N	0	167481	0	8331-1	3006322		
24932	2289	3006322	1972-07-01	1972-07-01 00:00:00	1972-07-01	5001	0	\N	0	0	\N	\N	0	152283	0	8331-1	3006322		
24972	2291	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	152470	0	6833-8	3023430		
147764	4529	4133840	1992-02-02	1992-02-02 00:00:00	1992-02-02	5001	0	\N	0	0	\N	\N	0	301554	0	127783003	4133840		
37231	3432	3006322	2008-08-24	2008-08-24 00:00:00	2008-08-24	5001	0	\N	0	0	\N	\N	0	227499	0	8331-1	3006322		
36482	3352	3006322	1989-07-08	1989-07-08 00:00:00	1989-07-08	5001	0	\N	0	0	\N	\N	0	222285	0	8331-1	3006322		
3274	99	4133840	1998-10-10	1998-10-10 00:00:00	1998-10-10	5001	0	\N	0	0	\N	\N	0	6778	0	127783003	4133840		
4167	411	3027231	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	27261	0	6276-0	3027231		
4286	421	3006322	1996-05-22	1996-05-22 00:00:00	1996-05-22	5001	0	\N	0	0	\N	\N	0	27882	0	8331-1	3006322		
8644	829	3006322	1983-05-19	1983-05-19 00:00:00	1983-05-19	5001	0	\N	0	0	\N	\N	0	54878	0	8331-1	3006322		
37869	3494	3011505	2005-07-21	2005-07-21 00:00:00	2005-07-21	5001	0	\N	0	0	\N	\N	0	231763	0	19926-5	3011505		
20074	1843	3036780	1994-08-24	1994-08-24 00:00:00	1994-08-24	5001	0	\N	0	0	\N	\N	0	123018	0	6095-4	3036780		
31808	2902	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	193380	0	6189-5	3006734		
14502	1355	40766240	1966-01-05	1966-01-05 00:00:00	1966-01-05	5001	0	\N	0	0	\N	\N	0	89835	0	63513-6	40766240		
14553	1355	3051031	1966-09-02	1966-09-02 00:00:00	1966-09-02	5001	0	\N	0	0	\N	\N	0	89854	0	46240-8	3051031		
14621	1356	3020655	1995-02-23	1995-02-23 00:00:00	1995-02-23	5001	0	\N	0	0	\N	\N	0	89888	0	6844-5	3020655		
26011	2392	3006322	1956-05-13	1956-05-13 00:00:00	1956-05-13	5001	0	\N	0	0	\N	\N	0	159040	0	8331-1	3006322		
28849	2669	40758406	1978-07-06	1978-07-06 00:00:00	1978-07-06	5001	0	\N	0	0	\N	\N	0	176811	0	55277-8	40758406		
37437	3446	3006322	1996-01-05	1996-01-05 00:00:00	1996-01-05	5001	0	\N	0	0	\N	\N	0	228813	0	8331-1	3006322		
56130	5150	3006322	2004-10-01	2004-10-01 00:00:00	2004-10-01	5001	0	\N	0	0	\N	\N	0	342439	0	8331-1	3006322		
48881	4474	3006322	2002-01-23	2002-01-23 00:00:00	2002-01-23	5001	0	\N	0	0	\N	\N	0	297643	0	8331-1	3006322		
28032	2577	3014599	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	170596	0	6106-9	3014599		
55366	5073	3006322	1959-09-29	1959-09-29 00:00:00	1959-09-29	5001	0	\N	0	0	\N	\N	0	337194	0	8331-1	3006322		
46087	4250	3006322	1996-10-12	1996-10-12 00:00:00	1996-10-12	5001	0	\N	0	0	\N	\N	0	282328	0	8331-1	3006322		
24147	2218	3012494	1979-03-30	1979-03-30 00:00:00	1979-03-30	5001	0	\N	0	0	\N	\N	0	147700	0	6206-7	3012494		
57542	5284	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	351551	0	6106-9	3014599		
47286	4359	3006322	1947-02-22	1947-02-22 00:00:00	1947-02-22	5001	0	\N	0	0	\N	\N	0	289216	0	8331-1	3006322		
52063	4781	3006322	1987-03-09	1987-03-09 00:00:00	1987-03-09	5001	0	\N	0	0	\N	\N	0	318291	0	8331-1	3006322		
36319	3337	40766240	2013-01-24	2013-01-24 00:00:00	2013-01-24	5001	0	\N	0	0	\N	\N	0	221391	0	63513-6	40766240		
19455	1776	3006322	1988-02-03	1988-02-03 00:00:00	1988-02-03	5001	0	\N	0	0	\N	\N	0	118785	0	8331-1	3006322		
51556	4719	3005136	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	314290	0	6075-6	3005136		
51626	4725	3027231	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	314894	0	6276-0	3027231		
51731	4745	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	316007	0	6085-5	3001247		
40706	1264	4133840	2006-10-13	2006-10-13 00:00:00	2006-10-13	5001	0	\N	0	0	\N	\N	0	83279	0	127783003	4133840		
42419	3916	3006734	1979-04-17	1979-04-17 00:00:00	1979-04-17	5001	0	\N	0	0	\N	\N	0	260278	0	6189-5	3006734		
42953	3968	3006322	1927-08-19	1927-08-19 00:00:00	1927-08-19	5001	0	\N	0	0	\N	\N	0	263867	0	8331-1	3006322		
54299	4967	3006322	1968-12-07	1968-12-07 00:00:00	1968-12-07	5001	0	\N	0	0	\N	\N	0	330155	0	8331-1	3006322		
54379	4971	3006322	1993-11-11	1993-11-11 00:00:00	1993-11-11	5001	0	\N	0	0	\N	\N	0	330644	0	8331-1	3006322		
21241	1967	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	130834	0	6276-0	3027231		
32628	2959	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	197575	0	6158-0	3019406		
7617	730	3049273	2017-09-16	2017-09-16 00:00:00	2017-09-16	5001	0	\N	0	0	\N	\N	0	48464	0	38265-5	3049273		
32744	2966	3006322	1983-12-17	1983-12-17 00:00:00	1983-12-17	5001	0	\N	0	0	\N	\N	0	198059	0	8331-1	3006322		
172653	5298	4052083	1943-01-26	1943-01-26 00:00:00	1943-01-26	5001	0	\N	0	0	\N	\N	0	352442	0	23426006	4052083		
7065	679	3006322	1984-10-27	1984-10-27 00:00:00	1984-10-27	5001	0	\N	0	0	\N	\N	0	44938	0	8331-1	3006322		
6420	603	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	39910	0	6246-3	3021226		
79575	2448	4024958	1964-08-16	1964-08-16 00:00:00	1964-08-16	5001	0	\N	0	0	\N	\N	0	162388	0	117015009	4024958		
90762	2801	4024958	1988-11-07	1988-11-07 00:00:00	1988-11-07	5001	0	\N	0	0	\N	\N	0	185581	0	117015009	4024958		
29180	2686	3006322	1971-06-13	1971-06-13 00:00:00	1971-06-13	5001	0	\N	0	0	\N	\N	0	178049	0	8331-1	3006322		
7761	246	4133840	2012-05-10	2012-05-10 00:00:00	2012-05-10	5001	0	\N	0	0	\N	\N	0	16515	0	127783003	4133840		
32020	987	4052083	1984-01-13	1984-01-13 00:00:00	1984-01-13	5001	0	\N	0	0	\N	\N	0	65584	0	23426006	4052083		
14346	1345	40766240	1993-01-02	1993-01-02 00:00:00	1993-01-02	5001	0	\N	0	0	\N	\N	0	89126	0	63513-6	40766240		
57857	1764	4024958	2003-05-18	2003-05-18 00:00:00	2003-05-18	5001	0	\N	0	0	\N	\N	0	117942	0	117015009	4024958		
14496	1355	3006322	1966-09-07	1966-09-07 00:00:00	1966-09-07	5001	0	\N	0	0	\N	\N	0	89796	0	8331-1	3006322		
25880	2381	3006322	1945-05-06	1945-05-06 00:00:00	1945-05-06	5001	0	\N	0	0	\N	\N	0	158345	0	8331-1	3006322		
37253	3436	3006322	2014-08-28	2014-08-28 00:00:00	2014-08-28	5001	0	\N	0	0	\N	\N	0	227891	0	8331-1	3006322		
42789	1317	4052083	1957-10-09	1957-10-09 00:00:00	1957-10-09	5001	0	\N	0	0	\N	\N	0	87241	0	23426006	4052083		
9921	948	3006322	1980-08-08	1980-08-08 00:00:00	1980-08-08	5001	0	\N	0	0	\N	\N	0	62966	0	8331-1	3006322		
9970	949	3011505	2009-11-09	2009-11-09 00:00:00	2009-11-09	5001	0	\N	0	0	\N	\N	0	63041	0	19926-5	3011505		
22582	2070	3020655	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	137700	0	6844-5	3020655		
50745	4626	3021226	1997-11-21	1997-11-21 00:00:00	1997-11-21	5001	0	\N	0	0	\N	\N	0	308259	0	6246-3	3021226		
50798	4630	3006322	1973-09-23	1973-09-23 00:00:00	1973-09-23	5001	0	\N	0	0	\N	\N	0	308525	0	8331-1	3006322		
16156	1476	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	98383	0	6206-7	3012494		
45694	4217	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	279980	0	6206-7	3012494		
45776	4220	3006322	1995-06-27	1995-06-27 00:00:00	1995-06-27	5001	0	\N	0	0	\N	\N	0	280224	0	8331-1	3006322		
27318	2535	3006322	1988-08-26	1988-08-26 00:00:00	1988-08-26	5001	0	\N	0	0	\N	\N	0	167553	0	8331-1	3006322		
24933	2289	3006322	1953-02-28	1953-02-28 00:00:00	1953-02-28	5001	0	\N	0	0	\N	\N	0	152215	0	8331-1	3006322		
24973	2291	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	152470	0	6246-3	3021226		
147767	4529	4133840	2003-11-23	2003-11-23 00:00:00	2003-11-23	5001	0	\N	0	0	\N	\N	0	301555	0	127783003	4133840		
37232	3432	3006322	2012-09-13	2012-09-13 00:00:00	2012-09-13	5001	0	\N	0	0	\N	\N	0	227564	0	8331-1	3006322		
36483	3352	3006322	2012-06-20	2012-06-20 00:00:00	2012-06-20	5001	0	\N	0	0	\N	\N	0	222306	0	8331-1	3006322		
3278	99	4133840	1998-11-21	1998-11-21 00:00:00	1998-11-21	5001	0	\N	0	0	\N	\N	0	6747	0	127783003	4133840		
4168	411	3012494	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	27261	0	6206-7	3012494		
4287	421	3006322	1970-03-23	1970-03-23 00:00:00	1970-03-23	5001	0	\N	0	0	\N	\N	0	27884	0	8331-1	3006322		
8645	829	3006322	2016-09-04	2016-09-04 00:00:00	2016-09-04	5001	0	\N	0	0	\N	\N	0	54931	0	8331-1	3006322		
37870	3494	3011505	2018-11-29	2018-11-29 00:00:00	2018-11-29	5001	0	\N	0	0	\N	\N	0	231739	0	19926-5	3011505		
20075	1844	3006322	1976-11-29	1976-11-29 00:00:00	1976-11-29	5001	0	\N	0	0	\N	\N	0	123134	0	8331-1	3006322		
31809	2902	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	193380	0	7258-7	3001488		
14503	1355	46235214	1966-02-04	1966-02-04 00:00:00	1966-02-04	5001	0	\N	0	0	\N	\N	0	89794	0	76690-7	46235214		
14554	1355	40758406	1966-08-03	1966-08-03 00:00:00	1966-08-03	5001	0	\N	0	0	\N	\N	0	89795	0	55277-8	40758406		
14622	1356	3001488	1995-02-23	1995-02-23 00:00:00	1995-02-23	5001	0	\N	0	0	\N	\N	0	89888	0	7258-7	3001488		
26012	2392	3011505	2013-10-04	2013-10-04 00:00:00	2013-10-04	5001	0	\N	0	0	\N	\N	0	159068	0	19926-5	3011505		
28850	2669	40766240	1978-07-06	1978-07-06 00:00:00	1978-07-06	5001	0	\N	0	0	\N	\N	0	176811	0	63513-6	40766240		
37439	3446	3006322	1991-10-18	1991-10-18 00:00:00	1991-10-18	5001	0	\N	0	0	\N	\N	0	228850	0	8331-1	3006322		
56131	5150	3006322	1977-09-01	1977-09-01 00:00:00	1977-09-01	5001	0	\N	0	0	\N	\N	0	342391	0	8331-1	3006322		
48882	4474	3006322	2018-02-23	2018-02-23 00:00:00	2018-02-23	5001	0	\N	0	0	\N	\N	0	297656	0	8331-1	3006322		
28033	2577	3001247	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	170596	0	6085-5	3001247		
55368	5076	3006322	1970-12-29	1970-12-29 00:00:00	1970-12-29	5001	0	\N	0	0	\N	\N	0	337397	0	8331-1	3006322		
46088	4250	3006322	1947-07-22	1947-07-22 00:00:00	1947-07-22	5001	0	\N	0	0	\N	\N	0	282332	0	8331-1	3006322		
24148	2218	3014599	1979-03-30	1979-03-30 00:00:00	1979-03-30	5001	0	\N	0	0	\N	\N	0	147700	0	6106-9	3014599		
57543	5284	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	351551	0	6844-5	3020655		
47287	4359	3006322	1988-03-06	1988-03-06 00:00:00	1988-03-06	5001	0	\N	0	0	\N	\N	0	289178	0	8331-1	3006322		
52064	4781	3006322	2016-12-14	2016-12-14 00:00:00	2016-12-14	5001	0	\N	0	0	\N	\N	0	318303	0	8331-1	3006322		
36322	3337	3051031	2013-04-24	2013-04-24 00:00:00	2013-04-24	5001	0	\N	0	0	\N	\N	0	221392	0	46240-8	3051031		
19456	1778	40758406	1981-07-16	1981-07-16 00:00:00	1981-07-16	5001	0	\N	0	0	\N	\N	0	118951	0	55277-8	40758406		
51557	4719	3027231	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	314290	0	6276-0	3027231		
51627	4725	3019406	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	314894	0	6158-0	3019406		
122467	3778	4024958	1997-03-10	1997-03-10 00:00:00	1997-03-10	5001	0	\N	0	0	\N	\N	0	251089	0	117015009	4024958		
40708	1264	4133840	2011-11-11	2011-11-11 00:00:00	2011-11-11	5001	0	\N	0	0	\N	\N	0	83281	0	127783003	4133840		
42420	3916	3023430	1979-04-17	1979-04-17 00:00:00	1979-04-17	5001	0	\N	0	0	\N	\N	0	260278	0	6833-8	3023430		
42954	3968	3006322	1954-03-29	1954-03-29 00:00:00	1954-03-29	5001	0	\N	0	0	\N	\N	0	263851	0	8331-1	3006322		
54300	4967	3006322	2010-05-07	2010-05-07 00:00:00	2010-05-07	5001	0	\N	0	0	\N	\N	0	330165	0	8331-1	3006322		
54380	4971	3011505	2000-12-05	2000-12-05 00:00:00	2000-12-05	5001	0	\N	0	0	\N	\N	0	330636	0	19926-5	3011505		
21242	1967	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	130834	0	6106-9	3014599		
32629	2959	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	197575	0	6075-6	3005136		
7618	730	3006322	2017-12-03	2017-12-03 00:00:00	2017-12-03	5001	0	\N	0	0	\N	\N	0	48467	0	8331-1	3006322		
32745	2966	3006322	2005-07-08	2005-07-08 00:00:00	2005-07-08	5001	0	\N	0	0	\N	\N	0	198048	0	8331-1	3006322		
172655	5299	4052083	1979-09-30	1979-09-30 00:00:00	1979-09-30	5001	0	\N	0	0	\N	\N	0	352494	0	23426006	4052083		
7066	679	3006322	1981-12-28	1981-12-28 00:00:00	1981-12-28	5001	0	\N	0	0	\N	\N	0	44955	0	8331-1	3006322		
6421	603	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	39910	0	6106-9	3014599		
79576	2448	4024958	1974-01-06	1974-01-06 00:00:00	1974-01-06	5001	0	\N	0	0	\N	\N	0	162364	0	117015009	4024958		
90771	2802	4052083	1971-05-16	1971-05-16 00:00:00	1971-05-16	5001	0	\N	0	0	\N	\N	0	185741	0	23426006	4052083		
29181	2686	3006322	2011-03-25	2011-03-25 00:00:00	2011-03-25	5001	0	\N	0	0	\N	\N	0	177998	0	8331-1	3006322		
7762	246	4024958	1964-09-13	1964-09-13 00:00:00	1964-09-13	5001	0	\N	0	0	\N	\N	0	16521	0	117015009	4024958		
32027	987	4024958	1999-09-17	1999-09-17 00:00:00	1999-09-17	5001	0	\N	0	0	\N	\N	0	65601	0	117015009	4024958		
14348	1345	3006322	2016-12-02	2016-12-02 00:00:00	2016-12-02	5001	0	\N	0	0	\N	\N	0	89162	0	8331-1	3006322		
57858	1764	4052083	1978-11-01	1978-11-01 00:00:00	1978-11-01	5001	0	\N	0	0	\N	\N	0	117939	0	23426006	4052083		
14497	1355	3051031	1966-01-05	1966-01-05 00:00:00	1966-01-05	5001	0	\N	0	0	\N	\N	0	89835	0	46240-8	3051031		
25881	2381	3006322	1938-08-08	1938-08-08 00:00:00	1938-08-08	5001	0	\N	0	0	\N	\N	0	158283	0	8331-1	3006322		
37254	3437	3006322	1956-06-03	1956-06-03 00:00:00	1956-06-03	5001	0	\N	0	0	\N	\N	0	228008	0	8331-1	3006322		
42793	1317	4133840	2001-11-09	2001-11-09 00:00:00	2001-11-09	5001	0	\N	0	0	\N	\N	0	87313	0	127783003	4133840		
9922	948	3006322	1993-06-19	1993-06-19 00:00:00	1993-06-19	5001	0	\N	0	0	\N	\N	0	62954	0	8331-1	3006322		
9971	949	3011505	2003-09-29	2003-09-29 00:00:00	2003-09-29	5001	0	\N	0	0	\N	\N	0	63039	0	19926-5	3011505		
22583	2070	3023430	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	137700	0	6833-8	3023430		
50746	4626	3023430	1997-11-21	1997-11-21 00:00:00	1997-11-21	5001	0	\N	0	0	\N	\N	0	308259	0	6833-8	3023430		
50799	4630	3006322	1991-07-03	1991-07-03 00:00:00	1991-07-03	5001	0	\N	0	0	\N	\N	0	308482	0	8331-1	3006322		
16157	1476	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	98383	0	6085-5	3001247		
45695	4217	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	279980	0	6075-6	3005136		
45777	4220	3006322	1953-11-28	1953-11-28 00:00:00	1953-11-28	5001	0	\N	0	0	\N	\N	0	280195	0	8331-1	3006322		
27319	2535	3006322	1972-09-09	1972-09-09 00:00:00	1972-09-09	5001	0	\N	0	0	\N	\N	0	167482	0	8331-1	3006322		
24934	2289	3006322	1950-04-04	1950-04-04 00:00:00	1950-04-04	5001	0	\N	0	0	\N	\N	0	152256	0	8331-1	3006322		
24974	2291	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	152470	0	6158-0	3019406		
147769	4529	4133840	2016-12-04	2016-12-04 00:00:00	2016-12-04	5001	0	\N	0	0	\N	\N	0	301603	0	127783003	4133840		
169232	5194	4024958	1969-12-19	1969-12-19 00:00:00	1969-12-19	5001	0	\N	0	0	\N	\N	0	345309	0	117015009	4024958		
36484	3352	3011505	2010-11-12	2010-11-12 00:00:00	2010-11-12	5001	0	\N	0	0	\N	\N	0	222281	0	19926-5	3011505		
3279	99	4133840	2009-07-18	2009-07-18 00:00:00	2009-07-18	5001	0	\N	0	0	\N	\N	0	6751	0	127783003	4133840		
4169	411	3023430	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	27261	0	6833-8	3023430		
4288	422	3006322	1984-02-07	1984-02-07 00:00:00	1984-02-07	5001	0	\N	0	0	\N	\N	0	27967	0	8331-1	3006322		
8646	829	3006322	1988-11-22	1988-11-22 00:00:00	1988-11-22	5001	0	\N	0	0	\N	\N	0	54897	0	8331-1	3006322		
37871	3494	3011505	2017-11-23	2017-11-23 00:00:00	2017-11-23	5001	0	\N	0	0	\N	\N	0	231793	0	19926-5	3011505		
20077	1844	3051031	1986-10-27	1986-10-27 00:00:00	1986-10-27	5001	0	\N	0	0	\N	\N	0	123172	0	46240-8	3051031		
31810	2902	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	193380	0	6095-4	3036780		
14504	1355	3051031	1966-02-04	1966-02-04 00:00:00	1966-02-04	5001	0	\N	0	0	\N	\N	0	89794	0	46240-8	3051031		
14555	1355	40766240	1966-08-03	1966-08-03 00:00:00	1966-08-03	5001	0	\N	0	0	\N	\N	0	89795	0	63513-6	40766240		
14623	1356	3019406	1995-02-23	1995-02-23 00:00:00	1995-02-23	5001	0	\N	0	0	\N	\N	0	89888	0	6158-0	3019406		
26013	2392	3011505	1983-12-16	1983-12-16 00:00:00	1983-12-16	5001	0	\N	0	0	\N	\N	0	159079	0	19926-5	3011505		
28853	2669	3051031	1978-07-06	1978-07-06 00:00:00	1978-07-06	5001	0	\N	0	0	\N	\N	0	176811	0	46240-8	3051031		
37449	3454	3006322	2015-08-17	2015-08-17 00:00:00	2015-08-17	5001	0	\N	0	0	\N	\N	0	229180	0	8331-1	3006322		
56132	5150	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	342380	0	7258-7	3001488		
48883	4474	3006322	1965-11-26	1965-11-26 00:00:00	1965-11-26	5001	0	\N	0	0	\N	\N	0	297669	0	8331-1	3006322		
28034	2577	3023430	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	170596	0	6833-8	3023430		
55369	5076	3006322	2003-10-19	2003-10-19 00:00:00	2003-10-19	5001	0	\N	0	0	\N	\N	0	337400	0	8331-1	3006322		
46089	4250	3006322	2016-03-07	2016-03-07 00:00:00	2016-03-07	5001	0	\N	0	0	\N	\N	0	282297	0	8331-1	3006322		
24149	2218	3023430	1979-03-30	1979-03-30 00:00:00	1979-03-30	5001	0	\N	0	0	\N	\N	0	147700	0	6833-8	3023430		
57544	5284	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	351551	0	6095-4	3036780		
47288	4359	3006322	2017-09-28	2017-09-28 00:00:00	2017-09-28	5001	0	\N	0	0	\N	\N	0	289253	0	8331-1	3006322		
52065	4781	40766240	2009-10-25	2009-10-25 00:00:00	2009-10-25	5001	0	\N	0	0	\N	\N	0	318256	0	63513-6	40766240		
36323	3337	46235214	2013-04-24	2013-04-24 00:00:00	2013-04-24	5001	0	\N	0	0	\N	\N	0	221392	0	76690-7	46235214		
19457	1778	3051031	1981-07-16	1981-07-16 00:00:00	1981-07-16	5001	0	\N	0	0	\N	\N	0	118951	0	46240-8	3051031		
51558	4719	3020655	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	314290	0	6844-5	3020655		
51628	4725	3020655	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	314894	0	6844-5	3020655		
122489	3778	4052083	2003-01-15	2003-01-15 00:00:00	2003-01-15	5001	0	\N	0	0	\N	\N	0	251061	0	23426006	4052083		
40711	1264	4133840	2000-01-21	2000-01-21 00:00:00	2000-01-21	5001	0	\N	0	0	\N	\N	0	83303	0	127783003	4133840		
42421	3916	3020655	1979-04-17	1979-04-17 00:00:00	1979-04-17	5001	0	\N	0	0	\N	\N	0	260278	0	6844-5	3020655		
42955	3968	3006322	1939-07-30	1939-07-30 00:00:00	1939-07-30	5001	0	\N	0	0	\N	\N	0	263850	0	8331-1	3006322		
54301	4967	3006322	1995-06-12	1995-06-12 00:00:00	1995-06-12	5001	0	\N	0	0	\N	\N	0	330158	0	8331-1	3006322		
54381	4971	3011505	2011-02-01	2011-02-01 00:00:00	2011-02-01	5001	0	\N	0	0	\N	\N	0	330581	0	19926-5	3011505		
21243	1967	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	130834	0	6085-5	3001247		
32630	2959	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	197575	0	7258-7	3001488		
7620	732	3006322	1991-06-05	1991-06-05 00:00:00	1991-06-05	5001	0	\N	0	0	\N	\N	0	48569	0	8331-1	3006322		
32746	2966	3000876	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	198142	0	6082-2	3000876		
151943	4655	4052083	2011-11-27	2011-11-27 00:00:00	2011-11-27	5001	0	\N	0	0	\N	\N	0	310345	0	23426006	4052083		
7067	679	3006322	1978-05-10	1978-05-10 00:00:00	1978-05-10	5001	0	\N	0	0	\N	\N	0	44937	0	8331-1	3006322		
6422	603	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	39910	0	6273-7	3006451		
79578	2448	4052083	1979-12-26	1979-12-26 00:00:00	1979-12-26	5001	0	\N	0	0	\N	\N	0	162389	0	23426006	4052083		
90775	2802	4024958	1944-04-11	1944-04-11 00:00:00	1944-04-11	5001	0	\N	0	0	\N	\N	0	185762	0	117015009	4024958		
29182	2686	3006322	2015-12-26	2015-12-26 00:00:00	2015-12-26	5001	0	\N	0	0	\N	\N	0	178034	0	8331-1	3006322		
7764	246	4133840	2013-05-16	2013-05-16 00:00:00	2013-05-16	5001	0	\N	0	0	\N	\N	0	16569	0	127783003	4133840		
32031	987	4052083	1959-08-12	1959-08-12 00:00:00	1959-08-12	5001	0	\N	0	0	\N	\N	0	65580	0	23426006	4052083		
14349	1345	46235214	1992-12-03	1992-12-03 00:00:00	1992-12-03	5001	0	\N	0	0	\N	\N	0	89105	0	76690-7	46235214		
57866	1764	4052083	1995-01-19	1995-01-19 00:00:00	1995-01-19	5001	0	\N	0	0	\N	\N	0	117983	0	23426006	4052083		
14498	1355	46235214	1966-01-05	1966-01-05 00:00:00	1966-01-05	5001	0	\N	0	0	\N	\N	0	89835	0	76690-7	46235214		
25882	2381	3006322	1951-09-26	1951-09-26 00:00:00	1951-09-26	5001	0	\N	0	0	\N	\N	0	158314	0	8331-1	3006322		
37256	3437	40766240	1924-07-23	1924-07-23 00:00:00	1924-07-23	5001	0	\N	0	0	\N	\N	0	227936	0	63513-6	40766240		
42797	1317	4133840	2009-12-25	2009-12-25 00:00:00	2009-12-25	5001	0	\N	0	0	\N	\N	0	87331	0	127783003	4133840		
9923	948	3006322	1976-08-16	1976-08-16 00:00:00	1976-08-16	5001	0	\N	0	0	\N	\N	0	62952	0	8331-1	3006322		
9972	949	3011505	2011-11-21	2011-11-21 00:00:00	2011-11-21	5001	0	\N	0	0	\N	\N	0	63042	0	19926-5	3011505		
22584	2070	3000876	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	137700	0	6082-2	3000876		
50747	4626	3006451	1997-11-21	1997-11-21 00:00:00	1997-11-21	5001	0	\N	0	0	\N	\N	0	308259	0	6273-7	3006451		
50800	4631	3006322	1977-10-28	1977-10-28 00:00:00	1977-10-28	5001	0	\N	0	0	\N	\N	0	308607	0	8331-1	3006322		
16158	1476	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	98383	0	7258-7	3001488		
45696	4217	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	279980	0	6106-9	3014599		
45778	4220	3006322	2008-11-28	2008-11-28 00:00:00	2008-11-28	5001	0	\N	0	0	\N	\N	0	280202	0	8331-1	3006322		
27320	2537	3006322	1973-07-04	1973-07-04 00:00:00	1973-07-04	5001	0	\N	0	0	\N	\N	0	167760	0	8331-1	3006322		
24935	2289	3049273	2009-12-29	2009-12-29 00:00:00	2009-12-29	5001	0	\N	0	0	\N	\N	0	152245	0	38265-5	3049273		
24975	2291	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	152470	0	7258-7	3001488		
147771	4529	4133840	2017-12-10	2017-12-10 00:00:00	2017-12-10	5001	0	\N	0	0	\N	\N	0	301565	0	127783003	4133840		
169242	5194	4024958	1946-06-18	1946-06-18 00:00:00	1946-06-18	5001	0	\N	0	0	\N	\N	0	345308	0	117015009	4024958		
36485	3352	3011505	1998-12-18	1998-12-18 00:00:00	1998-12-18	5001	0	\N	0	0	\N	\N	0	222303	0	19926-5	3011505		
3280	99	4133840	2006-12-09	2006-12-09 00:00:00	2006-12-09	5001	0	\N	0	0	\N	\N	0	6748	0	127783003	4133840		
4170	411	3019406	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	27256	0	6158-0	3019406		
4289	422	3006322	1997-08-19	1997-08-19 00:00:00	1997-08-19	5001	0	\N	0	0	\N	\N	0	27968	0	8331-1	3006322		
8647	829	3006322	1984-04-26	1984-04-26 00:00:00	1984-04-26	5001	0	\N	0	0	\N	\N	0	54905	0	8331-1	3006322		
37872	3494	3011505	2012-08-16	2012-08-16 00:00:00	2012-08-16	5001	0	\N	0	0	\N	\N	0	231754	0	19926-5	3011505		
20079	1844	46235214	1986-10-27	1986-10-27 00:00:00	1986-10-27	5001	0	\N	0	0	\N	\N	0	123172	0	76690-7	46235214		
31811	2902	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	193380	0	6206-7	3012494		
49351	4505	3006451	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	299990	0	6273-7	3006451		
14556	1355	46235214	1966-08-03	1966-08-03 00:00:00	1966-08-03	5001	0	\N	0	0	\N	\N	0	89795	0	76690-7	46235214		
14624	1356	3012494	1995-02-23	1995-02-23 00:00:00	1995-02-23	5001	0	\N	0	0	\N	\N	0	89888	0	6206-7	3012494		
26014	2392	3006322	1976-01-22	1976-01-22 00:00:00	1976-01-22	5001	0	\N	0	0	\N	\N	0	159101	0	8331-1	3006322		
28854	2669	46235214	2010-09-21	2010-09-21 00:00:00	2010-09-21	5001	0	\N	0	0	\N	\N	0	176815	0	76690-7	46235214		
37450	3455	3006322	1983-01-15	1983-01-15 00:00:00	1983-01-15	5001	0	\N	0	0	\N	\N	0	229201	0	8331-1	3006322		
56133	5150	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	342380	0	6844-5	3020655		
48884	4474	3006322	1972-07-19	1972-07-19 00:00:00	1972-07-19	5001	0	\N	0	0	\N	\N	0	297641	0	8331-1	3006322		
28035	2577	3036780	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	170596	0	6095-4	3036780		
55370	5076	40758406	1943-04-06	1943-04-06 00:00:00	1943-04-06	5001	0	\N	0	0	\N	\N	0	337416	0	55277-8	40758406		
46090	4250	3049273	2000-06-24	2000-06-24 00:00:00	2000-06-24	5001	0	\N	0	0	\N	\N	0	282263	0	38265-5	3049273		
24150	2218	3001247	1979-03-30	1979-03-30 00:00:00	1979-03-30	5001	0	\N	0	0	\N	\N	0	147700	0	6085-5	3001247		
57545	5284	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	351551	0	7258-7	3001488		
47289	4359	3006322	1959-01-15	1959-01-15 00:00:00	1959-01-15	5001	0	\N	0	0	\N	\N	0	289217	0	8331-1	3006322		
52066	4781	3051031	2009-10-25	2009-10-25 00:00:00	2009-10-25	5001	0	\N	0	0	\N	\N	0	318256	0	46240-8	3051031		
36324	3337	40766240	2013-04-24	2013-04-24 00:00:00	2013-04-24	5001	0	\N	0	0	\N	\N	0	221392	0	63513-6	40766240		
19460	1778	46235214	1981-07-16	1981-07-16 00:00:00	1981-07-16	5001	0	\N	0	0	\N	\N	0	118951	0	76690-7	46235214		
51559	4719	3036780	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	314290	0	6095-4	3036780		
51629	4725	3023430	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	314894	0	6833-8	3023430		
122496	3779	4024958	1978-09-05	1978-09-05 00:00:00	1978-09-05	5001	0	\N	0	0	\N	\N	0	251111	0	117015009	4024958		
40712	1264	4133840	2004-02-27	2004-02-27 00:00:00	2004-02-27	5001	0	\N	0	0	\N	\N	0	83285	0	127783003	4133840		
42422	3916	3006451	1979-04-17	1979-04-17 00:00:00	1979-04-17	5001	0	\N	0	0	\N	\N	0	260278	0	6273-7	3006451		
42956	3968	3006322	1972-04-02	1972-04-02 00:00:00	1972-04-02	5001	0	\N	0	0	\N	\N	0	263836	0	8331-1	3006322		
54302	4967	3006322	1971-11-16	1971-11-16 00:00:00	1971-11-16	5001	0	\N	0	0	\N	\N	0	330138	0	8331-1	3006322		
54382	4971	3011505	2019-04-09	2019-04-09 00:00:00	2019-04-09	5001	0	\N	0	0	\N	\N	0	330534	0	19926-5	3011505		
21244	1967	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	130834	0	6246-3	3021226		
32631	2959	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	197575	0	6189-5	3006734		
7621	732	3006322	1999-07-31	1999-07-31 00:00:00	1999-07-31	5001	0	\N	0	0	\N	\N	0	48570	0	8331-1	3006322		
32747	2966	3020655	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	198142	0	6844-5	3020655		
151969	4655	4052083	1993-06-14	1993-06-14 00:00:00	1993-06-14	5001	0	\N	0	0	\N	\N	0	310335	0	23426006	4052083		
7068	680	3006322	2016-10-04	2016-10-04 00:00:00	2016-10-04	5001	0	\N	0	0	\N	\N	0	45083	0	8331-1	3006322		
6423	603	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	39910	0	6276-0	3027231		
11182	354	4133840	2008-01-17	2008-01-17 00:00:00	2008-01-17	5001	0	\N	0	0	\N	\N	0	23589	0	127783003	4133840		
90777	2802	4024958	1941-03-13	1941-03-13 00:00:00	1941-03-13	5001	0	\N	0	0	\N	\N	0	185735	0	117015009	4024958		
29183	2686	3006322	1962-05-18	1962-05-18 00:00:00	1962-05-18	5001	0	\N	0	0	\N	\N	0	177983	0	8331-1	3006322		
7766	246	4133840	2009-04-23	2009-04-23 00:00:00	2009-04-23	5001	0	\N	0	0	\N	\N	0	16567	0	127783003	4133840		
67687	2075	4052083	2019-04-03	2019-04-03 00:00:00	2019-04-03	5001	0	\N	0	0	\N	\N	0	138032	0	23426006	4052083		
14352	1345	40766240	1992-12-03	1992-12-03 00:00:00	1992-12-03	5001	0	\N	0	0	\N	\N	0	89105	0	63513-6	40766240		
44973	4156	46235214	2000-11-11	2000-11-11 00:00:00	2000-11-11	5001	0	\N	0	0	\N	\N	0	276211	0	76690-7	46235214		
14499	1355	40758406	1966-01-05	1966-01-05 00:00:00	1966-01-05	5001	0	\N	0	0	\N	\N	0	89835	0	55277-8	40758406		
25889	2384	3006322	1985-02-19	1985-02-19 00:00:00	1985-02-19	5001	0	\N	0	0	\N	\N	0	158471	0	8331-1	3006322		
37257	3437	46235214	1924-07-23	1924-07-23 00:00:00	1924-07-23	5001	0	\N	0	0	\N	\N	0	227936	0	76690-7	46235214		
42803	1317	4133840	2003-11-21	2003-11-21 00:00:00	2003-11-21	5001	0	\N	0	0	\N	\N	0	87314	0	127783003	4133840		
9924	948	3006322	1989-12-27	1989-12-27 00:00:00	1989-12-27	5001	0	\N	0	0	\N	\N	0	62970	0	8331-1	3006322		
9973	950	3006322	2002-08-02	2002-08-02 00:00:00	2002-08-02	5001	0	\N	0	0	\N	\N	0	63069	0	8331-1	3006322		
22585	2070	3001488	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	137700	0	7258-7	3001488		
50748	4626	3012494	1997-11-21	1997-11-21 00:00:00	1997-11-21	5001	0	\N	0	0	\N	\N	0	308259	0	6206-7	3012494		
50801	4631	3049273	2002-06-28	2002-06-28 00:00:00	2002-06-28	5001	0	\N	0	0	\N	\N	0	308560	0	38265-5	3049273		
16159	1476	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	98383	0	6189-5	3006734		
45697	4217	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	279980	0	6158-0	3019406		
45779	4220	3006322	1972-11-10	1972-11-10 00:00:00	1972-11-10	5001	0	\N	0	0	\N	\N	0	280222	0	8331-1	3006322		
27321	2537	3006322	1958-01-15	1958-01-15 00:00:00	1958-01-15	5001	0	\N	0	0	\N	\N	0	167754	0	8331-1	3006322		
24936	2290	3006322	1984-05-14	1984-05-14 00:00:00	1984-05-14	5001	0	\N	0	0	\N	\N	0	152353	0	8331-1	3006322		
24976	2291	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	152470	0	6085-5	3001247		
147773	4529	4024958	1989-01-25	1989-01-25 00:00:00	1989-01-25	5001	0	\N	0	0	\N	\N	0	301568	0	117015009	4024958		
169245	5194	4052083	2000-05-08	2000-05-08 00:00:00	2000-05-08	5001	0	\N	0	0	\N	\N	0	345400	0	23426006	4052083		
36486	3352	3011505	2012-11-16	2012-11-16 00:00:00	2012-11-16	5001	0	\N	0	0	\N	\N	0	222321	0	19926-5	3011505		
3285	99	4133840	2019-04-27	2019-04-27 00:00:00	2019-04-27	5001	0	\N	0	0	\N	\N	0	6754	0	127783003	4133840		
4171	411	3006451	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	27256	0	6273-7	3006451		
4290	422	3006322	2016-04-28	2016-04-28 00:00:00	2016-04-28	5001	0	\N	0	0	\N	\N	0	27942	0	8331-1	3006322		
8648	829	3006322	1983-04-09	1983-04-09 00:00:00	1983-04-09	5001	0	\N	0	0	\N	\N	0	54924	0	8331-1	3006322		
37873	3494	3011505	2001-05-03	2001-05-03 00:00:00	2001-05-03	5001	0	\N	0	0	\N	\N	0	231734	0	19926-5	3011505		
20080	1844	40758406	1986-10-27	1986-10-27 00:00:00	1986-10-27	5001	0	\N	0	0	\N	\N	0	123172	0	55277-8	40758406		
31812	2902	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	193380	0	6082-2	3000876		
49352	4505	3012494	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	299990	0	6206-7	3012494		
14557	1355	3051031	1966-08-03	1966-08-03 00:00:00	1966-08-03	5001	0	\N	0	0	\N	\N	0	89795	0	46240-8	3051031		
14625	1356	3021226	1995-02-23	1995-02-23 00:00:00	1995-02-23	5001	0	\N	0	0	\N	\N	0	89888	0	6246-3	3021226		
26015	2392	3011505	1987-03-20	1987-03-20 00:00:00	1987-03-20	5001	0	\N	0	0	\N	\N	0	159004	0	19926-5	3011505		
28855	2669	40758406	2010-09-21	2010-09-21 00:00:00	2010-09-21	5001	0	\N	0	0	\N	\N	0	176815	0	55277-8	40758406		
37451	3455	3006322	1991-03-17	1991-03-17 00:00:00	1991-03-17	5001	0	\N	0	0	\N	\N	0	229202	0	8331-1	3006322		
56134	5150	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	342380	0	6189-5	3006734		
48885	4474	3006322	1969-10-22	1969-10-22 00:00:00	1969-10-22	5001	0	\N	0	0	\N	\N	0	297696	0	8331-1	3006322		
28036	2577	3020655	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	170596	0	6844-5	3020655		
55371	5076	3051031	1943-04-06	1943-04-06 00:00:00	1943-04-06	5001	0	\N	0	0	\N	\N	0	337416	0	46240-8	3051031		
46093	4253	3006322	1996-06-30	1996-06-30 00:00:00	1996-06-30	5001	0	\N	0	0	\N	\N	0	282447	0	8331-1	3006322		
24151	2218	3000876	1979-03-30	1979-03-30 00:00:00	1979-03-30	5001	0	\N	0	0	\N	\N	0	147700	0	6082-2	3000876		
57546	5284	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	351551	0	6085-5	3001247		
128512	3956	4052083	2012-10-02	2012-10-02 00:00:00	2012-10-02	5001	0	\N	0	0	\N	\N	0	262968	0	23426006	4052083		
52068	4781	46235214	2009-10-25	2009-10-25 00:00:00	2009-10-25	5001	0	\N	0	0	\N	\N	0	318256	0	76690-7	46235214		
36327	3337	40758406	2013-04-24	2013-04-24 00:00:00	2013-04-24	5001	0	\N	0	0	\N	\N	0	221392	0	55277-8	40758406		
19461	1778	40766240	1981-07-16	1981-07-16 00:00:00	1981-07-16	5001	0	\N	0	0	\N	\N	0	118951	0	63513-6	40766240		
51560	4719	3023430	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	314290	0	6833-8	3023430		
51630	4725	3036780	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	314894	0	6095-4	3036780		
122503	3779	4052083	1975-08-07	1975-08-07 00:00:00	1975-08-07	5001	0	\N	0	0	\N	\N	0	251144	0	23426006	4052083		
40715	1264	4133840	2018-06-01	2018-06-01 00:00:00	2018-06-01	5001	0	\N	0	0	\N	\N	0	83283	0	127783003	4133840		
42423	3916	3021226	1979-04-17	1979-04-17 00:00:00	1979-04-17	5001	0	\N	0	0	\N	\N	0	260278	0	6246-3	3021226		
42957	3968	3006322	1923-04-12	1923-04-12 00:00:00	1923-04-12	5001	0	\N	0	0	\N	\N	0	263790	0	8331-1	3006322		
54308	4970	3006322	1926-09-30	1926-09-30 00:00:00	1926-09-30	5001	0	\N	0	0	\N	\N	0	330473	0	8331-1	3006322		
54383	4971	3049273	2000-11-12	2000-11-12 00:00:00	2000-11-12	5001	0	\N	0	0	\N	\N	0	330514	0	38265-5	3049273		
21245	1967	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	130834	0	6844-5	3020655		
32632	2959	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	197575	0	6844-5	3020655		
101360	3115	4024958	2001-08-15	2001-08-15 00:00:00	2001-08-15	5001	0	\N	0	0	\N	\N	0	207210	0	117015009	4024958		
32748	2966	3001247	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	198142	0	6085-5	3001247		
163257	5015	4024958	1994-09-07	1994-09-07 00:00:00	1994-09-07	5001	0	\N	0	0	\N	\N	0	333361	0	117015009	4024958		
7069	680	3006322	1983-07-06	1983-07-06 00:00:00	1983-07-06	5001	0	\N	0	0	\N	\N	0	45003	0	8331-1	3006322		
6424	603	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	39910	0	6206-7	3012494		
11185	354	4133840	2017-03-09	2017-03-09 00:00:00	2017-03-09	5001	0	\N	0	0	\N	\N	0	23594	0	127783003	4133840		
90786	2802	4024958	1953-09-01	1953-09-01 00:00:00	1953-09-01	5001	0	\N	0	0	\N	\N	0	185705	0	117015009	4024958		
29184	2686	3006322	2013-08-23	2013-08-23 00:00:00	2013-08-23	5001	0	\N	0	0	\N	\N	0	178033	0	8331-1	3006322		
7774	246	4133840	2005-04-14	2005-04-14 00:00:00	2005-04-14	5001	0	\N	0	0	\N	\N	0	16534	0	127783003	4133840		
67707	2075	4024958	1978-04-14	1978-04-14 00:00:00	1978-04-14	5001	0	\N	0	0	\N	\N	0	138067	0	117015009	4024958		
14353	1345	40758406	1992-12-03	1992-12-03 00:00:00	1992-12-03	5001	0	\N	0	0	\N	\N	0	89105	0	55277-8	40758406		
44974	4156	40758406	2000-11-11	2000-11-11 00:00:00	2000-11-11	5001	0	\N	0	0	\N	\N	0	276211	0	55277-8	40758406		
25780	2366	3006322	1967-06-09	1967-06-09 00:00:00	1967-06-09	5001	0	\N	0	0	\N	\N	0	157526	0	8331-1	3006322		
25890	2384	3006322	2004-01-24	2004-01-24 00:00:00	2004-01-24	5001	0	\N	0	0	\N	\N	0	158509	0	8331-1	3006322		
37259	3437	3051031	1924-07-23	1924-07-23 00:00:00	1924-07-23	5001	0	\N	0	0	\N	\N	0	227936	0	46240-8	3051031		
100494	3083	4024958	1996-11-13	1996-11-13 00:00:00	1996-11-13	5001	0	\N	0	0	\N	\N	0	205264	0	117015009	4024958		
9925	949	3011505	2017-12-25	2017-12-25 00:00:00	2017-12-25	5001	0	\N	0	0	\N	\N	0	63019	0	19926-5	3011505		
9974	950	3006322	1981-03-29	1981-03-29 00:00:00	1981-03-29	5001	0	\N	0	0	\N	\N	0	63100	0	8331-1	3006322		
22586	2070	3027231	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	137700	0	6276-0	3027231		
50749	4626	3001488	1997-11-21	1997-11-21 00:00:00	1997-11-21	5001	0	\N	0	0	\N	\N	0	308259	0	7258-7	3001488		
50802	4631	3006322	1933-10-10	1933-10-10 00:00:00	1933-10-10	5001	0	\N	0	0	\N	\N	0	308581	0	8331-1	3006322		
16160	1476	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	98383	0	6106-9	3014599		
45698	4217	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	279980	0	6248-9	3015076		
45780	4220	3006322	1968-02-23	1968-02-23 00:00:00	1968-02-23	5001	0	\N	0	0	\N	\N	0	280221	0	8331-1	3006322		
27322	2537	3006322	2003-04-21	2003-04-21 00:00:00	2003-04-21	5001	0	\N	0	0	\N	\N	0	167672	0	8331-1	3006322		
24937	2290	3006322	1999-10-07	1999-10-07 00:00:00	1999-10-07	5001	0	\N	0	0	\N	\N	0	152359	0	8331-1	3006322		
24977	2291	3006322	2016-02-21	2016-02-21 00:00:00	2016-02-21	5001	0	\N	0	0	\N	\N	0	152507	0	8331-1	3006322		
147780	4529	4133840	2009-12-06	2009-12-06 00:00:00	2009-12-06	5001	0	\N	0	0	\N	\N	0	301564	0	127783003	4133840		
169249	5195	4024958	1992-04-27	1992-04-27 00:00:00	1992-04-27	5001	0	\N	0	0	\N	\N	0	345476	0	117015009	4024958		
36487	3352	3011505	2016-11-04	2016-11-04 00:00:00	2016-11-04	5001	0	\N	0	0	\N	\N	0	222323	0	19926-5	3011505		
3288	99	4024958	1992-04-11	1992-04-11 00:00:00	1992-04-11	5001	0	\N	0	0	\N	\N	0	6720	0	117015009	4024958		
4172	411	3014599	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	27256	0	6106-9	3014599		
4291	422	3006322	2011-05-15	2011-05-15 00:00:00	2011-05-15	5001	0	\N	0	0	\N	\N	0	27954	0	8331-1	3006322		
8649	830	3006322	1985-05-11	1985-05-11 00:00:00	1985-05-11	5001	0	\N	0	0	\N	\N	0	54968	0	8331-1	3006322		
37874	3494	3011505	2003-05-08	2003-05-08 00:00:00	2003-05-08	5001	0	\N	0	0	\N	\N	0	231791	0	19926-5	3011505		
20081	1844	40766240	1986-10-27	1986-10-27 00:00:00	1986-10-27	5001	0	\N	0	0	\N	\N	0	123172	0	63513-6	40766240		
31813	2903	3006322	2003-11-20	2003-11-20 00:00:00	2003-11-20	5001	0	\N	0	0	\N	\N	0	193413	0	8331-1	3006322		
49353	4505	3019406	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	299990	0	6158-0	3019406		
14559	1355	3006322	1963-11-11	1963-11-11 00:00:00	1963-11-11	5001	0	\N	0	0	\N	\N	0	89850	0	8331-1	3006322		
14626	1356	3036780	1995-02-23	1995-02-23 00:00:00	1995-02-23	5001	0	\N	0	0	\N	\N	0	89888	0	6095-4	3036780		
26016	2392	3011505	1972-03-03	1972-03-03 00:00:00	1972-03-03	5001	0	\N	0	0	\N	\N	0	159003	0	19926-5	3011505		
28857	2669	40766240	2010-09-21	2010-09-21 00:00:00	2010-09-21	5001	0	\N	0	0	\N	\N	0	176815	0	63513-6	40766240		
37452	3455	3006322	2006-03-11	2006-03-11 00:00:00	2006-03-11	5001	0	\N	0	0	\N	\N	0	229243	0	8331-1	3006322		
56135	5150	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	342380	0	6833-8	3023430		
48886	4474	3006322	1973-02-24	1973-02-24 00:00:00	1973-02-24	5001	0	\N	0	0	\N	\N	0	297651	0	8331-1	3006322		
28037	2577	3001488	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	170596	0	7258-7	3001488		
55372	5076	46235214	1943-04-06	1943-04-06 00:00:00	1943-04-06	5001	0	\N	0	0	\N	\N	0	337416	0	76690-7	46235214		
46094	4253	3006322	2010-11-24	2010-11-24 00:00:00	2010-11-24	5001	0	\N	0	0	\N	\N	0	282443	0	8331-1	3006322		
24152	2218	3019406	1979-03-30	1979-03-30 00:00:00	1979-03-30	5001	0	\N	0	0	\N	\N	0	147700	0	6158-0	3019406		
57547	5284	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	351551	0	6248-9	3015076		
128519	3957	4024958	1988-08-13	1988-08-13 00:00:00	1988-08-13	5001	0	\N	0	0	\N	\N	0	263101	0	117015009	4024958		
52070	4781	40758406	2009-10-25	2009-10-25 00:00:00	2009-10-25	5001	0	\N	0	0	\N	\N	0	318256	0	55277-8	40758406		
36328	3337	46235214	2013-05-24	2013-05-24 00:00:00	2013-05-24	5001	0	\N	0	0	\N	\N	0	221374	0	76690-7	46235214		
19462	1778	3006322	1997-02-21	1997-02-21 00:00:00	1997-02-21	5001	0	\N	0	0	\N	\N	0	118969	0	8331-1	3006322		
51561	4719	3006734	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	314290	0	6189-5	3006734		
51631	4725	3005136	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	314894	0	6075-6	3005136		
122505	3779	4024958	1985-12-08	1985-12-08 00:00:00	1985-12-08	5001	0	\N	0	0	\N	\N	0	251112	0	117015009	4024958		
40717	1264	4133840	2003-02-21	2003-02-21 00:00:00	2003-02-21	5001	0	\N	0	0	\N	\N	0	83346	0	127783003	4133840		
53742	4929	3006322	1994-01-12	1994-01-12 00:00:00	1994-01-12	5001	0	\N	0	0	\N	\N	0	327719	0	8331-1	3006322		
42958	3968	3006322	1994-05-13	1994-05-13 00:00:00	1994-05-13	5001	0	\N	0	0	\N	\N	0	263854	0	8331-1	3006322		
54309	4970	3006322	1959-01-06	1959-01-06 00:00:00	1959-01-06	5001	0	\N	0	0	\N	\N	0	330345	0	8331-1	3006322		
54384	4971	3006322	1983-10-29	1983-10-29 00:00:00	1983-10-29	5001	0	\N	0	0	\N	\N	0	330643	0	8331-1	3006322		
21246	1967	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	130834	0	6833-8	3023430		
32633	2959	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	197575	0	6833-8	3023430		
101384	3115	4052083	2000-07-06	2000-07-06 00:00:00	2000-07-06	5001	0	\N	0	0	\N	\N	0	207209	0	23426006	4052083		
32749	2966	3014599	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	198142	0	6106-9	3014599		
163262	5015	4024958	1993-05-06	1993-05-06 00:00:00	1993-05-06	5001	0	\N	0	0	\N	\N	0	333383	0	117015009	4024958		
7070	680	3006322	1986-11-30	1986-11-30 00:00:00	1986-11-30	5001	0	\N	0	0	\N	\N	0	45017	0	8331-1	3006322		
6425	603	3006322	2010-05-05	2010-05-05 00:00:00	2010-05-05	5001	0	\N	0	0	\N	\N	0	40033	0	8331-1	3006322		
11188	354	4133840	2013-02-14	2013-02-14 00:00:00	2013-02-14	5001	0	\N	0	0	\N	\N	0	23592	0	127783003	4133840		
90790	2802	4024958	1955-06-07	1955-06-07 00:00:00	1955-06-07	5001	0	\N	0	0	\N	\N	0	185737	0	117015009	4024958		
29186	2688	3006322	2014-09-14	2014-09-14 00:00:00	2014-09-14	5001	0	\N	0	0	\N	\N	0	178147	0	8331-1	3006322		
137545	4238	4024958	1973-06-10	1973-06-10 00:00:00	1973-06-10	5001	0	\N	0	0	\N	\N	0	281359	0	117015009	4024958		
67735	2076	4052083	1987-12-09	1987-12-09 00:00:00	1987-12-09	5001	0	\N	0	0	\N	\N	0	138199	0	23426006	4052083		
14354	1345	3051031	1992-12-03	1992-12-03 00:00:00	1992-12-03	5001	0	\N	0	0	\N	\N	0	89105	0	46240-8	3051031		
44975	4156	40766240	2000-11-11	2000-11-11 00:00:00	2000-11-11	5001	0	\N	0	0	\N	\N	0	276211	0	63513-6	40766240		
25781	2366	3006322	1968-11-13	1968-11-13 00:00:00	1968-11-13	5001	0	\N	0	0	\N	\N	0	157527	0	8331-1	3006322		
25891	2384	3006322	1988-02-19	1988-02-19 00:00:00	1988-02-19	5001	0	\N	0	0	\N	\N	0	158507	0	8331-1	3006322		
37260	3437	40758406	1924-07-23	1924-07-23 00:00:00	1924-07-23	5001	0	\N	0	0	\N	\N	0	227936	0	55277-8	40758406		
100495	3083	4024958	1969-07-20	1969-07-20 00:00:00	1969-07-20	5001	0	\N	0	0	\N	\N	0	205331	0	117015009	4024958		
9926	949	3006322	1968-06-24	1968-06-24 00:00:00	1968-06-24	5001	0	\N	0	0	\N	\N	0	63026	0	8331-1	3006322		
9975	950	3006322	2000-07-30	2000-07-30 00:00:00	2000-07-30	5001	0	\N	0	0	\N	\N	0	63068	0	8331-1	3006322		
22587	2070	3005136	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	137700	0	6075-6	3005136		
50750	4626	3006734	1997-11-21	1997-11-21 00:00:00	1997-11-21	5001	0	\N	0	0	\N	\N	0	308259	0	6189-5	3006734		
50803	4631	3006322	1960-06-14	1960-06-14 00:00:00	1960-06-14	5001	0	\N	0	0	\N	\N	0	308575	0	8331-1	3006322		
16161	1476	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	98383	0	6844-5	3020655		
45699	4217	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	279980	0	6189-5	3006734		
45781	4220	3049273	2012-08-10	2012-08-10 00:00:00	2012-08-10	5001	0	\N	0	0	\N	\N	0	280153	0	38265-5	3049273		
27323	2537	3006322	1988-11-24	1988-11-24 00:00:00	1988-11-24	5001	0	\N	0	0	\N	\N	0	167586	0	8331-1	3006322		
24938	2290	3006322	1970-06-14	1970-06-14 00:00:00	1970-06-14	5001	0	\N	0	0	\N	\N	0	152357	0	8331-1	3006322		
24978	2292	3011505	2016-03-11	2016-03-11 00:00:00	2016-03-11	5001	0	\N	0	0	\N	\N	0	152581	0	19926-5	3011505		
147783	4529	4133840	1989-01-29	1989-01-29 00:00:00	1989-01-29	5001	0	\N	0	0	\N	\N	0	301553	0	127783003	4133840		
169255	5195	4024958	1961-09-11	1961-09-11 00:00:00	1961-09-11	5001	0	\N	0	0	\N	\N	0	345411	0	117015009	4024958		
36488	3352	3011505	2001-12-21	2001-12-21 00:00:00	2001-12-21	5001	0	\N	0	0	\N	\N	0	222304	0	19926-5	3011505		
3290	99	4133840	2011-07-30	2011-07-30 00:00:00	2011-07-30	5001	0	\N	0	0	\N	\N	0	6749	0	127783003	4133840		
4173	411	3000876	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	27256	0	6082-2	3000876		
4292	422	3006322	1964-07-15	1964-07-15 00:00:00	1964-07-15	5001	0	\N	0	0	\N	\N	0	27966	0	8331-1	3006322		
8650	830	3006322	2016-09-21	2016-09-21 00:00:00	2016-09-21	5001	0	\N	0	0	\N	\N	0	55013	0	8331-1	3006322		
37875	3494	3006322	1970-07-20	1970-07-20 00:00:00	1970-07-20	5001	0	\N	0	0	\N	\N	0	231779	0	8331-1	3006322		
20083	1844	3051031	1989-05-24	1989-05-24 00:00:00	1989-05-24	5001	0	\N	0	0	\N	\N	0	123138	0	46240-8	3051031		
31814	2903	3006322	2016-08-07	2016-08-07 00:00:00	2016-08-07	5001	0	\N	0	0	\N	\N	0	193422	0	8331-1	3006322		
49354	4505	3001488	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	299990	0	7258-7	3001488		
14561	1355	40758406	2006-11-21	2006-11-21 00:00:00	2006-11-21	5001	0	\N	0	0	\N	\N	0	89857	0	55277-8	40758406		
14627	1356	3005136	1995-02-23	1995-02-23 00:00:00	1995-02-23	5001	0	\N	0	0	\N	\N	0	89888	0	6075-6	3005136		
26017	2392	3011505	1962-02-02	1962-02-02 00:00:00	1962-02-02	5001	0	\N	0	0	\N	\N	0	159000	0	19926-5	3011505		
28859	2669	3051031	2010-09-21	2010-09-21 00:00:00	2010-09-21	5001	0	\N	0	0	\N	\N	0	176815	0	46240-8	3051031		
37453	3455	3006322	2008-06-10	2008-06-10 00:00:00	2008-06-10	5001	0	\N	0	0	\N	\N	0	229203	0	8331-1	3006322		
56136	5150	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	342380	0	6273-7	3006451		
48887	4475	3006322	2018-09-29	2018-09-29 00:00:00	2018-09-29	5001	0	\N	0	0	\N	\N	0	297755	0	8331-1	3006322		
28038	2577	3006734	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	170596	0	6189-5	3006734		
55373	5076	40766240	1943-04-06	1943-04-06 00:00:00	1943-04-06	5001	0	\N	0	0	\N	\N	0	337416	0	63513-6	40766240		
46095	4253	3006322	1986-11-24	1986-11-24 00:00:00	1986-11-24	5001	0	\N	0	0	\N	\N	0	282439	0	8331-1	3006322		
24153	2218	3005136	1979-03-30	1979-03-30 00:00:00	1979-03-30	5001	0	\N	0	0	\N	\N	0	147700	0	6075-6	3005136		
57548	5284	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	351551	0	6158-0	3019406		
128522	3957	4133840	2012-10-11	2012-10-11 00:00:00	2012-10-11	5001	0	\N	0	0	\N	\N	0	263059	0	127783003	4133840		
52071	4781	40766240	2009-11-24	2009-11-24 00:00:00	2009-11-24	5001	0	\N	0	0	\N	\N	0	318301	0	63513-6	40766240		
36329	3337	40758406	2013-05-24	2013-05-24 00:00:00	2013-05-24	5001	0	\N	0	0	\N	\N	0	221374	0	55277-8	40758406		
19463	1778	3006322	2012-02-25	2012-02-25 00:00:00	2012-02-25	5001	0	\N	0	0	\N	\N	0	118971	0	8331-1	3006322		
51562	4719	3006451	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	314290	0	6273-7	3006451		
51632	4725	3014599	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	314894	0	6106-9	3014599		
145677	4472	4052083	1967-03-12	1967-03-12 00:00:00	1967-03-12	5001	0	\N	0	0	\N	\N	0	297483	0	23426006	4052083		
40718	1264	4133840	1993-04-16	1993-04-16 00:00:00	1993-04-16	5001	0	\N	0	0	\N	\N	0	83301	0	127783003	4133840		
53743	4929	3006322	1968-02-15	1968-02-15 00:00:00	1968-02-15	5001	0	\N	0	0	\N	\N	0	327695	0	8331-1	3006322		
42959	3968	3006322	1990-07-22	1990-07-22 00:00:00	1990-07-22	5001	0	\N	0	0	\N	\N	0	263853	0	8331-1	3006322		
54310	4970	40769184	1946-04-20	1946-04-20 00:00:00	1946-04-20	5001	0	\N	0	0	\N	\N	0	330381	0	66524-0	40769184		
54385	4972	3006322	1996-12-04	1996-12-04 00:00:00	1996-12-04	5001	0	\N	0	0	\N	\N	0	330669	0	8331-1	3006322		
21247	1967	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	130834	0	7258-7	3001488		
32634	2959	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	197575	0	6085-5	3001247		
101386	3115	4052083	1973-04-27	1973-04-27 00:00:00	1973-04-27	5001	0	\N	0	0	\N	\N	0	207254	0	23426006	4052083		
32750	2966	3021226	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	198142	0	6246-3	3021226		
163268	5015	4024958	1969-04-02	1969-04-02 00:00:00	1969-04-02	5001	0	\N	0	0	\N	\N	0	333360	0	117015009	4024958		
7071	680	3006322	1999-07-21	1999-07-21 00:00:00	1999-07-21	5001	0	\N	0	0	\N	\N	0	45082	0	8331-1	3006322		
6426	603	3006322	2009-05-26	2009-05-26 00:00:00	2009-05-26	5001	0	\N	0	0	\N	\N	0	40032	0	8331-1	3006322		
11191	354	4052083	1973-03-24	1973-03-24 00:00:00	1973-03-24	5001	0	\N	0	0	\N	\N	0	23518	0	23426006	4052083		
90792	2802	4024958	1940-10-02	1940-10-02 00:00:00	1940-10-02	5001	0	\N	0	0	\N	\N	0	185704	0	117015009	4024958		
29187	2688	3006322	1985-04-24	1985-04-24 00:00:00	1985-04-24	5001	0	\N	0	0	\N	\N	0	178093	0	8331-1	3006322		
137548	4238	4024958	1987-06-11	1987-06-11 00:00:00	1987-06-11	5001	0	\N	0	0	\N	\N	0	281361	0	117015009	4024958		
67739	2076	4024958	1982-12-07	1982-12-07 00:00:00	1982-12-07	5001	0	\N	0	0	\N	\N	0	138192	0	117015009	4024958		
14355	1345	3051031	1993-05-02	1993-05-02 00:00:00	1993-05-02	5001	0	\N	0	0	\N	\N	0	89166	0	46240-8	3051031		
44977	4156	3051031	2001-01-10	2001-01-10 00:00:00	2001-01-10	5001	0	\N	0	0	\N	\N	0	276174	0	46240-8	3051031		
25782	2366	3006322	2015-10-28	2015-10-28 00:00:00	2015-10-28	5001	0	\N	0	0	\N	\N	0	157486	0	8331-1	3006322		
25892	2384	3006322	1989-03-02	1989-03-02 00:00:00	1989-03-02	5001	0	\N	0	0	\N	\N	0	158476	0	8331-1	3006322		
37261	3437	40766240	1924-05-24	1924-05-24 00:00:00	1924-05-24	5001	0	\N	0	0	\N	\N	0	227982	0	63513-6	40766240		
100510	3083	4052083	1951-05-30	1951-05-30 00:00:00	1951-05-30	5001	0	\N	0	0	\N	\N	0	205329	0	23426006	4052083		
9927	949	3006322	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	63058	0	8331-1	3006322		
9976	951	3006322	1970-10-10	1970-10-10 00:00:00	1970-10-10	5001	0	\N	0	0	\N	\N	0	63209	0	8331-1	3006322		
22588	2070	3015076	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	137700	0	6248-9	3015076		
50751	4626	3020655	1997-11-21	1997-11-21 00:00:00	1997-11-21	5001	0	\N	0	0	\N	\N	0	308259	0	6844-5	3020655		
50804	4631	3006322	1921-03-14	1921-03-14 00:00:00	1921-03-14	5001	0	\N	0	0	\N	\N	0	308562	0	8331-1	3006322		
16162	1476	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	98383	0	6246-3	3021226		
45700	4217	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	279980	0	6273-7	3006451		
45797	4222	3006322	1969-06-02	1969-06-02 00:00:00	1969-06-02	5001	0	\N	0	0	\N	\N	0	280305	0	8331-1	3006322		
27324	2537	3020655	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	167631	0	6844-5	3020655		
24939	2290	3006322	1959-01-18	1959-01-18 00:00:00	1959-01-18	5001	0	\N	0	0	\N	\N	0	152325	0	8331-1	3006322		
24979	2292	3011505	2014-02-07	2014-02-07 00:00:00	2014-02-07	5001	0	\N	0	0	\N	\N	0	152590	0	19926-5	3011505		
147785	4529	4133840	1985-12-01	1985-12-01 00:00:00	1985-12-01	5001	0	\N	0	0	\N	\N	0	301589	0	127783003	4133840		
169268	5195	4024958	1986-09-12	1986-09-12 00:00:00	1986-09-12	5001	0	\N	0	0	\N	\N	0	345475	0	117015009	4024958		
36489	3352	3011505	2008-11-07	2008-11-07 00:00:00	2008-11-07	5001	0	\N	0	0	\N	\N	0	222275	0	19926-5	3011505		
3293	99	4133840	2012-08-04	2012-08-04 00:00:00	2012-08-04	5001	0	\N	0	0	\N	\N	0	6757	0	127783003	4133840		
4174	411	3005136	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	27256	0	6075-6	3005136		
4293	422	3006322	1993-01-29	1993-01-29 00:00:00	1993-01-29	5001	0	\N	0	0	\N	\N	0	27909	0	8331-1	3006322		
8651	830	3006322	1971-02-01	1971-02-01 00:00:00	1971-02-01	5001	0	\N	0	0	\N	\N	0	54956	0	8331-1	3006322		
37876	3494	3011505	2011-08-11	2011-08-11 00:00:00	2011-08-11	5001	0	\N	0	0	\N	\N	0	231736	0	19926-5	3011505		
20085	1844	46235214	1989-05-24	1989-05-24 00:00:00	1989-05-24	5001	0	\N	0	0	\N	\N	0	123138	0	76690-7	46235214		
31815	2903	3006322	2014-09-04	2014-09-04 00:00:00	2014-09-04	5001	0	\N	0	0	\N	\N	0	193421	0	8331-1	3006322		
49355	4505	3006734	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	299990	0	6189-5	3006734		
14562	1355	3051031	2006-11-21	2006-11-21 00:00:00	2006-11-21	5001	0	\N	0	0	\N	\N	0	89857	0	46240-8	3051031		
14628	1356	3014599	1995-02-23	1995-02-23 00:00:00	1995-02-23	5001	0	\N	0	0	\N	\N	0	89888	0	6106-9	3014599		
26018	2392	3011505	1967-02-03	1967-02-03 00:00:00	1967-02-03	5001	0	\N	0	0	\N	\N	0	159053	0	19926-5	3011505		
28861	2669	3051031	1979-07-01	1979-07-01 00:00:00	1979-07-01	5001	0	\N	0	0	\N	\N	0	176813	0	46240-8	3051031		
37454	3456	3006322	1952-06-07	1952-06-07 00:00:00	1952-06-07	5001	0	\N	0	0	\N	\N	0	229287	0	8331-1	3006322		
56137	5150	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	342380	0	6246-3	3021226		
48888	4475	3006322	1981-08-06	1981-08-06 00:00:00	1981-08-06	5001	0	\N	0	0	\N	\N	0	297736	0	8331-1	3006322		
28039	2577	3000876	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	170596	0	6082-2	3000876		
55376	5076	3006322	1999-11-27	1999-11-27 00:00:00	1999-11-27	5001	0	\N	0	0	\N	\N	0	337332	0	8331-1	3006322		
46096	4253	3006322	1992-02-05	1992-02-05 00:00:00	1992-02-05	5001	0	\N	0	0	\N	\N	0	282441	0	8331-1	3006322		
24154	2218	3021226	1979-03-30	1979-03-30 00:00:00	1979-03-30	5001	0	\N	0	0	\N	\N	0	147700	0	6246-3	3021226		
57549	5284	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	351551	0	6075-6	3005136		
106364	3275	4024958	1965-06-16	1965-06-16 00:00:00	1965-06-16	5001	0	\N	0	0	\N	\N	0	217646	0	117015009	4024958		
52073	4781	46235214	2009-11-24	2009-11-24 00:00:00	2009-11-24	5001	0	\N	0	0	\N	\N	0	318301	0	76690-7	46235214		
36330	3337	3051031	2013-05-24	2013-05-24 00:00:00	2013-05-24	5001	0	\N	0	0	\N	\N	0	221374	0	46240-8	3051031		
19464	1778	3006322	1998-01-29	1998-01-29 00:00:00	1998-01-29	5001	0	\N	0	0	\N	\N	0	118956	0	8331-1	3006322		
51563	4719	3014599	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	314290	0	6106-9	3014599		
51633	4725	3006734	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	314894	0	6189-5	3006734		
145683	4472	4024958	1938-10-26	1938-10-26 00:00:00	1938-10-26	5001	0	\N	0	0	\N	\N	0	297513	0	117015009	4024958		
40722	1264	4133840	2014-05-09	2014-05-09 00:00:00	2014-05-09	5001	0	\N	0	0	\N	\N	0	83287	0	127783003	4133840		
67095	2060	4024958	1993-09-10	1993-09-10 00:00:00	1993-09-10	5001	0	\N	0	0	\N	\N	0	137037	0	117015009	4024958		
54244	4957	3006322	1983-07-16	1983-07-16 00:00:00	1983-07-16	5001	0	\N	0	0	\N	\N	0	329553	0	8331-1	3006322		
54311	4970	40769189	1946-04-20	1946-04-20 00:00:00	1946-04-20	5001	0	\N	0	0	\N	\N	0	330381	0	66529-9	40769189		
54386	4972	3006322	1974-05-25	1974-05-25 00:00:00	1974-05-25	5001	0	\N	0	0	\N	\N	0	330713	0	8331-1	3006322		
21248	1967	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	130834	0	6206-7	3012494		
32635	2959	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	197575	0	6248-9	3015076		
101387	3115	4052083	1987-04-26	1987-04-26 00:00:00	1987-04-26	5001	0	\N	0	0	\N	\N	0	207256	0	23426006	4052083		
32751	2966	3027231	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	198142	0	6276-0	3027231		
163269	5015	4052083	1977-11-16	1977-11-16 00:00:00	1977-11-16	5001	0	\N	0	0	\N	\N	0	333344	0	23426006	4052083		
7072	680	3020655	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	44996	0	6844-5	3020655		
6427	603	3006322	2008-11-18	2008-11-18 00:00:00	2008-11-18	5001	0	\N	0	0	\N	\N	0	39967	0	8331-1	3006322		
11193	354	4133840	2018-03-15	2018-03-15 00:00:00	2018-03-15	5001	0	\N	0	0	\N	\N	0	23579	0	127783003	4133840		
79641	2450	4024958	1988-03-04	1988-03-04 00:00:00	1988-03-04	5001	0	\N	0	0	\N	\N	0	162502	0	117015009	4024958		
29188	2688	3006322	1984-12-08	1984-12-08 00:00:00	1984-12-08	5001	0	\N	0	0	\N	\N	0	178122	0	8331-1	3006322		
137554	4238	4052083	1973-12-05	1973-12-05 00:00:00	1973-12-05	5001	0	\N	0	0	\N	\N	0	281403	0	23426006	4052083		
67751	2077	4024958	1951-07-09	1951-07-09 00:00:00	1951-07-09	5001	0	\N	0	0	\N	\N	0	138266	0	117015009	4024958		
14356	1345	46235214	1993-05-02	1993-05-02 00:00:00	1993-05-02	5001	0	\N	0	0	\N	\N	0	89166	0	76690-7	46235214		
44979	4156	40758406	2001-01-10	2001-01-10 00:00:00	2001-01-10	5001	0	\N	0	0	\N	\N	0	276174	0	55277-8	40758406		
25783	2366	3006322	1978-10-04	1978-10-04 00:00:00	1978-10-04	5001	0	\N	0	0	\N	\N	0	157528	0	8331-1	3006322		
125150	3862	4024958	1973-07-03	1973-07-03 00:00:00	1973-07-03	5001	0	\N	0	0	\N	\N	0	256392	0	117015009	4024958		
37263	3437	40758406	1924-05-24	1924-05-24 00:00:00	1924-05-24	5001	0	\N	0	0	\N	\N	0	227982	0	55277-8	40758406		
100516	3083	4024958	1977-06-19	1977-06-19 00:00:00	1977-06-19	5001	0	\N	0	0	\N	\N	0	205320	0	117015009	4024958		
9928	949	3011505	2005-10-03	2005-10-03 00:00:00	2005-10-03	5001	0	\N	0	0	\N	\N	0	63016	0	19926-5	3011505		
9977	951	3006322	1952-07-04	1952-07-04 00:00:00	1952-07-04	5001	0	\N	0	0	\N	\N	0	63223	0	8331-1	3006322		
22589	2070	3006322	1980-03-10	1980-03-10 00:00:00	1980-03-10	5001	0	\N	0	0	\N	\N	0	137679	0	8331-1	3006322		
50752	4626	3027231	1997-11-21	1997-11-21 00:00:00	1997-11-21	5001	0	\N	0	0	\N	\N	0	308259	0	6276-0	3027231		
50805	4631	3006322	1920-12-01	1920-12-01 00:00:00	1920-12-01	5001	0	\N	0	0	\N	\N	0	308570	0	8331-1	3006322		
16163	1476	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	98383	0	6276-0	3027231		
45701	4217	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	279980	0	6276-0	3027231		
45798	4222	3006322	2007-05-27	2007-05-27 00:00:00	2007-05-27	5001	0	\N	0	0	\N	\N	0	280340	0	8331-1	3006322		
27325	2537	3036780	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	167631	0	6095-4	3036780		
24940	2290	3006322	1966-03-26	1966-03-26 00:00:00	1966-03-26	5001	0	\N	0	0	\N	\N	0	152362	0	8331-1	3006322		
24980	2292	3011505	2011-01-28	2011-01-28 00:00:00	2011-01-28	5001	0	\N	0	0	\N	\N	0	152589	0	19926-5	3011505		
147789	4530	4024958	1976-06-07	1976-06-07 00:00:00	1976-06-07	5001	0	\N	0	0	\N	\N	0	301631	0	117015009	4024958		
92710	2858	4024958	1911-12-25	1911-12-25 00:00:00	1911-12-25	5001	0	\N	0	0	\N	\N	0	189905	0	117015009	4024958		
36490	3352	3011505	2015-10-30	2015-10-30 00:00:00	2015-10-30	5001	0	\N	0	0	\N	\N	0	222276	0	19926-5	3011505		
3294	99	4133840	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	6764	0	127783003	4133840		
4175	411	3015076	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	27256	0	6248-9	3015076		
4294	422	3049273	2019-04-27	2019-04-27 00:00:00	2019-04-27	5001	0	\N	0	0	\N	\N	0	27964	0	38265-5	3049273		
8652	830	3006322	1992-05-18	1992-05-18 00:00:00	1992-05-18	5001	0	\N	0	0	\N	\N	0	55009	0	8331-1	3006322		
37877	3495	3006322	1968-06-02	1968-06-02 00:00:00	1968-06-02	5001	0	\N	0	0	\N	\N	0	231794	0	8331-1	3006322		
20086	1844	40758406	1989-05-24	1989-05-24 00:00:00	1989-05-24	5001	0	\N	0	0	\N	\N	0	123138	0	55277-8	40758406		
31816	2903	3006322	1971-07-07	1971-07-07 00:00:00	1971-07-07	5001	0	\N	0	0	\N	\N	0	193408	0	8331-1	3006322		
49356	4505	3020655	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	299990	0	6844-5	3020655		
14563	1355	46235214	2006-11-21	2006-11-21 00:00:00	2006-11-21	5001	0	\N	0	0	\N	\N	0	89857	0	76690-7	46235214		
14629	1356	3023430	1995-02-23	1995-02-23 00:00:00	1995-02-23	5001	0	\N	0	0	\N	\N	0	89888	0	6833-8	3023430		
26019	2392	3011505	1997-05-16	1997-05-16 00:00:00	1997-05-16	5001	0	\N	0	0	\N	\N	0	158971	0	19926-5	3011505		
28862	2669	40766240	1979-07-01	1979-07-01 00:00:00	1979-07-01	5001	0	\N	0	0	\N	\N	0	176813	0	63513-6	40766240		
37456	3456	3006322	1962-12-29	1962-12-29 00:00:00	1962-12-29	5001	0	\N	0	0	\N	\N	0	229307	0	8331-1	3006322		
154432	4736	4024958	2016-10-22	2016-10-22 00:00:00	2016-10-22	5001	0	\N	0	0	\N	\N	0	315486	0	117015009	4024958		
48889	4476	3006322	1984-02-26	1984-02-26 00:00:00	1984-02-26	5001	0	\N	0	0	\N	\N	0	297805	0	8331-1	3006322		
28040	2577	3019406	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	170596	0	6158-0	3019406		
55377	5076	3006322	1980-12-19	1980-12-19 00:00:00	1980-12-19	5001	0	\N	0	0	\N	\N	0	337433	0	8331-1	3006322		
46100	4255	40766240	1974-08-26	1974-08-26 00:00:00	1974-08-26	5001	0	\N	0	0	\N	\N	0	282524	0	63513-6	40766240		
24155	2218	3027231	1979-03-30	1979-03-30 00:00:00	1979-03-30	5001	0	\N	0	0	\N	\N	0	147700	0	6276-0	3027231		
57550	5284	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	351551	0	6276-0	3027231		
106367	3275	4024958	1971-02-07	1971-02-07 00:00:00	1971-02-07	5001	0	\N	0	0	\N	\N	0	217628	0	117015009	4024958		
52075	4781	40758406	2009-11-24	2009-11-24 00:00:00	2009-11-24	5001	0	\N	0	0	\N	\N	0	318301	0	55277-8	40758406		
36332	3337	40766240	2013-05-24	2013-05-24 00:00:00	2013-05-24	5001	0	\N	0	0	\N	\N	0	221374	0	63513-6	40766240		
19465	1779	3006322	1975-11-02	1975-11-02 00:00:00	1975-11-02	5001	0	\N	0	0	\N	\N	0	119074	0	8331-1	3006322		
51564	4719	3006322	1997-08-19	1997-08-19 00:00:00	1997-08-19	5001	0	\N	0	0	\N	\N	0	314330	0	8331-1	3006322		
51634	4725	3006322	1977-05-11	1977-05-11 00:00:00	1977-05-11	5001	0	\N	0	0	\N	\N	0	314868	0	8331-1	3006322		
145696	4473	4024958	1981-09-15	1981-09-15 00:00:00	1981-09-15	5001	0	\N	0	0	\N	\N	0	297611	0	117015009	4024958		
40725	1264	4133840	1999-01-15	1999-01-15 00:00:00	1999-01-15	5001	0	\N	0	0	\N	\N	0	83288	0	127783003	4133840		
67101	2060	4024958	1988-01-12	1988-01-12 00:00:00	1988-01-12	5001	0	\N	0	0	\N	\N	0	137006	0	117015009	4024958		
54245	4957	3006322	1979-09-22	1979-09-22 00:00:00	1979-09-22	5001	0	\N	0	0	\N	\N	0	329523	0	8331-1	3006322		
54312	4970	40769194	1946-04-20	1946-04-20 00:00:00	1946-04-20	5001	0	\N	0	0	\N	\N	0	330381	0	66534-9	40769194		
54387	4972	3049273	2016-09-19	2016-09-19 00:00:00	2016-09-19	5001	0	\N	0	0	\N	\N	0	330665	0	38265-5	3049273		
21249	1967	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	130834	0	6082-2	3000876		
32636	2959	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	197575	0	6246-3	3021226		
101407	3117	4052083	1985-10-28	1985-10-28 00:00:00	1985-10-28	5001	0	\N	0	0	\N	\N	0	207379	0	23426006	4052083		
32752	2966	3019406	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	198142	0	6158-0	3019406		
13157	1257	3006322	2018-05-30	2018-05-30 00:00:00	2018-05-30	5001	0	\N	0	0	\N	\N	0	82806	0	8331-1	3006322		
7073	680	3000876	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	44996	0	6082-2	3000876		
6428	603	3006322	1960-11-17	1960-11-17 00:00:00	1960-11-17	5001	0	\N	0	0	\N	\N	0	39934	0	8331-1	3006322		
11194	354	4052083	2001-10-18	2001-10-18 00:00:00	2001-10-18	5001	0	\N	0	0	\N	\N	0	23520	0	23426006	4052083		
79648	2450	4052083	1966-11-13	1966-11-13 00:00:00	1966-11-13	5001	0	\N	0	0	\N	\N	0	162498	0	23426006	4052083		
29189	2688	3006322	2017-08-13	2017-08-13 00:00:00	2017-08-13	5001	0	\N	0	0	\N	\N	0	178148	0	8331-1	3006322		
137561	4238	4052083	1962-04-29	1962-04-29 00:00:00	1962-04-29	5001	0	\N	0	0	\N	\N	0	281402	0	23426006	4052083		
166962	5123	4024958	1990-10-23	1990-10-23 00:00:00	1990-10-23	5001	0	\N	0	0	\N	\N	0	340641	0	117015009	4024958		
14359	1345	40766240	1993-05-02	1993-05-02 00:00:00	1993-05-02	5001	0	\N	0	0	\N	\N	0	89166	0	63513-6	40766240		
44980	4156	40766240	2001-01-10	2001-01-10 00:00:00	2001-01-10	5001	0	\N	0	0	\N	\N	0	276174	0	63513-6	40766240		
25784	2367	3006322	2018-06-26	2018-06-26 00:00:00	2018-06-26	5001	0	\N	0	0	\N	\N	0	157582	0	8331-1	3006322		
125169	3864	4052083	2003-05-25	2003-05-25 00:00:00	2003-05-25	5001	0	\N	0	0	\N	\N	0	256479	0	23426006	4052083		
37264	3437	3051031	1924-05-24	1924-05-24 00:00:00	1924-05-24	5001	0	\N	0	0	\N	\N	0	227982	0	46240-8	3051031		
100518	3084	4052083	1982-03-03	1982-03-03 00:00:00	1982-03-03	5001	0	\N	0	0	\N	\N	0	205366	0	23426006	4052083		
9929	949	3011505	1980-08-25	1980-08-25 00:00:00	1980-08-25	5001	0	\N	0	0	\N	\N	0	63012	0	19926-5	3011505		
9978	951	3006322	2015-07-21	2015-07-21 00:00:00	2015-07-21	5001	0	\N	0	0	\N	\N	0	63167	0	8331-1	3006322		
22590	2071	3006322	2006-07-24	2006-07-24 00:00:00	2006-07-24	5001	0	\N	0	0	\N	\N	0	137807	0	8331-1	3006322		
50753	4626	3020655	2001-05-25	2001-05-25 00:00:00	2001-05-25	5001	0	\N	0	0	\N	\N	0	308225	0	6844-5	3020655		
50806	4631	3006322	1924-05-09	1924-05-09 00:00:00	1924-05-09	5001	0	\N	0	0	\N	\N	0	308602	0	8331-1	3006322		
16164	1476	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	98383	0	6082-2	3000876		
45702	4217	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	279980	0	6082-2	3000876		
45799	4223	3006322	1969-11-15	1969-11-15 00:00:00	1969-11-15	5001	0	\N	0	0	\N	\N	0	280358	0	8331-1	3006322		
27326	2537	3023430	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	167631	0	6833-8	3023430		
24941	2290	3006322	2005-06-01	2005-06-01 00:00:00	2005-06-01	5001	0	\N	0	0	\N	\N	0	152318	0	8331-1	3006322		
24981	2292	3011505	2018-03-23	2018-03-23 00:00:00	2018-03-23	5001	0	\N	0	0	\N	\N	0	152582	0	19926-5	3011505		
147822	4531	4052083	2009-12-24	2009-12-24 00:00:00	2009-12-24	5001	0	\N	0	0	\N	\N	0	301754	0	23426006	4052083		
104013	3199	4052083	2012-04-14	2012-04-14 00:00:00	2012-04-14	5001	0	\N	0	0	\N	\N	0	212736	0	23426006	4052083		
36491	3352	3006322	1972-09-22	1972-09-22 00:00:00	1972-09-22	5001	0	\N	0	0	\N	\N	0	222293	0	8331-1	3006322		
3297	99	4133840	2002-11-30	2002-11-30 00:00:00	2002-11-30	5001	0	\N	0	0	\N	\N	0	6756	0	127783003	4133840		
4176	411	3027231	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	27256	0	6276-0	3027231		
4295	422	3006322	2009-07-02	2009-07-02 00:00:00	2009-07-02	5001	0	\N	0	0	\N	\N	0	27910	0	8331-1	3006322		
8653	830	3006322	1967-06-13	1967-06-13 00:00:00	1967-06-13	5001	0	\N	0	0	\N	\N	0	54978	0	8331-1	3006322		
37878	3495	3006322	1984-01-05	1984-01-05 00:00:00	1984-01-05	5001	0	\N	0	0	\N	\N	0	231804	0	8331-1	3006322		
20087	1844	40766240	1989-05-24	1989-05-24 00:00:00	1989-05-24	5001	0	\N	0	0	\N	\N	0	123138	0	63513-6	40766240		
31817	2903	3006322	1990-09-19	1990-09-19 00:00:00	1990-09-19	5001	0	\N	0	0	\N	\N	0	193411	0	8331-1	3006322		
49357	4505	3023430	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	299990	0	6833-8	3023430		
14566	1355	40766240	2006-11-21	2006-11-21 00:00:00	2006-11-21	5001	0	\N	0	0	\N	\N	0	89857	0	63513-6	40766240		
14630	1356	3006734	1995-02-23	1995-02-23 00:00:00	1995-02-23	5001	0	\N	0	0	\N	\N	0	89888	0	6189-5	3006734		
26020	2392	3011505	2013-08-16	2013-08-16 00:00:00	2013-08-16	5001	0	\N	0	0	\N	\N	0	158982	0	19926-5	3011505		
28863	2669	40758406	1979-07-01	1979-07-01 00:00:00	1979-07-01	5001	0	\N	0	0	\N	\N	0	176813	0	55277-8	40758406		
37457	3456	3006322	1982-03-03	1982-03-03 00:00:00	1982-03-03	5001	0	\N	0	0	\N	\N	0	229288	0	8331-1	3006322		
154437	4736	4024958	1998-08-12	1998-08-12 00:00:00	1998-08-12	5001	0	\N	0	0	\N	\N	0	315502	0	117015009	4024958		
48890	4476	3015076	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	297826	0	6248-9	3015076		
28041	2577	3015076	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	170596	0	6248-9	3015076		
55378	5076	3049273	2005-09-02	2005-09-02 00:00:00	2005-09-02	5001	0	\N	0	0	\N	\N	0	337331	0	38265-5	3049273		
46101	4255	46235214	1974-08-26	1974-08-26 00:00:00	1974-08-26	5001	0	\N	0	0	\N	\N	0	282524	0	76690-7	46235214		
24156	2218	3015076	1979-03-30	1979-03-30 00:00:00	1979-03-30	5001	0	\N	0	0	\N	\N	0	147700	0	6248-9	3015076		
57551	5284	3006322	2007-05-11	2007-05-11 00:00:00	2007-05-11	5001	0	\N	0	0	\N	\N	0	351617	0	8331-1	3006322		
106371	3275	4024958	1982-03-24	1982-03-24 00:00:00	1982-03-24	5001	0	\N	0	0	\N	\N	0	217581	0	117015009	4024958		
52076	4781	3051031	2009-11-24	2009-11-24 00:00:00	2009-11-24	5001	0	\N	0	0	\N	\N	0	318301	0	46240-8	3051031		
36334	3337	40758406	2013-02-23	2013-02-23 00:00:00	2013-02-23	5001	0	\N	0	0	\N	\N	0	221373	0	55277-8	40758406		
19466	1779	3006322	1997-10-06	1997-10-06 00:00:00	1997-10-06	5001	0	\N	0	0	\N	\N	0	118999	0	8331-1	3006322		
51565	4720	3006322	1979-12-28	1979-12-28 00:00:00	1979-12-28	5001	0	\N	0	0	\N	\N	0	314401	0	8331-1	3006322		
51635	4725	3001247	1976-10-20	1976-10-20 00:00:00	1976-10-20	5001	0	\N	0	0	\N	\N	0	314867	0	6085-5	3001247		
145698	4473	4024958	2002-07-03	2002-07-03 00:00:00	2002-07-03	5001	0	\N	0	0	\N	\N	0	297588	0	117015009	4024958		
40726	1264	4133840	2008-10-24	2008-10-24 00:00:00	2008-10-24	5001	0	\N	0	0	\N	\N	0	83290	0	127783003	4133840		
67102	2060	4024958	1992-05-01	1992-05-01 00:00:00	1992-05-01	5001	0	\N	0	0	\N	\N	0	137007	0	117015009	4024958		
54246	4957	3006322	2001-08-26	2001-08-26 00:00:00	2001-08-26	5001	0	\N	0	0	\N	\N	0	329524	0	8331-1	3006322		
54313	4970	40769179	1946-04-20	1946-04-20 00:00:00	1946-04-20	5001	0	\N	0	0	\N	\N	0	330381	0	66519-0	40769179		
54388	4972	3006322	1963-12-22	1963-12-22 00:00:00	1963-12-22	5001	0	\N	0	0	\N	\N	0	330702	0	8331-1	3006322		
21250	1967	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	130834	0	6158-0	3019406		
32637	2959	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	197575	0	6106-9	3014599		
101415	3117	4024958	1979-01-04	1979-01-04 00:00:00	1979-01-04	5001	0	\N	0	0	\N	\N	0	207332	0	117015009	4024958		
32753	2966	3015076	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	198142	0	6248-9	3015076		
13158	1257	3006322	1973-05-29	1973-05-29 00:00:00	1973-05-29	5001	0	\N	0	0	\N	\N	0	82802	0	8331-1	3006322		
7074	680	3001247	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	44996	0	6085-5	3001247		
6429	603	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	40004	0	6246-3	3021226		
11196	354	4133840	2006-01-05	2006-01-05 00:00:00	2006-01-05	5001	0	\N	0	0	\N	\N	0	23588	0	127783003	4133840		
79652	2450	4052083	1994-05-22	1994-05-22 00:00:00	1994-05-22	5001	0	\N	0	0	\N	\N	0	162540	0	23426006	4052083		
29190	2688	3006322	2005-04-21	2005-04-21 00:00:00	2005-04-21	5001	0	\N	0	0	\N	\N	0	178125	0	8331-1	3006322		
137568	4238	4024958	1967-01-03	1967-01-03 00:00:00	1967-01-03	5001	0	\N	0	0	\N	\N	0	281388	0	117015009	4024958		
166963	5123	4024958	1989-12-05	1989-12-05 00:00:00	1989-12-05	5001	0	\N	0	0	\N	\N	0	340640	0	117015009	4024958		
14360	1345	40758406	1993-05-02	1993-05-02 00:00:00	1993-05-02	5001	0	\N	0	0	\N	\N	0	89166	0	55277-8	40758406		
44982	4156	46235214	2001-01-10	2001-01-10 00:00:00	2001-01-10	5001	0	\N	0	0	\N	\N	0	276174	0	76690-7	46235214		
25785	2367	3006322	2013-05-11	2013-05-11 00:00:00	2013-05-11	5001	0	\N	0	0	\N	\N	0	157553	0	8331-1	3006322		
125173	3864	4024958	2010-01-31	2010-01-31 00:00:00	2010-01-31	5001	0	\N	0	0	\N	\N	0	256509	0	117015009	4024958		
37265	3437	46235214	1924-05-24	1924-05-24 00:00:00	1924-05-24	5001	0	\N	0	0	\N	\N	0	227982	0	76690-7	46235214		
100528	3084	4024958	2010-01-17	2010-01-17 00:00:00	2010-01-17	5001	0	\N	0	0	\N	\N	0	205399	0	117015009	4024958		
9931	949	40758406	1959-08-14	1959-08-14 00:00:00	1959-08-14	5001	0	\N	0	0	\N	\N	0	62984	0	55277-8	40758406		
9979	951	3006322	1974-08-02	1974-08-02 00:00:00	1974-08-02	5001	0	\N	0	0	\N	\N	0	63165	0	8331-1	3006322		
22591	2071	3006322	1983-04-14	1983-04-14 00:00:00	1983-04-14	5001	0	\N	0	0	\N	\N	0	137823	0	8331-1	3006322		
50754	4626	3001488	2001-05-25	2001-05-25 00:00:00	2001-05-25	5001	0	\N	0	0	\N	\N	0	308225	0	7258-7	3001488		
50807	4631	3006322	1929-07-22	1929-07-22 00:00:00	1929-07-22	5001	0	\N	0	0	\N	\N	0	308571	0	8331-1	3006322		
16165	1476	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	98383	0	6833-8	3023430		
45703	4217	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	279980	0	6844-5	3020655		
45800	4223	3006322	1967-07-04	1967-07-04 00:00:00	1967-07-04	5001	0	\N	0	0	\N	\N	0	280356	0	8331-1	3006322		
27327	2537	3006734	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	167631	0	6189-5	3006734		
24942	2290	3006322	2003-07-30	2003-07-30 00:00:00	2003-07-30	5001	0	\N	0	0	\N	\N	0	152317	0	8331-1	3006322		
24982	2292	3006322	1975-08-15	1975-08-15 00:00:00	1975-08-15	5001	0	\N	0	0	\N	\N	0	152564	0	8331-1	3006322		
159370	4899	4024958	1934-10-07	1934-10-07 00:00:00	1934-10-07	5001	0	\N	0	0	\N	\N	0	325775	0	117015009	4024958		
104023	3199	4052083	2009-12-28	2009-12-28 00:00:00	2009-12-28	5001	0	\N	0	0	\N	\N	0	212735	0	23426006	4052083		
36492	3352	3006322	1966-11-22	1966-11-22 00:00:00	1966-11-22	5001	0	\N	0	0	\N	\N	0	222292	0	8331-1	3006322		
3298	99	4052083	1980-11-30	1980-11-30 00:00:00	1980-11-30	5001	0	\N	0	0	\N	\N	0	6777	0	23426006	4052083		
4177	411	3001488	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	27256	0	7258-7	3001488		
4296	422	3006322	1972-09-25	1972-09-25 00:00:00	1972-09-25	5001	0	\N	0	0	\N	\N	0	27948	0	8331-1	3006322		
8654	830	3006322	1994-06-19	1994-06-19 00:00:00	1994-06-19	5001	0	\N	0	0	\N	\N	0	55002	0	8331-1	3006322		
37879	3495	3006322	1978-01-24	1978-01-24 00:00:00	1978-01-24	5001	0	\N	0	0	\N	\N	0	231826	0	8331-1	3006322		
20089	1844	3051031	1986-09-27	1986-09-27 00:00:00	1986-09-27	5001	0	\N	0	0	\N	\N	0	123136	0	46240-8	3051031		
31818	2903	3006322	1978-02-11	1978-02-11 00:00:00	1978-02-11	5001	0	\N	0	0	\N	\N	0	193465	0	8331-1	3006322		
49358	4505	3001247	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	299990	0	6085-5	3001247		
14567	1355	3006322	1987-07-02	1987-07-02 00:00:00	1987-07-02	5001	0	\N	0	0	\N	\N	0	89778	0	8331-1	3006322		
14631	1356	3006451	1995-02-23	1995-02-23 00:00:00	1995-02-23	5001	0	\N	0	0	\N	\N	0	89888	0	6273-7	3006451		
26021	2392	3011505	1998-05-22	1998-05-22 00:00:00	1998-05-22	5001	0	\N	0	0	\N	\N	0	159064	0	19926-5	3011505		
28864	2669	46235214	1979-07-01	1979-07-01 00:00:00	1979-07-01	5001	0	\N	0	0	\N	\N	0	176813	0	76690-7	46235214		
37458	3456	3006322	1950-08-03	1950-08-03 00:00:00	1950-08-03	5001	0	\N	0	0	\N	\N	0	229305	0	8331-1	3006322		
154438	4736	4024958	1973-01-15	1973-01-15 00:00:00	1973-01-15	5001	0	\N	0	0	\N	\N	0	315481	0	117015009	4024958		
48891	4476	3012494	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	297826	0	6206-7	3012494		
28042	2577	3006322	1976-01-15	1976-01-15 00:00:00	1976-01-15	5001	0	\N	0	0	\N	\N	0	170619	0	8331-1	3006322		
55379	5076	3006322	1966-10-09	1966-10-09 00:00:00	1966-10-09	5001	0	\N	0	0	\N	\N	0	337410	0	8331-1	3006322		
46102	4255	40758406	1974-08-26	1974-08-26 00:00:00	1974-08-26	5001	0	\N	0	0	\N	\N	0	282524	0	55277-8	40758406		
24157	2218	3001488	1979-03-30	1979-03-30 00:00:00	1979-03-30	5001	0	\N	0	0	\N	\N	0	147700	0	7258-7	3001488		
57552	5284	3006322	1991-10-02	1991-10-02 00:00:00	1991-10-02	5001	0	\N	0	0	\N	\N	0	351560	0	8331-1	3006322		
106390	3277	4024958	1963-07-08	1963-07-08 00:00:00	1963-07-08	5001	0	\N	0	0	\N	\N	0	217719	0	117015009	4024958		
52077	4782	3006322	2003-01-31	2003-01-31 00:00:00	2003-01-31	5001	0	\N	0	0	\N	\N	0	318307	0	8331-1	3006322		
36335	3337	40766240	2013-02-23	2013-02-23 00:00:00	2013-02-23	5001	0	\N	0	0	\N	\N	0	221373	0	63513-6	40766240		
19467	1779	3008598	2009-11-09	2009-11-09 00:00:00	2009-11-09	5001	0	\N	0	0	\N	\N	0	119050	0	3024-7	3008598		
51566	4720	3000963	2007-06-08	2007-06-08 00:00:00	2007-06-08	5001	0	\N	0	0	\N	\N	0	314409	0	718-7	3000963		
51636	4725	3001488	1976-10-20	1976-10-20 00:00:00	1976-10-20	5001	0	\N	0	0	\N	\N	0	314867	0	7258-7	3001488		
145699	4473	4024958	1979-02-14	1979-02-14 00:00:00	1979-02-14	5001	0	\N	0	0	\N	\N	0	297586	0	117015009	4024958		
40727	1264	4024958	2004-09-24	2004-09-24 00:00:00	2004-09-24	5001	0	\N	0	0	\N	\N	0	83340	0	117015009	4024958		
67116	2060	4052083	1998-12-19	1998-12-19 00:00:00	1998-12-19	5001	0	\N	0	0	\N	\N	0	136977	0	23426006	4052083		
54249	4960	3006322	1973-12-18	1973-12-18 00:00:00	1973-12-18	5001	0	\N	0	0	\N	\N	0	329695	0	8331-1	3006322		
54315	4970	3006322	1960-05-25	1960-05-25 00:00:00	1960-05-25	5001	0	\N	0	0	\N	\N	0	330358	0	8331-1	3006322		
54389	4972	3006322	1965-05-28	1965-05-28 00:00:00	1965-05-28	5001	0	\N	0	0	\N	\N	0	330711	0	8331-1	3006322		
21251	1967	3006322	2010-10-16	2010-10-16 00:00:00	2010-10-16	5001	0	\N	0	0	\N	\N	0	130802	0	8331-1	3006322		
32638	2959	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	197575	0	6095-4	3036780		
101425	3117	4024958	1995-05-01	1995-05-01 00:00:00	1995-05-01	5001	0	\N	0	0	\N	\N	0	207377	0	117015009	4024958		
32754	2966	3012494	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	198142	0	6206-7	3012494		
13159	1257	3006322	1976-02-28	1976-02-28 00:00:00	1976-02-28	5001	0	\N	0	0	\N	\N	0	82843	0	8331-1	3006322		
7075	680	3001488	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	44996	0	7258-7	3001488		
6430	603	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	40004	0	6106-9	3014599		
11199	354	4133840	2007-01-11	2007-01-11 00:00:00	2007-01-11	5001	0	\N	0	0	\N	\N	0	23576	0	127783003	4133840		
22568	709	4052083	1977-09-16	1977-09-16 00:00:00	1977-09-16	5001	0	\N	0	0	\N	\N	0	46925	0	23426006	4052083		
29191	2688	3006322	1974-11-16	1974-11-16 00:00:00	1974-11-16	5001	0	\N	0	0	\N	\N	0	178151	0	8331-1	3006322		
137593	4239	4024958	1958-02-24	1958-02-24 00:00:00	1958-02-24	5001	0	\N	0	0	\N	\N	0	281465	0	117015009	4024958		
166970	5123	4024958	2013-06-05	2013-06-05 00:00:00	2013-06-05	5001	0	\N	0	0	\N	\N	0	340644	0	117015009	4024958		
14361	1345	3051031	1992-11-03	1992-11-03 00:00:00	1992-11-03	5001	0	\N	0	0	\N	\N	0	89146	0	46240-8	3051031		
44983	4156	3006322	1958-10-29	1958-10-29 00:00:00	1958-10-29	5001	0	\N	0	0	\N	\N	0	276136	0	8331-1	3006322		
25786	2369	3006322	2002-09-07	2002-09-07 00:00:00	2002-09-07	5001	0	\N	0	0	\N	\N	0	157646	0	8331-1	3006322		
125182	3864	4052083	1974-08-08	1974-08-08 00:00:00	1974-08-08	5001	0	\N	0	0	\N	\N	0	256527	0	23426006	4052083		
37268	3437	3006322	1916-05-09	1916-05-09 00:00:00	1916-05-09	5001	0	\N	0	0	\N	\N	0	227980	0	8331-1	3006322		
66323	2033	4052083	1978-05-08	1978-05-08 00:00:00	1978-05-08	5001	0	\N	0	0	\N	\N	0	135316	0	23426006	4052083		
9933	949	40766240	1959-08-14	1959-08-14 00:00:00	1959-08-14	5001	0	\N	0	0	\N	\N	0	62984	0	63513-6	40766240		
9980	951	3006322	2004-11-02	2004-11-02 00:00:00	2004-11-02	5001	0	\N	0	0	\N	\N	0	63212	0	8331-1	3006322		
22595	2073	3006322	1995-03-29	1995-03-29 00:00:00	1995-03-29	5001	0	\N	0	0	\N	\N	0	137935	0	8331-1	3006322		
50755	4626	3006734	2001-05-25	2001-05-25 00:00:00	2001-05-25	5001	0	\N	0	0	\N	\N	0	308225	0	6189-5	3006734		
50808	4631	3006322	2006-10-27	2006-10-27 00:00:00	2006-10-27	5001	0	\N	0	0	\N	\N	0	308609	0	8331-1	3006322		
16166	1476	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	98383	0	6095-4	3036780		
45704	4217	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	279980	0	6085-5	3001247		
45801	4223	3006322	1984-12-06	1984-12-06 00:00:00	1984-12-06	5001	0	\N	0	0	\N	\N	0	280427	0	8331-1	3006322		
27328	2537	3006451	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	167631	0	6273-7	3006451		
24943	2291	3006322	1966-01-18	1966-01-18 00:00:00	1966-01-18	5001	0	\N	0	0	\N	\N	0	152448	0	8331-1	3006322		
24983	2292	3006322	2017-06-19	2017-06-19 00:00:00	2017-06-19	5001	0	\N	0	0	\N	\N	0	152596	0	8331-1	3006322		
159374	4899	4052083	1947-09-10	1947-09-10 00:00:00	1947-09-10	5001	0	\N	0	0	\N	\N	0	325767	0	23426006	4052083		
104027	3199	4024958	1976-03-17	1976-03-17 00:00:00	1976-03-17	5001	0	\N	0	0	\N	\N	0	212760	0	117015009	4024958		
36493	3352	3011505	2017-11-10	2017-11-10 00:00:00	2017-11-10	5001	0	\N	0	0	\N	\N	0	222277	0	19926-5	3011505		
3300	99	4133840	2004-12-04	2004-12-04 00:00:00	2004-12-04	5001	0	\N	0	0	\N	\N	0	6716	0	127783003	4133840		
4178	411	3020655	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	27256	0	6844-5	3020655		
34588	1082	4052083	1989-12-16	1989-12-16 00:00:00	1989-12-16	5001	0	\N	0	0	\N	\N	0	70931	0	23426006	4052083		
8655	830	3006322	2016-02-09	2016-02-09 00:00:00	2016-02-09	5001	0	\N	0	0	\N	\N	0	54958	0	8331-1	3006322		
37886	3501	3006322	1997-07-01	1997-07-01 00:00:00	1997-07-01	5001	0	\N	0	0	\N	\N	0	232048	0	8331-1	3006322		
20091	1844	46235214	1986-09-27	1986-09-27 00:00:00	1986-09-27	5001	0	\N	0	0	\N	\N	0	123136	0	76690-7	46235214		
31819	2904	3006322	2006-05-12	2006-05-12 00:00:00	2006-05-12	5001	0	\N	0	0	\N	\N	0	193485	0	8331-1	3006322		
49359	4505	3015076	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	299990	0	6248-9	3015076		
14568	1355	46235214	1966-03-06	1966-03-06 00:00:00	1966-03-06	5001	0	\N	0	0	\N	\N	0	89852	0	76690-7	46235214		
14632	1356	3027231	1995-02-23	1995-02-23 00:00:00	1995-02-23	5001	0	\N	0	0	\N	\N	0	89888	0	6276-0	3027231		
26022	2392	3011505	1958-08-01	1958-08-01 00:00:00	1958-08-01	5001	0	\N	0	0	\N	\N	0	159081	0	19926-5	3011505		
28866	2669	40758406	1978-06-06	1978-06-06 00:00:00	1978-06-06	5001	0	\N	0	0	\N	\N	0	176792	0	55277-8	40758406		
37459	3457	3006322	2005-08-06	2005-08-06 00:00:00	2005-08-06	5001	0	\N	0	0	\N	\N	0	229327	0	8331-1	3006322		
165762	5096	4024958	1980-08-17	1980-08-17 00:00:00	1980-08-17	5001	0	\N	0	0	\N	\N	0	338562	0	117015009	4024958		
48892	4476	3021226	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	297826	0	6246-3	3021226		
28043	2577	3027231	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	170588	0	6276-0	3027231		
55380	5077	3006322	1996-07-20	1996-07-20 00:00:00	1996-07-20	5001	0	\N	0	0	\N	\N	0	337491	0	8331-1	3006322		
46103	4255	3051031	1974-08-26	1974-08-26 00:00:00	1974-08-26	5001	0	\N	0	0	\N	\N	0	282524	0	46240-8	3051031		
24158	2218	3020655	1979-03-30	1979-03-30 00:00:00	1979-03-30	5001	0	\N	0	0	\N	\N	0	147700	0	6844-5	3020655		
57553	5284	3006322	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	351597	0	8331-1	3006322		
106426	3278	4024958	1966-03-21	1966-03-21 00:00:00	1966-03-21	5001	0	\N	0	0	\N	\N	0	217754	0	117015009	4024958		
52078	4782	3006322	2018-03-17	2018-03-17 00:00:00	2018-03-17	5001	0	\N	0	0	\N	\N	0	318324	0	8331-1	3006322		
36336	3337	46235214	2013-02-23	2013-02-23 00:00:00	2013-02-23	5001	0	\N	0	0	\N	\N	0	221373	0	76690-7	46235214		
19468	1779	3009201	2009-11-09	2009-11-09 00:00:00	2009-11-09	5001	0	\N	0	0	\N	\N	0	119050	0	3016-3	3009201		
51567	4720	3009542	2007-06-08	2007-06-08 00:00:00	2007-06-08	5001	0	\N	0	0	\N	\N	0	314409	0	20570-8	3009542		
51637	4725	3021226	1976-10-20	1976-10-20 00:00:00	1976-10-20	5001	0	\N	0	0	\N	\N	0	314867	0	6246-3	3021226		
156986	4826	4052083	1991-11-07	1991-11-07 00:00:00	1991-11-07	5001	0	\N	0	0	\N	\N	0	320946	0	23426006	4052083		
40729	1264	4133840	1988-01-08	1988-01-08 00:00:00	1988-01-08	5001	0	\N	0	0	\N	\N	0	83310	0	127783003	4133840		
117447	3621	4133840	1978-08-26	1978-08-26 00:00:00	1978-08-26	5001	0	\N	0	0	\N	\N	0	240643	0	127783003	4133840		
54250	4960	3006322	1919-05-13	1919-05-13 00:00:00	1919-05-13	5001	0	\N	0	0	\N	\N	0	329715	0	8331-1	3006322		
54317	4970	3006322	1959-07-21	1959-07-21 00:00:00	1959-07-21	5001	0	\N	0	0	\N	\N	0	330357	0	8331-1	3006322		
54390	4972	3006322	1954-09-27	1954-09-27 00:00:00	1954-09-27	5001	0	\N	0	0	\N	\N	0	330666	0	8331-1	3006322		
21252	1967	3006322	2002-06-19	2002-06-19 00:00:00	2002-06-19	5001	0	\N	0	0	\N	\N	0	130835	0	8331-1	3006322		
32639	2959	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	197575	0	6082-2	3000876		
101430	3117	4024958	1995-12-08	1995-12-08 00:00:00	1995-12-08	5001	0	\N	0	0	\N	\N	0	207369	0	117015009	4024958		
32755	2966	3001488	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	198142	0	7258-7	3001488		
13160	1258	3006322	2008-11-16	2008-11-16 00:00:00	2008-11-16	5001	0	\N	0	0	\N	\N	0	82866	0	8331-1	3006322		
7076	680	3006451	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	44996	0	6273-7	3006451		
6431	603	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	40004	0	6273-7	3006451		
11203	354	4133840	2014-02-20	2014-02-20 00:00:00	2014-02-20	5001	0	\N	0	0	\N	\N	0	23568	0	127783003	4133840		
22569	709	4024958	1971-05-26	1971-05-26 00:00:00	1971-05-26	5001	0	\N	0	0	\N	\N	0	46930	0	117015009	4024958		
29209	2690	3006322	1992-01-24	1992-01-24 00:00:00	1992-01-24	5001	0	\N	0	0	\N	\N	0	178241	0	8331-1	3006322		
137594	4239	4024958	2016-10-09	2016-10-09 00:00:00	2016-10-09	5001	0	\N	0	0	\N	\N	0	281558	0	117015009	4024958		
4834	462	3006322	2013-12-30	2013-12-30 00:00:00	2013-12-30	5001	0	\N	0	0	\N	\N	0	30908	0	8331-1	3006322		
14362	1345	46235214	1992-11-03	1992-11-03 00:00:00	1992-11-03	5001	0	\N	0	0	\N	\N	0	89146	0	76690-7	46235214		
44984	4156	40766240	2001-07-09	2001-07-09 00:00:00	2001-07-09	5001	0	\N	0	0	\N	\N	0	276196	0	63513-6	40766240		
25787	2369	3006322	1994-06-08	1994-06-08 00:00:00	1994-06-08	5001	0	\N	0	0	\N	\N	0	157677	0	8331-1	3006322		
125316	3866	4024958	1952-06-01	1952-06-01 00:00:00	1952-06-01	5001	0	\N	0	0	\N	\N	0	256729	0	117015009	4024958		
37269	3437	3006322	1974-05-13	1974-05-13 00:00:00	1974-05-13	5001	0	\N	0	0	\N	\N	0	227941	0	8331-1	3006322		
66325	2033	4052083	2013-03-25	2013-03-25 00:00:00	2013-03-25	5001	0	\N	0	0	\N	\N	0	135323	0	23426006	4052083		
92012	2835	4052083	1998-01-23	1998-01-23 00:00:00	1998-01-23	5001	0	\N	0	0	\N	\N	0	188321	0	23426006	4052083		
30261	938	4024958	1980-04-15	1980-04-15 00:00:00	1980-04-15	5001	0	\N	0	0	\N	\N	0	62349	0	117015009	4024958		
22596	2073	3006322	1995-09-08	1995-09-08 00:00:00	1995-09-08	5001	0	\N	0	0	\N	\N	0	137923	0	8331-1	3006322		
50756	4626	3023430	2001-05-25	2001-05-25 00:00:00	2001-05-25	5001	0	\N	0	0	\N	\N	0	308225	0	6833-8	3023430		
50809	4631	3006322	1995-04-01	1995-04-01 00:00:00	1995-04-01	5001	0	\N	0	0	\N	\N	0	308651	0	8331-1	3006322		
16167	1476	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	98395	0	6082-2	3000876		
45705	4217	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	279964	0	6833-8	3023430		
45802	4223	3006322	1971-06-22	1971-06-22 00:00:00	1971-06-22	5001	0	\N	0	0	\N	\N	0	280424	0	8331-1	3006322		
27329	2537	3014599	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	167631	0	6106-9	3014599		
24944	2291	3006322	1992-12-11	1992-12-11 00:00:00	1992-12-11	5001	0	\N	0	0	\N	\N	0	152542	0	8331-1	3006322		
24984	2292	3006322	2003-08-30	2003-08-30 00:00:00	2003-08-30	5001	0	\N	0	0	\N	\N	0	152605	0	8331-1	3006322		
159377	4899	4133840	1969-02-25	1969-02-25 00:00:00	1969-02-25	5001	0	\N	0	0	\N	\N	0	325826	0	127783003	4133840		
127185	3913	4024958	2005-03-19	2005-03-19 00:00:00	2005-03-19	5001	0	\N	0	0	\N	\N	0	260098	0	117015009	4024958		
36494	3352	3011505	2006-11-03	2006-11-03 00:00:00	2006-11-03	5001	0	\N	0	0	\N	\N	0	222267	0	19926-5	3011505		
3303	99	4133840	2016-04-09	2016-04-09 00:00:00	2016-04-09	5001	0	\N	0	0	\N	\N	0	6769	0	127783003	4133840		
4179	411	3001247	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	27256	0	6085-5	3001247		
34593	1082	4024958	1978-10-28	1978-10-28 00:00:00	1978-10-28	5001	0	\N	0	0	\N	\N	0	70942	0	117015009	4024958		
8656	830	3006322	1973-10-29	1973-10-29 00:00:00	1973-10-29	5001	0	\N	0	0	\N	\N	0	55001	0	8331-1	3006322		
37887	3501	3006322	1990-03-12	1990-03-12 00:00:00	1990-03-12	5001	0	\N	0	0	\N	\N	0	232067	0	8331-1	3006322		
20092	1844	40758406	1986-09-27	1986-09-27 00:00:00	1986-09-27	5001	0	\N	0	0	\N	\N	0	123136	0	55277-8	40758406		
31820	2904	3006322	1992-06-27	1992-06-27 00:00:00	1992-06-27	5001	0	\N	0	0	\N	\N	0	193483	0	8331-1	3006322		
49360	4505	3021226	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	299990	0	6246-3	3021226		
14569	1355	3051031	1966-03-06	1966-03-06 00:00:00	1966-03-06	5001	0	\N	0	0	\N	\N	0	89852	0	46240-8	3051031		
14633	1356	3006322	2012-09-24	2012-09-24 00:00:00	2012-09-24	5001	0	\N	0	0	\N	\N	0	89905	0	8331-1	3006322		
26023	2392	3011505	1954-10-15	1954-10-15 00:00:00	1954-10-15	5001	0	\N	0	0	\N	\N	0	158999	0	19926-5	3011505		
28867	2669	40766240	1978-06-06	1978-06-06 00:00:00	1978-06-06	5001	0	\N	0	0	\N	\N	0	176792	0	63513-6	40766240		
37460	3457	3006322	1960-04-26	1960-04-26 00:00:00	1960-04-26	5001	0	\N	0	0	\N	\N	0	229407	0	8331-1	3006322		
165766	5096	4052083	1971-03-25	1971-03-25 00:00:00	1971-03-25	5001	0	\N	0	0	\N	\N	0	338581	0	23426006	4052083		
48893	4476	3005136	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	297806	0	6075-6	3005136		
28044	2577	3006451	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	170588	0	6273-7	3006451		
55381	5077	3006322	2007-09-04	2007-09-04 00:00:00	2007-09-04	5001	0	\N	0	0	\N	\N	0	337449	0	8331-1	3006322		
46105	4255	3006322	1984-02-03	1984-02-03 00:00:00	1984-02-03	5001	0	\N	0	0	\N	\N	0	282539	0	8331-1	3006322		
24159	2218	3036780	1979-03-30	1979-03-30 00:00:00	1979-03-30	5001	0	\N	0	0	\N	\N	0	147700	0	6095-4	3036780		
57554	5284	3006322	1973-12-19	1973-12-19 00:00:00	1973-12-19	5001	0	\N	0	0	\N	\N	0	351479	0	8331-1	3006322		
106431	3278	4024958	2018-12-02	2018-12-02 00:00:00	2018-12-02	5001	0	\N	0	0	\N	\N	0	217786	0	117015009	4024958		
52079	4782	3006322	2005-03-01	2005-03-01 00:00:00	2005-03-01	5001	0	\N	0	0	\N	\N	0	318359	0	8331-1	3006322		
36337	3337	3051031	2013-02-23	2013-02-23 00:00:00	2013-02-23	5001	0	\N	0	0	\N	\N	0	221373	0	46240-8	3051031		
19469	1779	3006322	1970-11-14	1970-11-14 00:00:00	1970-11-14	5001	0	\N	0	0	\N	\N	0	118986	0	8331-1	3006322		
51571	4722	3006322	1990-09-07	1990-09-07 00:00:00	1990-09-07	5001	0	\N	0	0	\N	\N	0	314541	0	8331-1	3006322		
51638	4725	3027231	1976-10-20	1976-10-20 00:00:00	1976-10-20	5001	0	\N	0	0	\N	\N	0	314867	0	6276-0	3027231		
88581	2743	4024958	1998-07-31	1998-07-31 00:00:00	1998-07-31	5001	0	\N	0	0	\N	\N	0	181462	0	117015009	4024958		
40730	1264	4024958	1949-12-21	1949-12-21 00:00:00	1949-12-21	5001	0	\N	0	0	\N	\N	0	83274	0	117015009	4024958		
117450	3621	4133840	1996-06-08	1996-06-08 00:00:00	1996-06-08	5001	0	\N	0	0	\N	\N	0	240607	0	127783003	4133840		
54251	4960	3006322	1968-08-08	1968-08-08 00:00:00	1968-08-08	5001	0	\N	0	0	\N	\N	0	329752	0	8331-1	3006322		
54318	4970	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	330434	0	6158-0	3019406		
54408	4975	3006322	1965-08-10	1965-08-10 00:00:00	1965-08-10	5001	0	\N	0	0	\N	\N	0	330844	0	8331-1	3006322		
21253	1967	3006322	2014-05-10	2014-05-10 00:00:00	2014-05-10	5001	0	\N	0	0	\N	\N	0	130803	0	8331-1	3006322		
32640	2959	3027231	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	197540	0	6276-0	3027231		
32652	2959	3015076	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	197540	0	6248-9	3015076		
32756	2966	3006734	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	198142	0	6189-5	3006734		
13161	1258	3006322	1997-11-30	1997-11-30 00:00:00	1997-11-30	5001	0	\N	0	0	\N	\N	0	82865	0	8331-1	3006322		
7077	680	3015076	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	44996	0	6248-9	3015076		
6432	603	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	40004	0	6276-0	3027231		
11208	354	4133840	1998-01-15	1998-01-15 00:00:00	1998-01-15	5001	0	\N	0	0	\N	\N	0	23566	0	127783003	4133840		
22572	709	4024958	1995-06-19	1995-06-19 00:00:00	1995-06-19	5001	0	\N	0	0	\N	\N	0	46933	0	117015009	4024958		
29210	2690	3006322	1962-04-17	1962-04-17 00:00:00	1962-04-17	5001	0	\N	0	0	\N	\N	0	178238	0	8331-1	3006322		
137616	4240	4024958	2003-09-01	2003-09-01 00:00:00	2003-09-01	5001	0	\N	0	0	\N	\N	0	281673	0	117015009	4024958		
4835	462	3006322	2000-11-25	2000-11-25 00:00:00	2000-11-25	5001	0	\N	0	0	\N	\N	0	30868	0	8331-1	3006322		
14365	1345	40766240	1992-11-03	1992-11-03 00:00:00	1992-11-03	5001	0	\N	0	0	\N	\N	0	89146	0	63513-6	40766240		
44986	4156	46235214	2001-07-09	2001-07-09 00:00:00	2001-07-09	5001	0	\N	0	0	\N	\N	0	276196	0	76690-7	46235214		
25788	2369	3021226	1997-11-09	1997-11-09 00:00:00	1997-11-09	5001	0	\N	0	0	\N	\N	0	157655	0	6246-3	3021226		
125355	3869	4024958	1919-05-27	1919-05-27 00:00:00	1919-05-27	5001	0	\N	0	0	\N	\N	0	256891	0	117015009	4024958		
37270	3437	3006322	1960-10-19	1960-10-19 00:00:00	1960-10-19	5001	0	\N	0	0	\N	\N	0	227940	0	8331-1	3006322		
66343	2034	4024958	1991-07-28	1991-07-28 00:00:00	1991-07-28	5001	0	\N	0	0	\N	\N	0	135462	0	117015009	4024958		
92016	2835	4024958	2006-12-06	2006-12-06 00:00:00	2006-12-06	5001	0	\N	0	0	\N	\N	0	188322	0	117015009	4024958		
30266	938	4024958	1969-04-15	1969-04-15 00:00:00	1969-04-15	5001	0	\N	0	0	\N	\N	0	62326	0	117015009	4024958		
22597	2073	3006322	1983-11-10	1983-11-10 00:00:00	1983-11-10	5001	0	\N	0	0	\N	\N	0	137882	0	8331-1	3006322		
50757	4626	3006451	2001-05-25	2001-05-25 00:00:00	2001-05-25	5001	0	\N	0	0	\N	\N	0	308225	0	6273-7	3006451		
50810	4631	3006322	2008-08-03	2008-08-03 00:00:00	2008-08-03	5001	0	\N	0	0	\N	\N	0	308590	0	8331-1	3006322		
16168	1476	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	98395	0	6844-5	3020655		
45706	4217	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	279964	0	6095-4	3036780		
45803	4223	3006322	1968-07-14	1968-07-14 00:00:00	1968-07-14	5001	0	\N	0	0	\N	\N	0	280357	0	8331-1	3006322		
27330	2537	3015076	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	167631	0	6248-9	3015076		
24945	2291	3006322	1995-06-13	1995-06-13 00:00:00	1995-06-13	5001	0	\N	0	0	\N	\N	0	152427	0	8331-1	3006322		
24985	2292	3006322	1978-11-09	1978-11-09 00:00:00	1978-11-09	5001	0	\N	0	0	\N	\N	0	152631	0	8331-1	3006322		
159378	4899	4133840	1979-07-24	1979-07-24 00:00:00	1979-07-24	5001	0	\N	0	0	\N	\N	0	325828	0	127783003	4133840		
50522	4608	3011505	2005-12-22	2005-12-22 00:00:00	2005-12-22	5001	0	\N	0	0	\N	\N	0	307060	0	19926-5	3011505		
36495	3352	3011505	2014-10-24	2014-10-24 00:00:00	2014-10-24	5001	0	\N	0	0	\N	\N	0	222322	0	19926-5	3011505		
95177	2921	4133840	2002-08-27	2002-08-27 00:00:00	2002-08-27	5001	0	\N	0	0	\N	\N	0	194747	0	127783003	4133840		
4180	411	3006734	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	27256	0	6189-5	3006734		
34619	1082	4052083	1962-10-24	1962-10-24 00:00:00	1962-10-24	5001	0	\N	0	0	\N	\N	0	70940	0	23426006	4052083		
8658	834	3006322	1977-12-14	1977-12-14 00:00:00	1977-12-14	5001	0	\N	0	0	\N	\N	0	55239	0	8331-1	3006322		
37888	3501	3006322	1949-12-25	1949-12-25 00:00:00	1949-12-25	5001	0	\N	0	0	\N	\N	0	232064	0	8331-1	3006322		
20093	1844	40766240	1986-09-27	1986-09-27 00:00:00	1986-09-27	5001	0	\N	0	0	\N	\N	0	123136	0	63513-6	40766240		
31821	2904	3006322	1999-05-05	1999-05-05 00:00:00	1999-05-05	5001	0	\N	0	0	\N	\N	0	193484	0	8331-1	3006322		
49361	4505	3014599	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	299990	0	6106-9	3014599		
14572	1355	40766240	1966-03-06	1966-03-06 00:00:00	1966-03-06	5001	0	\N	0	0	\N	\N	0	89852	0	63513-6	40766240		
14634	1357	3006322	1980-07-29	1980-07-29 00:00:00	1980-07-29	5001	0	\N	0	0	\N	\N	0	89997	0	8331-1	3006322		
26024	2392	3011505	1966-02-04	1966-02-04 00:00:00	1966-02-04	5001	0	\N	0	0	\N	\N	0	159083	0	19926-5	3011505		
28868	2669	46235214	1978-06-06	1978-06-06 00:00:00	1978-06-06	5001	0	\N	0	0	\N	\N	0	176792	0	76690-7	46235214		
37461	3457	3006322	1926-10-11	1926-10-11 00:00:00	1926-10-11	5001	0	\N	0	0	\N	\N	0	229404	0	8331-1	3006322		
165781	5096	4052083	1989-04-29	1989-04-29 00:00:00	1989-04-29	5001	0	\N	0	0	\N	\N	0	338584	0	23426006	4052083		
48894	4476	3021226	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	297806	0	6246-3	3021226		
28045	2577	3021226	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	170588	0	6246-3	3021226		
55382	5077	3006322	1973-10-05	1973-10-05 00:00:00	1973-10-05	5001	0	\N	0	0	\N	\N	0	337435	0	8331-1	3006322		
46106	4255	3006322	2008-12-16	2008-12-16 00:00:00	2008-12-16	5001	0	\N	0	0	\N	\N	0	282529	0	8331-1	3006322		
24160	2220	3006322	1954-04-15	1954-04-15 00:00:00	1954-04-15	5001	0	\N	0	0	\N	\N	0	147812	0	8331-1	3006322		
125942	3881	4024958	2011-07-11	2011-07-11 00:00:00	2011-07-11	5001	0	\N	0	0	\N	\N	0	257916	0	117015009	4024958		
41322	3856	3006322	2015-02-26	2015-02-26 00:00:00	2015-02-26	5001	0	\N	0	0	\N	\N	0	255935	0	8331-1	3006322		
52080	4782	3006322	2006-03-11	2006-03-11 00:00:00	2006-03-11	5001	0	\N	0	0	\N	\N	0	318367	0	8331-1	3006322		
47615	4373	3006322	1977-02-03	1977-02-03 00:00:00	1977-02-03	5001	0	\N	0	0	\N	\N	0	290378	0	8331-1	3006322		
19470	1779	3006322	2011-11-02	2011-11-02 00:00:00	2011-11-02	5001	0	\N	0	0	\N	\N	0	119051	0	8331-1	3006322		
51572	4722	3006322	1979-02-23	1979-02-23 00:00:00	1979-02-23	5001	0	\N	0	0	\N	\N	0	314591	0	8331-1	3006322		
51639	4725	3020655	1976-10-20	1976-10-20 00:00:00	1976-10-20	5001	0	\N	0	0	\N	\N	0	314867	0	6844-5	3020655		
88605	2743	4024958	2008-03-19	2008-03-19 00:00:00	2008-03-19	5001	0	\N	0	0	\N	\N	0	181432	0	117015009	4024958		
40732	1264	4133840	2001-02-09	2001-02-09 00:00:00	2001-02-09	5001	0	\N	0	0	\N	\N	0	83345	0	127783003	4133840		
117452	3621	4133840	1980-09-06	1980-09-06 00:00:00	1980-09-06	5001	0	\N	0	0	\N	\N	0	240644	0	127783003	4133840		
54252	4960	3008598	1977-03-31	1977-03-31 00:00:00	1977-03-31	5001	0	\N	0	0	\N	\N	0	329696	0	3024-7	3008598		
54319	4970	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	330434	0	6206-7	3012494		
54409	4975	3006322	1973-10-19	1973-10-19 00:00:00	1973-10-19	5001	0	\N	0	0	\N	\N	0	330904	0	8331-1	3006322		
21254	1967	3006322	2019-04-26	2019-04-26 00:00:00	2019-04-26	5001	0	\N	0	0	\N	\N	0	130878	0	8331-1	3006322		
32641	2959	3006451	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	197540	0	6273-7	3006451		
32653	2959	3021226	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	197540	0	6246-3	3021226		
32757	2966	3006451	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	198142	0	6273-7	3006451		
13162	1258	3006322	1973-06-10	1973-06-10 00:00:00	1973-06-10	5001	0	\N	0	0	\N	\N	0	82903	0	8331-1	3006322		
7078	680	3036780	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	44996	0	6095-4	3036780		
6433	603	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	40004	0	6833-8	3023430		
11211	354	4133840	2010-01-28	2010-01-28 00:00:00	2010-01-28	5001	0	\N	0	0	\N	\N	0	23523	0	127783003	4133840		
22585	709	4052083	1953-04-14	1953-04-14 00:00:00	1953-04-14	5001	0	\N	0	0	\N	\N	0	46959	0	23426006	4052083		
29211	2690	3006322	1961-11-06	1961-11-06 00:00:00	1961-11-06	5001	0	\N	0	0	\N	\N	0	178207	0	8331-1	3006322		
137618	4240	4024958	1947-12-30	1947-12-30 00:00:00	1947-12-30	5001	0	\N	0	0	\N	\N	0	281687	0	117015009	4024958		
4836	464	3006322	1986-05-05	1986-05-05 00:00:00	1986-05-05	5001	0	\N	0	0	\N	\N	0	30973	0	8331-1	3006322		
14366	1345	40758406	1992-11-03	1992-11-03 00:00:00	1992-11-03	5001	0	\N	0	0	\N	\N	0	89146	0	55277-8	40758406		
44987	4156	40758406	2001-07-09	2001-07-09 00:00:00	2001-07-09	5001	0	\N	0	0	\N	\N	0	276196	0	55277-8	40758406		
25789	2369	3005136	1997-11-09	1997-11-09 00:00:00	1997-11-09	5001	0	\N	0	0	\N	\N	0	157655	0	6075-6	3005136		
125373	3869	4024958	1934-08-18	1934-08-18 00:00:00	1934-08-18	5001	0	\N	0	0	\N	\N	0	256925	0	117015009	4024958		
37271	3437	3006322	1965-09-05	1965-09-05 00:00:00	1965-09-05	5001	0	\N	0	0	\N	\N	0	227987	0	8331-1	3006322		
66344	2034	4024958	2006-06-22	2006-06-22 00:00:00	2006-06-22	5001	0	\N	0	0	\N	\N	0	135450	0	117015009	4024958		
92022	2835	4052083	2013-10-12	2013-10-12 00:00:00	2013-10-12	5001	0	\N	0	0	\N	\N	0	188272	0	23426006	4052083		
30284	938	4024958	1973-06-05	1973-06-05 00:00:00	1973-06-05	5001	0	\N	0	0	\N	\N	0	62347	0	117015009	4024958		
22598	2073	3006322	2017-02-07	2017-02-07 00:00:00	2017-02-07	5001	0	\N	0	0	\N	\N	0	137902	0	8331-1	3006322		
50758	4626	3012494	2001-05-25	2001-05-25 00:00:00	2001-05-25	5001	0	\N	0	0	\N	\N	0	308225	0	6206-7	3012494		
50811	4631	3006322	1992-04-04	1992-04-04 00:00:00	1992-04-04	5001	0	\N	0	0	\N	\N	0	308567	0	8331-1	3006322		
16169	1476	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	98395	0	6085-5	3001247		
45707	4217	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	279964	0	7258-7	3001488		
45804	4223	3006322	1984-07-25	1984-07-25 00:00:00	1984-07-25	5001	0	\N	0	0	\N	\N	0	280360	0	8331-1	3006322		
27331	2537	3019406	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	167631	0	6158-0	3019406		
24946	2291	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	152546	0	6189-5	3006734		
24986	2292	3011505	2015-02-13	2015-02-13 00:00:00	2015-02-13	5001	0	\N	0	0	\N	\N	0	152580	0	19926-5	3011505		
159381	4899	4133840	1986-09-02	1986-09-02 00:00:00	1986-09-02	5001	0	\N	0	0	\N	\N	0	325848	0	127783003	4133840		
50523	4608	3049273	2010-07-14	2010-07-14 00:00:00	2010-07-14	5001	0	\N	0	0	\N	\N	0	307071	0	38265-5	3049273		
36496	3352	3011505	2018-11-16	2018-11-16 00:00:00	2018-11-16	5001	0	\N	0	0	\N	\N	0	222282	0	19926-5	3011505		
95179	2921	4133840	2012-10-23	2012-10-23 00:00:00	2012-10-23	5001	0	\N	0	0	\N	\N	0	194745	0	127783003	4133840		
4181	411	3036780	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	27256	0	6095-4	3036780		
34621	1082	4024958	1975-01-04	1975-01-04 00:00:00	1975-01-04	5001	0	\N	0	0	\N	\N	0	70973	0	117015009	4024958		
8659	834	3006322	1968-06-07	1968-06-07 00:00:00	1968-06-07	5001	0	\N	0	0	\N	\N	0	55207	0	8331-1	3006322		
37889	3501	3006322	2014-10-13	2014-10-13 00:00:00	2014-10-13	5001	0	\N	0	0	\N	\N	0	232092	0	8331-1	3006322		
20094	1844	3006322	1962-11-18	1962-11-18 00:00:00	1962-11-18	5001	0	\N	0	0	\N	\N	0	123219	0	8331-1	3006322		
31822	2905	3006322	2010-08-23	2010-08-23 00:00:00	2010-08-23	5001	0	\N	0	0	\N	\N	0	193563	0	8331-1	3006322		
49362	4505	3036780	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	299990	0	6095-4	3036780		
14573	1355	40758406	1966-03-06	1966-03-06 00:00:00	1966-03-06	5001	0	\N	0	0	\N	\N	0	89852	0	55277-8	40758406		
14635	1357	3006322	2018-01-03	2018-01-03 00:00:00	2018-01-03	5001	0	\N	0	0	\N	\N	0	90024	0	8331-1	3006322		
26025	2392	3011505	1993-04-23	1993-04-23 00:00:00	1993-04-23	5001	0	\N	0	0	\N	\N	0	159061	0	19926-5	3011505		
28870	2669	3051031	1978-06-06	1978-06-06 00:00:00	1978-06-06	5001	0	\N	0	0	\N	\N	0	176792	0	46240-8	3051031		
37462	3457	3006322	2016-09-21	2016-09-21 00:00:00	2016-09-21	5001	0	\N	0	0	\N	\N	0	229333	0	8331-1	3006322		
165785	5096	4052083	1993-11-07	1993-11-07 00:00:00	1993-11-07	5001	0	\N	0	0	\N	\N	0	338586	0	23426006	4052083		
48895	4476	3036780	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	297806	0	6095-4	3036780		
28046	2577	3005136	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	170588	0	6075-6	3005136		
55384	5078	3006322	1971-07-07	1971-07-07 00:00:00	1971-07-07	5001	0	\N	0	0	\N	\N	0	337596	0	8331-1	3006322		
46107	4255	3051031	1982-09-18	1982-09-18 00:00:00	1982-09-18	5001	0	\N	0	0	\N	\N	0	282489	0	46240-8	3051031		
24161	2220	3006322	1986-03-15	1986-03-15 00:00:00	1986-03-15	5001	0	\N	0	0	\N	\N	0	147865	0	8331-1	3006322		
125949	3881	4052083	1998-01-13	1998-01-13 00:00:00	1998-01-13	5001	0	\N	0	0	\N	\N	0	257947	0	23426006	4052083		
41323	3856	3006322	1986-08-08	1986-08-08 00:00:00	1986-08-08	5001	0	\N	0	0	\N	\N	0	255922	0	8331-1	3006322		
52082	4784	3006322	1968-11-03	1968-11-03 00:00:00	1968-11-03	5001	0	\N	0	0	\N	\N	0	318493	0	8331-1	3006322		
47616	4373	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	290380	0	6095-4	3036780		
19471	1779	3006322	1965-08-29	1965-08-29 00:00:00	1965-08-29	5001	0	\N	0	0	\N	\N	0	119044	0	8331-1	3006322		
51573	4722	3049273	1984-04-09	1984-04-09 00:00:00	1984-04-09	5001	0	\N	0	0	\N	\N	0	314613	0	38265-5	3049273		
51640	4725	3006451	1976-10-20	1976-10-20 00:00:00	1976-10-20	5001	0	\N	0	0	\N	\N	0	314867	0	6273-7	3006451		
99894	3064	4052083	1995-01-03	1995-01-03 00:00:00	1995-01-03	5001	0	\N	0	0	\N	\N	0	203941	0	23426006	4052083		
40735	1264	4052083	1993-03-31	1993-03-31 00:00:00	1993-03-31	5001	0	\N	0	0	\N	\N	0	83315	0	23426006	4052083		
117454	3621	4133840	1993-05-22	1993-05-22 00:00:00	1993-05-22	5001	0	\N	0	0	\N	\N	0	240597	0	127783003	4133840		
54253	4960	3009201	1977-03-31	1977-03-31 00:00:00	1977-03-31	5001	0	\N	0	0	\N	\N	0	329696	0	3016-3	3009201		
54320	4970	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	330434	0	6082-2	3000876		
54410	4975	3006322	1993-08-21	1993-08-21 00:00:00	1993-08-21	5001	0	\N	0	0	\N	\N	0	330871	0	8331-1	3006322		
21255	1967	3051031	1956-11-11	1956-11-11 00:00:00	1956-11-11	5001	0	\N	0	0	\N	\N	0	130863	0	46240-8	3051031		
32642	2959	3000876	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	197540	0	6082-2	3000876		
32654	2959	3014599	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	197540	0	6106-9	3014599		
44035	4067	3006322	1972-05-24	1972-05-24 00:00:00	1972-05-24	5001	0	\N	0	0	\N	\N	0	270227	0	8331-1	3006322		
13163	1258	3049273	1982-03-24	1982-03-24 00:00:00	1982-03-24	5001	0	\N	0	0	\N	\N	0	82847	0	38265-5	3049273		
7079	680	3012494	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	44996	0	6206-7	3012494		
6434	603	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	40004	0	6095-4	3036780		
11213	354	4133840	1996-01-05	1996-01-05 00:00:00	1996-01-05	5001	0	\N	0	0	\N	\N	0	23586	0	127783003	4133840		
22590	709	4052083	1987-06-05	1987-06-05 00:00:00	1987-06-05	5001	0	\N	0	0	\N	\N	0	46931	0	23426006	4052083		
29212	2690	3006322	1993-04-03	1993-04-03 00:00:00	1993-04-03	5001	0	\N	0	0	\N	\N	0	178231	0	8331-1	3006322		
29252	2693	46235214	2014-01-28	2014-01-28 00:00:00	2014-01-28	5001	0	\N	0	0	\N	\N	0	178377	0	76690-7	46235214		
30498	947	4052083	2008-05-02	2008-05-02 00:00:00	2008-05-02	5001	0	\N	0	0	\N	\N	0	62872	0	23426006	4052083		
14368	1345	3051031	1993-07-01	1993-07-01 00:00:00	1993-07-01	5001	0	\N	0	0	\N	\N	0	89127	0	46240-8	3051031		
44988	4156	3051031	2001-07-09	2001-07-09 00:00:00	2001-07-09	5001	0	\N	0	0	\N	\N	0	276196	0	46240-8	3051031		
25790	2369	3001247	1997-11-09	1997-11-09 00:00:00	1997-11-09	5001	0	\N	0	0	\N	\N	0	157655	0	6085-5	3001247		
125392	3869	4052083	1981-11-11	1981-11-11 00:00:00	1981-11-11	5001	0	\N	0	0	\N	\N	0	256913	0	23426006	4052083		
37272	3437	3006322	1927-01-23	1927-01-23 00:00:00	1927-01-23	5001	0	\N	0	0	\N	\N	0	227983	0	8331-1	3006322		
66355	2034	4052083	1995-07-14	1995-07-14 00:00:00	1995-07-14	5001	0	\N	0	0	\N	\N	0	135413	0	23426006	4052083		
92024	2835	4024958	1948-02-06	1948-02-06 00:00:00	1948-02-06	5001	0	\N	0	0	\N	\N	0	188259	0	117015009	4024958		
30289	938	4024958	1949-02-01	1949-02-01 00:00:00	1949-02-01	5001	0	\N	0	0	\N	\N	0	62408	0	117015009	4024958		
22599	2073	3006322	1965-10-06	1965-10-06 00:00:00	1965-10-06	5001	0	\N	0	0	\N	\N	0	137881	0	8331-1	3006322		
50759	4626	3021226	2001-05-25	2001-05-25 00:00:00	2001-05-25	5001	0	\N	0	0	\N	\N	0	308225	0	6246-3	3021226		
50812	4631	3006322	1979-08-31	1979-08-31 00:00:00	1979-08-31	5001	0	\N	0	0	\N	\N	0	308578	0	8331-1	3006322		
16170	1476	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	98395	0	6106-9	3014599		
45708	4217	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	279964	0	6246-3	3021226		
45805	4224	3006322	2016-02-18	2016-02-18 00:00:00	2016-02-18	5001	0	\N	0	0	\N	\N	0	280542	0	8331-1	3006322		
27332	2537	3005136	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	167631	0	6075-6	3005136		
24947	2291	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	152546	0	6844-5	3020655		
24987	2292	3011505	2019-03-29	2019-03-29 00:00:00	2019-03-29	5001	0	\N	0	0	\N	\N	0	152593	0	19926-5	3011505		
159383	4899	4133840	1971-06-08	1971-06-08 00:00:00	1971-06-08	5001	0	\N	0	0	\N	\N	0	325853	0	127783003	4133840		
50524	4608	3051031	1956-02-14	1956-02-14 00:00:00	1956-02-14	5001	0	\N	0	0	\N	\N	0	306968	0	46240-8	3051031		
36497	3352	3006322	2017-06-03	2017-06-03 00:00:00	2017-06-03	5001	0	\N	0	0	\N	\N	0	222307	0	8331-1	3006322		
95181	2921	4133840	2009-10-06	2009-10-06 00:00:00	2009-10-06	5001	0	\N	0	0	\N	\N	0	194705	0	127783003	4133840		
4182	411	3012494	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	27256	0	6206-7	3012494		
34666	1083	4024958	1969-02-06	1969-02-06 00:00:00	1969-02-06	5001	0	\N	0	0	\N	\N	0	71067	0	117015009	4024958		
8660	834	3006322	1978-08-21	1978-08-21 00:00:00	1978-08-21	5001	0	\N	0	0	\N	\N	0	55240	0	8331-1	3006322		
37890	3501	3006322	1961-01-27	1961-01-27 00:00:00	1961-01-27	5001	0	\N	0	0	\N	\N	0	232066	0	8331-1	3006322		
20095	1844	3006322	2009-04-21	2009-04-21 00:00:00	2009-04-21	5001	0	\N	0	0	\N	\N	0	123204	0	8331-1	3006322		
31823	2905	3006322	2004-06-16	2004-06-16 00:00:00	2004-06-16	5001	0	\N	0	0	\N	\N	0	193561	0	8331-1	3006322		
49363	4505	3000876	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	299990	0	6082-2	3000876		
14574	1355	3051031	1966-07-04	1966-07-04 00:00:00	1966-07-04	5001	0	\N	0	0	\N	\N	0	89837	0	46240-8	3051031		
14636	1357	3006322	2012-07-20	2012-07-20 00:00:00	2012-07-20	5001	0	\N	0	0	\N	\N	0	90016	0	8331-1	3006322		
26026	2392	3011505	1982-12-10	1982-12-10 00:00:00	1982-12-10	5001	0	\N	0	0	\N	\N	0	159088	0	19926-5	3011505		
28872	2669	46235214	1978-02-06	1978-02-06 00:00:00	1978-02-06	5001	0	\N	0	0	\N	\N	0	176817	0	76690-7	46235214		
37463	3457	3049273	1976-10-29	1976-10-29 00:00:00	1976-10-29	5001	0	\N	0	0	\N	\N	0	229388	0	38265-5	3049273		
19325	1769	3006322	1986-09-26	1986-09-26 00:00:00	1986-09-26	5001	0	\N	0	0	\N	\N	0	118294	0	8331-1	3006322		
48896	4476	3001488	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	297806	0	7258-7	3001488		
28047	2577	3012494	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	170588	0	6206-7	3012494		
55385	5078	3006322	1962-04-14	1962-04-14 00:00:00	1962-04-14	5001	0	\N	0	0	\N	\N	0	337498	0	8331-1	3006322		
46109	4255	40758406	1982-09-18	1982-09-18 00:00:00	1982-09-18	5001	0	\N	0	0	\N	\N	0	282489	0	55277-8	40758406		
24162	2220	3006322	2008-06-22	2008-06-22 00:00:00	2008-06-22	5001	0	\N	0	0	\N	\N	0	147867	0	8331-1	3006322		
40979	1271	4052083	1968-09-01	1968-09-01 00:00:00	1968-09-01	5001	0	\N	0	0	\N	\N	0	83804	0	23426006	4052083		
41324	3856	3006322	1977-04-27	1977-04-27 00:00:00	1977-04-27	5001	0	\N	0	0	\N	\N	0	255919	0	8331-1	3006322		
52083	4784	3006322	2013-12-12	2013-12-12 00:00:00	2013-12-12	5001	0	\N	0	0	\N	\N	0	318486	0	8331-1	3006322		
47617	4373	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	290380	0	6206-7	3012494		
19472	1779	3006322	1997-05-23	1997-05-23 00:00:00	1997-05-23	5001	0	\N	0	0	\N	\N	0	119049	0	8331-1	3006322		
51574	4722	3006322	1974-11-02	1974-11-02 00:00:00	1974-11-02	5001	0	\N	0	0	\N	\N	0	314576	0	8331-1	3006322		
51641	4725	3000876	1976-10-20	1976-10-20 00:00:00	1976-10-20	5001	0	\N	0	0	\N	\N	0	314867	0	6082-2	3000876		
99913	3065	4052083	1987-10-01	1987-10-01 00:00:00	1987-10-01	5001	0	\N	0	0	\N	\N	0	204021	0	23426006	4052083		
40736	1264	4133840	1998-01-09	1998-01-09 00:00:00	1998-01-09	5001	0	\N	0	0	\N	\N	0	83302	0	127783003	4133840		
117459	3621	4133840	1979-09-01	1979-09-01 00:00:00	1979-09-01	5001	0	\N	0	0	\N	\N	0	240602	0	127783003	4133840		
54254	4960	3006322	1921-10-16	1921-10-16 00:00:00	1921-10-16	5001	0	\N	0	0	\N	\N	0	329716	0	8331-1	3006322		
54321	4970	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	330434	0	6095-4	3036780		
54411	4975	3006322	2011-07-03	2011-07-03 00:00:00	2011-07-03	5001	0	\N	0	0	\N	\N	0	330908	0	8331-1	3006322		
21256	1967	46235214	1956-11-11	1956-11-11 00:00:00	1956-11-11	5001	0	\N	0	0	\N	\N	0	130863	0	76690-7	46235214		
32643	2959	3012494	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	197540	0	6206-7	3012494		
32655	2959	3006322	1985-11-04	1985-11-04 00:00:00	1985-11-04	5001	0	\N	0	0	\N	\N	0	197483	0	8331-1	3006322		
44036	4067	3006322	2013-07-26	2013-07-26 00:00:00	2013-07-26	5001	0	\N	0	0	\N	\N	0	270207	0	8331-1	3006322		
13164	1258	3006322	1991-02-21	1991-02-21 00:00:00	1991-02-21	5001	0	\N	0	0	\N	\N	0	82864	0	8331-1	3006322		
7080	680	3019406	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	44996	0	6158-0	3019406		
6435	603	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	40004	0	6158-0	3019406		
11217	354	4133840	2009-01-22	2009-01-22 00:00:00	2009-01-22	5001	0	\N	0	0	\N	\N	0	23577	0	127783003	4133840		
22593	709	4024958	1982-01-20	1982-01-20 00:00:00	1982-01-20	5001	0	\N	0	0	\N	\N	0	46965	0	117015009	4024958		
29214	2690	3006322	1949-06-01	1949-06-01 00:00:00	1949-06-01	5001	0	\N	0	0	\N	\N	0	178226	0	8331-1	3006322		
29253	2693	40766240	2014-01-28	2014-01-28 00:00:00	2014-01-28	5001	0	\N	0	0	\N	\N	0	178377	0	63513-6	40766240		
30500	948	4052083	1974-05-09	1974-05-09 00:00:00	1974-05-09	5001	0	\N	0	0	\N	\N	0	62916	0	23426006	4052083		
14369	1345	46235214	1993-07-01	1993-07-01 00:00:00	1993-07-01	5001	0	\N	0	0	\N	\N	0	89127	0	76690-7	46235214		
44990	4156	3051031	2000-07-14	2000-07-14 00:00:00	2000-07-14	5001	0	\N	0	0	\N	\N	0	276173	0	46240-8	3051031		
25791	2369	3023430	1997-11-09	1997-11-09 00:00:00	1997-11-09	5001	0	\N	0	0	\N	\N	0	157655	0	6833-8	3023430		
50591	1536	4052083	1917-12-28	1917-12-28 00:00:00	1917-12-28	5001	0	\N	0	0	\N	\N	0	102795	0	23426006	4052083		
37273	3437	3006322	1966-02-13	1966-02-13 00:00:00	1966-02-13	5001	0	\N	0	0	\N	\N	0	227988	0	8331-1	3006322		
66369	2034	4052083	2006-05-19	2006-05-19 00:00:00	2006-05-19	5001	0	\N	0	0	\N	\N	0	135517	0	23426006	4052083		
92033	2835	4052083	1966-05-12	1966-05-12 00:00:00	1966-05-12	5001	0	\N	0	0	\N	\N	0	188260	0	23426006	4052083		
30299	939	4052083	2001-06-05	2001-06-05 00:00:00	2001-06-05	5001	0	\N	0	0	\N	\N	0	62432	0	23426006	4052083		
22600	2073	3006322	2015-07-08	2015-07-08 00:00:00	2015-07-08	5001	0	\N	0	0	\N	\N	0	137925	0	8331-1	3006322		
50760	4626	3005136	2001-05-25	2001-05-25 00:00:00	2001-05-25	5001	0	\N	0	0	\N	\N	0	308225	0	6075-6	3005136		
50813	4631	3006322	2005-12-19	2005-12-19 00:00:00	2005-12-19	5001	0	\N	0	0	\N	\N	0	308642	0	8331-1	3006322		
16171	1476	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	98395	0	6246-3	3021226		
45709	4217	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	279964	0	6206-7	3012494		
45806	4224	3006322	1955-09-23	1955-09-23 00:00:00	1955-09-23	5001	0	\N	0	0	\N	\N	0	280530	0	8331-1	3006322		
27333	2537	3027231	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	167631	0	6276-0	3027231		
24948	2291	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	152546	0	6833-8	3023430		
24988	2292	3011505	2015-03-06	2015-03-06 00:00:00	2015-03-06	5001	0	\N	0	0	\N	\N	0	152591	0	19926-5	3011505		
159387	4899	4133840	1980-07-29	1980-07-29 00:00:00	1980-07-29	5001	0	\N	0	0	\N	\N	0	325858	0	127783003	4133840		
50526	4608	40766240	1956-02-14	1956-02-14 00:00:00	1956-02-14	5001	0	\N	0	0	\N	\N	0	306968	0	63513-6	40766240		
36498	3352	3006322	1964-12-23	1964-12-23 00:00:00	1964-12-23	5001	0	\N	0	0	\N	\N	0	222268	0	8331-1	3006322		
95185	2921	4133840	2008-09-30	2008-09-30 00:00:00	2008-09-30	5001	0	\N	0	0	\N	\N	0	194743	0	127783003	4133840		
4183	411	3023430	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	27256	0	6833-8	3023430		
172232	5285	4052083	2007-09-05	2007-09-05 00:00:00	2007-09-05	5001	0	\N	0	0	\N	\N	0	351662	0	23426006	4052083		
8661	834	3006322	1971-10-30	1971-10-30 00:00:00	1971-10-30	5001	0	\N	0	0	\N	\N	0	55208	0	8331-1	3006322		
37891	3501	3006322	1957-09-01	1957-09-01 00:00:00	1957-09-01	5001	0	\N	0	0	\N	\N	0	232120	0	8331-1	3006322		
20096	1844	40758406	1986-11-26	1986-11-26 00:00:00	1986-11-26	5001	0	\N	0	0	\N	\N	0	123247	0	55277-8	40758406		
31824	2905	3006322	2003-02-27	2003-02-27 00:00:00	2003-02-27	5001	0	\N	0	0	\N	\N	0	193555	0	8331-1	3006322		
49364	4506	3051031	2002-10-03	2002-10-03 00:00:00	2002-10-03	5001	0	\N	0	0	\N	\N	0	300208	0	46240-8	3051031		
14575	1355	46235214	1966-07-04	1966-07-04 00:00:00	1966-07-04	5001	0	\N	0	0	\N	\N	0	89837	0	76690-7	46235214		
14637	1358	3006322	1965-12-21	1965-12-21 00:00:00	1965-12-21	5001	0	\N	0	0	\N	\N	0	90068	0	8331-1	3006322		
26027	2392	3011505	1994-04-29	1994-04-29 00:00:00	1994-04-29	5001	0	\N	0	0	\N	\N	0	159090	0	19926-5	3011505		
28873	2669	40758406	1978-02-06	1978-02-06 00:00:00	1978-02-06	5001	0	\N	0	0	\N	\N	0	176817	0	55277-8	40758406		
37464	3458	3006322	2008-09-06	2008-09-06 00:00:00	2008-09-06	5001	0	\N	0	0	\N	\N	0	229491	0	8331-1	3006322		
19326	1770	3006322	2017-12-25	2017-12-25 00:00:00	2017-12-25	5001	0	\N	0	0	\N	\N	0	118363	0	8331-1	3006322		
48897	4476	3006451	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	297806	0	6273-7	3006451		
28048	2577	3014599	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	170588	0	6106-9	3014599		
55386	5078	3006322	1979-06-20	1979-06-20 00:00:00	1979-06-20	5001	0	\N	0	0	\N	\N	0	337598	0	8331-1	3006322		
46110	4255	46235214	1982-09-18	1982-09-18 00:00:00	1982-09-18	5001	0	\N	0	0	\N	\N	0	282489	0	76690-7	46235214		
24163	2220	3006322	1976-09-03	1976-09-03 00:00:00	1976-09-03	5001	0	\N	0	0	\N	\N	0	147862	0	8331-1	3006322		
40991	1271	4052083	1986-02-10	1986-02-10 00:00:00	1986-02-10	5001	0	\N	0	0	\N	\N	0	83805	0	23426006	4052083		
41325	3856	3006322	1983-01-04	1983-01-04 00:00:00	1983-01-04	5001	0	\N	0	0	\N	\N	0	255920	0	8331-1	3006322		
52084	4784	3006322	1963-03-23	1963-03-23 00:00:00	1963-03-23	5001	0	\N	0	0	\N	\N	0	318418	0	8331-1	3006322		
47618	4373	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	290380	0	6248-9	3015076		
19473	1780	3006322	2010-09-28	2010-09-28 00:00:00	2010-09-28	5001	0	\N	0	0	\N	\N	0	119156	0	8331-1	3006322		
51575	4722	3049273	2015-09-29	2015-09-29 00:00:00	2015-09-29	5001	0	\N	0	0	\N	\N	0	314617	0	38265-5	3049273		
51642	4725	3036780	1976-10-20	1976-10-20 00:00:00	1976-10-20	5001	0	\N	0	0	\N	\N	0	314867	0	6095-4	3036780		
99915	3065	4052083	1983-12-03	1983-12-03 00:00:00	1983-12-03	5001	0	\N	0	0	\N	\N	0	204020	0	23426006	4052083		
40739	1264	4133840	1995-04-21	1995-04-21 00:00:00	1995-04-21	5001	0	\N	0	0	\N	\N	0	83344	0	127783003	4133840		
117462	3621	4133840	1994-05-28	1994-05-28 00:00:00	1994-05-28	5001	0	\N	0	0	\N	\N	0	240606	0	127783003	4133840		
54255	4960	3006322	1939-07-01	1939-07-01 00:00:00	1939-07-01	5001	0	\N	0	0	\N	\N	0	329656	0	8331-1	3006322		
54322	4970	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	330434	0	6844-5	3020655		
54412	4975	3006322	1976-10-17	1976-10-17 00:00:00	1976-10-17	5001	0	\N	0	0	\N	\N	0	330846	0	8331-1	3006322		
21257	1967	40766240	1956-11-11	1956-11-11 00:00:00	1956-11-11	5001	0	\N	0	0	\N	\N	0	130863	0	63513-6	40766240		
32644	2959	3036780	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	197540	0	6095-4	3036780		
32656	2960	3006322	1982-01-31	1982-01-31 00:00:00	1982-01-31	5001	0	\N	0	0	\N	\N	0	197664	0	8331-1	3006322		
104402	3215	4052083	1982-01-31	1982-01-31 00:00:00	1982-01-31	5001	0	\N	0	0	\N	\N	0	213664	0	23426006	4052083		
13165	1259	3006322	1957-12-17	1957-12-17 00:00:00	1957-12-17	5001	0	\N	0	0	\N	\N	0	82981	0	8331-1	3006322		
7081	680	3023430	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	44996	0	6833-8	3023430		
6436	603	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	40004	0	6206-7	3012494		
11220	354	4133840	2002-01-24	2002-01-24 00:00:00	2002-01-24	5001	0	\N	0	0	\N	\N	0	23591	0	127783003	4133840		
22610	710	4052083	1992-07-05	1992-07-05 00:00:00	1992-07-05	5001	0	\N	0	0	\N	\N	0	47026	0	23426006	4052083		
29220	2692	3051031	1949-05-15	1949-05-15 00:00:00	1949-05-15	5001	0	\N	0	0	\N	\N	0	178348	0	46240-8	3051031		
29282	2697	3006322	1947-12-21	1947-12-21 00:00:00	1947-12-21	5001	0	\N	0	0	\N	\N	0	178608	0	8331-1	3006322		
30507	948	4024958	1989-12-27	1989-12-27 00:00:00	1989-12-27	5001	0	\N	0	0	\N	\N	0	62970	0	117015009	4024958		
14371	1345	40766240	1993-07-01	1993-07-01 00:00:00	1993-07-01	5001	0	\N	0	0	\N	\N	0	89127	0	63513-6	40766240		
44993	4156	46235214	2000-07-14	2000-07-14 00:00:00	2000-07-14	5001	0	\N	0	0	\N	\N	0	276173	0	76690-7	46235214		
25792	2369	3019406	1997-11-09	1997-11-09 00:00:00	1997-11-09	5001	0	\N	0	0	\N	\N	0	157655	0	6158-0	3019406		
50592	1536	4024958	1968-10-29	1968-10-29 00:00:00	1968-10-29	5001	0	\N	0	0	\N	\N	0	102779	0	117015009	4024958		
37275	3437	40766240	1924-06-23	1924-06-23 00:00:00	1924-06-23	5001	0	\N	0	0	\N	\N	0	228030	0	63513-6	40766240		
66370	2034	4052083	1996-09-15	1996-09-15 00:00:00	1996-09-15	5001	0	\N	0	0	\N	\N	0	135464	0	23426006	4052083		
92036	2835	4052083	2004-11-11	2004-11-11 00:00:00	2004-11-11	5001	0	\N	0	0	\N	\N	0	188216	0	23426006	4052083		
77827	2387	4024958	1990-12-30	1990-12-30 00:00:00	1990-12-30	5001	0	\N	0	0	\N	\N	0	158739	0	117015009	4024958		
22602	2075	3006322	2018-11-15	2018-11-15 00:00:00	2018-11-15	5001	0	\N	0	0	\N	\N	0	138134	0	8331-1	3006322		
50761	4626	3014599	2001-05-25	2001-05-25 00:00:00	2001-05-25	5001	0	\N	0	0	\N	\N	0	308225	0	6106-9	3014599		
50814	4631	3006322	1948-06-06	1948-06-06 00:00:00	1948-06-06	5001	0	\N	0	0	\N	\N	0	308582	0	8331-1	3006322		
16172	1476	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	98395	0	6276-0	3027231		
45710	4217	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	279964	0	6844-5	3020655		
45807	4224	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	280467	0	6248-9	3015076		
27334	2537	3001488	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	167631	0	7258-7	3001488		
24949	2291	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	152546	0	6082-2	3000876		
24989	2292	3011505	2013-02-01	2013-02-01 00:00:00	2013-02-01	5001	0	\N	0	0	\N	\N	0	152625	0	19926-5	3011505		
159388	4899	4133840	1970-06-02	1970-06-02 00:00:00	1970-06-02	5001	0	\N	0	0	\N	\N	0	325792	0	127783003	4133840		
50527	4608	46235214	1956-02-14	1956-02-14 00:00:00	1956-02-14	5001	0	\N	0	0	\N	\N	0	306968	0	76690-7	46235214		
36499	3352	3011505	2004-10-29	2004-10-29 00:00:00	2004-10-29	5001	0	\N	0	0	\N	\N	0	222320	0	19926-5	3011505		
95190	2921	4133840	1984-07-03	1984-07-03 00:00:00	1984-07-03	5001	0	\N	0	0	\N	\N	0	194764	0	127783003	4133840		
4184	411	3021226	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	27256	0	6246-3	3021226		
172257	5285	4052083	1968-12-20	1968-12-20 00:00:00	1968-12-20	5001	0	\N	0	0	\N	\N	0	351698	0	23426006	4052083		
8662	836	3006322	2001-12-05	2001-12-05 00:00:00	2001-12-05	5001	0	\N	0	0	\N	\N	0	55313	0	8331-1	3006322		
37892	3501	3006322	1991-12-14	1991-12-14 00:00:00	1991-12-14	5001	0	\N	0	0	\N	\N	0	232136	0	8331-1	3006322		
20097	1844	40766240	1986-11-26	1986-11-26 00:00:00	1986-11-26	5001	0	\N	0	0	\N	\N	0	123247	0	63513-6	40766240		
31825	2905	3006322	1986-05-15	1986-05-15 00:00:00	1986-05-15	5001	0	\N	0	0	\N	\N	0	193596	0	8331-1	3006322		
49365	4506	40758406	2002-10-03	2002-10-03 00:00:00	2002-10-03	5001	0	\N	0	0	\N	\N	0	300208	0	55277-8	40758406		
14576	1355	40758406	1966-07-04	1966-07-04 00:00:00	1966-07-04	5001	0	\N	0	0	\N	\N	0	89837	0	55277-8	40758406		
14638	1358	3006322	1976-07-27	1976-07-27 00:00:00	1976-07-27	5001	0	\N	0	0	\N	\N	0	90047	0	8331-1	3006322		
26028	2392	3006322	1937-01-14	1937-01-14 00:00:00	1937-01-14	5001	0	\N	0	0	\N	\N	0	159018	0	8331-1	3006322		
28875	2669	40766240	1978-02-06	1978-02-06 00:00:00	1978-02-06	5001	0	\N	0	0	\N	\N	0	176817	0	63513-6	40766240		
37465	3458	3006322	2000-07-31	2000-07-31 00:00:00	2000-07-31	5001	0	\N	0	0	\N	\N	0	229471	0	8331-1	3006322		
19327	1770	3006322	1996-01-21	1996-01-21 00:00:00	1996-01-21	5001	0	\N	0	0	\N	\N	0	118379	0	8331-1	3006322		
48898	4476	3015076	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	297806	0	6248-9	3015076		
28049	2577	3001247	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	170588	0	6085-5	3001247		
55387	5078	3006322	1961-10-04	1961-10-04 00:00:00	1961-10-04	5001	0	\N	0	0	\N	\N	0	337595	0	8331-1	3006322		
46112	4255	40766240	1982-09-18	1982-09-18 00:00:00	1982-09-18	5001	0	\N	0	0	\N	\N	0	282489	0	63513-6	40766240		
24164	2220	3006322	1983-03-18	1983-03-18 00:00:00	1983-03-18	5001	0	\N	0	0	\N	\N	0	147864	0	8331-1	3006322		
35859	3294	3006322	1993-09-29	1993-09-29 00:00:00	1993-09-29	5001	0	\N	0	0	\N	\N	0	218832	0	8331-1	3006322		
41326	3856	3006322	1976-10-18	1976-10-18 00:00:00	1976-10-18	5001	0	\N	0	0	\N	\N	0	255907	0	8331-1	3006322		
52085	4784	46235214	1950-07-30	1950-07-30 00:00:00	1950-07-30	5001	0	\N	0	0	\N	\N	0	318492	0	76690-7	46235214		
47619	4373	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	290380	0	6158-0	3019406		
19474	1780	3006322	1967-11-04	1967-11-04 00:00:00	1967-11-04	5001	0	\N	0	0	\N	\N	0	119106	0	8331-1	3006322		
51576	4722	3049273	2012-10-14	2012-10-14 00:00:00	2012-10-14	5001	0	\N	0	0	\N	\N	0	314616	0	38265-5	3049273		
51643	4725	3019406	1976-10-20	1976-10-20 00:00:00	1976-10-20	5001	0	\N	0	0	\N	\N	0	314867	0	6158-0	3019406		
106004	3263	4024958	1987-08-25	1987-08-25 00:00:00	1987-08-25	5001	0	\N	0	0	\N	\N	0	216912	0	117015009	4024958		
40741	1264	4133840	2015-05-15	2015-05-15 00:00:00	2015-05-15	5001	0	\N	0	0	\N	\N	0	83293	0	127783003	4133840		
117464	3621	4133840	1974-08-03	1974-08-03 00:00:00	1974-08-03	5001	0	\N	0	0	\N	\N	0	240577	0	127783003	4133840		
54256	4960	3006322	1965-07-09	1965-07-09 00:00:00	1965-07-09	5001	0	\N	0	0	\N	\N	0	329674	0	8331-1	3006322		
54323	4970	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	330434	0	7258-7	3001488		
54413	4975	3006322	1992-11-13	1992-11-13 00:00:00	1992-11-13	5001	0	\N	0	0	\N	\N	0	330907	0	8331-1	3006322		
21258	1967	40758406	1956-11-11	1956-11-11 00:00:00	1956-11-11	5001	0	\N	0	0	\N	\N	0	130863	0	55277-8	40758406		
32645	2959	3019406	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	197540	0	6158-0	3019406		
32657	2960	3006322	1969-08-12	1969-08-12 00:00:00	1969-08-12	5001	0	\N	0	0	\N	\N	0	197631	0	8331-1	3006322		
104410	3215	4024958	1978-06-02	1978-06-02 00:00:00	1978-06-02	5001	0	\N	0	0	\N	\N	0	213640	0	117015009	4024958		
13166	1259	3006322	2005-11-23	2005-11-23 00:00:00	2005-11-23	5001	0	\N	0	0	\N	\N	0	82931	0	8331-1	3006322		
7082	680	3006734	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	44996	0	6189-5	3006734		
6437	603	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	40004	0	6844-5	3020655		
11222	354	4024958	1993-10-18	1993-10-18 00:00:00	1993-10-18	5001	0	\N	0	0	\N	\N	0	23526	0	117015009	4024958		
22619	710	4052083	1985-01-21	1985-01-21 00:00:00	1985-01-21	5001	0	\N	0	0	\N	\N	0	47003	0	23426006	4052083		
29221	2692	40758406	1949-05-15	1949-05-15 00:00:00	1949-05-15	5001	0	\N	0	0	\N	\N	0	178348	0	55277-8	40758406		
29283	2697	3006322	2003-12-31	2003-12-31 00:00:00	2003-12-31	5001	0	\N	0	0	\N	\N	0	178565	0	8331-1	3006322		
30515	948	4024958	1980-08-08	1980-08-08 00:00:00	1980-08-08	5001	0	\N	0	0	\N	\N	0	62966	0	117015009	4024958		
14372	1345	40758406	1993-07-01	1993-07-01 00:00:00	1993-07-01	5001	0	\N	0	0	\N	\N	0	89127	0	55277-8	40758406		
44994	4156	40758406	2000-07-14	2000-07-14 00:00:00	2000-07-14	5001	0	\N	0	0	\N	\N	0	276173	0	55277-8	40758406		
25793	2369	3015076	1997-11-09	1997-11-09 00:00:00	1997-11-09	5001	0	\N	0	0	\N	\N	0	157655	0	6248-9	3015076		
50594	1536	4052083	1919-09-17	1919-09-17 00:00:00	1919-09-17	5001	0	\N	0	0	\N	\N	0	102819	0	23426006	4052083		
37276	3437	46235214	1924-06-23	1924-06-23 00:00:00	1924-06-23	5001	0	\N	0	0	\N	\N	0	228030	0	76690-7	46235214		
66372	2034	4052083	1954-12-20	1954-12-20 00:00:00	1954-12-20	5001	0	\N	0	0	\N	\N	0	135447	0	23426006	4052083		
92037	2835	4024958	1938-05-16	1938-05-16 00:00:00	1938-05-16	5001	0	\N	0	0	\N	\N	0	188333	0	117015009	4024958		
64972	1992	4024958	1977-11-10	1977-11-10 00:00:00	1977-11-10	5001	0	\N	0	0	\N	\N	0	132717	0	117015009	4024958		
22603	2075	40758406	2003-01-20	2003-01-20 00:00:00	2003-01-20	5001	0	\N	0	0	\N	\N	0	138006	0	55277-8	40758406		
50762	4626	3036780	2001-05-25	2001-05-25 00:00:00	2001-05-25	5001	0	\N	0	0	\N	\N	0	308225	0	6095-4	3036780		
50815	4631	3006322	2009-09-08	2009-09-08 00:00:00	2009-09-08	5001	0	\N	0	0	\N	\N	0	308643	0	8331-1	3006322		
16173	1476	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	98395	0	6158-0	3019406		
45711	4217	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	279964	0	6082-2	3000876		
45808	4224	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	280467	0	7258-7	3001488		
27335	2537	3001247	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	167631	0	6085-5	3001247		
24950	2291	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	152546	0	6273-7	3006451		
24990	2292	3006322	1971-03-27	1971-03-27 00:00:00	1971-03-27	5001	0	\N	0	0	\N	\N	0	152568	0	8331-1	3006322		
159391	4899	4133840	1973-06-19	1973-06-19 00:00:00	1973-06-19	5001	0	\N	0	0	\N	\N	0	325854	0	127783003	4133840		
50528	4608	40758406	1956-02-14	1956-02-14 00:00:00	1956-02-14	5001	0	\N	0	0	\N	\N	0	306968	0	55277-8	40758406		
36500	3353	3006322	1993-11-28	1993-11-28 00:00:00	1993-11-28	5001	0	\N	0	0	\N	\N	0	222391	0	8331-1	3006322		
95191	2921	4024958	1960-05-18	1960-05-18 00:00:00	1960-05-18	5001	0	\N	0	0	\N	\N	0	194695	0	117015009	4024958		
4185	411	3006322	2001-02-24	2001-02-24 00:00:00	2001-02-24	5001	0	\N	0	0	\N	\N	0	27263	0	8331-1	3006322		
132721	4086	4133840	2015-11-25	2015-11-25 00:00:00	2015-11-25	5001	0	\N	0	0	\N	\N	0	271598	0	127783003	4133840		
8663	836	3006322	2008-01-16	2008-01-16 00:00:00	2008-01-16	5001	0	\N	0	0	\N	\N	0	55314	0	8331-1	3006322		
37901	3504	3006322	1946-01-27	1946-01-27 00:00:00	1946-01-27	5001	0	\N	0	0	\N	\N	0	232336	0	8331-1	3006322		
20098	1844	46235214	1986-11-26	1986-11-26 00:00:00	1986-11-26	5001	0	\N	0	0	\N	\N	0	123247	0	76690-7	46235214		
31826	2905	3006322	1971-08-19	1971-08-19 00:00:00	1971-08-19	5001	0	\N	0	0	\N	\N	0	193554	0	8331-1	3006322		
49366	4506	46235214	2002-10-03	2002-10-03 00:00:00	2002-10-03	5001	0	\N	0	0	\N	\N	0	300208	0	76690-7	46235214		
14577	1355	40766240	1966-07-04	1966-07-04 00:00:00	1966-07-04	5001	0	\N	0	0	\N	\N	0	89837	0	63513-6	40766240		
14639	1358	3006322	1978-11-25	1978-11-25 00:00:00	1978-11-25	5001	0	\N	0	0	\N	\N	0	90048	0	8331-1	3006322		
16770	525	4052083	1994-09-07	1994-09-07 00:00:00	1994-09-07	5001	0	\N	0	0	\N	\N	0	34967	0	23426006	4052083		
28877	2669	3051031	1978-02-06	1978-02-06 00:00:00	1978-02-06	5001	0	\N	0	0	\N	\N	0	176817	0	46240-8	3051031		
37466	3458	3006322	2006-08-10	2006-08-10 00:00:00	2006-08-10	5001	0	\N	0	0	\N	\N	0	229472	0	8331-1	3006322		
19328	1770	3006322	1998-01-19	1998-01-19 00:00:00	1998-01-19	5001	0	\N	0	0	\N	\N	0	118340	0	8331-1	3006322		
48899	4476	3023430	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	297806	0	6833-8	3023430		
28050	2577	3023430	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	170588	0	6833-8	3023430		
55389	5078	3006322	1979-01-09	1979-01-09 00:00:00	1979-01-09	5001	0	\N	0	0	\N	\N	0	337575	0	8331-1	3006322		
46113	4255	3006322	1984-08-14	1984-08-14 00:00:00	1984-08-14	5001	0	\N	0	0	\N	\N	0	282507	0	8331-1	3006322		
24165	2220	3006322	2013-12-07	2013-12-07 00:00:00	2013-12-07	5001	0	\N	0	0	\N	\N	0	147774	0	8331-1	3006322		
35860	3295	3051031	1952-06-07	1952-06-07 00:00:00	1952-06-07	5001	0	\N	0	0	\N	\N	0	218965	0	46240-8	3051031		
41327	3856	3006322	1989-06-02	1989-06-02 00:00:00	1989-06-02	5001	0	\N	0	0	\N	\N	0	255891	0	8331-1	3006322		
52088	4784	40766240	1950-07-30	1950-07-30 00:00:00	1950-07-30	5001	0	\N	0	0	\N	\N	0	318492	0	63513-6	40766240		
47620	4373	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	290380	0	6273-7	3006451		
19475	1780	3006322	2011-07-06	2011-07-06 00:00:00	2011-07-06	5001	0	\N	0	0	\N	\N	0	119096	0	8331-1	3006322		
51577	4724	3006322	1984-05-22	1984-05-22 00:00:00	1984-05-22	5001	0	\N	0	0	\N	\N	0	314772	0	8331-1	3006322		
51644	4725	3005136	1976-10-20	1976-10-20 00:00:00	1976-10-20	5001	0	\N	0	0	\N	\N	0	314867	0	6075-6	3005136		
106007	3263	4052083	2004-06-13	2004-06-13 00:00:00	2004-06-13	5001	0	\N	0	0	\N	\N	0	216963	0	23426006	4052083		
40745	1264	4133840	2012-11-16	2012-11-16 00:00:00	2012-11-16	5001	0	\N	0	0	\N	\N	0	83292	0	127783003	4133840		
117467	3621	4052083	1967-07-03	1967-07-03 00:00:00	1967-07-03	5001	0	\N	0	0	\N	\N	0	240579	0	23426006	4052083		
54260	4960	3006322	1916-10-08	1916-10-08 00:00:00	1916-10-08	5001	0	\N	0	0	\N	\N	0	329734	0	8331-1	3006322		
54324	4970	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	330434	0	6085-5	3001247		
54414	4975	3006322	1990-07-15	1990-07-15 00:00:00	1990-07-15	5001	0	\N	0	0	\N	\N	0	330882	0	8331-1	3006322		
21261	1967	3006322	1971-06-03	1971-06-03 00:00:00	1971-06-03	5001	0	\N	0	0	\N	\N	0	130782	0	8331-1	3006322		
32646	2959	3005136	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	197540	0	6075-6	3005136		
32658	2960	3006322	1998-02-18	1998-02-18 00:00:00	1998-02-18	5001	0	\N	0	0	\N	\N	0	197619	0	8331-1	3006322		
104427	3215	4024958	1986-02-06	1986-02-06 00:00:00	1986-02-06	5001	0	\N	0	0	\N	\N	0	213560	0	117015009	4024958		
13167	1259	3006322	1990-10-03	1990-10-03 00:00:00	1990-10-03	5001	0	\N	0	0	\N	\N	0	82977	0	8331-1	3006322		
7083	680	3005136	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	44996	0	6075-6	3005136		
6438	603	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	40004	0	7258-7	3001488		
11224	354	4133840	2012-02-09	2012-02-09 00:00:00	2012-02-09	5001	0	\N	0	0	\N	\N	0	23567	0	127783003	4133840		
22621	710	4024958	1980-07-07	1980-07-07 00:00:00	1980-07-07	5001	0	\N	0	0	\N	\N	0	47025	0	117015009	4024958		
29224	2692	40766240	1949-05-15	1949-05-15 00:00:00	1949-05-15	5001	0	\N	0	0	\N	\N	0	178348	0	63513-6	40766240		
29284	2697	3006322	1978-03-07	1978-03-07 00:00:00	1978-03-07	5001	0	\N	0	0	\N	\N	0	178596	0	8331-1	3006322		
30530	948	4052083	1965-12-13	1965-12-13 00:00:00	1965-12-13	5001	0	\N	0	0	\N	\N	0	62968	0	23426006	4052083		
14373	1345	40758406	1992-09-04	1992-09-04 00:00:00	1992-09-04	5001	0	\N	0	0	\N	\N	0	89104	0	55277-8	40758406		
44995	4156	40766240	2000-07-14	2000-07-14 00:00:00	2000-07-14	5001	0	\N	0	0	\N	\N	0	276173	0	63513-6	40766240		
25794	2369	3027231	1997-11-09	1997-11-09 00:00:00	1997-11-09	5001	0	\N	0	0	\N	\N	0	157655	0	6276-0	3027231		
50596	1536	4133840	1968-03-03	1968-03-03 00:00:00	1968-03-03	5001	0	\N	0	0	\N	\N	0	102776	0	127783003	4133840		
37278	3437	3051031	1924-06-23	1924-06-23 00:00:00	1924-06-23	5001	0	\N	0	0	\N	\N	0	228030	0	46240-8	3051031		
66393	2034	4024958	1924-03-14	1924-03-14 00:00:00	1924-03-14	5001	0	\N	0	0	\N	\N	0	135422	0	117015009	4024958		
92041	2836	4024958	2009-06-04	2009-06-04 00:00:00	2009-06-04	5001	0	\N	0	0	\N	\N	0	188400	0	117015009	4024958		
76259	2339	4024958	1986-02-24	1986-02-24 00:00:00	1986-02-24	5001	0	\N	0	0	\N	\N	0	155598	0	117015009	4024958		
22604	2075	3051031	2003-01-20	2003-01-20 00:00:00	2003-01-20	5001	0	\N	0	0	\N	\N	0	138006	0	46240-8	3051031		
50763	4626	3019406	2001-05-25	2001-05-25 00:00:00	2001-05-25	5001	0	\N	0	0	\N	\N	0	308225	0	6158-0	3019406		
50816	4633	3006322	1973-07-12	1973-07-12 00:00:00	1973-07-12	5001	0	\N	0	0	\N	\N	0	308740	0	8331-1	3006322		
16174	1476	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	98395	0	6273-7	3006451		
45712	4217	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	279964	0	6085-5	3001247		
45809	4224	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	280467	0	6085-5	3001247		
27336	2537	3000876	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	167631	0	6082-2	3000876		
24951	2291	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	152546	0	6085-5	3001247		
24991	2292	3006322	1997-03-19	1997-03-19 00:00:00	1997-03-19	5001	0	\N	0	0	\N	\N	0	152567	0	8331-1	3006322		
159394	4899	4133840	1967-02-21	1967-02-21 00:00:00	1967-02-21	5001	0	\N	0	0	\N	\N	0	325852	0	127783003	4133840		
50530	4608	3011505	2015-02-12	2015-02-12 00:00:00	2015-02-12	5001	0	\N	0	0	\N	\N	0	307061	0	19926-5	3011505		
36501	3353	3006322	2005-07-29	2005-07-29 00:00:00	2005-07-29	5001	0	\N	0	0	\N	\N	0	222420	0	8331-1	3006322		
95193	2921	4133840	1992-06-30	1992-06-30 00:00:00	1992-06-30	5001	0	\N	0	0	\N	\N	0	194758	0	127783003	4133840		
4186	411	3006322	1995-11-07	1995-11-07 00:00:00	1995-11-07	5001	0	\N	0	0	\N	\N	0	27336	0	8331-1	3006322		
132723	4086	4133840	2017-06-15	2017-06-15 00:00:00	2017-06-15	5001	0	\N	0	0	\N	\N	0	271578	0	127783003	4133840		
8664	836	3006322	2010-02-21	2010-02-21 00:00:00	2010-02-21	5001	0	\N	0	0	\N	\N	0	55298	0	8331-1	3006322		
37903	3504	3006322	1979-02-14	1979-02-14 00:00:00	1979-02-14	5001	0	\N	0	0	\N	\N	0	232279	0	8331-1	3006322		
20100	1844	3051031	1986-11-26	1986-11-26 00:00:00	1986-11-26	5001	0	\N	0	0	\N	\N	0	123247	0	46240-8	3051031		
31827	2905	3006322	1967-03-01	1967-03-01 00:00:00	1967-03-01	5001	0	\N	0	0	\N	\N	0	193553	0	8331-1	3006322		
49369	4506	40766240	2002-10-03	2002-10-03 00:00:00	2002-10-03	5001	0	\N	0	0	\N	\N	0	300208	0	63513-6	40766240		
14580	1356	3006322	1986-12-29	1986-12-29 00:00:00	1986-12-29	5001	0	\N	0	0	\N	\N	0	89930	0	8331-1	3006322		
14640	1358	3006322	1968-09-15	1968-09-15 00:00:00	1968-09-15	5001	0	\N	0	0	\N	\N	0	90069	0	8331-1	3006322		
16776	525	4052083	2002-02-19	2002-02-19 00:00:00	2002-02-19	5001	0	\N	0	0	\N	\N	0	34969	0	23426006	4052083		
28878	2669	40758406	1979-06-01	1979-06-01 00:00:00	1979-06-01	5001	0	\N	0	0	\N	\N	0	176801	0	55277-8	40758406		
44698	4130	46235214	1995-02-10	1995-02-10 00:00:00	1995-02-10	5001	0	\N	0	0	\N	\N	0	274607	0	76690-7	46235214		
19329	1770	3006322	1984-03-12	1984-03-12 00:00:00	1984-03-12	5001	0	\N	0	0	\N	\N	0	118357	0	8331-1	3006322		
48900	4476	3014599	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	297806	0	6106-9	3014599		
28051	2577	3036780	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	170588	0	6095-4	3036780		
55390	5078	3006322	1952-12-07	1952-12-07 00:00:00	1952-12-07	5001	0	\N	0	0	\N	\N	0	337537	0	8331-1	3006322		
12016	1143	40758406	1972-09-24	1972-09-24 00:00:00	1972-09-24	5001	0	\N	0	0	\N	\N	0	75437	0	55277-8	40758406		
35443	3244	3005136	1991-05-02	1991-05-02 00:00:00	1991-05-02	5001	0	\N	0	0	\N	\N	0	215732	0	6075-6	3005136		
35861	3295	40758406	1952-06-07	1952-06-07 00:00:00	1952-06-07	5001	0	\N	0	0	\N	\N	0	218965	0	55277-8	40758406		
41328	3856	3006322	1983-06-12	1983-06-12 00:00:00	1983-06-12	5001	0	\N	0	0	\N	\N	0	255890	0	8331-1	3006322		
52089	4784	3051031	1950-07-30	1950-07-30 00:00:00	1950-07-30	5001	0	\N	0	0	\N	\N	0	318492	0	46240-8	3051031		
47621	4373	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	290380	0	6246-3	3021226		
19476	1780	3006322	1978-05-06	1978-05-06 00:00:00	1978-05-06	5001	0	\N	0	0	\N	\N	0	119112	0	8331-1	3006322		
51579	4724	3049273	2011-03-06	2011-03-06 00:00:00	2011-03-06	5001	0	\N	0	0	\N	\N	0	314862	0	38265-5	3049273		
51645	4725	3014599	1976-10-20	1976-10-20 00:00:00	1976-10-20	5001	0	\N	0	0	\N	\N	0	314867	0	6106-9	3014599		
129402	3984	4052083	1957-05-07	1957-05-07 00:00:00	1957-05-07	5001	0	\N	0	0	\N	\N	0	264819	0	23426006	4052083		
40746	1264	4024958	1997-06-20	1997-06-20 00:00:00	1997-06-20	5001	0	\N	0	0	\N	\N	0	83316	0	117015009	4024958		
117469	3621	4133840	1982-09-18	1982-09-18 00:00:00	1982-09-18	5001	0	\N	0	0	\N	\N	0	240645	0	127783003	4133840		
54262	4960	3049273	1989-12-21	1989-12-21 00:00:00	1989-12-21	5001	0	\N	0	0	\N	\N	0	329712	0	38265-5	3049273		
54325	4970	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	330434	0	6189-5	3006734		
54415	4975	3006322	1973-05-11	1973-05-11 00:00:00	1973-05-11	5001	0	\N	0	0	\N	\N	0	330903	0	8331-1	3006322		
21262	1967	46235214	1957-03-11	1957-03-11 00:00:00	1957-03-11	5001	0	\N	0	0	\N	\N	0	130791	0	76690-7	46235214		
32647	2959	3001488	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	197540	0	7258-7	3001488		
32659	2960	3006322	2008-05-25	2008-05-25 00:00:00	2008-05-25	5001	0	\N	0	0	\N	\N	0	197693	0	8331-1	3006322		
104442	3215	4024958	1992-12-16	1992-12-16 00:00:00	1992-12-16	5001	0	\N	0	0	\N	\N	0	213681	0	117015009	4024958		
13168	1259	3006322	1962-06-06	1962-06-06 00:00:00	1962-06-06	5001	0	\N	0	0	\N	\N	0	82972	0	8331-1	3006322		
7084	680	3021226	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	44996	0	6246-3	3021226		
6439	603	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	40004	0	6085-5	3001247		
11226	354	4133840	2000-01-20	2000-01-20 00:00:00	2000-01-20	5001	0	\N	0	0	\N	\N	0	23575	0	127783003	4133840		
40223	1250	4052083	1997-10-03	1997-10-03 00:00:00	1997-10-03	5001	0	\N	0	0	\N	\N	0	82375	0	23426006	4052083		
29225	2692	46235214	1949-05-15	1949-05-15 00:00:00	1949-05-15	5001	0	\N	0	0	\N	\N	0	178348	0	76690-7	46235214		
29286	2697	3006322	1952-02-11	1952-02-11 00:00:00	1952-02-11	5001	0	\N	0	0	\N	\N	0	178609	0	8331-1	3006322		
30535	949	4133840	2018-05-14	2018-05-14 00:00:00	2018-05-14	5001	0	\N	0	0	\N	\N	0	63003	0	127783003	4133840		
14374	1345	40766240	1992-09-04	1992-09-04 00:00:00	1992-09-04	5001	0	\N	0	0	\N	\N	0	89104	0	63513-6	40766240		
44996	4156	40766240	2001-05-10	2001-05-10 00:00:00	2001-05-10	5001	0	\N	0	0	\N	\N	0	276212	0	63513-6	40766240		
25795	2369	3014599	1997-11-09	1997-11-09 00:00:00	1997-11-09	5001	0	\N	0	0	\N	\N	0	157655	0	6106-9	3014599		
50598	1536	4133840	1968-11-10	1968-11-10 00:00:00	1968-11-10	5001	0	\N	0	0	\N	\N	0	102845	0	127783003	4133840		
37279	3437	40758406	1924-06-23	1924-06-23 00:00:00	1924-06-23	5001	0	\N	0	0	\N	\N	0	228030	0	55277-8	40758406		
55167	1672	4024958	2006-02-03	2006-02-03 00:00:00	2006-02-03	5001	0	\N	0	0	\N	\N	0	112250	0	117015009	4024958		
92047	2836	4024958	2001-02-02	2001-02-02 00:00:00	2001-02-02	5001	0	\N	0	0	\N	\N	0	188387	0	117015009	4024958		
76293	2339	4024958	1997-08-08	1997-08-08 00:00:00	1997-08-08	5001	0	\N	0	0	\N	\N	0	155631	0	117015009	4024958		
22605	2075	46235214	2003-01-20	2003-01-20 00:00:00	2003-01-20	5001	0	\N	0	0	\N	\N	0	138006	0	76690-7	46235214		
50764	4626	3015076	2001-05-25	2001-05-25 00:00:00	2001-05-25	5001	0	\N	0	0	\N	\N	0	308225	0	6248-9	3015076		
50817	4633	3006322	2002-07-09	2002-07-09 00:00:00	2002-07-09	5001	0	\N	0	0	\N	\N	0	308750	0	8331-1	3006322		
16175	1476	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	98395	0	6075-6	3005136		
45713	4217	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	279964	0	6075-6	3005136		
45810	4224	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	280467	0	6833-8	3023430		
27337	2537	3021226	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	167631	0	6246-3	3021226		
24952	2291	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	152546	0	6248-9	3015076		
24992	2292	3011505	2017-03-17	2017-03-17 00:00:00	2017-03-17	5001	0	\N	0	0	\N	\N	0	152592	0	19926-5	3011505		
159397	4899	4133840	1994-10-18	1994-10-18 00:00:00	1994-10-18	5001	0	\N	0	0	\N	\N	0	325861	0	127783003	4133840		
50531	4608	3011505	2010-01-14	2010-01-14 00:00:00	2010-01-14	5001	0	\N	0	0	\N	\N	0	306943	0	19926-5	3011505		
36502	3353	3006322	1992-12-21	1992-12-21 00:00:00	1992-12-21	5001	0	\N	0	0	\N	\N	0	222358	0	8331-1	3006322		
95196	2921	4133840	2010-10-12	2010-10-12 00:00:00	2010-10-12	5001	0	\N	0	0	\N	\N	0	194744	0	127783003	4133840		
4187	411	3006322	1971-10-05	1971-10-05 00:00:00	1971-10-05	5001	0	\N	0	0	\N	\N	0	27308	0	8331-1	3006322		
132730	4087	4052083	1988-11-20	1988-11-20 00:00:00	1988-11-20	5001	0	\N	0	0	\N	\N	0	271667	0	23426006	4052083		
8676	841	3006322	1958-05-17	1958-05-17 00:00:00	1958-05-17	5001	0	\N	0	0	\N	\N	0	55513	0	8331-1	3006322		
37906	3504	3006322	1931-04-04	1931-04-04 00:00:00	1931-04-04	5001	0	\N	0	0	\N	\N	0	232288	0	8331-1	3006322		
20102	1844	3006322	1999-10-24	1999-10-24 00:00:00	1999-10-24	5001	0	\N	0	0	\N	\N	0	123178	0	8331-1	3006322		
31828	2905	3006322	2004-04-03	2004-04-03 00:00:00	2004-04-03	5001	0	\N	0	0	\N	\N	0	193541	0	8331-1	3006322		
49370	4506	40766240	1984-02-10	1984-02-10 00:00:00	1984-02-10	5001	0	\N	0	0	\N	\N	0	300207	0	63513-6	40766240		
14581	1356	3006322	1981-02-14	1981-02-14 00:00:00	1981-02-14	5001	0	\N	0	0	\N	\N	0	89939	0	8331-1	3006322		
14641	1358	3006322	1970-07-18	1970-07-18 00:00:00	1970-07-18	5001	0	\N	0	0	\N	\N	0	90046	0	8331-1	3006322		
16784	525	4024958	1977-10-31	1977-10-31 00:00:00	1977-10-31	5001	0	\N	0	0	\N	\N	0	34973	0	117015009	4024958		
28879	2669	46235214	1979-06-01	1979-06-01 00:00:00	1979-06-01	5001	0	\N	0	0	\N	\N	0	176801	0	76690-7	46235214		
44699	4130	40758406	1995-02-10	1995-02-10 00:00:00	1995-02-10	5001	0	\N	0	0	\N	\N	0	274607	0	55277-8	40758406		
19330	1770	3006322	2017-03-21	2017-03-21 00:00:00	2017-03-21	5001	0	\N	0	0	\N	\N	0	118347	0	8331-1	3006322		
48901	4476	3019406	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	297806	0	6158-0	3019406		
28052	2577	3020655	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	170588	0	6844-5	3020655		
55393	5078	3006322	1936-04-20	1936-04-20 00:00:00	1936-04-20	5001	0	\N	0	0	\N	\N	0	337635	0	8331-1	3006322		
12017	1143	3051031	1972-09-24	1972-09-24 00:00:00	1972-09-24	5001	0	\N	0	0	\N	\N	0	75437	0	46240-8	3051031		
35444	3244	3021226	1991-05-02	1991-05-02 00:00:00	1991-05-02	5001	0	\N	0	0	\N	\N	0	215732	0	6246-3	3021226		
35862	3295	46235214	1952-06-07	1952-06-07 00:00:00	1952-06-07	5001	0	\N	0	0	\N	\N	0	218965	0	76690-7	46235214		
41329	3857	3006322	1996-06-25	1996-06-25 00:00:00	1996-06-25	5001	0	\N	0	0	\N	\N	0	256031	0	8331-1	3006322		
99554	3056	4024958	2000-03-28	2000-03-28 00:00:00	2000-03-28	5001	0	\N	0	0	\N	\N	0	203254	0	117015009	4024958		
47622	4373	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	290380	0	6075-6	3005136		
19477	1780	3006322	1972-01-27	1972-01-27 00:00:00	1972-01-27	5001	0	\N	0	0	\N	\N	0	119110	0	8331-1	3006322		
51580	4724	3006322	2015-05-23	2015-05-23 00:00:00	2015-05-23	5001	0	\N	0	0	\N	\N	0	314719	0	8331-1	3006322		
51646	4725	3006734	1976-10-20	1976-10-20 00:00:00	1976-10-20	5001	0	\N	0	0	\N	\N	0	314867	0	6189-5	3006734		
140705	4342	4024958	1971-05-06	1971-05-06 00:00:00	1971-05-06	5001	0	\N	0	0	\N	\N	0	287957	0	117015009	4024958		
40747	1264	4133840	1992-01-17	1992-01-17 00:00:00	1992-01-17	5001	0	\N	0	0	\N	\N	0	83311	0	127783003	4133840		
117471	3621	4133840	1976-08-14	1976-08-14 00:00:00	1976-08-14	5001	0	\N	0	0	\N	\N	0	240642	0	127783003	4133840		
54263	4960	3006322	1990-10-03	1990-10-03 00:00:00	1990-10-03	5001	0	\N	0	0	\N	\N	0	329687	0	8331-1	3006322		
54326	4970	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	330434	0	6075-6	3005136		
54416	4976	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	330938	0	7258-7	3001488		
21263	1967	40766240	1957-03-11	1957-03-11 00:00:00	1957-03-11	5001	0	\N	0	0	\N	\N	0	130791	0	63513-6	40766240		
32648	2959	3023430	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	197540	0	6833-8	3023430		
32660	2960	3006322	1969-05-06	1969-05-06 00:00:00	1969-05-06	5001	0	\N	0	0	\N	\N	0	197612	0	8331-1	3006322		
104444	3215	4052083	1997-10-24	1997-10-24 00:00:00	1997-10-24	5001	0	\N	0	0	\N	\N	0	213666	0	23426006	4052083		
13169	1259	3006322	2006-05-08	2006-05-08 00:00:00	2006-05-08	5001	0	\N	0	0	\N	\N	0	82984	0	8331-1	3006322		
86244	2666	4024958	2016-12-21	2016-12-21 00:00:00	2016-12-21	5001	0	\N	0	0	\N	\N	0	176606	0	117015009	4024958		
6440	603	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	40004	0	6189-5	3006734		
11229	354	4133840	2004-01-29	2004-01-29 00:00:00	2004-01-29	5001	0	\N	0	0	\N	\N	0	23587	0	127783003	4133840		
40225	1250	4024958	1996-05-22	1996-05-22 00:00:00	1996-05-22	5001	0	\N	0	0	\N	\N	0	82322	0	117015009	4024958		
29226	2692	3006322	1958-04-26	1958-04-26 00:00:00	1958-04-26	5001	0	\N	0	0	\N	\N	0	178349	0	8331-1	3006322		
29287	2697	3006322	1947-07-09	1947-07-09 00:00:00	1947-07-09	5001	0	\N	0	0	\N	\N	0	178571	0	8331-1	3006322		
30536	949	4133840	2000-04-03	2000-04-03 00:00:00	2000-04-03	5001	0	\N	0	0	\N	\N	0	63034	0	127783003	4133840		
14376	1345	46235214	1992-09-04	1992-09-04 00:00:00	1992-09-04	5001	0	\N	0	0	\N	\N	0	89104	0	76690-7	46235214		
44997	4156	46235214	2001-05-10	2001-05-10 00:00:00	2001-05-10	5001	0	\N	0	0	\N	\N	0	276212	0	76690-7	46235214		
25796	2369	3006451	1997-11-09	1997-11-09 00:00:00	1997-11-09	5001	0	\N	0	0	\N	\N	0	157655	0	6273-7	3006451		
50599	1536	4133840	1971-11-28	1971-11-28 00:00:00	1971-11-28	5001	0	\N	0	0	\N	\N	0	102837	0	127783003	4133840		
37280	3438	3006322	1916-08-10	1916-08-10 00:00:00	1916-08-10	5001	0	\N	0	0	\N	\N	0	228070	0	8331-1	3006322		
55178	1672	4024958	1962-08-20	1962-08-20 00:00:00	1962-08-20	5001	0	\N	0	0	\N	\N	0	112221	0	117015009	4024958		
92048	2836	4024958	2011-02-05	2011-02-05 00:00:00	2011-02-05	5001	0	\N	0	0	\N	\N	0	188406	0	117015009	4024958		
76306	2339	4024958	1982-08-01	1982-08-01 00:00:00	1982-08-01	5001	0	\N	0	0	\N	\N	0	155612	0	117015009	4024958		
22607	2075	40766240	2003-01-20	2003-01-20 00:00:00	2003-01-20	5001	0	\N	0	0	\N	\N	0	138006	0	63513-6	40766240		
50765	4626	3001247	2001-05-25	2001-05-25 00:00:00	2001-05-25	5001	0	\N	0	0	\N	\N	0	308225	0	6085-5	3001247		
50818	4633	3006322	1991-03-26	1991-03-26 00:00:00	1991-03-26	5001	0	\N	0	0	\N	\N	0	308741	0	8331-1	3006322		
16176	1476	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	98395	0	6248-9	3015076		
45714	4217	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	279964	0	6106-9	3014599		
45811	4224	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	280467	0	6844-5	3020655		
27338	2537	3012494	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	167631	0	6206-7	3012494		
24953	2291	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	152546	0	7258-7	3001488		
24993	2292	3006322	1966-11-02	1966-11-02 00:00:00	1966-11-02	5001	0	\N	0	0	\N	\N	0	152612	0	8331-1	3006322		
159399	4899	4133840	1974-06-25	1974-06-25 00:00:00	1974-06-25	5001	0	\N	0	0	\N	\N	0	325794	0	127783003	4133840		
50532	4608	3011505	2018-03-01	2018-03-01 00:00:00	2018-03-01	5001	0	\N	0	0	\N	\N	0	307093	0	19926-5	3011505		
36503	3353	3006322	1996-11-28	1996-11-28 00:00:00	1996-11-28	5001	0	\N	0	0	\N	\N	0	222419	0	8331-1	3006322		
95201	2921	4133840	1987-05-26	1987-05-26 00:00:00	1987-05-26	5001	0	\N	0	0	\N	\N	0	194765	0	127783003	4133840		
4188	411	3006322	1964-01-07	1964-01-07 00:00:00	1964-01-07	5001	0	\N	0	0	\N	\N	0	27319	0	8331-1	3006322		
132732	4087	4052083	1983-12-18	1983-12-18 00:00:00	1983-12-18	5001	0	\N	0	0	\N	\N	0	271666	0	23426006	4052083		
8677	841	3006322	2006-01-18	2006-01-18 00:00:00	2006-01-18	5001	0	\N	0	0	\N	\N	0	55516	0	8331-1	3006322		
37907	3505	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	232384	0	6276-0	3027231		
20103	1844	40766240	1989-08-22	1989-08-22 00:00:00	1989-08-22	5001	0	\N	0	0	\N	\N	0	123139	0	63513-6	40766240		
31830	2906	3006322	1962-10-04	1962-10-04 00:00:00	1962-10-04	5001	0	\N	0	0	\N	\N	0	193616	0	8331-1	3006322		
49373	4506	46235214	1984-02-10	1984-02-10 00:00:00	1984-02-10	5001	0	\N	0	0	\N	\N	0	300207	0	76690-7	46235214		
14582	1356	3006322	2001-08-11	2001-08-11 00:00:00	2001-08-11	5001	0	\N	0	0	\N	\N	0	89945	0	8331-1	3006322		
14642	1358	3049273	2010-08-17	2010-08-17 00:00:00	2010-08-17	5001	0	\N	0	0	\N	\N	0	90112	0	38265-5	3049273		
16785	525	4024958	1997-04-03	1997-04-03 00:00:00	1997-04-03	5001	0	\N	0	0	\N	\N	0	34968	0	117015009	4024958		
28881	2669	40766240	1979-06-01	1979-06-01 00:00:00	1979-06-01	5001	0	\N	0	0	\N	\N	0	176801	0	63513-6	40766240		
44700	4130	40766240	1995-02-10	1995-02-10 00:00:00	1995-02-10	5001	0	\N	0	0	\N	\N	0	274607	0	63513-6	40766240		
30610	2804	3006322	1959-12-29	1959-12-29 00:00:00	1959-12-29	5001	0	\N	0	0	\N	\N	0	185810	0	8331-1	3006322		
48902	4476	3020655	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	297806	0	6844-5	3020655		
28053	2577	3001488	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	170588	0	7258-7	3001488		
55395	5078	3049273	1983-05-23	1983-05-23 00:00:00	1983-05-23	5001	0	\N	0	0	\N	\N	0	337526	0	38265-5	3049273		
12019	1143	46235214	1972-09-24	1972-09-24 00:00:00	1972-09-24	5001	0	\N	0	0	\N	\N	0	75437	0	76690-7	46235214		
35445	3244	3027231	1991-05-02	1991-05-02 00:00:00	1991-05-02	5001	0	\N	0	0	\N	\N	0	215732	0	6276-0	3027231		
35865	3295	40766240	1952-06-07	1952-06-07 00:00:00	1952-06-07	5001	0	\N	0	0	\N	\N	0	218965	0	63513-6	40766240		
41330	3857	3011505	2007-08-28	2007-08-28 00:00:00	2007-08-28	5001	0	\N	0	0	\N	\N	0	256003	0	19926-5	3011505		
99559	3056	4052083	1983-08-03	1983-08-03 00:00:00	1983-08-03	5001	0	\N	0	0	\N	\N	0	203229	0	23426006	4052083		
47623	4373	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	290380	0	6833-8	3023430		
19478	1781	3006322	1941-08-11	1941-08-11 00:00:00	1941-08-11	5001	0	\N	0	0	\N	\N	0	119194	0	8331-1	3006322		
51581	4724	3049273	2003-09-14	2003-09-14 00:00:00	2003-09-14	5001	0	\N	0	0	\N	\N	0	314690	0	38265-5	3049273		
51647	4725	3023430	1976-10-20	1976-10-20 00:00:00	1976-10-20	5001	0	\N	0	0	\N	\N	0	314867	0	6833-8	3023430		
140737	4342	4052083	1964-01-02	1964-01-02 00:00:00	1964-01-02	5001	0	\N	0	0	\N	\N	0	287942	0	23426006	4052083		
40748	1264	4052083	2001-02-02	2001-02-02 00:00:00	2001-02-02	5001	0	\N	0	0	\N	\N	0	83339	0	23426006	4052083		
117472	3621	4133840	1991-05-11	1991-05-11 00:00:00	1991-05-11	5001	0	\N	0	0	\N	\N	0	240646	0	127783003	4133840		
54265	4960	3006322	1948-03-30	1948-03-30 00:00:00	1948-03-30	5001	0	\N	0	0	\N	\N	0	329717	0	8331-1	3006322		
54327	4970	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	330434	0	6248-9	3015076		
119055	3667	4052083	1985-11-14	1985-11-14 00:00:00	1985-11-14	5001	0	\N	0	0	\N	\N	0	243946	0	23426006	4052083		
21264	1967	3051031	1957-03-11	1957-03-11 00:00:00	1957-03-11	5001	0	\N	0	0	\N	\N	0	130791	0	46240-8	3051031		
32649	2959	3006734	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	197540	0	6189-5	3006734		
32661	2960	3006322	1956-03-19	1956-03-19 00:00:00	1956-03-19	5001	0	\N	0	0	\N	\N	0	197629	0	8331-1	3006322		
104450	3216	4024958	2015-05-31	2015-05-31 00:00:00	2015-05-31	5001	0	\N	0	0	\N	\N	0	213715	0	117015009	4024958		
13170	1259	3006322	1997-10-11	1997-10-11 00:00:00	1997-10-11	5001	0	\N	0	0	\N	\N	0	82924	0	8331-1	3006322		
86246	2666	4024958	1980-04-05	1980-04-05 00:00:00	1980-04-05	5001	0	\N	0	0	\N	\N	0	176648	0	117015009	4024958		
6441	603	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	40004	0	6075-6	3005136		
11234	354	4133840	2016-03-03	2016-03-03 00:00:00	2016-03-03	5001	0	\N	0	0	\N	\N	0	23569	0	127783003	4133840		
40226	1250	4052083	1961-06-11	1961-06-11 00:00:00	1961-06-11	5001	0	\N	0	0	\N	\N	0	82328	0	23426006	4052083		
29227	2692	3006322	1974-07-13	1974-07-13 00:00:00	1974-07-13	5001	0	\N	0	0	\N	\N	0	178336	0	8331-1	3006322		
29288	2698	3006322	2005-12-07	2005-12-07 00:00:00	2005-12-07	5001	0	\N	0	0	\N	\N	0	178686	0	8331-1	3006322		
30537	949	4133840	1989-09-25	1989-09-25 00:00:00	1989-09-25	5001	0	\N	0	0	\N	\N	0	63043	0	127783003	4133840		
14378	1345	3051031	1992-09-04	1992-09-04 00:00:00	1992-09-04	5001	0	\N	0	0	\N	\N	0	89104	0	46240-8	3051031		
44998	4156	40758406	2001-05-10	2001-05-10 00:00:00	2001-05-10	5001	0	\N	0	0	\N	\N	0	276212	0	55277-8	40758406		
25797	2369	3012494	1997-11-09	1997-11-09 00:00:00	1997-11-09	5001	0	\N	0	0	\N	\N	0	157655	0	6206-7	3012494		
50612	1536	4133840	1969-11-16	1969-11-16 00:00:00	1969-11-16	5001	0	\N	0	0	\N	\N	0	102836	0	127783003	4133840		
37284	3438	3000963	1980-03-30	1980-03-30 00:00:00	1980-03-30	5001	0	\N	0	0	\N	\N	0	228075	0	718-7	3000963		
55179	1672	4024958	1958-10-31	1958-10-31 00:00:00	1958-10-31	5001	0	\N	0	0	\N	\N	0	112247	0	117015009	4024958		
35303	1099	4024958	1993-04-30	1993-04-30 00:00:00	1993-04-30	5001	0	\N	0	0	\N	\N	0	72206	0	117015009	4024958		
76322	2340	4052083	1999-06-11	1999-06-11 00:00:00	1999-06-11	5001	0	\N	0	0	\N	\N	0	155713	0	23426006	4052083		
22609	2075	3006322	1982-06-07	1982-06-07 00:00:00	1982-06-07	5001	0	\N	0	0	\N	\N	0	138117	0	8331-1	3006322		
50766	4626	3000876	2001-05-25	2001-05-25 00:00:00	2001-05-25	5001	0	\N	0	0	\N	\N	0	308225	0	6082-2	3000876		
50819	4634	3006322	2015-05-03	2015-05-03 00:00:00	2015-05-03	5001	0	\N	0	0	\N	\N	0	308881	0	8331-1	3006322		
16177	1476	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	98395	0	6206-7	3012494		
45715	4217	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	279964	0	6158-0	3019406		
45812	4224	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	280467	0	6189-5	3006734		
27339	2537	3006322	1957-01-09	1957-01-09 00:00:00	1957-01-09	5001	0	\N	0	0	\N	\N	0	167711	0	8331-1	3006322		
24954	2291	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	152546	0	6246-3	3021226		
24994	2292	3006322	2009-08-13	2009-08-13 00:00:00	2009-08-13	5001	0	\N	0	0	\N	\N	0	152607	0	8331-1	3006322		
159404	4899	4133840	1996-10-29	1996-10-29 00:00:00	1996-10-29	5001	0	\N	0	0	\N	\N	0	325862	0	127783003	4133840		
50533	4608	3011505	2001-02-22	2001-02-22 00:00:00	2001-02-22	5001	0	\N	0	0	\N	\N	0	307059	0	19926-5	3011505		
36504	3353	3006322	1962-05-02	1962-05-02 00:00:00	1962-05-02	5001	0	\N	0	0	\N	\N	0	222334	0	8331-1	3006322		
95203	2921	4133840	1997-07-29	1997-07-29 00:00:00	1997-07-29	5001	0	\N	0	0	\N	\N	0	194741	0	127783003	4133840		
4189	411	3006322	1975-05-27	1975-05-27 00:00:00	1975-05-27	5001	0	\N	0	0	\N	\N	0	27310	0	8331-1	3006322		
132743	4087	4052083	2002-09-17	2002-09-17 00:00:00	2002-09-17	5001	0	\N	0	0	\N	\N	0	271670	0	23426006	4052083		
8678	841	40769194	1955-07-10	1955-07-10 00:00:00	1955-07-10	5001	0	\N	0	0	\N	\N	0	55548	0	66534-9	40769194		
37908	3505	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	232384	0	6273-7	3006451		
20104	1844	46235214	1989-08-22	1989-08-22 00:00:00	1989-08-22	5001	0	\N	0	0	\N	\N	0	123139	0	76690-7	46235214		
31832	2906	3049273	2014-07-12	2014-07-12 00:00:00	2014-07-12	5001	0	\N	0	0	\N	\N	0	193623	0	38265-5	3049273		
49374	4506	40758406	1984-02-10	1984-02-10 00:00:00	1984-02-10	5001	0	\N	0	0	\N	\N	0	300207	0	55277-8	40758406		
14583	1356	3019406	1995-02-23	1995-02-23 00:00:00	1995-02-23	5001	0	\N	0	0	\N	\N	0	89888	0	6158-0	3019406		
14643	1359	3006322	1975-06-29	1975-06-29 00:00:00	1975-06-29	5001	0	\N	0	0	\N	\N	0	90205	0	8331-1	3006322		
142943	4390	4052083	1962-11-19	1962-11-19 00:00:00	1962-11-19	5001	0	\N	0	0	\N	\N	0	291812	0	23426006	4052083		
28883	2669	3051031	1979-06-01	1979-06-01 00:00:00	1979-06-01	5001	0	\N	0	0	\N	\N	0	176801	0	46240-8	3051031		
44701	4130	3051031	1995-02-10	1995-02-10 00:00:00	1995-02-10	5001	0	\N	0	0	\N	\N	0	274607	0	46240-8	3051031		
30611	2804	3006322	1982-07-20	1982-07-20 00:00:00	1982-07-20	5001	0	\N	0	0	\N	\N	0	185824	0	8331-1	3006322		
48903	4476	3001247	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	297806	0	6085-5	3001247		
28054	2577	3006734	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	170588	0	6189-5	3006734		
55396	5079	3006322	1983-08-17	1983-08-17 00:00:00	1983-08-17	5001	0	\N	0	0	\N	\N	0	337674	0	8331-1	3006322		
12021	1143	40766240	1972-09-24	1972-09-24 00:00:00	1972-09-24	5001	0	\N	0	0	\N	\N	0	75437	0	63513-6	40766240		
35446	3244	3019406	1991-05-02	1991-05-02 00:00:00	1991-05-02	5001	0	\N	0	0	\N	\N	0	215732	0	6158-0	3019406		
35866	3295	3049273	2009-02-23	2009-02-23 00:00:00	2009-02-23	5001	0	\N	0	0	\N	\N	0	218897	0	38265-5	3049273		
41331	3857	3011505	1972-03-14	1972-03-14 00:00:00	1972-03-14	5001	0	\N	0	0	\N	\N	0	256054	0	19926-5	3011505		
122714	3784	4133840	1991-08-13	1991-08-13 00:00:00	1991-08-13	5001	0	\N	0	0	\N	\N	0	251463	0	127783003	4133840		
47624	4373	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	290380	0	6844-5	3020655		
19479	1781	3006322	1994-08-10	1994-08-10 00:00:00	1994-08-10	5001	0	\N	0	0	\N	\N	0	119259	0	8331-1	3006322		
51582	4724	3009542	1941-05-07	1941-05-07 00:00:00	1941-05-07	5001	0	\N	0	0	\N	\N	0	314678	0	20570-8	3009542		
51648	4725	3015076	1976-10-20	1976-10-20 00:00:00	1976-10-20	5001	0	\N	0	0	\N	\N	0	314867	0	6248-9	3015076		
140741	4342	4024958	1964-06-01	1964-06-01 00:00:00	1964-06-01	5001	0	\N	0	0	\N	\N	0	287943	0	117015009	4024958		
40749	1264	4133840	2017-05-26	2017-05-26 00:00:00	2017-05-26	5001	0	\N	0	0	\N	\N	0	83294	0	127783003	4133840		
117475	3621	4052083	1972-02-28	1972-02-28 00:00:00	1972-02-28	5001	0	\N	0	0	\N	\N	0	240611	0	23426006	4052083		
54272	4963	3006322	1985-02-19	1985-02-19 00:00:00	1985-02-19	5001	0	\N	0	0	\N	\N	0	329964	0	8331-1	3006322		
54328	4970	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	330434	0	6246-3	3021226		
119058	3667	4024958	1977-09-15	1977-09-15 00:00:00	1977-09-15	5001	0	\N	0	0	\N	\N	0	243945	0	117015009	4024958		
21265	1967	40758406	1957-03-11	1957-03-11 00:00:00	1957-03-11	5001	0	\N	0	0	\N	\N	0	130791	0	55277-8	40758406		
32650	2959	3020655	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	197540	0	6844-5	3020655		
32662	2960	3006322	2016-04-13	2016-04-13 00:00:00	2016-04-13	5001	0	\N	0	0	\N	\N	0	197617	0	8331-1	3006322		
104452	3216	4052083	2002-06-13	2002-06-13 00:00:00	2002-06-13	5001	0	\N	0	0	\N	\N	0	213712	0	23426006	4052083		
13171	1259	3006322	1953-04-03	1953-04-03 00:00:00	1953-04-03	5001	0	\N	0	0	\N	\N	0	82980	0	8331-1	3006322		
86248	2666	4024958	2000-06-08	2000-06-08 00:00:00	2000-06-08	5001	0	\N	0	0	\N	\N	0	176649	0	117015009	4024958		
6442	603	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	40004	0	6248-9	3015076		
11237	354	4133840	2011-02-03	2011-02-03 00:00:00	2011-02-03	5001	0	\N	0	0	\N	\N	0	23578	0	127783003	4133840		
40267	1253	4052083	1970-12-16	1970-12-16 00:00:00	1970-12-16	5001	0	\N	0	0	\N	\N	0	82561	0	23426006	4052083		
29228	2692	40758406	1949-03-16	1949-03-16 00:00:00	1949-03-16	5001	0	\N	0	0	\N	\N	0	178328	0	55277-8	40758406		
29289	2698	3006322	2004-02-01	2004-02-01 00:00:00	2004-02-01	5001	0	\N	0	0	\N	\N	0	178685	0	8331-1	3006322		
30542	949	4133840	2012-11-26	2012-11-26 00:00:00	2012-11-26	5001	0	\N	0	0	\N	\N	0	63000	0	127783003	4133840		
14379	1345	3051031	1992-08-05	1992-08-05 00:00:00	1992-08-05	5001	0	\N	0	0	\N	\N	0	89145	0	46240-8	3051031		
45001	4156	3051031	2001-05-10	2001-05-10 00:00:00	2001-05-10	5001	0	\N	0	0	\N	\N	0	276212	0	46240-8	3051031		
25798	2369	3000876	1997-11-09	1997-11-09 00:00:00	1997-11-09	5001	0	\N	0	0	\N	\N	0	157655	0	6082-2	3000876		
50613	1537	4024958	1963-10-09	1963-10-09 00:00:00	1963-10-09	5001	0	\N	0	0	\N	\N	0	102867	0	117015009	4024958		
37285	3438	3009542	1980-03-30	1980-03-30 00:00:00	1980-03-30	5001	0	\N	0	0	\N	\N	0	228075	0	20570-8	3009542		
55181	1672	4024958	1966-09-11	1966-09-11 00:00:00	1966-09-11	5001	0	\N	0	0	\N	\N	0	112240	0	117015009	4024958		
35323	1100	4024958	1997-10-12	1997-10-12 00:00:00	1997-10-12	5001	0	\N	0	0	\N	\N	0	72279	0	117015009	4024958		
166522	5116	4024958	2016-08-23	2016-08-23 00:00:00	2016-08-23	5001	0	\N	0	0	\N	\N	0	339950	0	117015009	4024958		
22610	2075	3049273	2019-04-15	2019-04-15 00:00:00	2019-04-15	5001	0	\N	0	0	\N	\N	0	138004	0	38265-5	3049273		
50767	4626	3027231	2001-05-25	2001-05-25 00:00:00	2001-05-25	5001	0	\N	0	0	\N	\N	0	308225	0	6276-0	3027231		
50820	4634	3006322	2012-03-06	2012-03-06 00:00:00	2012-03-06	5001	0	\N	0	0	\N	\N	0	308832	0	8331-1	3006322		
16178	1476	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	98395	0	7258-7	3001488		
45716	4217	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	279964	0	6248-9	3015076		
45813	4224	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	280467	0	6246-3	3021226		
27340	2537	3006322	1953-05-20	1953-05-20 00:00:00	1953-05-20	5001	0	\N	0	0	\N	\N	0	167710	0	8331-1	3006322		
95570	2929	4052083	1992-10-13	1992-10-13 00:00:00	1992-10-13	5001	0	\N	0	0	\N	\N	0	195365	0	23426006	4052083		
24995	2294	3006322	1981-05-15	1981-05-15 00:00:00	1981-05-15	5001	0	\N	0	0	\N	\N	0	152703	0	8331-1	3006322		
159408	4899	4133840	1984-08-21	1984-08-21 00:00:00	1984-08-21	5001	0	\N	0	0	\N	\N	0	325856	0	127783003	4133840		
50534	4608	3011505	2013-01-31	2013-01-31 00:00:00	2013-01-31	5001	0	\N	0	0	\N	\N	0	307021	0	19926-5	3011505		
36505	3353	3006322	1979-04-14	1979-04-14 00:00:00	1979-04-14	5001	0	\N	0	0	\N	\N	0	222335	0	8331-1	3006322		
95205	2921	4133840	1978-06-13	1978-06-13 00:00:00	1978-06-13	5001	0	\N	0	0	\N	\N	0	194755	0	127783003	4133840		
4190	411	3006322	2007-12-03	2007-12-03 00:00:00	2007-12-03	5001	0	\N	0	0	\N	\N	0	27272	0	8331-1	3006322		
5192	499	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	33423	0	6276-0	3027231		
8679	841	40769184	1955-07-10	1955-07-10 00:00:00	1955-07-10	5001	0	\N	0	0	\N	\N	0	55548	0	66524-0	40769184		
37909	3505	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	232384	0	6246-3	3021226		
20106	1844	3051031	1989-08-22	1989-08-22 00:00:00	1989-08-22	5001	0	\N	0	0	\N	\N	0	123139	0	46240-8	3051031		
31834	2906	3006322	1947-07-11	1947-07-11 00:00:00	1947-07-11	5001	0	\N	0	0	\N	\N	0	193657	0	8331-1	3006322		
49375	4506	3051031	1984-02-10	1984-02-10 00:00:00	1984-02-10	5001	0	\N	0	0	\N	\N	0	300207	0	46240-8	3051031		
14584	1356	3012494	1995-02-23	1995-02-23 00:00:00	1995-02-23	5001	0	\N	0	0	\N	\N	0	89888	0	6206-7	3012494		
14647	1359	3006322	1982-02-03	1982-02-03 00:00:00	1982-02-03	5001	0	\N	0	0	\N	\N	0	90180	0	8331-1	3006322		
97247	2975	4052083	2017-09-23	2017-09-23 00:00:00	2017-09-23	5001	0	\N	0	0	\N	\N	0	198583	0	23426006	4052083		
28884	2669	40758406	1979-01-02	1979-01-02 00:00:00	1979-01-02	5001	0	\N	0	0	\N	\N	0	176812	0	55277-8	40758406		
44703	4130	3006322	2017-10-15	2017-10-15 00:00:00	2017-10-15	5001	0	\N	0	0	\N	\N	0	274610	0	8331-1	3006322		
30612	2804	3006322	1982-01-05	1982-01-05 00:00:00	1982-01-05	5001	0	\N	0	0	\N	\N	0	185813	0	8331-1	3006322		
48904	4476	3027231	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	297806	0	6276-0	3027231		
28055	2577	3000876	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	170588	0	6082-2	3000876		
55397	5079	3006322	1985-01-20	1985-01-20 00:00:00	1985-01-20	5001	0	\N	0	0	\N	\N	0	337704	0	8331-1	3006322		
12022	1143	40758406	1972-06-26	1972-06-26 00:00:00	1972-06-26	5001	0	\N	0	0	\N	\N	0	75436	0	55277-8	40758406		
35447	3244	3012494	1991-05-02	1991-05-02 00:00:00	1991-05-02	5001	0	\N	0	0	\N	\N	0	215732	0	6206-7	3012494		
35867	3295	3051031	1952-07-07	1952-07-07 00:00:00	1952-07-07	5001	0	\N	0	0	\N	\N	0	218883	0	46240-8	3051031		
41332	3857	3011505	2003-08-05	2003-08-05 00:00:00	2003-08-05	5001	0	\N	0	0	\N	\N	0	255996	0	19926-5	3011505		
122720	3784	4133840	1984-07-31	1984-07-31 00:00:00	1984-07-31	5001	0	\N	0	0	\N	\N	0	251532	0	127783003	4133840		
47625	4373	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	290380	0	6085-5	3001247		
19480	1781	3049273	2011-12-06	2011-12-06 00:00:00	2011-12-06	5001	0	\N	0	0	\N	\N	0	119201	0	38265-5	3049273		
51583	4724	3000963	1941-05-07	1941-05-07 00:00:00	1941-05-07	5001	0	\N	0	0	\N	\N	0	314678	0	718-7	3000963		
51649	4725	3012494	1976-10-20	1976-10-20 00:00:00	1976-10-20	5001	0	\N	0	0	\N	\N	0	314867	0	6206-7	3012494		
15197	476	4052083	1977-05-28	1977-05-28 00:00:00	1977-05-28	5001	0	\N	0	0	\N	\N	0	31735	0	23426006	4052083		
40751	1264	4133840	2001-01-26	2001-01-26 00:00:00	2001-01-26	5001	0	\N	0	0	\N	\N	0	83289	0	127783003	4133840		
117476	3621	4133840	1988-10-22	1988-10-22 00:00:00	1988-10-22	5001	0	\N	0	0	\N	\N	0	240656	0	127783003	4133840		
54273	4963	3006322	2001-10-03	2001-10-03 00:00:00	2001-10-03	5001	0	\N	0	0	\N	\N	0	329888	0	8331-1	3006322		
54329	4970	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	330434	0	6106-9	3014599		
119069	3667	4024958	1998-10-22	1998-10-22 00:00:00	1998-10-22	5001	0	\N	0	0	\N	\N	0	243948	0	117015009	4024958		
21268	1967	3006322	1993-04-22	1993-04-22 00:00:00	1993-04-22	5001	0	\N	0	0	\N	\N	0	130832	0	8331-1	3006322		
32651	2959	3001247	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	197540	0	6085-5	3001247		
32663	2960	3006322	1961-12-30	1961-12-30 00:00:00	1961-12-30	5001	0	\N	0	0	\N	\N	0	197654	0	8331-1	3006322		
104453	3216	4052083	1963-10-22	1963-10-22 00:00:00	1963-10-22	5001	0	\N	0	0	\N	\N	0	213743	0	23426006	4052083		
13172	1259	3020655	1981-04-14	1981-04-14 00:00:00	1981-04-14	5001	0	\N	0	0	\N	\N	0	82942	0	6844-5	3020655		
86251	2666	4024958	1952-05-13	1952-05-13 00:00:00	1952-05-13	5001	0	\N	0	0	\N	\N	0	176621	0	117015009	4024958		
6443	603	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	40004	0	6082-2	3000876		
40196	1249	4052083	2017-07-03	2017-07-03 00:00:00	2017-07-03	5001	0	\N	0	0	\N	\N	0	82299	0	23426006	4052083		
40274	1253	4024958	1978-01-20	1978-01-20 00:00:00	1978-01-20	5001	0	\N	0	0	\N	\N	0	82507	0	117015009	4024958		
29230	2692	3051031	1949-03-16	1949-03-16 00:00:00	1949-03-16	5001	0	\N	0	0	\N	\N	0	178328	0	46240-8	3051031		
29290	2698	3006322	2011-03-21	2011-03-21 00:00:00	2011-03-21	5001	0	\N	0	0	\N	\N	0	178696	0	8331-1	3006322		
30543	949	4133840	1996-03-25	1996-03-25 00:00:00	1996-03-25	5001	0	\N	0	0	\N	\N	0	63038	0	127783003	4133840		
14380	1345	46235214	1992-08-05	1992-08-05 00:00:00	1992-08-05	5001	0	\N	0	0	\N	\N	0	89145	0	76690-7	46235214		
45002	4156	3051031	2001-04-10	2001-04-10 00:00:00	2001-04-10	5001	0	\N	0	0	\N	\N	0	276175	0	46240-8	3051031		
25799	2369	3001488	1997-11-09	1997-11-09 00:00:00	1997-11-09	5001	0	\N	0	0	\N	\N	0	157655	0	7258-7	3001488		
50640	1537	4052083	1977-11-04	1977-11-04 00:00:00	1977-11-04	5001	0	\N	0	0	\N	\N	0	102922	0	23426006	4052083		
37286	3438	3049273	1989-06-17	1989-06-17 00:00:00	1989-06-17	5001	0	\N	0	0	\N	\N	0	228104	0	38265-5	3049273		
55222	1674	4052083	2008-09-09	2008-09-09 00:00:00	2008-09-09	5001	0	\N	0	0	\N	\N	0	112392	0	23426006	4052083		
35332	1101	4133840	2009-07-05	2009-07-05 00:00:00	2009-07-05	5001	0	\N	0	0	\N	\N	0	72305	0	127783003	4133840		
166528	5116	4024958	1992-06-04	1992-06-04 00:00:00	1992-06-04	5001	0	\N	0	0	\N	\N	0	340001	0	117015009	4024958		
22611	2075	3006322	1968-08-18	1968-08-18 00:00:00	1968-08-18	5001	0	\N	0	0	\N	\N	0	138075	0	8331-1	3006322		
50768	4626	3006322	2006-07-09	2006-07-09 00:00:00	2006-07-09	5001	0	\N	0	0	\N	\N	0	308187	0	8331-1	3006322		
50821	4634	3006322	1989-06-30	1989-06-30 00:00:00	1989-06-30	5001	0	\N	0	0	\N	\N	0	308878	0	8331-1	3006322		
16179	1476	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	98395	0	6095-4	3036780		
45717	4217	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	279964	0	6273-7	3006451		
45814	4224	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	280467	0	6075-6	3005136		
27341	2537	3006734	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	167725	0	6189-5	3006734		
106867	3293	4024958	1917-08-19	1917-08-19 00:00:00	1917-08-19	5001	0	\N	0	0	\N	\N	0	218698	0	117015009	4024958		
24996	2294	3006322	1980-03-26	1980-03-26 00:00:00	1980-03-26	5001	0	\N	0	0	\N	\N	0	152702	0	8331-1	3006322		
159410	4899	4133840	1997-11-04	1997-11-04 00:00:00	1997-11-04	5001	0	\N	0	0	\N	\N	0	325833	0	127783003	4133840		
50535	4608	3006322	1981-03-01	1981-03-01 00:00:00	1981-03-01	5001	0	\N	0	0	\N	\N	0	307074	0	8331-1	3006322		
36506	3353	3049273	1995-11-25	1995-11-25 00:00:00	1995-11-25	5001	0	\N	0	0	\N	\N	0	222384	0	38265-5	3049273		
95206	2921	4133840	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	194767	0	127783003	4133840		
4191	411	3006322	1963-11-28	1963-11-28 00:00:00	1963-11-28	5001	0	\N	0	0	\N	\N	0	27364	0	8331-1	3006322		
5193	499	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	33423	0	6273-7	3006451		
8680	841	40769179	1955-07-10	1955-07-10 00:00:00	1955-07-10	5001	0	\N	0	0	\N	\N	0	55548	0	66519-0	40769179		
108595	3353	4024958	1939-03-18	1939-03-18 00:00:00	1939-03-18	5001	0	\N	0	0	\N	\N	0	222354	0	117015009	4024958		
20107	1844	40758406	1989-08-22	1989-08-22 00:00:00	1989-08-22	5001	0	\N	0	0	\N	\N	0	123139	0	55277-8	40758406		
31835	2906	3006322	1924-06-13	1924-06-13 00:00:00	1924-06-13	5001	0	\N	0	0	\N	\N	0	193665	0	8331-1	3006322		
49376	4506	3051031	2012-03-24	2012-03-24 00:00:00	2012-03-24	5001	0	\N	0	0	\N	\N	0	300181	0	46240-8	3051031		
14585	1356	3006451	1995-02-23	1995-02-23 00:00:00	1995-02-23	5001	0	\N	0	0	\N	\N	0	89888	0	6273-7	3006451		
14648	1359	3006322	1993-07-28	1993-07-28 00:00:00	1993-07-28	5001	0	\N	0	0	\N	\N	0	90182	0	8331-1	3006322		
97258	2975	4052083	1984-11-03	1984-11-03 00:00:00	1984-11-03	5001	0	\N	0	0	\N	\N	0	198623	0	23426006	4052083		
28885	2669	46235214	1979-01-02	1979-01-02 00:00:00	1979-01-02	5001	0	\N	0	0	\N	\N	0	176812	0	76690-7	46235214		
44704	4130	40766240	1995-03-12	1995-03-12 00:00:00	1995-03-12	5001	0	\N	0	0	\N	\N	0	274643	0	63513-6	40766240		
30613	2804	3006322	1975-09-28	1975-09-28 00:00:00	1975-09-28	5001	0	\N	0	0	\N	\N	0	185814	0	8331-1	3006322		
48905	4476	3012494	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	297806	0	6206-7	3012494		
28056	2577	3019406	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	170588	0	6158-0	3019406		
55398	5079	3006322	1991-12-28	1991-12-28 00:00:00	1991-12-28	5001	0	\N	0	0	\N	\N	0	337689	0	8331-1	3006322		
12023	1143	3051031	1972-06-26	1972-06-26 00:00:00	1972-06-26	5001	0	\N	0	0	\N	\N	0	75436	0	46240-8	3051031		
35448	3244	3001247	1991-05-02	1991-05-02 00:00:00	1991-05-02	5001	0	\N	0	0	\N	\N	0	215732	0	6085-5	3001247		
35868	3295	40758406	1952-07-07	1952-07-07 00:00:00	1952-07-07	5001	0	\N	0	0	\N	\N	0	218883	0	55277-8	40758406		
41333	3857	3011505	1988-01-05	1988-01-05 00:00:00	1988-01-05	5001	0	\N	0	0	\N	\N	0	256017	0	19926-5	3011505		
122724	3784	4133840	1989-08-01	1989-08-01 00:00:00	1989-08-01	5001	0	\N	0	0	\N	\N	0	251462	0	127783003	4133840		
47626	4373	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	290380	0	6082-2	3000876		
19481	1781	3000963	2000-05-26	2000-05-26 00:00:00	2000-05-26	5001	0	\N	0	0	\N	\N	0	119260	0	718-7	3000963		
51584	4724	3049273	2008-12-16	2008-12-16 00:00:00	2008-12-16	5001	0	\N	0	0	\N	\N	0	314861	0	38265-5	3049273		
51650	4725	3000876	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	314890	0	6082-2	3000876		
26493	829	4024958	1987-04-23	1987-04-23 00:00:00	1987-04-23	5001	0	\N	0	0	\N	\N	0	54926	0	117015009	4024958		
40752	1264	4133840	2002-02-15	2002-02-15 00:00:00	2002-02-15	5001	0	\N	0	0	\N	\N	0	83284	0	127783003	4133840		
117483	3621	4133840	1969-07-12	1969-07-12 00:00:00	1969-07-12	5001	0	\N	0	0	\N	\N	0	240650	0	127783003	4133840		
54274	4963	3006322	1973-12-13	1973-12-13 00:00:00	1973-12-13	5001	0	\N	0	0	\N	\N	0	329942	0	8331-1	3006322		
54330	4970	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	330434	0	6273-7	3006451		
119070	3668	4052083	2000-08-30	2000-08-30 00:00:00	2000-08-30	5001	0	\N	0	0	\N	\N	0	244006	0	23426006	4052083		
21269	1967	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	130834	0	6095-4	3036780		
91697	2829	4024958	1979-05-17	1979-05-17 00:00:00	1979-05-17	5001	0	\N	0	0	\N	\N	0	187663	0	117015009	4024958		
32664	2960	3006322	1976-06-20	1976-06-20 00:00:00	1976-06-20	5001	0	\N	0	0	\N	\N	0	197613	0	8331-1	3006322		
104464	3216	4024958	1994-11-20	1994-11-20 00:00:00	1994-11-20	5001	0	\N	0	0	\N	\N	0	213732	0	117015009	4024958		
13173	1259	3023430	1981-04-14	1981-04-14 00:00:00	1981-04-14	5001	0	\N	0	0	\N	\N	0	82942	0	6833-8	3023430		
86255	2666	4024958	1975-07-20	1975-07-20 00:00:00	1975-07-20	5001	0	\N	0	0	\N	\N	0	176660	0	117015009	4024958		
6444	603	3006322	1978-01-15	1978-01-15 00:00:00	1978-01-15	5001	0	\N	0	0	\N	\N	0	39941	0	8331-1	3006322		
40203	1250	4024958	1958-12-08	1958-12-08 00:00:00	1958-12-08	5001	0	\N	0	0	\N	\N	0	82327	0	117015009	4024958		
51553	1563	4024958	1961-05-14	1961-05-14 00:00:00	1961-05-14	5001	0	\N	0	0	\N	\N	0	104696	0	117015009	4024958		
29231	2692	46235214	1949-03-16	1949-03-16 00:00:00	1949-03-16	5001	0	\N	0	0	\N	\N	0	178328	0	76690-7	46235214		
29291	2698	3006322	1994-04-12	1994-04-12 00:00:00	1994-04-12	5001	0	\N	0	0	\N	\N	0	178670	0	8331-1	3006322		
30544	949	4133840	2019-05-20	2019-05-20 00:00:00	2019-05-20	5001	0	\N	0	0	\N	\N	0	63020	0	127783003	4133840		
14383	1345	40766240	1992-08-05	1992-08-05 00:00:00	1992-08-05	5001	0	\N	0	0	\N	\N	0	89145	0	63513-6	40766240		
45005	4156	46235214	2001-04-10	2001-04-10 00:00:00	2001-04-10	5001	0	\N	0	0	\N	\N	0	276175	0	76690-7	46235214		
25800	2369	3006734	1997-11-09	1997-11-09 00:00:00	1997-11-09	5001	0	\N	0	0	\N	\N	0	157655	0	6189-5	3006734		
144794	4446	4024958	1970-11-17	1970-11-17 00:00:00	1970-11-17	5001	0	\N	0	0	\N	\N	0	295649	0	117015009	4024958		
37289	3438	3006322	1957-11-20	1957-11-20 00:00:00	1957-11-20	5001	0	\N	0	0	\N	\N	0	228095	0	8331-1	3006322		
55224	1674	4024958	2003-04-10	2003-04-10 00:00:00	2003-04-10	5001	0	\N	0	0	\N	\N	0	112378	0	117015009	4024958		
35334	1101	4133840	2014-08-24	2014-08-24 00:00:00	2014-08-24	5001	0	\N	0	0	\N	\N	0	72314	0	127783003	4133840		
166568	5117	4024958	1983-08-17	1983-08-17 00:00:00	1983-08-17	5001	0	\N	0	0	\N	\N	0	340095	0	117015009	4024958		
22612	2075	3001247	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	138131	0	6085-5	3001247		
50769	4628	3006322	1969-07-27	1969-07-27 00:00:00	1969-07-27	5001	0	\N	0	0	\N	\N	0	308308	0	8331-1	3006322		
50822	4634	3006322	1975-10-15	1975-10-15 00:00:00	1975-10-15	5001	0	\N	0	0	\N	\N	0	308830	0	8331-1	3006322		
16180	1476	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	98395	0	6189-5	3006734		
45718	4217	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	279964	0	6276-0	3027231		
45815	4224	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	280467	0	6206-7	3012494		
27342	2537	3036780	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	167725	0	6095-4	3036780		
106873	3293	4024958	1958-05-22	1958-05-22 00:00:00	1958-05-22	5001	0	\N	0	0	\N	\N	0	218702	0	117015009	4024958		
24997	2294	3006322	1980-12-01	1980-12-01 00:00:00	1980-12-01	5001	0	\N	0	0	\N	\N	0	152716	0	8331-1	3006322		
159413	4899	4133840	1988-09-13	1988-09-13 00:00:00	1988-09-13	5001	0	\N	0	0	\N	\N	0	325849	0	127783003	4133840		
50536	4608	3011505	1998-12-31	1998-12-31 00:00:00	1998-12-31	5001	0	\N	0	0	\N	\N	0	307058	0	19926-5	3011505		
36507	3353	3006322	1939-03-18	1939-03-18 00:00:00	1939-03-18	5001	0	\N	0	0	\N	\N	0	222354	0	8331-1	3006322		
95209	2921	4133840	1980-06-24	1980-06-24 00:00:00	1980-06-24	5001	0	\N	0	0	\N	\N	0	194756	0	127783003	4133840		
4192	411	3006322	1989-08-30	1989-08-30 00:00:00	1989-08-30	5001	0	\N	0	0	\N	\N	0	27311	0	8331-1	3006322		
5194	499	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	33423	0	6106-9	3014599		
8681	841	40769189	1955-07-10	1955-07-10 00:00:00	1955-07-10	5001	0	\N	0	0	\N	\N	0	55548	0	66529-9	40769189		
108603	3353	4024958	1979-04-14	1979-04-14 00:00:00	1979-04-14	5001	0	\N	0	0	\N	\N	0	222335	0	117015009	4024958		
20109	1844	3051031	1986-06-29	1986-06-29 00:00:00	1986-06-29	5001	0	\N	0	0	\N	\N	0	123135	0	46240-8	3051031		
31836	2906	3006322	2009-03-26	2009-03-26 00:00:00	2009-03-26	5001	0	\N	0	0	\N	\N	0	193637	0	8331-1	3006322		
49378	4506	40766240	2012-03-24	2012-03-24 00:00:00	2012-03-24	5001	0	\N	0	0	\N	\N	0	300181	0	63513-6	40766240		
14586	1356	3006734	1995-02-23	1995-02-23 00:00:00	1995-02-23	5001	0	\N	0	0	\N	\N	0	89888	0	6189-5	3006734		
14650	1359	3006322	1998-02-12	1998-02-12 00:00:00	1998-02-12	5001	0	\N	0	0	\N	\N	0	90156	0	8331-1	3006322		
97262	2975	4052083	1997-08-06	1997-08-06 00:00:00	1997-08-06	5001	0	\N	0	0	\N	\N	0	198691	0	23426006	4052083		
28887	2669	40766240	1979-01-02	1979-01-02 00:00:00	1979-01-02	5001	0	\N	0	0	\N	\N	0	176812	0	63513-6	40766240		
44706	4130	3051031	1995-03-12	1995-03-12 00:00:00	1995-03-12	5001	0	\N	0	0	\N	\N	0	274643	0	46240-8	3051031		
30614	2804	3006322	1997-08-14	1997-08-14 00:00:00	1997-08-14	5001	0	\N	0	0	\N	\N	0	185826	0	8331-1	3006322		
48906	4476	3006734	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	297806	0	6189-5	3006734		
28057	2577	3015076	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	170588	0	6248-9	3015076		
55399	5079	3006322	2002-12-15	2002-12-15 00:00:00	2002-12-15	5001	0	\N	0	0	\N	\N	0	337715	0	8331-1	3006322		
12025	1143	46235214	1972-06-26	1972-06-26 00:00:00	1972-06-26	5001	0	\N	0	0	\N	\N	0	75436	0	76690-7	46235214		
35449	3244	3015076	1991-05-02	1991-05-02 00:00:00	1991-05-02	5001	0	\N	0	0	\N	\N	0	215732	0	6248-9	3015076		
35869	3295	46235214	1952-07-07	1952-07-07 00:00:00	1952-07-07	5001	0	\N	0	0	\N	\N	0	218883	0	76690-7	46235214		
41334	3857	3006322	1992-05-04	1992-05-04 00:00:00	1992-05-04	5001	0	\N	0	0	\N	\N	0	255952	0	8331-1	3006322		
122728	3784	4133840	1988-07-26	1988-07-26 00:00:00	1988-07-26	5001	0	\N	0	0	\N	\N	0	251533	0	127783003	4133840		
47627	4373	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	290380	0	7258-7	3001488		
19482	1781	3009542	2000-05-26	2000-05-26 00:00:00	2000-05-26	5001	0	\N	0	0	\N	\N	0	119260	0	20570-8	3009542		
51585	4724	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	314724	0	7258-7	3001488		
51651	4725	3001247	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	314890	0	6085-5	3001247		
26499	829	4024958	2006-09-13	2006-09-13 00:00:00	2006-09-13	5001	0	\N	0	0	\N	\N	0	54929	0	117015009	4024958		
126740	3901	4052083	1990-06-10	1990-06-10 00:00:00	1990-06-10	5001	0	\N	0	0	\N	\N	0	259405	0	23426006	4052083		
117486	3621	4133840	1995-06-03	1995-06-03 00:00:00	1995-06-03	5001	0	\N	0	0	\N	\N	0	240598	0	127783003	4133840		
54275	4963	3006322	1994-10-27	1994-10-27 00:00:00	1994-10-27	5001	0	\N	0	0	\N	\N	0	329938	0	8331-1	3006322		
54331	4970	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	330434	0	6276-0	3027231		
119087	3668	4024958	1997-10-06	1997-10-06 00:00:00	1997-10-06	5001	0	\N	0	0	\N	\N	0	244011	0	117015009	4024958		
21270	1967	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	130834	0	6189-5	3006734		
91703	2829	4052083	1992-10-18	1992-10-18 00:00:00	1992-10-18	5001	0	\N	0	0	\N	\N	0	187634	0	23426006	4052083		
32665	2960	3006322	1999-08-28	1999-08-28 00:00:00	1999-08-28	5001	0	\N	0	0	\N	\N	0	197666	0	8331-1	3006322		
49922	4538	3006322	1981-07-12	1981-07-12 00:00:00	1981-07-12	5001	0	\N	0	0	\N	\N	0	302334	0	8331-1	3006322		
13174	1259	3012494	1981-04-14	1981-04-14 00:00:00	1981-04-14	5001	0	\N	0	0	\N	\N	0	82942	0	6206-7	3012494		
97561	2985	4052083	1982-11-28	1982-11-28 00:00:00	1982-11-28	5001	0	\N	0	0	\N	\N	0	199230	0	23426006	4052083		
23331	729	4052083	1974-01-25	1974-01-25 00:00:00	1974-01-25	5001	0	\N	0	0	\N	\N	0	48368	0	23426006	4052083		
40205	1250	4052083	1970-10-03	1970-10-03 00:00:00	1970-10-03	5001	0	\N	0	0	\N	\N	0	82384	0	23426006	4052083		
51556	1563	4024958	1983-06-28	1983-06-28 00:00:00	1983-06-28	5001	0	\N	0	0	\N	\N	0	104706	0	117015009	4024958		
29233	2692	40766240	1949-03-16	1949-03-16 00:00:00	1949-03-16	5001	0	\N	0	0	\N	\N	0	178328	0	63513-6	40766240		
29292	2699	3006322	2011-09-25	2011-09-25 00:00:00	2011-09-25	5001	0	\N	0	0	\N	\N	0	178702	0	8331-1	3006322		
30546	949	4133840	2007-10-29	2007-10-29 00:00:00	2007-10-29	5001	0	\N	0	0	\N	\N	0	63040	0	127783003	4133840		
14384	1345	40758406	1992-08-05	1992-08-05 00:00:00	1992-08-05	5001	0	\N	0	0	\N	\N	0	89145	0	55277-8	40758406		
45006	4156	40758406	2001-04-10	2001-04-10 00:00:00	2001-04-10	5001	0	\N	0	0	\N	\N	0	276175	0	55277-8	40758406		
25801	2369	3036780	1997-11-09	1997-11-09 00:00:00	1997-11-09	5001	0	\N	0	0	\N	\N	0	157655	0	6095-4	3036780		
144799	4446	4024958	1975-05-25	1975-05-25 00:00:00	1975-05-25	5001	0	\N	0	0	\N	\N	0	295641	0	117015009	4024958		
37290	3439	3006322	1983-06-06	1983-06-06 00:00:00	1983-06-06	5001	0	\N	0	0	\N	\N	0	228143	0	8331-1	3006322		
55228	1674	4052083	2013-11-01	2013-11-01 00:00:00	2013-11-01	5001	0	\N	0	0	\N	\N	0	112393	0	23426006	4052083		
35344	1101	4133840	2012-07-08	2012-07-08 00:00:00	2012-07-08	5001	0	\N	0	0	\N	\N	0	72306	0	127783003	4133840		
66606	2044	4052083	1967-03-19	1967-03-19 00:00:00	1967-03-19	5001	0	\N	0	0	\N	\N	0	136027	0	23426006	4052083		
22613	2075	3023430	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	138131	0	6833-8	3023430		
50770	4628	3006322	1979-12-16	1979-12-16 00:00:00	1979-12-16	5001	0	\N	0	0	\N	\N	0	308354	0	8331-1	3006322		
50823	4634	3006322	1980-11-17	1980-11-17 00:00:00	1980-11-17	5001	0	\N	0	0	\N	\N	0	308831	0	8331-1	3006322		
16181	1476	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	98395	0	6833-8	3023430		
45719	4217	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	279964	0	6189-5	3006734		
45816	4224	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	280467	0	6106-9	3014599		
27343	2537	3020655	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	167725	0	6844-5	3020655		
106874	3293	4024958	1921-09-23	1921-09-23 00:00:00	1921-09-23	5001	0	\N	0	0	\N	\N	0	218658	0	117015009	4024958		
24998	2294	3006322	1972-01-28	1972-01-28 00:00:00	1972-01-28	5001	0	\N	0	0	\N	\N	0	152660	0	8331-1	3006322		
159414	4899	4024958	1994-07-22	1994-07-22 00:00:00	1994-07-22	5001	0	\N	0	0	\N	\N	0	325778	0	117015009	4024958		
50537	4608	3011505	2009-01-08	2009-01-08 00:00:00	2009-01-08	5001	0	\N	0	0	\N	\N	0	307019	0	19926-5	3011505		
36508	3353	3006322	2012-07-03	2012-07-03 00:00:00	2012-07-03	5001	0	\N	0	0	\N	\N	0	222392	0	8331-1	3006322		
95211	2921	4133840	1982-06-29	1982-06-29 00:00:00	1982-06-29	5001	0	\N	0	0	\N	\N	0	194785	0	127783003	4133840		
4193	411	3006322	1982-03-01	1982-03-01 00:00:00	1982-03-01	5001	0	\N	0	0	\N	\N	0	27270	0	8331-1	3006322		
5195	499	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	33423	0	6075-6	3005136		
8682	842	3011505	2004-08-21	2004-08-21 00:00:00	2004-08-21	5001	0	\N	0	0	\N	\N	0	55682	0	19926-5	3011505		
108616	3355	4024958	1997-10-07	1997-10-07 00:00:00	1997-10-07	5001	0	\N	0	0	\N	\N	0	222495	0	117015009	4024958		
20111	1844	46235214	1986-06-29	1986-06-29 00:00:00	1986-06-29	5001	0	\N	0	0	\N	\N	0	123135	0	76690-7	46235214		
31837	2906	3006322	1931-12-20	1931-12-20 00:00:00	1931-12-20	5001	0	\N	0	0	\N	\N	0	193614	0	8331-1	3006322		
49379	4506	40758406	2012-03-24	2012-03-24 00:00:00	2012-03-24	5001	0	\N	0	0	\N	\N	0	300181	0	55277-8	40758406		
14587	1356	3014599	1995-02-23	1995-02-23 00:00:00	1995-02-23	5001	0	\N	0	0	\N	\N	0	89888	0	6106-9	3014599		
14651	1359	3006322	1941-07-26	1941-07-26 00:00:00	1941-07-26	5001	0	\N	0	0	\N	\N	0	90192	0	8331-1	3006322		
97282	2976	4052083	2011-05-06	2011-05-06 00:00:00	2011-05-06	5001	0	\N	0	0	\N	\N	0	198736	0	23426006	4052083		
28889	2669	3051031	1979-01-02	1979-01-02 00:00:00	1979-01-02	5001	0	\N	0	0	\N	\N	0	176812	0	46240-8	3051031		
44708	4130	46235214	1995-03-12	1995-03-12 00:00:00	1995-03-12	5001	0	\N	0	0	\N	\N	0	274643	0	76690-7	46235214		
30615	2804	3006322	1975-07-22	1975-07-22 00:00:00	1975-07-22	5001	0	\N	0	0	\N	\N	0	185812	0	8331-1	3006322		
48907	4476	3000876	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	297806	0	6082-2	3000876		
28058	2577	3006322	1975-07-03	1975-07-03 00:00:00	1975-07-03	5001	0	\N	0	0	\N	\N	0	170613	0	8331-1	3006322		
55403	5081	3006322	1957-11-30	1957-11-30 00:00:00	1957-11-30	5001	0	\N	0	0	\N	\N	0	337907	0	8331-1	3006322		
12027	1143	40766240	1972-06-26	1972-06-26 00:00:00	1972-06-26	5001	0	\N	0	0	\N	\N	0	75436	0	63513-6	40766240		
35450	3244	3000876	1991-05-02	1991-05-02 00:00:00	1991-05-02	5001	0	\N	0	0	\N	\N	0	215732	0	6082-2	3000876		
35872	3295	40766240	1952-07-07	1952-07-07 00:00:00	1952-07-07	5001	0	\N	0	0	\N	\N	0	218883	0	63513-6	40766240		
41335	3857	3011505	1994-01-04	1994-01-04 00:00:00	1994-01-04	5001	0	\N	0	0	\N	\N	0	256018	0	19926-5	3011505		
122729	3784	4133840	1983-07-26	1983-07-26 00:00:00	1983-07-26	5001	0	\N	0	0	\N	\N	0	251459	0	127783003	4133840		
47628	4373	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	290380	0	6106-9	3014599		
19483	1781	3006322	1961-11-03	1961-11-03 00:00:00	1961-11-03	5001	0	\N	0	0	\N	\N	0	119256	0	8331-1	3006322		
51586	4724	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	314724	0	6833-8	3023430		
51652	4725	3001488	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	314890	0	7258-7	3001488		
26502	829	4052083	1977-01-28	1977-01-28 00:00:00	1977-01-28	5001	0	\N	0	0	\N	\N	0	54923	0	23426006	4052083		
126746	3901	4052083	1942-11-14	1942-11-14 00:00:00	1942-11-14	5001	0	\N	0	0	\N	\N	0	259425	0	23426006	4052083		
117488	3621	4133840	1973-07-28	1973-07-28 00:00:00	1973-07-28	5001	0	\N	0	0	\N	\N	0	240652	0	127783003	4133840		
54276	4963	3006322	1986-08-26	1986-08-26 00:00:00	1986-08-26	5001	0	\N	0	0	\N	\N	0	329867	0	8331-1	3006322		
54332	4970	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	330434	0	6833-8	3023430		
119088	3668	4024958	1989-09-19	1989-09-19 00:00:00	1989-09-19	5001	0	\N	0	0	\N	\N	0	244034	0	117015009	4024958		
21271	1967	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	130747	0	6082-2	3000876		
91705	2829	4024958	1989-01-08	1989-01-08 00:00:00	1989-01-08	5001	0	\N	0	0	\N	\N	0	187660	0	117015009	4024958		
32666	2960	3006322	1956-01-11	1956-01-11 00:00:00	1956-01-11	5001	0	\N	0	0	\N	\N	0	197661	0	8331-1	3006322		
49923	4538	3049273	2011-10-29	2011-10-29 00:00:00	2011-10-29	5001	0	\N	0	0	\N	\N	0	302317	0	38265-5	3049273		
13175	1259	3036780	1981-04-14	1981-04-14 00:00:00	1981-04-14	5001	0	\N	0	0	\N	\N	0	82942	0	6095-4	3036780		
97566	2985	4024958	1968-06-26	1968-06-26 00:00:00	1968-06-26	5001	0	\N	0	0	\N	\N	0	199236	0	117015009	4024958		
23336	730	4052083	1966-04-17	1966-04-17 00:00:00	1966-04-17	5001	0	\N	0	0	\N	\N	0	48456	0	23426006	4052083		
40209	1250	4024958	1954-10-15	1954-10-15 00:00:00	1954-10-15	5001	0	\N	0	0	\N	\N	0	82393	0	117015009	4024958		
51562	1563	4052083	1998-02-03	1998-02-03 00:00:00	1998-02-03	5001	0	\N	0	0	\N	\N	0	104715	0	23426006	4052083		
29234	2693	3006322	1959-01-14	1959-01-14 00:00:00	1959-01-14	5001	0	\N	0	0	\N	\N	0	178420	0	8331-1	3006322		
29293	2699	3006322	2007-01-08	2007-01-08 00:00:00	2007-01-08	5001	0	\N	0	0	\N	\N	0	178720	0	8331-1	3006322		
30549	949	4133840	1989-09-04	1989-09-04 00:00:00	1989-09-04	5001	0	\N	0	0	\N	\N	0	63035	0	127783003	4133840		
14385	1345	3051031	1992-05-07	1992-05-07 00:00:00	1992-05-07	5001	0	\N	0	0	\N	\N	0	89144	0	46240-8	3051031		
45007	4156	40766240	2001-04-10	2001-04-10 00:00:00	2001-04-10	5001	0	\N	0	0	\N	\N	0	276175	0	63513-6	40766240		
25802	2369	3020655	1997-11-09	1997-11-09 00:00:00	1997-11-09	5001	0	\N	0	0	\N	\N	0	157655	0	6844-5	3020655		
144801	4446	4024958	1993-08-28	1993-08-28 00:00:00	1993-08-28	5001	0	\N	0	0	\N	\N	0	295636	0	117015009	4024958		
125429	3871	4052083	1963-09-08	1963-09-08 00:00:00	1963-09-08	5001	0	\N	0	0	\N	\N	0	257006	0	23426006	4052083		
55232	1674	4024958	2006-01-07	2006-01-07 00:00:00	2006-01-07	5001	0	\N	0	0	\N	\N	0	112379	0	117015009	4024958		
35346	1101	4133840	2000-06-25	2000-06-25 00:00:00	2000-06-25	5001	0	\N	0	0	\N	\N	0	72323	0	127783003	4133840		
66636	2046	4024958	1991-04-27	1991-04-27 00:00:00	1991-04-27	5001	0	\N	0	0	\N	\N	0	136182	0	117015009	4024958		
22614	2075	3020655	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	138131	0	6844-5	3020655		
50771	4628	3006322	1981-06-20	1981-06-20 00:00:00	1981-06-20	5001	0	\N	0	0	\N	\N	0	308367	0	8331-1	3006322		
50824	4634	3006322	2006-02-12	2006-02-12 00:00:00	2006-02-12	5001	0	\N	0	0	\N	\N	0	308880	0	8331-1	3006322		
16182	1476	3006322	2002-11-07	2002-11-07 00:00:00	2002-11-07	5001	0	\N	0	0	\N	\N	0	98419	0	8331-1	3006322		
104922	3231	4052083	1954-07-12	1954-07-12 00:00:00	1954-07-12	5001	0	\N	0	0	\N	\N	0	214769	0	23426006	4052083		
45817	4224	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	280467	0	6082-2	3000876		
27344	2537	3019406	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	167725	0	6158-0	3019406		
106879	3294	4024958	1993-09-29	1993-09-29 00:00:00	1993-09-29	5001	0	\N	0	0	\N	\N	0	218832	0	117015009	4024958		
24999	2294	3006322	1998-12-22	1998-12-22 00:00:00	1998-12-22	5001	0	\N	0	0	\N	\N	0	152681	0	8331-1	3006322		
159415	4899	4133840	1993-10-12	1993-10-12 00:00:00	1993-10-12	5001	0	\N	0	0	\N	\N	0	325831	0	127783003	4133840		
50538	4608	3011505	2016-02-18	2016-02-18 00:00:00	2016-02-18	5001	0	\N	0	0	\N	\N	0	307092	0	19926-5	3011505		
36509	3353	3006322	1983-01-04	1983-01-04 00:00:00	1983-01-04	5001	0	\N	0	0	\N	\N	0	222357	0	8331-1	3006322		
95212	2921	4133840	1995-07-18	1995-07-18 00:00:00	1995-07-18	5001	0	\N	0	0	\N	\N	0	194740	0	127783003	4133840		
4195	412	3006322	1999-11-20	1999-11-20 00:00:00	1999-11-20	5001	0	\N	0	0	\N	\N	0	27465	0	8331-1	3006322		
5196	499	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	33423	0	7258-7	3001488		
8683	842	3011505	1950-12-16	1950-12-16 00:00:00	1950-12-16	5001	0	\N	0	0	\N	\N	0	55741	0	19926-5	3011505		
108622	3355	4024958	1969-06-16	1969-06-16 00:00:00	1969-06-16	5001	0	\N	0	0	\N	\N	0	222493	0	117015009	4024958		
20112	1844	40758406	1986-06-29	1986-06-29 00:00:00	1986-06-29	5001	0	\N	0	0	\N	\N	0	123135	0	55277-8	40758406		
31838	2906	3006322	2004-06-10	2004-06-10 00:00:00	2004-06-10	5001	0	\N	0	0	\N	\N	0	193625	0	8331-1	3006322		
49381	4506	46235214	2012-03-24	2012-03-24 00:00:00	2012-03-24	5001	0	\N	0	0	\N	\N	0	300181	0	76690-7	46235214		
5275	159	4024958	1990-06-29	1990-06-29 00:00:00	1990-06-29	5001	0	\N	0	0	\N	\N	0	10927	0	117015009	4024958		
14653	1359	3006322	1988-11-09	1988-11-09 00:00:00	1988-11-09	5001	0	\N	0	0	\N	\N	0	90195	0	8331-1	3006322		
97285	2976	4133840	1984-03-08	1984-03-08 00:00:00	1984-03-08	5001	0	\N	0	0	\N	\N	0	198771	0	127783003	4133840		
28890	2669	46235214	1978-04-07	1978-04-07 00:00:00	1978-04-07	5001	0	\N	0	0	\N	\N	0	176810	0	76690-7	46235214		
44709	4130	40758406	1995-03-12	1995-03-12 00:00:00	1995-03-12	5001	0	\N	0	0	\N	\N	0	274643	0	55277-8	40758406		
30616	2804	3006322	2010-05-28	2010-05-28 00:00:00	2010-05-28	5001	0	\N	0	0	\N	\N	0	185859	0	8331-1	3006322		
48908	4476	40769189	1962-05-30	1962-05-30 00:00:00	1962-05-30	5001	0	\N	0	0	\N	\N	0	297888	0	66529-9	40769189		
28059	2577	3006322	1976-12-19	1976-12-19 00:00:00	1976-12-19	5001	0	\N	0	0	\N	\N	0	170604	0	8331-1	3006322		
55404	5081	3006322	1982-04-29	1982-04-29 00:00:00	1982-04-29	5001	0	\N	0	0	\N	\N	0	337912	0	8331-1	3006322		
12028	1143	3006322	2004-01-05	2004-01-05 00:00:00	2004-01-05	5001	0	\N	0	0	\N	\N	0	75420	0	8331-1	3006322		
35451	3244	3020655	1991-05-02	1991-05-02 00:00:00	1991-05-02	5001	0	\N	0	0	\N	\N	0	215732	0	6844-5	3020655		
35873	3295	3006322	2003-06-03	2003-06-03 00:00:00	2003-06-03	5001	0	\N	0	0	\N	\N	0	218930	0	8331-1	3006322		
41336	3857	3011505	1998-07-07	1998-07-07 00:00:00	1998-07-07	5001	0	\N	0	0	\N	\N	0	256020	0	19926-5	3011505		
122731	3784	4133840	1992-08-18	1992-08-18 00:00:00	1992-08-18	5001	0	\N	0	0	\N	\N	0	251535	0	127783003	4133840		
47629	4373	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	290380	0	6189-5	3006734		
19484	1781	3006322	1962-03-16	1962-03-16 00:00:00	1962-03-16	5001	0	\N	0	0	\N	\N	0	119198	0	8331-1	3006322		
51587	4724	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	314724	0	6095-4	3036780		
51653	4725	3021226	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	314890	0	6246-3	3021226		
26509	830	4024958	1967-06-13	1967-06-13 00:00:00	1967-06-13	5001	0	\N	0	0	\N	\N	0	54978	0	117015009	4024958		
126748	3901	4052083	2010-04-28	2010-04-28 00:00:00	2010-04-28	5001	0	\N	0	0	\N	\N	0	259407	0	23426006	4052083		
117489	3621	4133840	1989-10-28	1989-10-28 00:00:00	1989-10-28	5001	0	\N	0	0	\N	\N	0	240596	0	127783003	4133840		
54277	4963	3006322	1982-08-25	1982-08-25 00:00:00	1982-08-25	5001	0	\N	0	0	\N	\N	0	329963	0	8331-1	3006322		
54334	4970	3006322	1952-03-02	1952-03-02 00:00:00	1952-03-02	5001	0	\N	0	0	\N	\N	0	330492	0	8331-1	3006322		
6466	608	3006322	1977-10-03	1977-10-03 00:00:00	1977-10-03	5001	0	\N	0	0	\N	\N	0	40412	0	8331-1	3006322		
21272	1967	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	130747	0	6206-7	3012494		
91708	2829	4024958	1961-05-12	1961-05-12 00:00:00	1961-05-12	5001	0	\N	0	0	\N	\N	0	187632	0	117015009	4024958		
32667	2960	3006322	2011-02-25	2011-02-25 00:00:00	2011-02-25	5001	0	\N	0	0	\N	\N	0	197621	0	8331-1	3006322		
49924	4538	3006322	2013-04-22	2013-04-22 00:00:00	2013-04-22	5001	0	\N	0	0	\N	\N	0	302393	0	8331-1	3006322		
13176	1259	3027231	1981-04-14	1981-04-14 00:00:00	1981-04-14	5001	0	\N	0	0	\N	\N	0	82942	0	6276-0	3027231		
97584	2985	4024958	1996-07-08	1996-07-08 00:00:00	1996-07-08	5001	0	\N	0	0	\N	\N	0	199251	0	117015009	4024958		
23338	730	4052083	2013-08-10	2013-08-10 00:00:00	2013-08-10	5001	0	\N	0	0	\N	\N	0	48494	0	23426006	4052083		
40210	1250	4052083	2002-12-02	2002-12-02 00:00:00	2002-12-02	5001	0	\N	0	0	\N	\N	0	82376	0	23426006	4052083		
51569	1563	4024958	2002-10-24	2002-10-24 00:00:00	2002-10-24	5001	0	\N	0	0	\N	\N	0	104678	0	117015009	4024958		
29235	2693	40766240	2013-12-29	2013-12-29 00:00:00	2013-12-29	5001	0	\N	0	0	\N	\N	0	178370	0	63513-6	40766240		
46211	1409	4052083	1997-11-17	1997-11-17 00:00:00	1997-11-17	5001	0	\N	0	0	\N	\N	0	93716	0	23426006	4052083		
30550	949	4133840	2011-11-21	2011-11-21 00:00:00	2011-11-21	5001	0	\N	0	0	\N	\N	0	63042	0	127783003	4133840		
14386	1345	46235214	1992-05-07	1992-05-07 00:00:00	1992-05-07	5001	0	\N	0	0	\N	\N	0	89144	0	76690-7	46235214		
45017	4159	3006322	1977-01-09	1977-01-09 00:00:00	1977-01-09	5001	0	\N	0	0	\N	\N	0	276367	0	8331-1	3006322		
25803	2369	3000876	1982-01-16	1982-01-16 00:00:00	1982-01-16	5001	0	\N	0	0	\N	\N	0	157671	0	6082-2	3000876		
144804	4446	4052083	1964-12-06	1964-12-06 00:00:00	1964-12-06	5001	0	\N	0	0	\N	\N	0	295648	0	23426006	4052083		
125439	3871	4052083	1991-05-25	1991-05-25 00:00:00	1991-05-25	5001	0	\N	0	0	\N	\N	0	257063	0	23426006	4052083		
86066	2661	4052083	2015-11-02	2015-11-02 00:00:00	2015-11-02	5001	0	\N	0	0	\N	\N	0	176363	0	23426006	4052083		
35350	1101	4133840	2003-06-29	2003-06-29 00:00:00	2003-06-29	5001	0	\N	0	0	\N	\N	0	72303	0	127783003	4133840		
66648	2046	4052083	1961-04-01	1961-04-01 00:00:00	1961-04-01	5001	0	\N	0	0	\N	\N	0	136087	0	23426006	4052083		
22615	2075	3005136	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	138131	0	6075-6	3005136		
50772	4628	40769194	1986-10-08	1986-10-08 00:00:00	1986-10-08	5001	0	\N	0	0	\N	\N	0	308310	0	66534-9	40769194		
50825	4634	3006322	1976-09-17	1976-09-17 00:00:00	1976-09-17	5001	0	\N	0	0	\N	\N	0	308876	0	8331-1	3006322		
16183	1476	3006322	1959-10-28	1959-10-28 00:00:00	1959-10-28	5001	0	\N	0	0	\N	\N	0	98535	0	8331-1	3006322		
104923	3231	4024958	1983-03-11	1983-03-11 00:00:00	1983-03-11	5001	0	\N	0	0	\N	\N	0	214717	0	117015009	4024958		
45818	4224	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	280467	0	6276-0	3027231		
27345	2537	3015076	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	167725	0	6248-9	3015076		
2349	222	3006322	1974-03-09	1974-03-09 00:00:00	1974-03-09	5001	0	\N	0	0	\N	\N	0	14884	0	8331-1	3006322		
25000	2294	3006322	1990-10-08	1990-10-08 00:00:00	1990-10-08	5001	0	\N	0	0	\N	\N	0	152704	0	8331-1	3006322		
159420	4899	4133840	1991-10-01	1991-10-01 00:00:00	1991-10-01	5001	0	\N	0	0	\N	\N	0	325830	0	127783003	4133840		
50539	4608	3006322	1999-02-08	1999-02-08 00:00:00	1999-02-08	5001	0	\N	0	0	\N	\N	0	307042	0	8331-1	3006322		
36510	3355	3006322	1975-07-26	1975-07-26 00:00:00	1975-07-26	5001	0	\N	0	0	\N	\N	0	222480	0	8331-1	3006322		
95215	2921	4133840	1991-06-25	1991-06-25 00:00:00	1991-06-25	5001	0	\N	0	0	\N	\N	0	194766	0	127783003	4133840		
4196	412	3006322	1981-06-18	1981-06-18 00:00:00	1981-06-18	5001	0	\N	0	0	\N	\N	0	27463	0	8331-1	3006322		
5197	499	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	33423	0	6246-3	3021226		
8684	842	3011505	1964-10-10	1964-10-10 00:00:00	1964-10-10	5001	0	\N	0	0	\N	\N	0	55604	0	19926-5	3011505		
108627	3355	4024958	1978-06-24	1978-06-24 00:00:00	1978-06-24	5001	0	\N	0	0	\N	\N	0	222483	0	117015009	4024958		
20114	1844	40766240	1986-06-29	1986-06-29 00:00:00	1986-06-29	5001	0	\N	0	0	\N	\N	0	123135	0	63513-6	40766240		
7387	709	3006322	1967-11-09	1967-11-09 00:00:00	1967-11-09	5001	0	\N	0	0	\N	\N	0	46924	0	8331-1	3006322		
49383	4506	46235214	2012-08-21	2012-08-21 00:00:00	2012-08-21	5001	0	\N	0	0	\N	\N	0	300172	0	76690-7	46235214		
5281	160	4052083	2003-06-06	2003-06-06 00:00:00	2003-06-06	5001	0	\N	0	0	\N	\N	0	11004	0	23426006	4052083		
14654	1359	3006322	1961-06-02	1961-06-02 00:00:00	1961-06-02	5001	0	\N	0	0	\N	\N	0	90167	0	8331-1	3006322		
97287	2976	4133840	2018-08-09	2018-08-09 00:00:00	2018-08-09	5001	0	\N	0	0	\N	\N	0	198767	0	127783003	4133840		
28891	2669	40758406	1978-04-07	1978-04-07 00:00:00	1978-04-07	5001	0	\N	0	0	\N	\N	0	176810	0	55277-8	40758406		
44710	4130	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	274581	0	6106-9	3014599		
30617	2804	3006322	1999-06-14	1999-06-14 00:00:00	1999-06-14	5001	0	\N	0	0	\N	\N	0	185868	0	8331-1	3006322		
48909	4476	40769194	1962-05-30	1962-05-30 00:00:00	1962-05-30	5001	0	\N	0	0	\N	\N	0	297888	0	66534-9	40769194		
28060	2577	40769189	1973-09-22	1973-09-22 00:00:00	1973-09-22	5001	0	\N	0	0	\N	\N	0	170610	0	66529-9	40769189		
55405	5081	3006322	1972-05-26	1972-05-26 00:00:00	1972-05-26	5001	0	\N	0	0	\N	\N	0	337910	0	8331-1	3006322		
12029	1143	3006322	1978-06-20	1978-06-20 00:00:00	1978-06-20	5001	0	\N	0	0	\N	\N	0	75426	0	8331-1	3006322		
35452	3244	3001488	1991-05-02	1991-05-02 00:00:00	1991-05-02	5001	0	\N	0	0	\N	\N	0	215732	0	7258-7	3001488		
35874	3295	3006322	1981-11-04	1981-11-04 00:00:00	1981-11-04	5001	0	\N	0	0	\N	\N	0	218927	0	8331-1	3006322		
41337	3857	3011505	2018-07-31	2018-07-31 00:00:00	2018-07-31	5001	0	\N	0	0	\N	\N	0	256032	0	19926-5	3011505		
122733	3784	4133840	1987-07-21	1987-07-21 00:00:00	1987-07-21	5001	0	\N	0	0	\N	\N	0	251461	0	127783003	4133840		
47630	4373	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	290380	0	6276-0	3027231		
19485	1781	3006322	2014-05-12	2014-05-12 00:00:00	2014-05-12	5001	0	\N	0	0	\N	\N	0	119186	0	8331-1	3006322		
51588	4724	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	314724	0	6206-7	3012494		
51654	4725	3027231	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	314890	0	6276-0	3027231		
26511	830	4024958	1992-05-18	1992-05-18 00:00:00	1992-05-18	5001	0	\N	0	0	\N	\N	0	55009	0	117015009	4024958		
157047	4827	4052083	1982-05-20	1982-05-20 00:00:00	1982-05-20	5001	0	\N	0	0	\N	\N	0	321158	0	23426006	4052083		
117491	3621	4133840	1985-10-05	1985-10-05 00:00:00	1985-10-05	5001	0	\N	0	0	\N	\N	0	240594	0	127783003	4133840		
54278	4963	3006322	2017-08-03	2017-08-03 00:00:00	2017-08-03	5001	0	\N	0	0	\N	\N	0	329941	0	8331-1	3006322		
54335	4970	3006322	1962-03-02	1962-03-02 00:00:00	1962-03-02	5001	0	\N	0	0	\N	\N	0	330359	0	8331-1	3006322		
6467	608	3006322	1981-04-26	1981-04-26 00:00:00	1981-04-26	5001	0	\N	0	0	\N	\N	0	40378	0	8331-1	3006322		
21273	1967	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	130747	0	6158-0	3019406		
91713	2829	4024958	1963-03-12	1963-03-12 00:00:00	1963-03-12	5001	0	\N	0	0	\N	\N	0	187657	0	117015009	4024958		
32668	2960	40758406	1970-03-01	1970-03-01 00:00:00	1970-03-01	5001	0	\N	0	0	\N	\N	0	197663	0	55277-8	40758406		
49925	4538	3006322	1982-05-21	1982-05-21 00:00:00	1982-05-21	5001	0	\N	0	0	\N	\N	0	302333	0	8331-1	3006322		
13177	1259	3014599	1981-04-14	1981-04-14 00:00:00	1981-04-14	5001	0	\N	0	0	\N	\N	0	82942	0	6106-9	3014599		
97589	2986	4024958	1946-02-06	1946-02-06 00:00:00	1946-02-06	5001	0	\N	0	0	\N	\N	0	199327	0	117015009	4024958		
23355	730	4024958	1973-12-18	1973-12-18 00:00:00	1973-12-18	5001	0	\N	0	0	\N	\N	0	48457	0	117015009	4024958		
97685	2986	4133840	1995-10-17	1995-10-17 00:00:00	1995-10-17	5001	0	\N	0	0	\N	\N	0	199312	0	127783003	4133840		
109108	3370	4052083	2019-04-20	2019-04-20 00:00:00	2019-04-20	5001	0	\N	0	0	\N	\N	0	223509	0	23426006	4052083		
29238	2693	40758406	2013-12-29	2013-12-29 00:00:00	2013-12-29	5001	0	\N	0	0	\N	\N	0	178370	0	55277-8	40758406		
46221	1409	4024958	1993-05-27	1993-05-27 00:00:00	1993-05-27	5001	0	\N	0	0	\N	\N	0	93714	0	117015009	4024958		
30553	949	4133840	2013-12-02	2013-12-02 00:00:00	2013-12-02	5001	0	\N	0	0	\N	\N	0	63017	0	127783003	4133840		
14389	1345	40758406	1992-05-07	1992-05-07 00:00:00	1992-05-07	5001	0	\N	0	0	\N	\N	0	89144	0	55277-8	40758406		
45018	4159	3006322	1987-01-30	1987-01-30 00:00:00	1987-01-30	5001	0	\N	0	0	\N	\N	0	276368	0	8331-1	3006322		
25804	2369	3001488	1982-01-16	1982-01-16 00:00:00	1982-01-16	5001	0	\N	0	0	\N	\N	0	157671	0	7258-7	3001488		
165336	5077	4024958	1973-10-05	1973-10-05 00:00:00	1973-10-05	5001	0	\N	0	0	\N	\N	0	337435	0	117015009	4024958		
61948	1898	4052083	2013-05-25	2013-05-25 00:00:00	2013-05-25	5001	0	\N	0	0	\N	\N	0	126345	0	23426006	4052083		
86068	2661	4024958	2009-07-05	2009-07-05 00:00:00	2009-07-05	5001	0	\N	0	0	\N	\N	0	176312	0	117015009	4024958		
35355	1101	4052083	1974-10-19	1974-10-19 00:00:00	1974-10-19	5001	0	\N	0	0	\N	\N	0	72356	0	23426006	4052083		
66661	2046	4052083	1951-02-15	1951-02-15 00:00:00	1951-02-15	5001	0	\N	0	0	\N	\N	0	136099	0	23426006	4052083		
22616	2075	3019406	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	138131	0	6158-0	3019406		
50773	4628	40769189	1986-10-08	1986-10-08 00:00:00	1986-10-08	5001	0	\N	0	0	\N	\N	0	308310	0	66529-9	40769189		
50826	4634	3006322	1970-03-03	1970-03-03 00:00:00	1970-03-03	5001	0	\N	0	0	\N	\N	0	308821	0	8331-1	3006322		
16185	1476	3006322	2005-06-08	2005-06-08 00:00:00	2005-06-08	5001	0	\N	0	0	\N	\N	0	98451	0	8331-1	3006322		
173913	5333	4024958	1981-02-13	1981-02-13 00:00:00	1981-02-13	5001	0	\N	0	0	\N	\N	0	355129	0	117015009	4024958		
45819	4224	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	280467	0	6273-7	3006451		
27346	2537	3014599	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	167725	0	6106-9	3014599		
2350	222	3006322	1995-07-14	1995-07-14 00:00:00	1995-07-14	5001	0	\N	0	0	\N	\N	0	14915	0	8331-1	3006322		
25001	2294	3006322	1994-11-28	1994-11-28 00:00:00	1994-11-28	5001	0	\N	0	0	\N	\N	0	152661	0	8331-1	3006322		
159425	4899	4133840	1990-09-25	1990-09-25 00:00:00	1990-09-25	5001	0	\N	0	0	\N	\N	0	325850	0	127783003	4133840		
50540	4608	46235214	1985-06-06	1985-06-06 00:00:00	1985-06-06	5001	0	\N	0	0	\N	\N	0	307082	0	76690-7	46235214		
36511	3355	3006322	1966-12-02	1966-12-02 00:00:00	1966-12-02	5001	0	\N	0	0	\N	\N	0	222481	0	8331-1	3006322		
95216	2921	4133840	1975-06-10	1975-06-10 00:00:00	1975-06-10	5001	0	\N	0	0	\N	\N	0	194754	0	127783003	4133840		
4199	418	3006322	1996-01-06	1996-01-06 00:00:00	1996-01-06	5001	0	\N	0	0	\N	\N	0	27600	0	8331-1	3006322		
5198	499	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	33423	0	6158-0	3019406		
8685	842	3011505	1995-07-01	1995-07-01 00:00:00	1995-07-01	5001	0	\N	0	0	\N	\N	0	55696	0	19926-5	3011505		
119932	3698	4052083	1952-10-28	1952-10-28 00:00:00	1952-10-28	5001	0	\N	0	0	\N	\N	0	245894	0	23426006	4052083		
20115	1844	3006322	1979-10-27	1979-10-27 00:00:00	1979-10-27	5001	0	\N	0	0	\N	\N	0	123155	0	8331-1	3006322		
7388	709	3006322	1968-02-24	1968-02-24 00:00:00	1968-02-24	5001	0	\N	0	0	\N	\N	0	46957	0	8331-1	3006322		
49385	4506	40766240	2012-08-21	2012-08-21 00:00:00	2012-08-21	5001	0	\N	0	0	\N	\N	0	300172	0	63513-6	40766240		
5287	160	4052083	2004-10-01	2004-10-01 00:00:00	2004-10-01	5001	0	\N	0	0	\N	\N	0	10951	0	23426006	4052083		
14655	1359	3006322	1945-04-17	1945-04-17 00:00:00	1945-04-17	5001	0	\N	0	0	\N	\N	0	90201	0	8331-1	3006322		
97288	2976	4133840	1995-06-29	1995-06-29 00:00:00	1995-06-29	5001	0	\N	0	0	\N	\N	0	198773	0	127783003	4133840		
28892	2669	40766240	1978-04-07	1978-04-07 00:00:00	1978-04-07	5001	0	\N	0	0	\N	\N	0	176810	0	63513-6	40766240		
44711	4130	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	274581	0	6082-2	3000876		
30620	2806	3006322	1955-08-08	1955-08-08 00:00:00	1955-08-08	5001	0	\N	0	0	\N	\N	0	185921	0	8331-1	3006322		
48910	4476	40769184	1962-05-30	1962-05-30 00:00:00	1962-05-30	5001	0	\N	0	0	\N	\N	0	297888	0	66524-0	40769184		
28061	2577	40769194	1973-09-22	1973-09-22 00:00:00	1973-09-22	5001	0	\N	0	0	\N	\N	0	170610	0	66534-9	40769194		
55406	5081	3049273	1989-08-10	1989-08-10 00:00:00	1989-08-10	5001	0	\N	0	0	\N	\N	0	337809	0	38265-5	3049273		
12031	1143	40766240	1972-08-25	1972-08-25 00:00:00	1972-08-25	5001	0	\N	0	0	\N	\N	0	75444	0	63513-6	40766240		
35453	3244	40758406	1976-11-13	1976-11-13 00:00:00	1976-11-13	5001	0	\N	0	0	\N	\N	0	215711	0	55277-8	40758406		
35875	3295	40766240	1975-01-28	1975-01-28 00:00:00	1975-01-28	5001	0	\N	0	0	\N	\N	0	218968	0	63513-6	40766240		
41338	3857	3011505	2013-10-01	2013-10-01 00:00:00	2013-10-01	5001	0	\N	0	0	\N	\N	0	256024	0	19926-5	3011505		
65604	2013	4052083	1964-05-06	1964-05-06 00:00:00	1964-05-06	5001	0	\N	0	0	\N	\N	0	134005	0	23426006	4052083		
47631	4373	3006322	1978-06-09	1978-06-09 00:00:00	1978-06-09	5001	0	\N	0	0	\N	\N	0	290413	0	8331-1	3006322		
19486	1782	3019550	1956-01-11	1956-01-11 00:00:00	1956-01-11	5001	0	\N	0	0	\N	\N	0	119339	0	2951-2	3019550		
51589	4724	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	314724	0	6075-6	3005136		
51655	4725	3019406	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	314890	0	6158-0	3019406		
26512	830	4052083	1984-12-30	1984-12-30 00:00:00	1984-12-30	5001	0	\N	0	0	\N	\N	0	54967	0	23426006	4052083		
157053	4827	4024958	1963-05-03	1963-05-03 00:00:00	1963-05-03	5001	0	\N	0	0	\N	\N	0	321134	0	117015009	4024958		
117493	3621	4024958	1950-09-19	1950-09-19 00:00:00	1950-09-19	5001	0	\N	0	0	\N	\N	0	240620	0	117015009	4024958		
54279	4963	3006322	1975-07-20	1975-07-20 00:00:00	1975-07-20	5001	0	\N	0	0	\N	\N	0	329960	0	8331-1	3006322		
54336	4970	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	330495	0	6246-3	3021226		
6468	609	3006322	1994-09-22	1994-09-22 00:00:00	1994-09-22	5001	0	\N	0	0	\N	\N	0	40432	0	8331-1	3006322		
21274	1967	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	130747	0	6246-3	3021226		
91716	2830	4024958	1983-06-29	1983-06-29 00:00:00	1983-06-29	5001	0	\N	0	0	\N	\N	0	187785	0	117015009	4024958		
32669	2960	3051031	1970-03-01	1970-03-01 00:00:00	1970-03-01	5001	0	\N	0	0	\N	\N	0	197663	0	46240-8	3051031		
49926	4538	3006322	2002-09-06	2002-09-06 00:00:00	2002-09-06	5001	0	\N	0	0	\N	\N	0	302391	0	8331-1	3006322		
13178	1259	3005136	1981-04-14	1981-04-14 00:00:00	1981-04-14	5001	0	\N	0	0	\N	\N	0	82942	0	6075-6	3005136		
97592	2986	4133840	2014-04-08	2014-04-08 00:00:00	2014-04-08	5001	0	\N	0	0	\N	\N	0	199318	0	127783003	4133840		
23371	732	4052083	2000-09-16	2000-09-16 00:00:00	2000-09-16	5001	0	\N	0	0	\N	\N	0	48575	0	23426006	4052083		
97687	2986	4133840	2013-04-02	2013-04-02 00:00:00	2013-04-02	5001	0	\N	0	0	\N	\N	0	199324	0	127783003	4133840		
109229	3371	4024958	2000-09-07	2000-09-07 00:00:00	2000-09-07	5001	0	\N	0	0	\N	\N	0	223649	0	117015009	4024958		
29239	2693	46235214	2013-12-29	2013-12-29 00:00:00	2013-12-29	5001	0	\N	0	0	\N	\N	0	178370	0	76690-7	46235214		
46233	1410	4024958	1969-02-04	1969-02-04 00:00:00	1969-02-04	5001	0	\N	0	0	\N	\N	0	93847	0	117015009	4024958		
30554	949	4133840	2016-12-19	2016-12-19 00:00:00	2016-12-19	5001	0	\N	0	0	\N	\N	0	63002	0	127783003	4133840		
14390	1345	40766240	1992-05-07	1992-05-07 00:00:00	1992-05-07	5001	0	\N	0	0	\N	\N	0	89144	0	63513-6	40766240		
45019	4159	3006322	2005-11-04	2005-11-04 00:00:00	2005-11-04	5001	0	\N	0	0	\N	\N	0	276331	0	8331-1	3006322		
25805	2369	3006734	1982-01-16	1982-01-16 00:00:00	1982-01-16	5001	0	\N	0	0	\N	\N	0	157671	0	6189-5	3006734		
165363	5078	4052083	1973-04-22	1973-04-22 00:00:00	1973-04-22	5001	0	\N	0	0	\N	\N	0	337503	0	23426006	4052083		
61949	1898	4024958	1991-04-03	1991-04-03 00:00:00	1991-04-03	5001	0	\N	0	0	\N	\N	0	126342	0	117015009	4024958		
86094	2661	4024958	1990-08-19	1990-08-19 00:00:00	1990-08-19	5001	0	\N	0	0	\N	\N	0	176326	0	117015009	4024958		
35361	1101	4052083	1993-09-09	1993-09-09 00:00:00	1993-09-09	5001	0	\N	0	0	\N	\N	0	72352	0	23426006	4052083		
166692	5118	4024958	1967-12-19	1967-12-19 00:00:00	1967-12-19	5001	0	\N	0	0	\N	\N	0	340197	0	117015009	4024958		
22617	2075	3015076	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	138131	0	6248-9	3015076		
50774	4628	40769184	1986-10-08	1986-10-08 00:00:00	1986-10-08	5001	0	\N	0	0	\N	\N	0	308310	0	66524-0	40769184		
50827	4634	3006322	2008-04-14	2008-04-14 00:00:00	2008-04-14	5001	0	\N	0	0	\N	\N	0	308823	0	8331-1	3006322		
144455	4439	4024958	1958-10-22	1958-10-22 00:00:00	1958-10-22	5001	0	\N	0	0	\N	\N	0	295120	0	117015009	4024958		
173917	5333	4052083	1955-12-06	1955-12-06 00:00:00	1955-12-06	5001	0	\N	0	0	\N	\N	0	355145	0	23426006	4052083		
45820	4224	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	280467	0	6158-0	3019406		
27347	2537	3006451	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	167725	0	6273-7	3006451		
2351	222	3006322	1993-01-09	1993-01-09 00:00:00	1993-01-09	5001	0	\N	0	0	\N	\N	0	14895	0	8331-1	3006322		
25002	2295	3006322	1984-08-23	1984-08-23 00:00:00	1984-08-23	5001	0	\N	0	0	\N	\N	0	152776	0	8331-1	3006322		
159426	4899	4133840	1987-09-08	1987-09-08 00:00:00	1987-09-08	5001	0	\N	0	0	\N	\N	0	325845	0	127783003	4133840		
50541	4608	40758406	1985-06-06	1985-06-06 00:00:00	1985-06-06	5001	0	\N	0	0	\N	\N	0	307082	0	55277-8	40758406		
36512	3355	3006322	1967-10-10	1967-10-10 00:00:00	1967-10-10	5001	0	\N	0	0	\N	\N	0	222482	0	8331-1	3006322		
95219	2921	4133840	1989-05-30	1989-05-30 00:00:00	1989-05-30	5001	0	\N	0	0	\N	\N	0	194700	0	127783003	4133840		
4200	418	3006322	1983-01-01	1983-01-01 00:00:00	1983-01-01	5001	0	\N	0	0	\N	\N	0	27610	0	8331-1	3006322		
5199	499	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	33423	0	6082-2	3000876		
8686	842	3011505	1988-05-21	1988-05-21 00:00:00	1988-05-21	5001	0	\N	0	0	\N	\N	0	55668	0	19926-5	3011505		
119933	3698	4052083	2000-02-03	2000-02-03 00:00:00	2000-02-03	5001	0	\N	0	0	\N	\N	0	245875	0	23426006	4052083		
20117	1844	3051031	1989-02-23	1989-02-23 00:00:00	1989-02-23	5001	0	\N	0	0	\N	\N	0	123137	0	46240-8	3051031		
7389	709	3006322	1979-02-26	1979-02-26 00:00:00	1979-02-26	5001	0	\N	0	0	\N	\N	0	46976	0	8331-1	3006322		
49386	4506	3051031	2012-08-21	2012-08-21 00:00:00	2012-08-21	5001	0	\N	0	0	\N	\N	0	300172	0	46240-8	3051031		
5292	160	4052083	1973-02-10	1973-02-10 00:00:00	1973-02-10	5001	0	\N	0	0	\N	\N	0	10944	0	23426006	4052083		
14656	1359	3006322	1941-01-13	1941-01-13 00:00:00	1941-01-13	5001	0	\N	0	0	\N	\N	0	90199	0	8331-1	3006322		
97289	2976	4024958	1984-03-02	1984-03-02 00:00:00	1984-03-02	5001	0	\N	0	0	\N	\N	0	198726	0	117015009	4024958		
44619	4121	3011505	1980-09-28	1980-09-28 00:00:00	1980-09-28	5001	0	\N	0	0	\N	\N	0	273939	0	19926-5	3011505		
44712	4130	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	274581	0	6085-5	3001247		
30621	2806	3049273	2009-05-25	2009-05-25 00:00:00	2009-05-25	5001	0	\N	0	0	\N	\N	0	185962	0	38265-5	3049273		
39599	1229	4024958	1954-12-15	1954-12-15 00:00:00	1954-12-15	5001	0	\N	0	0	\N	\N	0	81005	0	117015009	4024958		
28062	2577	40769184	1973-09-22	1973-09-22 00:00:00	1973-09-22	5001	0	\N	0	0	\N	\N	0	170610	0	66524-0	40769184		
55407	5081	3006322	1939-11-19	1939-11-19 00:00:00	1939-11-19	5001	0	\N	0	0	\N	\N	0	337875	0	8331-1	3006322		
12033	1143	46235214	1972-08-25	1972-08-25 00:00:00	1972-08-25	5001	0	\N	0	0	\N	\N	0	75444	0	76690-7	46235214		
35454	3244	40766240	1976-11-13	1976-11-13 00:00:00	1976-11-13	5001	0	\N	0	0	\N	\N	0	215711	0	63513-6	40766240		
35876	3295	3051031	1975-01-28	1975-01-28 00:00:00	1975-01-28	5001	0	\N	0	0	\N	\N	0	218968	0	46240-8	3051031		
41339	3857	3006322	1954-10-11	1954-10-11 00:00:00	1954-10-11	5001	0	\N	0	0	\N	\N	0	255979	0	8331-1	3006322		
65618	2013	4024958	2004-10-02	2004-10-02 00:00:00	2004-10-02	5001	0	\N	0	0	\N	\N	0	133942	0	117015009	4024958		
47632	4374	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	290459	0	7258-7	3001488		
19487	1782	3016723	1956-01-11	1956-01-11 00:00:00	1956-01-11	5001	0	\N	0	0	\N	\N	0	119339	0	2160-0	3016723		
51590	4724	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	314724	0	6106-9	3014599		
51656	4725	3020655	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	314890	0	6844-5	3020655		
26517	830	4024958	2016-09-21	2016-09-21 00:00:00	2016-09-21	5001	0	\N	0	0	\N	\N	0	55013	0	117015009	4024958		
157078	4827	4024958	1992-11-07	1992-11-07 00:00:00	1992-11-07	5001	0	\N	0	0	\N	\N	0	321173	0	117015009	4024958		
117495	3621	4133840	1990-11-03	1990-11-03 00:00:00	1990-11-03	5001	0	\N	0	0	\N	\N	0	240605	0	127783003	4133840		
54280	4963	3006322	2010-08-31	2010-08-31 00:00:00	2010-08-31	5001	0	\N	0	0	\N	\N	0	329939	0	8331-1	3006322		
54337	4970	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	330495	0	6106-9	3014599		
6469	609	3006322	2010-01-03	2010-01-03 00:00:00	2010-01-03	5001	0	\N	0	0	\N	\N	0	40458	0	8331-1	3006322		
21275	1967	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	130747	0	6833-8	3023430		
21554	1987	3006322	1946-03-17	1946-03-17 00:00:00	1946-03-17	5001	0	\N	0	0	\N	\N	0	132315	0	8331-1	3006322		
32670	2960	46235214	1970-03-01	1970-03-01 00:00:00	1970-03-01	5001	0	\N	0	0	\N	\N	0	197663	0	76690-7	46235214		
49927	4538	3006322	1999-06-15	1999-06-15 00:00:00	1999-06-15	5001	0	\N	0	0	\N	\N	0	302310	0	8331-1	3006322		
13179	1259	3006734	1981-04-14	1981-04-14 00:00:00	1981-04-14	5001	0	\N	0	0	\N	\N	0	82942	0	6189-5	3006734		
97593	2986	4133840	1994-10-11	1994-10-11 00:00:00	1994-10-11	5001	0	\N	0	0	\N	\N	0	199364	0	127783003	4133840		
23382	732	4024958	2008-08-09	2008-08-09 00:00:00	2008-08-09	5001	0	\N	0	0	\N	\N	0	48572	0	117015009	4024958		
97696	2987	4024958	1973-07-23	1973-07-23 00:00:00	1973-07-23	5001	0	\N	0	0	\N	\N	0	199402	0	117015009	4024958		
109406	3376	4052083	1979-10-20	1979-10-20 00:00:00	1979-10-20	5001	0	\N	0	0	\N	\N	0	223955	0	23426006	4052083		
29240	2693	3051031	2013-12-29	2013-12-29 00:00:00	2013-12-29	5001	0	\N	0	0	\N	\N	0	178370	0	46240-8	3051031		
46241	1410	4024958	1973-02-24	1973-02-24 00:00:00	1973-02-24	5001	0	\N	0	0	\N	\N	0	93848	0	117015009	4024958		
30557	949	4133840	2010-11-15	2010-11-15 00:00:00	2010-11-15	5001	0	\N	0	0	\N	\N	0	63056	0	127783003	4133840		
14391	1345	3006322	1995-12-10	1995-12-10 00:00:00	1995-12-10	5001	0	\N	0	0	\N	\N	0	89160	0	8331-1	3006322		
45020	4160	3006322	2012-10-13	2012-10-13 00:00:00	2012-10-13	5001	0	\N	0	0	\N	\N	0	276458	0	8331-1	3006322		
25806	2369	3036780	1982-01-16	1982-01-16 00:00:00	1982-01-16	5001	0	\N	0	0	\N	\N	0	157671	0	6095-4	3036780		
165373	5078	4024958	1962-04-14	1962-04-14 00:00:00	1962-04-14	5001	0	\N	0	0	\N	\N	0	337498	0	117015009	4024958		
61968	1898	4024958	1981-09-24	1981-09-24 00:00:00	1981-09-24	5001	0	\N	0	0	\N	\N	0	126351	0	117015009	4024958		
8134	771	3006322	1967-05-29	1967-05-29 00:00:00	1967-05-29	5001	0	\N	0	0	\N	\N	0	51172	0	8331-1	3006322		
35365	1101	4133840	2006-07-02	2006-07-02 00:00:00	2006-07-02	5001	0	\N	0	0	\N	\N	0	72304	0	127783003	4133840		
166722	5118	4024958	1987-09-01	1987-09-01 00:00:00	1987-09-01	5001	0	\N	0	0	\N	\N	0	340164	0	117015009	4024958		
22618	2075	3006734	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	138131	0	6189-5	3006734		
50775	4628	40769179	1986-10-08	1986-10-08 00:00:00	1986-10-08	5001	0	\N	0	0	\N	\N	0	308310	0	66519-0	40769179		
50828	4634	3006322	1988-04-20	1988-04-20 00:00:00	1988-04-20	5001	0	\N	0	0	\N	\N	0	308822	0	8331-1	3006322		
17094	1556	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	104226	0	6276-0	3027231		
173928	5334	4052083	1988-11-06	1988-11-06 00:00:00	1988-11-06	5001	0	\N	0	0	\N	\N	0	355193	0	23426006	4052083		
45821	4224	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	280467	0	6095-4	3036780		
27348	2537	3005136	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	167725	0	6075-6	3005136		
2352	222	3006322	2015-12-11	2015-12-11 00:00:00	2015-12-11	5001	0	\N	0	0	\N	\N	0	14886	0	8331-1	3006322		
25003	2295	3006322	1973-11-04	1973-11-04 00:00:00	1973-11-04	5001	0	\N	0	0	\N	\N	0	152772	0	8331-1	3006322		
159427	4899	4133840	1978-07-18	1978-07-18 00:00:00	1978-07-18	5001	0	\N	0	0	\N	\N	0	325857	0	127783003	4133840		
50543	4608	3051031	1985-06-06	1985-06-06 00:00:00	1985-06-06	5001	0	\N	0	0	\N	\N	0	307082	0	46240-8	3051031		
36513	3355	3006322	1980-12-22	1980-12-22 00:00:00	1980-12-22	5001	0	\N	0	0	\N	\N	0	222510	0	8331-1	3006322		
106506	3279	4052083	1958-07-11	1958-07-11 00:00:00	1958-07-11	5001	0	\N	0	0	\N	\N	0	217895	0	23426006	4052083		
4201	418	3006322	2011-07-30	2011-07-30 00:00:00	2011-07-30	5001	0	\N	0	0	\N	\N	0	27615	0	8331-1	3006322		
5200	499	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	33423	0	6095-4	3036780		
8687	842	3011505	1992-06-13	1992-06-13 00:00:00	1992-06-13	5001	0	\N	0	0	\N	\N	0	55670	0	19926-5	3011505		
119939	3698	4024958	1963-12-07	1963-12-07 00:00:00	1963-12-07	5001	0	\N	0	0	\N	\N	0	245856	0	117015009	4024958		
20119	1844	46235214	1989-02-23	1989-02-23 00:00:00	1989-02-23	5001	0	\N	0	0	\N	\N	0	123137	0	76690-7	46235214		
7390	709	3006322	1995-06-19	1995-06-19 00:00:00	1995-06-19	5001	0	\N	0	0	\N	\N	0	46933	0	8331-1	3006322		
49387	4506	40758406	2012-08-21	2012-08-21 00:00:00	2012-08-21	5001	0	\N	0	0	\N	\N	0	300172	0	55277-8	40758406		
5293	160	4024958	1998-05-31	1998-05-31 00:00:00	1998-05-31	5001	0	\N	0	0	\N	\N	0	10980	0	117015009	4024958		
14657	1360	3006322	2016-03-28	2016-03-28 00:00:00	2016-03-28	5001	0	\N	0	0	\N	\N	0	90252	0	8331-1	3006322		
97290	2976	4133840	1993-03-18	1993-03-18 00:00:00	1993-03-18	5001	0	\N	0	0	\N	\N	0	198761	0	127783003	4133840		
44620	4121	3006322	1976-09-21	1976-09-21 00:00:00	1976-09-21	5001	0	\N	0	0	\N	\N	0	273980	0	8331-1	3006322		
44713	4130	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	274581	0	6189-5	3006734		
30622	2806	3049273	2013-06-13	2013-06-13 00:00:00	2013-06-13	5001	0	\N	0	0	\N	\N	0	185935	0	38265-5	3049273		
39626	1231	4052083	1957-07-07	1957-07-07 00:00:00	1957-07-07	5001	0	\N	0	0	\N	\N	0	81105	0	23426006	4052083		
28063	2577	40769179	1973-09-22	1973-09-22 00:00:00	1973-09-22	5001	0	\N	0	0	\N	\N	0	170610	0	66519-0	40769179		
55408	5081	3006322	1928-10-04	1928-10-04 00:00:00	1928-10-04	5001	0	\N	0	0	\N	\N	0	337906	0	8331-1	3006322		
12034	1143	40758406	1972-08-25	1972-08-25 00:00:00	1972-08-25	5001	0	\N	0	0	\N	\N	0	75444	0	55277-8	40758406		
35455	3244	3051031	1976-11-13	1976-11-13 00:00:00	1976-11-13	5001	0	\N	0	0	\N	\N	0	215711	0	46240-8	3051031		
35877	3295	40758406	1975-01-28	1975-01-28 00:00:00	1975-01-28	5001	0	\N	0	0	\N	\N	0	218968	0	55277-8	40758406		
41340	3857	3011505	2014-10-07	2014-10-07 00:00:00	2014-10-07	5001	0	\N	0	0	\N	\N	0	255998	0	19926-5	3011505		
65661	2016	4052083	1998-05-11	1998-05-11 00:00:00	1998-05-11	5001	0	\N	0	0	\N	\N	0	134120	0	23426006	4052083		
47633	4374	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	290459	0	6189-5	3006734		
19488	1782	3024561	1956-01-11	1956-01-11 00:00:00	1956-01-11	5001	0	\N	0	0	\N	\N	0	119339	0	1751-7	3024561		
51591	4724	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	314724	0	6158-0	3019406		
51657	4725	3023430	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	314890	0	6833-8	3023430		
26526	830	4024958	1985-05-11	1985-05-11 00:00:00	1985-05-11	5001	0	\N	0	0	\N	\N	0	54968	0	117015009	4024958		
157085	4827	4052083	2006-07-12	2006-07-12 00:00:00	2006-07-12	5001	0	\N	0	0	\N	\N	0	321095	0	23426006	4052083		
117497	3621	4133840	1986-10-11	1986-10-11 00:00:00	1986-10-11	5001	0	\N	0	0	\N	\N	0	240655	0	127783003	4133840		
168530	5174	4052083	1978-11-19	1978-11-19 00:00:00	1978-11-19	5001	0	\N	0	0	\N	\N	0	344039	0	23426006	4052083		
54338	4970	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	330495	0	6273-7	3006451		
6470	609	3006322	1993-02-13	1993-02-13 00:00:00	1993-02-13	5001	0	\N	0	0	\N	\N	0	40441	0	8331-1	3006322		
21276	1967	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	130747	0	6844-5	3020655		
21555	1987	3006322	1954-02-12	1954-02-12 00:00:00	1954-02-12	5001	0	\N	0	0	\N	\N	0	132331	0	8331-1	3006322		
32671	2960	40766240	1970-03-01	1970-03-01 00:00:00	1970-03-01	5001	0	\N	0	0	\N	\N	0	197663	0	63513-6	40766240		
49928	4538	3006322	1986-09-07	1986-09-07 00:00:00	1986-09-07	5001	0	\N	0	0	\N	\N	0	302335	0	8331-1	3006322		
13180	1259	3001488	1981-04-14	1981-04-14 00:00:00	1981-04-14	5001	0	\N	0	0	\N	\N	0	82942	0	7258-7	3001488		
97595	2986	4133840	1995-12-26	1995-12-26 00:00:00	1995-12-26	5001	0	\N	0	0	\N	\N	0	199349	0	127783003	4133840		
40880	3793	40766240	1940-08-29	1940-08-29 00:00:00	1940-08-29	5001	0	\N	0	0	\N	\N	0	252257	0	63513-6	40766240		
97698	2987	4024958	1992-10-01	1992-10-01 00:00:00	1992-10-01	5001	0	\N	0	0	\N	\N	0	199413	0	117015009	4024958		
109422	3376	4052083	1963-10-23	1963-10-23 00:00:00	1963-10-23	5001	0	\N	0	0	\N	\N	0	223953	0	23426006	4052083		
29241	2693	3006322	2019-02-23	2019-02-23 00:00:00	2019-02-23	5001	0	\N	0	0	\N	\N	0	178391	0	8331-1	3006322		
46243	1410	4052083	1991-12-05	1991-12-05 00:00:00	1991-12-05	5001	0	\N	0	0	\N	\N	0	93904	0	23426006	4052083		
30558	949	4133840	2014-12-08	2014-12-08 00:00:00	2014-12-08	5001	0	\N	0	0	\N	\N	0	63001	0	127783003	4133840		
14394	1345	40766240	1992-04-07	1992-04-07 00:00:00	1992-04-07	5001	0	\N	0	0	\N	\N	0	89125	0	63513-6	40766240		
12358	399	4024958	1979-09-17	1979-09-17 00:00:00	1979-09-17	5001	0	\N	0	0	\N	\N	0	26253	0	117015009	4024958		
25807	2369	3020655	1982-01-16	1982-01-16 00:00:00	1982-01-16	5001	0	\N	0	0	\N	\N	0	157671	0	6844-5	3020655		
165382	5078	4052083	1956-10-03	1956-10-03 00:00:00	1956-10-03	5001	0	\N	0	0	\N	\N	0	337540	0	23426006	4052083		
61975	1898	4024958	2005-09-26	2005-09-26 00:00:00	2005-09-26	5001	0	\N	0	0	\N	\N	0	126386	0	117015009	4024958		
8135	771	3006322	1975-05-28	1975-05-28 00:00:00	1975-05-28	5001	0	\N	0	0	\N	\N	0	51241	0	8331-1	3006322		
35369	1101	4133840	2016-08-28	2016-08-28 00:00:00	2016-08-28	5001	0	\N	0	0	\N	\N	0	72315	0	127783003	4133840		
102158	3137	4052083	1910-06-13	1910-06-13 00:00:00	1910-06-13	5001	0	\N	0	0	\N	\N	0	208830	0	23426006	4052083		
22619	2075	3014599	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	138131	0	6106-9	3014599		
50776	4628	3015076	1986-10-24	1986-10-24 00:00:00	1986-10-24	5001	0	\N	0	0	\N	\N	0	308311	0	6248-9	3015076		
50829	4634	3006322	1976-11-27	1976-11-27 00:00:00	1976-11-27	5001	0	\N	0	0	\N	\N	0	308877	0	8331-1	3006322		
17095	1556	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	104226	0	6085-5	3001247		
173933	5334	4052083	1988-02-01	1988-02-01 00:00:00	1988-02-01	5001	0	\N	0	0	\N	\N	0	355177	0	23426006	4052083		
45822	4224	3006322	2008-04-13	2008-04-13 00:00:00	2008-04-13	5001	0	\N	0	0	\N	\N	0	280455	0	8331-1	3006322		
27349	2537	3027231	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	167725	0	6276-0	3027231		
2353	222	3006322	1967-01-19	1967-01-19 00:00:00	1967-01-19	5001	0	\N	0	0	\N	\N	0	14950	0	8331-1	3006322		
106927	3295	4052083	1997-11-01	1997-11-01 00:00:00	1997-11-01	5001	0	\N	0	0	\N	\N	0	218973	0	23426006	4052083		
159429	4899	4133840	1983-08-16	1983-08-16 00:00:00	1983-08-16	5001	0	\N	0	0	\N	\N	0	325796	0	127783003	4133840		
50545	4608	40766240	1985-06-06	1985-06-06 00:00:00	1985-06-06	5001	0	\N	0	0	\N	\N	0	307082	0	63513-6	40766240		
36514	3355	3049273	2017-05-10	2017-05-10 00:00:00	2017-05-10	5001	0	\N	0	0	\N	\N	0	222509	0	38265-5	3049273		
47837	4379	3006322	2009-02-25	2009-02-25 00:00:00	2009-02-25	5001	0	\N	0	0	\N	\N	0	290984	0	8331-1	3006322		
4203	418	3051031	1966-11-20	1966-11-20 00:00:00	1966-11-20	5001	0	\N	0	0	\N	\N	0	27597	0	46240-8	3051031		
5201	499	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	33423	0	6248-9	3015076		
8688	842	3011505	2014-10-18	2014-10-18 00:00:00	2014-10-18	5001	0	\N	0	0	\N	\N	0	55703	0	19926-5	3011505		
119940	3698	4052083	1960-07-04	1960-07-04 00:00:00	1960-07-04	5001	0	\N	0	0	\N	\N	0	245827	0	23426006	4052083		
20120	1844	40758406	1989-02-23	1989-02-23 00:00:00	1989-02-23	5001	0	\N	0	0	\N	\N	0	123137	0	55277-8	40758406		
7391	709	3006322	1971-05-26	1971-05-26 00:00:00	1971-05-26	5001	0	\N	0	0	\N	\N	0	46930	0	8331-1	3006322		
49388	4506	40766240	2003-04-01	2003-04-01 00:00:00	2003-04-01	5001	0	\N	0	0	\N	\N	0	300209	0	63513-6	40766240		
5299	160	4052083	1990-01-13	1990-01-13 00:00:00	1990-01-13	5001	0	\N	0	0	\N	\N	0	10947	0	23426006	4052083		
14658	1360	3006322	1993-12-11	1993-12-11 00:00:00	1993-12-11	5001	0	\N	0	0	\N	\N	0	90282	0	8331-1	3006322		
97293	2976	4133840	2016-07-28	2016-07-28 00:00:00	2016-07-28	5001	0	\N	0	0	\N	\N	0	198766	0	127783003	4133840		
44621	4121	3011505	1973-08-19	1973-08-19 00:00:00	1973-08-19	5001	0	\N	0	0	\N	\N	0	273975	0	19926-5	3011505		
44714	4130	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	274581	0	6206-7	3012494		
30623	2806	3006322	1972-02-19	1972-02-19 00:00:00	1972-02-19	5001	0	\N	0	0	\N	\N	0	185974	0	8331-1	3006322		
39632	1231	4052083	1977-02-04	1977-02-04 00:00:00	1977-02-04	5001	0	\N	0	0	\N	\N	0	81083	0	23426006	4052083		
28064	2578	3006322	1990-08-14	1990-08-14 00:00:00	1990-08-14	5001	0	\N	0	0	\N	\N	0	170716	0	8331-1	3006322		
55409	5081	3006322	1944-04-10	1944-04-10 00:00:00	1944-04-10	5001	0	\N	0	0	\N	\N	0	337876	0	8331-1	3006322		
12035	1143	3051031	1972-08-25	1972-08-25 00:00:00	1972-08-25	5001	0	\N	0	0	\N	\N	0	75444	0	46240-8	3051031		
35456	3244	46235214	1976-11-13	1976-11-13 00:00:00	1976-11-13	5001	0	\N	0	0	\N	\N	0	215711	0	76690-7	46235214		
35878	3295	46235214	1975-01-28	1975-01-28 00:00:00	1975-01-28	5001	0	\N	0	0	\N	\N	0	218968	0	76690-7	46235214		
41341	3857	3006322	1998-06-26	1998-06-26 00:00:00	1998-06-26	5001	0	\N	0	0	\N	\N	0	255962	0	8331-1	3006322		
65668	2016	4024958	2017-06-14	2017-06-14 00:00:00	2017-06-14	5001	0	\N	0	0	\N	\N	0	134095	0	117015009	4024958		
47634	4374	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	290459	0	6833-8	3023430		
19489	1782	3028833	1956-01-11	1956-01-11 00:00:00	1956-01-11	5001	0	\N	0	0	\N	\N	0	119339	0	42719-5	3028833		
51592	4724	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	314724	0	6844-5	3020655		
51658	4725	3036780	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	314890	0	6095-4	3036780		
26530	830	4024958	1973-10-29	1973-10-29 00:00:00	1973-10-29	5001	0	\N	0	0	\N	\N	0	55001	0	117015009	4024958		
173579	5325	4052083	1973-03-16	1973-03-16 00:00:00	1973-03-16	5001	0	\N	0	0	\N	\N	0	354492	0	23426006	4052083		
117499	3621	4133840	1977-08-20	1977-08-20 00:00:00	1977-08-20	5001	0	\N	0	0	\N	\N	0	240601	0	127783003	4133840		
168545	5174	4052083	2010-08-20	2010-08-20 00:00:00	2010-08-20	5001	0	\N	0	0	\N	\N	0	344018	0	23426006	4052083		
54339	4970	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	330495	0	6276-0	3027231		
6471	609	3006322	1983-03-24	1983-03-24 00:00:00	1983-03-24	5001	0	\N	0	0	\N	\N	0	40429	0	8331-1	3006322		
21277	1967	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	130747	0	7258-7	3001488		
21556	1987	3006322	1998-12-18	1998-12-18 00:00:00	1998-12-18	5001	0	\N	0	0	\N	\N	0	132338	0	8331-1	3006322		
32674	2960	3006322	1955-03-07	1955-03-07 00:00:00	1955-03-07	5001	0	\N	0	0	\N	\N	0	197611	0	8331-1	3006322		
49929	4538	3006322	1954-11-08	1954-11-08 00:00:00	1954-11-08	5001	0	\N	0	0	\N	\N	0	302348	0	8331-1	3006322		
13181	1259	3001247	1981-04-14	1981-04-14 00:00:00	1981-04-14	5001	0	\N	0	0	\N	\N	0	82942	0	6085-5	3001247		
97598	2986	4052083	1978-12-06	1978-12-06 00:00:00	1978-12-06	5001	0	\N	0	0	\N	\N	0	199330	0	23426006	4052083		
40883	3793	3051031	1940-08-29	1940-08-29 00:00:00	1940-08-29	5001	0	\N	0	0	\N	\N	0	252257	0	46240-8	3051031		
97721	2987	4024958	1981-08-22	1981-08-22 00:00:00	1981-08-22	5001	0	\N	0	0	\N	\N	0	199391	0	117015009	4024958		
29869	923	4024958	1986-11-05	1986-11-05 00:00:00	1986-11-05	5001	0	\N	0	0	\N	\N	0	61475	0	117015009	4024958		
29242	2693	3006322	1961-04-17	1961-04-17 00:00:00	1961-04-17	5001	0	\N	0	0	\N	\N	0	178401	0	8331-1	3006322		
46247	1410	4024958	2005-05-30	2005-05-30 00:00:00	2005-05-30	5001	0	\N	0	0	\N	\N	0	93897	0	117015009	4024958		
30560	949	4133840	1986-09-01	1986-09-01 00:00:00	1986-09-01	5001	0	\N	0	0	\N	\N	0	62998	0	127783003	4133840		
14395	1345	40758406	1992-04-07	1992-04-07 00:00:00	1992-04-07	5001	0	\N	0	0	\N	\N	0	89125	0	55277-8	40758406		
12371	399	4024958	1994-12-09	1994-12-09 00:00:00	1994-12-09	5001	0	\N	0	0	\N	\N	0	26124	0	117015009	4024958		
25808	2369	3021226	1982-01-16	1982-01-16 00:00:00	1982-01-16	5001	0	\N	0	0	\N	\N	0	157671	0	6246-3	3021226		
56953	1740	4024958	1977-07-16	1977-07-16 00:00:00	1977-07-16	5001	0	\N	0	0	\N	\N	0	116263	0	117015009	4024958		
61977	1898	4024958	1998-12-09	1998-12-09 00:00:00	1998-12-09	5001	0	\N	0	0	\N	\N	0	126352	0	117015009	4024958		
8136	771	3006322	1993-12-31	1993-12-31 00:00:00	1993-12-31	5001	0	\N	0	0	\N	\N	0	51232	0	8331-1	3006322		
58527	1781	4052083	2009-11-17	2009-11-17 00:00:00	2009-11-17	5001	0	\N	0	0	\N	\N	0	119208	0	23426006	4052083		
102159	3137	4052083	1919-01-12	1919-01-12 00:00:00	1919-01-12	5001	0	\N	0	0	\N	\N	0	208821	0	23426006	4052083		
22620	2075	3027231	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	138131	0	6276-0	3027231		
50777	4628	3036780	1986-10-24	1986-10-24 00:00:00	1986-10-24	5001	0	\N	0	0	\N	\N	0	308311	0	6095-4	3036780		
50831	4636	3006322	2007-12-30	2007-12-30 00:00:00	2007-12-30	5001	0	\N	0	0	\N	\N	0	308970	0	8331-1	3006322		
17096	1556	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	104226	0	6844-5	3020655		
173934	5334	4024958	2008-11-25	2008-11-25 00:00:00	2008-11-25	5001	0	\N	0	0	\N	\N	0	355198	0	117015009	4024958		
45823	4224	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	280540	0	6075-6	3005136		
27350	2537	3023430	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	167725	0	6833-8	3023430		
2354	222	3006322	1960-12-13	1960-12-13 00:00:00	1960-12-13	5001	0	\N	0	0	\N	\N	0	14890	0	8331-1	3006322		
106940	3295	4024958	1981-11-04	1981-11-04 00:00:00	1981-11-04	5001	0	\N	0	0	\N	\N	0	218927	0	117015009	4024958		
159431	4899	4133840	1982-08-10	1982-08-10 00:00:00	1982-08-10	5001	0	\N	0	0	\N	\N	0	325859	0	127783003	4133840		
50546	4608	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	307006	0	6206-7	3012494		
36515	3355	3006322	1964-09-28	1964-09-28 00:00:00	1964-09-28	5001	0	\N	0	0	\N	\N	0	222492	0	8331-1	3006322		
47838	4380	3006322	1986-06-07	1986-06-07 00:00:00	1986-06-07	5001	0	\N	0	0	\N	\N	0	291033	0	8331-1	3006322		
4204	418	46235214	1966-11-20	1966-11-20 00:00:00	1966-11-20	5001	0	\N	0	0	\N	\N	0	27597	0	76690-7	46235214		
5202	499	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	33423	0	6206-7	3012494		
8689	842	3011505	1981-03-14	1981-03-14 00:00:00	1981-03-14	5001	0	\N	0	0	\N	\N	0	55665	0	19926-5	3011505		
119941	3698	4052083	2009-06-24	2009-06-24 00:00:00	2009-06-24	5001	0	\N	0	0	\N	\N	0	245877	0	23426006	4052083		
20121	1844	40766240	1989-02-23	1989-02-23 00:00:00	1989-02-23	5001	0	\N	0	0	\N	\N	0	123137	0	63513-6	40766240		
7392	709	3006322	1982-01-20	1982-01-20 00:00:00	1982-01-20	5001	0	\N	0	0	\N	\N	0	46965	0	8331-1	3006322		
49391	4506	46235214	2003-04-01	2003-04-01 00:00:00	2003-04-01	5001	0	\N	0	0	\N	\N	0	300209	0	76690-7	46235214		
5300	160	4024958	1961-10-28	1961-10-28 00:00:00	1961-10-28	5001	0	\N	0	0	\N	\N	0	10977	0	117015009	4024958		
14659	1360	3006322	1985-04-17	1985-04-17 00:00:00	1985-04-17	5001	0	\N	0	0	\N	\N	0	90233	0	8331-1	3006322		
97295	2976	4133840	2001-07-12	2001-07-12 00:00:00	2001-07-12	5001	0	\N	0	0	\N	\N	0	198763	0	127783003	4133840		
44622	4121	3006322	1923-12-22	1923-12-22 00:00:00	1923-12-22	5001	0	\N	0	0	\N	\N	0	273955	0	8331-1	3006322		
44715	4130	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	274581	0	6248-9	3015076		
30651	2812	3006322	2014-11-25	2014-11-25 00:00:00	2014-11-25	5001	0	\N	0	0	\N	\N	0	186313	0	8331-1	3006322		
39633	1231	4024958	1958-06-21	1958-06-21 00:00:00	1958-06-21	5001	0	\N	0	0	\N	\N	0	81152	0	117015009	4024958		
28065	2578	3006322	1971-01-28	1971-01-28 00:00:00	1971-01-28	5001	0	\N	0	0	\N	\N	0	170714	0	8331-1	3006322		
55413	5081	3006322	1918-10-12	1918-10-12 00:00:00	1918-10-12	5001	0	\N	0	0	\N	\N	0	337886	0	8331-1	3006322		
12036	1143	3006322	1975-06-21	1975-06-21 00:00:00	1975-06-21	5001	0	\N	0	0	\N	\N	0	75402	0	8331-1	3006322		
35460	3244	40758406	1976-09-14	1976-09-14 00:00:00	1976-09-14	5001	0	\N	0	0	\N	\N	0	215687	0	55277-8	40758406		
35881	3295	3006322	1986-09-22	1986-09-22 00:00:00	1986-09-22	5001	0	\N	0	0	\N	\N	0	218928	0	8331-1	3006322		
41342	3857	3011505	1977-12-20	1977-12-20 00:00:00	1977-12-20	5001	0	\N	0	0	\N	\N	0	256044	0	19926-5	3011505		
65681	2016	4024958	2002-01-19	2002-01-19 00:00:00	2002-01-19	5001	0	\N	0	0	\N	\N	0	134143	0	117015009	4024958		
47635	4374	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	290459	0	6273-7	3006451		
19490	1782	3002385	1956-01-11	1956-01-11 00:00:00	1956-01-11	5001	0	\N	0	0	\N	\N	0	119339	0	30385-9	3002385		
51593	4724	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	314724	0	6085-5	3001247		
51659	4725	3005136	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	314890	0	6075-6	3005136		
26534	830	4024958	1994-06-19	1994-06-19 00:00:00	1994-06-19	5001	0	\N	0	0	\N	\N	0	55002	0	117015009	4024958		
173600	5325	4024958	1955-08-03	1955-08-03 00:00:00	1955-08-03	5001	0	\N	0	0	\N	\N	0	354497	0	117015009	4024958		
117501	3621	4133840	1984-09-29	1984-09-29 00:00:00	1984-09-29	5001	0	\N	0	0	\N	\N	0	240654	0	127783003	4133840		
73695	2265	4024958	1971-08-06	1971-08-06 00:00:00	1971-08-06	5001	0	\N	0	0	\N	\N	0	150558	0	117015009	4024958		
54340	4970	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	330495	0	6833-8	3023430		
6472	609	3006322	1999-03-15	1999-03-15 00:00:00	1999-03-15	5001	0	\N	0	0	\N	\N	0	40433	0	8331-1	3006322		
21278	1967	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	130747	0	6085-5	3001247		
21557	1989	3006322	2010-08-14	2010-08-14 00:00:00	2010-08-14	5001	0	\N	0	0	\N	\N	0	132423	0	8331-1	3006322		
32675	2961	3006322	1987-12-10	1987-12-10 00:00:00	1987-12-10	5001	0	\N	0	0	\N	\N	0	197704	0	8331-1	3006322		
49930	4538	3006322	1958-06-01	1958-06-01 00:00:00	1958-06-01	5001	0	\N	0	0	\N	\N	0	302331	0	8331-1	3006322		
13182	1259	3000876	1981-04-14	1981-04-14 00:00:00	1981-04-14	5001	0	\N	0	0	\N	\N	0	82942	0	6082-2	3000876		
86435	2672	4024958	1986-08-01	1986-08-01 00:00:00	1986-08-01	5001	0	\N	0	0	\N	\N	0	177038	0	117015009	4024958		
40884	3793	46235214	1940-08-29	1940-08-29 00:00:00	1940-08-29	5001	0	\N	0	0	\N	\N	0	252257	0	76690-7	46235214		
109013	3367	4052083	1992-04-23	1992-04-23 00:00:00	1992-04-23	5001	0	\N	0	0	\N	\N	0	223308	0	23426006	4052083		
29876	923	4024958	1959-09-12	1959-09-12 00:00:00	1959-09-12	5001	0	\N	0	0	\N	\N	0	61415	0	117015009	4024958		
29243	2693	40758406	2013-11-29	2013-11-29 00:00:00	2013-11-29	5001	0	\N	0	0	\N	\N	0	178408	0	55277-8	40758406		
46265	1411	4024958	1981-06-08	1981-06-08 00:00:00	1981-06-08	5001	0	\N	0	0	\N	\N	0	93928	0	117015009	4024958		
30562	949	4024958	1968-06-24	1968-06-24 00:00:00	1968-06-24	5001	0	\N	0	0	\N	\N	0	63026	0	117015009	4024958		
14396	1345	3051031	1992-04-07	1992-04-07 00:00:00	1992-04-07	5001	0	\N	0	0	\N	\N	0	89125	0	46240-8	3051031		
12399	399	4024958	1955-09-02	1955-09-02 00:00:00	1955-09-02	5001	0	\N	0	0	\N	\N	0	26250	0	117015009	4024958		
25809	2369	3005136	1982-01-16	1982-01-16 00:00:00	1982-01-16	5001	0	\N	0	0	\N	\N	0	157671	0	6075-6	3005136		
108123	3339	4024958	2017-07-27	2017-07-27 00:00:00	2017-07-27	5001	0	\N	0	0	\N	\N	0	221529	0	117015009	4024958		
61991	1900	4024958	1969-07-09	1969-07-09 00:00:00	1969-07-09	5001	0	\N	0	0	\N	\N	0	126449	0	117015009	4024958		
8147	774	3006322	2010-11-15	2010-11-15 00:00:00	2010-11-15	5001	0	\N	0	0	\N	\N	0	51394	0	8331-1	3006322		
58531	1781	4052083	1961-01-27	1961-01-27 00:00:00	1961-01-27	5001	0	\N	0	0	\N	\N	0	119204	0	23426006	4052083		
102204	3141	4052083	1984-08-02	1984-08-02 00:00:00	1984-08-02	5001	0	\N	0	0	\N	\N	0	209001	0	23426006	4052083		
22621	2075	3036780	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	138131	0	6095-4	3036780		
50778	4628	3019406	1986-10-24	1986-10-24 00:00:00	1986-10-24	5001	0	\N	0	0	\N	\N	0	308311	0	6158-0	3019406		
50832	4636	3006322	1956-05-28	1956-05-28 00:00:00	1956-05-28	5001	0	\N	0	0	\N	\N	0	308932	0	8331-1	3006322		
17097	1556	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	104226	0	7258-7	3001488		
173943	5334	4052083	1970-10-25	1970-10-25 00:00:00	1970-10-25	5001	0	\N	0	0	\N	\N	0	355204	0	23426006	4052083		
45824	4224	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	280540	0	6206-7	3012494		
27351	2537	3001247	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	167725	0	6085-5	3001247		
2355	222	3006322	1967-11-30	1967-11-30 00:00:00	1967-11-30	5001	0	\N	0	0	\N	\N	0	14883	0	8331-1	3006322		
2431	232	3049273	2016-03-05	2016-03-05 00:00:00	2016-03-05	5001	0	\N	0	0	\N	\N	0	15620	0	38265-5	3049273		
159433	4899	4133840	1972-06-13	1972-06-13 00:00:00	1972-06-13	5001	0	\N	0	0	\N	\N	0	325793	0	127783003	4133840		
50547	4608	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	307006	0	6158-0	3019406		
36516	3355	3006322	1969-06-16	1969-06-16 00:00:00	1969-06-16	5001	0	\N	0	0	\N	\N	0	222493	0	8331-1	3006322		
47839	4380	3006322	2002-09-09	2002-09-09 00:00:00	2002-09-09	5001	0	\N	0	0	\N	\N	0	291024	0	8331-1	3006322		
4206	418	40758406	1966-11-20	1966-11-20 00:00:00	1966-11-20	5001	0	\N	0	0	\N	\N	0	27597	0	55277-8	40758406		
5203	499	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	33423	0	6844-5	3020655		
8690	842	3011505	1973-12-01	1973-12-01 00:00:00	1973-12-01	5001	0	\N	0	0	\N	\N	0	55746	0	19926-5	3011505		
119944	3698	4024958	1975-11-28	1975-11-28 00:00:00	1975-11-28	5001	0	\N	0	0	\N	\N	0	245853	0	117015009	4024958		
20122	1844	3006322	1964-04-24	1964-04-24 00:00:00	1964-04-24	5001	0	\N	0	0	\N	\N	0	123191	0	8331-1	3006322		
7393	709	3006322	1950-09-27	1950-09-27 00:00:00	1950-09-27	5001	0	\N	0	0	\N	\N	0	46956	0	8331-1	3006322		
49392	4506	40758406	2003-04-01	2003-04-01 00:00:00	2003-04-01	5001	0	\N	0	0	\N	\N	0	300209	0	55277-8	40758406		
5308	160	4052083	1980-01-14	1980-01-14 00:00:00	1980-01-14	5001	0	\N	0	0	\N	\N	0	10945	0	23426006	4052083		
14660	1361	3006322	1994-12-18	1994-12-18 00:00:00	1994-12-18	5001	0	\N	0	0	\N	\N	0	90327	0	8331-1	3006322		
97297	2976	4133840	2014-07-17	2014-07-17 00:00:00	2014-07-17	5001	0	\N	0	0	\N	\N	0	198765	0	127783003	4133840		
44623	4121	40758406	1921-07-17	1921-07-17 00:00:00	1921-07-17	5001	0	\N	0	0	\N	\N	0	273934	0	55277-8	40758406		
44716	4130	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	274581	0	6276-0	3027231		
30652	2813	3006322	1944-09-17	1944-09-17 00:00:00	1944-09-17	5001	0	\N	0	0	\N	\N	0	186407	0	8331-1	3006322		
39641	1231	4024958	1989-06-27	1989-06-27 00:00:00	1989-06-27	5001	0	\N	0	0	\N	\N	0	81096	0	117015009	4024958		
28066	2578	3006322	1988-11-09	1988-11-09 00:00:00	1988-11-09	5001	0	\N	0	0	\N	\N	0	170740	0	8331-1	3006322		
55416	5081	3006322	1954-03-09	1954-03-09 00:00:00	1954-03-09	5001	0	\N	0	0	\N	\N	0	337846	0	8331-1	3006322		
12037	1143	3006322	2004-05-19	2004-05-19 00:00:00	2004-05-19	5001	0	\N	0	0	\N	\N	0	75421	0	8331-1	3006322		
35461	3244	40766240	1976-09-14	1976-09-14 00:00:00	1976-09-14	5001	0	\N	0	0	\N	\N	0	215687	0	63513-6	40766240		
35882	3295	3006322	1975-04-20	1975-04-20 00:00:00	1975-04-20	5001	0	\N	0	0	\N	\N	0	218884	0	8331-1	3006322		
41343	3857	3011505	1999-07-13	1999-07-13 00:00:00	1999-07-13	5001	0	\N	0	0	\N	\N	0	255994	0	19926-5	3011505		
24301	758	4024958	1985-05-23	1985-05-23 00:00:00	1985-05-23	5001	0	\N	0	0	\N	\N	0	50300	0	117015009	4024958		
47636	4374	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	290459	0	6206-7	3012494		
19491	1782	3010813	1956-01-11	1956-01-11 00:00:00	1956-01-11	5001	0	\N	0	0	\N	\N	0	119339	0	26464-8	3010813		
51594	4724	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	314724	0	6189-5	3006734		
51660	4725	3014599	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	314890	0	6106-9	3014599		
3945	124	4133840	2014-03-25	2014-03-25 00:00:00	2014-03-25	5001	0	\N	0	0	\N	\N	0	8273	0	127783003	4133840		
173609	5325	4024958	2009-02-28	2009-02-28 00:00:00	2009-02-28	5001	0	\N	0	0	\N	\N	0	354494	0	117015009	4024958		
117503	3621	4133840	1975-08-09	1975-08-09 00:00:00	1975-08-09	5001	0	\N	0	0	\N	\N	0	240653	0	127783003	4133840		
73721	2266	4024958	1996-05-09	1996-05-09 00:00:00	1996-05-09	5001	0	\N	0	0	\N	\N	0	150642	0	117015009	4024958		
54341	4970	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	330495	0	6082-2	3000876		
6473	609	3006322	1980-11-21	1980-11-21 00:00:00	1980-11-21	5001	0	\N	0	0	\N	\N	0	40416	0	8331-1	3006322		
21279	1967	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	130747	0	6189-5	3006734		
21558	1989	3006322	1954-02-05	1954-02-05 00:00:00	1954-02-05	5001	0	\N	0	0	\N	\N	0	132421	0	8331-1	3006322		
32676	2961	3006322	1978-04-25	1978-04-25 00:00:00	1978-04-25	5001	0	\N	0	0	\N	\N	0	197748	0	8331-1	3006322		
30048	929	4052083	1963-08-24	1963-08-24 00:00:00	1963-08-24	5001	0	\N	0	0	\N	\N	0	61808	0	23426006	4052083		
13183	1259	3021226	1981-04-14	1981-04-14 00:00:00	1981-04-14	5001	0	\N	0	0	\N	\N	0	82942	0	6246-3	3021226		
97740	2988	4052083	2002-10-22	2002-10-22 00:00:00	2002-10-22	5001	0	\N	0	0	\N	\N	0	199471	0	23426006	4052083		
40885	3793	40758406	1940-08-29	1940-08-29 00:00:00	1940-08-29	5001	0	\N	0	0	\N	\N	0	252257	0	55277-8	40758406		
109014	3367	4024958	1965-12-19	1965-12-19 00:00:00	1965-12-19	5001	0	\N	0	0	\N	\N	0	223299	0	117015009	4024958		
29886	923	4024958	2014-01-05	2014-01-05 00:00:00	2014-01-05	5001	0	\N	0	0	\N	\N	0	61477	0	117015009	4024958		
29244	2693	3051031	2013-11-29	2013-11-29 00:00:00	2013-11-29	5001	0	\N	0	0	\N	\N	0	178408	0	46240-8	3051031		
46282	1411	4024958	1967-05-27	1967-05-27 00:00:00	1967-05-27	5001	0	\N	0	0	\N	\N	0	93963	0	117015009	4024958		
30564	949	4133840	2005-10-24	2005-10-24 00:00:00	2005-10-24	5001	0	\N	0	0	\N	\N	0	62999	0	127783003	4133840		
14397	1345	46235214	1992-04-07	1992-04-07 00:00:00	1992-04-07	5001	0	\N	0	0	\N	\N	0	89125	0	76690-7	46235214		
12402	399	4024958	1962-02-22	1962-02-22 00:00:00	1962-02-22	5001	0	\N	0	0	\N	\N	0	26161	0	117015009	4024958		
25810	2369	3019406	1982-01-16	1982-01-16 00:00:00	1982-01-16	5001	0	\N	0	0	\N	\N	0	157671	0	6158-0	3019406		
108129	3342	4052083	1927-06-04	1927-06-04 00:00:00	1927-06-04	5001	0	\N	0	0	\N	\N	0	221588	0	23426006	4052083		
61995	1900	4024958	1990-01-16	1990-01-16 00:00:00	1990-01-16	5001	0	\N	0	0	\N	\N	0	126459	0	117015009	4024958		
8148	774	3006322	1969-12-08	1969-12-08 00:00:00	1969-12-08	5001	0	\N	0	0	\N	\N	0	51392	0	8331-1	3006322		
69838	2140	4052083	1963-06-21	1963-06-21 00:00:00	1963-06-21	5001	0	\N	0	0	\N	\N	0	142529	0	23426006	4052083		
102205	3141	4052083	1979-08-25	1979-08-25 00:00:00	1979-08-25	5001	0	\N	0	0	\N	\N	0	208965	0	23426006	4052083		
22622	2075	3000876	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	138131	0	6082-2	3000876		
50779	4628	3012494	1986-10-24	1986-10-24 00:00:00	1986-10-24	5001	0	\N	0	0	\N	\N	0	308311	0	6206-7	3012494		
50833	4636	3006322	2000-11-14	2000-11-14 00:00:00	2000-11-14	5001	0	\N	0	0	\N	\N	0	308969	0	8331-1	3006322		
17098	1556	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	104226	0	6082-2	3000876		
173944	5334	4052083	2018-12-07	2018-12-07 00:00:00	2018-12-07	5001	0	\N	0	0	\N	\N	0	355180	0	23426006	4052083		
57106	5245	3023430	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	348961	0	6833-8	3023430		
27352	2537	3021226	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	167725	0	6246-3	3021226		
2359	224	3049273	2009-07-24	2009-07-24 00:00:00	2009-07-24	5001	0	\N	0	0	\N	\N	0	15110	0	38265-5	3049273		
2439	235	3006322	1986-04-19	1986-04-19 00:00:00	1986-04-19	5001	0	\N	0	0	\N	\N	0	15778	0	8331-1	3006322		
159434	4899	4024958	1933-01-03	1933-01-03 00:00:00	1933-01-03	5001	0	\N	0	0	\N	\N	0	325766	0	117015009	4024958		
50548	4608	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	307006	0	6075-6	3005136		
47794	4376	46235214	2012-07-28	2012-07-28 00:00:00	2012-07-28	5001	0	\N	0	0	\N	\N	0	290723	0	76690-7	46235214		
47840	4380	3006322	1994-06-08	1994-06-08 00:00:00	1994-06-08	5001	0	\N	0	0	\N	\N	0	291041	0	8331-1	3006322		
4207	418	40766240	1966-11-20	1966-11-20 00:00:00	1966-11-20	5001	0	\N	0	0	\N	\N	0	27597	0	63513-6	40766240		
5204	499	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	33423	0	6833-8	3023430		
8691	842	3011505	2016-10-29	2016-10-29 00:00:00	2016-10-29	5001	0	\N	0	0	\N	\N	0	55704	0	19926-5	3011505		
62927	1933	4024958	1963-06-07	1963-06-07 00:00:00	1963-06-07	5001	0	\N	0	0	\N	\N	0	128549	0	117015009	4024958		
20123	1844	40766240	1986-07-29	1986-07-29 00:00:00	1986-07-29	5001	0	\N	0	0	\N	\N	0	123163	0	63513-6	40766240		
7394	710	3006322	1969-10-21	1969-10-21 00:00:00	1969-10-21	5001	0	\N	0	0	\N	\N	0	47036	0	8331-1	3006322		
49393	4506	3051031	2003-04-01	2003-04-01 00:00:00	2003-04-01	5001	0	\N	0	0	\N	\N	0	300209	0	46240-8	3051031		
5313	160	4024958	2016-09-06	2016-09-06 00:00:00	2016-09-06	5001	0	\N	0	0	\N	\N	0	10965	0	117015009	4024958		
14661	1361	3006322	1955-09-06	1955-09-06 00:00:00	1955-09-06	5001	0	\N	0	0	\N	\N	0	90366	0	8331-1	3006322		
97298	2976	4133840	2012-11-15	2012-11-15 00:00:00	2012-11-15	5001	0	\N	0	0	\N	\N	0	198750	0	127783003	4133840		
44624	4121	40766240	1921-07-17	1921-07-17 00:00:00	1921-07-17	5001	0	\N	0	0	\N	\N	0	273934	0	63513-6	40766240		
44717	4130	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	274581	0	6158-0	3019406		
30653	2813	3006322	1942-03-18	1942-03-18 00:00:00	1942-03-18	5001	0	\N	0	0	\N	\N	0	186368	0	8331-1	3006322		
39646	1231	4024958	2002-05-13	2002-05-13 00:00:00	2002-05-13	5001	0	\N	0	0	\N	\N	0	81109	0	117015009	4024958		
28067	2579	3006322	1962-11-13	1962-11-13 00:00:00	1962-11-13	5001	0	\N	0	0	\N	\N	0	170846	0	8331-1	3006322		
55417	5081	3006322	1994-04-08	1994-04-08 00:00:00	1994-04-08	5001	0	\N	0	0	\N	\N	0	337833	0	8331-1	3006322		
12038	1143	3006322	1982-12-11	1982-12-11 00:00:00	1982-12-11	5001	0	\N	0	0	\N	\N	0	75440	0	8331-1	3006322		
35462	3244	46235214	1976-09-14	1976-09-14 00:00:00	1976-09-14	5001	0	\N	0	0	\N	\N	0	215687	0	76690-7	46235214		
35883	3295	3051031	1952-09-05	1952-09-05 00:00:00	1952-09-05	5001	0	\N	0	0	\N	\N	0	218966	0	46240-8	3051031		
41344	3857	3011505	1985-12-31	1985-12-31 00:00:00	1985-12-31	5001	0	\N	0	0	\N	\N	0	255975	0	19926-5	3011505		
24315	759	4052083	2005-07-25	2005-07-25 00:00:00	2005-07-25	5001	0	\N	0	0	\N	\N	0	50393	0	23426006	4052083		
47637	4374	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	290459	0	6246-3	3021226		
19492	1782	3026361	1956-01-11	1956-01-11 00:00:00	1956-01-11	5001	0	\N	0	0	\N	\N	0	119339	0	26453-1	3026361		
51595	4724	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	314724	0	6276-0	3027231		
51661	4725	3006734	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	314890	0	6189-5	3006734		
3961	124	4024958	1992-02-26	1992-02-26 00:00:00	1992-02-26	5001	0	\N	0	0	\N	\N	0	8316	0	117015009	4024958		
1	1	3006322	1991-01-31	1991-01-31 00:00:00	1991-01-31	5001	0	\N	0	0	\N	\N	0	45	0	8331-1	3006322		
117504	3621	4133840	1972-07-22	1972-07-22 00:00:00	1972-07-22	5001	0	\N	0	0	\N	\N	0	240576	0	127783003	4133840		
33517	1046	4052083	1980-09-19	1980-09-19 00:00:00	1980-09-19	5001	0	\N	0	0	\N	\N	0	68674	0	23426006	4052083		
54342	4970	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	330495	0	6189-5	3006734		
6474	609	3006322	1974-08-11	1974-08-11 00:00:00	1974-08-11	5001	0	\N	0	0	\N	\N	0	40415	0	8331-1	3006322		
21280	1967	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	130747	0	6095-4	3036780		
21559	1989	3006322	1976-02-20	1976-02-20 00:00:00	1976-02-20	5001	0	\N	0	0	\N	\N	0	132443	0	8331-1	3006322		
32677	2961	3006322	1982-12-12	1982-12-12 00:00:00	1982-12-12	5001	0	\N	0	0	\N	\N	0	197751	0	8331-1	3006322		
169023	5189	4052083	1970-04-05	1970-04-05 00:00:00	1970-04-05	5001	0	\N	0	0	\N	\N	0	344903	0	23426006	4052083		
13184	1259	3006451	1981-04-14	1981-04-14 00:00:00	1981-04-14	5001	0	\N	0	0	\N	\N	0	82942	0	6273-7	3006451		
97742	2988	4024958	1998-06-10	1998-06-10 00:00:00	1998-06-10	5001	0	\N	0	0	\N	\N	0	199442	0	117015009	4024958		
40886	3793	3006322	2014-07-31	2014-07-31 00:00:00	2014-07-31	5001	0	\N	0	0	\N	\N	0	252185	0	8331-1	3006322		
109018	3367	4052083	2000-08-18	2000-08-18 00:00:00	2000-08-18	5001	0	\N	0	0	\N	\N	0	223309	0	23426006	4052083		
29893	923	4024958	1978-02-06	1978-02-06 00:00:00	1978-02-06	5001	0	\N	0	0	\N	\N	0	61420	0	117015009	4024958		
29246	2693	46235214	2013-11-29	2013-11-29 00:00:00	2013-11-29	5001	0	\N	0	0	\N	\N	0	178408	0	76690-7	46235214		
35044	1091	4024958	2017-02-26	2017-02-26 00:00:00	2017-02-26	5001	0	\N	0	0	\N	\N	0	71650	0	117015009	4024958		
53386	4899	3006322	1994-05-12	1994-05-12 00:00:00	1994-05-12	5001	0	\N	0	0	\N	\N	0	325805	0	8331-1	3006322		
14405	1348	3006322	1963-11-30	1963-11-30 00:00:00	1963-11-30	5001	0	\N	0	0	\N	\N	0	89337	0	8331-1	3006322		
74484	2286	4024958	1998-01-28	1998-01-28 00:00:00	1998-01-28	5001	0	\N	0	0	\N	\N	0	152068	0	117015009	4024958		
25811	2369	3001247	1982-01-16	1982-01-16 00:00:00	1982-01-16	5001	0	\N	0	0	\N	\N	0	157671	0	6085-5	3001247		
7383	235	4024958	1988-10-19	1988-10-19 00:00:00	1988-10-19	5001	0	\N	0	0	\N	\N	0	15770	0	117015009	4024958		
62004	1900	4024958	1964-02-07	1964-02-07 00:00:00	1964-02-07	5001	0	\N	0	0	\N	\N	0	126457	0	117015009	4024958		
8149	775	3006322	1964-02-04	1964-02-04 00:00:00	1964-02-04	5001	0	\N	0	0	\N	\N	0	51419	0	8331-1	3006322		
69840	2140	4024958	1980-01-01	1980-01-01 00:00:00	1980-01-01	5001	0	\N	0	0	\N	\N	0	142506	0	117015009	4024958		
102209	3141	4052083	1987-09-11	1987-09-11 00:00:00	1987-09-11	5001	0	\N	0	0	\N	\N	0	208994	0	23426006	4052083		
22623	2075	3006451	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	138131	0	6273-7	3006451		
50780	4628	3021226	1986-10-24	1986-10-24 00:00:00	1986-10-24	5001	0	\N	0	0	\N	\N	0	308311	0	6246-3	3021226		
50834	4636	3049273	2006-08-15	2006-08-15 00:00:00	2006-08-15	5001	0	\N	0	0	\N	\N	0	308943	0	38265-5	3049273		
17099	1556	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	104226	0	6246-3	3021226		
173957	5335	4024958	1973-05-07	1973-05-07 00:00:00	1973-05-07	5001	0	\N	0	0	\N	\N	0	355303	0	117015009	4024958		
57107	5245	3014599	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	348961	0	6106-9	3014599		
27353	2537	3001488	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	167725	0	7258-7	3001488		
2360	224	3006322	1992-02-07	1992-02-07 00:00:00	1992-02-07	5001	0	\N	0	0	\N	\N	0	15086	0	8331-1	3006322		
2440	235	3006322	1991-04-04	1991-04-04 00:00:00	1991-04-04	5001	0	\N	0	0	\N	\N	0	15782	0	8331-1	3006322		
159437	4899	4024958	1925-02-02	1925-02-02 00:00:00	1925-02-02	5001	0	\N	0	0	\N	\N	0	325765	0	117015009	4024958		
50549	4608	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	307006	0	6248-9	3015076		
47795	4376	3011505	1982-07-20	1982-07-20 00:00:00	1982-07-20	5001	0	\N	0	0	\N	\N	0	290702	0	19926-5	3011505		
47841	4380	3006322	1986-04-28	1986-04-28 00:00:00	1986-04-28	5001	0	\N	0	0	\N	\N	0	291021	0	8331-1	3006322		
4209	418	3051031	1966-10-21	1966-10-21 00:00:00	1966-10-21	5001	0	\N	0	0	\N	\N	0	27606	0	46240-8	3051031		
5205	499	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	33423	0	6085-5	3001247		
8692	842	3011505	1954-12-25	1954-12-25 00:00:00	1954-12-25	5001	0	\N	0	0	\N	\N	0	55757	0	19926-5	3011505		
62928	1933	4052083	1980-12-02	1980-12-02 00:00:00	1980-12-02	5001	0	\N	0	0	\N	\N	0	128546	0	23426006	4052083		
20124	1844	40758406	1986-07-29	1986-07-29 00:00:00	1986-07-29	5001	0	\N	0	0	\N	\N	0	123163	0	55277-8	40758406		
7395	710	3000963	1964-04-17	1964-04-17 00:00:00	1964-04-17	5001	0	\N	0	0	\N	\N	0	47041	0	718-7	3000963		
49394	4506	40766240	2012-09-20	2012-09-20 00:00:00	2012-09-20	5001	0	\N	0	0	\N	\N	0	300182	0	63513-6	40766240		
5327	161	4052083	1978-02-24	1978-02-24 00:00:00	1978-02-24	5001	0	\N	0	0	\N	\N	0	11045	0	23426006	4052083		
14662	1361	3006322	1951-11-01	1951-11-01 00:00:00	1951-11-01	5001	0	\N	0	0	\N	\N	0	90369	0	8331-1	3006322		
97302	2976	4133840	2011-11-10	2011-11-10 00:00:00	2011-11-10	5001	0	\N	0	0	\N	\N	0	198764	0	127783003	4133840		
44625	4121	3051031	1921-07-17	1921-07-17 00:00:00	1921-07-17	5001	0	\N	0	0	\N	\N	0	273934	0	46240-8	3051031		
44718	4130	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	274581	0	6273-7	3006451		
30654	2813	3049273	2015-07-18	2015-07-18 00:00:00	2015-07-18	5001	0	\N	0	0	\N	\N	0	186417	0	38265-5	3049273		
39661	1231	4052083	1960-07-15	1960-07-15 00:00:00	1960-07-15	5001	0	\N	0	0	\N	\N	0	81153	0	23426006	4052083		
28068	2579	3006322	1956-05-01	1956-05-01 00:00:00	1956-05-01	5001	0	\N	0	0	\N	\N	0	170769	0	8331-1	3006322		
55418	5081	3006322	1974-04-27	1974-04-27 00:00:00	1974-04-27	5001	0	\N	0	0	\N	\N	0	337911	0	8331-1	3006322		
12040	1143	40758406	1972-07-26	1972-07-26 00:00:00	1972-07-26	5001	0	\N	0	0	\N	\N	0	75400	0	55277-8	40758406		
35463	3244	3051031	1976-09-14	1976-09-14 00:00:00	1976-09-14	5001	0	\N	0	0	\N	\N	0	215687	0	46240-8	3051031		
35884	3295	40758406	1952-09-05	1952-09-05 00:00:00	1952-09-05	5001	0	\N	0	0	\N	\N	0	218966	0	55277-8	40758406		
41345	3857	3011505	1997-01-21	1997-01-21 00:00:00	1997-01-21	5001	0	\N	0	0	\N	\N	0	256001	0	19926-5	3011505		
24336	759	4024958	1980-08-22	1980-08-22 00:00:00	1980-08-22	5001	0	\N	0	0	\N	\N	0	50445	0	117015009	4024958		
47638	4374	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	290459	0	6075-6	3005136		
19493	1782	3015632	1956-01-11	1956-01-11 00:00:00	1956-01-11	5001	0	\N	0	0	\N	\N	0	119339	0	2028-9	3015632		
111014	3431	4024958	1972-05-01	1972-05-01 00:00:00	1972-05-01	5001	0	\N	0	0	\N	\N	0	227458	0	117015009	4024958		
51662	4725	3006451	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	314890	0	6273-7	3006451		
3975	124	4024958	1992-04-07	1992-04-07 00:00:00	1992-04-07	5001	0	\N	0	0	\N	\N	0	8299	0	117015009	4024958		
2	1	3006322	1961-07-05	1961-07-05 00:00:00	1961-07-05	5001	0	\N	0	0	\N	\N	0	22	0	8331-1	3006322		
117508	3621	4133840	1992-05-16	1992-05-16 00:00:00	1992-05-16	5001	0	\N	0	0	\N	\N	0	240604	0	127783003	4133840		
33518	1046	4024958	1980-02-07	1980-02-07 00:00:00	1980-02-07	5001	0	\N	0	0	\N	\N	0	68673	0	117015009	4024958		
54343	4970	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	330495	0	6158-0	3019406		
6475	610	3006322	1973-08-27	1973-08-27 00:00:00	1973-08-27	5001	0	\N	0	0	\N	\N	0	40578	0	8331-1	3006322		
21281	1967	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	130747	0	6248-9	3015076		
21560	1989	3006322	1976-05-30	1976-05-30 00:00:00	1976-05-30	5001	0	\N	0	0	\N	\N	0	132444	0	8331-1	3006322		
32678	2961	3006322	1985-05-14	1985-05-14 00:00:00	1985-05-14	5001	0	\N	0	0	\N	\N	0	197709	0	8331-1	3006322		
169024	5189	4024958	1962-08-16	1962-08-16 00:00:00	1962-08-16	5001	0	\N	0	0	\N	\N	0	344901	0	117015009	4024958		
13185	1259	3015076	1981-04-14	1981-04-14 00:00:00	1981-04-14	5001	0	\N	0	0	\N	\N	0	82942	0	6248-9	3015076		
97748	2988	4024958	1974-01-20	1974-01-20 00:00:00	1974-01-20	5001	0	\N	0	0	\N	\N	0	199482	0	117015009	4024958		
40887	3793	3006322	2002-02-06	2002-02-06 00:00:00	2002-02-06	5001	0	\N	0	0	\N	\N	0	252183	0	8331-1	3006322		
109020	3367	4024958	1977-10-11	1977-10-11 00:00:00	1977-10-11	5001	0	\N	0	0	\N	\N	0	223307	0	117015009	4024958		
41186	1276	4052083	1967-03-18	1967-03-18 00:00:00	1967-03-18	5001	0	\N	0	0	\N	\N	0	84273	0	23426006	4052083		
29247	2693	40766240	2013-11-29	2013-11-29 00:00:00	2013-11-29	5001	0	\N	0	0	\N	\N	0	178408	0	63513-6	40766240		
35049	1091	4052083	1973-12-25	1973-12-25 00:00:00	1973-12-25	5001	0	\N	0	0	\N	\N	0	71679	0	23426006	4052083		
53387	4899	3011505	1997-11-04	1997-11-04 00:00:00	1997-11-04	5001	0	\N	0	0	\N	\N	0	325833	0	19926-5	3011505		
14406	1348	3006322	1914-06-18	1914-06-18 00:00:00	1914-06-18	5001	0	\N	0	0	\N	\N	0	89331	0	8331-1	3006322		
74492	2286	4024958	1972-04-17	1972-04-17 00:00:00	1972-04-17	5001	0	\N	0	0	\N	\N	0	152076	0	117015009	4024958		
25812	2369	3023430	1982-01-16	1982-01-16 00:00:00	1982-01-16	5001	0	\N	0	0	\N	\N	0	157671	0	6833-8	3023430		
7420	236	4024958	1955-02-01	1955-02-01 00:00:00	1955-02-01	5001	0	\N	0	0	\N	\N	0	15940	0	117015009	4024958		
62012	1900	4052083	2017-08-26	2017-08-26 00:00:00	2017-08-26	5001	0	\N	0	0	\N	\N	0	126456	0	23426006	4052083		
8150	775	3006322	2002-01-11	2002-01-11 00:00:00	2002-01-11	5001	0	\N	0	0	\N	\N	0	51407	0	8331-1	3006322		
69858	2140	4052083	1998-03-20	1998-03-20 00:00:00	1998-03-20	5001	0	\N	0	0	\N	\N	0	142488	0	23426006	4052083		
113489	3505	4024958	1959-11-13	1959-11-13 00:00:00	1959-11-13	5001	0	\N	0	0	\N	\N	0	232465	0	117015009	4024958		
22624	2075	3021226	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	138131	0	6246-3	3021226		
50781	4628	3006451	1986-10-24	1986-10-24 00:00:00	1986-10-24	5001	0	\N	0	0	\N	\N	0	308311	0	6273-7	3006451		
50835	4636	3006322	2003-07-14	2003-07-14 00:00:00	2003-07-14	5001	0	\N	0	0	\N	\N	0	308934	0	8331-1	3006322		
17100	1556	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	104226	0	6248-9	3015076		
173981	5335	4024958	2001-07-01	2001-07-01 00:00:00	2001-07-01	5001	0	\N	0	0	\N	\N	0	355262	0	117015009	4024958		
57108	5245	3020655	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	348961	0	6844-5	3020655		
27354	2537	3012494	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	167725	0	6206-7	3012494		
2361	224	3006322	1945-05-02	1945-05-02 00:00:00	1945-05-02	5001	0	\N	0	0	\N	\N	0	15043	0	8331-1	3006322		
2441	235	3006322	1988-10-19	1988-10-19 00:00:00	1988-10-19	5001	0	\N	0	0	\N	\N	0	15770	0	8331-1	3006322		
159439	4899	4133840	1989-09-19	1989-09-19 00:00:00	1989-09-19	5001	0	\N	0	0	\N	\N	0	325846	0	127783003	4133840		
50550	4608	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	307006	0	6082-2	3000876		
47797	4376	46235214	1947-11-17	1947-11-17 00:00:00	1947-11-17	5001	0	\N	0	0	\N	\N	0	290709	0	76690-7	46235214		
47842	4381	3006322	1980-11-19	1980-11-19 00:00:00	1980-11-19	5001	0	\N	0	0	\N	\N	0	291105	0	8331-1	3006322		
4210	418	46235214	1966-10-21	1966-10-21 00:00:00	1966-10-21	5001	0	\N	0	0	\N	\N	0	27606	0	76690-7	46235214		
5206	499	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	33423	0	6189-5	3006734		
8693	842	3011505	1959-01-03	1959-01-03 00:00:00	1959-01-03	5001	0	\N	0	0	\N	\N	0	55742	0	19926-5	3011505		
62945	1933	4024958	1968-06-25	1968-06-25 00:00:00	1968-06-25	5001	0	\N	0	0	\N	\N	0	128545	0	117015009	4024958		
20125	1844	46235214	1986-07-29	1986-07-29 00:00:00	1986-07-29	5001	0	\N	0	0	\N	\N	0	123163	0	76690-7	46235214		
7396	710	3009542	1964-04-17	1964-04-17 00:00:00	1964-04-17	5001	0	\N	0	0	\N	\N	0	47041	0	20570-8	3009542		
49395	4506	3051031	2012-09-20	2012-09-20 00:00:00	2012-09-20	5001	0	\N	0	0	\N	\N	0	300182	0	46240-8	3051031		
5332	161	4052083	2016-01-19	2016-01-19 00:00:00	2016-01-19	5001	0	\N	0	0	\N	\N	0	11048	0	23426006	4052083		
14663	1361	3006322	1980-10-06	1980-10-06 00:00:00	1980-10-06	5001	0	\N	0	0	\N	\N	0	90345	0	8331-1	3006322		
97303	2976	4133840	1987-03-12	1987-03-12 00:00:00	1987-03-12	5001	0	\N	0	0	\N	\N	0	198772	0	127783003	4133840		
44627	4121	46235214	1921-07-17	1921-07-17 00:00:00	1921-07-17	5001	0	\N	0	0	\N	\N	0	273934	0	76690-7	46235214		
44719	4130	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	274581	0	6075-6	3005136		
30655	2813	3006322	1947-05-21	1947-05-21 00:00:00	1947-05-21	5001	0	\N	0	0	\N	\N	0	186408	0	8331-1	3006322		
39665	1231	4024958	1955-04-11	1955-04-11 00:00:00	1955-04-11	5001	0	\N	0	0	\N	\N	0	81151	0	117015009	4024958		
28069	2579	3006322	1968-12-24	1968-12-24 00:00:00	1968-12-24	5001	0	\N	0	0	\N	\N	0	170847	0	8331-1	3006322		
55419	5081	3006322	1944-05-21	1944-05-21 00:00:00	1944-05-21	5001	0	\N	0	0	\N	\N	0	337845	0	8331-1	3006322		
12041	1143	3051031	1972-07-26	1972-07-26 00:00:00	1972-07-26	5001	0	\N	0	0	\N	\N	0	75400	0	46240-8	3051031		
35465	3244	40769194	1991-04-24	1991-04-24 00:00:00	1991-04-24	5001	0	\N	0	0	\N	\N	0	215718	0	66534-9	40769194		
35885	3295	46235214	1952-09-05	1952-09-05 00:00:00	1952-09-05	5001	0	\N	0	0	\N	\N	0	218966	0	76690-7	46235214		
41346	3857	3011505	1992-01-14	1992-01-14 00:00:00	1992-01-14	5001	0	\N	0	0	\N	\N	0	255992	0	19926-5	3011505		
24342	759	4024958	1947-05-25	1947-05-25 00:00:00	1947-05-25	5001	0	\N	0	0	\N	\N	0	50432	0	117015009	4024958		
47639	4374	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	290459	0	6106-9	3014599		
19494	1782	3006923	1956-01-11	1956-01-11 00:00:00	1956-01-11	5001	0	\N	0	0	\N	\N	0	119339	0	1742-6	3006923		
111019	3431	4024958	1968-09-23	1968-09-23 00:00:00	1968-09-23	5001	0	\N	0	0	\N	\N	0	227447	0	117015009	4024958		
51663	4725	3015076	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	314890	0	6248-9	3015076		
3983	124	4133840	2017-03-28	2017-03-28 00:00:00	2017-03-28	5001	0	\N	0	0	\N	\N	0	8274	0	127783003	4133840		
3	1	3006322	1953-02-06	1953-02-06 00:00:00	1953-02-06	5001	0	\N	0	0	\N	\N	0	41	0	8331-1	3006322		
117518	3621	4133840	1983-09-24	1983-09-24 00:00:00	1983-09-24	5001	0	\N	0	0	\N	\N	0	240578	0	127783003	4133840		
33522	1046	4024958	2002-12-31	2002-12-31 00:00:00	2002-12-31	5001	0	\N	0	0	\N	\N	0	68661	0	117015009	4024958		
54344	4970	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	330495	0	6206-7	3012494		
6476	610	3006322	1996-12-26	1996-12-26 00:00:00	1996-12-26	5001	0	\N	0	0	\N	\N	0	40554	0	8331-1	3006322		
21282	1967	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	130747	0	6273-7	3006451		
21561	1990	3006322	2002-11-28	2002-11-28 00:00:00	2002-11-28	5001	0	\N	0	0	\N	\N	0	132487	0	8331-1	3006322		
32694	2965	3014599	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	197968	0	6106-9	3014599		
169039	5190	4024958	2006-07-19	2006-07-19 00:00:00	2006-07-19	5001	0	\N	0	0	\N	\N	0	345044	0	117015009	4024958		
13186	1259	3019406	1981-04-14	1981-04-14 00:00:00	1981-04-14	5001	0	\N	0	0	\N	\N	0	82942	0	6158-0	3019406		
97756	2988	4024958	2011-10-04	2011-10-04 00:00:00	2011-10-04	5001	0	\N	0	0	\N	\N	0	199444	0	117015009	4024958		
40888	3793	40758406	1942-09-23	1942-09-23 00:00:00	1942-09-23	5001	0	\N	0	0	\N	\N	0	252258	0	55277-8	40758406		
109022	3367	4024958	1967-07-23	1967-07-23 00:00:00	1967-07-23	5001	0	\N	0	0	\N	\N	0	223297	0	117015009	4024958		
41190	1276	4024958	1967-09-10	1967-09-10 00:00:00	1967-09-10	5001	0	\N	0	0	\N	\N	0	84139	0	117015009	4024958		
29249	2693	40758406	2014-01-28	2014-01-28 00:00:00	2014-01-28	5001	0	\N	0	0	\N	\N	0	178377	0	55277-8	40758406		
35059	1092	4024958	1989-04-21	1989-04-21 00:00:00	1989-04-21	5001	0	\N	0	0	\N	\N	0	71752	0	117015009	4024958		
53389	4899	3006322	1996-02-28	1996-02-28 00:00:00	1996-02-28	5001	0	\N	0	0	\N	\N	0	325840	0	8331-1	3006322		
14407	1348	3006322	1997-11-11	1997-11-11 00:00:00	1997-11-11	5001	0	\N	0	0	\N	\N	0	89297	0	8331-1	3006322		
74496	2286	4024958	1980-10-17	1980-10-17 00:00:00	1980-10-17	5001	0	\N	0	0	\N	\N	0	152025	0	117015009	4024958		
25813	2369	3015076	1982-01-16	1982-01-16 00:00:00	1982-01-16	5001	0	\N	0	0	\N	\N	0	157671	0	6248-9	3015076		
38066	3513	3006322	2002-10-17	2002-10-17 00:00:00	2002-10-17	5001	0	\N	0	0	\N	\N	0	233142	0	8331-1	3006322		
62015	1900	4024958	2006-11-29	2006-11-29 00:00:00	2006-11-29	5001	0	\N	0	0	\N	\N	0	126477	0	117015009	4024958		
8151	775	3006322	1987-06-14	1987-06-14 00:00:00	1987-06-14	5001	0	\N	0	0	\N	\N	0	51422	0	8331-1	3006322		
69872	2140	4052083	1962-10-08	1962-10-08 00:00:00	1962-10-08	5001	0	\N	0	0	\N	\N	0	142560	0	23426006	4052083		
113510	3505	4052083	2018-04-28	2018-04-28 00:00:00	2018-04-28	5001	0	\N	0	0	\N	\N	0	232415	0	23426006	4052083		
22625	2075	3012494	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	138131	0	6206-7	3012494		
50782	4628	3027231	1986-10-24	1986-10-24 00:00:00	1986-10-24	5001	0	\N	0	0	\N	\N	0	308311	0	6276-0	3027231		
50836	4637	3006322	1991-05-30	1991-05-30 00:00:00	1991-05-30	5001	0	\N	0	0	\N	\N	0	309022	0	8331-1	3006322		
17101	1556	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	104226	0	6158-0	3019406		
163067	5005	4052083	2013-12-08	2013-12-08 00:00:00	2013-12-08	5001	0	\N	0	0	\N	\N	0	332931	0	23426006	4052083		
57109	5245	3005136	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	348961	0	6075-6	3005136		
27355	2537	3000876	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	167725	0	6082-2	3000876		
2362	224	3049273	2010-06-19	2010-06-19 00:00:00	2010-06-19	5001	0	\N	0	0	\N	\N	0	15111	0	38265-5	3049273		
2442	235	3006322	1991-10-15	1991-10-15 00:00:00	1991-10-15	5001	0	\N	0	0	\N	\N	0	15771	0	8331-1	3006322		
159441	4899	4133840	1976-07-06	1976-07-06 00:00:00	1976-07-06	5001	0	\N	0	0	\N	\N	0	325795	0	127783003	4133840		
50551	4608	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	307006	0	6844-5	3020655		
47798	4376	40758406	1947-11-17	1947-11-17 00:00:00	1947-11-17	5001	0	\N	0	0	\N	\N	0	290709	0	55277-8	40758406		
47843	4381	3006322	1994-11-01	1994-11-01 00:00:00	1994-11-01	5001	0	\N	0	0	\N	\N	0	291071	0	8331-1	3006322		
4212	418	40758406	1966-10-21	1966-10-21 00:00:00	1966-10-21	5001	0	\N	0	0	\N	\N	0	27606	0	55277-8	40758406		
5207	500	3006322	2009-07-03	2009-07-03 00:00:00	2009-07-03	5001	0	\N	0	0	\N	\N	0	33516	0	8331-1	3006322		
8694	842	3011505	1963-01-26	1963-01-26 00:00:00	1963-01-26	5001	0	\N	0	0	\N	\N	0	55744	0	19926-5	3011505		
62950	1934	4024958	1963-02-15	1963-02-15 00:00:00	1963-02-15	5001	0	\N	0	0	\N	\N	0	128632	0	117015009	4024958		
20127	1844	3051031	1986-07-29	1986-07-29 00:00:00	1986-07-29	5001	0	\N	0	0	\N	\N	0	123163	0	46240-8	3051031		
7397	710	3006322	1962-05-15	1962-05-15 00:00:00	1962-05-15	5001	0	\N	0	0	\N	\N	0	47040	0	8331-1	3006322		
49396	4506	46235214	2012-09-20	2012-09-20 00:00:00	2012-09-20	5001	0	\N	0	0	\N	\N	0	300182	0	76690-7	46235214		
5340	162	4052083	2001-06-25	2001-06-25 00:00:00	2001-06-25	5001	0	\N	0	0	\N	\N	0	11166	0	23426006	4052083		
14664	1361	3006322	1979-04-01	1979-04-01 00:00:00	1979-04-01	5001	0	\N	0	0	\N	\N	0	90367	0	8331-1	3006322		
97304	2976	4024958	1957-01-31	1957-01-31 00:00:00	1957-01-31	5001	0	\N	0	0	\N	\N	0	198745	0	117015009	4024958		
44629	4121	3011505	1970-04-19	1970-04-19 00:00:00	1970-04-19	5001	0	\N	0	0	\N	\N	0	273973	0	19926-5	3011505		
44720	4130	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	274581	0	6246-3	3021226		
30656	2813	3006322	2009-09-20	2009-09-20 00:00:00	2009-09-20	5001	0	\N	0	0	\N	\N	0	186381	0	8331-1	3006322		
39668	1232	4052083	1996-07-30	1996-07-30 00:00:00	1996-07-30	5001	0	\N	0	0	\N	\N	0	81221	0	23426006	4052083		
28070	2580	3006322	1962-08-04	1962-08-04 00:00:00	1962-08-04	5001	0	\N	0	0	\N	\N	0	170929	0	8331-1	3006322		
55420	5081	3049273	2004-11-19	2004-11-19 00:00:00	2004-11-19	5001	0	\N	0	0	\N	\N	0	337810	0	38265-5	3049273		
12043	1143	40766240	1972-07-26	1972-07-26 00:00:00	1972-07-26	5001	0	\N	0	0	\N	\N	0	75400	0	63513-6	40766240		
35466	3244	40769179	1991-04-24	1991-04-24 00:00:00	1991-04-24	5001	0	\N	0	0	\N	\N	0	215718	0	66519-0	40769179		
35888	3295	40766240	1952-09-05	1952-09-05 00:00:00	1952-09-05	5001	0	\N	0	0	\N	\N	0	218966	0	63513-6	40766240		
41347	3857	3011505	1998-04-07	1998-04-07 00:00:00	1998-04-07	5001	0	\N	0	0	\N	\N	0	255988	0	19926-5	3011505		
84452	2616	4024958	1963-09-27	1963-09-27 00:00:00	1963-09-27	5001	0	\N	0	0	\N	\N	0	173010	0	117015009	4024958		
47640	4374	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	290459	0	6095-4	3036780		
19495	1782	21494966	1956-01-11	1956-01-11 00:00:00	1956-01-11	5001	0	\N	0	0	\N	\N	0	119339	0	80271-0	21494966		
111035	3432	4052083	1994-12-01	1994-12-01 00:00:00	1994-12-01	5001	0	\N	0	0	\N	\N	0	227530	0	23426006	4052083		
51664	4725	3012494	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	314890	0	6206-7	3012494		
3986	124	4024958	1994-02-06	1994-02-06 00:00:00	1994-02-06	5001	0	\N	0	0	\N	\N	0	8324	0	117015009	4024958		
4	1	3006322	1975-10-12	1975-10-12 00:00:00	1975-10-12	5001	0	\N	0	0	\N	\N	0	43	0	8331-1	3006322		
117519	3621	4133840	1971-07-17	1971-07-17 00:00:00	1971-07-17	5001	0	\N	0	0	\N	\N	0	240651	0	127783003	4133840		
33524	1046	4024958	1972-11-03	1972-11-03 00:00:00	1972-11-03	5001	0	\N	0	0	\N	\N	0	68701	0	117015009	4024958		
54345	4970	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	330495	0	6095-4	3036780		
6477	610	3006322	1966-09-09	1966-09-09 00:00:00	1966-09-09	5001	0	\N	0	0	\N	\N	0	40474	0	8331-1	3006322		
21283	1967	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	130747	0	6075-6	3005136		
21562	1990	3006322	1975-07-09	1975-07-09 00:00:00	1975-07-09	5001	0	\N	0	0	\N	\N	0	132536	0	8331-1	3006322		
32695	2965	3006451	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	197968	0	6273-7	3006451		
169054	5190	4024958	1967-09-17	1967-09-17 00:00:00	1967-09-17	5001	0	\N	0	0	\N	\N	0	345027	0	117015009	4024958		
13187	1259	3006322	1981-07-12	1981-07-12 00:00:00	1981-07-12	5001	0	\N	0	0	\N	\N	0	82976	0	8331-1	3006322		
97774	2989	4024958	1963-09-04	1963-09-04 00:00:00	1963-09-04	5001	0	\N	0	0	\N	\N	0	199573	0	117015009	4024958		
40890	3793	46235214	1942-09-23	1942-09-23 00:00:00	1942-09-23	5001	0	\N	0	0	\N	\N	0	252258	0	76690-7	46235214		
109023	3367	4052083	2001-05-24	2001-05-24 00:00:00	2001-05-24	5001	0	\N	0	0	\N	\N	0	223298	0	23426006	4052083		
18526	1703	3006322	1961-08-22	1961-08-22 00:00:00	1961-08-22	5001	0	\N	0	0	\N	\N	0	113921	0	8331-1	3006322		
29250	2693	3051031	2014-01-28	2014-01-28 00:00:00	2014-01-28	5001	0	\N	0	0	\N	\N	0	178377	0	46240-8	3051031		
35061	1092	4024958	1959-08-21	1959-08-21 00:00:00	1959-08-21	5001	0	\N	0	0	\N	\N	0	71755	0	117015009	4024958		
53390	4899	3006322	1933-01-03	1933-01-03 00:00:00	1933-01-03	5001	0	\N	0	0	\N	\N	0	325766	0	8331-1	3006322		
14408	1348	3006322	1977-06-19	1977-06-19 00:00:00	1977-06-19	5001	0	\N	0	0	\N	\N	0	89314	0	8331-1	3006322		
74498	2286	4052083	1969-12-29	1969-12-29 00:00:00	1969-12-29	5001	0	\N	0	0	\N	\N	0	152059	0	23426006	4052083		
25814	2369	3027231	1982-01-16	1982-01-16 00:00:00	1982-01-16	5001	0	\N	0	0	\N	\N	0	157671	0	6276-0	3027231		
38067	3513	3006322	1979-04-24	1979-04-24 00:00:00	1979-04-24	5001	0	\N	0	0	\N	\N	0	233128	0	8331-1	3006322		
98772	3025	4052083	1979-09-01	1979-09-01 00:00:00	1979-09-01	5001	0	\N	0	0	\N	\N	0	201716	0	23426006	4052083		
8152	775	3006322	2013-10-15	2013-10-15 00:00:00	2013-10-15	5001	0	\N	0	0	\N	\N	0	51440	0	8331-1	3006322		
69873	2140	4024958	1989-11-22	1989-11-22 00:00:00	1989-11-22	5001	0	\N	0	0	\N	\N	0	142487	0	117015009	4024958		
39303	3628	3006322	1956-10-31	1956-10-31 00:00:00	1956-10-31	5001	0	\N	0	0	\N	\N	0	241360	0	8331-1	3006322		
22626	2075	3001488	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	138131	0	7258-7	3001488		
63997	1967	4052083	2001-12-12	2001-12-12 00:00:00	2001-12-12	5001	0	\N	0	0	\N	\N	0	130828	0	23426006	4052083		
75368	2311	4024958	1960-08-31	1960-08-31 00:00:00	1960-08-31	5001	0	\N	0	0	\N	\N	0	153751	0	117015009	4024958		
17102	1556	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	104226	0	6206-7	3012494		
77202	2366	4052083	2003-08-14	2003-08-14 00:00:00	2003-08-14	5001	0	\N	0	0	\N	\N	0	157521	0	23426006	4052083		
57110	5245	3027231	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	348961	0	6276-0	3027231		
27358	2540	40766240	1938-01-21	1938-01-21 00:00:00	1938-01-21	5001	0	\N	0	0	\N	\N	0	167886	0	63513-6	40766240		
2363	224	3006322	1959-07-04	1959-07-04 00:00:00	1959-07-04	5001	0	\N	0	0	\N	\N	0	15084	0	8331-1	3006322		
2443	235	3006322	1988-12-02	1988-12-02 00:00:00	1988-12-02	5001	0	\N	0	0	\N	\N	0	15781	0	8331-1	3006322		
159442	4899	4133840	1998-11-10	1998-11-10 00:00:00	1998-11-10	5001	0	\N	0	0	\N	\N	0	325847	0	127783003	4133840		
50552	4608	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	307006	0	6085-5	3001247		
47800	4376	3051031	1947-11-17	1947-11-17 00:00:00	1947-11-17	5001	0	\N	0	0	\N	\N	0	290709	0	46240-8	3051031		
47844	4381	3006322	2016-03-25	2016-03-25 00:00:00	2016-03-25	5001	0	\N	0	0	\N	\N	0	291076	0	8331-1	3006322		
4213	418	40766240	1966-10-21	1966-10-21 00:00:00	1966-10-21	5001	0	\N	0	0	\N	\N	0	27606	0	63513-6	40766240		
5208	500	3006322	1977-01-13	1977-01-13 00:00:00	1977-01-13	5001	0	\N	0	0	\N	\N	0	33520	0	8331-1	3006322		
8695	842	3011505	1967-10-28	1967-10-28 00:00:00	1967-10-28	5001	0	\N	0	0	\N	\N	0	55732	0	19926-5	3011505		
62952	1934	4052083	2013-01-22	2013-01-22 00:00:00	2013-01-22	5001	0	\N	0	0	\N	\N	0	128635	0	23426006	4052083		
20130	1844	3051031	1986-08-28	1986-08-28 00:00:00	1986-08-28	5001	0	\N	0	0	\N	\N	0	123246	0	46240-8	3051031		
7398	710	3006322	1980-07-07	1980-07-07 00:00:00	1980-07-07	5001	0	\N	0	0	\N	\N	0	47025	0	8331-1	3006322		
49399	4506	40758406	2012-09-20	2012-09-20 00:00:00	2012-09-20	5001	0	\N	0	0	\N	\N	0	300182	0	55277-8	40758406		
5343	162	4052083	1984-06-15	1984-06-15 00:00:00	1984-06-15	5001	0	\N	0	0	\N	\N	0	11165	0	23426006	4052083		
14665	1361	3006322	1981-08-14	1981-08-14 00:00:00	1981-08-14	5001	0	\N	0	0	\N	\N	0	90372	0	8331-1	3006322		
97307	2976	4133840	2006-10-12	2006-10-12 00:00:00	2006-10-12	5001	0	\N	0	0	\N	\N	0	198776	0	127783003	4133840		
44630	4121	3011505	1974-08-25	1974-08-25 00:00:00	1974-08-25	5001	0	\N	0	0	\N	\N	0	274007	0	19926-5	3011505		
44721	4130	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	274581	0	6833-8	3023430		
30657	2813	3006322	1954-07-29	1954-07-29 00:00:00	1954-07-29	5001	0	\N	0	0	\N	\N	0	186378	0	8331-1	3006322		
39673	1232	4052083	1969-08-21	1969-08-21 00:00:00	1969-08-21	5001	0	\N	0	0	\N	\N	0	81179	0	23426006	4052083		
28071	2580	3006322	1962-04-22	1962-04-22 00:00:00	1962-04-22	5001	0	\N	0	0	\N	\N	0	170878	0	8331-1	3006322		
55426	5083	3006322	1973-12-14	1973-12-14 00:00:00	1973-12-14	5001	0	\N	0	0	\N	\N	0	338023	0	8331-1	3006322		
12044	1143	46235214	1972-07-26	1972-07-26 00:00:00	1972-07-26	5001	0	\N	0	0	\N	\N	0	75400	0	76690-7	46235214		
35467	3244	40769184	1991-04-24	1991-04-24 00:00:00	1991-04-24	5001	0	\N	0	0	\N	\N	0	215718	0	66524-0	40769184		
35889	3295	40758406	1952-11-04	1952-11-04 00:00:00	1952-11-04	5001	0	\N	0	0	\N	\N	0	218876	0	55277-8	40758406		
41348	3857	3011505	2006-08-22	2006-08-22 00:00:00	2006-08-22	5001	0	\N	0	0	\N	\N	0	255990	0	19926-5	3011505		
84463	2616	4052083	2018-12-10	2018-12-10 00:00:00	2018-12-10	5001	0	\N	0	0	\N	\N	0	172980	0	23426006	4052083		
47641	4374	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	290459	0	6158-0	3019406		
19496	1782	3014576	1956-01-11	1956-01-11 00:00:00	1956-01-11	5001	0	\N	0	0	\N	\N	0	119339	0	2075-0	3014576		
134245	4133	4052083	2005-05-02	2005-05-02 00:00:00	2005-05-02	5001	0	\N	0	0	\N	\N	0	274786	0	23426006	4052083		
51667	4729	3006322	2009-01-29	2009-01-29 00:00:00	2009-01-29	5001	0	\N	0	0	\N	\N	0	315051	0	8331-1	3006322		
3992	124	4024958	1997-09-12	1997-09-12 00:00:00	1997-09-12	5001	0	\N	0	0	\N	\N	0	8322	0	117015009	4024958		
5	1	3006322	1971-01-24	1971-01-24 00:00:00	1971-01-24	5001	0	\N	0	0	\N	\N	0	42	0	8331-1	3006322		
171781	5272	4052083	2013-02-17	2013-02-17 00:00:00	2013-02-17	5001	0	\N	0	0	\N	\N	0	350632	0	23426006	4052083		
22351	704	4024958	1970-05-20	1970-05-20 00:00:00	1970-05-20	5001	0	\N	0	0	\N	\N	0	46514	0	117015009	4024958		
54346	4970	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	330495	0	6844-5	3020655		
6478	610	3006322	1972-11-19	1972-11-19 00:00:00	1972-11-19	5001	0	\N	0	0	\N	\N	0	40528	0	8331-1	3006322		
21284	1967	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	130747	0	6276-0	3027231		
21563	1990	3006322	1967-07-22	1967-07-22 00:00:00	1967-07-22	5001	0	\N	0	0	\N	\N	0	132481	0	8331-1	3006322		
32696	2965	3020655	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	197968	0	6844-5	3020655		
169059	5190	4024958	1974-10-21	1974-10-21 00:00:00	1974-10-21	5001	0	\N	0	0	\N	\N	0	344974	0	117015009	4024958		
13188	1259	40769194	1981-04-02	1981-04-02 00:00:00	1981-04-02	5001	0	\N	0	0	\N	\N	0	82922	0	66534-9	40769194		
44175	4071	40766240	1967-03-23	1967-03-23 00:00:00	1967-03-23	5001	0	\N	0	0	\N	\N	0	270577	0	63513-6	40766240		
40891	3793	40766240	1942-09-23	1942-09-23 00:00:00	1942-09-23	5001	0	\N	0	0	\N	\N	0	252258	0	63513-6	40766240		
109034	3367	4052083	1965-12-19	1965-12-19 00:00:00	1965-12-19	5001	0	\N	0	0	\N	\N	0	223299	0	23426006	4052083		
18527	1703	3006322	2016-04-05	2016-04-05 00:00:00	2016-04-05	5001	0	\N	0	0	\N	\N	0	113855	0	8331-1	3006322		
52395	4822	40766240	1971-02-05	1971-02-05 00:00:00	1971-02-05	5001	0	\N	0	0	\N	\N	0	320712	0	63513-6	40766240		
35083	1092	4024958	1969-02-09	1969-02-09 00:00:00	1969-02-09	5001	0	\N	0	0	\N	\N	0	71816	0	117015009	4024958		
53391	4899	3011505	1988-09-13	1988-09-13 00:00:00	1988-09-13	5001	0	\N	0	0	\N	\N	0	325849	0	19926-5	3011505		
53500	4913	46235214	1970-10-11	1970-10-11 00:00:00	1970-10-11	5001	0	\N	0	0	\N	\N	0	326510	0	76690-7	46235214		
74529	2287	4052083	1958-04-28	1958-04-28 00:00:00	1958-04-28	5001	0	\N	0	0	\N	\N	0	152097	0	23426006	4052083		
25815	2369	3014599	1982-01-16	1982-01-16 00:00:00	1982-01-16	5001	0	\N	0	0	\N	\N	0	157671	0	6106-9	3014599		
38068	3513	3006322	1974-01-10	1974-01-10 00:00:00	1974-01-10	5001	0	\N	0	0	\N	\N	0	233123	0	8331-1	3006322		
98799	3025	4052083	1992-08-31	1992-08-31 00:00:00	1992-08-31	5001	0	\N	0	0	\N	\N	0	201631	0	23426006	4052083		
8153	775	3006322	2010-09-19	2010-09-19 00:00:00	2010-09-19	5001	0	\N	0	0	\N	\N	0	51439	0	8331-1	3006322		
69876	2140	4024958	1955-08-18	1955-08-18 00:00:00	1955-08-18	5001	0	\N	0	0	\N	\N	0	142557	0	117015009	4024958		
39304	3628	3006322	2005-07-07	2005-07-07 00:00:00	2005-07-07	5001	0	\N	0	0	\N	\N	0	241365	0	8331-1	3006322		
22627	2075	3006322	2016-06-17	2016-06-17 00:00:00	2016-06-17	5001	0	\N	0	0	\N	\N	0	138007	0	8331-1	3006322		
64044	1967	4024958	1958-07-01	1958-07-01 00:00:00	1958-07-01	5001	0	\N	0	0	\N	\N	0	130804	0	117015009	4024958		
75373	2311	4052083	1973-08-31	1973-08-31 00:00:00	1973-08-31	5001	0	\N	0	0	\N	\N	0	153696	0	23426006	4052083		
17104	1558	3006322	2018-08-12	2018-08-12 00:00:00	2018-08-12	5001	0	\N	0	0	\N	\N	0	104310	0	8331-1	3006322		
77204	2366	4024958	1967-06-09	1967-06-09 00:00:00	1967-06-09	5001	0	\N	0	0	\N	\N	0	157526	0	117015009	4024958		
57111	5245	3000876	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	348961	0	6082-2	3000876		
27359	2540	46235214	1938-01-21	1938-01-21 00:00:00	1938-01-21	5001	0	\N	0	0	\N	\N	0	167886	0	76690-7	46235214		
2364	224	3006322	1975-02-19	1975-02-19 00:00:00	1975-02-19	5001	0	\N	0	0	\N	\N	0	15036	0	8331-1	3006322		
2444	236	3006322	1988-02-10	1988-02-10 00:00:00	1988-02-10	5001	0	\N	0	0	\N	\N	0	15952	0	8331-1	3006322		
20495	1882	3036780	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	125508	0	6095-4	3036780		
50553	4608	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	307006	0	6095-4	3036780		
47801	4376	40766240	1947-11-17	1947-11-17 00:00:00	1947-11-17	5001	0	\N	0	0	\N	\N	0	290709	0	63513-6	40766240		
47845	4381	3006322	1993-05-26	1993-05-26 00:00:00	1993-05-26	5001	0	\N	0	0	\N	\N	0	291113	0	8331-1	3006322		
4214	418	3006322	1963-11-04	1963-11-04 00:00:00	1963-11-04	5001	0	\N	0	0	\N	\N	0	27595	0	8331-1	3006322		
5209	500	3006322	1983-04-26	1983-04-26 00:00:00	1983-04-26	5001	0	\N	0	0	\N	\N	0	33489	0	8331-1	3006322		
116825	3601	4052083	1984-10-01	1984-10-01 00:00:00	1984-10-01	5001	0	\N	0	0	\N	\N	0	239180	0	23426006	4052083		
62971	1934	4024958	1992-07-24	1992-07-24 00:00:00	1992-07-24	5001	0	\N	0	0	\N	\N	0	128652	0	117015009	4024958		
20131	1844	46235214	1986-08-28	1986-08-28 00:00:00	1986-08-28	5001	0	\N	0	0	\N	\N	0	123246	0	76690-7	46235214		
7399	711	3006322	1959-10-19	1959-10-19 00:00:00	1959-10-19	5001	0	\N	0	0	\N	\N	0	47163	0	8331-1	3006322		
49400	4506	3051031	1983-08-14	1983-08-14 00:00:00	1983-08-14	5001	0	\N	0	0	\N	\N	0	300206	0	46240-8	3051031		
5355	162	4024958	1951-06-19	1951-06-19 00:00:00	1951-06-19	5001	0	\N	0	0	\N	\N	0	11083	0	117015009	4024958		
14666	1361	3006322	1999-04-20	1999-04-20 00:00:00	1999-04-20	5001	0	\N	0	0	\N	\N	0	90346	0	8331-1	3006322		
97310	2976	4133840	2005-06-23	2005-06-23 00:00:00	2005-06-23	5001	0	\N	0	0	\N	\N	0	198775	0	127783003	4133840		
44631	4121	3011505	1977-09-11	1977-09-11 00:00:00	1977-09-11	5001	0	\N	0	0	\N	\N	0	274021	0	19926-5	3011505		
44722	4130	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	274581	0	7258-7	3001488		
30674	2815	3006322	1998-07-16	1998-07-16 00:00:00	1998-07-16	5001	0	\N	0	0	\N	\N	0	186518	0	8331-1	3006322		
41870	3879	3051031	2007-05-26	2007-05-26 00:00:00	2007-05-26	5001	0	\N	0	0	\N	\N	0	257718	0	46240-8	3051031		
28072	2580	3006322	2005-02-19	2005-02-19 00:00:00	2005-02-19	5001	0	\N	0	0	\N	\N	0	170925	0	8331-1	3006322		
55427	5083	3006322	1980-03-25	1980-03-25 00:00:00	1980-03-25	5001	0	\N	0	0	\N	\N	0	338016	0	8331-1	3006322		
12045	1143	3006322	1974-05-16	1974-05-16 00:00:00	1974-05-16	5001	0	\N	0	0	\N	\N	0	75401	0	8331-1	3006322		
35468	3244	40769189	1991-04-24	1991-04-24 00:00:00	1991-04-24	5001	0	\N	0	0	\N	\N	0	215718	0	66529-9	40769189		
35890	3295	46235214	1952-11-04	1952-11-04 00:00:00	1952-11-04	5001	0	\N	0	0	\N	\N	0	218876	0	76690-7	46235214		
41349	3857	3011505	1996-01-16	1996-01-16 00:00:00	1996-01-16	5001	0	\N	0	0	\N	\N	0	255987	0	19926-5	3011505		
84466	2617	4024958	1965-04-18	1965-04-18 00:00:00	1965-04-18	5001	0	\N	0	0	\N	\N	0	173043	0	117015009	4024958		
47642	4374	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	290459	0	6085-5	3001247		
19497	1782	3013682	1956-01-11	1956-01-11 00:00:00	1956-01-11	5001	0	\N	0	0	\N	\N	0	119339	0	3094-0	3013682		
134249	4133	4024958	1994-05-06	1994-05-06 00:00:00	1994-05-06	5001	0	\N	0	0	\N	\N	0	274803	0	117015009	4024958		
51668	4729	3006322	1973-10-08	1973-10-08 00:00:00	1973-10-08	5001	0	\N	0	0	\N	\N	0	315083	0	8331-1	3006322		
58549	1781	4052083	1999-10-11	1999-10-11 00:00:00	1999-10-11	5001	0	\N	0	0	\N	\N	0	119184	0	23426006	4052083		
6	1	3006322	2008-01-16	2008-01-16 00:00:00	2008-01-16	5001	0	\N	0	0	\N	\N	0	76	0	8331-1	3006322		
171782	5272	4024958	1959-06-24	1959-06-24 00:00:00	1959-06-24	5001	0	\N	0	0	\N	\N	0	350672	0	117015009	4024958		
22362	704	4052083	1999-03-20	1999-03-20 00:00:00	1999-03-20	5001	0	\N	0	0	\N	\N	0	46597	0	23426006	4052083		
54347	4970	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	330495	0	7258-7	3001488		
6479	610	3006322	1987-08-22	1987-08-22 00:00:00	1987-08-22	5001	0	\N	0	0	\N	\N	0	40507	0	8331-1	3006322		
21285	1967	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	130747	0	6106-9	3014599		
21564	1990	3006322	1995-03-12	1995-03-12 00:00:00	1995-03-12	5001	0	\N	0	0	\N	\N	0	132485	0	8331-1	3006322		
32697	2965	3001488	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	197968	0	7258-7	3001488		
169069	5190	4024958	1964-07-24	1964-07-24 00:00:00	1964-07-24	5001	0	\N	0	0	\N	\N	0	345026	0	117015009	4024958		
13189	1259	40769189	1981-04-02	1981-04-02 00:00:00	1981-04-02	5001	0	\N	0	0	\N	\N	0	82922	0	66529-9	40769189		
44176	4071	3006322	1987-03-15	1987-03-15 00:00:00	1987-03-15	5001	0	\N	0	0	\N	\N	0	270625	0	8331-1	3006322		
40892	3793	3051031	1942-09-23	1942-09-23 00:00:00	1942-09-23	5001	0	\N	0	0	\N	\N	0	252258	0	46240-8	3051031		
109035	3367	4052083	2009-10-06	2009-10-06 00:00:00	2009-10-06	5001	0	\N	0	0	\N	\N	0	223288	0	23426006	4052083		
18528	1703	3006322	1995-09-06	1995-09-06 00:00:00	1995-09-06	5001	0	\N	0	0	\N	\N	0	113863	0	8331-1	3006322		
52396	4822	3006322	2018-07-27	2018-07-27 00:00:00	2018-07-27	5001	0	\N	0	0	\N	\N	0	320758	0	8331-1	3006322		
46363	1415	4024958	1969-02-28	1969-02-28 00:00:00	1969-02-28	5001	0	\N	0	0	\N	\N	0	94177	0	117015009	4024958		
53392	4899	3011505	1971-06-08	1971-06-08 00:00:00	1971-06-08	5001	0	\N	0	0	\N	\N	0	325853	0	19926-5	3011505		
53501	4913	3051031	1970-10-11	1970-10-11 00:00:00	1970-10-11	5001	0	\N	0	0	\N	\N	0	326510	0	46240-8	3051031		
41490	3865	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	256669	0	6082-2	3000876		
25816	2369	3006451	1982-01-16	1982-01-16 00:00:00	1982-01-16	5001	0	\N	0	0	\N	\N	0	157671	0	6273-7	3006451		
38069	3513	3006322	2010-08-20	2010-08-20 00:00:00	2010-08-20	5001	0	\N	0	0	\N	\N	0	233158	0	8331-1	3006322		
110091	3397	4052083	1952-04-07	1952-04-07 00:00:00	1952-04-07	5001	0	\N	0	0	\N	\N	0	225334	0	23426006	4052083		
8154	775	3006322	2005-02-05	2005-02-05 00:00:00	2005-02-05	5001	0	\N	0	0	\N	\N	0	51423	0	8331-1	3006322		
97431	2980	4024958	2014-06-17	2014-06-17 00:00:00	2014-06-17	5001	0	\N	0	0	\N	\N	0	198895	0	117015009	4024958		
39305	3628	3006322	1955-04-28	1955-04-28 00:00:00	1955-04-28	5001	0	\N	0	0	\N	\N	0	241407	0	8331-1	3006322		
22807	2088	3011505	1991-08-06	1991-08-06 00:00:00	1991-08-06	5001	0	\N	0	0	\N	\N	0	139277	0	19926-5	3011505		
98588	3017	4024958	1973-08-21	1973-08-21 00:00:00	1973-08-21	5001	0	\N	0	0	\N	\N	0	201210	0	117015009	4024958		
75380	2311	4024958	1971-09-17	1971-09-17 00:00:00	1971-09-17	5001	0	\N	0	0	\N	\N	0	153742	0	117015009	4024958		
17105	1558	3000963	1962-06-14	1962-06-14 00:00:00	1962-06-14	5001	0	\N	0	0	\N	\N	0	104301	0	718-7	3000963		
77210	2366	4052083	1982-01-18	1982-01-18 00:00:00	1982-01-18	5001	0	\N	0	0	\N	\N	0	157529	0	23426006	4052083		
57112	5245	3012494	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	348961	0	6206-7	3012494		
27361	2540	3051031	1938-01-21	1938-01-21 00:00:00	1938-01-21	5001	0	\N	0	0	\N	\N	0	167886	0	46240-8	3051031		
2365	224	3006322	1963-08-29	1963-08-29 00:00:00	1963-08-29	5001	0	\N	0	0	\N	\N	0	15085	0	8331-1	3006322		
2445	236	3049273	1983-12-29	1983-12-29 00:00:00	1983-12-29	5001	0	\N	0	0	\N	\N	0	15915	0	38265-5	3049273		
20496	1882	3000876	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	125508	0	6082-2	3000876		
50554	4608	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	307006	0	6276-0	3027231		
47802	4376	40766240	1999-03-04	1999-03-04 00:00:00	1999-03-04	5001	0	\N	0	0	\N	\N	0	290740	0	63513-6	40766240		
47846	4381	3006322	1965-02-28	1965-02-28 00:00:00	1965-02-28	5001	0	\N	0	0	\N	\N	0	291147	0	8331-1	3006322		
4215	418	3006322	1958-01-24	1958-01-24 00:00:00	1958-01-24	5001	0	\N	0	0	\N	\N	0	27681	0	8331-1	3006322		
5210	500	3049273	2013-03-19	2013-03-19 00:00:00	2013-03-19	5001	0	\N	0	0	\N	\N	0	33550	0	38265-5	3049273		
116831	3601	4024958	1969-01-30	1969-01-30 00:00:00	1969-01-30	5001	0	\N	0	0	\N	\N	0	239172	0	117015009	4024958		
62978	1935	4052083	1980-01-12	1980-01-12 00:00:00	1980-01-12	5001	0	\N	0	0	\N	\N	0	128684	0	23426006	4052083		
20132	1844	40758406	1986-08-28	1986-08-28 00:00:00	1986-08-28	5001	0	\N	0	0	\N	\N	0	123246	0	55277-8	40758406		
7400	711	3006322	2003-02-02	2003-02-02 00:00:00	2003-02-02	5001	0	\N	0	0	\N	\N	0	47085	0	8331-1	3006322		
49401	4506	40758406	1983-08-14	1983-08-14 00:00:00	1983-08-14	5001	0	\N	0	0	\N	\N	0	300206	0	55277-8	40758406		
38544	3566	3015076	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	236892	0	6248-9	3015076		
14667	1361	3006322	1995-11-24	1995-11-24 00:00:00	1995-11-24	5001	0	\N	0	0	\N	\N	0	90328	0	8331-1	3006322		
97312	2976	4052083	1966-08-26	1966-08-26 00:00:00	1966-08-26	5001	0	\N	0	0	\N	\N	0	198704	0	23426006	4052083		
44632	4121	3011505	1976-09-05	1976-09-05 00:00:00	1976-09-05	5001	0	\N	0	0	\N	\N	0	274008	0	19926-5	3011505		
44723	4130	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	274581	0	6095-4	3036780		
30675	2815	3006322	1987-08-12	1987-08-12 00:00:00	1987-08-12	5001	0	\N	0	0	\N	\N	0	186492	0	8331-1	3006322		
41871	3879	46235214	2007-05-26	2007-05-26 00:00:00	2007-05-26	5001	0	\N	0	0	\N	\N	0	257718	0	76690-7	46235214		
28073	2580	3006322	1988-10-29	1988-10-29 00:00:00	1988-10-29	5001	0	\N	0	0	\N	\N	0	170922	0	8331-1	3006322		
55428	5083	3006322	1988-03-25	1988-03-25 00:00:00	1988-03-25	5001	0	\N	0	0	\N	\N	0	338024	0	8331-1	3006322		
12046	1144	3006322	2016-06-12	2016-06-12 00:00:00	2016-06-12	5001	0	\N	0	0	\N	\N	0	75502	0	8331-1	3006322		
35470	3244	46235214	1977-01-12	1977-01-12 00:00:00	1977-01-12	5001	0	\N	0	0	\N	\N	0	215731	0	76690-7	46235214		
35893	3295	40766240	1952-11-04	1952-11-04 00:00:00	1952-11-04	5001	0	\N	0	0	\N	\N	0	218876	0	63513-6	40766240		
52629	4834	3051031	2010-08-01	2010-08-01 00:00:00	2010-08-01	5001	0	\N	0	0	\N	\N	0	321607	0	46240-8	3051031		
84469	2617	4024958	1972-05-22	1972-05-22 00:00:00	1972-05-22	5001	0	\N	0	0	\N	\N	0	173027	0	117015009	4024958		
47643	4374	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	290459	0	6082-2	3000876		
19498	1782	3023103	1956-01-11	1956-01-11 00:00:00	1956-01-11	5001	0	\N	0	0	\N	\N	0	119339	0	2823-3	3023103		
145535	4466	4024958	1991-05-31	1991-05-31 00:00:00	1991-05-31	5001	0	\N	0	0	\N	\N	0	297146	0	117015009	4024958		
51669	4729	3006322	2000-05-03	2000-05-03 00:00:00	2000-05-03	5001	0	\N	0	0	\N	\N	0	315087	0	8331-1	3006322		
58556	1781	4052083	1966-02-09	1966-02-09 00:00:00	1966-02-09	5001	0	\N	0	0	\N	\N	0	119257	0	23426006	4052083		
22203	701	4052083	1970-12-22	1970-12-22 00:00:00	1970-12-22	5001	0	\N	0	0	\N	\N	0	46345	0	23426006	4052083		
171783	5272	4052083	1949-04-29	1949-04-29 00:00:00	1949-04-29	5001	0	\N	0	0	\N	\N	0	350670	0	23426006	4052083		
33670	1054	4024958	1949-11-21	1949-11-21 00:00:00	1949-11-21	5001	0	\N	0	0	\N	\N	0	69140	0	117015009	4024958		
54348	4970	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	330495	0	6085-5	3001247		
6480	610	3006322	2013-01-13	2013-01-13 00:00:00	2013-01-13	5001	0	\N	0	0	\N	\N	0	40524	0	8331-1	3006322		
21286	1967	3006322	1958-07-01	1958-07-01 00:00:00	1958-07-01	5001	0	\N	0	0	\N	\N	0	130804	0	8331-1	3006322		
21565	1990	3006322	1996-05-21	1996-05-21 00:00:00	1996-05-21	5001	0	\N	0	0	\N	\N	0	132537	0	8331-1	3006322		
32698	2965	3006734	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	197968	0	6189-5	3006734		
169071	5191	4024958	1990-10-29	1990-10-29 00:00:00	1990-10-29	5001	0	\N	0	0	\N	\N	0	345117	0	117015009	4024958		
13190	1259	40769179	1981-04-02	1981-04-02 00:00:00	1981-04-02	5001	0	\N	0	0	\N	\N	0	82922	0	66519-0	40769179		
44178	4071	40766240	1967-02-21	1967-02-21 00:00:00	1967-02-21	5001	0	\N	0	0	\N	\N	0	270586	0	63513-6	40766240		
40894	3793	40758406	2009-04-04	2009-04-04 00:00:00	2009-04-04	5001	0	\N	0	0	\N	\N	0	252184	0	55277-8	40758406		
97872	2992	4052083	1983-11-09	1983-11-09 00:00:00	1983-11-09	5001	0	\N	0	0	\N	\N	0	199712	0	23426006	4052083		
18529	1703	3006322	1963-07-27	1963-07-27 00:00:00	1963-07-27	5001	0	\N	0	0	\N	\N	0	113907	0	8331-1	3006322		
52397	4822	3011505	2013-12-25	2013-12-25 00:00:00	2013-12-25	5001	0	\N	0	0	\N	\N	0	320720	0	19926-5	3011505		
46365	1415	4052083	1988-09-15	1988-09-15 00:00:00	1988-09-15	5001	0	\N	0	0	\N	\N	0	94196	0	23426006	4052083		
53393	4899	3011505	1969-02-25	1969-02-25 00:00:00	1969-02-25	5001	0	\N	0	0	\N	\N	0	325826	0	19926-5	3011505		
53503	4913	40758406	1970-10-11	1970-10-11 00:00:00	1970-10-11	5001	0	\N	0	0	\N	\N	0	326510	0	55277-8	40758406		
41491	3865	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	256669	0	6095-4	3036780		
25817	2369	3012494	1982-01-16	1982-01-16 00:00:00	1982-01-16	5001	0	\N	0	0	\N	\N	0	157671	0	6206-7	3012494		
38070	3513	3006322	1985-12-04	1985-12-04 00:00:00	1985-12-04	5001	0	\N	0	0	\N	\N	0	233129	0	8331-1	3006322		
68382	2088	4133840	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	139273	0	127783003	4133840		
8156	776	3011505	2015-09-10	2015-09-10 00:00:00	2015-09-10	5001	0	\N	0	0	\N	\N	0	51512	0	19926-5	3011505		
97432	2980	4052083	2013-01-03	2013-01-03 00:00:00	2013-01-03	5001	0	\N	0	0	\N	\N	0	198894	0	23426006	4052083		
39306	3628	3006322	2003-08-06	2003-08-06 00:00:00	2003-08-06	5001	0	\N	0	0	\N	\N	0	241364	0	8331-1	3006322		
22808	2088	3011505	1978-08-29	1978-08-29 00:00:00	1978-08-29	5001	0	\N	0	0	\N	\N	0	139322	0	19926-5	3011505		
98618	3020	4133840	2011-01-26	2011-01-26 00:00:00	2011-01-26	5001	0	\N	0	0	\N	\N	0	201433	0	127783003	4133840		
75414	2314	4024958	2016-03-25	2016-03-25 00:00:00	2016-03-25	5001	0	\N	0	0	\N	\N	0	153893	0	117015009	4024958		
17106	1558	3013682	1962-06-14	1962-06-14 00:00:00	1962-06-14	5001	0	\N	0	0	\N	\N	0	104301	0	3094-0	3013682		
77214	2367	4052083	2003-04-01	2003-04-01 00:00:00	2003-04-01	5001	0	\N	0	0	\N	\N	0	157581	0	23426006	4052083		
57113	5245	3019406	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	348961	0	6158-0	3019406		
27362	2540	40758406	1938-01-21	1938-01-21 00:00:00	1938-01-21	5001	0	\N	0	0	\N	\N	0	167886	0	55277-8	40758406		
2366	224	3006322	2008-11-18	2008-11-18 00:00:00	2008-11-18	5001	0	\N	0	0	\N	\N	0	15022	0	8331-1	3006322		
2446	236	3006322	2003-07-30	2003-07-30 00:00:00	2003-07-30	5001	0	\N	0	0	\N	\N	0	15909	0	8331-1	3006322		
20497	1882	3015076	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	125508	0	6248-9	3015076		
50555	4608	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	307006	0	6246-3	3021226		
47803	4376	40758406	1999-03-04	1999-03-04 00:00:00	1999-03-04	5001	0	\N	0	0	\N	\N	0	290740	0	55277-8	40758406		
47847	4382	3006322	1974-10-07	1974-10-07 00:00:00	1974-10-07	5001	0	\N	0	0	\N	\N	0	291181	0	8331-1	3006322		
4218	419	40766240	1913-06-24	1913-06-24 00:00:00	1913-06-24	5001	0	\N	0	0	\N	\N	0	27716	0	63513-6	40766240		
5211	500	3006322	1967-05-23	1967-05-23 00:00:00	1967-05-23	5001	0	\N	0	0	\N	\N	0	33538	0	8331-1	3006322		
116852	3603	4024958	1973-10-01	1973-10-01 00:00:00	1973-10-01	5001	0	\N	0	0	\N	\N	0	239355	0	117015009	4024958		
62992	1935	4024958	1977-10-06	1977-10-06 00:00:00	1977-10-06	5001	0	\N	0	0	\N	\N	0	128735	0	117015009	4024958		
20134	1844	40766240	1986-08-28	1986-08-28 00:00:00	1986-08-28	5001	0	\N	0	0	\N	\N	0	123246	0	63513-6	40766240		
7401	711	3006322	1978-05-01	1978-05-01 00:00:00	1978-05-01	5001	0	\N	0	0	\N	\N	0	47142	0	8331-1	3006322		
49402	4506	46235214	1983-08-14	1983-08-14 00:00:00	1983-08-14	5001	0	\N	0	0	\N	\N	0	300206	0	76690-7	46235214		
38545	3566	3005136	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	236892	0	6075-6	3005136		
14668	1361	3006322	1977-11-23	1977-11-23 00:00:00	1977-11-23	5001	0	\N	0	0	\N	\N	0	90326	0	8331-1	3006322		
97314	2976	4133840	2008-10-23	2008-10-23 00:00:00	2008-10-23	5001	0	\N	0	0	\N	\N	0	198777	0	127783003	4133840		
44633	4121	3011505	1971-04-25	1971-04-25 00:00:00	1971-04-25	5001	0	\N	0	0	\N	\N	0	274005	0	19926-5	3011505		
44724	4130	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	274581	0	6844-5	3020655		
30676	2815	3006322	1994-01-24	1994-01-24 00:00:00	1994-01-24	5001	0	\N	0	0	\N	\N	0	186493	0	8331-1	3006322		
41872	3879	3006322	1956-05-03	1956-05-03 00:00:00	1956-05-03	5001	0	\N	0	0	\N	\N	0	257658	0	8331-1	3006322		
28074	2580	3006322	2000-08-04	2000-08-04 00:00:00	2000-08-04	5001	0	\N	0	0	\N	\N	0	170909	0	8331-1	3006322		
55429	5083	3006322	1951-03-05	1951-03-05 00:00:00	1951-03-05	5001	0	\N	0	0	\N	\N	0	338051	0	8331-1	3006322		
12047	1144	3006322	2013-09-13	2013-09-13 00:00:00	2013-09-13	5001	0	\N	0	0	\N	\N	0	75501	0	8331-1	3006322		
35471	3244	3051031	1977-01-12	1977-01-12 00:00:00	1977-01-12	5001	0	\N	0	0	\N	\N	0	215731	0	46240-8	3051031		
35894	3295	3051031	1952-11-04	1952-11-04 00:00:00	1952-11-04	5001	0	\N	0	0	\N	\N	0	218876	0	46240-8	3051031		
52630	4834	3006322	2009-03-15	2009-03-15 00:00:00	2009-03-15	5001	0	\N	0	0	\N	\N	0	321606	0	8331-1	3006322		
95766	2936	4024958	2019-01-08	2019-01-08 00:00:00	2019-01-08	5001	0	\N	0	0	\N	\N	0	195747	0	117015009	4024958		
47644	4374	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	290459	0	6248-9	3015076		
19499	1782	3007461	1956-01-11	1956-01-11 00:00:00	1956-01-11	5001	0	\N	0	0	\N	\N	0	119339	0	26515-7	3007461		
145536	4466	4024958	2006-05-18	2006-05-18 00:00:00	2006-05-18	5001	0	\N	0	0	\N	\N	0	297147	0	117015009	4024958		
51673	4731	3006322	1993-01-04	1993-01-04 00:00:00	1993-01-04	5001	0	\N	0	0	\N	\N	0	315195	0	8331-1	3006322		
58560	1782	4024958	1956-10-08	1956-10-08 00:00:00	1956-10-08	5001	0	\N	0	0	\N	\N	0	119371	0	117015009	4024958		
22215	701	4024958	1964-04-17	1964-04-17 00:00:00	1964-04-17	5001	0	\N	0	0	\N	\N	0	46319	0	117015009	4024958		
171787	5272	4052083	1969-04-10	1969-04-10 00:00:00	1969-04-10	5001	0	\N	0	0	\N	\N	0	350655	0	23426006	4052083		
33678	1054	4052083	1996-10-26	1996-10-26 00:00:00	1996-10-26	5001	0	\N	0	0	\N	\N	0	69164	0	23426006	4052083		
54349	4970	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	330495	0	6075-6	3005136		
6481	610	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	40591	0	6833-8	3023430		
80350	2476	4052083	1966-07-15	1966-07-15 00:00:00	1966-07-15	5001	0	\N	0	0	\N	\N	0	164099	0	23426006	4052083		
21566	1990	3006322	1968-07-01	1968-07-01 00:00:00	1968-07-01	5001	0	\N	0	0	\N	\N	0	132491	0	8331-1	3006322		
32699	2965	3000876	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	197968	0	6082-2	3000876		
169072	5191	4024958	1977-01-19	1977-01-19 00:00:00	1977-01-19	5001	0	\N	0	0	\N	\N	0	345115	0	117015009	4024958		
13191	1259	40769184	1981-04-02	1981-04-02 00:00:00	1981-04-02	5001	0	\N	0	0	\N	\N	0	82922	0	66524-0	40769184		
44179	4071	3051031	1967-02-21	1967-02-21 00:00:00	1967-02-21	5001	0	\N	0	0	\N	\N	0	270586	0	46240-8	3051031		
40896	3793	3051031	2009-04-04	2009-04-04 00:00:00	2009-04-04	5001	0	\N	0	0	\N	\N	0	252184	0	46240-8	3051031		
97882	2992	4024958	1998-07-19	1998-07-19 00:00:00	1998-07-19	5001	0	\N	0	0	\N	\N	0	199688	0	117015009	4024958		
18530	1703	3006322	1977-08-07	1977-08-07 00:00:00	1977-08-07	5001	0	\N	0	0	\N	\N	0	113922	0	8331-1	3006322		
52398	4822	3011505	2014-12-31	2014-12-31 00:00:00	2014-12-31	5001	0	\N	0	0	\N	\N	0	320707	0	19926-5	3011505		
46367	1415	4024958	1969-08-13	1969-08-13 00:00:00	1969-08-13	5001	0	\N	0	0	\N	\N	0	94176	0	117015009	4024958		
53394	4899	40758406	1921-07-01	1921-07-01 00:00:00	1921-07-01	5001	0	\N	0	0	\N	\N	0	325771	0	55277-8	40758406		
53505	4913	40766240	1970-10-11	1970-10-11 00:00:00	1970-10-11	5001	0	\N	0	0	\N	\N	0	326510	0	63513-6	40766240		
41492	3865	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	256669	0	6276-0	3027231		
25818	2369	3036780	1994-05-08	1994-05-08 00:00:00	1994-05-08	5001	0	\N	0	0	\N	\N	0	157687	0	6095-4	3036780		
38071	3514	3006322	1987-01-04	1987-01-04 00:00:00	1987-01-04	5001	0	\N	0	0	\N	\N	0	233215	0	8331-1	3006322		
68383	2088	4133840	1970-12-01	1970-12-01 00:00:00	1970-12-01	5001	0	\N	0	0	\N	\N	0	139210	0	127783003	4133840		
8157	776	3011505	2011-08-18	2011-08-18 00:00:00	2011-08-18	5001	0	\N	0	0	\N	\N	0	51573	0	19926-5	3011505		
97452	2980	4024958	1977-02-21	1977-02-21 00:00:00	1977-02-21	5001	0	\N	0	0	\N	\N	0	198959	0	117015009	4024958		
39307	3628	3006322	1971-12-23	1971-12-23 00:00:00	1971-12-23	5001	0	\N	0	0	\N	\N	0	241408	0	8331-1	3006322		
22809	2088	3011505	2003-06-24	2003-06-24 00:00:00	2003-06-24	5001	0	\N	0	0	\N	\N	0	139289	0	19926-5	3011505		
98621	3020	4133840	2015-02-18	2015-02-18 00:00:00	2015-02-18	5001	0	\N	0	0	\N	\N	0	201377	0	127783003	4133840		
75420	2314	4052083	1986-05-21	1986-05-21 00:00:00	1986-05-21	5001	0	\N	0	0	\N	\N	0	153906	0	23426006	4052083		
17107	1558	3020630	1962-06-14	1962-06-14 00:00:00	1962-06-14	5001	0	\N	0	0	\N	\N	0	104301	0	2885-2	3020630		
77215	2367	4052083	2004-05-04	2004-05-04 00:00:00	2004-05-04	5001	0	\N	0	0	\N	\N	0	157551	0	23426006	4052083		
57114	5245	3006451	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	348961	0	6273-7	3006451		
62700	1923	4052083	2013-03-27	2013-03-27 00:00:00	2013-03-27	5001	0	\N	0	0	\N	\N	0	127854	0	23426006	4052083		
2367	224	3009201	2016-09-24	2016-09-24 00:00:00	2016-09-24	5001	0	\N	0	0	\N	\N	0	15027	0	3016-3	3009201		
2447	236	3006322	1983-02-11	1983-02-11 00:00:00	1983-02-11	5001	0	\N	0	0	\N	\N	0	15903	0	8331-1	3006322		
20498	1882	3019406	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	125508	0	6158-0	3019406		
50556	4608	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	307006	0	7258-7	3001488		
47804	4376	3051031	1999-03-04	1999-03-04 00:00:00	1999-03-04	5001	0	\N	0	0	\N	\N	0	290740	0	46240-8	3051031		
47848	4382	3006322	1967-08-31	1967-08-31 00:00:00	1967-08-31	5001	0	\N	0	0	\N	\N	0	291267	0	8331-1	3006322		
4220	419	3051031	1913-09-22	1913-09-22 00:00:00	1913-09-22	5001	0	\N	0	0	\N	\N	0	27717	0	46240-8	3051031		
5212	500	3006322	1991-03-30	1991-03-30 00:00:00	1991-03-30	5001	0	\N	0	0	\N	\N	0	33521	0	8331-1	3006322		
14756	461	4024958	1950-12-17	1950-12-17 00:00:00	1950-12-17	5001	0	\N	0	0	\N	\N	0	30825	0	117015009	4024958		
62993	1935	4052083	2004-05-04	2004-05-04 00:00:00	2004-05-04	5001	0	\N	0	0	\N	\N	0	128713	0	23426006	4052083		
20136	1844	3051031	1986-04-30	1986-04-30 00:00:00	1986-04-30	5001	0	\N	0	0	\N	\N	0	123162	0	46240-8	3051031		
7402	711	3006322	1971-05-02	1971-05-02 00:00:00	1971-05-02	5001	0	\N	0	0	\N	\N	0	47109	0	8331-1	3006322		
49404	4506	40766240	1983-08-14	1983-08-14 00:00:00	1983-08-14	5001	0	\N	0	0	\N	\N	0	300206	0	63513-6	40766240		
38546	3566	3019406	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	236892	0	6158-0	3019406		
14669	1361	3006322	2003-08-07	2003-08-07 00:00:00	2003-08-07	5001	0	\N	0	0	\N	\N	0	90373	0	8331-1	3006322		
97318	2976	4133840	2010-11-04	2010-11-04 00:00:00	2010-11-04	5001	0	\N	0	0	\N	\N	0	198748	0	127783003	4133840		
44634	4121	46235214	1921-08-16	1921-08-16 00:00:00	1921-08-16	5001	0	\N	0	0	\N	\N	0	273954	0	76690-7	46235214		
44725	4130	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	274534	0	6082-2	3000876		
30677	2815	3006322	1969-09-20	1969-09-20 00:00:00	1969-09-20	5001	0	\N	0	0	\N	\N	0	186490	0	8331-1	3006322		
41873	3879	40758406	2007-01-26	2007-01-26 00:00:00	2007-01-26	5001	0	\N	0	0	\N	\N	0	257733	0	55277-8	40758406		
28075	2580	3006322	1992-05-19	1992-05-19 00:00:00	1992-05-19	5001	0	\N	0	0	\N	\N	0	170924	0	8331-1	3006322		
55430	5083	3006322	1992-05-19	1992-05-19 00:00:00	1992-05-19	5001	0	\N	0	0	\N	\N	0	338025	0	8331-1	3006322		
12048	1144	3006322	1989-08-08	1989-08-08 00:00:00	1989-08-08	5001	0	\N	0	0	\N	\N	0	75514	0	8331-1	3006322		
35473	3244	40758406	1977-01-12	1977-01-12 00:00:00	1977-01-12	5001	0	\N	0	0	\N	\N	0	215731	0	55277-8	40758406		
35895	3295	3006322	1978-11-10	1978-11-10 00:00:00	1978-11-10	5001	0	\N	0	0	\N	\N	0	218970	0	8331-1	3006322		
52631	4835	3006322	2008-11-14	2008-11-14 00:00:00	2008-11-14	5001	0	\N	0	0	\N	\N	0	321644	0	8331-1	3006322		
35840	1110	4024958	1994-03-14	1994-03-14 00:00:00	1994-03-14	5001	0	\N	0	0	\N	\N	0	73028	0	117015009	4024958		
47645	4374	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	290459	0	6276-0	3027231		
19500	1782	3045716	1956-01-11	1956-01-11 00:00:00	1956-01-11	5001	0	\N	0	0	\N	\N	0	119339	0	33037-3	3045716		
145540	4467	4024958	1965-10-27	1965-10-27 00:00:00	1965-10-27	5001	0	\N	0	0	\N	\N	0	297240	0	117015009	4024958		
51674	4731	3006322	1973-05-12	1973-05-12 00:00:00	1973-05-12	5001	0	\N	0	0	\N	\N	0	315178	0	8331-1	3006322		
58597	1783	4052083	1981-03-15	1981-03-15 00:00:00	1981-03-15	5001	0	\N	0	0	\N	\N	0	119381	0	23426006	4052083		
22222	701	4024958	1968-02-07	1968-02-07 00:00:00	1968-02-07	5001	0	\N	0	0	\N	\N	0	46320	0	117015009	4024958		
171808	5274	4024958	1966-11-01	1966-11-01 00:00:00	1966-11-01	5001	0	\N	0	0	\N	\N	0	350834	0	117015009	4024958		
111370	3439	4024958	1957-08-16	1957-08-16 00:00:00	1957-08-16	5001	0	\N	0	0	\N	\N	0	228208	0	117015009	4024958		
54350	4970	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	330495	0	6248-9	3015076		
6482	610	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	40591	0	6248-9	3015076		
80356	2476	4024958	1976-05-25	1976-05-25 00:00:00	1976-05-25	5001	0	\N	0	0	\N	\N	0	164060	0	117015009	4024958		
21567	1991	3006322	1983-03-28	1983-03-28 00:00:00	1983-03-28	5001	0	\N	0	0	\N	\N	0	132604	0	8331-1	3006322		
32700	2965	3036780	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	197968	0	6095-4	3036780		
169078	5191	4024958	1990-07-18	1990-07-18 00:00:00	1990-07-18	5001	0	\N	0	0	\N	\N	0	345116	0	117015009	4024958		
13192	1259	3006322	2005-03-11	2005-03-11 00:00:00	2005-03-11	5001	0	\N	0	0	\N	\N	0	82978	0	8331-1	3006322		
44181	4071	40758406	1967-02-21	1967-02-21 00:00:00	1967-02-21	5001	0	\N	0	0	\N	\N	0	270586	0	55277-8	40758406		
40897	3793	46235214	2009-04-04	2009-04-04 00:00:00	2009-04-04	5001	0	\N	0	0	\N	\N	0	252184	0	76690-7	46235214		
97883	2992	4052083	2000-10-07	2000-10-07 00:00:00	2000-10-07	5001	0	\N	0	0	\N	\N	0	199743	0	23426006	4052083		
18531	1703	3006322	1951-04-03	1951-04-03 00:00:00	1951-04-03	5001	0	\N	0	0	\N	\N	0	113904	0	8331-1	3006322		
52399	4822	3011505	2018-01-17	2018-01-17 00:00:00	2018-01-17	5001	0	\N	0	0	\N	\N	0	320792	0	19926-5	3011505		
6645	621	3006322	1947-06-30	1947-06-30 00:00:00	1947-06-30	5001	0	\N	0	0	\N	\N	0	41450	0	8331-1	3006322		
53395	4899	40766240	1921-07-01	1921-07-01 00:00:00	1921-07-01	5001	0	\N	0	0	\N	\N	0	325771	0	63513-6	40766240		
53506	4913	3051031	1970-06-13	1970-06-13 00:00:00	1970-06-13	5001	0	\N	0	0	\N	\N	0	326531	0	46240-8	3051031		
41493	3865	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	256669	0	6246-3	3021226		
25819	2369	3020655	1994-05-08	1994-05-08 00:00:00	1994-05-08	5001	0	\N	0	0	\N	\N	0	157687	0	6844-5	3020655		
38072	3514	3006322	1985-09-01	1985-09-01 00:00:00	1985-09-01	5001	0	\N	0	0	\N	\N	0	233186	0	8331-1	3006322		
68385	2088	4133840	1998-05-26	1998-05-26 00:00:00	1998-05-26	5001	0	\N	0	0	\N	\N	0	139234	0	127783003	4133840		
8158	776	3011505	2016-09-15	2016-09-15 00:00:00	2016-09-15	5001	0	\N	0	0	\N	\N	0	51595	0	19926-5	3011505		
97462	2980	4052083	1983-05-22	1983-05-22 00:00:00	1983-05-22	5001	0	\N	0	0	\N	\N	0	199000	0	23426006	4052083		
39308	3628	3006322	1995-10-04	1995-10-04 00:00:00	1995-10-04	5001	0	\N	0	0	\N	\N	0	241363	0	8331-1	3006322		
22810	2088	3051031	1995-12-30	1995-12-30 00:00:00	1995-12-30	5001	0	\N	0	0	\N	\N	0	139232	0	46240-8	3051031		
98622	3020	4133840	2003-01-22	2003-01-22 00:00:00	2003-01-22	5001	0	\N	0	0	\N	\N	0	201430	0	127783003	4133840		
39784	1236	4024958	1971-04-26	1971-04-26 00:00:00	1971-04-26	5001	0	\N	0	0	\N	\N	0	81383	0	117015009	4024958		
17108	1558	3023103	1962-06-14	1962-06-14 00:00:00	1962-06-14	5001	0	\N	0	0	\N	\N	0	104301	0	2823-3	3023103		
134882	4153	4052083	1975-09-19	1975-09-19 00:00:00	1975-09-19	5001	0	\N	0	0	\N	\N	0	276060	0	23426006	4052083		
57115	5245	3036780	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	348961	0	6095-4	3036780		
62711	1923	4024958	1973-03-21	1973-03-21 00:00:00	1973-03-21	5001	0	\N	0	0	\N	\N	0	128004	0	117015009	4024958		
2368	224	3008598	2016-09-24	2016-09-24 00:00:00	2016-09-24	5001	0	\N	0	0	\N	\N	0	15027	0	3024-7	3008598		
2448	236	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	15828	0	6158-0	3019406		
20499	1882	3005136	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	125508	0	6075-6	3005136		
50557	4608	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	307006	0	6189-5	3006734		
47807	4376	46235214	1999-03-04	1999-03-04 00:00:00	1999-03-04	5001	0	\N	0	0	\N	\N	0	290740	0	76690-7	46235214		
47849	4382	3006322	1984-12-22	1984-12-22 00:00:00	1984-12-22	5001	0	\N	0	0	\N	\N	0	291251	0	8331-1	3006322		
132648	4085	4052083	1983-06-09	1983-06-09 00:00:00	1983-06-09	5001	0	\N	0	0	\N	\N	0	271495	0	23426006	4052083		
115554	3562	4024958	1997-02-04	1997-02-04 00:00:00	1997-02-04	5001	0	\N	0	0	\N	\N	0	236618	0	117015009	4024958		
14760	461	4052083	2011-03-11	2011-03-11 00:00:00	2011-03-11	5001	0	\N	0	0	\N	\N	0	30796	0	23426006	4052083		
62996	1935	4024958	1981-05-01	1981-05-01 00:00:00	1981-05-01	5001	0	\N	0	0	\N	\N	0	128711	0	117015009	4024958		
20399	1874	3006322	2011-01-27	2011-01-27 00:00:00	2011-01-27	5001	0	\N	0	0	\N	\N	0	125133	0	8331-1	3006322		
7403	711	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	47201	0	6833-8	3023430		
5208	158	4052083	1995-03-23	1995-03-23 00:00:00	1995-03-23	5001	0	\N	0	0	\N	\N	0	10823	0	23426006	4052083		
38547	3566	3012494	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	236892	0	6206-7	3012494		
5357	162	4052083	2013-12-31	2013-12-31 00:00:00	2013-12-31	5001	0	\N	0	0	\N	\N	0	11096	0	23426006	4052083		
97321	2976	4024958	1956-08-20	1956-08-20 00:00:00	1956-08-20	5001	0	\N	0	0	\N	\N	0	198744	0	117015009	4024958		
44635	4121	40766240	1921-08-16	1921-08-16 00:00:00	1921-08-16	5001	0	\N	0	0	\N	\N	0	273954	0	63513-6	40766240		
44726	4130	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	274534	0	7258-7	3001488		
30678	2815	3006322	1965-08-02	1965-08-02 00:00:00	1965-08-02	5001	0	\N	0	0	\N	\N	0	186546	0	8331-1	3006322		
41874	3879	40766240	2007-01-26	2007-01-26 00:00:00	2007-01-26	5001	0	\N	0	0	\N	\N	0	257733	0	63513-6	40766240		
28076	2580	3006322	1995-02-16	1995-02-16 00:00:00	1995-02-16	5001	0	\N	0	0	\N	\N	0	170930	0	8331-1	3006322		
55431	5083	3006322	1993-09-23	1993-09-23 00:00:00	1993-09-23	5001	0	\N	0	0	\N	\N	0	338027	0	8331-1	3006322		
12049	1144	3006322	1975-03-14	1975-03-14 00:00:00	1975-03-14	5001	0	\N	0	0	\N	\N	0	75470	0	8331-1	3006322		
35474	3244	40766240	1977-01-12	1977-01-12 00:00:00	1977-01-12	5001	0	\N	0	0	\N	\N	0	215731	0	63513-6	40766240		
35896	3295	3006322	2007-08-06	2007-08-06 00:00:00	2007-08-06	5001	0	\N	0	0	\N	\N	0	218886	0	8331-1	3006322		
52632	4835	3006322	1980-07-16	1980-07-16 00:00:00	1980-07-16	5001	0	\N	0	0	\N	\N	0	321638	0	8331-1	3006322		
35865	1112	4024958	2004-08-18	2004-08-18 00:00:00	2004-08-18	5001	0	\N	0	0	\N	\N	0	73169	0	117015009	4024958		
47646	4374	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	290459	0	6844-5	3020655		
19501	1782	3020630	1956-01-11	1956-01-11 00:00:00	1956-01-11	5001	0	\N	0	0	\N	\N	0	119339	0	2885-2	3020630		
145542	4467	4024958	2010-12-29	2010-12-29 00:00:00	2010-12-29	5001	0	\N	0	0	\N	\N	0	297244	0	117015009	4024958		
51675	4731	3006322	1972-07-03	1972-07-03 00:00:00	1972-07-03	5001	0	\N	0	0	\N	\N	0	315191	0	8331-1	3006322		
118700	3652	4024958	2018-01-28	2018-01-28 00:00:00	2018-01-28	5001	0	\N	0	0	\N	\N	0	243124	0	117015009	4024958		
86701	2680	4052083	1975-06-23	1975-06-23 00:00:00	1975-06-23	5001	0	\N	0	0	\N	\N	0	177539	0	23426006	4052083		
171834	5274	4024958	1966-02-20	1966-02-20 00:00:00	1966-02-20	5001	0	\N	0	0	\N	\N	0	350833	0	117015009	4024958		
111372	3439	4024958	1999-07-23	1999-07-23 00:00:00	1999-07-23	5001	0	\N	0	0	\N	\N	0	228211	0	117015009	4024958		
54351	4971	3006322	1986-04-07	1986-04-07 00:00:00	1986-04-07	5001	0	\N	0	0	\N	\N	0	330653	0	8331-1	3006322		
6483	610	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	40591	0	6206-7	3012494		
80359	2476	4052083	1971-04-08	1971-04-08 00:00:00	1971-04-08	5001	0	\N	0	0	\N	\N	0	164100	0	23426006	4052083		
21568	1991	3006322	1981-10-22	1981-10-22 00:00:00	1981-10-22	5001	0	\N	0	0	\N	\N	0	132557	0	8331-1	3006322		
32701	2965	3001247	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	197968	0	6085-5	3001247		
169088	5191	4024958	2013-02-13	2013-02-13 00:00:00	2013-02-13	5001	0	\N	0	0	\N	\N	0	345101	0	117015009	4024958		
29432	2711	40769179	1951-01-01	1951-01-01 00:00:00	1951-01-01	5001	0	\N	0	0	\N	\N	0	179705	0	66519-0	40769179		
44182	4071	46235214	1967-02-21	1967-02-21 00:00:00	1967-02-21	5001	0	\N	0	0	\N	\N	0	270586	0	76690-7	46235214		
40898	3793	40766240	2009-04-04	2009-04-04 00:00:00	2009-04-04	5001	0	\N	0	0	\N	\N	0	252184	0	63513-6	40766240		
97890	2993	4133840	2012-06-23	2012-06-23 00:00:00	2012-06-23	5001	0	\N	0	0	\N	\N	0	199792	0	127783003	4133840		
18532	1703	3006322	1976-03-05	1976-03-05 00:00:00	1976-03-05	5001	0	\N	0	0	\N	\N	0	113911	0	8331-1	3006322		
52400	4822	3011505	2010-12-08	2010-12-08 00:00:00	2010-12-08	5001	0	\N	0	0	\N	\N	0	320705	0	19926-5	3011505		
6667	624	3049273	2011-07-17	2011-07-17 00:00:00	2011-07-17	5001	0	\N	0	0	\N	\N	0	41695	0	38265-5	3049273		
53397	4899	3051031	1921-07-01	1921-07-01 00:00:00	1921-07-01	5001	0	\N	0	0	\N	\N	0	325771	0	46240-8	3051031		
53508	4913	40758406	1970-06-13	1970-06-13 00:00:00	1970-06-13	5001	0	\N	0	0	\N	\N	0	326531	0	55277-8	40758406		
41494	3865	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	256669	0	6085-5	3001247		
25820	2369	3000876	1994-05-08	1994-05-08 00:00:00	1994-05-08	5001	0	\N	0	0	\N	\N	0	157687	0	6082-2	3000876		
38073	3514	3006322	1978-05-31	1978-05-31 00:00:00	1978-05-31	5001	0	\N	0	0	\N	\N	0	233195	0	8331-1	3006322		
156161	4799	4052083	1963-12-16	1963-12-16 00:00:00	1963-12-16	5001	0	\N	0	0	\N	\N	0	319284	0	23426006	4052083		
154946	4753	4024958	1984-11-03	1984-11-03 00:00:00	1984-11-03	5001	0	\N	0	0	\N	\N	0	316546	0	117015009	4024958		
97475	2980	4052083	1993-01-11	1993-01-11 00:00:00	1993-01-11	5001	0	\N	0	0	\N	\N	0	198890	0	23426006	4052083		
39309	3628	3006322	1952-10-28	1952-10-28 00:00:00	1952-10-28	5001	0	\N	0	0	\N	\N	0	241370	0	8331-1	3006322		
22811	2088	46235214	1995-12-30	1995-12-30 00:00:00	1995-12-30	5001	0	\N	0	0	\N	\N	0	139232	0	76690-7	46235214		
98627	3020	4133840	2012-02-01	2012-02-01 00:00:00	2012-02-01	5001	0	\N	0	0	\N	\N	0	201386	0	127783003	4133840		
39809	1237	4052083	1979-07-15	1979-07-15 00:00:00	1979-07-15	5001	0	\N	0	0	\N	\N	0	81523	0	23426006	4052083		
17109	1558	3002385	1962-06-14	1962-06-14 00:00:00	1962-06-14	5001	0	\N	0	0	\N	\N	0	104301	0	30385-9	3002385		
134924	4156	4052083	1992-04-19	1992-04-19 00:00:00	1992-04-19	5001	0	\N	0	0	\N	\N	0	276171	0	23426006	4052083		
57116	5245	3015076	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	348961	0	6248-9	3015076		
62719	1924	4024958	1980-02-21	1980-02-21 00:00:00	1980-02-21	5001	0	\N	0	0	\N	\N	0	128027	0	117015009	4024958		
2369	224	3006322	1966-05-29	1966-05-29 00:00:00	1966-05-29	5001	0	\N	0	0	\N	\N	0	15021	0	8331-1	3006322		
2449	236	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	15828	0	6082-2	3000876		
20500	1882	3001247	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	125508	0	6085-5	3001247		
50558	4608	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	307006	0	6273-7	3006451		
47808	4376	3051031	2013-01-24	2013-01-24 00:00:00	2013-01-24	5001	0	\N	0	0	\N	\N	0	290724	0	46240-8	3051031		
47850	4382	3006322	2016-04-07	2016-04-07 00:00:00	2016-04-07	5001	0	\N	0	0	\N	\N	0	291240	0	8331-1	3006322		
132654	4085	4024958	1969-09-08	1969-09-08 00:00:00	1969-09-08	5001	0	\N	0	0	\N	\N	0	271493	0	117015009	4024958		
115555	3562	4024958	2003-11-24	2003-11-24 00:00:00	2003-11-24	5001	0	\N	0	0	\N	\N	0	236571	0	117015009	4024958		
14768	461	4052083	1993-02-07	1993-02-07 00:00:00	1993-02-07	5001	0	\N	0	0	\N	\N	0	30816	0	23426006	4052083		
15713	1438	3006322	1997-01-02	1997-01-02 00:00:00	1997-01-02	5001	0	\N	0	0	\N	\N	0	95809	0	8331-1	3006322		
20400	1874	3006322	1986-08-08	1986-08-08 00:00:00	1986-08-08	5001	0	\N	0	0	\N	\N	0	125130	0	8331-1	3006322		
7404	711	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	47201	0	6844-5	3020655		
5214	158	4052083	2014-03-29	2014-03-29 00:00:00	2014-03-29	5001	0	\N	0	0	\N	\N	0	10846	0	23426006	4052083		
38548	3566	3021226	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	236892	0	6246-3	3021226		
5369	162	4024958	1980-07-26	1980-07-26 00:00:00	1980-07-26	5001	0	\N	0	0	\N	\N	0	11163	0	117015009	4024958		
97322	2976	4133840	1990-03-15	1990-03-15 00:00:00	1990-03-15	5001	0	\N	0	0	\N	\N	0	198760	0	127783003	4133840		
44637	4121	40758406	1921-08-16	1921-08-16 00:00:00	1921-08-16	5001	0	\N	0	0	\N	\N	0	273954	0	55277-8	40758406		
44727	4130	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	274534	0	6095-4	3036780		
30679	2815	3006322	1986-07-06	1986-07-06 00:00:00	1986-07-06	5001	0	\N	0	0	\N	\N	0	186541	0	8331-1	3006322		
41877	3879	3051031	2007-01-26	2007-01-26 00:00:00	2007-01-26	5001	0	\N	0	0	\N	\N	0	257733	0	46240-8	3051031		
28078	2583	3006322	1999-10-12	1999-10-12 00:00:00	1999-10-12	5001	0	\N	0	0	\N	\N	0	171020	0	8331-1	3006322		
55433	5085	3006322	1986-12-01	1986-12-01 00:00:00	1986-12-01	5001	0	\N	0	0	\N	\N	0	338093	0	8331-1	3006322		
12050	1145	3006322	2002-09-11	2002-09-11 00:00:00	2002-09-11	5001	0	\N	0	0	\N	\N	0	75570	0	8331-1	3006322		
35476	3244	40766240	1990-05-09	1990-05-09 00:00:00	1990-05-09	5001	0	\N	0	0	\N	\N	0	215716	0	63513-6	40766240		
35897	3295	3006322	2005-03-03	2005-03-03 00:00:00	2005-03-03	5001	0	\N	0	0	\N	\N	0	218931	0	8331-1	3006322		
52633	4835	3006322	1996-12-04	1996-12-04 00:00:00	1996-12-04	5001	0	\N	0	0	\N	\N	0	321631	0	8331-1	3006322		
35887	1112	4052083	2000-06-11	2000-06-11 00:00:00	2000-06-11	5001	0	\N	0	0	\N	\N	0	73206	0	23426006	4052083		
47647	4374	3006322	2001-10-05	2001-10-05 00:00:00	2001-10-05	5001	0	\N	0	0	\N	\N	0	290566	0	8331-1	3006322		
19502	1782	3009542	1956-01-11	1956-01-11 00:00:00	1956-01-11	5001	0	\N	0	0	\N	\N	0	119339	0	20570-8	3009542		
145549	4467	4024958	1952-05-25	1952-05-25 00:00:00	1952-05-25	5001	0	\N	0	0	\N	\N	0	297223	0	117015009	4024958		
51676	4731	3006322	1979-04-25	1979-04-25 00:00:00	1979-04-25	5001	0	\N	0	0	\N	\N	0	315192	0	8331-1	3006322		
118707	3652	4024958	1987-04-16	1987-04-16 00:00:00	1987-04-16	5001	0	\N	0	0	\N	\N	0	243080	0	117015009	4024958		
86704	2680	4024958	1985-01-14	1985-01-14 00:00:00	1985-01-14	5001	0	\N	0	0	\N	\N	0	177541	0	117015009	4024958		
9667	911	3006322	2012-03-13	2012-03-13 00:00:00	2012-03-13	5001	0	\N	0	0	\N	\N	0	60482	0	8331-1	3006322		
111377	3439	4024958	1968-06-13	1968-06-13 00:00:00	1968-06-13	5001	0	\N	0	0	\N	\N	0	228141	0	117015009	4024958		
54352	4971	3011505	2008-01-15	2008-01-15 00:00:00	2008-01-15	5001	0	\N	0	0	\N	\N	0	330659	0	19926-5	3011505		
6484	610	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	40591	0	7258-7	3001488		
80369	2477	4024958	1963-10-14	1963-10-14 00:00:00	1963-10-14	5001	0	\N	0	0	\N	\N	0	164206	0	117015009	4024958		
21570	1991	3006322	1987-07-02	1987-07-02 00:00:00	1987-07-02	5001	0	\N	0	0	\N	\N	0	132559	0	8331-1	3006322		
32702	2965	3023430	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	197968	0	6833-8	3023430		
169092	5191	4052083	1993-01-22	1993-01-22 00:00:00	1993-01-22	5001	0	\N	0	0	\N	\N	0	345118	0	23426006	4052083		
29433	2711	40769189	1951-01-01	1951-01-01 00:00:00	1951-01-01	5001	0	\N	0	0	\N	\N	0	179705	0	66529-9	40769189		
44183	4071	3009542	2005-09-19	2005-09-19 00:00:00	2005-09-19	5001	0	\N	0	0	\N	\N	0	270627	0	20570-8	3009542		
40900	3793	3006322	1989-06-02	1989-06-02 00:00:00	1989-06-02	5001	0	\N	0	0	\N	\N	0	252252	0	8331-1	3006322		
97892	2993	4133840	2014-06-28	2014-06-28 00:00:00	2014-06-28	5001	0	\N	0	0	\N	\N	0	199772	0	127783003	4133840		
18569	1707	3006322	1991-06-20	1991-06-20 00:00:00	1991-06-20	5001	0	\N	0	0	\N	\N	0	114130	0	8331-1	3006322		
52401	4822	40758406	1954-12-16	1954-12-16 00:00:00	1954-12-16	5001	0	\N	0	0	\N	\N	0	320779	0	55277-8	40758406		
6668	624	3006322	1994-02-18	1994-02-18 00:00:00	1994-02-18	5001	0	\N	0	0	\N	\N	0	41663	0	8331-1	3006322		
53399	4899	46235214	1921-07-01	1921-07-01 00:00:00	1921-07-01	5001	0	\N	0	0	\N	\N	0	325771	0	76690-7	46235214		
53510	4913	40766240	1970-06-13	1970-06-13 00:00:00	1970-06-13	5001	0	\N	0	0	\N	\N	0	326531	0	63513-6	40766240		
41495	3865	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	256669	0	7258-7	3001488		
25821	2369	3001488	1994-05-08	1994-05-08 00:00:00	1994-05-08	5001	0	\N	0	0	\N	\N	0	157687	0	7258-7	3001488		
38074	3514	3009542	1997-08-13	1997-08-13 00:00:00	1997-08-13	5001	0	\N	0	0	\N	\N	0	233216	0	20570-8	3009542		
156163	4799	4024958	1970-02-14	1970-02-14 00:00:00	1970-02-14	5001	0	\N	0	0	\N	\N	0	319203	0	117015009	4024958		
154966	4753	4024958	1982-12-31	1982-12-31 00:00:00	1982-12-31	5001	0	\N	0	0	\N	\N	0	316491	0	117015009	4024958		
154975	4753	4024958	1985-05-14	1985-05-14 00:00:00	1985-05-14	5001	0	\N	0	0	\N	\N	0	316570	0	117015009	4024958		
39310	3628	3006322	1927-05-27	1927-05-27 00:00:00	1927-05-27	5001	0	\N	0	0	\N	\N	0	241297	0	8331-1	3006322		
22813	2088	40758406	1995-12-30	1995-12-30 00:00:00	1995-12-30	5001	0	\N	0	0	\N	\N	0	139232	0	55277-8	40758406		
39754	1236	4024958	1921-07-27	1921-07-27 00:00:00	1921-07-27	5001	0	\N	0	0	\N	\N	0	81420	0	117015009	4024958		
39811	1237	4024958	1948-12-17	1948-12-17 00:00:00	1948-12-17	5001	0	\N	0	0	\N	\N	0	81511	0	117015009	4024958		
17110	1558	3015632	1962-06-14	1962-06-14 00:00:00	1962-06-14	5001	0	\N	0	0	\N	\N	0	104301	0	2028-9	3015632		
134934	4156	4024958	1957-06-23	1957-06-23 00:00:00	1957-06-23	5001	0	\N	0	0	\N	\N	0	276176	0	117015009	4024958		
57117	5245	3001488	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	348961	0	7258-7	3001488		
27461	2542	3006322	2000-03-26	2000-03-26 00:00:00	2000-03-26	5001	0	\N	0	0	\N	\N	0	168209	0	8331-1	3006322		
2370	225	3006322	1971-03-06	1971-03-06 00:00:00	1971-03-06	5001	0	\N	0	0	\N	\N	0	15208	0	8331-1	3006322		
2450	236	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	15828	0	6085-5	3001247		
20501	1882	3006451	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	125508	0	6273-7	3006451		
50559	4608	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	307006	0	6106-9	3014599		
47810	4376	46235214	2013-01-24	2013-01-24 00:00:00	2013-01-24	5001	0	\N	0	0	\N	\N	0	290724	0	76690-7	46235214		
47851	4382	3006322	1963-05-10	1963-05-10 00:00:00	1963-05-10	5001	0	\N	0	0	\N	\N	0	291205	0	8331-1	3006322		
132667	4085	4052083	1976-10-03	1976-10-03 00:00:00	1976-10-03	5001	0	\N	0	0	\N	\N	0	271540	0	23426006	4052083		
115612	3565	4052083	1977-06-12	1977-06-12 00:00:00	1977-06-12	5001	0	\N	0	0	\N	\N	0	236786	0	23426006	4052083		
14774	461	4052083	1955-04-24	1955-04-24 00:00:00	1955-04-24	5001	0	\N	0	0	\N	\N	0	30807	0	23426006	4052083		
15714	1438	3006322	1982-04-10	1982-04-10 00:00:00	1982-04-10	5001	0	\N	0	0	\N	\N	0	95839	0	8331-1	3006322		
20401	1874	3006322	1987-10-18	1987-10-18 00:00:00	1987-10-18	5001	0	\N	0	0	\N	\N	0	125100	0	8331-1	3006322		
7405	711	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	47201	0	6085-5	3001247		
5217	158	4024958	1952-05-08	1952-05-08 00:00:00	1952-05-08	5001	0	\N	0	0	\N	\N	0	10818	0	117015009	4024958		
38549	3566	3027231	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	236892	0	6276-0	3027231		
16652	520	4052083	1958-03-04	1958-03-04 00:00:00	1958-03-04	5001	0	\N	0	0	\N	\N	0	34666	0	23426006	4052083		
49985	4548	3006734	2000-04-25	2000-04-25 00:00:00	2000-04-25	5001	0	\N	0	0	\N	\N	0	303041	0	6189-5	3006734		
44638	4121	3051031	1921-08-16	1921-08-16 00:00:00	1921-08-16	5001	0	\N	0	0	\N	\N	0	273954	0	46240-8	3051031		
44728	4130	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	274534	0	6106-9	3014599		
30680	2815	3006322	1999-02-23	1999-02-23 00:00:00	1999-02-23	5001	0	\N	0	0	\N	\N	0	186520	0	8331-1	3006322		
41878	3879	46235214	2007-01-26	2007-01-26 00:00:00	2007-01-26	5001	0	\N	0	0	\N	\N	0	257733	0	76690-7	46235214		
28079	2583	3006322	1978-02-28	1978-02-28 00:00:00	1978-02-28	5001	0	\N	0	0	\N	\N	0	171025	0	8331-1	3006322		
55434	5085	3006322	1977-04-11	1977-04-11 00:00:00	1977-04-11	5001	0	\N	0	0	\N	\N	0	338118	0	8331-1	3006322		
12051	1145	3006322	1939-04-24	1939-04-24 00:00:00	1939-04-24	5001	0	\N	0	0	\N	\N	0	75582	0	8331-1	3006322		
35477	3244	40758406	1990-05-09	1990-05-09 00:00:00	1990-05-09	5001	0	\N	0	0	\N	\N	0	215716	0	55277-8	40758406		
35898	3295	3051031	1975-02-27	1975-02-27 00:00:00	1975-02-27	5001	0	\N	0	0	\N	\N	0	218926	0	46240-8	3051031		
52634	4835	3006322	1971-01-26	1971-01-26 00:00:00	1971-01-26	5001	0	\N	0	0	\N	\N	0	321637	0	8331-1	3006322		
35895	1113	4024958	2010-03-13	2010-03-13 00:00:00	2010-03-13	5001	0	\N	0	0	\N	\N	0	73278	0	117015009	4024958		
47648	4374	3006322	1995-05-01	1995-05-01 00:00:00	1995-05-01	5001	0	\N	0	0	\N	\N	0	290565	0	8331-1	3006322		
44080	1356	4024958	2012-09-24	2012-09-24 00:00:00	2012-09-24	5001	0	\N	0	0	\N	\N	0	89905	0	117015009	4024958		
88445	2736	4024958	1976-05-04	1976-05-04 00:00:00	1976-05-04	5001	0	\N	0	0	\N	\N	0	181117	0	117015009	4024958		
51677	4731	3006322	1979-10-03	1979-10-03 00:00:00	1979-10-03	5001	0	\N	0	0	\N	\N	0	315228	0	8331-1	3006322		
118708	3652	4024958	1981-05-03	1981-05-03 00:00:00	1981-05-03	5001	0	\N	0	0	\N	\N	0	243099	0	117015009	4024958		
86716	2680	4024958	1977-09-13	1977-09-13 00:00:00	1977-09-13	5001	0	\N	0	0	\N	\N	0	177540	0	117015009	4024958		
9668	911	3006322	2005-03-08	2005-03-08 00:00:00	2005-03-08	5001	0	\N	0	0	\N	\N	0	60465	0	8331-1	3006322		
111379	3439	4024958	1983-06-06	1983-06-06 00:00:00	1983-06-06	5001	0	\N	0	0	\N	\N	0	228143	0	117015009	4024958		
54353	4971	3011505	2007-01-09	2007-01-09 00:00:00	2007-01-09	5001	0	\N	0	0	\N	\N	0	330506	0	19926-5	3011505		
6485	610	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	40591	0	6189-5	3006734		
10195	973	3006322	2005-12-18	2005-12-18 00:00:00	2005-12-18	5001	0	\N	0	0	\N	\N	0	64773	0	8331-1	3006322		
21571	1991	3006322	1986-12-18	1986-12-18 00:00:00	1986-12-18	5001	0	\N	0	0	\N	\N	0	132558	0	8331-1	3006322		
32703	2965	3027231	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	197968	0	6276-0	3027231		
151880	4653	4024958	1989-05-11	1989-05-11 00:00:00	1989-05-11	5001	0	\N	0	0	\N	\N	0	310128	0	117015009	4024958		
29434	2711	40769194	1951-01-01	1951-01-01 00:00:00	1951-01-01	5001	0	\N	0	0	\N	\N	0	179705	0	66534-9	40769194		
44184	4071	3000963	2005-09-19	2005-09-19 00:00:00	2005-09-19	5001	0	\N	0	0	\N	\N	0	270627	0	718-7	3000963		
40901	3793	3006322	1983-08-22	1983-08-22 00:00:00	1983-08-22	5001	0	\N	0	0	\N	\N	0	252251	0	8331-1	3006322		
97893	2993	4133840	2010-06-19	2010-06-19 00:00:00	2010-06-19	5001	0	\N	0	0	\N	\N	0	199776	0	127783003	4133840		
18570	1707	3006322	1988-01-12	1988-01-12 00:00:00	1988-01-12	5001	0	\N	0	0	\N	\N	0	114141	0	8331-1	3006322		
52402	4822	46235214	1954-12-16	1954-12-16 00:00:00	1954-12-16	5001	0	\N	0	0	\N	\N	0	320779	0	76690-7	46235214		
6669	624	3006322	1996-08-21	1996-08-21 00:00:00	1996-08-21	5001	0	\N	0	0	\N	\N	0	41652	0	8331-1	3006322		
53401	4899	3006322	1934-10-07	1934-10-07 00:00:00	1934-10-07	5001	0	\N	0	0	\N	\N	0	325775	0	8331-1	3006322		
53511	4913	46235214	1970-06-13	1970-06-13 00:00:00	1970-06-13	5001	0	\N	0	0	\N	\N	0	326531	0	76690-7	46235214		
41496	3865	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	256669	0	6189-5	3006734		
25822	2369	3006734	1994-05-08	1994-05-08 00:00:00	1994-05-08	5001	0	\N	0	0	\N	\N	0	157687	0	6189-5	3006734		
38075	3514	3000963	1997-08-13	1997-08-13 00:00:00	1997-08-13	5001	0	\N	0	0	\N	\N	0	233216	0	718-7	3000963		
156175	4799	4024958	1998-08-25	1998-08-25 00:00:00	1998-08-25	5001	0	\N	0	0	\N	\N	0	319262	0	117015009	4024958		
155069	4755	4052083	1932-12-04	1932-12-04 00:00:00	1932-12-04	5001	0	\N	0	0	\N	\N	0	316681	0	23426006	4052083		
154992	4753	4052083	1986-11-28	1986-11-28 00:00:00	1986-11-28	5001	0	\N	0	0	\N	\N	0	316547	0	23426006	4052083		
39311	3628	3049273	1974-12-28	1974-12-28 00:00:00	1974-12-28	5001	0	\N	0	0	\N	\N	0	241311	0	38265-5	3049273		
22815	2088	40766240	1995-12-30	1995-12-30 00:00:00	1995-12-30	5001	0	\N	0	0	\N	\N	0	139232	0	63513-6	40766240		
39769	1236	4024958	1933-12-04	1933-12-04 00:00:00	1933-12-04	5001	0	\N	0	0	\N	\N	0	81363	0	117015009	4024958		
39820	1237	4133840	1989-04-23	1989-04-23 00:00:00	1989-04-23	5001	0	\N	0	0	\N	\N	0	81500	0	127783003	4133840		
17111	1558	3007461	1962-06-14	1962-06-14 00:00:00	1962-06-14	5001	0	\N	0	0	\N	\N	0	104301	0	26515-7	3007461		
100736	3092	4052083	1982-04-27	1982-04-27 00:00:00	1982-04-27	5001	0	\N	0	0	\N	\N	0	205867	0	23426006	4052083		
57118	5245	3001247	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	348961	0	6085-5	3001247		
27462	2542	3006322	1965-12-18	1965-12-18 00:00:00	1965-12-18	5001	0	\N	0	0	\N	\N	0	168074	0	8331-1	3006322		
2371	225	3006322	2012-07-21	2012-07-21 00:00:00	2012-07-21	5001	0	\N	0	0	\N	\N	0	15198	0	8331-1	3006322		
2451	236	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	15828	0	6844-5	3020655		
20502	1882	3012494	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	125508	0	6206-7	3012494		
50560	4608	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	307006	0	6833-8	3023430		
47811	4376	40758406	2013-01-24	2013-01-24 00:00:00	2013-01-24	5001	0	\N	0	0	\N	\N	0	290724	0	55277-8	40758406		
47852	4382	3006322	2007-06-10	2007-06-10 00:00:00	2007-06-10	5001	0	\N	0	0	\N	\N	0	291256	0	8331-1	3006322		
132670	4085	4024958	1986-07-24	1986-07-24 00:00:00	1986-07-24	5001	0	\N	0	0	\N	\N	0	271496	0	117015009	4024958		
115621	3565	4052083	1955-11-21	1955-11-21 00:00:00	1955-11-21	5001	0	\N	0	0	\N	\N	0	236775	0	23426006	4052083		
14779	461	4024958	1969-06-28	1969-06-28 00:00:00	1969-06-28	5001	0	\N	0	0	\N	\N	0	30829	0	117015009	4024958		
15715	1438	3006322	1965-09-22	1965-09-22 00:00:00	1965-09-22	5001	0	\N	0	0	\N	\N	0	95837	0	8331-1	3006322		
20402	1874	3006322	2005-11-24	2005-11-24 00:00:00	2005-11-24	5001	0	\N	0	0	\N	\N	0	125101	0	8331-1	3006322		
7406	711	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	47201	0	6189-5	3006734		
5235	158	4024958	1955-05-05	1955-05-05 00:00:00	1955-05-05	5001	0	\N	0	0	\N	\N	0	10820	0	117015009	4024958		
38550	3566	3006451	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	236892	0	6273-7	3006451		
16658	520	4052083	1964-07-08	1964-07-08 00:00:00	1964-07-08	5001	0	\N	0	0	\N	\N	0	34663	0	23426006	4052083		
49986	4548	3006451	2000-04-25	2000-04-25 00:00:00	2000-04-25	5001	0	\N	0	0	\N	\N	0	303041	0	6273-7	3006451		
44640	4121	3011505	1979-09-23	1979-09-23 00:00:00	1979-09-23	5001	0	\N	0	0	\N	\N	0	273932	0	19926-5	3011505		
44729	4130	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	274534	0	6844-5	3020655		
146998	4506	4052083	1960-02-22	1960-02-22 00:00:00	1960-02-22	5001	0	\N	0	0	\N	\N	0	300169	0	23426006	4052083		
41879	3879	3049273	2010-04-08	2010-04-08 00:00:00	2010-04-08	5001	0	\N	0	0	\N	\N	0	257704	0	38265-5	3049273		
12619	1211	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	79522	0	6082-2	3000876		
55435	5085	3006322	2009-05-14	2009-05-14 00:00:00	2009-05-14	5001	0	\N	0	0	\N	\N	0	338100	0	8331-1	3006322		
12052	1145	3006322	1967-08-17	1967-08-17 00:00:00	1967-08-17	5001	0	\N	0	0	\N	\N	0	75629	0	8331-1	3006322		
35478	3244	3051031	1990-05-09	1990-05-09 00:00:00	1990-05-09	5001	0	\N	0	0	\N	\N	0	215716	0	46240-8	3051031		
35899	3295	46235214	1975-02-27	1975-02-27 00:00:00	1975-02-27	5001	0	\N	0	0	\N	\N	0	218926	0	76690-7	46235214		
171340	5256	4052083	1965-07-16	1965-07-16 00:00:00	1965-07-16	5001	0	\N	0	0	\N	\N	0	349710	0	23426006	4052083		
35902	1113	4024958	2009-07-05	2009-07-05 00:00:00	2009-07-05	5001	0	\N	0	0	\N	\N	0	73277	0	117015009	4024958		
47649	4374	3006322	1985-02-18	1985-02-18 00:00:00	1985-02-18	5001	0	\N	0	0	\N	\N	0	290487	0	8331-1	3006322		
44113	1357	4024958	2012-07-20	2012-07-20 00:00:00	2012-07-20	5001	0	\N	0	0	\N	\N	0	90016	0	117015009	4024958		
88461	2739	4024958	1995-08-14	1995-08-14 00:00:00	1995-08-14	5001	0	\N	0	0	\N	\N	0	181212	0	117015009	4024958		
145604	4470	4052083	2003-02-15	2003-02-15 00:00:00	2003-02-15	5001	0	\N	0	0	\N	\N	0	297381	0	23426006	4052083		
118709	3652	4024958	2002-05-11	2002-05-11 00:00:00	2002-05-11	5001	0	\N	0	0	\N	\N	0	243081	0	117015009	4024958		
86718	2680	4024958	1991-10-20	1991-10-20 00:00:00	1991-10-20	5001	0	\N	0	0	\N	\N	0	177524	0	117015009	4024958		
9669	911	3006322	2004-02-29	2004-02-29 00:00:00	2004-02-29	5001	0	\N	0	0	\N	\N	0	60464	0	8331-1	3006322		
111384	3439	4052083	1970-02-22	1970-02-22 00:00:00	1970-02-22	5001	0	\N	0	0	\N	\N	0	228186	0	23426006	4052083		
54354	4971	3011505	2017-03-07	2017-03-07 00:00:00	2017-03-07	5001	0	\N	0	0	\N	\N	0	330660	0	19926-5	3011505		
6486	610	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	40591	0	6095-4	3036780		
10196	973	3006322	1951-01-20	1951-01-20 00:00:00	1951-01-20	5001	0	\N	0	0	\N	\N	0	64810	0	8331-1	3006322		
21572	1991	3006322	1992-08-26	1992-08-26 00:00:00	1992-08-26	5001	0	\N	0	0	\N	\N	0	132612	0	8331-1	3006322		
32704	2965	3021226	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	197968	0	6246-3	3021226		
151890	4653	4024958	1997-04-13	1997-04-13 00:00:00	1997-04-13	5001	0	\N	0	0	\N	\N	0	310170	0	117015009	4024958		
29435	2711	40769184	1951-01-01	1951-01-01 00:00:00	1951-01-01	5001	0	\N	0	0	\N	\N	0	179705	0	66524-0	40769184		
44186	4071	40758406	1966-09-24	1966-09-24 00:00:00	1966-09-24	5001	0	\N	0	0	\N	\N	0	270576	0	55277-8	40758406		
40902	3793	3006322	1966-10-05	1966-10-05 00:00:00	1966-10-05	5001	0	\N	0	0	\N	\N	0	252263	0	8331-1	3006322		
97903	2993	4133840	2017-05-27	2017-05-27 00:00:00	2017-05-27	5001	0	\N	0	0	\N	\N	0	199773	0	127783003	4133840		
18571	1707	3006322	1988-11-18	1988-11-18 00:00:00	1988-11-18	5001	0	\N	0	0	\N	\N	0	114148	0	8331-1	3006322		
52403	4822	3051031	1954-12-16	1954-12-16 00:00:00	1954-12-16	5001	0	\N	0	0	\N	\N	0	320779	0	46240-8	3051031		
6670	624	3049273	2019-05-27	2019-05-27 00:00:00	2019-05-27	5001	0	\N	0	0	\N	\N	0	41697	0	38265-5	3049273		
53403	4899	3011505	1993-10-12	1993-10-12 00:00:00	1993-10-12	5001	0	\N	0	0	\N	\N	0	325831	0	19926-5	3011505		
53512	4913	46235214	1971-02-08	1971-02-08 00:00:00	1971-02-08	5001	0	\N	0	0	\N	\N	0	326518	0	76690-7	46235214		
41497	3865	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	256669	0	6273-7	3006451		
25823	2369	3006451	1994-05-08	1994-05-08 00:00:00	1994-05-08	5001	0	\N	0	0	\N	\N	0	157687	0	6273-7	3006451		
30674	951	4024958	1952-07-04	1952-07-04 00:00:00	1952-07-04	5001	0	\N	0	0	\N	\N	0	63223	0	117015009	4024958		
156183	4799	4052083	1971-04-07	1971-04-07 00:00:00	1971-04-07	5001	0	\N	0	0	\N	\N	0	319205	0	23426006	4052083		
155092	4756	4052083	1952-03-19	1952-03-19 00:00:00	1952-03-19	5001	0	\N	0	0	\N	\N	0	316863	0	23426006	4052083		
155007	4754	4052083	1991-09-13	1991-09-13 00:00:00	1991-09-13	5001	0	\N	0	0	\N	\N	0	316613	0	23426006	4052083		
39313	3629	3006322	1995-11-03	1995-11-03 00:00:00	1995-11-03	5001	0	\N	0	0	\N	\N	0	241461	0	8331-1	3006322		
22816	2088	3011505	1986-07-08	1986-07-08 00:00:00	1986-07-08	5001	0	\N	0	0	\N	\N	0	139286	0	19926-5	3011505		
39773	1236	4024958	2002-12-20	2002-12-20 00:00:00	2002-12-20	5001	0	\N	0	0	\N	\N	0	81365	0	117015009	4024958		
39823	1237	4024958	1967-09-28	1967-09-28 00:00:00	1967-09-28	5001	0	\N	0	0	\N	\N	0	81544	0	117015009	4024958		
17112	1558	3045716	1962-06-14	1962-06-14 00:00:00	1962-06-14	5001	0	\N	0	0	\N	\N	0	104301	0	33037-3	3045716		
100755	3093	4052083	2016-07-30	2016-07-30 00:00:00	2016-07-30	5001	0	\N	0	0	\N	\N	0	205910	0	23426006	4052083		
57119	5245	3006734	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	348961	0	6189-5	3006734		
27463	2542	3006322	2006-12-30	2006-12-30 00:00:00	2006-12-30	5001	0	\N	0	0	\N	\N	0	168114	0	8331-1	3006322		
2372	225	3006322	2013-09-25	2013-09-25 00:00:00	2013-09-25	5001	0	\N	0	0	\N	\N	0	15199	0	8331-1	3006322		
2452	236	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	15828	0	6833-8	3023430		
20503	1882	3014599	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	125482	0	6106-9	3014599		
50561	4608	3011505	2012-01-26	2012-01-26 00:00:00	2012-01-26	5001	0	\N	0	0	\N	\N	0	306944	0	19926-5	3011505		
47812	4376	40766240	2013-01-24	2013-01-24 00:00:00	2013-01-24	5001	0	\N	0	0	\N	\N	0	290724	0	63513-6	40766240		
47853	4383	3006322	1981-07-27	1981-07-27 00:00:00	1981-07-27	5001	0	\N	0	0	\N	\N	0	291339	0	8331-1	3006322		
132679	4086	4133840	2010-06-10	2010-06-10 00:00:00	2010-06-10	5001	0	\N	0	0	\N	\N	0	271610	0	127783003	4133840		
150065	4602	4024958	1985-12-26	1985-12-26 00:00:00	1985-12-26	5001	0	\N	0	0	\N	\N	0	306532	0	117015009	4024958		
14793	462	4052083	1981-06-23	1981-06-23 00:00:00	1981-06-23	5001	0	\N	0	0	\N	\N	0	30880	0	23426006	4052083		
15716	1438	3006322	2009-01-13	2009-01-13 00:00:00	2009-01-13	5001	0	\N	0	0	\N	\N	0	95830	0	8331-1	3006322		
20403	1874	3006322	2010-12-15	2010-12-15 00:00:00	2010-12-15	5001	0	\N	0	0	\N	\N	0	125152	0	8331-1	3006322		
7407	711	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	47201	0	6273-7	3006451		
5244	159	4052083	1997-08-18	1997-08-18 00:00:00	1997-08-18	5001	0	\N	0	0	\N	\N	0	10859	0	23426006	4052083		
38551	3566	3006734	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	236892	0	6189-5	3006734		
16669	520	4052083	1975-06-30	1975-06-30 00:00:00	1975-06-30	5001	0	\N	0	0	\N	\N	0	34726	0	23426006	4052083		
49987	4548	3036780	2000-04-25	2000-04-25 00:00:00	2000-04-25	5001	0	\N	0	0	\N	\N	0	303041	0	6095-4	3036780		
44641	4121	3011505	1985-10-27	1985-10-27 00:00:00	1985-10-27	5001	0	\N	0	0	\N	\N	0	274010	0	19926-5	3011505		
44730	4130	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	274534	0	6248-9	3015076		
56224	5165	3006322	1964-03-14	1964-03-14 00:00:00	1964-03-14	5001	0	\N	0	0	\N	\N	0	343267	0	8331-1	3006322		
41880	3879	3006322	1977-02-06	1977-02-06 00:00:00	1977-02-06	5001	0	\N	0	0	\N	\N	0	257691	0	8331-1	3006322		
12620	1211	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	79522	0	6095-4	3036780		
55436	5086	3006322	1970-09-24	1970-09-24 00:00:00	1970-09-24	5001	0	\N	0	0	\N	\N	0	338181	0	8331-1	3006322		
12053	1145	3049273	2011-12-18	2011-12-18 00:00:00	2011-12-18	5001	0	\N	0	0	\N	\N	0	75558	0	38265-5	3049273		
35480	3244	46235214	1990-05-09	1990-05-09 00:00:00	1990-05-09	5001	0	\N	0	0	\N	\N	0	215716	0	76690-7	46235214		
35901	3295	40758406	1975-02-27	1975-02-27 00:00:00	1975-02-27	5001	0	\N	0	0	\N	\N	0	218926	0	55277-8	40758406		
171343	5256	4024958	1986-05-20	1986-05-20 00:00:00	1986-05-20	5001	0	\N	0	0	\N	\N	0	349719	0	117015009	4024958		
139238	4288	4024958	1966-10-11	1966-10-11 00:00:00	1966-10-11	5001	0	\N	0	0	\N	\N	0	284663	0	117015009	4024958		
47650	4374	3006322	1982-08-21	1982-08-21 00:00:00	1982-08-21	5001	0	\N	0	0	\N	\N	0	290574	0	8331-1	3006322		
44123	1357	4052083	2015-04-22	2015-04-22 00:00:00	2015-04-22	5001	0	\N	0	0	\N	\N	0	90017	0	23426006	4052083		
88464	2739	4024958	1962-03-31	1962-03-31 00:00:00	1962-03-31	5001	0	\N	0	0	\N	\N	0	181210	0	117015009	4024958		
145606	4470	4052083	2017-08-09	2017-08-09 00:00:00	2017-08-09	5001	0	\N	0	0	\N	\N	0	297393	0	23426006	4052083		
118711	3652	4024958	1977-09-22	1977-09-22 00:00:00	1977-09-22	5001	0	\N	0	0	\N	\N	0	243078	0	117015009	4024958		
86719	2680	4052083	1981-04-09	1981-04-09 00:00:00	1981-04-09	5001	0	\N	0	0	\N	\N	0	177516	0	23426006	4052083		
9670	911	3006322	2010-06-09	2010-06-09 00:00:00	2010-06-09	5001	0	\N	0	0	\N	\N	0	60468	0	8331-1	3006322		
111400	3440	4024958	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	228324	0	117015009	4024958		
54355	4971	3006322	1985-05-30	1985-05-30 00:00:00	1985-05-30	5001	0	\N	0	0	\N	\N	0	330652	0	8331-1	3006322		
6487	610	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	40591	0	6085-5	3001247		
10197	973	3006322	1960-09-13	1960-09-13 00:00:00	1960-09-13	5001	0	\N	0	0	\N	\N	0	64833	0	8331-1	3006322		
21573	1991	3006322	2008-07-14	2008-07-14 00:00:00	2008-07-14	5001	0	\N	0	0	\N	\N	0	132560	0	8331-1	3006322		
32705	2965	3005136	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	197968	0	6075-6	3005136		
103152	3174	4052083	1989-08-29	1989-08-29 00:00:00	1989-08-29	5001	0	\N	0	0	\N	\N	0	210975	0	23426006	4052083		
29436	2711	3006322	2018-06-09	2018-06-09 00:00:00	2018-06-09	5001	0	\N	0	0	\N	\N	0	179800	0	8331-1	3006322		
44187	4071	3051031	1966-09-24	1966-09-24 00:00:00	1966-09-24	5001	0	\N	0	0	\N	\N	0	270576	0	46240-8	3051031		
40903	3793	3051031	1941-06-25	1941-06-25 00:00:00	1941-06-25	5001	0	\N	0	0	\N	\N	0	252247	0	46240-8	3051031		
97907	2993	4133840	2007-09-01	2007-09-01 00:00:00	2007-09-01	5001	0	\N	0	0	\N	\N	0	199775	0	127783003	4133840		
18605	1709	3006322	1955-04-28	1955-04-28 00:00:00	1955-04-28	5001	0	\N	0	0	\N	\N	0	114298	0	8331-1	3006322		
52406	4822	40766240	1954-12-16	1954-12-16 00:00:00	1954-12-16	5001	0	\N	0	0	\N	\N	0	320779	0	63513-6	40766240		
6671	625	3006322	1999-06-11	1999-06-11 00:00:00	1999-06-11	5001	0	\N	0	0	\N	\N	0	41765	0	8331-1	3006322		
53404	4899	3011505	1972-06-13	1972-06-13 00:00:00	1972-06-13	5001	0	\N	0	0	\N	\N	0	325793	0	19926-5	3011505		
53513	4913	3051031	1971-02-08	1971-02-08 00:00:00	1971-02-08	5001	0	\N	0	0	\N	\N	0	326518	0	46240-8	3051031		
41498	3865	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	256669	0	6106-9	3014599		
25824	2369	3012494	1994-05-08	1994-05-08 00:00:00	1994-05-08	5001	0	\N	0	0	\N	\N	0	157687	0	6206-7	3012494		
30675	951	4024958	1974-08-02	1974-08-02 00:00:00	1974-08-02	5001	0	\N	0	0	\N	\N	0	63165	0	117015009	4024958		
156187	4800	4052083	1977-04-12	1977-04-12 00:00:00	1977-04-12	5001	0	\N	0	0	\N	\N	0	319341	0	23426006	4052083		
155093	4756	4052083	2003-05-26	2003-05-26 00:00:00	2003-05-26	5001	0	\N	0	0	\N	\N	0	316868	0	23426006	4052083		
155009	4754	4024958	2008-07-14	2008-07-14 00:00:00	2008-07-14	5001	0	\N	0	0	\N	\N	0	316656	0	117015009	4024958		
39314	3629	3006322	1989-01-26	1989-01-26 00:00:00	1989-01-26	5001	0	\N	0	0	\N	\N	0	241492	0	8331-1	3006322		
22817	2088	3011505	1972-06-13	1972-06-13 00:00:00	1972-06-13	5001	0	\N	0	0	\N	\N	0	139199	0	19926-5	3011505		
133073	4100	4052083	1979-06-13	1979-06-13 00:00:00	1979-06-13	5001	0	\N	0	0	\N	\N	0	272412	0	23426006	4052083		
39826	1237	4024958	1956-05-04	1956-05-04 00:00:00	1956-05-04	5001	0	\N	0	0	\N	\N	0	81498	0	117015009	4024958		
17113	1558	3028833	1962-06-14	1962-06-14 00:00:00	1962-06-14	5001	0	\N	0	0	\N	\N	0	104301	0	42719-5	3028833		
100763	3093	4052083	2011-02-28	2011-02-28 00:00:00	2011-02-28	5001	0	\N	0	0	\N	\N	0	205908	0	23426006	4052083		
57120	5245	3021226	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	348961	0	6246-3	3021226		
27464	2542	3006322	1984-05-23	1984-05-23 00:00:00	1984-05-23	5001	0	\N	0	0	\N	\N	0	168105	0	8331-1	3006322		
2373	225	3006322	1974-07-29	1974-07-29 00:00:00	1974-07-29	5001	0	\N	0	0	\N	\N	0	15163	0	8331-1	3006322		
2453	236	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	15828	0	7258-7	3001488		
20504	1882	3006734	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	125482	0	6189-5	3006734		
50562	4608	3011505	2003-02-27	2003-02-27 00:00:00	2003-02-27	5001	0	\N	0	0	\N	\N	0	306941	0	19926-5	3011505		
47814	4376	3011505	2000-10-31	2000-10-31 00:00:00	2000-10-31	5001	0	\N	0	0	\N	\N	0	290819	0	19926-5	3011505		
47854	4383	3006322	1975-05-18	1975-05-18 00:00:00	1975-05-18	5001	0	\N	0	0	\N	\N	0	291338	0	8331-1	3006322		
132681	4086	4133840	2019-02-20	2019-02-20 00:00:00	2019-02-20	5001	0	\N	0	0	\N	\N	0	271613	0	127783003	4133840		
150071	4602	4024958	1996-06-16	1996-06-16 00:00:00	1996-06-16	5001	0	\N	0	0	\N	\N	0	306538	0	117015009	4024958		
14816	464	4024958	1986-05-05	1986-05-05 00:00:00	1986-05-05	5001	0	\N	0	0	\N	\N	0	30973	0	117015009	4024958		
15717	1438	3006322	1959-08-11	1959-08-11 00:00:00	1959-08-11	5001	0	\N	0	0	\N	\N	0	95828	0	8331-1	3006322		
20404	1874	3006322	2014-12-22	2014-12-22 00:00:00	2014-12-22	5001	0	\N	0	0	\N	\N	0	125121	0	8331-1	3006322		
7408	711	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	47201	0	6276-0	3027231		
5255	159	4024958	1997-12-11	1997-12-11 00:00:00	1997-12-11	5001	0	\N	0	0	\N	\N	0	10928	0	117015009	4024958		
38552	3566	3036780	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	236892	0	6095-4	3036780		
16673	520	4052083	1993-09-23	1993-09-23 00:00:00	1993-09-23	5001	0	\N	0	0	\N	\N	0	34671	0	23426006	4052083		
49988	4548	3020655	2000-04-25	2000-04-25 00:00:00	2000-04-25	5001	0	\N	0	0	\N	\N	0	303041	0	6844-5	3020655		
44642	4121	3011505	1971-08-08	1971-08-08 00:00:00	1971-08-08	5001	0	\N	0	0	\N	\N	0	273943	0	19926-5	3011505		
44731	4130	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	274534	0	6085-5	3001247		
56225	5165	3006322	1969-08-09	1969-08-09 00:00:00	1969-08-09	5001	0	\N	0	0	\N	\N	0	343288	0	8331-1	3006322		
41881	3879	3049273	2003-06-03	2003-06-03 00:00:00	2003-06-03	5001	0	\N	0	0	\N	\N	0	257728	0	38265-5	3049273		
12621	1211	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	79522	0	6085-5	3001247		
23987	2204	3006322	1950-07-03	1950-07-03 00:00:00	1950-07-03	5001	0	\N	0	0	\N	\N	0	146902	0	8331-1	3006322		
12054	1145	3006322	2016-05-04	2016-05-04 00:00:00	2016-05-04	5001	0	\N	0	0	\N	\N	0	75658	0	8331-1	3006322		
35481	3244	3051031	1990-04-09	1990-04-09 00:00:00	1990-04-09	5001	0	\N	0	0	\N	\N	0	215700	0	46240-8	3051031		
35903	3295	40766240	1975-02-27	1975-02-27 00:00:00	1975-02-27	5001	0	\N	0	0	\N	\N	0	218926	0	63513-6	40766240		
171348	5257	4024958	1979-09-09	1979-09-09 00:00:00	1979-09-09	5001	0	\N	0	0	\N	\N	0	349823	0	117015009	4024958		
139242	4288	4024958	1961-06-28	1961-06-28 00:00:00	1961-06-28	5001	0	\N	0	0	\N	\N	0	284661	0	117015009	4024958		
47651	4374	3006322	1986-08-22	1986-08-22 00:00:00	1986-08-22	5001	0	\N	0	0	\N	\N	0	290488	0	8331-1	3006322		
44134	1358	4052083	1965-03-06	1965-03-06 00:00:00	1965-03-06	5001	0	\N	0	0	\N	\N	0	90044	0	23426006	4052083		
94558	2906	4024958	1931-12-20	1931-12-20 00:00:00	1931-12-20	5001	0	\N	0	0	\N	\N	0	193614	0	117015009	4024958		
145608	4470	4024958	2015-10-21	2015-10-21 00:00:00	2015-10-21	5001	0	\N	0	0	\N	\N	0	297351	0	117015009	4024958		
118736	3654	4024958	2004-06-07	2004-06-07 00:00:00	2004-06-07	5001	0	\N	0	0	\N	\N	0	243241	0	117015009	4024958		
96236	2947	4024958	1989-08-04	1989-08-04 00:00:00	1989-08-04	5001	0	\N	0	0	\N	\N	0	196702	0	117015009	4024958		
9671	911	3006322	1984-04-10	1984-04-10 00:00:00	1984-04-10	5001	0	\N	0	0	\N	\N	0	60527	0	8331-1	3006322		
111406	3440	4024958	1980-12-12	1980-12-12 00:00:00	1980-12-12	5001	0	\N	0	0	\N	\N	0	228260	0	117015009	4024958		
54356	4971	3049273	2004-01-26	2004-01-26 00:00:00	2004-01-26	5001	0	\N	0	0	\N	\N	0	330515	0	38265-5	3049273		
6488	610	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	40591	0	6082-2	3000876		
10198	973	3006322	2001-04-02	2001-04-02 00:00:00	2001-04-02	5001	0	\N	0	0	\N	\N	0	64743	0	8331-1	3006322		
21574	1991	3006322	1991-11-19	1991-11-19 00:00:00	1991-11-19	5001	0	\N	0	0	\N	\N	0	132634	0	8331-1	3006322		
32706	2965	3019406	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	197968	0	6158-0	3019406		
103180	3175	4024958	1957-01-07	1957-01-07 00:00:00	1957-01-07	5001	0	\N	0	0	\N	\N	0	211017	0	117015009	4024958		
29437	2711	3006322	1957-05-10	1957-05-10 00:00:00	1957-05-10	5001	0	\N	0	0	\N	\N	0	179719	0	8331-1	3006322		
44188	4071	40766240	1966-09-24	1966-09-24 00:00:00	1966-09-24	5001	0	\N	0	0	\N	\N	0	270576	0	63513-6	40766240		
40904	3793	46235214	1941-06-25	1941-06-25 00:00:00	1941-06-25	5001	0	\N	0	0	\N	\N	0	252247	0	76690-7	46235214		
97909	2993	4133840	2019-06-01	2019-06-01 00:00:00	2019-06-01	5001	0	\N	0	0	\N	\N	0	199816	0	127783003	4133840		
18606	1709	3006322	1957-05-09	1957-05-09 00:00:00	1957-05-09	5001	0	\N	0	0	\N	\N	0	114299	0	8331-1	3006322		
52407	4822	40766240	1948-12-22	1948-12-22 00:00:00	1948-12-22	5001	0	\N	0	0	\N	\N	0	320776	0	63513-6	40766240		
6672	625	3006322	1998-01-04	1998-01-04 00:00:00	1998-01-04	5001	0	\N	0	0	\N	\N	0	41734	0	8331-1	3006322		
53405	4899	3011505	1992-10-06	1992-10-06 00:00:00	1992-10-06	5001	0	\N	0	0	\N	\N	0	325860	0	19926-5	3011505		
53515	4913	40758406	1971-02-08	1971-02-08 00:00:00	1971-02-08	5001	0	\N	0	0	\N	\N	0	326518	0	55277-8	40758406		
41499	3865	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	256669	0	6833-8	3023430		
25825	2369	3014599	1994-05-08	1994-05-08 00:00:00	1994-05-08	5001	0	\N	0	0	\N	\N	0	157687	0	6106-9	3014599		
52215	4800	3000963	1970-10-29	1970-10-29 00:00:00	1970-10-29	5001	0	\N	0	0	\N	\N	0	319321	0	718-7	3000963		
156208	4800	4052083	2001-01-28	2001-01-28 00:00:00	2001-01-28	5001	0	\N	0	0	\N	\N	0	319299	0	23426006	4052083		
155095	4756	4052083	1949-05-12	1949-05-12 00:00:00	1949-05-12	5001	0	\N	0	0	\N	\N	0	316827	0	23426006	4052083		
166327	5113	4024958	1985-04-30	1985-04-30 00:00:00	1985-04-30	5001	0	\N	0	0	\N	\N	0	339677	0	117015009	4024958		
39315	3629	3006322	1975-08-27	1975-08-27 00:00:00	1975-08-27	5001	0	\N	0	0	\N	\N	0	241495	0	8331-1	3006322		
22818	2088	3011505	2016-07-26	2016-07-26 00:00:00	2016-07-26	5001	0	\N	0	0	\N	\N	0	139292	0	19926-5	3011505		
5675	533	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	35444	0	6085-5	3001247		
39830	1237	4133840	1993-05-02	1993-05-02 00:00:00	1993-05-02	5001	0	\N	0	0	\N	\N	0	81539	0	127783003	4133840		
17114	1558	3009542	1962-06-14	1962-06-14 00:00:00	1962-06-14	5001	0	\N	0	0	\N	\N	0	104301	0	20570-8	3009542		
100764	3093	4024958	1989-11-02	1989-11-02 00:00:00	1989-11-02	5001	0	\N	0	0	\N	\N	0	205954	0	117015009	4024958		
57121	5245	3005136	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	349045	0	6075-6	3005136		
27465	2542	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	168108	0	6273-7	3006451		
2374	225	3027231	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	15177	0	6276-0	3027231		
2454	236	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	15828	0	6106-9	3014599		
20505	1882	3021226	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	125482	0	6246-3	3021226		
50563	4608	3011505	1992-05-28	1992-05-28 00:00:00	1992-05-28	5001	0	\N	0	0	\N	\N	0	307087	0	19926-5	3011505		
47815	4376	3011505	2004-11-23	2004-11-23 00:00:00	2004-11-23	5001	0	\N	0	0	\N	\N	0	290706	0	19926-5	3011505		
47855	4383	3006322	1984-10-05	1984-10-05 00:00:00	1984-10-05	5001	0	\N	0	0	\N	\N	0	291287	0	8331-1	3006322		
132684	4086	4133840	2007-06-07	2007-06-07 00:00:00	2007-06-07	5001	0	\N	0	0	\N	\N	0	271609	0	127783003	4133840		
150072	4602	4052083	1996-04-30	1996-04-30 00:00:00	1996-04-30	5001	0	\N	0	0	\N	\N	0	306542	0	23426006	4052083		
158025	4853	4052083	2018-09-06	2018-09-06 00:00:00	2018-09-06	5001	0	\N	0	0	\N	\N	0	322929	0	23426006	4052083		
15718	1439	3006322	1985-01-05	1985-01-05 00:00:00	1985-01-05	5001	0	\N	0	0	\N	\N	0	95917	0	8331-1	3006322		
31684	2898	3027231	1992-01-21	1992-01-21 00:00:00	1992-01-21	5001	0	\N	0	0	\N	\N	0	193068	0	6276-0	3027231		
7409	711	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	47201	0	6158-0	3019406		
5260	159	4052083	1971-12-17	1971-12-17 00:00:00	1971-12-17	5001	0	\N	0	0	\N	\N	0	10856	0	23426006	4052083		
38553	3566	3023430	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	236892	0	6833-8	3023430		
16684	520	4024958	1971-07-08	1971-07-08 00:00:00	1971-07-08	5001	0	\N	0	0	\N	\N	0	34668	0	117015009	4024958		
49989	4548	3023430	2000-04-25	2000-04-25 00:00:00	2000-04-25	5001	0	\N	0	0	\N	\N	0	303041	0	6833-8	3023430		
44644	4121	3006322	1921-01-16	1921-01-16 00:00:00	1921-01-16	5001	0	\N	0	0	\N	\N	0	273953	0	8331-1	3006322		
44732	4130	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	274534	0	6276-0	3027231		
56226	5165	3006322	1973-02-15	1973-02-15 00:00:00	1973-02-15	5001	0	\N	0	0	\N	\N	0	343289	0	8331-1	3006322		
41882	3879	40769179	1965-12-16	1965-12-16 00:00:00	1965-12-16	5001	0	\N	0	0	\N	\N	0	257730	0	66519-0	40769179		
12622	1211	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	79522	0	6833-8	3023430		
23988	2204	3006322	1955-04-20	1955-04-20 00:00:00	1955-04-20	5001	0	\N	0	0	\N	\N	0	146931	0	8331-1	3006322		
12055	1145	3006322	1986-12-18	1986-12-18 00:00:00	1986-12-18	5001	0	\N	0	0	\N	\N	0	75633	0	8331-1	3006322		
35482	3244	46235214	1990-04-09	1990-04-09 00:00:00	1990-04-09	5001	0	\N	0	0	\N	\N	0	215700	0	76690-7	46235214		
35904	3295	3051031	1952-08-06	1952-08-06 00:00:00	1952-08-06	5001	0	\N	0	0	\N	\N	0	218875	0	46240-8	3051031		
171351	5257	4024958	1988-01-10	1988-01-10 00:00:00	1988-01-10	5001	0	\N	0	0	\N	\N	0	349834	0	117015009	4024958		
139252	4289	4052083	2003-12-24	2003-12-24 00:00:00	2003-12-24	5001	0	\N	0	0	\N	\N	0	284787	0	23426006	4052083		
47652	4374	3006322	1993-12-23	1993-12-23 00:00:00	1993-12-23	5001	0	\N	0	0	\N	\N	0	290529	0	8331-1	3006322		
44136	1358	4052083	1969-04-01	1969-04-01 00:00:00	1969-04-01	5001	0	\N	0	0	\N	\N	0	90045	0	23426006	4052083		
94562	2906	4052083	1970-03-14	1970-03-14 00:00:00	1970-03-14	5001	0	\N	0	0	\N	\N	0	193746	0	23426006	4052083		
145609	4470	4024958	1997-11-04	1997-11-04 00:00:00	1997-11-04	5001	0	\N	0	0	\N	\N	0	297361	0	117015009	4024958		
118740	3654	4052083	1994-02-07	1994-02-07 00:00:00	1994-02-07	5001	0	\N	0	0	\N	\N	0	243202	0	23426006	4052083		
96243	2947	4052083	1987-08-13	1987-08-13 00:00:00	1987-08-13	5001	0	\N	0	0	\N	\N	0	196679	0	23426006	4052083		
9672	911	3006322	1995-11-30	1995-11-30 00:00:00	1995-11-30	5001	0	\N	0	0	\N	\N	0	60467	0	8331-1	3006322		
111417	3440	4024958	1950-03-02	1950-03-02 00:00:00	1950-03-02	5001	0	\N	0	0	\N	\N	0	228319	0	117015009	4024958		
54357	4971	3011505	2010-01-26	2010-01-26 00:00:00	2010-01-26	5001	0	\N	0	0	\N	\N	0	330637	0	19926-5	3011505		
6489	610	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	40591	0	6844-5	3020655		
10199	974	3049273	2014-04-08	2014-04-08 00:00:00	2014-04-08	5001	0	\N	0	0	\N	\N	0	64968	0	38265-5	3049273		
21575	1992	3006322	1977-11-10	1977-11-10 00:00:00	1977-11-10	5001	0	\N	0	0	\N	\N	0	132717	0	8331-1	3006322		
32707	2965	3012494	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	197968	0	6206-7	3012494		
103182	3175	4024958	1987-02-12	1987-02-12 00:00:00	1987-02-12	5001	0	\N	0	0	\N	\N	0	211002	0	117015009	4024958		
29439	2711	3006322	1959-10-13	1959-10-13 00:00:00	1959-10-13	5001	0	\N	0	0	\N	\N	0	179771	0	8331-1	3006322		
44189	4071	46235214	1966-09-24	1966-09-24 00:00:00	1966-09-24	5001	0	\N	0	0	\N	\N	0	270576	0	76690-7	46235214		
40905	3793	40766240	1941-06-25	1941-06-25 00:00:00	1941-06-25	5001	0	\N	0	0	\N	\N	0	252247	0	63513-6	40766240		
97910	2993	4133840	2015-05-23	2015-05-23 00:00:00	2015-05-23	5001	0	\N	0	0	\N	\N	0	199803	0	127783003	4133840		
18607	1709	3006322	2014-08-15	2014-08-15 00:00:00	2014-08-15	5001	0	\N	0	0	\N	\N	0	114258	0	8331-1	3006322		
52409	4822	46235214	1948-12-22	1948-12-22 00:00:00	1948-12-22	5001	0	\N	0	0	\N	\N	0	320776	0	76690-7	46235214		
6673	625	3006322	1979-04-07	1979-04-07 00:00:00	1979-04-07	5001	0	\N	0	0	\N	\N	0	41774	0	8331-1	3006322		
53406	4899	3006322	1925-02-02	1925-02-02 00:00:00	1925-02-02	5001	0	\N	0	0	\N	\N	0	325765	0	8331-1	3006322		
53517	4913	40766240	1971-02-08	1971-02-08 00:00:00	1971-02-08	5001	0	\N	0	0	\N	\N	0	326518	0	63513-6	40766240		
41500	3865	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	256583	0	6206-7	3012494		
25826	2369	3027231	1994-05-08	1994-05-08 00:00:00	1994-05-08	5001	0	\N	0	0	\N	\N	0	157687	0	6276-0	3027231		
52216	4800	3006322	1970-12-29	1970-12-29 00:00:00	1970-12-29	5001	0	\N	0	0	\N	\N	0	319322	0	8331-1	3006322		
156210	4800	4024958	1997-08-20	1997-08-20 00:00:00	1997-08-20	5001	0	\N	0	0	\N	\N	0	319344	0	117015009	4024958		
155096	4756	4052083	1953-06-21	1953-06-21 00:00:00	1953-06-21	5001	0	\N	0	0	\N	\N	0	316828	0	23426006	4052083		
42828	1318	4052083	1998-06-06	1998-06-06 00:00:00	1998-06-06	5001	0	\N	0	0	\N	\N	0	87346	0	23426006	4052083		
39316	3629	3006322	1961-02-24	1961-02-24 00:00:00	1961-02-24	5001	0	\N	0	0	\N	\N	0	241490	0	8331-1	3006322		
22819	2088	3011505	1967-11-14	1967-11-14 00:00:00	1967-11-14	5001	0	\N	0	0	\N	\N	0	139249	0	19926-5	3011505		
5676	533	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	35444	0	6095-4	3036780		
39833	1237	4024958	1963-07-09	1963-07-09 00:00:00	1963-07-09	5001	0	\N	0	0	\N	\N	0	81499	0	117015009	4024958		
17115	1558	3014576	1962-06-14	1962-06-14 00:00:00	1962-06-14	5001	0	\N	0	0	\N	\N	0	104301	0	2075-0	3014576		
100765	3093	4052083	2019-03-26	2019-03-26 00:00:00	2019-03-26	5001	0	\N	0	0	\N	\N	0	205945	0	23426006	4052083		
57122	5245	3027231	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	349045	0	6276-0	3027231		
27466	2542	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	168108	0	6276-0	3027231		
2375	225	3006451	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	15177	0	6273-7	3006451		
2455	236	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	15828	0	6273-7	3006451		
20506	1882	3027231	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	125482	0	6276-0	3027231		
50589	4613	40766240	1987-08-15	1987-08-15 00:00:00	1987-08-15	5001	0	\N	0	0	\N	\N	0	307266	0	63513-6	40766240		
47816	4376	3011505	1986-08-12	1986-08-12 00:00:00	1986-08-12	5001	0	\N	0	0	\N	\N	0	290798	0	19926-5	3011505		
47856	4383	3006322	1983-06-27	1983-06-27 00:00:00	1983-06-27	5001	0	\N	0	0	\N	\N	0	291286	0	8331-1	3006322		
132685	4086	4133840	2016-11-23	2016-11-23 00:00:00	2016-11-23	5001	0	\N	0	0	\N	\N	0	271561	0	127783003	4133840		
150098	4603	4024958	1939-12-13	1939-12-13 00:00:00	1939-12-13	5001	0	\N	0	0	\N	\N	0	306592	0	117015009	4024958		
158053	4855	4024958	1996-10-31	1996-10-31 00:00:00	1996-10-31	5001	0	\N	0	0	\N	\N	0	322995	0	117015009	4024958		
15724	1441	3006322	2016-12-17	2016-12-17 00:00:00	2016-12-17	5001	0	\N	0	0	\N	\N	0	96013	0	8331-1	3006322		
31685	2898	3014599	1992-01-21	1992-01-21 00:00:00	1992-01-21	5001	0	\N	0	0	\N	\N	0	193068	0	6106-9	3014599		
7410	711	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	47201	0	6106-9	3014599		
5262	159	4024958	1994-08-19	1994-08-19 00:00:00	1994-08-19	5001	0	\N	0	0	\N	\N	0	10893	0	117015009	4024958		
38554	3566	3014599	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	236892	0	6106-9	3014599		
16686	520	4052083	1983-06-21	1983-06-21 00:00:00	1983-06-21	5001	0	\N	0	0	\N	\N	0	34697	0	23426006	4052083		
49990	4548	3014599	2000-04-25	2000-04-25 00:00:00	2000-04-25	5001	0	\N	0	0	\N	\N	0	303041	0	6106-9	3014599		
44645	4121	3011505	1978-09-17	1978-09-17 00:00:00	1978-09-17	5001	0	\N	0	0	\N	\N	0	273938	0	19926-5	3011505		
44733	4130	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	274534	0	6158-0	3019406		
56227	5165	3006322	1969-05-31	1969-05-31 00:00:00	1969-05-31	5001	0	\N	0	0	\N	\N	0	343277	0	8331-1	3006322		
41883	3879	40769189	1965-12-16	1965-12-16 00:00:00	1965-12-16	5001	0	\N	0	0	\N	\N	0	257730	0	66529-9	40769189		
12623	1211	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	79522	0	6276-0	3027231		
23989	2204	3006322	1967-06-22	1967-06-22 00:00:00	1967-06-22	5001	0	\N	0	0	\N	\N	0	146904	0	8331-1	3006322		
12056	1145	3006322	2018-09-01	2018-09-01 00:00:00	2018-09-01	5001	0	\N	0	0	\N	\N	0	75546	0	8331-1	3006322		
35484	3244	40758406	1990-04-09	1990-04-09 00:00:00	1990-04-09	5001	0	\N	0	0	\N	\N	0	215700	0	55277-8	40758406		
35905	3295	40758406	1952-08-06	1952-08-06 00:00:00	1952-08-06	5001	0	\N	0	0	\N	\N	0	218875	0	55277-8	40758406		
171381	5258	4024958	1966-09-18	1966-09-18 00:00:00	1966-09-18	5001	0	\N	0	0	\N	\N	0	349870	0	117015009	4024958		
139261	4289	4052083	2017-11-11	2017-11-11 00:00:00	2017-11-11	5001	0	\N	0	0	\N	\N	0	284754	0	23426006	4052083		
47653	4374	3001488	1979-06-16	1979-06-16 00:00:00	1979-06-16	5001	0	\N	0	0	\N	\N	0	290554	0	7258-7	3001488		
44140	1358	4024958	1970-07-18	1970-07-18 00:00:00	1970-07-18	5001	0	\N	0	0	\N	\N	0	90046	0	117015009	4024958		
94588	2906	4024958	1962-10-04	1962-10-04 00:00:00	1962-10-04	5001	0	\N	0	0	\N	\N	0	193616	0	117015009	4024958		
145641	4472	4052083	2009-01-28	2009-01-28 00:00:00	2009-01-28	5001	0	\N	0	0	\N	\N	0	297498	0	23426006	4052083		
118749	3654	4024958	1971-10-31	1971-10-31 00:00:00	1971-10-31	5001	0	\N	0	0	\N	\N	0	243238	0	117015009	4024958		
99940	3065	4052083	1976-10-19	1976-10-19 00:00:00	1976-10-19	5001	0	\N	0	0	\N	\N	0	204057	0	23426006	4052083		
9673	911	3006322	1994-04-30	1994-04-30 00:00:00	1994-04-30	5001	0	\N	0	0	\N	\N	0	60462	0	8331-1	3006322		
111420	3440	4024958	1985-06-30	1985-06-30 00:00:00	1985-06-30	5001	0	\N	0	0	\N	\N	0	228261	0	117015009	4024958		
54358	4971	3011505	1999-11-30	1999-11-30 00:00:00	1999-11-30	5001	0	\N	0	0	\N	\N	0	330579	0	19926-5	3011505		
6490	610	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	40591	0	6276-0	3027231		
10200	974	3006322	1969-06-02	1969-06-02 00:00:00	1969-06-02	5001	0	\N	0	0	\N	\N	0	64985	0	8331-1	3006322		
21576	1992	3006734	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	132659	0	6189-5	3006734		
32708	2965	3015076	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	197968	0	6248-9	3015076		
103183	3175	4024958	1999-05-16	1999-05-16 00:00:00	1999-05-16	5001	0	\N	0	0	\N	\N	0	211007	0	117015009	4024958		
29440	2711	3049273	2015-11-03	2015-11-03 00:00:00	2015-11-03	5001	0	\N	0	0	\N	\N	0	179616	0	38265-5	3049273		
44191	4071	40758406	1966-03-28	1966-03-28 00:00:00	1966-03-28	5001	0	\N	0	0	\N	\N	0	270575	0	55277-8	40758406		
40908	3793	40758406	1941-06-25	1941-06-25 00:00:00	1941-06-25	5001	0	\N	0	0	\N	\N	0	252247	0	55277-8	40758406		
97911	2993	4133840	2004-08-28	2004-08-28 00:00:00	2004-08-28	5001	0	\N	0	0	\N	\N	0	199774	0	127783003	4133840		
64276	1976	4052083	2008-06-07	2008-06-07 00:00:00	2008-06-07	5001	0	\N	0	0	\N	\N	0	131391	0	23426006	4052083		
52410	4822	3051031	1948-12-22	1948-12-22 00:00:00	1948-12-22	5001	0	\N	0	0	\N	\N	0	320776	0	46240-8	3051031		
6674	625	3006322	1979-06-17	1979-06-17 00:00:00	1979-06-17	5001	0	\N	0	0	\N	\N	0	41741	0	8331-1	3006322		
53407	4899	3011505	1977-07-12	1977-07-12 00:00:00	1977-07-12	5001	0	\N	0	0	\N	\N	0	325827	0	19926-5	3011505		
53518	4913	3006322	1995-04-10	1995-04-10 00:00:00	1995-04-10	5001	0	\N	0	0	\N	\N	0	326557	0	8331-1	3006322		
41501	3865	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	256583	0	6158-0	3019406		
25827	2369	3015076	1994-05-08	1994-05-08 00:00:00	1994-05-08	5001	0	\N	0	0	\N	\N	0	157687	0	6248-9	3015076		
52217	4801	3006322	2011-10-04	2011-10-04 00:00:00	2011-10-04	5001	0	\N	0	0	\N	\N	0	319405	0	8331-1	3006322		
3269	316	3006322	1990-11-29	1990-11-29 00:00:00	1990-11-29	5001	0	\N	0	0	\N	\N	0	20868	0	8331-1	3006322		
155105	4756	4024958	2006-04-02	2006-04-02 00:00:00	2006-04-02	5001	0	\N	0	0	\N	\N	0	316788	0	117015009	4024958		
42884	1320	4024958	1960-08-01	1960-08-01 00:00:00	1960-08-01	5001	0	\N	0	0	\N	\N	0	87559	0	117015009	4024958		
39317	3630	3006322	1963-09-30	1963-09-30 00:00:00	1963-09-30	5001	0	\N	0	0	\N	\N	0	241515	0	8331-1	3006322		
22820	2088	3011505	1987-07-14	1987-07-14 00:00:00	1987-07-14	5001	0	\N	0	0	\N	\N	0	139254	0	19926-5	3011505		
5677	533	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	35444	0	6844-5	3020655		
39838	1237	4133840	1995-05-07	1995-05-07 00:00:00	1995-05-07	5001	0	\N	0	0	\N	\N	0	81510	0	127783003	4133840		
17116	1558	3024731	1962-06-14	1962-06-14 00:00:00	1962-06-14	5001	0	\N	0	0	\N	\N	0	104301	0	30428-7	3024731		
89561	2770	4052083	1961-10-09	1961-10-09 00:00:00	1961-10-09	5001	0	\N	0	0	\N	\N	0	183389	0	23426006	4052083		
57123	5245	3000876	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	349045	0	6082-2	3000876		
27467	2542	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	168108	0	6206-7	3012494		
2376	225	3021226	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	15177	0	6246-3	3021226		
2456	236	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	15828	0	6276-0	3027231		
20507	1882	3001488	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	125482	0	7258-7	3001488		
50591	4613	3006322	2005-10-07	2005-10-07 00:00:00	2005-10-07	5001	0	\N	0	0	\N	\N	0	307273	0	8331-1	3006322		
47817	4376	3011505	1978-07-18	1978-07-18 00:00:00	1978-07-18	5001	0	\N	0	0	\N	\N	0	290796	0	19926-5	3011505		
47857	4383	3006322	1991-09-11	1991-09-11 00:00:00	1991-09-11	5001	0	\N	0	0	\N	\N	0	291288	0	8331-1	3006322		
132686	4086	4024958	2017-06-10	2017-06-10 00:00:00	2017-06-10	5001	0	\N	0	0	\N	\N	0	271622	0	117015009	4024958		
150099	4603	4052083	1931-02-14	1931-02-14 00:00:00	1931-02-14	5001	0	\N	0	0	\N	\N	0	306626	0	23426006	4052083		
169335	5197	4052083	1964-08-24	1964-08-24 00:00:00	1964-08-24	5001	0	\N	0	0	\N	\N	0	345579	0	23426006	4052083		
15725	1441	3006322	1974-06-03	1974-06-03 00:00:00	1974-06-03	5001	0	\N	0	0	\N	\N	0	96028	0	8331-1	3006322		
31686	2898	3005136	1992-01-21	1992-01-21 00:00:00	1992-01-21	5001	0	\N	0	0	\N	\N	0	193068	0	6075-6	3005136		
7411	711	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	47201	0	6248-9	3015076		
131390	4045	4024958	2004-06-23	2004-06-23 00:00:00	2004-06-23	5001	0	\N	0	0	\N	\N	0	269025	0	117015009	4024958		
38555	3566	3006322	2000-02-03	2000-02-03 00:00:00	2000-02-03	5001	0	\N	0	0	\N	\N	0	236969	0	8331-1	3006322		
16687	520	4024958	1977-03-20	1977-03-20 00:00:00	1977-03-20	5001	0	\N	0	0	\N	\N	0	34669	0	117015009	4024958		
49991	4548	3006322	1998-01-03	1998-01-03 00:00:00	1998-01-03	5001	0	\N	0	0	\N	\N	0	302999	0	8331-1	3006322		
44646	4121	3006322	1930-12-30	1930-12-30 00:00:00	1930-12-30	5001	0	\N	0	0	\N	\N	0	273988	0	8331-1	3006322		
44734	4130	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	274534	0	6273-7	3006451		
56228	5165	3006322	2005-04-22	2005-04-22 00:00:00	2005-04-22	5001	0	\N	0	0	\N	\N	0	343383	0	8331-1	3006322		
41884	3879	40769184	1965-12-16	1965-12-16 00:00:00	1965-12-16	5001	0	\N	0	0	\N	\N	0	257730	0	66524-0	40769184		
12624	1211	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	79522	0	6246-3	3021226		
23990	2204	3006322	1988-06-15	1988-06-15 00:00:00	1988-06-15	5001	0	\N	0	0	\N	\N	0	146918	0	8331-1	3006322		
12057	1145	3049273	2018-08-13	2018-08-13 00:00:00	2018-08-13	5001	0	\N	0	0	\N	\N	0	75559	0	38265-5	3049273		
35485	3244	40766240	1990-04-09	1990-04-09 00:00:00	1990-04-09	5001	0	\N	0	0	\N	\N	0	215700	0	63513-6	40766240		
35906	3295	46235214	1952-08-06	1952-08-06 00:00:00	1952-08-06	5001	0	\N	0	0	\N	\N	0	218875	0	76690-7	46235214		
171383	5258	4052083	1997-11-02	1997-11-02 00:00:00	1997-11-02	5001	0	\N	0	0	\N	\N	0	349891	0	23426006	4052083		
46942	4321	3006322	2004-01-11	2004-01-11 00:00:00	2004-01-11	5001	0	\N	0	0	\N	\N	0	286706	0	8331-1	3006322		
47654	4374	3006734	1979-06-16	1979-06-16 00:00:00	1979-06-16	5001	0	\N	0	0	\N	\N	0	290554	0	6189-5	3006734		
44149	1358	4052083	1964-05-27	1964-05-27 00:00:00	1964-05-27	5001	0	\N	0	0	\N	\N	0	90043	0	23426006	4052083		
94590	2906	4024958	1947-07-11	1947-07-11 00:00:00	1947-07-11	5001	0	\N	0	0	\N	\N	0	193657	0	117015009	4024958		
88492	2739	4024958	1954-12-09	1954-12-09 00:00:00	1954-12-09	5001	0	\N	0	0	\N	\N	0	181269	0	117015009	4024958		
58802	1788	4024958	1976-08-17	1976-08-17 00:00:00	1976-08-17	5001	0	\N	0	0	\N	\N	0	119823	0	117015009	4024958		
99952	3067	4024958	1955-07-12	1955-07-12 00:00:00	1955-07-12	5001	0	\N	0	0	\N	\N	0	204100	0	117015009	4024958		
9674	911	3006322	2008-12-02	2008-12-02 00:00:00	2008-12-02	5001	0	\N	0	0	\N	\N	0	60493	0	8331-1	3006322		
111425	3440	4024958	1962-03-11	1962-03-11 00:00:00	1962-03-11	5001	0	\N	0	0	\N	\N	0	228259	0	117015009	4024958		
54359	4971	3049273	2015-02-24	2015-02-24 00:00:00	2015-02-24	5001	0	\N	0	0	\N	\N	0	330583	0	38265-5	3049273		
6491	610	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	40591	0	6158-0	3019406		
10201	974	3006322	1960-02-07	1960-02-07 00:00:00	1960-02-07	5001	0	\N	0	0	\N	\N	0	64930	0	8331-1	3006322		
21577	1992	3023430	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	132659	0	6833-8	3023430		
32709	2965	3006322	2012-10-05	2012-10-05 00:00:00	2012-10-05	5001	0	\N	0	0	\N	\N	0	197902	0	8331-1	3006322		
103188	3175	4052083	2010-07-09	2010-07-09 00:00:00	2010-07-09	5001	0	\N	0	0	\N	\N	0	211030	0	23426006	4052083		
29441	2711	3001247	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	179667	0	6085-5	3001247		
44192	4071	46235214	1966-03-28	1966-03-28 00:00:00	1966-03-28	5001	0	\N	0	0	\N	\N	0	270575	0	76690-7	46235214		
40909	3793	3006322	1953-07-19	1953-07-19 00:00:00	1953-07-19	5001	0	\N	0	0	\N	\N	0	252261	0	8331-1	3006322		
18444	1691	3006322	1959-12-27	1959-12-27 00:00:00	1959-12-27	5001	0	\N	0	0	\N	\N	0	113258	0	8331-1	3006322		
54621	1657	4024958	1949-04-02	1949-04-02 00:00:00	1949-04-02	5001	0	\N	0	0	\N	\N	0	111211	0	117015009	4024958		
52412	4822	40758406	1948-12-22	1948-12-22 00:00:00	1948-12-22	5001	0	\N	0	0	\N	\N	0	320776	0	55277-8	40758406		
6675	625	3006322	2006-06-19	2006-06-19 00:00:00	2006-06-19	5001	0	\N	0	0	\N	\N	0	41736	0	8331-1	3006322		
53408	4899	3011505	1989-09-19	1989-09-19 00:00:00	1989-09-19	5001	0	\N	0	0	\N	\N	0	325846	0	19926-5	3011505		
53519	4913	3051031	1971-05-09	1971-05-09 00:00:00	1971-05-09	5001	0	\N	0	0	\N	\N	0	326519	0	46240-8	3051031		
41502	3865	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	256583	0	6075-6	3005136		
25828	2369	3023430	1994-05-08	1994-05-08 00:00:00	1994-05-08	5001	0	\N	0	0	\N	\N	0	157687	0	6833-8	3023430		
52218	4801	3006322	1997-08-04	1997-08-04 00:00:00	1997-08-04	5001	0	\N	0	0	\N	\N	0	319356	0	8331-1	3006322		
3270	316	3006322	1939-09-14	1939-09-14 00:00:00	1939-09-14	5001	0	\N	0	0	\N	\N	0	20894	0	8331-1	3006322		
155112	4756	4024958	1944-07-09	1944-07-09 00:00:00	1944-07-09	5001	0	\N	0	0	\N	\N	0	316840	0	117015009	4024958		
42886	1320	4052083	1990-05-06	1990-05-06 00:00:00	1990-05-06	5001	0	\N	0	0	\N	\N	0	87515	0	23426006	4052083		
39318	3630	3049273	2009-02-12	2009-02-12 00:00:00	2009-02-12	5001	0	\N	0	0	\N	\N	0	241557	0	38265-5	3049273		
22821	2088	3011505	1990-07-31	1990-07-31 00:00:00	1990-07-31	5001	0	\N	0	0	\N	\N	0	139236	0	19926-5	3011505		
5678	533	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	35444	0	6248-9	3015076		
39843	1237	4052083	1971-02-18	1971-02-18 00:00:00	1971-02-18	5001	0	\N	0	0	\N	\N	0	81522	0	23426006	4052083		
17117	1558	3006923	1962-06-14	1962-06-14 00:00:00	1962-06-14	5001	0	\N	0	0	\N	\N	0	104301	0	1742-6	3006923		
89579	2771	4052083	1913-07-30	1913-07-30 00:00:00	1913-07-30	5001	0	\N	0	0	\N	\N	0	183415	0	23426006	4052083		
57124	5245	3012494	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	349045	0	6206-7	3012494		
27468	2542	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	168108	0	6075-6	3005136		
2377	225	3005136	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	15177	0	6075-6	3005136		
2457	236	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	15828	0	6095-4	3036780		
20508	1882	3020655	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	125482	0	6844-5	3020655		
50592	4613	40766240	1987-06-16	1987-06-16 00:00:00	1987-06-16	5001	0	\N	0	0	\N	\N	0	307268	0	63513-6	40766240		
47818	4376	3011505	1993-09-21	1993-09-21 00:00:00	1993-09-21	5001	0	\N	0	0	\N	\N	0	290806	0	19926-5	3011505		
47858	4384	3006322	1991-10-03	1991-10-03 00:00:00	1991-10-03	5001	0	\N	0	0	\N	\N	0	291419	0	8331-1	3006322		
132694	4086	4133840	2010-12-08	2010-12-08 00:00:00	2010-12-08	5001	0	\N	0	0	\N	\N	0	271597	0	127783003	4133840		
150106	4603	4052083	1972-04-14	1972-04-14 00:00:00	1972-04-14	5001	0	\N	0	0	\N	\N	0	306652	0	23426006	4052083		
169344	5197	4024958	2002-09-27	2002-09-27 00:00:00	2002-09-27	5001	0	\N	0	0	\N	\N	0	345636	0	117015009	4024958		
15726	1441	40769189	1967-07-09	1967-07-09 00:00:00	1967-07-09	5001	0	\N	0	0	\N	\N	0	95976	0	66529-9	40769189		
31687	2898	3015076	1992-01-21	1992-01-21 00:00:00	1992-01-21	5001	0	\N	0	0	\N	\N	0	193068	0	6248-9	3015076		
7412	711	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	47201	0	6075-6	3005136		
131443	4049	4052083	2017-11-13	2017-11-13 00:00:00	2017-11-13	5001	0	\N	0	0	\N	\N	0	269175	0	23426006	4052083		
38556	3566	3006322	1991-11-04	1991-11-04 00:00:00	1991-11-04	5001	0	\N	0	0	\N	\N	0	236961	0	8331-1	3006322		
131560	4052	4024958	1977-02-11	1977-02-11 00:00:00	1977-02-11	5001	0	\N	0	0	\N	\N	0	269371	0	117015009	4024958		
49992	4548	3006734	1986-11-17	1986-11-17 00:00:00	1986-11-17	5001	0	\N	0	0	\N	\N	0	303082	0	6189-5	3006734		
44647	4121	3011505	1986-11-02	1986-11-02 00:00:00	1986-11-02	5001	0	\N	0	0	\N	\N	0	273992	0	19926-5	3011505		
44735	4130	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	274534	0	6075-6	3005136		
56229	5165	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	343287	0	6075-6	3005136		
41885	3879	40769194	1965-12-16	1965-12-16 00:00:00	1965-12-16	5001	0	\N	0	0	\N	\N	0	257730	0	66534-9	40769194		
12625	1211	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	79522	0	6075-6	3005136		
23991	2204	3006322	2004-09-02	2004-09-02 00:00:00	2004-09-02	5001	0	\N	0	0	\N	\N	0	146937	0	8331-1	3006322		
12058	1145	3006322	1940-05-02	1940-05-02 00:00:00	1940-05-02	5001	0	\N	0	0	\N	\N	0	75560	0	8331-1	3006322		
35487	3244	40758406	1990-03-10	1990-03-10 00:00:00	1990-03-10	5001	0	\N	0	0	\N	\N	0	215713	0	55277-8	40758406		
35909	3295	40766240	1952-08-06	1952-08-06 00:00:00	1952-08-06	5001	0	\N	0	0	\N	\N	0	218875	0	63513-6	40766240		
171384	5258	4024958	1984-03-04	1984-03-04 00:00:00	1984-03-04	5001	0	\N	0	0	\N	\N	0	349849	0	117015009	4024958		
46943	4321	3006322	1969-01-29	1969-01-29 00:00:00	1969-01-29	5001	0	\N	0	0	\N	\N	0	286702	0	8331-1	3006322		
47655	4374	3023430	1979-06-16	1979-06-16 00:00:00	1979-06-16	5001	0	\N	0	0	\N	\N	0	290554	0	6833-8	3023430		
44150	1358	4052083	1987-03-04	1987-03-04 00:00:00	1987-03-04	5001	0	\N	0	0	\N	\N	0	90049	0	23426006	4052083		
94631	2909	4133840	1999-05-30	1999-05-30 00:00:00	1999-05-30	5001	0	\N	0	0	\N	\N	0	193922	0	127783003	4133840		
88499	2740	4024958	1977-04-01	1977-04-01 00:00:00	1977-04-01	5001	0	\N	0	0	\N	\N	0	181292	0	117015009	4024958		
58804	1788	4052083	1991-07-12	1991-07-12 00:00:00	1991-07-12	5001	0	\N	0	0	\N	\N	0	119843	0	23426006	4052083		
99970	3067	4052083	1970-10-09	1970-10-09 00:00:00	1970-10-09	5001	0	\N	0	0	\N	\N	0	204128	0	23426006	4052083		
152155	4662	4024958	1976-02-11	1976-02-11 00:00:00	1976-02-11	5001	0	\N	0	0	\N	\N	0	310788	0	117015009	4024958		
111436	3440	4052083	1957-10-16	1957-10-16 00:00:00	1957-10-16	5001	0	\N	0	0	\N	\N	0	228275	0	23426006	4052083		
54360	4971	3011505	2015-02-24	2015-02-24 00:00:00	2015-02-24	5001	0	\N	0	0	\N	\N	0	330583	0	19926-5	3011505		
6492	610	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	40591	0	6273-7	3006451		
10202	974	3006322	1979-01-22	1979-01-22 00:00:00	1979-01-22	5001	0	\N	0	0	\N	\N	0	64931	0	8331-1	3006322		
21578	1992	3020655	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	132659	0	6844-5	3020655		
32710	2965	3006322	1992-09-20	1992-09-20 00:00:00	1992-09-20	5001	0	\N	0	0	\N	\N	0	197939	0	8331-1	3006322		
103190	3175	4024958	1993-04-04	1993-04-04 00:00:00	1993-04-04	5001	0	\N	0	0	\N	\N	0	211006	0	117015009	4024958		
29442	2711	3006734	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	179667	0	6189-5	3006734		
44194	4071	3051031	1966-03-28	1966-03-28 00:00:00	1966-03-28	5001	0	\N	0	0	\N	\N	0	270575	0	46240-8	3051031		
40910	3793	40766240	1940-12-27	1940-12-27 00:00:00	1940-12-27	5001	0	\N	0	0	\N	\N	0	252264	0	63513-6	40766240		
18445	1691	3006322	1951-07-27	1951-07-27 00:00:00	1951-07-27	5001	0	\N	0	0	\N	\N	0	113261	0	8331-1	3006322		
54629	1657	4024958	1977-10-12	1977-10-12 00:00:00	1977-10-12	5001	0	\N	0	0	\N	\N	0	111229	0	117015009	4024958		
52414	4822	40766240	1955-02-14	1955-02-14 00:00:00	1955-02-14	5001	0	\N	0	0	\N	\N	0	320732	0	63513-6	40766240		
6676	625	3006322	2009-09-13	2009-09-13 00:00:00	2009-09-13	5001	0	\N	0	0	\N	\N	0	41737	0	8331-1	3006322		
53409	4899	3011505	1967-02-21	1967-02-21 00:00:00	1967-02-21	5001	0	\N	0	0	\N	\N	0	325852	0	19926-5	3011505		
53521	4913	40758406	1971-05-09	1971-05-09 00:00:00	1971-05-09	5001	0	\N	0	0	\N	\N	0	326519	0	55277-8	40758406		
41503	3865	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	256583	0	6248-9	3015076		
25829	2369	3019406	1994-05-08	1994-05-08 00:00:00	1994-05-08	5001	0	\N	0	0	\N	\N	0	157687	0	6158-0	3019406		
52219	4801	3006322	1997-04-21	1997-04-21 00:00:00	1997-04-21	5001	0	\N	0	0	\N	\N	0	319358	0	8331-1	3006322		
3271	316	3049273	2012-02-01	2012-02-01 00:00:00	2012-02-01	5001	0	\N	0	0	\N	\N	0	20984	0	38265-5	3049273		
155113	4756	4024958	1946-10-11	1946-10-11 00:00:00	1946-10-11	5001	0	\N	0	0	\N	\N	0	316826	0	117015009	4024958		
100550	3086	4024958	1981-09-18	1981-09-18 00:00:00	1981-09-18	5001	0	\N	0	0	\N	\N	0	205436	0	117015009	4024958		
39319	3630	3006322	1965-05-30	1965-05-30 00:00:00	1965-05-30	5001	0	\N	0	0	\N	\N	0	241563	0	8331-1	3006322		
22822	2088	3011505	2012-03-06	2012-03-06 00:00:00	2012-03-06	5001	0	\N	0	0	\N	\N	0	139284	0	19926-5	3011505		
5679	533	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	35444	0	6276-0	3027231		
39845	1237	4133840	1991-04-28	1991-04-28 00:00:00	1991-04-28	5001	0	\N	0	0	\N	\N	0	81496	0	127783003	4133840		
17118	1558	21494966	1962-06-14	1962-06-14 00:00:00	1962-06-14	5001	0	\N	0	0	\N	\N	0	104301	0	80271-0	21494966		
89637	2771	4024958	1917-12-06	1917-12-06 00:00:00	1917-12-06	5001	0	\N	0	0	\N	\N	0	183416	0	117015009	4024958		
57125	5245	3019406	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	349045	0	6158-0	3019406		
27469	2542	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	168108	0	6248-9	3015076		
2378	225	3012494	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	15177	0	6206-7	3012494		
2458	236	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	15828	0	6248-9	3015076		
20509	1882	3036780	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	125482	0	6095-4	3036780		
50594	4613	46235214	1987-06-16	1987-06-16 00:00:00	1987-06-16	5001	0	\N	0	0	\N	\N	0	307268	0	76690-7	46235214		
47819	4376	3011505	1999-10-26	1999-10-26 00:00:00	1999-10-26	5001	0	\N	0	0	\N	\N	0	290779	0	19926-5	3011505		
47859	4384	3006322	1973-07-29	1973-07-29 00:00:00	1973-07-29	5001	0	\N	0	0	\N	\N	0	291368	0	8331-1	3006322		
132705	4086	4133840	2012-12-12	2012-12-12 00:00:00	2012-12-12	5001	0	\N	0	0	\N	\N	0	271577	0	127783003	4133840		
150131	4604	4052083	1987-10-23	1987-10-23 00:00:00	1987-10-23	5001	0	\N	0	0	\N	\N	0	306714	0	23426006	4052083		
169345	5197	4052083	1960-11-20	1960-11-20 00:00:00	1960-11-20	5001	0	\N	0	0	\N	\N	0	345592	0	23426006	4052083		
15727	1441	40769179	1967-07-09	1967-07-09 00:00:00	1967-07-09	5001	0	\N	0	0	\N	\N	0	95976	0	66519-0	40769179		
31688	2898	3006451	1992-01-21	1992-01-21 00:00:00	1992-01-21	5001	0	\N	0	0	\N	\N	0	193068	0	6273-7	3006451		
7413	711	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	47201	0	6082-2	3000876		
131457	4049	4024958	1993-08-15	1993-08-15 00:00:00	1993-08-15	5001	0	\N	0	0	\N	\N	0	269174	0	117015009	4024958		
38557	3566	3006322	1963-08-23	1963-08-23 00:00:00	1963-08-23	5001	0	\N	0	0	\N	\N	0	236918	0	8331-1	3006322		
142848	4388	4024958	2000-04-04	2000-04-04 00:00:00	2000-04-04	5001	0	\N	0	0	\N	\N	0	291710	0	117015009	4024958		
49993	4548	3020655	1986-11-17	1986-11-17 00:00:00	1986-11-17	5001	0	\N	0	0	\N	\N	0	303082	0	6844-5	3020655		
44648	4121	3006322	1958-09-04	1958-09-04 00:00:00	1958-09-04	5001	0	\N	0	0	\N	\N	0	273995	0	8331-1	3006322		
44736	4130	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	274534	0	6246-3	3021226		
56230	5165	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	343287	0	6273-7	3006451		
53164	4884	3006322	1976-01-16	1976-01-16 00:00:00	1976-01-16	5001	0	\N	0	0	\N	\N	0	324727	0	8331-1	3006322		
12626	1211	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	79522	0	6158-0	3019406		
23992	2204	3009542	1954-09-11	1954-09-11 00:00:00	1954-09-11	5001	0	\N	0	0	\N	\N	0	146930	0	20570-8	3009542		
12059	1145	3006322	1940-12-10	1940-12-10 00:00:00	1940-12-10	5001	0	\N	0	0	\N	\N	0	75561	0	8331-1	3006322		
35488	3244	40766240	1990-03-10	1990-03-10 00:00:00	1990-03-10	5001	0	\N	0	0	\N	\N	0	215713	0	63513-6	40766240		
35910	3295	3051031	1975-03-29	1975-03-29 00:00:00	1975-03-29	5001	0	\N	0	0	\N	\N	0	218917	0	46240-8	3051031		
171385	5258	4024958	2000-04-09	2000-04-09 00:00:00	2000-04-09	5001	0	\N	0	0	\N	\N	0	349859	0	117015009	4024958		
46990	4324	3006322	1984-08-29	1984-08-29 00:00:00	1984-08-29	5001	0	\N	0	0	\N	\N	0	286839	0	8331-1	3006322		
47656	4374	3006451	1979-06-16	1979-06-16 00:00:00	1979-06-16	5001	0	\N	0	0	\N	\N	0	290554	0	6273-7	3006451		
39329	1223	4052083	1989-07-31	1989-07-31 00:00:00	1989-07-31	5001	0	\N	0	0	\N	\N	0	80476	0	23426006	4052083		
94634	2909	4133840	2006-07-09	2006-07-09 00:00:00	2006-07-09	5001	0	\N	0	0	\N	\N	0	193928	0	127783003	4133840		
88502	2740	4024958	1988-03-28	1988-03-28 00:00:00	1988-03-28	5001	0	\N	0	0	\N	\N	0	181286	0	117015009	4024958		
58806	1788	4024958	1976-03-05	1976-03-05 00:00:00	1976-03-05	5001	0	\N	0	0	\N	\N	0	119842	0	117015009	4024958		
99977	3067	4052083	1984-11-14	1984-11-14 00:00:00	1984-11-14	5001	0	\N	0	0	\N	\N	0	204129	0	23426006	4052083		
152167	4662	4024958	1953-08-23	1953-08-23 00:00:00	1953-08-23	5001	0	\N	0	0	\N	\N	0	310728	0	117015009	4024958		
111442	3440	4052083	1954-02-18	1954-02-18 00:00:00	1954-02-18	5001	0	\N	0	0	\N	\N	0	228320	0	23426006	4052083		
54361	4971	3006322	1941-02-01	1941-02-01 00:00:00	1941-02-01	5001	0	\N	0	0	\N	\N	0	330526	0	8331-1	3006322		
6493	610	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	40591	0	6075-6	3005136		
10203	974	3006322	1984-08-02	1984-08-02 00:00:00	1984-08-02	5001	0	\N	0	0	\N	\N	0	64987	0	8331-1	3006322		
21579	1992	3001488	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	132659	0	7258-7	3001488		
32711	2965	3006322	2006-11-19	2006-11-19 00:00:00	2006-11-19	5001	0	\N	0	0	\N	\N	0	197974	0	8331-1	3006322		
103195	3175	4024958	1954-05-09	1954-05-09 00:00:00	1954-05-09	5001	0	\N	0	0	\N	\N	0	211016	0	117015009	4024958		
29443	2711	3000876	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	179667	0	6082-2	3000876		
44195	4071	40766240	1966-03-28	1966-03-28 00:00:00	1966-03-28	5001	0	\N	0	0	\N	\N	0	270575	0	63513-6	40766240		
40911	3793	46235214	1940-12-27	1940-12-27 00:00:00	1940-12-27	5001	0	\N	0	0	\N	\N	0	252264	0	76690-7	46235214		
18446	1691	3006322	1960-02-06	1960-02-06 00:00:00	1960-02-06	5001	0	\N	0	0	\N	\N	0	113259	0	8331-1	3006322		
54660	1657	4024958	1951-12-01	1951-12-01 00:00:00	1951-12-01	5001	0	\N	0	0	\N	\N	0	111174	0	117015009	4024958		
52416	4822	46235214	1955-02-14	1955-02-14 00:00:00	1955-02-14	5001	0	\N	0	0	\N	\N	0	320732	0	76690-7	46235214		
6677	625	3006322	1990-11-28	1990-11-28 00:00:00	1990-11-28	5001	0	\N	0	0	\N	\N	0	41764	0	8331-1	3006322		
53410	4899	3011505	1973-06-19	1973-06-19 00:00:00	1973-06-19	5001	0	\N	0	0	\N	\N	0	325854	0	19926-5	3011505		
32245	1000	4052083	1972-04-20	1972-04-20 00:00:00	1972-04-20	5001	0	\N	0	0	\N	\N	0	66133	0	23426006	4052083		
41504	3865	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	256583	0	6276-0	3027231		
25830	2369	3001247	1994-05-08	1994-05-08 00:00:00	1994-05-08	5001	0	\N	0	0	\N	\N	0	157687	0	6085-5	3001247		
52220	4801	3006322	1985-06-11	1985-06-11 00:00:00	1985-06-11	5001	0	\N	0	0	\N	\N	0	319403	0	8331-1	3006322		
3272	316	3006322	1936-07-19	1936-07-19 00:00:00	1936-07-19	5001	0	\N	0	0	\N	\N	0	20959	0	8331-1	3006322		
155120	4756	4024958	1946-12-24	1946-12-24 00:00:00	1946-12-24	5001	0	\N	0	0	\N	\N	0	316862	0	117015009	4024958		
100552	3086	4024958	1993-12-14	1993-12-14 00:00:00	1993-12-14	5001	0	\N	0	0	\N	\N	0	205428	0	117015009	4024958		
39320	3630	3006322	1980-02-21	1980-02-21 00:00:00	1980-02-21	5001	0	\N	0	0	\N	\N	0	241559	0	8331-1	3006322		
22823	2088	3011505	2007-02-06	2007-02-06 00:00:00	2007-02-06	5001	0	\N	0	0	\N	\N	0	139267	0	19926-5	3011505		
5680	533	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	35444	0	6082-2	3000876		
39853	1238	4024958	1956-09-05	1956-09-05 00:00:00	1956-09-05	5001	0	\N	0	0	\N	\N	0	81573	0	117015009	4024958		
17119	1558	3006906	1962-06-14	1962-06-14 00:00:00	1962-06-14	5001	0	\N	0	0	\N	\N	0	104301	0	17861-6	3006906		
89638	2771	4024958	1942-05-22	1942-05-22 00:00:00	1942-05-22	5001	0	\N	0	0	\N	\N	0	183453	0	117015009	4024958		
57126	5245	3015076	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	349045	0	6248-9	3015076		
27470	2542	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	168108	0	6095-4	3036780		
2379	225	3001247	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	15177	0	6085-5	3001247		
2459	236	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	15828	0	6075-6	3005136		
20510	1882	3000876	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	125482	0	6082-2	3000876		
50595	4613	40758406	1987-06-16	1987-06-16 00:00:00	1987-06-16	5001	0	\N	0	0	\N	\N	0	307268	0	55277-8	40758406		
47820	4376	40766240	1947-09-18	1947-09-18 00:00:00	1947-09-18	5001	0	\N	0	0	\N	\N	0	290742	0	63513-6	40766240		
47860	4384	3006322	1970-11-29	1970-11-29 00:00:00	1970-11-29	5001	0	\N	0	0	\N	\N	0	291367	0	8331-1	3006322		
132713	4086	4133840	2014-12-17	2014-12-17 00:00:00	2014-12-17	5001	0	\N	0	0	\N	\N	0	271611	0	127783003	4133840		
153634	4715	4052083	1996-07-14	1996-07-14 00:00:00	1996-07-14	5001	0	\N	0	0	\N	\N	0	313933	0	23426006	4052083		
726	17	4024958	1965-07-07	1965-07-07 00:00:00	1965-07-07	5001	0	\N	0	0	\N	\N	0	1322	0	117015009	4024958		
15728	1441	40769194	1967-07-09	1967-07-09 00:00:00	1967-07-09	5001	0	\N	0	0	\N	\N	0	95976	0	66534-9	40769194		
31689	2898	3012494	1992-01-21	1992-01-21 00:00:00	1992-01-21	5001	0	\N	0	0	\N	\N	0	193068	0	6206-7	3012494		
7414	711	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	47201	0	6095-4	3036780		
131459	4049	4052083	1990-10-27	1990-10-27 00:00:00	1990-10-27	5001	0	\N	0	0	\N	\N	0	269163	0	23426006	4052083		
38558	3566	3006322	1981-05-20	1981-05-20 00:00:00	1981-05-20	5001	0	\N	0	0	\N	\N	0	236869	0	8331-1	3006322		
142879	4390	4024958	2002-12-30	2002-12-30 00:00:00	2002-12-30	5001	0	\N	0	0	\N	\N	0	291890	0	117015009	4024958		
49994	4548	3023430	1986-11-17	1986-11-17 00:00:00	1986-11-17	5001	0	\N	0	0	\N	\N	0	303082	0	6833-8	3023430		
44649	4121	3006322	1923-07-15	1923-07-15 00:00:00	1923-07-15	5001	0	\N	0	0	\N	\N	0	273987	0	8331-1	3006322		
44737	4130	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	274534	0	6206-7	3012494		
56231	5165	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	343287	0	6248-9	3015076		
53168	4886	3006322	2004-11-02	2004-11-02 00:00:00	2004-11-02	5001	0	\N	0	0	\N	\N	0	324891	0	8331-1	3006322		
12627	1211	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	79522	0	6206-7	3012494		
23993	2204	3000963	1954-09-11	1954-09-11 00:00:00	1954-09-11	5001	0	\N	0	0	\N	\N	0	146930	0	718-7	3000963		
12060	1145	3006322	2004-05-19	2004-05-19 00:00:00	2004-05-19	5001	0	\N	0	0	\N	\N	0	75635	0	8331-1	3006322		
35489	3244	46235214	1990-03-10	1990-03-10 00:00:00	1990-03-10	5001	0	\N	0	0	\N	\N	0	215713	0	76690-7	46235214		
35911	3295	40758406	1975-03-29	1975-03-29 00:00:00	1975-03-29	5001	0	\N	0	0	\N	\N	0	218917	0	55277-8	40758406		
171399	5258	4052083	1984-09-22	1984-09-22 00:00:00	1984-09-22	5001	0	\N	0	0	\N	\N	0	349850	0	23426006	4052083		
46991	4324	3006322	1961-08-12	1961-08-12 00:00:00	1961-08-12	5001	0	\N	0	0	\N	\N	0	286846	0	8331-1	3006322		
47657	4374	3012494	1979-06-16	1979-06-16 00:00:00	1979-06-16	5001	0	\N	0	0	\N	\N	0	290554	0	6206-7	3012494		
39344	1223	4052083	1982-08-20	1982-08-20 00:00:00	1982-08-20	5001	0	\N	0	0	\N	\N	0	80454	0	23426006	4052083		
94638	2909	4133840	1975-03-30	1975-03-30 00:00:00	1975-03-30	5001	0	\N	0	0	\N	\N	0	193923	0	127783003	4133840		
88508	2740	4024958	1978-09-06	1978-09-06 00:00:00	1978-09-06	5001	0	\N	0	0	\N	\N	0	181272	0	117015009	4024958		
58815	1789	4024958	2015-05-23	2015-05-23 00:00:00	2015-05-23	5001	0	\N	0	0	\N	\N	0	119931	0	117015009	4024958		
99980	3067	4052083	1991-09-10	1991-09-10 00:00:00	1991-09-10	5001	0	\N	0	0	\N	\N	0	204103	0	23426006	4052083		
152185	4662	4024958	1971-11-21	1971-11-21 00:00:00	1971-11-21	5001	0	\N	0	0	\N	\N	0	310730	0	117015009	4024958		
5106	155	4052083	2014-04-02	2014-04-02 00:00:00	2014-04-02	5001	0	\N	0	0	\N	\N	0	10556	0	23426006	4052083		
54362	4971	3011505	2003-12-23	2003-12-23 00:00:00	2003-12-23	5001	0	\N	0	0	\N	\N	0	330575	0	19926-5	3011505		
6494	610	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	40591	0	6106-9	3014599		
21481	1980	3027231	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	131811	0	6276-0	3027231		
21580	1992	3036780	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	132659	0	6095-4	3036780		
32712	2965	3006322	1979-07-07	1979-07-07 00:00:00	1979-07-07	5001	0	\N	0	0	\N	\N	0	197921	0	8331-1	3006322		
164566	5051	4052083	1986-10-09	1986-10-09 00:00:00	1986-10-09	5001	0	\N	0	0	\N	\N	0	335895	0	23426006	4052083		
29444	2711	3019406	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	179667	0	6158-0	3019406		
44197	4071	3006322	1989-06-14	1989-06-14 00:00:00	1989-06-14	5001	0	\N	0	0	\N	\N	0	270589	0	8331-1	3006322		
40913	3793	40758406	1940-12-27	1940-12-27 00:00:00	1940-12-27	5001	0	\N	0	0	\N	\N	0	252264	0	55277-8	40758406		
18447	1692	3006322	2012-10-22	2012-10-22 00:00:00	2012-10-22	5001	0	\N	0	0	\N	\N	0	113322	0	8331-1	3006322		
54694	1658	4024958	1918-10-07	1918-10-07 00:00:00	1918-10-07	5001	0	\N	0	0	\N	\N	0	111383	0	117015009	4024958		
52417	4822	40758406	1955-02-14	1955-02-14 00:00:00	1955-02-14	5001	0	\N	0	0	\N	\N	0	320732	0	55277-8	40758406		
6693	636	3006322	1960-12-05	1960-12-05 00:00:00	1960-12-05	5001	0	\N	0	0	\N	\N	0	42179	0	8331-1	3006322		
53411	4899	3006322	1961-01-30	1961-01-30 00:00:00	1961-01-30	5001	0	\N	0	0	\N	\N	0	325838	0	8331-1	3006322		
32260	1000	4024958	1989-08-10	1989-08-10 00:00:00	1989-08-10	5001	0	\N	0	0	\N	\N	0	66200	0	117015009	4024958		
41505	3865	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	256583	0	6082-2	3000876		
25831	2369	3005136	1994-05-08	1994-05-08 00:00:00	1994-05-08	5001	0	\N	0	0	\N	\N	0	157687	0	6075-6	3005136		
52221	4802	3006322	1999-12-11	1999-12-11 00:00:00	1999-12-11	5001	0	\N	0	0	\N	\N	0	319424	0	8331-1	3006322		
3273	316	3006322	2019-03-13	2019-03-13 00:00:00	2019-03-13	5001	0	\N	0	0	\N	\N	0	20965	0	8331-1	3006322		
155257	4760	4024958	2013-03-28	2013-03-28 00:00:00	2013-03-28	5001	0	\N	0	0	\N	\N	0	317124	0	117015009	4024958		
100553	3086	4024958	1982-05-27	1982-05-27 00:00:00	1982-05-27	5001	0	\N	0	0	\N	\N	0	205444	0	117015009	4024958		
39321	3631	3006322	1980-05-17	1980-05-17 00:00:00	1980-05-17	5001	0	\N	0	0	\N	\N	0	241628	0	8331-1	3006322		
22824	2088	3011505	1970-12-01	1970-12-01 00:00:00	1970-12-01	5001	0	\N	0	0	\N	\N	0	139210	0	19926-5	3011505		
5681	533	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	35444	0	6206-7	3012494		
133090	4100	4052083	1947-10-11	1947-10-11 00:00:00	1947-10-11	5001	0	\N	0	0	\N	\N	0	272453	0	23426006	4052083		
17120	1558	3035995	1962-06-14	1962-06-14 00:00:00	1962-06-14	5001	0	\N	0	0	\N	\N	0	104301	0	6768-6	3035995		
42482	3926	3011505	2002-11-25	2002-11-25 00:00:00	2002-11-25	5001	0	\N	0	0	\N	\N	0	261002	0	19926-5	3011505		
57127	5245	3001488	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	349045	0	7258-7	3001488		
27471	2542	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	168108	0	6082-2	3000876		
2380	225	3023430	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	15177	0	6833-8	3023430		
2460	236	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	15828	0	6206-7	3012494		
20511	1882	3015076	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	125482	0	6248-9	3015076		
50596	4613	3051031	1987-06-16	1987-06-16 00:00:00	1987-06-16	5001	0	\N	0	0	\N	\N	0	307268	0	46240-8	3051031		
47821	4376	3051031	1947-09-18	1947-09-18 00:00:00	1947-09-18	5001	0	\N	0	0	\N	\N	0	290742	0	46240-8	3051031		
47907	4387	3006322	1979-08-03	1979-08-03 00:00:00	1979-08-03	5001	0	\N	0	0	\N	\N	0	291607	0	8331-1	3006322		
160971	4945	4024958	1994-11-08	1994-11-08 00:00:00	1994-11-08	5001	0	\N	0	0	\N	\N	0	328727	0	117015009	4024958		
26387	2427	3006322	1959-12-03	1959-12-03 00:00:00	1959-12-03	5001	0	\N	0	0	\N	\N	0	161033	0	8331-1	3006322		
727	17	4024958	1984-06-30	1984-06-30 00:00:00	1984-06-30	5001	0	\N	0	0	\N	\N	0	1287	0	117015009	4024958		
15729	1441	40769184	1967-07-09	1967-07-09 00:00:00	1967-07-09	5001	0	\N	0	0	\N	\N	0	95976	0	66524-0	40769184		
31690	2898	3021226	1992-01-21	1992-01-21 00:00:00	1992-01-21	5001	0	\N	0	0	\N	\N	0	193068	0	6246-3	3021226		
7415	711	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	47201	0	6206-7	3012494		
131460	4049	4024958	1991-06-14	1991-06-14 00:00:00	1991-06-14	5001	0	\N	0	0	\N	\N	0	269172	0	117015009	4024958		
38559	3566	3006322	1979-07-17	1979-07-17 00:00:00	1979-07-17	5001	0	\N	0	0	\N	\N	0	236831	0	8331-1	3006322		
142890	4390	4052083	1985-09-13	1985-09-13 00:00:00	1985-09-13	5001	0	\N	0	0	\N	\N	0	291817	0	23426006	4052083		
49995	4548	3000876	1986-11-17	1986-11-17 00:00:00	1986-11-17	5001	0	\N	0	0	\N	\N	0	303082	0	6082-2	3000876		
44650	4121	3011505	1982-10-10	1982-10-10 00:00:00	1982-10-10	5001	0	\N	0	0	\N	\N	0	273940	0	19926-5	3011505		
44738	4130	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	274534	0	6189-5	3006734		
56232	5165	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	343287	0	6106-9	3014599		
53169	4886	3006322	2009-08-25	2009-08-25 00:00:00	2009-08-25	5001	0	\N	0	0	\N	\N	0	324904	0	8331-1	3006322		
12628	1211	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	79522	0	6248-9	3015076		
23994	2206	3006322	1984-09-29	1984-09-29 00:00:00	1984-09-29	5001	0	\N	0	0	\N	\N	0	147050	0	8331-1	3006322		
12061	1145	3006322	1942-05-20	1942-05-20 00:00:00	1942-05-20	5001	0	\N	0	0	\N	\N	0	75538	0	8331-1	3006322		
35492	3244	3051031	1990-03-10	1990-03-10 00:00:00	1990-03-10	5001	0	\N	0	0	\N	\N	0	215713	0	46240-8	3051031		
35913	3295	46235214	1975-03-29	1975-03-29 00:00:00	1975-03-29	5001	0	\N	0	0	\N	\N	0	218917	0	76690-7	46235214		
171404	5258	4024958	1994-10-27	1994-10-27 00:00:00	1994-10-27	5001	0	\N	0	0	\N	\N	0	349922	0	117015009	4024958		
46992	4324	3006322	1974-09-11	1974-09-11 00:00:00	1974-09-11	5001	0	\N	0	0	\N	\N	0	286847	0	8331-1	3006322		
3587	111	4024958	1994-09-21	1994-09-21 00:00:00	1994-09-21	5001	0	\N	0	0	\N	\N	0	7364	0	117015009	4024958		
50665	1538	4024958	2009-09-26	2009-09-26 00:00:00	2009-09-26	5001	0	\N	0	0	\N	\N	0	102991	0	117015009	4024958		
129265	3980	4024958	1981-12-20	1981-12-20 00:00:00	1981-12-20	5001	0	\N	0	0	\N	\N	0	264614	0	117015009	4024958		
88512	2740	4052083	1975-11-05	1975-11-05 00:00:00	1975-11-05	5001	0	\N	0	0	\N	\N	0	181285	0	23426006	4052083		
58826	1789	4052083	2018-06-13	2018-06-13 00:00:00	2018-06-13	5001	0	\N	0	0	\N	\N	0	119878	0	23426006	4052083		
99988	3067	4052083	1971-07-21	1971-07-21 00:00:00	1971-07-21	5001	0	\N	0	0	\N	\N	0	204153	0	23426006	4052083		
68739	2103	4024958	1983-08-15	1983-08-15 00:00:00	1983-08-15	5001	0	\N	0	0	\N	\N	0	140162	0	117015009	4024958		
5123	155	4052083	2005-07-09	2005-07-09 00:00:00	2005-07-09	5001	0	\N	0	0	\N	\N	0	10535	0	23426006	4052083		
50145	1524	4024958	1998-06-02	1998-06-02 00:00:00	1998-06-02	5001	0	\N	0	0	\N	\N	0	101920	0	117015009	4024958		
6495	610	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	40591	0	6246-3	3021226		
21482	1980	3006451	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	131811	0	6273-7	3006451		
21581	1992	3027231	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	132659	0	6276-0	3027231		
32713	2965	3036780	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	198013	0	6095-4	3036780		
164578	5051	4052083	1992-05-18	1992-05-18 00:00:00	1992-05-18	5001	0	\N	0	0	\N	\N	0	335931	0	23426006	4052083		
29445	2711	3012494	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	179667	0	6206-7	3012494		
44198	4071	40758406	1953-11-01	1953-11-01 00:00:00	1953-11-01	5001	0	\N	0	0	\N	\N	0	270608	0	55277-8	40758406		
40914	3793	3051031	1940-12-27	1940-12-27 00:00:00	1940-12-27	5001	0	\N	0	0	\N	\N	0	252264	0	46240-8	3051031		
18448	1692	3006322	1983-04-14	1983-04-14 00:00:00	1983-04-14	5001	0	\N	0	0	\N	\N	0	113325	0	8331-1	3006322		
54696	1658	4052083	1982-01-12	1982-01-12 00:00:00	1982-01-12	5001	0	\N	0	0	\N	\N	0	111391	0	23426006	4052083		
52418	4822	3051031	1955-02-14	1955-02-14 00:00:00	1955-02-14	5001	0	\N	0	0	\N	\N	0	320732	0	46240-8	3051031		
6694	636	3006322	2004-01-04	2004-01-04 00:00:00	2004-01-04	5001	0	\N	0	0	\N	\N	0	42156	0	8331-1	3006322		
53412	4899	3011505	1983-08-16	1983-08-16 00:00:00	1983-08-16	5001	0	\N	0	0	\N	\N	0	325796	0	19926-5	3011505		
39061	1214	4024958	2018-04-05	2018-04-05 00:00:00	2018-04-05	5001	0	\N	0	0	\N	\N	0	79927	0	117015009	4024958		
41506	3865	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	256583	0	6844-5	3020655		
25832	2369	3021226	1994-05-08	1994-05-08 00:00:00	1994-05-08	5001	0	\N	0	0	\N	\N	0	157687	0	6246-3	3021226		
52222	4802	3006322	2009-08-11	2009-08-11 00:00:00	2009-08-11	5001	0	\N	0	0	\N	\N	0	319439	0	8331-1	3006322		
3274	316	3049273	2007-10-25	2007-10-25 00:00:00	2007-10-25	5001	0	\N	0	0	\N	\N	0	20983	0	38265-5	3049273		
155271	4761	4052083	1986-08-03	1986-08-03 00:00:00	1986-08-03	5001	0	\N	0	0	\N	\N	0	317258	0	23426006	4052083		
100555	3086	4024958	1974-07-14	1974-07-14 00:00:00	1974-07-14	5001	0	\N	0	0	\N	\N	0	205427	0	117015009	4024958		
39322	3631	3006322	1977-12-15	1977-12-15 00:00:00	1977-12-15	5001	0	\N	0	0	\N	\N	0	241593	0	8331-1	3006322		
22825	2088	3011505	1994-05-03	1994-05-03 00:00:00	1994-05-03	5001	0	\N	0	0	\N	\N	0	139203	0	19926-5	3011505		
5682	533	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	35444	0	6158-0	3019406		
133099	4100	4024958	2009-10-12	2009-10-12 00:00:00	2009-10-12	5001	0	\N	0	0	\N	\N	0	272415	0	117015009	4024958		
17121	1558	3004501	1962-06-14	1962-06-14 00:00:00	1962-06-14	5001	0	\N	0	0	\N	\N	0	104301	0	2345-7	3004501		
42483	3926	3006322	1986-09-23	1986-09-23 00:00:00	1986-09-23	5001	0	\N	0	0	\N	\N	0	260980	0	8331-1	3006322		
57128	5245	3001247	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	349045	0	6085-5	3001247		
27472	2542	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	168108	0	6158-0	3019406		
2381	225	3036780	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	15177	0	6095-4	3036780		
2461	236	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	15828	0	6246-3	3021226		
20512	1882	3019406	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	125482	0	6158-0	3019406		
50598	4613	46235214	1987-08-15	1987-08-15 00:00:00	1987-08-15	5001	0	\N	0	0	\N	\N	0	307266	0	76690-7	46235214		
47822	4376	40758406	1947-09-18	1947-09-18 00:00:00	1947-09-18	5001	0	\N	0	0	\N	\N	0	290742	0	55277-8	40758406		
47908	4387	3006322	1992-06-06	1992-06-06 00:00:00	1992-06-06	5001	0	\N	0	0	\N	\N	0	291602	0	8331-1	3006322		
167269	5137	4024958	1995-02-06	1995-02-06 00:00:00	1995-02-06	5001	0	\N	0	0	\N	\N	0	341430	0	117015009	4024958		
26388	2427	3006322	1943-12-06	1943-12-06 00:00:00	1943-12-06	5001	0	\N	0	0	\N	\N	0	160978	0	8331-1	3006322		
737	17	4024958	1974-05-09	1974-05-09 00:00:00	1974-05-09	5001	0	\N	0	0	\N	\N	0	1298	0	117015009	4024958		
15730	1441	3023430	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	95975	0	6833-8	3023430		
31691	2898	3001247	1992-01-21	1992-01-21 00:00:00	1992-01-21	5001	0	\N	0	0	\N	\N	0	193068	0	6085-5	3001247		
7416	711	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	47201	0	7258-7	3001488		
131466	4049	4024958	2018-03-01	2018-03-01 00:00:00	2018-03-01	5001	0	\N	0	0	\N	\N	0	269131	0	117015009	4024958		
38560	3566	3006322	2008-05-02	2008-05-02 00:00:00	2008-05-02	5001	0	\N	0	0	\N	\N	0	236971	0	8331-1	3006322		
142896	4390	4024958	2000-09-30	2000-09-30 00:00:00	2000-09-30	5001	0	\N	0	0	\N	\N	0	291920	0	117015009	4024958		
49996	4548	3005136	1986-11-17	1986-11-17 00:00:00	1986-11-17	5001	0	\N	0	0	\N	\N	0	303082	0	6075-6	3005136		
44651	4121	3006322	1952-02-23	1952-02-23 00:00:00	1952-02-23	5001	0	\N	0	0	\N	\N	0	273976	0	8331-1	3006322		
44739	4130	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	274534	0	6833-8	3023430		
56233	5165	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	343287	0	6158-0	3019406		
53170	4886	3006322	1975-01-14	1975-01-14 00:00:00	1975-01-14	5001	0	\N	0	0	\N	\N	0	324888	0	8331-1	3006322		
12629	1211	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	79579	0	6833-8	3023430		
23995	2206	3006322	2010-08-13	2010-08-13 00:00:00	2010-08-13	5001	0	\N	0	0	\N	\N	0	147025	0	8331-1	3006322		
12062	1145	3006322	2015-05-31	2015-05-31 00:00:00	2015-05-31	5001	0	\N	0	0	\N	\N	0	75636	0	8331-1	3006322		
35493	3246	3006322	1988-01-10	1988-01-10 00:00:00	1988-01-10	5001	0	\N	0	0	\N	\N	0	215812	0	8331-1	3006322		
35915	3295	40766240	1975-03-29	1975-03-29 00:00:00	1975-03-29	5001	0	\N	0	0	\N	\N	0	218917	0	63513-6	40766240		
171412	5258	4052083	1982-11-23	1982-11-23 00:00:00	1982-11-23	5001	0	\N	0	0	\N	\N	0	349890	0	23426006	4052083		
46993	4324	3006322	2000-09-19	2000-09-19 00:00:00	2000-09-19	5001	0	\N	0	0	\N	\N	0	286827	0	8331-1	3006322		
9330	884	3012494	1994-03-15	1994-03-15 00:00:00	1994-03-15	5001	0	\N	0	0	\N	\N	0	58863	0	6206-7	3012494		
50671	1538	4024958	1994-05-19	1994-05-19 00:00:00	1994-05-19	5001	0	\N	0	0	\N	\N	0	103038	0	117015009	4024958		
129272	3980	4024958	1988-06-02	1988-06-02 00:00:00	1988-06-02	5001	0	\N	0	0	\N	\N	0	264580	0	117015009	4024958		
88514	2740	4024958	1990-07-30	1990-07-30 00:00:00	1990-07-30	5001	0	\N	0	0	\N	\N	0	181293	0	117015009	4024958		
58830	1789	4052083	2014-11-16	2014-11-16 00:00:00	2014-11-16	5001	0	\N	0	0	\N	\N	0	119893	0	23426006	4052083		
100000	3067	4052083	2003-10-21	2003-10-21 00:00:00	2003-10-21	5001	0	\N	0	0	\N	\N	0	204180	0	23426006	4052083		
68743	2103	4052083	1978-02-13	1978-02-13 00:00:00	1978-02-13	5001	0	\N	0	0	\N	\N	0	140135	0	23426006	4052083		
43736	4040	3006322	1981-02-13	1981-02-13 00:00:00	1981-02-13	5001	0	\N	0	0	\N	\N	0	268702	0	8331-1	3006322		
50150	1524	4024958	2005-10-31	2005-10-31 00:00:00	2005-10-31	5001	0	\N	0	0	\N	\N	0	101921	0	117015009	4024958		
6496	610	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	40494	0	6273-7	3006451		
21483	1980	3012494	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	131811	0	6206-7	3012494		
21582	1992	3006451	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	132659	0	6273-7	3006451		
32714	2965	3023430	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	198013	0	6833-8	3023430		
13080	1249	3000963	1988-01-20	1988-01-20 00:00:00	1988-01-20	5001	0	\N	0	0	\N	\N	0	82277	0	718-7	3000963		
29446	2711	3023430	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	179667	0	6833-8	3023430		
44199	4071	46235214	1953-11-01	1953-11-01 00:00:00	1953-11-01	5001	0	\N	0	0	\N	\N	0	270608	0	76690-7	46235214		
40916	3793	3006322	1959-10-28	1959-10-28 00:00:00	1959-10-28	5001	0	\N	0	0	\N	\N	0	252182	0	8331-1	3006322		
18458	1695	3006322	2017-10-17	2017-10-17 00:00:00	2017-10-17	5001	0	\N	0	0	\N	\N	0	113446	0	8331-1	3006322		
54697	1658	4024958	1989-09-03	1989-09-03 00:00:00	1989-09-03	5001	0	\N	0	0	\N	\N	0	111344	0	117015009	4024958		
52420	4822	46235214	1949-06-20	1949-06-20 00:00:00	1949-06-20	5001	0	\N	0	0	\N	\N	0	320778	0	76690-7	46235214		
6695	636	3049273	2018-01-04	2018-01-04 00:00:00	2018-01-04	5001	0	\N	0	0	\N	\N	0	42161	0	38265-5	3049273		
53413	4899	3011505	1996-10-29	1996-10-29 00:00:00	1996-10-29	5001	0	\N	0	0	\N	\N	0	325862	0	19926-5	3011505		
39087	1215	4024958	2008-08-31	2008-08-31 00:00:00	2008-08-31	5001	0	\N	0	0	\N	\N	0	80060	0	117015009	4024958		
41507	3865	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	256583	0	6085-5	3001247		
25833	2369	3006322	1981-12-31	1981-12-31 00:00:00	1981-12-31	5001	0	\N	0	0	\N	\N	0	157669	0	8331-1	3006322		
52223	4802	3006322	2008-04-08	2008-04-08 00:00:00	2008-04-08	5001	0	\N	0	0	\N	\N	0	319466	0	8331-1	3006322		
3275	316	3049273	2006-08-31	2006-08-31 00:00:00	2006-08-31	5001	0	\N	0	0	\N	\N	0	20891	0	38265-5	3049273		
79117	2433	4052083	1996-02-06	1996-02-06 00:00:00	1996-02-06	5001	0	\N	0	0	\N	\N	0	161282	0	23426006	4052083		
100558	3086	4052083	2014-10-22	2014-10-22 00:00:00	2014-10-22	5001	0	\N	0	0	\N	\N	0	205446	0	23426006	4052083		
39323	3631	3006322	1991-09-02	1991-09-02 00:00:00	1991-09-02	5001	0	\N	0	0	\N	\N	0	241584	0	8331-1	3006322		
22827	2088	40758406	1996-03-29	1996-03-29 00:00:00	1996-03-29	5001	0	\N	0	0	\N	\N	0	139233	0	55277-8	40758406		
5683	533	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	35444	0	6075-6	3005136		
133102	4100	4024958	1949-09-01	1949-09-01 00:00:00	1949-09-01	5001	0	\N	0	0	\N	\N	0	272454	0	117015009	4024958		
17122	1558	3026361	1962-06-14	1962-06-14 00:00:00	1962-06-14	5001	0	\N	0	0	\N	\N	0	104301	0	26453-1	3026361		
42484	3926	3011505	2007-02-12	2007-02-12 00:00:00	2007-02-12	5001	0	\N	0	0	\N	\N	0	260918	0	19926-5	3011505		
57129	5245	3006734	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	349045	0	6189-5	3006734		
27473	2542	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	168108	0	6246-3	3021226		
2382	225	3020655	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	15177	0	6844-5	3020655		
2462	236	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	15828	0	6189-5	3006734		
20513	1882	3005136	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	125482	0	6075-6	3005136		
50599	4613	40758406	1987-08-15	1987-08-15 00:00:00	1987-08-15	5001	0	\N	0	0	\N	\N	0	307266	0	55277-8	40758406		
47825	4376	46235214	1947-09-18	1947-09-18 00:00:00	1947-09-18	5001	0	\N	0	0	\N	\N	0	290742	0	76690-7	46235214		
47909	4387	3006322	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	291601	0	8331-1	3006322		
167275	5137	4024958	1999-11-22	1999-11-22 00:00:00	1999-11-22	5001	0	\N	0	0	\N	\N	0	341440	0	117015009	4024958		
26389	2427	3006322	1948-06-21	1948-06-21 00:00:00	1948-06-21	5001	0	\N	0	0	\N	\N	0	160979	0	8331-1	3006322		
758	18	4024958	1991-08-01	1991-08-01 00:00:00	1991-08-01	5001	0	\N	0	0	\N	\N	0	1387	0	117015009	4024958		
15731	1441	3001247	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	95975	0	6085-5	3001247		
31692	2898	3001488	1992-01-21	1992-01-21 00:00:00	1992-01-21	5001	0	\N	0	0	\N	\N	0	193068	0	7258-7	3001488		
7417	711	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	47201	0	6246-3	3021226		
85769	2654	4052083	2015-03-31	2015-03-31 00:00:00	2015-03-31	5001	0	\N	0	0	\N	\N	0	175717	0	23426006	4052083		
38561	3566	3006322	1982-06-29	1982-06-29 00:00:00	1982-06-29	5001	0	\N	0	0	\N	\N	0	236870	0	8331-1	3006322		
85899	2657	4024958	1968-01-29	1968-01-29 00:00:00	1968-01-29	5001	0	\N	0	0	\N	\N	0	175967	0	117015009	4024958		
49997	4548	3027231	1986-11-17	1986-11-17 00:00:00	1986-11-17	5001	0	\N	0	0	\N	\N	0	303082	0	6276-0	3027231		
44652	4121	3006322	1978-03-31	1978-03-31 00:00:00	1978-03-31	5001	0	\N	0	0	\N	\N	0	273981	0	8331-1	3006322		
44740	4130	3051031	1995-01-11	1995-01-11 00:00:00	1995-01-11	5001	0	\N	0	0	\N	\N	0	274659	0	46240-8	3051031		
56234	5165	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	343287	0	6085-5	3001247		
53171	4886	3006322	1971-09-06	1971-09-06 00:00:00	1971-09-06	5001	0	\N	0	0	\N	\N	0	324935	0	8331-1	3006322		
12630	1211	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	79579	0	6276-0	3027231		
23996	2206	3006322	1990-02-14	1990-02-14 00:00:00	1990-02-14	5001	0	\N	0	0	\N	\N	0	147052	0	8331-1	3006322		
12063	1146	3006322	1967-04-15	1967-04-15 00:00:00	1967-04-15	5001	0	\N	0	0	\N	\N	0	75715	0	8331-1	3006322		
35494	3246	3006322	2001-06-30	2001-06-30 00:00:00	2001-06-30	5001	0	\N	0	0	\N	\N	0	215805	0	8331-1	3006322		
35916	3296	3006322	2003-12-08	2003-12-08 00:00:00	2003-12-08	5001	0	\N	0	0	\N	\N	0	219067	0	8331-1	3006322		
171413	5259	4052083	1973-02-11	1973-02-11 00:00:00	1973-02-11	5001	0	\N	0	0	\N	\N	0	349972	0	23426006	4052083		
46994	4324	40769194	1981-06-15	1981-06-15 00:00:00	1981-06-15	5001	0	\N	0	0	\N	\N	0	286805	0	66534-9	40769194		
9331	884	3023430	1994-03-15	1994-03-15 00:00:00	1994-03-15	5001	0	\N	0	0	\N	\N	0	58863	0	6833-8	3023430		
85443	2646	4052083	1980-02-13	1980-02-13 00:00:00	1980-02-13	5001	0	\N	0	0	\N	\N	0	175090	0	23426006	4052083		
129275	3980	4024958	2001-08-01	2001-08-01 00:00:00	2001-08-01	5001	0	\N	0	0	\N	\N	0	264581	0	117015009	4024958		
88520	2740	4052083	2008-08-31	2008-08-31 00:00:00	2008-08-31	5001	0	\N	0	0	\N	\N	0	181273	0	23426006	4052083		
58881	1791	4024958	1965-01-11	1965-01-11 00:00:00	1965-01-11	5001	0	\N	0	0	\N	\N	0	120063	0	117015009	4024958		
24975	778	4024958	1980-11-05	1980-11-05 00:00:00	1980-11-05	5001	0	\N	0	0	\N	\N	0	51688	0	117015009	4024958		
68746	2103	4024958	2017-03-10	2017-03-10 00:00:00	2017-03-10	5001	0	\N	0	0	\N	\N	0	140153	0	117015009	4024958		
43737	4040	3006322	1986-11-27	1986-11-27 00:00:00	1986-11-27	5001	0	\N	0	0	\N	\N	0	268671	0	8331-1	3006322		
50156	1525	4024958	2009-01-07	2009-01-07 00:00:00	2009-01-07	5001	0	\N	0	0	\N	\N	0	102023	0	117015009	4024958		
6497	610	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	40494	0	6075-6	3005136		
21484	1980	3020655	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	131811	0	6844-5	3020655		
21583	1992	3014599	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	132659	0	6106-9	3014599		
32715	2965	3021226	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	198013	0	6246-3	3021226		
13081	1249	3009542	1988-01-20	1988-01-20 00:00:00	1988-01-20	5001	0	\N	0	0	\N	\N	0	82277	0	20570-8	3009542		
29447	2711	3036780	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	179667	0	6095-4	3036780		
44201	4071	40766240	1953-11-01	1953-11-01 00:00:00	1953-11-01	5001	0	\N	0	0	\N	\N	0	270608	0	63513-6	40766240		
40917	3793	3006322	2004-10-05	2004-10-05 00:00:00	2004-10-05	5001	0	\N	0	0	\N	\N	0	252235	0	8331-1	3006322		
18459	1695	3006322	1970-11-08	1970-11-08 00:00:00	1970-11-08	5001	0	\N	0	0	\N	\N	0	113435	0	8331-1	3006322		
110382	3407	4024958	1984-01-31	1984-01-31 00:00:00	1984-01-31	5001	0	\N	0	0	\N	\N	0	225982	0	117015009	4024958		
52421	4822	40758406	1949-06-20	1949-06-20 00:00:00	1949-06-20	5001	0	\N	0	0	\N	\N	0	320778	0	55277-8	40758406		
6697	639	3006322	2014-02-24	2014-02-24 00:00:00	2014-02-24	5001	0	\N	0	0	\N	\N	0	42305	0	8331-1	3006322		
53414	4899	3011505	1970-06-02	1970-06-02 00:00:00	1970-06-02	5001	0	\N	0	0	\N	\N	0	325792	0	19926-5	3011505		
39109	1216	4133840	2019-01-22	2019-01-22 00:00:00	2019-01-22	5001	0	\N	0	0	\N	\N	0	80087	0	127783003	4133840		
41508	3865	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	256583	0	6246-3	3021226		
25839	2372	3006322	1970-04-22	1970-04-22 00:00:00	1970-04-22	5001	0	\N	0	0	\N	\N	0	157824	0	8331-1	3006322		
52229	4804	46235214	1983-06-18	1983-06-18 00:00:00	1983-06-18	5001	0	\N	0	0	\N	\N	0	319632	0	76690-7	46235214		
3298	318	3006322	2010-04-01	2010-04-01 00:00:00	2010-04-01	5001	0	\N	0	0	\N	\N	0	21050	0	8331-1	3006322		
90398	2790	4024958	1953-05-21	1953-05-21 00:00:00	1953-05-21	5001	0	\N	0	0	\N	\N	0	184927	0	117015009	4024958		
100561	3086	4052083	1980-05-27	1980-05-27 00:00:00	1980-05-27	5001	0	\N	0	0	\N	\N	0	205435	0	23426006	4052083		
39324	3633	3006322	2013-02-28	2013-02-28 00:00:00	2013-02-28	5001	0	\N	0	0	\N	\N	0	241658	0	8331-1	3006322		
22829	2088	40766240	1996-03-29	1996-03-29 00:00:00	1996-03-29	5001	0	\N	0	0	\N	\N	0	139233	0	63513-6	40766240		
5684	533	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	35444	0	6106-9	3014599		
133104	4101	4052083	1980-06-08	1980-06-08 00:00:00	1980-06-08	5001	0	\N	0	0	\N	\N	0	272516	0	23426006	4052083		
17123	1558	3019550	1962-06-14	1962-06-14 00:00:00	1962-06-14	5001	0	\N	0	0	\N	\N	0	104301	0	2951-2	3019550		
42485	3926	3011505	2001-11-19	2001-11-19 00:00:00	2001-11-19	5001	0	\N	0	0	\N	\N	0	260953	0	19926-5	3011505		
104927	3231	4052083	1996-07-01	1996-07-01 00:00:00	1996-07-01	5001	0	\N	0	0	\N	\N	0	214777	0	23426006	4052083		
27474	2542	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	168108	0	6833-8	3023430		
2383	225	3001488	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	15177	0	7258-7	3001488		
2463	236	3006322	1981-11-22	1981-11-22 00:00:00	1981-11-22	5001	0	\N	0	0	\N	\N	0	15925	0	8331-1	3006322		
20514	1882	3023430	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	125482	0	6833-8	3023430		
50600	4613	3051031	1987-08-15	1987-08-15 00:00:00	1987-08-15	5001	0	\N	0	0	\N	\N	0	307266	0	46240-8	3051031		
47826	4376	3011505	1981-07-14	1981-07-14 00:00:00	1981-07-14	5001	0	\N	0	0	\N	\N	0	290833	0	19926-5	3011505		
47910	4387	3006322	1985-05-20	1985-05-20 00:00:00	1985-05-20	5001	0	\N	0	0	\N	\N	0	291608	0	8331-1	3006322		
167280	5137	4024958	1968-09-15	1968-09-15 00:00:00	1968-09-15	5001	0	\N	0	0	\N	\N	0	341359	0	117015009	4024958		
26390	2427	3006322	2014-03-22	2014-03-22 00:00:00	2014-03-22	5001	0	\N	0	0	\N	\N	0	161013	0	8331-1	3006322		
760	18	4024958	1991-09-13	1991-09-13 00:00:00	1991-09-13	5001	0	\N	0	0	\N	\N	0	1394	0	117015009	4024958		
15732	1441	3015076	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	95975	0	6248-9	3015076		
31693	2898	3006734	1992-01-21	1992-01-21 00:00:00	1992-01-21	5001	0	\N	0	0	\N	\N	0	193068	0	6189-5	3006734		
7418	711	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	47111	0	6833-8	3023430		
27185	2521	3006322	2001-07-06	2001-07-06 00:00:00	2001-07-06	5001	0	\N	0	0	\N	\N	0	166768	0	8331-1	3006322		
38562	3567	3006322	2003-07-22	2003-07-22 00:00:00	2003-07-22	5001	0	\N	0	0	\N	\N	0	236991	0	8331-1	3006322		
85904	2657	4024958	1995-05-25	1995-05-25 00:00:00	1995-05-25	5001	0	\N	0	0	\N	\N	0	175954	0	117015009	4024958		
49998	4548	3012494	1986-11-17	1986-11-17 00:00:00	1986-11-17	5001	0	\N	0	0	\N	\N	0	303082	0	6206-7	3012494		
44653	4121	3011505	1968-05-12	1968-05-12 00:00:00	1968-05-12	5001	0	\N	0	0	\N	\N	0	273972	0	19926-5	3011505		
44743	4130	46235214	1995-01-11	1995-01-11 00:00:00	1995-01-11	5001	0	\N	0	0	\N	\N	0	274659	0	76690-7	46235214		
46646	1425	4052083	1961-10-23	1961-10-23 00:00:00	1961-10-23	5001	0	\N	0	0	\N	\N	0	94734	0	23426006	4052083		
53172	4886	3006322	2014-02-15	2014-02-15 00:00:00	2014-02-15	5001	0	\N	0	0	\N	\N	0	324906	0	8331-1	3006322		
12631	1211	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	79579	0	6246-3	3021226		
23997	2207	3006322	2014-11-22	2014-11-22 00:00:00	2014-11-22	5001	0	\N	0	0	\N	\N	0	147058	0	8331-1	3006322		
12064	1146	3006322	2001-12-10	2001-12-10 00:00:00	2001-12-10	5001	0	\N	0	0	\N	\N	0	75719	0	8331-1	3006322		
35496	3246	3006322	1997-06-05	1997-06-05 00:00:00	1997-06-05	5001	0	\N	0	0	\N	\N	0	215791	0	8331-1	3006322		
35917	3296	3006322	1944-11-27	1944-11-27 00:00:00	1944-11-27	5001	0	\N	0	0	\N	\N	0	218984	0	8331-1	3006322		
171418	5259	4024958	2011-03-21	2011-03-21 00:00:00	2011-03-21	5001	0	\N	0	0	\N	\N	0	349969	0	117015009	4024958		
46995	4324	40769189	1981-06-15	1981-06-15 00:00:00	1981-06-15	5001	0	\N	0	0	\N	\N	0	286805	0	66529-9	40769189		
9332	884	3000876	1994-03-15	1994-03-15 00:00:00	1994-03-15	5001	0	\N	0	0	\N	\N	0	58863	0	6082-2	3000876		
85448	2646	4024958	1992-05-24	1992-05-24 00:00:00	1992-05-24	5001	0	\N	0	0	\N	\N	0	175045	0	117015009	4024958		
129301	3982	4052083	1986-09-22	1986-09-22 00:00:00	1986-09-22	5001	0	\N	0	0	\N	\N	0	264655	0	23426006	4052083		
88521	2740	4024958	1997-02-06	1997-02-06 00:00:00	1997-02-06	5001	0	\N	0	0	\N	\N	0	181326	0	117015009	4024958		
173500	5322	4024958	1994-02-18	1994-02-18 00:00:00	1994-02-18	5001	0	\N	0	0	\N	\N	0	354140	0	117015009	4024958		
62216	1908	4052083	1993-09-15	1993-09-15 00:00:00	1993-09-15	5001	0	\N	0	0	\N	\N	0	126997	0	23426006	4052083		
68763	2105	4024958	1978-10-27	1978-10-27 00:00:00	1978-10-27	5001	0	\N	0	0	\N	\N	0	140237	0	117015009	4024958		
43790	4044	3006322	2009-11-26	2009-11-26 00:00:00	2009-11-26	5001	0	\N	0	0	\N	\N	0	268953	0	8331-1	3006322		
50160	1525	4024958	1968-12-03	1968-12-03 00:00:00	1968-12-03	5001	0	\N	0	0	\N	\N	0	101972	0	117015009	4024958		
6498	610	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	40494	0	7258-7	3001488		
21485	1980	3001247	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	131811	0	6085-5	3001247		
21584	1992	3000876	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	132659	0	6082-2	3000876		
32716	2965	3005136	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	198013	0	6075-6	3005136		
13082	1249	3006322	1983-09-04	1983-09-04 00:00:00	1983-09-04	5001	0	\N	0	0	\N	\N	0	82255	0	8331-1	3006322		
29448	2711	3014599	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	179667	0	6106-9	3014599		
44202	4071	3051031	1953-11-01	1953-11-01 00:00:00	1953-11-01	5001	0	\N	0	0	\N	\N	0	270608	0	46240-8	3051031		
40918	3793	3049273	1999-05-25	1999-05-25 00:00:00	1999-05-25	5001	0	\N	0	0	\N	\N	0	252236	0	38265-5	3049273		
18505	1699	3006322	2011-03-03	2011-03-03 00:00:00	2011-03-03	5001	0	\N	0	0	\N	\N	0	113654	0	8331-1	3006322		
110390	3408	4052083	1997-01-13	1997-01-13 00:00:00	1997-01-13	5001	0	\N	0	0	\N	\N	0	226007	0	23426006	4052083		
52422	4822	3051031	1949-06-20	1949-06-20 00:00:00	1949-06-20	5001	0	\N	0	0	\N	\N	0	320778	0	46240-8	3051031		
6698	639	3006322	1974-05-16	1974-05-16 00:00:00	1974-05-16	5001	0	\N	0	0	\N	\N	0	42290	0	8331-1	3006322		
53415	4899	3011505	1986-09-02	1986-09-02 00:00:00	1986-09-02	5001	0	\N	0	0	\N	\N	0	325848	0	19926-5	3011505		
39111	1216	4133840	2015-01-13	2015-01-13 00:00:00	2015-01-13	5001	0	\N	0	0	\N	\N	0	80109	0	127783003	4133840		
41509	3865	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	256583	0	7258-7	3001488		
25840	2372	3006322	1977-05-08	1977-05-08 00:00:00	1977-05-08	5001	0	\N	0	0	\N	\N	0	157866	0	8331-1	3006322		
52230	4804	40758406	1983-06-18	1983-06-18 00:00:00	1983-06-18	5001	0	\N	0	0	\N	\N	0	319632	0	55277-8	40758406		
3299	318	3006322	1960-06-27	1960-06-27 00:00:00	1960-06-27	5001	0	\N	0	0	\N	\N	0	21092	0	8331-1	3006322		
90418	2790	4024958	1967-08-28	1967-08-28 00:00:00	1967-08-28	5001	0	\N	0	0	\N	\N	0	184868	0	117015009	4024958		
100576	3087	4052083	1955-12-07	1955-12-07 00:00:00	1955-12-07	5001	0	\N	0	0	\N	\N	0	205502	0	23426006	4052083		
39325	3633	3006322	2012-02-21	2012-02-21 00:00:00	2012-02-21	5001	0	\N	0	0	\N	\N	0	241657	0	8331-1	3006322		
22830	2088	3051031	1996-03-29	1996-03-29 00:00:00	1996-03-29	5001	0	\N	0	0	\N	\N	0	139233	0	46240-8	3051031		
5685	533	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	35444	0	6246-3	3021226		
133112	4101	4024958	1968-11-05	1968-11-05 00:00:00	1968-11-05	5001	0	\N	0	0	\N	\N	0	272509	0	117015009	4024958		
17124	1558	3027970	1962-06-14	1962-06-14 00:00:00	1962-06-14	5001	0	\N	0	0	\N	\N	0	104301	0	10834-0	3027970		
42486	3926	3006322	1984-12-10	1984-12-10 00:00:00	1984-12-10	5001	0	\N	0	0	\N	\N	0	260926	0	8331-1	3006322		
104939	3231	4024958	1979-02-16	1979-02-16 00:00:00	1979-02-16	5001	0	\N	0	0	\N	\N	0	214799	0	117015009	4024958		
27475	2542	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	168108	0	6085-5	3001247		
2384	225	3006734	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	15177	0	6189-5	3006734		
2464	236	3006322	1982-11-01	1982-11-01 00:00:00	1982-11-01	5001	0	\N	0	0	\N	\N	0	15926	0	8331-1	3006322		
20515	1882	3001247	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	125482	0	6085-5	3001247		
50602	4613	3006322	1976-11-28	1976-11-28 00:00:00	1976-11-28	5001	0	\N	0	0	\N	\N	0	307294	0	8331-1	3006322		
47827	4376	3011505	1992-09-15	1992-09-15 00:00:00	1992-09-15	5001	0	\N	0	0	\N	\N	0	290801	0	19926-5	3011505		
47911	4387	3006322	1974-11-13	1974-11-13 00:00:00	1974-11-13	5001	0	\N	0	0	\N	\N	0	291589	0	8331-1	3006322		
167291	5138	4024958	1992-10-15	1992-10-15 00:00:00	1992-10-15	5001	0	\N	0	0	\N	\N	0	341474	0	117015009	4024958		
26391	2427	3006322	1974-07-29	1974-07-29 00:00:00	1974-07-29	5001	0	\N	0	0	\N	\N	0	161029	0	8331-1	3006322		
761	18	4024958	1969-10-31	1969-10-31 00:00:00	1969-10-31	5001	0	\N	0	0	\N	\N	0	1386	0	117015009	4024958		
15733	1441	3021226	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	95975	0	6246-3	3021226		
31694	2898	3000876	1992-01-21	1992-01-21 00:00:00	1992-01-21	5001	0	\N	0	0	\N	\N	0	193068	0	6082-2	3000876		
7419	711	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	47111	0	6844-5	3020655		
27186	2521	3006322	1961-01-04	1961-01-04 00:00:00	1961-01-04	5001	0	\N	0	0	\N	\N	0	166712	0	8331-1	3006322		
38563	3567	3006322	2010-03-01	2010-03-01 00:00:00	2010-03-01	5001	0	\N	0	0	\N	\N	0	237051	0	8331-1	3006322		
85906	2657	4024958	1989-08-15	1989-08-15 00:00:00	1989-08-15	5001	0	\N	0	0	\N	\N	0	175973	0	117015009	4024958		
49999	4548	3019406	1986-11-17	1986-11-17 00:00:00	1986-11-17	5001	0	\N	0	0	\N	\N	0	303082	0	6158-0	3019406		
44654	4121	3011505	1981-10-04	1981-10-04 00:00:00	1981-10-04	5001	0	\N	0	0	\N	\N	0	273933	0	19926-5	3011505		
44744	4130	40758406	1995-01-11	1995-01-11 00:00:00	1995-01-11	5001	0	\N	0	0	\N	\N	0	274659	0	55277-8	40758406		
46660	1426	4052083	1978-11-22	1978-11-22 00:00:00	1978-11-22	5001	0	\N	0	0	\N	\N	0	94880	0	23426006	4052083		
53173	4886	3006322	1980-07-02	1980-07-02 00:00:00	1980-07-02	5001	0	\N	0	0	\N	\N	0	324903	0	8331-1	3006322		
12632	1211	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	79579	0	6075-6	3005136		
23998	2207	3006322	1990-07-03	1990-07-03 00:00:00	1990-07-03	5001	0	\N	0	0	\N	\N	0	147079	0	8331-1	3006322		
12065	1146	3006322	1967-03-05	1967-03-05 00:00:00	1967-03-05	5001	0	\N	0	0	\N	\N	0	75688	0	8331-1	3006322		
60254	1842	4052083	1981-07-29	1981-07-29 00:00:00	1981-07-29	5001	0	\N	0	0	\N	\N	0	122950	0	23426006	4052083		
35918	3296	3006322	1939-04-16	1939-04-16 00:00:00	1939-04-16	5001	0	\N	0	0	\N	\N	0	219084	0	8331-1	3006322		
171419	5259	4052083	1987-09-05	1987-09-05 00:00:00	1987-09-05	5001	0	\N	0	0	\N	\N	0	349946	0	23426006	4052083		
46996	4324	40769184	1981-06-15	1981-06-15 00:00:00	1981-06-15	5001	0	\N	0	0	\N	\N	0	286805	0	66524-0	40769184		
9333	884	3005136	1994-03-15	1994-03-15 00:00:00	1994-03-15	5001	0	\N	0	0	\N	\N	0	58863	0	6075-6	3005136		
85462	2646	4052083	2002-02-21	2002-02-21 00:00:00	2002-02-21	5001	0	\N	0	0	\N	\N	0	175092	0	23426006	4052083		
47740	4376	3051031	2013-02-23	2013-02-23 00:00:00	2013-02-23	5001	0	\N	0	0	\N	\N	0	290787	0	46240-8	3051031		
94640	2909	4133840	1984-04-08	1984-04-08 00:00:00	1984-04-08	5001	0	\N	0	0	\N	\N	0	193919	0	127783003	4133840		
173503	5322	4024958	1978-03-05	1978-03-05 00:00:00	1978-03-05	5001	0	\N	0	0	\N	\N	0	354122	0	117015009	4024958		
62218	1908	4024958	2008-08-13	2008-08-13 00:00:00	2008-08-13	5001	0	\N	0	0	\N	\N	0	126984	0	117015009	4024958		
68767	2105	4024958	2012-07-10	2012-07-10 00:00:00	2012-07-10	5001	0	\N	0	0	\N	\N	0	140257	0	117015009	4024958		
43791	4044	3006322	2017-10-27	2017-10-27 00:00:00	2017-10-27	5001	0	\N	0	0	\N	\N	0	268954	0	8331-1	3006322		
50174	1525	4024958	1976-01-05	1976-01-05 00:00:00	1976-01-05	5001	0	\N	0	0	\N	\N	0	101963	0	117015009	4024958		
6499	610	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	40494	0	6206-7	3012494		
21486	1980	3006734	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	131811	0	6189-5	3006734		
21585	1992	3001247	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	132659	0	6085-5	3001247		
32717	2965	3019406	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	198013	0	6158-0	3019406		
13083	1249	3006322	2004-04-29	2004-04-29 00:00:00	2004-04-29	5001	0	\N	0	0	\N	\N	0	82298	0	8331-1	3006322		
29449	2711	3021226	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	179667	0	6246-3	3021226		
44204	4071	3006322	2014-01-08	2014-01-08 00:00:00	2014-01-08	5001	0	\N	0	0	\N	\N	0	270628	0	8331-1	3006322		
40919	3793	3051031	1940-10-28	1940-10-28 00:00:00	1940-10-28	5001	0	\N	0	0	\N	\N	0	252227	0	46240-8	3051031		
18506	1699	3006322	2011-06-14	2011-06-14 00:00:00	2011-06-14	5001	0	\N	0	0	\N	\N	0	113655	0	8331-1	3006322		
110391	3408	4024958	1992-08-30	1992-08-30 00:00:00	1992-08-30	5001	0	\N	0	0	\N	\N	0	226033	0	117015009	4024958		
52424	4822	40766240	1949-06-20	1949-06-20 00:00:00	1949-06-20	5001	0	\N	0	0	\N	\N	0	320778	0	63513-6	40766240		
6699	639	3006322	2017-03-23	2017-03-23 00:00:00	2017-03-23	5001	0	\N	0	0	\N	\N	0	42246	0	8331-1	3006322		
53416	4899	3006322	1980-03-02	1980-03-02 00:00:00	1980-03-02	5001	0	\N	0	0	\N	\N	0	325768	0	8331-1	3006322		
39120	1216	4133840	2017-01-17	2017-01-17 00:00:00	2017-01-17	5001	0	\N	0	0	\N	\N	0	80086	0	127783003	4133840		
41510	3865	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	256583	0	6189-5	3006734		
25841	2372	3006322	1977-11-13	1977-11-13 00:00:00	1977-11-13	5001	0	\N	0	0	\N	\N	0	157842	0	8331-1	3006322		
52231	4804	3051031	1983-06-18	1983-06-18 00:00:00	1983-06-18	5001	0	\N	0	0	\N	\N	0	319632	0	46240-8	3051031		
3300	318	3006322	1977-01-25	1977-01-25 00:00:00	1977-01-25	5001	0	\N	0	0	\N	\N	0	21111	0	8331-1	3006322		
90453	2792	4052083	2008-05-21	2008-05-21 00:00:00	2008-05-21	5001	0	\N	0	0	\N	\N	0	185048	0	23426006	4052083		
111894	3456	4024958	1952-06-07	1952-06-07 00:00:00	1952-06-07	5001	0	\N	0	0	\N	\N	0	229287	0	117015009	4024958		
39326	3633	3006322	1982-06-08	1982-06-08 00:00:00	1982-06-08	5001	0	\N	0	0	\N	\N	0	241679	0	8331-1	3006322		
22831	2088	46235214	1996-03-29	1996-03-29 00:00:00	1996-03-29	5001	0	\N	0	0	\N	\N	0	139233	0	76690-7	46235214		
5686	533	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	35444	0	6273-7	3006451		
133120	4101	4024958	1961-08-21	1961-08-21 00:00:00	1961-08-21	5001	0	\N	0	0	\N	\N	0	272473	0	117015009	4024958		
17125	1558	3016723	1962-06-14	1962-06-14 00:00:00	1962-06-14	5001	0	\N	0	0	\N	\N	0	104301	0	2160-0	3016723		
42487	3926	3011505	2009-02-23	2009-02-23 00:00:00	2009-02-23	5001	0	\N	0	0	\N	\N	0	260919	0	19926-5	3011505		
104942	3231	4052083	2005-01-29	2005-01-29 00:00:00	2005-01-29	5001	0	\N	0	0	\N	\N	0	214759	0	23426006	4052083		
27476	2542	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	168108	0	6189-5	3006734		
2385	225	3000876	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	15177	0	6082-2	3000876		
2465	236	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	15882	0	6082-2	3000876		
20516	1882	3006451	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	125482	0	6273-7	3006451		
109856	3391	4052083	1994-10-19	1994-10-19 00:00:00	1994-10-19	5001	0	\N	0	0	\N	\N	0	224906	0	23426006	4052083		
47834	4379	3006322	2007-12-22	2007-12-22 00:00:00	2007-12-22	5001	0	\N	0	0	\N	\N	0	290971	0	8331-1	3006322		
47912	4387	3006322	1974-07-04	1974-07-04 00:00:00	1974-07-04	5001	0	\N	0	0	\N	\N	0	291588	0	8331-1	3006322		
115475	3561	4052083	1949-02-12	1949-02-12 00:00:00	1949-02-12	5001	0	\N	0	0	\N	\N	0	236509	0	23426006	4052083		
26392	2427	3049273	2008-12-20	2008-12-20 00:00:00	2008-12-20	5001	0	\N	0	0	\N	\N	0	160964	0	38265-5	3049273		
783	19	4024958	1974-10-19	1974-10-19 00:00:00	1974-10-19	5001	0	\N	0	0	\N	\N	0	1482	0	117015009	4024958		
15734	1441	3014599	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	95975	0	6106-9	3014599		
31695	2898	3014599	1980-03-29	1980-03-29 00:00:00	1980-03-29	5001	0	\N	0	0	\N	\N	0	193004	0	6106-9	3014599		
7420	711	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	47111	0	6075-6	3005136		
27187	2521	3006322	2009-06-09	2009-06-09 00:00:00	2009-06-09	5001	0	\N	0	0	\N	\N	0	166769	0	8331-1	3006322		
38564	3567	3006322	2017-04-06	2017-04-06 00:00:00	2017-04-06	5001	0	\N	0	0	\N	\N	0	237053	0	8331-1	3006322		
85912	2657	4024958	1977-12-20	1977-12-20 00:00:00	1977-12-20	5001	0	\N	0	0	\N	\N	0	175952	0	117015009	4024958		
50000	4548	3015076	1986-11-17	1986-11-17 00:00:00	1986-11-17	5001	0	\N	0	0	\N	\N	0	303082	0	6248-9	3015076		
44655	4121	3011505	1987-11-08	1987-11-08 00:00:00	1987-11-08	5001	0	\N	0	0	\N	\N	0	274011	0	19926-5	3011505		
44745	4130	40766240	1995-01-11	1995-01-11 00:00:00	1995-01-11	5001	0	\N	0	0	\N	\N	0	274659	0	63513-6	40766240		
46663	1426	4052083	1983-11-23	1983-11-23 00:00:00	1983-11-23	5001	0	\N	0	0	\N	\N	0	94830	0	23426006	4052083		
53174	4886	3006322	1972-01-16	1972-01-16 00:00:00	1972-01-16	5001	0	\N	0	0	\N	\N	0	324936	0	8331-1	3006322		
12633	1211	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	79579	0	6158-0	3019406		
23999	2207	3006322	2010-09-29	2010-09-29 00:00:00	2010-09-29	5001	0	\N	0	0	\N	\N	0	147102	0	8331-1	3006322		
12066	1146	3006322	2003-11-15	2003-11-15 00:00:00	2003-11-15	5001	0	\N	0	0	\N	\N	0	75747	0	8331-1	3006322		
60259	1842	4024958	1997-08-08	1997-08-08 00:00:00	1997-08-08	5001	0	\N	0	0	\N	\N	0	122951	0	117015009	4024958		
35920	3296	3006322	1948-08-21	1948-08-21 00:00:00	1948-08-21	5001	0	\N	0	0	\N	\N	0	218985	0	8331-1	3006322		
88851	2752	4052083	1989-12-07	1989-12-07 00:00:00	1989-12-07	5001	0	\N	0	0	\N	\N	0	182031	0	23426006	4052083		
46997	4324	40769179	1981-06-15	1981-06-15 00:00:00	1981-06-15	5001	0	\N	0	0	\N	\N	0	286805	0	66519-0	40769179		
9334	884	3014599	1994-03-15	1994-03-15 00:00:00	1994-03-15	5001	0	\N	0	0	\N	\N	0	58863	0	6106-9	3014599		
85464	2646	4052083	2008-11-25	2008-11-25 00:00:00	2008-11-25	5001	0	\N	0	0	\N	\N	0	175075	0	23426006	4052083		
47741	4376	40758406	2013-02-23	2013-02-23 00:00:00	2013-02-23	5001	0	\N	0	0	\N	\N	0	290787	0	55277-8	40758406		
94645	2909	4133840	1988-04-17	1988-04-17 00:00:00	1988-04-17	5001	0	\N	0	0	\N	\N	0	193852	0	127783003	4133840		
173505	5322	4024958	1973-04-22	1973-04-22 00:00:00	1973-04-22	5001	0	\N	0	0	\N	\N	0	354180	0	117015009	4024958		
62276	1911	4133840	1997-09-01	1997-09-01 00:00:00	1997-09-01	5001	0	\N	0	0	\N	\N	0	127138	0	127783003	4133840		
68777	2105	4052083	2015-03-06	2015-03-06 00:00:00	2015-03-06	5001	0	\N	0	0	\N	\N	0	140220	0	23426006	4052083		
43792	4044	3006322	2003-10-17	2003-10-17 00:00:00	2003-10-17	5001	0	\N	0	0	\N	\N	0	268973	0	8331-1	3006322		
50187	1525	4024958	1999-02-19	1999-02-19 00:00:00	1999-02-19	5001	0	\N	0	0	\N	\N	0	101990	0	117015009	4024958		
6500	610	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	40494	0	6085-5	3001247		
21487	1980	3023430	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	131811	0	6833-8	3023430		
21586	1992	3005136	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	132659	0	6075-6	3005136		
32718	2965	3012494	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	198013	0	6206-7	3012494		
13084	1249	3006322	1979-01-17	1979-01-17 00:00:00	1979-01-17	5001	0	\N	0	0	\N	\N	0	82275	0	8331-1	3006322		
29450	2711	3015076	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	179667	0	6248-9	3015076		
44205	4071	40758406	1966-10-24	1966-10-24 00:00:00	1966-10-24	5001	0	\N	0	0	\N	\N	0	270618	0	55277-8	40758406		
40920	3793	46235214	1940-10-28	1940-10-28 00:00:00	1940-10-28	5001	0	\N	0	0	\N	\N	0	252227	0	76690-7	46235214		
18507	1699	3006322	1977-06-03	1977-06-03 00:00:00	1977-06-03	5001	0	\N	0	0	\N	\N	0	113635	0	8331-1	3006322		
110406	3408	4024958	2011-06-06	2011-06-06 00:00:00	2011-06-06	5001	0	\N	0	0	\N	\N	0	226008	0	117015009	4024958		
52426	4822	46235214	1971-03-07	1971-03-07 00:00:00	1971-03-07	5001	0	\N	0	0	\N	\N	0	320783	0	76690-7	46235214		
6700	639	3006322	1981-11-22	1981-11-22 00:00:00	1981-11-22	5001	0	\N	0	0	\N	\N	0	42291	0	8331-1	3006322		
53417	4899	3011505	1995-10-24	1995-10-24 00:00:00	1995-10-24	5001	0	\N	0	0	\N	\N	0	325832	0	19926-5	3011505		
39122	1216	4133840	2013-01-08	2013-01-08 00:00:00	2013-01-08	5001	0	\N	0	0	\N	\N	0	80107	0	127783003	4133840		
41511	3865	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	256583	0	6273-7	3006451		
25842	2372	3006322	1984-08-17	1984-08-17 00:00:00	1984-08-17	5001	0	\N	0	0	\N	\N	0	157825	0	8331-1	3006322		
52232	4804	40766240	1983-06-18	1983-06-18 00:00:00	1983-06-18	5001	0	\N	0	0	\N	\N	0	319632	0	63513-6	40766240		
3301	318	3006322	1973-10-03	1973-10-03 00:00:00	1973-10-03	5001	0	\N	0	0	\N	\N	0	21094	0	8331-1	3006322		
27819	2559	3001247	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	169613	0	6085-5	3001247		
111904	3456	4024958	1950-08-03	1950-08-03 00:00:00	1950-08-03	5001	0	\N	0	0	\N	\N	0	229305	0	117015009	4024958		
39327	3633	3006322	1985-04-04	1985-04-04 00:00:00	1985-04-04	5001	0	\N	0	0	\N	\N	0	241681	0	8331-1	3006322		
22832	2088	3011505	2013-03-12	2013-03-12 00:00:00	2013-03-12	5001	0	\N	0	0	\N	\N	0	139244	0	19926-5	3011505		
5687	533	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	35444	0	7258-7	3001488		
133130	4101	4024958	2008-08-16	2008-08-16 00:00:00	2008-08-16	5001	0	\N	0	0	\N	\N	0	272535	0	117015009	4024958		
17126	1558	3024561	1962-06-14	1962-06-14 00:00:00	1962-06-14	5001	0	\N	0	0	\N	\N	0	104301	0	1751-7	3024561		
42488	3926	3006322	2017-07-10	2017-07-10 00:00:00	2017-07-10	5001	0	\N	0	0	\N	\N	0	260974	0	8331-1	3006322		
104947	3231	4052083	2001-05-30	2001-05-30 00:00:00	2001-05-30	5001	0	\N	0	0	\N	\N	0	214801	0	23426006	4052083		
27477	2542	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	168108	0	6106-9	3014599		
2386	225	3014599	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	15177	0	6106-9	3014599		
2466	236	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	15882	0	6085-5	3001247		
20517	1882	3012494	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	125482	0	6206-7	3012494		
109862	3391	4052083	2015-08-05	2015-08-05 00:00:00	2015-08-05	5001	0	\N	0	0	\N	\N	0	224929	0	23426006	4052083		
47835	4379	3006322	1983-04-08	1983-04-08 00:00:00	1983-04-08	5001	0	\N	0	0	\N	\N	0	290938	0	8331-1	3006322		
47913	4388	3006322	1975-02-28	1975-02-28 00:00:00	1975-02-28	5001	0	\N	0	0	\N	\N	0	291690	0	8331-1	3006322		
115484	3561	4024958	1953-08-16	1953-08-16 00:00:00	1953-08-16	5001	0	\N	0	0	\N	\N	0	236484	0	117015009	4024958		
26393	2427	3006322	2000-09-03	2000-09-03 00:00:00	2000-09-03	5001	0	\N	0	0	\N	\N	0	161032	0	8331-1	3006322		
798	19	4052083	2007-04-21	2007-04-21 00:00:00	2007-04-21	5001	0	\N	0	0	\N	\N	0	1454	0	23426006	4052083		
15735	1441	3012494	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	95975	0	6206-7	3012494		
31696	2898	3005136	1980-03-29	1980-03-29 00:00:00	1980-03-29	5001	0	\N	0	0	\N	\N	0	193004	0	6075-6	3005136		
7421	711	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	47111	0	6248-9	3015076		
27188	2522	3006322	2017-10-08	2017-10-08 00:00:00	2017-10-08	5001	0	\N	0	0	\N	\N	0	166830	0	8331-1	3006322		
38566	3568	46235214	2004-06-14	2004-06-14 00:00:00	2004-06-14	5001	0	\N	0	0	\N	\N	0	237108	0	76690-7	46235214		
97219	2975	4024958	1973-04-13	1973-04-13 00:00:00	1973-04-13	5001	0	\N	0	0	\N	\N	0	198622	0	117015009	4024958		
50001	4548	3001488	1986-11-17	1986-11-17 00:00:00	1986-11-17	5001	0	\N	0	0	\N	\N	0	303082	0	7258-7	3001488		
44656	4121	3011505	1966-05-08	1966-05-08 00:00:00	1966-05-08	5001	0	\N	0	0	\N	\N	0	273937	0	19926-5	3011505		
44746	4130	3051031	1995-05-11	1995-05-11 00:00:00	1995-05-11	5001	0	\N	0	0	\N	\N	0	274608	0	46240-8	3051031		
46667	1426	4024958	1955-11-04	1955-11-04 00:00:00	1955-11-04	5001	0	\N	0	0	\N	\N	0	94805	0	117015009	4024958		
53180	4890	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	325188	0	6246-3	3021226		
12634	1211	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	79579	0	6248-9	3015076		
24001	2210	3006322	1994-12-30	1994-12-30 00:00:00	1994-12-30	5001	0	\N	0	0	\N	\N	0	147266	0	8331-1	3006322		
89397	2767	4052083	1984-03-28	1984-03-28 00:00:00	1984-03-28	5001	0	\N	0	0	\N	\N	0	183071	0	23426006	4052083		
60261	1842	4024958	1990-03-25	1990-03-25 00:00:00	1990-03-25	5001	0	\N	0	0	\N	\N	0	122967	0	117015009	4024958		
35921	3296	3049273	2016-02-24	2016-02-24 00:00:00	2016-02-24	5001	0	\N	0	0	\N	\N	0	219096	0	38265-5	3049273		
36198	3330	3006322	2015-05-01	2015-05-01 00:00:00	2015-05-01	5001	0	\N	0	0	\N	\N	0	220991	0	8331-1	3006322		
46998	4324	3012494	1981-06-30	1981-06-30 00:00:00	1981-06-30	5001	0	\N	0	0	\N	\N	0	286849	0	6206-7	3012494		
9335	884	3006451	1994-03-15	1994-03-15 00:00:00	1994-03-15	5001	0	\N	0	0	\N	\N	0	58863	0	6273-7	3006451		
85465	2646	4024958	1979-03-21	1979-03-21 00:00:00	1979-03-21	5001	0	\N	0	0	\N	\N	0	175044	0	117015009	4024958		
47743	4376	3011505	2013-01-08	2013-01-08 00:00:00	2013-01-08	5001	0	\N	0	0	\N	\N	0	290782	0	19926-5	3011505		
94648	2909	4133840	2007-07-15	2007-07-15 00:00:00	2007-07-15	5001	0	\N	0	0	\N	\N	0	193881	0	127783003	4133840		
173507	5322	4052083	1964-02-24	1964-02-24 00:00:00	1964-02-24	5001	0	\N	0	0	\N	\N	0	354270	0	23426006	4052083		
62280	1911	4133840	1999-09-13	1999-09-13 00:00:00	1999-09-13	5001	0	\N	0	0	\N	\N	0	127173	0	127783003	4133840		
68796	2108	4052083	1947-12-06	1947-12-06 00:00:00	1947-12-06	5001	0	\N	0	0	\N	\N	0	140334	0	23426006	4052083		
43793	4045	3006322	2004-06-23	2004-06-23 00:00:00	2004-06-23	5001	0	\N	0	0	\N	\N	0	269025	0	8331-1	3006322		
50212	1526	4024958	2018-12-03	2018-12-03 00:00:00	2018-12-03	5001	0	\N	0	0	\N	\N	0	102085	0	117015009	4024958		
6501	610	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	40494	0	6248-9	3015076		
21488	1980	3000876	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	131811	0	6082-2	3000876		
21587	1992	3021226	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	132659	0	6246-3	3021226		
32719	2965	3015076	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	198013	0	6248-9	3015076		
13085	1249	3006322	2018-11-23	2018-11-23 00:00:00	2018-11-23	5001	0	\N	0	0	\N	\N	0	82300	0	8331-1	3006322		
29451	2711	3005136	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	179667	0	6075-6	3005136		
44207	4071	40766240	1966-10-24	1966-10-24 00:00:00	1966-10-24	5001	0	\N	0	0	\N	\N	0	270618	0	63513-6	40766240		
40921	3793	40758406	1940-10-28	1940-10-28 00:00:00	1940-10-28	5001	0	\N	0	0	\N	\N	0	252227	0	55277-8	40758406		
18508	1699	3006322	1981-12-23	1981-12-23 00:00:00	1981-12-23	5001	0	\N	0	0	\N	\N	0	113637	0	8331-1	3006322		
110420	3409	4024958	1961-01-24	1961-01-24 00:00:00	1961-01-24	5001	0	\N	0	0	\N	\N	0	226139	0	117015009	4024958		
52427	4822	40758406	1971-03-07	1971-03-07 00:00:00	1971-03-07	5001	0	\N	0	0	\N	\N	0	320783	0	55277-8	40758406		
6701	639	3006322	1982-09-29	1982-09-29 00:00:00	1982-09-29	5001	0	\N	0	0	\N	\N	0	42302	0	8331-1	3006322		
53418	4899	3006322	1924-11-19	1924-11-19 00:00:00	1924-11-19	5001	0	\N	0	0	\N	\N	0	325751	0	8331-1	3006322		
39128	1217	4133840	2010-12-03	2010-12-03 00:00:00	2010-12-03	5001	0	\N	0	0	\N	\N	0	80145	0	127783003	4133840		
41512	3865	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	256583	0	6106-9	3014599		
25843	2372	3006322	1966-07-27	1966-07-27 00:00:00	1966-07-27	5001	0	\N	0	0	\N	\N	0	157811	0	8331-1	3006322		
52235	4804	40758406	1983-07-18	1983-07-18 00:00:00	1983-07-18	5001	0	\N	0	0	\N	\N	0	319536	0	55277-8	40758406		
3302	318	3049273	2013-09-02	2013-09-02 00:00:00	2013-09-02	5001	0	\N	0	0	\N	\N	0	21064	0	38265-5	3049273		
27820	2559	3015076	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	169613	0	6248-9	3015076		
155182	4758	4052083	1985-05-08	1985-05-08 00:00:00	1985-05-08	5001	0	\N	0	0	\N	\N	0	317027	0	23426006	4052083		
39328	3634	3006322	1995-07-13	1995-07-13 00:00:00	1995-07-13	5001	0	\N	0	0	\N	\N	0	241733	0	8331-1	3006322		
22833	2088	3011505	1997-05-20	1997-05-20 00:00:00	1997-05-20	5001	0	\N	0	0	\N	\N	0	139280	0	19926-5	3011505		
5688	533	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	35444	0	6189-5	3006734		
133135	4101	4024958	1988-01-23	1988-01-23 00:00:00	1988-01-23	5001	0	\N	0	0	\N	\N	0	272512	0	117015009	4024958		
17127	1558	3013721	1962-06-14	1962-06-14 00:00:00	1962-06-14	5001	0	\N	0	0	\N	\N	0	104301	0	1920-8	3013721		
42489	3926	3011505	1984-12-17	1984-12-17 00:00:00	1984-12-17	5001	0	\N	0	0	\N	\N	0	260994	0	19926-5	3011505		
370	16	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	1173	0	7258-7	3001488		
27478	2542	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	168108	0	7258-7	3001488		
2387	225	3019406	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	15177	0	6158-0	3019406		
2467	236	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	15882	0	6844-5	3020655		
20518	1882	3006322	1991-10-22	1991-10-22 00:00:00	1991-10-22	5001	0	\N	0	0	\N	\N	0	125599	0	8331-1	3006322		
109864	3391	4052083	2008-07-16	2008-07-16 00:00:00	2008-07-16	5001	0	\N	0	0	\N	\N	0	224909	0	23426006	4052083		
47836	4379	3006322	2003-12-29	2003-12-29 00:00:00	2003-12-29	5001	0	\N	0	0	\N	\N	0	290974	0	8331-1	3006322		
47914	4388	3006322	2000-04-04	2000-04-04 00:00:00	2000-04-04	5001	0	\N	0	0	\N	\N	0	291710	0	8331-1	3006322		
115507	3561	4024958	1917-08-23	1917-08-23 00:00:00	1917-08-23	5001	0	\N	0	0	\N	\N	0	236505	0	117015009	4024958		
26394	2427	3006322	1978-09-17	1978-09-17 00:00:00	1978-09-17	5001	0	\N	0	0	\N	\N	0	161036	0	8331-1	3006322		
20620	648	4024958	1935-10-05	1935-10-05 00:00:00	1935-10-05	5001	0	\N	0	0	\N	\N	0	42899	0	117015009	4024958		
15736	1441	3036780	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	95975	0	6095-4	3036780		
31697	2898	3015076	1980-03-29	1980-03-29 00:00:00	1980-03-29	5001	0	\N	0	0	\N	\N	0	193004	0	6248-9	3015076		
7422	711	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	47111	0	6106-9	3014599		
27189	2522	3006322	1986-10-09	1986-10-09 00:00:00	1986-10-09	5001	0	\N	0	0	\N	\N	0	166849	0	8331-1	3006322		
38568	3568	40766240	2004-06-14	2004-06-14 00:00:00	2004-06-14	5001	0	\N	0	0	\N	\N	0	237108	0	63513-6	40766240		
38626	3571	3006322	1984-11-05	1984-11-05 00:00:00	1984-11-05	5001	0	\N	0	0	\N	\N	0	237345	0	8331-1	3006322		
50002	4548	3001247	1986-11-17	1986-11-17 00:00:00	1986-11-17	5001	0	\N	0	0	\N	\N	0	303082	0	6085-5	3001247		
44658	4121	40758406	1921-09-15	1921-09-15 00:00:00	1921-09-15	5001	0	\N	0	0	\N	\N	0	273986	0	55277-8	40758406		
44748	4130	46235214	1995-05-11	1995-05-11 00:00:00	1995-05-11	5001	0	\N	0	0	\N	\N	0	274608	0	76690-7	46235214		
46679	1426	4024958	1953-12-02	1953-12-02 00:00:00	1953-12-02	5001	0	\N	0	0	\N	\N	0	94815	0	117015009	4024958		
53181	4890	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	325188	0	6248-9	3015076		
12635	1211	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	79579	0	6206-7	3012494		
24002	2210	3006322	1945-12-11	1945-12-11 00:00:00	1945-12-11	5001	0	\N	0	0	\N	\N	0	147235	0	8331-1	3006322		
89411	2767	4024958	1940-04-18	1940-04-18 00:00:00	1940-04-18	5001	0	\N	0	0	\N	\N	0	183047	0	117015009	4024958		
24501	2261	46235214	1966-05-28	1966-05-28 00:00:00	1966-05-28	5001	0	\N	0	0	\N	\N	0	150283	0	76690-7	46235214		
35922	3296	3006322	2010-08-18	2010-08-18 00:00:00	2010-08-18	5001	0	\N	0	0	\N	\N	0	219026	0	8331-1	3006322		
36203	3332	3006322	1977-02-26	1977-02-26 00:00:00	1977-02-26	5001	0	\N	0	0	\N	\N	0	221099	0	8331-1	3006322		
46999	4324	3005136	1981-06-30	1981-06-30 00:00:00	1981-06-30	5001	0	\N	0	0	\N	\N	0	286849	0	6075-6	3005136		
9336	884	3021226	1994-03-15	1994-03-15 00:00:00	1994-03-15	5001	0	\N	0	0	\N	\N	0	58863	0	6246-3	3021226		
85466	2647	4052083	1975-11-13	1975-11-13 00:00:00	1975-11-13	5001	0	\N	0	0	\N	\N	0	175148	0	23426006	4052083		
47744	4376	3011505	1987-08-18	1987-08-18 00:00:00	1987-08-18	5001	0	\N	0	0	\N	\N	0	290818	0	19926-5	3011505		
94652	2909	4133840	1972-03-26	1972-03-26 00:00:00	1972-03-26	5001	0	\N	0	0	\N	\N	0	193851	0	127783003	4133840		
173518	5322	4024958	2009-07-14	2009-07-14 00:00:00	2009-07-14	5001	0	\N	0	0	\N	\N	0	354130	0	117015009	4024958		
62282	1911	4133840	2008-11-03	2008-11-03 00:00:00	2008-11-03	5001	0	\N	0	0	\N	\N	0	127174	0	127783003	4133840		
172110	5283	4024958	1999-03-20	1999-03-20 00:00:00	1999-03-20	5001	0	\N	0	0	\N	\N	0	351421	0	117015009	4024958		
43794	4045	3006322	2003-03-19	2003-03-19 00:00:00	2003-03-19	5001	0	\N	0	0	\N	\N	0	269041	0	8331-1	3006322		
168561	5174	4052083	1960-10-26	1960-10-26 00:00:00	1960-10-26	5001	0	\N	0	0	\N	\N	0	344024	0	23426006	4052083		
6502	610	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	40494	0	6276-0	3027231		
21489	1980	3036780	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	131811	0	6095-4	3036780		
21588	1992	3019406	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	132659	0	6158-0	3019406		
32720	2965	3014599	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	198013	0	6106-9	3014599		
13086	1249	3006322	1971-12-09	1971-12-09 00:00:00	1971-12-09	5001	0	\N	0	0	\N	\N	0	82296	0	8331-1	3006322		
29452	2711	3006451	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	179667	0	6273-7	3006451		
44208	4071	3051031	1966-10-24	1966-10-24 00:00:00	1966-10-24	5001	0	\N	0	0	\N	\N	0	270618	0	46240-8	3051031		
40923	3793	40766240	1940-10-28	1940-10-28 00:00:00	1940-10-28	5001	0	\N	0	0	\N	\N	0	252227	0	63513-6	40766240		
18509	1699	3006322	1969-10-18	1969-10-18 00:00:00	1969-10-18	5001	0	\N	0	0	\N	\N	0	113628	0	8331-1	3006322		
110421	3409	4024958	2011-06-01	2011-06-01 00:00:00	2011-06-01	5001	0	\N	0	0	\N	\N	0	226097	0	117015009	4024958		
52428	4822	3051031	1971-03-07	1971-03-07 00:00:00	1971-03-07	5001	0	\N	0	0	\N	\N	0	320783	0	46240-8	3051031		
6702	640	3006322	1956-01-19	1956-01-19 00:00:00	1956-01-19	5001	0	\N	0	0	\N	\N	0	42372	0	8331-1	3006322		
53423	4905	3006322	1989-02-15	1989-02-15 00:00:00	1989-02-15	5001	0	\N	0	0	\N	\N	0	326037	0	8331-1	3006322		
39133	1217	4133840	2017-01-13	2017-01-13 00:00:00	2017-01-13	5001	0	\N	0	0	\N	\N	0	80147	0	127783003	4133840		
41513	3865	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	256583	0	6833-8	3023430		
25844	2372	3006322	1975-03-10	1975-03-10 00:00:00	1975-03-10	5001	0	\N	0	0	\N	\N	0	157823	0	8331-1	3006322		
52236	4804	46235214	1983-07-18	1983-07-18 00:00:00	1983-07-18	5001	0	\N	0	0	\N	\N	0	319536	0	76690-7	46235214		
3303	318	3006322	2007-08-02	2007-08-02 00:00:00	2007-08-02	5001	0	\N	0	0	\N	\N	0	21081	0	8331-1	3006322		
27821	2559	3005136	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	169613	0	6075-6	3005136		
155190	4759	4024958	1997-07-05	1997-07-05 00:00:00	1997-07-05	5001	0	\N	0	0	\N	\N	0	317102	0	117015009	4024958		
39330	3636	46235214	2014-09-02	2014-09-02 00:00:00	2014-09-02	5001	0	\N	0	0	\N	\N	0	241842	0	76690-7	46235214		
22835	2088	40758406	1996-01-29	1996-01-29 00:00:00	1996-01-29	5001	0	\N	0	0	\N	\N	0	139294	0	55277-8	40758406		
5689	533	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	35444	0	6833-8	3023430		
133140	4102	4024958	1972-08-16	1972-08-16 00:00:00	1972-08-16	5001	0	\N	0	0	\N	\N	0	272596	0	117015009	4024958		
17128	1558	3010813	1962-06-14	1962-06-14 00:00:00	1962-06-14	5001	0	\N	0	0	\N	\N	0	104301	0	26464-8	3010813		
42490	3926	3011505	2005-01-31	2005-01-31 00:00:00	2005-01-31	5001	0	\N	0	0	\N	\N	0	260917	0	19926-5	3011505		
371	16	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	1173	0	6844-5	3020655		
27479	2542	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	168108	0	6844-5	3020655		
2388	225	3015076	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	15177	0	6248-9	3015076		
2468	236	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	15882	0	6833-8	3023430		
20519	1882	3006322	2016-12-21	2016-12-21 00:00:00	2016-12-21	5001	0	\N	0	0	\N	\N	0	125518	0	8331-1	3006322		
109873	3392	4024958	2005-09-19	2005-09-19 00:00:00	2005-09-19	5001	0	\N	0	0	\N	\N	0	224960	0	117015009	4024958		
118444	3647	4024958	1943-06-30	1943-06-30 00:00:00	1943-06-30	5001	0	\N	0	0	\N	\N	0	242678	0	117015009	4024958		
47915	4388	3006322	1967-05-02	1967-05-02 00:00:00	1967-05-02	5001	0	\N	0	0	\N	\N	0	291658	0	8331-1	3006322		
115544	3562	4024958	1975-02-20	1975-02-20 00:00:00	1975-02-20	5001	0	\N	0	0	\N	\N	0	236604	0	117015009	4024958		
26395	2427	3006322	2007-09-06	2007-09-06 00:00:00	2007-09-06	5001	0	\N	0	0	\N	\N	0	161000	0	8331-1	3006322		
20623	648	4052083	1936-10-27	1936-10-27 00:00:00	1936-10-27	5001	0	\N	0	0	\N	\N	0	42946	0	23426006	4052083		
15737	1441	3000876	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	95975	0	6082-2	3000876		
31698	2898	3006451	1980-03-29	1980-03-29 00:00:00	1980-03-29	5001	0	\N	0	0	\N	\N	0	193004	0	6273-7	3006451		
7423	711	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	47111	0	6158-0	3019406		
27190	2522	40758406	1995-11-29	1995-11-29 00:00:00	1995-11-29	5001	0	\N	0	0	\N	\N	0	166802	0	55277-8	40758406		
38569	3568	40758406	2004-06-14	2004-06-14 00:00:00	2004-06-14	5001	0	\N	0	0	\N	\N	0	237108	0	55277-8	40758406		
38627	3571	3006322	1979-06-02	1979-06-02 00:00:00	1979-06-02	5001	0	\N	0	0	\N	\N	0	237385	0	8331-1	3006322		
50003	4548	3021226	1986-11-17	1986-11-17 00:00:00	1986-11-17	5001	0	\N	0	0	\N	\N	0	303082	0	6246-3	3021226		
44659	4121	40766240	1921-09-15	1921-09-15 00:00:00	1921-09-15	5001	0	\N	0	0	\N	\N	0	273986	0	63513-6	40766240		
44749	4130	40766240	1995-05-11	1995-05-11 00:00:00	1995-05-11	5001	0	\N	0	0	\N	\N	0	274608	0	63513-6	40766240		
46701	1427	4052083	2011-07-20	2011-07-20 00:00:00	2011-07-20	5001	0	\N	0	0	\N	\N	0	94932	0	23426006	4052083		
53182	4890	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	325188	0	6106-9	3014599		
12636	1211	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	79579	0	6106-9	3014599		
24003	2210	3006322	1971-07-23	1971-07-23 00:00:00	1971-07-23	5001	0	\N	0	0	\N	\N	0	147213	0	8331-1	3006322		
89417	2767	4024958	1943-04-14	1943-04-14 00:00:00	1943-04-14	5001	0	\N	0	0	\N	\N	0	183021	0	117015009	4024958		
24502	2261	3051031	1966-05-28	1966-05-28 00:00:00	1966-05-28	5001	0	\N	0	0	\N	\N	0	150283	0	46240-8	3051031		
35923	3296	3006322	1972-06-12	1972-06-12 00:00:00	1972-06-12	5001	0	\N	0	0	\N	\N	0	219099	0	8331-1	3006322		
36204	3332	3006322	1998-06-19	1998-06-19 00:00:00	1998-06-19	5001	0	\N	0	0	\N	\N	0	221126	0	8331-1	3006322		
47000	4324	3006451	1981-06-30	1981-06-30 00:00:00	1981-06-30	5001	0	\N	0	0	\N	\N	0	286849	0	6273-7	3006451		
9337	884	3027231	1994-03-15	1994-03-15 00:00:00	1994-03-15	5001	0	\N	0	0	\N	\N	0	58863	0	6276-0	3027231		
85475	2647	4024958	1975-10-20	1975-10-20 00:00:00	1975-10-20	5001	0	\N	0	0	\N	\N	0	175110	0	117015009	4024958		
47745	4376	3011505	1989-08-29	1989-08-29 00:00:00	1989-08-29	5001	0	\N	0	0	\N	\N	0	290804	0	19926-5	3011505		
94654	2909	4052083	1954-08-18	1954-08-18 00:00:00	1954-08-18	5001	0	\N	0	0	\N	\N	0	193869	0	23426006	4052083		
13575	430	4052083	1949-12-15	1949-12-15 00:00:00	1949-12-15	5001	0	\N	0	0	\N	\N	0	28430	0	23426006	4052083		
32343	2939	3006322	2012-07-12	2012-07-12 00:00:00	2012-07-12	5001	0	\N	0	0	\N	\N	0	195943	0	8331-1	3006322		
172113	5283	4052083	1982-06-16	1982-06-16 00:00:00	1982-06-16	5001	0	\N	0	0	\N	\N	0	351412	0	23426006	4052083		
43795	4045	3006322	2009-04-10	2009-04-10 00:00:00	2009-04-10	5001	0	\N	0	0	\N	\N	0	268996	0	8331-1	3006322		
6445	603	3006322	1962-04-25	1962-04-25 00:00:00	1962-04-25	5001	0	\N	0	0	\N	\N	0	39935	0	8331-1	3006322		
6503	610	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	40494	0	6158-0	3019406		
21490	1980	3015076	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	131811	0	6248-9	3015076		
21589	1992	3015076	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	132659	0	6248-9	3015076		
32721	2965	3006451	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	198013	0	6273-7	3006451		
13087	1250	3006322	1986-01-31	1986-01-31 00:00:00	1986-01-31	5001	0	\N	0	0	\N	\N	0	82320	0	8331-1	3006322		
29453	2711	3027231	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	179667	0	6276-0	3027231		
44209	4071	46235214	1966-10-24	1966-10-24 00:00:00	1966-10-24	5001	0	\N	0	0	\N	\N	0	270618	0	76690-7	46235214		
40926	3793	40758406	1942-11-22	1942-11-22 00:00:00	1942-11-22	5001	0	\N	0	0	\N	\N	0	252229	0	55277-8	40758406		
18510	1699	3006322	1973-02-12	1973-02-12 00:00:00	1973-02-12	5001	0	\N	0	0	\N	\N	0	113645	0	8331-1	3006322		
110443	3409	4024958	1992-07-21	1992-07-21 00:00:00	1992-07-21	5001	0	\N	0	0	\N	\N	0	226093	0	117015009	4024958		
52430	4822	40766240	1971-03-07	1971-03-07 00:00:00	1971-03-07	5001	0	\N	0	0	\N	\N	0	320783	0	63513-6	40766240		
6703	640	3006322	2007-07-30	2007-07-30 00:00:00	2007-07-30	5001	0	\N	0	0	\N	\N	0	42403	0	8331-1	3006322		
53424	4905	3006322	2008-01-21	2008-01-21 00:00:00	2008-01-21	5001	0	\N	0	0	\N	\N	0	326074	0	8331-1	3006322		
39137	1217	4024958	1978-05-04	1978-05-04 00:00:00	1978-05-04	5001	0	\N	0	0	\N	\N	0	80135	0	117015009	4024958		
41514	3865	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	256583	0	6095-4	3036780		
25845	2372	3006322	1992-04-27	1992-04-27 00:00:00	1992-04-27	5001	0	\N	0	0	\N	\N	0	157843	0	8331-1	3006322		
52238	4804	40766240	1983-07-18	1983-07-18 00:00:00	1983-07-18	5001	0	\N	0	0	\N	\N	0	319536	0	63513-6	40766240		
3304	318	3006322	2000-12-06	2000-12-06 00:00:00	2000-12-06	5001	0	\N	0	0	\N	\N	0	21049	0	8331-1	3006322		
27822	2559	3027231	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	169613	0	6276-0	3027231		
166471	5116	4052083	1989-04-14	1989-04-14 00:00:00	1989-04-14	5001	0	\N	0	0	\N	\N	0	339983	0	23426006	4052083		
39331	3636	40758406	2014-09-02	2014-09-02 00:00:00	2014-09-02	5001	0	\N	0	0	\N	\N	0	241842	0	55277-8	40758406		
22837	2088	46235214	1996-01-29	1996-01-29 00:00:00	1996-01-29	5001	0	\N	0	0	\N	\N	0	139294	0	76690-7	46235214		
5690	533	3006322	2007-11-14	2007-11-14 00:00:00	2007-11-14	5001	0	\N	0	0	\N	\N	0	35498	0	8331-1	3006322		
133149	4102	4024958	1973-04-25	1973-04-25 00:00:00	1973-04-25	5001	0	\N	0	0	\N	\N	0	272591	0	117015009	4024958		
17129	1558	3006322	2000-12-04	2000-12-04 00:00:00	2000-12-04	5001	0	\N	0	0	\N	\N	0	104373	0	8331-1	3006322		
42491	3926	3011505	1997-10-27	1997-10-27 00:00:00	1997-10-27	5001	0	\N	0	0	\N	\N	0	260931	0	19926-5	3011505		
372	16	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	1173	0	6833-8	3023430		
27480	2542	3006322	2017-04-22	2017-04-22 00:00:00	2017-04-22	5001	0	\N	0	0	\N	\N	0	168115	0	8331-1	3006322		
2389	225	3036780	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	15183	0	6095-4	3036780		
2469	236	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	15882	0	6248-9	3015076		
20520	1882	3006322	1973-07-16	1973-07-16 00:00:00	1973-07-16	5001	0	\N	0	0	\N	\N	0	125479	0	8331-1	3006322		
109876	3392	4052083	2013-09-12	2013-09-12 00:00:00	2013-09-12	5001	0	\N	0	0	\N	\N	0	224978	0	23426006	4052083		
118455	3647	4052083	2018-06-25	2018-06-25 00:00:00	2018-06-25	5001	0	\N	0	0	\N	\N	0	242604	0	23426006	4052083		
47916	4388	3006322	1966-09-22	1966-09-22 00:00:00	1966-09-22	5001	0	\N	0	0	\N	\N	0	291657	0	8331-1	3006322		
138697	4276	4024958	2016-09-24	2016-09-24 00:00:00	2016-09-24	5001	0	\N	0	0	\N	\N	0	283778	0	117015009	4024958		
26396	2427	3006322	2011-05-28	2011-05-28 00:00:00	2011-05-28	5001	0	\N	0	0	\N	\N	0	160967	0	8331-1	3006322		
20626	648	4024958	2018-05-02	2018-05-02 00:00:00	2018-05-02	5001	0	\N	0	0	\N	\N	0	42955	0	117015009	4024958		
15738	1441	3019406	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	95975	0	6158-0	3019406		
31699	2898	3036780	1980-03-29	1980-03-29 00:00:00	1980-03-29	5001	0	\N	0	0	\N	\N	0	193004	0	6095-4	3036780		
7424	711	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	47111	0	6273-7	3006451		
27191	2522	46235214	1995-11-29	1995-11-29 00:00:00	1995-11-29	5001	0	\N	0	0	\N	\N	0	166802	0	76690-7	46235214		
38570	3568	3051031	2004-06-14	2004-06-14 00:00:00	2004-06-14	5001	0	\N	0	0	\N	\N	0	237108	0	46240-8	3051031		
38628	3571	3006322	1980-12-10	1980-12-10 00:00:00	1980-12-10	5001	0	\N	0	0	\N	\N	0	237343	0	8331-1	3006322		
50004	4548	3006451	1986-11-17	1986-11-17 00:00:00	1986-11-17	5001	0	\N	0	0	\N	\N	0	303082	0	6273-7	3006451		
44660	4121	46235214	1921-09-15	1921-09-15 00:00:00	1921-09-15	5001	0	\N	0	0	\N	\N	0	273986	0	76690-7	46235214		
56028	5142	3049273	2013-07-23	2013-07-23 00:00:00	2013-07-23	5001	0	\N	0	0	\N	\N	0	341698	0	38265-5	3049273		
46705	1427	4024958	1957-11-29	1957-11-29 00:00:00	1957-11-29	5001	0	\N	0	0	\N	\N	0	94951	0	117015009	4024958		
53183	4890	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	325188	0	6273-7	3006451		
12637	1211	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	79579	0	6273-7	3006451		
24004	2210	3006322	1990-09-08	1990-09-08 00:00:00	1990-09-08	5001	0	\N	0	0	\N	\N	0	147216	0	8331-1	3006322		
89423	2768	4024958	2009-10-30	2009-10-30 00:00:00	2009-10-30	5001	0	\N	0	0	\N	\N	0	183124	0	117015009	4024958		
24503	2261	40766240	1966-05-28	1966-05-28 00:00:00	1966-05-28	5001	0	\N	0	0	\N	\N	0	150283	0	63513-6	40766240		
35924	3296	3049273	2019-02-08	2019-02-08 00:00:00	2019-02-08	5001	0	\N	0	0	\N	\N	0	219097	0	38265-5	3049273		
36205	3332	3006322	2002-04-09	2002-04-09 00:00:00	2002-04-09	5001	0	\N	0	0	\N	\N	0	221074	0	8331-1	3006322		
47001	4324	3001247	1981-06-30	1981-06-30 00:00:00	1981-06-30	5001	0	\N	0	0	\N	\N	0	286849	0	6085-5	3001247		
9338	884	3019406	1994-03-15	1994-03-15 00:00:00	1994-03-15	5001	0	\N	0	0	\N	\N	0	58863	0	6158-0	3019406		
19902	1826	3006322	1949-06-25	1949-06-25 00:00:00	1949-06-25	5001	0	\N	0	0	\N	\N	0	121998	0	8331-1	3006322		
47746	4376	3011505	2001-11-06	2001-11-06 00:00:00	2001-11-06	5001	0	\N	0	0	\N	\N	0	290836	0	19926-5	3011505		
94655	2909	4133840	2004-06-27	2004-06-27 00:00:00	2004-06-27	5001	0	\N	0	0	\N	\N	0	193927	0	127783003	4133840		
13576	430	4052083	2006-02-15	2006-02-15 00:00:00	2006-02-15	5001	0	\N	0	0	\N	\N	0	28441	0	23426006	4052083		
32344	2939	3006322	1977-10-17	1977-10-17 00:00:00	1977-10-17	5001	0	\N	0	0	\N	\N	0	195940	0	8331-1	3006322		
172115	5283	4052083	1989-06-28	1989-06-28 00:00:00	1989-06-28	5001	0	\N	0	0	\N	\N	0	351425	0	23426006	4052083		
119776	3694	4052083	2019-01-24	2019-01-24 00:00:00	2019-01-24	5001	0	\N	0	0	\N	\N	0	245481	0	23426006	4052083		
6449	605	3006322	1957-07-12	1957-07-12 00:00:00	1957-07-12	5001	0	\N	0	0	\N	\N	0	40119	0	8331-1	3006322		
6504	610	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	40494	0	6246-3	3021226		
21491	1980	3005136	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	131811	0	6075-6	3005136		
21590	1992	3012494	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	132659	0	6206-7	3012494		
32722	2965	3027231	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	198013	0	6276-0	3027231		
13088	1250	3006322	1954-10-15	1954-10-15 00:00:00	1954-10-15	5001	0	\N	0	0	\N	\N	0	82393	0	8331-1	3006322		
29454	2711	3001488	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	179667	0	7258-7	3001488		
44211	4072	3006322	2006-01-24	2006-01-24 00:00:00	2006-01-24	5001	0	\N	0	0	\N	\N	0	270670	0	8331-1	3006322		
40927	3793	3051031	1942-11-22	1942-11-22 00:00:00	1942-11-22	5001	0	\N	0	0	\N	\N	0	252229	0	46240-8	3051031		
18514	1702	3006322	1967-04-22	1967-04-22 00:00:00	1967-04-22	5001	0	\N	0	0	\N	\N	0	113786	0	8331-1	3006322		
121723	3756	4133840	2016-07-09	2016-07-09 00:00:00	2016-07-09	5001	0	\N	0	0	\N	\N	0	249693	0	127783003	4133840		
52431	4822	3011505	2003-10-29	2003-10-29 00:00:00	2003-10-29	5001	0	\N	0	0	\N	\N	0	320770	0	19926-5	3011505		
6704	640	3006322	2006-06-20	2006-06-20 00:00:00	2006-06-20	5001	0	\N	0	0	\N	\N	0	42402	0	8331-1	3006322		
53425	4905	3006322	1977-07-09	1977-07-09 00:00:00	1977-07-09	5001	0	\N	0	0	\N	\N	0	326063	0	8331-1	3006322		
39138	1217	4133840	1998-07-03	1998-07-03 00:00:00	1998-07-03	5001	0	\N	0	0	\N	\N	0	80193	0	127783003	4133840		
41515	3865	3006322	1986-04-25	1986-04-25 00:00:00	1986-04-25	5001	0	\N	0	0	\N	\N	0	256661	0	8331-1	3006322		
25846	2372	3006322	1991-06-22	1991-06-22 00:00:00	1991-06-22	5001	0	\N	0	0	\N	\N	0	157827	0	8331-1	3006322		
52240	4804	3051031	1983-07-18	1983-07-18 00:00:00	1983-07-18	5001	0	\N	0	0	\N	\N	0	319536	0	46240-8	3051031		
3305	318	3006322	2005-11-26	2005-11-26 00:00:00	2005-11-26	5001	0	\N	0	0	\N	\N	0	21058	0	8331-1	3006322		
27823	2559	3012494	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	169613	0	6206-7	3012494		
166479	5116	4024958	2000-01-08	2000-01-08 00:00:00	2000-01-08	5001	0	\N	0	0	\N	\N	0	339973	0	117015009	4024958		
39334	3636	3051031	2014-09-02	2014-09-02 00:00:00	2014-09-02	5001	0	\N	0	0	\N	\N	0	241842	0	46240-8	3051031		
22838	2088	3051031	1996-01-29	1996-01-29 00:00:00	1996-01-29	5001	0	\N	0	0	\N	\N	0	139294	0	46240-8	3051031		
5691	533	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	35428	0	6095-4	3036780		
109999	3394	4052083	2016-02-17	2016-02-17 00:00:00	2016-02-17	5001	0	\N	0	0	\N	\N	0	225120	0	23426006	4052083		
17130	1558	3006322	1999-08-03	1999-08-03 00:00:00	1999-08-03	5001	0	\N	0	0	\N	\N	0	104308	0	8331-1	3006322		
42492	3926	3006322	2012-06-19	2012-06-19 00:00:00	2012-06-19	5001	0	\N	0	0	\N	\N	0	260986	0	8331-1	3006322		
373	16	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	1173	0	6085-5	3001247		
27481	2543	3006322	1979-09-04	1979-09-04 00:00:00	1979-09-04	5001	0	\N	0	0	\N	\N	0	168281	0	8331-1	3006322		
2390	225	3020655	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	15183	0	6844-5	3020655		
2470	236	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	15882	0	6075-6	3005136		
20526	1885	3006322	2009-02-19	2009-02-19 00:00:00	2009-02-19	5001	0	\N	0	0	\N	\N	0	125675	0	8331-1	3006322		
109879	3392	4024958	1973-08-28	1973-08-28 00:00:00	1973-08-28	5001	0	\N	0	0	\N	\N	0	224966	0	117015009	4024958		
118465	3647	4024958	1946-08-22	1946-08-22 00:00:00	1946-08-22	5001	0	\N	0	0	\N	\N	0	242619	0	117015009	4024958		
47917	4388	3006322	1996-05-10	1996-05-10 00:00:00	1996-05-10	5001	0	\N	0	0	\N	\N	0	291701	0	8331-1	3006322		
138698	4276	4024958	1960-02-19	1960-02-19 00:00:00	1960-02-19	5001	0	\N	0	0	\N	\N	0	283739	0	117015009	4024958		
26397	2428	3006322	1984-08-03	1984-08-03 00:00:00	1984-08-03	5001	0	\N	0	0	\N	\N	0	161082	0	8331-1	3006322		
20628	648	4052083	1944-03-16	1944-03-16 00:00:00	1944-03-16	5001	0	\N	0	0	\N	\N	0	42913	0	23426006	4052083		
15739	1441	3001488	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	95975	0	7258-7	3001488		
31700	2898	3012494	1980-03-29	1980-03-29 00:00:00	1980-03-29	5001	0	\N	0	0	\N	\N	0	193004	0	6206-7	3012494		
7425	711	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	47111	0	6276-0	3027231		
27192	2522	3051031	1995-11-29	1995-11-29 00:00:00	1995-11-29	5001	0	\N	0	0	\N	\N	0	166802	0	46240-8	3051031		
38572	3568	46235214	2004-10-12	2004-10-12 00:00:00	2004-10-12	5001	0	\N	0	0	\N	\N	0	237059	0	76690-7	46235214		
38629	3571	3006322	1988-08-01	1988-08-01 00:00:00	1988-08-01	5001	0	\N	0	0	\N	\N	0	237332	0	8331-1	3006322		
50005	4548	3014599	1986-11-17	1986-11-17 00:00:00	1986-11-17	5001	0	\N	0	0	\N	\N	0	303082	0	6106-9	3014599		
44661	4121	3051031	1921-09-15	1921-09-15 00:00:00	1921-09-15	5001	0	\N	0	0	\N	\N	0	273986	0	46240-8	3051031		
56029	5143	3006322	1995-09-28	1995-09-28 00:00:00	1995-09-28	5001	0	\N	0	0	\N	\N	0	341845	0	8331-1	3006322		
46717	1427	4052083	1979-07-07	1979-07-07 00:00:00	1979-07-07	5001	0	\N	0	0	\N	\N	0	94920	0	23426006	4052083		
53184	4890	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	325188	0	6276-0	3027231		
12638	1211	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	79579	0	6844-5	3020655		
24005	2210	3006322	2016-06-21	2016-06-21 00:00:00	2016-06-21	5001	0	\N	0	0	\N	\N	0	147220	0	8331-1	3006322		
89424	2768	4024958	2006-04-04	2006-04-04 00:00:00	2006-04-04	5001	0	\N	0	0	\N	\N	0	183142	0	117015009	4024958		
24504	2261	40758406	1966-05-28	1966-05-28 00:00:00	1966-05-28	5001	0	\N	0	0	\N	\N	0	150283	0	55277-8	40758406		
35925	3296	3006322	1949-09-29	1949-09-29 00:00:00	1949-09-29	5001	0	\N	0	0	\N	\N	0	218992	0	8331-1	3006322		
36206	3332	3006322	1971-03-17	1971-03-17 00:00:00	1971-03-17	5001	0	\N	0	0	\N	\N	0	221068	0	8331-1	3006322		
47002	4324	3006734	1981-06-30	1981-06-30 00:00:00	1981-06-30	5001	0	\N	0	0	\N	\N	0	286849	0	6189-5	3006734		
9339	884	3027231	1978-11-13	1978-11-13 00:00:00	1978-11-13	5001	0	\N	0	0	\N	\N	0	58857	0	6276-0	3027231		
19903	1826	3006322	1945-08-02	1945-08-02 00:00:00	1945-08-02	5001	0	\N	0	0	\N	\N	0	121997	0	8331-1	3006322		
47747	4376	40766240	2012-06-28	2012-06-28 00:00:00	2012-06-28	5001	0	\N	0	0	\N	\N	0	290713	0	63513-6	40766240		
94660	2909	4133840	1996-05-12	1996-05-12 00:00:00	1996-05-12	5001	0	\N	0	0	\N	\N	0	193868	0	127783003	4133840		
13597	430	4024958	1991-05-06	1991-05-06 00:00:00	1991-05-06	5001	0	\N	0	0	\N	\N	0	28495	0	117015009	4024958		
32345	2939	3006322	1954-03-03	1954-03-03 00:00:00	1954-03-03	5001	0	\N	0	0	\N	\N	0	195948	0	8331-1	3006322		
172120	5283	4024958	1996-08-17	1996-08-17 00:00:00	1996-08-17	5001	0	\N	0	0	\N	\N	0	351420	0	117015009	4024958		
119778	3694	4052083	2017-09-14	2017-09-14 00:00:00	2017-09-14	5001	0	\N	0	0	\N	\N	0	245527	0	23426006	4052083		
6450	605	3006322	1995-11-26	1995-11-26 00:00:00	1995-11-26	5001	0	\N	0	0	\N	\N	0	40128	0	8331-1	3006322		
6505	610	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	40494	0	6106-9	3014599		
21492	1980	3001488	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	131811	0	7258-7	3001488		
21591	1992	3006322	1983-07-22	1983-07-22 00:00:00	1983-07-22	5001	0	\N	0	0	\N	\N	0	132731	0	8331-1	3006322		
32723	2965	3020655	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	198013	0	6844-5	3020655		
13089	1250	3006322	1996-05-22	1996-05-22 00:00:00	1996-05-22	5001	0	\N	0	0	\N	\N	0	82322	0	8331-1	3006322		
29455	2711	3020655	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	179667	0	6844-5	3020655		
55491	5097	40769179	1992-07-02	1992-07-02 00:00:00	1992-07-02	5001	0	\N	0	0	\N	\N	0	338657	0	66519-0	40769179		
40929	3793	46235214	1942-11-22	1942-11-22 00:00:00	1942-11-22	5001	0	\N	0	0	\N	\N	0	252229	0	76690-7	46235214		
18515	1702	3006322	2011-04-01	2011-04-01 00:00:00	2011-04-01	5001	0	\N	0	0	\N	\N	0	113796	0	8331-1	3006322		
121726	3756	4052083	1968-12-13	1968-12-13 00:00:00	1968-12-13	5001	0	\N	0	0	\N	\N	0	249624	0	23426006	4052083		
52432	4822	3006322	1953-12-23	1953-12-23 00:00:00	1953-12-23	5001	0	\N	0	0	\N	\N	0	320728	0	8331-1	3006322		
6705	640	3006322	1982-04-16	1982-04-16 00:00:00	1982-04-16	5001	0	\N	0	0	\N	\N	0	42369	0	8331-1	3006322		
53426	4905	3006322	1977-08-18	1977-08-18 00:00:00	1977-08-18	5001	0	\N	0	0	\N	\N	0	326027	0	8331-1	3006322		
39139	1217	4133840	2006-12-22	2006-12-22 00:00:00	2006-12-22	5001	0	\N	0	0	\N	\N	0	80195	0	127783003	4133840		
41516	3866	3006322	2018-08-30	2018-08-30 00:00:00	2018-08-30	5001	0	\N	0	0	\N	\N	0	256763	0	8331-1	3006322		
25847	2373	3006322	1967-06-05	1967-06-05 00:00:00	1967-06-05	5001	0	\N	0	0	\N	\N	0	157885	0	8331-1	3006322		
52241	4804	3027231	1990-03-26	1990-03-26 00:00:00	1990-03-26	5001	0	\N	0	0	\N	\N	0	319661	0	6276-0	3027231		
3308	320	3006322	1981-11-19	1981-11-19 00:00:00	1981-11-19	5001	0	\N	0	0	\N	\N	0	21227	0	8331-1	3006322		
27824	2559	3014599	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	169613	0	6106-9	3014599		
155347	4761	4052083	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	317214	0	23426006	4052083		
39335	3636	40766240	2014-09-02	2014-09-02 00:00:00	2014-09-02	5001	0	\N	0	0	\N	\N	0	241842	0	63513-6	40766240		
22839	2088	40766240	1996-01-29	1996-01-29 00:00:00	1996-01-29	5001	0	\N	0	0	\N	\N	0	139294	0	63513-6	40766240		
5692	533	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	35428	0	6276-0	3027231		
110001	3394	4024958	1967-08-27	1967-08-27 00:00:00	1967-08-27	5001	0	\N	0	0	\N	\N	0	225141	0	117015009	4024958		
17137	1560	3006322	1936-02-12	1936-02-12 00:00:00	1936-02-12	5001	0	\N	0	0	\N	\N	0	104436	0	8331-1	3006322		
42493	3926	3011505	1988-10-03	1988-10-03 00:00:00	1988-10-03	5001	0	\N	0	0	\N	\N	0	260950	0	19926-5	3011505		
374	16	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	1173	0	6075-6	3005136		
27483	2543	3051031	1986-01-06	1986-01-06 00:00:00	1986-01-06	5001	0	\N	0	0	\N	\N	0	168251	0	46240-8	3051031		
2391	225	3001488	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	15183	0	7258-7	3001488		
2471	236	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	15882	0	6206-7	3012494		
20674	1898	40766240	1972-04-05	1972-04-05 00:00:00	1972-04-05	5001	0	\N	0	0	\N	\N	0	126391	0	63513-6	40766240		
109891	3392	4024958	2006-09-26	2006-09-26 00:00:00	2006-09-26	5001	0	\N	0	0	\N	\N	0	224961	0	117015009	4024958		
118487	3647	4024958	1978-02-20	1978-02-20 00:00:00	1978-02-20	5001	0	\N	0	0	\N	\N	0	242718	0	117015009	4024958		
47918	4388	3006322	1978-11-21	1978-11-21 00:00:00	1978-11-21	5001	0	\N	0	0	\N	\N	0	291693	0	8331-1	3006322		
138705	4276	4024958	1977-07-30	1977-07-30 00:00:00	1977-07-30	5001	0	\N	0	0	\N	\N	0	283760	0	117015009	4024958		
26398	2428	3006322	1989-04-21	1989-04-21 00:00:00	1989-04-21	5001	0	\N	0	0	\N	\N	0	161083	0	8331-1	3006322		
20635	648	4052083	1961-11-25	1961-11-25 00:00:00	1961-11-25	5001	0	\N	0	0	\N	\N	0	42847	0	23426006	4052083		
15740	1441	3005136	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	95975	0	6075-6	3005136		
31701	2898	3021226	1980-03-29	1980-03-29 00:00:00	1980-03-29	5001	0	\N	0	0	\N	\N	0	193004	0	6246-3	3021226		
7426	711	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	47111	0	6246-3	3021226		
27194	2522	40766240	1995-11-29	1995-11-29 00:00:00	1995-11-29	5001	0	\N	0	0	\N	\N	0	166802	0	63513-6	40766240		
38574	3568	40758406	2004-10-12	2004-10-12 00:00:00	2004-10-12	5001	0	\N	0	0	\N	\N	0	237059	0	55277-8	40758406		
38630	3571	3021226	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	237417	0	6246-3	3021226		
50006	4548	3036780	1986-11-17	1986-11-17 00:00:00	1986-11-17	5001	0	\N	0	0	\N	\N	0	303082	0	6095-4	3036780		
44663	4121	3011505	1984-10-21	1984-10-21 00:00:00	1984-10-21	5001	0	\N	0	0	\N	\N	0	273991	0	19926-5	3011505		
56030	5144	3006322	1955-11-17	1955-11-17 00:00:00	1955-11-17	5001	0	\N	0	0	\N	\N	0	341927	0	8331-1	3006322		
57998	1766	4133840	2015-11-17	2015-11-17 00:00:00	2015-11-17	5001	0	\N	0	0	\N	\N	0	118186	0	127783003	4133840		
53185	4890	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	325188	0	6075-6	3005136		
12639	1211	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	79579	0	7258-7	3001488		
24006	2210	3006322	1978-12-26	1978-12-26 00:00:00	1978-12-26	5001	0	\N	0	0	\N	\N	0	147265	0	8331-1	3006322		
89442	2768	4024958	1984-05-06	1984-05-06 00:00:00	1984-05-06	5001	0	\N	0	0	\N	\N	0	183171	0	117015009	4024958		
24507	2261	46235214	1965-11-29	1965-11-29 00:00:00	1965-11-29	5001	0	\N	0	0	\N	\N	0	150281	0	76690-7	46235214		
35926	3298	3006322	1972-12-10	1972-12-10 00:00:00	1972-12-10	5001	0	\N	0	0	\N	\N	0	219125	0	8331-1	3006322		
36207	3332	3006322	2011-05-06	2011-05-06 00:00:00	2011-05-06	5001	0	\N	0	0	\N	\N	0	221128	0	8331-1	3006322		
47003	4324	3000876	1981-06-30	1981-06-30 00:00:00	1981-06-30	5001	0	\N	0	0	\N	\N	0	286849	0	6082-2	3000876		
9340	884	3005136	1978-11-13	1978-11-13 00:00:00	1978-11-13	5001	0	\N	0	0	\N	\N	0	58857	0	6075-6	3005136		
19904	1826	3006322	2016-01-22	2016-01-22 00:00:00	2016-01-22	5001	0	\N	0	0	\N	\N	0	122018	0	8331-1	3006322		
47748	4376	40758406	2012-06-28	2012-06-28 00:00:00	2012-06-28	5001	0	\N	0	0	\N	\N	0	290713	0	55277-8	40758406		
94662	2909	4133840	1990-04-22	1990-04-22 00:00:00	1990-04-22	5001	0	\N	0	0	\N	\N	0	193925	0	127783003	4133840		
13600	430	4052083	1986-01-05	1986-01-05 00:00:00	1986-01-05	5001	0	\N	0	0	\N	\N	0	28458	0	23426006	4052083		
32346	2939	3006322	1958-03-28	1958-03-28 00:00:00	1958-03-28	5001	0	\N	0	0	\N	\N	0	195939	0	8331-1	3006322		
15508	1418	3006322	1978-01-02	1978-01-02 00:00:00	1978-01-02	5001	0	\N	0	0	\N	\N	0	94422	0	8331-1	3006322		
119780	3695	4052083	2008-11-30	2008-11-30 00:00:00	2008-11-30	5001	0	\N	0	0	\N	\N	0	245592	0	23426006	4052083		
6451	605	3006322	2000-10-28	2000-10-28 00:00:00	2000-10-28	5001	0	\N	0	0	\N	\N	0	40187	0	8331-1	3006322		
6506	610	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	40494	0	6844-5	3020655		
21493	1980	3021226	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	131811	0	6246-3	3021226		
21592	1992	3019406	1978-04-17	1978-04-17 00:00:00	1978-04-17	5001	0	\N	0	0	\N	\N	0	132718	0	6158-0	3019406		
32724	2965	3001488	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	198013	0	7258-7	3001488		
13090	1250	3006322	1958-12-08	1958-12-08 00:00:00	1958-12-08	5001	0	\N	0	0	\N	\N	0	82327	0	8331-1	3006322		
29458	2711	3006322	1998-07-30	1998-07-30 00:00:00	1998-07-30	5001	0	\N	0	0	\N	\N	0	179669	0	8331-1	3006322		
55492	5097	40769189	1992-07-02	1992-07-02 00:00:00	1992-07-02	5001	0	\N	0	0	\N	\N	0	338657	0	66529-9	40769189		
40930	3793	40766240	1942-11-22	1942-11-22 00:00:00	1942-11-22	5001	0	\N	0	0	\N	\N	0	252229	0	63513-6	40766240		
18516	1702	3006322	2013-03-05	2013-03-05 00:00:00	2013-03-05	5001	0	\N	0	0	\N	\N	0	113776	0	8331-1	3006322		
121730	3756	4133840	2012-06-16	2012-06-16 00:00:00	2012-06-16	5001	0	\N	0	0	\N	\N	0	249678	0	127783003	4133840		
52433	4822	3011505	2004-11-03	2004-11-03 00:00:00	2004-11-03	5001	0	\N	0	0	\N	\N	0	320789	0	19926-5	3011505		
22174	2033	3051031	2017-05-30	2017-05-30 00:00:00	2017-05-30	5001	0	\N	0	0	\N	\N	0	135354	0	46240-8	3051031		
53427	4905	3006322	1980-06-19	1980-06-19 00:00:00	1980-06-19	5001	0	\N	0	0	\N	\N	0	326032	0	8331-1	3006322		
102350	3145	4052083	1987-09-01	1987-09-01 00:00:00	1987-09-01	5001	0	\N	0	0	\N	\N	0	209256	0	23426006	4052083		
41517	3866	3006322	1973-07-12	1973-07-12 00:00:00	1973-07-12	5001	0	\N	0	0	\N	\N	0	256685	0	8331-1	3006322		
25848	2373	3006322	1965-11-26	1965-11-26 00:00:00	1965-11-26	5001	0	\N	0	0	\N	\N	0	157884	0	8331-1	3006322		
52242	4804	3001247	1990-03-26	1990-03-26 00:00:00	1990-03-26	5001	0	\N	0	0	\N	\N	0	319661	0	6085-5	3001247		
3309	320	3011505	2012-02-19	2012-02-19 00:00:00	2012-02-19	5001	0	\N	0	0	\N	\N	0	21186	0	19926-5	3011505		
27825	2559	3019406	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	169613	0	6158-0	3019406		
166652	5118	4024958	1968-11-27	1968-11-27 00:00:00	1968-11-27	5001	0	\N	0	0	\N	\N	0	340210	0	117015009	4024958		
39336	3636	3006322	1999-09-30	1999-09-30 00:00:00	1999-09-30	5001	0	\N	0	0	\N	\N	0	241869	0	8331-1	3006322		
22840	2088	3011505	1989-07-25	1989-07-25 00:00:00	1989-07-25	5001	0	\N	0	0	\N	\N	0	139235	0	19926-5	3011505		
5693	533	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	35428	0	6246-3	3021226		
110009	3394	4052083	1975-11-19	1975-11-19 00:00:00	1975-11-19	5001	0	\N	0	0	\N	\N	0	225163	0	23426006	4052083		
17138	1560	3006322	1984-05-27	1984-05-27 00:00:00	1984-05-27	5001	0	\N	0	0	\N	\N	0	104483	0	8331-1	3006322		
42494	3926	3011505	1992-10-12	1992-10-12 00:00:00	1992-10-12	5001	0	\N	0	0	\N	\N	0	260995	0	19926-5	3011505		
375	16	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	1173	0	6248-9	3015076		
27484	2543	40758406	1986-01-06	1986-01-06 00:00:00	1986-01-06	5001	0	\N	0	0	\N	\N	0	168251	0	55277-8	40758406		
2392	225	3006734	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	15183	0	6189-5	3006734		
2472	236	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	15882	0	6246-3	3021226		
20676	1898	3006322	1981-09-24	1981-09-24 00:00:00	1981-09-24	5001	0	\N	0	0	\N	\N	0	126351	0	8331-1	3006322		
144452	4439	4052083	1989-07-08	1989-07-08 00:00:00	1989-07-08	5001	0	\N	0	0	\N	\N	0	295127	0	23426006	4052083		
118495	3647	4052083	2004-03-31	2004-03-31 00:00:00	2004-03-31	5001	0	\N	0	0	\N	\N	0	242722	0	23426006	4052083		
129781	3998	4024958	1993-02-04	1993-02-04 00:00:00	1993-02-04	5001	0	\N	0	0	\N	\N	0	265788	0	117015009	4024958		
150034	4602	4024958	2004-02-20	2004-02-20 00:00:00	2004-02-20	5001	0	\N	0	0	\N	\N	0	306567	0	117015009	4024958		
26399	2428	3006322	1993-09-13	1993-09-13 00:00:00	1993-09-13	5001	0	\N	0	0	\N	\N	0	161095	0	8331-1	3006322		
20647	648	4024958	1949-11-02	1949-11-02 00:00:00	1949-11-02	5001	0	\N	0	0	\N	\N	0	42914	0	117015009	4024958		
15741	1441	3027231	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	95975	0	6276-0	3027231		
31702	2898	3001247	1980-03-29	1980-03-29 00:00:00	1980-03-29	5001	0	\N	0	0	\N	\N	0	193004	0	6085-5	3001247		
7427	711	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	47111	0	6085-5	3001247		
27196	2522	3006322	2015-06-05	2015-06-05 00:00:00	2015-06-05	5001	0	\N	0	0	\N	\N	0	166797	0	8331-1	3006322		
38575	3568	3051031	2004-10-12	2004-10-12 00:00:00	2004-10-12	5001	0	\N	0	0	\N	\N	0	237059	0	46240-8	3051031		
38631	3571	3014599	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	237417	0	6106-9	3014599		
50007	4548	3020655	1996-10-22	1996-10-22 00:00:00	1996-10-22	5001	0	\N	0	0	\N	\N	0	303083	0	6844-5	3020655		
44664	4121	3011505	1983-10-16	1983-10-16 00:00:00	1983-10-16	5001	0	\N	0	0	\N	\N	0	274009	0	19926-5	3011505		
56032	5144	3006322	1959-08-12	1959-08-12 00:00:00	1959-08-12	5001	0	\N	0	0	\N	\N	0	341964	0	8331-1	3006322		
58001	1766	4133840	1987-01-13	1987-01-13 00:00:00	1987-01-13	5001	0	\N	0	0	\N	\N	0	118158	0	127783003	4133840		
53186	4890	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	325188	0	6082-2	3000876		
12640	1211	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	79579	0	6189-5	3006734		
24007	2210	3006322	1954-09-05	1954-09-05 00:00:00	1954-09-05	5001	0	\N	0	0	\N	\N	0	147264	0	8331-1	3006322		
42238	3904	3006322	1986-04-17	1986-04-17 00:00:00	1986-04-17	5001	0	\N	0	0	\N	\N	0	259592	0	8331-1	3006322		
24508	2261	3051031	1965-11-29	1965-11-29 00:00:00	1965-11-29	5001	0	\N	0	0	\N	\N	0	150281	0	46240-8	3051031		
35927	3298	3006322	1984-06-02	1984-06-02 00:00:00	1984-06-02	5001	0	\N	0	0	\N	\N	0	219163	0	8331-1	3006322		
36208	3334	3006322	1959-12-13	1959-12-13 00:00:00	1959-12-13	5001	0	\N	0	0	\N	\N	0	221145	0	8331-1	3006322		
47004	4324	3036780	1981-06-30	1981-06-30 00:00:00	1981-06-30	5001	0	\N	0	0	\N	\N	0	286849	0	6095-4	3036780		
9341	884	3014599	1978-11-13	1978-11-13 00:00:00	1978-11-13	5001	0	\N	0	0	\N	\N	0	58857	0	6106-9	3014599		
19905	1826	3006322	1985-06-18	1985-06-18 00:00:00	1985-06-18	5001	0	\N	0	0	\N	\N	0	122054	0	8331-1	3006322		
47749	4376	3051031	2012-06-28	2012-06-28 00:00:00	2012-06-28	5001	0	\N	0	0	\N	\N	0	290713	0	46240-8	3051031		
94664	2909	4052083	1972-03-13	1972-03-13 00:00:00	1972-03-13	5001	0	\N	0	0	\N	\N	0	193844	0	23426006	4052083		
13604	431	4024958	1970-02-13	1970-02-13 00:00:00	1970-02-13	5001	0	\N	0	0	\N	\N	0	28553	0	117015009	4024958		
32347	2939	3006322	1953-03-25	1953-03-25 00:00:00	1953-03-25	5001	0	\N	0	0	\N	\N	0	195986	0	8331-1	3006322		
15509	1418	3006322	2012-08-29	2012-08-29 00:00:00	2012-08-29	5001	0	\N	0	0	\N	\N	0	94412	0	8331-1	3006322		
70065	2149	4024958	1968-07-12	1968-07-12 00:00:00	1968-07-12	5001	0	\N	0	0	\N	\N	0	143124	0	117015009	4024958		
6452	605	3006322	1979-04-13	1979-04-13 00:00:00	1979-04-13	5001	0	\N	0	0	\N	\N	0	40126	0	8331-1	3006322		
6507	610	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	40494	0	6082-2	3000876		
21494	1980	3019406	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	131811	0	6158-0	3019406		
21593	1992	3021226	1978-04-17	1978-04-17 00:00:00	1978-04-17	5001	0	\N	0	0	\N	\N	0	132718	0	6246-3	3021226		
32725	2965	3006734	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	198013	0	6189-5	3006734		
13096	1253	3006322	1978-01-20	1978-01-20 00:00:00	1978-01-20	5001	0	\N	0	0	\N	\N	0	82507	0	8331-1	3006322		
29459	2711	3006322	1953-05-15	1953-05-15 00:00:00	1953-05-15	5001	0	\N	0	0	\N	\N	0	179648	0	8331-1	3006322		
55493	5097	40769184	1992-07-02	1992-07-02 00:00:00	1992-07-02	5001	0	\N	0	0	\N	\N	0	338657	0	66524-0	40769184		
40932	3793	3051031	1941-05-26	1941-05-26 00:00:00	1941-05-26	5001	0	\N	0	0	\N	\N	0	252181	0	46240-8	3051031		
18517	1702	3006322	1973-05-04	1973-05-04 00:00:00	1973-05-04	5001	0	\N	0	0	\N	\N	0	113801	0	8331-1	3006322		
121733	3756	4133840	2015-07-04	2015-07-04 00:00:00	2015-07-04	5001	0	\N	0	0	\N	\N	0	249708	0	127783003	4133840		
52434	4822	3011505	2008-11-26	2008-11-26 00:00:00	2008-11-26	5001	0	\N	0	0	\N	\N	0	320791	0	19926-5	3011505		
22175	2033	40758406	2017-05-30	2017-05-30 00:00:00	2017-05-30	5001	0	\N	0	0	\N	\N	0	135354	0	55277-8	40758406		
53429	4907	3006322	1967-03-26	1967-03-26 00:00:00	1967-03-26	5001	0	\N	0	0	\N	\N	0	326170	0	8331-1	3006322		
102383	3147	4133840	1986-01-13	1986-01-13 00:00:00	1986-01-13	5001	0	\N	0	0	\N	\N	0	209362	0	127783003	4133840		
41518	3866	3006322	1966-02-10	1966-02-10 00:00:00	1966-02-10	5001	0	\N	0	0	\N	\N	0	256684	0	8331-1	3006322		
25849	2373	3006322	1970-05-01	1970-05-01 00:00:00	1970-05-01	5001	0	\N	0	0	\N	\N	0	157938	0	8331-1	3006322		
52243	4804	3036780	1990-03-26	1990-03-26 00:00:00	1990-03-26	5001	0	\N	0	0	\N	\N	0	319661	0	6095-4	3036780		
3310	320	3011505	1993-06-20	1993-06-20 00:00:00	1993-06-20	5001	0	\N	0	0	\N	\N	0	21204	0	19926-5	3011505		
27826	2559	3006451	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	169613	0	6273-7	3006451		
55242	1674	4024958	2011-12-20	2011-12-20 00:00:00	2011-12-20	5001	0	\N	0	0	\N	\N	0	112355	0	117015009	4024958		
39337	3636	3006322	1993-03-12	1993-03-12 00:00:00	1993-03-12	5001	0	\N	0	0	\N	\N	0	241836	0	8331-1	3006322		
22841	2088	3049273	1989-07-25	1989-07-25 00:00:00	1989-07-25	5001	0	\N	0	0	\N	\N	0	139235	0	38265-5	3049273		
5694	533	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	35428	0	7258-7	3001488		
17012	1551	3006322	2005-07-01	2005-07-01 00:00:00	2005-07-01	5001	0	\N	0	0	\N	\N	0	103869	0	8331-1	3006322		
17139	1560	3006322	1944-11-27	1944-11-27 00:00:00	1944-11-27	5001	0	\N	0	0	\N	\N	0	104501	0	8331-1	3006322		
42495	3926	3006322	1952-07-07	1952-07-07 00:00:00	1952-07-07	5001	0	\N	0	0	\N	\N	0	260922	0	8331-1	3006322		
376	16	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	1173	0	6276-0	3027231		
27485	2543	40766240	1986-01-06	1986-01-06 00:00:00	1986-01-06	5001	0	\N	0	0	\N	\N	0	168251	0	63513-6	40766240		
2393	225	3000876	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	15183	0	6082-2	3000876		
2473	236	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	15882	0	6189-5	3006734		
20677	1898	3006322	1991-04-03	1991-04-03 00:00:00	1991-04-03	5001	0	\N	0	0	\N	\N	0	126342	0	8331-1	3006322		
155741	4781	4024958	2016-12-14	2016-12-14 00:00:00	2016-12-14	5001	0	\N	0	0	\N	\N	0	318303	0	117015009	4024958		
13954	1310	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	86613	0	6095-4	3036780		
129783	3998	4024958	1962-02-08	1962-02-08 00:00:00	1962-02-08	5001	0	\N	0	0	\N	\N	0	265834	0	117015009	4024958		
142295	4375	4052083	1946-05-27	1946-05-27 00:00:00	1946-05-27	5001	0	\N	0	0	\N	\N	0	290635	0	23426006	4052083		
26403	2431	3006322	1976-11-04	1976-11-04 00:00:00	1976-11-04	5001	0	\N	0	0	\N	\N	0	161214	0	8331-1	3006322		
20648	648	4052083	2014-09-30	2014-09-30 00:00:00	2014-09-30	5001	0	\N	0	0	\N	\N	0	42891	0	23426006	4052083		
15742	1441	3006451	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	95975	0	6273-7	3006451		
31703	2898	3001488	1980-03-29	1980-03-29 00:00:00	1980-03-29	5001	0	\N	0	0	\N	\N	0	193004	0	7258-7	3001488		
7428	711	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	47111	0	6189-5	3006734		
27197	2522	40766240	1995-09-30	1995-09-30 00:00:00	1995-09-30	5001	0	\N	0	0	\N	\N	0	166794	0	63513-6	40766240		
38576	3568	40766240	2004-10-12	2004-10-12 00:00:00	2004-10-12	5001	0	\N	0	0	\N	\N	0	237059	0	63513-6	40766240		
38632	3571	3006451	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	237417	0	6273-7	3006451		
50008	4548	3023430	1996-10-22	1996-10-22 00:00:00	1996-10-22	5001	0	\N	0	0	\N	\N	0	303083	0	6833-8	3023430		
44665	4121	3011505	1972-08-13	1972-08-13 00:00:00	1972-08-13	5001	0	\N	0	0	\N	\N	0	274006	0	19926-5	3011505		
56034	5144	3006322	2007-11-21	2007-11-21 00:00:00	2007-11-21	5001	0	\N	0	0	\N	\N	0	341899	0	8331-1	3006322		
58003	1766	4133840	2007-10-02	2007-10-02 00:00:00	2007-10-02	5001	0	\N	0	0	\N	\N	0	118165	0	127783003	4133840		
53187	4890	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	325188	0	6158-0	3019406		
12641	1211	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	79579	0	6085-5	3001247		
24008	2211	3006322	1989-09-08	1989-09-08 00:00:00	1989-09-08	5001	0	\N	0	0	\N	\N	0	147298	0	8331-1	3006322		
42239	3906	3049273	2012-10-31	2012-10-31 00:00:00	2012-10-31	5001	0	\N	0	0	\N	\N	0	259712	0	38265-5	3049273		
24509	2261	40766240	1965-11-29	1965-11-29 00:00:00	1965-11-29	5001	0	\N	0	0	\N	\N	0	150281	0	63513-6	40766240		
35928	3298	3006322	1984-04-22	1984-04-22 00:00:00	1984-04-22	5001	0	\N	0	0	\N	\N	0	219126	0	8331-1	3006322		
36209	3334	3006322	2000-07-27	2000-07-27 00:00:00	2000-07-27	5001	0	\N	0	0	\N	\N	0	221147	0	8331-1	3006322		
47005	4324	3019406	1981-06-30	1981-06-30 00:00:00	1981-06-30	5001	0	\N	0	0	\N	\N	0	286849	0	6158-0	3019406		
9342	884	3006451	1978-11-13	1978-11-13 00:00:00	1978-11-13	5001	0	\N	0	0	\N	\N	0	58857	0	6273-7	3006451		
19906	1826	3006322	1961-08-30	1961-08-30 00:00:00	1961-08-30	5001	0	\N	0	0	\N	\N	0	122045	0	8331-1	3006322		
47752	4376	46235214	2012-06-28	2012-06-28 00:00:00	2012-06-28	5001	0	\N	0	0	\N	\N	0	290713	0	76690-7	46235214		
94665	2909	4052083	1957-05-13	1957-05-13 00:00:00	1957-05-13	5001	0	\N	0	0	\N	\N	0	193871	0	23426006	4052083		
24895	776	4133840	2016-09-15	2016-09-15 00:00:00	2016-09-15	5001	0	\N	0	0	\N	\N	0	51595	0	127783003	4133840		
32348	2939	3006322	2011-07-01	2011-07-01 00:00:00	2011-07-01	5001	0	\N	0	0	\N	\N	0	195954	0	8331-1	3006322		
15510	1418	3006322	2002-06-12	2002-06-12 00:00:00	2002-06-12	5001	0	\N	0	0	\N	\N	0	94435	0	8331-1	3006322		
70066	2149	4052083	1996-10-12	1996-10-12 00:00:00	1996-10-12	5001	0	\N	0	0	\N	\N	0	143128	0	23426006	4052083		
6453	605	3006322	1968-02-28	1968-02-28 00:00:00	1968-02-28	5001	0	\N	0	0	\N	\N	0	40153	0	8331-1	3006322		
6508	610	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	40494	0	6833-8	3023430		
21495	1980	3006322	2007-06-05	2007-06-05 00:00:00	2007-06-05	5001	0	\N	0	0	\N	\N	0	131834	0	8331-1	3006322		
21594	1992	3012494	1978-04-17	1978-04-17 00:00:00	1978-04-17	5001	0	\N	0	0	\N	\N	0	132718	0	6206-7	3012494		
32726	2965	3001247	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	198013	0	6085-5	3001247		
13097	1253	3006322	2004-03-18	2004-03-18 00:00:00	2004-03-18	5001	0	\N	0	0	\N	\N	0	82562	0	8331-1	3006322		
29460	2711	3001247	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	179639	0	6085-5	3001247		
55494	5097	3006451	1996-01-21	1996-01-21 00:00:00	1996-01-21	5001	0	\N	0	0	\N	\N	0	338744	0	6273-7	3006451		
40933	3793	46235214	1941-05-26	1941-05-26 00:00:00	1941-05-26	5001	0	\N	0	0	\N	\N	0	252181	0	76690-7	46235214		
18518	1702	3006322	1983-12-14	1983-12-14 00:00:00	1983-12-14	5001	0	\N	0	0	\N	\N	0	113795	0	8331-1	3006322		
20481	642	4024958	1972-01-28	1972-01-28 00:00:00	1972-01-28	5001	0	\N	0	0	\N	\N	0	42537	0	117015009	4024958		
52436	4822	40766240	1954-11-16	1954-11-16 00:00:00	1954-11-16	5001	0	\N	0	0	\N	\N	0	320731	0	63513-6	40766240		
22176	2033	46235214	2017-05-30	2017-05-30 00:00:00	2017-05-30	5001	0	\N	0	0	\N	\N	0	135354	0	76690-7	46235214		
53430	4907	3006322	1949-05-20	1949-05-20 00:00:00	1949-05-20	5001	0	\N	0	0	\N	\N	0	326168	0	8331-1	3006322		
102384	3147	4133840	1979-02-19	1979-02-19 00:00:00	1979-02-19	5001	0	\N	0	0	\N	\N	0	209382	0	127783003	4133840		
41519	3866	3006322	1957-05-16	1957-05-16 00:00:00	1957-05-16	5001	0	\N	0	0	\N	\N	0	256722	0	8331-1	3006322		
32356	1004	4024958	2014-04-01	2014-04-01 00:00:00	2014-04-01	5001	0	\N	0	0	\N	\N	0	66384	0	117015009	4024958		
52244	4804	3014599	1990-03-26	1990-03-26 00:00:00	1990-03-26	5001	0	\N	0	0	\N	\N	0	319661	0	6106-9	3014599		
3311	320	3011505	2002-03-10	2002-03-10 00:00:00	2002-03-10	5001	0	\N	0	0	\N	\N	0	21217	0	19926-5	3011505		
27827	2559	3021226	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	169613	0	6246-3	3021226		
55259	1676	4024958	1998-01-10	1998-01-10 00:00:00	1998-01-10	5001	0	\N	0	0	\N	\N	0	112460	0	117015009	4024958		
39338	3636	3006322	1978-11-11	1978-11-11 00:00:00	1978-11-11	5001	0	\N	0	0	\N	\N	0	241788	0	8331-1	3006322		
22842	2088	3011505	1999-06-01	1999-06-01 00:00:00	1999-06-01	5001	0	\N	0	0	\N	\N	0	139287	0	19926-5	3011505		
5695	533	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	35428	0	6189-5	3006734		
17013	1551	3006322	2019-01-02	2019-01-02 00:00:00	2019-01-02	5001	0	\N	0	0	\N	\N	0	103829	0	8331-1	3006322		
17140	1560	3006322	2014-08-29	2014-08-29 00:00:00	2014-08-29	5001	0	\N	0	0	\N	\N	0	104504	0	8331-1	3006322		
42496	3926	3011505	1998-11-02	1998-11-02 00:00:00	1998-11-02	5001	0	\N	0	0	\N	\N	0	261000	0	19926-5	3011505		
377	16	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	1173	0	6106-9	3014599		
27486	2543	46235214	1986-01-06	1986-01-06 00:00:00	1986-01-06	5001	0	\N	0	0	\N	\N	0	168251	0	76690-7	46235214		
2394	225	3014599	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	15183	0	6106-9	3014599		
2474	236	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	15882	0	7258-7	3001488		
20678	1898	3006322	1998-12-09	1998-12-09 00:00:00	1998-12-09	5001	0	\N	0	0	\N	\N	0	126352	0	8331-1	3006322		
155744	4781	4052083	1998-12-03	1998-12-03 00:00:00	1998-12-03	5001	0	\N	0	0	\N	\N	0	318293	0	23426006	4052083		
13955	1310	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	86613	0	6276-0	3027231		
129788	3998	4024958	2005-05-13	2005-05-13 00:00:00	2005-05-13	5001	0	\N	0	0	\N	\N	0	265776	0	117015009	4024958		
142302	4376	4133840	1988-08-23	1988-08-23 00:00:00	1988-08-23	5001	0	\N	0	0	\N	\N	0	290799	0	127783003	4133840		
26404	2431	3006322	1979-05-04	1979-05-04 00:00:00	1979-05-04	5001	0	\N	0	0	\N	\N	0	161203	0	8331-1	3006322		
20651	648	4024958	1946-09-06	1946-09-06 00:00:00	1946-09-06	5001	0	\N	0	0	\N	\N	0	42842	0	117015009	4024958		
15743	1441	3006322	1971-03-11	1971-03-11 00:00:00	1971-03-11	5001	0	\N	0	0	\N	\N	0	96034	0	8331-1	3006322		
31704	2898	3006734	1980-03-29	1980-03-29 00:00:00	1980-03-29	5001	0	\N	0	0	\N	\N	0	193004	0	6189-5	3006734		
7429	711	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	47111	0	7258-7	3001488		
27199	2522	3051031	1995-09-30	1995-09-30 00:00:00	1995-09-30	5001	0	\N	0	0	\N	\N	0	166794	0	46240-8	3051031		
38577	3568	3006322	1984-01-15	1984-01-15 00:00:00	1984-01-15	5001	0	\N	0	0	\N	\N	0	237095	0	8331-1	3006322		
38633	3571	3027231	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	237417	0	6276-0	3027231		
50009	4548	3000876	1996-10-22	1996-10-22 00:00:00	1996-10-22	5001	0	\N	0	0	\N	\N	0	303083	0	6082-2	3000876		
44666	4121	3006322	1965-05-11	1965-05-11 00:00:00	1965-05-11	5001	0	\N	0	0	\N	\N	0	273978	0	8331-1	3006322		
56035	5144	3006322	1970-04-30	1970-04-30 00:00:00	1970-04-30	5001	0	\N	0	0	\N	\N	0	341945	0	8331-1	3006322		
156405	4805	4052083	1983-07-07	1983-07-07 00:00:00	1983-07-07	5001	0	\N	0	0	\N	\N	0	319686	0	23426006	4052083		
53188	4890	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	325188	0	6844-5	3020655		
12642	1211	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	79579	0	6082-2	3000876		
24009	2211	3006322	1984-08-22	1984-08-22 00:00:00	1984-08-22	5001	0	\N	0	0	\N	\N	0	147302	0	8331-1	3006322		
42240	3906	3006322	1982-04-01	1982-04-01 00:00:00	1982-04-01	5001	0	\N	0	0	\N	\N	0	259675	0	8331-1	3006322		
24510	2261	40758406	1965-11-29	1965-11-29 00:00:00	1965-11-29	5001	0	\N	0	0	\N	\N	0	150281	0	55277-8	40758406		
35929	3300	3000963	2016-07-27	2016-07-27 00:00:00	2016-07-27	5001	0	\N	0	0	\N	\N	0	219248	0	718-7	3000963		
36210	3334	3006322	1986-02-28	1986-02-28 00:00:00	1986-02-28	5001	0	\N	0	0	\N	\N	0	221165	0	8331-1	3006322		
47006	4324	3021226	1981-06-30	1981-06-30 00:00:00	1981-06-30	5001	0	\N	0	0	\N	\N	0	286849	0	6246-3	3021226		
9343	884	3021226	1978-11-13	1978-11-13 00:00:00	1978-11-13	5001	0	\N	0	0	\N	\N	0	58857	0	6246-3	3021226		
19907	1826	3006322	1975-08-27	1975-08-27 00:00:00	1975-08-27	5001	0	\N	0	0	\N	\N	0	122053	0	8331-1	3006322		
47753	4376	3011505	2002-11-12	2002-11-12 00:00:00	2002-11-12	5001	0	\N	0	0	\N	\N	0	290705	0	19926-5	3011505		
94666	2909	4133840	1969-04-13	1969-04-13 00:00:00	1969-04-13	5001	0	\N	0	0	\N	\N	0	193872	0	127783003	4133840		
24901	776	4133840	2010-08-12	2010-08-12 00:00:00	2010-08-12	5001	0	\N	0	0	\N	\N	0	51583	0	127783003	4133840		
32349	2939	3006322	1985-06-21	1985-06-21 00:00:00	1985-06-21	5001	0	\N	0	0	\N	\N	0	195951	0	8331-1	3006322		
26627	834	4052083	1989-11-09	1989-11-09 00:00:00	1989-11-09	5001	0	\N	0	0	\N	\N	0	55176	0	23426006	4052083		
70087	2149	4052083	1959-08-17	1959-08-17 00:00:00	1959-08-17	5001	0	\N	0	0	\N	\N	0	143119	0	23426006	4052083		
6454	605	3006322	2000-08-15	2000-08-15 00:00:00	2000-08-15	5001	0	\N	0	0	\N	\N	0	40186	0	8331-1	3006322		
6509	610	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	40494	0	6189-5	3006734		
21496	1980	3015076	1975-10-10	1975-10-10 00:00:00	1975-10-10	5001	0	\N	0	0	\N	\N	0	131877	0	6248-9	3015076		
21595	1992	3015076	1978-04-17	1978-04-17 00:00:00	1978-04-17	5001	0	\N	0	0	\N	\N	0	132718	0	6248-9	3015076		
32727	2965	3000876	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	198013	0	6082-2	3000876		
13098	1253	3006322	1977-05-14	1977-05-14 00:00:00	1977-05-14	5001	0	\N	0	0	\N	\N	0	82506	0	8331-1	3006322		
29461	2711	3006734	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	179639	0	6189-5	3006734		
55495	5097	3015076	1996-01-21	1996-01-21 00:00:00	1996-01-21	5001	0	\N	0	0	\N	\N	0	338744	0	6248-9	3015076		
40934	3793	40766240	1941-05-26	1941-05-26 00:00:00	1941-05-26	5001	0	\N	0	0	\N	\N	0	252181	0	63513-6	40766240		
18519	1702	3006322	1975-11-30	1975-11-30 00:00:00	1975-11-30	5001	0	\N	0	0	\N	\N	0	113806	0	8331-1	3006322		
20504	644	4052083	2015-10-11	2015-10-11 00:00:00	2015-10-11	5001	0	\N	0	0	\N	\N	0	42615	0	23426006	4052083		
52438	4822	46235214	1954-11-16	1954-11-16 00:00:00	1954-11-16	5001	0	\N	0	0	\N	\N	0	320731	0	76690-7	46235214		
22178	2033	40766240	2017-05-30	2017-05-30 00:00:00	2017-05-30	5001	0	\N	0	0	\N	\N	0	135354	0	63513-6	40766240		
53431	4907	3006322	1986-04-11	1986-04-11 00:00:00	1986-04-11	5001	0	\N	0	0	\N	\N	0	326132	0	8331-1	3006322		
102387	3147	4133840	2009-04-20	2009-04-20 00:00:00	2009-04-20	5001	0	\N	0	0	\N	\N	0	209349	0	127783003	4133840		
41520	3866	3006322	1952-06-01	1952-06-01 00:00:00	1952-06-01	5001	0	\N	0	0	\N	\N	0	256729	0	8331-1	3006322		
32357	1004	4052083	2003-10-29	2003-10-29 00:00:00	2003-10-29	5001	0	\N	0	0	\N	\N	0	66378	0	23426006	4052083		
52245	4804	3015076	1990-03-26	1990-03-26 00:00:00	1990-03-26	5001	0	\N	0	0	\N	\N	0	319661	0	6248-9	3015076		
3312	320	3006322	2008-10-09	2008-10-09 00:00:00	2008-10-09	5001	0	\N	0	0	\N	\N	0	21239	0	8331-1	3006322		
27828	2559	3006322	1996-03-15	1996-03-15 00:00:00	1996-03-15	5001	0	\N	0	0	\N	\N	0	169581	0	8331-1	3006322		
55285	1677	4024958	1979-09-19	1979-09-19 00:00:00	1979-09-19	5001	0	\N	0	0	\N	\N	0	112491	0	117015009	4024958		
39339	3636	3006322	2004-04-19	2004-04-19 00:00:00	2004-04-19	5001	0	\N	0	0	\N	\N	0	241858	0	8331-1	3006322		
22843	2088	3011505	1975-08-12	1975-08-12 00:00:00	1975-08-12	5001	0	\N	0	0	\N	\N	0	139251	0	19926-5	3011505		
5696	533	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	35428	0	6273-7	3006451		
17014	1551	3006322	1978-09-24	1978-09-24 00:00:00	1978-09-24	5001	0	\N	0	0	\N	\N	0	103828	0	8331-1	3006322		
17141	1560	3006322	1968-01-10	1968-01-10 00:00:00	1968-01-10	5001	0	\N	0	0	\N	\N	0	104482	0	8331-1	3006322		
42497	3926	3011505	2012-03-12	2012-03-12 00:00:00	2012-03-12	5001	0	\N	0	0	\N	\N	0	260956	0	19926-5	3011505		
378	16	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	1173	0	6095-4	3036780		
27489	2543	40766240	1977-07-12	1977-07-12 00:00:00	1977-07-12	5001	0	\N	0	0	\N	\N	0	168279	0	63513-6	40766240		
2395	225	3019406	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	15183	0	6158-0	3019406		
2475	236	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	15882	0	6106-9	3014599		
20679	1898	3006322	2001-09-06	2001-09-06 00:00:00	2001-09-06	5001	0	\N	0	0	\N	\N	0	126385	0	8331-1	3006322		
155755	4782	4052083	1995-06-12	1995-06-12 00:00:00	1995-06-12	5001	0	\N	0	0	\N	\N	0	318316	0	23426006	4052083		
13956	1310	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	86613	0	6106-9	3014599		
25313	2327	3006322	1960-06-06	1960-06-06 00:00:00	1960-06-06	5001	0	\N	0	0	\N	\N	0	154744	0	8331-1	3006322		
142303	4376	4133840	1985-08-06	1985-08-06 00:00:00	1985-08-06	5001	0	\N	0	0	\N	\N	0	290835	0	127783003	4133840		
26405	2431	3006322	1996-02-20	1996-02-20 00:00:00	1996-02-20	5001	0	\N	0	0	\N	\N	0	161190	0	8331-1	3006322		
20234	1852	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	123986	0	6276-0	3027231		
144178	4432	4052083	1970-03-11	1970-03-11 00:00:00	1970-03-11	5001	0	\N	0	0	\N	\N	0	294587	0	23426006	4052083		
31705	2898	3000876	1980-03-29	1980-03-29 00:00:00	1980-03-29	5001	0	\N	0	0	\N	\N	0	193004	0	6082-2	3000876		
7430	711	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	47111	0	6095-4	3036780		
27201	2522	40758406	1995-09-30	1995-09-30 00:00:00	1995-09-30	5001	0	\N	0	0	\N	\N	0	166794	0	55277-8	40758406		
38579	3568	40766240	1971-02-23	1971-02-23 00:00:00	1971-02-23	5001	0	\N	0	0	\N	\N	0	237103	0	63513-6	40766240		
38634	3571	3023430	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	237417	0	6833-8	3023430		
50010	4548	3019406	1996-10-22	1996-10-22 00:00:00	1996-10-22	5001	0	\N	0	0	\N	\N	0	303083	0	6158-0	3019406		
44667	4121	3011505	1975-08-31	1975-08-31 00:00:00	1975-08-31	5001	0	\N	0	0	\N	\N	0	273990	0	19926-5	3011505		
56036	5144	3006322	2019-03-14	2019-03-14 00:00:00	2019-03-14	5001	0	\N	0	0	\N	\N	0	341930	0	8331-1	3006322		
156407	4805	4052083	2003-08-28	2003-08-28 00:00:00	2003-08-28	5001	0	\N	0	0	\N	\N	0	319735	0	23426006	4052083		
53189	4890	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	325188	0	7258-7	3001488		
12643	1211	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	79579	0	6095-4	3036780		
24010	2211	3006322	1981-05-30	1981-05-30 00:00:00	1981-05-30	5001	0	\N	0	0	\N	\N	0	147321	0	8331-1	3006322		
42241	3906	3049273	2011-04-02	2011-04-02 00:00:00	2011-04-02	5001	0	\N	0	0	\N	\N	0	259730	0	38265-5	3049273		
24511	2261	3051031	1966-06-27	1966-06-27 00:00:00	1966-06-27	5001	0	\N	0	0	\N	\N	0	150298	0	46240-8	3051031		
35930	3300	3009542	2016-07-27	2016-07-27 00:00:00	2016-07-27	5001	0	\N	0	0	\N	\N	0	219248	0	20570-8	3009542		
36211	3334	3006322	1981-07-01	1981-07-01 00:00:00	1981-07-01	5001	0	\N	0	0	\N	\N	0	221163	0	8331-1	3006322		
47007	4324	3027231	1981-06-30	1981-06-30 00:00:00	1981-06-30	5001	0	\N	0	0	\N	\N	0	286849	0	6276-0	3027231		
9344	884	3001247	1978-11-13	1978-11-13 00:00:00	1978-11-13	5001	0	\N	0	0	\N	\N	0	58857	0	6085-5	3001247		
19946	1829	3006322	2001-12-05	2001-12-05 00:00:00	2001-12-05	5001	0	\N	0	0	\N	\N	0	122280	0	8331-1	3006322		
47754	4376	3011505	1975-07-01	1975-07-01 00:00:00	1975-07-01	5001	0	\N	0	0	\N	\N	0	290816	0	19926-5	3011505		
94668	2909	4052083	1990-07-15	1990-07-15 00:00:00	1990-07-15	5001	0	\N	0	0	\N	\N	0	193845	0	23426006	4052083		
24907	776	4133840	2014-09-04	2014-09-04 00:00:00	2014-09-04	5001	0	\N	0	0	\N	\N	0	51594	0	127783003	4133840		
32350	2939	3006322	1977-03-27	1977-03-27 00:00:00	1977-03-27	5001	0	\N	0	0	\N	\N	0	195949	0	8331-1	3006322		
26634	834	4052083	1977-09-18	1977-09-18 00:00:00	1977-09-18	5001	0	\N	0	0	\N	\N	0	55209	0	23426006	4052083		
70094	2150	4024958	1980-10-04	1980-10-04 00:00:00	1980-10-04	5001	0	\N	0	0	\N	\N	0	143190	0	117015009	4024958		
6455	606	3006322	1992-03-28	1992-03-28 00:00:00	1992-03-28	5001	0	\N	0	0	\N	\N	0	40261	0	8331-1	3006322		
6510	610	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	40494	0	6095-4	3036780		
21497	1980	3000876	1975-10-10	1975-10-10 00:00:00	1975-10-10	5001	0	\N	0	0	\N	\N	0	131877	0	6082-2	3000876		
21596	1992	3006734	1978-04-17	1978-04-17 00:00:00	1978-04-17	5001	0	\N	0	0	\N	\N	0	132718	0	6189-5	3006734		
32728	2965	3006322	1985-10-15	1985-10-15 00:00:00	1985-10-15	5001	0	\N	0	0	\N	\N	0	197910	0	8331-1	3006322		
17326	545	4024958	1974-08-27	1974-08-27 00:00:00	1974-08-27	5001	0	\N	0	0	\N	\N	0	36133	0	117015009	4024958		
29462	2711	3000876	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	179639	0	6082-2	3000876		
55496	5097	3001488	1996-01-21	1996-01-21 00:00:00	1996-01-21	5001	0	\N	0	0	\N	\N	0	338744	0	7258-7	3001488		
40936	3793	40758406	1941-05-26	1941-05-26 00:00:00	1941-05-26	5001	0	\N	0	0	\N	\N	0	252181	0	55277-8	40758406		
18520	1702	3006322	1978-05-03	1978-05-03 00:00:00	1978-05-03	5001	0	\N	0	0	\N	\N	0	113807	0	8331-1	3006322		
20512	644	4024958	2017-05-30	2017-05-30 00:00:00	2017-05-30	5001	0	\N	0	0	\N	\N	0	42647	0	117015009	4024958		
52439	4822	40758406	1954-11-16	1954-11-16 00:00:00	1954-11-16	5001	0	\N	0	0	\N	\N	0	320731	0	55277-8	40758406		
22179	2033	3051031	1961-10-16	1961-10-16 00:00:00	1961-10-16	5001	0	\N	0	0	\N	\N	0	135373	0	46240-8	3051031		
53432	4907	3049273	2016-05-14	2016-05-14 00:00:00	2016-05-14	5001	0	\N	0	0	\N	\N	0	326156	0	38265-5	3049273		
102529	3150	4024958	1980-06-18	1980-06-18 00:00:00	1980-06-18	5001	0	\N	0	0	\N	\N	0	209594	0	117015009	4024958		
41521	3866	3008598	2017-09-24	2017-09-24 00:00:00	2017-09-24	5001	0	\N	0	0	\N	\N	0	256725	0	3024-7	3008598		
32363	1004	4052083	1970-12-30	1970-12-30 00:00:00	1970-12-30	5001	0	\N	0	0	\N	\N	0	66358	0	23426006	4052083		
52246	4804	3005136	1990-03-26	1990-03-26 00:00:00	1990-03-26	5001	0	\N	0	0	\N	\N	0	319661	0	6075-6	3005136		
3313	320	3011505	2006-02-19	2006-02-19 00:00:00	2006-02-19	5001	0	\N	0	0	\N	\N	0	21183	0	19926-5	3011505		
27829	2561	3006322	2007-12-15	2007-12-15 00:00:00	2007-12-15	5001	0	\N	0	0	\N	\N	0	169725	0	8331-1	3006322		
55288	1677	4024958	1991-12-09	1991-12-09 00:00:00	1991-12-09	5001	0	\N	0	0	\N	\N	0	112513	0	117015009	4024958		
39340	3636	3006322	2010-04-02	2010-04-02 00:00:00	2010-04-02	5001	0	\N	0	0	\N	\N	0	241784	0	8331-1	3006322		
22844	2088	3011505	2011-03-01	2011-03-01 00:00:00	2011-03-01	5001	0	\N	0	0	\N	\N	0	139243	0	19926-5	3011505		
5697	533	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	35428	0	6106-9	3014599		
17069	1556	3006322	1978-09-03	1978-09-03 00:00:00	1978-09-03	5001	0	\N	0	0	\N	\N	0	104272	0	8331-1	3006322		
17142	1560	3006322	1944-03-18	1944-03-18 00:00:00	1944-03-18	5001	0	\N	0	0	\N	\N	0	104500	0	8331-1	3006322		
42498	3926	3011505	2010-03-01	2010-03-01 00:00:00	2010-03-01	5001	0	\N	0	0	\N	\N	0	260955	0	19926-5	3011505		
379	16	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	1173	0	6158-0	3019406		
27490	2543	46235214	1977-07-12	1977-07-12 00:00:00	1977-07-12	5001	0	\N	0	0	\N	\N	0	168279	0	76690-7	46235214		
2396	225	3015076	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	15183	0	6248-9	3015076		
2476	236	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	15882	0	6273-7	3006451		
20680	1898	3006322	1987-02-06	1987-02-06 00:00:00	1987-02-06	5001	0	\N	0	0	\N	\N	0	126384	0	8331-1	3006322		
155761	4782	4024958	2005-03-01	2005-03-01 00:00:00	2005-03-01	5001	0	\N	0	0	\N	\N	0	318359	0	117015009	4024958		
13957	1310	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	86613	0	6085-5	3001247		
25314	2327	3006322	1976-07-20	1976-07-20 00:00:00	1976-07-20	5001	0	\N	0	0	\N	\N	0	154777	0	8331-1	3006322		
153583	4713	4052083	2000-02-12	2000-02-12 00:00:00	2000-02-12	5001	0	\N	0	0	\N	\N	0	313850	0	23426006	4052083		
26406	2431	3006322	1972-07-19	1972-07-19 00:00:00	1972-07-19	5001	0	\N	0	0	\N	\N	0	161201	0	8331-1	3006322		
20235	1852	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	123986	0	6833-8	3023430		
144183	4432	4052083	1994-08-09	1994-08-09 00:00:00	1994-08-09	5001	0	\N	0	0	\N	\N	0	294616	0	23426006	4052083		
31706	2898	3020655	1980-03-29	1980-03-29 00:00:00	1980-03-29	5001	0	\N	0	0	\N	\N	0	193004	0	6844-5	3020655		
7431	711	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	47111	0	6206-7	3012494		
27202	2522	46235214	1995-09-30	1995-09-30 00:00:00	1995-09-30	5001	0	\N	0	0	\N	\N	0	166794	0	76690-7	46235214		
38580	3568	40758406	1971-02-23	1971-02-23 00:00:00	1971-02-23	5001	0	\N	0	0	\N	\N	0	237103	0	55277-8	40758406		
38635	3571	3020655	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	237417	0	6844-5	3020655		
50011	4548	3005136	1996-10-22	1996-10-22 00:00:00	1996-10-22	5001	0	\N	0	0	\N	\N	0	303083	0	6075-6	3005136		
44668	4122	3006322	1975-01-18	1975-01-18 00:00:00	1975-01-18	5001	0	\N	0	0	\N	\N	0	274068	0	8331-1	3006322		
56037	5144	3006322	2013-04-03	2013-04-03 00:00:00	2013-04-03	5001	0	\N	0	0	\N	\N	0	341900	0	8331-1	3006322		
156413	4805	4052083	1999-08-12	1999-08-12 00:00:00	1999-08-12	5001	0	\N	0	0	\N	\N	0	319681	0	23426006	4052083		
53190	4890	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	325188	0	6206-7	3012494		
12644	1211	3006322	1966-09-11	1966-09-11 00:00:00	1966-09-11	5001	0	\N	0	0	\N	\N	0	79535	0	8331-1	3006322		
24011	2211	3006322	1992-04-09	1992-04-09 00:00:00	1992-04-09	5001	0	\N	0	0	\N	\N	0	147336	0	8331-1	3006322		
42242	3906	3006322	1980-01-29	1980-01-29 00:00:00	1980-01-29	5001	0	\N	0	0	\N	\N	0	259744	0	8331-1	3006322		
24512	2261	40766240	1966-06-27	1966-06-27 00:00:00	1966-06-27	5001	0	\N	0	0	\N	\N	0	150298	0	63513-6	40766240		
35931	3300	3006322	1982-10-05	1982-10-05 00:00:00	1982-10-05	5001	0	\N	0	0	\N	\N	0	219235	0	8331-1	3006322		
36212	3334	3006322	2019-04-27	2019-04-27 00:00:00	2019-04-27	5001	0	\N	0	0	\N	\N	0	221179	0	8331-1	3006322		
47008	4324	3015076	1981-06-30	1981-06-30 00:00:00	1981-06-30	5001	0	\N	0	0	\N	\N	0	286849	0	6248-9	3015076		
9345	884	3019406	1978-11-13	1978-11-13 00:00:00	1978-11-13	5001	0	\N	0	0	\N	\N	0	58857	0	6158-0	3019406		
38186	3526	3006322	2013-06-01	2013-06-01 00:00:00	2013-06-01	5001	0	\N	0	0	\N	\N	0	233946	0	8331-1	3006322		
47755	4376	3011505	1997-10-14	1997-10-14 00:00:00	1997-10-14	5001	0	\N	0	0	\N	\N	0	290808	0	19926-5	3011505		
94669	2909	4133840	1981-04-05	1981-04-05 00:00:00	1981-04-05	5001	0	\N	0	0	\N	\N	0	193918	0	127783003	4133840		
24911	776	4133840	2018-09-27	2018-09-27 00:00:00	2018-09-27	5001	0	\N	0	0	\N	\N	0	51596	0	127783003	4133840		
32351	2939	3006322	2010-01-22	2010-01-22 00:00:00	2010-01-22	5001	0	\N	0	0	\N	\N	0	196000	0	8331-1	3006322		
26648	834	4024958	1968-06-07	1968-06-07 00:00:00	1968-06-07	5001	0	\N	0	0	\N	\N	0	55207	0	117015009	4024958		
70096	2150	4024958	2017-08-30	2017-08-30 00:00:00	2017-08-30	5001	0	\N	0	0	\N	\N	0	143179	0	117015009	4024958		
6456	606	3006322	2008-04-12	2008-04-12 00:00:00	2008-04-12	5001	0	\N	0	0	\N	\N	0	40217	0	8331-1	3006322		
6511	610	3006322	1991-10-14	1991-10-14 00:00:00	1991-10-14	5001	0	\N	0	0	\N	\N	0	40536	0	8331-1	3006322		
21498	1980	3036780	1975-10-10	1975-10-10 00:00:00	1975-10-10	5001	0	\N	0	0	\N	\N	0	131877	0	6095-4	3036780		
21597	1992	3001488	1978-04-17	1978-04-17 00:00:00	1978-04-17	5001	0	\N	0	0	\N	\N	0	132718	0	7258-7	3001488		
32729	2966	3023430	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	198088	0	6833-8	3023430		
31686	973	4024958	1951-01-20	1951-01-20 00:00:00	1951-01-20	5001	0	\N	0	0	\N	\N	0	64810	0	117015009	4024958		
29463	2711	3006451	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	179639	0	6273-7	3006451		
55497	5097	3006734	1996-01-21	1996-01-21 00:00:00	1996-01-21	5001	0	\N	0	0	\N	\N	0	338744	0	6189-5	3006734		
40938	3793	3051031	1941-07-25	1941-07-25 00:00:00	1941-07-25	5001	0	\N	0	0	\N	\N	0	252228	0	46240-8	3051031		
18521	1702	3006322	1967-10-03	1967-10-03 00:00:00	1967-10-03	5001	0	\N	0	0	\N	\N	0	113799	0	8331-1	3006322		
7695	245	4052083	1991-04-10	1991-04-10 00:00:00	1991-04-10	5001	0	\N	0	0	\N	\N	0	16480	0	23426006	4052083		
52440	4822	3051031	1954-11-16	1954-11-16 00:00:00	1954-11-16	5001	0	\N	0	0	\N	\N	0	320731	0	46240-8	3051031		
22181	2033	40766240	1961-10-16	1961-10-16 00:00:00	1961-10-16	5001	0	\N	0	0	\N	\N	0	135373	0	63513-6	40766240		
53433	4907	3006322	1992-09-14	1992-09-14 00:00:00	1992-09-14	5001	0	\N	0	0	\N	\N	0	326100	0	8331-1	3006322		
102542	3150	4024958	1946-04-23	1946-04-23 00:00:00	1946-04-23	5001	0	\N	0	0	\N	\N	0	209612	0	117015009	4024958		
41522	3866	3009201	2017-09-24	2017-09-24 00:00:00	2017-09-24	5001	0	\N	0	0	\N	\N	0	256725	0	3016-3	3009201		
32386	1005	4052083	2008-10-15	2008-10-15 00:00:00	2008-10-15	5001	0	\N	0	0	\N	\N	0	66440	0	23426006	4052083		
52247	4804	46235214	1983-08-17	1983-08-17 00:00:00	1983-08-17	5001	0	\N	0	0	\N	\N	0	319660	0	76690-7	46235214		
3314	320	3011505	2014-03-02	2014-03-02 00:00:00	2014-03-02	5001	0	\N	0	0	\N	\N	0	21252	0	19926-5	3011505		
27830	2561	3006322	2018-03-06	2018-03-06 00:00:00	2018-03-06	5001	0	\N	0	0	\N	\N	0	169674	0	8331-1	3006322		
55307	1679	4024958	2000-03-06	2000-03-06 00:00:00	2000-03-06	5001	0	\N	0	0	\N	\N	0	112560	0	117015009	4024958		
9489	300	4052083	1973-02-19	1973-02-19 00:00:00	1973-02-19	5001	0	\N	0	0	\N	\N	0	20070	0	23426006	4052083		
22845	2088	3011505	2010-02-23	2010-02-23 00:00:00	2010-02-23	5001	0	\N	0	0	\N	\N	0	139283	0	19926-5	3011505		
5698	533	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	35428	0	6833-8	3023430		
17070	1556	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	104188	0	6082-2	3000876		
17143	1560	3006322	2017-01-27	2017-01-27 00:00:00	2017-01-27	5001	0	\N	0	0	\N	\N	0	104452	0	8331-1	3006322		
42499	3926	3011505	1996-10-21	1996-10-21 00:00:00	1996-10-21	5001	0	\N	0	0	\N	\N	0	260916	0	19926-5	3011505		
380	16	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	1173	0	6246-3	3021226		
27492	2543	3051031	1977-07-12	1977-07-12 00:00:00	1977-07-12	5001	0	\N	0	0	\N	\N	0	168279	0	46240-8	3051031		
2397	225	3027231	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	15183	0	6276-0	3027231		
2477	236	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	15882	0	6276-0	3027231		
20681	1898	3006322	2005-09-26	2005-09-26 00:00:00	2005-09-26	5001	0	\N	0	0	\N	\N	0	126386	0	8331-1	3006322		
155781	4782	4024958	2006-03-11	2006-03-11 00:00:00	2006-03-11	5001	0	\N	0	0	\N	\N	0	318367	0	117015009	4024958		
13958	1310	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	86613	0	7258-7	3001488		
25315	2327	3006322	1983-05-06	1983-05-06 00:00:00	1983-05-06	5001	0	\N	0	0	\N	\N	0	154778	0	8331-1	3006322		
153584	4713	4024958	1973-08-14	1973-08-14 00:00:00	1973-08-14	5001	0	\N	0	0	\N	\N	0	313835	0	117015009	4024958		
26407	2431	3006322	1999-01-18	1999-01-18 00:00:00	1999-01-18	5001	0	\N	0	0	\N	\N	0	161215	0	8331-1	3006322		
20236	1852	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	123986	0	6844-5	3020655		
144188	4432	4024958	1959-10-01	1959-10-01 00:00:00	1959-10-01	5001	0	\N	0	0	\N	\N	0	294611	0	117015009	4024958		
31707	2898	3023430	1980-03-29	1980-03-29 00:00:00	1980-03-29	5001	0	\N	0	0	\N	\N	0	193004	0	6833-8	3023430		
7432	711	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	47111	0	6082-2	3000876		
27203	2522	3006322	1997-04-26	1997-04-26 00:00:00	1997-04-26	5001	0	\N	0	0	\N	\N	0	166820	0	8331-1	3006322		
38581	3568	3051031	1971-02-23	1971-02-23 00:00:00	1971-02-23	5001	0	\N	0	0	\N	\N	0	237103	0	46240-8	3051031		
38636	3571	3001488	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	237417	0	7258-7	3001488		
50012	4548	3027231	1996-10-22	1996-10-22 00:00:00	1996-10-22	5001	0	\N	0	0	\N	\N	0	303083	0	6276-0	3027231		
44669	4122	3006322	2013-06-23	2013-06-23 00:00:00	2013-06-23	5001	0	\N	0	0	\N	\N	0	274042	0	8331-1	3006322		
56040	5145	3006322	1996-06-20	1996-06-20 00:00:00	1996-06-20	5001	0	\N	0	0	\N	\N	0	342041	0	8331-1	3006322		
156435	4807	4024958	1987-03-29	1987-03-29 00:00:00	1987-03-29	5001	0	\N	0	0	\N	\N	0	319857	0	117015009	4024958		
53191	4890	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	325188	0	6085-5	3001247		
12645	1211	3006322	2007-03-31	2007-03-31 00:00:00	2007-03-31	5001	0	\N	0	0	\N	\N	0	79545	0	8331-1	3006322		
24012	2213	3006322	1997-09-14	1997-09-14 00:00:00	1997-09-14	5001	0	\N	0	0	\N	\N	0	147362	0	8331-1	3006322		
42243	3906	3006322	1944-01-16	1944-01-16 00:00:00	1944-01-16	5001	0	\N	0	0	\N	\N	0	259669	0	8331-1	3006322		
24513	2261	40758406	1966-06-27	1966-06-27 00:00:00	1966-06-27	5001	0	\N	0	0	\N	\N	0	150298	0	55277-8	40758406		
35932	3300	3006322	2003-07-27	2003-07-27 00:00:00	2003-07-27	5001	0	\N	0	0	\N	\N	0	219246	0	8331-1	3006322		
36213	3334	3006322	1981-12-12	1981-12-12 00:00:00	1981-12-12	5001	0	\N	0	0	\N	\N	0	221164	0	8331-1	3006322		
47009	4324	3014599	1981-06-30	1981-06-30 00:00:00	1981-06-30	5001	0	\N	0	0	\N	\N	0	286849	0	6106-9	3014599		
9346	884	3015076	1978-11-13	1978-11-13 00:00:00	1978-11-13	5001	0	\N	0	0	\N	\N	0	58857	0	6248-9	3015076		
38187	3526	3006322	2009-04-12	2009-04-12 00:00:00	2009-04-12	5001	0	\N	0	0	\N	\N	0	233995	0	8331-1	3006322		
47756	4376	3011505	1991-09-10	1991-09-10 00:00:00	1991-09-10	5001	0	\N	0	0	\N	\N	0	290805	0	19926-5	3011505		
94673	2909	4133840	1998-05-24	1998-05-24 00:00:00	1998-05-24	5001	0	\N	0	0	\N	\N	0	193853	0	127783003	4133840		
24913	776	4133840	2015-09-10	2015-09-10 00:00:00	2015-09-10	5001	0	\N	0	0	\N	\N	0	51512	0	127783003	4133840		
32352	2939	3006322	1977-08-06	1977-08-06 00:00:00	1977-08-06	5001	0	\N	0	0	\N	\N	0	195950	0	8331-1	3006322		
37957	1176	4024958	1988-01-24	1988-01-24 00:00:00	1988-01-24	5001	0	\N	0	0	\N	\N	0	77601	0	117015009	4024958		
70106	2150	4052083	1989-06-30	1989-06-30 00:00:00	1989-06-30	5001	0	\N	0	0	\N	\N	0	143191	0	23426006	4052083		
6457	606	3006322	1975-12-11	1975-12-11 00:00:00	1975-12-11	5001	0	\N	0	0	\N	\N	0	40200	0	8331-1	3006322		
6514	613	3006322	1949-08-07	1949-08-07 00:00:00	1949-08-07	5001	0	\N	0	0	\N	\N	0	40758	0	8331-1	3006322		
21499	1980	3021226	1975-10-10	1975-10-10 00:00:00	1975-10-10	5001	0	\N	0	0	\N	\N	0	131877	0	6246-3	3021226		
21598	1992	3020655	1978-04-17	1978-04-17 00:00:00	1978-04-17	5001	0	\N	0	0	\N	\N	0	132718	0	6844-5	3020655		
32730	2966	3021226	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	198088	0	6246-3	3021226		
31703	973	4024958	1945-04-07	1945-04-07 00:00:00	1945-04-07	5001	0	\N	0	0	\N	\N	0	64809	0	117015009	4024958		
29464	2711	3027231	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	179639	0	6276-0	3027231		
55498	5097	3023430	1996-01-21	1996-01-21 00:00:00	1996-01-21	5001	0	\N	0	0	\N	\N	0	338744	0	6833-8	3023430		
40939	3793	46235214	1941-07-25	1941-07-25 00:00:00	1941-07-25	5001	0	\N	0	0	\N	\N	0	252228	0	76690-7	46235214		
18522	1702	3006322	2015-04-04	2015-04-04 00:00:00	2015-04-04	5001	0	\N	0	0	\N	\N	0	113809	0	8331-1	3006322		
18980	600	4024958	1967-06-30	1967-06-30 00:00:00	1967-06-30	5001	0	\N	0	0	\N	\N	0	39569	0	117015009	4024958		
52441	4822	40758406	1970-12-07	1970-12-07 00:00:00	1970-12-07	5001	0	\N	0	0	\N	\N	0	320782	0	55277-8	40758406		
22183	2033	40758406	1961-10-16	1961-10-16 00:00:00	1961-10-16	5001	0	\N	0	0	\N	\N	0	135373	0	55277-8	40758406		
53434	4907	3006322	1974-01-03	1974-01-03 00:00:00	1974-01-03	5001	0	\N	0	0	\N	\N	0	326157	0	8331-1	3006322		
113870	3513	4052083	1974-04-10	1974-04-10 00:00:00	1974-04-10	5001	0	\N	0	0	\N	\N	0	233124	0	23426006	4052083		
41525	3869	3049273	1980-12-03	1980-12-03 00:00:00	1980-12-03	5001	0	\N	0	0	\N	\N	0	256844	0	38265-5	3049273		
158757	4881	4024958	2018-03-14	2018-03-14 00:00:00	2018-03-14	5001	0	\N	0	0	\N	\N	0	324539	0	117015009	4024958		
52248	4804	40758406	1983-08-17	1983-08-17 00:00:00	1983-08-17	5001	0	\N	0	0	\N	\N	0	319660	0	55277-8	40758406		
3315	320	3011505	2018-03-25	2018-03-25 00:00:00	2018-03-25	5001	0	\N	0	0	\N	\N	0	21254	0	19926-5	3011505		
27831	2563	3006322	1972-10-11	1972-10-11 00:00:00	1972-10-11	5001	0	\N	0	0	\N	\N	0	169795	0	8331-1	3006322		
27901	2566	40766240	2015-11-04	2015-11-04 00:00:00	2015-11-04	5001	0	\N	0	0	\N	\N	0	169943	0	63513-6	40766240		
9491	300	4052083	2007-08-21	2007-08-21 00:00:00	2007-08-21	5001	0	\N	0	0	\N	\N	0	20076	0	23426006	4052083		
22846	2088	3011505	2001-06-12	2001-06-12 00:00:00	2001-06-12	5001	0	\N	0	0	\N	\N	0	139288	0	19926-5	3011505		
5699	533	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	35428	0	6844-5	3020655		
17071	1556	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	104188	0	6844-5	3020655		
17144	1560	3049273	2017-01-29	2017-01-29 00:00:00	2017-01-29	5001	0	\N	0	0	\N	\N	0	104435	0	38265-5	3049273		
42500	3926	3011505	2012-06-25	2012-06-25 00:00:00	2012-06-25	5001	0	\N	0	0	\N	\N	0	260920	0	19926-5	3011505		
381	16	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	1173	0	6273-7	3006451		
27493	2543	40758406	1977-07-12	1977-07-12 00:00:00	1977-07-12	5001	0	\N	0	0	\N	\N	0	168279	0	55277-8	40758406		
2398	225	3006451	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	15183	0	6273-7	3006451		
2478	236	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	15882	0	6095-4	3036780		
20682	1898	40758406	1972-02-05	1972-02-05 00:00:00	1972-02-05	5001	0	\N	0	0	\N	\N	0	126394	0	55277-8	40758406		
130766	4027	4024958	2017-06-19	2017-06-19 00:00:00	2017-06-19	5001	0	\N	0	0	\N	\N	0	267827	0	117015009	4024958		
13959	1310	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	86613	0	6189-5	3006734		
25316	2327	3006322	1993-12-18	1993-12-18 00:00:00	1993-12-18	5001	0	\N	0	0	\N	\N	0	154754	0	8331-1	3006322		
153596	4715	4024958	1962-07-09	1962-07-09 00:00:00	1962-07-09	5001	0	\N	0	0	\N	\N	0	313925	0	117015009	4024958		
26411	2433	3006322	2004-05-25	2004-05-25 00:00:00	2004-05-25	5001	0	\N	0	0	\N	\N	0	161328	0	8331-1	3006322		
20237	1852	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	123986	0	6095-4	3036780		
144190	4432	4052083	1966-01-11	1966-01-11 00:00:00	1966-01-11	5001	0	\N	0	0	\N	\N	0	294612	0	23426006	4052083		
31708	2898	3019406	1980-03-29	1980-03-29 00:00:00	1980-03-29	5001	0	\N	0	0	\N	\N	0	193004	0	6158-0	3019406		
7433	711	3006322	2012-10-07	2012-10-07 00:00:00	2012-10-07	5001	0	\N	0	0	\N	\N	0	47203	0	8331-1	3006322		
27204	2522	3006322	1979-11-01	1979-11-01 00:00:00	1979-11-01	5001	0	\N	0	0	\N	\N	0	166793	0	8331-1	3006322		
38583	3568	46235214	1971-02-23	1971-02-23 00:00:00	1971-02-23	5001	0	\N	0	0	\N	\N	0	237103	0	76690-7	46235214		
38637	3571	3001247	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	237417	0	6085-5	3001247		
50013	4548	3012494	1996-10-22	1996-10-22 00:00:00	1996-10-22	5001	0	\N	0	0	\N	\N	0	303083	0	6206-7	3012494		
44670	4122	3006322	1988-04-26	1988-04-26 00:00:00	1988-04-26	5001	0	\N	0	0	\N	\N	0	274032	0	8331-1	3006322		
56041	5145	3006322	1981-02-21	1981-02-21 00:00:00	1981-02-21	5001	0	\N	0	0	\N	\N	0	342004	0	8331-1	3006322		
156443	4807	4024958	1948-04-16	1948-04-16 00:00:00	1948-04-16	5001	0	\N	0	0	\N	\N	0	319802	0	117015009	4024958		
53192	4890	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	325188	0	6833-8	3023430		
12646	1211	3006322	1978-01-22	1978-01-22 00:00:00	1978-01-22	5001	0	\N	0	0	\N	\N	0	79539	0	8331-1	3006322		
24013	2213	3006322	1987-03-19	1987-03-19 00:00:00	1987-03-19	5001	0	\N	0	0	\N	\N	0	147377	0	8331-1	3006322		
42244	3906	3006322	1993-12-13	1993-12-13 00:00:00	1993-12-13	5001	0	\N	0	0	\N	\N	0	259732	0	8331-1	3006322		
24514	2261	46235214	1966-06-27	1966-06-27 00:00:00	1966-06-27	5001	0	\N	0	0	\N	\N	0	150298	0	76690-7	46235214		
35933	3300	3006322	1997-02-02	1997-02-02 00:00:00	1997-02-02	5001	0	\N	0	0	\N	\N	0	219193	0	8331-1	3006322		
36214	3335	3006322	2008-08-30	2008-08-30 00:00:00	2008-08-30	5001	0	\N	0	0	\N	\N	0	221264	0	8331-1	3006322		
47010	4324	3001488	1981-06-30	1981-06-30 00:00:00	1981-06-30	5001	0	\N	0	0	\N	\N	0	286849	0	7258-7	3001488		
9347	884	3036780	1978-11-13	1978-11-13 00:00:00	1978-11-13	5001	0	\N	0	0	\N	\N	0	58857	0	6095-4	3036780		
38188	3526	3006322	1951-10-20	1951-10-20 00:00:00	1951-10-20	5001	0	\N	0	0	\N	\N	0	233948	0	8331-1	3006322		
47757	4376	3011505	2007-12-11	2007-12-11 00:00:00	2007-12-11	5001	0	\N	0	0	\N	\N	0	290820	0	19926-5	3011505		
94675	2909	4133840	1995-05-07	1995-05-07 00:00:00	1995-05-07	5001	0	\N	0	0	\N	\N	0	193926	0	127783003	4133840		
24914	776	4133840	2012-08-23	2012-08-23 00:00:00	2012-08-23	5001	0	\N	0	0	\N	\N	0	51557	0	127783003	4133840		
32353	2939	3006322	2013-09-17	2013-09-17 00:00:00	2013-09-17	5001	0	\N	0	0	\N	\N	0	196002	0	8331-1	3006322		
37969	1176	4052083	2002-02-24	2002-02-24 00:00:00	2002-02-24	5001	0	\N	0	0	\N	\N	0	77636	0	23426006	4052083		
70112	2150	4052083	1968-02-25	1968-02-25 00:00:00	1968-02-25	5001	0	\N	0	0	\N	\N	0	143167	0	23426006	4052083		
6458	607	3006322	1956-03-22	1956-03-22 00:00:00	1956-03-22	5001	0	\N	0	0	\N	\N	0	40317	0	8331-1	3006322		
6515	613	3049273	2016-05-27	2016-05-27 00:00:00	2016-05-27	5001	0	\N	0	0	\N	\N	0	40683	0	38265-5	3049273		
21500	1980	3019406	1975-10-10	1975-10-10 00:00:00	1975-10-10	5001	0	\N	0	0	\N	\N	0	131877	0	6158-0	3019406		
21599	1992	3023430	1978-04-17	1978-04-17 00:00:00	1978-04-17	5001	0	\N	0	0	\N	\N	0	132718	0	6833-8	3023430		
32731	2966	3020655	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	198088	0	6844-5	3020655		
31704	973	4052083	1953-09-02	1953-09-02 00:00:00	1953-09-02	5001	0	\N	0	0	\N	\N	0	64872	0	23426006	4052083		
29465	2711	3015076	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	179639	0	6248-9	3015076		
55499	5097	3005136	1996-01-21	1996-01-21 00:00:00	1996-01-21	5001	0	\N	0	0	\N	\N	0	338744	0	6075-6	3005136		
40940	3793	40766240	1941-07-25	1941-07-25 00:00:00	1941-07-25	5001	0	\N	0	0	\N	\N	0	252228	0	63513-6	40766240		
18523	1702	3006322	1970-08-05	1970-08-05 00:00:00	1970-08-05	5001	0	\N	0	0	\N	\N	0	113775	0	8331-1	3006322		
18981	600	4024958	1980-09-17	1980-09-17 00:00:00	1980-09-17	5001	0	\N	0	0	\N	\N	0	39639	0	117015009	4024958		
52442	4822	3051031	1970-12-07	1970-12-07 00:00:00	1970-12-07	5001	0	\N	0	0	\N	\N	0	320782	0	46240-8	3051031		
22184	2033	46235214	1961-10-16	1961-10-16 00:00:00	1961-10-16	5001	0	\N	0	0	\N	\N	0	135373	0	76690-7	46235214		
53436	4909	3006322	2014-12-05	2014-12-05 00:00:00	2014-12-05	5001	0	\N	0	0	\N	\N	0	326274	0	8331-1	3006322		
30565	949	4133840	1998-03-30	1998-03-30 00:00:00	1998-03-30	5001	0	\N	0	0	\N	\N	0	63015	0	127783003	4133840		
41528	3869	3049273	1961-07-16	1961-07-16 00:00:00	1961-07-16	5001	0	\N	0	0	\N	\N	0	256843	0	38265-5	3049273		
158758	4881	4024958	1957-02-27	1957-02-27 00:00:00	1957-02-27	5001	0	\N	0	0	\N	\N	0	324524	0	117015009	4024958		
52250	4804	40766240	1983-08-17	1983-08-17 00:00:00	1983-08-17	5001	0	\N	0	0	\N	\N	0	319660	0	63513-6	40766240		
3316	320	3011505	2016-03-13	2016-03-13 00:00:00	2016-03-13	5001	0	\N	0	0	\N	\N	0	21253	0	19926-5	3011505		
27832	2563	3006322	1988-01-04	1988-01-04 00:00:00	1988-01-04	5001	0	\N	0	0	\N	\N	0	169761	0	8331-1	3006322		
27903	2566	40766240	2018-01-22	2018-01-22 00:00:00	2018-01-22	5001	0	\N	0	0	\N	\N	0	170042	0	63513-6	40766240		
9550	304	4052083	2003-09-03	2003-09-03 00:00:00	2003-09-03	5001	0	\N	0	0	\N	\N	0	20252	0	23426006	4052083		
22847	2088	3011505	1973-07-31	1973-07-31 00:00:00	1973-07-31	5001	0	\N	0	0	\N	\N	0	139211	0	19926-5	3011505		
5700	533	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	35428	0	6085-5	3001247		
17072	1556	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	104188	0	7258-7	3001488		
17162	1563	3006322	1958-06-17	1958-06-17 00:00:00	1958-06-17	5001	0	\N	0	0	\N	\N	0	104664	0	8331-1	3006322		
42501	3926	3006322	1986-05-15	1986-05-15 00:00:00	1986-05-15	5001	0	\N	0	0	\N	\N	0	260979	0	8331-1	3006322		
382	16	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	1173	0	6206-7	3012494		
27494	2543	3006322	2011-06-02	2011-06-02 00:00:00	2011-06-02	5001	0	\N	0	0	\N	\N	0	168233	0	8331-1	3006322		
2399	225	3021226	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	15183	0	6246-3	3021226		
2479	236	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	15882	0	6158-0	3019406		
20683	1898	40766240	1972-02-05	1972-02-05 00:00:00	1972-02-05	5001	0	\N	0	0	\N	\N	0	126394	0	63513-6	40766240		
130775	4027	4024958	1989-02-26	1989-02-26 00:00:00	1989-02-26	5001	0	\N	0	0	\N	\N	0	267834	0	117015009	4024958		
13960	1310	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	86613	0	6844-5	3020655		
25317	2327	3006322	1974-04-18	1974-04-18 00:00:00	1974-04-18	5001	0	\N	0	0	\N	\N	0	154745	0	8331-1	3006322		
153602	4715	4052083	2004-09-27	2004-09-27 00:00:00	2004-09-27	5001	0	\N	0	0	\N	\N	0	313898	0	23426006	4052083		
26412	2433	3006322	1961-01-30	1961-01-30 00:00:00	1961-01-30	5001	0	\N	0	0	\N	\N	0	161280	0	8331-1	3006322		
20238	1852	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	123986	0	7258-7	3001488		
144191	4432	4024958	1959-03-21	1959-03-21 00:00:00	1959-03-21	5001	0	\N	0	0	\N	\N	0	294567	0	117015009	4024958		
31709	2898	3027231	1980-03-29	1980-03-29 00:00:00	1980-03-29	5001	0	\N	0	0	\N	\N	0	193004	0	6276-0	3027231		
7434	711	3006322	1976-07-27	1976-07-27 00:00:00	1976-07-27	5001	0	\N	0	0	\N	\N	0	47153	0	8331-1	3006322		
27205	2522	3006322	1959-11-05	1959-11-05 00:00:00	1959-11-05	5001	0	\N	0	0	\N	\N	0	166848	0	8331-1	3006322		
38584	3568	3006322	2000-09-01	2000-09-01 00:00:00	2000-09-01	5001	0	\N	0	0	\N	\N	0	237107	0	8331-1	3006322		
38638	3571	3006734	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	237417	0	6189-5	3006734		
50014	4548	3015076	1996-10-22	1996-10-22 00:00:00	1996-10-22	5001	0	\N	0	0	\N	\N	0	303083	0	6248-9	3015076		
44671	4123	3006322	2015-03-23	2015-03-23 00:00:00	2015-03-23	5001	0	\N	0	0	\N	\N	0	274150	0	8331-1	3006322		
56042	5145	3006322	1992-03-05	1992-03-05 00:00:00	1992-03-05	5001	0	\N	0	0	\N	\N	0	342040	0	8331-1	3006322		
172869	5306	4024958	1995-04-29	1995-04-29 00:00:00	1995-04-29	5001	0	\N	0	0	\N	\N	0	352925	0	117015009	4024958		
53193	4890	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	325188	0	6189-5	3006734		
12647	1211	3006322	2008-12-02	2008-12-02 00:00:00	2008-12-02	5001	0	\N	0	0	\N	\N	0	79630	0	8331-1	3006322		
24014	2213	3015076	1991-08-01	1991-08-01 00:00:00	1991-08-01	5001	0	\N	0	0	\N	\N	0	147361	0	6248-9	3015076		
53523	4913	40766240	1971-05-09	1971-05-09 00:00:00	1971-05-09	5001	0	\N	0	0	\N	\N	0	326519	0	63513-6	40766240		
24517	2261	3006322	2006-02-05	2006-02-05 00:00:00	2006-02-05	5001	0	\N	0	0	\N	\N	0	150287	0	8331-1	3006322		
35934	3300	3006322	1997-04-17	1997-04-17 00:00:00	1997-04-17	5001	0	\N	0	0	\N	\N	0	219194	0	8331-1	3006322		
36215	3335	3006322	2002-12-17	2002-12-17 00:00:00	2002-12-17	5001	0	\N	0	0	\N	\N	0	221243	0	8331-1	3006322		
47011	4324	3020655	1981-06-30	1981-06-30 00:00:00	1981-06-30	5001	0	\N	0	0	\N	\N	0	286849	0	6844-5	3020655		
9348	884	3006734	1978-11-13	1978-11-13 00:00:00	1978-11-13	5001	0	\N	0	0	\N	\N	0	58857	0	6189-5	3006734		
38189	3526	40758406	2017-10-06	2017-10-06 00:00:00	2017-10-06	5001	0	\N	0	0	\N	\N	0	233956	0	55277-8	40758406		
47758	4376	40758406	1999-01-03	1999-01-03 00:00:00	1999-01-03	5001	0	\N	0	0	\N	\N	0	290722	0	55277-8	40758406		
94678	2909	4133840	1978-04-02	1978-04-02 00:00:00	1978-04-02	5001	0	\N	0	0	\N	\N	0	193917	0	127783003	4133840		
24918	776	4133840	2011-08-18	2011-08-18 00:00:00	2011-08-18	5001	0	\N	0	0	\N	\N	0	51573	0	127783003	4133840		
32355	2942	3006322	2007-07-04	2007-07-04 00:00:00	2007-07-04	5001	0	\N	0	0	\N	\N	0	196176	0	8331-1	3006322		
53014	1608	4052083	1945-01-26	1945-01-26 00:00:00	1945-01-26	5001	0	\N	0	0	\N	\N	0	108017	0	23426006	4052083		
70116	2150	4024958	1953-07-04	1953-07-04 00:00:00	1953-07-04	5001	0	\N	0	0	\N	\N	0	143145	0	117015009	4024958		
6459	607	3006322	1984-10-20	1984-10-20 00:00:00	1984-10-20	5001	0	\N	0	0	\N	\N	0	40327	0	8331-1	3006322		
6516	613	3006322	1970-01-03	1970-01-03 00:00:00	1970-01-03	5001	0	\N	0	0	\N	\N	0	40727	0	8331-1	3006322		
21501	1980	3012494	1975-10-10	1975-10-10 00:00:00	1975-10-10	5001	0	\N	0	0	\N	\N	0	131877	0	6206-7	3012494		
21600	1992	3005136	1978-04-17	1978-04-17 00:00:00	1978-04-17	5001	0	\N	0	0	\N	\N	0	132718	0	6075-6	3005136		
32732	2966	3001247	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	198088	0	6085-5	3001247		
31722	973	4052083	1916-09-06	1916-09-06 00:00:00	1916-09-06	5001	0	\N	0	0	\N	\N	0	64830	0	23426006	4052083		
29466	2711	3005136	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	179639	0	6075-6	3005136		
55500	5097	3021226	1996-01-21	1996-01-21 00:00:00	1996-01-21	5001	0	\N	0	0	\N	\N	0	338744	0	6246-3	3021226		
40942	3793	40758406	1941-07-25	1941-07-25 00:00:00	1941-07-25	5001	0	\N	0	0	\N	\N	0	252228	0	55277-8	40758406		
18524	1703	3006322	1995-07-28	1995-07-28 00:00:00	1995-07-28	5001	0	\N	0	0	\N	\N	0	113912	0	8331-1	3006322		
18991	600	4052083	1987-04-09	1987-04-09 00:00:00	1987-04-09	5001	0	\N	0	0	\N	\N	0	39573	0	23426006	4052083		
52444	4822	46235214	1970-12-07	1970-12-07 00:00:00	1970-12-07	5001	0	\N	0	0	\N	\N	0	320782	0	76690-7	46235214		
22185	2034	3006322	1941-08-25	1941-08-25 00:00:00	1941-08-25	5001	0	\N	0	0	\N	\N	0	135445	0	8331-1	3006322		
53437	4909	3006322	2004-02-17	2004-02-17 00:00:00	2004-02-17	5001	0	\N	0	0	\N	\N	0	326258	0	8331-1	3006322		
30567	949	4133840	2005-10-03	2005-10-03 00:00:00	2005-10-03	5001	0	\N	0	0	\N	\N	0	63016	0	127783003	4133840		
52848	4852	3006322	1970-05-08	1970-05-08 00:00:00	1970-05-08	5001	0	\N	0	0	\N	\N	0	322850	0	8331-1	3006322		
113965	3516	4052083	1956-11-01	1956-11-01 00:00:00	1956-11-01	5001	0	\N	0	0	\N	\N	0	233293	0	23426006	4052083		
52252	4804	3051031	1983-08-17	1983-08-17 00:00:00	1983-08-17	5001	0	\N	0	0	\N	\N	0	319660	0	46240-8	3051031		
3317	320	3011505	2019-03-31	2019-03-31 00:00:00	2019-03-31	5001	0	\N	0	0	\N	\N	0	21220	0	19926-5	3011505		
27833	2563	3006322	1998-04-21	1998-04-21 00:00:00	1998-04-21	5001	0	\N	0	0	\N	\N	0	169797	0	8331-1	3006322		
27905	2566	46235214	2018-01-22	2018-01-22 00:00:00	2018-01-22	5001	0	\N	0	0	\N	\N	0	170042	0	76690-7	46235214		
9551	304	4052083	2010-04-21	2010-04-21 00:00:00	2010-04-21	5001	0	\N	0	0	\N	\N	0	20276	0	23426006	4052083		
22848	2088	3011505	2015-07-21	2015-07-21 00:00:00	2015-07-21	5001	0	\N	0	0	\N	\N	0	139197	0	19926-5	3011505		
5701	533	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	35428	0	6082-2	3000876		
17073	1556	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	104188	0	6085-5	3001247		
17163	1563	3006322	1961-05-14	1961-05-14 00:00:00	1961-05-14	5001	0	\N	0	0	\N	\N	0	104696	0	8331-1	3006322		
42502	3926	3011505	2008-02-18	2008-02-18 00:00:00	2008-02-18	5001	0	\N	0	0	\N	\N	0	260933	0	19926-5	3011505		
383	16	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	1173	0	6082-2	3000876		
27495	2543	3006322	1991-01-15	1991-01-15 00:00:00	1991-01-15	5001	0	\N	0	0	\N	\N	0	168221	0	8331-1	3006322		
2400	225	3005136	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	15183	0	6075-6	3005136		
2480	236	3006322	1955-02-01	1955-02-01 00:00:00	1955-02-01	5001	0	\N	0	0	\N	\N	0	15940	0	8331-1	3006322		
20685	1898	3051031	1972-02-05	1972-02-05 00:00:00	1972-02-05	5001	0	\N	0	0	\N	\N	0	126394	0	46240-8	3051031		
130778	4027	4052083	2002-06-26	2002-06-26 00:00:00	2002-06-26	5001	0	\N	0	0	\N	\N	0	267826	0	23426006	4052083		
13961	1310	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	86613	0	6206-7	3012494		
25318	2327	3006322	2019-04-20	2019-04-20 00:00:00	2019-04-20	5001	0	\N	0	0	\N	\N	0	154756	0	8331-1	3006322		
153607	4715	4024958	1983-12-26	1983-12-26 00:00:00	1983-12-26	5001	0	\N	0	0	\N	\N	0	313958	0	117015009	4024958		
26413	2435	3006322	1981-04-15	1981-04-15 00:00:00	1981-04-15	5001	0	\N	0	0	\N	\N	0	161417	0	8331-1	3006322		
20239	1852	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	123952	0	7258-7	3001488		
144196	4433	4024958	1951-01-01	1951-01-01 00:00:00	1951-01-01	5001	0	\N	0	0	\N	\N	0	294665	0	117015009	4024958		
31710	2898	3006322	2013-08-22	2013-08-22 00:00:00	2013-08-22	5001	0	\N	0	0	\N	\N	0	193081	0	8331-1	3006322		
7435	711	3006322	2008-01-20	2008-01-20 00:00:00	2008-01-20	5001	0	\N	0	0	\N	\N	0	47202	0	8331-1	3006322		
27206	2522	40758406	1995-08-31	1995-08-31 00:00:00	1995-08-31	5001	0	\N	0	0	\N	\N	0	166801	0	55277-8	40758406		
38585	3568	40758406	1970-12-25	1970-12-25 00:00:00	1970-12-25	5001	0	\N	0	0	\N	\N	0	237093	0	55277-8	40758406		
38639	3571	3005136	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	237417	0	6075-6	3005136		
50015	4548	3001488	1996-10-22	1996-10-22 00:00:00	1996-10-22	5001	0	\N	0	0	\N	\N	0	303083	0	7258-7	3001488		
44672	4123	3006322	2015-02-08	2015-02-08 00:00:00	2015-02-08	5001	0	\N	0	0	\N	\N	0	274120	0	8331-1	3006322		
56043	5145	3006322	1967-10-08	1967-10-08 00:00:00	1967-10-08	5001	0	\N	0	0	\N	\N	0	342026	0	8331-1	3006322		
172903	5309	4024958	1954-02-15	1954-02-15 00:00:00	1954-02-15	5001	0	\N	0	0	\N	\N	0	353070	0	117015009	4024958		
53194	4890	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	325188	0	6095-4	3036780		
48720	1486	4052083	2001-03-11	2001-03-11 00:00:00	2001-03-11	5001	0	\N	0	0	\N	\N	0	99055	0	23426006	4052083		
24015	2213	3001247	1991-08-01	1991-08-01 00:00:00	1991-08-01	5001	0	\N	0	0	\N	\N	0	147361	0	6085-5	3001247		
53524	4913	46235214	1971-05-09	1971-05-09 00:00:00	1971-05-09	5001	0	\N	0	0	\N	\N	0	326519	0	76690-7	46235214		
24521	2261	40766240	1966-07-27	1966-07-27 00:00:00	1966-07-27	5001	0	\N	0	0	\N	\N	0	150313	0	63513-6	40766240		
35935	3301	3006322	1996-07-08	1996-07-08 00:00:00	1996-07-08	5001	0	\N	0	0	\N	\N	0	219267	0	8331-1	3006322		
36216	3335	40766240	2014-11-11	2014-11-11 00:00:00	2014-11-11	5001	0	\N	0	0	\N	\N	0	221249	0	63513-6	40766240		
47012	4324	3023430	1981-06-30	1981-06-30 00:00:00	1981-06-30	5001	0	\N	0	0	\N	\N	0	286849	0	6833-8	3023430		
9349	884	3000876	1978-11-13	1978-11-13 00:00:00	1978-11-13	5001	0	\N	0	0	\N	\N	0	58857	0	6082-2	3000876		
38190	3526	40766240	2017-10-06	2017-10-06 00:00:00	2017-10-06	5001	0	\N	0	0	\N	\N	0	233956	0	63513-6	40766240		
47759	4376	3051031	1999-01-03	1999-01-03 00:00:00	1999-01-03	5001	0	\N	0	0	\N	\N	0	290722	0	46240-8	3051031		
94682	2909	4133840	1986-04-13	1986-04-13 00:00:00	1986-04-13	5001	0	\N	0	0	\N	\N	0	193924	0	127783003	4133840		
57842	5312	3011505	2004-01-12	2004-01-12 00:00:00	2004-01-12	5001	0	\N	0	0	\N	\N	0	353243	0	19926-5	3011505		
32356	2942	40769184	1954-11-29	1954-11-29 00:00:00	1954-11-29	5001	0	\N	0	0	\N	\N	0	196085	0	66524-0	40769184		
53015	1608	4052083	1950-01-17	1950-01-17 00:00:00	1950-01-17	5001	0	\N	0	0	\N	\N	0	107985	0	23426006	4052083		
70336	2155	4052083	1993-07-19	1993-07-19 00:00:00	1993-07-19	5001	0	\N	0	0	\N	\N	0	143587	0	23426006	4052083		
6460	607	3006322	1971-05-27	1971-05-27 00:00:00	1971-05-27	5001	0	\N	0	0	\N	\N	0	40324	0	8331-1	3006322		
6517	613	3006322	1994-10-26	1994-10-26 00:00:00	1994-10-26	5001	0	\N	0	0	\N	\N	0	40737	0	8331-1	3006322		
21502	1980	3020655	1975-10-10	1975-10-10 00:00:00	1975-10-10	5001	0	\N	0	0	\N	\N	0	131877	0	6844-5	3020655		
21601	1992	3000876	1978-04-17	1978-04-17 00:00:00	1978-04-17	5001	0	\N	0	0	\N	\N	0	132718	0	6082-2	3000876		
32733	2966	3014599	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	198088	0	6106-9	3014599		
104648	3221	4052083	1977-02-07	1977-02-07 00:00:00	1977-02-07	5001	0	\N	0	0	\N	\N	0	214093	0	23426006	4052083		
29467	2711	3001488	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	179639	0	7258-7	3001488		
55501	5097	3014599	1996-01-21	1996-01-21 00:00:00	1996-01-21	5001	0	\N	0	0	\N	\N	0	338744	0	6106-9	3014599		
40943	3793	3051031	1942-10-23	1942-10-23 00:00:00	1942-10-23	5001	0	\N	0	0	\N	\N	0	252248	0	46240-8	3051031		
18525	1703	3006322	1984-06-10	1984-06-10 00:00:00	1984-06-10	5001	0	\N	0	0	\N	\N	0	113893	0	8331-1	3006322		
19001	600	4052083	1978-03-30	1978-03-30 00:00:00	1978-03-30	5001	0	\N	0	0	\N	\N	0	39571	0	23426006	4052083		
52446	4822	40766240	1970-12-07	1970-12-07 00:00:00	1970-12-07	5001	0	\N	0	0	\N	\N	0	320782	0	63513-6	40766240		
22186	2034	3049273	1996-09-10	1996-09-10 00:00:00	1996-09-10	5001	0	\N	0	0	\N	\N	0	135489	0	38265-5	3049273		
142454	4376	4133840	2008-12-16	2008-12-16 00:00:00	2008-12-16	5001	0	\N	0	0	\N	\N	0	290780	0	127783003	4133840		
30569	949	4133840	2003-09-29	2003-09-29 00:00:00	2003-09-29	5001	0	\N	0	0	\N	\N	0	63039	0	127783003	4133840		
77583	2381	4024958	2012-11-25	2012-11-25 00:00:00	2012-11-25	5001	0	\N	0	0	\N	\N	0	158335	0	117015009	4024958		
113966	3516	4024958	1965-06-25	1965-06-25 00:00:00	1965-06-25	5001	0	\N	0	0	\N	\N	0	233332	0	117015009	4024958		
52253	4804	46235214	1983-05-19	1983-05-19 00:00:00	1983-05-19	5001	0	\N	0	0	\N	\N	0	319659	0	76690-7	46235214		
3318	320	3011505	2008-01-27	2008-01-27 00:00:00	2008-01-27	5001	0	\N	0	0	\N	\N	0	21189	0	19926-5	3011505		
27834	2564	3006322	1991-08-06	1991-08-06 00:00:00	1991-08-06	5001	0	\N	0	0	\N	\N	0	169888	0	8331-1	3006322		
27906	2566	3051031	2018-01-22	2018-01-22 00:00:00	2018-01-22	5001	0	\N	0	0	\N	\N	0	170042	0	46240-8	3051031		
9558	304	4024958	1960-11-16	1960-11-16 00:00:00	1960-11-16	5001	0	\N	0	0	\N	\N	0	20245	0	117015009	4024958		
22849	2088	3011505	1992-08-11	1992-08-11 00:00:00	1992-08-11	5001	0	\N	0	0	\N	\N	0	139237	0	19926-5	3011505		
5702	533	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	35428	0	6206-7	3012494		
17074	1556	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	104188	0	6273-7	3006451		
17164	1563	3006322	1983-06-28	1983-06-28 00:00:00	1983-06-28	5001	0	\N	0	0	\N	\N	0	104706	0	8331-1	3006322		
42503	3926	3011505	1994-10-17	1994-10-17 00:00:00	1994-10-17	5001	0	\N	0	0	\N	\N	0	260951	0	19926-5	3011505		
384	16	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	1173	0	6189-5	3006734		
27496	2543	46235214	1985-12-07	1985-12-07 00:00:00	1985-12-07	5001	0	\N	0	0	\N	\N	0	168220	0	76690-7	46235214		
2401	225	3012494	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	15183	0	6206-7	3012494		
2481	236	3006322	1987-09-29	1987-09-29 00:00:00	1987-09-29	5001	0	\N	0	0	\N	\N	0	15927	0	8331-1	3006322		
20686	1898	46235214	1972-02-05	1972-02-05 00:00:00	1972-02-05	5001	0	\N	0	0	\N	\N	0	126394	0	76690-7	46235214		
130798	4027	4024958	1991-05-31	1991-05-31 00:00:00	1991-05-31	5001	0	\N	0	0	\N	\N	0	267839	0	117015009	4024958		
13962	1310	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	86613	0	6273-7	3006451		
25319	2327	3006322	1965-12-17	1965-12-17 00:00:00	1965-12-17	5001	0	\N	0	0	\N	\N	0	154731	0	8331-1	3006322		
153617	4715	4052083	1985-01-07	1985-01-07 00:00:00	1985-01-07	5001	0	\N	0	0	\N	\N	0	313928	0	23426006	4052083		
26414	2435	3006322	2011-01-26	2011-01-26 00:00:00	2011-01-26	5001	0	\N	0	0	\N	\N	0	161411	0	8331-1	3006322		
20240	1852	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	123952	0	6106-9	3014599		
144205	4433	4024958	1950-03-23	1950-03-23 00:00:00	1950-03-23	5001	0	\N	0	0	\N	\N	0	294642	0	117015009	4024958		
31711	2898	3014599	1995-07-25	1995-07-25 00:00:00	1995-07-25	5001	0	\N	0	0	\N	\N	0	192974	0	6106-9	3014599		
7436	711	3006322	1972-08-07	1972-08-07 00:00:00	1972-08-07	5001	0	\N	0	0	\N	\N	0	47110	0	8331-1	3006322		
27207	2522	46235214	1995-08-31	1995-08-31 00:00:00	1995-08-31	5001	0	\N	0	0	\N	\N	0	166801	0	76690-7	46235214		
38587	3568	3051031	1970-12-25	1970-12-25 00:00:00	1970-12-25	5001	0	\N	0	0	\N	\N	0	237093	0	46240-8	3051031		
38640	3571	3015076	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	237417	0	6248-9	3015076		
50016	4548	3001247	1996-10-22	1996-10-22 00:00:00	1996-10-22	5001	0	\N	0	0	\N	\N	0	303083	0	6085-5	3001247		
44673	4123	3006322	1977-07-03	1977-07-03 00:00:00	1977-07-03	5001	0	\N	0	0	\N	\N	0	274082	0	8331-1	3006322		
56044	5145	3006322	2015-06-23	2015-06-23 00:00:00	2015-06-23	5001	0	\N	0	0	\N	\N	0	342030	0	8331-1	3006322		
10746	1046	3006322	1980-02-07	1980-02-07 00:00:00	1980-02-07	5001	0	\N	0	0	\N	\N	0	68673	0	8331-1	3006322		
53195	4890	3049273	1998-09-28	1998-09-28 00:00:00	1998-09-28	5001	0	\N	0	0	\N	\N	0	325147	0	38265-5	3049273		
48770	1486	4024958	1958-12-25	1958-12-25 00:00:00	1958-12-25	5001	0	\N	0	0	\N	\N	0	99133	0	117015009	4024958		
24016	2213	3006734	1991-08-01	1991-08-01 00:00:00	1991-08-01	5001	0	\N	0	0	\N	\N	0	147361	0	6189-5	3006734		
53525	4913	3006322	2018-03-02	2018-03-02 00:00:00	2018-03-02	5001	0	\N	0	0	\N	\N	0	326534	0	8331-1	3006322		
24522	2261	40758406	1966-07-27	1966-07-27 00:00:00	1966-07-27	5001	0	\N	0	0	\N	\N	0	150313	0	55277-8	40758406		
35936	3301	3006322	1995-04-01	1995-04-01 00:00:00	1995-04-01	5001	0	\N	0	0	\N	\N	0	219338	0	8331-1	3006322		
5912	181	4024958	1994-07-01	1994-07-01 00:00:00	1994-07-01	5001	0	\N	0	0	\N	\N	0	12204	0	117015009	4024958		
47013	4325	3006322	1969-12-10	1969-12-10 00:00:00	1969-12-10	5001	0	\N	0	0	\N	\N	0	286935	0	8331-1	3006322		
9350	884	3023430	1978-11-13	1978-11-13 00:00:00	1978-11-13	5001	0	\N	0	0	\N	\N	0	58857	0	6833-8	3023430		
38191	3526	3051031	2017-10-06	2017-10-06 00:00:00	2017-10-06	5001	0	\N	0	0	\N	\N	0	233956	0	46240-8	3051031		
47760	4376	40766240	1999-01-03	1999-01-03 00:00:00	1999-01-03	5001	0	\N	0	0	\N	\N	0	290722	0	63513-6	40766240		
94684	2909	4133840	1997-05-18	1997-05-18 00:00:00	1997-05-18	5001	0	\N	0	0	\N	\N	0	193921	0	127783003	4133840		
57843	5312	3011505	2006-01-23	2006-01-23 00:00:00	2006-01-23	5001	0	\N	0	0	\N	\N	0	353269	0	19926-5	3011505		
32357	2942	40769179	1954-11-29	1954-11-29 00:00:00	1954-11-29	5001	0	\N	0	0	\N	\N	0	196085	0	66519-0	40769179		
53016	1608	4052083	1990-09-17	1990-09-17 00:00:00	1990-09-17	5001	0	\N	0	0	\N	\N	0	108002	0	23426006	4052083		
70343	2155	4024958	1961-08-11	1961-08-11 00:00:00	1961-08-11	5001	0	\N	0	0	\N	\N	0	143654	0	117015009	4024958		
6461	607	3006322	1984-09-05	1984-09-05 00:00:00	1984-09-05	5001	0	\N	0	0	\N	\N	0	40269	0	8331-1	3006322		
6518	613	3006322	1978-07-12	1978-07-12 00:00:00	1978-07-12	5001	0	\N	0	0	\N	\N	0	40719	0	8331-1	3006322		
21503	1980	3023430	1975-10-10	1975-10-10 00:00:00	1975-10-10	5001	0	\N	0	0	\N	\N	0	131877	0	6833-8	3023430		
21602	1992	3001247	1978-04-17	1978-04-17 00:00:00	1978-04-17	5001	0	\N	0	0	\N	\N	0	132718	0	6085-5	3001247		
91781	2830	4024958	2008-02-06	2008-02-06 00:00:00	2008-02-06	5001	0	\N	0	0	\N	\N	0	187689	0	117015009	4024958		
104661	3221	4052083	1977-04-16	1977-04-16 00:00:00	1977-04-16	5001	0	\N	0	0	\N	\N	0	214069	0	23426006	4052083		
29468	2711	3020655	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	179639	0	6844-5	3020655		
55502	5097	3027231	1996-01-21	1996-01-21 00:00:00	1996-01-21	5001	0	\N	0	0	\N	\N	0	338744	0	6276-0	3027231		
40944	3793	46235214	1942-10-23	1942-10-23 00:00:00	1942-10-23	5001	0	\N	0	0	\N	\N	0	252248	0	76690-7	46235214		
98092	3000	4024958	2012-09-25	2012-09-25 00:00:00	2012-09-25	5001	0	\N	0	0	\N	\N	0	200199	0	117015009	4024958		
19014	601	4024958	1983-07-04	1983-07-04 00:00:00	1983-07-04	5001	0	\N	0	0	\N	\N	0	39758	0	117015009	4024958		
52447	4822	3011505	2011-12-14	2011-12-14 00:00:00	2011-12-14	5001	0	\N	0	0	\N	\N	0	320719	0	19926-5	3011505		
22187	2034	3006322	2012-03-05	2012-03-05 00:00:00	2012-03-05	5001	0	\N	0	0	\N	\N	0	135416	0	8331-1	3006322		
142458	4376	4133840	2007-12-11	2007-12-11 00:00:00	2007-12-11	5001	0	\N	0	0	\N	\N	0	290820	0	127783003	4133840		
30572	949	4133840	1993-03-22	1993-03-22 00:00:00	1993-03-22	5001	0	\N	0	0	\N	\N	0	63037	0	127783003	4133840		
77636	2384	4024958	2004-01-24	2004-01-24 00:00:00	2004-01-24	5001	0	\N	0	0	\N	\N	0	158509	0	117015009	4024958		
113970	3516	4052083	1949-01-07	1949-01-07 00:00:00	1949-01-07	5001	0	\N	0	0	\N	\N	0	233312	0	23426006	4052083		
52256	4804	40766240	1983-05-19	1983-05-19 00:00:00	1983-05-19	5001	0	\N	0	0	\N	\N	0	319659	0	63513-6	40766240		
3319	320	3011505	1990-06-17	1990-06-17 00:00:00	1990-06-17	5001	0	\N	0	0	\N	\N	0	21203	0	19926-5	3011505		
27835	2564	3006322	2005-08-22	2005-08-22 00:00:00	2005-08-22	5001	0	\N	0	0	\N	\N	0	169837	0	8331-1	3006322		
27907	2566	40758406	2018-01-22	2018-01-22 00:00:00	2018-01-22	5001	0	\N	0	0	\N	\N	0	170042	0	55277-8	40758406		
9567	304	4024958	2018-12-27	2018-12-27 00:00:00	2018-12-27	5001	0	\N	0	0	\N	\N	0	20204	0	117015009	4024958		
22850	2088	40766240	1995-10-31	1995-10-31 00:00:00	1995-10-31	5001	0	\N	0	0	\N	\N	0	139293	0	63513-6	40766240		
5703	533	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	35428	0	6158-0	3019406		
17075	1556	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	104188	0	6276-0	3027231		
17165	1563	3006322	2002-10-24	2002-10-24 00:00:00	2002-10-24	5001	0	\N	0	0	\N	\N	0	104678	0	8331-1	3006322		
42504	3926	3011505	2014-07-07	2014-07-07 00:00:00	2014-07-07	5001	0	\N	0	0	\N	\N	0	260921	0	19926-5	3011505		
385	16	3006322	1976-09-20	1976-09-20 00:00:00	1976-09-20	5001	0	\N	0	0	\N	\N	0	1275	0	8331-1	3006322		
27498	2543	40766240	1985-12-07	1985-12-07 00:00:00	1985-12-07	5001	0	\N	0	0	\N	\N	0	168220	0	63513-6	40766240		
2402	225	3001247	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	15183	0	6085-5	3001247		
2486	239	3006322	2009-07-22	2009-07-22 00:00:00	2009-07-22	5001	0	\N	0	0	\N	\N	0	16060	0	8331-1	3006322		
20689	1900	3006322	1964-02-07	1964-02-07 00:00:00	1964-02-07	5001	0	\N	0	0	\N	\N	0	126457	0	8331-1	3006322		
130813	4027	4024958	1976-10-05	1976-10-05 00:00:00	1976-10-05	5001	0	\N	0	0	\N	\N	0	267896	0	117015009	4024958		
25240	2319	3006322	1964-05-17	1964-05-17 00:00:00	1964-05-17	5001	0	\N	0	0	\N	\N	0	154195	0	8331-1	3006322		
25320	2327	3006322	1979-05-15	1979-05-15 00:00:00	1979-05-15	5001	0	\N	0	0	\N	\N	0	154733	0	8331-1	3006322		
153619	4715	4024958	2017-09-05	2017-09-05 00:00:00	2017-09-05	5001	0	\N	0	0	\N	\N	0	313900	0	117015009	4024958		
26415	2435	3006322	1982-09-22	1982-09-22 00:00:00	1982-09-22	5001	0	\N	0	0	\N	\N	0	161399	0	8331-1	3006322		
20241	1852	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	123952	0	6276-0	3027231		
5295	507	40758406	1958-01-11	1958-01-11 00:00:00	1958-01-11	5001	0	\N	0	0	\N	\N	0	33947	0	55277-8	40758406		
31712	2898	3005136	1995-07-25	1995-07-25 00:00:00	1995-07-25	5001	0	\N	0	0	\N	\N	0	192974	0	6075-6	3005136		
7437	711	3006322	1954-08-06	1954-08-06 00:00:00	1954-08-06	5001	0	\N	0	0	\N	\N	0	47191	0	8331-1	3006322		
27208	2522	3051031	1995-08-31	1995-08-31 00:00:00	1995-08-31	5001	0	\N	0	0	\N	\N	0	166801	0	46240-8	3051031		
38588	3568	40766240	1970-12-25	1970-12-25 00:00:00	1970-12-25	5001	0	\N	0	0	\N	\N	0	237093	0	63513-6	40766240		
38641	3571	3000876	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	237417	0	6082-2	3000876		
50017	4548	3021226	1996-10-22	1996-10-22 00:00:00	1996-10-22	5001	0	\N	0	0	\N	\N	0	303083	0	6246-3	3021226		
44674	4123	3006322	2003-05-01	2003-05-01 00:00:00	2003-05-01	5001	0	\N	0	0	\N	\N	0	274148	0	8331-1	3006322		
56045	5145	3006322	1977-05-02	1977-05-02 00:00:00	1977-05-02	5001	0	\N	0	0	\N	\N	0	342002	0	8331-1	3006322		
28975	2673	3012494	1990-02-12	1990-02-12 00:00:00	1990-02-12	5001	0	\N	0	0	\N	\N	0	177114	0	6206-7	3012494		
53196	4890	3006322	1934-08-15	1934-08-15 00:00:00	1934-08-15	5001	0	\N	0	0	\N	\N	0	325062	0	8331-1	3006322		
12977	1236	3006322	1971-04-26	1971-04-26 00:00:00	1971-04-26	5001	0	\N	0	0	\N	\N	0	81383	0	8331-1	3006322		
24017	2213	3006451	1991-08-01	1991-08-01 00:00:00	1991-08-01	5001	0	\N	0	0	\N	\N	0	147361	0	6273-7	3006451		
53526	4913	3051031	1971-01-09	1971-01-09 00:00:00	1971-01-09	5001	0	\N	0	0	\N	\N	0	326535	0	46240-8	3051031		
24523	2261	46235214	1966-07-27	1966-07-27 00:00:00	1966-07-27	5001	0	\N	0	0	\N	\N	0	150313	0	76690-7	46235214		
35937	3301	3006322	1954-02-07	1954-02-07 00:00:00	1954-02-07	5001	0	\N	0	0	\N	\N	0	219305	0	8331-1	3006322		
5925	182	4052083	2007-10-17	2007-10-17 00:00:00	2007-10-17	5001	0	\N	0	0	\N	\N	0	12298	0	23426006	4052083		
47014	4325	3006322	1988-04-01	1988-04-01 00:00:00	1988-04-01	5001	0	\N	0	0	\N	\N	0	286896	0	8331-1	3006322		
9351	884	3001488	1978-11-13	1978-11-13 00:00:00	1978-11-13	5001	0	\N	0	0	\N	\N	0	58857	0	7258-7	3001488		
38194	3526	46235214	2017-10-06	2017-10-06 00:00:00	2017-10-06	5001	0	\N	0	0	\N	\N	0	233956	0	76690-7	46235214		
47761	4376	46235214	1999-01-03	1999-01-03 00:00:00	1999-01-03	5001	0	\N	0	0	\N	\N	0	290722	0	76690-7	46235214		
94687	2909	4133840	2005-07-03	2005-07-03 00:00:00	2005-07-03	5001	0	\N	0	0	\N	\N	0	193880	0	127783003	4133840		
57844	5312	3011505	1989-11-06	1989-11-06 00:00:00	1989-11-06	5001	0	\N	0	0	\N	\N	0	353266	0	19926-5	3011505		
32358	2942	40769189	1954-11-29	1954-11-29 00:00:00	1954-11-29	5001	0	\N	0	0	\N	\N	0	196085	0	66529-9	40769189		
53020	1608	4024958	1949-09-14	1949-09-14 00:00:00	1949-09-14	5001	0	\N	0	0	\N	\N	0	107964	0	117015009	4024958		
81629	2525	4052083	2009-12-26	2009-12-26 00:00:00	2009-12-26	5001	0	\N	0	0	\N	\N	0	166977	0	23426006	4052083		
6462	607	3006322	1964-09-18	1964-09-18 00:00:00	1964-09-18	5001	0	\N	0	0	\N	\N	0	40322	0	8331-1	3006322		
6519	613	3006322	1997-07-27	1997-07-27 00:00:00	1997-07-27	5001	0	\N	0	0	\N	\N	0	40748	0	8331-1	3006322		
21504	1980	3001247	1975-10-10	1975-10-10 00:00:00	1975-10-10	5001	0	\N	0	0	\N	\N	0	131877	0	6085-5	3001247		
21603	1992	3027231	1978-04-17	1978-04-17 00:00:00	1978-04-17	5001	0	\N	0	0	\N	\N	0	132718	0	6276-0	3027231		
103106	3172	4052083	1980-02-06	1980-02-06 00:00:00	1980-02-06	5001	0	\N	0	0	\N	\N	0	210850	0	23426006	4052083		
104683	3222	4024958	1971-03-19	1971-03-19 00:00:00	1971-03-19	5001	0	\N	0	0	\N	\N	0	214139	0	117015009	4024958		
29469	2711	3019406	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	179639	0	6158-0	3019406		
55503	5097	3020655	1996-01-21	1996-01-21 00:00:00	1996-01-21	5001	0	\N	0	0	\N	\N	0	338744	0	6844-5	3020655		
40946	3793	40758406	1942-10-23	1942-10-23 00:00:00	1942-10-23	5001	0	\N	0	0	\N	\N	0	252248	0	55277-8	40758406		
109372	3375	4052083	2007-02-24	2007-02-24 00:00:00	2007-02-24	5001	0	\N	0	0	\N	\N	0	223855	0	23426006	4052083		
19038	601	4024958	1971-10-21	1971-10-21 00:00:00	1971-10-21	5001	0	\N	0	0	\N	\N	0	39717	0	117015009	4024958		
6625	621	46235214	1972-10-05	1972-10-05 00:00:00	1972-10-05	5001	0	\N	0	0	\N	\N	0	41472	0	76690-7	46235214		
22188	2034	3006322	2006-06-22	2006-06-22 00:00:00	2006-06-22	5001	0	\N	0	0	\N	\N	0	135450	0	8331-1	3006322		
142461	4376	4133840	1986-08-12	1986-08-12 00:00:00	1986-08-12	5001	0	\N	0	0	\N	\N	0	290798	0	127783003	4133840		
30573	949	4133840	2008-11-03	2008-11-03 00:00:00	2008-11-03	5001	0	\N	0	0	\N	\N	0	63055	0	127783003	4133840		
77639	2384	4024958	1988-02-19	1988-02-19 00:00:00	1988-02-19	5001	0	\N	0	0	\N	\N	0	158507	0	117015009	4024958		
113987	3516	4052083	2002-05-05	2002-05-05 00:00:00	2002-05-05	5001	0	\N	0	0	\N	\N	0	233299	0	23426006	4052083		
52257	4804	3051031	1983-05-19	1983-05-19 00:00:00	1983-05-19	5001	0	\N	0	0	\N	\N	0	319659	0	46240-8	3051031		
3320	320	3011505	2009-02-01	2009-02-01 00:00:00	2009-02-01	5001	0	\N	0	0	\N	\N	0	21192	0	19926-5	3011505		
27836	2564	3006322	2012-10-28	2012-10-28 00:00:00	2012-10-28	5001	0	\N	0	0	\N	\N	0	169891	0	8331-1	3006322		
27909	2566	46235214	2017-05-27	2017-05-27 00:00:00	2017-05-27	5001	0	\N	0	0	\N	\N	0	170003	0	76690-7	46235214		
19518	1783	3006322	2008-12-19	2008-12-19 00:00:00	2008-12-19	5001	0	\N	0	0	\N	\N	0	119508	0	8331-1	3006322		
22852	2088	3051031	1995-10-31	1995-10-31 00:00:00	1995-10-31	5001	0	\N	0	0	\N	\N	0	139293	0	46240-8	3051031		
5704	533	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	35428	0	6075-6	3005136		
17076	1556	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	104188	0	6158-0	3019406		
17166	1563	3006322	2003-07-01	2003-07-01 00:00:00	2003-07-01	5001	0	\N	0	0	\N	\N	0	104688	0	8331-1	3006322		
42505	3926	3011505	1999-11-08	1999-11-08 00:00:00	1999-11-08	5001	0	\N	0	0	\N	\N	0	260952	0	19926-5	3011505		
386	16	3006322	2015-02-13	2015-02-13 00:00:00	2015-02-13	5001	0	\N	0	0	\N	\N	0	1188	0	8331-1	3006322		
27500	2543	3051031	1985-12-07	1985-12-07 00:00:00	1985-12-07	5001	0	\N	0	0	\N	\N	0	168220	0	46240-8	3051031		
2403	225	3023430	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	15183	0	6833-8	3023430		
2487	239	3006322	1970-06-17	1970-06-17 00:00:00	1970-06-17	5001	0	\N	0	0	\N	\N	0	16035	0	8331-1	3006322		
20690	1900	3006322	1966-09-10	1966-09-10 00:00:00	1966-09-10	5001	0	\N	0	0	\N	\N	0	126462	0	8331-1	3006322		
123885	3822	4052083	1972-08-31	1972-08-31 00:00:00	1972-08-31	5001	0	\N	0	0	\N	\N	0	253879	0	23426006	4052083		
25241	2319	3006322	1988-04-29	1988-04-29 00:00:00	1988-04-29	5001	0	\N	0	0	\N	\N	0	154166	0	8331-1	3006322		
25321	2328	3006322	2014-07-05	2014-07-05 00:00:00	2014-07-05	5001	0	\N	0	0	\N	\N	0	154821	0	8331-1	3006322		
153629	4715	4052083	1970-01-26	1970-01-26 00:00:00	1970-01-26	5001	0	\N	0	0	\N	\N	0	313896	0	23426006	4052083		
26416	2435	3006322	2001-01-26	2001-01-26 00:00:00	2001-01-26	5001	0	\N	0	0	\N	\N	0	161389	0	8331-1	3006322		
20242	1852	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	123952	0	6095-4	3036780		
5297	507	3051031	1958-01-11	1958-01-11 00:00:00	1958-01-11	5001	0	\N	0	0	\N	\N	0	33947	0	46240-8	3051031		
31713	2898	3015076	1995-07-25	1995-07-25 00:00:00	1995-07-25	5001	0	\N	0	0	\N	\N	0	192974	0	6248-9	3015076		
7438	711	3015632	1967-01-29	1967-01-29 00:00:00	1967-01-29	5001	0	\N	0	0	\N	\N	0	47196	0	2028-9	3015632		
38486	3559	3006322	1996-06-08	1996-06-08 00:00:00	1996-06-08	5001	0	\N	0	0	\N	\N	0	236277	0	8331-1	3006322		
38590	3568	46235214	1970-12-25	1970-12-25 00:00:00	1970-12-25	5001	0	\N	0	0	\N	\N	0	237093	0	76690-7	46235214		
38642	3571	3036780	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	237417	0	6095-4	3036780		
50018	4548	3006451	1996-10-22	1996-10-22 00:00:00	1996-10-22	5001	0	\N	0	0	\N	\N	0	303083	0	6273-7	3006451		
44675	4123	3006322	1971-02-22	1971-02-22 00:00:00	1971-02-22	5001	0	\N	0	0	\N	\N	0	274146	0	8331-1	3006322		
56046	5146	3006322	2018-11-14	2018-11-14 00:00:00	2018-11-14	5001	0	\N	0	0	\N	\N	0	342137	0	8331-1	3006322		
28976	2673	3015076	1990-02-12	1990-02-12 00:00:00	1990-02-12	5001	0	\N	0	0	\N	\N	0	177114	0	6248-9	3015076		
53197	4890	3049273	1981-12-26	1981-12-26 00:00:00	1981-12-26	5001	0	\N	0	0	\N	\N	0	325146	0	38265-5	3049273		
12978	1236	3049273	2010-07-29	2010-07-29 00:00:00	2010-07-29	5001	0	\N	0	0	\N	\N	0	81448	0	38265-5	3049273		
24018	2213	3027231	1991-08-01	1991-08-01 00:00:00	1991-08-01	5001	0	\N	0	0	\N	\N	0	147361	0	6276-0	3027231		
53529	4913	40766240	1971-01-09	1971-01-09 00:00:00	1971-01-09	5001	0	\N	0	0	\N	\N	0	326535	0	63513-6	40766240		
35801	3280	3011505	2016-12-08	2016-12-08 00:00:00	2016-12-08	5001	0	\N	0	0	\N	\N	0	218000	0	19926-5	3011505		
35938	3301	3006322	1992-12-30	1992-12-30 00:00:00	1992-12-30	5001	0	\N	0	0	\N	\N	0	219332	0	8331-1	3006322		
5938	182	4052083	1984-03-17	1984-03-17 00:00:00	1984-03-17	5001	0	\N	0	0	\N	\N	0	12277	0	23426006	4052083		
47015	4325	3006322	2009-11-27	2009-11-27 00:00:00	2009-11-27	5001	0	\N	0	0	\N	\N	0	286898	0	8331-1	3006322		
9352	884	3012494	1978-11-13	1978-11-13 00:00:00	1978-11-13	5001	0	\N	0	0	\N	\N	0	58857	0	6206-7	3012494		
38196	3526	40758406	2018-07-03	2018-07-03 00:00:00	2018-07-03	5001	0	\N	0	0	\N	\N	0	233978	0	55277-8	40758406		
47764	4376	3011505	1988-08-23	1988-08-23 00:00:00	1988-08-23	5001	0	\N	0	0	\N	\N	0	290799	0	19926-5	3011505		
47187	1439	4052083	1978-03-13	1978-03-13 00:00:00	1978-03-13	5001	0	\N	0	0	\N	\N	0	95916	0	23426006	4052083		
57845	5312	3011505	1980-11-24	1980-11-24 00:00:00	1980-11-24	5001	0	\N	0	0	\N	\N	0	353285	0	19926-5	3011505		
32359	2942	40769194	1954-11-29	1954-11-29 00:00:00	1954-11-29	5001	0	\N	0	0	\N	\N	0	196085	0	66534-9	40769194		
53034	1608	4024958	1967-07-28	1967-07-28 00:00:00	1967-07-28	5001	0	\N	0	0	\N	\N	0	107968	0	117015009	4024958		
81671	2528	4024958	1980-10-16	1980-10-16 00:00:00	1980-10-16	5001	0	\N	0	0	\N	\N	0	167106	0	117015009	4024958		
6463	607	3006322	1973-08-24	1973-08-24 00:00:00	1973-08-24	5001	0	\N	0	0	\N	\N	0	40325	0	8331-1	3006322		
6520	613	3006322	1973-09-26	1973-09-26 00:00:00	1973-09-26	5001	0	\N	0	0	\N	\N	0	40728	0	8331-1	3006322		
21505	1980	3006734	1975-10-10	1975-10-10 00:00:00	1975-10-10	5001	0	\N	0	0	\N	\N	0	131877	0	6189-5	3006734		
21604	1992	3036780	1978-04-17	1978-04-17 00:00:00	1978-04-17	5001	0	\N	0	0	\N	\N	0	132718	0	6095-4	3036780		
103109	3172	4024958	1991-09-30	1991-09-30 00:00:00	1991-09-30	5001	0	\N	0	0	\N	\N	0	210860	0	117015009	4024958		
104688	3222	4052083	2015-06-10	2015-06-10 00:00:00	2015-06-10	5001	0	\N	0	0	\N	\N	0	214219	0	23426006	4052083		
29470	2711	3012494	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	179639	0	6206-7	3012494		
55504	5097	3000876	1996-01-21	1996-01-21 00:00:00	1996-01-21	5001	0	\N	0	0	\N	\N	0	338744	0	6082-2	3000876		
40948	3793	40766240	1942-10-23	1942-10-23 00:00:00	1942-10-23	5001	0	\N	0	0	\N	\N	0	252248	0	63513-6	40766240		
109378	3375	4024958	1993-03-14	1993-03-14 00:00:00	1993-03-14	5001	0	\N	0	0	\N	\N	0	223854	0	117015009	4024958		
30587	2801	3006322	1983-04-26	1983-04-26 00:00:00	1983-04-26	5001	0	\N	0	0	\N	\N	0	185596	0	8331-1	3006322		
6627	621	40766240	1972-10-05	1972-10-05 00:00:00	1972-10-05	5001	0	\N	0	0	\N	\N	0	41472	0	63513-6	40766240		
22189	2034	3006322	1978-12-04	1978-12-04 00:00:00	1978-12-04	5001	0	\N	0	0	\N	\N	0	135495	0	8331-1	3006322		
142464	4376	4133840	2012-01-03	2012-01-03 00:00:00	2012-01-03	5001	0	\N	0	0	\N	\N	0	290822	0	127783003	4133840		
30575	949	4052083	2005-10-17	2005-10-17 00:00:00	2005-10-17	5001	0	\N	0	0	\N	\N	0	63044	0	23426006	4052083		
132007	4067	4052083	2012-08-19	2012-08-19 00:00:00	2012-08-19	5001	0	\N	0	0	\N	\N	0	270251	0	23426006	4052083		
125314	3866	4024958	1966-02-10	1966-02-10 00:00:00	1966-02-10	5001	0	\N	0	0	\N	\N	0	256684	0	117015009	4024958		
52258	4804	40758406	1983-05-19	1983-05-19 00:00:00	1983-05-19	5001	0	\N	0	0	\N	\N	0	319659	0	55277-8	40758406		
3321	320	3011505	1998-03-01	1998-03-01 00:00:00	1998-03-01	5001	0	\N	0	0	\N	\N	0	21251	0	19926-5	3011505		
27837	2564	3006322	1991-11-19	1991-11-19 00:00:00	1991-11-19	5001	0	\N	0	0	\N	\N	0	169913	0	8331-1	3006322		
27910	2566	40758406	2017-05-27	2017-05-27 00:00:00	2017-05-27	5001	0	\N	0	0	\N	\N	0	170003	0	55277-8	40758406		
19519	1783	3006322	1975-06-18	1975-06-18 00:00:00	1975-06-18	5001	0	\N	0	0	\N	\N	0	119495	0	8331-1	3006322		
22854	2088	40758406	1995-10-31	1995-10-31 00:00:00	1995-10-31	5001	0	\N	0	0	\N	\N	0	139293	0	55277-8	40758406		
5705	533	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	35428	0	6248-9	3015076		
17077	1556	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	104188	0	6206-7	3012494		
75440	2314	4024958	2004-12-12	2004-12-12 00:00:00	2004-12-12	5001	0	\N	0	0	\N	\N	0	153844	0	117015009	4024958		
42506	3926	3011505	1986-09-29	1986-09-29 00:00:00	1986-09-29	5001	0	\N	0	0	\N	\N	0	260998	0	19926-5	3011505		
387	16	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	1277	0	6189-5	3006734		
27501	2543	40758406	1985-12-07	1985-12-07 00:00:00	1985-12-07	5001	0	\N	0	0	\N	\N	0	168220	0	55277-8	40758406		
2406	227	3006322	1972-03-17	1972-03-17 00:00:00	1972-03-17	5001	0	\N	0	0	\N	\N	0	15364	0	8331-1	3006322		
2488	239	3006322	1991-11-09	1991-11-09 00:00:00	1991-11-09	5001	0	\N	0	0	\N	\N	0	16036	0	8331-1	3006322		
20691	1900	3006322	1980-08-27	1980-08-27 00:00:00	1980-08-27	5001	0	\N	0	0	\N	\N	0	126451	0	8331-1	3006322		
123893	3822	4024958	1959-09-03	1959-09-03 00:00:00	1959-09-03	5001	0	\N	0	0	\N	\N	0	253899	0	117015009	4024958		
25242	2320	3006322	2007-01-14	2007-01-14 00:00:00	2007-01-14	5001	0	\N	0	0	\N	\N	0	154258	0	8331-1	3006322		
25322	2328	3006322	1961-04-08	1961-04-08 00:00:00	1961-04-08	5001	0	\N	0	0	\N	\N	0	154814	0	8331-1	3006322		
26314	2419	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	160526	0	6189-5	3006734		
26417	2435	3006322	1979-07-17	1979-07-17 00:00:00	1979-07-17	5001	0	\N	0	0	\N	\N	0	161408	0	8331-1	3006322		
20243	1852	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	123952	0	6844-5	3020655		
5299	507	40766240	1958-01-11	1958-01-11 00:00:00	1958-01-11	5001	0	\N	0	0	\N	\N	0	33947	0	63513-6	40766240		
31714	2898	3006451	1995-07-25	1995-07-25 00:00:00	1995-07-25	5001	0	\N	0	0	\N	\N	0	192974	0	6273-7	3006451		
7439	711	3013682	1967-01-29	1967-01-29 00:00:00	1967-01-29	5001	0	\N	0	0	\N	\N	0	47196	0	3094-0	3013682		
38487	3559	3006322	1978-07-31	1978-07-31 00:00:00	1978-07-31	5001	0	\N	0	0	\N	\N	0	236267	0	8331-1	3006322		
38592	3568	46235214	2004-07-14	2004-07-14 00:00:00	2004-07-14	5001	0	\N	0	0	\N	\N	0	237057	0	76690-7	46235214		
38643	3571	3019406	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	237417	0	6158-0	3019406		
50019	4548	3036780	1996-10-22	1996-10-22 00:00:00	1996-10-22	5001	0	\N	0	0	\N	\N	0	303083	0	6095-4	3036780		
44676	4123	3049273	2013-02-09	2013-02-09 00:00:00	2013-02-09	5001	0	\N	0	0	\N	\N	0	274118	0	38265-5	3049273		
56047	5146	3006322	1994-01-10	1994-01-10 00:00:00	1994-01-10	5001	0	\N	0	0	\N	\N	0	342136	0	8331-1	3006322		
28977	2673	3021226	1990-02-12	1990-02-12 00:00:00	1990-02-12	5001	0	\N	0	0	\N	\N	0	177114	0	6246-3	3021226		
53198	4890	3006322	2004-11-05	2004-11-05 00:00:00	2004-11-05	5001	0	\N	0	0	\N	\N	0	325215	0	8331-1	3006322		
12979	1236	3006322	2015-11-15	2015-11-15 00:00:00	2015-11-15	5001	0	\N	0	0	\N	\N	0	81386	0	8331-1	3006322		
24019	2213	3019406	1991-08-01	1991-08-01 00:00:00	1991-08-01	5001	0	\N	0	0	\N	\N	0	147361	0	6158-0	3019406		
53530	4913	40758406	1971-01-09	1971-01-09 00:00:00	1971-01-09	5001	0	\N	0	0	\N	\N	0	326535	0	55277-8	40758406		
35802	3280	3006322	2000-07-26	2000-07-26 00:00:00	2000-07-26	5001	0	\N	0	0	\N	\N	0	217977	0	8331-1	3006322		
35939	3301	3006322	1976-08-02	1976-08-02 00:00:00	1976-08-02	5001	0	\N	0	0	\N	\N	0	219331	0	8331-1	3006322		
5947	183	4024958	1996-11-26	1996-11-26 00:00:00	1996-11-26	5001	0	\N	0	0	\N	\N	0	12338	0	117015009	4024958		
47016	4325	3006322	1995-12-01	1995-12-01 00:00:00	1995-12-01	5001	0	\N	0	0	\N	\N	0	286881	0	8331-1	3006322		
9353	884	3020655	1978-11-13	1978-11-13 00:00:00	1978-11-13	5001	0	\N	0	0	\N	\N	0	58857	0	6844-5	3020655		
38197	3526	3051031	2018-07-03	2018-07-03 00:00:00	2018-07-03	5001	0	\N	0	0	\N	\N	0	233978	0	46240-8	3051031		
47765	4376	3011505	2009-12-22	2009-12-22 00:00:00	2009-12-22	5001	0	\N	0	0	\N	\N	0	290821	0	19926-5	3011505		
47193	1439	4052083	2003-07-20	2003-07-20 00:00:00	2003-07-20	5001	0	\N	0	0	\N	\N	0	95880	0	23426006	4052083		
57846	5312	3011505	2005-01-17	2005-01-17 00:00:00	2005-01-17	5001	0	\N	0	0	\N	\N	0	353236	0	19926-5	3011505		
32360	2942	3006322	2002-03-07	2002-03-07 00:00:00	2002-03-07	5001	0	\N	0	0	\N	\N	0	196220	0	8331-1	3006322		
53043	1608	4052083	1952-03-01	1952-03-01 00:00:00	1952-03-01	5001	0	\N	0	0	\N	\N	0	107973	0	23426006	4052083		
81680	2528	4024958	1979-09-10	1979-09-10 00:00:00	1979-09-10	5001	0	\N	0	0	\N	\N	0	167104	0	117015009	4024958		
6464	607	3006322	1986-02-24	1986-02-24 00:00:00	1986-02-24	5001	0	\N	0	0	\N	\N	0	40328	0	8331-1	3006322		
6521	613	3049273	2007-03-07	2007-03-07 00:00:00	2007-03-07	5001	0	\N	0	0	\N	\N	0	40696	0	38265-5	3049273		
21506	1980	3027231	1975-10-10	1975-10-10 00:00:00	1975-10-10	5001	0	\N	0	0	\N	\N	0	131877	0	6276-0	3027231		
21605	1992	3006451	1978-04-17	1978-04-17 00:00:00	1978-04-17	5001	0	\N	0	0	\N	\N	0	132718	0	6273-7	3006451		
103110	3172	4052083	1986-11-21	1986-11-21 00:00:00	1986-11-21	5001	0	\N	0	0	\N	\N	0	210851	0	23426006	4052083		
104689	3222	4052083	1959-04-30	1959-04-30 00:00:00	1959-04-30	5001	0	\N	0	0	\N	\N	0	214136	0	23426006	4052083		
29471	2711	3023430	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	179639	0	6833-8	3023430		
55505	5097	3019406	1996-01-21	1996-01-21 00:00:00	1996-01-21	5001	0	\N	0	0	\N	\N	0	338744	0	6158-0	3019406		
40949	3795	3006322	2007-01-10	2007-01-10 00:00:00	2007-01-10	5001	0	\N	0	0	\N	\N	0	252303	0	8331-1	3006322		
144080	4428	4052083	1985-05-31	1985-05-31 00:00:00	1985-05-31	5001	0	\N	0	0	\N	\N	0	294350	0	23426006	4052083		
30588	2801	3006322	1926-04-30	1926-04-30 00:00:00	1926-04-30	5001	0	\N	0	0	\N	\N	0	185639	0	8331-1	3006322		
6628	621	3006322	1918-09-22	1918-09-22 00:00:00	1918-09-22	5001	0	\N	0	0	\N	\N	0	41360	0	8331-1	3006322		
22190	2034	3006322	1924-03-14	1924-03-14 00:00:00	1924-03-14	5001	0	\N	0	0	\N	\N	0	135422	0	8331-1	3006322		
142467	4376	4133840	1990-09-04	1990-09-04 00:00:00	1990-09-04	5001	0	\N	0	0	\N	\N	0	290800	0	127783003	4133840		
30580	949	4133840	1980-08-25	1980-08-25 00:00:00	1980-08-25	5001	0	\N	0	0	\N	\N	0	63012	0	127783003	4133840		
132009	4067	4024958	1981-06-20	1981-06-20 00:00:00	1981-06-20	5001	0	\N	0	0	\N	\N	0	270250	0	117015009	4024958		
50505	1532	4052083	2006-03-02	2006-03-02 00:00:00	2006-03-02	5001	0	\N	0	0	\N	\N	0	102608	0	23426006	4052083		
52259	4804	3051031	1983-04-19	1983-04-19 00:00:00	1983-04-19	5001	0	\N	0	0	\N	\N	0	319535	0	46240-8	3051031		
3322	320	3011505	2017-03-19	2017-03-19 00:00:00	2017-03-19	5001	0	\N	0	0	\N	\N	0	21219	0	19926-5	3011505		
27839	2566	46235214	2017-08-25	2017-08-25 00:00:00	2017-08-25	5001	0	\N	0	0	\N	\N	0	170004	0	76690-7	46235214		
27911	2566	40766240	2017-05-27	2017-05-27 00:00:00	2017-05-27	5001	0	\N	0	0	\N	\N	0	170003	0	63513-6	40766240		
19520	1783	3012494	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	119524	0	6206-7	3012494		
22855	2088	46235214	1995-10-31	1995-10-31 00:00:00	1995-10-31	5001	0	\N	0	0	\N	\N	0	139293	0	76690-7	46235214		
5706	533	3006322	2002-12-26	2002-12-26 00:00:00	2002-12-26	5001	0	\N	0	0	\N	\N	0	35497	0	8331-1	3006322		
17078	1556	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	104188	0	6246-3	3021226		
75474	2315	4052083	2002-03-31	2002-03-31 00:00:00	2002-03-31	5001	0	\N	0	0	\N	\N	0	153918	0	23426006	4052083		
42507	3926	3011505	2016-07-18	2016-07-18 00:00:00	2016-07-18	5001	0	\N	0	0	\N	\N	0	261005	0	19926-5	3011505		
388	16	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	1277	0	7258-7	3001488		
27502	2543	3006322	1993-11-11	1993-11-11 00:00:00	1993-11-11	5001	0	\N	0	0	\N	\N	0	168252	0	8331-1	3006322		
2407	227	3006322	2008-10-17	2008-10-17 00:00:00	2008-10-17	5001	0	\N	0	0	\N	\N	0	15328	0	8331-1	3006322		
2489	239	3049273	2012-03-01	2012-03-01 00:00:00	2012-03-01	5001	0	\N	0	0	\N	\N	0	16053	0	38265-5	3049273		
20692	1900	3006322	1969-07-09	1969-07-09 00:00:00	1969-07-09	5001	0	\N	0	0	\N	\N	0	126449	0	8331-1	3006322		
123956	3823	4024958	1962-11-02	1962-11-02 00:00:00	1962-11-02	5001	0	\N	0	0	\N	\N	0	253920	0	117015009	4024958		
25243	2320	3006322	1986-09-22	1986-09-22 00:00:00	1986-09-22	5001	0	\N	0	0	\N	\N	0	154281	0	8331-1	3006322		
25323	2328	3006322	1980-01-13	1980-01-13 00:00:00	1980-01-13	5001	0	\N	0	0	\N	\N	0	154816	0	8331-1	3006322		
26315	2419	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	160526	0	6833-8	3023430		
26418	2435	3006322	2010-01-18	2010-01-18 00:00:00	2010-01-18	5001	0	\N	0	0	\N	\N	0	161435	0	8331-1	3006322		
20244	1852	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	123952	0	6082-2	3000876		
5300	507	46235214	1958-01-11	1958-01-11 00:00:00	1958-01-11	5001	0	\N	0	0	\N	\N	0	33947	0	76690-7	46235214		
31715	2898	3012494	1995-07-25	1995-07-25 00:00:00	1995-07-25	5001	0	\N	0	0	\N	\N	0	192974	0	6206-7	3012494		
7440	711	3020630	1967-01-29	1967-01-29 00:00:00	1967-01-29	5001	0	\N	0	0	\N	\N	0	47196	0	2885-2	3020630		
38488	3559	3006322	1955-11-27	1955-11-27 00:00:00	1955-11-27	5001	0	\N	0	0	\N	\N	0	236273	0	8331-1	3006322		
38594	3568	40766240	2004-07-14	2004-07-14 00:00:00	2004-07-14	5001	0	\N	0	0	\N	\N	0	237057	0	63513-6	40766240		
38644	3571	3012494	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	237417	0	6206-7	3012494		
50020	4548	3014599	1996-10-22	1996-10-22 00:00:00	1996-10-22	5001	0	\N	0	0	\N	\N	0	303083	0	6106-9	3014599		
44677	4123	3006322	1967-02-26	1967-02-26 00:00:00	1967-02-26	5001	0	\N	0	0	\N	\N	0	274129	0	8331-1	3006322		
56048	5146	3006322	1972-02-23	1972-02-23 00:00:00	1972-02-23	5001	0	\N	0	0	\N	\N	0	342134	0	8331-1	3006322		
28978	2673	3006322	1979-06-30	1979-06-30 00:00:00	1979-06-30	5001	0	\N	0	0	\N	\N	0	177131	0	8331-1	3006322		
53199	4890	3006322	2000-06-15	2000-06-15 00:00:00	2000-06-15	5001	0	\N	0	0	\N	\N	0	325157	0	8331-1	3006322		
12980	1236	3049273	1994-08-24	1994-08-24 00:00:00	1994-08-24	5001	0	\N	0	0	\N	\N	0	81486	0	38265-5	3049273		
24020	2213	3012494	1991-08-01	1991-08-01 00:00:00	1991-08-01	5001	0	\N	0	0	\N	\N	0	147361	0	6206-7	3012494		
53531	4913	46235214	1971-01-09	1971-01-09 00:00:00	1971-01-09	5001	0	\N	0	0	\N	\N	0	326535	0	76690-7	46235214		
35803	3280	3049273	2011-11-10	2011-11-10 00:00:00	2011-11-10	5001	0	\N	0	0	\N	\N	0	217974	0	38265-5	3049273		
35940	3301	3006322	1949-08-21	1949-08-21 00:00:00	1949-08-21	5001	0	\N	0	0	\N	\N	0	219263	0	8331-1	3006322		
5948	183	4052083	1983-01-26	1983-01-26 00:00:00	1983-01-26	5001	0	\N	0	0	\N	\N	0	12373	0	23426006	4052083		
47017	4325	3006322	1969-01-03	1969-01-03 00:00:00	1969-01-03	5001	0	\N	0	0	\N	\N	0	286884	0	8331-1	3006322		
9354	884	40769184	1981-01-26	1981-01-26 00:00:00	1981-01-26	5001	0	\N	0	0	\N	\N	0	58838	0	66524-0	40769184		
38199	3526	40766240	2018-07-03	2018-07-03 00:00:00	2018-07-03	5001	0	\N	0	0	\N	\N	0	233978	0	63513-6	40766240		
47766	4376	3011505	2010-12-28	2010-12-28 00:00:00	2010-12-28	5001	0	\N	0	0	\N	\N	0	290781	0	19926-5	3011505		
47198	1439	4052083	1979-07-20	1979-07-20 00:00:00	1979-07-20	5001	0	\N	0	0	\N	\N	0	95882	0	23426006	4052083		
57847	5312	3006322	1948-02-14	1948-02-14 00:00:00	1948-02-14	5001	0	\N	0	0	\N	\N	0	353291	0	8331-1	3006322		
32361	2942	3006322	1975-03-03	1975-03-03 00:00:00	1975-03-03	5001	0	\N	0	0	\N	\N	0	196090	0	8331-1	3006322		
53048	1608	4024958	1985-06-01	1985-06-01 00:00:00	1985-06-01	5001	0	\N	0	0	\N	\N	0	107977	0	117015009	4024958		
89	2	3011505	1993-10-19	1993-10-19 00:00:00	1993-10-19	5001	0	\N	0	0	\N	\N	0	185	0	19926-5	3011505		
6465	607	3006322	2009-05-09	2009-05-09 00:00:00	2009-05-09	5001	0	\N	0	0	\N	\N	0	40270	0	8331-1	3006322		
6522	614	3006322	1967-06-16	1967-06-16 00:00:00	1967-06-16	5001	0	\N	0	0	\N	\N	0	40855	0	8331-1	3006322		
21507	1980	3006451	1975-10-10	1975-10-10 00:00:00	1975-10-10	5001	0	\N	0	0	\N	\N	0	131877	0	6273-7	3006451		
21606	1992	3014599	1978-04-17	1978-04-17 00:00:00	1978-04-17	5001	0	\N	0	0	\N	\N	0	132718	0	6106-9	3014599		
103113	3172	4052083	2005-01-23	2005-01-23 00:00:00	2005-01-23	5001	0	\N	0	0	\N	\N	0	210853	0	23426006	4052083		
104698	3222	4052083	1958-08-25	1958-08-25 00:00:00	1958-08-25	5001	0	\N	0	0	\N	\N	0	214213	0	23426006	4052083		
29472	2711	3036780	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	179639	0	6095-4	3036780		
55506	5097	3001247	1996-01-21	1996-01-21 00:00:00	1996-01-21	5001	0	\N	0	0	\N	\N	0	338744	0	6085-5	3001247		
40950	3795	3006322	1994-04-26	1994-04-26 00:00:00	1994-04-26	5001	0	\N	0	0	\N	\N	0	252311	0	8331-1	3006322		
144083	4428	4024958	1966-12-24	1966-12-24 00:00:00	1966-12-24	5001	0	\N	0	0	\N	\N	0	294412	0	117015009	4024958		
30590	2801	3006322	1986-12-04	1986-12-04 00:00:00	1986-12-04	5001	0	\N	0	0	\N	\N	0	185650	0	8331-1	3006322		
6629	621	3051031	1973-04-03	1973-04-03 00:00:00	1973-04-03	5001	0	\N	0	0	\N	\N	0	41474	0	46240-8	3051031		
22191	2034	3006322	1983-09-22	1983-09-22 00:00:00	1983-09-22	5001	0	\N	0	0	\N	\N	0	135412	0	8331-1	3006322		
142474	4376	4133840	1992-09-15	1992-09-15 00:00:00	1992-09-15	5001	0	\N	0	0	\N	\N	0	290801	0	127783003	4133840		
30581	949	4052083	2018-05-06	2018-05-06 00:00:00	2018-05-06	5001	0	\N	0	0	\N	\N	0	63045	0	23426006	4052083		
132014	4067	4024958	2013-07-26	2013-07-26 00:00:00	2013-07-26	5001	0	\N	0	0	\N	\N	0	270207	0	117015009	4024958		
50513	1533	4024958	1974-01-13	1974-01-13 00:00:00	1974-01-13	5001	0	\N	0	0	\N	\N	0	102646	0	117015009	4024958		
52260	4804	40766240	1983-04-19	1983-04-19 00:00:00	1983-04-19	5001	0	\N	0	0	\N	\N	0	319535	0	63513-6	40766240		
3323	320	3011505	2013-02-24	2013-02-24 00:00:00	2013-02-24	5001	0	\N	0	0	\N	\N	0	21194	0	19926-5	3011505		
27840	2566	40758406	2017-08-25	2017-08-25 00:00:00	2017-08-25	5001	0	\N	0	0	\N	\N	0	170004	0	55277-8	40758406		
27914	2566	3051031	2017-05-27	2017-05-27 00:00:00	2017-05-27	5001	0	\N	0	0	\N	\N	0	170003	0	46240-8	3051031		
19521	1783	3001488	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	119524	0	7258-7	3001488		
22856	2088	3011505	2005-07-05	2005-07-05 00:00:00	2005-07-05	5001	0	\N	0	0	\N	\N	0	139241	0	19926-5	3011505		
5707	533	3006322	1984-05-08	1984-05-08 00:00:00	1984-05-08	5001	0	\N	0	0	\N	\N	0	35427	0	8331-1	3006322		
17079	1556	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	104188	0	6248-9	3015076		
75476	2315	4052083	2018-10-30	2018-10-30 00:00:00	2018-10-30	5001	0	\N	0	0	\N	\N	0	153920	0	23426006	4052083		
42508	3926	3011505	2018-07-30	2018-07-30 00:00:00	2018-07-30	5001	0	\N	0	0	\N	\N	0	260935	0	19926-5	3011505		
389	16	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	1277	0	6844-5	3020655		
27503	2543	40766240	1977-04-13	1977-04-13 00:00:00	1977-04-13	5001	0	\N	0	0	\N	\N	0	168278	0	63513-6	40766240		
2408	227	3006322	2010-08-23	2010-08-23 00:00:00	2010-08-23	5001	0	\N	0	0	\N	\N	0	15329	0	8331-1	3006322		
2499	244	3006322	1956-01-11	1956-01-11 00:00:00	1956-01-11	5001	0	\N	0	0	\N	\N	0	16343	0	8331-1	3006322		
20693	1900	3006322	2006-11-29	2006-11-29 00:00:00	2006-11-29	5001	0	\N	0	0	\N	\N	0	126477	0	8331-1	3006322		
123963	3823	4052083	1969-10-25	1969-10-25 00:00:00	1969-10-25	5001	0	\N	0	0	\N	\N	0	253908	0	23426006	4052083		
25244	2320	3006322	1952-11-19	1952-11-19 00:00:00	1952-11-19	5001	0	\N	0	0	\N	\N	0	154285	0	8331-1	3006322		
25324	2328	3006322	1960-12-26	1960-12-26 00:00:00	1960-12-26	5001	0	\N	0	0	\N	\N	0	154813	0	8331-1	3006322		
26316	2419	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	160526	0	6273-7	3006451		
26419	2435	3006322	1978-02-13	1978-02-13 00:00:00	1978-02-13	5001	0	\N	0	0	\N	\N	0	161433	0	8331-1	3006322		
20245	1852	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	123952	0	6075-6	3005136		
5302	507	40758406	1957-12-12	1957-12-12 00:00:00	1957-12-12	5001	0	\N	0	0	\N	\N	0	33976	0	55277-8	40758406		
31716	2898	3021226	1995-07-25	1995-07-25 00:00:00	1995-07-25	5001	0	\N	0	0	\N	\N	0	192974	0	6246-3	3021226		
7441	711	3002385	1967-01-29	1967-01-29 00:00:00	1967-01-29	5001	0	\N	0	0	\N	\N	0	47196	0	30385-9	3002385		
38489	3559	3006322	2017-10-13	2017-10-13 00:00:00	2017-10-13	5001	0	\N	0	0	\N	\N	0	236246	0	8331-1	3006322		
38595	3568	40758406	2004-07-14	2004-07-14 00:00:00	2004-07-14	5001	0	\N	0	0	\N	\N	0	237057	0	55277-8	40758406		
38645	3571	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	237322	0	6833-8	3023430		
50021	4548	3006734	1996-10-22	1996-10-22 00:00:00	1996-10-22	5001	0	\N	0	0	\N	\N	0	303083	0	6189-5	3006734		
44678	4124	3006322	1976-03-08	1976-03-08 00:00:00	1976-03-08	5001	0	\N	0	0	\N	\N	0	274204	0	8331-1	3006322		
156327	4804	4052083	2006-09-16	2006-09-16 00:00:00	2006-09-16	5001	0	\N	0	0	\N	\N	0	319603	0	23426006	4052083		
28979	2673	3006322	1979-12-08	1979-12-08 00:00:00	1979-12-08	5001	0	\N	0	0	\N	\N	0	177132	0	8331-1	3006322		
53200	4890	3006322	2010-06-16	2010-06-16 00:00:00	2010-06-16	5001	0	\N	0	0	\N	\N	0	325190	0	8331-1	3006322		
12981	1236	3006322	1921-07-27	1921-07-27 00:00:00	1921-07-27	5001	0	\N	0	0	\N	\N	0	81420	0	8331-1	3006322		
24021	2213	3021226	1991-08-01	1991-08-01 00:00:00	1991-08-01	5001	0	\N	0	0	\N	\N	0	147361	0	6246-3	3021226		
53532	4913	3006322	1989-11-26	1989-11-26 00:00:00	1989-11-26	5001	0	\N	0	0	\N	\N	0	326522	0	8331-1	3006322		
35804	3280	3006322	1968-12-24	1968-12-24 00:00:00	1968-12-24	5001	0	\N	0	0	\N	\N	0	218031	0	8331-1	3006322		
12149	1155	3006322	1995-10-15	1995-10-15 00:00:00	1995-10-15	5001	0	\N	0	0	\N	\N	0	76315	0	8331-1	3006322		
5962	183	4024958	1978-05-23	1978-05-23 00:00:00	1978-05-23	5001	0	\N	0	0	\N	\N	0	12370	0	117015009	4024958		
47018	4325	3006322	1979-08-01	1979-08-01 00:00:00	1979-08-01	5001	0	\N	0	0	\N	\N	0	286887	0	8331-1	3006322		
9355	884	40769179	1981-01-26	1981-01-26 00:00:00	1981-01-26	5001	0	\N	0	0	\N	\N	0	58838	0	66519-0	40769179		
38200	3526	46235214	2018-07-03	2018-07-03 00:00:00	2018-07-03	5001	0	\N	0	0	\N	\N	0	233978	0	76690-7	46235214		
47767	4376	3006322	2009-01-08	2009-01-08 00:00:00	2009-01-08	5001	0	\N	0	0	\N	\N	0	290784	0	8331-1	3006322		
47201	1439	4052083	2019-05-12	2019-05-12 00:00:00	2019-05-12	5001	0	\N	0	0	\N	\N	0	95907	0	23426006	4052083		
57848	5312	3006322	1961-07-13	1961-07-13 00:00:00	1961-07-13	5001	0	\N	0	0	\N	\N	0	353283	0	8331-1	3006322		
32362	2942	3006322	1961-06-02	1961-06-02 00:00:00	1961-06-02	5001	0	\N	0	0	\N	\N	0	196128	0	8331-1	3006322		
53049	1608	4024958	1960-06-23	1960-06-23 00:00:00	1960-06-23	5001	0	\N	0	0	\N	\N	0	108043	0	117015009	4024958		
90	3	40758406	1993-04-08	1993-04-08 00:00:00	1993-04-08	5001	0	\N	0	0	\N	\N	0	293	0	55277-8	40758406		
33578	1051	4024958	1969-03-21	1969-03-21 00:00:00	1969-03-21	5001	0	\N	0	0	\N	\N	0	68863	0	117015009	4024958		
6523	614	3006322	1984-10-03	1984-10-03 00:00:00	1984-10-03	5001	0	\N	0	0	\N	\N	0	40791	0	8331-1	3006322		
21508	1980	3014599	1975-10-10	1975-10-10 00:00:00	1975-10-10	5001	0	\N	0	0	\N	\N	0	131877	0	6106-9	3014599		
21607	1992	3006322	1985-10-20	1985-10-20 00:00:00	1985-10-20	5001	0	\N	0	0	\N	\N	0	132708	0	8331-1	3006322		
103119	3172	4024958	1985-08-21	1985-08-21 00:00:00	1985-08-21	5001	0	\N	0	0	\N	\N	0	210868	0	117015009	4024958		
104707	3223	4052083	1945-02-12	1945-02-12 00:00:00	1945-02-12	5001	0	\N	0	0	\N	\N	0	214324	0	23426006	4052083		
29473	2711	3014599	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	179639	0	6106-9	3014599		
55507	5097	3012494	1996-01-21	1996-01-21 00:00:00	1996-01-21	5001	0	\N	0	0	\N	\N	0	338744	0	6206-7	3012494		
40951	3795	3006322	1996-11-21	1996-11-21 00:00:00	1996-11-21	5001	0	\N	0	0	\N	\N	0	252326	0	8331-1	3006322		
144089	4428	4052083	1983-08-31	1983-08-31 00:00:00	1983-08-31	5001	0	\N	0	0	\N	\N	0	294349	0	23426006	4052083		
30591	2801	3006322	1945-06-19	1945-06-19 00:00:00	1945-06-19	5001	0	\N	0	0	\N	\N	0	185648	0	8331-1	3006322		
6630	621	40758406	1973-04-03	1973-04-03 00:00:00	1973-04-03	5001	0	\N	0	0	\N	\N	0	41474	0	55277-8	40758406		
22193	2034	3006322	1977-06-01	1977-06-01 00:00:00	1977-06-01	5001	0	\N	0	0	\N	\N	0	135427	0	8331-1	3006322		
6792	211	4024958	1976-07-15	1976-07-15 00:00:00	1976-07-15	5001	0	\N	0	0	\N	\N	0	14374	0	117015009	4024958		
30582	949	4024958	1975-03-01	1975-03-01 00:00:00	1975-03-01	5001	0	\N	0	0	\N	\N	0	63025	0	117015009	4024958		
132015	4067	4024958	1987-01-04	1987-01-04 00:00:00	1987-01-04	5001	0	\N	0	0	\N	\N	0	270203	0	117015009	4024958		
50514	1533	4052083	1983-10-24	1983-10-24 00:00:00	1983-10-24	5001	0	\N	0	0	\N	\N	0	102658	0	23426006	4052083		
52261	4804	46235214	1983-04-19	1983-04-19 00:00:00	1983-04-19	5001	0	\N	0	0	\N	\N	0	319535	0	76690-7	46235214		
3324	320	3011505	2015-03-08	2015-03-08 00:00:00	2015-03-08	5001	0	\N	0	0	\N	\N	0	21218	0	19926-5	3011505		
27842	2566	3051031	2017-08-25	2017-08-25 00:00:00	2017-08-25	5001	0	\N	0	0	\N	\N	0	170004	0	46240-8	3051031		
27916	2566	3051031	2017-04-27	2017-04-27 00:00:00	2017-04-27	5001	0	\N	0	0	\N	\N	0	170040	0	46240-8	3051031		
19522	1783	3001247	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	119524	0	6085-5	3001247		
22859	2090	3006322	1973-10-08	1973-10-08 00:00:00	1973-10-08	5001	0	\N	0	0	\N	\N	0	139386	0	8331-1	3006322		
5708	533	3006322	2015-07-22	2015-07-22 00:00:00	2015-07-22	5001	0	\N	0	0	\N	\N	0	35374	0	8331-1	3006322		
17080	1556	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	104188	0	6095-4	3036780		
75515	2318	4024958	1995-07-17	1995-07-17 00:00:00	1995-07-17	5001	0	\N	0	0	\N	\N	0	154091	0	117015009	4024958		
42509	3926	3011505	1990-10-08	1990-10-08 00:00:00	1990-10-08	5001	0	\N	0	0	\N	\N	0	260999	0	19926-5	3011505		
390	16	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	1277	0	6833-8	3023430		
27506	2543	3051031	1977-04-13	1977-04-13 00:00:00	1977-04-13	5001	0	\N	0	0	\N	\N	0	168278	0	46240-8	3051031		
2409	227	3006322	2006-12-14	2006-12-14 00:00:00	2006-12-14	5001	0	\N	0	0	\N	\N	0	15317	0	8331-1	3006322		
2503	244	3006322	1946-06-05	1946-06-05 00:00:00	1946-06-05	5001	0	\N	0	0	\N	\N	0	16294	0	8331-1	3006322		
20694	1900	3006322	2012-03-12	2012-03-12 00:00:00	2012-03-12	5001	0	\N	0	0	\N	\N	0	126460	0	8331-1	3006322		
66776	2052	4052083	1964-02-24	1964-02-24 00:00:00	1964-02-24	5001	0	\N	0	0	\N	\N	0	136407	0	23426006	4052083		
25245	2320	3006322	1992-11-03	1992-11-03 00:00:00	1992-11-03	5001	0	\N	0	0	\N	\N	0	154243	0	8331-1	3006322		
25325	2328	3006322	2016-07-08	2016-07-08 00:00:00	2016-07-08	5001	0	\N	0	0	\N	\N	0	154871	0	8331-1	3006322		
26317	2419	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	160526	0	6206-7	3012494		
26420	2436	3023430	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	161510	0	6833-8	3023430		
20246	1852	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	123952	0	6246-3	3021226		
5304	507	3051031	1957-12-12	1957-12-12 00:00:00	1957-12-12	5001	0	\N	0	0	\N	\N	0	33976	0	46240-8	3051031		
31717	2898	3001247	1995-07-25	1995-07-25 00:00:00	1995-07-25	5001	0	\N	0	0	\N	\N	0	192974	0	6085-5	3001247		
7442	711	3007461	1967-01-29	1967-01-29 00:00:00	1967-01-29	5001	0	\N	0	0	\N	\N	0	47196	0	26515-7	3007461		
38490	3559	3006322	1959-11-21	1959-11-21 00:00:00	1959-11-21	5001	0	\N	0	0	\N	\N	0	236274	0	8331-1	3006322		
38596	3568	3051031	2004-07-14	2004-07-14 00:00:00	2004-07-14	5001	0	\N	0	0	\N	\N	0	237057	0	46240-8	3051031		
38646	3571	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	237322	0	6095-4	3036780		
50023	4550	3006322	1999-04-01	1999-04-01 00:00:00	1999-04-01	5001	0	\N	0	0	\N	\N	0	303260	0	8331-1	3006322		
44679	4124	3006322	1988-05-30	1988-05-30 00:00:00	1988-05-30	5001	0	\N	0	0	\N	\N	0	274205	0	8331-1	3006322		
156333	4804	4052083	1994-08-07	1994-08-07 00:00:00	1994-08-07	5001	0	\N	0	0	\N	\N	0	319563	0	23426006	4052083		
28980	2673	3006322	2001-03-28	2001-03-28 00:00:00	2001-03-28	5001	0	\N	0	0	\N	\N	0	177072	0	8331-1	3006322		
53201	4890	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	325066	0	6246-3	3021226		
12982	1237	3006322	1948-12-17	1948-12-17 00:00:00	1948-12-17	5001	0	\N	0	0	\N	\N	0	81511	0	8331-1	3006322		
24022	2213	3020655	1991-08-01	1991-08-01 00:00:00	1991-08-01	5001	0	\N	0	0	\N	\N	0	147361	0	6844-5	3020655		
53534	4913	3051031	1970-11-10	1970-11-10 00:00:00	1970-11-10	5001	0	\N	0	0	\N	\N	0	326517	0	46240-8	3051031		
35805	3280	3011505	2017-12-14	2017-12-14 00:00:00	2017-12-14	5001	0	\N	0	0	\N	\N	0	217994	0	19926-5	3011505		
12150	1155	3006322	1980-08-05	1980-08-05 00:00:00	1980-08-05	5001	0	\N	0	0	\N	\N	0	76304	0	8331-1	3006322		
5967	183	4024958	1975-11-22	1975-11-22 00:00:00	1975-11-22	5001	0	\N	0	0	\N	\N	0	12390	0	117015009	4024958		
47022	4328	3006322	1980-05-13	1980-05-13 00:00:00	1980-05-13	5001	0	\N	0	0	\N	\N	0	287013	0	8331-1	3006322		
9356	884	40769189	1981-01-26	1981-01-26 00:00:00	1981-01-26	5001	0	\N	0	0	\N	\N	0	58838	0	66529-9	40769189		
38201	3526	3051031	1991-02-15	1991-02-15 00:00:00	1991-02-15	5001	0	\N	0	0	\N	\N	0	233944	0	46240-8	3051031		
47768	4376	3011505	1990-09-04	1990-09-04 00:00:00	1990-09-04	5001	0	\N	0	0	\N	\N	0	290800	0	19926-5	3011505		
47202	1439	4052083	2006-08-30	2006-08-30 00:00:00	2006-08-30	5001	0	\N	0	0	\N	\N	0	95921	0	23426006	4052083		
57849	5312	3011505	2001-12-31	2001-12-31 00:00:00	2001-12-31	5001	0	\N	0	0	\N	\N	0	353242	0	19926-5	3011505		
32363	2942	3006322	2012-10-18	2012-10-18 00:00:00	2012-10-18	5001	0	\N	0	0	\N	\N	0	196222	0	8331-1	3006322		
53055	1608	4024958	1953-01-12	1953-01-12 00:00:00	1953-01-12	5001	0	\N	0	0	\N	\N	0	108041	0	117015009	4024958		
93	3	46235214	1993-04-08	1993-04-08 00:00:00	1993-04-08	5001	0	\N	0	0	\N	\N	0	293	0	76690-7	46235214		
33580	1051	4024958	1978-06-14	1978-06-14 00:00:00	1978-06-14	5001	0	\N	0	0	\N	\N	0	68854	0	117015009	4024958		
6524	614	3006322	1984-05-26	1984-05-26 00:00:00	1984-05-26	5001	0	\N	0	0	\N	\N	0	40820	0	8331-1	3006322		
21509	1980	3005136	1975-10-10	1975-10-10 00:00:00	1975-10-10	5001	0	\N	0	0	\N	\N	0	131877	0	6075-6	3005136		
21608	1992	3021226	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	132713	0	6246-3	3021226		
103128	3172	4024958	1997-02-15	1997-02-15 00:00:00	1997-02-15	5001	0	\N	0	0	\N	\N	0	210835	0	117015009	4024958		
32995	2980	3015076	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	198939	0	6248-9	3015076		
29474	2711	3021226	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	179639	0	6246-3	3021226		
55508	5097	3036780	1996-01-21	1996-01-21 00:00:00	1996-01-21	5001	0	\N	0	0	\N	\N	0	338744	0	6095-4	3036780		
40952	3795	3006322	2009-10-06	2009-10-06 00:00:00	2009-10-06	5001	0	\N	0	0	\N	\N	0	252312	0	8331-1	3006322		
155373	4763	4024958	1953-04-20	1953-04-20 00:00:00	1953-04-20	5001	0	\N	0	0	\N	\N	0	317426	0	117015009	4024958		
30593	2801	3006322	1990-02-09	1990-02-09 00:00:00	1990-02-09	5001	0	\N	0	0	\N	\N	0	185651	0	8331-1	3006322		
6632	621	46235214	1973-04-03	1973-04-03 00:00:00	1973-04-03	5001	0	\N	0	0	\N	\N	0	41474	0	76690-7	46235214		
22194	2034	3006322	1991-07-28	1991-07-28 00:00:00	1991-07-28	5001	0	\N	0	0	\N	\N	0	135462	0	8331-1	3006322		
6793	212	4024958	1993-12-15	1993-12-15 00:00:00	1993-12-15	5001	0	\N	0	0	\N	\N	0	14468	0	117015009	4024958		
30584	949	4133840	2015-12-14	2015-12-14 00:00:00	2015-12-14	5001	0	\N	0	0	\N	\N	0	63018	0	127783003	4133840		
132237	4071	4052083	1962-09-11	1962-09-11 00:00:00	1962-09-11	5001	0	\N	0	0	\N	\N	0	270609	0	23426006	4052083		
50519	1533	4024958	2015-07-31	2015-07-31 00:00:00	2015-07-31	5001	0	\N	0	0	\N	\N	0	102650	0	117015009	4024958		
52262	4804	40758406	1983-04-19	1983-04-19 00:00:00	1983-04-19	5001	0	\N	0	0	\N	\N	0	319535	0	55277-8	40758406		
3325	320	3006322	1958-10-08	1958-10-08 00:00:00	1958-10-08	5001	0	\N	0	0	\N	\N	0	21221	0	8331-1	3006322		
27843	2566	40766240	2017-08-25	2017-08-25 00:00:00	2017-08-25	5001	0	\N	0	0	\N	\N	0	170004	0	63513-6	40766240		
27917	2566	40758406	2017-04-27	2017-04-27 00:00:00	2017-04-27	5001	0	\N	0	0	\N	\N	0	170040	0	55277-8	40758406		
19523	1783	3014599	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	119524	0	6106-9	3014599		
22860	2090	3006322	2008-07-02	2008-07-02 00:00:00	2008-07-02	5001	0	\N	0	0	\N	\N	0	139389	0	8331-1	3006322		
5709	533	3006322	1999-01-02	1999-01-02 00:00:00	1999-01-02	5001	0	\N	0	0	\N	\N	0	35445	0	8331-1	3006322		
17081	1556	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	104188	0	6075-6	3005136		
41828	1292	4052083	1995-09-16	1995-09-16 00:00:00	1995-09-16	5001	0	\N	0	0	\N	\N	0	85385	0	23426006	4052083		
42510	3926	3011505	2011-03-07	2011-03-07 00:00:00	2011-03-07	5001	0	\N	0	0	\N	\N	0	261004	0	19926-5	3011505		
391	16	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	1277	0	6075-6	3005136		
27507	2543	40758406	1977-04-13	1977-04-13 00:00:00	1977-04-13	5001	0	\N	0	0	\N	\N	0	168278	0	55277-8	40758406		
2410	227	3006322	2003-07-25	2003-07-25 00:00:00	2003-07-25	5001	0	\N	0	0	\N	\N	0	15367	0	8331-1	3006322		
2506	244	3006322	1961-06-24	1961-06-24 00:00:00	1961-06-24	5001	0	\N	0	0	\N	\N	0	16264	0	8331-1	3006322		
20695	1900	3006322	1990-01-16	1990-01-16 00:00:00	1990-01-16	5001	0	\N	0	0	\N	\N	0	126459	0	8331-1	3006322		
66780	2052	4052083	2013-02-02	2013-02-02 00:00:00	2013-02-02	5001	0	\N	0	0	\N	\N	0	136409	0	23426006	4052083		
25246	2320	3006322	1962-07-13	1962-07-13 00:00:00	1962-07-13	5001	0	\N	0	0	\N	\N	0	154242	0	8331-1	3006322		
25326	2328	3006322	2003-09-21	2003-09-21 00:00:00	2003-09-21	5001	0	\N	0	0	\N	\N	0	154856	0	8331-1	3006322		
26318	2419	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	160526	0	6246-3	3021226		
26421	2436	3012494	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	161510	0	6206-7	3012494		
20247	1852	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	123952	0	6206-7	3012494		
5306	507	40766240	1957-12-12	1957-12-12 00:00:00	1957-12-12	5001	0	\N	0	0	\N	\N	0	33976	0	63513-6	40766240		
31718	2898	3001488	1995-07-25	1995-07-25 00:00:00	1995-07-25	5001	0	\N	0	0	\N	\N	0	192974	0	7258-7	3001488		
32107	992	4052083	1956-09-07	1956-09-07 00:00:00	1956-09-07	5001	0	\N	0	0	\N	\N	0	65727	0	23426006	4052083		
38491	3559	3006322	1969-05-11	1969-05-11 00:00:00	1969-05-11	5001	0	\N	0	0	\N	\N	0	236266	0	8331-1	3006322		
38597	3568	3006322	2016-05-21	2016-05-21 00:00:00	2016-05-21	5001	0	\N	0	0	\N	\N	0	237110	0	8331-1	3006322		
38647	3571	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	237322	0	6844-5	3020655		
50024	4550	3006322	1966-10-21	1966-10-21 00:00:00	1966-10-21	5001	0	\N	0	0	\N	\N	0	303157	0	8331-1	3006322		
44680	4124	3006322	1988-12-10	1988-12-10 00:00:00	1988-12-10	5001	0	\N	0	0	\N	\N	0	274193	0	8331-1	3006322		
156397	4805	4052083	1996-03-30	1996-03-30 00:00:00	1996-03-30	5001	0	\N	0	0	\N	\N	0	319672	0	23426006	4052083		
28981	2673	3001488	1982-03-04	1982-03-04 00:00:00	1982-03-04	5001	0	\N	0	0	\N	\N	0	177076	0	7258-7	3001488		
53202	4890	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	325066	0	6248-9	3015076		
12983	1237	3006322	1963-07-09	1963-07-09 00:00:00	1963-07-09	5001	0	\N	0	0	\N	\N	0	81499	0	8331-1	3006322		
24023	2213	3001488	1991-08-01	1991-08-01 00:00:00	1991-08-01	5001	0	\N	0	0	\N	\N	0	147361	0	7258-7	3001488		
53535	4913	40758406	1970-11-10	1970-11-10 00:00:00	1970-11-10	5001	0	\N	0	0	\N	\N	0	326517	0	55277-8	40758406		
35806	3280	3006322	1959-08-04	1959-08-04 00:00:00	1959-08-04	5001	0	\N	0	0	\N	\N	0	218004	0	8331-1	3006322		
12151	1155	3006322	1983-09-28	1983-09-28 00:00:00	1983-09-28	5001	0	\N	0	0	\N	\N	0	76301	0	8331-1	3006322		
6089	187	4024958	1951-12-22	1951-12-22 00:00:00	1951-12-22	5001	0	\N	0	0	\N	\N	0	12693	0	117015009	4024958		
47023	4328	3006322	1990-03-01	1990-03-01 00:00:00	1990-03-01	5001	0	\N	0	0	\N	\N	0	287014	0	8331-1	3006322		
9357	884	40769194	1981-01-26	1981-01-26 00:00:00	1981-01-26	5001	0	\N	0	0	\N	\N	0	58838	0	66534-9	40769194		
38203	3526	40758406	1991-02-15	1991-02-15 00:00:00	1991-02-15	5001	0	\N	0	0	\N	\N	0	233944	0	55277-8	40758406		
47769	4376	3011505	2005-11-29	2005-11-29 00:00:00	2005-11-29	5001	0	\N	0	0	\N	\N	0	290838	0	19926-5	3011505		
58535	1781	4024958	1961-11-03	1961-11-03 00:00:00	1961-11-03	5001	0	\N	0	0	\N	\N	0	119256	0	117015009	4024958		
57850	5312	3011505	1988-10-31	1988-10-31 00:00:00	1988-10-31	5001	0	\N	0	0	\N	\N	0	353265	0	19926-5	3011505		
32364	2942	3006322	2015-09-17	2015-09-17 00:00:00	2015-09-17	5001	0	\N	0	0	\N	\N	0	196115	0	8331-1	3006322		
53058	1608	4024958	1960-01-16	1960-01-16 00:00:00	1960-01-16	5001	0	\N	0	0	\N	\N	0	107966	0	117015009	4024958		
94	3	40766240	1993-04-08	1993-04-08 00:00:00	1993-04-08	5001	0	\N	0	0	\N	\N	0	293	0	63513-6	40766240		
33583	1051	4024958	1975-10-15	1975-10-15 00:00:00	1975-10-15	5001	0	\N	0	0	\N	\N	0	68861	0	117015009	4024958		
6525	615	3049273	1995-01-29	1995-01-29 00:00:00	1995-01-29	5001	0	\N	0	0	\N	\N	0	41044	0	38265-5	3049273		
21510	1980	3001488	1975-10-10	1975-10-10 00:00:00	1975-10-10	5001	0	\N	0	0	\N	\N	0	131877	0	7258-7	3001488		
21609	1992	3019406	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	132713	0	6158-0	3019406		
21636	1999	3001488	2011-10-05	2011-10-05 00:00:00	2011-10-05	5001	0	\N	0	0	\N	\N	0	133114	0	7258-7	3001488		
32996	2980	3012494	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	198939	0	6206-7	3012494		
29475	2711	3006322	2008-02-21	2008-02-21 00:00:00	2008-02-21	5001	0	\N	0	0	\N	\N	0	179730	0	8331-1	3006322		
55509	5097	3027231	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	338637	0	6276-0	3027231		
12159	392	4024958	1997-01-06	1997-01-06 00:00:00	1997-01-06	5001	0	\N	0	0	\N	\N	0	25741	0	117015009	4024958		
155391	4763	4052083	2003-08-15	2003-08-15 00:00:00	2003-08-15	5001	0	\N	0	0	\N	\N	0	317418	0	23426006	4052083		
30594	2801	3006322	1988-11-07	1988-11-07 00:00:00	1988-11-07	5001	0	\N	0	0	\N	\N	0	185581	0	8331-1	3006322		
6634	621	40766240	1973-04-03	1973-04-03 00:00:00	1973-04-03	5001	0	\N	0	0	\N	\N	0	41474	0	63513-6	40766240		
33475	3026	3006322	1984-02-06	1984-02-06 00:00:00	1984-02-06	5001	0	\N	0	0	\N	\N	0	201739	0	8331-1	3006322		
18107	569	4052083	1964-05-21	1964-05-21 00:00:00	1964-05-21	5001	0	\N	0	0	\N	\N	0	37694	0	23426006	4052083		
30586	949	4133840	2017-12-25	2017-12-25 00:00:00	2017-12-25	5001	0	\N	0	0	\N	\N	0	63019	0	127783003	4133840		
132252	4071	4024958	2014-01-08	2014-01-08 00:00:00	2014-01-08	5001	0	\N	0	0	\N	\N	0	270628	0	117015009	4024958		
50539	1535	4024958	1999-10-19	1999-10-19 00:00:00	1999-10-19	5001	0	\N	0	0	\N	\N	0	102739	0	117015009	4024958		
52265	4804	40758406	1983-09-16	1983-09-16 00:00:00	1983-09-16	5001	0	\N	0	0	\N	\N	0	319633	0	55277-8	40758406		
108203	3342	4052083	1952-11-13	1952-11-13 00:00:00	1952-11-13	5001	0	\N	0	0	\N	\N	0	221666	0	23426006	4052083		
27845	2566	3006322	1947-10-24	1947-10-24 00:00:00	1947-10-24	5001	0	\N	0	0	\N	\N	0	170007	0	8331-1	3006322		
27918	2566	46235214	2017-04-27	2017-04-27 00:00:00	2017-04-27	5001	0	\N	0	0	\N	\N	0	170040	0	76690-7	46235214		
19524	1783	3005136	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	119524	0	6075-6	3005136		
22861	2090	3006322	2006-04-30	2006-04-30 00:00:00	2006-04-30	5001	0	\N	0	0	\N	\N	0	139388	0	8331-1	3006322		
5710	534	3006322	2005-11-04	2005-11-04 00:00:00	2005-11-04	5001	0	\N	0	0	\N	\N	0	35570	0	8331-1	3006322		
17082	1556	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	104188	0	6106-9	3014599		
41860	1292	4024958	1965-10-09	1965-10-09 00:00:00	1965-10-09	5001	0	\N	0	0	\N	\N	0	85425	0	117015009	4024958		
42511	3926	3011505	2000-11-13	2000-11-13 00:00:00	2000-11-13	5001	0	\N	0	0	\N	\N	0	261001	0	19926-5	3011505		
392	16	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	1277	0	6248-9	3015076		
27508	2543	46235214	1977-04-13	1977-04-13 00:00:00	1977-04-13	5001	0	\N	0	0	\N	\N	0	168278	0	76690-7	46235214		
2411	227	3006322	1999-08-07	1999-08-07 00:00:00	1999-08-07	5001	0	\N	0	0	\N	\N	0	15316	0	8331-1	3006322		
167434	5142	4024958	1947-06-10	1947-06-10 00:00:00	1947-06-10	5001	0	\N	0	0	\N	\N	0	341704	0	117015009	4024958		
20697	1902	3006322	2019-03-07	2019-03-07 00:00:00	2019-03-07	5001	0	\N	0	0	\N	\N	0	126594	0	8331-1	3006322		
66796	2053	4024958	1958-01-19	1958-01-19 00:00:00	1958-01-19	5001	0	\N	0	0	\N	\N	0	136555	0	117015009	4024958		
25247	2320	3006322	1997-01-19	1997-01-19 00:00:00	1997-01-19	5001	0	\N	0	0	\N	\N	0	154283	0	8331-1	3006322		
25327	2329	3006322	1996-04-01	1996-04-01 00:00:00	1996-04-01	5001	0	\N	0	0	\N	\N	0	154939	0	8331-1	3006322		
26319	2419	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	160526	0	6075-6	3005136		
26422	2436	3001488	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	161510	0	7258-7	3001488		
20248	1852	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	123952	0	6085-5	3001247		
5307	507	46235214	1957-12-12	1957-12-12 00:00:00	1957-12-12	5001	0	\N	0	0	\N	\N	0	33976	0	76690-7	46235214		
31719	2898	3000876	1995-07-25	1995-07-25 00:00:00	1995-07-25	5001	0	\N	0	0	\N	\N	0	192974	0	6082-2	3000876		
32113	992	4052083	1987-07-01	1987-07-01 00:00:00	1987-07-01	5001	0	\N	0	0	\N	\N	0	65771	0	23426006	4052083		
38492	3560	3006322	1985-04-27	1985-04-27 00:00:00	1985-04-27	5001	0	\N	0	0	\N	\N	0	236354	0	8331-1	3006322		
38599	3568	46235214	1971-01-24	1971-01-24 00:00:00	1971-01-24	5001	0	\N	0	0	\N	\N	0	237087	0	76690-7	46235214		
38648	3571	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	237322	0	7258-7	3001488		
50025	4550	3005136	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	303229	0	6075-6	3005136		
44681	4124	3006322	1980-05-30	1980-05-30 00:00:00	1980-05-30	5001	0	\N	0	0	\N	\N	0	274173	0	8331-1	3006322		
28895	2669	3051031	1978-04-07	1978-04-07 00:00:00	1978-04-07	5001	0	\N	0	0	\N	\N	0	176810	0	46240-8	3051031		
28982	2673	3000876	1982-03-04	1982-03-04 00:00:00	1982-03-04	5001	0	\N	0	0	\N	\N	0	177076	0	6082-2	3000876		
53203	4890	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	325066	0	6106-9	3014599		
12984	1237	3011505	1989-04-23	1989-04-23 00:00:00	1989-04-23	5001	0	\N	0	0	\N	\N	0	81500	0	19926-5	3011505		
24024	2213	3000876	1991-08-01	1991-08-01 00:00:00	1991-08-01	5001	0	\N	0	0	\N	\N	0	147361	0	6082-2	3000876		
53537	4913	40766240	1970-11-10	1970-11-10 00:00:00	1970-11-10	5001	0	\N	0	0	\N	\N	0	326517	0	63513-6	40766240		
35810	3283	3006322	2004-03-30	2004-03-30 00:00:00	2004-03-30	5001	0	\N	0	0	\N	\N	0	218140	0	8331-1	3006322		
12152	1155	3006322	1996-08-25	1996-08-25 00:00:00	1996-08-25	5001	0	\N	0	0	\N	\N	0	76316	0	8331-1	3006322		
6098	187	4052083	1999-07-27	1999-07-27 00:00:00	1999-07-27	5001	0	\N	0	0	\N	\N	0	12745	0	23426006	4052083		
4345	133	4052083	2010-08-11	2010-08-11 00:00:00	2010-08-11	5001	0	\N	0	0	\N	\N	0	8959	0	23426006	4052083		
9358	884	3000876	1990-09-11	1990-09-11 00:00:00	1990-09-11	5001	0	\N	0	0	\N	\N	0	58941	0	6082-2	3000876		
38204	3526	40766240	1991-02-15	1991-02-15 00:00:00	1991-02-15	5001	0	\N	0	0	\N	\N	0	233944	0	63513-6	40766240		
47770	4376	3011505	2006-12-05	2006-12-05 00:00:00	2006-12-05	5001	0	\N	0	0	\N	\N	0	290707	0	19926-5	3011505		
129335	3982	4052083	1942-03-06	1942-03-06 00:00:00	1942-03-06	5001	0	\N	0	0	\N	\N	0	264646	0	23426006	4052083		
57851	5312	3006322	1951-11-22	1951-11-22 00:00:00	1951-11-22	5001	0	\N	0	0	\N	\N	0	353247	0	8331-1	3006322		
32365	2942	3006322	1960-11-21	1960-11-21 00:00:00	1960-11-21	5001	0	\N	0	0	\N	\N	0	196127	0	8331-1	3006322		
40419	1257	4024958	1973-05-29	1973-05-29 00:00:00	1973-05-29	5001	0	\N	0	0	\N	\N	0	82802	0	117015009	4024958		
95	3	3051031	1993-04-08	1993-04-08 00:00:00	1993-04-08	5001	0	\N	0	0	\N	\N	0	293	0	46240-8	3051031		
33586	1051	4024958	1973-09-08	1973-09-08 00:00:00	1973-09-08	5001	0	\N	0	0	\N	\N	0	68865	0	117015009	4024958		
6526	615	3006322	1987-11-17	1987-11-17 00:00:00	1987-11-17	5001	0	\N	0	0	\N	\N	0	40914	0	8331-1	3006322		
21511	1980	3027231	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	131768	0	6276-0	3027231		
21610	1992	3015076	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	132713	0	6248-9	3015076		
21637	1999	3020655	2011-10-05	2011-10-05 00:00:00	2011-10-05	5001	0	\N	0	0	\N	\N	0	133114	0	6844-5	3020655		
32997	2980	3023430	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	198939	0	6833-8	3023430		
29476	2712	3006322	2008-01-25	2008-01-25 00:00:00	2008-01-25	5001	0	\N	0	0	\N	\N	0	179821	0	8331-1	3006322		
55510	5097	3020655	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	338637	0	6844-5	3020655		
12162	392	4052083	1979-02-14	1979-02-14 00:00:00	1979-02-14	5001	0	\N	0	0	\N	\N	0	25716	0	23426006	4052083		
155400	4763	4024958	1950-10-22	1950-10-22 00:00:00	1950-10-22	5001	0	\N	0	0	\N	\N	0	317403	0	117015009	4024958		
30596	2801	3049273	2002-03-25	2002-03-25 00:00:00	2002-03-25	5001	0	\N	0	0	\N	\N	0	185617	0	38265-5	3049273		
6635	621	3006322	1926-02-09	1926-02-09 00:00:00	1926-02-09	5001	0	\N	0	0	\N	\N	0	41446	0	8331-1	3006322		
33476	3026	3006322	1996-05-10	1996-05-10 00:00:00	1996-05-10	5001	0	\N	0	0	\N	\N	0	201775	0	8331-1	3006322		
18117	569	4024958	1923-05-15	1923-05-15 00:00:00	1923-05-15	5001	0	\N	0	0	\N	\N	0	37664	0	117015009	4024958		
30590	949	4133840	2009-11-09	2009-11-09 00:00:00	2009-11-09	5001	0	\N	0	0	\N	\N	0	63041	0	127783003	4133840		
43481	1338	4052083	2004-10-22	2004-10-22 00:00:00	2004-10-22	5001	0	\N	0	0	\N	\N	0	88691	0	23426006	4052083		
50544	1535	4024958	2012-07-06	2012-07-06 00:00:00	2012-07-06	5001	0	\N	0	0	\N	\N	0	102761	0	117015009	4024958		
52268	4804	40766240	1983-09-16	1983-09-16 00:00:00	1983-09-16	5001	0	\N	0	0	\N	\N	0	319633	0	63513-6	40766240		
7460	236	4024958	1981-11-22	1981-11-22 00:00:00	1981-11-22	5001	0	\N	0	0	\N	\N	0	15925	0	117015009	4024958		
27847	2566	3051031	2016-01-03	2016-01-03 00:00:00	2016-01-03	5001	0	\N	0	0	\N	\N	0	170026	0	46240-8	3051031		
27919	2566	40766240	2017-04-27	2017-04-27 00:00:00	2017-04-27	5001	0	\N	0	0	\N	\N	0	170040	0	63513-6	40766240		
19525	1783	3021226	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	119524	0	6246-3	3021226		
22862	2090	3006322	1972-04-03	1972-04-03 00:00:00	1972-04-03	5001	0	\N	0	0	\N	\N	0	139353	0	8331-1	3006322		
5711	534	3006322	1993-10-31	1993-10-31 00:00:00	1993-10-31	5001	0	\N	0	0	\N	\N	0	35513	0	8331-1	3006322		
17083	1556	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	104188	0	6833-8	3023430		
41862	1292	4024958	1961-07-21	1961-07-21 00:00:00	1961-07-21	5001	0	\N	0	0	\N	\N	0	85381	0	117015009	4024958		
42512	3926	3011505	2004-12-06	2004-12-06 00:00:00	2004-12-06	5001	0	\N	0	0	\N	\N	0	261003	0	19926-5	3011505		
393	16	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	1277	0	6276-0	3027231		
27510	2543	3051031	1977-01-13	1977-01-13 00:00:00	1977-01-13	5001	0	\N	0	0	\N	\N	0	168236	0	46240-8	3051031		
2426	232	3006322	1945-10-29	1945-10-29 00:00:00	1945-10-29	5001	0	\N	0	0	\N	\N	0	15538	0	8331-1	3006322		
167447	5142	4024958	1973-08-06	1973-08-06 00:00:00	1973-08-06	5001	0	\N	0	0	\N	\N	0	341768	0	117015009	4024958		
20698	1902	3006322	1960-11-14	1960-11-14 00:00:00	1960-11-14	5001	0	\N	0	0	\N	\N	0	126635	0	8331-1	3006322		
66797	2053	4024958	1966-03-16	1966-03-16 00:00:00	1966-03-16	5001	0	\N	0	0	\N	\N	0	136514	0	117015009	4024958		
25248	2320	3006322	1950-02-18	1950-02-18 00:00:00	1950-02-18	5001	0	\N	0	0	\N	\N	0	154314	0	8331-1	3006322		
25328	2329	3006322	1977-03-14	1977-03-14 00:00:00	1977-03-14	5001	0	\N	0	0	\N	\N	0	154922	0	8331-1	3006322		
26320	2419	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	160526	0	6106-9	3014599		
26423	2436	3006734	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	161510	0	6189-5	3006734		
20249	1852	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	123952	0	6833-8	3023430		
5308	507	3006322	1949-01-27	1949-01-27 00:00:00	1949-01-27	5001	0	\N	0	0	\N	\N	0	33946	0	8331-1	3006322		
31720	2898	3036780	1995-07-25	1995-07-25 00:00:00	1995-07-25	5001	0	\N	0	0	\N	\N	0	192974	0	6095-4	3036780		
32145	994	4024958	2007-02-06	2007-02-06 00:00:00	2007-02-06	5001	0	\N	0	0	\N	\N	0	65892	0	117015009	4024958		
38493	3560	3006322	1999-06-11	1999-06-11 00:00:00	1999-06-11	5001	0	\N	0	0	\N	\N	0	236385	0	8331-1	3006322		
38601	3568	40766240	1971-01-24	1971-01-24 00:00:00	1971-01-24	5001	0	\N	0	0	\N	\N	0	237087	0	63513-6	40766240		
38649	3571	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	237322	0	6085-5	3001247		
50026	4550	3015076	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	303229	0	6248-9	3015076		
44682	4124	3006322	2002-06-11	2002-06-11 00:00:00	2002-06-11	5001	0	\N	0	0	\N	\N	0	274177	0	8331-1	3006322		
28896	2669	3006322	2008-01-05	2008-01-05 00:00:00	2008-01-05	5001	0	\N	0	0	\N	\N	0	176814	0	8331-1	3006322		
28983	2673	3019406	1982-03-04	1982-03-04 00:00:00	1982-03-04	5001	0	\N	0	0	\N	\N	0	177076	0	6158-0	3019406		
53204	4890	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	325066	0	6273-7	3006451		
12985	1237	3006322	1956-05-04	1956-05-04 00:00:00	1956-05-04	5001	0	\N	0	0	\N	\N	0	81498	0	8331-1	3006322		
24025	2213	3036780	1991-08-01	1991-08-01 00:00:00	1991-08-01	5001	0	\N	0	0	\N	\N	0	147361	0	6095-4	3036780		
53538	4913	46235214	1970-11-10	1970-11-10 00:00:00	1970-11-10	5001	0	\N	0	0	\N	\N	0	326517	0	76690-7	46235214		
35813	3285	3006322	1995-09-21	1995-09-21 00:00:00	1995-09-21	5001	0	\N	0	0	\N	\N	0	218230	0	8331-1	3006322		
12153	1155	3006322	2016-01-03	2016-01-03 00:00:00	2016-01-03	5001	0	\N	0	0	\N	\N	0	76377	0	8331-1	3006322		
6111	187	4024958	2006-12-22	2006-12-22 00:00:00	2006-12-22	5001	0	\N	0	0	\N	\N	0	12670	0	117015009	4024958		
4375	135	4024958	1973-07-07	1973-07-07 00:00:00	1973-07-07	5001	0	\N	0	0	\N	\N	0	9080	0	117015009	4024958		
9359	884	3023430	1990-09-11	1990-09-11 00:00:00	1990-09-11	5001	0	\N	0	0	\N	\N	0	58941	0	6833-8	3023430		
38205	3526	46235214	1991-02-15	1991-02-15 00:00:00	1991-02-15	5001	0	\N	0	0	\N	\N	0	233944	0	76690-7	46235214		
47771	4376	3049273	1989-05-05	1989-05-05 00:00:00	1989-05-05	5001	0	\N	0	0	\N	\N	0	290733	0	38265-5	3049273		
129340	3982	4024958	1950-04-13	1950-04-13 00:00:00	1950-04-13	5001	0	\N	0	0	\N	\N	0	264652	0	117015009	4024958		
57852	5312	3006322	1950-07-16	1950-07-16 00:00:00	1950-07-16	5001	0	\N	0	0	\N	\N	0	353292	0	8331-1	3006322		
32366	2942	3006322	2003-01-13	2003-01-13 00:00:00	2003-01-13	5001	0	\N	0	0	\N	\N	0	196221	0	8331-1	3006322		
40437	1258	4052083	1994-06-06	1994-06-06 00:00:00	1994-06-06	5001	0	\N	0	0	\N	\N	0	82875	0	23426006	4052083		
96	3	40766240	1994-02-02	1994-02-02 00:00:00	1994-02-02	5001	0	\N	0	0	\N	\N	0	351	0	63513-6	40766240		
33606	1051	4052083	2010-03-11	2010-03-11 00:00:00	2010-03-11	5001	0	\N	0	0	\N	\N	0	68943	0	23426006	4052083		
6527	615	3049273	2000-09-09	2000-09-09 00:00:00	2000-09-09	5001	0	\N	0	0	\N	\N	0	40882	0	38265-5	3049273		
21512	1980	3006451	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	131768	0	6273-7	3006451		
21611	1992	3012494	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	132713	0	6206-7	3012494		
21638	1999	3023430	2011-10-05	2011-10-05 00:00:00	2011-10-05	5001	0	\N	0	0	\N	\N	0	133114	0	6833-8	3023430		
32998	2980	3001247	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	198939	0	6085-5	3001247		
29477	2712	3006322	1998-04-04	1998-04-04 00:00:00	1998-04-04	5001	0	\N	0	0	\N	\N	0	179820	0	8331-1	3006322		
55511	5097	3000876	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	338637	0	6082-2	3000876		
12167	392	4052083	2019-01-31	2019-01-31 00:00:00	2019-01-31	5001	0	\N	0	0	\N	\N	0	25718	0	23426006	4052083		
155411	4764	4052083	1998-07-17	1998-07-17 00:00:00	1998-07-17	5001	0	\N	0	0	\N	\N	0	317484	0	23426006	4052083		
30597	2801	3006322	1939-05-11	1939-05-11 00:00:00	1939-05-11	5001	0	\N	0	0	\N	\N	0	185592	0	8331-1	3006322		
6636	621	3006322	1939-11-17	1939-11-17 00:00:00	1939-11-17	5001	0	\N	0	0	\N	\N	0	41470	0	8331-1	3006322		
33477	3026	3049273	2017-05-11	2017-05-11 00:00:00	2017-05-11	5001	0	\N	0	0	\N	\N	0	201729	0	38265-5	3049273		
18126	569	4024958	1922-01-07	1922-01-07 00:00:00	1922-01-07	5001	0	\N	0	0	\N	\N	0	37690	0	117015009	4024958		
30592	949	4133840	1990-03-19	1990-03-19 00:00:00	1990-03-19	5001	0	\N	0	0	\N	\N	0	63036	0	127783003	4133840		
54795	1659	4024958	1977-09-13	1977-09-13 00:00:00	1977-09-13	5001	0	\N	0	0	\N	\N	0	111557	0	117015009	4024958		
50546	1535	4024958	2015-10-31	2015-10-31 00:00:00	2015-10-31	5001	0	\N	0	0	\N	\N	0	102762	0	117015009	4024958		
5395	163	4024958	2010-07-05	2010-07-05 00:00:00	2010-07-05	5001	0	\N	0	0	\N	\N	0	11198	0	117015009	4024958		
7461	236	4052083	1985-05-02	1985-05-02 00:00:00	1985-05-02	5001	0	\N	0	0	\N	\N	0	15881	0	23426006	4052083		
27848	2566	40758406	2016-01-03	2016-01-03 00:00:00	2016-01-03	5001	0	\N	0	0	\N	\N	0	170026	0	55277-8	40758406		
27921	2566	3049273	2015-11-22	2015-11-22 00:00:00	2015-11-22	5001	0	\N	0	0	\N	\N	0	169984	0	38265-5	3049273		
19526	1783	3019406	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	119524	0	6158-0	3019406		
22863	2091	3006322	1997-04-27	1997-04-27 00:00:00	1997-04-27	5001	0	\N	0	0	\N	\N	0	139423	0	8331-1	3006322		
17006	1550	3011505	2019-01-12	2019-01-12 00:00:00	2019-01-12	5001	0	\N	0	0	\N	\N	0	103791	0	19926-5	3011505		
17084	1556	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	104188	0	6189-5	3006734		
41886	1293	4052083	2014-10-24	2014-10-24 00:00:00	2014-10-24	5001	0	\N	0	0	\N	\N	0	85462	0	23426006	4052083		
42513	3926	3011505	2006-02-06	2006-02-06 00:00:00	2006-02-06	5001	0	\N	0	0	\N	\N	0	260932	0	19926-5	3011505		
394	16	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	1277	0	6106-9	3014599		
27511	2543	40758406	1977-01-13	1977-01-13 00:00:00	1977-01-13	5001	0	\N	0	0	\N	\N	0	168236	0	55277-8	40758406		
2427	232	3006322	2018-11-23	2018-11-23 00:00:00	2018-11-23	5001	0	\N	0	0	\N	\N	0	15626	0	8331-1	3006322		
167472	5142	4052083	1999-03-30	1999-03-30 00:00:00	1999-03-30	5001	0	\N	0	0	\N	\N	0	341726	0	23426006	4052083		
20699	1902	3006322	1981-10-09	1981-10-09 00:00:00	1981-10-09	5001	0	\N	0	0	\N	\N	0	126590	0	8331-1	3006322		
66801	2053	4024958	1971-02-27	1971-02-27 00:00:00	1971-02-27	5001	0	\N	0	0	\N	\N	0	136515	0	117015009	4024958		
25303	2325	3006322	2004-07-31	2004-07-31 00:00:00	2004-07-31	5001	0	\N	0	0	\N	\N	0	154604	0	8331-1	3006322		
25329	2329	3006322	2012-09-13	2012-09-13 00:00:00	2012-09-13	5001	0	\N	0	0	\N	\N	0	154932	0	8331-1	3006322		
26321	2419	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	160526	0	6085-5	3001247		
26424	2436	3021226	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	161510	0	6246-3	3021226		
20250	1852	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	123952	0	6158-0	3019406		
5312	507	40766240	1958-02-10	1958-02-10 00:00:00	1958-02-10	5001	0	\N	0	0	\N	\N	0	33965	0	63513-6	40766240		
31721	2898	3006734	1995-07-25	1995-07-25 00:00:00	1995-07-25	5001	0	\N	0	0	\N	\N	0	192974	0	6189-5	3006734		
32154	994	4024958	1961-07-12	1961-07-12 00:00:00	1961-07-12	5001	0	\N	0	0	\N	\N	0	65906	0	117015009	4024958		
38494	3560	3006322	1994-05-22	1994-05-22 00:00:00	1994-05-22	5001	0	\N	0	0	\N	\N	0	236370	0	8331-1	3006322		
38602	3568	40758406	1971-01-24	1971-01-24 00:00:00	1971-01-24	5001	0	\N	0	0	\N	\N	0	237087	0	55277-8	40758406		
38650	3571	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	237322	0	6189-5	3006734		
50027	4550	3012494	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	303229	0	6206-7	3012494		
44683	4125	3006322	2007-02-02	2007-02-02 00:00:00	2007-02-02	5001	0	\N	0	0	\N	\N	0	274218	0	8331-1	3006322		
28897	2669	3006322	2000-02-21	2000-02-21 00:00:00	2000-02-21	5001	0	\N	0	0	\N	\N	0	176802	0	8331-1	3006322		
28984	2673	3005136	1982-03-04	1982-03-04 00:00:00	1982-03-04	5001	0	\N	0	0	\N	\N	0	177076	0	6075-6	3005136		
53205	4890	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	325066	0	6276-0	3027231		
12986	1237	3006322	1967-09-28	1967-09-28 00:00:00	1967-09-28	5001	0	\N	0	0	\N	\N	0	81544	0	8331-1	3006322		
24026	2213	3005136	1991-08-01	1991-08-01 00:00:00	1991-08-01	5001	0	\N	0	0	\N	\N	0	147361	0	6075-6	3005136		
53539	4913	3006322	2007-04-18	2007-04-18 00:00:00	2007-04-18	5001	0	\N	0	0	\N	\N	0	326523	0	8331-1	3006322		
35814	3285	3006322	1978-11-13	1978-11-13 00:00:00	1978-11-13	5001	0	\N	0	0	\N	\N	0	218211	0	8331-1	3006322		
12160	1158	3006322	2003-06-28	2003-06-28 00:00:00	2003-06-28	5001	0	\N	0	0	\N	\N	0	76489	0	8331-1	3006322		
6113	187	4052083	1965-10-07	1965-10-07 00:00:00	1965-10-07	5001	0	\N	0	0	\N	\N	0	12701	0	23426006	4052083		
4378	135	4052083	2016-05-15	2016-05-15 00:00:00	2016-05-15	5001	0	\N	0	0	\N	\N	0	9034	0	23426006	4052083		
9360	884	3005136	1990-09-11	1990-09-11 00:00:00	1990-09-11	5001	0	\N	0	0	\N	\N	0	58941	0	6075-6	3005136		
38207	3526	3006322	1990-10-07	1990-10-07 00:00:00	1990-10-07	5001	0	\N	0	0	\N	\N	0	233953	0	8331-1	3006322		
47772	4376	3006322	1971-09-27	1971-09-27 00:00:00	1971-09-27	5001	0	\N	0	0	\N	\N	0	290737	0	8331-1	3006322		
129342	3982	4052083	1940-08-03	1940-08-03 00:00:00	1940-08-03	5001	0	\N	0	0	\N	\N	0	264708	0	23426006	4052083		
57853	5312	3011505	1994-12-05	1994-12-05 00:00:00	1994-12-05	5001	0	\N	0	0	\N	\N	0	353245	0	19926-5	3011505		
32367	2942	3006322	1978-08-28	1978-08-28 00:00:00	1978-08-28	5001	0	\N	0	0	\N	\N	0	196108	0	8331-1	3006322		
40439	1258	4052083	2004-07-11	2004-07-11 00:00:00	2004-07-11	5001	0	\N	0	0	\N	\N	0	82861	0	23426006	4052083		
97	3	3051031	1994-02-02	1994-02-02 00:00:00	1994-02-02	5001	0	\N	0	0	\N	\N	0	351	0	46240-8	3051031		
107754	3325	4024958	1964-06-12	1964-06-12 00:00:00	1964-06-12	5001	0	\N	0	0	\N	\N	0	220742	0	117015009	4024958		
6528	615	3006322	1942-07-22	1942-07-22 00:00:00	1942-07-22	5001	0	\N	0	0	\N	\N	0	40865	0	8331-1	3006322		
21513	1980	3014599	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	131768	0	6106-9	3014599		
21612	1992	3006734	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	132713	0	6189-5	3006734		
21639	1999	3005136	2011-10-05	2011-10-05 00:00:00	2011-10-05	5001	0	\N	0	0	\N	\N	0	133114	0	6075-6	3005136		
32999	2980	3006734	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	198939	0	6189-5	3006734		
29482	2715	3006322	1974-10-01	1974-10-01 00:00:00	1974-10-01	5001	0	\N	0	0	\N	\N	0	180003	0	8331-1	3006322		
55512	5097	3019406	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	338637	0	6158-0	3019406		
23478	736	4024958	1977-10-17	1977-10-17 00:00:00	1977-10-17	5001	0	\N	0	0	\N	\N	0	48777	0	117015009	4024958		
29792	919	4024958	1986-08-24	1986-08-24 00:00:00	1986-08-24	5001	0	\N	0	0	\N	\N	0	61249	0	117015009	4024958		
30598	2801	3006322	1979-02-05	1979-02-05 00:00:00	1979-02-05	5001	0	\N	0	0	\N	\N	0	185574	0	8331-1	3006322		
6637	621	3051031	1973-02-02	1973-02-02 00:00:00	1973-02-02	5001	0	\N	0	0	\N	\N	0	41475	0	46240-8	3051031		
33478	3026	3006322	1987-09-04	1987-09-04 00:00:00	1987-09-04	5001	0	\N	0	0	\N	\N	0	201766	0	8331-1	3006322		
18129	569	4052083	1912-10-25	1912-10-25 00:00:00	1912-10-25	5001	0	\N	0	0	\N	\N	0	37689	0	23426006	4052083		
30598	949	4133840	1983-08-29	1983-08-29 00:00:00	1983-08-29	5001	0	\N	0	0	\N	\N	0	62997	0	127783003	4133840		
32278	1000	4024958	1995-12-16	1995-12-16 00:00:00	1995-12-16	5001	0	\N	0	0	\N	\N	0	66158	0	117015009	4024958		
50549	1535	4024958	1983-08-09	1983-08-09 00:00:00	1983-08-09	5001	0	\N	0	0	\N	\N	0	102707	0	117015009	4024958		
5410	163	4024958	1975-05-16	1975-05-16 00:00:00	1975-05-16	5001	0	\N	0	0	\N	\N	0	11189	0	117015009	4024958		
7483	236	4052083	1978-01-01	1978-01-01 00:00:00	1978-01-01	5001	0	\N	0	0	\N	\N	0	15902	0	23426006	4052083		
27850	2566	46235214	2016-01-03	2016-01-03 00:00:00	2016-01-03	5001	0	\N	0	0	\N	\N	0	170026	0	76690-7	46235214		
27922	2566	46235214	2017-03-28	2017-03-28 00:00:00	2017-03-28	5001	0	\N	0	0	\N	\N	0	169994	0	76690-7	46235214		
19527	1783	3015076	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	119524	0	6248-9	3015076		
22864	2091	3006322	1978-08-04	1978-08-04 00:00:00	1978-08-04	5001	0	\N	0	0	\N	\N	0	139442	0	8331-1	3006322		
17007	1550	3011505	2009-12-19	2009-12-19 00:00:00	2009-12-19	5001	0	\N	0	0	\N	\N	0	103781	0	19926-5	3011505		
17085	1556	3006322	1997-02-04	1997-02-04 00:00:00	1997-02-04	5001	0	\N	0	0	\N	\N	0	104186	0	8331-1	3006322		
110060	3397	4052083	1954-01-06	1954-01-06 00:00:00	1954-01-06	5001	0	\N	0	0	\N	\N	0	225323	0	23426006	4052083		
42514	3927	3006322	1957-03-04	1957-03-04 00:00:00	1957-03-04	5001	0	\N	0	0	\N	\N	0	261098	0	8331-1	3006322		
395	16	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	1277	0	6095-4	3036780		
27512	2543	46235214	1977-01-13	1977-01-13 00:00:00	1977-01-13	5001	0	\N	0	0	\N	\N	0	168236	0	76690-7	46235214		
2428	232	3006322	1947-11-01	1947-11-01 00:00:00	1947-11-01	5001	0	\N	0	0	\N	\N	0	15539	0	8331-1	3006322		
167480	5143	4052083	1986-06-25	1986-06-25 00:00:00	1986-06-25	5001	0	\N	0	0	\N	\N	0	341814	0	23426006	4052083		
20700	1902	3006322	1952-02-17	1952-02-17 00:00:00	1952-02-17	5001	0	\N	0	0	\N	\N	0	126588	0	8331-1	3006322		
66804	2053	4052083	1954-09-26	1954-09-26 00:00:00	1954-09-26	5001	0	\N	0	0	\N	\N	0	136507	0	23426006	4052083		
25304	2325	3006322	1999-12-09	1999-12-09 00:00:00	1999-12-09	5001	0	\N	0	0	\N	\N	0	154602	0	8331-1	3006322		
25330	2329	3006322	1978-04-23	1978-04-23 00:00:00	1978-04-23	5001	0	\N	0	0	\N	\N	0	154929	0	8331-1	3006322		
26322	2419	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	160526	0	6082-2	3000876		
26425	2436	3036780	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	161510	0	6095-4	3036780		
20251	1852	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	123952	0	6248-9	3015076		
5313	507	46235214	1958-02-10	1958-02-10 00:00:00	1958-02-10	5001	0	\N	0	0	\N	\N	0	33965	0	76690-7	46235214		
31722	2898	3020655	1995-07-25	1995-07-25 00:00:00	1995-07-25	5001	0	\N	0	0	\N	\N	0	192974	0	6844-5	3020655		
91254	2818	4024958	1980-01-15	1980-01-15 00:00:00	1980-01-15	5001	0	\N	0	0	\N	\N	0	186754	0	117015009	4024958		
38495	3561	3006322	1940-08-15	1940-08-15 00:00:00	1940-08-15	5001	0	\N	0	0	\N	\N	0	236417	0	8331-1	3006322		
38603	3568	3051031	1971-01-24	1971-01-24 00:00:00	1971-01-24	5001	0	\N	0	0	\N	\N	0	237087	0	46240-8	3051031		
38651	3571	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	237322	0	6246-3	3021226		
50028	4550	3000876	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	303229	0	6082-2	3000876		
44684	4125	3006322	1976-07-04	1976-07-04 00:00:00	1976-07-04	5001	0	\N	0	0	\N	\N	0	274229	0	8331-1	3006322		
28898	2669	40758406	1978-11-03	1978-11-03 00:00:00	1978-11-03	5001	0	\N	0	0	\N	\N	0	176819	0	55277-8	40758406		
28985	2673	3001247	1982-03-04	1982-03-04 00:00:00	1982-03-04	5001	0	\N	0	0	\N	\N	0	177076	0	6085-5	3001247		
53206	4890	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	325066	0	6075-6	3005136		
12987	1237	3011505	1991-04-28	1991-04-28 00:00:00	1991-04-28	5001	0	\N	0	0	\N	\N	0	81496	0	19926-5	3011505		
24027	2213	3014599	1991-08-01	1991-08-01 00:00:00	1991-08-01	5001	0	\N	0	0	\N	\N	0	147361	0	6106-9	3014599		
53540	4913	3051031	1971-04-09	1971-04-09 00:00:00	1971-04-09	5001	0	\N	0	0	\N	\N	0	326536	0	46240-8	3051031		
35815	3285	3006322	1998-02-19	1998-02-19 00:00:00	1998-02-19	5001	0	\N	0	0	\N	\N	0	218173	0	8331-1	3006322		
12161	1158	3006322	1979-10-07	1979-10-07 00:00:00	1979-10-07	5001	0	\N	0	0	\N	\N	0	76519	0	8331-1	3006322		
6119	187	4024958	1990-06-29	1990-06-29 00:00:00	1990-06-29	5001	0	\N	0	0	\N	\N	0	12696	0	117015009	4024958		
23590	2175	40766240	1977-05-28	1977-05-28 00:00:00	1977-05-28	5001	0	\N	0	0	\N	\N	0	145042	0	63513-6	40766240		
9361	884	3014599	1990-09-11	1990-09-11 00:00:00	1990-09-11	5001	0	\N	0	0	\N	\N	0	58941	0	6106-9	3014599		
38208	3526	40766240	2018-04-04	2018-04-04 00:00:00	2018-04-04	5001	0	\N	0	0	\N	\N	0	233977	0	63513-6	40766240		
47773	4376	3011505	2016-01-26	2016-01-26 00:00:00	2016-01-26	5001	0	\N	0	0	\N	\N	0	290708	0	19926-5	3011505		
129362	3984	4052083	1965-05-23	1965-05-23 00:00:00	1965-05-23	5001	0	\N	0	0	\N	\N	0	264806	0	23426006	4052083		
57854	5312	3006322	2006-10-21	2006-10-21 00:00:00	2006-10-21	5001	0	\N	0	0	\N	\N	0	353253	0	8331-1	3006322		
32368	2942	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	196157	0	6276-0	3027231		
40446	1258	4024958	1973-06-10	1973-06-10 00:00:00	1973-06-10	5001	0	\N	0	0	\N	\N	0	82903	0	117015009	4024958		
98	3	46235214	1949-03-25	1949-03-25 00:00:00	1949-03-25	5001	0	\N	0	0	\N	\N	0	219	0	76690-7	46235214		
119040	3666	4024958	1969-04-29	1969-04-29 00:00:00	1969-04-29	5001	0	\N	0	0	\N	\N	0	243859	0	117015009	4024958		
6529	615	3006322	1913-12-21	1913-12-21 00:00:00	1913-12-21	5001	0	\N	0	0	\N	\N	0	41001	0	8331-1	3006322		
21514	1980	3012494	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	131768	0	6206-7	3012494		
21613	1992	3023430	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	132713	0	6833-8	3023430		
21640	1999	3015076	2011-10-05	2011-10-05 00:00:00	2011-10-05	5001	0	\N	0	0	\N	\N	0	133114	0	6248-9	3015076		
33000	2980	3027231	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	198939	0	6276-0	3027231		
29483	2715	3006322	2006-09-28	2006-09-28 00:00:00	2006-09-28	5001	0	\N	0	0	\N	\N	0	180016	0	8331-1	3006322		
55513	5097	3006451	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	338637	0	6273-7	3006451		
23494	736	4024958	1974-06-25	1974-06-25 00:00:00	1974-06-25	5001	0	\N	0	0	\N	\N	0	48847	0	117015009	4024958		
29796	919	4024958	1974-10-13	1974-10-13 00:00:00	1974-10-13	5001	0	\N	0	0	\N	\N	0	61251	0	117015009	4024958		
30601	2802	3006322	1944-04-11	1944-04-11 00:00:00	1944-04-11	5001	0	\N	0	0	\N	\N	0	185762	0	8331-1	3006322		
6639	621	46235214	1973-02-02	1973-02-02 00:00:00	1973-02-02	5001	0	\N	0	0	\N	\N	0	41475	0	76690-7	46235214		
33479	3026	3006322	1971-12-26	1971-12-26 00:00:00	1971-12-26	5001	0	\N	0	0	\N	\N	0	201761	0	8331-1	3006322		
102335	3144	4052083	1965-02-18	1965-02-18 00:00:00	1965-02-18	5001	0	\N	0	0	\N	\N	0	209208	0	23426006	4052083		
30599	949	4133840	2001-09-24	2001-09-24 00:00:00	2001-09-24	5001	0	\N	0	0	\N	\N	0	63059	0	127783003	4133840		
32343	1004	4052083	1986-12-13	1986-12-13 00:00:00	1986-12-13	5001	0	\N	0	0	\N	\N	0	66383	0	23426006	4052083		
50550	1535	4052083	1980-09-20	1980-09-20 00:00:00	1980-09-20	5001	0	\N	0	0	\N	\N	0	102749	0	23426006	4052083		
5426	164	4024958	2000-05-30	2000-05-30 00:00:00	2000-05-30	5001	0	\N	0	0	\N	\N	0	11246	0	117015009	4024958		
7492	236	4024958	1988-02-10	1988-02-10 00:00:00	1988-02-10	5001	0	\N	0	0	\N	\N	0	15952	0	117015009	4024958		
27851	2566	40766240	2016-01-03	2016-01-03 00:00:00	2016-01-03	5001	0	\N	0	0	\N	\N	0	170026	0	63513-6	40766240		
27923	2566	40758406	2017-03-28	2017-03-28 00:00:00	2017-03-28	5001	0	\N	0	0	\N	\N	0	169994	0	55277-8	40758406		
19528	1783	3036780	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	119524	0	6095-4	3036780		
22865	2091	3006322	2010-10-31	2010-10-31 00:00:00	2010-10-31	5001	0	\N	0	0	\N	\N	0	139443	0	8331-1	3006322		
17008	1550	3011505	2007-12-15	2007-12-15 00:00:00	2007-12-15	5001	0	\N	0	0	\N	\N	0	103789	0	19926-5	3011505		
17086	1556	3006322	1981-12-02	1981-12-02 00:00:00	1981-12-02	5001	0	\N	0	0	\N	\N	0	104257	0	8331-1	3006322		
110068	3397	4024958	2008-10-18	2008-10-18 00:00:00	2008-10-18	5001	0	\N	0	0	\N	\N	0	225327	0	117015009	4024958		
42515	3927	3006322	2013-09-15	2013-09-15 00:00:00	2013-09-15	5001	0	\N	0	0	\N	\N	0	261055	0	8331-1	3006322		
396	16	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	1277	0	6206-7	3012494		
27513	2543	40766240	1977-01-13	1977-01-13 00:00:00	1977-01-13	5001	0	\N	0	0	\N	\N	0	168236	0	63513-6	40766240		
2429	232	3006322	2007-11-11	2007-11-11 00:00:00	2007-11-11	5001	0	\N	0	0	\N	\N	0	15601	0	8331-1	3006322		
40058	3734	3006322	1957-10-31	1957-10-31 00:00:00	1957-10-31	5001	0	\N	0	0	\N	\N	0	248096	0	8331-1	3006322		
20701	1903	3006322	1969-05-16	1969-05-16 00:00:00	1969-05-16	5001	0	\N	0	0	\N	\N	0	126669	0	8331-1	3006322		
66818	2053	4024958	1958-06-05	1958-06-05 00:00:00	1958-06-05	5001	0	\N	0	0	\N	\N	0	136500	0	117015009	4024958		
25305	2325	3006322	2018-10-30	2018-10-30 00:00:00	2018-10-30	5001	0	\N	0	0	\N	\N	0	154562	0	8331-1	3006322		
25331	2330	3006322	1995-04-08	1995-04-08 00:00:00	1995-04-08	5001	0	\N	0	0	\N	\N	0	154979	0	8331-1	3006322		
26323	2419	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	160526	0	6276-0	3027231		
26426	2436	3001247	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	161510	0	6085-5	3001247		
20252	1852	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	123952	0	6273-7	3006451		
5315	507	3051031	1958-02-10	1958-02-10 00:00:00	1958-02-10	5001	0	\N	0	0	\N	\N	0	33965	0	46240-8	3051031		
31723	2898	3023430	1995-07-25	1995-07-25 00:00:00	1995-07-25	5001	0	\N	0	0	\N	\N	0	192974	0	6833-8	3023430		
91264	2818	4052083	2004-04-30	2004-04-30 00:00:00	2004-04-30	5001	0	\N	0	0	\N	\N	0	186721	0	23426006	4052083		
38496	3561	3006322	1946-10-23	1946-10-23 00:00:00	1946-10-23	5001	0	\N	0	0	\N	\N	0	236497	0	8331-1	3006322		
38604	3568	40766240	1970-08-27	1970-08-27 00:00:00	1970-08-27	5001	0	\N	0	0	\N	\N	0	237071	0	63513-6	40766240		
38652	3571	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	237322	0	6106-9	3014599		
50029	4550	3001247	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	303229	0	6085-5	3001247		
44685	4127	3006322	1967-10-13	1967-10-13 00:00:00	1967-10-13	5001	0	\N	0	0	\N	\N	0	274313	0	8331-1	3006322		
28899	2669	46235214	1978-11-03	1978-11-03 00:00:00	1978-11-03	5001	0	\N	0	0	\N	\N	0	176819	0	76690-7	46235214		
28986	2673	3020655	1982-03-04	1982-03-04 00:00:00	1982-03-04	5001	0	\N	0	0	\N	\N	0	177076	0	6844-5	3020655		
165832	5097	4052083	1983-05-05	1983-05-05 00:00:00	1983-05-05	5001	0	\N	0	0	\N	\N	0	338629	0	23426006	4052083		
12988	1237	3011505	1993-05-02	1993-05-02 00:00:00	1993-05-02	5001	0	\N	0	0	\N	\N	0	81539	0	19926-5	3011505		
24028	2213	3023430	1991-08-01	1991-08-01 00:00:00	1991-08-01	5001	0	\N	0	0	\N	\N	0	147361	0	6833-8	3023430		
53542	4913	40758406	1971-04-09	1971-04-09 00:00:00	1971-04-09	5001	0	\N	0	0	\N	\N	0	326536	0	55277-8	40758406		
35816	3285	3006322	2019-06-11	2019-06-11 00:00:00	2019-06-11	5001	0	\N	0	0	\N	\N	0	218222	0	8331-1	3006322		
12162	1158	3006322	1998-02-15	1998-02-15 00:00:00	1998-02-15	5001	0	\N	0	0	\N	\N	0	76505	0	8331-1	3006322		
6140	188	4052083	1981-09-10	1981-09-10 00:00:00	1981-09-10	5001	0	\N	0	0	\N	\N	0	12786	0	23426006	4052083		
23591	2175	40758406	1977-05-28	1977-05-28 00:00:00	1977-05-28	5001	0	\N	0	0	\N	\N	0	145042	0	55277-8	40758406		
9362	884	3027231	1990-09-11	1990-09-11 00:00:00	1990-09-11	5001	0	\N	0	0	\N	\N	0	58941	0	6276-0	3027231		
38209	3526	46235214	2018-04-04	2018-04-04 00:00:00	2018-04-04	5001	0	\N	0	0	\N	\N	0	233977	0	76690-7	46235214		
47774	4376	3006322	1925-06-08	1925-06-08 00:00:00	1925-06-08	5001	0	\N	0	0	\N	\N	0	290760	0	8331-1	3006322		
129364	3984	4052083	1963-12-13	1963-12-13 00:00:00	1963-12-13	5001	0	\N	0	0	\N	\N	0	264821	0	23426006	4052083		
57855	5312	3006322	1995-01-14	1995-01-14 00:00:00	1995-01-14	5001	0	\N	0	0	\N	\N	0	353270	0	8331-1	3006322		
32369	2942	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	196157	0	6273-7	3006451		
51732	1565	4052083	1974-07-24	1974-07-24 00:00:00	1974-07-24	5001	0	\N	0	0	\N	\N	0	104970	0	23426006	4052083		
99	3	3051031	1949-03-25	1949-03-25 00:00:00	1949-03-25	5001	0	\N	0	0	\N	\N	0	219	0	46240-8	3051031		
119045	3666	4024958	1989-02-08	1989-02-08 00:00:00	1989-02-08	5001	0	\N	0	0	\N	\N	0	243916	0	117015009	4024958		
6530	615	3006322	2003-03-11	2003-03-11 00:00:00	2003-03-11	5001	0	\N	0	0	\N	\N	0	40961	0	8331-1	3006322		
21515	1980	3020655	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	131768	0	6844-5	3020655		
21614	1992	3020655	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	132713	0	6844-5	3020655		
21641	1999	3027231	2011-10-05	2011-10-05 00:00:00	2011-10-05	5001	0	\N	0	0	\N	\N	0	133114	0	6276-0	3027231		
33001	2980	3006451	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	198939	0	6273-7	3006451		
29484	2715	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	180031	0	7258-7	3001488		
55514	5097	3015076	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	338637	0	6248-9	3015076		
157216	4831	4052083	2015-01-15	2015-01-15 00:00:00	2015-01-15	5001	0	\N	0	0	\N	\N	0	321431	0	23426006	4052083		
29801	919	4024958	1999-05-13	1999-05-13 00:00:00	1999-05-13	5001	0	\N	0	0	\N	\N	0	61255	0	117015009	4024958		
30602	2802	3006322	1957-10-05	1957-10-05 00:00:00	1957-10-05	5001	0	\N	0	0	\N	\N	0	185738	0	8331-1	3006322		
6640	621	40758406	1973-02-02	1973-02-02 00:00:00	1973-02-02	5001	0	\N	0	0	\N	\N	0	41475	0	55277-8	40758406		
33480	3026	3006322	2011-12-17	2011-12-17 00:00:00	2011-12-17	5001	0	\N	0	0	\N	\N	0	201778	0	8331-1	3006322		
52654	1597	4052083	1993-01-15	1993-01-15 00:00:00	1993-01-15	5001	0	\N	0	0	\N	\N	0	107131	0	23426006	4052083		
30606	950	4052083	1985-06-05	1985-06-05 00:00:00	1985-06-05	5001	0	\N	0	0	\N	\N	0	63128	0	23426006	4052083		
32346	1004	4024958	1981-02-02	1981-02-02 00:00:00	1981-02-02	5001	0	\N	0	0	\N	\N	0	66381	0	117015009	4024958		
50552	1535	4024958	2015-12-16	2015-12-16 00:00:00	2015-12-16	5001	0	\N	0	0	\N	\N	0	102755	0	117015009	4024958		
5434	164	4024958	1989-12-14	1989-12-14 00:00:00	1989-12-14	5001	0	\N	0	0	\N	\N	0	11295	0	117015009	4024958		
53463	1618	4024958	2013-08-11	2013-08-11 00:00:00	2013-08-11	5001	0	\N	0	0	\N	\N	0	108812	0	117015009	4024958		
27852	2566	40766240	2016-09-29	2016-09-29 00:00:00	2016-09-29	5001	0	\N	0	0	\N	\N	0	170050	0	63513-6	40766240		
39202	3622	3006322	2000-07-29	2000-07-29 00:00:00	2000-07-29	5001	0	\N	0	0	\N	\N	0	240665	0	8331-1	3006322		
19529	1783	3027231	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	119524	0	6276-0	3027231		
22866	2091	3006322	1979-01-12	1979-01-12 00:00:00	1979-01-12	5001	0	\N	0	0	\N	\N	0	139432	0	8331-1	3006322		
17009	1550	3011505	2007-05-26	2007-05-26 00:00:00	2007-05-26	5001	0	\N	0	0	\N	\N	0	103780	0	19926-5	3011505		
17087	1556	3006322	1990-10-29	1990-10-29 00:00:00	1990-10-29	5001	0	\N	0	0	\N	\N	0	104262	0	8331-1	3006322		
121368	3745	4133840	2011-09-07	2011-09-07 00:00:00	2011-09-07	5001	0	\N	0	0	\N	\N	0	248964	0	127783003	4133840		
42516	3927	3006322	1948-10-22	1948-10-22 00:00:00	1948-10-22	5001	0	\N	0	0	\N	\N	0	261040	0	8331-1	3006322		
397	16	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	1277	0	6082-2	3000876		
27515	2543	40758406	1976-11-14	1976-11-14 00:00:00	1976-11-14	5001	0	\N	0	0	\N	\N	0	168232	0	55277-8	40758406		
2430	232	3006322	1981-03-17	1981-03-17 00:00:00	1981-03-17	5001	0	\N	0	0	\N	\N	0	15636	0	8331-1	3006322		
40059	3734	3006322	2007-05-25	2007-05-25 00:00:00	2007-05-25	5001	0	\N	0	0	\N	\N	0	248178	0	8331-1	3006322		
20702	1903	3006322	2007-08-20	2007-08-20 00:00:00	2007-08-20	5001	0	\N	0	0	\N	\N	0	126678	0	8331-1	3006322		
66820	2053	4024958	1965-12-30	1965-12-30 00:00:00	1965-12-30	5001	0	\N	0	0	\N	\N	0	136474	0	117015009	4024958		
25306	2325	3006322	1999-01-03	1999-01-03 00:00:00	1999-01-03	5001	0	\N	0	0	\N	\N	0	154618	0	8331-1	3006322		
25332	2330	3006322	2009-08-30	2009-08-30 00:00:00	2009-08-30	5001	0	\N	0	0	\N	\N	0	154987	0	8331-1	3006322		
26324	2419	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	160526	0	6158-0	3019406		
26427	2436	3020655	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	161510	0	6844-5	3020655		
20253	1852	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	123952	0	6189-5	3006734		
5316	507	40758406	1958-02-10	1958-02-10 00:00:00	1958-02-10	5001	0	\N	0	0	\N	\N	0	33965	0	55277-8	40758406		
31724	2898	3019406	1995-07-25	1995-07-25 00:00:00	1995-07-25	5001	0	\N	0	0	\N	\N	0	192974	0	6158-0	3019406		
91266	2818	4024958	2017-02-24	2017-02-24 00:00:00	2017-02-24	5001	0	\N	0	0	\N	\N	0	186772	0	117015009	4024958		
38497	3561	3006322	1974-04-19	1974-04-19 00:00:00	1974-04-19	5001	0	\N	0	0	\N	\N	0	236486	0	8331-1	3006322		
38606	3568	3051031	1970-08-27	1970-08-27 00:00:00	1970-08-27	5001	0	\N	0	0	\N	\N	0	237071	0	46240-8	3051031		
38653	3571	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	237322	0	6273-7	3006451		
50030	4550	3001488	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	303229	0	7258-7	3001488		
44686	4127	3006322	1991-08-23	1991-08-23 00:00:00	1991-08-23	5001	0	\N	0	0	\N	\N	0	274335	0	8331-1	3006322		
28902	2669	3051031	1978-11-03	1978-11-03 00:00:00	1978-11-03	5001	0	\N	0	0	\N	\N	0	176819	0	46240-8	3051031		
28987	2673	3023430	1982-03-04	1982-03-04 00:00:00	1982-03-04	5001	0	\N	0	0	\N	\N	0	177076	0	6833-8	3023430		
66581	2043	4052083	1995-09-23	1995-09-23 00:00:00	1995-09-23	5001	0	\N	0	0	\N	\N	0	135935	0	23426006	4052083		
12989	1237	3011505	1995-05-07	1995-05-07 00:00:00	1995-05-07	5001	0	\N	0	0	\N	\N	0	81510	0	19926-5	3011505		
24029	2213	3006322	1989-05-19	1989-05-19 00:00:00	1989-05-19	5001	0	\N	0	0	\N	\N	0	147356	0	8331-1	3006322		
53543	4913	40766240	1971-04-09	1971-04-09 00:00:00	1971-04-09	5001	0	\N	0	0	\N	\N	0	326536	0	63513-6	40766240		
35817	3285	3006322	1963-01-26	1963-01-26 00:00:00	1963-01-26	5001	0	\N	0	0	\N	\N	0	218170	0	8331-1	3006322		
12163	1158	3006322	2014-02-11	2014-02-11 00:00:00	2014-02-11	5001	0	\N	0	0	\N	\N	0	76522	0	8331-1	3006322		
6141	188	4052083	1986-03-28	1986-03-28 00:00:00	1986-03-28	5001	0	\N	0	0	\N	\N	0	12825	0	23426006	4052083		
23592	2175	46235214	1977-05-28	1977-05-28 00:00:00	1977-05-28	5001	0	\N	0	0	\N	\N	0	145042	0	76690-7	46235214		
9363	884	3021226	1990-09-11	1990-09-11 00:00:00	1990-09-11	5001	0	\N	0	0	\N	\N	0	58941	0	6246-3	3021226		
38211	3526	40758406	2018-04-04	2018-04-04 00:00:00	2018-04-04	5001	0	\N	0	0	\N	\N	0	233977	0	55277-8	40758406		
47775	4376	3011505	1979-07-03	1979-07-03 00:00:00	1979-07-03	5001	0	\N	0	0	\N	\N	0	290719	0	19926-5	3011505		
129365	3984	4024958	1958-04-04	1958-04-04 00:00:00	1958-04-04	5001	0	\N	0	0	\N	\N	0	264820	0	117015009	4024958		
57856	5312	3011505	2007-01-29	2007-01-29 00:00:00	2007-01-29	5001	0	\N	0	0	\N	\N	0	353246	0	19926-5	3011505		
32370	2942	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	196157	0	6246-3	3021226		
51738	1566	4052083	2000-08-13	2000-08-13 00:00:00	2000-08-13	5001	0	\N	0	0	\N	\N	0	105026	0	23426006	4052083		
100	3	40758406	1949-03-25	1949-03-25 00:00:00	1949-03-25	5001	0	\N	0	0	\N	\N	0	219	0	55277-8	40758406		
119046	3667	4052083	2012-12-04	2012-12-04 00:00:00	2012-12-04	5001	0	\N	0	0	\N	\N	0	243949	0	23426006	4052083		
6531	615	3036780	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	40867	0	6095-4	3036780		
21516	1980	3023430	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	131768	0	6833-8	3023430		
21615	1992	3001488	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	132713	0	7258-7	3001488		
21642	1999	3036780	2011-10-05	2011-10-05 00:00:00	2011-10-05	5001	0	\N	0	0	\N	\N	0	133114	0	6095-4	3036780		
33002	2980	3014599	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	198939	0	6106-9	3014599		
29485	2715	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	180031	0	6189-5	3006734		
55515	5097	3014599	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	338637	0	6106-9	3014599		
157234	4831	4052083	1991-12-18	1991-12-18 00:00:00	1991-12-18	5001	0	\N	0	0	\N	\N	0	321435	0	23426006	4052083		
29802	919	4052083	1992-08-19	1992-08-19 00:00:00	1992-08-19	5001	0	\N	0	0	\N	\N	0	61254	0	23426006	4052083		
30603	2802	3006322	1940-10-02	1940-10-02 00:00:00	1940-10-02	5001	0	\N	0	0	\N	\N	0	185704	0	8331-1	3006322		
6642	621	40766240	1973-02-02	1973-02-02 00:00:00	1973-02-02	5001	0	\N	0	0	\N	\N	0	41475	0	63513-6	40766240		
33481	3026	3006322	2004-08-09	2004-08-09 00:00:00	2004-08-09	5001	0	\N	0	0	\N	\N	0	201777	0	8331-1	3006322		
52656	1597	4024958	2003-04-12	2003-04-12 00:00:00	2003-04-12	5001	0	\N	0	0	\N	\N	0	107160	0	117015009	4024958		
30608	950	4024958	2002-08-02	2002-08-02 00:00:00	2002-08-02	5001	0	\N	0	0	\N	\N	0	63069	0	117015009	4024958		
158657	4878	4024958	1971-01-14	1971-01-14 00:00:00	1971-01-14	5001	0	\N	0	0	\N	\N	0	324315	0	117015009	4024958		
50555	1535	4024958	1997-01-22	1997-01-22 00:00:00	1997-01-22	5001	0	\N	0	0	\N	\N	0	102752	0	117015009	4024958		
5437	165	4024958	2002-09-14	2002-09-14 00:00:00	2002-09-14	5001	0	\N	0	0	\N	\N	0	11340	0	117015009	4024958		
53467	1618	4024958	1978-06-21	1978-06-21 00:00:00	1978-06-21	5001	0	\N	0	0	\N	\N	0	108822	0	117015009	4024958		
27854	2566	46235214	2016-09-29	2016-09-29 00:00:00	2016-09-29	5001	0	\N	0	0	\N	\N	0	170050	0	76690-7	46235214		
39203	3622	3049273	1982-07-21	1982-07-21 00:00:00	1982-07-21	5001	0	\N	0	0	\N	\N	0	240845	0	38265-5	3049273		
19530	1783	3006451	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	119524	0	6273-7	3006451		
22867	2091	3006322	1989-11-25	1989-11-25 00:00:00	1989-11-25	5001	0	\N	0	0	\N	\N	0	139433	0	8331-1	3006322		
17010	1550	3011505	2011-12-24	2011-12-24 00:00:00	2011-12-24	5001	0	\N	0	0	\N	\N	0	103793	0	19926-5	3011505		
17088	1556	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	104226	0	6095-4	3036780		
121373	3745	4024958	1941-07-30	1941-07-30 00:00:00	1941-07-30	5001	0	\N	0	0	\N	\N	0	248954	0	117015009	4024958		
42517	3927	3006322	1954-05-09	1954-05-09 00:00:00	1954-05-09	5001	0	\N	0	0	\N	\N	0	261051	0	8331-1	3006322		
398	16	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	1277	0	6085-5	3001247		
27516	2543	3051031	1976-11-14	1976-11-14 00:00:00	1976-11-14	5001	0	\N	0	0	\N	\N	0	168232	0	46240-8	3051031		
17113	534	4024958	1993-10-31	1993-10-31 00:00:00	1993-10-31	5001	0	\N	0	0	\N	\N	0	35513	0	117015009	4024958		
40060	3734	3006322	1990-02-14	1990-02-14 00:00:00	1990-02-14	5001	0	\N	0	0	\N	\N	0	248154	0	8331-1	3006322		
20703	1903	3006322	1984-04-11	1984-04-11 00:00:00	1984-04-11	5001	0	\N	0	0	\N	\N	0	126721	0	8331-1	3006322		
66822	2053	4024958	1962-09-04	1962-09-04 00:00:00	1962-09-04	5001	0	\N	0	0	\N	\N	0	136502	0	117015009	4024958		
25307	2326	3006322	1966-11-19	1966-11-19 00:00:00	1966-11-19	5001	0	\N	0	0	\N	\N	0	154645	0	8331-1	3006322		
25334	2332	3006322	1984-10-22	1984-10-22 00:00:00	1984-10-22	5001	0	\N	0	0	\N	\N	0	155050	0	8331-1	3006322		
26325	2419	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	160526	0	6248-9	3015076		
26428	2436	3000876	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	161510	0	6082-2	3000876		
20254	1852	3006322	1987-03-22	1987-03-22 00:00:00	1987-03-22	5001	0	\N	0	0	\N	\N	0	123889	0	8331-1	3006322		
5321	510	3006322	2001-11-08	2001-11-08 00:00:00	2001-11-08	5001	0	\N	0	0	\N	\N	0	34076	0	8331-1	3006322		
31725	2898	3027231	1995-07-25	1995-07-25 00:00:00	1995-07-25	5001	0	\N	0	0	\N	\N	0	192974	0	6276-0	3027231		
91269	2818	4024958	2010-03-13	2010-03-13 00:00:00	2010-03-13	5001	0	\N	0	0	\N	\N	0	186722	0	117015009	4024958		
38498	3561	3006322	2011-07-01	2011-07-01 00:00:00	2011-07-01	5001	0	\N	0	0	\N	\N	0	236489	0	8331-1	3006322		
38607	3568	40758406	1970-08-27	1970-08-27 00:00:00	1970-08-27	5001	0	\N	0	0	\N	\N	0	237071	0	55277-8	40758406		
38654	3571	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	237322	0	6276-0	3027231		
50031	4550	3023430	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	303229	0	6833-8	3023430		
44687	4127	3006322	2018-10-27	2018-10-27 00:00:00	2018-10-27	5001	0	\N	0	0	\N	\N	0	274348	0	8331-1	3006322		
28903	2669	40766240	1978-11-03	1978-11-03 00:00:00	1978-11-03	5001	0	\N	0	0	\N	\N	0	176819	0	63513-6	40766240		
28988	2673	3006734	1982-03-04	1982-03-04 00:00:00	1982-03-04	5001	0	\N	0	0	\N	\N	0	177076	0	6189-5	3006734		
77867	2389	4024958	2013-12-03	2013-12-03 00:00:00	2013-12-03	5001	0	\N	0	0	\N	\N	0	158876	0	117015009	4024958		
12991	1237	3006322	1949-06-25	1949-06-25 00:00:00	1949-06-25	5001	0	\N	0	0	\N	\N	0	81512	0	8331-1	3006322		
24030	2213	40769179	1991-07-21	1991-07-21 00:00:00	1991-07-21	5001	0	\N	0	0	\N	\N	0	147357	0	66519-0	40769179		
53544	4913	46235214	1971-04-09	1971-04-09 00:00:00	1971-04-09	5001	0	\N	0	0	\N	\N	0	326536	0	76690-7	46235214		
35818	3285	3006322	1988-04-06	1988-04-06 00:00:00	1988-04-06	5001	0	\N	0	0	\N	\N	0	218172	0	8331-1	3006322		
12164	1158	3006322	2010-01-07	2010-01-07 00:00:00	2010-01-07	5001	0	\N	0	0	\N	\N	0	76508	0	8331-1	3006322		
6142	188	4024958	2011-02-09	2011-02-09 00:00:00	2011-02-09	5001	0	\N	0	0	\N	\N	0	12827	0	117015009	4024958		
23595	2175	3051031	1977-06-27	1977-06-27 00:00:00	1977-06-27	5001	0	\N	0	0	\N	\N	0	144979	0	46240-8	3051031		
9364	884	3006451	1990-09-11	1990-09-11 00:00:00	1990-09-11	5001	0	\N	0	0	\N	\N	0	58941	0	6273-7	3006451		
38212	3526	3051031	2018-04-04	2018-04-04 00:00:00	2018-04-04	5001	0	\N	0	0	\N	\N	0	233977	0	46240-8	3051031		
47776	4376	3011505	2018-02-06	2018-02-06 00:00:00	2018-02-06	5001	0	\N	0	0	\N	\N	0	290829	0	19926-5	3011505		
129379	3984	4052083	1961-03-19	1961-03-19 00:00:00	1961-03-19	5001	0	\N	0	0	\N	\N	0	264805	0	23426006	4052083		
57857	5312	3006322	1980-10-18	1980-10-18 00:00:00	1980-10-18	5001	0	\N	0	0	\N	\N	0	353284	0	8331-1	3006322		
32371	2942	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	196157	0	6082-2	3000876		
51749	1566	4024958	1972-08-12	1972-08-12 00:00:00	1972-08-12	5001	0	\N	0	0	\N	\N	0	104994	0	117015009	4024958		
101	3	40766240	1949-03-25	1949-03-25 00:00:00	1949-03-25	5001	0	\N	0	0	\N	\N	0	219	0	63513-6	40766240		
119049	3667	4052083	1978-03-16	1978-03-16 00:00:00	1978-03-16	5001	0	\N	0	0	\N	\N	0	243965	0	23426006	4052083		
6532	615	3020655	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	40867	0	6844-5	3020655		
21517	1980	3001247	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	131768	0	6085-5	3001247		
21616	1992	3001247	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	132713	0	6085-5	3001247		
21643	1999	3001247	2011-10-05	2011-10-05 00:00:00	2011-10-05	5001	0	\N	0	0	\N	\N	0	133114	0	6085-5	3001247		
33003	2980	3027231	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	198943	0	6276-0	3027231		
29486	2715	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	180031	0	6833-8	3023430		
55516	5097	3005136	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	338637	0	6075-6	3005136		
157236	4831	4024958	1980-07-31	1980-07-31 00:00:00	1980-07-31	5001	0	\N	0	0	\N	\N	0	321419	0	117015009	4024958		
29828	921	4052083	2004-02-04	2004-02-04 00:00:00	2004-02-04	5001	0	\N	0	0	\N	\N	0	61375	0	23426006	4052083		
30604	2802	3006322	1984-07-12	1984-07-12 00:00:00	1984-07-12	5001	0	\N	0	0	\N	\N	0	185685	0	8331-1	3006322		
6643	621	3006322	1919-05-05	1919-05-05 00:00:00	1919-05-05	5001	0	\N	0	0	\N	\N	0	41413	0	8331-1	3006322		
33483	3028	3006322	1987-11-04	1987-11-04 00:00:00	1987-11-04	5001	0	\N	0	0	\N	\N	0	201894	0	8331-1	3006322		
52670	1597	4024958	2006-03-11	2006-03-11 00:00:00	2006-03-11	5001	0	\N	0	0	\N	\N	0	107161	0	117015009	4024958		
41891	1293	4024958	1976-07-11	1976-07-11 00:00:00	1976-07-11	5001	0	\N	0	0	\N	\N	0	85545	0	117015009	4024958		
158689	4878	4052083	1988-01-25	1988-01-25 00:00:00	1988-01-25	5001	0	\N	0	0	\N	\N	0	324346	0	23426006	4052083		
50557	1535	4024958	2016-03-31	2016-03-31 00:00:00	2016-03-31	5001	0	\N	0	0	\N	\N	0	102756	0	117015009	4024958		
5438	165	4052083	2012-11-18	2012-11-18 00:00:00	2012-11-18	5001	0	\N	0	0	\N	\N	0	11316	0	23426006	4052083		
53470	1618	4024958	1984-06-04	1984-06-04 00:00:00	1984-06-04	5001	0	\N	0	0	\N	\N	0	108775	0	117015009	4024958		
27855	2566	40758406	2016-09-29	2016-09-29 00:00:00	2016-09-29	5001	0	\N	0	0	\N	\N	0	170050	0	55277-8	40758406		
39204	3622	3006322	1975-03-31	1975-03-31 00:00:00	1975-03-31	5001	0	\N	0	0	\N	\N	0	240747	0	8331-1	3006322		
19531	1783	3000876	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	119524	0	6082-2	3000876		
22887	2094	3006322	1992-12-21	1992-12-21 00:00:00	1992-12-21	5001	0	\N	0	0	\N	\N	0	139636	0	8331-1	3006322		
17011	1551	3006322	1992-06-27	1992-06-27 00:00:00	1992-06-27	5001	0	\N	0	0	\N	\N	0	103867	0	8331-1	3006322		
17089	1556	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	104226	0	6075-6	3005136		
121376	3745	4133840	1995-06-07	1995-06-07 00:00:00	1995-06-07	5001	0	\N	0	0	\N	\N	0	248933	0	127783003	4133840		
42518	3927	3006322	2013-08-03	2013-08-03 00:00:00	2013-08-03	5001	0	\N	0	0	\N	\N	0	261101	0	8331-1	3006322		
399	16	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	1277	0	6158-0	3019406		
27518	2543	46235214	1976-11-14	1976-11-14 00:00:00	1976-11-14	5001	0	\N	0	0	\N	\N	0	168232	0	76690-7	46235214		
55722	5116	3006322	2016-08-23	2016-08-23 00:00:00	2016-08-23	5001	0	\N	0	0	\N	\N	0	339950	0	8331-1	3006322		
40093	3736	3006322	1985-04-12	1985-04-12 00:00:00	1985-04-12	5001	0	\N	0	0	\N	\N	0	248315	0	8331-1	3006322		
20704	1903	3006322	2010-07-16	2010-07-16 00:00:00	2010-07-16	5001	0	\N	0	0	\N	\N	0	126700	0	8331-1	3006322		
3506	337	3006322	1980-11-02	1980-11-02 00:00:00	1980-11-02	5001	0	\N	0	0	\N	\N	0	22446	0	8331-1	3006322		
25308	2326	3006322	2011-08-25	2011-08-25 00:00:00	2011-08-25	5001	0	\N	0	0	\N	\N	0	154638	0	8331-1	3006322		
25335	2332	3006322	2001-12-08	2001-12-08 00:00:00	2001-12-08	5001	0	\N	0	0	\N	\N	0	155072	0	8331-1	3006322		
26326	2419	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	160526	0	6844-5	3020655		
26429	2436	3019406	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	161510	0	6158-0	3019406		
20255	1852	3006322	1978-05-24	1978-05-24 00:00:00	1978-05-24	5001	0	\N	0	0	\N	\N	0	123894	0	8331-1	3006322		
5322	510	3006322	1979-07-22	1979-07-22 00:00:00	1979-07-22	5001	0	\N	0	0	\N	\N	0	34073	0	8331-1	3006322		
31726	2899	3006322	1951-09-17	1951-09-17 00:00:00	1951-09-17	5001	0	\N	0	0	\N	\N	0	193177	0	8331-1	3006322		
91279	2818	4024958	1977-04-16	1977-04-16 00:00:00	1977-04-16	5001	0	\N	0	0	\N	\N	0	186744	0	117015009	4024958		
38499	3561	3006322	1972-08-16	1972-08-16 00:00:00	1972-08-16	5001	0	\N	0	0	\N	\N	0	236511	0	8331-1	3006322		
38609	3568	46235214	1970-08-27	1970-08-27 00:00:00	1970-08-27	5001	0	\N	0	0	\N	\N	0	237071	0	76690-7	46235214		
38655	3571	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	237322	0	6158-0	3019406		
50032	4550	3036780	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	303229	0	6095-4	3036780		
44688	4127	3006322	2000-11-18	2000-11-18 00:00:00	2000-11-18	5001	0	\N	0	0	\N	\N	0	274314	0	8331-1	3006322		
28904	2669	46235214	1978-01-07	1978-01-07 00:00:00	1978-01-07	5001	0	\N	0	0	\N	\N	0	176809	0	76690-7	46235214		
28989	2673	3015076	1982-03-04	1982-03-04 00:00:00	1982-03-04	5001	0	\N	0	0	\N	\N	0	177076	0	6248-9	3015076		
77871	2389	4052083	1990-11-08	1990-11-08 00:00:00	1990-11-08	5001	0	\N	0	0	\N	\N	0	158837	0	23426006	4052083		
12992	1238	3006322	1976-06-06	1976-06-06 00:00:00	1976-06-06	5001	0	\N	0	0	\N	\N	0	81596	0	8331-1	3006322		
24031	2213	40769184	1991-07-21	1991-07-21 00:00:00	1991-07-21	5001	0	\N	0	0	\N	\N	0	147357	0	66524-0	40769184		
53546	4913	3051031	1970-08-12	1970-08-12 00:00:00	1970-08-12	5001	0	\N	0	0	\N	\N	0	326516	0	46240-8	3051031		
35819	3285	3006322	1994-09-13	1994-09-13 00:00:00	1994-09-13	5001	0	\N	0	0	\N	\N	0	218214	0	8331-1	3006322		
12165	1158	3006322	2010-06-16	2010-06-16 00:00:00	2010-06-16	5001	0	\N	0	0	\N	\N	0	76491	0	8331-1	3006322		
6146	188	4024958	2018-04-17	2018-04-17 00:00:00	2018-04-17	5001	0	\N	0	0	\N	\N	0	12788	0	117015009	4024958		
23596	2175	40766240	1977-06-27	1977-06-27 00:00:00	1977-06-27	5001	0	\N	0	0	\N	\N	0	144979	0	63513-6	40766240		
9365	884	3015076	1990-09-11	1990-09-11 00:00:00	1990-09-11	5001	0	\N	0	0	\N	\N	0	58941	0	6248-9	3015076		
38215	3526	40758406	2018-05-04	2018-05-04 00:00:00	2018-05-04	5001	0	\N	0	0	\N	\N	0	233996	0	55277-8	40758406		
47779	4376	46235214	1922-03-28	1922-03-28 00:00:00	1922-03-28	5001	0	\N	0	0	\N	\N	0	290824	0	76690-7	46235214		
129381	3984	4052083	1989-08-31	1989-08-31 00:00:00	1989-08-31	5001	0	\N	0	0	\N	\N	0	264837	0	23426006	4052083		
57858	5312	3011505	1982-11-29	1982-11-29 00:00:00	1982-11-29	5001	0	\N	0	0	\N	\N	0	353264	0	19926-5	3011505		
32372	2942	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	196157	0	6158-0	3019406		
15423	482	4024958	1990-03-18	1990-03-18 00:00:00	1990-03-18	5001	0	\N	0	0	\N	\N	0	32217	0	117015009	4024958		
106	3	40758406	1949-08-22	1949-08-22 00:00:00	1949-08-22	5001	0	\N	0	0	\N	\N	0	360	0	55277-8	40758406		
73737	2266	4024958	1971-04-04	1971-04-04 00:00:00	1971-04-04	5001	0	\N	0	0	\N	\N	0	150620	0	117015009	4024958		
6533	615	3023430	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	40867	0	6833-8	3023430		
21518	1980	3000876	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	131768	0	6082-2	3000876		
21617	1992	3005136	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	132713	0	6075-6	3005136		
21644	1999	3014599	2011-10-05	2011-10-05 00:00:00	2011-10-05	5001	0	\N	0	0	\N	\N	0	133114	0	6106-9	3014599		
33004	2980	3006451	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	198943	0	6273-7	3006451		
29487	2715	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	180031	0	6075-6	3005136		
55517	5097	3021226	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	338637	0	6246-3	3021226		
157280	4834	4052083	1983-09-13	1983-09-13 00:00:00	1983-09-13	5001	0	\N	0	0	\N	\N	0	321551	0	23426006	4052083		
43260	1328	4133840	2003-09-11	2003-09-11 00:00:00	2003-09-11	5001	0	\N	0	0	\N	\N	0	88170	0	127783003	4133840		
30605	2802	3006322	1941-03-13	1941-03-13 00:00:00	1941-03-13	5001	0	\N	0	0	\N	\N	0	185735	0	8331-1	3006322		
6644	621	3006322	1966-05-15	1966-05-15 00:00:00	1966-05-15	5001	0	\N	0	0	\N	\N	0	41417	0	8331-1	3006322		
33484	3028	3006322	2018-07-03	2018-07-03 00:00:00	2018-07-03	5001	0	\N	0	0	\N	\N	0	201906	0	8331-1	3006322		
52674	1597	4024958	1959-02-26	1959-02-26 00:00:00	1959-02-26	5001	0	\N	0	0	\N	\N	0	107099	0	117015009	4024958		
41911	1293	4024958	1953-04-03	1953-04-03 00:00:00	1953-04-03	5001	0	\N	0	0	\N	\N	0	85481	0	117015009	4024958		
158719	4878	4024958	1968-11-14	1968-11-14 00:00:00	1968-11-14	5001	0	\N	0	0	\N	\N	0	324329	0	117015009	4024958		
50561	1535	4052083	1986-10-28	1986-10-28 00:00:00	1986-10-28	5001	0	\N	0	0	\N	\N	0	102708	0	23426006	4052083		
5451	165	4052083	1983-05-26	1983-05-26 00:00:00	1983-05-26	5001	0	\N	0	0	\N	\N	0	11371	0	23426006	4052083		
53476	1618	4052083	1986-01-09	1986-01-09 00:00:00	1986-01-09	5001	0	\N	0	0	\N	\N	0	108800	0	23426006	4052083		
27857	2566	3051031	2016-09-29	2016-09-29 00:00:00	2016-09-29	5001	0	\N	0	0	\N	\N	0	170050	0	46240-8	3051031		
39205	3622	3006322	1969-12-14	1969-12-14 00:00:00	1969-12-14	5001	0	\N	0	0	\N	\N	0	240770	0	8331-1	3006322		
19532	1783	3006734	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	119524	0	6189-5	3006734		
22888	2094	3006322	1977-01-02	1977-01-02 00:00:00	1977-01-02	5001	0	\N	0	0	\N	\N	0	139594	0	8331-1	3006322		
76411	2342	4052083	2012-04-20	2012-04-20 00:00:00	2012-04-20	5001	0	\N	0	0	\N	\N	0	155926	0	23426006	4052083		
17090	1556	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	104226	0	6106-9	3014599		
99196	3041	4024958	1983-10-02	1983-10-02 00:00:00	1983-10-02	5001	0	\N	0	0	\N	\N	0	202528	0	117015009	4024958		
42519	3927	3006322	2015-01-18	2015-01-18 00:00:00	2015-01-18	5001	0	\N	0	0	\N	\N	0	261088	0	8331-1	3006322		
400	16	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	1277	0	6246-3	3021226		
27519	2543	40766240	1976-11-14	1976-11-14 00:00:00	1976-11-14	5001	0	\N	0	0	\N	\N	0	168232	0	63513-6	40766240		
55723	5116	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	339995	0	6844-5	3020655		
40094	3736	3006322	1957-02-21	1957-02-21 00:00:00	1957-02-21	5001	0	\N	0	0	\N	\N	0	248343	0	8331-1	3006322		
20705	1903	3006322	2018-05-19	2018-05-19 00:00:00	2018-05-19	5001	0	\N	0	0	\N	\N	0	126680	0	8331-1	3006322		
3507	337	40758406	2016-11-07	2016-11-07 00:00:00	2016-11-07	5001	0	\N	0	0	\N	\N	0	22423	0	55277-8	40758406		
25309	2326	3006322	2009-07-23	2009-07-23 00:00:00	2009-07-23	5001	0	\N	0	0	\N	\N	0	154662	0	8331-1	3006322		
25336	2332	3006322	1960-09-02	1960-09-02 00:00:00	1960-09-02	5001	0	\N	0	0	\N	\N	0	155045	0	8331-1	3006322		
26348	2423	3006322	2019-05-27	2019-05-27 00:00:00	2019-05-27	5001	0	\N	0	0	\N	\N	0	160723	0	8331-1	3006322		
26430	2436	3005136	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	161510	0	6075-6	3005136		
20256	1852	3006322	1976-07-22	1976-07-22 00:00:00	1976-07-22	5001	0	\N	0	0	\N	\N	0	123950	0	8331-1	3006322		
5323	510	3006322	1979-11-02	1979-11-02 00:00:00	1979-11-02	5001	0	\N	0	0	\N	\N	0	34074	0	8331-1	3006322		
31727	2899	3049273	2009-10-22	2009-10-22 00:00:00	2009-10-22	5001	0	\N	0	0	\N	\N	0	193167	0	38265-5	3049273		
91281	2818	4052083	1978-08-04	1978-08-04 00:00:00	1978-08-04	5001	0	\N	0	0	\N	\N	0	186745	0	23426006	4052083		
38500	3561	3006322	1983-03-14	1983-03-14 00:00:00	1983-03-14	5001	0	\N	0	0	\N	\N	0	236512	0	8331-1	3006322		
38611	3568	46235214	2004-08-13	2004-08-13 00:00:00	2004-08-13	5001	0	\N	0	0	\N	\N	0	237113	0	76690-7	46235214		
38656	3571	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	237322	0	6206-7	3012494		
50033	4550	3006734	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	303229	0	6189-5	3006734		
44691	4129	3006322	1978-04-24	1978-04-24 00:00:00	1978-04-24	5001	0	\N	0	0	\N	\N	0	274520	0	8331-1	3006322		
28905	2669	40758406	1978-01-07	1978-01-07 00:00:00	1978-01-07	5001	0	\N	0	0	\N	\N	0	176809	0	55277-8	40758406		
28990	2673	3021226	1982-03-04	1982-03-04 00:00:00	1982-03-04	5001	0	\N	0	0	\N	\N	0	177076	0	6246-3	3021226		
77906	2392	4133840	2011-08-05	2011-08-05 00:00:00	2011-08-05	5001	0	\N	0	0	\N	\N	0	159067	0	127783003	4133840		
12993	1238	3006322	2002-05-05	2002-05-05 00:00:00	2002-05-05	5001	0	\N	0	0	\N	\N	0	81612	0	8331-1	3006322		
24032	2213	40769189	1991-07-21	1991-07-21 00:00:00	1991-07-21	5001	0	\N	0	0	\N	\N	0	147357	0	66529-9	40769189		
53548	4913	40758406	1970-08-12	1970-08-12 00:00:00	1970-08-12	5001	0	\N	0	0	\N	\N	0	326516	0	55277-8	40758406		
35823	3287	3006322	1997-11-17	1997-11-17 00:00:00	1997-11-17	5001	0	\N	0	0	\N	\N	0	218367	0	8331-1	3006322		
12166	1158	3006322	2015-02-15	2015-02-15 00:00:00	2015-02-15	5001	0	\N	0	0	\N	\N	0	76523	0	8331-1	3006322		
6152	189	4024958	1963-08-01	1963-08-01 00:00:00	1963-08-01	5001	0	\N	0	0	\N	\N	0	12878	0	117015009	4024958		
23598	2175	46235214	1977-06-27	1977-06-27 00:00:00	1977-06-27	5001	0	\N	0	0	\N	\N	0	144979	0	76690-7	46235214		
9366	884	3012494	1990-09-11	1990-09-11 00:00:00	1990-09-11	5001	0	\N	0	0	\N	\N	0	58941	0	6206-7	3012494		
38216	3526	3051031	2018-05-04	2018-05-04 00:00:00	2018-05-04	5001	0	\N	0	0	\N	\N	0	233996	0	46240-8	3051031		
47780	4376	40766240	1922-03-28	1922-03-28 00:00:00	1922-03-28	5001	0	\N	0	0	\N	\N	0	290824	0	63513-6	40766240		
129391	3984	4024958	1959-04-11	1959-04-11 00:00:00	1959-04-11	5001	0	\N	0	0	\N	\N	0	264841	0	117015009	4024958		
57859	5312	3006322	1995-12-22	1995-12-22 00:00:00	1995-12-22	5001	0	\N	0	0	\N	\N	0	353288	0	8331-1	3006322		
32373	2942	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	196157	0	6248-9	3015076		
15435	482	4024958	1974-06-01	1974-06-01 00:00:00	1974-06-01	5001	0	\N	0	0	\N	\N	0	32231	0	117015009	4024958		
107	3	3051031	1949-08-22	1949-08-22 00:00:00	1949-08-22	5001	0	\N	0	0	\N	\N	0	360	0	46240-8	3051031		
73741	2266	4024958	2009-05-14	2009-05-14 00:00:00	2009-05-14	5001	0	\N	0	0	\N	\N	0	150643	0	117015009	4024958		
6534	615	3006734	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	40867	0	6189-5	3006734		
21519	1980	3036780	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	131768	0	6095-4	3036780		
21618	1992	3036780	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	132713	0	6095-4	3036780		
21645	1999	40769189	2011-09-23	2011-09-23 00:00:00	2011-09-23	5001	0	\N	0	0	\N	\N	0	133054	0	66529-9	40769189		
33005	2980	3014599	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	198943	0	6106-9	3014599		
29488	2715	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	180031	0	6246-3	3021226		
55518	5097	3001488	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	338637	0	7258-7	3001488		
157290	4835	4024958	2008-11-14	2008-11-14 00:00:00	2008-11-14	5001	0	\N	0	0	\N	\N	0	321644	0	117015009	4024958		
43265	1328	4133840	1989-12-21	1989-12-21 00:00:00	1989-12-21	5001	0	\N	0	0	\N	\N	0	88205	0	127783003	4133840		
30606	2802	3006322	1963-09-15	1963-09-15 00:00:00	1963-09-15	5001	0	\N	0	0	\N	\N	0	185764	0	8331-1	3006322		
34994	1091	4024958	1987-01-16	1987-01-16 00:00:00	1987-01-16	5001	0	\N	0	0	\N	\N	0	71596	0	117015009	4024958		
33485	3028	3006322	1968-05-06	1968-05-06 00:00:00	1968-05-06	5001	0	\N	0	0	\N	\N	0	201878	0	8331-1	3006322		
52682	1597	4024958	1960-10-01	1960-10-01 00:00:00	1960-10-01	5001	0	\N	0	0	\N	\N	0	107107	0	117015009	4024958		
41921	1294	4052083	1978-09-19	1978-09-19 00:00:00	1978-09-19	5001	0	\N	0	0	\N	\N	0	85650	0	23426006	4052083		
132363	4077	4052083	1975-03-23	1975-03-23 00:00:00	1975-03-23	5001	0	\N	0	0	\N	\N	0	270898	0	23426006	4052083		
50563	1535	4052083	1995-11-21	1995-11-21 00:00:00	1995-11-21	5001	0	\N	0	0	\N	\N	0	102701	0	23426006	4052083		
29624	2724	3006322	1957-01-24	1957-01-24 00:00:00	1957-01-24	5001	0	\N	0	0	\N	\N	0	180491	0	8331-1	3006322		
64800	1987	4024958	1952-09-06	1952-09-06 00:00:00	1952-09-06	5001	0	\N	0	0	\N	\N	0	132317	0	117015009	4024958		
27858	2566	3006322	1943-09-05	1943-09-05 00:00:00	1943-09-05	5001	0	\N	0	0	\N	\N	0	170006	0	8331-1	3006322		
39206	3623	3006322	2012-04-23	2012-04-23 00:00:00	2012-04-23	5001	0	\N	0	0	\N	\N	0	240871	0	8331-1	3006322		
19533	1783	3023430	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	119524	0	6833-8	3023430		
70683	2166	4024958	2015-04-26	2015-04-26 00:00:00	2015-04-26	5001	0	\N	0	0	\N	\N	0	144318	0	117015009	4024958		
76415	2342	4024958	2007-09-27	2007-09-27 00:00:00	2007-09-27	5001	0	\N	0	0	\N	\N	0	155924	0	117015009	4024958		
17091	1556	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	104226	0	6833-8	3023430		
99198	3041	4024958	2001-10-30	2001-10-30 00:00:00	2001-10-30	5001	0	\N	0	0	\N	\N	0	202525	0	117015009	4024958		
42520	3927	3006322	1967-10-21	1967-10-21 00:00:00	1967-10-21	5001	0	\N	0	0	\N	\N	0	261052	0	8331-1	3006322		
401	16	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	1277	0	6273-7	3006451		
27521	2543	46235214	1977-03-14	1977-03-14 00:00:00	1977-03-14	5001	0	\N	0	0	\N	\N	0	168249	0	76690-7	46235214		
55724	5116	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	339995	0	6833-8	3023430		
40095	3736	3006322	1965-05-16	1965-05-16 00:00:00	1965-05-16	5001	0	\N	0	0	\N	\N	0	248273	0	8331-1	3006322		
20709	1905	3006322	1990-01-27	1990-01-27 00:00:00	1990-01-27	5001	0	\N	0	0	\N	\N	0	126821	0	8331-1	3006322		
3510	337	40766240	2016-11-07	2016-11-07 00:00:00	2016-11-07	5001	0	\N	0	0	\N	\N	0	22423	0	63513-6	40766240		
25310	2326	3006322	2008-10-15	2008-10-15 00:00:00	2008-10-15	5001	0	\N	0	0	\N	\N	0	154637	0	8331-1	3006322		
25337	2332	3006322	1963-09-01	1963-09-01 00:00:00	1963-09-01	5001	0	\N	0	0	\N	\N	0	155048	0	8331-1	3006322		
26349	2423	3049273	2016-12-19	2016-12-19 00:00:00	2016-12-19	5001	0	\N	0	0	\N	\N	0	160790	0	38265-5	3049273		
26431	2436	3006451	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	161510	0	6273-7	3006451		
20261	1854	3006322	1973-08-23	1973-08-23 00:00:00	1973-08-23	5001	0	\N	0	0	\N	\N	0	124121	0	8331-1	3006322		
5324	510	3006322	2001-06-24	2001-06-24 00:00:00	2001-06-24	5001	0	\N	0	0	\N	\N	0	34094	0	8331-1	3006322		
31728	2899	3006322	1981-12-15	1981-12-15 00:00:00	1981-12-15	5001	0	\N	0	0	\N	\N	0	193146	0	8331-1	3006322		
158388	4867	4024958	1931-09-07	1931-09-07 00:00:00	1931-09-07	5001	0	\N	0	0	\N	\N	0	323642	0	117015009	4024958		
38501	3561	3006322	1972-02-04	1972-02-04 00:00:00	1972-02-04	5001	0	\N	0	0	\N	\N	0	236517	0	8331-1	3006322		
38613	3568	40766240	2004-08-13	2004-08-13 00:00:00	2004-08-13	5001	0	\N	0	0	\N	\N	0	237113	0	63513-6	40766240		
38657	3571	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	237322	0	6075-6	3005136		
50034	4550	3020655	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	303229	0	6844-5	3020655		
44692	4129	3006322	1977-04-19	1977-04-19 00:00:00	1977-04-19	5001	0	\N	0	0	\N	\N	0	274446	0	8331-1	3006322		
28907	2669	3051031	1978-01-07	1978-01-07 00:00:00	1978-01-07	5001	0	\N	0	0	\N	\N	0	176809	0	46240-8	3051031		
28991	2673	3014599	1982-03-04	1982-03-04 00:00:00	1982-03-04	5001	0	\N	0	0	\N	\N	0	177076	0	6106-9	3014599		
77910	2392	4133840	1997-05-16	1997-05-16 00:00:00	1997-05-16	5001	0	\N	0	0	\N	\N	0	158971	0	127783003	4133840		
12994	1238	3006322	1956-09-05	1956-09-05 00:00:00	1956-09-05	5001	0	\N	0	0	\N	\N	0	81573	0	8331-1	3006322		
24033	2213	40769194	1991-07-21	1991-07-21 00:00:00	1991-07-21	5001	0	\N	0	0	\N	\N	0	147357	0	66534-9	40769194		
53550	4913	40766240	1970-08-12	1970-08-12 00:00:00	1970-08-12	5001	0	\N	0	0	\N	\N	0	326516	0	63513-6	40766240		
35824	3287	3006322	1971-12-20	1971-12-20 00:00:00	1971-12-20	5001	0	\N	0	0	\N	\N	0	218330	0	8331-1	3006322		
12167	1159	3006322	2002-09-02	2002-09-02 00:00:00	2002-09-02	5001	0	\N	0	0	\N	\N	0	76580	0	8331-1	3006322		
6158	189	4024958	1959-10-06	1959-10-06 00:00:00	1959-10-06	5001	0	\N	0	0	\N	\N	0	12861	0	117015009	4024958		
23599	2175	40758406	1977-06-27	1977-06-27 00:00:00	1977-06-27	5001	0	\N	0	0	\N	\N	0	144979	0	55277-8	40758406		
9367	884	3001247	1990-09-11	1990-09-11 00:00:00	1990-09-11	5001	0	\N	0	0	\N	\N	0	58941	0	6085-5	3001247		
38218	3526	40766240	2018-05-04	2018-05-04 00:00:00	2018-05-04	5001	0	\N	0	0	\N	\N	0	233996	0	63513-6	40766240		
47781	4376	3051031	1922-03-28	1922-03-28 00:00:00	1922-03-28	5001	0	\N	0	0	\N	\N	0	290824	0	46240-8	3051031		
15130	474	4024958	1993-05-23	1993-05-23 00:00:00	1993-05-23	5001	0	\N	0	0	\N	\N	0	31610	0	117015009	4024958		
57861	5312	3011505	1973-12-31	1973-12-31 00:00:00	1973-12-31	5001	0	\N	0	0	\N	\N	0	353262	0	19926-5	3011505		
32374	2942	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	196157	0	6075-6	3005136		
126870	3904	4052083	1995-05-05	1995-05-05 00:00:00	1995-05-05	5001	0	\N	0	0	\N	\N	0	259594	0	23426006	4052083		
108	3	40766240	1949-08-22	1949-08-22 00:00:00	1949-08-22	5001	0	\N	0	0	\N	\N	0	360	0	63513-6	40766240		
111477	3442	4052083	1965-03-19	1965-03-19 00:00:00	1965-03-19	5001	0	\N	0	0	\N	\N	0	228397	0	23426006	4052083		
6535	615	3012494	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	40867	0	6206-7	3012494		
21520	1980	3006322	1976-11-19	1976-11-19 00:00:00	1976-11-19	5001	0	\N	0	0	\N	\N	0	131825	0	8331-1	3006322		
21619	1992	3027231	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	132713	0	6276-0	3027231		
21646	1999	40769179	2011-09-23	2011-09-23 00:00:00	2011-09-23	5001	0	\N	0	0	\N	\N	0	133054	0	66519-0	40769179		
33006	2980	3005136	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	198943	0	6075-6	3005136		
29489	2715	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	180031	0	6273-7	3006451		
55519	5097	3006734	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	338637	0	6189-5	3006734		
157294	4835	4024958	1971-01-26	1971-01-26 00:00:00	1971-01-26	5001	0	\N	0	0	\N	\N	0	321637	0	117015009	4024958		
43266	1328	4133840	1983-12-08	1983-12-08 00:00:00	1983-12-08	5001	0	\N	0	0	\N	\N	0	88228	0	127783003	4133840		
30607	2802	3006322	1953-09-01	1953-09-01 00:00:00	1953-09-01	5001	0	\N	0	0	\N	\N	0	185705	0	8331-1	3006322		
35006	1091	4024958	2007-11-20	2007-11-20 00:00:00	2007-11-20	5001	0	\N	0	0	\N	\N	0	71702	0	117015009	4024958		
33486	3028	3006322	1990-04-05	1990-04-05 00:00:00	1990-04-05	5001	0	\N	0	0	\N	\N	0	201880	0	8331-1	3006322		
52690	1597	4024958	1973-02-08	1973-02-08 00:00:00	1973-02-08	5001	0	\N	0	0	\N	\N	0	107100	0	117015009	4024958		
34146	1070	4052083	1987-01-02	1987-01-02 00:00:00	1987-01-02	5001	0	\N	0	0	\N	\N	0	70062	0	23426006	4052083		
132365	4077	4024958	1984-11-03	1984-11-03 00:00:00	1984-11-03	5001	0	\N	0	0	\N	\N	0	270911	0	117015009	4024958		
50579	1536	4133840	1966-02-20	1966-02-20 00:00:00	1966-02-20	5001	0	\N	0	0	\N	\N	0	102775	0	127783003	4133840		
29625	2724	3006322	1979-08-22	1979-08-22 00:00:00	1979-08-22	5001	0	\N	0	0	\N	\N	0	180498	0	8331-1	3006322		
38102	3516	3006322	2008-08-15	2008-08-15 00:00:00	2008-08-15	5001	0	\N	0	0	\N	\N	0	233327	0	8331-1	3006322		
27860	2566	46235214	2016-07-31	2016-07-31 00:00:00	2016-07-31	5001	0	\N	0	0	\N	\N	0	169945	0	76690-7	46235214		
39207	3623	3006322	1955-01-21	1955-01-21 00:00:00	1955-01-21	5001	0	\N	0	0	\N	\N	0	240922	0	8331-1	3006322		
19534	1783	3020655	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	119524	0	6844-5	3020655		
70689	2166	4052083	1970-01-08	1970-01-08 00:00:00	1970-01-08	5001	0	\N	0	0	\N	\N	0	144277	0	23426006	4052083		
87714	2711	4052083	1966-11-08	1966-11-08 00:00:00	1966-11-08	5001	0	\N	0	0	\N	\N	0	179774	0	23426006	4052083		
17092	1556	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	104226	0	6189-5	3006734		
65149	1998	4052083	2019-02-22	2019-02-22 00:00:00	2019-02-22	5001	0	\N	0	0	\N	\N	0	133030	0	23426006	4052083		
42521	3928	3006322	1993-10-28	1993-10-28 00:00:00	1993-10-28	5001	0	\N	0	0	\N	\N	0	261135	0	8331-1	3006322		
402	17	3006322	1958-11-30	1958-11-30 00:00:00	1958-11-30	5001	0	\N	0	0	\N	\N	0	1285	0	8331-1	3006322		
27524	2543	40766240	1977-03-14	1977-03-14 00:00:00	1977-03-14	5001	0	\N	0	0	\N	\N	0	168249	0	63513-6	40766240		
55725	5116	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	339995	0	6095-4	3036780		
40096	3736	3006322	2002-06-18	2002-06-18 00:00:00	2002-06-18	5001	0	\N	0	0	\N	\N	0	248320	0	8331-1	3006322		
20710	1905	3006322	1990-08-07	1990-08-07 00:00:00	1990-08-07	5001	0	\N	0	0	\N	\N	0	126805	0	8331-1	3006322		
3511	337	46235214	2016-11-07	2016-11-07 00:00:00	2016-11-07	5001	0	\N	0	0	\N	\N	0	22423	0	76690-7	46235214		
25311	2326	3006322	1985-01-10	1985-01-10 00:00:00	1985-01-10	5001	0	\N	0	0	\N	\N	0	154675	0	8331-1	3006322		
25338	2333	3006322	1945-01-18	1945-01-18 00:00:00	1945-01-18	5001	0	\N	0	0	\N	\N	0	155236	0	8331-1	3006322		
26350	2423	3006322	1981-07-07	1981-07-07 00:00:00	1981-07-07	5001	0	\N	0	0	\N	\N	0	160722	0	8331-1	3006322		
26432	2436	3027231	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	161510	0	6276-0	3027231		
20262	1855	3006322	2005-11-21	2005-11-21 00:00:00	2005-11-21	5001	0	\N	0	0	\N	\N	0	124224	0	8331-1	3006322		
5362	512	46235214	1960-07-17	1960-07-17 00:00:00	1960-07-17	5001	0	\N	0	0	\N	\N	0	34186	0	76690-7	46235214		
31729	2899	3006322	2012-05-30	2012-05-30 00:00:00	2012-05-30	5001	0	\N	0	0	\N	\N	0	193149	0	8331-1	3006322		
112603	3477	4052083	2010-08-18	2010-08-18 00:00:00	2010-08-18	5001	0	\N	0	0	\N	\N	0	230610	0	23426006	4052083		
38502	3561	3006322	1948-09-24	1948-09-24 00:00:00	1948-09-24	5001	0	\N	0	0	\N	\N	0	236508	0	8331-1	3006322		
38614	3568	40758406	2004-08-13	2004-08-13 00:00:00	2004-08-13	5001	0	\N	0	0	\N	\N	0	237113	0	55277-8	40758406		
38658	3571	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	237322	0	6248-9	3015076		
50035	4550	3006451	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	303229	0	6273-7	3006451		
44693	4129	3006322	2018-11-16	2018-11-16 00:00:00	2018-11-16	5001	0	\N	0	0	\N	\N	0	274510	0	8331-1	3006322		
28909	2669	40766240	1978-01-07	1978-01-07 00:00:00	1978-01-07	5001	0	\N	0	0	\N	\N	0	176809	0	63513-6	40766240		
28992	2673	3012494	1982-03-04	1982-03-04 00:00:00	1982-03-04	5001	0	\N	0	0	\N	\N	0	177076	0	6206-7	3012494		
77912	2392	4133840	1992-04-17	1992-04-17 00:00:00	1992-04-17	5001	0	\N	0	0	\N	\N	0	158993	0	127783003	4133840		
12995	1238	3006322	2007-07-20	2007-07-20 00:00:00	2007-07-20	5001	0	\N	0	0	\N	\N	0	81574	0	8331-1	3006322		
24034	2213	3006322	1982-01-01	1982-01-01 00:00:00	1982-01-01	5001	0	\N	0	0	\N	\N	0	147389	0	8331-1	3006322		
53551	4913	46235214	1970-08-12	1970-08-12 00:00:00	1970-08-12	5001	0	\N	0	0	\N	\N	0	326516	0	76690-7	46235214		
35827	3289	3006322	1978-07-29	1978-07-29 00:00:00	1978-07-29	5001	0	\N	0	0	\N	\N	0	218534	0	8331-1	3006322		
12168	1159	3006322	2012-09-19	2012-09-19 00:00:00	2012-09-19	5001	0	\N	0	0	\N	\N	0	76536	0	8331-1	3006322		
6165	189	4052083	2012-09-24	2012-09-24 00:00:00	2012-09-24	5001	0	\N	0	0	\N	\N	0	12839	0	23426006	4052083		
23600	2175	3006734	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	145012	0	6189-5	3006734		
9368	884	3001488	1990-09-11	1990-09-11 00:00:00	1990-09-11	5001	0	\N	0	0	\N	\N	0	58941	0	7258-7	3001488		
38219	3526	46235214	2018-05-04	2018-05-04 00:00:00	2018-05-04	5001	0	\N	0	0	\N	\N	0	233996	0	76690-7	46235214		
47782	4376	40758406	1922-03-28	1922-03-28 00:00:00	1922-03-28	5001	0	\N	0	0	\N	\N	0	290824	0	55277-8	40758406		
15132	474	4052083	2017-09-04	2017-09-04 00:00:00	2017-09-04	5001	0	\N	0	0	\N	\N	0	31604	0	23426006	4052083		
57862	5312	3011505	1984-12-03	1984-12-03 00:00:00	1984-12-03	5001	0	\N	0	0	\N	\N	0	353239	0	19926-5	3011505		
32375	2942	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	196157	0	6206-7	3012494		
126873	3904	4052083	2009-06-09	2009-06-09 00:00:00	2009-06-09	5001	0	\N	0	0	\N	\N	0	259626	0	23426006	4052083		
109	3	46235214	1949-08-22	1949-08-22 00:00:00	1949-08-22	5001	0	\N	0	0	\N	\N	0	360	0	76690-7	46235214		
111479	3442	4024958	1967-07-07	1967-07-07 00:00:00	1967-07-07	5001	0	\N	0	0	\N	\N	0	228428	0	117015009	4024958		
6536	615	3000876	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	40867	0	6082-2	3000876		
21525	1982	3006322	1985-09-23	1985-09-23 00:00:00	1985-09-23	5001	0	\N	0	0	\N	\N	0	131994	0	8331-1	3006322		
21620	1992	3006451	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	132713	0	6273-7	3006451		
21647	1999	40769194	2011-09-23	2011-09-23 00:00:00	2011-09-23	5001	0	\N	0	0	\N	\N	0	133054	0	66534-9	40769194		
33007	2980	3021226	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	198943	0	6246-3	3021226		
29490	2715	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	180031	0	6844-5	3020655		
55520	5097	3023430	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	338637	0	6833-8	3023430		
157295	4835	4024958	1980-07-16	1980-07-16 00:00:00	1980-07-16	5001	0	\N	0	0	\N	\N	0	321638	0	117015009	4024958		
43267	1328	4133840	1998-08-13	1998-08-13 00:00:00	1998-08-13	5001	0	\N	0	0	\N	\N	0	88231	0	127783003	4133840		
30608	2802	3006322	1955-06-07	1955-06-07 00:00:00	1955-06-07	5001	0	\N	0	0	\N	\N	0	185737	0	8331-1	3006322		
35017	1091	4024958	1961-12-12	1961-12-12 00:00:00	1961-12-12	5001	0	\N	0	0	\N	\N	0	71688	0	117015009	4024958		
33487	3028	3006322	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	201896	0	8331-1	3006322		
52702	1598	4052083	2002-08-21	2002-08-21 00:00:00	2002-08-21	5001	0	\N	0	0	\N	\N	0	107210	0	23426006	4052083		
34150	1070	4052083	2017-06-26	2017-06-26 00:00:00	2017-06-26	5001	0	\N	0	0	\N	\N	0	70049	0	23426006	4052083		
132366	4077	4052083	2013-07-17	2013-07-17 00:00:00	2013-07-17	5001	0	\N	0	0	\N	\N	0	270901	0	23426006	4052083		
50581	1536	4133840	1970-11-22	1970-11-22 00:00:00	1970-11-22	5001	0	\N	0	0	\N	\N	0	102769	0	127783003	4133840		
29626	2724	3000963	2013-05-08	2013-05-08 00:00:00	2013-05-08	5001	0	\N	0	0	\N	\N	0	180487	0	718-7	3000963		
38103	3516	3006322	1993-09-09	1993-09-09 00:00:00	1993-09-09	5001	0	\N	0	0	\N	\N	0	233392	0	8331-1	3006322		
27861	2566	40758406	2016-07-31	2016-07-31 00:00:00	2016-07-31	5001	0	\N	0	0	\N	\N	0	169945	0	55277-8	40758406		
39208	3623	3006322	1964-05-01	1964-05-01 00:00:00	1964-05-01	5001	0	\N	0	0	\N	\N	0	240892	0	8331-1	3006322		
19535	1783	3006322	2001-11-01	2001-11-01 00:00:00	2001-11-01	5001	0	\N	0	0	\N	\N	0	119391	0	8331-1	3006322		
70696	2166	4024958	1975-03-14	1975-03-14 00:00:00	1975-03-14	5001	0	\N	0	0	\N	\N	0	144288	0	117015009	4024958		
87751	2711	4024958	1959-10-13	1959-10-13 00:00:00	1959-10-13	5001	0	\N	0	0	\N	\N	0	179771	0	117015009	4024958		
17093	1556	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	104226	0	6273-7	3006451		
76436	2343	4052083	2002-11-05	2002-11-05 00:00:00	2002-11-05	5001	0	\N	0	0	\N	\N	0	155953	0	23426006	4052083		
42522	3928	3006322	2006-06-02	2006-06-02 00:00:00	2006-06-02	5001	0	\N	0	0	\N	\N	0	261137	0	8331-1	3006322		
403	17	3006322	2011-09-19	2011-09-19 00:00:00	2011-09-19	5001	0	\N	0	0	\N	\N	0	1316	0	8331-1	3006322		
27525	2543	40758406	1977-03-14	1977-03-14 00:00:00	1977-03-14	5001	0	\N	0	0	\N	\N	0	168249	0	55277-8	40758406		
55726	5116	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	339995	0	6106-9	3014599		
64792	1987	4052083	1950-03-11	1950-03-11 00:00:00	1950-03-11	5001	0	\N	0	0	\N	\N	0	132282	0	23426006	4052083		
20711	1905	3006322	2018-06-04	2018-06-04 00:00:00	2018-06-04	5001	0	\N	0	0	\N	\N	0	126809	0	8331-1	3006322		
3512	337	3051031	2016-11-07	2016-11-07 00:00:00	2016-11-07	5001	0	\N	0	0	\N	\N	0	22423	0	46240-8	3051031		
25312	2326	3006322	1983-02-05	1983-02-05 00:00:00	1983-02-05	5001	0	\N	0	0	\N	\N	0	154647	0	8331-1	3006322		
25339	2333	3006322	1921-12-27	1921-12-27 00:00:00	1921-12-27	5001	0	\N	0	0	\N	\N	0	155129	0	8331-1	3006322		
26351	2423	3006322	1967-12-08	1967-12-08 00:00:00	1967-12-08	5001	0	\N	0	0	\N	\N	0	160727	0	8331-1	3006322		
26433	2436	3015076	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	161510	0	6248-9	3015076		
20263	1855	3006322	1990-05-03	1990-05-03 00:00:00	1990-05-03	5001	0	\N	0	0	\N	\N	0	124222	0	8331-1	3006322		
5363	512	40766240	1960-07-17	1960-07-17 00:00:00	1960-07-17	5001	0	\N	0	0	\N	\N	0	34186	0	63513-6	40766240		
31730	2899	3006322	2004-02-28	2004-02-28 00:00:00	2004-02-28	5001	0	\N	0	0	\N	\N	0	193147	0	8331-1	3006322		
171618	5267	4024958	1972-02-23	1972-02-23 00:00:00	1972-02-23	5001	0	\N	0	0	\N	\N	0	350428	0	117015009	4024958		
38503	3561	3006322	2013-08-06	2013-08-06 00:00:00	2013-08-06	5001	0	\N	0	0	\N	\N	0	236490	0	8331-1	3006322		
38615	3568	3051031	2004-08-13	2004-08-13 00:00:00	2004-08-13	5001	0	\N	0	0	\N	\N	0	237113	0	46240-8	3051031		
38659	3571	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	237322	0	6082-2	3000876		
50036	4550	3014599	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	303229	0	6106-9	3014599		
44694	4129	3006322	1955-03-05	1955-03-05 00:00:00	1955-03-05	5001	0	\N	0	0	\N	\N	0	274444	0	8331-1	3006322		
28911	2669	40766240	1979-07-31	1979-07-31 00:00:00	1979-07-31	5001	0	\N	0	0	\N	\N	0	176783	0	63513-6	40766240		
28993	2673	3036780	1982-03-04	1982-03-04 00:00:00	1982-03-04	5001	0	\N	0	0	\N	\N	0	177076	0	6095-4	3036780		
77914	2392	4133840	1990-04-06	1990-04-06 00:00:00	1990-04-06	5001	0	\N	0	0	\N	\N	0	159006	0	127783003	4133840		
12996	1239	3006322	1987-10-23	1987-10-23 00:00:00	1987-10-23	5001	0	\N	0	0	\N	\N	0	81669	0	8331-1	3006322		
48803	1486	4052083	2007-06-16	2007-06-16 00:00:00	2007-06-16	5001	0	\N	0	0	\N	\N	0	99152	0	23426006	4052083		
53556	4916	3006322	1988-04-22	1988-04-22 00:00:00	1988-04-22	5001	0	\N	0	0	\N	\N	0	326688	0	8331-1	3006322		
35828	3289	3006322	2005-07-14	2005-07-14 00:00:00	2005-07-14	5001	0	\N	0	0	\N	\N	0	218516	0	8331-1	3006322		
12171	1162	46235214	1963-01-19	1963-01-19 00:00:00	1963-01-19	5001	0	\N	0	0	\N	\N	0	76662	0	76690-7	46235214		
6270	191	4133840	1991-10-01	1991-10-01 00:00:00	1991-10-01	5001	0	\N	0	0	\N	\N	0	13127	0	127783003	4133840		
23601	2175	3020655	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	145012	0	6844-5	3020655		
9369	884	3020655	1990-09-11	1990-09-11 00:00:00	1990-09-11	5001	0	\N	0	0	\N	\N	0	58941	0	6844-5	3020655		
38220	3526	3006322	1955-01-13	1955-01-13 00:00:00	1955-01-13	5001	0	\N	0	0	\N	\N	0	233906	0	8331-1	3006322		
47783	4376	3011505	2017-01-31	2017-01-31 00:00:00	2017-01-31	5001	0	\N	0	0	\N	\N	0	290758	0	19926-5	3011505		
15133	474	4024958	2002-03-03	2002-03-03 00:00:00	2002-03-03	5001	0	\N	0	0	\N	\N	0	31654	0	117015009	4024958		
57863	5312	3011505	1992-11-23	1992-11-23 00:00:00	1992-11-23	5001	0	\N	0	0	\N	\N	0	353244	0	19926-5	3011505		
108378	3347	4024958	1963-07-26	1963-07-26 00:00:00	1963-07-26	5001	0	\N	0	0	\N	\N	0	222035	0	117015009	4024958		
126891	3906	4024958	1944-01-16	1944-01-16 00:00:00	1944-01-16	5001	0	\N	0	0	\N	\N	0	259669	0	117015009	4024958		
110	3	46235214	1993-12-04	1993-12-04 00:00:00	1993-12-04	5001	0	\N	0	0	\N	\N	0	224	0	76690-7	46235214		
111489	3442	4024958	1974-06-11	1974-06-11 00:00:00	1974-06-11	5001	0	\N	0	0	\N	\N	0	228446	0	117015009	4024958		
6537	615	3001247	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	40867	0	6085-5	3001247		
21526	1982	3006322	1954-01-14	1954-01-14 00:00:00	1954-01-14	5001	0	\N	0	0	\N	\N	0	131950	0	8331-1	3006322		
21621	1992	3014599	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	132713	0	6106-9	3014599		
21648	1999	40769184	2011-09-23	2011-09-23 00:00:00	2011-09-23	5001	0	\N	0	0	\N	\N	0	133054	0	66524-0	40769184		
33008	2980	3019406	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	198943	0	6158-0	3019406		
29491	2715	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	180031	0	6082-2	3000876		
55521	5097	3036780	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	338637	0	6095-4	3036780		
10635	1032	3006322	1982-12-16	1982-12-16 00:00:00	1982-12-16	5001	0	\N	0	0	\N	\N	0	67886	0	8331-1	3006322		
43269	1328	4133840	2016-04-14	2016-04-14 00:00:00	2016-04-14	5001	0	\N	0	0	\N	\N	0	88215	0	127783003	4133840		
41887	3879	40758406	2006-12-27	2006-12-27 00:00:00	2006-12-27	5001	0	\N	0	0	\N	\N	0	257660	0	55277-8	40758406		
22091	2028	3006322	1997-10-27	1997-10-27 00:00:00	1997-10-27	5001	0	\N	0	0	\N	\N	0	135008	0	8331-1	3006322		
33492	3030	3006322	2013-07-04	2013-07-04 00:00:00	2013-07-04	5001	0	\N	0	0	\N	\N	0	202014	0	8331-1	3006322		
52721	1598	4052083	2009-09-12	2009-09-12 00:00:00	2009-09-12	5001	0	\N	0	0	\N	\N	0	107238	0	23426006	4052083		
153813	4719	4052083	2009-10-22	2009-10-22 00:00:00	2009-10-22	5001	0	\N	0	0	\N	\N	0	314332	0	23426006	4052083		
132367	4077	4052083	2006-01-12	2006-01-12 00:00:00	2006-01-12	5001	0	\N	0	0	\N	\N	0	270893	0	23426006	4052083		
50582	1536	4133840	1967-02-26	1967-02-26 00:00:00	1967-02-26	5001	0	\N	0	0	\N	\N	0	102844	0	127783003	4133840		
29627	2724	3009542	2013-05-08	2013-05-08 00:00:00	2013-05-08	5001	0	\N	0	0	\N	\N	0	180487	0	20570-8	3009542		
38104	3516	3006322	1957-09-25	1957-09-25 00:00:00	1957-09-25	5001	0	\N	0	0	\N	\N	0	233321	0	8331-1	3006322		
27863	2566	3051031	2016-07-31	2016-07-31 00:00:00	2016-07-31	5001	0	\N	0	0	\N	\N	0	169945	0	46240-8	3051031		
39209	3623	3006322	1982-04-10	1982-04-10 00:00:00	1982-04-10	5001	0	\N	0	0	\N	\N	0	240888	0	8331-1	3006322		
19536	1783	40769179	1962-12-20	1962-12-20 00:00:00	1962-12-20	5001	0	\N	0	0	\N	\N	0	119378	0	66519-0	40769179		
70699	2166	4052083	1990-04-10	1990-04-10 00:00:00	1990-04-10	5001	0	\N	0	0	\N	\N	0	144315	0	23426006	4052083		
87760	2711	4052083	1952-12-14	1952-12-14 00:00:00	1952-12-14	5001	0	\N	0	0	\N	\N	0	179707	0	23426006	4052083		
41770	1289	4024958	1989-06-11	1989-06-11 00:00:00	1989-06-11	5001	0	\N	0	0	\N	\N	0	85195	0	117015009	4024958		
76470	2344	4052083	1970-11-19	1970-11-19 00:00:00	1970-11-19	5001	0	\N	0	0	\N	\N	0	156024	0	23426006	4052083		
42523	3929	3011505	2004-01-05	2004-01-05 00:00:00	2004-01-05	5001	0	\N	0	0	\N	\N	0	261183	0	19926-5	3011505		
404	17	3006322	1963-12-02	1963-12-02 00:00:00	1963-12-02	5001	0	\N	0	0	\N	\N	0	1333	0	8331-1	3006322		
27526	2543	3051031	1977-03-14	1977-03-14 00:00:00	1977-03-14	5001	0	\N	0	0	\N	\N	0	168249	0	46240-8	3051031		
55727	5116	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	339995	0	6246-3	3021226		
76077	2334	4133840	2008-06-05	2008-06-05 00:00:00	2008-06-05	5001	0	\N	0	0	\N	\N	0	155302	0	127783003	4133840		
20712	1905	3006322	1980-01-09	1980-01-09 00:00:00	1980-01-09	5001	0	\N	0	0	\N	\N	0	126814	0	8331-1	3006322		
3513	338	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	22525	0	7258-7	3001488		
5475	520	3051031	1952-02-07	1952-02-07 00:00:00	1952-02-07	5001	0	\N	0	0	\N	\N	0	34693	0	46240-8	3051031		
25340	2333	3006322	1966-02-24	1966-02-24 00:00:00	1966-02-24	5001	0	\N	0	0	\N	\N	0	155203	0	8331-1	3006322		
26352	2423	3006322	1964-03-15	1964-03-15 00:00:00	1964-03-15	5001	0	\N	0	0	\N	\N	0	160749	0	8331-1	3006322		
26434	2436	3014599	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	161510	0	6106-9	3014599		
20303	1860	3006322	1991-07-14	1991-07-14 00:00:00	1991-07-14	5001	0	\N	0	0	\N	\N	0	124383	0	8331-1	3006322		
5364	512	3051031	1960-07-17	1960-07-17 00:00:00	1960-07-17	5001	0	\N	0	0	\N	\N	0	34186	0	46240-8	3051031		
31731	2899	3006322	1973-01-15	1973-01-15 00:00:00	1973-01-15	5001	0	\N	0	0	\N	\N	0	193116	0	8331-1	3006322		
70358	2155	4052083	1935-05-28	1935-05-28 00:00:00	1935-05-28	5001	0	\N	0	0	\N	\N	0	143653	0	23426006	4052083		
38504	3561	3049273	1967-04-02	1967-04-02 00:00:00	1967-04-02	5001	0	\N	0	0	\N	\N	0	236472	0	38265-5	3049273		
38616	3569	3006322	1999-08-12	1999-08-12 00:00:00	1999-08-12	5001	0	\N	0	0	\N	\N	0	237180	0	8331-1	3006322		
38660	3571	3006322	1994-06-16	1994-06-16 00:00:00	1994-06-16	5001	0	\N	0	0	\N	\N	0	237374	0	8331-1	3006322		
50037	4550	3021226	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	303229	0	6246-3	3021226		
44695	4129	3006322	1950-11-14	1950-11-14 00:00:00	1950-11-14	5001	0	\N	0	0	\N	\N	0	274452	0	8331-1	3006322		
28912	2669	46235214	1979-07-31	1979-07-31 00:00:00	1979-07-31	5001	0	\N	0	0	\N	\N	0	176783	0	76690-7	46235214		
28994	2673	3027231	1982-03-04	1982-03-04 00:00:00	1982-03-04	5001	0	\N	0	0	\N	\N	0	177076	0	6276-0	3027231		
77916	2392	4133840	1967-02-03	1967-02-03 00:00:00	1967-02-03	5001	0	\N	0	0	\N	\N	0	159053	0	127783003	4133840		
12997	1239	3006322	1983-06-03	1983-06-03 00:00:00	1983-06-03	5001	0	\N	0	0	\N	\N	0	81640	0	8331-1	3006322		
60149	1837	4024958	2016-11-21	2016-11-21 00:00:00	2016-11-21	5001	0	\N	0	0	\N	\N	0	122717	0	117015009	4024958		
53557	4916	3006322	1981-01-13	1981-01-13 00:00:00	1981-01-13	5001	0	\N	0	0	\N	\N	0	326709	0	8331-1	3006322		
35829	3289	3006322	1993-04-20	1993-04-20 00:00:00	1993-04-20	5001	0	\N	0	0	\N	\N	0	218537	0	8331-1	3006322		
12172	1162	40758406	1963-01-19	1963-01-19 00:00:00	1963-01-19	5001	0	\N	0	0	\N	\N	0	76662	0	55277-8	40758406		
6280	191	4024958	1923-05-19	1923-05-19 00:00:00	1923-05-19	5001	0	\N	0	0	\N	\N	0	13054	0	117015009	4024958		
23602	2175	3023430	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	145012	0	6833-8	3023430		
9370	884	3006734	1990-09-11	1990-09-11 00:00:00	1990-09-11	5001	0	\N	0	0	\N	\N	0	58941	0	6189-5	3006734		
38221	3526	3006322	1979-07-15	1979-07-15 00:00:00	1979-07-15	5001	0	\N	0	0	\N	\N	0	233909	0	8331-1	3006322		
47784	4376	3011505	1995-10-03	1995-10-03 00:00:00	1995-10-03	5001	0	\N	0	0	\N	\N	0	290807	0	19926-5	3011505		
15146	474	4024958	1998-04-12	1998-04-12 00:00:00	1998-04-12	5001	0	\N	0	0	\N	\N	0	31653	0	117015009	4024958		
57864	5312	3011505	1979-01-08	1979-01-08 00:00:00	1979-01-08	5001	0	\N	0	0	\N	\N	0	353238	0	19926-5	3011505		
108386	3347	4024958	1956-10-05	1956-10-05 00:00:00	1956-10-05	5001	0	\N	0	0	\N	\N	0	222065	0	117015009	4024958		
126895	3906	4052083	2001-10-20	2001-10-20 00:00:00	2001-10-20	5001	0	\N	0	0	\N	\N	0	259745	0	23426006	4052083		
111	3	3051031	1993-12-04	1993-12-04 00:00:00	1993-12-04	5001	0	\N	0	0	\N	\N	0	224	0	46240-8	3051031		
111514	3443	4052083	1994-05-20	1994-05-20 00:00:00	1994-05-20	5001	0	\N	0	0	\N	\N	0	228511	0	23426006	4052083		
6538	615	3014599	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	40867	0	6106-9	3014599		
21527	1982	3006322	1996-07-18	1996-07-18 00:00:00	1996-07-18	5001	0	\N	0	0	\N	\N	0	132036	0	8331-1	3006322		
21622	1992	3000876	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	132713	0	6082-2	3000876		
21649	1999	3006734	2011-10-05	2011-10-05 00:00:00	2011-10-05	5001	0	\N	0	0	\N	\N	0	133114	0	6189-5	3006734		
33009	2980	3000876	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	198943	0	6082-2	3000876		
29492	2715	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	180031	0	6248-9	3015076		
55522	5097	3001247	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	338637	0	6085-5	3001247		
10636	1032	3006322	1987-10-31	1987-10-31 00:00:00	1987-10-31	5001	0	\N	0	0	\N	\N	0	67908	0	8331-1	3006322		
43271	1328	4133840	1991-12-26	1991-12-26 00:00:00	1991-12-26	5001	0	\N	0	0	\N	\N	0	88167	0	127783003	4133840		
41888	3879	40766240	2006-12-27	2006-12-27 00:00:00	2006-12-27	5001	0	\N	0	0	\N	\N	0	257660	0	63513-6	40766240		
22092	2028	3006322	1971-10-19	1971-10-19 00:00:00	1971-10-19	5001	0	\N	0	0	\N	\N	0	134991	0	8331-1	3006322		
33499	3035	3006322	1985-02-22	1985-02-22 00:00:00	1985-02-22	5001	0	\N	0	0	\N	\N	0	202174	0	8331-1	3006322		
52722	1598	4024958	1972-08-19	1972-08-19 00:00:00	1972-08-19	5001	0	\N	0	0	\N	\N	0	107221	0	117015009	4024958		
153850	4719	4024958	2006-10-15	2006-10-15 00:00:00	2006-10-15	5001	0	\N	0	0	\N	\N	0	314195	0	117015009	4024958		
132370	4077	4024958	1998-04-18	1998-04-18 00:00:00	1998-04-18	5001	0	\N	0	0	\N	\N	0	270914	0	117015009	4024958		
144780	4446	4024958	1964-04-12	1964-04-12 00:00:00	1964-04-12	5001	0	\N	0	0	\N	\N	0	295634	0	117015009	4024958		
29628	2724	3006322	1969-04-19	1969-04-19 00:00:00	1969-04-19	5001	0	\N	0	0	\N	\N	0	180482	0	8331-1	3006322		
38105	3516	3006322	1946-06-25	1946-06-25 00:00:00	1946-06-25	5001	0	\N	0	0	\N	\N	0	233291	0	8331-1	3006322		
27864	2566	40766240	2016-07-31	2016-07-31 00:00:00	2016-07-31	5001	0	\N	0	0	\N	\N	0	169945	0	63513-6	40766240		
39210	3623	3006322	1956-06-27	1956-06-27 00:00:00	1956-06-27	5001	0	\N	0	0	\N	\N	0	240887	0	8331-1	3006322		
19537	1783	40769189	1962-12-20	1962-12-20 00:00:00	1962-12-20	5001	0	\N	0	0	\N	\N	0	119378	0	66529-9	40769189		
70700	2167	4024958	1988-03-26	1988-03-26 00:00:00	1988-03-26	5001	0	\N	0	0	\N	\N	0	144389	0	117015009	4024958		
21378	1975	3006322	1932-07-22	1932-07-22 00:00:00	1932-07-22	5001	0	\N	0	0	\N	\N	0	131268	0	8331-1	3006322		
87789	2711	4024958	2018-06-09	2018-06-09 00:00:00	2018-06-09	5001	0	\N	0	0	\N	\N	0	179800	0	117015009	4024958		
170268	5222	4133840	2001-01-25	2001-01-25 00:00:00	2001-01-25	5001	0	\N	0	0	\N	\N	0	347422	0	127783003	4133840		
42524	3929	3011505	2005-01-10	2005-01-10 00:00:00	2005-01-10	5001	0	\N	0	0	\N	\N	0	261222	0	19926-5	3011505		
405	17	3006322	1974-05-09	1974-05-09 00:00:00	1974-05-09	5001	0	\N	0	0	\N	\N	0	1298	0	8331-1	3006322		
27527	2543	3006322	2001-08-12	2001-08-12 00:00:00	2001-08-12	5001	0	\N	0	0	\N	\N	0	168253	0	8331-1	3006322		
55728	5116	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	339995	0	6273-7	3006451		
76081	2334	4133840	2015-07-16	2015-07-16 00:00:00	2015-07-16	5001	0	\N	0	0	\N	\N	0	155365	0	127783003	4133840		
20713	1905	3006322	2010-04-04	2010-04-04 00:00:00	2010-04-04	5001	0	\N	0	0	\N	\N	0	126818	0	8331-1	3006322		
3514	338	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	22525	0	6106-9	3014599		
5476	520	46235214	1952-02-07	1952-02-07 00:00:00	1952-02-07	5001	0	\N	0	0	\N	\N	0	34693	0	76690-7	46235214		
25341	2333	40758406	1921-07-01	1921-07-01 00:00:00	1921-07-01	5001	0	\N	0	0	\N	\N	0	155221	0	55277-8	40758406		
26353	2424	21494966	1997-06-06	1997-06-06 00:00:00	1997-06-06	5001	0	\N	0	0	\N	\N	0	160819	0	80271-0	21494966		
26435	2436	3021226	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	161591	0	6246-3	3021226		
20304	1860	3006322	1994-11-04	1994-11-04 00:00:00	1994-11-04	5001	0	\N	0	0	\N	\N	0	124361	0	8331-1	3006322		
5367	512	40758406	1960-07-17	1960-07-17 00:00:00	1960-07-17	5001	0	\N	0	0	\N	\N	0	34186	0	55277-8	40758406		
31732	2899	3006322	1955-12-06	1955-12-06 00:00:00	1955-12-06	5001	0	\N	0	0	\N	\N	0	193114	0	8331-1	3006322		
70363	2155	4024958	1979-09-19	1979-09-19 00:00:00	1979-09-19	5001	0	\N	0	0	\N	\N	0	143655	0	117015009	4024958		
38505	3561	3006322	1930-04-01	1930-04-01 00:00:00	1930-04-01	5001	0	\N	0	0	\N	\N	0	236506	0	8331-1	3006322		
38617	3569	3049273	2018-12-11	2018-12-11 00:00:00	2018-12-11	5001	0	\N	0	0	\N	\N	0	237138	0	38265-5	3049273		
38661	3571	40769194	1976-04-07	1976-04-07 00:00:00	1976-04-07	5001	0	\N	0	0	\N	\N	0	237383	0	66534-9	40769194		
50038	4550	3027231	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	303229	0	6276-0	3027231		
44696	4129	3006322	1989-11-07	1989-11-07 00:00:00	1989-11-07	5001	0	\N	0	0	\N	\N	0	274454	0	8331-1	3006322		
28913	2669	40758406	1979-07-31	1979-07-31 00:00:00	1979-07-31	5001	0	\N	0	0	\N	\N	0	176783	0	55277-8	40758406		
28995	2673	3006451	1982-03-04	1982-03-04 00:00:00	1982-03-04	5001	0	\N	0	0	\N	\N	0	177076	0	6273-7	3006451		
77917	2392	4133840	1960-01-29	1960-01-29 00:00:00	1960-01-29	5001	0	\N	0	0	\N	\N	0	159082	0	127783003	4133840		
12998	1239	3011505	2016-07-14	2016-07-14 00:00:00	2016-07-14	5001	0	\N	0	0	\N	\N	0	81667	0	19926-5	3011505		
60151	1837	4052083	1990-04-23	1990-04-23 00:00:00	1990-04-23	5001	0	\N	0	0	\N	\N	0	122669	0	23426006	4052083		
53558	4916	3006322	2014-04-15	2014-04-15 00:00:00	2014-04-15	5001	0	\N	0	0	\N	\N	0	326691	0	8331-1	3006322		
35830	3289	3006322	1993-10-02	1993-10-02 00:00:00	1993-10-02	5001	0	\N	0	0	\N	\N	0	218485	0	8331-1	3006322		
23468	2164	3006322	2012-08-14	2012-08-14 00:00:00	2012-08-14	5001	0	\N	0	0	\N	\N	0	144158	0	8331-1	3006322		
6308	192	4024958	1944-12-24	1944-12-24 00:00:00	1944-12-24	5001	0	\N	0	0	\N	\N	0	13180	0	117015009	4024958		
23603	2175	3012494	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	145012	0	6206-7	3012494		
9371	884	3036780	1990-09-11	1990-09-11 00:00:00	1990-09-11	5001	0	\N	0	0	\N	\N	0	58941	0	6095-4	3036780		
38222	3526	40766240	2018-01-04	2018-01-04 00:00:00	2018-01-04	5001	0	\N	0	0	\N	\N	0	233957	0	63513-6	40766240		
47785	4376	3011505	1985-08-06	1985-08-06 00:00:00	1985-08-06	5001	0	\N	0	0	\N	\N	0	290835	0	19926-5	3011505		
15181	476	4052083	1985-07-31	1985-07-31 00:00:00	1985-07-31	5001	0	\N	0	0	\N	\N	0	31738	0	23426006	4052083		
57865	5312	3011505	1986-12-08	1986-12-08 00:00:00	1986-12-08	5001	0	\N	0	0	\N	\N	0	353259	0	19926-5	3011505		
108390	3347	4024958	1963-03-17	1963-03-17 00:00:00	1963-03-17	5001	0	\N	0	0	\N	\N	0	222038	0	117015009	4024958		
40589	1261	4133840	2002-07-06	2002-07-06 00:00:00	2002-07-06	5001	0	\N	0	0	\N	\N	0	83129	0	127783003	4133840		
112	3	40766240	1993-12-04	1993-12-04 00:00:00	1993-12-04	5001	0	\N	0	0	\N	\N	0	224	0	63513-6	40766240		
33739	1057	4024958	1971-08-01	1971-08-01 00:00:00	1971-08-01	5001	0	\N	0	0	\N	\N	0	69322	0	117015009	4024958		
6539	615	3005136	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	40867	0	6075-6	3005136		
21528	1982	3006322	1984-03-18	1984-03-18 00:00:00	1984-03-18	5001	0	\N	0	0	\N	\N	0	132018	0	8331-1	3006322		
21630	1998	3006322	1986-11-09	1986-11-09 00:00:00	1986-11-09	5001	0	\N	0	0	\N	\N	0	132990	0	8331-1	3006322		
21650	1999	3001488	2011-10-05	2011-10-05 00:00:00	2011-10-05	5001	0	\N	0	0	\N	\N	0	133114	0	7258-7	3001488		
33010	2980	3036780	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	198943	0	6095-4	3036780		
29493	2715	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	180031	0	6106-9	3014599		
55523	5097	3012494	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	338637	0	6206-7	3012494		
10637	1032	3006322	1955-05-30	1955-05-30 00:00:00	1955-05-30	5001	0	\N	0	0	\N	\N	0	67898	0	8331-1	3006322		
43275	1328	4024958	1973-04-11	1973-04-11 00:00:00	1973-04-11	5001	0	\N	0	0	\N	\N	0	88193	0	117015009	4024958		
41890	3879	3051031	2006-12-27	2006-12-27 00:00:00	2006-12-27	5001	0	\N	0	0	\N	\N	0	257660	0	46240-8	3051031		
22093	2028	3006322	1956-11-09	1956-11-09 00:00:00	1956-11-09	5001	0	\N	0	0	\N	\N	0	134969	0	8331-1	3006322		
33500	3035	3006322	2016-02-04	2016-02-04 00:00:00	2016-02-04	5001	0	\N	0	0	\N	\N	0	202175	0	8331-1	3006322		
52725	1598	4052083	2011-06-19	2011-06-19 00:00:00	2011-06-19	5001	0	\N	0	0	\N	\N	0	107247	0	23426006	4052083		
153863	4720	4052083	2009-11-07	2009-11-07 00:00:00	2009-11-07	5001	0	\N	0	0	\N	\N	0	314378	0	23426006	4052083		
132408	4078	4024958	1963-09-06	1963-09-06 00:00:00	1963-09-06	5001	0	\N	0	0	\N	\N	0	271056	0	117015009	4024958		
45612	1397	4052083	1989-02-15	1989-02-15 00:00:00	1989-02-15	5001	0	\N	0	0	\N	\N	0	92840	0	23426006	4052083		
29629	2724	3006322	1975-04-01	1975-04-01 00:00:00	1975-04-01	5001	0	\N	0	0	\N	\N	0	180497	0	8331-1	3006322		
38106	3516	3006322	1979-04-13	1979-04-13 00:00:00	1979-04-13	5001	0	\N	0	0	\N	\N	0	233295	0	8331-1	3006322		
27865	2566	3049273	2014-01-01	2014-01-01 00:00:00	2014-01-01	5001	0	\N	0	0	\N	\N	0	170038	0	38265-5	3049273		
39211	3623	3006322	2000-12-10	2000-12-10 00:00:00	2000-12-10	5001	0	\N	0	0	\N	\N	0	240848	0	8331-1	3006322		
19538	1783	40769184	1962-12-20	1962-12-20 00:00:00	1962-12-20	5001	0	\N	0	0	\N	\N	0	119378	0	66524-0	40769184		
82041	2540	4024958	1968-02-12	1968-02-12 00:00:00	1968-02-12	5001	0	\N	0	0	\N	\N	0	167995	0	117015009	4024958		
21379	1975	3006322	1961-09-21	1961-09-21 00:00:00	1961-09-21	5001	0	\N	0	0	\N	\N	0	131298	0	8331-1	3006322		
87791	2711	4024958	1953-05-15	1953-05-15 00:00:00	1953-05-15	5001	0	\N	0	0	\N	\N	0	179648	0	117015009	4024958		
170269	5222	4133840	2003-02-06	2003-02-06 00:00:00	2003-02-06	5001	0	\N	0	0	\N	\N	0	347529	0	127783003	4133840		
42525	3929	3011505	1995-01-16	1995-01-16 00:00:00	1995-01-16	5001	0	\N	0	0	\N	\N	0	261162	0	19926-5	3011505		
406	17	3006322	1960-02-08	1960-02-08 00:00:00	1960-02-08	5001	0	\N	0	0	\N	\N	0	1321	0	8331-1	3006322		
27530	2543	40758406	1977-10-10	1977-10-10 00:00:00	1977-10-10	5001	0	\N	0	0	\N	\N	0	168280	0	55277-8	40758406		
55729	5116	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	339995	0	6189-5	3006734		
76088	2334	4133840	2001-04-26	2001-04-26 00:00:00	2001-04-26	5001	0	\N	0	0	\N	\N	0	155374	0	127783003	4133840		
20714	1906	3006322	1981-09-23	1981-09-23 00:00:00	1981-09-23	5001	0	\N	0	0	\N	\N	0	126878	0	8331-1	3006322		
3515	338	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	22525	0	6276-0	3027231		
5477	520	40766240	1952-02-07	1952-02-07 00:00:00	1952-02-07	5001	0	\N	0	0	\N	\N	0	34693	0	63513-6	40766240		
25342	2333	46235214	1921-07-01	1921-07-01 00:00:00	1921-07-01	5001	0	\N	0	0	\N	\N	0	155221	0	76690-7	46235214		
26354	2424	3004501	1997-06-06	1997-06-06 00:00:00	1997-06-06	5001	0	\N	0	0	\N	\N	0	160819	0	2345-7	3004501		
26436	2436	3023430	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	161591	0	6833-8	3023430		
20305	1860	3006322	1978-08-26	1978-08-26 00:00:00	1978-08-26	5001	0	\N	0	0	\N	\N	0	124358	0	8331-1	3006322		
5368	512	3006322	1970-09-17	1970-09-17 00:00:00	1970-09-17	5001	0	\N	0	0	\N	\N	0	34202	0	8331-1	3006322		
158288	4865	4024958	1981-12-22	1981-12-22 00:00:00	1981-12-22	5001	0	\N	0	0	\N	\N	0	323543	0	117015009	4024958		
70385	2156	4024958	2005-10-28	2005-10-28 00:00:00	2005-10-28	5001	0	\N	0	0	\N	\N	0	143721	0	117015009	4024958		
38506	3561	3006322	1917-08-23	1917-08-23 00:00:00	1917-08-23	5001	0	\N	0	0	\N	\N	0	236505	0	8331-1	3006322		
38618	3569	3006322	1979-09-18	1979-09-18 00:00:00	1979-09-18	5001	0	\N	0	0	\N	\N	0	237179	0	8331-1	3006322		
38662	3571	40769189	1976-04-07	1976-04-07 00:00:00	1976-04-07	5001	0	\N	0	0	\N	\N	0	237383	0	66529-9	40769189		
50039	4550	3019406	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	303229	0	6158-0	3019406		
30325	2778	3019406	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	183976	0	6158-0	3019406		
28914	2669	3051031	1979-07-31	1979-07-31 00:00:00	1979-07-31	5001	0	\N	0	0	\N	\N	0	176783	0	46240-8	3051031		
28996	2673	3019406	1993-08-16	1993-08-16 00:00:00	1993-08-16	5001	0	\N	0	0	\N	\N	0	177057	0	6158-0	3019406		
77919	2392	4052083	2013-09-25	2013-09-25 00:00:00	2013-09-25	5001	0	\N	0	0	\N	\N	0	159092	0	23426006	4052083		
12999	1239	3011505	2012-07-05	2012-07-05 00:00:00	2012-07-05	5001	0	\N	0	0	\N	\N	0	81682	0	19926-5	3011505		
83474	2578	4052083	1971-12-21	1971-12-21 00:00:00	1971-12-21	5001	0	\N	0	0	\N	\N	0	170751	0	23426006	4052083		
53559	4916	3006322	2013-06-04	2013-06-04 00:00:00	2013-06-04	5001	0	\N	0	0	\N	\N	0	326690	0	8331-1	3006322		
35831	3290	3006322	2011-07-28	2011-07-28 00:00:00	2011-07-28	5001	0	\N	0	0	\N	\N	0	218598	0	8331-1	3006322		
23469	2164	3006322	1974-03-07	1974-03-07 00:00:00	1974-03-07	5001	0	\N	0	0	\N	\N	0	144153	0	8331-1	3006322		
6310	192	4024958	1986-03-10	1986-03-10 00:00:00	1986-03-10	5001	0	\N	0	0	\N	\N	0	13149	0	117015009	4024958		
23604	2175	3001247	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	145012	0	6085-5	3001247		
9372	884	3019406	1990-09-11	1990-09-11 00:00:00	1990-09-11	5001	0	\N	0	0	\N	\N	0	58941	0	6158-0	3019406		
38223	3526	46235214	2018-01-04	2018-01-04 00:00:00	2018-01-04	5001	0	\N	0	0	\N	\N	0	233957	0	76690-7	46235214		
47786	4376	3011505	1998-10-20	1998-10-20 00:00:00	1998-10-20	5001	0	\N	0	0	\N	\N	0	290803	0	19926-5	3011505		
107383	3311	4052083	2012-01-07	2012-01-07 00:00:00	2012-01-07	5001	0	\N	0	0	\N	\N	0	219832	0	23426006	4052083		
57866	5312	3006322	1997-07-28	1997-07-28 00:00:00	1997-07-28	5001	0	\N	0	0	\N	\N	0	353271	0	8331-1	3006322		
108400	3347	4052083	1984-12-13	1984-12-13 00:00:00	1984-12-13	5001	0	\N	0	0	\N	\N	0	222037	0	23426006	4052083		
40599	1261	4133840	2006-05-13	2006-05-13 00:00:00	2006-05-13	5001	0	\N	0	0	\N	\N	0	83137	0	127783003	4133840		
114	3	40758406	1993-12-04	1993-12-04 00:00:00	1993-12-04	5001	0	\N	0	0	\N	\N	0	224	0	55277-8	40758406		
33746	1057	4024958	2002-03-31	2002-03-31 00:00:00	2002-03-31	5001	0	\N	0	0	\N	\N	0	69309	0	117015009	4024958		
6540	615	3015076	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	40867	0	6248-9	3015076		
21529	1982	3006322	1943-06-02	1943-06-02 00:00:00	1943-06-02	5001	0	\N	0	0	\N	\N	0	132032	0	8331-1	3006322		
21631	1998	3006322	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	133033	0	8331-1	3006322		
21651	1999	3020655	2011-10-05	2011-10-05 00:00:00	2011-10-05	5001	0	\N	0	0	\N	\N	0	133114	0	6844-5	3020655		
33011	2980	3015076	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	198943	0	6248-9	3015076		
29494	2715	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	180031	0	6276-0	3027231		
55524	5097	3006322	2004-11-12	2004-11-12 00:00:00	2004-11-12	5001	0	\N	0	0	\N	\N	0	338687	0	8331-1	3006322		
10638	1032	3006322	2004-12-08	2004-12-08 00:00:00	2004-12-08	5001	0	\N	0	0	\N	\N	0	67931	0	8331-1	3006322		
43277	1328	4133840	2002-09-05	2002-09-05 00:00:00	2002-09-05	5001	0	\N	0	0	\N	\N	0	88187	0	127783003	4133840		
41891	3879	46235214	2006-12-27	2006-12-27 00:00:00	2006-12-27	5001	0	\N	0	0	\N	\N	0	257660	0	76690-7	46235214		
22094	2028	3006322	2011-05-02	2011-05-02 00:00:00	2011-05-02	5001	0	\N	0	0	\N	\N	0	134976	0	8331-1	3006322		
33501	3035	3006322	1984-04-17	1984-04-17 00:00:00	1984-04-17	5001	0	\N	0	0	\N	\N	0	202173	0	8331-1	3006322		
102433	3147	4052083	1980-01-01	1980-01-01 00:00:00	1980-01-01	5001	0	\N	0	0	\N	\N	0	209360	0	23426006	4052083		
153865	4720	4052083	1977-11-22	1977-11-22 00:00:00	1977-11-22	5001	0	\N	0	0	\N	\N	0	314406	0	23426006	4052083		
132416	4078	4052083	1975-03-23	1975-03-23 00:00:00	1975-03-23	5001	0	\N	0	0	\N	\N	0	271057	0	23426006	4052083		
45619	1397	4024958	2002-07-18	2002-07-18 00:00:00	2002-07-18	5001	0	\N	0	0	\N	\N	0	92764	0	117015009	4024958		
29630	2724	3006322	1969-11-27	1969-11-27 00:00:00	1969-11-27	5001	0	\N	0	0	\N	\N	0	180483	0	8331-1	3006322		
38107	3516	3049273	1996-09-24	1996-09-24 00:00:00	1996-09-24	5001	0	\N	0	0	\N	\N	0	233368	0	38265-5	3049273		
27866	2566	3006322	2015-03-21	2015-03-21 00:00:00	2015-03-21	5001	0	\N	0	0	\N	\N	0	169942	0	8331-1	3006322		
39212	3624	3006322	2003-08-02	2003-08-02 00:00:00	2003-08-02	5001	0	\N	0	0	\N	\N	0	240946	0	8331-1	3006322		
19539	1783	40769194	1962-12-20	1962-12-20 00:00:00	1962-12-20	5001	0	\N	0	0	\N	\N	0	119378	0	66534-9	40769194		
151052	4630	4052083	2012-01-15	2012-01-15 00:00:00	2012-01-15	5001	0	\N	0	0	\N	\N	0	308511	0	23426006	4052083		
21380	1975	3006322	1952-11-21	1952-11-21 00:00:00	1952-11-21	5001	0	\N	0	0	\N	\N	0	131297	0	8331-1	3006322		
87821	2712	4052083	1978-11-13	1978-11-13 00:00:00	1978-11-13	5001	0	\N	0	0	\N	\N	0	179814	0	23426006	4052083		
170272	5222	4024958	1956-05-24	1956-05-24 00:00:00	1956-05-24	5001	0	\N	0	0	\N	\N	0	347485	0	117015009	4024958		
42526	3929	3006322	1961-04-05	1961-04-05 00:00:00	1961-04-05	5001	0	\N	0	0	\N	\N	0	261196	0	8331-1	3006322		
407	17	3006322	1984-06-30	1984-06-30 00:00:00	1984-06-30	5001	0	\N	0	0	\N	\N	0	1287	0	8331-1	3006322		
27531	2543	3051031	1977-10-10	1977-10-10 00:00:00	1977-10-10	5001	0	\N	0	0	\N	\N	0	168280	0	46240-8	3051031		
55730	5116	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	339899	0	6075-6	3005136		
76089	2334	4133840	1998-04-09	1998-04-09 00:00:00	1998-04-09	5001	0	\N	0	0	\N	\N	0	155278	0	127783003	4133840		
20715	1906	3006322	2012-03-26	2012-03-26 00:00:00	2012-03-26	5001	0	\N	0	0	\N	\N	0	126913	0	8331-1	3006322		
3516	338	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	22525	0	6085-5	3001247		
5480	520	40766240	1952-03-08	1952-03-08 00:00:00	1952-03-08	5001	0	\N	0	0	\N	\N	0	34724	0	63513-6	40766240		
25345	2333	3051031	1921-07-01	1921-07-01 00:00:00	1921-07-01	5001	0	\N	0	0	\N	\N	0	155221	0	46240-8	3051031		
26355	2424	3027970	1997-06-06	1997-06-06 00:00:00	1997-06-06	5001	0	\N	0	0	\N	\N	0	160819	0	10834-0	3027970		
26437	2436	3012494	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	161591	0	6206-7	3012494		
20307	1860	3006322	1966-11-15	1966-11-15 00:00:00	1966-11-15	5001	0	\N	0	0	\N	\N	0	124356	0	8331-1	3006322		
16648	1516	3006322	1971-02-28	1971-02-28 00:00:00	1971-02-28	5001	0	\N	0	0	\N	\N	0	101293	0	8331-1	3006322		
158297	4865	4052083	1980-06-29	1980-06-29 00:00:00	1980-06-29	5001	0	\N	0	0	\N	\N	0	323490	0	23426006	4052083		
70402	2156	4024958	1969-10-27	1969-10-27 00:00:00	1969-10-27	5001	0	\N	0	0	\N	\N	0	143744	0	117015009	4024958		
38507	3561	3049273	2010-06-11	2010-06-11 00:00:00	2010-06-11	5001	0	\N	0	0	\N	\N	0	236537	0	38265-5	3049273		
38619	3569	3006322	2006-11-17	2006-11-17 00:00:00	2006-11-17	5001	0	\N	0	0	\N	\N	0	237183	0	8331-1	3006322		
38663	3571	40769179	1976-04-07	1976-04-07 00:00:00	1976-04-07	5001	0	\N	0	0	\N	\N	0	237383	0	66519-0	40769179		
50040	4550	3006322	1977-09-07	1977-09-07 00:00:00	1977-09-07	5001	0	\N	0	0	\N	\N	0	303204	0	8331-1	3006322		
30326	2778	3005136	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	183976	0	6075-6	3005136		
28916	2669	46235214	2010-10-21	2010-10-21 00:00:00	2010-10-21	5001	0	\N	0	0	\N	\N	0	176788	0	76690-7	46235214		
28997	2673	3005136	1993-08-16	1993-08-16 00:00:00	1993-08-16	5001	0	\N	0	0	\N	\N	0	177057	0	6075-6	3005136		
77922	2392	4133840	1998-05-22	1998-05-22 00:00:00	1998-05-22	5001	0	\N	0	0	\N	\N	0	159064	0	127783003	4133840		
13000	1239	3006322	1994-01-30	1994-01-30 00:00:00	1994-01-30	5001	0	\N	0	0	\N	\N	0	81661	0	8331-1	3006322		
83476	2578	4052083	2008-03-06	2008-03-06 00:00:00	2008-03-06	5001	0	\N	0	0	\N	\N	0	170753	0	23426006	4052083		
53560	4916	3006322	2010-07-10	2010-07-10 00:00:00	2010-07-10	5001	0	\N	0	0	\N	\N	0	326664	0	8331-1	3006322		
35832	3290	3006322	1987-12-10	1987-12-10 00:00:00	1987-12-10	5001	0	\N	0	0	\N	\N	0	218587	0	8331-1	3006322		
23470	2164	3006322	2012-04-07	2012-04-07 00:00:00	2012-04-07	5001	0	\N	0	0	\N	\N	0	144157	0	8331-1	3006322		
6341	194	4024958	1995-01-06	1995-01-06 00:00:00	1995-01-06	5001	0	\N	0	0	\N	\N	0	13340	0	117015009	4024958		
23605	2175	3000876	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	145012	0	6082-2	3000876		
9373	884	3006322	1981-10-16	1981-10-16 00:00:00	1981-10-16	5001	0	\N	0	0	\N	\N	0	58940	0	8331-1	3006322		
38224	3526	40758406	2018-01-04	2018-01-04 00:00:00	2018-01-04	5001	0	\N	0	0	\N	\N	0	233957	0	55277-8	40758406		
47787	4376	3011505	2008-12-16	2008-12-16 00:00:00	2008-12-16	5001	0	\N	0	0	\N	\N	0	290780	0	19926-5	3011505		
58741	1786	4024958	1967-03-22	1967-03-22 00:00:00	1967-03-22	5001	0	\N	0	0	\N	\N	0	119684	0	117015009	4024958		
57867	5312	3011505	1995-12-11	1995-12-11 00:00:00	1995-12-11	5001	0	\N	0	0	\N	\N	0	353310	0	19926-5	3011505		
14093	445	4052083	1947-09-13	1947-09-13 00:00:00	1947-09-13	5001	0	\N	0	0	\N	\N	0	29602	0	23426006	4052083		
40606	1261	4133840	2015-11-28	2015-11-28 00:00:00	2015-11-28	5001	0	\N	0	0	\N	\N	0	83131	0	127783003	4133840		
116	3	46235214	1949-11-20	1949-11-20 00:00:00	1949-11-20	5001	0	\N	0	0	\N	\N	0	361	0	76690-7	46235214		
33753	1057	4052083	1989-12-10	1989-12-10 00:00:00	1989-12-10	5001	0	\N	0	0	\N	\N	0	69291	0	23426006	4052083		
6541	615	3019406	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	40867	0	6158-0	3019406		
21530	1982	3049273	2004-05-01	2004-05-01 00:00:00	2004-05-01	5001	0	\N	0	0	\N	\N	0	131962	0	38265-5	3049273		
21632	1998	3006322	1983-08-13	1983-08-13 00:00:00	1983-08-13	5001	0	\N	0	0	\N	\N	0	133027	0	8331-1	3006322		
21652	1999	3023430	2011-10-05	2011-10-05 00:00:00	2011-10-05	5001	0	\N	0	0	\N	\N	0	133114	0	6833-8	3023430		
33012	2980	3012494	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	198943	0	6206-7	3012494		
29495	2715	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	180031	0	6085-5	3001247		
55525	5097	3006322	2017-10-16	2017-10-16 00:00:00	2017-10-16	5001	0	\N	0	0	\N	\N	0	338696	0	8331-1	3006322		
10639	1033	3006322	1983-05-16	1983-05-16 00:00:00	1983-05-16	5001	0	\N	0	0	\N	\N	0	67971	0	8331-1	3006322		
43279	1328	4133840	1997-08-07	1997-08-07 00:00:00	1997-08-07	5001	0	\N	0	0	\N	\N	0	88194	0	127783003	4133840		
41892	3879	3006322	1975-11-29	1975-11-29 00:00:00	1975-11-29	5001	0	\N	0	0	\N	\N	0	257743	0	8331-1	3006322		
22095	2028	3006322	1966-11-30	1966-11-30 00:00:00	1966-11-30	5001	0	\N	0	0	\N	\N	0	134970	0	8331-1	3006322		
33502	3035	3006322	1966-04-10	1966-04-10 00:00:00	1966-04-10	5001	0	\N	0	0	\N	\N	0	202231	0	8331-1	3006322		
102436	3147	4133840	1976-02-16	1976-02-16 00:00:00	1976-02-16	5001	0	\N	0	0	\N	\N	0	209345	0	127783003	4133840		
153872	4720	4052083	1993-03-12	1993-03-12 00:00:00	1993-03-12	5001	0	\N	0	0	\N	\N	0	314403	0	23426006	4052083		
132440	4078	4052083	1967-09-12	1967-09-12 00:00:00	1967-09-12	5001	0	\N	0	0	\N	\N	0	270950	0	23426006	4052083		
45625	1397	4024958	1990-04-27	1990-04-27 00:00:00	1990-04-27	5001	0	\N	0	0	\N	\N	0	92842	0	117015009	4024958		
29631	2724	3006322	1974-11-17	1974-11-17 00:00:00	1974-11-17	5001	0	\N	0	0	\N	\N	0	180496	0	8331-1	3006322		
38109	3516	3006322	1999-10-20	1999-10-20 00:00:00	1999-10-20	5001	0	\N	0	0	\N	\N	0	233326	0	8331-1	3006322		
27867	2566	40766240	2016-07-01	2016-07-01 00:00:00	2016-07-01	5001	0	\N	0	0	\N	\N	0	170028	0	63513-6	40766240		
39213	3624	3006322	2012-12-03	2012-12-03 00:00:00	2012-12-03	5001	0	\N	0	0	\N	\N	0	240947	0	8331-1	3006322		
19540	1783	3001488	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	119537	0	7258-7	3001488		
151058	4630	4024958	1991-07-03	1991-07-03 00:00:00	1991-07-03	5001	0	\N	0	0	\N	\N	0	308482	0	117015009	4024958		
21381	1975	3006322	1936-02-10	1936-02-10 00:00:00	1936-02-10	5001	0	\N	0	0	\N	\N	0	131269	0	8331-1	3006322		
87823	2712	4024958	2008-01-25	2008-01-25 00:00:00	2008-01-25	5001	0	\N	0	0	\N	\N	0	179821	0	117015009	4024958		
170277	5222	4133840	2004-02-12	2004-02-12 00:00:00	2004-02-12	5001	0	\N	0	0	\N	\N	0	347466	0	127783003	4133840		
42527	3929	3011505	1999-12-20	1999-12-20 00:00:00	1999-12-20	5001	0	\N	0	0	\N	\N	0	261163	0	19926-5	3011505		
408	17	3006322	1965-07-07	1965-07-07 00:00:00	1965-07-07	5001	0	\N	0	0	\N	\N	0	1322	0	8331-1	3006322		
27532	2543	46235214	1977-10-10	1977-10-10 00:00:00	1977-10-10	5001	0	\N	0	0	\N	\N	0	168280	0	76690-7	46235214		
55731	5116	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	339899	0	6276-0	3027231		
76091	2334	4133840	2003-05-08	2003-05-08 00:00:00	2003-05-08	5001	0	\N	0	0	\N	\N	0	155375	0	127783003	4133840		
20716	1906	3006322	1970-02-08	1970-02-08 00:00:00	1970-02-08	5001	0	\N	0	0	\N	\N	0	126912	0	8331-1	3006322		
3517	338	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	22525	0	6833-8	3023430		
5481	520	46235214	1952-03-08	1952-03-08 00:00:00	1952-03-08	5001	0	\N	0	0	\N	\N	0	34724	0	76690-7	46235214		
25346	2333	40766240	1921-07-01	1921-07-01 00:00:00	1921-07-01	5001	0	\N	0	0	\N	\N	0	155221	0	63513-6	40766240		
26356	2424	3013721	1997-06-06	1997-06-06 00:00:00	1997-06-06	5001	0	\N	0	0	\N	\N	0	160819	0	1920-8	3013721		
26438	2436	3001488	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	161591	0	7258-7	3001488		
20308	1860	3006322	1985-12-01	1985-12-01 00:00:00	1985-12-01	5001	0	\N	0	0	\N	\N	0	124360	0	8331-1	3006322		
16649	1516	3006322	1959-04-21	1959-04-21 00:00:00	1959-04-21	5001	0	\N	0	0	\N	\N	0	101274	0	8331-1	3006322		
158299	4865	4024958	1991-10-26	1991-10-26 00:00:00	1991-10-26	5001	0	\N	0	0	\N	\N	0	323545	0	117015009	4024958		
140236	4321	4024958	1969-01-29	1969-01-29 00:00:00	1969-01-29	5001	0	\N	0	0	\N	\N	0	286702	0	117015009	4024958		
38508	3561	3006322	1953-08-16	1953-08-16 00:00:00	1953-08-16	5001	0	\N	0	0	\N	\N	0	236484	0	8331-1	3006322		
38620	3570	3006322	1994-06-22	1994-06-22 00:00:00	1994-06-22	5001	0	\N	0	0	\N	\N	0	237277	0	8331-1	3006322		
38664	3571	40769184	1976-04-07	1976-04-07 00:00:00	1976-04-07	5001	0	\N	0	0	\N	\N	0	237383	0	66524-0	40769184		
50041	4550	3006322	2002-12-26	2002-12-26 00:00:00	2002-12-26	5001	0	\N	0	0	\N	\N	0	303172	0	8331-1	3006322		
30327	2778	3006451	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	183976	0	6273-7	3006451		
28917	2669	40758406	2010-10-21	2010-10-21 00:00:00	2010-10-21	5001	0	\N	0	0	\N	\N	0	176788	0	55277-8	40758406		
28998	2673	3001488	1993-08-16	1993-08-16 00:00:00	1993-08-16	5001	0	\N	0	0	\N	\N	0	177057	0	7258-7	3001488		
77926	2392	4133840	1993-04-23	1993-04-23 00:00:00	1993-04-23	5001	0	\N	0	0	\N	\N	0	159061	0	127783003	4133840		
13001	1239	3011505	2014-07-10	2014-07-10 00:00:00	2014-07-10	5001	0	\N	0	0	\N	\N	0	81688	0	19926-5	3011505		
83480	2578	4024958	1990-08-14	1990-08-14 00:00:00	1990-08-14	5001	0	\N	0	0	\N	\N	0	170716	0	117015009	4024958		
53561	4916	3006322	2017-12-11	2017-12-11 00:00:00	2017-12-11	5001	0	\N	0	0	\N	\N	0	326692	0	8331-1	3006322		
35833	3290	3006322	1998-06-26	1998-06-26 00:00:00	1998-06-26	5001	0	\N	0	0	\N	\N	0	218611	0	8331-1	3006322		
23471	2164	3006322	2011-03-01	2011-03-01 00:00:00	2011-03-01	5001	0	\N	0	0	\N	\N	0	144142	0	8331-1	3006322		
6343	194	4024958	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	13339	0	117015009	4024958		
23606	2175	3006451	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	145012	0	6273-7	3006451		
9374	885	3006322	1984-03-22	1984-03-22 00:00:00	1984-03-22	5001	0	\N	0	0	\N	\N	0	59001	0	8331-1	3006322		
38225	3526	3051031	2018-01-04	2018-01-04 00:00:00	2018-01-04	5001	0	\N	0	0	\N	\N	0	233957	0	46240-8	3051031		
47788	4376	3011505	1980-07-08	1980-07-08 00:00:00	1980-07-08	5001	0	\N	0	0	\N	\N	0	290701	0	19926-5	3011505		
58757	1786	4024958	1959-12-18	1959-12-18 00:00:00	1959-12-18	5001	0	\N	0	0	\N	\N	0	119682	0	117015009	4024958		
57868	5312	3011505	2000-12-25	2000-12-25 00:00:00	2000-12-25	5001	0	\N	0	0	\N	\N	0	353234	0	19926-5	3011505		
14097	445	4024958	1929-08-21	1929-08-21 00:00:00	1929-08-21	5001	0	\N	0	0	\N	\N	0	29647	0	117015009	4024958		
40611	1261	4133840	2011-11-19	2011-11-19 00:00:00	2011-11-19	5001	0	\N	0	0	\N	\N	0	83228	0	127783003	4133840		
117	3	40766240	1949-11-20	1949-11-20 00:00:00	1949-11-20	5001	0	\N	0	0	\N	\N	0	361	0	63513-6	40766240		
33757	1057	4052083	1985-09-01	1985-09-01 00:00:00	1985-09-01	5001	0	\N	0	0	\N	\N	0	69275	0	23426006	4052083		
6542	615	3021226	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	40867	0	6246-3	3021226		
21531	1982	3049273	1997-02-07	1997-02-07 00:00:00	1997-02-07	5001	0	\N	0	0	\N	\N	0	131961	0	38265-5	3049273		
21633	1998	3006322	1998-10-30	1998-10-30 00:00:00	1998-10-30	5001	0	\N	0	0	\N	\N	0	133035	0	8331-1	3006322		
21653	1999	3005136	2011-10-05	2011-10-05 00:00:00	2011-10-05	5001	0	\N	0	0	\N	\N	0	133114	0	6075-6	3005136		
33013	2980	3020655	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	198943	0	6844-5	3020655		
29496	2715	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	180031	0	6206-7	3012494		
55526	5097	3001488	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	338637	0	7258-7	3001488		
10640	1033	3006322	1975-01-19	1975-01-19 00:00:00	1975-01-19	5001	0	\N	0	0	\N	\N	0	68008	0	8331-1	3006322		
43283	1328	4133840	1987-12-17	1987-12-17 00:00:00	1987-12-17	5001	0	\N	0	0	\N	\N	0	88204	0	127783003	4133840		
41893	3879	3006322	1945-06-16	1945-06-16 00:00:00	1945-06-16	5001	0	\N	0	0	\N	\N	0	257696	0	8331-1	3006322		
22096	2028	3008598	2018-11-17	2018-11-17 00:00:00	2018-11-17	5001	0	\N	0	0	\N	\N	0	135011	0	3024-7	3008598		
33503	3035	3006322	2007-11-08	2007-11-08 00:00:00	2007-11-08	5001	0	\N	0	0	\N	\N	0	202183	0	8331-1	3006322		
102437	3147	4133840	1999-02-22	1999-02-22 00:00:00	1999-02-22	5001	0	\N	0	0	\N	\N	0	209364	0	127783003	4133840		
158633	4876	4024958	1997-08-13	1997-08-13 00:00:00	1997-08-13	5001	0	\N	0	0	\N	\N	0	324288	0	117015009	4024958		
4947	479	3049273	2016-09-03	2016-09-03 00:00:00	2016-09-03	5001	0	\N	0	0	\N	\N	0	31963	0	38265-5	3049273		
56924	1739	4024958	1996-04-13	1996-04-13 00:00:00	1996-04-13	5001	0	\N	0	0	\N	\N	0	116211	0	117015009	4024958		
29632	2724	3049273	2015-04-19	2015-04-19 00:00:00	2015-04-19	5001	0	\N	0	0	\N	\N	0	180462	0	38265-5	3049273		
38110	3516	3006322	1965-06-25	1965-06-25 00:00:00	1965-06-25	5001	0	\N	0	0	\N	\N	0	233332	0	8331-1	3006322		
27869	2566	40758406	2016-07-01	2016-07-01 00:00:00	2016-07-01	5001	0	\N	0	0	\N	\N	0	170028	0	55277-8	40758406		
39214	3624	3006322	1961-01-19	1961-01-19 00:00:00	1961-01-19	5001	0	\N	0	0	\N	\N	0	240992	0	8331-1	3006322		
19541	1783	3027231	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	119537	0	6276-0	3027231		
151060	4630	4052083	1959-03-09	1959-03-09 00:00:00	1959-03-09	5001	0	\N	0	0	\N	\N	0	308473	0	23426006	4052083		
21383	1976	3006322	2004-08-30	2004-08-30 00:00:00	2004-08-30	5001	0	\N	0	0	\N	\N	0	131408	0	8331-1	3006322		
87834	2712	4052083	1995-10-30	1995-10-30 00:00:00	1995-10-30	5001	0	\N	0	0	\N	\N	0	179828	0	23426006	4052083		
170286	5222	4133840	2017-08-17	2017-08-17 00:00:00	2017-08-17	5001	0	\N	0	0	\N	\N	0	347351	0	127783003	4133840		
42528	3929	3011505	1987-04-06	1987-04-06 00:00:00	1987-04-06	5001	0	\N	0	0	\N	\N	0	261161	0	19926-5	3011505		
409	17	3006322	1967-04-07	1967-04-07 00:00:00	1967-04-07	5001	0	\N	0	0	\N	\N	0	1286	0	8331-1	3006322		
27533	2543	40766240	1977-10-10	1977-10-10 00:00:00	1977-10-10	5001	0	\N	0	0	\N	\N	0	168280	0	63513-6	40766240		
55732	5116	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	339899	0	6206-7	3012494		
76092	2334	4133840	2007-05-31	2007-05-31 00:00:00	2007-05-31	5001	0	\N	0	0	\N	\N	0	155279	0	127783003	4133840		
20717	1906	3006322	1963-04-04	1963-04-04 00:00:00	1963-04-04	5001	0	\N	0	0	\N	\N	0	126863	0	8331-1	3006322		
3518	338	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	22525	0	6844-5	3020655		
5482	520	3051031	1952-03-08	1952-03-08 00:00:00	1952-03-08	5001	0	\N	0	0	\N	\N	0	34724	0	46240-8	3051031		
25348	2333	3049273	2000-06-13	2000-06-13 00:00:00	2000-06-13	5001	0	\N	0	0	\N	\N	0	155177	0	38265-5	3049273		
26357	2424	3000963	1997-06-06	1997-06-06 00:00:00	1997-06-06	5001	0	\N	0	0	\N	\N	0	160819	0	718-7	3000963		
26439	2436	3036780	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	161591	0	6095-4	3036780		
20309	1861	3006322	1981-12-31	1981-12-31 00:00:00	1981-12-31	5001	0	\N	0	0	\N	\N	0	124417	0	8331-1	3006322		
16650	1517	3006322	1954-09-04	1954-09-04 00:00:00	1954-09-04	5001	0	\N	0	0	\N	\N	0	101455	0	8331-1	3006322		
158324	4867	4052083	2011-07-03	2011-07-03 00:00:00	2011-07-03	5001	0	\N	0	0	\N	\N	0	323671	0	23426006	4052083		
140279	4324	4024958	1974-09-11	1974-09-11 00:00:00	1974-09-11	5001	0	\N	0	0	\N	\N	0	286847	0	117015009	4024958		
38509	3561	3006322	1965-08-24	1965-08-24 00:00:00	1965-08-24	5001	0	\N	0	0	\N	\N	0	236504	0	8331-1	3006322		
38621	3570	3006322	1987-12-09	1987-12-09 00:00:00	1987-12-09	5001	0	\N	0	0	\N	\N	0	237290	0	8331-1	3006322		
49954	4543	3006322	1988-08-23	1988-08-23 00:00:00	1988-08-23	5001	0	\N	0	0	\N	\N	0	302622	0	8331-1	3006322		
50042	4550	3005136	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	303217	0	6075-6	3005136		
30328	2778	3023430	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	183976	0	6833-8	3023430		
28919	2669	40766240	2010-10-21	2010-10-21 00:00:00	2010-10-21	5001	0	\N	0	0	\N	\N	0	176788	0	63513-6	40766240		
40285	3748	3006322	2014-04-22	2014-04-22 00:00:00	2014-04-22	5001	0	\N	0	0	\N	\N	0	249100	0	8331-1	3006322		
77929	2392	4133840	1986-03-14	1986-03-14 00:00:00	1986-03-14	5001	0	\N	0	0	\N	\N	0	159058	0	127783003	4133840		
13002	1239	3006322	1982-04-26	1982-04-26 00:00:00	1982-04-26	5001	0	\N	0	0	\N	\N	0	81645	0	8331-1	3006322		
83484	2578	4024958	1971-01-28	1971-01-28 00:00:00	1971-01-28	5001	0	\N	0	0	\N	\N	0	170714	0	117015009	4024958		
53562	4917	3006322	2002-02-15	2002-02-15 00:00:00	2002-02-15	5001	0	\N	0	0	\N	\N	0	326759	0	8331-1	3006322		
35834	3290	3006322	1979-09-09	1979-09-09 00:00:00	1979-09-09	5001	0	\N	0	0	\N	\N	0	218585	0	8331-1	3006322		
23472	2164	3006322	1973-01-31	1973-01-31 00:00:00	1973-01-31	5001	0	\N	0	0	\N	\N	0	144178	0	8331-1	3006322		
6347	194	4052083	2013-06-27	2013-06-27 00:00:00	2013-06-27	5001	0	\N	0	0	\N	\N	0	13332	0	23426006	4052083		
23607	2175	3014599	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	145012	0	6106-9	3014599		
9375	885	3006322	2013-01-06	2013-01-06 00:00:00	2013-01-06	5001	0	\N	0	0	\N	\N	0	59039	0	8331-1	3006322		
38228	3526	3006322	1986-07-16	1986-07-16 00:00:00	1986-07-16	5001	0	\N	0	0	\N	\N	0	233910	0	8331-1	3006322		
47789	4376	40758406	2012-07-28	2012-07-28 00:00:00	2012-07-28	5001	0	\N	0	0	\N	\N	0	290723	0	55277-8	40758406		
58787	1788	4052083	2011-10-09	2011-10-09 00:00:00	2011-10-09	5001	0	\N	0	0	\N	\N	0	119814	0	23426006	4052083		
57869	5312	3011505	1991-11-18	1991-11-18 00:00:00	1991-11-18	5001	0	\N	0	0	\N	\N	0	353267	0	19926-5	3011505		
14105	445	4052083	1931-03-13	1931-03-13 00:00:00	1931-03-13	5001	0	\N	0	0	\N	\N	0	29555	0	23426006	4052083		
40613	1261	4133840	2009-11-14	2009-11-14 00:00:00	2009-11-14	5001	0	\N	0	0	\N	\N	0	83138	0	127783003	4133840		
120	3	3051031	1949-11-20	1949-11-20 00:00:00	1949-11-20	5001	0	\N	0	0	\N	\N	0	361	0	46240-8	3051031		
33762	1057	4052083	2011-04-29	2011-04-29 00:00:00	2011-04-29	5001	0	\N	0	0	\N	\N	0	69310	0	23426006	4052083		
6543	615	3001488	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	40867	0	7258-7	3001488		
21532	1982	3006322	1992-10-26	1992-10-26 00:00:00	1992-10-26	5001	0	\N	0	0	\N	\N	0	132019	0	8331-1	3006322		
21634	1998	3006322	2014-08-17	2014-08-17 00:00:00	2014-08-17	5001	0	\N	0	0	\N	\N	0	133019	0	8331-1	3006322		
21654	1999	3015076	2011-10-05	2011-10-05 00:00:00	2011-10-05	5001	0	\N	0	0	\N	\N	0	133114	0	6248-9	3015076		
33014	2980	3023430	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	198943	0	6833-8	3023430		
29497	2715	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	180031	0	6095-4	3036780		
55527	5097	3006734	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	338637	0	6189-5	3006734		
10641	1033	3006322	1993-06-21	1993-06-21 00:00:00	1993-06-21	5001	0	\N	0	0	\N	\N	0	67988	0	8331-1	3006322		
43285	1328	4052083	1966-11-05	1966-11-05 00:00:00	1966-11-05	5001	0	\N	0	0	\N	\N	0	88177	0	23426006	4052083		
41895	3879	40758406	2007-05-26	2007-05-26 00:00:00	2007-05-26	5001	0	\N	0	0	\N	\N	0	257718	0	55277-8	40758406		
22097	2028	3009201	2018-11-17	2018-11-17 00:00:00	2018-11-17	5001	0	\N	0	0	\N	\N	0	135011	0	3016-3	3009201		
33511	3040	3006322	1990-08-22	1990-08-22 00:00:00	1990-08-22	5001	0	\N	0	0	\N	\N	0	202367	0	8331-1	3006322		
102440	3147	4133840	2004-03-22	2004-03-22 00:00:00	2004-03-22	5001	0	\N	0	0	\N	\N	0	209408	0	127783003	4133840		
158635	4876	4024958	2009-09-22	2009-09-22 00:00:00	2009-09-22	5001	0	\N	0	0	\N	\N	0	324299	0	117015009	4024958		
4948	479	3006322	1960-06-06	1960-06-06 00:00:00	1960-06-06	5001	0	\N	0	0	\N	\N	0	31917	0	8331-1	3006322		
56936	1740	4052083	1962-10-16	1962-10-16 00:00:00	1962-10-16	5001	0	\N	0	0	\N	\N	0	116304	0	23426006	4052083		
29633	2724	3006322	1983-07-17	1983-07-17 00:00:00	1983-07-17	5001	0	\N	0	0	\N	\N	0	180478	0	8331-1	3006322		
38111	3516	3009542	1964-07-21	1964-07-21 00:00:00	1964-07-21	5001	0	\N	0	0	\N	\N	0	233294	0	20570-8	3009542		
27870	2566	46235214	2016-07-01	2016-07-01 00:00:00	2016-07-01	5001	0	\N	0	0	\N	\N	0	170028	0	76690-7	46235214		
39215	3624	3006322	2016-08-27	2016-08-27 00:00:00	2016-08-27	5001	0	\N	0	0	\N	\N	0	240948	0	8331-1	3006322		
19542	1783	3006451	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	119537	0	6273-7	3006451		
151072	4630	4052083	1995-03-01	1995-03-01 00:00:00	1995-03-01	5001	0	\N	0	0	\N	\N	0	308483	0	23426006	4052083		
21384	1976	3023430	1999-06-28	1999-06-28 00:00:00	1999-06-28	5001	0	\N	0	0	\N	\N	0	131406	0	6833-8	3023430		
87842	2712	4024958	1998-04-04	1998-04-04 00:00:00	1998-04-04	5001	0	\N	0	0	\N	\N	0	179820	0	117015009	4024958		
170289	5222	4133840	2012-03-29	2012-03-29 00:00:00	2012-03-29	5001	0	\N	0	0	\N	\N	0	347350	0	127783003	4133840		
42529	3929	3006322	1993-11-07	1993-11-07 00:00:00	1993-11-07	5001	0	\N	0	0	\N	\N	0	261156	0	8331-1	3006322		
410	18	3006322	1991-09-13	1991-09-13 00:00:00	1991-09-13	5001	0	\N	0	0	\N	\N	0	1394	0	8331-1	3006322		
27538	2545	3006322	1977-08-31	1977-08-31 00:00:00	1977-08-31	5001	0	\N	0	0	\N	\N	0	168415	0	8331-1	3006322		
55733	5116	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	339899	0	6082-2	3000876		
76093	2334	4133840	1988-02-11	1988-02-11 00:00:00	1988-02-11	5001	0	\N	0	0	\N	\N	0	155371	0	127783003	4133840		
20720	1908	3006322	1982-06-07	1982-06-07 00:00:00	1982-06-07	5001	0	\N	0	0	\N	\N	0	126955	0	8331-1	3006322		
3519	338	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	22525	0	6158-0	3019406		
5484	520	40758406	1952-03-08	1952-03-08 00:00:00	1952-03-08	5001	0	\N	0	0	\N	\N	0	34724	0	55277-8	40758406		
25349	2333	3004501	1978-05-19	1978-05-19 00:00:00	1978-05-19	5001	0	\N	0	0	\N	\N	0	155162	0	2345-7	3004501		
26358	2424	3002385	1997-06-06	1997-06-06 00:00:00	1997-06-06	5001	0	\N	0	0	\N	\N	0	160819	0	30385-9	3002385		
26440	2436	3006734	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	161591	0	6189-5	3006734		
20310	1861	3006322	2004-11-26	2004-11-26 00:00:00	2004-11-26	5001	0	\N	0	0	\N	\N	0	124455	0	8331-1	3006322		
16651	1517	3006322	1996-04-27	1996-04-27 00:00:00	1996-04-27	5001	0	\N	0	0	\N	\N	0	101457	0	8331-1	3006322		
158337	4867	4024958	1962-12-18	1962-12-18 00:00:00	1962-12-18	5001	0	\N	0	0	\N	\N	0	323708	0	117015009	4024958		
140287	4324	4052083	1981-08-26	1981-08-26 00:00:00	1981-08-26	5001	0	\N	0	0	\N	\N	0	286838	0	23426006	4052083		
38510	3562	3006322	2003-11-24	2003-11-24 00:00:00	2003-11-24	5001	0	\N	0	0	\N	\N	0	236571	0	8331-1	3006322		
38622	3570	3006322	1950-01-31	1950-01-31 00:00:00	1950-01-31	5001	0	\N	0	0	\N	\N	0	237286	0	8331-1	3006322		
49955	4544	3006322	1984-04-02	1984-04-02 00:00:00	1984-04-02	5001	0	\N	0	0	\N	\N	0	302656	0	8331-1	3006322		
50043	4550	3015076	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	303217	0	6248-9	3015076		
30329	2778	3001247	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	183976	0	6085-5	3001247		
28921	2669	3051031	2010-10-21	2010-10-21 00:00:00	2010-10-21	5001	0	\N	0	0	\N	\N	0	176788	0	46240-8	3051031		
40286	3748	3006322	1992-10-22	1992-10-22 00:00:00	1992-10-22	5001	0	\N	0	0	\N	\N	0	249098	0	8331-1	3006322		
77932	2392	4133840	1962-02-02	1962-02-02 00:00:00	1962-02-02	5001	0	\N	0	0	\N	\N	0	159000	0	127783003	4133840		
13003	1239	3009542	1980-06-22	1980-06-22 00:00:00	1980-06-22	5001	0	\N	0	0	\N	\N	0	81638	0	20570-8	3009542		
83521	2579	4024958	1956-05-01	1956-05-01 00:00:00	1956-05-01	5001	0	\N	0	0	\N	\N	0	170769	0	117015009	4024958		
53563	4917	3006322	2015-09-16	2015-09-16 00:00:00	2015-09-16	5001	0	\N	0	0	\N	\N	0	326752	0	8331-1	3006322		
35837	3293	3006322	1920-11-16	1920-11-16 00:00:00	1920-11-16	5001	0	\N	0	0	\N	\N	0	218703	0	8331-1	3006322		
23473	2164	3006322	1985-05-17	1985-05-17 00:00:00	1985-05-17	5001	0	\N	0	0	\N	\N	0	144141	0	8331-1	3006322		
100910	3100	4052083	1959-12-22	1959-12-22 00:00:00	1959-12-22	5001	0	\N	0	0	\N	\N	0	206217	0	23426006	4052083		
23608	2175	3001488	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	145012	0	7258-7	3001488		
9376	885	3006322	1976-01-09	1976-01-09 00:00:00	1976-01-09	5001	0	\N	0	0	\N	\N	0	58999	0	8331-1	3006322		
38229	3527	3006322	1975-06-28	1975-06-28 00:00:00	1975-06-28	5001	0	\N	0	0	\N	\N	0	234051	0	8331-1	3006322		
47790	4376	3051031	2012-07-28	2012-07-28 00:00:00	2012-07-28	5001	0	\N	0	0	\N	\N	0	290723	0	46240-8	3051031		
58788	1788	4024958	1999-05-13	1999-05-13 00:00:00	1999-05-13	5001	0	\N	0	0	\N	\N	0	119827	0	117015009	4024958		
57870	5312	3011505	1990-11-12	1990-11-12 00:00:00	1990-11-12	5001	0	\N	0	0	\N	\N	0	353260	0	19926-5	3011505		
14110	445	4052083	1950-12-23	1950-12-23 00:00:00	1950-12-23	5001	0	\N	0	0	\N	\N	0	29604	0	23426006	4052083		
51932	1571	4024958	1991-07-04	1991-07-04 00:00:00	1991-07-04	5001	0	\N	0	0	\N	\N	0	105500	0	117015009	4024958		
121	3	40758406	1949-11-20	1949-11-20 00:00:00	1949-11-20	5001	0	\N	0	0	\N	\N	0	361	0	55277-8	40758406		
33779	1058	4024958	1969-12-04	1969-12-04 00:00:00	1969-12-04	5001	0	\N	0	0	\N	\N	0	69445	0	117015009	4024958		
6544	615	3006451	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	40867	0	6273-7	3006451		
21533	1982	3006322	1983-06-10	1983-06-10 00:00:00	1983-06-10	5001	0	\N	0	0	\N	\N	0	131993	0	8331-1	3006322		
21635	1999	3006734	2011-10-05	2011-10-05 00:00:00	2011-10-05	5001	0	\N	0	0	\N	\N	0	133114	0	6189-5	3006734		
21655	1999	3027231	2011-10-05	2011-10-05 00:00:00	2011-10-05	5001	0	\N	0	0	\N	\N	0	133114	0	6276-0	3027231		
33015	2980	3001247	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	198943	0	6085-5	3001247		
29498	2715	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	180031	0	6158-0	3019406		
55528	5097	3023430	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	338637	0	6833-8	3023430		
10642	1033	3006322	1982-03-25	1982-03-25 00:00:00	1982-03-25	5001	0	\N	0	0	\N	\N	0	68012	0	8331-1	3006322		
43316	1332	4024958	1954-06-22	1954-06-22 00:00:00	1954-06-22	5001	0	\N	0	0	\N	\N	0	88354	0	117015009	4024958		
41896	3879	40766240	2007-05-26	2007-05-26 00:00:00	2007-05-26	5001	0	\N	0	0	\N	\N	0	257718	0	63513-6	40766240		
22101	2030	3006322	1975-08-01	1975-08-01 00:00:00	1975-08-01	5001	0	\N	0	0	\N	\N	0	135139	0	8331-1	3006322		
33512	3040	3006322	2000-05-15	2000-05-15 00:00:00	2000-05-15	5001	0	\N	0	0	\N	\N	0	202369	0	8331-1	3006322		
102444	3147	4133840	2014-05-19	2014-05-19 00:00:00	2014-05-19	5001	0	\N	0	0	\N	\N	0	209368	0	127783003	4133840		
7869	250	4024958	1977-03-02	1977-03-02 00:00:00	1977-03-02	5001	0	\N	0	0	\N	\N	0	16797	0	117015009	4024958		
4949	479	3006322	1975-12-26	1975-12-26 00:00:00	1975-12-26	5001	0	\N	0	0	\N	\N	0	31919	0	8331-1	3006322		
56939	1740	4024958	1986-05-10	1986-05-10 00:00:00	1986-05-10	5001	0	\N	0	0	\N	\N	0	116237	0	117015009	4024958		
29634	2724	3006322	1994-12-30	1994-12-30 00:00:00	1994-12-30	5001	0	\N	0	0	\N	\N	0	180443	0	8331-1	3006322		
38112	3516	3000963	1964-07-21	1964-07-21 00:00:00	1964-07-21	5001	0	\N	0	0	\N	\N	0	233294	0	718-7	3000963		
27872	2566	3051031	2016-07-01	2016-07-01 00:00:00	2016-07-01	5001	0	\N	0	0	\N	\N	0	170028	0	46240-8	3051031		
39216	3624	3006322	2004-12-06	2004-12-06 00:00:00	2004-12-06	5001	0	\N	0	0	\N	\N	0	240996	0	8331-1	3006322		
19543	1783	3000876	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	119537	0	6082-2	3000876		
151073	4630	4052083	1973-07-15	1973-07-15 00:00:00	1973-07-15	5001	0	\N	0	0	\N	\N	0	308436	0	23426006	4052083		
21385	1976	3020655	1999-06-28	1999-06-28 00:00:00	1999-06-28	5001	0	\N	0	0	\N	\N	0	131406	0	6844-5	3020655		
87845	2712	4052083	1980-07-01	1980-07-01 00:00:00	1980-07-01	5001	0	\N	0	0	\N	\N	0	179826	0	23426006	4052083		
170305	5222	4133840	2015-04-16	2015-04-16 00:00:00	2015-04-16	5001	0	\N	0	0	\N	\N	0	347468	0	127783003	4133840		
42530	3929	3011505	2006-01-16	2006-01-16 00:00:00	2006-01-16	5001	0	\N	0	0	\N	\N	0	261206	0	19926-5	3011505		
411	18	3006322	2012-11-15	2012-11-15 00:00:00	2012-11-15	5001	0	\N	0	0	\N	\N	0	1396	0	8331-1	3006322		
27539	2545	3006322	1973-08-11	1973-08-11 00:00:00	1973-08-11	5001	0	\N	0	0	\N	\N	0	168414	0	8331-1	3006322		
55734	5116	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	339899	0	6158-0	3019406		
76095	2334	4133840	1999-04-15	1999-04-15 00:00:00	1999-04-15	5001	0	\N	0	0	\N	\N	0	155301	0	127783003	4133840		
20721	1908	3006322	2008-08-13	2008-08-13 00:00:00	2008-08-13	5001	0	\N	0	0	\N	\N	0	126984	0	8331-1	3006322		
3520	338	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	22525	0	6248-9	3015076		
5485	520	3006322	1977-03-20	1977-03-20 00:00:00	1977-03-20	5001	0	\N	0	0	\N	\N	0	34669	0	8331-1	3006322		
25350	2333	3026361	1978-05-19	1978-05-19 00:00:00	1978-05-19	5001	0	\N	0	0	\N	\N	0	155162	0	26453-1	3026361		
26359	2424	3013682	1997-06-06	1997-06-06 00:00:00	1997-06-06	5001	0	\N	0	0	\N	\N	0	160819	0	3094-0	3013682		
26441	2436	3000876	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	161591	0	6082-2	3000876		
20311	1861	3006322	1990-07-01	1990-07-01 00:00:00	1990-07-01	5001	0	\N	0	0	\N	\N	0	124418	0	8331-1	3006322		
16652	1517	3006322	2017-12-15	2017-12-15 00:00:00	2017-12-15	5001	0	\N	0	0	\N	\N	0	101459	0	8331-1	3006322		
158352	4867	4024958	1988-04-12	1988-04-12 00:00:00	1988-04-12	5001	0	\N	0	0	\N	\N	0	323597	0	117015009	4024958		
140290	4324	4052083	2016-07-17	2016-07-17 00:00:00	2016-07-17	5001	0	\N	0	0	\N	\N	0	286830	0	23426006	4052083		
38511	3562	3006322	2016-10-27	2016-10-27 00:00:00	2016-10-27	5001	0	\N	0	0	\N	\N	0	236593	0	8331-1	3006322		
38623	3570	3006322	1995-02-28	1995-02-28 00:00:00	1995-02-28	5001	0	\N	0	0	\N	\N	0	237278	0	8331-1	3006322		
49959	4546	3006322	2011-12-29	2011-12-29 00:00:00	2011-12-29	5001	0	\N	0	0	\N	\N	0	302828	0	8331-1	3006322		
50044	4550	3012494	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	303217	0	6206-7	3012494		
30330	2778	3000876	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	183976	0	6082-2	3000876		
28922	2669	3006322	2002-07-25	2002-07-25 00:00:00	2002-07-25	5001	0	\N	0	0	\N	\N	0	176765	0	8331-1	3006322		
40287	3748	3006322	2005-08-29	2005-08-29 00:00:00	2005-08-29	5001	0	\N	0	0	\N	\N	0	249144	0	8331-1	3006322		
77934	2392	4133840	1978-02-10	1978-02-10 00:00:00	1978-02-10	5001	0	\N	0	0	\N	\N	0	159086	0	127783003	4133840		
13004	1239	3000963	1980-06-22	1980-06-22 00:00:00	1980-06-22	5001	0	\N	0	0	\N	\N	0	81638	0	718-7	3000963		
83524	2579	4052083	1996-10-06	1996-10-06 00:00:00	1996-10-06	5001	0	\N	0	0	\N	\N	0	170772	0	23426006	4052083		
53564	4917	3006322	1996-04-04	1996-04-04 00:00:00	1996-04-04	5001	0	\N	0	0	\N	\N	0	326758	0	8331-1	3006322		
35838	3293	3006322	1921-09-23	1921-09-23 00:00:00	1921-09-23	5001	0	\N	0	0	\N	\N	0	218658	0	8331-1	3006322		
23474	2164	3006322	1989-07-12	1989-07-12 00:00:00	1989-07-12	5001	0	\N	0	0	\N	\N	0	144137	0	8331-1	3006322		
100912	3100	4052083	1990-06-11	1990-06-11 00:00:00	1990-06-11	5001	0	\N	0	0	\N	\N	0	206218	0	23426006	4052083		
23609	2175	3027231	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	145012	0	6276-0	3027231		
9377	885	3006322	1976-10-18	1976-10-18 00:00:00	1976-10-18	5001	0	\N	0	0	\N	\N	0	59000	0	8331-1	3006322		
38230	3527	3051031	1983-09-06	1983-09-06 00:00:00	1983-09-06	5001	0	\N	0	0	\N	\N	0	234020	0	46240-8	3051031		
47791	4376	40766240	2012-07-28	2012-07-28 00:00:00	2012-07-28	5001	0	\N	0	0	\N	\N	0	290723	0	63513-6	40766240		
58795	1788	4024958	2002-04-09	2002-04-09 00:00:00	2002-04-09	5001	0	\N	0	0	\N	\N	0	119795	0	117015009	4024958		
57871	5312	3049273	1998-12-14	1998-12-14 00:00:00	1998-12-14	5001	0	\N	0	0	\N	\N	0	353233	0	38265-5	3049273		
123261	3799	4052083	1973-10-15	1973-10-15 00:00:00	1973-10-15	5001	0	\N	0	0	\N	\N	0	252561	0	23426006	4052083		
133893	4121	4052083	1928-06-23	1928-06-23 00:00:00	1928-06-23	5001	0	\N	0	0	\N	\N	0	273957	0	23426006	4052083		
122	3	3051031	1949-04-24	1949-04-24 00:00:00	1949-04-24	5001	0	\N	0	0	\N	\N	0	261	0	46240-8	3051031		
43818	4049	3006322	1987-08-19	1987-08-19 00:00:00	1987-08-19	5001	0	\N	0	0	\N	\N	0	269171	0	8331-1	3006322		
6545	615	3027231	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	40867	0	6276-0	3027231		
21534	1982	3006322	1949-04-29	1949-04-29 00:00:00	1949-04-29	5001	0	\N	0	0	\N	\N	0	131999	0	8331-1	3006322		
361	7	4024958	1997-04-12	1997-04-12 00:00:00	1997-04-12	5001	0	\N	0	0	\N	\N	0	601	0	117015009	4024958		
21656	1999	3014599	2011-10-05	2011-10-05 00:00:00	2011-10-05	5001	0	\N	0	0	\N	\N	0	133114	0	6106-9	3014599		
33016	2980	3006734	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	198943	0	6189-5	3006734		
29499	2715	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	180095	0	7258-7	3001488		
55529	5097	3020655	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	338637	0	6844-5	3020655		
10643	1033	3006322	1983-03-31	1983-03-31 00:00:00	1983-03-31	5001	0	\N	0	0	\N	\N	0	67987	0	8331-1	3006322		
54613	1656	4024958	2000-03-19	2000-03-19 00:00:00	2000-03-19	5001	0	\N	0	0	\N	\N	0	111069	0	117015009	4024958		
41898	3879	46235214	2007-06-25	2007-06-25 00:00:00	2007-06-25	5001	0	\N	0	0	\N	\N	0	257662	0	76690-7	46235214		
22102	2030	3006322	1968-11-20	1968-11-20 00:00:00	1968-11-20	5001	0	\N	0	0	\N	\N	0	135116	0	8331-1	3006322		
33513	3041	3001247	1990-03-08	1990-03-08 00:00:00	1990-03-08	5001	0	\N	0	0	\N	\N	0	202452	0	6085-5	3001247		
102446	3147	4133840	2019-06-17	2019-06-17 00:00:00	2019-06-17	5001	0	\N	0	0	\N	\N	0	209426	0	127783003	4133840		
19163	603	4052083	1979-04-09	1979-04-09 00:00:00	1979-04-09	5001	0	\N	0	0	\N	\N	0	39987	0	23426006	4052083		
4950	479	3006322	2004-07-10	2004-07-10 00:00:00	2004-07-10	5001	0	\N	0	0	\N	\N	0	31881	0	8331-1	3006322		
165268	5076	4052083	1942-02-16	1942-02-16 00:00:00	1942-02-16	5001	0	\N	0	0	\N	\N	0	337425	0	23426006	4052083		
29635	2724	3006322	2010-12-17	2010-12-17 00:00:00	2010-12-17	5001	0	\N	0	0	\N	\N	0	180463	0	8331-1	3006322		
38114	3516	3006322	1947-05-04	1947-05-04 00:00:00	1947-05-04	5001	0	\N	0	0	\N	\N	0	233311	0	8331-1	3006322		
27873	2566	40766240	2016-06-01	2016-06-01 00:00:00	2016-06-01	5001	0	\N	0	0	\N	\N	0	170001	0	63513-6	40766240		
39217	3624	3006322	1963-11-21	1963-11-21 00:00:00	1963-11-21	5001	0	\N	0	0	\N	\N	0	240963	0	8331-1	3006322		
19544	1783	3001247	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	119537	0	6085-5	3001247		
36647	1138	4024958	1994-12-15	1994-12-15 00:00:00	1994-12-15	5001	0	\N	0	0	\N	\N	0	75014	0	117015009	4024958		
21386	1976	3006451	1999-06-28	1999-06-28 00:00:00	1999-06-28	5001	0	\N	0	0	\N	\N	0	131406	0	6273-7	3006451		
65138	1998	4024958	1983-08-13	1983-08-13 00:00:00	1983-08-13	5001	0	\N	0	0	\N	\N	0	133027	0	117015009	4024958		
170314	5222	4052083	1983-10-13	1983-10-13 00:00:00	1983-10-13	5001	0	\N	0	0	\N	\N	0	347356	0	23426006	4052083		
42531	3929	3011505	1991-01-07	1991-01-07 00:00:00	1991-01-07	5001	0	\N	0	0	\N	\N	0	261210	0	19926-5	3011505		
412	18	3006322	1991-08-01	1991-08-01 00:00:00	1991-08-01	5001	0	\N	0	0	\N	\N	0	1387	0	8331-1	3006322		
27540	2545	3000963	1968-07-20	1968-07-20 00:00:00	1968-07-20	5001	0	\N	0	0	\N	\N	0	168413	0	718-7	3000963		
55735	5116	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	339899	0	6248-9	3015076		
76097	2334	4133840	2016-07-21	2016-07-21 00:00:00	2016-07-21	5001	0	\N	0	0	\N	\N	0	155322	0	127783003	4133840		
20722	1908	3006322	1998-09-22	1998-09-22 00:00:00	1998-09-22	5001	0	\N	0	0	\N	\N	0	126971	0	8331-1	3006322		
3521	338	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	22525	0	6273-7	3006451		
5486	520	40758406	1952-01-08	1952-01-08 00:00:00	1952-01-08	5001	0	\N	0	0	\N	\N	0	34661	0	55277-8	40758406		
25351	2333	3045716	1978-05-19	1978-05-19 00:00:00	1978-05-19	5001	0	\N	0	0	\N	\N	0	155162	0	33037-3	3045716		
26360	2424	3023103	1997-06-06	1997-06-06 00:00:00	1997-06-06	5001	0	\N	0	0	\N	\N	0	160819	0	2823-3	3023103		
26442	2436	3019406	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	161591	0	6158-0	3019406		
20315	1864	3006322	1989-03-03	1989-03-03 00:00:00	1989-03-03	5001	0	\N	0	0	\N	\N	0	124511	0	8331-1	3006322		
16653	1517	3006322	1985-02-08	1985-02-08 00:00:00	1985-02-08	5001	0	\N	0	0	\N	\N	0	101362	0	8331-1	3006322		
158362	4867	4052083	2001-07-17	2001-07-17 00:00:00	2001-07-17	5001	0	\N	0	0	\N	\N	0	323609	0	23426006	4052083		
140292	4324	4024958	1984-08-29	1984-08-29 00:00:00	1984-08-29	5001	0	\N	0	0	\N	\N	0	286839	0	117015009	4024958		
38512	3562	3006322	1975-02-20	1975-02-20 00:00:00	1975-02-20	5001	0	\N	0	0	\N	\N	0	236604	0	8331-1	3006322		
38624	3570	3006322	1968-03-09	1968-03-09 00:00:00	1968-03-09	5001	0	\N	0	0	\N	\N	0	237288	0	8331-1	3006322		
49960	4546	3006322	2009-12-27	2009-12-27 00:00:00	2009-12-27	5001	0	\N	0	0	\N	\N	0	302827	0	8331-1	3006322		
50045	4550	3000876	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	303217	0	6082-2	3000876		
30331	2778	3012494	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	183976	0	6206-7	3012494		
28925	2672	3006322	1964-11-26	1964-11-26 00:00:00	1964-11-26	5001	0	\N	0	0	\N	\N	0	176885	0	8331-1	3006322		
40288	3748	3006322	1992-03-17	1992-03-17 00:00:00	1992-03-17	5001	0	\N	0	0	\N	\N	0	249143	0	8331-1	3006322		
77936	2392	4133840	2000-06-02	2000-06-02 00:00:00	2000-06-02	5001	0	\N	0	0	\N	\N	0	159062	0	127783003	4133840		
13005	1239	3011505	2018-07-19	2018-07-19 00:00:00	2018-07-19	5001	0	\N	0	0	\N	\N	0	81659	0	19926-5	3011505		
83525	2580	4024958	1962-04-22	1962-04-22 00:00:00	1962-04-22	5001	0	\N	0	0	\N	\N	0	170878	0	117015009	4024958		
3878	376	3006322	1972-01-01	1972-01-01 00:00:00	1972-01-01	5001	0	\N	0	0	\N	\N	0	24901	0	8331-1	3006322		
35840	3293	3049273	1996-11-07	1996-11-07 00:00:00	1996-11-07	5001	0	\N	0	0	\N	\N	0	218695	0	38265-5	3049273		
23475	2165	3006322	1982-10-18	1982-10-18 00:00:00	1982-10-18	5001	0	\N	0	0	\N	\N	0	144222	0	8331-1	3006322		
7898	755	3006322	2014-01-24	2014-01-24 00:00:00	2014-01-24	5001	0	\N	0	0	\N	\N	0	50069	0	8331-1	3006322		
23610	2175	3036780	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	145012	0	6095-4	3036780		
9378	886	3006322	1992-07-06	1992-07-06 00:00:00	1992-07-06	5001	0	\N	0	0	\N	\N	0	59079	0	8331-1	3006322		
38231	3527	40758406	1983-09-06	1983-09-06 00:00:00	1983-09-06	5001	0	\N	0	0	\N	\N	0	234020	0	55277-8	40758406		
47149	1438	4052083	1965-09-07	1965-09-07 00:00:00	1965-09-07	5001	0	\N	0	0	\N	\N	0	95779	0	23426006	4052083		
58797	1788	4052083	2007-01-16	2007-01-16 00:00:00	2007-01-16	5001	0	\N	0	0	\N	\N	0	119830	0	23426006	4052083		
57872	5312	3011505	1998-12-14	1998-12-14 00:00:00	1998-12-14	5001	0	\N	0	0	\N	\N	0	353233	0	19926-5	3011505		
146604	4498	4024958	1982-11-04	1982-11-04 00:00:00	1982-11-04	5001	0	\N	0	0	\N	\N	0	299466	0	117015009	4024958		
133894	4121	4133840	1981-10-04	1981-10-04 00:00:00	1981-10-04	5001	0	\N	0	0	\N	\N	0	273933	0	127783003	4133840		
123	3	40758406	1949-04-24	1949-04-24 00:00:00	1949-04-24	5001	0	\N	0	0	\N	\N	0	261	0	55277-8	40758406		
43819	4049	3006322	2018-03-01	2018-03-01 00:00:00	2018-03-01	5001	0	\N	0	0	\N	\N	0	269131	0	8331-1	3006322		
6546	615	3006322	1946-06-14	1946-06-14 00:00:00	1946-06-14	5001	0	\N	0	0	\N	\N	0	40911	0	8331-1	3006322		
21535	1982	3006322	1948-10-18	1948-10-18 00:00:00	1948-10-18	5001	0	\N	0	0	\N	\N	0	132014	0	8331-1	3006322		
413	9	4024958	2003-10-23	2003-10-23 00:00:00	2003-10-23	5001	0	\N	0	0	\N	\N	0	798	0	117015009	4024958		
21657	1999	3036780	2011-10-05	2011-10-05 00:00:00	2011-10-05	5001	0	\N	0	0	\N	\N	0	133114	0	6095-4	3036780		
33017	2980	3001488	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	198943	0	7258-7	3001488		
29500	2715	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	180095	0	6189-5	3006734		
55530	5097	3005136	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	338637	0	6075-6	3005136		
10644	1033	3000963	1999-07-29	1999-07-29 00:00:00	1999-07-29	5001	0	\N	0	0	\N	\N	0	67973	0	718-7	3000963		
52943	1605	4024958	1950-08-15	1950-08-15 00:00:00	1950-08-15	5001	0	\N	0	0	\N	\N	0	107694	0	117015009	4024958		
41900	3879	40758406	2007-06-25	2007-06-25 00:00:00	2007-06-25	5001	0	\N	0	0	\N	\N	0	257662	0	55277-8	40758406		
22103	2030	3006322	2010-08-05	2010-08-05 00:00:00	2010-08-05	5001	0	\N	0	0	\N	\N	0	135162	0	8331-1	3006322		
33514	3041	3000876	1990-03-08	1990-03-08 00:00:00	1990-03-08	5001	0	\N	0	0	\N	\N	0	202452	0	6082-2	3000876		
102448	3147	4133840	1998-02-16	1998-02-16 00:00:00	1998-02-16	5001	0	\N	0	0	\N	\N	0	209424	0	127783003	4133840		
19168	603	4024958	1962-04-25	1962-04-25 00:00:00	1962-04-25	5001	0	\N	0	0	\N	\N	0	39935	0	117015009	4024958		
4951	480	3049273	1998-03-18	1998-03-18 00:00:00	1998-03-18	5001	0	\N	0	0	\N	\N	0	32119	0	38265-5	3049273		
165276	5076	4052083	1988-03-13	1988-03-13 00:00:00	1988-03-13	5001	0	\N	0	0	\N	\N	0	337422	0	23426006	4052083		
29636	2724	3006322	1961-07-13	1961-07-13 00:00:00	1961-07-13	5001	0	\N	0	0	\N	\N	0	180513	0	8331-1	3006322		
38115	3516	3006322	1976-04-14	1976-04-14 00:00:00	1976-04-14	5001	0	\N	0	0	\N	\N	0	233324	0	8331-1	3006322		
27875	2566	46235214	2016-06-01	2016-06-01 00:00:00	2016-06-01	5001	0	\N	0	0	\N	\N	0	170001	0	76690-7	46235214		
39218	3625	3006322	1979-12-29	1979-12-29 00:00:00	1979-12-29	5001	0	\N	0	0	\N	\N	0	241119	0	8331-1	3006322		
19545	1783	3014599	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	119537	0	6106-9	3014599		
36674	1138	4024958	2004-05-07	2004-05-07 00:00:00	2004-05-07	5001	0	\N	0	0	\N	\N	0	75118	0	117015009	4024958		
21387	1976	3012494	1999-06-28	1999-06-28 00:00:00	1999-06-28	5001	0	\N	0	0	\N	\N	0	131406	0	6206-7	3012494		
65147	1998	4024958	1986-11-09	1986-11-09 00:00:00	1986-11-09	5001	0	\N	0	0	\N	\N	0	132990	0	117015009	4024958		
170316	5222	4133840	2016-08-11	2016-08-11 00:00:00	2016-08-11	5001	0	\N	0	0	\N	\N	0	347428	0	127783003	4133840		
42532	3929	3011505	2002-12-30	2002-12-30 00:00:00	2002-12-30	5001	0	\N	0	0	\N	\N	0	261164	0	19926-5	3011505		
413	18	3006322	1969-10-31	1969-10-31 00:00:00	1969-10-31	5001	0	\N	0	0	\N	\N	0	1386	0	8331-1	3006322		
27541	2545	3009542	1968-07-20	1968-07-20 00:00:00	1968-07-20	5001	0	\N	0	0	\N	\N	0	168413	0	20570-8	3009542		
55736	5116	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	339899	0	7258-7	3001488		
76099	2334	4133840	1960-02-11	1960-02-11 00:00:00	1960-02-11	5001	0	\N	0	0	\N	\N	0	155367	0	127783003	4133840		
20727	1911	3006322	1991-02-06	1991-02-06 00:00:00	1991-02-06	5001	0	\N	0	0	\N	\N	0	127102	0	8331-1	3006322		
3522	338	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	22525	0	6189-5	3006734		
5488	520	3051031	1952-01-08	1952-01-08 00:00:00	1952-01-08	5001	0	\N	0	0	\N	\N	0	34661	0	46240-8	3051031		
25352	2333	3007461	1978-05-19	1978-05-19 00:00:00	1978-05-19	5001	0	\N	0	0	\N	\N	0	155162	0	26515-7	3007461		
26361	2424	3015632	1997-06-06	1997-06-06 00:00:00	1997-06-06	5001	0	\N	0	0	\N	\N	0	160819	0	2028-9	3015632		
26443	2436	3015076	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	161591	0	6248-9	3015076		
126915	3906	4052083	1978-06-20	1978-06-20 00:00:00	1978-06-20	5001	0	\N	0	0	\N	\N	0	259743	0	23426006	4052083		
45807	1399	4052083	1967-05-25	1967-05-25 00:00:00	1967-05-25	5001	0	\N	0	0	\N	\N	0	92994	0	23426006	4052083		
158369	4867	4024958	1948-02-09	1948-02-09 00:00:00	1948-02-09	5001	0	\N	0	0	\N	\N	0	323665	0	117015009	4024958		
140296	4325	4052083	1996-08-30	1996-08-30 00:00:00	1996-08-30	5001	0	\N	0	0	\N	\N	0	286882	0	23426006	4052083		
38513	3562	3006322	1997-02-04	1997-02-04 00:00:00	1997-02-04	5001	0	\N	0	0	\N	\N	0	236618	0	8331-1	3006322		
38625	3571	3006322	2014-04-15	2014-04-15 00:00:00	2014-04-15	5001	0	\N	0	0	\N	\N	0	237315	0	8331-1	3006322		
49961	4546	3006322	1984-06-18	1984-06-18 00:00:00	1984-06-18	5001	0	\N	0	0	\N	\N	0	302822	0	8331-1	3006322		
50046	4550	3001247	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	303217	0	6085-5	3001247		
30332	2779	3006322	1996-12-02	1996-12-02 00:00:00	1996-12-02	5001	0	\N	0	0	\N	\N	0	184164	0	8331-1	3006322		
28926	2672	3027231	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	177027	0	6276-0	3027231		
40289	3748	3006322	1981-01-03	1981-01-03 00:00:00	1981-01-03	5001	0	\N	0	0	\N	\N	0	249126	0	8331-1	3006322		
77939	2392	4024958	1922-06-06	1922-06-06 00:00:00	1922-06-06	5001	0	\N	0	0	\N	\N	0	159043	0	117015009	4024958		
13012	1242	3006322	1986-05-19	1986-05-19 00:00:00	1986-05-19	5001	0	\N	0	0	\N	\N	0	81794	0	8331-1	3006322		
83537	2580	4024958	1962-08-04	1962-08-04 00:00:00	1962-08-04	5001	0	\N	0	0	\N	\N	0	170929	0	117015009	4024958		
3879	376	3006322	1976-09-19	1976-09-19 00:00:00	1976-09-19	5001	0	\N	0	0	\N	\N	0	24916	0	8331-1	3006322		
35841	3293	3006322	1917-08-19	1917-08-19 00:00:00	1917-08-19	5001	0	\N	0	0	\N	\N	0	218698	0	8331-1	3006322		
23476	2165	3006322	1995-10-05	1995-10-05 00:00:00	1995-10-05	5001	0	\N	0	0	\N	\N	0	144227	0	8331-1	3006322		
7899	755	3006322	1953-04-08	1953-04-08 00:00:00	1953-04-08	5001	0	\N	0	0	\N	\N	0	50091	0	8331-1	3006322		
23611	2175	3019406	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	145012	0	6158-0	3019406		
9379	886	3006322	1998-02-02	1998-02-02 00:00:00	1998-02-02	5001	0	\N	0	0	\N	\N	0	59080	0	8331-1	3006322		
38232	3527	46235214	1983-09-06	1983-09-06 00:00:00	1983-09-06	5001	0	\N	0	0	\N	\N	0	234020	0	76690-7	46235214		
47150	1438	4024958	1959-08-11	1959-08-11 00:00:00	1959-08-11	5001	0	\N	0	0	\N	\N	0	95828	0	117015009	4024958		
27229	851	4024958	2011-11-06	2011-11-06 00:00:00	2011-11-06	5001	0	\N	0	0	\N	\N	0	56271	0	117015009	4024958		
57873	5312	3011505	1993-11-29	1993-11-29 00:00:00	1993-11-29	5001	0	\N	0	0	\N	\N	0	353268	0	19926-5	3011505		
146620	4500	4052083	1989-10-17	1989-10-17 00:00:00	1989-10-17	5001	0	\N	0	0	\N	\N	0	299534	0	23426006	4052083		
133897	4122	4024958	1975-01-18	1975-01-18 00:00:00	1975-01-18	5001	0	\N	0	0	\N	\N	0	274068	0	117015009	4024958		
126	3	46235214	1949-04-24	1949-04-24 00:00:00	1949-04-24	5001	0	\N	0	0	\N	\N	0	261	0	76690-7	46235214		
43820	4049	3006322	2009-08-01	2009-08-01 00:00:00	2009-08-01	5001	0	\N	0	0	\N	\N	0	269142	0	8331-1	3006322		
6547	615	3006734	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	40960	0	6189-5	3006734		
21536	1982	3006322	1961-02-05	1961-02-05 00:00:00	1961-02-05	5001	0	\N	0	0	\N	\N	0	132034	0	8331-1	3006322		
149789	4590	4024958	1988-06-27	1988-06-27 00:00:00	1988-06-27	5001	0	\N	0	0	\N	\N	0	305886	0	117015009	4024958		
21658	1999	3001247	2011-10-05	2011-10-05 00:00:00	2011-10-05	5001	0	\N	0	0	\N	\N	0	133114	0	6085-5	3001247		
33018	2980	3006322	1977-02-21	1977-02-21 00:00:00	1977-02-21	5001	0	\N	0	0	\N	\N	0	198959	0	8331-1	3006322		
29501	2715	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	180095	0	6833-8	3023430		
55531	5097	3021226	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	338637	0	6246-3	3021226		
10645	1033	3009542	1999-07-29	1999-07-29 00:00:00	1999-07-29	5001	0	\N	0	0	\N	\N	0	67973	0	20570-8	3009542		
52970	1606	4024958	1957-08-24	1957-08-24 00:00:00	1957-08-24	5001	0	\N	0	0	\N	\N	0	107873	0	117015009	4024958		
41901	3879	40766240	2007-06-25	2007-06-25 00:00:00	2007-06-25	5001	0	\N	0	0	\N	\N	0	257662	0	63513-6	40766240		
22104	2030	3006322	1978-12-24	1978-12-24 00:00:00	1978-12-24	5001	0	\N	0	0	\N	\N	0	135119	0	8331-1	3006322		
33515	3041	3020655	1990-03-08	1990-03-08 00:00:00	1990-03-08	5001	0	\N	0	0	\N	\N	0	202452	0	6844-5	3020655		
102449	3147	4133840	2005-03-28	2005-03-28 00:00:00	2005-03-28	5001	0	\N	0	0	\N	\N	0	209347	0	127783003	4133840		
19196	603	4024958	1978-01-15	1978-01-15 00:00:00	1978-01-15	5001	0	\N	0	0	\N	\N	0	39941	0	117015009	4024958		
4952	480	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	32090	0	6206-7	3012494		
165286	5076	4024958	1966-10-09	1966-10-09 00:00:00	1966-10-09	5001	0	\N	0	0	\N	\N	0	337410	0	117015009	4024958		
29637	2724	3006322	1955-08-19	1955-08-19 00:00:00	1955-08-19	5001	0	\N	0	0	\N	\N	0	180490	0	8331-1	3006322		
49406	4506	3051031	2012-10-20	2012-10-20 00:00:00	2012-10-20	5001	0	\N	0	0	\N	\N	0	300240	0	46240-8	3051031		
27877	2566	3051031	2016-06-01	2016-06-01 00:00:00	2016-06-01	5001	0	\N	0	0	\N	\N	0	170001	0	46240-8	3051031		
39219	3625	3006322	1981-04-08	1981-04-08 00:00:00	1981-04-08	5001	0	\N	0	0	\N	\N	0	241120	0	8331-1	3006322		
19546	1783	3005136	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	119537	0	6075-6	3005136		
47984	1464	4024958	1998-03-08	1998-03-08 00:00:00	1998-03-08	5001	0	\N	0	0	\N	\N	0	97549	0	117015009	4024958		
21388	1976	3014599	1999-06-28	1999-06-28 00:00:00	1999-06-28	5001	0	\N	0	0	\N	\N	0	131406	0	6106-9	3014599		
21457	1977	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	131487	0	6844-5	3020655		
170321	5222	4133840	2002-01-31	2002-01-31 00:00:00	2002-01-31	5001	0	\N	0	0	\N	\N	0	347347	0	127783003	4133840		
42533	3929	3006322	1977-07-23	1977-07-23 00:00:00	1977-07-23	5001	0	\N	0	0	\N	\N	0	261188	0	8331-1	3006322		
414	18	3006322	1979-05-24	1979-05-24 00:00:00	1979-05-24	5001	0	\N	0	0	\N	\N	0	1385	0	8331-1	3006322		
27542	2545	3006322	1994-03-11	1994-03-11 00:00:00	1994-03-11	5001	0	\N	0	0	\N	\N	0	168366	0	8331-1	3006322		
55737	5116	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	339899	0	6085-5	3001247		
76101	2334	4052083	1942-09-26	1942-09-26 00:00:00	1942-09-26	5001	0	\N	0	0	\N	\N	0	155313	0	23426006	4052083		
20728	1911	3011505	1999-09-13	1999-09-13 00:00:00	1999-09-13	5001	0	\N	0	0	\N	\N	0	127173	0	19926-5	3011505		
3523	338	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	22525	0	6075-6	3005136		
5489	520	46235214	1952-01-08	1952-01-08 00:00:00	1952-01-08	5001	0	\N	0	0	\N	\N	0	34661	0	76690-7	46235214		
25353	2333	3000963	1978-05-19	1978-05-19 00:00:00	1978-05-19	5001	0	\N	0	0	\N	\N	0	155162	0	718-7	3000963		
26362	2424	3024561	1997-06-06	1997-06-06 00:00:00	1997-06-06	5001	0	\N	0	0	\N	\N	0	160819	0	1751-7	3024561		
26444	2436	3001247	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	161591	0	6085-5	3001247		
126957	3909	4024958	2015-03-05	2015-03-05 00:00:00	2015-03-05	5001	0	\N	0	0	\N	\N	0	259869	0	117015009	4024958		
58899	1791	4024958	1983-01-29	1983-01-29 00:00:00	1983-01-29	5001	0	\N	0	0	\N	\N	0	120021	0	117015009	4024958		
162319	4979	4052083	1978-07-14	1978-07-14 00:00:00	1978-07-14	5001	0	\N	0	0	\N	\N	0	331291	0	23426006	4052083		
173662	5328	4052083	1988-09-05	1988-09-05 00:00:00	1988-09-05	5001	0	\N	0	0	\N	\N	0	354711	0	23426006	4052083		
38514	3562	3006322	2000-10-27	2000-10-27 00:00:00	2000-10-27	5001	0	\N	0	0	\N	\N	0	236598	0	8331-1	3006322		
167050	5127	4052083	1984-02-16	1984-02-16 00:00:00	1984-02-16	5001	0	\N	0	0	\N	\N	0	340866	0	23426006	4052083		
49962	4546	3006322	1982-10-17	1982-10-17 00:00:00	1982-10-17	5001	0	\N	0	0	\N	\N	0	302814	0	8331-1	3006322		
50047	4550	3001488	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	303217	0	7258-7	3001488		
30333	2779	40769189	1994-11-21	1994-11-21 00:00:00	1994-11-21	5001	0	\N	0	0	\N	\N	0	184123	0	66529-9	40769189		
28927	2672	3006451	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	177027	0	6273-7	3006451		
40292	3750	3006322	1981-01-29	1981-01-29 00:00:00	1981-01-29	5001	0	\N	0	0	\N	\N	0	249226	0	8331-1	3006322		
30734	2818	3006322	1985-12-24	1985-12-24 00:00:00	1985-12-24	5001	0	\N	0	0	\N	\N	0	186746	0	8331-1	3006322		
13013	1245	3049273	2008-08-08	2008-08-08 00:00:00	2008-08-08	5001	0	\N	0	0	\N	\N	0	81905	0	38265-5	3049273		
83538	2580	4052083	1963-07-15	1963-07-15 00:00:00	1963-07-15	5001	0	\N	0	0	\N	\N	0	170921	0	23426006	4052083		
3880	376	3006322	1991-04-02	1991-04-02 00:00:00	1991-04-02	5001	0	\N	0	0	\N	\N	0	24917	0	8331-1	3006322		
35842	3293	3006322	1996-11-07	1996-11-07 00:00:00	1996-11-07	5001	0	\N	0	0	\N	\N	0	218734	0	8331-1	3006322		
23477	2165	3006322	1963-11-15	1963-11-15 00:00:00	1963-11-15	5001	0	\N	0	0	\N	\N	0	144225	0	8331-1	3006322		
7900	755	3006322	2006-02-22	2006-02-22 00:00:00	2006-02-22	5001	0	\N	0	0	\N	\N	0	50056	0	8331-1	3006322		
23612	2175	3015076	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	145012	0	6248-9	3015076		
9380	886	3006322	1998-04-17	1998-04-17 00:00:00	1998-04-17	5001	0	\N	0	0	\N	\N	0	59081	0	8331-1	3006322		
38234	3527	40766240	1983-09-06	1983-09-06 00:00:00	1983-09-06	5001	0	\N	0	0	\N	\N	0	234020	0	63513-6	40766240		
47154	1438	4052083	1992-05-18	1992-05-18 00:00:00	1992-05-18	5001	0	\N	0	0	\N	\N	0	95808	0	23426006	4052083		
27230	851	4024958	1989-08-22	1989-08-22 00:00:00	1989-08-22	5001	0	\N	0	0	\N	\N	0	56320	0	117015009	4024958		
57874	5312	3011505	1999-12-20	1999-12-20 00:00:00	1999-12-20	5001	0	\N	0	0	\N	\N	0	353241	0	19926-5	3011505		
146631	4500	4024958	1968-09-08	1968-09-08 00:00:00	1968-09-08	5001	0	\N	0	0	\N	\N	0	299547	0	117015009	4024958		
133898	4122	4024958	2013-06-23	2013-06-23 00:00:00	2013-06-23	5001	0	\N	0	0	\N	\N	0	274042	0	117015009	4024958		
127	3	40766240	1949-04-24	1949-04-24 00:00:00	1949-04-24	5001	0	\N	0	0	\N	\N	0	261	0	63513-6	40766240		
43821	4049	3006322	1993-08-15	1993-08-15 00:00:00	1993-08-15	5001	0	\N	0	0	\N	\N	0	269174	0	8331-1	3006322		
122818	3786	4024958	2013-05-01	2013-05-01 00:00:00	2013-05-01	5001	0	\N	0	0	\N	\N	0	251717	0	117015009	4024958		
21537	1982	3006322	1963-03-13	1963-03-13 00:00:00	1963-03-13	5001	0	\N	0	0	\N	\N	0	131951	0	8331-1	3006322		
149811	4591	4024958	1997-02-10	1997-02-10 00:00:00	1997-02-10	5001	0	\N	0	0	\N	\N	0	305945	0	117015009	4024958		
21659	1999	3019406	2011-10-05	2011-10-05 00:00:00	2011-10-05	5001	0	\N	0	0	\N	\N	0	133114	0	6158-0	3019406		
33019	2980	3006322	2014-06-17	2014-06-17 00:00:00	2014-06-17	5001	0	\N	0	0	\N	\N	0	198895	0	8331-1	3006322		
29502	2715	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	180095	0	6075-6	3005136		
55532	5097	3006451	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	338637	0	6273-7	3006451		
10646	1033	3006322	1984-01-28	1984-01-28 00:00:00	1984-01-28	5001	0	\N	0	0	\N	\N	0	67972	0	8331-1	3006322		
52980	1606	4024958	1987-09-20	1987-09-20 00:00:00	1987-09-20	5001	0	\N	0	0	\N	\N	0	107849	0	117015009	4024958		
41903	3879	3051031	2007-06-25	2007-06-25 00:00:00	2007-06-25	5001	0	\N	0	0	\N	\N	0	257662	0	46240-8	3051031		
22105	2030	3006322	1987-12-20	1987-12-20 00:00:00	1987-12-20	5001	0	\N	0	0	\N	\N	0	135140	0	8331-1	3006322		
33516	3041	3001488	1990-03-08	1990-03-08 00:00:00	1990-03-08	5001	0	\N	0	0	\N	\N	0	202452	0	7258-7	3001488		
102453	3147	4133840	2015-05-25	2015-05-25 00:00:00	2015-05-25	5001	0	\N	0	0	\N	\N	0	209411	0	127783003	4133840		
19204	603	4052083	1973-05-10	1973-05-10 00:00:00	1973-05-10	5001	0	\N	0	0	\N	\N	0	39956	0	23426006	4052083		
4953	480	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	32090	0	6158-0	3019406		
165299	5076	4052083	2009-04-02	2009-04-02 00:00:00	2009-04-02	5001	0	\N	0	0	\N	\N	0	337401	0	23426006	4052083		
29658	2731	3006322	2000-09-24	2000-09-24 00:00:00	2000-09-24	5001	0	\N	0	0	\N	\N	0	180744	0	8331-1	3006322		
49407	4506	40758406	2012-10-20	2012-10-20 00:00:00	2012-10-20	5001	0	\N	0	0	\N	\N	0	300240	0	55277-8	40758406		
27878	2566	40758406	2016-06-01	2016-06-01 00:00:00	2016-06-01	5001	0	\N	0	0	\N	\N	0	170001	0	55277-8	40758406		
39220	3625	3049273	2013-09-10	2013-09-10 00:00:00	2013-09-10	5001	0	\N	0	0	\N	\N	0	241115	0	38265-5	3049273		
19547	1783	3021226	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	119537	0	6246-3	3021226		
47985	1464	4024958	1972-08-23	1972-08-23 00:00:00	1972-08-23	5001	0	\N	0	0	\N	\N	0	97511	0	117015009	4024958		
21389	1976	3001488	1999-06-28	1999-06-28 00:00:00	1999-06-28	5001	0	\N	0	0	\N	\N	0	131406	0	7258-7	3001488		
21458	1977	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	131487	0	6095-4	3036780		
170328	5222	4133840	2007-03-01	2007-03-01 00:00:00	2007-03-01	5001	0	\N	0	0	\N	\N	0	347426	0	127783003	4133840		
42535	3929	3011505	2001-12-24	2001-12-24 00:00:00	2001-12-24	5001	0	\N	0	0	\N	\N	0	261182	0	19926-5	3011505		
415	18	3006322	1992-01-21	1992-01-21 00:00:00	1992-01-21	5001	0	\N	0	0	\N	\N	0	1406	0	8331-1	3006322		
27669	2548	3006322	1967-12-25	1967-12-25 00:00:00	1967-12-25	5001	0	\N	0	0	\N	\N	0	168694	0	8331-1	3006322		
55738	5116	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	339899	0	6189-5	3006734		
76103	2334	4133840	1984-05-31	1984-05-31 00:00:00	1984-05-31	5001	0	\N	0	0	\N	\N	0	155336	0	127783003	4133840		
20729	1911	3011505	2009-11-09	2009-11-09 00:00:00	2009-11-09	5001	0	\N	0	0	\N	\N	0	127123	0	19926-5	3011505		
3524	338	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	22525	0	6095-4	3036780		
5490	520	40766240	1952-01-08	1952-01-08 00:00:00	1952-01-08	5001	0	\N	0	0	\N	\N	0	34661	0	63513-6	40766240		
25354	2333	3016723	1978-05-19	1978-05-19 00:00:00	1978-05-19	5001	0	\N	0	0	\N	\N	0	155162	0	2160-0	3016723		
26363	2424	3010813	1997-06-06	1997-06-06 00:00:00	1997-06-06	5001	0	\N	0	0	\N	\N	0	160819	0	26464-8	3010813		
26445	2436	3020655	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	161591	0	6844-5	3020655		
126963	3909	4024958	1972-07-08	1972-07-08 00:00:00	1972-07-08	5001	0	\N	0	0	\N	\N	0	259838	0	117015009	4024958		
58907	1791	4024958	1971-04-08	1971-04-08 00:00:00	1971-04-08	5001	0	\N	0	0	\N	\N	0	120065	0	117015009	4024958		
162320	4979	4024958	1995-07-27	1995-07-27 00:00:00	1995-07-27	5001	0	\N	0	0	\N	\N	0	331300	0	117015009	4024958		
173681	5328	4052083	1974-08-13	1974-08-13 00:00:00	1974-08-13	5001	0	\N	0	0	\N	\N	0	354624	0	23426006	4052083		
38516	3565	3006322	1947-12-17	1947-12-17 00:00:00	1947-12-17	5001	0	\N	0	0	\N	\N	0	236725	0	8331-1	3006322		
167056	5127	4052083	1994-10-26	1994-10-26 00:00:00	1994-10-26	5001	0	\N	0	0	\N	\N	0	340855	0	23426006	4052083		
49963	4546	3006322	2015-12-02	2015-12-02 00:00:00	2015-12-02	5001	0	\N	0	0	\N	\N	0	302818	0	8331-1	3006322		
50048	4550	3023430	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	303217	0	6833-8	3023430		
30334	2779	40769179	1994-11-21	1994-11-21 00:00:00	1994-11-21	5001	0	\N	0	0	\N	\N	0	184123	0	66519-0	40769179		
28928	2672	3021226	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	177027	0	6246-3	3021226		
40293	3750	3006322	1990-10-05	1990-10-05 00:00:00	1990-10-05	5001	0	\N	0	0	\N	\N	0	249246	0	8331-1	3006322		
30735	2818	3006322	2010-10-20	2010-10-20 00:00:00	2010-10-20	5001	0	\N	0	0	\N	\N	0	186747	0	8331-1	3006322		
13014	1245	3006322	1947-08-31	1947-08-31 00:00:00	1947-08-31	5001	0	\N	0	0	\N	\N	0	81980	0	8331-1	3006322		
83546	2580	4024958	1995-02-16	1995-02-16 00:00:00	1995-02-16	5001	0	\N	0	0	\N	\N	0	170930	0	117015009	4024958		
3881	376	3006322	1983-11-27	1983-11-27 00:00:00	1983-11-27	5001	0	\N	0	0	\N	\N	0	24903	0	8331-1	3006322		
35843	3293	3049273	2005-06-23	2005-06-23 00:00:00	2005-06-23	5001	0	\N	0	0	\N	\N	0	218697	0	38265-5	3049273		
23478	2165	3006322	1985-10-11	1985-10-11 00:00:00	1985-10-11	5001	0	\N	0	0	\N	\N	0	144188	0	8331-1	3006322		
7901	755	3049273	2016-01-28	2016-01-28 00:00:00	2016-01-28	5001	0	\N	0	0	\N	\N	0	50012	0	38265-5	3049273		
23613	2175	3021226	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	145012	0	6246-3	3021226		
9381	886	3006322	1984-09-30	1984-09-30 00:00:00	1984-09-30	5001	0	\N	0	0	\N	\N	0	59091	0	8331-1	3006322		
38236	3527	3006322	2018-03-22	2018-03-22 00:00:00	2018-03-22	5001	0	\N	0	0	\N	\N	0	234024	0	8331-1	3006322		
47159	1438	4052083	2017-04-29	2017-04-29 00:00:00	2017-04-29	5001	0	\N	0	0	\N	\N	0	95806	0	23426006	4052083		
27233	851	4024958	1994-10-20	1994-10-20 00:00:00	1994-10-20	5001	0	\N	0	0	\N	\N	0	56305	0	117015009	4024958		
57875	5312	3011505	1996-12-16	1996-12-16 00:00:00	1996-12-16	5001	0	\N	0	0	\N	\N	0	353240	0	19926-5	3011505		
146646	4500	4024958	2006-07-18	2006-07-18 00:00:00	2006-07-18	5001	0	\N	0	0	\N	\N	0	299592	0	117015009	4024958		
133921	4123	4024958	1967-02-26	1967-02-26 00:00:00	1967-02-26	5001	0	\N	0	0	\N	\N	0	274129	0	117015009	4024958		
128	3	40766240	1994-06-02	1994-06-02 00:00:00	1994-06-02	5001	0	\N	0	0	\N	\N	0	226	0	63513-6	40766240		
43822	4049	3006322	1991-06-14	1991-06-14 00:00:00	1991-06-14	5001	0	\N	0	0	\N	\N	0	269172	0	8331-1	3006322		
122819	3786	4052083	1981-04-12	1981-04-12 00:00:00	1981-04-12	5001	0	\N	0	0	\N	\N	0	251670	0	23426006	4052083		
21539	1982	3006322	1957-06-11	1957-06-11 00:00:00	1957-06-11	5001	0	\N	0	0	\N	\N	0	132015	0	8331-1	3006322		
149819	4591	4052083	2012-01-09	2012-01-09 00:00:00	2012-01-09	5001	0	\N	0	0	\N	\N	0	305946	0	23426006	4052083		
32937	2975	3005136	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	198641	0	6075-6	3005136		
33027	2985	3006322	1978-03-02	1978-03-02 00:00:00	1978-03-02	5001	0	\N	0	0	\N	\N	0	199228	0	8331-1	3006322		
29503	2715	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	180095	0	6248-9	3015076		
55533	5097	3015076	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	338637	0	6248-9	3015076		
1179	32	4052083	2002-07-21	2002-07-21 00:00:00	2002-07-21	5001	0	\N	0	0	\N	\N	0	2201	0	23426006	4052083		
9120	289	4024958	2000-04-27	2000-04-27 00:00:00	2000-04-27	5001	0	\N	0	0	\N	\N	0	19255	0	117015009	4024958		
41904	3879	3051031	2007-03-27	2007-03-27 00:00:00	2007-03-27	5001	0	\N	0	0	\N	\N	0	257661	0	46240-8	3051031		
22106	2030	3006322	2010-06-21	2010-06-21 00:00:00	2010-06-21	5001	0	\N	0	0	\N	\N	0	135161	0	8331-1	3006322		
33517	3041	3021226	1990-03-08	1990-03-08 00:00:00	1990-03-08	5001	0	\N	0	0	\N	\N	0	202452	0	6246-3	3021226		
102454	3147	4133840	2002-03-11	2002-03-11 00:00:00	2002-03-11	5001	0	\N	0	0	\N	\N	0	209407	0	127783003	4133840		
19205	603	4052083	1983-11-03	1983-11-03 00:00:00	1983-11-03	5001	0	\N	0	0	\N	\N	0	39942	0	23426006	4052083		
4954	480	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	32090	0	6075-6	3005136		
165313	5077	4024958	2007-09-04	2007-09-04 00:00:00	2007-09-04	5001	0	\N	0	0	\N	\N	0	337449	0	117015009	4024958		
29659	2731	3006322	2017-01-12	2017-01-12 00:00:00	2017-01-12	5001	0	\N	0	0	\N	\N	0	180771	0	8331-1	3006322		
49408	4506	46235214	2012-10-20	2012-10-20 00:00:00	2012-10-20	5001	0	\N	0	0	\N	\N	0	300240	0	76690-7	46235214		
27879	2566	3051031	2016-04-02	2016-04-02 00:00:00	2016-04-02	5001	0	\N	0	0	\N	\N	0	170027	0	46240-8	3051031		
39221	3625	3006322	1962-04-15	1962-04-15 00:00:00	1962-04-15	5001	0	\N	0	0	\N	\N	0	241061	0	8331-1	3006322		
19548	1783	3019406	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	119537	0	6158-0	3019406		
47990	1464	4024958	2016-07-26	2016-07-26 00:00:00	2016-07-26	5001	0	\N	0	0	\N	\N	0	97514	0	117015009	4024958		
21390	1976	3001247	1999-06-28	1999-06-28 00:00:00	1999-06-28	5001	0	\N	0	0	\N	\N	0	131406	0	6085-5	3001247		
21459	1977	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	131487	0	6082-2	3000876		
170332	5222	4133840	2014-04-10	2014-04-10 00:00:00	2014-04-10	5001	0	\N	0	0	\N	\N	0	347427	0	127783003	4133840		
42536	3929	3011505	1999-01-25	1999-01-25 00:00:00	1999-01-25	5001	0	\N	0	0	\N	\N	0	261211	0	19926-5	3011505		
416	19	3006322	2000-05-15	2000-05-15 00:00:00	2000-05-15	5001	0	\N	0	0	\N	\N	0	1453	0	8331-1	3006322		
27670	2548	3006322	1982-06-25	1982-06-25 00:00:00	1982-06-25	5001	0	\N	0	0	\N	\N	0	168680	0	8331-1	3006322		
55739	5116	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	339899	0	6246-3	3021226		
76106	2334	4024958	1975-06-05	1975-06-05 00:00:00	1975-06-05	5001	0	\N	0	0	\N	\N	0	155316	0	117015009	4024958		
20730	1911	3011505	2008-11-03	2008-11-03 00:00:00	2008-11-03	5001	0	\N	0	0	\N	\N	0	127174	0	19926-5	3011505		
3525	338	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	22525	0	6082-2	3000876		
5492	520	3006322	1971-07-08	1971-07-08 00:00:00	1971-07-08	5001	0	\N	0	0	\N	\N	0	34668	0	8331-1	3006322		
25355	2333	3028833	1978-05-19	1978-05-19 00:00:00	1978-05-19	5001	0	\N	0	0	\N	\N	0	155162	0	42719-5	3028833		
26364	2424	3014576	1997-06-06	1997-06-06 00:00:00	1997-06-06	5001	0	\N	0	0	\N	\N	0	160819	0	2075-0	3014576		
26446	2436	3005136	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	161591	0	6075-6	3005136		
126964	3909	4024958	1962-04-19	1962-04-19 00:00:00	1962-04-19	5001	0	\N	0	0	\N	\N	0	259853	0	117015009	4024958		
58911	1791	4052083	2017-03-22	2017-03-22 00:00:00	2017-03-22	5001	0	\N	0	0	\N	\N	0	120026	0	23426006	4052083		
162329	4979	4024958	2017-04-25	2017-04-25 00:00:00	2017-04-25	5001	0	\N	0	0	\N	\N	0	331273	0	117015009	4024958		
173684	5328	4052083	1934-03-01	1934-03-01 00:00:00	1934-03-01	5001	0	\N	0	0	\N	\N	0	354704	0	23426006	4052083		
38517	3565	3006322	1999-10-02	1999-10-02 00:00:00	1999-10-02	5001	0	\N	0	0	\N	\N	0	236719	0	8331-1	3006322		
167057	5127	4024958	2002-10-27	2002-10-27 00:00:00	2002-10-27	5001	0	\N	0	0	\N	\N	0	340891	0	117015009	4024958		
49964	4546	3006322	2014-05-31	2014-05-31 00:00:00	2014-05-31	5001	0	\N	0	0	\N	\N	0	302829	0	8331-1	3006322		
50049	4550	3036780	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	303217	0	6095-4	3036780		
30335	2779	40769184	1994-11-21	1994-11-21 00:00:00	1994-11-21	5001	0	\N	0	0	\N	\N	0	184123	0	66524-0	40769184		
28929	2672	3019406	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	177027	0	6158-0	3019406		
40294	3750	3049273	2012-01-11	2012-01-11 00:00:00	2012-01-11	5001	0	\N	0	0	\N	\N	0	249242	0	38265-5	3049273		
30736	2818	3006322	2002-07-08	2002-07-08 00:00:00	2002-07-08	5001	0	\N	0	0	\N	\N	0	186720	0	8331-1	3006322		
13015	1245	3006322	1964-05-27	1964-05-27 00:00:00	1964-05-27	5001	0	\N	0	0	\N	\N	0	81952	0	8331-1	3006322		
83548	2580	4052083	2005-05-13	2005-05-13 00:00:00	2005-05-13	5001	0	\N	0	0	\N	\N	0	170883	0	23426006	4052083		
3882	376	3006322	2013-01-12	2013-01-12 00:00:00	2013-01-12	5001	0	\N	0	0	\N	\N	0	24887	0	8331-1	3006322		
35844	3293	3006322	1927-11-23	1927-11-23 00:00:00	1927-11-23	5001	0	\N	0	0	\N	\N	0	218705	0	8331-1	3006322		
23479	2165	3006322	2010-10-31	2010-10-31 00:00:00	2010-10-31	5001	0	\N	0	0	\N	\N	0	144211	0	8331-1	3006322		
7902	756	3006322	1969-02-03	1969-02-03 00:00:00	1969-02-03	5001	0	\N	0	0	\N	\N	0	50174	0	8331-1	3006322		
23614	2175	3005136	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	145012	0	6075-6	3005136		
9382	886	3006322	1994-03-13	1994-03-13 00:00:00	1994-03-13	5001	0	\N	0	0	\N	\N	0	59088	0	8331-1	3006322		
38237	3527	3006322	1962-11-08	1962-11-08 00:00:00	1962-11-08	5001	0	\N	0	0	\N	\N	0	234087	0	8331-1	3006322		
47163	1438	4024958	1965-09-22	1965-09-22 00:00:00	1965-09-22	5001	0	\N	0	0	\N	\N	0	95837	0	117015009	4024958		
27249	851	4024958	1995-04-30	1995-04-30 00:00:00	1995-04-30	5001	0	\N	0	0	\N	\N	0	56270	0	117015009	4024958		
57876	5312	3011505	2003-01-06	2003-01-06 00:00:00	2003-01-06	5001	0	\N	0	0	\N	\N	0	353235	0	19926-5	3011505		
42336	3913	3006322	2005-03-19	2005-03-19 00:00:00	2005-03-19	5001	0	\N	0	0	\N	\N	0	260098	0	8331-1	3006322		
133922	4123	4024958	1971-02-22	1971-02-22 00:00:00	1971-02-22	5001	0	\N	0	0	\N	\N	0	274146	0	117015009	4024958		
129	3	3051031	1994-06-02	1994-06-02 00:00:00	1994-06-02	5001	0	\N	0	0	\N	\N	0	226	0	46240-8	3051031		
43825	4051	3006322	1986-12-11	1986-12-11 00:00:00	1986-12-11	5001	0	\N	0	0	\N	\N	0	269235	0	8331-1	3006322		
122821	3786	4024958	1974-03-27	1974-03-27 00:00:00	1974-03-27	5001	0	\N	0	0	\N	\N	0	251710	0	117015009	4024958		
21545	1986	3006322	2014-09-12	2014-09-12 00:00:00	2014-09-12	5001	0	\N	0	0	\N	\N	0	132255	0	8331-1	3006322		
149821	4591	4052083	1982-10-05	1982-10-05 00:00:00	1982-10-05	5001	0	\N	0	0	\N	\N	0	305925	0	23426006	4052083		
32938	2975	3006451	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	198641	0	6273-7	3006451		
33029	2985	46235214	1993-11-10	1993-11-10 00:00:00	1993-11-10	5001	0	\N	0	0	\N	\N	0	199265	0	76690-7	46235214		
29504	2715	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	180095	0	6246-3	3021226		
31837	978	4024958	2014-04-04	2014-04-04 00:00:00	2014-04-04	5001	0	\N	0	0	\N	\N	0	65144	0	117015009	4024958		
163384	5022	4024958	1975-04-25	1975-04-25 00:00:00	1975-04-25	5001	0	\N	0	0	\N	\N	0	333664	0	117015009	4024958		
9122	289	4024958	1972-02-26	1972-02-26 00:00:00	1972-02-26	5001	0	\N	0	0	\N	\N	0	19281	0	117015009	4024958		
41905	3879	46235214	2007-03-27	2007-03-27 00:00:00	2007-03-27	5001	0	\N	0	0	\N	\N	0	257661	0	76690-7	46235214		
22107	2030	3006322	1989-11-24	1989-11-24 00:00:00	1989-11-24	5001	0	\N	0	0	\N	\N	0	135146	0	8331-1	3006322		
33518	3041	3015076	1990-03-08	1990-03-08 00:00:00	1990-03-08	5001	0	\N	0	0	\N	\N	0	202452	0	6248-9	3015076		
102456	3147	4133840	1990-01-22	1990-01-22 00:00:00	1990-01-22	5001	0	\N	0	0	\N	\N	0	209427	0	127783003	4133840		
19214	603	4024958	1960-11-17	1960-11-17 00:00:00	1960-11-17	5001	0	\N	0	0	\N	\N	0	39934	0	117015009	4024958		
4955	480	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	32090	0	6248-9	3015076		
96707	2961	4024958	1985-05-14	1985-05-14 00:00:00	1985-05-14	5001	0	\N	0	0	\N	\N	0	197709	0	117015009	4024958		
29660	2731	3006322	1963-05-01	1963-05-01 00:00:00	1963-05-01	5001	0	\N	0	0	\N	\N	0	180745	0	8331-1	3006322		
49411	4506	40766240	2012-10-20	2012-10-20 00:00:00	2012-10-20	5001	0	\N	0	0	\N	\N	0	300240	0	63513-6	40766240		
27880	2566	40766240	2016-04-02	2016-04-02 00:00:00	2016-04-02	5001	0	\N	0	0	\N	\N	0	170027	0	63513-6	40766240		
39222	3625	3006322	1970-01-10	1970-01-10 00:00:00	1970-01-10	5001	0	\N	0	0	\N	\N	0	241036	0	8331-1	3006322		
19549	1783	3015076	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	119537	0	6248-9	3015076		
140134	4317	4024958	1987-07-02	1987-07-02 00:00:00	1987-07-02	5001	0	\N	0	0	\N	\N	0	286501	0	117015009	4024958		
21391	1976	3006734	1999-06-28	1999-06-28 00:00:00	1999-06-28	5001	0	\N	0	0	\N	\N	0	131406	0	6189-5	3006734		
21460	1977	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	131487	0	6189-5	3006734		
170340	5223	4052083	1978-02-08	1978-02-08 00:00:00	1978-02-08	5001	0	\N	0	0	\N	\N	0	347590	0	23426006	4052083		
42537	3929	3011505	1990-04-09	1990-04-09 00:00:00	1990-04-09	5001	0	\N	0	0	\N	\N	0	261209	0	19926-5	3011505		
417	19	3009201	2004-01-17	2004-01-17 00:00:00	2004-01-17	5001	0	\N	0	0	\N	\N	0	1497	0	3016-3	3009201		
27671	2548	3006322	2011-08-02	2011-08-02 00:00:00	2011-08-02	5001	0	\N	0	0	\N	\N	0	168711	0	8331-1	3006322		
55740	5116	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	339899	0	6273-7	3006451		
76107	2334	4133840	1980-05-22	1980-05-22 00:00:00	1980-05-22	5001	0	\N	0	0	\N	\N	0	155369	0	127783003	4133840		
20731	1911	3011505	2000-09-18	2000-09-18 00:00:00	2000-09-18	5001	0	\N	0	0	\N	\N	0	127194	0	19926-5	3011505		
3526	338	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	22525	0	6246-3	3021226		
5493	520	3049273	2011-01-06	2011-01-06 00:00:00	2011-01-06	5001	0	\N	0	0	\N	\N	0	34741	0	38265-5	3049273		
25356	2333	3009542	1978-05-19	1978-05-19 00:00:00	1978-05-19	5001	0	\N	0	0	\N	\N	0	155162	0	20570-8	3009542		
26365	2424	3035995	1997-06-06	1997-06-06 00:00:00	1997-06-06	5001	0	\N	0	0	\N	\N	0	160819	0	6768-6	3035995		
26447	2436	3014599	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	161591	0	6106-9	3014599		
54818	5017	3006322	1988-07-14	1988-07-14 00:00:00	1988-07-14	5001	0	\N	0	0	\N	\N	0	333424	0	8331-1	3006322		
58913	1791	4052083	2017-02-12	2017-02-12 00:00:00	2017-02-12	5001	0	\N	0	0	\N	\N	0	120071	0	23426006	4052083		
173639	5328	4052083	1969-05-03	1969-05-03 00:00:00	1969-05-03	5001	0	\N	0	0	\N	\N	0	354709	0	23426006	4052083		
173686	5328	4052083	1929-01-18	1929-01-18 00:00:00	1929-01-18	5001	0	\N	0	0	\N	\N	0	354618	0	23426006	4052083		
38518	3565	3006322	1986-06-03	1986-06-03 00:00:00	1986-06-03	5001	0	\N	0	0	\N	\N	0	236730	0	8331-1	3006322		
167065	5128	4052083	1994-11-17	1994-11-17 00:00:00	1994-11-17	5001	0	\N	0	0	\N	\N	0	341007	0	23426006	4052083		
49965	4546	3006322	2000-06-06	2000-06-06 00:00:00	2000-06-06	5001	0	\N	0	0	\N	\N	0	302800	0	8331-1	3006322		
50050	4550	3006734	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	303217	0	6189-5	3006734		
30336	2779	40769194	1994-11-21	1994-11-21 00:00:00	1994-11-21	5001	0	\N	0	0	\N	\N	0	184123	0	66534-9	40769194		
28930	2672	3000876	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	177027	0	6082-2	3000876		
40295	3750	3006322	1977-11-23	1977-11-23 00:00:00	1977-11-23	5001	0	\N	0	0	\N	\N	0	249225	0	8331-1	3006322		
30737	2818	3006322	1980-01-15	1980-01-15 00:00:00	1980-01-15	5001	0	\N	0	0	\N	\N	0	186754	0	8331-1	3006322		
13016	1245	3006322	1961-03-31	1961-03-31 00:00:00	1961-03-31	5001	0	\N	0	0	\N	\N	0	81950	0	8331-1	3006322		
83553	2580	4052083	1980-01-03	1980-01-03 00:00:00	1980-01-03	5001	0	\N	0	0	\N	\N	0	170880	0	23426006	4052083		
3883	376	3006322	1998-08-19	1998-08-19 00:00:00	1998-08-19	5001	0	\N	0	0	\N	\N	0	24919	0	8331-1	3006322		
35845	3293	3006322	1984-07-30	1984-07-30 00:00:00	1984-07-30	5001	0	\N	0	0	\N	\N	0	218733	0	8331-1	3006322		
23480	2166	3006322	1975-03-14	1975-03-14 00:00:00	1975-03-14	5001	0	\N	0	0	\N	\N	0	144288	0	8331-1	3006322		
7903	756	3006322	1967-03-01	1967-03-01 00:00:00	1967-03-01	5001	0	\N	0	0	\N	\N	0	50129	0	8331-1	3006322		
23615	2175	3014599	2012-08-21	2012-08-21 00:00:00	2012-08-21	5001	0	\N	0	0	\N	\N	0	144972	0	6106-9	3014599		
9383	887	3049273	2018-02-24	2018-02-24 00:00:00	2018-02-24	5001	0	\N	0	0	\N	\N	0	59163	0	38265-5	3049273		
38238	3527	3006322	2012-08-05	2012-08-05 00:00:00	2012-08-05	5001	0	\N	0	0	\N	\N	0	234036	0	8331-1	3006322		
47173	1438	4024958	2009-01-13	2009-01-13 00:00:00	2009-01-13	5001	0	\N	0	0	\N	\N	0	95830	0	117015009	4024958		
162115	4975	4024958	1990-07-15	1990-07-15 00:00:00	1990-07-15	5001	0	\N	0	0	\N	\N	0	330882	0	117015009	4024958		
57877	5312	3011505	1977-01-03	1977-01-03 00:00:00	1977-01-03	5001	0	\N	0	0	\N	\N	0	353263	0	19926-5	3011505		
42337	3913	3006322	1979-06-24	1979-06-24 00:00:00	1979-06-24	5001	0	\N	0	0	\N	\N	0	260172	0	8331-1	3006322		
133942	4123	4052083	1984-10-24	1984-10-24 00:00:00	1984-10-24	5001	0	\N	0	0	\N	\N	0	274084	0	23426006	4052083		
130	3	40758406	1994-06-02	1994-06-02 00:00:00	1994-06-02	5001	0	\N	0	0	\N	\N	0	226	0	55277-8	40758406		
43826	4051	3006734	1979-02-12	1979-02-12 00:00:00	1979-02-12	5001	0	\N	0	0	\N	\N	0	269265	0	6189-5	3006734		
122822	3786	4024958	1969-05-13	1969-05-13 00:00:00	1969-05-13	5001	0	\N	0	0	\N	\N	0	251698	0	117015009	4024958		
21546	1986	3006322	1988-12-03	1988-12-03 00:00:00	1988-12-03	5001	0	\N	0	0	\N	\N	0	132264	0	8331-1	3006322		
38447	3552	3006322	2009-08-05	2009-08-05 00:00:00	2009-08-05	5001	0	\N	0	0	\N	\N	0	235794	0	8331-1	3006322		
32939	2975	3023430	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	198641	0	6833-8	3023430		
33031	2985	3051031	1993-11-10	1993-11-10 00:00:00	1993-11-10	5001	0	\N	0	0	\N	\N	0	199265	0	46240-8	3051031		
29505	2715	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	180095	0	6273-7	3006451		
114593	3530	4024958	1980-10-05	1980-10-05 00:00:00	1980-10-05	5001	0	\N	0	0	\N	\N	0	234462	0	117015009	4024958		
163408	5022	4024958	1991-06-22	1991-06-22 00:00:00	1991-06-22	5001	0	\N	0	0	\N	\N	0	333667	0	117015009	4024958		
9123	289	4052083	2014-08-19	2014-08-19 00:00:00	2014-08-19	5001	0	\N	0	0	\N	\N	0	19310	0	23426006	4052083		
41907	3879	40758406	2007-03-27	2007-03-27 00:00:00	2007-03-27	5001	0	\N	0	0	\N	\N	0	257661	0	55277-8	40758406		
22115	2033	40766240	1976-04-10	1976-04-10 00:00:00	1976-04-10	5001	0	\N	0	0	\N	\N	0	135335	0	63513-6	40766240		
33519	3041	3019406	1990-03-08	1990-03-08 00:00:00	1990-03-08	5001	0	\N	0	0	\N	\N	0	202452	0	6158-0	3019406		
102457	3147	4133840	1994-01-31	1994-01-31 00:00:00	1994-01-31	5001	0	\N	0	0	\N	\N	0	209363	0	127783003	4133840		
26493	2444	3006322	1973-12-03	1973-12-03 00:00:00	1973-12-03	5001	0	\N	0	0	\N	\N	0	162110	0	8331-1	3006322		
4956	480	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	32090	0	6276-0	3027231		
96715	2961	4024958	1978-04-25	1978-04-25 00:00:00	1978-04-25	5001	0	\N	0	0	\N	\N	0	197748	0	117015009	4024958		
29661	2731	3006322	1999-02-17	1999-02-17 00:00:00	1999-02-17	5001	0	\N	0	0	\N	\N	0	180743	0	8331-1	3006322		
49412	4506	46235214	1956-04-22	1956-04-22 00:00:00	1956-04-22	5001	0	\N	0	0	\N	\N	0	300168	0	76690-7	46235214		
27882	2566	46235214	2016-04-02	2016-04-02 00:00:00	2016-04-02	5001	0	\N	0	0	\N	\N	0	170027	0	76690-7	46235214		
39223	3625	3008598	2010-06-30	2010-06-30 00:00:00	2010-06-30	5001	0	\N	0	0	\N	\N	0	241040	0	3024-7	3008598		
19550	1783	3012494	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	119537	0	6206-7	3012494		
140136	4317	4052083	2012-03-19	2012-03-19 00:00:00	2012-03-19	5001	0	\N	0	0	\N	\N	0	286502	0	23426006	4052083		
21392	1976	3036780	1999-06-28	1999-06-28 00:00:00	1999-06-28	5001	0	\N	0	0	\N	\N	0	131406	0	6095-4	3036780		
21461	1977	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	131487	0	6273-7	3006451		
170347	5223	4052083	1968-06-20	1968-06-20 00:00:00	1968-06-20	5001	0	\N	0	0	\N	\N	0	347585	0	23426006	4052083		
42538	3929	3006322	1957-02-10	1957-02-10 00:00:00	1957-02-10	5001	0	\N	0	0	\N	\N	0	261184	0	8331-1	3006322		
418	19	3008598	2004-01-17	2004-01-17 00:00:00	2004-01-17	5001	0	\N	0	0	\N	\N	0	1497	0	3024-7	3008598		
27672	2548	3006322	2014-03-31	2014-03-31 00:00:00	2014-03-31	5001	0	\N	0	0	\N	\N	0	168732	0	8331-1	3006322		
55741	5116	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	339899	0	6095-4	3036780		
76109	2334	4133840	1987-02-05	1987-02-05 00:00:00	1987-02-05	5001	0	\N	0	0	\N	\N	0	155337	0	127783003	4133840		
20733	1911	40766240	1960-08-19	1960-08-19 00:00:00	1960-08-19	5001	0	\N	0	0	\N	\N	0	127098	0	63513-6	40766240		
3527	338	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	22525	0	6206-7	3012494		
5494	520	3006322	1961-02-16	1961-02-16 00:00:00	1961-02-16	5001	0	\N	0	0	\N	\N	0	34725	0	8331-1	3006322		
25357	2333	3024561	1978-05-19	1978-05-19 00:00:00	1978-05-19	5001	0	\N	0	0	\N	\N	0	155162	0	1751-7	3024561		
26366	2424	3006906	1997-06-06	1997-06-06 00:00:00	1997-06-06	5001	0	\N	0	0	\N	\N	0	160819	0	17861-6	3006906		
26448	2436	3006451	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	161591	0	6273-7	3006451		
54819	5018	3006322	1995-03-13	1995-03-13 00:00:00	1995-03-13	5001	0	\N	0	0	\N	\N	0	333524	0	8331-1	3006322		
58915	1791	4024958	2011-03-30	2011-03-30 00:00:00	2011-03-30	5001	0	\N	0	0	\N	\N	0	120069	0	117015009	4024958		
173640	5328	4024958	1922-03-29	1922-03-29 00:00:00	1922-03-29	5001	0	\N	0	0	\N	\N	0	354617	0	117015009	4024958		
173692	5328	4052083	1939-02-03	1939-02-03 00:00:00	1939-02-03	5001	0	\N	0	0	\N	\N	0	354706	0	23426006	4052083		
38519	3565	3006322	2000-04-14	2000-04-14 00:00:00	2000-04-14	5001	0	\N	0	0	\N	\N	0	236716	0	8331-1	3006322		
167066	5128	4024958	1963-06-29	1963-06-29 00:00:00	1963-06-29	5001	0	\N	0	0	\N	\N	0	340959	0	117015009	4024958		
49966	4547	3006322	1990-11-11	1990-11-11 00:00:00	1990-11-11	5001	0	\N	0	0	\N	\N	0	302910	0	8331-1	3006322		
50051	4550	3020655	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	303217	0	6844-5	3020655		
30337	2779	3021226	1998-06-10	1998-06-10 00:00:00	1998-06-10	5001	0	\N	0	0	\N	\N	0	184202	0	6246-3	3021226		
28931	2672	3036780	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	177027	0	6095-4	3036780		
40296	3750	3006322	2010-09-20	2010-09-20 00:00:00	2010-09-20	5001	0	\N	0	0	\N	\N	0	249258	0	8331-1	3006322		
30738	2818	3006322	1977-04-16	1977-04-16 00:00:00	1977-04-16	5001	0	\N	0	0	\N	\N	0	186744	0	8331-1	3006322		
13018	1246	3006322	1954-05-28	1954-05-28 00:00:00	1954-05-28	5001	0	\N	0	0	\N	\N	0	82112	0	8331-1	3006322		
13253	1261	40769179	1989-05-20	1989-05-20 00:00:00	1989-05-20	5001	0	\N	0	0	\N	\N	0	83247	0	66519-0	40769179		
3884	376	3006322	1995-10-23	1995-10-23 00:00:00	1995-10-23	5001	0	\N	0	0	\N	\N	0	24918	0	8331-1	3006322		
35846	3293	3049273	2000-10-17	2000-10-17 00:00:00	2000-10-17	5001	0	\N	0	0	\N	\N	0	218696	0	38265-5	3049273		
23481	2166	3006322	2015-04-26	2015-04-26 00:00:00	2015-04-26	5001	0	\N	0	0	\N	\N	0	144318	0	8331-1	3006322		
7904	756	3006322	2015-08-06	2015-08-06 00:00:00	2015-08-06	5001	0	\N	0	0	\N	\N	0	50121	0	8331-1	3006322		
23616	2175	3005136	2012-08-21	2012-08-21 00:00:00	2012-08-21	5001	0	\N	0	0	\N	\N	0	144972	0	6075-6	3005136		
9384	887	3006322	2019-06-24	2019-06-24 00:00:00	2019-06-24	5001	0	\N	0	0	\N	\N	0	59145	0	8331-1	3006322		
38239	3527	3006322	2018-08-01	2018-08-01 00:00:00	2018-08-01	5001	0	\N	0	0	\N	\N	0	234135	0	8331-1	3006322		
15064	471	4024958	2000-03-18	2000-03-18 00:00:00	2000-03-18	5001	0	\N	0	0	\N	\N	0	31497	0	117015009	4024958		
162118	4975	4052083	2001-11-25	2001-11-25 00:00:00	2001-11-25	5001	0	\N	0	0	\N	\N	0	330883	0	23426006	4052083		
57878	5312	3011505	1997-12-22	1997-12-22 00:00:00	1997-12-22	5001	0	\N	0	0	\N	\N	0	353232	0	19926-5	3011505		
42338	3913	3006322	2006-08-22	2006-08-22 00:00:00	2006-08-22	5001	0	\N	0	0	\N	\N	0	260187	0	8331-1	3006322		
133944	4123	4024958	2003-05-01	2003-05-01 00:00:00	2003-05-01	5001	0	\N	0	0	\N	\N	0	274148	0	117015009	4024958		
133	3	46235214	1994-06-02	1994-06-02 00:00:00	1994-06-02	5001	0	\N	0	0	\N	\N	0	226	0	76690-7	46235214		
43827	4051	3020655	1979-02-12	1979-02-12 00:00:00	1979-02-12	5001	0	\N	0	0	\N	\N	0	269265	0	6844-5	3020655		
122829	3786	4024958	1997-06-28	1997-06-28 00:00:00	1997-06-28	5001	0	\N	0	0	\N	\N	0	251700	0	117015009	4024958		
21547	1986	3006322	1993-11-21	1993-11-21 00:00:00	1993-11-21	5001	0	\N	0	0	\N	\N	0	132248	0	8331-1	3006322		
38448	3553	3006322	1952-12-19	1952-12-19 00:00:00	1952-12-19	5001	0	\N	0	0	\N	\N	0	235872	0	8331-1	3006322		
32940	2975	3001247	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	198641	0	6085-5	3001247		
33032	2985	40758406	1993-11-10	1993-11-10 00:00:00	1993-11-10	5001	0	\N	0	0	\N	\N	0	199265	0	55277-8	40758406		
29506	2715	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	180095	0	6106-9	3014599		
114600	3530	4052083	1978-11-12	1978-11-12 00:00:00	1978-11-12	5001	0	\N	0	0	\N	\N	0	234499	0	23426006	4052083		
163412	5022	4052083	1978-01-10	1978-01-10 00:00:00	1978-01-10	5001	0	\N	0	0	\N	\N	0	333677	0	23426006	4052083		
9128	289	4024958	1962-10-29	1962-10-29 00:00:00	1962-10-29	5001	0	\N	0	0	\N	\N	0	19305	0	117015009	4024958		
41908	3879	40766240	2007-03-27	2007-03-27 00:00:00	2007-03-27	5001	0	\N	0	0	\N	\N	0	257661	0	63513-6	40766240		
22116	2033	3051031	1976-04-10	1976-04-10 00:00:00	1976-04-10	5001	0	\N	0	0	\N	\N	0	135335	0	46240-8	3051031		
33520	3041	3012494	1990-03-08	1990-03-08 00:00:00	1990-03-08	5001	0	\N	0	0	\N	\N	0	202452	0	6206-7	3012494		
102459	3147	4133840	1996-02-05	1996-02-05 00:00:00	1996-02-05	5001	0	\N	0	0	\N	\N	0	209346	0	127783003	4133840		
26494	2444	3006322	1960-02-16	1960-02-16 00:00:00	1960-02-16	5001	0	\N	0	0	\N	\N	0	162102	0	8331-1	3006322		
4957	480	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	32090	0	6082-2	3000876		
19321	605	4024958	1968-02-28	1968-02-28 00:00:00	1968-02-28	5001	0	\N	0	0	\N	\N	0	40153	0	117015009	4024958		
29662	2731	3006322	1978-08-22	1978-08-22 00:00:00	1978-08-22	5001	0	\N	0	0	\N	\N	0	180741	0	8331-1	3006322		
49414	4506	40766240	1956-04-22	1956-04-22 00:00:00	1956-04-22	5001	0	\N	0	0	\N	\N	0	300168	0	63513-6	40766240		
27883	2566	40758406	2016-04-02	2016-04-02 00:00:00	2016-04-02	5001	0	\N	0	0	\N	\N	0	170027	0	55277-8	40758406		
39224	3625	3009201	2010-06-30	2010-06-30 00:00:00	2010-06-30	5001	0	\N	0	0	\N	\N	0	241040	0	3016-3	3009201		
19551	1783	3006734	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	119537	0	6189-5	3006734		
140139	4317	4052083	1980-05-20	1980-05-20 00:00:00	1980-05-20	5001	0	\N	0	0	\N	\N	0	286499	0	23426006	4052083		
21393	1976	3000876	1999-06-28	1999-06-28 00:00:00	1999-06-28	5001	0	\N	0	0	\N	\N	0	131406	0	6082-2	3000876		
21462	1977	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	131487	0	6206-7	3012494		
21550	679	4024958	1981-12-28	1981-12-28 00:00:00	1981-12-28	5001	0	\N	0	0	\N	\N	0	44955	0	117015009	4024958		
42539	3929	3011505	1993-01-11	1993-01-11 00:00:00	1993-01-11	5001	0	\N	0	0	\N	\N	0	261221	0	19926-5	3011505		
419	19	3006322	2010-08-23	2010-08-23 00:00:00	2010-08-23	5001	0	\N	0	0	\N	\N	0	1498	0	8331-1	3006322		
27673	2548	3006322	2018-01-22	2018-01-22 00:00:00	2018-01-22	5001	0	\N	0	0	\N	\N	0	168712	0	8331-1	3006322		
55742	5116	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	339899	0	6106-9	3014599		
76112	2334	4133840	1965-04-29	1965-04-29 00:00:00	1965-04-29	5001	0	\N	0	0	\N	\N	0	155331	0	127783003	4133840		
20734	1911	40758406	1960-08-19	1960-08-19 00:00:00	1960-08-19	5001	0	\N	0	0	\N	\N	0	127098	0	55277-8	40758406		
3528	338	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	22474	0	6158-0	3019406		
5513	525	3020630	1952-05-22	1952-05-22 00:00:00	1952-05-22	5001	0	\N	0	0	\N	\N	0	34958	0	2885-2	3020630		
25358	2333	3013721	1978-05-19	1978-05-19 00:00:00	1978-05-19	5001	0	\N	0	0	\N	\N	0	155162	0	1920-8	3013721		
26367	2424	3006923	1997-06-06	1997-06-06 00:00:00	1997-06-06	5001	0	\N	0	0	\N	\N	0	160819	0	1742-6	3006923		
26449	2436	3027231	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	161591	0	6276-0	3027231		
54820	5018	3006322	1957-12-13	1957-12-13 00:00:00	1957-12-13	5001	0	\N	0	0	\N	\N	0	333532	0	8331-1	3006322		
58916	1791	4052083	1963-11-19	1963-11-19 00:00:00	1963-11-19	5001	0	\N	0	0	\N	\N	0	120088	0	23426006	4052083		
173644	5328	4052083	1993-12-17	1993-12-17 00:00:00	1993-12-17	5001	0	\N	0	0	\N	\N	0	354712	0	23426006	4052083		
173699	5328	4024958	2019-06-17	2019-06-17 00:00:00	2019-06-17	5001	0	\N	0	0	\N	\N	0	354612	0	117015009	4024958		
38520	3565	3006322	1963-03-15	1963-03-15 00:00:00	1963-03-15	5001	0	\N	0	0	\N	\N	0	236717	0	8331-1	3006322		
167070	5128	4024958	1971-03-28	1971-03-28 00:00:00	1971-03-28	5001	0	\N	0	0	\N	\N	0	341005	0	117015009	4024958		
49967	4547	3006322	2010-10-01	2010-10-01 00:00:00	2010-10-01	5001	0	\N	0	0	\N	\N	0	302971	0	8331-1	3006322		
50052	4550	3006451	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	303217	0	6273-7	3006451		
30338	2779	3001488	1998-06-10	1998-06-10 00:00:00	1998-06-10	5001	0	\N	0	0	\N	\N	0	184202	0	7258-7	3001488		
28932	2672	3015076	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	177027	0	6248-9	3015076		
40297	3750	3006322	2005-09-05	2005-09-05 00:00:00	2005-09-05	5001	0	\N	0	0	\N	\N	0	249229	0	8331-1	3006322		
30739	2818	3006322	2017-02-24	2017-02-24 00:00:00	2017-02-24	5001	0	\N	0	0	\N	\N	0	186772	0	8331-1	3006322		
13019	1246	3049273	2005-07-24	2005-07-24 00:00:00	2005-07-24	5001	0	\N	0	0	\N	\N	0	82056	0	38265-5	3049273		
13254	1261	40769194	1989-05-20	1989-05-20 00:00:00	1989-05-20	5001	0	\N	0	0	\N	\N	0	83247	0	66534-9	40769194		
3885	377	3006322	1985-02-01	1985-02-01 00:00:00	1985-02-01	5001	0	\N	0	0	\N	\N	0	25010	0	8331-1	3006322		
35847	3293	3006322	1940-02-14	1940-02-14 00:00:00	1940-02-14	5001	0	\N	0	0	\N	\N	0	218661	0	8331-1	3006322		
23482	2166	3006322	1976-12-16	1976-12-16 00:00:00	1976-12-16	5001	0	\N	0	0	\N	\N	0	144289	0	8331-1	3006322		
7905	756	3006322	1981-05-25	1981-05-25 00:00:00	1981-05-25	5001	0	\N	0	0	\N	\N	0	50119	0	8331-1	3006322		
23617	2175	3027231	2012-08-21	2012-08-21 00:00:00	2012-08-21	5001	0	\N	0	0	\N	\N	0	144972	0	6276-0	3027231		
9385	887	3006322	1992-10-17	1992-10-17 00:00:00	1992-10-17	5001	0	\N	0	0	\N	\N	0	59111	0	8331-1	3006322		
38240	3527	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	234071	0	6273-7	3006451		
15103	472	4024958	1996-09-20	1996-09-20 00:00:00	1996-09-20	5001	0	\N	0	0	\N	\N	0	31514	0	117015009	4024958		
162119	4975	4024958	1965-08-10	1965-08-10 00:00:00	1965-08-10	5001	0	\N	0	0	\N	\N	0	330844	0	117015009	4024958		
57883	5314	3006322	1980-02-04	1980-02-04 00:00:00	1980-02-04	5001	0	\N	0	0	\N	\N	0	353429	0	8331-1	3006322		
42339	3913	40769194	1981-10-23	1981-10-23 00:00:00	1981-10-23	5001	0	\N	0	0	\N	\N	0	260078	0	66534-9	40769194		
133966	4124	4024958	1976-03-08	1976-03-08 00:00:00	1976-03-08	5001	0	\N	0	0	\N	\N	0	274204	0	117015009	4024958		
134	3	3051031	1993-06-07	1993-06-07 00:00:00	1993-06-07	5001	0	\N	0	0	\N	\N	0	290	0	46240-8	3051031		
43828	4051	3001247	1979-02-12	1979-02-12 00:00:00	1979-02-12	5001	0	\N	0	0	\N	\N	0	269265	0	6085-5	3001247		
122833	3786	4024958	1981-09-11	1981-09-11 00:00:00	1981-09-11	5001	0	\N	0	0	\N	\N	0	251711	0	117015009	4024958		
21548	1987	3006322	1947-11-21	1947-11-21 00:00:00	1947-11-21	5001	0	\N	0	0	\N	\N	0	132316	0	8331-1	3006322		
38449	3553	3006322	1959-10-01	1959-10-01 00:00:00	1959-10-01	5001	0	\N	0	0	\N	\N	0	235905	0	8331-1	3006322		
32941	2975	3012494	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	198641	0	6206-7	3012494		
33033	2985	40766240	1993-11-10	1993-11-10 00:00:00	1993-11-10	5001	0	\N	0	0	\N	\N	0	199265	0	63513-6	40766240		
29507	2715	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	180095	0	6276-0	3027231		
114604	3530	4024958	1963-10-04	1963-10-04 00:00:00	1963-10-04	5001	0	\N	0	0	\N	\N	0	234466	0	117015009	4024958		
1254	99	3011505	2016-04-09	2016-04-09 00:00:00	2016-04-09	5001	0	\N	0	0	\N	\N	0	6769	0	19926-5	3011505		
20422	642	4052083	1944-03-14	1944-03-14 00:00:00	1944-03-14	5001	0	\N	0	0	\N	\N	0	42517	0	23426006	4052083		
41911	3879	3051031	2007-02-25	2007-02-25 00:00:00	2007-02-25	5001	0	\N	0	0	\N	\N	0	257717	0	46240-8	3051031		
22117	2033	40758406	1976-04-10	1976-04-10 00:00:00	1976-04-10	5001	0	\N	0	0	\N	\N	0	135335	0	55277-8	40758406		
33521	3041	3036780	1990-03-08	1990-03-08 00:00:00	1990-03-08	5001	0	\N	0	0	\N	\N	0	202452	0	6095-4	3036780		
102462	3147	4133840	2000-02-28	2000-02-28 00:00:00	2000-02-28	5001	0	\N	0	0	\N	\N	0	209425	0	127783003	4133840		
26495	2444	3006322	1980-03-27	1980-03-27 00:00:00	1980-03-27	5001	0	\N	0	0	\N	\N	0	162165	0	8331-1	3006322		
4958	480	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	32090	0	6095-4	3036780		
19323	605	4024958	2000-08-15	2000-08-15 00:00:00	2000-08-15	5001	0	\N	0	0	\N	\N	0	40186	0	117015009	4024958		
29663	2732	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	180939	0	6276-0	3027231		
49415	4506	3051031	1956-04-22	1956-04-22 00:00:00	1956-04-22	5001	0	\N	0	0	\N	\N	0	300168	0	46240-8	3051031		
27885	2566	40758406	2016-11-28	2016-11-28 00:00:00	2016-11-28	5001	0	\N	0	0	\N	\N	0	170002	0	55277-8	40758406		
39225	3625	3006322	1960-10-08	1960-10-08 00:00:00	1960-10-08	5001	0	\N	0	0	\N	\N	0	241116	0	8331-1	3006322		
19552	1783	3023430	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	119537	0	6833-8	3023430		
140156	4319	4052083	2009-04-04	2009-04-04 00:00:00	2009-04-04	5001	0	\N	0	0	\N	\N	0	286612	0	23426006	4052083		
21394	1976	3027231	1999-06-28	1999-06-28 00:00:00	1999-06-28	5001	0	\N	0	0	\N	\N	0	131406	0	6276-0	3027231		
21463	1977	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	131487	0	6246-3	3021226		
21552	679	4052083	2011-06-11	2011-06-11 00:00:00	2011-06-11	5001	0	\N	0	0	\N	\N	0	44940	0	23426006	4052083		
42540	3929	3011505	1997-01-20	1997-01-20 00:00:00	1997-01-20	5001	0	\N	0	0	\N	\N	0	261181	0	19926-5	3011505		
420	19	3006322	2010-01-09	2010-01-09 00:00:00	2010-01-09	5001	0	\N	0	0	\N	\N	0	1513	0	8331-1	3006322		
27677	2550	3006322	1986-05-02	1986-05-02 00:00:00	1986-05-02	5001	0	\N	0	0	\N	\N	0	168816	0	8331-1	3006322		
55743	5116	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	339899	0	6844-5	3020655		
76113	2334	4133840	1978-05-18	1978-05-18 00:00:00	1978-05-18	5001	0	\N	0	0	\N	\N	0	155290	0	127783003	4133840		
20735	1911	3051031	1960-08-19	1960-08-19 00:00:00	1960-08-19	5001	0	\N	0	0	\N	\N	0	127098	0	46240-8	3051031		
3529	338	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	22474	0	6248-9	3015076		
5514	525	3015632	1952-05-22	1952-05-22 00:00:00	1952-05-22	5001	0	\N	0	0	\N	\N	0	34958	0	2028-9	3015632		
25359	2333	3027970	1978-05-19	1978-05-19 00:00:00	1978-05-19	5001	0	\N	0	0	\N	\N	0	155162	0	10834-0	3027970		
26368	2424	3024731	1997-06-06	1997-06-06 00:00:00	1997-06-06	5001	0	\N	0	0	\N	\N	0	160819	0	30428-7	3024731		
26450	2436	3049273	1990-01-20	1990-01-20 00:00:00	1990-01-20	5001	0	\N	0	0	\N	\N	0	161576	0	38265-5	3049273		
54821	5018	3006322	2009-05-08	2009-05-08 00:00:00	2009-05-08	5001	0	\N	0	0	\N	\N	0	333526	0	8331-1	3006322		
58917	1791	4052083	1969-12-30	1969-12-30 00:00:00	1969-12-30	5001	0	\N	0	0	\N	\N	0	120089	0	23426006	4052083		
173650	5328	4024958	1981-05-26	1981-05-26 00:00:00	1981-05-26	5001	0	\N	0	0	\N	\N	0	354621	0	117015009	4024958		
173721	5329	4052083	2009-12-01	2009-12-01 00:00:00	2009-12-01	5001	0	\N	0	0	\N	\N	0	354765	0	23426006	4052083		
38521	3565	3000963	1976-02-25	1976-02-25 00:00:00	1976-02-25	5001	0	\N	0	0	\N	\N	0	236785	0	718-7	3000963		
167118	5128	4024958	1937-03-18	1937-03-18 00:00:00	1937-03-18	5001	0	\N	0	0	\N	\N	0	340964	0	117015009	4024958		
49968	4547	3006322	1928-03-09	1928-03-09 00:00:00	1928-03-09	5001	0	\N	0	0	\N	\N	0	302856	0	8331-1	3006322		
50053	4550	3014599	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	303217	0	6106-9	3014599		
30339	2779	3014599	1998-06-10	1998-06-10 00:00:00	1998-06-10	5001	0	\N	0	0	\N	\N	0	184202	0	6106-9	3014599		
28933	2672	3005136	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	177027	0	6075-6	3005136		
40298	3750	3006322	2001-10-16	2001-10-16 00:00:00	2001-10-16	5001	0	\N	0	0	\N	\N	0	249228	0	8331-1	3006322		
30740	2818	3006322	2010-03-13	2010-03-13 00:00:00	2010-03-13	5001	0	\N	0	0	\N	\N	0	186722	0	8331-1	3006322		
13020	1246	3006322	2007-01-18	2007-01-18 00:00:00	2007-01-18	5001	0	\N	0	0	\N	\N	0	82092	0	8331-1	3006322		
13255	1261	3006322	1987-05-31	1987-05-31 00:00:00	1987-05-31	5001	0	\N	0	0	\N	\N	0	83251	0	8331-1	3006322		
3886	377	3006322	1999-04-04	1999-04-04 00:00:00	1999-04-04	5001	0	\N	0	0	\N	\N	0	25020	0	8331-1	3006322		
35848	3293	3006322	2005-09-06	2005-09-06 00:00:00	2005-09-06	5001	0	\N	0	0	\N	\N	0	218709	0	8331-1	3006322		
23483	2166	3006322	1978-05-26	1978-05-26 00:00:00	1978-05-26	5001	0	\N	0	0	\N	\N	0	144304	0	8331-1	3006322		
7906	756	3006322	1971-07-07	1971-07-07 00:00:00	1971-07-07	5001	0	\N	0	0	\N	\N	0	50117	0	8331-1	3006322		
23618	2175	3006451	2012-08-21	2012-08-21 00:00:00	2012-08-21	5001	0	\N	0	0	\N	\N	0	144972	0	6273-7	3006451		
9386	887	3006322	1969-07-25	1969-07-25 00:00:00	1969-07-25	5001	0	\N	0	0	\N	\N	0	59137	0	8331-1	3006322		
38241	3527	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	234071	0	6276-0	3027231		
107270	3308	4024958	1957-06-20	1957-06-20 00:00:00	1957-06-20	5001	0	\N	0	0	\N	\N	0	219663	0	117015009	4024958		
162120	4975	4024958	2011-07-03	2011-07-03 00:00:00	2011-07-03	5001	0	\N	0	0	\N	\N	0	330908	0	117015009	4024958		
57884	5314	3006322	1986-02-15	1986-02-15 00:00:00	1986-02-15	5001	0	\N	0	0	\N	\N	0	353389	0	8331-1	3006322		
42340	3913	40769179	1981-10-23	1981-10-23 00:00:00	1981-10-23	5001	0	\N	0	0	\N	\N	0	260078	0	66519-0	40769179		
133967	4124	4024958	1980-05-30	1980-05-30 00:00:00	1980-05-30	5001	0	\N	0	0	\N	\N	0	274173	0	117015009	4024958		
135	3	46235214	1993-06-07	1993-06-07 00:00:00	1993-06-07	5001	0	\N	0	0	\N	\N	0	290	0	76690-7	46235214		
43829	4051	3027231	1979-02-12	1979-02-12 00:00:00	1979-02-12	5001	0	\N	0	0	\N	\N	0	269265	0	6276-0	3027231		
122840	3786	4024958	2011-03-29	2011-03-29 00:00:00	2011-03-29	5001	0	\N	0	0	\N	\N	0	251702	0	117015009	4024958		
21549	1987	3006322	1944-08-09	1944-08-09 00:00:00	1944-08-09	5001	0	\N	0	0	\N	\N	0	132281	0	8331-1	3006322		
38451	3553	3006322	1962-02-02	1962-02-02 00:00:00	1962-02-02	5001	0	\N	0	0	\N	\N	0	235906	0	8331-1	3006322		
32942	2975	3014599	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	198641	0	6106-9	3014599		
33034	2985	3049273	2016-07-13	2016-07-13 00:00:00	2016-07-13	5001	0	\N	0	0	\N	\N	0	199192	0	38265-5	3049273		
29508	2715	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	180095	0	6844-5	3020655		
114610	3530	4024958	1977-02-10	1977-02-10 00:00:00	1977-02-10	5001	0	\N	0	0	\N	\N	0	234468	0	117015009	4024958		
1255	99	3011505	2011-07-30	2011-07-30 00:00:00	2011-07-30	5001	0	\N	0	0	\N	\N	0	6749	0	19926-5	3011505		
20460	642	4024958	2013-12-31	2013-12-31 00:00:00	2013-12-31	5001	0	\N	0	0	\N	\N	0	42541	0	117015009	4024958		
41912	3879	46235214	2007-02-25	2007-02-25 00:00:00	2007-02-25	5001	0	\N	0	0	\N	\N	0	257717	0	76690-7	46235214		
22118	2033	46235214	1976-04-10	1976-04-10 00:00:00	1976-04-10	5001	0	\N	0	0	\N	\N	0	135335	0	76690-7	46235214		
33522	3041	3005136	1990-03-08	1990-03-08 00:00:00	1990-03-08	5001	0	\N	0	0	\N	\N	0	202452	0	6075-6	3005136		
102466	3147	4133840	2001-03-05	2001-03-05 00:00:00	2001-03-05	5001	0	\N	0	0	\N	\N	0	209365	0	127783003	4133840		
26496	2445	3006322	1953-02-11	1953-02-11 00:00:00	1953-02-11	5001	0	\N	0	0	\N	\N	0	162235	0	8331-1	3006322		
4959	480	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	32090	0	6246-3	3021226		
19324	605	4024958	1995-11-26	1995-11-26 00:00:00	1995-11-26	5001	0	\N	0	0	\N	\N	0	40128	0	117015009	4024958		
29664	2732	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	180939	0	6844-5	3020655		
49416	4506	40758406	1956-04-22	1956-04-22 00:00:00	1956-04-22	5001	0	\N	0	0	\N	\N	0	300168	0	55277-8	40758406		
27886	2566	46235214	2016-11-28	2016-11-28 00:00:00	2016-11-28	5001	0	\N	0	0	\N	\N	0	170002	0	76690-7	46235214		
39226	3625	3006322	1962-05-26	1962-05-26 00:00:00	1962-05-26	5001	0	\N	0	0	\N	\N	0	241034	0	8331-1	3006322		
19553	1783	3036780	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	119537	0	6095-4	3036780		
151435	4641	4133840	2018-07-19	2018-07-19 00:00:00	2018-07-19	5001	0	\N	0	0	\N	\N	0	309353	0	127783003	4133840		
21395	1976	3005136	1999-06-28	1999-06-28 00:00:00	1999-06-28	5001	0	\N	0	0	\N	\N	0	131406	0	6075-6	3005136		
21464	1977	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	131487	0	6075-6	3005136		
21558	679	4052083	1996-08-01	1996-08-01 00:00:00	1996-08-01	5001	0	\N	0	0	\N	\N	0	44939	0	23426006	4052083		
42541	3929	3006322	1996-11-01	1996-11-01 00:00:00	1996-11-01	5001	0	\N	0	0	\N	\N	0	261189	0	8331-1	3006322		
421	19	3049273	2003-07-16	2003-07-16 00:00:00	2003-07-16	5001	0	\N	0	0	\N	\N	0	1545	0	38265-5	3049273		
27678	2550	3006322	1993-08-03	1993-08-03 00:00:00	1993-08-03	5001	0	\N	0	0	\N	\N	0	168789	0	8331-1	3006322		
55744	5116	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	339899	0	6833-8	3023430		
76115	2334	4024958	1977-09-03	1977-09-03 00:00:00	1977-09-03	5001	0	\N	0	0	\N	\N	0	155306	0	117015009	4024958		
20737	1911	46235214	1960-08-19	1960-08-19 00:00:00	1960-08-19	5001	0	\N	0	0	\N	\N	0	127098	0	76690-7	46235214		
3530	338	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	22474	0	6273-7	3006451		
5515	525	3009542	1952-05-22	1952-05-22 00:00:00	1952-05-22	5001	0	\N	0	0	\N	\N	0	34958	0	20570-8	3009542		
25360	2333	3019550	1978-05-19	1978-05-19 00:00:00	1978-05-19	5001	0	\N	0	0	\N	\N	0	155162	0	2951-2	3019550		
26369	2424	3026361	1997-06-06	1997-06-06 00:00:00	1997-06-06	5001	0	\N	0	0	\N	\N	0	160819	0	26453-1	3026361		
26451	2436	3006322	1953-11-21	1953-11-21 00:00:00	1953-11-21	5001	0	\N	0	0	\N	\N	0	161639	0	8331-1	3006322		
54845	5022	3006322	1975-04-25	1975-04-25 00:00:00	1975-04-25	5001	0	\N	0	0	\N	\N	0	333664	0	8331-1	3006322		
58918	1791	4024958	1976-10-19	1976-10-19 00:00:00	1976-10-19	5001	0	\N	0	0	\N	\N	0	120086	0	117015009	4024958		
39797	3698	3006322	2004-06-26	2004-06-26 00:00:00	2004-06-26	5001	0	\N	0	0	\N	\N	0	245830	0	8331-1	3006322		
173727	5329	4024958	1994-11-21	1994-11-21 00:00:00	1994-11-21	5001	0	\N	0	0	\N	\N	0	354758	0	117015009	4024958		
38522	3565	3009542	1976-02-25	1976-02-25 00:00:00	1976-02-25	5001	0	\N	0	0	\N	\N	0	236785	0	20570-8	3009542		
28199	2594	3006322	1981-05-01	1981-05-01 00:00:00	1981-05-01	5001	0	\N	0	0	\N	\N	0	171710	0	8331-1	3006322		
49969	4547	3049273	1969-06-29	1969-06-29 00:00:00	1969-06-29	5001	0	\N	0	0	\N	\N	0	302950	0	38265-5	3049273		
50054	4550	3021226	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	303217	0	6246-3	3021226		
30340	2779	3005136	1998-06-10	1998-06-10 00:00:00	1998-06-10	5001	0	\N	0	0	\N	\N	0	184202	0	6075-6	3005136		
28934	2672	3012494	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	177027	0	6206-7	3012494		
40299	3750	3006322	1990-01-27	1990-01-27 00:00:00	1990-01-27	5001	0	\N	0	0	\N	\N	0	249227	0	8331-1	3006322		
30741	2821	3049273	1990-05-05	1990-05-05 00:00:00	1990-05-05	5001	0	\N	0	0	\N	\N	0	186853	0	38265-5	3049273		
13021	1246	3006322	1997-07-31	1997-07-31 00:00:00	1997-07-31	5001	0	\N	0	0	\N	\N	0	81990	0	8331-1	3006322		
13256	1261	3006734	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	83187	0	6189-5	3006734		
3887	377	3006322	1970-09-18	1970-09-18 00:00:00	1970-09-18	5001	0	\N	0	0	\N	\N	0	24955	0	8331-1	3006322		
35849	3293	3006322	1927-10-08	1927-10-08 00:00:00	1927-10-08	5001	0	\N	0	0	\N	\N	0	218660	0	8331-1	3006322		
23484	2167	3006322	1988-03-26	1988-03-26 00:00:00	1988-03-26	5001	0	\N	0	0	\N	\N	0	144389	0	8331-1	3006322		
7907	757	3006322	1926-05-05	1926-05-05 00:00:00	1926-05-05	5001	0	\N	0	0	\N	\N	0	50234	0	8331-1	3006322		
23619	2175	3000876	2012-08-21	2012-08-21 00:00:00	2012-08-21	5001	0	\N	0	0	\N	\N	0	144972	0	6082-2	3000876		
9387	887	3006322	1971-10-27	1971-10-27 00:00:00	1971-10-27	5001	0	\N	0	0	\N	\N	0	59154	0	8331-1	3006322		
38242	3527	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	234071	0	7258-7	3001488		
107299	3311	4024958	2015-10-02	2015-10-02 00:00:00	2015-10-02	5001	0	\N	0	0	\N	\N	0	219817	0	117015009	4024958		
162129	4975	4052083	1983-05-25	1983-05-25 00:00:00	1983-05-25	5001	0	\N	0	0	\N	\N	0	330905	0	23426006	4052083		
57885	5314	3006322	1958-05-19	1958-05-19 00:00:00	1958-05-19	5001	0	\N	0	0	\N	\N	0	353407	0	8331-1	3006322		
42341	3913	40769189	1981-10-23	1981-10-23 00:00:00	1981-10-23	5001	0	\N	0	0	\N	\N	0	260078	0	66529-9	40769189		
133971	4124	4024958	2002-06-11	2002-06-11 00:00:00	2002-06-11	5001	0	\N	0	0	\N	\N	0	274177	0	117015009	4024958		
136	3	40766240	1993-06-07	1993-06-07 00:00:00	1993-06-07	5001	0	\N	0	0	\N	\N	0	290	0	63513-6	40766240		
43830	4051	3019406	1979-02-12	1979-02-12 00:00:00	1979-02-12	5001	0	\N	0	0	\N	\N	0	269265	0	6158-0	3019406		
122844	3786	4052083	1964-12-08	1964-12-08 00:00:00	1964-12-08	5001	0	\N	0	0	\N	\N	0	251709	0	23426006	4052083		
21550	1987	3006322	1968-07-15	1968-07-15 00:00:00	1968-07-15	5001	0	\N	0	0	\N	\N	0	132336	0	8331-1	3006322		
38452	3553	3006322	1937-06-08	1937-06-08 00:00:00	1937-06-08	5001	0	\N	0	0	\N	\N	0	235932	0	8331-1	3006322		
32943	2975	3006734	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	198641	0	6189-5	3006734		
33035	2985	3051031	2011-07-04	2011-07-04 00:00:00	2011-07-04	5001	0	\N	0	0	\N	\N	0	199210	0	46240-8	3051031		
29509	2715	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	180095	0	6082-2	3000876		
114612	3531	4052083	1987-05-30	1987-05-30 00:00:00	1987-05-30	5001	0	\N	0	0	\N	\N	0	234569	0	23426006	4052083		
1256	99	3011505	2009-07-18	2009-07-18 00:00:00	2009-07-18	5001	0	\N	0	0	\N	\N	0	6751	0	19926-5	3011505		
55659	5111	3006322	1949-04-09	1949-04-09 00:00:00	1949-04-09	5001	0	\N	0	0	\N	\N	0	339618	0	8331-1	3006322		
41913	3879	40758406	2007-02-25	2007-02-25 00:00:00	2007-02-25	5001	0	\N	0	0	\N	\N	0	257717	0	55277-8	40758406		
22120	2033	40758406	1976-03-11	1976-03-11 00:00:00	1976-03-11	5001	0	\N	0	0	\N	\N	0	135375	0	55277-8	40758406		
33523	3041	3014599	1990-03-08	1990-03-08 00:00:00	1990-03-08	5001	0	\N	0	0	\N	\N	0	202452	0	6106-9	3014599		
102503	3149	4024958	1968-10-17	1968-10-17 00:00:00	1968-10-17	5001	0	\N	0	0	\N	\N	0	209524	0	117015009	4024958		
26497	2445	3006322	1935-08-19	1935-08-19 00:00:00	1935-08-19	5001	0	\N	0	0	\N	\N	0	162197	0	8331-1	3006322		
4960	480	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	32090	0	6273-7	3006451		
19332	605	4052083	2013-06-09	2013-06-09 00:00:00	2013-06-09	5001	0	\N	0	0	\N	\N	0	40178	0	23426006	4052083		
29665	2732	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	180939	0	6082-2	3000876		
49419	4506	3051031	2014-02-12	2014-02-12 00:00:00	2014-02-12	5001	0	\N	0	0	\N	\N	0	300178	0	46240-8	3051031		
27888	2566	3051031	2016-11-28	2016-11-28 00:00:00	2016-11-28	5001	0	\N	0	0	\N	\N	0	170002	0	46240-8	3051031		
39227	3625	3006322	1965-10-18	1965-10-18 00:00:00	1965-10-18	5001	0	\N	0	0	\N	\N	0	241035	0	8331-1	3006322		
19554	1783	3020655	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	119537	0	6844-5	3020655		
151438	4641	4133840	2009-07-23	2009-07-23 00:00:00	2009-07-23	5001	0	\N	0	0	\N	\N	0	309318	0	127783003	4133840		
21396	1976	3021226	1999-06-28	1999-06-28 00:00:00	1999-06-28	5001	0	\N	0	0	\N	\N	0	131406	0	6246-3	3021226		
21471	1980	3006322	1991-02-15	1991-02-15 00:00:00	1991-02-15	5001	0	\N	0	0	\N	\N	0	131786	0	8331-1	3006322		
21560	679	4024958	1984-10-27	1984-10-27 00:00:00	1984-10-27	5001	0	\N	0	0	\N	\N	0	44938	0	117015009	4024958		
42542	3930	3011505	1971-01-02	1971-01-02 00:00:00	1971-01-02	5001	0	\N	0	0	\N	\N	0	261304	0	19926-5	3011505		
422	19	3006322	1974-10-19	1974-10-19 00:00:00	1974-10-19	5001	0	\N	0	0	\N	\N	0	1482	0	8331-1	3006322		
27679	2551	3006322	1978-02-24	1978-02-24 00:00:00	1978-02-24	5001	0	\N	0	0	\N	\N	0	168856	0	8331-1	3006322		
55745	5116	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	339995	0	6085-5	3001247		
76117	2334	4133840	1997-04-03	1997-04-03 00:00:00	1997-04-03	5001	0	\N	0	0	\N	\N	0	155300	0	127783003	4133840		
20738	1911	3011505	1998-09-07	1998-09-07 00:00:00	1998-09-07	5001	0	\N	0	0	\N	\N	0	127121	0	19926-5	3011505		
3531	338	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	22474	0	6189-5	3006734		
5516	525	3014576	1952-05-22	1952-05-22 00:00:00	1952-05-22	5001	0	\N	0	0	\N	\N	0	34958	0	2075-0	3014576		
25361	2333	3015632	1978-05-19	1978-05-19 00:00:00	1978-05-19	5001	0	\N	0	0	\N	\N	0	155162	0	2028-9	3015632		
26370	2424	3019550	1997-06-06	1997-06-06 00:00:00	1997-06-06	5001	0	\N	0	0	\N	\N	0	160819	0	2951-2	3019550		
26452	2436	40769184	1930-03-21	1930-03-21 00:00:00	1930-03-21	5001	0	\N	0	0	\N	\N	0	161496	0	66524-0	40769184		
54846	5022	3006322	1991-06-22	1991-06-22 00:00:00	1991-06-22	5001	0	\N	0	0	\N	\N	0	333667	0	8331-1	3006322		
58919	1791	4024958	1986-03-29	1986-03-29 00:00:00	1986-03-29	5001	0	\N	0	0	\N	\N	0	120066	0	117015009	4024958		
39798	3698	3006322	1954-08-18	1954-08-18 00:00:00	1954-08-18	5001	0	\N	0	0	\N	\N	0	245852	0	8331-1	3006322		
173729	5329	4052083	2012-05-04	2012-05-04 00:00:00	2012-05-04	5001	0	\N	0	0	\N	\N	0	354792	0	23426006	4052083		
38523	3565	3006322	1971-05-12	1971-05-12 00:00:00	1971-05-12	5001	0	\N	0	0	\N	\N	0	236729	0	8331-1	3006322		
28200	2594	3049273	1979-09-03	1979-09-03 00:00:00	1979-09-03	5001	0	\N	0	0	\N	\N	0	171726	0	38265-5	3049273		
49970	4547	3006322	1976-11-13	1976-11-13 00:00:00	1976-11-13	5001	0	\N	0	0	\N	\N	0	302968	0	8331-1	3006322		
50055	4550	3027231	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	303217	0	6276-0	3027231		
30341	2779	3015076	1998-06-10	1998-06-10 00:00:00	1998-06-10	5001	0	\N	0	0	\N	\N	0	184202	0	6248-9	3015076		
28935	2672	3014599	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	177027	0	6106-9	3014599		
40300	3750	3006322	1979-04-29	1979-04-29 00:00:00	1979-04-29	5001	0	\N	0	0	\N	\N	0	249248	0	8331-1	3006322		
30742	2821	3006322	1950-05-18	1950-05-18 00:00:00	1950-05-18	5001	0	\N	0	0	\N	\N	0	186868	0	8331-1	3006322		
13023	1246	3006322	1986-12-03	1986-12-03 00:00:00	1986-12-03	5001	0	\N	0	0	\N	\N	0	82062	0	8331-1	3006322		
13257	1261	3023430	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	83187	0	6833-8	3023430		
3888	377	3006322	1975-05-11	1975-05-11 00:00:00	1975-05-11	5001	0	\N	0	0	\N	\N	0	25009	0	8331-1	3006322		
35850	3293	3006322	1935-07-24	1935-07-24 00:00:00	1935-07-24	5001	0	\N	0	0	\N	\N	0	218701	0	8331-1	3006322		
23485	2168	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	144458	0	6189-5	3006734		
7910	757	3006322	1964-01-04	1964-01-04 00:00:00	1964-01-04	5001	0	\N	0	0	\N	\N	0	50192	0	8331-1	3006322		
23620	2175	3001247	2012-08-21	2012-08-21 00:00:00	2012-08-21	5001	0	\N	0	0	\N	\N	0	144972	0	6085-5	3001247		
9388	887	3006322	1996-09-06	1996-09-06 00:00:00	1996-09-06	5001	0	\N	0	0	\N	\N	0	59112	0	8331-1	3006322		
38243	3527	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	234071	0	6189-5	3006734		
107309	3311	4052083	1979-01-15	1979-01-15 00:00:00	1979-01-15	5001	0	\N	0	0	\N	\N	0	219798	0	23426006	4052083		
162141	4976	4052083	1982-09-21	1982-09-21 00:00:00	1982-09-21	5001	0	\N	0	0	\N	\N	0	331037	0	23426006	4052083		
57886	5315	3006322	1977-02-15	1977-02-15 00:00:00	1977-02-15	5001	0	\N	0	0	\N	\N	0	353467	0	8331-1	3006322		
42342	3913	40769184	1981-10-23	1981-10-23 00:00:00	1981-10-23	5001	0	\N	0	0	\N	\N	0	260078	0	66524-0	40769184		
133972	4124	4024958	1988-12-10	1988-12-10 00:00:00	1988-12-10	5001	0	\N	0	0	\N	\N	0	274193	0	117015009	4024958		
138	3	40758406	1993-06-07	1993-06-07 00:00:00	1993-06-07	5001	0	\N	0	0	\N	\N	0	290	0	55277-8	40758406		
43831	4051	3005136	1979-02-12	1979-02-12 00:00:00	1979-02-12	5001	0	\N	0	0	\N	\N	0	269265	0	6075-6	3005136		
122846	3786	4052083	2002-07-25	2002-07-25 00:00:00	2002-07-25	5001	0	\N	0	0	\N	\N	0	251716	0	23426006	4052083		
21551	1987	3006322	2006-04-03	2006-04-03 00:00:00	2006-04-03	5001	0	\N	0	0	\N	\N	0	132339	0	8331-1	3006322		
38453	3553	3006322	1951-01-04	1951-01-04 00:00:00	1951-01-04	5001	0	\N	0	0	\N	\N	0	235923	0	8331-1	3006322		
32944	2975	3021226	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	198641	0	6246-3	3021226		
33036	2985	46235214	2011-07-04	2011-07-04 00:00:00	2011-07-04	5001	0	\N	0	0	\N	\N	0	199210	0	76690-7	46235214		
29510	2715	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	180095	0	6158-0	3019406		
114616	3531	4024958	1990-02-03	1990-02-03 00:00:00	1990-02-03	5001	0	\N	0	0	\N	\N	0	234571	0	117015009	4024958		
1257	99	3011505	2018-04-21	2018-04-21 00:00:00	2018-04-21	5001	0	\N	0	0	\N	\N	0	6770	0	19926-5	3011505		
55661	5113	3006322	2007-01-10	2007-01-10 00:00:00	2007-01-10	5001	0	\N	0	0	\N	\N	0	339668	0	8331-1	3006322		
41914	3879	40766240	2007-02-25	2007-02-25 00:00:00	2007-02-25	5001	0	\N	0	0	\N	\N	0	257717	0	63513-6	40766240		
22121	2033	3051031	1976-03-11	1976-03-11 00:00:00	1976-03-11	5001	0	\N	0	0	\N	\N	0	135375	0	46240-8	3051031		
33524	3041	3023430	1990-03-08	1990-03-08 00:00:00	1990-03-08	5001	0	\N	0	0	\N	\N	0	202452	0	6833-8	3023430		
7802	248	4052083	1981-02-16	1981-02-16 00:00:00	1981-02-16	5001	0	\N	0	0	\N	\N	0	16677	0	23426006	4052083		
26499	2445	3006322	1940-06-02	1940-06-02 00:00:00	1940-06-02	5001	0	\N	0	0	\N	\N	0	162256	0	8331-1	3006322		
4961	480	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	32090	0	6085-5	3001247		
30641	950	4024958	2000-07-30	2000-07-30 00:00:00	2000-07-30	5001	0	\N	0	0	\N	\N	0	63068	0	117015009	4024958		
29666	2732	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	180939	0	6158-0	3019406		
49420	4506	40758406	2014-02-12	2014-02-12 00:00:00	2014-02-12	5001	0	\N	0	0	\N	\N	0	300178	0	55277-8	40758406		
27889	2566	40766240	2016-11-28	2016-11-28 00:00:00	2016-11-28	5001	0	\N	0	0	\N	\N	0	170002	0	63513-6	40766240		
39228	3625	3000963	1997-07-03	1997-07-03 00:00:00	1997-07-03	5001	0	\N	0	0	\N	\N	0	241122	0	718-7	3000963		
19555	1783	3006322	1982-10-01	1982-10-01 00:00:00	1982-10-01	5001	0	\N	0	0	\N	\N	0	119425	0	8331-1	3006322		
151443	4641	4133840	2015-08-06	2015-08-06 00:00:00	2015-08-06	5001	0	\N	0	0	\N	\N	0	309345	0	127783003	4133840		
21397	1976	3015076	1999-06-28	1999-06-28 00:00:00	1999-06-28	5001	0	\N	0	0	\N	\N	0	131406	0	6248-9	3015076		
21472	1980	3019406	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	131768	0	6158-0	3019406		
21572	680	4052083	1989-03-19	1989-03-19 00:00:00	1989-03-19	5001	0	\N	0	0	\N	\N	0	44995	0	23426006	4052083		
42543	3930	3011505	1965-12-04	1965-12-04 00:00:00	1965-12-04	5001	0	\N	0	0	\N	\N	0	261253	0	19926-5	3011505		
423	19	3006322	2014-09-11	2014-09-11 00:00:00	2014-09-11	5001	0	\N	0	0	\N	\N	0	1487	0	8331-1	3006322		
27680	2551	3006322	1998-04-20	1998-04-20 00:00:00	1998-04-20	5001	0	\N	0	0	\N	\N	0	168878	0	8331-1	3006322		
55746	5116	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	339995	0	7258-7	3001488		
76123	2334	4133840	2005-05-19	2005-05-19 00:00:00	2005-05-19	5001	0	\N	0	0	\N	\N	0	155376	0	127783003	4133840		
20739	1911	3006322	1948-03-17	1948-03-17 00:00:00	1948-03-17	5001	0	\N	0	0	\N	\N	0	127164	0	8331-1	3006322		
3532	338	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	22474	0	6095-4	3036780		
5517	525	3000963	1952-05-22	1952-05-22 00:00:00	1952-05-22	5001	0	\N	0	0	\N	\N	0	34958	0	718-7	3000963		
25362	2333	3002385	1978-05-19	1978-05-19 00:00:00	1978-05-19	5001	0	\N	0	0	\N	\N	0	155162	0	30385-9	3002385		
26371	2424	3016723	1997-06-06	1997-06-06 00:00:00	1997-06-06	5001	0	\N	0	0	\N	\N	0	160819	0	2160-0	3016723		
26453	2436	40769194	1930-03-21	1930-03-21 00:00:00	1930-03-21	5001	0	\N	0	0	\N	\N	0	161496	0	66534-9	40769194		
54847	5022	3006322	1984-04-16	1984-04-16 00:00:00	1984-04-16	5001	0	\N	0	0	\N	\N	0	333678	0	8331-1	3006322		
58932	1793	4052083	1977-01-13	1977-01-13 00:00:00	1977-01-13	5001	0	\N	0	0	\N	\N	0	120181	0	23426006	4052083		
39799	3698	3006322	1975-11-28	1975-11-28 00:00:00	1975-11-28	5001	0	\N	0	0	\N	\N	0	245853	0	8331-1	3006322		
2866	90	4024958	1991-12-05	1991-12-05 00:00:00	1991-12-05	5001	0	\N	0	0	\N	\N	0	6006	0	117015009	4024958		
38524	3566	3006322	1986-05-20	1986-05-20 00:00:00	1986-05-20	5001	0	\N	0	0	\N	\N	0	236921	0	8331-1	3006322		
28201	2594	3006322	1979-07-29	1979-07-29 00:00:00	1979-07-29	5001	0	\N	0	0	\N	\N	0	171680	0	8331-1	3006322		
49971	4547	3006322	2008-03-04	2008-03-04 00:00:00	2008-03-04	5001	0	\N	0	0	\N	\N	0	302970	0	8331-1	3006322		
50056	4550	3019406	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	303217	0	6158-0	3019406		
30342	2779	3036780	1998-06-10	1998-06-10 00:00:00	1998-06-10	5001	0	\N	0	0	\N	\N	0	184202	0	6095-4	3036780		
28936	2672	3001488	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	177027	0	7258-7	3001488		
40302	3752	46235214	1993-11-28	1993-11-28 00:00:00	1993-11-28	5001	0	\N	0	0	\N	\N	0	249300	0	76690-7	46235214		
30743	2821	3006322	1933-05-24	1933-05-24 00:00:00	1933-05-24	5001	0	\N	0	0	\N	\N	0	186858	0	8331-1	3006322		
13024	1246	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	82117	0	6206-7	3012494		
13258	1261	3015076	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	83187	0	6248-9	3015076		
3890	379	3006322	1992-10-11	1992-10-11 00:00:00	1992-10-11	5001	0	\N	0	0	\N	\N	0	25068	0	8331-1	3006322		
35851	3293	3006322	1982-03-01	1982-03-01 00:00:00	1982-03-01	5001	0	\N	0	0	\N	\N	0	218670	0	8331-1	3006322		
23486	2168	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	144458	0	6833-8	3023430		
7911	757	3006322	1986-03-23	1986-03-23 00:00:00	1986-03-23	5001	0	\N	0	0	\N	\N	0	50239	0	8331-1	3006322		
23621	2175	3015076	2012-08-21	2012-08-21 00:00:00	2012-08-21	5001	0	\N	0	0	\N	\N	0	144972	0	6248-9	3015076		
9389	887	3006322	1960-02-03	1960-02-03 00:00:00	1960-02-03	5001	0	\N	0	0	\N	\N	0	59108	0	8331-1	3006322		
38244	3527	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	234071	0	6085-5	3001247		
107330	3311	4024958	2011-09-12	2011-09-12 00:00:00	2011-09-12	5001	0	\N	0	0	\N	\N	0	219769	0	117015009	4024958		
162172	4976	4024958	1970-08-16	1970-08-16 00:00:00	1970-08-16	5001	0	\N	0	0	\N	\N	0	330976	0	117015009	4024958		
57887	5315	3006322	1973-05-23	1973-05-23 00:00:00	1973-05-23	5001	0	\N	0	0	\N	\N	0	353503	0	8331-1	3006322		
42343	3913	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	260111	0	6106-9	3014599		
40756	1264	4133840	2007-10-19	2007-10-19 00:00:00	2007-10-19	5001	0	\N	0	0	\N	\N	0	83304	0	127783003	4133840		
140	3	3006322	1959-09-17	1959-09-17 00:00:00	1959-09-17	5001	0	\N	0	0	\N	\N	0	263	0	8331-1	3006322		
43832	4051	3001488	1979-02-12	1979-02-12 00:00:00	1979-02-12	5001	0	\N	0	0	\N	\N	0	269265	0	7258-7	3001488		
122852	3786	4052083	1982-07-13	1982-07-13 00:00:00	1982-07-13	5001	0	\N	0	0	\N	\N	0	251643	0	23426006	4052083		
21552	1987	3006322	2001-10-17	2001-10-17 00:00:00	2001-10-17	5001	0	\N	0	0	\N	\N	0	132358	0	8331-1	3006322		
38456	3553	3006322	1937-11-21	1937-11-21 00:00:00	1937-11-21	5001	0	\N	0	0	\N	\N	0	235868	0	8331-1	3006322		
32945	2975	3027231	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	198641	0	6276-0	3027231		
33038	2985	40758406	2011-07-04	2011-07-04 00:00:00	2011-07-04	5001	0	\N	0	0	\N	\N	0	199210	0	55277-8	40758406		
29511	2715	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	180095	0	6085-5	3001247		
114624	3531	4024958	1999-01-27	1999-01-27 00:00:00	1999-01-27	5001	0	\N	0	0	\N	\N	0	234543	0	117015009	4024958		
1258	99	3011505	2002-11-30	2002-11-30 00:00:00	2002-11-30	5001	0	\N	0	0	\N	\N	0	6756	0	19926-5	3011505		
55662	5113	3006322	1972-08-09	1972-08-09 00:00:00	1972-08-09	5001	0	\N	0	0	\N	\N	0	339692	0	8331-1	3006322		
17832	1618	46235214	1975-01-11	1975-01-11 00:00:00	1975-01-11	5001	0	\N	0	0	\N	\N	0	108798	0	76690-7	46235214		
22122	2033	46235214	1976-03-11	1976-03-11 00:00:00	1976-03-11	5001	0	\N	0	0	\N	\N	0	135375	0	76690-7	46235214		
33525	3041	3006734	1990-03-08	1990-03-08 00:00:00	1990-03-08	5001	0	\N	0	0	\N	\N	0	202452	0	6189-5	3006734		
7809	248	4052083	1990-12-21	1990-12-21 00:00:00	1990-12-21	5001	0	\N	0	0	\N	\N	0	16688	0	23426006	4052083		
26500	2445	3006322	1933-02-22	1933-02-22 00:00:00	1933-02-22	5001	0	\N	0	0	\N	\N	0	162255	0	8331-1	3006322		
4962	480	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	32090	0	7258-7	3001488		
30661	951	4024958	2004-11-02	2004-11-02 00:00:00	2004-11-02	5001	0	\N	0	0	\N	\N	0	63212	0	117015009	4024958		
29667	2732	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	180939	0	6085-5	3001247		
49421	4506	46235214	2014-02-12	2014-02-12 00:00:00	2014-02-12	5001	0	\N	0	0	\N	\N	0	300178	0	76690-7	46235214		
27891	2566	46235214	2017-10-24	2017-10-24 00:00:00	2017-10-24	5001	0	\N	0	0	\N	\N	0	170041	0	76690-7	46235214		
39229	3625	3009542	1997-07-03	1997-07-03 00:00:00	1997-07-03	5001	0	\N	0	0	\N	\N	0	241122	0	20570-8	3009542		
19556	1783	3006322	1979-05-09	1979-05-09 00:00:00	1979-05-09	5001	0	\N	0	0	\N	\N	0	119478	0	8331-1	3006322		
151447	4641	4133840	2013-08-01	2013-08-01 00:00:00	2013-08-01	5001	0	\N	0	0	\N	\N	0	309303	0	127783003	4133840		
21398	1976	3019406	1999-06-28	1999-06-28 00:00:00	1999-06-28	5001	0	\N	0	0	\N	\N	0	131406	0	6158-0	3019406		
21473	1980	3015076	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	131768	0	6248-9	3015076		
21580	680	4024958	1999-07-21	1999-07-21 00:00:00	1999-07-21	5001	0	\N	0	0	\N	\N	0	45082	0	117015009	4024958		
42544	3930	3011505	1979-09-01	1979-09-01 00:00:00	1979-09-01	5001	0	\N	0	0	\N	\N	0	261289	0	19926-5	3011505		
70906	2173	4024958	1998-09-09	1998-09-09 00:00:00	1998-09-09	5001	0	\N	0	0	\N	\N	0	144872	0	117015009	4024958		
27681	2551	3006322	1970-06-22	1970-06-22 00:00:00	1970-06-22	5001	0	\N	0	0	\N	\N	0	168896	0	8331-1	3006322		
55747	5116	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	339995	0	6075-6	3005136		
76126	2334	4133840	1994-03-17	1994-03-17 00:00:00	1994-03-17	5001	0	\N	0	0	\N	\N	0	155291	0	127783003	4133840		
20740	1911	3011505	2005-10-17	2005-10-17 00:00:00	2005-10-17	5001	0	\N	0	0	\N	\N	0	127114	0	19926-5	3011505		
3533	338	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	22474	0	6082-2	3000876		
5518	525	3028833	1952-05-22	1952-05-22 00:00:00	1952-05-22	5001	0	\N	0	0	\N	\N	0	34958	0	42719-5	3028833		
25363	2333	3023103	1978-05-19	1978-05-19 00:00:00	1978-05-19	5001	0	\N	0	0	\N	\N	0	155162	0	2823-3	3023103		
26372	2424	3009542	1997-06-06	1997-06-06 00:00:00	1997-06-06	5001	0	\N	0	0	\N	\N	0	160819	0	20570-8	3009542		
26454	2436	40769189	1930-03-21	1930-03-21 00:00:00	1930-03-21	5001	0	\N	0	0	\N	\N	0	161496	0	66529-9	40769189		
54848	5022	3006322	2000-11-16	2000-11-16 00:00:00	2000-11-16	5001	0	\N	0	0	\N	\N	0	333682	0	8331-1	3006322		
58943	1793	4024958	1919-10-06	1919-10-06 00:00:00	1919-10-06	5001	0	\N	0	0	\N	\N	0	120248	0	117015009	4024958		
39800	3698	3006322	1966-09-03	1966-09-03 00:00:00	1966-09-03	5001	0	\N	0	0	\N	\N	0	245828	0	8331-1	3006322		
39879	3703	3005136	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	246246	0	6075-6	3005136		
38525	3566	3001247	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	236980	0	6085-5	3001247		
28202	2594	3006322	1983-07-30	1983-07-30 00:00:00	1983-07-30	5001	0	\N	0	0	\N	\N	0	171681	0	8331-1	3006322		
49972	4547	3006322	1951-09-03	1951-09-03 00:00:00	1951-09-03	5001	0	\N	0	0	\N	\N	0	302965	0	8331-1	3006322		
50057	4551	3006322	1983-04-26	1983-04-26 00:00:00	1983-04-26	5001	0	\N	0	0	\N	\N	0	303326	0	8331-1	3006322		
30343	2779	3023430	1998-06-10	1998-06-10 00:00:00	1998-06-10	5001	0	\N	0	0	\N	\N	0	184202	0	6833-8	3023430		
28937	2672	3006734	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	177027	0	6189-5	3006734		
40303	3752	3051031	1993-11-28	1993-11-28 00:00:00	1993-11-28	5001	0	\N	0	0	\N	\N	0	249300	0	46240-8	3051031		
30744	2821	3006322	1971-03-25	1971-03-25 00:00:00	1971-03-25	5001	0	\N	0	0	\N	\N	0	186862	0	8331-1	3006322		
13025	1246	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	82117	0	6082-2	3000876		
13259	1261	3027231	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	83187	0	6276-0	3027231		
3891	379	3006322	1984-09-09	1984-09-09 00:00:00	1984-09-09	5001	0	\N	0	0	\N	\N	0	25063	0	8331-1	3006322		
35852	3293	3006322	1958-05-22	1958-05-22 00:00:00	1958-05-22	5001	0	\N	0	0	\N	\N	0	218702	0	8331-1	3006322		
23487	2168	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	144458	0	6844-5	3020655		
7912	757	3006322	1961-02-06	1961-02-06 00:00:00	1961-02-06	5001	0	\N	0	0	\N	\N	0	50238	0	8331-1	3006322		
23622	2175	3021226	2012-08-21	2012-08-21 00:00:00	2012-08-21	5001	0	\N	0	0	\N	\N	0	144972	0	6246-3	3021226		
9394	890	3006322	1988-04-03	1988-04-03 00:00:00	1988-04-03	5001	0	\N	0	0	\N	\N	0	59336	0	8331-1	3006322		
38245	3527	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	234071	0	6106-9	3014599		
47373	1443	4024958	1990-08-19	1990-08-19 00:00:00	1990-08-19	5001	0	\N	0	0	\N	\N	0	96244	0	117015009	4024958		
162173	4976	4024958	1928-06-06	1928-06-06 00:00:00	1928-06-06	5001	0	\N	0	0	\N	\N	0	330966	0	117015009	4024958		
57888	5315	3006322	1934-06-03	1934-06-03 00:00:00	1934-06-03	5001	0	\N	0	0	\N	\N	0	353498	0	8331-1	3006322		
42344	3913	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	260111	0	6075-6	3005136		
40757	1264	4133840	1997-01-03	1997-01-03 00:00:00	1997-01-03	5001	0	\N	0	0	\N	\N	0	83357	0	127783003	4133840		
141	3	3051031	1949-10-21	1949-10-21 00:00:00	1949-10-21	5001	0	\N	0	0	\N	\N	0	316	0	46240-8	3051031		
43833	4051	3023430	1979-02-12	1979-02-12 00:00:00	1979-02-12	5001	0	\N	0	0	\N	\N	0	269265	0	6833-8	3023430		
122856	3787	4052083	1986-02-14	1986-02-14 00:00:00	1986-02-14	5001	0	\N	0	0	\N	\N	0	251764	0	23426006	4052083		
21553	1987	3006322	1952-09-06	1952-09-06 00:00:00	1952-09-06	5001	0	\N	0	0	\N	\N	0	132317	0	8331-1	3006322		
38457	3553	3006322	1984-08-13	1984-08-13 00:00:00	1984-08-13	5001	0	\N	0	0	\N	\N	0	235876	0	8331-1	3006322		
32946	2975	3015076	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	198641	0	6248-9	3015076		
33039	2985	40766240	2011-07-04	2011-07-04 00:00:00	2011-07-04	5001	0	\N	0	0	\N	\N	0	199210	0	63513-6	40766240		
164657	5053	4024958	1948-02-11	1948-02-11 00:00:00	1948-02-11	5001	0	\N	0	0	\N	\N	0	336049	0	117015009	4024958		
114625	3531	4024958	1976-12-18	1976-12-18 00:00:00	1976-12-18	5001	0	\N	0	0	\N	\N	0	234520	0	117015009	4024958		
1259	99	3011505	1998-10-10	1998-10-10 00:00:00	1998-10-10	5001	0	\N	0	0	\N	\N	0	6778	0	19926-5	3011505		
55663	5113	3006322	2011-07-31	2011-07-31 00:00:00	2011-07-31	5001	0	\N	0	0	\N	\N	0	339708	0	8331-1	3006322		
17833	1618	40766240	1975-01-11	1975-01-11 00:00:00	1975-01-11	5001	0	\N	0	0	\N	\N	0	108798	0	63513-6	40766240		
22125	2033	40766240	1976-03-11	1976-03-11 00:00:00	1976-03-11	5001	0	\N	0	0	\N	\N	0	135375	0	63513-6	40766240		
33526	3041	3006451	1990-03-08	1990-03-08 00:00:00	1990-03-08	5001	0	\N	0	0	\N	\N	0	202452	0	6273-7	3006451		
7820	248	4052083	1984-01-18	1984-01-18 00:00:00	1984-01-18	5001	0	\N	0	0	\N	\N	0	16724	0	23426006	4052083		
26501	2445	3006322	1931-11-14	1931-11-14 00:00:00	1931-11-14	5001	0	\N	0	0	\N	\N	0	162254	0	8331-1	3006322		
4963	480	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	32090	0	6189-5	3006734		
26669	2458	3006322	1973-04-22	1973-04-22 00:00:00	1973-04-22	5001	0	\N	0	0	\N	\N	0	162946	0	8331-1	3006322		
29668	2732	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	180939	0	6206-7	3012494		
49423	4506	40766240	2014-02-12	2014-02-12 00:00:00	2014-02-12	5001	0	\N	0	0	\N	\N	0	300178	0	63513-6	40766240		
27892	2566	40758406	2017-10-24	2017-10-24 00:00:00	2017-10-24	5001	0	\N	0	0	\N	\N	0	170041	0	55277-8	40758406		
39230	3626	3006322	1980-04-24	1980-04-24 00:00:00	1980-04-24	5001	0	\N	0	0	\N	\N	0	241130	0	8331-1	3006322		
19558	1785	3006322	1958-06-18	1958-06-18 00:00:00	1958-06-18	5001	0	\N	0	0	\N	\N	0	119579	0	8331-1	3006322		
151448	4641	4133840	2001-09-06	2001-09-06 00:00:00	2001-09-06	5001	0	\N	0	0	\N	\N	0	309350	0	127783003	4133840		
21399	1976	3001247	1995-12-25	1995-12-25 00:00:00	1995-12-25	5001	0	\N	0	0	\N	\N	0	131330	0	6085-5	3001247		
21474	1980	3001488	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	131768	0	7258-7	3001488		
113433	3505	4024958	2000-02-08	2000-02-08 00:00:00	2000-02-08	5001	0	\N	0	0	\N	\N	0	232482	0	117015009	4024958		
42545	3930	3006322	1927-10-05	1927-10-05 00:00:00	1927-10-05	5001	0	\N	0	0	\N	\N	0	261229	0	8331-1	3006322		
70922	2173	4052083	1997-02-27	1997-02-27 00:00:00	1997-02-27	5001	0	\N	0	0	\N	\N	0	144871	0	23426006	4052083		
155968	4791	4024958	1994-07-18	1994-07-18 00:00:00	1994-07-18	5001	0	\N	0	0	\N	\N	0	318766	0	117015009	4024958		
55748	5116	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	339995	0	6276-0	3027231		
76128	2334	4133840	1990-02-22	1990-02-22 00:00:00	1990-02-22	5001	0	\N	0	0	\N	\N	0	155372	0	127783003	4133840		
20741	1911	3011505	1997-09-01	1997-09-01 00:00:00	1997-09-01	5001	0	\N	0	0	\N	\N	0	127138	0	19926-5	3011505		
3534	338	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	22474	0	6246-3	3021226		
5519	525	3016723	1952-05-22	1952-05-22 00:00:00	1952-05-22	5001	0	\N	0	0	\N	\N	0	34958	0	2160-0	3016723		
25364	2333	3013682	1978-05-19	1978-05-19 00:00:00	1978-05-19	5001	0	\N	0	0	\N	\N	0	155162	0	3094-0	3013682		
26373	2424	3028833	1997-06-06	1997-06-06 00:00:00	1997-06-06	5001	0	\N	0	0	\N	\N	0	160819	0	42719-5	3028833		
26455	2436	40769179	1930-03-21	1930-03-21 00:00:00	1930-03-21	5001	0	\N	0	0	\N	\N	0	161496	0	66519-0	40769179		
54849	5022	3006322	2006-12-29	2006-12-29 00:00:00	2006-12-29	5001	0	\N	0	0	\N	\N	0	333645	0	8331-1	3006322		
58944	1793	4024958	1967-06-13	1967-06-13 00:00:00	1967-06-13	5001	0	\N	0	0	\N	\N	0	120240	0	117015009	4024958		
39801	3698	3006322	1963-12-07	1963-12-07 00:00:00	1963-12-07	5001	0	\N	0	0	\N	\N	0	245856	0	8331-1	3006322		
39880	3703	3027231	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	246246	0	6276-0	3027231		
38526	3566	3020655	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	236980	0	6844-5	3020655		
28203	2594	3006322	1978-09-22	1978-09-22 00:00:00	1978-09-22	5001	0	\N	0	0	\N	\N	0	171697	0	8331-1	3006322		
49973	4547	3006322	1999-10-05	1999-10-05 00:00:00	1999-10-05	5001	0	\N	0	0	\N	\N	0	302938	0	8331-1	3006322		
50058	4551	3006322	2005-07-18	2005-07-18 00:00:00	2005-07-18	5001	0	\N	0	0	\N	\N	0	303342	0	8331-1	3006322		
30344	2779	3020655	1998-06-10	1998-06-10 00:00:00	1998-06-10	5001	0	\N	0	0	\N	\N	0	184202	0	6844-5	3020655		
28938	2672	3001247	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	177027	0	6085-5	3001247		
40305	3752	40758406	1993-11-28	1993-11-28 00:00:00	1993-11-28	5001	0	\N	0	0	\N	\N	0	249300	0	55277-8	40758406		
30745	2821	3006322	1921-08-28	1921-08-28 00:00:00	1921-08-28	5001	0	\N	0	0	\N	\N	0	186946	0	8331-1	3006322		
13026	1246	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	82117	0	6246-3	3021226		
13260	1261	3036780	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	83187	0	6095-4	3036780		
3892	379	3006322	2001-07-08	2001-07-08 00:00:00	2001-07-08	5001	0	\N	0	0	\N	\N	0	25075	0	8331-1	3006322		
35853	3294	3049273	2017-08-20	2017-08-20 00:00:00	2017-08-20	5001	0	\N	0	0	\N	\N	0	218853	0	38265-5	3049273		
23488	2168	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	144458	0	7258-7	3001488		
7916	757	3006322	1921-08-05	1921-08-05 00:00:00	1921-08-05	5001	0	\N	0	0	\N	\N	0	50204	0	8331-1	3006322		
23623	2175	3019406	2012-08-21	2012-08-21 00:00:00	2012-08-21	5001	0	\N	0	0	\N	\N	0	144972	0	6158-0	3019406		
9395	890	3006322	1979-02-11	1979-02-11 00:00:00	1979-02-11	5001	0	\N	0	0	\N	\N	0	59303	0	8331-1	3006322		
38246	3527	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	234071	0	6206-7	3012494		
47433	1446	4024958	2002-04-01	2002-04-01 00:00:00	2002-04-01	5001	0	\N	0	0	\N	\N	0	96365	0	117015009	4024958		
173452	5322	4024958	1949-07-12	1949-07-12 00:00:00	1949-07-12	5001	0	\N	0	0	\N	\N	0	354217	0	117015009	4024958		
57889	5315	3006322	1957-07-05	1957-07-05 00:00:00	1957-07-05	5001	0	\N	0	0	\N	\N	0	353464	0	8331-1	3006322		
42345	3913	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	260111	0	6248-9	3015076		
40759	1264	4133840	2005-10-07	2005-10-07 00:00:00	2005-10-07	5001	0	\N	0	0	\N	\N	0	83286	0	127783003	4133840		
142	3	40758406	1949-10-21	1949-10-21 00:00:00	1949-10-21	5001	0	\N	0	0	\N	\N	0	316	0	55277-8	40758406		
43834	4051	3000876	1979-02-12	1979-02-12 00:00:00	1979-02-12	5001	0	\N	0	0	\N	\N	0	269265	0	6082-2	3000876		
122870	3787	4052083	1978-07-16	1978-07-16 00:00:00	1978-07-16	5001	0	\N	0	0	\N	\N	0	251733	0	23426006	4052083		
140357	4328	4024958	1990-03-01	1990-03-01 00:00:00	1990-03-01	5001	0	\N	0	0	\N	\N	0	287014	0	117015009	4024958		
38458	3553	3009542	1982-10-26	1982-10-26 00:00:00	1982-10-26	5001	0	\N	0	0	\N	\N	0	235891	0	20570-8	3009542		
32947	2975	3001488	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	198641	0	7258-7	3001488		
33041	2985	3006322	1968-12-05	1968-12-05 00:00:00	1968-12-05	5001	0	\N	0	0	\N	\N	0	199227	0	8331-1	3006322		
164677	5053	4024958	1967-03-14	1967-03-14 00:00:00	1967-03-14	5001	0	\N	0	0	\N	\N	0	335971	0	117015009	4024958		
114639	3531	4024958	1972-08-30	1972-08-30 00:00:00	1972-08-30	5001	0	\N	0	0	\N	\N	0	234519	0	117015009	4024958		
1260	99	3011505	2017-04-15	2017-04-15 00:00:00	2017-04-15	5001	0	\N	0	0	\N	\N	0	6753	0	19926-5	3011505		
55664	5113	3006322	1993-12-07	1993-12-07 00:00:00	1993-12-07	5001	0	\N	0	0	\N	\N	0	339719	0	8331-1	3006322		
17836	1618	3051031	1975-01-11	1975-01-11 00:00:00	1975-01-11	5001	0	\N	0	0	\N	\N	0	108798	0	46240-8	3051031		
22126	2033	40758406	1976-01-11	1976-01-11 00:00:00	1976-01-11	5001	0	\N	0	0	\N	\N	0	135334	0	55277-8	40758406		
33527	3041	3027231	1990-03-08	1990-03-08 00:00:00	1990-03-08	5001	0	\N	0	0	\N	\N	0	202452	0	6276-0	3027231		
7822	248	4024958	1983-12-06	1983-12-06 00:00:00	1983-12-06	5001	0	\N	0	0	\N	\N	0	16687	0	117015009	4024958		
26505	2445	3006322	1988-04-19	1988-04-19 00:00:00	1988-04-19	5001	0	\N	0	0	\N	\N	0	162189	0	8331-1	3006322		
4964	480	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	32090	0	6106-9	3014599		
26670	2458	3006322	1985-03-20	1985-03-20 00:00:00	1985-03-20	5001	0	\N	0	0	\N	\N	0	162967	0	8331-1	3006322		
29669	2732	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	180939	0	6095-4	3036780		
49424	4506	40766240	2013-07-17	2013-07-17 00:00:00	2013-07-17	5001	0	\N	0	0	\N	\N	0	300139	0	63513-6	40766240		
27893	2566	40766240	2017-10-24	2017-10-24 00:00:00	2017-10-24	5001	0	\N	0	0	\N	\N	0	170041	0	63513-6	40766240		
39232	3626	3051031	2015-10-09	2015-10-09 00:00:00	2015-10-09	5001	0	\N	0	0	\N	\N	0	241149	0	46240-8	3051031		
19559	1785	3006322	2010-08-17	2010-08-17 00:00:00	2010-08-17	5001	0	\N	0	0	\N	\N	0	119614	0	8331-1	3006322		
151450	4641	4133840	2007-07-19	2007-07-19 00:00:00	2007-07-19	5001	0	\N	0	0	\N	\N	0	309344	0	127783003	4133840		
21400	1976	3006734	1995-12-25	1995-12-25 00:00:00	1995-12-25	5001	0	\N	0	0	\N	\N	0	131330	0	6189-5	3006734		
21475	1980	3005136	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	131768	0	6075-6	3005136		
113450	3505	4024958	2003-06-06	2003-06-06 00:00:00	2003-06-06	5001	0	\N	0	0	\N	\N	0	232413	0	117015009	4024958		
42546	3930	3011505	1972-07-22	1972-07-22 00:00:00	1972-07-22	5001	0	\N	0	0	\N	\N	0	261271	0	19926-5	3011505		
174382	5343	4024958	1987-12-09	1987-12-09 00:00:00	1987-12-09	5001	0	\N	0	0	\N	\N	0	355815	0	117015009	4024958		
155971	4791	4052083	1989-10-27	1989-10-27 00:00:00	1989-10-27	5001	0	\N	0	0	\N	\N	0	318801	0	23426006	4052083		
55749	5116	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	339995	0	6158-0	3019406		
76132	2334	4133840	1992-03-05	1992-03-05 00:00:00	1992-03-05	5001	0	\N	0	0	\N	\N	0	155373	0	127783003	4133840		
20743	1911	40766240	1946-12-26	1946-12-26 00:00:00	1946-12-26	5001	0	\N	0	0	\N	\N	0	127139	0	63513-6	40766240		
3535	338	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	22474	0	6206-7	3012494		
5520	525	3024561	1952-05-22	1952-05-22 00:00:00	1952-05-22	5001	0	\N	0	0	\N	\N	0	34958	0	1751-7	3024561		
25365	2333	3020630	1978-05-19	1978-05-19 00:00:00	1978-05-19	5001	0	\N	0	0	\N	\N	0	155162	0	2885-2	3020630		
26374	2424	3007461	1997-06-06	1997-06-06 00:00:00	1997-06-06	5001	0	\N	0	0	\N	\N	0	160819	0	26515-7	3007461		
26456	2436	3006322	1920-08-03	1920-08-03 00:00:00	1920-08-03	5001	0	\N	0	0	\N	\N	0	161484	0	8331-1	3006322		
54850	5023	3006322	2010-01-20	2010-01-20 00:00:00	2010-01-20	5001	0	\N	0	0	\N	\N	0	333778	0	8331-1	3006322		
58953	1793	4052083	2002-06-16	2002-06-16 00:00:00	2002-06-16	5001	0	\N	0	0	\N	\N	0	120269	0	23426006	4052083		
39802	3698	3006322	1982-01-07	1982-01-07 00:00:00	1982-01-07	5001	0	\N	0	0	\N	\N	0	245874	0	8331-1	3006322		
39881	3703	3021226	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	246246	0	6246-3	3021226		
38527	3566	3021226	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	236980	0	6246-3	3021226		
28204	2594	3006322	1994-05-13	1994-05-13 00:00:00	1994-05-13	5001	0	\N	0	0	\N	\N	0	171714	0	8331-1	3006322		
49974	4547	3006322	1936-07-10	1936-07-10 00:00:00	1936-07-10	5001	0	\N	0	0	\N	\N	0	302857	0	8331-1	3006322		
50059	4551	3006322	1990-04-30	1990-04-30 00:00:00	1990-04-30	5001	0	\N	0	0	\N	\N	0	303304	0	8331-1	3006322		
30345	2779	3000876	1998-06-10	1998-06-10 00:00:00	1998-06-10	5001	0	\N	0	0	\N	\N	0	184202	0	6082-2	3000876		
28939	2672	3023430	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	177027	0	6833-8	3023430		
40307	3752	40766240	1993-11-28	1993-11-28 00:00:00	1993-11-28	5001	0	\N	0	0	\N	\N	0	249300	0	63513-6	40766240		
30746	2821	3006322	1960-08-05	1960-08-05 00:00:00	1960-08-05	5001	0	\N	0	0	\N	\N	0	186895	0	8331-1	3006322		
13027	1246	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	82117	0	6248-9	3015076		
13261	1261	3001488	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	83187	0	7258-7	3001488		
3893	380	3006322	1996-07-16	1996-07-16 00:00:00	1996-07-16	5001	0	\N	0	0	\N	\N	0	25118	0	8331-1	3006322		
35854	3294	3006322	1981-01-19	1981-01-19 00:00:00	1981-01-19	5001	0	\N	0	0	\N	\N	0	218856	0	8331-1	3006322		
23489	2168	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	144458	0	6095-4	3036780		
7917	757	3006322	1928-05-07	1928-05-07 00:00:00	1928-05-07	5001	0	\N	0	0	\N	\N	0	50235	0	8331-1	3006322		
23624	2175	3012494	2012-08-21	2012-08-21 00:00:00	2012-08-21	5001	0	\N	0	0	\N	\N	0	144972	0	6206-7	3012494		
9396	890	3006322	2015-05-25	2015-05-25 00:00:00	2015-05-25	5001	0	\N	0	0	\N	\N	0	59305	0	8331-1	3006322		
38247	3527	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	234071	0	6158-0	3019406		
58716	1785	4024958	1989-11-21	1989-11-21 00:00:00	1989-11-21	5001	0	\N	0	0	\N	\N	0	119612	0	117015009	4024958		
84755	2626	4024958	1968-11-03	1968-11-03 00:00:00	1968-11-03	5001	0	\N	0	0	\N	\N	0	173706	0	117015009	4024958		
57891	5315	3006322	1952-06-20	1952-06-20 00:00:00	1952-06-20	5001	0	\N	0	0	\N	\N	0	353463	0	8331-1	3006322		
42346	3913	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	260111	0	6273-7	3006451		
40764	1264	4133840	2016-05-20	2016-05-20 00:00:00	2016-05-20	5001	0	\N	0	0	\N	\N	0	83282	0	127783003	4133840		
145	3	46235214	1949-10-21	1949-10-21 00:00:00	1949-10-21	5001	0	\N	0	0	\N	\N	0	316	0	76690-7	46235214		
43835	4051	3015076	1979-02-12	1979-02-12 00:00:00	1979-02-12	5001	0	\N	0	0	\N	\N	0	269265	0	6248-9	3015076		
122879	3787	4052083	1979-09-28	1979-09-28 00:00:00	1979-09-28	5001	0	\N	0	0	\N	\N	0	251773	0	23426006	4052083		
140364	4328	4052083	2015-02-02	2015-02-02 00:00:00	2015-02-02	5001	0	\N	0	0	\N	\N	0	287019	0	23426006	4052083		
38459	3553	3000963	1982-10-26	1982-10-26 00:00:00	1982-10-26	5001	0	\N	0	0	\N	\N	0	235891	0	718-7	3000963		
32948	2976	3011505	2003-07-17	2003-07-17 00:00:00	2003-07-17	5001	0	\N	0	0	\N	\N	0	198774	0	19926-5	3011505		
33042	2985	40758406	1995-03-10	1995-03-10 00:00:00	1995-03-10	5001	0	\N	0	0	\N	\N	0	199266	0	55277-8	40758406		
164678	5053	4024958	1956-12-08	1956-12-08 00:00:00	1956-12-08	5001	0	\N	0	0	\N	\N	0	336039	0	117015009	4024958		
114640	3531	4052083	1982-09-07	1982-09-07 00:00:00	1982-09-07	5001	0	\N	0	0	\N	\N	0	234521	0	23426006	4052083		
1261	99	3006322	2008-06-28	2008-06-28 00:00:00	2008-06-28	5001	0	\N	0	0	\N	\N	0	6721	0	8331-1	3006322		
55665	5113	3006322	1989-10-17	1989-10-17 00:00:00	1989-10-17	5001	0	\N	0	0	\N	\N	0	339667	0	8331-1	3006322		
17837	1618	40758406	1975-01-11	1975-01-11 00:00:00	1975-01-11	5001	0	\N	0	0	\N	\N	0	108798	0	55277-8	40758406		
22127	2033	46235214	1976-01-11	1976-01-11 00:00:00	1976-01-11	5001	0	\N	0	0	\N	\N	0	135334	0	76690-7	46235214		
33528	3041	3006322	2001-10-30	2001-10-30 00:00:00	2001-10-30	5001	0	\N	0	0	\N	\N	0	202525	0	8331-1	3006322		
7853	249	4024958	2013-07-21	2013-07-21 00:00:00	2013-07-21	5001	0	\N	0	0	\N	\N	0	16757	0	117015009	4024958		
26508	2447	3011505	2014-10-08	2014-10-08 00:00:00	2014-10-08	5001	0	\N	0	0	\N	\N	0	162330	0	19926-5	3011505		
4965	480	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	32090	0	6833-8	3023430		
26671	2458	3006322	1972-09-11	1972-09-11 00:00:00	1972-09-11	5001	0	\N	0	0	\N	\N	0	162957	0	8331-1	3006322		
29670	2732	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	180939	0	7258-7	3001488		
49425	4506	3051031	2013-07-17	2013-07-17 00:00:00	2013-07-17	5001	0	\N	0	0	\N	\N	0	300139	0	46240-8	3051031		
27896	2566	3051031	2017-10-24	2017-10-24 00:00:00	2017-10-24	5001	0	\N	0	0	\N	\N	0	170041	0	46240-8	3051031		
39233	3626	40766240	2015-10-09	2015-10-09 00:00:00	2015-10-09	5001	0	\N	0	0	\N	\N	0	241149	0	63513-6	40766240		
19560	1785	3006322	1989-11-21	1989-11-21 00:00:00	1989-11-21	5001	0	\N	0	0	\N	\N	0	119612	0	8331-1	3006322		
151452	4641	4133840	1998-09-03	1998-09-03 00:00:00	1998-09-03	5001	0	\N	0	0	\N	\N	0	309349	0	127783003	4133840		
21401	1976	3036780	1995-12-25	1995-12-25 00:00:00	1995-12-25	5001	0	\N	0	0	\N	\N	0	131330	0	6095-4	3036780		
21476	1980	3021226	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	131768	0	6246-3	3021226		
113454	3505	4024958	1937-09-04	1937-09-04 00:00:00	1937-09-04	5001	0	\N	0	0	\N	\N	0	232393	0	117015009	4024958		
42547	3930	3011505	1964-11-28	1964-11-28 00:00:00	1964-11-28	5001	0	\N	0	0	\N	\N	0	261292	0	19926-5	3011505		
174391	5343	4024958	2015-02-19	2015-02-19 00:00:00	2015-02-19	5001	0	\N	0	0	\N	\N	0	355944	0	117015009	4024958		
155976	4791	4052083	1981-01-24	1981-01-24 00:00:00	1981-01-24	5001	0	\N	0	0	\N	\N	0	318778	0	23426006	4052083		
55750	5116	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	339995	0	6248-9	3015076		
76134	2334	4133840	2014-07-10	2014-07-10 00:00:00	2014-07-10	5001	0	\N	0	0	\N	\N	0	155321	0	127783003	4133840		
20744	1911	40758406	1946-12-26	1946-12-26 00:00:00	1946-12-26	5001	0	\N	0	0	\N	\N	0	127139	0	55277-8	40758406		
3536	338	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	22474	0	6106-9	3014599		
5521	525	3013721	1952-05-22	1952-05-22 00:00:00	1952-05-22	5001	0	\N	0	0	\N	\N	0	34958	0	1920-8	3013721		
25366	2333	3024731	1978-05-19	1978-05-19 00:00:00	1978-05-19	5001	0	\N	0	0	\N	\N	0	155162	0	30428-7	3024731		
26375	2424	3045716	1997-06-06	1997-06-06 00:00:00	1997-06-06	5001	0	\N	0	0	\N	\N	0	160819	0	33037-3	3045716		
26457	2436	3006322	1966-03-30	1966-03-30 00:00:00	1966-03-30	5001	0	\N	0	0	\N	\N	0	161518	0	8331-1	3006322		
146856	4504	4024958	2007-04-18	2007-04-18 00:00:00	2007-04-18	5001	0	\N	0	0	\N	\N	0	299948	0	117015009	4024958		
58955	1793	4052083	1990-05-28	1990-05-28 00:00:00	1990-05-28	5001	0	\N	0	0	\N	\N	0	120243	0	23426006	4052083		
39803	3699	3006322	1974-11-29	1974-11-29 00:00:00	1974-11-29	5001	0	\N	0	0	\N	\N	0	245896	0	8331-1	3006322		
39882	3703	3006451	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	246246	0	6273-7	3006451		
38528	3566	3015076	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	236980	0	6248-9	3015076		
28205	2594	3006322	1975-03-30	1975-03-30 00:00:00	1975-03-30	5001	0	\N	0	0	\N	\N	0	171688	0	8331-1	3006322		
49975	4547	3006322	1968-02-16	1968-02-16 00:00:00	1968-02-16	5001	0	\N	0	0	\N	\N	0	302935	0	8331-1	3006322		
5034	488	3006322	1995-03-29	1995-03-29 00:00:00	1995-03-29	5001	0	\N	0	0	\N	\N	0	32620	0	8331-1	3006322		
30346	2779	3012494	1998-06-10	1998-06-10 00:00:00	1998-06-10	5001	0	\N	0	0	\N	\N	0	184202	0	6206-7	3012494		
28940	2672	3020655	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	177027	0	6844-5	3020655		
40309	3752	40758406	1993-05-02	1993-05-02 00:00:00	1993-05-02	5001	0	\N	0	0	\N	\N	0	249303	0	55277-8	40758406		
30749	2821	40766240	1921-08-30	1921-08-30 00:00:00	1921-08-30	5001	0	\N	0	0	\N	\N	0	186914	0	63513-6	40766240		
13028	1246	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	82117	0	6158-0	3019406		
13262	1261	3000876	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	83187	0	6082-2	3000876		
3894	380	3006322	2008-08-24	2008-08-24 00:00:00	2008-08-24	5001	0	\N	0	0	\N	\N	0	25131	0	8331-1	3006322		
35855	3294	3006322	1997-11-18	1997-11-18 00:00:00	1997-11-18	5001	0	\N	0	0	\N	\N	0	218809	0	8331-1	3006322		
23490	2168	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	144458	0	6246-3	3021226		
7918	757	3006322	1942-02-03	1942-02-03 00:00:00	1942-02-03	5001	0	\N	0	0	\N	\N	0	50208	0	8331-1	3006322		
23625	2175	3006734	2012-08-21	2012-08-21 00:00:00	2012-08-21	5001	0	\N	0	0	\N	\N	0	144972	0	6189-5	3006734		
9397	890	3006322	1964-10-15	1964-10-15 00:00:00	1964-10-15	5001	0	\N	0	0	\N	\N	0	59317	0	8331-1	3006322		
38248	3527	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	234071	0	6844-5	3020655		
162037	4972	4024958	1974-05-25	1974-05-25 00:00:00	1974-05-25	5001	0	\N	0	0	\N	\N	0	330713	0	117015009	4024958		
84756	2626	4052083	1994-07-30	1994-07-30 00:00:00	1994-07-30	5001	0	\N	0	0	\N	\N	0	173713	0	23426006	4052083		
57892	5315	3006322	1928-07-19	1928-07-19 00:00:00	1928-07-19	5001	0	\N	0	0	\N	\N	0	353483	0	8331-1	3006322		
42347	3913	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	260111	0	6206-7	3012494		
40765	1264	4133840	2004-10-01	2004-10-01 00:00:00	2004-10-01	5001	0	\N	0	0	\N	\N	0	83347	0	127783003	4133840		
146	3	40766240	1949-10-21	1949-10-21 00:00:00	1949-10-21	5001	0	\N	0	0	\N	\N	0	316	0	63513-6	40766240		
43836	4051	3012494	1979-02-12	1979-02-12 00:00:00	1979-02-12	5001	0	\N	0	0	\N	\N	0	269265	0	6206-7	3012494		
33626	1053	4052083	1979-10-22	1979-10-22 00:00:00	1979-10-22	5001	0	\N	0	0	\N	\N	0	69047	0	23426006	4052083		
140382	4328	4052083	2016-03-07	2016-03-07 00:00:00	2016-03-07	5001	0	\N	0	0	\N	\N	0	287020	0	23426006	4052083		
38462	3553	3006322	1973-08-14	1973-08-14 00:00:00	1973-08-14	5001	0	\N	0	0	\N	\N	0	235875	0	8331-1	3006322		
32949	2976	3011505	2012-11-15	2012-11-15 00:00:00	2012-11-15	5001	0	\N	0	0	\N	\N	0	198750	0	19926-5	3011505		
33043	2985	3051031	1995-03-10	1995-03-10 00:00:00	1995-03-10	5001	0	\N	0	0	\N	\N	0	199266	0	46240-8	3051031		
2507	244	3006322	1972-11-04	1972-11-04 00:00:00	1972-11-04	5001	0	\N	0	0	\N	\N	0	16266	0	8331-1	3006322		
8952	285	4052083	1984-11-09	1984-11-09 00:00:00	1984-11-09	5001	0	\N	0	0	\N	\N	0	18918	0	23426006	4052083		
1262	99	3011505	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	6764	0	19926-5	3011505		
55666	5113	3006322	1985-04-30	1985-04-30 00:00:00	1985-04-30	5001	0	\N	0	0	\N	\N	0	339677	0	8331-1	3006322		
17839	1618	3051031	1974-11-12	1974-11-12 00:00:00	1974-11-12	5001	0	\N	0	0	\N	\N	0	108769	0	46240-8	3051031		
22129	2033	40766240	1976-01-11	1976-01-11 00:00:00	1976-01-11	5001	0	\N	0	0	\N	\N	0	135334	0	63513-6	40766240		
33529	3041	3006322	1992-11-23	1992-11-23 00:00:00	1992-11-23	5001	0	\N	0	0	\N	\N	0	202431	0	8331-1	3006322		
7856	250	4052083	1995-01-25	1995-01-25 00:00:00	1995-01-25	5001	0	\N	0	0	\N	\N	0	16804	0	23426006	4052083		
26509	2447	3006322	2011-02-27	2011-02-27 00:00:00	2011-02-27	5001	0	\N	0	0	\N	\N	0	162315	0	8331-1	3006322		
4966	480	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	32090	0	6844-5	3020655		
37949	3505	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	232469	0	6248-9	3015076		
29671	2732	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	180939	0	6189-5	3006734		
49427	4506	40758406	2013-07-17	2013-07-17 00:00:00	2013-07-17	5001	0	\N	0	0	\N	\N	0	300139	0	55277-8	40758406		
27897	2566	3051031	2015-11-04	2015-11-04 00:00:00	2015-11-04	5001	0	\N	0	0	\N	\N	0	169943	0	46240-8	3051031		
39234	3626	40758406	2015-10-09	2015-10-09 00:00:00	2015-10-09	5001	0	\N	0	0	\N	\N	0	241149	0	55277-8	40758406		
19561	1785	3006322	1962-04-09	1962-04-09 00:00:00	1962-04-09	5001	0	\N	0	0	\N	\N	0	119611	0	8331-1	3006322		
151461	4642	4052083	1962-05-08	1962-05-08 00:00:00	1962-05-08	5001	0	\N	0	0	\N	\N	0	309414	0	23426006	4052083		
21402	1976	3000876	1995-12-25	1995-12-25 00:00:00	1995-12-25	5001	0	\N	0	0	\N	\N	0	131330	0	6082-2	3000876		
21477	1980	3006734	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	131768	0	6189-5	3006734		
113467	3505	4052083	1970-02-10	1970-02-10 00:00:00	1970-02-10	5001	0	\N	0	0	\N	\N	0	232439	0	23426006	4052083		
42548	3930	3011505	1971-07-17	1971-07-17 00:00:00	1971-07-17	5001	0	\N	0	0	\N	\N	0	261305	0	19926-5	3011505		
896	72	3006322	1992-10-01	1992-10-01 00:00:00	1992-10-01	5001	0	\N	0	0	\N	\N	0	4919	0	8331-1	3006322		
155978	4791	4024958	1982-11-06	1982-11-06 00:00:00	1982-11-06	5001	0	\N	0	0	\N	\N	0	318775	0	117015009	4024958		
55751	5116	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	339995	0	6082-2	3000876		
76135	2334	4133840	1974-05-09	1974-05-09 00:00:00	1974-05-09	5001	0	\N	0	0	\N	\N	0	155334	0	127783003	4133840		
20745	1911	3051031	1946-12-26	1946-12-26 00:00:00	1946-12-26	5001	0	\N	0	0	\N	\N	0	127139	0	46240-8	3051031		
3537	338	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	22474	0	6276-0	3027231		
5522	525	21494966	1952-05-22	1952-05-22 00:00:00	1952-05-22	5001	0	\N	0	0	\N	\N	0	34958	0	80271-0	21494966		
25367	2333	3006906	1978-05-19	1978-05-19 00:00:00	1978-05-19	5001	0	\N	0	0	\N	\N	0	155162	0	17861-6	3006906		
26376	2424	3020630	1997-06-06	1997-06-06 00:00:00	1997-06-06	5001	0	\N	0	0	\N	\N	0	160819	0	2885-2	3020630		
26458	2436	3006322	1970-03-23	1970-03-23 00:00:00	1970-03-23	5001	0	\N	0	0	\N	\N	0	161587	0	8331-1	3006322		
146864	4505	4052083	1945-05-07	1945-05-07 00:00:00	1945-05-07	5001	0	\N	0	0	\N	\N	0	300046	0	23426006	4052083		
58972	1793	4052083	1932-07-29	1932-07-29 00:00:00	1932-07-29	5001	0	\N	0	0	\N	\N	0	120238	0	23426006	4052083		
39804	3699	3006322	2008-08-23	2008-08-23 00:00:00	2008-08-23	5001	0	\N	0	0	\N	\N	0	245913	0	8331-1	3006322		
39883	3703	3014599	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	246246	0	6106-9	3014599		
38529	3566	3000876	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	236980	0	6082-2	3000876		
28206	2596	3006322	2014-06-17	2014-06-17 00:00:00	2014-06-17	5001	0	\N	0	0	\N	\N	0	171809	0	8331-1	3006322		
49976	4548	3005136	2000-04-25	2000-04-25 00:00:00	2000-04-25	5001	0	\N	0	0	\N	\N	0	303041	0	6075-6	3005136		
5035	488	3006322	2016-02-02	2016-02-02 00:00:00	2016-02-02	5001	0	\N	0	0	\N	\N	0	32621	0	8331-1	3006322		
30347	2779	3001247	1998-06-10	1998-06-10 00:00:00	1998-06-10	5001	0	\N	0	0	\N	\N	0	184202	0	6085-5	3001247		
28941	2672	3006322	2008-02-29	2008-02-29 00:00:00	2008-02-29	5001	0	\N	0	0	\N	\N	0	176896	0	8331-1	3006322		
40310	3752	40766240	1993-05-02	1993-05-02 00:00:00	1993-05-02	5001	0	\N	0	0	\N	\N	0	249303	0	63513-6	40766240		
30750	2821	40758406	1921-08-30	1921-08-30 00:00:00	1921-08-30	5001	0	\N	0	0	\N	\N	0	186914	0	55277-8	40758406		
13029	1246	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	82117	0	6075-6	3005136		
13263	1261	3005136	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	83187	0	6075-6	3005136		
3895	380	3006322	1996-06-04	1996-06-04 00:00:00	1996-06-04	5001	0	\N	0	0	\N	\N	0	25117	0	8331-1	3006322		
35856	3294	3006322	2003-08-31	2003-08-31 00:00:00	2003-08-31	5001	0	\N	0	0	\N	\N	0	218858	0	8331-1	3006322		
23491	2168	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	144458	0	6075-6	3005136		
7919	757	3006322	1925-04-27	1925-04-27 00:00:00	1925-04-27	5001	0	\N	0	0	\N	\N	0	50181	0	8331-1	3006322		
23626	2175	3023430	2012-08-21	2012-08-21 00:00:00	2012-08-21	5001	0	\N	0	0	\N	\N	0	144972	0	6833-8	3023430		
9398	890	3006322	1963-09-08	1963-09-08 00:00:00	1963-09-08	5001	0	\N	0	0	\N	\N	0	59329	0	8331-1	3006322		
38249	3527	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	234071	0	6833-8	3023430		
162039	4972	4052083	1984-07-11	1984-07-11 00:00:00	1984-07-11	5001	0	\N	0	0	\N	\N	0	330668	0	23426006	4052083		
84765	2626	4052083	1981-11-07	1981-11-07 00:00:00	1981-11-07	5001	0	\N	0	0	\N	\N	0	173710	0	23426006	4052083		
57893	5315	3006322	1944-04-19	1944-04-19 00:00:00	1944-04-19	5001	0	\N	0	0	\N	\N	0	353500	0	8331-1	3006322		
42348	3913	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	260111	0	6246-3	3021226		
40768	1265	4024958	2011-08-11	2011-08-11 00:00:00	2011-08-11	5001	0	\N	0	0	\N	\N	0	83423	0	117015009	4024958		
147	3	46235214	1994-08-01	1994-08-01 00:00:00	1994-08-01	5001	0	\N	0	0	\N	\N	0	352	0	76690-7	46235214		
43837	4051	3021226	1979-02-12	1979-02-12 00:00:00	1979-02-12	5001	0	\N	0	0	\N	\N	0	269265	0	6246-3	3021226		
33635	1053	4024958	1981-02-04	1981-02-04 00:00:00	1981-02-04	5001	0	\N	0	0	\N	\N	0	69045	0	117015009	4024958		
140384	4328	4024958	1980-05-13	1980-05-13 00:00:00	1980-05-13	5001	0	\N	0	0	\N	\N	0	287013	0	117015009	4024958		
38463	3553	3006322	1952-02-07	1952-02-07 00:00:00	1952-02-07	5001	0	\N	0	0	\N	\N	0	235874	0	8331-1	3006322		
32950	2976	3011505	2015-07-23	2015-07-23 00:00:00	2015-07-23	5001	0	\N	0	0	\N	\N	0	198751	0	19926-5	3011505		
33044	2985	46235214	1995-03-10	1995-03-10 00:00:00	1995-03-10	5001	0	\N	0	0	\N	\N	0	199266	0	76690-7	46235214		
2508	244	3006322	1995-09-17	1995-09-17 00:00:00	1995-09-17	5001	0	\N	0	0	\N	\N	0	16287	0	8331-1	3006322		
8959	285	4024958	1996-04-23	1996-04-23 00:00:00	1996-04-23	5001	0	\N	0	0	\N	\N	0	19021	0	117015009	4024958		
1263	99	3049273	2015-09-20	2015-09-20 00:00:00	2015-09-20	5001	0	\N	0	0	\N	\N	0	6733	0	38265-5	3049273		
55667	5113	3006322	1979-01-17	1979-01-17 00:00:00	1979-01-17	5001	0	\N	0	0	\N	\N	0	339707	0	8331-1	3006322		
17840	1618	40758406	1974-11-12	1974-11-12 00:00:00	1974-11-12	5001	0	\N	0	0	\N	\N	0	108769	0	55277-8	40758406		
22130	2033	3051031	1976-01-11	1976-01-11 00:00:00	1976-01-11	5001	0	\N	0	0	\N	\N	0	135334	0	46240-8	3051031		
33530	3041	3006322	2014-05-09	2014-05-09 00:00:00	2014-05-09	5001	0	\N	0	0	\N	\N	0	202477	0	8331-1	3006322		
7858	250	4024958	1983-02-12	1983-02-12 00:00:00	1983-02-12	5001	0	\N	0	0	\N	\N	0	16783	0	117015009	4024958		
26510	2447	3011505	2017-10-11	2017-10-11 00:00:00	2017-10-11	5001	0	\N	0	0	\N	\N	0	162331	0	19926-5	3011505		
4967	480	3006322	2000-02-04	2000-02-04 00:00:00	2000-02-04	5001	0	\N	0	0	\N	\N	0	32029	0	8331-1	3006322		
37950	3505	3006322	2003-06-06	2003-06-06 00:00:00	2003-06-06	5001	0	\N	0	0	\N	\N	0	232413	0	8331-1	3006322		
29672	2732	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	180939	0	6833-8	3023430		
49428	4506	46235214	2013-07-17	2013-07-17 00:00:00	2013-07-17	5001	0	\N	0	0	\N	\N	0	300139	0	76690-7	46235214		
27898	2566	40758406	2015-11-04	2015-11-04 00:00:00	2015-11-04	5001	0	\N	0	0	\N	\N	0	169943	0	55277-8	40758406		
39235	3626	46235214	2015-10-09	2015-10-09 00:00:00	2015-10-09	5001	0	\N	0	0	\N	\N	0	241149	0	76690-7	46235214		
19562	1786	3006322	1959-12-18	1959-12-18 00:00:00	1959-12-18	5001	0	\N	0	0	\N	\N	0	119682	0	8331-1	3006322		
151472	4642	4024958	1960-10-16	1960-10-16 00:00:00	1960-10-16	5001	0	\N	0	0	\N	\N	0	309413	0	117015009	4024958		
21403	1976	3027231	1995-12-25	1995-12-25 00:00:00	1995-12-25	5001	0	\N	0	0	\N	\N	0	131330	0	6276-0	3027231		
21478	1980	3009542	1999-09-04	1999-09-04 00:00:00	1999-09-04	5001	0	\N	0	0	\N	\N	0	131769	0	20570-8	3009542		
125039	3859	4133840	1999-08-21	1999-08-21 00:00:00	1999-08-21	5001	0	\N	0	0	\N	\N	0	256154	0	127783003	4133840		
42549	3930	3006322	1956-06-14	1956-06-14 00:00:00	1956-06-14	5001	0	\N	0	0	\N	\N	0	261265	0	8331-1	3006322		
897	72	3006322	1994-03-12	1994-03-12 00:00:00	1994-03-12	5001	0	\N	0	0	\N	\N	0	4920	0	8331-1	3006322		
155981	4791	4052083	2016-06-04	2016-06-04 00:00:00	2016-06-04	5001	0	\N	0	0	\N	\N	0	318793	0	23426006	4052083		
55752	5116	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	339995	0	6206-7	3012494		
76137	2334	4133840	2009-06-11	2009-06-11 00:00:00	2009-06-11	5001	0	\N	0	0	\N	\N	0	155280	0	127783003	4133840		
20747	1911	46235214	1946-12-26	1946-12-26 00:00:00	1946-12-26	5001	0	\N	0	0	\N	\N	0	127139	0	76690-7	46235214		
3538	338	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	22474	0	6085-5	3001247		
5523	525	3006906	1952-05-22	1952-05-22 00:00:00	1952-05-22	5001	0	\N	0	0	\N	\N	0	34958	0	17861-6	3006906		
25368	2333	3010813	1978-05-19	1978-05-19 00:00:00	1978-05-19	5001	0	\N	0	0	\N	\N	0	155162	0	26464-8	3010813		
26377	2424	3006322	1985-02-26	1985-02-26 00:00:00	1985-02-26	5001	0	\N	0	0	\N	\N	0	160838	0	8331-1	3006322		
26459	2436	3006322	1985-04-14	1985-04-14 00:00:00	1985-04-14	5001	0	\N	0	0	\N	\N	0	161590	0	8331-1	3006322		
146889	4505	4052083	1999-07-25	1999-07-25 00:00:00	1999-07-25	5001	0	\N	0	0	\N	\N	0	300069	0	23426006	4052083		
58973	1793	4024958	1987-10-08	1987-10-08 00:00:00	1987-10-08	5001	0	\N	0	0	\N	\N	0	120182	0	117015009	4024958		
39805	3699	3006322	1985-07-16	1985-07-16 00:00:00	1985-07-16	5001	0	\N	0	0	\N	\N	0	245929	0	8331-1	3006322		
39884	3703	3001488	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	246246	0	7258-7	3001488		
38530	3566	3001488	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	236980	0	7258-7	3001488		
28207	2596	3006322	1979-08-24	1979-08-24 00:00:00	1979-08-24	5001	0	\N	0	0	\N	\N	0	171811	0	8331-1	3006322		
49977	4548	3027231	2000-04-25	2000-04-25 00:00:00	2000-04-25	5001	0	\N	0	0	\N	\N	0	303041	0	6276-0	3027231		
5036	488	3006322	1958-06-13	1958-06-13 00:00:00	1958-06-13	5001	0	\N	0	0	\N	\N	0	32615	0	8331-1	3006322		
30348	2779	3006734	1998-06-10	1998-06-10 00:00:00	1998-06-10	5001	0	\N	0	0	\N	\N	0	184202	0	6189-5	3006734		
28942	2672	3021226	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	176924	0	6246-3	3021226		
40311	3752	46235214	1993-05-02	1993-05-02 00:00:00	1993-05-02	5001	0	\N	0	0	\N	\N	0	249303	0	76690-7	46235214		
30751	2821	3051031	1921-08-30	1921-08-30 00:00:00	1921-08-30	5001	0	\N	0	0	\N	\N	0	186914	0	46240-8	3051031		
13030	1246	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	82117	0	6276-0	3027231		
13264	1261	3019406	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	83187	0	6158-0	3019406		
3901	384	3006322	2004-03-06	2004-03-06 00:00:00	2004-03-06	5001	0	\N	0	0	\N	\N	0	25347	0	8331-1	3006322		
35857	3294	3006322	1971-08-25	1971-08-25 00:00:00	1971-08-25	5001	0	\N	0	0	\N	\N	0	218854	0	8331-1	3006322		
23492	2168	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	144458	0	6082-2	3000876		
7920	758	3006322	2007-03-22	2007-03-22 00:00:00	2007-03-22	5001	0	\N	0	0	\N	\N	0	50301	0	8331-1	3006322		
23627	2175	3020655	2012-08-21	2012-08-21 00:00:00	2012-08-21	5001	0	\N	0	0	\N	\N	0	144972	0	6844-5	3020655		
9404	893	3006322	1964-08-26	1964-08-26 00:00:00	1964-08-26	5001	0	\N	0	0	\N	\N	0	59473	0	8331-1	3006322		
38250	3527	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	234071	0	6095-4	3036780		
162055	4972	4024958	1954-09-27	1954-09-27 00:00:00	1954-09-27	5001	0	\N	0	0	\N	\N	0	330666	0	117015009	4024958		
84770	2626	4024958	1975-06-13	1975-06-13 00:00:00	1975-06-13	5001	0	\N	0	0	\N	\N	0	173708	0	117015009	4024958		
57894	5315	3006322	1959-04-09	1959-04-09 00:00:00	1959-04-09	5001	0	\N	0	0	\N	\N	0	353465	0	8331-1	3006322		
42349	3913	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	260111	0	6085-5	3001247		
40789	1265	4024958	1998-06-10	1998-06-10 00:00:00	1998-06-10	5001	0	\N	0	0	\N	\N	0	83421	0	117015009	4024958		
148	3	40766240	1994-08-01	1994-08-01 00:00:00	1994-08-01	5001	0	\N	0	0	\N	\N	0	352	0	63513-6	40766240		
43838	4051	3036780	1979-02-12	1979-02-12 00:00:00	1979-02-12	5001	0	\N	0	0	\N	\N	0	269265	0	6095-4	3036780		
33650	1054	4052083	1939-08-13	1939-08-13 00:00:00	1939-08-13	5001	0	\N	0	0	\N	\N	0	69139	0	23426006	4052083		
38365	3532	3006322	1995-07-01	1995-07-01 00:00:00	1995-07-01	5001	0	\N	0	0	\N	\N	0	234597	0	8331-1	3006322		
38464	3553	3006322	1983-08-08	1983-08-08 00:00:00	1983-08-08	5001	0	\N	0	0	\N	\N	0	235892	0	8331-1	3006322		
32951	2976	3011505	2009-10-29	2009-10-29 00:00:00	2009-10-29	5001	0	\N	0	0	\N	\N	0	198733	0	19926-5	3011505		
33047	2985	40766240	1995-03-10	1995-03-10 00:00:00	1995-03-10	5001	0	\N	0	0	\N	\N	0	199266	0	63513-6	40766240		
2509	244	3006322	1934-03-29	1934-03-29 00:00:00	1934-03-29	5001	0	\N	0	0	\N	\N	0	16341	0	8331-1	3006322		
9024	286	4024958	1973-02-19	1973-02-19 00:00:00	1973-02-19	5001	0	\N	0	0	\N	\N	0	19092	0	117015009	4024958		
1264	99	3011505	1998-11-21	1998-11-21 00:00:00	1998-11-21	5001	0	\N	0	0	\N	\N	0	6747	0	19926-5	3011505		
55668	5113	3006322	2019-05-13	2019-05-13 00:00:00	2019-05-13	5001	0	\N	0	0	\N	\N	0	339679	0	8331-1	3006322		
17841	1618	46235214	1974-11-12	1974-11-12 00:00:00	1974-11-12	5001	0	\N	0	0	\N	\N	0	108769	0	76690-7	46235214		
22132	2033	3051031	2018-03-26	2018-03-26 00:00:00	2018-03-26	5001	0	\N	0	0	\N	\N	0	135340	0	46240-8	3051031		
33531	3041	3020655	1993-09-09	1993-09-09 00:00:00	1993-09-09	5001	0	\N	0	0	\N	\N	0	202546	0	6844-5	3020655		
20835	654	4024958	1990-05-16	1990-05-16 00:00:00	1990-05-16	5001	0	\N	0	0	\N	\N	0	43320	0	117015009	4024958		
26511	2447	3006322	2010-10-16	2010-10-16 00:00:00	2010-10-16	5001	0	\N	0	0	\N	\N	0	162290	0	8331-1	3006322		
4968	480	40769189	1971-05-19	1971-05-19 00:00:00	1971-05-19	5001	0	\N	0	0	\N	\N	0	31987	0	66529-9	40769189		
37951	3505	3006322	1954-03-04	1954-03-04 00:00:00	1954-03-04	5001	0	\N	0	0	\N	\N	0	232395	0	8331-1	3006322		
29673	2732	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	180939	0	6075-6	3005136		
49431	4506	3051031	2011-05-29	2011-05-29 00:00:00	2011-05-29	5001	0	\N	0	0	\N	\N	0	300226	0	46240-8	3051031		
27900	2566	46235214	2015-11-04	2015-11-04 00:00:00	2015-11-04	5001	0	\N	0	0	\N	\N	0	169943	0	76690-7	46235214		
39238	3626	3051031	2015-09-09	2015-09-09 00:00:00	2015-09-09	5001	0	\N	0	0	\N	\N	0	241126	0	46240-8	3051031		
19563	1786	3006322	1968-10-21	1968-10-21 00:00:00	1968-10-21	5001	0	\N	0	0	\N	\N	0	119731	0	8331-1	3006322		
164757	5056	4024958	1996-10-30	1996-10-30 00:00:00	1996-10-30	5001	0	\N	0	0	\N	\N	0	336143	0	117015009	4024958		
21404	1976	3005136	1995-12-25	1995-12-25 00:00:00	1995-12-25	5001	0	\N	0	0	\N	\N	0	131330	0	6075-6	3005136		
21479	1980	3000963	1999-09-04	1999-09-04 00:00:00	1999-09-04	5001	0	\N	0	0	\N	\N	0	131769	0	718-7	3000963		
125043	3859	4052083	1949-08-25	1949-08-25 00:00:00	1949-08-25	5001	0	\N	0	0	\N	\N	0	256205	0	23426006	4052083		
42550	3930	3011505	1969-12-27	1969-12-27 00:00:00	1969-12-27	5001	0	\N	0	0	\N	\N	0	261288	0	19926-5	3011505		
898	72	3006322	1965-10-10	1965-10-10 00:00:00	1965-10-10	5001	0	\N	0	0	\N	\N	0	4915	0	8331-1	3006322		
155996	4792	4024958	1988-06-06	1988-06-06 00:00:00	1988-06-06	5001	0	\N	0	0	\N	\N	0	318871	0	117015009	4024958		
55753	5116	3006322	1992-06-04	1992-06-04 00:00:00	1992-06-04	5001	0	\N	0	0	\N	\N	0	340001	0	8331-1	3006322		
76138	2334	4133840	1968-05-02	1968-05-02 00:00:00	1968-05-02	5001	0	\N	0	0	\N	\N	0	155332	0	127783003	4133840		
20748	1911	3011505	2006-10-23	2006-10-23 00:00:00	2006-10-23	5001	0	\N	0	0	\N	\N	0	127172	0	19926-5	3011505		
3539	338	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	22474	0	6833-8	3023430		
5524	525	3027970	1952-05-22	1952-05-22 00:00:00	1952-05-22	5001	0	\N	0	0	\N	\N	0	34958	0	10834-0	3027970		
25369	2333	21494966	1978-05-19	1978-05-19 00:00:00	1978-05-19	5001	0	\N	0	0	\N	\N	0	155162	0	80271-0	21494966		
26378	2424	3006322	1971-04-02	1971-04-02 00:00:00	1971-04-02	5001	0	\N	0	0	\N	\N	0	160802	0	8331-1	3006322		
26460	2437	3006322	1971-06-06	1971-06-06 00:00:00	1971-06-06	5001	0	\N	0	0	\N	\N	0	161693	0	8331-1	3006322		
146917	4505	4024958	1981-05-21	1981-05-21 00:00:00	1981-05-21	5001	0	\N	0	0	\N	\N	0	300042	0	117015009	4024958		
58974	1793	4052083	1982-04-20	1982-04-20 00:00:00	1982-04-20	5001	0	\N	0	0	\N	\N	0	120214	0	23426006	4052083		
39806	3699	3006322	2017-06-01	2017-06-01 00:00:00	2017-06-01	5001	0	\N	0	0	\N	\N	0	245948	0	8331-1	3006322		
39885	3703	3001247	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	246246	0	6085-5	3001247		
38531	3566	3036780	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	236980	0	6095-4	3036780		
28208	2596	3049273	1974-04-11	1974-04-11 00:00:00	1974-04-11	5001	0	\N	0	0	\N	\N	0	171817	0	38265-5	3049273		
49978	4548	3012494	2000-04-25	2000-04-25 00:00:00	2000-04-25	5001	0	\N	0	0	\N	\N	0	303041	0	6206-7	3012494		
5037	488	3006322	1971-04-07	1971-04-07 00:00:00	1971-04-07	5001	0	\N	0	0	\N	\N	0	32619	0	8331-1	3006322		
30349	2779	3006451	1998-06-10	1998-06-10 00:00:00	1998-06-10	5001	0	\N	0	0	\N	\N	0	184202	0	6273-7	3006451		
28943	2672	3027231	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	176924	0	6276-0	3027231		
40312	3752	3051031	1993-05-02	1993-05-02 00:00:00	1993-05-02	5001	0	\N	0	0	\N	\N	0	249303	0	46240-8	3051031		
30752	2821	46235214	1921-08-30	1921-08-30 00:00:00	1921-08-30	5001	0	\N	0	0	\N	\N	0	186914	0	76690-7	46235214		
13031	1246	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	82117	0	7258-7	3001488		
13265	1261	3021226	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	83187	0	6246-3	3021226		
3902	384	3006322	1991-04-22	1991-04-22 00:00:00	1991-04-22	5001	0	\N	0	0	\N	\N	0	25292	0	8331-1	3006322		
35858	3294	3006322	2015-04-10	2015-04-10 00:00:00	2015-04-10	5001	0	\N	0	0	\N	\N	0	218811	0	8331-1	3006322		
23493	2168	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	144458	0	6085-5	3001247		
7921	758	3006322	1985-12-03	1985-12-03 00:00:00	1985-12-03	5001	0	\N	0	0	\N	\N	0	50326	0	8331-1	3006322		
23628	2175	3001488	2012-08-21	2012-08-21 00:00:00	2012-08-21	5001	0	\N	0	0	\N	\N	0	144972	0	7258-7	3001488		
9405	893	3006322	2004-03-20	2004-03-20 00:00:00	2004-03-20	5001	0	\N	0	0	\N	\N	0	59478	0	8331-1	3006322		
38251	3527	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	234071	0	6082-2	3000876		
162066	4972	4024958	1963-12-22	1963-12-22 00:00:00	1963-12-22	5001	0	\N	0	0	\N	\N	0	330702	0	117015009	4024958		
84771	2626	4024958	2003-12-20	2003-12-20 00:00:00	2003-12-20	5001	0	\N	0	0	\N	\N	0	173716	0	117015009	4024958		
57895	5315	3006322	1962-08-05	1962-08-05 00:00:00	1962-08-05	5001	0	\N	0	0	\N	\N	0	353466	0	8331-1	3006322		
42350	3913	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	260111	0	7258-7	3001488		
40798	1266	4024958	2018-10-21	2018-10-21 00:00:00	2018-10-21	5001	0	\N	0	0	\N	\N	0	83445	0	117015009	4024958		
149	3	3051031	1994-08-01	1994-08-01 00:00:00	1994-08-01	5001	0	\N	0	0	\N	\N	0	352	0	46240-8	3051031		
43839	4051	3014599	1979-02-12	1979-02-12 00:00:00	1979-02-12	5001	0	\N	0	0	\N	\N	0	269265	0	6106-9	3014599		
44930	1379	4133840	2013-03-23	2013-03-23 00:00:00	2013-03-23	5001	0	\N	0	0	\N	\N	0	91473	0	127783003	4133840		
38366	3533	3006322	1978-02-06	1978-02-06 00:00:00	1978-02-06	5001	0	\N	0	0	\N	\N	0	234678	0	8331-1	3006322		
38465	3553	3006322	1945-03-24	1945-03-24 00:00:00	1945-03-24	5001	0	\N	0	0	\N	\N	0	235870	0	8331-1	3006322		
32952	2976	3011505	2008-10-23	2008-10-23 00:00:00	2008-10-23	5001	0	\N	0	0	\N	\N	0	198777	0	19926-5	3011505		
33048	2985	3006322	1968-06-26	1968-06-26 00:00:00	1968-06-26	5001	0	\N	0	0	\N	\N	0	199236	0	8331-1	3006322		
2510	244	3006322	1949-10-27	1949-10-27 00:00:00	1949-10-27	5001	0	\N	0	0	\N	\N	0	16295	0	8331-1	3006322		
9032	286	4052083	1982-03-16	1982-03-16 00:00:00	1982-03-16	5001	0	\N	0	0	\N	\N	0	19120	0	23426006	4052083		
1266	101	3006322	1983-04-17	1983-04-17 00:00:00	1983-04-17	5001	0	\N	0	0	\N	\N	0	6907	0	8331-1	3006322		
55669	5113	3006322	1971-01-08	1971-01-08 00:00:00	1971-01-08	5001	0	\N	0	0	\N	\N	0	339691	0	8331-1	3006322		
17843	1618	40766240	1974-11-12	1974-11-12 00:00:00	1974-11-12	5001	0	\N	0	0	\N	\N	0	108769	0	63513-6	40766240		
22134	2033	40758406	2018-03-26	2018-03-26 00:00:00	2018-03-26	5001	0	\N	0	0	\N	\N	0	135340	0	55277-8	40758406		
12800	1219	3006322	1956-01-17	1956-01-17 00:00:00	1956-01-17	5001	0	\N	0	0	\N	\N	0	80285	0	8331-1	3006322		
20846	655	4052083	1975-05-24	1975-05-24 00:00:00	1975-05-24	5001	0	\N	0	0	\N	\N	0	43347	0	23426006	4052083		
26512	2448	3000963	1991-07-09	1991-07-09 00:00:00	1991-07-09	5001	0	\N	0	0	\N	\N	0	162338	0	718-7	3000963		
4969	480	40769184	1971-05-19	1971-05-19 00:00:00	1971-05-19	5001	0	\N	0	0	\N	\N	0	31987	0	66524-0	40769184		
37956	3508	3049273	2019-05-02	2019-05-02 00:00:00	2019-05-02	5001	0	\N	0	0	\N	\N	0	232693	0	38265-5	3049273		
29674	2732	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	180939	0	6246-3	3021226		
49432	4506	40758406	2011-05-29	2011-05-29 00:00:00	2011-05-29	5001	0	\N	0	0	\N	\N	0	300226	0	55277-8	40758406		
52455	1590	4024958	1989-09-16	1989-09-16 00:00:00	1989-09-16	5001	0	\N	0	0	\N	\N	0	106671	0	117015009	4024958		
39239	3626	40766240	2015-09-09	2015-09-09 00:00:00	2015-09-09	5001	0	\N	0	0	\N	\N	0	241126	0	63513-6	40766240		
19564	1786	3006322	1988-07-29	1988-07-29 00:00:00	1988-07-29	5001	0	\N	0	0	\N	\N	0	119720	0	8331-1	3006322		
164768	5056	4052083	1991-02-26	1991-02-26 00:00:00	1991-02-26	5001	0	\N	0	0	\N	\N	0	336142	0	23426006	4052083		
21405	1976	3021226	1995-12-25	1995-12-25 00:00:00	1995-12-25	5001	0	\N	0	0	\N	\N	0	131330	0	6246-3	3021226		
21480	1980	3014599	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	131811	0	6106-9	3014599		
125044	3859	4133840	2000-08-26	2000-08-26 00:00:00	2000-08-26	5001	0	\N	0	0	\N	\N	0	256238	0	127783003	4133840		
42551	3930	3011505	1974-08-03	1974-08-03 00:00:00	1974-08-03	5001	0	\N	0	0	\N	\N	0	261272	0	19926-5	3011505		
901	74	3006322	1995-09-11	1995-09-11 00:00:00	1995-09-11	5001	0	\N	0	0	\N	\N	0	4998	0	8331-1	3006322		
156001	4792	4052083	1996-10-09	1996-10-09 00:00:00	1996-10-09	5001	0	\N	0	0	\N	\N	0	318842	0	23426006	4052083		
55754	5116	3006322	2014-08-18	2014-08-18 00:00:00	2014-08-18	5001	0	\N	0	0	\N	\N	0	339949	0	8331-1	3006322		
76141	2334	4133840	2006-05-25	2006-05-25 00:00:00	2006-05-25	5001	0	\N	0	0	\N	\N	0	155363	0	127783003	4133840		
20749	1911	3011505	2007-10-29	2007-10-29 00:00:00	2007-10-29	5001	0	\N	0	0	\N	\N	0	127122	0	19926-5	3011505		
3540	338	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	22474	0	6844-5	3020655		
5525	525	3006923	1952-05-22	1952-05-22 00:00:00	1952-05-22	5001	0	\N	0	0	\N	\N	0	34958	0	1742-6	3006923		
25370	2333	3014576	1978-05-19	1978-05-19 00:00:00	1978-05-19	5001	0	\N	0	0	\N	\N	0	155162	0	2075-0	3014576		
26379	2424	3006322	2018-07-21	2018-07-21 00:00:00	2018-07-21	5001	0	\N	0	0	\N	\N	0	160842	0	8331-1	3006322		
26461	2437	3006322	1998-10-10	1998-10-10 00:00:00	1998-10-10	5001	0	\N	0	0	\N	\N	0	161699	0	8331-1	3006322		
146920	4505	4024958	1951-11-04	1951-11-04 00:00:00	1951-11-04	5001	0	\N	0	0	\N	\N	0	299964	0	117015009	4024958		
58978	1793	4024958	2005-12-28	2005-12-28 00:00:00	2005-12-28	5001	0	\N	0	0	\N	\N	0	120247	0	117015009	4024958		
39807	3699	3000963	1999-07-08	1999-07-08 00:00:00	1999-07-08	5001	0	\N	0	0	\N	\N	0	245930	0	718-7	3000963		
39886	3703	3012494	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	246246	0	6206-7	3012494		
38532	3566	3005136	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	236980	0	6075-6	3005136		
28209	2596	3006322	1990-04-12	1990-04-12 00:00:00	1990-04-12	5001	0	\N	0	0	\N	\N	0	171777	0	8331-1	3006322		
49979	4548	3000876	2000-04-25	2000-04-25 00:00:00	2000-04-25	5001	0	\N	0	0	\N	\N	0	303041	0	6082-2	3000876		
5038	488	3006322	1970-04-02	1970-04-02 00:00:00	1970-04-02	5001	0	\N	0	0	\N	\N	0	32692	0	8331-1	3006322		
30350	2779	3027231	1998-06-10	1998-06-10 00:00:00	1998-06-10	5001	0	\N	0	0	\N	\N	0	184202	0	6276-0	3027231		
28944	2672	3006451	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	176924	0	6273-7	3006451		
40314	3752	3006322	1959-04-07	1959-04-07 00:00:00	1959-04-07	5001	0	\N	0	0	\N	\N	0	249342	0	8331-1	3006322		
30754	2821	3006322	1947-06-19	1947-06-19 00:00:00	1947-06-19	5001	0	\N	0	0	\N	\N	0	186894	0	8331-1	3006322		
13032	1246	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	82117	0	6085-5	3001247		
13266	1261	3014599	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	83187	0	6106-9	3014599		
3903	384	3006322	1991-07-03	1991-07-03 00:00:00	1991-07-03	5001	0	\N	0	0	\N	\N	0	25310	0	8331-1	3006322		
13417	1271	3006322	1979-04-06	1979-04-06 00:00:00	1979-04-06	5001	0	\N	0	0	\N	\N	0	83823	0	8331-1	3006322		
23494	2168	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	144458	0	6106-9	3014599		
7922	758	3006322	1985-05-23	1985-05-23 00:00:00	1985-05-23	5001	0	\N	0	0	\N	\N	0	50300	0	8331-1	3006322		
34906	3183	40769194	2014-02-10	2014-02-10 00:00:00	2014-02-10	5001	0	\N	0	0	\N	\N	0	211942	0	66534-9	40769194		
9406	893	3006322	1971-06-04	1971-06-04 00:00:00	1971-06-04	5001	0	\N	0	0	\N	\N	0	59489	0	8331-1	3006322		
38252	3527	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	234071	0	6075-6	3005136		
162070	4972	4052083	1957-10-10	1957-10-10 00:00:00	1957-10-10	5001	0	\N	0	0	\N	\N	0	330687	0	23426006	4052083		
9964	318	4052083	1974-03-07	1974-03-07 00:00:00	1974-03-07	5001	0	\N	0	0	\N	\N	0	21057	0	23426006	4052083		
57896	5316	3006322	2016-06-22	2016-06-22 00:00:00	2016-06-22	5001	0	\N	0	0	\N	\N	0	353566	0	8331-1	3006322		
42351	3913	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	260111	0	6189-5	3006734		
40804	1266	4052083	1994-11-16	1994-11-16 00:00:00	1994-11-16	5001	0	\N	0	0	\N	\N	0	83489	0	23426006	4052083		
150	3	40758406	1994-08-01	1994-08-01 00:00:00	1994-08-01	5001	0	\N	0	0	\N	\N	0	352	0	55277-8	40758406		
43840	4051	3006451	1979-02-12	1979-02-12 00:00:00	1979-02-12	5001	0	\N	0	0	\N	\N	0	269265	0	6273-7	3006451		
44931	1379	4133840	2000-02-19	2000-02-19 00:00:00	2000-02-19	5001	0	\N	0	0	\N	\N	0	91469	0	127783003	4133840		
38367	3533	3006322	2003-07-09	2003-07-09 00:00:00	2003-07-09	5001	0	\N	0	0	\N	\N	0	234710	0	8331-1	3006322		
38472	3556	3006322	2017-01-27	2017-01-27 00:00:00	2017-01-27	5001	0	\N	0	0	\N	\N	0	236149	0	8331-1	3006322		
32953	2976	3011505	1999-07-08	1999-07-08 00:00:00	1999-07-08	5001	0	\N	0	0	\N	\N	0	198730	0	19926-5	3011505		
33050	2985	40758406	2011-06-04	2011-06-04 00:00:00	2011-06-04	5001	0	\N	0	0	\N	\N	0	199217	0	55277-8	40758406		
2511	245	3049273	2006-07-16	2006-07-16 00:00:00	2006-07-16	5001	0	\N	0	0	\N	\N	0	16382	0	38265-5	3049273		
86621	2677	4024958	1991-02-02	1991-02-02 00:00:00	1991-02-02	5001	0	\N	0	0	\N	\N	0	177380	0	117015009	4024958		
1267	101	3006322	2003-08-25	2003-08-25 00:00:00	2003-08-25	5001	0	\N	0	0	\N	\N	0	6938	0	8331-1	3006322		
126042	3884	4024958	2014-04-18	2014-04-18 00:00:00	2014-04-18	5001	0	\N	0	0	\N	\N	0	258191	0	117015009	4024958		
17844	1618	3006322	1984-06-04	1984-06-04 00:00:00	1984-06-04	5001	0	\N	0	0	\N	\N	0	108775	0	8331-1	3006322		
22135	2033	46235214	2018-03-26	2018-03-26 00:00:00	2018-03-26	5001	0	\N	0	0	\N	\N	0	135340	0	76690-7	46235214		
12802	1219	3006322	1942-11-14	1942-11-14 00:00:00	1942-11-14	5001	0	\N	0	0	\N	\N	0	80208	0	8331-1	3006322		
20853	655	4024958	1986-09-13	1986-09-13 00:00:00	1986-09-13	5001	0	\N	0	0	\N	\N	0	43400	0	117015009	4024958		
26513	2448	3009542	1991-07-09	1991-07-09 00:00:00	1991-07-09	5001	0	\N	0	0	\N	\N	0	162338	0	20570-8	3009542		
4970	480	40769179	1971-05-19	1971-05-19 00:00:00	1971-05-19	5001	0	\N	0	0	\N	\N	0	31987	0	66519-0	40769179		
37957	3509	3006322	1946-10-25	1946-10-25 00:00:00	1946-10-25	5001	0	\N	0	0	\N	\N	0	232736	0	8331-1	3006322		
29675	2732	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	180939	0	6273-7	3006451		
49433	4506	46235214	2011-05-29	2011-05-29 00:00:00	2011-05-29	5001	0	\N	0	0	\N	\N	0	300226	0	76690-7	46235214		
52458	1590	4052083	2003-05-20	2003-05-20 00:00:00	2003-05-20	5001	0	\N	0	0	\N	\N	0	106687	0	23426006	4052083		
39240	3626	40758406	2015-09-09	2015-09-09 00:00:00	2015-09-09	5001	0	\N	0	0	\N	\N	0	241126	0	55277-8	40758406		
19565	1786	3006322	1980-09-25	1980-09-25 00:00:00	1980-09-25	5001	0	\N	0	0	\N	\N	0	119732	0	8331-1	3006322		
164772	5056	4052083	2004-02-12	2004-02-12 00:00:00	2004-02-12	5001	0	\N	0	0	\N	\N	0	336218	0	23426006	4052083		
21406	1976	3019406	1995-12-25	1995-12-25 00:00:00	1995-12-25	5001	0	\N	0	0	\N	\N	0	131330	0	6158-0	3019406		
32758	2966	3005136	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	198142	0	6075-6	3005136		
125046	3859	4133840	2005-09-24	2005-09-24 00:00:00	2005-09-24	5001	0	\N	0	0	\N	\N	0	256159	0	127783003	4133840		
42552	3930	3011505	1973-07-28	1973-07-28 00:00:00	1973-07-28	5001	0	\N	0	0	\N	\N	0	261278	0	19926-5	3011505		
902	74	3006322	1989-01-29	1989-01-29 00:00:00	1989-01-29	5001	0	\N	0	0	\N	\N	0	5012	0	8331-1	3006322		
156013	4792	4052083	2013-11-10	2013-11-10 00:00:00	2013-11-10	5001	0	\N	0	0	\N	\N	0	318874	0	23426006	4052083		
55755	5116	3006322	2006-05-21	2006-05-21 00:00:00	2006-05-21	5001	0	\N	0	0	\N	\N	0	339942	0	8331-1	3006322		
76142	2334	4024958	1939-02-15	1939-02-15 00:00:00	1939-02-15	5001	0	\N	0	0	\N	\N	0	155282	0	117015009	4024958		
20750	1911	3006322	1989-08-02	1989-08-02 00:00:00	1989-08-02	5001	0	\N	0	0	\N	\N	0	127127	0	8331-1	3006322		
3541	338	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	22474	0	7258-7	3001488		
5526	525	3010813	1952-05-22	1952-05-22 00:00:00	1952-05-22	5001	0	\N	0	0	\N	\N	0	34958	0	26464-8	3010813		
25371	2333	3006923	1978-05-19	1978-05-19 00:00:00	1978-05-19	5001	0	\N	0	0	\N	\N	0	155162	0	1742-6	3006923		
26380	2424	3006322	2014-11-30	2014-11-30 00:00:00	2014-11-30	5001	0	\N	0	0	\N	\N	0	160805	0	8331-1	3006322		
26462	2437	3006322	2008-11-14	2008-11-14 00:00:00	2008-11-14	5001	0	\N	0	0	\N	\N	0	161717	0	8331-1	3006322		
146927	4505	4052083	1992-12-12	1992-12-12 00:00:00	1992-12-12	5001	0	\N	0	0	\N	\N	0	300116	0	23426006	4052083		
46068	1407	4052083	1999-09-26	1999-09-26 00:00:00	1999-09-26	5001	0	\N	0	0	\N	\N	0	93457	0	23426006	4052083		
39808	3699	3009542	1999-07-08	1999-07-08 00:00:00	1999-07-08	5001	0	\N	0	0	\N	\N	0	245930	0	20570-8	3009542		
39887	3703	3006322	2010-01-01	2010-01-01 00:00:00	2010-01-01	5001	0	\N	0	0	\N	\N	0	246297	0	8331-1	3006322		
38533	3566	3014599	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	236980	0	6106-9	3014599		
28210	2597	3006322	1983-09-27	1983-09-27 00:00:00	1983-09-27	5001	0	\N	0	0	\N	\N	0	171826	0	8331-1	3006322		
49980	4548	3019406	2000-04-25	2000-04-25 00:00:00	2000-04-25	5001	0	\N	0	0	\N	\N	0	303041	0	6158-0	3019406		
5039	488	3006322	1995-09-08	1995-09-08 00:00:00	1995-09-08	5001	0	\N	0	0	\N	\N	0	32625	0	8331-1	3006322		
30351	2779	3019406	1998-06-10	1998-06-10 00:00:00	1998-06-10	5001	0	\N	0	0	\N	\N	0	184202	0	6158-0	3019406		
28945	2672	3000876	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	176924	0	6082-2	3000876		
40315	3752	3006322	1966-03-14	1966-03-14 00:00:00	1966-03-14	5001	0	\N	0	0	\N	\N	0	249296	0	8331-1	3006322		
30757	2821	3051031	1921-07-01	1921-07-01 00:00:00	1921-07-01	5001	0	\N	0	0	\N	\N	0	186945	0	46240-8	3051031		
13033	1246	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	82117	0	6844-5	3020655		
13267	1261	3001247	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	83187	0	6085-5	3001247		
3904	384	3006322	1975-03-07	1975-03-07 00:00:00	1975-03-07	5001	0	\N	0	0	\N	\N	0	25337	0	8331-1	3006322		
13418	1271	3006322	2013-05-05	2013-05-05 00:00:00	2013-05-05	5001	0	\N	0	0	\N	\N	0	83841	0	8331-1	3006322		
23495	2168	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	144458	0	6158-0	3019406		
7923	759	3006322	1973-03-23	1973-03-23 00:00:00	1973-03-23	5001	0	\N	0	0	\N	\N	0	50381	0	8331-1	3006322		
34907	3183	3006322	1982-07-06	1982-07-06 00:00:00	1982-07-06	5001	0	\N	0	0	\N	\N	0	211930	0	8331-1	3006322		
52752	4847	3006322	2000-09-02	2000-09-02 00:00:00	2000-09-02	5001	0	\N	0	0	\N	\N	0	322443	0	8331-1	3006322		
38253	3527	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	234071	0	6246-3	3021226		
15821	495	4024958	1978-03-13	1978-03-13 00:00:00	1978-03-13	5001	0	\N	0	0	\N	\N	0	33078	0	117015009	4024958		
9968	318	4024958	1960-06-27	1960-06-27 00:00:00	1960-06-27	5001	0	\N	0	0	\N	\N	0	21092	0	117015009	4024958		
57897	5316	3006322	1987-09-13	1987-09-13 00:00:00	1987-09-13	5001	0	\N	0	0	\N	\N	0	353577	0	8331-1	3006322		
42352	3913	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	260111	0	6082-2	3000876		
40810	1266	4052083	2017-12-11	2017-12-11 00:00:00	2017-12-11	5001	0	\N	0	0	\N	\N	0	83435	0	23426006	4052083		
153	3	46235214	1994-07-02	1994-07-02 00:00:00	1994-07-02	5001	0	\N	0	0	\N	\N	0	295	0	76690-7	46235214		
43841	4052	40769194	1977-11-18	1977-11-18 00:00:00	1977-11-18	5001	0	\N	0	0	\N	\N	0	269372	0	66534-9	40769194		
44932	1379	4133840	2014-03-29	2014-03-29 00:00:00	2014-03-29	5001	0	\N	0	0	\N	\N	0	91453	0	127783003	4133840		
38374	3536	3006322	1996-06-23	1996-06-23 00:00:00	1996-06-23	5001	0	\N	0	0	\N	\N	0	234815	0	8331-1	3006322		
38474	3558	3011505	2018-05-19	2018-05-19 00:00:00	2018-05-19	5001	0	\N	0	0	\N	\N	0	236214	0	19926-5	3011505		
32954	2976	3006322	1981-04-05	1981-04-05 00:00:00	1981-04-05	5001	0	\N	0	0	\N	\N	0	198705	0	8331-1	3006322		
33051	2985	3051031	2011-06-04	2011-06-04 00:00:00	2011-06-04	5001	0	\N	0	0	\N	\N	0	199217	0	46240-8	3051031		
2512	245	3006322	2005-06-16	2005-06-16 00:00:00	2005-06-16	5001	0	\N	0	0	\N	\N	0	16428	0	8331-1	3006322		
132631	4085	4024958	1997-09-04	1997-09-04 00:00:00	1997-09-04	5001	0	\N	0	0	\N	\N	0	271541	0	117015009	4024958		
1268	101	3006322	1940-11-22	1940-11-22 00:00:00	1940-11-22	5001	0	\N	0	0	\N	\N	0	6834	0	8331-1	3006322		
30512	2792	3006322	1968-12-28	1968-12-28 00:00:00	1968-12-28	5001	0	\N	0	0	\N	\N	0	184990	0	8331-1	3006322		
17845	1618	46235214	1974-08-14	1974-08-14 00:00:00	1974-08-14	5001	0	\N	0	0	\N	\N	0	108768	0	76690-7	46235214		
22137	2033	40766240	2018-03-26	2018-03-26 00:00:00	2018-03-26	5001	0	\N	0	0	\N	\N	0	135340	0	63513-6	40766240		
12803	1219	3006322	1951-05-14	1951-05-14 00:00:00	1951-05-14	5001	0	\N	0	0	\N	\N	0	80234	0	8331-1	3006322		
20855	655	4024958	1964-01-21	1964-01-21 00:00:00	1964-01-21	5001	0	\N	0	0	\N	\N	0	43398	0	117015009	4024958		
26514	2448	3006322	1964-08-16	1964-08-16 00:00:00	1964-08-16	5001	0	\N	0	0	\N	\N	0	162388	0	8331-1	3006322		
4971	480	40769194	1971-05-19	1971-05-19 00:00:00	1971-05-19	5001	0	\N	0	0	\N	\N	0	31987	0	66534-9	40769194		
37958	3509	3006322	1956-06-27	1956-06-27 00:00:00	1956-06-27	5001	0	\N	0	0	\N	\N	0	232735	0	8331-1	3006322		
29676	2732	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	180939	0	6248-9	3015076		
49435	4506	40766240	2011-05-29	2011-05-29 00:00:00	2011-05-29	5001	0	\N	0	0	\N	\N	0	300226	0	63513-6	40766240		
52463	1590	4024958	1989-06-07	1989-06-07 00:00:00	1989-06-07	5001	0	\N	0	0	\N	\N	0	106716	0	117015009	4024958		
39241	3626	46235214	2015-09-09	2015-09-09 00:00:00	2015-09-09	5001	0	\N	0	0	\N	\N	0	241126	0	76690-7	46235214		
19566	1786	3006322	1947-03-10	1947-03-10 00:00:00	1947-03-10	5001	0	\N	0	0	\N	\N	0	119681	0	8331-1	3006322		
164793	5058	4052083	1995-04-27	1995-04-27 00:00:00	1995-04-27	5001	0	\N	0	0	\N	\N	0	336285	0	23426006	4052083		
21407	1976	3015076	1995-12-25	1995-12-25 00:00:00	1995-12-25	5001	0	\N	0	0	\N	\N	0	131330	0	6248-9	3015076		
32759	2966	3036780	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	198142	0	6095-4	3036780		
125047	3859	4133840	1996-08-03	1996-08-03 00:00:00	1996-08-03	5001	0	\N	0	0	\N	\N	0	256172	0	127783003	4133840		
42554	3930	3011505	1975-08-09	1975-08-09 00:00:00	1975-08-09	5001	0	\N	0	0	\N	\N	0	261255	0	19926-5	3011505		
903	74	3006322	1979-04-16	1979-04-16 00:00:00	1979-04-16	5001	0	\N	0	0	\N	\N	0	5009	0	8331-1	3006322		
156018	4792	4024958	1978-11-17	1978-11-17 00:00:00	1978-11-17	5001	0	\N	0	0	\N	\N	0	318840	0	117015009	4024958		
55756	5116	3006322	2000-01-08	2000-01-08 00:00:00	2000-01-08	5001	0	\N	0	0	\N	\N	0	339973	0	8331-1	3006322		
122094	3767	4024958	1998-06-20	1998-06-20 00:00:00	1998-06-20	5001	0	\N	0	0	\N	\N	0	250338	0	117015009	4024958		
20751	1911	3006322	1996-06-20	1996-06-20 00:00:00	1996-06-20	5001	0	\N	0	0	\N	\N	0	127169	0	8331-1	3006322		
3542	338	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	22474	0	6075-6	3005136		
5527	525	3035995	1952-05-22	1952-05-22 00:00:00	1952-05-22	5001	0	\N	0	0	\N	\N	0	34958	0	6768-6	3035995		
25372	2333	3035995	1978-05-19	1978-05-19 00:00:00	1978-05-19	5001	0	\N	0	0	\N	\N	0	155162	0	6768-6	3035995		
26381	2425	3006322	1961-10-13	1961-10-13 00:00:00	1961-10-13	5001	0	\N	0	0	\N	\N	0	160939	0	8331-1	3006322		
26463	2437	3006322	2003-09-26	2003-09-26 00:00:00	2003-09-26	5001	0	\N	0	0	\N	\N	0	161716	0	8331-1	3006322		
117988	3630	4052083	1964-06-25	1964-06-25 00:00:00	1964-06-25	5001	0	\N	0	0	\N	\N	0	241571	0	23426006	4052083		
10212	978	3006322	2014-04-04	2014-04-04 00:00:00	2014-04-04	5001	0	\N	0	0	\N	\N	0	65144	0	8331-1	3006322		
39809	3699	3006322	2010-01-25	2010-01-25 00:00:00	2010-01-25	5001	0	\N	0	0	\N	\N	0	245898	0	8331-1	3006322		
39888	3703	3006322	1999-01-17	1999-01-17 00:00:00	1999-01-17	5001	0	\N	0	0	\N	\N	0	246229	0	8331-1	3006322		
38534	3566	3023430	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	236980	0	6833-8	3023430		
28211	2597	3006322	2003-09-10	2003-09-10 00:00:00	2003-09-10	5001	0	\N	0	0	\N	\N	0	171834	0	8331-1	3006322		
49981	4548	3015076	2000-04-25	2000-04-25 00:00:00	2000-04-25	5001	0	\N	0	0	\N	\N	0	303041	0	6248-9	3015076		
5040	488	3006322	1962-07-31	1962-07-31 00:00:00	1962-07-31	5001	0	\N	0	0	\N	\N	0	32681	0	8331-1	3006322		
30352	2779	3049273	1976-11-13	1976-11-13 00:00:00	1976-11-13	5001	0	\N	0	0	\N	\N	0	184098	0	38265-5	3049273		
28946	2672	3036780	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	176924	0	6095-4	3036780		
40316	3752	3006322	1989-01-28	1989-01-28 00:00:00	1989-01-28	5001	0	\N	0	0	\N	\N	0	249343	0	8331-1	3006322		
30758	2821	40758406	1921-07-01	1921-07-01 00:00:00	1921-07-01	5001	0	\N	0	0	\N	\N	0	186945	0	55277-8	40758406		
13034	1246	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	82117	0	6095-4	3036780		
13268	1261	3020655	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	83187	0	6844-5	3020655		
3905	384	3006322	1971-05-14	1971-05-14 00:00:00	1971-05-14	5001	0	\N	0	0	\N	\N	0	25308	0	8331-1	3006322		
13419	1272	3000876	1992-09-18	1992-09-18 00:00:00	1992-09-18	5001	0	\N	0	0	\N	\N	0	83866	0	6082-2	3000876		
23496	2168	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	144458	0	6273-7	3006451		
7924	759	3006322	1959-01-03	1959-01-03 00:00:00	1959-01-03	5001	0	\N	0	0	\N	\N	0	50434	0	8331-1	3006322		
34908	3183	3020655	1981-08-20	1981-08-20 00:00:00	1981-08-20	5001	0	\N	0	0	\N	\N	0	211895	0	6844-5	3020655		
52753	4847	3011505	2006-02-22	2006-02-22 00:00:00	2006-02-22	5001	0	\N	0	0	\N	\N	0	322419	0	19926-5	3011505		
38254	3527	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	234071	0	6248-9	3015076		
73369	2256	4024958	1993-05-12	1993-05-12 00:00:00	1993-05-12	5001	0	\N	0	0	\N	\N	0	149917	0	117015009	4024958		
10003	320	4052083	1961-02-23	1961-02-23 00:00:00	1961-02-23	5001	0	\N	0	0	\N	\N	0	21228	0	23426006	4052083		
57898	5316	3006322	1966-01-25	1966-01-25 00:00:00	1966-01-25	5001	0	\N	0	0	\N	\N	0	353576	0	8331-1	3006322		
42353	3913	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	260111	0	6095-4	3036780		
40811	1266	4024958	1980-07-31	1980-07-31 00:00:00	1980-07-31	5001	0	\N	0	0	\N	\N	0	83485	0	117015009	4024958		
154	3	40766240	1994-07-02	1994-07-02 00:00:00	1994-07-02	5001	0	\N	0	0	\N	\N	0	295	0	63513-6	40766240		
43842	4052	40769189	1977-11-18	1977-11-18 00:00:00	1977-11-18	5001	0	\N	0	0	\N	\N	0	269372	0	66529-9	40769189		
44933	1379	4133840	2001-02-10	2001-02-10 00:00:00	2001-02-10	5001	0	\N	0	0	\N	\N	0	91470	0	127783003	4133840		
38375	3536	3006322	1999-08-24	1999-08-24 00:00:00	1999-08-24	5001	0	\N	0	0	\N	\N	0	234816	0	8331-1	3006322		
38475	3558	3006322	2010-02-06	2010-02-06 00:00:00	2010-02-06	5001	0	\N	0	0	\N	\N	0	236220	0	8331-1	3006322		
32955	2976	3006322	1957-01-31	1957-01-31 00:00:00	1957-01-31	5001	0	\N	0	0	\N	\N	0	198745	0	8331-1	3006322		
33053	2985	46235214	2011-06-04	2011-06-04 00:00:00	2011-06-04	5001	0	\N	0	0	\N	\N	0	199217	0	76690-7	46235214		
2513	245	3006322	1966-02-10	1966-02-10 00:00:00	1966-02-10	5001	0	\N	0	0	\N	\N	0	16437	0	8331-1	3006322		
143925	4423	4024958	1995-08-09	1995-08-09 00:00:00	1995-08-09	5001	0	\N	0	0	\N	\N	0	294087	0	117015009	4024958		
1269	101	3049273	2011-05-08	2011-05-08 00:00:00	2011-05-08	5001	0	\N	0	0	\N	\N	0	6943	0	38265-5	3049273		
30513	2792	3006322	2011-02-26	2011-02-26 00:00:00	2011-02-26	5001	0	\N	0	0	\N	\N	0	184992	0	8331-1	3006322		
17847	1618	40766240	1974-08-14	1974-08-14 00:00:00	1974-08-14	5001	0	\N	0	0	\N	\N	0	108768	0	63513-6	40766240		
22139	2033	40758406	2017-08-28	2017-08-28 00:00:00	2017-08-28	5001	0	\N	0	0	\N	\N	0	135355	0	55277-8	40758406		
12819	1222	3006322	2007-07-22	2007-07-22 00:00:00	2007-07-22	5001	0	\N	0	0	\N	\N	0	80436	0	8331-1	3006322		
20864	655	4052083	1979-04-10	1979-04-10 00:00:00	1979-04-10	5001	0	\N	0	0	\N	\N	0	43348	0	23426006	4052083		
26515	2448	3006322	1978-05-31	1978-05-31 00:00:00	1978-05-31	5001	0	\N	0	0	\N	\N	0	162337	0	8331-1	3006322		
4972	480	3006322	1980-02-29	1980-02-29 00:00:00	1980-02-29	5001	0	\N	0	0	\N	\N	0	32070	0	8331-1	3006322		
37959	3509	3006322	1987-11-10	1987-11-10 00:00:00	1987-11-10	5001	0	\N	0	0	\N	\N	0	232704	0	8331-1	3006322		
29677	2732	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	180939	0	6106-9	3014599		
49436	4506	3006322	1980-05-08	1980-05-08 00:00:00	1980-05-08	5001	0	\N	0	0	\N	\N	0	300236	0	8331-1	3006322		
90716	2801	4024958	1939-05-11	1939-05-11 00:00:00	1939-05-11	5001	0	\N	0	0	\N	\N	0	185592	0	117015009	4024958		
39244	3626	3051031	2015-08-10	2015-08-10 00:00:00	2015-08-10	5001	0	\N	0	0	\N	\N	0	241141	0	46240-8	3051031		
19567	1786	3006322	1979-11-08	1979-11-08 00:00:00	1979-11-08	5001	0	\N	0	0	\N	\N	0	119694	0	8331-1	3006322		
48814	4466	3006322	1991-05-31	1991-05-31 00:00:00	1991-05-31	5001	0	\N	0	0	\N	\N	0	297146	0	8331-1	3006322		
21408	1976	3023430	1995-12-25	1995-12-25 00:00:00	1995-12-25	5001	0	\N	0	0	\N	\N	0	131330	0	6833-8	3023430		
32760	2966	3023430	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	198142	0	6833-8	3023430		
125050	3859	4133840	2013-11-09	2013-11-09 00:00:00	2013-11-09	5001	0	\N	0	0	\N	\N	0	256246	0	127783003	4133840		
42555	3930	3011505	1977-08-20	1977-08-20 00:00:00	1977-08-20	5001	0	\N	0	0	\N	\N	0	261256	0	19926-5	3011505		
904	74	3006322	1981-03-19	1981-03-19 00:00:00	1981-03-19	5001	0	\N	0	0	\N	\N	0	5011	0	8331-1	3006322		
156022	4792	4052083	1962-10-30	1962-10-30 00:00:00	1962-10-30	5001	0	\N	0	0	\N	\N	0	318876	0	23426006	4052083		
55757	5117	3006322	1967-09-23	1967-09-23 00:00:00	1967-09-23	5001	0	\N	0	0	\N	\N	0	340127	0	8331-1	3006322		
11298	357	4024958	1983-11-16	1983-11-16 00:00:00	1983-11-16	5001	0	\N	0	0	\N	\N	0	23703	0	117015009	4024958		
20752	1911	3006322	1960-01-13	1960-01-13 00:00:00	1960-01-13	5001	0	\N	0	0	\N	\N	0	127166	0	8331-1	3006322		
3543	338	3006322	1979-03-05	1979-03-05 00:00:00	1979-03-05	5001	0	\N	0	0	\N	\N	0	22566	0	8331-1	3006322		
5528	525	3026361	1952-05-22	1952-05-22 00:00:00	1952-05-22	5001	0	\N	0	0	\N	\N	0	34958	0	26453-1	3026361		
25375	2333	3006322	1926-12-11	1926-12-11 00:00:00	1926-12-11	5001	0	\N	0	0	\N	\N	0	155222	0	8331-1	3006322		
26382	2425	3006322	1977-04-12	1977-04-12 00:00:00	1977-04-12	5001	0	\N	0	0	\N	\N	0	160943	0	8331-1	3006322		
26464	2437	3006322	1967-10-09	1967-10-09 00:00:00	1967-10-09	5001	0	\N	0	0	\N	\N	0	161692	0	8331-1	3006322		
117995	3630	4024958	1963-09-30	1963-09-30 00:00:00	1963-09-30	5001	0	\N	0	0	\N	\N	0	241515	0	117015009	4024958		
10213	978	3006322	1981-05-29	1981-05-29 00:00:00	1981-05-29	5001	0	\N	0	0	\N	\N	0	65175	0	8331-1	3006322		
39810	3700	3006322	1988-11-20	1988-11-20 00:00:00	1988-11-20	5001	0	\N	0	0	\N	\N	0	245995	0	8331-1	3006322		
39890	3707	3006322	1980-10-03	1980-10-03 00:00:00	1980-10-03	5001	0	\N	0	0	\N	\N	0	246435	0	8331-1	3006322		
38535	3566	3006734	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	236980	0	6189-5	3006734		
28212	2597	3006322	1983-12-13	1983-12-13 00:00:00	1983-12-13	5001	0	\N	0	0	\N	\N	0	171827	0	8331-1	3006322		
49982	4548	3021226	2000-04-25	2000-04-25 00:00:00	2000-04-25	5001	0	\N	0	0	\N	\N	0	303041	0	6246-3	3021226		
5041	488	3006322	1958-10-24	1958-10-24 00:00:00	1958-10-24	5001	0	\N	0	0	\N	\N	0	32671	0	8331-1	3006322		
30353	2779	3036780	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	184124	0	6095-4	3036780		
28947	2672	3019406	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	176924	0	6158-0	3019406		
40317	3752	3051031	1994-02-26	1994-02-26 00:00:00	1994-02-26	5001	0	\N	0	0	\N	\N	0	249353	0	46240-8	3051031		
30759	2821	40766240	1921-07-01	1921-07-01 00:00:00	1921-07-01	5001	0	\N	0	0	\N	\N	0	186945	0	63513-6	40766240		
13035	1246	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	82117	0	6833-8	3023430		
13269	1261	3006451	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	83187	0	6273-7	3006451		
3906	384	3006322	1965-10-03	1965-10-03 00:00:00	1965-10-03	5001	0	\N	0	0	\N	\N	0	25291	0	8331-1	3006322		
13420	1272	3006451	1992-09-18	1992-09-18 00:00:00	1992-09-18	5001	0	\N	0	0	\N	\N	0	83866	0	6273-7	3006451		
23497	2168	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	144458	0	6276-0	3027231		
7925	759	3006322	1980-08-22	1980-08-22 00:00:00	1980-08-22	5001	0	\N	0	0	\N	\N	0	50445	0	8331-1	3006322		
34909	3183	3027231	1981-08-20	1981-08-20 00:00:00	1981-08-20	5001	0	\N	0	0	\N	\N	0	211895	0	6276-0	3027231		
52754	4847	3011505	2002-01-30	2002-01-30 00:00:00	2002-01-30	5001	0	\N	0	0	\N	\N	0	322450	0	19926-5	3011505		
38255	3527	3006322	1978-03-26	1978-03-26 00:00:00	1978-03-26	5001	0	\N	0	0	\N	\N	0	234052	0	8331-1	3006322		
73377	2256	4024958	1989-05-17	1989-05-17 00:00:00	1989-05-17	5001	0	\N	0	0	\N	\N	0	149961	0	117015009	4024958		
10004	320	4133840	2012-02-19	2012-02-19 00:00:00	2012-02-19	5001	0	\N	0	0	\N	\N	0	21186	0	127783003	4133840		
57899	5316	3006322	1963-06-28	1963-06-28 00:00:00	1963-06-28	5001	0	\N	0	0	\N	\N	0	353575	0	8331-1	3006322		
42354	3913	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	260111	0	6844-5	3020655		
52090	1576	4024958	2003-04-15	2003-04-15 00:00:00	2003-04-15	5001	0	\N	0	0	\N	\N	0	105819	0	117015009	4024958		
157	3	3051031	1994-07-02	1994-07-02 00:00:00	1994-07-02	5001	0	\N	0	0	\N	\N	0	295	0	46240-8	3051031		
43843	4052	40769179	1977-11-18	1977-11-18 00:00:00	1977-11-18	5001	0	\N	0	0	\N	\N	0	269372	0	66519-0	40769179		
44934	1379	4052083	2000-07-23	2000-07-23 00:00:00	2000-07-23	5001	0	\N	0	0	\N	\N	0	91495	0	23426006	4052083		
38376	3536	3006322	2009-04-17	2009-04-17 00:00:00	2009-04-17	5001	0	\N	0	0	\N	\N	0	234855	0	8331-1	3006322		
38476	3558	3006322	1965-05-27	1965-05-27 00:00:00	1965-05-27	5001	0	\N	0	0	\N	\N	0	236226	0	8331-1	3006322		
32956	2976	3011505	1995-06-29	1995-06-29 00:00:00	1995-06-29	5001	0	\N	0	0	\N	\N	0	198773	0	19926-5	3011505		
33054	2985	40766240	2011-06-04	2011-06-04 00:00:00	2011-06-04	5001	0	\N	0	0	\N	\N	0	199217	0	63513-6	40766240		
2514	245	3006322	1971-04-02	1971-04-02 00:00:00	1971-04-02	5001	0	\N	0	0	\N	\N	0	16477	0	8331-1	3006322		
143931	4423	4052083	1998-09-22	1998-09-22 00:00:00	1998-09-22	5001	0	\N	0	0	\N	\N	0	294109	0	23426006	4052083		
1270	101	3049273	2017-07-10	2017-07-10 00:00:00	2017-07-10	5001	0	\N	0	0	\N	\N	0	6946	0	38265-5	3049273		
30514	2792	3006322	1963-10-16	1963-10-16 00:00:00	1963-10-16	5001	0	\N	0	0	\N	\N	0	185025	0	8331-1	3006322		
17848	1618	3051031	1974-08-14	1974-08-14 00:00:00	1974-08-14	5001	0	\N	0	0	\N	\N	0	108768	0	46240-8	3051031		
22140	2033	46235214	2017-08-28	2017-08-28 00:00:00	2017-08-28	5001	0	\N	0	0	\N	\N	0	135355	0	76690-7	46235214		
12820	1222	3006322	2004-01-01	2004-01-01 00:00:00	2004-01-01	5001	0	\N	0	0	\N	\N	0	80435	0	8331-1	3006322		
20889	656	4024958	1972-10-29	1972-10-29 00:00:00	1972-10-29	5001	0	\N	0	0	\N	\N	0	43461	0	117015009	4024958		
26516	2448	3006322	1996-02-06	1996-02-06 00:00:00	1996-02-06	5001	0	\N	0	0	\N	\N	0	162365	0	8331-1	3006322		
4973	480	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	32071	0	6075-6	3005136		
37960	3509	3049273	2011-03-26	2011-03-26 00:00:00	2011-03-26	5001	0	\N	0	0	\N	\N	0	232794	0	38265-5	3049273		
29678	2732	3006322	2014-01-30	2014-01-30 00:00:00	2014-01-30	5001	0	\N	0	0	\N	\N	0	180880	0	8331-1	3006322		
49437	4506	3051031	2012-05-23	2012-05-23 00:00:00	2012-05-23	5001	0	\N	0	0	\N	\N	0	300171	0	46240-8	3051031		
90734	2801	4052083	1931-06-16	1931-06-16 00:00:00	1931-06-16	5001	0	\N	0	0	\N	\N	0	185640	0	23426006	4052083		
39245	3626	46235214	2015-08-10	2015-08-10 00:00:00	2015-08-10	5001	0	\N	0	0	\N	\N	0	241141	0	76690-7	46235214		
19568	1786	3006322	2014-03-22	2014-03-22 00:00:00	2014-03-22	5001	0	\N	0	0	\N	\N	0	119734	0	8331-1	3006322		
48815	4466	3006322	2005-03-27	2005-03-27 00:00:00	2005-03-27	5001	0	\N	0	0	\N	\N	0	297116	0	8331-1	3006322		
21409	1976	3020655	1995-12-25	1995-12-25 00:00:00	1995-12-25	5001	0	\N	0	0	\N	\N	0	131330	0	6844-5	3020655		
32776	2969	3006322	1987-08-01	1987-08-01 00:00:00	1987-08-01	5001	0	\N	0	0	\N	\N	0	198203	0	8331-1	3006322		
125052	3859	4133840	1998-08-15	1998-08-15 00:00:00	1998-08-15	5001	0	\N	0	0	\N	\N	0	256237	0	127783003	4133840		
42556	3930	3006322	1947-10-13	1947-10-13 00:00:00	1947-10-13	5001	0	\N	0	0	\N	\N	0	261241	0	8331-1	3006322		
905	74	3006322	1986-02-04	1986-02-04 00:00:00	1986-02-04	5001	0	\N	0	0	\N	\N	0	5013	0	8331-1	3006322		
86960	2685	4133840	2009-04-16	2009-04-16 00:00:00	2009-04-16	5001	0	\N	0	0	\N	\N	0	177964	0	127783003	4133840		
55758	5117	3021226	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	340118	0	6246-3	3021226		
11313	357	4024958	1973-05-22	1973-05-22 00:00:00	1973-05-22	5001	0	\N	0	0	\N	\N	0	23737	0	117015009	4024958		
20753	1911	40758406	1947-02-24	1947-02-24 00:00:00	1947-02-24	5001	0	\N	0	0	\N	\N	0	127115	0	55277-8	40758406		
3544	338	3006322	2016-07-16	2016-07-16 00:00:00	2016-07-16	5001	0	\N	0	0	\N	\N	0	22501	0	8331-1	3006322		
5529	525	3007461	1952-05-22	1952-05-22 00:00:00	1952-05-22	5001	0	\N	0	0	\N	\N	0	34958	0	26515-7	3007461		
25377	2333	3006322	1954-04-12	1954-04-12 00:00:00	1954-04-12	5001	0	\N	0	0	\N	\N	0	155239	0	8331-1	3006322		
26383	2425	3006322	2004-12-10	2004-12-10 00:00:00	2004-12-10	5001	0	\N	0	0	\N	\N	0	160916	0	8331-1	3006322		
26465	2437	3006322	1991-04-07	1991-04-07 00:00:00	1991-04-07	5001	0	\N	0	0	\N	\N	0	161694	0	8331-1	3006322		
117996	3630	4052083	2015-09-15	2015-09-15 00:00:00	2015-09-15	5001	0	\N	0	0	\N	\N	0	241517	0	23426006	4052083		
10214	978	3006322	1979-09-25	1979-09-25 00:00:00	1979-09-25	5001	0	\N	0	0	\N	\N	0	65165	0	8331-1	3006322		
39811	3700	3006322	1983-09-04	1983-09-04 00:00:00	1983-09-04	5001	0	\N	0	0	\N	\N	0	245963	0	8331-1	3006322		
39891	3707	3006322	2014-06-20	2014-06-20 00:00:00	2014-06-20	5001	0	\N	0	0	\N	\N	0	246465	0	8331-1	3006322		
38536	3566	3006451	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	236980	0	6273-7	3006451		
28213	2597	3006322	2012-02-12	2012-02-12 00:00:00	2012-02-12	5001	0	\N	0	0	\N	\N	0	171840	0	8331-1	3006322		
49983	4548	3001488	2000-04-25	2000-04-25 00:00:00	2000-04-25	5001	0	\N	0	0	\N	\N	0	303041	0	7258-7	3001488		
5042	488	3006322	1976-04-22	1976-04-22 00:00:00	1976-04-22	5001	0	\N	0	0	\N	\N	0	32623	0	8331-1	3006322		
30354	2779	3023430	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	184124	0	6833-8	3023430		
28948	2672	3015076	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	176924	0	6248-9	3015076		
40318	3752	40758406	1994-02-26	1994-02-26 00:00:00	1994-02-26	5001	0	\N	0	0	\N	\N	0	249353	0	55277-8	40758406		
30760	2821	46235214	1921-07-01	1921-07-01 00:00:00	1921-07-01	5001	0	\N	0	0	\N	\N	0	186945	0	76690-7	46235214		
13036	1246	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	82117	0	6189-5	3006734		
13270	1261	3012494	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	83187	0	6206-7	3012494		
3907	384	3006322	2012-10-29	2012-10-29 00:00:00	2012-10-29	5001	0	\N	0	0	\N	\N	0	25339	0	8331-1	3006322		
13421	1272	3015076	1992-09-18	1992-09-18 00:00:00	1992-09-18	5001	0	\N	0	0	\N	\N	0	83866	0	6248-9	3015076		
23498	2168	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	144458	0	6248-9	3015076		
7926	759	3006322	1961-12-04	1961-12-04 00:00:00	1961-12-04	5001	0	\N	0	0	\N	\N	0	50375	0	8331-1	3006322		
34910	3183	3006451	1981-08-20	1981-08-20 00:00:00	1981-08-20	5001	0	\N	0	0	\N	\N	0	211895	0	6273-7	3006451		
52755	4847	3011505	2008-02-27	2008-02-27 00:00:00	2008-02-27	5001	0	\N	0	0	\N	\N	0	322429	0	19926-5	3011505		
38256	3527	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	234021	0	6833-8	3023430		
84716	2624	4024958	2012-09-11	2012-09-11 00:00:00	2012-09-11	5001	0	\N	0	0	\N	\N	0	173552	0	117015009	4024958		
10008	320	4133840	1993-06-20	1993-06-20 00:00:00	1993-06-20	5001	0	\N	0	0	\N	\N	0	21204	0	127783003	4133840		
57900	5316	3006322	1957-07-17	1957-07-17 00:00:00	1957-07-17	5001	0	\N	0	0	\N	\N	0	353603	0	8331-1	3006322		
42355	3913	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	260111	0	6833-8	3023430		
52100	1576	4052083	2009-11-27	2009-11-27 00:00:00	2009-11-27	5001	0	\N	0	0	\N	\N	0	105803	0	23426006	4052083		
158	3	40758406	1994-07-02	1994-07-02 00:00:00	1994-07-02	5001	0	\N	0	0	\N	\N	0	295	0	55277-8	40758406		
43844	4052	40769184	1977-11-18	1977-11-18 00:00:00	1977-11-18	5001	0	\N	0	0	\N	\N	0	269372	0	66524-0	40769184		
44935	1379	4133840	2003-02-15	2003-02-15 00:00:00	2003-02-15	5001	0	\N	0	0	\N	\N	0	91522	0	127783003	4133840		
38377	3536	3006322	1974-06-24	1974-06-24 00:00:00	1974-06-24	5001	0	\N	0	0	\N	\N	0	234840	0	8331-1	3006322		
38477	3558	3006322	1974-10-19	1974-10-19 00:00:00	1974-10-19	5001	0	\N	0	0	\N	\N	0	236182	0	8331-1	3006322		
32957	2976	3011505	2005-06-23	2005-06-23 00:00:00	2005-06-23	5001	0	\N	0	0	\N	\N	0	198775	0	19926-5	3011505		
33055	2985	3006322	1996-07-08	1996-07-08 00:00:00	1996-07-08	5001	0	\N	0	0	\N	\N	0	199251	0	8331-1	3006322		
2515	245	3006322	1987-10-18	1987-10-18 00:00:00	1987-10-18	5001	0	\N	0	0	\N	\N	0	16427	0	8331-1	3006322		
18351	576	4052083	2013-09-24	2013-09-24 00:00:00	2013-09-24	5001	0	\N	0	0	\N	\N	0	38131	0	23426006	4052083		
1271	101	3006322	1942-01-31	1942-01-31 00:00:00	1942-01-31	5001	0	\N	0	0	\N	\N	0	6905	0	8331-1	3006322		
30515	2792	3006322	1959-09-28	1959-09-28 00:00:00	1959-09-28	5001	0	\N	0	0	\N	\N	0	185042	0	8331-1	3006322		
17849	1618	40758406	1974-08-14	1974-08-14 00:00:00	1974-08-14	5001	0	\N	0	0	\N	\N	0	108768	0	55277-8	40758406		
22142	2033	40766240	2017-08-28	2017-08-28 00:00:00	2017-08-28	5001	0	\N	0	0	\N	\N	0	135355	0	63513-6	40766240		
12821	1222	3006322	2018-11-19	2018-11-19 00:00:00	2018-11-19	5001	0	\N	0	0	\N	\N	0	80406	0	8331-1	3006322		
20897	656	4024958	1966-02-24	1966-02-24 00:00:00	1966-02-24	5001	0	\N	0	0	\N	\N	0	43432	0	117015009	4024958		
26517	2448	46235214	1965-10-13	1965-10-13 00:00:00	1965-10-13	5001	0	\N	0	0	\N	\N	0	162354	0	76690-7	46235214		
4974	480	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	32071	0	6095-4	3036780		
37961	3509	3006322	1988-06-18	1988-06-18 00:00:00	1988-06-18	5001	0	\N	0	0	\N	\N	0	232705	0	8331-1	3006322		
29679	2732	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	180879	0	7258-7	3001488		
49438	4506	40758406	2012-05-23	2012-05-23 00:00:00	2012-05-23	5001	0	\N	0	0	\N	\N	0	300171	0	55277-8	40758406		
90742	2801	4052083	1959-04-13	1959-04-13 00:00:00	1959-04-13	5001	0	\N	0	0	\N	\N	0	185655	0	23426006	4052083		
39247	3626	40766240	2015-08-10	2015-08-10 00:00:00	2015-08-10	5001	0	\N	0	0	\N	\N	0	241141	0	63513-6	40766240		
19569	1786	3006322	1989-04-09	1989-04-09 00:00:00	1989-04-09	5001	0	\N	0	0	\N	\N	0	119721	0	8331-1	3006322		
48816	4466	3006322	2006-05-18	2006-05-18 00:00:00	2006-05-18	5001	0	\N	0	0	\N	\N	0	297147	0	8331-1	3006322		
21410	1976	3006451	1995-12-25	1995-12-25 00:00:00	1995-12-25	5001	0	\N	0	0	\N	\N	0	131330	0	6273-7	3006451		
32777	2969	3006322	1970-06-28	1970-06-28 00:00:00	1970-06-28	5001	0	\N	0	0	\N	\N	0	198201	0	8331-1	3006322		
125055	3859	4133840	1990-02-17	1990-02-17 00:00:00	1990-02-17	5001	0	\N	0	0	\N	\N	0	256273	0	127783003	4133840		
42557	3930	3011505	1967-12-16	1967-12-16 00:00:00	1967-12-16	5001	0	\N	0	0	\N	\N	0	261254	0	19926-5	3011505		
906	74	3006322	1978-03-07	1978-03-07 00:00:00	1978-03-07	5001	0	\N	0	0	\N	\N	0	5008	0	8331-1	3006322		
86964	2685	4133840	1997-02-06	1997-02-06 00:00:00	1997-02-06	5001	0	\N	0	0	\N	\N	0	177937	0	127783003	4133840		
55759	5117	3012494	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	340118	0	6206-7	3012494		
11326	357	4024958	1982-12-11	1982-12-11 00:00:00	1982-12-11	5001	0	\N	0	0	\N	\N	0	23664	0	117015009	4024958		
20754	1911	3051031	1947-02-24	1947-02-24 00:00:00	1947-02-24	5001	0	\N	0	0	\N	\N	0	127115	0	46240-8	3051031		
3545	338	3006322	1968-06-16	1968-06-16 00:00:00	1968-06-16	5001	0	\N	0	0	\N	\N	0	22565	0	8331-1	3006322		
5530	525	3004501	1952-05-22	1952-05-22 00:00:00	1952-05-22	5001	0	\N	0	0	\N	\N	0	34958	0	2345-7	3004501		
25378	2333	46235214	1921-08-30	1921-08-30 00:00:00	1921-08-30	5001	0	\N	0	0	\N	\N	0	155256	0	76690-7	46235214		
26384	2425	3006322	1994-08-22	1994-08-22 00:00:00	1994-08-22	5001	0	\N	0	0	\N	\N	0	160915	0	8331-1	3006322		
26466	2438	3006322	1989-07-19	1989-07-19 00:00:00	1989-07-19	5001	0	\N	0	0	\N	\N	0	161769	0	8331-1	3006322		
118014	3631	4024958	1977-12-15	1977-12-15 00:00:00	1977-12-15	5001	0	\N	0	0	\N	\N	0	241593	0	117015009	4024958		
10215	978	3006322	2011-11-02	2011-11-02 00:00:00	2011-11-02	5001	0	\N	0	0	\N	\N	0	65143	0	8331-1	3006322		
39812	3700	3006322	2000-09-29	2000-09-29 00:00:00	2000-09-29	5001	0	\N	0	0	\N	\N	0	245965	0	8331-1	3006322		
39892	3708	3027231	1978-01-26	1978-01-26 00:00:00	1978-01-26	5001	0	\N	0	0	\N	\N	0	246551	0	6276-0	3027231		
38537	3566	3027231	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	236980	0	6276-0	3027231		
28214	2597	3006322	1976-11-23	1976-11-23 00:00:00	1976-11-23	5001	0	\N	0	0	\N	\N	0	171831	0	8331-1	3006322		
49984	4548	3001247	2000-04-25	2000-04-25 00:00:00	2000-04-25	5001	0	\N	0	0	\N	\N	0	303041	0	6085-5	3001247		
5043	488	3006322	1960-07-31	1960-07-31 00:00:00	1960-07-31	5001	0	\N	0	0	\N	\N	0	32672	0	8331-1	3006322		
30355	2779	3020655	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	184124	0	6844-5	3020655		
28949	2672	3005136	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	176924	0	6075-6	3005136		
40320	3752	40766240	1994-02-26	1994-02-26 00:00:00	1994-02-26	5001	0	\N	0	0	\N	\N	0	249353	0	63513-6	40766240		
30764	2821	3049273	2005-05-07	2005-05-07 00:00:00	2005-05-07	5001	0	\N	0	0	\N	\N	0	186856	0	38265-5	3049273		
13037	1246	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	82117	0	6273-7	3006451		
13271	1261	3011505	2009-11-14	2009-11-14 00:00:00	2009-11-14	5001	0	\N	0	0	\N	\N	0	83138	0	19926-5	3011505		
3913	387	3006322	1979-05-18	1979-05-18 00:00:00	1979-05-18	5001	0	\N	0	0	\N	\N	0	25487	0	8331-1	3006322		
13422	1272	3012494	1992-09-18	1992-09-18 00:00:00	1992-09-18	5001	0	\N	0	0	\N	\N	0	83866	0	6206-7	3012494		
23499	2168	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	144458	0	6206-7	3012494		
7927	759	3049273	2016-11-17	2016-11-17 00:00:00	2016-11-17	5001	0	\N	0	0	\N	\N	0	50364	0	38265-5	3049273		
34911	3183	3000876	1981-08-20	1981-08-20 00:00:00	1981-08-20	5001	0	\N	0	0	\N	\N	0	211895	0	6082-2	3000876		
52756	4847	3011505	1978-01-25	1978-01-25 00:00:00	1978-01-25	5001	0	\N	0	0	\N	\N	0	322414	0	19926-5	3011505		
38257	3527	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	234021	0	6075-6	3005136		
2140	63	4024958	1980-03-05	1980-03-05 00:00:00	1980-03-05	5001	0	\N	0	0	\N	\N	0	4282	0	117015009	4024958		
20040	1843	3036780	1998-02-25	1998-02-25 00:00:00	1998-02-25	5001	0	\N	0	0	\N	\N	0	123041	0	6095-4	3036780		
57901	5317	3006322	2001-09-05	2001-09-05 00:00:00	2001-09-05	5001	0	\N	0	0	\N	\N	0	353651	0	8331-1	3006322		
42356	3913	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	260111	0	6158-0	3019406		
21456	675	4024958	1968-01-31	1968-01-31 00:00:00	1968-01-31	5001	0	\N	0	0	\N	\N	0	44688	0	117015009	4024958		
160	3	3051031	1994-04-03	1994-04-03 00:00:00	1994-04-03	5001	0	\N	0	0	\N	\N	0	294	0	46240-8	3051031		
43845	4052	3006322	1977-02-11	1977-02-11 00:00:00	1977-02-11	5001	0	\N	0	0	\N	\N	0	269371	0	8331-1	3006322		
44939	1379	4133840	1997-04-12	1997-04-12 00:00:00	1997-04-12	5001	0	\N	0	0	\N	\N	0	91483	0	127783003	4133840		
38378	3536	3006322	2017-10-16	2017-10-16 00:00:00	2017-10-16	5001	0	\N	0	0	\N	\N	0	234860	0	8331-1	3006322		
38478	3558	3006322	1993-10-05	1993-10-05 00:00:00	1993-10-05	5001	0	\N	0	0	\N	\N	0	236228	0	8331-1	3006322		
32958	2976	3011505	2011-11-10	2011-11-10 00:00:00	2011-11-10	5001	0	\N	0	0	\N	\N	0	198764	0	19926-5	3011505		
33056	2986	3006322	1999-03-10	1999-03-10 00:00:00	1999-03-10	5001	0	\N	0	0	\N	\N	0	199285	0	8331-1	3006322		
2516	245	3006322	1953-09-03	1953-09-03 00:00:00	1953-09-03	5001	0	\N	0	0	\N	\N	0	16476	0	8331-1	3006322		
18356	576	4024958	1997-07-31	1997-07-31 00:00:00	1997-07-31	5001	0	\N	0	0	\N	\N	0	38073	0	117015009	4024958		
1272	101	3006322	1982-02-08	1982-02-08 00:00:00	1982-02-08	5001	0	\N	0	0	\N	\N	0	6854	0	8331-1	3006322		
30572	2798	3006322	2006-07-21	2006-07-21 00:00:00	2006-07-21	5001	0	\N	0	0	\N	\N	0	185405	0	8331-1	3006322		
17851	1618	3006322	1978-06-21	1978-06-21 00:00:00	1978-06-21	5001	0	\N	0	0	\N	\N	0	108822	0	8331-1	3006322		
22143	2033	3051031	2017-08-28	2017-08-28 00:00:00	2017-08-28	5001	0	\N	0	0	\N	\N	0	135355	0	46240-8	3051031		
12822	1222	3006322	2017-08-10	2017-08-10 00:00:00	2017-08-10	5001	0	\N	0	0	\N	\N	0	80405	0	8331-1	3006322		
34104	1068	4052083	1987-05-05	1987-05-05 00:00:00	1987-05-05	5001	0	\N	0	0	\N	\N	0	69978	0	23426006	4052083		
26518	2448	40758406	1965-10-13	1965-10-13 00:00:00	1965-10-13	5001	0	\N	0	0	\N	\N	0	162354	0	55277-8	40758406		
4975	480	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	32071	0	6248-9	3015076		
37962	3509	3006322	1948-02-01	1948-02-01 00:00:00	1948-02-01	5001	0	\N	0	0	\N	\N	0	232702	0	8331-1	3006322		
29680	2732	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	180879	0	6189-5	3006734		
49440	4506	46235214	2012-05-23	2012-05-23 00:00:00	2012-05-23	5001	0	\N	0	0	\N	\N	0	300171	0	76690-7	46235214		
102037	3134	4052083	1977-08-22	1977-08-22 00:00:00	1977-08-22	5001	0	\N	0	0	\N	\N	0	208628	0	23426006	4052083		
39248	3626	40758406	2015-08-10	2015-08-10 00:00:00	2015-08-10	5001	0	\N	0	0	\N	\N	0	241141	0	55277-8	40758406		
19570	1786	3006322	1980-08-16	1980-08-16 00:00:00	1980-08-16	5001	0	\N	0	0	\N	\N	0	119751	0	8331-1	3006322		
48817	4466	3006322	2006-04-05	2006-04-05 00:00:00	2006-04-05	5001	0	\N	0	0	\N	\N	0	297157	0	8331-1	3006322		
21411	1976	3012494	1995-12-25	1995-12-25 00:00:00	1995-12-25	5001	0	\N	0	0	\N	\N	0	131330	0	6206-7	3012494		
32778	2969	3006322	1978-05-29	1978-05-29 00:00:00	1978-05-29	5001	0	\N	0	0	\N	\N	0	198206	0	8331-1	3006322		
125056	3859	4052083	1931-03-10	1931-03-10 00:00:00	1931-03-10	5001	0	\N	0	0	\N	\N	0	256242	0	23426006	4052083		
42558	3930	3011505	1976-08-14	1976-08-14 00:00:00	1976-08-14	5001	0	\N	0	0	\N	\N	0	261294	0	19926-5	3011505		
77229	2367	4052083	1999-09-04	1999-09-04 00:00:00	1999-09-04	5001	0	\N	0	0	\N	\N	0	157576	0	23426006	4052083		
86966	2685	4133840	2017-06-01	2017-06-01 00:00:00	2017-06-01	5001	0	\N	0	0	\N	\N	0	177982	0	127783003	4133840		
55760	5117	3005136	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	340118	0	6075-6	3005136		
11343	357	4052083	2000-02-24	2000-02-24 00:00:00	2000-02-24	5001	0	\N	0	0	\N	\N	0	23699	0	23426006	4052083		
56761	1733	4052083	2002-04-08	2002-04-08 00:00:00	2002-04-08	5001	0	\N	0	0	\N	\N	0	115836	0	23426006	4052083		
3546	338	3006322	2006-02-20	2006-02-20 00:00:00	2006-02-20	5001	0	\N	0	0	\N	\N	0	22528	0	8331-1	3006322		
5531	525	3002385	1952-05-22	1952-05-22 00:00:00	1952-05-22	5001	0	\N	0	0	\N	\N	0	34958	0	30385-9	3002385		
25381	2333	3051031	1921-08-30	1921-08-30 00:00:00	1921-08-30	5001	0	\N	0	0	\N	\N	0	155256	0	46240-8	3051031		
26385	2425	3006322	1971-09-29	1971-09-29 00:00:00	1971-09-29	5001	0	\N	0	0	\N	\N	0	160875	0	8331-1	3006322		
26467	2438	3006322	1981-12-15	1981-12-15 00:00:00	1981-12-15	5001	0	\N	0	0	\N	\N	0	161767	0	8331-1	3006322		
118031	3631	4052083	2015-03-22	2015-03-22 00:00:00	2015-03-22	5001	0	\N	0	0	\N	\N	0	241607	0	23426006	4052083		
10266	986	3006322	1923-07-28	1923-07-28 00:00:00	1923-07-28	5001	0	\N	0	0	\N	\N	0	65457	0	8331-1	3006322		
39813	3701	3006322	1969-02-18	1969-02-18 00:00:00	1969-02-18	5001	0	\N	0	0	\N	\N	0	246126	0	8331-1	3006322		
39893	3708	3019406	1978-01-26	1978-01-26 00:00:00	1978-01-26	5001	0	\N	0	0	\N	\N	0	246551	0	6158-0	3019406		
38538	3566	3019406	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	236980	0	6158-0	3019406		
28215	2597	3006322	2016-02-05	2016-02-05 00:00:00	2016-02-05	5001	0	\N	0	0	\N	\N	0	171835	0	8331-1	3006322		
167157	5132	4052083	2011-06-01	2011-06-01 00:00:00	2011-06-01	5001	0	\N	0	0	\N	\N	0	341137	0	23426006	4052083		
5044	489	3006322	2010-06-28	2010-06-28 00:00:00	2010-06-28	5001	0	\N	0	0	\N	\N	0	32805	0	8331-1	3006322		
30356	2779	3000876	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	184124	0	6082-2	3000876		
28950	2672	3012494	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	176924	0	6206-7	3012494		
40322	3752	46235214	1994-02-26	1994-02-26 00:00:00	1994-02-26	5001	0	\N	0	0	\N	\N	0	249353	0	76690-7	46235214		
102977	3167	4052083	1983-02-11	1983-02-11 00:00:00	1983-02-11	5001	0	\N	0	0	\N	\N	0	210593	0	23426006	4052083		
13038	1246	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	82117	0	6106-9	3014599		
13272	1261	3011505	2011-11-19	2011-11-19 00:00:00	2011-11-19	5001	0	\N	0	0	\N	\N	0	83228	0	19926-5	3011505		
3914	387	3006322	2014-01-29	2014-01-29 00:00:00	2014-01-29	5001	0	\N	0	0	\N	\N	0	25490	0	8331-1	3006322		
13423	1272	3001247	1992-09-18	1992-09-18 00:00:00	1992-09-18	5001	0	\N	0	0	\N	\N	0	83866	0	6085-5	3001247		
23500	2168	3006322	1993-12-20	1993-12-20 00:00:00	1993-12-20	5001	0	\N	0	0	\N	\N	0	144557	0	8331-1	3006322		
7928	759	3006322	1947-05-25	1947-05-25 00:00:00	1947-05-25	5001	0	\N	0	0	\N	\N	0	50432	0	8331-1	3006322		
34912	3183	3005136	1981-08-20	1981-08-20 00:00:00	1981-08-20	5001	0	\N	0	0	\N	\N	0	211895	0	6075-6	3005136		
52757	4847	3011505	1985-06-12	1985-06-12 00:00:00	1985-06-12	5001	0	\N	0	0	\N	\N	0	322447	0	19926-5	3011505		
38258	3527	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	234021	0	6246-3	3021226		
13489	426	4024958	1971-06-14	1971-06-14 00:00:00	1971-06-14	5001	0	\N	0	0	\N	\N	0	28250	0	117015009	4024958		
20041	1843	3023430	1998-02-25	1998-02-25 00:00:00	1998-02-25	5001	0	\N	0	0	\N	\N	0	123041	0	6833-8	3023430		
57902	5317	3006322	2011-01-03	2011-01-03 00:00:00	2011-01-03	5001	0	\N	0	0	\N	\N	0	353678	0	8331-1	3006322		
42357	3913	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	260111	0	6276-0	3027231		
32764	1022	4052083	1970-03-31	1970-03-31 00:00:00	1970-03-31	5001	0	\N	0	0	\N	\N	0	67269	0	23426006	4052083		
161	3	40758406	1994-04-03	1994-04-03 00:00:00	1994-04-03	5001	0	\N	0	0	\N	\N	0	294	0	55277-8	40758406		
43846	4052	3006322	1984-11-15	1984-11-15 00:00:00	1984-11-15	5001	0	\N	0	0	\N	\N	0	269374	0	8331-1	3006322		
44943	1379	4133840	2012-03-17	2012-03-17 00:00:00	2012-03-17	5001	0	\N	0	0	\N	\N	0	91452	0	127783003	4133840		
38379	3536	3006322	1971-01-01	1971-01-01 00:00:00	1971-01-01	5001	0	\N	0	0	\N	\N	0	234825	0	8331-1	3006322		
38479	3558	3011505	2019-05-25	2019-05-25 00:00:00	2019-05-25	5001	0	\N	0	0	\N	\N	0	236205	0	19926-5	3011505		
32959	2976	3011505	1981-04-16	1981-04-16 00:00:00	1981-04-16	5001	0	\N	0	0	\N	\N	0	198770	0	19926-5	3011505		
33057	2986	3011505	2015-04-14	2015-04-14 00:00:00	2015-04-14	5001	0	\N	0	0	\N	\N	0	199325	0	19926-5	3011505		
2517	245	3049273	1984-02-25	1984-02-25 00:00:00	1984-02-25	5001	0	\N	0	0	\N	\N	0	16402	0	38265-5	3049273		
18385	578	4024958	1996-10-07	1996-10-07 00:00:00	1996-10-07	5001	0	\N	0	0	\N	\N	0	38216	0	117015009	4024958		
1273	101	3006322	1995-03-25	1995-03-25 00:00:00	1995-03-25	5001	0	\N	0	0	\N	\N	0	6937	0	8331-1	3006322		
30573	2798	3006322	1996-05-01	1996-05-01 00:00:00	1996-05-01	5001	0	\N	0	0	\N	\N	0	185462	0	8331-1	3006322		
17854	1618	3051031	1974-10-13	1974-10-13 00:00:00	1974-10-13	5001	0	\N	0	0	\N	\N	0	108797	0	46240-8	3051031		
22144	2033	3006322	2011-04-14	2011-04-14 00:00:00	2011-04-14	5001	0	\N	0	0	\N	\N	0	135338	0	8331-1	3006322		
12823	1222	3006322	1988-10-06	1988-10-06 00:00:00	1988-10-06	5001	0	\N	0	0	\N	\N	0	80434	0	8331-1	3006322		
29347	2702	3006322	1974-04-02	1974-04-02 00:00:00	1974-04-02	5001	0	\N	0	0	\N	\N	0	178963	0	8331-1	3006322		
26521	2448	3051031	1965-10-13	1965-10-13 00:00:00	1965-10-13	5001	0	\N	0	0	\N	\N	0	162354	0	46240-8	3051031		
4976	480	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	32071	0	6276-0	3027231		
37963	3509	3049273	2015-12-30	2015-12-30 00:00:00	2015-12-30	5001	0	\N	0	0	\N	\N	0	232795	0	38265-5	3049273		
29681	2732	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	180879	0	6833-8	3023430		
49442	4506	40766240	2012-05-23	2012-05-23 00:00:00	2012-05-23	5001	0	\N	0	0	\N	\N	0	300171	0	63513-6	40766240		
102066	3135	4024958	1970-08-30	1970-08-30 00:00:00	1970-08-30	5001	0	\N	0	0	\N	\N	0	208681	0	117015009	4024958		
39249	3626	3006322	1982-06-23	1982-06-23 00:00:00	1982-06-23	5001	0	\N	0	0	\N	\N	0	241131	0	8331-1	3006322		
19571	1786	3006322	1967-03-22	1967-03-22 00:00:00	1967-03-22	5001	0	\N	0	0	\N	\N	0	119684	0	8331-1	3006322		
48818	4467	3006322	1989-10-08	1989-10-08 00:00:00	1989-10-08	5001	0	\N	0	0	\N	\N	0	297179	0	8331-1	3006322		
21412	1976	3014599	1995-12-25	1995-12-25 00:00:00	1995-12-25	5001	0	\N	0	0	\N	\N	0	131330	0	6106-9	3014599		
32779	2969	3006322	1985-11-28	1985-11-28 00:00:00	1985-11-28	5001	0	\N	0	0	\N	\N	0	198248	0	8331-1	3006322		
125059	3859	4133840	1988-09-17	1988-09-17 00:00:00	1988-09-17	5001	0	\N	0	0	\N	\N	0	256169	0	127783003	4133840		
42559	3930	3006322	1971-07-11	1971-07-11 00:00:00	1971-07-11	5001	0	\N	0	0	\N	\N	0	261231	0	8331-1	3006322		
77231	2367	4052083	1978-03-14	1978-03-14 00:00:00	1978-03-14	5001	0	\N	0	0	\N	\N	0	157575	0	23426006	4052083		
86970	2685	4133840	1987-01-08	1987-01-08 00:00:00	1987-01-08	5001	0	\N	0	0	\N	\N	0	177960	0	127783003	4133840		
55761	5117	3015076	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	340118	0	6248-9	3015076		
11346	357	4052083	1992-03-28	1992-03-28 00:00:00	1992-03-28	5001	0	\N	0	0	\N	\N	0	23764	0	23426006	4052083		
56765	1733	4024958	2005-03-16	2005-03-16 00:00:00	2005-03-16	5001	0	\N	0	0	\N	\N	0	115837	0	117015009	4024958		
3547	338	3006322	2016-05-08	2016-05-08 00:00:00	2016-05-08	5001	0	\N	0	0	\N	\N	0	22585	0	8331-1	3006322		
5532	525	3013682	1952-05-22	1952-05-22 00:00:00	1952-05-22	5001	0	\N	0	0	\N	\N	0	34958	0	3094-0	3013682		
25382	2333	40766240	1921-08-30	1921-08-30 00:00:00	1921-08-30	5001	0	\N	0	0	\N	\N	0	155256	0	63513-6	40766240		
97072	2970	4024958	2017-05-23	2017-05-23 00:00:00	2017-05-23	5001	0	\N	0	0	\N	\N	0	198390	0	117015009	4024958		
26468	2438	3006322	1995-01-03	1995-01-03 00:00:00	1995-01-03	5001	0	\N	0	0	\N	\N	0	161749	0	8331-1	3006322		
118032	3631	4024958	1991-09-02	1991-09-02 00:00:00	1991-09-02	5001	0	\N	0	0	\N	\N	0	241584	0	117015009	4024958		
10270	986	3006322	1967-05-23	1967-05-23 00:00:00	1967-05-23	5001	0	\N	0	0	\N	\N	0	65508	0	8331-1	3006322		
39814	3701	46235214	1970-12-27	1970-12-27 00:00:00	1970-12-27	5001	0	\N	0	0	\N	\N	0	246038	0	76690-7	46235214		
39894	3708	3023430	1978-01-26	1978-01-26 00:00:00	1978-01-26	5001	0	\N	0	0	\N	\N	0	246551	0	6833-8	3023430		
38539	3566	3012494	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	236980	0	6206-7	3012494		
28216	2598	3006322	2001-12-13	2001-12-13 00:00:00	2001-12-13	5001	0	\N	0	0	\N	\N	0	171926	0	8331-1	3006322		
167165	5132	4052083	1970-05-21	1970-05-21 00:00:00	1970-05-21	5001	0	\N	0	0	\N	\N	0	341107	0	23426006	4052083		
5045	489	3006322	1976-12-26	1976-12-26 00:00:00	1976-12-26	5001	0	\N	0	0	\N	\N	0	32717	0	8331-1	3006322		
30357	2779	3015076	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	184124	0	6248-9	3015076		
28951	2672	3014599	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	176924	0	6106-9	3014599		
40325	3752	3051031	1993-07-31	1993-07-31 00:00:00	1993-07-31	5001	0	\N	0	0	\N	\N	0	249304	0	46240-8	3051031		
102984	3167	4024958	1973-08-30	1973-08-30 00:00:00	1973-08-30	5001	0	\N	0	0	\N	\N	0	210530	0	117015009	4024958		
13040	1246	3006322	1957-03-26	1957-03-26 00:00:00	1957-03-26	5001	0	\N	0	0	\N	\N	0	82040	0	8331-1	3006322		
13273	1261	3011505	2002-07-06	2002-07-06 00:00:00	2002-07-06	5001	0	\N	0	0	\N	\N	0	83129	0	19926-5	3011505		
3915	387	3006322	1976-04-21	1976-04-21 00:00:00	1976-04-21	5001	0	\N	0	0	\N	\N	0	25503	0	8331-1	3006322		
13424	1272	3001488	1992-09-18	1992-09-18 00:00:00	1992-09-18	5001	0	\N	0	0	\N	\N	0	83866	0	7258-7	3001488		
23501	2168	3006322	1980-08-19	1980-08-19 00:00:00	1980-08-19	5001	0	\N	0	0	\N	\N	0	144409	0	8331-1	3006322		
7929	759	3006322	2005-12-24	2005-12-24 00:00:00	2005-12-24	5001	0	\N	0	0	\N	\N	0	50446	0	8331-1	3006322		
34913	3183	3001247	1981-08-20	1981-08-20 00:00:00	1981-08-20	5001	0	\N	0	0	\N	\N	0	211895	0	6085-5	3001247		
52758	4847	3011505	1991-06-26	1991-06-26 00:00:00	1991-06-26	5001	0	\N	0	0	\N	\N	0	322474	0	19926-5	3011505		
38259	3527	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	234021	0	6248-9	3015076		
46390	4270	3006322	2013-06-10	2013-06-10 00:00:00	2013-06-10	5001	0	\N	0	0	\N	\N	0	283439	0	8331-1	3006322		
20042	1843	3006451	1998-02-25	1998-02-25 00:00:00	1998-02-25	5001	0	\N	0	0	\N	\N	0	123041	0	6273-7	3006451		
57903	5317	3006322	1983-12-22	1983-12-22 00:00:00	1983-12-22	5001	0	\N	0	0	\N	\N	0	353650	0	8331-1	3006322		
42358	3913	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	260100	0	6833-8	3023430		
32768	1022	4024958	1965-06-26	1965-06-26 00:00:00	1965-06-26	5001	0	\N	0	0	\N	\N	0	67268	0	117015009	4024958		
163	3	46235214	1994-04-03	1994-04-03 00:00:00	1994-04-03	5001	0	\N	0	0	\N	\N	0	294	0	76690-7	46235214		
43847	4052	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	269336	0	6248-9	3015076		
44964	1381	4133840	2009-08-15	2009-08-15 00:00:00	2009-08-15	5001	0	\N	0	0	\N	\N	0	91574	0	127783003	4133840		
38380	3536	3006322	1975-09-29	1975-09-29 00:00:00	1975-09-29	5001	0	\N	0	0	\N	\N	0	234827	0	8331-1	3006322		
38480	3558	3011505	2015-05-02	2015-05-02 00:00:00	2015-05-02	5001	0	\N	0	0	\N	\N	0	236189	0	19926-5	3011505		
32960	2976	3006322	1984-03-02	1984-03-02 00:00:00	1984-03-02	5001	0	\N	0	0	\N	\N	0	198726	0	8331-1	3006322		
33058	2986	3011505	2002-01-29	2002-01-29 00:00:00	2002-01-29	5001	0	\N	0	0	\N	\N	0	199322	0	19926-5	3011505		
2518	245	3006322	2002-10-14	2002-10-14 00:00:00	2002-10-14	5001	0	\N	0	0	\N	\N	0	16485	0	8331-1	3006322		
18391	578	4024958	1979-05-31	1979-05-31 00:00:00	1979-05-31	5001	0	\N	0	0	\N	\N	0	38278	0	117015009	4024958		
1274	101	3006322	1930-05-06	1930-05-06 00:00:00	1930-05-06	5001	0	\N	0	0	\N	\N	0	6833	0	8331-1	3006322		
30574	2798	3006322	1978-08-11	1978-08-11 00:00:00	1978-08-11	5001	0	\N	0	0	\N	\N	0	185460	0	8331-1	3006322		
17855	1618	40766240	1974-10-13	1974-10-13 00:00:00	1974-10-13	5001	0	\N	0	0	\N	\N	0	108797	0	63513-6	40766240		
22145	2033	40758406	1961-07-18	1961-07-18 00:00:00	1961-07-18	5001	0	\N	0	0	\N	\N	0	135372	0	55277-8	40758406		
12824	1222	3006322	1968-04-13	1968-04-13 00:00:00	1968-04-13	5001	0	\N	0	0	\N	\N	0	80413	0	8331-1	3006322		
29348	2702	3006322	2003-11-20	2003-11-20 00:00:00	2003-11-20	5001	0	\N	0	0	\N	\N	0	178937	0	8331-1	3006322		
26522	2448	40766240	1965-10-13	1965-10-13 00:00:00	1965-10-13	5001	0	\N	0	0	\N	\N	0	162354	0	63513-6	40766240		
4977	480	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	32071	0	6206-7	3012494		
37964	3509	3006322	1976-09-21	1976-09-21 00:00:00	1976-09-21	5001	0	\N	0	0	\N	\N	0	232738	0	8331-1	3006322		
29682	2732	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	180879	0	6844-5	3020655		
49443	4506	40766240	1956-02-22	1956-02-22 00:00:00	1956-02-22	5001	0	\N	0	0	\N	\N	0	300203	0	63513-6	40766240		
59209	1801	4024958	1981-12-27	1981-12-27 00:00:00	1981-12-27	5001	0	\N	0	0	\N	\N	0	120761	0	117015009	4024958		
39250	3626	3006322	2005-08-31	2005-08-31 00:00:00	2005-08-31	5001	0	\N	0	0	\N	\N	0	241139	0	8331-1	3006322		
19572	1786	3006322	2010-11-24	2010-11-24 00:00:00	2010-11-24	5001	0	\N	0	0	\N	\N	0	119696	0	8331-1	3006322		
48819	4467	3006322	1965-10-27	1965-10-27 00:00:00	1965-10-27	5001	0	\N	0	0	\N	\N	0	297240	0	8331-1	3006322		
21413	1976	3001488	1995-12-25	1995-12-25 00:00:00	1995-12-25	5001	0	\N	0	0	\N	\N	0	131330	0	7258-7	3001488		
32780	2970	3006322	1980-01-31	1980-01-31 00:00:00	1980-01-31	5001	0	\N	0	0	\N	\N	0	198305	0	8331-1	3006322		
125063	3859	4133840	2017-04-22	2017-04-22 00:00:00	2017-04-22	5001	0	\N	0	0	\N	\N	0	256162	0	127783003	4133840		
42560	3930	3011505	1978-08-26	1978-08-26 00:00:00	1978-08-26	5001	0	\N	0	0	\N	\N	0	261295	0	19926-5	3011505		
77239	2369	4024958	1994-06-08	1994-06-08 00:00:00	1994-06-08	5001	0	\N	0	0	\N	\N	0	157677	0	117015009	4024958		
86972	2685	4133840	1982-12-02	1982-12-02 00:00:00	1982-12-02	5001	0	\N	0	0	\N	\N	0	177926	0	127783003	4133840		
55762	5117	3006451	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	340118	0	6273-7	3006451		
11358	358	4024958	1978-03-08	1978-03-08 00:00:00	1978-03-08	5001	0	\N	0	0	\N	\N	0	23790	0	117015009	4024958		
125802	3879	4052083	1996-10-13	1996-10-13 00:00:00	1996-10-13	5001	0	\N	0	0	\N	\N	0	257659	0	23426006	4052083		
3548	339	3006322	2002-11-08	2002-11-08 00:00:00	2002-11-08	5001	0	\N	0	0	\N	\N	0	22624	0	8331-1	3006322		
5533	525	3023103	1952-05-22	1952-05-22 00:00:00	1952-05-22	5001	0	\N	0	0	\N	\N	0	34958	0	2823-3	3023103		
25383	2333	40758406	1921-08-30	1921-08-30 00:00:00	1921-08-30	5001	0	\N	0	0	\N	\N	0	155256	0	55277-8	40758406		
47436	1446	4024958	1993-05-22	1993-05-22 00:00:00	1993-05-22	5001	0	\N	0	0	\N	\N	0	96362	0	117015009	4024958		
97193	2975	4052083	1973-09-09	1973-09-09 00:00:00	1973-09-09	5001	0	\N	0	0	\N	\N	0	198567	0	23426006	4052083		
118034	3631	4024958	1980-05-17	1980-05-17 00:00:00	1980-05-17	5001	0	\N	0	0	\N	\N	0	241628	0	117015009	4024958		
10271	986	3006322	1926-11-20	1926-11-20 00:00:00	1926-11-20	5001	0	\N	0	0	\N	\N	0	65458	0	8331-1	3006322		
39816	3701	3051031	1970-12-27	1970-12-27 00:00:00	1970-12-27	5001	0	\N	0	0	\N	\N	0	246038	0	46240-8	3051031		
39895	3708	3006734	1978-01-26	1978-01-26 00:00:00	1978-01-26	5001	0	\N	0	0	\N	\N	0	246551	0	6189-5	3006734		
38540	3566	3001247	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	236892	0	6085-5	3001247		
28217	2598	3006322	1998-01-20	1998-01-20 00:00:00	1998-01-20	5001	0	\N	0	0	\N	\N	0	171925	0	8331-1	3006322		
5013	484	3006322	1944-01-21	1944-01-21 00:00:00	1944-01-21	5001	0	\N	0	0	\N	\N	0	32306	0	8331-1	3006322		
5046	489	3014599	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	32787	0	6106-9	3014599		
30358	2779	3012494	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	184124	0	6206-7	3012494		
28952	2672	3001488	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	176924	0	7258-7	3001488		
40326	3752	46235214	1993-07-31	1993-07-31 00:00:00	1993-07-31	5001	0	\N	0	0	\N	\N	0	249304	0	76690-7	46235214		
102986	3167	4052083	1966-07-06	1966-07-06 00:00:00	1966-07-06	5001	0	\N	0	0	\N	\N	0	210529	0	23426006	4052083		
13042	1246	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	82151	0	6844-5	3020655		
13274	1261	3011505	2006-11-11	2006-11-11 00:00:00	2006-11-11	5001	0	\N	0	0	\N	\N	0	83227	0	19926-5	3011505		
3916	388	3006322	1976-09-18	1976-09-18 00:00:00	1976-09-18	5001	0	\N	0	0	\N	\N	0	25554	0	8331-1	3006322		
13425	1272	3021226	1992-09-18	1992-09-18 00:00:00	1992-09-18	5001	0	\N	0	0	\N	\N	0	83866	0	6246-3	3021226		
23502	2168	3006322	1973-07-17	1973-07-17 00:00:00	1973-07-17	5001	0	\N	0	0	\N	\N	0	144503	0	8331-1	3006322		
7930	760	3006322	2017-06-28	2017-06-28 00:00:00	2017-06-28	5001	0	\N	0	0	\N	\N	0	50466	0	8331-1	3006322		
34914	3183	3014599	1981-08-20	1981-08-20 00:00:00	1981-08-20	5001	0	\N	0	0	\N	\N	0	211895	0	6106-9	3014599		
52759	4847	3011505	1996-06-19	1996-06-19 00:00:00	1996-06-19	5001	0	\N	0	0	\N	\N	0	322418	0	19926-5	3011505		
38260	3527	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	234021	0	6158-0	3019406		
46391	4270	3006322	2005-03-11	2005-03-11 00:00:00	2005-03-11	5001	0	\N	0	0	\N	\N	0	283401	0	8331-1	3006322		
20043	1843	3021226	1998-02-25	1998-02-25 00:00:00	1998-02-25	5001	0	\N	0	0	\N	\N	0	123041	0	6246-3	3021226		
57904	5317	3006322	2003-03-08	2003-03-08 00:00:00	2003-03-08	5001	0	\N	0	0	\N	\N	0	353652	0	8331-1	3006322		
42359	3913	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	260100	0	6844-5	3020655		
32772	1022	4052083	1988-12-18	1988-12-18 00:00:00	1988-12-18	5001	0	\N	0	0	\N	\N	0	67254	0	23426006	4052083		
164	3	40766240	1994-04-03	1994-04-03 00:00:00	1994-04-03	5001	0	\N	0	0	\N	\N	0	294	0	63513-6	40766240		
43848	4052	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	269336	0	6276-0	3027231		
44965	1381	4052083	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	91567	0	23426006	4052083		
38381	3537	3006322	2001-10-16	2001-10-16 00:00:00	2001-10-16	5001	0	\N	0	0	\N	\N	0	234951	0	8331-1	3006322		
38481	3558	3011505	2016-05-07	2016-05-07 00:00:00	2016-05-07	5001	0	\N	0	0	\N	\N	0	236238	0	19926-5	3011505		
32961	2976	3011505	2017-08-03	2017-08-03 00:00:00	2017-08-03	5001	0	\N	0	0	\N	\N	0	198752	0	19926-5	3011505		
33059	2986	3011505	2011-03-22	2011-03-22 00:00:00	2011-03-22	5001	0	\N	0	0	\N	\N	0	199323	0	19926-5	3011505		
2519	246	3011505	1998-09-03	1998-09-03 00:00:00	1998-09-03	5001	0	\N	0	0	\N	\N	0	16565	0	19926-5	3011505		
18400	578	4052083	1996-10-06	1996-10-06 00:00:00	1996-10-06	5001	0	\N	0	0	\N	\N	0	38268	0	23426006	4052083		
24607	2264	3006322	1971-04-05	1971-04-05 00:00:00	1971-04-05	5001	0	\N	0	0	\N	\N	0	150427	0	8331-1	3006322		
30575	2798	3006322	1958-10-16	1958-10-16 00:00:00	1958-10-16	5001	0	\N	0	0	\N	\N	0	185455	0	8331-1	3006322		
17856	1618	46235214	1974-10-13	1974-10-13 00:00:00	1974-10-13	5001	0	\N	0	0	\N	\N	0	108797	0	76690-7	46235214		
22146	2033	46235214	1961-07-18	1961-07-18 00:00:00	1961-07-18	5001	0	\N	0	0	\N	\N	0	135372	0	76690-7	46235214		
12825	1223	3006322	1985-01-27	1985-01-27 00:00:00	1985-01-27	5001	0	\N	0	0	\N	\N	0	80515	0	8331-1	3006322		
29349	2702	3006322	2014-08-17	2014-08-17 00:00:00	2014-08-17	5001	0	\N	0	0	\N	\N	0	178939	0	8331-1	3006322		
26523	2448	3006322	1974-01-06	1974-01-06 00:00:00	1974-01-06	5001	0	\N	0	0	\N	\N	0	162364	0	8331-1	3006322		
4978	480	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	32071	0	6158-0	3019406		
37965	3510	3006322	1935-09-07	1935-09-07 00:00:00	1935-09-07	5001	0	\N	0	0	\N	\N	0	232959	0	8331-1	3006322		
29683	2732	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	180879	0	6075-6	3005136		
49446	4506	46235214	1956-02-22	1956-02-22 00:00:00	1956-02-22	5001	0	\N	0	0	\N	\N	0	300203	0	76690-7	46235214		
25121	782	4052083	1950-01-17	1950-01-17 00:00:00	1950-01-17	5001	0	\N	0	0	\N	\N	0	52024	0	23426006	4052083		
39251	3626	3051031	2015-11-08	2015-11-08 00:00:00	2015-11-08	5001	0	\N	0	0	\N	\N	0	241142	0	46240-8	3051031		
19588	1788	3006322	2003-10-09	2003-10-09 00:00:00	2003-10-09	5001	0	\N	0	0	\N	\N	0	119828	0	8331-1	3006322		
48820	4467	3006322	1952-05-25	1952-05-25 00:00:00	1952-05-25	5001	0	\N	0	0	\N	\N	0	297223	0	8331-1	3006322		
21414	1976	3001488	1986-01-15	1986-01-15 00:00:00	1986-01-15	5001	0	\N	0	0	\N	\N	0	131339	0	7258-7	3001488		
32781	2970	3006322	1990-07-03	1990-07-03 00:00:00	1990-07-03	5001	0	\N	0	0	\N	\N	0	198319	0	8331-1	3006322		
125067	3859	4133840	2007-10-06	2007-10-06 00:00:00	2007-10-06	5001	0	\N	0	0	\N	\N	0	256160	0	127783003	4133840		
42561	3930	3011505	1963-11-23	1963-11-23 00:00:00	1963-11-23	5001	0	\N	0	0	\N	\N	0	261252	0	19926-5	3011505		
77253	2369	4024958	1981-12-31	1981-12-31 00:00:00	1981-12-31	5001	0	\N	0	0	\N	\N	0	157669	0	117015009	4024958		
86973	2685	4133840	1971-01-07	1971-01-07 00:00:00	1971-01-07	5001	0	\N	0	0	\N	\N	0	177956	0	127783003	4133840		
55763	5117	3001488	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	340118	0	7258-7	3001488		
55780	5117	3005136	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	340071	0	6075-6	3005136		
125817	3879	4024958	1945-06-16	1945-06-16 00:00:00	1945-06-16	5001	0	\N	0	0	\N	\N	0	257696	0	117015009	4024958		
3549	339	3006322	1996-12-16	1996-12-16 00:00:00	1996-12-16	5001	0	\N	0	0	\N	\N	0	22621	0	8331-1	3006322		
5534	525	3045716	1952-05-22	1952-05-22 00:00:00	1952-05-22	5001	0	\N	0	0	\N	\N	0	34958	0	33037-3	3045716		
25384	2333	3006322	2007-02-02	2007-02-02 00:00:00	2007-02-02	5001	0	\N	0	0	\N	\N	0	155208	0	8331-1	3006322		
47448	1446	4024958	2010-09-11	2010-09-11 00:00:00	2010-09-11	5001	0	\N	0	0	\N	\N	0	96361	0	117015009	4024958		
47493	1447	4052083	2009-01-17	2009-01-17 00:00:00	2009-01-17	5001	0	\N	0	0	\N	\N	0	96485	0	23426006	4052083		
156521	4811	4052083	1962-09-16	1962-09-16 00:00:00	1962-09-16	5001	0	\N	0	0	\N	\N	0	320016	0	23426006	4052083		
10272	986	3006322	1978-03-12	1978-03-12 00:00:00	1978-03-12	5001	0	\N	0	0	\N	\N	0	65452	0	8331-1	3006322		
39817	3701	40766240	1970-12-27	1970-12-27 00:00:00	1970-12-27	5001	0	\N	0	0	\N	\N	0	246038	0	63513-6	40766240		
39896	3708	3000876	1978-01-26	1978-01-26 00:00:00	1978-01-26	5001	0	\N	0	0	\N	\N	0	246551	0	6082-2	3000876		
38541	3566	3020655	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	236892	0	6844-5	3020655		
28218	2598	3006322	1985-09-09	1985-09-09 00:00:00	1985-09-09	5001	0	\N	0	0	\N	\N	0	171888	0	8331-1	3006322		
5014	484	3006322	1947-08-16	1947-08-16 00:00:00	1947-08-16	5001	0	\N	0	0	\N	\N	0	32344	0	8331-1	3006322		
5047	489	3006451	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	32787	0	6273-7	3006451		
30359	2779	3006734	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	184124	0	6189-5	3006734		
28953	2672	3006734	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	176924	0	6189-5	3006734		
40327	3752	40766240	1993-07-31	1993-07-31 00:00:00	1993-07-31	5001	0	\N	0	0	\N	\N	0	249304	0	63513-6	40766240		
102991	3167	4024958	2011-09-29	2011-09-29 00:00:00	2011-09-29	5001	0	\N	0	0	\N	\N	0	210589	0	117015009	4024958		
13043	1246	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	82151	0	6095-4	3036780		
13275	1261	3021226	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	83248	0	6246-3	3021226		
3917	388	3006322	1999-09-04	1999-09-04 00:00:00	1999-09-04	5001	0	\N	0	0	\N	\N	0	25570	0	8331-1	3006322		
24708	2270	40758406	1979-11-27	1979-11-27 00:00:00	1979-11-27	5001	0	\N	0	0	\N	\N	0	150951	0	55277-8	40758406		
23503	2168	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	144562	0	6276-0	3027231		
7931	760	3006322	1999-06-20	1999-06-20 00:00:00	1999-06-20	5001	0	\N	0	0	\N	\N	0	50501	0	8331-1	3006322		
34915	3183	3012494	1981-08-20	1981-08-20 00:00:00	1981-08-20	5001	0	\N	0	0	\N	\N	0	211895	0	6206-7	3012494		
52760	4847	3011505	2000-07-12	2000-07-12 00:00:00	2000-07-12	5001	0	\N	0	0	\N	\N	0	322412	0	19926-5	3011505		
38261	3527	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	234021	0	6273-7	3006451		
46401	4274	3049273	2018-04-10	2018-04-10 00:00:00	2018-04-10	5001	0	\N	0	0	\N	\N	0	283563	0	38265-5	3049273		
20044	1843	3006322	1993-10-02	1993-10-02 00:00:00	1993-10-02	5001	0	\N	0	0	\N	\N	0	123058	0	8331-1	3006322		
57905	5317	3006322	2009-10-23	2009-10-23 00:00:00	2009-10-23	5001	0	\N	0	0	\N	\N	0	353677	0	8331-1	3006322		
42360	3913	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	260100	0	6158-0	3019406		
32776	1022	4052083	1982-01-05	1982-01-05 00:00:00	1982-01-05	5001	0	\N	0	0	\N	\N	0	67253	0	23426006	4052083		
165	3	3006322	1991-12-11	1991-12-11 00:00:00	1991-12-11	5001	0	\N	0	0	\N	\N	0	350	0	8331-1	3006322		
43849	4052	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	269336	0	6106-9	3014599		
85139	2636	4024958	1968-03-17	1968-03-17 00:00:00	1968-03-17	5001	0	\N	0	0	\N	\N	0	174484	0	117015009	4024958		
38382	3537	3006322	1989-10-30	1989-10-30 00:00:00	1989-10-30	5001	0	\N	0	0	\N	\N	0	234970	0	8331-1	3006322		
38482	3558	3011505	2017-05-13	2017-05-13 00:00:00	2017-05-13	5001	0	\N	0	0	\N	\N	0	236190	0	19926-5	3011505		
32962	2976	3011505	1990-03-15	1990-03-15 00:00:00	1990-03-15	5001	0	\N	0	0	\N	\N	0	198760	0	19926-5	3011505		
33060	2986	3011505	2007-02-27	2007-02-27 00:00:00	2007-02-27	5001	0	\N	0	0	\N	\N	0	199304	0	19926-5	3011505		
2520	246	3011505	2016-06-02	2016-06-02 00:00:00	2016-06-02	5001	0	\N	0	0	\N	\N	0	16573	0	19926-5	3011505		
41472	1281	4024958	2000-07-09	2000-07-09 00:00:00	2000-07-09	5001	0	\N	0	0	\N	\N	0	84698	0	117015009	4024958		
24608	2264	3006322	2008-01-14	2008-01-14 00:00:00	2008-01-14	5001	0	\N	0	0	\N	\N	0	150476	0	8331-1	3006322		
30576	2798	3006322	1983-11-25	1983-11-25 00:00:00	1983-11-25	5001	0	\N	0	0	\N	\N	0	185453	0	8331-1	3006322		
17857	1618	40758406	1974-10-13	1974-10-13 00:00:00	1974-10-13	5001	0	\N	0	0	\N	\N	0	108797	0	55277-8	40758406		
22148	2033	40766240	1961-07-18	1961-07-18 00:00:00	1961-07-18	5001	0	\N	0	0	\N	\N	0	135372	0	63513-6	40766240		
12826	1223	3006322	1959-12-23	1959-12-23 00:00:00	1959-12-23	5001	0	\N	0	0	\N	\N	0	80449	0	8331-1	3006322		
29350	2702	3006322	1976-12-29	1976-12-29 00:00:00	1976-12-29	5001	0	\N	0	0	\N	\N	0	178964	0	8331-1	3006322		
26524	2448	40758406	1965-09-13	1965-09-13 00:00:00	1965-09-13	5001	0	\N	0	0	\N	\N	0	162362	0	55277-8	40758406		
4979	480	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	32071	0	6082-2	3000876		
37966	3510	3006322	1962-05-27	1962-05-27 00:00:00	1962-05-27	5001	0	\N	0	0	\N	\N	0	232812	0	8331-1	3006322		
29684	2732	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	180879	0	6246-3	3021226		
49447	4506	3051031	1956-02-22	1956-02-22 00:00:00	1956-02-22	5001	0	\N	0	0	\N	\N	0	300203	0	46240-8	3051031		
25126	782	4052083	1911-12-17	1911-12-17 00:00:00	1911-12-17	5001	0	\N	0	0	\N	\N	0	51989	0	23426006	4052083		
39253	3626	46235214	2015-11-08	2015-11-08 00:00:00	2015-11-08	5001	0	\N	0	0	\N	\N	0	241142	0	76690-7	46235214		
19589	1788	3006322	1994-03-28	1994-03-28 00:00:00	1994-03-28	5001	0	\N	0	0	\N	\N	0	119844	0	8331-1	3006322		
48821	4467	3006322	2010-12-29	2010-12-29 00:00:00	2010-12-29	5001	0	\N	0	0	\N	\N	0	297244	0	8331-1	3006322		
21415	1976	3006451	1986-01-15	1986-01-15 00:00:00	1986-01-15	5001	0	\N	0	0	\N	\N	0	131339	0	6273-7	3006451		
32782	2970	3015076	2002-11-07	2002-11-07 00:00:00	2002-11-07	5001	0	\N	0	0	\N	\N	0	198259	0	6248-9	3015076		
125070	3859	4133840	1994-07-23	1994-07-23 00:00:00	1994-07-23	5001	0	\N	0	0	\N	\N	0	256171	0	127783003	4133840		
42562	3930	3011505	1966-12-10	1966-12-10 00:00:00	1966-12-10	5001	0	\N	0	0	\N	\N	0	261293	0	19926-5	3011505		
77278	2369	4024958	2002-09-07	2002-09-07 00:00:00	2002-09-07	5001	0	\N	0	0	\N	\N	0	157646	0	117015009	4024958		
86975	2685	4133840	1999-02-18	1999-02-18 00:00:00	1999-02-18	5001	0	\N	0	0	\N	\N	0	177902	0	127783003	4133840		
55764	5117	3020655	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	340118	0	6844-5	3020655		
55781	5117	3015076	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	340071	0	6248-9	3015076		
94383	2902	4024958	1986-03-17	1986-03-17 00:00:00	1986-03-17	5001	0	\N	0	0	\N	\N	0	193274	0	117015009	4024958		
3550	339	3006322	1993-04-22	1993-04-22 00:00:00	1993-04-22	5001	0	\N	0	0	\N	\N	0	22619	0	8331-1	3006322		
5535	525	3019550	1952-05-22	1952-05-22 00:00:00	1952-05-22	5001	0	\N	0	0	\N	\N	0	34958	0	2951-2	3019550		
25386	2334	3011505	1992-03-05	1992-03-05 00:00:00	1992-03-05	5001	0	\N	0	0	\N	\N	0	155373	0	19926-5	3011505		
47450	1446	4024958	1997-02-15	1997-02-15 00:00:00	1997-02-15	5001	0	\N	0	0	\N	\N	0	96391	0	117015009	4024958		
47523	1447	4024958	1974-01-08	1974-01-08 00:00:00	1974-01-08	5001	0	\N	0	0	\N	\N	0	96459	0	117015009	4024958		
156524	4811	4024958	1969-05-23	1969-05-23 00:00:00	1969-05-23	5001	0	\N	0	0	\N	\N	0	320074	0	117015009	4024958		
10273	986	3006322	1940-01-03	1940-01-03 00:00:00	1940-01-03	5001	0	\N	0	0	\N	\N	0	65448	0	8331-1	3006322		
39818	3701	40758406	1970-12-27	1970-12-27 00:00:00	1970-12-27	5001	0	\N	0	0	\N	\N	0	246038	0	55277-8	40758406		
39897	3708	3036780	1978-01-26	1978-01-26 00:00:00	1978-01-26	5001	0	\N	0	0	\N	\N	0	246551	0	6095-4	3036780		
38542	3566	3001488	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	236892	0	7258-7	3001488		
28219	2599	3006322	1984-01-29	1984-01-29 00:00:00	1984-01-29	5001	0	\N	0	0	\N	\N	0	171989	0	8331-1	3006322		
5015	484	3006322	2007-10-19	2007-10-19 00:00:00	2007-10-19	5001	0	\N	0	0	\N	\N	0	32319	0	8331-1	3006322		
5048	489	3020655	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	32787	0	6844-5	3020655		
30360	2779	3027231	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	184124	0	6276-0	3027231		
28954	2672	3001247	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	176924	0	6085-5	3001247		
40329	3752	40758406	1993-07-31	1993-07-31 00:00:00	1993-07-31	5001	0	\N	0	0	\N	\N	0	249304	0	55277-8	40758406		
102997	3167	4024958	1978-09-14	1978-09-14 00:00:00	1978-09-14	5001	0	\N	0	0	\N	\N	0	210531	0	117015009	4024958		
13044	1246	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	82151	0	6833-8	3023430		
13276	1261	3014599	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	83248	0	6106-9	3014599		
3918	388	3006322	1968-12-31	1968-12-31 00:00:00	1968-12-31	5001	0	\N	0	0	\N	\N	0	25553	0	8331-1	3006322		
24709	2270	3051031	1979-11-27	1979-11-27 00:00:00	1979-11-27	5001	0	\N	0	0	\N	\N	0	150951	0	46240-8	3051031		
23504	2168	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	144562	0	6158-0	3019406		
7932	760	3006322	1971-10-22	1971-10-22 00:00:00	1971-10-22	5001	0	\N	0	0	\N	\N	0	50455	0	8331-1	3006322		
34916	3183	3021226	1981-08-20	1981-08-20 00:00:00	1981-08-20	5001	0	\N	0	0	\N	\N	0	211895	0	6246-3	3021226		
52761	4847	3011505	2003-02-05	2003-02-05 00:00:00	2003-02-05	5001	0	\N	0	0	\N	\N	0	322477	0	19926-5	3011505		
38262	3527	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	234021	0	6276-0	3027231		
46402	4274	3006322	2009-11-10	2009-11-10 00:00:00	2009-11-10	5001	0	\N	0	0	\N	\N	0	283556	0	8331-1	3006322		
20045	1843	3006451	1982-09-26	1982-09-26 00:00:00	1982-09-26	5001	0	\N	0	0	\N	\N	0	123101	0	6273-7	3006451		
57906	5317	3006322	1973-11-03	1973-11-03 00:00:00	1973-11-03	5001	0	\N	0	0	\N	\N	0	353647	0	8331-1	3006322		
42361	3913	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	260100	0	6276-0	3027231		
25460	795	4052083	1965-06-20	1965-06-20 00:00:00	1965-06-20	5001	0	\N	0	0	\N	\N	0	52736	0	23426006	4052083		
166	3	3049273	1986-04-28	1986-04-28 00:00:00	1986-04-28	5001	0	\N	0	0	\N	\N	0	253	0	38265-5	3049273		
43850	4052	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	269336	0	6158-0	3019406		
85142	2636	4052083	2011-11-11	2011-11-11 00:00:00	2011-11-11	5001	0	\N	0	0	\N	\N	0	174468	0	23426006	4052083		
38383	3537	3006322	1998-06-25	1998-06-25 00:00:00	1998-06-25	5001	0	\N	0	0	\N	\N	0	234911	0	8331-1	3006322		
38483	3558	3006322	1977-07-18	1977-07-18 00:00:00	1977-07-18	5001	0	\N	0	0	\N	\N	0	236183	0	8331-1	3006322		
32963	2976	3011505	2016-07-28	2016-07-28 00:00:00	2016-07-28	5001	0	\N	0	0	\N	\N	0	198766	0	19926-5	3011505		
33061	2986	3011505	2018-06-12	2018-06-12 00:00:00	2018-06-12	5001	0	\N	0	0	\N	\N	0	199308	0	19926-5	3011505		
2521	246	3011505	2009-04-23	2009-04-23 00:00:00	2009-04-23	5001	0	\N	0	0	\N	\N	0	16567	0	19926-5	3011505		
41514	1282	4024958	1978-08-23	1978-08-23 00:00:00	1978-08-23	5001	0	\N	0	0	\N	\N	0	84720	0	117015009	4024958		
24609	2264	3006322	2000-04-28	2000-04-28 00:00:00	2000-04-28	5001	0	\N	0	0	\N	\N	0	150446	0	8331-1	3006322		
30577	2799	3006322	2008-05-23	2008-05-23 00:00:00	2008-05-23	5001	0	\N	0	0	\N	\N	0	185499	0	8331-1	3006322		
17858	1618	3006322	2013-08-11	2013-08-11 00:00:00	2013-08-11	5001	0	\N	0	0	\N	\N	0	108812	0	8331-1	3006322		
22149	2033	3051031	1961-07-18	1961-07-18 00:00:00	1961-07-18	5001	0	\N	0	0	\N	\N	0	135372	0	46240-8	3051031		
12827	1223	3006322	1955-06-03	1955-06-03 00:00:00	1955-06-03	5001	0	\N	0	0	\N	\N	0	80510	0	8331-1	3006322		
29351	2702	3006322	1982-12-11	1982-12-11 00:00:00	1982-12-11	5001	0	\N	0	0	\N	\N	0	178960	0	8331-1	3006322		
26526	2448	46235214	1965-09-13	1965-09-13 00:00:00	1965-09-13	5001	0	\N	0	0	\N	\N	0	162362	0	76690-7	46235214		
4980	480	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	32071	0	6844-5	3020655		
37967	3510	3006322	1996-05-19	1996-05-19 00:00:00	1996-05-19	5001	0	\N	0	0	\N	\N	0	232930	0	8331-1	3006322		
29685	2732	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	180879	0	6273-7	3006451		
5528	170	4024958	1973-01-26	1973-01-26 00:00:00	1973-01-26	5001	0	\N	0	0	\N	\N	0	11522	0	117015009	4024958		
25139	782	4052083	1963-11-14	1963-11-14 00:00:00	1963-11-14	5001	0	\N	0	0	\N	\N	0	51982	0	23426006	4052083		
39254	3626	40766240	2015-11-08	2015-11-08 00:00:00	2015-11-08	5001	0	\N	0	0	\N	\N	0	241142	0	63513-6	40766240		
19590	1788	3006322	2018-11-13	2018-11-13 00:00:00	2018-11-13	5001	0	\N	0	0	\N	\N	0	119804	0	8331-1	3006322		
48855	4470	3006322	2015-10-21	2015-10-21 00:00:00	2015-10-21	5001	0	\N	0	0	\N	\N	0	297351	0	8331-1	3006322		
21416	1976	3012494	1986-01-15	1986-01-15 00:00:00	1986-01-15	5001	0	\N	0	0	\N	\N	0	131339	0	6206-7	3012494		
32783	2970	3001247	2002-11-07	2002-11-07 00:00:00	2002-11-07	5001	0	\N	0	0	\N	\N	0	198259	0	6085-5	3001247		
125071	3859	4133840	1992-02-29	1992-02-29 00:00:00	1992-02-29	5001	0	\N	0	0	\N	\N	0	256236	0	127783003	4133840		
42563	3930	3006322	1923-04-18	1923-04-18 00:00:00	1923-04-18	5001	0	\N	0	0	\N	\N	0	261238	0	8331-1	3006322		
146256	4487	4052083	1997-09-04	1997-09-04 00:00:00	1997-09-04	5001	0	\N	0	0	\N	\N	0	298693	0	23426006	4052083		
86979	2685	4133840	2008-04-10	2008-04-10 00:00:00	2008-04-10	5001	0	\N	0	0	\N	\N	0	177904	0	127783003	4133840		
55765	5117	3000876	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	340118	0	6082-2	3000876		
55782	5117	3006451	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	340071	0	6273-7	3006451		
94390	2902	4052083	2005-02-18	2005-02-18 00:00:00	2005-02-18	5001	0	\N	0	0	\N	\N	0	193353	0	23426006	4052083		
3551	339	3006322	1997-03-25	1997-03-25 00:00:00	1997-03-25	5001	0	\N	0	0	\N	\N	0	22622	0	8331-1	3006322		
5536	525	3024731	1952-05-22	1952-05-22 00:00:00	1952-05-22	5001	0	\N	0	0	\N	\N	0	34958	0	30428-7	3024731		
25387	2334	3011505	2003-05-08	2003-05-08 00:00:00	2003-05-08	5001	0	\N	0	0	\N	\N	0	155375	0	19926-5	3011505		
47452	1446	4024958	2004-01-05	2004-01-05 00:00:00	2004-01-05	5001	0	\N	0	0	\N	\N	0	96360	0	117015009	4024958		
150772	4623	4024958	1973-10-21	1973-10-21 00:00:00	1973-10-21	5001	0	\N	0	0	\N	\N	0	307898	0	117015009	4024958		
156537	4811	4024958	1967-10-16	1967-10-16 00:00:00	1967-10-16	5001	0	\N	0	0	\N	\N	0	320073	0	117015009	4024958		
10276	986	3006322	1934-06-21	1934-06-21 00:00:00	1934-06-21	5001	0	\N	0	0	\N	\N	0	65506	0	8331-1	3006322		
39820	3701	3006322	2011-11-07	2011-11-07 00:00:00	2011-11-07	5001	0	\N	0	0	\N	\N	0	246081	0	8331-1	3006322		
39898	3708	3001488	1978-01-26	1978-01-26 00:00:00	1978-01-26	5001	0	\N	0	0	\N	\N	0	246551	0	7258-7	3001488		
38543	3566	3000876	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	236892	0	6082-2	3000876		
28220	2599	3006322	1990-12-06	1990-12-06 00:00:00	1990-12-06	5001	0	\N	0	0	\N	\N	0	171975	0	8331-1	3006322		
5016	484	3006322	2010-06-05	2010-06-05 00:00:00	2010-06-05	5001	0	\N	0	0	\N	\N	0	32381	0	8331-1	3006322		
5049	489	3001488	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	32787	0	7258-7	3001488		
30361	2779	3019406	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	184124	0	6158-0	3019406		
28955	2672	3023430	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	176924	0	6833-8	3023430		
40331	3752	3051031	1994-03-28	1994-03-28 00:00:00	1994-03-28	5001	0	\N	0	0	\N	\N	0	249311	0	46240-8	3051031		
103000	3168	4024958	1988-09-07	1988-09-07 00:00:00	1988-09-07	5001	0	\N	0	0	\N	\N	0	210643	0	117015009	4024958		
13045	1246	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	82151	0	6189-5	3006734		
13277	1261	3020655	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	83248	0	6844-5	3020655		
3919	388	3006322	1962-12-12	1962-12-12 00:00:00	1962-12-12	5001	0	\N	0	0	\N	\N	0	25590	0	8331-1	3006322		
24710	2270	46235214	1979-11-27	1979-11-27 00:00:00	1979-11-27	5001	0	\N	0	0	\N	\N	0	150951	0	76690-7	46235214		
23505	2168	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	144562	0	6273-7	3006451		
7933	760	3006322	1984-05-28	1984-05-28 00:00:00	1984-05-28	5001	0	\N	0	0	\N	\N	0	50499	0	8331-1	3006322		
34917	3183	3019406	1981-08-20	1981-08-20 00:00:00	1981-08-20	5001	0	\N	0	0	\N	\N	0	211895	0	6158-0	3019406		
52762	4847	3011505	1999-07-07	1999-07-07 00:00:00	1999-07-07	5001	0	\N	0	0	\N	\N	0	322448	0	19926-5	3011505		
38263	3527	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	234021	0	7258-7	3001488		
46403	4274	3006322	1986-01-06	1986-01-06 00:00:00	1986-01-06	5001	0	\N	0	0	\N	\N	0	283554	0	8331-1	3006322		
20046	1843	3021226	1982-09-26	1982-09-26 00:00:00	1982-09-26	5001	0	\N	0	0	\N	\N	0	123101	0	6246-3	3021226		
57907	5317	3006322	1984-01-29	1984-01-29 00:00:00	1984-01-29	5001	0	\N	0	0	\N	\N	0	353617	0	8331-1	3006322		
42362	3913	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	260100	0	6095-4	3036780		
130142	4013	4024958	1976-09-09	1976-09-09 00:00:00	1976-09-09	5001	0	\N	0	0	\N	\N	0	266639	0	117015009	4024958		
167	3	3051031	1993-11-04	1993-11-04 00:00:00	1993-11-04	5001	0	\N	0	0	\N	\N	0	320	0	46240-8	3051031		
43851	4052	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	269336	0	6273-7	3006451		
55211	5051	3000876	1990-11-29	1990-11-29 00:00:00	1990-11-29	5001	0	\N	0	0	\N	\N	0	335899	0	6082-2	3000876		
38384	3537	40769194	1961-12-30	1961-12-30 00:00:00	1961-12-30	5001	0	\N	0	0	\N	\N	0	234961	0	66534-9	40769194		
38484	3558	3006322	2009-11-22	2009-11-22 00:00:00	2009-11-22	5001	0	\N	0	0	\N	\N	0	236239	0	8331-1	3006322		
32964	2976	3011505	2006-10-12	2006-10-12 00:00:00	2006-10-12	5001	0	\N	0	0	\N	\N	0	198776	0	19926-5	3011505		
33062	2986	3006322	1946-02-06	1946-02-06 00:00:00	1946-02-06	5001	0	\N	0	0	\N	\N	0	199327	0	8331-1	3006322		
2522	246	3011505	2011-05-05	2011-05-05 00:00:00	2011-05-05	5001	0	\N	0	0	\N	\N	0	16568	0	19926-5	3011505		
52820	1602	4052083	1969-09-04	1969-09-04 00:00:00	1969-09-04	5001	0	\N	0	0	\N	\N	0	107539	0	23426006	4052083		
24610	2264	3006322	1998-11-19	1998-11-19 00:00:00	1998-11-19	5001	0	\N	0	0	\N	\N	0	150435	0	8331-1	3006322		
30578	2799	3006322	1986-06-02	1986-06-02 00:00:00	1986-06-02	5001	0	\N	0	0	\N	\N	0	185504	0	8331-1	3006322		
17861	1618	3051031	1974-12-12	1974-12-12 00:00:00	1974-12-12	5001	0	\N	0	0	\N	\N	0	108825	0	46240-8	3051031		
22151	2033	40758406	2018-01-25	2018-01-25 00:00:00	2018-01-25	5001	0	\N	0	0	\N	\N	0	135324	0	55277-8	40758406		
12828	1223	3006322	1975-12-07	1975-12-07 00:00:00	1975-12-07	5001	0	\N	0	0	\N	\N	0	80452	0	8331-1	3006322		
29352	2702	3006322	1968-07-21	1968-07-21 00:00:00	1968-07-21	5001	0	\N	0	0	\N	\N	0	178996	0	8331-1	3006322		
26527	2448	40766240	1965-09-13	1965-09-13 00:00:00	1965-09-13	5001	0	\N	0	0	\N	\N	0	162362	0	63513-6	40766240		
4981	480	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	32071	0	6246-3	3021226		
37968	3510	3049273	2015-11-27	2015-11-27 00:00:00	2015-11-27	5001	0	\N	0	0	\N	\N	0	232847	0	38265-5	3049273		
29686	2732	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	180879	0	6248-9	3015076		
30756	954	4024958	1984-03-16	1984-03-16 00:00:00	1984-03-16	5001	0	\N	0	0	\N	\N	0	63370	0	117015009	4024958		
128604	3957	4133840	2015-10-29	2015-10-29 00:00:00	2015-10-29	5001	0	\N	0	0	\N	\N	0	263081	0	127783003	4133840		
39255	3626	40758406	2015-11-08	2015-11-08 00:00:00	2015-11-08	5001	0	\N	0	0	\N	\N	0	241142	0	55277-8	40758406		
19591	1788	3006322	1999-05-13	1999-05-13 00:00:00	1999-05-13	5001	0	\N	0	0	\N	\N	0	119827	0	8331-1	3006322		
48856	4470	3006322	1982-09-15	1982-09-15 00:00:00	1982-09-15	5001	0	\N	0	0	\N	\N	0	297332	0	8331-1	3006322		
21417	1976	3014599	1986-01-15	1986-01-15 00:00:00	1986-01-15	5001	0	\N	0	0	\N	\N	0	131339	0	6106-9	3014599		
32784	2970	3020655	2002-11-07	2002-11-07 00:00:00	2002-11-07	5001	0	\N	0	0	\N	\N	0	198259	0	6844-5	3020655		
125073	3859	4133840	2010-10-23	2010-10-23 00:00:00	2010-10-23	5001	0	\N	0	0	\N	\N	0	256181	0	127783003	4133840		
14148	1323	3049273	2016-04-29	2016-04-29 00:00:00	2016-04-29	5001	0	\N	0	0	\N	\N	0	87849	0	38265-5	3049273		
146265	4487	4052083	1990-10-03	1990-10-03 00:00:00	1990-10-03	5001	0	\N	0	0	\N	\N	0	298716	0	23426006	4052083		
86983	2685	4133840	2012-05-03	2012-05-03 00:00:00	2012-05-03	5001	0	\N	0	0	\N	\N	0	177906	0	127783003	4133840		
55766	5117	3006734	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	340118	0	6189-5	3006734		
55783	5117	3023430	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	340071	0	6833-8	3023430		
94419	2902	4024958	1954-01-25	1954-01-25 00:00:00	1954-01-25	5001	0	\N	0	0	\N	\N	0	193263	0	117015009	4024958		
3552	340	3006322	1963-07-21	1963-07-21 00:00:00	1963-07-21	5001	0	\N	0	0	\N	\N	0	22685	0	8331-1	3006322		
5537	525	3006322	1977-10-31	1977-10-31 00:00:00	1977-10-31	5001	0	\N	0	0	\N	\N	0	34973	0	8331-1	3006322		
25388	2334	3011505	1997-04-03	1997-04-03 00:00:00	1997-04-03	5001	0	\N	0	0	\N	\N	0	155300	0	19926-5	3011505		
47457	1447	4052083	1988-09-18	1988-09-18 00:00:00	1988-09-18	5001	0	\N	0	0	\N	\N	0	96428	0	23426006	4052083		
150804	4623	4024958	1942-01-20	1942-01-20 00:00:00	1942-01-20	5001	0	\N	0	0	\N	\N	0	307964	0	117015009	4024958		
156539	4811	4052083	2002-10-31	2002-10-31 00:00:00	2002-10-31	5001	0	\N	0	0	\N	\N	0	320076	0	23426006	4052083		
10277	986	3006322	1992-11-03	1992-11-03 00:00:00	1992-11-03	5001	0	\N	0	0	\N	\N	0	65430	0	8331-1	3006322		
39822	3701	40758406	1971-01-26	1971-01-26 00:00:00	1971-01-26	5001	0	\N	0	0	\N	\N	0	246127	0	55277-8	40758406		
39899	3708	3001247	1978-01-26	1978-01-26 00:00:00	1978-01-26	5001	0	\N	0	0	\N	\N	0	246551	0	6085-5	3001247		
155689	4777	4024958	1970-05-29	1970-05-29 00:00:00	1970-05-29	5001	0	\N	0	0	\N	\N	0	318056	0	117015009	4024958		
28221	2599	3006322	2018-12-25	2018-12-25 00:00:00	2018-12-25	5001	0	\N	0	0	\N	\N	0	171976	0	8331-1	3006322		
5017	484	3006322	2010-02-21	2010-02-21 00:00:00	2010-02-21	5001	0	\N	0	0	\N	\N	0	32312	0	8331-1	3006322		
5050	489	3006734	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	32787	0	6189-5	3006734		
30362	2779	3001488	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	184124	0	7258-7	3001488		
28956	2672	3020655	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	176924	0	6844-5	3020655		
40332	3752	46235214	1994-03-28	1994-03-28 00:00:00	1994-03-28	5001	0	\N	0	0	\N	\N	0	249311	0	76690-7	46235214		
103020	3168	4052083	2012-06-09	2012-06-09 00:00:00	2012-06-09	5001	0	\N	0	0	\N	\N	0	210614	0	23426006	4052083		
13046	1246	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	82151	0	6273-7	3006451		
13278	1261	3006451	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	83248	0	6273-7	3006451		
3920	388	3006322	1975-04-14	1975-04-14 00:00:00	1975-04-14	5001	0	\N	0	0	\N	\N	0	25567	0	8331-1	3006322		
24712	2270	40766240	1979-11-27	1979-11-27 00:00:00	1979-11-27	5001	0	\N	0	0	\N	\N	0	150951	0	63513-6	40766240		
23506	2168	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	144562	0	6106-9	3014599		
7934	761	3015076	1991-12-20	1991-12-20 00:00:00	1991-12-20	5001	0	\N	0	0	\N	\N	0	50594	0	6248-9	3015076		
34918	3183	3015076	1981-08-20	1981-08-20 00:00:00	1981-08-20	5001	0	\N	0	0	\N	\N	0	211895	0	6248-9	3015076		
52763	4847	3011505	1995-06-14	1995-06-14 00:00:00	1995-06-14	5001	0	\N	0	0	\N	\N	0	322456	0	19926-5	3011505		
38264	3527	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	234021	0	6189-5	3006734		
46404	4274	3006322	1993-03-24	1993-03-24 00:00:00	1993-03-24	5001	0	\N	0	0	\N	\N	0	283621	0	8331-1	3006322		
20047	1843	3000876	1982-09-26	1982-09-26 00:00:00	1982-09-26	5001	0	\N	0	0	\N	\N	0	123101	0	6082-2	3000876		
57908	5317	3006322	2008-09-20	2008-09-20 00:00:00	2008-09-20	5001	0	\N	0	0	\N	\N	0	353676	0	8331-1	3006322		
42363	3913	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	260100	0	6082-2	3000876		
130151	4013	4052083	1984-06-28	1984-06-28 00:00:00	1984-06-28	5001	0	\N	0	0	\N	\N	0	266647	0	23426006	4052083		
168	3	40758406	1993-11-04	1993-11-04 00:00:00	1993-11-04	5001	0	\N	0	0	\N	\N	0	320	0	55277-8	40758406		
43852	4052	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	269336	0	6206-7	3012494		
55212	5051	3020655	1990-11-29	1990-11-29 00:00:00	1990-11-29	5001	0	\N	0	0	\N	\N	0	335899	0	6844-5	3020655		
38385	3537	40769184	1961-12-30	1961-12-30 00:00:00	1961-12-30	5001	0	\N	0	0	\N	\N	0	234961	0	66524-0	40769184		
38485	3559	3006322	2001-03-26	2001-03-26 00:00:00	2001-03-26	5001	0	\N	0	0	\N	\N	0	236294	0	8331-1	3006322		
32965	2976	3011505	1987-03-12	1987-03-12 00:00:00	1987-03-12	5001	0	\N	0	0	\N	\N	0	198772	0	19926-5	3011505		
33063	2986	3011505	2017-04-25	2017-04-25 00:00:00	2017-04-25	5001	0	\N	0	0	\N	\N	0	199344	0	19926-5	3011505		
2523	246	3011505	2001-04-05	2001-04-05 00:00:00	2001-04-05	5001	0	\N	0	0	\N	\N	0	16606	0	19926-5	3011505		
52821	1602	4024958	2006-08-07	2006-08-07 00:00:00	2006-08-07	5001	0	\N	0	0	\N	\N	0	107506	0	117015009	4024958		
24611	2264	3006322	1975-04-26	1975-04-26 00:00:00	1975-04-26	5001	0	\N	0	0	\N	\N	0	150458	0	8331-1	3006322		
30583	2801	3006322	1928-12-24	1928-12-24 00:00:00	1928-12-24	5001	0	\N	0	0	\N	\N	0	185569	0	8331-1	3006322		
17862	1618	46235214	1974-12-12	1974-12-12 00:00:00	1974-12-12	5001	0	\N	0	0	\N	\N	0	108825	0	76690-7	46235214		
22152	2033	40766240	2018-01-25	2018-01-25 00:00:00	2018-01-25	5001	0	\N	0	0	\N	\N	0	135324	0	63513-6	40766240		
12829	1223	3006322	1953-04-01	1953-04-01 00:00:00	1953-04-01	5001	0	\N	0	0	\N	\N	0	80475	0	8331-1	3006322		
29353	2702	3006322	1995-12-21	1995-12-21 00:00:00	1995-12-21	5001	0	\N	0	0	\N	\N	0	179032	0	8331-1	3006322		
26528	2448	3051031	1965-09-13	1965-09-13 00:00:00	1965-09-13	5001	0	\N	0	0	\N	\N	0	162362	0	46240-8	3051031		
4982	480	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	32071	0	6273-7	3006451		
37969	3510	3006322	2004-10-18	2004-10-18 00:00:00	2004-10-18	5001	0	\N	0	0	\N	\N	0	232944	0	8331-1	3006322		
29687	2732	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	180879	0	6106-9	3014599		
30760	954	4052083	1978-12-21	1978-12-21 00:00:00	1978-12-21	5001	0	\N	0	0	\N	\N	0	63369	0	23426006	4052083		
128621	3958	4052083	2017-06-26	2017-06-26 00:00:00	2017-06-26	5001	0	\N	0	0	\N	\N	0	263150	0	23426006	4052083		
52474	1590	4024958	1971-11-14	1971-11-14 00:00:00	1971-11-14	5001	0	\N	0	0	\N	\N	0	106700	0	117015009	4024958		
19592	1788	3006322	1976-03-05	1976-03-05 00:00:00	1976-03-05	5001	0	\N	0	0	\N	\N	0	119842	0	8331-1	3006322		
48857	4470	3006322	1999-07-08	1999-07-08 00:00:00	1999-07-08	5001	0	\N	0	0	\N	\N	0	297378	0	8331-1	3006322		
21418	1976	3027231	1986-01-15	1986-01-15 00:00:00	1986-01-15	5001	0	\N	0	0	\N	\N	0	131339	0	6276-0	3027231		
32785	2970	3001488	2002-11-07	2002-11-07 00:00:00	2002-11-07	5001	0	\N	0	0	\N	\N	0	198259	0	7258-7	3001488		
125079	3859	4133840	2009-10-17	2009-10-17 00:00:00	2009-10-17	5001	0	\N	0	0	\N	\N	0	256161	0	127783003	4133840		
14149	1323	3006322	2017-12-18	2017-12-18 00:00:00	2017-12-18	5001	0	\N	0	0	\N	\N	0	87808	0	8331-1	3006322		
146267	4487	4052083	1980-09-01	1980-09-01 00:00:00	1980-09-01	5001	0	\N	0	0	\N	\N	0	298700	0	23426006	4052083		
86985	2685	4133840	1992-11-26	1992-11-26 00:00:00	1992-11-26	5001	0	\N	0	0	\N	\N	0	177928	0	127783003	4133840		
55767	5117	3001247	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	340118	0	6085-5	3001247		
55784	5117	3014599	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	340071	0	6106-9	3014599		
94800	2913	4024958	1956-12-28	1956-12-28 00:00:00	1956-12-28	5001	0	\N	0	0	\N	\N	0	194109	0	117015009	4024958		
3554	340	40758406	1959-08-12	1959-08-12 00:00:00	1959-08-12	5001	0	\N	0	0	\N	\N	0	22721	0	55277-8	40758406		
5538	525	3006322	1997-04-03	1997-04-03 00:00:00	1997-04-03	5001	0	\N	0	0	\N	\N	0	34968	0	8331-1	3006322		
25389	2334	3011505	1978-05-18	1978-05-18 00:00:00	1978-05-18	5001	0	\N	0	0	\N	\N	0	155290	0	19926-5	3011505		
139427	4297	4052083	1977-12-13	1977-12-13 00:00:00	1977-12-13	5001	0	\N	0	0	\N	\N	0	285185	0	23426006	4052083		
150818	4623	4052083	1937-11-30	1937-11-30 00:00:00	1937-11-30	5001	0	\N	0	0	\N	\N	0	308006	0	23426006	4052083		
156543	4811	4024958	1962-06-17	1962-06-17 00:00:00	1962-06-17	5001	0	\N	0	0	\N	\N	0	320071	0	117015009	4024958		
10278	987	3006322	1956-04-20	1956-04-20 00:00:00	1956-04-20	5001	0	\N	0	0	\N	\N	0	65599	0	8331-1	3006322		
39823	3701	40766240	1971-01-26	1971-01-26 00:00:00	1971-01-26	5001	0	\N	0	0	\N	\N	0	246127	0	63513-6	40766240		
39900	3708	3014599	1978-01-26	1978-01-26 00:00:00	1978-01-26	5001	0	\N	0	0	\N	\N	0	246551	0	6106-9	3014599		
167037	5127	4052083	1989-06-28	1989-06-28 00:00:00	1989-06-28	5001	0	\N	0	0	\N	\N	0	340890	0	23426006	4052083		
28240	2602	3006322	1994-11-15	1994-11-15 00:00:00	1994-11-15	5001	0	\N	0	0	\N	\N	0	172159	0	8331-1	3006322		
5018	484	3006322	2001-11-07	2001-11-07 00:00:00	2001-11-07	5001	0	\N	0	0	\N	\N	0	32317	0	8331-1	3006322		
5051	489	3001247	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	32787	0	6085-5	3001247		
30363	2779	3021226	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	184124	0	6246-3	3021226		
28957	2672	3006322	2005-06-02	2005-06-02 00:00:00	2005-06-02	5001	0	\N	0	0	\N	\N	0	176925	0	8331-1	3006322		
40333	3752	40758406	1994-03-28	1994-03-28 00:00:00	1994-03-28	5001	0	\N	0	0	\N	\N	0	249311	0	55277-8	40758406		
103021	3168	4052083	2003-10-17	2003-10-17 00:00:00	2003-10-17	5001	0	\N	0	0	\N	\N	0	210613	0	23426006	4052083		
13047	1246	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	82151	0	6106-9	3014599		
13279	1261	3012494	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	83248	0	6206-7	3012494		
3921	388	3006322	1956-04-07	1956-04-07 00:00:00	1956-04-07	5001	0	\N	0	0	\N	\N	0	25524	0	8331-1	3006322		
24714	2270	3006322	1996-04-12	1996-04-12 00:00:00	1996-04-12	5001	0	\N	0	0	\N	\N	0	150953	0	8331-1	3006322		
23507	2168	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	144562	0	6248-9	3015076		
7935	761	3012494	1991-12-20	1991-12-20 00:00:00	1991-12-20	5001	0	\N	0	0	\N	\N	0	50594	0	6206-7	3012494		
34919	3183	3036780	1981-08-20	1981-08-20 00:00:00	1981-08-20	5001	0	\N	0	0	\N	\N	0	211895	0	6095-4	3036780		
52764	4847	3011505	1987-06-17	1987-06-17 00:00:00	1987-06-17	5001	0	\N	0	0	\N	\N	0	322473	0	19926-5	3011505		
38265	3527	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	234021	0	6085-5	3001247		
46405	4274	3006322	1983-04-13	1983-04-13 00:00:00	1983-04-13	5001	0	\N	0	0	\N	\N	0	283637	0	8331-1	3006322		
20048	1843	3027231	1982-09-26	1982-09-26 00:00:00	1982-09-26	5001	0	\N	0	0	\N	\N	0	123101	0	6276-0	3027231		
27309	855	4024958	1997-03-27	1997-03-27 00:00:00	1997-03-27	5001	0	\N	0	0	\N	\N	0	56469	0	117015009	4024958		
42364	3913	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	260100	0	7258-7	3001488		
130166	4013	4052083	2008-11-10	2008-11-10 00:00:00	2008-11-10	5001	0	\N	0	0	\N	\N	0	266664	0	23426006	4052083		
36411	1131	4024958	1974-10-25	1974-10-25 00:00:00	1974-10-25	5001	0	\N	0	0	\N	\N	0	74452	0	117015009	4024958		
43853	4052	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	269336	0	6189-5	3006734		
55213	5051	3006451	1990-11-29	1990-11-29 00:00:00	1990-11-29	5001	0	\N	0	0	\N	\N	0	335899	0	6273-7	3006451		
38386	3537	40769179	1961-12-30	1961-12-30 00:00:00	1961-12-30	5001	0	\N	0	0	\N	\N	0	234961	0	66519-0	40769179		
49763	4527	3006322	1974-10-12	1974-10-12 00:00:00	1974-10-12	5001	0	\N	0	0	\N	\N	0	301456	0	8331-1	3006322		
32966	2976	3011505	1993-03-18	1993-03-18 00:00:00	1993-03-18	5001	0	\N	0	0	\N	\N	0	198761	0	19926-5	3011505		
33064	2986	3006322	1949-10-12	1949-10-12 00:00:00	1949-10-12	5001	0	\N	0	0	\N	\N	0	199319	0	8331-1	3006322		
2524	246	3011505	2010-04-29	2010-04-29 00:00:00	2010-04-29	5001	0	\N	0	0	\N	\N	0	16514	0	19926-5	3011505		
52826	1602	4024958	1971-11-19	1971-11-19 00:00:00	1971-11-19	5001	0	\N	0	0	\N	\N	0	107540	0	117015009	4024958		
24612	2264	3006322	1981-05-09	1981-05-09 00:00:00	1981-05-09	5001	0	\N	0	0	\N	\N	0	150445	0	8331-1	3006322		
30584	2801	3049273	1984-03-01	1984-03-01 00:00:00	1984-03-01	5001	0	\N	0	0	\N	\N	0	185615	0	38265-5	3049273		
17863	1618	40766240	1974-12-12	1974-12-12 00:00:00	1974-12-12	5001	0	\N	0	0	\N	\N	0	108825	0	63513-6	40766240		
22153	2033	46235214	2018-01-25	2018-01-25 00:00:00	2018-01-25	5001	0	\N	0	0	\N	\N	0	135324	0	76690-7	46235214		
12879	1226	3006322	1990-08-31	1990-08-31 00:00:00	1990-08-31	5001	0	\N	0	0	\N	\N	0	80694	0	8331-1	3006322		
29354	2702	3006322	2017-10-14	2017-10-14 00:00:00	2017-10-14	5001	0	\N	0	0	\N	\N	0	178940	0	8331-1	3006322		
26530	2448	3006322	2000-03-30	2000-03-30 00:00:00	2000-03-30	5001	0	\N	0	0	\N	\N	0	162366	0	8331-1	3006322		
4983	480	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	32071	0	6085-5	3001247		
37970	3510	3006322	2019-05-15	2019-05-15 00:00:00	2019-05-15	5001	0	\N	0	0	\N	\N	0	232833	0	8331-1	3006322		
29688	2732	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	180879	0	6276-0	3027231		
30779	956	4024958	1942-11-11	1942-11-11 00:00:00	1942-11-11	5001	0	\N	0	0	\N	\N	0	63494	0	117015009	4024958		
128626	3958	4052083	1974-02-03	1974-02-03 00:00:00	1974-02-03	5001	0	\N	0	0	\N	\N	0	263179	0	23426006	4052083		
52523	1593	4052083	2014-09-22	2014-09-22 00:00:00	2014-09-22	5001	0	\N	0	0	\N	\N	0	106893	0	23426006	4052083		
19593	1788	3006322	1976-08-17	1976-08-17 00:00:00	1976-08-17	5001	0	\N	0	0	\N	\N	0	119823	0	8331-1	3006322		
48858	4470	3006322	1997-11-04	1997-11-04 00:00:00	1997-11-04	5001	0	\N	0	0	\N	\N	0	297361	0	8331-1	3006322		
21419	1976	3000876	1986-01-15	1986-01-15 00:00:00	1986-01-15	5001	0	\N	0	0	\N	\N	0	131339	0	6082-2	3000876		
32786	2970	3000876	2002-11-07	2002-11-07 00:00:00	2002-11-07	5001	0	\N	0	0	\N	\N	0	198259	0	6082-2	3000876		
125081	3859	4133840	2015-11-21	2015-11-21 00:00:00	2015-11-21	5001	0	\N	0	0	\N	\N	0	256247	0	127783003	4133840		
14150	1323	3006322	1986-07-10	1986-07-10 00:00:00	1986-07-10	5001	0	\N	0	0	\N	\N	0	87870	0	8331-1	3006322		
146271	4487	4052083	1960-05-10	1960-05-10 00:00:00	1960-05-10	5001	0	\N	0	0	\N	\N	0	298698	0	23426006	4052083		
86987	2685	4133840	2004-03-18	2004-03-18 00:00:00	2004-03-18	5001	0	\N	0	0	\N	\N	0	177979	0	127783003	4133840		
55768	5117	3036780	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	340118	0	6095-4	3036780		
55785	5117	3027231	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	340071	0	6276-0	3027231		
94805	2913	4024958	1959-12-27	1959-12-27 00:00:00	1959-12-27	5001	0	\N	0	0	\N	\N	0	194095	0	117015009	4024958		
3555	340	40766240	1959-08-12	1959-08-12 00:00:00	1959-08-12	5001	0	\N	0	0	\N	\N	0	22721	0	63513-6	40766240		
5539	525	3006322	1971-12-08	1971-12-08 00:00:00	1971-12-08	5001	0	\N	0	0	\N	\N	0	35012	0	8331-1	3006322		
25390	2334	3011505	2006-05-25	2006-05-25 00:00:00	2006-05-25	5001	0	\N	0	0	\N	\N	0	155363	0	19926-5	3011505		
139428	4297	4024958	1973-10-06	1973-10-06 00:00:00	1973-10-06	5001	0	\N	0	0	\N	\N	0	285166	0	117015009	4024958		
150827	4623	4024958	1958-02-20	1958-02-20 00:00:00	1958-02-20	5001	0	\N	0	0	\N	\N	0	307927	0	117015009	4024958		
156548	4811	4024958	1967-02-06	1967-02-06 00:00:00	1967-02-06	5001	0	\N	0	0	\N	\N	0	320072	0	117015009	4024958		
10279	987	3006322	1999-09-17	1999-09-17 00:00:00	1999-09-17	5001	0	\N	0	0	\N	\N	0	65601	0	8331-1	3006322		
39824	3701	46235214	1971-01-26	1971-01-26 00:00:00	1971-01-26	5001	0	\N	0	0	\N	\N	0	246127	0	76690-7	46235214		
39901	3708	3005136	1978-01-26	1978-01-26 00:00:00	1978-01-26	5001	0	\N	0	0	\N	\N	0	246551	0	6075-6	3005136		
167041	5127	4052083	1975-12-17	1975-12-17 00:00:00	1975-12-17	5001	0	\N	0	0	\N	\N	0	340888	0	23426006	4052083		
28241	2602	3006322	1998-04-11	1998-04-11 00:00:00	1998-04-11	5001	0	\N	0	0	\N	\N	0	172160	0	8331-1	3006322		
5019	484	3006322	1994-01-26	1994-01-26 00:00:00	1994-01-26	5001	0	\N	0	0	\N	\N	0	32366	0	8331-1	3006322		
5052	489	3000876	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	32787	0	6082-2	3000876		
30364	2779	3014599	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	184124	0	6106-9	3014599		
28958	2672	3006322	1986-05-17	1986-05-17 00:00:00	1986-05-17	5001	0	\N	0	0	\N	\N	0	176985	0	8331-1	3006322		
33890	3081	40758406	1999-04-10	1999-04-10 00:00:00	1999-04-10	5001	0	\N	0	0	\N	\N	0	205160	0	55277-8	40758406		
103043	3170	4024958	1960-01-05	1960-01-05 00:00:00	1960-01-05	5001	0	\N	0	0	\N	\N	0	210722	0	117015009	4024958		
13048	1246	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	82151	0	6248-9	3015076		
13280	1261	3019406	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	83248	0	6158-0	3019406		
3922	388	3006322	1966-12-03	1966-12-03 00:00:00	1966-12-03	5001	0	\N	0	0	\N	\N	0	25591	0	8331-1	3006322		
24715	2270	3006322	2012-05-29	2012-05-29 00:00:00	2012-05-29	5001	0	\N	0	0	\N	\N	0	150921	0	8331-1	3006322		
100848	3098	4052083	1991-07-21	1991-07-21 00:00:00	1991-07-21	5001	0	\N	0	0	\N	\N	0	206205	0	23426006	4052083		
7936	761	3021226	1991-12-20	1991-12-20 00:00:00	1991-12-20	5001	0	\N	0	0	\N	\N	0	50594	0	6246-3	3021226		
34920	3183	3006734	1981-08-20	1981-08-20 00:00:00	1981-08-20	5001	0	\N	0	0	\N	\N	0	211895	0	6189-5	3006734		
52765	4847	3011505	2014-04-02	2014-04-02 00:00:00	2014-04-02	5001	0	\N	0	0	\N	\N	0	322460	0	19926-5	3011505		
38266	3527	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	234021	0	6844-5	3020655		
46406	4274	3049273	2002-07-03	2002-07-03 00:00:00	2002-07-03	5001	0	\N	0	0	\N	\N	0	283562	0	38265-5	3049273		
31326	2863	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	190371	0	6844-5	3020655		
27310	855	4052083	1968-12-22	1968-12-22 00:00:00	1968-12-22	5001	0	\N	0	0	\N	\N	0	56479	0	23426006	4052083		
42365	3913	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	260100	0	6189-5	3006734		
130167	4013	4024958	1989-04-20	1989-04-20 00:00:00	1989-04-20	5001	0	\N	0	0	\N	\N	0	266668	0	117015009	4024958		
36417	1131	4052083	2016-04-05	2016-04-05 00:00:00	2016-04-05	5001	0	\N	0	0	\N	\N	0	74438	0	23426006	4052083		
43854	4052	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	269336	0	6833-8	3023430		
55214	5051	3006734	1990-11-29	1990-11-29 00:00:00	1990-11-29	5001	0	\N	0	0	\N	\N	0	335899	0	6189-5	3006734		
38387	3537	40769189	1961-12-30	1961-12-30 00:00:00	1961-12-30	5001	0	\N	0	0	\N	\N	0	234961	0	66529-9	40769189		
49764	4527	3006322	1963-02-26	1963-02-26 00:00:00	1963-02-26	5001	0	\N	0	0	\N	\N	0	301412	0	8331-1	3006322		
32967	2976	3006322	2011-01-24	2011-01-24 00:00:00	2011-01-24	5001	0	\N	0	0	\N	\N	0	198706	0	8331-1	3006322		
33065	2986	3011505	2004-02-10	2004-02-10 00:00:00	2004-02-10	5001	0	\N	0	0	\N	\N	0	199294	0	19926-5	3011505		
2525	246	3011505	2012-05-10	2012-05-10 00:00:00	2012-05-10	5001	0	\N	0	0	\N	\N	0	16515	0	19926-5	3011505		
98853	3026	4052083	1966-06-09	1966-06-09 00:00:00	1966-06-09	5001	0	\N	0	0	\N	\N	0	201804	0	23426006	4052083		
24613	2264	3006322	2007-10-03	2007-10-03 00:00:00	2007-10-03	5001	0	\N	0	0	\N	\N	0	150475	0	8331-1	3006322		
30585	2801	3006322	1985-06-25	1985-06-25 00:00:00	1985-06-25	5001	0	\N	0	0	\N	\N	0	185649	0	8331-1	3006322		
17864	1618	40758406	1974-12-12	1974-12-12 00:00:00	1974-12-12	5001	0	\N	0	0	\N	\N	0	108825	0	55277-8	40758406		
22155	2033	3051031	2018-01-25	2018-01-25 00:00:00	2018-01-25	5001	0	\N	0	0	\N	\N	0	135324	0	46240-8	3051031		
47524	4370	3006322	2010-07-25	2010-07-25 00:00:00	2010-07-25	5001	0	\N	0	0	\N	\N	0	290144	0	8331-1	3006322		
29355	2702	3006322	1989-02-15	1989-02-15 00:00:00	1989-02-15	5001	0	\N	0	0	\N	\N	0	178968	0	8331-1	3006322		
26536	2450	3006322	1985-11-29	1985-11-29 00:00:00	1985-11-29	5001	0	\N	0	0	\N	\N	0	162501	0	8331-1	3006322		
4984	480	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	32071	0	7258-7	3001488		
37971	3510	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	232905	0	6276-0	3027231		
29689	2732	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	180879	0	6085-5	3001247		
30787	956	4024958	1958-03-01	1958-03-01 00:00:00	1958-03-01	5001	0	\N	0	0	\N	\N	0	63539	0	117015009	4024958		
128637	3958	4024958	1983-03-20	1983-03-20 00:00:00	1983-03-20	5001	0	\N	0	0	\N	\N	0	263148	0	117015009	4024958		
52533	1593	4052083	1976-08-03	1976-08-03 00:00:00	1976-08-03	5001	0	\N	0	0	\N	\N	0	106826	0	23426006	4052083		
19594	1788	3006322	2002-04-09	2002-04-09 00:00:00	2002-04-09	5001	0	\N	0	0	\N	\N	0	119795	0	8331-1	3006322		
48859	4471	40769179	1984-07-13	1984-07-13 00:00:00	1984-07-13	5001	0	\N	0	0	\N	\N	0	297453	0	66519-0	40769179		
21420	1976	3036780	1986-01-15	1986-01-15 00:00:00	1986-01-15	5001	0	\N	0	0	\N	\N	0	131339	0	6095-4	3036780		
32787	2970	3036780	2002-11-07	2002-11-07 00:00:00	2002-11-07	5001	0	\N	0	0	\N	\N	0	198259	0	6095-4	3036780		
125084	3859	4133840	2014-11-15	2014-11-15 00:00:00	2014-11-15	5001	0	\N	0	0	\N	\N	0	256280	0	127783003	4133840		
14157	1325	3006322	2018-05-12	2018-05-12 00:00:00	2018-05-12	5001	0	\N	0	0	\N	\N	0	87963	0	8331-1	3006322		
146276	4487	4024958	2007-06-20	2007-06-20 00:00:00	2007-06-20	5001	0	\N	0	0	\N	\N	0	298696	0	117015009	4024958		
86990	2685	4133840	1991-01-17	1991-01-17 00:00:00	1991-01-17	5001	0	\N	0	0	\N	\N	0	177961	0	127783003	4133840		
55769	5117	3014599	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	340118	0	6106-9	3014599		
55786	5117	3019406	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	340071	0	6158-0	3019406		
83704	2588	4133840	2017-09-17	2017-09-17 00:00:00	2017-09-17	5001	0	\N	0	0	\N	\N	0	171282	0	127783003	4133840		
3556	340	3051031	1959-08-12	1959-08-12 00:00:00	1959-08-12	5001	0	\N	0	0	\N	\N	0	22721	0	46240-8	3051031		
5540	525	3006322	1952-12-18	1952-12-18 00:00:00	1952-12-18	5001	0	\N	0	0	\N	\N	0	34965	0	8331-1	3006322		
25391	2334	3011505	1995-03-23	1995-03-23 00:00:00	1995-03-23	5001	0	\N	0	0	\N	\N	0	155299	0	19926-5	3011505		
139435	4297	4052083	2008-01-28	2008-01-28 00:00:00	2008-01-28	5001	0	\N	0	0	\N	\N	0	285159	0	23426006	4052083		
46211	4260	40758406	1977-07-24	1977-07-24 00:00:00	1977-07-24	5001	0	\N	0	0	\N	\N	0	282786	0	55277-8	40758406		
156552	4811	4052083	1979-01-27	1979-01-27 00:00:00	1979-01-27	5001	0	\N	0	0	\N	\N	0	320075	0	23426006	4052083		
10280	987	3049273	2013-10-27	2013-10-27 00:00:00	2013-10-27	5001	0	\N	0	0	\N	\N	0	65571	0	38265-5	3049273		
39826	3701	3051031	1971-01-26	1971-01-26 00:00:00	1971-01-26	5001	0	\N	0	0	\N	\N	0	246127	0	46240-8	3051031		
39902	3708	3012494	1978-01-26	1978-01-26 00:00:00	1978-01-26	5001	0	\N	0	0	\N	\N	0	246551	0	6206-7	3012494		
28104	2586	3006322	1995-08-31	1995-08-31 00:00:00	1995-08-31	5001	0	\N	0	0	\N	\N	0	171191	0	8331-1	3006322		
28242	2602	3006322	1958-06-13	1958-06-13 00:00:00	1958-06-13	5001	0	\N	0	0	\N	\N	0	172105	0	8331-1	3006322		
5020	484	3006322	1965-05-29	1965-05-29 00:00:00	1965-05-29	5001	0	\N	0	0	\N	\N	0	32377	0	8331-1	3006322		
5053	489	3036780	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	32787	0	6095-4	3036780		
30365	2779	3005136	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	184124	0	6075-6	3005136		
28959	2672	3006322	1986-08-01	1986-08-01 00:00:00	1986-08-01	5001	0	\N	0	0	\N	\N	0	177038	0	8331-1	3006322		
33891	3081	3051031	1999-04-10	1999-04-10 00:00:00	1999-04-10	5001	0	\N	0	0	\N	\N	0	205160	0	46240-8	3051031		
103046	3170	4024958	1969-12-25	1969-12-25 00:00:00	1969-12-25	5001	0	\N	0	0	\N	\N	0	210720	0	117015009	4024958		
13049	1246	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	82151	0	6158-0	3019406		
13281	1261	3005136	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	83248	0	6075-6	3005136		
3924	390	3006322	1988-06-10	1988-06-10 00:00:00	1988-06-10	5001	0	\N	0	0	\N	\N	0	25605	0	8331-1	3006322		
24716	2270	40758406	1979-08-29	1979-08-29 00:00:00	1979-08-29	5001	0	\N	0	0	\N	\N	0	150950	0	55277-8	40758406		
100856	3098	4024958	1972-02-28	1972-02-28 00:00:00	1972-02-28	5001	0	\N	0	0	\N	\N	0	206143	0	117015009	4024958		
7937	761	3036780	1991-12-20	1991-12-20 00:00:00	1991-12-20	5001	0	\N	0	0	\N	\N	0	50594	0	6095-4	3036780		
34921	3183	3023430	1981-08-20	1981-08-20 00:00:00	1981-08-20	5001	0	\N	0	0	\N	\N	0	211895	0	6833-8	3023430		
52766	4847	3011505	1998-07-01	1998-07-01 00:00:00	1998-07-01	5001	0	\N	0	0	\N	\N	0	322411	0	19926-5	3011505		
38267	3527	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	234021	0	6106-9	3014599		
46407	4274	3006322	1964-06-06	1964-06-06 00:00:00	1964-06-06	5001	0	\N	0	0	\N	\N	0	283618	0	8331-1	3006322		
31327	2863	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	190443	0	6189-5	3006734		
27319	856	4024958	2005-04-06	2005-04-06 00:00:00	2005-04-06	5001	0	\N	0	0	\N	\N	0	56539	0	117015009	4024958		
42366	3913	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	260100	0	6085-5	3001247		
130191	4014	4024958	1975-02-18	1975-02-18 00:00:00	1975-02-18	5001	0	\N	0	0	\N	\N	0	266693	0	117015009	4024958		
36423	1131	4052083	1988-01-22	1988-01-22 00:00:00	1988-01-22	5001	0	\N	0	0	\N	\N	0	74444	0	23426006	4052083		
43855	4052	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	269336	0	6246-3	3021226		
55215	5051	3023430	1990-11-29	1990-11-29 00:00:00	1990-11-29	5001	0	\N	0	0	\N	\N	0	335899	0	6833-8	3023430		
38391	3539	3006322	2004-09-23	2004-09-23 00:00:00	2004-09-23	5001	0	\N	0	0	\N	\N	0	235083	0	8331-1	3006322		
49771	4529	3011505	1985-12-01	1985-12-01 00:00:00	1985-12-01	5001	0	\N	0	0	\N	\N	0	301589	0	19926-5	3011505		
32968	2976	3011505	2013-07-11	2013-07-11 00:00:00	2013-07-11	5001	0	\N	0	0	\N	\N	0	198749	0	19926-5	3011505		
33066	2986	3011505	2005-02-15	2005-02-15 00:00:00	2005-02-15	5001	0	\N	0	0	\N	\N	0	199303	0	19926-5	3011505		
2526	246	3006322	1986-08-10	1986-08-10 00:00:00	1986-08-10	5001	0	\N	0	0	\N	\N	0	16580	0	8331-1	3006322		
98855	3026	4052083	1995-11-03	1995-11-03 00:00:00	1995-11-03	5001	0	\N	0	0	\N	\N	0	201768	0	23426006	4052083		
24614	2265	3014599	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	150540	0	6106-9	3014599		
124328	3839	4024958	1979-08-06	1979-08-06 00:00:00	1979-08-06	5001	0	\N	0	0	\N	\N	0	254840	0	117015009	4024958		
17865	1618	40766240	1974-09-13	1974-09-13 00:00:00	1974-09-13	5001	0	\N	0	0	\N	\N	0	108824	0	63513-6	40766240		
22157	2033	46235214	1961-09-16	1961-09-16 00:00:00	1961-09-16	5001	0	\N	0	0	\N	\N	0	135281	0	76690-7	46235214		
47525	4370	3006322	2011-06-02	2011-06-02 00:00:00	2011-06-02	5001	0	\N	0	0	\N	\N	0	290145	0	8331-1	3006322		
29356	2702	3006322	2007-10-10	2007-10-10 00:00:00	2007-10-10	5001	0	\N	0	0	\N	\N	0	178938	0	8331-1	3006322		
26537	2450	3006322	1980-01-17	1980-01-17 00:00:00	1980-01-17	5001	0	\N	0	0	\N	\N	0	162500	0	8331-1	3006322		
4985	480	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	32071	0	6189-5	3006734		
37972	3510	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	232905	0	6158-0	3019406		
29690	2732	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	180879	0	6082-2	3000876		
29691	2732	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	180879	0	6158-0	3019406		
128661	3960	4024958	1980-04-23	1980-04-23 00:00:00	1980-04-23	5001	0	\N	0	0	\N	\N	0	263258	0	117015009	4024958		
8159	776	3006322	1981-10-03	1981-10-03 00:00:00	1981-10-03	5001	0	\N	0	0	\N	\N	0	51527	0	8331-1	3006322		
19595	1788	3006322	2016-12-15	2016-12-15 00:00:00	2016-12-15	5001	0	\N	0	0	\N	\N	0	119776	0	8331-1	3006322		
48860	4471	40769189	1984-07-13	1984-07-13 00:00:00	1984-07-13	5001	0	\N	0	0	\N	\N	0	297453	0	66529-9	40769189		
21421	1976	3023430	1986-01-15	1986-01-15 00:00:00	1986-01-15	5001	0	\N	0	0	\N	\N	0	131339	0	6833-8	3023430		
32788	2970	3019406	2002-11-07	2002-11-07 00:00:00	2002-11-07	5001	0	\N	0	0	\N	\N	0	198259	0	6158-0	3019406		
125086	3859	4133840	2011-10-29	2011-10-29 00:00:00	2011-10-29	5001	0	\N	0	0	\N	\N	0	256245	0	127783003	4133840		
14158	1325	3006322	1999-12-07	1999-12-07 00:00:00	1999-12-07	5001	0	\N	0	0	\N	\N	0	87985	0	8331-1	3006322		
146279	4487	4024958	1975-10-20	1975-10-20 00:00:00	1975-10-20	5001	0	\N	0	0	\N	\N	0	298689	0	117015009	4024958		
86993	2686	4052083	2001-04-17	2001-04-17 00:00:00	2001-04-17	5001	0	\N	0	0	\N	\N	0	178029	0	23426006	4052083		
55770	5117	3027231	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	340118	0	6276-0	3027231		
55787	5117	3021226	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	340071	0	6246-3	3021226		
83706	2588	4052083	1985-09-16	1985-09-16 00:00:00	1985-09-16	5001	0	\N	0	0	\N	\N	0	171277	0	23426006	4052083		
3558	340	46235214	1959-08-12	1959-08-12 00:00:00	1959-08-12	5001	0	\N	0	0	\N	\N	0	22721	0	76690-7	46235214		
5541	525	3006322	1967-03-21	1967-03-21 00:00:00	1967-03-21	5001	0	\N	0	0	\N	\N	0	35041	0	8331-1	3006322		
25392	2334	3011505	1968-05-02	1968-05-02 00:00:00	1968-05-02	5001	0	\N	0	0	\N	\N	0	155332	0	19926-5	3011505		
150719	4622	4024958	1994-11-01	1994-11-01 00:00:00	1994-11-01	5001	0	\N	0	0	\N	\N	0	307806	0	117015009	4024958		
46212	4260	3051031	1977-07-24	1977-07-24 00:00:00	1977-07-24	5001	0	\N	0	0	\N	\N	0	282786	0	46240-8	3051031		
156556	4811	4052083	2006-08-22	2006-08-22 00:00:00	2006-08-22	5001	0	\N	0	0	\N	\N	0	320018	0	23426006	4052083		
10281	987	3006322	2011-07-28	2011-07-28 00:00:00	2011-07-28	5001	0	\N	0	0	\N	\N	0	65586	0	8331-1	3006322		
39827	3701	3006322	2011-07-29	2011-07-29 00:00:00	2011-07-29	5001	0	\N	0	0	\N	\N	0	246045	0	8331-1	3006322		
39903	3708	3015076	1978-01-26	1978-01-26 00:00:00	1978-01-26	5001	0	\N	0	0	\N	\N	0	246551	0	6248-9	3015076		
28105	2586	3006322	1972-09-09	1972-09-09 00:00:00	1972-09-09	5001	0	\N	0	0	\N	\N	0	171206	0	8331-1	3006322		
28243	2602	3006322	2019-06-11	2019-06-11 00:00:00	2019-06-11	5001	0	\N	0	0	\N	\N	0	172161	0	8331-1	3006322		
5023	486	3006322	1986-09-21	1986-09-21 00:00:00	1986-09-21	5001	0	\N	0	0	\N	\N	0	32506	0	8331-1	3006322		
5054	489	3023430	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	32787	0	6833-8	3023430		
30366	2779	3006451	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	184124	0	6273-7	3006451		
28960	2672	3006322	1953-07-15	1953-07-15 00:00:00	1953-07-15	5001	0	\N	0	0	\N	\N	0	176882	0	8331-1	3006322		
33892	3081	40766240	1999-04-10	1999-04-10 00:00:00	1999-04-10	5001	0	\N	0	0	\N	\N	0	205160	0	63513-6	40766240		
103051	3170	4052083	1968-02-22	1968-02-22 00:00:00	1968-02-22	5001	0	\N	0	0	\N	\N	0	210732	0	23426006	4052083		
13050	1246	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	82151	0	6075-6	3005136		
13282	1261	3036780	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	83248	0	6095-4	3036780		
3925	390	3006322	1977-03-29	1977-03-29 00:00:00	1977-03-29	5001	0	\N	0	0	\N	\N	0	25616	0	8331-1	3006322		
24717	2270	3051031	1979-08-29	1979-08-29 00:00:00	1979-08-29	5001	0	\N	0	0	\N	\N	0	150950	0	46240-8	3051031		
100865	3098	4052083	2012-02-09	2012-02-09 00:00:00	2012-02-09	5001	0	\N	0	0	\N	\N	0	206198	0	23426006	4052083		
7938	761	3000876	1991-12-20	1991-12-20 00:00:00	1991-12-20	5001	0	\N	0	0	\N	\N	0	50594	0	6082-2	3000876		
34922	3183	3001488	1981-08-20	1981-08-20 00:00:00	1981-08-20	5001	0	\N	0	0	\N	\N	0	211895	0	7258-7	3001488		
52767	4847	3011505	1997-06-25	1997-06-25 00:00:00	1997-06-25	5001	0	\N	0	0	\N	\N	0	322457	0	19926-5	3011505		
9453	895	3006322	2008-03-20	2008-03-20 00:00:00	2008-03-20	5001	0	\N	0	0	\N	\N	0	59675	0	8331-1	3006322		
46408	4274	3049273	1995-08-25	1995-08-25 00:00:00	1995-08-25	5001	0	\N	0	0	\N	\N	0	283560	0	38265-5	3049273		
31328	2863	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	190443	0	6246-3	3021226		
27340	857	4133840	2002-03-03	2002-03-03 00:00:00	2002-03-03	5001	0	\N	0	0	\N	\N	0	56623	0	127783003	4133840		
42367	3913	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	260100	0	6246-3	3021226		
130207	4014	4052083	1976-09-11	1976-09-11 00:00:00	1976-09-11	5001	0	\N	0	0	\N	\N	0	266768	0	23426006	4052083		
36435	1132	4052083	2002-01-27	2002-01-27 00:00:00	2002-01-27	5001	0	\N	0	0	\N	\N	0	74537	0	23426006	4052083		
55133	5048	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	335420	0	6246-3	3021226		
55216	5051	3015076	1990-11-29	1990-11-29 00:00:00	1990-11-29	5001	0	\N	0	0	\N	\N	0	335899	0	6248-9	3015076		
38392	3539	3006322	2006-04-29	2006-04-29 00:00:00	2006-04-29	5001	0	\N	0	0	\N	\N	0	235101	0	8331-1	3006322		
49772	4529	3006322	1970-03-26	1970-03-26 00:00:00	1970-03-26	5001	0	\N	0	0	\N	\N	0	301547	0	8331-1	3006322		
32969	2976	3011505	2001-07-12	2001-07-12 00:00:00	2001-07-12	5001	0	\N	0	0	\N	\N	0	198763	0	19926-5	3011505		
33067	2986	3011505	1999-01-12	1999-01-12 00:00:00	1999-01-12	5001	0	\N	0	0	\N	\N	0	199313	0	19926-5	3011505		
2527	246	3006322	1964-09-13	1964-09-13 00:00:00	1964-09-13	5001	0	\N	0	0	\N	\N	0	16521	0	8331-1	3006322		
98859	3026	4024958	2004-08-09	2004-08-09 00:00:00	2004-08-09	5001	0	\N	0	0	\N	\N	0	201777	0	117015009	4024958		
24615	2265	3006734	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	150540	0	6189-5	3006734		
127543	3926	4133840	2003-12-01	2003-12-01 00:00:00	2003-12-01	5001	0	\N	0	0	\N	\N	0	260954	0	127783003	4133840		
17868	1618	3051031	1974-09-13	1974-09-13 00:00:00	1974-09-13	5001	0	\N	0	0	\N	\N	0	108824	0	46240-8	3051031		
22159	2033	40758406	1961-09-16	1961-09-16 00:00:00	1961-09-16	5001	0	\N	0	0	\N	\N	0	135281	0	55277-8	40758406		
47526	4370	3006322	1977-04-02	1977-04-02 00:00:00	1977-04-02	5001	0	\N	0	0	\N	\N	0	290142	0	8331-1	3006322		
40634	3772	3014599	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	250687	0	6106-9	3014599		
26538	2450	3000963	1974-12-29	1974-12-29 00:00:00	1974-12-29	5001	0	\N	0	0	\N	\N	0	162503	0	718-7	3000963		
4986	480	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	32071	0	6106-9	3014599		
37973	3510	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	232905	0	6844-5	3020655		
173102	5315	4024958	1944-04-19	1944-04-19 00:00:00	1944-04-19	5001	0	\N	0	0	\N	\N	0	353500	0	117015009	4024958		
29692	2732	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	180879	0	6206-7	3012494		
128664	3960	4052083	1970-11-28	1970-11-28 00:00:00	1970-11-28	5001	0	\N	0	0	\N	\N	0	263290	0	23426006	4052083		
8160	776	3011505	2010-08-12	2010-08-12 00:00:00	2010-08-12	5001	0	\N	0	0	\N	\N	0	51583	0	19926-5	3011505		
19596	1789	3006322	1985-03-07	1985-03-07 00:00:00	1985-03-07	5001	0	\N	0	0	\N	\N	0	119883	0	8331-1	3006322		
48861	4471	40769184	1984-07-13	1984-07-13 00:00:00	1984-07-13	5001	0	\N	0	0	\N	\N	0	297453	0	66524-0	40769184		
21422	1976	3020655	1986-01-15	1986-01-15 00:00:00	1986-01-15	5001	0	\N	0	0	\N	\N	0	131339	0	6844-5	3020655		
32789	2970	3027231	2002-11-07	2002-11-07 00:00:00	2002-11-07	5001	0	\N	0	0	\N	\N	0	198259	0	6276-0	3027231		
125095	3860	4024958	2004-02-02	2004-02-02 00:00:00	2004-02-02	5001	0	\N	0	0	\N	\N	0	256331	0	117015009	4024958		
14159	1325	3006322	1974-03-05	1974-03-05 00:00:00	1974-03-05	5001	0	\N	0	0	\N	\N	0	87957	0	8331-1	3006322		
146280	4487	4052083	1987-09-11	1987-09-11 00:00:00	1987-09-11	5001	0	\N	0	0	\N	\N	0	298715	0	23426006	4052083		
98314	3010	4024958	1975-11-08	1975-11-08 00:00:00	1975-11-08	5001	0	\N	0	0	\N	\N	0	200765	0	117015009	4024958		
55771	5117	3019406	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	340118	0	6158-0	3019406		
55788	5117	3006322	1983-08-17	1983-08-17 00:00:00	1983-08-17	5001	0	\N	0	0	\N	\N	0	340095	0	8331-1	3006322		
83708	2588	4133840	2018-09-23	2018-09-23 00:00:00	2018-09-23	5001	0	\N	0	0	\N	\N	0	171297	0	127783003	4133840		
3560	340	46235214	1959-06-13	1959-06-13 00:00:00	1959-06-13	5001	0	\N	0	0	\N	\N	0	22680	0	76690-7	46235214		
5542	525	3006322	1972-05-21	1972-05-21 00:00:00	1972-05-21	5001	0	\N	0	0	\N	\N	0	34972	0	8331-1	3006322		
25393	2334	3011505	2009-06-11	2009-06-11 00:00:00	2009-06-11	5001	0	\N	0	0	\N	\N	0	155280	0	19926-5	3011505		
150731	4622	4024958	1996-02-08	1996-02-08 00:00:00	1996-02-08	5001	0	\N	0	0	\N	\N	0	307781	0	117015009	4024958		
46213	4260	3006322	1999-06-04	1999-06-04 00:00:00	1999-06-04	5001	0	\N	0	0	\N	\N	0	282788	0	8331-1	3006322		
156564	4812	4024958	1991-02-15	1991-02-15 00:00:00	1991-02-15	5001	0	\N	0	0	\N	\N	0	320136	0	117015009	4024958		
134528	4145	4024958	1983-08-23	1983-08-23 00:00:00	1983-08-23	5001	0	\N	0	0	\N	\N	0	275494	0	117015009	4024958		
39828	3701	3006322	2005-11-15	2005-11-15 00:00:00	2005-11-15	5001	0	\N	0	0	\N	\N	0	246129	0	8331-1	3006322		
39904	3708	3006451	1978-01-26	1978-01-26 00:00:00	1978-01-26	5001	0	\N	0	0	\N	\N	0	246551	0	6273-7	3006451		
28106	2586	3006322	1983-05-11	1983-05-11 00:00:00	1983-05-11	5001	0	\N	0	0	\N	\N	0	171156	0	8331-1	3006322		
28244	2602	3049273	2009-03-25	2009-03-25 00:00:00	2009-03-25	5001	0	\N	0	0	\N	\N	0	172092	0	38265-5	3049273		
5024	486	3006322	1982-08-27	1982-08-27 00:00:00	1982-08-27	5001	0	\N	0	0	\N	\N	0	32460	0	8331-1	3006322		
5055	489	3027231	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	32787	0	6276-0	3027231		
30367	2779	3001247	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	184124	0	6085-5	3001247		
28961	2672	3006322	2012-09-19	2012-09-19 00:00:00	2012-09-19	5001	0	\N	0	0	\N	\N	0	176891	0	8331-1	3006322		
33893	3081	40758406	1999-09-07	1999-09-07 00:00:00	1999-09-07	5001	0	\N	0	0	\N	\N	0	205101	0	55277-8	40758406		
147030	4506	4024958	1980-05-08	1980-05-08 00:00:00	1980-05-08	5001	0	\N	0	0	\N	\N	0	300236	0	117015009	4024958		
13051	1246	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	82151	0	6276-0	3027231		
13283	1261	3001488	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	83248	0	7258-7	3001488		
3928	392	3006322	1991-02-24	1991-02-24 00:00:00	1991-02-24	5001	0	\N	0	0	\N	\N	0	25740	0	8331-1	3006322		
24718	2270	46235214	1979-08-29	1979-08-29 00:00:00	1979-08-29	5001	0	\N	0	0	\N	\N	0	150950	0	76690-7	46235214		
100872	3098	4024958	1963-08-29	1963-08-29 00:00:00	1963-08-29	5001	0	\N	0	0	\N	\N	0	206147	0	117015009	4024958		
7939	761	3006734	1991-12-20	1991-12-20 00:00:00	1991-12-20	5001	0	\N	0	0	\N	\N	0	50594	0	6189-5	3006734		
34923	3183	3006322	1992-05-27	1992-05-27 00:00:00	1992-05-27	5001	0	\N	0	0	\N	\N	0	211931	0	8331-1	3006322		
52768	4847	3011505	2013-03-27	2013-03-27 00:00:00	2013-03-27	5001	0	\N	0	0	\N	\N	0	322420	0	19926-5	3011505		
9454	895	3006322	2005-10-10	2005-10-10 00:00:00	2005-10-10	5001	0	\N	0	0	\N	\N	0	59684	0	8331-1	3006322		
46409	4274	3006322	1989-09-30	1989-09-30 00:00:00	1989-09-30	5001	0	\N	0	0	\N	\N	0	283640	0	8331-1	3006322		
31329	2863	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	190443	0	6248-9	3015076		
27341	857	4133840	2007-04-01	2007-04-01 00:00:00	2007-04-01	5001	0	\N	0	0	\N	\N	0	56589	0	127783003	4133840		
42368	3913	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	260100	0	6106-9	3014599		
130209	4014	4024958	2006-08-29	2006-08-29 00:00:00	2006-08-29	5001	0	\N	0	0	\N	\N	0	266750	0	117015009	4024958		
36446	1132	4052083	1972-08-23	1972-08-23 00:00:00	1972-08-23	5001	0	\N	0	0	\N	\N	0	74491	0	23426006	4052083		
55134	5048	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	335420	0	6082-2	3000876		
55217	5051	3001247	1990-11-29	1990-11-29 00:00:00	1990-11-29	5001	0	\N	0	0	\N	\N	0	335899	0	6085-5	3001247		
38393	3539	3006322	1999-06-07	1999-06-07 00:00:00	1999-06-07	5001	0	\N	0	0	\N	\N	0	235104	0	8331-1	3006322		
49773	4529	3011505	2007-12-02	2007-12-02 00:00:00	2007-12-02	5001	0	\N	0	0	\N	\N	0	301591	0	19926-5	3011505		
32970	2976	3011505	1984-03-08	1984-03-08 00:00:00	1984-03-08	5001	0	\N	0	0	\N	\N	0	198771	0	19926-5	3011505		
33068	2986	3008598	2015-09-23	2015-09-23 00:00:00	2015-09-23	5001	0	\N	0	0	\N	\N	0	199350	0	3024-7	3008598		
145797	4476	4052083	2008-08-03	2008-08-03 00:00:00	2008-08-03	5001	0	\N	0	0	\N	\N	0	297801	0	23426006	4052083		
98892	3028	4024958	1968-05-06	1968-05-06 00:00:00	1968-05-06	5001	0	\N	0	0	\N	\N	0	201878	0	117015009	4024958		
24616	2265	3012494	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	150540	0	6206-7	3012494		
127546	3926	4133840	1988-10-03	1988-10-03 00:00:00	1988-10-03	5001	0	\N	0	0	\N	\N	0	260950	0	127783003	4133840		
17869	1618	40758406	1974-09-13	1974-09-13 00:00:00	1974-09-13	5001	0	\N	0	0	\N	\N	0	108824	0	55277-8	40758406		
22160	2033	40766240	1961-09-16	1961-09-16 00:00:00	1961-09-16	5001	0	\N	0	0	\N	\N	0	135281	0	63513-6	40766240		
47527	4370	3006322	1968-04-04	1968-04-04 00:00:00	1968-04-04	5001	0	\N	0	0	\N	\N	0	290111	0	8331-1	3006322		
40635	3772	3015076	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	250687	0	6248-9	3015076		
26539	2450	3009542	1974-12-29	1974-12-29 00:00:00	1974-12-29	5001	0	\N	0	0	\N	\N	0	162503	0	20570-8	3009542		
4987	480	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	32071	0	6833-8	3023430		
37974	3510	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	232905	0	6085-5	3001247		
173113	5316	4052083	2014-12-10	2014-12-10 00:00:00	2014-12-10	5001	0	\N	0	0	\N	\N	0	353543	0	23426006	4052083		
29693	2732	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	180879	0	6095-4	3036780		
128675	3960	4052083	1966-09-30	1966-09-30 00:00:00	1966-09-30	5001	0	\N	0	0	\N	\N	0	263289	0	23426006	4052083		
8161	776	3006322	1978-08-05	1978-08-05 00:00:00	1978-08-05	5001	0	\N	0	0	\N	\N	0	51558	0	8331-1	3006322		
19597	1789	3006322	2015-05-23	2015-05-23 00:00:00	2015-05-23	5001	0	\N	0	0	\N	\N	0	119931	0	8331-1	3006322		
48862	4471	40769194	1984-07-13	1984-07-13 00:00:00	1984-07-13	5001	0	\N	0	0	\N	\N	0	297453	0	66534-9	40769194		
21423	1976	3001247	1986-01-15	1986-01-15 00:00:00	1986-01-15	5001	0	\N	0	0	\N	\N	0	131339	0	6085-5	3001247		
32790	2970	3012494	2002-11-07	2002-11-07 00:00:00	2002-11-07	5001	0	\N	0	0	\N	\N	0	198259	0	6206-7	3012494		
125098	3860	4024958	2012-04-12	2012-04-12 00:00:00	2012-04-12	5001	0	\N	0	0	\N	\N	0	256332	0	117015009	4024958		
14160	1325	3006322	1965-09-07	1965-09-07 00:00:00	1965-09-07	5001	0	\N	0	0	\N	\N	0	87956	0	8331-1	3006322		
146282	4487	4052083	1984-11-17	1984-11-17 00:00:00	1984-11-17	5001	0	\N	0	0	\N	\N	0	298691	0	23426006	4052083		
28617	2647	3012494	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	175217	0	6206-7	3012494		
55772	5117	3023430	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	340118	0	6833-8	3023430		
55789	5118	3006322	1968-11-27	1968-11-27 00:00:00	1968-11-27	5001	0	\N	0	0	\N	\N	0	340210	0	8331-1	3006322		
83712	2588	4024958	1993-07-02	1993-07-02 00:00:00	1993-07-02	5001	0	\N	0	0	\N	\N	0	171265	0	117015009	4024958		
3561	340	40758406	1959-06-13	1959-06-13 00:00:00	1959-06-13	5001	0	\N	0	0	\N	\N	0	22680	0	55277-8	40758406		
5543	526	3006322	1986-04-08	1986-04-08 00:00:00	1986-04-08	5001	0	\N	0	0	\N	\N	0	35095	0	8331-1	3006322		
25394	2334	3011505	1998-04-09	1998-04-09 00:00:00	1998-04-09	5001	0	\N	0	0	\N	\N	0	155278	0	19926-5	3011505		
150732	4622	4052083	1983-01-06	1983-01-06 00:00:00	1983-01-06	5001	0	\N	0	0	\N	\N	0	307833	0	23426006	4052083		
46214	4260	3006322	1939-01-27	1939-01-27 00:00:00	1939-01-27	5001	0	\N	0	0	\N	\N	0	282762	0	8331-1	3006322		
156569	4812	4024958	1999-05-31	1999-05-31 00:00:00	1999-05-31	5001	0	\N	0	0	\N	\N	0	320137	0	117015009	4024958		
8593	273	4052083	1980-11-17	1980-11-17 00:00:00	1980-11-17	5001	0	\N	0	0	\N	\N	0	18194	0	23426006	4052083		
39829	3701	3006322	1968-06-12	1968-06-12 00:00:00	1968-06-12	5001	0	\N	0	0	\N	\N	0	246125	0	8331-1	3006322		
39905	3708	3020655	1978-01-26	1978-01-26 00:00:00	1978-01-26	5001	0	\N	0	0	\N	\N	0	246551	0	6844-5	3020655		
28107	2586	3006322	2013-07-22	2013-07-22 00:00:00	2013-07-22	5001	0	\N	0	0	\N	\N	0	171192	0	8331-1	3006322		
28245	2602	3006322	2009-11-20	2009-11-20 00:00:00	2009-11-20	5001	0	\N	0	0	\N	\N	0	172133	0	8331-1	3006322		
5025	486	3006322	1979-05-29	1979-05-29 00:00:00	1979-05-29	5001	0	\N	0	0	\N	\N	0	32459	0	8331-1	3006322		
5056	489	3021226	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	32787	0	6246-3	3021226		
30368	2779	3036780	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	184124	0	6095-4	3036780		
28962	2673	3006322	2010-03-27	2010-03-27 00:00:00	2010-03-27	5001	0	\N	0	0	\N	\N	0	177060	0	8331-1	3006322		
33894	3081	3051031	1999-09-07	1999-09-07 00:00:00	1999-09-07	5001	0	\N	0	0	\N	\N	0	205101	0	46240-8	3051031		
147088	4509	4052083	1970-04-16	1970-04-16 00:00:00	1970-04-16	5001	0	\N	0	0	\N	\N	0	300383	0	23426006	4052083		
13052	1246	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	82151	0	7258-7	3001488		
13284	1261	3000876	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	83248	0	6082-2	3000876		
3929	392	3006322	1985-12-11	1985-12-11 00:00:00	1985-12-11	5001	0	\N	0	0	\N	\N	0	25714	0	8331-1	3006322		
24720	2270	40766240	1979-08-29	1979-08-29 00:00:00	1979-08-29	5001	0	\N	0	0	\N	\N	0	150950	0	63513-6	40766240		
100879	3098	4052083	1973-12-04	1973-12-04 00:00:00	1973-12-04	5001	0	\N	0	0	\N	\N	0	206148	0	23426006	4052083		
7940	761	3020655	1991-12-20	1991-12-20 00:00:00	1991-12-20	5001	0	\N	0	0	\N	\N	0	50594	0	6844-5	3020655		
34924	3184	3006322	2015-12-26	2015-12-26 00:00:00	2015-12-26	5001	0	\N	0	0	\N	\N	0	211976	0	8331-1	3006322		
52769	4847	3011505	1989-06-21	1989-06-21 00:00:00	1989-06-21	5001	0	\N	0	0	\N	\N	0	322410	0	19926-5	3011505		
9455	895	3006322	2011-10-15	2011-10-15 00:00:00	2011-10-15	5001	0	\N	0	0	\N	\N	0	59721	0	8331-1	3006322		
46410	4274	3006322	1960-05-16	1960-05-16 00:00:00	1960-05-16	5001	0	\N	0	0	\N	\N	0	283636	0	8331-1	3006322		
31330	2863	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	190443	0	7258-7	3001488		
27342	857	4133840	2005-03-20	2005-03-20 00:00:00	2005-03-20	5001	0	\N	0	0	\N	\N	0	56588	0	127783003	4133840		
42369	3913	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	260100	0	6273-7	3006451		
86803	2682	4024958	1982-02-11	1982-02-11 00:00:00	1982-02-11	5001	0	\N	0	0	\N	\N	0	177727	0	117015009	4024958		
36448	1132	4024958	1959-05-05	1959-05-05 00:00:00	1959-05-05	5001	0	\N	0	0	\N	\N	0	74505	0	117015009	4024958		
55135	5048	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	335420	0	6833-8	3023430		
55218	5051	3014599	1990-11-29	1990-11-29 00:00:00	1990-11-29	5001	0	\N	0	0	\N	\N	0	335899	0	6106-9	3014599		
38394	3540	3006322	1975-11-23	1975-11-23 00:00:00	1975-11-23	5001	0	\N	0	0	\N	\N	0	235112	0	8331-1	3006322		
49774	4529	40758406	1986-12-11	1986-12-11 00:00:00	1986-12-11	5001	0	\N	0	0	\N	\N	0	301550	0	55277-8	40758406		
32971	2976	3006322	1956-08-20	1956-08-20 00:00:00	1956-08-20	5001	0	\N	0	0	\N	\N	0	198744	0	8331-1	3006322		
33069	2986	3009201	2015-09-23	2015-09-23 00:00:00	2015-09-23	5001	0	\N	0	0	\N	\N	0	199350	0	3016-3	3009201		
145801	4476	4052083	2003-03-08	2003-03-08 00:00:00	2003-03-08	5001	0	\N	0	0	\N	\N	0	297857	0	23426006	4052083		
44436	4107	3006322	2005-08-07	2005-08-07 00:00:00	2005-08-07	5001	0	\N	0	0	\N	\N	0	272909	0	8331-1	3006322		
24617	2265	3000876	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	150540	0	6082-2	3000876		
127547	3926	4133840	2016-07-18	2016-07-18 00:00:00	2016-07-18	5001	0	\N	0	0	\N	\N	0	261005	0	127783003	4133840		
17870	1618	46235214	1974-09-13	1974-09-13 00:00:00	1974-09-13	5001	0	\N	0	0	\N	\N	0	108824	0	76690-7	46235214		
22161	2033	3051031	1961-09-16	1961-09-16 00:00:00	1961-09-16	5001	0	\N	0	0	\N	\N	0	135281	0	46240-8	3051031		
47537	4372	3021226	1981-01-19	1981-01-19 00:00:00	1981-01-19	5001	0	\N	0	0	\N	\N	0	290260	0	6246-3	3021226		
40636	3772	3006451	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	250687	0	6273-7	3006451		
26540	2450	3006322	1974-05-07	1974-05-07 00:00:00	1974-05-07	5001	0	\N	0	0	\N	\N	0	162490	0	8331-1	3006322		
4988	480	3006322	2017-06-17	2017-06-17 00:00:00	2017-06-17	5001	0	\N	0	0	\N	\N	0	32093	0	8331-1	3006322		
37975	3510	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	232905	0	6189-5	3006734		
47747	1454	4052083	1979-01-02	1979-01-02 00:00:00	1979-01-02	5001	0	\N	0	0	\N	\N	0	96976	0	23426006	4052083		
29694	2732	3006322	2013-11-16	2013-11-16 00:00:00	2013-11-16	5001	0	\N	0	0	\N	\N	0	180833	0	8331-1	3006322		
128684	3961	4024958	1989-06-28	1989-06-28 00:00:00	1989-06-28	5001	0	\N	0	0	\N	\N	0	263328	0	117015009	4024958		
8162	776	3011505	2012-08-23	2012-08-23 00:00:00	2012-08-23	5001	0	\N	0	0	\N	\N	0	51557	0	19926-5	3011505		
19598	1789	3027231	1976-03-06	1976-03-06 00:00:00	1976-03-06	5001	0	\N	0	0	\N	\N	0	119926	0	6276-0	3027231		
48864	4471	3006322	1975-04-27	1975-04-27 00:00:00	1975-04-27	5001	0	\N	0	0	\N	\N	0	297429	0	8331-1	3006322		
21424	1976	3006734	1986-01-15	1986-01-15 00:00:00	1986-01-15	5001	0	\N	0	0	\N	\N	0	131339	0	6189-5	3006734		
32791	2970	3021226	2002-11-07	2002-11-07 00:00:00	2002-11-07	5001	0	\N	0	0	\N	\N	0	198259	0	6246-3	3021226		
125105	3860	4024958	1993-10-11	1993-10-11 00:00:00	1993-10-11	5001	0	\N	0	0	\N	\N	0	256330	0	117015009	4024958		
14161	1325	3006322	2002-03-12	2002-03-12 00:00:00	2002-03-12	5001	0	\N	0	0	\N	\N	0	87972	0	8331-1	3006322		
146291	4488	4052083	1986-12-07	1986-12-07 00:00:00	1986-12-07	5001	0	\N	0	0	\N	\N	0	298821	0	23426006	4052083		
28618	2647	3006322	1977-02-23	1977-02-23 00:00:00	1977-02-23	5001	0	\N	0	0	\N	\N	0	175111	0	8331-1	3006322		
55773	5117	3000876	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	340071	0	6082-2	3000876		
55790	5118	3006322	1989-03-07	1989-03-07 00:00:00	1989-03-07	5001	0	\N	0	0	\N	\N	0	340221	0	8331-1	3006322		
83721	2588	4133840	2012-10-14	2012-10-14 00:00:00	2012-10-14	5001	0	\N	0	0	\N	\N	0	171263	0	127783003	4133840		
3562	340	40766240	1959-06-13	1959-06-13 00:00:00	1959-06-13	5001	0	\N	0	0	\N	\N	0	22680	0	63513-6	40766240		
87609	2708	4024958	1990-05-02	1990-05-02 00:00:00	1990-05-02	5001	0	\N	0	0	\N	\N	0	179353	0	117015009	4024958		
16836	1532	3006322	2018-09-27	2018-09-27 00:00:00	2018-09-27	5001	0	\N	0	0	\N	\N	0	102611	0	8331-1	3006322		
34852	3181	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	211757	0	6189-5	3006734		
46215	4261	3006322	2016-11-08	2016-11-08 00:00:00	2016-11-08	5001	0	\N	0	0	\N	\N	0	282944	0	8331-1	3006322		
156574	4812	4024958	1955-04-13	1955-04-13 00:00:00	1955-04-13	5001	0	\N	0	0	\N	\N	0	320134	0	117015009	4024958		
8605	273	4024958	2005-09-26	2005-09-26 00:00:00	2005-09-26	5001	0	\N	0	0	\N	\N	0	18242	0	117015009	4024958		
39830	3701	3006322	1955-07-23	1955-07-23 00:00:00	1955-07-23	5001	0	\N	0	0	\N	\N	0	246055	0	8331-1	3006322		
39906	3708	3021226	1978-01-26	1978-01-26 00:00:00	1978-01-26	5001	0	\N	0	0	\N	\N	0	246551	0	6246-3	3021226		
28108	2588	3011505	2016-09-11	2016-09-11 00:00:00	2016-09-11	5001	0	\N	0	0	\N	\N	0	171296	0	19926-5	3011505		
28246	2603	3006322	1988-10-12	1988-10-12 00:00:00	1988-10-12	5001	0	\N	0	0	\N	\N	0	172224	0	8331-1	3006322		
5026	486	3006322	2004-03-29	2004-03-29 00:00:00	2004-03-29	5001	0	\N	0	0	\N	\N	0	32472	0	8331-1	3006322		
5057	489	3005136	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	32787	0	6075-6	3005136		
30369	2779	3023430	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	184124	0	6833-8	3023430		
28963	2673	3005136	1990-02-12	1990-02-12 00:00:00	1990-02-12	5001	0	\N	0	0	\N	\N	0	177114	0	6075-6	3005136		
33895	3081	40766240	1999-09-07	1999-09-07 00:00:00	1999-09-07	5001	0	\N	0	0	\N	\N	0	205101	0	63513-6	40766240		
147090	4509	4133840	2013-09-17	2013-09-17 00:00:00	2013-09-17	5001	0	\N	0	0	\N	\N	0	300373	0	127783003	4133840		
13053	1246	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	82151	0	6206-7	3012494		
13285	1261	3006734	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	83248	0	6189-5	3006734		
3930	392	3006322	1997-01-06	1997-01-06 00:00:00	1997-01-06	5001	0	\N	0	0	\N	\N	0	25741	0	8331-1	3006322		
24722	2270	3006322	1979-05-30	1979-05-30 00:00:00	1979-05-30	5001	0	\N	0	0	\N	\N	0	150981	0	8331-1	3006322		
53688	4927	3006322	1994-11-29	1994-11-29 00:00:00	1994-11-29	5001	0	\N	0	0	\N	\N	0	327485	0	8331-1	3006322		
7941	761	3001247	1991-12-20	1991-12-20 00:00:00	1991-12-20	5001	0	\N	0	0	\N	\N	0	50594	0	6085-5	3001247		
34925	3184	3006322	2011-01-11	2011-01-11 00:00:00	2011-01-11	5001	0	\N	0	0	\N	\N	0	211963	0	8331-1	3006322		
52770	4847	3011505	1981-01-28	1981-01-28 00:00:00	1981-01-28	5001	0	\N	0	0	\N	\N	0	322415	0	19926-5	3011505		
9456	895	3006322	2007-08-11	2007-08-11 00:00:00	2007-08-11	5001	0	\N	0	0	\N	\N	0	59674	0	8331-1	3006322		
46411	4274	3006322	1930-03-10	1930-03-10 00:00:00	1930-03-10	5001	0	\N	0	0	\N	\N	0	283661	0	8331-1	3006322		
31331	2863	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	190443	0	6276-0	3027231		
96124	2945	4133840	2005-09-13	2005-09-13 00:00:00	2005-09-13	5001	0	\N	0	0	\N	\N	0	196488	0	127783003	4133840		
42370	3913	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	260100	0	6206-7	3012494		
86804	2682	4024958	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	177758	0	117015009	4024958		
723	49	3006322	1973-03-08	1973-03-08 00:00:00	1973-03-08	5001	0	\N	0	0	\N	\N	0	3531	0	8331-1	3006322		
55136	5049	3006322	1977-06-15	1977-06-15 00:00:00	1977-06-15	5001	0	\N	0	0	\N	\N	0	335575	0	8331-1	3006322		
55219	5051	3019406	1990-11-29	1990-11-29 00:00:00	1990-11-29	5001	0	\N	0	0	\N	\N	0	335899	0	6158-0	3019406		
38395	3540	3006322	1982-05-10	1982-05-10 00:00:00	1982-05-10	5001	0	\N	0	0	\N	\N	0	235143	0	8331-1	3006322		
49776	4529	46235214	1986-12-11	1986-12-11 00:00:00	1986-12-11	5001	0	\N	0	0	\N	\N	0	301550	0	76690-7	46235214		
32972	2976	3011505	2018-08-09	2018-08-09 00:00:00	2018-08-09	5001	0	\N	0	0	\N	\N	0	198767	0	19926-5	3011505		
33070	2986	3011505	2001-01-23	2001-01-23 00:00:00	2001-01-23	5001	0	\N	0	0	\N	\N	0	199314	0	19926-5	3011505		
145810	4476	4052083	1962-04-21	1962-04-21 00:00:00	1962-04-21	5001	0	\N	0	0	\N	\N	0	297891	0	23426006	4052083		
44484	4109	40769179	1965-05-08	1965-05-08 00:00:00	1965-05-08	5001	0	\N	0	0	\N	\N	0	273125	0	66519-0	40769179		
24618	2265	3019406	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	150540	0	6158-0	3019406		
127550	3926	4133840	2004-12-06	2004-12-06 00:00:00	2004-12-06	5001	0	\N	0	0	\N	\N	0	261003	0	127783003	4133840		
17879	1622	3006322	1997-09-20	1997-09-20 00:00:00	1997-09-20	5001	0	\N	0	0	\N	\N	0	108996	0	8331-1	3006322		
22163	2033	3006322	2017-07-25	2017-07-25 00:00:00	2017-07-25	5001	0	\N	0	0	\N	\N	0	135339	0	8331-1	3006322		
47538	4372	3005136	1981-01-19	1981-01-19 00:00:00	1981-01-19	5001	0	\N	0	0	\N	\N	0	290260	0	6075-6	3005136		
40637	3772	3021226	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	250687	0	6246-3	3021226		
26541	2450	3006322	2009-02-26	2009-02-26 00:00:00	2009-02-26	5001	0	\N	0	0	\N	\N	0	162505	0	8331-1	3006322		
4989	480	3006322	1945-06-20	1945-06-20 00:00:00	1945-06-20	5001	0	\N	0	0	\N	\N	0	32123	0	8331-1	3006322		
37976	3510	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	232905	0	6075-6	3005136		
47751	1454	4052083	1989-12-23	1989-12-23 00:00:00	1989-12-23	5001	0	\N	0	0	\N	\N	0	96987	0	23426006	4052083		
29701	2736	3006322	1976-05-04	1976-05-04 00:00:00	1976-05-04	5001	0	\N	0	0	\N	\N	0	181117	0	8331-1	3006322		
37055	1146	4024958	1990-12-26	1990-12-26 00:00:00	1990-12-26	5001	0	\N	0	0	\N	\N	0	75670	0	117015009	4024958		
8163	776	3011505	2018-09-27	2018-09-27 00:00:00	2018-09-27	5001	0	\N	0	0	\N	\N	0	51596	0	19926-5	3011505		
19599	1789	3015076	1976-03-06	1976-03-06 00:00:00	1976-03-06	5001	0	\N	0	0	\N	\N	0	119926	0	6248-9	3015076		
48865	4472	3049273	2005-11-13	2005-11-13 00:00:00	2005-11-13	5001	0	\N	0	0	\N	\N	0	297546	0	38265-5	3049273		
21425	1976	3005136	1986-01-15	1986-01-15 00:00:00	1986-01-15	5001	0	\N	0	0	\N	\N	0	131339	0	6075-6	3005136		
32792	2970	3005136	2002-11-07	2002-11-07 00:00:00	2002-11-07	5001	0	\N	0	0	\N	\N	0	198259	0	6075-6	3005136		
125107	3860	4052083	2014-02-07	2014-02-07 00:00:00	2014-02-07	5001	0	\N	0	0	\N	\N	0	256283	0	23426006	4052083		
14162	1325	3006322	2009-11-14	2009-11-14 00:00:00	2009-11-14	5001	0	\N	0	0	\N	\N	0	87962	0	8331-1	3006322		
146292	4488	4024958	1989-11-25	1989-11-25 00:00:00	1989-11-25	5001	0	\N	0	0	\N	\N	0	298822	0	117015009	4024958		
28619	2647	3000876	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	175206	0	6082-2	3000876		
55774	5117	3006734	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	340071	0	6189-5	3006734		
55791	5118	3006322	1987-09-01	1987-09-01 00:00:00	1987-09-01	5001	0	\N	0	0	\N	\N	0	340164	0	8331-1	3006322		
83726	2588	4133840	2014-08-31	2014-08-31 00:00:00	2014-08-31	5001	0	\N	0	0	\N	\N	0	171306	0	127783003	4133840		
3563	340	3051031	1959-06-13	1959-06-13 00:00:00	1959-06-13	5001	0	\N	0	0	\N	\N	0	22680	0	46240-8	3051031		
87620	2708	4052083	1968-03-05	1968-03-05 00:00:00	1968-03-05	5001	0	\N	0	0	\N	\N	0	179417	0	23426006	4052083		
16837	1533	3006322	2015-07-31	2015-07-31 00:00:00	2015-07-31	5001	0	\N	0	0	\N	\N	0	102650	0	8331-1	3006322		
34853	3181	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	211757	0	6844-5	3020655		
46218	4261	3051031	1956-10-29	1956-10-29 00:00:00	1956-10-29	5001	0	\N	0	0	\N	\N	0	282865	0	46240-8	3051031		
156576	4812	4024958	1963-05-10	1963-05-10 00:00:00	1963-05-10	5001	0	\N	0	0	\N	\N	0	320184	0	117015009	4024958		
8639	273	4052083	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	18296	0	23426006	4052083		
39831	3701	3006322	1959-12-16	1959-12-16 00:00:00	1959-12-16	5001	0	\N	0	0	\N	\N	0	246057	0	8331-1	3006322		
39907	3708	3006322	1992-05-12	1992-05-12 00:00:00	1992-05-12	5001	0	\N	0	0	\N	\N	0	246520	0	8331-1	3006322		
28109	2588	3011505	2015-09-06	2015-09-06 00:00:00	2015-09-06	5001	0	\N	0	0	\N	\N	0	171283	0	19926-5	3011505		
28247	2603	3008598	2014-05-12	2014-05-12 00:00:00	2014-05-12	5001	0	\N	0	0	\N	\N	0	172225	0	3024-7	3008598		
5027	487	3006322	1972-08-12	1972-08-12 00:00:00	1972-08-12	5001	0	\N	0	0	\N	\N	0	32603	0	8331-1	3006322		
5058	489	3019406	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	32787	0	6158-0	3019406		
30370	2779	3020655	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	184124	0	6844-5	3020655		
28964	2673	3027231	1990-02-12	1990-02-12 00:00:00	1990-02-12	5001	0	\N	0	0	\N	\N	0	177114	0	6276-0	3027231		
33898	3081	46235214	1999-09-07	1999-09-07 00:00:00	1999-09-07	5001	0	\N	0	0	\N	\N	0	205101	0	76690-7	46235214		
147093	4509	4133840	2007-09-04	2007-09-04 00:00:00	2007-09-04	5001	0	\N	0	0	\N	\N	0	300399	0	127783003	4133840		
13054	1246	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	82151	0	6085-5	3001247		
13286	1261	3023430	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	83248	0	6833-8	3023430		
3931	392	3006322	1997-09-18	1997-09-18 00:00:00	1997-09-18	5001	0	\N	0	0	\N	\N	0	25717	0	8331-1	3006322		
24723	2272	3006322	2013-11-17	2013-11-17 00:00:00	2013-11-17	5001	0	\N	0	0	\N	\N	0	151013	0	8331-1	3006322		
53689	4927	3006322	1983-01-23	1983-01-23 00:00:00	1983-01-23	5001	0	\N	0	0	\N	\N	0	327481	0	8331-1	3006322		
7942	761	3027231	1991-12-20	1991-12-20 00:00:00	1991-12-20	5001	0	\N	0	0	\N	\N	0	50594	0	6276-0	3027231		
83058	2564	4052083	1993-08-23	1993-08-23 00:00:00	1993-08-23	5001	0	\N	0	0	\N	\N	0	169851	0	23426006	4052083		
52771	4847	3011505	1983-06-08	1983-06-08 00:00:00	1983-06-08	5001	0	\N	0	0	\N	\N	0	322416	0	19926-5	3011505		
20766	1911	40758406	1947-04-25	1947-04-25 00:00:00	1947-04-25	5001	0	\N	0	0	\N	\N	0	127163	0	55277-8	40758406		
46412	4275	3006322	2003-04-15	2003-04-15 00:00:00	2003-04-15	5001	0	\N	0	0	\N	\N	0	283686	0	8331-1	3006322		
31332	2863	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	190443	0	6106-9	3014599		
96126	2945	4133840	1996-07-23	1996-07-23 00:00:00	1996-07-23	5001	0	\N	0	0	\N	\N	0	196493	0	127783003	4133840		
42371	3913	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	260100	0	6248-9	3015076		
86808	2682	4052083	1977-03-06	1977-03-06 00:00:00	1977-03-06	5001	0	\N	0	0	\N	\N	0	177737	0	23426006	4052083		
769	53	3006322	1998-03-27	1998-03-27 00:00:00	1998-03-27	5001	0	\N	0	0	\N	\N	0	3663	0	8331-1	3006322		
55137	5049	3006322	2001-10-24	2001-10-24 00:00:00	2001-10-24	5001	0	\N	0	0	\N	\N	0	335579	0	8331-1	3006322		
55220	5051	3012494	1990-11-29	1990-11-29 00:00:00	1990-11-29	5001	0	\N	0	0	\N	\N	0	335899	0	6206-7	3012494		
38396	3540	3006322	1977-10-25	1977-10-25 00:00:00	1977-10-25	5001	0	\N	0	0	\N	\N	0	235142	0	8331-1	3006322		
49777	4529	40766240	1986-12-11	1986-12-11 00:00:00	1986-12-11	5001	0	\N	0	0	\N	\N	0	301550	0	63513-6	40766240		
32973	2976	3011505	2010-11-04	2010-11-04 00:00:00	2010-11-04	5001	0	\N	0	0	\N	\N	0	198748	0	19926-5	3011505		
33071	2986	3011505	1994-10-11	1994-10-11 00:00:00	1994-10-11	5001	0	\N	0	0	\N	\N	0	199364	0	19926-5	3011505		
145854	4477	4024958	1966-11-09	1966-11-09 00:00:00	1966-11-09	5001	0	\N	0	0	\N	\N	0	297962	0	117015009	4024958		
44485	4109	40769184	1965-05-08	1965-05-08 00:00:00	1965-05-08	5001	0	\N	0	0	\N	\N	0	273125	0	66524-0	40769184		
24619	2265	3005136	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	150540	0	6075-6	3005136		
127551	3926	4024958	1986-05-15	1986-05-15 00:00:00	1986-05-15	5001	0	\N	0	0	\N	\N	0	260979	0	117015009	4024958		
17880	1622	3006322	2006-07-21	2006-07-21 00:00:00	2006-07-21	5001	0	\N	0	0	\N	\N	0	108999	0	8331-1	3006322		
22164	2033	3006322	2003-07-14	2003-07-14 00:00:00	2003-07-14	5001	0	\N	0	0	\N	\N	0	135337	0	8331-1	3006322		
47539	4372	3015076	1981-01-19	1981-01-19 00:00:00	1981-01-19	5001	0	\N	0	0	\N	\N	0	290260	0	6248-9	3015076		
40638	3772	3005136	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	250687	0	6075-6	3005136		
26542	2450	3006322	1988-03-04	1988-03-04 00:00:00	1988-03-04	5001	0	\N	0	0	\N	\N	0	162502	0	8331-1	3006322		
4990	480	3006322	1998-01-04	1998-01-04 00:00:00	1998-01-04	5001	0	\N	0	0	\N	\N	0	32091	0	8331-1	3006322		
37977	3510	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	232905	0	6106-9	3014599		
47752	1454	4024958	1998-07-28	1998-07-28 00:00:00	1998-07-28	5001	0	\N	0	0	\N	\N	0	97026	0	117015009	4024958		
29702	2736	3006322	2019-06-12	2019-06-12 00:00:00	2019-06-12	5001	0	\N	0	0	\N	\N	0	181129	0	8331-1	3006322		
37061	1146	4024958	2001-12-10	2001-12-10 00:00:00	2001-12-10	5001	0	\N	0	0	\N	\N	0	75719	0	117015009	4024958		
8164	776	3011505	2009-08-06	2009-08-06 00:00:00	2009-08-06	5001	0	\N	0	0	\N	\N	0	51506	0	19926-5	3011505		
53551	1622	4024958	2006-07-21	2006-07-21 00:00:00	2006-07-21	5001	0	\N	0	0	\N	\N	0	108999	0	117015009	4024958		
48866	4472	3006322	1964-05-08	1964-05-08 00:00:00	1964-05-08	5001	0	\N	0	0	\N	\N	0	297481	0	8331-1	3006322		
21426	1976	3021226	1986-01-15	1986-01-15 00:00:00	1986-01-15	5001	0	\N	0	0	\N	\N	0	131339	0	6246-3	3021226		
32793	2970	3014599	2002-11-07	2002-11-07 00:00:00	2002-11-07	5001	0	\N	0	0	\N	\N	0	198259	0	6106-9	3014599		
125116	3860	4024958	2004-03-13	2004-03-13 00:00:00	2004-03-13	5001	0	\N	0	0	\N	\N	0	256320	0	117015009	4024958		
14163	1325	3006322	1987-10-02	1987-10-02 00:00:00	1987-10-02	5001	0	\N	0	0	\N	\N	0	87987	0	8331-1	3006322		
146294	4488	4024958	2002-01-17	2002-01-17 00:00:00	2002-01-17	5001	0	\N	0	0	\N	\N	0	298792	0	117015009	4024958		
28620	2647	3036780	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	175206	0	6095-4	3036780		
55775	5117	3001247	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	340071	0	6085-5	3001247		
55792	5118	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	340191	0	6206-7	3012494		
83728	2588	4052083	2010-09-28	2010-09-28 00:00:00	2010-09-28	5001	0	\N	0	0	\N	\N	0	171288	0	23426006	4052083		
3565	340	3006322	1998-03-01	1998-03-01 00:00:00	1998-03-01	5001	0	\N	0	0	\N	\N	0	22671	0	8331-1	3006322		
87623	2708	4052083	1983-08-03	1983-08-03 00:00:00	1983-08-03	5001	0	\N	0	0	\N	\N	0	179351	0	23426006	4052083		
16838	1533	3006322	2014-08-27	2014-08-27 00:00:00	2014-08-27	5001	0	\N	0	0	\N	\N	0	102647	0	8331-1	3006322		
34854	3181	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	211757	0	6158-0	3019406		
46219	4261	40766240	1956-10-29	1956-10-29 00:00:00	1956-10-29	5001	0	\N	0	0	\N	\N	0	282865	0	63513-6	40766240		
156577	4812	4024958	1964-02-17	1964-02-17 00:00:00	1964-02-17	5001	0	\N	0	0	\N	\N	0	320135	0	117015009	4024958		
8642	273	4024958	2004-11-20	2004-11-20 00:00:00	2004-11-20	5001	0	\N	0	0	\N	\N	0	18280	0	117015009	4024958		
39832	3701	3051031	1970-06-30	1970-06-30 00:00:00	1970-06-30	5001	0	\N	0	0	\N	\N	0	246036	0	46240-8	3051031		
39908	3708	3006322	1983-04-16	1983-04-16 00:00:00	1983-04-16	5001	0	\N	0	0	\N	\N	0	246502	0	8331-1	3006322		
28110	2588	3011505	2018-09-23	2018-09-23 00:00:00	2018-09-23	5001	0	\N	0	0	\N	\N	0	171297	0	19926-5	3011505		
28248	2603	3009201	2014-05-12	2014-05-12 00:00:00	2014-05-12	5001	0	\N	0	0	\N	\N	0	172225	0	3016-3	3009201		
5028	487	3006322	2013-10-06	2013-10-06 00:00:00	2013-10-06	5001	0	\N	0	0	\N	\N	0	32600	0	8331-1	3006322		
5059	489	3012494	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	32787	0	6206-7	3012494		
30371	2779	3000876	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	184124	0	6082-2	3000876		
28965	2673	3006451	1990-02-12	1990-02-12 00:00:00	1990-02-12	5001	0	\N	0	0	\N	\N	0	177114	0	6273-7	3006451		
33899	3081	3006322	1974-09-08	1974-09-08 00:00:00	1974-09-08	5001	0	\N	0	0	\N	\N	0	205142	0	8331-1	3006322		
147105	4509	4133840	2018-09-04	2018-09-04 00:00:00	2018-09-04	5001	0	\N	0	0	\N	\N	0	300406	0	127783003	4133840		
13055	1246	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	82151	0	6246-3	3021226		
13287	1261	3001247	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	83248	0	6085-5	3001247		
3932	393	3006322	1993-11-27	1993-11-27 00:00:00	1993-11-27	5001	0	\N	0	0	\N	\N	0	25764	0	8331-1	3006322		
24724	2272	3006322	2001-03-14	2001-03-14 00:00:00	2001-03-14	5001	0	\N	0	0	\N	\N	0	150987	0	8331-1	3006322		
53690	4927	3006322	2002-05-02	2002-05-02 00:00:00	2002-05-02	5001	0	\N	0	0	\N	\N	0	327437	0	8331-1	3006322		
7943	761	3019406	1991-12-20	1991-12-20 00:00:00	1991-12-20	5001	0	\N	0	0	\N	\N	0	50594	0	6158-0	3019406		
83071	2564	4024958	2005-08-22	2005-08-22 00:00:00	2005-08-22	5001	0	\N	0	0	\N	\N	0	169837	0	117015009	4024958		
52772	4847	3011505	2005-02-16	2005-02-16 00:00:00	2005-02-16	5001	0	\N	0	0	\N	\N	0	322458	0	19926-5	3011505		
20767	1911	3051031	1947-04-25	1947-04-25 00:00:00	1947-04-25	5001	0	\N	0	0	\N	\N	0	127163	0	46240-8	3051031		
46413	4275	3006322	2008-07-29	2008-07-29 00:00:00	2008-07-29	5001	0	\N	0	0	\N	\N	0	283710	0	8331-1	3006322		
31333	2863	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	190443	0	6206-7	3012494		
96129	2945	4133840	1992-03-31	1992-03-31 00:00:00	1992-03-31	5001	0	\N	0	0	\N	\N	0	196492	0	127783003	4133840		
42372	3913	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	260100	0	6075-6	3005136		
86813	2682	4052083	2014-07-16	2014-07-16 00:00:00	2014-07-16	5001	0	\N	0	0	\N	\N	0	177753	0	23426006	4052083		
770	53	3006322	1967-11-29	1967-11-29 00:00:00	1967-11-29	5001	0	\N	0	0	\N	\N	0	3660	0	8331-1	3006322		
55138	5049	3006322	2002-05-03	2002-05-03 00:00:00	2002-05-03	5001	0	\N	0	0	\N	\N	0	335546	0	8331-1	3006322		
55221	5051	3021226	1990-11-29	1990-11-29 00:00:00	1990-11-29	5001	0	\N	0	0	\N	\N	0	335899	0	6246-3	3021226		
38397	3540	3006322	2016-05-28	2016-05-28 00:00:00	2016-05-28	5001	0	\N	0	0	\N	\N	0	235126	0	8331-1	3006322		
49779	4529	3051031	1986-12-11	1986-12-11 00:00:00	1986-12-11	5001	0	\N	0	0	\N	\N	0	301550	0	46240-8	3051031		
32974	2976	3011505	1997-07-03	1997-07-03 00:00:00	1997-07-03	5001	0	\N	0	0	\N	\N	0	198762	0	19926-5	3011505		
33072	2986	3011505	2018-05-01	2018-05-01 00:00:00	2018-05-01	5001	0	\N	0	0	\N	\N	0	199306	0	19926-5	3011505		
84493	2617	4024958	1962-08-18	1962-08-18 00:00:00	1962-08-18	5001	0	\N	0	0	\N	\N	0	173058	0	117015009	4024958		
44486	4109	40769194	1965-05-08	1965-05-08 00:00:00	1965-05-08	5001	0	\N	0	0	\N	\N	0	273125	0	66534-9	40769194		
24620	2265	3006451	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	150540	0	6273-7	3006451		
127552	3926	4133840	2014-07-07	2014-07-07 00:00:00	2014-07-07	5001	0	\N	0	0	\N	\N	0	260921	0	127783003	4133840		
17881	1622	3006322	1989-01-21	1989-01-21 00:00:00	1989-01-21	5001	0	\N	0	0	\N	\N	0	108945	0	8331-1	3006322		
22165	2033	3006322	1983-07-06	1983-07-06 00:00:00	1983-07-06	5001	0	\N	0	0	\N	\N	0	135377	0	8331-1	3006322		
47540	4372	3027231	1981-01-19	1981-01-19 00:00:00	1981-01-19	5001	0	\N	0	0	\N	\N	0	290260	0	6276-0	3027231		
40639	3772	3001488	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	250687	0	7258-7	3001488		
26543	2450	3006322	2016-10-29	2016-10-29 00:00:00	2016-10-29	5001	0	\N	0	0	\N	\N	0	162543	0	8331-1	3006322		
4991	480	3006322	1939-11-08	1939-11-08 00:00:00	1939-11-08	5001	0	\N	0	0	\N	\N	0	32083	0	8331-1	3006322		
37978	3510	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	232905	0	6273-7	3006451		
47754	1454	4052083	1985-05-09	1985-05-09 00:00:00	1985-05-09	5001	0	\N	0	0	\N	\N	0	96989	0	23426006	4052083		
29703	2736	3006322	2004-11-16	2004-11-16 00:00:00	2004-11-16	5001	0	\N	0	0	\N	\N	0	181115	0	8331-1	3006322		
47245	4352	3006322	2003-11-29	2003-11-29 00:00:00	2003-11-29	5001	0	\N	0	0	\N	\N	0	288709	0	8331-1	3006322		
8165	776	3011505	2013-08-29	2013-08-29 00:00:00	2013-08-29	5001	0	\N	0	0	\N	\N	0	51511	0	19926-5	3011505		
53561	1622	4024958	1977-02-13	1977-02-13 00:00:00	1977-02-13	5001	0	\N	0	0	\N	\N	0	108943	0	117015009	4024958		
48867	4472	3006322	1938-10-26	1938-10-26 00:00:00	1938-10-26	5001	0	\N	0	0	\N	\N	0	297513	0	8331-1	3006322		
21427	1976	3019406	1986-01-15	1986-01-15 00:00:00	1986-01-15	5001	0	\N	0	0	\N	\N	0	131339	0	6158-0	3019406		
32794	2970	3006451	2002-11-07	2002-11-07 00:00:00	2002-11-07	5001	0	\N	0	0	\N	\N	0	198259	0	6273-7	3006451		
159630	4909	4052083	2017-02-07	2017-02-07 00:00:00	2017-02-07	5001	0	\N	0	0	\N	\N	0	326259	0	23426006	4052083		
96434	2955	4024958	1976-09-02	1976-09-02 00:00:00	1976-09-02	5001	0	\N	0	0	\N	\N	0	197275	0	117015009	4024958		
112097	3462	4024958	1980-11-09	1980-11-09 00:00:00	1980-11-09	5001	0	\N	0	0	\N	\N	0	229712	0	117015009	4024958		
28621	2647	3001488	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	175206	0	7258-7	3001488		
55776	5117	3036780	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	340071	0	6095-4	3036780		
55793	5118	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	340191	0	6082-2	3000876		
83733	2588	4024958	1994-09-04	1994-09-04 00:00:00	1994-09-04	5001	0	\N	0	0	\N	\N	0	171245	0	117015009	4024958		
3566	340	46235214	1979-10-06	1979-10-06 00:00:00	1979-10-06	5001	0	\N	0	0	\N	\N	0	22687	0	76690-7	46235214		
87626	2708	4052083	1965-09-29	1965-09-29 00:00:00	1965-09-29	5001	0	\N	0	0	\N	\N	0	179360	0	23426006	4052083		
16839	1533	3006322	1974-01-13	1974-01-13 00:00:00	1974-01-13	5001	0	\N	0	0	\N	\N	0	102646	0	8331-1	3006322		
34855	3181	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	211757	0	6833-8	3023430		
46220	4261	40758406	1956-10-29	1956-10-29 00:00:00	1956-10-29	5001	0	\N	0	0	\N	\N	0	282865	0	55277-8	40758406		
156578	4812	4024958	1997-05-27	1997-05-27 00:00:00	1997-05-27	5001	0	\N	0	0	\N	\N	0	320111	0	117015009	4024958		
8654	273	4024958	2002-07-25	2002-07-25 00:00:00	2002-07-25	5001	0	\N	0	0	\N	\N	0	18295	0	117015009	4024958		
39835	3701	46235214	1970-06-30	1970-06-30 00:00:00	1970-06-30	5001	0	\N	0	0	\N	\N	0	246036	0	76690-7	46235214		
39909	3708	3006322	2006-08-18	2006-08-18 00:00:00	2006-08-18	5001	0	\N	0	0	\N	\N	0	246562	0	8331-1	3006322		
28111	2588	3011505	2017-09-17	2017-09-17 00:00:00	2017-09-17	5001	0	\N	0	0	\N	\N	0	171282	0	19926-5	3011505		
28249	2603	3006322	1988-05-02	1988-05-02 00:00:00	1988-05-02	5001	0	\N	0	0	\N	\N	0	172184	0	8331-1	3006322		
5029	487	3006322	2015-02-12	2015-02-12 00:00:00	2015-02-12	5001	0	\N	0	0	\N	\N	0	32545	0	8331-1	3006322		
5060	489	3015076	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	32787	0	6248-9	3015076		
30372	2779	3021226	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	184124	0	6246-3	3021226		
28966	2673	3001488	1990-02-12	1990-02-12 00:00:00	1990-02-12	5001	0	\N	0	0	\N	\N	0	177114	0	7258-7	3001488		
33900	3081	3006322	1984-09-07	1984-09-07 00:00:00	1984-09-07	5001	0	\N	0	0	\N	\N	0	205100	0	8331-1	3006322		
147106	4509	4133840	1990-04-10	1990-04-10 00:00:00	1990-04-10	5001	0	\N	0	0	\N	\N	0	300359	0	127783003	4133840		
13056	1246	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	82151	0	6082-2	3000876		
13288	1261	3015076	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	83248	0	6248-9	3015076		
3933	394	3006322	1922-12-20	1922-12-20 00:00:00	1922-12-20	5001	0	\N	0	0	\N	\N	0	25835	0	8331-1	3006322		
24725	2272	3006322	2010-02-10	2010-02-10 00:00:00	2010-02-10	5001	0	\N	0	0	\N	\N	0	151012	0	8331-1	3006322		
128435	3955	4052083	2004-03-09	2004-03-09 00:00:00	2004-03-09	5001	0	\N	0	0	\N	\N	0	262830	0	23426006	4052083		
7944	761	3014599	1991-12-20	1991-12-20 00:00:00	1991-12-20	5001	0	\N	0	0	\N	\N	0	50594	0	6106-9	3014599		
83080	2564	4024958	1991-11-19	1991-11-19 00:00:00	1991-11-19	5001	0	\N	0	0	\N	\N	0	169913	0	117015009	4024958		
52773	4847	3011505	1991-09-11	1991-09-11 00:00:00	1991-09-11	5001	0	\N	0	0	\N	\N	0	322454	0	19926-5	3011505		
20768	1911	46235214	1947-04-25	1947-04-25 00:00:00	1947-04-25	5001	0	\N	0	0	\N	\N	0	127163	0	76690-7	46235214		
46414	4276	3006322	1997-07-24	1997-07-24 00:00:00	1997-07-24	5001	0	\N	0	0	\N	\N	0	283775	0	8331-1	3006322		
31334	2863	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	190443	0	6085-5	3001247		
96130	2945	4024958	1950-05-21	1950-05-21 00:00:00	1950-05-21	5001	0	\N	0	0	\N	\N	0	196478	0	117015009	4024958		
42373	3913	3027231	1981-11-09	1981-11-09 00:00:00	1981-11-09	5001	0	\N	0	0	\N	\N	0	260154	0	6276-0	3027231		
98104	3000	4052083	1951-07-01	1951-07-01 00:00:00	1951-07-01	5001	0	\N	0	0	\N	\N	0	200184	0	23426006	4052083		
771	53	3006322	1980-02-19	1980-02-19 00:00:00	1980-02-19	5001	0	\N	0	0	\N	\N	0	3662	0	8331-1	3006322		
55139	5049	3011505	2019-02-06	2019-02-06 00:00:00	2019-02-06	5001	0	\N	0	0	\N	\N	0	335639	0	19926-5	3011505		
55222	5051	3005136	1990-11-29	1990-11-29 00:00:00	1990-11-29	5001	0	\N	0	0	\N	\N	0	335899	0	6075-6	3005136		
38398	3540	3006322	2005-04-18	2005-04-18 00:00:00	2005-04-18	5001	0	\N	0	0	\N	\N	0	235135	0	8331-1	3006322		
49780	4529	3006322	1972-11-23	1972-11-23 00:00:00	1972-11-23	5001	0	\N	0	0	\N	\N	0	301549	0	8331-1	3006322		
32975	2976	3011505	2014-07-17	2014-07-17 00:00:00	2014-07-17	5001	0	\N	0	0	\N	\N	0	198765	0	19926-5	3011505		
33073	2986	3006322	1948-05-10	1948-05-10 00:00:00	1948-05-10	5001	0	\N	0	0	\N	\N	0	199346	0	8331-1	3006322		
84494	2617	4024958	2018-07-10	2018-07-10 00:00:00	2018-07-10	5001	0	\N	0	0	\N	\N	0	173061	0	117015009	4024958		
44487	4109	40769189	1965-05-08	1965-05-08 00:00:00	1965-05-08	5001	0	\N	0	0	\N	\N	0	273125	0	66529-9	40769189		
24621	2265	3001247	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	150540	0	6085-5	3001247		
127556	3926	4133840	2010-03-01	2010-03-01 00:00:00	2010-03-01	5001	0	\N	0	0	\N	\N	0	260955	0	127783003	4133840		
17882	1622	3006322	1977-02-13	1977-02-13 00:00:00	1977-02-13	5001	0	\N	0	0	\N	\N	0	108943	0	8331-1	3006322		
22166	2033	3006322	1992-09-01	1992-09-01 00:00:00	1992-09-01	5001	0	\N	0	0	\N	\N	0	135336	0	8331-1	3006322		
47541	4372	3014599	1981-01-19	1981-01-19 00:00:00	1981-01-19	5001	0	\N	0	0	\N	\N	0	290260	0	6106-9	3014599		
40640	3772	3023430	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	250687	0	6833-8	3023430		
40714	3783	3006322	2001-05-31	2001-05-31 00:00:00	2001-05-31	5001	0	\N	0	0	\N	\N	0	251332	0	8331-1	3006322		
4998	482	3006322	1974-06-01	1974-06-01 00:00:00	1974-06-01	5001	0	\N	0	0	\N	\N	0	32231	0	8331-1	3006322		
37979	3510	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	232905	0	6833-8	3023430		
47756	1454	4024958	1984-04-06	1984-04-06 00:00:00	1984-04-06	5001	0	\N	0	0	\N	\N	0	96977	0	117015009	4024958		
29707	2739	3006322	2014-06-09	2014-06-09 00:00:00	2014-06-09	5001	0	\N	0	0	\N	\N	0	181189	0	8331-1	3006322		
47246	4352	3006322	1985-01-15	1985-01-15 00:00:00	1985-01-15	5001	0	\N	0	0	\N	\N	0	288707	0	8331-1	3006322		
8166	776	3006322	1971-05-28	1971-05-28 00:00:00	1971-05-28	5001	0	\N	0	0	\N	\N	0	51514	0	8331-1	3006322		
53572	1622	4024958	1997-09-20	1997-09-20 00:00:00	1997-09-20	5001	0	\N	0	0	\N	\N	0	108996	0	117015009	4024958		
108896	3364	4024958	1980-03-06	1980-03-06 00:00:00	1980-03-06	5001	0	\N	0	0	\N	\N	0	223039	0	117015009	4024958		
21428	1976	3015076	1986-01-15	1986-01-15 00:00:00	1986-01-15	5001	0	\N	0	0	\N	\N	0	131339	0	6248-9	3015076		
32795	2970	3023430	2002-11-07	2002-11-07 00:00:00	2002-11-07	5001	0	\N	0	0	\N	\N	0	198259	0	6833-8	3023430		
170961	5245	4024958	2016-01-07	2016-01-07 00:00:00	2016-01-07	5001	0	\N	0	0	\N	\N	0	349035	0	117015009	4024958		
96438	2955	4052083	1998-01-10	1998-01-10 00:00:00	1998-01-10	5001	0	\N	0	0	\N	\N	0	197207	0	23426006	4052083		
112100	3462	4024958	1990-06-15	1990-06-15 00:00:00	1990-06-15	5001	0	\N	0	0	\N	\N	0	229683	0	117015009	4024958		
28622	2647	3020655	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	175206	0	6844-5	3020655		
55777	5117	3001488	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	340071	0	7258-7	3001488		
55794	5118	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	340191	0	6106-9	3014599		
25051	2297	3006322	2014-06-06	2014-06-06 00:00:00	2014-06-06	5001	0	\N	0	0	\N	\N	0	152932	0	8331-1	3006322		
3567	340	40766240	1979-10-06	1979-10-06 00:00:00	1979-10-06	5001	0	\N	0	0	\N	\N	0	22687	0	63513-6	40766240		
87648	2709	4024958	1953-08-04	1953-08-04 00:00:00	1953-08-04	5001	0	\N	0	0	\N	\N	0	179486	0	117015009	4024958		
16840	1535	46235214	1991-06-24	1991-06-24 00:00:00	1991-06-24	5001	0	\N	0	0	\N	\N	0	102709	0	76690-7	46235214		
34856	3181	3011505	2017-11-10	2017-11-10 00:00:00	2017-11-10	5001	0	\N	0	0	\N	\N	0	211706	0	19926-5	3011505		
46221	4261	46235214	1956-10-29	1956-10-29 00:00:00	1956-10-29	5001	0	\N	0	0	\N	\N	0	282865	0	76690-7	46235214		
46821	4312	40769179	1961-02-16	1961-02-16 00:00:00	1961-02-16	5001	0	\N	0	0	\N	\N	0	286191	0	66519-0	40769179		
8657	273	4024958	1983-09-19	1983-09-19 00:00:00	1983-09-19	5001	0	\N	0	0	\N	\N	0	18266	0	117015009	4024958		
39836	3701	40766240	1970-06-30	1970-06-30 00:00:00	1970-06-30	5001	0	\N	0	0	\N	\N	0	246036	0	63513-6	40766240		
39910	3708	3006322	1996-10-29	1996-10-29 00:00:00	1996-10-29	5001	0	\N	0	0	\N	\N	0	246570	0	8331-1	3006322		
28112	2588	3006322	1994-09-04	1994-09-04 00:00:00	1994-09-04	5001	0	\N	0	0	\N	\N	0	171245	0	8331-1	3006322		
28250	2603	3006322	1965-09-16	1965-09-16 00:00:00	1965-09-16	5001	0	\N	0	0	\N	\N	0	172168	0	8331-1	3006322		
5030	487	3006322	1984-09-20	1984-09-20 00:00:00	1984-09-20	5001	0	\N	0	0	\N	\N	0	32541	0	8331-1	3006322		
5061	489	3006322	1993-10-12	1993-10-12 00:00:00	1993-10-12	5001	0	\N	0	0	\N	\N	0	32788	0	8331-1	3006322		
30373	2779	3014599	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	184124	0	6106-9	3014599		
28967	2673	3036780	1990-02-12	1990-02-12 00:00:00	1990-02-12	5001	0	\N	0	0	\N	\N	0	177114	0	6095-4	3036780		
33901	3081	3006322	1980-08-19	1980-08-19 00:00:00	1980-08-19	5001	0	\N	0	0	\N	\N	0	205118	0	8331-1	3006322		
91954	2834	4024958	1947-08-02	1947-08-02 00:00:00	1947-08-02	5001	0	\N	0	0	\N	\N	0	188185	0	117015009	4024958		
13057	1246	3006322	1991-09-22	1991-09-22 00:00:00	1991-09-22	5001	0	\N	0	0	\N	\N	0	82023	0	8331-1	3006322		
13289	1261	3027231	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	83248	0	6276-0	3027231		
3935	394	3006322	1941-01-09	1941-01-09 00:00:00	1941-01-09	5001	0	\N	0	0	\N	\N	0	25916	0	8331-1	3006322		
24726	2272	3006322	2010-06-20	2010-06-20 00:00:00	2010-06-20	5001	0	\N	0	0	\N	\N	0	151033	0	8331-1	3006322		
128461	3956	4024958	1930-01-01	1930-01-01 00:00:00	1930-01-01	5001	0	\N	0	0	\N	\N	0	263027	0	117015009	4024958		
7945	761	3006451	1991-12-20	1991-12-20 00:00:00	1991-12-20	5001	0	\N	0	0	\N	\N	0	50594	0	6273-7	3006451		
139893	4312	4052083	1994-04-02	1994-04-02 00:00:00	1994-04-02	5001	0	\N	0	0	\N	\N	0	286171	0	23426006	4052083		
52774	4847	3011505	2012-03-21	2012-03-21 00:00:00	2012-03-21	5001	0	\N	0	0	\N	\N	0	322480	0	19926-5	3011505		
20770	1911	40766240	1947-04-25	1947-04-25 00:00:00	1947-04-25	5001	0	\N	0	0	\N	\N	0	127163	0	63513-6	40766240		
46415	4276	46235214	1954-03-25	1954-03-25 00:00:00	1954-03-25	5001	0	\N	0	0	\N	\N	0	283759	0	76690-7	46235214		
31335	2863	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	190443	0	6833-8	3023430		
96131	2945	4133840	1988-10-25	1988-10-25 00:00:00	1988-10-25	5001	0	\N	0	0	\N	\N	0	196476	0	127783003	4133840		
42374	3913	3036780	1981-11-09	1981-11-09 00:00:00	1981-11-09	5001	0	\N	0	0	\N	\N	0	260154	0	6095-4	3036780		
98112	3000	4024958	1951-07-01	1951-07-01 00:00:00	1951-07-01	5001	0	\N	0	0	\N	\N	0	200184	0	117015009	4024958		
772	53	3006322	1977-05-23	1977-05-23 00:00:00	1977-05-23	5001	0	\N	0	0	\N	\N	0	3661	0	8331-1	3006322		
5177	156	4052083	2005-06-23	2005-06-23 00:00:00	2005-06-23	5001	0	\N	0	0	\N	\N	0	10673	0	23426006	4052083		
55223	5051	3001488	1990-11-29	1990-11-29 00:00:00	1990-11-29	5001	0	\N	0	0	\N	\N	0	335899	0	7258-7	3001488		
38399	3541	3006322	1983-06-17	1983-06-17 00:00:00	1983-06-17	5001	0	\N	0	0	\N	\N	0	235171	0	8331-1	3006322		
49781	4529	3011505	2015-11-29	2015-11-29 00:00:00	2015-11-29	5001	0	\N	0	0	\N	\N	0	301558	0	19926-5	3011505		
32976	2976	3011505	2007-10-18	2007-10-18 00:00:00	2007-10-18	5001	0	\N	0	0	\N	\N	0	198732	0	19926-5	3011505		
33074	2986	3011505	2013-04-02	2013-04-02 00:00:00	2013-04-02	5001	0	\N	0	0	\N	\N	0	199324	0	19926-5	3011505		
84525	2619	4052083	2011-07-26	2011-07-26 00:00:00	2011-07-26	5001	0	\N	0	0	\N	\N	0	173216	0	23426006	4052083		
44488	4109	3006322	2011-01-21	2011-01-21 00:00:00	2011-01-21	5001	0	\N	0	0	\N	\N	0	273115	0	8331-1	3006322		
24622	2265	3021226	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	150540	0	6246-3	3021226		
127558	3926	4133840	2006-02-06	2006-02-06 00:00:00	2006-02-06	5001	0	\N	0	0	\N	\N	0	260932	0	127783003	4133840		
17883	1623	3006322	2017-07-05	2017-07-05 00:00:00	2017-07-05	5001	0	\N	0	0	\N	\N	0	109088	0	8331-1	3006322		
22167	2033	40766240	1976-02-10	1976-02-10 00:00:00	1976-02-10	5001	0	\N	0	0	\N	\N	0	135285	0	63513-6	40766240		
47542	4372	3001247	1981-01-19	1981-01-19 00:00:00	1981-01-19	5001	0	\N	0	0	\N	\N	0	290260	0	6085-5	3001247		
40641	3772	3006734	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	250687	0	6189-5	3006734		
40715	3783	3006322	1960-11-20	1960-11-20 00:00:00	1960-11-20	5001	0	\N	0	0	\N	\N	0	251427	0	8331-1	3006322		
4999	482	3006322	1979-03-21	1979-03-21 00:00:00	1979-03-21	5001	0	\N	0	0	\N	\N	0	32199	0	8331-1	3006322		
37980	3510	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	232905	0	7258-7	3001488		
47758	1454	4024958	1984-07-17	1984-07-17 00:00:00	1984-07-17	5001	0	\N	0	0	\N	\N	0	97007	0	117015009	4024958		
29708	2739	3006322	1962-03-31	1962-03-31 00:00:00	1962-03-31	5001	0	\N	0	0	\N	\N	0	181210	0	8331-1	3006322		
47247	4352	3006322	1973-01-21	1973-01-21 00:00:00	1973-01-21	5001	0	\N	0	0	\N	\N	0	288635	0	8331-1	3006322		
8167	776	3011505	2014-09-04	2014-09-04 00:00:00	2014-09-04	5001	0	\N	0	0	\N	\N	0	51594	0	19926-5	3011505		
53578	1622	4052083	2015-04-08	2015-04-08 00:00:00	2015-04-08	5001	0	\N	0	0	\N	\N	0	108971	0	23426006	4052083		
166469	5116	4052083	2011-04-24	2011-04-24 00:00:00	2011-04-24	5001	0	\N	0	0	\N	\N	0	339943	0	23426006	4052083		
21429	1977	3006322	1972-05-28	1972-05-28 00:00:00	1972-05-28	5001	0	\N	0	0	\N	\N	0	131588	0	8331-1	3006322		
32796	2970	3006734	2002-11-07	2002-11-07 00:00:00	2002-11-07	5001	0	\N	0	0	\N	\N	0	198259	0	6189-5	3006734		
159837	4916	4024958	2014-04-15	2014-04-15 00:00:00	2014-04-15	5001	0	\N	0	0	\N	\N	0	326691	0	117015009	4024958		
96441	2955	4024958	1974-02-17	1974-02-17 00:00:00	1974-02-17	5001	0	\N	0	0	\N	\N	0	197202	0	117015009	4024958		
112119	3462	4024958	1969-05-20	1969-05-20 00:00:00	1969-05-20	5001	0	\N	0	0	\N	\N	0	229730	0	117015009	4024958		
28623	2647	3023430	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	175206	0	6833-8	3023430		
55778	5117	3020655	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	340071	0	6844-5	3020655		
55795	5118	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	340191	0	6095-4	3036780		
25052	2298	3006322	1992-02-17	1992-02-17 00:00:00	1992-02-17	5001	0	\N	0	0	\N	\N	0	152986	0	8331-1	3006322		
3568	340	40758406	1979-10-06	1979-10-06 00:00:00	1979-10-06	5001	0	\N	0	0	\N	\N	0	22687	0	55277-8	40758406		
87659	2709	4052083	2019-03-15	2019-03-15 00:00:00	2019-03-15	5001	0	\N	0	0	\N	\N	0	179496	0	23426006	4052083		
16841	1535	3051031	1991-06-24	1991-06-24 00:00:00	1991-06-24	5001	0	\N	0	0	\N	\N	0	102709	0	46240-8	3051031		
34857	3181	3011505	2003-07-04	2003-07-04 00:00:00	2003-07-04	5001	0	\N	0	0	\N	\N	0	211702	0	19926-5	3011505		
46222	4261	40766240	1957-01-27	1957-01-27 00:00:00	1957-01-27	5001	0	\N	0	0	\N	\N	0	282886	0	63513-6	40766240		
46822	4312	40769184	1961-02-16	1961-02-16 00:00:00	1961-02-16	5001	0	\N	0	0	\N	\N	0	286191	0	66524-0	40769184		
162219	4976	4052083	1956-11-20	1956-11-20 00:00:00	1956-11-20	5001	0	\N	0	0	\N	\N	0	330969	0	23426006	4052083		
39837	3701	40758406	1970-06-30	1970-06-30 00:00:00	1970-06-30	5001	0	\N	0	0	\N	\N	0	246036	0	55277-8	40758406		
39911	3708	3006322	2007-01-27	2007-01-27 00:00:00	2007-01-27	5001	0	\N	0	0	\N	\N	0	246527	0	8331-1	3006322		
28113	2588	3011505	2014-08-31	2014-08-31 00:00:00	2014-08-31	5001	0	\N	0	0	\N	\N	0	171306	0	19926-5	3011505		
28251	2603	3006322	1962-04-19	1962-04-19 00:00:00	1962-04-19	5001	0	\N	0	0	\N	\N	0	172231	0	8331-1	3006322		
5031	487	3006322	2008-02-26	2008-02-26 00:00:00	2008-02-26	5001	0	\N	0	0	\N	\N	0	32553	0	8331-1	3006322		
5062	489	3023430	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	32817	0	6833-8	3023430		
30374	2779	3005136	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	184124	0	6075-6	3005136		
28968	2673	3000876	1990-02-12	1990-02-12 00:00:00	1990-02-12	5001	0	\N	0	0	\N	\N	0	177114	0	6082-2	3000876		
33902	3081	46235214	1999-02-09	1999-02-09 00:00:00	1999-02-09	5001	0	\N	0	0	\N	\N	0	205120	0	76690-7	46235214		
91955	2834	4024958	1965-03-17	1965-03-17 00:00:00	1965-03-17	5001	0	\N	0	0	\N	\N	0	188178	0	117015009	4024958		
83433	2577	4024958	1976-12-19	1976-12-19 00:00:00	1976-12-19	5001	0	\N	0	0	\N	\N	0	170604	0	117015009	4024958		
13290	1261	3011505	2006-05-13	2006-05-13 00:00:00	2006-05-13	5001	0	\N	0	0	\N	\N	0	83137	0	19926-5	3011505		
3936	394	3006322	1955-02-10	1955-02-10 00:00:00	1955-02-10	5001	0	\N	0	0	\N	\N	0	25886	0	8331-1	3006322		
24727	2273	3006322	1989-07-20	1989-07-20 00:00:00	1989-07-20	5001	0	\N	0	0	\N	\N	0	151114	0	8331-1	3006322		
128468	3956	4024958	1928-07-31	1928-07-31 00:00:00	1928-07-31	5001	0	\N	0	0	\N	\N	0	262939	0	117015009	4024958		
7946	761	3001488	1991-12-20	1991-12-20 00:00:00	1991-12-20	5001	0	\N	0	0	\N	\N	0	50594	0	7258-7	3001488		
139923	4312	4024958	1989-11-09	1989-11-09 00:00:00	1989-11-09	5001	0	\N	0	0	\N	\N	0	286216	0	117015009	4024958		
52775	4847	3011505	2015-04-08	2015-04-08 00:00:00	2015-04-08	5001	0	\N	0	0	\N	\N	0	322421	0	19926-5	3011505		
165979	5101	4052083	1973-08-23	1973-08-23 00:00:00	1973-08-23	5001	0	\N	0	0	\N	\N	0	338962	0	23426006	4052083		
46417	4276	3051031	1954-03-25	1954-03-25 00:00:00	1954-03-25	5001	0	\N	0	0	\N	\N	0	283759	0	46240-8	3051031		
31336	2863	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	190443	0	6273-7	3006451		
96132	2945	4133840	1984-07-10	1984-07-10 00:00:00	1984-07-10	5001	0	\N	0	0	\N	\N	0	196475	0	127783003	4133840		
42375	3913	3020655	1981-11-09	1981-11-09 00:00:00	1981-11-09	5001	0	\N	0	0	\N	\N	0	260154	0	6844-5	3020655		
98114	3000	4024958	1961-07-18	1961-07-18 00:00:00	1961-07-18	5001	0	\N	0	0	\N	\N	0	200185	0	117015009	4024958		
773	53	3006322	1964-10-06	1964-10-06 00:00:00	1964-10-06	5001	0	\N	0	0	\N	\N	0	3658	0	8331-1	3006322		
5178	156	4024958	1983-12-26	1983-12-26 00:00:00	1983-12-26	5001	0	\N	0	0	\N	\N	0	10694	0	117015009	4024958		
55224	5051	3036780	1990-11-29	1990-11-29 00:00:00	1990-11-29	5001	0	\N	0	0	\N	\N	0	335899	0	6095-4	3036780		
38400	3541	3006322	2013-07-14	2013-07-14 00:00:00	2013-07-14	5001	0	\N	0	0	\N	\N	0	235193	0	8331-1	3006322		
49782	4529	3011505	2014-11-23	2014-11-23 00:00:00	2014-11-23	5001	0	\N	0	0	\N	\N	0	301602	0	19926-5	3011505		
32977	2976	3011505	2005-10-06	2005-10-06 00:00:00	2005-10-06	5001	0	\N	0	0	\N	\N	0	198731	0	19926-5	3011505		
33075	2986	3011505	1998-01-06	1998-01-06 00:00:00	1998-01-06	5001	0	\N	0	0	\N	\N	0	199320	0	19926-5	3011505		
84527	2619	4024958	1948-03-24	1948-03-24 00:00:00	1948-03-24	5001	0	\N	0	0	\N	\N	0	173203	0	117015009	4024958		
44489	4109	3006322	2013-06-19	2013-06-19 00:00:00	2013-06-19	5001	0	\N	0	0	\N	\N	0	273116	0	8331-1	3006322		
24623	2265	3027231	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	150540	0	6276-0	3027231		
127560	3926	4133840	2012-03-12	2012-03-12 00:00:00	2012-03-12	5001	0	\N	0	0	\N	\N	0	260956	0	127783003	4133840		
17884	1623	3006322	1995-12-07	1995-12-07 00:00:00	1995-12-07	5001	0	\N	0	0	\N	\N	0	109085	0	8331-1	3006322		
22168	2033	46235214	1976-02-10	1976-02-10 00:00:00	1976-02-10	5001	0	\N	0	0	\N	\N	0	135285	0	76690-7	46235214		
47543	4372	3006734	1981-01-19	1981-01-19 00:00:00	1981-01-19	5001	0	\N	0	0	\N	\N	0	290260	0	6189-5	3006734		
40642	3772	3001247	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	250687	0	6085-5	3001247		
40716	3783	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	251365	0	6095-4	3036780		
5000	482	3006322	2009-04-18	2009-04-18 00:00:00	2009-04-18	5001	0	\N	0	0	\N	\N	0	32232	0	8331-1	3006322		
37981	3510	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	232905	0	6248-9	3015076		
128078	3941	4052083	1986-05-31	1986-05-31 00:00:00	1986-05-31	5001	0	\N	0	0	\N	\N	0	262060	0	23426006	4052083		
29712	2739	3006322	1989-01-24	1989-01-24 00:00:00	1989-01-24	5001	0	\N	0	0	\N	\N	0	181218	0	8331-1	3006322		
47248	4352	3006322	2005-06-04	2005-06-04 00:00:00	2005-06-04	5001	0	\N	0	0	\N	\N	0	288710	0	8331-1	3006322		
8168	776	3011505	2017-09-21	2017-09-21 00:00:00	2017-09-21	5001	0	\N	0	0	\N	\N	0	51513	0	19926-5	3011505		
53597	1622	4024958	1989-01-21	1989-01-21 00:00:00	1989-01-21	5001	0	\N	0	0	\N	\N	0	108945	0	117015009	4024958		
4297	422	3006322	1967-07-13	1967-07-13 00:00:00	1967-07-13	5001	0	\N	0	0	\N	\N	0	27952	0	8331-1	3006322		
21430	1977	3006322	1998-04-09	1998-04-09 00:00:00	1998-04-09	5001	0	\N	0	0	\N	\N	0	131514	0	8331-1	3006322		
32797	2970	3036780	1999-05-06	1999-05-06 00:00:00	1999-05-06	5001	0	\N	0	0	\N	\N	0	198331	0	6095-4	3036780		
159839	4916	4024958	1981-01-13	1981-01-13 00:00:00	1981-01-13	5001	0	\N	0	0	\N	\N	0	326709	0	117015009	4024958		
96444	2955	4024958	1995-05-13	1995-05-13 00:00:00	1995-05-13	5001	0	\N	0	0	\N	\N	0	197243	0	117015009	4024958		
89658	2771	4052083	1973-12-22	1973-12-22 00:00:00	1973-12-22	5001	0	\N	0	0	\N	\N	0	183529	0	23426006	4052083		
28624	2647	3006734	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	175206	0	6189-5	3006734		
55779	5117	3012494	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	340071	0	6206-7	3012494		
55796	5118	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	340191	0	6833-8	3023430		
25053	2298	3006322	2015-10-26	2015-10-26 00:00:00	2015-10-26	5001	0	\N	0	0	\N	\N	0	153006	0	8331-1	3006322		
3569	340	3051031	1979-10-06	1979-10-06 00:00:00	1979-10-06	5001	0	\N	0	0	\N	\N	0	22687	0	46240-8	3051031		
87660	2709	4024958	1973-01-01	1973-01-01 00:00:00	1973-01-01	5001	0	\N	0	0	\N	\N	0	179462	0	117015009	4024958		
16843	1535	40758406	1991-06-24	1991-06-24 00:00:00	1991-06-24	5001	0	\N	0	0	\N	\N	0	102709	0	55277-8	40758406		
34903	3183	40769179	2014-02-10	2014-02-10 00:00:00	2014-02-10	5001	0	\N	0	0	\N	\N	0	211942	0	66519-0	40769179		
46224	4261	3051031	1957-01-27	1957-01-27 00:00:00	1957-01-27	5001	0	\N	0	0	\N	\N	0	282886	0	46240-8	3051031		
46823	4312	40769194	1961-02-16	1961-02-16 00:00:00	1961-02-16	5001	0	\N	0	0	\N	\N	0	286191	0	66534-9	40769194		
162235	4976	4052083	1913-03-14	1913-03-14 00:00:00	1913-03-14	5001	0	\N	0	0	\N	\N	0	331068	0	23426006	4052083		
39838	3701	40766240	1970-05-31	1970-05-31 00:00:00	1970-05-31	5001	0	\N	0	0	\N	\N	0	246118	0	63513-6	40766240		
51195	4682	3006322	1997-02-25	1997-02-25 00:00:00	1997-02-25	5001	0	\N	0	0	\N	\N	0	312006	0	8331-1	3006322		
28114	2588	3006322	1993-07-02	1993-07-02 00:00:00	1993-07-02	5001	0	\N	0	0	\N	\N	0	171265	0	8331-1	3006322		
28252	2604	3006322	1995-03-07	1995-03-07 00:00:00	1995-03-07	5001	0	\N	0	0	\N	\N	0	172256	0	8331-1	3006322		
5032	487	3006322	2003-07-08	2003-07-08 00:00:00	2003-07-08	5001	0	\N	0	0	\N	\N	0	32552	0	8331-1	3006322		
5063	489	3019406	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	32817	0	6158-0	3019406		
30375	2779	3015076	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	184124	0	6248-9	3015076		
28969	2673	3019406	1990-02-12	1990-02-12 00:00:00	1990-02-12	5001	0	\N	0	0	\N	\N	0	177114	0	6158-0	3019406		
33905	3081	40766240	1999-02-09	1999-02-09 00:00:00	1999-02-09	5001	0	\N	0	0	\N	\N	0	205120	0	63513-6	40766240		
91977	2834	4024958	1968-01-14	1968-01-14 00:00:00	1968-01-14	5001	0	\N	0	0	\N	\N	0	188190	0	117015009	4024958		
83444	2577	4052083	1992-01-17	1992-01-17 00:00:00	1992-01-17	5001	0	\N	0	0	\N	\N	0	170675	0	23426006	4052083		
13292	1264	3011505	2019-06-07	2019-06-07 00:00:00	2019-06-07	5001	0	\N	0	0	\N	\N	0	83295	0	19926-5	3011505		
3937	394	3006322	1966-01-23	1966-01-23 00:00:00	1966-01-23	5001	0	\N	0	0	\N	\N	0	25888	0	8331-1	3006322		
24728	2273	3006322	1994-06-04	1994-06-04 00:00:00	1994-06-04	5001	0	\N	0	0	\N	\N	0	151115	0	8331-1	3006322		
128499	3956	4052083	1944-09-12	1944-09-12 00:00:00	1944-09-12	5001	0	\N	0	0	\N	\N	0	262973	0	23426006	4052083		
7947	761	3023430	1991-12-20	1991-12-20 00:00:00	1991-12-20	5001	0	\N	0	0	\N	\N	0	50594	0	6833-8	3023430		
47329	4364	3006322	1961-03-26	1961-03-26 00:00:00	1961-03-26	5001	0	\N	0	0	\N	\N	0	289449	0	8331-1	3006322		
52776	4847	3011505	2001-07-18	2001-07-18 00:00:00	2001-07-18	5001	0	\N	0	0	\N	\N	0	322449	0	19926-5	3011505		
166020	5103	4052083	1967-12-29	1967-12-29 00:00:00	1967-12-29	5001	0	\N	0	0	\N	\N	0	339065	0	23426006	4052083		
46418	4276	40766240	1954-03-25	1954-03-25 00:00:00	1954-03-25	5001	0	\N	0	0	\N	\N	0	283759	0	63513-6	40766240		
31337	2863	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	190443	0	6075-6	3005136		
96133	2945	4133840	1981-07-07	1981-07-07 00:00:00	1981-07-07	5001	0	\N	0	0	\N	\N	0	196474	0	127783003	4133840		
42376	3913	3023430	1981-11-09	1981-11-09 00:00:00	1981-11-09	5001	0	\N	0	0	\N	\N	0	260154	0	6833-8	3023430		
98124	3001	4024958	2015-10-28	2015-10-28 00:00:00	2015-10-28	5001	0	\N	0	0	\N	\N	0	200288	0	117015009	4024958		
777	57	3006322	2010-07-06	2010-07-06 00:00:00	2010-07-06	5001	0	\N	0	0	\N	\N	0	3851	0	8331-1	3006322		
16481	515	4024958	1969-01-21	1969-01-21 00:00:00	1969-01-21	5001	0	\N	0	0	\N	\N	0	34324	0	117015009	4024958		
55225	5051	3027231	1990-11-29	1990-11-29 00:00:00	1990-11-29	5001	0	\N	0	0	\N	\N	0	335899	0	6276-0	3027231		
38401	3541	3006322	1988-01-04	1988-01-04 00:00:00	1988-01-04	5001	0	\N	0	0	\N	\N	0	235176	0	8331-1	3006322		
49783	4529	3011505	2003-11-23	2003-11-23 00:00:00	2003-11-23	5001	0	\N	0	0	\N	\N	0	301555	0	19926-5	3011505		
32978	2976	3011505	1979-07-05	1979-07-05 00:00:00	1979-07-05	5001	0	\N	0	0	\N	\N	0	198729	0	19926-5	3011505		
33076	2986	3011505	2012-03-27	2012-03-27 00:00:00	2012-03-27	5001	0	\N	0	0	\N	\N	0	199317	0	19926-5	3011505		
84538	2619	4024958	1948-05-08	1948-05-08 00:00:00	1948-05-08	5001	0	\N	0	0	\N	\N	0	173204	0	117015009	4024958		
44490	4109	3006322	1999-06-11	1999-06-11 00:00:00	1999-06-11	5001	0	\N	0	0	\N	\N	0	273143	0	8331-1	3006322		
24624	2265	3015076	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	150540	0	6248-9	3015076		
127563	3926	4133840	1996-10-21	1996-10-21 00:00:00	1996-10-21	5001	0	\N	0	0	\N	\N	0	260916	0	127783003	4133840		
17885	1623	3006322	2002-05-12	2002-05-12 00:00:00	2002-05-12	5001	0	\N	0	0	\N	\N	0	109086	0	8331-1	3006322		
22170	2033	40758406	1976-02-10	1976-02-10 00:00:00	1976-02-10	5001	0	\N	0	0	\N	\N	0	135285	0	55277-8	40758406		
47544	4372	3020655	1981-01-19	1981-01-19 00:00:00	1981-01-19	5001	0	\N	0	0	\N	\N	0	290260	0	6844-5	3020655		
40643	3772	3012494	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	250687	0	6206-7	3012494		
40717	3783	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	251365	0	6248-9	3015076		
5001	482	3006322	1990-03-18	1990-03-18 00:00:00	1990-03-18	5001	0	\N	0	0	\N	\N	0	32217	0	8331-1	3006322		
37982	3510	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	232905	0	6206-7	3012494		
128090	3941	4052083	1963-12-19	1963-12-19 00:00:00	1963-12-19	5001	0	\N	0	0	\N	\N	0	261998	0	23426006	4052083		
29713	2739	3006322	1995-08-14	1995-08-14 00:00:00	1995-08-14	5001	0	\N	0	0	\N	\N	0	181212	0	8331-1	3006322		
47249	4352	3006322	2003-04-22	2003-04-22 00:00:00	2003-04-22	5001	0	\N	0	0	\N	\N	0	288708	0	8331-1	3006322		
8185	778	3006322	1994-02-06	1994-02-06 00:00:00	1994-02-06	5001	0	\N	0	0	\N	\N	0	51646	0	8331-1	3006322		
53604	1623	4052083	2009-04-08	2009-04-08 00:00:00	2009-04-08	5001	0	\N	0	0	\N	\N	0	109082	0	23426006	4052083		
4298	422	3006322	2011-03-04	2011-03-04 00:00:00	2011-03-04	5001	0	\N	0	0	\N	\N	0	27932	0	8331-1	3006322		
21431	1977	3006322	1917-11-18	1917-11-18 00:00:00	1917-11-18	5001	0	\N	0	0	\N	\N	0	131572	0	8331-1	3006322		
32798	2970	3005136	1999-05-06	1999-05-06 00:00:00	1999-05-06	5001	0	\N	0	0	\N	\N	0	198331	0	6075-6	3005136		
159843	4916	4024958	1988-04-22	1988-04-22 00:00:00	1988-04-22	5001	0	\N	0	0	\N	\N	0	326688	0	117015009	4024958		
96449	2955	4024958	1991-03-02	1991-03-02 00:00:00	1991-03-02	5001	0	\N	0	0	\N	\N	0	197206	0	117015009	4024958		
32548	1015	4052083	1994-11-25	1994-11-25 00:00:00	1994-11-25	5001	0	\N	0	0	\N	\N	0	66820	0	23426006	4052083		
28625	2647	3012494	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	175206	0	6206-7	3012494		
156086	4795	4052083	1991-06-28	1991-06-28 00:00:00	1991-06-28	5001	0	\N	0	0	\N	\N	0	318999	0	23426006	4052083		
55797	5118	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	340191	0	6248-9	3015076		
25054	2298	3006322	1972-02-23	1972-02-23 00:00:00	1972-02-23	5001	0	\N	0	0	\N	\N	0	153003	0	8331-1	3006322		
3572	340	3006322	2010-12-05	2010-12-05 00:00:00	2010-12-05	5001	0	\N	0	0	\N	\N	0	22673	0	8331-1	3006322		
87662	2709	4052083	2002-11-16	2002-11-16 00:00:00	2002-11-16	5001	0	\N	0	0	\N	\N	0	179443	0	23426006	4052083		
16844	1535	40766240	1991-06-24	1991-06-24 00:00:00	1991-06-24	5001	0	\N	0	0	\N	\N	0	102709	0	63513-6	40766240		
34904	3183	40769189	2014-02-10	2014-02-10 00:00:00	2014-02-10	5001	0	\N	0	0	\N	\N	0	211942	0	66529-9	40769189		
46226	4261	46235214	1957-01-27	1957-01-27 00:00:00	1957-01-27	5001	0	\N	0	0	\N	\N	0	282886	0	76690-7	46235214		
46824	4312	40769189	1961-02-16	1961-02-16 00:00:00	1961-02-16	5001	0	\N	0	0	\N	\N	0	286191	0	66529-9	40769189		
162244	4976	4052083	1981-06-05	1981-06-05 00:00:00	1981-06-05	5001	0	\N	0	0	\N	\N	0	330978	0	23426006	4052083		
39840	3701	40758406	1970-05-31	1970-05-31 00:00:00	1970-05-31	5001	0	\N	0	0	\N	\N	0	246118	0	55277-8	40758406		
51197	4685	3006322	1961-02-17	1961-02-17 00:00:00	1961-02-17	5001	0	\N	0	0	\N	\N	0	312105	0	8331-1	3006322		
28115	2588	3000963	2016-08-17	2016-08-17 00:00:00	2016-08-17	5001	0	\N	0	0	\N	\N	0	171266	0	718-7	3000963		
28253	2604	3006322	2000-04-28	2000-04-28 00:00:00	2000-04-28	5001	0	\N	0	0	\N	\N	0	172278	0	8331-1	3006322		
5033	487	3006322	1994-09-10	1994-09-10 00:00:00	1994-09-10	5001	0	\N	0	0	\N	\N	0	32597	0	8331-1	3006322		
5064	489	3012494	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	32817	0	6206-7	3012494		
30376	2779	3027231	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	184124	0	6276-0	3027231		
28970	2673	3001247	1990-02-12	1990-02-12 00:00:00	1990-02-12	5001	0	\N	0	0	\N	\N	0	177114	0	6085-5	3001247		
33906	3081	3051031	1999-02-09	1999-02-09 00:00:00	1999-02-09	5001	0	\N	0	0	\N	\N	0	205120	0	46240-8	3051031		
91989	2835	4024958	1981-10-28	1981-10-28 00:00:00	1981-10-28	5001	0	\N	0	0	\N	\N	0	188270	0	117015009	4024958		
83467	2578	4052083	1972-12-31	1972-12-31 00:00:00	1972-12-31	5001	0	\N	0	0	\N	\N	0	170752	0	23426006	4052083		
13293	1264	3011505	2007-10-19	2007-10-19 00:00:00	2007-10-19	5001	0	\N	0	0	\N	\N	0	83304	0	19926-5	3011505		
3938	394	3006322	1926-01-16	1926-01-16 00:00:00	1926-01-16	5001	0	\N	0	0	\N	\N	0	25874	0	8331-1	3006322		
24729	2274	3006322	2010-11-08	2010-11-08 00:00:00	2010-11-08	5001	0	\N	0	0	\N	\N	0	151146	0	8331-1	3006322		
128503	3956	4052083	1924-03-22	1924-03-22 00:00:00	1924-03-22	5001	0	\N	0	0	\N	\N	0	263025	0	23426006	4052083		
7948	761	3005136	1991-12-20	1991-12-20 00:00:00	1991-12-20	5001	0	\N	0	0	\N	\N	0	50594	0	6075-6	3005136		
47330	4364	3006322	1961-09-05	1961-09-05 00:00:00	1961-09-05	5001	0	\N	0	0	\N	\N	0	289454	0	8331-1	3006322		
52777	4847	3011505	1993-06-02	1993-06-02 00:00:00	1993-06-02	5001	0	\N	0	0	\N	\N	0	322455	0	19926-5	3011505		
166038	5103	4052083	1992-07-21	1992-07-21 00:00:00	1992-07-21	5001	0	\N	0	0	\N	\N	0	339099	0	23426006	4052083		
46420	4276	40758406	1954-03-25	1954-03-25 00:00:00	1954-03-25	5001	0	\N	0	0	\N	\N	0	283759	0	55277-8	40758406		
31338	2863	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	190443	0	6158-0	3019406		
96134	2945	4133840	1972-07-18	1972-07-18 00:00:00	1972-07-18	5001	0	\N	0	0	\N	\N	0	196514	0	127783003	4133840		
42377	3913	3019406	1981-11-09	1981-11-09 00:00:00	1981-11-09	5001	0	\N	0	0	\N	\N	0	260154	0	6158-0	3019406		
98125	3001	4052083	1961-12-03	1961-12-03 00:00:00	1961-12-03	5001	0	\N	0	0	\N	\N	0	200270	0	23426006	4052083		
778	57	3006322	1983-12-03	1983-12-03 00:00:00	1983-12-03	5001	0	\N	0	0	\N	\N	0	3870	0	8331-1	3006322		
16485	515	4052083	1971-09-12	1971-09-12 00:00:00	1971-09-12	5001	0	\N	0	0	\N	\N	0	34325	0	23426006	4052083		
55226	5051	3027231	1994-06-02	1994-06-02 00:00:00	1994-06-02	5001	0	\N	0	0	\N	\N	0	335889	0	6276-0	3027231		
38402	3541	3006322	1992-02-22	1992-02-22 00:00:00	1992-02-22	5001	0	\N	0	0	\N	\N	0	235177	0	8331-1	3006322		
49784	4529	3011505	2016-12-04	2016-12-04 00:00:00	2016-12-04	5001	0	\N	0	0	\N	\N	0	301603	0	19926-5	3011505		
32988	2980	3005136	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	198939	0	6075-6	3005136		
73113	2243	4052083	1982-07-23	1982-07-23 00:00:00	1982-07-23	5001	0	\N	0	0	\N	\N	0	149335	0	23426006	4052083		
84539	2619	4024958	1949-02-16	1949-02-16 00:00:00	1949-02-16	5001	0	\N	0	0	\N	\N	0	173147	0	117015009	4024958		
44491	4109	3006322	1982-04-16	1982-04-16 00:00:00	1982-04-16	5001	0	\N	0	0	\N	\N	0	273056	0	8331-1	3006322		
24625	2265	3001488	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	150540	0	7258-7	3001488		
127565	3926	4133840	1984-10-15	1984-10-15 00:00:00	1984-10-15	5001	0	\N	0	0	\N	\N	0	260949	0	127783003	4133840		
17886	1623	3006322	1979-01-20	1979-01-20 00:00:00	1979-01-20	5001	0	\N	0	0	\N	\N	0	109080	0	8331-1	3006322		
22172	2033	3051031	1976-02-10	1976-02-10 00:00:00	1976-02-10	5001	0	\N	0	0	\N	\N	0	135285	0	46240-8	3051031		
47545	4372	3001488	1981-01-19	1981-01-19 00:00:00	1981-01-19	5001	0	\N	0	0	\N	\N	0	290260	0	7258-7	3001488		
40644	3772	3036780	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	250687	0	6095-4	3036780		
40718	3783	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	251365	0	6276-0	3027231		
5002	482	3006322	1979-08-02	1979-08-02 00:00:00	1979-08-02	5001	0	\N	0	0	\N	\N	0	32256	0	8331-1	3006322		
37983	3510	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	232905	0	6246-3	3021226		
128093	3941	4052083	1969-06-20	1969-06-20 00:00:00	1969-06-20	5001	0	\N	0	0	\N	\N	0	262058	0	23426006	4052083		
29714	2739	3006322	1998-11-10	1998-11-10 00:00:00	1998-11-10	5001	0	\N	0	0	\N	\N	0	181263	0	8331-1	3006322		
47250	4352	3006322	1973-07-06	1973-07-06 00:00:00	1973-07-06	5001	0	\N	0	0	\N	\N	0	288658	0	8331-1	3006322		
8186	778	3006322	1980-11-05	1980-11-05 00:00:00	1980-11-05	5001	0	\N	0	0	\N	\N	0	51688	0	8331-1	3006322		
53616	1623	4024958	1953-11-17	1953-11-17 00:00:00	1953-11-17	5001	0	\N	0	0	\N	\N	0	109131	0	117015009	4024958		
73548	2261	4052083	1974-01-13	1974-01-13 00:00:00	1974-01-13	5001	0	\N	0	0	\N	\N	0	150300	0	23426006	4052083		
21432	1977	3006322	1913-02-25	1913-02-25 00:00:00	1913-02-25	5001	0	\N	0	0	\N	\N	0	131554	0	8331-1	3006322		
32799	2970	3014599	1999-05-06	1999-05-06 00:00:00	1999-05-06	5001	0	\N	0	0	\N	\N	0	198331	0	6106-9	3014599		
159847	4916	4024958	2013-06-04	2013-06-04 00:00:00	2013-06-04	5001	0	\N	0	0	\N	\N	0	326690	0	117015009	4024958		
96454	2955	4052083	1983-05-02	1983-05-02 00:00:00	1983-05-02	5001	0	\N	0	0	\N	\N	0	197204	0	23426006	4052083		
32578	1015	4052083	2012-10-31	2012-10-31 00:00:00	2012-10-31	5001	0	\N	0	0	\N	\N	0	66795	0	23426006	4052083		
28626	2647	3001247	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	175206	0	6085-5	3001247		
39976	3717	3001488	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	246997	0	7258-7	3001488		
55798	5118	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	340191	0	6276-0	3027231		
25059	2300	3011505	2013-03-07	2013-03-07 00:00:00	2013-03-07	5001	0	\N	0	0	\N	\N	0	153153	0	19926-5	3011505		
3573	341	3011505	2017-08-28	2017-08-28 00:00:00	2017-08-28	5001	0	\N	0	0	\N	\N	0	22799	0	19926-5	3011505		
110922	3428	4052083	1978-07-22	1978-07-22 00:00:00	1978-07-22	5001	0	\N	0	0	\N	\N	0	227249	0	23426006	4052083		
16846	1535	3006322	1999-10-19	1999-10-19 00:00:00	1999-10-19	5001	0	\N	0	0	\N	\N	0	102739	0	8331-1	3006322		
34905	3183	40769184	2014-02-10	2014-02-10 00:00:00	2014-02-10	5001	0	\N	0	0	\N	\N	0	211942	0	66524-0	40769184		
46227	4261	40758406	1957-01-27	1957-01-27 00:00:00	1957-01-27	5001	0	\N	0	0	\N	\N	0	282886	0	55277-8	40758406		
46825	4312	3006322	1963-08-28	1963-08-28 00:00:00	1963-08-28	5001	0	\N	0	0	\N	\N	0	286109	0	8331-1	3006322		
162253	4977	4052083	1982-06-02	1982-06-02 00:00:00	1982-06-02	5001	0	\N	0	0	\N	\N	0	331110	0	23426006	4052083		
39842	3701	3051031	1970-05-31	1970-05-31 00:00:00	1970-05-31	5001	0	\N	0	0	\N	\N	0	246118	0	46240-8	3051031		
51198	4685	3006322	1948-07-18	1948-07-18 00:00:00	1948-07-18	5001	0	\N	0	0	\N	\N	0	312137	0	8331-1	3006322		
28116	2588	3009542	2016-08-17	2016-08-17 00:00:00	2016-08-17	5001	0	\N	0	0	\N	\N	0	171266	0	20570-8	3009542		
28254	2604	3006322	1986-03-04	1986-03-04 00:00:00	1986-03-04	5001	0	\N	0	0	\N	\N	0	172254	0	8331-1	3006322		
28272	2609	3006322	1989-01-06	1989-01-06 00:00:00	1989-01-06	5001	0	\N	0	0	\N	\N	0	172477	0	8331-1	3006322		
5065	489	3015076	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	32817	0	6248-9	3015076		
30377	2779	3019406	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	184124	0	6158-0	3019406		
28971	2673	3006734	1990-02-12	1990-02-12 00:00:00	1990-02-12	5001	0	\N	0	0	\N	\N	0	177114	0	6189-5	3006734		
33907	3081	40758406	1999-02-09	1999-02-09 00:00:00	1999-02-09	5001	0	\N	0	0	\N	\N	0	205120	0	55277-8	40758406		
103303	3177	4052083	1936-05-16	1936-05-16 00:00:00	1936-05-16	5001	0	\N	0	0	\N	\N	0	211266	0	23426006	4052083		
1924	173	3006322	1994-11-11	1994-11-11 00:00:00	1994-11-11	5001	0	\N	0	0	\N	\N	0	11790	0	8331-1	3006322		
13294	1264	3011505	1990-01-12	1990-01-12 00:00:00	1990-01-12	5001	0	\N	0	0	\N	\N	0	83356	0	19926-5	3011505		
116984	3604	4052083	1993-02-17	1993-02-17 00:00:00	1993-02-17	5001	0	\N	0	0	\N	\N	0	239475	0	23426006	4052083		
24730	2274	3006322	2004-08-10	2004-08-10 00:00:00	2004-08-10	5001	0	\N	0	0	\N	\N	0	151194	0	8331-1	3006322		
11616	366	4052083	1965-07-10	1965-07-10 00:00:00	1965-07-10	5001	0	\N	0	0	\N	\N	0	24274	0	23426006	4052083		
7949	761	3006322	2008-02-23	2008-02-23 00:00:00	2008-02-23	5001	0	\N	0	0	\N	\N	0	50583	0	8331-1	3006322		
47331	4364	3006322	1958-08-25	1958-08-25 00:00:00	1958-08-25	5001	0	\N	0	0	\N	\N	0	289467	0	8331-1	3006322		
52778	4847	3011505	2011-03-16	2011-03-16 00:00:00	2011-03-16	5001	0	\N	0	0	\N	\N	0	322453	0	19926-5	3011505		
17500	549	4024958	1985-12-22	1985-12-22 00:00:00	1985-12-22	5001	0	\N	0	0	\N	\N	0	36357	0	117015009	4024958		
46422	4276	40766240	1954-01-24	1954-01-24 00:00:00	1954-01-24	5001	0	\N	0	0	\N	\N	0	283725	0	63513-6	40766240		
31339	2863	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	190443	0	6082-2	3000876		
96135	2945	4052083	2007-12-31	2007-12-31 00:00:00	2007-12-31	5001	0	\N	0	0	\N	\N	0	196527	0	23426006	4052083		
42378	3913	3014599	1981-11-09	1981-11-09 00:00:00	1981-11-09	5001	0	\N	0	0	\N	\N	0	260154	0	6106-9	3014599		
98135	3001	4024958	1957-08-28	1957-08-28 00:00:00	1957-08-28	5001	0	\N	0	0	\N	\N	0	200235	0	117015009	4024958		
779	57	3006322	2008-06-04	2008-06-04 00:00:00	2008-06-04	5001	0	\N	0	0	\N	\N	0	3872	0	8331-1	3006322		
16493	515	4024958	2005-06-12	2005-06-12 00:00:00	2005-06-12	5001	0	\N	0	0	\N	\N	0	34415	0	117015009	4024958		
55227	5051	3001488	1994-06-02	1994-06-02 00:00:00	1994-06-02	5001	0	\N	0	0	\N	\N	0	335889	0	7258-7	3001488		
38403	3541	3006322	2018-09-27	2018-09-27 00:00:00	2018-09-27	5001	0	\N	0	0	\N	\N	0	235213	0	8331-1	3006322		
49785	4529	3011505	1992-02-02	1992-02-02 00:00:00	1992-02-02	5001	0	\N	0	0	\N	\N	0	301554	0	19926-5	3011505		
32989	2980	3001488	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	198939	0	7258-7	3001488		
73120	2243	4024958	2018-12-25	2018-12-25 00:00:00	2018-12-25	5001	0	\N	0	0	\N	\N	0	149339	0	117015009	4024958		
84544	2619	4052083	1964-04-18	1964-04-18 00:00:00	1964-04-18	5001	0	\N	0	0	\N	\N	0	173141	0	23426006	4052083		
44492	4109	3006322	1981-06-07	1981-06-07 00:00:00	1981-06-07	5001	0	\N	0	0	\N	\N	0	273127	0	8331-1	3006322		
24626	2265	3020655	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	150540	0	6844-5	3020655		
127566	3926	4133840	1998-11-02	1998-11-02 00:00:00	1998-11-02	5001	0	\N	0	0	\N	\N	0	261000	0	127783003	4133840		
17887	1623	3006322	1953-11-17	1953-11-17 00:00:00	1953-11-17	5001	0	\N	0	0	\N	\N	0	109131	0	8331-1	3006322		
12688	406	4024958	1959-12-25	1959-12-25 00:00:00	1959-12-25	5001	0	\N	0	0	\N	\N	0	26807	0	117015009	4024958		
47546	4372	3000876	1981-01-19	1981-01-19 00:00:00	1981-01-19	5001	0	\N	0	0	\N	\N	0	290260	0	6082-2	3000876		
40645	3772	3019406	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	250687	0	6158-0	3019406		
40719	3783	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	251365	0	6106-9	3014599		
5008	484	3006322	1940-01-27	1940-01-27 00:00:00	1940-01-27	5001	0	\N	0	0	\N	\N	0	32305	0	8331-1	3006322		
37984	3510	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	232905	0	6095-4	3036780		
128095	3941	4024958	1965-06-13	1965-06-13 00:00:00	1965-06-13	5001	0	\N	0	0	\N	\N	0	262057	0	117015009	4024958		
41014	3803	3006322	1973-05-09	1973-05-09 00:00:00	1973-05-09	5001	0	\N	0	0	\N	\N	0	252768	0	8331-1	3006322		
47251	4353	3006322	1968-05-31	1968-05-31 00:00:00	1968-05-31	5001	0	\N	0	0	\N	\N	0	288728	0	8331-1	3006322		
19512	1782	3006322	2008-11-11	2008-11-11 00:00:00	2008-11-11	5001	0	\N	0	0	\N	\N	0	119327	0	8331-1	3006322		
26465	828	4024958	1994-07-28	1994-07-28 00:00:00	1994-07-28	5001	0	\N	0	0	\N	\N	0	54843	0	117015009	4024958		
84859	2630	4052083	2015-09-04	2015-09-04 00:00:00	2015-09-04	5001	0	\N	0	0	\N	\N	0	173937	0	23426006	4052083		
21433	1977	3006322	1921-12-10	1921-12-10 00:00:00	1921-12-10	5001	0	\N	0	0	\N	\N	0	131555	0	8331-1	3006322		
32800	2970	3023430	1999-05-06	1999-05-06 00:00:00	1999-05-06	5001	0	\N	0	0	\N	\N	0	198331	0	6833-8	3023430		
171129	5251	4024958	1943-01-20	1943-01-20 00:00:00	1943-01-20	5001	0	\N	0	0	\N	\N	0	349317	0	117015009	4024958		
96460	2955	4024958	2005-02-01	2005-02-01 00:00:00	2005-02-01	5001	0	\N	0	0	\N	\N	0	197263	0	117015009	4024958		
43858	1352	4133840	2006-04-30	2006-04-30 00:00:00	2006-04-30	5001	0	\N	0	0	\N	\N	0	89542	0	127783003	4133840		
28627	2647	3015076	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	175206	0	6248-9	3015076		
39977	3717	3023430	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	246997	0	6833-8	3023430		
55799	5118	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	340191	0	6273-7	3006451		
25060	2300	3011505	2014-03-13	2014-03-13 00:00:00	2014-03-13	5001	0	\N	0	0	\N	\N	0	153136	0	19926-5	3011505		
3574	341	3006322	1969-10-24	1969-10-24 00:00:00	1969-10-24	5001	0	\N	0	0	\N	\N	0	22761	0	8331-1	3006322		
110929	3428	4024958	2007-05-15	2007-05-15 00:00:00	2007-05-15	5001	0	\N	0	0	\N	\N	0	227268	0	117015009	4024958		
16847	1535	3006322	2016-03-31	2016-03-31 00:00:00	2016-03-31	5001	0	\N	0	0	\N	\N	0	102756	0	8331-1	3006322		
46187	4260	3006322	1982-09-08	1982-09-08 00:00:00	1982-09-08	5001	0	\N	0	0	\N	\N	0	282806	0	8331-1	3006322		
46228	4261	40766240	1957-12-23	1957-12-23 00:00:00	1957-12-23	5001	0	\N	0	0	\N	\N	0	282963	0	63513-6	40766240		
46826	4312	3006322	1987-07-09	1987-07-09 00:00:00	1987-07-09	5001	0	\N	0	0	\N	\N	0	286209	0	8331-1	3006322		
162254	4977	4024958	2000-03-18	2000-03-18 00:00:00	2000-03-18	5001	0	\N	0	0	\N	\N	0	331193	0	117015009	4024958		
39843	3701	46235214	1970-05-31	1970-05-31 00:00:00	1970-05-31	5001	0	\N	0	0	\N	\N	0	246118	0	76690-7	46235214		
51200	4685	3006322	1953-10-01	1953-10-01 00:00:00	1953-10-01	5001	0	\N	0	0	\N	\N	0	312101	0	8331-1	3006322		
28117	2588	3011505	2012-10-14	2012-10-14 00:00:00	2012-10-14	5001	0	\N	0	0	\N	\N	0	171263	0	19926-5	3011505		
28255	2604	3006322	1989-08-23	1989-08-23 00:00:00	1989-08-23	5001	0	\N	0	0	\N	\N	0	172300	0	8331-1	3006322		
28273	2609	3006322	2013-04-11	2013-04-11 00:00:00	2013-04-11	5001	0	\N	0	0	\N	\N	0	172499	0	8331-1	3006322		
5066	489	3027231	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	32817	0	6276-0	3027231		
30378	2779	3001488	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	184124	0	7258-7	3001488		
28972	2673	3020655	1990-02-12	1990-02-12 00:00:00	1990-02-12	5001	0	\N	0	0	\N	\N	0	177114	0	6844-5	3020655		
33908	3081	46235214	1999-11-06	1999-11-06 00:00:00	1999-11-06	5001	0	\N	0	0	\N	\N	0	205144	0	76690-7	46235214		
103311	3177	4052083	2008-06-05	2008-06-05 00:00:00	2008-06-05	5001	0	\N	0	0	\N	\N	0	211321	0	23426006	4052083		
1925	173	3006322	1968-04-27	1968-04-27 00:00:00	1968-04-27	5001	0	\N	0	0	\N	\N	0	11764	0	8331-1	3006322		
13295	1264	3011505	1995-04-21	1995-04-21 00:00:00	1995-04-21	5001	0	\N	0	0	\N	\N	0	83344	0	19926-5	3011505		
116987	3604	4024958	1992-06-03	1992-06-03 00:00:00	1992-06-03	5001	0	\N	0	0	\N	\N	0	239526	0	117015009	4024958		
24731	2274	3006322	1983-03-10	1983-03-10 00:00:00	1983-03-10	5001	0	\N	0	0	\N	\N	0	151136	0	8331-1	3006322		
11618	366	4052083	1961-10-03	1961-10-03 00:00:00	1961-10-03	5001	0	\N	0	0	\N	\N	0	24385	0	23426006	4052083		
7950	761	3014599	1995-06-23	1995-06-23 00:00:00	1995-06-23	5001	0	\N	0	0	\N	\N	0	50626	0	6106-9	3014599		
47332	4364	3006322	2007-07-20	2007-07-20 00:00:00	2007-07-20	5001	0	\N	0	0	\N	\N	0	289465	0	8331-1	3006322		
52779	4847	3011505	2010-03-10	2010-03-10 00:00:00	2010-03-10	5001	0	\N	0	0	\N	\N	0	322479	0	19926-5	3011505		
17610	552	4024958	1958-05-10	1958-05-10 00:00:00	1958-05-10	5001	0	\N	0	0	\N	\N	0	36565	0	117015009	4024958		
46423	4276	46235214	1954-01-24	1954-01-24 00:00:00	1954-01-24	5001	0	\N	0	0	\N	\N	0	283725	0	76690-7	46235214		
31340	2863	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	190443	0	6095-4	3036780		
96137	2945	4024958	1964-01-21	1964-01-21 00:00:00	1964-01-21	5001	0	\N	0	0	\N	\N	0	196482	0	117015009	4024958		
42379	3913	3005136	1981-11-09	1981-11-09 00:00:00	1981-11-09	5001	0	\N	0	0	\N	\N	0	260154	0	6075-6	3005136		
42840	3957	40766240	1965-08-15	1965-08-15 00:00:00	1965-08-15	5001	0	\N	0	0	\N	\N	0	263096	0	63513-6	40766240		
780	57	3006322	1976-10-29	1976-10-29 00:00:00	1976-10-29	5001	0	\N	0	0	\N	\N	0	3823	0	8331-1	3006322		
16510	515	4024958	1955-10-07	1955-10-07 00:00:00	1955-10-07	5001	0	\N	0	0	\N	\N	0	34348	0	117015009	4024958		
55228	5051	3036780	1994-06-02	1994-06-02 00:00:00	1994-06-02	5001	0	\N	0	0	\N	\N	0	335889	0	6095-4	3036780		
38404	3542	3006322	1992-09-12	1992-09-12 00:00:00	1992-09-12	5001	0	\N	0	0	\N	\N	0	235264	0	8331-1	3006322		
49786	4529	3006322	2017-10-28	2017-10-28 00:00:00	2017-10-28	5001	0	\N	0	0	\N	\N	0	301604	0	8331-1	3006322		
32990	2980	3020655	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	198939	0	6844-5	3020655		
73121	2243	4052083	1978-12-08	1978-12-08 00:00:00	1978-12-08	5001	0	\N	0	0	\N	\N	0	149328	0	23426006	4052083		
104484	3217	4024958	2006-12-08	2006-12-08 00:00:00	2006-12-08	5001	0	\N	0	0	\N	\N	0	213766	0	117015009	4024958		
44493	4109	3014599	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	273140	0	6106-9	3014599		
24627	2265	3023430	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	150540	0	6833-8	3023430		
127567	3926	4133840	2005-01-31	2005-01-31 00:00:00	2005-01-31	5001	0	\N	0	0	\N	\N	0	260917	0	127783003	4133840		
126118	3884	4024958	2005-05-22	2005-05-22 00:00:00	2005-05-22	5001	0	\N	0	0	\N	\N	0	258155	0	117015009	4024958		
12692	406	4052083	1966-02-06	1966-02-06 00:00:00	1966-02-06	5001	0	\N	0	0	\N	\N	0	26829	0	23426006	4052083		
47547	4372	3036780	1981-01-19	1981-01-19 00:00:00	1981-01-19	5001	0	\N	0	0	\N	\N	0	290260	0	6095-4	3036780		
40646	3772	3020655	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	250687	0	6844-5	3020655		
40720	3783	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	251365	0	6158-0	3019406		
5009	484	3006322	1999-08-08	1999-08-08 00:00:00	1999-08-08	5001	0	\N	0	0	\N	\N	0	32311	0	8331-1	3006322		
37985	3510	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	232905	0	6082-2	3000876		
128098	3941	4052083	1964-10-30	1964-10-30 00:00:00	1964-10-30	5001	0	\N	0	0	\N	\N	0	262045	0	23426006	4052083		
41015	3803	3006322	1973-07-22	1973-07-22 00:00:00	1973-07-22	5001	0	\N	0	0	\N	\N	0	252805	0	8331-1	3006322		
47252	4353	3006322	1990-05-20	1990-05-20 00:00:00	1990-05-20	5001	0	\N	0	0	\N	\N	0	288757	0	8331-1	3006322		
19513	1782	3006322	2003-09-17	2003-09-17 00:00:00	2003-09-17	5001	0	\N	0	0	\N	\N	0	119348	0	8331-1	3006322		
26467	828	4052083	2000-01-13	2000-01-13 00:00:00	2000-01-13	5001	0	\N	0	0	\N	\N	0	54844	0	23426006	4052083		
84870	2630	4024958	1962-01-09	1962-01-09 00:00:00	1962-01-09	5001	0	\N	0	0	\N	\N	0	173982	0	117015009	4024958		
21434	1977	3006322	1988-05-20	1988-05-20 00:00:00	1988-05-20	5001	0	\N	0	0	\N	\N	0	131560	0	8331-1	3006322		
32801	2970	3006451	1999-05-06	1999-05-06 00:00:00	1999-05-06	5001	0	\N	0	0	\N	\N	0	198331	0	6273-7	3006451		
171130	5251	4052083	1954-04-13	1954-04-13 00:00:00	1954-04-13	5001	0	\N	0	0	\N	\N	0	349364	0	23426006	4052083		
96461	2955	4024958	2012-07-10	2012-07-10 00:00:00	2012-07-10	5001	0	\N	0	0	\N	\N	0	197208	0	117015009	4024958		
43859	1352	4133840	2014-06-15	2014-06-15 00:00:00	2014-06-15	5001	0	\N	0	0	\N	\N	0	89557	0	127783003	4133840		
28628	2647	3021226	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	175206	0	6246-3	3021226		
39978	3717	3020655	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	246997	0	6844-5	3020655		
55800	5118	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	340191	0	6246-3	3021226		
36344	3339	3006322	1968-08-09	1968-08-09 00:00:00	1968-08-09	5001	0	\N	0	0	\N	\N	0	221532	0	8331-1	3006322		
3575	341	3006322	1978-10-19	1978-10-19 00:00:00	1978-10-19	5001	0	\N	0	0	\N	\N	0	22805	0	8331-1	3006322		
110941	3428	4024958	2009-10-15	2009-10-15 00:00:00	2009-10-15	5001	0	\N	0	0	\N	\N	0	227252	0	117015009	4024958		
16848	1535	46235214	1979-11-29	1979-11-29 00:00:00	1979-11-29	5001	0	\N	0	0	\N	\N	0	102717	0	76690-7	46235214		
46188	4260	3006322	1940-05-02	1940-05-02 00:00:00	1940-05-02	5001	0	\N	0	0	\N	\N	0	282808	0	8331-1	3006322		
46229	4261	3051031	1957-12-23	1957-12-23 00:00:00	1957-12-23	5001	0	\N	0	0	\N	\N	0	282963	0	46240-8	3051031		
46827	4312	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	286058	0	6844-5	3020655		
162260	4977	4052083	2015-03-31	2015-03-31 00:00:00	2015-03-31	5001	0	\N	0	0	\N	\N	0	331114	0	23426006	4052083		
39844	3701	40758406	1970-09-28	1970-09-28 00:00:00	1970-09-28	5001	0	\N	0	0	\N	\N	0	246037	0	55277-8	40758406		
51201	4685	3006322	1957-11-19	1957-11-19 00:00:00	1957-11-19	5001	0	\N	0	0	\N	\N	0	312104	0	8331-1	3006322		
28118	2588	3006322	1994-11-17	1994-11-17 00:00:00	1994-11-17	5001	0	\N	0	0	\N	\N	0	171246	0	8331-1	3006322		
28256	2604	3006322	1991-02-28	1991-02-28 00:00:00	1991-02-28	5001	0	\N	0	0	\N	\N	0	172255	0	8331-1	3006322		
28274	2609	3006322	1974-12-08	1974-12-08 00:00:00	1974-12-08	5001	0	\N	0	0	\N	\N	0	172474	0	8331-1	3006322		
5067	489	3021226	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	32817	0	6246-3	3021226		
30379	2779	3012494	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	184124	0	6206-7	3012494		
28973	2673	3023430	1990-02-12	1990-02-12 00:00:00	1990-02-12	5001	0	\N	0	0	\N	\N	0	177114	0	6833-8	3023430		
33909	3081	40758406	1999-11-06	1999-11-06 00:00:00	1999-11-06	5001	0	\N	0	0	\N	\N	0	205144	0	55277-8	40758406		
56138	5150	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	342380	0	6075-6	3005136		
1926	173	3006322	1986-09-15	1986-09-15 00:00:00	1986-09-15	5001	0	\N	0	0	\N	\N	0	11768	0	8331-1	3006322		
13296	1264	3011505	2000-01-21	2000-01-21 00:00:00	2000-01-21	5001	0	\N	0	0	\N	\N	0	83303	0	19926-5	3011505		
117010	3604	4024958	1998-02-16	1998-02-16 00:00:00	1998-02-16	5001	0	\N	0	0	\N	\N	0	239481	0	117015009	4024958		
24732	2274	3006322	1954-10-25	1954-10-25 00:00:00	1954-10-25	5001	0	\N	0	0	\N	\N	0	151189	0	8331-1	3006322		
22918	719	4024958	2007-04-13	2007-04-13 00:00:00	2007-04-13	5001	0	\N	0	0	\N	\N	0	47559	0	117015009	4024958		
7951	761	3001488	1995-06-23	1995-06-23 00:00:00	1995-06-23	5001	0	\N	0	0	\N	\N	0	50626	0	7258-7	3001488		
47333	4364	3006322	2013-01-31	2013-01-31 00:00:00	2013-01-31	5001	0	\N	0	0	\N	\N	0	289470	0	8331-1	3006322		
52780	4847	3011505	2009-03-04	2009-03-04 00:00:00	2009-03-04	5001	0	\N	0	0	\N	\N	0	322452	0	19926-5	3011505		
17611	552	4024958	1958-11-20	1958-11-20 00:00:00	1958-11-20	5001	0	\N	0	0	\N	\N	0	36579	0	117015009	4024958		
46425	4276	3051031	1954-01-24	1954-01-24 00:00:00	1954-01-24	5001	0	\N	0	0	\N	\N	0	283725	0	46240-8	3051031		
31341	2863	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	190443	0	6844-5	3020655		
10010	320	4024958	1981-11-19	1981-11-19 00:00:00	1981-11-19	5001	0	\N	0	0	\N	\N	0	21227	0	117015009	4024958		
42380	3913	3015076	1981-11-09	1981-11-09 00:00:00	1981-11-09	5001	0	\N	0	0	\N	\N	0	260154	0	6248-9	3015076		
42841	3957	3011505	2006-01-12	2006-01-12 00:00:00	2006-01-12	5001	0	\N	0	0	\N	\N	0	263117	0	19926-5	3011505		
25486	795	4024958	2018-12-17	2018-12-17 00:00:00	2018-12-17	5001	0	\N	0	0	\N	\N	0	52745	0	117015009	4024958		
119908	3697	4052083	1960-07-05	1960-07-05 00:00:00	1960-07-05	5001	0	\N	0	0	\N	\N	0	245799	0	23426006	4052083		
55229	5051	3000876	1994-06-02	1994-06-02 00:00:00	1994-06-02	5001	0	\N	0	0	\N	\N	0	335889	0	6082-2	3000876		
38405	3542	3006322	1990-05-09	1990-05-09 00:00:00	1990-05-09	5001	0	\N	0	0	\N	\N	0	235236	0	8331-1	3006322		
49787	4529	3011505	2005-11-27	2005-11-27 00:00:00	2005-11-27	5001	0	\N	0	0	\N	\N	0	301580	0	19926-5	3011505		
32991	2980	3021226	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	198939	0	6246-3	3021226		
73137	2244	4024958	1972-11-24	1972-11-24 00:00:00	1972-11-24	5001	0	\N	0	0	\N	\N	0	149391	0	117015009	4024958		
104519	3218	4052083	1973-09-30	1973-09-30 00:00:00	1973-09-30	5001	0	\N	0	0	\N	\N	0	213860	0	23426006	4052083		
44494	4109	3020655	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	273140	0	6844-5	3020655		
24628	2265	3036780	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	150540	0	6095-4	3036780		
127569	3926	4133840	2012-06-25	2012-06-25 00:00:00	2012-06-25	5001	0	\N	0	0	\N	\N	0	260920	0	127783003	4133840		
126156	3885	4024958	1973-06-17	1973-06-17 00:00:00	1973-06-17	5001	0	\N	0	0	\N	\N	0	258282	0	117015009	4024958		
23991	752	4052083	1952-12-09	1952-12-09 00:00:00	1952-12-09	5001	0	\N	0	0	\N	\N	0	49701	0	23426006	4052083		
47548	4372	3006451	1981-01-19	1981-01-19 00:00:00	1981-01-19	5001	0	\N	0	0	\N	\N	0	290260	0	6273-7	3006451		
40647	3772	3000876	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	250687	0	6082-2	3000876		
40721	3783	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	251365	0	6273-7	3006451		
5010	484	3006322	1991-06-26	1991-06-26 00:00:00	1991-06-26	5001	0	\N	0	0	\N	\N	0	32365	0	8331-1	3006322		
37986	3510	3006322	1993-10-18	1993-10-18 00:00:00	1993-10-18	5001	0	\N	0	0	\N	\N	0	232830	0	8331-1	3006322		
128105	3942	4024958	1981-04-08	1981-04-08 00:00:00	1981-04-08	5001	0	\N	0	0	\N	\N	0	262077	0	117015009	4024958		
41016	3803	3006322	2003-04-14	2003-04-14 00:00:00	2003-04-14	5001	0	\N	0	0	\N	\N	0	252766	0	8331-1	3006322		
37426	1159	4024958	2002-09-02	2002-09-02 00:00:00	2002-09-02	5001	0	\N	0	0	\N	\N	0	76580	0	117015009	4024958		
19514	1782	3006322	1956-10-08	1956-10-08 00:00:00	1956-10-08	5001	0	\N	0	0	\N	\N	0	119371	0	8331-1	3006322		
26475	828	4024958	1956-04-06	1956-04-06 00:00:00	1956-04-06	5001	0	\N	0	0	\N	\N	0	54813	0	117015009	4024958		
54319	1649	4024958	1963-08-29	1963-08-29 00:00:00	1963-08-29	5001	0	\N	0	0	\N	\N	0	110657	0	117015009	4024958		
21435	1977	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	131561	0	6075-6	3005136		
32802	2970	3027231	1999-05-06	1999-05-06 00:00:00	1999-05-06	5001	0	\N	0	0	\N	\N	0	198331	0	6276-0	3027231		
171134	5251	4024958	1947-12-11	1947-12-11 00:00:00	1947-12-11	5001	0	\N	0	0	\N	\N	0	349334	0	117015009	4024958		
96462	2955	4024958	1997-12-13	1997-12-13 00:00:00	1997-12-13	5001	0	\N	0	0	\N	\N	0	197238	0	117015009	4024958		
43861	1352	4052083	1959-08-12	1959-08-12 00:00:00	1959-08-12	5001	0	\N	0	0	\N	\N	0	89534	0	23426006	4052083		
28629	2647	3006451	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	175206	0	6273-7	3006451		
39979	3717	3006451	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	246997	0	6273-7	3006451		
55801	5118	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	340191	0	6158-0	3019406		
36345	3339	3006322	1969-02-14	1969-02-14 00:00:00	1969-02-14	5001	0	\N	0	0	\N	\N	0	221475	0	8331-1	3006322		
3576	341	3011505	2018-12-03	2018-12-03 00:00:00	2018-12-03	5001	0	\N	0	0	\N	\N	0	22765	0	19926-5	3011505		
110942	3428	4052083	2003-10-25	2003-10-25 00:00:00	2003-10-25	5001	0	\N	0	0	\N	\N	0	227250	0	23426006	4052083		
16850	1535	3051031	1979-11-29	1979-11-29 00:00:00	1979-11-29	5001	0	\N	0	0	\N	\N	0	102717	0	46240-8	3051031		
46189	4260	3006322	2016-10-11	2016-10-11 00:00:00	2016-10-11	5001	0	\N	0	0	\N	\N	0	282790	0	8331-1	3006322		
46230	4261	46235214	1957-12-23	1957-12-23 00:00:00	1957-12-23	5001	0	\N	0	0	\N	\N	0	282963	0	76690-7	46235214		
46828	4312	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	286058	0	6082-2	3000876		
162266	4977	4024958	1999-12-06	1999-12-06 00:00:00	1999-12-06	5001	0	\N	0	0	\N	\N	0	331192	0	117015009	4024958		
39845	3701	40766240	1970-09-28	1970-09-28 00:00:00	1970-09-28	5001	0	\N	0	0	\N	\N	0	246037	0	63513-6	40766240		
51202	4685	3006322	1952-01-28	1952-01-28 00:00:00	1952-01-28	5001	0	\N	0	0	\N	\N	0	312138	0	8331-1	3006322		
28119	2588	3006322	1999-03-09	1999-03-09 00:00:00	1999-03-09	5001	0	\N	0	0	\N	\N	0	171278	0	8331-1	3006322		
28257	2604	3006322	1996-10-08	1996-10-08 00:00:00	1996-10-08	5001	0	\N	0	0	\N	\N	0	172277	0	8331-1	3006322		
28276	2610	3006322	1964-05-01	1964-05-01 00:00:00	1964-05-01	5001	0	\N	0	0	\N	\N	0	172537	0	8331-1	3006322		
5068	489	3005136	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	32817	0	6075-6	3005136		
30380	2779	3006451	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	184124	0	6273-7	3006451		
28974	2673	3014599	1990-02-12	1990-02-12 00:00:00	1990-02-12	5001	0	\N	0	0	\N	\N	0	177114	0	6106-9	3014599		
33910	3081	3051031	1999-11-06	1999-11-06 00:00:00	1999-11-06	5001	0	\N	0	0	\N	\N	0	205144	0	46240-8	3051031		
56139	5150	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	342380	0	6106-9	3014599		
1927	173	3006322	1976-10-23	1976-10-23 00:00:00	1976-10-23	5001	0	\N	0	0	\N	\N	0	11749	0	8331-1	3006322		
13297	1264	3011505	2004-02-27	2004-02-27 00:00:00	2004-02-27	5001	0	\N	0	0	\N	\N	0	83285	0	19926-5	3011505		
117021	3604	4024958	2005-06-21	2005-06-21 00:00:00	2005-06-21	5001	0	\N	0	0	\N	\N	0	239497	0	117015009	4024958		
24733	2274	3006322	1983-12-14	1983-12-14 00:00:00	1983-12-14	5001	0	\N	0	0	\N	\N	0	151145	0	8331-1	3006322		
22930	719	4052083	2005-05-31	2005-05-31 00:00:00	2005-05-31	5001	0	\N	0	0	\N	\N	0	47568	0	23426006	4052083		
7952	761	3006451	1995-06-23	1995-06-23 00:00:00	1995-06-23	5001	0	\N	0	0	\N	\N	0	50626	0	6273-7	3006451		
47334	4365	3006322	1993-12-09	1993-12-09 00:00:00	1993-12-09	5001	0	\N	0	0	\N	\N	0	289523	0	8331-1	3006322		
52781	4847	3011505	2004-02-11	2004-02-11 00:00:00	2004-02-11	5001	0	\N	0	0	\N	\N	0	322451	0	19926-5	3011505		
17805	558	4024958	1981-11-27	1981-11-27 00:00:00	1981-11-27	5001	0	\N	0	0	\N	\N	0	36971	0	117015009	4024958		
46426	4276	40758406	1954-01-24	1954-01-24 00:00:00	1954-01-24	5001	0	\N	0	0	\N	\N	0	283725	0	55277-8	40758406		
31342	2863	3006322	1969-08-27	1969-08-27 00:00:00	1969-08-27	5001	0	\N	0	0	\N	\N	0	190426	0	8331-1	3006322		
10011	320	4133840	2007-02-25	2007-02-25 00:00:00	2007-02-25	5001	0	\N	0	0	\N	\N	0	21191	0	127783003	4133840		
42381	3913	3006451	1981-11-09	1981-11-09 00:00:00	1981-11-09	5001	0	\N	0	0	\N	\N	0	260154	0	6273-7	3006451		
42842	3957	3011505	2006-09-07	2006-09-07 00:00:00	2006-09-07	5001	0	\N	0	0	\N	\N	0	263080	0	19926-5	3011505		
25487	795	4024958	2018-09-09	2018-09-09 00:00:00	2018-09-09	5001	0	\N	0	0	\N	\N	0	52777	0	117015009	4024958		
119922	3697	4052083	1986-09-10	1986-09-10 00:00:00	1986-09-10	5001	0	\N	0	0	\N	\N	0	245802	0	23426006	4052083		
55230	5051	3005136	1994-06-02	1994-06-02 00:00:00	1994-06-02	5001	0	\N	0	0	\N	\N	0	335889	0	6075-6	3005136		
38406	3542	3006322	1964-09-07	1964-09-07 00:00:00	1964-09-07	5001	0	\N	0	0	\N	\N	0	235234	0	8331-1	3006322		
49788	4529	3011505	1995-02-05	1995-02-05 00:00:00	1995-02-05	5001	0	\N	0	0	\N	\N	0	301561	0	19926-5	3011505		
32992	2980	3000876	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	198939	0	6082-2	3000876		
73139	2244	4052083	1962-02-08	1962-02-08 00:00:00	1962-02-08	5001	0	\N	0	0	\N	\N	0	149378	0	23426006	4052083		
104532	3219	4052083	2018-12-11	2018-12-11 00:00:00	2018-12-11	5001	0	\N	0	0	\N	\N	0	213894	0	23426006	4052083		
44495	4109	3021226	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	273140	0	6246-3	3021226		
24629	2265	3006322	2015-10-02	2015-10-02 00:00:00	2015-10-02	5001	0	\N	0	0	\N	\N	0	150508	0	8331-1	3006322		
127571	3926	4133840	1992-10-12	1992-10-12 00:00:00	1992-10-12	5001	0	\N	0	0	\N	\N	0	260995	0	127783003	4133840		
126160	3885	4024958	1966-10-29	1966-10-29 00:00:00	1966-10-29	5001	0	\N	0	0	\N	\N	0	258280	0	117015009	4024958		
24003	753	4052083	1999-11-30	1999-11-30 00:00:00	1999-11-30	5001	0	\N	0	0	\N	\N	0	49796	0	23426006	4052083		
47549	4372	3012494	1981-01-19	1981-01-19 00:00:00	1981-01-19	5001	0	\N	0	0	\N	\N	0	290260	0	6206-7	3012494		
40648	3772	3027231	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	250687	0	6276-0	3027231		
40722	3783	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	251365	0	6206-7	3012494		
5011	484	3049273	1997-03-15	1997-03-15 00:00:00	1997-03-15	5001	0	\N	0	0	\N	\N	0	32401	0	38265-5	3049273		
37987	3510	3006322	1980-04-16	1980-04-16 00:00:00	1980-04-16	5001	0	\N	0	0	\N	\N	0	232914	0	8331-1	3006322		
128121	3943	4024958	1983-11-26	1983-11-26 00:00:00	1983-11-26	5001	0	\N	0	0	\N	\N	0	262176	0	117015009	4024958		
41017	3803	3006322	1974-05-03	1974-05-03 00:00:00	1974-05-03	5001	0	\N	0	0	\N	\N	0	252754	0	8331-1	3006322		
37436	1159	4024958	2012-09-19	2012-09-19 00:00:00	2012-09-19	5001	0	\N	0	0	\N	\N	0	76536	0	117015009	4024958		
19515	1782	3006322	1970-03-13	1970-03-13 00:00:00	1970-03-13	5001	0	\N	0	0	\N	\N	0	119307	0	8331-1	3006322		
26481	829	4024958	1983-04-09	1983-04-09 00:00:00	1983-04-09	5001	0	\N	0	0	\N	\N	0	54924	0	117015009	4024958		
54329	1649	4052083	1960-03-18	1960-03-18 00:00:00	1960-03-18	5001	0	\N	0	0	\N	\N	0	110680	0	23426006	4052083		
21436	1977	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	131561	0	6246-3	3021226		
32803	2970	3006734	1999-05-06	1999-05-06 00:00:00	1999-05-06	5001	0	\N	0	0	\N	\N	0	198331	0	6189-5	3006734		
171141	5251	4024958	1952-01-30	1952-01-30 00:00:00	1952-01-30	5001	0	\N	0	0	\N	\N	0	349318	0	117015009	4024958		
96463	2955	4052083	1985-12-26	1985-12-26 00:00:00	1985-12-26	5001	0	\N	0	0	\N	\N	0	197237	0	23426006	4052083		
43864	1352	4133840	1995-08-20	1995-08-20 00:00:00	1995-08-20	5001	0	\N	0	0	\N	\N	0	89586	0	127783003	4133840		
28630	2647	3014599	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	175206	0	6106-9	3014599		
39980	3717	3015076	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	246997	0	6248-9	3015076		
55802	5118	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	340191	0	6075-6	3005136		
36346	3339	3006322	2003-06-27	2003-06-27 00:00:00	2003-06-27	5001	0	\N	0	0	\N	\N	0	221527	0	8331-1	3006322		
3577	341	3011505	2018-09-03	2018-09-03 00:00:00	2018-09-03	5001	0	\N	0	0	\N	\N	0	22813	0	19926-5	3011505		
110949	3430	4133840	2012-04-14	2012-04-14 00:00:00	2012-04-14	5001	0	\N	0	0	\N	\N	0	227376	0	127783003	4133840		
16851	1535	40758406	1979-11-29	1979-11-29 00:00:00	1979-11-29	5001	0	\N	0	0	\N	\N	0	102717	0	55277-8	40758406		
46190	4260	3006322	1981-07-01	1981-07-01 00:00:00	1981-07-01	5001	0	\N	0	0	\N	\N	0	282805	0	8331-1	3006322		
46233	4261	40758406	1957-12-23	1957-12-23 00:00:00	1957-12-23	5001	0	\N	0	0	\N	\N	0	282963	0	55277-8	40758406		
46829	4312	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	286058	0	6095-4	3036780		
162267	4977	4024958	1990-09-02	1990-09-02 00:00:00	1990-09-02	5001	0	\N	0	0	\N	\N	0	331189	0	117015009	4024958		
39846	3701	3051031	1970-09-28	1970-09-28 00:00:00	1970-09-28	5001	0	\N	0	0	\N	\N	0	246037	0	46240-8	3051031		
51203	4685	3006322	1944-08-21	1944-08-21 00:00:00	1944-08-21	5001	0	\N	0	0	\N	\N	0	312154	0	8331-1	3006322		
28120	2589	3006322	1995-05-02	1995-05-02 00:00:00	1995-05-02	5001	0	\N	0	0	\N	\N	0	171346	0	8331-1	3006322		
28258	2604	3006322	1994-07-27	1994-07-27 00:00:00	1994-07-27	5001	0	\N	0	0	\N	\N	0	172301	0	8331-1	3006322		
28277	2610	3006322	1983-09-13	1983-09-13 00:00:00	1983-09-13	5001	0	\N	0	0	\N	\N	0	172551	0	8331-1	3006322		
5069	489	3036780	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	32817	0	6095-4	3036780		
30381	2779	3001247	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	184124	0	6085-5	3001247		
66450	2037	4024958	1982-08-01	1982-08-01 00:00:00	1982-08-01	5001	0	\N	0	0	\N	\N	0	135680	0	117015009	4024958		
33911	3081	40766240	1999-11-06	1999-11-06 00:00:00	1999-11-06	5001	0	\N	0	0	\N	\N	0	205144	0	63513-6	40766240		
56140	5150	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	342380	0	6248-9	3015076		
1928	173	3006322	1996-06-19	1996-06-19 00:00:00	1996-06-19	5001	0	\N	0	0	\N	\N	0	11769	0	8331-1	3006322		
13298	1264	3011505	2003-02-21	2003-02-21 00:00:00	2003-02-21	5001	0	\N	0	0	\N	\N	0	83346	0	19926-5	3011505		
158558	4872	4024958	1946-07-27	1946-07-27 00:00:00	1946-07-27	5001	0	\N	0	0	\N	\N	0	324039	0	117015009	4024958		
24734	2274	3006322	2009-07-31	2009-07-31 00:00:00	2009-07-31	5001	0	\N	0	0	\N	\N	0	151195	0	8331-1	3006322		
22939	720	4024958	2005-07-08	2005-07-08 00:00:00	2005-07-08	5001	0	\N	0	0	\N	\N	0	47669	0	117015009	4024958		
7953	761	3015076	1995-06-23	1995-06-23 00:00:00	1995-06-23	5001	0	\N	0	0	\N	\N	0	50626	0	6248-9	3015076		
47336	4365	3006322	2013-01-12	2013-01-12 00:00:00	2013-01-12	5001	0	\N	0	0	\N	\N	0	289540	0	8331-1	3006322		
52782	4847	3011505	2007-02-28	2007-02-28 00:00:00	2007-02-28	5001	0	\N	0	0	\N	\N	0	322459	0	19926-5	3011505		
17826	559	4024958	1973-04-02	1973-04-02 00:00:00	1973-04-02	5001	0	\N	0	0	\N	\N	0	37046	0	117015009	4024958		
46427	4276	3006322	2000-05-21	2000-05-21 00:00:00	2000-05-21	5001	0	\N	0	0	\N	\N	0	283776	0	8331-1	3006322		
31343	2863	3006322	1961-11-14	1961-11-14 00:00:00	1961-11-14	5001	0	\N	0	0	\N	\N	0	190421	0	8331-1	3006322		
10014	320	4133840	2011-02-13	2011-02-13 00:00:00	2011-02-13	5001	0	\N	0	0	\N	\N	0	21193	0	127783003	4133840		
42382	3913	3012494	1981-11-09	1981-11-09 00:00:00	1981-11-09	5001	0	\N	0	0	\N	\N	0	260154	0	6206-7	3012494		
42844	3957	40766240	1965-05-17	1965-05-17 00:00:00	1965-05-17	5001	0	\N	0	0	\N	\N	0	263095	0	63513-6	40766240		
134690	4149	4024958	2005-06-25	2005-06-25 00:00:00	2005-06-25	5001	0	\N	0	0	\N	\N	0	275713	0	117015009	4024958		
70151	2151	4024958	1959-06-04	1959-06-04 00:00:00	1959-06-04	5001	0	\N	0	0	\N	\N	0	143303	0	117015009	4024958		
55231	5051	3012494	1994-06-02	1994-06-02 00:00:00	1994-06-02	5001	0	\N	0	0	\N	\N	0	335889	0	6206-7	3012494		
38407	3542	3006322	1938-01-02	1938-01-02 00:00:00	1938-01-02	5001	0	\N	0	0	\N	\N	0	235232	0	8331-1	3006322		
49789	4529	40758406	1987-02-09	1987-02-09 00:00:00	1987-02-09	5001	0	\N	0	0	\N	\N	0	301567	0	55277-8	40758406		
32993	2980	3036780	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	198939	0	6095-4	3036780		
73154	2244	4024958	1987-01-21	1987-01-21 00:00:00	1987-01-21	5001	0	\N	0	0	\N	\N	0	149405	0	117015009	4024958		
115825	3569	4052083	2011-07-15	2011-07-15 00:00:00	2011-07-15	5001	0	\N	0	0	\N	\N	0	237162	0	23426006	4052083		
44496	4109	3027231	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	273140	0	6276-0	3027231		
24630	2265	3006322	1971-08-06	1971-08-06 00:00:00	1971-08-06	5001	0	\N	0	0	\N	\N	0	150558	0	8331-1	3006322		
127572	3926	4133840	2013-07-01	2013-07-01 00:00:00	2013-07-01	5001	0	\N	0	0	\N	\N	0	260934	0	127783003	4133840		
126161	3885	4052083	1981-10-29	1981-10-29 00:00:00	1981-10-29	5001	0	\N	0	0	\N	\N	0	258226	0	23426006	4052083		
24004	753	4052083	1973-02-25	1973-02-25 00:00:00	1973-02-25	5001	0	\N	0	0	\N	\N	0	49810	0	23426006	4052083		
47550	4372	3023430	1981-01-19	1981-01-19 00:00:00	1981-01-19	5001	0	\N	0	0	\N	\N	0	290260	0	6833-8	3023430		
40649	3773	3006322	2009-05-16	2009-05-16 00:00:00	2009-05-16	5001	0	\N	0	0	\N	\N	0	250808	0	8331-1	3006322		
40723	3783	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	251365	0	6189-5	3006734		
5012	484	3049273	2011-03-02	2011-03-02 00:00:00	2011-03-02	5001	0	\N	0	0	\N	\N	0	32402	0	38265-5	3049273		
37988	3510	3006322	1952-05-09	1952-05-09 00:00:00	1952-05-09	5001	0	\N	0	0	\N	\N	0	232962	0	8331-1	3006322		
128128	3943	4024958	1960-03-19	1960-03-19 00:00:00	1960-03-19	5001	0	\N	0	0	\N	\N	0	262134	0	117015009	4024958		
41018	3804	3006322	2001-05-30	2001-05-30 00:00:00	2001-05-30	5001	0	\N	0	0	\N	\N	0	252866	0	8331-1	3006322		
37438	1159	4052083	1986-01-27	1986-01-27 00:00:00	1986-01-27	5001	0	\N	0	0	\N	\N	0	76553	0	23426006	4052083		
19516	1783	3006322	1974-07-10	1974-07-10 00:00:00	1974-07-10	5001	0	\N	0	0	\N	\N	0	119418	0	8331-1	3006322		
26489	829	4052083	2016-01-13	2016-01-13 00:00:00	2016-01-13	5001	0	\N	0	0	\N	\N	0	54930	0	23426006	4052083		
14849	1378	3014599	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	91332	0	6106-9	3014599		
21437	1977	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	131561	0	6206-7	3012494		
32804	2970	3019406	1999-05-06	1999-05-06 00:00:00	1999-05-06	5001	0	\N	0	0	\N	\N	0	198331	0	6158-0	3019406		
171143	5251	4052083	1947-05-18	1947-05-18 00:00:00	1947-05-18	5001	0	\N	0	0	\N	\N	0	349340	0	23426006	4052083		
107767	3325	4024958	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	220729	0	117015009	4024958		
43868	1352	4133840	2011-05-29	2011-05-29 00:00:00	2011-05-29	5001	0	\N	0	0	\N	\N	0	89573	0	127783003	4133840		
28631	2647	3019406	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	175206	0	6158-0	3019406		
39981	3717	3014599	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	246997	0	6106-9	3014599		
55803	5118	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	340191	0	6844-5	3020655		
36347	3339	3006322	1960-10-08	1960-10-08 00:00:00	1960-10-08	5001	0	\N	0	0	\N	\N	0	221501	0	8331-1	3006322		
3578	341	3006322	1986-11-26	1986-11-26 00:00:00	1986-11-26	5001	0	\N	0	0	\N	\N	0	22783	0	8331-1	3006322		
110951	3430	4133840	1998-03-14	1998-03-14 00:00:00	1998-03-14	5001	0	\N	0	0	\N	\N	0	227370	0	127783003	4133840		
16852	1535	40766240	1979-11-29	1979-11-29 00:00:00	1979-11-29	5001	0	\N	0	0	\N	\N	0	102717	0	63513-6	40766240		
46191	4260	3006322	1960-11-08	1960-11-08 00:00:00	1960-11-08	5001	0	\N	0	0	\N	\N	0	282833	0	8331-1	3006322		
46234	4261	46235214	1957-05-27	1957-05-27 00:00:00	1957-05-27	5001	0	\N	0	0	\N	\N	0	282857	0	76690-7	46235214		
46830	4312	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	286058	0	6248-9	3015076		
162268	4977	4024958	1971-07-31	1971-07-31 00:00:00	1971-07-31	5001	0	\N	0	0	\N	\N	0	331197	0	117015009	4024958		
39847	3701	46235214	1970-09-28	1970-09-28 00:00:00	1970-09-28	5001	0	\N	0	0	\N	\N	0	246037	0	76690-7	46235214		
51204	4685	3006322	1949-04-28	1949-04-28 00:00:00	1949-04-28	5001	0	\N	0	0	\N	\N	0	312130	0	8331-1	3006322		
28121	2589	3006322	1990-04-15	1990-04-15 00:00:00	1990-04-15	5001	0	\N	0	0	\N	\N	0	171331	0	8331-1	3006322		
68659	2100	4024958	1951-11-17	1951-11-17 00:00:00	1951-11-17	5001	0	\N	0	0	\N	\N	0	139937	0	117015009	4024958		
28278	2610	3006322	2013-11-11	2013-11-11 00:00:00	2013-11-11	5001	0	\N	0	0	\N	\N	0	172586	0	8331-1	3006322		
5070	489	3014599	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	32817	0	6106-9	3014599		
30382	2779	3006734	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	184124	0	6189-5	3006734		
66459	2037	4024958	1968-07-19	1968-07-19 00:00:00	1968-07-19	5001	0	\N	0	0	\N	\N	0	135676	0	117015009	4024958		
33914	3081	3006322	1957-06-27	1957-06-27 00:00:00	1957-06-27	5001	0	\N	0	0	\N	\N	0	205140	0	8331-1	3006322		
56141	5150	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	342380	0	6276-0	3027231		
1934	176	3006322	2003-12-19	2003-12-19 00:00:00	2003-12-19	5001	0	\N	0	0	\N	\N	0	11906	0	8331-1	3006322		
13299	1264	3011505	2009-10-30	2009-10-30 00:00:00	2009-10-30	5001	0	\N	0	0	\N	\N	0	83305	0	19926-5	3011505		
158566	4873	4024958	2014-06-24	2014-06-24 00:00:00	2014-06-24	5001	0	\N	0	0	\N	\N	0	324129	0	117015009	4024958		
24743	2277	3006322	1970-07-15	1970-07-15 00:00:00	1970-07-15	5001	0	\N	0	0	\N	\N	0	151351	0	8331-1	3006322		
22941	720	4024958	1992-06-18	1992-06-18 00:00:00	1992-06-18	5001	0	\N	0	0	\N	\N	0	47617	0	117015009	4024958		
7954	761	3023430	1995-06-23	1995-06-23 00:00:00	1995-06-23	5001	0	\N	0	0	\N	\N	0	50626	0	6833-8	3023430		
47337	4365	3006322	1952-01-21	1952-01-21 00:00:00	1952-01-21	5001	0	\N	0	0	\N	\N	0	289507	0	8331-1	3006322		
52783	4847	3011505	1975-01-22	1975-01-22 00:00:00	1975-01-22	5001	0	\N	0	0	\N	\N	0	322413	0	19926-5	3011505		
17829	559	4024958	2009-06-30	2009-06-30 00:00:00	2009-06-30	5001	0	\N	0	0	\N	\N	0	37057	0	117015009	4024958		
46428	4276	3006322	2019-02-25	2019-02-25 00:00:00	2019-02-25	5001	0	\N	0	0	\N	\N	0	283743	0	8331-1	3006322		
31344	2864	3006322	2013-05-04	2013-05-04 00:00:00	2013-05-04	5001	0	\N	0	0	\N	\N	0	190516	0	8331-1	3006322		
10015	320	4133840	2014-03-02	2014-03-02 00:00:00	2014-03-02	5001	0	\N	0	0	\N	\N	0	21252	0	127783003	4133840		
42383	3913	3021226	1981-11-09	1981-11-09 00:00:00	1981-11-09	5001	0	\N	0	0	\N	\N	0	260154	0	6246-3	3021226		
42845	3957	46235214	1965-05-17	1965-05-17 00:00:00	1965-05-17	5001	0	\N	0	0	\N	\N	0	263095	0	76690-7	46235214		
146752	4501	4024958	2011-01-13	2011-01-13 00:00:00	2011-01-13	5001	0	\N	0	0	\N	\N	0	299679	0	117015009	4024958		
81447	2518	4133840	2000-01-28	2000-01-28 00:00:00	2000-01-28	5001	0	\N	0	0	\N	\N	0	166590	0	127783003	4133840		
55232	5051	3014599	1994-06-02	1994-06-02 00:00:00	1994-06-02	5001	0	\N	0	0	\N	\N	0	335889	0	6106-9	3014599		
38408	3542	3049273	2017-09-23	2017-09-23 00:00:00	2017-09-23	5001	0	\N	0	0	\N	\N	0	235247	0	38265-5	3049273		
49790	4529	3051031	1987-02-09	1987-02-09 00:00:00	1987-02-09	5001	0	\N	0	0	\N	\N	0	301567	0	46240-8	3051031		
32994	2980	3019406	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	198939	0	6158-0	3019406		
73155	2244	4024958	1995-11-21	1995-11-21 00:00:00	1995-11-21	5001	0	\N	0	0	\N	\N	0	149398	0	117015009	4024958		
115827	3569	4024958	1979-09-18	1979-09-18 00:00:00	1979-09-18	5001	0	\N	0	0	\N	\N	0	237179	0	117015009	4024958		
44497	4109	3000876	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	273140	0	6082-2	3000876		
24631	2265	3012494	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	150517	0	6206-7	3012494		
127574	3926	4052083	2005-01-23	2005-01-23 00:00:00	2005-01-23	5001	0	\N	0	0	\N	\N	0	260927	0	23426006	4052083		
126175	3885	4052083	2003-06-06	2003-06-06 00:00:00	2003-06-06	5001	0	\N	0	0	\N	\N	0	258257	0	23426006	4052083		
24013	753	4024958	2017-03-31	2017-03-31 00:00:00	2017-03-31	5001	0	\N	0	0	\N	\N	0	49775	0	117015009	4024958		
47551	4372	3019406	1981-01-19	1981-01-19 00:00:00	1981-01-19	5001	0	\N	0	0	\N	\N	0	290260	0	6158-0	3019406		
40650	3773	3006322	1968-02-11	1968-02-11 00:00:00	1968-02-11	5001	0	\N	0	0	\N	\N	0	250804	0	8331-1	3006322		
40724	3783	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	251365	0	6833-8	3023430		
16290	1482	3012494	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	98836	0	6206-7	3012494		
37989	3510	3006322	1943-06-10	1943-06-10 00:00:00	1943-06-10	5001	0	\N	0	0	\N	\N	0	232900	0	8331-1	3006322		
128141	3943	4052083	1962-08-21	1962-08-21 00:00:00	1962-08-21	5001	0	\N	0	0	\N	\N	0	262165	0	23426006	4052083		
41020	3807	3006322	1952-02-26	1952-02-26 00:00:00	1952-02-26	5001	0	\N	0	0	\N	\N	0	252976	0	8331-1	3006322		
37440	1159	4052083	2010-11-05	2010-11-05 00:00:00	2010-11-05	5001	0	\N	0	0	\N	\N	0	76586	0	23426006	4052083		
19517	1783	3006322	2007-03-20	2007-03-20 00:00:00	2007-03-20	5001	0	\N	0	0	\N	\N	0	119507	0	8331-1	3006322		
37772	1174	4024958	1944-08-22	1944-08-22 00:00:00	1944-08-22	5001	0	\N	0	0	\N	\N	0	77326	0	117015009	4024958		
14850	1378	3019406	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	91332	0	6158-0	3019406		
21438	1977	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	131561	0	6273-7	3006451		
32805	2970	3012494	1999-05-06	1999-05-06 00:00:00	1999-05-06	5001	0	\N	0	0	\N	\N	0	198331	0	6206-7	3012494		
171145	5252	4133840	2006-04-18	2006-04-18 00:00:00	2006-04-18	5001	0	\N	0	0	\N	\N	0	349480	0	127783003	4133840		
15841	1447	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	96445	0	6075-6	3005136		
43872	1352	4133840	2003-04-13	2003-04-13 00:00:00	2003-04-13	5001	0	\N	0	0	\N	\N	0	89555	0	127783003	4133840		
28632	2647	3005136	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	175206	0	6075-6	3005136		
39982	3717	3027231	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	246997	0	6276-0	3027231		
55804	5118	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	340191	0	6189-5	3006734		
36348	3339	3006322	2017-07-27	2017-07-27 00:00:00	2017-07-27	5001	0	\N	0	0	\N	\N	0	221529	0	8331-1	3006322		
3579	341	3006322	1986-09-17	1986-09-17 00:00:00	1986-09-17	5001	0	\N	0	0	\N	\N	0	22762	0	8331-1	3006322		
110953	3430	4133840	2013-04-20	2013-04-20 00:00:00	2013-04-20	5001	0	\N	0	0	\N	\N	0	227337	0	127783003	4133840		
16854	1535	3006322	1997-01-22	1997-01-22 00:00:00	1997-01-22	5001	0	\N	0	0	\N	\N	0	102752	0	8331-1	3006322		
46192	4260	3006322	1987-06-27	1987-06-27 00:00:00	1987-06-27	5001	0	\N	0	0	\N	\N	0	282787	0	8331-1	3006322		
46237	4261	3051031	1957-05-27	1957-05-27 00:00:00	1957-05-27	5001	0	\N	0	0	\N	\N	0	282857	0	46240-8	3051031		
46831	4312	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	286058	0	6075-6	3005136		
162269	4977	4024958	1970-04-29	1970-04-29 00:00:00	1970-04-29	5001	0	\N	0	0	\N	\N	0	331122	0	117015009	4024958		
39853	3703	3006322	2014-07-22	2014-07-22 00:00:00	2014-07-22	5001	0	\N	0	0	\N	\N	0	246231	0	8331-1	3006322		
51205	4685	3006322	1944-06-13	1944-06-13 00:00:00	1944-06-13	5001	0	\N	0	0	\N	\N	0	312128	0	8331-1	3006322		
28122	2590	3006322	1965-06-05	1965-06-05 00:00:00	1965-06-05	5001	0	\N	0	0	\N	\N	0	171417	0	8331-1	3006322		
68671	2100	4024958	1951-09-06	1951-09-06 00:00:00	1951-09-06	5001	0	\N	0	0	\N	\N	0	139982	0	117015009	4024958		
28279	2610	3006322	1967-01-27	1967-01-27 00:00:00	1967-01-27	5001	0	\N	0	0	\N	\N	0	172538	0	8331-1	3006322		
5071	489	3006451	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	32817	0	6273-7	3006451		
30383	2780	3006322	1958-10-17	1958-10-17 00:00:00	1958-10-17	5001	0	\N	0	0	\N	\N	0	184218	0	8331-1	3006322		
154350	4732	4024958	1957-04-16	1957-04-16 00:00:00	1957-04-16	5001	0	\N	0	0	\N	\N	0	315278	0	117015009	4024958		
33915	3081	3006322	1968-04-15	1968-04-15 00:00:00	1968-04-15	5001	0	\N	0	0	\N	\N	0	205097	0	8331-1	3006322		
56142	5150	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	342380	0	6085-5	3001247		
1935	176	3006322	1986-10-08	1986-10-08 00:00:00	1986-10-08	5001	0	\N	0	0	\N	\N	0	11898	0	8331-1	3006322		
13300	1264	3011505	2011-11-11	2011-11-11 00:00:00	2011-11-11	5001	0	\N	0	0	\N	\N	0	83281	0	19926-5	3011505		
158576	4873	4024958	2009-09-07	2009-09-07 00:00:00	2009-09-07	5001	0	\N	0	0	\N	\N	0	324128	0	117015009	4024958		
48016	4403	3011505	1999-07-10	1999-07-10 00:00:00	1999-07-10	5001	0	\N	0	0	\N	\N	0	292697	0	19926-5	3011505		
22951	720	4024958	1986-11-05	1986-11-05 00:00:00	1986-11-05	5001	0	\N	0	0	\N	\N	0	47631	0	117015009	4024958		
7955	761	3012494	1995-06-23	1995-06-23 00:00:00	1995-06-23	5001	0	\N	0	0	\N	\N	0	50626	0	6206-7	3012494		
47338	4365	3006322	1960-03-23	1960-03-23 00:00:00	1960-03-23	5001	0	\N	0	0	\N	\N	0	289517	0	8331-1	3006322		
52784	4848	3006322	1963-11-30	1963-11-30 00:00:00	1963-11-30	5001	0	\N	0	0	\N	\N	0	322545	0	8331-1	3006322		
17834	559	4024958	1992-04-03	1992-04-03 00:00:00	1992-04-03	5001	0	\N	0	0	\N	\N	0	37055	0	117015009	4024958		
46429	4276	3006322	1960-02-19	1960-02-19 00:00:00	1960-02-19	5001	0	\N	0	0	\N	\N	0	283739	0	8331-1	3006322		
31345	2864	3006322	2015-06-15	2015-06-15 00:00:00	2015-06-15	5001	0	\N	0	0	\N	\N	0	190471	0	8331-1	3006322		
10018	320	4133840	1998-03-01	1998-03-01 00:00:00	1998-03-01	5001	0	\N	0	0	\N	\N	0	21251	0	127783003	4133840		
42384	3913	3001247	1981-11-09	1981-11-09 00:00:00	1981-11-09	5001	0	\N	0	0	\N	\N	0	260154	0	6085-5	3001247		
42847	3957	3051031	1965-05-17	1965-05-17 00:00:00	1965-05-17	5001	0	\N	0	0	\N	\N	0	263095	0	46240-8	3051031		
146756	4501	4024958	1973-11-29	1973-11-29 00:00:00	1973-11-29	5001	0	\N	0	0	\N	\N	0	299677	0	117015009	4024958		
81449	2518	4052083	2000-01-22	2000-01-22 00:00:00	2000-01-22	5001	0	\N	0	0	\N	\N	0	166519	0	23426006	4052083		
55233	5051	3019406	1994-06-02	1994-06-02 00:00:00	1994-06-02	5001	0	\N	0	0	\N	\N	0	335889	0	6158-0	3019406		
38409	3542	3049273	2010-07-03	2010-07-03 00:00:00	2010-07-03	5001	0	\N	0	0	\N	\N	0	235326	0	38265-5	3049273		
49792	4529	46235214	1987-02-09	1987-02-09 00:00:00	1987-02-09	5001	0	\N	0	0	\N	\N	0	301567	0	76690-7	46235214		
450	9	4024958	1996-02-09	1996-02-09 00:00:00	1996-02-09	5001	0	\N	0	0	\N	\N	0	846	0	117015009	4024958		
73158	2244	4024958	1956-09-07	1956-09-07 00:00:00	1956-09-07	5001	0	\N	0	0	\N	\N	0	149389	0	117015009	4024958		
142024	4372	4052083	1982-01-30	1982-01-30 00:00:00	1982-01-30	5001	0	\N	0	0	\N	\N	0	290261	0	23426006	4052083		
44498	4109	3036780	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	273140	0	6095-4	3036780		
24632	2265	3006734	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	150517	0	6189-5	3006734		
127575	3926	4133840	1981-10-12	1981-10-12 00:00:00	1981-10-12	5001	0	\N	0	0	\N	\N	0	260948	0	127783003	4133840		
52318	4807	3006322	1961-02-19	1961-02-19 00:00:00	1961-02-19	5001	0	\N	0	0	\N	\N	0	319787	0	8331-1	3006322		
24022	753	4052083	2009-11-11	2009-11-11 00:00:00	2009-11-11	5001	0	\N	0	0	\N	\N	0	49798	0	23426006	4052083		
47552	4372	3036780	1993-05-13	1993-05-13 00:00:00	1993-05-13	5001	0	\N	0	0	\N	\N	0	290262	0	6095-4	3036780		
40651	3773	3006322	1979-12-23	1979-12-23 00:00:00	1979-12-23	5001	0	\N	0	0	\N	\N	0	250778	0	8331-1	3006322		
40725	3783	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	251365	0	6246-3	3021226		
16291	1482	3005136	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	98836	0	6075-6	3005136		
37990	3510	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	232943	0	6106-9	3014599		
13682	432	4052083	1939-01-17	1939-01-17 00:00:00	1939-01-17	5001	0	\N	0	0	\N	\N	0	28741	0	23426006	4052083		
41021	3807	3006322	1965-06-15	1965-06-15 00:00:00	1965-06-15	5001	0	\N	0	0	\N	\N	0	252977	0	8331-1	3006322		
15029	469	4052083	1955-07-02	1955-07-02 00:00:00	1955-07-02	5001	0	\N	0	0	\N	\N	0	31309	0	23426006	4052083		
87054	2688	4024958	1985-04-24	1985-04-24 00:00:00	1985-04-24	5001	0	\N	0	0	\N	\N	0	178093	0	117015009	4024958		
37776	1174	4024958	1987-11-09	1987-11-09 00:00:00	1987-11-09	5001	0	\N	0	0	\N	\N	0	77307	0	117015009	4024958		
14851	1378	3027231	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	91332	0	6276-0	3027231		
21439	1977	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	131561	0	6082-2	3000876		
32806	2970	3021226	1999-05-06	1999-05-06 00:00:00	1999-05-06	5001	0	\N	0	0	\N	\N	0	198331	0	6246-3	3021226		
171146	5252	4133840	2019-06-11	2019-06-11 00:00:00	2019-06-11	5001	0	\N	0	0	\N	\N	0	349403	0	127783003	4133840		
15842	1447	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	96445	0	6248-9	3015076		
43874	1352	4133840	2012-06-03	2012-06-03 00:00:00	2012-06-03	5001	0	\N	0	0	\N	\N	0	89545	0	127783003	4133840		
28633	2647	3027231	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	175206	0	6276-0	3027231		
39983	3717	3006322	1999-06-22	1999-06-22 00:00:00	1999-06-22	5001	0	\N	0	0	\N	\N	0	246978	0	8331-1	3006322		
55805	5118	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	340191	0	7258-7	3001488		
36349	3342	3049273	1989-11-01	1989-11-01 00:00:00	1989-11-01	5001	0	\N	0	0	\N	\N	0	221595	0	38265-5	3049273		
14858	1378	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	91435	0	6095-4	3036780		
110955	3430	4133840	2011-04-09	2011-04-09 00:00:00	2011-04-09	5001	0	\N	0	0	\N	\N	0	227336	0	127783003	4133840		
16855	1535	3006322	2009-09-07	2009-09-07 00:00:00	2009-09-07	5001	0	\N	0	0	\N	\N	0	102754	0	8331-1	3006322		
46193	4260	46235214	1977-05-25	1977-05-25 00:00:00	1977-05-25	5001	0	\N	0	0	\N	\N	0	282809	0	76690-7	46235214		
46238	4261	40766240	1957-05-27	1957-05-27 00:00:00	1957-05-27	5001	0	\N	0	0	\N	\N	0	282857	0	63513-6	40766240		
46832	4312	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	286058	0	6106-9	3014599		
162275	4977	4024958	1981-06-24	1981-06-24 00:00:00	1981-06-24	5001	0	\N	0	0	\N	\N	0	331124	0	117015009	4024958		
39854	3703	3006322	2006-05-13	2006-05-13 00:00:00	2006-05-13	5001	0	\N	0	0	\N	\N	0	246275	0	8331-1	3006322		
122076	3767	4052083	2000-11-29	2000-11-29 00:00:00	2000-11-29	5001	0	\N	0	0	\N	\N	0	250339	0	23426006	4052083		
28123	2591	3006322	1977-09-28	1977-09-28 00:00:00	1977-09-28	5001	0	\N	0	0	\N	\N	0	171483	0	8331-1	3006322		
68725	2103	4024958	2015-09-07	2015-09-07 00:00:00	2015-09-07	5001	0	\N	0	0	\N	\N	0	140164	0	117015009	4024958		
28280	2611	3006322	1954-12-14	1954-12-14 00:00:00	1954-12-14	5001	0	\N	0	0	\N	\N	0	172656	0	8331-1	3006322		
5072	489	3020655	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	32817	0	6844-5	3020655		
30384	2780	3000963	2001-01-06	2001-01-06 00:00:00	2001-01-06	5001	0	\N	0	0	\N	\N	0	184222	0	718-7	3000963		
154405	4735	4024958	1989-10-20	1989-10-20 00:00:00	1989-10-20	5001	0	\N	0	0	\N	\N	0	315456	0	117015009	4024958		
33916	3081	40758406	1999-08-08	1999-08-08 00:00:00	1999-08-08	5001	0	\N	0	0	\N	\N	0	205121	0	55277-8	40758406		
56143	5150	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	342380	0	6206-7	3012494		
1936	176	3006322	1982-07-10	1982-07-10 00:00:00	1982-07-10	5001	0	\N	0	0	\N	\N	0	11892	0	8331-1	3006322		
13301	1264	3011505	2004-10-01	2004-10-01 00:00:00	2004-10-01	5001	0	\N	0	0	\N	\N	0	83347	0	19926-5	3011505		
158587	4874	4024958	1981-12-27	1981-12-27 00:00:00	1981-12-27	5001	0	\N	0	0	\N	\N	0	324161	0	117015009	4024958		
48017	4403	3011505	1997-06-28	1997-06-28 00:00:00	1997-06-28	5001	0	\N	0	0	\N	\N	0	292696	0	19926-5	3011505		
95006	2917	4024958	1990-02-08	1990-02-08 00:00:00	1990-02-08	5001	0	\N	0	0	\N	\N	0	194496	0	117015009	4024958		
7956	761	3021226	1995-06-23	1995-06-23 00:00:00	1995-06-23	5001	0	\N	0	0	\N	\N	0	50626	0	6246-3	3021226		
47339	4366	3001247	1994-05-10	1994-05-10 00:00:00	1994-05-10	5001	0	\N	0	0	\N	\N	0	289673	0	6085-5	3001247		
52785	4848	3006322	2012-01-27	2012-01-27 00:00:00	2012-01-27	5001	0	\N	0	0	\N	\N	0	322565	0	8331-1	3006322		
17839	559	4052083	1989-01-26	1989-01-26 00:00:00	1989-01-26	5001	0	\N	0	0	\N	\N	0	37100	0	23426006	4052083		
46430	4276	3006322	2016-01-15	2016-01-15 00:00:00	2016-01-15	5001	0	\N	0	0	\N	\N	0	283742	0	8331-1	3006322		
31346	2864	3006322	1947-02-15	1947-02-15 00:00:00	1947-02-15	5001	0	\N	0	0	\N	\N	0	190492	0	8331-1	3006322		
10020	320	4133840	2008-01-27	2008-01-27 00:00:00	2008-01-27	5001	0	\N	0	0	\N	\N	0	21189	0	127783003	4133840		
67025	2058	4024958	2001-06-26	2001-06-26 00:00:00	2001-06-26	5001	0	\N	0	0	\N	\N	0	136813	0	117015009	4024958		
42848	3957	40758406	1965-05-17	1965-05-17 00:00:00	1965-05-17	5001	0	\N	0	0	\N	\N	0	263095	0	55277-8	40758406		
146760	4501	4024958	1986-05-09	1986-05-09 00:00:00	1986-05-09	5001	0	\N	0	0	\N	\N	0	299710	0	117015009	4024958		
81450	2518	4133840	2007-08-31	2007-08-31 00:00:00	2007-08-31	5001	0	\N	0	0	\N	\N	0	166550	0	127783003	4133840		
55234	5051	3015076	1994-06-02	1994-06-02 00:00:00	1994-06-02	5001	0	\N	0	0	\N	\N	0	335889	0	6248-9	3015076		
38410	3542	3006322	1941-01-28	1941-01-28 00:00:00	1941-01-28	5001	0	\N	0	0	\N	\N	0	235319	0	8331-1	3006322		
49793	4529	40766240	1987-02-09	1987-02-09 00:00:00	1987-02-09	5001	0	\N	0	0	\N	\N	0	301567	0	63513-6	40766240		
471	9	4024958	2000-05-28	2000-05-28 00:00:00	2000-05-28	5001	0	\N	0	0	\N	\N	0	856	0	117015009	4024958		
73160	2244	4024958	1983-07-29	1983-07-29 00:00:00	1983-07-29	5001	0	\N	0	0	\N	\N	0	149386	0	117015009	4024958		
142025	4372	4052083	2012-10-13	2012-10-13 00:00:00	2012-10-13	5001	0	\N	0	0	\N	\N	0	290246	0	23426006	4052083		
44499	4109	3006734	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	273140	0	6189-5	3006734		
24633	2265	3014599	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	150517	0	6106-9	3014599		
127580	3926	4133840	2009-02-23	2009-02-23 00:00:00	2009-02-23	5001	0	\N	0	0	\N	\N	0	260919	0	127783003	4133840		
52319	4807	3006322	1961-04-05	1961-04-05 00:00:00	1961-04-05	5001	0	\N	0	0	\N	\N	0	319788	0	8331-1	3006322		
24025	753	4024958	2011-07-05	2011-07-05 00:00:00	2011-07-05	5001	0	\N	0	0	\N	\N	0	49799	0	117015009	4024958		
47553	4372	3023430	1993-05-13	1993-05-13 00:00:00	1993-05-13	5001	0	\N	0	0	\N	\N	0	290262	0	6833-8	3023430		
40652	3773	3000963	1960-05-01	1960-05-01 00:00:00	1960-05-01	5001	0	\N	0	0	\N	\N	0	250803	0	718-7	3000963		
40726	3783	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	251365	0	6075-6	3005136		
16292	1482	3001247	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	98836	0	6085-5	3001247		
37991	3510	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	232943	0	6273-7	3006451		
13709	432	4024958	1994-02-20	1994-02-20 00:00:00	1994-02-20	5001	0	\N	0	0	\N	\N	0	28737	0	117015009	4024958		
41022	3807	3006322	1966-12-20	1966-12-20 00:00:00	1966-12-20	5001	0	\N	0	0	\N	\N	0	252978	0	8331-1	3006322		
26314	823	4133840	2012-12-31	2012-12-31 00:00:00	2012-12-31	5001	0	\N	0	0	\N	\N	0	54582	0	127783003	4133840		
87063	2688	4024958	1974-11-16	1974-11-16 00:00:00	1974-11-16	5001	0	\N	0	0	\N	\N	0	178151	0	117015009	4024958		
37780	1174	4024958	1971-08-26	1971-08-26 00:00:00	1971-08-26	5001	0	\N	0	0	\N	\N	0	77328	0	117015009	4024958		
14852	1378	3011505	2005-03-22	2005-03-22 00:00:00	2005-03-22	5001	0	\N	0	0	\N	\N	0	91342	0	19926-5	3011505		
21440	1977	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	131561	0	6095-4	3036780		
32807	2970	3015076	1999-05-06	1999-05-06 00:00:00	1999-05-06	5001	0	\N	0	0	\N	\N	0	198331	0	6248-9	3015076		
171153	5252	4133840	2016-05-24	2016-05-24 00:00:00	2016-05-24	5001	0	\N	0	0	\N	\N	0	349477	0	127783003	4133840		
15843	1447	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	96445	0	6206-7	3012494		
43876	1352	4133840	2018-01-28	2018-01-28 00:00:00	2018-01-28	5001	0	\N	0	0	\N	\N	0	89575	0	127783003	4133840		
28634	2647	3006322	1975-10-20	1975-10-20 00:00:00	1975-10-20	5001	0	\N	0	0	\N	\N	0	175110	0	8331-1	3006322		
39985	3718	3006322	1985-05-07	1985-05-07 00:00:00	1985-05-07	5001	0	\N	0	0	\N	\N	0	247109	0	8331-1	3006322		
55806	5118	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	340191	0	6085-5	3001247		
36350	3342	3049273	1979-07-01	1979-07-01 00:00:00	1979-07-01	5001	0	\N	0	0	\N	\N	0	221567	0	38265-5	3049273		
14859	1378	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	91435	0	6106-9	3014599		
110959	3430	4133840	2003-03-22	2003-03-22 00:00:00	2003-03-22	5001	0	\N	0	0	\N	\N	0	227335	0	127783003	4133840		
16856	1535	46235214	1979-10-30	1979-10-30 00:00:00	1979-10-30	5001	0	\N	0	0	\N	\N	0	102759	0	76690-7	46235214		
46195	4260	40758406	1977-05-25	1977-05-25 00:00:00	1977-05-25	5001	0	\N	0	0	\N	\N	0	282809	0	55277-8	40758406		
46239	4261	40758406	1957-05-27	1957-05-27 00:00:00	1957-05-27	5001	0	\N	0	0	\N	\N	0	282857	0	55277-8	40758406		
46833	4312	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	286058	0	7258-7	3001488		
162281	4977	4024958	2004-11-06	2004-11-06 00:00:00	2004-11-06	5001	0	\N	0	0	\N	\N	0	331126	0	117015009	4024958		
39855	3703	3023430	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	246285	0	6833-8	3023430		
128332	3951	4024958	1955-11-18	1955-11-18 00:00:00	1955-11-18	5001	0	\N	0	0	\N	\N	0	262616	0	117015009	4024958		
28124	2591	3049273	2012-03-14	2012-03-14 00:00:00	2012-03-14	5001	0	\N	0	0	\N	\N	0	171547	0	38265-5	3049273		
57637	1760	4024958	2016-04-03	2016-04-03 00:00:00	2016-04-03	5001	0	\N	0	0	\N	\N	0	117657	0	117015009	4024958		
28281	2611	3006322	2009-08-06	2009-08-06 00:00:00	2009-08-06	5001	0	\N	0	0	\N	\N	0	172631	0	8331-1	3006322		
5073	489	3001488	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	32817	0	7258-7	3001488		
30385	2780	3009542	2001-01-06	2001-01-06 00:00:00	2001-01-06	5001	0	\N	0	0	\N	\N	0	184222	0	20570-8	3009542		
154410	4735	4024958	1985-08-01	1985-08-01 00:00:00	1985-08-01	5001	0	\N	0	0	\N	\N	0	315414	0	117015009	4024958		
33917	3081	3051031	1999-08-08	1999-08-08 00:00:00	1999-08-08	5001	0	\N	0	0	\N	\N	0	205121	0	46240-8	3051031		
56144	5150	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	342380	0	6095-4	3036780		
1937	176	3006322	1986-08-26	1986-08-26 00:00:00	1986-08-26	5001	0	\N	0	0	\N	\N	0	11881	0	8331-1	3006322		
13302	1264	3006322	2004-09-24	2004-09-24 00:00:00	2004-09-24	5001	0	\N	0	0	\N	\N	0	83340	0	8331-1	3006322		
158589	4874	4052083	1976-12-12	1976-12-12 00:00:00	1976-12-12	5001	0	\N	0	0	\N	\N	0	324159	0	23426006	4052083		
48018	4403	3006322	1942-01-26	1942-01-26 00:00:00	1942-01-26	5001	0	\N	0	0	\N	\N	0	292664	0	8331-1	3006322		
95011	2917	4024958	1949-05-30	1949-05-30 00:00:00	1949-05-30	5001	0	\N	0	0	\N	\N	0	194434	0	117015009	4024958		
7957	761	3036780	1995-06-23	1995-06-23 00:00:00	1995-06-23	5001	0	\N	0	0	\N	\N	0	50626	0	6095-4	3036780		
47340	4366	3006734	1994-05-10	1994-05-10 00:00:00	1994-05-10	5001	0	\N	0	0	\N	\N	0	289673	0	6189-5	3006734		
52786	4848	3006322	2000-09-17	2000-09-17 00:00:00	2000-09-17	5001	0	\N	0	0	\N	\N	0	322501	0	8331-1	3006322		
17867	559	4024958	1988-11-06	1988-11-06 00:00:00	1988-11-06	5001	0	\N	0	0	\N	\N	0	37109	0	117015009	4024958		
46431	4276	3006322	2016-09-24	2016-09-24 00:00:00	2016-09-24	5001	0	\N	0	0	\N	\N	0	283778	0	8331-1	3006322		
31347	2864	3006322	1941-02-17	1941-02-17 00:00:00	1941-02-17	5001	0	\N	0	0	\N	\N	0	190551	0	8331-1	3006322		
10022	320	4024958	1958-10-08	1958-10-08 00:00:00	1958-10-08	5001	0	\N	0	0	\N	\N	0	21221	0	117015009	4024958		
171724	5272	4024958	1923-09-09	1923-09-09 00:00:00	1923-09-09	5001	0	\N	0	0	\N	\N	0	350652	0	117015009	4024958		
42849	3957	40758406	1965-12-13	1965-12-13 00:00:00	1965-12-13	5001	0	\N	0	0	\N	\N	0	263143	0	55277-8	40758406		
53744	4929	3006322	1972-12-05	1972-12-05 00:00:00	1972-12-05	5001	0	\N	0	0	\N	\N	0	327688	0	8331-1	3006322		
81452	2518	4024958	2004-08-06	2004-08-06 00:00:00	2004-08-06	5001	0	\N	0	0	\N	\N	0	166520	0	117015009	4024958		
55235	5051	3001247	1994-06-02	1994-06-02 00:00:00	1994-06-02	5001	0	\N	0	0	\N	\N	0	335889	0	6085-5	3001247		
38411	3542	3006322	2007-12-08	2007-12-08 00:00:00	2007-12-08	5001	0	\N	0	0	\N	\N	0	235265	0	8331-1	3006322		
49795	4529	3006322	1965-11-08	1965-11-08 00:00:00	1965-11-08	5001	0	\N	0	0	\N	\N	0	301566	0	8331-1	3006322		
485	9	4052083	1985-06-15	1985-06-15 00:00:00	1985-06-15	5001	0	\N	0	0	\N	\N	0	723	0	23426006	4052083		
529	11	4024958	1955-10-23	1955-10-23 00:00:00	1955-10-23	5001	0	\N	0	0	\N	\N	0	978	0	117015009	4024958		
142093	4373	4024958	1978-06-09	1978-06-09 00:00:00	1978-06-09	5001	0	\N	0	0	\N	\N	0	290413	0	117015009	4024958		
44500	4109	3023430	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	273140	0	6833-8	3023430		
24634	2265	3001488	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	150517	0	7258-7	3001488		
127583	3926	4133840	2007-02-12	2007-02-12 00:00:00	2007-02-12	5001	0	\N	0	0	\N	\N	0	260918	0	127783003	4133840		
52320	4807	3006322	1987-03-29	1987-03-29 00:00:00	1987-03-29	5001	0	\N	0	0	\N	\N	0	319857	0	8331-1	3006322		
12725	1214	3006322	1942-12-27	1942-12-27 00:00:00	1942-12-27	5001	0	\N	0	0	\N	\N	0	79993	0	8331-1	3006322		
47554	4372	3019406	1993-05-13	1993-05-13 00:00:00	1993-05-13	5001	0	\N	0	0	\N	\N	0	290262	0	6158-0	3019406		
40653	3773	3009542	1960-05-01	1960-05-01 00:00:00	1960-05-01	5001	0	\N	0	0	\N	\N	0	250803	0	20570-8	3009542		
40727	3783	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	251365	0	6085-5	3001247		
16293	1482	3027231	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	98836	0	6276-0	3027231		
37992	3510	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	232943	0	6833-8	3023430		
13711	432	4024958	1985-12-22	1985-12-22 00:00:00	1985-12-22	5001	0	\N	0	0	\N	\N	0	28724	0	117015009	4024958		
41023	3807	3006322	1953-07-04	1953-07-04 00:00:00	1953-07-04	5001	0	\N	0	0	\N	\N	0	252959	0	8331-1	3006322		
26319	823	4052083	1970-05-08	1970-05-08 00:00:00	1970-05-08	5001	0	\N	0	0	\N	\N	0	54550	0	23426006	4052083		
87085	2690	4024958	1962-04-17	1962-04-17 00:00:00	1962-04-17	5001	0	\N	0	0	\N	\N	0	178238	0	117015009	4024958		
37794	1174	4052083	1951-09-15	1951-09-15 00:00:00	1951-09-15	5001	0	\N	0	0	\N	\N	0	77327	0	23426006	4052083		
14853	1378	3011505	2017-07-25	2017-07-25 00:00:00	2017-07-25	5001	0	\N	0	0	\N	\N	0	91345	0	19926-5	3011505		
21441	1977	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	131561	0	6844-5	3020655		
32808	2970	3001247	1999-05-06	1999-05-06 00:00:00	1999-05-06	5001	0	\N	0	0	\N	\N	0	198331	0	6085-5	3001247		
171158	5252	4133840	2018-06-05	2018-06-05 00:00:00	2018-06-05	5001	0	\N	0	0	\N	\N	0	349481	0	127783003	4133840		
15844	1447	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	96445	0	6844-5	3020655		
43880	1352	4133840	2009-05-17	2009-05-17 00:00:00	2009-05-17	5001	0	\N	0	0	\N	\N	0	89589	0	127783003	4133840		
28635	2647	3006322	2011-02-16	2011-02-16 00:00:00	2011-02-16	5001	0	\N	0	0	\N	\N	0	175218	0	8331-1	3006322		
39986	3718	3006322	1979-06-28	1979-06-28 00:00:00	1979-06-28	5001	0	\N	0	0	\N	\N	0	247108	0	8331-1	3006322		
55807	5118	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	340232	0	6082-2	3000876		
36351	3342	3006322	1936-02-06	1936-02-06 00:00:00	1936-02-06	5001	0	\N	0	0	\N	\N	0	221548	0	8331-1	3006322		
14860	1378	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	91435	0	6276-0	3027231		
110962	3430	4133840	2019-05-25	2019-05-25 00:00:00	2019-05-25	5001	0	\N	0	0	\N	\N	0	227339	0	127783003	4133840		
16857	1535	3051031	1979-10-30	1979-10-30 00:00:00	1979-10-30	5001	0	\N	0	0	\N	\N	0	102759	0	46240-8	3051031		
46196	4260	3051031	1977-05-25	1977-05-25 00:00:00	1977-05-25	5001	0	\N	0	0	\N	\N	0	282809	0	46240-8	3051031		
46240	4261	46235214	1957-07-26	1957-07-26 00:00:00	1957-07-26	5001	0	\N	0	0	\N	\N	0	282888	0	76690-7	46235214		
46834	4312	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	286058	0	6833-8	3023430		
162282	4977	4024958	1999-08-30	1999-08-30 00:00:00	1999-08-30	5001	0	\N	0	0	\N	\N	0	331191	0	117015009	4024958		
39856	3703	3006734	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	246285	0	6189-5	3006734		
128335	3951	4024958	1948-12-31	1948-12-31 00:00:00	1948-12-31	5001	0	\N	0	0	\N	\N	0	262650	0	117015009	4024958		
28125	2591	3006322	1971-11-14	1971-11-14 00:00:00	1971-11-14	5001	0	\N	0	0	\N	\N	0	171491	0	8331-1	3006322		
68919	2114	4052083	1996-05-06	1996-05-06 00:00:00	1996-05-06	5001	0	\N	0	0	\N	\N	0	140676	0	23426006	4052083		
28282	2611	3006322	1974-07-14	1974-07-14 00:00:00	1974-07-14	5001	0	\N	0	0	\N	\N	0	172645	0	8331-1	3006322		
5074	489	3006734	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	32817	0	6189-5	3006734		
30386	2780	3006322	1958-12-30	1958-12-30 00:00:00	1958-12-30	5001	0	\N	0	0	\N	\N	0	184219	0	8331-1	3006322		
154417	4735	4024958	1980-05-14	1980-05-14 00:00:00	1980-05-14	5001	0	\N	0	0	\N	\N	0	315413	0	117015009	4024958		
33918	3081	46235214	1999-08-08	1999-08-08 00:00:00	1999-08-08	5001	0	\N	0	0	\N	\N	0	205121	0	76690-7	46235214		
56145	5150	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	342380	0	6082-2	3000876		
1938	176	3006322	1969-01-07	1969-01-07 00:00:00	1969-01-07	5001	0	\N	0	0	\N	\N	0	11891	0	8331-1	3006322		
13303	1264	3006322	1953-05-16	1953-05-16 00:00:00	1953-05-16	5001	0	\N	0	0	\N	\N	0	83321	0	8331-1	3006322		
158592	4874	4052083	1972-06-14	1972-06-14 00:00:00	1972-06-14	5001	0	\N	0	0	\N	\N	0	324158	0	23426006	4052083		
48019	4403	3011505	1998-07-04	1998-07-04 00:00:00	1998-07-04	5001	0	\N	0	0	\N	\N	0	292692	0	19926-5	3011505		
95021	2917	4052083	1964-11-14	1964-11-14 00:00:00	1964-11-14	5001	0	\N	0	0	\N	\N	0	194433	0	23426006	4052083		
7958	761	3000876	1995-06-23	1995-06-23 00:00:00	1995-06-23	5001	0	\N	0	0	\N	\N	0	50626	0	6082-2	3000876		
47341	4366	3023430	1994-05-10	1994-05-10 00:00:00	1994-05-10	5001	0	\N	0	0	\N	\N	0	289673	0	6833-8	3023430		
52787	4848	3006322	2018-04-10	2018-04-10 00:00:00	2018-04-10	5001	0	\N	0	0	\N	\N	0	322550	0	8331-1	3006322		
63821	1960	4052083	1983-10-04	1983-10-04 00:00:00	1983-10-04	5001	0	\N	0	0	\N	\N	0	130374	0	23426006	4052083		
46433	4276	40766240	1954-04-24	1954-04-24 00:00:00	1954-04-24	5001	0	\N	0	0	\N	\N	0	283738	0	63513-6	40766240		
31348	2864	3006322	1942-12-22	1942-12-22 00:00:00	1942-12-22	5001	0	\N	0	0	\N	\N	0	190463	0	8331-1	3006322		
21338	672	4052083	2004-11-15	2004-11-15 00:00:00	2004-11-15	5001	0	\N	0	0	\N	\N	0	44405	0	23426006	4052083		
171729	5272	4024958	1918-05-14	1918-05-14 00:00:00	1918-05-14	5001	0	\N	0	0	\N	\N	0	350651	0	117015009	4024958		
42851	3957	3051031	1965-12-13	1965-12-13 00:00:00	1965-12-13	5001	0	\N	0	0	\N	\N	0	263143	0	46240-8	3051031		
53745	4929	3006322	2012-09-15	2012-09-15 00:00:00	2012-09-15	5001	0	\N	0	0	\N	\N	0	327662	0	8331-1	3006322		
81453	2518	4133840	1992-12-04	1992-12-04 00:00:00	1992-12-04	5001	0	\N	0	0	\N	\N	0	166572	0	127783003	4133840		
55236	5051	3006734	1994-06-02	1994-06-02 00:00:00	1994-06-02	5001	0	\N	0	0	\N	\N	0	335889	0	6189-5	3006734		
38412	3543	3006322	1975-05-19	1975-05-19 00:00:00	1975-05-19	5001	0	\N	0	0	\N	\N	0	235368	0	8331-1	3006322		
49796	4529	3011505	1989-01-29	1989-01-29 00:00:00	1989-01-29	5001	0	\N	0	0	\N	\N	0	301553	0	19926-5	3011505		
514	11	4024958	1956-11-02	1956-11-02 00:00:00	1956-11-02	5001	0	\N	0	0	\N	\N	0	979	0	117015009	4024958		
11816	374	4024958	1986-01-06	1986-01-06 00:00:00	1986-01-06	5001	0	\N	0	0	\N	\N	0	24811	0	117015009	4024958		
108049	3337	4052083	2010-07-24	2010-07-24 00:00:00	2010-07-24	5001	0	\N	0	0	\N	\N	0	221371	0	23426006	4052083		
44501	4109	3019406	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	273140	0	6158-0	3019406		
24635	2265	3020655	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	150517	0	6844-5	3020655		
127588	3926	4133840	2015-07-13	2015-07-13 00:00:00	2015-07-13	5001	0	\N	0	0	\N	\N	0	260957	0	127783003	4133840		
52321	4807	3006322	1975-01-17	1975-01-17 00:00:00	1975-01-17	5001	0	\N	0	0	\N	\N	0	319789	0	8331-1	3006322		
12726	1214	3051031	1987-05-15	1987-05-15 00:00:00	1987-05-15	5001	0	\N	0	0	\N	\N	0	79904	0	46240-8	3051031		
47555	4372	3006451	1993-05-13	1993-05-13 00:00:00	1993-05-13	5001	0	\N	0	0	\N	\N	0	290262	0	6273-7	3006451		
40654	3773	3006322	1980-06-04	1980-06-04 00:00:00	1980-06-04	5001	0	\N	0	0	\N	\N	0	250779	0	8331-1	3006322		
40728	3783	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	251365	0	6844-5	3020655		
16294	1482	3011505	2005-11-19	2005-11-19 00:00:00	2005-11-19	5001	0	\N	0	0	\N	\N	0	98823	0	19926-5	3011505		
37993	3510	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	232943	0	7258-7	3001488		
13718	432	4024958	1939-03-21	1939-03-21 00:00:00	1939-03-21	5001	0	\N	0	0	\N	\N	0	28747	0	117015009	4024958		
41028	3811	3006322	1982-09-05	1982-09-05 00:00:00	1982-09-05	5001	0	\N	0	0	\N	\N	0	253220	0	8331-1	3006322		
26324	823	4133840	2017-01-23	2017-01-23 00:00:00	2017-01-23	5001	0	\N	0	0	\N	\N	0	54584	0	127783003	4133840		
87098	2690	4024958	1992-01-24	1992-01-24 00:00:00	1992-01-24	5001	0	\N	0	0	\N	\N	0	178241	0	117015009	4024958		
92066	2837	4024958	1978-09-01	1978-09-01 00:00:00	1978-09-01	5001	0	\N	0	0	\N	\N	0	188415	0	117015009	4024958		
14854	1378	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	91435	0	6082-2	3000876		
21442	1977	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	131561	0	6189-5	3006734		
32809	2970	3020655	1999-05-06	1999-05-06 00:00:00	1999-05-06	5001	0	\N	0	0	\N	\N	0	198331	0	6844-5	3020655		
32816	2970	3001488	1999-05-06	1999-05-06 00:00:00	1999-05-06	5001	0	\N	0	0	\N	\N	0	198331	0	7258-7	3001488		
15845	1447	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	96420	0	6844-5	3020655		
43882	1352	4052083	1959-12-07	1959-12-07 00:00:00	1959-12-07	5001	0	\N	0	0	\N	\N	0	89590	0	23426006	4052083		
28636	2649	3006322	1993-03-05	1993-03-05 00:00:00	1993-03-05	5001	0	\N	0	0	\N	\N	0	175333	0	8331-1	3006322		
39988	3718	3006322	1977-02-27	1977-02-27 00:00:00	1977-02-27	5001	0	\N	0	0	\N	\N	0	247107	0	8331-1	3006322		
55808	5118	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	340232	0	6075-6	3005136		
36352	3342	3006322	1914-03-17	1914-03-17 00:00:00	1914-03-17	5001	0	\N	0	0	\N	\N	0	221572	0	8331-1	3006322		
14861	1378	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	91435	0	6158-0	3019406		
110965	3430	4133840	2015-05-02	2015-05-02 00:00:00	2015-05-02	5001	0	\N	0	0	\N	\N	0	227356	0	127783003	4133840		
16859	1535	40758406	1979-10-30	1979-10-30 00:00:00	1979-10-30	5001	0	\N	0	0	\N	\N	0	102759	0	55277-8	40758406		
46197	4260	40766240	1977-05-25	1977-05-25 00:00:00	1977-05-25	5001	0	\N	0	0	\N	\N	0	282809	0	63513-6	40766240		
46243	4261	40758406	1957-07-26	1957-07-26 00:00:00	1957-07-26	5001	0	\N	0	0	\N	\N	0	282888	0	55277-8	40758406		
46835	4312	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	286058	0	6085-5	3001247		
162285	4977	4052083	1963-02-01	1963-02-01 00:00:00	1963-02-01	5001	0	\N	0	0	\N	\N	0	331184	0	23426006	4052083		
39857	3703	3006451	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	246285	0	6273-7	3006451		
128336	3951	4024958	1951-01-01	1951-01-01 00:00:00	1951-01-01	5001	0	\N	0	0	\N	\N	0	262649	0	117015009	4024958		
28126	2591	3006322	1992-08-12	1992-08-12 00:00:00	1992-08-12	5001	0	\N	0	0	\N	\N	0	171427	0	8331-1	3006322		
68925	2114	4024958	2003-11-08	2003-11-08 00:00:00	2003-11-08	5001	0	\N	0	0	\N	\N	0	140672	0	117015009	4024958		
39563	3666	3006322	1972-05-27	1972-05-27 00:00:00	1972-05-27	5001	0	\N	0	0	\N	\N	0	243874	0	8331-1	3006322		
5075	489	3001247	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	32817	0	6085-5	3001247		
30387	2780	3006322	1958-06-10	1958-06-10 00:00:00	1958-06-10	5001	0	\N	0	0	\N	\N	0	184233	0	8331-1	3006322		
44794	4139	3006322	1971-12-03	1971-12-03 00:00:00	1971-12-03	5001	0	\N	0	0	\N	\N	0	275133	0	8331-1	3006322		
33921	3081	40766240	1999-08-08	1999-08-08 00:00:00	1999-08-08	5001	0	\N	0	0	\N	\N	0	205121	0	63513-6	40766240		
56146	5150	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	342380	0	6158-0	3019406		
1939	176	3006322	2005-01-25	2005-01-25 00:00:00	2005-01-25	5001	0	\N	0	0	\N	\N	0	11894	0	8331-1	3006322		
13304	1264	3011505	2002-02-15	2002-02-15 00:00:00	2002-02-15	5001	0	\N	0	0	\N	\N	0	83284	0	19926-5	3011505		
169873	5213	4024958	1943-04-25	1943-04-25 00:00:00	1943-04-25	5001	0	\N	0	0	\N	\N	0	346706	0	117015009	4024958		
48020	4403	3049273	1992-10-04	1992-10-04 00:00:00	1992-10-04	5001	0	\N	0	0	\N	\N	0	292712	0	38265-5	3049273		
95031	2917	4024958	1971-03-06	1971-03-06 00:00:00	1971-03-06	5001	0	\N	0	0	\N	\N	0	194456	0	117015009	4024958		
7959	761	3006734	1995-06-23	1995-06-23 00:00:00	1995-06-23	5001	0	\N	0	0	\N	\N	0	50626	0	6189-5	3006734		
47342	4366	3020655	1994-05-10	1994-05-10 00:00:00	1994-05-10	5001	0	\N	0	0	\N	\N	0	289673	0	6844-5	3020655		
52788	4848	3006322	1986-07-15	1986-07-15 00:00:00	1986-07-15	5001	0	\N	0	0	\N	\N	0	322496	0	8331-1	3006322		
63827	1960	4024958	1987-10-15	1987-10-15 00:00:00	1987-10-15	5001	0	\N	0	0	\N	\N	0	130375	0	117015009	4024958		
46434	4276	40758406	1954-04-24	1954-04-24 00:00:00	1954-04-24	5001	0	\N	0	0	\N	\N	0	283738	0	55277-8	40758406		
31349	2864	3006322	1955-02-25	1955-02-25 00:00:00	1955-02-25	5001	0	\N	0	0	\N	\N	0	190550	0	8331-1	3006322		
21339	672	4024958	1996-09-28	1996-09-28 00:00:00	1996-09-28	5001	0	\N	0	0	\N	\N	0	44394	0	117015009	4024958		
171735	5272	4024958	1929-06-03	1929-06-03 00:00:00	1929-06-03	5001	0	\N	0	0	\N	\N	0	350709	0	117015009	4024958		
42852	3957	46235214	1965-12-13	1965-12-13 00:00:00	1965-12-13	5001	0	\N	0	0	\N	\N	0	263143	0	76690-7	46235214		
53746	4929	3006322	1984-10-15	1984-10-15 00:00:00	1984-10-15	5001	0	\N	0	0	\N	\N	0	327718	0	8331-1	3006322		
81456	2518	4133840	2002-02-01	2002-02-01 00:00:00	2002-02-01	5001	0	\N	0	0	\N	\N	0	166549	0	127783003	4133840		
55237	5051	3023430	1994-06-02	1994-06-02 00:00:00	1994-06-02	5001	0	\N	0	0	\N	\N	0	335889	0	6833-8	3023430		
38413	3543	3006322	1981-12-28	1981-12-28 00:00:00	1981-12-28	5001	0	\N	0	0	\N	\N	0	235348	0	8331-1	3006322		
49797	4529	3011505	2001-02-11	2001-02-11 00:00:00	2001-02-11	5001	0	\N	0	0	\N	\N	0	301563	0	19926-5	3011505		
520	11	4052083	1966-10-25	1966-10-25 00:00:00	1966-10-25	5001	0	\N	0	0	\N	\N	0	943	0	23426006	4052083		
11821	374	4024958	2002-07-24	2002-07-24 00:00:00	2002-07-24	5001	0	\N	0	0	\N	\N	0	24839	0	117015009	4024958		
108061	3337	4024958	1972-03-28	1972-03-28 00:00:00	1972-03-28	5001	0	\N	0	0	\N	\N	0	221420	0	117015009	4024958		
44502	4109	3006451	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	273140	0	6273-7	3006451		
24636	2265	3036780	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	150517	0	6095-4	3036780		
127590	3926	4133840	2011-03-07	2011-03-07 00:00:00	2011-03-07	5001	0	\N	0	0	\N	\N	0	261004	0	127783003	4133840		
52322	4807	3049273	2006-03-09	2006-03-09 00:00:00	2006-03-09	5001	0	\N	0	0	\N	\N	0	319872	0	38265-5	3049273		
12728	1214	40758406	1987-05-15	1987-05-15 00:00:00	1987-05-15	5001	0	\N	0	0	\N	\N	0	79904	0	55277-8	40758406		
47556	4372	3012494	1993-05-13	1993-05-13 00:00:00	1993-05-13	5001	0	\N	0	0	\N	\N	0	290262	0	6206-7	3012494		
40660	3776	3006322	2003-12-03	2003-12-03 00:00:00	2003-12-03	5001	0	\N	0	0	\N	\N	0	250948	0	8331-1	3006322		
40729	3783	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	251365	0	6082-2	3000876		
16295	1482	3006322	2011-06-08	2011-06-08 00:00:00	2011-06-08	5001	0	\N	0	0	\N	\N	0	98838	0	8331-1	3006322		
37994	3510	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	232943	0	6248-9	3015076		
117185	3612	4052083	1995-05-15	1995-05-15 00:00:00	1995-05-15	5001	0	\N	0	0	\N	\N	0	239935	0	23426006	4052083		
41029	3811	3006322	1948-03-20	1948-03-20 00:00:00	1948-03-20	5001	0	\N	0	0	\N	\N	0	253117	0	8331-1	3006322		
26328	823	4133840	2008-12-15	2008-12-15 00:00:00	2008-12-15	5001	0	\N	0	0	\N	\N	0	54525	0	127783003	4133840		
136036	4194	4024958	2005-04-23	2005-04-23 00:00:00	2005-04-23	5001	0	\N	0	0	\N	\N	0	278384	0	117015009	4024958		
92071	2837	4024958	1991-06-04	1991-06-04 00:00:00	1991-06-04	5001	0	\N	0	0	\N	\N	0	188417	0	117015009	4024958		
14855	1378	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	91435	0	6189-5	3006734		
21443	1977	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	131561	0	6085-5	3001247		
32810	2970	3001488	1999-05-06	1999-05-06 00:00:00	1999-05-06	5001	0	\N	0	0	\N	\N	0	198331	0	7258-7	3001488		
32817	2970	3000876	1999-05-06	1999-05-06 00:00:00	1999-05-06	5001	0	\N	0	0	\N	\N	0	198331	0	6082-2	3000876		
15846	1447	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	96420	0	6085-5	3001247		
43883	1352	4133840	2015-03-22	2015-03-22 00:00:00	2015-03-22	5001	0	\N	0	0	\N	\N	0	89546	0	127783003	4133840		
28637	2649	3006322	2012-03-19	2012-03-19 00:00:00	2012-03-19	5001	0	\N	0	0	\N	\N	0	175273	0	8331-1	3006322		
39990	3718	3006322	1987-03-11	1987-03-11 00:00:00	1987-03-11	5001	0	\N	0	0	\N	\N	0	247137	0	8331-1	3006322		
55809	5118	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	340232	0	6246-3	3021226		
36353	3342	3006322	1978-04-19	1978-04-19 00:00:00	1978-04-19	5001	0	\N	0	0	\N	\N	0	221633	0	8331-1	3006322		
14862	1378	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	91435	0	6075-6	3005136		
110967	3430	4133840	2009-04-04	2009-04-04 00:00:00	2009-04-04	5001	0	\N	0	0	\N	\N	0	227372	0	127783003	4133840		
16860	1535	40766240	1979-10-30	1979-10-30 00:00:00	1979-10-30	5001	0	\N	0	0	\N	\N	0	102759	0	63513-6	40766240		
46199	4260	40766240	1977-04-25	1977-04-25 00:00:00	1977-04-25	5001	0	\N	0	0	\N	\N	0	282835	0	63513-6	40766240		
46244	4261	40766240	1957-07-26	1957-07-26 00:00:00	1957-07-26	5001	0	\N	0	0	\N	\N	0	282888	0	63513-6	40766240		
46836	4312	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	286058	0	6273-7	3006451		
162288	4977	4024958	1987-11-04	1987-11-04 00:00:00	1987-11-04	5001	0	\N	0	0	\N	\N	0	331162	0	117015009	4024958		
39858	3703	3014599	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	246285	0	6106-9	3014599		
128342	3951	4052083	1997-12-11	1997-12-11 00:00:00	1997-12-11	5001	0	\N	0	0	\N	\N	0	262686	0	23426006	4052083		
28127	2591	3006322	1987-01-01	1987-01-01 00:00:00	1987-01-01	5001	0	\N	0	0	\N	\N	0	171496	0	8331-1	3006322		
68967	2115	4052083	1972-10-20	1972-10-20 00:00:00	1972-10-20	5001	0	\N	0	0	\N	\N	0	140691	0	23426006	4052083		
39564	3666	3006322	1989-02-08	1989-02-08 00:00:00	1989-02-08	5001	0	\N	0	0	\N	\N	0	243916	0	8331-1	3006322		
5076	489	3000876	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	32817	0	6082-2	3000876		
30388	2780	3006322	2013-02-27	2013-02-27 00:00:00	2013-02-27	5001	0	\N	0	0	\N	\N	0	184223	0	8331-1	3006322		
44799	4142	3006322	2004-03-08	2004-03-08 00:00:00	2004-03-08	5001	0	\N	0	0	\N	\N	0	275284	0	8331-1	3006322		
33922	3081	3006322	1970-09-15	1970-09-15 00:00:00	1970-09-15	5001	0	\N	0	0	\N	\N	0	205158	0	8331-1	3006322		
56147	5150	3006322	1987-10-17	1987-10-17 00:00:00	1987-10-17	5001	0	\N	0	0	\N	\N	0	342354	0	8331-1	3006322		
1940	177	3006322	1969-03-13	1969-03-13 00:00:00	1969-03-13	5001	0	\N	0	0	\N	\N	0	12003	0	8331-1	3006322		
13305	1264	3011505	2010-11-05	2010-11-05 00:00:00	2010-11-05	5001	0	\N	0	0	\N	\N	0	83291	0	19926-5	3011505		
169884	5213	4052083	1942-11-23	1942-11-23 00:00:00	1942-11-23	5001	0	\N	0	0	\N	\N	0	346763	0	23426006	4052083		
48021	4403	3011505	1995-06-17	1995-06-17 00:00:00	1995-06-17	5001	0	\N	0	0	\N	\N	0	292695	0	19926-5	3011505		
95049	2919	4133840	2017-12-16	2017-12-16 00:00:00	2017-12-16	5001	0	\N	0	0	\N	\N	0	194622	0	127783003	4133840		
7960	761	3020655	1995-06-23	1995-06-23 00:00:00	1995-06-23	5001	0	\N	0	0	\N	\N	0	50626	0	6844-5	3020655		
47343	4366	3001488	1994-05-10	1994-05-10 00:00:00	1994-05-10	5001	0	\N	0	0	\N	\N	0	289673	0	7258-7	3001488		
52789	4848	3006322	1997-11-22	1997-11-22 00:00:00	1997-11-22	5001	0	\N	0	0	\N	\N	0	322500	0	8331-1	3006322		
63829	1960	4024958	1944-01-13	1944-01-13 00:00:00	1944-01-13	5001	0	\N	0	0	\N	\N	0	130319	0	117015009	4024958		
46435	4276	3051031	1954-04-24	1954-04-24 00:00:00	1954-04-24	5001	0	\N	0	0	\N	\N	0	283738	0	46240-8	3051031		
31350	2864	3006322	1994-09-27	1994-09-27 00:00:00	1994-09-27	5001	0	\N	0	0	\N	\N	0	190501	0	8331-1	3006322		
21340	672	4052083	1956-10-25	1956-10-25 00:00:00	1956-10-25	5001	0	\N	0	0	\N	\N	0	44334	0	23426006	4052083		
171737	5272	4052083	2001-03-22	2001-03-22 00:00:00	2001-03-22	5001	0	\N	0	0	\N	\N	0	350612	0	23426006	4052083		
42854	3957	40766240	1965-12-13	1965-12-13 00:00:00	1965-12-13	5001	0	\N	0	0	\N	\N	0	263143	0	63513-6	40766240		
53750	4932	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	327826	0	6246-3	3021226		
81459	2518	4133840	2005-08-19	2005-08-19 00:00:00	2005-08-19	5001	0	\N	0	0	\N	\N	0	166591	0	127783003	4133840		
55238	5051	3020655	1994-06-02	1994-06-02 00:00:00	1994-06-02	5001	0	\N	0	0	\N	\N	0	335889	0	6844-5	3020655		
38414	3543	3006322	2008-12-19	2008-12-19 00:00:00	2008-12-19	5001	0	\N	0	0	\N	\N	0	235371	0	8331-1	3006322		
49798	4529	3006322	1984-11-03	1984-11-03 00:00:00	1984-11-03	5001	0	\N	0	0	\N	\N	0	301545	0	8331-1	3006322		
543	11	4024958	1963-06-13	1963-06-13 00:00:00	1963-06-13	5001	0	\N	0	0	\N	\N	0	970	0	117015009	4024958		
39434	1226	4024958	1993-07-28	1993-07-28 00:00:00	1993-07-28	5001	0	\N	0	0	\N	\N	0	80712	0	117015009	4024958		
108070	3337	4052083	2019-06-10	2019-06-10 00:00:00	2019-06-10	5001	0	\N	0	0	\N	\N	0	221358	0	23426006	4052083		
44503	4109	3005136	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	273140	0	6075-6	3005136		
24637	2265	3021226	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	150517	0	6246-3	3021226		
127591	3926	4133840	1990-10-08	1990-10-08 00:00:00	1990-10-08	5001	0	\N	0	0	\N	\N	0	260999	0	127783003	4133840		
52323	4807	3006322	1948-04-16	1948-04-16 00:00:00	1948-04-16	5001	0	\N	0	0	\N	\N	0	319802	0	8331-1	3006322		
12730	1214	46235214	1987-05-15	1987-05-15 00:00:00	1987-05-15	5001	0	\N	0	0	\N	\N	0	79904	0	76690-7	46235214		
47557	4372	3021226	1993-05-13	1993-05-13 00:00:00	1993-05-13	5001	0	\N	0	0	\N	\N	0	290262	0	6246-3	3021226		
40661	3776	3006322	1979-12-29	1979-12-29 00:00:00	1979-12-29	5001	0	\N	0	0	\N	\N	0	250983	0	8331-1	3006322		
40730	3783	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	251365	0	7258-7	3001488		
18230	572	4024958	1954-05-24	1954-05-24 00:00:00	1954-05-24	5001	0	\N	0	0	\N	\N	0	37893	0	117015009	4024958		
37995	3510	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	232943	0	6206-7	3012494		
117191	3612	4024958	1985-06-20	1985-06-20 00:00:00	1985-06-20	5001	0	\N	0	0	\N	\N	0	239961	0	117015009	4024958		
41030	3811	3006322	1969-12-31	1969-12-31 00:00:00	1969-12-31	5001	0	\N	0	0	\N	\N	0	253120	0	8331-1	3006322		
26329	823	4052083	2009-02-01	2009-02-01 00:00:00	2009-02-01	5001	0	\N	0	0	\N	\N	0	54532	0	23426006	4052083		
147366	4520	4133840	1991-01-05	1991-01-05 00:00:00	1991-01-05	5001	0	\N	0	0	\N	\N	0	300927	0	127783003	4133840		
92073	2837	4052083	1998-09-25	1998-09-25 00:00:00	1998-09-25	5001	0	\N	0	0	\N	\N	0	188463	0	23426006	4052083		
14856	1378	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	91435	0	6085-5	3001247		
21444	1977	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	131561	0	6158-0	3019406		
32811	2970	3000876	1999-05-06	1999-05-06 00:00:00	1999-05-06	5001	0	\N	0	0	\N	\N	0	198331	0	6082-2	3000876		
32818	2970	3015076	1999-05-06	1999-05-06 00:00:00	1999-05-06	5001	0	\N	0	0	\N	\N	0	198331	0	6248-9	3015076		
15847	1447	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	96420	0	6206-7	3012494		
43885	1352	4052083	1946-09-05	1946-09-05 00:00:00	1946-09-05	5001	0	\N	0	0	\N	\N	0	89532	0	23426006	4052083		
28638	2649	3006322	1963-01-16	1963-01-16 00:00:00	1963-01-16	5001	0	\N	0	0	\N	\N	0	175252	0	8331-1	3006322		
39992	3719	3006322	1978-07-28	1978-07-28 00:00:00	1978-07-28	5001	0	\N	0	0	\N	\N	0	247209	0	8331-1	3006322		
55810	5118	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	340232	0	6158-0	3019406		
36354	3342	3049273	1981-07-20	1981-07-20 00:00:00	1981-07-20	5001	0	\N	0	0	\N	\N	0	221568	0	38265-5	3049273		
14863	1378	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	91435	0	6248-9	3015076		
110969	3430	4133840	2014-04-26	2014-04-26 00:00:00	2014-04-26	5001	0	\N	0	0	\N	\N	0	227377	0	127783003	4133840		
16862	1535	3006322	2012-07-06	2012-07-06 00:00:00	2012-07-06	5001	0	\N	0	0	\N	\N	0	102761	0	8331-1	3006322		
46200	4260	46235214	1977-04-25	1977-04-25 00:00:00	1977-04-25	5001	0	\N	0	0	\N	\N	0	282835	0	76690-7	46235214		
46245	4261	3051031	1957-07-26	1957-07-26 00:00:00	1957-07-26	5001	0	\N	0	0	\N	\N	0	282888	0	46240-8	3051031		
46837	4312	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	286058	0	6206-7	3012494		
172483	5291	4052083	2007-09-05	2007-09-05 00:00:00	2007-09-05	5001	0	\N	0	0	\N	\N	0	352067	0	23426006	4052083		
39859	3703	3015076	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	246285	0	6248-9	3015076		
139645	4305	4024958	1997-07-07	1997-07-07 00:00:00	1997-07-07	5001	0	\N	0	0	\N	\N	0	285530	0	117015009	4024958		
28128	2591	3006322	2003-04-07	2003-04-07 00:00:00	2003-04-07	5001	0	\N	0	0	\N	\N	0	171456	0	8331-1	3006322		
68978	2116	4052083	1965-02-04	1965-02-04 00:00:00	1965-02-04	5001	0	\N	0	0	\N	\N	0	140790	0	23426006	4052083		
39565	3666	3006322	1969-04-29	1969-04-29 00:00:00	1969-04-29	5001	0	\N	0	0	\N	\N	0	243859	0	8331-1	3006322		
5077	489	3019406	1976-11-03	1976-11-03 00:00:00	1976-11-03	5001	0	\N	0	0	\N	\N	0	32754	0	6158-0	3019406		
30389	2781	3006322	1990-04-22	1990-04-22 00:00:00	1990-04-22	5001	0	\N	0	0	\N	\N	0	184297	0	8331-1	3006322		
44800	4142	3006322	1988-06-08	1988-06-08 00:00:00	1988-06-08	5001	0	\N	0	0	\N	\N	0	275319	0	8331-1	3006322		
33923	3081	40758406	1999-07-09	1999-07-09 00:00:00	1999-07-09	5001	0	\N	0	0	\N	\N	0	205161	0	55277-8	40758406		
56148	5150	3006322	1939-12-26	1939-12-26 00:00:00	1939-12-26	5001	0	\N	0	0	\N	\N	0	342364	0	8331-1	3006322		
1941	177	3006322	1969-04-28	1969-04-28 00:00:00	1969-04-28	5001	0	\N	0	0	\N	\N	0	12004	0	8331-1	3006322		
13306	1264	3011505	1992-01-17	1992-01-17 00:00:00	1992-01-17	5001	0	\N	0	0	\N	\N	0	83311	0	19926-5	3011505		
9754	312	4052083	2009-05-30	2009-05-30 00:00:00	2009-05-30	5001	0	\N	0	0	\N	\N	0	20676	0	23426006	4052083		
48022	4403	3011505	2000-07-15	2000-07-15 00:00:00	2000-07-15	5001	0	\N	0	0	\N	\N	0	292650	0	19926-5	3011505		
106337	3275	4052083	1996-10-21	1996-10-21 00:00:00	1996-10-21	5001	0	\N	0	0	\N	\N	0	217610	0	23426006	4052083		
7961	761	3001247	1995-06-23	1995-06-23 00:00:00	1995-06-23	5001	0	\N	0	0	\N	\N	0	50626	0	6085-5	3001247		
47344	4366	3006451	1994-05-10	1994-05-10 00:00:00	1994-05-10	5001	0	\N	0	0	\N	\N	0	289673	0	6273-7	3006451		
52790	4848	3006322	1959-03-13	1959-03-13 00:00:00	1959-03-13	5001	0	\N	0	0	\N	\N	0	322491	0	8331-1	3006322		
63854	1962	4024958	1967-10-04	1967-10-04 00:00:00	1967-10-04	5001	0	\N	0	0	\N	\N	0	130488	0	117015009	4024958		
46437	4276	46235214	1954-04-24	1954-04-24 00:00:00	1954-04-24	5001	0	\N	0	0	\N	\N	0	283738	0	76690-7	46235214		
31351	2864	3006322	1947-03-29	1947-03-29 00:00:00	1947-03-29	5001	0	\N	0	0	\N	\N	0	190464	0	8331-1	3006322		
21343	672	4052083	1965-04-19	1965-04-19 00:00:00	1965-04-19	5001	0	\N	0	0	\N	\N	0	44335	0	23426006	4052083		
171749	5272	4052083	1972-01-04	1972-01-04 00:00:00	1972-01-04	5001	0	\N	0	0	\N	\N	0	350656	0	23426006	4052083		
42855	3958	3006322	1983-03-20	1983-03-20 00:00:00	1983-03-20	5001	0	\N	0	0	\N	\N	0	263148	0	8331-1	3006322		
53751	4932	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	327826	0	6075-6	3005136		
81461	2518	4133840	2015-01-16	2015-01-16 00:00:00	2015-01-16	5001	0	\N	0	0	\N	\N	0	166576	0	127783003	4133840		
55239	5051	3006451	1994-06-02	1994-06-02 00:00:00	1994-06-02	5001	0	\N	0	0	\N	\N	0	335889	0	6273-7	3006451		
38419	3545	3006322	1996-01-09	1996-01-09 00:00:00	1996-01-09	5001	0	\N	0	0	\N	\N	0	235484	0	8331-1	3006322		
49799	4529	3011505	2011-12-11	2011-12-11 00:00:00	2011-12-11	5001	0	\N	0	0	\N	\N	0	301556	0	19926-5	3011505		
544	11	4024958	1970-06-01	1970-06-01 00:00:00	1970-06-01	5001	0	\N	0	0	\N	\N	0	971	0	117015009	4024958		
39452	1226	4024958	1986-10-06	1986-10-06 00:00:00	1986-10-06	5001	0	\N	0	0	\N	\N	0	80707	0	117015009	4024958		
108076	3337	4052083	1982-07-03	1982-07-03 00:00:00	1982-07-03	5001	0	\N	0	0	\N	\N	0	221415	0	23426006	4052083		
44504	4109	3015076	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	273140	0	6248-9	3015076		
24638	2265	3027231	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	150517	0	6276-0	3027231		
127595	3926	4133840	2018-07-30	2018-07-30 00:00:00	2018-07-30	5001	0	\N	0	0	\N	\N	0	260935	0	127783003	4133840		
52324	4807	3006322	1967-07-12	1967-07-12 00:00:00	1967-07-12	5001	0	\N	0	0	\N	\N	0	319797	0	8331-1	3006322		
12731	1214	40766240	1987-05-15	1987-05-15 00:00:00	1987-05-15	5001	0	\N	0	0	\N	\N	0	79904	0	63513-6	40766240		
47558	4372	3005136	1993-05-13	1993-05-13 00:00:00	1993-05-13	5001	0	\N	0	0	\N	\N	0	290262	0	6075-6	3005136		
40662	3776	3006322	2014-08-28	2014-08-28 00:00:00	2014-08-28	5001	0	\N	0	0	\N	\N	0	250989	0	8331-1	3006322		
40731	3783	3006322	1946-06-05	1946-06-05 00:00:00	1946-06-05	5001	0	\N	0	0	\N	\N	0	251386	0	8331-1	3006322		
18248	572	4052083	2008-09-26	2008-09-26 00:00:00	2008-09-26	5001	0	\N	0	0	\N	\N	0	37870	0	23426006	4052083		
37996	3510	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	232943	0	6246-3	3021226		
117193	3612	4052083	2000-04-30	2000-04-30 00:00:00	2000-04-30	5001	0	\N	0	0	\N	\N	0	239973	0	23426006	4052083		
41031	3811	3006322	2008-04-13	2008-04-13 00:00:00	2008-04-13	5001	0	\N	0	0	\N	\N	0	253184	0	8331-1	3006322		
26330	823	4133840	2009-12-14	2009-12-14 00:00:00	2009-12-14	5001	0	\N	0	0	\N	\N	0	54599	0	127783003	4133840		
147371	4520	4133840	1974-10-12	1974-10-12 00:00:00	1974-10-12	5001	0	\N	0	0	\N	\N	0	300887	0	127783003	4133840		
92078	2837	4024958	1969-08-18	1969-08-18 00:00:00	1969-08-18	5001	0	\N	0	0	\N	\N	0	188460	0	117015009	4024958		
14857	1378	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	91435	0	6833-8	3023430		
21445	1977	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	131561	0	6833-8	3023430		
32812	2970	3006322	1980-06-14	1980-06-14 00:00:00	1980-06-14	5001	0	\N	0	0	\N	\N	0	198306	0	8331-1	3006322		
32819	2970	3036780	1999-05-06	1999-05-06 00:00:00	1999-05-06	5001	0	\N	0	0	\N	\N	0	198331	0	6095-4	3036780		
15848	1447	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	96420	0	6158-0	3019406		
43887	1352	4133840	2002-04-07	2002-04-07 00:00:00	2002-04-07	5001	0	\N	0	0	\N	\N	0	89577	0	127783003	4133840		
28639	2649	3006322	1998-09-18	1998-09-18 00:00:00	1998-09-18	5001	0	\N	0	0	\N	\N	0	175280	0	8331-1	3006322		
39996	3719	3006322	1998-10-21	1998-10-21 00:00:00	1998-10-21	5001	0	\N	0	0	\N	\N	0	247151	0	8331-1	3006322		
55811	5118	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	340232	0	7258-7	3001488		
36355	3342	3006322	1971-10-11	1971-10-11 00:00:00	1971-10-11	5001	0	\N	0	0	\N	\N	0	221564	0	8331-1	3006322		
74265	2280	4024958	1976-04-16	1976-04-16 00:00:00	1976-04-16	5001	0	\N	0	0	\N	\N	0	151560	0	117015009	4024958		
110973	3430	4133840	1995-03-11	1995-03-11 00:00:00	1995-03-11	5001	0	\N	0	0	\N	\N	0	227369	0	127783003	4133840		
16863	1535	3006322	2015-10-31	2015-10-31 00:00:00	2015-10-31	5001	0	\N	0	0	\N	\N	0	102762	0	8331-1	3006322		
46203	4260	40758406	1977-04-25	1977-04-25 00:00:00	1977-04-25	5001	0	\N	0	0	\N	\N	0	282835	0	55277-8	40758406		
46247	4261	3051031	1926-05-10	1926-05-10 00:00:00	1926-05-10	5001	0	\N	0	0	\N	\N	0	282970	0	46240-8	3051031		
46838	4312	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	286058	0	6189-5	3006734		
172532	5295	4024958	1934-01-26	1934-01-26 00:00:00	1934-01-26	5001	0	\N	0	0	\N	\N	0	352271	0	117015009	4024958		
39860	3703	3019406	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	246285	0	6158-0	3019406		
139674	4305	4052083	2012-08-01	2012-08-01 00:00:00	2012-08-01	5001	0	\N	0	0	\N	\N	0	285644	0	23426006	4052083		
28129	2591	3049273	2004-02-15	2004-02-15 00:00:00	2004-02-15	5001	0	\N	0	0	\N	\N	0	171448	0	38265-5	3049273		
68979	2116	4052083	2005-12-02	2005-12-02 00:00:00	2005-12-02	5001	0	\N	0	0	\N	\N	0	140847	0	23426006	4052083		
39566	3666	3006322	2017-01-21	2017-01-21 00:00:00	2017-01-21	5001	0	\N	0	0	\N	\N	0	243917	0	8331-1	3006322		
5078	489	3005136	1976-11-03	1976-11-03 00:00:00	1976-11-03	5001	0	\N	0	0	\N	\N	0	32754	0	6075-6	3005136		
30390	2781	3051031	2012-04-19	2012-04-19 00:00:00	2012-04-19	5001	0	\N	0	0	\N	\N	0	184331	0	46240-8	3051031		
44801	4142	3006322	1992-10-28	1992-10-28 00:00:00	1992-10-28	5001	0	\N	0	0	\N	\N	0	275320	0	8331-1	3006322		
33924	3081	3051031	1999-07-09	1999-07-09 00:00:00	1999-07-09	5001	0	\N	0	0	\N	\N	0	205161	0	46240-8	3051031		
56149	5150	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	342409	0	7258-7	3001488		
1942	177	3006322	1991-10-28	1991-10-28 00:00:00	1991-10-28	5001	0	\N	0	0	\N	\N	0	11993	0	8331-1	3006322		
13307	1264	3011505	2018-06-01	2018-06-01 00:00:00	2018-06-01	5001	0	\N	0	0	\N	\N	0	83283	0	19926-5	3011505		
9763	312	4052083	1972-05-24	1972-05-24 00:00:00	1972-05-24	5001	0	\N	0	0	\N	\N	0	20660	0	23426006	4052083		
48023	4403	3011505	1990-05-19	1990-05-19 00:00:00	1990-05-19	5001	0	\N	0	0	\N	\N	0	292736	0	19926-5	3011505		
106343	3275	4052083	1993-04-02	1993-04-02 00:00:00	1993-04-02	5001	0	\N	0	0	\N	\N	0	217609	0	23426006	4052083		
7962	761	3027231	1995-06-23	1995-06-23 00:00:00	1995-06-23	5001	0	\N	0	0	\N	\N	0	50626	0	6276-0	3027231		
47345	4366	3012494	1994-05-10	1994-05-10 00:00:00	1994-05-10	5001	0	\N	0	0	\N	\N	0	289673	0	6206-7	3012494		
165935	5099	4052083	2017-02-16	2017-02-16 00:00:00	2017-02-16	5001	0	\N	0	0	\N	\N	0	338864	0	23426006	4052083		
63859	1962	4024958	1992-04-13	1992-04-13 00:00:00	1992-04-13	5001	0	\N	0	0	\N	\N	0	130490	0	117015009	4024958		
46438	4276	3049273	2005-05-21	2005-05-21 00:00:00	2005-05-21	5001	0	\N	0	0	\N	\N	0	283772	0	38265-5	3049273		
31352	2864	3006322	2014-06-06	2014-06-06 00:00:00	2014-06-06	5001	0	\N	0	0	\N	\N	0	190530	0	8331-1	3006322		
21350	672	4024958	1995-04-27	1995-04-27 00:00:00	1995-04-27	5001	0	\N	0	0	\N	\N	0	44351	0	117015009	4024958		
171755	5272	4024958	2014-01-27	2014-01-27 00:00:00	2014-01-27	5001	0	\N	0	0	\N	\N	0	350633	0	117015009	4024958		
42856	3958	3006322	1997-03-16	1997-03-16 00:00:00	1997-03-16	5001	0	\N	0	0	\N	\N	0	263149	0	8331-1	3006322		
53752	4932	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	327826	0	6158-0	3019406		
81463	2518	4133840	1986-11-28	1986-11-28 00:00:00	1986-11-28	5001	0	\N	0	0	\N	\N	0	166515	0	127783003	4133840		
55240	5051	3021226	1994-06-02	1994-06-02 00:00:00	1994-06-02	5001	0	\N	0	0	\N	\N	0	335889	0	6246-3	3021226		
38420	3545	3006322	1991-02-19	1991-02-19 00:00:00	1991-02-19	5001	0	\N	0	0	\N	\N	0	235447	0	8331-1	3006322		
49800	4529	3011505	2018-12-16	2018-12-16 00:00:00	2018-12-16	5001	0	\N	0	0	\N	\N	0	301581	0	19926-5	3011505		
548	12	4052083	1986-10-23	1986-10-23 00:00:00	1986-10-23	5001	0	\N	0	0	\N	\N	0	1019	0	23426006	4052083		
39454	1226	4024958	1990-08-31	1990-08-31 00:00:00	1990-08-31	5001	0	\N	0	0	\N	\N	0	80694	0	117015009	4024958		
108104	3339	4052083	2012-09-13	2012-09-13 00:00:00	2012-09-13	5001	0	\N	0	0	\N	\N	0	221478	0	23426006	4052083		
44505	4109	3012494	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	273140	0	6206-7	3012494		
24639	2265	3015076	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	150517	0	6248-9	3015076		
127596	3926	4133840	1994-10-17	1994-10-17 00:00:00	1994-10-17	5001	0	\N	0	0	\N	\N	0	260951	0	127783003	4133840		
52332	4811	3006322	1962-06-17	1962-06-17 00:00:00	1962-06-17	5001	0	\N	0	0	\N	\N	0	320071	0	8331-1	3006322		
12733	1214	46235214	1987-01-15	1987-01-15 00:00:00	1987-01-15	5001	0	\N	0	0	\N	\N	0	79901	0	76690-7	46235214		
47559	4372	3015076	1993-05-13	1993-05-13 00:00:00	1993-05-13	5001	0	\N	0	0	\N	\N	0	290262	0	6248-9	3015076		
40663	3776	3006322	2008-01-23	2008-01-23 00:00:00	2008-01-23	5001	0	\N	0	0	\N	\N	0	250985	0	8331-1	3006322		
40732	3783	3049273	2008-11-02	2008-11-02 00:00:00	2008-11-02	5001	0	\N	0	0	\N	\N	0	251384	0	38265-5	3049273		
18256	573	4024958	1998-10-28	1998-10-28 00:00:00	1998-10-28	5001	0	\N	0	0	\N	\N	0	38001	0	117015009	4024958		
37997	3510	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	232943	0	6095-4	3036780		
117213	3612	4024958	1996-01-11	1996-01-11 00:00:00	1996-01-11	5001	0	\N	0	0	\N	\N	0	239936	0	117015009	4024958		
41032	3811	3006322	1994-03-31	1994-03-31 00:00:00	1994-03-31	5001	0	\N	0	0	\N	\N	0	253221	0	8331-1	3006322		
26335	823	4024958	1953-02-19	1953-02-19 00:00:00	1953-02-19	5001	0	\N	0	0	\N	\N	0	54529	0	117015009	4024958		
147375	4520	4133840	1960-09-17	1960-09-17 00:00:00	1960-09-17	5001	0	\N	0	0	\N	\N	0	300923	0	127783003	4133840		
92080	2837	4052083	1992-04-19	1992-04-19 00:00:00	1992-04-19	5001	0	\N	0	0	\N	\N	0	188437	0	23426006	4052083		
26135	2402	3006322	1977-08-10	1977-08-10 00:00:00	1977-08-10	5001	0	\N	0	0	\N	\N	0	159615	0	8331-1	3006322		
21446	1977	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	131561	0	7258-7	3001488		
32813	2970	3001247	1999-05-06	1999-05-06 00:00:00	1999-05-06	5001	0	\N	0	0	\N	\N	0	198331	0	6085-5	3001247		
32820	2970	3014599	1999-05-06	1999-05-06 00:00:00	1999-05-06	5001	0	\N	0	0	\N	\N	0	198331	0	6106-9	3014599		
15849	1447	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	96420	0	6075-6	3005136		
43888	1352	4133840	2017-01-22	2017-01-22 00:00:00	2017-01-22	5001	0	\N	0	0	\N	\N	0	89547	0	127783003	4133840		
28640	2649	3006322	1982-04-20	1982-04-20 00:00:00	1982-04-20	5001	0	\N	0	0	\N	\N	0	175299	0	8331-1	3006322		
39997	3719	3006322	1972-05-21	1972-05-21 00:00:00	1972-05-21	5001	0	\N	0	0	\N	\N	0	247208	0	8331-1	3006322		
55812	5118	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	340232	0	6085-5	3001247		
36356	3343	3006322	1999-05-03	1999-05-03 00:00:00	1999-05-03	5001	0	\N	0	0	\N	\N	0	221785	0	8331-1	3006322		
74268	2280	4024958	1986-08-31	1986-08-31 00:00:00	1986-08-31	5001	0	\N	0	0	\N	\N	0	151566	0	117015009	4024958		
110976	3430	4133840	2017-05-13	2017-05-13 00:00:00	2017-05-13	5001	0	\N	0	0	\N	\N	0	227341	0	127783003	4133840		
16864	1535	3006322	1983-08-09	1983-08-09 00:00:00	1983-08-09	5001	0	\N	0	0	\N	\N	0	102707	0	8331-1	3006322		
46204	4260	3051031	1977-04-25	1977-04-25 00:00:00	1977-04-25	5001	0	\N	0	0	\N	\N	0	282835	0	46240-8	3051031		
46249	4261	40758406	1926-05-10	1926-05-10 00:00:00	1926-05-10	5001	0	\N	0	0	\N	\N	0	282970	0	55277-8	40758406		
46839	4312	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	286058	0	6276-0	3027231		
172534	5295	4052083	1944-05-08	1944-05-08 00:00:00	1944-05-08	5001	0	\N	0	0	\N	\N	0	352281	0	23426006	4052083		
39861	3703	3005136	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	246285	0	6075-6	3005136		
59708	1821	4052083	1974-11-18	1974-11-18 00:00:00	1974-11-18	5001	0	\N	0	0	\N	\N	0	121811	0	23426006	4052083		
28130	2591	3006322	1970-09-07	1970-09-07 00:00:00	1970-09-07	5001	0	\N	0	0	\N	\N	0	171453	0	8331-1	3006322		
68985	2116	4052083	1979-03-26	1979-03-26 00:00:00	1979-03-26	5001	0	\N	0	0	\N	\N	0	140793	0	23426006	4052083		
39567	3666	3006322	1966-07-30	1966-07-30 00:00:00	1966-07-30	5001	0	\N	0	0	\N	\N	0	243911	0	8331-1	3006322		
5079	489	3012494	1976-11-03	1976-11-03 00:00:00	1976-11-03	5001	0	\N	0	0	\N	\N	0	32754	0	6206-7	3012494		
30392	2781	46235214	2012-04-19	2012-04-19 00:00:00	2012-04-19	5001	0	\N	0	0	\N	\N	0	184331	0	76690-7	46235214		
44802	4142	3006322	2007-08-02	2007-08-02 00:00:00	2007-08-02	5001	0	\N	0	0	\N	\N	0	275307	0	8331-1	3006322		
33925	3081	40766240	1999-07-09	1999-07-09 00:00:00	1999-07-09	5001	0	\N	0	0	\N	\N	0	205161	0	63513-6	40766240		
56150	5150	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	342409	0	6189-5	3006734		
1943	177	3006322	1983-12-27	1983-12-27 00:00:00	1983-12-27	5001	0	\N	0	0	\N	\N	0	12005	0	8331-1	3006322		
13308	1264	3011505	1997-01-03	1997-01-03 00:00:00	1997-01-03	5001	0	\N	0	0	\N	\N	0	83357	0	19926-5	3011505		
114525	3529	4024958	1947-08-13	1947-08-13 00:00:00	1947-08-13	5001	0	\N	0	0	\N	\N	0	234300	0	117015009	4024958		
48024	4403	3006322	1945-09-19	1945-09-19 00:00:00	1945-09-19	5001	0	\N	0	0	\N	\N	0	292658	0	8331-1	3006322		
106353	3275	4052083	2002-06-01	2002-06-01 00:00:00	2002-06-01	5001	0	\N	0	0	\N	\N	0	217631	0	23426006	4052083		
7963	761	3019406	1995-06-23	1995-06-23 00:00:00	1995-06-23	5001	0	\N	0	0	\N	\N	0	50626	0	6158-0	3019406		
47346	4366	3014599	1994-05-10	1994-05-10 00:00:00	1994-05-10	5001	0	\N	0	0	\N	\N	0	289673	0	6106-9	3014599		
165936	5099	4024958	1944-03-31	1944-03-31 00:00:00	1944-03-31	5001	0	\N	0	0	\N	\N	0	338833	0	117015009	4024958		
63874	1962	4024958	1985-02-10	1985-02-10 00:00:00	1985-02-10	5001	0	\N	0	0	\N	\N	0	130489	0	117015009	4024958		
46439	4276	40758406	1954-02-23	1954-02-23 00:00:00	1954-02-23	5001	0	\N	0	0	\N	\N	0	283736	0	55277-8	40758406		
31353	2864	3006322	1963-05-26	1963-05-26 00:00:00	1963-05-26	5001	0	\N	0	0	\N	\N	0	190497	0	8331-1	3006322		
21354	672	4052083	1972-11-15	1972-11-15 00:00:00	1972-11-15	5001	0	\N	0	0	\N	\N	0	44369	0	23426006	4052083		
171773	5272	4024958	1950-12-18	1950-12-18 00:00:00	1950-12-18	5001	0	\N	0	0	\N	\N	0	350671	0	117015009	4024958		
42870	3960	3006322	2014-02-10	2014-02-10 00:00:00	2014-02-10	5001	0	\N	0	0	\N	\N	0	263255	0	8331-1	3006322		
53753	4932	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	327826	0	6085-5	3001247		
81465	2518	4133840	2010-09-17	2010-09-17 00:00:00	2010-09-17	5001	0	\N	0	0	\N	\N	0	166570	0	127783003	4133840		
55241	5051	3027231	1978-10-04	1978-10-04 00:00:00	1978-10-04	5001	0	\N	0	0	\N	\N	0	335893	0	6276-0	3027231		
38425	3547	3006322	2009-06-28	2009-06-28 00:00:00	2009-06-28	5001	0	\N	0	0	\N	\N	0	235595	0	8331-1	3006322		
49801	4529	40758406	1987-01-10	1987-01-10 00:00:00	1987-01-10	5001	0	\N	0	0	\N	\N	0	301592	0	55277-8	40758406		
550	12	4052083	1974-08-01	1974-08-01 00:00:00	1974-08-01	5001	0	\N	0	0	\N	\N	0	1029	0	23426006	4052083		
39456	1226	4052083	1995-09-18	1995-09-18 00:00:00	1995-09-18	5001	0	\N	0	0	\N	\N	0	80698	0	23426006	4052083		
108111	3339	4024958	1960-10-08	1960-10-08 00:00:00	1960-10-08	5001	0	\N	0	0	\N	\N	0	221501	0	117015009	4024958		
44506	4109	3001247	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	273140	0	6085-5	3001247		
24640	2265	3000876	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	150517	0	6082-2	3000876		
127598	3926	4133840	1984-12-17	1984-12-17 00:00:00	1984-12-17	5001	0	\N	0	0	\N	\N	0	260994	0	127783003	4133840		
52333	4811	3006322	1967-02-06	1967-02-06 00:00:00	1967-02-06	5001	0	\N	0	0	\N	\N	0	320072	0	8331-1	3006322		
12734	1214	40766240	1987-01-15	1987-01-15 00:00:00	1987-01-15	5001	0	\N	0	0	\N	\N	0	79901	0	63513-6	40766240		
47560	4372	3027231	1993-05-13	1993-05-13 00:00:00	1993-05-13	5001	0	\N	0	0	\N	\N	0	290262	0	6276-0	3027231		
40664	3777	3006322	2004-11-10	2004-11-10 00:00:00	2004-11-10	5001	0	\N	0	0	\N	\N	0	251043	0	8331-1	3006322		
40733	3783	3006322	1973-06-01	1973-06-01 00:00:00	1973-06-01	5001	0	\N	0	0	\N	\N	0	251429	0	8331-1	3006322		
29558	915	4052083	1973-08-23	1973-08-23 00:00:00	1973-08-23	5001	0	\N	0	0	\N	\N	0	60861	0	23426006	4052083		
37998	3510	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	232943	0	6082-2	3000876		
117217	3612	4024958	2017-06-02	2017-06-02 00:00:00	2017-06-02	5001	0	\N	0	0	\N	\N	0	239963	0	117015009	4024958		
41035	3811	3006322	1989-01-13	1989-01-13 00:00:00	1989-01-13	5001	0	\N	0	0	\N	\N	0	253121	0	8331-1	3006322		
26337	823	4133840	2010-12-20	2010-12-20 00:00:00	2010-12-20	5001	0	\N	0	0	\N	\N	0	54570	0	127783003	4133840		
147377	4520	4133840	1985-12-07	1985-12-07 00:00:00	1985-12-07	5001	0	\N	0	0	\N	\N	0	300932	0	127783003	4133840		
92083	2837	4052083	2008-10-11	2008-10-11 00:00:00	2008-10-11	5001	0	\N	0	0	\N	\N	0	188420	0	23426006	4052083		
26136	2402	3006734	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	159575	0	6189-5	3006734		
21447	1977	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	131561	0	6248-9	3015076		
32814	2970	3020655	1999-05-06	1999-05-06 00:00:00	1999-05-06	5001	0	\N	0	0	\N	\N	0	198331	0	6844-5	3020655		
32821	2970	3023430	1999-05-06	1999-05-06 00:00:00	1999-05-06	5001	0	\N	0	0	\N	\N	0	198331	0	6833-8	3023430		
15850	1447	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	96420	0	6248-9	3015076		
43891	1352	4133840	2004-04-18	2004-04-18 00:00:00	2004-04-18	5001	0	\N	0	0	\N	\N	0	89578	0	127783003	4133840		
39921	3714	3006322	1929-06-25	1929-06-25 00:00:00	1929-06-25	5001	0	\N	0	0	\N	\N	0	246853	0	8331-1	3006322		
39998	3720	3006322	1966-01-19	1966-01-19 00:00:00	1966-01-19	5001	0	\N	0	0	\N	\N	0	247293	0	8331-1	3006322		
55813	5118	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	340232	0	6844-5	3020655		
36357	3343	3000876	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	221826	0	6082-2	3000876		
74273	2280	4024958	2000-08-08	2000-08-08 00:00:00	2000-08-08	5001	0	\N	0	0	\N	\N	0	151608	0	117015009	4024958		
110980	3430	4133840	2016-05-07	2016-05-07 00:00:00	2016-05-07	5001	0	\N	0	0	\N	\N	0	227373	0	127783003	4133840		
16865	1535	3006322	2015-12-16	2015-12-16 00:00:00	2015-12-16	5001	0	\N	0	0	\N	\N	0	102755	0	8331-1	3006322		
46206	4260	3006322	1959-12-04	1959-12-04 00:00:00	1959-12-04	5001	0	\N	0	0	\N	\N	0	282754	0	8331-1	3006322		
46250	4261	40766240	1926-05-10	1926-05-10 00:00:00	1926-05-10	5001	0	\N	0	0	\N	\N	0	282970	0	63513-6	40766240		
46840	4312	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	286058	0	6246-3	3021226		
172543	5295	4024958	1914-09-05	1914-09-05 00:00:00	1914-09-05	5001	0	\N	0	0	\N	\N	0	352278	0	117015009	4024958		
39862	3703	3027231	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	246285	0	6276-0	3027231		
59724	1821	4024958	1964-07-30	1964-07-30 00:00:00	1964-07-30	5001	0	\N	0	0	\N	\N	0	121769	0	117015009	4024958		
28131	2591	3006322	2002-07-01	2002-07-01 00:00:00	2002-07-01	5001	0	\N	0	0	\N	\N	0	171485	0	8331-1	3006322		
21827	2012	3006322	1977-05-20	1977-05-20 00:00:00	1977-05-20	5001	0	\N	0	0	\N	\N	0	133918	0	8331-1	3006322		
39568	3666	3006322	2013-03-27	2013-03-27 00:00:00	2013-03-27	5001	0	\N	0	0	\N	\N	0	243862	0	8331-1	3006322		
5080	489	3015076	1976-11-03	1976-11-03 00:00:00	1976-11-03	5001	0	\N	0	0	\N	\N	0	32754	0	6248-9	3015076		
30393	2781	40766240	2012-04-19	2012-04-19 00:00:00	2012-04-19	5001	0	\N	0	0	\N	\N	0	184331	0	63513-6	40766240		
44803	4143	3006322	1997-04-05	1997-04-05 00:00:00	1997-04-05	5001	0	\N	0	0	\N	\N	0	275370	0	8331-1	3006322		
33928	3081	46235214	1999-07-09	1999-07-09 00:00:00	1999-07-09	5001	0	\N	0	0	\N	\N	0	205161	0	76690-7	46235214		
56151	5150	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	342409	0	6833-8	3023430		
1947	180	3001247	1993-10-28	1993-10-28 00:00:00	1993-10-28	5001	0	\N	0	0	\N	\N	0	12147	0	6085-5	3001247		
13309	1264	3011505	2006-10-13	2006-10-13 00:00:00	2006-10-13	5001	0	\N	0	0	\N	\N	0	83279	0	19926-5	3011505		
114538	3529	4024958	1957-05-13	1957-05-13 00:00:00	1957-05-13	5001	0	\N	0	0	\N	\N	0	234319	0	117015009	4024958		
48029	4405	3006322	1971-03-13	1971-03-13 00:00:00	1971-03-13	5001	0	\N	0	0	\N	\N	0	292796	0	8331-1	3006322		
160008	4922	4024958	1985-07-16	1985-07-16 00:00:00	1985-07-16	5001	0	\N	0	0	\N	\N	0	326987	0	117015009	4024958		
7964	761	3005136	1995-06-23	1995-06-23 00:00:00	1995-06-23	5001	0	\N	0	0	\N	\N	0	50626	0	6075-6	3005136		
47347	4366	3027231	1994-05-10	1994-05-10 00:00:00	1994-05-10	5001	0	\N	0	0	\N	\N	0	289673	0	6276-0	3027231		
165954	5101	4052083	1994-04-26	1994-04-26 00:00:00	1994-04-26	5001	0	\N	0	0	\N	\N	0	338965	0	23426006	4052083		
63878	1962	4024958	1972-08-05	1972-08-05 00:00:00	1972-08-05	5001	0	\N	0	0	\N	\N	0	130456	0	117015009	4024958		
46440	4276	46235214	1954-02-23	1954-02-23 00:00:00	1954-02-23	5001	0	\N	0	0	\N	\N	0	283736	0	76690-7	46235214		
31354	2865	3006322	2004-01-04	2004-01-04 00:00:00	2004-01-04	5001	0	\N	0	0	\N	\N	0	190578	0	8331-1	3006322		
162833	4998	4024958	1993-02-08	1993-02-08 00:00:00	1993-02-08	5001	0	\N	0	0	\N	\N	0	332406	0	117015009	4024958		
171774	5272	4024958	1966-12-25	1966-12-25 00:00:00	1966-12-25	5001	0	\N	0	0	\N	\N	0	350673	0	117015009	4024958		
42871	3960	3006322	1980-04-23	1980-04-23 00:00:00	1980-04-23	5001	0	\N	0	0	\N	\N	0	263258	0	8331-1	3006322		
53754	4932	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	327826	0	6833-8	3023430		
81466	2518	4133840	2010-12-24	2010-12-24 00:00:00	2010-12-24	5001	0	\N	0	0	\N	\N	0	166552	0	127783003	4133840		
55242	5051	3006451	1978-10-04	1978-10-04 00:00:00	1978-10-04	5001	0	\N	0	0	\N	\N	0	335893	0	6273-7	3006451		
38426	3547	3006322	1982-10-23	1982-10-23 00:00:00	1982-10-23	5001	0	\N	0	0	\N	\N	0	235548	0	8331-1	3006322		
49802	4529	3051031	1987-01-10	1987-01-10 00:00:00	1987-01-10	5001	0	\N	0	0	\N	\N	0	301592	0	46240-8	3051031		
551	12	4024958	1995-10-22	1995-10-22 00:00:00	1995-10-22	5001	0	\N	0	0	\N	\N	0	1017	0	117015009	4024958		
39465	1227	4052083	1949-12-22	1949-12-22 00:00:00	1949-12-22	5001	0	\N	0	0	\N	\N	0	80802	0	23426006	4052083		
108114	3339	4024958	2003-06-27	2003-06-27 00:00:00	2003-06-27	5001	0	\N	0	0	\N	\N	0	221527	0	117015009	4024958		
44507	4109	3001488	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	273140	0	7258-7	3001488		
24641	2265	3019406	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	150517	0	6158-0	3019406		
127599	3926	4133840	2000-11-13	2000-11-13 00:00:00	2000-11-13	5001	0	\N	0	0	\N	\N	0	261001	0	127783003	4133840		
52334	4811	3006322	1967-10-16	1967-10-16 00:00:00	1967-10-16	5001	0	\N	0	0	\N	\N	0	320073	0	8331-1	3006322		
12736	1214	40758406	1987-01-15	1987-01-15 00:00:00	1987-01-15	5001	0	\N	0	0	\N	\N	0	79901	0	55277-8	40758406		
106741	3289	4024958	1993-10-02	1993-10-02 00:00:00	1993-10-02	5001	0	\N	0	0	\N	\N	0	218485	0	117015009	4024958		
40665	3778	3006322	1988-06-03	1988-06-03 00:00:00	1988-06-03	5001	0	\N	0	0	\N	\N	0	251088	0	8331-1	3006322		
40734	3783	3006322	1986-02-07	1986-02-07 00:00:00	1986-02-07	5001	0	\N	0	0	\N	\N	0	251346	0	8331-1	3006322		
29561	915	4052083	1969-08-06	1969-08-06 00:00:00	1969-08-06	5001	0	\N	0	0	\N	\N	0	60860	0	23426006	4052083		
37999	3510	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	232943	0	6189-5	3006734		
117218	3612	4052083	1994-06-21	1994-06-21 00:00:00	1994-06-21	5001	0	\N	0	0	\N	\N	0	239972	0	23426006	4052083		
41036	3811	3049273	2000-08-24	2000-08-24 00:00:00	2000-08-24	5001	0	\N	0	0	\N	\N	0	253235	0	38265-5	3049273		
26339	823	4052083	1964-08-08	1964-08-08 00:00:00	1964-08-08	5001	0	\N	0	0	\N	\N	0	54511	0	23426006	4052083		
147379	4520	4133840	1966-09-24	1966-09-24 00:00:00	1966-09-24	5001	0	\N	0	0	\N	\N	0	300886	0	127783003	4133840		
92086	2837	4024958	1998-03-15	1998-03-15 00:00:00	1998-03-15	5001	0	\N	0	0	\N	\N	0	188439	0	117015009	4024958		
26137	2402	3006451	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	159575	0	6273-7	3006451		
21448	1977	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	131561	0	6106-9	3014599		
32815	2970	3021226	1999-05-06	1999-05-06 00:00:00	1999-05-06	5001	0	\N	0	0	\N	\N	0	198331	0	6246-3	3021226		
32822	2970	3005136	1999-05-06	1999-05-06 00:00:00	1999-05-06	5001	0	\N	0	0	\N	\N	0	198331	0	6075-6	3005136		
15851	1447	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	96420	0	6276-0	3027231		
42564	3930	3011505	1968-12-21	1968-12-21 00:00:00	1968-12-21	5001	0	\N	0	0	\N	\N	0	261303	0	19926-5	3011505		
39922	3714	3006322	1982-02-21	1982-02-21 00:00:00	1982-02-21	5001	0	\N	0	0	\N	\N	0	246759	0	8331-1	3006322		
39999	3720	3006322	2002-09-02	2002-09-02 00:00:00	2002-09-02	5001	0	\N	0	0	\N	\N	0	247286	0	8331-1	3006322		
55814	5118	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	340232	0	6189-5	3006734		
36358	3343	3001488	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	221826	0	7258-7	3001488		
74285	2280	4052083	1995-08-28	1995-08-28 00:00:00	1995-08-28	5001	0	\N	0	0	\N	\N	0	151644	0	23426006	4052083		
8138	262	4024958	1985-01-10	1985-01-10 00:00:00	1985-01-10	5001	0	\N	0	0	\N	\N	0	17363	0	117015009	4024958		
16867	1535	40766240	1979-07-02	1979-07-02 00:00:00	1979-07-02	5001	0	\N	0	0	\N	\N	0	102699	0	63513-6	40766240		
46208	4260	40766240	1977-07-24	1977-07-24 00:00:00	1977-07-24	5001	0	\N	0	0	\N	\N	0	282786	0	63513-6	40766240		
46251	4261	46235214	1926-05-10	1926-05-10 00:00:00	1926-05-10	5001	0	\N	0	0	\N	\N	0	282970	0	76690-7	46235214		
46841	4312	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	286058	0	6158-0	3019406		
10383	1015	40758406	2018-11-29	2018-11-29 00:00:00	2018-11-29	5001	0	\N	0	0	\N	\N	0	66810	0	55277-8	40758406		
39863	3703	3021226	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	246285	0	6246-3	3021226		
59737	1821	4052083	1939-11-22	1939-11-22 00:00:00	1939-11-22	5001	0	\N	0	0	\N	\N	0	121849	0	23426006	4052083		
28132	2591	3006322	1985-07-31	1985-07-31 00:00:00	1985-07-31	5001	0	\N	0	0	\N	\N	0	171484	0	8331-1	3006322		
21828	2012	3006322	1987-08-07	1987-08-07 00:00:00	1987-08-07	5001	0	\N	0	0	\N	\N	0	133920	0	8331-1	3006322		
39569	3666	3006322	1999-03-27	1999-03-27 00:00:00	1999-03-27	5001	0	\N	0	0	\N	\N	0	243876	0	8331-1	3006322		
5081	489	3027231	1976-11-03	1976-11-03 00:00:00	1976-11-03	5001	0	\N	0	0	\N	\N	0	32754	0	6276-0	3027231		
30395	2781	40758406	2012-04-19	2012-04-19 00:00:00	2012-04-19	5001	0	\N	0	0	\N	\N	0	184331	0	55277-8	40758406		
44804	4143	3006322	1971-03-31	1971-03-31 00:00:00	1971-03-31	5001	0	\N	0	0	\N	\N	0	275344	0	8331-1	3006322		
33929	3082	3006322	1977-08-04	1977-08-04 00:00:00	1977-08-04	5001	0	\N	0	0	\N	\N	0	205179	0	8331-1	3006322		
56152	5150	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	342409	0	6844-5	3020655		
1948	180	3023430	1993-10-28	1993-10-28 00:00:00	1993-10-28	5001	0	\N	0	0	\N	\N	0	12147	0	6833-8	3023430		
13310	1264	3011505	1999-01-15	1999-01-15 00:00:00	1999-01-15	5001	0	\N	0	0	\N	\N	0	83288	0	19926-5	3011505		
114556	3529	4024958	1949-01-16	1949-01-16 00:00:00	1949-01-16	5001	0	\N	0	0	\N	\N	0	234433	0	117015009	4024958		
48030	4405	3006322	1976-05-29	1976-05-29 00:00:00	1976-05-29	5001	0	\N	0	0	\N	\N	0	292841	0	8331-1	3006322		
171320	5256	4024958	1980-11-04	1980-11-04 00:00:00	1980-11-04	5001	0	\N	0	0	\N	\N	0	349743	0	117015009	4024958		
7965	761	3006451	1979-09-26	1979-09-26 00:00:00	1979-09-26	5001	0	\N	0	0	\N	\N	0	50589	0	6273-7	3006451		
47348	4366	3036780	1994-05-10	1994-05-10 00:00:00	1994-05-10	5001	0	\N	0	0	\N	\N	0	289673	0	6095-4	3036780		
165956	5101	4052083	1997-12-23	1997-12-23 00:00:00	1997-12-23	5001	0	\N	0	0	\N	\N	0	338952	0	23426006	4052083		
63895	1964	4024958	1961-10-01	1961-10-01 00:00:00	1961-10-01	5001	0	\N	0	0	\N	\N	0	130554	0	117015009	4024958		
46442	4276	3051031	1954-02-23	1954-02-23 00:00:00	1954-02-23	5001	0	\N	0	0	\N	\N	0	283736	0	46240-8	3051031		
31355	2865	3006322	1969-01-25	1969-01-25 00:00:00	1969-01-25	5001	0	\N	0	0	\N	\N	0	190625	0	8331-1	3006322		
162836	4999	4052083	1978-12-25	1978-12-25 00:00:00	1978-12-25	5001	0	\N	0	0	\N	\N	0	332413	0	23426006	4052083		
21372	673	4052083	1973-11-20	1973-11-20 00:00:00	1973-11-20	5001	0	\N	0	0	\N	\N	0	44462	0	23426006	4052083		
42872	3961	3006322	1998-02-23	1998-02-23 00:00:00	1998-02-23	5001	0	\N	0	0	\N	\N	0	263365	0	8331-1	3006322		
53755	4932	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	327826	0	6248-9	3015076		
81691	2528	4052083	2011-03-28	2011-03-28 00:00:00	2011-03-28	5001	0	\N	0	0	\N	\N	0	167121	0	23426006	4052083		
55243	5051	3021226	1978-10-04	1978-10-04 00:00:00	1978-10-04	5001	0	\N	0	0	\N	\N	0	335893	0	6246-3	3021226		
38427	3547	3006322	1977-03-09	1977-03-09 00:00:00	1977-03-09	5001	0	\N	0	0	\N	\N	0	235564	0	8331-1	3006322		
49804	4529	46235214	1987-01-10	1987-01-10 00:00:00	1987-01-10	5001	0	\N	0	0	\N	\N	0	301592	0	76690-7	46235214		
161155	4949	4024958	1975-09-09	1975-09-09 00:00:00	1975-09-09	5001	0	\N	0	0	\N	\N	0	329001	0	117015009	4024958		
59423	1812	4052083	1984-06-12	1984-06-12 00:00:00	1984-06-12	5001	0	\N	0	0	\N	\N	0	121255	0	23426006	4052083		
116018	3573	4052083	1940-04-10	1940-04-10 00:00:00	1940-04-10	5001	0	\N	0	0	\N	\N	0	237575	0	23426006	4052083		
44508	4109	3006322	1990-10-15	1990-10-15 00:00:00	1990-10-15	5001	0	\N	0	0	\N	\N	0	273091	0	8331-1	3006322		
24642	2265	3005136	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	150517	0	6075-6	3005136		
127600	3926	4133840	2008-02-18	2008-02-18 00:00:00	2008-02-18	5001	0	\N	0	0	\N	\N	0	260933	0	127783003	4133840		
52335	4811	3006322	1969-05-23	1969-05-23 00:00:00	1969-05-23	5001	0	\N	0	0	\N	\N	0	320074	0	8331-1	3006322		
12737	1214	3051031	1987-01-15	1987-01-15 00:00:00	1987-01-15	5001	0	\N	0	0	\N	\N	0	79901	0	46240-8	3051031		
106744	3289	4052083	1986-10-13	1986-10-13 00:00:00	1986-10-13	5001	0	\N	0	0	\N	\N	0	218535	0	23426006	4052083		
40666	3778	3006322	1995-08-07	1995-08-07 00:00:00	1995-08-07	5001	0	\N	0	0	\N	\N	0	251057	0	8331-1	3006322		
40735	3783	3006322	2008-07-24	2008-07-24 00:00:00	2008-07-24	5001	0	\N	0	0	\N	\N	0	251389	0	8331-1	3006322		
29568	915	4024958	1997-08-29	1997-08-29 00:00:00	1997-08-29	5001	0	\N	0	0	\N	\N	0	60863	0	117015009	4024958		
38000	3510	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	232943	0	6844-5	3020655		
117224	3613	4024958	2013-07-04	2013-07-04 00:00:00	2013-07-04	5001	0	\N	0	0	\N	\N	0	240047	0	117015009	4024958		
41037	3811	3006322	1944-12-24	1944-12-24 00:00:00	1944-12-24	5001	0	\N	0	0	\N	\N	0	253145	0	8331-1	3006322		
26340	823	4133840	2016-01-18	2016-01-18 00:00:00	2016-01-18	5001	0	\N	0	0	\N	\N	0	54527	0	127783003	4133840		
147380	4520	4133840	1978-10-28	1978-10-28 00:00:00	1978-10-28	5001	0	\N	0	0	\N	\N	0	300958	0	127783003	4133840		
92123	2839	4052083	1977-11-22	1977-11-22 00:00:00	1977-11-22	5001	0	\N	0	0	\N	\N	0	188550	0	23426006	4052083		
26138	2402	3021226	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	159575	0	6246-3	3021226		
21449	1977	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	131561	0	6276-0	3027231		
103577	3181	4024958	1984-07-23	1984-07-23 00:00:00	1984-07-23	5001	0	\N	0	0	\N	\N	0	211663	0	117015009	4024958		
32823	2970	3006734	1999-05-06	1999-05-06 00:00:00	1999-05-06	5001	0	\N	0	0	\N	\N	0	198331	0	6189-5	3006734		
15852	1447	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	96420	0	6082-2	3000876		
42565	3930	46235214	1943-09-21	1943-09-21 00:00:00	1943-09-21	5001	0	\N	0	0	\N	\N	0	261257	0	76690-7	46235214		
39923	3714	3049273	2012-12-19	2012-12-19 00:00:00	2012-12-19	5001	0	\N	0	0	\N	\N	0	246855	0	38265-5	3049273		
40000	3720	3006322	1980-12-01	1980-12-01 00:00:00	1980-12-01	5001	0	\N	0	0	\N	\N	0	247284	0	8331-1	3006322		
55815	5118	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	340232	0	6248-9	3015076		
36359	3343	3023430	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	221826	0	6833-8	3023430		
85564	2649	4052083	2002-11-15	2002-11-15 00:00:00	2002-11-15	5001	0	\N	0	0	\N	\N	0	175258	0	23426006	4052083		
8141	263	4052083	1955-02-16	1955-02-16 00:00:00	1955-02-16	5001	0	\N	0	0	\N	\N	0	17425	0	23426006	4052083		
16868	1535	3051031	1979-07-02	1979-07-02 00:00:00	1979-07-02	5001	0	\N	0	0	\N	\N	0	102699	0	46240-8	3051031		
46210	4260	46235214	1977-07-24	1977-07-24 00:00:00	1977-07-24	5001	0	\N	0	0	\N	\N	0	282786	0	76690-7	46235214		
46252	4261	40758406	1957-11-23	1957-11-23 00:00:00	1957-11-23	5001	0	\N	0	0	\N	\N	0	282858	0	55277-8	40758406		
46842	4312	3006322	1989-11-09	1989-11-09 00:00:00	1989-11-09	5001	0	\N	0	0	\N	\N	0	286216	0	8331-1	3006322		
10385	1015	3051031	2018-11-29	2018-11-29 00:00:00	2018-11-29	5001	0	\N	0	0	\N	\N	0	66810	0	46240-8	3051031		
39864	3703	3020655	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	246285	0	6844-5	3020655		
58309	5343	3012494	1996-01-07	1996-01-07 00:00:00	1996-01-07	5001	0	\N	0	0	\N	\N	0	355877	0	6206-7	3012494		
28133	2591	3006322	1959-05-25	1959-05-25 00:00:00	1959-05-25	5001	0	\N	0	0	\N	\N	0	171489	0	8331-1	3006322		
21829	2012	3006322	2002-08-01	2002-08-01 00:00:00	2002-08-01	5001	0	\N	0	0	\N	\N	0	133899	0	8331-1	3006322		
39570	3667	3006322	1995-03-29	1995-03-29 00:00:00	1995-03-29	5001	0	\N	0	0	\N	\N	0	243937	0	8331-1	3006322		
5082	489	3023430	1976-11-03	1976-11-03 00:00:00	1976-11-03	5001	0	\N	0	0	\N	\N	0	32754	0	6833-8	3023430		
30396	2781	40766240	2012-07-18	2012-07-18 00:00:00	2012-07-18	5001	0	\N	0	0	\N	\N	0	184332	0	63513-6	40766240		
44805	4143	3006322	1978-12-01	1978-12-01 00:00:00	1978-12-01	5001	0	\N	0	0	\N	\N	0	275345	0	8331-1	3006322		
33930	3082	3006322	2006-05-07	2006-05-07 00:00:00	2006-05-07	5001	0	\N	0	0	\N	\N	0	205243	0	8331-1	3006322		
56153	5150	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	342409	0	6075-6	3005136		
1949	180	3020655	1993-10-28	1993-10-28 00:00:00	1993-10-28	5001	0	\N	0	0	\N	\N	0	12147	0	6844-5	3020655		
13311	1264	3011505	1993-04-16	1993-04-16 00:00:00	1993-04-16	5001	0	\N	0	0	\N	\N	0	83301	0	19926-5	3011505		
125839	3879	4052083	1984-10-05	1984-10-05 00:00:00	1984-10-05	5001	0	\N	0	0	\N	\N	0	257744	0	23426006	4052083		
48031	4406	3006322	1967-07-06	1967-07-06 00:00:00	1967-07-06	5001	0	\N	0	0	\N	\N	0	292892	0	8331-1	3006322		
171323	5256	4024958	2018-08-02	2018-08-02 00:00:00	2018-08-02	5001	0	\N	0	0	\N	\N	0	349777	0	117015009	4024958		
7966	761	3015076	1979-09-26	1979-09-26 00:00:00	1979-09-26	5001	0	\N	0	0	\N	\N	0	50589	0	6248-9	3015076		
47349	4366	3000876	1994-05-10	1994-05-10 00:00:00	1994-05-10	5001	0	\N	0	0	\N	\N	0	289673	0	6082-2	3000876		
165965	5101	4052083	1971-04-16	1971-04-16 00:00:00	1971-04-16	5001	0	\N	0	0	\N	\N	0	338992	0	23426006	4052083		
148823	4559	4052083	1950-09-21	1950-09-21 00:00:00	1950-09-21	5001	0	\N	0	0	\N	\N	0	303734	0	23426006	4052083		
46444	4276	40766240	1954-02-23	1954-02-23 00:00:00	1954-02-23	5001	0	\N	0	0	\N	\N	0	283736	0	63513-6	40766240		
31356	2865	3006322	2008-12-03	2008-12-03 00:00:00	2008-12-03	5001	0	\N	0	0	\N	\N	0	190617	0	8331-1	3006322		
162848	4999	4052083	2001-09-19	2001-09-19 00:00:00	2001-09-19	5001	0	\N	0	0	\N	\N	0	332417	0	23426006	4052083		
21374	673	4024958	1987-05-10	1987-05-10 00:00:00	1987-05-10	5001	0	\N	0	0	\N	\N	0	44522	0	117015009	4024958		
42873	3961	3006322	1989-06-28	1989-06-28 00:00:00	1989-06-28	5001	0	\N	0	0	\N	\N	0	263328	0	8331-1	3006322		
53756	4932	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	327826	0	6276-0	3027231		
81716	2530	4024958	1985-06-10	1985-06-10 00:00:00	1985-06-10	5001	0	\N	0	0	\N	\N	0	167215	0	117015009	4024958		
55244	5051	3001488	1978-10-04	1978-10-04 00:00:00	1978-10-04	5001	0	\N	0	0	\N	\N	0	335893	0	7258-7	3001488		
38428	3547	3006322	1997-04-20	1997-04-20 00:00:00	1997-04-20	5001	0	\N	0	0	\N	\N	0	235585	0	8331-1	3006322		
49805	4529	40766240	1987-01-10	1987-01-10 00:00:00	1987-01-10	5001	0	\N	0	0	\N	\N	0	301592	0	63513-6	40766240		
161156	4949	4024958	1980-02-12	1980-02-12 00:00:00	1980-02-12	5001	0	\N	0	0	\N	\N	0	328998	0	117015009	4024958		
70770	2168	4024958	1980-08-19	1980-08-19 00:00:00	1980-08-19	5001	0	\N	0	0	\N	\N	0	144409	0	117015009	4024958		
116021	3573	4024958	1958-10-01	1958-10-01 00:00:00	1958-10-01	5001	0	\N	0	0	\N	\N	0	237520	0	117015009	4024958		
44509	4109	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	273200	0	6082-2	3000876		
24643	2265	3006451	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	150517	0	6273-7	3006451		
127601	3926	4133840	2001-11-19	2001-11-19 00:00:00	2001-11-19	5001	0	\N	0	0	\N	\N	0	260953	0	127783003	4133840		
52336	4812	3006322	2007-09-25	2007-09-25 00:00:00	2007-09-25	5001	0	\N	0	0	\N	\N	0	320139	0	8331-1	3006322		
12738	1214	3006322	1947-02-14	1947-02-14 00:00:00	1947-02-14	5001	0	\N	0	0	\N	\N	0	79994	0	8331-1	3006322		
106751	3289	4052083	2007-04-04	2007-04-04 00:00:00	2007-04-04	5001	0	\N	0	0	\N	\N	0	218486	0	23426006	4052083		
40667	3778	3006322	1997-03-10	1997-03-10 00:00:00	1997-03-10	5001	0	\N	0	0	\N	\N	0	251089	0	8331-1	3006322		
40736	3783	3006322	1953-05-15	1953-05-15 00:00:00	1953-05-15	5001	0	\N	0	0	\N	\N	0	251282	0	8331-1	3006322		
29573	915	4052083	2010-01-27	2010-01-27 00:00:00	2010-01-27	5001	0	\N	0	0	\N	\N	0	60866	0	23426006	4052083		
38001	3510	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	232943	0	6085-5	3001247		
117238	3614	4052083	2008-03-30	2008-03-30 00:00:00	2008-03-30	5001	0	\N	0	0	\N	\N	0	240115	0	23426006	4052083		
41039	3811	3006322	1965-08-30	1965-08-30 00:00:00	1965-08-30	5001	0	\N	0	0	\N	\N	0	253219	0	8331-1	3006322		
26343	823	4133840	2011-12-26	2011-12-26 00:00:00	2011-12-26	5001	0	\N	0	0	\N	\N	0	54600	0	127783003	4133840		
147382	4520	4133840	1977-10-22	1977-10-22 00:00:00	1977-10-22	5001	0	\N	0	0	\N	\N	0	300913	0	127783003	4133840		
80875	2497	4052083	1971-06-20	1971-06-20 00:00:00	1971-06-20	5001	0	\N	0	0	\N	\N	0	165329	0	23426006	4052083		
26139	2402	3019406	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	159575	0	6158-0	3019406		
21450	1977	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	131487	0	6248-9	3015076		
103587	3181	4133840	2010-10-01	2010-10-01 00:00:00	2010-10-01	5001	0	\N	0	0	\N	\N	0	211832	0	127783003	4133840		
32824	2970	3006451	1999-05-06	1999-05-06 00:00:00	1999-05-06	5001	0	\N	0	0	\N	\N	0	198331	0	6273-7	3006451		
15853	1447	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	96420	0	6095-4	3036780		
42567	3930	40766240	1943-09-21	1943-09-21 00:00:00	1943-09-21	5001	0	\N	0	0	\N	\N	0	261257	0	63513-6	40766240		
39924	3714	3006322	1924-05-09	1924-05-09 00:00:00	1924-05-09	5001	0	\N	0	0	\N	\N	0	246851	0	8331-1	3006322		
40001	3720	3006322	1963-02-20	1963-02-20 00:00:00	1963-02-20	5001	0	\N	0	0	\N	\N	0	247292	0	8331-1	3006322		
55816	5118	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	340232	0	6276-0	3027231		
36360	3343	3015076	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	221826	0	6248-9	3015076		
85570	2649	4052083	1964-02-29	1964-02-29 00:00:00	1964-02-29	5001	0	\N	0	0	\N	\N	0	175298	0	23426006	4052083		
8144	263	4052083	1988-09-04	1988-09-04 00:00:00	1988-09-04	5001	0	\N	0	0	\N	\N	0	17442	0	23426006	4052083		
16870	1535	40758406	1979-07-02	1979-07-02 00:00:00	1979-07-02	5001	0	\N	0	0	\N	\N	0	102699	0	55277-8	40758406		
42743	3957	40766240	1965-04-17	1965-04-17 00:00:00	1965-04-17	5001	0	\N	0	0	\N	\N	0	263107	0	63513-6	40766240		
46253	4261	3051031	1957-11-23	1957-11-23 00:00:00	1957-11-23	5001	0	\N	0	0	\N	\N	0	282858	0	46240-8	3051031		
46843	4312	3006322	2009-08-13	2009-08-13 00:00:00	2009-08-13	5001	0	\N	0	0	\N	\N	0	286172	0	8331-1	3006322		
10387	1015	46235214	2018-11-29	2018-11-29 00:00:00	2018-11-29	5001	0	\N	0	0	\N	\N	0	66810	0	76690-7	46235214		
39865	3703	3036780	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	246285	0	6095-4	3036780		
58310	5343	3036780	1996-01-07	1996-01-07 00:00:00	1996-01-07	5001	0	\N	0	0	\N	\N	0	355877	0	6095-4	3036780		
68582	2097	4052083	1988-02-01	1988-02-01 00:00:00	1988-02-01	5001	0	\N	0	0	\N	\N	0	139760	0	23426006	4052083		
21831	2013	40758406	1967-08-07	1967-08-07 00:00:00	1967-08-07	5001	0	\N	0	0	\N	\N	0	133950	0	55277-8	40758406		
39571	3667	3006322	1976-04-11	1976-04-11 00:00:00	1976-04-11	5001	0	\N	0	0	\N	\N	0	243936	0	8331-1	3006322		
5083	489	3036780	1976-11-03	1976-11-03 00:00:00	1976-11-03	5001	0	\N	0	0	\N	\N	0	32754	0	6095-4	3036780		
30397	2781	46235214	2012-07-18	2012-07-18 00:00:00	2012-07-18	5001	0	\N	0	0	\N	\N	0	184332	0	76690-7	46235214		
44806	4143	3006322	2006-09-27	2006-09-27 00:00:00	2006-09-27	5001	0	\N	0	0	\N	\N	0	275393	0	8331-1	3006322		
33931	3082	3006322	1987-02-06	1987-02-06 00:00:00	1987-02-06	5001	0	\N	0	0	\N	\N	0	205236	0	8331-1	3006322		
56154	5150	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	342409	0	6246-3	3021226		
1950	180	3001488	1993-10-28	1993-10-28 00:00:00	1993-10-28	5001	0	\N	0	0	\N	\N	0	12147	0	7258-7	3001488		
13312	1264	3006322	1997-06-20	1997-06-20 00:00:00	1997-06-20	5001	0	\N	0	0	\N	\N	0	83316	0	8331-1	3006322		
11469	362	4052083	1996-12-14	1996-12-14 00:00:00	1996-12-14	5001	0	\N	0	0	\N	\N	0	24018	0	23426006	4052083		
48032	4406	3006322	2008-04-16	2008-04-16 00:00:00	2008-04-16	5001	0	\N	0	0	\N	\N	0	292942	0	8331-1	3006322		
24796	2280	3006322	1976-04-16	1976-04-16 00:00:00	1976-04-16	5001	0	\N	0	0	\N	\N	0	151560	0	8331-1	3006322		
7967	761	3012494	1979-09-26	1979-09-26 00:00:00	1979-09-26	5001	0	\N	0	0	\N	\N	0	50589	0	6206-7	3012494		
47350	4366	3006322	1983-09-25	1983-09-25 00:00:00	1983-09-25	5001	0	\N	0	0	\N	\N	0	289667	0	8331-1	3006322		
100297	3079	4052083	1995-08-30	1995-08-30 00:00:00	1995-08-30	5001	0	\N	0	0	\N	\N	0	204872	0	23426006	4052083		
148826	4559	4052083	1990-03-09	1990-03-09 00:00:00	1990-03-09	5001	0	\N	0	0	\N	\N	0	303754	0	23426006	4052083		
46445	4276	3006322	1977-07-30	1977-07-30 00:00:00	1977-07-30	5001	0	\N	0	0	\N	\N	0	283760	0	8331-1	3006322		
31357	2865	3006322	2007-08-28	2007-08-28 00:00:00	2007-08-28	5001	0	\N	0	0	\N	\N	0	190602	0	8331-1	3006322		
162858	5000	4052083	1953-04-08	1953-04-08 00:00:00	1953-04-08	5001	0	\N	0	0	\N	\N	0	332512	0	23426006	4052083		
21387	673	4024958	1995-02-09	1995-02-09 00:00:00	1995-02-09	5001	0	\N	0	0	\N	\N	0	44466	0	117015009	4024958		
42874	3961	3006322	2000-12-23	2000-12-23 00:00:00	2000-12-23	5001	0	\N	0	0	\N	\N	0	263340	0	8331-1	3006322		
53757	4932	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	327826	0	6106-9	3014599		
81725	2530	4052083	1978-04-06	1978-04-06 00:00:00	1978-04-06	5001	0	\N	0	0	\N	\N	0	167212	0	23426006	4052083		
55245	5051	3036780	1978-10-04	1978-10-04 00:00:00	1978-10-04	5001	0	\N	0	0	\N	\N	0	335893	0	6095-4	3036780		
38432	3549	3006322	1981-11-07	1981-11-07 00:00:00	1981-11-07	5001	0	\N	0	0	\N	\N	0	235678	0	8331-1	3006322		
5827	180	4024958	2015-03-05	2015-03-05 00:00:00	2015-03-05	5001	0	\N	0	0	\N	\N	0	12150	0	117015009	4024958		
161195	4952	4052083	1975-02-07	1975-02-07 00:00:00	1975-02-07	5001	0	\N	0	0	\N	\N	0	329181	0	23426006	4052083		
142812	4387	4024958	1985-05-20	1985-05-20 00:00:00	1985-05-20	5001	0	\N	0	0	\N	\N	0	291608	0	117015009	4024958		
116041	3573	4052083	1926-06-12	1926-06-12 00:00:00	1926-06-12	5001	0	\N	0	0	\N	\N	0	237571	0	23426006	4052083		
44510	4109	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	273200	0	6844-5	3020655		
24644	2265	3023430	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	150517	0	6833-8	3023430		
127610	3927	4024958	1954-05-09	1954-05-09 00:00:00	1954-05-09	5001	0	\N	0	0	\N	\N	0	261051	0	117015009	4024958		
52337	4812	3006322	1963-05-10	1963-05-10 00:00:00	1963-05-10	5001	0	\N	0	0	\N	\N	0	320184	0	8331-1	3006322		
12739	1214	3006322	1967-09-19	1967-09-19 00:00:00	1967-09-19	5001	0	\N	0	0	\N	\N	0	79999	0	8331-1	3006322		
106758	3289	4024958	2005-07-14	2005-07-14 00:00:00	2005-07-14	5001	0	\N	0	0	\N	\N	0	218516	0	117015009	4024958		
40668	3778	3006322	1999-06-11	1999-06-11 00:00:00	1999-06-11	5001	0	\N	0	0	\N	\N	0	251060	0	8331-1	3006322		
40737	3783	3006322	2006-01-22	2006-01-22 00:00:00	2006-01-22	5001	0	\N	0	0	\N	\N	0	251405	0	8331-1	3006322		
29574	915	4024958	2010-06-28	2010-06-28 00:00:00	2010-06-28	5001	0	\N	0	0	\N	\N	0	60828	0	117015009	4024958		
38002	3510	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	232943	0	6276-0	3027231		
117242	3614	4133840	2009-11-22	2009-11-22 00:00:00	2009-11-22	5001	0	\N	0	0	\N	\N	0	240138	0	127783003	4133840		
41040	3811	3006322	1967-08-31	1967-08-31 00:00:00	1967-08-31	5001	0	\N	0	0	\N	\N	0	253168	0	8331-1	3006322		
26345	823	4024958	1950-02-25	1950-02-25 00:00:00	1950-02-25	5001	0	\N	0	0	\N	\N	0	54561	0	117015009	4024958		
90456	2792	4024958	1963-10-16	1963-10-16 00:00:00	1963-10-16	5001	0	\N	0	0	\N	\N	0	185025	0	117015009	4024958		
11187	1082	3006322	1971-01-15	1971-01-15 00:00:00	1971-01-15	5001	0	\N	0	0	\N	\N	0	70929	0	8331-1	3006322		
26140	2402	3036780	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	159575	0	6095-4	3036780		
21451	1977	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	131487	0	6276-0	3027231		
103590	3181	4133840	2006-09-08	2006-09-08 00:00:00	2006-09-08	5001	0	\N	0	0	\N	\N	0	211704	0	127783003	4133840		
32825	2970	3012494	1999-05-06	1999-05-06 00:00:00	1999-05-06	5001	0	\N	0	0	\N	\N	0	198331	0	6206-7	3012494		
15854	1447	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	96420	0	6246-3	3021226		
42568	3930	40758406	1943-09-21	1943-09-21 00:00:00	1943-09-21	5001	0	\N	0	0	\N	\N	0	261257	0	55277-8	40758406		
39925	3714	3006322	2019-06-06	2019-06-06 00:00:00	2019-06-06	5001	0	\N	0	0	\N	\N	0	246768	0	8331-1	3006322		
40002	3720	3006322	1983-06-01	1983-06-01 00:00:00	1983-06-01	5001	0	\N	0	0	\N	\N	0	247245	0	8331-1	3006322		
55817	5118	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	340232	0	6273-7	3006451		
36361	3343	3027231	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	221826	0	6276-0	3027231		
85572	2649	4024958	1993-03-05	1993-03-05 00:00:00	1993-03-05	5001	0	\N	0	0	\N	\N	0	175333	0	117015009	4024958		
8171	263	4024958	1960-10-20	1960-10-20 00:00:00	1960-10-20	5001	0	\N	0	0	\N	\N	0	17443	0	117015009	4024958		
16871	1535	46235214	1979-07-02	1979-07-02 00:00:00	1979-07-02	5001	0	\N	0	0	\N	\N	0	102699	0	76690-7	46235214		
42745	3957	46235214	1965-04-17	1965-04-17 00:00:00	1965-04-17	5001	0	\N	0	0	\N	\N	0	263107	0	76690-7	46235214		
46254	4261	40766240	1957-11-23	1957-11-23 00:00:00	1957-11-23	5001	0	\N	0	0	\N	\N	0	282858	0	63513-6	40766240		
46844	4312	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	286090	0	6082-2	3000876		
10388	1015	40766240	2018-11-29	2018-11-29 00:00:00	2018-11-29	5001	0	\N	0	0	\N	\N	0	66810	0	63513-6	40766240		
39866	3703	3001488	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	246285	0	7258-7	3001488		
58311	5343	3001247	1996-01-07	1996-01-07 00:00:00	1996-01-07	5001	0	\N	0	0	\N	\N	0	355877	0	6085-5	3001247		
68585	2097	4024958	2010-12-28	2010-12-28 00:00:00	2010-12-28	5001	0	\N	0	0	\N	\N	0	139799	0	117015009	4024958		
21833	2013	3051031	1967-08-07	1967-08-07 00:00:00	1967-08-07	5001	0	\N	0	0	\N	\N	0	133950	0	46240-8	3051031		
39572	3667	3006322	1977-09-15	1977-09-15 00:00:00	1977-09-15	5001	0	\N	0	0	\N	\N	0	243945	0	8331-1	3006322		
5084	489	3000876	1976-11-03	1976-11-03 00:00:00	1976-11-03	5001	0	\N	0	0	\N	\N	0	32754	0	6082-2	3000876		
30398	2781	3051031	2012-07-18	2012-07-18 00:00:00	2012-07-18	5001	0	\N	0	0	\N	\N	0	184332	0	46240-8	3051031		
44807	4143	3006322	1965-06-13	1965-06-13 00:00:00	1965-06-13	5001	0	\N	0	0	\N	\N	0	275405	0	8331-1	3006322		
33932	3082	3006322	1982-10-19	1982-10-19 00:00:00	1982-10-19	5001	0	\N	0	0	\N	\N	0	205248	0	8331-1	3006322		
56155	5150	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	342409	0	6273-7	3006451		
1951	180	3006451	1993-10-28	1993-10-28 00:00:00	1993-10-28	5001	0	\N	0	0	\N	\N	0	12147	0	6273-7	3006451		
13313	1264	3011505	2015-05-15	2015-05-15 00:00:00	2015-05-15	5001	0	\N	0	0	\N	\N	0	83293	0	19926-5	3011505		
11470	362	4024958	1991-10-30	1991-10-30 00:00:00	1991-10-30	5001	0	\N	0	0	\N	\N	0	24024	0	117015009	4024958		
48033	4406	3006322	1948-01-08	1948-01-08 00:00:00	1948-01-08	5001	0	\N	0	0	\N	\N	0	292872	0	8331-1	3006322		
24797	2280	3006322	1993-04-04	1993-04-04 00:00:00	1993-04-04	5001	0	\N	0	0	\N	\N	0	151670	0	8331-1	3006322		
7968	761	3036780	1979-09-26	1979-09-26 00:00:00	1979-09-26	5001	0	\N	0	0	\N	\N	0	50589	0	6095-4	3036780		
47351	4366	3020655	1997-11-11	1997-11-11 00:00:00	1997-11-11	5001	0	\N	0	0	\N	\N	0	289729	0	6844-5	3020655		
100308	3079	4024958	1934-06-18	1934-06-18 00:00:00	1934-06-18	5001	0	\N	0	0	\N	\N	0	204937	0	117015009	4024958		
148827	4559	4052083	1981-11-25	1981-11-25 00:00:00	1981-11-25	5001	0	\N	0	0	\N	\N	0	303788	0	23426006	4052083		
46446	4276	40758406	1954-05-24	1954-05-24 00:00:00	1954-05-24	5001	0	\N	0	0	\N	\N	0	283737	0	55277-8	40758406		
31358	2865	3006322	1981-06-29	1981-06-29 00:00:00	1981-06-29	5001	0	\N	0	0	\N	\N	0	190577	0	8331-1	3006322		
162863	5000	4052083	2007-06-12	2007-06-12 00:00:00	2007-06-12	5001	0	\N	0	0	\N	\N	0	332528	0	23426006	4052083		
21426	675	4052083	1985-03-25	1985-03-25 00:00:00	1985-03-25	5001	0	\N	0	0	\N	\N	0	44588	0	23426006	4052083		
42875	3961	3006322	2016-06-17	2016-06-17 00:00:00	2016-06-17	5001	0	\N	0	0	\N	\N	0	263370	0	8331-1	3006322		
53758	4932	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	327826	0	6273-7	3006451		
81726	2530	4024958	1996-09-21	1996-09-21 00:00:00	1996-09-21	5001	0	\N	0	0	\N	\N	0	167247	0	117015009	4024958		
55246	5051	3001247	1978-10-04	1978-10-04 00:00:00	1978-10-04	5001	0	\N	0	0	\N	\N	0	335893	0	6085-5	3001247		
38433	3549	3049273	2012-02-16	2012-02-16 00:00:00	2012-02-16	5001	0	\N	0	0	\N	\N	0	235631	0	38265-5	3049273		
5838	180	4024958	1999-02-28	1999-02-28 00:00:00	1999-02-28	5001	0	\N	0	0	\N	\N	0	12188	0	117015009	4024958		
161203	4952	4052083	1978-05-12	1978-05-12 00:00:00	1978-05-12	5001	0	\N	0	0	\N	\N	0	329153	0	23426006	4052083		
142827	4388	4024958	1966-09-22	1966-09-22 00:00:00	1966-09-22	5001	0	\N	0	0	\N	\N	0	291657	0	117015009	4024958		
116053	3573	4052083	2010-06-13	2010-06-13 00:00:00	2010-06-13	5001	0	\N	0	0	\N	\N	0	237546	0	23426006	4052083		
44511	4109	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	273200	0	6106-9	3014599		
24645	2265	3001247	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	150517	0	6085-5	3001247		
62301	1911	4133840	2005-10-17	2005-10-17 00:00:00	2005-10-17	5001	0	\N	0	0	\N	\N	0	127114	0	127783003	4133840		
52338	4812	3006322	1955-04-13	1955-04-13 00:00:00	1955-04-13	5001	0	\N	0	0	\N	\N	0	320134	0	8331-1	3006322		
12740	1214	40766240	1987-02-14	1987-02-14 00:00:00	1987-02-14	5001	0	\N	0	0	\N	\N	0	80001	0	63513-6	40766240		
106760	3289	4052083	1991-06-05	1991-06-05 00:00:00	1991-06-05	5001	0	\N	0	0	\N	\N	0	218536	0	23426006	4052083		
40669	3779	3006322	1970-07-07	1970-07-07 00:00:00	1970-07-07	5001	0	\N	0	0	\N	\N	0	251110	0	8331-1	3006322		
40738	3783	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	251370	0	6189-5	3006734		
29579	915	4024958	1989-01-02	1989-01-02 00:00:00	1989-01-02	5001	0	\N	0	0	\N	\N	0	60837	0	117015009	4024958		
38003	3510	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	232943	0	6158-0	3019406		
117244	3614	4024958	1992-07-22	1992-07-22 00:00:00	1992-07-22	5001	0	\N	0	0	\N	\N	0	240106	0	117015009	4024958		
41041	3811	3006322	2007-03-06	2007-03-06 00:00:00	2007-03-06	5001	0	\N	0	0	\N	\N	0	253222	0	8331-1	3006322		
26346	823	4133840	2014-01-06	2014-01-06 00:00:00	2014-01-06	5001	0	\N	0	0	\N	\N	0	54526	0	127783003	4133840		
90459	2792	4024958	1959-09-28	1959-09-28 00:00:00	1959-09-28	5001	0	\N	0	0	\N	\N	0	185042	0	117015009	4024958		
11188	1082	3006322	1975-01-04	1975-01-04 00:00:00	1975-01-04	5001	0	\N	0	0	\N	\N	0	70973	0	8331-1	3006322		
26141	2402	3014599	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	159575	0	6106-9	3014599		
21452	1977	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	131487	0	6106-9	3014599		
103596	3181	4133840	2008-09-19	2008-09-19 00:00:00	2008-09-19	5001	0	\N	0	0	\N	\N	0	211705	0	127783003	4133840		
32826	2970	3019406	1999-05-06	1999-05-06 00:00:00	1999-05-06	5001	0	\N	0	0	\N	\N	0	198331	0	6158-0	3019406		
15855	1447	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	96420	0	7258-7	3001488		
42570	3930	3051031	1943-09-21	1943-09-21 00:00:00	1943-09-21	5001	0	\N	0	0	\N	\N	0	261257	0	46240-8	3051031		
39926	3714	3006322	1958-07-14	1958-07-14 00:00:00	1958-07-14	5001	0	\N	0	0	\N	\N	0	246796	0	8331-1	3006322		
40003	3720	3006322	1975-06-16	1975-06-16 00:00:00	1975-06-16	5001	0	\N	0	0	\N	\N	0	247272	0	8331-1	3006322		
55818	5118	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	340232	0	6095-4	3036780		
36362	3343	3014599	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	221826	0	6106-9	3014599		
85612	2651	4052083	1954-02-28	1954-02-28 00:00:00	1954-02-28	5001	0	\N	0	0	\N	\N	0	175426	0	23426006	4052083		
8199	264	4024958	1958-09-13	1958-09-13 00:00:00	1958-09-13	5001	0	\N	0	0	\N	\N	0	17509	0	117015009	4024958		
16872	1535	40758406	1979-06-02	1979-06-02 00:00:00	1979-06-02	5001	0	\N	0	0	\N	\N	0	102715	0	55277-8	40758406		
42746	3957	40758406	1965-04-17	1965-04-17 00:00:00	1965-04-17	5001	0	\N	0	0	\N	\N	0	263107	0	55277-8	40758406		
46257	4261	46235214	1957-11-23	1957-11-23 00:00:00	1957-11-23	5001	0	\N	0	0	\N	\N	0	282858	0	76690-7	46235214		
46845	4312	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	286090	0	6844-5	3020655		
799	19	4024958	2000-05-15	2000-05-15 00:00:00	2000-05-15	5001	0	\N	0	0	\N	\N	0	1453	0	117015009	4024958		
39867	3703	3001247	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	246285	0	6085-5	3001247		
58312	5343	3006322	2017-06-23	2017-06-23 00:00:00	2017-06-23	5001	0	\N	0	0	\N	\N	0	355945	0	8331-1	3006322		
68593	2097	4024958	2011-04-09	2011-04-09 00:00:00	2011-04-09	5001	0	\N	0	0	\N	\N	0	139764	0	117015009	4024958		
21834	2013	46235214	1967-08-07	1967-08-07 00:00:00	1967-08-07	5001	0	\N	0	0	\N	\N	0	133950	0	76690-7	46235214		
39573	3667	3006322	1998-10-22	1998-10-22 00:00:00	1998-10-22	5001	0	\N	0	0	\N	\N	0	243948	0	8331-1	3006322		
5085	489	3001247	1976-11-03	1976-11-03 00:00:00	1976-11-03	5001	0	\N	0	0	\N	\N	0	32754	0	6085-5	3001247		
30400	2781	40758406	2012-07-18	2012-07-18 00:00:00	2012-07-18	5001	0	\N	0	0	\N	\N	0	184332	0	55277-8	40758406		
44809	4145	40769179	2006-07-12	2006-07-12 00:00:00	2006-07-12	5001	0	\N	0	0	\N	\N	0	275513	0	66519-0	40769179		
33933	3083	3006322	1972-06-18	1972-06-18 00:00:00	1972-06-18	5001	0	\N	0	0	\N	\N	0	205325	0	8331-1	3006322		
56156	5150	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	342409	0	6248-9	3015076		
1952	180	3021226	1993-10-28	1993-10-28 00:00:00	1993-10-28	5001	0	\N	0	0	\N	\N	0	12147	0	6246-3	3021226		
13314	1264	3011505	2013-11-22	2013-11-22 00:00:00	2013-11-22	5001	0	\N	0	0	\N	\N	0	83280	0	19926-5	3011505		
11485	362	4052083	1981-08-21	1981-08-21 00:00:00	1981-08-21	5001	0	\N	0	0	\N	\N	0	24017	0	23426006	4052083		
48034	4406	3006322	1960-07-19	1960-07-19 00:00:00	1960-07-19	5001	0	\N	0	0	\N	\N	0	292904	0	8331-1	3006322		
24798	2280	3006322	1969-09-04	1969-09-04 00:00:00	1969-09-04	5001	0	\N	0	0	\N	\N	0	151551	0	8331-1	3006322		
7969	761	3000876	1979-09-26	1979-09-26 00:00:00	1979-09-26	5001	0	\N	0	0	\N	\N	0	50589	0	6082-2	3000876		
47352	4366	3023430	1997-11-11	1997-11-11 00:00:00	1997-11-11	5001	0	\N	0	0	\N	\N	0	289729	0	6833-8	3023430		
100312	3079	4052083	1965-11-28	1965-11-28 00:00:00	1965-11-28	5001	0	\N	0	0	\N	\N	0	204919	0	23426006	4052083		
148849	4560	4024958	1984-06-06	1984-06-06 00:00:00	1984-06-06	5001	0	\N	0	0	\N	\N	0	303831	0	117015009	4024958		
46447	4276	3051031	1954-05-24	1954-05-24 00:00:00	1954-05-24	5001	0	\N	0	0	\N	\N	0	283737	0	46240-8	3051031		
31359	2865	3006322	1993-06-06	1993-06-06 00:00:00	1993-06-06	5001	0	\N	0	0	\N	\N	0	190599	0	8331-1	3006322		
162880	5000	4024958	1977-07-04	1977-07-04 00:00:00	1977-07-04	5001	0	\N	0	0	\N	\N	0	332544	0	117015009	4024958		
21446	675	4024958	2018-11-08	2018-11-08 00:00:00	2018-11-08	5001	0	\N	0	0	\N	\N	0	44611	0	117015009	4024958		
42876	3961	3006322	1977-05-19	1977-05-19 00:00:00	1977-05-19	5001	0	\N	0	0	\N	\N	0	263339	0	8331-1	3006322		
53759	4932	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	327826	0	6206-7	3012494		
81727	2530	4024958	1983-06-08	1983-06-08 00:00:00	1983-06-08	5001	0	\N	0	0	\N	\N	0	167214	0	117015009	4024958		
55247	5051	3006734	1978-10-04	1978-10-04 00:00:00	1978-10-04	5001	0	\N	0	0	\N	\N	0	335893	0	6189-5	3006734		
38434	3549	3006322	1972-01-19	1972-01-19 00:00:00	1972-01-19	5001	0	\N	0	0	\N	\N	0	235666	0	8331-1	3006322		
5862	180	4024958	1985-09-28	1985-09-28 00:00:00	1985-09-28	5001	0	\N	0	0	\N	\N	0	12121	0	117015009	4024958		
49807	4529	3011505	1998-02-08	1998-02-08 00:00:00	1998-02-08	5001	0	\N	0	0	\N	\N	0	301562	0	19926-5	3011505		
142837	4388	4024958	1967-05-02	1967-05-02 00:00:00	1967-05-02	5001	0	\N	0	0	\N	\N	0	291658	0	117015009	4024958		
116055	3573	4024958	1941-07-02	1941-07-02 00:00:00	1941-07-02	5001	0	\N	0	0	\N	\N	0	237517	0	117015009	4024958		
44512	4109	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	273200	0	6246-3	3021226		
24646	2265	3006322	1979-04-05	1979-04-05 00:00:00	1979-04-05	5001	0	\N	0	0	\N	\N	0	150516	0	8331-1	3006322		
62307	1911	4133840	2004-10-11	2004-10-11 00:00:00	2004-10-11	5001	0	\N	0	0	\N	\N	0	127196	0	127783003	4133840		
52339	4812	3006322	1991-02-15	1991-02-15 00:00:00	1991-02-15	5001	0	\N	0	0	\N	\N	0	320136	0	8331-1	3006322		
12741	1214	46235214	1987-02-14	1987-02-14 00:00:00	1987-02-14	5001	0	\N	0	0	\N	\N	0	80001	0	76690-7	46235214		
106771	3290	4024958	1998-06-26	1998-06-26 00:00:00	1998-06-26	5001	0	\N	0	0	\N	\N	0	218611	0	117015009	4024958		
40670	3779	3006322	1978-09-05	1978-09-05 00:00:00	1978-09-05	5001	0	\N	0	0	\N	\N	0	251111	0	8331-1	3006322		
40739	3783	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	251370	0	6833-8	3023430		
29582	915	4024958	2015-08-24	2015-08-24 00:00:00	2015-08-24	5001	0	\N	0	0	\N	\N	0	60829	0	117015009	4024958		
38004	3510	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	232943	0	6075-6	3005136		
14291	449	4133840	2017-09-07	2017-09-07 00:00:00	2017-09-07	5001	0	\N	0	0	\N	\N	0	29994	0	127783003	4133840		
41043	3813	3006322	1973-08-30	1973-08-30 00:00:00	1973-08-30	5001	0	\N	0	0	\N	\N	0	253258	0	8331-1	3006322		
26350	823	4133840	2019-02-04	2019-02-04 00:00:00	2019-02-04	5001	0	\N	0	0	\N	\N	0	54601	0	127783003	4133840		
70534	2160	4024958	1988-12-12	1988-12-12 00:00:00	1988-12-12	5001	0	\N	0	0	\N	\N	0	143978	0	117015009	4024958		
11189	1082	3006322	2004-06-24	2004-06-24 00:00:00	2004-06-24	5001	0	\N	0	0	\N	\N	0	70961	0	8331-1	3006322		
26142	2402	3027231	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	159575	0	6276-0	3027231		
21453	1977	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	131487	0	6158-0	3019406		
103605	3181	4133840	2014-10-24	2014-10-24 00:00:00	2014-10-24	5001	0	\N	0	0	\N	\N	0	211834	0	127783003	4133840		
32827	2970	3027231	1999-05-06	1999-05-06 00:00:00	1999-05-06	5001	0	\N	0	0	\N	\N	0	198331	0	6276-0	3027231		
15856	1447	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	96420	0	6189-5	3006734		
42571	3930	3006322	1941-01-09	1941-01-09 00:00:00	1941-01-09	5001	0	\N	0	0	\N	\N	0	261230	0	8331-1	3006322		
39927	3714	3006322	1997-09-15	1997-09-15 00:00:00	1997-09-15	5001	0	\N	0	0	\N	\N	0	246793	0	8331-1	3006322		
40004	3721	3006322	2000-12-17	2000-12-17 00:00:00	2000-12-17	5001	0	\N	0	0	\N	\N	0	247389	0	8331-1	3006322		
55819	5118	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	340232	0	6833-8	3023430		
36363	3343	3006451	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	221826	0	6273-7	3006451		
31220	2853	3006322	1963-07-26	1963-07-26 00:00:00	1963-07-26	5001	0	\N	0	0	\N	\N	0	189548	0	8331-1	3006322		
8205	264	4024958	1955-12-04	1955-12-04 00:00:00	1955-12-04	5001	0	\N	0	0	\N	\N	0	17551	0	117015009	4024958		
16873	1535	46235214	1979-06-02	1979-06-02 00:00:00	1979-06-02	5001	0	\N	0	0	\N	\N	0	102715	0	76690-7	46235214		
42747	3957	3011505	2017-11-09	2017-11-09 00:00:00	2017-11-09	5001	0	\N	0	0	\N	\N	0	263082	0	19926-5	3011505		
46258	4261	3006322	1932-10-28	1932-10-28 00:00:00	1932-10-28	5001	0	\N	0	0	\N	\N	0	282856	0	8331-1	3006322		
46846	4312	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	286090	0	6206-7	3012494		
820	19	4052083	1997-08-25	1997-08-25 00:00:00	1997-08-25	5001	0	\N	0	0	\N	\N	0	1507	0	23426006	4052083		
39868	3703	3012494	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	246285	0	6206-7	3012494		
58313	5343	3006322	1994-08-30	1994-08-30 00:00:00	1994-08-30	5001	0	\N	0	0	\N	\N	0	355876	0	8331-1	3006322		
68604	2098	4024958	1968-02-06	1968-02-06 00:00:00	1968-02-06	5001	0	\N	0	0	\N	\N	0	139893	0	117015009	4024958		
21835	2013	40766240	1967-08-07	1967-08-07 00:00:00	1967-08-07	5001	0	\N	0	0	\N	\N	0	133950	0	63513-6	40766240		
39574	3667	3006322	1968-07-06	1968-07-06 00:00:00	1968-07-06	5001	0	\N	0	0	\N	\N	0	243934	0	8331-1	3006322		
5086	489	3006734	1976-11-03	1976-11-03 00:00:00	1976-11-03	5001	0	\N	0	0	\N	\N	0	32754	0	6189-5	3006734		
30402	2781	3006322	1987-07-24	1987-07-24 00:00:00	1987-07-24	5001	0	\N	0	0	\N	\N	0	184292	0	8331-1	3006322		
44810	4145	40769184	2006-07-12	2006-07-12 00:00:00	2006-07-12	5001	0	\N	0	0	\N	\N	0	275513	0	66524-0	40769184		
33934	3083	3006322	1952-05-27	1952-05-27 00:00:00	1952-05-27	5001	0	\N	0	0	\N	\N	0	205330	0	8331-1	3006322		
56157	5150	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	342409	0	6106-9	3014599		
1953	180	3012494	1993-10-28	1993-10-28 00:00:00	1993-10-28	5001	0	\N	0	0	\N	\N	0	12147	0	6206-7	3012494		
13315	1264	3011505	2012-11-16	2012-11-16 00:00:00	2012-11-16	5001	0	\N	0	0	\N	\N	0	83292	0	19926-5	3011505		
11504	363	4052083	1977-05-01	1977-05-01 00:00:00	1977-05-01	5001	0	\N	0	0	\N	\N	0	24097	0	23426006	4052083		
48035	4406	3006322	2014-12-23	2014-12-23 00:00:00	2014-12-23	5001	0	\N	0	0	\N	\N	0	292943	0	8331-1	3006322		
24799	2280	3006322	2000-08-08	2000-08-08 00:00:00	2000-08-08	5001	0	\N	0	0	\N	\N	0	151608	0	8331-1	3006322		
7970	761	3006734	1979-09-26	1979-09-26 00:00:00	1979-09-26	5001	0	\N	0	0	\N	\N	0	50589	0	6189-5	3006734		
47353	4366	3014599	1997-11-11	1997-11-11 00:00:00	1997-11-11	5001	0	\N	0	0	\N	\N	0	289729	0	6106-9	3014599		
100313	3079	4052083	1957-05-16	1957-05-16 00:00:00	1957-05-16	5001	0	\N	0	0	\N	\N	0	204869	0	23426006	4052083		
148866	4561	4024958	1959-04-12	1959-04-12 00:00:00	1959-04-12	5001	0	\N	0	0	\N	\N	0	303883	0	117015009	4024958		
46448	4276	46235214	1954-05-24	1954-05-24 00:00:00	1954-05-24	5001	0	\N	0	0	\N	\N	0	283737	0	76690-7	46235214		
31360	2865	3006322	1998-09-20	1998-09-20 00:00:00	1998-09-20	5001	0	\N	0	0	\N	\N	0	190616	0	8331-1	3006322		
162881	5000	4024958	1941-04-13	1941-04-13 00:00:00	1941-04-13	5001	0	\N	0	0	\N	\N	0	332586	0	117015009	4024958		
15402	1409	40758406	1961-07-17	1961-07-17 00:00:00	1961-07-17	5001	0	\N	0	0	\N	\N	0	93762	0	55277-8	40758406		
42877	3962	3006322	1968-04-30	1968-04-30 00:00:00	1968-04-30	5001	0	\N	0	0	\N	\N	0	263477	0	8331-1	3006322		
53760	4932	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	327826	0	6082-2	3000876		
81740	2530	4024958	1979-04-10	1979-04-10 00:00:00	1979-04-10	5001	0	\N	0	0	\N	\N	0	167245	0	117015009	4024958		
55248	5051	3023430	1978-10-04	1978-10-04 00:00:00	1978-10-04	5001	0	\N	0	0	\N	\N	0	335893	0	6833-8	3023430		
38435	3549	3006322	2001-05-18	2001-05-18 00:00:00	2001-05-18	5001	0	\N	0	0	\N	\N	0	235655	0	8331-1	3006322		
74658	2291	4024958	2016-02-21	2016-02-21 00:00:00	2016-02-21	5001	0	\N	0	0	\N	\N	0	152507	0	117015009	4024958		
49808	4529	3011505	2013-11-17	2013-11-17 00:00:00	2013-11-17	5001	0	\N	0	0	\N	\N	0	301557	0	19926-5	3011505		
23769	2186	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	145818	0	6189-5	3006734		
116056	3573	4024958	1989-12-28	1989-12-28 00:00:00	1989-12-28	5001	0	\N	0	0	\N	\N	0	237584	0	117015009	4024958		
44513	4109	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	273200	0	6276-0	3027231		
24647	2266	3006322	1996-05-09	1996-05-09 00:00:00	1996-05-09	5001	0	\N	0	0	\N	\N	0	150642	0	8331-1	3006322		
62309	1911	4133840	2003-10-06	2003-10-06 00:00:00	2003-10-06	5001	0	\N	0	0	\N	\N	0	127113	0	127783003	4133840		
52340	4812	3006322	1999-05-31	1999-05-31 00:00:00	1999-05-31	5001	0	\N	0	0	\N	\N	0	320137	0	8331-1	3006322		
12743	1214	3051031	1987-02-14	1987-02-14 00:00:00	1987-02-14	5001	0	\N	0	0	\N	\N	0	80001	0	46240-8	3051031		
106774	3290	4052083	1970-03-29	1970-03-29 00:00:00	1970-03-29	5001	0	\N	0	0	\N	\N	0	218548	0	23426006	4052083		
40671	3779	3006322	1985-12-08	1985-12-08 00:00:00	1985-12-08	5001	0	\N	0	0	\N	\N	0	251112	0	8331-1	3006322		
40740	3783	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	251370	0	6206-7	3012494		
29584	915	4024958	1960-05-27	1960-05-27 00:00:00	1960-05-27	5001	0	\N	0	0	\N	\N	0	60833	0	117015009	4024958		
38005	3510	3006322	1974-10-30	1974-10-30 00:00:00	1974-10-30	5001	0	\N	0	0	\N	\N	0	232902	0	8331-1	3006322		
14298	449	4133840	2014-08-21	2014-08-21 00:00:00	2014-08-21	5001	0	\N	0	0	\N	\N	0	29983	0	127783003	4133840		
41044	3814	3006322	2012-11-09	2012-11-09 00:00:00	2012-11-09	5001	0	\N	0	0	\N	\N	0	253355	0	8331-1	3006322		
26356	823	4133840	2009-02-09	2009-02-09 00:00:00	2009-02-09	5001	0	\N	0	0	\N	\N	0	54598	0	127783003	4133840		
70538	2160	4024958	1967-10-06	1967-10-06 00:00:00	1967-10-06	5001	0	\N	0	0	\N	\N	0	143961	0	117015009	4024958		
11190	1082	3001488	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	71021	0	7258-7	3001488		
26143	2402	3001488	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	159575	0	7258-7	3001488		
21454	1977	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	131487	0	6085-5	3001247		
103640	3183	4052083	2004-11-30	2004-11-30 00:00:00	2004-11-30	5001	0	\N	0	0	\N	\N	0	211899	0	23426006	4052083		
32828	2970	40769179	1999-04-17	1999-04-17 00:00:00	1999-04-17	5001	0	\N	0	0	\N	\N	0	198321	0	66519-0	40769179		
15857	1447	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	96420	0	6273-7	3006451		
42573	3932	3006322	1978-11-09	1978-11-09 00:00:00	1978-11-09	5001	0	\N	0	0	\N	\N	0	261352	0	8331-1	3006322		
39928	3714	3049273	2007-02-18	2007-02-18 00:00:00	2007-02-18	5001	0	\N	0	0	\N	\N	0	246787	0	38265-5	3049273		
40005	3721	3006322	1990-08-31	1990-08-31 00:00:00	1990-08-31	5001	0	\N	0	0	\N	\N	0	247353	0	8331-1	3006322		
55820	5118	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	340232	0	6106-9	3014599		
36364	3343	3012494	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	221826	0	6206-7	3012494		
31221	2853	3006322	1964-08-29	1964-08-29 00:00:00	1964-08-29	5001	0	\N	0	0	\N	\N	0	189503	0	8331-1	3006322		
8206	264	4052083	2010-11-12	2010-11-12 00:00:00	2010-11-12	5001	0	\N	0	0	\N	\N	0	17567	0	23426006	4052083		
16874	1535	3051031	1979-06-02	1979-06-02 00:00:00	1979-06-02	5001	0	\N	0	0	\N	\N	0	102715	0	46240-8	3051031		
42748	3957	3011505	2018-11-15	2018-11-15 00:00:00	2018-11-15	5001	0	\N	0	0	\N	\N	0	263106	0	19926-5	3011505		
46260	4261	46235214	1957-09-24	1957-09-24 00:00:00	1957-09-24	5001	0	\N	0	0	\N	\N	0	282962	0	76690-7	46235214		
46847	4312	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	286090	0	6273-7	3006451		
128857	3966	4024958	1975-09-08	1975-09-08 00:00:00	1975-09-08	5001	0	\N	0	0	\N	\N	0	263630	0	117015009	4024958		
39869	3703	3000876	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	246285	0	6082-2	3000876		
58314	5343	3006322	2008-08-11	2008-08-11 00:00:00	2008-08-11	5001	0	\N	0	0	\N	\N	0	355935	0	8331-1	3006322		
68605	2098	4024958	1999-11-16	1999-11-16 00:00:00	1999-11-16	5001	0	\N	0	0	\N	\N	0	139897	0	117015009	4024958		
21836	2013	46235214	1957-05-16	1957-05-16 00:00:00	1957-05-16	5001	0	\N	0	0	\N	\N	0	133992	0	76690-7	46235214		
39575	3667	3006322	2014-07-11	2014-07-11 00:00:00	2014-07-11	5001	0	\N	0	0	\N	\N	0	243957	0	8331-1	3006322		
5087	489	3001488	1976-11-03	1976-11-03 00:00:00	1976-11-03	5001	0	\N	0	0	\N	\N	0	32754	0	7258-7	3001488		
30403	2782	3006322	1932-07-28	1932-07-28 00:00:00	1932-07-28	5001	0	\N	0	0	\N	\N	0	184441	0	8331-1	3006322		
44811	4145	40769189	2006-07-12	2006-07-12 00:00:00	2006-07-12	5001	0	\N	0	0	\N	\N	0	275513	0	66529-9	40769189		
33935	3083	3006322	1996-11-13	1996-11-13 00:00:00	1996-11-13	5001	0	\N	0	0	\N	\N	0	205264	0	8331-1	3006322		
56158	5150	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	342409	0	6276-0	3027231		
1954	180	3014599	1993-10-28	1993-10-28 00:00:00	1993-10-28	5001	0	\N	0	0	\N	\N	0	12147	0	6106-9	3014599		
13316	1264	3011505	1988-01-08	1988-01-08 00:00:00	1988-01-08	5001	0	\N	0	0	\N	\N	0	83310	0	19926-5	3011505		
114765	3537	4052083	1998-10-09	1998-10-09 00:00:00	1998-10-09	5001	0	\N	0	0	\N	\N	0	234938	0	23426006	4052083		
48036	4406	3006322	2018-07-14	2018-07-14 00:00:00	2018-07-14	5001	0	\N	0	0	\N	\N	0	292869	0	8331-1	3006322		
24800	2280	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	151567	0	6082-2	3000876		
7971	761	3020655	1979-09-26	1979-09-26 00:00:00	1979-09-26	5001	0	\N	0	0	\N	\N	0	50589	0	6844-5	3020655		
47354	4366	3012494	1997-11-11	1997-11-11 00:00:00	1997-11-11	5001	0	\N	0	0	\N	\N	0	289729	0	6206-7	3012494		
100339	3080	4024958	1951-09-17	1951-09-17 00:00:00	1951-09-17	5001	0	\N	0	0	\N	\N	0	204986	0	117015009	4024958		
148874	4561	4052083	1984-08-06	1984-08-06 00:00:00	1984-08-06	5001	0	\N	0	0	\N	\N	0	303938	0	23426006	4052083		
46451	4276	40766240	1954-05-24	1954-05-24 00:00:00	1954-05-24	5001	0	\N	0	0	\N	\N	0	283737	0	63513-6	40766240		
31361	2866	3006322	1992-05-30	1992-05-30 00:00:00	1992-05-30	5001	0	\N	0	0	\N	\N	0	190687	0	8331-1	3006322		
162888	5000	4052083	1979-01-28	1979-01-28 00:00:00	1979-01-28	5001	0	\N	0	0	\N	\N	0	332540	0	23426006	4052083		
15403	1409	40766240	1961-07-17	1961-07-17 00:00:00	1961-07-17	5001	0	\N	0	0	\N	\N	0	93762	0	63513-6	40766240		
42878	3962	3006322	2003-11-13	2003-11-13 00:00:00	2003-11-13	5001	0	\N	0	0	\N	\N	0	263441	0	8331-1	3006322		
53761	4932	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	327826	0	7258-7	3001488		
171	3	46235214	1993-11-04	1993-11-04 00:00:00	1993-11-04	5001	0	\N	0	0	\N	\N	0	320	0	76690-7	46235214		
55249	5051	3020655	1978-10-04	1978-10-04 00:00:00	1978-10-04	5001	0	\N	0	0	\N	\N	0	335893	0	6844-5	3020655		
38436	3549	3006322	1997-01-13	1997-01-13 00:00:00	1997-01-13	5001	0	\N	0	0	\N	\N	0	235642	0	8331-1	3006322		
140425	4329	4024958	2014-06-18	2014-06-18 00:00:00	2014-06-18	5001	0	\N	0	0	\N	\N	0	287126	0	117015009	4024958		
49809	4529	3011505	2009-12-06	2009-12-06 00:00:00	2009-12-06	5001	0	\N	0	0	\N	\N	0	301564	0	19926-5	3011505		
23770	2186	3006322	1981-11-09	1981-11-09 00:00:00	1981-11-09	5001	0	\N	0	0	\N	\N	0	145756	0	8331-1	3006322		
116083	3576	4024958	1984-02-26	1984-02-26 00:00:00	1984-02-26	5001	0	\N	0	0	\N	\N	0	237747	0	117015009	4024958		
44514	4109	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	273200	0	6158-0	3019406		
24648	2266	3006322	1971-04-04	1971-04-04 00:00:00	1971-04-04	5001	0	\N	0	0	\N	\N	0	150620	0	8331-1	3006322		
62312	1911	4133840	2002-09-30	2002-09-30 00:00:00	2002-09-30	5001	0	\N	0	0	\N	\N	0	127195	0	127783003	4133840		
52341	4812	3006322	1964-02-17	1964-02-17 00:00:00	1964-02-17	5001	0	\N	0	0	\N	\N	0	320135	0	8331-1	3006322		
12745	1214	40758406	1987-02-14	1987-02-14 00:00:00	1987-02-14	5001	0	\N	0	0	\N	\N	0	80001	0	55277-8	40758406		
106785	3290	4024958	2011-07-28	2011-07-28 00:00:00	2011-07-28	5001	0	\N	0	0	\N	\N	0	218598	0	117015009	4024958		
73918	2272	4024958	2013-11-17	2013-11-17 00:00:00	2013-11-17	5001	0	\N	0	0	\N	\N	0	151013	0	117015009	4024958		
40741	3783	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	251370	0	6246-3	3021226		
113061	3489	4052083	2009-09-07	2009-09-07 00:00:00	2009-09-07	5001	0	\N	0	0	\N	\N	0	231462	0	23426006	4052083		
52162	4788	3006322	1989-04-11	1989-04-11 00:00:00	1989-04-11	5001	0	\N	0	0	\N	\N	0	318650	0	8331-1	3006322		
14300	449	4052083	2001-06-27	2001-06-27 00:00:00	2001-06-27	5001	0	\N	0	0	\N	\N	0	29913	0	23426006	4052083		
41045	3814	3006322	1975-06-02	1975-06-02 00:00:00	1975-06-02	5001	0	\N	0	0	\N	\N	0	253354	0	8331-1	3006322		
26358	823	4133840	2015-01-12	2015-01-12 00:00:00	2015-01-12	5001	0	\N	0	0	\N	\N	0	54583	0	127783003	4133840		
70595	2164	4024958	1985-05-17	1985-05-17 00:00:00	1985-05-17	5001	0	\N	0	0	\N	\N	0	144141	0	117015009	4024958		
11191	1082	3023430	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	71021	0	6833-8	3023430		
26144	2402	3015076	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	159575	0	6248-9	3015076		
21455	1977	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	131487	0	7258-7	3001488		
114919	3542	4024958	1964-09-07	1964-09-07 00:00:00	1964-09-07	5001	0	\N	0	0	\N	\N	0	235234	0	117015009	4024958		
32829	2970	40769194	1999-04-17	1999-04-17 00:00:00	1999-04-17	5001	0	\N	0	0	\N	\N	0	198321	0	66534-9	40769194		
15858	1447	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	96420	0	6106-9	3014599		
42574	3932	3006322	2013-11-17	2013-11-17 00:00:00	2013-11-17	5001	0	\N	0	0	\N	\N	0	261362	0	8331-1	3006322		
39929	3714	3006322	1937-08-24	1937-08-24 00:00:00	1937-08-24	5001	0	\N	0	0	\N	\N	0	246791	0	8331-1	3006322		
40006	3721	3006322	1971-09-16	1971-09-16 00:00:00	1971-09-16	5001	0	\N	0	0	\N	\N	0	247351	0	8331-1	3006322		
55821	5118	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	340232	0	6206-7	3012494		
36365	3343	3021226	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	221826	0	6246-3	3021226		
31222	2853	3006322	1965-07-10	1965-07-10 00:00:00	1965-07-10	5001	0	\N	0	0	\N	\N	0	189504	0	8331-1	3006322		
8214	264	4024958	1969-06-18	1969-06-18 00:00:00	1969-06-18	5001	0	\N	0	0	\N	\N	0	17512	0	117015009	4024958		
16876	1535	40766240	1979-06-02	1979-06-02 00:00:00	1979-06-02	5001	0	\N	0	0	\N	\N	0	102715	0	63513-6	40766240		
42749	3957	3011505	2012-10-11	2012-10-11 00:00:00	2012-10-11	5001	0	\N	0	0	\N	\N	0	263059	0	19926-5	3011505		
46261	4261	40766240	1957-09-24	1957-09-24 00:00:00	1957-09-24	5001	0	\N	0	0	\N	\N	0	282962	0	63513-6	40766240		
46848	4312	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	286090	0	6085-5	3001247		
128861	3966	4024958	1976-03-19	1976-03-19 00:00:00	1976-03-19	5001	0	\N	0	0	\N	\N	0	263631	0	117015009	4024958		
39870	3703	3006322	2016-07-22	2016-07-22 00:00:00	2016-07-22	5001	0	\N	0	0	\N	\N	0	246298	0	8331-1	3006322		
58315	5343	3006322	1987-12-09	1987-12-09 00:00:00	1987-12-09	5001	0	\N	0	0	\N	\N	0	355815	0	8331-1	3006322		
68645	2100	4024958	1977-11-23	1977-11-23 00:00:00	1977-11-23	5001	0	\N	0	0	\N	\N	0	139984	0	117015009	4024958		
21838	2013	40766240	1957-05-16	1957-05-16 00:00:00	1957-05-16	5001	0	\N	0	0	\N	\N	0	133992	0	63513-6	40766240		
39576	3668	3006322	1989-09-19	1989-09-19 00:00:00	1989-09-19	5001	0	\N	0	0	\N	\N	0	244034	0	8331-1	3006322		
5088	489	3020655	1976-11-03	1976-11-03 00:00:00	1976-11-03	5001	0	\N	0	0	\N	\N	0	32754	0	6844-5	3020655		
30404	2782	3006322	1935-12-19	1935-12-19 00:00:00	1935-12-19	5001	0	\N	0	0	\N	\N	0	184343	0	8331-1	3006322		
44812	4145	40769194	2006-07-12	2006-07-12 00:00:00	2006-07-12	5001	0	\N	0	0	\N	\N	0	275513	0	66534-9	40769194		
33936	3083	3006322	1977-06-19	1977-06-19 00:00:00	1977-06-19	5001	0	\N	0	0	\N	\N	0	205320	0	8331-1	3006322		
56159	5150	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	342409	0	6082-2	3000876		
1955	180	3027231	1993-10-28	1993-10-28 00:00:00	1993-10-28	5001	0	\N	0	0	\N	\N	0	12147	0	6276-0	3027231		
13317	1264	3011505	2017-05-26	2017-05-26 00:00:00	2017-05-26	5001	0	\N	0	0	\N	\N	0	83294	0	19926-5	3011505		
114767	3537	4024958	1989-10-30	1989-10-30 00:00:00	1989-10-30	5001	0	\N	0	0	\N	\N	0	234970	0	117015009	4024958		
48037	4406	3006322	1989-08-07	1989-08-07 00:00:00	1989-08-07	5001	0	\N	0	0	\N	\N	0	292865	0	8331-1	3006322		
24801	2280	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	151567	0	6095-4	3036780		
7972	761	3001247	1979-09-26	1979-09-26 00:00:00	1979-09-26	5001	0	\N	0	0	\N	\N	0	50589	0	6085-5	3001247		
47355	4366	3006451	1997-11-11	1997-11-11 00:00:00	1997-11-11	5001	0	\N	0	0	\N	\N	0	289729	0	6273-7	3006451		
100345	3080	4052083	1980-11-29	1980-11-29 00:00:00	1980-11-29	5001	0	\N	0	0	\N	\N	0	205059	0	23426006	4052083		
148875	4561	4024958	1954-05-25	1954-05-25 00:00:00	1954-05-25	5001	0	\N	0	0	\N	\N	0	303907	0	117015009	4024958		
46452	4278	3011505	2012-11-02	2012-11-02 00:00:00	2012-11-02	5001	0	\N	0	0	\N	\N	0	283849	0	19926-5	3011505		
31362	2866	3011505	2009-07-05	2009-07-05 00:00:00	2009-07-05	5001	0	\N	0	0	\N	\N	0	190653	0	19926-5	3011505		
115377	3559	4052083	1956-10-20	1956-10-20 00:00:00	1956-10-20	5001	0	\N	0	0	\N	\N	0	236244	0	23426006	4052083		
15405	1409	3006322	1958-12-28	1958-12-28 00:00:00	1958-12-28	5001	0	\N	0	0	\N	\N	0	93711	0	8331-1	3006322		
42879	3962	3006322	1985-02-21	1985-02-21 00:00:00	1985-02-21	5001	0	\N	0	0	\N	\N	0	263439	0	8331-1	3006322		
53762	4932	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	327826	0	6189-5	3006734		
172	3	40766240	1993-11-04	1993-11-04 00:00:00	1993-11-04	5001	0	\N	0	0	\N	\N	0	320	0	63513-6	40766240		
55250	5051	3005136	1978-10-04	1978-10-04 00:00:00	1978-10-04	5001	0	\N	0	0	\N	\N	0	335893	0	6075-6	3005136		
38437	3549	3006322	1982-04-20	1982-04-20 00:00:00	1982-04-20	5001	0	\N	0	0	\N	\N	0	235679	0	8331-1	3006322		
140436	4329	4024958	2013-10-04	2013-10-04 00:00:00	2013-10-04	5001	0	\N	0	0	\N	\N	0	287124	0	117015009	4024958		
49810	4529	3006322	1989-01-25	1989-01-25 00:00:00	1989-01-25	5001	0	\N	0	0	\N	\N	0	301568	0	8331-1	3006322		
23771	2186	3006322	1974-10-02	1974-10-02 00:00:00	1974-10-02	5001	0	\N	0	0	\N	\N	0	145816	0	8331-1	3006322		
116085	3576	4024958	1978-07-13	1978-07-13 00:00:00	1978-07-13	5001	0	\N	0	0	\N	\N	0	237714	0	117015009	4024958		
44515	4109	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	273200	0	6273-7	3006451		
24649	2266	3006322	2009-05-14	2009-05-14 00:00:00	2009-05-14	5001	0	\N	0	0	\N	\N	0	150643	0	8331-1	3006322		
62318	1911	4024958	1986-07-08	1986-07-08 00:00:00	1986-07-08	5001	0	\N	0	0	\N	\N	0	127143	0	117015009	4024958		
52342	4812	3006322	1997-05-27	1997-05-27 00:00:00	1997-05-27	5001	0	\N	0	0	\N	\N	0	320111	0	8331-1	3006322		
12746	1214	3006322	2009-12-31	2009-12-31 00:00:00	2009-12-31	5001	0	\N	0	0	\N	\N	0	79926	0	8331-1	3006322		
25507	2339	3006322	2006-10-06	2006-10-06 00:00:00	2006-10-06	5001	0	\N	0	0	\N	\N	0	155651	0	8331-1	3006322		
147208	4514	4052083	1999-05-19	1999-05-19 00:00:00	1999-05-19	5001	0	\N	0	0	\N	\N	0	300641	0	23426006	4052083		
40742	3783	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	251370	0	6075-6	3005136		
113074	3490	4052083	1969-10-30	1969-10-30 00:00:00	1969-10-30	5001	0	\N	0	0	\N	\N	0	231490	0	23426006	4052083		
52163	4788	3006322	1985-02-18	1985-02-18 00:00:00	1985-02-18	5001	0	\N	0	0	\N	\N	0	318649	0	8331-1	3006322		
14305	449	4133840	1992-12-10	1992-12-10 00:00:00	1992-12-10	5001	0	\N	0	0	\N	\N	0	29867	0	127783003	4133840		
41046	3814	3006322	1987-12-08	1987-12-08 00:00:00	1987-12-08	5001	0	\N	0	0	\N	\N	0	253335	0	8331-1	3006322		
26361	823	4133840	2018-01-29	2018-01-29 00:00:00	2018-01-29	5001	0	\N	0	0	\N	\N	0	54517	0	127783003	4133840		
70599	2164	4024958	2011-03-01	2011-03-01 00:00:00	2011-03-01	5001	0	\N	0	0	\N	\N	0	144142	0	117015009	4024958		
11192	1082	3020655	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	71021	0	6844-5	3020655		
26145	2402	3005136	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	159575	0	6075-6	3005136		
21456	1977	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	131487	0	6833-8	3023430		
103690	3184	4052083	1989-07-27	1989-07-27 00:00:00	1989-07-27	5001	0	\N	0	0	\N	\N	0	211998	0	23426006	4052083		
32830	2970	40769184	1999-04-17	1999-04-17 00:00:00	1999-04-17	5001	0	\N	0	0	\N	\N	0	198321	0	66524-0	40769184		
15859	1447	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	96420	0	6833-8	3023430		
42575	3932	3006322	1981-11-08	1981-11-08 00:00:00	1981-11-08	5001	0	\N	0	0	\N	\N	0	261361	0	8331-1	3006322		
39934	3717	3006322	1977-07-05	1977-07-05 00:00:00	1977-07-05	5001	0	\N	0	0	\N	\N	0	246995	0	8331-1	3006322		
40007	3721	3006322	2015-02-13	2015-02-13 00:00:00	2015-02-13	5001	0	\N	0	0	\N	\N	0	247329	0	8331-1	3006322		
55822	5118	3006322	1967-12-19	1967-12-19 00:00:00	1967-12-19	5001	0	\N	0	0	\N	\N	0	340197	0	8331-1	3006322		
36366	3343	3005136	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	221826	0	6075-6	3005136		
31223	2853	3006322	1994-11-17	1994-11-17 00:00:00	1994-11-17	5001	0	\N	0	0	\N	\N	0	189524	0	8331-1	3006322		
8218	264	4024958	1977-02-28	1977-02-28 00:00:00	1977-02-28	5001	0	\N	0	0	\N	\N	0	17593	0	117015009	4024958		
16878	1535	3051031	1991-05-25	1991-05-25 00:00:00	1991-05-25	5001	0	\N	0	0	\N	\N	0	102751	0	46240-8	3051031		
42750	3957	3011505	2009-09-24	2009-09-24 00:00:00	2009-09-24	5001	0	\N	0	0	\N	\N	0	263069	0	19926-5	3011505		
46263	4261	3051031	1957-09-24	1957-09-24 00:00:00	1957-09-24	5001	0	\N	0	0	\N	\N	0	282962	0	46240-8	3051031		
46849	4312	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	286090	0	6189-5	3006734		
129153	3976	4024958	1964-04-13	1964-04-13 00:00:00	1964-04-13	5001	0	\N	0	0	\N	\N	0	264379	0	117015009	4024958		
39871	3703	3006322	2003-11-08	2003-11-08 00:00:00	2003-11-08	5001	0	\N	0	0	\N	\N	0	246296	0	8331-1	3006322		
58316	5343	3006322	2015-02-19	2015-02-19 00:00:00	2015-02-19	5001	0	\N	0	0	\N	\N	0	355944	0	8331-1	3006322		
57566	1758	4024958	1974-03-24	1974-03-24 00:00:00	1974-03-24	5001	0	\N	0	0	\N	\N	0	117544	0	117015009	4024958		
33116	2988	3006322	1999-05-14	1999-05-14 00:00:00	1999-05-14	5001	0	\N	0	0	\N	\N	0	199443	0	8331-1	3006322		
39577	3668	3006322	1997-10-06	1997-10-06 00:00:00	1997-10-06	5001	0	\N	0	0	\N	\N	0	244011	0	8331-1	3006322		
5089	489	3021226	1976-11-03	1976-11-03 00:00:00	1976-11-03	5001	0	\N	0	0	\N	\N	0	32754	0	6246-3	3021226		
30405	2782	3006322	1956-01-04	1956-01-04 00:00:00	1956-01-04	5001	0	\N	0	0	\N	\N	0	184361	0	8331-1	3006322		
44813	4145	3027231	2006-07-29	2006-07-29 00:00:00	2006-07-29	5001	0	\N	0	0	\N	\N	0	275533	0	6276-0	3027231		
33937	3083	3006322	2011-02-23	2011-02-23 00:00:00	2011-02-23	5001	0	\N	0	0	\N	\N	0	205266	0	8331-1	3006322		
56160	5150	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	342409	0	6158-0	3019406		
1956	180	3005136	1993-10-28	1993-10-28 00:00:00	1993-10-28	5001	0	\N	0	0	\N	\N	0	12147	0	6075-6	3005136		
13318	1264	3011505	1986-05-02	1986-05-02 00:00:00	1986-05-02	5001	0	\N	0	0	\N	\N	0	83300	0	19926-5	3011505		
114775	3537	4052083	1990-12-22	1990-12-22 00:00:00	1990-12-22	5001	0	\N	0	0	\N	\N	0	234897	0	23426006	4052083		
48038	4406	3006322	1942-03-25	1942-03-25 00:00:00	1942-03-25	5001	0	\N	0	0	\N	\N	0	292861	0	8331-1	3006322		
24802	2280	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	151567	0	7258-7	3001488		
7973	761	3001488	1979-09-26	1979-09-26 00:00:00	1979-09-26	5001	0	\N	0	0	\N	\N	0	50589	0	7258-7	3001488		
47356	4366	3001488	1997-11-11	1997-11-11 00:00:00	1997-11-11	5001	0	\N	0	0	\N	\N	0	289729	0	7258-7	3001488		
123690	3817	4052083	2010-07-13	2010-07-13 00:00:00	2010-07-13	5001	0	\N	0	0	\N	\N	0	253523	0	23426006	4052083		
148883	4561	4052083	2015-06-23	2015-06-23 00:00:00	2015-06-23	5001	0	\N	0	0	\N	\N	0	303913	0	23426006	4052083		
46453	4278	3011505	2010-10-22	2010-10-22 00:00:00	2010-10-22	5001	0	\N	0	0	\N	\N	0	283853	0	19926-5	3011505		
31363	2866	3011505	2015-07-19	2015-07-19 00:00:00	2015-07-19	5001	0	\N	0	0	\N	\N	0	190643	0	19926-5	3011505		
115379	3559	4024958	1978-07-31	1978-07-31 00:00:00	1978-07-31	5001	0	\N	0	0	\N	\N	0	236267	0	117015009	4024958		
15406	1409	3006322	1996-12-18	1996-12-18 00:00:00	1996-12-18	5001	0	\N	0	0	\N	\N	0	93715	0	8331-1	3006322		
42880	3962	3006322	1957-12-16	1957-12-16 00:00:00	1957-12-16	5001	0	\N	0	0	\N	\N	0	263468	0	8331-1	3006322		
53763	4932	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	327826	0	6095-4	3036780		
173	3	40758406	1994-02-02	1994-02-02 00:00:00	1994-02-02	5001	0	\N	0	0	\N	\N	0	351	0	55277-8	40758406		
55251	5051	3012494	1978-10-04	1978-10-04 00:00:00	1978-10-04	5001	0	\N	0	0	\N	\N	0	335893	0	6206-7	3012494		
38438	3549	3006322	1999-07-15	1999-07-15 00:00:00	1999-07-15	5001	0	\N	0	0	\N	\N	0	235683	0	8331-1	3006322		
140440	4329	4052083	2018-03-15	2018-03-15 00:00:00	2018-03-15	5001	0	\N	0	0	\N	\N	0	287074	0	23426006	4052083		
49811	4529	3006322	1993-07-14	1993-07-14 00:00:00	1993-07-14	5001	0	\N	0	0	\N	\N	0	301551	0	8331-1	3006322		
23772	2186	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	145810	0	6082-2	3000876		
72392	2217	4052083	2001-01-06	2001-01-06 00:00:00	2001-01-06	5001	0	\N	0	0	\N	\N	0	147629	0	23426006	4052083		
44516	4109	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	273200	0	6075-6	3005136		
24650	2267	3006322	2000-08-30	2000-08-30 00:00:00	2000-08-30	5001	0	\N	0	0	\N	\N	0	150726	0	8331-1	3006322		
62320	1911	4133840	2000-09-18	2000-09-18 00:00:00	2000-09-18	5001	0	\N	0	0	\N	\N	0	127194	0	127783003	4133840		
52343	4812	3006322	1965-01-24	1965-01-24 00:00:00	1965-01-24	5001	0	\N	0	0	\N	\N	0	320107	0	8331-1	3006322		
12747	1214	3006322	1952-09-25	1952-09-25 00:00:00	1952-09-25	5001	0	\N	0	0	\N	\N	0	79995	0	8331-1	3006322		
25508	2339	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	155669	0	6206-7	3012494		
15150	1397	3006322	2002-07-18	2002-07-18 00:00:00	2002-07-18	5001	0	\N	0	0	\N	\N	0	92764	0	8331-1	3006322		
40743	3783	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	251370	0	6085-5	3001247		
113087	3490	4024958	1950-04-22	1950-04-22 00:00:00	1950-04-22	5001	0	\N	0	0	\N	\N	0	231493	0	117015009	4024958		
52164	4788	3006322	1978-09-10	1978-09-10 00:00:00	1978-09-10	5001	0	\N	0	0	\N	\N	0	318675	0	8331-1	3006322		
14307	449	4133840	1995-12-14	1995-12-14 00:00:00	1995-12-14	5001	0	\N	0	0	\N	\N	0	29868	0	127783003	4133840		
41048	3817	3006322	1970-01-26	1970-01-26 00:00:00	1970-01-26	5001	0	\N	0	0	\N	\N	0	253519	0	8331-1	3006322		
141119	4352	4052083	2006-03-27	2006-03-27 00:00:00	2006-03-27	5001	0	\N	0	0	\N	\N	0	288711	0	23426006	4052083		
139610	4304	4052083	1993-10-30	1993-10-30 00:00:00	1993-10-30	5001	0	\N	0	0	\N	\N	0	285486	0	23426006	4052083		
11193	1082	3036780	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	71021	0	6095-4	3036780		
26146	2402	3023430	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	159575	0	6833-8	3023430		
103499	3181	4133840	2013-10-18	2013-10-18 00:00:00	2013-10-18	5001	0	\N	0	0	\N	\N	0	211717	0	127783003	4133840		
158907	4886	4024958	1971-09-06	1971-09-06 00:00:00	1971-09-06	5001	0	\N	0	0	\N	\N	0	324935	0	117015009	4024958		
32831	2970	40769189	1999-04-17	1999-04-17 00:00:00	1999-04-17	5001	0	\N	0	0	\N	\N	0	198321	0	66529-9	40769189		
15860	1447	3006322	1974-01-08	1974-01-08 00:00:00	1974-01-08	5001	0	\N	0	0	\N	\N	0	96459	0	8331-1	3006322		
42576	3932	3006322	1975-09-17	1975-09-17 00:00:00	1975-09-17	5001	0	\N	0	0	\N	\N	0	261401	0	8331-1	3006322		
39935	3717	3006322	2003-11-25	2003-11-25 00:00:00	2003-11-25	5001	0	\N	0	0	\N	\N	0	247049	0	8331-1	3006322		
40008	3721	3006322	1968-03-25	1968-03-25 00:00:00	1968-03-25	5001	0	\N	0	0	\N	\N	0	247355	0	8331-1	3006322		
55823	5119	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	340316	0	6085-5	3001247		
36367	3343	3019406	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	221826	0	6158-0	3019406		
31224	2853	3006322	2014-09-17	2014-09-17 00:00:00	2014-09-17	5001	0	\N	0	0	\N	\N	0	189536	0	8331-1	3006322		
8219	264	4024958	1970-09-22	1970-09-22 00:00:00	1970-09-22	5001	0	\N	0	0	\N	\N	0	17539	0	117015009	4024958		
16880	1535	40758406	1991-05-25	1991-05-25 00:00:00	1991-05-25	5001	0	\N	0	0	\N	\N	0	102751	0	55277-8	40758406		
42751	3957	46235214	1956-10-21	1956-10-21 00:00:00	1956-10-21	5001	0	\N	0	0	\N	\N	0	263093	0	76690-7	46235214		
46264	4261	40758406	1957-09-24	1957-09-24 00:00:00	1957-09-24	5001	0	\N	0	0	\N	\N	0	282962	0	55277-8	40758406		
46850	4312	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	286090	0	6276-0	3027231		
129157	3976	4052083	2018-04-15	2018-04-15 00:00:00	2018-04-15	5001	0	\N	0	0	\N	\N	0	264399	0	23426006	4052083		
39872	3703	3020655	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	246246	0	6844-5	3020655		
58317	5343	3006322	1999-02-21	1999-02-21 00:00:00	1999-02-21	5001	0	\N	0	0	\N	\N	0	355892	0	8331-1	3006322		
57570	1758	4052083	2004-02-01	2004-02-01 00:00:00	2004-02-01	5001	0	\N	0	0	\N	\N	0	117545	0	23426006	4052083		
33117	2988	40766240	1978-05-02	1978-05-02 00:00:00	1978-05-02	5001	0	\N	0	0	\N	\N	0	199490	0	63513-6	40766240		
39578	3668	3006322	1996-04-30	1996-04-30 00:00:00	1996-04-30	5001	0	\N	0	0	\N	\N	0	244010	0	8331-1	3006322		
5090	489	3006451	1976-11-03	1976-11-03 00:00:00	1976-11-03	5001	0	\N	0	0	\N	\N	0	32754	0	6273-7	3006451		
4643	144	4052083	1980-10-21	1980-10-21 00:00:00	1980-10-21	5001	0	\N	0	0	\N	\N	0	9613	0	23426006	4052083		
44814	4145	3014599	2006-07-29	2006-07-29 00:00:00	2006-07-29	5001	0	\N	0	0	\N	\N	0	275533	0	6106-9	3014599		
33938	3083	3006322	1976-09-07	1976-09-07 00:00:00	1976-09-07	5001	0	\N	0	0	\N	\N	0	205333	0	8331-1	3006322		
56161	5150	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	342409	0	6206-7	3012494		
1957	180	3019406	1993-10-28	1993-10-28 00:00:00	1993-10-28	5001	0	\N	0	0	\N	\N	0	12147	0	6158-0	3019406		
13319	1264	3006322	2017-09-30	2017-09-30 00:00:00	2017-09-30	5001	0	\N	0	0	\N	\N	0	83307	0	8331-1	3006322		
114787	3537	4024958	1998-06-25	1998-06-25 00:00:00	1998-06-25	5001	0	\N	0	0	\N	\N	0	234911	0	117015009	4024958		
48039	4406	3006322	1965-06-06	1965-06-06 00:00:00	1965-06-06	5001	0	\N	0	0	\N	\N	0	292894	0	8331-1	3006322		
24803	2280	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	151567	0	6844-5	3020655		
7974	761	3023430	1979-09-26	1979-09-26 00:00:00	1979-09-26	5001	0	\N	0	0	\N	\N	0	50589	0	6833-8	3023430		
47357	4366	3015076	1997-11-11	1997-11-11 00:00:00	1997-11-11	5001	0	\N	0	0	\N	\N	0	289729	0	6248-9	3015076		
123691	3817	4052083	1964-12-21	1964-12-21 00:00:00	1964-12-21	5001	0	\N	0	0	\N	\N	0	253486	0	23426006	4052083		
34525	1081	4024958	1964-09-17	1964-09-17 00:00:00	1964-09-17	5001	0	\N	0	0	\N	\N	0	70831	0	117015009	4024958		
46454	4278	3006322	2000-12-24	2000-12-24 00:00:00	2000-12-24	5001	0	\N	0	0	\N	\N	0	283940	0	8331-1	3006322		
31364	2866	3011505	2017-08-13	2017-08-13 00:00:00	2017-08-13	5001	0	\N	0	0	\N	\N	0	190694	0	19926-5	3011505		
115381	3559	4024958	1955-11-27	1955-11-27 00:00:00	1955-11-27	5001	0	\N	0	0	\N	\N	0	236273	0	117015009	4024958		
15407	1409	3006322	1939-06-29	1939-06-29 00:00:00	1939-06-29	5001	0	\N	0	0	\N	\N	0	93819	0	8331-1	3006322		
42881	3962	3006322	1969-08-03	1969-08-03 00:00:00	1969-08-03	5001	0	\N	0	0	\N	\N	0	263438	0	8331-1	3006322		
53764	4932	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	327826	0	6844-5	3020655		
176	3	46235214	1994-02-02	1994-02-02 00:00:00	1994-02-02	5001	0	\N	0	0	\N	\N	0	351	0	76690-7	46235214		
55252	5051	3014599	1978-10-04	1978-10-04 00:00:00	1978-10-04	5001	0	\N	0	0	\N	\N	0	335893	0	6106-9	3014599		
38439	3550	3006322	1992-07-23	1992-07-23 00:00:00	1992-07-23	5001	0	\N	0	0	\N	\N	0	235727	0	8331-1	3006322		
140443	4329	4024958	1982-11-22	1982-11-22 00:00:00	1982-11-22	5001	0	\N	0	0	\N	\N	0	287117	0	117015009	4024958		
49812	4529	3011505	1988-12-04	1988-12-04 00:00:00	1988-12-04	5001	0	\N	0	0	\N	\N	0	301590	0	19926-5	3011505		
23773	2186	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	145810	0	6273-7	3006451		
72437	2218	4024958	1978-12-22	1978-12-22 00:00:00	1978-12-22	5001	0	\N	0	0	\N	\N	0	147732	0	117015009	4024958		
44517	4109	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	273200	0	6248-9	3015076		
24651	2267	3006322	1988-01-03	1988-01-03 00:00:00	1988-01-03	5001	0	\N	0	0	\N	\N	0	150724	0	8331-1	3006322		
62326	1911	4133840	2001-09-24	2001-09-24 00:00:00	2001-09-24	5001	0	\N	0	0	\N	\N	0	127112	0	127783003	4133840		
52344	4812	3006322	2006-06-17	2006-06-17 00:00:00	2006-06-17	5001	0	\N	0	0	\N	\N	0	320129	0	8331-1	3006322		
12748	1214	3006322	2018-04-05	2018-04-05 00:00:00	2018-04-05	5001	0	\N	0	0	\N	\N	0	79927	0	8331-1	3006322		
25509	2339	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	155669	0	6158-0	3019406		
15151	1397	3006322	1990-04-27	1990-04-27 00:00:00	1990-04-27	5001	0	\N	0	0	\N	\N	0	92842	0	8331-1	3006322		
40744	3783	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	251370	0	6248-9	3015076		
113100	3490	4052083	1961-06-23	1961-06-23 00:00:00	1961-06-23	5001	0	\N	0	0	\N	\N	0	231564	0	23426006	4052083		
52165	4788	3006322	1999-03-31	1999-03-31 00:00:00	1999-03-31	5001	0	\N	0	0	\N	\N	0	318688	0	8331-1	3006322		
14314	449	4133840	2018-09-13	2018-09-13 00:00:00	2018-09-13	5001	0	\N	0	0	\N	\N	0	29985	0	127783003	4133840		
41049	3817	3006322	2014-02-24	2014-02-24 00:00:00	2014-02-24	5001	0	\N	0	0	\N	\N	0	253466	0	8331-1	3006322		
141135	4352	4024958	1973-07-06	1973-07-06 00:00:00	1973-07-06	5001	0	\N	0	0	\N	\N	0	288658	0	117015009	4024958		
139615	4304	4024958	1996-05-24	1996-05-24 00:00:00	1996-05-24	5001	0	\N	0	0	\N	\N	0	285519	0	117015009	4024958		
11194	1082	3012494	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	71021	0	6206-7	3012494		
26147	2402	3001247	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	159575	0	6085-5	3001247		
103506	3181	4133840	2000-09-22	2000-09-22 00:00:00	2000-09-22	5001	0	\N	0	0	\N	\N	0	211714	0	127783003	4133840		
158909	4886	4024958	1980-07-02	1980-07-02 00:00:00	1980-07-02	5001	0	\N	0	0	\N	\N	0	324903	0	117015009	4024958		
32832	2970	3006322	2017-05-23	2017-05-23 00:00:00	2017-05-23	5001	0	\N	0	0	\N	\N	0	198390	0	8331-1	3006322		
15861	1447	3006322	2018-03-31	2018-03-31 00:00:00	2018-03-31	5001	0	\N	0	0	\N	\N	0	96435	0	8331-1	3006322		
42577	3932	3006322	1995-12-08	1995-12-08 00:00:00	1995-12-08	5001	0	\N	0	0	\N	\N	0	261404	0	8331-1	3006322		
39936	3717	3019406	1977-02-15	1977-02-15 00:00:00	1977-02-15	5001	0	\N	0	0	\N	\N	0	247065	0	6158-0	3019406		
40009	3721	3006322	1985-04-15	1985-04-15 00:00:00	1985-04-15	5001	0	\N	0	0	\N	\N	0	247334	0	8331-1	3006322		
55824	5119	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	340316	0	6189-5	3006734		
36368	3343	3001247	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	221826	0	6085-5	3001247		
31225	2853	3006322	2014-11-28	2014-11-28 00:00:00	2014-11-28	5001	0	\N	0	0	\N	\N	0	189525	0	8331-1	3006322		
22834	718	4024958	1971-11-01	1971-11-01 00:00:00	1971-11-01	5001	0	\N	0	0	\N	\N	0	47529	0	117015009	4024958		
16881	1535	40766240	1991-05-25	1991-05-25 00:00:00	1991-05-25	5001	0	\N	0	0	\N	\N	0	102751	0	63513-6	40766240		
42752	3957	3051031	1956-10-21	1956-10-21 00:00:00	1956-10-21	5001	0	\N	0	0	\N	\N	0	263093	0	46240-8	3051031		
46265	4261	3051031	1956-12-28	1956-12-28 00:00:00	1956-12-28	5001	0	\N	0	0	\N	\N	0	282939	0	46240-8	3051031		
46851	4312	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	286090	0	6095-4	3036780		
133878	4121	4133840	1978-09-17	1978-09-17 00:00:00	1978-09-17	5001	0	\N	0	0	\N	\N	0	273938	0	127783003	4133840		
39873	3703	3036780	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	246246	0	6095-4	3036780		
58318	5343	3001488	1984-05-11	1984-05-11 00:00:00	1984-05-11	5001	0	\N	0	0	\N	\N	0	355857	0	7258-7	3001488		
57580	1758	4024958	1975-07-12	1975-07-12 00:00:00	1975-07-12	5001	0	\N	0	0	\N	\N	0	117503	0	117015009	4024958		
33119	2988	40758406	1978-05-02	1978-05-02 00:00:00	1978-05-02	5001	0	\N	0	0	\N	\N	0	199490	0	55277-8	40758406		
39587	3672	3006322	1967-09-26	1967-09-26 00:00:00	1967-09-26	5001	0	\N	0	0	\N	\N	0	244285	0	8331-1	3006322		
5091	489	3014599	1976-11-03	1976-11-03 00:00:00	1976-11-03	5001	0	\N	0	0	\N	\N	0	32754	0	6106-9	3014599		
15943	498	4052083	1988-02-06	1988-02-06 00:00:00	1988-02-06	5001	0	\N	0	0	\N	\N	0	33271	0	23426006	4052083		
44815	4145	3006734	2006-07-29	2006-07-29 00:00:00	2006-07-29	5001	0	\N	0	0	\N	\N	0	275533	0	6189-5	3006734		
33939	3083	3006322	1988-10-14	1988-10-14 00:00:00	1988-10-14	5001	0	\N	0	0	\N	\N	0	205323	0	8331-1	3006322		
56162	5150	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	342409	0	6085-5	3001247		
1958	180	3015076	1993-10-28	1993-10-28 00:00:00	1993-10-28	5001	0	\N	0	0	\N	\N	0	12147	0	6248-9	3015076		
13320	1264	3011505	2001-01-26	2001-01-26 00:00:00	2001-01-26	5001	0	\N	0	0	\N	\N	0	83289	0	19926-5	3011505		
69545	2133	4052083	2009-10-16	2009-10-16 00:00:00	2009-10-16	5001	0	\N	0	0	\N	\N	0	141936	0	23426006	4052083		
48040	4406	3006322	1986-05-11	1986-05-11 00:00:00	1986-05-11	5001	0	\N	0	0	\N	\N	0	292897	0	8331-1	3006322		
24804	2280	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	151567	0	6833-8	3023430		
7975	761	3021226	1979-09-26	1979-09-26 00:00:00	1979-09-26	5001	0	\N	0	0	\N	\N	0	50589	0	6246-3	3021226		
47358	4366	3019406	1997-11-11	1997-11-11 00:00:00	1997-11-11	5001	0	\N	0	0	\N	\N	0	289729	0	6158-0	3019406		
123692	3817	4052083	2012-09-16	2012-09-16 00:00:00	2012-09-16	5001	0	\N	0	0	\N	\N	0	253514	0	23426006	4052083		
34531	1081	4052083	1985-01-19	1985-01-19 00:00:00	1985-01-19	5001	0	\N	0	0	\N	\N	0	70844	0	23426006	4052083		
46455	4278	3006322	1994-06-01	1994-06-01 00:00:00	1994-06-01	5001	0	\N	0	0	\N	\N	0	283883	0	8331-1	3006322		
31365	2866	3011505	2008-08-17	2008-08-17 00:00:00	2008-08-17	5001	0	\N	0	0	\N	\N	0	190678	0	19926-5	3011505		
115383	3559	4052083	1977-05-22	1977-05-22 00:00:00	1977-05-22	5001	0	\N	0	0	\N	\N	0	236278	0	23426006	4052083		
15408	1410	3006322	1969-02-04	1969-02-04 00:00:00	1969-02-04	5001	0	\N	0	0	\N	\N	0	93847	0	8331-1	3006322		
42882	3962	3006322	1992-08-30	1992-08-30 00:00:00	1992-08-30	5001	0	\N	0	0	\N	\N	0	263448	0	8331-1	3006322		
53765	4932	3020655	1976-12-03	1976-12-03 00:00:00	1976-12-03	5001	0	\N	0	0	\N	\N	0	327863	0	6844-5	3020655		
178	3	3051031	1950-01-19	1950-01-19 00:00:00	1950-01-19	5001	0	\N	0	0	\N	\N	0	317	0	46240-8	3051031		
55253	5051	3019406	1978-10-04	1978-10-04 00:00:00	1978-10-04	5001	0	\N	0	0	\N	\N	0	335893	0	6158-0	3019406		
38440	3550	3006322	1988-07-02	1988-07-02 00:00:00	1988-07-02	5001	0	\N	0	0	\N	\N	0	235746	0	8331-1	3006322		
140460	4330	4052083	1964-03-31	1964-03-31 00:00:00	1964-03-31	5001	0	\N	0	0	\N	\N	0	287186	0	23426006	4052083		
49813	4529	3006322	1997-12-29	1997-12-29 00:00:00	1997-12-29	5001	0	\N	0	0	\N	\N	0	301552	0	8331-1	3006322		
23774	2186	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	145810	0	6248-9	3015076		
72448	2220	4052083	1973-10-06	1973-10-06 00:00:00	1973-10-06	5001	0	\N	0	0	\N	\N	0	147853	0	23426006	4052083		
119445	3680	4024958	1999-11-17	1999-11-17 00:00:00	1999-11-17	5001	0	\N	0	0	\N	\N	0	244702	0	117015009	4024958		
24652	2267	3006322	1993-07-19	1993-07-19 00:00:00	1993-07-19	5001	0	\N	0	0	\N	\N	0	150725	0	8331-1	3006322		
62328	1911	4133840	2007-10-29	2007-10-29 00:00:00	2007-10-29	5001	0	\N	0	0	\N	\N	0	127122	0	127783003	4133840		
52345	4812	3006322	1986-07-26	1986-07-26 00:00:00	1986-07-26	5001	0	\N	0	0	\N	\N	0	320110	0	8331-1	3006322		
12749	1214	3006322	1941-03-26	1941-03-26 00:00:00	1941-03-26	5001	0	\N	0	0	\N	\N	0	79974	0	8331-1	3006322		
25510	2339	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	155669	0	6075-6	3005136		
15152	1397	3001488	1977-11-27	1977-11-27 00:00:00	1977-11-27	5001	0	\N	0	0	\N	\N	0	92780	0	7258-7	3001488		
40745	3783	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	251370	0	6276-0	3027231		
113103	3490	4052083	1980-09-24	1980-09-24 00:00:00	1980-09-24	5001	0	\N	0	0	\N	\N	0	231625	0	23426006	4052083		
52170	4791	3006322	1994-07-18	1994-07-18 00:00:00	1994-07-18	5001	0	\N	0	0	\N	\N	0	318766	0	8331-1	3006322		
14315	449	4133840	2011-08-04	2011-08-04 00:00:00	2011-08-04	5001	0	\N	0	0	\N	\N	0	29871	0	127783003	4133840		
173123	5316	4024958	1966-01-25	1966-01-25 00:00:00	1966-01-25	5001	0	\N	0	0	\N	\N	0	353576	0	117015009	4024958		
49611	1510	4024958	1977-09-24	1977-09-24 00:00:00	1977-09-24	5001	0	\N	0	0	\N	\N	0	100780	0	117015009	4024958		
139618	4304	4052083	1988-05-03	1988-05-03 00:00:00	1988-05-03	5001	0	\N	0	0	\N	\N	0	285458	0	23426006	4052083		
11195	1082	3005136	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	71021	0	6075-6	3005136		
26148	2402	3020655	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	159575	0	6844-5	3020655		
103510	3181	4133840	2005-09-02	2005-09-02 00:00:00	2005-09-02	5001	0	\N	0	0	\N	\N	0	211708	0	127783003	4133840		
158928	4886	4052083	1996-10-13	1996-10-13 00:00:00	1996-10-13	5001	0	\N	0	0	\N	\N	0	324879	0	23426006	4052083		
114945	3542	4024958	1938-01-02	1938-01-02 00:00:00	1938-01-02	5001	0	\N	0	0	\N	\N	0	235232	0	117015009	4024958		
15862	1448	3006322	1996-11-07	1996-11-07 00:00:00	1996-11-07	5001	0	\N	0	0	\N	\N	0	96588	0	8331-1	3006322		
42578	3934	3006322	1998-09-06	1998-09-06 00:00:00	1998-09-06	5001	0	\N	0	0	\N	\N	0	261481	0	8331-1	3006322		
39937	3717	3021226	1977-02-15	1977-02-15 00:00:00	1977-02-15	5001	0	\N	0	0	\N	\N	0	247065	0	6246-3	3021226		
40018	3725	3006322	1970-06-27	1970-06-27 00:00:00	1970-06-27	5001	0	\N	0	0	\N	\N	0	247587	0	8331-1	3006322		
55825	5119	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	340316	0	6833-8	3023430		
36369	3343	3006734	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	221826	0	6189-5	3006734		
31226	2853	3006322	1974-01-09	1974-01-09 00:00:00	1974-01-09	5001	0	\N	0	0	\N	\N	0	189546	0	8331-1	3006322		
22843	718	4052083	1983-10-26	1983-10-26 00:00:00	1983-10-26	5001	0	\N	0	0	\N	\N	0	47440	0	23426006	4052083		
16883	1535	46235214	1991-05-25	1991-05-25 00:00:00	1991-05-25	5001	0	\N	0	0	\N	\N	0	102751	0	76690-7	46235214		
42754	3957	40766240	1956-10-21	1956-10-21 00:00:00	1956-10-21	5001	0	\N	0	0	\N	\N	0	263093	0	63513-6	40766240		
46266	4261	40766240	1956-12-28	1956-12-28 00:00:00	1956-12-28	5001	0	\N	0	0	\N	\N	0	282939	0	63513-6	40766240		
46852	4312	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	286090	0	6106-9	3014599		
133881	4121	4133840	1972-08-13	1972-08-13 00:00:00	1972-08-13	5001	0	\N	0	0	\N	\N	0	274006	0	127783003	4133840		
39874	3703	3023430	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	246246	0	6833-8	3023430		
58319	5343	3006734	1984-05-11	1984-05-11 00:00:00	1984-05-11	5001	0	\N	0	0	\N	\N	0	355857	0	6189-5	3006734		
57589	1759	4052083	1993-12-16	1993-12-16 00:00:00	1993-12-16	5001	0	\N	0	0	\N	\N	0	117605	0	23426006	4052083		
33120	2988	3051031	1978-05-02	1978-05-02 00:00:00	1978-05-02	5001	0	\N	0	0	\N	\N	0	199490	0	46240-8	3051031		
39588	3672	3006322	1975-08-27	1975-08-27 00:00:00	1975-08-27	5001	0	\N	0	0	\N	\N	0	244287	0	8331-1	3006322		
5096	492	3006322	2016-06-10	2016-06-10 00:00:00	2016-06-10	5001	0	\N	0	0	\N	\N	0	32986	0	8331-1	3006322		
15944	498	4024958	1972-06-14	1972-06-14 00:00:00	1972-06-14	5001	0	\N	0	0	\N	\N	0	33245	0	117015009	4024958		
44816	4145	3001488	2006-07-29	2006-07-29 00:00:00	2006-07-29	5001	0	\N	0	0	\N	\N	0	275533	0	7258-7	3001488		
33940	3083	3049273	2013-02-19	2013-02-19 00:00:00	2013-02-19	5001	0	\N	0	0	\N	\N	0	205353	0	38265-5	3049273		
56163	5150	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	342409	0	6095-4	3036780		
1959	180	3000876	1993-10-28	1993-10-28 00:00:00	1993-10-28	5001	0	\N	0	0	\N	\N	0	12147	0	6082-2	3000876		
13321	1264	3006322	1987-08-16	1987-08-16 00:00:00	1987-08-16	5001	0	\N	0	0	\N	\N	0	83329	0	8331-1	3006322		
69548	2134	4052083	2014-09-19	2014-09-19 00:00:00	2014-09-19	5001	0	\N	0	0	\N	\N	0	142028	0	23426006	4052083		
48041	4406	3006322	1998-08-29	1998-08-29 00:00:00	1998-08-29	5001	0	\N	0	0	\N	\N	0	292866	0	8331-1	3006322		
24805	2280	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	151567	0	6158-0	3019406		
7976	761	3027231	1979-09-26	1979-09-26 00:00:00	1979-09-26	5001	0	\N	0	0	\N	\N	0	50589	0	6276-0	3027231		
47359	4366	3021226	1997-11-11	1997-11-11 00:00:00	1997-11-11	5001	0	\N	0	0	\N	\N	0	289729	0	6246-3	3021226		
123700	3817	4052083	1968-08-18	1968-08-18 00:00:00	1968-08-18	5001	0	\N	0	0	\N	\N	0	253487	0	23426006	4052083		
34534	1081	4024958	2018-04-25	2018-04-25 00:00:00	2018-04-25	5001	0	\N	0	0	\N	\N	0	70847	0	117015009	4024958		
46456	4278	3011505	1992-01-10	1992-01-10 00:00:00	1992-01-10	5001	0	\N	0	0	\N	\N	0	283926	0	19926-5	3011505		
31366	2866	3011505	2011-07-10	2011-07-10 00:00:00	2011-07-10	5001	0	\N	0	0	\N	\N	0	190679	0	19926-5	3011505		
115391	3560	4024958	1994-05-22	1994-05-22 00:00:00	1994-05-22	5001	0	\N	0	0	\N	\N	0	236370	0	117015009	4024958		
15409	1410	3006322	1973-02-24	1973-02-24 00:00:00	1973-02-24	5001	0	\N	0	0	\N	\N	0	93848	0	8331-1	3006322		
157155	4828	4024958	1977-10-01	1977-10-01 00:00:00	1977-10-01	5001	0	\N	0	0	\N	\N	0	321246	0	117015009	4024958		
53766	4932	3006734	1976-12-03	1976-12-03 00:00:00	1976-12-03	5001	0	\N	0	0	\N	\N	0	327863	0	6189-5	3006734		
179	3	40758406	1950-01-19	1950-01-19 00:00:00	1950-01-19	5001	0	\N	0	0	\N	\N	0	317	0	55277-8	40758406		
55254	5051	3015076	1978-10-04	1978-10-04 00:00:00	1978-10-04	5001	0	\N	0	0	\N	\N	0	335893	0	6248-9	3015076		
38441	3550	3006322	2019-05-20	2019-05-20 00:00:00	2019-05-20	5001	0	\N	0	0	\N	\N	0	235729	0	8331-1	3006322		
140470	4330	4024958	1951-07-27	1951-07-27 00:00:00	1951-07-27	5001	0	\N	0	0	\N	\N	0	287181	0	117015009	4024958		
49814	4529	3011505	2017-12-10	2017-12-10 00:00:00	2017-12-10	5001	0	\N	0	0	\N	\N	0	301565	0	19926-5	3011505		
23775	2186	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	145810	0	6206-7	3012494		
72450	2220	4024958	1976-09-03	1976-09-03 00:00:00	1976-09-03	5001	0	\N	0	0	\N	\N	0	147862	0	117015009	4024958		
45853	4226	3006734	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	280641	0	6189-5	3006734		
24653	2267	3006322	1997-03-10	1997-03-10 00:00:00	1997-03-10	5001	0	\N	0	0	\N	\N	0	150709	0	8331-1	3006322		
62334	1911	4024958	1953-02-05	1953-02-05 00:00:00	1953-02-05	5001	0	\N	0	0	\N	\N	0	127142	0	117015009	4024958		
52346	4812	3006322	2002-05-25	2002-05-25 00:00:00	2002-05-25	5001	0	\N	0	0	\N	\N	0	320128	0	8331-1	3006322		
12750	1214	3006322	2008-01-30	2008-01-30 00:00:00	2008-01-30	5001	0	\N	0	0	\N	\N	0	79908	0	8331-1	3006322		
25511	2339	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	155669	0	6248-9	3015076		
15153	1397	3001247	1977-11-27	1977-11-27 00:00:00	1977-11-27	5001	0	\N	0	0	\N	\N	0	92780	0	6085-5	3001247		
40746	3783	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	251370	0	6106-9	3014599		
113111	3490	4052083	1978-05-02	1978-05-02 00:00:00	1978-05-02	5001	0	\N	0	0	\N	\N	0	231610	0	23426006	4052083		
52171	4791	3006322	2015-02-12	2015-02-12 00:00:00	2015-02-12	5001	0	\N	0	0	\N	\N	0	318815	0	8331-1	3006322		
14319	449	4133840	2012-08-09	2012-08-09 00:00:00	2012-08-09	5001	0	\N	0	0	\N	\N	0	29891	0	127783003	4133840		
173142	5317	4052083	1976-03-08	1976-03-08 00:00:00	1976-03-08	5001	0	\N	0	0	\N	\N	0	353656	0	23426006	4052083		
49612	1510	4052083	1992-11-14	1992-11-14 00:00:00	1992-11-14	5001	0	\N	0	0	\N	\N	0	100856	0	23426006	4052083		
150913	4626	4024958	1990-09-18	1990-09-18 00:00:00	1990-09-18	5001	0	\N	0	0	\N	\N	0	308233	0	117015009	4024958		
11196	1082	3014599	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	71021	0	6106-9	3014599		
26149	2402	3000876	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	159575	0	6082-2	3000876		
103514	3181	4133840	2017-11-10	2017-11-10 00:00:00	2017-11-10	5001	0	\N	0	0	\N	\N	0	211706	0	127783003	4133840		
158936	4886	4024958	1975-01-14	1975-01-14 00:00:00	1975-01-14	5001	0	\N	0	0	\N	\N	0	324888	0	117015009	4024958		
114975	3543	4024958	1981-12-28	1981-12-28 00:00:00	1981-12-28	5001	0	\N	0	0	\N	\N	0	235348	0	117015009	4024958		
15863	1448	3006322	2008-10-19	2008-10-19 00:00:00	2008-10-19	5001	0	\N	0	0	\N	\N	0	96632	0	8331-1	3006322		
42579	3934	3006322	1976-11-15	1976-11-15 00:00:00	1976-11-15	5001	0	\N	0	0	\N	\N	0	261490	0	8331-1	3006322		
39938	3717	3012494	1977-02-15	1977-02-15 00:00:00	1977-02-15	5001	0	\N	0	0	\N	\N	0	247065	0	6206-7	3012494		
40019	3725	3006322	2006-10-24	2006-10-24 00:00:00	2006-10-24	5001	0	\N	0	0	\N	\N	0	247566	0	8331-1	3006322		
55826	5119	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	340316	0	6844-5	3020655		
36370	3343	3036780	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	221826	0	6095-4	3036780		
31227	2853	3006322	2010-10-21	2010-10-21 00:00:00	2010-10-21	5001	0	\N	0	0	\N	\N	0	189535	0	8331-1	3006322		
11793	372	4024958	1966-08-18	1966-08-18 00:00:00	1966-08-18	5001	0	\N	0	0	\N	\N	0	24753	0	117015009	4024958		
16884	1535	3006322	1995-12-16	1995-12-16 00:00:00	1995-12-16	5001	0	\N	0	0	\N	\N	0	102760	0	8331-1	3006322		
42756	3957	40758406	1956-10-21	1956-10-21 00:00:00	1956-10-21	5001	0	\N	0	0	\N	\N	0	263093	0	55277-8	40758406		
46268	4261	46235214	1956-12-28	1956-12-28 00:00:00	1956-12-28	5001	0	\N	0	0	\N	\N	0	282939	0	76690-7	46235214		
46853	4312	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	286090	0	6075-6	3005136		
133883	4121	4133840	1971-04-25	1971-04-25 00:00:00	1971-04-25	5001	0	\N	0	0	\N	\N	0	274005	0	127783003	4133840		
39875	3703	3006734	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	246246	0	6189-5	3006734		
58320	5343	3023430	1984-05-11	1984-05-11 00:00:00	1984-05-11	5001	0	\N	0	0	\N	\N	0	355857	0	6833-8	3023430		
57592	1759	4052083	2012-09-15	2012-09-15 00:00:00	2012-09-15	5001	0	\N	0	0	\N	\N	0	117625	0	23426006	4052083		
33122	2988	46235214	1978-05-02	1978-05-02 00:00:00	1978-05-02	5001	0	\N	0	0	\N	\N	0	199490	0	76690-7	46235214		
39589	3672	3006322	2008-01-17	2008-01-17 00:00:00	2008-01-17	5001	0	\N	0	0	\N	\N	0	244308	0	8331-1	3006322		
5097	492	3009542	1979-12-05	1979-12-05 00:00:00	1979-12-05	5001	0	\N	0	0	\N	\N	0	32984	0	20570-8	3009542		
15969	499	4052083	1989-08-29	1989-08-29 00:00:00	1989-08-29	5001	0	\N	0	0	\N	\N	0	33320	0	23426006	4052083		
44817	4145	3001247	2006-07-29	2006-07-29 00:00:00	2006-07-29	5001	0	\N	0	0	\N	\N	0	275533	0	6085-5	3001247		
33941	3083	3006322	1962-01-19	1962-01-19 00:00:00	1962-01-19	5001	0	\N	0	0	\N	\N	0	205318	0	8331-1	3006322		
56164	5151	3006322	1980-04-05	1980-04-05 00:00:00	1980-04-05	5001	0	\N	0	0	\N	\N	0	342578	0	8331-1	3006322		
1960	180	3006734	1993-10-28	1993-10-28 00:00:00	1993-10-28	5001	0	\N	0	0	\N	\N	0	12147	0	6189-5	3006734		
13322	1264	3006322	1953-08-28	1953-08-28 00:00:00	1953-08-28	5001	0	\N	0	0	\N	\N	0	83336	0	8331-1	3006322		
69564	2134	4052083	1997-02-08	1997-02-08 00:00:00	1997-02-08	5001	0	\N	0	0	\N	\N	0	142003	0	23426006	4052083		
48055	4408	3006322	2015-09-07	2015-09-07 00:00:00	2015-09-07	5001	0	\N	0	0	\N	\N	0	293029	0	8331-1	3006322		
24806	2280	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	151567	0	6246-3	3021226		
7977	761	3019406	1979-09-26	1979-09-26 00:00:00	1979-09-26	5001	0	\N	0	0	\N	\N	0	50589	0	6158-0	3019406		
47360	4366	3005136	1997-11-11	1997-11-11 00:00:00	1997-11-11	5001	0	\N	0	0	\N	\N	0	289729	0	6075-6	3005136		
6072	186	4024958	1998-06-18	1998-06-18 00:00:00	1998-06-18	5001	0	\N	0	0	\N	\N	0	12597	0	117015009	4024958		
34539	1081	4052083	1963-03-10	1963-03-10 00:00:00	1963-03-10	5001	0	\N	0	0	\N	\N	0	70860	0	23426006	4052083		
46457	4278	3011505	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	283884	0	19926-5	3011505		
31367	2866	3011505	1998-04-26	1998-04-26 00:00:00	1998-04-26	5001	0	\N	0	0	\N	\N	0	190675	0	19926-5	3011505		
115392	3560	4052083	1976-07-11	1976-07-11 00:00:00	1976-07-11	5001	0	\N	0	0	\N	\N	0	236356	0	23426006	4052083		
15410	1410	3006322	1976-01-21	1976-01-21 00:00:00	1976-01-21	5001	0	\N	0	0	\N	\N	0	93902	0	8331-1	3006322		
168443	5170	4024958	1979-06-05	1979-06-05 00:00:00	1979-06-05	5001	0	\N	0	0	\N	\N	0	343764	0	117015009	4024958		
53767	4932	3036780	1976-12-03	1976-12-03 00:00:00	1976-12-03	5001	0	\N	0	0	\N	\N	0	327863	0	6095-4	3036780		
11457	1097	3006322	1986-06-23	1986-06-23 00:00:00	1986-06-23	5001	0	\N	0	0	\N	\N	0	72006	0	8331-1	3006322		
55255	5051	3000876	1978-10-04	1978-10-04 00:00:00	1978-10-04	5001	0	\N	0	0	\N	\N	0	335893	0	6082-2	3000876		
38442	3550	3006322	2018-05-14	2018-05-14 00:00:00	2018-05-14	5001	0	\N	0	0	\N	\N	0	235740	0	8331-1	3006322		
140475	4330	4052083	2000-01-04	2000-01-04 00:00:00	2000-01-04	5001	0	\N	0	0	\N	\N	0	287213	0	23426006	4052083		
49815	4530	3006322	1976-06-07	1976-06-07 00:00:00	1976-06-07	5001	0	\N	0	0	\N	\N	0	301631	0	8331-1	3006322		
23776	2186	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	145810	0	6085-5	3001247		
72465	2220	4024958	1983-03-18	1983-03-18 00:00:00	1983-03-18	5001	0	\N	0	0	\N	\N	0	147864	0	117015009	4024958		
45854	4226	3001488	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	280641	0	7258-7	3001488		
24654	2267	3006322	2012-12-09	2012-12-09 00:00:00	2012-12-09	5001	0	\N	0	0	\N	\N	0	150685	0	8331-1	3006322		
62335	1911	4133840	1998-09-07	1998-09-07 00:00:00	1998-09-07	5001	0	\N	0	0	\N	\N	0	127121	0	127783003	4133840		
52347	4812	3006322	1974-02-16	1974-02-16 00:00:00	1974-02-16	5001	0	\N	0	0	\N	\N	0	320093	0	8331-1	3006322		
12751	1215	3006322	1987-04-22	1987-04-22 00:00:00	1987-04-22	5001	0	\N	0	0	\N	\N	0	80009	0	8331-1	3006322		
25512	2339	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	155669	0	6276-0	3027231		
15154	1397	3023430	1977-11-27	1977-11-27 00:00:00	1977-11-27	5001	0	\N	0	0	\N	\N	0	92780	0	6833-8	3023430		
40747	3783	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	251370	0	6158-0	3019406		
124410	3843	4024958	1995-05-24	1995-05-24 00:00:00	1995-05-24	5001	0	\N	0	0	\N	\N	0	255063	0	117015009	4024958		
52172	4791	3006322	1982-11-06	1982-11-06 00:00:00	1982-11-06	5001	0	\N	0	0	\N	\N	0	318775	0	8331-1	3006322		
35762	3278	3006322	2017-07-02	2017-07-02 00:00:00	2017-07-02	5001	0	\N	0	0	\N	\N	0	217785	0	8331-1	3006322		
173152	5317	4052083	1983-09-20	1983-09-20 00:00:00	1983-09-20	5001	0	\N	0	0	\N	\N	0	353649	0	23426006	4052083		
49614	1510	4052083	1995-05-12	1995-05-12 00:00:00	1995-05-12	5001	0	\N	0	0	\N	\N	0	100808	0	23426006	4052083		
150915	4626	4052083	1990-12-14	1990-12-14 00:00:00	1990-12-14	5001	0	\N	0	0	\N	\N	0	308234	0	23426006	4052083		
11197	1082	3019406	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	71021	0	6158-0	3019406		
26150	2402	3012494	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	159575	0	6206-7	3012494		
103515	3181	4133840	2003-07-04	2003-07-04 00:00:00	2003-07-04	5001	0	\N	0	0	\N	\N	0	211702	0	127783003	4133840		
170230	5222	4133840	2008-03-06	2008-03-06 00:00:00	2008-03-06	5001	0	\N	0	0	\N	\N	0	347348	0	127783003	4133840		
114996	3545	4052083	1973-03-24	1973-03-24 00:00:00	1973-03-24	5001	0	\N	0	0	\N	\N	0	235495	0	23426006	4052083		
15864	1448	3006322	1993-10-08	1993-10-08 00:00:00	1993-10-08	5001	0	\N	0	0	\N	\N	0	96602	0	8331-1	3006322		
42580	3934	3006322	1972-09-22	1972-09-22 00:00:00	1972-09-22	5001	0	\N	0	0	\N	\N	0	261478	0	8331-1	3006322		
39939	3717	3000876	1977-02-15	1977-02-15 00:00:00	1977-02-15	5001	0	\N	0	0	\N	\N	0	247065	0	6082-2	3000876		
40020	3725	3006322	2016-03-20	2016-03-20 00:00:00	2016-03-20	5001	0	\N	0	0	\N	\N	0	247567	0	8331-1	3006322		
55827	5119	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	340316	0	6273-7	3006451		
36371	3343	3020655	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	221826	0	6844-5	3020655		
31228	2853	3006322	1995-11-27	1995-11-27 00:00:00	1995-11-27	5001	0	\N	0	0	\N	\N	0	189507	0	8331-1	3006322		
11803	374	4024958	2010-04-05	2010-04-05 00:00:00	2010-04-05	5001	0	\N	0	0	\N	\N	0	24800	0	117015009	4024958		
16885	1535	46235214	1979-08-31	1979-08-31 00:00:00	1979-08-31	5001	0	\N	0	0	\N	\N	0	102716	0	76690-7	46235214		
42757	3957	3011505	2003-01-02	2003-01-02 00:00:00	2003-01-02	5001	0	\N	0	0	\N	\N	0	263078	0	19926-5	3011505		
46270	4261	40758406	1956-12-28	1956-12-28 00:00:00	1956-12-28	5001	0	\N	0	0	\N	\N	0	282939	0	55277-8	40758406		
46854	4312	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	286090	0	6248-9	3015076		
133886	4121	4133840	1985-10-27	1985-10-27 00:00:00	1985-10-27	5001	0	\N	0	0	\N	\N	0	274010	0	127783003	4133840		
39876	3703	3000876	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	246246	0	6082-2	3000876		
58321	5343	3020655	1984-05-11	1984-05-11 00:00:00	1984-05-11	5001	0	\N	0	0	\N	\N	0	355857	0	6844-5	3020655		
57593	1759	4052083	2006-01-29	2006-01-29 00:00:00	2006-01-29	5001	0	\N	0	0	\N	\N	0	117576	0	23426006	4052083		
33123	2988	3006322	2003-02-07	2003-02-07 00:00:00	2003-02-07	5001	0	\N	0	0	\N	\N	0	199493	0	8331-1	3006322		
39595	3675	3006322	2017-12-03	2017-12-03 00:00:00	2017-12-03	5001	0	\N	0	0	\N	\N	0	244437	0	8331-1	3006322		
5098	492	3000963	1979-12-05	1979-12-05 00:00:00	1979-12-05	5001	0	\N	0	0	\N	\N	0	32984	0	718-7	3000963		
125560	3874	4024958	1998-05-25	1998-05-25 00:00:00	1998-05-25	5001	0	\N	0	0	\N	\N	0	257270	0	117015009	4024958		
44818	4145	3000876	2006-07-29	2006-07-29 00:00:00	2006-07-29	5001	0	\N	0	0	\N	\N	0	275533	0	6082-2	3000876		
33942	3083	3006322	1969-07-20	1969-07-20 00:00:00	1969-07-20	5001	0	\N	0	0	\N	\N	0	205331	0	8331-1	3006322		
56165	5151	3006322	1995-03-11	1995-03-11 00:00:00	1995-03-11	5001	0	\N	0	0	\N	\N	0	342549	0	8331-1	3006322		
1961	180	3036780	1993-10-28	1993-10-28 00:00:00	1993-10-28	5001	0	\N	0	0	\N	\N	0	12147	0	6095-4	3036780		
13323	1264	3011505	1998-01-09	1998-01-09 00:00:00	1998-01-09	5001	0	\N	0	0	\N	\N	0	83302	0	19926-5	3011505		
69575	2134	4052083	1955-04-15	1955-04-15 00:00:00	1955-04-15	5001	0	\N	0	0	\N	\N	0	141985	0	23426006	4052083		
48056	4408	3006322	1995-06-10	1995-06-10 00:00:00	1995-06-10	5001	0	\N	0	0	\N	\N	0	293016	0	8331-1	3006322		
24807	2280	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	151567	0	6276-0	3027231		
7978	761	3005136	1979-09-26	1979-09-26 00:00:00	1979-09-26	5001	0	\N	0	0	\N	\N	0	50589	0	6075-6	3005136		
47361	4366	3000876	1997-11-11	1997-11-11 00:00:00	1997-11-11	5001	0	\N	0	0	\N	\N	0	289729	0	6082-2	3000876		
6075	186	4052083	1995-06-21	1995-06-21 00:00:00	1995-06-21	5001	0	\N	0	0	\N	\N	0	12627	0	23426006	4052083		
34541	1081	4024958	2003-07-01	2003-07-01 00:00:00	2003-07-01	5001	0	\N	0	0	\N	\N	0	70837	0	117015009	4024958		
46458	4278	3006322	1997-11-25	1997-11-25 00:00:00	1997-11-25	5001	0	\N	0	0	\N	\N	0	283939	0	8331-1	3006322		
31368	2866	3011505	2004-05-02	2004-05-02 00:00:00	2004-05-02	5001	0	\N	0	0	\N	\N	0	190677	0	19926-5	3011505		
115396	3560	4052083	2016-11-27	2016-11-27 00:00:00	2016-11-27	5001	0	\N	0	0	\N	\N	0	236358	0	23426006	4052083		
15411	1410	3006322	2005-05-30	2005-05-30 00:00:00	2005-05-30	5001	0	\N	0	0	\N	\N	0	93897	0	8331-1	3006322		
168457	5172	4052083	2013-09-20	2013-09-20 00:00:00	2013-09-20	5001	0	\N	0	0	\N	\N	0	343865	0	23426006	4052083		
53768	4932	3021226	1976-12-03	1976-12-03 00:00:00	1976-12-03	5001	0	\N	0	0	\N	\N	0	327863	0	6246-3	3021226		
11458	1097	3006322	1972-09-22	1972-09-22 00:00:00	1972-09-22	5001	0	\N	0	0	\N	\N	0	72004	0	8331-1	3006322		
55257	5053	3006322	1964-03-16	1964-03-16 00:00:00	1964-03-16	5001	0	\N	0	0	\N	\N	0	335988	0	8331-1	3006322		
38443	3550	3006322	1993-09-06	1993-09-06 00:00:00	1993-09-06	5001	0	\N	0	0	\N	\N	0	235736	0	8331-1	3006322		
140483	4330	4024958	2007-05-24	2007-05-24 00:00:00	2007-05-24	5001	0	\N	0	0	\N	\N	0	287240	0	117015009	4024958		
49816	4530	3006322	2004-08-19	2004-08-19 00:00:00	2004-08-19	5001	0	\N	0	0	\N	\N	0	301648	0	8331-1	3006322		
23777	2186	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	145810	0	7258-7	3001488		
72469	2220	4052083	1966-12-15	1966-12-15 00:00:00	1966-12-15	5001	0	\N	0	0	\N	\N	0	147851	0	23426006	4052083		
45855	4226	3036780	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	280641	0	6095-4	3036780		
24655	2267	3006322	2016-12-26	2016-12-26 00:00:00	2016-12-26	5001	0	\N	0	0	\N	\N	0	150686	0	8331-1	3006322		
57319	5264	3006322	1969-06-23	1969-06-23 00:00:00	1969-06-23	5001	0	\N	0	0	\N	\N	0	350226	0	8331-1	3006322		
52352	4814	3006322	1947-06-29	1947-06-29 00:00:00	1947-06-29	5001	0	\N	0	0	\N	\N	0	320252	0	8331-1	3006322		
12752	1215	3006322	1996-11-21	1996-11-21 00:00:00	1996-11-21	5001	0	\N	0	0	\N	\N	0	80010	0	8331-1	3006322		
25513	2339	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	155669	0	6082-2	3000876		
15155	1397	3020655	1977-11-27	1977-11-27 00:00:00	1977-11-27	5001	0	\N	0	0	\N	\N	0	92780	0	6844-5	3020655		
40748	3783	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	251370	0	6273-7	3006451		
124419	3843	4024958	2000-03-08	2000-03-08 00:00:00	2000-03-08	5001	0	\N	0	0	\N	\N	0	255068	0	117015009	4024958		
52173	4792	3006322	1951-06-17	1951-06-17 00:00:00	1951-06-17	5001	0	\N	0	0	\N	\N	0	318831	0	8331-1	3006322		
35763	3278	3006322	1976-10-05	1976-10-05 00:00:00	1976-10-05	5001	0	\N	0	0	\N	\N	0	217750	0	8331-1	3006322		
173159	5317	4024958	2001-09-05	2001-09-05 00:00:00	2001-09-05	5001	0	\N	0	0	\N	\N	0	353651	0	117015009	4024958		
49624	1511	4052083	2007-01-28	2007-01-28 00:00:00	2007-01-28	5001	0	\N	0	0	\N	\N	0	100879	0	23426006	4052083		
150931	4626	4052083	1982-01-31	1982-01-31 00:00:00	1982-01-31	5001	0	\N	0	0	\N	\N	0	308232	0	23426006	4052083		
11198	1082	3001247	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	71021	0	6085-5	3001247		
26151	2402	3006322	1984-02-19	1984-02-19 00:00:00	1984-02-19	5001	0	\N	0	0	\N	\N	0	159616	0	8331-1	3006322		
103518	3181	4133840	2004-07-09	2004-07-09 00:00:00	2004-07-09	5001	0	\N	0	0	\N	\N	0	211831	0	127783003	4133840		
170236	5222	4133840	2013-04-04	2013-04-04 00:00:00	2013-04-04	5001	0	\N	0	0	\N	\N	0	347344	0	127783003	4133840		
115008	3545	4024958	1996-01-09	1996-01-09 00:00:00	1996-01-09	5001	0	\N	0	0	\N	\N	0	235484	0	117015009	4024958		
15865	1448	3006322	1986-04-05	1986-04-05 00:00:00	1986-04-05	5001	0	\N	0	0	\N	\N	0	96631	0	8331-1	3006322		
42581	3935	3006322	1973-02-26	1973-02-26 00:00:00	1973-02-26	5001	0	\N	0	0	\N	\N	0	261544	0	8331-1	3006322		
39940	3717	3006734	1977-02-15	1977-02-15 00:00:00	1977-02-15	5001	0	\N	0	0	\N	\N	0	247065	0	6189-5	3006734		
40027	3728	3006322	1990-02-24	1990-02-24 00:00:00	1990-02-24	5001	0	\N	0	0	\N	\N	0	247729	0	8331-1	3006322		
55828	5119	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	340316	0	6246-3	3021226		
36372	3343	3000876	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	221764	0	6082-2	3000876		
31234	2857	3006322	1968-03-22	1968-03-22 00:00:00	1968-03-22	5001	0	\N	0	0	\N	\N	0	189709	0	8331-1	3006322		
11805	374	4052083	2004-07-10	2004-07-10 00:00:00	2004-07-10	5001	0	\N	0	0	\N	\N	0	24842	0	23426006	4052083		
16886	1535	3051031	1979-08-31	1979-08-31 00:00:00	1979-08-31	5001	0	\N	0	0	\N	\N	0	102716	0	46240-8	3051031		
42758	3957	3011505	2011-10-06	2011-10-06 00:00:00	2011-10-06	5001	0	\N	0	0	\N	\N	0	263061	0	19926-5	3011505		
46271	4261	40758406	1956-07-31	1956-07-31 00:00:00	1956-07-31	5001	0	\N	0	0	\N	\N	0	282864	0	55277-8	40758406		
46855	4312	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	286090	0	6158-0	3019406		
133887	4121	4052083	1934-05-31	1934-05-31 00:00:00	1934-05-31	5001	0	\N	0	0	\N	\N	0	273994	0	23426006	4052083		
39877	3703	3015076	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	246246	0	6248-9	3015076		
58322	5343	3005136	1984-05-11	1984-05-11 00:00:00	1984-05-11	5001	0	\N	0	0	\N	\N	0	355857	0	6075-6	3005136		
57601	1759	4024958	1999-09-16	1999-09-16 00:00:00	1999-09-16	5001	0	\N	0	0	\N	\N	0	117575	0	117015009	4024958		
33124	2988	40758406	1978-03-03	1978-03-03 00:00:00	1978-03-03	5001	0	\N	0	0	\N	\N	0	199440	0	55277-8	40758406		
39596	3675	3006322	1995-08-09	1995-08-09 00:00:00	1995-08-09	5001	0	\N	0	0	\N	\N	0	244477	0	8331-1	3006322		
5099	492	3006322	2016-03-31	2016-03-31 00:00:00	2016-03-31	5001	0	\N	0	0	\N	\N	0	32954	0	8331-1	3006322		
125566	3874	4024958	1986-06-14	1986-06-14 00:00:00	1986-06-14	5001	0	\N	0	0	\N	\N	0	257238	0	117015009	4024958		
44819	4145	3020655	2006-07-29	2006-07-29 00:00:00	2006-07-29	5001	0	\N	0	0	\N	\N	0	275533	0	6844-5	3020655		
33943	3083	3006322	1978-01-31	1978-01-31 00:00:00	1978-01-31	5001	0	\N	0	0	\N	\N	0	205326	0	8331-1	3006322		
56166	5151	3006322	1958-11-23	1958-11-23 00:00:00	1958-11-23	5001	0	\N	0	0	\N	\N	0	342499	0	8331-1	3006322		
1962	180	3006322	1985-09-28	1985-09-28 00:00:00	1985-09-28	5001	0	\N	0	0	\N	\N	0	12121	0	8331-1	3006322		
13324	1264	3006322	1949-12-21	1949-12-21 00:00:00	1949-12-21	5001	0	\N	0	0	\N	\N	0	83274	0	8331-1	3006322		
69606	2135	4052083	1967-05-12	1967-05-12 00:00:00	1967-05-12	5001	0	\N	0	0	\N	\N	0	142161	0	23426006	4052083		
48057	4409	3006322	1982-09-28	1982-09-28 00:00:00	1982-09-28	5001	0	\N	0	0	\N	\N	0	293121	0	8331-1	3006322		
24808	2280	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	151567	0	6248-9	3015076		
7979	761	3014599	1979-09-26	1979-09-26 00:00:00	1979-09-26	5001	0	\N	0	0	\N	\N	0	50589	0	6106-9	3014599		
47362	4366	3036780	1997-11-11	1997-11-11 00:00:00	1997-11-11	5001	0	\N	0	0	\N	\N	0	289729	0	6095-4	3036780		
6085	187	4024958	1979-03-17	1979-03-17 00:00:00	1979-03-17	5001	0	\N	0	0	\N	\N	0	12742	0	117015009	4024958		
137822	4247	4024958	2019-03-28	2019-03-28 00:00:00	2019-03-28	5001	0	\N	0	0	\N	\N	0	282077	0	117015009	4024958		
46459	4278	3011505	2017-12-01	2017-12-01 00:00:00	2017-12-01	5001	0	\N	0	0	\N	\N	0	283943	0	19926-5	3011505		
31369	2866	3011505	2006-08-13	2006-08-13 00:00:00	2006-08-13	5001	0	\N	0	0	\N	\N	0	190648	0	19926-5	3011505		
115415	3560	4052083	1980-06-12	1980-06-12 00:00:00	1980-06-12	5001	0	\N	0	0	\N	\N	0	236353	0	23426006	4052083		
15412	1411	3006322	1999-02-12	1999-02-12 00:00:00	1999-02-12	5001	0	\N	0	0	\N	\N	0	93969	0	8331-1	3006322		
168466	5172	4024958	1990-04-26	1990-04-26 00:00:00	1990-04-26	5001	0	\N	0	0	\N	\N	0	343880	0	117015009	4024958		
53769	4932	3012494	1976-12-03	1976-12-03 00:00:00	1976-12-03	5001	0	\N	0	0	\N	\N	0	327863	0	6206-7	3012494		
11459	1098	3006322	1976-12-10	1976-12-10 00:00:00	1976-12-10	5001	0	\N	0	0	\N	\N	0	72034	0	8331-1	3006322		
131237	4040	4052083	2017-03-02	2017-03-02 00:00:00	2017-03-02	5001	0	\N	0	0	\N	\N	0	268673	0	23426006	4052083		
38444	3550	3006322	1993-05-01	1993-05-01 00:00:00	1993-05-01	5001	0	\N	0	0	\N	\N	0	235747	0	8331-1	3006322		
63539	1952	4024958	1996-12-09	1996-12-09 00:00:00	1996-12-09	5001	0	\N	0	0	\N	\N	0	129816	0	117015009	4024958		
49817	4531	3049273	1983-07-22	1983-07-22 00:00:00	1983-07-22	5001	0	\N	0	0	\N	\N	0	301707	0	38265-5	3049273		
23778	2186	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	145810	0	6246-3	3021226		
49911	1517	4052083	1984-11-25	1984-11-25 00:00:00	1984-11-25	5001	0	\N	0	0	\N	\N	0	101456	0	23426006	4052083		
45856	4226	3012494	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	280641	0	6206-7	3012494		
24656	2267	3006322	1966-06-13	1966-06-13 00:00:00	1966-06-13	5001	0	\N	0	0	\N	\N	0	150682	0	8331-1	3006322		
57320	5264	3006322	2018-01-12	2018-01-12 00:00:00	2018-01-12	5001	0	\N	0	0	\N	\N	0	350208	0	8331-1	3006322		
52353	4814	3006322	1981-11-05	1981-11-05 00:00:00	1981-11-05	5001	0	\N	0	0	\N	\N	0	320230	0	8331-1	3006322		
12753	1215	3006322	1990-03-15	1990-03-15 00:00:00	1990-03-15	5001	0	\N	0	0	\N	\N	0	80025	0	8331-1	3006322		
25514	2339	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	155669	0	6844-5	3020655		
15156	1397	3036780	1977-11-27	1977-11-27 00:00:00	1977-11-27	5001	0	\N	0	0	\N	\N	0	92780	0	6095-4	3036780		
40749	3783	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	251370	0	6082-2	3000876		
67525	2070	4024958	1988-03-20	1988-03-20 00:00:00	1988-03-20	5001	0	\N	0	0	\N	\N	0	137766	0	117015009	4024958		
52174	4792	3006322	1993-08-23	1993-08-23 00:00:00	1993-08-23	5001	0	\N	0	0	\N	\N	0	318872	0	8331-1	3006322		
35764	3278	3006322	1966-03-21	1966-03-21 00:00:00	1966-03-21	5001	0	\N	0	0	\N	\N	0	217754	0	8331-1	3006322		
173163	5317	4024958	1973-11-03	1973-11-03 00:00:00	1973-11-03	5001	0	\N	0	0	\N	\N	0	353647	0	117015009	4024958		
49629	1511	4024958	1970-03-02	1970-03-02 00:00:00	1970-03-02	5001	0	\N	0	0	\N	\N	0	100900	0	117015009	4024958		
36519	1134	4024958	1949-06-01	1949-06-01 00:00:00	1949-06-01	5001	0	\N	0	0	\N	\N	0	74663	0	117015009	4024958		
11199	1082	3006734	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	71021	0	6189-5	3006734		
26152	2402	3001488	1977-11-19	1977-11-19 00:00:00	1977-11-19	5001	0	\N	0	0	\N	\N	0	159572	0	7258-7	3001488		
103521	3181	4133840	2018-11-16	2018-11-16 00:00:00	2018-11-16	5001	0	\N	0	0	\N	\N	0	211729	0	127783003	4133840		
170248	5222	4052083	1973-07-09	1973-07-09 00:00:00	1973-07-09	5001	0	\N	0	0	\N	\N	0	347386	0	23426006	4052083		
115014	3545	4052083	1974-10-03	1974-10-03 00:00:00	1974-10-03	5001	0	\N	0	0	\N	\N	0	235445	0	23426006	4052083		
15866	1448	3006322	2008-11-28	2008-11-28 00:00:00	2008-11-28	5001	0	\N	0	0	\N	\N	0	96604	0	8331-1	3006322		
42582	3935	3006322	1987-10-23	1987-10-23 00:00:00	1987-10-23	5001	0	\N	0	0	\N	\N	0	261567	0	8331-1	3006322		
39941	3717	3036780	1977-02-15	1977-02-15 00:00:00	1977-02-15	5001	0	\N	0	0	\N	\N	0	247065	0	6095-4	3036780		
40028	3728	3006322	1984-06-13	1984-06-13 00:00:00	1984-06-13	5001	0	\N	0	0	\N	\N	0	247698	0	8331-1	3006322		
55829	5119	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	340316	0	6276-0	3027231		
36373	3343	3001488	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	221764	0	7258-7	3001488		
31235	2857	3006322	1979-01-15	1979-01-15 00:00:00	1979-01-15	5001	0	\N	0	0	\N	\N	0	189722	0	8331-1	3006322		
11809	374	4024958	2015-10-17	2015-10-17 00:00:00	2015-10-17	5001	0	\N	0	0	\N	\N	0	24843	0	117015009	4024958		
16888	1535	40758406	1979-08-31	1979-08-31 00:00:00	1979-08-31	5001	0	\N	0	0	\N	\N	0	102716	0	55277-8	40758406		
42759	3957	40758406	1956-11-20	1956-11-20 00:00:00	1956-11-20	5001	0	\N	0	0	\N	\N	0	263133	0	55277-8	40758406		
46273	4261	40766240	1956-07-31	1956-07-31 00:00:00	1956-07-31	5001	0	\N	0	0	\N	\N	0	282864	0	63513-6	40766240		
46856	4312	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	286090	0	7258-7	3001488		
133888	4121	4133840	1971-08-08	1971-08-08 00:00:00	1971-08-08	5001	0	\N	0	0	\N	\N	0	273943	0	127783003	4133840		
39878	3703	3019406	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	246246	0	6158-0	3019406		
58323	5343	3021226	1984-05-11	1984-05-11 00:00:00	1984-05-11	5001	0	\N	0	0	\N	\N	0	355857	0	6246-3	3021226		
57604	1759	4052083	2005-06-25	2005-06-25 00:00:00	2005-06-25	5001	0	\N	0	0	\N	\N	0	117607	0	23426006	4052083		
33126	2988	3051031	1978-03-03	1978-03-03 00:00:00	1978-03-03	5001	0	\N	0	0	\N	\N	0	199440	0	46240-8	3051031		
39597	3675	3006322	2012-07-22	2012-07-22 00:00:00	2012-07-22	5001	0	\N	0	0	\N	\N	0	244435	0	8331-1	3006322		
5100	492	3006322	1948-02-07	1948-02-07 00:00:00	1948-02-07	5001	0	\N	0	0	\N	\N	0	32935	0	8331-1	3006322		
55070	1669	4133840	2018-05-07	2018-05-07 00:00:00	2018-05-07	5001	0	\N	0	0	\N	\N	0	112119	0	127783003	4133840		
44820	4145	3023430	2006-07-29	2006-07-29 00:00:00	2006-07-29	5001	0	\N	0	0	\N	\N	0	275533	0	6833-8	3023430		
33944	3083	3006322	2006-07-09	2006-07-09 00:00:00	2006-07-09	5001	0	\N	0	0	\N	\N	0	205265	0	8331-1	3006322		
56167	5151	3006322	2001-05-22	2001-05-22 00:00:00	2001-05-22	5001	0	\N	0	0	\N	\N	0	342512	0	8331-1	3006322		
1963	180	3015076	1980-05-17	1980-05-17 00:00:00	1980-05-17	5001	0	\N	0	0	\N	\N	0	12198	0	6248-9	3015076		
13325	1264	3006322	1987-12-28	1987-12-28 00:00:00	1987-12-28	5001	0	\N	0	0	\N	\N	0	83338	0	8331-1	3006322		
22270	2044	40766240	1963-01-12	1963-01-12 00:00:00	1963-01-12	5001	0	\N	0	0	\N	\N	0	135953	0	63513-6	40766240		
48058	4409	3006322	2011-10-04	2011-10-04 00:00:00	2011-10-04	5001	0	\N	0	0	\N	\N	0	293107	0	8331-1	3006322		
24809	2280	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	151567	0	6106-9	3014599		
137304	4229	4052083	1985-05-05	1985-05-05 00:00:00	1985-05-05	5001	0	\N	0	0	\N	\N	0	280946	0	23426006	4052083		
47363	4366	3006734	1997-11-11	1997-11-11 00:00:00	1997-11-11	5001	0	\N	0	0	\N	\N	0	289729	0	6189-5	3006734		
17380	545	4024958	2007-09-21	2007-09-21 00:00:00	2007-09-21	5001	0	\N	0	0	\N	\N	0	36064	0	117015009	4024958		
149117	4571	4052083	2018-03-11	2018-03-11 00:00:00	2018-03-11	5001	0	\N	0	0	\N	\N	0	304562	0	23426006	4052083		
46461	4278	3011505	1994-01-14	1994-01-14 00:00:00	1994-01-14	5001	0	\N	0	0	\N	\N	0	283919	0	19926-5	3011505		
31370	2866	3006322	2003-05-16	2003-05-16 00:00:00	2003-05-16	5001	0	\N	0	0	\N	\N	0	190652	0	8331-1	3006322		
115435	3561	4024958	1983-03-14	1983-03-14 00:00:00	1983-03-14	5001	0	\N	0	0	\N	\N	0	236512	0	117015009	4024958		
15413	1411	3027970	1999-11-23	1999-11-23 00:00:00	1999-11-23	5001	0	\N	0	0	\N	\N	0	93967	0	10834-0	3027970		
100033	3069	4052083	1971-04-28	1971-04-28 00:00:00	1971-04-28	5001	0	\N	0	0	\N	\N	0	204245	0	23426006	4052083		
53770	4932	3000876	1976-12-03	1976-12-03 00:00:00	1976-12-03	5001	0	\N	0	0	\N	\N	0	327863	0	6082-2	3000876		
11460	1098	3006322	2006-11-04	2006-11-04 00:00:00	2006-11-04	5001	0	\N	0	0	\N	\N	0	72067	0	8331-1	3006322		
131239	4040	4052083	1979-11-22	1979-11-22 00:00:00	1979-11-22	5001	0	\N	0	0	\N	\N	0	268663	0	23426006	4052083		
38445	3552	3006322	1982-08-05	1982-08-05 00:00:00	1982-08-05	5001	0	\N	0	0	\N	\N	0	235804	0	8331-1	3006322		
74839	2294	4024958	1972-01-28	1972-01-28 00:00:00	1972-01-28	5001	0	\N	0	0	\N	\N	0	152660	0	117015009	4024958		
49818	4531	3006322	1936-02-20	1936-02-20 00:00:00	1936-02-20	5001	0	\N	0	0	\N	\N	0	301726	0	8331-1	3006322		
23779	2186	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	145810	0	6276-0	3027231		
49928	1517	4024958	1996-04-27	1996-04-27 00:00:00	1996-04-27	5001	0	\N	0	0	\N	\N	0	101457	0	117015009	4024958		
45857	4226	3000876	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	280641	0	6082-2	3000876		
2610	260	3006451	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	17212	0	6273-7	3006451		
57321	5264	3006322	2002-07-09	2002-07-09 00:00:00	2002-07-09	5001	0	\N	0	0	\N	\N	0	350215	0	8331-1	3006322		
52354	4814	3049273	2016-08-15	2016-08-15 00:00:00	2016-08-15	5001	0	\N	0	0	\N	\N	0	320266	0	38265-5	3049273		
12754	1215	3006322	2008-08-31	2008-08-31 00:00:00	2008-08-31	5001	0	\N	0	0	\N	\N	0	80060	0	8331-1	3006322		
25515	2339	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	155669	0	6085-5	3001247		
15157	1397	3000876	1977-11-27	1977-11-27 00:00:00	1977-11-27	5001	0	\N	0	0	\N	\N	0	92780	0	6082-2	3000876		
40750	3783	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	251370	0	6844-5	3020655		
150356	4608	4133840	2008-01-03	2008-01-03 00:00:00	2008-01-03	5001	0	\N	0	0	\N	\N	0	306942	0	127783003	4133840		
52175	4792	3006322	1978-05-07	1978-05-07 00:00:00	1978-05-07	5001	0	\N	0	0	\N	\N	0	318877	0	8331-1	3006322		
35765	3279	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	217813	0	6082-2	3000876		
173164	5317	4052083	1973-11-03	1973-11-03 00:00:00	1973-11-03	5001	0	\N	0	0	\N	\N	0	353647	0	23426006	4052083		
49641	1511	4024958	1972-04-01	1972-04-01 00:00:00	1972-04-01	5001	0	\N	0	0	\N	\N	0	100887	0	117015009	4024958		
36520	1134	4024958	2001-07-10	2001-07-10 00:00:00	2001-07-10	5001	0	\N	0	0	\N	\N	0	74691	0	117015009	4024958		
11200	1082	3006451	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	71021	0	6273-7	3006451		
26153	2402	3020655	1977-11-19	1977-11-19 00:00:00	1977-11-19	5001	0	\N	0	0	\N	\N	0	159572	0	6844-5	3020655		
103522	3181	4052083	1994-12-27	1994-12-27 00:00:00	1994-12-27	5001	0	\N	0	0	\N	\N	0	211676	0	23426006	4052083		
170249	5222	4024958	1979-06-07	1979-06-07 00:00:00	1979-06-07	5001	0	\N	0	0	\N	\N	0	347410	0	117015009	4024958		
103797	3189	4024958	1982-03-01	1982-03-01 00:00:00	1982-03-01	5001	0	\N	0	0	\N	\N	0	212255	0	117015009	4024958		
15867	1448	3006322	1981-05-19	1981-05-19 00:00:00	1981-05-19	5001	0	\N	0	0	\N	\N	0	96569	0	8331-1	3006322		
42584	3935	3006322	1957-01-04	1957-01-04 00:00:00	1957-01-04	5001	0	\N	0	0	\N	\N	0	261558	0	8331-1	3006322		
39942	3717	3005136	1977-02-15	1977-02-15 00:00:00	1977-02-15	5001	0	\N	0	0	\N	\N	0	247065	0	6075-6	3005136		
40037	3730	3006322	1994-12-06	1994-12-06 00:00:00	1994-12-06	5001	0	\N	0	0	\N	\N	0	247873	0	8331-1	3006322		
55830	5119	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	340316	0	7258-7	3001488		
36374	3343	3006734	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	221764	0	6189-5	3006734		
31236	2857	3006322	1970-10-19	1970-10-19 00:00:00	1970-10-19	5001	0	\N	0	0	\N	\N	0	189684	0	8331-1	3006322		
111553	3444	4024958	1989-09-28	1989-09-28 00:00:00	1989-09-28	5001	0	\N	0	0	\N	\N	0	228567	0	117015009	4024958		
16889	1535	40766240	1979-08-31	1979-08-31 00:00:00	1979-08-31	5001	0	\N	0	0	\N	\N	0	102716	0	63513-6	40766240		
42761	3957	3051031	1956-11-20	1956-11-20 00:00:00	1956-11-20	5001	0	\N	0	0	\N	\N	0	263133	0	46240-8	3051031		
46274	4261	3051031	1956-07-31	1956-07-31 00:00:00	1956-07-31	5001	0	\N	0	0	\N	\N	0	282864	0	46240-8	3051031		
46857	4312	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	286090	0	6833-8	3023430		
133892	4121	4133840	1974-08-25	1974-08-25 00:00:00	1974-08-25	5001	0	\N	0	0	\N	\N	0	274007	0	127783003	4133840		
140530	4333	4052083	1970-12-27	1970-12-27 00:00:00	1970-12-27	5001	0	\N	0	0	\N	\N	0	287355	0	23426006	4052083		
58324	5343	3006451	1984-05-11	1984-05-11 00:00:00	1984-05-11	5001	0	\N	0	0	\N	\N	0	355857	0	6273-7	3006451		
57617	1760	4024958	1993-03-19	1993-03-19 00:00:00	1993-03-19	5001	0	\N	0	0	\N	\N	0	117693	0	117015009	4024958		
33128	2988	46235214	1978-03-03	1978-03-03 00:00:00	1978-03-03	5001	0	\N	0	0	\N	\N	0	199440	0	76690-7	46235214		
39598	3675	3006322	1968-04-13	1968-04-13 00:00:00	1968-04-13	5001	0	\N	0	0	\N	\N	0	244407	0	8331-1	3006322		
5101	492	3006322	1964-08-17	1964-08-17 00:00:00	1964-08-17	5001	0	\N	0	0	\N	\N	0	32981	0	8331-1	3006322		
55073	1669	4133840	2017-05-01	2017-05-01 00:00:00	2017-05-01	5001	0	\N	0	0	\N	\N	0	112108	0	127783003	4133840		
44821	4145	3005136	2006-07-29	2006-07-29 00:00:00	2006-07-29	5001	0	\N	0	0	\N	\N	0	275533	0	6075-6	3005136		
33945	3084	3006322	2019-06-14	2019-06-14 00:00:00	2019-06-14	5001	0	\N	0	0	\N	\N	0	205386	0	8331-1	3006322		
56168	5151	3006322	1961-11-18	1961-11-18 00:00:00	1961-11-18	5001	0	\N	0	0	\N	\N	0	342576	0	8331-1	3006322		
1964	180	3001247	1980-05-17	1980-05-17 00:00:00	1980-05-17	5001	0	\N	0	0	\N	\N	0	12198	0	6085-5	3001247		
13326	1264	3011505	2014-05-09	2014-05-09 00:00:00	2014-05-09	5001	0	\N	0	0	\N	\N	0	83287	0	19926-5	3011505		
22271	2044	3051031	1963-01-12	1963-01-12 00:00:00	1963-01-12	5001	0	\N	0	0	\N	\N	0	135953	0	46240-8	3051031		
48059	4409	3006322	1983-09-06	1983-09-06 00:00:00	1983-09-06	5001	0	\N	0	0	\N	\N	0	293083	0	8331-1	3006322		
24810	2280	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	151567	0	6206-7	3012494		
137305	4229	4052083	1963-08-10	1963-08-10 00:00:00	1963-08-10	5001	0	\N	0	0	\N	\N	0	280961	0	23426006	4052083		
47364	4366	3027231	1997-11-11	1997-11-11 00:00:00	1997-11-11	5001	0	\N	0	0	\N	\N	0	289729	0	6276-0	3027231		
17406	546	4024958	1986-03-11	1986-03-11 00:00:00	1986-03-11	5001	0	\N	0	0	\N	\N	0	36178	0	117015009	4024958		
149124	4571	4024958	2009-01-24	2009-01-24 00:00:00	2009-01-24	5001	0	\N	0	0	\N	\N	0	304524	0	117015009	4024958		
46462	4278	3011505	2006-09-29	2006-09-29 00:00:00	2006-09-29	5001	0	\N	0	0	\N	\N	0	283929	0	19926-5	3011505		
31371	2866	3011505	2018-08-19	2018-08-19 00:00:00	2018-08-19	5001	0	\N	0	0	\N	\N	0	190651	0	19926-5	3011505		
115449	3561	4052083	2007-08-24	2007-08-24 00:00:00	2007-08-24	5001	0	\N	0	0	\N	\N	0	236488	0	23426006	4052083		
15414	1411	3013721	1999-11-23	1999-11-23 00:00:00	1999-11-23	5001	0	\N	0	0	\N	\N	0	93967	0	1920-8	3013721		
100039	3069	4024958	1997-02-05	1997-02-05 00:00:00	1997-02-05	5001	0	\N	0	0	\N	\N	0	204248	0	117015009	4024958		
53771	4932	3001488	1976-12-03	1976-12-03 00:00:00	1976-12-03	5001	0	\N	0	0	\N	\N	0	327863	0	7258-7	3001488		
11461	1098	3006322	2013-02-21	2013-02-21 00:00:00	2013-02-21	5001	0	\N	0	0	\N	\N	0	72085	0	8331-1	3006322		
81512	2521	4024958	1967-04-15	1967-04-15 00:00:00	1967-04-15	5001	0	\N	0	0	\N	\N	0	166730	0	117015009	4024958		
38446	3552	3006322	1997-05-30	1997-05-30 00:00:00	1997-05-30	5001	0	\N	0	0	\N	\N	0	235792	0	8331-1	3006322		
74845	2294	4024958	1998-12-22	1998-12-22 00:00:00	1998-12-22	5001	0	\N	0	0	\N	\N	0	152681	0	117015009	4024958		
49819	4531	3006322	2011-07-11	2011-07-11 00:00:00	2011-07-11	5001	0	\N	0	0	\N	\N	0	301731	0	8331-1	3006322		
23780	2186	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	145810	0	6158-0	3019406		
39503	1227	4052083	1974-12-25	1974-12-25 00:00:00	1974-12-25	5001	0	\N	0	0	\N	\N	0	80781	0	23426006	4052083		
45858	4226	3006322	1974-08-02	1974-08-02 00:00:00	1974-08-02	5001	0	\N	0	0	\N	\N	0	280651	0	8331-1	3006322		
2611	260	3015076	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	17212	0	6248-9	3015076		
57322	5264	3006322	2008-07-18	2008-07-18 00:00:00	2008-07-18	5001	0	\N	0	0	\N	\N	0	350216	0	8331-1	3006322		
52355	4814	3006322	1936-12-11	1936-12-11 00:00:00	1936-12-11	5001	0	\N	0	0	\N	\N	0	320299	0	8331-1	3006322		
12755	1216	3011505	2019-01-22	2019-01-22 00:00:00	2019-01-22	5001	0	\N	0	0	\N	\N	0	80087	0	19926-5	3011505		
25516	2339	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	155669	0	6095-4	3036780		
15158	1397	3006451	1977-11-27	1977-11-27 00:00:00	1977-11-27	5001	0	\N	0	0	\N	\N	0	92780	0	6273-7	3006451		
40751	3783	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	251370	0	7258-7	3001488		
161650	4964	4024958	1970-04-20	1970-04-20 00:00:00	1970-04-20	5001	0	\N	0	0	\N	\N	0	329988	0	117015009	4024958		
52176	4792	3006322	2012-04-26	2012-04-26 00:00:00	2012-04-26	5001	0	\N	0	0	\N	\N	0	318873	0	8331-1	3006322		
35766	3279	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	217813	0	6276-0	3027231		
171866	5276	4052083	2012-08-19	2012-08-19 00:00:00	2012-08-19	5001	0	\N	0	0	\N	\N	0	350879	0	23426006	4052083		
49642	1511	4052083	2014-07-23	2014-07-23 00:00:00	2014-07-23	5001	0	\N	0	0	\N	\N	0	100916	0	23426006	4052083		
36527	1135	4052083	1992-01-04	1992-01-04 00:00:00	1992-01-04	5001	0	\N	0	0	\N	\N	0	74763	0	23426006	4052083		
11201	1082	3021226	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	71021	0	6246-3	3021226		
26154	2402	3023430	1977-11-19	1977-11-19 00:00:00	1977-11-19	5001	0	\N	0	0	\N	\N	0	159572	0	6833-8	3023430		
103523	3181	4133840	2012-10-12	2012-10-12 00:00:00	2012-10-12	5001	0	\N	0	0	\N	\N	0	211833	0	127783003	4133840		
170255	5222	4133840	2015-08-06	2015-08-06 00:00:00	2015-08-06	5001	0	\N	0	0	\N	\N	0	347469	0	127783003	4133840		
103802	3189	4024958	1968-08-31	1968-08-31 00:00:00	1968-08-31	5001	0	\N	0	0	\N	\N	0	212217	0	117015009	4024958		
15871	1450	3006322	2010-01-21	2010-01-21 00:00:00	2010-01-21	5001	0	\N	0	0	\N	\N	0	96722	0	8331-1	3006322		
42585	3936	3006322	2004-03-17	2004-03-17 00:00:00	2004-03-17	5001	0	\N	0	0	\N	\N	0	261608	0	8331-1	3006322		
39943	3717	3027231	1977-02-15	1977-02-15 00:00:00	1977-02-15	5001	0	\N	0	0	\N	\N	0	247065	0	6276-0	3027231		
40038	3730	3006322	1983-01-26	1983-01-26 00:00:00	1983-01-26	5001	0	\N	0	0	\N	\N	0	247845	0	8331-1	3006322		
55831	5119	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	340316	0	6095-4	3036780		
36375	3343	3036780	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	221764	0	6095-4	3036780		
31237	2857	3006322	1992-11-15	1992-11-15 00:00:00	1992-11-15	5001	0	\N	0	0	\N	\N	0	189712	0	8331-1	3006322		
40006	1245	4052083	2013-06-05	2013-06-05 00:00:00	2013-06-05	5001	0	\N	0	0	\N	\N	0	81985	0	23426006	4052083		
16891	1535	40766240	1979-08-01	1979-08-01 00:00:00	1979-08-01	5001	0	\N	0	0	\N	\N	0	102746	0	63513-6	40766240		
42762	3957	46235214	1956-11-20	1956-11-20 00:00:00	1956-11-20	5001	0	\N	0	0	\N	\N	0	263133	0	76690-7	46235214		
46275	4261	46235214	1956-07-31	1956-07-31 00:00:00	1956-07-31	5001	0	\N	0	0	\N	\N	0	282864	0	76690-7	46235214		
46858	4312	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	286090	0	6246-3	3021226		
145178	4454	4052083	1985-12-08	1985-12-08 00:00:00	1985-12-08	5001	0	\N	0	0	\N	\N	0	296417	0	23426006	4052083		
140545	4333	4052083	1983-08-27	1983-08-27 00:00:00	1983-08-27	5001	0	\N	0	0	\N	\N	0	287416	0	23426006	4052083		
58325	5343	3015076	1984-05-11	1984-05-11 00:00:00	1984-05-11	5001	0	\N	0	0	\N	\N	0	355857	0	6248-9	3015076		
57627	1760	4024958	1985-01-21	1985-01-21 00:00:00	1985-01-21	5001	0	\N	0	0	\N	\N	0	117655	0	117015009	4024958		
33129	2988	40766240	1978-03-03	1978-03-03 00:00:00	1978-03-03	5001	0	\N	0	0	\N	\N	0	199440	0	63513-6	40766240		
39599	3675	3006322	1988-10-24	1988-10-24 00:00:00	1988-10-24	5001	0	\N	0	0	\N	\N	0	244446	0	8331-1	3006322		
5102	492	3049273	2014-08-07	2014-08-07 00:00:00	2014-08-07	5001	0	\N	0	0	\N	\N	0	32906	0	38265-5	3049273		
55077	1669	4133840	2011-03-28	2011-03-28 00:00:00	2011-03-28	5001	0	\N	0	0	\N	\N	0	112089	0	127783003	4133840		
44822	4145	3012494	2006-07-29	2006-07-29 00:00:00	2006-07-29	5001	0	\N	0	0	\N	\N	0	275533	0	6206-7	3012494		
33946	3084	3006322	1993-10-04	1993-10-04 00:00:00	1993-10-04	5001	0	\N	0	0	\N	\N	0	205381	0	8331-1	3006322		
56169	5151	3006322	2014-02-25	2014-02-25 00:00:00	2014-02-25	5001	0	\N	0	0	\N	\N	0	342505	0	8331-1	3006322		
1965	180	3023430	1980-05-17	1980-05-17 00:00:00	1980-05-17	5001	0	\N	0	0	\N	\N	0	12198	0	6833-8	3023430		
13327	1264	3011505	2016-05-20	2016-05-20 00:00:00	2016-05-20	5001	0	\N	0	0	\N	\N	0	83282	0	19926-5	3011505		
22274	2044	46235214	1963-01-12	1963-01-12 00:00:00	1963-01-12	5001	0	\N	0	0	\N	\N	0	135953	0	76690-7	46235214		
48060	4409	3006322	1978-11-07	1978-11-07 00:00:00	1978-11-07	5001	0	\N	0	0	\N	\N	0	293053	0	8331-1	3006322		
24811	2280	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	151567	0	6075-6	3005136		
137311	4229	4052083	1996-03-10	1996-03-10 00:00:00	1996-03-10	5001	0	\N	0	0	\N	\N	0	280947	0	23426006	4052083		
47365	4366	3001247	1997-11-11	1997-11-11 00:00:00	1997-11-11	5001	0	\N	0	0	\N	\N	0	289729	0	6085-5	3001247		
17416	546	4024958	1968-08-19	1968-08-19 00:00:00	1968-08-19	5001	0	\N	0	0	\N	\N	0	36176	0	117015009	4024958		
149129	4572	4024958	1980-05-08	1980-05-08 00:00:00	1980-05-08	5001	0	\N	0	0	\N	\N	0	304621	0	117015009	4024958		
46463	4278	3011505	2013-11-08	2013-11-08 00:00:00	2013-11-08	5001	0	\N	0	0	\N	\N	0	283867	0	19926-5	3011505		
31372	2866	3011505	2013-07-14	2013-07-14 00:00:00	2013-07-14	5001	0	\N	0	0	\N	\N	0	190693	0	19926-5	3011505		
2683	84	4024958	1984-06-19	1984-06-19 00:00:00	1984-06-19	5001	0	\N	0	0	\N	\N	0	5667	0	117015009	4024958		
15415	1411	3000963	1999-11-23	1999-11-23 00:00:00	1999-11-23	5001	0	\N	0	0	\N	\N	0	93967	0	718-7	3000963		
100042	3069	4024958	1966-09-20	1966-09-20 00:00:00	1966-09-20	5001	0	\N	0	0	\N	\N	0	204244	0	117015009	4024958		
53772	4932	3005136	1976-12-03	1976-12-03 00:00:00	1976-12-03	5001	0	\N	0	0	\N	\N	0	327863	0	6075-6	3005136		
11462	1098	3006322	1995-07-21	1995-07-21 00:00:00	1995-07-21	5001	0	\N	0	0	\N	\N	0	72035	0	8331-1	3006322		
81519	2521	4052083	1981-11-05	1981-11-05 00:00:00	1981-11-05	5001	0	\N	0	0	\N	\N	0	166731	0	23426006	4052083		
5732	176	4024958	2005-01-25	2005-01-25 00:00:00	2005-01-25	5001	0	\N	0	0	\N	\N	0	11894	0	117015009	4024958		
74866	2295	4052083	1994-09-16	1994-09-16 00:00:00	1994-09-16	5001	0	\N	0	0	\N	\N	0	152774	0	23426006	4052083		
49820	4531	3006322	1940-05-11	1940-05-11 00:00:00	1940-05-11	5001	0	\N	0	0	\N	\N	0	301812	0	8331-1	3006322		
23781	2186	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	145810	0	6844-5	3020655		
39505	1227	4052083	1956-01-08	1956-01-08 00:00:00	1956-01-08	5001	0	\N	0	0	\N	\N	0	80845	0	23426006	4052083		
45859	4226	3011505	2018-11-25	2018-11-25 00:00:00	2018-11-25	5001	0	\N	0	0	\N	\N	0	280666	0	19926-5	3011505		
2612	260	3012494	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	17212	0	6206-7	3012494		
57323	5265	3006322	1973-09-26	1973-09-26 00:00:00	1973-09-26	5001	0	\N	0	0	\N	\N	0	350274	0	8331-1	3006322		
52356	4814	3006322	1955-12-25	1955-12-25 00:00:00	1955-12-25	5001	0	\N	0	0	\N	\N	0	320229	0	8331-1	3006322		
12756	1216	3006322	1971-03-22	1971-03-22 00:00:00	1971-03-22	5001	0	\N	0	0	\N	\N	0	80096	0	8331-1	3006322		
25517	2339	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	155669	0	6246-3	3021226		
15159	1397	3021226	1977-11-27	1977-11-27 00:00:00	1977-11-27	5001	0	\N	0	0	\N	\N	0	92780	0	6246-3	3021226		
40752	3783	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	251370	0	6095-4	3036780		
161661	4964	4024958	2000-05-31	2000-05-31 00:00:00	2000-05-31	5001	0	\N	0	0	\N	\N	0	329986	0	117015009	4024958		
52177	4792	3006322	1988-06-06	1988-06-06 00:00:00	1988-06-06	5001	0	\N	0	0	\N	\N	0	318871	0	8331-1	3006322		
35767	3279	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	217813	0	6106-9	3014599		
171867	5276	4052083	1960-06-08	1960-06-08 00:00:00	1960-06-08	5001	0	\N	0	0	\N	\N	0	350922	0	23426006	4052083		
49657	1512	4024958	2002-11-30	2002-11-30 00:00:00	2002-11-30	5001	0	\N	0	0	\N	\N	0	100962	0	117015009	4024958		
36543	1135	4024958	1972-03-19	1972-03-19 00:00:00	1972-03-19	5001	0	\N	0	0	\N	\N	0	74738	0	117015009	4024958		
11202	1082	3000876	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	71021	0	6082-2	3000876		
26155	2402	3005136	1977-11-19	1977-11-19 00:00:00	1977-11-19	5001	0	\N	0	0	\N	\N	0	159572	0	6075-6	3005136		
103529	3181	4133840	2011-10-07	2011-10-07 00:00:00	2011-10-07	5001	0	\N	0	0	\N	\N	0	211716	0	127783003	4133840		
170261	5222	4052083	1947-12-21	1947-12-21 00:00:00	1947-12-21	5001	0	\N	0	0	\N	\N	0	347408	0	23426006	4052083		
115110	3550	4024958	1993-05-01	1993-05-01 00:00:00	1993-05-01	5001	0	\N	0	0	\N	\N	0	235747	0	117015009	4024958		
15872	1450	3006322	2011-05-24	2011-05-24 00:00:00	2011-05-24	5001	0	\N	0	0	\N	\N	0	96723	0	8331-1	3006322		
42586	3936	3006322	1968-11-23	1968-11-23 00:00:00	1968-11-23	5001	0	\N	0	0	\N	\N	0	261605	0	8331-1	3006322		
39944	3717	3014599	1977-02-15	1977-02-15 00:00:00	1977-02-15	5001	0	\N	0	0	\N	\N	0	247065	0	6106-9	3014599		
40039	3730	3006322	1958-11-23	1958-11-23 00:00:00	1958-11-23	5001	0	\N	0	0	\N	\N	0	247843	0	8331-1	3006322		
55832	5119	3006451	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	340417	0	6273-7	3006451		
36376	3343	3020655	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	221764	0	6844-5	3020655		
31238	2857	3006322	2011-05-19	2011-05-19 00:00:00	2011-05-19	5001	0	\N	0	0	\N	\N	0	189723	0	8331-1	3006322		
169288	5196	4024958	1959-09-13	1959-09-13 00:00:00	1959-09-13	5001	0	\N	0	0	\N	\N	0	345550	0	117015009	4024958		
16893	1535	46235214	1979-08-01	1979-08-01 00:00:00	1979-08-01	5001	0	\N	0	0	\N	\N	0	102746	0	76690-7	46235214		
42764	3957	40766240	1956-11-20	1956-11-20 00:00:00	1956-11-20	5001	0	\N	0	0	\N	\N	0	263133	0	63513-6	40766240		
46277	4261	3049273	1982-05-09	1982-05-09 00:00:00	1982-05-09	5001	0	\N	0	0	\N	\N	0	282950	0	38265-5	3049273		
46859	4313	3020655	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	286336	0	6844-5	3020655		
145192	4454	4052083	1955-11-08	1955-11-08 00:00:00	1955-11-08	5001	0	\N	0	0	\N	\N	0	296466	0	23426006	4052083		
121914	3759	4024958	2005-09-01	2005-09-01 00:00:00	2005-09-01	5001	0	\N	0	0	\N	\N	0	249926	0	117015009	4024958		
58326	5343	3014599	1984-05-11	1984-05-11 00:00:00	1984-05-11	5001	0	\N	0	0	\N	\N	0	355857	0	6106-9	3014599		
57630	1760	4052083	2015-01-02	2015-01-02 00:00:00	2015-01-02	5001	0	\N	0	0	\N	\N	0	117694	0	23426006	4052083		
33130	2988	40758406	1977-12-03	1977-12-03 00:00:00	1977-12-03	5001	0	\N	0	0	\N	\N	0	199439	0	55277-8	40758406		
39600	3675	3006322	2000-03-27	2000-03-27 00:00:00	2000-03-27	5001	0	\N	0	0	\N	\N	0	244447	0	8331-1	3006322		
5103	492	3006322	1954-03-18	1954-03-18 00:00:00	1954-03-18	5001	0	\N	0	0	\N	\N	0	32979	0	8331-1	3006322		
55079	1669	4133840	2002-02-25	2002-02-25 00:00:00	2002-02-25	5001	0	\N	0	0	\N	\N	0	112116	0	127783003	4133840		
44823	4145	3036780	2006-07-29	2006-07-29 00:00:00	2006-07-29	5001	0	\N	0	0	\N	\N	0	275533	0	6095-4	3036780		
33947	3084	3006322	2008-06-15	2008-06-15 00:00:00	2008-06-15	5001	0	\N	0	0	\N	\N	0	205398	0	8331-1	3006322		
56170	5151	3006322	1992-01-15	1992-01-15 00:00:00	1992-01-15	5001	0	\N	0	0	\N	\N	0	342503	0	8331-1	3006322		
1966	180	3020655	1980-05-17	1980-05-17 00:00:00	1980-05-17	5001	0	\N	0	0	\N	\N	0	12198	0	6844-5	3020655		
13328	1264	3011505	2001-02-09	2001-02-09 00:00:00	2001-02-09	5001	0	\N	0	0	\N	\N	0	83345	0	19926-5	3011505		
22275	2044	40758406	1963-01-12	1963-01-12 00:00:00	1963-01-12	5001	0	\N	0	0	\N	\N	0	135953	0	55277-8	40758406		
48061	4409	3006322	2002-11-05	2002-11-05 00:00:00	2002-11-05	5001	0	\N	0	0	\N	\N	0	293084	0	8331-1	3006322		
24812	2280	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	151567	0	6273-7	3006451		
137313	4229	4024958	1954-11-24	1954-11-24 00:00:00	1954-11-24	5001	0	\N	0	0	\N	\N	0	280959	0	117015009	4024958		
47366	4366	3000876	1982-04-19	1982-04-19 00:00:00	1982-04-19	5001	0	\N	0	0	\N	\N	0	289663	0	6082-2	3000876		
19339	1773	3006734	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	118614	0	6189-5	3006734		
149130	4572	4024958	2016-08-13	2016-08-13 00:00:00	2016-08-13	5001	0	\N	0	0	\N	\N	0	304603	0	117015009	4024958		
46464	4278	3011505	2000-07-07	2000-07-07 00:00:00	2000-07-07	5001	0	\N	0	0	\N	\N	0	283839	0	19926-5	3011505		
31373	2866	3011505	2001-04-29	2001-04-29 00:00:00	2001-04-29	5001	0	\N	0	0	\N	\N	0	190676	0	19926-5	3011505		
13969	442	4024958	1947-09-24	1947-09-24 00:00:00	1947-09-24	5001	0	\N	0	0	\N	\N	0	29290	0	117015009	4024958		
15416	1411	3026361	1999-11-23	1999-11-23 00:00:00	1999-11-23	5001	0	\N	0	0	\N	\N	0	93967	0	26453-1	3026361		
111349	3439	4052083	1972-06-20	1972-06-20 00:00:00	1972-06-20	5001	0	\N	0	0	\N	\N	0	228142	0	23426006	4052083		
53773	4932	3019406	1976-12-03	1976-12-03 00:00:00	1976-12-03	5001	0	\N	0	0	\N	\N	0	327863	0	6158-0	3019406		
11463	1098	3006322	1962-11-14	1962-11-14 00:00:00	1962-11-14	5001	0	\N	0	0	\N	\N	0	72066	0	8331-1	3006322		
81521	2521	4024958	1952-08-29	1952-08-29 00:00:00	1952-08-29	5001	0	\N	0	0	\N	\N	0	166766	0	117015009	4024958		
5734	176	4024958	1982-07-10	1982-07-10 00:00:00	1982-07-10	5001	0	\N	0	0	\N	\N	0	11892	0	117015009	4024958		
74875	2295	4024958	1984-08-23	1984-08-23 00:00:00	1984-08-23	5001	0	\N	0	0	\N	\N	0	152776	0	117015009	4024958		
49821	4531	3006322	1973-06-14	1973-06-14 00:00:00	1973-06-14	5001	0	\N	0	0	\N	\N	0	301741	0	8331-1	3006322		
23782	2186	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	145810	0	6095-4	3036780		
39512	1227	4024958	1951-12-12	1951-12-12 00:00:00	1951-12-12	5001	0	\N	0	0	\N	\N	0	80844	0	117015009	4024958		
45860	4226	3011505	2012-01-15	2012-01-15 00:00:00	2012-01-15	5001	0	\N	0	0	\N	\N	0	280663	0	19926-5	3011505		
2613	260	3005136	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	17212	0	6075-6	3005136		
57324	5265	40766240	2003-04-14	2003-04-14 00:00:00	2003-04-14	5001	0	\N	0	0	\N	\N	0	350302	0	63513-6	40766240		
52357	4814	3006322	1942-03-26	1942-03-26 00:00:00	1942-03-26	5001	0	\N	0	0	\N	\N	0	320301	0	8331-1	3006322		
12757	1216	3011505	2017-01-17	2017-01-17 00:00:00	2017-01-17	5001	0	\N	0	0	\N	\N	0	80086	0	19926-5	3011505		
25518	2339	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	155669	0	6273-7	3006451		
15160	1397	3012494	1977-11-27	1977-11-27 00:00:00	1977-11-27	5001	0	\N	0	0	\N	\N	0	92780	0	6206-7	3012494		
40753	3784	3011505	1992-08-18	1992-08-18 00:00:00	1992-08-18	5001	0	\N	0	0	\N	\N	0	251535	0	19926-5	3011505		
161663	4964	4024958	1968-01-16	1968-01-16 00:00:00	1968-01-16	5001	0	\N	0	0	\N	\N	0	330031	0	117015009	4024958		
52178	4792	3006322	1978-11-17	1978-11-17 00:00:00	1978-11-17	5001	0	\N	0	0	\N	\N	0	318840	0	8331-1	3006322		
35768	3279	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	217813	0	6246-3	3021226		
171870	5276	4052083	1969-12-24	1969-12-24 00:00:00	1969-12-24	5001	0	\N	0	0	\N	\N	0	350904	0	23426006	4052083		
49664	1512	4024958	1987-10-03	1987-10-03 00:00:00	1987-10-03	5001	0	\N	0	0	\N	\N	0	100953	0	117015009	4024958		
128692	3961	4024958	2016-06-17	2016-06-17 00:00:00	2016-06-17	5001	0	\N	0	0	\N	\N	0	263370	0	117015009	4024958		
11203	1082	3027231	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	71021	0	6276-0	3027231		
26156	2402	3015076	1977-11-19	1977-11-19 00:00:00	1977-11-19	5001	0	\N	0	0	\N	\N	0	159572	0	6248-9	3015076		
103531	3181	4133840	2002-06-28	2002-06-28 00:00:00	2002-06-28	5001	0	\N	0	0	\N	\N	0	211642	0	127783003	4133840		
170265	5222	4133840	2018-08-23	2018-08-23 00:00:00	2018-08-23	5001	0	\N	0	0	\N	\N	0	347345	0	127783003	4133840		
22380	704	4024958	2007-09-12	2007-09-12 00:00:00	2007-09-12	5001	0	\N	0	0	\N	\N	0	46598	0	117015009	4024958		
15873	1450	3006322	2015-03-17	2015-03-17 00:00:00	2015-03-17	5001	0	\N	0	0	\N	\N	0	96680	0	8331-1	3006322		
42587	3936	3006322	1991-05-27	1991-05-27 00:00:00	1991-05-27	5001	0	\N	0	0	\N	\N	0	261618	0	8331-1	3006322		
39945	3717	3015076	1977-02-15	1977-02-15 00:00:00	1977-02-15	5001	0	\N	0	0	\N	\N	0	247065	0	6248-9	3015076		
40040	3730	3006322	1954-05-03	1954-05-03 00:00:00	1954-05-03	5001	0	\N	0	0	\N	\N	0	247832	0	8331-1	3006322		
55833	5119	3000876	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	340417	0	6082-2	3000876		
36377	3343	3021226	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	221764	0	6246-3	3021226		
31239	2858	3006322	1910-11-20	1910-11-20 00:00:00	1910-11-20	5001	0	\N	0	0	\N	\N	0	189873	0	8331-1	3006322		
169291	5196	4052083	2005-09-04	2005-09-04 00:00:00	2005-09-04	5001	0	\N	0	0	\N	\N	0	345513	0	23426006	4052083		
16894	1535	3051031	1979-08-01	1979-08-01 00:00:00	1979-08-01	5001	0	\N	0	0	\N	\N	0	102746	0	46240-8	3051031		
42765	3957	3011505	1998-12-24	1998-12-24 00:00:00	1998-12-24	5001	0	\N	0	0	\N	\N	0	263116	0	19926-5	3011505		
46278	4261	3006322	1979-04-21	1979-04-21 00:00:00	1979-04-21	5001	0	\N	0	0	\N	\N	0	282889	0	8331-1	3006322		
46860	4313	3023430	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	286336	0	6833-8	3023430		
145210	4454	4052083	2015-12-21	2015-12-21 00:00:00	2015-12-21	5001	0	\N	0	0	\N	\N	0	296419	0	23426006	4052083		
121917	3759	4052083	1966-03-03	1966-03-03 00:00:00	1966-03-03	5001	0	\N	0	0	\N	\N	0	249944	0	23426006	4052083		
58327	5343	3027231	1984-05-11	1984-05-11 00:00:00	1984-05-11	5001	0	\N	0	0	\N	\N	0	355857	0	6276-0	3027231		
21740	2002	40766240	1976-05-11	1976-05-11 00:00:00	1976-05-11	5001	0	\N	0	0	\N	\N	0	133373	0	63513-6	40766240		
33131	2988	3051031	1977-12-03	1977-12-03 00:00:00	1977-12-03	5001	0	\N	0	0	\N	\N	0	199439	0	46240-8	3051031		
39601	3675	3006322	1994-12-01	1994-12-01 00:00:00	1994-12-01	5001	0	\N	0	0	\N	\N	0	244476	0	8331-1	3006322		
5104	492	3006322	1961-03-23	1961-03-23 00:00:00	1961-03-23	5001	0	\N	0	0	\N	\N	0	32937	0	8331-1	3006322		
55080	1669	4133840	1998-02-16	1998-02-16 00:00:00	1998-02-16	5001	0	\N	0	0	\N	\N	0	112086	0	127783003	4133840		
44824	4145	3021226	2006-07-29	2006-07-29 00:00:00	2006-07-29	5001	0	\N	0	0	\N	\N	0	275533	0	6246-3	3021226		
33948	3084	3006322	2010-01-17	2010-01-17 00:00:00	2010-01-17	5001	0	\N	0	0	\N	\N	0	205399	0	8331-1	3006322		
56171	5151	3006322	1964-12-13	1964-12-13 00:00:00	1964-12-13	5001	0	\N	0	0	\N	\N	0	342508	0	8331-1	3006322		
1967	180	3001488	1980-05-17	1980-05-17 00:00:00	1980-05-17	5001	0	\N	0	0	\N	\N	0	12198	0	7258-7	3001488		
13329	1264	3011505	2005-10-07	2005-10-07 00:00:00	2005-10-07	5001	0	\N	0	0	\N	\N	0	83286	0	19926-5	3011505		
22278	2044	3051031	1963-10-09	1963-10-09 00:00:00	1963-10-09	5001	0	\N	0	0	\N	\N	0	135955	0	46240-8	3051031		
48062	4409	3006322	1975-08-08	1975-08-08 00:00:00	1975-08-08	5001	0	\N	0	0	\N	\N	0	293118	0	8331-1	3006322		
24813	2280	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	151567	0	6085-5	3001247		
137326	4229	4024958	1970-11-11	1970-11-11 00:00:00	1970-11-11	5001	0	\N	0	0	\N	\N	0	280964	0	117015009	4024958		
47367	4366	3005136	1982-04-19	1982-04-19 00:00:00	1982-04-19	5001	0	\N	0	0	\N	\N	0	289663	0	6075-6	3005136		
19340	1773	3036780	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	118614	0	6095-4	3036780		
149135	4572	4024958	1999-08-28	1999-08-28 00:00:00	1999-08-28	5001	0	\N	0	0	\N	\N	0	304602	0	117015009	4024958		
46465	4278	3011505	2001-08-31	2001-08-31 00:00:00	2001-08-31	5001	0	\N	0	0	\N	\N	0	283847	0	19926-5	3011505		
31374	2866	3011505	2016-08-07	2016-08-07 00:00:00	2016-08-07	5001	0	\N	0	0	\N	\N	0	190650	0	19926-5	3011505		
62137	1905	4024958	1990-01-27	1990-01-27 00:00:00	1990-01-27	5001	0	\N	0	0	\N	\N	0	126821	0	117015009	4024958		
15417	1411	3019550	1999-11-23	1999-11-23 00:00:00	1999-11-23	5001	0	\N	0	0	\N	\N	0	93967	0	2951-2	3019550		
111355	3439	4024958	1990-08-15	1990-08-15 00:00:00	1990-08-15	5001	0	\N	0	0	\N	\N	0	228210	0	117015009	4024958		
53774	4932	3001247	1976-12-03	1976-12-03 00:00:00	1976-12-03	5001	0	\N	0	0	\N	\N	0	327863	0	6085-5	3001247		
11464	1098	3006322	1962-03-10	1962-03-10 00:00:00	1962-03-10	5001	0	\N	0	0	\N	\N	0	72033	0	8331-1	3006322		
81547	2521	4024958	1959-10-30	1959-10-30 00:00:00	1959-10-30	5001	0	\N	0	0	\N	\N	0	166758	0	117015009	4024958		
5741	176	4052083	1966-08-19	1966-08-19 00:00:00	1966-08-19	5001	0	\N	0	0	\N	\N	0	11896	0	23426006	4052083		
74886	2295	4052083	2001-03-12	2001-03-12 00:00:00	2001-03-12	5001	0	\N	0	0	\N	\N	0	152777	0	23426006	4052083		
49822	4531	3006322	1923-10-12	1923-10-12 00:00:00	1923-10-12	5001	0	\N	0	0	\N	\N	0	301736	0	8331-1	3006322		
23783	2186	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	145810	0	6075-6	3005136		
39519	1227	4052083	2012-03-06	2012-03-06 00:00:00	2012-03-06	5001	0	\N	0	0	\N	\N	0	80805	0	23426006	4052083		
45861	4226	3011505	2006-01-01	2006-01-01 00:00:00	2006-01-01	5001	0	\N	0	0	\N	\N	0	280709	0	19926-5	3011505		
2614	260	3014599	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	17212	0	6106-9	3014599		
57325	5265	46235214	2003-04-14	2003-04-14 00:00:00	2003-04-14	5001	0	\N	0	0	\N	\N	0	350302	0	76690-7	46235214		
52358	4814	3006322	1965-04-21	1965-04-21 00:00:00	1965-04-21	5001	0	\N	0	0	\N	\N	0	320253	0	8331-1	3006322		
12758	1216	3011505	2013-01-08	2013-01-08 00:00:00	2013-01-08	5001	0	\N	0	0	\N	\N	0	80107	0	19926-5	3011505		
25519	2339	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	155669	0	7258-7	3001488		
15161	1397	3014599	1977-11-27	1977-11-27 00:00:00	1977-11-27	5001	0	\N	0	0	\N	\N	0	92780	0	6106-9	3014599		
40754	3784	3011505	1985-08-06	1985-08-06 00:00:00	1985-08-06	5001	0	\N	0	0	\N	\N	0	251460	0	19926-5	3011505		
161903	4970	4024958	1926-09-30	1926-09-30 00:00:00	1926-09-30	5001	0	\N	0	0	\N	\N	0	330473	0	117015009	4024958		
52200	4795	3006322	2011-02-07	2011-02-07 00:00:00	2011-02-07	5001	0	\N	0	0	\N	\N	0	319039	0	8331-1	3006322		
35769	3279	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	217813	0	6844-5	3020655		
171873	5276	4024958	2010-02-27	2010-02-27 00:00:00	2010-02-27	5001	0	\N	0	0	\N	\N	0	350935	0	117015009	4024958		
118610	3650	4024958	1961-09-18	1961-09-18 00:00:00	1961-09-18	5001	0	\N	0	0	\N	\N	0	242901	0	117015009	4024958		
139998	4313	4024958	1958-12-29	1958-12-29 00:00:00	1958-12-29	5001	0	\N	0	0	\N	\N	0	286275	0	117015009	4024958		
11204	1082	3015076	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	71021	0	6248-9	3015076		
26157	2402	3027231	1977-11-19	1977-11-19 00:00:00	1977-11-19	5001	0	\N	0	0	\N	\N	0	159572	0	6276-0	3027231		
103539	3181	4133840	2007-09-14	2007-09-14 00:00:00	2007-09-14	5001	0	\N	0	0	\N	\N	0	211709	0	127783003	4133840		
58233	1773	4024958	1978-07-18	1978-07-18 00:00:00	1978-07-18	5001	0	\N	0	0	\N	\N	0	118572	0	117015009	4024958		
34142	3114	3049273	2016-04-04	2016-04-04 00:00:00	2016-04-04	5001	0	\N	0	0	\N	\N	0	207118	0	38265-5	3049273		
15874	1450	3006322	1983-10-25	1983-10-25 00:00:00	1983-10-25	5001	0	\N	0	0	\N	\N	0	96719	0	8331-1	3006322		
42588	3936	3006322	1987-10-17	1987-10-17 00:00:00	1987-10-17	5001	0	\N	0	0	\N	\N	0	261606	0	8331-1	3006322		
39946	3717	3006451	1977-02-15	1977-02-15 00:00:00	1977-02-15	5001	0	\N	0	0	\N	\N	0	247065	0	6273-7	3006451		
40041	3731	3006322	1976-09-11	1976-09-11 00:00:00	1976-09-11	5001	0	\N	0	0	\N	\N	0	247912	0	8331-1	3006322		
55834	5119	3005136	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	340417	0	6075-6	3005136		
36378	3343	3005136	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	221764	0	6075-6	3005136		
31240	2858	3006322	1918-05-20	1918-05-20 00:00:00	1918-05-20	5001	0	\N	0	0	\N	\N	0	189822	0	8331-1	3006322		
169292	5196	4052083	1995-05-16	1995-05-16 00:00:00	1995-05-16	5001	0	\N	0	0	\N	\N	0	345545	0	23426006	4052083		
16896	1535	40758406	1979-08-01	1979-08-01 00:00:00	1979-08-01	5001	0	\N	0	0	\N	\N	0	102746	0	55277-8	40758406		
42766	3957	40758406	1957-01-19	1957-01-19 00:00:00	1957-01-19	5001	0	\N	0	0	\N	\N	0	263094	0	55277-8	40758406		
46280	4261	40758406	1956-11-28	1956-11-28 00:00:00	1956-11-28	5001	0	\N	0	0	\N	\N	0	282940	0	55277-8	40758406		
46861	4313	3019406	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	286336	0	6158-0	3019406		
91124	2813	4024958	1944-09-17	1944-09-17 00:00:00	1944-09-17	5001	0	\N	0	0	\N	\N	0	186407	0	117015009	4024958		
121925	3759	4052083	2010-07-05	2010-07-05 00:00:00	2010-07-05	5001	0	\N	0	0	\N	\N	0	249975	0	23426006	4052083		
58328	5343	3019406	1984-05-11	1984-05-11 00:00:00	1984-05-11	5001	0	\N	0	0	\N	\N	0	355857	0	6158-0	3019406		
21741	2002	3051031	1976-05-11	1976-05-11 00:00:00	1976-05-11	5001	0	\N	0	0	\N	\N	0	133373	0	46240-8	3051031		
33133	2988	46235214	1977-12-03	1977-12-03 00:00:00	1977-12-03	5001	0	\N	0	0	\N	\N	0	199439	0	76690-7	46235214		
39602	3675	3006322	2001-07-05	2001-07-05 00:00:00	2001-07-05	5001	0	\N	0	0	\N	\N	0	244434	0	8331-1	3006322		
5107	495	3006322	1975-03-15	1975-03-15 00:00:00	1975-03-15	5001	0	\N	0	0	\N	\N	0	33094	0	8331-1	3006322		
55082	1669	4024958	1985-01-20	1985-01-20 00:00:00	1985-01-20	5001	0	\N	0	0	\N	\N	0	112052	0	117015009	4024958		
44825	4145	3006451	2006-07-29	2006-07-29 00:00:00	2006-07-29	5001	0	\N	0	0	\N	\N	0	275533	0	6273-7	3006451		
33949	3084	3006322	1995-03-13	1995-03-13 00:00:00	1995-03-13	5001	0	\N	0	0	\N	\N	0	205367	0	8331-1	3006322		
56172	5152	3006322	1973-01-22	1973-01-22 00:00:00	1973-01-22	5001	0	\N	0	0	\N	\N	0	342601	0	8331-1	3006322		
1968	180	3006451	1980-05-17	1980-05-17 00:00:00	1980-05-17	5001	0	\N	0	0	\N	\N	0	12198	0	6273-7	3006451		
13330	1264	3011505	2008-10-24	2008-10-24 00:00:00	2008-10-24	5001	0	\N	0	0	\N	\N	0	83290	0	19926-5	3011505		
22279	2044	40766240	1963-10-09	1963-10-09 00:00:00	1963-10-09	5001	0	\N	0	0	\N	\N	0	135955	0	63513-6	40766240		
48063	4409	3006322	1968-11-13	1968-11-13 00:00:00	1968-11-13	5001	0	\N	0	0	\N	\N	0	293081	0	8331-1	3006322		
24814	2280	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	151567	0	6189-5	3006734		
137327	4229	4024958	1983-03-21	1983-03-21 00:00:00	1983-03-21	5001	0	\N	0	0	\N	\N	0	280956	0	117015009	4024958		
47368	4366	3027231	1982-04-19	1982-04-19 00:00:00	1982-04-19	5001	0	\N	0	0	\N	\N	0	289663	0	6276-0	3027231		
19341	1773	3023430	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	118614	0	6833-8	3023430		
149136	4572	4024958	1993-12-01	1993-12-01 00:00:00	1993-12-01	5001	0	\N	0	0	\N	\N	0	304639	0	117015009	4024958		
46466	4278	3011505	2000-07-14	2000-07-14 00:00:00	2000-07-14	5001	0	\N	0	0	\N	\N	0	283887	0	19926-5	3011505		
31375	2866	3006322	1979-06-24	1979-06-24 00:00:00	1979-06-24	5001	0	\N	0	0	\N	\N	0	190662	0	8331-1	3006322		
62138	1905	4024958	2010-04-04	2010-04-04 00:00:00	2010-04-04	5001	0	\N	0	0	\N	\N	0	126818	0	117015009	4024958		
15418	1411	3015632	1999-11-23	1999-11-23 00:00:00	1999-11-23	5001	0	\N	0	0	\N	\N	0	93967	0	2028-9	3015632		
111363	3439	4024958	1952-05-27	1952-05-27 00:00:00	1952-05-27	5001	0	\N	0	0	\N	\N	0	228140	0	117015009	4024958		
53775	4932	3023430	1976-12-03	1976-12-03 00:00:00	1976-12-03	5001	0	\N	0	0	\N	\N	0	327863	0	6833-8	3023430		
11465	1098	3006322	2010-02-26	2010-02-26 00:00:00	2010-02-26	5001	0	\N	0	0	\N	\N	0	72037	0	8331-1	3006322		
81553	2521	4024958	1955-02-07	1955-02-07 00:00:00	1955-02-07	5001	0	\N	0	0	\N	\N	0	166729	0	117015009	4024958		
5767	177	4024958	1969-04-28	1969-04-28 00:00:00	1969-04-28	5001	0	\N	0	0	\N	\N	0	12004	0	117015009	4024958		
74888	2295	4024958	1973-11-04	1973-11-04 00:00:00	1973-11-04	5001	0	\N	0	0	\N	\N	0	152772	0	117015009	4024958		
49823	4531	3006322	1941-02-18	1941-02-18 00:00:00	1941-02-18	5001	0	\N	0	0	\N	\N	0	301813	0	8331-1	3006322		
23784	2186	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	145810	0	6833-8	3023430		
39526	1227	4024958	1984-12-27	1984-12-27 00:00:00	1984-12-27	5001	0	\N	0	0	\N	\N	0	80755	0	117015009	4024958		
45862	4226	3011505	2013-01-20	2013-01-20 00:00:00	2013-01-20	5001	0	\N	0	0	\N	\N	0	280683	0	19926-5	3011505		
2615	260	3006734	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	17212	0	6189-5	3006734		
57328	5265	3051031	2003-04-14	2003-04-14 00:00:00	2003-04-14	5001	0	\N	0	0	\N	\N	0	350302	0	46240-8	3051031		
52359	4814	3006322	1944-07-28	1944-07-28 00:00:00	1944-07-28	5001	0	\N	0	0	\N	\N	0	320302	0	8331-1	3006322		
12759	1216	3011505	2015-01-13	2015-01-13 00:00:00	2015-01-13	5001	0	\N	0	0	\N	\N	0	80109	0	19926-5	3011505		
25520	2339	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	155669	0	6189-5	3006734		
15162	1397	3027231	1977-11-27	1977-11-27 00:00:00	1977-11-27	5001	0	\N	0	0	\N	\N	0	92780	0	6276-0	3027231		
40755	3784	3011505	1991-08-13	1991-08-13 00:00:00	1991-08-13	5001	0	\N	0	0	\N	\N	0	251463	0	19926-5	3011505		
161919	4971	4133840	2006-01-03	2006-01-03 00:00:00	2006-01-03	5001	0	\N	0	0	\N	\N	0	330658	0	127783003	4133840		
52207	4799	3006322	1998-08-25	1998-08-25 00:00:00	1998-08-25	5001	0	\N	0	0	\N	\N	0	319262	0	8331-1	3006322		
35770	3279	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	217813	0	6158-0	3019406		
171878	5276	4024958	1972-03-21	1972-03-21 00:00:00	1972-03-21	5001	0	\N	0	0	\N	\N	0	350866	0	117015009	4024958		
118612	3650	4052083	2013-12-17	2013-12-17 00:00:00	2013-12-17	5001	0	\N	0	0	\N	\N	0	242995	0	23426006	4052083		
140039	4313	4052083	1991-08-28	1991-08-28 00:00:00	1991-08-28	5001	0	\N	0	0	\N	\N	0	286264	0	23426006	4052083		
11205	1082	3027231	1988-09-06	1988-09-06 00:00:00	1988-09-06	5001	0	\N	0	0	\N	\N	0	70905	0	6276-0	3027231		
26158	2402	3014599	1977-11-19	1977-11-19 00:00:00	1977-11-19	5001	0	\N	0	0	\N	\N	0	159572	0	6106-9	3014599		
103544	3181	4133840	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	211715	0	127783003	4133840		
58235	1773	4024958	1967-05-19	1967-05-19 00:00:00	1967-05-19	5001	0	\N	0	0	\N	\N	0	118571	0	117015009	4024958		
34143	3114	3006322	1990-06-10	1990-06-10 00:00:00	1990-06-10	5001	0	\N	0	0	\N	\N	0	207133	0	8331-1	3006322		
37742	3481	3006322	2014-08-17	2014-08-17 00:00:00	2014-08-17	5001	0	\N	0	0	\N	\N	0	230854	0	8331-1	3006322		
42589	3936	3006322	2000-12-18	2000-12-18 00:00:00	2000-12-18	5001	0	\N	0	0	\N	\N	0	261620	0	8331-1	3006322		
39947	3717	3020655	1977-02-15	1977-02-15 00:00:00	1977-02-15	5001	0	\N	0	0	\N	\N	0	247065	0	6844-5	3020655		
40042	3731	3006322	1985-07-09	1985-07-09 00:00:00	1985-07-09	5001	0	\N	0	0	\N	\N	0	247915	0	8331-1	3006322		
55835	5119	3012494	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	340417	0	6206-7	3012494		
36379	3343	3001247	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	221764	0	6085-5	3001247		
31241	2858	3006322	1950-07-26	1950-07-26 00:00:00	1950-07-26	5001	0	\N	0	0	\N	\N	0	189798	0	8331-1	3006322		
169295	5196	4052083	1958-12-26	1958-12-26 00:00:00	1958-12-26	5001	0	\N	0	0	\N	\N	0	345551	0	23426006	4052083		
16897	1536	3006322	1968-10-29	1968-10-29 00:00:00	1968-10-29	5001	0	\N	0	0	\N	\N	0	102779	0	8331-1	3006322		
42768	3957	3051031	1957-01-19	1957-01-19 00:00:00	1957-01-19	5001	0	\N	0	0	\N	\N	0	263094	0	46240-8	3051031		
46281	4261	3051031	1956-11-28	1956-11-28 00:00:00	1956-11-28	5001	0	\N	0	0	\N	\N	0	282940	0	46240-8	3051031		
46862	4313	3005136	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	286336	0	6075-6	3005136		
91141	2815	4024958	1994-01-24	1994-01-24 00:00:00	1994-01-24	5001	0	\N	0	0	\N	\N	0	186493	0	117015009	4024958		
121953	3761	4052083	1981-11-29	1981-11-29 00:00:00	1981-11-29	5001	0	\N	0	0	\N	\N	0	250054	0	23426006	4052083		
58329	5343	3000876	1984-05-11	1984-05-11 00:00:00	1984-05-11	5001	0	\N	0	0	\N	\N	0	355857	0	6082-2	3000876		
21742	2002	46235214	1976-05-11	1976-05-11 00:00:00	1976-05-11	5001	0	\N	0	0	\N	\N	0	133373	0	76690-7	46235214		
33134	2988	40766240	1977-12-03	1977-12-03 00:00:00	1977-12-03	5001	0	\N	0	0	\N	\N	0	199439	0	63513-6	40766240		
39603	3675	3006322	1974-10-24	1974-10-24 00:00:00	1974-10-24	5001	0	\N	0	0	\N	\N	0	244432	0	8331-1	3006322		
5108	495	3006322	1979-01-18	1979-01-18 00:00:00	1979-01-18	5001	0	\N	0	0	\N	\N	0	33063	0	8331-1	3006322		
55083	1669	4133840	2016-04-25	2016-04-25 00:00:00	2016-04-25	5001	0	\N	0	0	\N	\N	0	112118	0	127783003	4133840		
44826	4145	3015076	2006-07-29	2006-07-29 00:00:00	2006-07-29	5001	0	\N	0	0	\N	\N	0	275533	0	6248-9	3015076		
33950	3086	3006322	2009-12-04	2009-12-04 00:00:00	2009-12-04	5001	0	\N	0	0	\N	\N	0	205469	0	8331-1	3006322		
56173	5152	3006322	1988-02-23	1988-02-23 00:00:00	1988-02-23	5001	0	\N	0	0	\N	\N	0	342602	0	8331-1	3006322		
1969	180	3021226	1980-05-17	1980-05-17 00:00:00	1980-05-17	5001	0	\N	0	0	\N	\N	0	12198	0	6246-3	3021226		
13331	1265	3006322	1998-06-10	1998-06-10 00:00:00	1998-06-10	5001	0	\N	0	0	\N	\N	0	83421	0	8331-1	3006322		
22280	2044	40758406	1963-10-09	1963-10-09 00:00:00	1963-10-09	5001	0	\N	0	0	\N	\N	0	135955	0	55277-8	40758406		
48064	4409	3006322	1969-06-24	1969-06-24 00:00:00	1969-06-24	5001	0	\N	0	0	\N	\N	0	293090	0	8331-1	3006322		
24815	2280	3006322	1980-03-09	1980-03-09 00:00:00	1980-03-09	5001	0	\N	0	0	\N	\N	0	151561	0	8331-1	3006322		
137333	4229	4024958	1984-11-22	1984-11-22 00:00:00	1984-11-22	5001	0	\N	0	0	\N	\N	0	280945	0	117015009	4024958		
47369	4366	3001247	1982-04-19	1982-04-19 00:00:00	1982-04-19	5001	0	\N	0	0	\N	\N	0	289663	0	6085-5	3001247		
19342	1773	3020655	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	118614	0	6844-5	3020655		
149138	4572	4024958	2018-07-16	2018-07-16 00:00:00	2018-07-16	5001	0	\N	0	0	\N	\N	0	304626	0	117015009	4024958		
46467	4278	3011505	2014-11-14	2014-11-14 00:00:00	2014-11-14	5001	0	\N	0	0	\N	\N	0	283850	0	19926-5	3011505		
31376	2866	3006322	1970-01-29	1970-01-29 00:00:00	1970-01-29	5001	0	\N	0	0	\N	\N	0	190645	0	8331-1	3006322		
62155	1905	4052083	2003-11-28	2003-11-28 00:00:00	2003-11-28	5001	0	\N	0	0	\N	\N	0	126807	0	23426006	4052083		
15419	1411	3045716	1999-11-23	1999-11-23 00:00:00	1999-11-23	5001	0	\N	0	0	\N	\N	0	93967	0	33037-3	3045716		
38737	1208	4024958	1954-07-10	1954-07-10 00:00:00	1954-07-10	5001	0	\N	0	0	\N	\N	0	79393	0	117015009	4024958		
53776	4932	3015076	1976-12-03	1976-12-03 00:00:00	1976-12-03	5001	0	\N	0	0	\N	\N	0	327863	0	6248-9	3015076		
11466	1099	3001247	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	72213	0	6085-5	3001247		
81557	2522	4024958	1959-11-05	1959-11-05 00:00:00	1959-11-05	5001	0	\N	0	0	\N	\N	0	166848	0	117015009	4024958		
63279	1946	4024958	1977-09-20	1977-09-20 00:00:00	1977-09-20	5001	0	\N	0	0	\N	\N	0	129279	0	117015009	4024958		
1680	148	3006322	2016-10-28	2016-10-28 00:00:00	2016-10-28	5001	0	\N	0	0	\N	\N	0	9990	0	8331-1	3006322		
49825	4531	3049273	1995-04-20	1995-04-20 00:00:00	1995-04-20	5001	0	\N	0	0	\N	\N	0	301708	0	38265-5	3049273		
23785	2186	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	145810	0	6106-9	3014599		
39534	1227	4052083	1965-03-07	1965-03-07 00:00:00	1965-03-07	5001	0	\N	0	0	\N	\N	0	80749	0	23426006	4052083		
45863	4226	3006322	1989-12-07	1989-12-07 00:00:00	1989-12-07	5001	0	\N	0	0	\N	\N	0	280722	0	8331-1	3006322		
2616	260	3036780	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	17212	0	6095-4	3036780		
57329	5265	40758406	2003-04-14	2003-04-14 00:00:00	2003-04-14	5001	0	\N	0	0	\N	\N	0	350302	0	55277-8	40758406		
52360	4815	3006322	1997-02-26	1997-02-26 00:00:00	1997-02-26	5001	0	\N	0	0	\N	\N	0	320329	0	8331-1	3006322		
12760	1217	3006322	2012-11-21	2012-11-21 00:00:00	2012-11-21	5001	0	\N	0	0	\N	\N	0	80139	0	8331-1	3006322		
25521	2339	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	155669	0	6106-9	3014599		
15163	1397	3019406	1977-11-27	1977-11-27 00:00:00	1977-11-27	5001	0	\N	0	0	\N	\N	0	92780	0	6158-0	3019406		
40756	3784	3011505	1993-08-24	1993-08-24 00:00:00	1993-08-24	5001	0	\N	0	0	\N	\N	0	251464	0	19926-5	3011505		
161923	4971	4133840	2004-12-28	2004-12-28 00:00:00	2004-12-28	5001	0	\N	0	0	\N	\N	0	330505	0	127783003	4133840		
52208	4799	3006322	2011-07-27	2011-07-27 00:00:00	2011-07-27	5001	0	\N	0	0	\N	\N	0	319274	0	8331-1	3006322		
35771	3279	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	217813	0	6273-7	3006451		
171890	5276	4052083	1962-06-13	1962-06-13 00:00:00	1962-06-13	5001	0	\N	0	0	\N	\N	0	350902	0	23426006	4052083		
118616	3650	4024958	1938-10-10	1938-10-10 00:00:00	1938-10-10	5001	0	\N	0	0	\N	\N	0	242899	0	117015009	4024958		
37475	1162	4024958	1959-11-08	1959-11-08 00:00:00	1959-11-08	5001	0	\N	0	0	\N	\N	0	76698	0	117015009	4024958		
11206	1082	3015076	1988-09-06	1988-09-06 00:00:00	1988-09-06	5001	0	\N	0	0	\N	\N	0	70905	0	6248-9	3015076		
26159	2402	3036780	1977-11-19	1977-11-19 00:00:00	1977-11-19	5001	0	\N	0	0	\N	\N	0	159572	0	6095-4	3036780		
103555	3181	4133840	2016-11-04	2016-11-04 00:00:00	2016-11-04	5001	0	\N	0	0	\N	\N	0	211711	0	127783003	4133840		
81408	2518	4133840	2016-01-22	2016-01-22 00:00:00	2016-01-22	5001	0	\N	0	0	\N	\N	0	166593	0	127783003	4133840		
34144	3114	3006322	1963-12-31	1963-12-31 00:00:00	1963-12-31	5001	0	\N	0	0	\N	\N	0	207122	0	8331-1	3006322		
49047	4484	3006322	1960-09-26	1960-09-26 00:00:00	1960-09-26	5001	0	\N	0	0	\N	\N	0	298459	0	8331-1	3006322		
42590	3936	3006322	1990-12-12	1990-12-12 00:00:00	1990-12-12	5001	0	\N	0	0	\N	\N	0	261643	0	8331-1	3006322		
39948	3717	3023430	1977-02-15	1977-02-15 00:00:00	1977-02-15	5001	0	\N	0	0	\N	\N	0	247065	0	6833-8	3023430		
40043	3731	3006322	1989-01-28	1989-01-28 00:00:00	1989-01-28	5001	0	\N	0	0	\N	\N	0	247939	0	8331-1	3006322		
55836	5119	3014599	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	340417	0	6106-9	3014599		
36380	3343	3023430	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	221764	0	6833-8	3023430		
31242	2858	3049273	1998-01-05	1998-01-05 00:00:00	1998-01-05	5001	0	\N	0	0	\N	\N	0	189904	0	38265-5	3049273		
169304	5196	4024958	2006-01-21	2006-01-21 00:00:00	2006-01-21	5001	0	\N	0	0	\N	\N	0	345547	0	117015009	4024958		
16898	1536	3006322	1959-07-04	1959-07-04 00:00:00	1959-07-04	5001	0	\N	0	0	\N	\N	0	102796	0	8331-1	3006322		
42769	3957	46235214	1957-01-19	1957-01-19 00:00:00	1957-01-19	5001	0	\N	0	0	\N	\N	0	263094	0	76690-7	46235214		
46282	4261	40766240	1956-11-28	1956-11-28 00:00:00	1956-11-28	5001	0	\N	0	0	\N	\N	0	282940	0	63513-6	40766240		
46863	4313	3015076	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	286336	0	6248-9	3015076		
91144	2815	4052083	2002-03-23	2002-03-23 00:00:00	2002-03-23	5001	0	\N	0	0	\N	\N	0	186556	0	23426006	4052083		
121975	3761	4052083	1987-05-29	1987-05-29 00:00:00	1987-05-29	5001	0	\N	0	0	\N	\N	0	250063	0	23426006	4052083		
58330	5343	3012494	1984-05-11	1984-05-11 00:00:00	1984-05-11	5001	0	\N	0	0	\N	\N	0	355857	0	6206-7	3012494		
21743	2002	40758406	1976-05-11	1976-05-11 00:00:00	1976-05-11	5001	0	\N	0	0	\N	\N	0	133373	0	55277-8	40758406		
33136	2988	3006322	1998-06-10	1998-06-10 00:00:00	1998-06-10	5001	0	\N	0	0	\N	\N	0	199442	0	8331-1	3006322		
39604	3676	3006322	2000-05-25	2000-05-25 00:00:00	2000-05-25	5001	0	\N	0	0	\N	\N	0	244499	0	8331-1	3006322		
5109	495	3051031	2009-07-07	2009-07-07 00:00:00	2009-07-07	5001	0	\N	0	0	\N	\N	0	33056	0	46240-8	3051031		
55086	1669	4133840	2004-03-01	2004-03-01 00:00:00	2004-03-01	5001	0	\N	0	0	\N	\N	0	112087	0	127783003	4133840		
44827	4145	3019406	2006-07-29	2006-07-29 00:00:00	2006-07-29	5001	0	\N	0	0	\N	\N	0	275533	0	6158-0	3019406		
33951	3086	3006322	1982-05-27	1982-05-27 00:00:00	1982-05-27	5001	0	\N	0	0	\N	\N	0	205444	0	8331-1	3006322		
56174	5152	3006322	1976-08-14	1976-08-14 00:00:00	1976-08-14	5001	0	\N	0	0	\N	\N	0	342637	0	8331-1	3006322		
13247	1261	3011505	2006-05-06	2006-05-06 00:00:00	2006-05-06	5001	0	\N	0	0	\N	\N	0	83136	0	19926-5	3011505		
13332	1265	3006322	2011-08-11	2011-08-11 00:00:00	2011-08-11	5001	0	\N	0	0	\N	\N	0	83423	0	8331-1	3006322		
22281	2044	46235214	1963-10-09	1963-10-09 00:00:00	1963-10-09	5001	0	\N	0	0	\N	\N	0	135955	0	76690-7	46235214		
48065	4411	3006322	2017-06-15	2017-06-15 00:00:00	2017-06-15	5001	0	\N	0	0	\N	\N	0	293166	0	8331-1	3006322		
24816	2280	3006322	1986-08-31	1986-08-31 00:00:00	1986-08-31	5001	0	\N	0	0	\N	\N	0	151566	0	8331-1	3006322		
52298	1585	4024958	1941-12-24	1941-12-24 00:00:00	1941-12-24	5001	0	\N	0	0	\N	\N	0	106296	0	117015009	4024958		
47370	4366	3006734	1982-04-19	1982-04-19 00:00:00	1982-04-19	5001	0	\N	0	0	\N	\N	0	289663	0	6189-5	3006734		
19343	1773	3021226	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	118614	0	6246-3	3021226		
149143	4572	4024958	1985-03-09	1985-03-09 00:00:00	1985-03-09	5001	0	\N	0	0	\N	\N	0	304647	0	117015009	4024958		
46468	4278	3011505	1998-01-23	1998-01-23 00:00:00	1998-01-23	5001	0	\N	0	0	\N	\N	0	283885	0	19926-5	3011505		
31377	2866	3006322	1969-12-22	1969-12-22 00:00:00	1969-12-22	5001	0	\N	0	0	\N	\N	0	190644	0	8331-1	3006322		
62163	1906	4052083	1981-03-16	1981-03-16 00:00:00	1981-03-16	5001	0	\N	0	0	\N	\N	0	126866	0	23426006	4052083		
15420	1411	3002385	1999-11-23	1999-11-23 00:00:00	1999-11-23	5001	0	\N	0	0	\N	\N	0	93967	0	30385-9	3002385		
38780	1209	4024958	2014-12-31	2014-12-31 00:00:00	2014-12-31	5001	0	\N	0	0	\N	\N	0	79434	0	117015009	4024958		
53777	4932	3027231	1976-12-03	1976-12-03 00:00:00	1976-12-03	5001	0	\N	0	0	\N	\N	0	327863	0	6276-0	3027231		
11467	1099	3001488	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	72213	0	7258-7	3001488		
81565	2522	4052083	1959-05-08	1959-05-08 00:00:00	1959-05-08	5001	0	\N	0	0	\N	\N	0	166798	0	23426006	4052083		
63289	1947	4024958	1955-06-15	1955-06-15 00:00:00	1955-06-15	5001	0	\N	0	0	\N	\N	0	129424	0	117015009	4024958		
1681	148	3006322	2011-08-09	2011-08-09 00:00:00	2011-08-09	5001	0	\N	0	0	\N	\N	0	10020	0	8331-1	3006322		
49826	4531	3049273	2004-12-25	2004-12-25 00:00:00	2004-12-25	5001	0	\N	0	0	\N	\N	0	301781	0	38265-5	3049273		
23786	2186	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	145810	0	6189-5	3006734		
50854	1542	4052083	1970-09-01	1970-09-01 00:00:00	1970-09-01	5001	0	\N	0	0	\N	\N	0	103338	0	23426006	4052083		
45864	4226	3011505	2010-01-10	2010-01-10 00:00:00	2010-01-10	5001	0	\N	0	0	\N	\N	0	280648	0	19926-5	3011505		
2617	260	3000876	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	17212	0	6082-2	3000876		
57330	5265	3006322	2007-08-23	2007-08-23 00:00:00	2007-08-23	5001	0	\N	0	0	\N	\N	0	350283	0	8331-1	3006322		
52361	4815	3006322	1995-08-19	1995-08-19 00:00:00	1995-08-19	5001	0	\N	0	0	\N	\N	0	320338	0	8331-1	3006322		
12761	1217	3011505	2006-07-14	2006-07-14 00:00:00	2006-07-14	5001	0	\N	0	0	\N	\N	0	80144	0	19926-5	3011505		
25522	2339	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	155669	0	6833-8	3023430		
15164	1397	3015076	1977-11-27	1977-11-27 00:00:00	1977-11-27	5001	0	\N	0	0	\N	\N	0	92780	0	6248-9	3015076		
40757	3784	3006322	1972-08-12	1972-08-12 00:00:00	1972-08-12	5001	0	\N	0	0	\N	\N	0	251509	0	8331-1	3006322		
36281	1124	4052083	1975-07-25	1975-07-25 00:00:00	1975-07-25	5001	0	\N	0	0	\N	\N	0	74076	0	23426006	4052083		
52209	4799	3006322	2017-11-30	2017-11-30 00:00:00	2017-11-30	5001	0	\N	0	0	\N	\N	0	319264	0	8331-1	3006322		
35772	3279	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	217813	0	6248-9	3015076		
171918	5277	4024958	1968-09-26	1968-09-26 00:00:00	1968-09-26	5001	0	\N	0	0	\N	\N	0	351041	0	117015009	4024958		
118620	3650	4052083	2002-06-08	2002-06-08 00:00:00	2002-06-08	5001	0	\N	0	0	\N	\N	0	242945	0	23426006	4052083		
37477	1162	4024958	1981-09-24	1981-09-24 00:00:00	1981-09-24	5001	0	\N	0	0	\N	\N	0	76700	0	117015009	4024958		
11207	1082	3001488	1988-09-06	1988-09-06 00:00:00	1988-09-06	5001	0	\N	0	0	\N	\N	0	70905	0	7258-7	3001488		
26160	2402	3001247	1977-11-19	1977-11-19 00:00:00	1977-11-19	5001	0	\N	0	0	\N	\N	0	159572	0	6085-5	3001247		
103561	3181	4133840	2009-09-25	2009-09-25 00:00:00	2009-09-25	5001	0	\N	0	0	\N	\N	0	211710	0	127783003	4133840		
81410	2518	4133840	2014-01-10	2014-01-10 00:00:00	2014-01-10	5001	0	\N	0	0	\N	\N	0	166592	0	127783003	4133840		
34145	3114	3006322	1958-04-03	1958-04-03 00:00:00	1958-04-03	5001	0	\N	0	0	\N	\N	0	207143	0	8331-1	3006322		
49048	4484	3006322	1986-03-14	1986-03-14 00:00:00	1986-03-14	5001	0	\N	0	0	\N	\N	0	298446	0	8331-1	3006322		
42591	3936	3006322	1977-08-18	1977-08-18 00:00:00	1977-08-18	5001	0	\N	0	0	\N	\N	0	261617	0	8331-1	3006322		
39949	3717	3001488	1977-02-15	1977-02-15 00:00:00	1977-02-15	5001	0	\N	0	0	\N	\N	0	247065	0	7258-7	3001488		
40044	3731	3006322	2012-04-11	2012-04-11 00:00:00	2012-04-11	5001	0	\N	0	0	\N	\N	0	247941	0	8331-1	3006322		
55837	5119	3019406	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	340417	0	6158-0	3019406		
36381	3343	3019406	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	221764	0	6158-0	3019406		
31243	2858	3006322	1911-12-25	1911-12-25 00:00:00	1911-12-25	5001	0	\N	0	0	\N	\N	0	189905	0	8331-1	3006322		
169306	5196	4052083	2002-09-12	2002-09-12 00:00:00	2002-09-12	5001	0	\N	0	0	\N	\N	0	345546	0	23426006	4052083		
16900	1536	3011505	1968-11-10	1968-11-10 00:00:00	1968-11-10	5001	0	\N	0	0	\N	\N	0	102845	0	19926-5	3011505		
42771	3957	40766240	1957-01-19	1957-01-19 00:00:00	1957-01-19	5001	0	\N	0	0	\N	\N	0	263094	0	63513-6	40766240		
46283	4261	46235214	1956-11-28	1956-11-28 00:00:00	1956-11-28	5001	0	\N	0	0	\N	\N	0	282940	0	76690-7	46235214		
46864	4313	3021226	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	286336	0	6246-3	3021226		
91150	2815	4024958	1969-09-20	1969-09-20 00:00:00	1969-09-20	5001	0	\N	0	0	\N	\N	0	186490	0	117015009	4024958		
121977	3761	4024958	1959-11-14	1959-11-14 00:00:00	1959-11-14	5001	0	\N	0	0	\N	\N	0	250065	0	117015009	4024958		
58331	5343	3001247	1984-05-11	1984-05-11 00:00:00	1984-05-11	5001	0	\N	0	0	\N	\N	0	355857	0	6085-5	3001247		
21744	2002	46235214	2004-10-31	2004-10-31 00:00:00	2004-10-31	5001	0	\N	0	0	\N	\N	0	133333	0	76690-7	46235214		
33138	2988	40766240	1977-10-04	1977-10-04 00:00:00	1977-10-04	5001	0	\N	0	0	\N	\N	0	199467	0	63513-6	40766240		
39605	3676	3006322	1989-08-07	1989-08-07 00:00:00	1989-08-07	5001	0	\N	0	0	\N	\N	0	244498	0	8331-1	3006322		
5110	495	40758406	2009-07-07	2009-07-07 00:00:00	2009-07-07	5001	0	\N	0	0	\N	\N	0	33056	0	55277-8	40758406		
55090	1669	4133840	2014-04-14	2014-04-14 00:00:00	2014-04-14	5001	0	\N	0	0	\N	\N	0	112117	0	127783003	4133840		
44828	4145	3006322	1994-02-05	1994-02-05 00:00:00	1994-02-05	5001	0	\N	0	0	\N	\N	0	275532	0	8331-1	3006322		
33952	3086	3006322	1985-12-18	1985-12-18 00:00:00	1985-12-18	5001	0	\N	0	0	\N	\N	0	205437	0	8331-1	3006322		
56175	5152	3006322	2001-10-25	2001-10-25 00:00:00	2001-10-25	5001	0	\N	0	0	\N	\N	0	342618	0	8331-1	3006322		
13248	1261	3011505	2015-11-28	2015-11-28 00:00:00	2015-11-28	5001	0	\N	0	0	\N	\N	0	83131	0	19926-5	3011505		
13333	1265	3006734	1983-06-08	1983-06-08 00:00:00	1983-06-08	5001	0	\N	0	0	\N	\N	0	83401	0	6189-5	3006734		
22282	2044	3051031	1963-12-08	1963-12-08 00:00:00	1963-12-08	5001	0	\N	0	0	\N	\N	0	135964	0	46240-8	3051031		
48066	4411	3006322	1947-01-08	1947-01-08 00:00:00	1947-01-08	5001	0	\N	0	0	\N	\N	0	293175	0	8331-1	3006322		
24817	2280	3006322	1985-09-24	1985-09-24 00:00:00	1985-09-24	5001	0	\N	0	0	\N	\N	0	151565	0	8331-1	3006322		
52299	1585	4024958	2011-06-23	2011-06-23 00:00:00	2011-06-23	5001	0	\N	0	0	\N	\N	0	106261	0	117015009	4024958		
47371	4366	3036780	1982-04-19	1982-04-19 00:00:00	1982-04-19	5001	0	\N	0	0	\N	\N	0	289663	0	6095-4	3036780		
19344	1773	3000876	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	118614	0	6082-2	3000876		
149155	4574	4024958	1990-06-24	1990-06-24 00:00:00	1990-06-24	5001	0	\N	0	0	\N	\N	0	304740	0	117015009	4024958		
46469	4278	3011505	2004-09-17	2004-09-17 00:00:00	2004-09-17	5001	0	\N	0	0	\N	\N	0	283865	0	19926-5	3011505		
31378	2867	3006322	1982-11-11	1982-11-11 00:00:00	1982-11-11	5001	0	\N	0	0	\N	\N	0	190701	0	8331-1	3006322		
62164	1906	4024958	1963-04-04	1963-04-04 00:00:00	1963-04-04	5001	0	\N	0	0	\N	\N	0	126863	0	117015009	4024958		
15421	1411	3024731	1999-11-23	1999-11-23 00:00:00	1999-11-23	5001	0	\N	0	0	\N	\N	0	93967	0	30428-7	3024731		
22089	695	4052083	1974-10-21	1974-10-21 00:00:00	1974-10-21	5001	0	\N	0	0	\N	\N	0	45989	0	23426006	4052083		
53778	4932	3014599	1976-12-03	1976-12-03 00:00:00	1976-12-03	5001	0	\N	0	0	\N	\N	0	327863	0	6106-9	3014599		
11468	1099	3023430	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	72213	0	6833-8	3023430		
81570	2522	4052083	1970-06-23	1970-06-23 00:00:00	1970-06-23	5001	0	\N	0	0	\N	\N	0	166799	0	23426006	4052083		
63292	1947	4052083	1950-02-11	1950-02-11 00:00:00	1950-02-11	5001	0	\N	0	0	\N	\N	0	129423	0	23426006	4052083		
1682	148	3006322	1991-09-09	1991-09-09 00:00:00	1991-09-09	5001	0	\N	0	0	\N	\N	0	10008	0	8331-1	3006322		
49827	4532	3006322	1937-01-17	1937-01-17 00:00:00	1937-01-17	5001	0	\N	0	0	\N	\N	0	301906	0	8331-1	3006322		
23787	2186	3000876	1975-03-07	1975-03-07 00:00:00	1975-03-07	5001	0	\N	0	0	\N	\N	0	145721	0	6082-2	3000876		
34497	3149	3006322	2009-02-25	2009-02-25 00:00:00	2009-02-25	5001	0	\N	0	0	\N	\N	0	209544	0	8331-1	3006322		
45865	4226	3006322	1992-08-04	1992-08-04 00:00:00	1992-08-04	5001	0	\N	0	0	\N	\N	0	280771	0	8331-1	3006322		
2618	260	3027231	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	17212	0	6276-0	3027231		
57331	5265	3051031	2003-06-13	2003-06-13 00:00:00	2003-06-13	5001	0	\N	0	0	\N	\N	0	350282	0	46240-8	3051031		
52362	4815	3006322	2001-10-12	2001-10-12 00:00:00	2001-10-12	5001	0	\N	0	0	\N	\N	0	320339	0	8331-1	3006322		
12762	1217	3011505	2015-01-09	2015-01-09 00:00:00	2015-01-09	5001	0	\N	0	0	\N	\N	0	80186	0	19926-5	3011505		
25523	2339	3006322	1997-08-08	1997-08-08 00:00:00	1997-08-08	5001	0	\N	0	0	\N	\N	0	155631	0	8331-1	3006322		
15165	1397	3006734	1977-11-27	1977-11-27 00:00:00	1977-11-27	5001	0	\N	0	0	\N	\N	0	92780	0	6189-5	3006734		
40758	3784	3011505	1990-08-07	1990-08-07 00:00:00	1990-08-07	5001	0	\N	0	0	\N	\N	0	251534	0	19926-5	3011505		
36293	1125	4052083	2006-02-24	2006-02-24 00:00:00	2006-02-24	5001	0	\N	0	0	\N	\N	0	74198	0	23426006	4052083		
52210	4799	3006322	1970-02-14	1970-02-14 00:00:00	1970-02-14	5001	0	\N	0	0	\N	\N	0	319203	0	8331-1	3006322		
35773	3279	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	217813	0	6075-6	3005136		
171926	5277	4052083	1998-08-05	1998-08-05 00:00:00	1998-08-05	5001	0	\N	0	0	\N	\N	0	351032	0	23426006	4052083		
118625	3650	4052083	1955-09-30	1955-09-30 00:00:00	1955-09-30	5001	0	\N	0	0	\N	\N	0	242987	0	23426006	4052083		
37478	1162	4024958	1987-12-01	1987-12-01 00:00:00	1987-12-01	5001	0	\N	0	0	\N	\N	0	76701	0	117015009	4024958		
11208	1082	3014599	1988-09-06	1988-09-06 00:00:00	1988-09-06	5001	0	\N	0	0	\N	\N	0	70905	0	6106-9	3014599		
26161	2402	3019406	1977-11-19	1977-11-19 00:00:00	1977-11-19	5001	0	\N	0	0	\N	\N	0	159572	0	6158-0	3019406		
103564	3181	4133840	2015-10-30	2015-10-30 00:00:00	2015-10-30	5001	0	\N	0	0	\N	\N	0	211718	0	127783003	4133840		
81414	2518	4133840	1989-12-01	1989-12-01 00:00:00	1989-12-01	5001	0	\N	0	0	\N	\N	0	166516	0	127783003	4133840		
34146	3114	3006322	1980-09-07	1980-09-07 00:00:00	1980-09-07	5001	0	\N	0	0	\N	\N	0	207113	0	8331-1	3006322		
49049	4484	3006322	2012-02-25	2012-02-25 00:00:00	2012-02-25	5001	0	\N	0	0	\N	\N	0	298496	0	8331-1	3006322		
42592	3936	3006322	1959-06-04	1959-06-04 00:00:00	1959-06-04	5001	0	\N	0	0	\N	\N	0	261638	0	8331-1	3006322		
39950	3717	3001247	1977-02-15	1977-02-15 00:00:00	1977-02-15	5001	0	\N	0	0	\N	\N	0	247065	0	6085-5	3001247		
40045	3732	3006322	2010-11-01	2010-11-01 00:00:00	2010-11-01	5001	0	\N	0	0	\N	\N	0	247980	0	8331-1	3006322		
55838	5119	3015076	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	340417	0	6248-9	3015076		
36382	3343	3015076	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	221764	0	6248-9	3015076		
31244	2858	3006322	1962-11-02	1962-11-02 00:00:00	1962-11-02	5001	0	\N	0	0	\N	\N	0	189742	0	8331-1	3006322		
169312	5197	4024958	1971-04-20	1971-04-20 00:00:00	1971-04-20	5001	0	\N	0	0	\N	\N	0	345626	0	117015009	4024958		
16901	1536	3011505	1967-02-26	1967-02-26 00:00:00	1967-02-26	5001	0	\N	0	0	\N	\N	0	102844	0	19926-5	3011505		
42773	3957	3051031	1966-09-09	1966-09-09 00:00:00	1966-09-09	5001	0	\N	0	0	\N	\N	0	263045	0	46240-8	3051031		
46287	4261	3051031	1956-09-29	1956-09-29 00:00:00	1956-09-29	5001	0	\N	0	0	\N	\N	0	282938	0	46240-8	3051031		
46865	4313	3000876	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	286336	0	6082-2	3000876		
91151	2815	4024958	1965-08-02	1965-08-02 00:00:00	1965-08-02	5001	0	\N	0	0	\N	\N	0	186546	0	117015009	4024958		
121978	3761	4052083	2002-03-18	2002-03-18 00:00:00	2002-03-18	5001	0	\N	0	0	\N	\N	0	250055	0	23426006	4052083		
58332	5343	3036780	1984-05-11	1984-05-11 00:00:00	1984-05-11	5001	0	\N	0	0	\N	\N	0	355857	0	6095-4	3036780		
21745	2002	40766240	2004-10-31	2004-10-31 00:00:00	2004-10-31	5001	0	\N	0	0	\N	\N	0	133333	0	63513-6	40766240		
33139	2988	40758406	1977-10-04	1977-10-04 00:00:00	1977-10-04	5001	0	\N	0	0	\N	\N	0	199467	0	55277-8	40758406		
39606	3678	3006322	2004-04-08	2004-04-08 00:00:00	2004-04-08	5001	0	\N	0	0	\N	\N	0	244583	0	8331-1	3006322		
5111	495	46235214	2009-07-07	2009-07-07 00:00:00	2009-07-07	5001	0	\N	0	0	\N	\N	0	33056	0	76690-7	46235214		
55092	1669	4133840	2006-03-06	2006-03-06 00:00:00	2006-03-06	5001	0	\N	0	0	\N	\N	0	112106	0	127783003	4133840		
44829	4145	3027231	2010-01-30	2010-01-30 00:00:00	2010-01-30	5001	0	\N	0	0	\N	\N	0	275481	0	6276-0	3027231		
33953	3086	3006322	1993-12-14	1993-12-14 00:00:00	1993-12-14	5001	0	\N	0	0	\N	\N	0	205428	0	8331-1	3006322		
56176	5153	3006322	1998-04-02	1998-04-02 00:00:00	1998-04-02	5001	0	\N	0	0	\N	\N	0	342670	0	8331-1	3006322		
13249	1261	3011505	2005-07-09	2005-07-09 00:00:00	2005-07-09	5001	0	\N	0	0	\N	\N	0	83130	0	19926-5	3011505		
13334	1265	3012494	1983-06-08	1983-06-08 00:00:00	1983-06-08	5001	0	\N	0	0	\N	\N	0	83401	0	6206-7	3012494		
22283	2044	40766240	1963-12-08	1963-12-08 00:00:00	1963-12-08	5001	0	\N	0	0	\N	\N	0	135964	0	63513-6	40766240		
48067	4411	3006322	2003-05-15	2003-05-15 00:00:00	2003-05-15	5001	0	\N	0	0	\N	\N	0	293203	0	8331-1	3006322		
24818	2280	40769194	1975-06-11	1975-06-11 00:00:00	1975-06-11	5001	0	\N	0	0	\N	\N	0	151585	0	66534-9	40769194		
52310	1585	4052083	1976-03-26	1976-03-26 00:00:00	1976-03-26	5001	0	\N	0	0	\N	\N	0	106274	0	23426006	4052083		
47372	4366	3021226	1982-04-19	1982-04-19 00:00:00	1982-04-19	5001	0	\N	0	0	\N	\N	0	289663	0	6246-3	3021226		
19345	1773	3001247	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	118614	0	6085-5	3001247		
103854	3191	4052083	1993-05-07	1993-05-07 00:00:00	1993-05-07	5001	0	\N	0	0	\N	\N	0	212350	0	23426006	4052083		
46470	4278	3006322	1963-11-27	1963-11-27 00:00:00	1963-11-27	5001	0	\N	0	0	\N	\N	0	283904	0	8331-1	3006322		
31379	2867	3006322	1979-09-13	1979-09-13 00:00:00	1979-09-13	5001	0	\N	0	0	\N	\N	0	190740	0	8331-1	3006322		
62166	1906	4024958	1970-02-08	1970-02-08 00:00:00	1970-02-08	5001	0	\N	0	0	\N	\N	0	126912	0	117015009	4024958		
15422	1411	3006906	1999-11-23	1999-11-23 00:00:00	1999-11-23	5001	0	\N	0	0	\N	\N	0	93967	0	17861-6	3006906		
22129	697	4052083	1973-08-01	1973-08-01 00:00:00	1973-08-01	5001	0	\N	0	0	\N	\N	0	46125	0	23426006	4052083		
53779	4932	3006451	1976-12-03	1976-12-03 00:00:00	1976-12-03	5001	0	\N	0	0	\N	\N	0	327863	0	6273-7	3006451		
11469	1099	3005136	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	72213	0	6075-6	3005136		
81573	2522	4024958	1979-11-01	1979-11-01 00:00:00	1979-11-01	5001	0	\N	0	0	\N	\N	0	166793	0	117015009	4024958		
63298	1947	4052083	1995-05-16	1995-05-16 00:00:00	1995-05-16	5001	0	\N	0	0	\N	\N	0	129404	0	23426006	4052083		
1683	149	3006322	2005-06-20	2005-06-20 00:00:00	2005-06-20	5001	0	\N	0	0	\N	\N	0	10050	0	8331-1	3006322		
49828	4532	3049273	1984-03-03	1984-03-03 00:00:00	1984-03-03	5001	0	\N	0	0	\N	\N	0	301893	0	38265-5	3049273		
23788	2186	3006451	1975-03-07	1975-03-07 00:00:00	1975-03-07	5001	0	\N	0	0	\N	\N	0	145721	0	6273-7	3006451		
34498	3149	3006322	1996-10-04	1996-10-04 00:00:00	1996-10-04	5001	0	\N	0	0	\N	\N	0	209543	0	8331-1	3006322		
45866	4226	3006322	1967-06-27	1967-06-27 00:00:00	1967-06-27	5001	0	\N	0	0	\N	\N	0	280650	0	8331-1	3006322		
2619	260	3001247	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	17212	0	6085-5	3001247		
57332	5265	40758406	2003-06-13	2003-06-13 00:00:00	2003-06-13	5001	0	\N	0	0	\N	\N	0	350282	0	55277-8	40758406		
52363	4815	3006322	1970-12-31	1970-12-31 00:00:00	1970-12-31	5001	0	\N	0	0	\N	\N	0	320318	0	8331-1	3006322		
12763	1217	3011505	2012-12-07	2012-12-07 00:00:00	2012-12-07	5001	0	\N	0	0	\N	\N	0	80133	0	19926-5	3011505		
25524	2339	3006322	1986-02-24	1986-02-24 00:00:00	1986-02-24	5001	0	\N	0	0	\N	\N	0	155598	0	8331-1	3006322		
15166	1397	3005136	1977-11-27	1977-11-27 00:00:00	1977-11-27	5001	0	\N	0	0	\N	\N	0	92780	0	6075-6	3005136		
40759	3784	3011505	1982-07-20	1982-07-20 00:00:00	1982-07-20	5001	0	\N	0	0	\N	\N	0	251531	0	19926-5	3011505		
36315	1125	4052083	1958-09-11	1958-09-11 00:00:00	1958-09-11	5001	0	\N	0	0	\N	\N	0	74195	0	23426006	4052083		
52211	4800	3006322	1997-08-20	1997-08-20 00:00:00	1997-08-20	5001	0	\N	0	0	\N	\N	0	319344	0	8331-1	3006322		
35774	3279	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	217813	0	6206-7	3012494		
171941	5278	4024958	2006-01-24	2006-01-24 00:00:00	2006-01-24	5001	0	\N	0	0	\N	\N	0	351097	0	117015009	4024958		
118635	3650	4024958	1940-11-06	1940-11-06 00:00:00	1940-11-06	5001	0	\N	0	0	\N	\N	0	242900	0	117015009	4024958		
37479	1162	4052083	1933-09-13	1933-09-13 00:00:00	1933-09-13	5001	0	\N	0	0	\N	\N	0	76695	0	23426006	4052083		
11209	1082	3012494	1988-09-06	1988-09-06 00:00:00	1988-09-06	5001	0	\N	0	0	\N	\N	0	70905	0	6206-7	3012494		
26162	2402	3021226	1977-11-19	1977-11-19 00:00:00	1977-11-19	5001	0	\N	0	0	\N	\N	0	159572	0	6246-3	3021226		
103566	3181	4052083	1977-11-06	1977-11-06 00:00:00	1977-11-06	5001	0	\N	0	0	\N	\N	0	211733	0	23426006	4052083		
81417	2518	4133840	1980-11-21	1980-11-21 00:00:00	1980-11-21	5001	0	\N	0	0	\N	\N	0	166547	0	127783003	4133840		
34147	3114	3006322	1979-07-05	1979-07-05 00:00:00	1979-07-05	5001	0	\N	0	0	\N	\N	0	207123	0	8331-1	3006322		
49050	4484	3006322	2000-05-10	2000-05-10 00:00:00	2000-05-10	5001	0	\N	0	0	\N	\N	0	298463	0	8331-1	3006322		
42593	3936	3006322	1987-08-09	1987-08-09 00:00:00	1987-08-09	5001	0	\N	0	0	\N	\N	0	261642	0	8331-1	3006322		
39951	3717	3019406	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	247016	0	6158-0	3019406		
40046	3732	3006322	1972-09-25	1972-09-25 00:00:00	1972-09-25	5001	0	\N	0	0	\N	\N	0	247957	0	8331-1	3006322		
55839	5119	3001247	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	340417	0	6085-5	3001247		
36383	3343	3027231	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	221764	0	6276-0	3027231		
31245	2858	3006322	1962-04-23	1962-04-23 00:00:00	1962-04-23	5001	0	\N	0	0	\N	\N	0	189741	0	8331-1	3006322		
169322	5197	4052083	1954-06-17	1954-06-17 00:00:00	1954-06-17	5001	0	\N	0	0	\N	\N	0	345578	0	23426006	4052083		
16902	1536	3006322	1915-04-14	1915-04-14 00:00:00	1915-04-14	5001	0	\N	0	0	\N	\N	0	102792	0	8331-1	3006322		
42774	3957	46235214	1966-09-09	1966-09-09 00:00:00	1966-09-09	5001	0	\N	0	0	\N	\N	0	263045	0	76690-7	46235214		
46288	4261	40766240	1956-09-29	1956-09-29 00:00:00	1956-09-29	5001	0	\N	0	0	\N	\N	0	282938	0	63513-6	40766240		
46866	4313	3036780	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	286336	0	6095-4	3036780		
171484	5262	4052083	1983-12-27	1983-12-27 00:00:00	1983-12-27	5001	0	\N	0	0	\N	\N	0	350101	0	23426006	4052083		
121980	3761	4024958	1960-12-09	1960-12-09 00:00:00	1960-12-09	5001	0	\N	0	0	\N	\N	0	250095	0	117015009	4024958		
58333	5343	3000876	1999-07-11	1999-07-11 00:00:00	1999-07-11	5001	0	\N	0	0	\N	\N	0	355823	0	6082-2	3000876		
21746	2002	40758406	2004-10-31	2004-10-31 00:00:00	2004-10-31	5001	0	\N	0	0	\N	\N	0	133333	0	55277-8	40758406		
33140	2988	46235214	1977-10-04	1977-10-04 00:00:00	1977-10-04	5001	0	\N	0	0	\N	\N	0	199467	0	76690-7	46235214		
39607	3678	3006322	2014-09-07	2014-09-07 00:00:00	2014-09-07	5001	0	\N	0	0	\N	\N	0	244588	0	8331-1	3006322		
5113	495	40766240	2009-07-07	2009-07-07 00:00:00	2009-07-07	5001	0	\N	0	0	\N	\N	0	33056	0	63513-6	40766240		
55096	1669	4133840	2010-03-22	2010-03-22 00:00:00	2010-03-22	5001	0	\N	0	0	\N	\N	0	112081	0	127783003	4133840		
44830	4145	3014599	2010-01-30	2010-01-30 00:00:00	2010-01-30	5001	0	\N	0	0	\N	\N	0	275481	0	6106-9	3014599		
33954	3086	3006322	1974-07-14	1974-07-14 00:00:00	1974-07-14	5001	0	\N	0	0	\N	\N	0	205427	0	8331-1	3006322		
56177	5153	3006322	1972-01-07	1972-01-07 00:00:00	1972-01-07	5001	0	\N	0	0	\N	\N	0	342679	0	8331-1	3006322		
13250	1261	3011505	2013-11-23	2013-11-23 00:00:00	2013-11-23	5001	0	\N	0	0	\N	\N	0	83135	0	19926-5	3011505		
36575	3364	40769189	2000-06-26	2000-06-26 00:00:00	2000-06-26	5001	0	\N	0	0	\N	\N	0	223064	0	66529-9	40769189		
22286	2044	46235214	1963-12-08	1963-12-08 00:00:00	1963-12-08	5001	0	\N	0	0	\N	\N	0	135964	0	76690-7	46235214		
48068	4411	3006322	1961-03-18	1961-03-18 00:00:00	1961-03-18	5001	0	\N	0	0	\N	\N	0	293177	0	8331-1	3006322		
24819	2280	40769189	1975-06-11	1975-06-11 00:00:00	1975-06-11	5001	0	\N	0	0	\N	\N	0	151585	0	66529-9	40769189		
52315	1585	4024958	1973-02-25	1973-02-25 00:00:00	1973-02-25	5001	0	\N	0	0	\N	\N	0	106273	0	117015009	4024958		
47373	4366	3019406	1982-04-19	1982-04-19 00:00:00	1982-04-19	5001	0	\N	0	0	\N	\N	0	289663	0	6158-0	3019406		
19346	1773	3005136	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	118614	0	6075-6	3005136		
103855	3191	4052083	2013-10-08	2013-10-08 00:00:00	2013-10-08	5001	0	\N	0	0	\N	\N	0	212337	0	23426006	4052083		
46471	4278	3011505	2000-08-25	2000-08-25 00:00:00	2000-08-25	5001	0	\N	0	0	\N	\N	0	283888	0	19926-5	3011505		
31380	2867	3006322	1989-06-19	1989-06-19 00:00:00	1989-06-19	5001	0	\N	0	0	\N	\N	0	190742	0	8331-1	3006322		
62178	1906	4024958	2012-03-26	2012-03-26 00:00:00	2012-03-26	5001	0	\N	0	0	\N	\N	0	126913	0	117015009	4024958		
15423	1411	3035995	1999-11-23	1999-11-23 00:00:00	1999-11-23	5001	0	\N	0	0	\N	\N	0	93967	0	6768-6	3035995		
22131	697	4052083	1986-04-16	1986-04-16 00:00:00	1986-04-16	5001	0	\N	0	0	\N	\N	0	46121	0	23426006	4052083		
53780	4932	3006322	2008-01-11	2008-01-11 00:00:00	2008-01-11	5001	0	\N	0	0	\N	\N	0	327923	0	8331-1	3006322		
11470	1099	3015076	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	72213	0	6248-9	3015076		
93092	2865	4052083	2002-07-31	2002-07-31 00:00:00	2002-07-31	5001	0	\N	0	0	\N	\N	0	190600	0	23426006	4052083		
63309	1947	4024958	1959-08-13	1959-08-13 00:00:00	1959-08-13	5001	0	\N	0	0	\N	\N	0	129481	0	117015009	4024958		
1684	149	3006322	1971-07-10	1971-07-10 00:00:00	1971-07-10	5001	0	\N	0	0	\N	\N	0	10048	0	8331-1	3006322		
49829	4532	3006322	1911-04-27	1911-04-27 00:00:00	1911-04-27	5001	0	\N	0	0	\N	\N	0	301912	0	8331-1	3006322		
23789	2186	3015076	1975-03-07	1975-03-07 00:00:00	1975-03-07	5001	0	\N	0	0	\N	\N	0	145721	0	6248-9	3015076		
34499	3149	3006322	1968-10-17	1968-10-17 00:00:00	1968-10-17	5001	0	\N	0	0	\N	\N	0	209524	0	8331-1	3006322		
45867	4226	3011505	2015-02-01	2015-02-01 00:00:00	2015-02-01	5001	0	\N	0	0	\N	\N	0	280684	0	19926-5	3011505		
2620	260	3001488	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	17212	0	7258-7	3001488		
57333	5265	46235214	2003-06-13	2003-06-13 00:00:00	2003-06-13	5001	0	\N	0	0	\N	\N	0	350282	0	76690-7	46235214		
52364	4815	3006322	1992-03-21	1992-03-21 00:00:00	1992-03-21	5001	0	\N	0	0	\N	\N	0	320328	0	8331-1	3006322		
12764	1217	3011505	2009-12-25	2009-12-25 00:00:00	2009-12-25	5001	0	\N	0	0	\N	\N	0	80196	0	19926-5	3011505		
25525	2339	3006451	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	155630	0	6273-7	3006451		
15167	1397	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	92751	0	7258-7	3001488		
40760	3784	3006322	1987-07-07	1987-07-07 00:00:00	1987-07-07	5001	0	\N	0	0	\N	\N	0	251495	0	8331-1	3006322		
116654	3595	4052083	1957-07-03	1957-07-03 00:00:00	1957-07-03	5001	0	\N	0	0	\N	\N	0	238774	0	23426006	4052083		
52212	4800	3006322	1975-03-22	1975-03-22 00:00:00	1975-03-22	5001	0	\N	0	0	\N	\N	0	319328	0	8331-1	3006322		
35775	3279	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	217813	0	7258-7	3001488		
80552	2485	4024958	1937-04-10	1937-04-10 00:00:00	1937-04-10	5001	0	\N	0	0	\N	\N	0	164672	0	117015009	4024958		
118636	3650	4052083	1935-04-03	1935-04-03 00:00:00	1935-04-03	5001	0	\N	0	0	\N	\N	0	242940	0	23426006	4052083		
37500	1162	4052083	1994-07-27	1994-07-27 00:00:00	1994-07-27	5001	0	\N	0	0	\N	\N	0	76715	0	23426006	4052083		
11210	1082	3005136	1988-09-06	1988-09-06 00:00:00	1988-09-06	5001	0	\N	0	0	\N	\N	0	70905	0	6075-6	3005136		
26163	2402	3006451	1977-11-19	1977-11-19 00:00:00	1977-11-19	5001	0	\N	0	0	\N	\N	0	159572	0	6273-7	3006451		
103567	3181	4133840	2004-08-27	2004-08-27 00:00:00	2004-08-27	5001	0	\N	0	0	\N	\N	0	211679	0	127783003	4133840		
81418	2518	4133840	1999-06-25	1999-06-25 00:00:00	1999-06-25	5001	0	\N	0	0	\N	\N	0	166573	0	127783003	4133840		
34148	3114	3006322	1988-07-09	1988-07-09 00:00:00	1988-07-09	5001	0	\N	0	0	\N	\N	0	207182	0	8331-1	3006322		
49051	4484	3006322	2009-12-27	2009-12-27 00:00:00	2009-12-27	5001	0	\N	0	0	\N	\N	0	298495	0	8331-1	3006322		
42594	3936	3006322	2012-08-13	2012-08-13 00:00:00	2012-08-13	5001	0	\N	0	0	\N	\N	0	261640	0	8331-1	3006322		
39952	3717	3015076	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	247016	0	6248-9	3015076		
40047	3732	3006322	1961-07-16	1961-07-16 00:00:00	1961-07-16	5001	0	\N	0	0	\N	\N	0	247998	0	8331-1	3006322		
55840	5119	3006734	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	340417	0	6189-5	3006734		
36384	3343	3014599	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	221764	0	6106-9	3014599		
31246	2858	3006322	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	189956	0	8331-1	3006322		
169327	5197	4052083	1966-09-28	1966-09-28 00:00:00	1966-09-28	5001	0	\N	0	0	\N	\N	0	345580	0	23426006	4052083		
16903	1536	3011505	1966-02-20	1966-02-20 00:00:00	1966-02-20	5001	0	\N	0	0	\N	\N	0	102775	0	19926-5	3011505		
42775	3957	40766240	1966-09-09	1966-09-09 00:00:00	1966-09-09	5001	0	\N	0	0	\N	\N	0	263045	0	63513-6	40766240		
46289	4261	46235214	1956-09-29	1956-09-29 00:00:00	1956-09-29	5001	0	\N	0	0	\N	\N	0	282938	0	76690-7	46235214		
46867	4313	3012494	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	286336	0	6206-7	3012494		
171495	5262	4024958	2003-04-14	2003-04-14 00:00:00	2003-04-14	5001	0	\N	0	0	\N	\N	0	350113	0	117015009	4024958		
121981	3761	4024958	1960-09-27	1960-09-27 00:00:00	1960-09-27	5001	0	\N	0	0	\N	\N	0	250066	0	117015009	4024958		
58334	5343	3001247	1999-07-11	1999-07-11 00:00:00	1999-07-11	5001	0	\N	0	0	\N	\N	0	355823	0	6085-5	3001247		
21748	2002	3051031	2004-10-31	2004-10-31 00:00:00	2004-10-31	5001	0	\N	0	0	\N	\N	0	133333	0	46240-8	3051031		
33141	2988	3051031	1977-10-04	1977-10-04 00:00:00	1977-10-04	5001	0	\N	0	0	\N	\N	0	199467	0	46240-8	3051031		
39608	3678	3006322	1982-03-27	1982-03-27 00:00:00	1982-03-27	5001	0	\N	0	0	\N	\N	0	244579	0	8331-1	3006322		
5115	495	3006322	1978-03-13	1978-03-13 00:00:00	1978-03-13	5001	0	\N	0	0	\N	\N	0	33078	0	8331-1	3006322		
55098	1669	4133840	2000-02-21	2000-02-21 00:00:00	2000-02-21	5001	0	\N	0	0	\N	\N	0	112079	0	127783003	4133840		
44831	4145	3006734	2010-01-30	2010-01-30 00:00:00	2010-01-30	5001	0	\N	0	0	\N	\N	0	275481	0	6189-5	3006734		
33955	3086	3006322	1971-10-14	1971-10-14 00:00:00	1971-10-14	5001	0	\N	0	0	\N	\N	0	205443	0	8331-1	3006322		
56189	5157	3006322	1991-12-24	1991-12-24 00:00:00	1991-12-24	5001	0	\N	0	0	\N	\N	0	342882	0	8331-1	3006322		
13251	1261	40769184	1989-05-20	1989-05-20 00:00:00	1989-05-20	5001	0	\N	0	0	\N	\N	0	83247	0	66524-0	40769184		
36576	3364	3006322	1988-01-24	1988-01-24 00:00:00	1988-01-24	5001	0	\N	0	0	\N	\N	0	223109	0	8331-1	3006322		
22287	2044	40758406	1963-12-08	1963-12-08 00:00:00	1963-12-08	5001	0	\N	0	0	\N	\N	0	135964	0	55277-8	40758406		
48069	4411	3049273	2014-11-24	2014-11-24 00:00:00	2014-11-24	5001	0	\N	0	0	\N	\N	0	293251	0	38265-5	3049273		
24820	2280	40769184	1975-06-11	1975-06-11 00:00:00	1975-06-11	5001	0	\N	0	0	\N	\N	0	151585	0	66524-0	40769184		
52326	1585	4052083	1953-12-30	1953-12-30 00:00:00	1953-12-30	5001	0	\N	0	0	\N	\N	0	106256	0	23426006	4052083		
47374	4366	3015076	1982-04-19	1982-04-19 00:00:00	1982-04-19	5001	0	\N	0	0	\N	\N	0	289663	0	6248-9	3015076		
19347	1773	3014599	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	118614	0	6106-9	3014599		
103859	3191	4024958	1996-10-13	1996-10-13 00:00:00	1996-10-13	5001	0	\N	0	0	\N	\N	0	212333	0	117015009	4024958		
151414	4641	4024958	2012-03-22	2012-03-22 00:00:00	2012-03-22	5001	0	\N	0	0	\N	\N	0	309307	0	117015009	4024958		
31382	2868	3006322	1969-08-21	1969-08-21 00:00:00	1969-08-21	5001	0	\N	0	0	\N	\N	0	190802	0	8331-1	3006322		
62180	1906	4052083	1975-10-27	1975-10-27 00:00:00	1975-10-27	5001	0	\N	0	0	\N	\N	0	126865	0	23426006	4052083		
15424	1411	21494966	1999-11-23	1999-11-23 00:00:00	1999-11-23	5001	0	\N	0	0	\N	\N	0	93967	0	80271-0	21494966		
22132	697	4052083	2016-06-24	2016-06-24 00:00:00	2016-06-24	5001	0	\N	0	0	\N	\N	0	46124	0	23426006	4052083		
53781	4932	3006322	2019-04-24	2019-04-24 00:00:00	2019-04-24	5001	0	\N	0	0	\N	\N	0	327829	0	8331-1	3006322		
11471	1099	3012494	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	72213	0	6206-7	3012494		
93098	2865	4024958	1993-06-06	1993-06-06 00:00:00	1993-06-06	5001	0	\N	0	0	\N	\N	0	190599	0	117015009	4024958		
63313	1947	4052083	1951-12-17	1951-12-17 00:00:00	1951-12-17	5001	0	\N	0	0	\N	\N	0	129391	0	23426006	4052083		
1685	149	3006322	2016-12-02	2016-12-02 00:00:00	2016-12-02	5001	0	\N	0	0	\N	\N	0	10030	0	8331-1	3006322		
49832	4532	3006322	1955-02-25	1955-02-25 00:00:00	1955-02-25	5001	0	\N	0	0	\N	\N	0	301907	0	8331-1	3006322		
23790	2186	3012494	1975-03-07	1975-03-07 00:00:00	1975-03-07	5001	0	\N	0	0	\N	\N	0	145721	0	6206-7	3012494		
34500	3149	3049273	2012-11-22	2012-11-22 00:00:00	2012-11-22	5001	0	\N	0	0	\N	\N	0	209567	0	38265-5	3049273		
45868	4226	3011505	2016-11-13	2016-11-13 00:00:00	2016-11-13	5001	0	\N	0	0	\N	\N	0	280644	0	19926-5	3011505		
2621	260	3023430	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	17212	0	6833-8	3023430		
57336	5265	40766240	2003-06-13	2003-06-13 00:00:00	2003-06-13	5001	0	\N	0	0	\N	\N	0	350282	0	63513-6	40766240		
52371	4819	3006322	1965-09-10	1965-09-10 00:00:00	1965-09-10	5001	0	\N	0	0	\N	\N	0	320521	0	8331-1	3006322		
12765	1217	3011505	2017-01-13	2017-01-13 00:00:00	2017-01-13	5001	0	\N	0	0	\N	\N	0	80147	0	19926-5	3011505		
25526	2339	3001488	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	155630	0	7258-7	3001488		
15168	1397	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	92751	0	6844-5	3020655		
40761	3784	3011505	1988-07-26	1988-07-26 00:00:00	1988-07-26	5001	0	\N	0	0	\N	\N	0	251533	0	19926-5	3011505		
2234	66	4052083	1972-04-16	1972-04-16 00:00:00	1972-04-16	5001	0	\N	0	0	\N	\N	0	4475	0	23426006	4052083		
52213	4800	3006322	1980-08-03	1980-08-03 00:00:00	1980-08-03	5001	0	\N	0	0	\N	\N	0	319342	0	8331-1	3006322		
35776	3279	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	217813	0	6095-4	3036780		
80576	2485	4052083	1924-07-25	1924-07-25 00:00:00	1924-07-25	5001	0	\N	0	0	\N	\N	0	164593	0	23426006	4052083		
118643	3650	4052083	1931-03-08	1931-03-08 00:00:00	1931-03-08	5001	0	\N	0	0	\N	\N	0	242964	0	23426006	4052083		
37504	1162	4024958	1931-08-01	1931-08-01 00:00:00	1931-08-01	5001	0	\N	0	0	\N	\N	0	76694	0	117015009	4024958		
11211	1082	3020655	1988-09-06	1988-09-06 00:00:00	1988-09-06	5001	0	\N	0	0	\N	\N	0	70905	0	6844-5	3020655		
26164	2402	3012494	1977-11-19	1977-11-19 00:00:00	1977-11-19	5001	0	\N	0	0	\N	\N	0	159572	0	6206-7	3012494		
158826	4883	4024958	1955-03-19	1955-03-19 00:00:00	1955-03-19	5001	0	\N	0	0	\N	\N	0	324701	0	117015009	4024958		
81420	2518	4024958	1993-12-21	1993-12-21 00:00:00	1993-12-21	5001	0	\N	0	0	\N	\N	0	166506	0	117015009	4024958		
34149	3114	3006322	1960-02-07	1960-02-07 00:00:00	1960-02-07	5001	0	\N	0	0	\N	\N	0	207144	0	8331-1	3006322		
49052	4484	3006322	1963-09-21	1963-09-21 00:00:00	1963-09-21	5001	0	\N	0	0	\N	\N	0	298444	0	8331-1	3006322		
42599	3938	3006322	1916-06-20	1916-06-20 00:00:00	1916-06-20	5001	0	\N	0	0	\N	\N	0	261773	0	8331-1	3006322		
39953	3717	3012494	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	247016	0	6206-7	3012494		
40048	3732	3006322	1980-01-02	1980-01-02 00:00:00	1980-01-02	5001	0	\N	0	0	\N	\N	0	247979	0	8331-1	3006322		
55841	5119	3023430	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	340417	0	6833-8	3023430		
36385	3343	3006451	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	221764	0	6273-7	3006451		
31247	2858	3006322	1957-09-03	1957-09-03 00:00:00	1957-09-03	5001	0	\N	0	0	\N	\N	0	189799	0	8331-1	3006322		
7166	695	3006322	1991-02-03	1991-02-03 00:00:00	1991-02-03	5001	0	\N	0	0	\N	\N	0	46015	0	8331-1	3006322		
16904	1536	3011505	1970-11-22	1970-11-22 00:00:00	1970-11-22	5001	0	\N	0	0	\N	\N	0	102769	0	19926-5	3011505		
42776	3957	40758406	1966-09-09	1966-09-09 00:00:00	1966-09-09	5001	0	\N	0	0	\N	\N	0	263045	0	55277-8	40758406		
46290	4261	40758406	1956-09-29	1956-09-29 00:00:00	1956-09-29	5001	0	\N	0	0	\N	\N	0	282938	0	55277-8	40758406		
150142	4604	4052083	1977-09-12	1977-09-12 00:00:00	1977-09-12	5001	0	\N	0	0	\N	\N	0	306712	0	23426006	4052083		
171498	5262	4024958	1981-08-27	1981-08-27 00:00:00	1981-08-27	5001	0	\N	0	0	\N	\N	0	350084	0	117015009	4024958		
121984	3761	4052083	1991-06-06	1991-06-06 00:00:00	1991-06-06	5001	0	\N	0	0	\N	\N	0	250067	0	23426006	4052083		
58335	5343	3012494	1999-07-11	1999-07-11 00:00:00	1999-07-11	5001	0	\N	0	0	\N	\N	0	355823	0	6206-7	3012494		
21750	2002	3006322	1999-04-09	1999-04-09 00:00:00	1999-04-09	5001	0	\N	0	0	\N	\N	0	133353	0	8331-1	3006322		
33143	2989	3006322	1962-02-27	1962-02-27 00:00:00	1962-02-27	5001	0	\N	0	0	\N	\N	0	199528	0	8331-1	3006322		
39609	3678	3006322	1992-12-13	1992-12-13 00:00:00	1992-12-13	5001	0	\N	0	0	\N	\N	0	244594	0	8331-1	3006322		
39618	3680	3012494	1995-10-10	1995-10-10 00:00:00	1995-10-10	5001	0	\N	0	0	\N	\N	0	244695	0	6206-7	3012494		
55102	1669	4133840	2019-05-13	2019-05-13 00:00:00	2019-05-13	5001	0	\N	0	0	\N	\N	0	112109	0	127783003	4133840		
44832	4145	3001488	2010-01-30	2010-01-30 00:00:00	2010-01-30	5001	0	\N	0	0	\N	\N	0	275481	0	7258-7	3001488		
33956	3086	3006322	1981-09-18	1981-09-18 00:00:00	1981-09-18	5001	0	\N	0	0	\N	\N	0	205436	0	8331-1	3006322		
56190	5157	3006322	2007-01-14	2007-01-14 00:00:00	2007-01-14	5001	0	\N	0	0	\N	\N	0	342931	0	8331-1	3006322		
13252	1261	40769189	1989-05-20	1989-05-20 00:00:00	1989-05-20	5001	0	\N	0	0	\N	\N	0	83247	0	66529-9	40769189		
36577	3364	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	223119	0	6844-5	3020655		
22288	2044	3006322	1978-04-20	1978-04-20 00:00:00	1978-04-20	5001	0	\N	0	0	\N	\N	0	135976	0	8331-1	3006322		
48070	4411	3006322	1994-12-04	1994-12-04 00:00:00	1994-12-04	5001	0	\N	0	0	\N	\N	0	293181	0	8331-1	3006322		
24821	2280	40769179	1975-06-11	1975-06-11 00:00:00	1975-06-11	5001	0	\N	0	0	\N	\N	0	151585	0	66519-0	40769179		
52342	1585	4052083	1949-02-15	1949-02-15 00:00:00	1949-02-15	5001	0	\N	0	0	\N	\N	0	106303	0	23426006	4052083		
47375	4366	3023430	1982-04-19	1982-04-19 00:00:00	1982-04-19	5001	0	\N	0	0	\N	\N	0	289663	0	6833-8	3023430		
19348	1773	3019406	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	118614	0	6158-0	3019406		
103865	3191	4024958	1958-12-23	1958-12-23 00:00:00	1958-12-23	5001	0	\N	0	0	\N	\N	0	212331	0	117015009	4024958		
151416	4641	4024958	1979-10-06	1979-10-06 00:00:00	1979-10-06	5001	0	\N	0	0	\N	\N	0	309296	0	117015009	4024958		
31383	2868	3006322	1968-02-12	1968-02-12 00:00:00	1968-02-12	5001	0	\N	0	0	\N	\N	0	190801	0	8331-1	3006322		
62199	1908	4052083	1989-10-27	1989-10-27 00:00:00	1989-10-27	5001	0	\N	0	0	\N	\N	0	126956	0	23426006	4052083		
15425	1411	3004501	1999-11-23	1999-11-23 00:00:00	1999-11-23	5001	0	\N	0	0	\N	\N	0	93967	0	2345-7	3004501		
22135	697	4052083	2012-04-22	2012-04-22 00:00:00	2012-04-22	5001	0	\N	0	0	\N	\N	0	46111	0	23426006	4052083		
53782	4932	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	327805	0	6246-3	3021226		
11472	1099	3000876	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	72213	0	6082-2	3000876		
93106	2866	4133840	2013-07-14	2013-07-14 00:00:00	2013-07-14	5001	0	\N	0	0	\N	\N	0	190693	0	127783003	4133840		
63318	1947	4052083	1968-02-01	1968-02-01 00:00:00	1968-02-01	5001	0	\N	0	0	\N	\N	0	129469	0	23426006	4052083		
1686	149	3006322	1960-05-28	1960-05-28 00:00:00	1960-05-28	5001	0	\N	0	0	\N	\N	0	10072	0	8331-1	3006322		
49833	4532	3008598	1964-04-03	1964-04-03 00:00:00	1964-04-03	5001	0	\N	0	0	\N	\N	0	301895	0	3024-7	3008598		
23791	2186	3021226	1975-03-07	1975-03-07 00:00:00	1975-03-07	5001	0	\N	0	0	\N	\N	0	145721	0	6246-3	3021226		
34501	3149	3006322	2006-11-24	2006-11-24 00:00:00	2006-11-24	5001	0	\N	0	0	\N	\N	0	209504	0	8331-1	3006322		
45869	4226	3006322	1987-09-04	1987-09-04 00:00:00	1987-09-04	5001	0	\N	0	0	\N	\N	0	280693	0	8331-1	3006322		
2622	260	3019406	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	17212	0	6158-0	3019406		
57337	5265	3006322	1996-12-07	1996-12-07 00:00:00	1996-12-07	5001	0	\N	0	0	\N	\N	0	350275	0	8331-1	3006322		
52372	4819	3006322	1989-05-06	1989-05-06 00:00:00	1989-05-06	5001	0	\N	0	0	\N	\N	0	320514	0	8331-1	3006322		
12766	1217	3011505	2003-07-11	2003-07-11 00:00:00	2003-07-11	5001	0	\N	0	0	\N	\N	0	80143	0	19926-5	3011505		
25527	2339	3006734	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	155630	0	6189-5	3006734		
15169	1397	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	92751	0	6833-8	3023430		
40762	3784	3011505	1987-07-21	1987-07-21 00:00:00	1987-07-21	5001	0	\N	0	0	\N	\N	0	251461	0	19926-5	3011505		
2237	66	4052083	2000-09-27	2000-09-27 00:00:00	2000-09-27	5001	0	\N	0	0	\N	\N	0	4506	0	23426006	4052083		
52214	4800	3009542	1970-10-29	1970-10-29 00:00:00	1970-10-29	5001	0	\N	0	0	\N	\N	0	319321	0	20570-8	3009542		
35777	3279	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	217813	0	6833-8	3023430		
80588	2486	4052083	2007-02-07	2007-02-07 00:00:00	2007-02-07	5001	0	\N	0	0	\N	\N	0	164742	0	23426006	4052083		
118654	3650	4052083	2017-03-07	2017-03-07 00:00:00	2017-03-07	5001	0	\N	0	0	\N	\N	0	242996	0	23426006	4052083		
26366	823	4024958	2017-11-19	2017-11-19 00:00:00	2017-11-19	5001	0	\N	0	0	\N	\N	0	54533	0	117015009	4024958		
11212	1082	3036780	1988-09-06	1988-09-06 00:00:00	1988-09-06	5001	0	\N	0	0	\N	\N	0	70905	0	6095-4	3036780		
26165	2402	3000876	1977-11-19	1977-11-19 00:00:00	1977-11-19	5001	0	\N	0	0	\N	\N	0	159572	0	6082-2	3000876		
158831	4883	4024958	1981-12-09	1981-12-09 00:00:00	1981-12-09	5001	0	\N	0	0	\N	\N	0	324634	0	117015009	4024958		
81422	2518	4133840	2013-01-04	2013-01-04 00:00:00	2013-01-04	5001	0	\N	0	0	\N	\N	0	166575	0	127783003	4133840		
34150	3114	3049273	2013-02-19	2013-02-19 00:00:00	2013-02-19	5001	0	\N	0	0	\N	\N	0	207117	0	38265-5	3049273		
49053	4484	3006322	1977-04-20	1977-04-20 00:00:00	1977-04-20	5001	0	\N	0	0	\N	\N	0	298474	0	8331-1	3006322		
42600	3938	3006322	1922-02-05	1922-02-05 00:00:00	1922-02-05	5001	0	\N	0	0	\N	\N	0	261774	0	8331-1	3006322		
39954	3717	3000876	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	247016	0	6082-2	3000876		
40050	3733	3006322	1987-01-13	1987-01-13 00:00:00	1987-01-13	5001	0	\N	0	0	\N	\N	0	248056	0	8331-1	3006322		
55842	5119	3020655	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	340417	0	6844-5	3020655		
36386	3343	3012494	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	221764	0	6206-7	3012494		
31248	2858	3006322	1930-08-27	1930-08-27 00:00:00	1930-08-27	5001	0	\N	0	0	\N	\N	0	189823	0	8331-1	3006322		
7167	695	3006322	2017-05-13	2017-05-13 00:00:00	2017-05-13	5001	0	\N	0	0	\N	\N	0	45993	0	8331-1	3006322		
16905	1536	3006322	1964-08-18	1964-08-18 00:00:00	1964-08-18	5001	0	\N	0	0	\N	\N	0	102778	0	8331-1	3006322		
42778	3957	3011505	2014-10-23	2014-10-23 00:00:00	2014-10-23	5001	0	\N	0	0	\N	\N	0	263060	0	19926-5	3011505		
46291	4261	3006322	1995-11-03	1995-11-03 00:00:00	1995-11-03	5001	0	\N	0	0	\N	\N	0	282941	0	8331-1	3006322		
150148	4604	4024958	1979-03-12	1979-03-12 00:00:00	1979-03-12	5001	0	\N	0	0	\N	\N	0	306713	0	117015009	4024958		
48330	1475	4052083	1993-04-29	1993-04-29 00:00:00	1993-04-29	5001	0	\N	0	0	\N	\N	0	98260	0	23426006	4052083		
171527	5264	4024958	1969-06-23	1969-06-23 00:00:00	1969-06-23	5001	0	\N	0	0	\N	\N	0	350226	0	117015009	4024958		
58336	5343	3036780	1999-07-11	1999-07-11 00:00:00	1999-07-11	5001	0	\N	0	0	\N	\N	0	355823	0	6095-4	3036780		
21751	2002	3006322	2001-03-12	2001-03-12 00:00:00	2001-03-12	5001	0	\N	0	0	\N	\N	0	133341	0	8331-1	3006322		
33144	2989	3006322	1980-04-05	1980-04-05 00:00:00	1980-04-05	5001	0	\N	0	0	\N	\N	0	199544	0	8331-1	3006322		
39610	3678	3006322	2013-04-29	2013-04-29 00:00:00	2013-04-29	5001	0	\N	0	0	\N	\N	0	244597	0	8331-1	3006322		
39619	3680	3019406	1995-10-10	1995-10-10 00:00:00	1995-10-10	5001	0	\N	0	0	\N	\N	0	244695	0	6158-0	3019406		
55105	1669	4133840	2012-04-02	2012-04-02 00:00:00	2012-04-02	5001	0	\N	0	0	\N	\N	0	112082	0	127783003	4133840		
44833	4145	3001247	2010-01-30	2010-01-30 00:00:00	2010-01-30	5001	0	\N	0	0	\N	\N	0	275481	0	6085-5	3001247		
33957	3087	3006322	1943-05-05	1943-05-05 00:00:00	1943-05-05	5001	0	\N	0	0	\N	\N	0	205560	0	8331-1	3006322		
56191	5157	3006322	1982-08-31	1982-08-31 00:00:00	1982-08-31	5001	0	\N	0	0	\N	\N	0	342903	0	8331-1	3006322		
1257	35	4024958	1996-07-02	1996-07-02 00:00:00	1996-07-02	5001	0	\N	0	0	\N	\N	0	2405	0	117015009	4024958		
36578	3364	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	223119	0	6833-8	3023430		
22290	2046	3006322	1977-06-30	1977-06-30 00:00:00	1977-06-30	5001	0	\N	0	0	\N	\N	0	136180	0	8331-1	3006322		
48071	4411	3006322	2002-01-09	2002-01-09 00:00:00	2002-01-09	5001	0	\N	0	0	\N	\N	0	293182	0	8331-1	3006322		
24822	2280	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	151673	0	7258-7	3001488		
52356	1586	4052083	2001-10-15	2001-10-15 00:00:00	2001-10-15	5001	0	\N	0	0	\N	\N	0	106463	0	23426006	4052083		
47376	4366	3020655	1982-04-19	1982-04-19 00:00:00	1982-04-19	5001	0	\N	0	0	\N	\N	0	289663	0	6844-5	3020655		
19349	1773	3006451	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	118614	0	6273-7	3006451		
103867	3191	4024958	1960-03-31	1960-03-31 00:00:00	1960-03-31	5001	0	\N	0	0	\N	\N	0	212332	0	117015009	4024958		
151418	4641	4133840	2017-07-13	2017-07-13 00:00:00	2017-07-13	5001	0	\N	0	0	\N	\N	0	309346	0	127783003	4133840		
31384	2869	3006322	2009-12-25	2009-12-25 00:00:00	2009-12-25	5001	0	\N	0	0	\N	\N	0	190893	0	8331-1	3006322		
96972	2969	4052083	2000-11-03	2000-11-03 00:00:00	2000-11-03	5001	0	\N	0	0	\N	\N	0	198250	0	23426006	4052083		
15426	1411	3024561	1999-11-23	1999-11-23 00:00:00	1999-11-23	5001	0	\N	0	0	\N	\N	0	93967	0	1751-7	3024561		
22140	697	4052083	2015-10-13	2015-10-13 00:00:00	2015-10-13	5001	0	\N	0	0	\N	\N	0	46137	0	23426006	4052083		
53783	4932	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	327805	0	6075-6	3005136		
11473	1099	3021226	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	72213	0	6246-3	3021226		
93107	2866	4133840	1998-04-26	1998-04-26 00:00:00	1998-04-26	5001	0	\N	0	0	\N	\N	0	190675	0	127783003	4133840		
63460	1950	4133840	2017-02-09	2017-02-09 00:00:00	2017-02-09	5001	0	\N	0	0	\N	\N	0	129695	0	127783003	4133840		
1687	149	3006322	1943-11-08	1943-11-08 00:00:00	1943-11-08	5001	0	\N	0	0	\N	\N	0	10031	0	8331-1	3006322		
49834	4532	3009201	1964-04-03	1964-04-03 00:00:00	1964-04-03	5001	0	\N	0	0	\N	\N	0	301895	0	3016-3	3009201		
23792	2186	3001247	1975-03-07	1975-03-07 00:00:00	1975-03-07	5001	0	\N	0	0	\N	\N	0	145721	0	6085-5	3001247		
34502	3150	3006322	1967-08-10	1967-08-10 00:00:00	1967-08-10	5001	0	\N	0	0	\N	\N	0	209583	0	8331-1	3006322		
45870	4226	3011505	2008-01-06	2008-01-06 00:00:00	2008-01-06	5001	0	\N	0	0	\N	\N	0	280682	0	19926-5	3011505		
2623	260	3021226	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	17212	0	6246-3	3021226		
57338	5265	3051031	2003-07-13	2003-07-13 00:00:00	2003-07-13	5001	0	\N	0	0	\N	\N	0	350303	0	46240-8	3051031		
52373	4819	3006322	1980-05-09	1980-05-09 00:00:00	1980-05-09	5001	0	\N	0	0	\N	\N	0	320576	0	8331-1	3006322		
12767	1217	3011505	2012-12-14	2012-12-14 00:00:00	2012-12-14	5001	0	\N	0	0	\N	\N	0	80146	0	19926-5	3011505		
25528	2339	3014599	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	155630	0	6106-9	3014599		
15170	1397	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	92751	0	6085-5	3001247		
40764	3784	3011505	1983-07-26	1983-07-26 00:00:00	1983-07-26	5001	0	\N	0	0	\N	\N	0	251459	0	19926-5	3011505		
2249	66	4024958	1967-09-10	1967-09-10 00:00:00	1967-09-10	5001	0	\N	0	0	\N	\N	0	4456	0	117015009	4024958		
161722	4967	4024958	1971-11-16	1971-11-16 00:00:00	1971-11-16	5001	0	\N	0	0	\N	\N	0	330138	0	117015009	4024958		
35778	3279	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	217813	0	6189-5	3006734		
80591	2486	4024958	1979-10-26	1979-10-26 00:00:00	1979-10-26	5001	0	\N	0	0	\N	\N	0	164739	0	117015009	4024958		
118656	3650	4024958	2015-07-03	2015-07-03 00:00:00	2015-07-03	5001	0	\N	0	0	\N	\N	0	242949	0	117015009	4024958		
26374	825	4024958	1982-09-13	1982-09-13 00:00:00	1982-09-13	5001	0	\N	0	0	\N	\N	0	54692	0	117015009	4024958		
11213	1082	3023430	1988-09-06	1988-09-06 00:00:00	1988-09-06	5001	0	\N	0	0	\N	\N	0	70905	0	6833-8	3023430		
26166	2402	3006734	1977-11-19	1977-11-19 00:00:00	1977-11-19	5001	0	\N	0	0	\N	\N	0	159572	0	6189-5	3006734		
158848	4883	4052083	1987-05-17	1987-05-17 00:00:00	1987-05-17	5001	0	\N	0	0	\N	\N	0	324702	0	23426006	4052083		
81424	2518	4133840	2017-01-27	2017-01-27 00:00:00	2017-01-27	5001	0	\N	0	0	\N	\N	0	166527	0	127783003	4133840		
34330	3128	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	208215	0	6844-5	3020655		
49054	4484	3006322	2003-05-18	2003-05-18 00:00:00	2003-05-18	5001	0	\N	0	0	\N	\N	0	298505	0	8331-1	3006322		
42601	3938	3006322	1946-12-09	1946-12-09 00:00:00	1946-12-09	5001	0	\N	0	0	\N	\N	0	261776	0	8331-1	3006322		
39955	3717	3001247	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	247016	0	6085-5	3001247		
40051	3733	3006322	2003-06-01	2003-06-01 00:00:00	2003-06-01	5001	0	\N	0	0	\N	\N	0	248044	0	8331-1	3006322		
55843	5119	3021226	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	340417	0	6246-3	3021226		
36387	3343	3006322	2005-07-13	2005-07-13 00:00:00	2005-07-13	5001	0	\N	0	0	\N	\N	0	221742	0	8331-1	3006322		
31249	2858	3006322	1967-09-18	1967-09-18 00:00:00	1967-09-18	5001	0	\N	0	0	\N	\N	0	189743	0	8331-1	3006322		
7168	695	3006322	1999-11-03	1999-11-03 00:00:00	1999-11-03	5001	0	\N	0	0	\N	\N	0	45991	0	8331-1	3006322		
16906	1536	3011505	1968-03-03	1968-03-03 00:00:00	1968-03-03	5001	0	\N	0	0	\N	\N	0	102776	0	19926-5	3011505		
42779	3957	40758406	1966-02-11	1966-02-11 00:00:00	1966-02-11	5001	0	\N	0	0	\N	\N	0	263098	0	55277-8	40758406		
46292	4261	46235214	1957-04-27	1957-04-27 00:00:00	1957-04-27	5001	0	\N	0	0	\N	\N	0	282887	0	76690-7	46235214		
150151	4604	4024958	1976-09-12	1976-09-12 00:00:00	1976-09-12	5001	0	\N	0	0	\N	\N	0	306762	0	117015009	4024958		
48234	4423	3006322	1995-08-09	1995-08-09 00:00:00	1995-08-09	5001	0	\N	0	0	\N	\N	0	294087	0	8331-1	3006322		
171535	5264	4052083	2016-02-22	2016-02-22 00:00:00	2016-02-22	5001	0	\N	0	0	\N	\N	0	350245	0	23426006	4052083		
58337	5343	3019406	1999-07-11	1999-07-11 00:00:00	1999-07-11	5001	0	\N	0	0	\N	\N	0	355823	0	6158-0	3019406		
21752	2002	3006322	2008-09-12	2008-09-12 00:00:00	2008-09-12	5001	0	\N	0	0	\N	\N	0	133345	0	8331-1	3006322		
33145	2989	3006322	1971-04-10	1971-04-10 00:00:00	1971-04-10	5001	0	\N	0	0	\N	\N	0	199551	0	8331-1	3006322		
39611	3678	3006322	1997-11-28	1997-11-28 00:00:00	1997-11-28	5001	0	\N	0	0	\N	\N	0	244581	0	8331-1	3006322		
39620	3680	3023430	1995-10-10	1995-10-10 00:00:00	1995-10-10	5001	0	\N	0	0	\N	\N	0	244695	0	6833-8	3023430		
55108	1669	4133840	2008-03-10	2008-03-10 00:00:00	2008-03-10	5001	0	\N	0	0	\N	\N	0	112080	0	127783003	4133840		
44834	4145	3000876	2010-01-30	2010-01-30 00:00:00	2010-01-30	5001	0	\N	0	0	\N	\N	0	275481	0	6082-2	3000876		
33958	3087	3006322	1968-04-05	1968-04-05 00:00:00	1968-04-05	5001	0	\N	0	0	\N	\N	0	205514	0	8331-1	3006322		
56192	5157	3049273	2018-01-22	2018-01-22 00:00:00	2018-01-22	5001	0	\N	0	0	\N	\N	0	342948	0	38265-5	3049273		
1274	35	4052083	1978-11-14	1978-11-14 00:00:00	1978-11-14	5001	0	\N	0	0	\N	\N	0	2403	0	23426006	4052083		
36579	3364	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	223119	0	6158-0	3019406		
22291	2046	3006322	1945-03-03	1945-03-03 00:00:00	1945-03-03	5001	0	\N	0	0	\N	\N	0	136145	0	8331-1	3006322		
48072	4411	3006322	1978-09-14	1978-09-14 00:00:00	1978-09-14	5001	0	\N	0	0	\N	\N	0	293188	0	8331-1	3006322		
24823	2280	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	151673	0	6844-5	3020655		
52357	1586	4024958	1952-07-02	1952-07-02 00:00:00	1952-07-02	5001	0	\N	0	0	\N	\N	0	106411	0	117015009	4024958		
47377	4366	3001488	1982-04-19	1982-04-19 00:00:00	1982-04-19	5001	0	\N	0	0	\N	\N	0	289663	0	7258-7	3001488		
19350	1773	3027231	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	118614	0	6276-0	3027231		
103895	3194	4052083	1968-01-02	1968-01-02 00:00:00	1968-01-02	5001	0	\N	0	0	\N	\N	0	212455	0	23426006	4052083		
151420	4641	4052083	1981-07-12	1981-07-12 00:00:00	1981-07-12	5001	0	\N	0	0	\N	\N	0	309304	0	23426006	4052083		
31385	2869	3006322	1999-01-11	1999-01-11 00:00:00	1999-01-11	5001	0	\N	0	0	\N	\N	0	190836	0	8331-1	3006322		
96979	2969	4024958	1985-11-28	1985-11-28 00:00:00	1985-11-28	5001	0	\N	0	0	\N	\N	0	198248	0	117015009	4024958		
15427	1411	3016723	1999-11-23	1999-11-23 00:00:00	1999-11-23	5001	0	\N	0	0	\N	\N	0	93967	0	2160-0	3016723		
96275	2949	4052083	1964-05-13	1964-05-13 00:00:00	1964-05-13	5001	0	\N	0	0	\N	\N	0	196863	0	23426006	4052083		
53784	4932	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	327805	0	6085-5	3001247		
11474	1099	3027231	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	72213	0	6276-0	3027231		
93109	2866	4133840	2011-07-10	2011-07-10 00:00:00	2011-07-10	5001	0	\N	0	0	\N	\N	0	190679	0	127783003	4133840		
63463	1950	4133840	2011-01-06	2011-01-06 00:00:00	2011-01-06	5001	0	\N	0	0	\N	\N	0	129709	0	127783003	4133840		
1707	152	3006322	2017-01-26	2017-01-26 00:00:00	2017-01-26	5001	0	\N	0	0	\N	\N	0	10270	0	8331-1	3006322		
49835	4532	3006322	1912-07-15	1912-07-15 00:00:00	1912-07-15	5001	0	\N	0	0	\N	\N	0	301829	0	8331-1	3006322		
23793	2186	3001488	1975-03-07	1975-03-07 00:00:00	1975-03-07	5001	0	\N	0	0	\N	\N	0	145721	0	7258-7	3001488		
34503	3150	3006322	1950-07-25	1950-07-25 00:00:00	1950-07-25	5001	0	\N	0	0	\N	\N	0	209570	0	8331-1	3006322		
45871	4226	3011505	2016-02-07	2016-02-07 00:00:00	2016-02-07	5001	0	\N	0	0	\N	\N	0	280710	0	19926-5	3011505		
2624	260	3020655	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	17212	0	6844-5	3020655		
57339	5265	40758406	2003-07-13	2003-07-13 00:00:00	2003-07-13	5001	0	\N	0	0	\N	\N	0	350303	0	55277-8	40758406		
52374	4819	3000963	1960-09-21	1960-09-21 00:00:00	1960-09-21	5001	0	\N	0	0	\N	\N	0	320582	0	718-7	3000963		
12768	1217	3006322	1978-05-04	1978-05-04 00:00:00	1978-05-04	5001	0	\N	0	0	\N	\N	0	80135	0	8331-1	3006322		
25529	2339	3023430	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	155630	0	6833-8	3023430		
15171	1397	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	92751	0	6082-2	3000876		
40765	3784	3011505	1986-08-12	1986-08-12 00:00:00	1986-08-12	5001	0	\N	0	0	\N	\N	0	251476	0	19926-5	3011505		
2253	67	4052083	1992-08-09	1992-08-09 00:00:00	1992-08-09	5001	0	\N	0	0	\N	\N	0	4525	0	23426006	4052083		
161741	4967	4024958	1961-12-27	1961-12-27 00:00:00	1961-12-27	5001	0	\N	0	0	\N	\N	0	330133	0	117015009	4024958		
35779	3279	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	217813	0	6085-5	3001247		
80597	2486	4052083	1978-09-29	1978-09-29 00:00:00	1978-09-29	5001	0	\N	0	0	\N	\N	0	164738	0	23426006	4052083		
118662	3651	4052083	2009-10-03	2009-10-03 00:00:00	2009-10-03	5001	0	\N	0	0	\N	\N	0	243069	0	23426006	4052083		
26376	825	4024958	1994-06-22	1994-06-22 00:00:00	1994-06-22	5001	0	\N	0	0	\N	\N	0	54641	0	117015009	4024958		
11214	1082	3006451	1988-09-06	1988-09-06 00:00:00	1988-09-06	5001	0	\N	0	0	\N	\N	0	70905	0	6273-7	3006451		
26167	2402	3006734	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	159619	0	6189-5	3006734		
158856	4884	4024958	2004-08-22	2004-08-22 00:00:00	2004-08-22	5001	0	\N	0	0	\N	\N	0	324747	0	117015009	4024958		
81426	2518	4133840	2006-08-25	2006-08-25 00:00:00	2006-08-25	5001	0	\N	0	0	\N	\N	0	166568	0	127783003	4133840		
34331	3128	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	208215	0	6276-0	3027231		
49055	4484	3006322	1992-09-05	1992-09-05 00:00:00	1992-09-05	5001	0	\N	0	0	\N	\N	0	298462	0	8331-1	3006322		
14233	1328	3011505	2003-09-11	2003-09-11 00:00:00	2003-09-11	5001	0	\N	0	0	\N	\N	0	88170	0	19926-5	3011505		
39956	3717	3021226	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	247016	0	6246-3	3021226		
40052	3734	3049273	2006-07-11	2006-07-11 00:00:00	2006-07-11	5001	0	\N	0	0	\N	\N	0	248174	0	38265-5	3049273		
55844	5119	3027231	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	340417	0	6276-0	3027231		
36388	3343	3006322	1983-08-02	1983-08-02 00:00:00	1983-08-02	5001	0	\N	0	0	\N	\N	0	221772	0	8331-1	3006322		
31250	2858	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	189825	0	6248-9	3015076		
7169	695	3006322	1976-06-12	1976-06-12 00:00:00	1976-06-12	5001	0	\N	0	0	\N	\N	0	46006	0	8331-1	3006322		
16907	1536	3006322	1965-01-31	1965-01-31 00:00:00	1965-01-31	5001	0	\N	0	0	\N	\N	0	102803	0	8331-1	3006322		
42780	3957	46235214	1966-02-11	1966-02-11 00:00:00	1966-02-11	5001	0	\N	0	0	\N	\N	0	263098	0	76690-7	46235214		
116744	3598	4024958	1984-07-19	1984-07-19 00:00:00	1984-07-19	5001	0	\N	0	0	\N	\N	0	238931	0	117015009	4024958		
150155	4604	4052083	2014-04-06	2014-04-06 00:00:00	2014-04-06	5001	0	\N	0	0	\N	\N	0	306729	0	23426006	4052083		
48235	4423	3006322	2013-06-20	2013-06-20 00:00:00	2013-06-20	5001	0	\N	0	0	\N	\N	0	294100	0	8331-1	3006322		
171554	5265	4052083	2018-12-15	2018-12-15 00:00:00	2018-12-15	5001	0	\N	0	0	\N	\N	0	350285	0	23426006	4052083		
58338	5343	3014599	1999-07-11	1999-07-11 00:00:00	1999-07-11	5001	0	\N	0	0	\N	\N	0	355823	0	6106-9	3014599		
21753	2002	3051031	1976-06-10	1976-06-10 00:00:00	1976-06-10	5001	0	\N	0	0	\N	\N	0	133351	0	46240-8	3051031		
33146	2989	3006322	1963-09-04	1963-09-04 00:00:00	1963-09-04	5001	0	\N	0	0	\N	\N	0	199573	0	8331-1	3006322		
39614	3680	3005136	1995-10-10	1995-10-10 00:00:00	1995-10-10	5001	0	\N	0	0	\N	\N	0	244695	0	6075-6	3005136		
39621	3680	3006734	1995-10-10	1995-10-10 00:00:00	1995-10-10	5001	0	\N	0	0	\N	\N	0	244695	0	6189-5	3006734		
55114	1669	4133840	2013-04-08	2013-04-08 00:00:00	2013-04-08	5001	0	\N	0	0	\N	\N	0	112090	0	127783003	4133840		
44835	4145	3020655	2010-01-30	2010-01-30 00:00:00	2010-01-30	5001	0	\N	0	0	\N	\N	0	275481	0	6844-5	3020655		
33959	3087	3006322	2014-09-28	2014-09-28 00:00:00	2014-09-28	5001	0	\N	0	0	\N	\N	0	205508	0	8331-1	3006322		
56235	5165	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	343287	0	6082-2	3000876		
1281	36	4024958	1962-10-18	1962-10-18 00:00:00	1962-10-18	5001	0	\N	0	0	\N	\N	0	2503	0	117015009	4024958		
36580	3364	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	223119	0	6276-0	3027231		
22292	2046	3006322	2011-12-08	2011-12-08 00:00:00	2011-12-08	5001	0	\N	0	0	\N	\N	0	136148	0	8331-1	3006322		
48073	4411	3006322	1971-05-10	1971-05-10 00:00:00	1971-05-10	5001	0	\N	0	0	\N	\N	0	293201	0	8331-1	3006322		
24824	2280	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	151673	0	6833-8	3023430		
52359	1586	4052083	1997-02-26	1997-02-26 00:00:00	1997-02-26	5001	0	\N	0	0	\N	\N	0	106439	0	23426006	4052083		
47378	4366	3006451	1982-04-19	1982-04-19 00:00:00	1982-04-19	5001	0	\N	0	0	\N	\N	0	289663	0	6273-7	3006451		
19351	1773	3015076	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	118614	0	6248-9	3015076		
103908	3194	4052083	1974-08-24	1974-08-24 00:00:00	1974-08-24	5001	0	\N	0	0	\N	\N	0	212456	0	23426006	4052083		
151424	4641	4024958	1973-08-27	1973-08-27 00:00:00	1973-08-27	5001	0	\N	0	0	\N	\N	0	309329	0	117015009	4024958		
31386	2869	3049273	2013-01-20	2013-01-20 00:00:00	2013-01-20	5001	0	\N	0	0	\N	\N	0	190829	0	38265-5	3049273		
96983	2969	4052083	1982-04-24	1982-04-24 00:00:00	1982-04-24	5001	0	\N	0	0	\N	\N	0	198202	0	23426006	4052083		
15428	1411	3028833	1999-11-23	1999-11-23 00:00:00	1999-11-23	5001	0	\N	0	0	\N	\N	0	93967	0	42719-5	3028833		
96295	2949	4024958	2019-04-11	2019-04-11 00:00:00	2019-04-11	5001	0	\N	0	0	\N	\N	0	196848	0	117015009	4024958		
53785	4932	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	327805	0	6833-8	3023430		
11475	1099	3019406	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	72213	0	6158-0	3019406		
93111	2866	4133840	2009-07-05	2009-07-05 00:00:00	2009-07-05	5001	0	\N	0	0	\N	\N	0	190653	0	127783003	4133840		
63466	1950	4133840	2016-02-04	2016-02-04 00:00:00	2016-02-04	5001	0	\N	0	0	\N	\N	0	129665	0	127783003	4133840		
1708	152	3007461	1973-12-15	1973-12-15 00:00:00	1973-12-15	5001	0	\N	0	0	\N	\N	0	10291	0	26515-7	3007461		
49836	4532	3006322	1953-02-21	1953-02-21 00:00:00	1953-02-21	5001	0	\N	0	0	\N	\N	0	301952	0	8331-1	3006322		
23794	2186	3027231	1975-03-07	1975-03-07 00:00:00	1975-03-07	5001	0	\N	0	0	\N	\N	0	145721	0	6276-0	3027231		
34504	3150	3006322	1946-04-23	1946-04-23 00:00:00	1946-04-23	5001	0	\N	0	0	\N	\N	0	209612	0	8331-1	3006322		
45872	4226	3023430	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	280670	0	6833-8	3023430		
2625	260	3006322	1991-01-31	1991-01-31 00:00:00	1991-01-31	5001	0	\N	0	0	\N	\N	0	17228	0	8331-1	3006322		
57340	5265	46235214	2003-07-13	2003-07-13 00:00:00	2003-07-13	5001	0	\N	0	0	\N	\N	0	350303	0	76690-7	46235214		
52375	4819	3009542	1960-09-21	1960-09-21 00:00:00	1960-09-21	5001	0	\N	0	0	\N	\N	0	320582	0	20570-8	3009542		
12769	1217	3011505	2013-01-04	2013-01-04 00:00:00	2013-01-04	5001	0	\N	0	0	\N	\N	0	80152	0	19926-5	3011505		
25530	2339	3012494	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	155630	0	6206-7	3012494		
15172	1397	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	92751	0	6106-9	3014599		
40766	3784	3011505	1989-08-01	1989-08-01 00:00:00	1989-08-01	5001	0	\N	0	0	\N	\N	0	251462	0	19926-5	3011505		
2260	67	4024958	2010-01-07	2010-01-07 00:00:00	2010-01-07	5001	0	\N	0	0	\N	\N	0	4568	0	117015009	4024958		
161742	4967	4052083	2014-11-19	2014-11-19 00:00:00	2014-11-19	5001	0	\N	0	0	\N	\N	0	330139	0	23426006	4052083		
35780	3279	3001488	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	217867	0	7258-7	3001488		
80605	2486	4024958	1992-10-03	1992-10-03 00:00:00	1992-10-03	5001	0	\N	0	0	\N	\N	0	164725	0	117015009	4024958		
118669	3651	4024958	1985-02-23	1985-02-23 00:00:00	1985-02-23	5001	0	\N	0	0	\N	\N	0	243045	0	117015009	4024958		
26398	825	4052083	1976-02-05	1976-02-05 00:00:00	1976-02-05	5001	0	\N	0	0	\N	\N	0	54626	0	23426006	4052083		
11215	1082	3021226	1988-09-06	1988-09-06 00:00:00	1988-09-06	5001	0	\N	0	0	\N	\N	0	70905	0	6246-3	3021226		
26168	2402	3001488	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	159619	0	7258-7	3001488		
158862	4884	4024958	2001-08-24	2001-08-24 00:00:00	2001-08-24	5001	0	\N	0	0	\N	\N	0	324756	0	117015009	4024958		
81428	2518	4133840	1997-06-20	1997-06-20 00:00:00	1997-06-20	5001	0	\N	0	0	\N	\N	0	166548	0	127783003	4133840		
34332	3128	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	208215	0	6206-7	3012494		
49056	4484	3006322	2001-01-15	2001-01-15 00:00:00	2001-01-15	5001	0	\N	0	0	\N	\N	0	298494	0	8331-1	3006322		
14234	1328	3011505	1991-12-26	1991-12-26 00:00:00	1991-12-26	5001	0	\N	0	0	\N	\N	0	88167	0	19926-5	3011505		
39957	3717	3001488	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	247016	0	7258-7	3001488		
40053	3734	3006322	1989-04-04	1989-04-04 00:00:00	1989-04-04	5001	0	\N	0	0	\N	\N	0	248153	0	8331-1	3006322		
55845	5119	3001488	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	340417	0	7258-7	3001488		
36389	3343	3000876	1977-07-13	1977-07-13 00:00:00	1977-07-13	5001	0	\N	0	0	\N	\N	0	221770	0	6082-2	3000876		
31251	2858	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	189825	0	6075-6	3005136		
7171	695	40758406	1996-01-13	1996-01-13 00:00:00	1996-01-13	5001	0	\N	0	0	\N	\N	0	46017	0	55277-8	40758406		
16908	1536	3011505	1969-11-16	1969-11-16 00:00:00	1969-11-16	5001	0	\N	0	0	\N	\N	0	102836	0	19926-5	3011505		
105376	3242	4024958	1999-02-23	1999-02-23 00:00:00	1999-02-23	5001	0	\N	0	0	\N	\N	0	215633	0	117015009	4024958		
116745	3598	4024958	1956-06-23	1956-06-23 00:00:00	1956-06-23	5001	0	\N	0	0	\N	\N	0	238948	0	117015009	4024958		
150157	4604	4052083	1971-03-26	1971-03-26 00:00:00	1971-03-26	5001	0	\N	0	0	\N	\N	0	306711	0	23426006	4052083		
7908	254	4052083	1953-07-09	1953-07-09 00:00:00	1953-07-09	5001	0	\N	0	0	\N	\N	0	16920	0	23426006	4052083		
171563	5265	4024958	2007-08-23	2007-08-23 00:00:00	2007-08-23	5001	0	\N	0	0	\N	\N	0	350283	0	117015009	4024958		
58339	5343	3027231	1999-07-11	1999-07-11 00:00:00	1999-07-11	5001	0	\N	0	0	\N	\N	0	355823	0	6276-0	3027231		
21755	2002	40758406	1976-06-10	1976-06-10 00:00:00	1976-06-10	5001	0	\N	0	0	\N	\N	0	133351	0	55277-8	40758406		
33147	2989	3006322	1958-10-02	1958-10-02 00:00:00	1958-10-02	5001	0	\N	0	0	\N	\N	0	199542	0	8331-1	3006322		
39615	3680	3021226	1995-10-10	1995-10-10 00:00:00	1995-10-10	5001	0	\N	0	0	\N	\N	0	244695	0	6246-3	3021226		
39622	3680	3014599	1995-10-10	1995-10-10 00:00:00	1995-10-10	5001	0	\N	0	0	\N	\N	0	244695	0	6106-9	3014599		
55120	1669	4133840	2009-03-16	2009-03-16 00:00:00	2009-03-16	5001	0	\N	0	0	\N	\N	0	112088	0	127783003	4133840		
44836	4145	3023430	2010-01-30	2010-01-30 00:00:00	2010-01-30	5001	0	\N	0	0	\N	\N	0	275481	0	6833-8	3023430		
33960	3087	3006322	2013-03-21	2013-03-21 00:00:00	2013-03-21	5001	0	\N	0	0	\N	\N	0	205520	0	8331-1	3006322		
56236	5165	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	343287	0	6833-8	3023430		
1321	36	4052083	1974-05-20	1974-05-20 00:00:00	1974-05-20	5001	0	\N	0	0	\N	\N	0	2488	0	23426006	4052083		
36581	3364	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	223119	0	6095-4	3036780		
22293	2046	3006322	1945-08-14	1945-08-14 00:00:00	1945-08-14	5001	0	\N	0	0	\N	\N	0	136146	0	8331-1	3006322		
48074	4411	3006322	1951-10-22	1951-10-22 00:00:00	1951-10-22	5001	0	\N	0	0	\N	\N	0	293176	0	8331-1	3006322		
24825	2280	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	151673	0	6158-0	3019406		
52367	1586	4052083	1954-10-20	1954-10-20 00:00:00	1954-10-20	5001	0	\N	0	0	\N	\N	0	106449	0	23426006	4052083		
47379	4366	3012494	1982-04-19	1982-04-19 00:00:00	1982-04-19	5001	0	\N	0	0	\N	\N	0	289663	0	6206-7	3012494		
19352	1773	3012494	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	118614	0	6206-7	3012494		
103913	3194	4052083	1980-11-29	1980-11-29 00:00:00	1980-11-29	5001	0	\N	0	0	\N	\N	0	212465	0	23426006	4052083		
151425	4641	4133840	2004-09-09	2004-09-09 00:00:00	2004-09-09	5001	0	\N	0	0	\N	\N	0	309351	0	127783003	4133840		
31387	2869	3006322	2018-01-23	2018-01-23 00:00:00	2018-01-23	5001	0	\N	0	0	\N	\N	0	190849	0	8331-1	3006322		
96988	2969	4024958	1978-05-29	1978-05-29 00:00:00	1978-05-29	5001	0	\N	0	0	\N	\N	0	198206	0	117015009	4024958		
15429	1411	3009542	1999-11-23	1999-11-23 00:00:00	1999-11-23	5001	0	\N	0	0	\N	\N	0	93967	0	20570-8	3009542		
96300	2949	4024958	1992-04-04	1992-04-04 00:00:00	1992-04-04	5001	0	\N	0	0	\N	\N	0	196846	0	117015009	4024958		
53786	4932	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	327805	0	6158-0	3019406		
11476	1099	3006734	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	72213	0	6189-5	3006734		
93113	2866	4133840	2008-08-17	2008-08-17 00:00:00	2008-08-17	5001	0	\N	0	0	\N	\N	0	190678	0	127783003	4133840		
63469	1950	4133840	1997-10-23	1997-10-23 00:00:00	1997-10-23	5001	0	\N	0	0	\N	\N	0	129658	0	127783003	4133840		
1709	152	3023103	1973-12-15	1973-12-15 00:00:00	1973-12-15	5001	0	\N	0	0	\N	\N	0	10291	0	2823-3	3023103		
49837	4532	3006322	1966-03-13	1966-03-13 00:00:00	1966-03-13	5001	0	\N	0	0	\N	\N	0	301844	0	8331-1	3006322		
23795	2186	3020655	1975-03-07	1975-03-07 00:00:00	1975-03-07	5001	0	\N	0	0	\N	\N	0	145721	0	6844-5	3020655		
34506	3150	3006322	1947-01-01	1947-01-01 00:00:00	1947-01-01	5001	0	\N	0	0	\N	\N	0	209569	0	8331-1	3006322		
45873	4226	3020655	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	280670	0	6844-5	3020655		
2626	260	3006322	1992-02-08	1992-02-08 00:00:00	1992-02-08	5001	0	\N	0	0	\N	\N	0	17255	0	8331-1	3006322		
57343	5265	40766240	2003-07-13	2003-07-13 00:00:00	2003-07-13	5001	0	\N	0	0	\N	\N	0	350303	0	63513-6	40766240		
52376	4819	3006322	1960-09-18	1960-09-18 00:00:00	1960-09-18	5001	0	\N	0	0	\N	\N	0	320509	0	8331-1	3006322		
12770	1217	3011505	2006-12-22	2006-12-22 00:00:00	2006-12-22	5001	0	\N	0	0	\N	\N	0	80195	0	19926-5	3011505		
25531	2339	3019406	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	155630	0	6158-0	3019406		
15173	1397	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	92751	0	6246-3	3021226		
40767	3784	3006322	1932-01-01	1932-01-01 00:00:00	1932-01-01	5001	0	\N	0	0	\N	\N	0	251490	0	8331-1	3006322		
2264	67	4052083	1980-01-31	1980-01-31 00:00:00	1980-01-31	5001	0	\N	0	0	\N	\N	0	4537	0	23426006	4052083		
161748	4967	4024958	1993-04-10	1993-04-10 00:00:00	1993-04-10	5001	0	\N	0	0	\N	\N	0	330185	0	117015009	4024958		
35781	3279	3036780	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	217867	0	6095-4	3036780		
80608	2487	4024958	2009-08-22	2009-08-22 00:00:00	2009-08-22	5001	0	\N	0	0	\N	\N	0	164805	0	117015009	4024958		
118673	3651	4024958	2005-06-06	2005-06-06 00:00:00	2005-06-06	5001	0	\N	0	0	\N	\N	0	243049	0	117015009	4024958		
26403	826	4052083	1993-03-16	1993-03-16 00:00:00	1993-03-16	5001	0	\N	0	0	\N	\N	0	54698	0	23426006	4052083		
11216	1082	3000876	1988-09-06	1988-09-06 00:00:00	1988-09-06	5001	0	\N	0	0	\N	\N	0	70905	0	6082-2	3000876		
26169	2402	3023430	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	159619	0	6833-8	3023430		
158867	4884	4024958	1979-09-08	1979-09-08 00:00:00	1979-09-08	5001	0	\N	0	0	\N	\N	0	324776	0	117015009	4024958		
81429	2518	4133840	2011-12-30	2011-12-30 00:00:00	2011-12-30	5001	0	\N	0	0	\N	\N	0	166571	0	127783003	4133840		
34333	3128	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	208215	0	6075-6	3005136		
49057	4484	3006322	1989-04-13	1989-04-13 00:00:00	1989-04-13	5001	0	\N	0	0	\N	\N	0	298475	0	8331-1	3006322		
14235	1328	3011505	2015-04-09	2015-04-09 00:00:00	2015-04-09	5001	0	\N	0	0	\N	\N	0	88234	0	19926-5	3011505		
39958	3717	3006451	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	247016	0	6273-7	3006451		
40054	3734	3006322	1981-04-30	1981-04-30 00:00:00	1981-04-30	5001	0	\N	0	0	\N	\N	0	248097	0	8331-1	3006322		
55846	5119	3036780	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	340417	0	6095-4	3036780		
36390	3343	3023430	1977-07-13	1977-07-13 00:00:00	1977-07-13	5001	0	\N	0	0	\N	\N	0	221770	0	6833-8	3023430		
31252	2858	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	189825	0	6273-7	3006451		
7172	695	40766240	1996-01-13	1996-01-13 00:00:00	1996-01-13	5001	0	\N	0	0	\N	\N	0	46017	0	63513-6	40766240		
16909	1536	3011505	1971-11-28	1971-11-28 00:00:00	1971-11-28	5001	0	\N	0	0	\N	\N	0	102837	0	19926-5	3011505		
105377	3242	4052083	1985-04-02	1985-04-02 00:00:00	1985-04-02	5001	0	\N	0	0	\N	\N	0	215617	0	23426006	4052083		
116749	3598	4052083	1950-05-25	1950-05-25 00:00:00	1950-05-25	5001	0	\N	0	0	\N	\N	0	238922	0	23426006	4052083		
161485	4960	4024958	1939-07-01	1939-07-01 00:00:00	1939-07-01	5001	0	\N	0	0	\N	\N	0	329656	0	117015009	4024958		
7912	254	4052083	1962-10-29	1962-10-29 00:00:00	1962-10-29	5001	0	\N	0	0	\N	\N	0	16955	0	23426006	4052083		
171576	5265	4024958	2018-12-21	2018-12-21 00:00:00	2018-12-21	5001	0	\N	0	0	\N	\N	0	350278	0	117015009	4024958		
58340	5343	3020655	1999-07-11	1999-07-11 00:00:00	1999-07-11	5001	0	\N	0	0	\N	\N	0	355823	0	6844-5	3020655		
21756	2002	46235214	1976-06-10	1976-06-10 00:00:00	1976-06-10	5001	0	\N	0	0	\N	\N	0	133351	0	76690-7	46235214		
33150	2991	3006322	1966-06-05	1966-06-05 00:00:00	1966-06-05	5001	0	\N	0	0	\N	\N	0	199667	0	8331-1	3006322		
39616	3680	3027231	1995-10-10	1995-10-10 00:00:00	1995-10-10	5001	0	\N	0	0	\N	\N	0	244695	0	6276-0	3027231		
39623	3680	3020655	1995-10-10	1995-10-10 00:00:00	1995-10-10	5001	0	\N	0	0	\N	\N	0	244695	0	6844-5	3020655		
55125	1669	4133840	2015-04-20	2015-04-20 00:00:00	2015-04-20	5001	0	\N	0	0	\N	\N	0	112107	0	127783003	4133840		
44837	4145	3005136	2010-01-30	2010-01-30 00:00:00	2010-01-30	5001	0	\N	0	0	\N	\N	0	275481	0	6075-6	3005136		
33961	3087	3049273	1996-07-15	1996-07-15 00:00:00	1996-07-15	5001	0	\N	0	0	\N	\N	0	205556	0	38265-5	3049273		
56237	5165	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	343287	0	6095-4	3036780		
1323	36	4052083	2001-06-17	2001-06-17 00:00:00	2001-06-17	5001	0	\N	0	0	\N	\N	0	2631	0	23426006	4052083		
36582	3364	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	223119	0	6082-2	3000876		
22294	2046	3006322	1948-02-17	1948-02-17 00:00:00	1948-02-17	5001	0	\N	0	0	\N	\N	0	136171	0	8331-1	3006322		
48075	4412	3006322	1994-06-27	1994-06-27 00:00:00	1994-06-27	5001	0	\N	0	0	\N	\N	0	293385	0	8331-1	3006322		
24826	2280	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	151673	0	6246-3	3021226		
21272	670	4052083	1984-10-02	1984-10-02 00:00:00	1984-10-02	5001	0	\N	0	0	\N	\N	0	44222	0	23426006	4052083		
47380	4366	3014599	1982-04-19	1982-04-19 00:00:00	1982-04-19	5001	0	\N	0	0	\N	\N	0	289663	0	6106-9	3014599		
19353	1773	3006322	1984-12-24	1984-12-24 00:00:00	1984-12-24	5001	0	\N	0	0	\N	\N	0	118537	0	8331-1	3006322		
103918	3195	4024958	1959-04-01	1959-04-01 00:00:00	1959-04-01	5001	0	\N	0	0	\N	\N	0	212564	0	117015009	4024958		
151428	4641	4024958	1967-10-14	1967-10-14 00:00:00	1967-10-14	5001	0	\N	0	0	\N	\N	0	309285	0	117015009	4024958		
13506	426	4024958	1969-12-05	1969-12-05 00:00:00	1969-12-05	5001	0	\N	0	0	\N	\N	0	28249	0	117015009	4024958		
123174	3796	4024958	2001-01-14	2001-01-14 00:00:00	2001-01-14	5001	0	\N	0	0	\N	\N	0	252392	0	117015009	4024958		
15430	1411	3007461	1999-11-23	1999-11-23 00:00:00	1999-11-23	5001	0	\N	0	0	\N	\N	0	93967	0	26515-7	3007461		
22268	703	4052083	1976-04-06	1976-04-06 00:00:00	1976-04-06	5001	0	\N	0	0	\N	\N	0	46474	0	23426006	4052083		
53787	4932	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	327805	0	6248-9	3015076		
11477	1099	3020655	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	72213	0	6844-5	3020655		
93116	2866	4133840	2004-05-02	2004-05-02 00:00:00	2004-05-02	5001	0	\N	0	0	\N	\N	0	190677	0	127783003	4133840		
63472	1950	4133840	1983-01-06	1983-01-06 00:00:00	1983-01-06	5001	0	\N	0	0	\N	\N	0	129654	0	127783003	4133840		
1710	152	3013682	1973-12-15	1973-12-15 00:00:00	1973-12-15	5001	0	\N	0	0	\N	\N	0	10291	0	3094-0	3013682		
49838	4532	3006322	1939-02-22	1939-02-22 00:00:00	1939-02-22	5001	0	\N	0	0	\N	\N	0	301916	0	8331-1	3006322		
23796	2186	3023430	1975-03-07	1975-03-07 00:00:00	1975-03-07	5001	0	\N	0	0	\N	\N	0	145721	0	6833-8	3023430		
34507	3150	3006322	1980-06-18	1980-06-18 00:00:00	1980-06-18	5001	0	\N	0	0	\N	\N	0	209594	0	8331-1	3006322		
45874	4226	3005136	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	280670	0	6075-6	3005136		
2632	262	3006322	1985-01-10	1985-01-10 00:00:00	1985-01-10	5001	0	\N	0	0	\N	\N	0	17363	0	8331-1	3006322		
57344	5265	3006322	2018-12-21	2018-12-21 00:00:00	2018-12-21	5001	0	\N	0	0	\N	\N	0	350278	0	8331-1	3006322		
52377	4819	3006322	1976-06-17	1976-06-17 00:00:00	1976-06-17	5001	0	\N	0	0	\N	\N	0	320522	0	8331-1	3006322		
12771	1217	3011505	1994-09-23	1994-09-23 00:00:00	1994-09-23	5001	0	\N	0	0	\N	\N	0	80180	0	19926-5	3011505		
25532	2339	3005136	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	155630	0	6075-6	3005136		
15174	1397	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	92751	0	6206-7	3012494		
40768	3784	3011505	1984-07-31	1984-07-31 00:00:00	1984-07-31	5001	0	\N	0	0	\N	\N	0	251532	0	19926-5	3011505		
2266	67	4024958	1972-11-10	1972-11-10 00:00:00	1972-11-10	5001	0	\N	0	0	\N	\N	0	4535	0	117015009	4024958		
161937	4971	4133840	2016-03-01	2016-03-01 00:00:00	2016-03-01	5001	0	\N	0	0	\N	\N	0	330532	0	127783003	4133840		
35782	3279	3006734	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	217867	0	6189-5	3006734		
56534	5189	3006322	1981-05-03	1981-05-03 00:00:00	1981-05-03	5001	0	\N	0	0	\N	\N	0	344942	0	8331-1	3006322		
102072	3135	4024958	1986-02-21	1986-02-21 00:00:00	1986-02-21	5001	0	\N	0	0	\N	\N	0	208667	0	117015009	4024958		
26419	826	4024958	1967-01-04	1967-01-04 00:00:00	1967-01-04	5001	0	\N	0	0	\N	\N	0	54712	0	117015009	4024958		
11217	1082	3006734	1988-09-06	1988-09-06 00:00:00	1988-09-06	5001	0	\N	0	0	\N	\N	0	70905	0	6189-5	3006734		
26170	2402	3020655	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	159619	0	6844-5	3020655		
64990	1992	4052083	1984-03-06	1984-03-06 00:00:00	1984-03-06	5001	0	\N	0	0	\N	\N	0	132732	0	23426006	4052083		
81431	2518	4133840	1983-11-25	1983-11-25 00:00:00	1983-11-25	5001	0	\N	0	0	\N	\N	0	166514	0	127783003	4133840		
34334	3128	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	208215	0	6158-0	3019406		
49058	4485	3006322	1990-07-26	1990-07-26 00:00:00	1990-07-26	5001	0	\N	0	0	\N	\N	0	298542	0	8331-1	3006322		
14236	1328	3011505	1989-12-21	1989-12-21 00:00:00	1989-12-21	5001	0	\N	0	0	\N	\N	0	88205	0	19926-5	3011505		
39959	3717	3020655	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	247016	0	6844-5	3020655		
40055	3734	3006322	2019-05-20	2019-05-20 00:00:00	2019-05-20	5001	0	\N	0	0	\N	\N	0	248156	0	8331-1	3006322		
55847	5119	3006322	2010-12-08	2010-12-08 00:00:00	2010-12-08	5001	0	\N	0	0	\N	\N	0	340366	0	8331-1	3006322		
36391	3343	3015076	1977-07-13	1977-07-13 00:00:00	1977-07-13	5001	0	\N	0	0	\N	\N	0	221770	0	6248-9	3015076		
31253	2858	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	189825	0	6276-0	3027231		
7174	695	3051031	1996-01-13	1996-01-13 00:00:00	1996-01-13	5001	0	\N	0	0	\N	\N	0	46017	0	46240-8	3051031		
16910	1536	3049273	1971-11-28	1971-11-28 00:00:00	1971-11-28	5001	0	\N	0	0	\N	\N	0	102837	0	38265-5	3049273		
105395	3242	4052083	2002-10-04	2002-10-04 00:00:00	2002-10-04	5001	0	\N	0	0	\N	\N	0	215620	0	23426006	4052083		
116756	3598	4052083	2004-03-21	2004-03-21 00:00:00	2004-03-21	5001	0	\N	0	0	\N	\N	0	239012	0	23426006	4052083		
161491	4960	4024958	1990-10-03	1990-10-03 00:00:00	1990-10-03	5001	0	\N	0	0	\N	\N	0	329687	0	117015009	4024958		
7915	254	4024958	1954-12-01	1954-12-01 00:00:00	1954-12-01	5001	0	\N	0	0	\N	\N	0	16906	0	117015009	4024958		
171579	5265	4052083	1990-08-26	1990-08-26 00:00:00	1990-08-26	5001	0	\N	0	0	\N	\N	0	350313	0	23426006	4052083		
58341	5343	3015076	1999-07-11	1999-07-11 00:00:00	1999-07-11	5001	0	\N	0	0	\N	\N	0	355823	0	6248-9	3015076		
21758	2002	40766240	1976-06-10	1976-06-10 00:00:00	1976-06-10	5001	0	\N	0	0	\N	\N	0	133351	0	63513-6	40766240		
33151	2991	3006322	1976-07-27	1976-07-27 00:00:00	1976-07-27	5001	0	\N	0	0	\N	\N	0	199668	0	8331-1	3006322		
39617	3680	3036780	1995-10-10	1995-10-10 00:00:00	1995-10-10	5001	0	\N	0	0	\N	\N	0	244695	0	6095-4	3036780		
39624	3680	3000876	1995-10-10	1995-10-10 00:00:00	1995-10-10	5001	0	\N	0	0	\N	\N	0	244695	0	6082-2	3000876		
55126	1670	4052083	1981-11-03	1981-11-03 00:00:00	1981-11-03	5001	0	\N	0	0	\N	\N	0	112156	0	23426006	4052083		
44838	4145	3012494	2010-01-30	2010-01-30 00:00:00	2010-01-30	5001	0	\N	0	0	\N	\N	0	275481	0	6206-7	3012494		
33962	3087	3006322	1992-12-09	1992-12-09 00:00:00	1992-12-09	5001	0	\N	0	0	\N	\N	0	205517	0	8331-1	3006322		
56238	5165	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	343287	0	6246-3	3021226		
1330	36	4052083	1988-10-26	1988-10-26 00:00:00	1988-10-26	5001	0	\N	0	0	\N	\N	0	2490	0	23426006	4052083		
36583	3364	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	223119	0	6206-7	3012494		
22295	2046	3006322	1992-11-26	1992-11-26 00:00:00	1992-11-26	5001	0	\N	0	0	\N	\N	0	136174	0	8331-1	3006322		
48076	4412	3006322	1981-12-06	1981-12-06 00:00:00	1981-12-06	5001	0	\N	0	0	\N	\N	0	293340	0	8331-1	3006322		
24827	2280	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	151673	0	6276-0	3027231		
21276	670	4052083	1977-09-15	1977-09-15 00:00:00	1977-09-15	5001	0	\N	0	0	\N	\N	0	44220	0	23426006	4052083		
47381	4366	3006322	1991-11-23	1991-11-23 00:00:00	1991-11-23	5001	0	\N	0	0	\N	\N	0	289680	0	8331-1	3006322		
19354	1773	3006322	2011-07-20	2011-07-20 00:00:00	2011-07-20	5001	0	\N	0	0	\N	\N	0	118605	0	8331-1	3006322		
56593	5194	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	345320	0	6106-9	3014599		
151429	4641	4052083	1978-03-19	1978-03-19 00:00:00	1978-03-19	5001	0	\N	0	0	\N	\N	0	309295	0	23426006	4052083		
13511	426	4052083	1981-03-26	1981-03-26 00:00:00	1981-03-26	5001	0	\N	0	0	\N	\N	0	28275	0	23426006	4052083		
31438	2871	3006322	1978-10-16	1978-10-16 00:00:00	1978-10-16	5001	0	\N	0	0	\N	\N	0	191155	0	8331-1	3006322		
15431	1411	3023103	1999-11-23	1999-11-23 00:00:00	1999-11-23	5001	0	\N	0	0	\N	\N	0	93967	0	2823-3	3023103		
22273	703	4024958	1984-08-07	1984-08-07 00:00:00	1984-08-07	5001	0	\N	0	0	\N	\N	0	46457	0	117015009	4024958		
53788	4932	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	327805	0	6276-0	3027231		
11478	1099	3006451	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	72213	0	6273-7	3006451		
93118	2866	4133840	2018-08-19	2018-08-19 00:00:00	2018-08-19	5001	0	\N	0	0	\N	\N	0	190651	0	127783003	4133840		
63475	1950	4024958	1978-05-10	1978-05-10 00:00:00	1978-05-10	5001	0	\N	0	0	\N	\N	0	129625	0	117015009	4024958		
1711	152	3020630	1973-12-15	1973-12-15 00:00:00	1973-12-15	5001	0	\N	0	0	\N	\N	0	10291	0	2885-2	3020630		
49840	4532	3000963	1960-04-04	1960-04-04 00:00:00	1960-04-04	5001	0	\N	0	0	\N	\N	0	301954	0	718-7	3000963		
23797	2186	3036780	1975-03-07	1975-03-07 00:00:00	1975-03-07	5001	0	\N	0	0	\N	\N	0	145721	0	6095-4	3036780		
34516	3157	3006322	1957-03-11	1957-03-11 00:00:00	1957-03-11	5001	0	\N	0	0	\N	\N	0	209812	0	8331-1	3006322		
45875	4226	3015076	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	280670	0	6248-9	3015076		
2633	262	3006322	1966-09-24	1966-09-24 00:00:00	1966-09-24	5001	0	\N	0	0	\N	\N	0	17360	0	8331-1	3006322		
57345	5265	3006322	2011-04-20	2011-04-20 00:00:00	2011-04-20	5001	0	\N	0	0	\N	\N	0	350277	0	8331-1	3006322		
52378	4819	3006322	1962-10-18	1962-10-18 00:00:00	1962-10-18	5001	0	\N	0	0	\N	\N	0	320510	0	8331-1	3006322		
12772	1217	3011505	2010-12-03	2010-12-03 00:00:00	2010-12-03	5001	0	\N	0	0	\N	\N	0	80145	0	19926-5	3011505		
25533	2339	3015076	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	155630	0	6248-9	3015076		
15175	1397	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	92751	0	6273-7	3006451		
40769	3784	3009201	1984-06-24	1984-06-24 00:00:00	1984-06-24	5001	0	\N	0	0	\N	\N	0	251500	0	3016-3	3009201		
2267	67	4052083	1988-10-07	1988-10-07 00:00:00	1988-10-07	5001	0	\N	0	0	\N	\N	0	4521	0	23426006	4052083		
160431	4929	4024958	1984-10-15	1984-10-15 00:00:00	1984-10-15	5001	0	\N	0	0	\N	\N	0	327718	0	117015009	4024958		
35783	3279	3012494	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	217867	0	6206-7	3012494		
56535	5189	3006322	1982-01-13	1982-01-13 00:00:00	1982-01-13	5001	0	\N	0	0	\N	\N	0	344933	0	8331-1	3006322		
136581	4210	4024958	1999-05-17	1999-05-17 00:00:00	1999-05-17	5001	0	\N	0	0	\N	\N	0	279521	0	117015009	4024958		
141205	4353	4052083	1991-11-26	1991-11-26 00:00:00	1991-11-26	5001	0	\N	0	0	\N	\N	0	288784	0	23426006	4052083		
11218	1082	3019406	1988-09-06	1988-09-06 00:00:00	1988-09-06	5001	0	\N	0	0	\N	\N	0	70905	0	6158-0	3019406		
26171	2402	3006451	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	159619	0	6273-7	3006451		
65031	1992	4024958	1985-10-20	1985-10-20 00:00:00	1985-10-20	5001	0	\N	0	0	\N	\N	0	132708	0	117015009	4024958		
81433	2518	4133840	2008-09-05	2008-09-05 00:00:00	2008-09-05	5001	0	\N	0	0	\N	\N	0	166569	0	127783003	4133840		
34335	3128	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	208215	0	6273-7	3006451		
49059	4485	3006322	1958-10-04	1958-10-04 00:00:00	1958-10-04	5001	0	\N	0	0	\N	\N	0	298597	0	8331-1	3006322		
14237	1328	3011505	2009-03-05	2009-03-05 00:00:00	2009-03-05	5001	0	\N	0	0	\N	\N	0	88172	0	19926-5	3011505		
39960	3717	3023430	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	247016	0	6833-8	3023430		
40056	3734	3006322	1976-03-10	1976-03-10 00:00:00	1976-03-10	5001	0	\N	0	0	\N	\N	0	248176	0	8331-1	3006322		
55848	5119	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	340316	0	6082-2	3000876		
36392	3343	3027231	1977-07-13	1977-07-13 00:00:00	1977-07-13	5001	0	\N	0	0	\N	\N	0	221770	0	6276-0	3027231		
31254	2858	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	189825	0	6246-3	3021226		
7175	695	46235214	1996-01-13	1996-01-13 00:00:00	1996-01-13	5001	0	\N	0	0	\N	\N	0	46017	0	76690-7	46235214		
16911	1537	3006322	1963-10-09	1963-10-09 00:00:00	1963-10-09	5001	0	\N	0	0	\N	\N	0	102867	0	8331-1	3006322		
105413	3244	4024958	2013-06-10	2013-06-10 00:00:00	2013-06-10	5001	0	\N	0	0	\N	\N	0	215733	0	117015009	4024958		
116758	3599	4052083	2012-11-19	2012-11-19 00:00:00	2012-11-19	5001	0	\N	0	0	\N	\N	0	239051	0	23426006	4052083		
54998	5035	3049273	1996-06-20	1996-06-20 00:00:00	1996-06-20	5001	0	\N	0	0	\N	\N	0	334620	0	38265-5	3049273		
7916	254	4052083	1988-05-28	1988-05-28 00:00:00	1988-05-28	5001	0	\N	0	0	\N	\N	0	16907	0	23426006	4052083		
57738	5298	3006322	2001-12-02	2001-12-02 00:00:00	2001-12-02	5001	0	\N	0	0	\N	\N	0	352414	0	8331-1	3006322		
58342	5343	3021226	1999-07-11	1999-07-11 00:00:00	1999-07-11	5001	0	\N	0	0	\N	\N	0	355823	0	6246-3	3021226		
21761	2002	3051031	2004-09-01	2004-09-01 00:00:00	2004-09-01	5001	0	\N	0	0	\N	\N	0	133343	0	46240-8	3051031		
33152	2991	3006322	1980-07-20	1980-07-20 00:00:00	1980-07-20	5001	0	\N	0	0	\N	\N	0	199622	0	8331-1	3006322		
80025	2462	4052083	1966-01-17	1966-01-17 00:00:00	1966-01-17	5001	0	\N	0	0	\N	\N	0	163293	0	23426006	4052083		
39625	3680	3001247	1995-10-10	1995-10-10 00:00:00	1995-10-10	5001	0	\N	0	0	\N	\N	0	244695	0	6085-5	3001247		
55127	1670	4052083	2014-10-13	2014-10-13 00:00:00	2014-10-13	5001	0	\N	0	0	\N	\N	0	112139	0	23426006	4052083		
44839	4145	3036780	2010-01-30	2010-01-30 00:00:00	2010-01-30	5001	0	\N	0	0	\N	\N	0	275481	0	6095-4	3036780		
33963	3087	3006322	2008-05-03	2008-05-03 00:00:00	2008-05-03	5001	0	\N	0	0	\N	\N	0	205506	0	8331-1	3006322		
56239	5165	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	343287	0	7258-7	3001488		
25216	2318	3024731	1969-03-09	1969-03-09 00:00:00	1969-03-09	5001	0	\N	0	0	\N	\N	0	154115	0	30428-7	3024731		
36584	3364	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	223119	0	6246-3	3021226		
22296	2046	3006322	2006-03-27	2006-03-27 00:00:00	2006-03-27	5001	0	\N	0	0	\N	\N	0	136147	0	8331-1	3006322		
48077	4412	3006322	1973-02-13	1973-02-13 00:00:00	1973-02-13	5001	0	\N	0	0	\N	\N	0	293406	0	8331-1	3006322		
24828	2280	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	151673	0	6248-9	3015076		
21280	670	4024958	1976-04-22	1976-04-22 00:00:00	1976-04-22	5001	0	\N	0	0	\N	\N	0	44238	0	117015009	4024958		
106442	3279	4024958	1971-01-21	1971-01-21 00:00:00	1971-01-21	5001	0	\N	0	0	\N	\N	0	217902	0	117015009	4024958		
19355	1773	3005136	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	118557	0	6075-6	3005136		
56594	5194	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	345320	0	6273-7	3006451		
151432	4641	4024958	1997-04-15	1997-04-15 00:00:00	1997-04-15	5001	0	\N	0	0	\N	\N	0	309306	0	117015009	4024958		
50801	1540	4024958	1966-07-31	1966-07-31 00:00:00	1966-07-31	5001	0	\N	0	0	\N	\N	0	103215	0	117015009	4024958		
31439	2871	3006322	1972-05-08	1972-05-08 00:00:00	1972-05-08	5001	0	\N	0	0	\N	\N	0	191166	0	8331-1	3006322		
15432	1411	3013682	1999-11-23	1999-11-23 00:00:00	1999-11-23	5001	0	\N	0	0	\N	\N	0	93967	0	3094-0	3013682		
22279	703	4052083	2009-05-04	2009-05-04 00:00:00	2009-05-04	5001	0	\N	0	0	\N	\N	0	46438	0	23426006	4052083		
53789	4932	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	327805	0	6106-9	3014599		
11479	1099	3014599	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	72213	0	6106-9	3014599		
93120	2866	4024958	1969-12-22	1969-12-22 00:00:00	1969-12-22	5001	0	\N	0	0	\N	\N	0	190644	0	117015009	4024958		
63477	1950	4133840	2008-12-25	2008-12-25 00:00:00	2008-12-25	5001	0	\N	0	0	\N	\N	0	129708	0	127783003	4133840		
1712	152	3002385	1973-12-15	1973-12-15 00:00:00	1973-12-15	5001	0	\N	0	0	\N	\N	0	10291	0	30385-9	3002385		
49841	4532	3009542	1960-04-04	1960-04-04 00:00:00	1960-04-04	5001	0	\N	0	0	\N	\N	0	301954	0	20570-8	3009542		
23798	2186	3019406	1975-03-07	1975-03-07 00:00:00	1975-03-07	5001	0	\N	0	0	\N	\N	0	145721	0	6158-0	3019406		
34517	3157	3006322	1965-01-13	1965-01-13 00:00:00	1965-01-13	5001	0	\N	0	0	\N	\N	0	209813	0	8331-1	3006322		
45876	4226	3014599	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	280670	0	6106-9	3014599		
2634	262	3006322	1974-10-24	1974-10-24 00:00:00	1974-10-24	5001	0	\N	0	0	\N	\N	0	17413	0	8331-1	3006322		
57346	5265	40758406	2003-08-12	2003-08-12 00:00:00	2003-08-12	5001	0	\N	0	0	\N	\N	0	350276	0	55277-8	40758406		
52379	4819	3006322	1970-02-10	1970-02-10 00:00:00	1970-02-10	5001	0	\N	0	0	\N	\N	0	320584	0	8331-1	3006322		
12773	1217	3011505	1998-07-03	1998-07-03 00:00:00	1998-07-03	5001	0	\N	0	0	\N	\N	0	80193	0	19926-5	3011505		
25534	2339	3027231	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	155630	0	6276-0	3027231		
15176	1397	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	92751	0	6189-5	3006734		
40770	3784	3008598	1984-06-24	1984-06-24 00:00:00	1984-06-24	5001	0	\N	0	0	\N	\N	0	251500	0	3024-7	3008598		
2272	67	4024958	1975-02-12	1975-02-12 00:00:00	1975-02-12	5001	0	\N	0	0	\N	\N	0	4564	0	117015009	4024958		
160433	4929	4024958	1972-12-05	1972-12-05 00:00:00	1972-12-05	5001	0	\N	0	0	\N	\N	0	327688	0	117015009	4024958		
35784	3279	3023430	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	217867	0	6833-8	3023430		
56536	5189	3006322	1962-08-16	1962-08-16 00:00:00	1962-08-16	5001	0	\N	0	0	\N	\N	0	344901	0	8331-1	3006322		
136588	4210	4024958	2002-06-16	2002-06-16 00:00:00	2002-06-16	5001	0	\N	0	0	\N	\N	0	279574	0	117015009	4024958		
152513	4675	4052083	1969-03-23	1969-03-23 00:00:00	1969-03-23	5001	0	\N	0	0	\N	\N	0	311548	0	23426006	4052083		
11219	1082	3001247	1988-09-06	1988-09-06 00:00:00	1988-09-06	5001	0	\N	0	0	\N	\N	0	70905	0	6085-5	3001247		
26172	2402	3019406	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	159619	0	6158-0	3019406		
10177	326	4024958	1985-03-11	1985-03-11 00:00:00	1985-03-11	5001	0	\N	0	0	\N	\N	0	21554	0	117015009	4024958		
81435	2518	4133840	1995-06-16	1995-06-16 00:00:00	1995-06-16	5001	0	\N	0	0	\N	\N	0	166589	0	127783003	4133840		
34336	3128	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	208215	0	6106-9	3014599		
16020	1466	3006322	2013-08-12	2013-08-12 00:00:00	2013-08-12	5001	0	\N	0	0	\N	\N	0	97650	0	8331-1	3006322		
14238	1328	3011505	2006-09-28	2006-09-28 00:00:00	2006-09-28	5001	0	\N	0	0	\N	\N	0	88195	0	19926-5	3011505		
39961	3717	3036780	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	247016	0	6095-4	3036780		
40057	3734	3006322	2019-01-07	2019-01-07 00:00:00	2019-01-07	5001	0	\N	0	0	\N	\N	0	248129	0	8331-1	3006322		
28474	882	4024958	1965-06-07	1965-06-07 00:00:00	1965-06-07	5001	0	\N	0	0	\N	\N	0	58725	0	117015009	4024958		
36393	3343	3014599	1977-07-13	1977-07-13 00:00:00	1977-07-13	5001	0	\N	0	0	\N	\N	0	221770	0	6106-9	3014599		
31255	2858	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	189825	0	6085-5	3001247		
7177	695	40758406	1979-11-18	1979-11-18 00:00:00	1979-11-18	5001	0	\N	0	0	\N	\N	0	45990	0	55277-8	40758406		
16912	1537	3006322	2014-01-26	2014-01-26 00:00:00	2014-01-26	5001	0	\N	0	0	\N	\N	0	102910	0	8331-1	3006322		
105428	3244	4052083	1996-09-10	1996-09-10 00:00:00	1996-09-10	5001	0	\N	0	0	\N	\N	0	215701	0	23426006	4052083		
116763	3599	4024958	1966-07-06	1966-07-06 00:00:00	1966-07-06	5001	0	\N	0	0	\N	\N	0	239031	0	117015009	4024958		
55000	5035	3006322	1962-05-24	1962-05-24 00:00:00	1962-05-24	5001	0	\N	0	0	\N	\N	0	334546	0	8331-1	3006322		
46868	4313	3014599	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	286336	0	6106-9	3014599		
57739	5298	3006322	1954-03-19	1954-03-19 00:00:00	1954-03-19	5001	0	\N	0	0	\N	\N	0	352418	0	8331-1	3006322		
58343	5343	3006451	1999-07-11	1999-07-11 00:00:00	1999-07-11	5001	0	\N	0	0	\N	\N	0	355823	0	6273-7	3006451		
21762	2002	40758406	2004-09-01	2004-09-01 00:00:00	2004-09-01	5001	0	\N	0	0	\N	\N	0	133343	0	55277-8	40758406		
33153	2992	3006322	1968-09-27	1968-09-27 00:00:00	1968-09-27	5001	0	\N	0	0	\N	\N	0	199685	0	8331-1	3006322		
80048	2463	4024958	2011-06-05	2011-06-05 00:00:00	2011-06-05	5001	0	\N	0	0	\N	\N	0	163365	0	117015009	4024958		
39626	3680	3001488	1995-10-10	1995-10-10 00:00:00	1995-10-10	5001	0	\N	0	0	\N	\N	0	244695	0	7258-7	3001488		
152467	4675	4024958	1921-02-11	1921-02-11 00:00:00	1921-02-11	5001	0	\N	0	0	\N	\N	0	311543	0	117015009	4024958		
44840	4145	3021226	2010-01-30	2010-01-30 00:00:00	2010-01-30	5001	0	\N	0	0	\N	\N	0	275481	0	6246-3	3021226		
33964	3088	3006322	1940-05-12	1940-05-12 00:00:00	1940-05-12	5001	0	\N	0	0	\N	\N	0	205683	0	8331-1	3006322		
56240	5165	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	343287	0	6206-7	3012494		
25217	2318	3019550	1969-03-09	1969-03-09 00:00:00	1969-03-09	5001	0	\N	0	0	\N	\N	0	154115	0	2951-2	3019550		
36585	3364	3006322	1982-12-05	1982-12-05 00:00:00	1982-12-05	5001	0	\N	0	0	\N	\N	0	223080	0	8331-1	3006322		
22298	2046	3006322	1991-04-27	1991-04-27 00:00:00	1991-04-27	5001	0	\N	0	0	\N	\N	0	136182	0	8331-1	3006322		
48078	4412	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	293384	0	6273-7	3006451		
24829	2280	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	151673	0	6106-9	3014599		
21284	670	4024958	2018-05-01	2018-05-01 00:00:00	2018-05-01	5001	0	\N	0	0	\N	\N	0	44226	0	117015009	4024958		
106444	3279	4052083	1998-11-14	1998-11-14 00:00:00	1998-11-14	5001	0	\N	0	0	\N	\N	0	217869	0	23426006	4052083		
19356	1773	3000876	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	118557	0	6082-2	3000876		
56595	5194	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	345320	0	6075-6	3005136		
151433	4641	4133840	2011-07-28	2011-07-28 00:00:00	2011-07-28	5001	0	\N	0	0	\N	\N	0	309352	0	127783003	4133840		
50805	1540	4024958	1979-09-06	1979-09-06 00:00:00	1979-09-06	5001	0	\N	0	0	\N	\N	0	103216	0	117015009	4024958		
31440	2871	3006322	2003-04-21	2003-04-21 00:00:00	2003-04-21	5001	0	\N	0	0	\N	\N	0	191168	0	8331-1	3006322		
15433	1411	3020630	1999-11-23	1999-11-23 00:00:00	1999-11-23	5001	0	\N	0	0	\N	\N	0	93967	0	2885-2	3020630		
22304	703	4052083	1995-12-24	1995-12-24 00:00:00	1995-12-24	5001	0	\N	0	0	\N	\N	0	46458	0	23426006	4052083		
53790	4932	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	327805	0	6273-7	3006451		
11480	1099	3036780	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	72213	0	6095-4	3036780		
93122	2866	4133840	2016-08-07	2016-08-07 00:00:00	2016-08-07	5001	0	\N	0	0	\N	\N	0	190650	0	127783003	4133840		
63479	1950	4133840	2003-11-27	2003-11-27 00:00:00	2003-11-27	5001	0	\N	0	0	\N	\N	0	129620	0	127783003	4133840		
1713	152	3015632	1973-12-15	1973-12-15 00:00:00	1973-12-15	5001	0	\N	0	0	\N	\N	0	10291	0	2028-9	3015632		
49842	4532	3006322	1910-08-13	1910-08-13 00:00:00	1910-08-13	5001	0	\N	0	0	\N	\N	0	301911	0	8331-1	3006322		
23799	2186	3005136	1975-03-07	1975-03-07 00:00:00	1975-03-07	5001	0	\N	0	0	\N	\N	0	145721	0	6075-6	3005136		
34518	3157	3006322	2000-10-26	2000-10-26 00:00:00	2000-10-26	5001	0	\N	0	0	\N	\N	0	209847	0	8331-1	3006322		
45877	4226	3019406	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	280670	0	6158-0	3019406		
2635	263	3006322	2014-07-28	2014-07-28 00:00:00	2014-07-28	5001	0	\N	0	0	\N	\N	0	17478	0	8331-1	3006322		
57347	5265	40766240	2003-08-12	2003-08-12 00:00:00	2003-08-12	5001	0	\N	0	0	\N	\N	0	350276	0	63513-6	40766240		
52380	4819	3006322	1995-01-19	1995-01-19 00:00:00	1995-01-19	5001	0	\N	0	0	\N	\N	0	320578	0	8331-1	3006322		
12774	1217	3006322	1990-07-09	1990-07-09 00:00:00	1990-07-09	5001	0	\N	0	0	\N	\N	0	80137	0	8331-1	3006322		
25535	2339	3000876	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	155630	0	6082-2	3000876		
15177	1397	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	92751	0	6158-0	3019406		
150238	4608	4133840	2018-03-01	2018-03-01 00:00:00	2018-03-01	5001	0	\N	0	0	\N	\N	0	307093	0	127783003	4133840		
2273	67	4024958	2017-07-12	2017-07-12 00:00:00	2017-07-12	5001	0	\N	0	0	\N	\N	0	4528	0	117015009	4024958		
160497	4932	4024958	1983-09-01	1983-09-01 00:00:00	1983-09-01	5001	0	\N	0	0	\N	\N	0	327867	0	117015009	4024958		
35785	3279	3014599	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	217867	0	6106-9	3014599		
56537	5189	3006322	1966-07-06	1966-07-06 00:00:00	1966-07-06	5001	0	\N	0	0	\N	\N	0	344902	0	8331-1	3006322		
136610	4212	4052083	1983-10-20	1983-10-20 00:00:00	1983-10-20	5001	0	\N	0	0	\N	\N	0	279682	0	23426006	4052083		
152539	4675	4052083	1959-07-08	1959-07-08 00:00:00	1959-07-08	5001	0	\N	0	0	\N	\N	0	311570	0	23426006	4052083		
11220	1082	3006322	1979-08-02	1979-08-02 00:00:00	1979-08-02	5001	0	\N	0	0	\N	\N	0	70974	0	8331-1	3006322		
26173	2402	3021226	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	159619	0	6246-3	3021226		
10178	326	4052083	1973-05-18	1973-05-18 00:00:00	1973-05-18	5001	0	\N	0	0	\N	\N	0	21530	0	23426006	4052083		
81437	2518	4133840	2018-02-02	2018-02-02 00:00:00	2018-02-02	5001	0	\N	0	0	\N	\N	0	166594	0	127783003	4133840		
34337	3128	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	208215	0	6248-9	3015076		
16021	1466	3006322	1996-07-06	1996-07-06 00:00:00	1996-07-06	5001	0	\N	0	0	\N	\N	0	97611	0	8331-1	3006322		
14239	1328	3011505	2012-03-22	2012-03-22 00:00:00	2012-03-22	5001	0	\N	0	0	\N	\N	0	88214	0	19926-5	3011505		
39962	3717	3014599	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	247016	0	6106-9	3014599		
64759	1986	4052083	2005-11-05	2005-11-05 00:00:00	2005-11-05	5001	0	\N	0	0	\N	\N	0	132249	0	23426006	4052083		
28487	882	4024958	1950-11-24	1950-11-24 00:00:00	1950-11-24	5001	0	\N	0	0	\N	\N	0	58674	0	117015009	4024958		
36394	3343	3006451	1977-07-13	1977-07-13 00:00:00	1977-07-13	5001	0	\N	0	0	\N	\N	0	221770	0	6273-7	3006451		
31256	2858	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	189825	0	6082-2	3000876		
7178	695	46235214	1979-11-18	1979-11-18 00:00:00	1979-11-18	5001	0	\N	0	0	\N	\N	0	45990	0	76690-7	46235214		
16913	1537	3009201	2010-05-31	2010-05-31 00:00:00	2010-05-31	5001	0	\N	0	0	\N	\N	0	102871	0	3016-3	3009201		
35347	3237	3006322	1928-06-05	1928-06-05 00:00:00	1928-06-05	5001	0	\N	0	0	\N	\N	0	215217	0	8331-1	3006322		
116775	3599	4052083	1974-12-22	1974-12-22 00:00:00	1974-12-22	5001	0	\N	0	0	\N	\N	0	239048	0	23426006	4052083		
55001	5035	3006322	1940-07-23	1940-07-23 00:00:00	1940-07-23	5001	0	\N	0	0	\N	\N	0	334621	0	8331-1	3006322		
46869	4313	3001247	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	286336	0	6085-5	3001247		
57740	5298	3006322	1999-07-04	1999-07-04 00:00:00	1999-07-04	5001	0	\N	0	0	\N	\N	0	352425	0	8331-1	3006322		
58344	5343	3001488	1999-07-11	1999-07-11 00:00:00	1999-07-11	5001	0	\N	0	0	\N	\N	0	355823	0	7258-7	3001488		
21763	2002	46235214	2004-09-01	2004-09-01 00:00:00	2004-09-01	5001	0	\N	0	0	\N	\N	0	133343	0	76690-7	46235214		
33154	2992	3006322	1958-03-13	1958-03-13 00:00:00	1958-03-13	5001	0	\N	0	0	\N	\N	0	199692	0	8331-1	3006322		
80061	2463	4024958	2004-05-30	2004-05-30 00:00:00	2004-05-30	5001	0	\N	0	0	\N	\N	0	163391	0	117015009	4024958		
39627	3680	3006451	1995-10-10	1995-10-10 00:00:00	1995-10-10	5001	0	\N	0	0	\N	\N	0	244695	0	6273-7	3006451		
152470	4675	4052083	1945-10-14	1945-10-14 00:00:00	1945-10-14	5001	0	\N	0	0	\N	\N	0	311494	0	23426006	4052083		
44841	4145	3006451	2010-01-30	2010-01-30 00:00:00	2010-01-30	5001	0	\N	0	0	\N	\N	0	275481	0	6273-7	3006451		
33965	3088	3006322	1950-08-02	1950-08-02 00:00:00	1950-08-02	5001	0	\N	0	0	\N	\N	0	205641	0	8331-1	3006322		
56241	5165	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	343287	0	6189-5	3006734		
25218	2318	3026361	1969-03-09	1969-03-09 00:00:00	1969-03-09	5001	0	\N	0	0	\N	\N	0	154115	0	26453-1	3026361		
36586	3364	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	223062	0	6095-4	3036780		
22310	2051	3006322	1976-10-18	1976-10-18 00:00:00	1976-10-18	5001	0	\N	0	0	\N	\N	0	136345	0	8331-1	3006322		
48079	4412	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	293384	0	6075-6	3005136		
24830	2280	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	151673	0	6085-5	3001247		
32582	1015	4052083	1979-12-29	1979-12-29 00:00:00	1979-12-29	5001	0	\N	0	0	\N	\N	0	66766	0	23426006	4052083		
106498	3279	4052083	2016-08-04	2016-08-04 00:00:00	2016-08-04	5001	0	\N	0	0	\N	\N	0	217918	0	23426006	4052083		
19357	1773	3001247	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	118557	0	6085-5	3001247		
56596	5194	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	345320	0	6085-5	3001247		
162722	4992	4024958	1996-08-19	1996-08-19 00:00:00	1996-08-19	5001	0	\N	0	0	\N	\N	0	332148	0	117015009	4024958		
50823	1541	4024958	1989-04-22	1989-04-22 00:00:00	1989-04-22	5001	0	\N	0	0	\N	\N	0	103242	0	117015009	4024958		
31441	2871	3049273	2017-03-15	2017-03-15 00:00:00	2017-03-15	5001	0	\N	0	0	\N	\N	0	191095	0	38265-5	3049273		
15434	1411	3014576	1999-11-23	1999-11-23 00:00:00	1999-11-23	5001	0	\N	0	0	\N	\N	0	93967	0	2075-0	3014576		
62288	1911	4024958	1989-08-02	1989-08-02 00:00:00	1989-08-02	5001	0	\N	0	0	\N	\N	0	127127	0	117015009	4024958		
53791	4932	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	327805	0	6206-7	3012494		
11481	1099	3006322	1993-04-30	1993-04-30 00:00:00	1993-04-30	5001	0	\N	0	0	\N	\N	0	72206	0	8331-1	3006322		
93123	2866	4133840	2001-04-29	2001-04-29 00:00:00	2001-04-29	5001	0	\N	0	0	\N	\N	0	190676	0	127783003	4133840		
63484	1950	4133840	1993-09-30	1993-09-30 00:00:00	1993-09-30	5001	0	\N	0	0	\N	\N	0	129656	0	127783003	4133840		
1714	152	3045716	1973-12-15	1973-12-15 00:00:00	1973-12-15	5001	0	\N	0	0	\N	\N	0	10291	0	33037-3	3045716		
49845	4532	3006322	1912-02-07	1912-02-07 00:00:00	1912-02-07	5001	0	\N	0	0	\N	\N	0	301913	0	8331-1	3006322		
23800	2186	3014599	1975-03-07	1975-03-07 00:00:00	1975-03-07	5001	0	\N	0	0	\N	\N	0	145721	0	6106-9	3014599		
34519	3157	3006322	2002-11-27	2002-11-27 00:00:00	2002-11-27	5001	0	\N	0	0	\N	\N	0	209884	0	8331-1	3006322		
45878	4226	3006451	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	280670	0	6273-7	3006451		
2636	263	3051031	2003-01-04	2003-01-04 00:00:00	2003-01-04	5001	0	\N	0	0	\N	\N	0	17471	0	46240-8	3051031		
57348	5265	3051031	2003-08-12	2003-08-12 00:00:00	2003-08-12	5001	0	\N	0	0	\N	\N	0	350276	0	46240-8	3051031		
52381	4819	3006322	1967-08-14	1967-08-14 00:00:00	1967-08-14	5001	0	\N	0	0	\N	\N	0	320512	0	8331-1	3006322		
12775	1217	3011505	2001-07-06	2001-07-06 00:00:00	2001-07-06	5001	0	\N	0	0	\N	\N	0	80194	0	19926-5	3011505		
25536	2339	3020655	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	155630	0	6844-5	3020655		
15178	1397	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	92751	0	6248-9	3015076		
150248	4608	4133840	2014-02-06	2014-02-06 00:00:00	2014-02-06	5001	0	\N	0	0	\N	\N	0	307091	0	127783003	4133840		
2295	69	4052083	2000-11-15	2000-11-15 00:00:00	2000-11-15	5001	0	\N	0	0	\N	\N	0	4701	0	23426006	4052083		
57811	1762	4133840	1961-03-09	1961-03-09 00:00:00	1961-03-09	5001	0	\N	0	0	\N	\N	0	117887	0	127783003	4133840		
35786	3279	3021226	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	217867	0	6246-3	3021226		
56538	5189	3006322	2012-11-13	2012-11-13 00:00:00	2012-11-13	5001	0	\N	0	0	\N	\N	0	344918	0	8331-1	3006322		
136615	4212	4024958	1992-10-26	1992-10-26 00:00:00	1992-10-26	5001	0	\N	0	0	\N	\N	0	279664	0	117015009	4024958		
152543	4676	4052083	2014-10-29	2014-10-29 00:00:00	2014-10-29	5001	0	\N	0	0	\N	\N	0	311598	0	23426006	4052083		
11221	1082	3006451	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	70975	0	6273-7	3006451		
26174	2402	3036780	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	159619	0	6095-4	3036780		
10184	326	4024958	1979-09-23	1979-09-23 00:00:00	1979-09-23	5001	0	\N	0	0	\N	\N	0	21553	0	117015009	4024958		
81444	2518	4133840	2003-08-22	2003-08-22 00:00:00	2003-08-22	5001	0	\N	0	0	\N	\N	0	166567	0	127783003	4133840		
34338	3128	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	208215	0	6246-3	3021226		
16022	1466	3006322	2008-11-24	2008-11-24 00:00:00	2008-11-24	5001	0	\N	0	0	\N	\N	0	97612	0	8331-1	3006322		
14240	1328	3011505	2004-09-16	2004-09-16 00:00:00	2004-09-16	5001	0	\N	0	0	\N	\N	0	88211	0	19926-5	3011505		
39963	3717	3005136	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	247016	0	6075-6	3005136		
64772	1986	4024958	1993-11-21	1993-11-21 00:00:00	1993-11-21	5001	0	\N	0	0	\N	\N	0	132248	0	117015009	4024958		
28489	882	4024958	1957-06-07	1957-06-07 00:00:00	1957-06-07	5001	0	\N	0	0	\N	\N	0	58675	0	117015009	4024958		
36395	3343	3012494	1977-07-13	1977-07-13 00:00:00	1977-07-13	5001	0	\N	0	0	\N	\N	0	221770	0	6206-7	3012494		
31257	2858	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	189825	0	7258-7	3001488		
7179	695	3051031	1979-11-18	1979-11-18 00:00:00	1979-11-18	5001	0	\N	0	0	\N	\N	0	45990	0	46240-8	3051031		
16914	1537	3008598	2010-05-31	2010-05-31 00:00:00	2010-05-31	5001	0	\N	0	0	\N	\N	0	102871	0	3024-7	3008598		
35349	3237	3006322	1948-04-04	1948-04-04 00:00:00	1948-04-04	5001	0	\N	0	0	\N	\N	0	215220	0	8331-1	3006322		
35429	3244	3006322	2001-05-05	2001-05-05 00:00:00	2001-05-05	5001	0	\N	0	0	\N	\N	0	215714	0	8331-1	3006322		
55002	5035	3006322	1975-01-12	1975-01-12 00:00:00	1975-01-12	5001	0	\N	0	0	\N	\N	0	334589	0	8331-1	3006322		
46870	4313	3001488	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	286336	0	7258-7	3001488		
57741	5300	3006322	1986-07-29	1986-07-29 00:00:00	1986-07-29	5001	0	\N	0	0	\N	\N	0	352605	0	8331-1	3006322		
58345	5343	3006734	1999-07-11	1999-07-11 00:00:00	1999-07-11	5001	0	\N	0	0	\N	\N	0	355823	0	6189-5	3006734		
21764	2002	40766240	2004-09-01	2004-09-01 00:00:00	2004-09-01	5001	0	\N	0	0	\N	\N	0	133343	0	63513-6	40766240		
33155	2992	3049273	2012-05-17	2012-05-17 00:00:00	2012-05-17	5001	0	\N	0	0	\N	\N	0	199768	0	38265-5	3049273		
80068	2463	4052083	1999-01-04	1999-01-04 00:00:00	1999-01-04	5001	0	\N	0	0	\N	\N	0	163390	0	23426006	4052083		
39628	3680	3015076	1995-10-10	1995-10-10 00:00:00	1995-10-10	5001	0	\N	0	0	\N	\N	0	244695	0	6248-9	3015076		
152477	4675	4052083	1984-08-28	1984-08-28 00:00:00	1984-08-28	5001	0	\N	0	0	\N	\N	0	311438	0	23426006	4052083		
44842	4145	3015076	2010-01-30	2010-01-30 00:00:00	2010-01-30	5001	0	\N	0	0	\N	\N	0	275481	0	6248-9	3015076		
33966	3088	3006322	1998-05-30	1998-05-30 00:00:00	1998-05-30	5001	0	\N	0	0	\N	\N	0	205684	0	8331-1	3006322		
56242	5165	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	343287	0	6276-0	3027231		
25219	2318	21494966	1969-03-09	1969-03-09 00:00:00	1969-03-09	5001	0	\N	0	0	\N	\N	0	154115	0	80271-0	21494966		
36587	3364	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	223062	0	6189-5	3006734		
22311	2051	3006322	1993-06-13	1993-06-13 00:00:00	1993-06-13	5001	0	\N	0	0	\N	\N	0	136350	0	8331-1	3006322		
48080	4412	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	293384	0	6106-9	3014599		
24831	2280	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	151673	0	6189-5	3006734		
32587	1015	4052083	1984-11-21	1984-11-21 00:00:00	1984-11-21	5001	0	\N	0	0	\N	\N	0	66819	0	23426006	4052083		
117789	3626	4024958	1982-06-23	1982-06-23 00:00:00	1982-06-23	5001	0	\N	0	0	\N	\N	0	241131	0	117015009	4024958		
19358	1773	3014599	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	118557	0	6106-9	3014599		
56597	5194	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	345320	0	7258-7	3001488		
50702	1538	4024958	1937-06-28	1937-06-28 00:00:00	1937-06-28	5001	0	\N	0	0	\N	\N	0	102950	0	117015009	4024958		
50832	1541	4052083	1996-01-08	1996-01-08 00:00:00	1996-01-08	5001	0	\N	0	0	\N	\N	0	103248	0	23426006	4052083		
31442	2871	3006322	1955-09-19	1955-09-19 00:00:00	1955-09-19	5001	0	\N	0	0	\N	\N	0	191119	0	8331-1	3006322		
15435	1411	3006923	1999-11-23	1999-11-23 00:00:00	1999-11-23	5001	0	\N	0	0	\N	\N	0	93967	0	1742-6	3006923		
62290	1911	4133840	2006-10-23	2006-10-23 00:00:00	2006-10-23	5001	0	\N	0	0	\N	\N	0	127172	0	127783003	4133840		
53792	4932	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	327805	0	6082-2	3000876		
11482	1099	3006322	1982-12-14	1982-12-14 00:00:00	1982-12-14	5001	0	\N	0	0	\N	\N	0	72243	0	8331-1	3006322		
11530	1102	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	72441	0	6095-4	3036780		
63486	1950	4133840	2018-02-22	2018-02-22 00:00:00	2018-02-22	5001	0	\N	0	0	\N	\N	0	129666	0	127783003	4133840		
63717	1956	4024958	1994-01-27	1994-01-27 00:00:00	1994-01-27	5001	0	\N	0	0	\N	\N	0	130204	0	117015009	4024958		
49846	4532	3006322	1970-02-02	1970-02-02 00:00:00	1970-02-02	5001	0	\N	0	0	\N	\N	0	301908	0	8331-1	3006322		
23801	2186	3006734	1975-03-07	1975-03-07 00:00:00	1975-03-07	5001	0	\N	0	0	\N	\N	0	145721	0	6189-5	3006734		
34520	3157	3006322	1970-06-07	1970-06-07 00:00:00	1970-06-07	5001	0	\N	0	0	\N	\N	0	209892	0	8331-1	3006322		
45879	4226	3027231	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	280670	0	6276-0	3027231		
2637	263	40758406	2003-01-04	2003-01-04 00:00:00	2003-01-04	5001	0	\N	0	0	\N	\N	0	17471	0	55277-8	40758406		
57351	5265	46235214	2003-08-12	2003-08-12 00:00:00	2003-08-12	5001	0	\N	0	0	\N	\N	0	350276	0	76690-7	46235214		
52382	4820	3006322	1968-02-04	1968-02-04 00:00:00	1968-02-04	5001	0	\N	0	0	\N	\N	0	320618	0	8331-1	3006322		
12776	1217	3011505	1995-06-30	1995-06-30 00:00:00	1995-06-30	5001	0	\N	0	0	\N	\N	0	80192	0	19926-5	3011505		
25537	2339	3001247	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	155630	0	6085-5	3001247		
15179	1397	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	92751	0	6075-6	3005136		
150253	4608	4133840	2004-12-16	2004-12-16 00:00:00	2004-12-16	5001	0	\N	0	0	\N	\N	0	307089	0	127783003	4133840		
2302	69	4052083	1975-02-28	1975-02-28 00:00:00	1975-02-28	5001	0	\N	0	0	\N	\N	0	4687	0	23426006	4052083		
57815	1762	4133840	2004-02-12	2004-02-12 00:00:00	2004-02-12	5001	0	\N	0	0	\N	\N	0	117856	0	127783003	4133840		
35787	3279	3020655	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	217867	0	6844-5	3020655		
56539	5190	3006322	1974-10-21	1974-10-21 00:00:00	1974-10-21	5001	0	\N	0	0	\N	\N	0	344974	0	8331-1	3006322		
136619	4212	4024958	1982-09-05	1982-09-05 00:00:00	1982-09-05	5001	0	\N	0	0	\N	\N	0	279646	0	117015009	4024958		
152546	4676	4024958	1995-11-22	1995-11-22 00:00:00	1995-11-22	5001	0	\N	0	0	\N	\N	0	311589	0	117015009	4024958		
11222	1082	3021226	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	70975	0	6246-3	3021226		
26175	2402	3014599	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	159619	0	6106-9	3014599		
92312	2845	4024958	1994-12-16	1994-12-16 00:00:00	1994-12-16	5001	0	\N	0	0	\N	\N	0	188902	0	117015009	4024958		
92741	2858	4024958	1914-07-26	1914-07-26 00:00:00	1914-07-26	5001	0	\N	0	0	\N	\N	0	189738	0	117015009	4024958		
34339	3128	40769179	1973-08-01	1973-08-01 00:00:00	1973-08-01	5001	0	\N	0	0	\N	\N	0	208172	0	66519-0	40769179		
16023	1466	3006322	1975-06-30	1975-06-30 00:00:00	1975-06-30	5001	0	\N	0	0	\N	\N	0	97620	0	8331-1	3006322		
14241	1328	3011505	1993-12-30	1993-12-30 00:00:00	1993-12-30	5001	0	\N	0	0	\N	\N	0	88229	0	19926-5	3011505		
39964	3717	3027231	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	247016	0	6276-0	3027231		
143267	4403	4133840	1994-06-11	1994-06-11 00:00:00	1994-06-11	5001	0	\N	0	0	\N	\N	0	292690	0	127783003	4133840		
28494	882	4024958	1971-01-24	1971-01-24 00:00:00	1971-01-24	5001	0	\N	0	0	\N	\N	0	58758	0	117015009	4024958		
106975	3296	4052083	2004-07-04	2004-07-04 00:00:00	2004-07-04	5001	0	\N	0	0	\N	\N	0	219068	0	23426006	4052083		
31258	2858	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	189825	0	6844-5	3020655		
7181	695	40766240	1979-11-18	1979-11-18 00:00:00	1979-11-18	5001	0	\N	0	0	\N	\N	0	45990	0	63513-6	40766240		
87679	2709	4024958	2008-03-14	2008-03-14 00:00:00	2008-03-14	5001	0	\N	0	0	\N	\N	0	179489	0	117015009	4024958		
35350	3237	3006322	1985-09-10	1985-09-10 00:00:00	1985-09-10	5001	0	\N	0	0	\N	\N	0	215198	0	8331-1	3006322		
35430	3244	3006322	1986-01-13	1986-01-13 00:00:00	1986-01-13	5001	0	\N	0	0	\N	\N	0	215712	0	8331-1	3006322		
55004	5035	3006322	1943-09-19	1943-09-19 00:00:00	1943-09-19	5001	0	\N	0	0	\N	\N	0	334543	0	8331-1	3006322		
46871	4313	3006734	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	286336	0	6189-5	3006734		
57742	5300	3049273	2018-03-18	2018-03-18 00:00:00	2018-03-18	5001	0	\N	0	0	\N	\N	0	352657	0	38265-5	3049273		
58346	5343	3023430	1999-07-11	1999-07-11 00:00:00	1999-07-11	5001	0	\N	0	0	\N	\N	0	355823	0	6833-8	3023430		
21766	2002	3051031	1976-04-11	1976-04-11 00:00:00	1976-04-11	5001	0	\N	0	0	\N	\N	0	133323	0	46240-8	3051031		
33156	2992	3006322	2002-10-08	2002-10-08 00:00:00	2002-10-08	5001	0	\N	0	0	\N	\N	0	199696	0	8331-1	3006322		
69002	2116	4024958	1984-12-21	1984-12-21 00:00:00	1984-12-21	5001	0	\N	0	0	\N	\N	0	140804	0	117015009	4024958		
39629	3680	3006322	1999-11-17	1999-11-17 00:00:00	1999-11-17	5001	0	\N	0	0	\N	\N	0	244702	0	8331-1	3006322		
152478	4675	4024958	1921-10-19	1921-10-19 00:00:00	1921-10-19	5001	0	\N	0	0	\N	\N	0	311427	0	117015009	4024958		
44843	4145	3019406	2010-01-30	2010-01-30 00:00:00	2010-01-30	5001	0	\N	0	0	\N	\N	0	275481	0	6158-0	3019406		
33967	3088	3009542	1999-03-30	1999-03-30 00:00:00	1999-03-30	5001	0	\N	0	0	\N	\N	0	205619	0	20570-8	3009542		
56243	5165	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	343287	0	6844-5	3020655		
25220	2318	3004501	1969-03-09	1969-03-09 00:00:00	1969-03-09	5001	0	\N	0	0	\N	\N	0	154115	0	2345-7	3004501		
36588	3364	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	223062	0	6844-5	3020655		
22312	2051	3006322	1974-05-22	1974-05-22 00:00:00	1974-05-22	5001	0	\N	0	0	\N	\N	0	136354	0	8331-1	3006322		
48081	4412	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	293384	0	6082-2	3000876		
24832	2280	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	151673	0	6206-7	3012494		
32624	1016	4024958	2011-11-16	2011-11-16 00:00:00	2011-11-16	5001	0	\N	0	0	\N	\N	0	66920	0	117015009	4024958		
117794	3626	4024958	2005-08-31	2005-08-31 00:00:00	2005-08-31	5001	0	\N	0	0	\N	\N	0	241139	0	117015009	4024958		
19359	1773	3019406	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	118557	0	6158-0	3019406		
56598	5195	3006322	1992-04-27	1992-04-27 00:00:00	1992-04-27	5001	0	\N	0	0	\N	\N	0	345476	0	8331-1	3006322		
50710	1538	4052083	2010-04-28	2010-04-28 00:00:00	2010-04-28	5001	0	\N	0	0	\N	\N	0	103068	0	23426006	4052083		
46472	4278	3011505	2009-10-16	2009-10-16 00:00:00	2009-10-16	5001	0	\N	0	0	\N	\N	0	283862	0	19926-5	3011505		
31444	2872	3006322	1974-11-19	1974-11-19 00:00:00	1974-11-19	5001	0	\N	0	0	\N	\N	0	191180	0	8331-1	3006322		
15436	1411	3010813	1999-11-23	1999-11-23 00:00:00	1999-11-23	5001	0	\N	0	0	\N	\N	0	93967	0	26464-8	3010813		
73571	2261	4052083	2017-04-12	2017-04-12 00:00:00	2017-04-12	5001	0	\N	0	0	\N	\N	0	150315	0	23426006	4052083		
53793	4932	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	327805	0	7258-7	3001488		
11483	1099	3006322	1997-10-15	1997-10-15 00:00:00	1997-10-15	5001	0	\N	0	0	\N	\N	0	72209	0	8331-1	3006322		
11531	1102	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	72441	0	7258-7	3001488		
63488	1950	4024958	1982-12-31	1982-12-31 00:00:00	1982-12-31	5001	0	\N	0	0	\N	\N	0	129699	0	117015009	4024958		
75008	2298	4024958	1992-02-17	1992-02-17 00:00:00	1992-02-17	5001	0	\N	0	0	\N	\N	0	152986	0	117015009	4024958		
49850	4534	3006322	1951-04-28	1951-04-28 00:00:00	1951-04-28	5001	0	\N	0	0	\N	\N	0	302054	0	8331-1	3006322		
23807	2189	3006322	1998-04-02	1998-04-02 00:00:00	1998-04-02	5001	0	\N	0	0	\N	\N	0	145920	0	8331-1	3006322		
34521	3157	3006322	1972-01-13	1972-01-13 00:00:00	1972-01-13	5001	0	\N	0	0	\N	\N	0	209865	0	8331-1	3006322		
45880	4226	3001247	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	280670	0	6085-5	3001247		
2638	263	46235214	2003-01-04	2003-01-04 00:00:00	2003-01-04	5001	0	\N	0	0	\N	\N	0	17471	0	76690-7	46235214		
57352	5267	3006322	1979-03-04	1979-03-04 00:00:00	1979-03-04	5001	0	\N	0	0	\N	\N	0	350355	0	8331-1	3006322		
52383	4820	3006322	1996-01-03	1996-01-03 00:00:00	1996-01-03	5001	0	\N	0	0	\N	\N	0	320654	0	8331-1	3006322		
12777	1217	3011505	2019-01-18	2019-01-18 00:00:00	2019-01-18	5001	0	\N	0	0	\N	\N	0	80134	0	19926-5	3011505		
25538	2339	3021226	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	155630	0	6246-3	3021226		
15180	1397	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	92751	0	6095-4	3036780		
150260	4608	4133840	2016-02-18	2016-02-18 00:00:00	2016-02-18	5001	0	\N	0	0	\N	\N	0	307092	0	127783003	4133840		
2307	69	4024958	1948-04-06	1948-04-06 00:00:00	1948-04-06	5001	0	\N	0	0	\N	\N	0	4692	0	117015009	4024958		
57817	1762	4133840	1991-02-28	1991-02-28 00:00:00	1991-02-28	5001	0	\N	0	0	\N	\N	0	117819	0	127783003	4133840		
35788	3279	3001247	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	217867	0	6085-5	3001247		
56540	5190	3006322	1964-07-24	1964-07-24 00:00:00	1964-07-24	5001	0	\N	0	0	\N	\N	0	345026	0	8331-1	3006322		
136620	4212	4052083	2014-12-18	2014-12-18 00:00:00	2014-12-18	5001	0	\N	0	0	\N	\N	0	279666	0	23426006	4052083		
152550	4676	4024958	2015-03-26	2015-03-26 00:00:00	2015-03-26	5001	0	\N	0	0	\N	\N	0	311599	0	117015009	4024958		
11223	1082	3000876	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	70975	0	6082-2	3000876		
26176	2402	3027231	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	159619	0	6276-0	3027231		
92316	2845	4052083	1961-01-19	1961-01-19 00:00:00	1961-01-19	5001	0	\N	0	0	\N	\N	0	188905	0	23426006	4052083		
92747	2858	4024958	1930-08-27	1930-08-27 00:00:00	1930-08-27	5001	0	\N	0	0	\N	\N	0	189823	0	117015009	4024958		
34340	3128	40769184	1973-08-01	1973-08-01 00:00:00	1973-08-01	5001	0	\N	0	0	\N	\N	0	208172	0	66524-0	40769184		
16024	1466	3006322	1998-11-04	1998-11-04 00:00:00	1998-11-04	5001	0	\N	0	0	\N	\N	0	97662	0	8331-1	3006322		
14242	1328	3011505	2014-04-03	2014-04-03 00:00:00	2014-04-03	5001	0	\N	0	0	\N	\N	0	88196	0	19926-5	3011505		
39965	3717	3006734	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	247016	0	6189-5	3006734		
143271	4403	4052083	1982-07-12	1982-07-12 00:00:00	1982-07-12	5001	0	\N	0	0	\N	\N	0	292669	0	23426006	4052083		
28501	883	4052083	1987-01-24	1987-01-24 00:00:00	1987-01-24	5001	0	\N	0	0	\N	\N	0	58810	0	23426006	4052083		
106976	3296	4024958	1939-04-16	1939-04-16 00:00:00	1939-04-16	5001	0	\N	0	0	\N	\N	0	219084	0	117015009	4024958		
31259	2858	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	189825	0	6189-5	3006734		
149571	4586	4024958	1992-04-26	1992-04-26 00:00:00	1992-04-26	5001	0	\N	0	0	\N	\N	0	305521	0	117015009	4024958		
99003	3035	4052083	1974-08-25	1974-08-25 00:00:00	1974-08-25	5001	0	\N	0	0	\N	\N	0	202180	0	23426006	4052083		
35351	3237	3006322	2009-12-01	2009-12-01 00:00:00	2009-12-01	5001	0	\N	0	0	\N	\N	0	215191	0	8331-1	3006322		
35432	3244	3051031	1974-06-17	1974-06-17 00:00:00	1974-06-17	5001	0	\N	0	0	\N	\N	0	215710	0	46240-8	3051031		
55005	5035	3049273	1997-08-14	1997-08-14 00:00:00	1997-08-14	5001	0	\N	0	0	\N	\N	0	334576	0	38265-5	3049273		
46872	4313	3027231	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	286336	0	6276-0	3027231		
57743	5300	3006322	1962-02-16	1962-02-16 00:00:00	1962-02-16	5001	0	\N	0	0	\N	\N	0	352602	0	8331-1	3006322		
58347	5343	3005136	1999-07-11	1999-07-11 00:00:00	1999-07-11	5001	0	\N	0	0	\N	\N	0	355823	0	6075-6	3005136		
21767	2002	46235214	1976-04-11	1976-04-11 00:00:00	1976-04-11	5001	0	\N	0	0	\N	\N	0	133323	0	76690-7	46235214		
33157	2992	3006322	1992-11-30	1992-11-30 00:00:00	1992-11-30	5001	0	\N	0	0	\N	\N	0	199695	0	8331-1	3006322		
33183	2997	3006322	2015-12-08	2015-12-08 00:00:00	2015-12-08	5001	0	\N	0	0	\N	\N	0	199941	0	8331-1	3006322		
39630	3680	3001488	1992-04-07	1992-04-07 00:00:00	1992-04-07	5001	0	\N	0	0	\N	\N	0	244679	0	7258-7	3001488		
152507	4675	4052083	1972-06-16	1972-06-16 00:00:00	1972-06-16	5001	0	\N	0	0	\N	\N	0	311497	0	23426006	4052083		
44844	4145	3027231	2006-07-29	2006-07-29 00:00:00	2006-07-29	5001	0	\N	0	0	\N	\N	0	275533	0	6276-0	3027231		
33968	3088	3000963	1999-03-30	1999-03-30 00:00:00	1999-03-30	5001	0	\N	0	0	\N	\N	0	205619	0	718-7	3000963		
56244	5165	3006322	1973-01-03	1973-01-03 00:00:00	1973-01-03	5001	0	\N	0	0	\N	\N	0	343247	0	8331-1	3006322		
25221	2318	3006906	1969-03-09	1969-03-09 00:00:00	1969-03-09	5001	0	\N	0	0	\N	\N	0	154115	0	17861-6	3006906		
36589	3364	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	223062	0	6833-8	3023430		
22313	2051	3006322	1980-07-11	1980-07-11 00:00:00	1980-07-11	5001	0	\N	0	0	\N	\N	0	136346	0	8331-1	3006322		
48082	4412	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	293384	0	6833-8	3023430		
24833	2280	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	151673	0	6075-6	3005136		
32629	1017	4024958	1966-10-15	1966-10-15 00:00:00	1966-10-15	5001	0	\N	0	0	\N	\N	0	66988	0	117015009	4024958		
27911	869	4052083	1997-04-04	1997-04-04 00:00:00	1997-04-04	5001	0	\N	0	0	\N	\N	0	57754	0	23426006	4052083		
19360	1773	3001488	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	118557	0	7258-7	3001488		
56599	5195	3006322	1961-09-11	1961-09-11 00:00:00	1961-09-11	5001	0	\N	0	0	\N	\N	0	345411	0	8331-1	3006322		
50753	1538	4052083	2006-04-04	2006-04-04 00:00:00	2006-04-04	5001	0	\N	0	0	\N	\N	0	103039	0	23426006	4052083		
46473	4278	3011505	2000-04-28	2000-04-28 00:00:00	2000-04-28	5001	0	\N	0	0	\N	\N	0	283886	0	19926-5	3011505		
31445	2872	3006322	1968-04-15	1968-04-15 00:00:00	1968-04-15	5001	0	\N	0	0	\N	\N	0	191217	0	8331-1	3006322		
15437	1411	3006322	1981-06-08	1981-06-08 00:00:00	1981-06-08	5001	0	\N	0	0	\N	\N	0	93928	0	8331-1	3006322		
73608	2264	4024958	1981-05-09	1981-05-09 00:00:00	1981-05-09	5001	0	\N	0	0	\N	\N	0	150445	0	117015009	4024958		
53794	4932	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	327805	0	6189-5	3006734		
11484	1099	3001247	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	72208	0	6085-5	3001247		
11532	1102	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	72441	0	6833-8	3023430		
63490	1950	4133840	1995-10-12	1995-10-12 00:00:00	1995-10-12	5001	0	\N	0	0	\N	\N	0	129657	0	127783003	4133840		
75010	2298	4052083	1982-03-11	1982-03-11 00:00:00	1982-03-11	5001	0	\N	0	0	\N	\N	0	153004	0	23426006	4052083		
49851	4534	3049273	1996-05-21	1996-05-21 00:00:00	1996-05-21	5001	0	\N	0	0	\N	\N	0	302077	0	38265-5	3049273		
35106	3207	3006322	1971-02-09	1971-02-09 00:00:00	1971-02-09	5001	0	\N	0	0	\N	\N	0	213147	0	8331-1	3006322		
34522	3157	3006322	1965-12-20	1965-12-20 00:00:00	1965-12-20	5001	0	\N	0	0	\N	\N	0	209814	0	8331-1	3006322		
45881	4226	3006734	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	280670	0	6189-5	3006734		
2639	263	40766240	2003-01-04	2003-01-04 00:00:00	2003-01-04	5001	0	\N	0	0	\N	\N	0	17471	0	63513-6	40766240		
57353	5267	3006322	1971-05-15	1971-05-15 00:00:00	1971-05-15	5001	0	\N	0	0	\N	\N	0	350352	0	8331-1	3006322		
52384	4820	3006322	1989-01-25	1989-01-25 00:00:00	1989-01-25	5001	0	\N	0	0	\N	\N	0	320669	0	8331-1	3006322		
12778	1217	3006322	1973-06-12	1973-06-12 00:00:00	1973-06-12	5001	0	\N	0	0	\N	\N	0	80153	0	8331-1	3006322		
25539	2339	3036780	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	155630	0	6095-4	3036780		
15181	1397	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	92751	0	6276-0	3027231		
150266	4608	4133840	2009-01-08	2009-01-08 00:00:00	2009-01-08	5001	0	\N	0	0	\N	\N	0	307019	0	127783003	4133840		
105765	3253	4024958	1984-12-17	1984-12-17 00:00:00	1984-12-17	5001	0	\N	0	0	\N	\N	0	216326	0	117015009	4024958		
69099	2119	4024958	1961-10-13	1961-10-13 00:00:00	1961-10-13	5001	0	\N	0	0	\N	\N	0	140998	0	117015009	4024958		
35789	3279	3000876	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	217867	0	6082-2	3000876		
56541	5190	3006322	1967-09-17	1967-09-17 00:00:00	1967-09-17	5001	0	\N	0	0	\N	\N	0	345027	0	8331-1	3006322		
75713	2325	4024958	2018-10-30	2018-10-30 00:00:00	2018-10-30	5001	0	\N	0	0	\N	\N	0	154562	0	117015009	4024958		
49688	1512	4052083	1979-07-17	1979-07-17 00:00:00	1979-07-17	5001	0	\N	0	0	\N	\N	0	100959	0	23426006	4052083		
11224	1082	3027231	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	70975	0	6276-0	3027231		
26177	2402	3015076	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	159619	0	6248-9	3015076		
92326	2846	4052083	2003-11-21	2003-11-21 00:00:00	2003-11-21	5001	0	\N	0	0	\N	\N	0	189013	0	23426006	4052083		
92761	2858	4024958	1910-11-20	1910-11-20 00:00:00	1910-11-20	5001	0	\N	0	0	\N	\N	0	189873	0	117015009	4024958		
34341	3128	40769194	1973-08-01	1973-08-01 00:00:00	1973-08-01	5001	0	\N	0	0	\N	\N	0	208172	0	66534-9	40769194		
16025	1466	3006322	1978-02-27	1978-02-27 00:00:00	1978-02-27	5001	0	\N	0	0	\N	\N	0	97621	0	8331-1	3006322		
14243	1328	3011505	2019-05-02	2019-05-02 00:00:00	2019-05-02	5001	0	\N	0	0	\N	\N	0	88175	0	19926-5	3011505		
39966	3717	3006322	1999-09-04	1999-09-04 00:00:00	1999-09-04	5001	0	\N	0	0	\N	\N	0	246979	0	8331-1	3006322		
143273	4403	4133840	1989-05-13	1989-05-13 00:00:00	1989-05-13	5001	0	\N	0	0	\N	\N	0	292735	0	127783003	4133840		
28504	883	4024958	1969-09-14	1969-09-14 00:00:00	1969-09-14	5001	0	\N	0	0	\N	\N	0	58791	0	117015009	4024958		
106979	3296	4024958	1972-06-12	1972-06-12 00:00:00	1972-06-12	5001	0	\N	0	0	\N	\N	0	219099	0	117015009	4024958		
31260	2858	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	189825	0	6158-0	3019406		
149591	4586	4052083	1968-05-29	1968-05-29 00:00:00	1968-05-29	5001	0	\N	0	0	\N	\N	0	305464	0	23426006	4052083		
99011	3035	4024958	2007-11-08	2007-11-08 00:00:00	2007-11-08	5001	0	\N	0	0	\N	\N	0	202183	0	117015009	4024958		
35352	3237	3006322	2004-02-17	2004-02-17 00:00:00	2004-02-17	5001	0	\N	0	0	\N	\N	0	215190	0	8331-1	3006322		
35433	3244	40766240	1974-06-17	1974-06-17 00:00:00	1974-06-17	5001	0	\N	0	0	\N	\N	0	215710	0	63513-6	40766240		
55006	5035	3006322	1982-10-12	1982-10-12 00:00:00	1982-10-12	5001	0	\N	0	0	\N	\N	0	334641	0	8331-1	3006322		
46873	4313	3006451	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	286336	0	6273-7	3006451		
57744	5300	3006322	1948-10-17	1948-10-17 00:00:00	1948-10-17	5001	0	\N	0	0	\N	\N	0	352630	0	8331-1	3006322		
145320	4460	4024958	1954-10-03	1954-10-03 00:00:00	1954-10-03	5001	0	\N	0	0	\N	\N	0	296772	0	117015009	4024958		
21768	2002	40758406	1976-04-11	1976-04-11 00:00:00	1976-04-11	5001	0	\N	0	0	\N	\N	0	133323	0	55277-8	40758406		
33158	2992	3006322	1998-07-19	1998-07-19 00:00:00	1998-07-19	5001	0	\N	0	0	\N	\N	0	199688	0	8331-1	3006322		
33239	3000	3006322	2012-09-25	2012-09-25 00:00:00	2012-09-25	5001	0	\N	0	0	\N	\N	0	200199	0	8331-1	3006322		
39631	3680	3006451	1992-04-07	1992-04-07 00:00:00	1992-04-07	5001	0	\N	0	0	\N	\N	0	244679	0	6273-7	3006451		
163803	5031	4052083	1973-04-30	1973-04-30 00:00:00	1973-04-30	5001	0	\N	0	0	\N	\N	0	334331	0	23426006	4052083		
44845	4145	3021226	2006-07-29	2006-07-29 00:00:00	2006-07-29	5001	0	\N	0	0	\N	\N	0	275533	0	6246-3	3021226		
33970	3088	3006322	1960-09-08	1960-09-08 00:00:00	1960-09-08	5001	0	\N	0	0	\N	\N	0	205609	0	8331-1	3006322		
56245	5165	3006322	1977-02-07	1977-02-07 00:00:00	1977-02-07	5001	0	\N	0	0	\N	\N	0	343256	0	8331-1	3006322		
25222	2318	3016723	1969-03-09	1969-03-09 00:00:00	1969-03-09	5001	0	\N	0	0	\N	\N	0	154115	0	2160-0	3016723		
36590	3364	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	223062	0	6158-0	3019406		
22314	2052	3006322	2012-04-26	2012-04-26 00:00:00	2012-04-26	5001	0	\N	0	0	\N	\N	0	136413	0	8331-1	3006322		
48083	4412	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	293384	0	6085-5	3001247		
24834	2280	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	151673	0	6273-7	3006451		
22990	722	4052083	1969-07-12	1969-07-12 00:00:00	1969-07-12	5001	0	\N	0	0	\N	\N	0	47800	0	23426006	4052083		
27915	869	4052083	1980-06-30	1980-06-30 00:00:00	1980-06-30	5001	0	\N	0	0	\N	\N	0	57767	0	23426006	4052083		
19361	1773	3036780	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	118557	0	6095-4	3036780		
56600	5195	3049273	2015-09-08	2015-09-08 00:00:00	2015-09-08	5001	0	\N	0	0	\N	\N	0	345410	0	38265-5	3049273		
50759	1538	4052083	1992-11-18	1992-11-18 00:00:00	1992-11-18	5001	0	\N	0	0	\N	\N	0	103028	0	23426006	4052083		
46474	4278	3006322	1955-11-25	1955-11-25 00:00:00	1955-11-25	5001	0	\N	0	0	\N	\N	0	283902	0	8331-1	3006322		
31446	2872	3006322	1990-11-05	1990-11-05 00:00:00	1990-11-05	5001	0	\N	0	0	\N	\N	0	191220	0	8331-1	3006322		
15438	1411	3006322	1967-05-27	1967-05-27 00:00:00	1967-05-27	5001	0	\N	0	0	\N	\N	0	93963	0	8331-1	3006322		
73616	2264	4024958	2008-01-14	2008-01-14 00:00:00	2008-01-14	5001	0	\N	0	0	\N	\N	0	150476	0	117015009	4024958		
53795	4932	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	327805	0	6095-4	3036780		
11485	1099	3012494	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	72208	0	6206-7	3012494		
11533	1102	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	72441	0	6158-0	3019406		
63495	1950	4133840	2009-12-31	2009-12-31 00:00:00	2009-12-31	5001	0	\N	0	0	\N	\N	0	129622	0	127783003	4133840		
75063	2300	4133840	2018-04-05	2018-04-05 00:00:00	2018-04-05	5001	0	\N	0	0	\N	\N	0	153147	0	127783003	4133840		
49852	4534	3006322	1990-08-08	1990-08-08 00:00:00	1990-08-08	5001	0	\N	0	0	\N	\N	0	302099	0	8331-1	3006322		
35107	3207	3006322	2011-12-21	2011-12-21 00:00:00	2011-12-21	5001	0	\N	0	0	\N	\N	0	213183	0	8331-1	3006322		
34523	3158	3006322	1958-12-04	1958-12-04 00:00:00	1958-12-04	5001	0	\N	0	0	\N	\N	0	210009	0	8331-1	3006322		
45882	4226	3001488	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	280670	0	7258-7	3001488		
2642	263	3051031	2003-02-03	2003-02-03 00:00:00	2003-02-03	5001	0	\N	0	0	\N	\N	0	17438	0	46240-8	3051031		
57354	5267	3006322	1985-10-12	1985-10-12 00:00:00	1985-10-12	5001	0	\N	0	0	\N	\N	0	350429	0	8331-1	3006322		
52385	4820	3006322	2010-07-30	2010-07-30 00:00:00	2010-07-30	5001	0	\N	0	0	\N	\N	0	320671	0	8331-1	3006322		
12794	1219	3006322	1989-03-07	1989-03-07 00:00:00	1989-03-07	5001	0	\N	0	0	\N	\N	0	80212	0	8331-1	3006322		
25540	2339	3006322	1982-08-01	1982-08-01 00:00:00	1982-08-01	5001	0	\N	0	0	\N	\N	0	155612	0	8331-1	3006322		
15182	1397	3006322	2003-07-29	2003-07-29 00:00:00	2003-07-29	5001	0	\N	0	0	\N	\N	0	92765	0	8331-1	3006322		
150269	4608	4133840	1996-12-26	1996-12-26 00:00:00	1996-12-26	5001	0	\N	0	0	\N	\N	0	307017	0	127783003	4133840		
105773	3253	4024958	1987-03-23	1987-03-23 00:00:00	1987-03-23	5001	0	\N	0	0	\N	\N	0	216328	0	117015009	4024958		
69119	2119	4024958	1984-05-30	1984-05-30 00:00:00	1984-05-30	5001	0	\N	0	0	\N	\N	0	140965	0	117015009	4024958		
35790	3279	3015076	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	217867	0	6248-9	3015076		
56542	5190	3006322	2006-07-19	2006-07-19 00:00:00	2006-07-19	5001	0	\N	0	0	\N	\N	0	345044	0	8331-1	3006322		
75714	2325	4052083	1999-09-17	1999-09-17 00:00:00	1999-09-17	5001	0	\N	0	0	\N	\N	0	154619	0	23426006	4052083		
49698	1513	4024958	1993-02-21	1993-02-21 00:00:00	1993-02-21	5001	0	\N	0	0	\N	\N	0	101080	0	117015009	4024958		
11225	1082	3015076	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	70975	0	6248-9	3015076		
26178	2402	3005136	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	159619	0	6075-6	3005136		
92331	2846	4024958	1986-06-06	1986-06-06 00:00:00	1986-06-06	5001	0	\N	0	0	\N	\N	0	189005	0	117015009	4024958		
10194	327	4052083	1976-04-07	1976-04-07 00:00:00	1976-04-07	5001	0	\N	0	0	\N	\N	0	21570	0	23426006	4052083		
34342	3128	40769189	1973-08-01	1973-08-01 00:00:00	1973-08-01	5001	0	\N	0	0	\N	\N	0	208172	0	66529-9	40769189		
16026	1467	3006322	1951-09-30	1951-09-30 00:00:00	1951-09-30	5001	0	\N	0	0	\N	\N	0	97759	0	8331-1	3006322		
14244	1328	3011505	1985-12-12	1985-12-12 00:00:00	1985-12-12	5001	0	\N	0	0	\N	\N	0	88221	0	19926-5	3011505		
39967	3717	3006322	2010-02-02	2010-02-02 00:00:00	2010-02-02	5001	0	\N	0	0	\N	\N	0	246992	0	8331-1	3006322		
143275	4403	4024958	1959-09-23	1959-09-23 00:00:00	1959-09-23	5001	0	\N	0	0	\N	\N	0	292654	0	117015009	4024958		
28513	883	4024958	2003-08-24	2003-08-24 00:00:00	2003-08-24	5001	0	\N	0	0	\N	\N	0	58773	0	117015009	4024958		
106987	3296	4024958	2003-12-08	2003-12-08 00:00:00	2003-12-08	5001	0	\N	0	0	\N	\N	0	219067	0	117015009	4024958		
31261	2858	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	189825	0	6206-7	3012494		
149593	4587	4052083	2003-07-02	2003-07-02 00:00:00	2003-07-02	5001	0	\N	0	0	\N	\N	0	305598	0	23426006	4052083		
99021	3035	4052083	1986-10-30	1986-10-30 00:00:00	1986-10-30	5001	0	\N	0	0	\N	\N	0	202168	0	23426006	4052083		
35354	3237	3006322	1971-10-13	1971-10-13 00:00:00	1971-10-13	5001	0	\N	0	0	\N	\N	0	215223	0	8331-1	3006322		
35435	3244	40758406	1974-06-17	1974-06-17 00:00:00	1974-06-17	5001	0	\N	0	0	\N	\N	0	215710	0	55277-8	40758406		
55008	5035	3006322	1976-04-21	1976-04-21 00:00:00	1976-04-21	5001	0	\N	0	0	\N	\N	0	334639	0	8331-1	3006322		
46874	4313	3006322	1954-10-12	1954-10-12 00:00:00	1954-10-12	5001	0	\N	0	0	\N	\N	0	286308	0	8331-1	3006322		
57745	5300	3000963	1945-02-13	1945-02-13 00:00:00	1945-02-13	5001	0	\N	0	0	\N	\N	0	352654	0	718-7	3000963		
145324	4460	4052083	2008-08-21	2008-08-21 00:00:00	2008-08-21	5001	0	\N	0	0	\N	\N	0	296798	0	23426006	4052083		
21769	2002	40766240	1976-04-11	1976-04-11 00:00:00	1976-04-11	5001	0	\N	0	0	\N	\N	0	133323	0	63513-6	40766240		
33159	2992	3006322	2005-01-04	2005-01-04 00:00:00	2005-01-04	5001	0	\N	0	0	\N	\N	0	199697	0	8331-1	3006322		
33240	3000	3006322	1976-11-12	1976-11-12 00:00:00	1976-11-12	5001	0	\N	0	0	\N	\N	0	200196	0	8331-1	3006322		
39632	3680	3015076	1992-04-07	1992-04-07 00:00:00	1992-04-07	5001	0	\N	0	0	\N	\N	0	244679	0	6248-9	3015076		
163809	5034	4024958	1973-06-24	1973-06-24 00:00:00	1973-06-24	5001	0	\N	0	0	\N	\N	0	334486	0	117015009	4024958		
44846	4145	3006451	2006-07-29	2006-07-29 00:00:00	2006-07-29	5001	0	\N	0	0	\N	\N	0	275533	0	6273-7	3006451		
17564	1597	3006322	2006-03-11	2006-03-11 00:00:00	2006-03-11	5001	0	\N	0	0	\N	\N	0	107161	0	8331-1	3006322		
56246	5165	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	343257	0	6189-5	3006734		
25223	2318	3013721	1969-03-09	1969-03-09 00:00:00	1969-03-09	5001	0	\N	0	0	\N	\N	0	154115	0	1920-8	3013721		
36591	3364	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	223062	0	6276-0	3027231		
22315	2052	3006322	1987-03-26	1987-03-26 00:00:00	1987-03-26	5001	0	\N	0	0	\N	\N	0	136408	0	8331-1	3006322		
48084	4412	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	293384	0	6189-5	3006734		
24835	2280	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	151673	0	6095-4	3036780		
22993	722	4052083	1975-08-19	1975-08-19 00:00:00	1975-08-19	5001	0	\N	0	0	\N	\N	0	47762	0	23426006	4052083		
27916	869	4024958	1950-07-15	1950-07-15 00:00:00	1950-07-15	5001	0	\N	0	0	\N	\N	0	57749	0	117015009	4024958		
19362	1773	3006734	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	118557	0	6189-5	3006734		
56601	5195	3006322	1986-09-12	1986-09-12 00:00:00	1986-09-12	5001	0	\N	0	0	\N	\N	0	345475	0	8331-1	3006322		
56725	5206	3006322	2017-09-01	2017-09-01 00:00:00	2017-09-01	5001	0	\N	0	0	\N	\N	0	346260	0	8331-1	3006322		
46475	4278	3011505	2003-09-12	2003-09-12 00:00:00	2003-09-12	5001	0	\N	0	0	\N	\N	0	283848	0	19926-5	3011505		
31447	2872	3006322	1959-06-07	1959-06-07 00:00:00	1959-06-07	5001	0	\N	0	0	\N	\N	0	191216	0	8331-1	3006322		
15439	1411	3006322	1978-12-11	1978-12-11 00:00:00	1978-12-11	5001	0	\N	0	0	\N	\N	0	93964	0	8331-1	3006322		
73621	2264	4024958	1971-04-05	1971-04-05 00:00:00	1971-04-05	5001	0	\N	0	0	\N	\N	0	150427	0	117015009	4024958		
53796	4932	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	327805	0	6844-5	3020655		
11486	1099	3000876	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	72208	0	6082-2	3000876		
11534	1102	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	72441	0	6276-0	3027231		
63496	1950	4133840	2017-02-16	2017-02-16 00:00:00	2017-02-16	5001	0	\N	0	0	\N	\N	0	129696	0	127783003	4133840		
75065	2300	4133840	2008-02-07	2008-02-07 00:00:00	2008-02-07	5001	0	\N	0	0	\N	\N	0	153163	0	127783003	4133840		
49853	4534	3006322	1955-02-03	1955-02-03 00:00:00	1955-02-03	5001	0	\N	0	0	\N	\N	0	302082	0	8331-1	3006322		
35108	3208	3006322	2004-01-19	2004-01-19 00:00:00	2004-01-19	5001	0	\N	0	0	\N	\N	0	213273	0	8331-1	3006322		
34525	3158	3006322	1996-08-31	1996-08-31 00:00:00	1996-08-31	5001	0	\N	0	0	\N	\N	0	209959	0	8331-1	3006322		
45883	4226	3036780	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	280670	0	6095-4	3036780		
2643	263	40758406	2003-02-03	2003-02-03 00:00:00	2003-02-03	5001	0	\N	0	0	\N	\N	0	17438	0	55277-8	40758406		
57355	5267	3005136	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	350431	0	6075-6	3005136		
52386	4820	3006322	1961-05-30	1961-05-30 00:00:00	1961-05-30	5001	0	\N	0	0	\N	\N	0	320640	0	8331-1	3006322		
12796	1219	3006322	1952-09-20	1952-09-20 00:00:00	1952-09-20	5001	0	\N	0	0	\N	\N	0	80235	0	8331-1	3006322		
25541	2340	3006322	1984-10-03	1984-10-03 00:00:00	1984-10-03	5001	0	\N	0	0	\N	\N	0	155732	0	8331-1	3006322		
15183	1397	3006322	1977-02-21	1977-02-21 00:00:00	1977-02-21	5001	0	\N	0	0	\N	\N	0	92727	0	8331-1	3006322		
150274	4608	4133840	2005-12-22	2005-12-22 00:00:00	2005-12-22	5001	0	\N	0	0	\N	\N	0	307060	0	127783003	4133840		
105784	3254	4024958	2008-07-21	2008-07-21 00:00:00	2008-07-21	5001	0	\N	0	0	\N	\N	0	216433	0	117015009	4024958		
69128	2119	4052083	1976-04-25	1976-04-25 00:00:00	1976-04-25	5001	0	\N	0	0	\N	\N	0	141001	0	23426006	4052083		
35791	3279	3019406	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	217867	0	6158-0	3019406		
56543	5191	3006322	1990-07-18	1990-07-18 00:00:00	1990-07-18	5001	0	\N	0	0	\N	\N	0	345116	0	8331-1	3006322		
86995	2686	4052083	1969-09-07	1969-09-07 00:00:00	1969-09-07	5001	0	\N	0	0	\N	\N	0	178005	0	23426006	4052083		
49721	1513	4052083	1968-07-26	1968-07-26 00:00:00	1968-07-26	5001	0	\N	0	0	\N	\N	0	101114	0	23426006	4052083		
11226	1082	3012494	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	70975	0	6206-7	3012494		
26179	2402	3001247	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	159619	0	6085-5	3001247		
92333	2846	4024958	1993-05-12	1993-05-12 00:00:00	1993-05-12	5001	0	\N	0	0	\N	\N	0	189022	0	117015009	4024958		
113341	3501	4052083	1962-08-16	1962-08-16 00:00:00	1962-08-16	5001	0	\N	0	0	\N	\N	0	232080	0	23426006	4052083		
34343	3129	3006322	2012-12-17	2012-12-17 00:00:00	2012-12-17	5001	0	\N	0	0	\N	\N	0	208279	0	8331-1	3006322		
16027	1467	3006322	1963-09-18	1963-09-18 00:00:00	1963-09-18	5001	0	\N	0	0	\N	\N	0	97715	0	8331-1	3006322		
14245	1328	3006322	1956-04-27	1956-04-27 00:00:00	1956-04-27	5001	0	\N	0	0	\N	\N	0	88161	0	8331-1	3006322		
39968	3717	3021226	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	246997	0	6246-3	3021226		
143277	4403	4133840	1992-05-30	1992-05-30 00:00:00	1992-05-30	5001	0	\N	0	0	\N	\N	0	292737	0	127783003	4133840		
302	5	4052083	1971-03-12	1971-03-12 00:00:00	1971-03-12	5001	0	\N	0	0	\N	\N	0	401	0	23426006	4052083		
106995	3296	4024958	1944-11-27	1944-11-27 00:00:00	1944-11-27	5001	0	\N	0	0	\N	\N	0	218984	0	117015009	4024958		
31262	2858	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	189825	0	6833-8	3023430		
166168	5108	4052083	2002-03-10	2002-03-10 00:00:00	2002-03-10	5001	0	\N	0	0	\N	\N	0	339419	0	23426006	4052083		
99024	3035	4052083	1995-04-07	1995-04-07 00:00:00	1995-04-07	5001	0	\N	0	0	\N	\N	0	202182	0	23426006	4052083		
35356	3238	3011505	2017-03-06	2017-03-06 00:00:00	2017-03-06	5001	0	\N	0	0	\N	\N	0	215272	0	19926-5	3011505		
35436	3244	46235214	1974-06-17	1974-06-17 00:00:00	1974-06-17	5001	0	\N	0	0	\N	\N	0	215710	0	76690-7	46235214		
55009	5035	3006322	1979-03-20	1979-03-20 00:00:00	1979-03-20	5001	0	\N	0	0	\N	\N	0	334626	0	8331-1	3006322		
46875	4313	3006322	1966-01-01	1966-01-01 00:00:00	1966-01-01	5001	0	\N	0	0	\N	\N	0	286319	0	8331-1	3006322		
57746	5300	3045716	1945-02-13	1945-02-13 00:00:00	1945-02-13	5001	0	\N	0	0	\N	\N	0	352654	0	33037-3	3045716		
145332	4460	4052083	1952-07-05	1952-07-05 00:00:00	1952-07-05	5001	0	\N	0	0	\N	\N	0	296813	0	23426006	4052083		
21795	2004	3006322	1979-12-18	1979-12-18 00:00:00	1979-12-18	5001	0	\N	0	0	\N	\N	0	133441	0	8331-1	3006322		
33160	2993	3011505	2017-05-27	2017-05-27 00:00:00	2017-05-27	5001	0	\N	0	0	\N	\N	0	199773	0	19926-5	3011505		
33241	3000	3006322	1961-07-18	1961-07-18 00:00:00	1961-07-18	5001	0	\N	0	0	\N	\N	0	200185	0	8331-1	3006322		
39633	3680	3036780	1992-04-07	1992-04-07 00:00:00	1992-04-07	5001	0	\N	0	0	\N	\N	0	244679	0	6095-4	3036780		
163814	5034	4052083	1927-11-28	1927-11-28 00:00:00	1927-11-28	5001	0	\N	0	0	\N	\N	0	334440	0	23426006	4052083		
44847	4145	3015076	2006-07-29	2006-07-29 00:00:00	2006-07-29	5001	0	\N	0	0	\N	\N	0	275533	0	6248-9	3015076		
17565	1597	3006322	1953-08-15	1953-08-15 00:00:00	1953-08-15	5001	0	\N	0	0	\N	\N	0	107098	0	8331-1	3006322		
56247	5165	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	343257	0	6844-5	3020655		
25224	2318	3027970	1969-03-09	1969-03-09 00:00:00	1969-03-09	5001	0	\N	0	0	\N	\N	0	154115	0	10834-0	3027970		
36592	3364	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	223062	0	6106-9	3014599		
22316	2053	3006322	1971-02-27	1971-02-27 00:00:00	1971-02-27	5001	0	\N	0	0	\N	\N	0	136515	0	8331-1	3006322		
48085	4412	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	293384	0	7258-7	3001488		
24836	2280	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	151673	0	6082-2	3000876		
22994	722	4024958	1997-08-21	1997-08-21 00:00:00	1997-08-21	5001	0	\N	0	0	\N	\N	0	47766	0	117015009	4024958		
27921	869	4052083	1960-09-04	1960-09-04 00:00:00	1960-09-04	5001	0	\N	0	0	\N	\N	0	57810	0	23426006	4052083		
19363	1773	3023430	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	118557	0	6833-8	3023430		
56602	5196	3006322	1958-01-11	1958-01-11 00:00:00	1958-01-11	5001	0	\N	0	0	\N	\N	0	345511	0	8331-1	3006322		
56726	5206	3006322	1981-12-21	1981-12-21 00:00:00	1981-12-21	5001	0	\N	0	0	\N	\N	0	346290	0	8331-1	3006322		
46476	4278	3011505	2005-09-23	2005-09-23 00:00:00	2005-09-23	5001	0	\N	0	0	\N	\N	0	283860	0	19926-5	3011505		
31448	2872	3006322	1960-01-12	1960-01-12 00:00:00	1960-01-12	5001	0	\N	0	0	\N	\N	0	191218	0	8331-1	3006322		
15440	1412	3006322	1994-01-13	1994-01-13 00:00:00	1994-01-13	5001	0	\N	0	0	\N	\N	0	94064	0	8331-1	3006322		
5014	153	4024958	1975-03-03	1975-03-03 00:00:00	1975-03-03	5001	0	\N	0	0	\N	\N	0	10381	0	117015009	4024958		
53797	4932	3006322	1983-09-01	1983-09-01 00:00:00	1983-09-01	5001	0	\N	0	0	\N	\N	0	327867	0	8331-1	3006322		
11487	1099	3001488	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	72208	0	7258-7	3001488		
11535	1102	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	72441	0	6246-3	3021226		
63500	1950	4133840	2007-12-20	2007-12-20 00:00:00	2007-12-20	5001	0	\N	0	0	\N	\N	0	129621	0	127783003	4133840		
75066	2300	4133840	2019-04-11	2019-04-11 00:00:00	2019-04-11	5001	0	\N	0	0	\N	\N	0	153137	0	127783003	4133840		
49854	4534	3006322	1959-12-26	1959-12-26 00:00:00	1959-12-26	5001	0	\N	0	0	\N	\N	0	302083	0	8331-1	3006322		
35109	3208	3006322	2003-09-08	2003-09-08 00:00:00	2003-09-08	5001	0	\N	0	0	\N	\N	0	213267	0	8331-1	3006322		
34526	3158	3006322	1949-12-24	1949-12-24 00:00:00	1949-12-24	5001	0	\N	0	0	\N	\N	0	209993	0	8331-1	3006322		
45884	4226	3021226	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	280670	0	6246-3	3021226		
2645	263	46235214	2003-02-03	2003-02-03 00:00:00	2003-02-03	5001	0	\N	0	0	\N	\N	0	17438	0	76690-7	46235214		
57356	5267	3001488	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	350431	0	7258-7	3001488		
52387	4820	3006322	1974-03-30	1974-03-30 00:00:00	1974-03-30	5001	0	\N	0	0	\N	\N	0	320620	0	8331-1	3006322		
12797	1219	3006322	1992-10-03	1992-10-03 00:00:00	1992-10-03	5001	0	\N	0	0	\N	\N	0	80238	0	8331-1	3006322		
25542	2340	3006322	2013-03-31	2013-03-31 00:00:00	2013-03-31	5001	0	\N	0	0	\N	\N	0	155735	0	8331-1	3006322		
15184	1397	3006322	1995-02-13	1995-02-13 00:00:00	1995-02-13	5001	0	\N	0	0	\N	\N	0	92763	0	8331-1	3006322		
150275	4608	4024958	1981-03-01	1981-03-01 00:00:00	1981-03-01	5001	0	\N	0	0	\N	\N	0	307074	0	117015009	4024958		
105787	3254	4024958	2018-10-14	2018-10-14 00:00:00	2018-10-14	5001	0	\N	0	0	\N	\N	0	216411	0	117015009	4024958		
57948	1766	4133840	2018-03-27	2018-03-27 00:00:00	2018-03-27	5001	0	\N	0	0	\N	\N	0	118150	0	127783003	4133840		
35792	3279	3027231	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	217867	0	6276-0	3027231		
56544	5191	3006322	1977-01-19	1977-01-19 00:00:00	1977-01-19	5001	0	\N	0	0	\N	\N	0	345115	0	8331-1	3006322		
86997	2686	4024958	1962-05-18	1962-05-18 00:00:00	1962-05-18	5001	0	\N	0	0	\N	\N	0	177983	0	117015009	4024958		
49749	1513	4024958	1970-07-16	1970-07-16 00:00:00	1970-07-16	5001	0	\N	0	0	\N	\N	0	101116	0	117015009	4024958		
11227	1082	3001488	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	70975	0	7258-7	3001488		
26180	2402	3000876	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	159619	0	6082-2	3000876		
92338	2846	4052083	2001-08-24	2001-08-24 00:00:00	2001-08-24	5001	0	\N	0	0	\N	\N	0	189036	0	23426006	4052083		
113405	3504	4024958	1931-04-04	1931-04-04 00:00:00	1931-04-04	5001	0	\N	0	0	\N	\N	0	232288	0	117015009	4024958		
34344	3129	3006322	2009-04-09	2009-04-09 00:00:00	2009-04-09	5001	0	\N	0	0	\N	\N	0	208251	0	8331-1	3006322		
16028	1467	3006322	1966-09-15	1966-09-15 00:00:00	1966-09-15	5001	0	\N	0	0	\N	\N	0	97716	0	8331-1	3006322		
14246	1328	3011505	1996-08-01	1996-08-01 00:00:00	1996-08-01	5001	0	\N	0	0	\N	\N	0	88230	0	19926-5	3011505		
39969	3717	3019406	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	246997	0	6158-0	3019406		
143279	4403	4133840	1997-06-28	1997-06-28 00:00:00	1997-06-28	5001	0	\N	0	0	\N	\N	0	292696	0	127783003	4133840		
318	5	4052083	2012-02-10	2012-02-10 00:00:00	2012-02-10	5001	0	\N	0	0	\N	\N	0	508	0	23426006	4052083		
107008	3296	4052083	1948-10-02	1948-10-02 00:00:00	1948-10-02	5001	0	\N	0	0	\N	\N	0	219085	0	23426006	4052083		
31263	2858	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	189825	0	6095-4	3036780		
166177	5108	4024958	1962-10-18	1962-10-18 00:00:00	1962-10-18	5001	0	\N	0	0	\N	\N	0	339431	0	117015009	4024958		
99025	3035	4024958	2016-02-04	2016-02-04 00:00:00	2016-02-04	5001	0	\N	0	0	\N	\N	0	202175	0	117015009	4024958		
35357	3238	3006322	1985-06-06	1985-06-06 00:00:00	1985-06-06	5001	0	\N	0	0	\N	\N	0	215275	0	8331-1	3006322		
35437	3244	3006322	2013-06-10	2013-06-10 00:00:00	2013-06-10	5001	0	\N	0	0	\N	\N	0	215733	0	8331-1	3006322		
55015	5037	3006322	2015-12-24	2015-12-24 00:00:00	2015-12-24	5001	0	\N	0	0	\N	\N	0	334713	0	8331-1	3006322		
46876	4313	3006322	1958-12-29	1958-12-29 00:00:00	1958-12-29	5001	0	\N	0	0	\N	\N	0	286275	0	8331-1	3006322		
57747	5300	3023103	1945-02-13	1945-02-13 00:00:00	1945-02-13	5001	0	\N	0	0	\N	\N	0	352654	0	2823-3	3023103		
145339	4460	4024958	1985-02-08	1985-02-08 00:00:00	1985-02-08	5001	0	\N	0	0	\N	\N	0	296776	0	117015009	4024958		
21796	2004	3006322	1993-03-17	1993-03-17 00:00:00	1993-03-17	5001	0	\N	0	0	\N	\N	0	133437	0	8331-1	3006322		
33161	2993	3011505	2012-06-23	2012-06-23 00:00:00	2012-06-23	5001	0	\N	0	0	\N	\N	0	199792	0	19926-5	3011505		
33242	3000	3006322	1951-07-01	1951-07-01 00:00:00	1951-07-01	5001	0	\N	0	0	\N	\N	0	200184	0	8331-1	3006322		
39634	3680	3012494	1992-04-07	1992-04-07 00:00:00	1992-04-07	5001	0	\N	0	0	\N	\N	0	244679	0	6206-7	3012494		
13611	1280	3006322	2014-07-15	2014-07-15 00:00:00	2014-07-15	5001	0	\N	0	0	\N	\N	0	84608	0	8331-1	3006322		
44848	4145	3019406	2006-07-29	2006-07-29 00:00:00	2006-07-29	5001	0	\N	0	0	\N	\N	0	275533	0	6158-0	3019406		
17566	1597	3006322	1973-02-08	1973-02-08 00:00:00	1973-02-08	5001	0	\N	0	0	\N	\N	0	107100	0	8331-1	3006322		
56248	5165	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	343257	0	6206-7	3012494		
25225	2318	3009542	1969-03-09	1969-03-09 00:00:00	1969-03-09	5001	0	\N	0	0	\N	\N	0	154115	0	20570-8	3009542		
36593	3364	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	223062	0	6075-6	3005136		
22318	2053	40758406	1964-07-24	1964-07-24 00:00:00	1964-07-24	5001	0	\N	0	0	\N	\N	0	136511	0	55277-8	40758406		
48086	4412	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	293384	0	6844-5	3020655		
24837	2280	3006322	2002-07-11	2002-07-11 00:00:00	2002-07-11	5001	0	\N	0	0	\N	\N	0	151646	0	8331-1	3006322		
23001	722	4024958	1974-07-16	1974-07-16 00:00:00	1974-07-16	5001	0	\N	0	0	\N	\N	0	47772	0	117015009	4024958		
36218	3335	3051031	2014-11-11	2014-11-11 00:00:00	2014-11-11	5001	0	\N	0	0	\N	\N	0	221249	0	46240-8	3051031		
19364	1773	3020655	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	118557	0	6844-5	3020655		
56603	5196	3006322	1952-10-27	1952-10-27 00:00:00	1952-10-27	5001	0	\N	0	0	\N	\N	0	345510	0	8331-1	3006322		
56727	5206	3006322	1983-10-28	1983-10-28 00:00:00	1983-10-28	5001	0	\N	0	0	\N	\N	0	346263	0	8331-1	3006322		
46478	4278	3011505	2000-01-28	2000-01-28 00:00:00	2000-01-28	5001	0	\N	0	0	\N	\N	0	283927	0	19926-5	3011505		
31454	2876	3011505	2014-10-16	2014-10-16 00:00:00	2014-10-16	5001	0	\N	0	0	\N	\N	0	191354	0	19926-5	3011505		
15441	1412	3006322	1995-07-20	1995-07-20 00:00:00	1995-07-20	5001	0	\N	0	0	\N	\N	0	93984	0	8331-1	3006322		
5033	154	4052083	1990-01-14	1990-01-14 00:00:00	1990-01-14	5001	0	\N	0	0	\N	\N	0	10472	0	23426006	4052083		
53798	4932	3006322	1985-03-04	1985-03-04 00:00:00	1985-03-04	5001	0	\N	0	0	\N	\N	0	327810	0	8331-1	3006322		
11488	1099	3036780	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	72208	0	6095-4	3036780		
11536	1102	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	72441	0	6844-5	3020655		
63503	1950	4133840	2012-01-12	2012-01-12 00:00:00	2012-01-12	5001	0	\N	0	0	\N	\N	0	129663	0	127783003	4133840		
75067	2300	4052083	1991-05-09	1991-05-09 00:00:00	1991-05-09	5001	0	\N	0	0	\N	\N	0	153166	0	23426006	4052083		
49855	4534	3006322	1949-07-29	1949-07-29 00:00:00	1949-07-29	5001	0	\N	0	0	\N	\N	0	302053	0	8331-1	3006322		
35110	3211	3006322	1963-10-19	1963-10-19 00:00:00	1963-10-19	5001	0	\N	0	0	\N	\N	0	213330	0	8331-1	3006322		
34527	3158	3006322	1986-02-25	1986-02-25 00:00:00	1986-02-25	5001	0	\N	0	0	\N	\N	0	209917	0	8331-1	3006322		
45885	4226	3012494	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	280670	0	6206-7	3012494		
2646	263	40766240	2003-02-03	2003-02-03 00:00:00	2003-02-03	5001	0	\N	0	0	\N	\N	0	17438	0	63513-6	40766240		
57357	5267	3021226	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	350431	0	6246-3	3021226		
52388	4820	3006322	1968-04-18	1968-04-18 00:00:00	1968-04-18	5001	0	\N	0	0	\N	\N	0	320619	0	8331-1	3006322		
36121	3325	3006322	1979-06-18	1979-06-18 00:00:00	1979-06-18	5001	0	\N	0	0	\N	\N	0	220694	0	8331-1	3006322		
25543	2340	3006322	1967-12-21	1967-12-21 00:00:00	1967-12-21	5001	0	\N	0	0	\N	\N	0	155766	0	8331-1	3006322		
15185	1397	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	92805	0	6158-0	3019406		
150278	4608	4133840	2011-01-20	2011-01-20 00:00:00	2011-01-20	5001	0	\N	0	0	\N	\N	0	307020	0	127783003	4133840		
24321	2250	3006322	1994-07-17	1994-07-17 00:00:00	1994-07-17	5001	0	\N	0	0	\N	\N	0	149683	0	8331-1	3006322		
57951	1766	4133840	1984-01-10	1984-01-10 00:00:00	1984-01-10	5001	0	\N	0	0	\N	\N	0	118157	0	127783003	4133840		
35793	3279	3006451	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	217867	0	6273-7	3006451		
56545	5191	3006322	2013-02-13	2013-02-13 00:00:00	2013-02-13	5001	0	\N	0	0	\N	\N	0	345101	0	8331-1	3006322		
86999	2686	4024958	2011-03-25	2011-03-25 00:00:00	2011-03-25	5001	0	\N	0	0	\N	\N	0	177998	0	117015009	4024958		
102075	3135	4024958	1991-04-05	1991-04-05 00:00:00	1991-04-05	5001	0	\N	0	0	\N	\N	0	208669	0	117015009	4024958		
11228	1082	3023430	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	70975	0	6833-8	3023430		
26181	2402	3012494	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	159619	0	6206-7	3012494		
92344	2846	4024958	1982-02-14	1982-02-14 00:00:00	1982-02-14	5001	0	\N	0	0	\N	\N	0	189032	0	117015009	4024958		
124986	3859	4133840	1989-09-23	1989-09-23 00:00:00	1989-09-23	5001	0	\N	0	0	\N	\N	0	256170	0	127783003	4133840		
34345	3129	3006322	2003-03-02	2003-03-02 00:00:00	2003-03-02	5001	0	\N	0	0	\N	\N	0	208250	0	8331-1	3006322		
16029	1467	3006322	2012-02-27	2012-02-27 00:00:00	2012-02-27	5001	0	\N	0	0	\N	\N	0	97673	0	8331-1	3006322		
14247	1328	3011505	2001-08-30	2001-08-30 00:00:00	2001-08-30	5001	0	\N	0	0	\N	\N	0	88169	0	19926-5	3011505		
39970	3717	3000876	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	246997	0	6082-2	3000876		
143282	4403	4133840	1999-07-10	1999-07-10 00:00:00	1999-07-10	5001	0	\N	0	0	\N	\N	0	292697	0	127783003	4133840		
329	6	4024958	1993-09-27	1993-09-27 00:00:00	1993-09-27	5001	0	\N	0	0	\N	\N	0	565	0	117015009	4024958		
118323	3641	4052083	2000-06-24	2000-06-24 00:00:00	2000-06-24	5001	0	\N	0	0	\N	\N	0	242341	0	23426006	4052083		
31264	2858	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	189825	0	6106-9	3014599		
166187	5108	4052083	1999-01-28	1999-01-28 00:00:00	1999-01-28	5001	0	\N	0	0	\N	\N	0	339411	0	23426006	4052083		
99027	3035	4024958	1966-04-10	1966-04-10 00:00:00	1966-04-10	5001	0	\N	0	0	\N	\N	0	202231	0	117015009	4024958		
35358	3238	3006322	2009-01-13	2009-01-13 00:00:00	2009-01-13	5001	0	\N	0	0	\N	\N	0	215262	0	8331-1	3006322		
35438	3244	3036780	1991-05-02	1991-05-02 00:00:00	1991-05-02	5001	0	\N	0	0	\N	\N	0	215732	0	6095-4	3036780		
55016	5037	3006322	1985-06-22	1985-06-22 00:00:00	1985-06-22	5001	0	\N	0	0	\N	\N	0	334737	0	8331-1	3006322		
46877	4313	3005136	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	286276	0	6075-6	3005136		
57748	5300	3013682	1945-02-13	1945-02-13 00:00:00	1945-02-13	5001	0	\N	0	0	\N	\N	0	352654	0	3094-0	3013682		
156642	4814	4024958	1936-12-11	1936-12-11 00:00:00	1936-12-11	5001	0	\N	0	0	\N	\N	0	320299	0	117015009	4024958		
21797	2005	3006322	1979-11-12	1979-11-12 00:00:00	1979-11-12	5001	0	\N	0	0	\N	\N	0	133510	0	8331-1	3006322		
33162	2993	3011505	2019-06-01	2019-06-01 00:00:00	2019-06-01	5001	0	\N	0	0	\N	\N	0	199816	0	19926-5	3011505		
33243	3000	3006322	1991-10-20	1991-10-20 00:00:00	1991-10-20	5001	0	\N	0	0	\N	\N	0	200151	0	8331-1	3006322		
39635	3680	3019406	1992-04-07	1992-04-07 00:00:00	1992-04-07	5001	0	\N	0	0	\N	\N	0	244679	0	6158-0	3019406		
13612	1280	3006322	1974-07-02	1974-07-02 00:00:00	1974-07-02	5001	0	\N	0	0	\N	\N	0	84557	0	8331-1	3006322		
44849	4145	3020655	2006-07-29	2006-07-29 00:00:00	2006-07-29	5001	0	\N	0	0	\N	\N	0	275533	0	6844-5	3020655		
17567	1597	3006322	1959-02-26	1959-02-26 00:00:00	1959-02-26	5001	0	\N	0	0	\N	\N	0	107099	0	8331-1	3006322		
56249	5165	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	343257	0	6246-3	3021226		
25226	2318	3006322	1995-07-17	1995-07-17 00:00:00	1995-07-17	5001	0	\N	0	0	\N	\N	0	154091	0	8331-1	3006322		
36594	3364	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	223062	0	6248-9	3015076		
22319	2053	3051031	1964-07-24	1964-07-24 00:00:00	1964-07-24	5001	0	\N	0	0	\N	\N	0	136511	0	46240-8	3051031		
48087	4412	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	293384	0	6095-4	3036780		
50890	4639	3006322	1971-07-18	1971-07-18 00:00:00	1971-07-18	5001	0	\N	0	0	\N	\N	0	309185	0	8331-1	3006322		
23017	723	4024958	2011-08-17	2011-08-17 00:00:00	2011-08-17	5001	0	\N	0	0	\N	\N	0	47845	0	117015009	4024958		
36219	3335	40758406	2014-11-11	2014-11-11 00:00:00	2014-11-11	5001	0	\N	0	0	\N	\N	0	221249	0	55277-8	40758406		
19365	1773	3021226	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	118557	0	6246-3	3021226		
56604	5196	3006322	2006-01-21	2006-01-21 00:00:00	2006-01-21	5001	0	\N	0	0	\N	\N	0	345547	0	8331-1	3006322		
56728	5207	40766240	2001-04-29	2001-04-29 00:00:00	2001-04-29	5001	0	\N	0	0	\N	\N	0	346381	0	63513-6	40766240		
46479	4278	3011505	2007-10-05	2007-10-05 00:00:00	2007-10-05	5001	0	\N	0	0	\N	\N	0	283861	0	19926-5	3011505		
31455	2876	3011505	1995-08-10	1995-08-10 00:00:00	1995-08-10	5001	0	\N	0	0	\N	\N	0	191386	0	19926-5	3011505		
15442	1412	3006322	1992-04-13	1992-04-13 00:00:00	1992-04-13	5001	0	\N	0	0	\N	\N	0	94063	0	8331-1	3006322		
5034	154	4024958	1989-01-20	1989-01-20 00:00:00	1989-01-20	5001	0	\N	0	0	\N	\N	0	10499	0	117015009	4024958		
53799	4932	3006322	1995-09-21	1995-09-21 00:00:00	1995-09-21	5001	0	\N	0	0	\N	\N	0	327920	0	8331-1	3006322		
11489	1099	3023430	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	72208	0	6833-8	3023430		
11537	1102	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	72441	0	6273-7	3006451		
63506	1950	4133840	1989-07-13	1989-07-13 00:00:00	1989-07-13	5001	0	\N	0	0	\N	\N	0	129691	0	127783003	4133840		
75068	2300	4052083	1974-11-08	1974-11-08 00:00:00	1974-11-08	5001	0	\N	0	0	\N	\N	0	153205	0	23426006	4052083		
49856	4534	3006322	1953-01-01	1953-01-01 00:00:00	1953-01-01	5001	0	\N	0	0	\N	\N	0	302086	0	8331-1	3006322		
35111	3211	3006322	1966-02-22	1966-02-22 00:00:00	1966-02-22	5001	0	\N	0	0	\N	\N	0	213314	0	8331-1	3006322		
34528	3158	3006322	1994-11-24	1994-11-24 00:00:00	1994-11-24	5001	0	\N	0	0	\N	\N	0	209918	0	8331-1	3006322		
45886	4226	3000876	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	280670	0	6082-2	3000876		
2649	263	3051031	2003-05-04	2003-05-04 00:00:00	2003-05-04	5001	0	\N	0	0	\N	\N	0	17439	0	46240-8	3051031		
57358	5267	3019406	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	350431	0	6158-0	3019406		
52389	4822	3011505	2017-01-11	2017-01-11 00:00:00	2017-01-11	5001	0	\N	0	0	\N	\N	0	320774	0	19926-5	3011505		
36122	3325	3006322	1981-03-24	1981-03-24 00:00:00	1981-03-24	5001	0	\N	0	0	\N	\N	0	220713	0	8331-1	3006322		
25544	2340	3006322	1990-06-18	1990-06-18 00:00:00	1990-06-18	5001	0	\N	0	0	\N	\N	0	155734	0	8331-1	3006322		
15186	1397	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	92805	0	6248-9	3015076		
150284	4608	4133840	2001-02-22	2001-02-22 00:00:00	2001-02-22	5001	0	\N	0	0	\N	\N	0	307059	0	127783003	4133840		
24322	2250	3006322	1958-12-24	1958-12-24 00:00:00	1958-12-24	5001	0	\N	0	0	\N	\N	0	149663	0	8331-1	3006322		
57955	1766	4133840	2010-10-19	2010-10-19 00:00:00	2010-10-19	5001	0	\N	0	0	\N	\N	0	118144	0	127783003	4133840		
35794	3279	3005136	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	217867	0	6075-6	3005136		
56546	5191	3006322	2015-07-13	2015-07-13 00:00:00	2015-07-13	5001	0	\N	0	0	\N	\N	0	345103	0	8331-1	3006322		
87001	2686	4052083	1966-07-12	1966-07-12 00:00:00	1966-07-12	5001	0	\N	0	0	\N	\N	0	177984	0	23426006	4052083		
102078	3135	4052083	2005-05-02	2005-05-02 00:00:00	2005-05-02	5001	0	\N	0	0	\N	\N	0	208697	0	23426006	4052083		
11229	1082	3020655	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	70975	0	6844-5	3020655		
26182	2404	3006322	1979-11-07	1979-11-07 00:00:00	1979-11-07	5001	0	\N	0	0	\N	\N	0	159712	0	8331-1	3006322		
103649	3183	4024958	1982-07-06	1982-07-06 00:00:00	1982-07-06	5001	0	\N	0	0	\N	\N	0	211930	0	117015009	4024958		
124987	3859	4133840	2008-10-11	2008-10-11 00:00:00	2008-10-11	5001	0	\N	0	0	\N	\N	0	256180	0	127783003	4133840		
34346	3129	3006322	2012-05-05	2012-05-05 00:00:00	2012-05-05	5001	0	\N	0	0	\N	\N	0	208256	0	8331-1	3006322		
16030	1467	3006322	1989-03-29	1989-03-29 00:00:00	1989-03-29	5001	0	\N	0	0	\N	\N	0	97749	0	8331-1	3006322		
14248	1328	3006322	1973-04-11	1973-04-11 00:00:00	1973-04-11	5001	0	\N	0	0	\N	\N	0	88193	0	8331-1	3006322		
39971	3717	3012494	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	246997	0	6206-7	3012494		
143286	4403	4133840	1993-06-05	1993-06-05 00:00:00	1993-06-05	5001	0	\N	0	0	\N	\N	0	292733	0	127783003	4133840		
341	6	4024958	2001-09-24	2001-09-24 00:00:00	2001-09-24	5001	0	\N	0	0	\N	\N	0	582	0	117015009	4024958		
13845	1303	3006322	1976-08-23	1976-08-23 00:00:00	1976-08-23	5001	0	\N	0	0	\N	\N	0	86056	0	8331-1	3006322		
31265	2858	3049273	1986-02-07	1986-02-07 00:00:00	1986-02-07	5001	0	\N	0	0	\N	\N	0	189903	0	38265-5	3049273		
170816	5240	4052083	1982-11-08	1982-11-08 00:00:00	1982-11-08	5001	0	\N	0	0	\N	\N	0	348642	0	23426006	4052083		
99031	3035	4024958	1985-02-22	1985-02-22 00:00:00	1985-02-22	5001	0	\N	0	0	\N	\N	0	202174	0	117015009	4024958		
35359	3238	3011505	2018-03-12	2018-03-12 00:00:00	2018-03-12	5001	0	\N	0	0	\N	\N	0	215287	0	19926-5	3011505		
35439	3244	3006734	1991-05-02	1991-05-02 00:00:00	1991-05-02	5001	0	\N	0	0	\N	\N	0	215732	0	6189-5	3006734		
55017	5037	3006322	2014-01-20	2014-01-20 00:00:00	2014-01-20	5001	0	\N	0	0	\N	\N	0	334718	0	8331-1	3006322		
46878	4313	3021226	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	286276	0	6246-3	3021226		
57749	5300	3020630	1945-02-13	1945-02-13 00:00:00	1945-02-13	5001	0	\N	0	0	\N	\N	0	352654	0	2885-2	3020630		
156651	4815	4024958	1992-03-21	1992-03-21 00:00:00	1992-03-21	5001	0	\N	0	0	\N	\N	0	320328	0	117015009	4024958		
21798	2005	3006322	2017-07-28	2017-07-28 00:00:00	2017-07-28	5001	0	\N	0	0	\N	\N	0	133513	0	8331-1	3006322		
33163	2993	3006322	1987-08-22	1987-08-22 00:00:00	1987-08-22	5001	0	\N	0	0	\N	\N	0	199799	0	8331-1	3006322		
33244	3000	3006322	2012-05-17	2012-05-17 00:00:00	2012-05-17	5001	0	\N	0	0	\N	\N	0	200153	0	8331-1	3006322		
39636	3680	3020655	1992-04-07	1992-04-07 00:00:00	1992-04-07	5001	0	\N	0	0	\N	\N	0	244679	0	6844-5	3020655		
13613	1280	3006322	1974-11-08	1974-11-08 00:00:00	1974-11-08	5001	0	\N	0	0	\N	\N	0	84543	0	8331-1	3006322		
44850	4145	3023430	2006-07-29	2006-07-29 00:00:00	2006-07-29	5001	0	\N	0	0	\N	\N	0	275533	0	6833-8	3023430		
17568	1597	3006322	2003-04-12	2003-04-12 00:00:00	2003-04-12	5001	0	\N	0	0	\N	\N	0	107160	0	8331-1	3006322		
56250	5165	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	343257	0	6095-4	3036780		
25227	2318	3006322	1972-01-02	1972-01-02 00:00:00	1972-01-02	5001	0	\N	0	0	\N	\N	0	154037	0	8331-1	3006322		
36595	3364	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	223062	0	6273-7	3006451		
22321	2053	46235214	1964-07-24	1964-07-24 00:00:00	1964-07-24	5001	0	\N	0	0	\N	\N	0	136511	0	76690-7	46235214		
48088	4412	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	293384	0	6246-3	3021226		
50891	4639	3006322	1984-05-30	1984-05-30 00:00:00	1984-05-30	5001	0	\N	0	0	\N	\N	0	309233	0	8331-1	3006322		
23025	723	4052083	1990-10-25	1990-10-25 00:00:00	1990-10-25	5001	0	\N	0	0	\N	\N	0	47824	0	23426006	4052083		
36221	3335	46235214	2014-11-11	2014-11-11 00:00:00	2014-11-11	5001	0	\N	0	0	\N	\N	0	221249	0	76690-7	46235214		
19366	1773	3006451	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	118557	0	6273-7	3006451		
56605	5196	3006322	1959-09-13	1959-09-13 00:00:00	1959-09-13	5001	0	\N	0	0	\N	\N	0	345550	0	8331-1	3006322		
56729	5207	46235214	2001-04-29	2001-04-29 00:00:00	2001-04-29	5001	0	\N	0	0	\N	\N	0	346381	0	76690-7	46235214		
46480	4278	3011505	2011-10-28	2011-10-28 00:00:00	2011-10-28	5001	0	\N	0	0	\N	\N	0	283866	0	19926-5	3011505		
31456	2876	3011505	2013-10-10	2013-10-10 00:00:00	2013-10-10	5001	0	\N	0	0	\N	\N	0	191355	0	19926-5	3011505		
15443	1412	3006322	1969-02-02	1969-02-02 00:00:00	1969-02-02	5001	0	\N	0	0	\N	\N	0	94091	0	8331-1	3006322		
5038	154	4052083	1985-03-29	1985-03-29 00:00:00	1985-03-29	5001	0	\N	0	0	\N	\N	0	10495	0	23426006	4052083		
53800	4932	3006322	2000-03-12	2000-03-12 00:00:00	2000-03-12	5001	0	\N	0	0	\N	\N	0	327882	0	8331-1	3006322		
11490	1099	3006734	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	72208	0	6189-5	3006734		
11538	1102	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	72441	0	6248-9	3015076		
63508	1951	4024958	1995-05-21	1995-05-21 00:00:00	1995-05-21	5001	0	\N	0	0	\N	\N	0	129750	0	117015009	4024958		
75069	2300	4133840	2006-01-26	2006-01-26 00:00:00	2006-01-26	5001	0	\N	0	0	\N	\N	0	153162	0	127783003	4133840		
49857	4534	3006322	2008-10-13	2008-10-13 00:00:00	2008-10-13	5001	0	\N	0	0	\N	\N	0	302046	0	8331-1	3006322		
35112	3211	3006322	1998-04-19	1998-04-19 00:00:00	1998-04-19	5001	0	\N	0	0	\N	\N	0	213367	0	8331-1	3006322		
34529	3158	3006322	1950-08-01	1950-08-01 00:00:00	1950-08-01	5001	0	\N	0	0	\N	\N	0	209906	0	8331-1	3006322		
45887	4226	3011505	2014-01-26	2014-01-26 00:00:00	2014-01-26	5001	0	\N	0	0	\N	\N	0	280664	0	19926-5	3011505		
2650	263	40758406	2003-05-04	2003-05-04 00:00:00	2003-05-04	5001	0	\N	0	0	\N	\N	0	17439	0	55277-8	40758406		
57359	5267	3027231	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	350431	0	6276-0	3027231		
52390	4822	40758406	1971-02-05	1971-02-05 00:00:00	1971-02-05	5001	0	\N	0	0	\N	\N	0	320712	0	55277-8	40758406		
36123	3325	3006322	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	220729	0	8331-1	3006322		
25545	2341	3006322	1959-08-19	1959-08-19 00:00:00	1959-08-19	5001	0	\N	0	0	\N	\N	0	155788	0	8331-1	3006322		
15187	1397	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	92805	0	6075-6	3005136		
150288	4608	4133840	1994-12-22	1994-12-22 00:00:00	1994-12-22	5001	0	\N	0	0	\N	\N	0	307088	0	127783003	4133840		
24323	2250	3006322	1990-03-25	1990-03-25 00:00:00	1990-03-25	5001	0	\N	0	0	\N	\N	0	149696	0	8331-1	3006322		
57957	1766	4133840	1990-01-16	1990-01-16 00:00:00	1990-01-16	5001	0	\N	0	0	\N	\N	0	118135	0	127783003	4133840		
35795	3279	3006322	1971-01-21	1971-01-21 00:00:00	1971-01-21	5001	0	\N	0	0	\N	\N	0	217902	0	8331-1	3006322		
56547	5191	3006322	1990-10-29	1990-10-29 00:00:00	1990-10-29	5001	0	\N	0	0	\N	\N	0	345117	0	8331-1	3006322		
87007	2686	4024958	1971-06-13	1971-06-13 00:00:00	1971-06-13	5001	0	\N	0	0	\N	\N	0	178049	0	117015009	4024958		
102080	3135	4052083	2011-08-19	2011-08-19 00:00:00	2011-08-19	5001	0	\N	0	0	\N	\N	0	208707	0	23426006	4052083		
11230	1082	3036780	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	70975	0	6095-4	3036780		
26183	2404	3006322	1994-06-14	1994-06-14 00:00:00	1994-06-14	5001	0	\N	0	0	\N	\N	0	159749	0	8331-1	3006322		
103651	3183	4052083	1993-10-19	1993-10-19 00:00:00	1993-10-19	5001	0	\N	0	0	\N	\N	0	211921	0	23426006	4052083		
124989	3859	4133840	1993-07-17	1993-07-17 00:00:00	1993-07-17	5001	0	\N	0	0	\N	\N	0	256255	0	127783003	4133840		
34355	3132	3006322	1974-08-22	1974-08-22 00:00:00	1974-08-22	5001	0	\N	0	0	\N	\N	0	208389	0	8331-1	3006322		
16031	1467	3006322	1962-07-12	1962-07-12 00:00:00	1962-07-12	5001	0	\N	0	0	\N	\N	0	97777	0	8331-1	3006322		
14249	1328	3011505	2016-04-14	2016-04-14 00:00:00	2016-04-14	5001	0	\N	0	0	\N	\N	0	88215	0	19926-5	3011505		
39972	3717	3006734	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	246997	0	6189-5	3006734		
143287	4403	4133840	1990-05-19	1990-05-19 00:00:00	1990-05-19	5001	0	\N	0	0	\N	\N	0	292736	0	127783003	4133840		
143349	4405	4052083	1968-10-25	1968-10-25 00:00:00	1968-10-25	5001	0	\N	0	0	\N	\N	0	292839	0	23426006	4052083		
13846	1303	3006322	1998-12-09	1998-12-09 00:00:00	1998-12-09	5001	0	\N	0	0	\N	\N	0	86026	0	8331-1	3006322		
31266	2858	3006322	1914-07-26	1914-07-26 00:00:00	1914-07-26	5001	0	\N	0	0	\N	\N	0	189738	0	8331-1	3006322		
170831	5240	4024958	1965-08-24	1965-08-24 00:00:00	1965-08-24	5001	0	\N	0	0	\N	\N	0	348692	0	117015009	4024958		
133703	4116	4052083	1996-12-20	1996-12-20 00:00:00	1996-12-20	5001	0	\N	0	0	\N	\N	0	273628	0	23426006	4052083		
35360	3238	3006322	1981-09-14	1981-09-14 00:00:00	1981-09-14	5001	0	\N	0	0	\N	\N	0	215298	0	8331-1	3006322		
35440	3244	3023430	1991-05-02	1991-05-02 00:00:00	1991-05-02	5001	0	\N	0	0	\N	\N	0	215732	0	6833-8	3023430		
55018	5037	3006322	1992-05-01	1992-05-01 00:00:00	1992-05-01	5001	0	\N	0	0	\N	\N	0	334772	0	8331-1	3006322		
46879	4313	3015076	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	286276	0	6248-9	3015076		
57750	5300	3015632	1945-02-13	1945-02-13 00:00:00	1945-02-13	5001	0	\N	0	0	\N	\N	0	352654	0	2028-9	3015632		
156653	4815	4024958	1995-08-19	1995-08-19 00:00:00	1995-08-19	5001	0	\N	0	0	\N	\N	0	320338	0	117015009	4024958		
21799	2005	3006322	2004-06-11	2004-06-11 00:00:00	2004-06-11	5001	0	\N	0	0	\N	\N	0	133526	0	8331-1	3006322		
33164	2993	3011505	2004-08-28	2004-08-28 00:00:00	2004-08-28	5001	0	\N	0	0	\N	\N	0	199774	0	19926-5	3011505		
33245	3000	3006322	1987-04-03	1987-04-03 00:00:00	1987-04-03	5001	0	\N	0	0	\N	\N	0	200150	0	8331-1	3006322		
39637	3680	3000876	1992-04-07	1992-04-07 00:00:00	1992-04-07	5001	0	\N	0	0	\N	\N	0	244679	0	6082-2	3000876		
13614	1280	3006322	1989-02-26	1989-02-26 00:00:00	1989-02-26	5001	0	\N	0	0	\N	\N	0	84532	0	8331-1	3006322		
44851	4145	3006322	1983-08-23	1983-08-23 00:00:00	1983-08-23	5001	0	\N	0	0	\N	\N	0	275494	0	8331-1	3006322		
17569	1597	3006322	1960-10-01	1960-10-01 00:00:00	1960-10-01	5001	0	\N	0	0	\N	\N	0	107107	0	8331-1	3006322		
56251	5165	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	343257	0	7258-7	3001488		
25228	2318	3006322	2015-06-24	2015-06-24 00:00:00	2015-06-24	5001	0	\N	0	0	\N	\N	0	154097	0	8331-1	3006322		
36596	3364	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	223062	0	6206-7	3012494		
22322	2053	40766240	1964-07-24	1964-07-24 00:00:00	1964-07-24	5001	0	\N	0	0	\N	\N	0	136511	0	63513-6	40766240		
48089	4412	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	293384	0	6248-9	3015076		
50892	4639	3006322	1982-04-02	1982-04-02 00:00:00	1982-04-02	5001	0	\N	0	0	\N	\N	0	309192	0	8331-1	3006322		
23040	723	4052083	2017-08-12	2017-08-12 00:00:00	2017-08-12	5001	0	\N	0	0	\N	\N	0	47825	0	23426006	4052083		
36222	3335	40766240	2014-09-12	2014-09-12 00:00:00	2014-09-12	5001	0	\N	0	0	\N	\N	0	221266	0	63513-6	40766240		
19367	1773	3027231	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	118557	0	6276-0	3027231		
56606	5197	3006322	1971-04-20	1971-04-20 00:00:00	1971-04-20	5001	0	\N	0	0	\N	\N	0	345626	0	8331-1	3006322		
56731	5207	3051031	2001-04-29	2001-04-29 00:00:00	2001-04-29	5001	0	\N	0	0	\N	\N	0	346381	0	46240-8	3051031		
46481	4278	3011505	1986-10-31	1986-10-31 00:00:00	1986-10-31	5001	0	\N	0	0	\N	\N	0	283925	0	19926-5	3011505		
31457	2876	3011505	2003-10-16	2003-10-16 00:00:00	2003-10-16	5001	0	\N	0	0	\N	\N	0	191352	0	19926-5	3011505		
15451	1415	3006322	1984-05-12	1984-05-12 00:00:00	1984-05-12	5001	0	\N	0	0	\N	\N	0	94195	0	8331-1	3006322		
5044	154	4052083	2017-07-15	2017-07-15 00:00:00	2017-07-15	5001	0	\N	0	0	\N	\N	0	10473	0	23426006	4052083		
53801	4932	40769189	1976-11-22	1976-11-22 00:00:00	1976-11-22	5001	0	\N	0	0	\N	\N	0	327866	0	66529-9	40769189		
11491	1099	3020655	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	72208	0	6844-5	3020655		
11539	1102	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	72441	0	6206-7	3012494		
63509	1951	4024958	2019-05-18	2019-05-18 00:00:00	2019-05-18	5001	0	\N	0	0	\N	\N	0	129754	0	117015009	4024958		
75070	2300	4024958	1977-05-26	1977-05-26 00:00:00	1977-05-26	5001	0	\N	0	0	\N	\N	0	153184	0	117015009	4024958		
49859	4534	3006322	1980-10-14	1980-10-14 00:00:00	1980-10-14	5001	0	\N	0	0	\N	\N	0	302043	0	8331-1	3006322		
35113	3211	3006322	1974-02-01	1974-02-01 00:00:00	1974-02-01	5001	0	\N	0	0	\N	\N	0	213365	0	8331-1	3006322		
34530	3159	3006322	1966-01-02	1966-01-02 00:00:00	1966-01-02	5001	0	\N	0	0	\N	\N	0	210021	0	8331-1	3006322		
45888	4227	3006322	1961-05-27	1961-05-27 00:00:00	1961-05-27	5001	0	\N	0	0	\N	\N	0	280819	0	8331-1	3006322		
2651	263	46235214	2003-05-04	2003-05-04 00:00:00	2003-05-04	5001	0	\N	0	0	\N	\N	0	17439	0	76690-7	46235214		
57360	5267	3006451	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	350431	0	6273-7	3006451		
52391	4822	3051031	1971-02-05	1971-02-05 00:00:00	1971-02-05	5001	0	\N	0	0	\N	\N	0	320712	0	46240-8	3051031		
36124	3325	3006322	1984-01-21	1984-01-21 00:00:00	1984-01-21	5001	0	\N	0	0	\N	\N	0	220743	0	8331-1	3006322		
25546	2341	3006322	1962-06-28	1962-06-28 00:00:00	1962-06-28	5001	0	\N	0	0	\N	\N	0	155851	0	8331-1	3006322		
15188	1397	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	92805	0	6095-4	3036780		
150290	4608	4133840	2006-12-28	2006-12-28 00:00:00	2006-12-28	5001	0	\N	0	0	\N	\N	0	307090	0	127783003	4133840		
35622	3253	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	216383	0	6844-5	3020655		
57961	1766	4133840	2013-11-05	2013-11-05 00:00:00	2013-11-05	5001	0	\N	0	0	\N	\N	0	118185	0	127783003	4133840		
35796	3279	3006322	1994-03-04	1994-03-04 00:00:00	1994-03-04	5001	0	\N	0	0	\N	\N	0	217868	0	8331-1	3006322		
56549	5193	3006322	1983-07-05	1983-07-05 00:00:00	1983-07-05	5001	0	\N	0	0	\N	\N	0	345200	0	8331-1	3006322		
87027	2686	4024958	1956-11-02	1956-11-02 00:00:00	1956-11-02	5001	0	\N	0	0	\N	\N	0	178015	0	117015009	4024958		
102081	3135	4024958	1998-01-25	1998-01-25 00:00:00	1998-01-25	5001	0	\N	0	0	\N	\N	0	208696	0	117015009	4024958		
11231	1082	3005136	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	70975	0	6075-6	3005136		
26184	2404	3006322	1987-04-09	1987-04-09 00:00:00	1987-04-09	5001	0	\N	0	0	\N	\N	0	159748	0	8331-1	3006322		
103654	3183	4052083	1982-05-06	1982-05-06 00:00:00	1982-05-06	5001	0	\N	0	0	\N	\N	0	211929	0	23426006	4052083		
124991	3859	4133840	2003-09-13	2003-09-13 00:00:00	2003-09-13	5001	0	\N	0	0	\N	\N	0	256156	0	127783003	4133840		
34356	3132	3006322	1983-09-20	1983-09-20 00:00:00	1983-09-20	5001	0	\N	0	0	\N	\N	0	208391	0	8331-1	3006322		
16032	1467	3006322	1935-04-17	1935-04-17 00:00:00	1935-04-17	5001	0	\N	0	0	\N	\N	0	97769	0	8331-1	3006322		
14250	1328	3011505	2005-09-22	2005-09-22 00:00:00	2005-09-22	5001	0	\N	0	0	\N	\N	0	88171	0	19926-5	3011505		
39973	3717	3005136	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	246997	0	6075-6	3005136		
143289	4403	4133840	1998-07-04	1998-07-04 00:00:00	1998-07-04	5001	0	\N	0	0	\N	\N	0	292692	0	127783003	4133840		
143351	4405	4052083	1975-12-26	1975-12-26 00:00:00	1975-12-26	5001	0	\N	0	0	\N	\N	0	292783	0	23426006	4052083		
13847	1303	3006322	2005-07-16	2005-07-16 00:00:00	2005-07-16	5001	0	\N	0	0	\N	\N	0	86063	0	8331-1	3006322		
31267	2858	3006322	2013-07-12	2013-07-12 00:00:00	2013-07-12	5001	0	\N	0	0	\N	\N	0	189885	0	8331-1	3006322		
170834	5240	4024958	1947-08-16	1947-08-16 00:00:00	1947-08-16	5001	0	\N	0	0	\N	\N	0	348639	0	117015009	4024958		
133709	4116	4024958	1981-11-22	1981-11-22 00:00:00	1981-11-22	5001	0	\N	0	0	\N	\N	0	273627	0	117015009	4024958		
35361	3238	3011505	2019-03-18	2019-03-18 00:00:00	2019-03-18	5001	0	\N	0	0	\N	\N	0	215315	0	19926-5	3011505		
35441	3244	3014599	1991-05-02	1991-05-02 00:00:00	1991-05-02	5001	0	\N	0	0	\N	\N	0	215732	0	6106-9	3014599		
55019	5037	3006322	1982-10-22	1982-10-22 00:00:00	1982-10-22	5001	0	\N	0	0	\N	\N	0	334736	0	8331-1	3006322		
46880	4313	3001488	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	286276	0	7258-7	3001488		
57751	5300	3007461	1945-02-13	1945-02-13 00:00:00	1945-02-13	5001	0	\N	0	0	\N	\N	0	352654	0	26515-7	3007461		
156654	4815	4024958	1970-12-31	1970-12-31 00:00:00	1970-12-31	5001	0	\N	0	0	\N	\N	0	320318	0	117015009	4024958		
21800	2005	3006322	2003-12-04	2003-12-04 00:00:00	2003-12-04	5001	0	\N	0	0	\N	\N	0	133525	0	8331-1	3006322		
33165	2993	3011505	2015-05-23	2015-05-23 00:00:00	2015-05-23	5001	0	\N	0	0	\N	\N	0	199803	0	19926-5	3011505		
33246	3000	3006322	2013-04-03	2013-04-03 00:00:00	2013-04-03	5001	0	\N	0	0	\N	\N	0	200200	0	8331-1	3006322		
39638	3680	3001247	1992-04-07	1992-04-07 00:00:00	1992-04-07	5001	0	\N	0	0	\N	\N	0	244679	0	6085-5	3001247		
13615	1280	3006322	2016-12-14	2016-12-14 00:00:00	2016-12-14	5001	0	\N	0	0	\N	\N	0	84536	0	8331-1	3006322		
44852	4145	3005136	2006-07-29	2006-07-29 00:00:00	2006-07-29	5001	0	\N	0	0	\N	\N	0	275533	0	6075-6	3005136		
17570	1598	3006322	1965-08-13	1965-08-13 00:00:00	1965-08-13	5001	0	\N	0	0	\N	\N	0	107220	0	8331-1	3006322		
56252	5165	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	343257	0	6833-8	3023430		
25229	2318	3006322	1978-01-10	1978-01-10 00:00:00	1978-01-10	5001	0	\N	0	0	\N	\N	0	154119	0	8331-1	3006322		
36597	3364	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	223062	0	6246-3	3021226		
22324	2053	46235214	1963-09-28	1963-09-28 00:00:00	1963-09-28	5001	0	\N	0	0	\N	\N	0	136503	0	76690-7	46235214		
48090	4412	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	293384	0	6206-7	3012494		
50896	4641	3006322	2012-03-22	2012-03-22 00:00:00	2012-03-22	5001	0	\N	0	0	\N	\N	0	309307	0	8331-1	3006322		
50963	4646	3000876	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	309825	0	6082-2	3000876		
36225	3335	3051031	2014-09-12	2014-09-12 00:00:00	2014-09-12	5001	0	\N	0	0	\N	\N	0	221266	0	46240-8	3051031		
19368	1773	3015076	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	118557	0	6248-9	3015076		
56607	5197	3015632	1962-06-05	1962-06-05 00:00:00	1962-06-05	5001	0	\N	0	0	\N	\N	0	345571	0	2028-9	3015632		
56733	5207	40758406	2001-04-29	2001-04-29 00:00:00	2001-04-29	5001	0	\N	0	0	\N	\N	0	346381	0	55277-8	40758406		
46482	4278	3011505	1996-01-19	1996-01-19 00:00:00	1996-01-19	5001	0	\N	0	0	\N	\N	0	283859	0	19926-5	3011505		
31458	2876	3011505	1998-08-13	1998-08-13 00:00:00	1998-08-13	5001	0	\N	0	0	\N	\N	0	191387	0	19926-5	3011505		
15452	1415	3006322	1969-08-13	1969-08-13 00:00:00	1969-08-13	5001	0	\N	0	0	\N	\N	0	94176	0	8331-1	3006322		
5047	154	4024958	1979-07-02	1979-07-02 00:00:00	1979-07-02	5001	0	\N	0	0	\N	\N	0	10433	0	117015009	4024958		
53802	4932	40769179	1976-11-22	1976-11-22 00:00:00	1976-11-22	5001	0	\N	0	0	\N	\N	0	327866	0	66519-0	40769179		
11492	1099	3006451	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	72208	0	6273-7	3006451		
11540	1102	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	72441	0	6075-6	3005136		
63527	1951	4052083	2003-04-10	2003-04-10 00:00:00	2003-04-10	5001	0	\N	0	0	\N	\N	0	129737	0	23426006	4052083		
75071	2300	4133840	1983-11-24	1983-11-24 00:00:00	1983-11-24	5001	0	\N	0	0	\N	\N	0	153194	0	127783003	4133840		
5895	181	4052083	1984-09-19	1984-09-19 00:00:00	1984-09-19	5001	0	\N	0	0	\N	\N	0	12203	0	23426006	4052083		
35114	3211	3006322	2009-03-31	2009-03-31 00:00:00	2009-03-31	5001	0	\N	0	0	\N	\N	0	213333	0	8331-1	3006322		
34531	3159	3006322	1976-12-08	1976-12-08 00:00:00	1976-12-08	5001	0	\N	0	0	\N	\N	0	210090	0	8331-1	3006322		
45889	4227	3006322	2012-03-02	2012-03-02 00:00:00	2012-03-02	5001	0	\N	0	0	\N	\N	0	280821	0	8331-1	3006322		
2652	263	40766240	2003-05-04	2003-05-04 00:00:00	2003-05-04	5001	0	\N	0	0	\N	\N	0	17439	0	63513-6	40766240		
57361	5267	3014599	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	350431	0	6106-9	3014599		
52393	4822	46235214	1971-02-05	1971-02-05 00:00:00	1971-02-05	5001	0	\N	0	0	\N	\N	0	320712	0	76690-7	46235214		
36125	3325	3051031	1970-11-12	1970-11-12 00:00:00	1970-11-12	5001	0	\N	0	0	\N	\N	0	220711	0	46240-8	3051031		
25547	2341	3006322	2007-03-13	2007-03-13 00:00:00	2007-03-13	5001	0	\N	0	0	\N	\N	0	155818	0	8331-1	3006322		
15189	1397	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	92805	0	6082-2	3000876		
148980	4565	4052083	1991-08-27	1991-08-27 00:00:00	1991-08-27	5001	0	\N	0	0	\N	\N	0	304164	0	23426006	4052083		
35623	3253	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	216383	0	6833-8	3023430		
57963	1766	4133840	2005-09-20	2005-09-20 00:00:00	2005-09-20	5001	0	\N	0	0	\N	\N	0	118164	0	127783003	4133840		
35797	3279	3006322	1966-08-29	1966-08-29 00:00:00	1966-08-29	5001	0	\N	0	0	\N	\N	0	217883	0	8331-1	3006322		
56550	5193	3006322	1974-03-29	1974-03-29 00:00:00	1974-03-29	5001	0	\N	0	0	\N	\N	0	345209	0	8331-1	3006322		
87040	2688	4024958	1984-12-08	1984-12-08 00:00:00	1984-12-08	5001	0	\N	0	0	\N	\N	0	178122	0	117015009	4024958		
102082	3135	4052083	1978-12-24	1978-12-24 00:00:00	1978-12-24	5001	0	\N	0	0	\N	\N	0	208666	0	23426006	4052083		
11232	1082	3014599	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	70975	0	6106-9	3014599		
26185	2404	3006322	1969-11-17	1969-11-17 00:00:00	1969-11-17	5001	0	\N	0	0	\N	\N	0	159729	0	8331-1	3006322		
103662	3184	4052083	2004-12-02	2004-12-02 00:00:00	2004-12-02	5001	0	\N	0	0	\N	\N	0	211959	0	23426006	4052083		
124994	3859	4133840	1993-03-06	1993-03-06 00:00:00	1993-03-06	5001	0	\N	0	0	\N	\N	0	256153	0	127783003	4133840		
34357	3132	3006322	1971-10-26	1971-10-26 00:00:00	1971-10-26	5001	0	\N	0	0	\N	\N	0	208388	0	8331-1	3006322		
16033	1467	3006322	1953-04-03	1953-04-03 00:00:00	1953-04-03	5001	0	\N	0	0	\N	\N	0	97714	0	8331-1	3006322		
14251	1328	3006322	1978-06-30	1978-06-30 00:00:00	1978-06-30	5001	0	\N	0	0	\N	\N	0	88135	0	8331-1	3006322		
39974	3717	3036780	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	246997	0	6095-4	3036780		
143293	4403	4052083	1986-04-20	1986-04-20 00:00:00	1986-04-20	5001	0	\N	0	0	\N	\N	0	292722	0	23426006	4052083		
143366	4405	4024958	1976-05-29	1976-05-29 00:00:00	1976-05-29	5001	0	\N	0	0	\N	\N	0	292841	0	117015009	4024958		
13853	1305	3006322	1966-03-02	1966-03-02 00:00:00	1966-03-02	5001	0	\N	0	0	\N	\N	0	86109	0	8331-1	3006322		
31268	2858	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	189881	0	6106-9	3014599		
170841	5241	4052083	2001-04-02	2001-04-02 00:00:00	2001-04-02	5001	0	\N	0	0	\N	\N	0	348720	0	23426006	4052083		
133711	4116	4052083	2006-01-28	2006-01-28 00:00:00	2006-01-28	5001	0	\N	0	0	\N	\N	0	273632	0	23426006	4052083		
35362	3240	46235214	1993-06-10	1993-06-10 00:00:00	1993-06-10	5001	0	\N	0	0	\N	\N	0	215347	0	76690-7	46235214		
35442	3244	3006451	1991-05-02	1991-05-02 00:00:00	1991-05-02	5001	0	\N	0	0	\N	\N	0	215732	0	6273-7	3006451		
55020	5039	3006322	1999-08-28	1999-08-28 00:00:00	1999-08-28	5001	0	\N	0	0	\N	\N	0	334894	0	8331-1	3006322		
46881	4313	3006734	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	286276	0	6189-5	3006734		
57752	5300	3002385	1945-02-13	1945-02-13 00:00:00	1945-02-13	5001	0	\N	0	0	\N	\N	0	352654	0	30385-9	3002385		
156659	4815	4024958	1997-02-26	1997-02-26 00:00:00	1997-02-26	5001	0	\N	0	0	\N	\N	0	320329	0	117015009	4024958		
21801	2005	3006322	1982-09-13	1982-09-13 00:00:00	1982-09-13	5001	0	\N	0	0	\N	\N	0	133480	0	8331-1	3006322		
33166	2993	3011505	2014-06-28	2014-06-28 00:00:00	2014-06-28	5001	0	\N	0	0	\N	\N	0	199772	0	19926-5	3011505		
33247	3001	3006322	1957-08-28	1957-08-28 00:00:00	1957-08-28	5001	0	\N	0	0	\N	\N	0	200235	0	8331-1	3006322		
39639	3680	3014599	1992-04-07	1992-04-07 00:00:00	1992-04-07	5001	0	\N	0	0	\N	\N	0	244679	0	6106-9	3014599		
13616	1280	3006322	1952-03-03	1952-03-03 00:00:00	1952-03-03	5001	0	\N	0	0	\N	\N	0	84572	0	8331-1	3006322		
44853	4145	3012494	2006-07-29	2006-07-29 00:00:00	2006-07-29	5001	0	\N	0	0	\N	\N	0	275533	0	6206-7	3012494		
17571	1598	3049273	2018-08-06	2018-08-06 00:00:00	2018-08-06	5001	0	\N	0	0	\N	\N	0	107269	0	38265-5	3049273		
56253	5165	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	343257	0	6273-7	3006451		
25230	2319	3006322	1968-09-02	1968-09-02 00:00:00	1968-09-02	5001	0	\N	0	0	\N	\N	0	154156	0	8331-1	3006322		
36598	3364	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	223062	0	6085-5	3001247		
22325	2053	40766240	1963-09-28	1963-09-28 00:00:00	1963-09-28	5001	0	\N	0	0	\N	\N	0	136503	0	63513-6	40766240		
48091	4412	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	293384	0	6276-0	3027231		
50897	4641	3006322	1997-04-15	1997-04-15 00:00:00	1997-04-15	5001	0	\N	0	0	\N	\N	0	309306	0	8331-1	3006322		
50964	4646	3001488	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	309825	0	7258-7	3001488		
36226	3335	40758406	2014-09-12	2014-09-12 00:00:00	2014-09-12	5001	0	\N	0	0	\N	\N	0	221266	0	55277-8	40758406		
19369	1773	3012494	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	118557	0	6206-7	3012494		
56608	5197	3023103	1962-06-05	1962-06-05 00:00:00	1962-06-05	5001	0	\N	0	0	\N	\N	0	345571	0	2823-3	3023103		
56734	5207	3006322	1977-04-30	1977-04-30 00:00:00	1977-04-30	5001	0	\N	0	0	\N	\N	0	346346	0	8331-1	3006322		
46483	4278	3011505	2008-10-10	2008-10-10 00:00:00	2008-10-10	5001	0	\N	0	0	\N	\N	0	283852	0	19926-5	3011505		
31459	2876	3006322	1995-09-01	1995-09-01 00:00:00	1995-09-01	5001	0	\N	0	0	\N	\N	0	191343	0	8331-1	3006322		
15453	1415	3006322	1969-02-28	1969-02-28 00:00:00	1969-02-28	5001	0	\N	0	0	\N	\N	0	94177	0	8331-1	3006322		
5069	155	4024958	1971-05-11	1971-05-11 00:00:00	1971-05-11	5001	0	\N	0	0	\N	\N	0	10627	0	117015009	4024958		
53803	4932	40769184	1976-11-22	1976-11-22 00:00:00	1976-11-22	5001	0	\N	0	0	\N	\N	0	327866	0	66524-0	40769184		
11493	1099	3014599	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	72208	0	6106-9	3014599		
11541	1102	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	72441	0	6106-9	3014599		
63532	1951	4024958	1991-04-25	1991-04-25 00:00:00	1991-04-25	5001	0	\N	0	0	\N	\N	0	129776	0	117015009	4024958		
75074	2300	4133840	2004-01-15	2004-01-15 00:00:00	2004-01-15	5001	0	\N	0	0	\N	\N	0	153161	0	127783003	4133840		
17204	539	4024958	1980-12-18	1980-12-18 00:00:00	1980-12-18	5001	0	\N	0	0	\N	\N	0	35815	0	117015009	4024958		
35115	3211	3006322	1972-02-29	1972-02-29 00:00:00	1972-02-29	5001	0	\N	0	0	\N	\N	0	213315	0	8331-1	3006322		
34532	3159	3006322	1964-06-30	1964-06-30 00:00:00	1964-06-30	5001	0	\N	0	0	\N	\N	0	210036	0	8331-1	3006322		
45890	4227	3006322	1986-06-10	1986-06-10 00:00:00	1986-06-10	5001	0	\N	0	0	\N	\N	0	280847	0	8331-1	3006322		
2655	263	3051031	2003-04-04	2003-04-04 00:00:00	2003-04-04	5001	0	\N	0	0	\N	\N	0	17472	0	46240-8	3051031		
57362	5267	3000876	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	350431	0	6082-2	3000876		
9359	297	4024958	1965-05-23	1965-05-23 00:00:00	1965-05-23	5001	0	\N	0	0	\N	\N	0	19777	0	117015009	4024958		
36127	3325	40766240	1970-11-12	1970-11-12 00:00:00	1970-11-12	5001	0	\N	0	0	\N	\N	0	220711	0	63513-6	40766240		
25548	2341	3006322	1961-05-21	1961-05-21 00:00:00	1961-05-21	5001	0	\N	0	0	\N	\N	0	155785	0	8331-1	3006322		
15190	1397	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	92805	0	6273-7	3006451		
148982	4565	4024958	1963-03-30	1963-03-30 00:00:00	1963-03-30	5001	0	\N	0	0	\N	\N	0	304162	0	117015009	4024958		
35624	3253	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	216383	0	6106-9	3014599		
57965	1766	4133840	2009-10-13	2009-10-13 00:00:00	2009-10-13	5001	0	\N	0	0	\N	\N	0	118197	0	127783003	4133840		
35798	3279	3006322	2006-12-06	2006-12-06 00:00:00	2006-12-06	5001	0	\N	0	0	\N	\N	0	217923	0	8331-1	3006322		
56551	5193	3006322	1965-09-29	1965-09-29 00:00:00	1965-09-29	5001	0	\N	0	0	\N	\N	0	345208	0	8331-1	3006322		
87041	2688	4052083	2008-12-27	2008-12-27 00:00:00	2008-12-27	5001	0	\N	0	0	\N	\N	0	178152	0	23426006	4052083		
102085	3135	4052083	1990-09-08	1990-09-08 00:00:00	1990-09-08	5001	0	\N	0	0	\N	\N	0	208668	0	23426006	4052083		
11233	1082	3019406	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	70975	0	6158-0	3019406		
26186	2404	3006322	2003-07-14	2003-07-14 00:00:00	2003-07-14	5001	0	\N	0	0	\N	\N	0	159713	0	8331-1	3006322		
101980	3133	4052083	1962-09-20	1962-09-20 00:00:00	1962-09-20	5001	0	\N	0	0	\N	\N	0	208519	0	23426006	4052083		
124998	3859	4133840	2019-05-04	2019-05-04 00:00:00	2019-05-04	5001	0	\N	0	0	\N	\N	0	256248	0	127783003	4133840		
34358	3132	3006322	1995-05-05	1995-05-05 00:00:00	1995-05-05	5001	0	\N	0	0	\N	\N	0	208430	0	8331-1	3006322		
16034	1467	3006322	2006-03-15	2006-03-15 00:00:00	2006-03-15	5001	0	\N	0	0	\N	\N	0	97672	0	8331-1	3006322		
14252	1328	3011505	2000-08-24	2000-08-24 00:00:00	2000-08-24	5001	0	\N	0	0	\N	\N	0	88186	0	19926-5	3011505		
39975	3717	3001247	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	246997	0	6085-5	3001247		
143304	4403	4024958	1942-01-26	1942-01-26 00:00:00	1942-01-26	5001	0	\N	0	0	\N	\N	0	292664	0	117015009	4024958		
143375	4406	4024958	1960-07-19	1960-07-19 00:00:00	1960-07-19	5001	0	\N	0	0	\N	\N	0	292904	0	117015009	4024958		
13854	1306	3006322	2014-11-19	2014-11-19 00:00:00	2014-11-19	5001	0	\N	0	0	\N	\N	0	86183	0	8331-1	3006322		
31269	2858	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	189881	0	6082-2	3000876		
170850	5241	4052083	2017-03-18	2017-03-18 00:00:00	2017-03-18	5001	0	\N	0	0	\N	\N	0	348771	0	23426006	4052083		
145003	4451	4052083	1957-03-14	1957-03-14 00:00:00	1957-03-14	5001	0	\N	0	0	\N	\N	0	296177	0	23426006	4052083		
35365	3240	3051031	1993-06-10	1993-06-10 00:00:00	1993-06-10	5001	0	\N	0	0	\N	\N	0	215347	0	46240-8	3051031		
46724	4304	3006322	1996-05-24	1996-05-24 00:00:00	1996-05-24	5001	0	\N	0	0	\N	\N	0	285519	0	8331-1	3006322		
55021	5039	3006322	1991-03-13	1991-03-13 00:00:00	1991-03-13	5001	0	\N	0	0	\N	\N	0	334856	0	8331-1	3006322		
46882	4313	3001247	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	286276	0	6085-5	3001247		
57753	5300	3024731	1945-02-13	1945-02-13 00:00:00	1945-02-13	5001	0	\N	0	0	\N	\N	0	352654	0	30428-7	3024731		
156669	4815	4052083	2012-06-02	2012-06-02 00:00:00	2012-06-02	5001	0	\N	0	0	\N	\N	0	320330	0	23426006	4052083		
21802	2005	3006322	2005-04-21	2005-04-21 00:00:00	2005-04-21	5001	0	\N	0	0	\N	\N	0	133522	0	8331-1	3006322		
33167	2993	3006322	1981-07-16	1981-07-16 00:00:00	1981-07-16	5001	0	\N	0	0	\N	\N	0	199778	0	8331-1	3006322		
33248	3001	3006322	1969-04-23	1969-04-23 00:00:00	1969-04-23	5001	0	\N	0	0	\N	\N	0	200237	0	8331-1	3006322		
39640	3680	3023430	1992-04-07	1992-04-07 00:00:00	1992-04-07	5001	0	\N	0	0	\N	\N	0	244679	0	6833-8	3023430		
13617	1280	3006322	1984-12-07	1984-12-07 00:00:00	1984-12-07	5001	0	\N	0	0	\N	\N	0	84530	0	8331-1	3006322		
44854	4145	3036780	2006-07-29	2006-07-29 00:00:00	2006-07-29	5001	0	\N	0	0	\N	\N	0	275533	0	6095-4	3036780		
17572	1598	3006322	1972-08-19	1972-08-19 00:00:00	1972-08-19	5001	0	\N	0	0	\N	\N	0	107221	0	8331-1	3006322		
56254	5165	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	343257	0	6276-0	3027231		
25231	2319	3006322	1964-11-25	1964-11-25 00:00:00	1964-11-25	5001	0	\N	0	0	\N	\N	0	154227	0	8331-1	3006322		
36599	3364	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	223062	0	7258-7	3001488		
22327	2053	40758406	1963-09-28	1963-09-28 00:00:00	1963-09-28	5001	0	\N	0	0	\N	\N	0	136503	0	55277-8	40758406		
48092	4412	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	293384	0	6158-0	3019406		
50898	4641	3011505	2017-07-13	2017-07-13 00:00:00	2017-07-13	5001	0	\N	0	0	\N	\N	0	309346	0	19926-5	3011505		
50965	4646	3006734	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	309825	0	6189-5	3006734		
36227	3335	46235214	2014-09-12	2014-09-12 00:00:00	2014-09-12	5001	0	\N	0	0	\N	\N	0	221266	0	76690-7	46235214		
19370	1773	3006322	1967-05-19	1967-05-19 00:00:00	1967-05-19	5001	0	\N	0	0	\N	\N	0	118571	0	8331-1	3006322		
56609	5197	3002385	1962-06-05	1962-06-05 00:00:00	1962-06-05	5001	0	\N	0	0	\N	\N	0	345571	0	30385-9	3002385		
56735	5207	3006322	1990-03-07	1990-03-07 00:00:00	1990-03-07	5001	0	\N	0	0	\N	\N	0	346315	0	8331-1	3006322		
46484	4278	3011505	2016-11-25	2016-11-25 00:00:00	2016-11-25	5001	0	\N	0	0	\N	\N	0	283851	0	19926-5	3011505		
31460	2876	3011505	2008-06-12	2008-06-12 00:00:00	2008-06-12	5001	0	\N	0	0	\N	\N	0	191384	0	19926-5	3011505		
106132	3268	4052083	2014-06-10	2014-06-10 00:00:00	2014-06-10	5001	0	\N	0	0	\N	\N	0	217176	0	23426006	4052083		
5088	155	4024958	1988-04-08	1988-04-08 00:00:00	1988-04-08	5001	0	\N	0	0	\N	\N	0	10617	0	117015009	4024958		
53804	4932	40769194	1976-11-22	1976-11-22 00:00:00	1976-11-22	5001	0	\N	0	0	\N	\N	0	327866	0	66534-9	40769194		
11494	1099	3006322	1979-03-23	1979-03-23 00:00:00	1979-03-23	5001	0	\N	0	0	\N	\N	0	72242	0	8331-1	3006322		
11542	1102	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	72441	0	6085-5	3001247		
63535	1951	4024958	2014-05-03	2014-05-03 00:00:00	2014-05-03	5001	0	\N	0	0	\N	\N	0	129761	0	117015009	4024958		
60874	1855	4052083	2004-03-22	2004-03-22 00:00:00	2004-03-22	5001	0	\N	0	0	\N	\N	0	124214	0	23426006	4052083		
17205	539	4052083	1950-11-24	1950-11-24 00:00:00	1950-11-24	5001	0	\N	0	0	\N	\N	0	35794	0	23426006	4052083		
35116	3211	3006322	1996-04-18	1996-04-18 00:00:00	1996-04-18	5001	0	\N	0	0	\N	\N	0	213332	0	8331-1	3006322		
34533	3159	3006322	1970-11-17	1970-11-17 00:00:00	1970-11-17	5001	0	\N	0	0	\N	\N	0	210024	0	8331-1	3006322		
45891	4227	3006322	1987-05-18	1987-05-18 00:00:00	1987-05-18	5001	0	\N	0	0	\N	\N	0	280782	0	8331-1	3006322		
2656	263	40758406	2003-04-04	2003-04-04 00:00:00	2003-04-04	5001	0	\N	0	0	\N	\N	0	17472	0	55277-8	40758406		
57363	5267	3036780	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	350431	0	6095-4	3036780		
9369	297	4024958	1967-12-17	1967-12-17 00:00:00	1967-12-17	5001	0	\N	0	0	\N	\N	0	19805	0	117015009	4024958		
36128	3325	40758406	1970-11-12	1970-11-12 00:00:00	1970-11-12	5001	0	\N	0	0	\N	\N	0	220711	0	55277-8	40758406		
25549	2341	3006322	2014-08-17	2014-08-17 00:00:00	2014-08-17	5001	0	\N	0	0	\N	\N	0	155862	0	8331-1	3006322		
15191	1397	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	92805	0	6246-3	3021226		
148993	4565	4052083	1977-05-23	1977-05-23 00:00:00	1977-05-23	5001	0	\N	0	0	\N	\N	0	304236	0	23426006	4052083		
35625	3253	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	216383	0	6248-9	3015076		
57967	1766	4024958	1994-04-15	1994-04-15 00:00:00	1994-04-15	5001	0	\N	0	0	\N	\N	0	118147	0	117015009	4024958		
35799	3280	3006322	1999-01-25	1999-01-25 00:00:00	1999-01-25	5001	0	\N	0	0	\N	\N	0	218044	0	8331-1	3006322		
56552	5193	3006322	2009-03-01	2009-03-01 00:00:00	2009-03-01	5001	0	\N	0	0	\N	\N	0	345180	0	8331-1	3006322		
136782	4217	4024958	1983-04-14	1983-04-14 00:00:00	1983-04-14	5001	0	\N	0	0	\N	\N	0	279968	0	117015009	4024958		
102088	3135	4052083	1979-12-27	1979-12-27 00:00:00	1979-12-27	5001	0	\N	0	0	\N	\N	0	208685	0	23426006	4052083		
11234	1082	3001247	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	70975	0	6085-5	3001247		
26187	2404	3006322	2016-10-13	2016-10-13 00:00:00	2016-10-13	5001	0	\N	0	0	\N	\N	0	159769	0	8331-1	3006322		
101983	3133	4024958	1965-10-19	1965-10-19 00:00:00	1965-10-19	5001	0	\N	0	0	\N	\N	0	208520	0	117015009	4024958		
125002	3859	4133840	2018-04-28	2018-04-28 00:00:00	2018-04-28	5001	0	\N	0	0	\N	\N	0	256183	0	127783003	4133840		
34360	3133	40766240	2004-09-07	2004-09-07 00:00:00	2004-09-07	5001	0	\N	0	0	\N	\N	0	208502	0	63513-6	40766240		
16035	1467	3006322	1957-11-20	1957-11-20 00:00:00	1957-11-20	5001	0	\N	0	0	\N	\N	0	97745	0	8331-1	3006322		
14253	1328	3011505	1983-12-08	1983-12-08 00:00:00	1983-12-08	5001	0	\N	0	0	\N	\N	0	88228	0	19926-5	3011505		
64655	1982	4052083	1987-08-16	1987-08-16 00:00:00	1987-08-16	5001	0	\N	0	0	\N	\N	0	131957	0	23426006	4052083		
143306	4403	4133840	1996-06-22	1996-06-22 00:00:00	1996-06-22	5001	0	\N	0	0	\N	\N	0	292691	0	127783003	4133840		
154660	4745	4052083	1988-02-23	1988-02-23 00:00:00	1988-02-23	5001	0	\N	0	0	\N	\N	0	315964	0	23426006	4052083		
13855	1306	3049273	2019-04-11	2019-04-11 00:00:00	2019-04-11	5001	0	\N	0	0	\N	\N	0	86205	0	38265-5	3049273		
31270	2858	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	189881	0	6085-5	3001247		
170851	5241	4024958	2005-10-14	2005-10-14 00:00:00	2005-10-14	5001	0	\N	0	0	\N	\N	0	348759	0	117015009	4024958		
145012	4451	4024958	2005-03-22	2005-03-22 00:00:00	2005-03-22	5001	0	\N	0	0	\N	\N	0	296168	0	117015009	4024958		
35366	3240	40758406	1993-06-10	1993-06-10 00:00:00	1993-06-10	5001	0	\N	0	0	\N	\N	0	215347	0	55277-8	40758406		
46725	4304	3006322	1990-09-08	1990-09-08 00:00:00	1990-09-08	5001	0	\N	0	0	\N	\N	0	285518	0	8331-1	3006322		
55022	5039	3006322	1991-05-29	1991-05-29 00:00:00	1991-05-29	5001	0	\N	0	0	\N	\N	0	334882	0	8331-1	3006322		
46883	4313	3014599	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	286276	0	6106-9	3014599		
57754	5300	3010813	1945-02-13	1945-02-13 00:00:00	1945-02-13	5001	0	\N	0	0	\N	\N	0	352654	0	26464-8	3010813		
140605	4337	4052083	1964-12-31	1964-12-31 00:00:00	1964-12-31	5001	0	\N	0	0	\N	\N	0	287637	0	23426006	4052083		
21803	2006	3006322	1980-07-29	1980-07-29 00:00:00	1980-07-29	5001	0	\N	0	0	\N	\N	0	133593	0	8331-1	3006322		
33168	2993	3011505	2007-09-01	2007-09-01 00:00:00	2007-09-01	5001	0	\N	0	0	\N	\N	0	199775	0	19926-5	3011505		
33249	3001	3006322	1959-07-03	1959-07-03 00:00:00	1959-07-03	5001	0	\N	0	0	\N	\N	0	200269	0	8331-1	3006322		
39641	3680	3006734	1992-04-07	1992-04-07 00:00:00	1992-04-07	5001	0	\N	0	0	\N	\N	0	244679	0	6189-5	3006734		
13618	1280	3006322	1958-08-10	1958-08-10 00:00:00	1958-08-10	5001	0	\N	0	0	\N	\N	0	84596	0	8331-1	3006322		
44855	4145	3014599	2006-07-29	2006-07-29 00:00:00	2006-07-29	5001	0	\N	0	0	\N	\N	0	275533	0	6106-9	3014599		
17573	1598	3006322	1984-09-26	1984-09-26 00:00:00	1984-09-26	5001	0	\N	0	0	\N	\N	0	107249	0	8331-1	3006322		
56255	5165	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	343257	0	6248-9	3015076		
25232	2319	3006322	2019-03-05	2019-03-05 00:00:00	2019-03-05	5001	0	\N	0	0	\N	\N	0	154222	0	8331-1	3006322		
36600	3364	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	223062	0	6082-2	3000876		
22328	2053	3051031	1963-09-28	1963-09-28 00:00:00	1963-09-28	5001	0	\N	0	0	\N	\N	0	136503	0	46240-8	3051031		
48093	4412	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	293331	0	7258-7	3001488		
50899	4641	3006322	1973-08-27	1973-08-27 00:00:00	1973-08-27	5001	0	\N	0	0	\N	\N	0	309329	0	8331-1	3006322		
50966	4646	3001247	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	309825	0	6085-5	3001247		
36228	3335	46235214	2014-04-15	2014-04-15 00:00:00	2014-04-15	5001	0	\N	0	0	\N	\N	0	221278	0	76690-7	46235214		
19371	1773	3006322	1978-07-18	1978-07-18 00:00:00	1978-07-18	5001	0	\N	0	0	\N	\N	0	118572	0	8331-1	3006322		
56610	5197	3013682	1962-06-05	1962-06-05 00:00:00	1962-06-05	5001	0	\N	0	0	\N	\N	0	345571	0	3094-0	3013682		
56736	5207	40766240	2001-05-29	2001-05-29 00:00:00	2001-05-29	5001	0	\N	0	0	\N	\N	0	346364	0	63513-6	40766240		
46485	4278	3011505	2002-09-06	2002-09-06 00:00:00	2002-09-06	5001	0	\N	0	0	\N	\N	0	283864	0	19926-5	3011505		
31461	2876	3011505	2016-10-27	2016-10-27 00:00:00	2016-10-27	5001	0	\N	0	0	\N	\N	0	191385	0	19926-5	3011505		
106134	3268	4024958	2003-02-21	2003-02-21 00:00:00	2003-02-21	5001	0	\N	0	0	\N	\N	0	217187	0	117015009	4024958		
32376	2942	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	196157	0	6106-9	3014599		
53805	4933	3006322	1984-08-01	1984-08-01 00:00:00	1984-08-01	5001	0	\N	0	0	\N	\N	0	327972	0	8331-1	3006322		
11495	1099	3027231	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	72208	0	6276-0	3027231		
11543	1102	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	72441	0	6189-5	3006734		
63536	1951	4024958	2009-07-20	2009-07-20 00:00:00	2009-07-20	5001	0	\N	0	0	\N	\N	0	129760	0	117015009	4024958		
60924	1860	4024958	1994-11-04	1994-11-04 00:00:00	1994-11-04	5001	0	\N	0	0	\N	\N	0	124361	0	117015009	4024958		
17209	539	4052083	1989-01-16	1989-01-16 00:00:00	1989-01-16	5001	0	\N	0	0	\N	\N	0	35836	0	23426006	4052083		
35117	3212	3002385	2018-07-21	2018-07-21 00:00:00	2018-07-21	5001	0	\N	0	0	\N	\N	0	213430	0	30385-9	3002385		
34534	3159	3006322	1985-07-07	1985-07-07 00:00:00	1985-07-07	5001	0	\N	0	0	\N	\N	0	210091	0	8331-1	3006322		
45892	4227	3006322	2004-06-30	2004-06-30 00:00:00	2004-06-30	5001	0	\N	0	0	\N	\N	0	280820	0	8331-1	3006322		
2657	263	46235214	2003-04-04	2003-04-04 00:00:00	2003-04-04	5001	0	\N	0	0	\N	\N	0	17472	0	76690-7	46235214		
57364	5267	3015076	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	350431	0	6248-9	3015076		
9371	297	4024958	1963-07-18	1963-07-18 00:00:00	1963-07-18	5001	0	\N	0	0	\N	\N	0	19804	0	117015009	4024958		
36130	3325	46235214	1970-11-12	1970-11-12 00:00:00	1970-11-12	5001	0	\N	0	0	\N	\N	0	220711	0	76690-7	46235214		
25550	2342	3006322	2007-09-27	2007-09-27 00:00:00	2007-09-27	5001	0	\N	0	0	\N	\N	0	155924	0	8331-1	3006322		
15192	1397	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	92805	0	6206-7	3012494		
148997	4565	4052083	2011-11-04	2011-11-04 00:00:00	2011-11-04	5001	0	\N	0	0	\N	\N	0	304168	0	23426006	4052083		
35626	3253	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	216383	0	6276-0	3027231		
57969	1766	4133840	1981-01-06	1981-01-06 00:00:00	1981-01-06	5001	0	\N	0	0	\N	\N	0	118180	0	127783003	4133840		
35800	3280	3011505	2018-12-20	2018-12-20 00:00:00	2018-12-20	5001	0	\N	0	0	\N	\N	0	218001	0	19926-5	3011505		
56553	5193	3006322	1975-06-06	1975-06-06 00:00:00	1975-06-06	5001	0	\N	0	0	\N	\N	0	345179	0	8331-1	3006322		
136783	4217	4024958	1976-01-11	1976-01-11 00:00:00	1976-01-11	5001	0	\N	0	0	\N	\N	0	279947	0	117015009	4024958		
102115	3137	4024958	1935-05-10	1935-05-10 00:00:00	1935-05-10	5001	0	\N	0	0	\N	\N	0	208778	0	117015009	4024958		
11235	1082	3006734	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	70975	0	6189-5	3006734		
26188	2406	3006322	1964-03-05	1964-03-05 00:00:00	1964-03-05	5001	0	\N	0	0	\N	\N	0	159830	0	8331-1	3006322		
113320	3501	4052083	1961-05-15	1961-05-15 00:00:00	1961-05-15	5001	0	\N	0	0	\N	\N	0	232121	0	23426006	4052083		
125008	3859	4133840	2006-09-30	2006-09-30 00:00:00	2006-09-30	5001	0	\N	0	0	\N	\N	0	256258	0	127783003	4133840		
34361	3133	3051031	2004-09-07	2004-09-07 00:00:00	2004-09-07	5001	0	\N	0	0	\N	\N	0	208502	0	46240-8	3051031		
16036	1467	3000963	2006-03-08	2006-03-08 00:00:00	2006-03-08	5001	0	\N	0	0	\N	\N	0	97751	0	718-7	3000963		
14254	1328	3011505	1999-08-19	1999-08-19 00:00:00	1999-08-19	5001	0	\N	0	0	\N	\N	0	88168	0	19926-5	3011505		
64673	1982	4024958	1992-10-26	1992-10-26 00:00:00	1992-10-26	5001	0	\N	0	0	\N	\N	0	132019	0	117015009	4024958		
143314	4403	4133840	1995-06-17	1995-06-17 00:00:00	1995-06-17	5001	0	\N	0	0	\N	\N	0	292695	0	127783003	4133840		
25753	2359	3006322	1983-04-13	1983-04-13 00:00:00	1983-04-13	5001	0	\N	0	0	\N	\N	0	157178	0	8331-1	3006322		
13856	1306	3006322	1994-05-24	1994-05-24 00:00:00	1994-05-24	5001	0	\N	0	0	\N	\N	0	86181	0	8331-1	3006322		
31271	2858	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	189881	0	6189-5	3006734		
170860	5241	4024958	1996-01-20	1996-01-20 00:00:00	1996-01-20	5001	0	\N	0	0	\N	\N	0	348719	0	117015009	4024958		
122321	3772	4052083	2014-06-28	2014-06-28 00:00:00	2014-06-28	5001	0	\N	0	0	\N	\N	0	250762	0	23426006	4052083		
35367	3240	40766240	1993-06-10	1993-06-10 00:00:00	1993-06-10	5001	0	\N	0	0	\N	\N	0	215347	0	63513-6	40766240		
46726	4305	3006322	2014-03-06	2014-03-06 00:00:00	2014-03-06	5001	0	\N	0	0	\N	\N	0	285532	0	8331-1	3006322		
55023	5039	3006322	1979-12-27	1979-12-27 00:00:00	1979-12-27	5001	0	\N	0	0	\N	\N	0	334860	0	8331-1	3006322		
46884	4313	3012494	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	286276	0	6206-7	3012494		
57755	5300	3004501	1945-02-13	1945-02-13 00:00:00	1945-02-13	5001	0	\N	0	0	\N	\N	0	352654	0	2345-7	3004501		
140608	4337	4052083	2016-07-06	2016-07-06 00:00:00	2016-07-06	5001	0	\N	0	0	\N	\N	0	287567	0	23426006	4052083		
21804	2006	3008598	2017-12-31	2017-12-31 00:00:00	2017-12-31	5001	0	\N	0	0	\N	\N	0	133644	0	3024-7	3008598		
33169	2993	3011505	2010-06-19	2010-06-19 00:00:00	2010-06-19	5001	0	\N	0	0	\N	\N	0	199776	0	19926-5	3011505		
33250	3001	3006322	2015-10-28	2015-10-28 00:00:00	2015-10-28	5001	0	\N	0	0	\N	\N	0	200288	0	8331-1	3006322		
39642	3680	3005136	1992-04-07	1992-04-07 00:00:00	1992-04-07	5001	0	\N	0	0	\N	\N	0	244679	0	6075-6	3005136		
13619	1280	3006322	1990-04-05	1990-04-05 00:00:00	1990-04-05	5001	0	\N	0	0	\N	\N	0	84617	0	8331-1	3006322		
44856	4145	3006734	2006-07-29	2006-07-29 00:00:00	2006-07-29	5001	0	\N	0	0	\N	\N	0	275533	0	6189-5	3006734		
17574	1598	3006322	2017-07-17	2017-07-17 00:00:00	2017-07-17	5001	0	\N	0	0	\N	\N	0	107251	0	8331-1	3006322		
56256	5165	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	343257	0	6158-0	3019406		
25233	2319	3006322	1984-02-06	1984-02-06 00:00:00	1984-02-06	5001	0	\N	0	0	\N	\N	0	154208	0	8331-1	3006322		
36601	3364	3006322	1980-03-06	1980-03-06 00:00:00	1980-03-06	5001	0	\N	0	0	\N	\N	0	223039	0	8331-1	3006322		
22329	2053	3051031	1963-07-30	1963-07-30 00:00:00	1963-07-30	5001	0	\N	0	0	\N	\N	0	136556	0	46240-8	3051031		
48094	4412	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	293331	0	6095-4	3036780		
50900	4641	3011505	2013-08-01	2013-08-01 00:00:00	2013-08-01	5001	0	\N	0	0	\N	\N	0	309303	0	19926-5	3011505		
50967	4646	3020655	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	309825	0	6844-5	3020655		
36230	3335	3051031	2014-04-15	2014-04-15 00:00:00	2014-04-15	5001	0	\N	0	0	\N	\N	0	221278	0	46240-8	3051031		
19372	1773	3006322	1974-01-25	1974-01-25 00:00:00	1974-01-25	5001	0	\N	0	0	\N	\N	0	118523	0	8331-1	3006322		
56611	5197	3007461	1962-06-05	1962-06-05 00:00:00	1962-06-05	5001	0	\N	0	0	\N	\N	0	345571	0	26515-7	3007461		
56738	5207	46235214	2001-05-29	2001-05-29 00:00:00	2001-05-29	5001	0	\N	0	0	\N	\N	0	346364	0	76690-7	46235214		
46486	4278	3006322	2002-12-28	2002-12-28 00:00:00	2002-12-28	5001	0	\N	0	0	\N	\N	0	283841	0	8331-1	3006322		
31462	2876	3011505	2007-10-25	2007-10-25 00:00:00	2007-10-25	5001	0	\N	0	0	\N	\N	0	191374	0	19926-5	3011505		
106136	3268	4024958	1974-09-15	1974-09-15 00:00:00	1974-09-15	5001	0	\N	0	0	\N	\N	0	217172	0	117015009	4024958		
32377	2942	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	196157	0	6085-5	3001247		
53806	4933	3006322	1981-11-05	1981-11-05 00:00:00	1981-11-05	5001	0	\N	0	0	\N	\N	0	327928	0	8331-1	3006322		
11496	1099	3019406	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	72208	0	6158-0	3019406		
47823	1459	4024958	1948-11-09	1948-11-09 00:00:00	1948-11-09	5001	0	\N	0	0	\N	\N	0	97233	0	117015009	4024958		
63635	1954	4052083	1964-05-04	1964-05-04 00:00:00	1964-05-04	5001	0	\N	0	0	\N	\N	0	130046	0	23426006	4052083		
60926	1860	4024958	1966-11-15	1966-11-15 00:00:00	1966-11-15	5001	0	\N	0	0	\N	\N	0	124356	0	117015009	4024958		
17217	539	4052083	1957-03-08	1957-03-08 00:00:00	1957-03-08	5001	0	\N	0	0	\N	\N	0	35770	0	23426006	4052083		
35118	3212	3007461	2018-07-21	2018-07-21 00:00:00	2018-07-21	5001	0	\N	0	0	\N	\N	0	213430	0	26515-7	3007461		
34535	3159	3006322	2004-01-12	2004-01-12 00:00:00	2004-01-12	5001	0	\N	0	0	\N	\N	0	210040	0	8331-1	3006322		
45893	4227	3006322	1960-05-18	1960-05-18 00:00:00	1960-05-18	5001	0	\N	0	0	\N	\N	0	280852	0	8331-1	3006322		
2658	263	40766240	2003-04-04	2003-04-04 00:00:00	2003-04-04	5001	0	\N	0	0	\N	\N	0	17472	0	63513-6	40766240		
57365	5267	3012494	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	350431	0	6206-7	3012494		
9373	297	4024958	1960-03-20	1960-03-20 00:00:00	1960-03-20	5001	0	\N	0	0	\N	\N	0	19788	0	117015009	4024958		
36131	3325	3006322	2005-03-11	2005-03-11 00:00:00	2005-03-11	5001	0	\N	0	0	\N	\N	0	220745	0	8331-1	3006322		
25551	2343	3006322	1965-03-30	1965-03-30 00:00:00	1965-03-30	5001	0	\N	0	0	\N	\N	0	156000	0	8331-1	3006322		
15193	1397	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	92805	0	6085-5	3001247		
149010	4565	4052083	2012-10-23	2012-10-23 00:00:00	2012-10-23	5001	0	\N	0	0	\N	\N	0	304258	0	23426006	4052083		
35627	3253	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	216383	0	6158-0	3019406		
57971	1766	4133840	2019-04-02	2019-04-02 00:00:00	2019-04-02	5001	0	\N	0	0	\N	\N	0	118199	0	127783003	4133840		
47084	4342	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	287954	0	6082-2	3000876		
56554	5194	3006322	1953-08-03	1953-08-03 00:00:00	1953-08-03	5001	0	\N	0	0	\N	\N	0	345287	0	8331-1	3006322		
136813	4217	4024958	1989-02-22	1989-02-22 00:00:00	1989-02-22	5001	0	\N	0	0	\N	\N	0	279949	0	117015009	4024958		
102116	3137	4052083	1944-01-16	1944-01-16 00:00:00	1944-01-16	5001	0	\N	0	0	\N	\N	0	208825	0	23426006	4052083		
11236	1082	3006322	1966-02-25	1966-02-25 00:00:00	1966-02-25	5001	0	\N	0	0	\N	\N	0	70903	0	8331-1	3006322		
26189	2406	3006322	1985-01-15	1985-01-15 00:00:00	1985-01-15	5001	0	\N	0	0	\N	\N	0	159844	0	8331-1	3006322		
113321	3501	4024958	1990-03-12	1990-03-12 00:00:00	1990-03-12	5001	0	\N	0	0	\N	\N	0	232067	0	117015009	4024958		
125009	3859	4133840	1987-09-10	1987-09-10 00:00:00	1987-09-10	5001	0	\N	0	0	\N	\N	0	256254	0	127783003	4133840		
34362	3133	40758406	2004-09-07	2004-09-07 00:00:00	2004-09-07	5001	0	\N	0	0	\N	\N	0	208502	0	55277-8	40758406		
16037	1467	3009542	2006-03-08	2006-03-08 00:00:00	2006-03-08	5001	0	\N	0	0	\N	\N	0	97751	0	20570-8	3009542		
14255	1328	3011505	2017-04-20	2017-04-20 00:00:00	2017-04-20	5001	0	\N	0	0	\N	\N	0	88174	0	19926-5	3011505		
64675	1982	4024958	1949-04-29	1949-04-29 00:00:00	1949-04-29	5001	0	\N	0	0	\N	\N	0	131999	0	117015009	4024958		
143346	4405	4024958	1971-03-13	1971-03-13 00:00:00	1971-03-13	5001	0	\N	0	0	\N	\N	0	292796	0	117015009	4024958		
37058	3407	3006322	1969-11-04	1969-11-04 00:00:00	1969-11-04	5001	0	\N	0	0	\N	\N	0	225933	0	8331-1	3006322		
13857	1306	3006322	1984-11-25	1984-11-25 00:00:00	1984-11-25	5001	0	\N	0	0	\N	\N	0	86192	0	8331-1	3006322		
31272	2858	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	189881	0	6095-4	3036780		
170863	5241	4024958	1975-08-27	1975-08-27 00:00:00	1975-08-27	5001	0	\N	0	0	\N	\N	0	348756	0	117015009	4024958		
122332	3773	4052083	2003-06-09	2003-06-09 00:00:00	2003-06-09	5001	0	\N	0	0	\N	\N	0	250824	0	23426006	4052083		
35368	3240	3006322	2006-07-19	2006-07-19 00:00:00	2006-07-19	5001	0	\N	0	0	\N	\N	0	215383	0	8331-1	3006322		
46727	4305	3006322	2007-08-28	2007-08-28 00:00:00	2007-08-28	5001	0	\N	0	0	\N	\N	0	285643	0	8331-1	3006322		
55024	5041	3006322	1972-01-20	1972-01-20 00:00:00	1972-01-20	5001	0	\N	0	0	\N	\N	0	334948	0	8331-1	3006322		
46885	4313	3000876	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	286276	0	6082-2	3000876		
57756	5300	3006923	1945-02-13	1945-02-13 00:00:00	1945-02-13	5001	0	\N	0	0	\N	\N	0	352654	0	1742-6	3006923		
140612	4337	4052083	1962-04-07	1962-04-07 00:00:00	1962-04-07	5001	0	\N	0	0	\N	\N	0	287600	0	23426006	4052083		
21805	2006	3009201	2017-12-31	2017-12-31 00:00:00	2017-12-31	5001	0	\N	0	0	\N	\N	0	133644	0	3016-3	3009201		
21915	2016	3006322	2017-06-14	2017-06-14 00:00:00	2017-06-14	5001	0	\N	0	0	\N	\N	0	134095	0	8331-1	3006322		
33251	3001	3006322	1990-11-11	1990-11-11 00:00:00	1990-11-11	5001	0	\N	0	0	\N	\N	0	200316	0	8331-1	3006322		
39643	3680	3021226	1992-04-07	1992-04-07 00:00:00	1992-04-07	5001	0	\N	0	0	\N	\N	0	244679	0	6246-3	3021226		
13620	1281	3006322	2006-10-19	2006-10-19 00:00:00	2006-10-19	5001	0	\N	0	0	\N	\N	0	84644	0	8331-1	3006322		
44857	4145	3001488	2006-07-29	2006-07-29 00:00:00	2006-07-29	5001	0	\N	0	0	\N	\N	0	275533	0	7258-7	3001488		
17575	1599	3006322	1991-12-18	1991-12-18 00:00:00	1991-12-18	5001	0	\N	0	0	\N	\N	0	107330	0	8331-1	3006322		
56257	5165	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	343257	0	6106-9	3014599		
25234	2319	3006322	1977-03-29	1977-03-29 00:00:00	1977-03-29	5001	0	\N	0	0	\N	\N	0	154218	0	8331-1	3006322		
36602	3365	3006322	2013-03-14	2013-03-14 00:00:00	2013-03-14	5001	0	\N	0	0	\N	\N	0	223175	0	8331-1	3006322		
22330	2053	40758406	1963-07-30	1963-07-30 00:00:00	1963-07-30	5001	0	\N	0	0	\N	\N	0	136556	0	55277-8	40758406		
48095	4412	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	293331	0	6844-5	3020655		
50901	4641	3011505	2001-09-06	2001-09-06 00:00:00	2001-09-06	5001	0	\N	0	0	\N	\N	0	309350	0	19926-5	3011505		
50968	4646	3036780	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	309825	0	6095-4	3036780		
36231	3335	40758406	2014-04-15	2014-04-15 00:00:00	2014-04-15	5001	0	\N	0	0	\N	\N	0	221278	0	55277-8	40758406		
6251	191	4052083	1967-06-30	1967-06-30 00:00:00	1967-06-30	5001	0	\N	0	0	\N	\N	0	13066	0	23426006	4052083		
56612	5197	3045716	1962-06-05	1962-06-05 00:00:00	1962-06-05	5001	0	\N	0	0	\N	\N	0	345571	0	33037-3	3045716		
56739	5207	40758406	2001-05-29	2001-05-29 00:00:00	2001-05-29	5001	0	\N	0	0	\N	\N	0	346364	0	55277-8	40758406		
46487	4278	3011505	1988-03-11	1988-03-11 00:00:00	1988-03-11	5001	0	\N	0	0	\N	\N	0	283896	0	19926-5	3011505		
31463	2876	3011505	1989-08-03	1989-08-03 00:00:00	1989-08-03	5001	0	\N	0	0	\N	\N	0	191372	0	19926-5	3011505		
52985	1606	4052083	2018-02-10	2018-02-10 00:00:00	2018-02-10	5001	0	\N	0	0	\N	\N	0	107862	0	23426006	4052083		
32378	2942	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	196157	0	6833-8	3023430		
53811	4935	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	328036	0	6273-7	3006451		
11497	1099	3021226	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	72208	0	6246-3	3021226		
47834	1459	4052083	1990-06-02	1990-06-02 00:00:00	1990-06-02	5001	0	\N	0	0	\N	\N	0	97263	0	23426006	4052083		
63641	1954	4024958	1944-09-28	1944-09-28 00:00:00	1944-09-28	5001	0	\N	0	0	\N	\N	0	129954	0	117015009	4024958		
60935	1860	4052083	1992-08-04	1992-08-04 00:00:00	1992-08-04	5001	0	\N	0	0	\N	\N	0	124375	0	23426006	4052083		
74718	2291	4024958	1992-12-11	1992-12-11 00:00:00	1992-12-11	5001	0	\N	0	0	\N	\N	0	152542	0	117015009	4024958		
35119	3212	3023103	2018-07-21	2018-07-21 00:00:00	2018-07-21	5001	0	\N	0	0	\N	\N	0	213430	0	2823-3	3023103		
34536	3159	3006322	2012-11-11	2012-11-11 00:00:00	2012-11-11	5001	0	\N	0	0	\N	\N	0	210041	0	8331-1	3006322		
45894	4227	3006322	1978-07-08	1978-07-08 00:00:00	1978-07-08	5001	0	\N	0	0	\N	\N	0	280781	0	8331-1	3006322		
2660	263	40758406	1999-07-09	1999-07-09 00:00:00	1999-07-09	5001	0	\N	0	0	\N	\N	0	17469	0	55277-8	40758406		
57366	5267	3020655	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	350431	0	6844-5	3020655		
9374	297	4024958	1970-10-27	1970-10-27 00:00:00	1970-10-27	5001	0	\N	0	0	\N	\N	0	19778	0	117015009	4024958		
36132	3325	40758406	1994-03-06	1994-03-06 00:00:00	1994-03-06	5001	0	\N	0	0	\N	\N	0	220744	0	55277-8	40758406		
25552	2344	3006322	1968-07-02	1968-07-02 00:00:00	1968-07-02	5001	0	\N	0	0	\N	\N	0	156074	0	8331-1	3006322		
15194	1397	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	92805	0	6833-8	3023430		
149042	4569	4052083	1999-02-02	1999-02-02 00:00:00	1999-02-02	5001	0	\N	0	0	\N	\N	0	304400	0	23426006	4052083		
35628	3253	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	216383	0	6246-3	3021226		
57972	1766	4024958	1958-10-10	1958-10-10 00:00:00	1958-10-10	5001	0	\N	0	0	\N	\N	0	118173	0	117015009	4024958		
47085	4342	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	287954	0	6276-0	3027231		
56555	5194	3006322	1946-06-18	1946-06-18 00:00:00	1946-06-18	5001	0	\N	0	0	\N	\N	0	345308	0	8331-1	3006322		
136828	4217	4024958	1973-09-06	1973-09-06 00:00:00	1973-09-06	5001	0	\N	0	0	\N	\N	0	279973	0	117015009	4024958		
102120	3137	4024958	1981-04-13	1981-04-13 00:00:00	1981-04-13	5001	0	\N	0	0	\N	\N	0	208794	0	117015009	4024958		
11237	1082	3006322	1978-10-28	1978-10-28 00:00:00	1978-10-28	5001	0	\N	0	0	\N	\N	0	70942	0	8331-1	3006322		
26190	2406	3006322	1949-05-08	1949-05-08 00:00:00	1949-05-08	5001	0	\N	0	0	\N	\N	0	159804	0	8331-1	3006322		
113325	3501	4024958	1997-07-01	1997-07-01 00:00:00	1997-07-01	5001	0	\N	0	0	\N	\N	0	232048	0	117015009	4024958		
125010	3859	4133840	2004-09-18	2004-09-18 00:00:00	2004-09-18	5001	0	\N	0	0	\N	\N	0	256240	0	127783003	4133840		
34364	3133	46235214	2004-09-07	2004-09-07 00:00:00	2004-09-07	5001	0	\N	0	0	\N	\N	0	208502	0	76690-7	46235214		
16038	1468	40766240	2016-08-27	2016-08-27 00:00:00	2016-08-27	5001	0	\N	0	0	\N	\N	0	97830	0	63513-6	40766240		
14256	1328	3011505	2018-04-26	2018-04-26 00:00:00	2018-04-26	5001	0	\N	0	0	\N	\N	0	88216	0	19926-5	3011505		
64677	1982	4024958	1957-06-11	1957-06-11 00:00:00	1957-06-11	5001	0	\N	0	0	\N	\N	0	132015	0	117015009	4024958		
25671	2352	3023430	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	156717	0	6833-8	3023430		
37059	3407	3006322	2016-06-23	2016-06-23 00:00:00	2016-06-23	5001	0	\N	0	0	\N	\N	0	225983	0	8331-1	3006322		
13858	1306	3006322	1959-05-28	1959-05-28 00:00:00	1959-05-28	5001	0	\N	0	0	\N	\N	0	86238	0	8331-1	3006322		
31273	2858	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	189881	0	6833-8	3023430		
25294	785	4052083	1989-08-15	1989-08-15 00:00:00	1989-08-15	5001	0	\N	0	0	\N	\N	0	52286	0	23426006	4052083		
122338	3773	4052083	1961-11-14	1961-11-14 00:00:00	1961-11-14	5001	0	\N	0	0	\N	\N	0	250777	0	23426006	4052083		
35369	3240	3006322	1975-05-06	1975-05-06 00:00:00	1975-05-06	5001	0	\N	0	0	\N	\N	0	215335	0	8331-1	3006322		
46728	4305	3006322	1963-07-28	1963-07-28 00:00:00	1963-07-28	5001	0	\N	0	0	\N	\N	0	285558	0	8331-1	3006322		
55025	5041	3006322	1983-07-24	1983-07-24 00:00:00	1983-07-24	5001	0	\N	0	0	\N	\N	0	334951	0	8331-1	3006322		
46886	4313	3036780	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	286276	0	6095-4	3036780		
57757	5300	3006906	1945-02-13	1945-02-13 00:00:00	1945-02-13	5001	0	\N	0	0	\N	\N	0	352654	0	17861-6	3006906		
140632	4338	4052083	2014-04-26	2014-04-26 00:00:00	2014-04-26	5001	0	\N	0	0	\N	\N	0	287667	0	23426006	4052083		
21806	2006	3006322	1961-12-11	1961-12-11 00:00:00	1961-12-11	5001	0	\N	0	0	\N	\N	0	133567	0	8331-1	3006322		
21916	2016	3006322	2002-01-19	2002-01-19 00:00:00	2002-01-19	5001	0	\N	0	0	\N	\N	0	134143	0	8331-1	3006322		
33252	3001	3006322	2019-02-21	2019-02-21 00:00:00	2019-02-21	5001	0	\N	0	0	\N	\N	0	200241	0	8331-1	3006322		
39644	3680	3027231	1992-04-07	1992-04-07 00:00:00	1992-04-07	5001	0	\N	0	0	\N	\N	0	244679	0	6276-0	3027231		
13621	1281	3006322	2000-07-09	2000-07-09 00:00:00	2000-07-09	5001	0	\N	0	0	\N	\N	0	84698	0	8331-1	3006322		
44858	4145	3001247	2006-07-29	2006-07-29 00:00:00	2006-07-29	5001	0	\N	0	0	\N	\N	0	275533	0	6085-5	3001247		
17576	1599	3006322	1962-11-26	1962-11-26 00:00:00	1962-11-26	5001	0	\N	0	0	\N	\N	0	107285	0	8331-1	3006322		
56258	5165	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	343257	0	6075-6	3005136		
25235	2319	3006322	2001-12-25	2001-12-25 00:00:00	2001-12-25	5001	0	\N	0	0	\N	\N	0	154228	0	8331-1	3006322		
36603	3365	3006322	1973-11-01	1973-11-01 00:00:00	1973-11-01	5001	0	\N	0	0	\N	\N	0	223172	0	8331-1	3006322		
22332	2053	46235214	1963-07-30	1963-07-30 00:00:00	1963-07-30	5001	0	\N	0	0	\N	\N	0	136556	0	76690-7	46235214		
48096	4412	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	293331	0	6085-5	3001247		
50902	4641	3011505	2015-08-06	2015-08-06 00:00:00	2015-08-06	5001	0	\N	0	0	\N	\N	0	309345	0	19926-5	3011505		
50969	4646	3023430	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	309825	0	6833-8	3023430		
36232	3335	40766240	2014-04-15	2014-04-15 00:00:00	2014-04-15	5001	0	\N	0	0	\N	\N	0	221278	0	63513-6	40766240		
6252	191	4133840	1995-10-03	1995-10-03 00:00:00	1995-10-03	5001	0	\N	0	0	\N	\N	0	13146	0	127783003	4133840		
56613	5197	3020630	1962-06-05	1962-06-05 00:00:00	1962-06-05	5001	0	\N	0	0	\N	\N	0	345571	0	2885-2	3020630		
56741	5207	3051031	2001-05-29	2001-05-29 00:00:00	2001-05-29	5001	0	\N	0	0	\N	\N	0	346364	0	46240-8	3051031		
46488	4278	3011505	2018-12-07	2018-12-07 00:00:00	2018-12-07	5001	0	\N	0	0	\N	\N	0	283863	0	19926-5	3011505		
31464	2876	3011505	2001-08-16	2001-08-16 00:00:00	2001-08-16	5001	0	\N	0	0	\N	\N	0	191388	0	19926-5	3011505		
52988	1606	4024958	1959-06-23	1959-06-23 00:00:00	1959-06-23	5001	0	\N	0	0	\N	\N	0	107880	0	117015009	4024958		
32379	2942	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	196157	0	6844-5	3020655		
53812	4935	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	328036	0	6158-0	3019406		
11498	1099	3005136	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	72208	0	6075-6	3005136		
47857	1460	4024958	1983-04-21	1983-04-21 00:00:00	1983-04-21	5001	0	\N	0	0	\N	\N	0	97307	0	117015009	4024958		
63661	1956	4052083	1996-04-23	1996-04-23 00:00:00	1996-04-23	5001	0	\N	0	0	\N	\N	0	130142	0	23426006	4052083		
60938	1860	4052083	1995-09-30	1995-09-30 00:00:00	1995-09-30	5001	0	\N	0	0	\N	\N	0	124384	0	23426006	4052083		
74739	2291	4052083	2018-12-19	2018-12-19 00:00:00	2018-12-19	5001	0	\N	0	0	\N	\N	0	152509	0	23426006	4052083		
35120	3212	3004501	2018-07-21	2018-07-21 00:00:00	2018-07-21	5001	0	\N	0	0	\N	\N	0	213430	0	2345-7	3004501		
34537	3159	3006322	1975-07-03	1975-07-03 00:00:00	1975-07-03	5001	0	\N	0	0	\N	\N	0	210037	0	8331-1	3006322		
45895	4229	3006322	1984-11-22	1984-11-22 00:00:00	1984-11-22	5001	0	\N	0	0	\N	\N	0	280945	0	8331-1	3006322		
2661	263	3051031	1999-07-09	1999-07-09 00:00:00	1999-07-09	5001	0	\N	0	0	\N	\N	0	17469	0	46240-8	3051031		
57367	5267	3023430	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	350431	0	6833-8	3023430		
9378	297	4052083	1999-11-21	1999-11-21 00:00:00	1999-11-21	5001	0	\N	0	0	\N	\N	0	19771	0	23426006	4052083		
36134	3325	46235214	1994-03-06	1994-03-06 00:00:00	1994-03-06	5001	0	\N	0	0	\N	\N	0	220744	0	76690-7	46235214		
25553	2344	3006322	1989-03-26	1989-03-26 00:00:00	1989-03-26	5001	0	\N	0	0	\N	\N	0	156025	0	8331-1	3006322		
15195	1397	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	92805	0	6844-5	3020655		
149047	4569	4024958	1976-06-09	1976-06-09 00:00:00	1976-06-09	5001	0	\N	0	0	\N	\N	0	304399	0	117015009	4024958		
35629	3253	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	216383	0	6095-4	3036780		
57974	1766	4133840	2017-11-28	2017-11-28 00:00:00	2017-11-28	5001	0	\N	0	0	\N	\N	0	118170	0	127783003	4133840		
47086	4342	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	287954	0	6248-9	3015076		
56556	5194	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	345299	0	6273-7	3006451		
136829	4217	4024958	1965-06-09	1965-06-09 00:00:00	1965-06-09	5001	0	\N	0	0	\N	\N	0	279971	0	117015009	4024958		
102124	3137	4052083	1920-07-27	1920-07-27 00:00:00	1920-07-27	5001	0	\N	0	0	\N	\N	0	208850	0	23426006	4052083		
11238	1083	40769184	1966-10-26	1966-10-26 00:00:00	1966-10-26	5001	0	\N	0	0	\N	\N	0	71098	0	66524-0	40769184		
26191	2406	3006322	1974-07-22	1974-07-22 00:00:00	1974-07-22	5001	0	\N	0	0	\N	\N	0	159840	0	8331-1	3006322		
113327	3501	4052083	2012-02-03	2012-02-03 00:00:00	2012-02-03	5001	0	\N	0	0	\N	\N	0	232084	0	23426006	4052083		
125014	3859	4052083	1954-10-15	1954-10-15 00:00:00	1954-10-15	5001	0	\N	0	0	\N	\N	0	256206	0	23426006	4052083		
34365	3133	3006322	2002-07-04	2002-07-04 00:00:00	2002-07-04	5001	0	\N	0	0	\N	\N	0	208522	0	8331-1	3006322		
16040	1468	40758406	2016-08-27	2016-08-27 00:00:00	2016-08-27	5001	0	\N	0	0	\N	\N	0	97830	0	55277-8	40758406		
14257	1328	3011505	2002-09-05	2002-09-05 00:00:00	2002-09-05	5001	0	\N	0	0	\N	\N	0	88187	0	19926-5	3011505		
64678	1982	4024958	1983-06-10	1983-06-10 00:00:00	1983-06-10	5001	0	\N	0	0	\N	\N	0	131993	0	117015009	4024958		
25672	2352	3020655	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	156717	0	6844-5	3020655		
37060	3407	3006322	1966-11-09	1966-11-09 00:00:00	1966-11-09	5001	0	\N	0	0	\N	\N	0	225980	0	8331-1	3006322		
167487	5143	4052083	1968-04-20	1968-04-20 00:00:00	1968-04-20	5001	0	\N	0	0	\N	\N	0	341852	0	23426006	4052083		
31274	2858	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	189881	0	6206-7	3012494		
25310	787	4024958	2014-03-28	2014-03-28 00:00:00	2014-03-28	5001	0	\N	0	0	\N	\N	0	52365	0	117015009	4024958		
8220	264	4024958	1958-05-04	1958-05-04 00:00:00	1958-05-04	5001	0	\N	0	0	\N	\N	0	17507	0	117015009	4024958		
35370	3240	40758406	1993-08-09	1993-08-09 00:00:00	1993-08-09	5001	0	\N	0	0	\N	\N	0	215387	0	55277-8	40758406		
46729	4305	3006322	1997-07-07	1997-07-07 00:00:00	1997-07-07	5001	0	\N	0	0	\N	\N	0	285530	0	8331-1	3006322		
55026	5041	3006322	1976-12-05	1976-12-05 00:00:00	1976-12-05	5001	0	\N	0	0	\N	\N	0	334915	0	8331-1	3006322		
46887	4313	3006451	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	286276	0	6273-7	3006451		
57758	5300	21494966	1945-02-13	1945-02-13 00:00:00	1945-02-13	5001	0	\N	0	0	\N	\N	0	352654	0	80271-0	21494966		
140637	4338	4024958	1967-12-01	1967-12-01 00:00:00	1967-12-01	5001	0	\N	0	0	\N	\N	0	287644	0	117015009	4024958		
21807	2006	3006322	1972-02-28	1972-02-28 00:00:00	1972-02-28	5001	0	\N	0	0	\N	\N	0	133619	0	8331-1	3006322		
21917	2016	3006322	2013-07-20	2013-07-20 00:00:00	2013-07-20	5001	0	\N	0	0	\N	\N	0	134111	0	8331-1	3006322		
33253	3001	3006322	1995-01-04	1995-01-04 00:00:00	1995-01-04	5001	0	\N	0	0	\N	\N	0	200271	0	8331-1	3006322		
39645	3680	3005136	1979-12-15	1979-12-15 00:00:00	1979-12-15	5001	0	\N	0	0	\N	\N	0	244725	0	6075-6	3005136		
13622	1281	3006322	1989-03-27	1989-03-27 00:00:00	1989-03-27	5001	0	\N	0	0	\N	\N	0	84642	0	8331-1	3006322		
44859	4145	3000876	2006-07-29	2006-07-29 00:00:00	2006-07-29	5001	0	\N	0	0	\N	\N	0	275533	0	6082-2	3000876		
17577	1599	3006322	1987-02-26	1987-02-26 00:00:00	1987-02-26	5001	0	\N	0	0	\N	\N	0	107293	0	8331-1	3006322		
56259	5165	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	343257	0	6082-2	3000876		
25236	2319	3006322	1966-10-03	1966-10-03 00:00:00	1966-10-03	5001	0	\N	0	0	\N	\N	0	154162	0	8331-1	3006322		
36604	3365	3006322	1993-09-10	1993-09-10 00:00:00	1993-09-10	5001	0	\N	0	0	\N	\N	0	223155	0	8331-1	3006322		
22334	2053	40766240	1963-07-30	1963-07-30 00:00:00	1963-07-30	5001	0	\N	0	0	\N	\N	0	136556	0	63513-6	40766240		
48097	4412	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	293331	0	6833-8	3023430		
50903	4641	3011505	2004-09-09	2004-09-09 00:00:00	2004-09-09	5001	0	\N	0	0	\N	\N	0	309351	0	19926-5	3011505		
50970	4646	3014599	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	309825	0	6106-9	3014599		
36234	3335	40766240	2015-08-08	2015-08-08 00:00:00	2015-08-08	5001	0	\N	0	0	\N	\N	0	221251	0	63513-6	40766240		
6255	191	4133840	1998-10-20	1998-10-20 00:00:00	1998-10-20	5001	0	\N	0	0	\N	\N	0	13108	0	127783003	4133840		
56614	5197	3019550	1962-06-05	1962-06-05 00:00:00	1962-06-05	5001	0	\N	0	0	\N	\N	0	345571	0	2951-2	3019550		
56742	5207	40766240	2001-09-26	2001-09-26 00:00:00	2001-09-26	5001	0	\N	0	0	\N	\N	0	346350	0	63513-6	40766240		
46489	4278	3006322	2014-10-11	2014-10-11 00:00:00	2014-10-11	5001	0	\N	0	0	\N	\N	0	283842	0	8331-1	3006322		
31465	2876	3011505	1992-08-06	1992-08-06 00:00:00	1992-08-06	5001	0	\N	0	0	\N	\N	0	191373	0	19926-5	3011505		
52989	1606	4024958	1986-11-12	1986-11-12 00:00:00	1986-11-12	5001	0	\N	0	0	\N	\N	0	107847	0	117015009	4024958		
32380	2942	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	196157	0	6095-4	3036780		
53813	4935	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	328036	0	6833-8	3023430		
11499	1099	3015076	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	72208	0	6248-9	3015076		
47891	1461	4024958	1968-09-17	1968-09-17 00:00:00	1968-09-17	5001	0	\N	0	0	\N	\N	0	97364	0	117015009	4024958		
63690	1956	4024958	1977-10-12	1977-10-12 00:00:00	1977-10-12	5001	0	\N	0	0	\N	\N	0	130179	0	117015009	4024958		
60945	1860	4024958	1991-07-14	1991-07-14 00:00:00	1991-07-14	5001	0	\N	0	0	\N	\N	0	124383	0	117015009	4024958		
74740	2291	4024958	1995-06-13	1995-06-13 00:00:00	1995-06-13	5001	0	\N	0	0	\N	\N	0	152427	0	117015009	4024958		
35121	3212	3006906	2018-07-21	2018-07-21 00:00:00	2018-07-21	5001	0	\N	0	0	\N	\N	0	213430	0	17861-6	3006906		
34539	3161	3006322	1953-04-06	1953-04-06 00:00:00	1953-04-06	5001	0	\N	0	0	\N	\N	0	210242	0	8331-1	3006322		
45896	4229	3006322	2005-12-30	2005-12-30 00:00:00	2005-12-30	5001	0	\N	0	0	\N	\N	0	280902	0	8331-1	3006322		
2662	263	46235214	1999-07-09	1999-07-09 00:00:00	1999-07-09	5001	0	\N	0	0	\N	\N	0	17469	0	76690-7	46235214		
57368	5267	3001247	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	350431	0	6085-5	3001247		
9381	297	4024958	1989-07-20	1989-07-20 00:00:00	1989-07-20	5001	0	\N	0	0	\N	\N	0	19779	0	117015009	4024958		
36135	3325	3051031	1994-03-06	1994-03-06 00:00:00	1994-03-06	5001	0	\N	0	0	\N	\N	0	220744	0	46240-8	3051031		
3930	124	4133840	2011-03-22	2011-03-22 00:00:00	2011-03-22	5001	0	\N	0	0	\N	\N	0	8272	0	127783003	4133840		
15196	1397	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	92805	0	6189-5	3006734		
149058	4570	4024958	1938-02-18	1938-02-18 00:00:00	1938-02-18	5001	0	\N	0	0	\N	\N	0	304508	0	117015009	4024958		
35630	3253	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	216383	0	6082-2	3000876		
57976	1766	4133840	2002-06-11	2002-06-11 00:00:00	2002-06-11	5001	0	\N	0	0	\N	\N	0	118166	0	127783003	4133840		
47087	4342	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	287954	0	7258-7	3001488		
56557	5194	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	345299	0	6095-4	3036780		
68398	2090	4024958	1973-10-08	1973-10-08 00:00:00	1973-10-08	5001	0	\N	0	0	\N	\N	0	139386	0	117015009	4024958		
102152	3137	4024958	1928-06-23	1928-06-23 00:00:00	1928-06-23	5001	0	\N	0	0	\N	\N	0	208851	0	117015009	4024958		
11239	1083	40769194	1966-10-26	1966-10-26 00:00:00	1966-10-26	5001	0	\N	0	0	\N	\N	0	71098	0	66534-9	40769194		
26192	2406	3006322	1978-08-26	1978-08-26 00:00:00	1978-08-26	5001	0	\N	0	0	\N	\N	0	159851	0	8331-1	3006322		
113334	3501	4052083	1949-11-24	1949-11-24 00:00:00	1949-11-24	5001	0	\N	0	0	\N	\N	0	232119	0	23426006	4052083		
125019	3859	4133840	1997-08-09	1997-08-09 00:00:00	1997-08-09	5001	0	\N	0	0	\N	\N	0	256257	0	127783003	4133840		
34366	3133	3006322	1987-06-10	1987-06-10 00:00:00	1987-06-10	5001	0	\N	0	0	\N	\N	0	208470	0	8331-1	3006322		
16041	1468	3051031	2016-08-27	2016-08-27 00:00:00	2016-08-27	5001	0	\N	0	0	\N	\N	0	97830	0	46240-8	3051031		
14258	1328	3011505	1998-08-13	1998-08-13 00:00:00	1998-08-13	5001	0	\N	0	0	\N	\N	0	88231	0	19926-5	3011505		
64685	1982	4024958	1948-10-18	1948-10-18 00:00:00	1948-10-18	5001	0	\N	0	0	\N	\N	0	132014	0	117015009	4024958		
25673	2352	3001488	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	156717	0	7258-7	3001488		
37061	3407	3006322	1984-01-31	1984-01-31 00:00:00	1984-01-31	5001	0	\N	0	0	\N	\N	0	225982	0	8331-1	3006322		
167541	5144	4052083	1961-06-17	1961-06-17 00:00:00	1961-06-17	5001	0	\N	0	0	\N	\N	0	341944	0	23426006	4052083		
31275	2858	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	189881	0	6844-5	3020655		
25317	787	4024958	2011-11-24	2011-11-24 00:00:00	2011-11-24	5001	0	\N	0	0	\N	\N	0	52363	0	117015009	4024958		
19542	610	4052083	1998-01-28	1998-01-28 00:00:00	1998-01-28	5001	0	\N	0	0	\N	\N	0	40567	0	23426006	4052083		
35371	3240	40766240	1993-08-09	1993-08-09 00:00:00	1993-08-09	5001	0	\N	0	0	\N	\N	0	215387	0	63513-6	40766240		
46730	4305	3006322	1984-08-31	1984-08-31 00:00:00	1984-08-31	5001	0	\N	0	0	\N	\N	0	285575	0	8331-1	3006322		
55027	5041	3006322	1993-05-11	1993-05-11 00:00:00	1993-05-11	5001	0	\N	0	0	\N	\N	0	334940	0	8331-1	3006322		
46888	4313	3027231	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	286276	0	6276-0	3027231		
57759	5300	3014576	1945-02-13	1945-02-13 00:00:00	1945-02-13	5001	0	\N	0	0	\N	\N	0	352654	0	2075-0	3014576		
19350	606	4024958	2008-04-12	2008-04-12 00:00:00	2008-04-12	5001	0	\N	0	0	\N	\N	0	40217	0	117015009	4024958		
21808	2006	3006322	1999-08-03	1999-08-03 00:00:00	1999-08-03	5001	0	\N	0	0	\N	\N	0	133643	0	8331-1	3006322		
21918	2016	3006322	2009-07-28	2009-07-28 00:00:00	2009-07-28	5001	0	\N	0	0	\N	\N	0	134145	0	8331-1	3006322		
33254	3002	3006322	1980-04-28	1980-04-28 00:00:00	1980-04-28	5001	0	\N	0	0	\N	\N	0	200384	0	8331-1	3006322		
39646	3680	3006734	1979-12-15	1979-12-15 00:00:00	1979-12-15	5001	0	\N	0	0	\N	\N	0	244725	0	6189-5	3006734		
13623	1282	3006322	1978-08-23	1978-08-23 00:00:00	1978-08-23	5001	0	\N	0	0	\N	\N	0	84720	0	8331-1	3006322		
44860	4145	3006322	2010-05-28	2010-05-28 00:00:00	2010-05-28	5001	0	\N	0	0	\N	\N	0	275544	0	8331-1	3006322		
17578	1599	3006322	2006-10-14	2006-10-14 00:00:00	2006-10-14	5001	0	\N	0	0	\N	\N	0	107331	0	8331-1	3006322		
56260	5165	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	343257	0	6085-5	3001247		
25237	2319	3049273	2017-10-14	2017-10-14 00:00:00	2017-10-14	5001	0	\N	0	0	\N	\N	0	154146	0	38265-5	3049273		
36605	3365	3006322	1978-07-23	1978-07-23 00:00:00	1978-07-23	5001	0	\N	0	0	\N	\N	0	223173	0	8331-1	3006322		
22335	2053	3006322	1962-09-04	1962-09-04 00:00:00	1962-09-04	5001	0	\N	0	0	\N	\N	0	136502	0	8331-1	3006322		
12800	408	4024958	1967-11-17	1967-11-17 00:00:00	1967-11-17	5001	0	\N	0	0	\N	\N	0	26940	0	117015009	4024958		
50904	4641	3011505	2018-07-19	2018-07-19 00:00:00	2018-07-19	5001	0	\N	0	0	\N	\N	0	309353	0	19926-5	3011505		
50971	4646	3021226	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	309825	0	6246-3	3021226		
36236	3335	40758406	2015-08-08	2015-08-08 00:00:00	2015-08-08	5001	0	\N	0	0	\N	\N	0	221251	0	55277-8	40758406		
6259	191	4024958	1924-12-24	1924-12-24 00:00:00	1924-12-24	5001	0	\N	0	0	\N	\N	0	13055	0	117015009	4024958		
56615	5197	3006906	1962-06-05	1962-06-05 00:00:00	1962-06-05	5001	0	\N	0	0	\N	\N	0	345571	0	17861-6	3006906		
9871	316	4052083	2007-11-23	2007-11-23 00:00:00	2007-11-23	5001	0	\N	0	0	\N	\N	0	20864	0	23426006	4052083		
46490	4278	3011505	2015-11-20	2015-11-20 00:00:00	2015-11-20	5001	0	\N	0	0	\N	\N	0	283868	0	19926-5	3011505		
31466	2876	3011505	2018-11-08	2018-11-08 00:00:00	2018-11-08	5001	0	\N	0	0	\N	\N	0	191375	0	19926-5	3011505		
53000	1606	4052083	2000-12-28	2000-12-28 00:00:00	2000-12-28	5001	0	\N	0	0	\N	\N	0	107859	0	23426006	4052083		
32381	2942	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	196157	0	7258-7	3001488		
53814	4935	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	328036	0	6082-2	3000876		
11500	1100	3006322	1997-10-12	1997-10-12 00:00:00	1997-10-12	5001	0	\N	0	0	\N	\N	0	72279	0	8331-1	3006322		
887	70	3006322	1978-01-19	1978-01-19 00:00:00	1978-01-19	5001	0	\N	0	0	\N	\N	0	4719	0	8331-1	3006322		
109663	3382	4024958	1969-10-03	1969-10-03 00:00:00	1969-10-03	5001	0	\N	0	0	\N	\N	0	224436	0	117015009	4024958		
60949	1860	4052083	1971-04-24	1971-04-24 00:00:00	1971-04-24	5001	0	\N	0	0	\N	\N	0	124350	0	23426006	4052083		
74748	2291	4052083	2001-03-14	2001-03-14 00:00:00	2001-03-14	5001	0	\N	0	0	\N	\N	0	152417	0	23426006	4052083		
35122	3212	21494966	2018-07-21	2018-07-21 00:00:00	2018-07-21	5001	0	\N	0	0	\N	\N	0	213430	0	80271-0	21494966		
34540	3161	3006322	1975-09-18	1975-09-18 00:00:00	1975-09-18	5001	0	\N	0	0	\N	\N	0	210243	0	8331-1	3006322		
45897	4229	3006322	1953-10-16	1953-10-16 00:00:00	1953-10-16	5001	0	\N	0	0	\N	\N	0	280900	0	8331-1	3006322		
2663	263	40766240	1999-07-09	1999-07-09 00:00:00	1999-07-09	5001	0	\N	0	0	\N	\N	0	17469	0	63513-6	40766240		
57369	5267	3006734	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	350431	0	6189-5	3006734		
55969	5137	3006322	1999-11-22	1999-11-22 00:00:00	1999-11-22	5001	0	\N	0	0	\N	\N	0	341440	0	8331-1	3006322		
36136	3325	40766240	1994-03-06	1994-03-06 00:00:00	1994-03-06	5001	0	\N	0	0	\N	\N	0	220744	0	63513-6	40766240		
15248	479	4052083	1944-02-29	1944-02-29 00:00:00	1944-02-29	5001	0	\N	0	0	\N	\N	0	31904	0	23426006	4052083		
15197	1397	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	92805	0	7258-7	3001488		
57656	1761	4024958	2001-01-01	2001-01-01 00:00:00	2001-01-01	5001	0	\N	0	0	\N	\N	0	117709	0	117015009	4024958		
35631	3253	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	216383	0	6085-5	3001247		
57980	1766	4133840	2012-10-30	2012-10-30 00:00:00	2012-10-30	5001	0	\N	0	0	\N	\N	0	118145	0	127783003	4133840		
47088	4342	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	287954	0	6833-8	3023430		
56558	5194	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	345299	0	6248-9	3015076		
68407	2090	4052083	1969-11-14	1969-11-14 00:00:00	1969-11-14	5001	0	\N	0	0	\N	\N	0	139352	0	23426006	4052083		
136682	4214	4024958	1981-04-27	1981-04-27 00:00:00	1981-04-27	5001	0	\N	0	0	\N	\N	0	279758	0	117015009	4024958		
11240	1083	40769179	1966-10-26	1966-10-26 00:00:00	1966-10-26	5001	0	\N	0	0	\N	\N	0	71098	0	66519-0	40769179		
26193	2406	3006322	1975-05-30	1975-05-30 00:00:00	1975-05-30	5001	0	\N	0	0	\N	\N	0	159841	0	8331-1	3006322		
113601	3508	4052083	1996-03-21	1996-03-21 00:00:00	1996-03-21	5001	0	\N	0	0	\N	\N	0	232625	0	23426006	4052083		
125020	3859	4133840	1995-07-29	1995-07-29 00:00:00	1995-07-29	5001	0	\N	0	0	\N	\N	0	256256	0	127783003	4133840		
34367	3133	40766240	2004-08-08	2004-08-08 00:00:00	2004-08-08	5001	0	\N	0	0	\N	\N	0	208457	0	63513-6	40766240		
16043	1468	46235214	2016-08-27	2016-08-27 00:00:00	2016-08-27	5001	0	\N	0	0	\N	\N	0	97830	0	76690-7	46235214		
14259	1328	3011505	1980-12-04	1980-12-04 00:00:00	1980-12-04	5001	0	\N	0	0	\N	\N	0	88227	0	19926-5	3011505		
64687	1982	4024958	1943-06-02	1943-06-02 00:00:00	1943-06-02	5001	0	\N	0	0	\N	\N	0	132032	0	117015009	4024958		
25674	2352	3006451	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	156717	0	6273-7	3006451		
37062	3408	3006322	1976-10-29	1976-10-29 00:00:00	1976-10-29	5001	0	\N	0	0	\N	\N	0	226035	0	8331-1	3006322		
5371	512	46235214	1960-05-18	1960-05-18 00:00:00	1960-05-18	5001	0	\N	0	0	\N	\N	0	34162	0	76690-7	46235214		
31276	2858	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	189881	0	6158-0	3019406		
25321	787	4024958	1978-09-26	1978-09-26 00:00:00	1978-09-26	5001	0	\N	0	0	\N	\N	0	52361	0	117015009	4024958		
19571	610	4024958	1996-12-26	1996-12-26 00:00:00	1996-12-26	5001	0	\N	0	0	\N	\N	0	40554	0	117015009	4024958		
35372	3240	46235214	1993-08-09	1993-08-09 00:00:00	1993-08-09	5001	0	\N	0	0	\N	\N	0	215387	0	76690-7	46235214		
46731	4305	3049273	2019-06-12	2019-06-12 00:00:00	2019-06-12	5001	0	\N	0	0	\N	\N	0	285537	0	38265-5	3049273		
55028	5041	3006322	1994-03-19	1994-03-19 00:00:00	1994-03-19	5001	0	\N	0	0	\N	\N	0	334941	0	8331-1	3006322		
46889	4313	3019406	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	286276	0	6158-0	3019406		
57760	5300	3035995	1945-02-13	1945-02-13 00:00:00	1945-02-13	5001	0	\N	0	0	\N	\N	0	352654	0	6768-6	3035995		
19352	606	4024958	1975-12-11	1975-12-11 00:00:00	1975-12-11	5001	0	\N	0	0	\N	\N	0	40200	0	117015009	4024958		
21809	2006	3006322	1948-02-08	1948-02-08 00:00:00	1948-02-08	5001	0	\N	0	0	\N	\N	0	133591	0	8331-1	3006322		
21919	2017	40758406	1971-01-25	1971-01-25 00:00:00	1971-01-25	5001	0	\N	0	0	\N	\N	0	134177	0	55277-8	40758406		
33255	3002	3006322	2004-02-01	2004-02-01 00:00:00	2004-02-01	5001	0	\N	0	0	\N	\N	0	200347	0	8331-1	3006322		
39647	3680	3027231	1979-12-15	1979-12-15 00:00:00	1979-12-15	5001	0	\N	0	0	\N	\N	0	244725	0	6276-0	3027231		
13624	1282	3006322	2001-05-10	2001-05-10 00:00:00	2001-05-10	5001	0	\N	0	0	\N	\N	0	84767	0	8331-1	3006322		
44866	4149	3006322	1988-02-13	1988-02-13 00:00:00	1988-02-13	5001	0	\N	0	0	\N	\N	0	275706	0	8331-1	3006322		
17579	1599	3006322	2008-01-21	2008-01-21 00:00:00	2008-01-21	5001	0	\N	0	0	\N	\N	0	107299	0	8331-1	3006322		
56261	5166	3006322	1963-12-23	1963-12-23 00:00:00	1963-12-23	5001	0	\N	0	0	\N	\N	0	343423	0	8331-1	3006322		
25238	2319	3008598	2015-01-29	2015-01-29 00:00:00	2015-01-29	5001	0	\N	0	0	\N	\N	0	154211	0	3024-7	3008598		
36606	3365	3006322	2017-03-09	2017-03-09 00:00:00	2017-03-09	5001	0	\N	0	0	\N	\N	0	223201	0	8331-1	3006322		
22336	2053	40766240	1963-11-27	1963-11-27 00:00:00	1963-11-27	5001	0	\N	0	0	\N	\N	0	136529	0	63513-6	40766240		
12803	408	4024958	2010-06-29	2010-06-29 00:00:00	2010-06-29	5001	0	\N	0	0	\N	\N	0	26968	0	117015009	4024958		
50905	4641	3011505	1998-09-03	1998-09-03 00:00:00	1998-09-03	5001	0	\N	0	0	\N	\N	0	309349	0	19926-5	3011505		
50972	4646	3006451	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	309825	0	6273-7	3006451		
36237	3335	46235214	2015-08-08	2015-08-08 00:00:00	2015-08-08	5001	0	\N	0	0	\N	\N	0	221251	0	76690-7	46235214		
6261	191	4133840	1999-10-26	1999-10-26 00:00:00	1999-10-26	5001	0	\N	0	0	\N	\N	0	13129	0	127783003	4133840		
56616	5197	3009542	1962-06-05	1962-06-05 00:00:00	1962-06-05	5001	0	\N	0	0	\N	\N	0	345571	0	20570-8	3009542		
9875	316	4052083	2016-03-26	2016-03-26 00:00:00	2016-03-26	5001	0	\N	0	0	\N	\N	0	20866	0	23426006	4052083		
46491	4279	3051031	1951-05-07	1951-05-07 00:00:00	1951-05-07	5001	0	\N	0	0	\N	\N	0	283959	0	46240-8	3051031		
31467	2876	3006322	2012-08-24	2012-08-24 00:00:00	2012-08-24	5001	0	\N	0	0	\N	\N	0	191360	0	8331-1	3006322		
31481	2878	3006322	2003-12-10	2003-12-10 00:00:00	2003-12-10	5001	0	\N	0	0	\N	\N	0	191463	0	8331-1	3006322		
32382	2942	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	196157	0	6189-5	3006734		
53815	4935	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	328036	0	6075-6	3005136		
11501	1101	3011505	2000-06-25	2000-06-25 00:00:00	2000-06-25	5001	0	\N	0	0	\N	\N	0	72323	0	19926-5	3011505		
888	70	3006322	1993-04-29	1993-04-29 00:00:00	1993-04-29	5001	0	\N	0	0	\N	\N	0	4763	0	8331-1	3006322		
109682	3383	4024958	2016-03-05	2016-03-05 00:00:00	2016-03-05	5001	0	\N	0	0	\N	\N	0	224524	0	117015009	4024958		
121042	3736	4024958	1954-09-20	1954-09-20 00:00:00	1954-09-20	5001	0	\N	0	0	\N	\N	0	248271	0	117015009	4024958		
74750	2292	4052083	2009-01-16	2009-01-16 00:00:00	2009-01-16	5001	0	\N	0	0	\N	\N	0	152569	0	23426006	4052083		
35123	3212	3014576	2018-07-21	2018-07-21 00:00:00	2018-07-21	5001	0	\N	0	0	\N	\N	0	213430	0	2075-0	3014576		
34541	3161	3006322	2007-07-12	2007-07-12 00:00:00	2007-07-12	5001	0	\N	0	0	\N	\N	0	210244	0	8331-1	3006322		
45898	4229	3006322	1970-11-11	1970-11-11 00:00:00	1970-11-11	5001	0	\N	0	0	\N	\N	0	280964	0	8331-1	3006322		
2666	263	3006322	2015-10-02	2015-10-02 00:00:00	2015-10-02	5001	0	\N	0	0	\N	\N	0	17479	0	8331-1	3006322		
57370	5267	3006322	2013-12-30	2013-12-30 00:00:00	2013-12-30	5001	0	\N	0	0	\N	\N	0	350400	0	8331-1	3006322		
55970	5137	3006322	1995-02-06	1995-02-06 00:00:00	1995-02-06	5001	0	\N	0	0	\N	\N	0	341430	0	8331-1	3006322		
36138	3325	3006322	1974-05-02	1974-05-02 00:00:00	1974-05-02	5001	0	\N	0	0	\N	\N	0	220692	0	8331-1	3006322		
15265	479	4052083	1984-08-09	1984-08-09 00:00:00	1984-08-09	5001	0	\N	0	0	\N	\N	0	31936	0	23426006	4052083		
15198	1397	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	92805	0	6106-9	3014599		
57658	1761	4052083	1995-09-30	1995-09-30 00:00:00	1995-09-30	5001	0	\N	0	0	\N	\N	0	117757	0	23426006	4052083		
35632	3253	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	216383	0	6206-7	3012494		
57983	1766	4133840	2000-06-06	2000-06-06 00:00:00	2000-06-06	5001	0	\N	0	0	\N	\N	0	118183	0	127783003	4133840		
47089	4342	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	287954	0	6844-5	3020655		
56559	5194	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	345299	0	6106-9	3014599		
68417	2090	4052083	1999-05-05	1999-05-05 00:00:00	1999-05-05	5001	0	\N	0	0	\N	\N	0	139377	0	23426006	4052083		
136695	4214	4052083	1981-12-13	1981-12-13 00:00:00	1981-12-13	5001	0	\N	0	0	\N	\N	0	279773	0	23426006	4052083		
11241	1083	40769189	1966-10-26	1966-10-26 00:00:00	1966-10-26	5001	0	\N	0	0	\N	\N	0	71098	0	66529-9	40769189		
26194	2406	3006322	1982-03-21	1982-03-21 00:00:00	1982-03-21	5001	0	\N	0	0	\N	\N	0	159843	0	8331-1	3006322		
113616	3509	4024958	1988-06-18	1988-06-18 00:00:00	1988-06-18	5001	0	\N	0	0	\N	\N	0	232705	0	117015009	4024958		
125023	3859	4024958	1931-06-03	1931-06-03 00:00:00	1931-06-03	5001	0	\N	0	0	\N	\N	0	256157	0	117015009	4024958		
34368	3133	40758406	2004-08-08	2004-08-08 00:00:00	2004-08-08	5001	0	\N	0	0	\N	\N	0	208457	0	55277-8	40758406		
16044	1468	40758406	2016-07-28	2016-07-28 00:00:00	2016-07-28	5001	0	\N	0	0	\N	\N	0	97798	0	55277-8	40758406		
14260	1328	3011505	1995-07-27	1995-07-27 00:00:00	1995-07-27	5001	0	\N	0	0	\N	\N	0	88206	0	19926-5	3011505		
64699	1982	4024958	1954-01-14	1954-01-14 00:00:00	1954-01-14	5001	0	\N	0	0	\N	\N	0	131950	0	117015009	4024958		
25675	2352	3021226	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	156717	0	6246-3	3021226		
37063	3408	3006322	2011-06-06	2011-06-06 00:00:00	2011-06-06	5001	0	\N	0	0	\N	\N	0	226008	0	8331-1	3006322		
5372	512	40766240	1960-05-18	1960-05-18 00:00:00	1960-05-18	5001	0	\N	0	0	\N	\N	0	34162	0	63513-6	40766240		
31277	2858	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	189881	0	7258-7	3001488		
25322	787	4052083	1978-02-17	1978-02-17 00:00:00	1978-02-17	5001	0	\N	0	0	\N	\N	0	52360	0	23426006	4052083		
111654	3446	4052083	1970-10-21	1970-10-21 00:00:00	1970-10-21	5001	0	\N	0	0	\N	\N	0	228786	0	23426006	4052083		
35375	3240	3051031	1993-08-09	1993-08-09 00:00:00	1993-08-09	5001	0	\N	0	0	\N	\N	0	215387	0	46240-8	3051031		
46732	4305	3006322	1975-02-08	1975-02-08 00:00:00	1975-02-08	5001	0	\N	0	0	\N	\N	0	285560	0	8331-1	3006322		
55029	5041	3006322	1981-08-22	1981-08-22 00:00:00	1981-08-22	5001	0	\N	0	0	\N	\N	0	334949	0	8331-1	3006322		
46890	4313	3020655	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	286276	0	6844-5	3020655		
57761	5300	3026361	1945-02-13	1945-02-13 00:00:00	1945-02-13	5001	0	\N	0	0	\N	\N	0	352654	0	26453-1	3026361		
19373	607	4024958	1984-09-05	1984-09-05 00:00:00	1984-09-05	5001	0	\N	0	0	\N	\N	0	40269	0	117015009	4024958		
21810	2006	3006322	2010-01-19	2010-01-19 00:00:00	2010-01-19	5001	0	\N	0	0	\N	\N	0	133570	0	8331-1	3006322		
21920	2017	3051031	1971-01-25	1971-01-25 00:00:00	1971-01-25	5001	0	\N	0	0	\N	\N	0	134177	0	46240-8	3051031		
33317	3010	3006322	1979-02-04	1979-02-04 00:00:00	1979-02-04	5001	0	\N	0	0	\N	\N	0	200781	0	8331-1	3006322		
39648	3680	3021226	1979-12-15	1979-12-15 00:00:00	1979-12-15	5001	0	\N	0	0	\N	\N	0	244725	0	6246-3	3021226		
13625	1282	3006451	1977-08-12	1977-08-12 00:00:00	1977-08-12	5001	0	\N	0	0	\N	\N	0	84719	0	6273-7	3006451		
44867	4149	3006322	2005-06-25	2005-06-25 00:00:00	2005-06-25	5001	0	\N	0	0	\N	\N	0	275713	0	8331-1	3006322		
17580	1599	3006322	2013-10-07	2013-10-07 00:00:00	2013-10-07	5001	0	\N	0	0	\N	\N	0	107351	0	8331-1	3006322		
56262	5166	3006322	2011-04-23	2011-04-23 00:00:00	2011-04-23	5001	0	\N	0	0	\N	\N	0	343465	0	8331-1	3006322		
25239	2319	3009201	2015-01-29	2015-01-29 00:00:00	2015-01-29	5001	0	\N	0	0	\N	\N	0	154211	0	3016-3	3009201		
36610	3367	3006322	2014-07-10	2014-07-10 00:00:00	2014-07-10	5001	0	\N	0	0	\N	\N	0	223311	0	8331-1	3006322		
22338	2053	40758406	1963-11-27	1963-11-27 00:00:00	1963-11-27	5001	0	\N	0	0	\N	\N	0	136529	0	55277-8	40758406		
12804	408	4052083	2011-06-03	2011-06-03 00:00:00	2011-06-03	5001	0	\N	0	0	\N	\N	0	26992	0	23426006	4052083		
50906	4641	3011505	2009-07-23	2009-07-23 00:00:00	2009-07-23	5001	0	\N	0	0	\N	\N	0	309318	0	19926-5	3011505		
50973	4646	3012494	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	309825	0	6206-7	3012494		
36239	3335	3051031	2015-08-08	2015-08-08 00:00:00	2015-08-08	5001	0	\N	0	0	\N	\N	0	221251	0	46240-8	3051031		
6264	191	4133840	1996-10-08	1996-10-08 00:00:00	1996-10-08	5001	0	\N	0	0	\N	\N	0	13053	0	127783003	4133840		
56617	5197	3024561	1962-06-05	1962-06-05 00:00:00	1962-06-05	5001	0	\N	0	0	\N	\N	0	345571	0	1751-7	3024561		
9877	316	4052083	1937-10-24	1937-10-24 00:00:00	1937-10-24	5001	0	\N	0	0	\N	\N	0	20861	0	23426006	4052083		
46493	4279	40766240	1951-05-07	1951-05-07 00:00:00	1951-05-07	5001	0	\N	0	0	\N	\N	0	283959	0	63513-6	40766240		
31468	2876	3006322	2008-06-04	2008-06-04 00:00:00	2008-06-04	5001	0	\N	0	0	\N	\N	0	191330	0	8331-1	3006322		
31482	2878	3006322	1986-08-08	1986-08-08 00:00:00	1986-08-08	5001	0	\N	0	0	\N	\N	0	191452	0	8331-1	3006322		
32383	2942	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	196219	0	6276-0	3027231		
53816	4935	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	328036	0	6248-9	3015076		
11502	1101	3006322	1976-03-12	1976-03-12 00:00:00	1976-03-12	5001	0	\N	0	0	\N	\N	0	72340	0	8331-1	3006322		
889	70	3006322	2019-04-24	2019-04-24 00:00:00	2019-04-24	5001	0	\N	0	0	\N	\N	0	4766	0	8331-1	3006322		
109683	3383	4024958	1988-11-04	1988-11-04 00:00:00	1988-11-04	5001	0	\N	0	0	\N	\N	0	224477	0	117015009	4024958		
121043	3736	4052083	1962-06-07	1962-06-07 00:00:00	1962-06-07	5001	0	\N	0	0	\N	\N	0	248311	0	23426006	4052083		
74753	2292	4133840	2015-02-13	2015-02-13 00:00:00	2015-02-13	5001	0	\N	0	0	\N	\N	0	152580	0	127783003	4133840		
35124	3212	3006923	2018-07-21	2018-07-21 00:00:00	2018-07-21	5001	0	\N	0	0	\N	\N	0	213430	0	1742-6	3006923		
45825	4224	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	280540	0	6246-3	3021226		
45899	4229	3006322	1954-11-24	1954-11-24 00:00:00	1954-11-24	5001	0	\N	0	0	\N	\N	0	280959	0	8331-1	3006322		
2667	263	3006322	2002-12-16	2002-12-16 00:00:00	2002-12-16	5001	0	\N	0	0	\N	\N	0	17470	0	8331-1	3006322		
57371	5267	3012494	1999-06-26	1999-06-26 00:00:00	1999-06-26	5001	0	\N	0	0	\N	\N	0	350412	0	6206-7	3012494		
55971	5137	3006322	1968-09-15	1968-09-15 00:00:00	1968-09-15	5001	0	\N	0	0	\N	\N	0	341359	0	8331-1	3006322		
36139	3325	3006322	2007-10-29	2007-10-29 00:00:00	2007-10-29	5001	0	\N	0	0	\N	\N	0	220715	0	8331-1	3006322		
15267	479	4052083	1949-02-17	1949-02-17 00:00:00	1949-02-17	5001	0	\N	0	0	\N	\N	0	31875	0	23426006	4052083		
15199	1397	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	92805	0	6276-0	3027231		
57664	1761	4024958	1958-06-07	1958-06-07 00:00:00	1958-06-07	5001	0	\N	0	0	\N	\N	0	117768	0	117015009	4024958		
35633	3253	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	216383	0	6189-5	3006734		
57984	1766	4133840	1994-05-24	1994-05-24 00:00:00	1994-05-24	5001	0	\N	0	0	\N	\N	0	118159	0	127783003	4133840		
47090	4342	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	287954	0	6273-7	3006451		
56560	5194	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	345299	0	6075-6	3005136		
68418	2090	4024958	2008-07-02	2008-07-02 00:00:00	2008-07-02	5001	0	\N	0	0	\N	\N	0	139389	0	117015009	4024958		
136697	4214	4052083	2005-03-09	2005-03-09 00:00:00	2005-03-09	5001	0	\N	0	0	\N	\N	0	279795	0	23426006	4052083		
11242	1083	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	71099	0	6106-9	3014599		
26198	2409	3006322	1982-02-16	1982-02-16 00:00:00	1982-02-16	5001	0	\N	0	0	\N	\N	0	159945	0	8331-1	3006322		
113620	3509	4024958	1948-02-01	1948-02-01 00:00:00	1948-02-01	5001	0	\N	0	0	\N	\N	0	232702	0	117015009	4024958		
125026	3859	4024958	1965-03-18	1965-03-18 00:00:00	1965-03-18	5001	0	\N	0	0	\N	\N	0	256207	0	117015009	4024958		
45647	4212	3006322	1993-10-04	1993-10-04 00:00:00	1993-10-04	5001	0	\N	0	0	\N	\N	0	279648	0	8331-1	3006322		
16045	1468	3051031	2016-07-28	2016-07-28 00:00:00	2016-07-28	5001	0	\N	0	0	\N	\N	0	97798	0	46240-8	3051031		
14261	1328	3006322	2010-04-08	2010-04-08 00:00:00	2010-04-08	5001	0	\N	0	0	\N	\N	0	88224	0	8331-1	3006322		
132867	4090	4024958	1986-10-12	1986-10-12 00:00:00	1986-10-12	5001	0	\N	0	0	\N	\N	0	271851	0	117015009	4024958		
25676	2352	3012494	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	156717	0	6206-7	3012494		
37064	3408	3006322	1992-05-20	1992-05-20 00:00:00	1992-05-20	5001	0	\N	0	0	\N	\N	0	226037	0	8331-1	3006322		
5373	512	40758406	1960-05-18	1960-05-18 00:00:00	1960-05-18	5001	0	\N	0	0	\N	\N	0	34162	0	55277-8	40758406		
31278	2858	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	189881	0	6246-3	3021226		
25324	787	4024958	1978-05-19	1978-05-19 00:00:00	1978-05-19	5001	0	\N	0	0	\N	\N	0	52346	0	117015009	4024958		
111666	3446	4024958	1982-11-22	1982-11-22 00:00:00	1982-11-22	5001	0	\N	0	0	\N	\N	0	228787	0	117015009	4024958		
35376	3240	3006322	2005-05-11	2005-05-11 00:00:00	2005-05-11	5001	0	\N	0	0	\N	\N	0	215353	0	8331-1	3006322		
46733	4305	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	285616	0	6833-8	3023430		
89765	2776	4024958	1989-04-01	1989-04-01 00:00:00	1989-04-01	5001	0	\N	0	0	\N	\N	0	183854	0	117015009	4024958		
46891	4313	3023430	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	286276	0	6833-8	3023430		
57762	5300	3027970	1945-02-13	1945-02-13 00:00:00	1945-02-13	5001	0	\N	0	0	\N	\N	0	352654	0	10834-0	3027970		
19374	607	4052083	2009-09-09	2009-09-09 00:00:00	2009-09-09	5001	0	\N	0	0	\N	\N	0	40280	0	23426006	4052083		
21811	2007	3006322	2002-11-22	2002-11-22 00:00:00	2002-11-22	5001	0	\N	0	0	\N	\N	0	133681	0	8331-1	3006322		
21921	2017	40766240	1971-01-25	1971-01-25 00:00:00	1971-01-25	5001	0	\N	0	0	\N	\N	0	134177	0	63513-6	40766240		
33318	3010	3006322	1984-07-24	1984-07-24 00:00:00	1984-07-24	5001	0	\N	0	0	\N	\N	0	200771	0	8331-1	3006322		
39649	3680	3023430	1979-12-15	1979-12-15 00:00:00	1979-12-15	5001	0	\N	0	0	\N	\N	0	244725	0	6833-8	3023430		
13626	1282	3036780	1977-08-12	1977-08-12 00:00:00	1977-08-12	5001	0	\N	0	0	\N	\N	0	84719	0	6095-4	3036780		
44868	4149	3006322	1973-11-16	1973-11-16 00:00:00	1973-11-16	5001	0	\N	0	0	\N	\N	0	275740	0	8331-1	3006322		
17581	1600	3049273	2013-09-01	2013-09-01 00:00:00	2013-09-01	5001	0	\N	0	0	\N	\N	0	107367	0	38265-5	3049273		
56263	5166	3006322	1997-09-07	1997-09-07 00:00:00	1997-09-07	5001	0	\N	0	0	\N	\N	0	343442	0	8331-1	3006322		
36517	3355	3006322	1997-10-07	1997-10-07 00:00:00	1997-10-07	5001	0	\N	0	0	\N	\N	0	222495	0	8331-1	3006322		
36611	3367	3006322	2015-10-13	2015-10-13 00:00:00	2015-10-13	5001	0	\N	0	0	\N	\N	0	223342	0	8331-1	3006322		
22339	2053	3051031	1963-11-27	1963-11-27 00:00:00	1963-11-27	5001	0	\N	0	0	\N	\N	0	136529	0	46240-8	3051031		
12815	408	4024958	1991-08-24	1991-08-24 00:00:00	1991-08-24	5001	0	\N	0	0	\N	\N	0	26988	0	117015009	4024958		
50907	4641	3006322	1967-10-14	1967-10-14 00:00:00	1967-10-14	5001	0	\N	0	0	\N	\N	0	309285	0	8331-1	3006322		
50974	4646	3015076	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	309825	0	6248-9	3015076		
36240	3335	46235214	2014-07-14	2014-07-14 00:00:00	2014-07-14	5001	0	\N	0	0	\N	\N	0	221279	0	76690-7	46235214		
6265	191	4133840	1997-10-14	1997-10-14 00:00:00	1997-10-14	5001	0	\N	0	0	\N	\N	0	13026	0	127783003	4133840		
56618	5197	3028833	1962-06-05	1962-06-05 00:00:00	1962-06-05	5001	0	\N	0	0	\N	\N	0	345571	0	42719-5	3028833		
9878	316	4024958	1936-07-19	1936-07-19 00:00:00	1936-07-19	5001	0	\N	0	0	\N	\N	0	20959	0	117015009	4024958		
46495	4279	3049273	2018-03-16	2018-03-16 00:00:00	2018-03-16	5001	0	\N	0	0	\N	\N	0	284093	0	38265-5	3049273		
31469	2876	3011505	2015-10-22	2015-10-22 00:00:00	2015-10-22	5001	0	\N	0	0	\N	\N	0	191356	0	19926-5	3011505		
31483	2878	3006322	2016-11-10	2016-11-10 00:00:00	2016-11-10	5001	0	\N	0	0	\N	\N	0	191464	0	8331-1	3006322		
32384	2942	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	196219	0	6246-3	3021226		
53817	4935	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	328036	0	6246-3	3021226		
11503	1101	3011505	2016-08-28	2016-08-28 00:00:00	2016-08-28	5001	0	\N	0	0	\N	\N	0	72315	0	19926-5	3011505		
890	70	3006322	1968-11-28	1968-11-28 00:00:00	1968-11-28	5001	0	\N	0	0	\N	\N	0	4718	0	8331-1	3006322		
109693	3383	4024958	2005-11-19	2005-11-19 00:00:00	2005-11-19	5001	0	\N	0	0	\N	\N	0	224483	0	117015009	4024958		
121046	3736	4052083	1964-09-13	1964-09-13 00:00:00	1964-09-13	5001	0	\N	0	0	\N	\N	0	248313	0	23426006	4052083		
74755	2292	4133840	2016-03-11	2016-03-11 00:00:00	2016-03-11	5001	0	\N	0	0	\N	\N	0	152581	0	127783003	4133840		
35125	3212	3024731	2018-07-21	2018-07-21 00:00:00	2018-07-21	5001	0	\N	0	0	\N	\N	0	213430	0	30428-7	3024731		
45826	4224	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	280540	0	6106-9	3014599		
45900	4229	3006322	1983-03-21	1983-03-21 00:00:00	1983-03-21	5001	0	\N	0	0	\N	\N	0	280956	0	8331-1	3006322		
2669	263	40758406	1999-08-08	1999-08-08 00:00:00	1999-08-08	5001	0	\N	0	0	\N	\N	0	17446	0	55277-8	40758406		
57372	5267	3020655	1999-06-26	1999-06-26 00:00:00	1999-06-26	5001	0	\N	0	0	\N	\N	0	350412	0	6844-5	3020655		
55972	5138	3006322	2017-11-30	2017-11-30 00:00:00	2017-11-30	5001	0	\N	0	0	\N	\N	0	341459	0	8331-1	3006322		
36140	3325	3006322	1964-06-12	1964-06-12 00:00:00	1964-06-12	5001	0	\N	0	0	\N	\N	0	220742	0	8331-1	3006322		
15273	479	4052083	2018-09-21	2018-09-21 00:00:00	2018-09-21	5001	0	\N	0	0	\N	\N	0	31908	0	23426006	4052083		
150455	4613	4052083	2018-05-21	2018-05-21 00:00:00	2018-05-21	5001	0	\N	0	0	\N	\N	0	307317	0	23426006	4052083		
57679	1761	4024958	1963-11-27	1963-11-27 00:00:00	1963-11-27	5001	0	\N	0	0	\N	\N	0	117753	0	117015009	4024958		
35634	3253	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	216383	0	6075-6	3005136		
57985	1766	4133840	2003-06-17	2003-06-17 00:00:00	2003-06-17	5001	0	\N	0	0	\N	\N	0	118162	0	127783003	4133840		
47091	4342	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	287954	0	6246-3	3021226		
56561	5194	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	345299	0	6085-5	3001247		
68423	2090	4052083	2011-06-10	2011-06-10 00:00:00	2011-06-10	5001	0	\N	0	0	\N	\N	0	139390	0	23426006	4052083		
136703	4214	4024958	1975-09-15	1975-09-15 00:00:00	1975-09-15	5001	0	\N	0	0	\N	\N	0	279772	0	117015009	4024958		
11243	1083	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	71099	0	6273-7	3006451		
26199	2409	3006322	1992-12-30	1992-12-30 00:00:00	1992-12-30	5001	0	\N	0	0	\N	\N	0	159913	0	8331-1	3006322		
113626	3509	4024958	1946-10-25	1946-10-25 00:00:00	1946-10-25	5001	0	\N	0	0	\N	\N	0	232736	0	117015009	4024958		
125029	3859	4133840	1991-02-23	1991-02-23 00:00:00	1991-02-23	5001	0	\N	0	0	\N	\N	0	256152	0	127783003	4133840		
45648	4212	3006322	1977-01-23	1977-01-23 00:00:00	1977-01-23	5001	0	\N	0	0	\N	\N	0	279680	0	8331-1	3006322		
16047	1468	46235214	2016-07-28	2016-07-28 00:00:00	2016-07-28	5001	0	\N	0	0	\N	\N	0	97798	0	76690-7	46235214		
14262	1328	3011505	1997-08-07	1997-08-07 00:00:00	1997-08-07	5001	0	\N	0	0	\N	\N	0	88194	0	19926-5	3011505		
132870	4090	4052083	1988-06-21	1988-06-21 00:00:00	1988-06-21	5001	0	\N	0	0	\N	\N	0	271845	0	23426006	4052083		
25677	2352	3014599	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	156717	0	6106-9	3014599		
37065	3408	3006322	1992-08-30	1992-08-30 00:00:00	1992-08-30	5001	0	\N	0	0	\N	\N	0	226033	0	8331-1	3006322		
5374	512	3051031	1960-05-18	1960-05-18 00:00:00	1960-05-18	5001	0	\N	0	0	\N	\N	0	34162	0	46240-8	3051031		
31279	2858	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	189881	0	6248-9	3015076		
25352	789	4052083	1989-05-07	1989-05-07 00:00:00	1989-05-07	5001	0	\N	0	0	\N	\N	0	52509	0	23426006	4052083		
111668	3446	4024958	1990-07-14	1990-07-14 00:00:00	1990-07-14	5001	0	\N	0	0	\N	\N	0	228811	0	117015009	4024958		
35377	3240	46235214	1993-04-11	1993-04-11 00:00:00	1993-04-11	5001	0	\N	0	0	\N	\N	0	215337	0	76690-7	46235214		
46734	4305	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	285616	0	6075-6	3005136		
89767	2776	4024958	2001-06-23	2001-06-23 00:00:00	2001-06-23	5001	0	\N	0	0	\N	\N	0	183775	0	117015009	4024958		
58176	5337	3021226	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	355418	0	6246-3	3021226		
57763	5300	3009542	1945-02-13	1945-02-13 00:00:00	1945-02-13	5001	0	\N	0	0	\N	\N	0	352654	0	20570-8	3009542		
19384	607	4024958	1984-10-20	1984-10-20 00:00:00	1984-10-20	5001	0	\N	0	0	\N	\N	0	40327	0	117015009	4024958		
21812	2007	3006322	1994-05-27	1994-05-27 00:00:00	1994-05-27	5001	0	\N	0	0	\N	\N	0	133680	0	8331-1	3006322		
21923	2017	46235214	1971-01-25	1971-01-25 00:00:00	1971-01-25	5001	0	\N	0	0	\N	\N	0	134177	0	76690-7	46235214		
33319	3010	3006322	1975-11-08	1975-11-08 00:00:00	1975-11-08	5001	0	\N	0	0	\N	\N	0	200765	0	8331-1	3006322		
39650	3680	3019406	1979-12-15	1979-12-15 00:00:00	1979-12-15	5001	0	\N	0	0	\N	\N	0	244725	0	6158-0	3019406		
13627	1282	3006734	1977-08-12	1977-08-12 00:00:00	1977-08-12	5001	0	\N	0	0	\N	\N	0	84719	0	6189-5	3006734		
44869	4149	3006322	2012-09-21	2012-09-21 00:00:00	2012-09-21	5001	0	\N	0	0	\N	\N	0	275707	0	8331-1	3006322		
17582	1600	3051031	1947-05-25	1947-05-25 00:00:00	1947-05-25	5001	0	\N	0	0	\N	\N	0	107441	0	46240-8	3051031		
56264	5166	3006322	2004-02-17	2004-02-17 00:00:00	2004-02-17	5001	0	\N	0	0	\N	\N	0	343464	0	8331-1	3006322		
36518	3355	3006322	1978-06-24	1978-06-24 00:00:00	1978-06-24	5001	0	\N	0	0	\N	\N	0	222483	0	8331-1	3006322		
36612	3367	3006322	1977-10-11	1977-10-11 00:00:00	1977-10-11	5001	0	\N	0	0	\N	\N	0	223307	0	8331-1	3006322		
22340	2053	46235214	1963-11-27	1963-11-27 00:00:00	1963-11-27	5001	0	\N	0	0	\N	\N	0	136529	0	76690-7	46235214		
12819	408	4052083	1994-06-16	1994-06-16 00:00:00	1994-06-16	5001	0	\N	0	0	\N	\N	0	26928	0	23426006	4052083		
50908	4641	3011505	2007-07-19	2007-07-19 00:00:00	2007-07-19	5001	0	\N	0	0	\N	\N	0	309344	0	19926-5	3011505		
50975	4646	3005136	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	309825	0	6075-6	3005136		
36241	3335	40766240	2014-07-14	2014-07-14 00:00:00	2014-07-14	5001	0	\N	0	0	\N	\N	0	221279	0	63513-6	40766240		
17543	550	4052083	1994-09-24	1994-09-24 00:00:00	1994-09-24	5001	0	\N	0	0	\N	\N	0	36492	0	23426006	4052083		
56619	5197	3013721	1962-06-05	1962-06-05 00:00:00	1962-06-05	5001	0	\N	0	0	\N	\N	0	345571	0	1920-8	3013721		
9915	316	4024958	1939-09-14	1939-09-14 00:00:00	1939-09-14	5001	0	\N	0	0	\N	\N	0	20894	0	117015009	4024958		
46496	4279	46235214	1951-05-07	1951-05-07 00:00:00	1951-05-07	5001	0	\N	0	0	\N	\N	0	283959	0	76690-7	46235214		
31470	2876	3006322	2017-12-12	2017-12-12 00:00:00	2017-12-12	5001	0	\N	0	0	\N	\N	0	191364	0	8331-1	3006322		
31495	2882	3006322	1996-07-20	1996-07-20 00:00:00	1996-07-20	5001	0	\N	0	0	\N	\N	0	191699	0	8331-1	3006322		
32385	2942	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	196219	0	6273-7	3006451		
53818	4935	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	328036	0	6844-5	3020655		
11504	1101	3011505	2006-07-02	2006-07-02 00:00:00	2006-07-02	5001	0	\N	0	0	\N	\N	0	72304	0	19926-5	3011505		
891	70	3006322	1983-05-06	1983-05-06 00:00:00	1983-05-06	5001	0	\N	0	0	\N	\N	0	4726	0	8331-1	3006322		
163737	5031	4024958	1931-09-09	1931-09-09 00:00:00	1931-09-09	5001	0	\N	0	0	\N	\N	0	334312	0	117015009	4024958		
121047	3736	4024958	1968-02-26	1968-02-26 00:00:00	1968-02-26	5001	0	\N	0	0	\N	\N	0	248256	0	117015009	4024958		
74757	2292	4024958	1975-08-15	1975-08-15 00:00:00	1975-08-15	5001	0	\N	0	0	\N	\N	0	152564	0	117015009	4024958		
35126	3212	3010813	2018-07-21	2018-07-21 00:00:00	2018-07-21	5001	0	\N	0	0	\N	\N	0	213430	0	26464-8	3010813		
45827	4224	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	280540	0	6276-0	3027231		
45901	4229	3006322	1996-05-08	1996-05-08 00:00:00	1996-05-08	5001	0	\N	0	0	\N	\N	0	280935	0	8331-1	3006322		
2670	263	46235214	1999-08-08	1999-08-08 00:00:00	1999-08-08	5001	0	\N	0	0	\N	\N	0	17446	0	76690-7	46235214		
57373	5267	3023430	1999-06-26	1999-06-26 00:00:00	1999-06-26	5001	0	\N	0	0	\N	\N	0	350412	0	6833-8	3023430		
55973	5138	3006322	1992-10-15	1992-10-15 00:00:00	1992-10-15	5001	0	\N	0	0	\N	\N	0	341474	0	8331-1	3006322		
14133	1321	3006322	1973-12-28	1973-12-28 00:00:00	1973-12-28	5001	0	\N	0	0	\N	\N	0	87651	0	8331-1	3006322		
15274	479	4052083	2004-11-03	2004-11-03 00:00:00	2004-11-03	5001	0	\N	0	0	\N	\N	0	31882	0	23426006	4052083		
150461	4613	4052083	1996-02-15	1996-02-15 00:00:00	1996-02-15	5001	0	\N	0	0	\N	\N	0	307260	0	23426006	4052083		
57682	1761	4052083	1967-07-09	1967-07-09 00:00:00	1967-07-09	5001	0	\N	0	0	\N	\N	0	117787	0	23426006	4052083		
35635	3253	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	216383	0	6273-7	3006451		
57987	1766	4133840	2014-11-11	2014-11-11 00:00:00	2014-11-11	5001	0	\N	0	0	\N	\N	0	118146	0	127783003	4133840		
47092	4342	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	287954	0	6095-4	3036780		
56562	5194	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	345299	0	7258-7	3001488		
68425	2090	4024958	1972-04-03	1972-04-03 00:00:00	1972-04-03	5001	0	\N	0	0	\N	\N	0	139353	0	117015009	4024958		
136704	4214	4024958	1986-07-11	1986-07-11 00:00:00	1986-07-11	5001	0	\N	0	0	\N	\N	0	279774	0	117015009	4024958		
11244	1083	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	71099	0	6276-0	3027231		
26200	2409	3006322	1996-09-19	1996-09-19 00:00:00	1996-09-19	5001	0	\N	0	0	\N	\N	0	159914	0	8331-1	3006322		
113648	3509	4052083	1961-03-08	1961-03-08 00:00:00	1961-03-08	5001	0	\N	0	0	\N	\N	0	232782	0	23426006	4052083		
125030	3859	4133840	2012-11-03	2012-11-03 00:00:00	2012-11-03	5001	0	\N	0	0	\N	\N	0	256279	0	127783003	4133840		
45649	4212	3006322	2015-06-26	2015-06-26 00:00:00	2015-06-26	5001	0	\N	0	0	\N	\N	0	279684	0	8331-1	3006322		
16049	1468	40766240	2016-07-28	2016-07-28 00:00:00	2016-07-28	5001	0	\N	0	0	\N	\N	0	97798	0	63513-6	40766240		
14263	1328	3011505	2011-03-17	2011-03-17 00:00:00	2011-03-17	5001	0	\N	0	0	\N	\N	0	88173	0	19926-5	3011505		
132880	4090	4052083	1952-02-01	1952-02-01 00:00:00	1952-02-01	5001	0	\N	0	0	\N	\N	0	271847	0	23426006	4052083		
25678	2352	3027231	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	156717	0	6276-0	3027231		
37066	3409	3006322	1955-12-27	1955-12-27 00:00:00	1955-12-27	5001	0	\N	0	0	\N	\N	0	226125	0	8331-1	3006322		
5375	512	3006322	1958-03-04	1958-03-04 00:00:00	1958-03-04	5001	0	\N	0	0	\N	\N	0	34175	0	8331-1	3006322		
31280	2858	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	189881	0	6075-6	3005136		
25354	789	4052083	1995-12-01	1995-12-01 00:00:00	1995-12-01	5001	0	\N	0	0	\N	\N	0	52511	0	23426006	4052083		
111675	3446	4052083	1959-12-01	1959-12-01 00:00:00	1959-12-01	5001	0	\N	0	0	\N	\N	0	228807	0	23426006	4052083		
35378	3240	40758406	1993-04-11	1993-04-11 00:00:00	1993-04-11	5001	0	\N	0	0	\N	\N	0	215337	0	55277-8	40758406		
46735	4305	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	285616	0	6246-3	3021226		
153761	4719	4024958	1997-08-19	1997-08-19 00:00:00	1997-08-19	5001	0	\N	0	0	\N	\N	0	314330	0	117015009	4024958		
58177	5337	3012494	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	355418	0	6206-7	3012494		
57764	5300	3016723	1945-02-13	1945-02-13 00:00:00	1945-02-13	5001	0	\N	0	0	\N	\N	0	352654	0	2160-0	3016723		
19386	607	4024958	2009-05-09	2009-05-09 00:00:00	2009-05-09	5001	0	\N	0	0	\N	\N	0	40270	0	117015009	4024958		
10553	1024	3006322	1999-01-30	1999-01-30 00:00:00	1999-01-30	5001	0	\N	0	0	\N	\N	0	67476	0	8331-1	3006322		
21925	2017	3006322	1971-02-20	1971-02-20 00:00:00	1971-02-20	5001	0	\N	0	0	\N	\N	0	134166	0	8331-1	3006322		
33320	3010	3006322	1964-12-12	1964-12-12 00:00:00	1964-12-12	5001	0	\N	0	0	\N	\N	0	200794	0	8331-1	3006322		
39651	3680	3036780	1979-12-15	1979-12-15 00:00:00	1979-12-15	5001	0	\N	0	0	\N	\N	0	244725	0	6095-4	3036780		
13628	1282	3005136	1977-08-12	1977-08-12 00:00:00	1977-08-12	5001	0	\N	0	0	\N	\N	0	84719	0	6075-6	3005136		
44870	4149	3006322	2008-06-18	2008-06-18 00:00:00	2008-06-18	5001	0	\N	0	0	\N	\N	0	275714	0	8331-1	3006322		
17585	1600	40766240	1947-05-25	1947-05-25 00:00:00	1947-05-25	5001	0	\N	0	0	\N	\N	0	107441	0	63513-6	40766240		
56265	5166	3006322	1953-04-06	1953-04-06 00:00:00	1953-04-06	5001	0	\N	0	0	\N	\N	0	343414	0	8331-1	3006322		
36537	3362	3006322	2004-08-09	2004-08-09 00:00:00	2004-08-09	5001	0	\N	0	0	\N	\N	0	222900	0	8331-1	3006322		
36613	3367	3006322	1967-07-23	1967-07-23 00:00:00	1967-07-23	5001	0	\N	0	0	\N	\N	0	223297	0	8331-1	3006322		
22342	2053	40758406	1964-04-25	1964-04-25 00:00:00	1964-04-25	5001	0	\N	0	0	\N	\N	0	136510	0	55277-8	40758406		
12838	409	4024958	1968-12-03	1968-12-03 00:00:00	1968-12-03	5001	0	\N	0	0	\N	\N	0	27071	0	117015009	4024958		
50909	4641	3006322	1999-02-18	1999-02-18 00:00:00	1999-02-18	5001	0	\N	0	0	\N	\N	0	309298	0	8331-1	3006322		
50976	4646	3027231	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	309825	0	6276-0	3027231		
36244	3335	3051031	2014-07-14	2014-07-14 00:00:00	2014-07-14	5001	0	\N	0	0	\N	\N	0	221279	0	46240-8	3051031		
17568	552	4052083	1969-07-17	1969-07-17 00:00:00	1969-07-17	5001	0	\N	0	0	\N	\N	0	36623	0	23426006	4052083		
56620	5197	3004501	1962-06-05	1962-06-05 00:00:00	1962-06-05	5001	0	\N	0	0	\N	\N	0	345571	0	2345-7	3004501		
2525	79	4024958	1997-12-20	1997-12-20 00:00:00	1997-12-20	5001	0	\N	0	0	\N	\N	0	5284	0	117015009	4024958		
46497	4279	40758406	1951-05-07	1951-05-07 00:00:00	1951-05-07	5001	0	\N	0	0	\N	\N	0	283959	0	55277-8	40758406		
31471	2876	3011505	2005-10-20	2005-10-20 00:00:00	2005-10-20	5001	0	\N	0	0	\N	\N	0	191389	0	19926-5	3011505		
31496	2882	3006322	2006-07-08	2006-07-08 00:00:00	2006-07-08	5001	0	\N	0	0	\N	\N	0	191712	0	8331-1	3006322		
32386	2942	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	196219	0	6075-6	3005136		
53819	4935	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	328036	0	6276-0	3027231		
11505	1101	3011505	2009-07-05	2009-07-05 00:00:00	2009-07-05	5001	0	\N	0	0	\N	\N	0	72305	0	19926-5	3011505		
892	70	3006322	1964-02-18	1964-02-18 00:00:00	1964-02-18	5001	0	\N	0	0	\N	\N	0	4723	0	8331-1	3006322		
163743	5031	4052083	1928-02-17	1928-02-17 00:00:00	1928-02-17	5001	0	\N	0	0	\N	\N	0	334323	0	23426006	4052083		
121050	3736	4024958	1959-03-27	1959-03-27 00:00:00	1959-03-27	5001	0	\N	0	0	\N	\N	0	248255	0	117015009	4024958		
74759	2292	4133840	2018-03-23	2018-03-23 00:00:00	2018-03-23	5001	0	\N	0	0	\N	\N	0	152582	0	127783003	4133840		
35127	3212	3024561	2018-07-21	2018-07-21 00:00:00	2018-07-21	5001	0	\N	0	0	\N	\N	0	213430	0	1751-7	3024561		
45828	4224	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	280540	0	6082-2	3000876		
45911	4235	3006322	1979-11-30	1979-11-30 00:00:00	1979-11-30	5001	0	\N	0	0	\N	\N	0	281187	0	8331-1	3006322		
2671	263	40766240	1999-08-08	1999-08-08 00:00:00	1999-08-08	5001	0	\N	0	0	\N	\N	0	17446	0	63513-6	40766240		
57374	5267	3001247	1999-06-26	1999-06-26 00:00:00	1999-06-26	5001	0	\N	0	0	\N	\N	0	350412	0	6085-5	3001247		
55974	5138	3006322	2001-08-13	2001-08-13 00:00:00	2001-08-13	5001	0	\N	0	0	\N	\N	0	341457	0	8331-1	3006322		
14134	1321	3006322	2003-12-29	2003-12-29 00:00:00	2003-12-29	5001	0	\N	0	0	\N	\N	0	87612	0	8331-1	3006322		
84190	2604	4024958	2000-04-28	2000-04-28 00:00:00	2000-04-28	5001	0	\N	0	0	\N	\N	0	172278	0	117015009	4024958		
150470	4613	4024958	1976-11-28	1976-11-28 00:00:00	1976-11-28	5001	0	\N	0	0	\N	\N	0	307294	0	117015009	4024958		
57686	1762	4133840	1998-04-09	1998-04-09 00:00:00	1998-04-09	5001	0	\N	0	0	\N	\N	0	117826	0	127783003	4133840		
35636	3253	3006322	1989-02-21	1989-02-21 00:00:00	1989-02-21	5001	0	\N	0	0	\N	\N	0	216370	0	8331-1	3006322		
45106	4165	3006322	1951-01-22	1951-01-22 00:00:00	1951-01-22	5001	0	\N	0	0	\N	\N	0	276697	0	8331-1	3006322		
47093	4342	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	287954	0	6206-7	3012494		
56563	5194	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	345299	0	6246-3	3021226		
68428	2091	4024958	1979-01-12	1979-01-12 00:00:00	1979-01-12	5001	0	\N	0	0	\N	\N	0	139432	0	117015009	4024958		
136898	4220	4024958	1972-11-10	1972-11-10 00:00:00	1972-11-10	5001	0	\N	0	0	\N	\N	0	280222	0	117015009	4024958		
11245	1083	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	71099	0	6075-6	3005136		
26201	2409	3006322	2016-01-02	2016-01-02 00:00:00	2016-01-02	5001	0	\N	0	0	\N	\N	0	159952	0	8331-1	3006322		
46849	1431	4052083	2003-03-14	2003-03-14 00:00:00	2003-03-14	5001	0	\N	0	0	\N	\N	0	95305	0	23426006	4052083		
125032	3859	4133840	2001-09-01	2001-09-01 00:00:00	2001-09-01	5001	0	\N	0	0	\N	\N	0	256155	0	127783003	4133840		
45650	4212	3006322	2019-05-23	2019-05-23 00:00:00	2019-05-23	5001	0	\N	0	0	\N	\N	0	279685	0	8331-1	3006322		
16050	1468	40758406	2016-06-28	2016-06-28 00:00:00	2016-06-28	5001	0	\N	0	0	\N	\N	0	97877	0	55277-8	40758406		
14264	1328	3011505	2010-03-11	2010-03-11 00:00:00	2010-03-11	5001	0	\N	0	0	\N	\N	0	88213	0	19926-5	3011505		
132881	4090	4024958	1971-12-18	1971-12-18 00:00:00	1971-12-18	5001	0	\N	0	0	\N	\N	0	271853	0	117015009	4024958		
25679	2352	3005136	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	156717	0	6075-6	3005136		
37067	3409	3006322	1955-11-17	1955-11-17 00:00:00	1955-11-17	5001	0	\N	0	0	\N	\N	0	226063	0	8331-1	3006322		
5376	512	46235214	1960-08-16	1960-08-16 00:00:00	1960-08-16	5001	0	\N	0	0	\N	\N	0	34163	0	76690-7	46235214		
31281	2858	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	189881	0	6273-7	3006451		
25370	789	4052083	1987-12-07	1987-12-07 00:00:00	1987-12-07	5001	0	\N	0	0	\N	\N	0	52462	0	23426006	4052083		
111689	3446	4052083	1958-07-29	1958-07-29 00:00:00	1958-07-29	5001	0	\N	0	0	\N	\N	0	228835	0	23426006	4052083		
35379	3240	40766240	1993-04-11	1993-04-11 00:00:00	1993-04-11	5001	0	\N	0	0	\N	\N	0	215337	0	63513-6	40766240		
46736	4305	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	285616	0	6276-0	3027231		
165053	5068	4024958	1934-09-12	1934-09-12 00:00:00	1934-09-12	5001	0	\N	0	0	\N	\N	0	336913	0	117015009	4024958		
58178	5337	3005136	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	355418	0	6075-6	3005136		
57765	5300	3024561	1945-02-13	1945-02-13 00:00:00	1945-02-13	5001	0	\N	0	0	\N	\N	0	352654	0	1751-7	3024561		
19387	607	4052083	1977-11-04	1977-11-04 00:00:00	1977-11-04	5001	0	\N	0	0	\N	\N	0	40326	0	23426006	4052083		
10554	1024	3006322	2008-05-28	2008-05-28 00:00:00	2008-05-28	5001	0	\N	0	0	\N	\N	0	67477	0	8331-1	3006322		
21926	2017	40758406	1970-10-27	1970-10-27 00:00:00	1970-10-27	5001	0	\N	0	0	\N	\N	0	134176	0	55277-8	40758406		
33321	3010	3006322	2012-05-13	2012-05-13 00:00:00	2012-05-13	5001	0	\N	0	0	\N	\N	0	200773	0	8331-1	3006322		
39652	3680	3012494	1979-12-15	1979-12-15 00:00:00	1979-12-15	5001	0	\N	0	0	\N	\N	0	244725	0	6206-7	3012494		
13629	1282	3014599	1977-08-12	1977-08-12 00:00:00	1977-08-12	5001	0	\N	0	0	\N	\N	0	84719	0	6106-9	3014599		
44871	4149	3006322	2011-06-15	2011-06-15 00:00:00	2011-06-15	5001	0	\N	0	0	\N	\N	0	275746	0	8331-1	3006322		
17586	1600	46235214	1947-05-25	1947-05-25 00:00:00	1947-05-25	5001	0	\N	0	0	\N	\N	0	107441	0	76690-7	46235214		
56312	5168	3006322	2000-04-20	2000-04-20 00:00:00	2000-04-20	5001	0	\N	0	0	\N	\N	0	343648	0	8331-1	3006322		
36538	3362	3006322	2011-08-12	2011-08-12 00:00:00	2011-08-12	5001	0	\N	0	0	\N	\N	0	222886	0	8331-1	3006322		
36614	3367	3006322	1965-12-19	1965-12-19 00:00:00	1965-12-19	5001	0	\N	0	0	\N	\N	0	223299	0	8331-1	3006322		
22343	2053	3051031	1964-04-25	1964-04-25 00:00:00	1964-04-25	5001	0	\N	0	0	\N	\N	0	136510	0	46240-8	3051031		
13060	411	4052083	1970-08-03	1970-08-03 00:00:00	1970-08-03	5001	0	\N	0	0	\N	\N	0	27267	0	23426006	4052083		
50910	4641	3006322	1979-10-06	1979-10-06 00:00:00	1979-10-06	5001	0	\N	0	0	\N	\N	0	309296	0	8331-1	3006322		
50977	4646	3019406	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	309825	0	6158-0	3019406		
36245	3335	40758406	2014-07-14	2014-07-14 00:00:00	2014-07-14	5001	0	\N	0	0	\N	\N	0	221279	0	55277-8	40758406		
17594	552	4024958	1955-04-15	1955-04-15 00:00:00	1955-04-15	5001	0	\N	0	0	\N	\N	0	36641	0	117015009	4024958		
56621	5197	3014576	1962-06-05	1962-06-05 00:00:00	1962-06-05	5001	0	\N	0	0	\N	\N	0	345571	0	2075-0	3014576		
2534	79	4024958	1954-01-17	1954-01-17 00:00:00	1954-01-17	5001	0	\N	0	0	\N	\N	0	5254	0	117015009	4024958		
46498	4279	3006322	1954-01-20	1954-01-20 00:00:00	1954-01-20	5001	0	\N	0	0	\N	\N	0	283960	0	8331-1	3006322		
31472	2876	3011505	2017-11-02	2017-11-02 00:00:00	2017-11-02	5001	0	\N	0	0	\N	\N	0	191391	0	19926-5	3011505		
31497	2882	3006322	1988-04-20	1988-04-20 00:00:00	1988-04-20	5001	0	\N	0	0	\N	\N	0	191709	0	8331-1	3006322		
32387	2942	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	196219	0	6206-7	3012494		
53820	4935	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	328036	0	7258-7	3001488		
11506	1101	3011505	2014-08-24	2014-08-24 00:00:00	2014-08-24	5001	0	\N	0	0	\N	\N	0	72314	0	19926-5	3011505		
894	72	3006322	1968-02-12	1968-02-12 00:00:00	1968-02-12	5001	0	\N	0	0	\N	\N	0	4916	0	8331-1	3006322		
163751	5031	4052083	2002-02-06	2002-02-06 00:00:00	2002-02-06	5001	0	\N	0	0	\N	\N	0	334289	0	23426006	4052083		
121061	3736	4052083	1969-01-11	1969-01-11 00:00:00	1969-01-11	5001	0	\N	0	0	\N	\N	0	248314	0	23426006	4052083		
74763	2292	4052083	2001-12-26	2001-12-26 00:00:00	2001-12-26	5001	0	\N	0	0	\N	\N	0	152613	0	23426006	4052083		
59806	1826	4024958	1949-06-25	1949-06-25 00:00:00	1949-06-25	5001	0	\N	0	0	\N	\N	0	121998	0	117015009	4024958		
45829	4224	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	280540	0	6158-0	3019406		
45912	4235	3006322	2012-06-23	2012-06-23 00:00:00	2012-06-23	5001	0	\N	0	0	\N	\N	0	281171	0	8331-1	3006322		
2673	263	3051031	1999-08-08	1999-08-08 00:00:00	1999-08-08	5001	0	\N	0	0	\N	\N	0	17446	0	46240-8	3051031		
57375	5267	3006734	1999-06-26	1999-06-26 00:00:00	1999-06-26	5001	0	\N	0	0	\N	\N	0	350412	0	6189-5	3006734		
56023	5142	3049273	2014-06-18	2014-06-18 00:00:00	2014-06-18	5001	0	\N	0	0	\N	\N	0	341699	0	38265-5	3049273		
14135	1321	3006322	1966-06-26	1966-06-26 00:00:00	1966-06-26	5001	0	\N	0	0	\N	\N	0	87639	0	8331-1	3006322		
84245	2609	4052083	2017-03-02	2017-03-02 00:00:00	2017-03-02	5001	0	\N	0	0	\N	\N	0	172476	0	23426006	4052083		
12880	1226	3006322	1993-07-28	1993-07-28 00:00:00	1993-07-28	5001	0	\N	0	0	\N	\N	0	80712	0	8331-1	3006322		
57689	1762	4133840	1967-03-16	1967-03-16 00:00:00	1967-03-16	5001	0	\N	0	0	\N	\N	0	117889	0	127783003	4133840		
35637	3253	3006322	1984-12-17	1984-12-17 00:00:00	1984-12-17	5001	0	\N	0	0	\N	\N	0	216326	0	8331-1	3006322		
45107	4165	3006322	1958-02-25	1958-02-25 00:00:00	1958-02-25	5001	0	\N	0	0	\N	\N	0	276745	0	8331-1	3006322		
47094	4342	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	287954	0	6075-6	3005136		
56564	5194	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	345299	0	6276-0	3027231		
68444	2091	4052083	1967-12-31	1967-12-31 00:00:00	1967-12-31	5001	0	\N	0	0	\N	\N	0	139441	0	23426006	4052083		
136916	4220	4052083	1962-01-16	1962-01-16 00:00:00	1962-01-16	5001	0	\N	0	0	\N	\N	0	280185	0	23426006	4052083		
11246	1083	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	71099	0	6246-3	3021226		
26202	2409	3006322	2017-04-10	2017-04-10 00:00:00	2017-04-10	5001	0	\N	0	0	\N	\N	0	159937	0	8331-1	3006322		
46853	1431	4052083	1963-06-22	1963-06-22 00:00:00	1963-06-22	5001	0	\N	0	0	\N	\N	0	95296	0	23426006	4052083		
125033	3859	4133840	2002-09-07	2002-09-07 00:00:00	2002-09-07	5001	0	\N	0	0	\N	\N	0	256239	0	127783003	4133840		
45651	4212	3006322	1992-10-26	1992-10-26 00:00:00	1992-10-26	5001	0	\N	0	0	\N	\N	0	279664	0	8331-1	3006322		
16051	1468	3051031	2016-06-28	2016-06-28 00:00:00	2016-06-28	5001	0	\N	0	0	\N	\N	0	97877	0	46240-8	3051031		
14265	1328	3011505	2007-10-04	2007-10-04 00:00:00	2007-10-04	5001	0	\N	0	0	\N	\N	0	88232	0	19926-5	3011505		
110672	3417	4052083	1914-09-20	1914-09-20 00:00:00	1914-09-20	5001	0	\N	0	0	\N	\N	0	226652	0	23426006	4052083		
25680	2352	3019406	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	156717	0	6158-0	3019406		
37068	3409	3049273	2011-04-26	2011-04-26 00:00:00	2011-04-26	5001	0	\N	0	0	\N	\N	0	226124	0	38265-5	3049273		
5377	512	40766240	1960-08-16	1960-08-16 00:00:00	1960-08-16	5001	0	\N	0	0	\N	\N	0	34163	0	63513-6	40766240		
31282	2858	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	189881	0	6276-0	3027231		
25373	789	4024958	2014-02-16	2014-02-16 00:00:00	2014-02-16	5001	0	\N	0	0	\N	\N	0	52464	0	117015009	4024958		
7186	697	3006322	2002-10-09	2002-10-09 00:00:00	2002-10-09	5001	0	\N	0	0	\N	\N	0	46110	0	8331-1	3006322		
35382	3240	3051031	1993-04-11	1993-04-11 00:00:00	1993-04-11	5001	0	\N	0	0	\N	\N	0	215337	0	46240-8	3051031		
46737	4305	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	285616	0	7258-7	3001488		
165060	5068	4024958	1974-04-16	1974-04-16 00:00:00	1974-04-16	5001	0	\N	0	0	\N	\N	0	336947	0	117015009	4024958		
58179	5337	3014599	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	355418	0	6106-9	3014599		
57766	5300	3028833	1945-02-13	1945-02-13 00:00:00	1945-02-13	5001	0	\N	0	0	\N	\N	0	352654	0	42719-5	3028833		
19388	607	4024958	1973-08-24	1973-08-24 00:00:00	1973-08-24	5001	0	\N	0	0	\N	\N	0	40325	0	117015009	4024958		
10555	1024	3049273	2012-08-16	2012-08-16 00:00:00	2012-08-16	5001	0	\N	0	0	\N	\N	0	67441	0	38265-5	3049273		
21927	2017	3051031	1970-10-27	1970-10-27 00:00:00	1970-10-27	5001	0	\N	0	0	\N	\N	0	134176	0	46240-8	3051031		
33322	3010	3006322	1975-03-04	1975-03-04 00:00:00	1975-03-04	5001	0	\N	0	0	\N	\N	0	200780	0	8331-1	3006322		
39653	3680	3014599	1979-12-15	1979-12-15 00:00:00	1979-12-15	5001	0	\N	0	0	\N	\N	0	244725	0	6106-9	3014599		
13630	1282	3023430	1977-08-12	1977-08-12 00:00:00	1977-08-12	5001	0	\N	0	0	\N	\N	0	84719	0	6833-8	3023430		
19242	1764	3006322	2003-05-18	2003-05-18 00:00:00	2003-05-18	5001	0	\N	0	0	\N	\N	0	117942	0	8331-1	3006322		
17587	1600	40758406	1947-05-25	1947-05-25 00:00:00	1947-05-25	5001	0	\N	0	0	\N	\N	0	107441	0	55277-8	40758406		
56313	5168	3006322	2014-02-20	2014-02-20 00:00:00	2014-02-20	5001	0	\N	0	0	\N	\N	0	343611	0	8331-1	3006322		
36539	3362	3006322	1979-10-01	1979-10-01 00:00:00	1979-10-01	5001	0	\N	0	0	\N	\N	0	222864	0	8331-1	3006322		
36616	3370	3012494	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	223479	0	6206-7	3012494		
22346	2053	46235214	1964-04-25	1964-04-25 00:00:00	1964-04-25	5001	0	\N	0	0	\N	\N	0	136510	0	76690-7	46235214		
13063	412	4052083	1960-01-11	1960-01-11 00:00:00	1960-01-11	5001	0	\N	0	0	\N	\N	0	27424	0	23426006	4052083		
50911	4641	3011505	2011-07-28	2011-07-28 00:00:00	2011-07-28	5001	0	\N	0	0	\N	\N	0	309352	0	19926-5	3011505		
50978	4646	3006322	1977-01-23	1977-01-23 00:00:00	1977-01-23	5001	0	\N	0	0	\N	\N	0	309786	0	8331-1	3006322		
36247	3335	40766240	2014-08-13	2014-08-13 00:00:00	2014-08-13	5001	0	\N	0	0	\N	\N	0	221248	0	63513-6	40766240		
17596	552	4052083	1991-08-31	1991-08-31 00:00:00	1991-08-31	5001	0	\N	0	0	\N	\N	0	36583	0	23426006	4052083		
56622	5197	3010813	1962-06-05	1962-06-05 00:00:00	1962-06-05	5001	0	\N	0	0	\N	\N	0	345571	0	26464-8	3010813		
2543	79	4052083	1990-08-05	1990-08-05 00:00:00	1990-08-05	5001	0	\N	0	0	\N	\N	0	5260	0	23426006	4052083		
46499	4279	3006322	2007-03-03	2007-03-03 00:00:00	2007-03-03	5001	0	\N	0	0	\N	\N	0	284006	0	8331-1	3006322		
31473	2876	3011505	2012-06-21	2012-06-21 00:00:00	2012-06-21	5001	0	\N	0	0	\N	\N	0	191390	0	19926-5	3011505		
31498	2883	3006322	1991-11-04	1991-11-04 00:00:00	1991-11-04	5001	0	\N	0	0	\N	\N	0	191769	0	8331-1	3006322		
32388	2942	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	196219	0	6106-9	3014599		
53821	4935	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	328036	0	6189-5	3006734		
11507	1101	3011505	2012-07-08	2012-07-08 00:00:00	2012-07-08	5001	0	\N	0	0	\N	\N	0	72306	0	19926-5	3011505		
895	72	3006322	1989-10-02	1989-10-02 00:00:00	1989-10-02	5001	0	\N	0	0	\N	\N	0	4918	0	8331-1	3006322		
163759	5031	4024958	1944-11-08	1944-11-08 00:00:00	1944-11-08	5001	0	\N	0	0	\N	\N	0	334361	0	117015009	4024958		
121066	3736	4024958	1985-04-12	1985-04-12 00:00:00	1985-04-12	5001	0	\N	0	0	\N	\N	0	248315	0	117015009	4024958		
74766	2292	4133840	2019-03-29	2019-03-29 00:00:00	2019-03-29	5001	0	\N	0	0	\N	\N	0	152593	0	127783003	4133840		
59836	1826	4052083	2017-02-27	2017-02-27 00:00:00	2017-02-27	5001	0	\N	0	0	\N	\N	0	122059	0	23426006	4052083		
45830	4224	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	280540	0	6273-7	3006451		
50860	1542	4024958	1992-03-24	1992-03-24 00:00:00	1992-03-24	5001	0	\N	0	0	\N	\N	0	103321	0	117015009	4024958		
2674	263	3006322	1997-08-01	1997-08-01 00:00:00	1997-08-01	5001	0	\N	0	0	\N	\N	0	17468	0	8331-1	3006322		
1957	57	4024958	1976-10-29	1976-10-29 00:00:00	1976-10-29	5001	0	\N	0	0	\N	\N	0	3823	0	117015009	4024958		
56024	5142	3006322	2018-06-05	2018-06-05 00:00:00	2018-06-05	5001	0	\N	0	0	\N	\N	0	341716	0	8331-1	3006322		
14136	1322	3006322	1945-09-09	1945-09-09 00:00:00	1945-09-09	5001	0	\N	0	0	\N	\N	0	87787	0	8331-1	3006322		
84246	2609	4024958	1989-01-06	1989-01-06 00:00:00	1989-01-06	5001	0	\N	0	0	\N	\N	0	172477	0	117015009	4024958		
12881	1226	3006322	1986-10-06	1986-10-06 00:00:00	1986-10-06	5001	0	\N	0	0	\N	\N	0	80707	0	8331-1	3006322		
57691	1762	4133840	2012-03-29	2012-03-29 00:00:00	2012-03-29	5001	0	\N	0	0	\N	\N	0	117811	0	127783003	4133840		
35638	3253	3006322	1987-03-23	1987-03-23 00:00:00	1987-03-23	5001	0	\N	0	0	\N	\N	0	216328	0	8331-1	3006322		
45108	4165	3006322	1980-01-11	1980-01-11 00:00:00	1980-01-11	5001	0	\N	0	0	\N	\N	0	276754	0	8331-1	3006322		
47095	4342	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	287954	0	6106-9	3014599		
23863	747	4024958	1968-11-05	1968-11-05 00:00:00	1968-11-05	5001	0	\N	0	0	\N	\N	0	49468	0	117015009	4024958		
68454	2091	4024958	1989-11-25	1989-11-25 00:00:00	1989-11-25	5001	0	\N	0	0	\N	\N	0	139433	0	117015009	4024958		
153280	4701	4052083	1977-12-27	1977-12-27 00:00:00	1977-12-27	5001	0	\N	0	0	\N	\N	0	313135	0	23426006	4052083		
11247	1083	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	71099	0	7258-7	3001488		
26203	2409	3006322	2001-03-10	2001-03-10 00:00:00	2001-03-10	5001	0	\N	0	0	\N	\N	0	159895	0	8331-1	3006322		
46888	1431	4024958	1984-12-26	1984-12-26 00:00:00	1984-12-26	5001	0	\N	0	0	\N	\N	0	95287	0	117015009	4024958		
125036	3859	4133840	2016-04-16	2016-04-16 00:00:00	2016-04-16	5001	0	\N	0	0	\N	\N	0	256182	0	127783003	4133840		
45652	4212	3006322	1982-09-05	1982-09-05 00:00:00	1982-09-05	5001	0	\N	0	0	\N	\N	0	279646	0	8331-1	3006322		
16053	1468	46235214	2016-06-28	2016-06-28 00:00:00	2016-06-28	5001	0	\N	0	0	\N	\N	0	97877	0	76690-7	46235214		
14266	1328	3006322	1993-02-22	1993-02-22 00:00:00	1993-02-22	5001	0	\N	0	0	\N	\N	0	88136	0	8331-1	3006322		
110679	3417	4052083	1980-01-29	1980-01-29 00:00:00	1980-01-29	5001	0	\N	0	0	\N	\N	0	226593	0	23426006	4052083		
25681	2352	3000876	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	156717	0	6082-2	3000876		
37069	3409	3006322	1992-07-21	1992-07-21 00:00:00	1992-07-21	5001	0	\N	0	0	\N	\N	0	226093	0	8331-1	3006322		
5378	512	3051031	1960-08-16	1960-08-16 00:00:00	1960-08-16	5001	0	\N	0	0	\N	\N	0	34163	0	46240-8	3051031		
31283	2859	3006322	1951-06-13	1951-06-13 00:00:00	1951-06-13	5001	0	\N	0	0	\N	\N	0	190022	0	8331-1	3006322		
23959	2199	3006322	1991-01-05	1991-01-05 00:00:00	1991-01-05	5001	0	\N	0	0	\N	\N	0	146545	0	8331-1	3006322		
7187	697	3006322	1979-11-29	1979-11-29 00:00:00	1979-11-29	5001	0	\N	0	0	\N	\N	0	46120	0	8331-1	3006322		
35383	3240	3051031	1993-05-11	1993-05-11 00:00:00	1993-05-11	5001	0	\N	0	0	\N	\N	0	215413	0	46240-8	3051031		
46738	4305	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	285616	0	6189-5	3006734		
165062	5068	4024958	1956-09-14	1956-09-14 00:00:00	1956-09-14	5001	0	\N	0	0	\N	\N	0	336996	0	117015009	4024958		
58180	5337	3000876	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	355418	0	6082-2	3000876		
57767	5300	3013721	1945-02-13	1945-02-13 00:00:00	1945-02-13	5001	0	\N	0	0	\N	\N	0	352654	0	1920-8	3013721		
26282	821	4052083	1953-07-18	1953-07-18 00:00:00	1953-07-18	5001	0	\N	0	0	\N	\N	0	54377	0	23426006	4052083		
10556	1025	3006322	1968-05-30	1968-05-30 00:00:00	1968-05-30	5001	0	\N	0	0	\N	\N	0	67542	0	8331-1	3006322		
21928	2017	46235214	1970-10-27	1970-10-27 00:00:00	1970-10-27	5001	0	\N	0	0	\N	\N	0	134176	0	76690-7	46235214		
33323	3011	3006322	2014-09-09	2014-09-09 00:00:00	2014-09-09	5001	0	\N	0	0	\N	\N	0	200838	0	8331-1	3006322		
39654	3680	3020655	1979-12-15	1979-12-15 00:00:00	1979-12-15	5001	0	\N	0	0	\N	\N	0	244725	0	6844-5	3020655		
13631	1282	3019406	1977-08-12	1977-08-12 00:00:00	1977-08-12	5001	0	\N	0	0	\N	\N	0	84719	0	6158-0	3019406		
19288	1766	3006322	1952-12-23	1952-12-23 00:00:00	1952-12-23	5001	0	\N	0	0	\N	\N	0	118172	0	8331-1	3006322		
17588	1600	46235214	1947-04-25	1947-04-25 00:00:00	1947-04-25	5001	0	\N	0	0	\N	\N	0	107406	0	76690-7	46235214		
56314	5168	3006322	2017-08-15	2017-08-15 00:00:00	2017-08-15	5001	0	\N	0	0	\N	\N	0	343626	0	8331-1	3006322		
36540	3362	3006322	1979-05-23	1979-05-23 00:00:00	1979-05-23	5001	0	\N	0	0	\N	\N	0	222927	0	8331-1	3006322		
36617	3370	3019406	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	223479	0	6158-0	3019406		
22347	2053	40766240	1964-04-25	1964-04-25 00:00:00	1964-04-25	5001	0	\N	0	0	\N	\N	0	136510	0	63513-6	40766240		
24355	759	4052083	2017-09-07	2017-09-07 00:00:00	2017-09-07	5001	0	\N	0	0	\N	\N	0	50395	0	23426006	4052083		
50912	4642	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	309381	0	6276-0	3027231		
50979	4646	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	309845	0	6095-4	3036780		
36249	3335	46235214	2014-08-13	2014-08-13 00:00:00	2014-08-13	5001	0	\N	0	0	\N	\N	0	221248	0	76690-7	46235214		
17604	552	4024958	1963-04-12	1963-04-12 00:00:00	1963-04-12	5001	0	\N	0	0	\N	\N	0	36580	0	117015009	4024958		
56623	5197	3026361	1962-06-05	1962-06-05 00:00:00	1962-06-05	5001	0	\N	0	0	\N	\N	0	345571	0	26453-1	3026361		
2564	80	4024958	1986-08-29	1986-08-29 00:00:00	1986-08-29	5001	0	\N	0	0	\N	\N	0	5382	0	117015009	4024958		
46500	4279	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	283952	0	6189-5	3006734		
31474	2876	3011505	2010-06-17	2010-06-17 00:00:00	2010-06-17	5001	0	\N	0	0	\N	\N	0	191353	0	19926-5	3011505		
31499	2883	3006322	2003-01-19	2003-01-19 00:00:00	2003-01-19	5001	0	\N	0	0	\N	\N	0	191795	0	8331-1	3006322		
32389	2942	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	196219	0	6085-5	3001247		
53822	4935	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	328036	0	6085-5	3001247		
11509	1101	3011505	2003-06-29	2003-06-29 00:00:00	2003-06-29	5001	0	\N	0	0	\N	\N	0	72303	0	19926-5	3011505		
12174	1162	40766240	1963-01-19	1963-01-19 00:00:00	1963-01-19	5001	0	\N	0	0	\N	\N	0	76662	0	63513-6	40766240		
163764	5031	4024958	1962-04-30	1962-04-30 00:00:00	1962-04-30	5001	0	\N	0	0	\N	\N	0	334362	0	117015009	4024958		
121067	3736	4024958	1986-12-01	1986-12-01 00:00:00	1986-12-01	5001	0	\N	0	0	\N	\N	0	248260	0	117015009	4024958		
74769	2292	4133840	2015-03-06	2015-03-06 00:00:00	2015-03-06	5001	0	\N	0	0	\N	\N	0	152591	0	127783003	4133840		
59853	1826	4024958	1985-06-18	1985-06-18 00:00:00	1985-06-18	5001	0	\N	0	0	\N	\N	0	122054	0	117015009	4024958		
45831	4224	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	280540	0	6095-4	3036780		
50863	1542	4024958	2003-04-12	2003-04-12 00:00:00	2003-04-12	5001	0	\N	0	0	\N	\N	0	103322	0	117015009	4024958		
2675	263	3051031	2002-12-05	2002-12-05 00:00:00	2002-12-05	5001	0	\N	0	0	\N	\N	0	17448	0	46240-8	3051031		
13257	421	4024958	1996-05-22	1996-05-22 00:00:00	1996-05-22	5001	0	\N	0	0	\N	\N	0	27882	0	117015009	4024958		
56025	5142	3006322	1973-08-06	1973-08-06 00:00:00	1973-08-06	5001	0	\N	0	0	\N	\N	0	341768	0	8331-1	3006322		
14137	1322	3006322	1962-02-07	1962-02-07 00:00:00	1962-02-07	5001	0	\N	0	0	\N	\N	0	87717	0	8331-1	3006322		
84250	2609	4024958	2013-04-11	2013-04-11 00:00:00	2013-04-11	5001	0	\N	0	0	\N	\N	0	172499	0	117015009	4024958		
12882	1227	3006322	1967-09-02	1967-09-02 00:00:00	1967-09-02	5001	0	\N	0	0	\N	\N	0	80750	0	8331-1	3006322		
57698	1762	4133840	2009-03-12	2009-03-12 00:00:00	2009-03-12	5001	0	\N	0	0	\N	\N	0	117831	0	127783003	4133840		
35639	3253	3012494	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	216281	0	6206-7	3012494		
12479	403	4024958	1936-08-22	1936-08-22 00:00:00	1936-08-22	5001	0	\N	0	0	\N	\N	0	26532	0	117015009	4024958		
47096	4342	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	287954	0	6158-0	3019406		
23865	747	4024958	1965-05-16	1965-05-16 00:00:00	1965-05-16	5001	0	\N	0	0	\N	\N	0	49467	0	117015009	4024958		
110115	3399	4024958	1990-10-23	1990-10-23 00:00:00	1990-10-23	5001	0	\N	0	0	\N	\N	0	225488	0	117015009	4024958		
153281	4701	4052083	2008-11-02	2008-11-02 00:00:00	2008-11-02	5001	0	\N	0	0	\N	\N	0	313163	0	23426006	4052083		
11248	1083	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	71099	0	6158-0	3019406		
26204	2411	3006322	2019-02-08	2019-02-08 00:00:00	2019-02-08	5001	0	\N	0	0	\N	\N	0	159990	0	8331-1	3006322		
46895	1431	4052083	2019-03-21	2019-03-21 00:00:00	2019-03-21	5001	0	\N	0	0	\N	\N	0	95307	0	23426006	4052083		
159544	4905	4052083	2018-09-01	2018-09-01 00:00:00	2018-09-01	5001	0	\N	0	0	\N	\N	0	326039	0	23426006	4052083		
45654	4214	3006322	1975-09-15	1975-09-15 00:00:00	1975-09-15	5001	0	\N	0	0	\N	\N	0	279772	0	8331-1	3006322		
16055	1468	40766240	2016-06-28	2016-06-28 00:00:00	2016-06-28	5001	0	\N	0	0	\N	\N	0	97877	0	63513-6	40766240		
14267	1328	3006322	1951-11-09	1951-11-09 00:00:00	1951-11-09	5001	0	\N	0	0	\N	\N	0	88176	0	8331-1	3006322		
110680	3417	4024958	1916-10-09	1916-10-09 00:00:00	1916-10-09	5001	0	\N	0	0	\N	\N	0	226577	0	117015009	4024958		
25682	2352	3006734	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	156717	0	6189-5	3006734		
37070	3409	3006322	1961-01-24	1961-01-24 00:00:00	1961-01-24	5001	0	\N	0	0	\N	\N	0	226139	0	8331-1	3006322		
5379	512	40758406	1960-08-16	1960-08-16 00:00:00	1960-08-16	5001	0	\N	0	0	\N	\N	0	34163	0	55277-8	40758406		
31284	2859	3006322	1994-12-21	1994-12-21 00:00:00	1994-12-21	5001	0	\N	0	0	\N	\N	0	190004	0	8331-1	3006322		
23960	2199	3006322	1996-01-02	1996-01-02 00:00:00	1996-01-02	5001	0	\N	0	0	\N	\N	0	146588	0	8331-1	3006322		
7192	700	3006322	1979-03-13	1979-03-13 00:00:00	1979-03-13	5001	0	\N	0	0	\N	\N	0	46240	0	8331-1	3006322		
35385	3240	46235214	1993-05-11	1993-05-11 00:00:00	1993-05-11	5001	0	\N	0	0	\N	\N	0	215413	0	76690-7	46235214		
46739	4305	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	285616	0	6082-2	3000876		
165064	5068	4024958	1984-12-02	1984-12-02 00:00:00	1984-12-02	5001	0	\N	0	0	\N	\N	0	336923	0	117015009	4024958		
58181	5337	3027231	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	355418	0	6276-0	3027231		
57768	5300	3019550	1945-02-13	1945-02-13 00:00:00	1945-02-13	5001	0	\N	0	0	\N	\N	0	352654	0	2951-2	3019550		
26283	821	4024958	1981-03-01	1981-03-01 00:00:00	1981-03-01	5001	0	\N	0	0	\N	\N	0	54411	0	117015009	4024958		
10557	1025	3006322	2013-02-11	2013-02-11 00:00:00	2013-02-11	5001	0	\N	0	0	\N	\N	0	67565	0	8331-1	3006322		
21930	2017	40766240	1970-10-27	1970-10-27 00:00:00	1970-10-27	5001	0	\N	0	0	\N	\N	0	134176	0	63513-6	40766240		
33324	3011	3006322	1980-01-10	1980-01-10 00:00:00	1980-01-10	5001	0	\N	0	0	\N	\N	0	200822	0	8331-1	3006322		
39655	3680	3000876	1979-12-15	1979-12-15 00:00:00	1979-12-15	5001	0	\N	0	0	\N	\N	0	244725	0	6082-2	3000876		
13632	1282	3012494	1977-08-12	1977-08-12 00:00:00	1977-08-12	5001	0	\N	0	0	\N	\N	0	84719	0	6206-7	3012494		
19289	1766	3011505	2003-09-09	2003-09-09 00:00:00	2003-09-09	5001	0	\N	0	0	\N	\N	0	118179	0	19926-5	3011505		
17589	1600	40758406	1947-04-25	1947-04-25 00:00:00	1947-04-25	5001	0	\N	0	0	\N	\N	0	107406	0	55277-8	40758406		
56315	5168	3006322	1975-10-06	1975-10-06 00:00:00	1975-10-06	5001	0	\N	0	0	\N	\N	0	343647	0	8331-1	3006322		
36541	3362	3006322	1957-09-22	1957-09-22 00:00:00	1957-09-22	5001	0	\N	0	0	\N	\N	0	222881	0	8331-1	3006322		
36618	3370	3001247	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	223479	0	6085-5	3001247		
22348	2053	3006322	1966-03-16	1966-03-16 00:00:00	1966-03-16	5001	0	\N	0	0	\N	\N	0	136514	0	8331-1	3006322		
24392	760	4024958	1984-05-28	1984-05-28 00:00:00	1984-05-28	5001	0	\N	0	0	\N	\N	0	50499	0	117015009	4024958		
50913	4642	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	309381	0	6075-6	3005136		
50980	4646	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	309845	0	6844-5	3020655		
36250	3335	3051031	2014-08-13	2014-08-13 00:00:00	2014-08-13	5001	0	\N	0	0	\N	\N	0	221248	0	46240-8	3051031		
32756	1022	4024958	1968-01-25	1968-01-25 00:00:00	1968-01-25	5001	0	\N	0	0	\N	\N	0	67222	0	117015009	4024958		
56624	5197	21494966	1962-06-05	1962-06-05 00:00:00	1962-06-05	5001	0	\N	0	0	\N	\N	0	345571	0	80271-0	21494966		
2580	80	4052083	1953-02-24	1953-02-24 00:00:00	1953-02-24	5001	0	\N	0	0	\N	\N	0	5380	0	23426006	4052083		
46501	4279	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	283952	0	7258-7	3001488		
31475	2876	3006322	1971-03-03	1971-03-03 00:00:00	1971-03-03	5001	0	\N	0	0	\N	\N	0	191340	0	8331-1	3006322		
31504	2886	3006322	2003-05-20	2003-05-20 00:00:00	2003-05-20	5001	0	\N	0	0	\N	\N	0	191951	0	8331-1	3006322		
32390	2942	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	196219	0	6833-8	3023430		
53823	4935	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	328036	0	6206-7	3012494		
11510	1102	3006322	2018-03-14	2018-03-14 00:00:00	2018-03-14	5001	0	\N	0	0	\N	\N	0	72469	0	8331-1	3006322		
12176	1162	3051031	1963-01-19	1963-01-19 00:00:00	1963-01-19	5001	0	\N	0	0	\N	\N	0	76662	0	46240-8	3051031		
163765	5031	4024958	2018-10-18	2018-10-18 00:00:00	2018-10-18	5001	0	\N	0	0	\N	\N	0	334291	0	117015009	4024958		
121069	3736	4024958	1957-02-21	1957-02-21 00:00:00	1957-02-21	5001	0	\N	0	0	\N	\N	0	248343	0	117015009	4024958		
74774	2292	4133840	2011-01-28	2011-01-28 00:00:00	2011-01-28	5001	0	\N	0	0	\N	\N	0	152589	0	127783003	4133840		
11841	376	4024958	1976-09-19	1976-09-19 00:00:00	1976-09-19	5001	0	\N	0	0	\N	\N	0	24916	0	117015009	4024958		
45832	4224	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	280540	0	6248-9	3015076		
50871	1542	4052083	2012-10-13	2012-10-13 00:00:00	2012-10-13	5001	0	\N	0	0	\N	\N	0	103323	0	23426006	4052083		
2676	263	40758406	2002-12-05	2002-12-05 00:00:00	2002-12-05	5001	0	\N	0	0	\N	\N	0	17448	0	55277-8	40758406		
13259	421	4024958	1970-03-23	1970-03-23 00:00:00	1970-03-23	5001	0	\N	0	0	\N	\N	0	27884	0	117015009	4024958		
56026	5142	3006322	2014-11-14	2014-11-14 00:00:00	2014-11-14	5001	0	\N	0	0	\N	\N	0	341710	0	8331-1	3006322		
14138	1322	3006322	1935-09-14	1935-09-14 00:00:00	1935-09-14	5001	0	\N	0	0	\N	\N	0	87735	0	8331-1	3006322		
84267	2609	4052083	1960-07-21	1960-07-21 00:00:00	1960-07-21	5001	0	\N	0	0	\N	\N	0	172496	0	23426006	4052083		
12884	1227	3051031	2014-10-30	2014-10-30 00:00:00	2014-10-30	5001	0	\N	0	0	\N	\N	0	80785	0	46240-8	3051031		
57700	1762	4133840	1995-03-23	1995-03-23 00:00:00	1995-03-23	5001	0	\N	0	0	\N	\N	0	117844	0	127783003	4133840		
35640	3253	3005136	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	216281	0	6075-6	3005136		
12483	403	4052083	1929-02-11	1929-02-11 00:00:00	1929-02-11	5001	0	\N	0	0	\N	\N	0	26538	0	23426006	4052083		
47097	4342	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	287954	0	6085-5	3001247		
23867	747	4024958	2005-07-07	2005-07-07 00:00:00	2005-07-07	5001	0	\N	0	0	\N	\N	0	49490	0	117015009	4024958		
110135	3399	4024958	1987-01-30	1987-01-30 00:00:00	1987-01-30	5001	0	\N	0	0	\N	\N	0	225487	0	117015009	4024958		
153282	4701	4024958	2010-03-24	2010-03-24 00:00:00	2010-03-24	5001	0	\N	0	0	\N	\N	0	313164	0	117015009	4024958		
11249	1083	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	71099	0	6082-2	3000876		
26205	2411	3006322	1995-12-05	1995-12-05 00:00:00	1995-12-05	5001	0	\N	0	0	\N	\N	0	159970	0	8331-1	3006322		
46898	1431	4024958	1961-01-05	1961-01-05 00:00:00	1961-01-05	5001	0	\N	0	0	\N	\N	0	95286	0	117015009	4024958		
159551	4905	4024958	1980-06-19	1980-06-19 00:00:00	1980-06-19	5001	0	\N	0	0	\N	\N	0	326032	0	117015009	4024958		
45655	4214	3051031	1998-01-21	1998-01-21 00:00:00	1998-01-21	5001	0	\N	0	0	\N	\N	0	279760	0	46240-8	3051031		
16056	1468	3006322	1958-09-12	1958-09-12 00:00:00	1958-09-12	5001	0	\N	0	0	\N	\N	0	97851	0	8331-1	3006322		
14268	1328	3011505	2008-02-28	2008-02-28 00:00:00	2008-02-28	5001	0	\N	0	0	\N	\N	0	88212	0	19926-5	3011505		
110710	3418	4024958	2000-09-04	2000-09-04 00:00:00	2000-09-04	5001	0	\N	0	0	\N	\N	0	226717	0	117015009	4024958		
25683	2352	3036780	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	156717	0	6095-4	3036780		
37071	3409	3006322	2017-05-21	2017-05-21 00:00:00	2017-05-21	5001	0	\N	0	0	\N	\N	0	226059	0	8331-1	3006322		
5382	512	3006322	1973-08-15	1973-08-15 00:00:00	1973-08-15	5001	0	\N	0	0	\N	\N	0	34204	0	8331-1	3006322		
31285	2859	3006322	1953-05-29	1953-05-29 00:00:00	1953-05-29	5001	0	\N	0	0	\N	\N	0	190032	0	8331-1	3006322		
23961	2199	3006322	1993-09-05	1993-09-05 00:00:00	1993-09-05	5001	0	\N	0	0	\N	\N	0	146569	0	8331-1	3006322		
7193	700	3009542	2011-06-06	2011-06-06 00:00:00	2011-06-06	5001	0	\N	0	0	\N	\N	0	46242	0	20570-8	3009542		
35387	3240	40766240	1993-05-11	1993-05-11 00:00:00	1993-05-11	5001	0	\N	0	0	\N	\N	0	215413	0	63513-6	40766240		
46740	4305	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	285616	0	6844-5	3020655		
165072	5068	4052083	1969-10-26	1969-10-26 00:00:00	1969-10-26	5001	0	\N	0	0	\N	\N	0	336970	0	23426006	4052083		
58182	5337	3001488	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	355418	0	7258-7	3001488		
57769	5300	3006322	1979-05-28	1979-05-28 00:00:00	1979-05-28	5001	0	\N	0	0	\N	\N	0	352629	0	8331-1	3006322		
26292	822	4024958	1978-09-08	1978-09-08 00:00:00	1978-09-08	5001	0	\N	0	0	\N	\N	0	54490	0	117015009	4024958		
21839	2013	40758406	1957-05-16	1957-05-16 00:00:00	1957-05-16	5001	0	\N	0	0	\N	\N	0	133992	0	55277-8	40758406		
21932	2017	3006322	2011-04-15	2011-04-15 00:00:00	2011-04-15	5001	0	\N	0	0	\N	\N	0	134162	0	8331-1	3006322		
33325	3011	3006322	2003-04-02	2003-04-02 00:00:00	2003-04-02	5001	0	\N	0	0	\N	\N	0	200824	0	8331-1	3006322		
39656	3680	3001247	1979-12-15	1979-12-15 00:00:00	1979-12-15	5001	0	\N	0	0	\N	\N	0	244725	0	6085-5	3001247		
13633	1282	3021226	1977-08-12	1977-08-12 00:00:00	1977-08-12	5001	0	\N	0	0	\N	\N	0	84719	0	6246-3	3021226		
19290	1766	3011505	2009-10-13	2009-10-13 00:00:00	2009-10-13	5001	0	\N	0	0	\N	\N	0	118197	0	19926-5	3011505		
17590	1600	40766240	1947-04-25	1947-04-25 00:00:00	1947-04-25	5001	0	\N	0	0	\N	\N	0	107406	0	63513-6	40766240		
56316	5168	3000963	2015-02-15	2015-02-15 00:00:00	2015-02-15	5001	0	\N	0	0	\N	\N	0	343612	0	718-7	3000963		
36542	3362	3006322	1965-06-26	1965-06-26 00:00:00	1965-06-26	5001	0	\N	0	0	\N	\N	0	222882	0	8331-1	3006322		
36619	3370	3036780	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	223479	0	6095-4	3036780		
22349	2053	3006322	1958-01-19	1958-01-19 00:00:00	1958-01-19	5001	0	\N	0	0	\N	\N	0	136555	0	8331-1	3006322		
24395	760	4052083	1992-12-08	1992-12-08 00:00:00	1992-12-08	5001	0	\N	0	0	\N	\N	0	50496	0	23426006	4052083		
50914	4642	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	309381	0	6248-9	3015076		
50981	4646	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	309845	0	6833-8	3023430		
36251	3335	40758406	2014-08-13	2014-08-13 00:00:00	2014-08-13	5001	0	\N	0	0	\N	\N	0	221248	0	55277-8	40758406		
44071	1356	4024958	1988-01-06	1988-01-06 00:00:00	1988-01-06	5001	0	\N	0	0	\N	\N	0	89886	0	117015009	4024958		
56625	5197	3024731	1962-06-05	1962-06-05 00:00:00	1962-06-05	5001	0	\N	0	0	\N	\N	0	345571	0	30428-7	3024731		
85542	2647	4052083	1974-08-25	1974-08-25 00:00:00	1974-08-25	5001	0	\N	0	0	\N	\N	0	175109	0	23426006	4052083		
46502	4279	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	283952	0	6844-5	3020655		
31476	2878	3006322	1996-10-08	1996-10-08 00:00:00	1996-10-08	5001	0	\N	0	0	\N	\N	0	191460	0	8331-1	3006322		
42782	3957	3051031	1966-02-11	1966-02-11 00:00:00	1966-02-11	5001	0	\N	0	0	\N	\N	0	263098	0	46240-8	3051031		
32391	2942	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	196219	0	6844-5	3020655		
53824	4935	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	328036	0	6095-4	3036780		
11511	1102	3000876	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	72407	0	6082-2	3000876		
12178	1162	40758406	1978-06-14	1978-06-14 00:00:00	1978-06-14	5001	0	\N	0	0	\N	\N	0	76699	0	55277-8	40758406		
163777	5031	4052083	1922-07-28	1922-07-28 00:00:00	1922-07-28	5001	0	\N	0	0	\N	\N	0	334271	0	23426006	4052083		
121095	3739	4024958	1983-09-07	1983-09-07 00:00:00	1983-09-07	5001	0	\N	0	0	\N	\N	0	248445	0	117015009	4024958		
74776	2292	4133840	2017-03-17	2017-03-17 00:00:00	2017-03-17	5001	0	\N	0	0	\N	\N	0	152592	0	127783003	4133840		
11844	376	4024958	1998-08-19	1998-08-19 00:00:00	1998-08-19	5001	0	\N	0	0	\N	\N	0	24919	0	117015009	4024958		
45833	4224	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	280540	0	6844-5	3020655		
50888	1543	4052083	1941-06-19	1941-06-19 00:00:00	1941-06-19	5001	0	\N	0	0	\N	\N	0	103417	0	23426006	4052083		
2677	263	46235214	2002-12-05	2002-12-05 00:00:00	2002-12-05	5001	0	\N	0	0	\N	\N	0	17448	0	76690-7	46235214		
13273	422	4052083	1976-12-08	1976-12-08 00:00:00	1976-12-08	5001	0	\N	0	0	\N	\N	0	27951	0	23426006	4052083		
56027	5142	3006322	1947-06-10	1947-06-10 00:00:00	1947-06-10	5001	0	\N	0	0	\N	\N	0	341704	0	8331-1	3006322		
14139	1322	3006322	1987-10-05	1987-10-05 00:00:00	1987-10-05	5001	0	\N	0	0	\N	\N	0	87773	0	8331-1	3006322		
107513	3315	4024958	1969-07-27	1969-07-27 00:00:00	1969-07-27	5001	0	\N	0	0	\N	\N	0	220165	0	117015009	4024958		
12885	1227	46235214	2014-10-30	2014-10-30 00:00:00	2014-10-30	5001	0	\N	0	0	\N	\N	0	80785	0	76690-7	46235214		
57702	1762	4133840	1999-04-15	1999-04-15 00:00:00	1999-04-15	5001	0	\N	0	0	\N	\N	0	117875	0	127783003	4133840		
35641	3253	3006451	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	216281	0	6273-7	3006451		
12497	403	4024958	1932-12-16	1932-12-16 00:00:00	1932-12-16	5001	0	\N	0	0	\N	\N	0	26431	0	117015009	4024958		
47098	4342	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	287954	0	6189-5	3006734		
23877	747	4052083	1994-06-11	1994-06-11 00:00:00	1994-06-11	5001	0	\N	0	0	\N	\N	0	49471	0	23426006	4052083		
110140	3399	4024958	1996-11-02	1996-11-02 00:00:00	1996-11-02	5001	0	\N	0	0	\N	\N	0	225492	0	117015009	4024958		
153285	4701	4024958	1990-02-25	1990-02-25 00:00:00	1990-02-25	5001	0	\N	0	0	\N	\N	0	313162	0	117015009	4024958		
11250	1083	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	71099	0	6189-5	3006734		
26206	2411	3006322	1987-07-04	1987-07-04 00:00:00	1987-07-04	5001	0	\N	0	0	\N	\N	0	159999	0	8331-1	3006322		
58182	1773	4052083	1969-12-21	1969-12-21 00:00:00	1969-12-21	5001	0	\N	0	0	\N	\N	0	118536	0	23426006	4052083		
159559	4905	4052083	1982-07-11	1982-07-11 00:00:00	1982-07-11	5001	0	\N	0	0	\N	\N	0	326033	0	23426006	4052083		
45658	4214	40758406	1998-01-21	1998-01-21 00:00:00	1998-01-21	5001	0	\N	0	0	\N	\N	0	279760	0	55277-8	40758406		
16057	1468	3006322	2015-04-05	2015-04-05 00:00:00	2015-04-05	5001	0	\N	0	0	\N	\N	0	97813	0	8331-1	3006322		
14269	1328	3011505	2013-03-28	2013-03-28 00:00:00	2013-03-28	5001	0	\N	0	0	\N	\N	0	88233	0	19926-5	3011505		
110716	3418	4024958	1980-12-17	1980-12-17 00:00:00	1980-12-17	5001	0	\N	0	0	\N	\N	0	226715	0	117015009	4024958		
25684	2352	3015076	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	156717	0	6248-9	3015076		
37072	3409	3006322	1959-07-21	1959-07-21 00:00:00	1959-07-21	5001	0	\N	0	0	\N	\N	0	226056	0	8331-1	3006322		
5383	512	3006322	1998-12-16	1998-12-16 00:00:00	1998-12-16	5001	0	\N	0	0	\N	\N	0	34164	0	8331-1	3006322		
31286	2859	3006322	1951-09-27	1951-09-27 00:00:00	1951-09-27	5001	0	\N	0	0	\N	\N	0	190023	0	8331-1	3006322		
23962	2199	3006322	1980-02-21	1980-02-21 00:00:00	1980-02-21	5001	0	\N	0	0	\N	\N	0	146543	0	8331-1	3006322		
7194	700	3000963	2011-06-06	2011-06-06 00:00:00	2011-06-06	5001	0	\N	0	0	\N	\N	0	46242	0	718-7	3000963		
35388	3240	40758406	1993-05-11	1993-05-11 00:00:00	1993-05-11	5001	0	\N	0	0	\N	\N	0	215413	0	55277-8	40758406		
46741	4305	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	285616	0	6206-7	3012494		
26469	2439	3006322	2014-04-24	2014-04-24 00:00:00	2014-04-24	5001	0	\N	0	0	\N	\N	0	161800	0	8331-1	3006322		
58183	5337	3015076	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	355418	0	6248-9	3015076		
57770	5300	3006322	1953-08-07	1953-08-07 00:00:00	1953-08-07	5001	0	\N	0	0	\N	\N	0	352631	0	8331-1	3006322		
26297	822	4024958	1976-08-04	1976-08-04 00:00:00	1976-08-04	5001	0	\N	0	0	\N	\N	0	54489	0	117015009	4024958		
21841	2013	3051031	1957-05-16	1957-05-16 00:00:00	1957-05-16	5001	0	\N	0	0	\N	\N	0	133992	0	46240-8	3051031		
21933	2017	40758406	1970-09-27	1970-09-27 00:00:00	1970-09-27	5001	0	\N	0	0	\N	\N	0	134187	0	55277-8	40758406		
33326	3011	3006322	1975-08-07	1975-08-07 00:00:00	1975-08-07	5001	0	\N	0	0	\N	\N	0	200837	0	8331-1	3006322		
39657	3680	3015076	1979-12-15	1979-12-15 00:00:00	1979-12-15	5001	0	\N	0	0	\N	\N	0	244725	0	6248-9	3015076		
13634	1282	3027231	1977-08-12	1977-08-12 00:00:00	1977-08-12	5001	0	\N	0	0	\N	\N	0	84719	0	6276-0	3027231		
19291	1766	3011505	2014-11-11	2014-11-11 00:00:00	2014-11-11	5001	0	\N	0	0	\N	\N	0	118146	0	19926-5	3011505		
17593	1600	3051031	1947-04-25	1947-04-25 00:00:00	1947-04-25	5001	0	\N	0	0	\N	\N	0	107406	0	46240-8	3051031		
58005	1766	4133840	1996-05-28	1996-05-28 00:00:00	1996-05-28	5001	0	\N	0	0	\N	\N	0	118143	0	127783003	4133840		
36543	3362	3006322	1984-01-17	1984-01-17 00:00:00	1984-01-17	5001	0	\N	0	0	\N	\N	0	222928	0	8331-1	3006322		
36620	3370	3021226	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	223479	0	6246-3	3021226		
22350	2053	3006322	1958-06-05	1958-06-05 00:00:00	1958-06-05	5001	0	\N	0	0	\N	\N	0	136500	0	8331-1	3006322		
127714	3930	4052083	1917-09-14	1917-09-14 00:00:00	1917-09-14	5001	0	\N	0	0	\N	\N	0	261262	0	23426006	4052083		
50915	4642	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	309381	0	6106-9	3014599		
50982	4646	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	309845	0	6158-0	3019406		
36252	3335	40766240	2014-06-14	2014-06-14 00:00:00	2014-06-14	5001	0	\N	0	0	\N	\N	0	221265	0	63513-6	40766240		
6439	197	4024958	1963-09-05	1963-09-05 00:00:00	1963-09-05	5001	0	\N	0	0	\N	\N	0	13568	0	117015009	4024958		
56626	5197	3006923	1962-06-05	1962-06-05 00:00:00	1962-06-05	5001	0	\N	0	0	\N	\N	0	345571	0	1742-6	3006923		
96849	2965	4052083	2000-08-15	2000-08-15 00:00:00	2000-08-15	5001	0	\N	0	0	\N	\N	0	197899	0	23426006	4052083		
46503	4279	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	283952	0	6833-8	3023430		
31477	2878	3006322	1981-09-21	1981-09-21 00:00:00	1981-09-21	5001	0	\N	0	0	\N	\N	0	191469	0	8331-1	3006322		
42783	3957	40766240	1966-02-11	1966-02-11 00:00:00	1966-02-11	5001	0	\N	0	0	\N	\N	0	263098	0	63513-6	40766240		
32392	2942	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	196219	0	6248-9	3015076		
53825	4935	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	328036	0	6106-9	3014599		
11512	1102	3001488	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	72407	0	7258-7	3001488		
12180	1162	3051031	1978-06-14	1978-06-14 00:00:00	1978-06-14	5001	0	\N	0	0	\N	\N	0	76699	0	46240-8	3051031		
1612	144	3006322	2000-09-23	2000-09-23 00:00:00	2000-09-23	5001	0	\N	0	0	\N	\N	0	9622	0	8331-1	3006322		
121097	3739	4024958	1973-09-04	1973-09-04 00:00:00	1973-09-04	5001	0	\N	0	0	\N	\N	0	248438	0	117015009	4024958		
74787	2292	4024958	1997-03-19	1997-03-19 00:00:00	1997-03-19	5001	0	\N	0	0	\N	\N	0	152567	0	117015009	4024958		
11846	376	4024958	1983-11-27	1983-11-27 00:00:00	1983-11-27	5001	0	\N	0	0	\N	\N	0	24903	0	117015009	4024958		
45834	4224	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	280540	0	6833-8	3023430		
50912	1543	4052083	1971-07-21	1971-07-21 00:00:00	1971-07-21	5001	0	\N	0	0	\N	\N	0	103376	0	23426006	4052083		
2678	263	40766240	2002-12-05	2002-12-05 00:00:00	2002-12-05	5001	0	\N	0	0	\N	\N	0	17448	0	63513-6	40766240		
13276	422	4024958	1997-08-19	1997-08-19 00:00:00	1997-08-19	5001	0	\N	0	0	\N	\N	0	27968	0	117015009	4024958		
124405	3843	4052083	1978-02-21	1978-02-21 00:00:00	1978-02-21	5001	0	\N	0	0	\N	\N	0	255062	0	23426006	4052083		
14140	1322	3006322	1954-08-08	1954-08-08 00:00:00	1954-08-08	5001	0	\N	0	0	\N	\N	0	87788	0	8331-1	3006322		
118859	3658	4052083	1983-02-08	1983-02-08 00:00:00	1983-02-08	5001	0	\N	0	0	\N	\N	0	243479	0	23426006	4052083		
12886	1227	40758406	2014-10-30	2014-10-30 00:00:00	2014-10-30	5001	0	\N	0	0	\N	\N	0	80785	0	55277-8	40758406		
57709	1762	4133840	2015-04-16	2015-04-16 00:00:00	2015-04-16	5001	0	\N	0	0	\N	\N	0	117834	0	127783003	4133840		
35642	3253	3000876	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	216281	0	6082-2	3000876		
46924	1431	4052083	2018-07-09	2018-07-09 00:00:00	2018-07-09	5001	0	\N	0	0	\N	\N	0	95353	0	23426006	4052083		
47099	4342	3006322	2013-02-04	2013-02-04 00:00:00	2013-02-04	5001	0	\N	0	0	\N	\N	0	287956	0	8331-1	3006322		
58439	1779	4052083	1956-03-31	1956-03-31 00:00:00	1956-03-31	5001	0	\N	0	0	\N	\N	0	119043	0	23426006	4052083		
110146	3399	4024958	1983-05-12	1983-05-12 00:00:00	1983-05-12	5001	0	\N	0	0	\N	\N	0	225503	0	117015009	4024958		
68495	2094	4024958	1950-08-08	1950-08-08 00:00:00	1950-08-08	5001	0	\N	0	0	\N	\N	0	139601	0	117015009	4024958		
11251	1083	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	71099	0	6085-5	3001247		
26207	2411	3006322	2017-11-04	2017-11-04 00:00:00	2017-11-04	5001	0	\N	0	0	\N	\N	0	159992	0	8331-1	3006322		
81394	2518	4133840	1993-06-11	1993-06-11 00:00:00	1993-06-11	5001	0	\N	0	0	\N	\N	0	166566	0	127783003	4133840		
159567	4907	4024958	1986-04-11	1986-04-11 00:00:00	1986-04-11	5001	0	\N	0	0	\N	\N	0	326132	0	117015009	4024958		
45659	4214	46235214	1998-01-21	1998-01-21 00:00:00	1998-01-21	5001	0	\N	0	0	\N	\N	0	279760	0	76690-7	46235214		
16058	1468	3051031	2016-09-26	2016-09-26 00:00:00	2016-09-26	5001	0	\N	0	0	\N	\N	0	97878	0	46240-8	3051031		
14270	1328	3011505	1987-12-17	1987-12-17 00:00:00	1987-12-17	5001	0	\N	0	0	\N	\N	0	88204	0	19926-5	3011505		
110725	3418	4052083	2008-12-27	2008-12-27 00:00:00	2008-12-27	5001	0	\N	0	0	\N	\N	0	226719	0	23426006	4052083		
25685	2352	3006322	1997-04-10	1997-04-10 00:00:00	1997-04-10	5001	0	\N	0	0	\N	\N	0	156618	0	8331-1	3006322		
37073	3409	3006322	2010-04-28	2010-04-28 00:00:00	2010-04-28	5001	0	\N	0	0	\N	\N	0	226057	0	8331-1	3006322		
5384	512	46235214	1960-03-19	1960-03-19 00:00:00	1960-03-19	5001	0	\N	0	0	\N	\N	0	34172	0	76690-7	46235214		
31287	2859	3006322	2005-04-08	2005-04-08 00:00:00	2005-04-08	5001	0	\N	0	0	\N	\N	0	189981	0	8331-1	3006322		
23963	2200	3006322	1995-09-28	1995-09-28 00:00:00	1995-09-28	5001	0	\N	0	0	\N	\N	0	146639	0	8331-1	3006322		
7195	700	3006322	1991-11-20	1991-11-20 00:00:00	1991-11-20	5001	0	\N	0	0	\N	\N	0	46286	0	8331-1	3006322		
35389	3240	3006322	1970-12-16	1970-12-16 00:00:00	1970-12-16	5001	0	\N	0	0	\N	\N	0	215352	0	8331-1	3006322		
46742	4305	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	285616	0	6158-0	3019406		
26470	2439	3006322	1976-05-29	1976-05-29 00:00:00	1976-05-29	5001	0	\N	0	0	\N	\N	0	161798	0	8331-1	3006322		
58184	5337	3001247	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	355418	0	6085-5	3001247		
57771	5300	3006322	1957-02-28	1957-02-28 00:00:00	1957-02-28	5001	0	\N	0	0	\N	\N	0	352632	0	8331-1	3006322		
26302	822	4024958	1976-03-26	1976-03-26 00:00:00	1976-03-26	5001	0	\N	0	0	\N	\N	0	54480	0	117015009	4024958		
21842	2013	46235214	1957-04-16	1957-04-16 00:00:00	1957-04-16	5001	0	\N	0	0	\N	\N	0	134004	0	76690-7	46235214		
21935	2017	3051031	1970-09-27	1970-09-27 00:00:00	1970-09-27	5001	0	\N	0	0	\N	\N	0	134187	0	46240-8	3051031		
33327	3011	3006322	1994-10-05	1994-10-05 00:00:00	1994-10-05	5001	0	\N	0	0	\N	\N	0	200853	0	8331-1	3006322		
39658	3680	3001488	1979-12-15	1979-12-15 00:00:00	1979-12-15	5001	0	\N	0	0	\N	\N	0	244725	0	7258-7	3001488		
13635	1282	3015076	1977-08-12	1977-08-12 00:00:00	1977-08-12	5001	0	\N	0	0	\N	\N	0	84719	0	6248-9	3015076		
19292	1766	3006322	2007-01-22	2007-01-22 00:00:00	2007-01-22	5001	0	\N	0	0	\N	\N	0	118136	0	8331-1	3006322		
17594	1600	3006322	1959-11-30	1959-11-30 00:00:00	1959-11-30	5001	0	\N	0	0	\N	\N	0	107440	0	8331-1	3006322		
58006	1766	4133840	2006-09-26	2006-09-26 00:00:00	2006-09-26	5001	0	\N	0	0	\N	\N	0	118168	0	127783003	4133840		
36544	3363	3006322	2009-11-25	2009-11-25 00:00:00	2009-11-25	5001	0	\N	0	0	\N	\N	0	222989	0	8331-1	3006322		
36621	3370	3006451	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	223479	0	6273-7	3006451		
22351	2053	40758406	1964-08-23	1964-08-23 00:00:00	1964-08-23	5001	0	\N	0	0	\N	\N	0	136473	0	55277-8	40758406		
127715	3930	4133840	1973-07-28	1973-07-28 00:00:00	1973-07-28	5001	0	\N	0	0	\N	\N	0	261278	0	127783003	4133840		
50916	4642	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	309381	0	6189-5	3006734		
50983	4646	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	309845	0	6276-0	3027231		
36255	3335	3051031	2014-06-14	2014-06-14 00:00:00	2014-06-14	5001	0	\N	0	0	\N	\N	0	221265	0	46240-8	3051031		
17781	558	4024958	1983-09-02	1983-09-02 00:00:00	1983-09-02	5001	0	\N	0	0	\N	\N	0	36985	0	117015009	4024958		
56627	5197	3027970	1962-06-05	1962-06-05 00:00:00	1962-06-05	5001	0	\N	0	0	\N	\N	0	345571	0	10834-0	3027970		
96856	2965	4024958	2006-11-19	2006-11-19 00:00:00	2006-11-19	5001	0	\N	0	0	\N	\N	0	197974	0	117015009	4024958		
46504	4279	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	283952	0	6085-5	3001247		
31478	2878	3006322	1986-10-16	1986-10-16 00:00:00	1986-10-16	5001	0	\N	0	0	\N	\N	0	191459	0	8331-1	3006322		
42785	3957	40766240	1966-03-13	1966-03-13 00:00:00	1966-03-13	5001	0	\N	0	0	\N	\N	0	263043	0	63513-6	40766240		
32393	2942	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	196219	0	6158-0	3019406		
78410	2404	4024958	1969-11-17	1969-11-17 00:00:00	1969-11-17	5001	0	\N	0	0	\N	\N	0	159729	0	117015009	4024958		
11513	1102	3023430	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	72407	0	6833-8	3023430		
12181	1162	40766240	1978-06-14	1978-06-14 00:00:00	1978-06-14	5001	0	\N	0	0	\N	\N	0	76699	0	63513-6	40766240		
1613	144	3006322	1997-10-22	1997-10-22 00:00:00	1997-10-22	5001	0	\N	0	0	\N	\N	0	9620	0	8331-1	3006322		
59335	1808	4024958	1969-06-03	1969-06-03 00:00:00	1969-06-03	5001	0	\N	0	0	\N	\N	0	121047	0	117015009	4024958		
74795	2292	4133840	2013-02-01	2013-02-01 00:00:00	2013-02-01	5001	0	\N	0	0	\N	\N	0	152625	0	127783003	4133840		
11849	376	4024958	1995-10-23	1995-10-23 00:00:00	1995-10-23	5001	0	\N	0	0	\N	\N	0	24918	0	117015009	4024958		
45835	4224	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	280540	0	7258-7	3001488		
50914	1543	4024958	1969-04-25	1969-04-25 00:00:00	1969-04-25	5001	0	\N	0	0	\N	\N	0	103370	0	117015009	4024958		
2681	263	3051031	1999-09-07	1999-09-07 00:00:00	1999-09-07	5001	0	\N	0	0	\N	\N	0	17426	0	46240-8	3051031		
13282	422	4024958	2016-04-28	2016-04-28 00:00:00	2016-04-28	5001	0	\N	0	0	\N	\N	0	27942	0	117015009	4024958		
34768	1084	4024958	1979-08-30	1979-08-30 00:00:00	1979-08-30	5001	0	\N	0	0	\N	\N	0	71237	0	117015009	4024958		
14141	1322	3049273	2003-08-13	2003-08-13 00:00:00	2003-08-13	5001	0	\N	0	0	\N	\N	0	87686	0	38265-5	3049273		
2886	273	3020655	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	18241	0	6844-5	3020655		
12888	1227	40766240	2014-10-30	2014-10-30 00:00:00	2014-10-30	5001	0	\N	0	0	\N	\N	0	80785	0	63513-6	40766240		
57710	1762	4133840	1979-02-01	1979-02-01 00:00:00	1979-02-01	5001	0	\N	0	0	\N	\N	0	117801	0	127783003	4133840		
35643	3253	3001247	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	216281	0	6085-5	3001247		
46942	1432	4024958	1991-05-03	1991-05-03 00:00:00	1991-05-03	5001	0	\N	0	0	\N	\N	0	95409	0	117015009	4024958		
47100	4342	3006322	2010-11-06	2010-11-06 00:00:00	2010-11-06	5001	0	\N	0	0	\N	\N	0	287879	0	8331-1	3006322		
58440	1779	4024958	1975-11-02	1975-11-02 00:00:00	1975-11-02	5001	0	\N	0	0	\N	\N	0	119074	0	117015009	4024958		
156226	4801	4024958	1997-08-04	1997-08-04 00:00:00	1997-08-04	5001	0	\N	0	0	\N	\N	0	319356	0	117015009	4024958		
68501	2094	4052083	1989-12-09	1989-12-09 00:00:00	1989-12-09	5001	0	\N	0	0	\N	\N	0	139595	0	23426006	4052083		
11252	1083	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	71099	0	6844-5	3020655		
77860	2389	4052083	1996-06-11	1996-06-11 00:00:00	1996-06-11	5001	0	\N	0	0	\N	\N	0	158889	0	23426006	4052083		
81399	2518	4133840	2019-02-08	2019-02-08 00:00:00	2019-02-08	5001	0	\N	0	0	\N	\N	0	166528	0	127783003	4133840		
159575	4907	4052083	1949-09-16	1949-09-16 00:00:00	1949-09-16	5001	0	\N	0	0	\N	\N	0	326099	0	23426006	4052083		
45660	4214	40766240	1998-01-21	1998-01-21 00:00:00	1998-01-21	5001	0	\N	0	0	\N	\N	0	279760	0	63513-6	40766240		
16060	1468	46235214	2016-09-26	2016-09-26 00:00:00	2016-09-26	5001	0	\N	0	0	\N	\N	0	97878	0	76690-7	46235214		
14271	1328	3006322	1950-05-03	1950-05-03 00:00:00	1950-05-03	5001	0	\N	0	0	\N	\N	0	88191	0	8331-1	3006322		
110730	3418	4024958	1990-06-14	1990-06-14 00:00:00	1990-06-14	5001	0	\N	0	0	\N	\N	0	226752	0	117015009	4024958		
25699	2356	3006322	2002-04-14	2002-04-14 00:00:00	2002-04-14	5001	0	\N	0	0	\N	\N	0	156886	0	8331-1	3006322		
37074	3409	3006322	2011-06-01	2011-06-01 00:00:00	2011-06-01	5001	0	\N	0	0	\N	\N	0	226097	0	8331-1	3006322		
5385	512	40766240	1960-03-19	1960-03-19 00:00:00	1960-03-19	5001	0	\N	0	0	\N	\N	0	34172	0	63513-6	40766240		
31288	2859	3006322	1972-07-28	1972-07-28 00:00:00	1972-07-28	5001	0	\N	0	0	\N	\N	0	190061	0	8331-1	3006322		
23964	2200	3006322	1978-05-16	1978-05-16 00:00:00	1978-05-16	5001	0	\N	0	0	\N	\N	0	146628	0	8331-1	3006322		
7196	701	3006322	1997-12-14	1997-12-14 00:00:00	1997-12-14	5001	0	\N	0	0	\N	\N	0	46348	0	8331-1	3006322		
35390	3241	3006322	1988-08-15	1988-08-15 00:00:00	1988-08-15	5001	0	\N	0	0	\N	\N	0	215478	0	8331-1	3006322		
46743	4305	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	285616	0	6248-9	3015076		
26477	2442	3006322	2008-09-29	2008-09-29 00:00:00	2008-09-29	5001	0	\N	0	0	\N	\N	0	161933	0	8331-1	3006322		
58185	5337	3006734	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	355418	0	6189-5	3006734		
57773	5301	3006322	1981-07-07	1981-07-07 00:00:00	1981-07-07	5001	0	\N	0	0	\N	\N	0	352732	0	8331-1	3006322		
37600	1169	4024958	2001-03-06	2001-03-06 00:00:00	2001-03-06	5001	0	\N	0	0	\N	\N	0	77032	0	117015009	4024958		
21844	2013	40766240	1957-04-16	1957-04-16 00:00:00	1957-04-16	5001	0	\N	0	0	\N	\N	0	134004	0	63513-6	40766240		
21936	2017	46235214	1970-09-27	1970-09-27 00:00:00	1970-09-27	5001	0	\N	0	0	\N	\N	0	134187	0	76690-7	46235214		
33328	3011	3006322	1978-09-05	1978-09-05 00:00:00	1978-09-05	5001	0	\N	0	0	\N	\N	0	200852	0	8331-1	3006322		
39659	3680	3006451	1979-12-15	1979-12-15 00:00:00	1979-12-15	5001	0	\N	0	0	\N	\N	0	244725	0	6273-7	3006451		
13636	1282	3001247	1977-08-12	1977-08-12 00:00:00	1977-08-12	5001	0	\N	0	0	\N	\N	0	84719	0	6085-5	3001247		
19293	1766	3011505	1987-01-13	1987-01-13 00:00:00	1987-01-13	5001	0	\N	0	0	\N	\N	0	118158	0	19926-5	3011505		
17595	1600	3006322	1967-08-04	1967-08-04 00:00:00	1967-08-04	5001	0	\N	0	0	\N	\N	0	107409	0	8331-1	3006322		
58009	1766	4133840	2004-09-14	2004-09-14 00:00:00	2004-09-14	5001	0	\N	0	0	\N	\N	0	118167	0	127783003	4133840		
36545	3363	3006322	1965-08-02	1965-08-02 00:00:00	1965-08-02	5001	0	\N	0	0	\N	\N	0	222992	0	8331-1	3006322		
36622	3370	3027231	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	223479	0	6276-0	3027231		
56773	5210	46235214	1973-01-05	1973-01-05 00:00:00	1973-01-05	5001	0	\N	0	0	\N	\N	0	346473	0	76690-7	46235214		
127725	3930	4133840	1963-11-23	1963-11-23 00:00:00	1963-11-23	5001	0	\N	0	0	\N	\N	0	261252	0	127783003	4133840		
50917	4642	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	309381	0	6844-5	3020655		
50984	4646	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	309845	0	6106-9	3014599		
36256	3335	40758406	2014-06-14	2014-06-14 00:00:00	2014-06-14	5001	0	\N	0	0	\N	\N	0	221265	0	55277-8	40758406		
63774	1958	4024958	1996-11-26	1996-11-26 00:00:00	1996-11-26	5001	0	\N	0	0	\N	\N	0	130248	0	117015009	4024958		
56628	5197	3016723	1962-06-05	1962-06-05 00:00:00	1962-06-05	5001	0	\N	0	0	\N	\N	0	345571	0	2160-0	3016723		
96858	2965	4052083	2008-11-28	2008-11-28 00:00:00	2008-11-28	5001	0	\N	0	0	\N	\N	0	197900	0	23426006	4052083		
46505	4279	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	283952	0	6075-6	3005136		
31479	2878	3006322	2002-12-30	2002-12-30 00:00:00	2002-12-30	5001	0	\N	0	0	\N	\N	0	191441	0	8331-1	3006322		
42786	3957	46235214	1966-03-13	1966-03-13 00:00:00	1966-03-13	5001	0	\N	0	0	\N	\N	0	263043	0	76690-7	46235214		
32394	2942	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	196219	0	7258-7	3001488		
78422	2404	4052083	1987-05-15	1987-05-15 00:00:00	1987-05-15	5001	0	\N	0	0	\N	\N	0	159771	0	23426006	4052083		
11514	1102	3019406	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	72407	0	6158-0	3019406		
12182	1162	46235214	1978-06-14	1978-06-14 00:00:00	1978-06-14	5001	0	\N	0	0	\N	\N	0	76699	0	76690-7	46235214		
1614	145	3006322	1991-08-21	1991-08-21 00:00:00	1991-08-21	5001	0	\N	0	0	\N	\N	0	9747	0	8331-1	3006322		
12328	1175	3036780	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	77451	0	6095-4	3036780		
74797	2292	4133840	2014-02-07	2014-02-07 00:00:00	2014-02-07	5001	0	\N	0	0	\N	\N	0	152590	0	127783003	4133840		
11859	376	4024958	1991-04-02	1991-04-02 00:00:00	1991-04-02	5001	0	\N	0	0	\N	\N	0	24917	0	117015009	4024958		
45836	4224	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	280540	0	6085-5	3001247		
154272	4731	4024958	1979-10-03	1979-10-03 00:00:00	1979-10-03	5001	0	\N	0	0	\N	\N	0	315228	0	117015009	4024958		
2682	263	40758406	1999-09-07	1999-09-07 00:00:00	1999-09-07	5001	0	\N	0	0	\N	\N	0	17426	0	55277-8	40758406		
13283	422	4024958	1972-09-25	1972-09-25 00:00:00	1972-09-25	5001	0	\N	0	0	\N	\N	0	27948	0	117015009	4024958		
34795	1085	4052083	1965-12-30	1965-12-30 00:00:00	1965-12-30	5001	0	\N	0	0	\N	\N	0	71255	0	23426006	4052083		
25419	2334	3006322	1999-07-23	1999-07-23 00:00:00	1999-07-23	5001	0	\N	0	0	\N	\N	0	155308	0	8331-1	3006322		
2887	273	3023430	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	18241	0	6833-8	3023430		
24166	2220	3049273	2005-02-04	2005-02-04 00:00:00	2005-02-04	5001	0	\N	0	0	\N	\N	0	147792	0	38265-5	3049273		
57713	1762	4133840	1967-10-12	1967-10-12 00:00:00	1967-10-12	5001	0	\N	0	0	\N	\N	0	117814	0	127783003	4133840		
35644	3253	3006734	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	216281	0	6189-5	3006734		
46946	1432	4024958	1962-11-24	1962-11-24 00:00:00	1962-11-24	5001	0	\N	0	0	\N	\N	0	95391	0	117015009	4024958		
47101	4342	3006322	1964-06-01	1964-06-01 00:00:00	1964-06-01	5001	0	\N	0	0	\N	\N	0	287943	0	8331-1	3006322		
86018	2659	4052083	1988-03-15	1988-03-15 00:00:00	1988-03-15	5001	0	\N	0	0	\N	\N	0	176152	0	23426006	4052083		
156229	4801	4052083	2013-03-04	2013-03-04 00:00:00	2013-03-04	5001	0	\N	0	0	\N	\N	0	319359	0	23426006	4052083		
110207	3401	4024958	2007-05-13	2007-05-13 00:00:00	2007-05-13	5001	0	\N	0	0	\N	\N	0	225597	0	117015009	4024958		
11253	1083	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	71099	0	6206-7	3012494		
131040	4032	4024958	2007-06-22	2007-06-22 00:00:00	2007-06-22	5001	0	\N	0	0	\N	\N	0	268283	0	117015009	4024958		
81400	2518	4133840	2009-09-11	2009-09-11 00:00:00	2009-09-11	5001	0	\N	0	0	\N	\N	0	166551	0	127783003	4133840		
159582	4907	4052083	2008-03-18	2008-03-18 00:00:00	2008-03-18	5001	0	\N	0	0	\N	\N	0	326161	0	23426006	4052083		
45661	4214	3006322	2008-01-17	2008-01-17 00:00:00	2008-01-17	5001	0	\N	0	0	\N	\N	0	279796	0	8331-1	3006322		
16061	1468	40766240	2016-09-26	2016-09-26 00:00:00	2016-09-26	5001	0	\N	0	0	\N	\N	0	97878	0	63513-6	40766240		
14279	1332	3006322	1998-06-10	1998-06-10 00:00:00	1998-06-10	5001	0	\N	0	0	\N	\N	0	88367	0	8331-1	3006322		
110732	3418	4052083	1991-07-09	1991-07-09 00:00:00	1991-07-09	5001	0	\N	0	0	\N	\N	0	226716	0	23426006	4052083		
25700	2356	3006322	1983-01-08	1983-01-08 00:00:00	1983-01-08	5001	0	\N	0	0	\N	\N	0	156864	0	8331-1	3006322		
37075	3409	3006322	2017-03-13	2017-03-13 00:00:00	2017-03-13	5001	0	\N	0	0	\N	\N	0	226065	0	8331-1	3006322		
5386	512	3051031	1960-03-19	1960-03-19 00:00:00	1960-03-19	5001	0	\N	0	0	\N	\N	0	34172	0	46240-8	3051031		
31289	2859	3006322	1973-08-02	1973-08-02 00:00:00	1973-08-02	5001	0	\N	0	0	\N	\N	0	189965	0	8331-1	3006322		
23965	2200	3006322	2008-03-06	2008-03-06 00:00:00	2008-03-06	5001	0	\N	0	0	\N	\N	0	146627	0	8331-1	3006322		
7197	701	3006322	1999-10-21	1999-10-21 00:00:00	1999-10-21	5001	0	\N	0	0	\N	\N	0	46311	0	8331-1	3006322		
35391	3241	3006322	1986-05-15	1986-05-15 00:00:00	1986-05-15	5001	0	\N	0	0	\N	\N	0	215541	0	8331-1	3006322		
46744	4305	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	285616	0	6095-4	3036780		
26478	2442	3006322	1977-12-19	1977-12-19 00:00:00	1977-12-19	5001	0	\N	0	0	\N	\N	0	162008	0	8331-1	3006322		
58186	5337	3036780	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	355418	0	6095-4	3036780		
57774	5301	3006322	1998-11-01	1998-11-01 00:00:00	1998-11-01	5001	0	\N	0	0	\N	\N	0	352753	0	8331-1	3006322		
37606	1169	4052083	1937-12-03	1937-12-03 00:00:00	1937-12-03	5001	0	\N	0	0	\N	\N	0	77028	0	23426006	4052083		
21845	2013	40758406	1957-04-16	1957-04-16 00:00:00	1957-04-16	5001	0	\N	0	0	\N	\N	0	134004	0	55277-8	40758406		
21937	2017	40766240	1970-09-27	1970-09-27 00:00:00	1970-09-27	5001	0	\N	0	0	\N	\N	0	134187	0	63513-6	40766240		
33332	3013	3006322	1984-03-13	1984-03-13 00:00:00	1984-03-13	5001	0	\N	0	0	\N	\N	0	200933	0	8331-1	3006322		
39660	3680	40769179	1982-01-28	1982-01-28 00:00:00	1982-01-28	5001	0	\N	0	0	\N	\N	0	244675	0	66519-0	40769179		
13637	1282	3020655	1977-08-12	1977-08-12 00:00:00	1977-08-12	5001	0	\N	0	0	\N	\N	0	84719	0	6844-5	3020655		
19294	1766	3011505	1984-01-10	1984-01-10 00:00:00	1984-01-10	5001	0	\N	0	0	\N	\N	0	118157	0	19926-5	3011505		
17596	1600	46235214	1947-01-25	1947-01-25 00:00:00	1947-01-25	5001	0	\N	0	0	\N	\N	0	107395	0	76690-7	46235214		
58015	1766	4133840	2016-11-22	2016-11-22 00:00:00	2016-11-22	5001	0	\N	0	0	\N	\N	0	118198	0	127783003	4133840		
36546	3363	3006322	1963-03-31	1963-03-31 00:00:00	1963-03-31	5001	0	\N	0	0	\N	\N	0	222942	0	8331-1	3006322		
36623	3370	3005136	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	223479	0	6075-6	3005136		
56774	5210	40766240	1973-01-05	1973-01-05 00:00:00	1973-01-05	5001	0	\N	0	0	\N	\N	0	346473	0	63513-6	40766240		
127727	3930	4024958	1956-06-14	1956-06-14 00:00:00	1956-06-14	5001	0	\N	0	0	\N	\N	0	261265	0	117015009	4024958		
50918	4642	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	309381	0	6833-8	3023430		
50985	4646	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	309845	0	6075-6	3005136		
36257	3335	46235214	2014-06-14	2014-06-14 00:00:00	2014-06-14	5001	0	\N	0	0	\N	\N	0	221265	0	76690-7	46235214		
63775	1958	4052083	1987-09-02	1987-09-02 00:00:00	1987-09-02	5001	0	\N	0	0	\N	\N	0	130257	0	23426006	4052083		
56629	5197	3000963	1962-06-05	1962-06-05 00:00:00	1962-06-05	5001	0	\N	0	0	\N	\N	0	345571	0	718-7	3000963		
96877	2966	4024958	2005-07-08	2005-07-08 00:00:00	2005-07-08	5001	0	\N	0	0	\N	\N	0	198048	0	117015009	4024958		
46506	4279	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	283952	0	6248-9	3015076		
31480	2878	3006322	1998-05-13	1998-05-13 00:00:00	1998-05-13	5001	0	\N	0	0	\N	\N	0	191462	0	8331-1	3006322		
42788	3957	3051031	1966-03-13	1966-03-13 00:00:00	1966-03-13	5001	0	\N	0	0	\N	\N	0	263043	0	46240-8	3051031		
32395	2942	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	196219	0	6189-5	3006734		
78424	2404	4024958	2003-07-14	2003-07-14 00:00:00	2003-07-14	5001	0	\N	0	0	\N	\N	0	159713	0	117015009	4024958		
11515	1102	3027231	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	72407	0	6276-0	3027231		
12183	1162	3006322	1958-07-03	1958-07-03 00:00:00	1958-07-03	5001	0	\N	0	0	\N	\N	0	76676	0	8331-1	3006322		
1615	145	3006322	1951-12-19	1951-12-19 00:00:00	1951-12-19	5001	0	\N	0	0	\N	\N	0	9713	0	8331-1	3006322		
12329	1175	3000876	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	77451	0	6082-2	3000876		
75077	2300	4133840	1999-12-23	1999-12-23 00:00:00	1999-12-23	5001	0	\N	0	0	\N	\N	0	153149	0	127783003	4133840		
11864	376	4024958	1972-01-01	1972-01-01 00:00:00	1972-01-01	5001	0	\N	0	0	\N	\N	0	24901	0	117015009	4024958		
45837	4224	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	280540	0	6189-5	3006734		
154279	4731	4024958	1993-01-04	1993-01-04 00:00:00	1993-01-04	5001	0	\N	0	0	\N	\N	0	315195	0	117015009	4024958		
2683	263	46235214	1999-09-07	1999-09-07 00:00:00	1999-09-07	5001	0	\N	0	0	\N	\N	0	17426	0	76690-7	46235214		
13287	422	4024958	1967-07-13	1967-07-13 00:00:00	1967-07-13	5001	0	\N	0	0	\N	\N	0	27952	0	117015009	4024958		
34796	1085	4024958	1976-05-16	1976-05-16 00:00:00	1976-05-16	5001	0	\N	0	0	\N	\N	0	71251	0	117015009	4024958		
25420	2334	3011505	1987-02-05	1987-02-05 00:00:00	1987-02-05	5001	0	\N	0	0	\N	\N	0	155337	0	19926-5	3011505		
2888	273	3015076	1976-09-25	1976-09-25 00:00:00	1976-09-25	5001	0	\N	0	0	\N	\N	0	18193	0	6248-9	3015076		
24167	2220	3006322	2003-11-06	2003-11-06 00:00:00	2003-11-06	5001	0	\N	0	0	\N	\N	0	147866	0	8331-1	3006322		
57714	1762	4052083	1948-08-22	1948-08-22 00:00:00	1948-08-22	5001	0	\N	0	0	\N	\N	0	117805	0	23426006	4052083		
35645	3253	3001488	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	216281	0	7258-7	3001488		
46947	1432	4024958	1972-05-17	1972-05-17 00:00:00	1972-05-17	5001	0	\N	0	0	\N	\N	0	95414	0	117015009	4024958		
47102	4342	3006322	1980-04-02	1980-04-02 00:00:00	1980-04-02	5001	0	\N	0	0	\N	\N	0	287976	0	8331-1	3006322		
86023	2659	4024958	1979-01-03	1979-01-03 00:00:00	1979-01-03	5001	0	\N	0	0	\N	\N	0	176118	0	117015009	4024958		
156235	4801	4052083	1988-08-24	1988-08-24 00:00:00	1988-08-24	5001	0	\N	0	0	\N	\N	0	319357	0	23426006	4052083		
110211	3401	4024958	1971-03-19	1971-03-19 00:00:00	1971-03-19	5001	0	\N	0	0	\N	\N	0	225601	0	117015009	4024958		
11254	1083	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	71099	0	6248-9	3015076		
131046	4032	4052083	1985-08-21	1985-08-21 00:00:00	1985-08-21	5001	0	\N	0	0	\N	\N	0	268243	0	23426006	4052083		
81405	2518	4133840	2004-08-13	2004-08-13 00:00:00	2004-08-13	5001	0	\N	0	0	\N	\N	0	166574	0	127783003	4133840		
159586	4907	4052083	1959-10-28	1959-10-28 00:00:00	1959-10-28	5001	0	\N	0	0	\N	\N	0	326128	0	23426006	4052083		
45662	4214	3051031	1998-04-21	1998-04-21 00:00:00	1998-04-21	5001	0	\N	0	0	\N	\N	0	279761	0	46240-8	3051031		
16063	1468	40758406	2016-09-26	2016-09-26 00:00:00	2016-09-26	5001	0	\N	0	0	\N	\N	0	97878	0	55277-8	40758406		
14280	1332	3006322	2008-01-29	2008-01-29 00:00:00	2008-01-29	5001	0	\N	0	0	\N	\N	0	88349	0	8331-1	3006322		
87975	2715	4052083	1966-06-14	1966-06-14 00:00:00	1966-06-14	5001	0	\N	0	0	\N	\N	0	180037	0	23426006	4052083		
25701	2357	3006322	1981-01-24	1981-01-24 00:00:00	1981-01-24	5001	0	\N	0	0	\N	\N	0	157019	0	8331-1	3006322		
37076	3410	3006322	1980-07-03	1980-07-03 00:00:00	1980-07-03	5001	0	\N	0	0	\N	\N	0	226189	0	8331-1	3006322		
5387	512	40758406	1960-03-19	1960-03-19 00:00:00	1960-03-19	5001	0	\N	0	0	\N	\N	0	34172	0	55277-8	40758406		
31290	2859	3006322	1948-03-19	1948-03-19 00:00:00	1948-03-19	5001	0	\N	0	0	\N	\N	0	190057	0	8331-1	3006322		
23975	2202	3006322	1978-02-20	1978-02-20 00:00:00	1978-02-20	5001	0	\N	0	0	\N	\N	0	146787	0	8331-1	3006322		
7198	701	3006322	1968-02-07	1968-02-07 00:00:00	1968-02-07	5001	0	\N	0	0	\N	\N	0	46320	0	8331-1	3006322		
35392	3241	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	215501	0	6082-2	3000876		
46745	4305	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	285616	0	6106-9	3014599		
26479	2442	3006322	1978-12-06	1978-12-06 00:00:00	1978-12-06	5001	0	\N	0	0	\N	\N	0	161920	0	8331-1	3006322		
58187	5337	3023430	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	355418	0	6833-8	3023430		
57775	5301	3006322	1955-11-27	1955-11-27 00:00:00	1955-11-27	5001	0	\N	0	0	\N	\N	0	352750	0	8331-1	3006322		
37607	1169	4024958	1952-02-18	1952-02-18 00:00:00	1952-02-18	5001	0	\N	0	0	\N	\N	0	76959	0	117015009	4024958		
21847	2013	3051031	1957-04-16	1957-04-16 00:00:00	1957-04-16	5001	0	\N	0	0	\N	\N	0	134004	0	46240-8	3051031		
21939	2017	3006322	2009-10-09	2009-10-09 00:00:00	2009-10-09	5001	0	\N	0	0	\N	\N	0	134161	0	8331-1	3006322		
33333	3013	3006322	1985-04-19	1985-04-19 00:00:00	1985-04-19	5001	0	\N	0	0	\N	\N	0	200934	0	8331-1	3006322		
39661	3680	40769189	1982-01-28	1982-01-28 00:00:00	1982-01-28	5001	0	\N	0	0	\N	\N	0	244675	0	66529-9	40769189		
13638	1282	3000876	1977-08-12	1977-08-12 00:00:00	1977-08-12	5001	0	\N	0	0	\N	\N	0	84719	0	6082-2	3000876		
19295	1766	3006322	1958-10-10	1958-10-10 00:00:00	1958-10-10	5001	0	\N	0	0	\N	\N	0	118173	0	8331-1	3006322		
17597	1600	40758406	1947-01-25	1947-01-25 00:00:00	1947-01-25	5001	0	\N	0	0	\N	\N	0	107395	0	55277-8	40758406		
58019	1766	4133840	1994-04-26	1994-04-26 00:00:00	1994-04-26	5001	0	\N	0	0	\N	\N	0	118182	0	127783003	4133840		
36547	3364	3006322	1993-10-10	1993-10-10 00:00:00	1993-10-10	5001	0	\N	0	0	\N	\N	0	223073	0	8331-1	3006322		
36624	3370	3015076	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	223479	0	6248-9	3015076		
56776	5210	3006322	2013-07-03	2013-07-03 00:00:00	2013-07-03	5001	0	\N	0	0	\N	\N	0	346468	0	8331-1	3006322		
127729	3930	4133840	1972-07-22	1972-07-22 00:00:00	1972-07-22	5001	0	\N	0	0	\N	\N	0	261271	0	127783003	4133840		
50919	4642	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	309381	0	6082-2	3000876		
50986	4646	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	309845	0	6248-9	3015076		
36258	3335	40758406	2015-02-09	2015-02-09 00:00:00	2015-02-09	5001	0	\N	0	0	\N	\N	0	221250	0	55277-8	40758406		
63782	1958	4024958	1981-05-19	1981-05-19 00:00:00	1981-05-19	5001	0	\N	0	0	\N	\N	0	130255	0	117015009	4024958		
56630	5197	3035995	1962-06-05	1962-06-05 00:00:00	1962-06-05	5001	0	\N	0	0	\N	\N	0	345571	0	6768-6	3035995		
38268	3527	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	234021	0	6206-7	3012494		
46507	4279	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	283952	0	6276-0	3027231		
135278	4167	4052083	2016-01-12	2016-01-12 00:00:00	2016-01-12	5001	0	\N	0	0	\N	\N	0	276926	0	23426006	4052083		
42789	3957	40758406	1966-03-13	1966-03-13 00:00:00	1966-03-13	5001	0	\N	0	0	\N	\N	0	263043	0	55277-8	40758406		
32396	2942	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	196219	0	6082-2	3000876		
78427	2404	4024958	1994-06-14	1994-06-14 00:00:00	1994-06-14	5001	0	\N	0	0	\N	\N	0	159749	0	117015009	4024958		
11516	1102	3021226	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	72407	0	6246-3	3021226		
12184	1162	3006322	1936-11-16	1936-11-16 00:00:00	1936-11-16	5001	0	\N	0	0	\N	\N	0	76696	0	8331-1	3006322		
1616	145	3006322	1952-09-28	1952-09-28 00:00:00	1952-09-28	5001	0	\N	0	0	\N	\N	0	9683	0	8331-1	3006322		
12330	1175	3020655	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	77451	0	6844-5	3020655		
75078	2300	4133840	2013-03-07	2013-03-07 00:00:00	2013-03-07	5001	0	\N	0	0	\N	\N	0	153153	0	127783003	4133840		
11878	377	4024958	1975-05-11	1975-05-11 00:00:00	1975-05-11	5001	0	\N	0	0	\N	\N	0	25009	0	117015009	4024958		
45838	4224	3006322	2005-05-14	2005-05-14 00:00:00	2005-05-14	5001	0	\N	0	0	\N	\N	0	280493	0	8331-1	3006322		
154293	4731	4052083	2014-06-14	2014-06-14 00:00:00	2014-06-14	5001	0	\N	0	0	\N	\N	0	315197	0	23426006	4052083		
2684	263	40766240	1999-09-07	1999-09-07 00:00:00	1999-09-07	5001	0	\N	0	0	\N	\N	0	17426	0	63513-6	40766240		
13290	422	4024958	2009-07-02	2009-07-02 00:00:00	2009-07-02	5001	0	\N	0	0	\N	\N	0	27910	0	117015009	4024958		
34811	1086	4052083	1973-04-02	1973-04-02 00:00:00	1973-04-02	5001	0	\N	0	0	\N	\N	0	71319	0	23426006	4052083		
25421	2334	3011505	1994-03-17	1994-03-17 00:00:00	1994-03-17	5001	0	\N	0	0	\N	\N	0	155291	0	19926-5	3011505		
2889	273	3005136	1976-09-25	1976-09-25 00:00:00	1976-09-25	5001	0	\N	0	0	\N	\N	0	18193	0	6075-6	3005136		
24168	2220	3006322	1989-07-10	1989-07-10 00:00:00	1989-07-10	5001	0	\N	0	0	\N	\N	0	147771	0	8331-1	3006322		
57720	1762	4133840	2007-03-01	2007-03-01 00:00:00	2007-03-01	5001	0	\N	0	0	\N	\N	0	117830	0	127783003	4133840		
35646	3253	3020655	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	216281	0	6844-5	3020655		
46952	1432	4052083	2018-09-16	2018-09-16 00:00:00	2018-09-16	5001	0	\N	0	0	\N	\N	0	95382	0	23426006	4052083		
47103	4342	3006322	1989-12-27	1989-12-27 00:00:00	1989-12-27	5001	0	\N	0	0	\N	\N	0	287944	0	8331-1	3006322		
86046	2661	4024958	1974-10-19	1974-10-19 00:00:00	1974-10-19	5001	0	\N	0	0	\N	\N	0	176382	0	117015009	4024958		
156249	4801	4024958	2011-10-04	2011-10-04 00:00:00	2011-10-04	5001	0	\N	0	0	\N	\N	0	319405	0	117015009	4024958		
167614	5146	4024958	1972-02-23	1972-02-23 00:00:00	1972-02-23	5001	0	\N	0	0	\N	\N	0	342134	0	117015009	4024958		
11255	1083	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	71099	0	6095-4	3036780		
131064	4032	4024958	1968-01-29	1968-01-29 00:00:00	1968-01-29	5001	0	\N	0	0	\N	\N	0	268218	0	117015009	4024958		
159535	4905	4024958	2008-01-21	2008-01-21 00:00:00	2008-01-21	5001	0	\N	0	0	\N	\N	0	326074	0	117015009	4024958		
159590	4907	4024958	1974-01-03	1974-01-03 00:00:00	1974-01-03	5001	0	\N	0	0	\N	\N	0	326157	0	117015009	4024958		
45665	4214	40758406	1998-04-21	1998-04-21 00:00:00	1998-04-21	5001	0	\N	0	0	\N	\N	0	279761	0	55277-8	40758406		
16064	1468	3006322	1977-02-25	1977-02-25 00:00:00	1977-02-25	5001	0	\N	0	0	\N	\N	0	97859	0	8331-1	3006322		
14281	1332	3006322	1951-10-21	1951-10-21 00:00:00	1951-10-21	5001	0	\N	0	0	\N	\N	0	88345	0	8331-1	3006322		
44342	4090	3006322	1971-12-18	1971-12-18 00:00:00	1971-12-18	5001	0	\N	0	0	\N	\N	0	271853	0	8331-1	3006322		
25702	2357	3006322	1958-12-26	1958-12-26 00:00:00	1958-12-26	5001	0	\N	0	0	\N	\N	0	157018	0	8331-1	3006322		
37077	3410	3006322	1967-03-02	1967-03-02 00:00:00	1967-03-02	5001	0	\N	0	0	\N	\N	0	226192	0	8331-1	3006322		
5390	512	46235214	1960-06-17	1960-06-17 00:00:00	1960-06-17	5001	0	\N	0	0	\N	\N	0	34199	0	76690-7	46235214		
31291	2859	3006322	2014-02-03	2014-02-03 00:00:00	2014-02-03	5001	0	\N	0	0	\N	\N	0	189966	0	8331-1	3006322		
23979	2204	3006322	1988-01-01	1988-01-01 00:00:00	1988-01-01	5001	0	\N	0	0	\N	\N	0	146897	0	8331-1	3006322		
7199	701	3006322	1964-04-17	1964-04-17 00:00:00	1964-04-17	5001	0	\N	0	0	\N	\N	0	46319	0	8331-1	3006322		
35393	3241	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	215501	0	6095-4	3036780		
46746	4305	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	285616	0	6273-7	3006451		
26480	2442	3006322	1978-05-30	1978-05-30 00:00:00	1978-05-30	5001	0	\N	0	0	\N	\N	0	161919	0	8331-1	3006322		
58188	5337	3020655	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	355418	0	6844-5	3020655		
57776	5301	3006322	1980-04-03	1980-04-03 00:00:00	1980-04-03	5001	0	\N	0	0	\N	\N	0	352751	0	8331-1	3006322		
129507	3989	4052083	1999-01-26	1999-01-26 00:00:00	1999-01-26	5001	0	\N	0	0	\N	\N	0	265173	0	23426006	4052083		
21848	2013	40758406	1967-09-06	1967-09-06 00:00:00	1967-09-06	5001	0	\N	0	0	\N	\N	0	133957	0	55277-8	40758406		
21940	2017	40758406	1970-12-26	1970-12-26 00:00:00	1970-12-26	5001	0	\N	0	0	\N	\N	0	134188	0	55277-8	40758406		
33334	3013	3006322	1968-05-19	1968-05-19 00:00:00	1968-05-19	5001	0	\N	0	0	\N	\N	0	200931	0	8331-1	3006322		
39662	3680	40769184	1982-01-28	1982-01-28 00:00:00	1982-01-28	5001	0	\N	0	0	\N	\N	0	244675	0	66524-0	40769184		
13639	1282	3001488	1977-08-12	1977-08-12 00:00:00	1977-08-12	5001	0	\N	0	0	\N	\N	0	84719	0	7258-7	3001488		
19296	1766	3011505	2019-04-02	2019-04-02 00:00:00	2019-04-02	5001	0	\N	0	0	\N	\N	0	118199	0	19926-5	3011505		
17598	1600	40766240	1947-01-25	1947-01-25 00:00:00	1947-01-25	5001	0	\N	0	0	\N	\N	0	107395	0	63513-6	40766240		
58021	1766	4133840	2008-10-07	2008-10-07 00:00:00	2008-10-07	5001	0	\N	0	0	\N	\N	0	118169	0	127783003	4133840		
36548	3364	3014599	1977-10-02	1977-10-02 00:00:00	1977-10-02	5001	0	\N	0	0	\N	\N	0	223078	0	6106-9	3014599		
36625	3370	3014599	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	223479	0	6106-9	3014599		
56777	5210	3006322	1978-02-12	1978-02-12 00:00:00	1978-02-12	5001	0	\N	0	0	\N	\N	0	346475	0	8331-1	3006322		
127735	3930	4133840	1964-11-28	1964-11-28 00:00:00	1964-11-28	5001	0	\N	0	0	\N	\N	0	261292	0	127783003	4133840		
50920	4642	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	309381	0	7258-7	3001488		
50987	4646	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	309845	0	6273-7	3006451		
36259	3335	3051031	2015-02-09	2015-02-09 00:00:00	2015-02-09	5001	0	\N	0	0	\N	\N	0	221250	0	46240-8	3051031		
63804	1960	4024958	1935-03-15	1935-03-15 00:00:00	1935-03-15	5001	0	\N	0	0	\N	\N	0	130317	0	117015009	4024958		
56631	5197	3006322	2002-09-27	2002-09-27 00:00:00	2002-09-27	5001	0	\N	0	0	\N	\N	0	345636	0	8331-1	3006322		
38269	3527	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	234021	0	6095-4	3036780		
46508	4279	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	283952	0	6106-9	3014599		
135288	4167	4052083	2002-01-13	2002-01-13 00:00:00	2002-01-13	5001	0	\N	0	0	\N	\N	0	276925	0	23426006	4052083		
42791	3957	40758406	1966-04-12	1966-04-12 00:00:00	1966-04-12	5001	0	\N	0	0	\N	\N	0	263085	0	55277-8	40758406		
32397	2942	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	196219	0	6095-4	3036780		
78443	2406	4024958	1964-03-05	1964-03-05 00:00:00	1964-03-05	5001	0	\N	0	0	\N	\N	0	159830	0	117015009	4024958		
11517	1102	3020655	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	72407	0	6844-5	3020655		
12186	1162	3006322	1931-08-01	1931-08-01 00:00:00	1931-08-01	5001	0	\N	0	0	\N	\N	0	76694	0	8331-1	3006322		
1617	145	3049273	2003-05-17	2003-05-17 00:00:00	2003-05-17	5001	0	\N	0	0	\N	\N	0	9805	0	38265-5	3049273		
12331	1175	3006322	2002-01-06	2002-01-06 00:00:00	2002-01-06	5001	0	\N	0	0	\N	\N	0	77512	0	8331-1	3006322		
75079	2300	4133840	2017-03-30	2017-03-30 00:00:00	2017-03-30	5001	0	\N	0	0	\N	\N	0	153164	0	127783003	4133840		
7622	732	3006322	2008-08-09	2008-08-09 00:00:00	2008-08-09	5001	0	\N	0	0	\N	\N	0	48572	0	8331-1	3006322		
45839	4225	3006322	1991-08-01	1991-08-01 00:00:00	1991-08-01	5001	0	\N	0	0	\N	\N	0	280615	0	8331-1	3006322		
165601	5086	4052083	2009-04-30	2009-04-30 00:00:00	2009-04-30	5001	0	\N	0	0	\N	\N	0	338159	0	23426006	4052083		
13963	1310	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	86613	0	6158-0	3019406		
165713	5094	4024958	1989-10-04	1989-10-04 00:00:00	1989-10-04	5001	0	\N	0	0	\N	\N	0	338443	0	117015009	4024958		
34816	1086	4052083	1990-02-24	1990-02-24 00:00:00	1990-02-24	5001	0	\N	0	0	\N	\N	0	71328	0	23426006	4052083		
25422	2334	3011505	1988-02-11	1988-02-11 00:00:00	1988-02-11	5001	0	\N	0	0	\N	\N	0	155371	0	19926-5	3011505		
2890	273	3012494	1976-09-25	1976-09-25 00:00:00	1976-09-25	5001	0	\N	0	0	\N	\N	0	18193	0	6206-7	3012494		
24169	2222	3006322	2008-02-10	2008-02-10 00:00:00	2008-02-10	5001	0	\N	0	0	\N	\N	0	147927	0	8331-1	3006322		
57722	1762	4133840	2014-04-10	2014-04-10 00:00:00	2014-04-10	5001	0	\N	0	0	\N	\N	0	117812	0	127783003	4133840		
35647	3253	3023430	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	216281	0	6833-8	3023430		
46961	1432	4052083	2012-08-29	2012-08-29 00:00:00	2012-08-29	5001	0	\N	0	0	\N	\N	0	95412	0	23426006	4052083		
47104	4342	3006322	2009-07-28	2009-07-28 00:00:00	2009-07-28	5001	0	\N	0	0	\N	\N	0	287878	0	8331-1	3006322		
86050	2661	4024958	1966-08-21	1966-08-21 00:00:00	1966-08-21	5001	0	\N	0	0	\N	\N	0	176322	0	117015009	4024958		
156250	4801	4024958	1985-06-11	1985-06-11 00:00:00	1985-06-11	5001	0	\N	0	0	\N	\N	0	319403	0	117015009	4024958		
167618	5146	4052083	1947-03-04	1947-03-04 00:00:00	1947-03-04	5001	0	\N	0	0	\N	\N	0	342084	0	23426006	4052083		
11256	1083	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	71099	0	6833-8	3023430		
131068	4032	4052083	2002-11-03	2002-11-03 00:00:00	2002-11-03	5001	0	\N	0	0	\N	\N	0	268282	0	23426006	4052083		
159536	4905	4024958	1977-07-09	1977-07-09 00:00:00	1977-07-09	5001	0	\N	0	0	\N	\N	0	326063	0	117015009	4024958		
159592	4907	4024958	1992-09-14	1992-09-14 00:00:00	1992-09-14	5001	0	\N	0	0	\N	\N	0	326100	0	117015009	4024958		
45666	4214	46235214	1998-04-21	1998-04-21 00:00:00	1998-04-21	5001	0	\N	0	0	\N	\N	0	279761	0	76690-7	46235214		
16065	1468	3006322	1983-01-11	1983-01-11 00:00:00	1983-01-11	5001	0	\N	0	0	\N	\N	0	97861	0	8331-1	3006322		
14283	1332	3006322	1954-06-22	1954-06-22 00:00:00	1954-06-22	5001	0	\N	0	0	\N	\N	0	88354	0	8331-1	3006322		
44343	4090	3006322	1986-10-12	1986-10-12 00:00:00	1986-10-12	5001	0	\N	0	0	\N	\N	0	271851	0	8331-1	3006322		
25703	2357	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	157052	0	6273-7	3006451		
37078	3410	3006322	1993-08-06	1993-08-06 00:00:00	1993-08-06	5001	0	\N	0	0	\N	\N	0	226196	0	8331-1	3006322		
5391	512	40766240	1960-06-17	1960-06-17 00:00:00	1960-06-17	5001	0	\N	0	0	\N	\N	0	34199	0	63513-6	40766240		
31292	2860	3006322	1949-10-21	1949-10-21 00:00:00	1949-10-21	5001	0	\N	0	0	\N	\N	0	190123	0	8331-1	3006322		
23980	2204	3006322	1958-06-18	1958-06-18 00:00:00	1958-06-18	5001	0	\N	0	0	\N	\N	0	146874	0	8331-1	3006322		
7200	701	3006322	1962-05-11	1962-05-11 00:00:00	1962-05-11	5001	0	\N	0	0	\N	\N	0	46318	0	8331-1	3006322		
35394	3241	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	215501	0	6158-0	3019406		
46747	4305	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	285616	0	6085-5	3001247		
26481	2442	3006322	2014-04-12	2014-04-12 00:00:00	2014-04-12	5001	0	\N	0	0	\N	\N	0	161935	0	8331-1	3006322		
42444	1310	4024958	1953-11-02	1953-11-02 00:00:00	1953-11-02	5001	0	\N	0	0	\N	\N	0	86572	0	117015009	4024958		
57777	5301	3006322	1986-03-28	1986-03-28 00:00:00	1986-03-28	5001	0	\N	0	0	\N	\N	0	352752	0	8331-1	3006322		
129514	3989	4052083	1971-01-14	1971-01-14 00:00:00	1971-01-14	5001	0	\N	0	0	\N	\N	0	265169	0	23426006	4052083		
21850	2013	3051031	1967-09-06	1967-09-06 00:00:00	1967-09-06	5001	0	\N	0	0	\N	\N	0	133957	0	46240-8	3051031		
21941	2017	3051031	1970-12-26	1970-12-26 00:00:00	1970-12-26	5001	0	\N	0	0	\N	\N	0	134188	0	46240-8	3051031		
33335	3013	3006322	1963-05-06	1963-05-06 00:00:00	1963-05-06	5001	0	\N	0	0	\N	\N	0	200938	0	8331-1	3006322		
39663	3680	40769194	1982-01-28	1982-01-28 00:00:00	1982-01-28	5001	0	\N	0	0	\N	\N	0	244675	0	66534-9	40769194		
13640	1283	3006322	1959-09-13	1959-09-13 00:00:00	1959-09-13	5001	0	\N	0	0	\N	\N	0	84795	0	8331-1	3006322		
19297	1766	3011505	2007-10-02	2007-10-02 00:00:00	2007-10-02	5001	0	\N	0	0	\N	\N	0	118165	0	19926-5	3011505		
17601	1600	3051031	1947-01-25	1947-01-25 00:00:00	1947-01-25	5001	0	\N	0	0	\N	\N	0	107395	0	46240-8	3051031		
58025	1766	4133840	2011-10-25	2011-10-25 00:00:00	2011-10-25	5001	0	\N	0	0	\N	\N	0	118184	0	127783003	4133840		
36549	3364	3005136	1977-10-02	1977-10-02 00:00:00	1977-10-02	5001	0	\N	0	0	\N	\N	0	223078	0	6075-6	3005136		
36626	3370	3006734	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	223479	0	6189-5	3006734		
56778	5210	3006322	1974-01-26	1974-01-26 00:00:00	1974-01-26	5001	0	\N	0	0	\N	\N	0	346474	0	8331-1	3006322		
127741	3930	4133840	1971-07-17	1971-07-17 00:00:00	1971-07-17	5001	0	\N	0	0	\N	\N	0	261305	0	127783003	4133840		
50921	4642	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	309381	0	6085-5	3001247		
50988	4646	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	309845	0	6206-7	3012494		
36260	3335	46235214	2015-02-09	2015-02-09 00:00:00	2015-02-09	5001	0	\N	0	0	\N	\N	0	221250	0	76690-7	46235214		
63813	1960	4024958	1983-05-27	1983-05-27 00:00:00	1983-05-27	5001	0	\N	0	0	\N	\N	0	130341	0	117015009	4024958		
56632	5197	3006322	1975-09-09	1975-09-09 00:00:00	1975-09-09	5001	0	\N	0	0	\N	\N	0	345581	0	8331-1	3006322		
38270	3527	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	234021	0	6082-2	3000876		
46509	4279	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	283952	0	6095-4	3036780		
135295	4167	4024958	1980-12-11	1980-12-11 00:00:00	1980-12-11	5001	0	\N	0	0	\N	\N	0	276920	0	117015009	4024958		
42793	3957	3051031	1966-04-12	1966-04-12 00:00:00	1966-04-12	5001	0	\N	0	0	\N	\N	0	263085	0	46240-8	3051031		
32398	2943	3006322	2018-05-30	2018-05-30 00:00:00	2018-05-30	5001	0	\N	0	0	\N	\N	0	196281	0	8331-1	3006322		
78447	2406	4024958	1949-05-08	1949-05-08 00:00:00	1949-05-08	5001	0	\N	0	0	\N	\N	0	159804	0	117015009	4024958		
11518	1102	3036780	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	72407	0	6095-4	3036780		
12187	1162	3049273	1993-03-07	1993-03-07 00:00:00	1993-03-07	5001	0	\N	0	0	\N	\N	0	76731	0	38265-5	3049273		
27011	843	4052083	1983-07-26	1983-07-26 00:00:00	1983-07-26	5001	0	\N	0	0	\N	\N	0	55787	0	23426006	4052083		
12332	1175	3006322	1942-07-20	1942-07-20 00:00:00	1942-07-20	5001	0	\N	0	0	\N	\N	0	77544	0	8331-1	3006322		
75081	2300	4133840	2016-03-24	2016-03-24 00:00:00	2016-03-24	5001	0	\N	0	0	\N	\N	0	153146	0	127783003	4133840		
7623	732	3006322	2001-07-04	2001-07-04 00:00:00	2001-07-04	5001	0	\N	0	0	\N	\N	0	48571	0	8331-1	3006322		
45840	4225	3006322	1996-12-15	1996-12-15 00:00:00	1996-12-15	5001	0	\N	0	0	\N	\N	0	280616	0	8331-1	3006322		
165603	5086	4052083	2017-05-23	2017-05-23 00:00:00	2017-05-23	5001	0	\N	0	0	\N	\N	0	338183	0	23426006	4052083		
13964	1310	40769184	1969-03-03	1969-03-03 00:00:00	1969-03-03	5001	0	\N	0	0	\N	\N	0	86584	0	66524-0	40769184		
165716	5094	4024958	1994-09-08	1994-09-08 00:00:00	1994-09-08	5001	0	\N	0	0	\N	\N	0	338471	0	117015009	4024958		
34828	1086	4052083	1980-03-19	1980-03-19 00:00:00	1980-03-19	5001	0	\N	0	0	\N	\N	0	71354	0	23426006	4052083		
25423	2334	3011505	2014-07-10	2014-07-10 00:00:00	2014-07-10	5001	0	\N	0	0	\N	\N	0	155321	0	19926-5	3011505		
2891	273	3006322	2004-11-20	2004-11-20 00:00:00	2004-11-20	5001	0	\N	0	0	\N	\N	0	18280	0	8331-1	3006322		
24170	2222	3006322	1971-09-12	1971-09-12 00:00:00	1971-09-12	5001	0	\N	0	0	\N	\N	0	147895	0	8331-1	3006322		
57724	1762	4133840	1975-10-02	1975-10-02 00:00:00	1975-10-02	5001	0	\N	0	0	\N	\N	0	117839	0	127783003	4133840		
35648	3253	3019406	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	216281	0	6158-0	3019406		
46971	1433	4052083	1978-11-11	1978-11-11 00:00:00	1978-11-11	5001	0	\N	0	0	\N	\N	0	95427	0	23426006	4052083		
47105	4342	3006322	1971-05-06	1971-05-06 00:00:00	1971-05-06	5001	0	\N	0	0	\N	\N	0	287957	0	8331-1	3006322		
143535	4412	4024958	1994-06-27	1994-06-27 00:00:00	1994-06-27	5001	0	\N	0	0	\N	\N	0	293385	0	117015009	4024958		
156253	4802	4024958	2009-08-11	2009-08-11 00:00:00	2009-08-11	5001	0	\N	0	0	\N	\N	0	319439	0	117015009	4024958		
167641	5146	4052083	2000-01-18	2000-01-18 00:00:00	2000-01-18	5001	0	\N	0	0	\N	\N	0	342098	0	23426006	4052083		
11257	1083	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	71173	0	6276-0	3027231		
131069	4032	4052083	1987-02-19	1987-02-19 00:00:00	1987-02-19	5001	0	\N	0	0	\N	\N	0	268272	0	23426006	4052083		
148366	4547	4052083	1943-10-17	1943-10-17 00:00:00	1943-10-17	5001	0	\N	0	0	\N	\N	0	302843	0	23426006	4052083		
159602	4907	4024958	1967-03-26	1967-03-26 00:00:00	1967-03-26	5001	0	\N	0	0	\N	\N	0	326170	0	117015009	4024958		
45667	4214	40766240	1998-04-21	1998-04-21 00:00:00	1998-04-21	5001	0	\N	0	0	\N	\N	0	279761	0	63513-6	40766240		
16066	1468	3006322	1967-09-05	1967-09-05 00:00:00	1967-09-05	5001	0	\N	0	0	\N	\N	0	97853	0	8331-1	3006322		
14284	1333	3006322	2007-06-04	2007-06-04 00:00:00	2007-06-04	5001	0	\N	0	0	\N	\N	0	88466	0	8331-1	3006322		
44344	4090	3006322	1991-04-02	1991-04-02 00:00:00	1991-04-02	5001	0	\N	0	0	\N	\N	0	271846	0	8331-1	3006322		
25704	2357	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	157052	0	6206-7	3012494		
37079	3410	3006322	1969-04-05	1969-04-05 00:00:00	1969-04-05	5001	0	\N	0	0	\N	\N	0	226193	0	8331-1	3006322		
51418	4704	3006322	1970-11-09	1970-11-09 00:00:00	1970-11-09	5001	0	\N	0	0	\N	\N	0	313394	0	8331-1	3006322		
31293	2860	3006322	2013-06-28	2013-06-28 00:00:00	2013-06-28	5001	0	\N	0	0	\N	\N	0	190139	0	8331-1	3006322		
23981	2204	3006322	1982-12-13	1982-12-13 00:00:00	1982-12-13	5001	0	\N	0	0	\N	\N	0	146934	0	8331-1	3006322		
7201	701	3051031	1958-09-30	1958-09-30 00:00:00	1958-09-30	5001	0	\N	0	0	\N	\N	0	46343	0	46240-8	3051031		
35395	3241	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	215501	0	6246-3	3021226		
46748	4305	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	285642	0	6075-6	3005136		
26482	2442	3006322	1979-12-18	1979-12-18 00:00:00	1979-12-18	5001	0	\N	0	0	\N	\N	0	162010	0	8331-1	3006322		
129176	3976	4024958	1967-09-07	1967-09-07 00:00:00	1967-09-07	5001	0	\N	0	0	\N	\N	0	264356	0	117015009	4024958		
57778	5302	3006322	1976-02-10	1976-02-10 00:00:00	1976-02-10	5001	0	\N	0	0	\N	\N	0	352769	0	8331-1	3006322		
129516	3989	4052083	1981-01-13	1981-01-13 00:00:00	1981-01-13	5001	0	\N	0	0	\N	\N	0	265257	0	23426006	4052083		
21851	2013	46235214	1967-09-06	1967-09-06 00:00:00	1967-09-06	5001	0	\N	0	0	\N	\N	0	133957	0	76690-7	46235214		
21942	2017	46235214	1970-12-26	1970-12-26 00:00:00	1970-12-26	5001	0	\N	0	0	\N	\N	0	134188	0	76690-7	46235214		
33336	3013	3006322	1997-09-24	1997-09-24 00:00:00	1997-09-24	5001	0	\N	0	0	\N	\N	0	200941	0	8331-1	3006322		
39682	3686	3006322	2016-08-16	2016-08-16 00:00:00	2016-08-16	5001	0	\N	0	0	\N	\N	0	245068	0	8331-1	3006322		
13641	1283	3006322	1994-11-12	1994-11-12 00:00:00	1994-11-12	5001	0	\N	0	0	\N	\N	0	84829	0	8331-1	3006322		
19298	1766	3011505	2018-03-27	2018-03-27 00:00:00	2018-03-27	5001	0	\N	0	0	\N	\N	0	118150	0	19926-5	3011505		
17602	1600	3006322	1952-10-24	1952-10-24 00:00:00	1952-10-24	5001	0	\N	0	0	\N	\N	0	107438	0	8331-1	3006322		
58065	1769	4024958	1986-09-26	1986-09-26 00:00:00	1986-09-26	5001	0	\N	0	0	\N	\N	0	118294	0	117015009	4024958		
36550	3364	3015076	1977-10-02	1977-10-02 00:00:00	1977-10-02	5001	0	\N	0	0	\N	\N	0	223078	0	6248-9	3015076		
36627	3370	3020655	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	223479	0	6844-5	3020655		
56779	5210	3006322	1982-10-31	1982-10-31 00:00:00	1982-10-31	5001	0	\N	0	0	\N	\N	0	346476	0	8331-1	3006322		
127742	3930	4133840	1967-12-16	1967-12-16 00:00:00	1967-12-16	5001	0	\N	0	0	\N	\N	0	261254	0	127783003	4133840		
50922	4642	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	309381	0	6095-4	3036780		
50989	4646	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	309845	0	6246-3	3021226		
36263	3335	40766240	2015-02-09	2015-02-09 00:00:00	2015-02-09	5001	0	\N	0	0	\N	\N	0	221250	0	63513-6	40766240		
148753	4557	4024958	1934-11-16	1934-11-16 00:00:00	1934-11-16	5001	0	\N	0	0	\N	\N	0	303572	0	117015009	4024958		
56636	5199	3006322	1971-03-31	1971-03-31 00:00:00	1971-03-31	5001	0	\N	0	0	\N	\N	0	345767	0	8331-1	3006322		
38271	3527	3006322	1971-07-03	1971-07-03 00:00:00	1971-07-03	5001	0	\N	0	0	\N	\N	0	234089	0	8331-1	3006322		
46510	4279	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	283952	0	6206-7	3012494		
49710	4520	40766240	1928-06-07	1928-06-07 00:00:00	1928-06-07	5001	0	\N	0	0	\N	\N	0	300896	0	63513-6	40766240		
42795	3957	46235214	1966-04-12	1966-04-12 00:00:00	1966-04-12	5001	0	\N	0	0	\N	\N	0	263085	0	76690-7	46235214		
32399	2943	3006322	1982-12-09	1982-12-09 00:00:00	1982-12-09	5001	0	\N	0	0	\N	\N	0	196270	0	8331-1	3006322		
78449	2406	4052083	1991-03-02	1991-03-02 00:00:00	1991-03-02	5001	0	\N	0	0	\N	\N	0	159806	0	23426006	4052083		
11519	1102	3006451	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	72407	0	6273-7	3006451		
12188	1162	3051031	1978-08-13	1978-08-13 00:00:00	1978-08-13	5001	0	\N	0	0	\N	\N	0	76708	0	46240-8	3051031		
27021	843	4024958	1986-12-23	1986-12-23 00:00:00	1986-12-23	5001	0	\N	0	0	\N	\N	0	55788	0	117015009	4024958		
12333	1175	3006322	1949-01-15	1949-01-15 00:00:00	1949-01-15	5001	0	\N	0	0	\N	\N	0	77546	0	8331-1	3006322		
75082	2300	4133840	1991-12-05	1991-12-05 00:00:00	1991-12-05	5001	0	\N	0	0	\N	\N	0	153142	0	127783003	4133840		
7624	733	3006322	1978-06-15	1978-06-15 00:00:00	1978-06-15	5001	0	\N	0	0	\N	\N	0	48661	0	8331-1	3006322		
45841	4226	3011505	2017-11-19	2017-11-19 00:00:00	2017-11-19	5001	0	\N	0	0	\N	\N	0	280685	0	19926-5	3011505		
1793	49	4052083	2010-04-20	2010-04-20 00:00:00	2010-04-20	5001	0	\N	0	0	\N	\N	0	3534	0	23426006	4052083		
13965	1310	40769189	1969-03-03	1969-03-03 00:00:00	1969-03-03	5001	0	\N	0	0	\N	\N	0	86584	0	66529-9	40769189		
165717	5094	4024958	1990-04-15	1990-04-15 00:00:00	1990-04-15	5001	0	\N	0	0	\N	\N	0	338444	0	117015009	4024958		
34831	1086	4052083	1988-11-23	1988-11-23 00:00:00	1988-11-23	5001	0	\N	0	0	\N	\N	0	71355	0	23426006	4052083		
25424	2334	3011505	1993-03-11	1993-03-11 00:00:00	1993-03-11	5001	0	\N	0	0	\N	\N	0	155359	0	19926-5	3011505		
2892	273	3006734	1976-09-25	1976-09-25 00:00:00	1976-09-25	5001	0	\N	0	0	\N	\N	0	18193	0	6189-5	3006734		
24171	2222	3006322	1986-02-09	1986-02-09 00:00:00	1986-02-09	5001	0	\N	0	0	\N	\N	0	147925	0	8331-1	3006322		
57725	1762	4133840	1964-03-12	1964-03-12 00:00:00	1964-03-12	5001	0	\N	0	0	\N	\N	0	117888	0	127783003	4133840		
35649	3253	3021226	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	216281	0	6246-3	3021226		
46974	1433	4052083	1975-05-28	1975-05-28 00:00:00	1975-05-28	5001	0	\N	0	0	\N	\N	0	95460	0	23426006	4052083		
47106	4342	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	287964	0	6273-7	3006451		
154847	4750	4024958	1973-11-29	1973-11-29 00:00:00	1973-11-29	5001	0	\N	0	0	\N	\N	0	316285	0	117015009	4024958		
167546	5144	4024958	1970-04-30	1970-04-30 00:00:00	1970-04-30	5001	0	\N	0	0	\N	\N	0	341945	0	117015009	4024958		
18867	596	4024958	1951-01-03	1951-01-03 00:00:00	1951-01-03	5001	0	\N	0	0	\N	\N	0	39373	0	117015009	4024958		
11258	1083	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	71173	0	6273-7	3006451		
166593	5117	4024958	1967-09-23	1967-09-23 00:00:00	1967-09-23	5001	0	\N	0	0	\N	\N	0	340127	0	117015009	4024958		
148368	4547	4052083	1994-02-02	1994-02-02 00:00:00	1994-02-02	5001	0	\N	0	0	\N	\N	0	302911	0	23426006	4052083		
159612	4909	4024958	2004-02-17	2004-02-17 00:00:00	2004-02-17	5001	0	\N	0	0	\N	\N	0	326258	0	117015009	4024958		
45668	4214	40766240	1997-12-22	1997-12-22 00:00:00	1997-12-22	5001	0	\N	0	0	\N	\N	0	279780	0	63513-6	40766240		
16067	1468	3006322	1956-02-13	1956-02-13 00:00:00	1956-02-13	5001	0	\N	0	0	\N	\N	0	97850	0	8331-1	3006322		
14285	1333	3006322	2011-11-23	2011-11-23 00:00:00	2011-11-23	5001	0	\N	0	0	\N	\N	0	88420	0	8331-1	3006322		
44345	4091	3006322	1974-04-07	1974-04-07 00:00:00	1974-04-07	5001	0	\N	0	0	\N	\N	0	271946	0	8331-1	3006322		
25705	2357	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	157052	0	6833-8	3023430		
37080	3410	3006322	2017-10-11	2017-10-11 00:00:00	2017-10-11	5001	0	\N	0	0	\N	\N	0	226191	0	8331-1	3006322		
51419	4704	3006322	1968-10-05	1968-10-05 00:00:00	1968-10-05	5001	0	\N	0	0	\N	\N	0	313392	0	8331-1	3006322		
31294	2860	3006322	1980-02-13	1980-02-13 00:00:00	1980-02-13	5001	0	\N	0	0	\N	\N	0	190137	0	8331-1	3006322		
23982	2204	3006322	1984-10-28	1984-10-28 00:00:00	1984-10-28	5001	0	\N	0	0	\N	\N	0	146935	0	8331-1	3006322		
7202	701	46235214	1958-09-30	1958-09-30 00:00:00	1958-09-30	5001	0	\N	0	0	\N	\N	0	46343	0	76690-7	46235214		
35396	3241	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	215501	0	6276-0	3027231		
46749	4305	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	285642	0	6246-3	3021226		
26483	2443	3006322	1975-06-04	1975-06-04 00:00:00	1975-06-04	5001	0	\N	0	0	\N	\N	0	162087	0	8331-1	3006322		
129183	3976	4024958	1989-09-03	1989-09-03 00:00:00	1989-09-03	5001	0	\N	0	0	\N	\N	0	264344	0	117015009	4024958		
57779	5302	3006322	1989-01-15	1989-01-15 00:00:00	1989-01-15	5001	0	\N	0	0	\N	\N	0	352811	0	8331-1	3006322		
129517	3989	4024958	1972-06-18	1972-06-18 00:00:00	1972-06-18	5001	0	\N	0	0	\N	\N	0	265157	0	117015009	4024958		
21853	2013	40766240	1967-09-06	1967-09-06 00:00:00	1967-09-06	5001	0	\N	0	0	\N	\N	0	133957	0	63513-6	40766240		
21944	2017	40766240	1970-12-26	1970-12-26 00:00:00	1970-12-26	5001	0	\N	0	0	\N	\N	0	134188	0	63513-6	40766240		
33337	3013	3006322	2012-04-18	2012-04-18 00:00:00	2012-04-18	5001	0	\N	0	0	\N	\N	0	200895	0	8331-1	3006322		
39683	3686	3006322	1980-01-17	1980-01-17 00:00:00	1980-01-17	5001	0	\N	0	0	\N	\N	0	245066	0	8331-1	3006322		
13642	1283	3006322	2012-07-20	2012-07-20 00:00:00	2012-07-20	5001	0	\N	0	0	\N	\N	0	84800	0	8331-1	3006322		
19299	1766	3011505	1996-05-28	1996-05-28 00:00:00	1996-05-28	5001	0	\N	0	0	\N	\N	0	118143	0	19926-5	3011505		
17603	1600	3006322	1993-04-04	1993-04-04 00:00:00	1993-04-04	5001	0	\N	0	0	\N	\N	0	107413	0	8331-1	3006322		
58077	1769	4052083	1978-06-07	1978-06-07 00:00:00	1978-06-07	5001	0	\N	0	0	\N	\N	0	118293	0	23426006	4052083		
36551	3364	3006451	1977-10-02	1977-10-02 00:00:00	1977-10-02	5001	0	\N	0	0	\N	\N	0	223078	0	6273-7	3006451		
36628	3370	3023430	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	223479	0	6833-8	3023430		
56831	5213	3006322	1943-04-25	1943-04-25 00:00:00	1943-04-25	5001	0	\N	0	0	\N	\N	0	346706	0	8331-1	3006322		
127744	3930	4133840	1976-08-14	1976-08-14 00:00:00	1976-08-14	5001	0	\N	0	0	\N	\N	0	261294	0	127783003	4133840		
50923	4642	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	309381	0	6246-3	3021226		
50990	4646	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	309845	0	6085-5	3001247		
36265	3335	40766240	2015-07-09	2015-07-09 00:00:00	2015-07-09	5001	0	\N	0	0	\N	\N	0	221280	0	63513-6	40766240		
148768	4557	4024958	1965-03-12	1965-03-12 00:00:00	1965-03-12	5001	0	\N	0	0	\N	\N	0	303647	0	117015009	4024958		
56637	5199	3006322	1974-09-25	1974-09-25 00:00:00	1974-09-25	5001	0	\N	0	0	\N	\N	0	345780	0	8331-1	3006322		
38272	3528	3014599	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	234230	0	6106-9	3014599		
46511	4279	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	283952	0	6082-2	3000876		
49711	4520	3051031	1928-06-07	1928-06-07 00:00:00	1928-06-07	5001	0	\N	0	0	\N	\N	0	300896	0	46240-8	3051031		
42796	3957	40766240	1966-04-12	1966-04-12 00:00:00	1966-04-12	5001	0	\N	0	0	\N	\N	0	263085	0	63513-6	40766240		
43689	4032	3006322	1968-01-29	1968-01-29 00:00:00	1968-01-29	5001	0	\N	0	0	\N	\N	0	268218	0	8331-1	3006322		
78451	2406	4024958	1978-08-26	1978-08-26 00:00:00	1978-08-26	5001	0	\N	0	0	\N	\N	0	159851	0	117015009	4024958		
11520	1102	3015076	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	72407	0	6248-9	3015076		
12189	1162	40758406	1978-08-13	1978-08-13 00:00:00	1978-08-13	5001	0	\N	0	0	\N	\N	0	76708	0	55277-8	40758406		
18507	582	4052083	2008-03-23	2008-03-23 00:00:00	2008-03-23	5001	0	\N	0	0	\N	\N	0	38582	0	23426006	4052083		
12334	1175	3006322	2011-01-01	2011-01-01 00:00:00	2011-01-01	5001	0	\N	0	0	\N	\N	0	77541	0	8331-1	3006322		
75084	2300	4133840	1989-11-30	1989-11-30 00:00:00	1989-11-30	5001	0	\N	0	0	\N	\N	0	153196	0	127783003	4133840		
7625	733	3006322	1993-04-11	1993-04-11 00:00:00	1993-04-11	5001	0	\N	0	0	\N	\N	0	48616	0	8331-1	3006322		
45842	4226	3011505	2003-12-28	2003-12-28 00:00:00	2003-12-28	5001	0	\N	0	0	\N	\N	0	280662	0	19926-5	3011505		
1794	49	4024958	2011-06-14	2011-06-14 00:00:00	2011-06-14	5001	0	\N	0	0	\N	\N	0	3565	0	117015009	4024958		
13966	1310	40769179	1969-03-03	1969-03-03 00:00:00	1969-03-03	5001	0	\N	0	0	\N	\N	0	86584	0	66519-0	40769179		
165718	5094	4052083	2006-06-05	2006-06-05 00:00:00	2006-06-05	5001	0	\N	0	0	\N	\N	0	338458	0	23426006	4052083		
34832	1086	4024958	2007-03-07	2007-03-07 00:00:00	2007-03-07	5001	0	\N	0	0	\N	\N	0	71322	0	117015009	4024958		
25425	2334	3011505	1963-02-14	1963-02-14 00:00:00	1963-02-14	5001	0	\N	0	0	\N	\N	0	155368	0	19926-5	3011505		
2893	273	3001488	1976-09-25	1976-09-25 00:00:00	1976-09-25	5001	0	\N	0	0	\N	\N	0	18193	0	7258-7	3001488		
24172	2222	3006322	1987-10-16	1987-10-16 00:00:00	1987-10-16	5001	0	\N	0	0	\N	\N	0	147890	0	8331-1	3006322		
46466	1418	4024958	1978-01-02	1978-01-02 00:00:00	1978-01-02	5001	0	\N	0	0	\N	\N	0	94422	0	117015009	4024958		
35650	3253	3027231	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	216281	0	6276-0	3027231		
46983	1433	4024958	1963-07-18	1963-07-18 00:00:00	1963-07-18	5001	0	\N	0	0	\N	\N	0	95459	0	117015009	4024958		
47107	4342	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	287964	0	6246-3	3021226		
154860	4750	4024958	1998-11-13	1998-11-13 00:00:00	1998-11-13	5001	0	\N	0	0	\N	\N	0	316296	0	117015009	4024958		
167548	5144	4052083	2017-06-03	2017-06-03 00:00:00	2017-06-03	5001	0	\N	0	0	\N	\N	0	341895	0	23426006	4052083		
18877	596	4052083	1958-02-26	1958-02-26 00:00:00	1958-02-26	5001	0	\N	0	0	\N	\N	0	39351	0	23426006	4052083		
11259	1083	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	71173	0	6106-9	3014599		
166603	5117	4052083	1993-07-02	1993-07-02 00:00:00	1993-07-02	5001	0	\N	0	0	\N	\N	0	340070	0	23426006	4052083		
148385	4547	4024958	1951-09-03	1951-09-03 00:00:00	1951-09-03	5001	0	\N	0	0	\N	\N	0	302965	0	117015009	4024958		
159765	4913	4052083	1979-05-24	1979-05-24 00:00:00	1979-05-24	5001	0	\N	0	0	\N	\N	0	326521	0	23426006	4052083		
45669	4214	3051031	1997-12-22	1997-12-22 00:00:00	1997-12-22	5001	0	\N	0	0	\N	\N	0	279780	0	46240-8	3051031		
16068	1468	3006322	2004-06-02	2004-06-02 00:00:00	2004-06-02	5001	0	\N	0	0	\N	\N	0	97812	0	8331-1	3006322		
14286	1333	3006322	1957-12-18	1957-12-18 00:00:00	1957-12-18	5001	0	\N	0	0	\N	\N	0	88440	0	8331-1	3006322		
44346	4091	3006322	1979-12-19	1979-12-19 00:00:00	1979-12-19	5001	0	\N	0	0	\N	\N	0	271947	0	8331-1	3006322		
25706	2357	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	157052	0	6158-0	3019406		
37081	3410	3006322	1970-10-14	1970-10-14 00:00:00	1970-10-14	5001	0	\N	0	0	\N	\N	0	226206	0	8331-1	3006322		
51420	4704	3006322	1982-04-21	1982-04-21 00:00:00	1982-04-21	5001	0	\N	0	0	\N	\N	0	313361	0	8331-1	3006322		
31295	2860	3006322	1944-12-03	1944-12-03 00:00:00	1944-12-03	5001	0	\N	0	0	\N	\N	0	190131	0	8331-1	3006322		
23983	2204	3006322	1966-05-16	1966-05-16 00:00:00	1966-05-16	5001	0	\N	0	0	\N	\N	0	146875	0	8331-1	3006322		
7203	701	40758406	1958-09-30	1958-09-30 00:00:00	1958-09-30	5001	0	\N	0	0	\N	\N	0	46343	0	55277-8	40758406		
35397	3241	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	215501	0	6248-9	3015076		
46750	4305	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	285642	0	7258-7	3001488		
26485	2443	3006322	1962-12-25	1962-12-25 00:00:00	1962-12-25	5001	0	\N	0	0	\N	\N	0	162085	0	8331-1	3006322		
129188	3976	4024958	1994-05-22	1994-05-22 00:00:00	1994-05-22	5001	0	\N	0	0	\N	\N	0	264345	0	117015009	4024958		
57780	5302	3006322	1997-02-17	1997-02-17 00:00:00	1997-02-17	5001	0	\N	0	0	\N	\N	0	352812	0	8331-1	3006322		
129522	3989	4024958	1948-01-25	1948-01-25 00:00:00	1948-01-25	5001	0	\N	0	0	\N	\N	0	265153	0	117015009	4024958		
21854	2013	40758406	1957-08-14	1957-08-14 00:00:00	1957-08-14	5001	0	\N	0	0	\N	\N	0	133993	0	55277-8	40758406		
21947	2020	3006322	1999-11-27	1999-11-27 00:00:00	1999-11-27	5001	0	\N	0	0	\N	\N	0	134246	0	8331-1	3006322		
33338	3013	3006322	1962-12-25	1962-12-25 00:00:00	1962-12-25	5001	0	\N	0	0	\N	\N	0	200937	0	8331-1	3006322		
39688	3689	3006322	1961-12-01	1961-12-01 00:00:00	1961-12-01	5001	0	\N	0	0	\N	\N	0	245227	0	8331-1	3006322		
13643	1283	3006322	1960-11-17	1960-11-17 00:00:00	1960-11-17	5001	0	\N	0	0	\N	\N	0	84796	0	8331-1	3006322		
19300	1766	3006322	1994-04-15	1994-04-15 00:00:00	1994-04-15	5001	0	\N	0	0	\N	\N	0	118147	0	8331-1	3006322		
17607	1602	3006322	1964-05-13	1964-05-13 00:00:00	1964-05-13	5001	0	\N	0	0	\N	\N	0	107528	0	8331-1	3006322		
58085	1770	4052083	1986-06-01	1986-06-01 00:00:00	1986-06-01	5001	0	\N	0	0	\N	\N	0	118400	0	23426006	4052083		
36552	3364	3012494	1977-10-02	1977-10-02 00:00:00	1977-10-02	5001	0	\N	0	0	\N	\N	0	223078	0	6206-7	3012494		
36629	3370	3000876	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	223479	0	6082-2	3000876		
56832	5213	3000963	2018-05-27	2018-05-27 00:00:00	2018-05-27	5001	0	\N	0	0	\N	\N	0	346744	0	718-7	3000963		
127746	3930	4133840	1971-01-02	1971-01-02 00:00:00	1971-01-02	5001	0	\N	0	0	\N	\N	0	261304	0	127783003	4133840		
50924	4642	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	309381	0	6273-7	3006451		
50991	4646	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	309845	0	7258-7	3001488		
36266	3335	3051031	2015-07-09	2015-07-09 00:00:00	2015-07-09	5001	0	\N	0	0	\N	\N	0	221280	0	46240-8	3051031		
34417	1077	4024958	1989-09-28	1989-09-28 00:00:00	1989-09-28	5001	0	\N	0	0	\N	\N	0	70594	0	117015009	4024958		
56638	5200	3006322	1978-12-28	1978-12-28 00:00:00	1978-12-28	5001	0	\N	0	0	\N	\N	0	345933	0	8331-1	3006322		
38273	3528	3005136	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	234230	0	6075-6	3005136		
46512	4279	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	283952	0	6158-0	3019406		
49713	4520	3011505	1968-09-28	1968-09-28 00:00:00	1968-09-28	5001	0	\N	0	0	\N	\N	0	300930	0	19926-5	3011505		
42797	3957	3006322	2013-06-19	2013-06-19 00:00:00	2013-06-19	5001	0	\N	0	0	\N	\N	0	263089	0	8331-1	3006322		
43690	4032	3006322	1971-02-26	1971-02-26 00:00:00	1971-02-26	5001	0	\N	0	0	\N	\N	0	268231	0	8331-1	3006322		
78454	2406	4024958	1975-05-30	1975-05-30 00:00:00	1975-05-30	5001	0	\N	0	0	\N	\N	0	159841	0	117015009	4024958		
11521	1102	3012494	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	72407	0	6206-7	3012494		
12191	1162	40766240	1978-08-13	1978-08-13 00:00:00	1978-08-13	5001	0	\N	0	0	\N	\N	0	76708	0	63513-6	40766240		
18511	582	4052083	1973-09-17	1973-09-17 00:00:00	1973-09-17	5001	0	\N	0	0	\N	\N	0	38571	0	23426006	4052083		
12335	1175	3006322	1947-10-07	1947-10-07 00:00:00	1947-10-07	5001	0	\N	0	0	\N	\N	0	77545	0	8331-1	3006322		
75086	2300	4133840	1986-11-27	1986-11-27 00:00:00	1986-11-27	5001	0	\N	0	0	\N	\N	0	153195	0	127783003	4133840		
7626	733	3006322	1944-12-31	1944-12-31 00:00:00	1944-12-31	5001	0	\N	0	0	\N	\N	0	48652	0	8331-1	3006322		
45843	4226	3005136	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	280641	0	6075-6	3005136		
1799	49	4024958	1973-03-08	1973-03-08 00:00:00	1973-03-08	5001	0	\N	0	0	\N	\N	0	3531	0	117015009	4024958		
13967	1310	40769194	1969-03-03	1969-03-03 00:00:00	1969-03-03	5001	0	\N	0	0	\N	\N	0	86584	0	66534-9	40769194		
165733	5095	4052083	2012-11-27	2012-11-27 00:00:00	2012-11-27	5001	0	\N	0	0	\N	\N	0	338520	0	23426006	4052083		
23603	741	4024958	2010-07-05	2010-07-05 00:00:00	2010-07-05	5001	0	\N	0	0	\N	\N	0	49098	0	117015009	4024958		
25426	2334	3011505	2016-07-21	2016-07-21 00:00:00	2016-07-21	5001	0	\N	0	0	\N	\N	0	155322	0	19926-5	3011505		
2894	273	3021226	1976-09-25	1976-09-25 00:00:00	1976-09-25	5001	0	\N	0	0	\N	\N	0	18193	0	6246-3	3021226		
24194	2226	3006322	1950-03-29	1950-03-29 00:00:00	1950-03-29	5001	0	\N	0	0	\N	\N	0	148074	0	8331-1	3006322		
46475	1418	4052083	2016-12-21	2016-12-21 00:00:00	2016-12-21	5001	0	\N	0	0	\N	\N	0	94458	0	23426006	4052083		
35651	3253	3015076	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	216281	0	6248-9	3015076		
74565	2289	4052083	1977-04-29	1977-04-29 00:00:00	1977-04-29	5001	0	\N	0	0	\N	\N	0	152267	0	23426006	4052083		
47108	4342	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	287964	0	6082-2	3000876		
154883	4750	4024958	1973-02-19	1973-02-19 00:00:00	1973-02-19	5001	0	\N	0	0	\N	\N	0	316284	0	117015009	4024958		
167552	5144	4024958	2013-04-03	2013-04-03 00:00:00	2013-04-03	5001	0	\N	0	0	\N	\N	0	341900	0	117015009	4024958		
18892	597	4024958	2003-06-21	2003-06-21 00:00:00	2003-06-21	5001	0	\N	0	0	\N	\N	0	39447	0	117015009	4024958		
11260	1083	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	71173	0	6075-6	3005136		
166638	5117	4052083	1979-09-17	1979-09-17 00:00:00	1979-09-17	5001	0	\N	0	0	\N	\N	0	340094	0	23426006	4052083		
22628	2075	3006322	2007-02-11	2007-02-11 00:00:00	2007-02-11	5001	0	\N	0	0	\N	\N	0	138031	0	8331-1	3006322		
159779	4913	4052083	1995-12-17	1995-12-17 00:00:00	1995-12-17	5001	0	\N	0	0	\N	\N	0	326558	0	23426006	4052083		
45672	4214	40758406	1997-12-22	1997-12-22 00:00:00	1997-12-22	5001	0	\N	0	0	\N	\N	0	279780	0	55277-8	40758406		
16069	1468	3006322	2009-03-23	2009-03-23 00:00:00	2009-03-23	5001	0	\N	0	0	\N	\N	0	97857	0	8331-1	3006322		
14287	1333	3006322	1969-04-02	1969-04-02 00:00:00	1969-04-02	5001	0	\N	0	0	\N	\N	0	88441	0	8331-1	3006322		
44347	4091	3006322	2010-05-20	2010-05-20 00:00:00	2010-05-20	5001	0	\N	0	0	\N	\N	0	271970	0	8331-1	3006322		
25707	2357	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	157052	0	6095-4	3036780		
37103	3413	3006322	1973-06-23	1973-06-23 00:00:00	1973-06-23	5001	0	\N	0	0	\N	\N	0	226372	0	8331-1	3006322		
51421	4704	3006322	1983-10-27	1983-10-27 00:00:00	1983-10-27	5001	0	\N	0	0	\N	\N	0	313370	0	8331-1	3006322		
31296	2860	3006322	1977-03-21	1977-03-21 00:00:00	1977-03-21	5001	0	\N	0	0	\N	\N	0	190151	0	8331-1	3006322		
23984	2204	3006322	1983-08-20	1983-08-20 00:00:00	1983-08-20	5001	0	\N	0	0	\N	\N	0	146939	0	8331-1	3006322		
7205	701	40766240	1958-09-30	1958-09-30 00:00:00	1958-09-30	5001	0	\N	0	0	\N	\N	0	46343	0	63513-6	40766240		
35398	3241	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	215501	0	6106-9	3014599		
46751	4305	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	285642	0	6189-5	3006734		
26486	2443	3006322	1980-08-20	1980-08-20 00:00:00	1980-08-20	5001	0	\N	0	0	\N	\N	0	162038	0	8331-1	3006322		
90288	2788	4024958	1979-01-14	1979-01-14 00:00:00	1979-01-14	5001	0	\N	0	0	\N	\N	0	184730	0	117015009	4024958		
57781	5302	3006322	2004-11-19	2004-11-19 00:00:00	2004-11-19	5001	0	\N	0	0	\N	\N	0	352781	0	8331-1	3006322		
129526	3989	4024958	1935-02-09	1935-02-09 00:00:00	1935-02-09	5001	0	\N	0	0	\N	\N	0	265149	0	117015009	4024958		
21856	2013	40766240	1957-08-14	1957-08-14 00:00:00	1957-08-14	5001	0	\N	0	0	\N	\N	0	133993	0	63513-6	40766240		
21948	2020	3006322	1974-05-15	1974-05-15 00:00:00	1974-05-15	5001	0	\N	0	0	\N	\N	0	134267	0	8331-1	3006322		
33339	3013	3049273	2014-05-05	2014-05-05 00:00:00	2014-05-05	5001	0	\N	0	0	\N	\N	0	200967	0	38265-5	3049273		
39690	3689	3051031	1962-07-26	1962-07-26 00:00:00	1962-07-26	5001	0	\N	0	0	\N	\N	0	245210	0	46240-8	3051031		
13644	1283	3027970	1972-04-22	1972-04-22 00:00:00	1972-04-22	5001	0	\N	0	0	\N	\N	0	84823	0	10834-0	3027970		
19301	1766	3011505	2012-10-30	2012-10-30 00:00:00	2012-10-30	5001	0	\N	0	0	\N	\N	0	118145	0	19926-5	3011505		
17608	1602	3006322	2006-08-07	2006-08-07 00:00:00	2006-08-07	5001	0	\N	0	0	\N	\N	0	107506	0	8331-1	3006322		
10747	1046	3006322	2016-07-29	2016-07-29 00:00:00	2016-07-29	5001	0	\N	0	0	\N	\N	0	68706	0	8331-1	3006322		
36553	3364	3021226	1977-10-02	1977-10-02 00:00:00	1977-10-02	5001	0	\N	0	0	\N	\N	0	223078	0	6246-3	3021226		
36630	3370	3001488	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	223479	0	7258-7	3001488		
56833	5213	3009542	2018-05-27	2018-05-27 00:00:00	2018-05-27	5001	0	\N	0	0	\N	\N	0	346744	0	20570-8	3009542		
127747	3930	4024958	1947-10-13	1947-10-13 00:00:00	1947-10-13	5001	0	\N	0	0	\N	\N	0	261241	0	117015009	4024958		
50925	4642	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	309381	0	6206-7	3012494		
50992	4646	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	309845	0	6189-5	3006734		
36267	3335	40758406	2015-07-09	2015-07-09 00:00:00	2015-07-09	5001	0	\N	0	0	\N	\N	0	221280	0	55277-8	40758406		
34420	1077	4052083	1983-10-06	1983-10-06 00:00:00	1983-10-06	5001	0	\N	0	0	\N	\N	0	70651	0	23426006	4052083		
56639	5200	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	345902	0	6082-2	3000876		
38274	3528	3015076	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	234230	0	6248-9	3015076		
46513	4279	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	283952	0	6246-3	3021226		
49714	4520	3011505	1976-10-16	1976-10-16 00:00:00	1976-10-16	5001	0	\N	0	0	\N	\N	0	300931	0	19926-5	3011505		
42798	3957	40758406	1966-01-12	1966-01-12 00:00:00	1966-01-12	5001	0	\N	0	0	\N	\N	0	263084	0	55277-8	40758406		
43691	4032	3006322	1989-12-14	1989-12-14 00:00:00	1989-12-14	5001	0	\N	0	0	\N	\N	0	268273	0	8331-1	3006322		
117521	3621	4133840	1981-09-12	1981-09-12 00:00:00	1981-09-12	5001	0	\N	0	0	\N	\N	0	240603	0	127783003	4133840		
11522	1102	3005136	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	72407	0	6075-6	3005136		
12193	1162	46235214	1978-08-13	1978-08-13 00:00:00	1978-08-13	5001	0	\N	0	0	\N	\N	0	76708	0	76690-7	46235214		
18515	582	4024958	1971-12-23	1971-12-23 00:00:00	1971-12-23	5001	0	\N	0	0	\N	\N	0	38589	0	117015009	4024958		
12336	1175	3021226	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	77538	0	6246-3	3021226		
75088	2300	4133840	1972-12-07	1972-12-07 00:00:00	1972-12-07	5001	0	\N	0	0	\N	\N	0	153198	0	127783003	4133840		
7627	733	3006322	1956-04-29	1956-04-29 00:00:00	1956-04-29	5001	0	\N	0	0	\N	\N	0	48609	0	8331-1	3006322		
45844	4226	3015076	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	280641	0	6248-9	3015076		
1844	53	4024958	1964-10-06	1964-10-06 00:00:00	1964-10-06	5001	0	\N	0	0	\N	\N	0	3658	0	117015009	4024958		
13968	1310	3006322	1953-11-02	1953-11-02 00:00:00	1953-11-02	5001	0	\N	0	0	\N	\N	0	86572	0	8331-1	3006322		
165745	5095	4052083	2016-05-02	2016-05-02 00:00:00	2016-05-02	5001	0	\N	0	0	\N	\N	0	338549	0	23426006	4052083		
23605	741	4052083	1992-11-25	1992-11-25 00:00:00	1992-11-25	5001	0	\N	0	0	\N	\N	0	49067	0	23426006	4052083		
25427	2334	3011505	2007-05-31	2007-05-31 00:00:00	2007-05-31	5001	0	\N	0	0	\N	\N	0	155279	0	19926-5	3011505		
2895	273	3014599	1976-09-25	1976-09-25 00:00:00	1976-09-25	5001	0	\N	0	0	\N	\N	0	18193	0	6106-9	3014599		
24195	2226	3006322	1949-08-17	1949-08-17 00:00:00	1949-08-17	5001	0	\N	0	0	\N	\N	0	148117	0	8331-1	3006322		
57820	1762	4024958	1952-08-01	1952-08-01 00:00:00	1952-08-01	5001	0	\N	0	0	\N	\N	0	117891	0	117015009	4024958		
35652	3253	3014599	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	216281	0	6106-9	3014599		
74593	2289	4024958	1972-07-01	1972-07-01 00:00:00	1972-07-01	5001	0	\N	0	0	\N	\N	0	152283	0	117015009	4024958		
47109	4342	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	287964	0	6276-0	3027231		
155015	4754	4052083	1968-07-03	1968-07-03 00:00:00	1968-07-03	5001	0	\N	0	0	\N	\N	0	316653	0	23426006	4052083		
141917	4370	4024958	1968-04-04	1968-04-04 00:00:00	1968-04-04	5001	0	\N	0	0	\N	\N	0	290111	0	117015009	4024958		
18893	597	4024958	1970-06-30	1970-06-30 00:00:00	1970-06-30	5001	0	\N	0	0	\N	\N	0	39446	0	117015009	4024958		
11261	1083	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	71173	0	7258-7	3001488		
166782	5119	4052083	1985-04-02	1985-04-02 00:00:00	1985-04-02	5001	0	\N	0	0	\N	\N	0	340351	0	23426006	4052083		
22629	2075	3006322	2009-11-07	2009-11-07 00:00:00	2009-11-07	5001	0	\N	0	0	\N	\N	0	138021	0	8331-1	3006322		
159790	4913	4024958	2018-03-02	2018-03-02 00:00:00	2018-03-02	5001	0	\N	0	0	\N	\N	0	326534	0	117015009	4024958		
45673	4214	46235214	1997-12-22	1997-12-22 00:00:00	1997-12-22	5001	0	\N	0	0	\N	\N	0	279780	0	76690-7	46235214		
142633	4382	4024958	1963-05-10	1963-05-10 00:00:00	1963-05-10	5001	0	\N	0	0	\N	\N	0	291205	0	117015009	4024958		
14288	1333	3006322	1978-03-26	1978-03-26 00:00:00	1978-03-26	5001	0	\N	0	0	\N	\N	0	88453	0	8331-1	3006322		
44348	4091	3006322	1973-05-29	1973-05-29 00:00:00	1973-05-29	5001	0	\N	0	0	\N	\N	0	271986	0	8331-1	3006322		
25708	2357	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	157052	0	7258-7	3001488		
37104	3413	3006322	1988-05-28	1988-05-28 00:00:00	1988-05-28	5001	0	\N	0	0	\N	\N	0	226380	0	8331-1	3006322		
51422	4704	3006322	1990-06-07	1990-06-07 00:00:00	1990-06-07	5001	0	\N	0	0	\N	\N	0	313396	0	8331-1	3006322		
31297	2860	3006322	1953-11-14	1953-11-14 00:00:00	1953-11-14	5001	0	\N	0	0	\N	\N	0	190133	0	8331-1	3006322		
23985	2204	3006322	1949-09-25	1949-09-25 00:00:00	1949-09-25	5001	0	\N	0	0	\N	\N	0	146929	0	8331-1	3006322		
146528	4496	4024958	1970-01-26	1970-01-26 00:00:00	1970-01-26	5001	0	\N	0	0	\N	\N	0	299311	0	117015009	4024958		
35399	3241	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	215501	0	7258-7	3001488		
46752	4305	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	285642	0	6833-8	3023430		
26487	2443	3006322	2016-11-02	2016-11-02 00:00:00	2016-11-02	5001	0	\N	0	0	\N	\N	0	162061	0	8331-1	3006322		
18787	1727	3013721	1982-03-24	1982-03-24 00:00:00	1982-03-24	5001	0	\N	0	0	\N	\N	0	115482	0	1920-8	3013721		
57787	5306	3006322	1992-10-29	1992-10-29 00:00:00	1992-10-29	5001	0	\N	0	0	\N	\N	0	352924	0	8331-1	3006322		
129542	3989	4052083	1978-04-09	1978-04-09 00:00:00	1978-04-09	5001	0	\N	0	0	\N	\N	0	265159	0	23426006	4052083		
21857	2013	46235214	1957-08-14	1957-08-14 00:00:00	1957-08-14	5001	0	\N	0	0	\N	\N	0	133993	0	76690-7	46235214		
21949	2020	3006322	1983-12-06	1983-12-06 00:00:00	1983-12-06	5001	0	\N	0	0	\N	\N	0	134278	0	8331-1	3006322		
33340	3014	3006322	1990-11-29	1990-11-29 00:00:00	1990-11-29	5001	0	\N	0	0	\N	\N	0	201018	0	8331-1	3006322		
39691	3689	46235214	1962-07-26	1962-07-26 00:00:00	1962-07-26	5001	0	\N	0	0	\N	\N	0	245210	0	76690-7	46235214		
13645	1283	3009542	1972-04-22	1972-04-22 00:00:00	1972-04-22	5001	0	\N	0	0	\N	\N	0	84823	0	20570-8	3009542		
19302	1766	3011505	2000-06-06	2000-06-06 00:00:00	2000-06-06	5001	0	\N	0	0	\N	\N	0	118183	0	19926-5	3011505		
17609	1602	3006322	1971-11-19	1971-11-19 00:00:00	1971-11-19	5001	0	\N	0	0	\N	\N	0	107540	0	8331-1	3006322		
10748	1046	3006322	1972-11-03	1972-11-03 00:00:00	1972-11-03	5001	0	\N	0	0	\N	\N	0	68701	0	8331-1	3006322		
36554	3364	3001247	1977-10-02	1977-10-02 00:00:00	1977-10-02	5001	0	\N	0	0	\N	\N	0	223078	0	6085-5	3001247		
36631	3370	3006322	1976-06-08	1976-06-08 00:00:00	1976-06-08	5001	0	\N	0	0	\N	\N	0	223396	0	8331-1	3006322		
56834	5213	3006322	1949-10-01	1949-10-01 00:00:00	1949-10-01	5001	0	\N	0	0	\N	\N	0	346694	0	8331-1	3006322		
127748	3930	4133840	1966-12-10	1966-12-10 00:00:00	1966-12-10	5001	0	\N	0	0	\N	\N	0	261293	0	127783003	4133840		
50926	4642	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	309381	0	6158-0	3019406		
50993	4646	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	309845	0	6082-2	3000876		
36268	3335	46235214	2015-07-09	2015-07-09 00:00:00	2015-07-09	5001	0	\N	0	0	\N	\N	0	221280	0	76690-7	46235214		
34422	1077	4052083	1999-08-14	1999-08-14 00:00:00	1999-08-14	5001	0	\N	0	0	\N	\N	0	70642	0	23426006	4052083		
56640	5200	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	345902	0	6075-6	3005136		
38275	3528	3006451	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	234230	0	6273-7	3006451		
46514	4279	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	283952	0	6273-7	3006451		
49715	4520	3011505	1992-01-11	1992-01-11 00:00:00	1992-01-11	5001	0	\N	0	0	\N	\N	0	300935	0	19926-5	3011505		
42800	3957	3051031	1966-01-12	1966-01-12 00:00:00	1966-01-12	5001	0	\N	0	0	\N	\N	0	263084	0	46240-8	3051031		
43692	4032	3006322	1975-03-20	1975-03-20 00:00:00	1975-03-20	5001	0	\N	0	0	\N	\N	0	268189	0	8331-1	3006322		
117522	3621	4133840	1987-10-17	1987-10-17 00:00:00	1987-10-17	5001	0	\N	0	0	\N	\N	0	240595	0	127783003	4133840		
11523	1102	3014599	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	72407	0	6106-9	3014599		
12194	1162	3006322	1981-09-24	1981-09-24 00:00:00	1981-09-24	5001	0	\N	0	0	\N	\N	0	76700	0	8331-1	3006322		
18521	582	4024958	1971-11-09	1971-11-09 00:00:00	1971-11-09	5001	0	\N	0	0	\N	\N	0	38570	0	117015009	4024958		
12337	1175	3005136	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	77538	0	6075-6	3005136		
75090	2300	4133840	2011-02-24	2011-02-24 00:00:00	2011-02-24	5001	0	\N	0	0	\N	\N	0	153152	0	127783003	4133840		
7628	733	3006322	1947-09-28	1947-09-28 00:00:00	1947-09-28	5001	0	\N	0	0	\N	\N	0	48679	0	8331-1	3006322		
67218	2063	4024958	2017-07-27	2017-07-27 00:00:00	2017-07-27	5001	0	\N	0	0	\N	\N	0	137211	0	117015009	4024958		
1854	53	4052083	1992-11-06	1992-11-06 00:00:00	1992-11-06	5001	0	\N	0	0	\N	\N	0	3654	0	23426006	4052083		
83834	2591	4052083	2017-11-22	2017-11-22 00:00:00	2017-11-22	5001	0	\N	0	0	\N	\N	0	171458	0	23426006	4052083		
165747	5095	4052083	1985-06-20	1985-06-20 00:00:00	1985-06-20	5001	0	\N	0	0	\N	\N	0	338548	0	23426006	4052083		
22057	2025	3006322	1956-06-18	1956-06-18 00:00:00	1956-06-18	5001	0	\N	0	0	\N	\N	0	134667	0	8331-1	3006322		
25428	2334	3011505	1974-05-09	1974-05-09 00:00:00	1974-05-09	5001	0	\N	0	0	\N	\N	0	155334	0	19926-5	3011505		
2896	273	3006451	1976-09-25	1976-09-25 00:00:00	1976-09-25	5001	0	\N	0	0	\N	\N	0	18193	0	6273-7	3006451		
24196	2226	3006322	1999-03-09	1999-03-09 00:00:00	1999-03-09	5001	0	\N	0	0	\N	\N	0	148120	0	8331-1	3006322		
57824	1762	4133840	2013-04-04	2013-04-04 00:00:00	2013-04-04	5001	0	\N	0	0	\N	\N	0	117833	0	127783003	4133840		
35653	3253	3036780	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	216281	0	6095-4	3036780		
74595	2289	4052083	1955-11-01	1955-11-01 00:00:00	1955-11-01	5001	0	\N	0	0	\N	\N	0	152260	0	23426006	4052083		
47110	4342	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	287964	0	6248-9	3015076		
155019	4754	4052083	1971-08-12	1971-08-12 00:00:00	1971-08-12	5001	0	\N	0	0	\N	\N	0	316640	0	23426006	4052083		
141925	4370	4052083	1993-05-17	1993-05-17 00:00:00	1993-05-17	5001	0	\N	0	0	\N	\N	0	290129	0	23426006	4052083		
18908	597	4052083	1964-11-29	1964-11-29 00:00:00	1964-11-29	5001	0	\N	0	0	\N	\N	0	39417	0	23426006	4052083		
11262	1083	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	71173	0	6246-3	3021226		
166783	5119	4052083	2000-09-24	2000-09-24 00:00:00	2000-09-24	5001	0	\N	0	0	\N	\N	0	340383	0	23426006	4052083		
22630	2075	3051031	2002-12-21	2002-12-21 00:00:00	2002-12-21	5001	0	\N	0	0	\N	\N	0	138030	0	46240-8	3051031		
11015	349	4024958	1968-07-02	1968-07-02 00:00:00	1968-07-02	5001	0	\N	0	0	\N	\N	0	23204	0	117015009	4024958		
45674	4214	3006322	1986-07-11	1986-07-11 00:00:00	1986-07-11	5001	0	\N	0	0	\N	\N	0	279774	0	8331-1	3006322		
142636	4382	4024958	1967-08-31	1967-08-31 00:00:00	1967-08-31	5001	0	\N	0	0	\N	\N	0	291267	0	117015009	4024958		
14289	1334	3006322	1991-01-03	1991-01-03 00:00:00	1991-01-03	5001	0	\N	0	0	\N	\N	0	88538	0	8331-1	3006322		
44349	4091	3006322	2016-04-05	2016-04-05 00:00:00	2016-04-05	5001	0	\N	0	0	\N	\N	0	271994	0	8331-1	3006322		
25709	2357	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	157052	0	6082-2	3000876		
37105	3413	3006322	1976-07-18	1976-07-18 00:00:00	1976-07-18	5001	0	\N	0	0	\N	\N	0	226374	0	8331-1	3006322		
51423	4705	3006322	1989-02-11	1989-02-11 00:00:00	1989-02-11	5001	0	\N	0	0	\N	\N	0	313478	0	8331-1	3006322		
31298	2860	3049273	2001-11-01	2001-11-01 00:00:00	2001-11-01	5001	0	\N	0	0	\N	\N	0	190130	0	38265-5	3049273		
31936	2915	46235214	2011-08-19	2011-08-19 00:00:00	2011-08-19	5001	0	\N	0	0	\N	\N	0	194276	0	76690-7	46235214		
146550	4497	4052083	1978-03-06	1978-03-06 00:00:00	1978-03-06	5001	0	\N	0	0	\N	\N	0	299397	0	23426006	4052083		
35400	3241	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	215501	0	6844-5	3020655		
46753	4305	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	285642	0	6276-0	3027231		
26488	2443	3006322	1986-03-04	1986-03-04 00:00:00	1986-03-04	5001	0	\N	0	0	\N	\N	0	162073	0	8331-1	3006322		
18788	1727	21494966	1982-03-24	1982-03-24 00:00:00	1982-03-24	5001	0	\N	0	0	\N	\N	0	115482	0	80271-0	21494966		
57788	5306	3006322	1983-12-03	1983-12-03 00:00:00	1983-12-03	5001	0	\N	0	0	\N	\N	0	352923	0	8331-1	3006322		
129543	3989	4024958	1996-11-05	1996-11-05 00:00:00	1996-11-05	5001	0	\N	0	0	\N	\N	0	265172	0	117015009	4024958		
21859	2013	3051031	1957-08-14	1957-08-14 00:00:00	1957-08-14	5001	0	\N	0	0	\N	\N	0	133993	0	46240-8	3051031		
21950	2020	3006322	2015-05-20	2015-05-20 00:00:00	2015-05-20	5001	0	\N	0	0	\N	\N	0	134284	0	8331-1	3006322		
23769	742	4133840	1994-05-02	1994-05-02 00:00:00	1994-05-02	5001	0	\N	0	0	\N	\N	0	49179	0	127783003	4133840		
39692	3689	40766240	1962-07-26	1962-07-26 00:00:00	1962-07-26	5001	0	\N	0	0	\N	\N	0	245210	0	63513-6	40766240		
13646	1283	3028833	1972-04-22	1972-04-22 00:00:00	1972-04-22	5001	0	\N	0	0	\N	\N	0	84823	0	42719-5	3028833		
19303	1766	3011505	2004-09-14	2004-09-14 00:00:00	2004-09-14	5001	0	\N	0	0	\N	\N	0	118167	0	19926-5	3011505		
17610	1602	3006322	1973-12-19	1973-12-19 00:00:00	1973-12-19	5001	0	\N	0	0	\N	\N	0	107502	0	8331-1	3006322		
10749	1046	3006322	1984-08-25	1984-08-25 00:00:00	1984-08-25	5001	0	\N	0	0	\N	\N	0	68649	0	8331-1	3006322		
36555	3364	3001488	1977-10-02	1977-10-02 00:00:00	1977-10-02	5001	0	\N	0	0	\N	\N	0	223078	0	7258-7	3001488		
36632	3370	3036780	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	223481	0	6095-4	3036780		
56835	5213	3006322	1985-02-23	1985-02-23 00:00:00	1985-02-23	5001	0	\N	0	0	\N	\N	0	346765	0	8331-1	3006322		
127749	3930	4133840	1978-08-26	1978-08-26 00:00:00	1978-08-26	5001	0	\N	0	0	\N	\N	0	261295	0	127783003	4133840		
50927	4642	3006322	1971-07-04	1971-07-04 00:00:00	1971-07-04	5001	0	\N	0	0	\N	\N	0	309358	0	8331-1	3006322		
50994	4646	3006322	1948-11-07	1948-11-07 00:00:00	1948-11-07	5001	0	\N	0	0	\N	\N	0	309784	0	8331-1	3006322		
36272	3337	3006322	1991-08-31	1991-08-31 00:00:00	1991-08-31	5001	0	\N	0	0	\N	\N	0	221369	0	8331-1	3006322		
34431	1077	4024958	1996-02-05	1996-02-05 00:00:00	1996-02-05	5001	0	\N	0	0	\N	\N	0	70636	0	117015009	4024958		
56641	5200	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	345902	0	6246-3	3021226		
38276	3528	3012494	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	234230	0	6206-7	3012494		
46515	4279	3049273	2011-07-21	2011-07-21 00:00:00	2011-07-21	5001	0	\N	0	0	\N	\N	0	284092	0	38265-5	3049273		
49717	4521	3006322	1991-01-17	1991-01-17 00:00:00	1991-01-17	5001	0	\N	0	0	\N	\N	0	301021	0	8331-1	3006322		
42801	3957	46235214	1966-01-12	1966-01-12 00:00:00	1966-01-12	5001	0	\N	0	0	\N	\N	0	263084	0	76690-7	46235214		
43693	4032	3006322	2007-06-22	2007-06-22 00:00:00	2007-06-22	5001	0	\N	0	0	\N	\N	0	268283	0	8331-1	3006322		
117525	3621	4024958	1932-03-07	1932-03-07 00:00:00	1932-03-07	5001	0	\N	0	0	\N	\N	0	240618	0	117015009	4024958		
11524	1102	3001247	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	72407	0	6085-5	3001247		
12195	1162	3006322	1959-11-08	1959-11-08 00:00:00	1959-11-08	5001	0	\N	0	0	\N	\N	0	76698	0	8331-1	3006322		
18539	582	4024958	2014-04-02	2014-04-02 00:00:00	2014-04-02	5001	0	\N	0	0	\N	\N	0	38583	0	117015009	4024958		
12338	1175	3015076	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	77538	0	6248-9	3015076		
75093	2300	4133840	2002-01-03	2002-01-03 00:00:00	2002-01-03	5001	0	\N	0	0	\N	\N	0	153150	0	127783003	4133840		
7629	733	3006322	1994-02-16	1994-02-16 00:00:00	1994-02-16	5001	0	\N	0	0	\N	\N	0	48610	0	8331-1	3006322		
67220	2063	4052083	2008-04-30	2008-04-30 00:00:00	2008-04-30	5001	0	\N	0	0	\N	\N	0	137250	0	23426006	4052083		
70876	2173	4024958	1931-10-02	1931-10-02 00:00:00	1931-10-02	5001	0	\N	0	0	\N	\N	0	144724	0	117015009	4024958		
84634	2622	4024958	1933-05-27	1933-05-27 00:00:00	1933-05-27	5001	0	\N	0	0	\N	\N	0	173469	0	117015009	4024958		
3581	343	3027231	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	22856	0	6276-0	3027231		
22058	2025	3006322	1910-08-17	1910-08-17 00:00:00	1910-08-17	5001	0	\N	0	0	\N	\N	0	134629	0	8331-1	3006322		
25429	2334	3011505	1986-01-30	1986-01-30 00:00:00	1986-01-30	5001	0	\N	0	0	\N	\N	0	155370	0	19926-5	3011505		
2897	273	3027231	1976-09-25	1976-09-25 00:00:00	1976-09-25	5001	0	\N	0	0	\N	\N	0	18193	0	6276-0	3027231		
24197	2226	3006322	1993-11-06	1993-11-06 00:00:00	1993-11-06	5001	0	\N	0	0	\N	\N	0	148075	0	8331-1	3006322		
33638	3053	3006322	2006-10-01	2006-10-01 00:00:00	2006-10-01	5001	0	\N	0	0	\N	\N	0	203127	0	8331-1	3006322		
35654	3253	3006322	2004-02-16	2004-02-16 00:00:00	2004-02-16	5001	0	\N	0	0	\N	\N	0	216368	0	8331-1	3006322		
74617	2290	4024958	1999-10-07	1999-10-07 00:00:00	1999-10-07	5001	0	\N	0	0	\N	\N	0	152359	0	117015009	4024958		
47111	4342	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	287964	0	7258-7	3001488		
155028	4754	4024958	1972-08-24	1972-08-24 00:00:00	1972-08-24	5001	0	\N	0	0	\N	\N	0	316654	0	117015009	4024958		
141936	4370	4052083	1969-06-27	1969-06-27 00:00:00	1969-06-27	5001	0	\N	0	0	\N	\N	0	290121	0	23426006	4052083		
18914	597	4052083	2003-09-08	2003-09-08 00:00:00	2003-09-08	5001	0	\N	0	0	\N	\N	0	39473	0	23426006	4052083		
11263	1083	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	71173	0	6082-2	3000876		
166793	5119	4024958	1964-11-26	1964-11-26 00:00:00	1964-11-26	5001	0	\N	0	0	\N	\N	0	340292	0	117015009	4024958		
22631	2075	40758406	2002-12-21	2002-12-21 00:00:00	2002-12-21	5001	0	\N	0	0	\N	\N	0	138030	0	55277-8	40758406		
11022	349	4024958	1970-08-14	1970-08-14 00:00:00	1970-08-14	5001	0	\N	0	0	\N	\N	0	23181	0	117015009	4024958		
45675	4214	3006322	1990-03-08	1990-03-08 00:00:00	1990-03-08	5001	0	\N	0	0	\N	\N	0	279759	0	8331-1	3006322		
142646	4382	4052083	1967-01-22	1967-01-22 00:00:00	1967-01-22	5001	0	\N	0	0	\N	\N	0	291178	0	23426006	4052083		
14290	1334	3006322	1997-10-11	1997-10-11 00:00:00	1997-10-11	5001	0	\N	0	0	\N	\N	0	88524	0	8331-1	3006322		
44350	4091	3006322	1980-03-04	1980-03-04 00:00:00	1980-03-04	5001	0	\N	0	0	\N	\N	0	271987	0	8331-1	3006322		
25710	2357	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	157052	0	6246-3	3021226		
37106	3413	3006322	1983-02-09	1983-02-09 00:00:00	1983-02-09	5001	0	\N	0	0	\N	\N	0	226379	0	8331-1	3006322		
51424	4705	3006322	1995-10-03	1995-10-03 00:00:00	1995-10-03	5001	0	\N	0	0	\N	\N	0	313468	0	8331-1	3006322		
31299	2861	3006322	1992-05-12	1992-05-12 00:00:00	1992-05-12	5001	0	\N	0	0	\N	\N	0	190207	0	8331-1	3006322		
31937	2915	40766240	2011-08-19	2011-08-19 00:00:00	2011-08-19	5001	0	\N	0	0	\N	\N	0	194276	0	63513-6	40766240		
146554	4497	4024958	1962-04-29	1962-04-29 00:00:00	1962-04-29	5001	0	\N	0	0	\N	\N	0	299415	0	117015009	4024958		
35401	3241	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	215501	0	6833-8	3023430		
46754	4305	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	285642	0	6106-9	3014599		
26489	2444	3006322	1988-04-04	1988-04-04 00:00:00	1988-04-04	5001	0	\N	0	0	\N	\N	0	162161	0	8331-1	3006322		
18789	1727	3006906	1982-03-24	1982-03-24 00:00:00	1982-03-24	5001	0	\N	0	0	\N	\N	0	115482	0	17861-6	3006906		
57789	5306	3006322	1995-04-29	1995-04-29 00:00:00	1995-04-29	5001	0	\N	0	0	\N	\N	0	352925	0	8331-1	3006322		
129545	3989	4024958	1928-08-29	1928-08-29 00:00:00	1928-08-29	5001	0	\N	0	0	\N	\N	0	265148	0	117015009	4024958		
21860	2013	3051031	1967-07-08	1967-07-08 00:00:00	1967-07-08	5001	0	\N	0	0	\N	\N	0	133940	0	46240-8	3051031		
23681	742	4133840	1961-10-16	1961-10-16 00:00:00	1961-10-16	5001	0	\N	0	0	\N	\N	0	49159	0	127783003	4133840		
23770	742	4133840	1991-04-15	1991-04-15 00:00:00	1991-04-15	5001	0	\N	0	0	\N	\N	0	49209	0	127783003	4133840		
39694	3689	40758406	1962-07-26	1962-07-26 00:00:00	1962-07-26	5001	0	\N	0	0	\N	\N	0	245210	0	55277-8	40758406		
13647	1283	3004501	1972-04-22	1972-04-22 00:00:00	1972-04-22	5001	0	\N	0	0	\N	\N	0	84823	0	2345-7	3004501		
19304	1766	3011505	1994-04-26	1994-04-26 00:00:00	1994-04-26	5001	0	\N	0	0	\N	\N	0	118182	0	19926-5	3011505		
17611	1604	3006322	1959-09-27	1959-09-27 00:00:00	1959-09-27	5001	0	\N	0	0	\N	\N	0	107625	0	8331-1	3006322		
10750	1046	3006322	2002-12-31	2002-12-31 00:00:00	2002-12-31	5001	0	\N	0	0	\N	\N	0	68661	0	8331-1	3006322		
36556	3364	3006734	1977-10-02	1977-10-02 00:00:00	1977-10-02	5001	0	\N	0	0	\N	\N	0	223078	0	6189-5	3006734		
36633	3370	3006734	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	223481	0	6189-5	3006734		
56836	5213	3006322	2009-03-30	2009-03-30 00:00:00	2009-03-30	5001	0	\N	0	0	\N	\N	0	346742	0	8331-1	3006322		
127753	3930	4133840	1969-12-27	1969-12-27 00:00:00	1969-12-27	5001	0	\N	0	0	\N	\N	0	261288	0	127783003	4133840		
50928	4642	3006322	2008-01-18	2008-01-18 00:00:00	2008-01-18	5001	0	\N	0	0	\N	\N	0	309489	0	8331-1	3006322		
51000	4649	3006322	2017-12-23	2017-12-23 00:00:00	2017-12-23	5001	0	\N	0	0	\N	\N	0	309979	0	8331-1	3006322		
36273	3337	40758406	2013-03-25	2013-03-25 00:00:00	2013-03-25	5001	0	\N	0	0	\N	\N	0	221361	0	55277-8	40758406		
34441	1077	4024958	1987-05-30	1987-05-30 00:00:00	1987-05-30	5001	0	\N	0	0	\N	\N	0	70587	0	117015009	4024958		
56642	5200	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	345902	0	6206-7	3012494		
38277	3528	3021226	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	234230	0	6246-3	3021226		
46516	4279	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	283993	0	6189-5	3006734		
49719	4521	3006322	1991-09-23	1991-09-23 00:00:00	1991-09-23	5001	0	\N	0	0	\N	\N	0	300967	0	8331-1	3006322		
42803	3957	40766240	1966-01-12	1966-01-12 00:00:00	1966-01-12	5001	0	\N	0	0	\N	\N	0	263084	0	63513-6	40766240		
43694	4033	3006322	2009-05-02	2009-05-02 00:00:00	2009-05-02	5001	0	\N	0	0	\N	\N	0	268362	0	8331-1	3006322		
117526	3621	4052083	1993-11-01	1993-11-01 00:00:00	1993-11-01	5001	0	\N	0	0	\N	\N	0	240583	0	23426006	4052083		
11525	1102	3006734	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	72407	0	6189-5	3006734		
12197	1162	46235214	1963-02-18	1963-02-18 00:00:00	1963-02-18	5001	0	\N	0	0	\N	\N	0	76705	0	76690-7	46235214		
18541	582	4024958	1966-08-26	1966-08-26 00:00:00	1966-08-26	5001	0	\N	0	0	\N	\N	0	38536	0	117015009	4024958		
12339	1175	3006734	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	77538	0	6189-5	3006734		
75095	2300	4133840	1980-11-20	1980-11-20 00:00:00	1980-11-20	5001	0	\N	0	0	\N	\N	0	153201	0	127783003	4133840		
7630	733	3006322	1944-09-19	1944-09-19 00:00:00	1944-09-19	5001	0	\N	0	0	\N	\N	0	48651	0	8331-1	3006322		
67227	2064	4052083	1996-06-30	1996-06-30 00:00:00	1996-06-30	5001	0	\N	0	0	\N	\N	0	137290	0	23426006	4052083		
82185	2542	4024958	2006-12-30	2006-12-30 00:00:00	2006-12-30	5001	0	\N	0	0	\N	\N	0	168114	0	117015009	4024958		
84653	2622	4024958	1990-01-13	1990-01-13 00:00:00	1990-01-13	5001	0	\N	0	0	\N	\N	0	173477	0	117015009	4024958		
3582	343	3019406	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	22856	0	6158-0	3019406		
22059	2025	3006322	1921-03-29	1921-03-29 00:00:00	1921-03-29	5001	0	\N	0	0	\N	\N	0	134770	0	8331-1	3006322		
25430	2334	3011505	2000-04-20	2000-04-20 00:00:00	2000-04-20	5001	0	\N	0	0	\N	\N	0	155360	0	19926-5	3011505		
2898	273	3036780	1976-09-25	1976-09-25 00:00:00	1976-09-25	5001	0	\N	0	0	\N	\N	0	18193	0	6095-4	3036780		
24198	2226	3006322	1994-08-17	1994-08-17 00:00:00	1994-08-17	5001	0	\N	0	0	\N	\N	0	148146	0	8331-1	3006322		
33639	3053	3006322	1992-11-15	1992-11-15 00:00:00	1992-11-15	5001	0	\N	0	0	\N	\N	0	203095	0	8331-1	3006322		
35655	3254	3006322	2018-10-14	2018-10-14 00:00:00	2018-10-14	5001	0	\N	0	0	\N	\N	0	216411	0	8331-1	3006322		
74618	2290	4024958	2005-06-01	2005-06-01 00:00:00	2005-06-01	5001	0	\N	0	0	\N	\N	0	152318	0	117015009	4024958		
47112	4342	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	287964	0	6833-8	3023430		
155033	4755	4052083	2001-03-22	2001-03-22 00:00:00	2001-03-22	5001	0	\N	0	0	\N	\N	0	316774	0	23426006	4052083		
153231	4700	4024958	1955-08-31	1955-08-31 00:00:00	1955-08-31	5001	0	\N	0	0	\N	\N	0	313118	0	117015009	4024958		
18915	597	4052083	1993-09-05	1993-09-05 00:00:00	1993-09-05	5001	0	\N	0	0	\N	\N	0	39424	0	23426006	4052083		
11264	1083	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	71173	0	6095-4	3036780		
66743	2051	4052083	2002-08-07	2002-08-07 00:00:00	2002-08-07	5001	0	\N	0	0	\N	\N	0	136352	0	23426006	4052083		
22632	2075	46235214	2002-12-21	2002-12-21 00:00:00	2002-12-21	5001	0	\N	0	0	\N	\N	0	138030	0	76690-7	46235214		
11025	349	4024958	1969-02-11	1969-02-11 00:00:00	1969-02-11	5001	0	\N	0	0	\N	\N	0	23180	0	117015009	4024958		
45676	4214	3006322	1981-04-27	1981-04-27 00:00:00	1981-04-27	5001	0	\N	0	0	\N	\N	0	279758	0	8331-1	3006322		
142652	4383	4024958	1981-07-27	1981-07-27 00:00:00	1981-07-27	5001	0	\N	0	0	\N	\N	0	291339	0	117015009	4024958		
14291	1335	3006322	1983-07-14	1983-07-14 00:00:00	1983-07-14	5001	0	\N	0	0	\N	\N	0	88605	0	8331-1	3006322		
44351	4091	3006322	2000-01-30	2000-01-30 00:00:00	2000-01-30	5001	0	\N	0	0	\N	\N	0	271989	0	8331-1	3006322		
25711	2357	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	157052	0	6075-6	3005136		
37107	3413	3006322	1998-06-16	1998-06-16 00:00:00	1998-06-16	5001	0	\N	0	0	\N	\N	0	226421	0	8331-1	3006322		
51425	4705	3006322	1992-10-04	1992-10-04 00:00:00	1992-10-04	5001	0	\N	0	0	\N	\N	0	313488	0	8331-1	3006322		
31300	2861	3006322	1970-03-15	1970-03-15 00:00:00	1970-03-15	5001	0	\N	0	0	\N	\N	0	190206	0	8331-1	3006322		
31938	2915	3006322	1952-05-23	1952-05-23 00:00:00	1952-05-23	5001	0	\N	0	0	\N	\N	0	194339	0	8331-1	3006322		
135354	4168	4052083	1973-12-20	1973-12-20 00:00:00	1973-12-20	5001	0	\N	0	0	\N	\N	0	277042	0	23426006	4052083		
35402	3241	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	215501	0	6206-7	3012494		
46755	4305	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	285642	0	6273-7	3006451		
26490	2444	3006322	1981-01-02	1981-01-02 00:00:00	1981-01-02	5001	0	\N	0	0	\N	\N	0	162143	0	8331-1	3006322		
18790	1727	3002385	1982-03-24	1982-03-24 00:00:00	1982-03-24	5001	0	\N	0	0	\N	\N	0	115482	0	30385-9	3002385		
57790	5306	3000963	1989-01-14	1989-01-14 00:00:00	1989-01-14	5001	0	\N	0	0	\N	\N	0	352949	0	718-7	3000963		
129547	3989	4024958	1939-10-28	1939-10-28 00:00:00	1939-10-28	5001	0	\N	0	0	\N	\N	0	265150	0	117015009	4024958		
21863	2013	40766240	1967-07-08	1967-07-08 00:00:00	1967-07-08	5001	0	\N	0	0	\N	\N	0	133940	0	63513-6	40766240		
23684	742	4133840	2011-12-12	2011-12-12 00:00:00	2011-12-12	5001	0	\N	0	0	\N	\N	0	49185	0	127783003	4133840		
23773	742	4133840	2001-06-11	2001-06-11 00:00:00	2001-06-11	5001	0	\N	0	0	\N	\N	0	49124	0	127783003	4133840		
39695	3689	3006322	2005-06-21	2005-06-21 00:00:00	2005-06-21	5001	0	\N	0	0	\N	\N	0	245220	0	8331-1	3006322		
13648	1283	3010813	1972-04-22	1972-04-22 00:00:00	1972-04-22	5001	0	\N	0	0	\N	\N	0	84823	0	26464-8	3010813		
19305	1766	3011505	1998-06-02	1998-06-02 00:00:00	1998-06-02	5001	0	\N	0	0	\N	\N	0	118161	0	19926-5	3011505		
17612	1604	3011505	2009-07-30	2009-07-30 00:00:00	2009-07-30	5001	0	\N	0	0	\N	\N	0	107644	0	19926-5	3011505		
10778	1051	3006322	1978-06-14	1978-06-14 00:00:00	1978-06-14	5001	0	\N	0	0	\N	\N	0	68854	0	8331-1	3006322		
36557	3364	3000876	1977-10-02	1977-10-02 00:00:00	1977-10-02	5001	0	\N	0	0	\N	\N	0	223078	0	6082-2	3000876		
36634	3370	3020655	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	223481	0	6844-5	3020655		
56837	5213	3006322	1950-04-12	1950-04-12 00:00:00	1950-04-12	5001	0	\N	0	0	\N	\N	0	346695	0	8331-1	3006322		
127754	3930	4133840	1977-08-20	1977-08-20 00:00:00	1977-08-20	5001	0	\N	0	0	\N	\N	0	261256	0	127783003	4133840		
50929	4642	3006322	1960-10-16	1960-10-16 00:00:00	1960-10-16	5001	0	\N	0	0	\N	\N	0	309413	0	8331-1	3006322		
51001	4649	3006322	2004-11-18	2004-11-18 00:00:00	2004-11-18	5001	0	\N	0	0	\N	\N	0	310011	0	8331-1	3006322		
36274	3337	46235214	2013-03-25	2013-03-25 00:00:00	2013-03-25	5001	0	\N	0	0	\N	\N	0	221361	0	76690-7	46235214		
34476	1079	4052083	2004-12-07	2004-12-07 00:00:00	2004-12-07	5001	0	\N	0	0	\N	\N	0	70714	0	23426006	4052083		
56643	5200	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	345902	0	6106-9	3014599		
38278	3528	3001247	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	234230	0	6085-5	3001247		
46517	4279	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	283993	0	7258-7	3001488		
49720	4521	3006322	1968-06-19	1968-06-19 00:00:00	1968-06-19	5001	0	\N	0	0	\N	\N	0	301019	0	8331-1	3006322		
42804	3957	40758406	1965-10-14	1965-10-14 00:00:00	1965-10-14	5001	0	\N	0	0	\N	\N	0	263083	0	55277-8	40758406		
43695	4033	3006322	2010-05-13	2010-05-13 00:00:00	2010-05-13	5001	0	\N	0	0	\N	\N	0	268363	0	8331-1	3006322		
117528	3621	4024958	1945-09-05	1945-09-05 00:00:00	1945-09-05	5001	0	\N	0	0	\N	\N	0	240608	0	117015009	4024958		
11526	1102	3006322	2014-10-17	2014-10-17 00:00:00	2014-10-17	5001	0	\N	0	0	\N	\N	0	72409	0	8331-1	3006322		
12200	1162	40766240	1963-02-18	1963-02-18 00:00:00	1963-02-18	5001	0	\N	0	0	\N	\N	0	76705	0	63513-6	40766240		
18542	582	4024958	1998-05-29	1998-05-29 00:00:00	1998-05-29	5001	0	\N	0	0	\N	\N	0	38580	0	117015009	4024958		
12340	1175	3023430	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	77538	0	6833-8	3023430		
75096	2300	4133840	1993-12-09	1993-12-09 00:00:00	1993-12-09	5001	0	\N	0	0	\N	\N	0	153160	0	127783003	4133840		
7649	736	3006322	1977-10-17	1977-10-17 00:00:00	1977-10-17	5001	0	\N	0	0	\N	\N	0	48777	0	8331-1	3006322		
67237	2064	4052083	1993-10-06	1993-10-06 00:00:00	1993-10-06	5001	0	\N	0	0	\N	\N	0	137281	0	23426006	4052083		
35210	3218	3006322	1985-07-02	1985-07-02 00:00:00	1985-07-02	5001	0	\N	0	0	\N	\N	0	213814	0	8331-1	3006322		
84660	2622	4052083	1991-08-04	1991-08-04 00:00:00	1991-08-04	5001	0	\N	0	0	\N	\N	0	173442	0	23426006	4052083		
3583	343	3021226	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	22856	0	6246-3	3021226		
22060	2025	3006322	1911-08-09	1911-08-09 00:00:00	1911-08-09	5001	0	\N	0	0	\N	\N	0	134630	0	8331-1	3006322		
25431	2334	3011505	2013-07-04	2013-07-04 00:00:00	2013-07-04	5001	0	\N	0	0	\N	\N	0	155364	0	19926-5	3011505		
2899	273	3019406	1976-09-25	1976-09-25 00:00:00	1976-09-25	5001	0	\N	0	0	\N	\N	0	18193	0	6158-0	3019406		
24199	2226	3006322	1966-12-27	1966-12-27 00:00:00	1966-12-27	5001	0	\N	0	0	\N	\N	0	148139	0	8331-1	3006322		
33640	3053	3000963	1987-01-08	1987-01-08 00:00:00	1987-01-08	5001	0	\N	0	0	\N	\N	0	203142	0	718-7	3000963		
35656	3254	3006322	2008-07-21	2008-07-21 00:00:00	2008-07-21	5001	0	\N	0	0	\N	\N	0	216433	0	8331-1	3006322		
74619	2290	4024958	1970-06-14	1970-06-14 00:00:00	1970-06-14	5001	0	\N	0	0	\N	\N	0	152357	0	117015009	4024958		
47113	4342	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	287964	0	6844-5	3020655		
155042	4755	4024958	1947-04-06	1947-04-06 00:00:00	1947-04-06	5001	0	\N	0	0	\N	\N	0	316682	0	117015009	4024958		
153233	4700	4052083	2015-03-13	2015-03-13 00:00:00	2015-03-13	5001	0	\N	0	0	\N	\N	0	313057	0	23426006	4052083		
18918	598	4024958	2000-05-07	2000-05-07 00:00:00	2000-05-07	5001	0	\N	0	0	\N	\N	0	39503	0	117015009	4024958		
11265	1083	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	71173	0	6158-0	3019406		
66750	2051	4052083	1969-03-18	1969-03-18 00:00:00	1969-03-18	5001	0	\N	0	0	\N	\N	0	136365	0	23426006	4052083		
22634	2075	40766240	2002-12-21	2002-12-21 00:00:00	2002-12-21	5001	0	\N	0	0	\N	\N	0	138030	0	63513-6	40766240		
11027	349	4024958	1964-01-13	1964-01-13 00:00:00	1964-01-13	5001	0	\N	0	0	\N	\N	0	23196	0	117015009	4024958		
45685	4217	3006322	1976-01-11	1976-01-11 00:00:00	1976-01-11	5001	0	\N	0	0	\N	\N	0	279947	0	8331-1	3006322		
142661	4383	4052083	1976-03-30	1976-03-30 00:00:00	1976-03-30	5001	0	\N	0	0	\N	\N	0	291324	0	23426006	4052083		
14292	1335	3006322	2010-05-30	2010-05-30 00:00:00	2010-05-30	5001	0	\N	0	0	\N	\N	0	88582	0	8331-1	3006322		
44352	4092	3006322	2001-07-11	2001-07-11 00:00:00	2001-07-11	5001	0	\N	0	0	\N	\N	0	272056	0	8331-1	3006322		
25712	2357	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	157052	0	6248-9	3015076		
37108	3413	3006322	1977-12-24	1977-12-24 00:00:00	1977-12-24	5001	0	\N	0	0	\N	\N	0	226375	0	8331-1	3006322		
51426	4705	3006322	1978-04-19	1978-04-19 00:00:00	1978-04-19	5001	0	\N	0	0	\N	\N	0	313443	0	8331-1	3006322		
31301	2861	3006322	2013-11-13	2013-11-13 00:00:00	2013-11-13	5001	0	\N	0	0	\N	\N	0	190196	0	8331-1	3006322		
31939	2915	3006322	1986-11-13	1986-11-13 00:00:00	1986-11-13	5001	0	\N	0	0	\N	\N	0	194326	0	8331-1	3006322		
78229	2396	4052083	1959-01-25	1959-01-25 00:00:00	1959-01-25	5001	0	\N	0	0	\N	\N	0	159296	0	23426006	4052083		
35403	3241	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	215501	0	6075-6	3005136		
46756	4305	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	285642	0	6248-9	3015076		
26491	2444	3006322	1971-01-05	1971-01-05 00:00:00	1971-01-05	5001	0	\N	0	0	\N	\N	0	162142	0	8331-1	3006322		
18791	1727	3007461	1982-03-24	1982-03-24 00:00:00	1982-03-24	5001	0	\N	0	0	\N	\N	0	115482	0	26515-7	3007461		
57791	5306	3009542	1989-01-14	1989-01-14 00:00:00	1989-01-14	5001	0	\N	0	0	\N	\N	0	352949	0	20570-8	3009542		
129575	3991	4024958	1981-08-23	1981-08-23 00:00:00	1981-08-23	5001	0	\N	0	0	\N	\N	0	265343	0	117015009	4024958		
21864	2013	46235214	1967-07-08	1967-07-08 00:00:00	1967-07-08	5001	0	\N	0	0	\N	\N	0	133940	0	76690-7	46235214		
23687	742	4133840	1970-11-16	1970-11-16 00:00:00	1970-11-16	5001	0	\N	0	0	\N	\N	0	49170	0	127783003	4133840		
23775	742	4133840	1968-11-11	1968-11-11 00:00:00	1968-11-11	5001	0	\N	0	0	\N	\N	0	49161	0	127783003	4133840		
39696	3689	3006322	1987-12-07	1987-12-07 00:00:00	1987-12-07	5001	0	\N	0	0	\N	\N	0	245235	0	8331-1	3006322		
13649	1283	21494966	1972-04-22	1972-04-22 00:00:00	1972-04-22	5001	0	\N	0	0	\N	\N	0	84823	0	80271-0	21494966		
19306	1766	3011505	2015-11-17	2015-11-17 00:00:00	2015-11-17	5001	0	\N	0	0	\N	\N	0	118186	0	19926-5	3011505		
17613	1604	3011505	2003-06-26	2003-06-26 00:00:00	2003-06-26	5001	0	\N	0	0	\N	\N	0	107635	0	19926-5	3011505		
10779	1051	3006322	1975-10-15	1975-10-15 00:00:00	1975-10-15	5001	0	\N	0	0	\N	\N	0	68861	0	8331-1	3006322		
36558	3364	3036780	1977-10-02	1977-10-02 00:00:00	1977-10-02	5001	0	\N	0	0	\N	\N	0	223078	0	6095-4	3036780		
36635	3370	3023430	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	223481	0	6833-8	3023430		
56839	5215	3006322	1945-08-28	1945-08-28 00:00:00	1945-08-28	5001	0	\N	0	0	\N	\N	0	346865	0	8331-1	3006322		
127756	3930	4024958	1941-01-09	1941-01-09 00:00:00	1941-01-09	5001	0	\N	0	0	\N	\N	0	261230	0	117015009	4024958		
50930	4642	3014599	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	309400	0	6106-9	3014599		
51002	4649	3006322	2018-03-04	2018-03-04 00:00:00	2018-03-04	5001	0	\N	0	0	\N	\N	0	309997	0	8331-1	3006322		
36275	3337	3051031	2013-03-25	2013-03-25 00:00:00	2013-03-25	5001	0	\N	0	0	\N	\N	0	221361	0	46240-8	3051031		
137727	4243	4024958	1999-11-07	1999-11-07 00:00:00	1999-11-07	5001	0	\N	0	0	\N	\N	0	281828	0	117015009	4024958		
56644	5200	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	345902	0	6158-0	3019406		
38279	3528	3001488	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	234230	0	7258-7	3001488		
46518	4279	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	283993	0	6844-5	3020655		
49721	4521	3049273	2008-11-13	2008-11-13 00:00:00	2008-11-13	5001	0	\N	0	0	\N	\N	0	301028	0	38265-5	3049273		
42806	3957	40766240	1965-10-14	1965-10-14 00:00:00	1965-10-14	5001	0	\N	0	0	\N	\N	0	263083	0	63513-6	40766240		
43696	4033	3051031	2004-02-02	2004-02-02 00:00:00	2004-02-02	5001	0	\N	0	0	\N	\N	0	268361	0	46240-8	3051031		
117529	3622	4024958	1932-10-16	1932-10-16 00:00:00	1932-10-16	5001	0	\N	0	0	\N	\N	0	240768	0	117015009	4024958		
11527	1102	3006322	1986-11-14	1986-11-14 00:00:00	1986-11-14	5001	0	\N	0	0	\N	\N	0	72387	0	8331-1	3006322		
12201	1162	3051031	1963-02-18	1963-02-18 00:00:00	1963-02-18	5001	0	\N	0	0	\N	\N	0	76705	0	46240-8	3051031		
64614	1980	4024958	2007-06-05	2007-06-05 00:00:00	2007-06-05	5001	0	\N	0	0	\N	\N	0	131834	0	117015009	4024958		
12341	1175	3001247	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	77538	0	6085-5	3001247		
75097	2300	4133840	2014-03-13	2014-03-13 00:00:00	2014-03-13	5001	0	\N	0	0	\N	\N	0	153136	0	127783003	4133840		
7650	736	3006322	1979-05-24	1979-05-24 00:00:00	1979-05-24	5001	0	\N	0	0	\N	\N	0	48784	0	8331-1	3006322		
67252	2064	4024958	2000-09-02	2000-09-02 00:00:00	2000-09-02	5001	0	\N	0	0	\N	\N	0	137259	0	117015009	4024958		
35211	3219	3006322	2014-10-16	2014-10-16 00:00:00	2014-10-16	5001	0	\N	0	0	\N	\N	0	213913	0	8331-1	3006322		
95946	2942	4024958	1960-11-21	1960-11-21 00:00:00	1960-11-21	5001	0	\N	0	0	\N	\N	0	196127	0	117015009	4024958		
3584	343	3001488	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	22856	0	7258-7	3001488		
22061	2025	3049273	1979-09-01	1979-09-01 00:00:00	1979-09-01	5001	0	\N	0	0	\N	\N	0	134742	0	38265-5	3049273		
25432	2334	3011505	1990-02-22	1990-02-22 00:00:00	1990-02-22	5001	0	\N	0	0	\N	\N	0	155372	0	19926-5	3011505		
2900	273	3000876	1976-09-25	1976-09-25 00:00:00	1976-09-25	5001	0	\N	0	0	\N	\N	0	18193	0	6082-2	3000876		
24200	2226	3006322	2014-07-26	2014-07-26 00:00:00	2014-07-26	5001	0	\N	0	0	\N	\N	0	148077	0	8331-1	3006322		
33641	3053	3009542	1987-01-08	1987-01-08 00:00:00	1987-01-08	5001	0	\N	0	0	\N	\N	0	203142	0	20570-8	3009542		
35657	3254	3006322	1964-02-01	1964-02-01 00:00:00	1964-02-01	5001	0	\N	0	0	\N	\N	0	216453	0	8331-1	3006322		
74620	2290	4024958	1966-03-26	1966-03-26 00:00:00	1966-03-26	5001	0	\N	0	0	\N	\N	0	152362	0	117015009	4024958		
47114	4342	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	287964	0	6206-7	3012494		
155047	4755	4024958	1944-09-06	1944-09-06 00:00:00	1944-09-06	5001	0	\N	0	0	\N	\N	0	316755	0	117015009	4024958		
153254	4700	4024958	1959-01-09	1959-01-09 00:00:00	1959-01-09	5001	0	\N	0	0	\N	\N	0	313021	0	117015009	4024958		
18921	598	4024958	2001-11-10	2001-11-10 00:00:00	2001-11-10	5001	0	\N	0	0	\N	\N	0	39476	0	117015009	4024958		
11266	1083	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	71173	0	6248-9	3015076		
66752	2051	4052083	1980-03-17	1980-03-17 00:00:00	1980-03-17	5001	0	\N	0	0	\N	\N	0	136369	0	23426006	4052083		
22636	2075	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	138118	0	6085-5	3001247		
11028	349	4052083	1994-01-21	1994-01-21 00:00:00	1994-01-21	5001	0	\N	0	0	\N	\N	0	23207	0	23426006	4052083		
45686	4217	3006322	1965-06-09	1965-06-09 00:00:00	1965-06-09	5001	0	\N	0	0	\N	\N	0	279971	0	8331-1	3006322		
153951	4722	4052083	1938-12-11	1938-12-11 00:00:00	1938-12-11	5001	0	\N	0	0	\N	\N	0	314588	0	23426006	4052083		
14293	1335	3006322	1982-02-04	1982-02-04 00:00:00	1982-02-04	5001	0	\N	0	0	\N	\N	0	88561	0	8331-1	3006322		
44353	4092	3006322	2007-02-22	2007-02-22 00:00:00	2007-02-22	5001	0	\N	0	0	\N	\N	0	272022	0	8331-1	3006322		
25713	2357	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	157052	0	6276-0	3027231		
37109	3413	3006322	1999-12-20	1999-12-20 00:00:00	1999-12-20	5001	0	\N	0	0	\N	\N	0	226412	0	8331-1	3006322		
51427	4705	3006322	2013-05-12	2013-05-12 00:00:00	2013-05-12	5001	0	\N	0	0	\N	\N	0	313493	0	8331-1	3006322		
24578	764	4024958	1985-10-21	1985-10-21 00:00:00	1985-10-21	5001	0	\N	0	0	\N	\N	0	50814	0	117015009	4024958		
31940	2915	3006322	1969-11-25	1969-11-25 00:00:00	1969-11-25	5001	0	\N	0	0	\N	\N	0	194292	0	8331-1	3006322		
40047	1246	4052083	1950-06-13	1950-06-13 00:00:00	1950-06-13	5001	0	\N	0	0	\N	\N	0	82099	0	23426006	4052083		
35404	3241	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	215501	0	6273-7	3006451		
46757	4305	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	285642	0	6095-4	3036780		
26492	2444	3006322	1976-11-29	1976-11-29 00:00:00	1976-11-29	5001	0	\N	0	0	\N	\N	0	162164	0	8331-1	3006322		
18792	1727	3023103	1982-03-24	1982-03-24 00:00:00	1982-03-24	5001	0	\N	0	0	\N	\N	0	115482	0	2823-3	3023103		
57797	5309	3006322	1976-09-29	1976-09-29 00:00:00	1976-09-29	5001	0	\N	0	0	\N	\N	0	353116	0	8331-1	3006322		
129578	3991	4024958	1973-10-23	1973-10-23 00:00:00	1973-10-23	5001	0	\N	0	0	\N	\N	0	265301	0	117015009	4024958		
21865	2013	40758406	1967-07-08	1967-07-08 00:00:00	1967-07-08	5001	0	\N	0	0	\N	\N	0	133940	0	55277-8	40758406		
23688	742	4133840	2014-10-20	2014-10-20 00:00:00	2014-10-20	5001	0	\N	0	0	\N	\N	0	49198	0	127783003	4133840		
23779	742	4133840	2013-12-23	2013-12-23 00:00:00	2013-12-23	5001	0	\N	0	0	\N	\N	0	49186	0	127783003	4133840		
39697	3689	3006322	1992-10-06	1992-10-06 00:00:00	1992-10-06	5001	0	\N	0	0	\N	\N	0	245231	0	8331-1	3006322		
13650	1283	3006906	1972-04-22	1972-04-22 00:00:00	1972-04-22	5001	0	\N	0	0	\N	\N	0	84823	0	17861-6	3006906		
19307	1766	3011505	1981-01-06	1981-01-06 00:00:00	1981-01-06	5001	0	\N	0	0	\N	\N	0	118180	0	19926-5	3011505		
17614	1604	3011505	1999-06-17	1999-06-17 00:00:00	1999-06-17	5001	0	\N	0	0	\N	\N	0	107597	0	19926-5	3011505		
10780	1051	3006322	1973-09-08	1973-09-08 00:00:00	1973-09-08	5001	0	\N	0	0	\N	\N	0	68865	0	8331-1	3006322		
36559	3364	3020655	1977-10-02	1977-10-02 00:00:00	1977-10-02	5001	0	\N	0	0	\N	\N	0	223078	0	6844-5	3020655		
36636	3370	3001488	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	223481	0	7258-7	3001488		
56840	5215	3006322	1992-09-14	1992-09-14 00:00:00	1992-09-14	5001	0	\N	0	0	\N	\N	0	346869	0	8331-1	3006322		
127757	3930	4024958	1971-07-11	1971-07-11 00:00:00	1971-07-11	5001	0	\N	0	0	\N	\N	0	261231	0	117015009	4024958		
50931	4642	3006734	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	309400	0	6189-5	3006734		
51003	4649	3006322	1990-08-23	1990-08-23 00:00:00	1990-08-23	5001	0	\N	0	0	\N	\N	0	310032	0	8331-1	3006322		
36276	3337	40766240	2013-03-25	2013-03-25 00:00:00	2013-03-25	5001	0	\N	0	0	\N	\N	0	221361	0	63513-6	40766240		
137730	4243	4052083	1993-11-06	1993-11-06 00:00:00	1993-11-06	5001	0	\N	0	0	\N	\N	0	281851	0	23426006	4052083		
56645	5200	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	345902	0	6273-7	3006451		
38280	3528	3006734	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	234230	0	6189-5	3006734		
46519	4279	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	283993	0	6833-8	3023430		
49723	4521	3006322	1942-02-28	1942-02-28 00:00:00	1942-02-28	5001	0	\N	0	0	\N	\N	0	301046	0	8331-1	3006322		
42807	3957	3051031	1965-10-14	1965-10-14 00:00:00	1965-10-14	5001	0	\N	0	0	\N	\N	0	263083	0	46240-8	3051031		
43697	4033	40766240	2004-02-02	2004-02-02 00:00:00	2004-02-02	5001	0	\N	0	0	\N	\N	0	268361	0	63513-6	40766240		
117555	3622	4052083	2019-03-26	2019-03-26 00:00:00	2019-03-26	5001	0	\N	0	0	\N	\N	0	240667	0	23426006	4052083		
11528	1102	3006322	2006-10-14	2006-10-14 00:00:00	2006-10-14	5001	0	\N	0	0	\N	\N	0	72434	0	8331-1	3006322		
12202	1162	40758406	1963-02-18	1963-02-18 00:00:00	1963-02-18	5001	0	\N	0	0	\N	\N	0	76705	0	55277-8	40758406		
12281	1173	3006322	1951-03-11	1951-03-11 00:00:00	1951-03-11	5001	0	\N	0	0	\N	\N	0	77206	0	8331-1	3006322		
12342	1175	3001488	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	77538	0	7258-7	3001488		
75098	2300	4133840	1977-11-17	1977-11-17 00:00:00	1977-11-17	5001	0	\N	0	0	\N	\N	0	153200	0	127783003	4133840		
7651	736	3006322	1974-06-25	1974-06-25 00:00:00	1974-06-25	5001	0	\N	0	0	\N	\N	0	48847	0	8331-1	3006322		
10372	332	4052083	1978-04-12	1978-04-12 00:00:00	1978-04-12	5001	0	\N	0	0	\N	\N	0	21994	0	23426006	4052083		
35212	3219	3006322	1986-12-28	1986-12-28 00:00:00	1986-12-28	5001	0	\N	0	0	\N	\N	0	213918	0	8331-1	3006322		
95949	2942	4052083	1983-05-24	1983-05-24 00:00:00	1983-05-24	5001	0	\N	0	0	\N	\N	0	196132	0	23426006	4052083		
3585	343	3023430	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	22856	0	6833-8	3023430		
22062	2025	3006322	1910-11-29	1910-11-29 00:00:00	1910-11-29	5001	0	\N	0	0	\N	\N	0	134691	0	8331-1	3006322		
25433	2334	3011505	1960-02-11	1960-02-11 00:00:00	1960-02-11	5001	0	\N	0	0	\N	\N	0	155367	0	19926-5	3011505		
2901	273	3001247	1976-09-25	1976-09-25 00:00:00	1976-09-25	5001	0	\N	0	0	\N	\N	0	18193	0	6085-5	3001247		
24201	2226	3006322	2001-05-08	2001-05-08 00:00:00	2001-05-08	5001	0	\N	0	0	\N	\N	0	148121	0	8331-1	3006322		
33642	3053	3006322	2003-01-09	2003-01-09 00:00:00	2003-01-09	5001	0	\N	0	0	\N	\N	0	203146	0	8331-1	3006322		
35664	3258	3006322	1998-07-23	1998-07-23 00:00:00	1998-07-23	5001	0	\N	0	0	\N	\N	0	216581	0	8331-1	3006322		
143383	4406	4024958	1965-06-06	1965-06-06 00:00:00	1965-06-06	5001	0	\N	0	0	\N	\N	0	292894	0	117015009	4024958		
47115	4342	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	287964	0	6075-6	3005136		
155059	4755	4052083	1925-06-06	1925-06-06 00:00:00	1925-06-06	5001	0	\N	0	0	\N	\N	0	316679	0	23426006	4052083		
153267	4701	4024958	1976-08-28	1976-08-28 00:00:00	1976-08-28	5001	0	\N	0	0	\N	\N	0	313125	0	117015009	4024958		
18922	598	4052083	2014-10-21	2014-10-21 00:00:00	2014-10-21	5001	0	\N	0	0	\N	\N	0	39480	0	23426006	4052083		
11267	1083	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	71173	0	6206-7	3012494		
66756	2051	4052083	1984-04-14	1984-04-14 00:00:00	1984-04-14	5001	0	\N	0	0	\N	\N	0	136355	0	23426006	4052083		
22637	2075	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	138118	0	6833-8	3023430		
11031	349	4024958	1959-07-26	1959-07-26 00:00:00	1959-07-26	5001	0	\N	0	0	\N	\N	0	23195	0	117015009	4024958		
45687	4217	3006322	1983-04-14	1983-04-14 00:00:00	1983-04-14	5001	0	\N	0	0	\N	\N	0	279968	0	8331-1	3006322		
171063	5249	4024958	1988-03-02	1988-03-02 00:00:00	1988-03-02	5001	0	\N	0	0	\N	\N	0	349234	0	117015009	4024958		
14294	1335	3006322	2010-03-20	2010-03-20 00:00:00	2010-03-20	5001	0	\N	0	0	\N	\N	0	88560	0	8331-1	3006322		
44354	4092	3006322	1982-07-08	1982-07-08 00:00:00	1982-07-08	5001	0	\N	0	0	\N	\N	0	272020	0	8331-1	3006322		
25714	2357	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	157052	0	6106-9	3014599		
37110	3414	3006322	2013-04-06	2013-04-06 00:00:00	2013-04-06	5001	0	\N	0	0	\N	\N	0	226437	0	8331-1	3006322		
51428	4705	3006322	2016-04-07	2016-04-07 00:00:00	2016-04-07	5001	0	\N	0	0	\N	\N	0	313494	0	8331-1	3006322		
127888	3936	4024958	1987-08-09	1987-08-09 00:00:00	1987-08-09	5001	0	\N	0	0	\N	\N	0	261642	0	117015009	4024958		
31941	2915	3006322	1969-09-16	1969-09-16 00:00:00	1969-09-16	5001	0	\N	0	0	\N	\N	0	194346	0	8331-1	3006322		
40077	1246	4024958	1997-07-31	1997-07-31 00:00:00	1997-07-31	5001	0	\N	0	0	\N	\N	0	81990	0	117015009	4024958		
35405	3241	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	215501	0	6085-5	3001247		
46758	4305	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	285642	0	6085-5	3001247		
37795	3483	3006322	2017-09-03	2017-09-03 00:00:00	2017-09-03	5001	0	\N	0	0	\N	\N	0	231045	0	8331-1	3006322		
18793	1727	3020630	1982-03-24	1982-03-24 00:00:00	1982-03-24	5001	0	\N	0	0	\N	\N	0	115482	0	2885-2	3020630		
57798	5309	3006322	2003-10-19	2003-10-19 00:00:00	2003-10-19	5001	0	\N	0	0	\N	\N	0	353077	0	8331-1	3006322		
15575	488	4052083	2015-08-18	2015-08-18 00:00:00	2015-08-18	5001	0	\N	0	0	\N	\N	0	32654	0	23426006	4052083		
21866	2013	40758406	1967-04-09	1967-04-09 00:00:00	1967-04-09	5001	0	\N	0	0	\N	\N	0	133939	0	55277-8	40758406		
23692	742	4133840	2010-12-06	2010-12-06 00:00:00	2010-12-06	5001	0	\N	0	0	\N	\N	0	49174	0	127783003	4133840		
23783	743	4024958	2001-07-15	2001-07-15 00:00:00	2001-07-15	5001	0	\N	0	0	\N	\N	0	49278	0	117015009	4024958		
39698	3689	3006322	2016-10-02	2016-10-02 00:00:00	2016-10-02	5001	0	\N	0	0	\N	\N	0	245238	0	8331-1	3006322		
13651	1283	3014576	1972-04-22	1972-04-22 00:00:00	1972-04-22	5001	0	\N	0	0	\N	\N	0	84823	0	2075-0	3014576		
19308	1766	3011505	1992-06-30	1992-06-30 00:00:00	1992-06-30	5001	0	\N	0	0	\N	\N	0	118181	0	19926-5	3011505		
17615	1604	3011505	2008-07-24	2008-07-24 00:00:00	2008-07-24	5001	0	\N	0	0	\N	\N	0	107600	0	19926-5	3011505		
10781	1051	3006322	1969-03-21	1969-03-21 00:00:00	1969-03-21	5001	0	\N	0	0	\N	\N	0	68863	0	8331-1	3006322		
36560	3364	3023430	1977-10-02	1977-10-02 00:00:00	1977-10-02	5001	0	\N	0	0	\N	\N	0	223078	0	6833-8	3023430		
36637	3370	3000876	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	223481	0	6082-2	3000876		
56841	5215	3006322	1998-09-23	1998-09-23 00:00:00	1998-09-23	5001	0	\N	0	0	\N	\N	0	346834	0	8331-1	3006322		
127759	3930	4133840	1974-08-03	1974-08-03 00:00:00	1974-08-03	5001	0	\N	0	0	\N	\N	0	261272	0	127783003	4133840		
50932	4642	3020655	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	309400	0	6844-5	3020655		
51009	4653	3006322	2010-09-23	2010-09-23 00:00:00	2010-09-23	5001	0	\N	0	0	\N	\N	0	310130	0	8331-1	3006322		
36279	3337	40758406	2013-08-22	2013-08-22 00:00:00	2013-08-22	5001	0	\N	0	0	\N	\N	0	221375	0	55277-8	40758406		
137735	4243	4024958	1998-09-01	1998-09-01 00:00:00	1998-09-01	5001	0	\N	0	0	\N	\N	0	281840	0	117015009	4024958		
56646	5200	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	345902	0	6833-8	3023430		
38281	3528	3000876	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	234230	0	6082-2	3000876		
46520	4279	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	283993	0	6075-6	3005136		
49724	4521	3006322	1968-05-12	1968-05-12 00:00:00	1968-05-12	5001	0	\N	0	0	\N	\N	0	301041	0	8331-1	3006322		
42809	3957	46235214	1965-10-14	1965-10-14 00:00:00	1965-10-14	5001	0	\N	0	0	\N	\N	0	263083	0	76690-7	46235214		
43698	4033	46235214	2004-02-02	2004-02-02 00:00:00	2004-02-02	5001	0	\N	0	0	\N	\N	0	268361	0	76690-7	46235214		
117569	3622	4024958	1961-05-15	1961-05-15 00:00:00	1961-05-15	5001	0	\N	0	0	\N	\N	0	240776	0	117015009	4024958		
11529	1102	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	72441	0	6082-2	3000876		
12204	1162	46235214	1978-07-14	1978-07-14 00:00:00	1978-07-14	5001	0	\N	0	0	\N	\N	0	76714	0	76690-7	46235214		
12282	1174	3051031	1941-02-11	1941-02-11 00:00:00	1941-02-11	5001	0	\N	0	0	\N	\N	0	77303	0	46240-8	3051031		
12343	1175	3036780	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	77538	0	6095-4	3036780		
75100	2300	4024958	1953-09-08	1953-09-08 00:00:00	1953-09-08	5001	0	\N	0	0	\N	\N	0	153148	0	117015009	4024958		
7652	736	3006322	1986-01-26	1986-01-26 00:00:00	1986-01-26	5001	0	\N	0	0	\N	\N	0	48790	0	8331-1	3006322		
21683	682	4024958	1975-12-24	1975-12-24 00:00:00	1975-12-24	5001	0	\N	0	0	\N	\N	0	45146	0	117015009	4024958		
35213	3219	3006322	1983-05-04	1983-05-04 00:00:00	1983-05-04	5001	0	\N	0	0	\N	\N	0	213887	0	8331-1	3006322		
95961	2942	4024958	2003-01-13	2003-01-13 00:00:00	2003-01-13	5001	0	\N	0	0	\N	\N	0	196221	0	117015009	4024958		
3586	343	3014599	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	22856	0	6106-9	3014599		
22063	2025	3006322	2017-08-10	2017-08-10 00:00:00	2017-08-10	5001	0	\N	0	0	\N	\N	0	134702	0	8331-1	3006322		
25434	2334	3006322	1942-05-10	1942-05-10 00:00:00	1942-05-10	5001	0	\N	0	0	\N	\N	0	155285	0	8331-1	3006322		
2902	273	3020655	1976-09-25	1976-09-25 00:00:00	1976-09-25	5001	0	\N	0	0	\N	\N	0	18193	0	6844-5	3020655		
24202	2226	3006322	1965-11-17	1965-11-17 00:00:00	1965-11-17	5001	0	\N	0	0	\N	\N	0	148138	0	8331-1	3006322		
33643	3053	3006322	2016-12-20	2016-12-20 00:00:00	2016-12-20	5001	0	\N	0	0	\N	\N	0	203129	0	8331-1	3006322		
35665	3258	3006322	1989-04-26	1989-04-26 00:00:00	1989-04-26	5001	0	\N	0	0	\N	\N	0	216558	0	8331-1	3006322		
143388	4406	4024958	1986-05-11	1986-05-11 00:00:00	1986-05-11	5001	0	\N	0	0	\N	\N	0	292897	0	117015009	4024958		
47116	4342	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	287964	0	6106-9	3014599		
31382	962	4052083	1982-09-25	1982-09-25 00:00:00	1982-09-25	5001	0	\N	0	0	\N	\N	0	64088	0	23426006	4052083		
64814	1987	4024958	1954-02-12	1954-02-12 00:00:00	1954-02-12	5001	0	\N	0	0	\N	\N	0	132331	0	117015009	4024958		
48701	4450	3006322	1975-06-03	1975-06-03 00:00:00	1975-06-03	5001	0	\N	0	0	\N	\N	0	296037	0	8331-1	3006322		
11268	1083	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	71173	0	6844-5	3020655		
66758	2051	4024958	1974-05-22	1974-05-22 00:00:00	1974-05-22	5001	0	\N	0	0	\N	\N	0	136354	0	117015009	4024958		
22638	2075	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	138118	0	6844-5	3020655		
11038	350	4024958	1962-10-05	1962-10-05 00:00:00	1962-10-05	5001	0	\N	0	0	\N	\N	0	23297	0	117015009	4024958		
45688	4217	3006322	1973-09-06	1973-09-06 00:00:00	1973-09-06	5001	0	\N	0	0	\N	\N	0	279973	0	8331-1	3006322		
171161	5252	4133840	2007-12-04	2007-12-04 00:00:00	2007-12-04	5001	0	\N	0	0	\N	\N	0	349472	0	127783003	4133840		
14295	1335	3006322	1984-12-15	1984-12-15 00:00:00	1984-12-15	5001	0	\N	0	0	\N	\N	0	88562	0	8331-1	3006322		
44355	4092	3006322	1996-08-08	1996-08-08 00:00:00	1996-08-08	5001	0	\N	0	0	\N	\N	0	272045	0	8331-1	3006322		
25715	2357	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	157052	0	6085-5	3001247		
37111	3414	3006322	1993-01-13	1993-01-13 00:00:00	1993-01-13	5001	0	\N	0	0	\N	\N	0	226460	0	8331-1	3006322		
51429	4705	3006322	1985-05-21	1985-05-21 00:00:00	1985-05-21	5001	0	\N	0	0	\N	\N	0	313477	0	8331-1	3006322		
127927	3938	4052083	1926-07-06	1926-07-06 00:00:00	1926-07-06	5001	0	\N	0	0	\N	\N	0	261770	0	23426006	4052083		
31942	2915	3006322	1955-03-19	1955-03-19 00:00:00	1955-03-19	5001	0	\N	0	0	\N	\N	0	194344	0	8331-1	3006322		
40079	1246	4052083	2005-04-12	2005-04-12 00:00:00	2005-04-12	5001	0	\N	0	0	\N	\N	0	82091	0	23426006	4052083		
35406	3241	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	215501	0	6189-5	3006734		
46759	4305	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	285642	0	6844-5	3020655		
37796	3483	3006322	1976-12-11	1976-12-11 00:00:00	1976-12-11	5001	0	\N	0	0	\N	\N	0	231024	0	8331-1	3006322		
18794	1727	3045716	1982-03-24	1982-03-24 00:00:00	1982-03-24	5001	0	\N	0	0	\N	\N	0	115482	0	33037-3	3045716		
57799	5309	3006322	1996-01-06	1996-01-06 00:00:00	1996-01-06	5001	0	\N	0	0	\N	\N	0	353118	0	8331-1	3006322		
15580	488	4024958	1960-07-31	1960-07-31 00:00:00	1960-07-31	5001	0	\N	0	0	\N	\N	0	32672	0	117015009	4024958		
21868	2013	3051031	1967-04-09	1967-04-09 00:00:00	1967-04-09	5001	0	\N	0	0	\N	\N	0	133939	0	46240-8	3051031		
23693	742	4024958	1951-12-08	1951-12-08 00:00:00	1951-12-08	5001	0	\N	0	0	\N	\N	0	49215	0	117015009	4024958		
23789	743	4024958	1986-08-07	1986-08-07 00:00:00	1986-08-07	5001	0	\N	0	0	\N	\N	0	49276	0	117015009	4024958		
39699	3689	3006322	1971-09-23	1971-09-23 00:00:00	1971-09-23	5001	0	\N	0	0	\N	\N	0	245216	0	8331-1	3006322		
13652	1283	3006923	1972-04-22	1972-04-22 00:00:00	1972-04-22	5001	0	\N	0	0	\N	\N	0	84823	0	1742-6	3006923		
19309	1766	3011505	1994-05-24	1994-05-24 00:00:00	1994-05-24	5001	0	\N	0	0	\N	\N	0	118159	0	19926-5	3011505		
17616	1604	3011505	2005-07-07	2005-07-07 00:00:00	2005-07-07	5001	0	\N	0	0	\N	\N	0	107636	0	19926-5	3011505		
10782	1051	3006322	1998-06-24	1998-06-24 00:00:00	1998-06-24	5001	0	\N	0	0	\N	\N	0	68877	0	8331-1	3006322		
36561	3364	3019406	1977-10-02	1977-10-02 00:00:00	1977-10-02	5001	0	\N	0	0	\N	\N	0	223078	0	6158-0	3019406		
36638	3370	3012494	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	223481	0	6206-7	3012494		
56842	5215	3006322	1943-08-28	1943-08-28 00:00:00	1943-08-28	5001	0	\N	0	0	\N	\N	0	346821	0	8331-1	3006322		
127782	3932	4024958	1978-11-09	1978-11-09 00:00:00	1978-11-09	5001	0	\N	0	0	\N	\N	0	261352	0	117015009	4024958		
50933	4642	3023430	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	309400	0	6833-8	3023430		
51010	4653	3006322	2004-07-18	2004-07-18 00:00:00	2004-07-18	5001	0	\N	0	0	\N	\N	0	310140	0	8331-1	3006322		
36280	3337	40766240	2013-08-22	2013-08-22 00:00:00	2013-08-22	5001	0	\N	0	0	\N	\N	0	221375	0	63513-6	40766240		
137781	4246	4024958	1967-05-01	1967-05-01 00:00:00	1967-05-01	5001	0	\N	0	0	\N	\N	0	281984	0	117015009	4024958		
56647	5200	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	345902	0	6095-4	3036780		
38282	3528	3036780	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	234230	0	6095-4	3036780		
46521	4279	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	283993	0	6248-9	3015076		
49725	4521	3006322	1987-02-23	1987-02-23 00:00:00	1987-02-23	5001	0	\N	0	0	\N	\N	0	300966	0	8331-1	3006322		
42810	3957	3011505	1996-12-19	1996-12-19 00:00:00	1996-12-19	5001	0	\N	0	0	\N	\N	0	263068	0	19926-5	3011505		
43701	4033	40758406	2004-02-02	2004-02-02 00:00:00	2004-02-02	5001	0	\N	0	0	\N	\N	0	268361	0	55277-8	40758406		
117573	3622	4052083	1948-12-04	1948-12-04 00:00:00	1948-12-04	5001	0	\N	0	0	\N	\N	0	240769	0	23426006	4052083		
36458	1132	4052083	1998-03-10	1998-03-10 00:00:00	1998-03-10	5001	0	\N	0	0	\N	\N	0	74494	0	23426006	4052083		
12205	1162	3051031	1978-07-14	1978-07-14 00:00:00	1978-07-14	5001	0	\N	0	0	\N	\N	0	76714	0	46240-8	3051031		
12285	1174	40766240	1941-02-11	1941-02-11 00:00:00	1941-02-11	5001	0	\N	0	0	\N	\N	0	77303	0	63513-6	40766240		
12344	1175	3000876	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	77538	0	6082-2	3000876		
75101	2300	4133840	2010-02-18	2010-02-18 00:00:00	2010-02-18	5001	0	\N	0	0	\N	\N	0	153134	0	127783003	4133840		
7653	738	3006322	1986-08-22	1986-08-22 00:00:00	1986-08-22	5001	0	\N	0	0	\N	\N	0	48866	0	8331-1	3006322		
21686	682	4052083	1982-02-20	1982-02-20 00:00:00	1982-02-20	5001	0	\N	0	0	\N	\N	0	45187	0	23426006	4052083		
35262	3221	3006322	1986-03-01	1986-03-01 00:00:00	1986-03-01	5001	0	\N	0	0	\N	\N	0	214109	0	8331-1	3006322		
95972	2943	4052083	1994-05-30	1994-05-30 00:00:00	1994-05-30	5001	0	\N	0	0	\N	\N	0	196323	0	23426006	4052083		
3587	343	3005136	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	22856	0	6075-6	3005136		
22064	2025	3006322	2012-01-28	2012-01-28 00:00:00	2012-01-28	5001	0	\N	0	0	\N	\N	0	134724	0	8331-1	3006322		
25435	2334	3011505	1965-04-29	1965-04-29 00:00:00	1965-04-29	5001	0	\N	0	0	\N	\N	0	155331	0	19926-5	3011505		
2903	273	3023430	1976-09-25	1976-09-25 00:00:00	1976-09-25	5001	0	\N	0	0	\N	\N	0	18193	0	6833-8	3023430		
24203	2226	3006322	2003-11-10	2003-11-10 00:00:00	2003-11-10	5001	0	\N	0	0	\N	\N	0	148076	0	8331-1	3006322		
33649	3056	3006322	2004-11-16	2004-11-16 00:00:00	2004-11-16	5001	0	\N	0	0	\N	\N	0	203255	0	8331-1	3006322		
35666	3258	3006322	2005-11-27	2005-11-27 00:00:00	2005-11-27	5001	0	\N	0	0	\N	\N	0	216557	0	8331-1	3006322		
143397	4406	4024958	1967-07-06	1967-07-06 00:00:00	1967-07-06	5001	0	\N	0	0	\N	\N	0	292892	0	117015009	4024958		
47117	4342	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	287964	0	6158-0	3019406		
31384	962	4024958	1994-03-02	1994-03-02 00:00:00	1994-03-02	5001	0	\N	0	0	\N	\N	0	64028	0	117015009	4024958		
64817	1987	4024958	1944-08-09	1944-08-09 00:00:00	1944-08-09	5001	0	\N	0	0	\N	\N	0	132281	0	117015009	4024958		
48702	4450	3006322	1980-05-29	1980-05-29 00:00:00	1980-05-29	5001	0	\N	0	0	\N	\N	0	296038	0	8331-1	3006322		
11456	1097	3006322	1969-09-25	1969-09-25 00:00:00	1969-09-25	5001	0	\N	0	0	\N	\N	0	72014	0	8331-1	3006322		
9572	304	4052083	1959-05-24	1959-05-24 00:00:00	1959-05-24	5001	0	\N	0	0	\N	\N	0	20215	0	23426006	4052083		
22639	2075	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	138118	0	7258-7	3001488		
11053	350	4024958	1994-03-03	1994-03-03 00:00:00	1994-03-03	5001	0	\N	0	0	\N	\N	0	23326	0	117015009	4024958		
93483	2876	4133840	2008-06-12	2008-06-12 00:00:00	2008-06-12	5001	0	\N	0	0	\N	\N	0	191384	0	127783003	4133840		
171162	5252	4133840	2017-05-30	2017-05-30 00:00:00	2017-05-30	5001	0	\N	0	0	\N	\N	0	349448	0	127783003	4133840		
14301	1338	3049273	2019-03-23	2019-03-23 00:00:00	2019-03-23	5001	0	\N	0	0	\N	\N	0	88765	0	38265-5	3049273		
44356	4092	3006322	1973-10-09	1973-10-09 00:00:00	1973-10-09	5001	0	\N	0	0	\N	\N	0	272019	0	8331-1	3006322		
25716	2357	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	157052	0	6189-5	3006734		
137943	4250	4052083	1974-03-11	1974-03-11 00:00:00	1974-03-11	5001	0	\N	0	0	\N	\N	0	282291	0	23426006	4052083		
51433	4707	3006322	1991-11-14	1991-11-14 00:00:00	1991-11-14	5001	0	\N	0	0	\N	\N	0	313557	0	8331-1	3006322		
127944	3938	4024958	1922-02-05	1922-02-05 00:00:00	1922-02-05	5001	0	\N	0	0	\N	\N	0	261774	0	117015009	4024958		
31944	2915	3051031	2011-06-20	2011-06-20 00:00:00	2011-06-20	5001	0	\N	0	0	\N	\N	0	194244	0	46240-8	3051031		
40094	1246	4024958	1954-05-28	1954-05-28 00:00:00	1954-05-28	5001	0	\N	0	0	\N	\N	0	82112	0	117015009	4024958		
35407	3241	3006322	1980-09-29	1980-09-29 00:00:00	1980-09-29	5001	0	\N	0	0	\N	\N	0	215576	0	8331-1	3006322		
46760	4305	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	285642	0	6206-7	3012494		
37797	3483	3006322	1963-11-29	1963-11-29 00:00:00	1963-11-29	5001	0	\N	0	0	\N	\N	0	231077	0	8331-1	3006322		
18795	1727	3015632	1982-03-24	1982-03-24 00:00:00	1982-03-24	5001	0	\N	0	0	\N	\N	0	115482	0	2028-9	3015632		
57800	5309	3006322	1998-01-06	1998-01-06 00:00:00	1998-01-06	5001	0	\N	0	0	\N	\N	0	353088	0	8331-1	3006322		
15587	488	4024958	1962-07-31	1962-07-31 00:00:00	1962-07-31	5001	0	\N	0	0	\N	\N	0	32681	0	117015009	4024958		
21870	2013	40766240	1967-04-09	1967-04-09 00:00:00	1967-04-09	5001	0	\N	0	0	\N	\N	0	133939	0	63513-6	40766240		
23694	742	4133840	1972-11-20	1972-11-20 00:00:00	1972-11-20	5001	0	\N	0	0	\N	\N	0	49151	0	127783003	4133840		
23800	744	4024958	1960-03-19	1960-03-19 00:00:00	1960-03-19	5001	0	\N	0	0	\N	\N	0	49313	0	117015009	4024958		
80108	2466	4052083	1979-10-17	1979-10-17 00:00:00	1979-10-17	5001	0	\N	0	0	\N	\N	0	163502	0	23426006	4052083		
13653	1283	3024731	1972-04-22	1972-04-22 00:00:00	1972-04-22	5001	0	\N	0	0	\N	\N	0	84823	0	30428-7	3024731		
19310	1766	3011505	2003-06-17	2003-06-17 00:00:00	2003-06-17	5001	0	\N	0	0	\N	\N	0	118162	0	19926-5	3011505		
17617	1604	3049273	2018-12-27	2018-12-27 00:00:00	2018-12-27	5001	0	\N	0	0	\N	\N	0	107607	0	38265-5	3049273		
10783	1051	3006322	1990-09-22	1990-09-22 00:00:00	1990-09-22	5001	0	\N	0	0	\N	\N	0	68880	0	8331-1	3006322		
36562	3364	3027231	1977-10-02	1977-10-02 00:00:00	1977-10-02	5001	0	\N	0	0	\N	\N	0	223078	0	6276-0	3027231		
36639	3370	3019406	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	223481	0	6158-0	3019406		
56843	5215	3049273	2004-03-30	2004-03-30 00:00:00	2004-03-30	5001	0	\N	0	0	\N	\N	0	346922	0	38265-5	3049273		
127787	3932	4052083	2006-09-27	2006-09-27 00:00:00	2006-09-27	5001	0	\N	0	0	\N	\N	0	261380	0	23426006	4052083		
50934	4642	3027231	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	309400	0	6276-0	3027231		
51011	4653	3006322	1964-09-24	1964-09-24 00:00:00	1964-09-24	5001	0	\N	0	0	\N	\N	0	310166	0	8331-1	3006322		
36281	3337	46235214	2013-08-22	2013-08-22 00:00:00	2013-08-22	5001	0	\N	0	0	\N	\N	0	221375	0	76690-7	46235214		
137783	4246	4052083	1969-10-14	1969-10-14 00:00:00	1969-10-14	5001	0	\N	0	0	\N	\N	0	281985	0	23426006	4052083		
56648	5200	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	345902	0	6248-9	3015076		
38283	3528	3020655	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	234230	0	6844-5	3020655		
46522	4279	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	283993	0	6276-0	3027231		
49726	4521	3006322	2006-10-19	2006-10-19 00:00:00	2006-10-19	5001	0	\N	0	0	\N	\N	0	300988	0	8331-1	3006322		
42811	3957	3006322	1964-03-10	1964-03-10 00:00:00	1964-03-10	5001	0	\N	0	0	\N	\N	0	263134	0	8331-1	3006322		
43702	4033	3006322	1979-11-21	1979-11-21 00:00:00	1979-11-21	5001	0	\N	0	0	\N	\N	0	268316	0	8331-1	3006322		
117586	3622	4024958	2012-09-04	2012-09-04 00:00:00	2012-09-04	5001	0	\N	0	0	\N	\N	0	240781	0	117015009	4024958		
36459	1132	4024958	1997-02-09	1997-02-09 00:00:00	1997-02-09	5001	0	\N	0	0	\N	\N	0	74508	0	117015009	4024958		
12206	1162	40766240	1978-07-14	1978-07-14 00:00:00	1978-07-14	5001	0	\N	0	0	\N	\N	0	76714	0	63513-6	40766240		
12286	1174	40758406	1941-02-11	1941-02-11 00:00:00	1941-02-11	5001	0	\N	0	0	\N	\N	0	77303	0	55277-8	40758406		
12345	1175	3027231	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	77538	0	6276-0	3027231		
75102	2300	4024958	1966-03-29	1966-03-29 00:00:00	1966-03-29	5001	0	\N	0	0	\N	\N	0	153204	0	117015009	4024958		
7654	738	3006322	2018-10-07	2018-10-07 00:00:00	2018-10-07	5001	0	\N	0	0	\N	\N	0	48888	0	8331-1	3006322		
21693	682	4024958	1981-09-04	1981-09-04 00:00:00	1981-09-04	5001	0	\N	0	0	\N	\N	0	45156	0	117015009	4024958		
35263	3221	3006322	1970-02-26	1970-02-26 00:00:00	1970-02-26	5001	0	\N	0	0	\N	\N	0	214071	0	8331-1	3006322		
61315	1874	4024958	1986-08-08	1986-08-08 00:00:00	1986-08-08	5001	0	\N	0	0	\N	\N	0	125130	0	117015009	4024958		
3588	343	3015076	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	22856	0	6248-9	3015076		
22065	2025	3006322	1911-10-21	1911-10-21 00:00:00	1911-10-21	5001	0	\N	0	0	\N	\N	0	134768	0	8331-1	3006322		
25436	2334	3011505	2012-06-28	2012-06-28 00:00:00	2012-06-28	5001	0	\N	0	0	\N	\N	0	155284	0	19926-5	3011505		
2904	273	3006322	2002-07-25	2002-07-25 00:00:00	2002-07-25	5001	0	\N	0	0	\N	\N	0	18295	0	8331-1	3006322		
24204	2226	3006322	1982-02-21	1982-02-21 00:00:00	1982-02-21	5001	0	\N	0	0	\N	\N	0	148118	0	8331-1	3006322		
33650	3056	3006322	1972-11-18	1972-11-18 00:00:00	1972-11-18	5001	0	\N	0	0	\N	\N	0	203285	0	8331-1	3006322		
35667	3258	3006322	2012-08-20	2012-08-20 00:00:00	2012-08-20	5001	0	\N	0	0	\N	\N	0	216623	0	8331-1	3006322		
143402	4406	4024958	1948-01-08	1948-01-08 00:00:00	1948-01-08	5001	0	\N	0	0	\N	\N	0	292872	0	117015009	4024958		
47118	4342	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	287964	0	6095-4	3036780		
31392	962	4024958	1955-09-30	1955-09-30 00:00:00	1955-09-30	5001	0	\N	0	0	\N	\N	0	64021	0	117015009	4024958		
64824	1987	4024958	2006-04-03	2006-04-03 00:00:00	2006-04-03	5001	0	\N	0	0	\N	\N	0	132339	0	117015009	4024958		
48703	4450	3006322	1975-12-11	1975-12-11 00:00:00	1975-12-11	5001	0	\N	0	0	\N	\N	0	296091	0	8331-1	3006322		
22745	2087	3006322	2008-10-09	2008-10-09 00:00:00	2008-10-09	5001	0	\N	0	0	\N	\N	0	139127	0	8331-1	3006322		
9578	304	4024958	2005-09-14	2005-09-14 00:00:00	2005-09-14	5001	0	\N	0	0	\N	\N	0	20254	0	117015009	4024958		
22640	2075	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	138118	0	6075-6	3005136		
11054	350	4052083	2008-11-01	2008-11-01 00:00:00	2008-11-01	5001	0	\N	0	0	\N	\N	0	23259	0	23426006	4052083		
93485	2876	4133840	2014-10-16	2014-10-16 00:00:00	2014-10-16	5001	0	\N	0	0	\N	\N	0	191354	0	127783003	4133840		
171167	5252	4133840	2004-04-13	2004-04-13 00:00:00	2004-04-13	5001	0	\N	0	0	\N	\N	0	349445	0	127783003	4133840		
14302	1338	3006322	1946-10-25	1946-10-25 00:00:00	1946-10-25	5001	0	\N	0	0	\N	\N	0	88682	0	8331-1	3006322		
44357	4092	3006322	2007-04-04	2007-04-04 00:00:00	2007-04-04	5001	0	\N	0	0	\N	\N	0	272048	0	8331-1	3006322		
25717	2357	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	157052	0	6844-5	3020655		
137945	4250	4024958	2001-08-28	2001-08-28 00:00:00	2001-08-28	5001	0	\N	0	0	\N	\N	0	282293	0	117015009	4024958		
51434	4707	3006322	1975-01-01	1975-01-01 00:00:00	1975-01-01	5001	0	\N	0	0	\N	\N	0	313571	0	8331-1	3006322		
127952	3938	4024958	1946-12-09	1946-12-09 00:00:00	1946-12-09	5001	0	\N	0	0	\N	\N	0	261776	0	117015009	4024958		
31945	2915	46235214	2011-06-20	2011-06-20 00:00:00	2011-06-20	5001	0	\N	0	0	\N	\N	0	194244	0	76690-7	46235214		
40096	1246	4052083	1971-09-30	1971-09-30 00:00:00	1971-09-30	5001	0	\N	0	0	\N	\N	0	82041	0	23426006	4052083		
35408	3241	3006322	1964-07-15	1964-07-15 00:00:00	1964-07-15	5001	0	\N	0	0	\N	\N	0	215449	0	8331-1	3006322		
46761	4305	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	285642	0	6158-0	3019406		
37798	3483	3006322	1968-04-15	1968-04-15 00:00:00	1968-04-15	5001	0	\N	0	0	\N	\N	0	231086	0	8331-1	3006322		
30073	2767	3023103	1939-05-23	1939-05-23 00:00:00	1939-05-23	5001	0	\N	0	0	\N	\N	0	183063	0	2823-3	3023103		
57801	5309	3006322	1954-02-15	1954-02-15 00:00:00	1954-02-15	5001	0	\N	0	0	\N	\N	0	353070	0	8331-1	3006322		
15605	488	4024958	1995-03-29	1995-03-29 00:00:00	1995-03-29	5001	0	\N	0	0	\N	\N	0	32620	0	117015009	4024958		
21871	2013	46235214	1967-04-09	1967-04-09 00:00:00	1967-04-09	5001	0	\N	0	0	\N	\N	0	133939	0	76690-7	46235214		
23697	742	4133840	1960-03-28	1960-03-28 00:00:00	1960-03-28	5001	0	\N	0	0	\N	\N	0	49149	0	127783003	4133840		
35090	1092	4024958	1966-08-24	1966-08-24 00:00:00	1966-08-24	5001	0	\N	0	0	\N	\N	0	71814	0	117015009	4024958		
80121	2466	4052083	2004-04-26	2004-04-26 00:00:00	2004-04-26	5001	0	\N	0	0	\N	\N	0	163506	0	23426006	4052083		
13654	1283	3026361	1972-04-22	1972-04-22 00:00:00	1972-04-22	5001	0	\N	0	0	\N	\N	0	84823	0	26453-1	3026361		
19311	1766	3011505	2002-06-11	2002-06-11 00:00:00	2002-06-11	5001	0	\N	0	0	\N	\N	0	118166	0	19926-5	3011505		
17618	1604	3011505	2001-06-21	2001-06-21 00:00:00	2001-06-21	5001	0	\N	0	0	\N	\N	0	107652	0	19926-5	3011505		
10784	1051	3006322	2013-11-28	2013-11-28 00:00:00	2013-11-28	5001	0	\N	0	0	\N	\N	0	68909	0	8331-1	3006322		
36563	3364	3006322	2013-10-18	2013-10-18 00:00:00	2013-10-18	5001	0	\N	0	0	\N	\N	0	223065	0	8331-1	3006322		
36640	3370	3021226	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	223481	0	6246-3	3021226		
56844	5215	3006322	1949-06-18	1949-06-18 00:00:00	1949-06-18	5001	0	\N	0	0	\N	\N	0	346822	0	8331-1	3006322		
46114	4255	3051031	1975-05-23	1975-05-23 00:00:00	1975-05-23	5001	0	\N	0	0	\N	\N	0	282511	0	46240-8	3051031		
50935	4642	3005136	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	309400	0	6075-6	3005136		
51012	4653	3006322	1997-04-13	1997-04-13 00:00:00	1997-04-13	5001	0	\N	0	0	\N	\N	0	310170	0	8331-1	3006322		
36283	3337	3051031	2013-08-22	2013-08-22 00:00:00	2013-08-22	5001	0	\N	0	0	\N	\N	0	221375	0	46240-8	3051031		
137784	4246	4052083	2005-08-14	2005-08-14 00:00:00	2005-08-14	5001	0	\N	0	0	\N	\N	0	281922	0	23426006	4052083		
56649	5200	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	345902	0	6189-5	3006734		
38284	3528	3023430	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	234230	0	6833-8	3023430		
46523	4279	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	283993	0	6106-9	3014599		
49727	4521	3006322	1965-09-05	1965-09-05 00:00:00	1965-09-05	5001	0	\N	0	0	\N	\N	0	301040	0	8331-1	3006322		
42812	3957	3011505	2013-10-17	2013-10-17 00:00:00	2013-10-17	5001	0	\N	0	0	\N	\N	0	263062	0	19926-5	3011505		
43704	4035	3006322	2019-03-09	2019-03-09 00:00:00	2019-03-09	5001	0	\N	0	0	\N	\N	0	268461	0	8331-1	3006322		
9726	914	3049273	2015-06-09	2015-06-09 00:00:00	2015-06-09	5001	0	\N	0	0	\N	\N	0	60733	0	38265-5	3049273		
36478	1133	4052083	1973-03-30	1973-03-30 00:00:00	1973-03-30	5001	0	\N	0	0	\N	\N	0	74587	0	23426006	4052083		
12209	1162	40758406	1978-07-14	1978-07-14 00:00:00	1978-07-14	5001	0	\N	0	0	\N	\N	0	76714	0	55277-8	40758406		
12287	1174	46235214	1941-02-11	1941-02-11 00:00:00	1941-02-11	5001	0	\N	0	0	\N	\N	0	77303	0	76690-7	46235214		
12346	1175	3014599	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	77538	0	6106-9	3014599		
75104	2300	4133840	2015-03-19	2015-03-19 00:00:00	2015-03-19	5001	0	\N	0	0	\N	\N	0	153154	0	127783003	4133840		
7655	738	3006322	2007-02-28	2007-02-28 00:00:00	2007-02-28	5001	0	\N	0	0	\N	\N	0	48903	0	8331-1	3006322		
21696	682	4024958	2018-03-21	2018-03-21 00:00:00	2018-03-21	5001	0	\N	0	0	\N	\N	0	45158	0	117015009	4024958		
46541	4283	3006322	1990-09-11	1990-09-11 00:00:00	1990-09-11	5001	0	\N	0	0	\N	\N	0	284263	0	8331-1	3006322		
61316	1874	4024958	1987-10-18	1987-10-18 00:00:00	1987-10-18	5001	0	\N	0	0	\N	\N	0	125100	0	117015009	4024958		
3589	343	3036780	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	22856	0	6095-4	3036780		
22066	2025	3006322	1920-08-18	1920-08-18 00:00:00	1920-08-18	5001	0	\N	0	0	\N	\N	0	134747	0	8331-1	3006322		
25440	2337	3006322	1998-12-05	1998-12-05 00:00:00	1998-12-05	5001	0	\N	0	0	\N	\N	0	155492	0	8331-1	3006322		
2905	273	3006322	1983-09-19	1983-09-19 00:00:00	1983-09-19	5001	0	\N	0	0	\N	\N	0	18266	0	8331-1	3006322		
24206	2228	3006322	2000-03-01	2000-03-01 00:00:00	2000-03-01	5001	0	\N	0	0	\N	\N	0	148247	0	8331-1	3006322		
33651	3056	3006322	1964-02-22	1964-02-22 00:00:00	1964-02-22	5001	0	\N	0	0	\N	\N	0	203238	0	8331-1	3006322		
35668	3258	3006322	1992-01-04	1992-01-04 00:00:00	1992-01-04	5001	0	\N	0	0	\N	\N	0	216553	0	8331-1	3006322		
143403	4406	4024958	2014-12-23	2014-12-23 00:00:00	2014-12-23	5001	0	\N	0	0	\N	\N	0	292943	0	117015009	4024958		
47119	4342	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	287964	0	6085-5	3001247		
31396	962	4052083	2016-05-20	2016-05-20 00:00:00	2016-05-20	5001	0	\N	0	0	\N	\N	0	64100	0	23426006	4052083		
64855	1989	4052083	1984-04-14	1984-04-14 00:00:00	1984-04-14	5001	0	\N	0	0	\N	\N	0	132445	0	23426006	4052083		
48704	4450	3006322	1997-07-24	1997-07-24 00:00:00	1997-07-24	5001	0	\N	0	0	\N	\N	0	296069	0	8331-1	3006322		
22746	2087	3006322	1965-03-07	1965-03-07 00:00:00	1965-03-07	5001	0	\N	0	0	\N	\N	0	139086	0	8331-1	3006322		
46795	1430	4024958	1986-09-09	1986-09-09 00:00:00	1986-09-09	5001	0	\N	0	0	\N	\N	0	95154	0	117015009	4024958		
22641	2075	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	138118	0	6158-0	3019406		
11061	350	4024958	1970-12-16	1970-12-16 00:00:00	1970-12-16	5001	0	\N	0	0	\N	\N	0	23324	0	117015009	4024958		
93487	2876	4133840	2017-11-02	2017-11-02 00:00:00	2017-11-02	5001	0	\N	0	0	\N	\N	0	191391	0	127783003	4133840		
171168	5252	4133840	2015-05-19	2015-05-19 00:00:00	2015-05-19	5001	0	\N	0	0	\N	\N	0	349447	0	127783003	4133840		
14303	1338	3006322	1994-04-08	1994-04-08 00:00:00	1994-04-08	5001	0	\N	0	0	\N	\N	0	88687	0	8331-1	3006322		
44358	4092	3006322	1996-11-19	1996-11-19 00:00:00	1996-11-19	5001	0	\N	0	0	\N	\N	0	272046	0	8331-1	3006322		
25718	2357	3006322	1967-06-28	1967-06-28 00:00:00	1967-06-28	5001	0	\N	0	0	\N	\N	0	157081	0	8331-1	3006322		
137948	4250	4024958	2002-12-04	2002-12-04 00:00:00	2002-12-04	5001	0	\N	0	0	\N	\N	0	282294	0	117015009	4024958		
51435	4707	3006322	1996-03-06	1996-03-06 00:00:00	1996-03-06	5001	0	\N	0	0	\N	\N	0	313591	0	8331-1	3006322		
127957	3938	4024958	1916-06-20	1916-06-20 00:00:00	1916-06-20	5001	0	\N	0	0	\N	\N	0	261773	0	117015009	4024958		
31946	2915	40766240	2011-06-20	2011-06-20 00:00:00	2011-06-20	5001	0	\N	0	0	\N	\N	0	194244	0	63513-6	40766240		
51386	1558	4024958	1999-08-03	1999-08-03 00:00:00	1999-08-03	5001	0	\N	0	0	\N	\N	0	104308	0	117015009	4024958		
35409	3241	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	215488	0	6082-2	3000876		
46762	4305	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	285642	0	6082-2	3000876		
37799	3483	3006322	1984-06-14	1984-06-14 00:00:00	1984-06-14	5001	0	\N	0	0	\N	\N	0	231063	0	8331-1	3006322		
30074	2767	3015632	1939-05-23	1939-05-23 00:00:00	1939-05-23	5001	0	\N	0	0	\N	\N	0	183063	0	2028-9	3015632		
57802	5309	3006322	1980-01-21	1980-01-21 00:00:00	1980-01-21	5001	0	\N	0	0	\N	\N	0	353072	0	8331-1	3006322		
3073	297	3006322	1967-12-17	1967-12-17 00:00:00	1967-12-17	5001	0	\N	0	0	\N	\N	0	19805	0	8331-1	3006322		
21872	2013	40758406	1967-12-05	1967-12-05 00:00:00	1967-12-05	5001	0	\N	0	0	\N	\N	0	133958	0	55277-8	40758406		
23698	742	4133840	2003-06-23	2003-06-23 00:00:00	2003-06-23	5001	0	\N	0	0	\N	\N	0	49181	0	127783003	4133840		
35092	1092	4024958	1970-11-11	1970-11-11 00:00:00	1970-11-11	5001	0	\N	0	0	\N	\N	0	71756	0	117015009	4024958		
80123	2466	4024958	1981-05-11	1981-05-11 00:00:00	1981-05-11	5001	0	\N	0	0	\N	\N	0	163503	0	117015009	4024958		
13655	1283	3000963	1972-04-22	1972-04-22 00:00:00	1972-04-22	5001	0	\N	0	0	\N	\N	0	84823	0	718-7	3000963		
19312	1766	3011505	2006-09-26	2006-09-26 00:00:00	2006-09-26	5001	0	\N	0	0	\N	\N	0	118168	0	19926-5	3011505		
17619	1604	3011505	2012-08-16	2012-08-16 00:00:00	2012-08-16	5001	0	\N	0	0	\N	\N	0	107654	0	19926-5	3011505		
10785	1051	3006322	2010-03-07	2010-03-07 00:00:00	2010-03-07	5001	0	\N	0	0	\N	\N	0	68878	0	8331-1	3006322		
36564	3364	3006322	2011-09-19	2011-09-19 00:00:00	2011-09-19	5001	0	\N	0	0	\N	\N	0	223154	0	8331-1	3006322		
36641	3370	3006451	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	223481	0	6273-7	3006451		
5837	549	3006322	1985-12-22	1985-12-22 00:00:00	1985-12-22	5001	0	\N	0	0	\N	\N	0	36357	0	8331-1	3006322		
46116	4255	40766240	1975-05-23	1975-05-23 00:00:00	1975-05-23	5001	0	\N	0	0	\N	\N	0	282511	0	63513-6	40766240		
50936	4642	3015076	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	309400	0	6248-9	3015076		
51013	4653	3006322	1989-05-11	1989-05-11 00:00:00	1989-05-11	5001	0	\N	0	0	\N	\N	0	310128	0	8331-1	3006322		
36285	3337	3051031	1971-09-07	1971-09-07 00:00:00	1971-09-07	5001	0	\N	0	0	\N	\N	0	221414	0	46240-8	3051031		
137785	4246	4024958	2002-04-03	2002-04-03 00:00:00	2002-04-03	5001	0	\N	0	0	\N	\N	0	281957	0	117015009	4024958		
56650	5200	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	345902	0	6085-5	3001247		
38285	3528	3019406	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	234230	0	6158-0	3019406		
46524	4279	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	283993	0	6095-4	3036780		
49728	4521	3049273	1972-05-11	1972-05-11 00:00:00	1972-05-11	5001	0	\N	0	0	\N	\N	0	301012	0	38265-5	3049273		
42813	3957	3011505	2007-09-13	2007-09-13 00:00:00	2007-09-13	5001	0	\N	0	0	\N	\N	0	263104	0	19926-5	3011505		
43705	4035	3006322	2018-04-02	2018-04-02 00:00:00	2018-04-02	5001	0	\N	0	0	\N	\N	0	268493	0	8331-1	3006322		
9727	914	3006322	1945-11-27	1945-11-27 00:00:00	1945-11-27	5001	0	\N	0	0	\N	\N	0	60754	0	8331-1	3006322		
36498	1134	4024958	1952-05-03	1952-05-03 00:00:00	1952-05-03	5001	0	\N	0	0	\N	\N	0	74664	0	117015009	4024958		
12210	1162	40758406	1920-11-30	1920-11-30 00:00:00	1920-11-30	5001	0	\N	0	0	\N	\N	0	76672	0	55277-8	40758406		
12288	1174	3006322	1944-08-22	1944-08-22 00:00:00	1944-08-22	5001	0	\N	0	0	\N	\N	0	77326	0	8331-1	3006322		
12347	1175	3006451	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	77538	0	6273-7	3006451		
75108	2300	4024958	2001-04-12	2001-04-12 00:00:00	2001-04-12	5001	0	\N	0	0	\N	\N	0	153178	0	117015009	4024958		
7656	738	3006322	1989-08-21	1989-08-21 00:00:00	1989-08-21	5001	0	\N	0	0	\N	\N	0	48891	0	8331-1	3006322		
21701	682	4024958	1983-04-12	1983-04-12 00:00:00	1983-04-12	5001	0	\N	0	0	\N	\N	0	45163	0	117015009	4024958		
46542	4283	3006322	1996-01-27	1996-01-27 00:00:00	1996-01-27	5001	0	\N	0	0	\N	\N	0	284290	0	8331-1	3006322		
61319	1874	4024958	2011-01-27	2011-01-27 00:00:00	2011-01-27	5001	0	\N	0	0	\N	\N	0	125133	0	117015009	4024958		
3590	343	3020655	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	22856	0	6844-5	3020655		
22067	2025	3006322	1950-09-04	1950-09-04 00:00:00	1950-09-04	5001	0	\N	0	0	\N	\N	0	134772	0	8331-1	3006322		
25441	2337	3006322	1992-09-25	1992-09-25 00:00:00	1992-09-25	5001	0	\N	0	0	\N	\N	0	155491	0	8331-1	3006322		
2909	276	3006322	1984-04-16	1984-04-16 00:00:00	1984-04-16	5001	0	\N	0	0	\N	\N	0	18417	0	8331-1	3006322		
24207	2228	3006322	1969-06-04	1969-06-04 00:00:00	1969-06-04	5001	0	\N	0	0	\N	\N	0	148245	0	8331-1	3006322		
33652	3056	3006322	2000-03-28	2000-03-28 00:00:00	2000-03-28	5001	0	\N	0	0	\N	\N	0	203254	0	8331-1	3006322		
35669	3258	3006322	1996-10-18	1996-10-18 00:00:00	1996-10-18	5001	0	\N	0	0	\N	\N	0	216580	0	8331-1	3006322		
143404	4406	4024958	1942-03-25	1942-03-25 00:00:00	1942-03-25	5001	0	\N	0	0	\N	\N	0	292861	0	117015009	4024958		
47120	4342	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	287964	0	6189-5	3006734		
31405	962	4024958	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	64089	0	117015009	4024958		
64856	1989	4024958	1976-05-30	1976-05-30 00:00:00	1976-05-30	5001	0	\N	0	0	\N	\N	0	132444	0	117015009	4024958		
48705	4450	3006322	2012-02-07	2012-02-07 00:00:00	2012-02-07	5001	0	\N	0	0	\N	\N	0	296073	0	8331-1	3006322		
22747	2087	3006322	1951-06-21	1951-06-21 00:00:00	1951-06-21	5001	0	\N	0	0	\N	\N	0	139028	0	8331-1	3006322		
46803	1430	4052083	1971-12-16	1971-12-16 00:00:00	1971-12-16	5001	0	\N	0	0	\N	\N	0	95123	0	23426006	4052083		
22642	2075	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	138118	0	6248-9	3015076		
11070	350	4024958	1968-07-16	1968-07-16 00:00:00	1968-07-16	5001	0	\N	0	0	\N	\N	0	23298	0	117015009	4024958		
93490	2876	4133840	2001-08-16	2001-08-16 00:00:00	2001-08-16	5001	0	\N	0	0	\N	\N	0	191388	0	127783003	4133840		
171171	5252	4133840	1997-04-08	1997-04-08 00:00:00	1997-04-08	5001	0	\N	0	0	\N	\N	0	349479	0	127783003	4133840		
14304	1338	3006322	1959-02-03	1959-02-03 00:00:00	1959-02-03	5001	0	\N	0	0	\N	\N	0	88717	0	8331-1	3006322		
44361	4094	3006322	1981-01-05	1981-01-05 00:00:00	1981-01-05	5001	0	\N	0	0	\N	\N	0	272124	0	8331-1	3006322		
25719	2357	3006322	1977-07-30	1977-07-30 00:00:00	1977-07-30	5001	0	\N	0	0	\N	\N	0	156935	0	8331-1	3006322		
137952	4250	4052083	1980-07-03	1980-07-03 00:00:00	1980-07-03	5001	0	\N	0	0	\N	\N	0	282287	0	23426006	4052083		
51436	4707	3006322	2000-02-25	2000-02-25 00:00:00	2000-02-25	5001	0	\N	0	0	\N	\N	0	313593	0	8331-1	3006322		
127962	3938	4052083	1956-02-04	1956-02-04 00:00:00	1956-02-04	5001	0	\N	0	0	\N	\N	0	261720	0	23426006	4052083		
31948	2915	40758406	2011-06-20	2011-06-20 00:00:00	2011-06-20	5001	0	\N	0	0	\N	\N	0	194244	0	55277-8	40758406		
51395	1558	4052083	2006-04-06	2006-04-06 00:00:00	2006-04-06	5001	0	\N	0	0	\N	\N	0	104309	0	23426006	4052083		
35410	3241	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	215488	0	6095-4	3036780		
46766	4308	3006322	1962-05-03	1962-05-03 00:00:00	1962-05-03	5001	0	\N	0	0	\N	\N	0	285753	0	8331-1	3006322		
37801	3486	3006322	1990-09-12	1990-09-12 00:00:00	1990-09-12	5001	0	\N	0	0	\N	\N	0	231300	0	8331-1	3006322		
30075	2767	3013682	1939-05-23	1939-05-23 00:00:00	1939-05-23	5001	0	\N	0	0	\N	\N	0	183063	0	3094-0	3013682		
57803	5309	3049273	2018-06-16	2018-06-16 00:00:00	2018-06-16	5001	0	\N	0	0	\N	\N	0	353149	0	38265-5	3049273		
3074	297	3006322	1976-12-09	1976-12-09 00:00:00	1976-12-09	5001	0	\N	0	0	\N	\N	0	19795	0	8331-1	3006322		
21874	2013	40766240	1967-12-05	1967-12-05 00:00:00	1967-12-05	5001	0	\N	0	0	\N	\N	0	133958	0	63513-6	40766240		
23700	742	4133840	1977-09-05	1977-09-05 00:00:00	1977-09-05	5001	0	\N	0	0	\N	\N	0	49119	0	127783003	4133840		
113245	3495	4052083	1979-05-06	1979-05-06 00:00:00	1979-05-06	5001	0	\N	0	0	\N	\N	0	231807	0	23426006	4052083		
80156	2468	4052083	1966-11-06	1966-11-06 00:00:00	1966-11-06	5001	0	\N	0	0	\N	\N	0	163611	0	23426006	4052083		
13656	1283	3002385	1972-04-22	1972-04-22 00:00:00	1972-04-22	5001	0	\N	0	0	\N	\N	0	84823	0	30385-9	3002385		
19313	1766	3011505	2016-11-22	2016-11-22 00:00:00	2016-11-22	5001	0	\N	0	0	\N	\N	0	118198	0	19926-5	3011505		
17620	1604	3011505	2015-09-03	2015-09-03 00:00:00	2015-09-03	5001	0	\N	0	0	\N	\N	0	107647	0	19926-5	3011505		
10786	1053	3006322	1985-03-25	1985-03-25 00:00:00	1985-03-25	5001	0	\N	0	0	\N	\N	0	69005	0	8331-1	3006322		
36565	3364	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	223119	0	6106-9	3014599		
36642	3370	3001247	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	223481	0	6085-5	3001247		
5838	549	3006322	2010-05-09	2010-05-09 00:00:00	2010-05-09	5001	0	\N	0	0	\N	\N	0	36367	0	8331-1	3006322		
46118	4255	46235214	1975-05-23	1975-05-23 00:00:00	1975-05-23	5001	0	\N	0	0	\N	\N	0	282511	0	76690-7	46235214		
50937	4642	3021226	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	309400	0	6246-3	3021226		
51014	4653	3006322	1989-03-01	1989-03-01 00:00:00	1989-03-01	5001	0	\N	0	0	\N	\N	0	310194	0	8331-1	3006322		
36287	3337	40758406	1971-09-07	1971-09-07 00:00:00	1971-09-07	5001	0	\N	0	0	\N	\N	0	221414	0	55277-8	40758406		
137789	4246	4024958	1973-05-10	1973-05-10 00:00:00	1973-05-10	5001	0	\N	0	0	\N	\N	0	281955	0	117015009	4024958		
56651	5200	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	345902	0	7258-7	3001488		
38286	3528	3027231	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	234230	0	6276-0	3027231		
46525	4279	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	283993	0	6085-5	3001247		
49730	4521	3006322	1967-12-03	1967-12-03 00:00:00	1967-12-03	5001	0	\N	0	0	\N	\N	0	301018	0	8331-1	3006322		
42814	3957	3011505	2016-11-03	2016-11-03 00:00:00	2016-11-03	5001	0	\N	0	0	\N	\N	0	263105	0	19926-5	3011505		
43706	4035	3006322	1986-11-04	1986-11-04 00:00:00	1986-11-04	5001	0	\N	0	0	\N	\N	0	268470	0	8331-1	3006322		
9728	914	3049273	2013-05-20	2013-05-20 00:00:00	2013-05-20	5001	0	\N	0	0	\N	\N	0	60732	0	38265-5	3049273		
834	61	3006322	2012-08-23	2012-08-23 00:00:00	2012-08-23	5001	0	\N	0	0	\N	\N	0	4078	0	8331-1	3006322		
12212	1162	40766240	1920-11-30	1920-11-30 00:00:00	1920-11-30	5001	0	\N	0	0	\N	\N	0	76672	0	63513-6	40766240		
12289	1174	3006322	1971-08-26	1971-08-26 00:00:00	1971-08-26	5001	0	\N	0	0	\N	\N	0	77328	0	8331-1	3006322		
12348	1175	3012494	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	77538	0	6206-7	3012494		
75109	2300	4133840	2003-01-09	2003-01-09 00:00:00	2003-01-09	5001	0	\N	0	0	\N	\N	0	153143	0	127783003	4133840		
7659	739	3006322	1949-10-08	1949-10-08 00:00:00	1949-10-08	5001	0	\N	0	0	\N	\N	0	48973	0	8331-1	3006322		
21703	682	4024958	1994-03-28	1994-03-28 00:00:00	1994-03-28	5001	0	\N	0	0	\N	\N	0	45157	0	117015009	4024958		
46543	4283	3006322	1970-09-15	1970-09-15 00:00:00	1970-09-15	5001	0	\N	0	0	\N	\N	0	284236	0	8331-1	3006322		
61338	1874	4052083	2000-11-27	2000-11-27 00:00:00	2000-11-27	5001	0	\N	0	0	\N	\N	0	125120	0	23426006	4052083		
3591	343	3000876	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	22856	0	6082-2	3000876		
22068	2025	3006322	1996-08-04	1996-08-04 00:00:00	1996-08-04	5001	0	\N	0	0	\N	\N	0	134670	0	8331-1	3006322		
25442	2337	3006322	2015-07-31	2015-07-31 00:00:00	2015-07-31	5001	0	\N	0	0	\N	\N	0	155523	0	8331-1	3006322		
2910	276	3006322	2006-03-05	2006-03-05 00:00:00	2006-03-05	5001	0	\N	0	0	\N	\N	0	18418	0	8331-1	3006322		
24208	2228	3049273	2007-04-21	2007-04-21 00:00:00	2007-04-21	5001	0	\N	0	0	\N	\N	0	148242	0	38265-5	3049273		
44937	4153	3006322	1980-01-27	1980-01-27 00:00:00	1980-01-27	5001	0	\N	0	0	\N	\N	0	276049	0	8331-1	3006322		
35670	3258	3049273	1995-07-09	1995-07-09 00:00:00	1995-07-09	5001	0	\N	0	0	\N	\N	0	216551	0	38265-5	3049273		
143407	4406	4052083	1969-11-27	1969-11-27 00:00:00	1969-11-27	5001	0	\N	0	0	\N	\N	0	292895	0	23426006	4052083		
14657	457	4052083	2003-03-01	2003-03-01 00:00:00	2003-03-01	5001	0	\N	0	0	\N	\N	0	30558	0	23426006	4052083		
31414	962	4024958	1951-02-09	1951-02-09 00:00:00	1951-02-09	5001	0	\N	0	0	\N	\N	0	64085	0	117015009	4024958		
64885	1990	4052083	1970-05-07	1970-05-07 00:00:00	1970-05-07	5001	0	\N	0	0	\N	\N	0	132535	0	23426006	4052083		
48706	4450	3006322	1982-06-28	1982-06-28 00:00:00	1982-06-28	5001	0	\N	0	0	\N	\N	0	296092	0	8331-1	3006322		
22748	2087	3006322	1980-12-07	1980-12-07 00:00:00	1980-12-07	5001	0	\N	0	0	\N	\N	0	139047	0	8331-1	3006322		
46818	1430	4052083	1946-02-11	1946-02-11 00:00:00	1946-02-11	5001	0	\N	0	0	\N	\N	0	95119	0	23426006	4052083		
22643	2075	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	138118	0	6189-5	3006734		
11071	350	4024958	2017-05-10	2017-05-10 00:00:00	2017-05-10	5001	0	\N	0	0	\N	\N	0	23313	0	117015009	4024958		
93494	2876	4133840	2013-10-10	2013-10-10 00:00:00	2013-10-10	5001	0	\N	0	0	\N	\N	0	191355	0	127783003	4133840		
171172	5252	4133840	2013-05-07	2013-05-07 00:00:00	2013-05-07	5001	0	\N	0	0	\N	\N	0	349428	0	127783003	4133840		
14305	1338	3006322	1999-01-26	1999-01-26 00:00:00	1999-01-26	5001	0	\N	0	0	\N	\N	0	88743	0	8331-1	3006322		
44362	4094	3006322	1957-10-15	1957-10-15 00:00:00	1957-10-15	5001	0	\N	0	0	\N	\N	0	272113	0	8331-1	3006322		
25720	2357	3049273	2009-02-24	2009-02-24 00:00:00	2009-02-24	5001	0	\N	0	0	\N	\N	0	157087	0	38265-5	3049273		
126718	3901	4052083	2017-07-16	2017-07-16 00:00:00	2017-07-16	5001	0	\N	0	0	\N	\N	0	259429	0	23426006	4052083		
51437	4709	3006322	1969-12-10	1969-12-10 00:00:00	1969-12-10	5001	0	\N	0	0	\N	\N	0	313689	0	8331-1	3006322		
127966	3938	4052083	1929-11-14	1929-11-14 00:00:00	1929-11-14	5001	0	\N	0	0	\N	\N	0	261701	0	23426006	4052083		
31949	2915	3006322	1950-07-18	1950-07-18 00:00:00	1950-07-18	5001	0	\N	0	0	\N	\N	0	194338	0	8331-1	3006322		
22903	718	4024958	1978-08-10	1978-08-10 00:00:00	1978-08-10	5001	0	\N	0	0	\N	\N	0	47499	0	117015009	4024958		
35411	3241	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	215488	0	6158-0	3019406		
46768	4308	3006322	1938-04-16	1938-04-16 00:00:00	1938-04-16	5001	0	\N	0	0	\N	\N	0	285766	0	8331-1	3006322		
37802	3486	3006322	2005-05-07	2005-05-07 00:00:00	2005-05-07	5001	0	\N	0	0	\N	\N	0	231240	0	8331-1	3006322		
30077	2767	3006322	1940-04-18	1940-04-18 00:00:00	1940-04-18	5001	0	\N	0	0	\N	\N	0	183047	0	8331-1	3006322		
128247	3949	4052083	1976-01-11	1976-01-11 00:00:00	1976-01-11	5001	0	\N	0	0	\N	\N	0	262439	0	23426006	4052083		
3075	297	3006322	1963-07-18	1963-07-18 00:00:00	1963-07-18	5001	0	\N	0	0	\N	\N	0	19804	0	8331-1	3006322		
21875	2013	46235214	1967-12-05	1967-12-05 00:00:00	1967-12-05	5001	0	\N	0	0	\N	\N	0	133958	0	76690-7	46235214		
23702	742	4133840	1983-10-10	1983-10-10 00:00:00	1983-10-10	5001	0	\N	0	0	\N	\N	0	49205	0	127783003	4133840		
124593	3851	4024958	1912-10-26	1912-10-26 00:00:00	1912-10-26	5001	0	\N	0	0	\N	\N	0	255561	0	117015009	4024958		
80163	2468	4052083	1959-01-09	1959-01-09 00:00:00	1959-01-09	5001	0	\N	0	0	\N	\N	0	163602	0	23426006	4052083		
13657	1283	3007461	1972-04-22	1972-04-22 00:00:00	1972-04-22	5001	0	\N	0	0	\N	\N	0	84823	0	26515-7	3007461		
19314	1766	3011505	2005-09-20	2005-09-20 00:00:00	2005-09-20	5001	0	\N	0	0	\N	\N	0	118164	0	19926-5	3011505		
17621	1604	3011505	2017-09-14	2017-09-14 00:00:00	2017-09-14	5001	0	\N	0	0	\N	\N	0	107601	0	19926-5	3011505		
10787	1053	3006322	1981-02-04	1981-02-04 00:00:00	1981-02-04	5001	0	\N	0	0	\N	\N	0	69045	0	8331-1	3006322		
36566	3364	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	223119	0	6075-6	3005136		
36643	3370	3027231	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	223481	0	6276-0	3027231		
5839	549	3006322	2004-04-26	2004-04-26 00:00:00	2004-04-26	5001	0	\N	0	0	\N	\N	0	36365	0	8331-1	3006322		
46119	4255	40758406	1975-05-23	1975-05-23 00:00:00	1975-05-23	5001	0	\N	0	0	\N	\N	0	282511	0	55277-8	40758406		
50938	4642	3006451	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	309400	0	6273-7	3006451		
126303	3890	4024958	1990-04-19	1990-04-19 00:00:00	1990-04-19	5001	0	\N	0	0	\N	\N	0	258553	0	117015009	4024958		
36288	3337	40766240	1971-09-07	1971-09-07 00:00:00	1971-09-07	5001	0	\N	0	0	\N	\N	0	221414	0	63513-6	40766240		
103823	3189	4024958	1987-12-08	1987-12-08 00:00:00	1987-12-08	5001	0	\N	0	0	\N	\N	0	212232	0	117015009	4024958		
56652	5200	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	345902	0	6844-5	3020655		
38287	3528	3006322	1982-10-14	1982-10-14 00:00:00	1982-10-14	5001	0	\N	0	0	\N	\N	0	234166	0	8331-1	3006322		
46526	4279	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	283993	0	6158-0	3019406		
49731	4521	3049273	1996-12-15	1996-12-15 00:00:00	1996-12-15	5001	0	\N	0	0	\N	\N	0	301015	0	38265-5	3049273		
42815	3957	3011505	2010-09-30	2010-09-30 00:00:00	2010-09-30	5001	0	\N	0	0	\N	\N	0	263058	0	19926-5	3011505		
58708	1785	4052083	2013-09-25	2013-09-25 00:00:00	2013-09-25	5001	0	\N	0	0	\N	\N	0	119598	0	23426006	4052083		
9729	914	3006322	1980-01-25	1980-01-25 00:00:00	1980-01-25	5001	0	\N	0	0	\N	\N	0	60716	0	8331-1	3006322		
835	61	3006322	2015-12-20	2015-12-20 00:00:00	2015-12-20	5001	0	\N	0	0	\N	\N	0	4100	0	8331-1	3006322		
12213	1162	46235214	1920-11-30	1920-11-30 00:00:00	1920-11-30	5001	0	\N	0	0	\N	\N	0	76672	0	76690-7	46235214		
12292	1174	3051031	1941-06-12	1941-06-12 00:00:00	1941-06-12	5001	0	\N	0	0	\N	\N	0	77360	0	46240-8	3051031		
12349	1175	3020655	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	77538	0	6844-5	3020655		
75110	2300	4133840	2009-02-12	2009-02-12 00:00:00	2009-02-12	5001	0	\N	0	0	\N	\N	0	153151	0	127783003	4133840		
7661	739	3006322	1981-11-14	1981-11-14 00:00:00	1981-11-14	5001	0	\N	0	0	\N	\N	0	48951	0	8331-1	3006322		
21988	691	4024958	1974-08-25	1974-08-25 00:00:00	1974-08-25	5001	0	\N	0	0	\N	\N	0	45743	0	117015009	4024958		
46544	4284	3006322	1990-03-17	1990-03-17 00:00:00	1990-03-17	5001	0	\N	0	0	\N	\N	0	284393	0	8331-1	3006322		
61342	1874	4052083	1987-06-22	1987-06-22 00:00:00	1987-06-22	5001	0	\N	0	0	\N	\N	0	125131	0	23426006	4052083		
3592	343	3012494	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	22856	0	6206-7	3012494		
22069	2026	3006322	1984-11-07	1984-11-07 00:00:00	1984-11-07	5001	0	\N	0	0	\N	\N	0	134792	0	8331-1	3006322		
25443	2337	3006322	2000-05-11	2000-05-11 00:00:00	2000-05-11	5001	0	\N	0	0	\N	\N	0	155536	0	8331-1	3006322		
2911	276	3006322	1978-11-02	1978-11-02 00:00:00	1978-11-02	5001	0	\N	0	0	\N	\N	0	18415	0	8331-1	3006322		
24209	2228	3006322	2000-10-12	2000-10-12 00:00:00	2000-10-12	5001	0	\N	0	0	\N	\N	0	148248	0	8331-1	3006322		
44938	4153	3006322	1991-12-04	1991-12-04 00:00:00	1991-12-04	5001	0	\N	0	0	\N	\N	0	276064	0	8331-1	3006322		
35671	3258	3006322	2010-09-15	2010-09-15 00:00:00	2010-09-15	5001	0	\N	0	0	\N	\N	0	216614	0	8331-1	3006322		
132269	4072	4052083	2010-10-28	2010-10-28 00:00:00	2010-10-28	5001	0	\N	0	0	\N	\N	0	270671	0	23426006	4052083		
14665	457	4052083	2007-03-10	2007-03-10 00:00:00	2007-03-10	5001	0	\N	0	0	\N	\N	0	30604	0	23426006	4052083		
31446	964	4024958	1981-11-13	1981-11-13 00:00:00	1981-11-13	5001	0	\N	0	0	\N	\N	0	64202	0	117015009	4024958		
64887	1990	4052083	1998-04-10	1998-04-10 00:00:00	1998-04-10	5001	0	\N	0	0	\N	\N	0	132486	0	23426006	4052083		
48707	4450	3006322	2004-02-02	2004-02-02 00:00:00	2004-02-02	5001	0	\N	0	0	\N	\N	0	296071	0	8331-1	3006322		
22749	2087	3049273	1997-02-06	1997-02-06 00:00:00	1997-02-06	5001	0	\N	0	0	\N	\N	0	139104	0	38265-5	3049273		
46822	1430	4052083	2017-11-18	2017-11-18 00:00:00	2017-11-18	5001	0	\N	0	0	\N	\N	0	95133	0	23426006	4052083		
22644	2075	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	138118	0	6082-2	3000876		
11074	350	4024958	1991-11-03	1991-11-03 00:00:00	1991-11-03	5001	0	\N	0	0	\N	\N	0	23332	0	117015009	4024958		
93499	2876	4133840	2018-11-08	2018-11-08 00:00:00	2018-11-08	5001	0	\N	0	0	\N	\N	0	191375	0	127783003	4133840		
171173	5252	4133840	2012-05-01	2012-05-01 00:00:00	2012-05-01	5001	0	\N	0	0	\N	\N	0	349436	0	127783003	4133840		
14306	1338	3006322	1987-01-03	1987-01-03 00:00:00	1987-01-03	5001	0	\N	0	0	\N	\N	0	88685	0	8331-1	3006322		
44363	4094	3006322	1968-03-31	1968-03-31 00:00:00	1968-03-31	5001	0	\N	0	0	\N	\N	0	272121	0	8331-1	3006322		
25721	2357	3006322	1993-10-02	1993-10-02 00:00:00	1993-10-02	5001	0	\N	0	0	\N	\N	0	156982	0	8331-1	3006322		
126721	3901	4024958	1947-06-28	1947-06-28 00:00:00	1947-06-28	5001	0	\N	0	0	\N	\N	0	259402	0	117015009	4024958		
51438	4709	3006322	2001-10-21	2001-10-21 00:00:00	2001-10-21	5001	0	\N	0	0	\N	\N	0	313693	0	8331-1	3006322		
55985	1707	4024958	1988-11-18	1988-11-18 00:00:00	1988-11-18	5001	0	\N	0	0	\N	\N	0	114148	0	117015009	4024958		
31950	2915	3006322	2005-06-20	2005-06-20 00:00:00	2005-06-20	5001	0	\N	0	0	\N	\N	0	194243	0	8331-1	3006322		
34241	1072	4024958	1977-11-20	1977-11-20 00:00:00	1977-11-20	5001	0	\N	0	0	\N	\N	0	70247	0	117015009	4024958		
35412	3241	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	215488	0	6246-3	3021226		
46770	4308	3006322	1916-12-29	1916-12-29 00:00:00	1916-12-29	5001	0	\N	0	0	\N	\N	0	285732	0	8331-1	3006322		
37803	3486	3006322	1964-01-17	1964-01-17 00:00:00	1964-01-17	5001	0	\N	0	0	\N	\N	0	231226	0	8331-1	3006322		
30078	2768	3006322	1974-11-13	1974-11-13 00:00:00	1974-11-13	5001	0	\N	0	0	\N	\N	0	183169	0	8331-1	3006322		
128280	3949	4024958	1992-12-22	1992-12-22 00:00:00	1992-12-22	5001	0	\N	0	0	\N	\N	0	262509	0	117015009	4024958		
3076	297	3006322	1960-03-20	1960-03-20 00:00:00	1960-03-20	5001	0	\N	0	0	\N	\N	0	19788	0	8331-1	3006322		
21876	2013	3051031	1967-12-05	1967-12-05 00:00:00	1967-12-05	5001	0	\N	0	0	\N	\N	0	133958	0	46240-8	3051031		
23705	742	4133840	2010-08-02	2010-08-02 00:00:00	2010-08-02	5001	0	\N	0	0	\N	\N	0	49125	0	127783003	4133840		
124595	3851	4052083	1969-02-17	1969-02-17 00:00:00	1969-02-17	5001	0	\N	0	0	\N	\N	0	255563	0	23426006	4052083		
80164	2468	4052083	1994-03-27	1994-03-27 00:00:00	1994-03-27	5001	0	\N	0	0	\N	\N	0	163635	0	23426006	4052083		
13658	1283	3045716	1972-04-22	1972-04-22 00:00:00	1972-04-22	5001	0	\N	0	0	\N	\N	0	84823	0	33037-3	3045716		
19315	1766	3011505	2013-11-05	2013-11-05 00:00:00	2013-11-05	5001	0	\N	0	0	\N	\N	0	118185	0	19926-5	3011505		
17622	1604	3011505	2010-08-05	2010-08-05 00:00:00	2010-08-05	5001	0	\N	0	0	\N	\N	0	107653	0	19926-5	3011505		
10788	1054	3049273	2000-02-03	2000-02-03 00:00:00	2000-02-03	5001	0	\N	0	0	\N	\N	0	69136	0	38265-5	3049273		
36567	3364	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	223119	0	6248-9	3015076		
36644	3370	3005136	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	223481	0	6075-6	3005136		
5840	549	3006322	1958-09-01	1958-09-01 00:00:00	1958-09-01	5001	0	\N	0	0	\N	\N	0	36355	0	8331-1	3006322		
46120	4255	3051031	1975-06-22	1975-06-22 00:00:00	1975-06-22	5001	0	\N	0	0	\N	\N	0	282537	0	46240-8	3051031		
50939	4642	3012494	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	309400	0	6206-7	3012494		
126305	3890	4024958	1987-01-19	1987-01-19 00:00:00	1987-01-19	5001	0	\N	0	0	\N	\N	0	258559	0	117015009	4024958		
36289	3337	46235214	1971-09-07	1971-09-07 00:00:00	1971-09-07	5001	0	\N	0	0	\N	\N	0	221414	0	76690-7	46235214		
103843	3191	4024958	1981-10-21	1981-10-21 00:00:00	1981-10-21	5001	0	\N	0	0	\N	\N	0	212360	0	117015009	4024958		
56653	5200	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	345902	0	6276-0	3027231		
38288	3528	3049273	2015-05-04	2015-05-04 00:00:00	2015-05-04	5001	0	\N	0	0	\N	\N	0	234284	0	38265-5	3049273		
46527	4279	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	283993	0	6246-3	3021226		
49733	4522	3006322	2003-09-08	2003-09-08 00:00:00	2003-09-08	5001	0	\N	0	0	\N	\N	0	301136	0	8331-1	3006322		
42816	3957	3051031	1966-08-10	1966-08-10 00:00:00	1966-08-10	5001	0	\N	0	0	\N	\N	0	263135	0	46240-8	3051031		
69995	2147	4052083	1988-01-23	1988-01-23 00:00:00	1988-01-23	5001	0	\N	0	0	\N	\N	0	142943	0	23426006	4052083		
9730	914	3006322	1950-05-18	1950-05-18 00:00:00	1950-05-18	5001	0	\N	0	0	\N	\N	0	60709	0	8331-1	3006322		
836	61	3006322	1977-12-03	1977-12-03 00:00:00	1977-12-03	5001	0	\N	0	0	\N	\N	0	4121	0	8331-1	3006322		
12215	1162	3051031	1920-11-30	1920-11-30 00:00:00	1920-11-30	5001	0	\N	0	0	\N	\N	0	76672	0	46240-8	3051031		
12293	1174	40758406	1941-06-12	1941-06-12 00:00:00	1941-06-12	5001	0	\N	0	0	\N	\N	0	77360	0	55277-8	40758406		
12350	1175	3019406	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	77538	0	6158-0	3019406		
75111	2300	4133840	1997-12-18	1997-12-18 00:00:00	1997-12-18	5001	0	\N	0	0	\N	\N	0	153197	0	127783003	4133840		
7662	739	3049273	1991-08-15	1991-08-15 00:00:00	1991-08-15	5001	0	\N	0	0	\N	\N	0	48934	0	38265-5	3049273		
67866	2078	4052083	1994-08-07	1994-08-07 00:00:00	1994-08-07	5001	0	\N	0	0	\N	\N	0	138428	0	23426006	4052083		
46545	4284	3006322	1998-04-01	1998-04-01 00:00:00	1998-04-01	5001	0	\N	0	0	\N	\N	0	284394	0	8331-1	3006322		
153472	4707	4024958	1991-11-14	1991-11-14 00:00:00	1991-11-14	5001	0	\N	0	0	\N	\N	0	313557	0	117015009	4024958		
3593	343	3006451	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	22856	0	6273-7	3006451		
22070	2026	3006322	1955-10-05	1955-10-05 00:00:00	1955-10-05	5001	0	\N	0	0	\N	\N	0	134789	0	8331-1	3006322		
25444	2337	3006322	1963-11-17	1963-11-17 00:00:00	1963-11-17	5001	0	\N	0	0	\N	\N	0	155535	0	8331-1	3006322		
2912	276	3006322	2009-04-03	2009-04-03 00:00:00	2009-04-03	5001	0	\N	0	0	\N	\N	0	18409	0	8331-1	3006322		
24210	2228	3006322	1980-05-15	1980-05-15 00:00:00	1980-05-15	5001	0	\N	0	0	\N	\N	0	148264	0	8331-1	3006322		
44963	4156	3006322	1998-11-09	1998-11-09 00:00:00	1998-11-09	5001	0	\N	0	0	\N	\N	0	276180	0	8331-1	3006322		
35672	3258	3006322	1991-04-27	1991-04-27 00:00:00	1991-04-27	5001	0	\N	0	0	\N	\N	0	216560	0	8331-1	3006322		
143577	4412	4024958	1982-10-17	1982-10-17 00:00:00	1982-10-17	5001	0	\N	0	0	\N	\N	0	293341	0	117015009	4024958		
26005	812	4024958	1977-08-20	1977-08-20 00:00:00	1977-08-20	5001	0	\N	0	0	\N	\N	0	53853	0	117015009	4024958		
31447	964	4024958	1980-11-04	1980-11-04 00:00:00	1980-11-04	5001	0	\N	0	0	\N	\N	0	64183	0	117015009	4024958		
37291	3439	3006322	1957-08-16	1957-08-16 00:00:00	1957-08-16	5001	0	\N	0	0	\N	\N	0	228208	0	8331-1	3006322		
48708	4450	3006322	2018-10-18	2018-10-18 00:00:00	2018-10-18	5001	0	\N	0	0	\N	\N	0	296074	0	8331-1	3006322		
22750	2087	3006322	1983-03-09	1983-03-09 00:00:00	1983-03-09	5001	0	\N	0	0	\N	\N	0	139007	0	8331-1	3006322		
48924	1490	4024958	1953-08-19	1953-08-19 00:00:00	1953-08-19	5001	0	\N	0	0	\N	\N	0	99380	0	117015009	4024958		
22645	2075	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	138118	0	6273-7	3006451		
11081	351	4024958	2002-04-07	2002-04-07 00:00:00	2002-04-07	5001	0	\N	0	0	\N	\N	0	23407	0	117015009	4024958		
93501	2876	4133840	1998-08-13	1998-08-13 00:00:00	1998-08-13	5001	0	\N	0	0	\N	\N	0	191387	0	127783003	4133840		
171177	5252	4133840	2001-04-17	2001-04-17 00:00:00	2001-04-17	5001	0	\N	0	0	\N	\N	0	349402	0	127783003	4133840		
14307	1338	3006322	1961-03-10	1961-03-10 00:00:00	1961-03-10	5001	0	\N	0	0	\N	\N	0	88684	0	8331-1	3006322		
44364	4094	3006322	2004-09-16	2004-09-16 00:00:00	2004-09-16	5001	0	\N	0	0	\N	\N	0	272116	0	8331-1	3006322		
25722	2357	3006322	1951-01-14	1951-01-14 00:00:00	1951-01-14	5001	0	\N	0	0	\N	\N	0	156933	0	8331-1	3006322		
126727	3901	4024958	1975-03-26	1975-03-26 00:00:00	1975-03-26	5001	0	\N	0	0	\N	\N	0	259344	0	117015009	4024958		
51439	4709	3006322	1981-09-21	1981-09-21 00:00:00	1981-09-21	5001	0	\N	0	0	\N	\N	0	313634	0	8331-1	3006322		
147825	4531	4052083	1924-02-26	1924-02-26 00:00:00	1924-02-26	5001	0	\N	0	0	\N	\N	0	301682	0	23426006	4052083		
31951	2915	3023430	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	194348	0	6833-8	3023430		
67413	2069	4024958	1958-08-17	1958-08-17 00:00:00	1958-08-17	5001	0	\N	0	0	\N	\N	0	137567	0	117015009	4024958		
35413	3241	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	215488	0	6276-0	3027231		
46771	4308	3006322	1941-11-07	1941-11-07 00:00:00	1941-11-07	5001	0	\N	0	0	\N	\N	0	285737	0	8331-1	3006322		
37804	3486	3006322	1986-08-26	1986-08-26 00:00:00	1986-08-26	5001	0	\N	0	0	\N	\N	0	231284	0	8331-1	3006322		
30079	2768	3006322	1995-11-20	1995-11-20 00:00:00	1995-11-20	5001	0	\N	0	0	\N	\N	0	183136	0	8331-1	3006322		
128281	3949	4024958	1975-05-17	1975-05-17 00:00:00	1975-05-17	5001	0	\N	0	0	\N	\N	0	262475	0	117015009	4024958		
3077	297	3006322	1970-10-27	1970-10-27 00:00:00	1970-10-27	5001	0	\N	0	0	\N	\N	0	19778	0	8331-1	3006322		
21878	2013	46235214	1957-11-12	1957-11-12 00:00:00	1957-11-12	5001	0	\N	0	0	\N	\N	0	133938	0	76690-7	46235214		
23710	742	4133840	1961-10-09	1961-10-09 00:00:00	1961-10-09	5001	0	\N	0	0	\N	\N	0	49216	0	127783003	4133840		
168820	5184	4024958	1990-01-19	1990-01-19 00:00:00	1990-01-19	5001	0	\N	0	0	\N	\N	0	344567	0	117015009	4024958		
69074	2119	4024958	1988-01-25	1988-01-25 00:00:00	1988-01-25	5001	0	\N	0	0	\N	\N	0	141051	0	117015009	4024958		
13659	1283	3023103	1972-04-22	1972-04-22 00:00:00	1972-04-22	5001	0	\N	0	0	\N	\N	0	84823	0	2823-3	3023103		
19316	1766	3011505	1990-01-16	1990-01-16 00:00:00	1990-01-16	5001	0	\N	0	0	\N	\N	0	118135	0	19926-5	3011505		
17623	1604	3011505	2011-08-11	2011-08-11 00:00:00	2011-08-11	5001	0	\N	0	0	\N	\N	0	107645	0	19926-5	3011505		
10791	1054	3006322	1949-11-21	1949-11-21 00:00:00	1949-11-21	5001	0	\N	0	0	\N	\N	0	69140	0	8331-1	3006322		
36568	3364	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	223119	0	6273-7	3006451		
36645	3370	3015076	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	223481	0	6248-9	3015076		
5842	550	3006322	1927-03-16	1927-03-16 00:00:00	1927-03-16	5001	0	\N	0	0	\N	\N	0	36489	0	8331-1	3006322		
46122	4255	40758406	1975-06-22	1975-06-22 00:00:00	1975-06-22	5001	0	\N	0	0	\N	\N	0	282537	0	55277-8	40758406		
50940	4642	3019406	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	309400	0	6158-0	3019406		
126312	3890	4024958	1960-03-16	1960-03-16 00:00:00	1960-03-16	5001	0	\N	0	0	\N	\N	0	258548	0	117015009	4024958		
36292	3337	46235214	2013-06-23	2013-06-23 00:00:00	2013-06-23	5001	0	\N	0	0	\N	\N	0	221362	0	76690-7	46235214		
18694	588	4052083	2016-03-02	2016-03-02 00:00:00	2016-03-02	5001	0	\N	0	0	\N	\N	0	38918	0	23426006	4052083		
56654	5200	3051031	1982-09-09	1982-09-09 00:00:00	1982-09-09	5001	0	\N	0	0	\N	\N	0	345850	0	46240-8	3051031		
38289	3528	3023430	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	234239	0	6833-8	3023430		
46528	4279	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	283993	0	6273-7	3006451		
49734	4522	3006322	1986-06-03	1986-06-03 00:00:00	1986-06-03	5001	0	\N	0	0	\N	\N	0	301127	0	8331-1	3006322		
42817	3957	40758406	1966-08-10	1966-08-10 00:00:00	1966-08-10	5001	0	\N	0	0	\N	\N	0	263135	0	55277-8	40758406		
70009	2147	4052083	1984-12-24	1984-12-24 00:00:00	1984-12-24	5001	0	\N	0	0	\N	\N	0	142942	0	23426006	4052083		
9731	915	3006322	2010-06-28	2010-06-28 00:00:00	2010-06-28	5001	0	\N	0	0	\N	\N	0	60828	0	8331-1	3006322		
837	61	3006322	1990-05-10	1990-05-10 00:00:00	1990-05-10	5001	0	\N	0	0	\N	\N	0	4140	0	8331-1	3006322		
12216	1162	40758406	1963-04-19	1963-04-19 00:00:00	1963-04-19	5001	0	\N	0	0	\N	\N	0	76663	0	55277-8	40758406		
12294	1174	40766240	1941-06-12	1941-06-12 00:00:00	1941-06-12	5001	0	\N	0	0	\N	\N	0	77360	0	63513-6	40766240		
12351	1175	3006322	2000-05-08	2000-05-08 00:00:00	2000-05-08	5001	0	\N	0	0	\N	\N	0	77539	0	8331-1	3006322		
75113	2300	4133840	2007-02-01	2007-02-01 00:00:00	2007-02-01	5001	0	\N	0	0	\N	\N	0	153145	0	127783003	4133840		
7663	739	3006322	1992-09-01	1992-09-01 00:00:00	1992-09-01	5001	0	\N	0	0	\N	\N	0	48952	0	8331-1	3006322		
67869	2078	4024958	1984-06-02	1984-06-02 00:00:00	1984-06-02	5001	0	\N	0	0	\N	\N	0	138393	0	117015009	4024958		
46546	4284	3006322	1947-03-14	1947-03-14 00:00:00	1947-03-14	5001	0	\N	0	0	\N	\N	0	284325	0	8331-1	3006322		
153473	4707	4024958	1975-01-01	1975-01-01 00:00:00	1975-01-01	5001	0	\N	0	0	\N	\N	0	313571	0	117015009	4024958		
3594	343	3001247	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	22856	0	6085-5	3001247		
22072	2026	3051031	1966-02-06	1966-02-06 00:00:00	1966-02-06	5001	0	\N	0	0	\N	\N	0	134799	0	46240-8	3051031		
106692	3287	4052083	2009-07-31	2009-07-31 00:00:00	2009-07-31	5001	0	\N	0	0	\N	\N	0	218392	0	23426006	4052083		
2913	276	3006322	1993-10-12	1993-10-12 00:00:00	1993-10-12	5001	0	\N	0	0	\N	\N	0	18408	0	8331-1	3006322		
24211	2228	3006322	1980-09-27	1980-09-27 00:00:00	1980-09-27	5001	0	\N	0	0	\N	\N	0	148265	0	8331-1	3006322		
44964	4156	3006322	1957-06-23	1957-06-23 00:00:00	1957-06-23	5001	0	\N	0	0	\N	\N	0	276176	0	8331-1	3006322		
35673	3259	3006322	2003-05-22	2003-05-22 00:00:00	2003-05-22	5001	0	\N	0	0	\N	\N	0	216686	0	8331-1	3006322		
143598	4412	4052083	1979-12-07	1979-12-07 00:00:00	1979-12-07	5001	0	\N	0	0	\N	\N	0	293325	0	23426006	4052083		
3575	110	4024958	1984-04-06	1984-04-06 00:00:00	1984-04-06	5001	0	\N	0	0	\N	\N	0	7317	0	117015009	4024958		
31452	964	4024958	1982-10-18	1982-10-18 00:00:00	1982-10-18	5001	0	\N	0	0	\N	\N	0	64192	0	117015009	4024958		
37292	3439	3006322	1968-05-04	1968-05-04 00:00:00	1968-05-04	5001	0	\N	0	0	\N	\N	0	228209	0	8331-1	3006322		
48709	4451	3006322	1976-07-03	1976-07-03 00:00:00	1976-07-03	5001	0	\N	0	0	\N	\N	0	296165	0	8331-1	3006322		
22751	2087	3006322	1922-08-21	1922-08-21 00:00:00	1922-08-21	5001	0	\N	0	0	\N	\N	0	139037	0	8331-1	3006322		
48935	1491	4024958	1996-11-12	1996-11-12 00:00:00	1996-11-12	5001	0	\N	0	0	\N	\N	0	99405	0	117015009	4024958		
22646	2075	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	138118	0	6246-3	3021226		
91374	2822	4024958	1998-03-01	1998-03-01 00:00:00	1998-03-01	5001	0	\N	0	0	\N	\N	0	187011	0	117015009	4024958		
93514	2878	4024958	2016-11-10	2016-11-10 00:00:00	2016-11-10	5001	0	\N	0	0	\N	\N	0	191464	0	117015009	4024958		
171179	5252	4133840	1999-04-13	1999-04-13 00:00:00	1999-04-13	5001	0	\N	0	0	\N	\N	0	349425	0	127783003	4133840		
14308	1339	3006322	1968-05-04	1968-05-04 00:00:00	1968-05-04	5001	0	\N	0	0	\N	\N	0	88800	0	8331-1	3006322		
44369	4100	3051031	1980-02-29	1980-02-29 00:00:00	1980-02-29	5001	0	\N	0	0	\N	\N	0	272413	0	46240-8	3051031		
25723	2357	3006322	1969-10-26	1969-10-26 00:00:00	1969-10-26	5001	0	\N	0	0	\N	\N	0	156934	0	8331-1	3006322		
126730	3901	4024958	1941-11-13	1941-11-13 00:00:00	1941-11-13	5001	0	\N	0	0	\N	\N	0	259435	0	117015009	4024958		
51440	4709	3006322	1965-04-23	1965-04-23 00:00:00	1965-04-23	5001	0	\N	0	0	\N	\N	0	313660	0	8331-1	3006322		
147829	4531	4052083	1967-12-11	1967-12-11 00:00:00	1967-12-11	5001	0	\N	0	0	\N	\N	0	301747	0	23426006	4052083		
31952	2915	3014599	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	194348	0	6106-9	3014599		
67423	2069	4024958	1978-01-25	1978-01-25 00:00:00	1978-01-25	5001	0	\N	0	0	\N	\N	0	137600	0	117015009	4024958		
35414	3241	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	215488	0	6248-9	3015076		
46772	4309	3006322	1985-08-24	1985-08-24 00:00:00	1985-08-24	5001	0	\N	0	0	\N	\N	0	285887	0	8331-1	3006322		
37805	3486	3006322	1974-09-03	1974-09-03 00:00:00	1974-09-03	5001	0	\N	0	0	\N	\N	0	231231	0	8331-1	3006322		
30080	2768	3006322	2006-04-04	2006-04-04 00:00:00	2006-04-04	5001	0	\N	0	0	\N	\N	0	183142	0	8331-1	3006322		
128298	3950	4052083	2016-05-12	2016-05-12 00:00:00	2016-05-12	5001	0	\N	0	0	\N	\N	0	262533	0	23426006	4052083		
3078	297	3006322	1970-05-20	1970-05-20 00:00:00	1970-05-20	5001	0	\N	0	0	\N	\N	0	19769	0	8331-1	3006322		
21880	2013	3051031	1957-11-12	1957-11-12 00:00:00	1957-11-12	5001	0	\N	0	0	\N	\N	0	133938	0	46240-8	3051031		
23712	742	4133840	2007-07-16	2007-07-16 00:00:00	2007-07-16	5001	0	\N	0	0	\N	\N	0	49183	0	127783003	4133840		
11051	1068	3006322	1978-07-22	1978-07-22 00:00:00	1978-07-22	5001	0	\N	0	0	\N	\N	0	69973	0	8331-1	3006322		
69075	2119	4024958	1962-11-20	1962-11-20 00:00:00	1962-11-20	5001	0	\N	0	0	\N	\N	0	140962	0	117015009	4024958		
13660	1283	3020630	1972-04-22	1972-04-22 00:00:00	1972-04-22	5001	0	\N	0	0	\N	\N	0	84823	0	2885-2	3020630		
19317	1766	3011505	2010-10-19	2010-10-19 00:00:00	2010-10-19	5001	0	\N	0	0	\N	\N	0	118144	0	19926-5	3011505		
17624	1604	3011505	2004-07-01	2004-07-01 00:00:00	2004-07-01	5001	0	\N	0	0	\N	\N	0	107598	0	19926-5	3011505		
10793	1054	3006322	2002-11-20	2002-11-20 00:00:00	2002-11-20	5001	0	\N	0	0	\N	\N	0	69096	0	8331-1	3006322		
36569	3364	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	223119	0	6085-5	3001247		
36646	3370	3014599	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	223481	0	6106-9	3014599		
5843	550	3006322	1965-09-13	1965-09-13 00:00:00	1965-09-13	5001	0	\N	0	0	\N	\N	0	36490	0	8331-1	3006322		
46123	4255	46235214	1975-06-22	1975-06-22 00:00:00	1975-06-22	5001	0	\N	0	0	\N	\N	0	282537	0	76690-7	46235214		
50941	4642	3036780	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	309400	0	6095-4	3036780		
126315	3890	4052083	1976-09-07	1976-09-07 00:00:00	1976-09-07	5001	0	\N	0	0	\N	\N	0	258592	0	23426006	4052083		
36293	3337	3051031	2013-06-23	2013-06-23 00:00:00	2013-06-23	5001	0	\N	0	0	\N	\N	0	221362	0	46240-8	3051031		
18697	588	4024958	2016-02-13	2016-02-13 00:00:00	2016-02-13	5001	0	\N	0	0	\N	\N	0	38936	0	117015009	4024958		
56656	5200	40758406	1982-09-09	1982-09-09 00:00:00	1982-09-09	5001	0	\N	0	0	\N	\N	0	345850	0	55277-8	40758406		
38290	3528	3019406	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	234239	0	6158-0	3019406		
46529	4279	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	283993	0	6206-7	3012494		
49735	4522	3006322	1988-09-12	1988-09-12 00:00:00	1988-09-12	5001	0	\N	0	0	\N	\N	0	301128	0	8331-1	3006322		
42819	3957	46235214	1966-08-10	1966-08-10 00:00:00	1966-08-10	5001	0	\N	0	0	\N	\N	0	263135	0	76690-7	46235214		
70011	2147	4052083	1973-08-27	1973-08-27 00:00:00	1973-08-27	5001	0	\N	0	0	\N	\N	0	143003	0	23426006	4052083		
9732	915	3006322	2012-03-30	2012-03-30 00:00:00	2012-03-30	5001	0	\N	0	0	\N	\N	0	60867	0	8331-1	3006322		
840	63	3006322	1960-11-18	1960-11-18 00:00:00	1960-11-18	5001	0	\N	0	0	\N	\N	0	4300	0	8331-1	3006322		
12218	1162	40766240	1963-04-19	1963-04-19 00:00:00	1963-04-19	5001	0	\N	0	0	\N	\N	0	76663	0	63513-6	40766240		
12295	1174	46235214	1941-06-12	1941-06-12 00:00:00	1941-06-12	5001	0	\N	0	0	\N	\N	0	77360	0	76690-7	46235214		
23629	2175	3036780	2012-08-21	2012-08-21 00:00:00	2012-08-21	5001	0	\N	0	0	\N	\N	0	144972	0	6095-4	3036780		
75115	2300	4133840	1974-11-14	1974-11-14 00:00:00	1974-11-14	5001	0	\N	0	0	\N	\N	0	153199	0	127783003	4133840		
7666	739	3049273	1975-08-20	1975-08-20 00:00:00	1975-08-20	5001	0	\N	0	0	\N	\N	0	48930	0	38265-5	3049273		
67887	2078	4024958	2007-02-15	2007-02-15 00:00:00	2007-02-15	5001	0	\N	0	0	\N	\N	0	138423	0	117015009	4024958		
46547	4284	3006322	2014-09-19	2014-09-19 00:00:00	2014-09-19	5001	0	\N	0	0	\N	\N	0	284396	0	8331-1	3006322		
153497	4709	4052083	2000-11-20	2000-11-20 00:00:00	2000-11-20	5001	0	\N	0	0	\N	\N	0	313636	0	23426006	4052083		
3595	343	3006734	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	22856	0	6189-5	3006734		
22073	2026	40766240	1966-02-06	1966-02-06 00:00:00	1966-02-06	5001	0	\N	0	0	\N	\N	0	134799	0	63513-6	40766240		
3900	123	4024958	1988-07-21	1988-07-21 00:00:00	1988-07-21	5001	0	\N	0	0	\N	\N	0	8155	0	117015009	4024958		
2914	276	3006322	1998-05-31	1998-05-31 00:00:00	1998-05-31	5001	0	\N	0	0	\N	\N	0	18431	0	8331-1	3006322		
24212	2228	3006322	1950-12-01	1950-12-01 00:00:00	1950-12-01	5001	0	\N	0	0	\N	\N	0	148280	0	8331-1	3006322		
44965	4156	40758406	2001-06-09	2001-06-09 00:00:00	2001-06-09	5001	0	\N	0	0	\N	\N	0	276163	0	55277-8	40758406		
35674	3259	3006322	1990-08-17	1990-08-17 00:00:00	1990-08-17	5001	0	\N	0	0	\N	\N	0	216644	0	8331-1	3006322		
143607	4412	4024958	1973-02-13	1973-02-13 00:00:00	1973-02-13	5001	0	\N	0	0	\N	\N	0	293406	0	117015009	4024958		
129689	3995	4024958	1977-02-15	1977-02-15 00:00:00	1977-02-15	5001	0	\N	0	0	\N	\N	0	265593	0	117015009	4024958		
31454	964	4052083	1981-04-02	1981-04-02 00:00:00	1981-04-02	5001	0	\N	0	0	\N	\N	0	64201	0	23426006	4052083		
37293	3439	3006322	1952-05-27	1952-05-27 00:00:00	1952-05-27	5001	0	\N	0	0	\N	\N	0	228140	0	8331-1	3006322		
48710	4451	3049273	2003-09-28	2003-09-28 00:00:00	2003-09-28	5001	0	\N	0	0	\N	\N	0	296141	0	38265-5	3049273		
22752	2087	3006322	2013-02-24	2013-02-24 00:00:00	2013-02-24	5001	0	\N	0	0	\N	\N	0	139141	0	8331-1	3006322		
48937	1491	4024958	2002-05-26	2002-05-26 00:00:00	2002-05-26	5001	0	\N	0	0	\N	\N	0	99406	0	117015009	4024958		
22647	2075	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	138118	0	6206-7	3012494		
91377	2822	4052083	1990-09-16	1990-09-16 00:00:00	1990-09-16	5001	0	\N	0	0	\N	\N	0	186986	0	23426006	4052083		
93517	2878	4052083	1999-12-14	1999-12-14 00:00:00	1999-12-14	5001	0	\N	0	0	\N	\N	0	191432	0	23426006	4052083		
171183	5252	4133840	2014-05-13	2014-05-13 00:00:00	2014-05-13	5001	0	\N	0	0	\N	\N	0	349476	0	127783003	4133840		
14309	1339	3006322	2005-01-17	2005-01-17 00:00:00	2005-01-17	5001	0	\N	0	0	\N	\N	0	88824	0	8331-1	3006322		
44370	4100	46235214	1980-02-29	1980-02-29 00:00:00	1980-02-29	5001	0	\N	0	0	\N	\N	0	272413	0	76690-7	46235214		
25724	2357	3036780	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	156941	0	6095-4	3036780		
138034	4253	4052083	1987-06-22	1987-06-22 00:00:00	1987-06-22	5001	0	\N	0	0	\N	\N	0	282440	0	23426006	4052083		
51442	4712	3006322	1978-12-06	1978-12-06 00:00:00	1978-12-06	5001	0	\N	0	0	\N	\N	0	313783	0	8331-1	3006322		
147846	4531	4024958	1940-05-11	1940-05-11 00:00:00	1940-05-11	5001	0	\N	0	0	\N	\N	0	301812	0	117015009	4024958		
31953	2915	3027231	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	194348	0	6276-0	3027231		
170590	5233	4052083	2012-02-12	2012-02-12 00:00:00	2012-02-12	5001	0	\N	0	0	\N	\N	0	348140	0	23426006	4052083		
35415	3241	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	215488	0	6106-9	3014599		
46773	4309	3006322	1990-12-12	1990-12-12 00:00:00	1990-12-12	5001	0	\N	0	0	\N	\N	0	285888	0	8331-1	3006322		
37806	3486	3049273	2012-04-16	2012-04-16 00:00:00	2012-04-16	5001	0	\N	0	0	\N	\N	0	231299	0	38265-5	3049273		
30081	2768	3006322	2009-10-30	2009-10-30 00:00:00	2009-10-30	5001	0	\N	0	0	\N	\N	0	183124	0	8331-1	3006322		
128324	3950	4052083	1976-08-01	1976-08-01 00:00:00	1976-08-01	5001	0	\N	0	0	\N	\N	0	262586	0	23426006	4052083		
3079	297	3006322	1989-07-20	1989-07-20 00:00:00	1989-07-20	5001	0	\N	0	0	\N	\N	0	19779	0	8331-1	3006322		
21881	2013	40766240	1957-11-12	1957-11-12 00:00:00	1957-11-12	5001	0	\N	0	0	\N	\N	0	133938	0	63513-6	40766240		
23714	742	4133840	1966-10-24	1966-10-24 00:00:00	1966-10-24	5001	0	\N	0	0	\N	\N	0	49169	0	127783003	4133840		
11052	1068	3006322	2003-01-29	2003-01-29 00:00:00	2003-01-29	5001	0	\N	0	0	\N	\N	0	69989	0	8331-1	3006322		
69077	2119	4024958	1989-06-04	1989-06-04 00:00:00	1989-06-04	5001	0	\N	0	0	\N	\N	0	141056	0	117015009	4024958		
13661	1283	3015632	1972-04-22	1972-04-22 00:00:00	1972-04-22	5001	0	\N	0	0	\N	\N	0	84823	0	2028-9	3015632		
19318	1766	3011505	2017-11-28	2017-11-28 00:00:00	2017-11-28	5001	0	\N	0	0	\N	\N	0	118170	0	19926-5	3011505		
17625	1604	3006322	1957-02-24	1957-02-24 00:00:00	1957-02-24	5001	0	\N	0	0	\N	\N	0	107624	0	8331-1	3006322		
10794	1054	3006322	1972-11-30	1972-11-30 00:00:00	1972-11-30	5001	0	\N	0	0	\N	\N	0	69147	0	8331-1	3006322		
36570	3364	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	223119	0	7258-7	3001488		
36647	3370	3006322	1990-05-05	1990-05-05 00:00:00	1990-05-05	5001	0	\N	0	0	\N	\N	0	223453	0	8331-1	3006322		
5844	550	3006322	1964-09-10	1964-09-10 00:00:00	1964-09-10	5001	0	\N	0	0	\N	\N	0	36534	0	8331-1	3006322		
46125	4255	40766240	1975-06-22	1975-06-22 00:00:00	1975-06-22	5001	0	\N	0	0	\N	\N	0	282537	0	63513-6	40766240		
50942	4642	3001247	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	309400	0	6085-5	3001247		
126318	3890	4024958	1995-07-04	1995-07-04 00:00:00	1995-07-04	5001	0	\N	0	0	\N	\N	0	258554	0	117015009	4024958		
36294	3337	40766240	2013-06-23	2013-06-23 00:00:00	2013-06-23	5001	0	\N	0	0	\N	\N	0	221362	0	63513-6	40766240		
28796	2661	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	176385	0	6189-5	3006734		
56658	5200	46235214	1982-09-09	1982-09-09 00:00:00	1982-09-09	5001	0	\N	0	0	\N	\N	0	345850	0	76690-7	46235214		
38291	3528	3027231	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	234239	0	6276-0	3027231		
46530	4279	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	283993	0	6082-2	3000876		
49736	4522	3006322	1984-12-25	1984-12-25 00:00:00	1984-12-25	5001	0	\N	0	0	\N	\N	0	301105	0	8331-1	3006322		
42820	3957	40766240	1966-08-10	1966-08-10 00:00:00	1966-08-10	5001	0	\N	0	0	\N	\N	0	263135	0	63513-6	40766240		
70014	2147	4024958	1975-12-30	1975-12-30 00:00:00	1975-12-30	5001	0	\N	0	0	\N	\N	0	142888	0	117015009	4024958		
9733	915	3006322	1989-01-02	1989-01-02 00:00:00	1989-01-02	5001	0	\N	0	0	\N	\N	0	60837	0	8331-1	3006322		
841	63	3006322	2012-11-27	2012-11-27 00:00:00	2012-11-27	5001	0	\N	0	0	\N	\N	0	4285	0	8331-1	3006322		
12220	1162	3051031	1963-04-19	1963-04-19 00:00:00	1963-04-19	5001	0	\N	0	0	\N	\N	0	76663	0	46240-8	3051031		
12296	1174	3006322	1987-11-09	1987-11-09 00:00:00	1987-11-09	5001	0	\N	0	0	\N	\N	0	77307	0	8331-1	3006322		
23630	2175	46235214	1977-03-29	1977-03-29 00:00:00	1977-03-29	5001	0	\N	0	0	\N	\N	0	144978	0	76690-7	46235214		
75118	2300	4133840	2005-01-20	2005-01-20 00:00:00	2005-01-20	5001	0	\N	0	0	\N	\N	0	153144	0	127783003	4133840		
7667	739	3049273	1978-05-06	1978-05-06 00:00:00	1978-05-06	5001	0	\N	0	0	\N	\N	0	48931	0	38265-5	3049273		
67888	2078	4024958	2012-12-29	2012-12-29 00:00:00	2012-12-29	5001	0	\N	0	0	\N	\N	0	138430	0	117015009	4024958		
46548	4284	3006322	2011-09-29	2011-09-29 00:00:00	2011-09-29	5001	0	\N	0	0	\N	\N	0	284395	0	8331-1	3006322		
153507	4709	4024958	1965-04-23	1965-04-23 00:00:00	1965-04-23	5001	0	\N	0	0	\N	\N	0	313660	0	117015009	4024958		
3596	343	3006322	2013-02-17	2013-02-17 00:00:00	2013-02-17	5001	0	\N	0	0	\N	\N	0	22963	0	8331-1	3006322		
22074	2026	46235214	1966-02-06	1966-02-06 00:00:00	1966-02-06	5001	0	\N	0	0	\N	\N	0	134799	0	76690-7	46235214		
3904	123	4052083	1954-01-10	1954-01-10 00:00:00	1954-01-10	5001	0	\N	0	0	\N	\N	0	8149	0	23426006	4052083		
2915	277	3006322	1981-06-27	1981-06-27 00:00:00	1981-06-27	5001	0	\N	0	0	\N	\N	0	18481	0	8331-1	3006322		
24219	2230	3006322	2008-09-13	2008-09-13 00:00:00	2008-09-13	5001	0	\N	0	0	\N	\N	0	148376	0	8331-1	3006322		
44966	4156	40766240	2001-06-09	2001-06-09 00:00:00	2001-06-09	5001	0	\N	0	0	\N	\N	0	276163	0	63513-6	40766240		
35675	3259	3006322	1980-11-12	1980-11-12 00:00:00	1980-11-12	5001	0	\N	0	0	\N	\N	0	216643	0	8331-1	3006322		
143623	4413	4024958	1966-06-04	1966-06-04 00:00:00	1966-06-04	5001	0	\N	0	0	\N	\N	0	293454	0	117015009	4024958		
129705	3996	4024958	2001-06-01	2001-06-01 00:00:00	2001-06-01	5001	0	\N	0	0	\N	\N	0	265688	0	117015009	4024958		
31455	964	4024958	1984-06-23	1984-06-23 00:00:00	1984-06-23	5001	0	\N	0	0	\N	\N	0	64184	0	117015009	4024958		
37294	3439	3006322	1999-07-23	1999-07-23 00:00:00	1999-07-23	5001	0	\N	0	0	\N	\N	0	228211	0	8331-1	3006322		
48711	4451	3006322	2019-05-22	2019-05-22 00:00:00	2019-05-22	5001	0	\N	0	0	\N	\N	0	296150	0	8331-1	3006322		
22753	2087	3006322	1974-06-28	1974-06-28 00:00:00	1974-06-28	5001	0	\N	0	0	\N	\N	0	139087	0	8331-1	3006322		
48938	1491	4024958	2008-05-05	2008-05-05 00:00:00	2008-05-05	5001	0	\N	0	0	\N	\N	0	99414	0	117015009	4024958		
22648	2075	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	138118	0	6106-9	3014599		
91382	2822	4052083	1996-09-30	1996-09-30 00:00:00	1996-09-30	5001	0	\N	0	0	\N	\N	0	186997	0	23426006	4052083		
93521	2878	4024958	2002-12-30	2002-12-30 00:00:00	2002-12-30	5001	0	\N	0	0	\N	\N	0	191441	0	117015009	4024958		
171184	5252	4024958	1990-02-15	1990-02-15 00:00:00	1990-02-15	5001	0	\N	0	0	\N	\N	0	349459	0	117015009	4024958		
14310	1339	3006322	1994-04-05	1994-04-05 00:00:00	1994-04-05	5001	0	\N	0	0	\N	\N	0	88823	0	8331-1	3006322		
44372	4100	40758406	1980-02-29	1980-02-29 00:00:00	1980-02-29	5001	0	\N	0	0	\N	\N	0	272413	0	55277-8	40758406		
25725	2357	3001488	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	156941	0	7258-7	3001488		
138035	4253	4024958	1996-06-30	1996-06-30 00:00:00	1996-06-30	5001	0	\N	0	0	\N	\N	0	282447	0	117015009	4024958		
51443	4712	3006322	1979-03-18	1979-03-18 00:00:00	1979-03-18	5001	0	\N	0	0	\N	\N	0	313746	0	8331-1	3006322		
94477	2903	4024958	1971-07-07	1971-07-07 00:00:00	1971-07-07	5001	0	\N	0	0	\N	\N	0	193408	0	117015009	4024958		
31954	2915	3006451	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	194348	0	6273-7	3006451		
170591	5233	4052083	1956-11-18	1956-11-18 00:00:00	1956-11-18	5001	0	\N	0	0	\N	\N	0	348136	0	23426006	4052083		
35416	3241	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	215488	0	7258-7	3001488		
54118	4949	3006322	1980-02-12	1980-02-12 00:00:00	1980-02-12	5001	0	\N	0	0	\N	\N	0	328998	0	8331-1	3006322		
37807	3486	3006322	1980-04-14	1980-04-14 00:00:00	1980-04-14	5001	0	\N	0	0	\N	\N	0	231291	0	8331-1	3006322		
30082	2768	3006322	1984-05-06	1984-05-06 00:00:00	1984-05-06	5001	0	\N	0	0	\N	\N	0	183171	0	8331-1	3006322		
128325	3950	4024958	1999-07-16	1999-07-16 00:00:00	1999-07-16	5001	0	\N	0	0	\N	\N	0	262538	0	117015009	4024958		
3080	297	3006322	1952-02-15	1952-02-15 00:00:00	1952-02-15	5001	0	\N	0	0	\N	\N	0	19787	0	8331-1	3006322		
21883	2013	40758406	1957-11-12	1957-11-12 00:00:00	1957-11-12	5001	0	\N	0	0	\N	\N	0	133938	0	55277-8	40758406		
23716	742	4133840	2005-07-04	2005-07-04 00:00:00	2005-07-04	5001	0	\N	0	0	\N	\N	0	49182	0	127783003	4133840		
11053	1068	3006322	2018-10-21	2018-10-21 00:00:00	2018-10-21	5001	0	\N	0	0	\N	\N	0	69964	0	8331-1	3006322		
80379	2477	4052083	1998-04-06	1998-04-06 00:00:00	1998-04-06	5001	0	\N	0	0	\N	\N	0	164163	0	23426006	4052083		
13662	1283	3013682	1972-04-22	1972-04-22 00:00:00	1972-04-22	5001	0	\N	0	0	\N	\N	0	84823	0	3094-0	3013682		
19319	1766	3011505	2011-10-25	2011-10-25 00:00:00	2011-10-25	5001	0	\N	0	0	\N	\N	0	118184	0	19926-5	3011505		
17626	1604	3011505	2014-08-28	2014-08-28 00:00:00	2014-08-28	5001	0	\N	0	0	\N	\N	0	107655	0	19926-5	3011505		
10796	1054	3006322	1992-01-03	1992-01-03 00:00:00	1992-01-03	5001	0	\N	0	0	\N	\N	0	69141	0	8331-1	3006322		
36571	3364	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	223119	0	6189-5	3006734		
36648	3370	3006322	2000-04-22	2000-04-22 00:00:00	2000-04-22	5001	0	\N	0	0	\N	\N	0	223483	0	8331-1	3006322		
5846	550	3006322	2001-05-29	2001-05-29 00:00:00	2001-05-29	5001	0	\N	0	0	\N	\N	0	36456	0	8331-1	3006322		
46126	4255	46235214	1975-02-22	1975-02-22 00:00:00	1975-02-22	5001	0	\N	0	0	\N	\N	0	282510	0	76690-7	46235214		
50943	4642	3000876	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	309400	0	6082-2	3000876		
126331	3890	4052083	1962-09-29	1962-09-29 00:00:00	1962-09-29	5001	0	\N	0	0	\N	\N	0	258557	0	23426006	4052083		
36295	3337	40758406	2013-06-23	2013-06-23 00:00:00	2013-06-23	5001	0	\N	0	0	\N	\N	0	221362	0	55277-8	40758406		
28797	2661	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	176385	0	6833-8	3023430		
56659	5200	40766240	1982-09-09	1982-09-09 00:00:00	1982-09-09	5001	0	\N	0	0	\N	\N	0	345850	0	63513-6	40766240		
38292	3528	3020655	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	234239	0	6844-5	3020655		
46531	4279	3006322	1975-10-09	1975-10-09 00:00:00	1975-10-09	5001	0	\N	0	0	\N	\N	0	283948	0	8331-1	3006322		
49737	4522	3006322	2017-02-12	2017-02-12 00:00:00	2017-02-12	5001	0	\N	0	0	\N	\N	0	301110	0	8331-1	3006322		
42822	3957	40758406	1966-06-11	1966-06-11 00:00:00	1966-06-11	5001	0	\N	0	0	\N	\N	0	263044	0	55277-8	40758406		
70020	2147	4024958	1962-04-08	1962-04-08 00:00:00	1962-04-08	5001	0	\N	0	0	\N	\N	0	142928	0	117015009	4024958		
9734	915	3006322	2015-08-24	2015-08-24 00:00:00	2015-08-24	5001	0	\N	0	0	\N	\N	0	60829	0	8331-1	3006322		
842	63	3006322	1973-08-27	1973-08-27 00:00:00	1973-08-27	5001	0	\N	0	0	\N	\N	0	4242	0	8331-1	3006322		
12221	1162	46235214	1963-04-19	1963-04-19 00:00:00	1963-04-19	5001	0	\N	0	0	\N	\N	0	76663	0	76690-7	46235214		
12297	1174	3006322	1946-03-28	1946-03-28 00:00:00	1946-03-28	5001	0	\N	0	0	\N	\N	0	77341	0	8331-1	3006322		
23633	2175	3051031	1977-03-29	1977-03-29 00:00:00	1977-03-29	5001	0	\N	0	0	\N	\N	0	144978	0	46240-8	3051031		
75119	2300	4133840	2000-12-28	2000-12-28 00:00:00	2000-12-28	5001	0	\N	0	0	\N	\N	0	153133	0	127783003	4133840		
7668	739	3006322	1971-11-28	1971-11-28 00:00:00	1971-11-28	5001	0	\N	0	0	\N	\N	0	48937	0	8331-1	3006322		
67895	2079	4052083	1989-05-21	1989-05-21 00:00:00	1989-05-21	5001	0	\N	0	0	\N	\N	0	138493	0	23426006	4052083		
46549	4284	3006322	1994-10-03	1994-10-03 00:00:00	1994-10-03	5001	0	\N	0	0	\N	\N	0	284329	0	8331-1	3006322		
153511	4709	4024958	1981-09-21	1981-09-21 00:00:00	1981-09-21	5001	0	\N	0	0	\N	\N	0	313634	0	117015009	4024958		
3597	343	3006322	1998-01-22	1998-01-22 00:00:00	1998-01-22	5001	0	\N	0	0	\N	\N	0	22954	0	8331-1	3006322		
22076	2026	40758406	1966-02-06	1966-02-06 00:00:00	1966-02-06	5001	0	\N	0	0	\N	\N	0	134799	0	55277-8	40758406		
3913	123	4024958	1998-11-18	1998-11-18 00:00:00	1998-11-18	5001	0	\N	0	0	\N	\N	0	8109	0	117015009	4024958		
2916	277	3006322	1964-03-02	1964-03-02 00:00:00	1964-03-02	5001	0	\N	0	0	\N	\N	0	18490	0	8331-1	3006322		
24220	2230	3006322	1993-12-02	1993-12-02 00:00:00	1993-12-02	5001	0	\N	0	0	\N	\N	0	148374	0	8331-1	3006322		
44967	4156	3051031	2001-06-09	2001-06-09 00:00:00	2001-06-09	5001	0	\N	0	0	\N	\N	0	276163	0	46240-8	3051031		
35676	3259	3006322	1981-12-21	1981-12-21 00:00:00	1981-12-21	5001	0	\N	0	0	\N	\N	0	216663	0	8331-1	3006322		
143739	4418	4024958	1996-10-09	1996-10-09 00:00:00	1996-10-09	5001	0	\N	0	0	\N	\N	0	293720	0	117015009	4024958		
129707	3996	4024958	1974-07-16	1974-07-16 00:00:00	1974-07-16	5001	0	\N	0	0	\N	\N	0	265653	0	117015009	4024958		
155196	4759	4024958	1986-06-30	1986-06-30 00:00:00	1986-06-30	5001	0	\N	0	0	\N	\N	0	317040	0	117015009	4024958		
37295	3439	3006322	1990-08-15	1990-08-15 00:00:00	1990-08-15	5001	0	\N	0	0	\N	\N	0	228210	0	8331-1	3006322		
48712	4451	3006322	1999-11-08	1999-11-08 00:00:00	1999-11-08	5001	0	\N	0	0	\N	\N	0	296134	0	8331-1	3006322		
22754	2087	3049273	1989-04-19	1989-04-19 00:00:00	1989-04-19	5001	0	\N	0	0	\N	\N	0	139103	0	38265-5	3049273		
48939	1491	4024958	1975-09-13	1975-09-13 00:00:00	1975-09-13	5001	0	\N	0	0	\N	\N	0	99442	0	117015009	4024958		
22649	2075	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	138118	0	6276-0	3027231		
91387	2822	4024958	1999-06-10	1999-06-10 00:00:00	1999-06-10	5001	0	\N	0	0	\N	\N	0	187012	0	117015009	4024958		
93529	2878	4024958	1998-05-13	1998-05-13 00:00:00	1998-05-13	5001	0	\N	0	0	\N	\N	0	191462	0	117015009	4024958		
171193	5252	4133840	2009-12-15	2009-12-15 00:00:00	2009-12-15	5001	0	\N	0	0	\N	\N	0	349473	0	127783003	4133840		
14311	1340	3006322	1958-02-16	1958-02-16 00:00:00	1958-02-16	5001	0	\N	0	0	\N	\N	0	88956	0	8331-1	3006322		
44373	4100	40766240	1980-02-29	1980-02-29 00:00:00	1980-02-29	5001	0	\N	0	0	\N	\N	0	272413	0	63513-6	40766240		
25726	2357	3023430	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	156941	0	6833-8	3023430		
138043	4253	4024958	2010-11-24	2010-11-24 00:00:00	2010-11-24	5001	0	\N	0	0	\N	\N	0	282443	0	117015009	4024958		
51444	4712	3006322	1973-06-23	1973-06-23 00:00:00	1973-06-23	5001	0	\N	0	0	\N	\N	0	313782	0	8331-1	3006322		
94484	2903	4052083	1966-06-02	1966-06-02 00:00:00	1966-06-02	5001	0	\N	0	0	\N	\N	0	193438	0	23426006	4052083		
31955	2915	3012494	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	194348	0	6206-7	3012494		
170606	5233	4024958	1968-03-22	1968-03-22 00:00:00	1968-03-22	5001	0	\N	0	0	\N	\N	0	348138	0	117015009	4024958		
35417	3241	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	215488	0	6844-5	3020655		
54119	4949	3006322	1977-04-16	1977-04-16 00:00:00	1977-04-16	5001	0	\N	0	0	\N	\N	0	329004	0	8331-1	3006322		
37808	3486	3006322	1961-06-18	1961-06-18 00:00:00	1961-06-18	5001	0	\N	0	0	\N	\N	0	231253	0	8331-1	3006322		
30084	2770	3023430	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	183291	0	6833-8	3023430		
167976	5157	4052083	1980-08-10	1980-08-10 00:00:00	1980-08-10	5001	0	\N	0	0	\N	\N	0	342881	0	23426006	4052083		
3081	297	3006322	1965-05-23	1965-05-23 00:00:00	1965-05-23	5001	0	\N	0	0	\N	\N	0	19777	0	8331-1	3006322		
21884	2013	3006322	2004-10-02	2004-10-02 00:00:00	2004-10-02	5001	0	\N	0	0	\N	\N	0	133942	0	8331-1	3006322		
23718	742	4024958	1990-03-29	1990-03-29 00:00:00	1990-03-29	5001	0	\N	0	0	\N	\N	0	49220	0	117015009	4024958		
11054	1068	3006322	1984-10-05	1984-10-05 00:00:00	1984-10-05	5001	0	\N	0	0	\N	\N	0	69976	0	8331-1	3006322		
80397	2477	4024958	2015-01-30	2015-01-30 00:00:00	2015-01-30	5001	0	\N	0	0	\N	\N	0	164166	0	117015009	4024958		
13663	1283	3035995	1972-04-22	1972-04-22 00:00:00	1972-04-22	5001	0	\N	0	0	\N	\N	0	84823	0	6768-6	3035995		
19320	1766	3011505	2008-10-07	2008-10-07 00:00:00	2008-10-07	5001	0	\N	0	0	\N	\N	0	118169	0	19926-5	3011505		
17627	1604	3011505	2013-08-22	2013-08-22 00:00:00	2013-08-22	5001	0	\N	0	0	\N	\N	0	107646	0	19926-5	3011505		
167760	5150	4052083	2011-06-01	2011-06-01 00:00:00	2011-06-01	5001	0	\N	0	0	\N	\N	0	342466	0	23426006	4052083		
36572	3364	40769179	2000-06-26	2000-06-26 00:00:00	2000-06-26	5001	0	\N	0	0	\N	\N	0	223064	0	66519-0	40769179		
36649	3371	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	223626	0	6246-3	3021226		
5848	550	3006322	1977-02-20	1977-02-20 00:00:00	1977-02-20	5001	0	\N	0	0	\N	\N	0	36519	0	8331-1	3006322		
46127	4255	40758406	1975-02-22	1975-02-22 00:00:00	1975-02-22	5001	0	\N	0	0	\N	\N	0	282510	0	55277-8	40758406		
50944	4642	3001488	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	309400	0	7258-7	3001488		
81057	2503	4024958	2009-06-01	2009-06-01 00:00:00	2009-06-01	5001	0	\N	0	0	\N	\N	0	165653	0	117015009	4024958		
74007	2274	4052083	1954-01-26	1954-01-26 00:00:00	1954-01-26	5001	0	\N	0	0	\N	\N	0	151133	0	23426006	4052083		
28798	2661	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	176385	0	6273-7	3006451		
56660	5200	40766240	1982-10-09	1982-10-09 00:00:00	1982-10-09	5001	0	\N	0	0	\N	\N	0	345936	0	63513-6	40766240		
38293	3528	3036780	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	234239	0	6095-4	3036780		
46538	4282	3006322	1997-11-06	1997-11-06 00:00:00	1997-11-06	5001	0	\N	0	0	\N	\N	0	284198	0	8331-1	3006322		
49738	4522	3006322	1988-08-04	1988-08-04 00:00:00	1988-08-04	5001	0	\N	0	0	\N	\N	0	301109	0	8331-1	3006322		
42823	3957	3051031	1966-06-11	1966-06-11 00:00:00	1966-06-11	5001	0	\N	0	0	\N	\N	0	263044	0	46240-8	3051031		
70022	2147	4024958	1967-02-24	1967-02-24 00:00:00	1967-02-24	5001	0	\N	0	0	\N	\N	0	142885	0	117015009	4024958		
9735	915	3006322	1960-05-27	1960-05-27 00:00:00	1960-05-27	5001	0	\N	0	0	\N	\N	0	60833	0	8331-1	3006322		
843	63	3049273	2008-02-19	2008-02-19 00:00:00	2008-02-19	5001	0	\N	0	0	\N	\N	0	4299	0	38265-5	3049273		
12224	1162	3006322	1987-12-01	1987-12-01 00:00:00	1987-12-01	5001	0	\N	0	0	\N	\N	0	76701	0	8331-1	3006322		
12298	1174	3006322	2013-06-08	2013-06-08 00:00:00	2013-06-08	5001	0	\N	0	0	\N	\N	0	77364	0	8331-1	3006322		
23634	2175	40766240	1977-03-29	1977-03-29 00:00:00	1977-03-29	5001	0	\N	0	0	\N	\N	0	144978	0	63513-6	40766240		
75120	2300	4133840	2012-03-01	2012-03-01 00:00:00	2012-03-01	5001	0	\N	0	0	\N	\N	0	153135	0	127783003	4133840		
7669	741	3006322	2001-04-15	2001-04-15 00:00:00	2001-04-15	5001	0	\N	0	0	\N	\N	0	49054	0	8331-1	3006322		
67903	2079	4024958	1960-03-06	1960-03-06 00:00:00	1960-03-06	5001	0	\N	0	0	\N	\N	0	138445	0	117015009	4024958		
46550	4284	3006322	1964-01-07	1964-01-07 00:00:00	1964-01-07	5001	0	\N	0	0	\N	\N	0	284401	0	8331-1	3006322		
153514	4709	4052083	1984-09-09	1984-09-09 00:00:00	1984-09-09	5001	0	\N	0	0	\N	\N	0	313661	0	23426006	4052083		
3598	343	3006322	1987-09-02	1987-09-02 00:00:00	1987-09-02	5001	0	\N	0	0	\N	\N	0	22919	0	8331-1	3006322		
22077	2026	3006322	1954-05-02	1954-05-02 00:00:00	1954-05-02	5001	0	\N	0	0	\N	\N	0	134853	0	8331-1	3006322		
107459	3314	4024958	1989-06-24	1989-06-24 00:00:00	1989-06-24	5001	0	\N	0	0	\N	\N	0	220077	0	117015009	4024958		
2917	277	3006322	2009-10-22	2009-10-22 00:00:00	2009-10-22	5001	0	\N	0	0	\N	\N	0	18493	0	8331-1	3006322		
24221	2230	3006322	1997-04-30	1997-04-30 00:00:00	1997-04-30	5001	0	\N	0	0	\N	\N	0	148403	0	8331-1	3006322		
44970	4156	46235214	2001-06-09	2001-06-09 00:00:00	2001-06-09	5001	0	\N	0	0	\N	\N	0	276163	0	76690-7	46235214		
35677	3259	3006322	2008-03-08	2008-03-08 00:00:00	2008-03-08	5001	0	\N	0	0	\N	\N	0	216653	0	8331-1	3006322		
143740	4418	4052083	1992-10-21	1992-10-21 00:00:00	1992-10-21	5001	0	\N	0	0	\N	\N	0	293719	0	23426006	4052083		
129714	3996	4052083	2003-04-05	2003-04-05 00:00:00	2003-04-05	5001	0	\N	0	0	\N	\N	0	265676	0	23426006	4052083		
155207	4759	4052083	1979-02-06	1979-02-06 00:00:00	1979-02-06	5001	0	\N	0	0	\N	\N	0	317055	0	23426006	4052083		
37296	3439	3006322	1968-06-13	1968-06-13 00:00:00	1968-06-13	5001	0	\N	0	0	\N	\N	0	228141	0	8331-1	3006322		
48713	4451	3006322	1979-03-03	1979-03-03 00:00:00	1979-03-03	5001	0	\N	0	0	\N	\N	0	296149	0	8331-1	3006322		
22755	2087	3006322	1959-10-19	1959-10-19 00:00:00	1959-10-19	5001	0	\N	0	0	\N	\N	0	139044	0	8331-1	3006322		
48951	1491	4024958	1980-10-13	1980-10-13 00:00:00	1980-10-13	5001	0	\N	0	0	\N	\N	0	99433	0	117015009	4024958		
22650	2075	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	138118	0	6095-4	3036780		
91389	2822	4052083	1980-06-01	1980-06-01 00:00:00	1980-06-01	5001	0	\N	0	0	\N	\N	0	187034	0	23426006	4052083		
173912	5333	4024958	1987-09-01	1987-09-01 00:00:00	1987-09-01	5001	0	\N	0	0	\N	\N	0	355130	0	117015009	4024958		
171197	5252	4133840	2010-12-21	2010-12-21 00:00:00	2010-12-21	5001	0	\N	0	0	\N	\N	0	349427	0	127783003	4133840		
5649	173	4052083	2002-04-06	2002-04-06 00:00:00	2002-04-06	5001	0	\N	0	0	\N	\N	0	11742	0	23426006	4052083		
44375	4100	3006322	2009-10-12	2009-10-12 00:00:00	2009-10-12	5001	0	\N	0	0	\N	\N	0	272415	0	8331-1	3006322		
25727	2357	3014599	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	156941	0	6106-9	3014599		
138045	4253	4052083	2017-06-12	2017-06-12 00:00:00	2017-06-12	5001	0	\N	0	0	\N	\N	0	282460	0	23426006	4052083		
51445	4712	3006322	1990-02-28	1990-02-28 00:00:00	1990-02-28	5001	0	\N	0	0	\N	\N	0	313786	0	8331-1	3006322		
105795	3254	4024958	1964-02-01	1964-02-01 00:00:00	1964-02-01	5001	0	\N	0	0	\N	\N	0	216453	0	117015009	4024958		
31956	2915	3020655	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	194348	0	6844-5	3020655		
170608	5233	4024958	2001-02-07	2001-02-07 00:00:00	2001-02-07	5001	0	\N	0	0	\N	\N	0	348156	0	117015009	4024958		
35418	3241	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	215488	0	6833-8	3023430		
54120	4949	3006322	1975-09-09	1975-09-09 00:00:00	1975-09-09	5001	0	\N	0	0	\N	\N	0	329001	0	8331-1	3006322		
37809	3488	3011505	2010-03-12	2010-03-12 00:00:00	2010-03-12	5001	0	\N	0	0	\N	\N	0	231412	0	19926-5	3011505		
30085	2770	3020655	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	183291	0	6844-5	3020655		
26220	820	4024958	1999-06-09	1999-06-09 00:00:00	1999-06-09	5001	0	\N	0	0	\N	\N	0	54352	0	117015009	4024958		
3082	297	3006322	2015-09-16	2015-09-16 00:00:00	2015-09-16	5001	0	\N	0	0	\N	\N	0	19782	0	8331-1	3006322		
21885	2013	40758406	1967-10-06	1967-10-06 00:00:00	1967-10-06	5001	0	\N	0	0	\N	\N	0	133926	0	55277-8	40758406		
23719	742	4133840	1976-08-30	1976-08-30 00:00:00	1976-08-30	5001	0	\N	0	0	\N	\N	0	49108	0	127783003	4133840		
11055	1068	3006322	2000-02-28	2000-02-28 00:00:00	2000-02-28	5001	0	\N	0	0	\N	\N	0	69988	0	8331-1	3006322		
80398	2477	4052083	1974-01-05	1974-01-05 00:00:00	1974-01-05	5001	0	\N	0	0	\N	\N	0	164178	0	23426006	4052083		
13664	1283	3019550	1972-04-22	1972-04-22 00:00:00	1972-04-22	5001	0	\N	0	0	\N	\N	0	84823	0	2951-2	3019550		
135591	4176	4052083	1983-05-01	1983-05-01 00:00:00	1983-05-01	5001	0	\N	0	0	\N	\N	0	277530	0	23426006	4052083		
17628	1604	3011505	2018-09-20	2018-09-20 00:00:00	2018-09-20	5001	0	\N	0	0	\N	\N	0	107666	0	19926-5	3011505		
167772	5150	4024958	1977-09-01	1977-09-01 00:00:00	1977-09-01	5001	0	\N	0	0	\N	\N	0	342391	0	117015009	4024958		
36573	3364	40769194	2000-06-26	2000-06-26 00:00:00	2000-06-26	5001	0	\N	0	0	\N	\N	0	223064	0	66534-9	40769194		
36650	3371	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	223626	0	6158-0	3019406		
5850	550	3049273	1980-03-26	1980-03-26 00:00:00	1980-03-26	5001	0	\N	0	0	\N	\N	0	36459	0	38265-5	3049273		
46128	4255	3051031	1975-02-22	1975-02-22 00:00:00	1975-02-22	5001	0	\N	0	0	\N	\N	0	282510	0	46240-8	3051031		
50945	4642	3006322	1985-12-27	1985-12-27 00:00:00	1985-12-27	5001	0	\N	0	0	\N	\N	0	309370	0	8331-1	3006322		
92366	2847	4052083	1985-06-12	1985-06-12 00:00:00	1985-06-12	5001	0	\N	0	0	\N	\N	0	189111	0	23426006	4052083		
74015	2274	4052083	1967-09-19	1967-09-19 00:00:00	1967-09-19	5001	0	\N	0	0	\N	\N	0	151135	0	23426006	4052083		
28799	2661	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	176385	0	6206-7	3012494		
56661	5200	40758406	1982-10-09	1982-10-09 00:00:00	1982-10-09	5001	0	\N	0	0	\N	\N	0	345936	0	55277-8	40758406		
38294	3528	3001247	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	234239	0	6085-5	3001247		
46539	4282	3006322	1975-06-20	1975-06-20 00:00:00	1975-06-20	5001	0	\N	0	0	\N	\N	0	284166	0	8331-1	3006322		
49739	4523	3006322	2014-03-02	2014-03-02 00:00:00	2014-03-02	5001	0	\N	0	0	\N	\N	0	301196	0	8331-1	3006322		
42825	3957	46235214	1966-06-11	1966-06-11 00:00:00	1966-06-11	5001	0	\N	0	0	\N	\N	0	263044	0	76690-7	46235214		
70050	2149	4024958	1998-11-12	1998-11-12 00:00:00	1998-11-12	5001	0	\N	0	0	\N	\N	0	143061	0	117015009	4024958		
9736	915	3006322	2009-10-22	2009-10-22 00:00:00	2009-10-22	5001	0	\N	0	0	\N	\N	0	60865	0	8331-1	3006322		
844	63	3006322	1980-03-05	1980-03-05 00:00:00	1980-03-05	5001	0	\N	0	0	\N	\N	0	4282	0	8331-1	3006322		
36918	1143	4024958	1974-05-16	1974-05-16 00:00:00	1974-05-16	5001	0	\N	0	0	\N	\N	0	75401	0	117015009	4024958		
12299	1174	46235214	1941-09-10	1941-09-10 00:00:00	1941-09-10	5001	0	\N	0	0	\N	\N	0	77340	0	76690-7	46235214		
23635	2175	40758406	1977-03-29	1977-03-29 00:00:00	1977-03-29	5001	0	\N	0	0	\N	\N	0	144978	0	55277-8	40758406		
75121	2300	4052083	1957-09-18	1957-09-18 00:00:00	1957-09-18	5001	0	\N	0	0	\N	\N	0	153122	0	23426006	4052083		
7670	741	3006322	2010-07-05	2010-07-05 00:00:00	2010-07-05	5001	0	\N	0	0	\N	\N	0	49098	0	8331-1	3006322		
67905	2079	4024958	1958-03-06	1958-03-06 00:00:00	1958-03-06	5001	0	\N	0	0	\N	\N	0	138466	0	117015009	4024958		
46551	4284	3006322	2013-07-02	2013-07-02 00:00:00	2013-07-02	5001	0	\N	0	0	\N	\N	0	284333	0	8331-1	3006322		
115910	3571	4024958	1984-11-05	1984-11-05 00:00:00	1984-11-05	5001	0	\N	0	0	\N	\N	0	237345	0	117015009	4024958		
3599	343	3012494	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	22870	0	6206-7	3012494		
22078	2026	3006322	1960-03-23	1960-03-23 00:00:00	1960-03-23	5001	0	\N	0	0	\N	\N	0	134798	0	8331-1	3006322		
107463	3314	4024958	1999-12-11	1999-12-11 00:00:00	1999-12-11	5001	0	\N	0	0	\N	\N	0	220066	0	117015009	4024958		
2918	277	3006322	1965-07-05	1965-07-05 00:00:00	1965-07-05	5001	0	\N	0	0	\N	\N	0	18457	0	8331-1	3006322		
24222	2231	3006322	1986-08-26	1986-08-26 00:00:00	1986-08-26	5001	0	\N	0	0	\N	\N	0	148435	0	8331-1	3006322		
44971	4156	3051031	2000-11-11	2000-11-11 00:00:00	2000-11-11	5001	0	\N	0	0	\N	\N	0	276211	0	46240-8	3051031		
35678	3260	3006322	1999-02-03	1999-02-03 00:00:00	1999-02-03	5001	0	\N	0	0	\N	\N	0	216707	0	8331-1	3006322		
143743	4418	4052083	2010-01-20	2010-01-20 00:00:00	2010-01-20	5001	0	\N	0	0	\N	\N	0	293752	0	23426006	4052083		
129715	3996	4024958	1995-09-19	1995-09-19 00:00:00	1995-09-19	5001	0	\N	0	0	\N	\N	0	265687	0	117015009	4024958		
155212	4759	4052083	2000-08-10	2000-08-10 00:00:00	2000-08-10	5001	0	\N	0	0	\N	\N	0	317076	0	23426006	4052083		
37297	3439	3006322	1998-03-17	1998-03-17 00:00:00	1998-03-17	5001	0	\N	0	0	\N	\N	0	228192	0	8331-1	3006322		
48714	4451	3006322	2005-03-22	2005-03-22 00:00:00	2005-03-22	5001	0	\N	0	0	\N	\N	0	296168	0	8331-1	3006322		
22756	2087	3049273	1998-07-01	1998-07-01 00:00:00	1998-07-01	5001	0	\N	0	0	\N	\N	0	139057	0	38265-5	3049273		
48954	1491	4024958	1979-05-08	1979-05-08 00:00:00	1979-05-08	5001	0	\N	0	0	\N	\N	0	99432	0	117015009	4024958		
22651	2075	3006322	1977-02-10	1977-02-10 00:00:00	1977-02-10	5001	0	\N	0	0	\N	\N	0	138077	0	8331-1	3006322		
59973	1829	4052083	1985-04-02	1985-04-02 00:00:00	1985-04-02	5001	0	\N	0	0	\N	\N	0	122303	0	23426006	4052083		
59436	1812	4052083	2005-09-02	2005-09-02 00:00:00	2005-09-02	5001	0	\N	0	0	\N	\N	0	121294	0	23426006	4052083		
171199	5252	4133840	2003-04-22	2003-04-22 00:00:00	2003-04-22	5001	0	\N	0	0	\N	\N	0	349470	0	127783003	4133840		
5653	173	4024958	1996-06-19	1996-06-19 00:00:00	1996-06-19	5001	0	\N	0	0	\N	\N	0	11769	0	117015009	4024958		
44376	4100	46235214	1980-01-30	1980-01-30 00:00:00	1980-01-30	5001	0	\N	0	0	\N	\N	0	272383	0	76690-7	46235214		
25728	2357	3019406	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	156941	0	6158-0	3019406		
138050	4253	4024958	1986-11-24	1986-11-24 00:00:00	1986-11-24	5001	0	\N	0	0	\N	\N	0	282439	0	117015009	4024958		
51446	4713	3006322	1999-02-01	1999-02-01 00:00:00	1999-02-01	5001	0	\N	0	0	\N	\N	0	313849	0	8331-1	3006322		
94824	2914	4024958	1999-01-20	1999-01-20 00:00:00	1999-01-20	5001	0	\N	0	0	\N	\N	0	194180	0	117015009	4024958		
31957	2915	3001488	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	194348	0	7258-7	3001488		
170611	5234	4133840	1997-04-23	1997-04-23 00:00:00	1997-04-23	5001	0	\N	0	0	\N	\N	0	348274	0	127783003	4133840		
35419	3241	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	215488	0	6206-7	3012494		
54121	4949	3006322	2017-06-11	2017-06-11 00:00:00	2017-06-11	5001	0	\N	0	0	\N	\N	0	329010	0	8331-1	3006322		
37810	3488	3011505	2009-03-06	2009-03-06 00:00:00	2009-03-06	5001	0	\N	0	0	\N	\N	0	231377	0	19926-5	3011505		
30086	2770	3006451	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	183291	0	6273-7	3006451		
26226	820	4024958	1978-07-20	1978-07-20 00:00:00	1978-07-20	5001	0	\N	0	0	\N	\N	0	54305	0	117015009	4024958		
3083	298	3006322	1952-10-08	1952-10-08 00:00:00	1952-10-08	5001	0	\N	0	0	\N	\N	0	19896	0	8331-1	3006322		
21887	2013	3051031	1967-10-06	1967-10-06 00:00:00	1967-10-06	5001	0	\N	0	0	\N	\N	0	133926	0	46240-8	3051031		
23721	742	4133840	1996-05-13	1996-05-13 00:00:00	1996-05-13	5001	0	\N	0	0	\N	\N	0	49180	0	127783003	4133840		
11056	1070	3006322	1988-08-14	1988-08-14 00:00:00	1988-08-14	5001	0	\N	0	0	\N	\N	0	70075	0	8331-1	3006322		
80425	2480	4052083	1996-10-28	1996-10-28 00:00:00	1996-10-28	5001	0	\N	0	0	\N	\N	0	164277	0	23426006	4052083		
13665	1283	3024561	1972-04-22	1972-04-22 00:00:00	1972-04-22	5001	0	\N	0	0	\N	\N	0	84823	0	1751-7	3024561		
135598	4176	4052083	1979-01-01	1979-01-01 00:00:00	1979-01-01	5001	0	\N	0	0	\N	\N	0	277528	0	23426006	4052083		
17629	1604	3011505	1999-03-11	1999-03-11 00:00:00	1999-03-11	5001	0	\N	0	0	\N	\N	0	107634	0	19926-5	3011505		
167778	5150	4052083	1998-09-13	1998-09-13 00:00:00	1998-09-13	5001	0	\N	0	0	\N	\N	0	342410	0	23426006	4052083		
36574	3364	40769184	2000-06-26	2000-06-26 00:00:00	2000-06-26	5001	0	\N	0	0	\N	\N	0	223064	0	66524-0	40769184		
36651	3371	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	223626	0	6095-4	3036780		
5852	550	3049273	1977-07-29	1977-07-29 00:00:00	1977-07-29	5001	0	\N	0	0	\N	\N	0	36449	0	38265-5	3049273		
46131	4255	40766240	1975-02-22	1975-02-22 00:00:00	1975-02-22	5001	0	\N	0	0	\N	\N	0	282510	0	63513-6	40766240		
50946	4643	3006322	1961-05-22	1961-05-22 00:00:00	1961-05-22	5001	0	\N	0	0	\N	\N	0	309527	0	8331-1	3006322		
92371	2847	4024958	1975-07-20	1975-07-20 00:00:00	1975-07-20	5001	0	\N	0	0	\N	\N	0	189109	0	117015009	4024958		
74027	2274	4024958	1983-12-14	1983-12-14 00:00:00	1983-12-14	5001	0	\N	0	0	\N	\N	0	151145	0	117015009	4024958		
28800	2661	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	176385	0	6246-3	3021226		
56662	5200	3051031	1982-10-09	1982-10-09 00:00:00	1982-10-09	5001	0	\N	0	0	\N	\N	0	345936	0	46240-8	3051031		
38295	3528	3001488	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	234239	0	7258-7	3001488		
46540	4283	3006322	1959-02-04	1959-02-04 00:00:00	1959-02-04	5001	0	\N	0	0	\N	\N	0	284230	0	8331-1	3006322		
49740	4523	3006322	1979-04-06	1979-04-06 00:00:00	1979-04-06	5001	0	\N	0	0	\N	\N	0	301198	0	8331-1	3006322		
42827	3957	40766240	1966-06-11	1966-06-11 00:00:00	1966-06-11	5001	0	\N	0	0	\N	\N	0	263044	0	63513-6	40766240		
70052	2149	4024958	1963-12-24	1963-12-24 00:00:00	1963-12-24	5001	0	\N	0	0	\N	\N	0	143072	0	117015009	4024958		
9737	915	3006322	1997-08-29	1997-08-29 00:00:00	1997-08-29	5001	0	\N	0	0	\N	\N	0	60863	0	8331-1	3006322		
845	64	3006322	1995-07-13	1995-07-13 00:00:00	1995-07-13	5001	0	\N	0	0	\N	\N	0	4333	0	8331-1	3006322		
36935	1143	4052083	2012-12-02	2012-12-02 00:00:00	2012-12-02	5001	0	\N	0	0	\N	\N	0	75449	0	23426006	4052083		
12302	1174	40758406	1941-09-10	1941-09-10 00:00:00	1941-09-10	5001	0	\N	0	0	\N	\N	0	77340	0	55277-8	40758406		
23636	2175	3006451	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	145012	0	6273-7	3006451		
75124	2300	4133840	1995-12-14	1995-12-14 00:00:00	1995-12-14	5001	0	\N	0	0	\N	\N	0	153202	0	127783003	4133840		
7671	742	3006322	1926-01-12	1926-01-12 00:00:00	1926-01-12	5001	0	\N	0	0	\N	\N	0	49135	0	8331-1	3006322		
67920	2079	4052083	1975-12-28	1975-12-28 00:00:00	1975-12-28	5001	0	\N	0	0	\N	\N	0	138492	0	23426006	4052083		
46552	4284	3006322	1951-04-02	1951-04-02 00:00:00	1951-04-02	5001	0	\N	0	0	\N	\N	0	284364	0	8331-1	3006322		
115914	3571	4024958	1977-05-28	1977-05-28 00:00:00	1977-05-28	5001	0	\N	0	0	\N	\N	0	237378	0	117015009	4024958		
3600	343	3006451	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	22870	0	6273-7	3006451		
22079	2026	3006322	2012-02-28	2012-02-28 00:00:00	2012-02-28	5001	0	\N	0	0	\N	\N	0	134859	0	8331-1	3006322		
107467	3314	4024958	1970-07-10	1970-07-10 00:00:00	1970-07-10	5001	0	\N	0	0	\N	\N	0	220073	0	117015009	4024958		
2919	277	3006322	1983-10-28	1983-10-28 00:00:00	1983-10-28	5001	0	\N	0	0	\N	\N	0	18499	0	8331-1	3006322		
24223	2231	3006322	2012-12-02	2012-12-02 00:00:00	2012-12-02	5001	0	\N	0	0	\N	\N	0	148454	0	8331-1	3006322		
991	23	4052083	1991-10-01	1991-10-01 00:00:00	1991-10-01	5001	0	\N	0	0	\N	\N	0	1791	0	23426006	4052083		
35679	3260	3006322	1987-10-21	1987-10-21 00:00:00	1987-10-21	5001	0	\N	0	0	\N	\N	0	216760	0	8331-1	3006322		
143764	4418	4024958	1961-06-23	1961-06-23 00:00:00	1961-06-23	5001	0	\N	0	0	\N	\N	0	293780	0	117015009	4024958		
129737	3997	4052083	2001-04-01	2001-04-01 00:00:00	2001-04-01	5001	0	\N	0	0	\N	\N	0	265740	0	23426006	4052083		
155214	4759	4052083	1987-03-05	1987-03-05 00:00:00	1987-03-05	5001	0	\N	0	0	\N	\N	0	317058	0	23426006	4052083		
37298	3440	3006322	1988-01-28	1988-01-28 00:00:00	1988-01-28	5001	0	\N	0	0	\N	\N	0	228323	0	8331-1	3006322		
48715	4451	3006322	1987-01-31	1987-01-31 00:00:00	1987-01-31	5001	0	\N	0	0	\N	\N	0	296099	0	8331-1	3006322		
22757	2087	3006322	1927-02-11	1927-02-11 00:00:00	1927-02-11	5001	0	\N	0	0	\N	\N	0	139012	0	8331-1	3006322		
148139	4538	4052083	2009-06-08	2009-06-08 00:00:00	2009-06-08	5001	0	\N	0	0	\N	\N	0	302352	0	23426006	4052083		
22652	2075	3006322	1978-04-14	1978-04-14 00:00:00	1978-04-14	5001	0	\N	0	0	\N	\N	0	138067	0	8331-1	3006322		
60048	1834	4024958	1970-12-13	1970-12-13 00:00:00	1970-12-13	5001	0	\N	0	0	\N	\N	0	122558	0	117015009	4024958		
59455	1813	4024958	2002-06-04	2002-06-04 00:00:00	2002-06-04	5001	0	\N	0	0	\N	\N	0	121350	0	117015009	4024958		
171200	5252	4052083	1961-12-06	1961-12-06 00:00:00	1961-12-06	5001	0	\N	0	0	\N	\N	0	349409	0	23426006	4052083		
5654	173	4024958	1994-11-11	1994-11-11 00:00:00	1994-11-11	5001	0	\N	0	0	\N	\N	0	11790	0	117015009	4024958		
44377	4100	40758406	1980-01-30	1980-01-30 00:00:00	1980-01-30	5001	0	\N	0	0	\N	\N	0	272383	0	55277-8	40758406		
25729	2357	3006451	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	156941	0	6273-7	3006451		
138053	4253	4024958	1992-02-05	1992-02-05 00:00:00	1992-02-05	5001	0	\N	0	0	\N	\N	0	282441	0	117015009	4024958		
51447	4713	3006322	1990-12-28	1990-12-28 00:00:00	1990-12-28	5001	0	\N	0	0	\N	\N	0	313830	0	8331-1	3006322		
94825	2914	4052083	1962-09-26	1962-09-26 00:00:00	1962-09-26	5001	0	\N	0	0	\N	\N	0	194191	0	23426006	4052083		
31958	2915	3021226	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	194348	0	6246-3	3021226		
170613	5234	4133840	1999-05-05	1999-05-05 00:00:00	1999-05-05	5001	0	\N	0	0	\N	\N	0	348275	0	127783003	4133840		
35420	3241	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	215488	0	6075-6	3005136		
54124	4952	3009542	1991-03-16	1991-03-16 00:00:00	1991-03-16	5001	0	\N	0	0	\N	\N	0	329128	0	20570-8	3009542		
37811	3488	3011505	2004-02-06	2004-02-06 00:00:00	2004-02-06	5001	0	\N	0	0	\N	\N	0	231409	0	19926-5	3011505		
30087	2770	3012494	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	183291	0	6206-7	3012494		
26234	820	4024958	1992-06-30	1992-06-30 00:00:00	1992-06-30	5001	0	\N	0	0	\N	\N	0	54306	0	117015009	4024958		
3084	298	3006322	1975-08-24	1975-08-24 00:00:00	1975-08-24	5001	0	\N	0	0	\N	\N	0	19895	0	8331-1	3006322		
21889	2013	40766240	1967-10-06	1967-10-06 00:00:00	1967-10-06	5001	0	\N	0	0	\N	\N	0	133926	0	63513-6	40766240		
23722	742	4133840	1979-09-17	1979-09-17 00:00:00	1979-09-17	5001	0	\N	0	0	\N	\N	0	49120	0	127783003	4133840		
11057	1070	3006322	2000-06-29	2000-06-29 00:00:00	2000-06-29	5001	0	\N	0	0	\N	\N	0	70076	0	8331-1	3006322		
80428	2480	4024958	1970-03-01	1970-03-01 00:00:00	1970-03-01	5001	0	\N	0	0	\N	\N	0	164341	0	117015009	4024958		
13666	1283	3016723	1972-04-22	1972-04-22 00:00:00	1972-04-22	5001	0	\N	0	0	\N	\N	0	84823	0	2160-0	3016723		
135628	4176	4052083	1945-03-07	1945-03-07 00:00:00	1945-03-07	5001	0	\N	0	0	\N	\N	0	277444	0	23426006	4052083		
17630	1604	3011505	2006-07-13	2006-07-13 00:00:00	2006-07-13	5001	0	\N	0	0	\N	\N	0	107599	0	19926-5	3011505		
167783	5150	4024958	1939-12-26	1939-12-26 00:00:00	1939-12-26	5001	0	\N	0	0	\N	\N	0	342364	0	117015009	4024958		
147563	4523	4024958	2012-03-28	2012-03-28 00:00:00	2012-03-28	5001	0	\N	0	0	\N	\N	0	301195	0	117015009	4024958		
36652	3371	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	223626	0	6248-9	3015076		
5868	552	3006322	2012-12-12	2012-12-12 00:00:00	2012-12-12	5001	0	\N	0	0	\N	\N	0	36664	0	8331-1	3006322		
46132	4255	3051031	1974-11-24	1974-11-24 00:00:00	1974-11-24	5001	0	\N	0	0	\N	\N	0	282526	0	46240-8	3051031		
50948	4643	3006322	1979-06-27	1979-06-27 00:00:00	1979-06-27	5001	0	\N	0	0	\N	\N	0	309529	0	8331-1	3006322		
92373	2847	4024958	1968-04-14	1968-04-14 00:00:00	1968-04-14	5001	0	\N	0	0	\N	\N	0	189104	0	117015009	4024958		
74074	2277	4052083	1992-07-06	1992-07-06 00:00:00	1992-07-06	5001	0	\N	0	0	\N	\N	0	151377	0	23426006	4052083		
28801	2661	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	176385	0	6075-6	3005136		
56664	5200	46235214	1982-10-09	1982-10-09 00:00:00	1982-10-09	5001	0	\N	0	0	\N	\N	0	345936	0	76690-7	46235214		
38296	3528	3006734	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	234239	0	6189-5	3006734		
115319	3558	4024958	2010-02-06	2010-02-06 00:00:00	2010-02-06	5001	0	\N	0	0	\N	\N	0	236220	0	117015009	4024958		
49741	4523	3006322	2012-03-28	2012-03-28 00:00:00	2012-03-28	5001	0	\N	0	0	\N	\N	0	301195	0	8331-1	3006322		
42828	3957	3011505	2015-10-29	2015-10-29 00:00:00	2015-10-29	5001	0	\N	0	0	\N	\N	0	263081	0	19926-5	3011505		
70059	2149	4024958	1962-12-13	1962-12-13 00:00:00	1962-12-13	5001	0	\N	0	0	\N	\N	0	143071	0	117015009	4024958		
9738	915	3006322	2006-01-27	2006-01-27 00:00:00	2006-01-27	5001	0	\N	0	0	\N	\N	0	60827	0	8331-1	3006322		
846	64	3006322	1985-11-12	1985-11-12 00:00:00	1985-11-12	5001	0	\N	0	0	\N	\N	0	4320	0	8331-1	3006322		
36946	1143	4024958	1982-12-11	1982-12-11 00:00:00	1982-12-11	5001	0	\N	0	0	\N	\N	0	75440	0	117015009	4024958		
12303	1174	3051031	1941-09-10	1941-09-10 00:00:00	1941-09-10	5001	0	\N	0	0	\N	\N	0	77340	0	46240-8	3051031		
23637	2175	3014599	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	145012	0	6106-9	3014599		
140496	4331	4024958	2005-01-09	2005-01-09 00:00:00	2005-01-09	5001	0	\N	0	0	\N	\N	0	287329	0	117015009	4024958		
7672	742	3011505	1979-09-17	1979-09-17 00:00:00	1979-09-17	5001	0	\N	0	0	\N	\N	0	49120	0	19926-5	3011505		
67926	2080	4024958	2019-01-15	2019-01-15 00:00:00	2019-01-15	5001	0	\N	0	0	\N	\N	0	138600	0	117015009	4024958		
46553	4284	3006322	1981-11-13	1981-11-13 00:00:00	1981-11-13	5001	0	\N	0	0	\N	\N	0	284328	0	8331-1	3006322		
115930	3571	4052083	2001-04-04	2001-04-04 00:00:00	2001-04-04	5001	0	\N	0	0	\N	\N	0	237312	0	23426006	4052083		
3601	343	3001247	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	22870	0	6085-5	3001247		
22080	2026	3006322	1975-06-17	1975-06-17 00:00:00	1975-06-17	5001	0	\N	0	0	\N	\N	0	134814	0	8331-1	3006322		
107471	3314	4024958	1966-05-21	1966-05-21 00:00:00	1966-05-21	5001	0	\N	0	0	\N	\N	0	220116	0	117015009	4024958		
2921	279	3006322	1953-10-21	1953-10-21 00:00:00	1953-10-21	5001	0	\N	0	0	\N	\N	0	18614	0	8331-1	3006322		
24224	2231	3006322	1977-11-29	1977-11-29 00:00:00	1977-11-29	5001	0	\N	0	0	\N	\N	0	148425	0	8331-1	3006322		
996	23	4024958	2013-12-06	2013-12-06 00:00:00	2013-12-06	5001	0	\N	0	0	\N	\N	0	1786	0	117015009	4024958		
3208	97	4133840	2017-08-21	2017-08-21 00:00:00	2017-08-21	5001	0	\N	0	0	\N	\N	0	6605	0	127783003	4133840		
143769	4418	4052083	2018-11-29	2018-11-29 00:00:00	2018-11-29	5001	0	\N	0	0	\N	\N	0	293765	0	23426006	4052083		
129740	3997	4024958	1981-03-16	1981-03-16 00:00:00	1981-03-16	5001	0	\N	0	0	\N	\N	0	265737	0	117015009	4024958		
155230	4760	4024958	1975-12-11	1975-12-11 00:00:00	1975-12-11	5001	0	\N	0	0	\N	\N	0	317121	0	117015009	4024958		
37299	3440	3009201	2015-02-20	2015-02-20 00:00:00	2015-02-20	5001	0	\N	0	0	\N	\N	0	228239	0	3016-3	3009201		
48716	4452	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	296333	0	6158-0	3019406		
22758	2087	3008598	1968-05-30	1968-05-30 00:00:00	1968-05-30	5001	0	\N	0	0	\N	\N	0	139031	0	3024-7	3008598		
148140	4538	4024958	1958-06-01	1958-06-01 00:00:00	1958-06-01	5001	0	\N	0	0	\N	\N	0	302331	0	117015009	4024958		
22653	2076	3006322	2009-09-29	2009-09-29 00:00:00	2009-09-29	5001	0	\N	0	0	\N	\N	0	138146	0	8331-1	3006322		
60050	1834	4052083	1971-06-11	1971-06-11 00:00:00	1971-06-11	5001	0	\N	0	0	\N	\N	0	122559	0	23426006	4052083		
59469	1813	4024958	2004-05-07	2004-05-07 00:00:00	2004-05-07	5001	0	\N	0	0	\N	\N	0	121345	0	117015009	4024958		
171204	5252	4133840	2008-12-09	2008-12-09 00:00:00	2008-12-09	5001	0	\N	0	0	\N	\N	0	349426	0	127783003	4133840		
5655	173	4052083	2001-02-02	2001-02-02 00:00:00	2001-02-02	5001	0	\N	0	0	\N	\N	0	11741	0	23426006	4052083		
44378	4100	3051031	1980-01-30	1980-01-30 00:00:00	1980-01-30	5001	0	\N	0	0	\N	\N	0	272383	0	46240-8	3051031		
25730	2357	3012494	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	156941	0	6206-7	3012494		
38741	3582	3049273	2011-12-03	2011-12-03 00:00:00	2011-12-03	5001	0	\N	0	0	\N	\N	0	238125	0	38265-5	3049273		
51448	4713	40758406	1967-04-07	1967-04-07 00:00:00	1967-04-07	5001	0	\N	0	0	\N	\N	0	313838	0	55277-8	40758406		
94833	2914	4024958	1960-05-10	1960-05-10 00:00:00	1960-05-10	5001	0	\N	0	0	\N	\N	0	194190	0	117015009	4024958		
31959	2915	3019406	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	194348	0	6158-0	3019406		
170615	5234	4024958	1956-11-18	1956-11-18 00:00:00	1956-11-18	5001	0	\N	0	0	\N	\N	0	348244	0	117015009	4024958		
35421	3241	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	215488	0	6273-7	3006451		
54125	4952	3000963	1991-03-16	1991-03-16 00:00:00	1991-03-16	5001	0	\N	0	0	\N	\N	0	329128	0	718-7	3000963		
37812	3488	3011505	2018-04-27	2018-04-27 00:00:00	2018-04-27	5001	0	\N	0	0	\N	\N	0	231378	0	19926-5	3011505		
30088	2770	3014599	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	183291	0	6106-9	3014599		
26245	820	4024958	1974-12-26	1974-12-26 00:00:00	1974-12-26	5001	0	\N	0	0	\N	\N	0	54287	0	117015009	4024958		
3085	298	3006322	1981-12-03	1981-12-03 00:00:00	1981-12-03	5001	0	\N	0	0	\N	\N	0	19947	0	8331-1	3006322		
21890	2013	46235214	1967-10-06	1967-10-06 00:00:00	1967-10-06	5001	0	\N	0	0	\N	\N	0	133926	0	76690-7	46235214		
23726	742	4133840	1998-05-25	1998-05-25 00:00:00	1998-05-25	5001	0	\N	0	0	\N	\N	0	49111	0	127783003	4133840		
31563	969	4052083	1988-07-15	1988-07-15 00:00:00	1988-07-15	5001	0	\N	0	0	\N	\N	0	64462	0	23426006	4052083		
33256	3002	3006322	2014-01-22	2014-01-22 00:00:00	2014-01-22	5001	0	\N	0	0	\N	\N	0	200336	0	8331-1	3006322		
13667	1283	3013721	1972-04-22	1972-04-22 00:00:00	1972-04-22	5001	0	\N	0	0	\N	\N	0	84823	0	1920-8	3013721		
6190	578	40758406	2011-04-15	2011-04-15 00:00:00	2011-04-15	5001	0	\N	0	0	\N	\N	0	38198	0	55277-8	40758406		
53740	1627	4024958	1971-02-09	1971-02-09 00:00:00	1971-02-09	5001	0	\N	0	0	\N	\N	0	109364	0	117015009	4024958		
167834	5151	4024958	1980-04-05	1980-04-05 00:00:00	1980-04-05	5001	0	\N	0	0	\N	\N	0	342578	0	117015009	4024958		
147565	4523	4052083	1998-11-27	1998-11-27 00:00:00	1998-11-27	5001	0	\N	0	0	\N	\N	0	301183	0	23426006	4052083		
36653	3371	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	223626	0	6206-7	3012494		
5869	552	3006322	1963-04-12	1963-04-12 00:00:00	1963-04-12	5001	0	\N	0	0	\N	\N	0	36580	0	8331-1	3006322		
46134	4255	40758406	1974-11-24	1974-11-24 00:00:00	1974-11-24	5001	0	\N	0	0	\N	\N	0	282526	0	55277-8	40758406		
50950	4643	3049273	1978-12-07	1978-12-07 00:00:00	1978-12-07	5001	0	\N	0	0	\N	\N	0	309626	0	38265-5	3049273		
92397	2849	4052083	1972-12-13	1972-12-13 00:00:00	1972-12-13	5001	0	\N	0	0	\N	\N	0	189205	0	23426006	4052083		
74081	2277	4052083	2005-10-09	2005-10-09 00:00:00	2005-10-09	5001	0	\N	0	0	\N	\N	0	151325	0	23426006	4052083		
28802	2661	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	176385	0	6106-9	3014599		
56666	5200	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	345811	0	6273-7	3006451		
38297	3528	3000876	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	234239	0	6082-2	3000876		
115322	3558	4133840	2017-05-13	2017-05-13 00:00:00	2017-05-13	5001	0	\N	0	0	\N	\N	0	236190	0	127783003	4133840		
49742	4523	3006322	1977-10-19	1977-10-19 00:00:00	1977-10-19	5001	0	\N	0	0	\N	\N	0	301174	0	8331-1	3006322		
42830	3957	40766240	1965-09-14	1965-09-14 00:00:00	1965-09-14	5001	0	\N	0	0	\N	\N	0	263142	0	63513-6	40766240		
70256	2152	4052083	1972-11-25	1972-11-25 00:00:00	1972-11-25	5001	0	\N	0	0	\N	\N	0	143424	0	23426006	4052083		
9739	915	3006322	1979-10-10	1979-10-10 00:00:00	1979-10-10	5001	0	\N	0	0	\N	\N	0	60840	0	8331-1	3006322		
847	64	3006322	1982-02-15	1982-02-15 00:00:00	1982-02-15	5001	0	\N	0	0	\N	\N	0	4368	0	8331-1	3006322		
36949	1143	4052083	1992-02-05	1992-02-05 00:00:00	1992-02-05	5001	0	\N	0	0	\N	\N	0	75443	0	23426006	4052083		
12304	1174	40766240	1941-09-10	1941-09-10 00:00:00	1941-09-10	5001	0	\N	0	0	\N	\N	0	77340	0	63513-6	40766240		
23638	2175	3036780	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	145012	0	6095-4	3036780		
151807	4649	4024958	1990-08-23	1990-08-23 00:00:00	1990-08-23	5001	0	\N	0	0	\N	\N	0	310032	0	117015009	4024958		
7673	742	3011505	1968-10-28	1968-10-28 00:00:00	1968-10-28	5001	0	\N	0	0	\N	\N	0	49150	0	19926-5	3011505		
68074	2084	4052083	1986-06-03	1986-06-03 00:00:00	1986-06-03	5001	0	\N	0	0	\N	\N	0	138852	0	23426006	4052083		
46554	4284	3006322	2014-08-09	2014-08-09 00:00:00	2014-08-09	5001	0	\N	0	0	\N	\N	0	284366	0	8331-1	3006322		
115942	3571	4024958	1988-08-01	1988-08-01 00:00:00	1988-08-01	5001	0	\N	0	0	\N	\N	0	237332	0	117015009	4024958		
82315	2545	4024958	1977-08-31	1977-08-31 00:00:00	1977-08-31	5001	0	\N	0	0	\N	\N	0	168415	0	117015009	4024958		
22081	2026	3049273	2016-05-04	2016-05-04 00:00:00	2016-05-04	5001	0	\N	0	0	\N	\N	0	134796	0	38265-5	3049273		
107474	3314	4052083	2008-12-21	2008-12-21 00:00:00	2008-12-21	5001	0	\N	0	0	\N	\N	0	220087	0	23426006	4052083		
2922	279	3006322	2000-01-19	2000-01-19 00:00:00	2000-01-19	5001	0	\N	0	0	\N	\N	0	18641	0	8331-1	3006322		
24225	2231	3006322	1987-11-05	1987-11-05 00:00:00	1987-11-05	5001	0	\N	0	0	\N	\N	0	148419	0	8331-1	3006322		
999	23	4052083	2011-11-24	2011-11-24 00:00:00	2011-11-24	5001	0	\N	0	0	\N	\N	0	1804	0	23426006	4052083		
3211	97	4133840	2004-06-07	2004-06-07 00:00:00	2004-06-07	5001	0	\N	0	0	\N	\N	0	6602	0	127783003	4133840		
143771	4418	4052083	1996-12-07	1996-12-07 00:00:00	1996-12-07	5001	0	\N	0	0	\N	\N	0	293704	0	23426006	4052083		
129744	3997	4024958	1978-06-17	1978-06-17 00:00:00	1978-06-17	5001	0	\N	0	0	\N	\N	0	265731	0	117015009	4024958		
155242	4760	4052083	1971-07-11	1971-07-11 00:00:00	1971-07-11	5001	0	\N	0	0	\N	\N	0	317175	0	23426006	4052083		
37300	3440	3008598	2015-02-20	2015-02-20 00:00:00	2015-02-20	5001	0	\N	0	0	\N	\N	0	228239	0	3024-7	3008598		
48717	4452	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	296333	0	6248-9	3015076		
22759	2087	3009201	1968-05-30	1968-05-30 00:00:00	1968-05-30	5001	0	\N	0	0	\N	\N	0	139031	0	3016-3	3009201		
148142	4538	4052083	1986-09-21	1986-09-21 00:00:00	1986-09-21	5001	0	\N	0	0	\N	\N	0	302389	0	23426006	4052083		
22654	2076	3006322	1982-12-07	1982-12-07 00:00:00	1982-12-07	5001	0	\N	0	0	\N	\N	0	138192	0	8331-1	3006322		
60354	1843	4024958	2000-08-22	2000-08-22 00:00:00	2000-08-22	5001	0	\N	0	0	\N	\N	0	123042	0	117015009	4024958		
59473	1813	4052083	1990-10-09	1990-10-09 00:00:00	1990-10-09	5001	0	\N	0	0	\N	\N	0	121343	0	23426006	4052083		
171206	5252	4024958	1992-01-23	1992-01-23 00:00:00	1992-01-23	5001	0	\N	0	0	\N	\N	0	349388	0	117015009	4024958		
131874	4064	4052083	1991-01-06	1991-01-06 00:00:00	1991-01-06	5001	0	\N	0	0	\N	\N	0	270019	0	23426006	4052083		
44381	4100	40766240	1980-01-30	1980-01-30 00:00:00	1980-01-30	5001	0	\N	0	0	\N	\N	0	272383	0	63513-6	40766240		
25731	2357	3021226	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	156941	0	6246-3	3021226		
38742	3582	3011505	2013-07-07	2013-07-07 00:00:00	2013-07-07	5001	0	\N	0	0	\N	\N	0	238099	0	19926-5	3011505		
51449	4713	3051031	1967-04-07	1967-04-07 00:00:00	1967-04-07	5001	0	\N	0	0	\N	\N	0	313838	0	46240-8	3051031		
94841	2914	4052083	1972-12-25	1972-12-25 00:00:00	1972-12-25	5001	0	\N	0	0	\N	\N	0	194192	0	23426006	4052083		
31960	2915	3015076	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	194348	0	6248-9	3015076		
170623	5234	4052083	1956-06-25	1956-06-25 00:00:00	1956-06-25	5001	0	\N	0	0	\N	\N	0	348222	0	23426006	4052083		
35422	3241	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	215488	0	6085-5	3001247		
54126	4952	3006322	2009-02-25	2009-02-25 00:00:00	2009-02-25	5001	0	\N	0	0	\N	\N	0	329155	0	8331-1	3006322		
37813	3488	3011505	2013-03-29	2013-03-29 00:00:00	2013-03-29	5001	0	\N	0	0	\N	\N	0	231372	0	19926-5	3011505		
30089	2770	3027231	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	183291	0	6276-0	3027231		
26247	821	4024958	1968-12-07	1968-12-07 00:00:00	1968-12-07	5001	0	\N	0	0	\N	\N	0	54429	0	117015009	4024958		
3086	298	3006322	2018-09-02	2018-09-02 00:00:00	2018-09-02	5001	0	\N	0	0	\N	\N	0	19887	0	8331-1	3006322		
21891	2013	40758406	1967-05-09	1967-05-09 00:00:00	1967-05-09	5001	0	\N	0	0	\N	\N	0	133949	0	55277-8	40758406		
23728	742	4133840	1984-10-15	1984-10-15 00:00:00	1984-10-15	5001	0	\N	0	0	\N	\N	0	49114	0	127783003	4133840		
31591	970	4024958	1997-03-10	1997-03-10 00:00:00	1997-03-10	5001	0	\N	0	0	\N	\N	0	64521	0	117015009	4024958		
33257	3004	3006322	1961-10-08	1961-10-08 00:00:00	1961-10-08	5001	0	\N	0	0	\N	\N	0	200455	0	8331-1	3006322		
13668	1283	3006322	1975-10-09	1975-10-09 00:00:00	1975-10-09	5001	0	\N	0	0	\N	\N	0	84827	0	8331-1	3006322		
6192	578	40766240	2011-04-15	2011-04-15 00:00:00	2011-04-15	5001	0	\N	0	0	\N	\N	0	38198	0	63513-6	40766240		
53741	1627	4052083	1995-10-05	1995-10-05 00:00:00	1995-10-05	5001	0	\N	0	0	\N	\N	0	109337	0	23426006	4052083		
167835	5151	4052083	2007-03-21	2007-03-21 00:00:00	2007-03-21	5001	0	\N	0	0	\N	\N	0	342580	0	23426006	4052083		
147605	4525	4024958	2013-11-06	2013-11-06 00:00:00	2013-11-06	5001	0	\N	0	0	\N	\N	0	301263	0	117015009	4024958		
36654	3371	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	223626	0	6082-2	3000876		
5870	552	3006322	2014-02-21	2014-02-21 00:00:00	2014-02-21	5001	0	\N	0	0	\N	\N	0	36646	0	8331-1	3006322		
46135	4255	46235214	1974-11-24	1974-11-24 00:00:00	1974-11-24	5001	0	\N	0	0	\N	\N	0	282526	0	76690-7	46235214		
50951	4643	3006322	1953-02-06	1953-02-06 00:00:00	1953-02-06	5001	0	\N	0	0	\N	\N	0	309525	0	8331-1	3006322		
92400	2849	4024958	1951-01-28	1951-01-28 00:00:00	1951-01-28	5001	0	\N	0	0	\N	\N	0	189301	0	117015009	4024958		
8454	800	3006322	1982-07-01	1982-07-01 00:00:00	1982-07-01	5001	0	\N	0	0	\N	\N	0	53111	0	8331-1	3006322		
28803	2661	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	176385	0	6095-4	3036780		
56667	5200	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	345811	0	6833-8	3023430		
38298	3528	3014599	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	234239	0	6106-9	3014599		
115323	3558	4024958	1965-05-27	1965-05-27 00:00:00	1965-05-27	5001	0	\N	0	0	\N	\N	0	236226	0	117015009	4024958		
49743	4523	3006322	1978-07-01	1978-07-01 00:00:00	1978-07-01	5001	0	\N	0	0	\N	\N	0	301181	0	8331-1	3006322		
42831	3957	3051031	1965-09-14	1965-09-14 00:00:00	1965-09-14	5001	0	\N	0	0	\N	\N	0	263142	0	46240-8	3051031		
70261	2152	4052083	1922-08-12	1922-08-12 00:00:00	1922-08-12	5001	0	\N	0	0	\N	\N	0	143378	0	23426006	4052083		
9740	915	3006322	1977-01-11	1977-01-11 00:00:00	1977-01-11	5001	0	\N	0	0	\N	\N	0	60862	0	8331-1	3006322		
848	64	3006322	1989-12-01	1989-12-01 00:00:00	1989-12-01	5001	0	\N	0	0	\N	\N	0	4332	0	8331-1	3006322		
36967	1144	4024958	2016-06-12	2016-06-12 00:00:00	2016-06-12	5001	0	\N	0	0	\N	\N	0	75502	0	117015009	4024958		
12305	1174	3006322	1981-10-31	1981-10-31 00:00:00	1981-10-31	5001	0	\N	0	0	\N	\N	0	77344	0	8331-1	3006322		
23639	2175	3027231	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	145012	0	6276-0	3027231		
151813	4649	4052083	2010-05-03	2010-05-03 00:00:00	2010-05-03	5001	0	\N	0	0	\N	\N	0	310012	0	23426006	4052083		
7674	742	3011505	1985-10-21	1985-10-21 00:00:00	1985-10-21	5001	0	\N	0	0	\N	\N	0	49206	0	19926-5	3011505		
68078	2084	4052083	1997-04-29	1997-04-29 00:00:00	1997-04-29	5001	0	\N	0	0	\N	\N	0	138839	0	23426006	4052083		
59964	1829	4052083	2003-07-17	2003-07-17 00:00:00	2003-07-17	5001	0	\N	0	0	\N	\N	0	122305	0	23426006	4052083		
115956	3571	4052083	2017-07-17	2017-07-17 00:00:00	2017-07-17	5001	0	\N	0	0	\N	\N	0	237316	0	23426006	4052083		
82318	2545	4052083	1959-11-12	1959-11-12 00:00:00	1959-11-12	5001	0	\N	0	0	\N	\N	0	168438	0	23426006	4052083		
22082	2027	3006322	1963-10-04	1963-10-04 00:00:00	1963-10-04	5001	0	\N	0	0	\N	\N	0	134872	0	8331-1	3006322		
107479	3314	4024958	1980-04-30	1980-04-30 00:00:00	1980-04-30	5001	0	\N	0	0	\N	\N	0	220075	0	117015009	4024958		
2923	279	3006322	2001-10-22	2001-10-22 00:00:00	2001-10-22	5001	0	\N	0	0	\N	\N	0	18622	0	8331-1	3006322		
24226	2232	3006322	2019-06-18	2019-06-18 00:00:00	2019-06-18	5001	0	\N	0	0	\N	\N	0	148514	0	8331-1	3006322		
63160	1941	4052083	1997-03-18	1997-03-18 00:00:00	1997-03-18	5001	0	\N	0	0	\N	\N	0	129038	0	23426006	4052083		
3217	97	4133840	2006-06-19	2006-06-19 00:00:00	2006-06-19	5001	0	\N	0	0	\N	\N	0	6603	0	127783003	4133840		
143800	4419	4052083	1956-01-21	1956-01-21 00:00:00	1956-01-21	5001	0	\N	0	0	\N	\N	0	293859	0	23426006	4052083		
129745	3997	4024958	2001-01-13	2001-01-13 00:00:00	2001-01-13	5001	0	\N	0	0	\N	\N	0	265771	0	117015009	4024958		
155243	4760	4052083	1985-06-28	1985-06-28 00:00:00	1985-06-28	5001	0	\N	0	0	\N	\N	0	317146	0	23426006	4052083		
37301	3440	3049273	2015-10-29	2015-10-29 00:00:00	2015-10-29	5001	0	\N	0	0	\N	\N	0	228232	0	38265-5	3049273		
48718	4452	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	296333	0	6082-2	3000876		
22760	2088	3011505	2004-06-29	2004-06-29 00:00:00	2004-06-29	5001	0	\N	0	0	\N	\N	0	139174	0	19926-5	3011505		
148149	4538	4024958	1986-09-07	1986-09-07 00:00:00	1986-09-07	5001	0	\N	0	0	\N	\N	0	302335	0	117015009	4024958		
22655	2077	3006322	1984-12-22	1984-12-22 00:00:00	1984-12-22	5001	0	\N	0	0	\N	\N	0	138269	0	8331-1	3006322		
60362	1843	4024958	1986-05-28	1986-05-28 00:00:00	1986-05-28	5001	0	\N	0	0	\N	\N	0	123056	0	117015009	4024958		
59475	1813	4052083	1987-07-20	1987-07-20 00:00:00	1987-07-20	5001	0	\N	0	0	\N	\N	0	121340	0	23426006	4052083		
171207	5252	4052083	1987-01-08	1987-01-08 00:00:00	1987-01-08	5001	0	\N	0	0	\N	\N	0	349415	0	23426006	4052083		
131875	4064	4024958	1999-10-06	1999-10-06 00:00:00	1999-10-06	5001	0	\N	0	0	\N	\N	0	270117	0	117015009	4024958		
44382	4100	3051031	1979-12-31	1979-12-31 00:00:00	1979-12-31	5001	0	\N	0	0	\N	\N	0	272455	0	46240-8	3051031		
25732	2357	3005136	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	156941	0	6075-6	3005136		
38743	3582	3006322	1998-03-17	1998-03-17 00:00:00	1998-03-17	5001	0	\N	0	0	\N	\N	0	238091	0	8331-1	3006322		
51451	4713	40766240	1967-04-07	1967-04-07 00:00:00	1967-04-07	5001	0	\N	0	0	\N	\N	0	313838	0	63513-6	40766240		
94863	2915	4024958	1952-05-23	1952-05-23 00:00:00	1952-05-23	5001	0	\N	0	0	\N	\N	0	194339	0	117015009	4024958		
31961	2915	3005136	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	194348	0	6075-6	3005136		
170891	5242	4052083	1975-11-18	1975-11-18 00:00:00	1975-11-18	5001	0	\N	0	0	\N	\N	0	348829	0	23426006	4052083		
35423	3241	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	215488	0	6189-5	3006734		
78887	2423	4024958	1967-12-08	1967-12-08 00:00:00	1967-12-08	5001	0	\N	0	0	\N	\N	0	160727	0	117015009	4024958		
37814	3488	3011505	1997-08-29	1997-08-29 00:00:00	1997-08-29	5001	0	\N	0	0	\N	\N	0	231398	0	19926-5	3011505		
30090	2770	3001488	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	183291	0	7258-7	3001488		
26257	821	4052083	1968-08-08	1968-08-08 00:00:00	1968-08-08	5001	0	\N	0	0	\N	\N	0	54398	0	23426006	4052083		
3087	299	46235214	1963-09-05	1963-09-05 00:00:00	1963-09-05	5001	0	\N	0	0	\N	\N	0	20014	0	76690-7	46235214		
21892	2013	46235214	1967-05-09	1967-05-09 00:00:00	1967-05-09	5001	0	\N	0	0	\N	\N	0	133949	0	76690-7	46235214		
23730	742	4133840	1964-10-19	1964-10-19 00:00:00	1964-10-19	5001	0	\N	0	0	\N	\N	0	49160	0	127783003	4133840		
31594	970	4024958	1976-09-05	1976-09-05 00:00:00	1976-09-05	5001	0	\N	0	0	\N	\N	0	64481	0	117015009	4024958		
33258	3004	3006322	2008-01-23	2008-01-23 00:00:00	2008-01-23	5001	0	\N	0	0	\N	\N	0	200469	0	8331-1	3006322		
13674	1285	3001247	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	84986	0	6085-5	3001247		
6194	578	3051031	2010-11-16	2010-11-16 00:00:00	2010-11-16	5001	0	\N	0	0	\N	\N	0	38255	0	46240-8	3051031		
108815	3362	4024958	1965-06-26	1965-06-26 00:00:00	1965-06-26	5001	0	\N	0	0	\N	\N	0	222882	0	117015009	4024958		
167840	5151	4024958	2014-02-25	2014-02-25 00:00:00	2014-02-25	5001	0	\N	0	0	\N	\N	0	342505	0	117015009	4024958		
147606	4525	4052083	1969-01-26	1969-01-26 00:00:00	1969-01-26	5001	0	\N	0	0	\N	\N	0	301268	0	23426006	4052083		
36655	3371	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	223626	0	6844-5	3020655		
5871	552	3006322	1980-12-18	1980-12-18 00:00:00	1980-12-18	5001	0	\N	0	0	\N	\N	0	36662	0	8331-1	3006322		
46137	4255	40766240	1974-11-24	1974-11-24 00:00:00	1974-11-24	5001	0	\N	0	0	\N	\N	0	282526	0	63513-6	40766240		
50952	4643	3049273	1985-02-03	1985-02-03 00:00:00	1985-02-03	5001	0	\N	0	0	\N	\N	0	309627	0	38265-5	3049273		
92403	2849	4024958	1925-02-05	1925-02-05 00:00:00	1925-02-05	5001	0	\N	0	0	\N	\N	0	189299	0	117015009	4024958		
8455	800	3006322	2013-03-15	2013-03-15 00:00:00	2013-03-15	5001	0	\N	0	0	\N	\N	0	53132	0	8331-1	3006322		
28804	2661	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	176385	0	6158-0	3019406		
56668	5200	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	345811	0	6844-5	3020655		
38299	3528	3005136	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	234239	0	6075-6	3005136		
115327	3558	4133840	2019-05-25	2019-05-25 00:00:00	2019-05-25	5001	0	\N	0	0	\N	\N	0	236205	0	127783003	4133840		
49747	4525	3006322	1984-05-19	1984-05-19 00:00:00	1984-05-19	5001	0	\N	0	0	\N	\N	0	301298	0	8331-1	3006322		
42832	3957	46235214	1965-09-14	1965-09-14 00:00:00	1965-09-14	5001	0	\N	0	0	\N	\N	0	263142	0	76690-7	46235214		
70271	2152	4024958	1924-05-05	1924-05-05 00:00:00	1924-05-05	5001	0	\N	0	0	\N	\N	0	143431	0	117015009	4024958		
9743	917	3006322	1978-12-25	1978-12-25 00:00:00	1978-12-25	5001	0	\N	0	0	\N	\N	0	61072	0	8331-1	3006322		
849	65	3006322	2005-12-10	2005-12-10 00:00:00	2005-12-10	5001	0	\N	0	0	\N	\N	0	4398	0	8331-1	3006322		
146133	4482	4024958	1958-11-30	1958-11-30 00:00:00	1958-11-30	5001	0	\N	0	0	\N	\N	0	298385	0	117015009	4024958		
12306	1174	3006322	1978-10-31	1978-10-31 00:00:00	1978-10-31	5001	0	\N	0	0	\N	\N	0	77343	0	8331-1	3006322		
23640	2175	3001488	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	145012	0	7258-7	3001488		
151815	4649	4052083	2004-05-11	2004-05-11 00:00:00	2004-05-11	5001	0	\N	0	0	\N	\N	0	309977	0	23426006	4052083		
7675	742	3011505	1988-11-07	1988-11-07 00:00:00	1988-11-07	5001	0	\N	0	0	\N	\N	0	49121	0	19926-5	3011505		
68082	2084	4024958	1990-07-11	1990-07-11 00:00:00	1990-07-11	5001	0	\N	0	0	\N	\N	0	138836	0	117015009	4024958		
71252	2180	4024958	1979-01-30	1979-01-30 00:00:00	1979-01-30	5001	0	\N	0	0	\N	\N	0	145404	0	117015009	4024958		
78731	2418	4052083	2018-06-02	2018-06-02 00:00:00	2018-06-02	5001	0	\N	0	0	\N	\N	0	160446	0	23426006	4052083		
82321	2545	4024958	1988-05-16	1988-05-16 00:00:00	1988-05-16	5001	0	\N	0	0	\N	\N	0	168391	0	117015009	4024958		
22083	2027	3006322	1969-01-15	1969-01-15 00:00:00	1969-01-15	5001	0	\N	0	0	\N	\N	0	134869	0	8331-1	3006322		
107485	3315	4024958	1981-05-05	1981-05-05 00:00:00	1981-05-05	5001	0	\N	0	0	\N	\N	0	220137	0	117015009	4024958		
2924	279	3006322	2006-05-10	2006-05-10 00:00:00	2006-05-10	5001	0	\N	0	0	\N	\N	0	18623	0	8331-1	3006322		
24227	2233	3006322	1976-01-15	1976-01-15 00:00:00	1976-01-15	5001	0	\N	0	0	\N	\N	0	148583	0	8331-1	3006322		
112980	3488	4133840	1997-08-29	1997-08-29 00:00:00	1997-08-29	5001	0	\N	0	0	\N	\N	0	231398	0	127783003	4133840		
3219	97	4133840	2003-06-02	2003-06-02 00:00:00	2003-06-02	5001	0	\N	0	0	\N	\N	0	6629	0	127783003	4133840		
19953	621	4024958	1939-11-17	1939-11-17 00:00:00	1939-11-17	5001	0	\N	0	0	\N	\N	0	41470	0	117015009	4024958		
129747	3997	4024958	1969-12-04	1969-12-04 00:00:00	1969-12-04	5001	0	\N	0	0	\N	\N	0	265729	0	117015009	4024958		
16460	1500	3006322	1984-08-30	1984-08-30 00:00:00	1984-08-30	5001	0	\N	0	0	\N	\N	0	100127	0	8331-1	3006322		
37302	3440	3006322	1962-03-11	1962-03-11 00:00:00	1962-03-11	5001	0	\N	0	0	\N	\N	0	228259	0	8331-1	3006322		
48719	4452	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	296333	0	6075-6	3005136		
22761	2088	3011505	1993-08-17	1993-08-17 00:00:00	1993-08-17	5001	0	\N	0	0	\N	\N	0	139278	0	19926-5	3011505		
148151	4538	4024958	1981-07-12	1981-07-12 00:00:00	1981-07-12	5001	0	\N	0	0	\N	\N	0	302334	0	117015009	4024958		
22657	2077	3006322	1951-07-09	1951-07-09 00:00:00	1951-07-09	5001	0	\N	0	0	\N	\N	0	138266	0	8331-1	3006322		
60363	1843	4024958	1993-10-02	1993-10-02 00:00:00	1993-10-02	5001	0	\N	0	0	\N	\N	0	123058	0	117015009	4024958		
59478	1813	4024958	2007-09-03	2007-09-03 00:00:00	2007-09-03	5001	0	\N	0	0	\N	\N	0	121347	0	117015009	4024958		
171209	5252	4133840	2011-12-27	2011-12-27 00:00:00	2011-12-27	5001	0	\N	0	0	\N	\N	0	349474	0	127783003	4133840		
49116	4487	3006322	1985-03-11	1985-03-11 00:00:00	1985-03-11	5001	0	\N	0	0	\N	\N	0	298749	0	8331-1	3006322		
44385	4100	40766240	1979-12-31	1979-12-31 00:00:00	1979-12-31	5001	0	\N	0	0	\N	\N	0	272455	0	63513-6	40766240		
25733	2357	3015076	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	156941	0	6248-9	3015076		
38744	3582	3011505	2006-05-28	2006-05-28 00:00:00	2006-05-28	5001	0	\N	0	0	\N	\N	0	238162	0	19926-5	3011505		
51453	4713	46235214	1967-04-07	1967-04-07 00:00:00	1967-04-07	5001	0	\N	0	0	\N	\N	0	313838	0	76690-7	46235214		
106167	3270	4024958	1981-01-14	1981-01-14 00:00:00	1981-01-14	5001	0	\N	0	0	\N	\N	0	217259	0	117015009	4024958		
31962	2915	3000876	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	194348	0	6082-2	3000876		
170894	5242	4024958	2017-05-12	2017-05-12 00:00:00	2017-05-12	5001	0	\N	0	0	\N	\N	0	348845	0	117015009	4024958		
35424	3242	3006322	1989-07-03	1989-07-03 00:00:00	1989-07-03	5001	0	\N	0	0	\N	\N	0	215593	0	8331-1	3006322		
78897	2423	4024958	1964-03-15	1964-03-15 00:00:00	1964-03-15	5001	0	\N	0	0	\N	\N	0	160749	0	117015009	4024958		
37815	3488	3011505	1988-07-29	1988-07-29 00:00:00	1988-07-29	5001	0	\N	0	0	\N	\N	0	231407	0	19926-5	3011505		
30091	2770	3001247	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	183291	0	6085-5	3001247		
26267	821	4024958	1978-04-04	1978-04-04 00:00:00	1978-04-04	5001	0	\N	0	0	\N	\N	0	54381	0	117015009	4024958		
3088	299	40758406	1963-09-05	1963-09-05 00:00:00	1963-09-05	5001	0	\N	0	0	\N	\N	0	20014	0	55277-8	40758406		
21894	2013	40766240	1967-05-09	1967-05-09 00:00:00	1967-05-09	5001	0	\N	0	0	\N	\N	0	133949	0	63513-6	40766240		
23735	742	4133840	1997-05-19	1997-05-19 00:00:00	1997-05-19	5001	0	\N	0	0	\N	\N	0	49122	0	127783003	4133840		
31603	970	4024958	1985-09-14	1985-09-14 00:00:00	1985-09-14	5001	0	\N	0	0	\N	\N	0	64520	0	117015009	4024958		
33259	3004	3006322	1958-10-12	1958-10-12 00:00:00	1958-10-12	5001	0	\N	0	0	\N	\N	0	200464	0	8331-1	3006322		
13675	1285	3023430	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	84986	0	6833-8	3023430		
6195	578	40758406	2010-11-16	2010-11-16 00:00:00	2010-11-16	5001	0	\N	0	0	\N	\N	0	38255	0	55277-8	40758406		
108822	3362	4024958	1979-10-01	1979-10-01 00:00:00	1979-10-01	5001	0	\N	0	0	\N	\N	0	222864	0	117015009	4024958		
33972	3088	3006322	1952-01-08	1952-01-08 00:00:00	1952-01-08	5001	0	\N	0	0	\N	\N	0	205616	0	8331-1	3006322		
147609	4525	4024958	1984-05-19	1984-05-19 00:00:00	1984-05-19	5001	0	\N	0	0	\N	\N	0	301298	0	117015009	4024958		
36656	3371	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	223626	0	6833-8	3023430		
5872	552	3006322	1955-04-15	1955-04-15 00:00:00	1955-04-15	5001	0	\N	0	0	\N	\N	0	36641	0	8331-1	3006322		
46138	4256	3006322	1961-11-01	1961-11-01 00:00:00	1961-11-01	5001	0	\N	0	0	\N	\N	0	282608	0	8331-1	3006322		
50953	4643	3006322	1994-06-20	1994-06-20 00:00:00	1994-06-20	5001	0	\N	0	0	\N	\N	0	309596	0	8331-1	3006322		
7297	232	4052083	1977-04-14	1977-04-14 00:00:00	1977-04-14	5001	0	\N	0	0	\N	\N	0	15635	0	23426006	4052083		
8456	800	3006322	1965-02-04	1965-02-04 00:00:00	1965-02-04	5001	0	\N	0	0	\N	\N	0	53106	0	8331-1	3006322		
28805	2661	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	176385	0	6085-5	3001247		
56669	5200	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	345811	0	7258-7	3001488		
38300	3528	3015076	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	234239	0	6248-9	3015076		
115328	3558	4024958	1993-10-05	1993-10-05 00:00:00	1993-10-05	5001	0	\N	0	0	\N	\N	0	236228	0	117015009	4024958		
49748	4525	3006322	1974-02-01	1974-02-01 00:00:00	1974-02-01	5001	0	\N	0	0	\N	\N	0	301270	0	8331-1	3006322		
42833	3957	40758406	1965-09-14	1965-09-14 00:00:00	1965-09-14	5001	0	\N	0	0	\N	\N	0	263142	0	55277-8	40758406		
70272	2152	4024958	1959-06-18	1959-06-18 00:00:00	1959-06-18	5001	0	\N	0	0	\N	\N	0	143435	0	117015009	4024958		
9744	917	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	61059	0	6273-7	3006451		
850	65	3006322	2004-11-06	2004-11-06 00:00:00	2004-11-06	5001	0	\N	0	0	\N	\N	0	4404	0	8331-1	3006322		
146154	4484	4052083	2011-09-09	2011-09-09 00:00:00	2011-09-09	5001	0	\N	0	0	\N	\N	0	298465	0	23426006	4052083		
12309	1174	3051031	1941-10-09	1941-10-09 00:00:00	1941-10-09	5001	0	\N	0	0	\N	\N	0	77389	0	46240-8	3051031		
23641	2175	3012494	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	145012	0	6206-7	3012494		
151821	4649	4052083	2015-03-01	2015-03-01 00:00:00	2015-03-01	5001	0	\N	0	0	\N	\N	0	309978	0	23426006	4052083		
7676	742	3006322	1970-02-05	1970-02-05 00:00:00	1970-02-05	5001	0	\N	0	0	\N	\N	0	49126	0	8331-1	3006322		
68084	2084	4024958	1992-12-07	1992-12-07 00:00:00	1992-12-07	5001	0	\N	0	0	\N	\N	0	138837	0	117015009	4024958		
71255	2180	4024958	1984-10-13	1984-10-13 00:00:00	1984-10-13	5001	0	\N	0	0	\N	\N	0	145399	0	117015009	4024958		
21823	686	4024958	1967-06-12	1967-06-12 00:00:00	1967-06-12	5001	0	\N	0	0	\N	\N	0	45382	0	117015009	4024958		
82325	2545	4024958	1973-08-11	1973-08-11 00:00:00	1973-08-11	5001	0	\N	0	0	\N	\N	0	168414	0	117015009	4024958		
22084	2027	3006322	2005-12-29	2005-12-29 00:00:00	2005-12-29	5001	0	\N	0	0	\N	\N	0	134877	0	8331-1	3006322		
107487	3315	4024958	2002-02-07	2002-02-07 00:00:00	2002-02-07	5001	0	\N	0	0	\N	\N	0	220208	0	117015009	4024958		
2925	279	3006322	1964-07-07	1964-07-07 00:00:00	1964-07-07	5001	0	\N	0	0	\N	\N	0	18653	0	8331-1	3006322		
24228	2235	3006322	2012-10-26	2012-10-26 00:00:00	2012-10-26	5001	0	\N	0	0	\N	\N	0	148639	0	8331-1	3006322		
112983	3488	4133840	2014-04-04	2014-04-04 00:00:00	2014-04-04	5001	0	\N	0	0	\N	\N	0	231426	0	127783003	4133840		
3221	97	4133840	1980-07-28	1980-07-28 00:00:00	1980-07-28	5001	0	\N	0	0	\N	\N	0	6606	0	127783003	4133840		
19968	621	4024958	1945-05-29	1945-05-29 00:00:00	1945-05-29	5001	0	\N	0	0	\N	\N	0	41449	0	117015009	4024958		
38179	1185	4024958	1941-01-10	1941-01-10 00:00:00	1941-01-10	5001	0	\N	0	0	\N	\N	0	78102	0	117015009	4024958		
16461	1500	3006322	2007-04-15	2007-04-15 00:00:00	2007-04-15	5001	0	\N	0	0	\N	\N	0	100071	0	8331-1	3006322		
37303	3440	3049273	1944-01-29	1944-01-29 00:00:00	1944-01-29	5001	0	\N	0	0	\N	\N	0	228291	0	38265-5	3049273		
48720	4452	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	296333	0	6246-3	3021226		
22762	2088	3011505	1996-05-14	1996-05-14 00:00:00	1996-05-14	5001	0	\N	0	0	\N	\N	0	139239	0	19926-5	3011505		
69989	2147	4024958	1971-07-15	1971-07-15 00:00:00	1971-07-15	5001	0	\N	0	0	\N	\N	0	143002	0	117015009	4024958		
22658	2077	3006322	1961-05-31	1961-05-31 00:00:00	1961-05-31	5001	0	\N	0	0	\N	\N	0	138283	0	8331-1	3006322		
60383	1844	4024958	1964-04-24	1964-04-24 00:00:00	1964-04-24	5001	0	\N	0	0	\N	\N	0	123191	0	117015009	4024958		
59481	1814	4052083	1991-05-30	1991-05-30 00:00:00	1991-05-30	5001	0	\N	0	0	\N	\N	0	121442	0	23426006	4052083		
171210	5253	4133840	2006-12-16	2006-12-16 00:00:00	2006-12-16	5001	0	\N	0	0	\N	\N	0	349512	0	127783003	4133840		
49117	4487	3006322	1975-10-20	1975-10-20 00:00:00	1975-10-20	5001	0	\N	0	0	\N	\N	0	298689	0	8331-1	3006322		
44386	4100	40758406	1979-12-31	1979-12-31 00:00:00	1979-12-31	5001	0	\N	0	0	\N	\N	0	272455	0	55277-8	40758406		
25734	2357	3027231	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	156941	0	6276-0	3027231		
38745	3582	3011505	2000-06-11	2000-06-11 00:00:00	2000-06-11	5001	0	\N	0	0	\N	\N	0	238098	0	19926-5	3011505		
51454	4713	3051031	2013-10-22	2013-10-22 00:00:00	2013-10-22	5001	0	\N	0	0	\N	\N	0	313871	0	46240-8	3051031		
106169	3270	4024958	1984-01-24	1984-01-24 00:00:00	1984-01-24	5001	0	\N	0	0	\N	\N	0	217252	0	117015009	4024958		
31963	2915	3001247	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	194348	0	6085-5	3001247		
170895	5242	4052083	1996-12-07	1996-12-07 00:00:00	1996-12-07	5001	0	\N	0	0	\N	\N	0	348844	0	23426006	4052083		
35425	3242	3006322	2014-09-13	2014-09-13 00:00:00	2014-09-13	5001	0	\N	0	0	\N	\N	0	215634	0	8331-1	3006322		
170723	5236	4052083	2017-10-12	2017-10-12 00:00:00	2017-10-12	5001	0	\N	0	0	\N	\N	0	348423	0	23426006	4052083		
37816	3488	3011505	2005-02-11	2005-02-11 00:00:00	2005-02-11	5001	0	\N	0	0	\N	\N	0	231375	0	19926-5	3011505		
30092	2770	3006734	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	183291	0	6189-5	3006734		
59620	1819	4024958	1981-04-07	1981-04-07 00:00:00	1981-04-07	5001	0	\N	0	0	\N	\N	0	121673	0	117015009	4024958		
3090	299	40766240	1963-09-05	1963-09-05 00:00:00	1963-09-05	5001	0	\N	0	0	\N	\N	0	20014	0	63513-6	40766240		
21895	2013	3051031	1967-05-09	1967-05-09 00:00:00	1967-05-09	5001	0	\N	0	0	\N	\N	0	133949	0	46240-8	3051031		
23737	742	4133840	1999-05-31	1999-05-31 00:00:00	1999-05-31	5001	0	\N	0	0	\N	\N	0	49123	0	127783003	4133840		
31609	970	4024958	1953-08-03	1953-08-03 00:00:00	1953-08-03	5001	0	\N	0	0	\N	\N	0	64486	0	117015009	4024958		
33260	3004	3006322	2004-12-24	2004-12-24 00:00:00	2004-12-24	5001	0	\N	0	0	\N	\N	0	200501	0	8331-1	3006322		
13676	1285	3021226	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	84986	0	6246-3	3021226		
6196	578	40766240	2010-11-16	2010-11-16 00:00:00	2010-11-16	5001	0	\N	0	0	\N	\N	0	38255	0	63513-6	40766240		
108830	3362	4024958	1957-09-22	1957-09-22 00:00:00	1957-09-22	5001	0	\N	0	0	\N	\N	0	222881	0	117015009	4024958		
33973	3090	3006322	2008-02-08	2008-02-08 00:00:00	2008-02-08	5001	0	\N	0	0	\N	\N	0	205757	0	8331-1	3006322		
147626	4525	4052083	2007-05-23	2007-05-23 00:00:00	2007-05-23	5001	0	\N	0	0	\N	\N	0	301289	0	23426006	4052083		
61489	1882	4052083	1987-06-13	1987-06-13 00:00:00	1987-06-13	5001	0	\N	0	0	\N	\N	0	125481	0	23426006	4052083		
5873	552	3006322	1958-11-20	1958-11-20 00:00:00	1958-11-20	5001	0	\N	0	0	\N	\N	0	36579	0	8331-1	3006322		
46139	4256	3006322	1997-09-22	1997-09-22 00:00:00	1997-09-22	5001	0	\N	0	0	\N	\N	0	282585	0	8331-1	3006322		
50954	4643	3006322	1958-01-24	1958-01-24 00:00:00	1958-01-24	5001	0	\N	0	0	\N	\N	0	309538	0	8331-1	3006322		
7301	232	4024958	1947-11-01	1947-11-01 00:00:00	1947-11-01	5001	0	\N	0	0	\N	\N	0	15539	0	117015009	4024958		
8457	800	3006322	1979-02-05	1979-02-05 00:00:00	1979-02-05	5001	0	\N	0	0	\N	\N	0	53119	0	8331-1	3006322		
28806	2661	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	176385	0	6082-2	3000876		
56670	5200	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	345811	0	6276-0	3027231		
38301	3528	3006451	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	234239	0	6273-7	3006451		
115332	3558	4133840	2015-05-02	2015-05-02 00:00:00	2015-05-02	5001	0	\N	0	0	\N	\N	0	236189	0	127783003	4133840		
49749	4525	3006322	2013-11-06	2013-11-06 00:00:00	2013-11-06	5001	0	\N	0	0	\N	\N	0	301263	0	8331-1	3006322		
42835	3957	40758406	1965-08-15	1965-08-15 00:00:00	1965-08-15	5001	0	\N	0	0	\N	\N	0	263096	0	55277-8	40758406		
70276	2152	4024958	1949-07-14	1949-07-14 00:00:00	1949-07-14	5001	0	\N	0	0	\N	\N	0	143449	0	117015009	4024958		
9745	917	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	61059	0	6248-9	3015076		
851	65	3049273	2018-07-31	2018-07-31 00:00:00	2018-07-31	5001	0	\N	0	0	\N	\N	0	4446	0	38265-5	3049273		
146159	4484	4024958	1960-09-26	1960-09-26 00:00:00	1960-09-26	5001	0	\N	0	0	\N	\N	0	298459	0	117015009	4024958		
12310	1174	40758406	1941-10-09	1941-10-09 00:00:00	1941-10-09	5001	0	\N	0	0	\N	\N	0	77389	0	55277-8	40758406		
23642	2175	3001247	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	145012	0	6085-5	3001247		
1715	152	21494966	1973-12-15	1973-12-15 00:00:00	1973-12-15	5001	0	\N	0	0	\N	\N	0	10291	0	80271-0	21494966		
7677	742	3011505	1960-03-28	1960-03-28 00:00:00	1960-03-28	5001	0	\N	0	0	\N	\N	0	49149	0	19926-5	3011505		
68087	2084	4024958	1971-05-29	1971-05-29 00:00:00	1971-05-29	5001	0	\N	0	0	\N	\N	0	138853	0	117015009	4024958		
71306	2184	4024958	2003-04-19	2003-04-19 00:00:00	2003-04-19	5001	0	\N	0	0	\N	\N	0	145595	0	117015009	4024958		
21825	686	4024958	1960-08-28	1960-08-28 00:00:00	1960-08-28	5001	0	\N	0	0	\N	\N	0	45395	0	117015009	4024958		
82328	2545	4024958	1952-08-20	1952-08-20 00:00:00	1952-08-20	5001	0	\N	0	0	\N	\N	0	168409	0	117015009	4024958		
22085	2027	3006322	1977-03-18	1977-03-18 00:00:00	1977-03-18	5001	0	\N	0	0	\N	\N	0	134936	0	8331-1	3006322		
107493	3315	4052083	1962-10-30	1962-10-30 00:00:00	1962-10-30	5001	0	\N	0	0	\N	\N	0	220167	0	23426006	4052083		
2926	279	3006322	1972-06-08	1972-06-08 00:00:00	1972-06-08	5001	0	\N	0	0	\N	\N	0	18638	0	8331-1	3006322		
24229	2235	3006322	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	148690	0	8331-1	3006322		
112985	3488	4133840	2019-05-03	2019-05-03 00:00:00	2019-05-03	5001	0	\N	0	0	\N	\N	0	231402	0	127783003	4133840		
3222	97	4133840	1983-07-25	1983-07-25 00:00:00	1983-07-25	5001	0	\N	0	0	\N	\N	0	6607	0	127783003	4133840		
19986	621	4024958	1929-04-14	1929-04-14 00:00:00	1929-04-14	5001	0	\N	0	0	\N	\N	0	41469	0	117015009	4024958		
38193	1185	4052083	2000-07-23	2000-07-23 00:00:00	2000-07-23	5001	0	\N	0	0	\N	\N	0	78106	0	23426006	4052083		
16462	1500	3006322	1966-07-25	1966-07-25 00:00:00	1966-07-25	5001	0	\N	0	0	\N	\N	0	100107	0	8331-1	3006322		
37304	3440	3006322	2013-12-02	2013-12-02 00:00:00	2013-12-02	5001	0	\N	0	0	\N	\N	0	228263	0	8331-1	3006322		
48721	4452	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	296333	0	6833-8	3023430		
22763	2088	3011505	1984-06-26	1984-06-26 00:00:00	1984-06-26	5001	0	\N	0	0	\N	\N	0	139285	0	19926-5	3011505		
148283	4544	4052083	1942-03-14	1942-03-14 00:00:00	1942-03-14	5001	0	\N	0	0	\N	\N	0	302708	0	23426006	4052083		
22659	2077	3049273	2001-06-11	2001-06-11 00:00:00	2001-06-11	5001	0	\N	0	0	\N	\N	0	138379	0	38265-5	3049273		
60384	1844	4052083	1994-10-31	1994-10-31 00:00:00	1994-10-31	5001	0	\N	0	0	\N	\N	0	123161	0	23426006	4052083		
59490	1814	4024958	2018-02-25	2018-02-25 00:00:00	2018-02-25	5001	0	\N	0	0	\N	\N	0	121445	0	117015009	4024958		
171212	5253	4133840	2017-05-13	2017-05-13 00:00:00	2017-05-13	5001	0	\N	0	0	\N	\N	0	349515	0	127783003	4133840		
49118	4487	3006322	2007-06-20	2007-06-20 00:00:00	2007-06-20	5001	0	\N	0	0	\N	\N	0	298696	0	8331-1	3006322		
44387	4100	46235214	1979-12-31	1979-12-31 00:00:00	1979-12-31	5001	0	\N	0	0	\N	\N	0	272455	0	76690-7	46235214		
25735	2357	3001247	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	156941	0	6085-5	3001247		
38746	3582	3011505	2008-06-08	2008-06-08 00:00:00	2008-06-08	5001	0	\N	0	0	\N	\N	0	238163	0	19926-5	3011505		
51456	4713	40766240	2013-10-22	2013-10-22 00:00:00	2013-10-22	5001	0	\N	0	0	\N	\N	0	313871	0	63513-6	40766240		
83735	2588	4052083	1966-06-22	1966-06-22 00:00:00	1966-06-22	5001	0	\N	0	0	\N	\N	0	171284	0	23426006	4052083		
31964	2915	3036780	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	194348	0	6095-4	3036780		
8772	843	3027231	1983-05-08	1983-05-08 00:00:00	1983-05-08	5001	0	\N	0	0	\N	\N	0	55804	0	6276-0	3027231		
35426	3242	3006322	1999-02-23	1999-02-23 00:00:00	1999-02-23	5001	0	\N	0	0	\N	\N	0	215633	0	8331-1	3006322		
170724	5236	4024958	1982-07-11	1982-07-11 00:00:00	1982-07-11	5001	0	\N	0	0	\N	\N	0	348416	0	117015009	4024958		
37817	3488	3011505	1993-03-26	1993-03-26 00:00:00	1993-03-26	5001	0	\N	0	0	\N	\N	0	231408	0	19926-5	3011505		
30093	2770	3036780	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	183291	0	6095-4	3036780		
59621	1819	4052083	1989-08-20	1989-08-20 00:00:00	1989-08-20	5001	0	\N	0	0	\N	\N	0	121645	0	23426006	4052083		
3092	299	3051031	1963-09-05	1963-09-05 00:00:00	1963-09-05	5001	0	\N	0	0	\N	\N	0	20014	0	46240-8	3051031		
21897	2013	3006322	2012-06-06	2012-06-06 00:00:00	2012-06-06	5001	0	\N	0	0	\N	\N	0	133929	0	8331-1	3006322		
23739	742	4133840	1989-04-03	1989-04-03 00:00:00	1989-04-03	5001	0	\N	0	0	\N	\N	0	49208	0	127783003	4133840		
31618	971	4024958	1960-11-04	1960-11-04 00:00:00	1960-11-04	5001	0	\N	0	0	\N	\N	0	64589	0	117015009	4024958		
33261	3004	3006322	1968-12-11	1968-12-11 00:00:00	1968-12-11	5001	0	\N	0	0	\N	\N	0	200497	0	8331-1	3006322		
13677	1285	3012494	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	84986	0	6206-7	3012494		
6198	578	46235214	2010-11-16	2010-11-16 00:00:00	2010-11-16	5001	0	\N	0	0	\N	\N	0	38255	0	76690-7	46235214		
120110	3703	4024958	2003-11-08	2003-11-08 00:00:00	2003-11-08	5001	0	\N	0	0	\N	\N	0	246296	0	117015009	4024958		
33974	3090	3006322	1999-04-07	1999-04-07 00:00:00	1999-04-07	5001	0	\N	0	0	\N	\N	0	205708	0	8331-1	3006322		
147640	4526	4024958	1997-07-29	1997-07-29 00:00:00	1997-07-29	5001	0	\N	0	0	\N	\N	0	301365	0	117015009	4024958		
61503	1882	4024958	1973-07-16	1973-07-16 00:00:00	1973-07-16	5001	0	\N	0	0	\N	\N	0	125479	0	117015009	4024958		
5874	552	3006322	1958-05-10	1958-05-10 00:00:00	1958-05-10	5001	0	\N	0	0	\N	\N	0	36565	0	8331-1	3006322		
46140	4256	3006322	2013-06-22	2013-06-22 00:00:00	2013-06-22	5001	0	\N	0	0	\N	\N	0	282617	0	8331-1	3006322		
50957	4643	3006322	1909-09-15	1909-09-15 00:00:00	1909-09-15	5001	0	\N	0	0	\N	\N	0	309605	0	8331-1	3006322		
17355	1577	21494966	1997-01-31	1997-01-31 00:00:00	1997-01-31	5001	0	\N	0	0	\N	\N	0	105932	0	80271-0	21494966		
8458	800	3006322	2008-08-25	2008-08-25 00:00:00	2008-08-25	5001	0	\N	0	0	\N	\N	0	53153	0	8331-1	3006322		
28807	2661	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	176385	0	6248-9	3015076		
56671	5200	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	345811	0	6248-9	3015076		
38302	3528	3012494	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	234239	0	6206-7	3012494		
115336	3558	4133840	2018-05-19	2018-05-19 00:00:00	2018-05-19	5001	0	\N	0	0	\N	\N	0	236214	0	127783003	4133840		
49750	4525	3006322	1990-02-27	1990-02-27 00:00:00	1990-02-27	5001	0	\N	0	0	\N	\N	0	301261	0	8331-1	3006322		
42837	3957	3051031	1965-08-15	1965-08-15 00:00:00	1965-08-15	5001	0	\N	0	0	\N	\N	0	263096	0	46240-8	3051031		
70277	2153	4024958	1974-10-06	1974-10-06 00:00:00	1974-10-06	5001	0	\N	0	0	\N	\N	0	143475	0	117015009	4024958		
9746	917	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	61059	0	6206-7	3012494		
852	65	3006322	2011-09-21	2011-09-21 00:00:00	2011-09-21	5001	0	\N	0	0	\N	\N	0	4405	0	8331-1	3006322		
146162	4484	4052083	1986-03-23	1986-03-23 00:00:00	1986-03-23	5001	0	\N	0	0	\N	\N	0	298461	0	23426006	4052083		
12311	1174	40766240	1941-10-09	1941-10-09 00:00:00	1941-10-09	5001	0	\N	0	0	\N	\N	0	77389	0	63513-6	40766240		
23643	2175	3000876	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	145012	0	6082-2	3000876		
1716	152	3035995	1973-12-15	1973-12-15 00:00:00	1973-12-15	5001	0	\N	0	0	\N	\N	0	10291	0	6768-6	3035995		
7678	742	3011505	2011-12-12	2011-12-12 00:00:00	2011-12-12	5001	0	\N	0	0	\N	\N	0	49185	0	19926-5	3011505		
68090	2084	4052083	2015-10-25	2015-10-25 00:00:00	2015-10-25	5001	0	\N	0	0	\N	\N	0	138841	0	23426006	4052083		
71310	2184	4052083	2012-05-19	2012-05-19 00:00:00	2012-05-19	5001	0	\N	0	0	\N	\N	0	145583	0	23426006	4052083		
21835	686	4052083	1958-11-04	1958-11-04 00:00:00	1958-11-04	5001	0	\N	0	0	\N	\N	0	45394	0	23426006	4052083		
93643	2882	4052083	1990-09-06	1990-09-06 00:00:00	1990-09-06	5001	0	\N	0	0	\N	\N	0	191711	0	23426006	4052083		
22086	2027	3006322	2013-05-08	2013-05-08 00:00:00	2013-05-08	5001	0	\N	0	0	\N	\N	0	134874	0	8331-1	3006322		
127434	3920	4052083	1975-04-14	1975-04-14 00:00:00	1975-04-14	5001	0	\N	0	0	\N	\N	0	260633	0	23426006	4052083		
2927	279	3006322	1993-06-13	1993-06-13 00:00:00	1993-06-13	5001	0	\N	0	0	\N	\N	0	18655	0	8331-1	3006322		
24230	2235	3006322	2000-10-19	2000-10-19 00:00:00	2000-10-19	5001	0	\N	0	0	\N	\N	0	148691	0	8331-1	3006322		
112987	3488	4133840	1994-01-21	1994-01-21 00:00:00	1994-01-21	5001	0	\N	0	0	\N	\N	0	231414	0	127783003	4133840		
14506	454	4052083	1999-02-06	1999-02-06 00:00:00	1999-02-06	5001	0	\N	0	0	\N	\N	0	30285	0	23426006	4052083		
19993	621	4024958	1919-05-05	1919-05-05 00:00:00	1919-05-05	5001	0	\N	0	0	\N	\N	0	41413	0	117015009	4024958		
38197	1185	4052083	1948-04-22	1948-04-22 00:00:00	1948-04-22	5001	0	\N	0	0	\N	\N	0	78157	0	23426006	4052083		
27746	2554	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	169268	0	6095-4	3036780		
37305	3440	3006322	2004-04-07	2004-04-07 00:00:00	2004-04-07	5001	0	\N	0	0	\N	\N	0	228325	0	8331-1	3006322		
48722	4452	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	296333	0	6844-5	3020655		
22764	2088	3011505	2006-07-11	2006-07-11 00:00:00	2006-07-11	5001	0	\N	0	0	\N	\N	0	139281	0	19926-5	3011505		
148303	4544	4052083	1953-04-21	1953-04-21 00:00:00	1953-04-21	5001	0	\N	0	0	\N	\N	0	302653	0	23426006	4052083		
22660	2077	3006322	1941-04-16	1941-04-16 00:00:00	1941-04-16	5001	0	\N	0	0	\N	\N	0	138237	0	8331-1	3006322		
60389	1844	4024958	1979-10-27	1979-10-27 00:00:00	1979-10-27	5001	0	\N	0	0	\N	\N	0	123155	0	117015009	4024958		
59495	1814	4052083	1940-12-17	1940-12-17 00:00:00	1940-12-17	5001	0	\N	0	0	\N	\N	0	121408	0	23426006	4052083		
171214	5253	4133840	1991-03-23	1991-03-23 00:00:00	1991-03-23	5001	0	\N	0	0	\N	\N	0	349506	0	127783003	4133840		
49119	4487	3006322	2005-01-20	2005-01-20 00:00:00	2005-01-20	5001	0	\N	0	0	\N	\N	0	298758	0	8331-1	3006322		
44388	4100	3051031	1980-04-29	1980-04-29 00:00:00	1980-04-29	5001	0	\N	0	0	\N	\N	0	272394	0	46240-8	3051031		
25736	2357	3006734	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	156941	0	6189-5	3006734		
38747	3582	3011505	1996-06-02	1996-06-02 00:00:00	1996-06-02	5001	0	\N	0	0	\N	\N	0	238104	0	19926-5	3011505		
51458	4713	46235214	2013-10-22	2013-10-22 00:00:00	2013-10-22	5001	0	\N	0	0	\N	\N	0	313871	0	76690-7	46235214		
83736	2588	4133840	2016-09-11	2016-09-11 00:00:00	2016-09-11	5001	0	\N	0	0	\N	\N	0	171296	0	127783003	4133840		
31965	2915	3006734	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	194348	0	6189-5	3006734		
8773	843	3014599	1983-05-08	1983-05-08 00:00:00	1983-05-08	5001	0	\N	0	0	\N	\N	0	55804	0	6106-9	3014599		
78767	2419	4052083	2000-01-30	2000-01-30 00:00:00	2000-01-30	5001	0	\N	0	0	\N	\N	0	160546	0	23426006	4052083		
117373	3618	4052083	1916-08-20	1916-08-20 00:00:00	1916-08-20	5001	0	\N	0	0	\N	\N	0	240344	0	23426006	4052083		
37818	3488	3011505	2011-03-18	2011-03-18 00:00:00	2011-03-18	5001	0	\N	0	0	\N	\N	0	231371	0	19926-5	3011505		
30094	2770	3000876	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	183291	0	6082-2	3000876		
59622	1819	4024958	2013-12-04	2013-12-04 00:00:00	2013-12-04	5001	0	\N	0	0	\N	\N	0	121647	0	117015009	4024958		
3093	299	40758406	1963-02-07	1963-02-07 00:00:00	1963-02-07	5001	0	\N	0	0	\N	\N	0	20005	0	55277-8	40758406		
21898	2013	46235214	1957-06-15	1957-06-15 00:00:00	1957-06-15	5001	0	\N	0	0	\N	\N	0	133948	0	76690-7	46235214		
23741	742	4133840	1974-08-19	1974-08-19 00:00:00	1974-08-19	5001	0	\N	0	0	\N	\N	0	49171	0	127783003	4133840		
31631	971	4024958	1947-04-01	1947-04-01 00:00:00	1947-04-01	5001	0	\N	0	0	\N	\N	0	64584	0	117015009	4024958		
33262	3004	3006322	1957-08-01	1957-08-01 00:00:00	1957-08-01	5001	0	\N	0	0	\N	\N	0	200463	0	8331-1	3006322		
13678	1285	3019406	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	84986	0	6158-0	3019406		
6199	579	3006322	1966-09-11	1966-09-11 00:00:00	1966-09-11	5001	0	\N	0	0	\N	\N	0	38365	0	8331-1	3006322		
16587	1510	3006322	2019-02-03	2019-02-03 00:00:00	2019-02-03	5001	0	\N	0	0	\N	\N	0	100811	0	8331-1	3006322		
33975	3090	3006322	2002-07-31	2002-07-31 00:00:00	2002-07-31	5001	0	\N	0	0	\N	\N	0	205756	0	8331-1	3006322		
1528	42	4052083	1992-04-09	1992-04-09 00:00:00	1992-04-09	5001	0	\N	0	0	\N	\N	0	3069	0	23426006	4052083		
61513	1882	4024958	1991-10-22	1991-10-22 00:00:00	1991-10-22	5001	0	\N	0	0	\N	\N	0	125599	0	117015009	4024958		
5875	552	3006322	1954-02-08	1954-02-08 00:00:00	1954-02-08	5001	0	\N	0	0	\N	\N	0	36564	0	8331-1	3006322		
46141	4256	3006322	2008-11-02	2008-11-02 00:00:00	2008-11-02	5001	0	\N	0	0	\N	\N	0	282616	0	8331-1	3006322		
50959	4643	3006322	1920-01-05	1920-01-05 00:00:00	1920-01-05	5001	0	\N	0	0	\N	\N	0	309601	0	8331-1	3006322		
17356	1577	3024731	1997-01-31	1997-01-31 00:00:00	1997-01-31	5001	0	\N	0	0	\N	\N	0	105932	0	30428-7	3024731		
8479	806	3006322	2010-11-09	2010-11-09 00:00:00	2010-11-09	5001	0	\N	0	0	\N	\N	0	53516	0	8331-1	3006322		
28808	2661	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	176385	0	6276-0	3027231		
56672	5200	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	345811	0	6085-5	3001247		
38303	3528	3021226	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	234239	0	6246-3	3021226		
115338	3558	4133840	2016-05-07	2016-05-07 00:00:00	2016-05-07	5001	0	\N	0	0	\N	\N	0	236238	0	127783003	4133840		
49751	4526	3006322	1997-07-29	1997-07-29 00:00:00	1997-07-29	5001	0	\N	0	0	\N	\N	0	301365	0	8331-1	3006322		
42838	3957	46235214	1965-08-15	1965-08-15 00:00:00	1965-08-15	5001	0	\N	0	0	\N	\N	0	263096	0	76690-7	46235214		
70291	2153	4024958	1981-05-14	1981-05-14 00:00:00	1981-05-14	5001	0	\N	0	0	\N	\N	0	143473	0	117015009	4024958		
9747	917	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	61059	0	6158-0	3019406		
853	65	3006322	1991-07-04	1991-07-04 00:00:00	1991-07-04	5001	0	\N	0	0	\N	\N	0	4403	0	8331-1	3006322		
146172	4484	4024958	1989-04-13	1989-04-13 00:00:00	1989-04-13	5001	0	\N	0	0	\N	\N	0	298475	0	117015009	4024958		
12312	1174	46235214	1941-10-09	1941-10-09 00:00:00	1941-10-09	5001	0	\N	0	0	\N	\N	0	77389	0	76690-7	46235214		
23644	2175	3005136	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	145012	0	6075-6	3005136		
1717	152	3004501	1973-12-15	1973-12-15 00:00:00	1973-12-15	5001	0	\N	0	0	\N	\N	0	10291	0	2345-7	3004501		
7679	742	3006322	1933-07-29	1933-07-29 00:00:00	1933-07-29	5001	0	\N	0	0	\N	\N	0	49106	0	8331-1	3006322		
68093	2084	4052083	2003-10-19	2003-10-19 00:00:00	2003-10-19	5001	0	\N	0	0	\N	\N	0	138863	0	23426006	4052083		
11990	384	4024958	1975-03-07	1975-03-07 00:00:00	1975-03-07	5001	0	\N	0	0	\N	\N	0	25337	0	117015009	4024958		
33134	1032	4024958	1955-05-30	1955-05-30 00:00:00	1955-05-30	5001	0	\N	0	0	\N	\N	0	67898	0	117015009	4024958		
93648	2882	4024958	1996-07-20	1996-07-20 00:00:00	1996-07-20	5001	0	\N	0	0	\N	\N	0	191699	0	117015009	4024958		
22087	2028	3049273	1997-11-16	1997-11-16 00:00:00	1997-11-16	5001	0	\N	0	0	\N	\N	0	134954	0	38265-5	3049273		
138728	4278	4133840	1996-01-19	1996-01-19 00:00:00	1996-01-19	5001	0	\N	0	0	\N	\N	0	283859	0	127783003	4133840		
2928	279	3006322	1992-03-07	1992-03-07 00:00:00	1992-03-07	5001	0	\N	0	0	\N	\N	0	18654	0	8331-1	3006322		
24232	2235	3006322	1963-12-05	1963-12-05 00:00:00	1963-12-05	5001	0	\N	0	0	\N	\N	0	148688	0	8331-1	3006322		
112992	3488	4133840	2012-03-23	2012-03-23 00:00:00	2012-03-23	5001	0	\N	0	0	\N	\N	0	231425	0	127783003	4133840		
14507	454	4052083	1992-12-17	1992-12-17 00:00:00	1992-12-17	5001	0	\N	0	0	\N	\N	0	30352	0	23426006	4052083		
20002	621	4024958	1918-09-22	1918-09-22 00:00:00	1918-09-22	5001	0	\N	0	0	\N	\N	0	41360	0	117015009	4024958		
38211	1185	4052083	2012-08-30	2012-08-30 00:00:00	2012-08-30	5001	0	\N	0	0	\N	\N	0	78107	0	23426006	4052083		
27747	2554	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	169268	0	6833-8	3023430		
37306	3440	3006322	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	228324	0	8331-1	3006322		
48723	4452	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	296333	0	6273-7	3006451		
22765	2088	3011505	2013-07-09	2013-07-09 00:00:00	2013-07-09	5001	0	\N	0	0	\N	\N	0	139196	0	19926-5	3011505		
148343	4546	4024958	2015-12-02	2015-12-02 00:00:00	2015-12-02	5001	0	\N	0	0	\N	\N	0	302818	0	117015009	4024958		
22661	2077	3006322	2006-07-10	2006-07-10 00:00:00	2006-07-10	5001	0	\N	0	0	\N	\N	0	138274	0	8331-1	3006322		
60399	1844	4024958	2009-04-21	2009-04-21 00:00:00	2009-04-21	5001	0	\N	0	0	\N	\N	0	123204	0	117015009	4024958		
162935	5001	4052083	1965-02-11	1965-02-11 00:00:00	1965-02-11	5001	0	\N	0	0	\N	\N	0	332616	0	23426006	4052083		
171215	5253	4133840	2015-01-31	2015-01-31 00:00:00	2015-01-31	5001	0	\N	0	0	\N	\N	0	349520	0	127783003	4133840		
49120	4487	3006322	2002-09-16	2002-09-16 00:00:00	2002-09-16	5001	0	\N	0	0	\N	\N	0	298694	0	8331-1	3006322		
44391	4100	40766240	1980-04-29	1980-04-29 00:00:00	1980-04-29	5001	0	\N	0	0	\N	\N	0	272394	0	63513-6	40766240		
25737	2357	3020655	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	156941	0	6844-5	3020655		
38748	3582	3011505	2002-06-16	2002-06-16 00:00:00	2002-06-16	5001	0	\N	0	0	\N	\N	0	238161	0	19926-5	3011505		
51459	4713	40758406	2013-10-22	2013-10-22 00:00:00	2013-10-22	5001	0	\N	0	0	\N	\N	0	313871	0	55277-8	40758406		
83737	2588	4133840	2015-09-06	2015-09-06 00:00:00	2015-09-06	5001	0	\N	0	0	\N	\N	0	171283	0	127783003	4133840		
31966	2915	3006322	1949-04-13	1949-04-13 00:00:00	1949-04-13	5001	0	\N	0	0	\N	\N	0	194350	0	8331-1	3006322		
8774	843	3001488	1983-05-08	1983-05-08 00:00:00	1983-05-08	5001	0	\N	0	0	\N	\N	0	55804	0	7258-7	3001488		
78783	2419	4024958	1952-05-13	1952-05-13 00:00:00	1952-05-13	5001	0	\N	0	0	\N	\N	0	160568	0	117015009	4024958		
117382	3618	4052083	1960-07-13	1960-07-13 00:00:00	1960-07-13	5001	0	\N	0	0	\N	\N	0	240451	0	23426006	4052083		
37819	3488	3011505	2015-04-10	2015-04-10 00:00:00	2015-04-10	5001	0	\N	0	0	\N	\N	0	231373	0	19926-5	3011505		
30095	2770	3005136	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	183291	0	6075-6	3005136		
59624	1819	4052083	1998-04-13	1998-04-13 00:00:00	1998-04-13	5001	0	\N	0	0	\N	\N	0	121674	0	23426006	4052083		
3094	299	40766240	1963-02-07	1963-02-07 00:00:00	1963-02-07	5001	0	\N	0	0	\N	\N	0	20005	0	63513-6	40766240		
21899	2013	40766240	1957-06-15	1957-06-15 00:00:00	1957-06-15	5001	0	\N	0	0	\N	\N	0	133948	0	63513-6	40766240		
23743	742	4133840	1981-09-28	1981-09-28 00:00:00	1981-09-28	5001	0	\N	0	0	\N	\N	0	49204	0	127783003	4133840		
53046	4872	3006322	1979-08-03	1979-08-03 00:00:00	1979-08-03	5001	0	\N	0	0	\N	\N	0	323992	0	8331-1	3006322		
33263	3004	3006322	1976-04-13	1976-04-13 00:00:00	1976-04-13	5001	0	\N	0	0	\N	\N	0	200499	0	8331-1	3006322		
13679	1285	3015076	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	84986	0	6248-9	3015076		
6200	579	3006322	1984-06-13	1984-06-13 00:00:00	1984-06-13	5001	0	\N	0	0	\N	\N	0	38367	0	8331-1	3006322		
16588	1510	3006322	1977-09-24	1977-09-24 00:00:00	1977-09-24	5001	0	\N	0	0	\N	\N	0	100780	0	8331-1	3006322		
33982	3092	3006322	2017-07-08	2017-07-08 00:00:00	2017-07-08	5001	0	\N	0	0	\N	\N	0	205843	0	8331-1	3006322		
1543	42	4052083	1938-11-10	1938-11-10 00:00:00	1938-11-10	5001	0	\N	0	0	\N	\N	0	2995	0	23426006	4052083		
61518	1882	4052083	1973-02-17	1973-02-17 00:00:00	1973-02-17	5001	0	\N	0	0	\N	\N	0	125587	0	23426006	4052083		
5876	552	3049273	2015-06-05	2015-06-05 00:00:00	2015-06-05	5001	0	\N	0	0	\N	\N	0	36614	0	38265-5	3049273		
46142	4256	3004501	1963-11-14	1963-11-14 00:00:00	1963-11-14	5001	0	\N	0	0	\N	\N	0	282589	0	2345-7	3004501		
50960	4643	3006322	1945-12-01	1945-12-01 00:00:00	1945-12-01	5001	0	\N	0	0	\N	\N	0	309537	0	8331-1	3006322		
17357	1577	3035995	1997-01-31	1997-01-31 00:00:00	1997-01-31	5001	0	\N	0	0	\N	\N	0	105932	0	6768-6	3035995		
8480	806	3049273	2010-01-03	2010-01-03 00:00:00	2010-01-03	5001	0	\N	0	0	\N	\N	0	53470	0	38265-5	3049273		
28809	2661	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	176385	0	6844-5	3020655		
56673	5200	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	345811	0	6189-5	3006734		
38304	3528	3006322	1991-10-16	1991-10-16 00:00:00	1991-10-16	5001	0	\N	0	0	\N	\N	0	234173	0	8331-1	3006322		
115343	3559	4024958	1959-11-21	1959-11-21 00:00:00	1959-11-21	5001	0	\N	0	0	\N	\N	0	236274	0	117015009	4024958		
49752	4526	3006322	1954-12-17	1954-12-17 00:00:00	1954-12-17	5001	0	\N	0	0	\N	\N	0	301328	0	8331-1	3006322		
58657	1783	4024958	2008-12-19	2008-12-19 00:00:00	2008-12-19	5001	0	\N	0	0	\N	\N	0	119508	0	117015009	4024958		
70292	2153	4024958	2009-12-18	2009-12-18 00:00:00	2009-12-18	5001	0	\N	0	0	\N	\N	0	143508	0	117015009	4024958		
9748	917	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	61059	0	6276-0	3027231		
854	65	3006322	1982-06-11	1982-06-11 00:00:00	1982-06-11	5001	0	\N	0	0	\N	\N	0	4395	0	8331-1	3006322		
146173	4484	4024958	2001-01-15	2001-01-15 00:00:00	2001-01-15	5001	0	\N	0	0	\N	\N	0	298494	0	117015009	4024958		
12313	1175	3006322	1965-04-01	1965-04-01 00:00:00	1965-04-01	5001	0	\N	0	0	\N	\N	0	77431	0	8331-1	3006322		
23645	2175	3021226	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	145012	0	6246-3	3021226		
1718	152	3016723	1973-12-15	1973-12-15 00:00:00	1973-12-15	5001	0	\N	0	0	\N	\N	0	10291	0	2160-0	3016723		
7680	742	3011505	1977-09-05	1977-09-05 00:00:00	1977-09-05	5001	0	\N	0	0	\N	\N	0	49119	0	19926-5	3011505		
169122	5193	4024958	1974-03-29	1974-03-29 00:00:00	1974-03-29	5001	0	\N	0	0	\N	\N	0	345209	0	117015009	4024958		
23287	728	4052083	1983-12-11	1983-12-11 00:00:00	1983-12-11	5001	0	\N	0	0	\N	\N	0	48355	0	23426006	4052083		
33135	1032	4052083	2010-08-28	2010-08-28 00:00:00	2010-08-28	5001	0	\N	0	0	\N	\N	0	67932	0	23426006	4052083		
46651	4297	3016723	1991-02-19	1991-02-19 00:00:00	1991-02-19	5001	0	\N	0	0	\N	\N	0	285178	0	2160-0	3016723		
22088	2028	3006322	1974-04-15	1974-04-15 00:00:00	1974-04-15	5001	0	\N	0	0	\N	\N	0	134992	0	8331-1	3006322		
138729	4278	4133840	2001-08-31	2001-08-31 00:00:00	2001-08-31	5001	0	\N	0	0	\N	\N	0	283847	0	127783003	4133840		
2929	280	3006322	1962-08-09	1962-08-09 00:00:00	1962-08-09	5001	0	\N	0	0	\N	\N	0	18674	0	8331-1	3006322		
24235	2237	3006322	1966-06-20	1966-06-20 00:00:00	1966-06-20	5001	0	\N	0	0	\N	\N	0	148812	0	8331-1	3006322		
112994	3488	4133840	1988-07-29	1988-07-29 00:00:00	1988-07-29	5001	0	\N	0	0	\N	\N	0	231407	0	127783003	4133840		
14524	454	4024958	1937-05-21	1937-05-21 00:00:00	1937-05-21	5001	0	\N	0	0	\N	\N	0	30288	0	117015009	4024958		
52849	4852	3051031	1996-11-23	1996-11-23 00:00:00	1996-11-23	5001	0	\N	0	0	\N	\N	0	322761	0	46240-8	3051031		
38213	1185	4052083	2011-06-06	2011-06-06 00:00:00	2011-06-06	5001	0	\N	0	0	\N	\N	0	78162	0	23426006	4052083		
27748	2554	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	169268	0	6189-5	3006734		
37307	3440	3006322	1999-04-24	1999-04-24 00:00:00	1999-04-24	5001	0	\N	0	0	\N	\N	0	228238	0	8331-1	3006322		
48724	4452	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	296333	0	6206-7	3012494		
22766	2088	3011505	1981-09-15	1981-09-15 00:00:00	1981-09-15	5001	0	\N	0	0	\N	\N	0	139312	0	19926-5	3011505		
148345	4546	4052083	2004-06-15	2004-06-15 00:00:00	2004-06-15	5001	0	\N	0	0	\N	\N	0	302817	0	23426006	4052083		
22663	2077	3014599	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	138304	0	6106-9	3014599		
60405	1844	4024958	1999-10-24	1999-10-24 00:00:00	1999-10-24	5001	0	\N	0	0	\N	\N	0	123178	0	117015009	4024958		
162948	5002	4024958	1989-05-19	1989-05-19 00:00:00	1989-05-19	5001	0	\N	0	0	\N	\N	0	332725	0	117015009	4024958		
171218	5253	4052083	1991-03-13	1991-03-13 00:00:00	1991-03-13	5001	0	\N	0	0	\N	\N	0	349523	0	23426006	4052083		
49122	4488	3006322	2009-08-24	2009-08-24 00:00:00	2009-08-24	5001	0	\N	0	0	\N	\N	0	298793	0	8331-1	3006322		
44392	4100	40758406	1980-04-29	1980-04-29 00:00:00	1980-04-29	5001	0	\N	0	0	\N	\N	0	272394	0	55277-8	40758406		
25738	2357	3000876	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	156941	0	6082-2	3000876		
38749	3582	3011505	2018-02-25	2018-02-25 00:00:00	2018-02-25	5001	0	\N	0	0	\N	\N	0	238135	0	19926-5	3011505		
51460	4713	3006322	1969-11-19	1969-11-19 00:00:00	1969-11-19	5001	0	\N	0	0	\N	\N	0	313826	0	8331-1	3006322		
83745	2589	4024958	1995-05-02	1995-05-02 00:00:00	1995-05-02	5001	0	\N	0	0	\N	\N	0	171346	0	117015009	4024958		
31967	2915	3006322	2006-08-26	2006-08-26 00:00:00	2006-08-26	5001	0	\N	0	0	\N	\N	0	194273	0	8331-1	3006322		
8775	843	3006322	1984-02-24	1984-02-24 00:00:00	1984-02-24	5001	0	\N	0	0	\N	\N	0	55805	0	8331-1	3006322		
117265	3614	4133840	2003-07-20	2003-07-20 00:00:00	2003-07-20	5001	0	\N	0	0	\N	\N	0	240077	0	127783003	4133840		
117383	3618	4024958	1961-11-04	1961-11-04 00:00:00	1961-11-04	5001	0	\N	0	0	\N	\N	0	240452	0	117015009	4024958		
37820	3488	3011505	1999-09-03	1999-09-03 00:00:00	1999-09-03	5001	0	\N	0	0	\N	\N	0	231424	0	19926-5	3011505		
30096	2770	3021226	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	183291	0	6246-3	3021226		
59631	1819	4024958	2010-09-10	2010-09-10 00:00:00	2010-09-10	5001	0	\N	0	0	\N	\N	0	121689	0	117015009	4024958		
3095	299	46235214	1963-02-07	1963-02-07 00:00:00	1963-02-07	5001	0	\N	0	0	\N	\N	0	20005	0	76690-7	46235214		
21901	2013	40758406	1957-06-15	1957-06-15 00:00:00	1957-06-15	5001	0	\N	0	0	\N	\N	0	133948	0	55277-8	40758406		
23746	742	4133840	1993-04-26	1993-04-26 00:00:00	1993-04-26	5001	0	\N	0	0	\N	\N	0	49210	0	127783003	4133840		
53047	4872	3006322	1915-09-30	1915-09-30 00:00:00	1915-09-30	5001	0	\N	0	0	\N	\N	0	323988	0	8331-1	3006322		
33266	3007	3006322	1970-05-07	1970-05-07 00:00:00	1970-05-07	5001	0	\N	0	0	\N	\N	0	200630	0	8331-1	3006322		
13680	1285	3006451	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	84986	0	6273-7	3006451		
6201	579	3006322	1961-07-22	1961-07-22 00:00:00	1961-07-22	5001	0	\N	0	0	\N	\N	0	38288	0	8331-1	3006322		
16589	1511	3006322	2002-07-08	2002-07-08 00:00:00	2002-07-08	5001	0	\N	0	0	\N	\N	0	100902	0	8331-1	3006322		
33983	3092	3006322	1963-10-17	1963-10-17 00:00:00	1963-10-17	5001	0	\N	0	0	\N	\N	0	205864	0	8331-1	3006322		
1545	42	4024958	1985-05-25	1985-05-25 00:00:00	1985-05-25	5001	0	\N	0	0	\N	\N	0	2998	0	117015009	4024958		
1361	36	4024958	2006-11-22	2006-11-22 00:00:00	2006-11-22	5001	0	\N	0	0	\N	\N	0	2562	0	117015009	4024958		
51857	4756	3006322	1946-12-24	1946-12-24 00:00:00	1946-12-24	5001	0	\N	0	0	\N	\N	0	316862	0	8331-1	3006322		
46143	4256	3010813	1963-11-14	1963-11-14 00:00:00	1963-11-14	5001	0	\N	0	0	\N	\N	0	282589	0	26464-8	3010813		
50961	4644	3006322	1980-11-01	1980-11-01 00:00:00	1980-11-01	5001	0	\N	0	0	\N	\N	0	309688	0	8331-1	3006322		
17358	1577	3019550	1997-01-31	1997-01-31 00:00:00	1997-01-31	5001	0	\N	0	0	\N	\N	0	105932	0	2951-2	3019550		
8481	806	3006322	1960-07-13	1960-07-13 00:00:00	1960-07-13	5001	0	\N	0	0	\N	\N	0	53501	0	8331-1	3006322		
28810	2661	3006322	1990-08-19	1990-08-19 00:00:00	1990-08-19	5001	0	\N	0	0	\N	\N	0	176326	0	8331-1	3006322		
56674	5200	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	345811	0	6095-4	3036780		
38305	3528	3006322	1963-10-12	1963-10-12 00:00:00	1963-10-12	5001	0	\N	0	0	\N	\N	0	234228	0	8331-1	3006322		
96930	2966	4052083	2016-11-23	2016-11-23 00:00:00	2016-11-23	5001	0	\N	0	0	\N	\N	0	198105	0	23426006	4052083		
49753	4526	3006322	1959-02-07	1959-02-07 00:00:00	1959-02-07	5001	0	\N	0	0	\N	\N	0	301329	0	8331-1	3006322		
58671	1783	4024958	1974-07-10	1974-07-10 00:00:00	1974-07-10	5001	0	\N	0	0	\N	\N	0	119418	0	117015009	4024958		
70301	2153	4052083	1996-08-18	1996-08-18 00:00:00	1996-08-18	5001	0	\N	0	0	\N	\N	0	143507	0	23426006	4052083		
9749	917	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	61059	0	7258-7	3001488		
855	66	3006322	1968-04-18	1968-04-18 00:00:00	1968-04-18	5001	0	\N	0	0	\N	\N	0	4474	0	8331-1	3006322		
146177	4484	4052083	1951-11-14	1951-11-14 00:00:00	1951-11-14	5001	0	\N	0	0	\N	\N	0	298458	0	23426006	4052083		
12314	1175	3006322	2001-01-15	2001-01-15 00:00:00	2001-01-15	5001	0	\N	0	0	\N	\N	0	77511	0	8331-1	3006322		
23646	2175	3019406	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	145012	0	6158-0	3019406		
1719	152	3026361	1973-12-15	1973-12-15 00:00:00	1973-12-15	5001	0	\N	0	0	\N	\N	0	10291	0	26453-1	3026361		
7683	742	46235214	1934-04-13	1934-04-13 00:00:00	1934-04-13	5001	0	\N	0	0	\N	\N	0	49172	0	76690-7	46235214		
6989	669	3006322	2008-04-22	2008-04-22 00:00:00	2008-04-22	5001	0	\N	0	0	\N	\N	0	44180	0	8331-1	3006322		
23317	729	4024958	1969-07-01	1969-07-01 00:00:00	1969-07-01	5001	0	\N	0	0	\N	\N	0	48397	0	117015009	4024958		
33158	1032	4024958	1982-12-16	1982-12-16 00:00:00	1982-12-16	5001	0	\N	0	0	\N	\N	0	67886	0	117015009	4024958		
46652	4297	3020630	1991-02-19	1991-02-19 00:00:00	1991-02-19	5001	0	\N	0	0	\N	\N	0	285178	0	2885-2	3020630		
22089	2028	3006322	1995-12-22	1995-12-22 00:00:00	1995-12-22	5001	0	\N	0	0	\N	\N	0	134973	0	8331-1	3006322		
138733	4278	4133840	2008-10-10	2008-10-10 00:00:00	2008-10-10	5001	0	\N	0	0	\N	\N	0	283852	0	127783003	4133840		
2930	280	3006322	1949-04-06	1949-04-06 00:00:00	1949-04-06	5001	0	\N	0	0	\N	\N	0	18718	0	8331-1	3006322		
24236	2237	3006322	1956-01-30	1956-01-30 00:00:00	1956-01-30	5001	0	\N	0	0	\N	\N	0	148787	0	8331-1	3006322		
112997	3488	4133840	2004-02-06	2004-02-06 00:00:00	2004-02-06	5001	0	\N	0	0	\N	\N	0	231409	0	127783003	4133840		
14539	454	4024958	1937-07-28	1937-07-28 00:00:00	1937-07-28	5001	0	\N	0	0	\N	\N	0	30319	0	117015009	4024958		
52850	4852	40758406	1996-11-23	1996-11-23 00:00:00	1996-11-23	5001	0	\N	0	0	\N	\N	0	322761	0	55277-8	40758406		
107163	3304	4024958	1985-10-13	1985-10-13 00:00:00	1985-10-13	5001	0	\N	0	0	\N	\N	0	219450	0	117015009	4024958		
27749	2554	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	169268	0	6273-7	3006451		
37308	3440	3006322	2017-07-28	2017-07-28 00:00:00	2017-07-28	5001	0	\N	0	0	\N	\N	0	228278	0	8331-1	3006322		
48725	4452	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	296333	0	6106-9	3014599		
22767	2088	3049273	1969-03-02	1969-03-02 00:00:00	1969-03-02	5001	0	\N	0	0	\N	\N	0	139180	0	38265-5	3049273		
148346	4546	4024958	2011-12-29	2011-12-29 00:00:00	2011-12-29	5001	0	\N	0	0	\N	\N	0	302828	0	117015009	4024958		
22664	2077	3019406	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	138304	0	6158-0	3019406		
49273	1500	4052083	2015-04-30	2015-04-30 00:00:00	2015-04-30	5001	0	\N	0	0	\N	\N	0	100072	0	23426006	4052083		
162950	5002	4024958	1977-04-06	1977-04-06 00:00:00	1977-04-06	5001	0	\N	0	0	\N	\N	0	332715	0	117015009	4024958		
171219	5253	4133840	2019-05-25	2019-05-25 00:00:00	2019-05-25	5001	0	\N	0	0	\N	\N	0	349516	0	127783003	4133840		
49123	4488	3006322	1996-05-03	1996-05-03 00:00:00	1996-05-03	5001	0	\N	0	0	\N	\N	0	298811	0	8331-1	3006322		
55670	5113	3006322	2013-05-02	2013-05-02 00:00:00	2013-05-02	5001	0	\N	0	0	\N	\N	0	339669	0	8331-1	3006322		
25739	2357	3006322	1953-01-16	1953-01-16 00:00:00	1953-01-16	5001	0	\N	0	0	\N	\N	0	157079	0	8331-1	3006322		
38750	3582	3011505	1998-06-07	1998-06-07 00:00:00	1998-06-07	5001	0	\N	0	0	\N	\N	0	238131	0	19926-5	3011505		
51461	4713	40758406	1973-08-03	1973-08-03 00:00:00	1973-08-03	5001	0	\N	0	0	\N	\N	0	313840	0	55277-8	40758406		
83751	2589	4024958	1990-04-15	1990-04-15 00:00:00	1990-04-15	5001	0	\N	0	0	\N	\N	0	171331	0	117015009	4024958		
31968	2915	3049273	2005-04-03	2005-04-03 00:00:00	2005-04-03	5001	0	\N	0	0	\N	\N	0	194378	0	38265-5	3049273		
8776	843	3027231	1998-11-07	1998-11-07 00:00:00	1998-11-07	5001	0	\N	0	0	\N	\N	0	55792	0	6276-0	3027231		
117268	3614	4133840	2010-11-21	2010-11-21 00:00:00	2010-11-21	5001	0	\N	0	0	\N	\N	0	240069	0	127783003	4133840		
117399	3618	4052083	1956-12-23	1956-12-23 00:00:00	1956-12-23	5001	0	\N	0	0	\N	\N	0	240450	0	23426006	4052083		
37821	3488	3011505	2019-05-03	2019-05-03 00:00:00	2019-05-03	5001	0	\N	0	0	\N	\N	0	231402	0	19926-5	3011505		
30097	2770	3019406	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	183291	0	6158-0	3019406		
59649	1820	4052083	2010-11-20	2010-11-20 00:00:00	2010-11-20	5001	0	\N	0	0	\N	\N	0	121747	0	23426006	4052083		
3098	299	3051031	1963-02-07	1963-02-07 00:00:00	1963-02-07	5001	0	\N	0	0	\N	\N	0	20005	0	46240-8	3051031		
21903	2013	3051031	1957-06-15	1957-06-15 00:00:00	1957-06-15	5001	0	\N	0	0	\N	\N	0	133948	0	46240-8	3051031		
23748	742	4024958	1926-01-12	1926-01-12 00:00:00	1926-01-12	5001	0	\N	0	0	\N	\N	0	49135	0	117015009	4024958		
53048	4872	3006322	1946-11-05	1946-11-05 00:00:00	1946-11-05	5001	0	\N	0	0	\N	\N	0	323977	0	8331-1	3006322		
33267	3007	3006322	1968-07-02	1968-07-02 00:00:00	1968-07-02	5001	0	\N	0	0	\N	\N	0	200637	0	8331-1	3006322		
13681	1285	3006734	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	84986	0	6189-5	3006734		
6202	579	3006322	1970-06-02	1970-06-02 00:00:00	1970-06-02	5001	0	\N	0	0	\N	\N	0	38356	0	8331-1	3006322		
16590	1511	3006322	1970-03-02	1970-03-02 00:00:00	1970-03-02	5001	0	\N	0	0	\N	\N	0	100900	0	8331-1	3006322		
33984	3092	3006322	1970-07-20	1970-07-20 00:00:00	1970-07-20	5001	0	\N	0	0	\N	\N	0	205865	0	8331-1	3006322		
1567	42	4052083	2006-03-04	2006-03-04 00:00:00	2006-03-04	5001	0	\N	0	0	\N	\N	0	3136	0	23426006	4052083		
1396	38	4024958	2005-06-06	2005-06-06 00:00:00	2005-06-06	5001	0	\N	0	0	\N	\N	0	2720	0	117015009	4024958		
51859	4756	3006322	1964-08-01	1964-08-01 00:00:00	1964-08-01	5001	0	\N	0	0	\N	\N	0	316864	0	8331-1	3006322		
46144	4256	3027970	1963-11-14	1963-11-14 00:00:00	1963-11-14	5001	0	\N	0	0	\N	\N	0	282589	0	10834-0	3027970		
48098	4412	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	293331	0	6082-2	3000876		
17359	1577	3006906	1997-01-31	1997-01-31 00:00:00	1997-01-31	5001	0	\N	0	0	\N	\N	0	105932	0	17861-6	3006906		
8482	806	3006322	1999-02-28	1999-02-28 00:00:00	1999-02-28	5001	0	\N	0	0	\N	\N	0	53503	0	8331-1	3006322		
28811	2661	3006322	2007-10-29	2007-10-29 00:00:00	2007-10-29	5001	0	\N	0	0	\N	\N	0	176355	0	8331-1	3006322		
18767	592	4024958	1975-11-29	1975-11-29 00:00:00	1975-11-29	5001	0	\N	0	0	\N	\N	0	39111	0	117015009	4024958		
38306	3528	3006322	2006-05-10	2006-05-10 00:00:00	2006-05-10	5001	0	\N	0	0	\N	\N	0	234150	0	8331-1	3006322		
162816	4998	4024958	2008-04-13	2008-04-13 00:00:00	2008-04-13	5001	0	\N	0	0	\N	\N	0	332407	0	117015009	4024958		
49754	4526	3006322	2006-06-26	2006-06-26 00:00:00	2006-06-26	5001	0	\N	0	0	\N	\N	0	301333	0	8331-1	3006322		
58701	1785	4024958	1958-06-18	1958-06-18 00:00:00	1958-06-18	5001	0	\N	0	0	\N	\N	0	119579	0	117015009	4024958		
70304	2153	4024958	2007-04-22	2007-04-22 00:00:00	2007-04-22	5001	0	\N	0	0	\N	\N	0	143474	0	117015009	4024958		
9750	917	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	61059	0	6246-3	3021226		
856	66	3006322	1967-09-10	1967-09-10 00:00:00	1967-09-10	5001	0	\N	0	0	\N	\N	0	4456	0	8331-1	3006322		
146185	4484	4024958	1986-03-14	1986-03-14 00:00:00	1986-03-14	5001	0	\N	0	0	\N	\N	0	298446	0	117015009	4024958		
12315	1175	3006322	2001-03-28	2001-03-28 00:00:00	2001-03-28	5001	0	\N	0	0	\N	\N	0	77540	0	8331-1	3006322		
23647	2175	3015076	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	145012	0	6248-9	3015076		
1720	152	3000963	1973-12-15	1973-12-15 00:00:00	1973-12-15	5001	0	\N	0	0	\N	\N	0	10291	0	718-7	3000963		
7684	742	40766240	1934-04-13	1934-04-13 00:00:00	1934-04-13	5001	0	\N	0	0	\N	\N	0	49172	0	63513-6	40766240		
6990	669	3011505	2018-11-21	2018-11-21 00:00:00	2018-11-21	5001	0	\N	0	0	\N	\N	0	44192	0	19926-5	3011505		
19069	1748	3006322	2008-08-27	2008-08-27 00:00:00	2008-08-27	5001	0	\N	0	0	\N	\N	0	116844	0	8331-1	3006322		
33166	1032	4052083	1980-10-13	1980-10-13 00:00:00	1980-10-13	5001	0	\N	0	0	\N	\N	0	67885	0	23426006	4052083		
46653	4297	3024731	1991-02-19	1991-02-19 00:00:00	1991-02-19	5001	0	\N	0	0	\N	\N	0	285178	0	30428-7	3024731		
22090	2028	3006322	1985-01-04	1985-01-04 00:00:00	1985-01-04	5001	0	\N	0	0	\N	\N	0	134979	0	8331-1	3006322		
138736	4278	4133840	2000-07-14	2000-07-14 00:00:00	2000-07-14	5001	0	\N	0	0	\N	\N	0	283887	0	127783003	4133840		
2931	280	3006322	1997-06-01	1997-06-01 00:00:00	1997-06-01	5001	0	\N	0	0	\N	\N	0	18714	0	8331-1	3006322		
24237	2237	3006322	1939-05-22	1939-05-22 00:00:00	1939-05-22	5001	0	\N	0	0	\N	\N	0	148745	0	8331-1	3006322		
112999	3488	4024958	1966-06-29	1966-06-29 00:00:00	1966-06-29	5001	0	\N	0	0	\N	\N	0	231381	0	117015009	4024958		
3413	102	4024958	2014-08-02	2014-08-02 00:00:00	2014-08-02	5001	0	\N	0	0	\N	\N	0	6970	0	117015009	4024958		
52852	4852	40766240	1996-11-23	1996-11-23 00:00:00	1996-11-23	5001	0	\N	0	0	\N	\N	0	322761	0	63513-6	40766240		
107165	3304	4052083	1984-10-17	1984-10-17 00:00:00	1984-10-17	5001	0	\N	0	0	\N	\N	0	219426	0	23426006	4052083		
27750	2554	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	169268	0	6106-9	3014599		
37309	3440	3006322	1985-06-30	1985-06-30 00:00:00	1985-06-30	5001	0	\N	0	0	\N	\N	0	228261	0	8331-1	3006322		
48726	4452	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	296333	0	6276-0	3027231		
22768	2088	3006322	2013-06-30	2013-06-30 00:00:00	2013-06-30	5001	0	\N	0	0	\N	\N	0	139295	0	8331-1	3006322		
148349	4546	4052083	1973-02-03	1973-02-03 00:00:00	1973-02-03	5001	0	\N	0	0	\N	\N	0	302810	0	23426006	4052083		
22665	2077	3005136	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	138304	0	6075-6	3005136		
49279	1500	4052083	1973-11-12	1973-11-12 00:00:00	1973-11-12	5001	0	\N	0	0	\N	\N	0	100109	0	23426006	4052083		
162952	5002	4052083	2009-09-15	2009-09-15 00:00:00	2009-09-15	5001	0	\N	0	0	\N	\N	0	332704	0	23426006	4052083		
171222	5253	4133840	1993-01-09	1993-01-09 00:00:00	1993-01-09	5001	0	\N	0	0	\N	\N	0	349536	0	127783003	4133840		
49124	4488	3006322	1976-03-06	1976-03-06 00:00:00	1976-03-06	5001	0	\N	0	0	\N	\N	0	298787	0	8331-1	3006322		
126460	3893	4024958	1979-10-07	1979-10-07 00:00:00	1979-10-07	5001	0	\N	0	0	\N	\N	0	258879	0	117015009	4024958		
25740	2358	3006322	1973-12-25	1973-12-25 00:00:00	1973-12-25	5001	0	\N	0	0	\N	\N	0	157163	0	8331-1	3006322		
38751	3582	3011505	2016-07-24	2016-07-24 00:00:00	2016-07-24	5001	0	\N	0	0	\N	\N	0	238107	0	19926-5	3011505		
51462	4713	3051031	1973-08-03	1973-08-03 00:00:00	1973-08-03	5001	0	\N	0	0	\N	\N	0	313840	0	46240-8	3051031		
83764	2590	4052083	1994-01-03	1994-01-03 00:00:00	1994-01-03	5001	0	\N	0	0	\N	\N	0	171418	0	23426006	4052083		
31969	2915	3006322	2016-06-12	2016-06-12 00:00:00	2016-06-12	5001	0	\N	0	0	\N	\N	0	194246	0	8331-1	3006322		
8777	843	3006451	1998-11-07	1998-11-07 00:00:00	1998-11-07	5001	0	\N	0	0	\N	\N	0	55792	0	6273-7	3006451		
117270	3614	4133840	2005-07-31	2005-07-31 00:00:00	2005-07-31	5001	0	\N	0	0	\N	\N	0	240102	0	127783003	4133840		
117705	3624	4052083	2001-03-22	2001-03-22 00:00:00	2001-03-22	5001	0	\N	0	0	\N	\N	0	240970	0	23426006	4052083		
37823	3488	3006322	1965-08-22	1965-08-22 00:00:00	1965-08-22	5001	0	\N	0	0	\N	\N	0	231341	0	8331-1	3006322		
30098	2770	3015076	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	183291	0	6248-9	3015076		
59656	1820	4024958	1986-08-08	1986-08-08 00:00:00	1986-08-08	5001	0	\N	0	0	\N	\N	0	121739	0	117015009	4024958		
3099	299	46235214	1963-10-05	1963-10-05 00:00:00	1963-10-05	5001	0	\N	0	0	\N	\N	0	20021	0	76690-7	46235214		
21904	2013	40758406	1967-03-10	1967-03-10 00:00:00	1967-03-10	5001	0	\N	0	0	\N	\N	0	134006	0	55277-8	40758406		
23751	742	4133840	1968-10-28	1968-10-28 00:00:00	1968-10-28	5001	0	\N	0	0	\N	\N	0	49150	0	127783003	4133840		
14392	450	4052083	1967-10-09	1967-10-09 00:00:00	1967-10-09	5001	0	\N	0	0	\N	\N	0	30005	0	23426006	4052083		
33268	3007	3006322	2000-04-19	2000-04-19 00:00:00	2000-04-19	5001	0	\N	0	0	\N	\N	0	200620	0	8331-1	3006322		
13682	1285	3005136	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	84986	0	6075-6	3005136		
6203	579	3006322	1973-09-23	1973-09-23 00:00:00	1973-09-23	5001	0	\N	0	0	\N	\N	0	38290	0	8331-1	3006322		
16591	1511	3006322	1972-04-01	1972-04-01 00:00:00	1972-04-01	5001	0	\N	0	0	\N	\N	0	100887	0	8331-1	3006322		
33985	3092	3006322	1976-06-04	1976-06-04 00:00:00	1976-06-04	5001	0	\N	0	0	\N	\N	0	205866	0	8331-1	3006322		
1574	42	4052083	1989-05-16	1989-05-16 00:00:00	1989-05-16	5001	0	\N	0	0	\N	\N	0	3057	0	23426006	4052083		
1398	38	4052083	1981-09-29	1981-09-29 00:00:00	1981-09-29	5001	0	\N	0	0	\N	\N	0	2725	0	23426006	4052083		
51860	4756	3006322	1944-07-09	1944-07-09 00:00:00	1944-07-09	5001	0	\N	0	0	\N	\N	0	316840	0	8331-1	3006322		
46145	4256	3009542	1963-11-14	1963-11-14 00:00:00	1963-11-14	5001	0	\N	0	0	\N	\N	0	282589	0	20570-8	3009542		
48099	4412	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	293331	0	6075-6	3005136		
17360	1577	3000963	1997-01-31	1997-01-31 00:00:00	1997-01-31	5001	0	\N	0	0	\N	\N	0	105932	0	718-7	3000963		
8483	807	3006322	1960-05-17	1960-05-17 00:00:00	1960-05-17	5001	0	\N	0	0	\N	\N	0	53566	0	8331-1	3006322		
28812	2663	3006322	1974-10-19	1974-10-19 00:00:00	1974-10-19	5001	0	\N	0	0	\N	\N	0	176452	0	8331-1	3006322		
18785	592	4052083	1975-08-01	1975-08-01 00:00:00	1975-08-01	5001	0	\N	0	0	\N	\N	0	39127	0	23426006	4052083		
49587	4513	3006322	1982-02-07	1982-02-07 00:00:00	1982-02-07	5001	0	\N	0	0	\N	\N	0	300545	0	8331-1	3006322		
162818	4998	4024958	1975-01-19	1975-01-19 00:00:00	1975-01-19	5001	0	\N	0	0	\N	\N	0	332404	0	117015009	4024958		
49755	4526	3006322	1979-09-05	1979-09-05 00:00:00	1979-09-05	5001	0	\N	0	0	\N	\N	0	301363	0	8331-1	3006322		
58703	1785	4024958	1962-04-09	1962-04-09 00:00:00	1962-04-09	5001	0	\N	0	0	\N	\N	0	119611	0	117015009	4024958		
7	1	3006322	2017-05-12	2017-05-12 00:00:00	2017-05-12	5001	0	\N	0	0	\N	\N	0	64	0	8331-1	3006322		
9751	917	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	61059	0	6085-5	3001247		
857	66	3006322	1971-07-14	1971-07-14 00:00:00	1971-07-14	5001	0	\N	0	0	\N	\N	0	4512	0	8331-1	3006322		
146188	4485	4052083	1994-07-20	1994-07-20 00:00:00	1994-07-20	5001	0	\N	0	0	\N	\N	0	298581	0	23426006	4052083		
12316	1175	3019406	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	77451	0	6158-0	3019406		
23648	2175	3006734	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	145012	0	6189-5	3006734		
1721	152	3024731	1973-12-15	1973-12-15 00:00:00	1973-12-15	5001	0	\N	0	0	\N	\N	0	10291	0	30428-7	3024731		
7685	742	40758406	1934-04-13	1934-04-13 00:00:00	1934-04-13	5001	0	\N	0	0	\N	\N	0	49172	0	55277-8	40758406		
6991	669	3006322	2014-10-28	2014-10-28 00:00:00	2014-10-28	5001	0	\N	0	0	\N	\N	0	44182	0	8331-1	3006322		
19070	1748	3006322	1998-04-01	1998-04-01 00:00:00	1998-04-01	5001	0	\N	0	0	\N	\N	0	116875	0	8331-1	3006322		
33167	1032	4052083	2017-03-07	2017-03-07 00:00:00	2017-03-07	5001	0	\N	0	0	\N	\N	0	67934	0	23426006	4052083		
46654	4297	3006906	1991-02-19	1991-02-19 00:00:00	1991-02-19	5001	0	\N	0	0	\N	\N	0	285178	0	17861-6	3006906		
12638	404	4052083	2001-11-07	2001-11-07 00:00:00	2001-11-07	5001	0	\N	0	0	\N	\N	0	26609	0	23426006	4052083		
138742	4278	4133840	2017-12-01	2017-12-01 00:00:00	2017-12-01	5001	0	\N	0	0	\N	\N	0	283943	0	127783003	4133840		
2932	280	3006322	1982-10-09	1982-10-09 00:00:00	1982-10-09	5001	0	\N	0	0	\N	\N	0	18764	0	8331-1	3006322		
24238	2237	3006322	1947-08-20	1947-08-20 00:00:00	1947-08-20	5001	0	\N	0	0	\N	\N	0	148786	0	8331-1	3006322		
113001	3488	4133840	2009-03-06	2009-03-06 00:00:00	2009-03-06	5001	0	\N	0	0	\N	\N	0	231377	0	127783003	4133840		
3428	103	4052083	1996-09-03	1996-09-03 00:00:00	1996-09-03	5001	0	\N	0	0	\N	\N	0	7034	0	23426006	4052083		
52854	4852	46235214	1996-11-23	1996-11-23 00:00:00	1996-11-23	5001	0	\N	0	0	\N	\N	0	322761	0	76690-7	46235214		
107176	3304	4052083	1990-08-03	1990-08-03 00:00:00	1990-08-03	5001	0	\N	0	0	\N	\N	0	219446	0	23426006	4052083		
27751	2554	3006322	1934-09-24	1934-09-24 00:00:00	1934-09-24	5001	0	\N	0	0	\N	\N	0	169133	0	8331-1	3006322		
37310	3440	3006322	1980-12-12	1980-12-12 00:00:00	1980-12-12	5001	0	\N	0	0	\N	\N	0	228260	0	8331-1	3006322		
48727	4452	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	296333	0	7258-7	3001488		
22769	2088	3011505	1988-07-19	1988-07-19 00:00:00	1988-07-19	5001	0	\N	0	0	\N	\N	0	139276	0	19926-5	3011505		
148352	4546	4024958	2009-12-27	2009-12-27 00:00:00	2009-12-27	5001	0	\N	0	0	\N	\N	0	302827	0	117015009	4024958		
22666	2077	3027231	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	138304	0	6276-0	3027231		
49314	1504	4024958	1988-04-11	1988-04-11 00:00:00	1988-04-11	5001	0	\N	0	0	\N	\N	0	100277	0	117015009	4024958		
134862	4153	4024958	1991-12-04	1991-12-04 00:00:00	1991-12-04	5001	0	\N	0	0	\N	\N	0	276064	0	117015009	4024958		
171223	5253	4024958	1956-03-13	1956-03-13 00:00:00	1956-03-13	5001	0	\N	0	0	\N	\N	0	349559	0	117015009	4024958		
49125	4488	3006322	2002-01-17	2002-01-17 00:00:00	2002-01-17	5001	0	\N	0	0	\N	\N	0	298792	0	8331-1	3006322		
126576	3895	4052083	2004-08-30	2004-08-30 00:00:00	2004-08-30	5001	0	\N	0	0	\N	\N	0	259105	0	23426006	4052083		
25741	2358	3006322	2006-08-31	2006-08-31 00:00:00	2006-08-31	5001	0	\N	0	0	\N	\N	0	157152	0	8331-1	3006322		
38752	3582	3011505	2017-02-19	2017-02-19 00:00:00	2017-02-19	5001	0	\N	0	0	\N	\N	0	238120	0	19926-5	3011505		
51464	4713	46235214	1973-08-03	1973-08-03 00:00:00	1973-08-03	5001	0	\N	0	0	\N	\N	0	313840	0	76690-7	46235214		
95051	2919	4024958	1983-10-06	1983-10-06 00:00:00	1983-10-06	5001	0	\N	0	0	\N	\N	0	194563	0	117015009	4024958		
31970	2915	3021226	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	194256	0	6246-3	3021226		
8778	843	3014599	1998-11-07	1998-11-07 00:00:00	1998-11-07	5001	0	\N	0	0	\N	\N	0	55792	0	6106-9	3014599		
117271	3614	4133840	2005-10-30	2005-10-30 00:00:00	2005-10-30	5001	0	\N	0	0	\N	\N	0	240132	0	127783003	4133840		
117717	3624	4024958	1963-11-21	1963-11-21 00:00:00	1963-11-21	5001	0	\N	0	0	\N	\N	0	240963	0	117015009	4024958		
37824	3488	3011505	1991-08-02	1991-08-02 00:00:00	1991-08-02	5001	0	\N	0	0	\N	\N	0	231343	0	19926-5	3011505		
30099	2770	3049273	2009-10-09	2009-10-09 00:00:00	2009-10-09	5001	0	\N	0	0	\N	\N	0	183307	0	38265-5	3049273		
59662	1820	4052083	1989-08-25	1989-08-25 00:00:00	1989-08-25	5001	0	\N	0	0	\N	\N	0	121712	0	23426006	4052083		
3100	299	40758406	1963-10-05	1963-10-05 00:00:00	1963-10-05	5001	0	\N	0	0	\N	\N	0	20021	0	55277-8	40758406		
21906	2013	3051031	1967-03-10	1967-03-10 00:00:00	1967-03-10	5001	0	\N	0	0	\N	\N	0	134006	0	46240-8	3051031		
23754	742	4133840	2004-06-28	2004-06-28 00:00:00	2004-06-28	5001	0	\N	0	0	\N	\N	0	49212	0	127783003	4133840		
14408	452	4052083	2017-02-21	2017-02-21 00:00:00	2017-02-21	5001	0	\N	0	0	\N	\N	0	30107	0	23426006	4052083		
33269	3007	3006322	1978-03-22	1978-03-22 00:00:00	1978-03-22	5001	0	\N	0	0	\N	\N	0	200631	0	8331-1	3006322		
13683	1285	3001488	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	84986	0	7258-7	3001488		
6204	579	40766240	1985-04-15	1985-04-15 00:00:00	1985-04-15	5001	0	\N	0	0	\N	\N	0	38357	0	63513-6	40766240		
16592	1511	3049273	2012-12-15	2012-12-15 00:00:00	2012-12-15	5001	0	\N	0	0	\N	\N	0	100937	0	38265-5	3049273		
33986	3093	3006322	1989-11-02	1989-11-02 00:00:00	1989-11-02	5001	0	\N	0	0	\N	\N	0	205954	0	8331-1	3006322		
1578	42	4052083	1999-11-17	1999-11-17 00:00:00	1999-11-17	5001	0	\N	0	0	\N	\N	0	3059	0	23426006	4052083		
1405	38	4052083	2016-01-01	2016-01-01 00:00:00	2016-01-01	5001	0	\N	0	0	\N	\N	0	2709	0	23426006	4052083		
51861	4756	3049273	2004-09-11	2004-09-11 00:00:00	2004-09-11	5001	0	\N	0	0	\N	\N	0	316875	0	38265-5	3049273		
46146	4256	3028833	1963-11-14	1963-11-14 00:00:00	1963-11-14	5001	0	\N	0	0	\N	\N	0	282589	0	42719-5	3028833		
48100	4412	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	293331	0	6106-9	3014599		
17361	1577	3026361	1997-01-31	1997-01-31 00:00:00	1997-01-31	5001	0	\N	0	0	\N	\N	0	105932	0	26453-1	3026361		
8484	807	3006322	2015-11-21	2015-11-21 00:00:00	2015-11-21	5001	0	\N	0	0	\N	\N	0	53568	0	8331-1	3006322		
28813	2663	3006322	1965-12-21	1965-12-21 00:00:00	1965-12-21	5001	0	\N	0	0	\N	\N	0	176476	0	8331-1	3006322		
30096	931	4052083	1975-06-09	1975-06-09 00:00:00	1975-06-09	5001	0	\N	0	0	\N	\N	0	61936	0	23426006	4052083		
49588	4513	3006322	2014-07-07	2014-07-07 00:00:00	2014-07-07	5001	0	\N	0	0	\N	\N	0	300566	0	8331-1	3006322		
162821	4998	4052083	1992-05-02	1992-05-02 00:00:00	1992-05-02	5001	0	\N	0	0	\N	\N	0	332382	0	23426006	4052083		
49756	4526	3006322	1991-10-16	1991-10-16 00:00:00	1991-10-16	5001	0	\N	0	0	\N	\N	0	301323	0	8331-1	3006322		
57373	1752	4024958	2000-05-01	2000-05-01 00:00:00	2000-05-01	5001	0	\N	0	0	\N	\N	0	117121	0	117015009	4024958		
8	2	3006322	1963-02-05	1963-02-05 00:00:00	1963-02-05	5001	0	\N	0	0	\N	\N	0	128	0	8331-1	3006322		
9752	917	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	61059	0	6189-5	3006734		
858	67	3006322	2017-07-12	2017-07-12 00:00:00	2017-07-12	5001	0	\N	0	0	\N	\N	0	4528	0	8331-1	3006322		
146189	4485	4024958	1958-10-04	1958-10-04 00:00:00	1958-10-04	5001	0	\N	0	0	\N	\N	0	298597	0	117015009	4024958		
12317	1175	3021226	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	77451	0	6246-3	3021226		
23649	2175	3023430	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	145012	0	6833-8	3023430		
1722	152	3028833	1973-12-15	1973-12-15 00:00:00	1973-12-15	5001	0	\N	0	0	\N	\N	0	10291	0	42719-5	3028833		
7686	742	3051031	1934-04-13	1934-04-13 00:00:00	1934-04-13	5001	0	\N	0	0	\N	\N	0	49172	0	46240-8	3051031		
6992	669	3006322	1972-03-22	1972-03-22 00:00:00	1972-03-22	5001	0	\N	0	0	\N	\N	0	44164	0	8331-1	3006322		
19071	1748	3006322	1959-02-12	1959-02-12 00:00:00	1959-02-12	5001	0	\N	0	0	\N	\N	0	116838	0	8331-1	3006322		
44781	1378	4133840	2002-03-05	2002-03-05 00:00:00	2002-03-05	5001	0	\N	0	0	\N	\N	0	91441	0	127783003	4133840		
46655	4297	3006322	1973-10-06	1973-10-06 00:00:00	1973-10-06	5001	0	\N	0	0	\N	\N	0	285166	0	8331-1	3006322		
12643	404	4024958	2002-01-06	2002-01-06 00:00:00	2002-01-06	5001	0	\N	0	0	\N	\N	0	26592	0	117015009	4024958		
138745	4278	4133840	1988-03-11	1988-03-11 00:00:00	1988-03-11	5001	0	\N	0	0	\N	\N	0	283896	0	127783003	4133840		
2933	280	3006322	1997-11-09	1997-11-09 00:00:00	1997-11-09	5001	0	\N	0	0	\N	\N	0	18690	0	8331-1	3006322		
6762	642	3006322	1999-05-19	1999-05-19 00:00:00	1999-05-19	5001	0	\N	0	0	\N	\N	0	42490	0	8331-1	3006322		
113003	3488	4024958	1993-03-19	1993-03-19 00:00:00	1993-03-19	5001	0	\N	0	0	\N	\N	0	231383	0	117015009	4024958		
3430	103	4024958	1974-02-22	1974-02-22 00:00:00	1974-02-22	5001	0	\N	0	0	\N	\N	0	7033	0	117015009	4024958		
52855	4852	40766240	1996-12-23	1996-12-23 00:00:00	1996-12-23	5001	0	\N	0	0	\N	\N	0	322788	0	63513-6	40766240		
107214	3307	4024958	1967-07-16	1967-07-16 00:00:00	1967-07-16	5001	0	\N	0	0	\N	\N	0	219550	0	117015009	4024958		
27752	2554	40769179	1964-07-31	1964-07-31 00:00:00	1964-07-31	5001	0	\N	0	0	\N	\N	0	169261	0	66519-0	40769179		
37311	3440	3006322	1950-03-02	1950-03-02 00:00:00	1950-03-02	5001	0	\N	0	0	\N	\N	0	228319	0	8331-1	3006322		
48728	4452	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	296333	0	6085-5	3001247		
22770	2088	3011505	1968-11-19	1968-11-19 00:00:00	1968-11-19	5001	0	\N	0	0	\N	\N	0	139318	0	19926-5	3011505		
148359	4546	4052083	1999-01-16	1999-01-16 00:00:00	1999-01-16	5001	0	\N	0	0	\N	\N	0	302794	0	23426006	4052083		
22667	2077	3012494	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	138304	0	6206-7	3012494		
49316	1504	4024958	1960-11-30	1960-11-30 00:00:00	1960-11-30	5001	0	\N	0	0	\N	\N	0	100268	0	117015009	4024958		
100647	3088	4052083	1947-12-30	1947-12-30 00:00:00	1947-12-30	5001	0	\N	0	0	\N	\N	0	205640	0	23426006	4052083		
171225	5253	4052083	1974-09-03	1974-09-03 00:00:00	1974-09-03	5001	0	\N	0	0	\N	\N	0	349489	0	23426006	4052083		
49126	4488	3006322	2011-11-23	2011-11-23 00:00:00	2011-11-23	5001	0	\N	0	0	\N	\N	0	298823	0	8331-1	3006322		
126579	3895	4052083	1974-04-02	1974-04-02 00:00:00	1974-04-02	5001	0	\N	0	0	\N	\N	0	259051	0	23426006	4052083		
25742	2358	3006322	1982-03-30	1982-03-30 00:00:00	1982-03-30	5001	0	\N	0	0	\N	\N	0	157141	0	8331-1	3006322		
38753	3582	3011505	2012-07-01	2012-07-01 00:00:00	2012-07-01	5001	0	\N	0	0	\N	\N	0	238119	0	19926-5	3011505		
51465	4713	40766240	1973-08-03	1973-08-03 00:00:00	1973-08-03	5001	0	\N	0	0	\N	\N	0	313840	0	63513-6	40766240		
95052	2919	4052083	1951-11-10	1951-11-10 00:00:00	1951-11-10	5001	0	\N	0	0	\N	\N	0	194584	0	23426006	4052083		
31971	2915	3005136	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	194256	0	6075-6	3005136		
8779	843	3005136	1998-11-07	1998-11-07 00:00:00	1998-11-07	5001	0	\N	0	0	\N	\N	0	55792	0	6075-6	3005136		
117272	3614	4133840	2007-11-11	2007-11-11 00:00:00	2007-11-11	5001	0	\N	0	0	\N	\N	0	240114	0	127783003	4133840		
117726	3624	4024958	1961-01-19	1961-01-19 00:00:00	1961-01-19	5001	0	\N	0	0	\N	\N	0	240992	0	117015009	4024958		
37825	3488	3011505	2012-03-23	2012-03-23 00:00:00	2012-03-23	5001	0	\N	0	0	\N	\N	0	231425	0	19926-5	3011505		
30100	2770	3006322	1938-11-18	1938-11-18 00:00:00	1938-11-18	5001	0	\N	0	0	\N	\N	0	183363	0	8331-1	3006322		
59664	1820	4052083	1984-01-09	1984-01-09 00:00:00	1984-01-09	5001	0	\N	0	0	\N	\N	0	121742	0	23426006	4052083		
3102	299	40766240	1963-10-05	1963-10-05 00:00:00	1963-10-05	5001	0	\N	0	0	\N	\N	0	20021	0	63513-6	40766240		
21908	2013	40766240	1967-03-10	1967-03-10 00:00:00	1967-03-10	5001	0	\N	0	0	\N	\N	0	134006	0	63513-6	40766240		
23757	742	4133840	2006-07-10	2006-07-10 00:00:00	2006-07-10	5001	0	\N	0	0	\N	\N	0	49213	0	127783003	4133840		
14410	452	4052083	2017-10-27	2017-10-27 00:00:00	2017-10-27	5001	0	\N	0	0	\N	\N	0	30127	0	23426006	4052083		
33270	3007	3006322	1977-02-09	1977-02-09 00:00:00	1977-02-09	5001	0	\N	0	0	\N	\N	0	200586	0	8331-1	3006322		
13684	1285	3014599	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	84986	0	6106-9	3014599		
6205	579	40758406	1985-04-15	1985-04-15 00:00:00	1985-04-15	5001	0	\N	0	0	\N	\N	0	38357	0	55277-8	40758406		
16593	1512	3006322	2003-10-08	2003-10-08 00:00:00	2003-10-08	5001	0	\N	0	0	\N	\N	0	100954	0	8331-1	3006322		
33987	3093	3006322	1973-03-19	1973-03-19 00:00:00	1973-03-19	5001	0	\N	0	0	\N	\N	0	205940	0	8331-1	3006322		
1587	43	4024958	1993-05-16	1993-05-16 00:00:00	1993-05-16	5001	0	\N	0	0	\N	\N	0	3146	0	117015009	4024958		
1408	38	4052083	1966-08-05	1966-08-05 00:00:00	1966-08-05	5001	0	\N	0	0	\N	\N	0	2745	0	23426006	4052083		
51862	4757	3006322	1971-07-09	1971-07-09 00:00:00	1971-07-09	5001	0	\N	0	0	\N	\N	0	316910	0	8331-1	3006322		
46147	4256	21494966	1963-11-14	1963-11-14 00:00:00	1963-11-14	5001	0	\N	0	0	\N	\N	0	282589	0	80271-0	21494966		
48101	4412	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	293331	0	6273-7	3006451		
17362	1577	3009542	1997-01-31	1997-01-31 00:00:00	1997-01-31	5001	0	\N	0	0	\N	\N	0	105932	0	20570-8	3009542		
8485	807	40758406	1952-02-15	1952-02-15 00:00:00	1952-02-15	5001	0	\N	0	0	\N	\N	0	53564	0	55277-8	40758406		
28814	2663	3006322	2004-08-26	2004-08-26 00:00:00	2004-08-26	5001	0	\N	0	0	\N	\N	0	176453	0	8331-1	3006322		
30102	931	4024958	1966-08-08	1966-08-08 00:00:00	1966-08-08	5001	0	\N	0	0	\N	\N	0	61927	0	117015009	4024958		
49589	4513	3006322	1993-11-01	1993-11-01 00:00:00	1993-11-01	5001	0	\N	0	0	\N	\N	0	300584	0	8331-1	3006322		
162826	4998	4052083	1967-02-27	1967-02-27 00:00:00	1967-02-27	5001	0	\N	0	0	\N	\N	0	332326	0	23426006	4052083		
49757	4526	3006322	1954-08-07	1954-08-07 00:00:00	1954-08-07	5001	0	\N	0	0	\N	\N	0	301326	0	8331-1	3006322		
57374	1752	4024958	2009-08-08	2009-08-08 00:00:00	2009-08-08	5001	0	\N	0	0	\N	\N	0	117122	0	117015009	4024958		
9	2	3006322	1999-12-01	1999-12-01 00:00:00	1999-12-01	5001	0	\N	0	0	\N	\N	0	108	0	8331-1	3006322		
9753	917	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	61059	0	6106-9	3014599		
859	67	3006322	1972-11-10	1972-11-10 00:00:00	1972-11-10	5001	0	\N	0	0	\N	\N	0	4535	0	8331-1	3006322		
8796	279	4052083	1967-03-18	1967-03-18 00:00:00	1967-03-18	5001	0	\N	0	0	\N	\N	0	18616	0	23426006	4052083		
12318	1175	3005136	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	77451	0	6075-6	3005136		
23650	2175	3020655	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	145012	0	6844-5	3020655		
1723	152	3009542	1973-12-15	1973-12-15 00:00:00	1973-12-15	5001	0	\N	0	0	\N	\N	0	10291	0	20570-8	3009542		
7687	742	3011505	1961-10-16	1961-10-16 00:00:00	1961-10-16	5001	0	\N	0	0	\N	\N	0	49159	0	19926-5	3011505		
6993	669	3006322	1977-12-03	1977-12-03 00:00:00	1977-12-03	5001	0	\N	0	0	\N	\N	0	44142	0	8331-1	3006322		
19072	1748	3006322	2007-01-24	2007-01-24 00:00:00	2007-01-24	5001	0	\N	0	0	\N	\N	0	116876	0	8331-1	3006322		
44786	1378	4133840	2008-09-30	2008-09-30 00:00:00	2008-09-30	5001	0	\N	0	0	\N	\N	0	91344	0	127783003	4133840		
46656	4297	3004501	1991-02-19	1991-02-19 00:00:00	1991-02-19	5001	0	\N	0	0	\N	\N	0	285178	0	2345-7	3004501		
12649	404	4052083	2007-01-21	2007-01-21 00:00:00	2007-01-21	5001	0	\N	0	0	\N	\N	0	26593	0	23426006	4052083		
138746	4278	4133840	2002-09-06	2002-09-06 00:00:00	2002-09-06	5001	0	\N	0	0	\N	\N	0	283864	0	127783003	4133840		
2934	280	3049273	2010-10-11	2010-10-11 00:00:00	2010-10-11	5001	0	\N	0	0	\N	\N	0	18708	0	38265-5	3049273		
6763	642	3006322	1944-10-11	1944-10-11 00:00:00	1944-10-11	5001	0	\N	0	0	\N	\N	0	42522	0	8331-1	3006322		
113004	3488	4133840	2010-03-12	2010-03-12 00:00:00	2010-03-12	5001	0	\N	0	0	\N	\N	0	231412	0	127783003	4133840		
3447	103	4052083	1974-07-22	1974-07-22 00:00:00	1974-07-22	5001	0	\N	0	0	\N	\N	0	7043	0	23426006	4052083		
52857	4852	40758406	1996-12-23	1996-12-23 00:00:00	1996-12-23	5001	0	\N	0	0	\N	\N	0	322788	0	55277-8	40758406		
118503	3647	4052083	1954-05-21	1954-05-21 00:00:00	1954-05-21	5001	0	\N	0	0	\N	\N	0	242717	0	23426006	4052083		
27753	2554	40769184	1964-07-31	1964-07-31 00:00:00	1964-07-31	5001	0	\N	0	0	\N	\N	0	169261	0	66524-0	40769184		
37315	3442	3006322	1985-06-26	1985-06-26 00:00:00	1985-06-26	5001	0	\N	0	0	\N	\N	0	228429	0	8331-1	3006322		
48729	4452	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	296333	0	6189-5	3006734		
22771	2088	3011505	1974-08-06	1974-08-06 00:00:00	1974-08-06	5001	0	\N	0	0	\N	\N	0	139320	0	19926-5	3011505		
37807	1174	4024958	1978-10-31	1978-10-31 00:00:00	1978-10-31	5001	0	\N	0	0	\N	\N	0	77343	0	117015009	4024958		
22668	2077	3000876	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	138304	0	6082-2	3000876		
164086	5041	4024958	1993-05-11	1993-05-11 00:00:00	1993-05-11	5001	0	\N	0	0	\N	\N	0	334940	0	117015009	4024958		
100651	3088	4024958	1960-09-08	1960-09-08 00:00:00	1960-09-08	5001	0	\N	0	0	\N	\N	0	205609	0	117015009	4024958		
171226	5253	4133840	2011-01-08	2011-01-08 00:00:00	2011-01-08	5001	0	\N	0	0	\N	\N	0	349514	0	127783003	4133840		
49127	4488	3006322	1978-10-08	1978-10-08 00:00:00	1978-10-08	5001	0	\N	0	0	\N	\N	0	298820	0	8331-1	3006322		
126596	3895	4024958	1946-06-02	1946-06-02 00:00:00	1946-06-02	5001	0	\N	0	0	\N	\N	0	259047	0	117015009	4024958		
25743	2359	3049273	1998-03-23	1998-03-23 00:00:00	1998-03-23	5001	0	\N	0	0	\N	\N	0	157239	0	38265-5	3049273		
38754	3582	3011505	2011-06-26	2011-06-26 00:00:00	2011-06-26	5001	0	\N	0	0	\N	\N	0	238134	0	19926-5	3011505		
51467	4713	3006322	1973-08-14	1973-08-14 00:00:00	1973-08-14	5001	0	\N	0	0	\N	\N	0	313835	0	8331-1	3006322		
95053	2919	4133840	2013-11-23	2013-11-23 00:00:00	2013-11-23	5001	0	\N	0	0	\N	\N	0	194634	0	127783003	4133840		
31972	2915	3015076	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	194256	0	6248-9	3015076		
8780	843	3001488	1998-11-07	1998-11-07 00:00:00	1998-11-07	5001	0	\N	0	0	\N	\N	0	55792	0	7258-7	3001488		
117274	3614	4133840	2004-07-25	2004-07-25 00:00:00	2004-07-25	5001	0	\N	0	0	\N	\N	0	240067	0	127783003	4133840		
117738	3625	4052083	1964-10-15	1964-10-15 00:00:00	1964-10-15	5001	0	\N	0	0	\N	\N	0	241075	0	23426006	4052083		
37826	3488	3011505	2006-02-17	2006-02-17 00:00:00	2006-02-17	5001	0	\N	0	0	\N	\N	0	231410	0	19926-5	3011505		
30101	2770	3006322	1981-04-26	1981-04-26 00:00:00	1981-04-26	5001	0	\N	0	0	\N	\N	0	183367	0	8331-1	3006322		
59665	1820	4052083	2006-12-02	2006-12-02 00:00:00	2006-12-02	5001	0	\N	0	0	\N	\N	0	121746	0	23426006	4052083		
3104	299	3051031	1963-10-05	1963-10-05 00:00:00	1963-10-05	5001	0	\N	0	0	\N	\N	0	20021	0	46240-8	3051031		
21909	2013	46235214	1967-03-10	1967-03-10 00:00:00	1967-03-10	5001	0	\N	0	0	\N	\N	0	134006	0	76690-7	46235214		
23758	742	4133840	1978-09-11	1978-09-11 00:00:00	1978-09-11	5001	0	\N	0	0	\N	\N	0	49109	0	127783003	4133840		
14411	452	4052083	1976-03-28	1976-03-28 00:00:00	1976-03-28	5001	0	\N	0	0	\N	\N	0	30136	0	23426006	4052083		
33271	3007	3006322	2016-12-03	2016-12-03 00:00:00	2016-12-03	5001	0	\N	0	0	\N	\N	0	200639	0	8331-1	3006322		
13685	1285	3027231	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	84986	0	6276-0	3027231		
6207	579	3051031	1985-04-15	1985-04-15 00:00:00	1985-04-15	5001	0	\N	0	0	\N	\N	0	38357	0	46240-8	3051031		
16594	1512	3006322	2002-11-30	2002-11-30 00:00:00	2002-11-30	5001	0	\N	0	0	\N	\N	0	100962	0	8331-1	3006322		
33988	3093	3006322	1979-02-01	1979-02-01 00:00:00	1979-02-01	5001	0	\N	0	0	\N	\N	0	205913	0	8331-1	3006322		
1590	43	4024958	1967-07-18	1967-07-18 00:00:00	1967-07-18	5001	0	\N	0	0	\N	\N	0	3143	0	117015009	4024958		
1410	38	4024958	1967-10-01	1967-10-01 00:00:00	1967-10-01	5001	0	\N	0	0	\N	\N	0	2722	0	117015009	4024958		
51863	4757	3006322	1983-12-28	1983-12-28 00:00:00	1983-12-28	5001	0	\N	0	0	\N	\N	0	316890	0	8331-1	3006322		
46148	4256	3006906	1963-11-14	1963-11-14 00:00:00	1963-11-14	5001	0	\N	0	0	\N	\N	0	282589	0	17861-6	3006906		
48102	4412	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	293331	0	6158-0	3019406		
17363	1577	3013721	1997-01-31	1997-01-31 00:00:00	1997-01-31	5001	0	\N	0	0	\N	\N	0	105932	0	1920-8	3013721		
8486	807	3051031	1952-02-15	1952-02-15 00:00:00	1952-02-15	5001	0	\N	0	0	\N	\N	0	53564	0	46240-8	3051031		
28815	2663	3006322	2011-11-14	2011-11-14 00:00:00	2011-11-14	5001	0	\N	0	0	\N	\N	0	176487	0	8331-1	3006322		
40169	3742	3006322	1995-04-02	1995-04-02 00:00:00	1995-04-02	5001	0	\N	0	0	\N	\N	0	248671	0	8331-1	3006322		
49590	4513	3006322	1986-01-30	1986-01-30 00:00:00	1986-01-30	5001	0	\N	0	0	\N	\N	0	300582	0	8331-1	3006322		
2589	80	4052083	1975-10-16	1975-10-16 00:00:00	1975-10-16	5001	0	\N	0	0	\N	\N	0	5440	0	23426006	4052083		
49758	4527	3006322	1986-03-28	1986-03-28 00:00:00	1986-03-28	5001	0	\N	0	0	\N	\N	0	301426	0	8331-1	3006322		
57419	1753	4024958	1973-03-09	1973-03-09 00:00:00	1973-03-09	5001	0	\N	0	0	\N	\N	0	117272	0	117015009	4024958		
10	2	3011505	1989-09-26	1989-09-26 00:00:00	1989-09-26	5001	0	\N	0	0	\N	\N	0	132	0	19926-5	3011505		
9754	917	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	61059	0	6095-4	3036780		
860	67	3006322	2010-01-07	2010-01-07 00:00:00	2010-01-07	5001	0	\N	0	0	\N	\N	0	4568	0	8331-1	3006322		
8802	279	4052083	2014-10-24	2014-10-24 00:00:00	2014-10-24	5001	0	\N	0	0	\N	\N	0	18644	0	23426006	4052083		
12319	1175	3027231	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	77451	0	6276-0	3027231		
23651	2175	3006322	1979-12-12	1979-12-12 00:00:00	1979-12-12	5001	0	\N	0	0	\N	\N	0	144999	0	8331-1	3006322		
1724	152	3024561	1973-12-15	1973-12-15 00:00:00	1973-12-15	5001	0	\N	0	0	\N	\N	0	10291	0	1751-7	3024561		
7688	742	3011505	1961-10-09	1961-10-09 00:00:00	1961-10-09	5001	0	\N	0	0	\N	\N	0	49216	0	19926-5	3011505		
6994	669	3006322	2004-10-27	2004-10-27 00:00:00	2004-10-27	5001	0	\N	0	0	\N	\N	0	44169	0	8331-1	3006322		
19073	1748	3006322	1949-05-23	1949-05-23 00:00:00	1949-05-23	5001	0	\N	0	0	\N	\N	0	116915	0	8331-1	3006322		
79300	2437	4024958	1971-06-06	1971-06-06 00:00:00	1971-06-06	5001	0	\N	0	0	\N	\N	0	161693	0	117015009	4024958		
46657	4297	3010813	1991-02-19	1991-02-19 00:00:00	1991-02-19	5001	0	\N	0	0	\N	\N	0	285178	0	26464-8	3010813		
1357	117	3006322	2017-11-23	2017-11-23 00:00:00	2017-11-23	5001	0	\N	0	0	\N	\N	0	7761	0	8331-1	3006322		
138749	4278	4133840	2012-11-02	2012-11-02 00:00:00	2012-11-02	5001	0	\N	0	0	\N	\N	0	283849	0	127783003	4133840		
2939	283	3006322	1985-01-23	1985-01-23 00:00:00	1985-01-23	5001	0	\N	0	0	\N	\N	0	18835	0	8331-1	3006322		
6767	642	3006322	2013-01-20	2013-01-20 00:00:00	2013-01-20	5001	0	\N	0	0	\N	\N	0	42525	0	8331-1	3006322		
113008	3488	4133840	2006-02-17	2006-02-17 00:00:00	2006-02-17	5001	0	\N	0	0	\N	\N	0	231410	0	127783003	4133840		
3449	103	4024958	2009-08-26	2009-08-26 00:00:00	2009-08-26	5001	0	\N	0	0	\N	\N	0	7035	0	117015009	4024958		
52858	4852	3051031	1996-12-23	1996-12-23 00:00:00	1996-12-23	5001	0	\N	0	0	\N	\N	0	322788	0	46240-8	3051031		
160522	4932	4052083	2010-10-22	2010-10-22 00:00:00	2010-10-22	5001	0	\N	0	0	\N	\N	0	327924	0	23426006	4052083		
27754	2554	40769194	1964-07-31	1964-07-31 00:00:00	1964-07-31	5001	0	\N	0	0	\N	\N	0	169261	0	66534-9	40769194		
37316	3442	3006322	1967-07-07	1967-07-07 00:00:00	1967-07-07	5001	0	\N	0	0	\N	\N	0	228428	0	8331-1	3006322		
48730	4452	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	296333	0	6095-4	3036780		
22772	2088	3006322	2009-05-11	2009-05-11 00:00:00	2009-05-11	5001	0	\N	0	0	\N	\N	0	139186	0	8331-1	3006322		
37810	1174	4024958	1981-10-31	1981-10-31 00:00:00	1981-10-31	5001	0	\N	0	0	\N	\N	0	77344	0	117015009	4024958		
22669	2077	3001488	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	138304	0	7258-7	3001488		
1970	180	3012494	1980-05-17	1980-05-17 00:00:00	1980-05-17	5001	0	\N	0	0	\N	\N	0	12198	0	6206-7	3012494		
100678	3090	4052083	1989-10-28	1989-10-28 00:00:00	1989-10-28	5001	0	\N	0	0	\N	\N	0	205755	0	23426006	4052083		
171227	5253	4133840	2016-05-07	2016-05-07 00:00:00	2016-05-07	5001	0	\N	0	0	\N	\N	0	349528	0	127783003	4133840		
49128	4488	3006322	1989-11-25	1989-11-25 00:00:00	1989-11-25	5001	0	\N	0	0	\N	\N	0	298822	0	8331-1	3006322		
126616	3895	4024958	1943-02-24	1943-02-24 00:00:00	1943-02-24	5001	0	\N	0	0	\N	\N	0	259056	0	117015009	4024958		
25744	2359	3006322	1957-02-07	1957-02-07 00:00:00	1957-02-07	5001	0	\N	0	0	\N	\N	0	157276	0	8331-1	3006322		
38755	3582	3006322	1997-01-08	1997-01-08 00:00:00	1997-01-08	5001	0	\N	0	0	\N	\N	0	238137	0	8331-1	3006322		
51468	4713	3051031	1967-02-06	1967-02-06 00:00:00	1967-02-06	5001	0	\N	0	0	\N	\N	0	313834	0	46240-8	3051031		
95058	2919	4133840	2010-11-06	2010-11-06 00:00:00	2010-11-06	5001	0	\N	0	0	\N	\N	0	194635	0	127783003	4133840		
31973	2915	3019406	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	194256	0	6158-0	3019406		
8781	843	3021226	1998-11-07	1998-11-07 00:00:00	1998-11-07	5001	0	\N	0	0	\N	\N	0	55792	0	6246-3	3021226		
117284	3615	4024958	1951-11-22	1951-11-22 00:00:00	1951-11-22	5001	0	\N	0	0	\N	\N	0	240177	0	117015009	4024958		
117744	3625	4024958	1960-10-08	1960-10-08 00:00:00	1960-10-08	5001	0	\N	0	0	\N	\N	0	241116	0	117015009	4024958		
37827	3488	3006322	1966-06-29	1966-06-29 00:00:00	1966-06-29	5001	0	\N	0	0	\N	\N	0	231381	0	8331-1	3006322		
30102	2770	3006322	1933-11-22	1933-11-22 00:00:00	1933-11-22	5001	0	\N	0	0	\N	\N	0	183331	0	8331-1	3006322		
145247	4456	4052083	1967-02-09	1967-02-09 00:00:00	1967-02-09	5001	0	\N	0	0	\N	\N	0	296550	0	23426006	4052083		
3105	299	40766240	1963-01-08	1963-01-08 00:00:00	1963-01-08	5001	0	\N	0	0	\N	\N	0	20019	0	63513-6	40766240		
12333	399	4024958	1967-12-05	1967-12-05 00:00:00	1967-12-05	5001	0	\N	0	0	\N	\N	0	26172	0	117015009	4024958		
23760	742	4133840	1975-08-25	1975-08-25 00:00:00	1975-08-25	5001	0	\N	0	0	\N	\N	0	49118	0	127783003	4133840		
14431	452	4024958	2003-08-28	2003-08-28 00:00:00	2003-08-28	5001	0	\N	0	0	\N	\N	0	30105	0	117015009	4024958		
33272	3007	3006322	1967-11-20	1967-11-20 00:00:00	1967-11-20	5001	0	\N	0	0	\N	\N	0	200629	0	8331-1	3006322		
13686	1285	3020655	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	84986	0	6844-5	3020655		
6208	579	46235214	1985-04-15	1985-04-15 00:00:00	1985-04-15	5001	0	\N	0	0	\N	\N	0	38357	0	76690-7	46235214		
16595	1512	3006322	1987-10-03	1987-10-03 00:00:00	1987-10-03	5001	0	\N	0	0	\N	\N	0	100953	0	8331-1	3006322		
33989	3093	3006322	1983-01-27	1983-01-27 00:00:00	1983-01-27	5001	0	\N	0	0	\N	\N	0	205928	0	8331-1	3006322		
1594	43	4024958	1996-07-14	1996-07-14 00:00:00	1996-07-14	5001	0	\N	0	0	\N	\N	0	3173	0	117015009	4024958		
1610	43	4052083	1979-10-19	1979-10-19 00:00:00	1979-10-19	5001	0	\N	0	0	\N	\N	0	3144	0	23426006	4052083		
51864	4757	3006322	1971-10-20	1971-10-20 00:00:00	1971-10-20	5001	0	\N	0	0	\N	\N	0	316911	0	8331-1	3006322		
46149	4256	3014576	1963-11-14	1963-11-14 00:00:00	1963-11-14	5001	0	\N	0	0	\N	\N	0	282589	0	2075-0	3014576		
48103	4412	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	293331	0	6206-7	3012494		
28641	2649	3006322	1960-06-19	1960-06-19 00:00:00	1960-06-19	5001	0	\N	0	0	\N	\N	0	175297	0	8331-1	3006322		
8488	807	46235214	1952-02-15	1952-02-15 00:00:00	1952-02-15	5001	0	\N	0	0	\N	\N	0	53564	0	76690-7	46235214		
28816	2663	3006322	2010-05-10	2010-05-10 00:00:00	2010-05-10	5001	0	\N	0	0	\N	\N	0	176486	0	8331-1	3006322		
40170	3742	3006322	1984-08-04	1984-08-04 00:00:00	1984-08-04	5001	0	\N	0	0	\N	\N	0	248667	0	8331-1	3006322		
49591	4513	3006322	1994-05-14	1994-05-14 00:00:00	1994-05-14	5001	0	\N	0	0	\N	\N	0	300546	0	8331-1	3006322		
2590	80	4052083	2013-12-29	2013-12-29 00:00:00	2013-12-29	5001	0	\N	0	0	\N	\N	0	5441	0	23426006	4052083		
49759	4527	3006322	2015-12-11	2015-12-11 00:00:00	2015-12-11	5001	0	\N	0	0	\N	\N	0	301429	0	8331-1	3006322		
57430	1753	4024958	1998-04-18	1998-04-18 00:00:00	1998-04-18	5001	0	\N	0	0	\N	\N	0	117204	0	117015009	4024958		
11	2	3011505	2005-08-23	2005-08-23 00:00:00	2005-08-23	5001	0	\N	0	0	\N	\N	0	136	0	19926-5	3011505		
9755	917	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	61059	0	6075-6	3005136		
861	67	3006322	2006-07-13	2006-07-13 00:00:00	2006-07-13	5001	0	\N	0	0	\N	\N	0	4540	0	8331-1	3006322		
8807	279	4024958	1953-10-21	1953-10-21 00:00:00	1953-10-21	5001	0	\N	0	0	\N	\N	0	18614	0	117015009	4024958		
12320	1175	3014599	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	77451	0	6106-9	3014599		
23652	2175	46235214	1977-04-28	1977-04-28 00:00:00	1977-04-28	5001	0	\N	0	0	\N	\N	0	144949	0	76690-7	46235214		
1725	152	3027970	1973-12-15	1973-12-15 00:00:00	1973-12-15	5001	0	\N	0	0	\N	\N	0	10291	0	10834-0	3027970		
7689	742	3011505	1997-05-19	1997-05-19 00:00:00	1997-05-19	5001	0	\N	0	0	\N	\N	0	49122	0	19926-5	3011505		
6995	670	3006322	2018-05-01	2018-05-01 00:00:00	2018-05-01	5001	0	\N	0	0	\N	\N	0	44226	0	8331-1	3006322		
19074	1748	3006322	2017-10-26	2017-10-26 00:00:00	2017-10-26	5001	0	\N	0	0	\N	\N	0	116861	0	8331-1	3006322		
79318	2437	4024958	2003-09-26	2003-09-26 00:00:00	2003-09-26	5001	0	\N	0	0	\N	\N	0	161716	0	117015009	4024958		
46658	4297	3014576	1991-02-19	1991-02-19 00:00:00	1991-02-19	5001	0	\N	0	0	\N	\N	0	285178	0	2075-0	3014576		
1358	117	3006322	2011-02-19	2011-02-19 00:00:00	2011-02-19	5001	0	\N	0	0	\N	\N	0	7780	0	8331-1	3006322		
138750	4278	4133840	1994-01-14	1994-01-14 00:00:00	1994-01-14	5001	0	\N	0	0	\N	\N	0	283919	0	127783003	4133840		
2940	283	3006322	1993-06-03	1993-06-03 00:00:00	1993-06-03	5001	0	\N	0	0	\N	\N	0	18861	0	8331-1	3006322		
6768	642	3006322	2013-12-31	2013-12-31 00:00:00	2013-12-31	5001	0	\N	0	0	\N	\N	0	42541	0	8331-1	3006322		
113010	3488	4133840	2008-02-29	2008-02-29 00:00:00	2008-02-29	5001	0	\N	0	0	\N	\N	0	231411	0	127783003	4133840		
3453	103	4024958	1979-07-11	1979-07-11 00:00:00	1979-07-11	5001	0	\N	0	0	\N	\N	0	7044	0	117015009	4024958		
52860	4852	46235214	1996-12-23	1996-12-23 00:00:00	1996-12-23	5001	0	\N	0	0	\N	\N	0	322788	0	76690-7	46235214		
160543	4932	4052083	1964-12-08	1964-12-08 00:00:00	1964-12-08	5001	0	\N	0	0	\N	\N	0	327865	0	23426006	4052083		
27755	2554	40769189	1964-07-31	1964-07-31 00:00:00	1964-07-31	5001	0	\N	0	0	\N	\N	0	169261	0	66529-9	40769189		
37317	3442	3006322	1974-06-11	1974-06-11 00:00:00	1974-06-11	5001	0	\N	0	0	\N	\N	0	228446	0	8331-1	3006322		
48731	4452	3006322	1962-07-29	1962-07-29 00:00:00	1962-07-29	5001	0	\N	0	0	\N	\N	0	296210	0	8331-1	3006322		
22773	2088	3011505	1982-09-21	1982-09-21 00:00:00	1982-09-21	5001	0	\N	0	0	\N	\N	0	139212	0	19926-5	3011505		
37826	1175	4052083	2009-04-19	2009-04-19 00:00:00	2009-04-19	5001	0	\N	0	0	\N	\N	0	77529	0	23426006	4052083		
22670	2077	3020655	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	138304	0	6844-5	3020655		
1971	180	3014599	1980-05-17	1980-05-17 00:00:00	1980-05-17	5001	0	\N	0	0	\N	\N	0	12198	0	6106-9	3014599		
100684	3090	4052083	2006-02-07	2006-02-07 00:00:00	2006-02-07	5001	0	\N	0	0	\N	\N	0	205750	0	23426006	4052083		
171232	5253	4133840	2008-12-27	2008-12-27 00:00:00	2008-12-27	5001	0	\N	0	0	\N	\N	0	349513	0	127783003	4133840		
49129	4490	3006322	1971-05-09	1971-05-09 00:00:00	1971-05-09	5001	0	\N	0	0	\N	\N	0	298889	0	8331-1	3006322		
126618	3895	4052083	1933-09-14	1933-09-14 00:00:00	1933-09-14	5001	0	\N	0	0	\N	\N	0	259115	0	23426006	4052083		
25745	2359	3006322	2002-08-02	2002-08-02 00:00:00	2002-08-02	5001	0	\N	0	0	\N	\N	0	157247	0	8331-1	3006322		
38756	3582	3011505	2009-06-14	2009-06-14 00:00:00	2009-06-14	5001	0	\N	0	0	\N	\N	0	238133	0	19926-5	3011505		
51470	4713	40766240	1967-02-06	1967-02-06 00:00:00	1967-02-06	5001	0	\N	0	0	\N	\N	0	313834	0	63513-6	40766240		
95059	2919	4133840	2014-11-29	2014-11-29 00:00:00	2014-11-29	5001	0	\N	0	0	\N	\N	0	194637	0	127783003	4133840		
31974	2915	3000876	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	194256	0	6082-2	3000876		
8782	843	3019406	1998-11-07	1998-11-07 00:00:00	1998-11-07	5001	0	\N	0	0	\N	\N	0	55792	0	6158-0	3019406		
117290	3615	4052083	2011-01-02	2011-01-02 00:00:00	2011-01-02	5001	0	\N	0	0	\N	\N	0	240203	0	23426006	4052083		
117752	3625	4024958	1962-04-15	1962-04-15 00:00:00	1962-04-15	5001	0	\N	0	0	\N	\N	0	241061	0	117015009	4024958		
108518	3352	4024958	1964-12-23	1964-12-23 00:00:00	1964-12-23	5001	0	\N	0	0	\N	\N	0	222268	0	117015009	4024958		
30103	2770	3006322	1947-07-30	1947-07-30 00:00:00	1947-07-30	5001	0	\N	0	0	\N	\N	0	183311	0	8331-1	3006322		
145248	4456	4052083	1999-12-09	1999-12-09 00:00:00	1999-12-09	5001	0	\N	0	0	\N	\N	0	296553	0	23426006	4052083		
3106	299	46235214	1963-01-08	1963-01-08 00:00:00	1963-01-08	5001	0	\N	0	0	\N	\N	0	20019	0	76690-7	46235214		
23629	742	4133840	1982-10-04	1982-10-04 00:00:00	1982-10-04	5001	0	\N	0	0	\N	\N	0	49113	0	127783003	4133840		
23762	742	4133840	1985-10-21	1985-10-21 00:00:00	1985-10-21	5001	0	\N	0	0	\N	\N	0	49206	0	127783003	4133840		
14458	453	4052083	2014-04-18	2014-04-18 00:00:00	2014-04-18	5001	0	\N	0	0	\N	\N	0	30187	0	23426006	4052083		
33273	3007	3006322	1987-05-18	1987-05-18 00:00:00	1987-05-18	5001	0	\N	0	0	\N	\N	0	200636	0	8331-1	3006322		
13687	1285	3036780	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	84986	0	6095-4	3036780		
6210	579	3006322	1996-09-21	1996-09-21 00:00:00	1996-09-21	5001	0	\N	0	0	\N	\N	0	38301	0	8331-1	3006322		
16596	1513	3021226	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	101053	0	6246-3	3021226		
33990	3093	3006322	2003-11-13	2003-11-13 00:00:00	2003-11-13	5001	0	\N	0	0	\N	\N	0	205916	0	8331-1	3006322		
148427	4547	4052083	1965-05-27	1965-05-27 00:00:00	1965-05-27	5001	0	\N	0	0	\N	\N	0	302934	0	23426006	4052083		
12916	410	4024958	2001-11-01	2001-11-01 00:00:00	2001-11-01	5001	0	\N	0	0	\N	\N	0	27174	0	117015009	4024958		
51865	4757	3006322	1991-05-03	1991-05-03 00:00:00	1991-05-03	5001	0	\N	0	0	\N	\N	0	316902	0	8331-1	3006322		
46150	4256	3006923	1963-11-14	1963-11-14 00:00:00	1963-11-14	5001	0	\N	0	0	\N	\N	0	282589	0	1742-6	3006923		
48104	4412	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	293331	0	6276-0	3027231		
28643	2651	3006322	1973-11-08	1973-11-08 00:00:00	1973-11-08	5001	0	\N	0	0	\N	\N	0	175488	0	8331-1	3006322		
8489	807	40766240	1952-02-15	1952-02-15 00:00:00	1952-02-15	5001	0	\N	0	0	\N	\N	0	53564	0	63513-6	40766240		
40097	3736	3006322	1959-03-27	1959-03-27 00:00:00	1959-03-27	5001	0	\N	0	0	\N	\N	0	248255	0	8331-1	3006322		
40171	3742	3006322	1988-03-25	1988-03-25 00:00:00	1988-03-25	5001	0	\N	0	0	\N	\N	0	248680	0	8331-1	3006322		
49592	4514	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	300640	0	6082-2	3000876		
2600	80	4024958	1950-03-20	1950-03-20 00:00:00	1950-03-20	5001	0	\N	0	0	\N	\N	0	5462	0	117015009	4024958		
49760	4527	3049273	2011-09-02	2011-09-02 00:00:00	2011-09-02	5001	0	\N	0	0	\N	\N	0	301446	0	38265-5	3049273		
140785	4342	4024958	1989-12-27	1989-12-27 00:00:00	1989-12-27	5001	0	\N	0	0	\N	\N	0	287944	0	117015009	4024958		
12	2	3051031	1935-08-22	1935-08-22 00:00:00	1935-08-22	5001	0	\N	0	0	\N	\N	0	125	0	46240-8	3051031		
9756	917	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	61059	0	6833-8	3023430		
862	67	3006322	1975-02-12	1975-02-12 00:00:00	1975-02-12	5001	0	\N	0	0	\N	\N	0	4564	0	8331-1	3006322		
8812	279	4052083	1992-02-12	1992-02-12 00:00:00	1992-02-12	5001	0	\N	0	0	\N	\N	0	18639	0	23426006	4052083		
12321	1175	3006451	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	77451	0	6273-7	3006451		
23654	2175	40758406	1977-04-28	1977-04-28 00:00:00	1977-04-28	5001	0	\N	0	0	\N	\N	0	144949	0	55277-8	40758406		
1726	152	3013721	1973-12-15	1973-12-15 00:00:00	1973-12-15	5001	0	\N	0	0	\N	\N	0	10291	0	1920-8	3013721		
7690	742	3011505	1994-05-02	1994-05-02 00:00:00	1994-05-02	5001	0	\N	0	0	\N	\N	0	49179	0	19926-5	3011505		
6996	670	3006322	2018-09-13	2018-09-13 00:00:00	2018-09-13	5001	0	\N	0	0	\N	\N	0	44227	0	8331-1	3006322		
19105	1750	3006322	2006-09-11	2006-09-11 00:00:00	2006-09-11	5001	0	\N	0	0	\N	\N	0	117020	0	8331-1	3006322		
79328	2438	4024958	1989-07-19	1989-07-19 00:00:00	1989-07-19	5001	0	\N	0	0	\N	\N	0	161769	0	117015009	4024958		
46659	4297	3035995	1991-02-19	1991-02-19 00:00:00	1991-02-19	5001	0	\N	0	0	\N	\N	0	285178	0	6768-6	3035995		
1363	119	3006322	1958-11-08	1958-11-08 00:00:00	1958-11-08	5001	0	\N	0	0	\N	\N	0	7882	0	8331-1	3006322		
138751	4278	4024958	1994-06-01	1994-06-01 00:00:00	1994-06-01	5001	0	\N	0	0	\N	\N	0	283883	0	117015009	4024958		
2941	283	3006322	1992-04-27	1992-04-27 00:00:00	1992-04-27	5001	0	\N	0	0	\N	\N	0	18825	0	8331-1	3006322		
6769	642	3049273	2017-11-18	2017-11-18 00:00:00	2017-11-18	5001	0	\N	0	0	\N	\N	0	42576	0	38265-5	3049273		
113012	3488	4133840	2005-02-11	2005-02-11 00:00:00	2005-02-11	5001	0	\N	0	0	\N	\N	0	231375	0	127783003	4133840		
3474	105	4024958	1979-03-03	1979-03-03 00:00:00	1979-03-03	5001	0	\N	0	0	\N	\N	0	7143	0	117015009	4024958		
52861	4852	3006322	1960-11-30	1960-11-30 00:00:00	1960-11-30	5001	0	\N	0	0	\N	\N	0	322784	0	8331-1	3006322		
160549	4932	4052083	1997-04-18	1997-04-18 00:00:00	1997-04-18	5001	0	\N	0	0	\N	\N	0	327921	0	23426006	4052083		
27756	2554	3006322	1940-02-08	1940-02-08 00:00:00	1940-02-08	5001	0	\N	0	0	\N	\N	0	169134	0	8331-1	3006322		
37318	3443	3006322	1986-06-23	1986-06-23 00:00:00	1986-06-23	5001	0	\N	0	0	\N	\N	0	228481	0	8331-1	3006322		
73419	2258	4024958	1960-11-26	1960-11-26 00:00:00	1960-11-26	5001	0	\N	0	0	\N	\N	0	150041	0	117015009	4024958		
22774	2088	3011505	1969-11-25	1969-11-25 00:00:00	1969-11-25	5001	0	\N	0	0	\N	\N	0	139250	0	19926-5	3011505		
37872	1175	4052083	1953-09-20	1953-09-20 00:00:00	1953-09-20	5001	0	\N	0	0	\N	\N	0	77415	0	23426006	4052083		
22671	2077	3023430	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	138304	0	6833-8	3023430		
1972	180	3027231	1980-05-17	1980-05-17 00:00:00	1980-05-17	5001	0	\N	0	0	\N	\N	0	12198	0	6276-0	3027231		
100685	3090	4052083	2005-03-06	2005-03-06 00:00:00	2005-03-06	5001	0	\N	0	0	\N	\N	0	205709	0	23426006	4052083		
171233	5253	4133840	2018-05-19	2018-05-19 00:00:00	2018-05-19	5001	0	\N	0	0	\N	\N	0	349570	0	127783003	4133840		
49130	4490	3006322	1971-03-29	1971-03-29 00:00:00	1971-03-29	5001	0	\N	0	0	\N	\N	0	298917	0	8331-1	3006322		
126621	3895	4052083	1963-07-29	1963-07-29 00:00:00	1963-07-29	5001	0	\N	0	0	\N	\N	0	259050	0	23426006	4052083		
25746	2359	3006322	1997-08-14	1997-08-14 00:00:00	1997-08-14	5001	0	\N	0	0	\N	\N	0	157180	0	8331-1	3006322		
38757	3582	3011505	1993-08-15	1993-08-15 00:00:00	1993-08-15	5001	0	\N	0	0	\N	\N	0	238103	0	19926-5	3011505		
51472	4713	46235214	1967-02-06	1967-02-06 00:00:00	1967-02-06	5001	0	\N	0	0	\N	\N	0	313834	0	76690-7	46235214		
95060	2919	4024958	1949-11-20	1949-11-20 00:00:00	1949-11-20	5001	0	\N	0	0	\N	\N	0	194582	0	117015009	4024958		
31975	2915	3006734	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	194256	0	6189-5	3006734		
8783	843	3000876	1998-11-07	1998-11-07 00:00:00	1998-11-07	5001	0	\N	0	0	\N	\N	0	55792	0	6082-2	3000876		
117297	3615	4052083	1997-09-25	1997-09-25 00:00:00	1997-09-25	5001	0	\N	0	0	\N	\N	0	240180	0	23426006	4052083		
117756	3625	4024958	1981-04-08	1981-04-08 00:00:00	1981-04-08	5001	0	\N	0	0	\N	\N	0	241120	0	117015009	4024958		
108521	3352	4133840	2017-11-10	2017-11-10 00:00:00	2017-11-10	5001	0	\N	0	0	\N	\N	0	222277	0	127783003	4133840		
30104	2770	3023430	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	183401	0	6833-8	3023430		
145254	4456	4052083	1971-06-11	1971-06-11 00:00:00	1971-06-11	5001	0	\N	0	0	\N	\N	0	296565	0	23426006	4052083		
3108	299	3051031	1963-01-08	1963-01-08 00:00:00	1963-01-08	5001	0	\N	0	0	\N	\N	0	20019	0	46240-8	3051031		
23632	742	4133840	1987-11-02	1987-11-02 00:00:00	1987-11-02	5001	0	\N	0	0	\N	\N	0	49207	0	127783003	4133840		
113164	3494	4133840	2009-07-30	2009-07-30 00:00:00	2009-07-30	5001	0	\N	0	0	\N	\N	0	231735	0	127783003	4133840		
152130	4660	4052083	1989-01-02	1989-01-02 00:00:00	1989-01-02	5001	0	\N	0	0	\N	\N	0	310608	0	23426006	4052083		
44585	4116	3006322	1981-11-22	1981-11-22 00:00:00	1981-11-22	5001	0	\N	0	0	\N	\N	0	273627	0	8331-1	3006322		
13688	1285	3000876	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	84986	0	6082-2	3000876		
6211	579	3006322	1997-07-02	1997-07-02 00:00:00	1997-07-02	5001	0	\N	0	0	\N	\N	0	38359	0	8331-1	3006322		
16597	1513	3019406	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	101053	0	6158-0	3019406		
33991	3093	3006322	1998-04-28	1998-04-28 00:00:00	1998-04-28	5001	0	\N	0	0	\N	\N	0	205930	0	8331-1	3006322		
43996	4064	3006734	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	270013	0	6189-5	3006734		
12931	410	4052083	1982-10-17	1982-10-17 00:00:00	1982-10-17	5001	0	\N	0	0	\N	\N	0	27198	0	23426006	4052083		
51866	4757	3006322	1996-07-21	1996-07-21 00:00:00	1996-07-21	5001	0	\N	0	0	\N	\N	0	316913	0	8331-1	3006322		
46151	4256	3024731	1963-11-14	1963-11-14 00:00:00	1963-11-14	5001	0	\N	0	0	\N	\N	0	282589	0	30428-7	3024731		
48105	4412	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	293331	0	6246-3	3021226		
28644	2651	3006322	1969-08-19	1969-08-19 00:00:00	1969-08-19	5001	0	\N	0	0	\N	\N	0	175444	0	8331-1	3006322		
8491	807	3006322	1970-06-24	1970-06-24 00:00:00	1970-06-24	5001	0	\N	0	0	\N	\N	0	53560	0	8331-1	3006322		
40098	3736	3006322	1968-02-26	1968-02-26 00:00:00	1968-02-26	5001	0	\N	0	0	\N	\N	0	248256	0	8331-1	3006322		
40172	3742	3006322	2017-12-18	2017-12-18 00:00:00	2017-12-18	5001	0	\N	0	0	\N	\N	0	248641	0	8331-1	3006322		
49593	4514	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	300640	0	7258-7	3001488		
2606	80	4052083	1937-07-09	1937-07-09 00:00:00	1937-07-09	5001	0	\N	0	0	\N	\N	0	5460	0	23426006	4052083		
49761	4527	3006322	1988-04-27	1988-04-27 00:00:00	1988-04-27	5001	0	\N	0	0	\N	\N	0	301428	0	8331-1	3006322		
140789	4342	4052083	1987-05-07	1987-05-07 00:00:00	1987-05-07	5001	0	\N	0	0	\N	\N	0	287958	0	23426006	4052083		
14	2	46235214	1935-08-22	1935-08-22 00:00:00	1935-08-22	5001	0	\N	0	0	\N	\N	0	125	0	76690-7	46235214		
9757	917	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	61059	0	6844-5	3020655		
879	69	3006322	1948-04-06	1948-04-06 00:00:00	1948-04-06	5001	0	\N	0	0	\N	\N	0	4692	0	8331-1	3006322		
8815	279	4052083	1971-02-06	1971-02-06 00:00:00	1971-02-06	5001	0	\N	0	0	\N	\N	0	18637	0	23426006	4052083		
12322	1175	3012494	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	77451	0	6206-7	3012494		
23655	2175	40766240	1977-04-28	1977-04-28 00:00:00	1977-04-28	5001	0	\N	0	0	\N	\N	0	144949	0	63513-6	40766240		
1727	152	3014576	1973-12-15	1973-12-15 00:00:00	1973-12-15	5001	0	\N	0	0	\N	\N	0	10291	0	2075-0	3014576		
7691	742	3011505	2009-07-27	2009-07-27 00:00:00	2009-07-27	5001	0	\N	0	0	\N	\N	0	49184	0	19926-5	3011505		
6997	670	3006322	1976-04-22	1976-04-22 00:00:00	1976-04-22	5001	0	\N	0	0	\N	\N	0	44238	0	8331-1	3006322		
19106	1750	3006322	1979-07-20	1979-07-20 00:00:00	1979-07-20	5001	0	\N	0	0	\N	\N	0	117031	0	8331-1	3006322		
79344	2439	4052083	2008-05-18	2008-05-18 00:00:00	2008-05-18	5001	0	\N	0	0	\N	\N	0	161785	0	23426006	4052083		
46660	4297	3006923	1991-02-19	1991-02-19 00:00:00	1991-02-19	5001	0	\N	0	0	\N	\N	0	285178	0	1742-6	3006923		
1364	119	3006322	1991-02-10	1991-02-10 00:00:00	1991-02-10	5001	0	\N	0	0	\N	\N	0	7867	0	8331-1	3006322		
138753	4278	4133840	2004-09-17	2004-09-17 00:00:00	2004-09-17	5001	0	\N	0	0	\N	\N	0	283865	0	127783003	4133840		
2942	283	3006322	1984-02-15	1984-02-15 00:00:00	1984-02-15	5001	0	\N	0	0	\N	\N	0	18859	0	8331-1	3006322		
6770	642	3006322	1972-01-28	1972-01-28 00:00:00	1972-01-28	5001	0	\N	0	0	\N	\N	0	42537	0	8331-1	3006322		
113013	3488	4133840	1999-09-03	1999-09-03 00:00:00	1999-09-03	5001	0	\N	0	0	\N	\N	0	231424	0	127783003	4133840		
118241	3639	4024958	1966-05-24	1966-05-24 00:00:00	1966-05-24	5001	0	\N	0	0	\N	\N	0	242064	0	117015009	4024958		
52862	4852	40758406	1997-01-22	1997-01-22 00:00:00	1997-01-22	5001	0	\N	0	0	\N	\N	0	322776	0	55277-8	40758406		
160559	4932	4052083	1990-09-06	1990-09-06 00:00:00	1990-09-06	5001	0	\N	0	0	\N	\N	0	327887	0	23426006	4052083		
27757	2554	3006322	1968-04-05	1968-04-05 00:00:00	1968-04-05	5001	0	\N	0	0	\N	\N	0	169097	0	8331-1	3006322		
37319	3444	3006322	1995-02-08	1995-02-08 00:00:00	1995-02-08	5001	0	\N	0	0	\N	\N	0	228524	0	8331-1	3006322		
73436	2258	4052083	1979-07-19	1979-07-19 00:00:00	1979-07-19	5001	0	\N	0	0	\N	\N	0	150077	0	23426006	4052083		
22775	2088	3011505	1977-08-23	1977-08-23 00:00:00	1977-08-23	5001	0	\N	0	0	\N	\N	0	139252	0	19926-5	3011505		
79909	2460	4024958	2016-10-20	2016-10-20 00:00:00	2016-10-20	5001	0	\N	0	0	\N	\N	0	163114	0	117015009	4024958		
22672	2077	3006734	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	138304	0	6189-5	3006734		
1973	180	3005136	1980-05-17	1980-05-17 00:00:00	1980-05-17	5001	0	\N	0	0	\N	\N	0	12198	0	6075-6	3005136		
100712	3092	4052083	1965-08-05	1965-08-05 00:00:00	1965-08-05	5001	0	\N	0	0	\N	\N	0	205882	0	23426006	4052083		
171235	5253	4024958	1981-04-11	1981-04-11 00:00:00	1981-04-11	5001	0	\N	0	0	\N	\N	0	349564	0	117015009	4024958		
49131	4490	3006322	1981-02-26	1981-02-26 00:00:00	1981-02-26	5001	0	\N	0	0	\N	\N	0	298910	0	8331-1	3006322		
126631	3896	4052083	2000-10-31	2000-10-31 00:00:00	2000-10-31	5001	0	\N	0	0	\N	\N	0	259181	0	23426006	4052083		
25747	2359	3006322	1962-11-18	1962-11-18 00:00:00	1962-11-18	5001	0	\N	0	0	\N	\N	0	157177	0	8331-1	3006322		
38758	3582	3011505	2004-06-20	2004-06-20 00:00:00	2004-06-20	5001	0	\N	0	0	\N	\N	0	238105	0	19926-5	3011505		
51473	4713	40758406	1967-02-06	1967-02-06 00:00:00	1967-02-06	5001	0	\N	0	0	\N	\N	0	313834	0	55277-8	40758406		
95064	2919	4133840	2010-10-23	2010-10-23 00:00:00	2010-10-23	5001	0	\N	0	0	\N	\N	0	194626	0	127783003	4133840		
31976	2915	3036780	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	194256	0	6095-4	3036780		
8784	843	3036780	1998-11-07	1998-11-07 00:00:00	1998-11-07	5001	0	\N	0	0	\N	\N	0	55792	0	6095-4	3036780		
117317	3616	4024958	1998-10-19	1998-10-19 00:00:00	1998-10-19	5001	0	\N	0	0	\N	\N	0	240314	0	117015009	4024958		
117771	3625	4024958	1970-01-10	1970-01-10 00:00:00	1970-01-10	5001	0	\N	0	0	\N	\N	0	241036	0	117015009	4024958		
108523	3352	4133840	2004-10-29	2004-10-29 00:00:00	2004-10-29	5001	0	\N	0	0	\N	\N	0	222320	0	127783003	4133840		
30105	2770	3020655	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	183401	0	6844-5	3020655		
145257	4456	4052083	1976-01-24	1976-01-24 00:00:00	1976-01-24	5001	0	\N	0	0	\N	\N	0	296551	0	23426006	4052083		
3110	299	40758406	1963-01-08	1963-01-08 00:00:00	1963-01-08	5001	0	\N	0	0	\N	\N	0	20019	0	55277-8	40758406		
23636	742	4133840	2000-06-05	2000-06-05 00:00:00	2000-06-05	5001	0	\N	0	0	\N	\N	0	49112	0	127783003	4133840		
113168	3494	4133840	2003-05-08	2003-05-08 00:00:00	2003-05-08	5001	0	\N	0	0	\N	\N	0	231791	0	127783003	4133840		
152133	4660	4052083	1967-08-02	1967-08-02 00:00:00	1967-08-02	5001	0	\N	0	0	\N	\N	0	310597	0	23426006	4052083		
44586	4116	3006322	1980-08-16	1980-08-16 00:00:00	1980-08-16	5001	0	\N	0	0	\N	\N	0	273626	0	8331-1	3006322		
13689	1285	3006322	1973-12-23	1973-12-23 00:00:00	1973-12-23	5001	0	\N	0	0	\N	\N	0	84984	0	8331-1	3006322		
6212	580	3049273	1997-10-05	1997-10-05 00:00:00	1997-10-05	5001	0	\N	0	0	\N	\N	0	38467	0	38265-5	3049273		
16598	1513	3001488	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	101053	0	7258-7	3001488		
33996	3096	3006322	2016-07-11	2016-07-11 00:00:00	2016-07-11	5001	0	\N	0	0	\N	\N	0	206094	0	8331-1	3006322		
43997	4064	3020655	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	270013	0	6844-5	3020655		
12937	410	4024958	1990-05-08	1990-05-08 00:00:00	1990-05-08	5001	0	\N	0	0	\N	\N	0	27192	0	117015009	4024958		
51867	4758	3006322	1994-09-11	1994-09-11 00:00:00	1994-09-11	5001	0	\N	0	0	\N	\N	0	317028	0	8331-1	3006322		
46152	4256	3026361	1963-11-14	1963-11-14 00:00:00	1963-11-14	5001	0	\N	0	0	\N	\N	0	282589	0	26453-1	3026361		
48106	4412	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	293331	0	6248-9	3015076		
28645	2651	3006322	1982-09-04	1982-09-04 00:00:00	1982-09-04	5001	0	\N	0	0	\N	\N	0	175380	0	8331-1	3006322		
8493	807	46235214	1952-06-14	1952-06-14 00:00:00	1952-06-14	5001	0	\N	0	0	\N	\N	0	53558	0	76690-7	46235214		
40099	3736	3006322	1986-12-01	1986-12-01 00:00:00	1986-12-01	5001	0	\N	0	0	\N	\N	0	248260	0	8331-1	3006322		
40173	3743	3006322	1986-03-02	1986-03-02 00:00:00	1986-03-02	5001	0	\N	0	0	\N	\N	0	248694	0	8331-1	3006322		
49594	4514	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	300640	0	6844-5	3020655		
2625	81	4024958	2005-08-09	2005-08-09 00:00:00	2005-08-09	5001	0	\N	0	0	\N	\N	0	5489	0	117015009	4024958		
49762	4527	3006322	2016-09-22	2016-09-22 00:00:00	2016-09-22	5001	0	\N	0	0	\N	\N	0	301430	0	8331-1	3006322		
140798	4343	4024958	2019-06-24	2019-06-24 00:00:00	2019-06-24	5001	0	\N	0	0	\N	\N	0	288037	0	117015009	4024958		
15	2	40766240	1935-08-22	1935-08-22 00:00:00	1935-08-22	5001	0	\N	0	0	\N	\N	0	125	0	63513-6	40766240		
9758	917	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	61059	0	6082-2	3000876		
880	69	3006322	2000-09-25	2000-09-25 00:00:00	2000-09-25	5001	0	\N	0	0	\N	\N	0	4616	0	8331-1	3006322		
8819	279	4024958	1964-07-07	1964-07-07 00:00:00	1964-07-07	5001	0	\N	0	0	\N	\N	0	18653	0	117015009	4024958		
12323	1175	3015076	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	77451	0	6248-9	3015076		
23657	2175	3051031	1977-04-28	1977-04-28 00:00:00	1977-04-28	5001	0	\N	0	0	\N	\N	0	144949	0	46240-8	3051031		
1728	152	3006923	1973-12-15	1973-12-15 00:00:00	1973-12-15	5001	0	\N	0	0	\N	\N	0	10291	0	1742-6	3006923		
7692	742	3011505	1999-05-31	1999-05-31 00:00:00	1999-05-31	5001	0	\N	0	0	\N	\N	0	49123	0	19926-5	3011505		
6998	670	3006322	1984-08-06	1984-08-06 00:00:00	1984-08-06	5001	0	\N	0	0	\N	\N	0	44240	0	8331-1	3006322		
19107	1751	3006322	1993-06-03	1993-06-03 00:00:00	1993-06-03	5001	0	\N	0	0	\N	\N	0	117048	0	8331-1	3006322		
79358	2439	4024958	1976-05-29	1976-05-29 00:00:00	1976-05-29	5001	0	\N	0	0	\N	\N	0	161798	0	117015009	4024958		
46661	4297	3027970	1991-02-19	1991-02-19 00:00:00	1991-02-19	5001	0	\N	0	0	\N	\N	0	285178	0	10834-0	3027970		
1365	119	3006322	1962-09-30	1962-09-30 00:00:00	1962-09-30	5001	0	\N	0	0	\N	\N	0	7895	0	8331-1	3006322		
138755	4278	4133840	1992-01-10	1992-01-10 00:00:00	1992-01-10	5001	0	\N	0	0	\N	\N	0	283926	0	127783003	4133840		
2957	285	3014599	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	18965	0	6106-9	3014599		
6771	642	3006322	2017-06-26	2017-06-26 00:00:00	2017-06-26	5001	0	\N	0	0	\N	\N	0	42493	0	8331-1	3006322		
113015	3488	4052083	1960-04-20	1960-04-20 00:00:00	1960-04-20	5001	0	\N	0	0	\N	\N	0	231340	0	23426006	4052083		
118250	3639	4024958	1958-11-08	1958-11-08 00:00:00	1958-11-08	5001	0	\N	0	0	\N	\N	0	242029	0	117015009	4024958		
52864	4852	40766240	1997-01-22	1997-01-22 00:00:00	1997-01-22	5001	0	\N	0	0	\N	\N	0	322776	0	63513-6	40766240		
160560	4932	4024958	1985-03-04	1985-03-04 00:00:00	1985-03-04	5001	0	\N	0	0	\N	\N	0	327810	0	117015009	4024958		
27758	2554	3006322	2005-09-24	2005-09-24 00:00:00	2005-09-24	5001	0	\N	0	0	\N	\N	0	169222	0	8331-1	3006322		
37320	3444	3006322	1981-01-31	1981-01-31 00:00:00	1981-01-31	5001	0	\N	0	0	\N	\N	0	228556	0	8331-1	3006322		
73444	2258	4052083	2003-11-11	2003-11-11 00:00:00	2003-11-11	5001	0	\N	0	0	\N	\N	0	150094	0	23426006	4052083		
22776	2088	3011505	1976-08-17	1976-08-17 00:00:00	1976-08-17	5001	0	\N	0	0	\N	\N	0	139321	0	19926-5	3011505		
79913	2460	4024958	2006-08-17	2006-08-17 00:00:00	2006-08-17	5001	0	\N	0	0	\N	\N	0	163092	0	117015009	4024958		
22673	2077	3036780	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	138304	0	6095-4	3036780		
1974	180	3019406	1980-05-17	1980-05-17 00:00:00	1980-05-17	5001	0	\N	0	0	\N	\N	0	12198	0	6158-0	3019406		
100713	3092	4024958	1963-10-17	1963-10-17 00:00:00	1963-10-17	5001	0	\N	0	0	\N	\N	0	205864	0	117015009	4024958		
171236	5253	4133840	1983-04-23	1983-04-23 00:00:00	1983-04-23	5001	0	\N	0	0	\N	\N	0	349532	0	127783003	4133840		
49132	4490	3006322	1987-04-06	1987-04-06 00:00:00	1987-04-06	5001	0	\N	0	0	\N	\N	0	298911	0	8331-1	3006322		
126632	3896	4024958	1990-01-26	1990-01-26 00:00:00	1990-01-26	5001	0	\N	0	0	\N	\N	0	259165	0	117015009	4024958		
25748	2359	3006322	1955-09-06	1955-09-06 00:00:00	1955-09-06	5001	0	\N	0	0	\N	\N	0	157246	0	8331-1	3006322		
38759	3582	3006322	1983-04-08	1983-04-08 00:00:00	1983-04-08	5001	0	\N	0	0	\N	\N	0	238168	0	8331-1	3006322		
51474	4715	3006322	2017-09-05	2017-09-05 00:00:00	2017-09-05	5001	0	\N	0	0	\N	\N	0	313900	0	8331-1	3006322		
95067	2919	4024958	1969-03-02	1969-03-02 00:00:00	1969-03-02	5001	0	\N	0	0	\N	\N	0	194587	0	117015009	4024958		
31977	2915	3001247	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	194256	0	6085-5	3001247		
8785	843	3015076	1998-11-07	1998-11-07 00:00:00	1998-11-07	5001	0	\N	0	0	\N	\N	0	55792	0	6248-9	3015076		
117319	3616	4024958	1982-04-04	1982-04-04 00:00:00	1982-04-04	5001	0	\N	0	0	\N	\N	0	240271	0	117015009	4024958		
3392	101	4024958	2003-08-25	2003-08-25 00:00:00	2003-08-25	5001	0	\N	0	0	\N	\N	0	6938	0	117015009	4024958		
108525	3352	4133840	2008-11-07	2008-11-07 00:00:00	2008-11-07	5001	0	\N	0	0	\N	\N	0	222275	0	127783003	4133840		
30106	2770	3006451	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	183401	0	6273-7	3006451		
4201	129	4024958	1993-08-01	1993-08-01 00:00:00	1993-08-01	5001	0	\N	0	0	\N	\N	0	8674	0	117015009	4024958		
3111	299	3051031	1963-12-04	1963-12-04 00:00:00	1963-12-04	5001	0	\N	0	0	\N	\N	0	20015	0	46240-8	3051031		
23637	742	4024958	1970-02-05	1970-02-05 00:00:00	1970-02-05	5001	0	\N	0	0	\N	\N	0	49126	0	117015009	4024958		
113171	3494	4133840	2013-10-31	2013-10-31 00:00:00	2013-10-31	5001	0	\N	0	0	\N	\N	0	231765	0	127783003	4133840		
152137	4661	4024958	1986-06-26	1986-06-26 00:00:00	1986-06-26	5001	0	\N	0	0	\N	\N	0	310708	0	117015009	4024958		
44587	4116	3006322	2002-11-12	2002-11-12 00:00:00	2002-11-12	5001	0	\N	0	0	\N	\N	0	273631	0	8331-1	3006322		
13690	1285	3001488	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	84976	0	7258-7	3001488		
6213	580	3006322	1930-12-17	1930-12-17 00:00:00	1930-12-17	5001	0	\N	0	0	\N	\N	0	38443	0	8331-1	3006322		
16599	1513	3001247	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	101053	0	6085-5	3001247		
33997	3096	3006322	1998-09-03	1998-09-03 00:00:00	1998-09-03	5001	0	\N	0	0	\N	\N	0	206069	0	8331-1	3006322		
43998	4064	3023430	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	270013	0	6833-8	3023430		
12938	410	4052083	2004-08-30	2004-08-30 00:00:00	2004-08-30	5001	0	\N	0	0	\N	\N	0	27195	0	23426006	4052083		
51868	4758	3006322	1987-10-07	1987-10-07 00:00:00	1987-10-07	5001	0	\N	0	0	\N	\N	0	316997	0	8331-1	3006322		
46153	4256	3000963	1963-11-14	1963-11-14 00:00:00	1963-11-14	5001	0	\N	0	0	\N	\N	0	282589	0	718-7	3000963		
48107	4412	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	293331	0	6189-5	3006734		
28646	2651	3006322	2014-07-28	2014-07-28 00:00:00	2014-07-28	5001	0	\N	0	0	\N	\N	0	175432	0	8331-1	3006322		
8495	807	40766240	1952-06-14	1952-06-14 00:00:00	1952-06-14	5001	0	\N	0	0	\N	\N	0	53558	0	63513-6	40766240		
40100	3736	3006322	1986-01-22	1986-01-22 00:00:00	1986-01-22	5001	0	\N	0	0	\N	\N	0	248316	0	8331-1	3006322		
40174	3744	40766240	1971-01-27	1971-01-27 00:00:00	1971-01-27	5001	0	\N	0	0	\N	\N	0	248739	0	63513-6	40766240		
49595	4514	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	300640	0	6833-8	3023430		
2628	81	4024958	1964-09-18	1964-09-18 00:00:00	1964-09-18	5001	0	\N	0	0	\N	\N	0	5487	0	117015009	4024958		
10657	338	4052083	2008-11-01	2008-11-01 00:00:00	2008-11-01	5001	0	\N	0	0	\N	\N	0	22543	0	23426006	4052083		
140820	4343	4024958	1997-01-11	1997-01-11 00:00:00	1997-01-11	5001	0	\N	0	0	\N	\N	0	288053	0	117015009	4024958		
17	2	40758406	1935-08-22	1935-08-22 00:00:00	1935-08-22	5001	0	\N	0	0	\N	\N	0	125	0	55277-8	40758406		
9759	917	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	61073	0	6082-2	3000876		
881	69	3006322	1972-06-12	1972-06-12 00:00:00	1972-06-12	5001	0	\N	0	0	\N	\N	0	4695	0	8331-1	3006322		
8822	279	4024958	1993-06-13	1993-06-13 00:00:00	1993-06-13	5001	0	\N	0	0	\N	\N	0	18655	0	117015009	4024958		
12324	1175	3006734	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	77451	0	6189-5	3006734		
23658	2175	46235214	1977-07-27	1977-07-27 00:00:00	1977-07-27	5001	0	\N	0	0	\N	\N	0	144998	0	76690-7	46235214		
1729	152	3006906	1973-12-15	1973-12-15 00:00:00	1973-12-15	5001	0	\N	0	0	\N	\N	0	10291	0	17861-6	3006906		
7693	742	3006322	1951-12-08	1951-12-08 00:00:00	1951-12-08	5001	0	\N	0	0	\N	\N	0	49215	0	8331-1	3006322		
6999	670	3006322	1980-07-13	1980-07-13 00:00:00	1980-07-13	5001	0	\N	0	0	\N	\N	0	44239	0	8331-1	3006322		
19108	1751	3006322	1990-05-07	1990-05-07 00:00:00	1990-05-07	5001	0	\N	0	0	\N	\N	0	117058	0	8331-1	3006322		
79362	2439	4052083	2012-12-24	2012-12-24 00:00:00	2012-12-24	5001	0	\N	0	0	\N	\N	0	161810	0	23426006	4052083		
46662	4297	3024561	1991-02-19	1991-02-19 00:00:00	1991-02-19	5001	0	\N	0	0	\N	\N	0	285178	0	1751-7	3024561		
1366	119	3006322	1957-02-04	1957-02-04 00:00:00	1957-02-04	5001	0	\N	0	0	\N	\N	0	7864	0	8331-1	3006322		
138757	4278	4133840	2016-11-25	2016-11-25 00:00:00	2016-11-25	5001	0	\N	0	0	\N	\N	0	283851	0	127783003	4133840		
2958	285	3001488	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	18965	0	7258-7	3001488		
6773	644	3006322	2017-05-30	2017-05-30 00:00:00	2017-05-30	5001	0	\N	0	0	\N	\N	0	42647	0	8331-1	3006322		
113016	3488	4052083	2000-01-19	2000-01-19 00:00:00	2000-01-19	5001	0	\N	0	0	\N	\N	0	231416	0	23426006	4052083		
118252	3639	4052083	1994-03-15	1994-03-15 00:00:00	1994-03-15	5001	0	\N	0	0	\N	\N	0	242160	0	23426006	4052083		
52866	4852	46235214	1997-01-22	1997-01-22 00:00:00	1997-01-22	5001	0	\N	0	0	\N	\N	0	322776	0	76690-7	46235214		
171843	5274	4024958	1954-11-26	1954-11-26 00:00:00	1954-11-26	5001	0	\N	0	0	\N	\N	0	350822	0	117015009	4024958		
27759	2554	3006322	2017-08-16	2017-08-16 00:00:00	2017-08-16	5001	0	\N	0	0	\N	\N	0	169202	0	8331-1	3006322		
37321	3444	3006322	2003-03-13	2003-03-13 00:00:00	2003-03-13	5001	0	\N	0	0	\N	\N	0	228587	0	8331-1	3006322		
64890	1990	4024958	1975-07-09	1975-07-09 00:00:00	1975-07-09	5001	0	\N	0	0	\N	\N	0	132536	0	117015009	4024958		
22777	2088	3011505	1979-09-04	1979-09-04 00:00:00	1979-09-04	5001	0	\N	0	0	\N	\N	0	139253	0	19926-5	3011505		
79925	2461	4024958	1984-04-23	1984-04-23 00:00:00	1984-04-23	5001	0	\N	0	0	\N	\N	0	163181	0	117015009	4024958		
22674	2077	3015076	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	138304	0	6248-9	3015076		
1975	180	3000876	1980-05-17	1980-05-17 00:00:00	1980-05-17	5001	0	\N	0	0	\N	\N	0	12198	0	6082-2	3000876		
100719	3092	4024958	1970-07-20	1970-07-20 00:00:00	1970-07-20	5001	0	\N	0	0	\N	\N	0	205865	0	117015009	4024958		
171238	5253	4133840	2005-12-10	2005-12-10 00:00:00	2005-12-10	5001	0	\N	0	0	\N	\N	0	349566	0	127783003	4133840		
49134	4491	3006322	2005-07-17	2005-07-17 00:00:00	2005-07-17	5001	0	\N	0	0	\N	\N	0	298943	0	8331-1	3006322		
69789	2138	4052083	1994-09-16	1994-09-16 00:00:00	1994-09-16	5001	0	\N	0	0	\N	\N	0	142377	0	23426006	4052083		
25749	2359	3006322	1926-10-10	1926-10-10 00:00:00	1926-10-10	5001	0	\N	0	0	\N	\N	0	157268	0	8331-1	3006322		
38760	3582	3049273	2014-12-17	2014-12-17 00:00:00	2014-12-17	5001	0	\N	0	0	\N	\N	0	238126	0	38265-5	3049273		
51475	4715	3006322	2016-12-27	2016-12-27 00:00:00	2016-12-27	5001	0	\N	0	0	\N	\N	0	313930	0	8331-1	3006322		
95068	2919	4133840	2016-12-10	2016-12-10 00:00:00	2016-12-10	5001	0	\N	0	0	\N	\N	0	194627	0	127783003	4133840		
31978	2915	3027231	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	194256	0	6276-0	3027231		
8786	843	3012494	1998-11-07	1998-11-07 00:00:00	1998-11-07	5001	0	\N	0	0	\N	\N	0	55792	0	6206-7	3012494		
117323	3616	4024958	1967-02-09	1967-02-09 00:00:00	1967-02-09	5001	0	\N	0	0	\N	\N	0	240270	0	117015009	4024958		
14685	458	4024958	1974-04-09	1974-04-09 00:00:00	1974-04-09	5001	0	\N	0	0	\N	\N	0	30614	0	117015009	4024958		
108528	3352	4133840	2006-11-03	2006-11-03 00:00:00	2006-11-03	5001	0	\N	0	0	\N	\N	0	222267	0	127783003	4133840		
30107	2770	3012494	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	183401	0	6206-7	3012494		
4206	129	4024958	2002-09-07	2002-09-07 00:00:00	2002-09-07	5001	0	\N	0	0	\N	\N	0	8672	0	117015009	4024958		
3114	299	40766240	1963-12-04	1963-12-04 00:00:00	1963-12-04	5001	0	\N	0	0	\N	\N	0	20015	0	63513-6	40766240		
23641	742	4133840	1990-04-09	1990-04-09 00:00:00	1990-04-09	5001	0	\N	0	0	\N	\N	0	49116	0	127783003	4133840		
113172	3494	4133840	2005-07-21	2005-07-21 00:00:00	2005-07-21	5001	0	\N	0	0	\N	\N	0	231763	0	127783003	4133840		
152138	4661	4024958	2013-04-10	2013-04-10 00:00:00	2013-04-10	5001	0	\N	0	0	\N	\N	0	310676	0	117015009	4024958		
44588	4117	3006322	1964-05-10	1964-05-10 00:00:00	1964-05-10	5001	0	\N	0	0	\N	\N	0	273690	0	8331-1	3006322		
13691	1285	3027231	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	84976	0	6276-0	3027231		
6214	580	3006322	2017-05-27	2017-05-27 00:00:00	2017-05-27	5001	0	\N	0	0	\N	\N	0	38460	0	8331-1	3006322		
16600	1513	3015076	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	101053	0	6248-9	3015076		
33998	3096	3006322	1968-05-02	1968-05-02 00:00:00	1968-05-02	5001	0	\N	0	0	\N	\N	0	206100	0	8331-1	3006322		
43999	4064	3001247	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	270013	0	6085-5	3001247		
12945	410	4052083	2010-09-26	2010-09-26 00:00:00	2010-09-26	5001	0	\N	0	0	\N	\N	0	27219	0	23426006	4052083		
51869	4759	3006322	1992-05-21	1992-05-21 00:00:00	1992-05-21	5001	0	\N	0	0	\N	\N	0	317060	0	8331-1	3006322		
46154	4256	3002385	1963-11-14	1963-11-14 00:00:00	1963-11-14	5001	0	\N	0	0	\N	\N	0	282589	0	30385-9	3002385		
48108	4412	3006322	1982-10-17	1982-10-17 00:00:00	1982-10-17	5001	0	\N	0	0	\N	\N	0	293341	0	8331-1	3006322		
28654	2654	3006322	1985-06-09	1985-06-09 00:00:00	1985-06-09	5001	0	\N	0	0	\N	\N	0	175702	0	8331-1	3006322		
8496	807	3051031	1952-06-14	1952-06-14 00:00:00	1952-06-14	5001	0	\N	0	0	\N	\N	0	53558	0	46240-8	3051031		
40101	3736	3006322	1964-06-09	1964-06-09 00:00:00	1964-06-09	5001	0	\N	0	0	\N	\N	0	248312	0	8331-1	3006322		
40176	3744	46235214	1971-01-27	1971-01-27 00:00:00	1971-01-27	5001	0	\N	0	0	\N	\N	0	248739	0	76690-7	46235214		
49596	4514	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	300640	0	6189-5	3006734		
2631	81	4024958	1967-05-19	1967-05-19 00:00:00	1967-05-19	5001	0	\N	0	0	\N	\N	0	5482	0	117015009	4024958		
10686	338	4024958	2006-02-20	2006-02-20 00:00:00	2006-02-20	5001	0	\N	0	0	\N	\N	0	22528	0	117015009	4024958		
140825	4343	4024958	1960-04-23	1960-04-23 00:00:00	1960-04-23	5001	0	\N	0	0	\N	\N	0	287988	0	117015009	4024958		
18	2	3006322	1969-09-18	1969-09-18 00:00:00	1969-09-18	5001	0	\N	0	0	\N	\N	0	139	0	8331-1	3006322		
9760	917	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	61073	0	6273-7	3006451		
882	69	3006322	2019-01-30	2019-01-30 00:00:00	2019-01-30	5001	0	\N	0	0	\N	\N	0	4703	0	8331-1	3006322		
8828	279	4024958	1992-03-07	1992-03-07 00:00:00	1992-03-07	5001	0	\N	0	0	\N	\N	0	18654	0	117015009	4024958		
12325	1175	3023430	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	77451	0	6833-8	3023430		
23661	2175	3051031	1977-07-27	1977-07-27 00:00:00	1977-07-27	5001	0	\N	0	0	\N	\N	0	144998	0	46240-8	3051031		
1730	152	3010813	1973-12-15	1973-12-15 00:00:00	1973-12-15	5001	0	\N	0	0	\N	\N	0	10291	0	26464-8	3010813		
7695	742	46235214	1934-05-13	1934-05-13 00:00:00	1934-05-13	5001	0	\N	0	0	\N	\N	0	49136	0	76690-7	46235214		
7000	670	3006322	2012-03-25	2012-03-25 00:00:00	2012-03-25	5001	0	\N	0	0	\N	\N	0	44204	0	8331-1	3006322		
19109	1751	3006322	2011-05-15	2011-05-15 00:00:00	2011-05-15	5001	0	\N	0	0	\N	\N	0	117049	0	8331-1	3006322		
68197	2087	4024958	1983-03-09	1983-03-09 00:00:00	1983-03-09	5001	0	\N	0	0	\N	\N	0	139007	0	117015009	4024958		
46663	4297	3026361	1991-02-19	1991-02-19 00:00:00	1991-02-19	5001	0	\N	0	0	\N	\N	0	285178	0	26453-1	3026361		
1367	119	3006322	1956-03-29	1956-03-29 00:00:00	1956-03-29	5001	0	\N	0	0	\N	\N	0	7863	0	8331-1	3006322		
138762	4278	4133840	2014-11-14	2014-11-14 00:00:00	2014-11-14	5001	0	\N	0	0	\N	\N	0	283850	0	127783003	4133840		
2959	285	3021226	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	18965	0	6246-3	3021226		
6774	644	3006322	2011-09-20	2011-09-20 00:00:00	2011-09-20	5001	0	\N	0	0	\N	\N	0	42646	0	8331-1	3006322		
113018	3488	4133840	2011-03-18	2011-03-18 00:00:00	2011-03-18	5001	0	\N	0	0	\N	\N	0	231371	0	127783003	4133840		
118253	3639	4052083	1964-10-17	1964-10-17 00:00:00	1964-10-17	5001	0	\N	0	0	\N	\N	0	242126	0	23426006	4052083		
52867	4852	3051031	1997-01-22	1997-01-22 00:00:00	1997-01-22	5001	0	\N	0	0	\N	\N	0	322776	0	46240-8	3051031		
171857	5276	4024958	1981-04-18	1981-04-18 00:00:00	1981-04-18	5001	0	\N	0	0	\N	\N	0	350925	0	117015009	4024958		
27760	2554	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	169125	0	6246-3	3021226		
37322	3444	3006322	1955-01-18	1955-01-18 00:00:00	1955-01-18	5001	0	\N	0	0	\N	\N	0	228519	0	8331-1	3006322		
64892	1990	4052083	2011-06-28	2011-06-28 00:00:00	2011-06-28	5001	0	\N	0	0	\N	\N	0	132538	0	23426006	4052083		
22778	2088	3006322	1941-04-17	1941-04-17 00:00:00	1941-04-17	5001	0	\N	0	0	\N	\N	0	139169	0	8331-1	3006322		
79937	2461	4024958	1987-08-17	1987-08-17 00:00:00	1987-08-17	5001	0	\N	0	0	\N	\N	0	163182	0	117015009	4024958		
22675	2077	3021226	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	138304	0	6246-3	3021226		
1976	180	3006734	1980-05-17	1980-05-17 00:00:00	1980-05-17	5001	0	\N	0	0	\N	\N	0	12198	0	6189-5	3006734		
78215	2396	4024958	1958-07-03	1958-07-03 00:00:00	1958-07-03	5001	0	\N	0	0	\N	\N	0	159295	0	117015009	4024958		
171239	5253	4133840	1997-12-20	1997-12-20 00:00:00	1997-12-20	5001	0	\N	0	0	\N	\N	0	349537	0	127783003	4133840		
49135	4491	3006322	1957-02-18	1957-02-18 00:00:00	1957-02-18	5001	0	\N	0	0	\N	\N	0	299015	0	8331-1	3006322		
69791	2138	4024958	1964-09-03	1964-09-03 00:00:00	1964-09-03	5001	0	\N	0	0	\N	\N	0	142374	0	117015009	4024958		
25750	2359	3049273	1995-06-07	1995-06-07 00:00:00	1995-06-07	5001	0	\N	0	0	\N	\N	0	157238	0	38265-5	3049273		
38761	3582	3011505	2007-06-03	2007-06-03 00:00:00	2007-06-03	5001	0	\N	0	0	\N	\N	0	238132	0	19926-5	3011505		
51476	4715	3006322	1962-07-09	1962-07-09 00:00:00	1962-07-09	5001	0	\N	0	0	\N	\N	0	313925	0	8331-1	3006322		
95070	2919	4133840	2015-12-05	2015-12-05 00:00:00	2015-12-05	5001	0	\N	0	0	\N	\N	0	194621	0	127783003	4133840		
31979	2915	3012494	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	194256	0	6206-7	3012494		
8787	843	3020655	1998-11-07	1998-11-07 00:00:00	1998-11-07	5001	0	\N	0	0	\N	\N	0	55792	0	6844-5	3020655		
117329	3616	4024958	1970-08-18	1970-08-18 00:00:00	1970-08-18	5001	0	\N	0	0	\N	\N	0	240298	0	117015009	4024958		
14691	458	4024958	1986-05-18	1986-05-18 00:00:00	1986-05-18	5001	0	\N	0	0	\N	\N	0	30666	0	117015009	4024958		
108530	3352	4133840	2014-10-24	2014-10-24 00:00:00	2014-10-24	5001	0	\N	0	0	\N	\N	0	222322	0	127783003	4133840		
30108	2770	3014599	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	183401	0	6106-9	3014599		
165188	5073	4052083	1970-03-08	1970-03-08 00:00:00	1970-03-08	5001	0	\N	0	0	\N	\N	0	337246	0	23426006	4052083		
3115	299	46235214	1963-12-04	1963-12-04 00:00:00	1963-12-04	5001	0	\N	0	0	\N	\N	0	20015	0	76690-7	46235214		
23642	742	4133840	1992-04-20	1992-04-20 00:00:00	1992-04-20	5001	0	\N	0	0	\N	\N	0	49117	0	127783003	4133840		
113174	3494	4024958	1970-07-20	1970-07-20 00:00:00	1970-07-20	5001	0	\N	0	0	\N	\N	0	231779	0	117015009	4024958		
163430	5023	4024958	2010-01-20	2010-01-20 00:00:00	2010-01-20	5001	0	\N	0	0	\N	\N	0	333778	0	117015009	4024958		
44589	4117	3006322	2017-10-18	2017-10-18 00:00:00	2017-10-18	5001	0	\N	0	0	\N	\N	0	273716	0	8331-1	3006322		
13692	1285	3020655	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	84976	0	6844-5	3020655		
6216	582	3006322	1966-08-26	1966-08-26 00:00:00	1966-08-26	5001	0	\N	0	0	\N	\N	0	38536	0	8331-1	3006322		
16601	1513	3006451	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	101053	0	6273-7	3006451		
33999	3096	3006322	1999-03-15	1999-03-15 00:00:00	1999-03-15	5001	0	\N	0	0	\N	\N	0	206053	0	8331-1	3006322		
44000	4064	3015076	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	270013	0	6248-9	3015076		
18429	1689	3006322	1963-02-07	1963-02-07 00:00:00	1963-02-07	5001	0	\N	0	0	\N	\N	0	113079	0	8331-1	3006322		
51870	4759	3006322	1986-06-30	1986-06-30 00:00:00	1986-06-30	5001	0	\N	0	0	\N	\N	0	317040	0	8331-1	3006322		
46155	4256	3007461	1963-11-14	1963-11-14 00:00:00	1963-11-14	5001	0	\N	0	0	\N	\N	0	282589	0	26515-7	3007461		
48109	4412	3006322	2013-05-29	2013-05-29 00:00:00	2013-05-29	5001	0	\N	0	0	\N	\N	0	293388	0	8331-1	3006322		
28655	2654	3006322	1951-08-27	1951-08-27 00:00:00	1951-08-27	5001	0	\N	0	0	\N	\N	0	175658	0	8331-1	3006322		
8497	807	40758406	1952-06-14	1952-06-14 00:00:00	1952-06-14	5001	0	\N	0	0	\N	\N	0	53558	0	55277-8	40758406		
40102	3736	3006322	1967-09-16	1967-09-16 00:00:00	1967-09-16	5001	0	\N	0	0	\N	\N	0	248347	0	8331-1	3006322		
40177	3744	40758406	1971-01-27	1971-01-27 00:00:00	1971-01-27	5001	0	\N	0	0	\N	\N	0	248739	0	55277-8	40758406		
49597	4514	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	300640	0	6206-7	3012494		
2638	81	4024958	2003-06-11	2003-06-11 00:00:00	2003-06-11	5001	0	\N	0	0	\N	\N	0	5486	0	117015009	4024958		
10701	338	4052083	2003-10-21	2003-10-21 00:00:00	2003-10-21	5001	0	\N	0	0	\N	\N	0	22541	0	23426006	4052083		
140833	4343	4024958	1989-03-11	1989-03-11 00:00:00	1989-03-11	5001	0	\N	0	0	\N	\N	0	287993	0	117015009	4024958		
19	2	3006322	1984-08-14	1984-08-14 00:00:00	1984-08-14	5001	0	\N	0	0	\N	\N	0	91	0	8331-1	3006322		
9761	917	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	61073	0	6248-9	3015076		
883	70	3006322	1958-10-31	1958-10-31 00:00:00	1958-10-31	5001	0	\N	0	0	\N	\N	0	4770	0	8331-1	3006322		
8829	279	4052083	1965-12-05	1965-12-05 00:00:00	1965-12-05	5001	0	\N	0	0	\N	\N	0	18633	0	23426006	4052083		
12326	1175	3001247	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	77451	0	6085-5	3001247		
23662	2175	40766240	1977-07-27	1977-07-27 00:00:00	1977-07-27	5001	0	\N	0	0	\N	\N	0	144998	0	63513-6	40766240		
1731	152	3006322	1976-04-11	1976-04-11 00:00:00	1976-04-11	5001	0	\N	0	0	\N	\N	0	10241	0	8331-1	3006322		
7697	742	40766240	1934-05-13	1934-05-13 00:00:00	1934-05-13	5001	0	\N	0	0	\N	\N	0	49136	0	63513-6	40766240		
7001	672	3006322	1982-05-24	1982-05-24 00:00:00	1982-05-24	5001	0	\N	0	0	\N	\N	0	44371	0	8331-1	3006322		
19110	1751	3006322	1985-06-20	1985-06-20 00:00:00	1985-06-20	5001	0	\N	0	0	\N	\N	0	117098	0	8331-1	3006322		
79479	2444	4024958	1960-02-16	1960-02-16 00:00:00	1960-02-16	5001	0	\N	0	0	\N	\N	0	162102	0	117015009	4024958		
46664	4297	3019550	1991-02-19	1991-02-19 00:00:00	1991-02-19	5001	0	\N	0	0	\N	\N	0	285178	0	2951-2	3019550		
1368	120	3006322	1988-04-28	1988-04-28 00:00:00	1988-04-28	5001	0	\N	0	0	\N	\N	0	7974	0	8331-1	3006322		
138765	4278	4133840	2013-11-08	2013-11-08 00:00:00	2013-11-08	5001	0	\N	0	0	\N	\N	0	283867	0	127783003	4133840		
2960	285	3027231	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	18965	0	6276-0	3027231		
6775	644	3006322	1987-06-04	1987-06-04 00:00:00	1987-06-04	5001	0	\N	0	0	\N	\N	0	42644	0	8331-1	3006322		
113020	3488	4133840	2013-03-29	2013-03-29 00:00:00	2013-03-29	5001	0	\N	0	0	\N	\N	0	231372	0	127783003	4133840		
118286	3641	4024958	1913-10-30	1913-10-30 00:00:00	1913-10-30	5001	0	\N	0	0	\N	\N	0	242253	0	117015009	4024958		
52868	4852	3006322	1995-04-23	1995-04-23 00:00:00	1995-04-23	5001	0	\N	0	0	\N	\N	0	322855	0	8331-1	3006322		
69182	2122	4052083	2011-07-15	2011-07-15 00:00:00	2011-07-15	5001	0	\N	0	0	\N	\N	0	141196	0	23426006	4052083		
27761	2554	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	169125	0	6206-7	3012494		
37323	3444	3006322	1954-02-10	1954-02-10 00:00:00	1954-02-10	5001	0	\N	0	0	\N	\N	0	228615	0	8331-1	3006322		
64893	1990	4024958	2002-11-28	2002-11-28 00:00:00	2002-11-28	5001	0	\N	0	0	\N	\N	0	132487	0	117015009	4024958		
22779	2088	3011505	1995-05-09	1995-05-09 00:00:00	1995-05-09	5001	0	\N	0	0	\N	\N	0	139279	0	19926-5	3011505		
79940	2461	4052083	1991-02-24	1991-02-24 00:00:00	1991-02-24	5001	0	\N	0	0	\N	\N	0	163143	0	23426006	4052083		
22676	2077	3001247	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	138304	0	6085-5	3001247		
1977	180	3036780	1980-05-17	1980-05-17 00:00:00	1980-05-17	5001	0	\N	0	0	\N	\N	0	12198	0	6095-4	3036780		
89516	2770	4024958	1933-11-22	1933-11-22 00:00:00	1933-11-22	5001	0	\N	0	0	\N	\N	0	183331	0	117015009	4024958		
171240	5253	4133840	2001-12-29	2001-12-29 00:00:00	2001-12-29	5001	0	\N	0	0	\N	\N	0	349558	0	127783003	4133840		
49136	4491	3006322	2003-05-15	2003-05-15 00:00:00	2003-05-15	5001	0	\N	0	0	\N	\N	0	298942	0	8331-1	3006322		
81120	2504	4024958	1971-05-06	1971-05-06 00:00:00	1971-05-06	5001	0	\N	0	0	\N	\N	0	165774	0	117015009	4024958		
25751	2359	3006322	1945-10-12	1945-10-12 00:00:00	1945-10-12	5001	0	\N	0	0	\N	\N	0	157176	0	8331-1	3006322		
38762	3582	3011505	2010-06-20	2010-06-20 00:00:00	2010-06-20	5001	0	\N	0	0	\N	\N	0	238118	0	19926-5	3011505		
51477	4715	3006322	1983-12-26	1983-12-26 00:00:00	1983-12-26	5001	0	\N	0	0	\N	\N	0	313958	0	8331-1	3006322		
95071	2919	4024958	1975-04-13	1975-04-13 00:00:00	1975-04-13	5001	0	\N	0	0	\N	\N	0	194588	0	117015009	4024958		
31980	2915	3014599	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	194256	0	6106-9	3014599		
8788	843	3023430	1998-11-07	1998-11-07 00:00:00	1998-11-07	5001	0	\N	0	0	\N	\N	0	55792	0	6833-8	3023430		
117336	3616	4052083	2012-03-15	2012-03-15 00:00:00	2012-03-15	5001	0	\N	0	0	\N	\N	0	240303	0	23426006	4052083		
14698	459	4024958	1998-08-25	1998-08-25 00:00:00	1998-08-25	5001	0	\N	0	0	\N	\N	0	30706	0	117015009	4024958		
108531	3352	4133840	2018-11-16	2018-11-16 00:00:00	2018-11-16	5001	0	\N	0	0	\N	\N	0	222282	0	127783003	4133840		
30109	2770	3027231	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	183401	0	6276-0	3027231		
165191	5073	4024958	1959-09-29	1959-09-29 00:00:00	1959-09-29	5001	0	\N	0	0	\N	\N	0	337194	0	117015009	4024958		
3116	299	40758406	1963-12-04	1963-12-04 00:00:00	1963-12-04	5001	0	\N	0	0	\N	\N	0	20015	0	55277-8	40758406		
23644	742	4133840	2002-06-17	2002-06-17 00:00:00	2002-06-17	5001	0	\N	0	0	\N	\N	0	49103	0	127783003	4133840		
113177	3494	4133840	2018-11-29	2018-11-29 00:00:00	2018-11-29	5001	0	\N	0	0	\N	\N	0	231739	0	127783003	4133840		
49078	1497	4052083	1979-05-21	1979-05-21 00:00:00	1979-05-21	5001	0	\N	0	0	\N	\N	0	99766	0	23426006	4052083		
44590	4117	3006322	1966-04-11	1966-04-11 00:00:00	1966-04-11	5001	0	\N	0	0	\N	\N	0	273736	0	8331-1	3006322		
33435	3025	3005136	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	201615	0	6075-6	3005136		
6217	582	3006322	2004-04-11	2004-04-11 00:00:00	2004-04-11	5001	0	\N	0	0	\N	\N	0	38572	0	8331-1	3006322		
16602	1513	3012494	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	101053	0	6206-7	3012494		
34000	3096	3006322	2019-02-07	2019-02-07 00:00:00	2019-02-07	5001	0	\N	0	0	\N	\N	0	206095	0	8331-1	3006322		
44001	4064	3021226	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	270013	0	6246-3	3021226		
18430	1689	3006322	1984-02-12	1984-02-12 00:00:00	1984-02-12	5001	0	\N	0	0	\N	\N	0	113107	0	8331-1	3006322		
51871	4759	3006322	1990-09-21	1990-09-21 00:00:00	1990-09-21	5001	0	\N	0	0	\N	\N	0	317059	0	8331-1	3006322		
46156	4256	3045716	1963-11-14	1963-11-14 00:00:00	1963-11-14	5001	0	\N	0	0	\N	\N	0	282589	0	33037-3	3045716		
48110	4413	3006322	1966-06-04	1966-06-04 00:00:00	1966-06-04	5001	0	\N	0	0	\N	\N	0	293454	0	8331-1	3006322		
28656	2654	3049273	2010-03-09	2010-03-09 00:00:00	2010-03-09	5001	0	\N	0	0	\N	\N	0	175727	0	38265-5	3049273		
8498	807	3006322	1967-03-26	1967-03-26 00:00:00	1967-03-26	5001	0	\N	0	0	\N	\N	0	53559	0	8331-1	3006322		
40103	3736	3006322	1954-09-20	1954-09-20 00:00:00	1954-09-20	5001	0	\N	0	0	\N	\N	0	248271	0	8331-1	3006322		
40178	3744	3051031	1971-01-27	1971-01-27 00:00:00	1971-01-27	5001	0	\N	0	0	\N	\N	0	248739	0	46240-8	3051031		
49598	4514	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	300640	0	6095-4	3036780		
2641	81	4024958	1963-09-14	1963-09-14 00:00:00	1963-09-14	5001	0	\N	0	0	\N	\N	0	5529	0	117015009	4024958		
10714	338	4024958	1968-06-16	1968-06-16 00:00:00	1968-06-16	5001	0	\N	0	0	\N	\N	0	22565	0	117015009	4024958		
140834	4343	4024958	1974-06-03	1974-06-03 00:00:00	1974-06-03	5001	0	\N	0	0	\N	\N	0	287990	0	117015009	4024958		
20	2	3011505	1996-07-02	1996-07-02 00:00:00	1996-07-02	5001	0	\N	0	0	\N	\N	0	134	0	19926-5	3011505		
9762	917	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	61073	0	6206-7	3012494		
884	70	3006322	1948-08-11	1948-08-11 00:00:00	1948-08-11	5001	0	\N	0	0	\N	\N	0	4762	0	8331-1	3006322		
8844	280	4024958	1982-10-09	1982-10-09 00:00:00	1982-10-09	5001	0	\N	0	0	\N	\N	0	18764	0	117015009	4024958		
12327	1175	3001488	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	77451	0	7258-7	3001488		
23663	2175	40758406	1977-07-27	1977-07-27 00:00:00	1977-07-27	5001	0	\N	0	0	\N	\N	0	144998	0	55277-8	40758406		
1732	152	3019550	1973-12-15	1973-12-15 00:00:00	1973-12-15	5001	0	\N	0	0	\N	\N	0	10291	0	2951-2	3019550		
74813	2294	4024958	1990-10-08	1990-10-08 00:00:00	1990-10-08	5001	0	\N	0	0	\N	\N	0	152704	0	117015009	4024958		
7002	672	3006322	1996-09-28	1996-09-28 00:00:00	1996-09-28	5001	0	\N	0	0	\N	\N	0	44394	0	8331-1	3006322		
19111	1752	3006322	2009-08-08	2009-08-08 00:00:00	2009-08-08	5001	0	\N	0	0	\N	\N	0	117122	0	8331-1	3006322		
79507	2445	4024958	1931-11-14	1931-11-14 00:00:00	1931-11-14	5001	0	\N	0	0	\N	\N	0	162254	0	117015009	4024958		
46665	4297	3000963	1991-02-19	1991-02-19 00:00:00	1991-02-19	5001	0	\N	0	0	\N	\N	0	285178	0	718-7	3000963		
1369	120	3006322	1981-08-22	1981-08-22 00:00:00	1981-08-22	5001	0	\N	0	0	\N	\N	0	8001	0	8331-1	3006322		
138766	4278	4024958	1963-11-27	1963-11-27 00:00:00	1963-11-27	5001	0	\N	0	0	\N	\N	0	283904	0	117015009	4024958		
2961	285	3019406	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	18965	0	6158-0	3019406		
6776	644	3006322	1978-08-08	1978-08-08 00:00:00	1978-08-08	5001	0	\N	0	0	\N	\N	0	42655	0	8331-1	3006322		
113022	3488	4133840	1991-08-02	1991-08-02 00:00:00	1991-08-02	5001	0	\N	0	0	\N	\N	0	231343	0	127783003	4133840		
118295	3641	4024958	1943-11-18	1943-11-18 00:00:00	1943-11-18	5001	0	\N	0	0	\N	\N	0	242323	0	117015009	4024958		
52869	4852	40758406	1997-05-23	1997-05-23 00:00:00	1997-05-23	5001	0	\N	0	0	\N	\N	0	322762	0	55277-8	40758406		
69184	2122	4024958	1987-10-27	1987-10-27 00:00:00	1987-10-27	5001	0	\N	0	0	\N	\N	0	141195	0	117015009	4024958		
27762	2554	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	169125	0	6248-9	3015076		
37324	3444	3006322	1961-07-06	1961-07-06 00:00:00	1961-07-06	5001	0	\N	0	0	\N	\N	0	228521	0	8331-1	3006322		
64898	1990	4024958	1968-07-01	1968-07-01 00:00:00	1968-07-01	5001	0	\N	0	0	\N	\N	0	132491	0	117015009	4024958		
22780	2088	3011505	2014-07-15	2014-07-15 00:00:00	2014-07-15	5001	0	\N	0	0	\N	\N	0	139291	0	19926-5	3011505		
79944	2461	4024958	1984-03-15	1984-03-15 00:00:00	1984-03-15	5001	0	\N	0	0	\N	\N	0	163180	0	117015009	4024958		
22677	2077	3006451	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	138304	0	6273-7	3006451		
1978	180	3006322	1999-02-28	1999-02-28 00:00:00	1999-02-28	5001	0	\N	0	0	\N	\N	0	12188	0	8331-1	3006322		
89533	2770	4024958	1940-11-21	1940-11-21 00:00:00	1940-11-21	5001	0	\N	0	0	\N	\N	0	183309	0	117015009	4024958		
102819	3161	4024958	1953-04-06	1953-04-06 00:00:00	1953-04-06	5001	0	\N	0	0	\N	\N	0	210242	0	117015009	4024958		
49137	4491	3006322	1995-04-18	1995-04-18 00:00:00	1995-04-18	5001	0	\N	0	0	\N	\N	0	299019	0	8331-1	3006322		
81123	2504	4052083	1970-12-28	1970-12-28 00:00:00	1970-12-28	5001	0	\N	0	0	\N	\N	0	165773	0	23426006	4052083		
25752	2359	3006322	2017-03-28	2017-03-28 00:00:00	2017-03-28	5001	0	\N	0	0	\N	\N	0	157272	0	8331-1	3006322		
38763	3582	3011505	2015-07-19	2015-07-19 00:00:00	2015-07-19	5001	0	\N	0	0	\N	\N	0	238153	0	19926-5	3011505		
51478	4715	3006322	2014-08-30	2014-08-30 00:00:00	2014-08-30	5001	0	\N	0	0	\N	\N	0	313899	0	8331-1	3006322		
95074	2919	4133840	2018-12-22	2018-12-22 00:00:00	2018-12-22	5001	0	\N	0	0	\N	\N	0	194628	0	127783003	4133840		
31981	2915	3006451	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	194256	0	6273-7	3006451		
8789	843	3001247	1998-11-07	1998-11-07 00:00:00	1998-11-07	5001	0	\N	0	0	\N	\N	0	55792	0	6085-5	3001247		
117635	3622	4052083	2005-01-23	2005-01-23 00:00:00	2005-01-23	5001	0	\N	0	0	\N	\N	0	240678	0	23426006	4052083		
14712	459	4052083	1985-02-15	1985-02-15 00:00:00	1985-02-15	5001	0	\N	0	0	\N	\N	0	30672	0	23426006	4052083		
108533	3352	4133840	1998-12-18	1998-12-18 00:00:00	1998-12-18	5001	0	\N	0	0	\N	\N	0	222303	0	127783003	4133840		
30110	2770	3001488	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	183401	0	7258-7	3001488		
165216	5073	4024958	1941-01-12	1941-01-12 00:00:00	1941-01-12	5001	0	\N	0	0	\N	\N	0	337193	0	117015009	4024958		
3117	299	3006322	1965-10-29	1965-10-29 00:00:00	1965-10-29	5001	0	\N	0	0	\N	\N	0	20022	0	8331-1	3006322		
23646	742	4133840	2009-07-27	2009-07-27 00:00:00	2009-07-27	5001	0	\N	0	0	\N	\N	0	49184	0	127783003	4133840		
113178	3494	4133840	2007-07-26	2007-07-26 00:00:00	2007-07-26	5001	0	\N	0	0	\N	\N	0	231753	0	127783003	4133840		
49146	1497	4052083	1992-03-11	1992-03-11 00:00:00	1992-03-11	5001	0	\N	0	0	\N	\N	0	99800	0	23426006	4052083		
44591	4117	3006322	1970-03-02	1970-03-02 00:00:00	1970-03-02	5001	0	\N	0	0	\N	\N	0	273711	0	8331-1	3006322		
33436	3025	3001247	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	201615	0	6085-5	3001247		
6218	582	3006322	1978-08-03	1978-08-03 00:00:00	1978-08-03	5001	0	\N	0	0	\N	\N	0	38578	0	8331-1	3006322		
16603	1513	3000876	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	101053	0	6082-2	3000876		
34001	3096	3006322	2012-06-20	2012-06-20 00:00:00	2012-06-20	5001	0	\N	0	0	\N	\N	0	206055	0	8331-1	3006322		
44002	4064	3014599	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	270013	0	6106-9	3014599		
18431	1689	3006322	1960-05-15	1960-05-15 00:00:00	1960-05-15	5001	0	\N	0	0	\N	\N	0	113093	0	8331-1	3006322		
51872	4759	3006322	1997-07-05	1997-07-05 00:00:00	1997-07-05	5001	0	\N	0	0	\N	\N	0	317102	0	8331-1	3006322		
46157	4256	3023103	1963-11-14	1963-11-14 00:00:00	1963-11-14	5001	0	\N	0	0	\N	\N	0	282589	0	2823-3	3023103		
48111	4413	3006322	1986-01-20	1986-01-20 00:00:00	1986-01-20	5001	0	\N	0	0	\N	\N	0	293457	0	8331-1	3006322		
28657	2654	3006322	2011-02-20	2011-02-20 00:00:00	2011-02-20	5001	0	\N	0	0	\N	\N	0	175689	0	8331-1	3006322		
8499	807	3006322	1971-03-06	1971-03-06 00:00:00	1971-03-06	5001	0	\N	0	0	\N	\N	0	53623	0	8331-1	3006322		
40104	3739	3006322	1973-04-26	1973-04-26 00:00:00	1973-04-26	5001	0	\N	0	0	\N	\N	0	248421	0	8331-1	3006322		
40180	3744	3001488	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	248741	0	7258-7	3001488		
49599	4514	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	300640	0	6085-5	3001247		
2648	82	4024958	1970-01-05	1970-01-05 00:00:00	1970-01-05	5001	0	\N	0	0	\N	\N	0	5538	0	117015009	4024958		
30944	2832	3005136	1994-03-05	1994-03-05 00:00:00	1994-03-05	5001	0	\N	0	0	\N	\N	0	187897	0	6075-6	3005136		
140836	4343	4052083	2007-08-31	2007-08-31 00:00:00	2007-08-31	5001	0	\N	0	0	\N	\N	0	288013	0	23426006	4052083		
22	2	3051031	1934-08-27	1934-08-27 00:00:00	1934-08-27	5001	0	\N	0	0	\N	\N	0	175	0	46240-8	3051031		
9763	917	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	61073	0	6085-5	3001247		
885	70	3006322	1968-09-18	1968-09-18 00:00:00	1968-09-18	5001	0	\N	0	0	\N	\N	0	4724	0	8331-1	3006322		
8853	280	4052083	1947-08-13	1947-08-13 00:00:00	1947-08-13	5001	0	\N	0	0	\N	\N	0	18710	0	23426006	4052083		
36996	1145	4052083	2012-08-14	2012-08-14 00:00:00	2012-08-14	5001	0	\N	0	0	\N	\N	0	75571	0	23426006	4052083		
23664	2176	3006322	1975-02-19	1975-02-19 00:00:00	1975-02-19	5001	0	\N	0	0	\N	\N	0	145158	0	8331-1	3006322		
1733	152	3006322	1970-06-28	1970-06-28 00:00:00	1970-06-28	5001	0	\N	0	0	\N	\N	0	10275	0	8331-1	3006322		
635	16	4052083	1985-03-05	1985-03-05 00:00:00	1985-03-05	5001	0	\N	0	0	\N	\N	0	1276	0	23426006	4052083		
44135	4071	3006322	1993-01-05	1993-01-05 00:00:00	1993-01-05	5001	0	\N	0	0	\N	\N	0	270626	0	8331-1	3006322		
19112	1752	3006322	2001-07-06	2001-07-06 00:00:00	2001-07-06	5001	0	\N	0	0	\N	\N	0	117111	0	8331-1	3006322		
79522	2445	4024958	1940-06-02	1940-06-02 00:00:00	1940-06-02	5001	0	\N	0	0	\N	\N	0	162256	0	117015009	4024958		
46666	4297	3015632	1991-02-19	1991-02-19 00:00:00	1991-02-19	5001	0	\N	0	0	\N	\N	0	285178	0	2028-9	3015632		
1370	120	3006322	2019-05-30	2019-05-30 00:00:00	2019-05-30	5001	0	\N	0	0	\N	\N	0	8008	0	8331-1	3006322		
138768	4278	4024958	1955-11-25	1955-11-25 00:00:00	1955-11-25	5001	0	\N	0	0	\N	\N	0	283902	0	117015009	4024958		
2962	285	3005136	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	18965	0	6075-6	3005136		
6777	644	3006322	2001-08-02	2001-08-02 00:00:00	2001-08-02	5001	0	\N	0	0	\N	\N	0	42613	0	8331-1	3006322		
113024	3488	4133840	2002-02-01	2002-02-01 00:00:00	2002-02-01	5001	0	\N	0	0	\N	\N	0	231399	0	127783003	4133840		
118303	3641	4024958	1978-02-07	1978-02-07 00:00:00	1978-02-07	5001	0	\N	0	0	\N	\N	0	242338	0	117015009	4024958		
52871	4852	3051031	1997-05-23	1997-05-23 00:00:00	1997-05-23	5001	0	\N	0	0	\N	\N	0	322762	0	46240-8	3051031		
69187	2122	4052083	1982-03-09	1982-03-09 00:00:00	1982-03-09	5001	0	\N	0	0	\N	\N	0	141188	0	23426006	4052083		
27763	2554	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	169125	0	6158-0	3019406		
37325	3444	3006322	1962-09-15	1962-09-15 00:00:00	1962-09-15	5001	0	\N	0	0	\N	\N	0	228564	0	8331-1	3006322		
64903	1990	4024958	1995-03-12	1995-03-12 00:00:00	1995-03-12	5001	0	\N	0	0	\N	\N	0	132485	0	117015009	4024958		
22781	2088	3011505	1971-12-07	1971-12-07 00:00:00	1971-12-07	5001	0	\N	0	0	\N	\N	0	139310	0	19926-5	3011505		
79957	2462	4024958	1964-09-25	1964-09-25 00:00:00	1964-09-25	5001	0	\N	0	0	\N	\N	0	163292	0	117015009	4024958		
22679	2077	40769179	1958-03-29	1958-03-29 00:00:00	1958-03-29	5001	0	\N	0	0	\N	\N	0	138268	0	66519-0	40769179		
1979	180	3006322	1983-09-28	1983-09-28 00:00:00	1983-09-28	5001	0	\N	0	0	\N	\N	0	12163	0	8331-1	3006322		
89550	2770	4052083	1952-01-28	1952-01-28 00:00:00	1952-01-28	5001	0	\N	0	0	\N	\N	0	183397	0	23426006	4052083		
102821	3161	4052083	1990-04-26	1990-04-26 00:00:00	1990-04-26	5001	0	\N	0	0	\N	\N	0	210214	0	23426006	4052083		
49138	4491	3049273	2006-07-09	2006-07-09 00:00:00	2006-07-09	5001	0	\N	0	0	\N	\N	0	299006	0	38265-5	3049273		
81129	2504	4024958	1957-12-06	1957-12-06 00:00:00	1957-12-06	5001	0	\N	0	0	\N	\N	0	165813	0	117015009	4024958		
88693	2747	4024958	1995-09-30	1995-09-30 00:00:00	1995-09-30	5001	0	\N	0	0	\N	\N	0	181694	0	117015009	4024958		
38764	3582	3011505	2014-07-13	2014-07-13 00:00:00	2014-07-13	5001	0	\N	0	0	\N	\N	0	238106	0	19926-5	3011505		
76168	2337	4052083	2016-09-11	2016-09-11 00:00:00	2016-09-11	5001	0	\N	0	0	\N	\N	0	155524	0	23426006	4052083		
95080	2919	4024958	1959-06-07	1959-06-07 00:00:00	1959-06-07	5001	0	\N	0	0	\N	\N	0	194601	0	117015009	4024958		
31982	2915	3020655	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	194256	0	6844-5	3020655		
8790	843	3006734	1998-11-07	1998-11-07 00:00:00	1998-11-07	5001	0	\N	0	0	\N	\N	0	55792	0	6189-5	3006734		
117687	3623	4024958	1982-04-10	1982-04-10 00:00:00	1982-04-10	5001	0	\N	0	0	\N	\N	0	240888	0	117015009	4024958		
14713	459	4024958	1995-05-03	1995-05-03 00:00:00	1995-05-03	5001	0	\N	0	0	\N	\N	0	30679	0	117015009	4024958		
108535	3352	4133840	2001-12-21	2001-12-21 00:00:00	2001-12-21	5001	0	\N	0	0	\N	\N	0	222304	0	127783003	4133840		
30111	2770	3001247	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	183401	0	6085-5	3001247		
37910	3505	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	232384	0	6075-6	3005136		
3118	299	40758406	2003-05-23	2003-05-23 00:00:00	2003-05-23	5001	0	\N	0	0	\N	\N	0	20026	0	55277-8	40758406		
23652	742	4133840	1995-05-08	1995-05-08 00:00:00	1995-05-08	5001	0	\N	0	0	\N	\N	0	49211	0	127783003	4133840		
113180	3494	4133840	2017-11-23	2017-11-23 00:00:00	2017-11-23	5001	0	\N	0	0	\N	\N	0	231793	0	127783003	4133840		
152335	4670	4052083	1962-03-21	1962-03-21 00:00:00	1962-03-21	5001	0	\N	0	0	\N	\N	0	311192	0	23426006	4052083		
44592	4117	3006322	1996-03-26	1996-03-26 00:00:00	1996-03-26	5001	0	\N	0	0	\N	\N	0	273737	0	8331-1	3006322		
33437	3025	3001488	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	201615	0	7258-7	3001488		
6219	582	3006322	1998-05-29	1998-05-29 00:00:00	1998-05-29	5001	0	\N	0	0	\N	\N	0	38580	0	8331-1	3006322		
16604	1513	3020655	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	101053	0	6844-5	3020655		
34002	3096	3049273	2016-04-08	2016-04-08 00:00:00	2016-04-08	5001	0	\N	0	0	\N	\N	0	206080	0	38265-5	3049273		
44003	4064	3036780	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	270013	0	6095-4	3036780		
18432	1689	3006322	1967-01-02	1967-01-02 00:00:00	1967-01-02	5001	0	\N	0	0	\N	\N	0	113094	0	8331-1	3006322		
51873	4759	3006322	1998-06-12	1998-06-12 00:00:00	1998-06-12	5001	0	\N	0	0	\N	\N	0	317075	0	8331-1	3006322		
46158	4256	3020630	1963-11-14	1963-11-14 00:00:00	1963-11-14	5001	0	\N	0	0	\N	\N	0	282589	0	2885-2	3020630		
48112	4413	3006322	1998-01-15	1998-01-15 00:00:00	1998-01-15	5001	0	\N	0	0	\N	\N	0	293463	0	8331-1	3006322		
28658	2654	3006322	2007-03-29	2007-03-29 00:00:00	2007-03-29	5001	0	\N	0	0	\N	\N	0	175716	0	8331-1	3006322		
8500	807	3006322	1981-10-25	1981-10-25 00:00:00	1981-10-25	5001	0	\N	0	0	\N	\N	0	53567	0	8331-1	3006322		
40105	3739	3006322	2000-09-19	2000-09-19 00:00:00	2000-09-19	5001	0	\N	0	0	\N	\N	0	248446	0	8331-1	3006322		
40181	3744	3027231	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	248741	0	6276-0	3027231		
49600	4514	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	300640	0	6248-9	3015076		
2666	82	4024958	1978-03-03	1978-03-03 00:00:00	1978-03-03	5001	0	\N	0	0	\N	\N	0	5604	0	117015009	4024958		
30945	2832	3000876	1994-03-05	1994-03-05 00:00:00	1994-03-05	5001	0	\N	0	0	\N	\N	0	187897	0	6082-2	3000876		
140838	4343	4024958	1979-02-16	1979-02-16 00:00:00	1979-02-16	5001	0	\N	0	0	\N	\N	0	287991	0	117015009	4024958		
25	2	40766240	1934-08-27	1934-08-27 00:00:00	1934-08-27	5001	0	\N	0	0	\N	\N	0	175	0	63513-6	40766240		
9764	917	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	61073	0	7258-7	3001488		
886	70	3006322	1967-11-09	1967-11-09 00:00:00	1967-11-09	5001	0	\N	0	0	\N	\N	0	4717	0	8331-1	3006322		
158196	4860	4052083	2006-09-28	2006-09-28 00:00:00	2006-09-28	5001	0	\N	0	0	\N	\N	0	323297	0	23426006	4052083		
37003	1145	4052083	1958-04-20	1958-04-20 00:00:00	1958-04-20	5001	0	\N	0	0	\N	\N	0	75628	0	23426006	4052083		
23665	2176	3006322	1989-09-15	1989-09-15 00:00:00	1989-09-15	5001	0	\N	0	0	\N	\N	0	145141	0	8331-1	3006322		
1734	152	3006322	1969-09-16	1969-09-16 00:00:00	1969-09-16	5001	0	\N	0	0	\N	\N	0	10226	0	8331-1	3006322		
640	16	4024958	1976-09-20	1976-09-20 00:00:00	1976-09-20	5001	0	\N	0	0	\N	\N	0	1275	0	117015009	4024958		
44136	4071	3006322	1994-09-09	1994-09-09 00:00:00	1994-09-09	5001	0	\N	0	0	\N	\N	0	270566	0	8331-1	3006322		
19113	1752	3006322	2000-05-01	2000-05-01 00:00:00	2000-05-01	5001	0	\N	0	0	\N	\N	0	117121	0	8331-1	3006322		
79528	2445	4024958	1988-04-19	1988-04-19 00:00:00	1988-04-19	5001	0	\N	0	0	\N	\N	0	162189	0	117015009	4024958		
46667	4297	3013682	1991-02-19	1991-02-19 00:00:00	1991-02-19	5001	0	\N	0	0	\N	\N	0	285178	0	3094-0	3013682		
1373	123	3006322	1998-11-18	1998-11-18 00:00:00	1998-11-18	5001	0	\N	0	0	\N	\N	0	8109	0	8331-1	3006322		
138770	4278	4133840	2000-01-28	2000-01-28 00:00:00	2000-01-28	5001	0	\N	0	0	\N	\N	0	283927	0	127783003	4133840		
2963	285	3023430	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	18965	0	6833-8	3023430		
6787	648	3006322	1946-09-06	1946-09-06 00:00:00	1946-09-06	5001	0	\N	0	0	\N	\N	0	42842	0	8331-1	3006322		
113027	3488	4052083	1990-04-05	1990-04-05 00:00:00	1990-04-05	5001	0	\N	0	0	\N	\N	0	231417	0	23426006	4052083		
118306	3641	4052083	2002-01-03	2002-01-03 00:00:00	2002-01-03	5001	0	\N	0	0	\N	\N	0	242334	0	23426006	4052083		
52872	4852	46235214	1997-05-23	1997-05-23 00:00:00	1997-05-23	5001	0	\N	0	0	\N	\N	0	322762	0	76690-7	46235214		
69188	2122	4024958	1980-01-18	1980-01-18 00:00:00	1980-01-18	5001	0	\N	0	0	\N	\N	0	141187	0	117015009	4024958		
27764	2554	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	169125	0	6075-6	3005136		
37326	3444	3006322	1958-01-12	1958-01-12 00:00:00	1958-01-12	5001	0	\N	0	0	\N	\N	0	228536	0	8331-1	3006322		
64904	1990	4052083	1980-11-18	1980-11-18 00:00:00	1980-11-18	5001	0	\N	0	0	\N	\N	0	132483	0	23426006	4052083		
22782	2088	3011505	1985-07-02	1985-07-02 00:00:00	1985-07-02	5001	0	\N	0	0	\N	\N	0	139171	0	19926-5	3011505		
79968	2462	4052083	2008-06-11	2008-06-11 00:00:00	2008-06-11	5001	0	\N	0	0	\N	\N	0	163276	0	23426006	4052083		
22680	2077	40769189	1958-03-29	1958-03-29 00:00:00	1958-03-29	5001	0	\N	0	0	\N	\N	0	138268	0	66529-9	40769189		
1980	180	3006322	1980-01-07	1980-01-07 00:00:00	1980-01-07	5001	0	\N	0	0	\N	\N	0	12151	0	8331-1	3006322		
31123	2845	3006322	1953-10-30	1953-10-30 00:00:00	1953-10-30	5001	0	\N	0	0	\N	\N	0	188904	0	8331-1	3006322		
102825	3161	4052083	1978-05-26	1978-05-26 00:00:00	1978-05-26	5001	0	\N	0	0	\N	\N	0	210251	0	23426006	4052083		
49139	4491	3006322	1983-04-09	1983-04-09 00:00:00	1983-04-09	5001	0	\N	0	0	\N	\N	0	299017	0	8331-1	3006322		
8338	787	3006322	1978-09-26	1978-09-26 00:00:00	1978-09-26	5001	0	\N	0	0	\N	\N	0	52361	0	8331-1	3006322		
88696	2747	4024958	2012-08-20	2012-08-20 00:00:00	2012-08-20	5001	0	\N	0	0	\N	\N	0	181677	0	117015009	4024958		
38765	3582	3011505	2019-03-03	2019-03-03 00:00:00	2019-03-03	5001	0	\N	0	0	\N	\N	0	238121	0	19926-5	3011505		
76175	2337	4024958	1998-12-05	1998-12-05 00:00:00	1998-12-05	5001	0	\N	0	0	\N	\N	0	155492	0	117015009	4024958		
95082	2919	4024958	1956-10-10	1956-10-10 00:00:00	1956-10-10	5001	0	\N	0	0	\N	\N	0	194586	0	117015009	4024958		
31983	2915	3001488	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	194256	0	7258-7	3001488		
8791	843	3006322	1996-02-15	1996-02-15 00:00:00	1996-02-15	5001	0	\N	0	0	\N	\N	0	55870	0	8331-1	3006322		
117688	3623	4052083	2005-01-06	2005-01-06 00:00:00	2005-01-06	5001	0	\N	0	0	\N	\N	0	240869	0	23426006	4052083		
14740	461	4052083	1951-12-10	1951-12-10 00:00:00	1951-12-10	5001	0	\N	0	0	\N	\N	0	30805	0	23426006	4052083		
108537	3352	4133840	2010-11-12	2010-11-12 00:00:00	2010-11-12	5001	0	\N	0	0	\N	\N	0	222281	0	127783003	4133840		
30112	2770	3006734	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	183401	0	6189-5	3006734		
37911	3505	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	232384	0	6206-7	3012494		
3120	299	46235214	2003-05-23	2003-05-23 00:00:00	2003-05-23	5001	0	\N	0	0	\N	\N	0	20026	0	76690-7	46235214		
23653	742	4133840	2008-07-21	2008-07-21 00:00:00	2008-07-21	5001	0	\N	0	0	\N	\N	0	49195	0	127783003	4133840		
113181	3494	4052083	1981-04-01	1981-04-01 00:00:00	1981-04-01	5001	0	\N	0	0	\N	\N	0	231721	0	23426006	4052083		
152337	4670	4052083	1964-03-18	1964-03-18 00:00:00	1964-03-18	5001	0	\N	0	0	\N	\N	0	311203	0	23426006	4052083		
44595	4119	3006322	1949-10-12	1949-10-12 00:00:00	1949-10-12	5001	0	\N	0	0	\N	\N	0	273792	0	8331-1	3006322		
33438	3025	3021226	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	201615	0	6246-3	3021226		
6220	582	3006322	1971-12-23	1971-12-23 00:00:00	1971-12-23	5001	0	\N	0	0	\N	\N	0	38589	0	8331-1	3006322		
16605	1513	3006734	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	101053	0	6189-5	3006734		
34005	3098	3006322	1987-09-21	1987-09-21 00:00:00	1987-09-21	5001	0	\N	0	0	\N	\N	0	206145	0	8331-1	3006322		
44004	4064	3000876	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	270013	0	6082-2	3000876		
18434	1689	3006322	1945-12-03	1945-12-03 00:00:00	1945-12-03	5001	0	\N	0	0	\N	\N	0	113137	0	8331-1	3006322		
51874	4760	3006322	1955-03-27	1955-03-27 00:00:00	1955-03-27	5001	0	\N	0	0	\N	\N	0	317171	0	8331-1	3006322		
46159	4256	3015632	1963-11-14	1963-11-14 00:00:00	1963-11-14	5001	0	\N	0	0	\N	\N	0	282589	0	2028-9	3015632		
48113	4413	3006322	2008-02-06	2008-02-06 00:00:00	2008-02-06	5001	0	\N	0	0	\N	\N	0	293430	0	8331-1	3006322		
28709	2657	3006322	1977-12-20	1977-12-20 00:00:00	1977-12-20	5001	0	\N	0	0	\N	\N	0	175952	0	8331-1	3006322		
8501	807	40758406	1996-10-01	1996-10-01 00:00:00	1996-10-01	5001	0	\N	0	0	\N	\N	0	53574	0	55277-8	40758406		
40106	3739	3006322	2001-10-28	2001-10-28 00:00:00	2001-10-28	5001	0	\N	0	0	\N	\N	0	248450	0	8331-1	3006322		
40182	3744	3005136	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	248741	0	6075-6	3005136		
49601	4514	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	300640	0	6246-3	3021226		
10603	337	4052083	1986-02-04	1986-02-04 00:00:00	1986-02-04	5001	0	\N	0	0	\N	\N	0	22455	0	23426006	4052083		
30946	2832	3001247	1994-03-05	1994-03-05 00:00:00	1994-03-05	5001	0	\N	0	0	\N	\N	0	187897	0	6085-5	3001247		
118786	3655	4024958	1948-11-02	1948-11-02 00:00:00	1948-11-02	5001	0	\N	0	0	\N	\N	0	243292	0	117015009	4024958		
26	2	46235214	1934-08-27	1934-08-27 00:00:00	1934-08-27	5001	0	\N	0	0	\N	\N	0	175	0	76690-7	46235214		
9765	917	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	61073	0	6246-3	3021226		
146114	4482	4052083	1952-04-13	1952-04-13 00:00:00	1952-04-13	5001	0	\N	0	0	\N	\N	0	298406	0	23426006	4052083		
158211	4861	4024958	1961-05-19	1961-05-19 00:00:00	1961-05-19	5001	0	\N	0	0	\N	\N	0	323355	0	117015009	4024958		
37013	1145	4024958	1942-05-20	1942-05-20 00:00:00	1942-05-20	5001	0	\N	0	0	\N	\N	0	75538	0	117015009	4024958		
23666	2176	3006322	1991-09-13	1991-09-13 00:00:00	1991-09-13	5001	0	\N	0	0	\N	\N	0	145107	0	8331-1	3006322		
1735	152	3006322	1998-10-22	1998-10-22 00:00:00	1998-10-22	5001	0	\N	0	0	\N	\N	0	10252	0	8331-1	3006322		
659	16	4024958	2015-02-13	2015-02-13 00:00:00	2015-02-13	5001	0	\N	0	0	\N	\N	0	1188	0	117015009	4024958		
44137	4071	3006322	2011-04-09	2011-04-09 00:00:00	2011-04-09	5001	0	\N	0	0	\N	\N	0	270591	0	8331-1	3006322		
19115	1753	40758406	1965-06-06	1965-06-06 00:00:00	1965-06-06	5001	0	\N	0	0	\N	\N	0	117193	0	55277-8	40758406		
79537	2447	4133840	2017-10-11	2017-10-11 00:00:00	2017-10-11	5001	0	\N	0	0	\N	\N	0	162331	0	127783003	4133840		
46668	4297	3007461	1991-02-19	1991-02-19 00:00:00	1991-02-19	5001	0	\N	0	0	\N	\N	0	285178	0	26515-7	3007461		
1374	123	3006322	1960-10-20	1960-10-20 00:00:00	1960-10-20	5001	0	\N	0	0	\N	\N	0	8120	0	8331-1	3006322		
138772	4278	4024958	2000-12-24	2000-12-24 00:00:00	2000-12-24	5001	0	\N	0	0	\N	\N	0	283940	0	117015009	4024958		
2964	285	3006451	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	18965	0	6273-7	3006451		
6788	648	3006322	2006-12-03	2006-12-03 00:00:00	2006-12-03	5001	0	\N	0	0	\N	\N	0	42906	0	8331-1	3006322		
113028	3488	4133840	2000-01-28	2000-01-28 00:00:00	2000-01-28	5001	0	\N	0	0	\N	\N	0	231374	0	127783003	4133840		
26782	841	4052083	1966-08-31	1966-08-31 00:00:00	1966-08-31	5001	0	\N	0	0	\N	\N	0	55561	0	23426006	4052083		
52873	4852	40766240	1997-05-23	1997-05-23 00:00:00	1997-05-23	5001	0	\N	0	0	\N	\N	0	322762	0	63513-6	40766240		
69191	2122	4024958	1987-06-21	1987-06-21 00:00:00	1987-06-21	5001	0	\N	0	0	\N	\N	0	141173	0	117015009	4024958		
27765	2554	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	169125	0	6276-0	3027231		
37327	3444	3006322	1989-09-28	1989-09-28 00:00:00	1989-09-28	5001	0	\N	0	0	\N	\N	0	228567	0	8331-1	3006322		
64922	1991	4024958	1986-12-18	1986-12-18 00:00:00	1986-12-18	5001	0	\N	0	0	\N	\N	0	132558	0	117015009	4024958		
22783	2088	3011505	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	139273	0	19926-5	3011505		
152672	4680	4024958	1989-02-18	1989-02-18 00:00:00	1989-02-18	5001	0	\N	0	0	\N	\N	0	311889	0	117015009	4024958		
22681	2077	40769184	1958-03-29	1958-03-29 00:00:00	1958-03-29	5001	0	\N	0	0	\N	\N	0	138268	0	66524-0	40769184		
1981	180	3006322	2015-03-05	2015-03-05 00:00:00	2015-03-05	5001	0	\N	0	0	\N	\N	0	12150	0	8331-1	3006322		
31124	2846	3006322	1979-06-21	1979-06-21 00:00:00	1979-06-21	5001	0	\N	0	0	\N	\N	0	188993	0	8331-1	3006322		
71426	2186	4024958	1981-11-09	1981-11-09 00:00:00	1981-11-09	5001	0	\N	0	0	\N	\N	0	145756	0	117015009	4024958		
49140	4491	3006322	1965-05-17	1965-05-17 00:00:00	1965-05-17	5001	0	\N	0	0	\N	\N	0	299028	0	8331-1	3006322		
8339	787	3006322	2011-11-24	2011-11-24 00:00:00	2011-11-24	5001	0	\N	0	0	\N	\N	0	52363	0	8331-1	3006322		
88698	2747	4052083	2008-12-09	2008-12-09 00:00:00	2008-12-09	5001	0	\N	0	0	\N	\N	0	181676	0	23426006	4052083		
38766	3583	3027231	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	238256	0	6276-0	3027231		
76194	2337	4024958	1992-09-25	1992-09-25 00:00:00	1992-09-25	5001	0	\N	0	0	\N	\N	0	155491	0	117015009	4024958		
95083	2919	4133840	2009-10-17	2009-10-17 00:00:00	2009-10-17	5001	0	\N	0	0	\N	\N	0	194620	0	127783003	4133840		
31984	2915	3023430	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	194256	0	6833-8	3023430		
8792	843	3023430	1995-05-06	1995-05-06 00:00:00	1995-05-06	5001	0	\N	0	0	\N	\N	0	55807	0	6833-8	3023430		
3308	99	4133840	2014-08-16	2014-08-16 00:00:00	2014-08-16	5001	0	\N	0	0	\N	\N	0	6758	0	127783003	4133840		
106621	3285	4052083	1962-07-28	1962-07-28 00:00:00	1962-07-28	5001	0	\N	0	0	\N	\N	0	218218	0	23426006	4052083		
108540	3352	4133840	2015-10-30	2015-10-30 00:00:00	2015-10-30	5001	0	\N	0	0	\N	\N	0	222276	0	127783003	4133840		
30113	2770	3036780	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	183401	0	6095-4	3036780		
37912	3505	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	232384	0	6085-5	3001247		
3121	299	40766240	2003-05-23	2003-05-23 00:00:00	2003-05-23	5001	0	\N	0	0	\N	\N	0	20026	0	63513-6	40766240		
23660	742	4133840	2012-12-17	2012-12-17 00:00:00	2012-12-17	5001	0	\N	0	0	\N	\N	0	49197	0	127783003	4133840		
113187	3494	4133840	2014-11-06	2014-11-06 00:00:00	2014-11-06	5001	0	\N	0	0	\N	\N	0	231737	0	127783003	4133840		
152357	4670	4024958	1977-03-21	1977-03-21 00:00:00	1977-03-21	5001	0	\N	0	0	\N	\N	0	311193	0	117015009	4024958		
44596	4119	3006322	2011-01-01	2011-01-01 00:00:00	2011-01-01	5001	0	\N	0	0	\N	\N	0	273892	0	8331-1	3006322		
33439	3025	3027231	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	201615	0	6276-0	3027231		
6221	582	3006322	2014-04-02	2014-04-02 00:00:00	2014-04-02	5001	0	\N	0	0	\N	\N	0	38583	0	8331-1	3006322		
16606	1513	3023430	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	101053	0	6833-8	3023430		
34006	3098	3049273	2019-06-23	2019-06-23 00:00:00	2019-06-23	5001	0	\N	0	0	\N	\N	0	206195	0	38265-5	3049273		
44005	4064	3012494	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	270013	0	6206-7	3012494		
18435	1690	3006322	1979-12-31	1979-12-31 00:00:00	1979-12-31	5001	0	\N	0	0	\N	\N	0	113207	0	8331-1	3006322		
51875	4760	3006322	1968-02-28	1968-02-28 00:00:00	1968-02-28	5001	0	\N	0	0	\N	\N	0	317203	0	8331-1	3006322		
46160	4256	3013682	1963-11-14	1963-11-14 00:00:00	1963-11-14	5001	0	\N	0	0	\N	\N	0	282589	0	3094-0	3013682		
48114	4413	3006322	1981-01-31	1981-01-31 00:00:00	1981-01-31	5001	0	\N	0	0	\N	\N	0	293428	0	8331-1	3006322		
28710	2657	3006322	1989-08-15	1989-08-15 00:00:00	1989-08-15	5001	0	\N	0	0	\N	\N	0	175973	0	8331-1	3006322		
8502	807	3051031	1996-10-01	1996-10-01 00:00:00	1996-10-01	5001	0	\N	0	0	\N	\N	0	53574	0	46240-8	3051031		
40107	3739	3006322	1979-07-17	1979-07-17 00:00:00	1979-07-17	5001	0	\N	0	0	\N	\N	0	248427	0	8331-1	3006322		
40183	3744	3001247	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	248741	0	6085-5	3001247		
49602	4514	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	300640	0	6106-9	3014599		
10611	337	4052083	1991-08-06	1991-08-06 00:00:00	1991-08-06	5001	0	\N	0	0	\N	\N	0	22422	0	23426006	4052083		
30947	2832	3006322	1988-04-15	1988-04-15 00:00:00	1988-04-15	5001	0	\N	0	0	\N	\N	0	187884	0	8331-1	3006322		
118790	3655	4052083	1972-01-15	1972-01-15 00:00:00	1972-01-15	5001	0	\N	0	0	\N	\N	0	243277	0	23426006	4052083		
27	2	40758406	1934-08-27	1934-08-27 00:00:00	1934-08-27	5001	0	\N	0	0	\N	\N	0	175	0	55277-8	40758406		
9766	917	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	61073	0	6276-0	3027231		
146130	4482	4052083	2003-10-08	2003-10-08 00:00:00	2003-10-08	5001	0	\N	0	0	\N	\N	0	298359	0	23426006	4052083		
158215	4861	4052083	1958-08-31	1958-08-31 00:00:00	1958-08-31	5001	0	\N	0	0	\N	\N	0	323382	0	23426006	4052083		
37017	1145	4052083	2002-06-08	2002-06-08 00:00:00	2002-06-08	5001	0	\N	0	0	\N	\N	0	75639	0	23426006	4052083		
23667	2176	3006322	1961-01-10	1961-01-10 00:00:00	1961-01-10	5001	0	\N	0	0	\N	\N	0	145123	0	8331-1	3006322		
1736	153	3006322	1975-03-03	1975-03-03 00:00:00	1975-03-03	5001	0	\N	0	0	\N	\N	0	10381	0	8331-1	3006322		
694	16	4052083	1994-01-01	1994-01-01 00:00:00	1994-01-01	5001	0	\N	0	0	\N	\N	0	1202	0	23426006	4052083		
44138	4071	40766240	1966-04-27	1966-04-27 00:00:00	1966-04-27	5001	0	\N	0	0	\N	\N	0	270616	0	63513-6	40766240		
19116	1753	46235214	1965-06-06	1965-06-06 00:00:00	1965-06-06	5001	0	\N	0	0	\N	\N	0	117193	0	76690-7	46235214		
79539	2447	4024958	2011-02-27	2011-02-27 00:00:00	2011-02-27	5001	0	\N	0	0	\N	\N	0	162315	0	117015009	4024958		
46669	4297	3045716	1991-02-19	1991-02-19 00:00:00	1991-02-19	5001	0	\N	0	0	\N	\N	0	285178	0	33037-3	3045716		
1375	123	3006322	2001-05-17	2001-05-17 00:00:00	2001-05-17	5001	0	\N	0	0	\N	\N	0	8156	0	8331-1	3006322		
138774	4278	4133840	2018-12-07	2018-12-07 00:00:00	2018-12-07	5001	0	\N	0	0	\N	\N	0	283863	0	127783003	4133840		
2965	285	3015076	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	18965	0	6248-9	3015076		
6789	648	3006322	1949-11-02	1949-11-02 00:00:00	1949-11-02	5001	0	\N	0	0	\N	\N	0	42914	0	8331-1	3006322		
113029	3488	4133840	1996-01-26	1996-01-26 00:00:00	1996-01-26	5001	0	\N	0	0	\N	\N	0	231397	0	127783003	4133840		
26786	842	4133840	1976-12-18	1976-12-18 00:00:00	1976-12-18	5001	0	\N	0	0	\N	\N	0	55734	0	127783003	4133840		
52875	4852	3006322	2003-07-24	2003-07-24 00:00:00	2003-07-24	5001	0	\N	0	0	\N	\N	0	322763	0	8331-1	3006322		
69194	2122	4052083	1991-05-02	1991-05-02 00:00:00	1991-05-02	5001	0	\N	0	0	\N	\N	0	141190	0	23426006	4052083		
27766	2554	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	169125	0	7258-7	3001488		
37328	3444	3006322	1979-02-02	1979-02-02 00:00:00	1979-02-02	5001	0	\N	0	0	\N	\N	0	228523	0	8331-1	3006322		
64939	1991	4024958	1983-03-28	1983-03-28 00:00:00	1983-03-28	5001	0	\N	0	0	\N	\N	0	132604	0	117015009	4024958		
22784	2088	3006322	1942-01-22	1942-01-22 00:00:00	1942-01-22	5001	0	\N	0	0	\N	\N	0	139260	0	8331-1	3006322		
152678	4680	4024958	1924-01-01	1924-01-01 00:00:00	1924-01-01	5001	0	\N	0	0	\N	\N	0	311954	0	117015009	4024958		
22682	2077	40769194	1958-03-29	1958-03-29 00:00:00	1958-03-29	5001	0	\N	0	0	\N	\N	0	138268	0	66534-9	40769194		
1982	180	3006322	1999-04-13	1999-04-13 00:00:00	1999-04-13	5001	0	\N	0	0	\N	\N	0	12091	0	8331-1	3006322		
31125	2846	3006322	2017-09-16	2017-09-16 00:00:00	2017-09-16	5001	0	\N	0	0	\N	\N	0	189038	0	8331-1	3006322		
71494	2189	4024958	1998-04-02	1998-04-02 00:00:00	1998-04-02	5001	0	\N	0	0	\N	\N	0	145920	0	117015009	4024958		
49141	4491	3006322	1968-02-11	1968-02-11 00:00:00	1968-02-11	5001	0	\N	0	0	\N	\N	0	299016	0	8331-1	3006322		
8340	787	3006322	1978-05-19	1978-05-19 00:00:00	1978-05-19	5001	0	\N	0	0	\N	\N	0	52346	0	8331-1	3006322		
88699	2747	4024958	2008-05-01	2008-05-01 00:00:00	2008-05-01	5001	0	\N	0	0	\N	\N	0	181707	0	117015009	4024958		
44540	1371	4024958	2015-03-02	2015-03-02 00:00:00	2015-03-02	5001	0	\N	0	0	\N	\N	0	90883	0	117015009	4024958		
76197	2337	4024958	2000-05-11	2000-05-11 00:00:00	2000-05-11	5001	0	\N	0	0	\N	\N	0	155536	0	117015009	4024958		
95087	2919	4133840	2011-11-12	2011-11-12 00:00:00	2011-11-12	5001	0	\N	0	0	\N	\N	0	194633	0	127783003	4133840		
31985	2915	3006322	2007-03-07	2007-03-07 00:00:00	2007-03-07	5001	0	\N	0	0	\N	\N	0	194274	0	8331-1	3006322		
32018	2919	3006322	1975-08-25	1975-08-25 00:00:00	1975-08-25	5001	0	\N	0	0	\N	\N	0	194575	0	8331-1	3006322		
3310	99	4133840	2017-04-15	2017-04-15 00:00:00	2017-04-15	5001	0	\N	0	0	\N	\N	0	6753	0	127783003	4133840		
106626	3285	4024958	2019-06-11	2019-06-11 00:00:00	2019-06-11	5001	0	\N	0	0	\N	\N	0	218222	0	117015009	4024958		
108544	3352	4133840	2016-11-04	2016-11-04 00:00:00	2016-11-04	5001	0	\N	0	0	\N	\N	0	222323	0	127783003	4133840		
30114	2770	3000876	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	183401	0	6082-2	3000876		
37913	3505	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	232384	0	6833-8	3023430		
3123	299	3051031	2003-05-23	2003-05-23 00:00:00	2003-05-23	5001	0	\N	0	0	\N	\N	0	20026	0	46240-8	3051031		
23663	742	4133840	1980-09-22	1980-09-22 00:00:00	1980-09-22	5001	0	\N	0	0	\N	\N	0	49110	0	127783003	4133840		
113192	3494	4133840	2016-11-17	2016-11-17 00:00:00	2016-11-17	5001	0	\N	0	0	\N	\N	0	231738	0	127783003	4133840		
2170	196	3006322	1997-12-14	1997-12-14 00:00:00	1997-12-14	5001	0	\N	0	0	\N	\N	0	13446	0	8331-1	3006322		
44597	4119	3006322	2012-05-08	2012-05-08 00:00:00	2012-05-08	5001	0	\N	0	0	\N	\N	0	273793	0	8331-1	3006322		
33440	3025	3019406	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	201615	0	6158-0	3019406		
6222	582	3006322	1971-11-09	1971-11-09 00:00:00	1971-11-09	5001	0	\N	0	0	\N	\N	0	38570	0	8331-1	3006322		
16607	1513	3036780	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	101053	0	6095-4	3036780		
34007	3098	3006322	1972-02-28	1972-02-28 00:00:00	1972-02-28	5001	0	\N	0	0	\N	\N	0	206143	0	8331-1	3006322		
44006	4064	3036780	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	270030	0	6095-4	3036780		
18436	1690	3006322	1983-01-07	1983-01-07 00:00:00	1983-01-07	5001	0	\N	0	0	\N	\N	0	113164	0	8331-1	3006322		
51876	4760	3006322	2013-03-28	2013-03-28 00:00:00	2013-03-28	5001	0	\N	0	0	\N	\N	0	317124	0	8331-1	3006322		
46161	4256	3035995	1963-11-14	1963-11-14 00:00:00	1963-11-14	5001	0	\N	0	0	\N	\N	0	282589	0	6768-6	3035995		
48115	4413	3006322	1961-10-08	1961-10-08 00:00:00	1961-10-08	5001	0	\N	0	0	\N	\N	0	293489	0	8331-1	3006322		
28711	2657	3006322	1968-01-29	1968-01-29 00:00:00	1968-01-29	5001	0	\N	0	0	\N	\N	0	175967	0	8331-1	3006322		
8504	807	40766240	1996-10-01	1996-10-01 00:00:00	1996-10-01	5001	0	\N	0	0	\N	\N	0	53574	0	63513-6	40766240		
40108	3739	3006322	1971-01-26	1971-01-26 00:00:00	1971-01-26	5001	0	\N	0	0	\N	\N	0	248426	0	8331-1	3006322		
40184	3744	3006734	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	248741	0	6189-5	3006734		
49603	4514	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	300640	0	6158-0	3019406		
49627	4514	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	300684	0	6246-3	3021226		
30948	2832	3006322	1989-11-17	1989-11-17 00:00:00	1989-11-17	5001	0	\N	0	0	\N	\N	0	187944	0	8331-1	3006322		
118841	3658	4052083	1998-01-10	1998-01-10 00:00:00	1998-01-10	5001	0	\N	0	0	\N	\N	0	243440	0	23426006	4052083		
28	2	3011505	2003-08-12	2003-08-12 00:00:00	2003-08-12	5001	0	\N	0	0	\N	\N	0	90	0	19926-5	3011505		
9767	917	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	61073	0	6844-5	3020655		
158138	4859	4024958	1999-10-29	1999-10-29 00:00:00	1999-10-29	5001	0	\N	0	0	\N	\N	0	323254	0	117015009	4024958		
158221	4861	4052083	2003-04-12	2003-04-12 00:00:00	2003-04-12	5001	0	\N	0	0	\N	\N	0	323384	0	23426006	4052083		
37019	1145	4024958	2018-09-01	2018-09-01 00:00:00	2018-09-01	5001	0	\N	0	0	\N	\N	0	75546	0	117015009	4024958		
23668	2176	3006322	1956-11-20	1956-11-20 00:00:00	1956-11-20	5001	0	\N	0	0	\N	\N	0	145106	0	8331-1	3006322		
1737	153	3006322	1948-05-09	1948-05-09 00:00:00	1948-05-09	5001	0	\N	0	0	\N	\N	0	10346	0	8331-1	3006322		
49830	1516	4052083	1979-05-07	1979-05-07 00:00:00	1979-05-07	5001	0	\N	0	0	\N	\N	0	101261	0	23426006	4052083		
44139	4071	46235214	1966-04-27	1966-04-27 00:00:00	1966-04-27	5001	0	\N	0	0	\N	\N	0	270616	0	76690-7	46235214		
19117	1753	3051031	1965-06-06	1965-06-06 00:00:00	1965-06-06	5001	0	\N	0	0	\N	\N	0	117193	0	46240-8	3051031		
79542	2447	4024958	2010-10-16	2010-10-16 00:00:00	2010-10-16	5001	0	\N	0	0	\N	\N	0	162290	0	117015009	4024958		
46670	4297	3002385	1991-02-19	1991-02-19 00:00:00	1991-02-19	5001	0	\N	0	0	\N	\N	0	285178	0	30385-9	3002385		
1376	123	3006322	1988-11-28	1988-11-28 00:00:00	1988-11-28	5001	0	\N	0	0	\N	\N	0	8107	0	8331-1	3006322		
138776	4278	4133840	2010-10-22	2010-10-22 00:00:00	2010-10-22	5001	0	\N	0	0	\N	\N	0	283853	0	127783003	4133840		
2966	285	3012494	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	18965	0	6206-7	3012494		
6790	648	3006322	2016-05-28	2016-05-28 00:00:00	2016-05-28	5001	0	\N	0	0	\N	\N	0	42915	0	8331-1	3006322		
113032	3488	4133840	1993-03-26	1993-03-26 00:00:00	1993-03-26	5001	0	\N	0	0	\N	\N	0	231408	0	127783003	4133840		
26789	842	4133840	1981-03-14	1981-03-14 00:00:00	1981-03-14	5001	0	\N	0	0	\N	\N	0	55665	0	127783003	4133840		
52877	4852	40766240	1997-03-23	1997-03-23 00:00:00	1997-03-23	5001	0	\N	0	0	\N	\N	0	322789	0	63513-6	40766240		
69206	2123	4024958	1963-05-23	1963-05-23 00:00:00	1963-05-23	5001	0	\N	0	0	\N	\N	0	141260	0	117015009	4024958		
27767	2554	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	169125	0	6085-5	3001247		
42127	1303	4024958	1998-12-09	1998-12-09 00:00:00	1998-12-09	5001	0	\N	0	0	\N	\N	0	86026	0	117015009	4024958		
64945	1991	4052083	1971-07-01	1971-07-01 00:00:00	1971-07-01	5001	0	\N	0	0	\N	\N	0	132632	0	23426006	4052083		
22785	2088	3011505	1983-06-21	1983-06-21 00:00:00	1983-06-21	5001	0	\N	0	0	\N	\N	0	139170	0	19926-5	3011505		
163981	5037	4024958	1982-10-22	1982-10-22 00:00:00	1982-10-22	5001	0	\N	0	0	\N	\N	0	334736	0	117015009	4024958		
22684	2077	3036780	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	138284	0	6095-4	3036780		
1983	180	3001247	1990-04-26	1990-04-26 00:00:00	1990-04-26	5001	0	\N	0	0	\N	\N	0	12108	0	6085-5	3001247		
31126	2846	3006322	1982-02-14	1982-02-14 00:00:00	1982-02-14	5001	0	\N	0	0	\N	\N	0	189032	0	8331-1	3006322		
60689	1851	4133840	2009-07-16	2009-07-16 00:00:00	2009-07-16	5001	0	\N	0	0	\N	\N	0	123835	0	127783003	4133840		
49142	4491	3006322	2015-02-09	2015-02-09 00:00:00	2015-02-09	5001	0	\N	0	0	\N	\N	0	298999	0	8331-1	3006322		
8341	787	3006322	2014-03-28	2014-03-28 00:00:00	2014-03-28	5001	0	\N	0	0	\N	\N	0	52365	0	8331-1	3006322		
88701	2747	4024958	1994-09-23	1994-09-23 00:00:00	1994-09-23	5001	0	\N	0	0	\N	\N	0	181717	0	117015009	4024958		
44548	1371	4024958	1978-12-17	1978-12-17 00:00:00	1978-12-17	5001	0	\N	0	0	\N	\N	0	90937	0	117015009	4024958		
122178	3769	4052083	1954-04-02	1954-04-02 00:00:00	1954-04-02	5001	0	\N	0	0	\N	\N	0	250518	0	23426006	4052083		
95090	2919	4133840	2008-10-11	2008-10-11 00:00:00	2008-10-11	5001	0	\N	0	0	\N	\N	0	194625	0	127783003	4133840		
31986	2915	40769179	1967-05-11	1967-05-11 00:00:00	1967-05-11	5001	0	\N	0	0	\N	\N	0	194341	0	66519-0	40769179		
32019	2919	3011505	2009-10-17	2009-10-17 00:00:00	2009-10-17	5001	0	\N	0	0	\N	\N	0	194620	0	19926-5	3011505		
3312	99	4133840	2008-07-12	2008-07-12 00:00:00	2008-07-12	5001	0	\N	0	0	\N	\N	0	6767	0	127783003	4133840		
106642	3285	4024958	1978-11-13	1978-11-13 00:00:00	1978-11-13	5001	0	\N	0	0	\N	\N	0	218211	0	117015009	4024958		
108545	3352	4133840	2012-11-16	2012-11-16 00:00:00	2012-11-16	5001	0	\N	0	0	\N	\N	0	222321	0	127783003	4133840		
30115	2770	3005136	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	183401	0	6075-6	3005136		
37914	3505	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	232384	0	6844-5	3020655		
3124	299	3011505	2017-06-24	2017-06-24 00:00:00	2017-06-24	5001	0	\N	0	0	\N	\N	0	19984	0	19926-5	3011505		
23667	742	4133840	1986-10-27	1986-10-27 00:00:00	1986-10-27	5001	0	\N	0	0	\N	\N	0	49115	0	127783003	4133840		
113196	3494	4133840	2012-08-16	2012-08-16 00:00:00	2012-08-16	5001	0	\N	0	0	\N	\N	0	231754	0	127783003	4133840		
2171	197	3006322	2012-07-29	2012-07-29 00:00:00	2012-07-29	5001	0	\N	0	0	\N	\N	0	13539	0	8331-1	3006322		
44598	4119	3006322	2000-01-18	2000-01-18 00:00:00	2000-01-18	5001	0	\N	0	0	\N	\N	0	273846	0	8331-1	3006322		
33441	3025	3012494	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	201615	0	6206-7	3012494		
6223	582	3049273	2016-09-10	2016-09-10 00:00:00	2016-09-10	5001	0	\N	0	0	\N	\N	0	38557	0	38265-5	3049273		
16608	1513	3006322	2010-06-12	2010-06-12 00:00:00	2010-06-12	5001	0	\N	0	0	\N	\N	0	101109	0	8331-1	3006322		
34008	3098	3006322	1963-08-29	1963-08-29 00:00:00	1963-08-29	5001	0	\N	0	0	\N	\N	0	206147	0	8331-1	3006322		
44007	4064	3012494	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	270030	0	6206-7	3012494		
18437	1690	3006322	1999-06-24	1999-06-24 00:00:00	1999-06-24	5001	0	\N	0	0	\N	\N	0	113220	0	8331-1	3006322		
51877	4760	3006322	1982-08-03	1982-08-03 00:00:00	1982-08-03	5001	0	\N	0	0	\N	\N	0	317145	0	8331-1	3006322		
46162	4256	3019550	1963-11-14	1963-11-14 00:00:00	1963-11-14	5001	0	\N	0	0	\N	\N	0	282589	0	2951-2	3019550		
48116	4413	3006322	2016-12-01	2016-12-01 00:00:00	2016-12-01	5001	0	\N	0	0	\N	\N	0	293465	0	8331-1	3006322		
28712	2657	3006322	1995-05-25	1995-05-25 00:00:00	1995-05-25	5001	0	\N	0	0	\N	\N	0	175954	0	8331-1	3006322		
8505	807	46235214	1996-10-01	1996-10-01 00:00:00	1996-10-01	5001	0	\N	0	0	\N	\N	0	53574	0	76690-7	46235214		
40109	3739	3006322	2005-03-26	2005-03-26 00:00:00	2005-03-26	5001	0	\N	0	0	\N	\N	0	248422	0	8331-1	3006322		
40185	3744	3020655	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	248741	0	6844-5	3020655		
49604	4514	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	300640	0	6075-6	3005136		
49628	4514	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	300684	0	6273-7	3006451		
30949	2832	3006322	2003-03-23	2003-03-23 00:00:00	2003-03-23	5001	0	\N	0	0	\N	\N	0	187933	0	8331-1	3006322		
118848	3658	4024958	1968-09-25	1968-09-25 00:00:00	1968-09-25	5001	0	\N	0	0	\N	\N	0	243457	0	117015009	4024958		
29	2	3011505	2002-08-06	2002-08-06 00:00:00	2002-08-06	5001	0	\N	0	0	\N	\N	0	187	0	19926-5	3011505		
9768	917	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	61073	0	6833-8	3023430		
158149	4859	4024958	1958-09-02	1958-09-02 00:00:00	1958-09-02	5001	0	\N	0	0	\N	\N	0	323229	0	117015009	4024958		
158231	4861	4024958	1947-06-02	1947-06-02 00:00:00	1947-06-02	5001	0	\N	0	0	\N	\N	0	323420	0	117015009	4024958		
37026	1145	4052083	1964-02-27	1964-02-27 00:00:00	1964-02-27	5001	0	\N	0	0	\N	\N	0	75566	0	23426006	4052083		
23669	2176	3006322	1963-09-05	1963-09-05 00:00:00	1963-09-05	5001	0	\N	0	0	\N	\N	0	145085	0	8331-1	3006322		
1738	153	3006322	1966-04-09	1966-04-09 00:00:00	1966-04-09	5001	0	\N	0	0	\N	\N	0	10395	0	8331-1	3006322		
49832	1516	4052083	1952-10-17	1952-10-17 00:00:00	1952-10-17	5001	0	\N	0	0	\N	\N	0	101257	0	23426006	4052083		
44141	4071	40758406	1966-04-27	1966-04-27 00:00:00	1966-04-27	5001	0	\N	0	0	\N	\N	0	270616	0	55277-8	40758406		
19119	1753	40766240	1965-06-06	1965-06-06 00:00:00	1965-06-06	5001	0	\N	0	0	\N	\N	0	117193	0	63513-6	40766240		
11113	351	4052083	1985-02-28	1985-02-28 00:00:00	1985-02-28	5001	0	\N	0	0	\N	\N	0	23411	0	23426006	4052083		
46671	4297	3023103	1991-02-19	1991-02-19 00:00:00	1991-02-19	5001	0	\N	0	0	\N	\N	0	285178	0	2823-3	3023103		
1377	123	3006322	2011-04-10	2011-04-10 00:00:00	2011-04-10	5001	0	\N	0	0	\N	\N	0	8157	0	8331-1	3006322		
138780	4278	4133840	2000-04-28	2000-04-28 00:00:00	2000-04-28	5001	0	\N	0	0	\N	\N	0	283886	0	127783003	4133840		
2967	285	3036780	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	18965	0	6095-4	3036780		
6791	648	3006322	2018-05-02	2018-05-02 00:00:00	2018-05-02	5001	0	\N	0	0	\N	\N	0	42955	0	8331-1	3006322		
113035	3488	4133840	2016-04-15	2016-04-15 00:00:00	2016-04-15	5001	0	\N	0	0	\N	\N	0	231379	0	127783003	4133840		
26792	842	4133840	2000-07-29	2000-07-29 00:00:00	2000-07-29	5001	0	\N	0	0	\N	\N	0	55680	0	127783003	4133840		
52879	4852	40758406	1997-03-23	1997-03-23 00:00:00	1997-03-23	5001	0	\N	0	0	\N	\N	0	322789	0	55277-8	40758406		
69212	2123	4052083	2018-08-27	2018-08-27 00:00:00	2018-08-27	5001	0	\N	0	0	\N	\N	0	141315	0	23426006	4052083		
27768	2554	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	169125	0	6844-5	3020655		
42133	1303	4052083	1981-11-03	1981-11-03 00:00:00	1981-11-03	5001	0	\N	0	0	\N	\N	0	86062	0	23426006	4052083		
64947	1991	4024958	1987-07-02	1987-07-02 00:00:00	1987-07-02	5001	0	\N	0	0	\N	\N	0	132559	0	117015009	4024958		
22786	2088	3011505	2018-08-07	2018-08-07 00:00:00	2018-08-07	5001	0	\N	0	0	\N	\N	0	139290	0	19926-5	3011505		
141420	4359	4024958	1947-02-22	1947-02-22 00:00:00	1947-02-22	5001	0	\N	0	0	\N	\N	0	289216	0	117015009	4024958		
22685	2077	3001247	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	138284	0	6085-5	3001247		
1984	180	3023430	1990-04-26	1990-04-26 00:00:00	1990-04-26	5001	0	\N	0	0	\N	\N	0	12108	0	6833-8	3023430		
31127	2846	3006322	1993-05-12	1993-05-12 00:00:00	1993-05-12	5001	0	\N	0	0	\N	\N	0	189022	0	8331-1	3006322		
60693	1851	4133840	2017-12-14	2017-12-14 00:00:00	2017-12-14	5001	0	\N	0	0	\N	\N	0	123857	0	127783003	4133840		
49143	4492	3006322	1974-01-09	1974-01-09 00:00:00	1974-01-09	5001	0	\N	0	0	\N	\N	0	299073	0	8331-1	3006322		
8342	788	3006322	2007-02-22	2007-02-22 00:00:00	2007-02-22	5001	0	\N	0	0	\N	\N	0	52408	0	8331-1	3006322		
88705	2747	4024958	2005-05-23	2005-05-23 00:00:00	2005-05-23	5001	0	\N	0	0	\N	\N	0	181659	0	117015009	4024958		
44549	1371	4024958	1998-10-25	1998-10-25 00:00:00	1998-10-25	5001	0	\N	0	0	\N	\N	0	90901	0	117015009	4024958		
122189	3769	4052083	1957-04-25	1957-04-25 00:00:00	1957-04-25	5001	0	\N	0	0	\N	\N	0	250537	0	23426006	4052083		
36396	3343	3021226	1977-07-13	1977-07-13 00:00:00	1977-07-13	5001	0	\N	0	0	\N	\N	0	221770	0	6246-3	3021226		
31987	2915	40769189	1967-05-11	1967-05-11 00:00:00	1967-05-11	5001	0	\N	0	0	\N	\N	0	194341	0	66529-9	40769189		
32020	2919	3011505	2018-12-22	2018-12-22 00:00:00	2018-12-22	5001	0	\N	0	0	\N	\N	0	194628	0	19926-5	3011505		
3315	99	4024958	2008-06-28	2008-06-28 00:00:00	2008-06-28	5001	0	\N	0	0	\N	\N	0	6721	0	117015009	4024958		
106643	3285	4052083	1981-04-15	1981-04-15 00:00:00	1981-04-15	5001	0	\N	0	0	\N	\N	0	218213	0	23426006	4052083		
108549	3352	4024958	1972-04-09	1972-04-09 00:00:00	1972-04-09	5001	0	\N	0	0	\N	\N	0	222305	0	117015009	4024958		
30116	2770	3021226	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	183401	0	6246-3	3021226		
37915	3505	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	232384	0	6095-4	3036780		
3125	299	3006322	1967-04-09	1967-04-09 00:00:00	1967-04-09	5001	0	\N	0	0	\N	\N	0	20023	0	8331-1	3006322		
23673	742	4052083	1972-08-22	1972-08-22 00:00:00	1972-08-22	5001	0	\N	0	0	\N	\N	0	49218	0	23426006	4052083		
113200	3494	4133840	2010-08-05	2010-08-05 00:00:00	2010-08-05	5001	0	\N	0	0	\N	\N	0	231764	0	127783003	4133840		
2172	197	3006322	2015-02-26	2015-02-26 00:00:00	2015-02-26	5001	0	\N	0	0	\N	\N	0	13548	0	8331-1	3006322		
44599	4119	3006322	1948-11-02	1948-11-02 00:00:00	1948-11-02	5001	0	\N	0	0	\N	\N	0	273791	0	8331-1	3006322		
33442	3025	3000876	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	201615	0	6082-2	3000876		
46631	1425	4052083	1996-04-17	1996-04-17 00:00:00	1996-04-17	5001	0	\N	0	0	\N	\N	0	94746	0	23426006	4052083		
16609	1513	3020655	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	101125	0	6844-5	3020655		
34009	3098	3009542	1958-09-22	1958-09-22 00:00:00	1958-09-22	5001	0	\N	0	0	\N	\N	0	206146	0	20570-8	3009542		
44008	4064	3001247	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	270030	0	6085-5	3001247		
29715	2739	3006322	1960-03-25	1960-03-25 00:00:00	1960-03-25	5001	0	\N	0	0	\N	\N	0	181209	0	8331-1	3006322		
51878	4760	3006322	1979-07-08	1979-07-08 00:00:00	1979-07-08	5001	0	\N	0	0	\N	\N	0	317144	0	8331-1	3006322		
46163	4256	3024561	1963-11-14	1963-11-14 00:00:00	1963-11-14	5001	0	\N	0	0	\N	\N	0	282589	0	1751-7	3024561		
48117	4413	3006322	1962-07-13	1962-07-13 00:00:00	1962-07-13	5001	0	\N	0	0	\N	\N	0	293456	0	8331-1	3006322		
28713	2657	3006322	1980-02-22	1980-02-22 00:00:00	1980-02-22	5001	0	\N	0	0	\N	\N	0	175953	0	8331-1	3006322		
8508	807	40758406	1952-03-16	1952-03-16 00:00:00	1952-03-16	5001	0	\N	0	0	\N	\N	0	53557	0	55277-8	40758406		
40110	3739	3006322	2014-12-15	2014-12-15 00:00:00	2014-12-15	5001	0	\N	0	0	\N	\N	0	248423	0	8331-1	3006322		
40186	3744	3012494	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	248741	0	6206-7	3012494		
49605	4514	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	300640	0	6276-0	3027231		
49629	4514	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	300684	0	6085-5	3001247		
30950	2832	40769189	1994-02-17	1994-02-17 00:00:00	1994-02-17	5001	0	\N	0	0	\N	\N	0	187896	0	66529-9	40769189		
122603	3783	4024958	1973-06-01	1973-06-01 00:00:00	1973-06-01	5001	0	\N	0	0	\N	\N	0	251429	0	117015009	4024958		
30	2	3011505	1992-10-13	1992-10-13 00:00:00	1992-10-13	5001	0	\N	0	0	\N	\N	0	87	0	19926-5	3011505		
9769	917	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	61073	0	6095-4	3036780		
158159	4859	4024958	1983-06-10	1983-06-10 00:00:00	1983-06-10	5001	0	\N	0	0	\N	\N	0	323269	0	117015009	4024958		
169517	5201	4024958	1987-11-05	1987-11-05 00:00:00	1987-11-05	5001	0	\N	0	0	\N	\N	0	345952	0	117015009	4024958		
37037	1146	4024958	1978-11-15	1978-11-15 00:00:00	1978-11-15	5001	0	\N	0	0	\N	\N	0	75718	0	117015009	4024958		
23670	2177	3006322	1985-07-20	1985-07-20 00:00:00	1985-07-20	5001	0	\N	0	0	\N	\N	0	145215	0	8331-1	3006322		
1739	153	3006322	1943-09-11	1943-09-11 00:00:00	1943-09-11	5001	0	\N	0	0	\N	\N	0	10334	0	8331-1	3006322		
49835	1516	4024958	1982-06-15	1982-06-15 00:00:00	1982-06-15	5001	0	\N	0	0	\N	\N	0	101337	0	117015009	4024958		
44142	4071	3051031	1966-04-27	1966-04-27 00:00:00	1966-04-27	5001	0	\N	0	0	\N	\N	0	270616	0	46240-8	3051031		
19120	1753	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	117215	0	6075-6	3005136		
11120	351	4052083	1982-10-05	1982-10-05 00:00:00	1982-10-05	5001	0	\N	0	0	\N	\N	0	23409	0	23426006	4052083		
46672	4297	3006322	1975-04-08	1975-04-08 00:00:00	1975-04-08	5001	0	\N	0	0	\N	\N	0	285184	0	8331-1	3006322		
1379	123	3006322	1967-06-30	1967-06-30 00:00:00	1967-06-30	5001	0	\N	0	0	\N	\N	0	8151	0	8331-1	3006322		
138781	4278	4133840	2009-10-16	2009-10-16 00:00:00	2009-10-16	5001	0	\N	0	0	\N	\N	0	283862	0	127783003	4133840		
27623	862	4052083	1973-09-16	1973-09-16 00:00:00	1973-09-16	5001	0	\N	0	0	\N	\N	0	57040	0	23426006	4052083		
6792	648	3006322	1976-05-02	1976-05-02 00:00:00	1976-05-02	5001	0	\N	0	0	\N	\N	0	42935	0	8331-1	3006322		
113038	3488	4133840	2015-04-10	2015-04-10 00:00:00	2015-04-10	5001	0	\N	0	0	\N	\N	0	231373	0	127783003	4133840		
26794	842	4133840	1952-12-20	1952-12-20 00:00:00	1952-12-20	5001	0	\N	0	0	\N	\N	0	55727	0	127783003	4133840		
52880	4852	3051031	1997-03-23	1997-03-23 00:00:00	1997-03-23	5001	0	\N	0	0	\N	\N	0	322789	0	46240-8	3051031		
69219	2123	4052083	1961-06-06	1961-06-06 00:00:00	1961-06-06	5001	0	\N	0	0	\N	\N	0	141251	0	23426006	4052083		
27769	2554	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	169125	0	6095-4	3036780		
42136	1303	4052083	1977-02-18	1977-02-18 00:00:00	1977-02-18	5001	0	\N	0	0	\N	\N	0	86061	0	23426006	4052083		
14685	1367	3006322	1997-05-23	1997-05-23 00:00:00	1997-05-23	5001	0	\N	0	0	\N	\N	0	90588	0	8331-1	3006322		
22787	2088	3006322	1934-12-07	1934-12-07 00:00:00	1934-12-07	5001	0	\N	0	0	\N	\N	0	139167	0	8331-1	3006322		
141424	4359	4052083	1991-02-08	1991-02-08 00:00:00	1991-02-08	5001	0	\N	0	0	\N	\N	0	289251	0	23426006	4052083		
22686	2077	3015076	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	138284	0	6248-9	3015076		
1985	180	3020655	1990-04-26	1990-04-26 00:00:00	1990-04-26	5001	0	\N	0	0	\N	\N	0	12108	0	6844-5	3020655		
31128	2846	3006322	1986-06-06	1986-06-06 00:00:00	1986-06-06	5001	0	\N	0	0	\N	\N	0	189005	0	8331-1	3006322		
60698	1851	4052083	2014-10-12	2014-10-12 00:00:00	2014-10-12	5001	0	\N	0	0	\N	\N	0	123817	0	23426006	4052083		
49144	4492	3006322	1955-03-08	1955-03-08 00:00:00	1955-03-08	5001	0	\N	0	0	\N	\N	0	299071	0	8331-1	3006322		
8343	788	3006322	2009-03-23	2009-03-23 00:00:00	2009-03-23	5001	0	\N	0	0	\N	\N	0	52413	0	8331-1	3006322		
88729	2749	4024958	1968-12-22	1968-12-22 00:00:00	1968-12-22	5001	0	\N	0	0	\N	\N	0	181784	0	117015009	4024958		
44553	1371	4052083	1985-03-02	1985-03-02 00:00:00	1985-03-02	5001	0	\N	0	0	\N	\N	0	90898	0	23426006	4052083		
122191	3769	4052083	1981-07-29	1981-07-29 00:00:00	1981-07-29	5001	0	\N	0	0	\N	\N	0	250522	0	23426006	4052083		
36397	3343	3005136	1977-07-13	1977-07-13 00:00:00	1977-07-13	5001	0	\N	0	0	\N	\N	0	221770	0	6075-6	3005136		
31988	2915	40769184	1967-05-11	1967-05-11 00:00:00	1967-05-11	5001	0	\N	0	0	\N	\N	0	194341	0	66524-0	40769184		
32021	2919	3011505	2014-11-29	2014-11-29 00:00:00	2014-11-29	5001	0	\N	0	0	\N	\N	0	194637	0	19926-5	3011505		
3318	99	4024958	1972-01-30	1972-01-30 00:00:00	1972-01-30	5001	0	\N	0	0	\N	\N	0	6772	0	117015009	4024958		
106677	3287	4024958	1997-11-17	1997-11-17 00:00:00	1997-11-17	5001	0	\N	0	0	\N	\N	0	218367	0	117015009	4024958		
108551	3353	4052083	1976-11-01	1976-11-01 00:00:00	1976-11-01	5001	0	\N	0	0	\N	\N	0	222382	0	23426006	4052083		
30117	2770	3019406	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	183401	0	6158-0	3019406		
37916	3505	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	232384	0	7258-7	3001488		
3126	299	3011505	2014-12-27	2014-12-27 00:00:00	2014-12-27	5001	0	\N	0	0	\N	\N	0	19981	0	19926-5	3011505		
23674	742	4024958	1926-11-18	1926-11-18 00:00:00	1926-11-18	5001	0	\N	0	0	\N	\N	0	49105	0	117015009	4024958		
113202	3494	4133840	2003-07-17	2003-07-17 00:00:00	2003-07-17	5001	0	\N	0	0	\N	\N	0	231762	0	127783003	4133840		
2173	197	3006322	1963-09-05	1963-09-05 00:00:00	1963-09-05	5001	0	\N	0	0	\N	\N	0	13568	0	8331-1	3006322		
44600	4119	3006322	1968-05-18	1968-05-18 00:00:00	1968-05-18	5001	0	\N	0	0	\N	\N	0	273865	0	8331-1	3006322		
33443	3025	3020655	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	201615	0	6844-5	3020655		
172780	5301	4024958	1986-03-28	1986-03-28 00:00:00	1986-03-28	5001	0	\N	0	0	\N	\N	0	352752	0	117015009	4024958		
16610	1513	3006734	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	101125	0	6189-5	3006734		
34010	3098	3000963	1958-09-22	1958-09-22 00:00:00	1958-09-22	5001	0	\N	0	0	\N	\N	0	206146	0	718-7	3000963		
44009	4064	3015076	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	270030	0	6248-9	3015076		
29716	2739	3006322	1995-04-05	1995-04-05 00:00:00	1995-04-05	5001	0	\N	0	0	\N	\N	0	181219	0	8331-1	3006322		
51879	4760	3006322	2014-09-03	2014-09-03 00:00:00	2014-09-03	5001	0	\N	0	0	\N	\N	0	317125	0	8331-1	3006322		
46164	4256	3016723	1963-11-14	1963-11-14 00:00:00	1963-11-14	5001	0	\N	0	0	\N	\N	0	282589	0	2160-0	3016723		
48118	4413	3006322	1992-03-02	1992-03-02 00:00:00	1992-03-02	5001	0	\N	0	0	\N	\N	0	293491	0	8331-1	3006322		
51955	4763	40766240	2009-09-06	2009-09-06 00:00:00	2009-09-06	5001	0	\N	0	0	\N	\N	0	317419	0	63513-6	40766240		
8509	807	3051031	1952-03-16	1952-03-16 00:00:00	1952-03-16	5001	0	\N	0	0	\N	\N	0	53557	0	46240-8	3051031		
40111	3739	3006322	1973-09-04	1973-09-04 00:00:00	1973-09-04	5001	0	\N	0	0	\N	\N	0	248438	0	8331-1	3006322		
40187	3744	3019406	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	248741	0	6158-0	3019406		
49606	4514	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	300640	0	6273-7	3006451		
49630	4514	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	300684	0	6248-9	3015076		
30951	2832	40769179	1994-02-17	1994-02-17 00:00:00	1994-02-17	5001	0	\N	0	0	\N	\N	0	187896	0	66519-0	40769179		
58887	1791	4052083	1963-05-14	1963-05-14 00:00:00	1963-05-14	5001	0	\N	0	0	\N	\N	0	120084	0	23426006	4052083		
31	2	3051031	1935-01-24	1935-01-24 00:00:00	1935-01-24	5001	0	\N	0	0	\N	\N	0	152	0	46240-8	3051031		
68833	2108	4052083	1946-10-03	1946-10-03 00:00:00	1946-10-03	5001	0	\N	0	0	\N	\N	0	140312	0	23426006	4052083		
158168	4859	4024958	1980-11-07	1980-11-07 00:00:00	1980-11-07	5001	0	\N	0	0	\N	\N	0	323249	0	117015009	4024958		
169527	5201	4052083	2001-10-21	2001-10-21 00:00:00	2001-10-21	5001	0	\N	0	0	\N	\N	0	345975	0	23426006	4052083		
37053	1146	4052083	1990-11-30	1990-11-30 00:00:00	1990-11-30	5001	0	\N	0	0	\N	\N	0	75744	0	23426006	4052083		
48353	1475	4052083	1963-12-30	1963-12-30 00:00:00	1963-12-30	5001	0	\N	0	0	\N	\N	0	98220	0	23426006	4052083		
1740	153	3006322	1945-08-10	1945-08-10 00:00:00	1945-08-10	5001	0	\N	0	0	\N	\N	0	10321	0	8331-1	3006322		
49842	1516	4024958	1945-12-15	1945-12-15 00:00:00	1945-12-15	5001	0	\N	0	0	\N	\N	0	101241	0	117015009	4024958		
44144	4071	40758406	1966-02-26	1966-02-26 00:00:00	1966-02-26	5001	0	\N	0	0	\N	\N	0	270595	0	55277-8	40758406		
19121	1753	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	117215	0	6106-9	3014599		
11132	351	4024958	1978-12-27	1978-12-27 00:00:00	1978-12-27	5001	0	\N	0	0	\N	\N	0	23404	0	117015009	4024958		
46674	4299	3006322	1993-01-10	1993-01-10 00:00:00	1993-01-10	5001	0	\N	0	0	\N	\N	0	285277	0	8331-1	3006322		
1380	123	3006322	1988-07-21	1988-07-21 00:00:00	1988-07-21	5001	0	\N	0	0	\N	\N	0	8155	0	8331-1	3006322		
138784	4278	4133840	2005-09-23	2005-09-23 00:00:00	2005-09-23	5001	0	\N	0	0	\N	\N	0	283860	0	127783003	4133840		
27624	862	4052083	1977-02-10	1977-02-10 00:00:00	1977-02-10	5001	0	\N	0	0	\N	\N	0	57042	0	23426006	4052083		
6793	648	3006322	1935-10-05	1935-10-05 00:00:00	1935-10-05	5001	0	\N	0	0	\N	\N	0	42899	0	8331-1	3006322		
113040	3488	4133840	2018-04-27	2018-04-27 00:00:00	2018-04-27	5001	0	\N	0	0	\N	\N	0	231378	0	127783003	4133840		
26796	842	4133840	2012-10-06	2012-10-06 00:00:00	2012-10-06	5001	0	\N	0	0	\N	\N	0	55701	0	127783003	4133840		
52881	4852	46235214	1997-03-23	1997-03-23 00:00:00	1997-03-23	5001	0	\N	0	0	\N	\N	0	322789	0	76690-7	46235214		
69244	2123	4052083	1974-03-12	1974-03-12 00:00:00	1974-03-12	5001	0	\N	0	0	\N	\N	0	141252	0	23426006	4052083		
27770	2554	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	169125	0	6833-8	3023430		
42171	1305	4052083	1976-05-02	1976-05-02 00:00:00	1976-05-02	5001	0	\N	0	0	\N	\N	0	86110	0	23426006	4052083		
14687	1368	3006322	1965-02-19	1965-02-19 00:00:00	1965-02-19	5001	0	\N	0	0	\N	\N	0	90661	0	8331-1	3006322		
22788	2088	3011505	2017-08-01	2017-08-01 00:00:00	2017-08-01	5001	0	\N	0	0	\N	\N	0	139274	0	19926-5	3011505		
9612	307	4024958	1969-09-20	1969-09-20 00:00:00	1969-09-20	5001	0	\N	0	0	\N	\N	0	20367	0	117015009	4024958		
22687	2077	3021226	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	138284	0	6246-3	3021226		
1986	180	3001488	1990-04-26	1990-04-26 00:00:00	1990-04-26	5001	0	\N	0	0	\N	\N	0	12108	0	7258-7	3001488		
31129	2847	3006322	1968-04-14	1968-04-14 00:00:00	1968-04-14	5001	0	\N	0	0	\N	\N	0	189104	0	8331-1	3006322		
60704	1851	4133840	2012-07-19	2012-07-19 00:00:00	2012-07-19	5001	0	\N	0	0	\N	\N	0	123836	0	127783003	4133840		
49145	4492	3006322	1948-02-28	1948-02-28 00:00:00	1948-02-28	5001	0	\N	0	0	\N	\N	0	299081	0	8331-1	3006322		
8344	788	3051031	1988-12-04	1988-12-04 00:00:00	1988-12-04	5001	0	\N	0	0	\N	\N	0	52405	0	46240-8	3051031		
88730	2749	4052083	1991-03-21	1991-03-21 00:00:00	1991-03-21	5001	0	\N	0	0	\N	\N	0	181819	0	23426006	4052083		
44555	1371	4024958	1974-05-30	1974-05-30 00:00:00	1974-05-30	5001	0	\N	0	0	\N	\N	0	90913	0	117015009	4024958		
122202	3769	4052083	1964-02-10	1964-02-10 00:00:00	1964-02-10	5001	0	\N	0	0	\N	\N	0	250535	0	23426006	4052083		
36398	3343	3019406	1977-07-13	1977-07-13 00:00:00	1977-07-13	5001	0	\N	0	0	\N	\N	0	221770	0	6158-0	3019406		
31989	2915	40769194	1967-05-11	1967-05-11 00:00:00	1967-05-11	5001	0	\N	0	0	\N	\N	0	194341	0	66534-9	40769194		
32022	2919	3006322	1951-04-28	1951-04-28 00:00:00	1951-04-28	5001	0	\N	0	0	\N	\N	0	194583	0	8331-1	3006322		
3322	99	4133840	2010-07-24	2010-07-24 00:00:00	2010-07-24	5001	0	\N	0	0	\N	\N	0	6768	0	127783003	4133840		
117965	3629	4024958	1989-01-26	1989-01-26 00:00:00	1989-01-26	5001	0	\N	0	0	\N	\N	0	241492	0	117015009	4024958		
108559	3353	4024958	1962-05-02	1962-05-02 00:00:00	1962-05-02	5001	0	\N	0	0	\N	\N	0	222334	0	117015009	4024958		
30118	2770	3015076	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	183401	0	6248-9	3015076		
37917	3505	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	232384	0	6189-5	3006734		
3127	299	3011505	2019-01-19	2019-01-19 00:00:00	2019-01-19	5001	0	\N	0	0	\N	\N	0	19983	0	19926-5	3011505		
23675	742	4133840	1988-11-07	1988-11-07 00:00:00	1988-11-07	5001	0	\N	0	0	\N	\N	0	49121	0	127783003	4133840		
113204	3494	4024958	1967-04-22	1967-04-22 00:00:00	1967-04-22	5001	0	\N	0	0	\N	\N	0	231719	0	117015009	4024958		
2190	199	3006322	2001-02-17	2001-02-17 00:00:00	2001-02-17	5001	0	\N	0	0	\N	\N	0	13674	0	8331-1	3006322		
44601	4119	3006322	2015-08-04	2015-08-04 00:00:00	2015-08-04	5001	0	\N	0	0	\N	\N	0	273872	0	8331-1	3006322		
33444	3025	3023430	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	201615	0	6833-8	3023430		
172782	5301	4052083	1929-09-11	1929-09-11 00:00:00	1929-09-11	5001	0	\N	0	0	\N	\N	0	352659	0	23426006	4052083		
16611	1513	3023430	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	101125	0	6833-8	3023430		
40335	3752	40766240	1994-03-28	1994-03-28 00:00:00	1994-03-28	5001	0	\N	0	0	\N	\N	0	249311	0	63513-6	40766240		
44010	4064	3021226	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	270030	0	6246-3	3021226		
29719	2739	3006322	1954-12-09	1954-12-09 00:00:00	1954-12-09	5001	0	\N	0	0	\N	\N	0	181269	0	8331-1	3006322		
51880	4760	3006322	1998-04-06	1998-04-06 00:00:00	1998-04-06	5001	0	\N	0	0	\N	\N	0	317177	0	8331-1	3006322		
46165	4256	3013721	1963-11-14	1963-11-14 00:00:00	1963-11-14	5001	0	\N	0	0	\N	\N	0	282589	0	1920-8	3013721		
48148	4418	3006322	1996-10-09	1996-10-09 00:00:00	1996-10-09	5001	0	\N	0	0	\N	\N	0	293720	0	8331-1	3006322		
51956	4763	40758406	2009-09-06	2009-09-06 00:00:00	2009-09-06	5001	0	\N	0	0	\N	\N	0	317419	0	55277-8	40758406		
8510	807	46235214	1952-03-16	1952-03-16 00:00:00	1952-03-16	5001	0	\N	0	0	\N	\N	0	53557	0	76690-7	46235214		
40112	3739	3006322	1983-09-07	1983-09-07 00:00:00	1983-09-07	5001	0	\N	0	0	\N	\N	0	248445	0	8331-1	3006322		
40188	3744	3021226	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	248741	0	6246-3	3021226		
49607	4514	3000876	1976-06-28	1976-06-28 00:00:00	1976-06-28	5001	0	\N	0	0	\N	\N	0	300670	0	6082-2	3000876		
49631	4514	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	300684	0	6189-5	3006734		
30952	2832	40769184	1994-02-17	1994-02-17 00:00:00	1994-02-17	5001	0	\N	0	0	\N	\N	0	187896	0	66524-0	40769184		
70216	2151	4052083	1969-03-17	1969-03-17 00:00:00	1969-03-17	5001	0	\N	0	0	\N	\N	0	143257	0	23426006	4052083		
33	2	46235214	1935-01-24	1935-01-24 00:00:00	1935-01-24	5001	0	\N	0	0	\N	\N	0	152	0	76690-7	46235214		
68839	2108	4052083	1957-04-12	1957-04-12 00:00:00	1957-04-12	5001	0	\N	0	0	\N	\N	0	140397	0	23426006	4052083		
158170	4859	4052083	1963-10-17	1963-10-17 00:00:00	1963-10-17	5001	0	\N	0	0	\N	\N	0	323277	0	23426006	4052083		
169528	5201	4024958	1980-10-25	1980-10-25 00:00:00	1980-10-25	5001	0	\N	0	0	\N	\N	0	345951	0	117015009	4024958		
48336	1475	4052083	2017-12-29	2017-12-29 00:00:00	2017-12-29	5001	0	\N	0	0	\N	\N	0	98278	0	23426006	4052083		
48355	1475	4024958	1959-12-06	1959-12-06 00:00:00	1959-12-06	5001	0	\N	0	0	\N	\N	0	98217	0	117015009	4024958		
1741	153	3006322	1961-07-23	1961-07-23 00:00:00	1961-07-23	5001	0	\N	0	0	\N	\N	0	10385	0	8331-1	3006322		
49854	1516	4024958	1948-06-17	1948-06-17 00:00:00	1948-06-17	5001	0	\N	0	0	\N	\N	0	101350	0	117015009	4024958		
44146	4071	46235214	1966-02-26	1966-02-26 00:00:00	1966-02-26	5001	0	\N	0	0	\N	\N	0	270595	0	76690-7	46235214		
19122	1753	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	117215	0	6273-7	3006451		
11136	352	4024958	1992-12-27	1992-12-27 00:00:00	1992-12-27	5001	0	\N	0	0	\N	\N	0	23449	0	117015009	4024958		
46675	4299	3006322	2003-05-07	2003-05-07 00:00:00	2003-05-07	5001	0	\N	0	0	\N	\N	0	285278	0	8331-1	3006322		
1381	124	3006322	1997-09-12	1997-09-12 00:00:00	1997-09-12	5001	0	\N	0	0	\N	\N	0	8322	0	8331-1	3006322		
138787	4278	4133840	1998-01-23	1998-01-23 00:00:00	1998-01-23	5001	0	\N	0	0	\N	\N	0	283885	0	127783003	4133840		
27626	863	4024958	1942-04-14	1942-04-14 00:00:00	1942-04-14	5001	0	\N	0	0	\N	\N	0	57165	0	117015009	4024958		
6794	648	3049273	2007-07-26	2007-07-26 00:00:00	2007-07-26	5001	0	\N	0	0	\N	\N	0	42967	0	38265-5	3049273		
113044	3488	4133840	2017-04-21	2017-04-21 00:00:00	2017-04-21	5001	0	\N	0	0	\N	\N	0	231401	0	127783003	4133840		
26800	842	4133840	1975-12-13	1975-12-13 00:00:00	1975-12-13	5001	0	\N	0	0	\N	\N	0	55747	0	127783003	4133840		
52882	4852	3006322	1966-10-12	1966-10-12 00:00:00	1966-10-12	5001	0	\N	0	0	\N	\N	0	322831	0	8331-1	3006322		
69247	2123	4052083	1988-12-21	1988-12-21 00:00:00	1988-12-21	5001	0	\N	0	0	\N	\N	0	141310	0	23426006	4052083		
27771	2554	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	169125	0	6189-5	3006734		
41050	3817	3006322	2008-06-12	2008-06-12 00:00:00	2008-06-12	5001	0	\N	0	0	\N	\N	0	253522	0	8331-1	3006322		
14688	1368	3006322	1958-04-13	1958-04-13 00:00:00	1958-04-13	5001	0	\N	0	0	\N	\N	0	90733	0	8331-1	3006322		
22789	2088	3011505	1998-05-26	1998-05-26 00:00:00	1998-05-26	5001	0	\N	0	0	\N	\N	0	139234	0	19926-5	3011505		
9619	307	4052083	1990-08-02	1990-08-02 00:00:00	1990-08-02	5001	0	\N	0	0	\N	\N	0	20334	0	23426006	4052083		
22688	2077	3006451	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	138284	0	6273-7	3006451		
1987	180	3006451	1990-04-26	1990-04-26 00:00:00	1990-04-26	5001	0	\N	0	0	\N	\N	0	12108	0	6273-7	3006451		
31130	2847	3006322	1990-11-18	1990-11-18 00:00:00	1990-11-18	5001	0	\N	0	0	\N	\N	0	189095	0	8331-1	3006322		
60708	1851	4133840	2015-07-23	2015-07-23 00:00:00	2015-07-23	5001	0	\N	0	0	\N	\N	0	123837	0	127783003	4133840		
49146	4492	3006322	1993-05-11	1993-05-11 00:00:00	1993-05-11	5001	0	\N	0	0	\N	\N	0	299050	0	8331-1	3006322		
8345	788	46235214	1988-12-04	1988-12-04 00:00:00	1988-12-04	5001	0	\N	0	0	\N	\N	0	52405	0	76690-7	46235214		
88736	2749	4052083	1966-09-19	1966-09-19 00:00:00	1966-09-19	5001	0	\N	0	0	\N	\N	0	181800	0	23426006	4052083		
44556	1371	4024958	1984-10-27	1984-10-27 00:00:00	1984-10-27	5001	0	\N	0	0	\N	\N	0	90876	0	117015009	4024958		
122216	3771	4024958	1972-05-19	1972-05-19 00:00:00	1972-05-19	5001	0	\N	0	0	\N	\N	0	250611	0	117015009	4024958		
36399	3343	3001247	1977-07-13	1977-07-13 00:00:00	1977-07-13	5001	0	\N	0	0	\N	\N	0	221770	0	6085-5	3001247		
31990	2915	46235214	2011-07-20	2011-07-20 00:00:00	2011-07-20	5001	0	\N	0	0	\N	\N	0	194382	0	76690-7	46235214		
32023	2919	46235214	2002-10-06	2002-10-06 00:00:00	2002-10-06	5001	0	\N	0	0	\N	\N	0	194589	0	76690-7	46235214		
3324	99	4133840	2018-04-21	2018-04-21 00:00:00	2018-04-21	5001	0	\N	0	0	\N	\N	0	6770	0	127783003	4133840		
117970	3629	4052083	1994-11-18	1994-11-18 00:00:00	1994-11-18	5001	0	\N	0	0	\N	\N	0	241497	0	23426006	4052083		
108569	3353	4052083	1947-01-27	1947-01-27 00:00:00	1947-01-27	5001	0	\N	0	0	\N	\N	0	222414	0	23426006	4052083		
30119	2770	3006322	1951-07-04	1951-07-04 00:00:00	1951-07-04	5001	0	\N	0	0	\N	\N	0	183365	0	8331-1	3006322		
37918	3505	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	232384	0	6082-2	3000876		
3128	299	3011505	2018-06-30	2018-06-30 00:00:00	2018-06-30	5001	0	\N	0	0	\N	\N	0	19986	0	19926-5	3011505		
23679	742	4024958	1968-10-31	1968-10-31 00:00:00	1968-10-31	5001	0	\N	0	0	\N	\N	0	49217	0	117015009	4024958		
113205	3494	4024958	1962-02-22	1962-02-22 00:00:00	1962-02-22	5001	0	\N	0	0	\N	\N	0	231770	0	117015009	4024958		
2191	199	3006322	1952-12-24	1952-12-24 00:00:00	1952-12-24	5001	0	\N	0	0	\N	\N	0	13677	0	8331-1	3006322		
33389	3017	3049273	1960-07-01	1960-07-01 00:00:00	1960-07-01	5001	0	\N	0	0	\N	\N	0	201237	0	38265-5	3049273		
33445	3025	3006734	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	201615	0	6189-5	3006734		
172786	5302	4052083	1992-07-23	1992-07-23 00:00:00	1992-07-23	5001	0	\N	0	0	\N	\N	0	352780	0	23426006	4052083		
16612	1513	3014599	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	101125	0	6106-9	3014599		
40336	3752	40766240	1993-06-01	1993-06-01 00:00:00	1993-06-01	5001	0	\N	0	0	\N	\N	0	249299	0	63513-6	40766240		
44011	4064	3014599	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	270030	0	6106-9	3014599		
29720	2739	3006322	2007-01-05	2007-01-05 00:00:00	2007-01-05	5001	0	\N	0	0	\N	\N	0	181188	0	8331-1	3006322		
51881	4760	3006322	1993-08-19	1993-08-19 00:00:00	1993-08-19	5001	0	\N	0	0	\N	\N	0	317172	0	8331-1	3006322		
46166	4256	3006322	1983-07-24	1983-07-24 00:00:00	1983-07-24	5001	0	\N	0	0	\N	\N	0	282610	0	8331-1	3006322		
48149	4418	3006322	1959-04-20	1959-04-20 00:00:00	1959-04-20	5001	0	\N	0	0	\N	\N	0	293715	0	8331-1	3006322		
51957	4763	3051031	2009-09-06	2009-09-06 00:00:00	2009-09-06	5001	0	\N	0	0	\N	\N	0	317419	0	46240-8	3051031		
8511	807	40766240	1952-03-16	1952-03-16 00:00:00	1952-03-16	5001	0	\N	0	0	\N	\N	0	53557	0	63513-6	40766240		
40113	3739	3006322	2007-07-14	2007-07-14 00:00:00	2007-07-14	5001	0	\N	0	0	\N	\N	0	248463	0	8331-1	3006322		
40189	3744	3006451	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	248741	0	6273-7	3006451		
49608	4514	3001488	1976-06-28	1976-06-28 00:00:00	1976-06-28	5001	0	\N	0	0	\N	\N	0	300670	0	7258-7	3001488		
49632	4514	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	300684	0	6206-7	3012494		
30953	2832	40769194	1994-02-17	1994-02-17 00:00:00	1994-02-17	5001	0	\N	0	0	\N	\N	0	187896	0	66534-9	40769194		
70241	2152	4052083	2005-01-26	2005-01-26 00:00:00	2005-01-26	5001	0	\N	0	0	\N	\N	0	143427	0	23426006	4052083		
34	2	40766240	1935-01-24	1935-01-24 00:00:00	1935-01-24	5001	0	\N	0	0	\N	\N	0	152	0	63513-6	40766240		
68841	2108	4052083	1974-03-09	1974-03-09 00:00:00	1974-03-09	5001	0	\N	0	0	\N	\N	0	140314	0	23426006	4052083		
158171	4859	4024958	1972-03-01	1972-03-01 00:00:00	1972-03-01	5001	0	\N	0	0	\N	\N	0	323233	0	117015009	4024958		
21130	1954	3006322	1997-11-05	1997-11-05 00:00:00	1997-11-05	5001	0	\N	0	0	\N	\N	0	130052	0	8331-1	3006322		
48342	1475	4052083	2000-01-09	2000-01-09 00:00:00	2000-01-09	5001	0	\N	0	0	\N	\N	0	98275	0	23426006	4052083		
48365	1475	4024958	1941-04-02	1941-04-02 00:00:00	1941-04-02	5001	0	\N	0	0	\N	\N	0	98268	0	117015009	4024958		
1742	153	3006322	1951-07-07	1951-07-07 00:00:00	1951-07-07	5001	0	\N	0	0	\N	\N	0	10405	0	8331-1	3006322		
49861	1516	4024958	1959-04-21	1959-04-21 00:00:00	1959-04-21	5001	0	\N	0	0	\N	\N	0	101274	0	117015009	4024958		
44148	4071	40766240	1966-02-26	1966-02-26 00:00:00	1966-02-26	5001	0	\N	0	0	\N	\N	0	270595	0	63513-6	40766240		
19123	1753	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	117215	0	6246-3	3021226		
11145	352	4024958	1994-08-31	1994-08-31 00:00:00	1994-08-31	5001	0	\N	0	0	\N	\N	0	23438	0	117015009	4024958		
46676	4299	3006322	1995-02-09	1995-02-09 00:00:00	1995-02-09	5001	0	\N	0	0	\N	\N	0	285285	0	8331-1	3006322		
1382	124	3019406	1987-04-02	1987-04-02 00:00:00	1987-04-02	5001	0	\N	0	0	\N	\N	0	8296	0	6158-0	3019406		
138790	4278	4133840	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	283884	0	127783003	4133840		
101539	3118	4133840	2004-12-19	2004-12-19 00:00:00	2004-12-19	5001	0	\N	0	0	\N	\N	0	207426	0	127783003	4133840		
6795	648	3049273	2000-02-03	2000-02-03 00:00:00	2000-02-03	5001	0	\N	0	0	\N	\N	0	42965	0	38265-5	3049273		
113048	3488	4133840	2007-02-23	2007-02-23 00:00:00	2007-02-23	5001	0	\N	0	0	\N	\N	0	231376	0	127783003	4133840		
26801	842	4133840	1971-11-20	1971-11-20 00:00:00	1971-11-20	5001	0	\N	0	0	\N	\N	0	55745	0	127783003	4133840		
52883	4852	3006322	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	322775	0	8331-1	3006322		
57990	1766	4133840	1992-06-30	1992-06-30 00:00:00	1992-06-30	5001	0	\N	0	0	\N	\N	0	118181	0	127783003	4133840		
27772	2554	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	169125	0	6273-7	3006451		
41051	3817	3006322	1984-12-19	1984-12-19 00:00:00	1984-12-19	5001	0	\N	0	0	\N	\N	0	253488	0	8331-1	3006322		
14689	1368	3006322	2018-08-20	2018-08-20 00:00:00	2018-08-20	5001	0	\N	0	0	\N	\N	0	90736	0	8331-1	3006322		
22790	2088	3011505	1980-09-09	1980-09-09 00:00:00	1980-09-09	5001	0	\N	0	0	\N	\N	0	139275	0	19926-5	3011505		
9624	308	4052083	1964-11-09	1964-11-09 00:00:00	1964-11-09	5001	0	\N	0	0	\N	\N	0	20457	0	23426006	4052083		
22689	2077	3014599	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	138284	0	6106-9	3014599		
1988	180	3021226	1990-04-26	1990-04-26 00:00:00	1990-04-26	5001	0	\N	0	0	\N	\N	0	12108	0	6246-3	3021226		
31131	2847	3006322	2016-05-19	2016-05-19 00:00:00	2016-05-19	5001	0	\N	0	0	\N	\N	0	189114	0	8331-1	3006322		
60732	1852	4052083	1974-05-03	1974-05-03 00:00:00	1974-05-03	5001	0	\N	0	0	\N	\N	0	123893	0	23426006	4052083		
49148	4492	46235214	2005-12-19	2005-12-19 00:00:00	2005-12-19	5001	0	\N	0	0	\N	\N	0	299075	0	76690-7	46235214		
8347	788	40766240	1988-12-04	1988-12-04 00:00:00	1988-12-04	5001	0	\N	0	0	\N	\N	0	52405	0	63513-6	40766240		
88744	2749	4024958	1961-12-16	1961-12-16 00:00:00	1961-12-16	5001	0	\N	0	0	\N	\N	0	181783	0	117015009	4024958		
55849	1702	4024958	1978-05-03	1978-05-03 00:00:00	1978-05-03	5001	0	\N	0	0	\N	\N	0	113807	0	117015009	4024958		
99496	3053	4024958	1992-11-15	1992-11-15 00:00:00	1992-11-15	5001	0	\N	0	0	\N	\N	0	203095	0	117015009	4024958		
36400	3343	3036780	1977-07-13	1977-07-13 00:00:00	1977-07-13	5001	0	\N	0	0	\N	\N	0	221770	0	6095-4	3036780		
31991	2915	40766240	2011-07-20	2011-07-20 00:00:00	2011-07-20	5001	0	\N	0	0	\N	\N	0	194382	0	63513-6	40766240		
32024	2919	3051031	2002-10-06	2002-10-06 00:00:00	2002-10-06	5001	0	\N	0	0	\N	\N	0	194589	0	46240-8	3051031		
3325	99	4133840	2015-04-04	2015-04-04 00:00:00	2015-04-04	5001	0	\N	0	0	\N	\N	0	6752	0	127783003	4133840		
117975	3629	4052083	1988-09-30	1988-09-30 00:00:00	1988-09-30	5001	0	\N	0	0	\N	\N	0	241458	0	23426006	4052083		
108574	3353	4052083	1955-04-02	1955-04-02 00:00:00	1955-04-02	5001	0	\N	0	0	\N	\N	0	222390	0	23426006	4052083		
30120	2770	3006322	1935-06-23	1935-06-23 00:00:00	1935-06-23	5001	0	\N	0	0	\N	\N	0	183332	0	8331-1	3006322		
37919	3505	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	232384	0	6106-9	3014599		
3129	299	3011505	2017-01-07	2017-01-07 00:00:00	2017-01-07	5001	0	\N	0	0	\N	\N	0	19982	0	19926-5	3011505		
138517	4270	4052083	1980-12-06	1980-12-06 00:00:00	1980-12-06	5001	0	\N	0	0	\N	\N	0	283448	0	23426006	4052083		
113207	3494	4133840	1999-04-29	1999-04-29 00:00:00	1999-04-29	5001	0	\N	0	0	\N	\N	0	231752	0	127783003	4133840		
2192	199	3006322	2009-11-10	2009-11-10 00:00:00	2009-11-10	5001	0	\N	0	0	\N	\N	0	13655	0	8331-1	3006322		
33390	3017	3006322	2011-10-14	2011-10-14 00:00:00	2011-10-14	5001	0	\N	0	0	\N	\N	0	201215	0	8331-1	3006322		
33446	3025	3006322	1985-05-01	1985-05-01 00:00:00	1985-05-01	5001	0	\N	0	0	\N	\N	0	201717	0	8331-1	3006322		
172798	5302	4052083	1996-01-03	1996-01-03 00:00:00	1996-01-03	5001	0	\N	0	0	\N	\N	0	352789	0	23426006	4052083		
16613	1513	3005136	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	101125	0	6075-6	3005136		
40338	3752	3051031	1993-06-01	1993-06-01 00:00:00	1993-06-01	5001	0	\N	0	0	\N	\N	0	249299	0	46240-8	3051031		
44012	4064	3006734	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	270030	0	6189-5	3006734		
29721	2740	3006322	1988-03-28	1988-03-28 00:00:00	1988-03-28	5001	0	\N	0	0	\N	\N	0	181286	0	8331-1	3006322		
51882	4760	3006322	1968-09-06	1968-09-06 00:00:00	1968-09-06	5001	0	\N	0	0	\N	\N	0	317174	0	8331-1	3006322		
46167	4256	3006322	1956-12-14	1956-12-14 00:00:00	1956-12-14	5001	0	\N	0	0	\N	\N	0	282606	0	8331-1	3006322		
48150	4418	3006322	2000-06-05	2000-06-05 00:00:00	2000-06-05	5001	0	\N	0	0	\N	\N	0	293782	0	8331-1	3006322		
51958	4763	3006322	1989-06-25	1989-06-25 00:00:00	1989-06-25	5001	0	\N	0	0	\N	\N	0	317428	0	8331-1	3006322		
8513	807	40758406	1996-09-01	1996-09-01 00:00:00	1996-09-01	5001	0	\N	0	0	\N	\N	0	53627	0	55277-8	40758406		
40114	3739	3006322	2007-02-01	2007-02-01 00:00:00	2007-02-01	5001	0	\N	0	0	\N	\N	0	248451	0	8331-1	3006322		
40190	3744	3000876	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	248741	0	6082-2	3000876		
49609	4514	3020655	1976-06-28	1976-06-28 00:00:00	1976-06-28	5001	0	\N	0	0	\N	\N	0	300670	0	6844-5	3020655		
49633	4514	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	300684	0	6106-9	3014599		
30954	2832	3027231	1997-09-06	1997-09-06 00:00:00	1997-09-06	5001	0	\N	0	0	\N	\N	0	187932	0	6276-0	3027231		
10727	339	4024958	1993-04-22	1993-04-22 00:00:00	1993-04-22	5001	0	\N	0	0	\N	\N	0	22619	0	117015009	4024958		
36	2	40758406	1935-01-24	1935-01-24 00:00:00	1935-01-24	5001	0	\N	0	0	\N	\N	0	152	0	55277-8	40758406		
68845	2108	4024958	1950-11-25	1950-11-25 00:00:00	1950-11-25	5001	0	\N	0	0	\N	\N	0	140373	0	117015009	4024958		
158184	4860	4024958	1995-12-03	1995-12-03 00:00:00	1995-12-03	5001	0	\N	0	0	\N	\N	0	323344	0	117015009	4024958		
21132	1954	40766240	2003-02-07	2003-02-07 00:00:00	2003-02-07	5001	0	\N	0	0	\N	\N	0	130001	0	63513-6	40766240		
75918	2332	4024958	1960-09-02	1960-09-02 00:00:00	1960-09-02	5001	0	\N	0	0	\N	\N	0	155045	0	117015009	4024958		
48376	1476	4024958	1959-10-28	1959-10-28 00:00:00	1959-10-28	5001	0	\N	0	0	\N	\N	0	98535	0	117015009	4024958		
1743	154	3006322	1994-03-05	1994-03-05 00:00:00	1994-03-05	5001	0	\N	0	0	\N	\N	0	10500	0	8331-1	3006322		
49866	1516	4024958	1971-02-28	1971-02-28 00:00:00	1971-02-28	5001	0	\N	0	0	\N	\N	0	101293	0	117015009	4024958		
44149	4071	3051031	1966-02-26	1966-02-26 00:00:00	1966-02-26	5001	0	\N	0	0	\N	\N	0	270595	0	46240-8	3051031		
19124	1753	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	117215	0	6276-0	3027231		
11159	352	4052083	1981-09-26	1981-09-26 00:00:00	1981-09-26	5001	0	\N	0	0	\N	\N	0	23436	0	23426006	4052083		
46677	4299	3006322	1978-11-15	1978-11-15 00:00:00	1978-11-15	5001	0	\N	0	0	\N	\N	0	285284	0	8331-1	3006322		
1383	124	3012494	1987-04-02	1987-04-02 00:00:00	1987-04-02	5001	0	\N	0	0	\N	\N	0	8296	0	6206-7	3012494		
72831	2237	4052083	1968-02-05	1968-02-05 00:00:00	1968-02-05	5001	0	\N	0	0	\N	\N	0	148789	0	23426006	4052083		
101542	3118	4133840	2002-12-29	2002-12-29 00:00:00	2002-12-29	5001	0	\N	0	0	\N	\N	0	207499	0	127783003	4133840		
6796	648	3006322	1955-11-10	1955-11-10 00:00:00	1955-11-10	5001	0	\N	0	0	\N	\N	0	42949	0	8331-1	3006322		
120646	3721	4024958	2015-02-13	2015-02-13 00:00:00	2015-02-13	5001	0	\N	0	0	\N	\N	0	247329	0	117015009	4024958		
26802	842	4133840	2015-10-24	2015-10-24 00:00:00	2015-10-24	5001	0	\N	0	0	\N	\N	0	55685	0	127783003	4133840		
52884	4853	3006322	1965-04-09	1965-04-09 00:00:00	1965-04-09	5001	0	\N	0	0	\N	\N	0	322867	0	8331-1	3006322		
57993	1766	4133840	2003-09-09	2003-09-09 00:00:00	2003-09-09	5001	0	\N	0	0	\N	\N	0	118179	0	127783003	4133840		
27773	2554	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	169125	0	6106-9	3014599		
41052	3817	3006322	2001-02-06	2001-02-06 00:00:00	2001-02-06	5001	0	\N	0	0	\N	\N	0	253521	0	8331-1	3006322		
14690	1368	3006322	2008-02-28	2008-02-28 00:00:00	2008-02-28	5001	0	\N	0	0	\N	\N	0	90713	0	8331-1	3006322		
22791	2088	3011505	2000-06-06	2000-06-06 00:00:00	2000-06-06	5001	0	\N	0	0	\N	\N	0	139172	0	19926-5	3011505		
9625	308	4052083	1961-08-11	1961-08-11 00:00:00	1961-08-11	5001	0	\N	0	0	\N	\N	0	20455	0	23426006	4052083		
22690	2077	3019406	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	138284	0	6158-0	3019406		
1989	180	3012494	1990-04-26	1990-04-26 00:00:00	1990-04-26	5001	0	\N	0	0	\N	\N	0	12108	0	6206-7	3012494		
31132	2847	3006322	1975-03-09	1975-03-09 00:00:00	1975-03-09	5001	0	\N	0	0	\N	\N	0	189052	0	8331-1	3006322		
60759	1852	4024958	1987-03-22	1987-03-22 00:00:00	1987-03-22	5001	0	\N	0	0	\N	\N	0	123889	0	117015009	4024958		
49149	4492	40766240	2005-12-19	2005-12-19 00:00:00	2005-12-19	5001	0	\N	0	0	\N	\N	0	299075	0	63513-6	40766240		
8349	788	40758406	1988-12-04	1988-12-04 00:00:00	1988-12-04	5001	0	\N	0	0	\N	\N	0	52405	0	55277-8	40758406		
110750	3420	4024958	1998-12-27	1998-12-27 00:00:00	1998-12-27	5001	0	\N	0	0	\N	\N	0	226873	0	117015009	4024958		
55853	1702	4024958	1975-11-30	1975-11-30 00:00:00	1975-11-30	5001	0	\N	0	0	\N	\N	0	113806	0	117015009	4024958		
110807	3422	4052083	1981-03-21	1981-03-21 00:00:00	1981-03-21	5001	0	\N	0	0	\N	\N	0	227025	0	23426006	4052083		
36401	3343	3001488	1977-07-13	1977-07-13 00:00:00	1977-07-13	5001	0	\N	0	0	\N	\N	0	221770	0	7258-7	3001488		
31993	2915	40758406	2011-07-20	2011-07-20 00:00:00	2011-07-20	5001	0	\N	0	0	\N	\N	0	194382	0	55277-8	40758406		
32025	2919	40758406	2002-10-06	2002-10-06 00:00:00	2002-10-06	5001	0	\N	0	0	\N	\N	0	194589	0	55277-8	40758406		
3348	101	4024958	1983-04-17	1983-04-17 00:00:00	1983-04-17	5001	0	\N	0	0	\N	\N	0	6907	0	117015009	4024958		
129940	4006	4052083	1952-07-23	1952-07-23 00:00:00	1952-07-23	5001	0	\N	0	0	\N	\N	0	266136	0	23426006	4052083		
108577	3353	4052083	1962-04-23	1962-04-23 00:00:00	1962-04-23	5001	0	\N	0	0	\N	\N	0	222416	0	23426006	4052083		
30121	2770	3049273	2004-11-04	2004-11-04 00:00:00	2004-11-04	5001	0	\N	0	0	\N	\N	0	183305	0	38265-5	3049273		
37920	3505	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	232384	0	6158-0	3019406		
3130	299	3011505	2013-12-21	2013-12-21 00:00:00	2013-12-21	5001	0	\N	0	0	\N	\N	0	19991	0	19926-5	3011505		
149829	4591	4052083	1964-06-18	1964-06-18 00:00:00	1964-06-18	5001	0	\N	0	0	\N	\N	0	305924	0	23426006	4052083		
113209	3494	4133840	2001-05-03	2001-05-03 00:00:00	2001-05-03	5001	0	\N	0	0	\N	\N	0	231734	0	127783003	4133840		
2193	199	3006322	1957-07-11	1957-07-11 00:00:00	1957-07-11	5001	0	\N	0	0	\N	\N	0	13672	0	8331-1	3006322		
33391	3017	3006322	1973-08-21	1973-08-21 00:00:00	1973-08-21	5001	0	\N	0	0	\N	\N	0	201210	0	8331-1	3006322		
33447	3025	3006451	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	201695	0	6273-7	3006451		
172800	5302	4052083	1980-04-19	1980-04-19 00:00:00	1980-04-19	5001	0	\N	0	0	\N	\N	0	352770	0	23426006	4052083		
16614	1513	3027231	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	101125	0	6276-0	3027231		
40339	3752	46235214	1993-06-01	1993-06-01 00:00:00	1993-06-01	5001	0	\N	0	0	\N	\N	0	249299	0	76690-7	46235214		
44013	4064	3020655	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	270030	0	6844-5	3020655		
29722	2740	3006322	1990-07-30	1990-07-30 00:00:00	1990-07-30	5001	0	\N	0	0	\N	\N	0	181293	0	8331-1	3006322		
51883	4760	3006322	1975-12-11	1975-12-11 00:00:00	1975-12-11	5001	0	\N	0	0	\N	\N	0	317121	0	8331-1	3006322		
57460	5279	3006322	1965-02-16	1965-02-16 00:00:00	1965-02-16	5001	0	\N	0	0	\N	\N	0	351145	0	8331-1	3006322		
48151	4418	3006322	2012-03-25	2012-03-25 00:00:00	2012-03-25	5001	0	\N	0	0	\N	\N	0	293753	0	8331-1	3006322		
51959	4763	46235214	2009-11-05	2009-11-05 00:00:00	2009-11-05	5001	0	\N	0	0	\N	\N	0	317381	0	76690-7	46235214		
8514	807	3051031	1996-09-01	1996-09-01 00:00:00	1996-09-01	5001	0	\N	0	0	\N	\N	0	53627	0	46240-8	3051031		
99577	3057	4024958	1938-10-28	1938-10-28 00:00:00	1938-10-28	5001	0	\N	0	0	\N	\N	0	203357	0	117015009	4024958		
40191	3744	3023430	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	248741	0	6833-8	3023430		
49610	4514	3006734	1976-06-28	1976-06-28 00:00:00	1976-06-28	5001	0	\N	0	0	\N	\N	0	300670	0	6189-5	3006734		
49634	4514	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	300684	0	6158-0	3019406		
30955	2832	3015076	1997-09-06	1997-09-06 00:00:00	1997-09-06	5001	0	\N	0	0	\N	\N	0	187932	0	6248-9	3015076		
10729	339	4024958	1996-12-16	1996-12-16 00:00:00	1996-12-16	5001	0	\N	0	0	\N	\N	0	22621	0	117015009	4024958		
38	2	3011505	1999-07-20	1999-07-20 00:00:00	1999-07-20	5001	0	\N	0	0	\N	\N	0	88	0	19926-5	3011505		
68848	2109	4024958	1985-11-11	1985-11-11 00:00:00	1985-11-11	5001	0	\N	0	0	\N	\N	0	140411	0	117015009	4024958		
53826	4935	3006322	2017-03-24	2017-03-24 00:00:00	2017-03-24	5001	0	\N	0	0	\N	\N	0	328097	0	8331-1	3006322		
21133	1954	46235214	2003-02-07	2003-02-07 00:00:00	2003-02-07	5001	0	\N	0	0	\N	\N	0	130001	0	76690-7	46235214		
75919	2332	4024958	2001-12-08	2001-12-08 00:00:00	2001-12-08	5001	0	\N	0	0	\N	\N	0	155072	0	117015009	4024958		
48406	1476	4024958	2002-11-07	2002-11-07 00:00:00	2002-11-07	5001	0	\N	0	0	\N	\N	0	98419	0	117015009	4024958		
1744	154	3006322	1989-01-20	1989-01-20 00:00:00	1989-01-20	5001	0	\N	0	0	\N	\N	0	10499	0	8331-1	3006322		
74985	2298	4052083	2018-02-08	2018-02-08 00:00:00	2018-02-08	5001	0	\N	0	0	\N	\N	0	153019	0	23426006	4052083		
44150	4071	40758406	1966-07-26	1966-07-26 00:00:00	1966-07-26	5001	0	\N	0	0	\N	\N	0	270617	0	55277-8	40758406		
19125	1753	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	117215	0	6158-0	3019406		
11174	354	4133840	2015-02-26	2015-02-26 00:00:00	2015-02-26	5001	0	\N	0	0	\N	\N	0	23593	0	127783003	4133840		
82712	2554	4052083	1973-12-29	1973-12-29 00:00:00	1973-12-29	5001	0	\N	0	0	\N	\N	0	169266	0	23426006	4052083		
1384	124	3027231	1987-04-02	1987-04-02 00:00:00	1987-04-02	5001	0	\N	0	0	\N	\N	0	8296	0	6276-0	3027231		
72839	2237	4024958	1955-10-18	1955-10-18 00:00:00	1955-10-18	5001	0	\N	0	0	\N	\N	0	148760	0	117015009	4024958		
101562	3119	4024958	1984-09-26	1984-09-26 00:00:00	1984-09-26	5001	0	\N	0	0	\N	\N	0	207584	0	117015009	4024958		
6797	648	3049273	2001-02-27	2001-02-27 00:00:00	2001-02-27	5001	0	\N	0	0	\N	\N	0	42966	0	38265-5	3049273		
131927	4064	4024958	1961-03-07	1961-03-07 00:00:00	1961-03-07	5001	0	\N	0	0	\N	\N	0	270071	0	117015009	4024958		
26805	842	4133840	1977-12-24	1977-12-24 00:00:00	1977-12-24	5001	0	\N	0	0	\N	\N	0	55663	0	127783003	4133840		
52885	4853	3006322	1970-07-12	1970-07-12 00:00:00	1970-07-12	5001	0	\N	0	0	\N	\N	0	322924	0	8331-1	3006322		
57994	1766	4133840	1998-06-02	1998-06-02 00:00:00	1998-06-02	5001	0	\N	0	0	\N	\N	0	118161	0	127783003	4133840		
27774	2554	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	169125	0	6082-2	3000876		
41056	3820	3006322	1992-05-21	1992-05-21 00:00:00	1992-05-21	5001	0	\N	0	0	\N	\N	0	253617	0	8331-1	3006322		
14691	1368	3006322	1976-09-02	1976-09-02 00:00:00	1976-09-02	5001	0	\N	0	0	\N	\N	0	90708	0	8331-1	3006322		
22792	2088	3011505	2008-02-12	2008-02-12 00:00:00	2008-02-12	5001	0	\N	0	0	\N	\N	0	139282	0	19926-5	3011505		
9635	308	4024958	1966-04-01	1966-04-01 00:00:00	1966-04-01	5001	0	\N	0	0	\N	\N	0	20422	0	117015009	4024958		
22691	2077	3001488	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	138284	0	7258-7	3001488		
1990	180	3014599	1990-04-26	1990-04-26 00:00:00	1990-04-26	5001	0	\N	0	0	\N	\N	0	12108	0	6106-9	3014599		
31133	2847	3006322	1968-12-23	1968-12-23 00:00:00	1968-12-23	5001	0	\N	0	0	\N	\N	0	189108	0	8331-1	3006322		
2073	190	3006322	1963-10-10	1963-10-10 00:00:00	1963-10-10	5001	0	\N	0	0	\N	\N	0	12982	0	8331-1	3006322		
49150	4492	3051031	2005-12-19	2005-12-19 00:00:00	2005-12-19	5001	0	\N	0	0	\N	\N	0	299075	0	46240-8	3051031		
8351	788	46235214	1988-11-04	1988-11-04 00:00:00	1988-11-04	5001	0	\N	0	0	\N	\N	0	52432	0	76690-7	46235214		
110755	3420	4024958	1980-01-22	1980-01-22 00:00:00	1980-01-22	5001	0	\N	0	0	\N	\N	0	226866	0	117015009	4024958		
55856	1702	4024958	1967-10-03	1967-10-03 00:00:00	1967-10-03	5001	0	\N	0	0	\N	\N	0	113799	0	117015009	4024958		
110808	3422	4024958	1975-03-08	1975-03-08 00:00:00	1975-03-08	5001	0	\N	0	0	\N	\N	0	226953	0	117015009	4024958		
36402	3343	3006734	1977-07-13	1977-07-13 00:00:00	1977-07-13	5001	0	\N	0	0	\N	\N	0	221770	0	6189-5	3006734		
31995	2915	3051031	2011-07-20	2011-07-20 00:00:00	2011-07-20	5001	0	\N	0	0	\N	\N	0	194382	0	46240-8	3051031		
32028	2919	40766240	2002-10-06	2002-10-06 00:00:00	2002-10-06	5001	0	\N	0	0	\N	\N	0	194589	0	63513-6	40766240		
3353	101	4024958	1930-05-06	1930-05-06 00:00:00	1930-05-06	5001	0	\N	0	0	\N	\N	0	6833	0	117015009	4024958		
141289	4355	4052083	1994-03-13	1994-03-13 00:00:00	1994-03-13	5001	0	\N	0	0	\N	\N	0	288988	0	23426006	4052083		
108581	3353	4052083	1978-08-02	1978-08-02 00:00:00	1978-08-02	5001	0	\N	0	0	\N	\N	0	222383	0	23426006	4052083		
30122	2770	3006322	1953-07-08	1953-07-08 00:00:00	1953-07-08	5001	0	\N	0	0	\N	\N	0	183398	0	8331-1	3006322		
37921	3505	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	232384	0	6248-9	3015076		
3131	299	3006322	1962-04-09	1962-04-09 00:00:00	1962-04-09	5001	0	\N	0	0	\N	\N	0	20012	0	8331-1	3006322		
149861	4593	4052083	1977-02-01	1977-02-01 00:00:00	1977-02-01	5001	0	\N	0	0	\N	\N	0	306034	0	23426006	4052083		
113212	3494	4133840	2012-10-25	2012-10-25 00:00:00	2012-10-25	5001	0	\N	0	0	\N	\N	0	231755	0	127783003	4133840		
2194	199	3006322	1947-12-01	1947-12-01 00:00:00	1947-12-01	5001	0	\N	0	0	\N	\N	0	13636	0	8331-1	3006322		
33392	3017	3006322	2005-05-05	2005-05-05 00:00:00	2005-05-05	5001	0	\N	0	0	\N	\N	0	201230	0	8331-1	3006322		
33448	3025	3005136	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	201695	0	6075-6	3005136		
172805	5302	4024958	1989-01-15	1989-01-15 00:00:00	1989-01-15	5001	0	\N	0	0	\N	\N	0	352811	0	117015009	4024958		
16615	1513	3036780	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	101125	0	6095-4	3036780		
40340	3752	40758406	1993-06-01	1993-06-01 00:00:00	1993-06-01	5001	0	\N	0	0	\N	\N	0	249299	0	55277-8	40758406		
44014	4064	3023430	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	270030	0	6833-8	3023430		
29723	2740	3006322	1978-09-06	1978-09-06 00:00:00	1978-09-06	5001	0	\N	0	0	\N	\N	0	181272	0	8331-1	3006322		
51884	4761	3012494	1996-11-11	1996-11-11 00:00:00	1996-11-11	5001	0	\N	0	0	\N	\N	0	317251	0	6206-7	3012494		
57461	5279	3006322	2016-10-22	2016-10-22 00:00:00	2016-10-22	5001	0	\N	0	0	\N	\N	0	351206	0	8331-1	3006322		
7877	754	3006322	1961-10-30	1961-10-30 00:00:00	1961-10-30	5001	0	\N	0	0	\N	\N	0	49848	0	8331-1	3006322		
51961	4763	40758406	2009-11-05	2009-11-05 00:00:00	2009-11-05	5001	0	\N	0	0	\N	\N	0	317381	0	55277-8	40758406		
26754	2466	3049273	1989-06-25	1989-06-25 00:00:00	1989-06-25	5001	0	\N	0	0	\N	\N	0	163499	0	38265-5	3049273		
99592	3057	4024958	1966-07-16	1966-07-16 00:00:00	1966-07-16	5001	0	\N	0	0	\N	\N	0	203362	0	117015009	4024958		
40192	3744	3036780	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	248741	0	6095-4	3036780		
49611	4514	3023430	1976-06-28	1976-06-28 00:00:00	1976-06-28	5001	0	\N	0	0	\N	\N	0	300670	0	6833-8	3023430		
49635	4514	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	300684	0	6075-6	3005136		
30956	2832	3012494	1997-09-06	1997-09-06 00:00:00	1997-09-06	5001	0	\N	0	0	\N	\N	0	187932	0	6206-7	3012494		
10731	339	4024958	1997-03-25	1997-03-25 00:00:00	1997-03-25	5001	0	\N	0	0	\N	\N	0	22622	0	117015009	4024958		
39	2	3011505	2004-08-17	2004-08-17 00:00:00	2004-08-17	5001	0	\N	0	0	\N	\N	0	188	0	19926-5	3011505		
152229	4665	4024958	1986-12-03	1986-12-03 00:00:00	1986-12-03	5001	0	\N	0	0	\N	\N	0	310899	0	117015009	4024958		
53827	4935	3006322	1965-08-21	1965-08-21 00:00:00	1965-08-21	5001	0	\N	0	0	\N	\N	0	328032	0	8331-1	3006322		
21135	1954	3051031	2003-02-07	2003-02-07 00:00:00	2003-02-07	5001	0	\N	0	0	\N	\N	0	130001	0	46240-8	3051031		
75922	2332	4052083	1960-06-13	1960-06-13 00:00:00	1960-06-13	5001	0	\N	0	0	\N	\N	0	155102	0	23426006	4052083		
29918	924	4024958	1995-08-11	1995-08-11 00:00:00	1995-08-11	5001	0	\N	0	0	\N	\N	0	61548	0	117015009	4024958		
1745	154	3006322	1979-07-02	1979-07-02 00:00:00	1979-07-02	5001	0	\N	0	0	\N	\N	0	10433	0	8331-1	3006322		
74994	2298	4024958	1972-02-23	1972-02-23 00:00:00	1972-02-23	5001	0	\N	0	0	\N	\N	0	153003	0	117015009	4024958		
44152	4071	40766240	1966-07-26	1966-07-26 00:00:00	1966-07-26	5001	0	\N	0	0	\N	\N	0	270617	0	63513-6	40766240		
19126	1753	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	117215	0	6095-4	3036780		
11177	354	4133840	2019-03-21	2019-03-21 00:00:00	2019-03-21	5001	0	\N	0	0	\N	\N	0	23524	0	127783003	4133840		
82714	2554	4052083	1991-07-22	1991-07-22 00:00:00	1991-07-22	5001	0	\N	0	0	\N	\N	0	169153	0	23426006	4052083		
1385	124	3021226	1987-04-02	1987-04-02 00:00:00	1987-04-02	5001	0	\N	0	0	\N	\N	0	8296	0	6246-3	3021226		
84141	2602	4024958	2019-06-11	2019-06-11 00:00:00	2019-06-11	5001	0	\N	0	0	\N	\N	0	172161	0	117015009	4024958		
101566	3119	4052083	2008-06-27	2008-06-27 00:00:00	2008-06-27	5001	0	\N	0	0	\N	\N	0	207577	0	23426006	4052083		
6798	648	3006322	1942-09-12	1942-09-12 00:00:00	1942-09-12	5001	0	\N	0	0	\N	\N	0	42948	0	8331-1	3006322		
131956	4064	4024958	1991-02-08	1991-02-08 00:00:00	1991-02-08	5001	0	\N	0	0	\N	\N	0	270001	0	117015009	4024958		
95722	2935	4024958	2001-01-27	2001-01-27 00:00:00	2001-01-27	5001	0	\N	0	0	\N	\N	0	195686	0	117015009	4024958		
52886	4853	3006322	1965-08-22	1965-08-22 00:00:00	1965-08-22	5001	0	\N	0	0	\N	\N	0	322868	0	8331-1	3006322		
57996	1766	4052083	1994-05-13	1994-05-13 00:00:00	1994-05-13	5001	0	\N	0	0	\N	\N	0	118177	0	23426006	4052083		
27775	2554	3006322	1963-12-17	1963-12-17 00:00:00	1963-12-17	5001	0	\N	0	0	\N	\N	0	169095	0	8331-1	3006322		
41057	3820	3006322	1968-07-05	1968-07-05 00:00:00	1968-07-05	5001	0	\N	0	0	\N	\N	0	253657	0	8331-1	3006322		
14753	1371	3006322	1978-12-17	1978-12-17 00:00:00	1978-12-17	5001	0	\N	0	0	\N	\N	0	90937	0	8331-1	3006322		
22793	2088	3011505	1972-07-25	1972-07-25 00:00:00	1972-07-25	5001	0	\N	0	0	\N	\N	0	139311	0	19926-5	3011505		
9639	308	4024958	1980-11-29	1980-11-29 00:00:00	1980-11-29	5001	0	\N	0	0	\N	\N	0	20401	0	117015009	4024958		
22692	2077	3020655	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	138284	0	6844-5	3020655		
72570	2226	4024958	1993-11-06	1993-11-06 00:00:00	1993-11-06	5001	0	\N	0	0	\N	\N	0	148075	0	117015009	4024958		
31134	2847	3006322	1989-11-12	1989-11-12 00:00:00	1989-11-12	5001	0	\N	0	0	\N	\N	0	189112	0	8331-1	3006322		
2074	190	3006322	1961-03-13	1961-03-13 00:00:00	1961-03-13	5001	0	\N	0	0	\N	\N	0	12981	0	8331-1	3006322		
49152	4492	40758406	2005-12-19	2005-12-19 00:00:00	2005-12-19	5001	0	\N	0	0	\N	\N	0	299075	0	55277-8	40758406		
8353	788	40758406	1988-11-04	1988-11-04 00:00:00	1988-11-04	5001	0	\N	0	0	\N	\N	0	52432	0	55277-8	40758406		
110757	3420	4024958	1972-10-15	1972-10-15 00:00:00	1972-10-15	5001	0	\N	0	0	\N	\N	0	226905	0	117015009	4024958		
55864	1703	4024958	1976-03-05	1976-03-05 00:00:00	1976-03-05	5001	0	\N	0	0	\N	\N	0	113911	0	117015009	4024958		
110809	3422	4024958	2012-09-19	2012-09-19 00:00:00	2012-09-19	5001	0	\N	0	0	\N	\N	0	227029	0	117015009	4024958		
36403	3343	3020655	1977-07-13	1977-07-13 00:00:00	1977-07-13	5001	0	\N	0	0	\N	\N	0	221770	0	6844-5	3020655		
31996	2915	3006322	2012-07-23	2012-07-23 00:00:00	2012-07-23	5001	0	\N	0	0	\N	\N	0	194245	0	8331-1	3006322		
32029	2919	3006322	1975-04-13	1975-04-13 00:00:00	1975-04-13	5001	0	\N	0	0	\N	\N	0	194588	0	8331-1	3006322		
3358	101	4024958	1995-03-25	1995-03-25 00:00:00	1995-03-25	5001	0	\N	0	0	\N	\N	0	6937	0	117015009	4024958		
141294	4355	4052083	2019-04-12	2019-04-12 00:00:00	2019-04-12	5001	0	\N	0	0	\N	\N	0	288947	0	23426006	4052083		
62852	1928	4052083	2004-09-24	2004-09-24 00:00:00	2004-09-24	5001	0	\N	0	0	\N	\N	0	128371	0	23426006	4052083		
30123	2770	3006322	1940-11-21	1940-11-21 00:00:00	1940-11-21	5001	0	\N	0	0	\N	\N	0	183309	0	8331-1	3006322		
37922	3505	3006322	1949-11-14	1949-11-14 00:00:00	1949-11-14	5001	0	\N	0	0	\N	\N	0	232438	0	8331-1	3006322		
3132	299	40758406	1963-06-07	1963-06-07 00:00:00	1963-06-07	5001	0	\N	0	0	\N	\N	0	20013	0	55277-8	40758406		
149864	4593	4024958	2002-08-03	2002-08-03 00:00:00	2002-08-03	5001	0	\N	0	0	\N	\N	0	306036	0	117015009	4024958		
113215	3494	4133840	2015-11-12	2015-11-12 00:00:00	2015-11-12	5001	0	\N	0	0	\N	\N	0	231792	0	127783003	4133840		
2195	199	3006322	1951-05-26	1951-05-26 00:00:00	1951-05-26	5001	0	\N	0	0	\N	\N	0	13676	0	8331-1	3006322		
33393	3017	3006322	1969-07-31	1969-07-31 00:00:00	1969-07-31	5001	0	\N	0	0	\N	\N	0	201272	0	8331-1	3006322		
33449	3025	3001247	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	201695	0	6085-5	3001247		
172808	5302	4024958	1976-02-10	1976-02-10 00:00:00	1976-02-10	5001	0	\N	0	0	\N	\N	0	352769	0	117015009	4024958		
16616	1513	3012494	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	101125	0	6206-7	3012494		
40342	3752	40758406	1993-10-29	1993-10-29 00:00:00	1993-10-29	5001	0	\N	0	0	\N	\N	0	249305	0	55277-8	40758406		
44015	4064	3000876	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	270030	0	6082-2	3000876		
29724	2740	3006322	1977-04-01	1977-04-01 00:00:00	1977-04-01	5001	0	\N	0	0	\N	\N	0	181292	0	8331-1	3006322		
51885	4761	3036780	1996-11-11	1996-11-11 00:00:00	1996-11-11	5001	0	\N	0	0	\N	\N	0	317251	0	6095-4	3036780		
57462	5279	3006322	1949-12-09	1949-12-09 00:00:00	1949-12-09	5001	0	\N	0	0	\N	\N	0	351212	0	8331-1	3006322		
7878	754	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	49966	0	6082-2	3000876		
51962	4763	40766240	2009-11-05	2009-11-05 00:00:00	2009-11-05	5001	0	\N	0	0	\N	\N	0	317381	0	63513-6	40766240		
26755	2466	3006322	2002-02-04	2002-02-04 00:00:00	2002-02-04	5001	0	\N	0	0	\N	\N	0	163491	0	8331-1	3006322		
99609	3057	4024958	1949-01-08	1949-01-08 00:00:00	1949-01-08	5001	0	\N	0	0	\N	\N	0	203334	0	117015009	4024958		
40193	3744	3015076	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	248741	0	6248-9	3015076		
49612	4514	3015076	1976-06-28	1976-06-28 00:00:00	1976-06-28	5001	0	\N	0	0	\N	\N	0	300670	0	6248-9	3015076		
49636	4514	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	300684	0	6276-0	3027231		
30957	2832	3001488	1997-09-06	1997-09-06 00:00:00	1997-09-06	5001	0	\N	0	0	\N	\N	0	187932	0	7258-7	3001488		
22023	693	4052083	1975-10-16	1975-10-16 00:00:00	1975-10-16	5001	0	\N	0	0	\N	\N	0	45965	0	23426006	4052083		
41	2	3011505	1990-10-02	1990-10-02 00:00:00	1990-10-02	5001	0	\N	0	0	\N	\N	0	195	0	19926-5	3011505		
152230	4665	4052083	1988-09-09	1988-09-09 00:00:00	1988-09-09	5001	0	\N	0	0	\N	\N	0	310900	0	23426006	4052083		
53828	4935	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	328123	0	6106-9	3014599		
21137	1954	40758406	2003-02-07	2003-02-07 00:00:00	2003-02-07	5001	0	\N	0	0	\N	\N	0	130001	0	55277-8	40758406		
75923	2332	4024958	1984-10-22	1984-10-22 00:00:00	1984-10-22	5001	0	\N	0	0	\N	\N	0	155050	0	117015009	4024958		
29926	924	4024958	1963-07-31	1963-07-31 00:00:00	1963-07-31	5001	0	\N	0	0	\N	\N	0	61560	0	117015009	4024958		
1746	155	3006322	1976-07-26	1976-07-26 00:00:00	1976-07-26	5001	0	\N	0	0	\N	\N	0	10616	0	8331-1	3006322		
86299	2669	4024958	1982-02-14	1982-02-14 00:00:00	1982-02-14	5001	0	\N	0	0	\N	\N	0	176785	0	117015009	4024958		
44154	4071	3051031	1966-07-26	1966-07-26 00:00:00	1966-07-26	5001	0	\N	0	0	\N	\N	0	270617	0	46240-8	3051031		
19127	1753	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	117215	0	6189-5	3006734		
28784	890	4024958	2015-05-25	2015-05-25 00:00:00	2015-05-25	5001	0	\N	0	0	\N	\N	0	59305	0	117015009	4024958		
82716	2554	4024958	1934-09-24	1934-09-24 00:00:00	1934-09-24	5001	0	\N	0	0	\N	\N	0	169133	0	117015009	4024958		
1386	124	3015076	1987-04-02	1987-04-02 00:00:00	1987-04-02	5001	0	\N	0	0	\N	\N	0	8296	0	6248-9	3015076		
84142	2602	4024958	1958-06-13	1958-06-13 00:00:00	1958-06-13	5001	0	\N	0	0	\N	\N	0	172105	0	117015009	4024958		
44722	1376	4024958	1992-06-26	1992-06-26 00:00:00	1992-06-26	5001	0	\N	0	0	\N	\N	0	91182	0	117015009	4024958		
6799	649	3006322	1985-05-25	1985-05-25 00:00:00	1985-05-25	5001	0	\N	0	0	\N	\N	0	43033	0	8331-1	3006322		
36940	3394	3006322	1986-02-07	1986-02-07 00:00:00	1986-02-07	5001	0	\N	0	0	\N	\N	0	225147	0	8331-1	3006322		
95740	2935	4052083	2002-04-22	2002-04-22 00:00:00	2002-04-22	5001	0	\N	0	0	\N	\N	0	195687	0	23426006	4052083		
52887	4853	3006322	1994-01-22	1994-01-22 00:00:00	1994-01-22	5001	0	\N	0	0	\N	\N	0	322925	0	8331-1	3006322		
56463	5184	3006322	1990-01-19	1990-01-19 00:00:00	1990-01-19	5001	0	\N	0	0	\N	\N	0	344567	0	8331-1	3006322		
27776	2555	3006322	2016-08-11	2016-08-11 00:00:00	2016-08-11	5001	0	\N	0	0	\N	\N	0	169328	0	8331-1	3006322		
41058	3820	3006322	1968-11-10	1968-11-10 00:00:00	1968-11-10	5001	0	\N	0	0	\N	\N	0	253658	0	8331-1	3006322		
14754	1371	3006322	2009-05-22	2009-05-22 00:00:00	2009-05-22	5001	0	\N	0	0	\N	\N	0	90902	0	8331-1	3006322		
22794	2088	3011505	2002-06-18	2002-06-18 00:00:00	2002-06-18	5001	0	\N	0	0	\N	\N	0	139173	0	19926-5	3011505		
9644	308	4052083	1996-04-04	1996-04-04 00:00:00	1996-04-04	5001	0	\N	0	0	\N	\N	0	20423	0	23426006	4052083		
22693	2077	3023430	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	138284	0	6833-8	3023430		
72573	2226	4052083	1945-08-29	1945-08-29 00:00:00	1945-08-29	5001	0	\N	0	0	\N	\N	0	148136	0	23426006	4052083		
31135	2847	3006322	1975-07-20	1975-07-20 00:00:00	1975-07-20	5001	0	\N	0	0	\N	\N	0	189109	0	8331-1	3006322		
2075	190	3006322	1994-07-14	1994-07-14 00:00:00	1994-07-14	5001	0	\N	0	0	\N	\N	0	12966	0	8331-1	3006322		
49153	4492	3006322	1996-05-11	1996-05-11 00:00:00	1996-05-11	5001	0	\N	0	0	\N	\N	0	299051	0	8331-1	3006322		
8354	788	3051031	1988-11-04	1988-11-04 00:00:00	1988-11-04	5001	0	\N	0	0	\N	\N	0	52432	0	46240-8	3051031		
110765	3420	4024958	1970-08-13	1970-08-13 00:00:00	1970-08-13	5001	0	\N	0	0	\N	\N	0	226883	0	117015009	4024958		
55865	1703	4024958	1963-07-27	1963-07-27 00:00:00	1963-07-27	5001	0	\N	0	0	\N	\N	0	113907	0	117015009	4024958		
110830	3423	4024958	1992-10-27	1992-10-27 00:00:00	1992-10-27	5001	0	\N	0	0	\N	\N	0	227035	0	117015009	4024958		
36404	3343	3006322	1991-06-06	1991-06-06 00:00:00	1991-06-06	5001	0	\N	0	0	\N	\N	0	221870	0	8331-1	3006322		
31998	2917	3000963	1962-08-27	1962-08-27 00:00:00	1962-08-27	5001	0	\N	0	0	\N	\N	0	194432	0	718-7	3000963		
32030	2919	3011505	2011-11-12	2011-11-12 00:00:00	2011-11-12	5001	0	\N	0	0	\N	\N	0	194633	0	19926-5	3011505		
3368	101	4024958	1940-11-22	1940-11-22 00:00:00	1940-11-22	5001	0	\N	0	0	\N	\N	0	6834	0	117015009	4024958		
36773	3375	3006322	1993-03-14	1993-03-14 00:00:00	1993-03-14	5001	0	\N	0	0	\N	\N	0	223854	0	8331-1	3006322		
62856	1928	4024958	1979-04-27	1979-04-27 00:00:00	1979-04-27	5001	0	\N	0	0	\N	\N	0	128346	0	117015009	4024958		
30124	2770	3006322	1951-05-22	1951-05-22 00:00:00	1951-05-22	5001	0	\N	0	0	\N	\N	0	183230	0	8331-1	3006322		
37923	3505	3006322	1998-06-05	1998-06-05 00:00:00	1998-06-05	5001	0	\N	0	0	\N	\N	0	232431	0	8331-1	3006322		
3133	299	46235214	1963-06-07	1963-06-07 00:00:00	1963-06-07	5001	0	\N	0	0	\N	\N	0	20013	0	76690-7	46235214		
173018	5312	4133840	1999-12-20	1999-12-20 00:00:00	1999-12-20	5001	0	\N	0	0	\N	\N	0	353241	0	127783003	4133840		
113217	3494	4133840	2011-08-11	2011-08-11 00:00:00	2011-08-11	5001	0	\N	0	0	\N	\N	0	231736	0	127783003	4133840		
2196	199	3006322	1977-07-24	1977-07-24 00:00:00	1977-07-24	5001	0	\N	0	0	\N	\N	0	13679	0	8331-1	3006322		
33394	3017	3006322	1999-03-22	1999-03-22 00:00:00	1999-03-22	5001	0	\N	0	0	\N	\N	0	201229	0	8331-1	3006322		
33450	3025	3001488	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	201695	0	7258-7	3001488		
22549	2069	3006322	1959-04-09	1959-04-09 00:00:00	1959-04-09	5001	0	\N	0	0	\N	\N	0	137598	0	8331-1	3006322		
16617	1513	3015076	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	101125	0	6248-9	3015076		
40344	3752	40766240	1993-10-29	1993-10-29 00:00:00	1993-10-29	5001	0	\N	0	0	\N	\N	0	249305	0	63513-6	40766240		
44016	4064	3019406	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	270030	0	6158-0	3019406		
29725	2740	3006322	1997-02-06	1997-02-06 00:00:00	1997-02-06	5001	0	\N	0	0	\N	\N	0	181326	0	8331-1	3006322		
51886	4761	3000876	1996-11-11	1996-11-11 00:00:00	1996-11-11	5001	0	\N	0	0	\N	\N	0	317251	0	6082-2	3000876		
72945	2238	4052083	2003-10-14	2003-10-14 00:00:00	2003-10-14	5001	0	\N	0	0	\N	\N	0	148924	0	23426006	4052083		
7879	754	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	49966	0	6206-7	3012494		
51963	4763	3051031	2009-11-05	2009-11-05 00:00:00	2009-11-05	5001	0	\N	0	0	\N	\N	0	317381	0	46240-8	3051031		
26756	2466	3006322	1981-05-11	1981-05-11 00:00:00	1981-05-11	5001	0	\N	0	0	\N	\N	0	163503	0	8331-1	3006322		
99617	3057	4024958	1941-09-24	1941-09-24 00:00:00	1941-09-24	5001	0	\N	0	0	\N	\N	0	203360	0	117015009	4024958		
40194	3744	3014599	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	248741	0	6106-9	3014599		
49613	4514	3001247	1976-06-28	1976-06-28 00:00:00	1976-06-28	5001	0	\N	0	0	\N	\N	0	300670	0	6085-5	3001247		
49660	4520	40758406	1928-10-05	1928-10-05 00:00:00	1928-10-05	5001	0	\N	0	0	\N	\N	0	300943	0	55277-8	40758406		
30958	2832	3006734	1997-09-06	1997-09-06 00:00:00	1997-09-06	5001	0	\N	0	0	\N	\N	0	187932	0	6189-5	3006734		
22024	693	4024958	1992-10-25	1992-10-25 00:00:00	1992-10-25	5001	0	\N	0	0	\N	\N	0	45947	0	117015009	4024958		
42	2	40758406	1934-10-26	1934-10-26 00:00:00	1934-10-26	5001	0	\N	0	0	\N	\N	0	151	0	55277-8	40758406		
152239	4666	4052083	1984-03-03	1984-03-03 00:00:00	1984-03-03	5001	0	\N	0	0	\N	\N	0	310948	0	23426006	4052083		
53829	4935	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	328123	0	6206-7	3012494		
21139	1954	3051031	1967-06-21	1967-06-21 00:00:00	1967-06-21	5001	0	\N	0	0	\N	\N	0	129948	0	46240-8	3051031		
75924	2332	4024958	1963-09-01	1963-09-01 00:00:00	1963-09-01	5001	0	\N	0	0	\N	\N	0	155048	0	117015009	4024958		
29929	925	4133840	2016-10-07	2016-10-07 00:00:00	2016-10-07	5001	0	\N	0	0	\N	\N	0	61635	0	127783003	4133840		
1747	155	3006322	1971-05-11	1971-05-11 00:00:00	1971-05-11	5001	0	\N	0	0	\N	\N	0	10627	0	8331-1	3006322		
86308	2669	4024958	2002-07-25	2002-07-25 00:00:00	2002-07-25	5001	0	\N	0	0	\N	\N	0	176765	0	117015009	4024958		
44155	4071	46235214	1966-07-26	1966-07-26 00:00:00	1966-07-26	5001	0	\N	0	0	\N	\N	0	270617	0	76690-7	46235214		
19128	1753	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	117215	0	6085-5	3001247		
40116	1246	4052083	1985-11-30	1985-11-30 00:00:00	1985-11-30	5001	0	\N	0	0	\N	\N	0	82115	0	23426006	4052083		
82717	2554	4052083	1942-06-20	1942-06-20 00:00:00	1942-06-20	5001	0	\N	0	0	\N	\N	0	169167	0	23426006	4052083		
1387	124	3006734	1987-04-02	1987-04-02 00:00:00	1987-04-02	5001	0	\N	0	0	\N	\N	0	8296	0	6189-5	3006734		
84146	2603	4052083	1980-02-11	1980-02-11 00:00:00	1980-02-11	5001	0	\N	0	0	\N	\N	0	172232	0	23426006	4052083		
44732	1376	4052083	2012-07-17	2012-07-17 00:00:00	2012-07-17	5001	0	\N	0	0	\N	\N	0	91184	0	23426006	4052083		
6800	649	3006322	1979-09-12	1979-09-12 00:00:00	1979-09-12	5001	0	\N	0	0	\N	\N	0	43032	0	8331-1	3006322		
36941	3394	3006322	1982-06-17	1982-06-17 00:00:00	1982-06-17	5001	0	\N	0	0	\N	\N	0	225142	0	8331-1	3006322		
95747	2936	4052083	2008-02-26	2008-02-26 00:00:00	2008-02-26	5001	0	\N	0	0	\N	\N	0	195783	0	23426006	4052083		
52888	4853	3006322	2015-04-04	2015-04-04 00:00:00	2015-04-04	5001	0	\N	0	0	\N	\N	0	322902	0	8331-1	3006322		
56464	5184	3006322	1998-10-14	1998-10-14 00:00:00	1998-10-14	5001	0	\N	0	0	\N	\N	0	344581	0	8331-1	3006322		
27777	2555	3006322	2009-09-21	2009-09-21 00:00:00	2009-09-21	5001	0	\N	0	0	\N	\N	0	169325	0	8331-1	3006322		
41106	3822	3006322	1973-11-30	1973-11-30 00:00:00	1973-11-30	5001	0	\N	0	0	\N	\N	0	253880	0	8331-1	3006322		
14755	1371	3006322	2015-03-02	2015-03-02 00:00:00	2015-03-02	5001	0	\N	0	0	\N	\N	0	90883	0	8331-1	3006322		
22796	2088	40766240	1995-10-01	1995-10-01 00:00:00	1995-10-01	5001	0	\N	0	0	\N	\N	0	139231	0	63513-6	40766240		
9651	308	4052083	2006-04-07	2006-04-07 00:00:00	2006-04-07	5001	0	\N	0	0	\N	\N	0	20412	0	23426006	4052083		
22694	2077	3006734	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	138284	0	6189-5	3006734		
72585	2226	4024958	1982-02-21	1982-02-21 00:00:00	1982-02-21	5001	0	\N	0	0	\N	\N	0	148118	0	117015009	4024958		
31138	2849	3006322	1968-05-08	1968-05-08 00:00:00	1968-05-08	5001	0	\N	0	0	\N	\N	0	189302	0	8331-1	3006322		
2079	190	3006322	1999-10-29	1999-10-29 00:00:00	1999-10-29	5001	0	\N	0	0	\N	\N	0	12970	0	8331-1	3006322		
49155	4492	40758406	1947-09-05	1947-09-05 00:00:00	1947-09-05	5001	0	\N	0	0	\N	\N	0	299058	0	55277-8	40758406		
8355	788	40766240	1988-11-04	1988-11-04 00:00:00	1988-11-04	5001	0	\N	0	0	\N	\N	0	52432	0	63513-6	40766240		
110772	3420	4052083	2002-07-29	2002-07-29 00:00:00	2002-07-29	5001	0	\N	0	0	\N	\N	0	226887	0	23426006	4052083		
11889	1137	3051031	1984-11-29	1984-11-29 00:00:00	1984-11-29	5001	0	\N	0	0	\N	\N	0	74941	0	46240-8	3051031		
100111	3072	4024958	1974-01-27	1974-01-27 00:00:00	1974-01-27	5001	0	\N	0	0	\N	\N	0	204491	0	117015009	4024958		
36426	3347	3006322	1963-03-17	1963-03-17 00:00:00	1963-03-17	5001	0	\N	0	0	\N	\N	0	222038	0	8331-1	3006322		
31999	2917	3009542	1962-08-27	1962-08-27 00:00:00	1962-08-27	5001	0	\N	0	0	\N	\N	0	194432	0	20570-8	3009542		
32031	2919	3011505	2012-11-17	2012-11-17 00:00:00	2012-11-17	5001	0	\N	0	0	\N	\N	0	194636	0	19926-5	3011505		
3382	101	4052083	1945-06-01	1945-06-01 00:00:00	1945-06-01	5001	0	\N	0	0	\N	\N	0	6933	0	23426006	4052083		
36774	3375	3006322	2011-02-23	2011-02-23 00:00:00	2011-02-23	5001	0	\N	0	0	\N	\N	0	223882	0	8331-1	3006322		
62858	1928	4052083	1993-06-10	1993-06-10 00:00:00	1993-06-10	5001	0	\N	0	0	\N	\N	0	128311	0	23426006	4052083		
30125	2771	3006322	1939-02-25	1939-02-25 00:00:00	1939-02-25	5001	0	\N	0	0	\N	\N	0	183427	0	8331-1	3006322		
37924	3505	3049273	2009-08-12	2009-08-12 00:00:00	2009-08-12	5001	0	\N	0	0	\N	\N	0	232382	0	38265-5	3049273		
3135	299	40766240	1963-06-07	1963-06-07 00:00:00	1963-06-07	5001	0	\N	0	0	\N	\N	0	20013	0	63513-6	40766240		
173019	5312	4133840	1980-11-24	1980-11-24 00:00:00	1980-11-24	5001	0	\N	0	0	\N	\N	0	353285	0	127783003	4133840		
113225	3495	4024958	1984-01-05	1984-01-05 00:00:00	1984-01-05	5001	0	\N	0	0	\N	\N	0	231804	0	117015009	4024958		
2197	199	3006322	2018-12-06	2018-12-06 00:00:00	2018-12-06	5001	0	\N	0	0	\N	\N	0	13656	0	8331-1	3006322		
33395	3017	3006322	1960-10-02	1960-10-02 00:00:00	1960-10-02	5001	0	\N	0	0	\N	\N	0	201239	0	8331-1	3006322		
33451	3025	3036780	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	201695	0	6095-4	3036780		
22550	2069	3006322	1978-01-25	1978-01-25 00:00:00	1978-01-25	5001	0	\N	0	0	\N	\N	0	137600	0	8331-1	3006322		
16618	1513	3006451	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	101125	0	6273-7	3006451		
40346	3752	3051031	1993-10-29	1993-10-29 00:00:00	1993-10-29	5001	0	\N	0	0	\N	\N	0	249305	0	46240-8	3051031		
44017	4064	3001488	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	270030	0	7258-7	3001488		
29771	2743	3051031	1961-06-05	1961-06-05 00:00:00	1961-06-05	5001	0	\N	0	0	\N	\N	0	181454	0	46240-8	3051031		
51887	4761	3005136	1996-11-11	1996-11-11 00:00:00	1996-11-11	5001	0	\N	0	0	\N	\N	0	317251	0	6075-6	3005136		
72986	2240	4024958	1988-12-09	1988-12-09 00:00:00	1988-12-09	5001	0	\N	0	0	\N	\N	0	149143	0	117015009	4024958		
7880	754	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	49966	0	6844-5	3020655		
51965	4764	3006322	1991-10-01	1991-10-01 00:00:00	1991-10-01	5001	0	\N	0	0	\N	\N	0	317509	0	8331-1	3006322		
26759	2468	3006322	1970-12-16	1970-12-16 00:00:00	1970-12-16	5001	0	\N	0	0	\N	\N	0	163612	0	8331-1	3006322		
99643	3059	4024958	2006-06-02	2006-06-02 00:00:00	2006-06-02	5001	0	\N	0	0	\N	\N	0	203496	0	117015009	4024958		
40195	3744	3014599	2006-07-12	2006-07-12 00:00:00	2006-07-12	5001	0	\N	0	0	\N	\N	0	248784	0	6106-9	3014599		
49614	4514	3036780	1976-06-28	1976-06-28 00:00:00	1976-06-28	5001	0	\N	0	0	\N	\N	0	300670	0	6095-4	3036780		
49661	4520	40766240	1928-10-05	1928-10-05 00:00:00	1928-10-05	5001	0	\N	0	0	\N	\N	0	300943	0	63513-6	40766240		
30959	2832	3036780	1997-09-06	1997-09-06 00:00:00	1997-09-06	5001	0	\N	0	0	\N	\N	0	187932	0	6095-4	3036780		
22031	693	4052083	1965-05-20	1965-05-20 00:00:00	1965-05-20	5001	0	\N	0	0	\N	\N	0	45885	0	23426006	4052083		
44	2	3051031	1934-10-26	1934-10-26 00:00:00	1934-10-26	5001	0	\N	0	0	\N	\N	0	151	0	46240-8	3051031		
152240	4666	4024958	2005-07-13	2005-07-13 00:00:00	2005-07-13	5001	0	\N	0	0	\N	\N	0	310950	0	117015009	4024958		
53830	4935	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	328123	0	6095-4	3036780		
21140	1954	40766240	1967-06-21	1967-06-21 00:00:00	1967-06-21	5001	0	\N	0	0	\N	\N	0	129948	0	63513-6	40766240		
75937	2332	4052083	1997-03-05	1997-03-05 00:00:00	1997-03-05	5001	0	\N	0	0	\N	\N	0	155085	0	23426006	4052083		
29933	925	4133840	2018-10-12	2018-10-12 00:00:00	2018-10-12	5001	0	\N	0	0	\N	\N	0	61616	0	127783003	4133840		
1748	155	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	10534	0	6075-6	3005136		
87438	2702	4024958	2014-08-17	2014-08-17 00:00:00	2014-08-17	5001	0	\N	0	0	\N	\N	0	178939	0	117015009	4024958		
44156	4071	40758406	1966-01-27	1966-01-27 00:00:00	1966-01-27	5001	0	\N	0	0	\N	\N	0	270612	0	55277-8	40758406		
19129	1753	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	117215	0	7258-7	3001488		
97602	2986	4133840	1992-11-03	1992-11-03 00:00:00	1992-11-03	5001	0	\N	0	0	\N	\N	0	199363	0	127783003	4133840		
82749	2554	4052083	1933-12-26	1933-12-26 00:00:00	1933-12-26	5001	0	\N	0	0	\N	\N	0	169260	0	23426006	4052083		
1388	124	3001488	1987-04-02	1987-04-02 00:00:00	1987-04-02	5001	0	\N	0	0	\N	\N	0	8296	0	7258-7	3001488		
84150	2603	4024958	1962-04-19	1962-04-19 00:00:00	1962-04-19	5001	0	\N	0	0	\N	\N	0	172231	0	117015009	4024958		
44734	1376	4052083	2004-09-06	2004-09-06 00:00:00	2004-09-06	5001	0	\N	0	0	\N	\N	0	91204	0	23426006	4052083		
6801	649	3006322	1972-05-26	1972-05-26 00:00:00	1972-05-26	5001	0	\N	0	0	\N	\N	0	43015	0	8331-1	3006322		
36942	3394	3006322	1967-08-27	1967-08-27 00:00:00	1967-08-27	5001	0	\N	0	0	\N	\N	0	225141	0	8331-1	3006322		
95748	2936	4024958	1999-10-14	1999-10-14 00:00:00	1999-10-14	5001	0	\N	0	0	\N	\N	0	195741	0	117015009	4024958		
52889	4853	3006322	1964-09-27	1964-09-27 00:00:00	1964-09-27	5001	0	\N	0	0	\N	\N	0	322883	0	8331-1	3006322		
56465	5184	3006322	1973-02-03	1973-02-03 00:00:00	1973-02-03	5001	0	\N	0	0	\N	\N	0	344579	0	8331-1	3006322		
27778	2555	3006322	2000-11-21	2000-11-21 00:00:00	2000-11-21	5001	0	\N	0	0	\N	\N	0	169342	0	8331-1	3006322		
41107	3822	3006322	1959-09-03	1959-09-03 00:00:00	1959-09-03	5001	0	\N	0	0	\N	\N	0	253899	0	8331-1	3006322		
14756	1371	3006322	1998-10-25	1998-10-25 00:00:00	1998-10-25	5001	0	\N	0	0	\N	\N	0	90901	0	8331-1	3006322		
22797	2088	40758406	1995-10-01	1995-10-01 00:00:00	1995-10-01	5001	0	\N	0	0	\N	\N	0	139231	0	55277-8	40758406		
39342	3636	3051031	2014-08-03	2014-08-03 00:00:00	2014-08-03	5001	0	\N	0	0	\N	\N	0	241785	0	46240-8	3051031		
22695	2077	3005136	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	138284	0	6075-6	3005136		
72624	2228	4024958	1950-12-01	1950-12-01 00:00:00	1950-12-01	5001	0	\N	0	0	\N	\N	0	148280	0	117015009	4024958		
31139	2849	3049273	2017-10-17	2017-10-17 00:00:00	2017-10-17	5001	0	\N	0	0	\N	\N	0	189298	0	38265-5	3049273		
2080	190	3006322	1937-05-04	1937-05-04 00:00:00	1937-05-04	5001	0	\N	0	0	\N	\N	0	13012	0	8331-1	3006322		
49157	4492	40766240	1947-09-05	1947-09-05 00:00:00	1947-09-05	5001	0	\N	0	0	\N	\N	0	299058	0	63513-6	40766240		
8356	788	40758406	1989-03-04	1989-03-04 00:00:00	1989-03-04	5001	0	\N	0	0	\N	\N	0	52406	0	55277-8	40758406		
122084	3767	4024958	2017-09-20	2017-09-20 00:00:00	2017-09-20	5001	0	\N	0	0	\N	\N	0	250352	0	117015009	4024958		
11891	1137	3051031	1984-08-31	1984-08-31 00:00:00	1984-08-31	5001	0	\N	0	0	\N	\N	0	74939	0	46240-8	3051031		
100118	3072	4024958	1962-03-08	1962-03-08 00:00:00	1962-03-08	5001	0	\N	0	0	\N	\N	0	204428	0	117015009	4024958		
36427	3347	3049273	2011-02-16	2011-02-16 00:00:00	2011-02-16	5001	0	\N	0	0	\N	\N	0	222022	0	38265-5	3049273		
32000	2917	3006322	2012-01-08	2012-01-08 00:00:00	2012-01-08	5001	0	\N	0	0	\N	\N	0	194499	0	8331-1	3006322		
32032	2919	3006322	1959-06-07	1959-06-07 00:00:00	1959-06-07	5001	0	\N	0	0	\N	\N	0	194601	0	8331-1	3006322		
106536	3280	4133840	2018-12-20	2018-12-20 00:00:00	2018-12-20	5001	0	\N	0	0	\N	\N	0	218001	0	127783003	4133840		
36775	3375	3006322	1976-12-06	1976-12-06 00:00:00	1976-12-06	5001	0	\N	0	0	\N	\N	0	223912	0	8331-1	3006322		
62860	1928	4024958	1998-09-26	1998-09-26 00:00:00	1998-09-26	5001	0	\N	0	0	\N	\N	0	128312	0	117015009	4024958		
30126	2771	3006322	2001-06-24	2001-06-24 00:00:00	2001-06-24	5001	0	\N	0	0	\N	\N	0	183546	0	8331-1	3006322		
37925	3505	3006322	2008-02-21	2008-02-21 00:00:00	2008-02-21	5001	0	\N	0	0	\N	\N	0	232433	0	8331-1	3006322		
3137	299	3051031	1963-06-07	1963-06-07 00:00:00	1963-06-07	5001	0	\N	0	0	\N	\N	0	20013	0	46240-8	3051031		
173021	5312	4133840	1997-12-22	1997-12-22 00:00:00	1997-12-22	5001	0	\N	0	0	\N	\N	0	353232	0	127783003	4133840		
113235	3495	4052083	1980-07-14	1980-07-14 00:00:00	1980-07-14	5001	0	\N	0	0	\N	\N	0	231795	0	23426006	4052083		
2198	199	3006322	1993-08-14	1993-08-14 00:00:00	1993-08-14	5001	0	\N	0	0	\N	\N	0	13647	0	8331-1	3006322		
33396	3019	3006322	1988-05-08	1988-05-08 00:00:00	1988-05-08	5001	0	\N	0	0	\N	\N	0	201353	0	8331-1	3006322		
33452	3025	3023430	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	201695	0	6833-8	3023430		
22551	2069	3006322	1965-09-18	1965-09-18 00:00:00	1965-09-18	5001	0	\N	0	0	\N	\N	0	137615	0	8331-1	3006322		
16619	1513	3021226	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	101125	0	6246-3	3021226		
40347	3752	46235214	1993-10-29	1993-10-29 00:00:00	1993-10-29	5001	0	\N	0	0	\N	\N	0	249305	0	76690-7	46235214		
44018	4064	3005136	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	270030	0	6075-6	3005136		
29772	2743	40758406	1961-06-05	1961-06-05 00:00:00	1961-06-05	5001	0	\N	0	0	\N	\N	0	181454	0	55277-8	40758406		
51888	4761	3027231	1996-11-11	1996-11-11 00:00:00	1996-11-11	5001	0	\N	0	0	\N	\N	0	317251	0	6276-0	3027231		
72999	2240	4024958	2004-06-01	2004-06-01 00:00:00	2004-06-01	5001	0	\N	0	0	\N	\N	0	149144	0	117015009	4024958		
7881	754	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	49966	0	6095-4	3036780		
51966	4764	3006322	1989-01-04	1989-01-04 00:00:00	1989-01-04	5001	0	\N	0	0	\N	\N	0	317495	0	8331-1	3006322		
26760	2468	3006322	1998-12-24	1998-12-24 00:00:00	1998-12-24	5001	0	\N	0	0	\N	\N	0	163606	0	8331-1	3006322		
134075	4129	4024958	1989-11-07	1989-11-07 00:00:00	1989-11-07	5001	0	\N	0	0	\N	\N	0	274454	0	117015009	4024958		
40196	3744	3015076	2006-07-12	2006-07-12 00:00:00	2006-07-12	5001	0	\N	0	0	\N	\N	0	248784	0	6248-9	3015076		
49615	4514	3021226	1976-06-28	1976-06-28 00:00:00	1976-06-28	5001	0	\N	0	0	\N	\N	0	300670	0	6246-3	3021226		
49662	4520	46235214	1928-10-05	1928-10-05 00:00:00	1928-10-05	5001	0	\N	0	0	\N	\N	0	300943	0	76690-7	46235214		
30960	2832	3023430	1997-09-06	1997-09-06 00:00:00	1997-09-06	5001	0	\N	0	0	\N	\N	0	187932	0	6833-8	3023430		
22050	693	4024958	2005-05-31	2005-05-31 00:00:00	2005-05-31	5001	0	\N	0	0	\N	\N	0	45901	0	117015009	4024958		
46	2	40766240	1934-10-26	1934-10-26 00:00:00	1934-10-26	5001	0	\N	0	0	\N	\N	0	151	0	63513-6	40766240		
152271	4668	4024958	1989-03-25	1989-03-25 00:00:00	1989-03-25	5001	0	\N	0	0	\N	\N	0	311079	0	117015009	4024958		
53831	4935	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	328123	0	6082-2	3000876		
21142	1954	46235214	1967-06-21	1967-06-21 00:00:00	1967-06-21	5001	0	\N	0	0	\N	\N	0	129948	0	76690-7	46235214		
75942	2332	4052083	1994-12-30	1994-12-30 00:00:00	1994-12-30	5001	0	\N	0	0	\N	\N	0	155071	0	23426006	4052083		
29934	925	4133840	2009-05-15	2009-05-15 00:00:00	2009-05-15	5001	0	\N	0	0	\N	\N	0	61615	0	127783003	4133840		
1749	155	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	10534	0	6206-7	3012494		
87447	2702	4024958	2003-11-20	2003-11-20 00:00:00	2003-11-20	5001	0	\N	0	0	\N	\N	0	178937	0	117015009	4024958		
44157	4071	46235214	1966-01-27	1966-01-27 00:00:00	1966-01-27	5001	0	\N	0	0	\N	\N	0	270612	0	76690-7	46235214		
19130	1753	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	117215	0	6844-5	3020655		
97603	2986	4133840	2005-02-15	2005-02-15 00:00:00	2005-02-15	5001	0	\N	0	0	\N	\N	0	199303	0	127783003	4133840		
124376	3841	4052083	1982-09-27	1982-09-27 00:00:00	1982-09-27	5001	0	\N	0	0	\N	\N	0	255022	0	23426006	4052083		
1389	124	3036780	1987-04-02	1987-04-02 00:00:00	1987-04-02	5001	0	\N	0	0	\N	\N	0	8296	0	6095-4	3036780		
84164	2604	4052083	1978-10-03	1978-10-03 00:00:00	1978-10-03	5001	0	\N	0	0	\N	\N	0	172247	0	23426006	4052083		
44747	1377	4052083	2008-12-02	2008-12-02 00:00:00	2008-12-02	5001	0	\N	0	0	\N	\N	0	91253	0	23426006	4052083		
6802	649	3006322	1987-06-26	1987-06-26 00:00:00	1987-06-26	5001	0	\N	0	0	\N	\N	0	43035	0	8331-1	3006322		
36950	3397	3006322	2001-10-11	2001-10-11 00:00:00	2001-10-11	5001	0	\N	0	0	\N	\N	0	225326	0	8331-1	3006322		
95755	2936	4024958	2000-12-19	2000-12-19 00:00:00	2000-12-19	5001	0	\N	0	0	\N	\N	0	195782	0	117015009	4024958		
52890	4853	3006322	2008-10-22	2008-10-22 00:00:00	2008-10-22	5001	0	\N	0	0	\N	\N	0	322887	0	8331-1	3006322		
56466	5184	3006322	2003-12-29	2003-12-29 00:00:00	2003-12-29	5001	0	\N	0	0	\N	\N	0	344549	0	8331-1	3006322		
27779	2555	3006322	2011-06-26	2011-06-26 00:00:00	2011-06-26	5001	0	\N	0	0	\N	\N	0	169326	0	8331-1	3006322		
41108	3822	3006322	1986-02-20	1986-02-20 00:00:00	1986-02-20	5001	0	\N	0	0	\N	\N	0	253815	0	8331-1	3006322		
14757	1371	3006322	1974-05-30	1974-05-30 00:00:00	1974-05-30	5001	0	\N	0	0	\N	\N	0	90913	0	8331-1	3006322		
22799	2088	46235214	1995-10-01	1995-10-01 00:00:00	1995-10-01	5001	0	\N	0	0	\N	\N	0	139231	0	76690-7	46235214		
39343	3636	40766240	2014-08-03	2014-08-03 00:00:00	2014-08-03	5001	0	\N	0	0	\N	\N	0	241785	0	63513-6	40766240		
22696	2077	3027231	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	138284	0	6276-0	3027231		
152908	4689	4024958	1981-01-08	1981-01-08 00:00:00	1981-01-08	5001	0	\N	0	0	\N	\N	0	312439	0	117015009	4024958		
31140	2849	3006322	1951-01-28	1951-01-28 00:00:00	1951-01-28	5001	0	\N	0	0	\N	\N	0	189301	0	8331-1	3006322		
2083	191	46235214	1976-08-11	1976-08-11 00:00:00	1976-08-11	5001	0	\N	0	0	\N	\N	0	13099	0	76690-7	46235214		
49158	4492	46235214	1947-09-05	1947-09-05 00:00:00	1947-09-05	5001	0	\N	0	0	\N	\N	0	299058	0	76690-7	46235214		
8357	788	40766240	1989-03-04	1989-03-04 00:00:00	1989-03-04	5001	0	\N	0	0	\N	\N	0	52406	0	63513-6	40766240		
122086	3767	4024958	2011-08-07	2011-08-07 00:00:00	2011-08-07	5001	0	\N	0	0	\N	\N	0	250350	0	117015009	4024958		
11892	1137	40758406	1984-08-31	1984-08-31 00:00:00	1984-08-31	5001	0	\N	0	0	\N	\N	0	74939	0	55277-8	40758406		
100120	3072	4024958	1969-12-09	1969-12-09 00:00:00	1969-12-09	5001	0	\N	0	0	\N	\N	0	204485	0	117015009	4024958		
36428	3347	3006322	1963-07-26	1963-07-26 00:00:00	1963-07-26	5001	0	\N	0	0	\N	\N	0	222035	0	8331-1	3006322		
32001	2917	3006322	1998-10-04	1998-10-04 00:00:00	1998-10-04	5001	0	\N	0	0	\N	\N	0	194470	0	8331-1	3006322		
32033	2919	3049273	2018-03-21	2018-03-21 00:00:00	2018-03-21	5001	0	\N	0	0	\N	\N	0	194613	0	38265-5	3049273		
106540	3280	4133840	2017-12-14	2017-12-14 00:00:00	2017-12-14	5001	0	\N	0	0	\N	\N	0	217994	0	127783003	4133840		
36776	3375	3006322	1988-07-22	1988-07-22 00:00:00	1988-07-22	5001	0	\N	0	0	\N	\N	0	223881	0	8331-1	3006322		
62866	1929	4024958	1987-01-08	1987-01-08 00:00:00	1987-01-08	5001	0	\N	0	0	\N	\N	0	128463	0	117015009	4024958		
30127	2771	3006322	1994-05-12	1994-05-12 00:00:00	1994-05-12	5001	0	\N	0	0	\N	\N	0	183545	0	8331-1	3006322		
37926	3505	3006322	2000-02-08	2000-02-08 00:00:00	2000-02-08	5001	0	\N	0	0	\N	\N	0	232482	0	8331-1	3006322		
3139	299	40766240	1963-07-07	1963-07-07 00:00:00	1963-07-07	5001	0	\N	0	0	\N	\N	0	20020	0	63513-6	40766240		
173022	5312	4133840	2005-01-17	2005-01-17 00:00:00	2005-01-17	5001	0	\N	0	0	\N	\N	0	353236	0	127783003	4133840		
113236	3495	4052083	2008-10-06	2008-10-06 00:00:00	2008-10-06	5001	0	\N	0	0	\N	\N	0	231854	0	23426006	4052083		
2199	199	3049273	2007-07-06	2007-07-06 00:00:00	2007-07-06	5001	0	\N	0	0	\N	\N	0	13646	0	38265-5	3049273		
33397	3020	3011505	2014-02-12	2014-02-12 00:00:00	2014-02-12	5001	0	\N	0	0	\N	\N	0	201387	0	19926-5	3011505		
33453	3025	3006734	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	201695	0	6189-5	3006734		
22552	2069	3006322	1959-02-24	1959-02-24 00:00:00	1959-02-24	5001	0	\N	0	0	\N	\N	0	137613	0	8331-1	3006322		
16620	1513	3019406	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	101125	0	6158-0	3019406		
40349	3752	3051031	1994-04-27	1994-04-27 00:00:00	1994-04-27	5001	0	\N	0	0	\N	\N	0	249306	0	46240-8	3051031		
44019	4064	3006451	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	270030	0	6273-7	3006451		
29774	2743	40766240	1961-06-05	1961-06-05 00:00:00	1961-06-05	5001	0	\N	0	0	\N	\N	0	181454	0	63513-6	40766240		
51889	4761	3014599	1996-11-11	1996-11-11 00:00:00	1996-11-11	5001	0	\N	0	0	\N	\N	0	317251	0	6106-9	3014599		
73002	2240	4024958	2012-09-16	2012-09-16 00:00:00	2012-09-16	5001	0	\N	0	0	\N	\N	0	149118	0	117015009	4024958		
7882	754	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	49966	0	6833-8	3023430		
51967	4764	3006322	1997-01-15	1997-01-15 00:00:00	1997-01-15	5001	0	\N	0	0	\N	\N	0	317496	0	8331-1	3006322		
26761	2468	3006322	1972-09-18	1972-09-18 00:00:00	1972-09-18	5001	0	\N	0	0	\N	\N	0	163652	0	8331-1	3006322		
134090	4129	4024958	1955-03-05	1955-03-05 00:00:00	1955-03-05	5001	0	\N	0	0	\N	\N	0	274444	0	117015009	4024958		
40197	3744	3006451	2006-07-12	2006-07-12 00:00:00	2006-07-12	5001	0	\N	0	0	\N	\N	0	248784	0	6273-7	3006451		
49616	4514	3006451	1976-06-28	1976-06-28 00:00:00	1976-06-28	5001	0	\N	0	0	\N	\N	0	300670	0	6273-7	3006451		
49663	4520	3051031	1928-10-05	1928-10-05 00:00:00	1928-10-05	5001	0	\N	0	0	\N	\N	0	300943	0	46240-8	3051031		
30961	2832	3020655	1997-09-06	1997-09-06 00:00:00	1997-09-06	5001	0	\N	0	0	\N	\N	0	187932	0	6844-5	3020655		
22052	693	4024958	1966-04-01	1966-04-01 00:00:00	1966-04-01	5001	0	\N	0	0	\N	\N	0	45963	0	117015009	4024958		
47	2	46235214	1934-10-26	1934-10-26 00:00:00	1934-10-26	5001	0	\N	0	0	\N	\N	0	151	0	76690-7	46235214		
152278	4668	4024958	1961-04-11	1961-04-11 00:00:00	1961-04-11	5001	0	\N	0	0	\N	\N	0	311104	0	117015009	4024958		
53832	4935	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	328123	0	6075-6	3005136		
21143	1954	40758406	1967-06-21	1967-06-21 00:00:00	1967-06-21	5001	0	\N	0	0	\N	\N	0	129948	0	55277-8	40758406		
44336	1365	4024958	2007-11-22	2007-11-22 00:00:00	2007-11-22	5001	0	\N	0	0	\N	\N	0	90507	0	117015009	4024958		
29936	925	4024958	1999-09-22	1999-09-22 00:00:00	1999-09-22	5001	0	\N	0	0	\N	\N	0	61602	0	117015009	4024958		
1750	155	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	10534	0	6106-9	3014599		
87448	2702	4024958	1968-07-21	1968-07-21 00:00:00	1968-07-21	5001	0	\N	0	0	\N	\N	0	178996	0	117015009	4024958		
44159	4071	40766240	1966-01-27	1966-01-27 00:00:00	1966-01-27	5001	0	\N	0	0	\N	\N	0	270612	0	63513-6	40766240		
19131	1753	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	117215	0	6248-9	3015076		
97606	2986	4133840	2016-04-19	2016-04-19 00:00:00	2016-04-19	5001	0	\N	0	0	\N	\N	0	199307	0	127783003	4133840		
55911	5123	3006322	2013-06-05	2013-06-05 00:00:00	2013-06-05	5001	0	\N	0	0	\N	\N	0	340644	0	8331-1	3006322		
1390	124	3020655	1987-04-02	1987-04-02 00:00:00	1987-04-02	5001	0	\N	0	0	\N	\N	0	8296	0	6844-5	3020655		
84165	2604	4052083	2016-11-21	2016-11-21 00:00:00	2016-11-21	5001	0	\N	0	0	\N	\N	0	172279	0	23426006	4052083		
44750	1377	4024958	2017-11-16	2017-11-16 00:00:00	2017-11-16	5001	0	\N	0	0	\N	\N	0	91240	0	117015009	4024958		
24854	775	4052083	1982-09-05	1982-09-05 00:00:00	1982-09-05	5001	0	\N	0	0	\N	\N	0	51487	0	23426006	4052083		
36951	3397	3006322	2008-10-18	2008-10-18 00:00:00	2008-10-18	5001	0	\N	0	0	\N	\N	0	225327	0	8331-1	3006322		
95760	2936	4052083	1997-06-22	1997-06-22 00:00:00	1997-06-22	5001	0	\N	0	0	\N	\N	0	195757	0	23426006	4052083		
52895	4855	3006322	1990-08-18	1990-08-18 00:00:00	1990-08-18	5001	0	\N	0	0	\N	\N	0	323005	0	8331-1	3006322		
56467	5185	3006322	1936-05-13	1936-05-13 00:00:00	1936-05-13	5001	0	\N	0	0	\N	\N	0	344647	0	8331-1	3006322		
27780	2555	3006322	1976-05-02	1976-05-02 00:00:00	1976-05-02	5001	0	\N	0	0	\N	\N	0	169318	0	8331-1	3006322		
41109	3822	3006322	1958-02-28	1958-02-28 00:00:00	1958-02-28	5001	0	\N	0	0	\N	\N	0	253865	0	8331-1	3006322		
14758	1371	3006322	1984-10-27	1984-10-27 00:00:00	1984-10-27	5001	0	\N	0	0	\N	\N	0	90876	0	8331-1	3006322		
22800	2088	3051031	1995-10-01	1995-10-01 00:00:00	1995-10-01	5001	0	\N	0	0	\N	\N	0	139231	0	46240-8	3051031		
39344	3636	46235214	2014-08-03	2014-08-03 00:00:00	2014-08-03	5001	0	\N	0	0	\N	\N	0	241785	0	76690-7	46235214		
22697	2077	3012494	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	138284	0	6206-7	3012494		
152913	4689	4052083	1998-10-01	1998-10-01 00:00:00	1998-10-01	5001	0	\N	0	0	\N	\N	0	312379	0	23426006	4052083		
31141	2849	3049273	2004-04-28	2004-04-28 00:00:00	2004-04-28	5001	0	\N	0	0	\N	\N	0	189297	0	38265-5	3049273		
2085	191	40766240	1976-08-11	1976-08-11 00:00:00	1976-08-11	5001	0	\N	0	0	\N	\N	0	13099	0	63513-6	40766240		
49159	4492	3051031	1947-09-05	1947-09-05 00:00:00	1947-09-05	5001	0	\N	0	0	\N	\N	0	299058	0	46240-8	3051031		
8358	788	3051031	1989-03-04	1989-03-04 00:00:00	1989-03-04	5001	0	\N	0	0	\N	\N	0	52406	0	46240-8	3051031		
88062	2721	4052083	1971-04-26	1971-04-26 00:00:00	1971-04-26	5001	0	\N	0	0	\N	\N	0	180327	0	23426006	4052083		
11894	1137	46235214	1984-08-31	1984-08-31 00:00:00	1984-08-31	5001	0	\N	0	0	\N	\N	0	74939	0	76690-7	46235214		
100162	3074	4024958	1981-06-25	1981-06-25 00:00:00	1981-06-25	5001	0	\N	0	0	\N	\N	0	204599	0	117015009	4024958		
36429	3347	3006322	1969-09-02	1969-09-02 00:00:00	1969-09-02	5001	0	\N	0	0	\N	\N	0	222036	0	8331-1	3006322		
32002	2917	3006322	1990-02-08	1990-02-08 00:00:00	1990-02-08	5001	0	\N	0	0	\N	\N	0	194496	0	8331-1	3006322		
32034	2919	3011505	2010-10-23	2010-10-23 00:00:00	2010-10-23	5001	0	\N	0	0	\N	\N	0	194626	0	19926-5	3011505		
106541	3280	4024958	2000-07-26	2000-07-26 00:00:00	2000-07-26	5001	0	\N	0	0	\N	\N	0	217977	0	117015009	4024958		
36777	3376	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	224054	0	6085-5	3001247		
62882	1929	4024958	2019-01-12	2019-01-12 00:00:00	2019-01-12	5001	0	\N	0	0	\N	\N	0	128452	0	117015009	4024958		
30128	2771	3006322	1942-05-22	1942-05-22 00:00:00	1942-05-22	5001	0	\N	0	0	\N	\N	0	183453	0	8331-1	3006322		
37927	3505	3006322	1973-11-05	1973-11-05 00:00:00	1973-11-05	5001	0	\N	0	0	\N	\N	0	232513	0	8331-1	3006322		
3140	299	46235214	1963-07-07	1963-07-07 00:00:00	1963-07-07	5001	0	\N	0	0	\N	\N	0	20020	0	76690-7	46235214		
173023	5312	4133840	1982-11-29	1982-11-29 00:00:00	1982-11-29	5001	0	\N	0	0	\N	\N	0	353264	0	127783003	4133840		
113238	3495	4024958	1978-01-24	1978-01-24 00:00:00	1978-01-24	5001	0	\N	0	0	\N	\N	0	231826	0	117015009	4024958		
2200	199	3006322	1958-02-20	1958-02-20 00:00:00	1958-02-20	5001	0	\N	0	0	\N	\N	0	13638	0	8331-1	3006322		
33398	3020	3011505	2015-02-18	2015-02-18 00:00:00	2015-02-18	5001	0	\N	0	0	\N	\N	0	201377	0	19926-5	3011505		
33454	3025	3015076	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	201695	0	6248-9	3015076		
22553	2069	3006322	1958-08-17	1958-08-17 00:00:00	1958-08-17	5001	0	\N	0	0	\N	\N	0	137567	0	8331-1	3006322		
16621	1513	3001488	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	101125	0	7258-7	3001488		
40350	3752	46235214	1994-04-27	1994-04-27 00:00:00	1994-04-27	5001	0	\N	0	0	\N	\N	0	249306	0	76690-7	46235214		
44020	4064	3027231	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	270030	0	6276-0	3027231		
29776	2743	46235214	1961-06-05	1961-06-05 00:00:00	1961-06-05	5001	0	\N	0	0	\N	\N	0	181454	0	76690-7	46235214		
51890	4761	3020655	1996-11-11	1996-11-11 00:00:00	1996-11-11	5001	0	\N	0	0	\N	\N	0	317251	0	6844-5	3020655		
41171	3836	3006322	1998-06-29	1998-06-29 00:00:00	1998-06-29	5001	0	\N	0	0	\N	\N	0	254722	0	8331-1	3006322		
7883	754	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	49966	0	6189-5	3006734		
51968	4764	3006322	2015-03-02	2015-03-02 00:00:00	2015-03-02	5001	0	\N	0	0	\N	\N	0	317511	0	8331-1	3006322		
26762	2468	3006322	1974-02-20	1974-02-20 00:00:00	1974-02-20	5001	0	\N	0	0	\N	\N	0	163633	0	8331-1	3006322		
134110	4130	4024958	2017-10-15	2017-10-15 00:00:00	2017-10-15	5001	0	\N	0	0	\N	\N	0	274610	0	117015009	4024958		
40198	3744	3036780	2006-07-12	2006-07-12 00:00:00	2006-07-12	5001	0	\N	0	0	\N	\N	0	248784	0	6095-4	3036780		
49617	4514	3019406	1976-06-28	1976-06-28 00:00:00	1976-06-28	5001	0	\N	0	0	\N	\N	0	300670	0	6158-0	3019406		
49666	4520	3011505	1984-12-01	1984-12-01 00:00:00	1984-12-01	5001	0	\N	0	0	\N	\N	0	300924	0	19926-5	3011505		
30962	2832	3006451	1997-09-06	1997-09-06 00:00:00	1997-09-06	5001	0	\N	0	0	\N	\N	0	187932	0	6273-7	3006451		
22056	693	4024958	1954-09-15	1954-09-15 00:00:00	1954-09-15	5001	0	\N	0	0	\N	\N	0	45961	0	117015009	4024958		
50	2	3011505	2000-07-25	2000-07-25 00:00:00	2000-07-25	5001	0	\N	0	0	\N	\N	0	186	0	19926-5	3011505		
38023	1176	4024958	1965-10-05	1965-10-05 00:00:00	1965-10-05	5001	0	\N	0	0	\N	\N	0	77648	0	117015009	4024958		
53833	4935	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	328123	0	6246-3	3021226		
21148	1956	3006322	1994-01-27	1994-01-27 00:00:00	1994-01-27	5001	0	\N	0	0	\N	\N	0	130204	0	8331-1	3006322		
44381	1367	4052083	2006-06-25	2006-06-25 00:00:00	2006-06-25	5001	0	\N	0	0	\N	\N	0	90601	0	23426006	4052083		
29938	925	4133840	2013-05-24	2013-05-24 00:00:00	2013-05-24	5001	0	\N	0	0	\N	\N	0	61598	0	127783003	4133840		
1751	155	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	10534	0	6158-0	3019406		
87460	2702	4024958	2007-10-10	2007-10-10 00:00:00	2007-10-10	5001	0	\N	0	0	\N	\N	0	178938	0	117015009	4024958		
44160	4071	3051031	1966-01-27	1966-01-27 00:00:00	1966-01-27	5001	0	\N	0	0	\N	\N	0	270612	0	46240-8	3051031		
19132	1753	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	117215	0	6206-7	3012494		
97609	2986	4133840	2010-03-16	2010-03-16 00:00:00	2010-03-16	5001	0	\N	0	0	\N	\N	0	199316	0	127783003	4133840		
55912	5123	3006322	1990-03-14	1990-03-14 00:00:00	1990-03-14	5001	0	\N	0	0	\N	\N	0	340637	0	8331-1	3006322		
1391	124	3001247	1987-04-02	1987-04-02 00:00:00	1987-04-02	5001	0	\N	0	0	\N	\N	0	8296	0	6085-5	3001247		
84166	2604	4052083	2011-05-19	2011-05-19 00:00:00	2011-05-19	5001	0	\N	0	0	\N	\N	0	172316	0	23426006	4052083		
56030	1709	4052083	1989-05-23	1989-05-23 00:00:00	1989-05-23	5001	0	\N	0	0	\N	\N	0	114321	0	23426006	4052083		
24875	776	4024958	1981-10-03	1981-10-03 00:00:00	1981-10-03	5001	0	\N	0	0	\N	\N	0	51527	0	117015009	4024958		
36952	3397	3006322	1951-01-13	1951-01-13 00:00:00	1951-01-13	5001	0	\N	0	0	\N	\N	0	225333	0	8331-1	3006322		
107062	3300	4024958	1982-10-05	1982-10-05 00:00:00	1982-10-05	5001	0	\N	0	0	\N	\N	0	219235	0	117015009	4024958		
52896	4855	3006322	1996-10-31	1996-10-31 00:00:00	1996-10-31	5001	0	\N	0	0	\N	\N	0	322995	0	8331-1	3006322		
56468	5185	3006322	2015-04-07	2015-04-07 00:00:00	2015-04-07	5001	0	\N	0	0	\N	\N	0	344688	0	8331-1	3006322		
27781	2555	3006322	1958-02-26	1958-02-26 00:00:00	1958-02-26	5001	0	\N	0	0	\N	\N	0	169320	0	8331-1	3006322		
41110	3822	3006322	1948-01-12	1948-01-12 00:00:00	1948-01-12	5001	0	\N	0	0	\N	\N	0	253862	0	8331-1	3006322		
14759	1371	3006322	2008-11-13	2008-11-13 00:00:00	2008-11-13	5001	0	\N	0	0	\N	\N	0	90915	0	8331-1	3006322		
22801	2088	3051031	1996-02-28	1996-02-28 00:00:00	1996-02-28	5001	0	\N	0	0	\N	\N	0	139204	0	46240-8	3051031		
39345	3636	40758406	2014-08-03	2014-08-03 00:00:00	2014-08-03	5001	0	\N	0	0	\N	\N	0	241785	0	55277-8	40758406		
22698	2077	3000876	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	138284	0	6082-2	3000876		
22710	2080	3006322	1990-06-12	1990-06-12 00:00:00	1990-06-12	5001	0	\N	0	0	\N	\N	0	138535	0	8331-1	3006322		
31142	2849	3006322	1927-04-08	1927-04-08 00:00:00	1927-04-08	5001	0	\N	0	0	\N	\N	0	189246	0	8331-1	3006322		
2086	191	40758406	1976-08-11	1976-08-11 00:00:00	1976-08-11	5001	0	\N	0	0	\N	\N	0	13099	0	55277-8	40758406		
49160	4493	3006322	2004-07-11	2004-07-11 00:00:00	2004-07-11	5001	0	\N	0	0	\N	\N	0	299142	0	8331-1	3006322		
8360	788	46235214	1989-03-04	1989-03-04 00:00:00	1989-03-04	5001	0	\N	0	0	\N	\N	0	52406	0	76690-7	46235214		
27364	2540	40766240	1959-08-09	1959-08-09 00:00:00	1959-08-09	5001	0	\N	0	0	\N	\N	0	167976	0	63513-6	40766240		
11895	1137	40766240	1984-08-31	1984-08-31 00:00:00	1984-08-31	5001	0	\N	0	0	\N	\N	0	74939	0	63513-6	40766240		
100167	3074	4024958	1962-05-25	1962-05-25 00:00:00	1962-05-25	5001	0	\N	0	0	\N	\N	0	204536	0	117015009	4024958		
36430	3347	3006322	1999-08-12	1999-08-12 00:00:00	1999-08-12	5001	0	\N	0	0	\N	\N	0	222063	0	8331-1	3006322		
32003	2917	3006322	1949-05-30	1949-05-30 00:00:00	1949-05-30	5001	0	\N	0	0	\N	\N	0	194434	0	8331-1	3006322		
32035	2919	3011505	2008-10-11	2008-10-11 00:00:00	2008-10-11	5001	0	\N	0	0	\N	\N	0	194625	0	19926-5	3011505		
106548	3280	4133840	2016-12-08	2016-12-08 00:00:00	2016-12-08	5001	0	\N	0	0	\N	\N	0	218000	0	127783003	4133840		
36778	3376	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	224054	0	7258-7	3001488		
47550	1448	4024958	1981-05-19	1981-05-19 00:00:00	1981-05-19	5001	0	\N	0	0	\N	\N	0	96569	0	117015009	4024958		
30129	2771	3006322	1969-10-11	1969-10-11 00:00:00	1969-10-11	5001	0	\N	0	0	\N	\N	0	183527	0	8331-1	3006322		
37928	3505	3006322	1965-03-11	1965-03-11 00:00:00	1965-03-11	5001	0	\N	0	0	\N	\N	0	232397	0	8331-1	3006322		
3141	299	40758406	1963-07-07	1963-07-07 00:00:00	1963-07-07	5001	0	\N	0	0	\N	\N	0	20020	0	55277-8	40758406		
173026	5312	4024958	1995-01-14	1995-01-14 00:00:00	1995-01-14	5001	0	\N	0	0	\N	\N	0	353270	0	117015009	4024958		
149889	4595	4052083	1976-03-02	1976-03-02 00:00:00	1976-03-02	5001	0	\N	0	0	\N	\N	0	306186	0	23426006	4052083		
2221	202	3006322	1990-07-09	1990-07-09 00:00:00	1990-07-09	5001	0	\N	0	0	\N	\N	0	13849	0	8331-1	3006322		
33399	3020	3011505	2011-01-26	2011-01-26 00:00:00	2011-01-26	5001	0	\N	0	0	\N	\N	0	201433	0	19926-5	3011505		
33455	3025	3014599	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	201695	0	6106-9	3014599		
22554	2069	3006322	1991-01-27	1991-01-27 00:00:00	1991-01-27	5001	0	\N	0	0	\N	\N	0	137569	0	8331-1	3006322		
16622	1513	3001247	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	101125	0	6085-5	3001247		
40351	3752	40758406	1994-04-27	1994-04-27 00:00:00	1994-04-27	5001	0	\N	0	0	\N	\N	0	249306	0	55277-8	40758406		
44021	4064	3019406	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	270013	0	6158-0	3019406		
29777	2743	3006322	1973-11-25	1973-11-25 00:00:00	1973-11-25	5001	0	\N	0	0	\N	\N	0	181455	0	8331-1	3006322		
51891	4761	3006734	1996-11-11	1996-11-11 00:00:00	1996-11-11	5001	0	\N	0	0	\N	\N	0	317251	0	6189-5	3006734		
41172	3836	3006322	1981-06-15	1981-06-15 00:00:00	1981-06-15	5001	0	\N	0	0	\N	\N	0	254736	0	8331-1	3006322		
7884	754	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	49966	0	6273-7	3006451		
51969	4764	3006322	2013-12-27	2013-12-27 00:00:00	2013-12-27	5001	0	\N	0	0	\N	\N	0	317485	0	8331-1	3006322		
26763	2468	3006322	2005-03-04	2005-03-04 00:00:00	2005-03-04	5001	0	\N	0	0	\N	\N	0	163608	0	8331-1	3006322		
65688	2017	4024958	2009-10-09	2009-10-09 00:00:00	2009-10-09	5001	0	\N	0	0	\N	\N	0	134161	0	117015009	4024958		
40199	3744	3023430	2006-07-12	2006-07-12 00:00:00	2006-07-12	5001	0	\N	0	0	\N	\N	0	248784	0	6833-8	3023430		
49618	4514	3014599	1976-06-28	1976-06-28 00:00:00	1976-06-28	5001	0	\N	0	0	\N	\N	0	300670	0	6106-9	3014599		
49668	4520	40766240	1928-07-07	1928-07-07 00:00:00	1928-07-07	5001	0	\N	0	0	\N	\N	0	300942	0	63513-6	40766240		
30963	2832	3021226	1997-09-06	1997-09-06 00:00:00	1997-09-06	5001	0	\N	0	0	\N	\N	0	187932	0	6246-3	3021226		
22064	693	4024958	2007-10-04	2007-10-04 00:00:00	2007-10-04	5001	0	\N	0	0	\N	\N	0	45909	0	117015009	4024958		
51	2	3011505	1991-10-08	1991-10-08 00:00:00	1991-10-08	5001	0	\N	0	0	\N	\N	0	174	0	19926-5	3011505		
38037	1177	4024958	1980-07-22	1980-07-22 00:00:00	1980-07-22	5001	0	\N	0	0	\N	\N	0	77731	0	117015009	4024958		
53834	4935	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	328123	0	6248-9	3015076		
21149	1956	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	130152	0	6095-4	3036780		
44385	1367	4024958	2000-05-17	2000-05-17 00:00:00	2000-05-17	5001	0	\N	0	0	\N	\N	0	90599	0	117015009	4024958		
29941	925	4133840	2014-10-03	2014-10-03 00:00:00	2014-10-03	5001	0	\N	0	0	\N	\N	0	61605	0	127783003	4133840		
1752	155	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	10534	0	6248-9	3015076		
87471	2703	4052083	1986-02-17	1986-02-17 00:00:00	1986-02-17	5001	0	\N	0	0	\N	\N	0	179087	0	23426006	4052083		
44162	4071	3006322	1976-07-30	1976-07-30 00:00:00	1976-07-30	5001	0	\N	0	0	\N	\N	0	270619	0	8331-1	3006322		
19133	1753	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	117215	0	6833-8	3023430		
97614	2986	4133840	2011-03-22	2011-03-22 00:00:00	2011-03-22	5001	0	\N	0	0	\N	\N	0	199323	0	127783003	4133840		
55913	5123	3006322	1989-12-05	1989-12-05 00:00:00	1989-12-05	5001	0	\N	0	0	\N	\N	0	340640	0	8331-1	3006322		
1392	124	3023430	1987-04-02	1987-04-02 00:00:00	1987-04-02	5001	0	\N	0	0	\N	\N	0	8296	0	6833-8	3023430		
84171	2604	4052083	1966-02-18	1966-02-18 00:00:00	1966-02-18	5001	0	\N	0	0	\N	\N	0	172253	0	23426006	4052083		
56034	1709	4024958	1971-03-13	1971-03-13 00:00:00	1971-03-13	5001	0	\N	0	0	\N	\N	0	114264	0	117015009	4024958		
24877	776	4133840	2017-09-21	2017-09-21 00:00:00	2017-09-21	5001	0	\N	0	0	\N	\N	0	51513	0	127783003	4133840		
36953	3397	3006322	1952-06-19	1952-06-19 00:00:00	1952-06-19	5001	0	\N	0	0	\N	\N	0	225363	0	8331-1	3006322		
107066	3300	4052083	1983-05-03	1983-05-03 00:00:00	1983-05-03	5001	0	\N	0	0	\N	\N	0	219217	0	23426006	4052083		
52897	4855	3006322	2008-03-11	2008-03-11 00:00:00	2008-03-11	5001	0	\N	0	0	\N	\N	0	323021	0	8331-1	3006322		
56472	5185	3006322	2011-07-04	2011-07-04 00:00:00	2011-07-04	5001	0	\N	0	0	\N	\N	0	344699	0	8331-1	3006322		
27782	2555	3006322	1985-10-30	1985-10-30 00:00:00	1985-10-30	5001	0	\N	0	0	\N	\N	0	169339	0	8331-1	3006322		
41111	3822	3006322	1978-03-21	1978-03-21 00:00:00	1978-03-21	5001	0	\N	0	0	\N	\N	0	253847	0	8331-1	3006322		
119594	3689	4052083	1956-07-28	1956-07-28 00:00:00	1956-07-28	5001	0	\N	0	0	\N	\N	0	245234	0	23426006	4052083		
22802	2088	40766240	1996-02-28	1996-02-28 00:00:00	1996-02-28	5001	0	\N	0	0	\N	\N	0	139204	0	63513-6	40766240		
39347	3636	3006322	1998-02-25	1998-02-25 00:00:00	1998-02-25	5001	0	\N	0	0	\N	\N	0	241867	0	8331-1	3006322		
22700	2077	3006322	1970-05-25	1970-05-25 00:00:00	1970-05-25	5001	0	\N	0	0	\N	\N	0	138334	0	8331-1	3006322		
22711	2080	3006322	2008-11-14	2008-11-14 00:00:00	2008-11-14	5001	0	\N	0	0	\N	\N	0	138599	0	8331-1	3006322		
31143	2849	3006322	1993-04-08	1993-04-08 00:00:00	1993-04-08	5001	0	\N	0	0	\N	\N	0	189270	0	8331-1	3006322		
2088	191	3051031	1976-08-11	1976-08-11 00:00:00	1976-08-11	5001	0	\N	0	0	\N	\N	0	13099	0	46240-8	3051031		
49161	4493	3006322	1987-04-30	1987-04-30 00:00:00	1987-04-30	5001	0	\N	0	0	\N	\N	0	299153	0	8331-1	3006322		
8362	788	3006322	1970-11-06	1970-11-06 00:00:00	1970-11-06	5001	0	\N	0	0	\N	\N	0	52392	0	8331-1	3006322		
27365	2540	46235214	1959-08-09	1959-08-09 00:00:00	1959-08-09	5001	0	\N	0	0	\N	\N	0	167976	0	76690-7	46235214		
11897	1137	46235214	1984-06-02	1984-06-02 00:00:00	1984-06-02	5001	0	\N	0	0	\N	\N	0	74938	0	76690-7	46235214		
100179	3074	4024958	1964-06-27	1964-06-27 00:00:00	1964-06-27	5001	0	\N	0	0	\N	\N	0	204577	0	117015009	4024958		
36431	3347	3006322	1956-10-05	1956-10-05 00:00:00	1956-10-05	5001	0	\N	0	0	\N	\N	0	222065	0	8331-1	3006322		
32005	2917	40766240	1951-09-29	1951-09-29 00:00:00	1951-09-29	5001	0	\N	0	0	\N	\N	0	194493	0	63513-6	40766240		
32036	2919	3011505	2013-11-23	2013-11-23 00:00:00	2013-11-23	5001	0	\N	0	0	\N	\N	0	194634	0	19926-5	3011505		
106553	3280	4052083	1974-02-15	1974-02-15 00:00:00	1974-02-15	5001	0	\N	0	0	\N	\N	0	218042	0	23426006	4052083		
36779	3376	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	224054	0	6189-5	3006734		
47567	1448	4024958	1996-11-07	1996-11-07 00:00:00	1996-11-07	5001	0	\N	0	0	\N	\N	0	96588	0	117015009	4024958		
30130	2771	3006322	1995-09-15	1995-09-15 00:00:00	1995-09-15	5001	0	\N	0	0	\N	\N	0	183459	0	8331-1	3006322		
37929	3505	3006322	1982-09-14	1982-09-14 00:00:00	1982-09-14	5001	0	\N	0	0	\N	\N	0	232468	0	8331-1	3006322		
3143	299	3051031	1963-07-07	1963-07-07 00:00:00	1963-07-07	5001	0	\N	0	0	\N	\N	0	20020	0	46240-8	3051031		
173028	5312	4133840	1994-12-05	1994-12-05 00:00:00	1994-12-05	5001	0	\N	0	0	\N	\N	0	353245	0	127783003	4133840		
149903	4595	4052083	1991-04-09	1991-04-09 00:00:00	1991-04-09	5001	0	\N	0	0	\N	\N	0	306188	0	23426006	4052083		
2222	202	3006322	2002-11-23	2002-11-23 00:00:00	2002-11-23	5001	0	\N	0	0	\N	\N	0	13812	0	8331-1	3006322		
33400	3020	3011505	2018-03-07	2018-03-07 00:00:00	2018-03-07	5001	0	\N	0	0	\N	\N	0	201389	0	19926-5	3011505		
33456	3025	3021226	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	201695	0	6246-3	3021226		
6546	202	4052083	1998-01-30	1998-01-30 00:00:00	1998-01-30	5001	0	\N	0	0	\N	\N	0	13886	0	23426006	4052083		
16623	1513	3000876	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	101125	0	6082-2	3000876		
40353	3752	40766240	1994-04-27	1994-04-27 00:00:00	1994-04-27	5001	0	\N	0	0	\N	\N	0	249306	0	63513-6	40766240		
44022	4064	3001488	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	270013	0	7258-7	3001488		
29778	2743	3006322	2008-03-19	2008-03-19 00:00:00	2008-03-19	5001	0	\N	0	0	\N	\N	0	181432	0	8331-1	3006322		
51892	4761	3023430	1996-11-11	1996-11-11 00:00:00	1996-11-11	5001	0	\N	0	0	\N	\N	0	317251	0	6833-8	3023430		
41175	3839	3006322	1952-12-12	1952-12-12 00:00:00	1952-12-12	5001	0	\N	0	0	\N	\N	0	254836	0	8331-1	3006322		
7885	754	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	49966	0	6106-9	3014599		
52014	4771	3006322	1981-10-03	1981-10-03 00:00:00	1981-10-03	5001	0	\N	0	0	\N	\N	0	317745	0	8331-1	3006322		
26764	2468	3006322	1941-09-23	1941-09-23 00:00:00	1941-09-23	5001	0	\N	0	0	\N	\N	0	163662	0	8331-1	3006322		
76975	2357	4052083	1957-09-26	1957-09-26 00:00:00	1957-09-26	5001	0	\N	0	0	\N	\N	0	157093	0	23426006	4052083		
40200	3744	3000876	2006-07-12	2006-07-12 00:00:00	2006-07-12	5001	0	\N	0	0	\N	\N	0	248784	0	6082-2	3000876		
49619	4514	3012494	1976-06-28	1976-06-28 00:00:00	1976-06-28	5001	0	\N	0	0	\N	\N	0	300670	0	6206-7	3012494		
49669	4520	40758406	1928-07-07	1928-07-07 00:00:00	1928-07-07	5001	0	\N	0	0	\N	\N	0	300942	0	55277-8	40758406		
30964	2832	3005136	1997-09-06	1997-09-06 00:00:00	1997-09-06	5001	0	\N	0	0	\N	\N	0	187932	0	6075-6	3005136		
26619	834	4024958	1977-12-14	1977-12-14 00:00:00	1977-12-14	5001	0	\N	0	0	\N	\N	0	55239	0	117015009	4024958		
52	2	3006322	2001-02-03	2001-02-03 00:00:00	2001-02-03	5001	0	\N	0	0	\N	\N	0	143	0	8331-1	3006322		
38047	1177	4024958	2006-03-19	2006-03-19 00:00:00	2006-03-19	5001	0	\N	0	0	\N	\N	0	77800	0	117015009	4024958		
53835	4935	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	328123	0	6158-0	3019406		
21150	1956	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	130152	0	6273-7	3006451		
55685	1695	4052083	2007-02-27	2007-02-27 00:00:00	2007-02-27	5001	0	\N	0	0	\N	\N	0	113440	0	23426006	4052083		
75983	2333	4052083	1958-09-19	1958-09-19 00:00:00	1958-09-19	5001	0	\N	0	0	\N	\N	0	155202	0	23426006	4052083		
1753	155	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	10534	0	6833-8	3023430		
130656	4026	4052083	2003-01-20	2003-01-20 00:00:00	2003-01-20	5001	0	\N	0	0	\N	\N	0	267713	0	23426006	4052083		
44163	4071	3006322	2010-03-01	2010-03-01 00:00:00	2010-03-01	5001	0	\N	0	0	\N	\N	0	270568	0	8331-1	3006322		
19134	1753	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	117215	0	6082-2	3000876		
97619	2986	4133840	1990-10-30	1990-10-30 00:00:00	1990-10-30	5001	0	\N	0	0	\N	\N	0	199301	0	127783003	4133840		
55914	5123	3006322	1990-10-23	1990-10-23 00:00:00	1990-10-23	5001	0	\N	0	0	\N	\N	0	340641	0	8331-1	3006322		
1393	124	3000876	1987-04-02	1987-04-02 00:00:00	1987-04-02	5001	0	\N	0	0	\N	\N	0	8296	0	6082-2	3000876		
164980	5065	4052083	1984-06-23	1984-06-23 00:00:00	1984-06-23	5001	0	\N	0	0	\N	\N	0	336702	0	23426006	4052083		
56042	1709	4024958	1955-03-18	1955-03-18 00:00:00	1955-03-18	5001	0	\N	0	0	\N	\N	0	114253	0	117015009	4024958		
24878	776	4133840	2013-08-29	2013-08-29 00:00:00	2013-08-29	5001	0	\N	0	0	\N	\N	0	51511	0	127783003	4133840		
36954	3397	3006322	2010-04-24	2010-04-24 00:00:00	2010-04-24	5001	0	\N	0	0	\N	\N	0	225314	0	8331-1	3006322		
67541	2071	4052083	1976-12-08	1976-12-08 00:00:00	1976-12-08	5001	0	\N	0	0	\N	\N	0	137789	0	23426006	4052083		
52898	4855	3006322	1984-11-03	1984-11-03 00:00:00	1984-11-03	5001	0	\N	0	0	\N	\N	0	323004	0	8331-1	3006322		
56473	5185	3006322	1999-10-06	1999-10-06 00:00:00	1999-10-06	5001	0	\N	0	0	\N	\N	0	344685	0	8331-1	3006322		
27783	2555	3006322	1978-06-02	1978-06-02 00:00:00	1978-06-02	5001	0	\N	0	0	\N	\N	0	169322	0	8331-1	3006322		
41112	3822	3006322	1953-01-11	1953-01-11 00:00:00	1953-01-11	5001	0	\N	0	0	\N	\N	0	253898	0	8331-1	3006322		
119596	3689	4052083	1975-03-10	1975-03-10 00:00:00	1975-03-10	5001	0	\N	0	0	\N	\N	0	245229	0	23426006	4052083		
22803	2088	46235214	1996-02-28	1996-02-28 00:00:00	1996-02-28	5001	0	\N	0	0	\N	\N	0	139204	0	76690-7	46235214		
39348	3637	3006322	1966-10-16	1966-10-16 00:00:00	1966-10-16	5001	0	\N	0	0	\N	\N	0	241899	0	8331-1	3006322		
22701	2078	3006322	2007-02-15	2007-02-15 00:00:00	2007-02-15	5001	0	\N	0	0	\N	\N	0	138423	0	8331-1	3006322		
22712	2080	3006322	2013-11-27	2013-11-27 00:00:00	2013-11-27	5001	0	\N	0	0	\N	\N	0	138578	0	8331-1	3006322		
31144	2849	3049273	1987-09-25	1987-09-25 00:00:00	1987-09-25	5001	0	\N	0	0	\N	\N	0	189295	0	38265-5	3049273		
2090	191	3006322	1924-12-24	1924-12-24 00:00:00	1924-12-24	5001	0	\N	0	0	\N	\N	0	13055	0	8331-1	3006322		
49164	4496	3006322	1953-10-08	1953-10-08 00:00:00	1953-10-08	5001	0	\N	0	0	\N	\N	0	299309	0	8331-1	3006322		
8363	788	3006322	1974-11-27	1974-11-27 00:00:00	1974-11-27	5001	0	\N	0	0	\N	\N	0	52393	0	8331-1	3006322		
27367	2540	3051031	1959-08-09	1959-08-09 00:00:00	1959-08-09	5001	0	\N	0	0	\N	\N	0	167976	0	46240-8	3051031		
11898	1137	40758406	1984-06-02	1984-06-02 00:00:00	1984-06-02	5001	0	\N	0	0	\N	\N	0	74938	0	55277-8	40758406		
100180	3074	4024958	1979-05-24	1979-05-24 00:00:00	1979-05-24	5001	0	\N	0	0	\N	\N	0	204539	0	117015009	4024958		
118386	3644	4024958	1959-06-02	1959-06-02 00:00:00	1959-06-02	5001	0	\N	0	0	\N	\N	0	242473	0	117015009	4024958		
32008	2917	46235214	1951-09-29	1951-09-29 00:00:00	1951-09-29	5001	0	\N	0	0	\N	\N	0	194493	0	76690-7	46235214		
32037	2919	3006322	1976-10-01	1976-10-01 00:00:00	1976-10-01	5001	0	\N	0	0	\N	\N	0	194562	0	8331-1	3006322		
106562	3280	4024958	1959-08-04	1959-08-04 00:00:00	1959-08-04	5001	0	\N	0	0	\N	\N	0	218004	0	117015009	4024958		
36780	3376	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	224054	0	6273-7	3006451		
47576	1448	4024958	2008-11-28	2008-11-28 00:00:00	2008-11-28	5001	0	\N	0	0	\N	\N	0	96604	0	117015009	4024958		
30131	2771	3049273	2013-09-28	2013-09-28 00:00:00	2013-09-28	5001	0	\N	0	0	\N	\N	0	183478	0	38265-5	3049273		
37930	3505	3006322	2014-01-05	2014-01-05 00:00:00	2014-01-05	5001	0	\N	0	0	\N	\N	0	232483	0	8331-1	3006322		
3144	299	3011505	2016-01-02	2016-01-02 00:00:00	2016-01-02	5001	0	\N	0	0	\N	\N	0	19992	0	19926-5	3011505		
173031	5312	4133840	2003-01-06	2003-01-06 00:00:00	2003-01-06	5001	0	\N	0	0	\N	\N	0	353235	0	127783003	4133840		
149916	4596	4052083	1957-10-25	1957-10-25 00:00:00	1957-10-25	5001	0	\N	0	0	\N	\N	0	306254	0	23426006	4052083		
2223	202	3006322	2005-04-26	2005-04-26 00:00:00	2005-04-26	5001	0	\N	0	0	\N	\N	0	13850	0	8331-1	3006322		
33401	3020	3006322	2005-09-05	2005-09-05 00:00:00	2005-09-05	5001	0	\N	0	0	\N	\N	0	201394	0	8331-1	3006322		
33457	3025	3027231	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	201695	0	6276-0	3027231		
6547	202	4052083	1964-03-11	1964-03-11 00:00:00	1964-03-11	5001	0	\N	0	0	\N	\N	0	13842	0	23426006	4052083		
16624	1513	3006322	1975-09-30	1975-09-30 00:00:00	1975-09-30	5001	0	\N	0	0	\N	\N	0	101117	0	8331-1	3006322		
40355	3752	40766240	1993-01-02	1993-01-02 00:00:00	1993-01-02	5001	0	\N	0	0	\N	\N	0	249309	0	63513-6	40766240		
44023	4064	3005136	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	270013	0	6075-6	3005136		
29779	2743	46235214	1961-05-06	1961-05-06 00:00:00	1961-05-06	5001	0	\N	0	0	\N	\N	0	181471	0	76690-7	46235214		
51893	4761	3021226	1996-11-11	1996-11-11 00:00:00	1996-11-11	5001	0	\N	0	0	\N	\N	0	317251	0	6246-3	3021226		
41176	3839	3006322	1981-11-01	1981-11-01 00:00:00	1981-11-01	5001	0	\N	0	0	\N	\N	0	254921	0	8331-1	3006322		
7886	754	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	49966	0	7258-7	3001488		
52015	4771	3006322	1962-07-15	1962-07-15 00:00:00	1962-07-15	5001	0	\N	0	0	\N	\N	0	317774	0	8331-1	3006322		
26765	2468	3006322	1970-07-07	1970-07-07 00:00:00	1970-07-07	5001	0	\N	0	0	\N	\N	0	163586	0	8331-1	3006322		
77000	2357	4024958	1967-06-28	1967-06-28 00:00:00	1967-06-28	5001	0	\N	0	0	\N	\N	0	157081	0	117015009	4024958		
40201	3744	3021226	2006-07-12	2006-07-12 00:00:00	2006-07-12	5001	0	\N	0	0	\N	\N	0	248784	0	6246-3	3021226		
49620	4514	3027231	1976-06-28	1976-06-28 00:00:00	1976-06-28	5001	0	\N	0	0	\N	\N	0	300670	0	6276-0	3027231		
49670	4520	3051031	1928-07-07	1928-07-07 00:00:00	1928-07-07	5001	0	\N	0	0	\N	\N	0	300942	0	46240-8	3051031		
30965	2832	3000876	1997-09-06	1997-09-06 00:00:00	1997-09-06	5001	0	\N	0	0	\N	\N	0	187932	0	6082-2	3000876		
53	2	3051031	1935-03-25	1935-03-25 00:00:00	1935-03-25	5001	0	\N	0	0	\N	\N	0	184	0	46240-8	3051031		
172123	5283	4052083	1998-08-29	1998-08-29 00:00:00	1998-08-29	5001	0	\N	0	0	\N	\N	0	351430	0	23426006	4052083		
53836	4935	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	328123	0	6844-5	3020655		
21151	1956	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	130152	0	6248-9	3015076		
10394	332	4052083	2005-10-28	2005-10-28 00:00:00	2005-10-28	5001	0	\N	0	0	\N	\N	0	21958	0	23426006	4052083		
76008	2333	4052083	1926-02-01	1926-02-01 00:00:00	1926-02-01	5001	0	\N	0	0	\N	\N	0	155257	0	23426006	4052083		
1754	155	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	10534	0	6844-5	3020655		
130661	4026	4024958	2018-04-01	2018-04-01 00:00:00	2018-04-01	5001	0	\N	0	0	\N	\N	0	267601	0	117015009	4024958		
44164	4071	40758406	1966-11-23	1966-11-23 00:00:00	1966-11-23	5001	0	\N	0	0	\N	\N	0	270585	0	55277-8	40758406		
19135	1753	3006322	1998-04-18	1998-04-18 00:00:00	1998-04-18	5001	0	\N	0	0	\N	\N	0	117204	0	8331-1	3006322		
97622	2986	4133840	2019-06-18	2019-06-18 00:00:00	2019-06-18	5001	0	\N	0	0	\N	\N	0	199345	0	127783003	4133840		
55927	5127	3006322	2002-10-27	2002-10-27 00:00:00	2002-10-27	5001	0	\N	0	0	\N	\N	0	340891	0	8331-1	3006322		
1394	124	3005136	1987-04-02	1987-04-02 00:00:00	1987-04-02	5001	0	\N	0	0	\N	\N	0	8296	0	6075-6	3005136		
164982	5065	4052083	1989-02-04	1989-02-04 00:00:00	1989-02-04	5001	0	\N	0	0	\N	\N	0	336734	0	23426006	4052083		
56311	1719	4052083	1961-03-05	1961-03-05 00:00:00	1961-03-05	5001	0	\N	0	0	\N	\N	0	114965	0	23426006	4052083		
24879	776	4133840	2009-08-06	2009-08-06 00:00:00	2009-08-06	5001	0	\N	0	0	\N	\N	0	51506	0	127783003	4133840		
36957	3399	3005136	1983-12-17	1983-12-17 00:00:00	1983-12-17	5001	0	\N	0	0	\N	\N	0	225486	0	6075-6	3005136		
67545	2071	4052083	1989-01-19	1989-01-19 00:00:00	1989-01-19	5001	0	\N	0	0	\N	\N	0	137806	0	23426006	4052083		
52910	4859	3006322	2018-08-30	2018-08-30 00:00:00	2018-08-30	5001	0	\N	0	0	\N	\N	0	323237	0	8331-1	3006322		
56474	5185	3006322	1950-07-09	1950-07-09 00:00:00	1950-07-09	5001	0	\N	0	0	\N	\N	0	344649	0	8331-1	3006322		
27784	2556	3006322	2012-01-16	2012-01-16 00:00:00	2012-01-16	5001	0	\N	0	0	\N	\N	0	169396	0	8331-1	3006322		
41113	3822	3006322	1952-01-05	1952-01-05 00:00:00	1952-01-05	5001	0	\N	0	0	\N	\N	0	253864	0	8331-1	3006322		
119597	3689	4052083	2014-07-10	2014-07-10 00:00:00	2014-07-10	5001	0	\N	0	0	\N	\N	0	245221	0	23426006	4052083		
22804	2088	40758406	1996-02-28	1996-02-28 00:00:00	1996-02-28	5001	0	\N	0	0	\N	\N	0	139204	0	55277-8	40758406		
39349	3637	3006322	1970-11-09	1970-11-09 00:00:00	1970-11-09	5001	0	\N	0	0	\N	\N	0	241921	0	8331-1	3006322		
22702	2078	3006322	1984-06-02	1984-06-02 00:00:00	1984-06-02	5001	0	\N	0	0	\N	\N	0	138393	0	8331-1	3006322		
22713	2080	3006322	1985-12-21	1985-12-21 00:00:00	1985-12-21	5001	0	\N	0	0	\N	\N	0	138533	0	8331-1	3006322		
31145	2849	3049273	2003-05-04	2003-05-04 00:00:00	2003-05-04	5001	0	\N	0	0	\N	\N	0	189296	0	38265-5	3049273		
2092	191	40766240	1963-04-17	1963-04-17 00:00:00	1963-04-17	5001	0	\N	0	0	\N	\N	0	13057	0	63513-6	40766240		
49165	4496	3006322	1970-01-26	1970-01-26 00:00:00	1970-01-26	5001	0	\N	0	0	\N	\N	0	299311	0	8331-1	3006322		
8364	788	3006322	2010-06-29	2010-06-29 00:00:00	2010-06-29	5001	0	\N	0	0	\N	\N	0	52414	0	8331-1	3006322		
27368	2540	40758406	1959-08-09	1959-08-09 00:00:00	1959-08-09	5001	0	\N	0	0	\N	\N	0	167976	0	55277-8	40758406		
11899	1137	3051031	1984-06-02	1984-06-02 00:00:00	1984-06-02	5001	0	\N	0	0	\N	\N	0	74938	0	46240-8	3051031		
169165	5194	4052083	1958-05-30	1958-05-30 00:00:00	1958-05-30	5001	0	\N	0	0	\N	\N	0	345288	0	23426006	4052083		
118396	3644	4052083	1975-05-29	1975-05-29 00:00:00	1975-05-29	5001	0	\N	0	0	\N	\N	0	242494	0	23426006	4052083		
32009	2917	3051031	1951-09-29	1951-09-29 00:00:00	1951-09-29	5001	0	\N	0	0	\N	\N	0	194493	0	46240-8	3051031		
32038	2919	3011505	2006-09-30	2006-09-30 00:00:00	2006-09-30	5001	0	\N	0	0	\N	\N	0	194624	0	19926-5	3011505		
106563	3280	4024958	1968-12-24	1968-12-24 00:00:00	1968-12-24	5001	0	\N	0	0	\N	\N	0	218031	0	117015009	4024958		
36781	3376	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	224054	0	6246-3	3021226		
47596	1450	4052083	1999-11-03	1999-11-03 00:00:00	1999-11-03	5001	0	\N	0	0	\N	\N	0	96740	0	23426006	4052083		
30132	2771	3014576	1974-09-02	1974-09-02 00:00:00	1974-09-02	5001	0	\N	0	0	\N	\N	0	183474	0	2075-0	3014576		
37931	3505	3006322	1959-11-13	1959-11-13 00:00:00	1959-11-13	5001	0	\N	0	0	\N	\N	0	232465	0	8331-1	3006322		
3145	299	46235214	1963-05-08	1963-05-08 00:00:00	1963-05-08	5001	0	\N	0	0	\N	\N	0	20006	0	76690-7	46235214		
173034	5312	4133840	1991-11-18	1991-11-18 00:00:00	1991-11-18	5001	0	\N	0	0	\N	\N	0	353267	0	127783003	4133840		
149920	4596	4024958	1941-01-25	1941-01-25 00:00:00	1941-01-25	5001	0	\N	0	0	\N	\N	0	306259	0	117015009	4024958		
2226	202	3006322	1980-07-03	1980-07-03 00:00:00	1980-07-03	5001	0	\N	0	0	\N	\N	0	13848	0	8331-1	3006322		
33402	3020	3006322	1975-08-27	1975-08-27 00:00:00	1975-08-27	5001	0	\N	0	0	\N	\N	0	201390	0	8331-1	3006322		
33458	3025	3019406	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	201695	0	6158-0	3019406		
6568	202	4052083	2014-11-18	2014-11-18 00:00:00	2014-11-18	5001	0	\N	0	0	\N	\N	0	13889	0	23426006	4052083		
16625	1513	3006322	1993-02-21	1993-02-21 00:00:00	1993-02-21	5001	0	\N	0	0	\N	\N	0	101080	0	8331-1	3006322		
40356	3752	46235214	1993-01-02	1993-01-02 00:00:00	1993-01-02	5001	0	\N	0	0	\N	\N	0	249309	0	76690-7	46235214		
44024	4064	3027231	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	270013	0	6276-0	3027231		
29780	2743	40758406	1961-05-06	1961-05-06 00:00:00	1961-05-06	5001	0	\N	0	0	\N	\N	0	181471	0	55277-8	40758406		
51894	4761	3019406	1996-11-11	1996-11-11 00:00:00	1996-11-11	5001	0	\N	0	0	\N	\N	0	317251	0	6158-0	3019406		
41177	3839	3006322	1979-08-06	1979-08-06 00:00:00	1979-08-06	5001	0	\N	0	0	\N	\N	0	254840	0	8331-1	3006322		
7887	754	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	49966	0	6085-5	3001247		
52016	4771	3006322	1963-04-26	1963-04-26 00:00:00	1963-04-26	5001	0	\N	0	0	\N	\N	0	317756	0	8331-1	3006322		
26766	2469	3006322	2007-07-04	2007-07-04 00:00:00	2007-07-04	5001	0	\N	0	0	\N	\N	0	163716	0	8331-1	3006322		
77002	2357	4024958	1993-10-02	1993-10-02 00:00:00	1993-10-02	5001	0	\N	0	0	\N	\N	0	156982	0	117015009	4024958		
40202	3744	3006734	2006-07-12	2006-07-12 00:00:00	2006-07-12	5001	0	\N	0	0	\N	\N	0	248784	0	6189-5	3006734		
49621	4514	3005136	1976-06-28	1976-06-28 00:00:00	1976-06-28	5001	0	\N	0	0	\N	\N	0	300670	0	6075-6	3005136		
49671	4520	46235214	1928-07-07	1928-07-07 00:00:00	1928-07-07	5001	0	\N	0	0	\N	\N	0	300942	0	76690-7	46235214		
30966	2832	3001247	1997-09-06	1997-09-06 00:00:00	1997-09-06	5001	0	\N	0	0	\N	\N	0	187932	0	6085-5	3001247		
55	2	40766240	1935-03-25	1935-03-25 00:00:00	1935-03-25	5001	0	\N	0	0	\N	\N	0	184	0	63513-6	40766240		
172124	5283	4024958	2009-04-09	2009-04-09 00:00:00	2009-04-09	5001	0	\N	0	0	\N	\N	0	351459	0	117015009	4024958		
53837	4935	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	328123	0	6833-8	3023430		
21152	1956	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	130152	0	6106-9	3014599		
10417	332	4052083	1982-09-26	1982-09-26 00:00:00	1982-09-26	5001	0	\N	0	0	\N	\N	0	22014	0	23426006	4052083		
76016	2333	4052083	1997-10-03	1997-10-03 00:00:00	1997-10-03	5001	0	\N	0	0	\N	\N	0	155207	0	23426006	4052083		
1755	155	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	10534	0	6085-5	3001247		
130663	4026	4133840	2014-02-16	2014-02-16 00:00:00	2014-02-16	5001	0	\N	0	0	\N	\N	0	267758	0	127783003	4133840		
44165	4071	3051031	1966-11-23	1966-11-23 00:00:00	1966-11-23	5001	0	\N	0	0	\N	\N	0	270585	0	46240-8	3051031		
19136	1753	3006322	1973-03-09	1973-03-09 00:00:00	1973-03-09	5001	0	\N	0	0	\N	\N	0	117272	0	8331-1	3006322		
97626	2986	4133840	2007-02-27	2007-02-27 00:00:00	2007-02-27	5001	0	\N	0	0	\N	\N	0	199304	0	127783003	4133840		
55928	5128	3006322	1971-03-28	1971-03-28 00:00:00	1971-03-28	5001	0	\N	0	0	\N	\N	0	341005	0	8331-1	3006322		
1395	124	3014599	1987-04-02	1987-04-02 00:00:00	1987-04-02	5001	0	\N	0	0	\N	\N	0	8296	0	6106-9	3014599		
164983	5065	4024958	2000-07-31	2000-07-31 00:00:00	2000-07-31	5001	0	\N	0	0	\N	\N	0	336703	0	117015009	4024958		
56313	1719	4024958	1967-02-15	1967-02-15 00:00:00	1967-02-15	5001	0	\N	0	0	\N	\N	0	114888	0	117015009	4024958		
24880	776	4024958	1978-08-05	1978-08-05 00:00:00	1978-08-05	5001	0	\N	0	0	\N	\N	0	51558	0	117015009	4024958		
36958	3399	3015076	1983-12-17	1983-12-17 00:00:00	1983-12-17	5001	0	\N	0	0	\N	\N	0	225486	0	6248-9	3015076		
67554	2071	4052083	1993-04-22	1993-04-22 00:00:00	1993-04-22	5001	0	\N	0	0	\N	\N	0	137790	0	23426006	4052083		
52911	4859	3006322	1983-06-10	1983-06-10 00:00:00	1983-06-10	5001	0	\N	0	0	\N	\N	0	323269	0	8331-1	3006322		
56476	5185	3006322	1955-03-26	1955-03-26 00:00:00	1955-03-26	5001	0	\N	0	0	\N	\N	0	344635	0	8331-1	3006322		
27785	2556	3006322	1981-05-17	1981-05-17 00:00:00	1981-05-17	5001	0	\N	0	0	\N	\N	0	169420	0	8331-1	3006322		
41114	3823	3006322	1966-12-26	1966-12-26 00:00:00	1966-12-26	5001	0	\N	0	0	\N	\N	0	253977	0	8331-1	3006322		
119607	3689	4024958	1992-10-06	1992-10-06 00:00:00	1992-10-06	5001	0	\N	0	0	\N	\N	0	245231	0	117015009	4024958		
70605	2164	4024958	2012-08-14	2012-08-14 00:00:00	2012-08-14	5001	0	\N	0	0	\N	\N	0	144158	0	117015009	4024958		
39350	3637	3006322	1993-07-25	1993-07-25 00:00:00	1993-07-25	5001	0	\N	0	0	\N	\N	0	241924	0	8331-1	3006322		
22703	2078	3006322	2012-12-29	2012-12-29 00:00:00	2012-12-29	5001	0	\N	0	0	\N	\N	0	138430	0	8331-1	3006322		
22714	2082	3006322	1967-02-23	1967-02-23 00:00:00	1967-02-23	5001	0	\N	0	0	\N	\N	0	138710	0	8331-1	3006322		
31146	2849	3006322	1925-02-05	1925-02-05 00:00:00	1925-02-05	5001	0	\N	0	0	\N	\N	0	189299	0	8331-1	3006322		
2093	191	3051031	1963-04-17	1963-04-17 00:00:00	1963-04-17	5001	0	\N	0	0	\N	\N	0	13057	0	46240-8	3051031		
49167	4497	40758406	2007-12-12	2007-12-12 00:00:00	2007-12-12	5001	0	\N	0	0	\N	\N	0	299399	0	55277-8	40758406		
8365	788	40758406	1988-10-05	1988-10-05 00:00:00	1988-10-05	5001	0	\N	0	0	\N	\N	0	52431	0	55277-8	40758406		
27370	2540	40766240	1959-02-10	1959-02-10 00:00:00	1959-02-10	5001	0	\N	0	0	\N	\N	0	167975	0	63513-6	40766240		
11901	1137	40766240	1984-06-02	1984-06-02 00:00:00	1984-06-02	5001	0	\N	0	0	\N	\N	0	74938	0	63513-6	40766240		
134984	4159	4052083	1967-04-02	1967-04-02 00:00:00	1967-04-02	5001	0	\N	0	0	\N	\N	0	276366	0	23426006	4052083		
13911	1309	3006322	1989-09-02	1989-09-02 00:00:00	1989-09-02	5001	0	\N	0	0	\N	\N	0	86443	0	8331-1	3006322		
32010	2917	40758406	1951-09-29	1951-09-29 00:00:00	1951-09-29	5001	0	\N	0	0	\N	\N	0	194493	0	55277-8	40758406		
32039	2919	3011505	2016-12-10	2016-12-10 00:00:00	2016-12-10	5001	0	\N	0	0	\N	\N	0	194627	0	19926-5	3011505		
47919	4388	3006322	1983-04-07	1983-04-07 00:00:00	1983-04-07	5001	0	\N	0	0	\N	\N	0	291660	0	8331-1	3006322		
36782	3376	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	224054	0	6206-7	3012494		
47606	1450	4024958	1983-10-25	1983-10-25 00:00:00	1983-10-25	5001	0	\N	0	0	\N	\N	0	96719	0	117015009	4024958		
30133	2771	3010813	1974-09-02	1974-09-02 00:00:00	1974-09-02	5001	0	\N	0	0	\N	\N	0	183474	0	26464-8	3010813		
37932	3505	3006322	1977-07-01	1977-07-01 00:00:00	1977-07-01	5001	0	\N	0	0	\N	\N	0	232399	0	8331-1	3006322		
49269	4500	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	299570	0	6246-3	3021226		
173035	5312	4133840	1989-11-06	1989-11-06 00:00:00	1989-11-06	5001	0	\N	0	0	\N	\N	0	353266	0	127783003	4133840		
149922	4596	4052083	2017-01-01	2017-01-01 00:00:00	2017-01-01	5001	0	\N	0	0	\N	\N	0	306305	0	23426006	4052083		
2227	202	3006322	1989-07-02	1989-07-02 00:00:00	1989-07-02	5001	0	\N	0	0	\N	\N	0	13843	0	8331-1	3006322		
33403	3020	3011505	2012-02-01	2012-02-01 00:00:00	2012-02-01	5001	0	\N	0	0	\N	\N	0	201386	0	19926-5	3011505		
33459	3025	3012494	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	201695	0	6206-7	3012494		
6572	202	4024958	1989-07-02	1989-07-02 00:00:00	1989-07-02	5001	0	\N	0	0	\N	\N	0	13843	0	117015009	4024958		
16626	1513	3006322	1996-05-17	1996-05-17 00:00:00	1996-05-17	5001	0	\N	0	0	\N	\N	0	101024	0	8331-1	3006322		
40357	3752	3051031	1993-01-02	1993-01-02 00:00:00	1993-01-02	5001	0	\N	0	0	\N	\N	0	249309	0	46240-8	3051031		
44025	4064	3006451	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	270013	0	6273-7	3006451		
29782	2743	40766240	1961-05-06	1961-05-06 00:00:00	1961-05-06	5001	0	\N	0	0	\N	\N	0	181471	0	63513-6	40766240		
51895	4761	3001488	1996-11-11	1996-11-11 00:00:00	1996-11-11	5001	0	\N	0	0	\N	\N	0	317251	0	7258-7	3001488		
41178	3839	3049273	2012-05-26	2012-05-26 00:00:00	2012-05-26	5001	0	\N	0	0	\N	\N	0	254863	0	38265-5	3049273		
7888	754	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	49966	0	6248-9	3015076		
52017	4771	3006322	1956-12-05	1956-12-05 00:00:00	1956-12-05	5001	0	\N	0	0	\N	\N	0	317755	0	8331-1	3006322		
26767	2469	3006322	2016-09-24	2016-09-24 00:00:00	2016-09-24	5001	0	\N	0	0	\N	\N	0	163720	0	8331-1	3006322		
77014	2357	4024958	1977-07-30	1977-07-30 00:00:00	1977-07-30	5001	0	\N	0	0	\N	\N	0	156935	0	117015009	4024958		
40203	3744	3020655	2006-07-12	2006-07-12 00:00:00	2006-07-12	5001	0	\N	0	0	\N	\N	0	248784	0	6844-5	3020655		
49622	4514	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	300684	0	6082-2	3000876		
49673	4520	3011505	1980-11-08	1980-11-08 00:00:00	1980-11-08	5001	0	\N	0	0	\N	\N	0	300959	0	19926-5	3011505		
30967	2832	3014599	1997-09-06	1997-09-06 00:00:00	1997-09-06	5001	0	\N	0	0	\N	\N	0	187932	0	6106-9	3014599		
56	2	46235214	1935-03-25	1935-03-25 00:00:00	1935-03-25	5001	0	\N	0	0	\N	\N	0	184	0	76690-7	46235214		
172166	5284	4024958	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	351597	0	117015009	4024958		
53838	4935	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	328123	0	6273-7	3006451		
21153	1956	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	130152	0	6833-8	3023430		
10443	334	4024958	1974-09-05	1974-09-05 00:00:00	1974-09-05	5001	0	\N	0	0	\N	\N	0	22147	0	117015009	4024958		
76022	2333	4024958	1926-12-11	1926-12-11 00:00:00	1926-12-11	5001	0	\N	0	0	\N	\N	0	155222	0	117015009	4024958		
1756	155	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	10534	0	6189-5	3006734		
141980	4372	4024958	2001-02-04	2001-02-04 00:00:00	2001-02-04	5001	0	\N	0	0	\N	\N	0	290290	0	117015009	4024958		
44166	4071	46235214	1966-11-23	1966-11-23 00:00:00	1966-11-23	5001	0	\N	0	0	\N	\N	0	270585	0	76690-7	46235214		
19137	1753	3006322	1976-03-31	1976-03-31 00:00:00	1976-03-31	5001	0	\N	0	0	\N	\N	0	117212	0	8331-1	3006322		
97631	2986	4133840	1999-01-12	1999-01-12 00:00:00	1999-01-12	5001	0	\N	0	0	\N	\N	0	199313	0	127783003	4133840		
55929	5128	3049273	1997-02-19	1997-02-19 00:00:00	1997-02-19	5001	0	\N	0	0	\N	\N	0	340966	0	38265-5	3049273		
1396	124	3006451	1987-04-02	1987-04-02 00:00:00	1987-04-02	5001	0	\N	0	0	\N	\N	0	8296	0	6273-7	3006451		
164994	5066	4052083	2011-06-18	2011-06-18 00:00:00	2011-06-18	5001	0	\N	0	0	\N	\N	0	336763	0	23426006	4052083		
56318	1719	4024958	1965-03-30	1965-03-30 00:00:00	1965-03-30	5001	0	\N	0	0	\N	\N	0	114942	0	117015009	4024958		
105187	3237	4052083	1928-07-02	1928-07-02 00:00:00	1928-07-02	5001	0	\N	0	0	\N	\N	0	215195	0	23426006	4052083		
36959	3399	3012494	1983-12-17	1983-12-17 00:00:00	1983-12-17	5001	0	\N	0	0	\N	\N	0	225486	0	6206-7	3012494		
64099	1971	4024958	1985-12-16	1985-12-16 00:00:00	1985-12-16	5001	0	\N	0	0	\N	\N	0	130988	0	117015009	4024958		
52912	4859	3006322	1972-03-01	1972-03-01 00:00:00	1972-03-01	5001	0	\N	0	0	\N	\N	0	323233	0	8331-1	3006322		
56477	5185	3006322	1948-06-19	1948-06-19 00:00:00	1948-06-19	5001	0	\N	0	0	\N	\N	0	344634	0	8331-1	3006322		
27793	2559	3006322	1962-06-25	1962-06-25 00:00:00	1962-06-25	5001	0	\N	0	0	\N	\N	0	169622	0	8331-1	3006322		
41116	3823	3006322	1962-11-02	1962-11-02 00:00:00	1962-11-02	5001	0	\N	0	0	\N	\N	0	253920	0	8331-1	3006322		
119609	3689	4052083	1959-09-10	1959-09-10 00:00:00	1959-09-10	5001	0	\N	0	0	\N	\N	0	245209	0	23426006	4052083		
70608	2164	4052083	2018-12-26	2018-12-26 00:00:00	2018-12-26	5001	0	\N	0	0	\N	\N	0	144126	0	23426006	4052083		
39351	3638	3006322	2009-08-06	2009-08-06 00:00:00	2009-08-06	5001	0	\N	0	0	\N	\N	0	241978	0	8331-1	3006322		
22704	2079	3006322	1960-03-06	1960-03-06 00:00:00	1960-03-06	5001	0	\N	0	0	\N	\N	0	138445	0	8331-1	3006322		
22715	2082	3049273	2007-12-10	2007-12-10 00:00:00	2007-12-10	5001	0	\N	0	0	\N	\N	0	138719	0	38265-5	3049273		
42424	3916	3000876	1991-10-09	1991-10-09 00:00:00	1991-10-09	5001	0	\N	0	0	\N	\N	0	260266	0	6082-2	3000876		
2094	191	46235214	1963-04-17	1963-04-17 00:00:00	1963-04-17	5001	0	\N	0	0	\N	\N	0	13057	0	76690-7	46235214		
49169	4497	3051031	2007-12-12	2007-12-12 00:00:00	2007-12-12	5001	0	\N	0	0	\N	\N	0	299399	0	46240-8	3051031		
8366	788	3051031	1988-10-05	1988-10-05 00:00:00	1988-10-05	5001	0	\N	0	0	\N	\N	0	52431	0	46240-8	3051031		
27371	2540	46235214	1959-02-10	1959-02-10 00:00:00	1959-02-10	5001	0	\N	0	0	\N	\N	0	167975	0	76690-7	46235214		
11903	1137	40758406	1984-04-03	1984-04-03 00:00:00	1984-04-03	5001	0	\N	0	0	\N	\N	0	74882	0	55277-8	40758406		
134992	4159	4024958	1987-01-30	1987-01-30 00:00:00	1987-01-30	5001	0	\N	0	0	\N	\N	0	276368	0	117015009	4024958		
13912	1309	3006322	1964-05-13	1964-05-13 00:00:00	1964-05-13	5001	0	\N	0	0	\N	\N	0	86518	0	8331-1	3006322		
32011	2917	3006322	1971-03-06	1971-03-06 00:00:00	1971-03-06	5001	0	\N	0	0	\N	\N	0	194456	0	8331-1	3006322		
32040	2919	3006322	1949-11-20	1949-11-20 00:00:00	1949-11-20	5001	0	\N	0	0	\N	\N	0	194582	0	8331-1	3006322		
47920	4388	3006322	2004-12-24	2004-12-24 00:00:00	2004-12-24	5001	0	\N	0	0	\N	\N	0	291714	0	8331-1	3006322		
36783	3376	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	224054	0	6106-9	3014599		
47611	1450	4052083	1970-03-08	1970-03-08 00:00:00	1970-03-08	5001	0	\N	0	0	\N	\N	0	96738	0	23426006	4052083		
30134	2771	3004501	1974-09-02	1974-09-02 00:00:00	1974-09-02	5001	0	\N	0	0	\N	\N	0	183474	0	2345-7	3004501		
37933	3505	3006322	1963-12-02	1963-12-02 00:00:00	1963-12-02	5001	0	\N	0	0	\N	\N	0	232396	0	8331-1	3006322		
49270	4500	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	299570	0	6276-0	3027231		
173059	5314	4052083	1959-05-12	1959-05-12 00:00:00	1959-05-12	5001	0	\N	0	0	\N	\N	0	353393	0	23426006	4052083		
149925	4596	4052083	1947-08-09	1947-08-09 00:00:00	1947-08-09	5001	0	\N	0	0	\N	\N	0	306252	0	23426006	4052083		
2228	202	3006322	2002-05-19	2002-05-19 00:00:00	2002-05-19	5001	0	\N	0	0	\N	\N	0	13844	0	8331-1	3006322		
33404	3020	3011505	2016-02-24	2016-02-24 00:00:00	2016-02-24	5001	0	\N	0	0	\N	\N	0	201388	0	19926-5	3011505		
33460	3025	3000876	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	201695	0	6082-2	3000876		
6576	202	4052083	2013-06-10	2013-06-10 00:00:00	2013-06-10	5001	0	\N	0	0	\N	\N	0	13888	0	23426006	4052083		
16627	1513	3006322	1985-05-25	1985-05-25 00:00:00	1985-05-25	5001	0	\N	0	0	\N	\N	0	101120	0	8331-1	3006322		
40358	3752	40758406	1993-01-02	1993-01-02 00:00:00	1993-01-02	5001	0	\N	0	0	\N	\N	0	249309	0	55277-8	40758406		
44026	4064	3006322	1991-02-08	1991-02-08 00:00:00	1991-02-08	5001	0	\N	0	0	\N	\N	0	270001	0	8331-1	3006322		
29783	2743	3051031	1961-05-06	1961-05-06 00:00:00	1961-05-06	5001	0	\N	0	0	\N	\N	0	181471	0	46240-8	3051031		
51896	4761	3001247	1996-11-11	1996-11-11 00:00:00	1996-11-11	5001	0	\N	0	0	\N	\N	0	317251	0	6085-5	3001247		
41179	3839	3049273	2017-04-30	2017-04-30 00:00:00	2017-04-30	5001	0	\N	0	0	\N	\N	0	254864	0	38265-5	3049273		
7889	754	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	49966	0	6158-0	3019406		
52018	4771	3006322	2015-12-16	2015-12-16 00:00:00	2015-12-16	5001	0	\N	0	0	\N	\N	0	317761	0	8331-1	3006322		
26768	2469	3006322	1990-05-24	1990-05-24 00:00:00	1990-05-24	5001	0	\N	0	0	\N	\N	0	163726	0	8331-1	3006322		
77026	2358	4052083	1986-04-22	1986-04-22 00:00:00	1986-04-22	5001	0	\N	0	0	\N	\N	0	157133	0	23426006	4052083		
40204	3744	3019406	2006-07-12	2006-07-12 00:00:00	2006-07-12	5001	0	\N	0	0	\N	\N	0	248784	0	6158-0	3019406		
49623	4514	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	300684	0	7258-7	3001488		
49674	4520	3011505	1957-04-20	1957-04-20 00:00:00	1957-04-20	5001	0	\N	0	0	\N	\N	0	300885	0	19926-5	3011505		
42245	3906	3006322	1978-06-27	1978-06-27 00:00:00	1978-06-27	5001	0	\N	0	0	\N	\N	0	259656	0	8331-1	3006322		
57	2	40758406	1935-03-25	1935-03-25 00:00:00	1935-03-25	5001	0	\N	0	0	\N	\N	0	184	0	55277-8	40758406		
172167	5284	4052083	1971-07-24	1971-07-24 00:00:00	1971-07-24	5001	0	\N	0	0	\N	\N	0	351549	0	23426006	4052083		
53839	4935	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	328123	0	6276-0	3027231		
21154	1956	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	130152	0	6189-5	3006734		
10450	334	4052083	1944-09-16	1944-09-16 00:00:00	1944-09-16	5001	0	\N	0	0	\N	\N	0	22164	0	23426006	4052083		
76032	2334	4133840	1991-02-28	1991-02-28 00:00:00	1991-02-28	5001	0	\N	0	0	\N	\N	0	155358	0	127783003	4133840		
1757	155	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	10534	0	6082-2	3000876		
86463	2673	4024958	1979-06-30	1979-06-30 00:00:00	1979-06-30	5001	0	\N	0	0	\N	\N	0	177131	0	117015009	4024958		
44168	4071	40766240	1966-11-23	1966-11-23 00:00:00	1966-11-23	5001	0	\N	0	0	\N	\N	0	270585	0	63513-6	40766240		
19138	1753	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	117203	0	6075-6	3005136		
97633	2986	4133840	1988-10-25	1988-10-25 00:00:00	1988-10-25	5001	0	\N	0	0	\N	\N	0	199300	0	127783003	4133840		
55930	5128	3006322	1994-10-17	1994-10-17 00:00:00	1994-10-17	5001	0	\N	0	0	\N	\N	0	340996	0	8331-1	3006322		
1397	124	3019406	1997-03-10	1997-03-10 00:00:00	1997-03-10	5001	0	\N	0	0	\N	\N	0	8325	0	6158-0	3019406		
165021	5067	4052083	1976-12-20	1976-12-20 00:00:00	1976-12-20	5001	0	\N	0	0	\N	\N	0	336850	0	23426006	4052083		
56332	1719	4052083	2015-01-28	2015-01-28 00:00:00	2015-01-28	5001	0	\N	0	0	\N	\N	0	114962	0	23426006	4052083		
105197	3238	4133840	2017-03-06	2017-03-06 00:00:00	2017-03-06	5001	0	\N	0	0	\N	\N	0	215272	0	127783003	4133840		
36960	3399	3000876	1983-12-17	1983-12-17 00:00:00	1983-12-17	5001	0	\N	0	0	\N	\N	0	225486	0	6082-2	3000876		
64112	1971	4024958	1980-03-03	1980-03-03 00:00:00	1980-03-03	5001	0	\N	0	0	\N	\N	0	131084	0	117015009	4024958		
52913	4859	3024731	1971-06-05	1971-06-05 00:00:00	1971-06-05	5001	0	\N	0	0	\N	\N	0	323226	0	30428-7	3024731		
56479	5185	3049273	2010-09-22	2010-09-22 00:00:00	2010-09-22	5001	0	\N	0	0	\N	\N	0	344726	0	38265-5	3049273		
27794	2559	3001488	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	169525	0	7258-7	3001488		
41117	3823	3006322	1991-01-31	1991-01-31 00:00:00	1991-01-31	5001	0	\N	0	0	\N	\N	0	253950	0	8331-1	3006322		
119632	3689	4024958	1988-10-19	1988-10-19 00:00:00	1988-10-19	5001	0	\N	0	0	\N	\N	0	245219	0	117015009	4024958		
70613	2164	4024958	2012-04-07	2012-04-07 00:00:00	2012-04-07	5001	0	\N	0	0	\N	\N	0	144157	0	117015009	4024958		
39352	3638	3006322	1970-05-11	1970-05-11 00:00:00	1970-05-11	5001	0	\N	0	0	\N	\N	0	241974	0	8331-1	3006322		
22705	2079	3006322	1980-06-28	1980-06-28 00:00:00	1980-06-28	5001	0	\N	0	0	\N	\N	0	138457	0	8331-1	3006322		
22716	2082	3006322	1944-05-27	1944-05-27 00:00:00	1944-05-27	5001	0	\N	0	0	\N	\N	0	138696	0	8331-1	3006322		
42425	3916	3005136	1991-10-09	1991-10-09 00:00:00	1991-10-09	5001	0	\N	0	0	\N	\N	0	260266	0	6075-6	3005136		
2095	191	40758406	1963-04-17	1963-04-17 00:00:00	1963-04-17	5001	0	\N	0	0	\N	\N	0	13057	0	55277-8	40758406		
49170	4497	46235214	2007-12-12	2007-12-12 00:00:00	2007-12-12	5001	0	\N	0	0	\N	\N	0	299399	0	76690-7	46235214		
8367	788	40766240	1988-10-05	1988-10-05 00:00:00	1988-10-05	5001	0	\N	0	0	\N	\N	0	52431	0	63513-6	40766240		
27373	2540	3051031	1959-02-10	1959-02-10 00:00:00	1959-02-10	5001	0	\N	0	0	\N	\N	0	167975	0	46240-8	3051031		
11906	1137	40766240	1984-04-03	1984-04-03 00:00:00	1984-04-03	5001	0	\N	0	0	\N	\N	0	74882	0	63513-6	40766240		
135009	4160	4052083	2015-07-09	2015-07-09 00:00:00	2015-07-09	5001	0	\N	0	0	\N	\N	0	276459	0	23426006	4052083		
13913	1309	3006322	1998-07-26	1998-07-26 00:00:00	1998-07-26	5001	0	\N	0	0	\N	\N	0	86461	0	8331-1	3006322		
32013	2917	3006322	1966-05-14	1966-05-14 00:00:00	1966-05-14	5001	0	\N	0	0	\N	\N	0	194455	0	8331-1	3006322		
32041	2919	3006322	1956-10-10	1956-10-10 00:00:00	1956-10-10	5001	0	\N	0	0	\N	\N	0	194586	0	8331-1	3006322		
47921	4388	3006322	2006-05-02	2006-05-02 00:00:00	2006-05-02	5001	0	\N	0	0	\N	\N	0	291631	0	8331-1	3006322		
36784	3376	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	224054	0	6276-0	3027231		
47612	1450	4052083	2015-11-24	2015-11-24 00:00:00	2015-11-24	5001	0	\N	0	0	\N	\N	0	96724	0	23426006	4052083		
30135	2771	21494966	1974-09-02	1974-09-02 00:00:00	1974-09-02	5001	0	\N	0	0	\N	\N	0	183474	0	80271-0	21494966		
37934	3505	3006322	1937-09-04	1937-09-04 00:00:00	1937-09-04	5001	0	\N	0	0	\N	\N	0	232393	0	8331-1	3006322		
49271	4500	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	299570	0	6158-0	3019406		
173083	5315	4024958	1957-07-05	1957-07-05 00:00:00	1957-07-05	5001	0	\N	0	0	\N	\N	0	353464	0	117015009	4024958		
149932	4596	4052083	1957-06-18	1957-06-18 00:00:00	1957-06-18	5001	0	\N	0	0	\N	\N	0	306287	0	23426006	4052083		
53049	4872	3006322	1936-07-06	1936-07-06 00:00:00	1936-07-06	5001	0	\N	0	0	\N	\N	0	324038	0	8331-1	3006322		
33405	3020	3006322	1959-03-27	1959-03-27 00:00:00	1959-03-27	5001	0	\N	0	0	\N	\N	0	201364	0	8331-1	3006322		
33461	3025	3020655	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	201695	0	6844-5	3020655		
16481	1504	3006322	1988-04-11	1988-04-11 00:00:00	1988-04-11	5001	0	\N	0	0	\N	\N	0	100277	0	8331-1	3006322		
16628	1513	3006322	2009-11-28	2009-11-28 00:00:00	2009-11-28	5001	0	\N	0	0	\N	\N	0	101108	0	8331-1	3006322		
40361	3752	46235214	1993-03-03	1993-03-03 00:00:00	1993-03-03	5001	0	\N	0	0	\N	\N	0	249298	0	76690-7	46235214		
44027	4064	3006322	2000-07-15	2000-07-15 00:00:00	2000-07-15	5001	0	\N	0	0	\N	\N	0	270031	0	8331-1	3006322		
29785	2743	3006322	1998-07-31	1998-07-31 00:00:00	1998-07-31	5001	0	\N	0	0	\N	\N	0	181462	0	8331-1	3006322		
51897	4761	3015076	1996-11-11	1996-11-11 00:00:00	1996-11-11	5001	0	\N	0	0	\N	\N	0	317251	0	6248-9	3015076		
41180	3841	3006322	2018-09-25	2018-09-25 00:00:00	2018-09-25	5001	0	\N	0	0	\N	\N	0	255035	0	8331-1	3006322		
7890	754	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	49966	0	6075-6	3005136		
52021	4773	3006322	2003-05-11	2003-05-11 00:00:00	2003-05-11	5001	0	\N	0	0	\N	\N	0	317894	0	8331-1	3006322		
26769	2470	3006322	1983-03-19	1983-03-19 00:00:00	1983-03-19	5001	0	\N	0	0	\N	\N	0	163817	0	8331-1	3006322		
77035	2358	4024958	1982-03-30	1982-03-30 00:00:00	1982-03-30	5001	0	\N	0	0	\N	\N	0	157141	0	117015009	4024958		
40205	3744	3027231	2006-07-12	2006-07-12 00:00:00	2006-07-12	5001	0	\N	0	0	\N	\N	0	248784	0	6276-0	3027231		
49624	4514	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	300684	0	6844-5	3020655		
49675	4520	3011505	1993-01-16	1993-01-16 00:00:00	1993-01-16	5001	0	\N	0	0	\N	\N	0	300928	0	19926-5	3011505		
42252	3909	3006322	1972-07-08	1972-07-08 00:00:00	1972-07-08	5001	0	\N	0	0	\N	\N	0	259838	0	8331-1	3006322		
59	2	40766240	1935-06-23	1935-06-23 00:00:00	1935-06-23	5001	0	\N	0	0	\N	\N	0	101	0	63513-6	40766240		
10025	956	3051031	1999-02-14	1999-02-14 00:00:00	1999-02-14	5001	0	\N	0	0	\N	\N	0	63451	0	46240-8	3051031		
53840	4935	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	328123	0	7258-7	3001488		
21155	1956	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	130152	0	6246-3	3021226		
10459	334	4052083	1982-08-26	1982-08-26 00:00:00	1982-08-26	5001	0	\N	0	0	\N	\N	0	22128	0	23426006	4052083		
76035	2334	4133840	2000-04-20	2000-04-20 00:00:00	2000-04-20	5001	0	\N	0	0	\N	\N	0	155360	0	127783003	4133840		
1758	155	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	10534	0	6273-7	3006451		
86486	2673	4024958	2010-03-27	2010-03-27 00:00:00	2010-03-27	5001	0	\N	0	0	\N	\N	0	177060	0	117015009	4024958		
44171	4071	40758406	1967-03-23	1967-03-23 00:00:00	1967-03-23	5001	0	\N	0	0	\N	\N	0	270577	0	55277-8	40758406		
19139	1753	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	117203	0	6106-9	3014599		
97636	2986	4133840	2004-02-10	2004-02-10 00:00:00	2004-02-10	5001	0	\N	0	0	\N	\N	0	199294	0	127783003	4133840		
55931	5128	3006322	1937-03-18	1937-03-18 00:00:00	1937-03-18	5001	0	\N	0	0	\N	\N	0	340964	0	8331-1	3006322		
1398	124	3012494	1997-03-10	1997-03-10 00:00:00	1997-03-10	5001	0	\N	0	0	\N	\N	0	8325	0	6206-7	3012494		
165031	5067	4052083	2006-11-18	2006-11-18 00:00:00	2006-11-18	5001	0	\N	0	0	\N	\N	0	336856	0	23426006	4052083		
56359	1720	4052083	1991-09-26	1991-09-26 00:00:00	1991-09-26	5001	0	\N	0	0	\N	\N	0	115030	0	23426006	4052083		
105200	3238	4133840	2019-03-18	2019-03-18 00:00:00	2019-03-18	5001	0	\N	0	0	\N	\N	0	215315	0	127783003	4133840		
36961	3399	3006451	1983-12-17	1983-12-17 00:00:00	1983-12-17	5001	0	\N	0	0	\N	\N	0	225486	0	6273-7	3006451		
64149	1971	4024958	1996-02-17	1996-02-17 00:00:00	1996-02-17	5001	0	\N	0	0	\N	\N	0	131002	0	117015009	4024958		
52914	4859	3006923	1971-06-05	1971-06-05 00:00:00	1971-06-05	5001	0	\N	0	0	\N	\N	0	323226	0	1742-6	3006923		
56480	5185	3006322	1983-01-22	1983-01-22 00:00:00	1983-01-22	5001	0	\N	0	0	\N	\N	0	344654	0	8331-1	3006322		
27795	2559	3000876	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	169525	0	6082-2	3000876		
41124	3825	3006322	1988-11-25	1988-11-25 00:00:00	1988-11-25	5001	0	\N	0	0	\N	\N	0	254081	0	8331-1	3006322		
119633	3689	4024958	1971-09-23	1971-09-23 00:00:00	1971-09-23	5001	0	\N	0	0	\N	\N	0	245216	0	117015009	4024958		
70617	2164	4052083	1979-05-12	1979-05-12 00:00:00	1979-05-12	5001	0	\N	0	0	\N	\N	0	144136	0	23426006	4052083		
39353	3638	3006322	1966-07-17	1966-07-17 00:00:00	1966-07-17	5001	0	\N	0	0	\N	\N	0	241969	0	8331-1	3006322		
22706	2079	3006322	2006-01-28	2006-01-28 00:00:00	2006-01-28	5001	0	\N	0	0	\N	\N	0	138469	0	8331-1	3006322		
22717	2082	3049273	2017-02-20	2017-02-20 00:00:00	2017-02-20	5001	0	\N	0	0	\N	\N	0	138721	0	38265-5	3049273		
42426	3916	3012494	1991-10-09	1991-10-09 00:00:00	1991-10-09	5001	0	\N	0	0	\N	\N	0	260266	0	6206-7	3012494		
2097	191	3051031	1936-08-26	1936-08-26 00:00:00	1936-08-26	5001	0	\N	0	0	\N	\N	0	13018	0	46240-8	3051031		
49171	4497	40766240	2007-12-12	2007-12-12 00:00:00	2007-12-12	5001	0	\N	0	0	\N	\N	0	299399	0	63513-6	40766240		
8370	788	46235214	1988-10-05	1988-10-05 00:00:00	1988-10-05	5001	0	\N	0	0	\N	\N	0	52431	0	76690-7	46235214		
27374	2540	40758406	1959-02-10	1959-02-10 00:00:00	1959-02-10	5001	0	\N	0	0	\N	\N	0	167975	0	55277-8	40758406		
11907	1137	3051031	1984-04-03	1984-04-03 00:00:00	1984-04-03	5001	0	\N	0	0	\N	\N	0	74882	0	46240-8	3051031		
135014	4160	4052083	1991-05-14	1991-05-14 00:00:00	1991-05-14	5001	0	\N	0	0	\N	\N	0	276415	0	23426006	4052083		
13914	1309	3006322	1981-12-31	1981-12-31 00:00:00	1981-12-31	5001	0	\N	0	0	\N	\N	0	86485	0	8331-1	3006322		
32017	2919	3011505	2015-12-05	2015-12-05 00:00:00	2015-12-05	5001	0	\N	0	0	\N	\N	0	194621	0	19926-5	3011505		
43360	4009	3006322	1999-01-26	1999-01-26 00:00:00	1999-01-26	5001	0	\N	0	0	\N	\N	0	266382	0	8331-1	3006322		
47925	4390	3006322	2014-03-18	2014-03-18 00:00:00	2014-03-18	5001	0	\N	0	0	\N	\N	0	291895	0	8331-1	3006322		
36785	3376	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	224054	0	6075-6	3005136		
15582	1425	3006322	1990-02-08	1990-02-08 00:00:00	1990-02-08	5001	0	\N	0	0	\N	\N	0	94787	0	8331-1	3006322		
30136	2771	3024731	1974-09-02	1974-09-02 00:00:00	1974-09-02	5001	0	\N	0	0	\N	\N	0	183474	0	30428-7	3024731		
37935	3505	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	232469	0	6246-3	3021226		
49272	4500	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	299570	0	6085-5	3001247		
173086	5315	4052083	1957-09-09	1957-09-09 00:00:00	1957-09-09	5001	0	\N	0	0	\N	\N	0	353501	0	23426006	4052083		
149936	4596	4024958	1939-03-24	1939-03-24 00:00:00	1939-03-24	5001	0	\N	0	0	\N	\N	0	306285	0	117015009	4024958		
53050	4872	3006322	1972-04-19	1972-04-19 00:00:00	1972-04-19	5001	0	\N	0	0	\N	\N	0	324011	0	8331-1	3006322		
33406	3020	3011505	2013-02-06	2013-02-06 00:00:00	2013-02-06	5001	0	\N	0	0	\N	\N	0	201376	0	19926-5	3011505		
33462	3025	40769179	1971-12-02	1971-12-02 00:00:00	1971-12-02	5001	0	\N	0	0	\N	\N	0	201565	0	66519-0	40769179		
16482	1504	3006322	1987-10-05	1987-10-05 00:00:00	1987-10-05	5001	0	\N	0	0	\N	\N	0	100276	0	8331-1	3006322		
16629	1513	3005136	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	101053	0	6075-6	3005136		
40362	3752	3051031	1993-03-03	1993-03-03 00:00:00	1993-03-03	5001	0	\N	0	0	\N	\N	0	249298	0	46240-8	3051031		
44029	4067	3006322	1987-01-04	1987-01-04 00:00:00	1987-01-04	5001	0	\N	0	0	\N	\N	0	270203	0	8331-1	3006322		
29787	2745	3006322	1972-06-17	1972-06-17 00:00:00	1972-06-17	5001	0	\N	0	0	\N	\N	0	181597	0	8331-1	3006322		
51898	4761	3006451	1996-11-11	1996-11-11 00:00:00	1996-11-11	5001	0	\N	0	0	\N	\N	0	317251	0	6273-7	3006451		
41181	3843	3006322	2000-03-08	2000-03-08 00:00:00	2000-03-08	5001	0	\N	0	0	\N	\N	0	255068	0	8331-1	3006322		
7891	754	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	49966	0	6276-0	3027231		
52022	4773	3006322	1993-11-04	1993-11-04 00:00:00	1993-11-04	5001	0	\N	0	0	\N	\N	0	317850	0	8331-1	3006322		
26770	2470	3006322	2019-05-07	2019-05-07 00:00:00	2019-05-07	5001	0	\N	0	0	\N	\N	0	163768	0	8331-1	3006322		
95811	2939	4024958	1953-03-25	1953-03-25 00:00:00	1953-03-25	5001	0	\N	0	0	\N	\N	0	195986	0	117015009	4024958		
40206	3744	3001488	2006-07-12	2006-07-12 00:00:00	2006-07-12	5001	0	\N	0	0	\N	\N	0	248784	0	7258-7	3001488		
49625	4514	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	300684	0	6833-8	3023430		
49676	4520	40758406	1928-11-04	1928-11-04 00:00:00	1928-11-04	5001	0	\N	0	0	\N	\N	0	300951	0	55277-8	40758406		
42253	3909	3006322	1962-04-19	1962-04-19 00:00:00	1962-04-19	5001	0	\N	0	0	\N	\N	0	259853	0	8331-1	3006322		
60	2	46235214	1935-06-23	1935-06-23 00:00:00	1935-06-23	5001	0	\N	0	0	\N	\N	0	101	0	76690-7	46235214		
10027	956	40766240	1999-02-14	1999-02-14 00:00:00	1999-02-14	5001	0	\N	0	0	\N	\N	0	63451	0	63513-6	40766240		
53841	4935	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	328123	0	6189-5	3006734		
21156	1956	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	130152	0	6082-2	3000876		
145497	4465	4024958	2006-03-08	2006-03-08 00:00:00	2006-03-08	5001	0	\N	0	0	\N	\N	0	297057	0	117015009	4024958		
76036	2334	4133840	1971-05-06	1971-05-06 00:00:00	1971-05-06	5001	0	\N	0	0	\N	\N	0	155333	0	127783003	4133840		
1759	155	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	10534	0	6246-3	3021226		
86508	2673	4024958	1979-12-08	1979-12-08 00:00:00	1979-12-08	5001	0	\N	0	0	\N	\N	0	177132	0	117015009	4024958		
44172	4071	3051031	1967-03-23	1967-03-23 00:00:00	1967-03-23	5001	0	\N	0	0	\N	\N	0	270577	0	46240-8	3051031		
19140	1753	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	117203	0	6273-7	3006451		
97638	2986	4133840	1998-01-06	1998-01-06 00:00:00	1998-01-06	5001	0	\N	0	0	\N	\N	0	199320	0	127783003	4133840		
55932	5128	3006322	1976-12-07	1976-12-07 00:00:00	1976-12-07	5001	0	\N	0	0	\N	\N	0	340961	0	8331-1	3006322		
1399	124	3027231	1997-03-10	1997-03-10 00:00:00	1997-03-10	5001	0	\N	0	0	\N	\N	0	8325	0	6276-0	3027231		
2865	273	3020655	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	18196	0	6844-5	3020655		
67664	2075	4052083	1993-05-08	1993-05-08 00:00:00	1993-05-08	5001	0	\N	0	0	\N	\N	0	138107	0	23426006	4052083		
105204	3238	4024958	2009-01-13	2009-01-13 00:00:00	2009-01-13	5001	0	\N	0	0	\N	\N	0	215262	0	117015009	4024958		
36962	3399	3019406	1983-12-17	1983-12-17 00:00:00	1983-12-17	5001	0	\N	0	0	\N	\N	0	225486	0	6158-0	3019406		
64170	1971	4052083	1983-10-02	1983-10-02 00:00:00	1983-10-02	5001	0	\N	0	0	\N	\N	0	131085	0	23426006	4052083		
52915	4859	3019550	1971-06-05	1971-06-05 00:00:00	1971-06-05	5001	0	\N	0	0	\N	\N	0	323226	0	2951-2	3019550		
56481	5185	3049273	1989-01-01	1989-01-01 00:00:00	1989-01-01	5001	0	\N	0	0	\N	\N	0	344603	0	38265-5	3049273		
27796	2559	3036780	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	169525	0	6095-4	3036780		
41125	3825	3006322	1998-12-30	1998-12-30 00:00:00	1998-12-30	5001	0	\N	0	0	\N	\N	0	254109	0	8331-1	3006322		
119662	3691	4052083	1984-01-05	1984-01-05 00:00:00	1984-01-05	5001	0	\N	0	0	\N	\N	0	245353	0	23426006	4052083		
70620	2164	4024958	1973-01-31	1973-01-31 00:00:00	1973-01-31	5001	0	\N	0	0	\N	\N	0	144178	0	117015009	4024958		
39354	3638	3006322	2003-06-24	2003-06-24 00:00:00	2003-06-24	5001	0	\N	0	0	\N	\N	0	241960	0	8331-1	3006322		
22707	2079	3006322	1958-03-06	1958-03-06 00:00:00	1958-03-06	5001	0	\N	0	0	\N	\N	0	138466	0	8331-1	3006322		
22718	2082	3006322	1949-06-12	1949-06-12 00:00:00	1949-06-12	5001	0	\N	0	0	\N	\N	0	138706	0	8331-1	3006322		
42427	3916	3014599	1991-10-09	1991-10-09 00:00:00	1991-10-09	5001	0	\N	0	0	\N	\N	0	260266	0	6106-9	3014599		
2098	191	46235214	1936-08-26	1936-08-26 00:00:00	1936-08-26	5001	0	\N	0	0	\N	\N	0	13018	0	76690-7	46235214		
154070	4724	4052083	1994-01-17	1994-01-17 00:00:00	1994-01-17	5001	0	\N	0	0	\N	\N	0	314835	0	23426006	4052083		
8371	788	40758406	1989-04-03	1989-04-03 00:00:00	1989-04-03	5001	0	\N	0	0	\N	\N	0	52411	0	55277-8	40758406		
27376	2540	40766240	1959-03-12	1959-03-12 00:00:00	1959-03-12	5001	0	\N	0	0	\N	\N	0	167936	0	63513-6	40766240		
11908	1137	46235214	1984-04-03	1984-04-03 00:00:00	1984-04-03	5001	0	\N	0	0	\N	\N	0	74882	0	76690-7	46235214		
123879	3822	4024958	1958-02-28	1958-02-28 00:00:00	1958-02-28	5001	0	\N	0	0	\N	\N	0	253865	0	117015009	4024958		
13915	1309	3006322	1974-01-29	1974-01-29 00:00:00	1974-01-29	5001	0	\N	0	0	\N	\N	0	86459	0	8331-1	3006322		
32194	2925	3005136	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	195100	0	6075-6	3005136		
43362	4010	3006322	2015-10-21	2015-10-21 00:00:00	2015-10-21	5001	0	\N	0	0	\N	\N	0	266455	0	8331-1	3006322		
47926	4390	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	291804	0	6833-8	3023430		
36786	3376	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	224054	0	6082-2	3000876		
15583	1425	3006322	1945-11-04	1945-11-04 00:00:00	1945-11-04	5001	0	\N	0	0	\N	\N	0	94783	0	8331-1	3006322		
30137	2771	3006906	1974-09-02	1974-09-02 00:00:00	1974-09-02	5001	0	\N	0	0	\N	\N	0	183474	0	17861-6	3006906		
37936	3505	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	232469	0	6075-6	3005136		
49273	4500	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	299570	0	7258-7	3001488		
173087	5315	4052083	1949-10-23	1949-10-23 00:00:00	1949-10-23	5001	0	\N	0	0	\N	\N	0	353533	0	23426006	4052083		
149951	4596	4052083	1988-01-15	1988-01-15 00:00:00	1988-01-15	5001	0	\N	0	0	\N	\N	0	306322	0	23426006	4052083		
53051	4872	3006322	1997-01-24	1997-01-24 00:00:00	1997-01-24	5001	0	\N	0	0	\N	\N	0	323995	0	8331-1	3006322		
33407	3020	3011505	2019-03-13	2019-03-13 00:00:00	2019-03-13	5001	0	\N	0	0	\N	\N	0	201410	0	19926-5	3011505		
33463	3025	40769194	1971-12-02	1971-12-02 00:00:00	1971-12-02	5001	0	\N	0	0	\N	\N	0	201565	0	66534-9	40769194		
16483	1504	3006322	2015-09-23	2015-09-23 00:00:00	2015-09-23	5001	0	\N	0	0	\N	\N	0	100273	0	8331-1	3006322		
16630	1513	3027231	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	101053	0	6276-0	3027231		
40363	3752	40766240	1993-03-03	1993-03-03 00:00:00	1993-03-03	5001	0	\N	0	0	\N	\N	0	249298	0	63513-6	40766240		
44030	4067	3006322	2005-08-09	2005-08-09 00:00:00	2005-08-09	5001	0	\N	0	0	\N	\N	0	270205	0	8331-1	3006322		
116268	3582	4133840	1993-08-15	1993-08-15 00:00:00	1993-08-15	5001	0	\N	0	0	\N	\N	0	238103	0	127783003	4133840		
51899	4761	3014599	1984-05-29	1984-05-29 00:00:00	1984-05-29	5001	0	\N	0	0	\N	\N	0	317259	0	6106-9	3014599		
41182	3843	3006322	2013-06-20	2013-06-20 00:00:00	2013-06-20	5001	0	\N	0	0	\N	\N	0	255070	0	8331-1	3006322		
7892	754	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	49966	0	6246-3	3021226		
52023	4773	3006322	1967-07-12	1967-07-12 00:00:00	1967-07-12	5001	0	\N	0	0	\N	\N	0	317846	0	8331-1	3006322		
26771	2470	3006322	1971-10-12	1971-10-12 00:00:00	1971-10-12	5001	0	\N	0	0	\N	\N	0	163762	0	8331-1	3006322		
95812	2939	4024958	1958-03-28	1958-03-28 00:00:00	1958-03-28	5001	0	\N	0	0	\N	\N	0	195939	0	117015009	4024958		
40207	3744	3001247	2006-07-12	2006-07-12 00:00:00	2006-07-12	5001	0	\N	0	0	\N	\N	0	248784	0	6085-5	3001247		
49626	4514	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	300684	0	6095-4	3036780		
49677	4520	46235214	1928-11-04	1928-11-04 00:00:00	1928-11-04	5001	0	\N	0	0	\N	\N	0	300951	0	76690-7	46235214		
42254	3909	3006322	2015-03-05	2015-03-05 00:00:00	2015-03-05	5001	0	\N	0	0	\N	\N	0	259869	0	8331-1	3006322		
62	2	3051031	1935-06-23	1935-06-23 00:00:00	1935-06-23	5001	0	\N	0	0	\N	\N	0	101	0	46240-8	3051031		
10028	956	40758406	1999-02-14	1999-02-14 00:00:00	1999-02-14	5001	0	\N	0	0	\N	\N	0	63451	0	55277-8	40758406		
53842	4935	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	328123	0	6085-5	3001247		
21157	1956	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	130152	0	7258-7	3001488		
145517	4466	4052083	1996-07-16	1996-07-16 00:00:00	1996-07-16	5001	0	\N	0	0	\N	\N	0	297156	0	23426006	4052083		
76040	2334	4133840	1982-05-27	1982-05-27 00:00:00	1982-05-27	5001	0	\N	0	0	\N	\N	0	155298	0	127783003	4133840		
1760	155	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	10534	0	6276-0	3027231		
132498	4080	4052083	1993-09-05	1993-09-05 00:00:00	1993-09-05	5001	0	\N	0	0	\N	\N	0	271157	0	23426006	4052083		
44173	4071	46235214	1967-03-23	1967-03-23 00:00:00	1967-03-23	5001	0	\N	0	0	\N	\N	0	270577	0	76690-7	46235214		
19141	1753	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	117203	0	6246-3	3021226		
97641	2986	4052083	2018-06-05	2018-06-05 00:00:00	2018-06-05	5001	0	\N	0	0	\N	\N	0	199336	0	23426006	4052083		
55933	5128	3006322	2017-08-20	2017-08-20 00:00:00	2017-08-20	5001	0	\N	0	0	\N	\N	0	341008	0	8331-1	3006322		
1400	124	3021226	1997-03-10	1997-03-10 00:00:00	1997-03-10	5001	0	\N	0	0	\N	\N	0	8325	0	6246-3	3021226		
2866	273	3023430	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	18196	0	6833-8	3023430		
67665	2075	4024958	2009-11-07	2009-11-07 00:00:00	2009-11-07	5001	0	\N	0	0	\N	\N	0	138021	0	117015009	4024958		
105205	3238	4024958	1985-06-06	1985-06-06 00:00:00	1985-06-06	5001	0	\N	0	0	\N	\N	0	215275	0	117015009	4024958		
36963	3399	3001247	1983-12-17	1983-12-17 00:00:00	1983-12-17	5001	0	\N	0	0	\N	\N	0	225486	0	6085-5	3001247		
79119	2433	4052083	1962-12-22	1962-12-22 00:00:00	1962-12-22	5001	0	\N	0	0	\N	\N	0	161281	0	23426006	4052083		
52916	4859	21494966	1971-06-05	1971-06-05 00:00:00	1971-06-05	5001	0	\N	0	0	\N	\N	0	323226	0	80271-0	21494966		
56482	5185	3006322	1949-10-25	1949-10-25 00:00:00	1949-10-25	5001	0	\N	0	0	\N	\N	0	344648	0	8331-1	3006322		
27797	2559	3006734	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	169525	0	6189-5	3006734		
41126	3825	3006322	1994-09-06	1994-09-06 00:00:00	1994-09-06	5001	0	\N	0	0	\N	\N	0	254070	0	8331-1	3006322		
42207	1306	4052083	1983-05-16	1983-05-16 00:00:00	1983-05-16	5001	0	\N	0	0	\N	\N	0	86191	0	23426006	4052083		
70621	2164	4024958	1974-03-07	1974-03-07 00:00:00	1974-03-07	5001	0	\N	0	0	\N	\N	0	144153	0	117015009	4024958		
39355	3638	3006322	1999-10-29	1999-10-29 00:00:00	1999-10-29	5001	0	\N	0	0	\N	\N	0	241958	0	8331-1	3006322		
22708	2080	3006322	2019-01-15	2019-01-15 00:00:00	2019-01-15	5001	0	\N	0	0	\N	\N	0	138600	0	8331-1	3006322		
22719	2082	3006322	1978-08-11	1978-08-11 00:00:00	1978-08-11	5001	0	\N	0	0	\N	\N	0	138677	0	8331-1	3006322		
42428	3916	3019406	1991-10-09	1991-10-09 00:00:00	1991-10-09	5001	0	\N	0	0	\N	\N	0	260266	0	6158-0	3019406		
2100	191	40766240	1936-08-26	1936-08-26 00:00:00	1936-08-26	5001	0	\N	0	0	\N	\N	0	13018	0	63513-6	40766240		
154071	4724	4052083	1996-10-20	1996-10-20 00:00:00	1996-10-20	5001	0	\N	0	0	\N	\N	0	314798	0	23426006	4052083		
8372	788	40766240	1989-04-03	1989-04-03 00:00:00	1989-04-03	5001	0	\N	0	0	\N	\N	0	52411	0	63513-6	40766240		
27377	2540	46235214	1959-03-12	1959-03-12 00:00:00	1959-03-12	5001	0	\N	0	0	\N	\N	0	167936	0	76690-7	46235214		
11910	1137	3051031	1983-12-05	1983-12-05 00:00:00	1983-12-05	5001	0	\N	0	0	\N	\N	0	74960	0	46240-8	3051031		
123882	3822	4024958	1952-01-05	1952-01-05 00:00:00	1952-01-05	5001	0	\N	0	0	\N	\N	0	253864	0	117015009	4024958		
13916	1309	3006322	1973-03-08	1973-03-08 00:00:00	1973-03-08	5001	0	\N	0	0	\N	\N	0	86441	0	8331-1	3006322		
32195	2925	3001488	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	195100	0	7258-7	3001488		
43363	4010	3000963	1999-04-30	1999-04-30 00:00:00	1999-04-30	5001	0	\N	0	0	\N	\N	0	266454	0	718-7	3000963		
47927	4390	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	291804	0	6844-5	3020655		
36787	3376	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	224054	0	6095-4	3036780		
15584	1425	3006322	1946-03-19	1946-03-19 00:00:00	1946-03-19	5001	0	\N	0	0	\N	\N	0	94767	0	8331-1	3006322		
30138	2771	3000963	1974-09-02	1974-09-02 00:00:00	1974-09-02	5001	0	\N	0	0	\N	\N	0	183474	0	718-7	3000963		
37937	3505	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	232469	0	6206-7	3012494		
49274	4500	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	299570	0	6095-4	3036780		
173088	5315	4052083	1945-02-14	1945-02-14 00:00:00	1945-02-14	5001	0	\N	0	0	\N	\N	0	353462	0	23426006	4052083		
149956	4596	4024958	1958-04-15	1958-04-15 00:00:00	1958-04-15	5001	0	\N	0	0	\N	\N	0	306319	0	117015009	4024958		
53052	4872	3006322	1946-07-27	1946-07-27 00:00:00	1946-07-27	5001	0	\N	0	0	\N	\N	0	324039	0	8331-1	3006322		
33408	3020	3011505	2003-01-22	2003-01-22 00:00:00	2003-01-22	5001	0	\N	0	0	\N	\N	0	201430	0	19926-5	3011505		
33464	3025	40769184	1971-12-02	1971-12-02 00:00:00	1971-12-02	5001	0	\N	0	0	\N	\N	0	201565	0	66524-0	40769184		
16484	1504	3006322	2005-08-06	2005-08-06 00:00:00	2005-08-06	5001	0	\N	0	0	\N	\N	0	100243	0	8331-1	3006322		
16631	1513	3014599	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	101053	0	6106-9	3014599		
40364	3752	40758406	1993-03-03	1993-03-03 00:00:00	1993-03-03	5001	0	\N	0	0	\N	\N	0	249298	0	55277-8	40758406		
44031	4067	3006322	2015-08-27	2015-08-27 00:00:00	2015-08-27	5001	0	\N	0	0	\N	\N	0	270208	0	8331-1	3006322		
116269	3582	4133840	2018-02-25	2018-02-25 00:00:00	2018-02-25	5001	0	\N	0	0	\N	\N	0	238135	0	127783003	4133840		
51900	4761	3005136	1984-05-29	1984-05-29 00:00:00	1984-05-29	5001	0	\N	0	0	\N	\N	0	317259	0	6075-6	3005136		
41183	3843	3006322	1995-05-24	1995-05-24 00:00:00	1995-05-24	5001	0	\N	0	0	\N	\N	0	255063	0	8331-1	3006322		
7893	755	3006322	1975-12-08	1975-12-08 00:00:00	1975-12-08	5001	0	\N	0	0	\N	\N	0	50054	0	8331-1	3006322		
52024	4773	3006322	1960-04-21	1960-04-21 00:00:00	1960-04-21	5001	0	\N	0	0	\N	\N	0	317845	0	8331-1	3006322		
26772	2470	3006322	2004-07-09	2004-07-09 00:00:00	2004-07-09	5001	0	\N	0	0	\N	\N	0	163764	0	8331-1	3006322		
95814	2939	4052083	1974-09-29	1974-09-29 00:00:00	1974-09-29	5001	0	\N	0	0	\N	\N	0	195916	0	23426006	4052083		
40208	3744	3012494	2006-07-12	2006-07-12 00:00:00	2006-07-12	5001	0	\N	0	0	\N	\N	0	248784	0	6206-7	3012494		
19989	1834	3006322	1985-01-13	1985-01-13 00:00:00	1985-01-13	5001	0	\N	0	0	\N	\N	0	122483	0	8331-1	3006322		
49679	4520	40766240	1928-11-04	1928-11-04 00:00:00	1928-11-04	5001	0	\N	0	0	\N	\N	0	300951	0	63513-6	40766240		
10827	343	4024958	2013-02-17	2013-02-17 00:00:00	2013-02-17	5001	0	\N	0	0	\N	\N	0	22963	0	117015009	4024958		
63	2	40758406	1935-06-23	1935-06-23 00:00:00	1935-06-23	5001	0	\N	0	0	\N	\N	0	101	0	55277-8	40758406		
10030	956	46235214	1999-02-14	1999-02-14 00:00:00	1999-02-14	5001	0	\N	0	0	\N	\N	0	63451	0	76690-7	46235214		
53843	4935	40769194	1985-09-27	1985-09-27 00:00:00	1985-09-27	5001	0	\N	0	0	\N	\N	0	328104	0	66534-9	40769194		
21158	1956	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	130152	0	6085-5	3001247		
145518	4466	4024958	2005-03-27	2005-03-27 00:00:00	2005-03-27	5001	0	\N	0	0	\N	\N	0	297116	0	117015009	4024958		
76042	2334	4133840	1993-03-11	1993-03-11 00:00:00	1993-03-11	5001	0	\N	0	0	\N	\N	0	155359	0	127783003	4133840		
1761	155	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	10534	0	7258-7	3001488		
132499	4080	4052083	2007-01-25	2007-01-25 00:00:00	2007-01-25	5001	0	\N	0	0	\N	\N	0	271180	0	23426006	4052083		
28654	885	4024958	1976-10-18	1976-10-18 00:00:00	1976-10-18	5001	0	\N	0	0	\N	\N	0	59000	0	117015009	4024958		
19142	1753	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	117203	0	6276-0	3027231		
97645	2986	4133840	2015-04-14	2015-04-14 00:00:00	2015-04-14	5001	0	\N	0	0	\N	\N	0	199325	0	127783003	4133840		
55934	5128	3006322	1947-01-09	1947-01-09 00:00:00	1947-01-09	5001	0	\N	0	0	\N	\N	0	340956	0	8331-1	3006322		
1401	124	3015076	1997-03-10	1997-03-10 00:00:00	1997-03-10	5001	0	\N	0	0	\N	\N	0	8325	0	6248-9	3015076		
2867	273	3001488	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	18196	0	7258-7	3001488		
67666	2075	4024958	1977-02-10	1977-02-10 00:00:00	1977-02-10	5001	0	\N	0	0	\N	\N	0	138077	0	117015009	4024958		
105207	3238	4052083	1974-06-21	1974-06-21 00:00:00	1974-06-21	5001	0	\N	0	0	\N	\N	0	215261	0	23426006	4052083		
36964	3399	3001488	1983-12-17	1983-12-17 00:00:00	1983-12-17	5001	0	\N	0	0	\N	\N	0	225486	0	7258-7	3001488		
79165	2435	4024958	1978-02-13	1978-02-13 00:00:00	1978-02-13	5001	0	\N	0	0	\N	\N	0	161433	0	117015009	4024958		
52917	4859	3014576	1971-06-05	1971-06-05 00:00:00	1971-06-05	5001	0	\N	0	0	\N	\N	0	323226	0	2075-0	3014576		
56483	5185	3006322	2014-10-27	2014-10-27 00:00:00	2014-10-27	5001	0	\N	0	0	\N	\N	0	344700	0	8331-1	3006322		
27798	2559	3001247	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	169525	0	6085-5	3001247		
41127	3825	3006322	1977-01-14	1977-01-14 00:00:00	1977-01-14	5001	0	\N	0	0	\N	\N	0	254059	0	8331-1	3006322		
53539	1622	4052083	1978-04-07	1978-04-07 00:00:00	1978-04-07	5001	0	\N	0	0	\N	\N	0	109006	0	23426006	4052083		
70642	2165	4024958	1982-10-18	1982-10-18 00:00:00	1982-10-18	5001	0	\N	0	0	\N	\N	0	144222	0	117015009	4024958		
39356	3638	3006322	1977-05-15	1977-05-15 00:00:00	1977-05-15	5001	0	\N	0	0	\N	\N	0	241986	0	8331-1	3006322		
22709	2080	3006322	1984-01-20	1984-01-20 00:00:00	1984-01-20	5001	0	\N	0	0	\N	\N	0	138514	0	8331-1	3006322		
22720	2082	3006322	1997-03-17	1997-03-17 00:00:00	1997-03-17	5001	0	\N	0	0	\N	\N	0	138678	0	8331-1	3006322		
42429	3916	3015076	1991-10-09	1991-10-09 00:00:00	1991-10-09	5001	0	\N	0	0	\N	\N	0	260266	0	6248-9	3015076		
2101	191	40758406	1936-08-26	1936-08-26 00:00:00	1936-08-26	5001	0	\N	0	0	\N	\N	0	13018	0	55277-8	40758406		
27210	2522	40766240	1995-08-31	1995-08-31 00:00:00	1995-08-31	5001	0	\N	0	0	\N	\N	0	166801	0	63513-6	40766240		
8375	788	46235214	1989-04-03	1989-04-03 00:00:00	1989-04-03	5001	0	\N	0	0	\N	\N	0	52411	0	76690-7	46235214		
27379	2540	3051031	1959-03-12	1959-03-12 00:00:00	1959-03-12	5001	0	\N	0	0	\N	\N	0	167936	0	46240-8	3051031		
11912	1137	40766240	1983-12-05	1983-12-05 00:00:00	1983-12-05	5001	0	\N	0	0	\N	\N	0	74960	0	63513-6	40766240		
55445	1683	4024958	1983-11-04	1983-11-04 00:00:00	1983-11-04	5001	0	\N	0	0	\N	\N	0	112798	0	117015009	4024958		
13917	1309	3006322	1973-12-18	1973-12-18 00:00:00	1973-12-18	5001	0	\N	0	0	\N	\N	0	86453	0	8331-1	3006322		
32196	2925	3021226	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	195100	0	6246-3	3021226		
43364	4010	3009542	1999-04-30	1999-04-30 00:00:00	1999-04-30	5001	0	\N	0	0	\N	\N	0	266454	0	20570-8	3009542		
47928	4390	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	291804	0	6075-6	3005136		
36788	3376	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	224054	0	6158-0	3019406		
15585	1426	3006322	2000-01-26	2000-01-26 00:00:00	2000-01-26	5001	0	\N	0	0	\N	\N	0	94807	0	8331-1	3006322		
30139	2771	3006923	1974-09-02	1974-09-02 00:00:00	1974-09-02	5001	0	\N	0	0	\N	\N	0	183474	0	1742-6	3006923		
37938	3505	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	232469	0	6106-9	3014599		
49275	4500	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	299570	0	6833-8	3023430		
20219	1851	3011505	2015-07-23	2015-07-23 00:00:00	2015-07-23	5001	0	\N	0	0	\N	\N	0	123837	0	19926-5	3011505		
10971	1062	3006322	1967-01-18	1967-01-18 00:00:00	1967-01-18	5001	0	\N	0	0	\N	\N	0	69683	0	8331-1	3006322		
53053	4872	3006322	1990-08-17	1990-08-17 00:00:00	1990-08-17	5001	0	\N	0	0	\N	\N	0	323993	0	8331-1	3006322		
33409	3020	3011505	2001-01-17	2001-01-17 00:00:00	2001-01-17	5001	0	\N	0	0	\N	\N	0	201407	0	19926-5	3011505		
33465	3025	40769189	1971-12-02	1971-12-02 00:00:00	1971-12-02	5001	0	\N	0	0	\N	\N	0	201565	0	66529-9	40769189		
16485	1504	3006322	1992-09-30	1992-09-30 00:00:00	1992-09-30	5001	0	\N	0	0	\N	\N	0	100270	0	8331-1	3006322		
16632	1513	3006322	1970-07-16	1970-07-16 00:00:00	1970-07-16	5001	0	\N	0	0	\N	\N	0	101116	0	8331-1	3006322		
40367	3752	40766240	1993-12-28	1993-12-28 00:00:00	1993-12-28	5001	0	\N	0	0	\N	\N	0	249310	0	63513-6	40766240		
44032	4067	3006322	1981-06-20	1981-06-20 00:00:00	1981-06-20	5001	0	\N	0	0	\N	\N	0	270250	0	8331-1	3006322		
116275	3582	4133840	1998-06-07	1998-06-07 00:00:00	1998-06-07	5001	0	\N	0	0	\N	\N	0	238131	0	127783003	4133840		
51901	4761	3027231	1984-05-29	1984-05-29 00:00:00	1984-05-29	5001	0	\N	0	0	\N	\N	0	317259	0	6276-0	3027231		
41184	3843	3006322	2011-02-20	2011-02-20 00:00:00	2011-02-20	5001	0	\N	0	0	\N	\N	0	255065	0	8331-1	3006322		
7894	755	3006322	1981-08-18	1981-08-18 00:00:00	1981-08-18	5001	0	\N	0	0	\N	\N	0	50046	0	8331-1	3006322		
52025	4773	3006322	1987-01-28	1987-01-28 00:00:00	1987-01-28	5001	0	\N	0	0	\N	\N	0	317849	0	8331-1	3006322		
26773	2470	3006322	1974-08-09	1974-08-09 00:00:00	1974-08-09	5001	0	\N	0	0	\N	\N	0	163779	0	8331-1	3006322		
95862	2942	4052083	2007-12-09	2007-12-09 00:00:00	2007-12-09	5001	0	\N	0	0	\N	\N	0	196209	0	23426006	4052083		
40209	3744	3005136	2006-07-12	2006-07-12 00:00:00	2006-07-12	5001	0	\N	0	0	\N	\N	0	248784	0	6075-6	3005136		
19990	1834	3006322	1989-06-13	1989-06-13 00:00:00	1989-06-13	5001	0	\N	0	0	\N	\N	0	122561	0	8331-1	3006322		
49680	4520	3051031	1928-11-04	1928-11-04 00:00:00	1928-11-04	5001	0	\N	0	0	\N	\N	0	300951	0	46240-8	3051031		
10831	343	4024958	1998-01-22	1998-01-22 00:00:00	1998-01-22	5001	0	\N	0	0	\N	\N	0	22954	0	117015009	4024958		
65	2	3051031	1934-11-25	1934-11-25 00:00:00	1934-11-25	5001	0	\N	0	0	\N	\N	0	176	0	46240-8	3051031		
26856	2485	3049273	2003-11-12	2003-11-12 00:00:00	2003-11-12	5001	0	\N	0	0	\N	\N	0	164632	0	38265-5	3049273		
53844	4935	40769184	1985-09-27	1985-09-27 00:00:00	1985-09-27	5001	0	\N	0	0	\N	\N	0	328104	0	66524-0	40769184		
21159	1956	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	130152	0	6276-0	3027231		
156820	4822	4133840	2009-12-02	2009-12-02 00:00:00	2009-12-02	5001	0	\N	0	0	\N	\N	0	320773	0	127783003	4133840		
76043	2334	4133840	2010-06-17	2010-06-17 00:00:00	2010-06-17	5001	0	\N	0	0	\N	\N	0	155283	0	127783003	4133840		
1762	155	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	10534	0	6095-4	3036780		
132529	4081	4052083	1988-10-25	1988-10-25 00:00:00	1988-10-25	5001	0	\N	0	0	\N	\N	0	271235	0	23426006	4052083		
28666	886	4024958	1994-03-13	1994-03-13 00:00:00	1994-03-13	5001	0	\N	0	0	\N	\N	0	59088	0	117015009	4024958		
19143	1753	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	117203	0	6158-0	3019406		
97650	2986	4133840	2006-02-21	2006-02-21 00:00:00	2006-02-21	5001	0	\N	0	0	\N	\N	0	199295	0	127783003	4133840		
55935	5128	3006322	1998-09-13	1998-09-13 00:00:00	1998-09-13	5001	0	\N	0	0	\N	\N	0	340997	0	8331-1	3006322		
1402	124	3006734	1997-03-10	1997-03-10 00:00:00	1997-03-10	5001	0	\N	0	0	\N	\N	0	8325	0	6189-5	3006734		
101495	3118	4133840	1990-12-16	1990-12-16 00:00:00	1990-12-16	5001	0	\N	0	0	\N	\N	0	207498	0	127783003	4133840		
91090	2813	4024958	1942-03-18	1942-03-18 00:00:00	1942-03-18	5001	0	\N	0	0	\N	\N	0	186368	0	117015009	4024958		
105209	3238	4133840	2018-03-12	2018-03-12 00:00:00	2018-03-12	5001	0	\N	0	0	\N	\N	0	215287	0	127783003	4133840		
36965	3399	3006734	1983-12-17	1983-12-17 00:00:00	1983-12-17	5001	0	\N	0	0	\N	\N	0	225486	0	6189-5	3006734		
79166	2435	4024958	2010-01-18	2010-01-18 00:00:00	2010-01-18	5001	0	\N	0	0	\N	\N	0	161435	0	117015009	4024958		
52918	4859	3006906	1971-06-05	1971-06-05 00:00:00	1971-06-05	5001	0	\N	0	0	\N	\N	0	323226	0	17861-6	3006906		
56484	5185	3006322	2010-05-25	2010-05-25 00:00:00	2010-05-25	5001	0	\N	0	0	\N	\N	0	344696	0	8331-1	3006322		
27799	2559	3015076	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	169525	0	6248-9	3015076		
41130	3827	3049273	2015-08-24	2015-08-24 00:00:00	2015-08-24	5001	0	\N	0	0	\N	\N	0	254191	0	38265-5	3049273		
49530	4506	40758406	2002-06-05	2002-06-05 00:00:00	2002-06-05	5001	0	\N	0	0	\N	\N	0	300162	0	55277-8	40758406		
70646	2165	4024958	1985-10-11	1985-10-11 00:00:00	1985-10-11	5001	0	\N	0	0	\N	\N	0	144188	0	117015009	4024958		
39358	3639	3006322	1958-11-08	1958-11-08 00:00:00	1958-11-08	5001	0	\N	0	0	\N	\N	0	242029	0	8331-1	3006322		
22889	2094	3006322	1950-08-08	1950-08-08 00:00:00	1950-08-08	5001	0	\N	0	0	\N	\N	0	139601	0	8331-1	3006322		
22723	2084	3006322	1971-05-29	1971-05-29 00:00:00	1971-05-29	5001	0	\N	0	0	\N	\N	0	138853	0	8331-1	3006322		
42430	3916	3001247	1991-10-09	1991-10-09 00:00:00	1991-10-09	5001	0	\N	0	0	\N	\N	0	260266	0	6085-5	3001247		
2104	191	3006322	1957-04-03	1957-04-03 00:00:00	1957-04-03	5001	0	\N	0	0	\N	\N	0	13021	0	8331-1	3006322		
27212	2524	3011505	2002-07-06	2002-07-06 00:00:00	2002-07-06	5001	0	\N	0	0	\N	\N	0	166932	0	19926-5	3011505		
8376	788	3051031	1989-04-03	1989-04-03 00:00:00	1989-04-03	5001	0	\N	0	0	\N	\N	0	52411	0	46240-8	3051031		
27380	2540	40758406	1959-03-12	1959-03-12 00:00:00	1959-03-12	5001	0	\N	0	0	\N	\N	0	167936	0	55277-8	40758406		
11913	1137	46235214	1983-12-05	1983-12-05 00:00:00	1983-12-05	5001	0	\N	0	0	\N	\N	0	74960	0	76690-7	46235214		
55450	1683	4024958	1978-10-17	1978-10-17 00:00:00	1978-10-17	5001	0	\N	0	0	\N	\N	0	112774	0	117015009	4024958		
13918	1309	3016723	1994-03-21	1994-03-21 00:00:00	1994-03-21	5001	0	\N	0	0	\N	\N	0	86444	0	2160-0	3016723		
56865	1737	4052083	2001-02-01	2001-02-01 00:00:00	2001-02-01	5001	0	\N	0	0	\N	\N	0	116018	0	23426006	4052083		
43365	4010	3006322	1981-03-18	1981-03-18 00:00:00	1981-03-18	5001	0	\N	0	0	\N	\N	0	266493	0	8331-1	3006322		
47929	4390	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	291804	0	6248-9	3015076		
36789	3376	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	224054	0	6248-9	3015076		
15586	1426	3006322	1955-11-04	1955-11-04 00:00:00	1955-11-04	5001	0	\N	0	0	\N	\N	0	94805	0	8331-1	3006322		
30140	2771	3035995	1974-09-02	1974-09-02 00:00:00	1974-09-02	5001	0	\N	0	0	\N	\N	0	183474	0	6768-6	3035995		
37939	3505	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	232469	0	6085-5	3001247		
49276	4500	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	299570	0	6189-5	3006734		
20220	1851	3006322	2007-05-04	2007-05-04 00:00:00	2007-05-04	5001	0	\N	0	0	\N	\N	0	123815	0	8331-1	3006322		
10972	1062	3006322	1994-02-18	1994-02-18 00:00:00	1994-02-18	5001	0	\N	0	0	\N	\N	0	69652	0	8331-1	3006322		
53054	4872	3006322	2015-11-12	2015-11-12 00:00:00	2015-11-12	5001	0	\N	0	0	\N	\N	0	324034	0	8331-1	3006322		
33410	3020	3011505	2007-01-03	2007-01-03 00:00:00	2007-01-03	5001	0	\N	0	0	\N	\N	0	201431	0	19926-5	3011505		
33467	3026	3006322	2018-08-26	2018-08-26 00:00:00	2018-08-26	5001	0	\N	0	0	\N	\N	0	201793	0	8331-1	3006322		
16486	1504	3006322	1968-05-05	1968-05-05 00:00:00	1968-05-05	5001	0	\N	0	0	\N	\N	0	100239	0	8331-1	3006322		
16633	1513	3006322	2007-07-04	2007-07-04 00:00:00	2007-07-04	5001	0	\N	0	0	\N	\N	0	101025	0	8331-1	3006322		
40368	3752	46235214	1993-12-28	1993-12-28 00:00:00	1993-12-28	5001	0	\N	0	0	\N	\N	0	249310	0	76690-7	46235214		
44033	4067	3006322	2016-08-03	2016-08-03 00:00:00	2016-08-03	5001	0	\N	0	0	\N	\N	0	270230	0	8331-1	3006322		
116278	3582	4133840	2019-03-03	2019-03-03 00:00:00	2019-03-03	5001	0	\N	0	0	\N	\N	0	238121	0	127783003	4133840		
51902	4761	3006734	1984-05-29	1984-05-29 00:00:00	1984-05-29	5001	0	\N	0	0	\N	\N	0	317259	0	6189-5	3006734		
41185	3844	3006322	2000-12-04	2000-12-04 00:00:00	2000-12-04	5001	0	\N	0	0	\N	\N	0	255143	0	8331-1	3006322		
7895	755	3006322	1975-06-02	1975-06-02 00:00:00	1975-06-02	5001	0	\N	0	0	\N	\N	0	50045	0	8331-1	3006322		
52026	4773	3006322	1961-04-02	1961-04-02 00:00:00	1961-04-02	5001	0	\N	0	0	\N	\N	0	317902	0	8331-1	3006322		
26774	2470	3006322	1981-08-15	1981-08-15 00:00:00	1981-08-15	5001	0	\N	0	0	\N	\N	0	163763	0	8331-1	3006322		
4383	135	4052083	2017-11-14	2017-11-14 00:00:00	2017-11-14	5001	0	\N	0	0	\N	\N	0	9062	0	23426006	4052083		
40210	3744	3001488	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	248741	0	7258-7	3001488		
19991	1834	3006322	1954-10-22	1954-10-22 00:00:00	1954-10-22	5001	0	\N	0	0	\N	\N	0	122464	0	8331-1	3006322		
49682	4520	3011505	1974-10-12	1974-10-12 00:00:00	1974-10-12	5001	0	\N	0	0	\N	\N	0	300887	0	19926-5	3011505		
10858	343	4024958	1987-09-02	1987-09-02 00:00:00	1987-09-02	5001	0	\N	0	0	\N	\N	0	22919	0	117015009	4024958		
66	2	40758406	1934-11-25	1934-11-25 00:00:00	1934-11-25	5001	0	\N	0	0	\N	\N	0	176	0	55277-8	40758406		
26857	2485	3006322	1950-03-31	1950-03-31 00:00:00	1950-03-31	5001	0	\N	0	0	\N	\N	0	164596	0	8331-1	3006322		
53845	4935	40769179	1985-09-27	1985-09-27 00:00:00	1985-09-27	5001	0	\N	0	0	\N	\N	0	328104	0	66519-0	40769179		
21160	1956	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	130152	0	6075-6	3005136		
156822	4822	4133840	2012-12-19	2012-12-19 00:00:00	2012-12-19	5001	0	\N	0	0	\N	\N	0	320706	0	127783003	4133840		
76044	2334	4133840	2018-08-02	2018-08-02 00:00:00	2018-08-02	5001	0	\N	0	0	\N	\N	0	155323	0	127783003	4133840		
1763	155	3006322	2018-12-06	2018-12-06 00:00:00	2018-12-06	5001	0	\N	0	0	\N	\N	0	10557	0	8331-1	3006322		
132536	4081	4024958	1969-07-09	1969-07-09 00:00:00	1969-07-09	5001	0	\N	0	0	\N	\N	0	271284	0	117015009	4024958		
28673	886	4024958	1998-02-02	1998-02-02 00:00:00	1998-02-02	5001	0	\N	0	0	\N	\N	0	59080	0	117015009	4024958		
19144	1753	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	117203	0	6095-4	3036780		
97654	2986	4133840	2017-04-25	2017-04-25 00:00:00	2017-04-25	5001	0	\N	0	0	\N	\N	0	199344	0	127783003	4133840		
55936	5128	3006322	1963-06-29	1963-06-29 00:00:00	1963-06-29	5001	0	\N	0	0	\N	\N	0	340959	0	8331-1	3006322		
1403	124	3001488	1997-03-10	1997-03-10 00:00:00	1997-03-10	5001	0	\N	0	0	\N	\N	0	8325	0	7258-7	3001488		
101498	3118	4133840	1999-12-12	1999-12-12 00:00:00	1999-12-12	5001	0	\N	0	0	\N	\N	0	207453	0	127783003	4133840		
91106	2813	4024958	1947-05-21	1947-05-21 00:00:00	1947-05-21	5001	0	\N	0	0	\N	\N	0	186408	0	117015009	4024958		
105213	3238	4024958	1981-09-14	1981-09-14 00:00:00	1981-09-14	5001	0	\N	0	0	\N	\N	0	215298	0	117015009	4024958		
36966	3399	3020655	1983-12-17	1983-12-17 00:00:00	1983-12-17	5001	0	\N	0	0	\N	\N	0	225486	0	6844-5	3020655		
79167	2435	4024958	1982-09-22	1982-09-22 00:00:00	1982-09-22	5001	0	\N	0	0	\N	\N	0	161399	0	117015009	4024958		
52919	4859	3010813	1971-06-05	1971-06-05 00:00:00	1971-06-05	5001	0	\N	0	0	\N	\N	0	323226	0	26464-8	3010813		
56485	5185	3006322	1964-11-16	1964-11-16 00:00:00	1964-11-16	5001	0	\N	0	0	\N	\N	0	344650	0	8331-1	3006322		
27800	2559	3021226	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	169525	0	6246-3	3021226		
41131	3827	3006322	1973-01-17	1973-01-17 00:00:00	1973-01-17	5001	0	\N	0	0	\N	\N	0	254210	0	8331-1	3006322		
49533	4506	40766240	2002-06-05	2002-06-05 00:00:00	2002-06-05	5001	0	\N	0	0	\N	\N	0	300162	0	63513-6	40766240		
70648	2165	4052083	2014-07-03	2014-07-03 00:00:00	2014-07-03	5001	0	\N	0	0	\N	\N	0	144191	0	23426006	4052083		
39359	3639	3006322	2005-01-05	2005-01-05 00:00:00	2005-01-05	5001	0	\N	0	0	\N	\N	0	242162	0	8331-1	3006322		
22890	2094	3006322	2004-08-29	2004-08-29 00:00:00	2004-08-29	5001	0	\N	0	0	\N	\N	0	139604	0	8331-1	3006322		
22724	2084	3006322	1981-07-16	1981-07-16 00:00:00	1981-07-16	5001	0	\N	0	0	\N	\N	0	138851	0	8331-1	3006322		
42431	3916	3006734	1991-10-09	1991-10-09 00:00:00	1991-10-09	5001	0	\N	0	0	\N	\N	0	260266	0	6189-5	3006734		
2105	191	3011505	1995-10-03	1995-10-03 00:00:00	1995-10-03	5001	0	\N	0	0	\N	\N	0	13146	0	19926-5	3011505		
27213	2524	3006322	1970-12-08	1970-12-08 00:00:00	1970-12-08	5001	0	\N	0	0	\N	\N	0	166901	0	8331-1	3006322		
8377	789	3006322	2003-10-11	2003-10-11 00:00:00	2003-10-11	5001	0	\N	0	0	\N	\N	0	52484	0	8331-1	3006322		
27381	2540	3006322	1968-02-12	1968-02-12 00:00:00	1968-02-12	5001	0	\N	0	0	\N	\N	0	167995	0	8331-1	3006322		
11915	1137	40758406	1983-12-05	1983-12-05 00:00:00	1983-12-05	5001	0	\N	0	0	\N	\N	0	74960	0	55277-8	40758406		
55478	1685	4052083	1985-09-13	1985-09-13 00:00:00	1985-09-13	5001	0	\N	0	0	\N	\N	0	112870	0	23426006	4052083		
13919	1309	3028833	1994-03-21	1994-03-21 00:00:00	1994-03-21	5001	0	\N	0	0	\N	\N	0	86444	0	42719-5	3028833		
56871	1738	4024958	1975-09-07	1975-09-07 00:00:00	1975-09-07	5001	0	\N	0	0	\N	\N	0	116130	0	117015009	4024958		
43366	4010	3006322	2007-12-17	2007-12-17 00:00:00	2007-12-17	5001	0	\N	0	0	\N	\N	0	266463	0	8331-1	3006322		
47930	4390	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	291804	0	6106-9	3014599		
36790	3376	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	224054	0	6833-8	3023430		
15587	1426	3006322	1980-10-27	1980-10-27 00:00:00	1980-10-27	5001	0	\N	0	0	\N	\N	0	94819	0	8331-1	3006322		
30141	2771	3015632	1974-09-02	1974-09-02 00:00:00	1974-09-02	5001	0	\N	0	0	\N	\N	0	183474	0	2028-9	3015632		
37940	3505	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	232469	0	6833-8	3023430		
49277	4500	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	299570	0	6844-5	3020655		
20221	1851	3011505	2012-07-19	2012-07-19 00:00:00	2012-07-19	5001	0	\N	0	0	\N	\N	0	123836	0	19926-5	3011505		
10973	1062	3006322	1967-05-31	1967-05-31 00:00:00	1967-05-31	5001	0	\N	0	0	\N	\N	0	69649	0	8331-1	3006322		
53055	4872	3006322	1971-08-08	1971-08-08 00:00:00	1971-08-08	5001	0	\N	0	0	\N	\N	0	324028	0	8331-1	3006322		
33411	3020	3011505	2017-03-01	2017-03-01 00:00:00	2017-03-01	5001	0	\N	0	0	\N	\N	0	201378	0	19926-5	3011505		
33468	3026	3006322	1992-02-19	1992-02-19 00:00:00	1992-02-19	5001	0	\N	0	0	\N	\N	0	201767	0	8331-1	3006322		
16487	1504	3006322	1960-11-30	1960-11-30 00:00:00	1960-11-30	5001	0	\N	0	0	\N	\N	0	100268	0	8331-1	3006322		
16637	1516	3006322	1938-04-07	1938-04-07 00:00:00	1938-04-07	5001	0	\N	0	0	\N	\N	0	101255	0	8331-1	3006322		
40369	3752	3051031	1993-12-28	1993-12-28 00:00:00	1993-12-28	5001	0	\N	0	0	\N	\N	0	249310	0	46240-8	3051031		
44034	4067	3006322	2008-06-09	2008-06-09 00:00:00	2008-06-09	5001	0	\N	0	0	\N	\N	0	270206	0	8331-1	3006322		
116280	3582	4133840	2010-06-20	2010-06-20 00:00:00	2010-06-20	5001	0	\N	0	0	\N	\N	0	238118	0	127783003	4133840		
51903	4761	3020655	1984-05-29	1984-05-29 00:00:00	1984-05-29	5001	0	\N	0	0	\N	\N	0	317259	0	6844-5	3020655		
41186	3844	3006322	1990-10-20	1990-10-20 00:00:00	1990-10-20	5001	0	\N	0	0	\N	\N	0	255154	0	8331-1	3006322		
7896	755	3006322	1965-10-14	1965-10-14 00:00:00	1965-10-14	5001	0	\N	0	0	\N	\N	0	50044	0	8331-1	3006322		
52027	4773	3006322	2002-11-01	2002-11-01 00:00:00	2002-11-01	5001	0	\N	0	0	\N	\N	0	317851	0	8331-1	3006322		
26803	2476	3006322	2012-03-21	2012-03-21 00:00:00	2012-03-21	5001	0	\N	0	0	\N	\N	0	164102	0	8331-1	3006322		
4407	137	4024958	1995-06-18	1995-06-18 00:00:00	1995-06-18	5001	0	\N	0	0	\N	\N	0	9149	0	117015009	4024958		
40211	3744	3001247	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	248741	0	6085-5	3001247		
19992	1834	3006322	1998-05-10	1998-05-10 00:00:00	1998-05-10	5001	0	\N	0	0	\N	\N	0	122563	0	8331-1	3006322		
49683	4520	3011505	1960-09-17	1960-09-17 00:00:00	1960-09-17	5001	0	\N	0	0	\N	\N	0	300923	0	19926-5	3011505		
10892	343	4052083	1988-11-25	1988-11-25 00:00:00	1988-11-25	5001	0	\N	0	0	\N	\N	0	22920	0	23426006	4052083		
68	2	40766240	1934-11-25	1934-11-25 00:00:00	1934-11-25	5001	0	\N	0	0	\N	\N	0	176	0	63513-6	40766240		
26858	2485	3006322	1987-08-06	1987-08-06 00:00:00	1987-08-06	5001	0	\N	0	0	\N	\N	0	164575	0	8331-1	3006322		
53846	4935	40769189	1985-09-27	1985-09-27 00:00:00	1985-09-27	5001	0	\N	0	0	\N	\N	0	328104	0	66529-9	40769189		
21161	1956	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	130152	0	6206-7	3012494		
156824	4822	4133840	2014-12-31	2014-12-31 00:00:00	2014-12-31	5001	0	\N	0	0	\N	\N	0	320707	0	127783003	4133840		
76049	2334	4133840	1986-01-30	1986-01-30 00:00:00	1986-01-30	5001	0	\N	0	0	\N	\N	0	155370	0	127783003	4133840		
1764	155	3006322	1988-04-08	1988-04-08 00:00:00	1988-04-08	5001	0	\N	0	0	\N	\N	0	10617	0	8331-1	3006322		
132537	4081	4024958	1962-07-01	1962-07-01 00:00:00	1962-07-01	5001	0	\N	0	0	\N	\N	0	271282	0	117015009	4024958		
28678	886	4052083	2016-02-19	2016-02-19 00:00:00	2016-02-19	5001	0	\N	0	0	\N	\N	0	59063	0	23426006	4052083		
112887	3483	4052083	2015-06-04	2015-06-04 00:00:00	2015-06-04	5001	0	\N	0	0	\N	\N	0	231043	0	23426006	4052083		
97659	2986	4133840	2002-01-29	2002-01-29 00:00:00	2002-01-29	5001	0	\N	0	0	\N	\N	0	199322	0	127783003	4133840		
55939	5132	3006322	2002-01-13	2002-01-13 00:00:00	2002-01-13	5001	0	\N	0	0	\N	\N	0	341131	0	8331-1	3006322		
1404	124	3036780	1997-03-10	1997-03-10 00:00:00	1997-03-10	5001	0	\N	0	0	\N	\N	0	8325	0	6095-4	3036780		
101506	3118	4133840	2005-12-25	2005-12-25 00:00:00	2005-12-25	5001	0	\N	0	0	\N	\N	0	207422	0	127783003	4133840		
102389	3147	4133840	2016-05-30	2016-05-30 00:00:00	2016-05-30	5001	0	\N	0	0	\N	\N	0	209369	0	127783003	4133840		
105239	3240	4052083	1990-12-30	1990-12-30 00:00:00	1990-12-30	5001	0	\N	0	0	\N	\N	0	215345	0	23426006	4052083		
36967	3399	3023430	1983-12-17	1983-12-17 00:00:00	1983-12-17	5001	0	\N	0	0	\N	\N	0	225486	0	6833-8	3023430		
79190	2436	4024958	1953-11-21	1953-11-21 00:00:00	1953-11-21	5001	0	\N	0	0	\N	\N	0	161639	0	117015009	4024958		
52920	4859	3004501	1971-06-05	1971-06-05 00:00:00	1971-06-05	5001	0	\N	0	0	\N	\N	0	323226	0	2345-7	3004501		
12502	403	4052083	1992-11-09	1992-11-09 00:00:00	1992-11-09	5001	0	\N	0	0	\N	\N	0	26499	0	23426006	4052083		
27801	2559	3006451	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	169525	0	6273-7	3006451		
62046	1902	4024958	1960-11-14	1960-11-14 00:00:00	1960-11-14	5001	0	\N	0	0	\N	\N	0	126635	0	117015009	4024958		
49535	4506	40766240	2011-10-26	2011-10-26 00:00:00	2011-10-26	5001	0	\N	0	0	\N	\N	0	300210	0	63513-6	40766240		
70654	2165	4024958	1963-11-15	1963-11-15 00:00:00	1963-11-15	5001	0	\N	0	0	\N	\N	0	144225	0	117015009	4024958		
39361	3639	3006322	1966-05-24	1966-05-24 00:00:00	1966-05-24	5001	0	\N	0	0	\N	\N	0	242064	0	8331-1	3006322		
34190	3117	40758406	2001-11-22	2001-11-22 00:00:00	2001-11-22	5001	0	\N	0	0	\N	\N	0	207388	0	55277-8	40758406		
22725	2084	3006322	1990-07-11	1990-07-11 00:00:00	1990-07-11	5001	0	\N	0	0	\N	\N	0	138836	0	8331-1	3006322		
42432	3916	3023430	1991-10-09	1991-10-09 00:00:00	1991-10-09	5001	0	\N	0	0	\N	\N	0	260266	0	6833-8	3023430		
2106	191	3011505	1994-09-27	1994-09-27 00:00:00	1994-09-27	5001	0	\N	0	0	\N	\N	0	13052	0	19926-5	3011505		
27214	2524	3006322	1968-03-11	1968-03-11 00:00:00	1968-03-11	5001	0	\N	0	0	\N	\N	0	166913	0	8331-1	3006322		
8378	789	3006322	2006-04-14	2006-04-14 00:00:00	2006-04-14	5001	0	\N	0	0	\N	\N	0	52477	0	8331-1	3006322		
27382	2540	3006322	1992-09-15	1992-09-15 00:00:00	1992-09-15	5001	0	\N	0	0	\N	\N	0	167881	0	8331-1	3006322		
11916	1137	3006322	1996-06-03	1996-06-03 00:00:00	1996-06-03	5001	0	\N	0	0	\N	\N	0	74908	0	8331-1	3006322		
55482	1685	4024958	1989-01-10	1989-01-10 00:00:00	1989-01-10	5001	0	\N	0	0	\N	\N	0	112892	0	117015009	4024958		
13920	1309	3027970	1994-03-21	1994-03-21 00:00:00	1994-03-21	5001	0	\N	0	0	\N	\N	0	86444	0	10834-0	3027970		
56880	1738	4052083	1986-07-15	1986-07-15 00:00:00	1986-07-15	5001	0	\N	0	0	\N	\N	0	116149	0	23426006	4052083		
43367	4010	3006322	1983-08-29	1983-08-29 00:00:00	1983-08-29	5001	0	\N	0	0	\N	\N	0	266461	0	8331-1	3006322		
47931	4390	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	291804	0	6158-0	3019406		
36791	3376	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	224054	0	6844-5	3020655		
15588	1426	3049273	2007-10-08	2007-10-08 00:00:00	2007-10-08	5001	0	\N	0	0	\N	\N	0	94876	0	38265-5	3049273		
30142	2771	3007461	1974-09-02	1974-09-02 00:00:00	1974-09-02	5001	0	\N	0	0	\N	\N	0	183474	0	26515-7	3007461		
37941	3505	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	232469	0	6844-5	3020655		
49278	4500	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	299570	0	6075-6	3005136		
20222	1852	3006322	2011-01-24	2011-01-24 00:00:00	2011-01-24	5001	0	\N	0	0	\N	\N	0	123877	0	8331-1	3006322		
10974	1062	3006322	1994-07-30	1994-07-30 00:00:00	1994-07-30	5001	0	\N	0	0	\N	\N	0	69686	0	8331-1	3006322		
53056	4872	3006322	1976-05-08	1976-05-08 00:00:00	1976-05-08	5001	0	\N	0	0	\N	\N	0	324029	0	8331-1	3006322		
33412	3020	3011505	2010-01-20	2010-01-20 00:00:00	2010-01-20	5001	0	\N	0	0	\N	\N	0	201409	0	19926-5	3011505		
33470	3026	40766240	1984-02-15	1984-02-15 00:00:00	1984-02-15	5001	0	\N	0	0	\N	\N	0	201762	0	63513-6	40766240		
16488	1505	3006322	2015-10-31	2015-10-31 00:00:00	2015-10-31	5001	0	\N	0	0	\N	\N	0	100387	0	8331-1	3006322		
51143	4674	3006322	1982-05-12	1982-05-12 00:00:00	1982-05-12	5001	0	\N	0	0	\N	\N	0	311389	0	8331-1	3006322		
40370	3752	40758406	1993-12-28	1993-12-28 00:00:00	1993-12-28	5001	0	\N	0	0	\N	\N	0	249310	0	55277-8	40758406		
55312	5063	3006322	1973-01-27	1973-01-27 00:00:00	1973-01-27	5001	0	\N	0	0	\N	\N	0	336569	0	8331-1	3006322		
116285	3582	4133840	2015-07-19	2015-07-19 00:00:00	2015-07-19	5001	0	\N	0	0	\N	\N	0	238153	0	127783003	4133840		
51904	4761	3023430	1984-05-29	1984-05-29 00:00:00	1984-05-29	5001	0	\N	0	0	\N	\N	0	317259	0	6833-8	3023430		
41187	3844	3006322	1966-06-01	1966-06-01 00:00:00	1966-06-01	5001	0	\N	0	0	\N	\N	0	255152	0	8331-1	3006322		
7897	755	3049273	2018-10-14	2018-10-14 00:00:00	2018-10-14	5001	0	\N	0	0	\N	\N	0	50013	0	38265-5	3049273		
52028	4773	3006322	1974-12-18	1974-12-18 00:00:00	1974-12-18	5001	0	\N	0	0	\N	\N	0	317871	0	8331-1	3006322		
26804	2476	3006322	1981-12-06	1981-12-06 00:00:00	1981-12-06	5001	0	\N	0	0	\N	\N	0	164061	0	8331-1	3006322		
4414	137	4024958	2003-10-17	2003-10-17 00:00:00	2003-10-17	5001	0	\N	0	0	\N	\N	0	9150	0	117015009	4024958		
40212	3744	3027231	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	248741	0	6276-0	3027231		
19993	1834	3006322	2016-05-17	2016-05-17 00:00:00	2016-05-17	5001	0	\N	0	0	\N	\N	0	122517	0	8331-1	3006322		
49684	4520	3011505	1988-12-24	1988-12-24 00:00:00	1988-12-24	5001	0	\N	0	0	\N	\N	0	300926	0	19926-5	3011505		
55604	1691	4024958	1977-07-31	1977-07-31 00:00:00	1977-07-31	5001	0	\N	0	0	\N	\N	0	113224	0	117015009	4024958		
69	2	46235214	1934-11-25	1934-11-25 00:00:00	1934-11-25	5001	0	\N	0	0	\N	\N	0	176	0	76690-7	46235214		
26859	2485	3006322	1976-08-24	1976-08-24 00:00:00	1976-08-24	5001	0	\N	0	0	\N	\N	0	164586	0	8331-1	3006322		
53847	4935	3001488	1985-10-11	1985-10-11 00:00:00	1985-10-11	5001	0	\N	0	0	\N	\N	0	328074	0	7258-7	3001488		
21162	1956	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	130152	0	6844-5	3020655		
156827	4822	4133840	2005-11-09	2005-11-09 00:00:00	2005-11-09	5001	0	\N	0	0	\N	\N	0	320771	0	127783003	4133840		
76052	2334	4133840	1995-03-23	1995-03-23 00:00:00	1995-03-23	5001	0	\N	0	0	\N	\N	0	155299	0	127783003	4133840		
1765	155	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	10629	0	6082-2	3000876		
172561	5295	4024958	1917-02-12	1917-02-12 00:00:00	1917-02-12	5001	0	\N	0	0	\N	\N	0	352270	0	117015009	4024958		
28681	886	4052083	1998-11-19	1998-11-19 00:00:00	1998-11-19	5001	0	\N	0	0	\N	\N	0	59060	0	23426006	4052083		
112926	3486	4024958	1974-09-03	1974-09-03 00:00:00	1974-09-03	5001	0	\N	0	0	\N	\N	0	231231	0	117015009	4024958		
97661	2986	4133840	2001-01-23	2001-01-23 00:00:00	2001-01-23	5001	0	\N	0	0	\N	\N	0	199314	0	127783003	4133840		
55940	5132	3049273	2019-06-06	2019-06-06 00:00:00	2019-06-06	5001	0	\N	0	0	\N	\N	0	341172	0	38265-5	3049273		
1405	124	3020655	1997-03-10	1997-03-10 00:00:00	1997-03-10	5001	0	\N	0	0	\N	\N	0	8325	0	6844-5	3020655		
101530	3118	4133840	2004-07-04	2004-07-04 00:00:00	2004-07-04	5001	0	\N	0	0	\N	\N	0	207410	0	127783003	4133840		
102392	3147	4133840	2018-06-11	2018-06-11 00:00:00	2018-06-11	5001	0	\N	0	0	\N	\N	0	209350	0	127783003	4133840		
105246	3240	4024958	1970-12-16	1970-12-16 00:00:00	1970-12-16	5001	0	\N	0	0	\N	\N	0	215352	0	117015009	4024958		
36968	3399	3021226	1983-12-17	1983-12-17 00:00:00	1983-12-17	5001	0	\N	0	0	\N	\N	0	225486	0	6246-3	3021226		
113696	3510	4024958	1996-05-19	1996-05-19 00:00:00	1996-05-19	5001	0	\N	0	0	\N	\N	0	232930	0	117015009	4024958		
52921	4859	3015632	1971-06-05	1971-06-05 00:00:00	1971-06-05	5001	0	\N	0	0	\N	\N	0	323226	0	2028-9	3015632		
12518	403	4024958	1934-03-27	1934-03-27 00:00:00	1934-03-27	5001	0	\N	0	0	\N	\N	0	26432	0	117015009	4024958		
27802	2559	3014599	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	169525	0	6106-9	3014599		
62068	1902	4024958	1952-02-17	1952-02-17 00:00:00	1952-02-17	5001	0	\N	0	0	\N	\N	0	126588	0	117015009	4024958		
49536	4506	3051031	2011-10-26	2011-10-26 00:00:00	2011-10-26	5001	0	\N	0	0	\N	\N	0	300210	0	46240-8	3051031		
70670	2166	4052083	2001-06-13	2001-06-13 00:00:00	2001-06-13	5001	0	\N	0	0	\N	\N	0	144291	0	23426006	4052083		
39363	3639	3006322	2009-09-21	2009-09-21 00:00:00	2009-09-21	5001	0	\N	0	0	\N	\N	0	242039	0	8331-1	3006322		
34191	3117	40758406	2002-04-21	2002-04-21 00:00:00	2002-04-21	5001	0	\N	0	0	\N	\N	0	207372	0	55277-8	40758406		
22726	2084	3006322	1992-12-07	1992-12-07 00:00:00	1992-12-07	5001	0	\N	0	0	\N	\N	0	138837	0	8331-1	3006322		
42433	3916	3020655	1991-10-09	1991-10-09 00:00:00	1991-10-09	5001	0	\N	0	0	\N	\N	0	260266	0	6844-5	3020655		
2107	191	3006322	1953-05-13	1953-05-13 00:00:00	1953-05-13	5001	0	\N	0	0	\N	\N	0	13063	0	8331-1	3006322		
27215	2524	3006322	1993-06-02	1993-06-02 00:00:00	1993-06-02	5001	0	\N	0	0	\N	\N	0	166915	0	8331-1	3006322		
8379	789	3006322	2014-02-16	2014-02-16 00:00:00	2014-02-16	5001	0	\N	0	0	\N	\N	0	52464	0	8331-1	3006322		
27383	2540	40758406	1967-02-03	1967-02-03 00:00:00	1967-02-03	5001	0	\N	0	0	\N	\N	0	167938	0	55277-8	40758406		
11918	1137	3051031	1984-02-03	1984-02-03 00:00:00	1984-02-03	5001	0	\N	0	0	\N	\N	0	74981	0	46240-8	3051031		
55486	1685	4024958	1980-09-10	1980-09-10 00:00:00	1980-09-10	5001	0	\N	0	0	\N	\N	0	112883	0	117015009	4024958		
13921	1309	3007461	1994-03-21	1994-03-21 00:00:00	1994-03-21	5001	0	\N	0	0	\N	\N	0	86444	0	26515-7	3007461		
56891	1738	4024958	1972-05-01	1972-05-01 00:00:00	1972-05-01	5001	0	\N	0	0	\N	\N	0	116100	0	117015009	4024958		
43368	4010	3006322	1994-01-17	1994-01-17 00:00:00	1994-01-17	5001	0	\N	0	0	\N	\N	0	266514	0	8331-1	3006322		
47932	4390	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	291804	0	6273-7	3006451		
36792	3376	3006322	2018-07-08	2018-07-08 00:00:00	2018-07-08	5001	0	\N	0	0	\N	\N	0	224041	0	8331-1	3006322		
15589	1426	3006322	1953-12-02	1953-12-02 00:00:00	1953-12-02	5001	0	\N	0	0	\N	\N	0	94815	0	8331-1	3006322		
30143	2771	3045716	1974-09-02	1974-09-02 00:00:00	1974-09-02	5001	0	\N	0	0	\N	\N	0	183474	0	33037-3	3045716		
37942	3505	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	232469	0	6276-0	3027231		
49279	4500	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	299570	0	6248-9	3015076		
20223	1852	3006322	2017-06-01	2017-06-01 00:00:00	2017-06-01	5001	0	\N	0	0	\N	\N	0	123879	0	8331-1	3006322		
31578	2892	46235214	1984-01-25	1984-01-25 00:00:00	1984-01-25	5001	0	\N	0	0	\N	\N	0	192412	0	76690-7	46235214		
53057	4872	3006322	1933-11-07	1933-11-07 00:00:00	1933-11-07	5001	0	\N	0	0	\N	\N	0	323973	0	8331-1	3006322		
33413	3020	3011505	2005-09-14	2005-09-14 00:00:00	2005-09-14	5001	0	\N	0	0	\N	\N	0	201403	0	19926-5	3011505		
33471	3026	40758406	1984-02-15	1984-02-15 00:00:00	1984-02-15	5001	0	\N	0	0	\N	\N	0	201762	0	55277-8	40758406		
16489	1505	3006322	1996-03-21	1996-03-21 00:00:00	1996-03-21	5001	0	\N	0	0	\N	\N	0	100353	0	8331-1	3006322		
51144	4674	3006322	2015-03-17	2015-03-17 00:00:00	2015-03-17	5001	0	\N	0	0	\N	\N	0	311384	0	8331-1	3006322		
40372	3752	3006322	2013-04-05	2013-04-05 00:00:00	2013-04-05	5001	0	\N	0	0	\N	\N	0	249322	0	8331-1	3006322		
55313	5063	3006322	2004-10-27	2004-10-27 00:00:00	2004-10-27	5001	0	\N	0	0	\N	\N	0	336536	0	8331-1	3006322		
116287	3582	4133840	2006-05-28	2006-05-28 00:00:00	2006-05-28	5001	0	\N	0	0	\N	\N	0	238162	0	127783003	4133840		
51905	4761	3021226	1984-05-29	1984-05-29 00:00:00	1984-05-29	5001	0	\N	0	0	\N	\N	0	317259	0	6246-3	3021226		
41188	3844	3006322	1965-10-22	1965-10-22 00:00:00	1965-10-22	5001	0	\N	0	0	\N	\N	0	255126	0	8331-1	3006322		
126199	3887	4052083	1973-05-08	1973-05-08 00:00:00	1973-05-08	5001	0	\N	0	0	\N	\N	0	258339	0	23426006	4052083		
88132	2724	4024958	1961-07-13	1961-07-13 00:00:00	1961-07-13	5001	0	\N	0	0	\N	\N	0	180513	0	117015009	4024958		
26805	2476	3006322	1982-10-13	1982-10-13 00:00:00	1982-10-13	5001	0	\N	0	0	\N	\N	0	164101	0	8331-1	3006322		
4455	137	4024958	1977-09-28	1977-09-28 00:00:00	1977-09-28	5001	0	\N	0	0	\N	\N	0	9131	0	117015009	4024958		
40213	3744	3023430	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	248741	0	6833-8	3023430		
19994	1834	3006322	1970-12-13	1970-12-13 00:00:00	1970-12-13	5001	0	\N	0	0	\N	\N	0	122558	0	8331-1	3006322		
49685	4520	3011505	1972-10-07	1972-10-07 00:00:00	1972-10-07	5001	0	\N	0	0	\N	\N	0	300912	0	19926-5	3011505		
55625	1691	4024958	1960-02-06	1960-02-06 00:00:00	1960-02-06	5001	0	\N	0	0	\N	\N	0	113259	0	117015009	4024958		
71	2	3049273	1990-04-14	1990-04-14 00:00:00	1990-04-14	5001	0	\N	0	0	\N	\N	0	116	0	38265-5	3049273		
26860	2485	3006322	1925-11-30	1925-11-30 00:00:00	1925-11-30	5001	0	\N	0	0	\N	\N	0	164583	0	8331-1	3006322		
53848	4935	3006734	1985-10-11	1985-10-11 00:00:00	1985-10-11	5001	0	\N	0	0	\N	\N	0	328074	0	6189-5	3006734		
21163	1956	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	130152	0	6158-0	3019406		
156834	4822	4052083	2018-06-01	2018-06-01 00:00:00	2018-06-01	5001	0	\N	0	0	\N	\N	0	320716	0	23426006	4052083		
156866	4822	4133840	2010-12-08	2010-12-08 00:00:00	2010-12-08	5001	0	\N	0	0	\N	\N	0	320705	0	127783003	4133840		
1766	155	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	10629	0	7258-7	3001488		
172570	5295	4024958	1985-08-06	1985-08-06 00:00:00	1985-08-06	5001	0	\N	0	0	\N	\N	0	352244	0	117015009	4024958		
28683	886	4024958	1984-09-30	1984-09-30 00:00:00	1984-09-30	5001	0	\N	0	0	\N	\N	0	59091	0	117015009	4024958		
112928	3486	4024958	1961-06-18	1961-06-18 00:00:00	1961-06-18	5001	0	\N	0	0	\N	\N	0	231253	0	117015009	4024958		
97662	2986	4133840	2009-03-10	2009-03-10 00:00:00	2009-03-10	5001	0	\N	0	0	\N	\N	0	199305	0	127783003	4133840		
55941	5132	3006322	1974-02-28	1974-02-28 00:00:00	1974-02-28	5001	0	\N	0	0	\N	\N	0	341109	0	8331-1	3006322		
1406	124	3001247	1997-03-10	1997-03-10 00:00:00	1997-03-10	5001	0	\N	0	0	\N	\N	0	8325	0	6085-5	3001247		
101533	3118	4133840	2004-01-04	2004-01-04 00:00:00	2004-01-04	5001	0	\N	0	0	\N	\N	0	207425	0	127783003	4133840		
102396	3147	4133840	2003-03-17	2003-03-17 00:00:00	2003-03-17	5001	0	\N	0	0	\N	\N	0	209366	0	127783003	4133840		
3051	94	4052083	1994-10-24	1994-10-24 00:00:00	1994-10-24	5001	0	\N	0	0	\N	\N	0	6369	0	23426006	4052083		
36969	3399	3036780	1983-12-17	1983-12-17 00:00:00	1983-12-17	5001	0	\N	0	0	\N	\N	0	225486	0	6095-4	3036780		
113736	3510	4024958	1943-06-10	1943-06-10 00:00:00	1943-06-10	5001	0	\N	0	0	\N	\N	0	232900	0	117015009	4024958		
52922	4859	3007461	1971-06-05	1971-06-05 00:00:00	1971-06-05	5001	0	\N	0	0	\N	\N	0	323226	0	26515-7	3007461		
23814	744	4024958	2009-11-03	2009-11-03 00:00:00	2009-11-03	5001	0	\N	0	0	\N	\N	0	49350	0	117015009	4024958		
27803	2559	3019406	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	169525	0	6158-0	3019406		
62069	1902	4024958	1981-10-09	1981-10-09 00:00:00	1981-10-09	5001	0	\N	0	0	\N	\N	0	126590	0	117015009	4024958		
49537	4506	46235214	2011-10-26	2011-10-26 00:00:00	2011-10-26	5001	0	\N	0	0	\N	\N	0	300210	0	76690-7	46235214		
150992	4628	4024958	1992-10-31	1992-10-31 00:00:00	1992-10-31	5001	0	\N	0	0	\N	\N	0	308357	0	117015009	4024958		
39364	3639	3006322	1960-07-11	1960-07-11 00:00:00	1960-07-11	5001	0	\N	0	0	\N	\N	0	242062	0	8331-1	3006322		
34192	3117	46235214	2002-04-21	2002-04-21 00:00:00	2002-04-21	5001	0	\N	0	0	\N	\N	0	207372	0	76690-7	46235214		
34011	3100	3006322	1954-11-17	1954-11-17 00:00:00	1954-11-17	5001	0	\N	0	0	\N	\N	0	206255	0	8331-1	3006322		
42434	3916	3006451	1991-10-09	1991-10-09 00:00:00	1991-10-09	5001	0	\N	0	0	\N	\N	0	260266	0	6273-7	3006451		
2108	191	3049273	1994-05-07	1994-05-07 00:00:00	1994-05-07	5001	0	\N	0	0	\N	\N	0	13042	0	38265-5	3049273		
27216	2524	3006322	1986-01-28	1986-01-28 00:00:00	1986-01-28	5001	0	\N	0	0	\N	\N	0	166903	0	8331-1	3006322		
8380	789	3006322	1985-03-21	1985-03-21 00:00:00	1985-03-21	5001	0	\N	0	0	\N	\N	0	52493	0	8331-1	3006322		
27384	2540	46235214	1967-02-03	1967-02-03 00:00:00	1967-02-03	5001	0	\N	0	0	\N	\N	0	167938	0	76690-7	46235214		
11919	1137	40766240	1984-02-03	1984-02-03 00:00:00	1984-02-03	5001	0	\N	0	0	\N	\N	0	74981	0	63513-6	40766240		
55488	1685	4024958	1999-01-01	1999-01-01 00:00:00	1999-01-01	5001	0	\N	0	0	\N	\N	0	112872	0	117015009	4024958		
13922	1309	3045716	1994-03-21	1994-03-21 00:00:00	1994-03-21	5001	0	\N	0	0	\N	\N	0	86444	0	33037-3	3045716		
56896	1738	4024958	1974-01-30	1974-01-30 00:00:00	1974-01-30	5001	0	\N	0	0	\N	\N	0	116129	0	117015009	4024958		
43369	4010	3006322	1981-05-01	1981-05-01 00:00:00	1981-05-01	5001	0	\N	0	0	\N	\N	0	266513	0	8331-1	3006322		
47933	4390	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	291804	0	6276-0	3027231		
36793	3376	3006322	1994-12-25	1994-12-25 00:00:00	1994-12-25	5001	0	\N	0	0	\N	\N	0	224055	0	8331-1	3006322		
15590	1426	3049273	2005-10-18	2005-10-18 00:00:00	2005-10-18	5001	0	\N	0	0	\N	\N	0	94875	0	38265-5	3049273		
30144	2771	3023103	1974-09-02	1974-09-02 00:00:00	1974-09-02	5001	0	\N	0	0	\N	\N	0	183474	0	2823-3	3023103		
37943	3505	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	232469	0	6273-7	3006451		
49280	4500	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	299570	0	6082-2	3000876		
20224	1852	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	123986	0	6075-6	3005136		
31579	2892	40758406	1984-01-25	1984-01-25 00:00:00	1984-01-25	5001	0	\N	0	0	\N	\N	0	192412	0	55277-8	40758406		
53058	4872	3006322	2013-11-10	2013-11-10 00:00:00	2013-11-10	5001	0	\N	0	0	\N	\N	0	324084	0	8331-1	3006322		
33414	3020	3011505	2005-01-26	2005-01-26 00:00:00	2005-01-26	5001	0	\N	0	0	\N	\N	0	201402	0	19926-5	3011505		
33472	3026	3051031	1984-02-15	1984-02-15 00:00:00	1984-02-15	5001	0	\N	0	0	\N	\N	0	201762	0	46240-8	3051031		
16490	1505	3006322	1961-01-29	1961-01-29 00:00:00	1961-01-29	5001	0	\N	0	0	\N	\N	0	100327	0	8331-1	3006322		
51145	4674	3006322	1982-09-21	1982-09-21 00:00:00	1982-09-21	5001	0	\N	0	0	\N	\N	0	311373	0	8331-1	3006322		
40373	3752	3051031	1994-05-27	1994-05-27 00:00:00	1994-05-27	5001	0	\N	0	0	\N	\N	0	249354	0	46240-8	3051031		
55314	5063	3006322	2000-12-02	2000-12-02 00:00:00	2000-12-02	5001	0	\N	0	0	\N	\N	0	336571	0	8331-1	3006322		
116292	3582	4133840	2004-06-20	2004-06-20 00:00:00	2004-06-20	5001	0	\N	0	0	\N	\N	0	238105	0	127783003	4133840		
51906	4761	3019406	1984-05-29	1984-05-29 00:00:00	1984-05-29	5001	0	\N	0	0	\N	\N	0	317259	0	6158-0	3019406		
41189	3844	3006322	1990-03-09	1990-03-09 00:00:00	1990-03-09	5001	0	\N	0	0	\N	\N	0	255153	0	8331-1	3006322		
126200	3887	4024958	1977-04-02	1977-04-02 00:00:00	1977-04-02	5001	0	\N	0	0	\N	\N	0	258367	0	117015009	4024958		
88140	2724	4024958	1983-07-17	1983-07-17 00:00:00	1983-07-17	5001	0	\N	0	0	\N	\N	0	180478	0	117015009	4024958		
26806	2476	3006322	1976-05-25	1976-05-25 00:00:00	1976-05-25	5001	0	\N	0	0	\N	\N	0	164060	0	8331-1	3006322		
4460	137	4024958	1989-04-01	1989-04-01 00:00:00	1989-04-01	5001	0	\N	0	0	\N	\N	0	9133	0	117015009	4024958		
40214	3744	3036780	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	248741	0	6095-4	3036780		
19995	1834	3006322	1987-05-14	1987-05-14 00:00:00	1987-05-14	5001	0	\N	0	0	\N	\N	0	122484	0	8331-1	3006322		
49686	4520	3011505	1970-10-03	1970-10-03 00:00:00	1970-10-03	5001	0	\N	0	0	\N	\N	0	300957	0	19926-5	3011505		
55635	1691	4024958	1959-12-27	1959-12-27 00:00:00	1959-12-27	5001	0	\N	0	0	\N	\N	0	113258	0	117015009	4024958		
72	2	3011505	1998-07-14	1998-07-14 00:00:00	1998-07-14	5001	0	\N	0	0	\N	\N	0	135	0	19926-5	3011505		
26861	2485	3049273	1990-03-11	1990-03-11 00:00:00	1990-03-11	5001	0	\N	0	0	\N	\N	0	164690	0	38265-5	3049273		
53849	4935	3001247	1985-10-11	1985-10-11 00:00:00	1985-10-11	5001	0	\N	0	0	\N	\N	0	328074	0	6085-5	3001247		
21164	1956	3006322	1977-10-12	1977-10-12 00:00:00	1977-10-12	5001	0	\N	0	0	\N	\N	0	130179	0	8331-1	3006322		
156837	4822	4133840	2016-01-06	2016-01-06 00:00:00	2016-01-06	5001	0	\N	0	0	\N	\N	0	320721	0	127783003	4133840		
156870	4822	4133840	2018-06-20	2018-06-20 00:00:00	2018-06-20	5001	0	\N	0	0	\N	\N	0	320793	0	127783003	4133840		
1767	155	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	10629	0	6095-4	3036780		
34412	3135	3006322	2008-10-13	2008-10-13 00:00:00	2008-10-13	5001	0	\N	0	0	\N	\N	0	208649	0	8331-1	3006322		
28684	886	4052083	1995-11-29	1995-11-29 00:00:00	1995-11-29	5001	0	\N	0	0	\N	\N	0	59077	0	23426006	4052083		
112944	3486	4052083	1995-12-30	1995-12-30 00:00:00	1995-12-30	5001	0	\N	0	0	\N	\N	0	231292	0	23426006	4052083		
97667	2986	4133840	1996-12-31	1996-12-31 00:00:00	1996-12-31	5001	0	\N	0	0	\N	\N	0	199293	0	127783003	4133840		
55942	5132	3006322	1968-11-28	1968-11-28 00:00:00	1968-11-28	5001	0	\N	0	0	\N	\N	0	341128	0	8331-1	3006322		
1407	124	3023430	1997-03-10	1997-03-10 00:00:00	1997-03-10	5001	0	\N	0	0	\N	\N	0	8325	0	6833-8	3023430		
101536	3118	4133840	1983-06-05	1983-06-05 00:00:00	1983-06-05	5001	0	\N	0	0	\N	\N	0	207508	0	127783003	4133840		
102399	3147	4133840	1988-01-18	1988-01-18 00:00:00	1988-01-18	5001	0	\N	0	0	\N	\N	0	209384	0	127783003	4133840		
3071	95	4024958	1969-11-06	1969-11-06 00:00:00	1969-11-06	5001	0	\N	0	0	\N	\N	0	6454	0	117015009	4024958		
36970	3399	3027231	1983-12-17	1983-12-17 00:00:00	1983-12-17	5001	0	\N	0	0	\N	\N	0	225486	0	6276-0	3027231		
113761	3510	4052083	1935-10-06	1935-10-06 00:00:00	1935-10-06	5001	0	\N	0	0	\N	\N	0	232960	0	23426006	4052083		
52923	4859	3009542	1971-06-05	1971-06-05 00:00:00	1971-06-05	5001	0	\N	0	0	\N	\N	0	323226	0	20570-8	3009542		
23823	744	4024958	1963-01-14	1963-01-14 00:00:00	1963-01-14	5001	0	\N	0	0	\N	\N	0	49314	0	117015009	4024958		
27804	2559	3005136	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	169525	0	6075-6	3005136		
62076	1903	4052083	2014-08-21	2014-08-21 00:00:00	2014-08-21	5001	0	\N	0	0	\N	\N	0	126725	0	23426006	4052083		
49539	4506	40758406	2011-10-26	2011-10-26 00:00:00	2011-10-26	5001	0	\N	0	0	\N	\N	0	300210	0	55277-8	40758406		
150999	4628	4024958	1981-06-20	1981-06-20 00:00:00	1981-06-20	5001	0	\N	0	0	\N	\N	0	308367	0	117015009	4024958		
39365	3639	3006322	1928-02-14	1928-02-14 00:00:00	1928-02-14	5001	0	\N	0	0	\N	\N	0	242125	0	8331-1	3006322		
34194	3117	40766240	2002-04-21	2002-04-21 00:00:00	2002-04-21	5001	0	\N	0	0	\N	\N	0	207372	0	63513-6	40766240		
34017	3105	3006322	2001-07-15	2001-07-15 00:00:00	2001-07-15	5001	0	\N	0	0	\N	\N	0	206490	0	8331-1	3006322		
42435	3916	3021226	1991-10-09	1991-10-09 00:00:00	1991-10-09	5001	0	\N	0	0	\N	\N	0	260266	0	6246-3	3021226		
2109	191	3011505	1993-09-21	1993-09-21 00:00:00	1993-09-21	5001	0	\N	0	0	\N	\N	0	13085	0	19926-5	3011505		
27218	2525	3006322	1991-06-17	1991-06-17 00:00:00	1991-06-17	5001	0	\N	0	0	\N	\N	0	166976	0	8331-1	3006322		
8381	789	3006322	2001-03-16	2001-03-16 00:00:00	2001-03-16	5001	0	\N	0	0	\N	\N	0	52483	0	8331-1	3006322		
27386	2540	3051031	1967-02-03	1967-02-03 00:00:00	1967-02-03	5001	0	\N	0	0	\N	\N	0	167938	0	46240-8	3051031		
11921	1137	46235214	1984-02-03	1984-02-03 00:00:00	1984-02-03	5001	0	\N	0	0	\N	\N	0	74981	0	76690-7	46235214		
28519	883	4024958	1972-09-10	1972-09-10 00:00:00	1972-09-10	5001	0	\N	0	0	\N	\N	0	58813	0	117015009	4024958		
13923	1309	3002385	1994-03-21	1994-03-21 00:00:00	1994-03-21	5001	0	\N	0	0	\N	\N	0	86444	0	30385-9	3002385		
56911	1739	4024958	1969-03-11	1969-03-11 00:00:00	1969-03-11	5001	0	\N	0	0	\N	\N	0	116209	0	117015009	4024958		
32197	2925	3019406	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	195100	0	6158-0	3019406		
47934	4390	3006322	2002-12-30	2002-12-30 00:00:00	2002-12-30	5001	0	\N	0	0	\N	\N	0	291890	0	8331-1	3006322		
36794	3376	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	224029	0	6248-9	3015076		
15591	1426	3006322	2006-09-01	2006-09-01 00:00:00	2006-09-01	5001	0	\N	0	0	\N	\N	0	94808	0	8331-1	3006322		
30145	2771	3013682	1974-09-02	1974-09-02 00:00:00	1974-09-02	5001	0	\N	0	0	\N	\N	0	183474	0	3094-0	3013682		
37944	3505	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	232469	0	6095-4	3036780		
49281	4501	3006322	2011-01-13	2011-01-13 00:00:00	2011-01-13	5001	0	\N	0	0	\N	\N	0	299679	0	8331-1	3006322		
20225	1852	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	123986	0	6158-0	3019406		
31582	2892	40766240	1984-01-25	1984-01-25 00:00:00	1984-01-25	5001	0	\N	0	0	\N	\N	0	192412	0	63513-6	40766240		
53059	4873	3006322	2014-06-24	2014-06-24 00:00:00	2014-06-24	5001	0	\N	0	0	\N	\N	0	324129	0	8331-1	3006322		
33415	3020	3006322	1974-11-15	1974-11-15 00:00:00	1974-11-15	5001	0	\N	0	0	\N	\N	0	201381	0	8331-1	3006322		
33473	3026	46235214	1984-02-15	1984-02-15 00:00:00	1984-02-15	5001	0	\N	0	0	\N	\N	0	201762	0	76690-7	46235214		
16491	1505	46235214	1983-10-28	1983-10-28 00:00:00	1983-10-28	5001	0	\N	0	0	\N	\N	0	100314	0	76690-7	46235214		
51146	4675	3006322	1968-01-01	1968-01-01 00:00:00	1968-01-01	5001	0	\N	0	0	\N	\N	0	311430	0	8331-1	3006322		
40374	3752	46235214	1994-05-27	1994-05-27 00:00:00	1994-05-27	5001	0	\N	0	0	\N	\N	0	249354	0	76690-7	46235214		
55331	5065	3006322	1973-07-05	1973-07-05 00:00:00	1973-07-05	5001	0	\N	0	0	\N	\N	0	336731	0	8331-1	3006322		
116295	3582	4133840	2013-07-07	2013-07-07 00:00:00	2013-07-07	5001	0	\N	0	0	\N	\N	0	238099	0	127783003	4133840		
51907	4761	3001488	1984-05-29	1984-05-29 00:00:00	1984-05-29	5001	0	\N	0	0	\N	\N	0	317259	0	7258-7	3001488		
50326	1529	4052083	2010-04-19	2010-04-19 00:00:00	2010-04-19	5001	0	\N	0	0	\N	\N	0	102321	0	23426006	4052083		
126201	3887	4024958	1970-03-24	1970-03-24 00:00:00	1970-03-24	5001	0	\N	0	0	\N	\N	0	258388	0	117015009	4024958		
88153	2724	4024958	1969-11-27	1969-11-27 00:00:00	1969-11-27	5001	0	\N	0	0	\N	\N	0	180483	0	117015009	4024958		
26807	2477	3006322	2001-08-30	2001-08-30 00:00:00	2001-08-30	5001	0	\N	0	0	\N	\N	0	164180	0	8331-1	3006322		
73220	2250	4052083	1993-12-27	1993-12-27 00:00:00	1993-12-27	5001	0	\N	0	0	\N	\N	0	149682	0	23426006	4052083		
40215	3744	3005136	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	248741	0	6075-6	3005136		
20002	1837	3006322	2017-01-28	2017-01-28 00:00:00	2017-01-28	5001	0	\N	0	0	\N	\N	0	122718	0	8331-1	3006322		
49687	4520	3011505	1963-09-21	1963-09-21 00:00:00	1963-09-21	5001	0	\N	0	0	\N	\N	0	300929	0	19926-5	3011505		
55646	1692	4024958	1983-04-14	1983-04-14 00:00:00	1983-04-14	5001	0	\N	0	0	\N	\N	0	113325	0	117015009	4024958		
73	2	3011505	1997-07-08	1997-07-08 00:00:00	1997-07-08	5001	0	\N	0	0	\N	\N	0	197	0	19926-5	3011505		
26862	2485	3006322	1940-02-10	1940-02-10 00:00:00	1940-02-10	5001	0	\N	0	0	\N	\N	0	164595	0	8331-1	3006322		
53850	4935	3014599	1985-10-11	1985-10-11 00:00:00	1985-10-11	5001	0	\N	0	0	\N	\N	0	328074	0	6106-9	3014599		
21165	1956	3006322	1995-07-06	1995-07-06 00:00:00	1995-07-06	5001	0	\N	0	0	\N	\N	0	130126	0	8331-1	3006322		
156838	4822	4133840	2008-11-26	2008-11-26 00:00:00	2008-11-26	5001	0	\N	0	0	\N	\N	0	320791	0	127783003	4133840		
156872	4822	4133840	2007-11-21	2007-11-21 00:00:00	2007-11-21	5001	0	\N	0	0	\N	\N	0	320772	0	127783003	4133840		
1768	155	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	10629	0	6276-0	3027231		
34413	3135	3006322	1998-01-25	1998-01-25 00:00:00	1998-01-25	5001	0	\N	0	0	\N	\N	0	208696	0	8331-1	3006322		
28688	887	4052083	1965-06-05	1965-06-05 00:00:00	1965-06-05	5001	0	\N	0	0	\N	\N	0	59142	0	23426006	4052083		
124238	3836	4052083	2008-09-24	2008-09-24 00:00:00	2008-09-24	5001	0	\N	0	0	\N	\N	0	254725	0	23426006	4052083		
97669	2986	4133840	2018-06-12	2018-06-12 00:00:00	2018-06-12	5001	0	\N	0	0	\N	\N	0	199308	0	127783003	4133840		
55943	5132	3006322	1972-12-24	1972-12-24 00:00:00	1972-12-24	5001	0	\N	0	0	\N	\N	0	341108	0	8331-1	3006322		
1408	124	3000876	1997-03-10	1997-03-10 00:00:00	1997-03-10	5001	0	\N	0	0	\N	\N	0	8325	0	6082-2	3000876		
56295	1718	4024958	1976-04-16	1976-04-16 00:00:00	1976-04-16	5001	0	\N	0	0	\N	\N	0	114842	0	117015009	4024958		
102401	3147	4133840	1972-02-14	1972-02-14 00:00:00	1972-02-14	5001	0	\N	0	0	\N	\N	0	209418	0	127783003	4133840		
3088	96	4052083	1935-03-06	1935-03-06 00:00:00	1935-03-06	5001	0	\N	0	0	\N	\N	0	6542	0	23426006	4052083		
36971	3399	3014599	1983-12-17	1983-12-17 00:00:00	1983-12-17	5001	0	\N	0	0	\N	\N	0	225486	0	6106-9	3014599		
113879	3513	4024958	2002-10-17	2002-10-17 00:00:00	2002-10-17	5001	0	\N	0	0	\N	\N	0	233142	0	117015009	4024958		
52924	4859	3035995	1971-06-05	1971-06-05 00:00:00	1971-06-05	5001	0	\N	0	0	\N	\N	0	323226	0	6768-6	3035995		
47006	1435	4052083	1967-12-16	1967-12-16 00:00:00	1967-12-16	5001	0	\N	0	0	\N	\N	0	95558	0	23426006	4052083		
27805	2559	3027231	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	169525	0	6276-0	3027231		
62082	1903	4024958	2010-07-16	2010-07-16 00:00:00	2010-07-16	5001	0	\N	0	0	\N	\N	0	126700	0	117015009	4024958		
49541	4506	40758406	2012-11-19	2012-11-19 00:00:00	2012-11-19	5001	0	\N	0	0	\N	\N	0	300173	0	55277-8	40758406		
151003	4628	4024958	1969-07-27	1969-07-27 00:00:00	1969-07-27	5001	0	\N	0	0	\N	\N	0	308308	0	117015009	4024958		
39366	3639	3006322	1930-06-19	1930-06-19 00:00:00	1930-06-19	5001	0	\N	0	0	\N	\N	0	242030	0	8331-1	3006322		
34195	3117	3051031	2002-04-21	2002-04-21 00:00:00	2002-04-21	5001	0	\N	0	0	\N	\N	0	207372	0	46240-8	3051031		
34018	3105	3006322	2018-03-31	2018-03-31 00:00:00	2018-03-31	5001	0	\N	0	0	\N	\N	0	206502	0	8331-1	3006322		
42436	3916	3027231	1991-10-09	1991-10-09 00:00:00	1991-10-09	5001	0	\N	0	0	\N	\N	0	260266	0	6276-0	3027231		
2110	191	3006322	1923-05-19	1923-05-19 00:00:00	1923-05-19	5001	0	\N	0	0	\N	\N	0	13054	0	8331-1	3006322		
27219	2525	3006322	1987-06-28	1987-06-28 00:00:00	1987-06-28	5001	0	\N	0	0	\N	\N	0	166968	0	8331-1	3006322		
8382	789	3006322	1998-09-19	1998-09-19 00:00:00	1998-09-19	5001	0	\N	0	0	\N	\N	0	52494	0	8331-1	3006322		
27387	2540	40766240	1967-02-03	1967-02-03 00:00:00	1967-02-03	5001	0	\N	0	0	\N	\N	0	167938	0	63513-6	40766240		
11923	1137	40758406	1984-02-03	1984-02-03 00:00:00	1984-02-03	5001	0	\N	0	0	\N	\N	0	74981	0	55277-8	40758406		
28520	883	4024958	1993-01-03	1993-01-03 00:00:00	1993-01-03	5001	0	\N	0	0	\N	\N	0	58822	0	117015009	4024958		
13924	1309	3015632	1994-03-21	1994-03-21 00:00:00	1994-03-21	5001	0	\N	0	0	\N	\N	0	86444	0	2028-9	3015632		
56915	1739	4052083	1985-06-13	1985-06-13 00:00:00	1985-06-13	5001	0	\N	0	0	\N	\N	0	116210	0	23426006	4052083		
32198	2925	3000876	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	195100	0	6082-2	3000876		
47935	4390	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	291892	0	6082-2	3000876		
36795	3376	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	224029	0	6082-2	3000876		
15592	1426	3006322	1970-07-09	1970-07-09 00:00:00	1970-07-09	5001	0	\N	0	0	\N	\N	0	94817	0	8331-1	3006322		
26144	817	4024958	1970-06-30	1970-06-30 00:00:00	1970-06-30	5001	0	\N	0	0	\N	\N	0	54161	0	117015009	4024958		
37945	3505	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	232469	0	7258-7	3001488		
49282	4501	40766240	1974-08-27	1974-08-27 00:00:00	1974-08-27	5001	0	\N	0	0	\N	\N	0	299682	0	63513-6	40766240		
20226	1852	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	123986	0	6248-9	3015076		
31583	2892	3051031	1984-01-25	1984-01-25 00:00:00	1984-01-25	5001	0	\N	0	0	\N	\N	0	192412	0	46240-8	3051031		
53060	4873	3006322	2017-11-16	2017-11-16 00:00:00	2017-11-16	5001	0	\N	0	0	\N	\N	0	324097	0	8331-1	3006322		
33416	3020	3011505	2008-01-09	2008-01-09 00:00:00	2008-01-09	5001	0	\N	0	0	\N	\N	0	201408	0	19926-5	3011505		
44751	4130	40758406	1995-05-11	1995-05-11 00:00:00	1995-05-11	5001	0	\N	0	0	\N	\N	0	274608	0	55277-8	40758406		
16492	1505	40758406	1983-10-28	1983-10-28 00:00:00	1983-10-28	5001	0	\N	0	0	\N	\N	0	100314	0	55277-8	40758406		
51147	4675	3006322	2001-08-31	2001-08-31 00:00:00	2001-08-31	5001	0	\N	0	0	\N	\N	0	311553	0	8331-1	3006322		
40375	3752	40758406	1994-05-27	1994-05-27 00:00:00	1994-05-27	5001	0	\N	0	0	\N	\N	0	249354	0	55277-8	40758406		
55332	5065	3006322	1984-05-16	1984-05-16 00:00:00	1984-05-16	5001	0	\N	0	0	\N	\N	0	336732	0	8331-1	3006322		
116296	3582	4133840	2009-06-14	2009-06-14 00:00:00	2009-06-14	5001	0	\N	0	0	\N	\N	0	238133	0	127783003	4133840		
51908	4761	3001247	1984-05-29	1984-05-29 00:00:00	1984-05-29	5001	0	\N	0	0	\N	\N	0	317259	0	6085-5	3001247		
50332	1529	4052083	1996-12-19	1996-12-19 00:00:00	1996-12-19	5001	0	\N	0	0	\N	\N	0	102303	0	23426006	4052083		
126217	3887	4024958	1957-09-20	1957-09-20 00:00:00	1957-09-20	5001	0	\N	0	0	\N	\N	0	258401	0	117015009	4024958		
122635	3783	4024958	1946-06-05	1946-06-05 00:00:00	1946-06-05	5001	0	\N	0	0	\N	\N	0	251386	0	117015009	4024958		
26808	2477	3006322	2010-11-09	2010-11-09 00:00:00	2010-11-09	5001	0	\N	0	0	\N	\N	0	164122	0	8331-1	3006322		
73223	2250	4052083	1965-12-03	1965-12-03 00:00:00	1965-12-03	5001	0	\N	0	0	\N	\N	0	149627	0	23426006	4052083		
40216	3744	3006734	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	248741	0	6189-5	3006734		
20003	1837	3006322	1974-03-27	1974-03-27 00:00:00	1974-03-27	5001	0	\N	0	0	\N	\N	0	122668	0	8331-1	3006322		
49688	4520	3011505	1996-02-03	1996-02-03 00:00:00	1996-02-03	5001	0	\N	0	0	\N	\N	0	300939	0	19926-5	3011505		
66950	2056	4024958	2019-02-21	2019-02-21 00:00:00	2019-02-21	5001	0	\N	0	0	\N	\N	0	136745	0	117015009	4024958		
74	2	3011505	1994-06-21	1994-06-21 00:00:00	1994-06-21	5001	0	\N	0	0	\N	\N	0	133	0	19926-5	3011505		
26863	2485	3006322	1991-03-04	1991-03-04 00:00:00	1991-03-04	5001	0	\N	0	0	\N	\N	0	164589	0	8331-1	3006322		
53851	4935	3012494	1985-10-11	1985-10-11 00:00:00	1985-10-11	5001	0	\N	0	0	\N	\N	0	328074	0	6206-7	3012494		
21166	1956	3036780	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	130141	0	6095-4	3036780		
156840	4822	4052083	1947-10-26	1947-10-26 00:00:00	1947-10-26	5001	0	\N	0	0	\N	\N	0	320739	0	23426006	4052083		
156874	4822	4133840	2011-12-14	2011-12-14 00:00:00	2011-12-14	5001	0	\N	0	0	\N	\N	0	320719	0	127783003	4133840		
1769	155	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	10629	0	6075-6	3005136		
34414	3135	3006322	1991-04-05	1991-04-05 00:00:00	1991-04-05	5001	0	\N	0	0	\N	\N	0	208669	0	8331-1	3006322		
28691	887	4024958	1992-10-17	1992-10-17 00:00:00	1992-10-17	5001	0	\N	0	0	\N	\N	0	59111	0	117015009	4024958		
12094	388	4024958	1968-12-31	1968-12-31 00:00:00	1968-12-31	5001	0	\N	0	0	\N	\N	0	25553	0	117015009	4024958		
97671	2986	4133840	2008-03-04	2008-03-04 00:00:00	2008-03-04	5001	0	\N	0	0	\N	\N	0	199296	0	127783003	4133840		
23406	733	4024958	1978-06-15	1978-06-15 00:00:00	1978-06-15	5001	0	\N	0	0	\N	\N	0	48661	0	117015009	4024958		
1409	124	3005136	1997-03-10	1997-03-10 00:00:00	1997-03-10	5001	0	\N	0	0	\N	\N	0	8325	0	6075-6	3005136		
56299	1718	4052083	1991-10-27	1991-10-27 00:00:00	1991-10-27	5001	0	\N	0	0	\N	\N	0	114851	0	23426006	4052083		
102404	3147	4133840	2010-04-26	2010-04-26 00:00:00	2010-04-26	5001	0	\N	0	0	\N	\N	0	209389	0	127783003	4133840		
3091	96	4133840	1974-12-28	1974-12-28 00:00:00	1974-12-28	5001	0	\N	0	0	\N	\N	0	6479	0	127783003	4133840		
36972	3399	3006322	1987-01-30	1987-01-30 00:00:00	1987-01-30	5001	0	\N	0	0	\N	\N	0	225487	0	8331-1	3006322		
113885	3513	4024958	1979-04-24	1979-04-24 00:00:00	1979-04-24	5001	0	\N	0	0	\N	\N	0	233128	0	117015009	4024958		
52925	4859	3000963	1971-06-05	1971-06-05 00:00:00	1971-06-05	5001	0	\N	0	0	\N	\N	0	323226	0	718-7	3000963		
47012	1435	4024958	1976-08-21	1976-08-21 00:00:00	1976-08-21	5001	0	\N	0	0	\N	\N	0	95547	0	117015009	4024958		
27806	2559	3012494	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	169525	0	6206-7	3012494		
62083	1903	4052083	1981-12-30	1981-12-30 00:00:00	1981-12-30	5001	0	\N	0	0	\N	\N	0	126673	0	23426006	4052083		
49542	4506	40766240	2012-11-19	2012-11-19 00:00:00	2012-11-19	5001	0	\N	0	0	\N	\N	0	300173	0	63513-6	40766240		
36573	1136	4024958	2001-10-18	2001-10-18 00:00:00	2001-10-18	5001	0	\N	0	0	\N	\N	0	74869	0	117015009	4024958		
39367	3639	3006322	1973-01-02	1973-01-02 00:00:00	1973-01-02	5001	0	\N	0	0	\N	\N	0	242157	0	8331-1	3006322		
34197	3117	46235214	2002-05-21	2002-05-21 00:00:00	2002-05-21	5001	0	\N	0	0	\N	\N	0	207390	0	76690-7	46235214		
34019	3106	3006322	1963-07-03	1963-07-03 00:00:00	1963-07-03	5001	0	\N	0	0	\N	\N	0	206567	0	8331-1	3006322		
42437	3916	3001488	1991-10-09	1991-10-09 00:00:00	1991-10-09	5001	0	\N	0	0	\N	\N	0	260266	0	7258-7	3001488		
2111	191	3006322	1962-05-24	1962-05-24 00:00:00	1962-05-24	5001	0	\N	0	0	\N	\N	0	13023	0	8331-1	3006322		
27220	2525	3006322	2014-03-28	2014-03-28 00:00:00	2014-03-28	5001	0	\N	0	0	\N	\N	0	166955	0	8331-1	3006322		
8387	793	3006322	1980-04-15	1980-04-15 00:00:00	1980-04-15	5001	0	\N	0	0	\N	\N	0	52615	0	8331-1	3006322		
38665	3571	3006322	1977-05-28	1977-05-28 00:00:00	1977-05-28	5001	0	\N	0	0	\N	\N	0	237378	0	8331-1	3006322		
11924	1137	46235214	1984-05-03	1984-05-03 00:00:00	1984-05-03	5001	0	\N	0	0	\N	\N	0	74983	0	76690-7	46235214		
28521	883	4052083	2008-06-28	2008-06-28 00:00:00	2008-06-28	5001	0	\N	0	0	\N	\N	0	58777	0	23426006	4052083		
13925	1309	3023103	1994-03-21	1994-03-21 00:00:00	1994-03-21	5001	0	\N	0	0	\N	\N	0	86444	0	2823-3	3023103		
137196	4226	4133840	2016-02-07	2016-02-07 00:00:00	2016-02-07	5001	0	\N	0	0	\N	\N	0	280710	0	127783003	4133840		
32199	2925	3036780	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	195100	0	6095-4	3036780		
47936	4390	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	291892	0	6246-3	3021226		
36796	3376	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	224029	0	6095-4	3036780		
15593	1426	3006322	1970-03-30	1970-03-30 00:00:00	1970-03-30	5001	0	\N	0	0	\N	\N	0	94806	0	8331-1	3006322		
26146	817	4052083	2008-12-03	2008-12-03 00:00:00	2008-12-03	5001	0	\N	0	0	\N	\N	0	54094	0	23426006	4052083		
37946	3505	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	232469	0	6189-5	3006734		
49284	4501	3051031	1974-08-27	1974-08-27 00:00:00	1974-08-27	5001	0	\N	0	0	\N	\N	0	299682	0	46240-8	3051031		
20227	1852	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	123986	0	6273-7	3006451		
31584	2892	3006322	1981-05-24	1981-05-24 00:00:00	1981-05-24	5001	0	\N	0	0	\N	\N	0	192423	0	8331-1	3006322		
53061	4873	3006322	2009-09-07	2009-09-07 00:00:00	2009-09-07	5001	0	\N	0	0	\N	\N	0	324128	0	8331-1	3006322		
33417	3020	3011505	2009-01-14	2009-01-14 00:00:00	2009-01-14	5001	0	\N	0	0	\N	\N	0	201432	0	19926-5	3011505		
44752	4130	3051031	1995-06-10	1995-06-10 00:00:00	1995-06-10	5001	0	\N	0	0	\N	\N	0	274644	0	46240-8	3051031		
16494	1505	40758406	1983-09-28	1983-09-28 00:00:00	1983-09-28	5001	0	\N	0	0	\N	\N	0	100385	0	55277-8	40758406		
51148	4675	3006322	2009-02-02	2009-02-02 00:00:00	2009-02-02	5001	0	\N	0	0	\N	\N	0	311555	0	8331-1	3006322		
40377	3752	40766240	1994-05-27	1994-05-27 00:00:00	1994-05-27	5001	0	\N	0	0	\N	\N	0	249354	0	63513-6	40766240		
55333	5065	3006322	1984-11-26	1984-11-26 00:00:00	1984-11-26	5001	0	\N	0	0	\N	\N	0	336720	0	8331-1	3006322		
116301	3582	4133840	2008-06-08	2008-06-08 00:00:00	2008-06-08	5001	0	\N	0	0	\N	\N	0	238163	0	127783003	4133840		
51909	4761	3015076	1984-05-29	1984-05-29 00:00:00	1984-05-29	5001	0	\N	0	0	\N	\N	0	317259	0	6248-9	3015076		
50344	1529	4024958	1994-02-21	1994-02-21 00:00:00	1994-02-21	5001	0	\N	0	0	\N	\N	0	102359	0	117015009	4024958		
126243	3889	4052083	1943-11-12	1943-11-12 00:00:00	1943-11-12	5001	0	\N	0	0	\N	\N	0	258496	0	23426006	4052083		
122671	3783	4052083	2003-10-06	2003-10-06 00:00:00	2003-10-06	5001	0	\N	0	0	\N	\N	0	251303	0	23426006	4052083		
26809	2477	3006322	2015-01-30	2015-01-30 00:00:00	2015-01-30	5001	0	\N	0	0	\N	\N	0	164166	0	8331-1	3006322		
73225	2250	4024958	1958-12-24	1958-12-24 00:00:00	1958-12-24	5001	0	\N	0	0	\N	\N	0	149663	0	117015009	4024958		
40217	3744	3020655	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	248741	0	6844-5	3020655		
20004	1837	3006322	1973-11-14	1973-11-14 00:00:00	1973-11-14	5001	0	\N	0	0	\N	\N	0	122726	0	8331-1	3006322		
49689	4520	3011505	1995-01-28	1995-01-28 00:00:00	1995-01-28	5001	0	\N	0	0	\N	\N	0	300961	0	19926-5	3011505		
32221	2925	3005136	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	195093	0	6075-6	3005136		
75	2	3006322	1995-04-18	1995-04-18 00:00:00	1995-04-18	5001	0	\N	0	0	\N	\N	0	92	0	8331-1	3006322		
26864	2485	3006322	1937-04-10	1937-04-10 00:00:00	1937-04-10	5001	0	\N	0	0	\N	\N	0	164672	0	8331-1	3006322		
53852	4935	3036780	1985-10-11	1985-10-11 00:00:00	1985-10-11	5001	0	\N	0	0	\N	\N	0	328074	0	6095-4	3036780		
21167	1956	3015076	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	130141	0	6248-9	3015076		
156841	4822	4133840	2018-06-13	2018-06-13 00:00:00	2018-06-13	5001	0	\N	0	0	\N	\N	0	320708	0	127783003	4133840		
156876	4822	4133840	2013-12-25	2013-12-25 00:00:00	2013-12-25	5001	0	\N	0	0	\N	\N	0	320720	0	127783003	4133840		
1770	155	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	10629	0	6206-7	3012494		
34415	3135	3006322	1970-08-30	1970-08-30 00:00:00	1970-08-30	5001	0	\N	0	0	\N	\N	0	208681	0	8331-1	3006322		
103259	3176	4024958	2012-03-03	2012-03-03 00:00:00	2012-03-03	5001	0	\N	0	0	\N	\N	0	211100	0	117015009	4024958		
12098	388	4052083	1994-08-16	1994-08-16 00:00:00	1994-08-16	5001	0	\N	0	0	\N	\N	0	25526	0	23426006	4052083		
97674	2986	4133840	2003-02-04	2003-02-04 00:00:00	2003-02-04	5001	0	\N	0	0	\N	\N	0	199315	0	127783003	4133840		
23417	733	4024958	1947-09-28	1947-09-28 00:00:00	1947-09-28	5001	0	\N	0	0	\N	\N	0	48679	0	117015009	4024958		
1410	124	3014599	1997-03-10	1997-03-10 00:00:00	1997-03-10	5001	0	\N	0	0	\N	\N	0	8325	0	6106-9	3014599		
56302	1718	4024958	1982-11-23	1982-11-23 00:00:00	1982-11-23	5001	0	\N	0	0	\N	\N	0	114850	0	117015009	4024958		
102406	3147	4133840	2008-04-14	2008-04-14 00:00:00	2008-04-14	5001	0	\N	0	0	\N	\N	0	209388	0	127783003	4133840		
3094	96	4133840	1977-01-08	1977-01-08 00:00:00	1977-01-08	5001	0	\N	0	0	\N	\N	0	6480	0	127783003	4133840		
36973	3399	3014599	1999-08-17	1999-08-17 00:00:00	1999-08-17	5001	0	\N	0	0	\N	\N	0	225448	0	6106-9	3014599		
113887	3514	4024958	1987-01-04	1987-01-04 00:00:00	1987-01-04	5001	0	\N	0	0	\N	\N	0	233215	0	117015009	4024958		
52926	4859	3026361	1971-06-05	1971-06-05 00:00:00	1971-06-05	5001	0	\N	0	0	\N	\N	0	323226	0	26453-1	3026361		
47024	1435	4052083	1980-10-27	1980-10-27 00:00:00	1980-10-27	5001	0	\N	0	0	\N	\N	0	95598	0	23426006	4052083		
27807	2559	3020655	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	169525	0	6844-5	3020655		
62093	1903	4052083	1971-03-05	1971-03-05 00:00:00	1971-03-05	5001	0	\N	0	0	\N	\N	0	126699	0	23426006	4052083		
49544	4506	46235214	2012-11-19	2012-11-19 00:00:00	2012-11-19	5001	0	\N	0	0	\N	\N	0	300173	0	76690-7	46235214		
36576	1136	4052083	1974-08-28	1974-08-28 00:00:00	1974-08-28	5001	0	\N	0	0	\N	\N	0	74825	0	23426006	4052083		
39369	3639	3006322	1979-01-14	1979-01-14 00:00:00	1979-01-14	5001	0	\N	0	0	\N	\N	0	242031	0	8331-1	3006322		
34199	3117	40766240	2002-05-21	2002-05-21 00:00:00	2002-05-21	5001	0	\N	0	0	\N	\N	0	207390	0	63513-6	40766240		
34020	3106	3006322	2010-05-12	2010-05-12 00:00:00	2010-05-12	5001	0	\N	0	0	\N	\N	0	206601	0	8331-1	3006322		
42438	3916	3036780	1991-10-09	1991-10-09 00:00:00	1991-10-09	5001	0	\N	0	0	\N	\N	0	260266	0	6095-4	3036780		
2113	191	3011505	1998-10-20	1998-10-20 00:00:00	1998-10-20	5001	0	\N	0	0	\N	\N	0	13108	0	19926-5	3011505		
27221	2526	3006322	1982-05-16	1982-05-16 00:00:00	1982-05-16	5001	0	\N	0	0	\N	\N	0	166990	0	8331-1	3006322		
8388	793	3006322	1980-03-06	1980-03-06 00:00:00	1980-03-06	5001	0	\N	0	0	\N	\N	0	52623	0	8331-1	3006322		
38667	3572	3006322	1970-12-04	1970-12-04 00:00:00	1970-12-04	5001	0	\N	0	0	\N	\N	0	237450	0	8331-1	3006322		
11925	1137	40766240	1984-05-03	1984-05-03 00:00:00	1984-05-03	5001	0	\N	0	0	\N	\N	0	74983	0	63513-6	40766240		
28522	883	4024958	2005-04-26	2005-04-26 00:00:00	2005-04-26	5001	0	\N	0	0	\N	\N	0	58795	0	117015009	4024958		
13926	1309	3013682	1994-03-21	1994-03-21 00:00:00	1994-03-21	5001	0	\N	0	0	\N	\N	0	86444	0	3094-0	3013682		
137197	4226	4024958	1974-08-02	1974-08-02 00:00:00	1974-08-02	5001	0	\N	0	0	\N	\N	0	280651	0	117015009	4024958		
32200	2925	3015076	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	195100	0	6248-9	3015076		
47937	4390	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	291892	0	6206-7	3012494		
36797	3376	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	224029	0	6158-0	3019406		
15594	1427	3006322	1957-11-29	1957-11-29 00:00:00	1957-11-29	5001	0	\N	0	0	\N	\N	0	94951	0	8331-1	3006322		
26147	817	4024958	1967-05-25	1967-05-25 00:00:00	1967-05-25	5001	0	\N	0	0	\N	\N	0	54144	0	117015009	4024958		
37947	3505	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	232469	0	6082-2	3000876		
49286	4501	46235214	1974-08-27	1974-08-27 00:00:00	1974-08-27	5001	0	\N	0	0	\N	\N	0	299682	0	76690-7	46235214		
31505	2886	3006322	1959-12-28	1959-12-28 00:00:00	1959-12-28	5001	0	\N	0	0	\N	\N	0	191955	0	8331-1	3006322		
31585	2892	3006322	2015-04-09	2015-04-09 00:00:00	2015-04-09	5001	0	\N	0	0	\N	\N	0	192414	0	8331-1	3006322		
53062	4873	3006322	1980-11-25	1980-11-25 00:00:00	1980-11-25	5001	0	\N	0	0	\N	\N	0	324104	0	8331-1	3006322		
33418	3022	3006322	1975-04-24	1975-04-24 00:00:00	1975-04-24	5001	0	\N	0	0	\N	\N	0	201491	0	8331-1	3006322		
44754	4130	46235214	1995-06-10	1995-06-10 00:00:00	1995-06-10	5001	0	\N	0	0	\N	\N	0	274644	0	76690-7	46235214		
16495	1505	46235214	1983-09-28	1983-09-28 00:00:00	1983-09-28	5001	0	\N	0	0	\N	\N	0	100385	0	76690-7	46235214		
51149	4675	3006322	1986-06-09	1986-06-09 00:00:00	1986-06-09	5001	0	\N	0	0	\N	\N	0	311552	0	8331-1	3006322		
40379	3754	3006322	1973-07-17	1973-07-17 00:00:00	1973-07-17	5001	0	\N	0	0	\N	\N	0	249444	0	8331-1	3006322		
55335	5065	3006322	1970-12-04	1970-12-04 00:00:00	1970-12-04	5001	0	\N	0	0	\N	\N	0	336739	0	8331-1	3006322		
116305	3582	4024958	1998-03-17	1998-03-17 00:00:00	1998-03-17	5001	0	\N	0	0	\N	\N	0	238091	0	117015009	4024958		
51910	4761	3006451	1984-05-29	1984-05-29 00:00:00	1984-05-29	5001	0	\N	0	0	\N	\N	0	317259	0	6273-7	3006451		
77405	2373	4024958	1957-06-14	1957-06-14 00:00:00	1957-06-14	5001	0	\N	0	0	\N	\N	0	157953	0	117015009	4024958		
126250	3889	4052083	1964-02-23	1964-02-23 00:00:00	1964-02-23	5001	0	\N	0	0	\N	\N	0	258477	0	23426006	4052083		
122677	3783	4052083	1969-03-21	1969-03-21 00:00:00	1969-03-21	5001	0	\N	0	0	\N	\N	0	251367	0	23426006	4052083		
26810	2477	3006322	1993-10-01	1993-10-01 00:00:00	1993-10-01	5001	0	\N	0	0	\N	\N	0	164209	0	8331-1	3006322		
73229	2250	4052083	2007-10-14	2007-10-14 00:00:00	2007-10-14	5001	0	\N	0	0	\N	\N	0	149665	0	23426006	4052083		
40218	3744	3012494	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	248741	0	6206-7	3012494		
20005	1837	3006322	1962-09-04	1962-09-04 00:00:00	1962-09-04	5001	0	\N	0	0	\N	\N	0	122734	0	8331-1	3006322		
49691	4520	3011505	1986-12-13	1986-12-13 00:00:00	1986-12-13	5001	0	\N	0	0	\N	\N	0	300925	0	19926-5	3011505		
32222	2925	3001488	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	195093	0	7258-7	3001488		
76	2	3006322	1960-10-31	1960-10-31 00:00:00	1960-10-31	5001	0	\N	0	0	\N	\N	0	179	0	8331-1	3006322		
26865	2485	3006322	1972-04-02	1972-04-02 00:00:00	1972-04-02	5001	0	\N	0	0	\N	\N	0	164573	0	8331-1	3006322		
53853	4935	3006451	1985-10-11	1985-10-11 00:00:00	1985-10-11	5001	0	\N	0	0	\N	\N	0	328074	0	6273-7	3006451		
21168	1956	3014599	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	130141	0	6106-9	3014599		
156846	4822	4133840	2017-01-11	2017-01-11 00:00:00	2017-01-11	5001	0	\N	0	0	\N	\N	0	320774	0	127783003	4133840		
156877	4822	4133840	2019-06-26	2019-06-26 00:00:00	2019-06-26	5001	0	\N	0	0	\N	\N	0	320775	0	127783003	4133840		
1771	155	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	10629	0	6106-9	3014599		
34416	3135	3006322	1986-02-21	1986-02-21 00:00:00	1986-02-21	5001	0	\N	0	0	\N	\N	0	208667	0	8331-1	3006322		
103267	3176	4024958	1985-09-05	1985-09-05 00:00:00	1985-09-05	5001	0	\N	0	0	\N	\N	0	211165	0	117015009	4024958		
12103	388	4024958	1956-04-07	1956-04-07 00:00:00	1956-04-07	5001	0	\N	0	0	\N	\N	0	25524	0	117015009	4024958		
97675	2986	4133840	2000-01-18	2000-01-18 00:00:00	2000-01-18	5001	0	\N	0	0	\N	\N	0	199321	0	127783003	4133840		
23419	733	4024958	1956-04-29	1956-04-29 00:00:00	1956-04-29	5001	0	\N	0	0	\N	\N	0	48609	0	117015009	4024958		
1411	124	3006451	1997-03-10	1997-03-10 00:00:00	1997-03-10	5001	0	\N	0	0	\N	\N	0	8325	0	6273-7	3006451		
56304	1718	4024958	1972-07-21	1972-07-21 00:00:00	1972-07-21	5001	0	\N	0	0	\N	\N	0	114848	0	117015009	4024958		
102408	3147	4133840	1973-02-12	1973-02-12 00:00:00	1973-02-12	5001	0	\N	0	0	\N	\N	0	209439	0	127783003	4133840		
3096	96	4133840	1978-01-14	1978-01-14 00:00:00	1978-01-14	5001	0	\N	0	0	\N	\N	0	6491	0	127783003	4133840		
36974	3399	3021226	1999-08-17	1999-08-17 00:00:00	1999-08-17	5001	0	\N	0	0	\N	\N	0	225448	0	6246-3	3021226		
113895	3514	4052083	1994-02-23	1994-02-23 00:00:00	1994-02-23	5001	0	\N	0	0	\N	\N	0	233185	0	23426006	4052083		
52927	4859	3027970	1971-06-05	1971-06-05 00:00:00	1971-06-05	5001	0	\N	0	0	\N	\N	0	323226	0	10834-0	3027970		
47028	1435	4052083	2016-09-11	2016-09-11 00:00:00	2016-09-11	5001	0	\N	0	0	\N	\N	0	95578	0	23426006	4052083		
27808	2559	3023430	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	169525	0	6833-8	3023430		
62101	1903	4052083	1995-09-14	1995-09-14 00:00:00	1995-09-14	5001	0	\N	0	0	\N	\N	0	126657	0	23426006	4052083		
49545	4506	3051031	2012-11-19	2012-11-19 00:00:00	2012-11-19	5001	0	\N	0	0	\N	\N	0	300173	0	46240-8	3051031		
36585	1136	4052083	2003-05-22	2003-05-22 00:00:00	2003-05-22	5001	0	\N	0	0	\N	\N	0	74838	0	23426006	4052083		
39371	3639	3006322	1958-03-05	1958-03-05 00:00:00	1958-03-05	5001	0	\N	0	0	\N	\N	0	242028	0	8331-1	3006322		
34200	3117	40758406	2002-05-21	2002-05-21 00:00:00	2002-05-21	5001	0	\N	0	0	\N	\N	0	207390	0	55277-8	40758406		
34028	3109	3006322	1930-08-22	1930-08-22 00:00:00	1930-08-22	5001	0	\N	0	0	\N	\N	0	206768	0	8331-1	3006322		
42439	3916	3006322	2001-11-20	2001-11-20 00:00:00	2001-11-20	5001	0	\N	0	0	\N	\N	0	260374	0	8331-1	3006322		
2114	191	3006322	1964-02-27	1964-02-27 00:00:00	1964-02-27	5001	0	\N	0	0	\N	\N	0	13072	0	8331-1	3006322		
27223	2528	3006322	1980-10-16	1980-10-16 00:00:00	1980-10-16	5001	0	\N	0	0	\N	\N	0	167106	0	8331-1	3006322		
8391	795	3006322	1956-10-18	1956-10-18 00:00:00	1956-10-18	5001	0	\N	0	0	\N	\N	0	52748	0	8331-1	3006322		
38668	3573	3006322	1941-07-02	1941-07-02 00:00:00	1941-07-02	5001	0	\N	0	0	\N	\N	0	237517	0	8331-1	3006322		
11927	1137	3051031	1984-05-03	1984-05-03 00:00:00	1984-05-03	5001	0	\N	0	0	\N	\N	0	74983	0	46240-8	3051031		
28534	884	4052083	1985-08-21	1985-08-21 00:00:00	1985-08-21	5001	0	\N	0	0	\N	\N	0	58839	0	23426006	4052083		
13927	1309	3014576	1994-03-21	1994-03-21 00:00:00	1994-03-21	5001	0	\N	0	0	\N	\N	0	86444	0	2075-0	3014576		
137202	4226	4133840	2006-01-01	2006-01-01 00:00:00	2006-01-01	5001	0	\N	0	0	\N	\N	0	280709	0	127783003	4133840		
32201	2925	3012494	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	195100	0	6206-7	3012494		
47938	4390	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	291892	0	6158-0	3019406		
36798	3376	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	224029	0	6075-6	3005136		
15595	1427	3006322	1978-06-24	1978-06-24 00:00:00	1978-06-24	5001	0	\N	0	0	\N	\N	0	94953	0	8331-1	3006322		
161495	4960	4052083	1930-09-03	1930-09-03 00:00:00	1930-09-03	5001	0	\N	0	0	\N	\N	0	329655	0	23426006	4052083		
37948	3505	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	232469	0	6158-0	3019406		
49287	4501	40758406	1974-08-27	1974-08-27 00:00:00	1974-08-27	5001	0	\N	0	0	\N	\N	0	299682	0	55277-8	40758406		
31506	2886	3006322	2017-11-06	2017-11-06 00:00:00	2017-11-06	5001	0	\N	0	0	\N	\N	0	191989	0	8331-1	3006322		
31586	2892	3006322	1975-08-16	1975-08-16 00:00:00	1975-08-16	5001	0	\N	0	0	\N	\N	0	192422	0	8331-1	3006322		
53063	4874	3006322	1995-11-30	1995-11-30 00:00:00	1995-11-30	5001	0	\N	0	0	\N	\N	0	324162	0	8331-1	3006322		
33419	3022	3006322	1990-05-20	1990-05-20 00:00:00	1990-05-20	5001	0	\N	0	0	\N	\N	0	201444	0	8331-1	3006322		
44755	4130	40758406	1995-06-10	1995-06-10 00:00:00	1995-06-10	5001	0	\N	0	0	\N	\N	0	274644	0	55277-8	40758406		
16496	1505	3051031	1983-09-28	1983-09-28 00:00:00	1983-09-28	5001	0	\N	0	0	\N	\N	0	100385	0	46240-8	3051031		
51150	4675	3049273	1991-10-20	1991-10-20 00:00:00	1991-10-20	5001	0	\N	0	0	\N	\N	0	311565	0	38265-5	3049273		
40380	3754	3000876	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	249539	0	6082-2	3000876		
55336	5065	3006322	2000-07-31	2000-07-31 00:00:00	2000-07-31	5001	0	\N	0	0	\N	\N	0	336703	0	8331-1	3006322		
116306	3582	4133840	2014-07-13	2014-07-13 00:00:00	2014-07-13	5001	0	\N	0	0	\N	\N	0	238106	0	127783003	4133840		
29154	2685	3011505	1994-12-08	1994-12-08 00:00:00	1994-12-08	5001	0	\N	0	0	\N	\N	0	177929	0	19926-5	3011505		
77416	2373	4052083	1992-12-01	1992-12-01 00:00:00	1992-12-01	5001	0	\N	0	0	\N	\N	0	157900	0	23426006	4052083		
126257	3889	4024958	1939-04-07	1939-04-07 00:00:00	1939-04-07	5001	0	\N	0	0	\N	\N	0	258495	0	117015009	4024958		
122686	3784	4133840	1993-08-24	1993-08-24 00:00:00	1993-08-24	5001	0	\N	0	0	\N	\N	0	251464	0	127783003	4133840		
26811	2477	3006322	2009-01-05	2009-01-05 00:00:00	2009-01-05	5001	0	\N	0	0	\N	\N	0	164212	0	8331-1	3006322		
73230	2250	4024958	1990-03-25	1990-03-25 00:00:00	1990-03-25	5001	0	\N	0	0	\N	\N	0	149696	0	117015009	4024958		
40219	3744	3019406	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	248741	0	6158-0	3019406		
20006	1837	3009542	1970-05-11	1970-05-11 00:00:00	1970-05-11	5001	0	\N	0	0	\N	\N	0	122738	0	20570-8	3009542		
49692	4520	3011505	1982-11-20	1982-11-20 00:00:00	1982-11-20	5001	0	\N	0	0	\N	\N	0	300960	0	19926-5	3011505		
32223	2925	3021226	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	195093	0	6246-3	3021226		
77	2	3011505	2007-09-04	2007-09-04 00:00:00	2007-09-04	5001	0	\N	0	0	\N	\N	0	137	0	19926-5	3011505		
26866	2485	3006322	1959-11-24	1959-11-24 00:00:00	1959-11-24	5001	0	\N	0	0	\N	\N	0	164585	0	8331-1	3006322		
53854	4935	3027231	1985-10-11	1985-10-11 00:00:00	1985-10-11	5001	0	\N	0	0	\N	\N	0	328074	0	6276-0	3027231		
21169	1956	3001488	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	130141	0	7258-7	3001488		
156852	4822	4133840	2018-01-17	2018-01-17 00:00:00	2018-01-17	5001	0	\N	0	0	\N	\N	0	320792	0	127783003	4133840		
156884	4822	4133840	2004-11-03	2004-11-03 00:00:00	2004-11-03	5001	0	\N	0	0	\N	\N	0	320789	0	127783003	4133840		
1772	155	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	10629	0	6158-0	3019406		
34417	3135	3006322	1993-05-06	1993-05-06 00:00:00	1993-05-06	5001	0	\N	0	0	\N	\N	0	208648	0	8331-1	3006322		
114564	3529	4024958	1989-05-19	1989-05-19 00:00:00	1989-05-19	5001	0	\N	0	0	\N	\N	0	234440	0	117015009	4024958		
12109	388	4024958	1966-12-03	1966-12-03 00:00:00	1966-12-03	5001	0	\N	0	0	\N	\N	0	25591	0	117015009	4024958		
97677	2986	4133840	2012-03-27	2012-03-27 00:00:00	2012-03-27	5001	0	\N	0	0	\N	\N	0	199317	0	127783003	4133840		
23428	733	4052083	1999-05-04	1999-05-04 00:00:00	1999-05-04	5001	0	\N	0	0	\N	\N	0	48617	0	23426006	4052083		
1412	124	3011505	2011-03-22	2011-03-22 00:00:00	2011-03-22	5001	0	\N	0	0	\N	\N	0	8272	0	19926-5	3011505		
56309	1719	4052083	1973-06-25	1973-06-25 00:00:00	1973-06-25	5001	0	\N	0	0	\N	\N	0	114956	0	23426006	4052083		
102409	3147	4133840	2017-06-05	2017-06-05 00:00:00	2017-06-05	5001	0	\N	0	0	\N	\N	0	209412	0	127783003	4133840		
3098	96	4133840	1990-03-24	1990-03-24 00:00:00	1990-03-24	5001	0	\N	0	0	\N	\N	0	6494	0	127783003	4133840		
36975	3399	3023430	1999-08-17	1999-08-17 00:00:00	1999-08-17	5001	0	\N	0	0	\N	\N	0	225448	0	6833-8	3023430		
113898	3514	4052083	1981-06-14	1981-06-14 00:00:00	1981-06-14	5001	0	\N	0	0	\N	\N	0	233184	0	23426006	4052083		
52928	4859	3016723	1971-06-05	1971-06-05 00:00:00	1971-06-05	5001	0	\N	0	0	\N	\N	0	323226	0	2160-0	3016723		
47029	1435	4052083	2008-11-20	2008-11-20 00:00:00	2008-11-20	5001	0	\N	0	0	\N	\N	0	95549	0	23426006	4052083		
27809	2559	3006322	1982-08-12	1982-08-12 00:00:00	1982-08-12	5001	0	\N	0	0	\N	\N	0	169524	0	8331-1	3006322		
3326	320	3011505	2007-02-25	2007-02-25 00:00:00	2007-02-25	5001	0	\N	0	0	\N	\N	0	21191	0	19926-5	3011505		
49546	4506	3051031	2013-03-19	2013-03-19 00:00:00	2013-03-19	5001	0	\N	0	0	\N	\N	0	300183	0	46240-8	3051031		
36586	1136	4052083	2001-08-21	2001-08-21 00:00:00	2001-08-21	5001	0	\N	0	0	\N	\N	0	74868	0	23426006	4052083		
39375	3641	3049273	1992-11-30	1992-11-30 00:00:00	1992-11-30	5001	0	\N	0	0	\N	\N	0	242315	0	38265-5	3049273		
34201	3117	3051031	2002-05-21	2002-05-21 00:00:00	2002-05-21	5001	0	\N	0	0	\N	\N	0	207390	0	46240-8	3051031		
34030	3109	3006322	1983-09-08	1983-09-08 00:00:00	1983-09-08	5001	0	\N	0	0	\N	\N	0	206831	0	8331-1	3006322		
42440	3917	3006322	1971-04-20	1971-04-20 00:00:00	1971-04-20	5001	0	\N	0	0	\N	\N	0	260498	0	8331-1	3006322		
2115	191	3011505	1991-10-01	1991-10-01 00:00:00	1991-10-01	5001	0	\N	0	0	\N	\N	0	13127	0	19926-5	3011505		
27224	2528	3006322	1970-10-24	1970-10-24 00:00:00	1970-10-24	5001	0	\N	0	0	\N	\N	0	167086	0	8331-1	3006322		
8392	795	3006322	2001-09-30	2001-09-30 00:00:00	2001-09-30	5001	0	\N	0	0	\N	\N	0	52775	0	8331-1	3006322		
38669	3573	3006322	2004-01-12	2004-01-12 00:00:00	2004-01-12	5001	0	\N	0	0	\N	\N	0	237585	0	8331-1	3006322		
11928	1137	40758406	1984-05-03	1984-05-03 00:00:00	1984-05-03	5001	0	\N	0	0	\N	\N	0	74983	0	55277-8	40758406		
28557	884	4024958	1981-10-16	1981-10-16 00:00:00	1981-10-16	5001	0	\N	0	0	\N	\N	0	58940	0	117015009	4024958		
13928	1309	3024731	1994-03-21	1994-03-21 00:00:00	1994-03-21	5001	0	\N	0	0	\N	\N	0	86444	0	30428-7	3024731		
137208	4226	4133840	2015-02-01	2015-02-01 00:00:00	2015-02-01	5001	0	\N	0	0	\N	\N	0	280684	0	127783003	4133840		
32202	2925	3020655	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	195100	0	6844-5	3020655		
47939	4390	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	291892	0	6273-7	3006451		
36799	3376	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	224029	0	6276-0	3027231		
15596	1428	3006322	2004-03-23	2004-03-23 00:00:00	2004-03-23	5001	0	\N	0	0	\N	\N	0	95012	0	8331-1	3006322		
161497	4960	4052083	1918-09-28	1918-09-28 00:00:00	1918-09-28	5001	0	\N	0	0	\N	\N	0	329735	0	23426006	4052083		
49226	4498	3006322	1982-11-04	1982-11-04 00:00:00	1982-11-04	5001	0	\N	0	0	\N	\N	0	299466	0	8331-1	3006322		
49289	4501	40766240	1973-12-30	1973-12-30 00:00:00	1973-12-30	5001	0	\N	0	0	\N	\N	0	299701	0	63513-6	40766240		
31507	2886	3006322	2011-03-04	2011-03-04 00:00:00	2011-03-04	5001	0	\N	0	0	\N	\N	0	191933	0	8331-1	3006322		
31587	2892	3006322	1979-05-12	1979-05-12 00:00:00	1979-05-12	5001	0	\N	0	0	\N	\N	0	192411	0	8331-1	3006322		
53064	4874	3006322	1981-12-27	1981-12-27 00:00:00	1981-12-27	5001	0	\N	0	0	\N	\N	0	324161	0	8331-1	3006322		
33420	3023	3006322	1995-07-15	1995-07-15 00:00:00	1995-07-15	5001	0	\N	0	0	\N	\N	0	201539	0	8331-1	3006322		
44756	4130	40766240	1995-06-10	1995-06-10 00:00:00	1995-06-10	5001	0	\N	0	0	\N	\N	0	274644	0	63513-6	40766240		
16498	1505	40766240	1983-09-28	1983-09-28 00:00:00	1983-09-28	5001	0	\N	0	0	\N	\N	0	100385	0	63513-6	40766240		
51151	4675	3006322	1921-10-19	1921-10-19 00:00:00	1921-10-19	5001	0	\N	0	0	\N	\N	0	311427	0	8331-1	3006322		
40381	3754	3023430	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	249539	0	6833-8	3023430		
55337	5065	3006322	1993-01-26	1993-01-26 00:00:00	1993-01-26	5001	0	\N	0	0	\N	\N	0	336721	0	8331-1	3006322		
116313	3583	4052083	1988-01-26	1988-01-26 00:00:00	1988-01-26	5001	0	\N	0	0	\N	\N	0	238260	0	23426006	4052083		
29155	2685	3011505	1992-11-26	1992-11-26 00:00:00	1992-11-26	5001	0	\N	0	0	\N	\N	0	177928	0	19926-5	3011505		
12067	1146	3049273	2001-09-11	2001-09-11 00:00:00	2001-09-11	5001	0	\N	0	0	\N	\N	0	75753	0	38265-5	3049273		
21243	669	4024958	2014-10-28	2014-10-28 00:00:00	2014-10-28	5001	0	\N	0	0	\N	\N	0	44182	0	117015009	4024958		
122694	3784	4133840	1985-08-06	1985-08-06 00:00:00	1985-08-06	5001	0	\N	0	0	\N	\N	0	251460	0	127783003	4133840		
26812	2477	3006322	2007-04-04	2007-04-04 00:00:00	2007-04-04	5001	0	\N	0	0	\N	\N	0	164181	0	8331-1	3006322		
73239	2250	4052083	1973-02-11	1973-02-11 00:00:00	1973-02-11	5001	0	\N	0	0	\N	\N	0	149695	0	23426006	4052083		
40220	3744	3021226	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	248741	0	6246-3	3021226		
20007	1837	3000963	1970-05-11	1970-05-11 00:00:00	1970-05-11	5001	0	\N	0	0	\N	\N	0	122738	0	718-7	3000963		
49693	4520	3011505	1987-12-19	1987-12-19 00:00:00	1987-12-19	5001	0	\N	0	0	\N	\N	0	300933	0	19926-5	3011505		
32224	2925	3019406	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	195093	0	6158-0	3019406		
78	2	3011505	2006-08-29	2006-08-29 00:00:00	2006-08-29	5001	0	\N	0	0	\N	\N	0	198	0	19926-5	3011505		
26867	2485	3006322	1999-09-29	1999-09-29 00:00:00	1999-09-29	5001	0	\N	0	0	\N	\N	0	164675	0	8331-1	3006322		
53855	4935	3000876	1985-10-11	1985-10-11 00:00:00	1985-10-11	5001	0	\N	0	0	\N	\N	0	328074	0	6082-2	3000876		
21170	1956	3001247	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	130141	0	6085-5	3001247		
6548	615	3023430	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	40960	0	6833-8	3023430		
156886	4822	4133840	2006-11-15	2006-11-15 00:00:00	2006-11-15	5001	0	\N	0	0	\N	\N	0	320790	0	127783003	4133840		
1773	155	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	10629	0	6248-9	3015076		
34424	3137	3006322	1928-06-23	1928-06-23 00:00:00	1928-06-23	5001	0	\N	0	0	\N	\N	0	208851	0	8331-1	3006322		
114574	3529	4024958	1957-12-22	1957-12-22 00:00:00	1957-12-22	5001	0	\N	0	0	\N	\N	0	234439	0	117015009	4024958		
12111	388	4024958	1999-09-04	1999-09-04 00:00:00	1999-09-04	5001	0	\N	0	0	\N	\N	0	25570	0	117015009	4024958		
97681	2986	4133840	2018-05-01	2018-05-01 00:00:00	2018-05-01	5001	0	\N	0	0	\N	\N	0	199306	0	127783003	4133840		
34749	1084	4052083	2004-06-29	2004-06-29 00:00:00	2004-06-29	5001	0	\N	0	0	\N	\N	0	71189	0	23426006	4052083		
1413	124	3006322	1994-10-14	1994-10-14 00:00:00	1994-10-14	5001	0	\N	0	0	\N	\N	0	8242	0	8331-1	3006322		
90825	2804	4052083	1956-09-14	1956-09-14 00:00:00	1956-09-14	5001	0	\N	0	0	\N	\N	0	185844	0	23426006	4052083		
102411	3147	4133840	1992-01-27	1992-01-27 00:00:00	1992-01-27	5001	0	\N	0	0	\N	\N	0	209385	0	127783003	4133840		
3101	96	4133840	1993-04-10	1993-04-10 00:00:00	1993-04-10	5001	0	\N	0	0	\N	\N	0	6528	0	127783003	4133840		
36976	3399	3027231	1999-08-17	1999-08-17 00:00:00	1999-08-17	5001	0	\N	0	0	\N	\N	0	225448	0	6276-0	3027231		
113914	3514	4024958	1978-05-31	1978-05-31 00:00:00	1978-05-31	5001	0	\N	0	0	\N	\N	0	233195	0	117015009	4024958		
52929	4859	3024561	1971-06-05	1971-06-05 00:00:00	1971-06-05	5001	0	\N	0	0	\N	\N	0	323226	0	1751-7	3024561		
47030	1435	4024958	2018-10-16	2018-10-16 00:00:00	2018-10-16	5001	0	\N	0	0	\N	\N	0	95588	0	117015009	4024958		
27810	2559	3006322	2004-06-18	2004-06-18 00:00:00	2004-06-18	5001	0	\N	0	0	\N	\N	0	169582	0	8331-1	3006322		
3327	320	3011505	2000-03-05	2000-03-05 00:00:00	2000-03-05	5001	0	\N	0	0	\N	\N	0	21178	0	19926-5	3011505		
49547	4506	46235214	2013-03-19	2013-03-19 00:00:00	2013-03-19	5001	0	\N	0	0	\N	\N	0	300183	0	76690-7	46235214		
36589	1136	4024958	2009-02-22	2009-02-22 00:00:00	2009-02-22	5001	0	\N	0	0	\N	\N	0	74814	0	117015009	4024958		
39376	3641	3006322	1943-11-18	1943-11-18 00:00:00	1943-11-18	5001	0	\N	0	0	\N	\N	0	242323	0	8331-1	3006322		
34203	3117	3006322	1981-08-01	1981-08-01 00:00:00	1981-08-01	5001	0	\N	0	0	\N	\N	0	207367	0	8331-1	3006322		
34031	3109	3006322	1955-05-07	1955-05-07 00:00:00	1955-05-07	5001	0	\N	0	0	\N	\N	0	206849	0	8331-1	3006322		
42446	3920	3006322	1997-07-27	1997-07-27 00:00:00	1997-07-27	5001	0	\N	0	0	\N	\N	0	260645	0	8331-1	3006322		
2116	191	3011505	1990-09-25	1990-09-25 00:00:00	1990-09-25	5001	0	\N	0	0	\N	\N	0	13120	0	19926-5	3011505		
27225	2528	3006322	2000-05-17	2000-05-17 00:00:00	2000-05-17	5001	0	\N	0	0	\N	\N	0	167111	0	8331-1	3006322		
8393	795	3006322	1940-03-02	1940-03-02 00:00:00	1940-03-02	5001	0	\N	0	0	\N	\N	0	52704	0	8331-1	3006322		
38670	3573	3006322	1946-05-24	1946-05-24 00:00:00	1946-05-24	5001	0	\N	0	0	\N	\N	0	237577	0	8331-1	3006322		
11930	1137	3006322	1973-11-19	1973-11-19 00:00:00	1973-11-19	5001	0	\N	0	0	\N	\N	0	74880	0	8331-1	3006322		
28563	884	4052083	2017-06-16	2017-06-16 00:00:00	2017-06-16	5001	0	\N	0	0	\N	\N	0	58913	0	23426006	4052083		
13929	1309	3035995	1994-03-21	1994-03-21 00:00:00	1994-03-21	5001	0	\N	0	0	\N	\N	0	86444	0	6768-6	3035995		
137210	4226	4133840	2008-01-06	2008-01-06 00:00:00	2008-01-06	5001	0	\N	0	0	\N	\N	0	280682	0	127783003	4133840		
32203	2925	3023430	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	195100	0	6833-8	3023430		
47940	4390	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	291892	0	6095-4	3036780		
36800	3376	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	224029	0	6246-3	3021226		
15597	1428	3049273	1998-06-05	1998-06-05 00:00:00	1998-06-05	5001	0	\N	0	0	\N	\N	0	95043	0	38265-5	3049273		
161507	4960	4024958	1916-10-08	1916-10-08 00:00:00	1916-10-08	5001	0	\N	0	0	\N	\N	0	329734	0	117015009	4024958		
49227	4498	3006322	1978-07-19	1978-07-19 00:00:00	1978-07-19	5001	0	\N	0	0	\N	\N	0	299468	0	8331-1	3006322		
49290	4501	46235214	1973-12-30	1973-12-30 00:00:00	1973-12-30	5001	0	\N	0	0	\N	\N	0	299701	0	76690-7	46235214		
31508	2886	3006322	2004-06-24	2004-06-24 00:00:00	2004-06-24	5001	0	\N	0	0	\N	\N	0	191920	0	8331-1	3006322		
31588	2892	3006322	1980-05-20	1980-05-20 00:00:00	1980-05-20	5001	0	\N	0	0	\N	\N	0	192420	0	8331-1	3006322		
53067	4876	3006322	1977-11-24	1977-11-24 00:00:00	1977-11-24	5001	0	\N	0	0	\N	\N	0	324296	0	8331-1	3006322		
33421	3025	3006322	1992-02-08	1992-02-08 00:00:00	1992-02-08	5001	0	\N	0	0	\N	\N	0	201595	0	8331-1	3006322		
44758	4131	3006322	1996-09-07	1996-09-07 00:00:00	1996-09-07	5001	0	\N	0	0	\N	\N	0	274684	0	8331-1	3006322		
16499	1505	3006322	2004-10-18	2004-10-18 00:00:00	2004-10-18	5001	0	\N	0	0	\N	\N	0	100357	0	8331-1	3006322		
51152	4675	3006322	1921-02-11	1921-02-11 00:00:00	1921-02-11	5001	0	\N	0	0	\N	\N	0	311543	0	8331-1	3006322		
40382	3754	3006734	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	249539	0	6189-5	3006734		
55338	5066	3006322	2014-09-10	2014-09-10 00:00:00	2014-09-10	5001	0	\N	0	0	\N	\N	0	336774	0	8331-1	3006322		
49040	4482	3006322	1955-06-07	1955-06-07 00:00:00	1955-06-07	5001	0	\N	0	0	\N	\N	0	298407	0	8331-1	3006322		
29156	2685	3011505	1989-01-12	1989-01-12 00:00:00	1989-01-12	5001	0	\N	0	0	\N	\N	0	177927	0	19926-5	3011505		
12068	1146	3006322	1990-12-26	1990-12-26 00:00:00	1990-12-26	5001	0	\N	0	0	\N	\N	0	75670	0	8331-1	3006322		
21250	669	4052083	1974-04-09	1974-04-09 00:00:00	1974-04-09	5001	0	\N	0	0	\N	\N	0	44141	0	23426006	4052083		
122697	3784	4024958	1972-08-12	1972-08-12 00:00:00	1972-08-12	5001	0	\N	0	0	\N	\N	0	251509	0	117015009	4024958		
26813	2477	3006322	1967-06-10	1967-06-10 00:00:00	1967-06-10	5001	0	\N	0	0	\N	\N	0	164141	0	8331-1	3006322		
35696	1107	4024958	2002-05-30	2002-05-30 00:00:00	2002-05-30	5001	0	\N	0	0	\N	\N	0	72930	0	117015009	4024958		
40221	3744	3000876	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	248741	0	6082-2	3000876		
20008	1837	3006322	2016-11-21	2016-11-21 00:00:00	2016-11-21	5001	0	\N	0	0	\N	\N	0	122717	0	8331-1	3006322		
49694	4520	3011505	1977-10-22	1977-10-22 00:00:00	1977-10-22	5001	0	\N	0	0	\N	\N	0	300913	0	19926-5	3011505		
32225	2925	3000876	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	195093	0	6082-2	3000876		
79	2	3011505	2001-07-31	2001-07-31 00:00:00	2001-07-31	5001	0	\N	0	0	\N	\N	0	89	0	19926-5	3011505		
26868	2485	3006322	2006-10-06	2006-10-06 00:00:00	2006-10-06	5001	0	\N	0	0	\N	\N	0	164648	0	8331-1	3006322		
53856	4935	3005136	1985-10-11	1985-10-11 00:00:00	1985-10-11	5001	0	\N	0	0	\N	\N	0	328074	0	6075-6	3005136		
21171	1956	3027231	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	130141	0	6276-0	3027231		
6549	615	3020655	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	40960	0	6844-5	3020655		
156888	4822	4133840	2003-10-29	2003-10-29 00:00:00	2003-10-29	5001	0	\N	0	0	\N	\N	0	320770	0	127783003	4133840		
1774	155	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	10629	0	6085-5	3001247		
34425	3137	3006322	1919-02-27	1919-02-27 00:00:00	1919-02-27	5001	0	\N	0	0	\N	\N	0	208831	0	8331-1	3006322		
86165	2663	4024958	2004-08-26	2004-08-26 00:00:00	2004-08-26	5001	0	\N	0	0	\N	\N	0	176453	0	117015009	4024958		
12126	390	4052083	1989-10-20	1989-10-20 00:00:00	1989-10-20	5001	0	\N	0	0	\N	\N	0	25654	0	23426006	4052083		
97791	2989	4024958	1962-02-27	1962-02-27 00:00:00	1962-02-27	5001	0	\N	0	0	\N	\N	0	199528	0	117015009	4024958		
34758	1084	4024958	1990-02-14	1990-02-14 00:00:00	1990-02-14	5001	0	\N	0	0	\N	\N	0	71210	0	117015009	4024958		
1414	124	40769189	1987-12-27	1987-12-27 00:00:00	1987-12-27	5001	0	\N	0	0	\N	\N	0	8225	0	66529-9	40769189		
90831	2804	4024958	1959-12-29	1959-12-29 00:00:00	1959-12-29	5001	0	\N	0	0	\N	\N	0	185810	0	117015009	4024958		
102413	3147	4133840	2007-04-09	2007-04-09 00:00:00	2007-04-09	5001	0	\N	0	0	\N	\N	0	209348	0	127783003	4133840		
3102	96	4024958	1927-08-26	1927-08-26 00:00:00	1927-08-26	5001	0	\N	0	0	\N	\N	0	6547	0	117015009	4024958		
36977	3399	3036780	1999-08-17	1999-08-17 00:00:00	1999-08-17	5001	0	\N	0	0	\N	\N	0	225448	0	6095-4	3036780		
113950	3516	4024958	1946-06-25	1946-06-25 00:00:00	1946-06-25	5001	0	\N	0	0	\N	\N	0	233291	0	117015009	4024958		
52930	4859	3028833	1971-06-05	1971-06-05 00:00:00	1971-06-05	5001	0	\N	0	0	\N	\N	0	323226	0	42719-5	3028833		
47035	1435	4024958	1996-12-16	1996-12-16 00:00:00	1996-12-16	5001	0	\N	0	0	\N	\N	0	95548	0	117015009	4024958		
27811	2559	3006322	1968-01-15	1968-01-15 00:00:00	1968-01-15	5001	0	\N	0	0	\N	\N	0	169603	0	8331-1	3006322		
3328	320	3011505	1996-02-25	1996-02-25 00:00:00	1996-02-25	5001	0	\N	0	0	\N	\N	0	21181	0	19926-5	3011505		
49549	4506	40758406	2013-03-19	2013-03-19 00:00:00	2013-03-19	5001	0	\N	0	0	\N	\N	0	300183	0	55277-8	40758406		
36591	1136	4052083	2014-07-08	2014-07-08 00:00:00	2014-07-08	5001	0	\N	0	0	\N	\N	0	74871	0	23426006	4052083		
39377	3641	3006322	1978-02-07	1978-02-07 00:00:00	1978-02-07	5001	0	\N	0	0	\N	\N	0	242338	0	8331-1	3006322		
34204	3117	3006322	1995-05-01	1995-05-01 00:00:00	1995-05-01	5001	0	\N	0	0	\N	\N	0	207377	0	8331-1	3006322		
34032	3109	3006322	1939-09-16	1939-09-16 00:00:00	1939-09-16	5001	0	\N	0	0	\N	\N	0	206733	0	8331-1	3006322		
42447	3920	3006322	1976-07-07	1976-07-07 00:00:00	1976-07-07	5001	0	\N	0	0	\N	\N	0	260634	0	8331-1	3006322		
2118	191	46235214	1963-02-16	1963-02-16 00:00:00	1963-02-16	5001	0	\N	0	0	\N	\N	0	13071	0	76690-7	46235214		
27226	2528	3006322	2005-06-02	2005-06-02 00:00:00	2005-06-02	5001	0	\N	0	0	\N	\N	0	167140	0	8331-1	3006322		
8394	795	3049273	2006-11-01	2006-11-01 00:00:00	2006-11-01	5001	0	\N	0	0	\N	\N	0	52769	0	38265-5	3049273		
38671	3573	3049273	2000-01-24	2000-01-24 00:00:00	2000-01-24	5001	0	\N	0	0	\N	\N	0	237630	0	38265-5	3049273		
11931	1138	3006322	1994-04-04	1994-04-04 00:00:00	1994-04-04	5001	0	\N	0	0	\N	\N	0	75068	0	8331-1	3006322		
154753	4748	4024958	1978-04-25	1978-04-25 00:00:00	1978-04-25	5001	0	\N	0	0	\N	\N	0	316159	0	117015009	4024958		
13930	1309	3004501	1994-03-21	1994-03-21 00:00:00	1994-03-21	5001	0	\N	0	0	\N	\N	0	86444	0	2345-7	3004501		
137214	4226	4133840	2003-12-28	2003-12-28 00:00:00	2003-12-28	5001	0	\N	0	0	\N	\N	0	280662	0	127783003	4133840		
32204	2925	3001247	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	195100	0	6085-5	3001247		
47941	4390	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	291892	0	6833-8	3023430		
36801	3376	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	224029	0	6206-7	3012494		
15598	1428	3006322	1995-11-19	1995-11-19 00:00:00	1995-11-19	5001	0	\N	0	0	\N	\N	0	95047	0	8331-1	3006322		
161517	4960	4024958	1948-03-30	1948-03-30 00:00:00	1948-03-30	5001	0	\N	0	0	\N	\N	0	329717	0	117015009	4024958		
49228	4498	3012494	1978-03-01	1978-03-01 00:00:00	1978-03-01	5001	0	\N	0	0	\N	\N	0	299481	0	6206-7	3012494		
49292	4501	3051031	1973-12-30	1973-12-30 00:00:00	1973-12-30	5001	0	\N	0	0	\N	\N	0	299701	0	46240-8	3051031		
31509	2886	3006322	1983-01-06	1983-01-06 00:00:00	1983-01-06	5001	0	\N	0	0	\N	\N	0	191896	0	8331-1	3006322		
31589	2892	46235214	1983-12-26	1983-12-26 00:00:00	1983-12-26	5001	0	\N	0	0	\N	\N	0	192395	0	76690-7	46235214		
53068	4876	3006322	2009-09-22	2009-09-22 00:00:00	2009-09-22	5001	0	\N	0	0	\N	\N	0	324299	0	8331-1	3006322		
33422	3025	3006322	1994-03-10	1994-03-10 00:00:00	1994-03-10	5001	0	\N	0	0	\N	\N	0	201696	0	8331-1	3006322		
44759	4131	3006322	2011-12-21	2011-12-21 00:00:00	2011-12-21	5001	0	\N	0	0	\N	\N	0	274720	0	8331-1	3006322		
16501	1505	40766240	1983-10-28	1983-10-28 00:00:00	1983-10-28	5001	0	\N	0	0	\N	\N	0	100314	0	63513-6	40766240		
51153	4676	3006322	2015-03-26	2015-03-26 00:00:00	2015-03-26	5001	0	\N	0	0	\N	\N	0	311599	0	8331-1	3006322		
40383	3754	3006451	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	249539	0	6273-7	3006451		
55339	5066	3006322	1982-12-16	1982-12-16 00:00:00	1982-12-16	5001	0	\N	0	0	\N	\N	0	336773	0	8331-1	3006322		
49041	4482	3006322	2017-01-02	2017-01-02 00:00:00	2017-01-02	5001	0	\N	0	0	\N	\N	0	298371	0	8331-1	3006322		
29157	2685	3011505	2005-03-24	2005-03-24 00:00:00	2005-03-24	5001	0	\N	0	0	\N	\N	0	177933	0	19926-5	3011505		
12069	1146	3006322	2004-08-21	2004-08-21 00:00:00	2004-08-21	5001	0	\N	0	0	\N	\N	0	75671	0	8331-1	3006322		
21252	669	4024958	1977-12-03	1977-12-03 00:00:00	1977-12-03	5001	0	\N	0	0	\N	\N	0	44142	0	117015009	4024958		
122702	3784	4052083	1956-07-02	1956-07-02 00:00:00	1956-07-02	5001	0	\N	0	0	\N	\N	0	251455	0	23426006	4052083		
26814	2477	3006322	1963-10-14	1963-10-14 00:00:00	1963-10-14	5001	0	\N	0	0	\N	\N	0	164206	0	8331-1	3006322		
35700	1107	4024958	1930-08-13	1930-08-13 00:00:00	1930-08-13	5001	0	\N	0	0	\N	\N	0	72927	0	117015009	4024958		
40222	3744	3006451	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	248741	0	6273-7	3006451		
20011	1840	3006322	1986-10-02	1986-10-02 00:00:00	1986-10-02	5001	0	\N	0	0	\N	\N	0	122824	0	8331-1	3006322		
49695	4520	3011505	1978-10-28	1978-10-28 00:00:00	1978-10-28	5001	0	\N	0	0	\N	\N	0	300958	0	19926-5	3011505		
32226	2925	3036780	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	195093	0	6095-4	3036780		
80	2	3006322	1985-07-26	1985-07-26 00:00:00	1985-07-26	5001	0	\N	0	0	\N	\N	0	141	0	8331-1	3006322		
26869	2485	3006322	2012-05-21	2012-05-21 00:00:00	2012-05-21	5001	0	\N	0	0	\N	\N	0	164676	0	8331-1	3006322		
53857	4935	3021226	1985-10-11	1985-10-11 00:00:00	1985-10-11	5001	0	\N	0	0	\N	\N	0	328074	0	6246-3	3021226		
21172	1956	3005136	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	130141	0	6075-6	3005136		
6550	615	3001488	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	40960	0	7258-7	3001488		
17907	1626	3000963	1989-12-17	1989-12-17 00:00:00	1989-12-17	5001	0	\N	0	0	\N	\N	0	109189	0	718-7	3000963		
1775	155	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	10629	0	6189-5	3006734		
34426	3137	3006322	1930-04-27	1930-04-27 00:00:00	1930-04-27	5001	0	\N	0	0	\N	\N	0	208823	0	8331-1	3006322		
86231	2666	4024958	1961-11-20	1961-11-20 00:00:00	1961-11-20	5001	0	\N	0	0	\N	\N	0	176605	0	117015009	4024958		
12127	390	4024958	1977-03-29	1977-03-29 00:00:00	1977-03-29	5001	0	\N	0	0	\N	\N	0	25616	0	117015009	4024958		
97822	2991	4052083	1996-04-14	1996-04-14 00:00:00	1996-04-14	5001	0	\N	0	0	\N	\N	0	199632	0	23426006	4052083		
34763	1084	4052083	2010-12-04	2010-12-04 00:00:00	2010-12-04	5001	0	\N	0	0	\N	\N	0	71191	0	23426006	4052083		
1415	124	40769179	1987-12-27	1987-12-27 00:00:00	1987-12-27	5001	0	\N	0	0	\N	\N	0	8225	0	66519-0	40769179		
90839	2804	4052083	1983-08-09	1983-08-09 00:00:00	1983-08-09	5001	0	\N	0	0	\N	\N	0	185825	0	23426006	4052083		
102415	3147	4133840	2006-04-03	2006-04-03 00:00:00	2006-04-03	5001	0	\N	0	0	\N	\N	0	209387	0	127783003	4133840		
3105	96	4133840	1963-06-08	1963-06-08 00:00:00	1963-06-08	5001	0	\N	0	0	\N	\N	0	6563	0	127783003	4133840		
36978	3399	3006734	1999-08-17	1999-08-17 00:00:00	1999-08-17	5001	0	\N	0	0	\N	\N	0	225448	0	6189-5	3006734		
87249	2697	4052083	2004-03-20	2004-03-20 00:00:00	2004-03-20	5001	0	\N	0	0	\N	\N	0	178566	0	23426006	4052083		
16296	1482	3001488	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	98836	0	7258-7	3001488		
74621	2290	4024958	1959-01-18	1959-01-18 00:00:00	1959-01-18	5001	0	\N	0	0	\N	\N	0	152325	0	117015009	4024958		
27812	2559	3006322	1965-10-15	1965-10-15 00:00:00	1965-10-15	5001	0	\N	0	0	\N	\N	0	169623	0	8331-1	3006322		
3329	320	3011505	2011-02-13	2011-02-13 00:00:00	2011-02-13	5001	0	\N	0	0	\N	\N	0	21193	0	19926-5	3011505		
49551	4506	40766240	2013-03-19	2013-03-19 00:00:00	2013-03-19	5001	0	\N	0	0	\N	\N	0	300183	0	63513-6	40766240		
36598	1136	4024958	1980-12-24	1980-12-24 00:00:00	1980-12-24	5001	0	\N	0	0	\N	\N	0	74826	0	117015009	4024958		
39378	3641	3006322	1915-07-04	1915-07-04 00:00:00	1915-07-04	5001	0	\N	0	0	\N	\N	0	242356	0	8331-1	3006322		
34205	3117	3006322	1995-12-08	1995-12-08 00:00:00	1995-12-08	5001	0	\N	0	0	\N	\N	0	207369	0	8331-1	3006322		
34035	3109	3006322	1928-11-18	1928-11-18 00:00:00	1928-11-18	5001	0	\N	0	0	\N	\N	0	206792	0	8331-1	3006322		
42448	3921	40758406	1987-12-10	1987-12-10 00:00:00	1987-12-10	5001	0	\N	0	0	\N	\N	0	260726	0	55277-8	40758406		
2119	191	40758406	1963-02-16	1963-02-16 00:00:00	1963-02-16	5001	0	\N	0	0	\N	\N	0	13071	0	55277-8	40758406		
27227	2528	3006322	1978-09-04	1978-09-04 00:00:00	1978-09-04	5001	0	\N	0	0	\N	\N	0	167087	0	8331-1	3006322		
8395	795	3006322	2018-12-17	2018-12-17 00:00:00	2018-12-17	5001	0	\N	0	0	\N	\N	0	52745	0	8331-1	3006322		
38672	3573	3006322	1941-01-18	1941-01-18 00:00:00	1941-01-18	5001	0	\N	0	0	\N	\N	0	237539	0	8331-1	3006322		
11932	1138	3006322	2004-05-07	2004-05-07 00:00:00	2004-05-07	5001	0	\N	0	0	\N	\N	0	75118	0	8331-1	3006322		
154760	4748	4024958	1969-08-11	1969-08-11 00:00:00	1969-08-11	5001	0	\N	0	0	\N	\N	0	316131	0	117015009	4024958		
13931	1309	3006906	1994-03-21	1994-03-21 00:00:00	1994-03-21	5001	0	\N	0	0	\N	\N	0	86444	0	17861-6	3006906		
137216	4226	4052083	1995-12-09	1995-12-09 00:00:00	1995-12-09	5001	0	\N	0	0	\N	\N	0	280642	0	23426006	4052083		
32205	2925	3006734	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	195100	0	6189-5	3006734		
47942	4390	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	291892	0	6844-5	3020655		
36802	3376	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	224029	0	6106-9	3014599		
15599	1428	3006322	1983-03-16	1983-03-16 00:00:00	1983-03-16	5001	0	\N	0	0	\N	\N	0	95027	0	8331-1	3006322		
161526	4960	4024958	1921-10-16	1921-10-16 00:00:00	1921-10-16	5001	0	\N	0	0	\N	\N	0	329716	0	117015009	4024958		
49229	4498	3021226	1978-03-01	1978-03-01 00:00:00	1978-03-01	5001	0	\N	0	0	\N	\N	0	299481	0	6246-3	3021226		
49293	4501	40758406	1973-12-30	1973-12-30 00:00:00	1973-12-30	5001	0	\N	0	0	\N	\N	0	299701	0	55277-8	40758406		
31510	2886	3006322	1991-12-06	1991-12-06 00:00:00	1991-12-06	5001	0	\N	0	0	\N	\N	0	191970	0	8331-1	3006322		
31590	2892	40758406	1983-12-26	1983-12-26 00:00:00	1983-12-26	5001	0	\N	0	0	\N	\N	0	192395	0	55277-8	40758406		
53069	4876	3006322	1997-08-13	1997-08-13 00:00:00	1997-08-13	5001	0	\N	0	0	\N	\N	0	324288	0	8331-1	3006322		
33424	3025	46235214	1947-01-25	1947-01-25 00:00:00	1947-01-25	5001	0	\N	0	0	\N	\N	0	201685	0	76690-7	46235214		
44760	4131	3006322	2000-05-02	2000-05-02 00:00:00	2000-05-02	5001	0	\N	0	0	\N	\N	0	274714	0	8331-1	3006322		
16502	1505	3051031	1983-10-28	1983-10-28 00:00:00	1983-10-28	5001	0	\N	0	0	\N	\N	0	100314	0	46240-8	3051031		
51154	4676	3009542	1983-08-01	1983-08-01 00:00:00	1983-08-01	5001	0	\N	0	0	\N	\N	0	311586	0	20570-8	3009542		
40384	3754	3014599	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	249539	0	6106-9	3014599		
55340	5067	3006322	1974-08-04	1974-08-04 00:00:00	1974-08-04	5001	0	\N	0	0	\N	\N	0	336887	0	8331-1	3006322		
49042	4482	3006322	1958-11-30	1958-11-30 00:00:00	1958-11-30	5001	0	\N	0	0	\N	\N	0	298385	0	8331-1	3006322		
29158	2685	3006322	1989-05-05	1989-05-05 00:00:00	1989-05-05	5001	0	\N	0	0	\N	\N	0	177908	0	8331-1	3006322		
12070	1146	3006322	1978-11-15	1978-11-15 00:00:00	1978-11-15	5001	0	\N	0	0	\N	\N	0	75718	0	8331-1	3006322		
21261	669	4024958	2004-10-27	2004-10-27 00:00:00	2004-10-27	5001	0	\N	0	0	\N	\N	0	44169	0	117015009	4024958		
122705	3784	4052083	1937-05-04	1937-05-04 00:00:00	1937-05-04	5001	0	\N	0	0	\N	\N	0	251491	0	23426006	4052083		
26815	2477	3006322	2003-10-05	2003-10-05 00:00:00	2003-10-05	5001	0	\N	0	0	\N	\N	0	164165	0	8331-1	3006322		
35707	1107	4024958	1956-12-20	1956-12-20 00:00:00	1956-12-20	5001	0	\N	0	0	\N	\N	0	72928	0	117015009	4024958		
40223	3744	3015076	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	248741	0	6248-9	3015076		
20012	1840	3006322	1985-12-21	1985-12-21 00:00:00	1985-12-21	5001	0	\N	0	0	\N	\N	0	122797	0	8331-1	3006322		
49696	4520	3011505	1989-12-30	1989-12-30 00:00:00	1989-12-30	5001	0	\N	0	0	\N	\N	0	300934	0	19926-5	3011505		
32227	2925	3015076	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	195093	0	6248-9	3015076		
81	2	3011505	1995-06-27	1995-06-27 00:00:00	1995-06-27	5001	0	\N	0	0	\N	\N	0	196	0	19926-5	3011505		
26870	2486	3006322	1992-10-03	1992-10-03 00:00:00	1992-10-03	5001	0	\N	0	0	\N	\N	0	164725	0	8331-1	3006322		
53858	4935	3015076	1985-10-11	1985-10-11 00:00:00	1985-10-11	5001	0	\N	0	0	\N	\N	0	328074	0	6248-9	3015076		
21173	1956	3012494	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	130141	0	6206-7	3012494		
6551	615	3036780	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	40960	0	6095-4	3036780		
17908	1626	3019550	1989-12-17	1989-12-17 00:00:00	1989-12-17	5001	0	\N	0	0	\N	\N	0	109189	0	2951-2	3019550		
1776	155	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	10629	0	6833-8	3023430		
34427	3137	3006322	1948-05-09	1948-05-09 00:00:00	1948-05-09	5001	0	\N	0	0	\N	\N	0	208826	0	8331-1	3006322		
86240	2666	4024958	1954-08-15	1954-08-15 00:00:00	1954-08-15	5001	0	\N	0	0	\N	\N	0	176602	0	117015009	4024958		
6288	592	3006322	1975-11-29	1975-11-29 00:00:00	1975-11-29	5001	0	\N	0	0	\N	\N	0	39111	0	8331-1	3006322		
97835	2991	4024958	1966-06-05	1966-06-05 00:00:00	1966-06-05	5001	0	\N	0	0	\N	\N	0	199667	0	117015009	4024958		
7643	244	4024958	1934-03-29	1934-03-29 00:00:00	1934-03-29	5001	0	\N	0	0	\N	\N	0	16341	0	117015009	4024958		
1416	124	40769184	1987-12-27	1987-12-27 00:00:00	1987-12-27	5001	0	\N	0	0	\N	\N	0	8225	0	66524-0	40769184		
90849	2804	4052083	1961-06-07	1961-06-07 00:00:00	1961-06-07	5001	0	\N	0	0	\N	\N	0	185878	0	23426006	4052083		
102416	3147	4052083	1947-11-09	1947-11-09 00:00:00	1947-11-09	5001	0	\N	0	0	\N	\N	0	209356	0	23426006	4052083		
3106	96	4133840	1986-03-01	1986-03-01 00:00:00	1986-03-01	5001	0	\N	0	0	\N	\N	0	6515	0	127783003	4133840		
36979	3399	3020655	1999-08-17	1999-08-17 00:00:00	1999-08-17	5001	0	\N	0	0	\N	\N	0	225448	0	6844-5	3020655		
87250	2697	4052083	2001-06-15	2001-06-15 00:00:00	2001-06-15	5001	0	\N	0	0	\N	\N	0	178563	0	23426006	4052083		
16297	1482	3011505	2016-10-29	2016-10-29 00:00:00	2016-10-29	5001	0	\N	0	0	\N	\N	0	98827	0	19926-5	3011505		
74635	2290	4024958	1984-05-14	1984-05-14 00:00:00	1984-05-14	5001	0	\N	0	0	\N	\N	0	152353	0	117015009	4024958		
27813	2559	3000876	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	169613	0	6082-2	3000876		
3330	320	3011505	2010-02-07	2010-02-07 00:00:00	2010-02-07	5001	0	\N	0	0	\N	\N	0	21185	0	19926-5	3011505		
49552	4506	3051031	2013-10-15	2013-10-15 00:00:00	2013-10-15	5001	0	\N	0	0	\N	\N	0	300140	0	46240-8	3051031		
36606	1137	4052083	2011-04-06	2011-04-06 00:00:00	2011-04-06	5001	0	\N	0	0	\N	\N	0	74910	0	23426006	4052083		
39379	3641	3006322	1913-10-30	1913-10-30 00:00:00	1913-10-30	5001	0	\N	0	0	\N	\N	0	242253	0	8331-1	3006322		
34206	3118	3011505	2004-07-04	2004-07-04 00:00:00	2004-07-04	5001	0	\N	0	0	\N	\N	0	207410	0	19926-5	3011505		
34037	3109	3006322	1977-12-23	1977-12-23 00:00:00	1977-12-23	5001	0	\N	0	0	\N	\N	0	206749	0	8331-1	3006322		
42449	3921	46235214	1987-12-10	1987-12-10 00:00:00	1987-12-10	5001	0	\N	0	0	\N	\N	0	260726	0	76690-7	46235214		
2121	191	40766240	1963-02-16	1963-02-16 00:00:00	1963-02-16	5001	0	\N	0	0	\N	\N	0	13071	0	63513-6	40766240		
27228	2528	3006322	1979-09-10	1979-09-10 00:00:00	1979-09-10	5001	0	\N	0	0	\N	\N	0	167104	0	8331-1	3006322		
8396	795	3006322	1950-05-25	1950-05-25 00:00:00	1950-05-25	5001	0	\N	0	0	\N	\N	0	52773	0	8331-1	3006322		
38673	3573	3049273	2003-10-18	2003-10-18 00:00:00	2003-10-18	5001	0	\N	0	0	\N	\N	0	237525	0	38265-5	3049273		
11933	1138	3012494	1996-08-08	1996-08-08 00:00:00	1996-08-08	5001	0	\N	0	0	\N	\N	0	75088	0	6206-7	3012494		
154768	4748	4024958	1999-02-13	1999-02-13 00:00:00	1999-02-13	5001	0	\N	0	0	\N	\N	0	316205	0	117015009	4024958		
13932	1309	3026361	1994-03-21	1994-03-21 00:00:00	1994-03-21	5001	0	\N	0	0	\N	\N	0	86444	0	26453-1	3026361		
137229	4226	4133840	2012-01-15	2012-01-15 00:00:00	2012-01-15	5001	0	\N	0	0	\N	\N	0	280663	0	127783003	4133840		
32206	2925	3027231	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	195100	0	6276-0	3027231		
47943	4390	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	291892	0	6075-6	3005136		
36803	3376	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	224029	0	6189-5	3006734		
15600	1428	3006322	1972-10-27	1972-10-27 00:00:00	1972-10-27	5001	0	\N	0	0	\N	\N	0	94986	0	8331-1	3006322		
118065	3633	4024958	2012-02-21	2012-02-21 00:00:00	2012-02-21	5001	0	\N	0	0	\N	\N	0	241657	0	117015009	4024958		
49230	4498	3000876	1978-03-01	1978-03-01 00:00:00	1978-03-01	5001	0	\N	0	0	\N	\N	0	299481	0	6082-2	3000876		
49295	4501	40758406	1974-06-28	1974-06-28 00:00:00	1974-06-28	5001	0	\N	0	0	\N	\N	0	299702	0	55277-8	40758406		
31514	2889	3006322	1977-08-05	1977-08-05 00:00:00	1977-08-05	5001	0	\N	0	0	\N	\N	0	192142	0	8331-1	3006322		
31593	2892	40766240	1983-12-26	1983-12-26 00:00:00	1983-12-26	5001	0	\N	0	0	\N	\N	0	192395	0	63513-6	40766240		
53070	4876	3006322	1987-04-24	1987-04-24 00:00:00	1987-04-24	5001	0	\N	0	0	\N	\N	0	324297	0	8331-1	3006322		
33425	3025	3051031	1947-01-25	1947-01-25 00:00:00	1947-01-25	5001	0	\N	0	0	\N	\N	0	201685	0	46240-8	3051031		
44761	4131	3006322	1985-04-26	1985-04-26 00:00:00	1985-04-26	5001	0	\N	0	0	\N	\N	0	274712	0	8331-1	3006322		
16504	1505	3006322	1980-05-03	1980-05-03 00:00:00	1980-05-03	5001	0	\N	0	0	\N	\N	0	100328	0	8331-1	3006322		
51155	4676	3000963	1983-08-01	1983-08-01 00:00:00	1983-08-01	5001	0	\N	0	0	\N	\N	0	311586	0	718-7	3000963		
40385	3754	3015076	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	249539	0	6248-9	3015076		
55341	5068	3006322	1937-11-05	1937-11-05 00:00:00	1937-11-05	5001	0	\N	0	0	\N	\N	0	336914	0	8331-1	3006322		
49043	4482	3006322	1975-01-15	1975-01-15 00:00:00	1975-01-15	5001	0	\N	0	0	\N	\N	0	298392	0	8331-1	3006322		
29159	2685	3011505	2004-03-18	2004-03-18 00:00:00	2004-03-18	5001	0	\N	0	0	\N	\N	0	177979	0	19926-5	3011505		
12071	1146	3006322	1977-02-07	1977-02-07 00:00:00	1977-02-07	5001	0	\N	0	0	\N	\N	0	75716	0	8331-1	3006322		
21262	669	4133840	2018-11-21	2018-11-21 00:00:00	2018-11-21	5001	0	\N	0	0	\N	\N	0	44192	0	127783003	4133840		
122706	3784	4133840	1982-07-20	1982-07-20 00:00:00	1982-07-20	5001	0	\N	0	0	\N	\N	0	251531	0	127783003	4133840		
26818	2480	3006322	1970-03-01	1970-03-01 00:00:00	1970-03-01	5001	0	\N	0	0	\N	\N	0	164341	0	8331-1	3006322		
35719	1107	4052083	1956-12-20	1956-12-20 00:00:00	1956-12-20	5001	0	\N	0	0	\N	\N	0	72928	0	23426006	4052083		
40224	3744	3014599	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	248741	0	6106-9	3014599		
20013	1840	3006322	1978-10-01	1978-10-01 00:00:00	1978-10-01	5001	0	\N	0	0	\N	\N	0	122795	0	8331-1	3006322		
49697	4520	3006322	1940-04-04	1940-04-04 00:00:00	1940-04-04	5001	0	\N	0	0	\N	\N	0	300944	0	8331-1	3006322		
32228	2925	3012494	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	195093	0	6206-7	3012494		
82	2	40758406	1921-07-01	1921-07-01 00:00:00	1921-07-01	5001	0	\N	0	0	\N	\N	0	149	0	55277-8	40758406		
26871	2486	3006322	1979-10-26	1979-10-26 00:00:00	1979-10-26	5001	0	\N	0	0	\N	\N	0	164739	0	8331-1	3006322		
53859	4935	3019406	1985-10-11	1985-10-11 00:00:00	1985-10-11	5001	0	\N	0	0	\N	\N	0	328074	0	6158-0	3019406		
21174	1956	3006734	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	130141	0	6189-5	3006734		
6552	615	3027231	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	40960	0	6276-0	3027231		
17909	1626	3014576	1989-12-17	1989-12-17 00:00:00	1989-12-17	5001	0	\N	0	0	\N	\N	0	109189	0	2075-0	3014576		
1777	155	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	10629	0	6844-5	3020655		
34428	3137	3006322	1981-04-13	1981-04-13 00:00:00	1981-04-13	5001	0	\N	0	0	\N	\N	0	208794	0	8331-1	3006322		
31737	974	4024958	1998-10-03	1998-10-03 00:00:00	1998-10-03	5001	0	\N	0	0	\N	\N	0	64994	0	117015009	4024958		
6306	596	3006322	1981-12-12	1981-12-12 00:00:00	1981-12-12	5001	0	\N	0	0	\N	\N	0	39375	0	8331-1	3006322		
97836	2991	4024958	1976-07-27	1976-07-27 00:00:00	1976-07-27	5001	0	\N	0	0	\N	\N	0	199668	0	117015009	4024958		
7659	244	4052083	1993-07-02	1993-07-02 00:00:00	1993-07-02	5001	0	\N	0	0	\N	\N	0	16286	0	23426006	4052083		
1417	124	40769194	1987-12-27	1987-12-27 00:00:00	1987-12-27	5001	0	\N	0	0	\N	\N	0	8225	0	66534-9	40769194		
90850	2804	4052083	2017-08-18	2017-08-18 00:00:00	2017-08-18	5001	0	\N	0	0	\N	\N	0	185828	0	23426006	4052083		
102421	3147	4133840	2012-05-07	2012-05-07 00:00:00	2012-05-07	5001	0	\N	0	0	\N	\N	0	209367	0	127783003	4133840		
3108	96	4024958	1925-08-26	1925-08-26 00:00:00	1925-08-26	5001	0	\N	0	0	\N	\N	0	6540	0	117015009	4024958		
36980	3399	3001488	1999-08-17	1999-08-17 00:00:00	1999-08-17	5001	0	\N	0	0	\N	\N	0	225448	0	7258-7	3001488		
87263	2697	4024958	1952-02-11	1952-02-11 00:00:00	1952-02-11	5001	0	\N	0	0	\N	\N	0	178609	0	117015009	4024958		
16305	1486	3021226	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	99139	0	6246-3	3021226		
143471	4409	4024958	1978-11-07	1978-11-07 00:00:00	1978-11-07	5001	0	\N	0	0	\N	\N	0	293053	0	117015009	4024958		
27814	2559	3001488	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	169613	0	7258-7	3001488		
3331	320	3011505	2004-03-14	2004-03-14 00:00:00	2004-03-14	5001	0	\N	0	0	\N	\N	0	21182	0	19926-5	3011505		
49553	4506	40758406	2013-10-15	2013-10-15 00:00:00	2013-10-15	5001	0	\N	0	0	\N	\N	0	300140	0	55277-8	40758406		
36631	1137	4052083	1959-03-15	1959-03-15 00:00:00	1959-03-15	5001	0	\N	0	0	\N	\N	0	74878	0	23426006	4052083		
39380	3641	3006322	1967-10-24	1967-10-24 00:00:00	1967-10-24	5001	0	\N	0	0	\N	\N	0	242330	0	8331-1	3006322		
34207	3118	3011505	2002-12-29	2002-12-29 00:00:00	2002-12-29	5001	0	\N	0	0	\N	\N	0	207499	0	19926-5	3011505		
34248	3118	3015076	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	207486	0	6248-9	3015076		
42450	3921	40766240	1987-12-10	1987-12-10 00:00:00	1987-12-10	5001	0	\N	0	0	\N	\N	0	260726	0	63513-6	40766240		
2122	191	3051031	1963-02-16	1963-02-16 00:00:00	1963-02-16	5001	0	\N	0	0	\N	\N	0	13071	0	46240-8	3051031		
27229	2528	3006322	1977-05-30	1977-05-30 00:00:00	1977-05-30	5001	0	\N	0	0	\N	\N	0	167119	0	8331-1	3006322		
8397	795	3006322	1954-02-18	1954-02-18 00:00:00	1954-02-18	5001	0	\N	0	0	\N	\N	0	52774	0	8331-1	3006322		
38674	3573	3006322	1996-11-02	1996-11-02 00:00:00	1996-11-02	5001	0	\N	0	0	\N	\N	0	237545	0	8331-1	3006322		
11934	1138	3006451	1996-08-08	1996-08-08 00:00:00	1996-08-08	5001	0	\N	0	0	\N	\N	0	75088	0	6273-7	3006451		
154784	4748	4024958	1946-11-27	1946-11-27 00:00:00	1946-11-27	5001	0	\N	0	0	\N	\N	0	316160	0	117015009	4024958		
13933	1309	3019550	1994-03-21	1994-03-21 00:00:00	1994-03-21	5001	0	\N	0	0	\N	\N	0	86444	0	2951-2	3019550		
137233	4226	4052083	1975-04-15	1975-04-15 00:00:00	1975-04-15	5001	0	\N	0	0	\N	\N	0	280764	0	23426006	4052083		
32207	2925	3006451	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	195100	0	6273-7	3006451		
47944	4390	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	291892	0	6248-9	3015076		
36804	3376	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	224029	0	6273-7	3006451		
15601	1428	3006322	2006-07-24	2006-07-24 00:00:00	2006-07-24	5001	0	\N	0	0	\N	\N	0	94996	0	8331-1	3006322		
118066	3633	4024958	1982-06-08	1982-06-08 00:00:00	1982-06-08	5001	0	\N	0	0	\N	\N	0	241679	0	117015009	4024958		
49231	4498	3027231	1978-03-01	1978-03-01 00:00:00	1978-03-01	5001	0	\N	0	0	\N	\N	0	299481	0	6276-0	3027231		
49296	4501	40766240	1974-06-28	1974-06-28 00:00:00	1974-06-28	5001	0	\N	0	0	\N	\N	0	299702	0	63513-6	40766240		
31515	2889	3006322	1995-02-13	1995-02-13 00:00:00	1995-02-13	5001	0	\N	0	0	\N	\N	0	192165	0	8331-1	3006322		
31594	2892	3051031	1983-12-26	1983-12-26 00:00:00	1983-12-26	5001	0	\N	0	0	\N	\N	0	192395	0	46240-8	3051031		
53071	4876	3006322	1985-10-21	1985-10-21 00:00:00	1985-10-21	5001	0	\N	0	0	\N	\N	0	324270	0	8331-1	3006322		
33426	3025	40758406	1947-01-25	1947-01-25 00:00:00	1947-01-25	5001	0	\N	0	0	\N	\N	0	201685	0	55277-8	40758406		
44762	4131	3006322	2009-10-21	2009-10-21 00:00:00	2009-10-21	5001	0	\N	0	0	\N	\N	0	274694	0	8331-1	3006322		
16505	1506	3006322	1950-09-26	1950-09-26 00:00:00	1950-09-26	5001	0	\N	0	0	\N	\N	0	100446	0	8331-1	3006322		
51156	4676	3006322	1993-03-24	1993-03-24 00:00:00	1993-03-24	5001	0	\N	0	0	\N	\N	0	311588	0	8331-1	3006322		
40386	3754	3019406	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	249539	0	6158-0	3019406		
55342	5068	3006322	1998-04-05	1998-04-05 00:00:00	1998-04-05	5001	0	\N	0	0	\N	\N	0	336924	0	8331-1	3006322		
49044	4482	3006322	1950-12-20	1950-12-20 00:00:00	1950-12-20	5001	0	\N	0	0	\N	\N	0	298384	0	8331-1	3006322		
29160	2686	3051031	2003-01-07	2003-01-07 00:00:00	2003-01-07	5001	0	\N	0	0	\N	\N	0	178031	0	46240-8	3051031		
12117	1148	3006322	2017-05-06	2017-05-06 00:00:00	2017-05-06	5001	0	\N	0	0	\N	\N	0	75923	0	8331-1	3006322		
80985	2501	4024958	1991-10-18	1991-10-18 00:00:00	1991-10-18	5001	0	\N	0	0	\N	\N	0	165529	0	117015009	4024958		
122708	3784	4133840	1990-08-07	1990-08-07 00:00:00	1990-08-07	5001	0	\N	0	0	\N	\N	0	251534	0	127783003	4133840		
26819	2480	3006322	1975-05-21	1975-05-21 00:00:00	1975-05-21	5001	0	\N	0	0	\N	\N	0	164300	0	8331-1	3006322		
35720	1107	4024958	1929-04-09	1929-04-09 00:00:00	1929-04-09	5001	0	\N	0	0	\N	\N	0	72911	0	117015009	4024958		
40225	3744	3006322	1992-09-30	1992-09-30 00:00:00	1992-09-30	5001	0	\N	0	0	\N	\N	0	248792	0	8331-1	3006322		
20014	1840	3006322	1983-01-22	1983-01-22 00:00:00	1983-01-22	5001	0	\N	0	0	\N	\N	0	122836	0	8331-1	3006322		
49698	4520	3011505	1979-11-03	1979-11-03 00:00:00	1979-11-03	5001	0	\N	0	0	\N	\N	0	300888	0	19926-5	3011505		
32229	2925	3020655	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	195093	0	6844-5	3020655		
83	2	46235214	1921-07-01	1921-07-01 00:00:00	1921-07-01	5001	0	\N	0	0	\N	\N	0	149	0	76690-7	46235214		
26872	2487	3006322	1998-12-22	1998-12-22 00:00:00	1998-12-22	5001	0	\N	0	0	\N	\N	0	164814	0	8331-1	3006322		
53860	4935	3020655	1985-10-11	1985-10-11 00:00:00	1985-10-11	5001	0	\N	0	0	\N	\N	0	328074	0	6844-5	3020655		
21175	1956	3020655	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	130141	0	6844-5	3020655		
6553	615	3006451	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	40960	0	6273-7	3006451		
17910	1626	3035995	1989-12-17	1989-12-17 00:00:00	1989-12-17	5001	0	\N	0	0	\N	\N	0	109189	0	6768-6	3035995		
1778	155	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	10629	0	6273-7	3006451		
34429	3137	3006322	1927-03-18	1927-03-18 00:00:00	1927-03-18	5001	0	\N	0	0	\N	\N	0	208776	0	8331-1	3006322		
31742	974	4024958	1969-06-02	1969-06-02 00:00:00	1969-06-02	5001	0	\N	0	0	\N	\N	0	64985	0	117015009	4024958		
6307	596	3006322	1979-01-12	1979-01-12 00:00:00	1979-01-12	5001	0	\N	0	0	\N	\N	0	39352	0	8331-1	3006322		
97973	2997	4052083	1993-12-01	1993-12-01 00:00:00	1993-12-01	5001	0	\N	0	0	\N	\N	0	199970	0	23426006	4052083		
7662	244	4052083	1923-06-23	1923-06-23 00:00:00	1923-06-23	5001	0	\N	0	0	\N	\N	0	16293	0	23426006	4052083		
1418	124	3006322	1994-02-06	1994-02-06 00:00:00	1994-02-06	5001	0	\N	0	0	\N	\N	0	8324	0	8331-1	3006322		
90852	2804	4024958	1982-01-05	1982-01-05 00:00:00	1982-01-05	5001	0	\N	0	0	\N	\N	0	185813	0	117015009	4024958		
102423	3147	4133840	2011-05-02	2011-05-02 00:00:00	2011-05-02	5001	0	\N	0	0	\N	\N	0	209409	0	127783003	4133840		
3111	96	4133840	1983-02-12	1983-02-12 00:00:00	1983-02-12	5001	0	\N	0	0	\N	\N	0	6525	0	127783003	4133840		
36981	3399	3006451	1999-08-17	1999-08-17 00:00:00	1999-08-17	5001	0	\N	0	0	\N	\N	0	225448	0	6273-7	3006451		
87265	2697	4024958	1978-03-07	1978-03-07 00:00:00	1978-03-07	5001	0	\N	0	0	\N	\N	0	178596	0	117015009	4024958		
16306	1486	3012494	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	99139	0	6206-7	3012494		
143485	4411	4052083	2002-07-08	2002-07-08 00:00:00	2002-07-08	5001	0	\N	0	0	\N	\N	0	293183	0	23426006	4052083		
27815	2559	3020655	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	169613	0	6844-5	3020655		
3332	321	3006322	1997-10-01	1997-10-01 00:00:00	1997-10-01	5001	0	\N	0	0	\N	\N	0	21274	0	8331-1	3006322		
49554	4506	46235214	2013-10-15	2013-10-15 00:00:00	2013-10-15	5001	0	\N	0	0	\N	\N	0	300140	0	76690-7	46235214		
140112	4317	4024958	1981-08-22	1981-08-22 00:00:00	1981-08-22	5001	0	\N	0	0	\N	\N	0	286500	0	117015009	4024958		
50660	4621	3006322	1995-03-20	1995-03-20 00:00:00	1995-03-20	5001	0	\N	0	0	\N	\N	0	307770	0	8331-1	3006322		
34208	3118	3011505	1996-12-29	1996-12-29 00:00:00	1996-12-29	5001	0	\N	0	0	\N	\N	0	207407	0	19926-5	3011505		
34249	3118	3005136	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	207486	0	6075-6	3005136		
42451	3921	3051031	1987-12-10	1987-12-10 00:00:00	1987-12-10	5001	0	\N	0	0	\N	\N	0	260726	0	46240-8	3051031		
2123	191	3011505	2002-11-12	2002-11-12 00:00:00	2002-11-12	5001	0	\N	0	0	\N	\N	0	13110	0	19926-5	3011505		
27230	2528	3006322	1969-11-12	1969-11-12 00:00:00	1969-11-12	5001	0	\N	0	0	\N	\N	0	167103	0	8331-1	3006322		
8398	795	3006322	1968-03-16	1968-03-16 00:00:00	1968-03-16	5001	0	\N	0	0	\N	\N	0	52706	0	8331-1	3006322		
38675	3573	3006322	1989-12-28	1989-12-28 00:00:00	1989-12-28	5001	0	\N	0	0	\N	\N	0	237584	0	8331-1	3006322		
11935	1138	3001247	1996-08-08	1996-08-08 00:00:00	1996-08-08	5001	0	\N	0	0	\N	\N	0	75088	0	6085-5	3001247		
38818	3589	3006734	1997-07-08	1997-07-08 00:00:00	1997-07-08	5001	0	\N	0	0	\N	\N	0	238474	0	6189-5	3006734		
13934	1309	3000963	1994-03-21	1994-03-21 00:00:00	1994-03-21	5001	0	\N	0	0	\N	\N	0	86444	0	718-7	3000963		
137237	4226	4024958	1967-06-27	1967-06-27 00:00:00	1967-06-27	5001	0	\N	0	0	\N	\N	0	280650	0	117015009	4024958		
32208	2925	3014599	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	195100	0	6106-9	3014599		
47945	4390	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	291892	0	6106-9	3014599		
36805	3376	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	224029	0	7258-7	3001488		
15605	1430	3006322	1995-10-04	1995-10-04 00:00:00	1995-10-04	5001	0	\N	0	0	\N	\N	0	95140	0	8331-1	3006322		
118096	3636	4052083	2010-02-10	2010-02-10 00:00:00	2010-02-10	5001	0	\N	0	0	\N	\N	0	241841	0	23426006	4052083		
49232	4498	3005136	1978-03-01	1978-03-01 00:00:00	1978-03-01	5001	0	\N	0	0	\N	\N	0	299481	0	6075-6	3005136		
49297	4501	46235214	1974-06-28	1974-06-28 00:00:00	1974-06-28	5001	0	\N	0	0	\N	\N	0	299702	0	76690-7	46235214		
31516	2889	3006322	2010-10-01	2010-10-01 00:00:00	2010-10-01	5001	0	\N	0	0	\N	\N	0	192145	0	8331-1	3006322		
31595	2893	3006322	2006-10-22	2006-10-22 00:00:00	2006-10-22	5001	0	\N	0	0	\N	\N	0	192520	0	8331-1	3006322		
53072	4878	3006322	1971-01-14	1971-01-14 00:00:00	1971-01-14	5001	0	\N	0	0	\N	\N	0	324315	0	8331-1	3006322		
33427	3025	40766240	1947-01-25	1947-01-25 00:00:00	1947-01-25	5001	0	\N	0	0	\N	\N	0	201685	0	63513-6	40766240		
44764	4133	3006322	1992-06-19	1992-06-19 00:00:00	1992-06-19	5001	0	\N	0	0	\N	\N	0	274797	0	8331-1	3006322		
16506	1506	3006322	1975-12-30	1975-12-30 00:00:00	1975-12-30	5001	0	\N	0	0	\N	\N	0	100402	0	8331-1	3006322		
51157	4676	3006322	1995-11-22	1995-11-22 00:00:00	1995-11-22	5001	0	\N	0	0	\N	\N	0	311589	0	8331-1	3006322		
40387	3754	3005136	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	249539	0	6075-6	3005136		
55343	5068	3006322	1945-08-06	1945-08-06 00:00:00	1945-08-06	5001	0	\N	0	0	\N	\N	0	336915	0	8331-1	3006322		
49045	4482	3006322	2011-06-18	2011-06-18 00:00:00	2011-06-18	5001	0	\N	0	0	\N	\N	0	298397	0	8331-1	3006322		
29162	2686	46235214	2003-01-07	2003-01-07 00:00:00	2003-01-07	5001	0	\N	0	0	\N	\N	0	178031	0	76690-7	46235214		
12118	1148	3006322	1958-08-17	1958-08-17 00:00:00	1958-08-17	5001	0	\N	0	0	\N	\N	0	75886	0	8331-1	3006322		
80988	2501	4052083	1996-05-27	1996-05-27 00:00:00	1996-05-27	5001	0	\N	0	0	\N	\N	0	165538	0	23426006	4052083		
122709	3784	4133840	1986-08-12	1986-08-12 00:00:00	1986-08-12	5001	0	\N	0	0	\N	\N	0	251476	0	127783003	4133840		
26820	2480	3049273	2009-06-05	2009-06-05 00:00:00	2009-06-05	5001	0	\N	0	0	\N	\N	0	164319	0	38265-5	3049273		
35733	1107	4024958	1939-05-13	1939-05-13 00:00:00	1939-05-13	5001	0	\N	0	0	\N	\N	0	72840	0	117015009	4024958		
40226	3744	3006322	2012-01-13	2012-01-13 00:00:00	2012-01-13	5001	0	\N	0	0	\N	\N	0	248785	0	8331-1	3006322		
20020	1842	3006322	1990-03-25	1990-03-25 00:00:00	1990-03-25	5001	0	\N	0	0	\N	\N	0	122967	0	8331-1	3006322		
49699	4520	3011505	1994-01-22	1994-01-22 00:00:00	1994-01-22	5001	0	\N	0	0	\N	\N	0	300938	0	19926-5	3011505		
32230	2925	3023430	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	195093	0	6833-8	3023430		
84	2	40766240	1921-07-01	1921-07-01 00:00:00	1921-07-01	5001	0	\N	0	0	\N	\N	0	149	0	63513-6	40766240		
26873	2487	3006322	2009-08-22	2009-08-22 00:00:00	2009-08-22	5001	0	\N	0	0	\N	\N	0	164805	0	8331-1	3006322		
53861	4935	3023430	1985-10-11	1985-10-11 00:00:00	1985-10-11	5001	0	\N	0	0	\N	\N	0	328074	0	6833-8	3023430		
21176	1956	3019406	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	130141	0	6158-0	3019406		
6554	615	3000876	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	40960	0	6082-2	3000876		
17911	1626	3006906	1989-12-17	1989-12-17 00:00:00	1989-12-17	5001	0	\N	0	0	\N	\N	0	109189	0	17861-6	3006906		
1779	155	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	10629	0	6246-3	3021226		
34430	3137	3006322	1965-06-24	1965-06-24 00:00:00	1965-06-24	5001	0	\N	0	0	\N	\N	0	208827	0	8331-1	3006322		
31743	974	4024958	1984-08-02	1984-08-02 00:00:00	1984-08-02	5001	0	\N	0	0	\N	\N	0	64987	0	117015009	4024958		
6309	596	3006322	1952-07-09	1952-07-09 00:00:00	1952-07-09	5001	0	\N	0	0	\N	\N	0	39374	0	8331-1	3006322		
18419	579	4024958	1997-07-02	1997-07-02 00:00:00	1997-07-02	5001	0	\N	0	0	\N	\N	0	38359	0	117015009	4024958		
7667	244	4024958	1956-01-11	1956-01-11 00:00:00	1956-01-11	5001	0	\N	0	0	\N	\N	0	16343	0	117015009	4024958		
1419	124	3006322	1992-02-26	1992-02-26 00:00:00	1992-02-26	5001	0	\N	0	0	\N	\N	0	8316	0	8331-1	3006322		
90854	2804	4024958	1982-07-20	1982-07-20 00:00:00	1982-07-20	5001	0	\N	0	0	\N	\N	0	185824	0	117015009	4024958		
102425	3147	4133840	1997-02-10	1997-02-10 00:00:00	1997-02-10	5001	0	\N	0	0	\N	\N	0	209386	0	127783003	4133840		
3114	96	4133840	1976-01-03	1976-01-03 00:00:00	1976-01-03	5001	0	\N	0	0	\N	\N	0	6490	0	127783003	4133840		
36982	3399	3001247	1999-08-17	1999-08-17 00:00:00	1999-08-17	5001	0	\N	0	0	\N	\N	0	225448	0	6085-5	3001247		
87270	2697	4024958	1947-07-09	1947-07-09 00:00:00	1947-07-09	5001	0	\N	0	0	\N	\N	0	178571	0	117015009	4024958		
16307	1486	3001247	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	99139	0	6085-5	3001247		
143489	4411	4024958	2017-06-15	2017-06-15 00:00:00	2017-06-15	5001	0	\N	0	0	\N	\N	0	293166	0	117015009	4024958		
27816	2559	3023430	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	169613	0	6833-8	3023430		
3333	321	3006322	1965-09-25	1965-09-25 00:00:00	1965-09-25	5001	0	\N	0	0	\N	\N	0	21270	0	8331-1	3006322		
49557	4506	40766240	2013-10-15	2013-10-15 00:00:00	2013-10-15	5001	0	\N	0	0	\N	\N	0	300140	0	63513-6	40766240		
140126	4317	4024958	1953-02-05	1953-02-05 00:00:00	1953-02-05	5001	0	\N	0	0	\N	\N	0	286490	0	117015009	4024958		
50661	4621	3006322	1979-10-12	1979-10-12 00:00:00	1979-10-12	5001	0	\N	0	0	\N	\N	0	307746	0	8331-1	3006322		
34210	3118	3006322	1989-05-03	1989-05-03 00:00:00	1989-05-03	5001	0	\N	0	0	\N	\N	0	207485	0	8331-1	3006322		
34250	3118	3012494	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	207486	0	6206-7	3012494		
42454	3921	3006322	2008-09-21	2008-09-21 00:00:00	2008-09-21	5001	0	\N	0	0	\N	\N	0	260728	0	8331-1	3006322		
2124	191	3011505	1989-09-19	1989-09-19 00:00:00	1989-09-19	5001	0	\N	0	0	\N	\N	0	13126	0	19926-5	3011505		
27246	2530	3006322	1979-07-18	1979-07-18 00:00:00	1979-07-18	5001	0	\N	0	0	\N	\N	0	167246	0	8331-1	3006322		
8399	795	3006322	1961-11-05	1961-11-05 00:00:00	1961-11-05	5001	0	\N	0	0	\N	\N	0	52705	0	8331-1	3006322		
38676	3573	3006322	1938-06-24	1938-06-24 00:00:00	1938-06-24	5001	0	\N	0	0	\N	\N	0	237574	0	8331-1	3006322		
11936	1138	3006734	1996-08-08	1996-08-08 00:00:00	1996-08-08	5001	0	\N	0	0	\N	\N	0	75088	0	6189-5	3006734		
38819	3589	3015076	1997-07-08	1997-07-08 00:00:00	1997-07-08	5001	0	\N	0	0	\N	\N	0	238474	0	6248-9	3015076		
13935	1309	3020630	1994-03-21	1994-03-21 00:00:00	1994-03-21	5001	0	\N	0	0	\N	\N	0	86444	0	2885-2	3020630		
137238	4226	4052083	1983-03-09	1983-03-09 00:00:00	1983-03-09	5001	0	\N	0	0	\N	\N	0	280768	0	23426006	4052083		
32209	2925	3006322	2013-07-22	2013-07-22 00:00:00	2013-07-22	5001	0	\N	0	0	\N	\N	0	195080	0	8331-1	3006322		
47946	4390	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	291892	0	6276-0	3027231		
36806	3376	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	224029	0	6833-8	3023430		
15606	1430	3006322	1999-03-01	1999-03-01 00:00:00	1999-03-01	5001	0	\N	0	0	\N	\N	0	95141	0	8331-1	3006322		
118098	3636	4052083	1979-03-12	1979-03-12 00:00:00	1979-03-12	5001	0	\N	0	0	\N	\N	0	241804	0	23426006	4052083		
49233	4498	3001488	1978-03-01	1978-03-01 00:00:00	1978-03-01	5001	0	\N	0	0	\N	\N	0	299481	0	7258-7	3001488		
49299	4501	3051031	1974-06-28	1974-06-28 00:00:00	1974-06-28	5001	0	\N	0	0	\N	\N	0	299702	0	46240-8	3051031		
31517	2889	3006322	2009-12-23	2009-12-23 00:00:00	2009-12-23	5001	0	\N	0	0	\N	\N	0	192166	0	8331-1	3006322		
31596	2893	3006322	1972-07-13	1972-07-13 00:00:00	1972-07-13	5001	0	\N	0	0	\N	\N	0	192499	0	8331-1	3006322		
53073	4878	3006322	1968-11-14	1968-11-14 00:00:00	1968-11-14	5001	0	\N	0	0	\N	\N	0	324329	0	8331-1	3006322		
33429	3025	3000963	1988-11-15	1988-11-15 00:00:00	1988-11-15	5001	0	\N	0	0	\N	\N	0	201604	0	718-7	3000963		
44765	4133	3006322	1981-03-08	1981-03-08 00:00:00	1981-03-08	5001	0	\N	0	0	\N	\N	0	274784	0	8331-1	3006322		
16507	1506	3006322	1958-08-28	1958-08-28 00:00:00	1958-08-28	5001	0	\N	0	0	\N	\N	0	100397	0	8331-1	3006322		
51158	4677	3006322	1971-08-29	1971-08-29 00:00:00	1971-08-29	5001	0	\N	0	0	\N	\N	0	311652	0	8331-1	3006322		
40388	3754	3027231	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	249539	0	6276-0	3027231		
55344	5068	3006322	1973-07-07	1973-07-07 00:00:00	1973-07-07	5001	0	\N	0	0	\N	\N	0	336971	0	8331-1	3006322		
65986	2025	4024958	1911-10-21	1911-10-21 00:00:00	1911-10-21	5001	0	\N	0	0	\N	\N	0	134768	0	117015009	4024958		
29163	2686	40766240	2003-01-07	2003-01-07 00:00:00	2003-01-07	5001	0	\N	0	0	\N	\N	0	178031	0	63513-6	40766240		
12119	1148	3006322	1963-02-03	1963-02-03 00:00:00	1963-02-03	5001	0	\N	0	0	\N	\N	0	75877	0	8331-1	3006322		
80994	2501	4052083	1981-11-14	1981-11-14 00:00:00	1981-11-14	5001	0	\N	0	0	\N	\N	0	165537	0	23426006	4052083		
84371	2613	4024958	1984-06-04	1984-06-04 00:00:00	1984-06-04	5001	0	\N	0	0	\N	\N	0	172748	0	117015009	4024958		
26821	2480	3006322	1998-05-05	1998-05-05 00:00:00	1998-05-05	5001	0	\N	0	0	\N	\N	0	164303	0	8331-1	3006322		
35958	1115	4052083	2010-10-11	2010-10-11 00:00:00	2010-10-11	5001	0	\N	0	0	\N	\N	0	73488	0	23426006	4052083		
40227	3744	3006322	1998-01-14	1998-01-14 00:00:00	1998-01-14	5001	0	\N	0	0	\N	\N	0	248748	0	8331-1	3006322		
20021	1842	3006322	1991-09-24	1991-09-24 00:00:00	1991-09-24	5001	0	\N	0	0	\N	\N	0	122944	0	8331-1	3006322		
49700	4520	3011505	1981-11-14	1981-11-14 00:00:00	1981-11-14	5001	0	\N	0	0	\N	\N	0	300936	0	19926-5	3011505		
32231	2925	3001247	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	195093	0	6085-5	3001247		
87	2	3051031	1921-07-01	1921-07-01 00:00:00	1921-07-01	5001	0	\N	0	0	\N	\N	0	149	0	46240-8	3051031		
26874	2487	3006322	2000-11-27	2000-11-27 00:00:00	2000-11-27	5001	0	\N	0	0	\N	\N	0	164763	0	8331-1	3006322		
53862	4935	3006322	1968-08-18	1968-08-18 00:00:00	1968-08-18	5001	0	\N	0	0	\N	\N	0	328033	0	8331-1	3006322		
21177	1956	3021226	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	130141	0	6246-3	3021226		
6555	615	3001247	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	40960	0	6085-5	3001247		
17912	1626	3002385	1989-12-17	1989-12-17 00:00:00	1989-12-17	5001	0	\N	0	0	\N	\N	0	109189	0	30385-9	3002385		
1780	156	3006322	2000-05-09	2000-05-09 00:00:00	2000-05-09	5001	0	\N	0	0	\N	\N	0	10695	0	8331-1	3006322		
34431	3137	3049273	1975-04-13	1975-04-13 00:00:00	1975-04-13	5001	0	\N	0	0	\N	\N	0	208834	0	38265-5	3049273		
31749	974	4024958	1960-02-07	1960-02-07 00:00:00	1960-02-07	5001	0	\N	0	0	\N	\N	0	64930	0	117015009	4024958		
6310	596	3006322	1972-01-09	1972-01-09 00:00:00	1972-01-09	5001	0	\N	0	0	\N	\N	0	39383	0	8331-1	3006322		
18422	579	4024958	1973-09-23	1973-09-23 00:00:00	1973-09-23	5001	0	\N	0	0	\N	\N	0	38290	0	117015009	4024958		
7669	244	4024958	1972-11-04	1972-11-04 00:00:00	1972-11-04	5001	0	\N	0	0	\N	\N	0	16266	0	117015009	4024958		
1420	124	3006322	1992-04-07	1992-04-07 00:00:00	1992-04-07	5001	0	\N	0	0	\N	\N	0	8299	0	8331-1	3006322		
90868	2806	4024958	1955-08-08	1955-08-08 00:00:00	1955-08-08	5001	0	\N	0	0	\N	\N	0	185921	0	117015009	4024958		
102426	3147	4133840	1980-01-07	1980-01-07 00:00:00	1980-01-07	5001	0	\N	0	0	\N	\N	0	209383	0	127783003	4133840		
3115	96	4133840	1984-02-18	1984-02-18 00:00:00	1984-02-18	5001	0	\N	0	0	\N	\N	0	6514	0	127783003	4133840		
36983	3399	3019406	1999-08-17	1999-08-17 00:00:00	1999-08-17	5001	0	\N	0	0	\N	\N	0	225448	0	6158-0	3019406		
87276	2698	4024958	2005-12-07	2005-12-07 00:00:00	2005-12-07	5001	0	\N	0	0	\N	\N	0	178686	0	117015009	4024958		
16308	1486	3036780	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	99139	0	6095-4	3036780		
143496	4411	4024958	1978-09-14	1978-09-14 00:00:00	1978-09-14	5001	0	\N	0	0	\N	\N	0	293188	0	117015009	4024958		
27817	2559	3006734	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	169613	0	6189-5	3006734		
3334	321	3006322	1965-12-07	1965-12-07 00:00:00	1965-12-07	5001	0	\N	0	0	\N	\N	0	21304	0	8331-1	3006322		
49564	4509	3011505	2013-09-17	2013-09-17 00:00:00	2013-09-17	5001	0	\N	0	0	\N	\N	0	300373	0	19926-5	3011505		
153393	4704	4024958	1968-10-05	1968-10-05 00:00:00	1968-10-05	5001	0	\N	0	0	\N	\N	0	313392	0	117015009	4024958		
50662	4621	3006322	2008-07-20	2008-07-20 00:00:00	2008-07-20	5001	0	\N	0	0	\N	\N	0	307772	0	8331-1	3006322		
34211	3118	3011505	2004-01-04	2004-01-04 00:00:00	2004-01-04	5001	0	\N	0	0	\N	\N	0	207425	0	19926-5	3011505		
34251	3118	3023430	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	207486	0	6833-8	3023430		
42475	3926	3011505	1984-10-15	1984-10-15 00:00:00	1984-10-15	5001	0	\N	0	0	\N	\N	0	260949	0	19926-5	3011505		
2125	191	3011505	1999-10-26	1999-10-26 00:00:00	1999-10-26	5001	0	\N	0	0	\N	\N	0	13129	0	19926-5	3011505		
27247	2530	3006322	1985-06-10	1985-06-10 00:00:00	1985-06-10	5001	0	\N	0	0	\N	\N	0	167215	0	8331-1	3006322		
8400	795	3006322	2018-09-09	2018-09-09 00:00:00	2018-09-09	5001	0	\N	0	0	\N	\N	0	52777	0	8331-1	3006322		
38677	3573	3006322	1931-05-17	1931-05-17 00:00:00	1931-05-17	5001	0	\N	0	0	\N	\N	0	237573	0	8331-1	3006322		
11937	1138	3027231	1996-08-08	1996-08-08 00:00:00	1996-08-08	5001	0	\N	0	0	\N	\N	0	75088	0	6276-0	3027231		
38820	3589	3001488	1997-07-08	1997-07-08 00:00:00	1997-07-08	5001	0	\N	0	0	\N	\N	0	238474	0	7258-7	3001488		
13936	1309	3006923	1994-03-21	1994-03-21 00:00:00	1994-03-21	5001	0	\N	0	0	\N	\N	0	86444	0	1742-6	3006923		
137262	4227	4024958	1960-05-18	1960-05-18 00:00:00	1960-05-18	5001	0	\N	0	0	\N	\N	0	280852	0	117015009	4024958		
32210	2925	3006322	2011-02-17	2011-02-17 00:00:00	2011-02-17	5001	0	\N	0	0	\N	\N	0	195011	0	8331-1	3006322		
47947	4390	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	291892	0	6085-5	3001247		
36807	3376	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	224029	0	6844-5	3020655		
15607	1430	3049273	2004-10-12	2004-10-12 00:00:00	2004-10-12	5001	0	\N	0	0	\N	\N	0	95168	0	38265-5	3049273		
118106	3636	4024958	1998-02-25	1998-02-25 00:00:00	1998-02-25	5001	0	\N	0	0	\N	\N	0	241867	0	117015009	4024958		
49234	4498	3001247	1978-03-01	1978-03-01 00:00:00	1978-03-01	5001	0	\N	0	0	\N	\N	0	299481	0	6085-5	3001247		
49300	4501	3006322	1986-05-09	1986-05-09 00:00:00	1986-05-09	5001	0	\N	0	0	\N	\N	0	299710	0	8331-1	3006322		
31518	2889	3006322	2007-10-25	2007-10-25 00:00:00	2007-10-25	5001	0	\N	0	0	\N	\N	0	192176	0	8331-1	3006322		
31597	2893	3006322	1952-01-18	1952-01-18 00:00:00	1952-01-18	5001	0	\N	0	0	\N	\N	0	192453	0	8331-1	3006322		
53074	4878	3036780	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	324320	0	6095-4	3036780		
33430	3025	3009542	1988-11-15	1988-11-15 00:00:00	1988-11-15	5001	0	\N	0	0	\N	\N	0	201604	0	20570-8	3009542		
44766	4133	3006322	1994-05-06	1994-05-06 00:00:00	1994-05-06	5001	0	\N	0	0	\N	\N	0	274803	0	8331-1	3006322		
16508	1506	3006322	1947-09-27	1947-09-27 00:00:00	1947-09-27	5001	0	\N	0	0	\N	\N	0	100409	0	8331-1	3006322		
51159	4677	3006322	2017-05-16	2017-05-16 00:00:00	2017-05-16	5001	0	\N	0	0	\N	\N	0	311670	0	8331-1	3006322		
40389	3754	3021226	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	249539	0	6246-3	3021226		
55345	5068	3049273	2007-11-06	2007-11-06 00:00:00	2007-11-06	5001	0	\N	0	0	\N	\N	0	336993	0	38265-5	3049273		
66002	2025	4052083	2012-04-21	2012-04-21 00:00:00	2012-04-21	5001	0	\N	0	0	\N	\N	0	134725	0	23426006	4052083		
29164	2686	40758406	2003-01-07	2003-01-07 00:00:00	2003-01-07	5001	0	\N	0	0	\N	\N	0	178031	0	55277-8	40758406		
12120	1148	3006322	1990-10-04	1990-10-04 00:00:00	1990-10-04	5001	0	\N	0	0	\N	\N	0	75901	0	8331-1	3006322		
33760	3064	3006322	2015-11-27	2015-11-27 00:00:00	2015-11-27	5001	0	\N	0	0	\N	\N	0	203981	0	8331-1	3006322		
84374	2613	4024958	1960-09-17	1960-09-17 00:00:00	1960-09-17	5001	0	\N	0	0	\N	\N	0	172752	0	117015009	4024958		
26822	2480	3006322	1967-07-03	1967-07-03 00:00:00	1967-07-03	5001	0	\N	0	0	\N	\N	0	164297	0	8331-1	3006322		
35963	1115	4052083	1970-05-09	1970-05-09 00:00:00	1970-05-09	5001	0	\N	0	0	\N	\N	0	73453	0	23426006	4052083		
40228	3744	40769189	2002-12-28	2002-12-28 00:00:00	2002-12-28	5001	0	\N	0	0	\N	\N	0	248749	0	66529-9	40769189		
20022	1842	3006322	1968-08-07	1968-08-07 00:00:00	1968-08-07	5001	0	\N	0	0	\N	\N	0	122966	0	8331-1	3006322		
49701	4520	3011505	1966-09-24	1966-09-24 00:00:00	1966-09-24	5001	0	\N	0	0	\N	\N	0	300886	0	19926-5	3011505		
32232	2925	3006734	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	195093	0	6189-5	3006734		
88	2	3049273	1993-03-29	1993-03-29 00:00:00	1993-03-29	5001	0	\N	0	0	\N	\N	0	117	0	38265-5	3049273		
26875	2487	3006322	1961-04-17	1961-04-17 00:00:00	1961-04-17	5001	0	\N	0	0	\N	\N	0	164785	0	8331-1	3006322		
53863	4935	3006322	1973-03-03	1973-03-03 00:00:00	1973-03-03	5001	0	\N	0	0	\N	\N	0	328035	0	8331-1	3006322		
21178	1956	3006451	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	130141	0	6273-7	3006451		
6556	615	3014599	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	40960	0	6106-9	3014599		
17913	1626	3020630	1989-12-17	1989-12-17 00:00:00	1989-12-17	5001	0	\N	0	0	\N	\N	0	109189	0	2885-2	3020630		
1781	156	3006322	1983-12-26	1983-12-26 00:00:00	1983-12-26	5001	0	\N	0	0	\N	\N	0	10694	0	8331-1	3006322		
34432	3137	3006322	1935-05-10	1935-05-10 00:00:00	1935-05-10	5001	0	\N	0	0	\N	\N	0	208778	0	8331-1	3006322		
31765	974	4024958	2010-08-14	2010-08-14 00:00:00	2010-08-14	5001	0	\N	0	0	\N	\N	0	64952	0	117015009	4024958		
6312	596	3006322	1951-01-03	1951-01-03 00:00:00	1951-01-03	5001	0	\N	0	0	\N	\N	0	39373	0	8331-1	3006322		
18428	579	4024958	1996-09-21	1996-09-21 00:00:00	1996-09-21	5001	0	\N	0	0	\N	\N	0	38301	0	117015009	4024958		
7672	244	4052083	1926-12-20	1926-12-20 00:00:00	1926-12-20	5001	0	\N	0	0	\N	\N	0	16262	0	23426006	4052083		
1421	124	3011505	2014-03-25	2014-03-25 00:00:00	2014-03-25	5001	0	\N	0	0	\N	\N	0	8273	0	19926-5	3011505		
91039	2812	4052083	1999-07-20	1999-07-20 00:00:00	1999-07-20	5001	0	\N	0	0	\N	\N	0	186312	0	23426006	4052083		
102427	3147	4133840	2013-05-13	2013-05-13 00:00:00	2013-05-13	5001	0	\N	0	0	\N	\N	0	209410	0	127783003	4133840		
3117	96	4052083	1940-05-16	1940-05-16 00:00:00	1940-05-16	5001	0	\N	0	0	\N	\N	0	6510	0	23426006	4052083		
36984	3399	3005136	1999-08-17	1999-08-17 00:00:00	1999-08-17	5001	0	\N	0	0	\N	\N	0	225448	0	6075-6	3005136		
87277	2698	4024958	1994-04-12	1994-04-12 00:00:00	1994-04-12	5001	0	\N	0	0	\N	\N	0	178670	0	117015009	4024958		
16309	1486	3000876	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	99139	0	6082-2	3000876		
143497	4411	4024958	1951-10-22	1951-10-22 00:00:00	1951-10-22	5001	0	\N	0	0	\N	\N	0	293176	0	117015009	4024958		
27818	2559	3036780	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	169613	0	6095-4	3036780		
3335	321	3006322	1994-02-04	1994-02-04 00:00:00	1994-02-04	5001	0	\N	0	0	\N	\N	0	21308	0	8331-1	3006322		
49565	4509	3011505	1996-04-16	1996-04-16 00:00:00	1996-04-16	5001	0	\N	0	0	\N	\N	0	300395	0	19926-5	3011505		
153394	4704	4024958	1970-11-09	1970-11-09 00:00:00	1970-11-09	5001	0	\N	0	0	\N	\N	0	313394	0	117015009	4024958		
50663	4621	3006322	1991-08-25	1991-08-25 00:00:00	1991-08-25	5001	0	\N	0	0	\N	\N	0	307721	0	8331-1	3006322		
34212	3118	3011505	1999-12-12	1999-12-12 00:00:00	1999-12-12	5001	0	\N	0	0	\N	\N	0	207453	0	19926-5	3011505		
34252	3118	3020655	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	207486	0	6844-5	3020655		
42476	3926	3006322	1959-08-13	1959-08-13 00:00:00	1959-08-13	5001	0	\N	0	0	\N	\N	0	260924	0	8331-1	3006322		
2127	191	40766240	1976-09-10	1976-09-10 00:00:00	1976-09-10	5001	0	\N	0	0	\N	\N	0	13075	0	63513-6	40766240		
27248	2530	3006322	1996-09-21	1996-09-21 00:00:00	1996-09-21	5001	0	\N	0	0	\N	\N	0	167247	0	8331-1	3006322		
44394	1367	4024958	1997-05-23	1997-05-23 00:00:00	1997-05-23	5001	0	\N	0	0	\N	\N	0	90588	0	117015009	4024958		
38678	3573	3006322	1958-10-01	1958-10-01 00:00:00	1958-10-01	5001	0	\N	0	0	\N	\N	0	237520	0	8331-1	3006322		
11938	1138	3019406	1996-08-08	1996-08-08 00:00:00	1996-08-08	5001	0	\N	0	0	\N	\N	0	75088	0	6158-0	3019406		
38821	3589	3001247	1997-07-08	1997-07-08 00:00:00	1997-07-08	5001	0	\N	0	0	\N	\N	0	238474	0	6085-5	3001247		
13937	1309	3010813	1994-03-21	1994-03-21 00:00:00	1994-03-21	5001	0	\N	0	0	\N	\N	0	86444	0	26464-8	3010813		
137268	4227	4024958	1987-05-18	1987-05-18 00:00:00	1987-05-18	5001	0	\N	0	0	\N	\N	0	280782	0	117015009	4024958		
32211	2925	3006322	1973-12-09	1973-12-09 00:00:00	1973-12-09	5001	0	\N	0	0	\N	\N	0	194996	0	8331-1	3006322		
47948	4390	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	291892	0	6189-5	3006734		
36808	3376	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	224029	0	6085-5	3001247		
15608	1430	3006322	1986-09-09	1986-09-09 00:00:00	1986-09-09	5001	0	\N	0	0	\N	\N	0	95154	0	8331-1	3006322		
118107	3636	4024958	1978-11-11	1978-11-11 00:00:00	1978-11-11	5001	0	\N	0	0	\N	\N	0	241788	0	117015009	4024958		
49235	4498	3020655	1978-03-01	1978-03-01 00:00:00	1978-03-01	5001	0	\N	0	0	\N	\N	0	299481	0	6844-5	3020655		
49301	4501	46235214	1974-01-29	1974-01-29 00:00:00	1974-01-29	5001	0	\N	0	0	\N	\N	0	299678	0	76690-7	46235214		
31519	2889	3006322	1961-08-13	1961-08-13 00:00:00	1961-08-13	5001	0	\N	0	0	\N	\N	0	192122	0	8331-1	3006322		
31598	2893	3006322	1999-08-14	1999-08-14 00:00:00	1999-08-14	5001	0	\N	0	0	\N	\N	0	192504	0	8331-1	3006322		
53075	4878	3023430	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	324320	0	6833-8	3023430		
33431	3025	3006451	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	201615	0	6273-7	3006451		
44767	4133	3006322	2015-01-01	2015-01-01 00:00:00	2015-01-01	5001	0	\N	0	0	\N	\N	0	274787	0	8331-1	3006322		
16509	1506	3006322	1972-09-05	1972-09-05 00:00:00	1972-09-05	5001	0	\N	0	0	\N	\N	0	100398	0	8331-1	3006322		
51160	4677	3006322	2002-01-10	2002-01-10 00:00:00	2002-01-10	5001	0	\N	0	0	\N	\N	0	311656	0	8331-1	3006322		
40390	3754	3001488	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	249539	0	7258-7	3001488		
55346	5068	3006322	1956-09-14	1956-09-14 00:00:00	1956-09-14	5001	0	\N	0	0	\N	\N	0	336996	0	8331-1	3006322		
66003	2025	4024958	1996-08-04	1996-08-04 00:00:00	1996-08-04	5001	0	\N	0	0	\N	\N	0	134670	0	117015009	4024958		
29167	2686	46235214	2002-10-09	2002-10-09 00:00:00	2002-10-09	5001	0	\N	0	0	\N	\N	0	178030	0	76690-7	46235214		
12121	1148	3006322	1978-05-23	1978-05-23 00:00:00	1978-05-23	5001	0	\N	0	0	\N	\N	0	75887	0	8331-1	3006322		
33761	3064	3006322	2006-06-06	2006-06-06 00:00:00	2006-06-06	5001	0	\N	0	0	\N	\N	0	203980	0	8331-1	3006322		
84396	2615	4024958	1984-04-17	1984-04-17 00:00:00	1984-04-17	5001	0	\N	0	0	\N	\N	0	172927	0	117015009	4024958		
26823	2481	3006322	1990-08-02	1990-08-02 00:00:00	1990-08-02	5001	0	\N	0	0	\N	\N	0	164396	0	8331-1	3006322		
35973	1115	4052083	1959-07-20	1959-07-20 00:00:00	1959-07-20	5001	0	\N	0	0	\N	\N	0	73451	0	23426006	4052083		
40229	3744	40769184	2002-12-28	2002-12-28 00:00:00	2002-12-28	5001	0	\N	0	0	\N	\N	0	248749	0	66524-0	40769184		
20023	1842	3006322	2000-11-02	2000-11-02 00:00:00	2000-11-02	5001	0	\N	0	0	\N	\N	0	122968	0	8331-1	3006322		
49702	4520	3011505	1983-11-26	1983-11-26 00:00:00	1983-11-26	5001	0	\N	0	0	\N	\N	0	300937	0	19926-5	3011505		
32233	2926	3006322	2012-10-13	2012-10-13 00:00:00	2012-10-13	5001	0	\N	0	0	\N	\N	0	195179	0	8331-1	3006322		
36358	1128	4024958	1993-03-04	1993-03-04 00:00:00	1993-03-04	5001	0	\N	0	0	\N	\N	0	74331	0	117015009	4024958		
26876	2487	3009201	2010-02-16	2010-02-16 00:00:00	2010-02-16	5001	0	\N	0	0	\N	\N	0	164764	0	3016-3	3009201		
78480	2409	4024958	2001-03-10	2001-03-10 00:00:00	2001-03-10	5001	0	\N	0	0	\N	\N	0	159895	0	117015009	4024958		
21179	1956	3000876	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	130141	0	6082-2	3000876		
6557	615	3005136	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	40960	0	6075-6	3005136		
17914	1626	3007461	1989-12-17	1989-12-17 00:00:00	1989-12-17	5001	0	\N	0	0	\N	\N	0	109189	0	26515-7	3007461		
1786	158	3006322	1952-05-08	1952-05-08 00:00:00	1952-05-08	5001	0	\N	0	0	\N	\N	0	10818	0	8331-1	3006322		
34433	3137	3006322	1921-12-27	1921-12-27 00:00:00	1921-12-27	5001	0	\N	0	0	\N	\N	0	208822	0	8331-1	3006322		
31777	974	4024958	1979-01-22	1979-01-22 00:00:00	1979-01-22	5001	0	\N	0	0	\N	\N	0	64931	0	117015009	4024958		
6314	597	3006322	1970-06-30	1970-06-30 00:00:00	1970-06-30	5001	0	\N	0	0	\N	\N	0	39446	0	8331-1	3006322		
18431	579	4024958	1966-09-11	1966-09-11 00:00:00	1966-09-11	5001	0	\N	0	0	\N	\N	0	38365	0	117015009	4024958		
7676	244	4052083	1974-10-16	1974-10-16 00:00:00	1974-10-16	5001	0	\N	0	0	\N	\N	0	16284	0	23426006	4052083		
1422	124	3000876	2000-09-12	2000-09-12 00:00:00	2000-09-12	5001	0	\N	0	0	\N	\N	0	8277	0	6082-2	3000876		
22627	711	4052083	1985-10-30	1985-10-30 00:00:00	1985-10-30	5001	0	\N	0	0	\N	\N	0	47165	0	23426006	4052083		
102429	3147	4133840	1983-01-10	1983-01-10 00:00:00	1983-01-10	5001	0	\N	0	0	\N	\N	0	209419	0	127783003	4133840		
3120	96	4133840	1996-04-27	1996-04-27 00:00:00	1996-04-27	5001	0	\N	0	0	\N	\N	0	6496	0	127783003	4133840		
36985	3399	3012494	1999-08-17	1999-08-17 00:00:00	1999-08-17	5001	0	\N	0	0	\N	\N	0	225448	0	6206-7	3012494		
87282	2698	4024958	2004-02-01	2004-02-01 00:00:00	2004-02-01	5001	0	\N	0	0	\N	\N	0	178685	0	117015009	4024958		
16310	1486	3014599	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	99139	0	6106-9	3014599		
143504	4411	4024958	1961-03-18	1961-03-18 00:00:00	1961-03-18	5001	0	\N	0	0	\N	\N	0	293177	0	117015009	4024958		
41088	1273	4052083	1947-11-29	1947-11-29 00:00:00	1947-11-29	5001	0	\N	0	0	\N	\N	0	83976	0	23426006	4052083		
3336	321	3006322	1989-08-17	1989-08-17 00:00:00	1989-08-17	5001	0	\N	0	0	\N	\N	0	21272	0	8331-1	3006322		
49566	4509	3006322	1986-05-23	1986-05-23 00:00:00	1986-05-23	5001	0	\N	0	0	\N	\N	0	300375	0	8331-1	3006322		
153403	4704	4052083	1972-01-17	1972-01-17 00:00:00	1972-01-17	5001	0	\N	0	0	\N	\N	0	313395	0	23426006	4052083		
50664	4622	3006322	1996-02-08	1996-02-08 00:00:00	1996-02-08	5001	0	\N	0	0	\N	\N	0	307781	0	8331-1	3006322		
34213	3118	3011505	1992-12-20	1992-12-20 00:00:00	1992-12-20	5001	0	\N	0	0	\N	\N	0	207452	0	19926-5	3011505		
34253	3118	3014599	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	207486	0	6106-9	3014599		
42477	3926	3011505	2017-07-24	2017-07-24 00:00:00	2017-07-24	5001	0	\N	0	0	\N	\N	0	260958	0	19926-5	3011505		
2128	191	40758406	1976-09-10	1976-09-10 00:00:00	1976-09-10	5001	0	\N	0	0	\N	\N	0	13075	0	55277-8	40758406		
27249	2530	3006322	1983-06-08	1983-06-08 00:00:00	1983-06-08	5001	0	\N	0	0	\N	\N	0	167214	0	8331-1	3006322		
44428	1368	4024958	1958-04-13	1958-04-13 00:00:00	1958-04-13	5001	0	\N	0	0	\N	\N	0	90733	0	117015009	4024958		
38682	3576	3006322	1978-07-13	1978-07-13 00:00:00	1978-07-13	5001	0	\N	0	0	\N	\N	0	237714	0	8331-1	3006322		
11939	1138	3021226	1996-08-08	1996-08-08 00:00:00	1996-08-08	5001	0	\N	0	0	\N	\N	0	75088	0	6246-3	3021226		
38822	3589	3023430	1997-07-08	1997-07-08 00:00:00	1997-07-08	5001	0	\N	0	0	\N	\N	0	238474	0	6833-8	3023430		
13938	1309	3024561	1994-03-21	1994-03-21 00:00:00	1994-03-21	5001	0	\N	0	0	\N	\N	0	86444	0	1751-7	3024561		
50425	4595	3006322	1970-07-13	1970-07-13 00:00:00	1970-07-13	5001	0	\N	0	0	\N	\N	0	306150	0	8331-1	3006322		
32212	2925	40769184	1963-05-08	1963-05-08 00:00:00	1963-05-08	5001	0	\N	0	0	\N	\N	0	194995	0	66524-0	40769184		
47949	4390	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	291892	0	7258-7	3001488		
36809	3376	3006322	1966-08-19	1966-08-19 00:00:00	1966-08-19	5001	0	\N	0	0	\N	\N	0	224008	0	8331-1	3006322		
15609	1431	3006322	1984-07-13	1984-07-13 00:00:00	1984-07-13	5001	0	\N	0	0	\N	\N	0	95210	0	8331-1	3006322		
118108	3636	4024958	2010-04-02	2010-04-02 00:00:00	2010-04-02	5001	0	\N	0	0	\N	\N	0	241784	0	117015009	4024958		
49236	4498	3036780	1978-03-01	1978-03-01 00:00:00	1978-03-01	5001	0	\N	0	0	\N	\N	0	299481	0	6095-4	3036780		
49303	4501	3051031	1974-01-29	1974-01-29 00:00:00	1974-01-29	5001	0	\N	0	0	\N	\N	0	299678	0	46240-8	3051031		
31520	2889	3006322	1968-05-25	1968-05-25 00:00:00	1968-05-25	5001	0	\N	0	0	\N	\N	0	192175	0	8331-1	3006322		
31599	2893	3006322	1994-04-30	1994-04-30 00:00:00	1994-04-30	5001	0	\N	0	0	\N	\N	0	192534	0	8331-1	3006322		
53076	4878	3006734	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	324320	0	6189-5	3006734		
33432	3025	3015076	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	201615	0	6248-9	3015076		
44768	4133	3006322	1993-09-25	1993-09-25 00:00:00	1993-09-25	5001	0	\N	0	0	\N	\N	0	274767	0	8331-1	3006322		
16510	1506	3006322	1963-11-28	1963-11-28 00:00:00	1963-11-28	5001	0	\N	0	0	\N	\N	0	100400	0	8331-1	3006322		
51161	4677	3006322	2011-06-04	2011-06-04 00:00:00	2011-06-04	5001	0	\N	0	0	\N	\N	0	311679	0	8331-1	3006322		
40391	3754	3001247	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	249539	0	6085-5	3001247		
55347	5068	3006322	1984-12-02	1984-12-02 00:00:00	1984-12-02	5001	0	\N	0	0	\N	\N	0	336923	0	8331-1	3006322		
66027	2025	4024958	2012-01-28	2012-01-28 00:00:00	2012-01-28	5001	0	\N	0	0	\N	\N	0	134724	0	117015009	4024958		
29168	2686	40766240	2002-10-09	2002-10-09 00:00:00	2002-10-09	5001	0	\N	0	0	\N	\N	0	178030	0	63513-6	40766240		
12122	1148	3006322	2015-07-04	2015-07-04 00:00:00	2015-07-04	5001	0	\N	0	0	\N	\N	0	75902	0	8331-1	3006322		
33762	3064	3006322	2017-10-03	2017-10-03 00:00:00	2017-10-03	5001	0	\N	0	0	\N	\N	0	203943	0	8331-1	3006322		
84398	2615	4052083	1979-12-29	1979-12-29 00:00:00	1979-12-29	5001	0	\N	0	0	\N	\N	0	172896	0	23426006	4052083		
26824	2481	3006322	2015-10-17	2015-10-17 00:00:00	2015-10-17	5001	0	\N	0	0	\N	\N	0	164410	0	8331-1	3006322		
47263	1441	4024958	1971-03-11	1971-03-11 00:00:00	1971-03-11	5001	0	\N	0	0	\N	\N	0	96034	0	117015009	4024958		
40230	3744	40769194	2002-12-28	2002-12-28 00:00:00	2002-12-28	5001	0	\N	0	0	\N	\N	0	248749	0	66534-9	40769194		
20024	1842	3006322	1997-08-08	1997-08-08 00:00:00	1997-08-08	5001	0	\N	0	0	\N	\N	0	122951	0	8331-1	3006322		
49703	4520	3006322	1942-08-01	1942-08-01 00:00:00	1942-08-01	5001	0	\N	0	0	\N	\N	0	300872	0	8331-1	3006322		
32234	2926	3006322	1995-12-03	1995-12-03 00:00:00	1995-12-03	5001	0	\N	0	0	\N	\N	0	195192	0	8331-1	3006322		
36374	1128	4052083	1975-02-21	1975-02-21 00:00:00	1975-02-21	5001	0	\N	0	0	\N	\N	0	74348	0	23426006	4052083		
26877	2487	3008598	2010-02-16	2010-02-16 00:00:00	2010-02-16	5001	0	\N	0	0	\N	\N	0	164764	0	3024-7	3008598		
78486	2409	4052083	2008-06-14	2008-06-14 00:00:00	2008-06-14	5001	0	\N	0	0	\N	\N	0	159903	0	23426006	4052083		
21180	1956	3023430	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	130141	0	6833-8	3023430		
6558	615	3021226	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	40960	0	6246-3	3021226		
17915	1626	3045716	1989-12-17	1989-12-17 00:00:00	1989-12-17	5001	0	\N	0	0	\N	\N	0	109189	0	33037-3	3045716		
1787	158	3006322	1975-11-01	1975-11-01 00:00:00	1975-11-01	5001	0	\N	0	0	\N	\N	0	10794	0	8331-1	3006322		
34440	3141	3006322	2018-02-26	2018-02-26 00:00:00	2018-02-26	5001	0	\N	0	0	\N	\N	0	208995	0	8331-1	3006322		
31791	975	4024958	1985-10-12	1985-10-12 00:00:00	1985-10-12	5001	0	\N	0	0	\N	\N	0	65034	0	117015009	4024958		
6315	597	3006322	2016-03-24	2016-03-24 00:00:00	2016-03-24	5001	0	\N	0	0	\N	\N	0	39442	0	8331-1	3006322		
18432	579	4024958	1961-07-22	1961-07-22 00:00:00	1961-07-22	5001	0	\N	0	0	\N	\N	0	38288	0	117015009	4024958		
7678	244	4024958	1949-10-27	1949-10-27 00:00:00	1949-10-27	5001	0	\N	0	0	\N	\N	0	16295	0	117015009	4024958		
1423	124	3005136	2000-09-12	2000-09-12 00:00:00	2000-09-12	5001	0	\N	0	0	\N	\N	0	8277	0	6075-6	3005136		
22682	711	4024958	1976-07-27	1976-07-27 00:00:00	1976-07-27	5001	0	\N	0	0	\N	\N	0	47153	0	117015009	4024958		
102432	3147	4024958	1955-08-20	1955-08-20 00:00:00	1955-08-20	5001	0	\N	0	0	\N	\N	0	209370	0	117015009	4024958		
3123	96	4133840	1965-06-12	1965-06-12 00:00:00	1965-06-12	5001	0	\N	0	0	\N	\N	0	6489	0	127783003	4133840		
36986	3399	3015076	1999-08-17	1999-08-17 00:00:00	1999-08-17	5001	0	\N	0	0	\N	\N	0	225448	0	6248-9	3015076		
87297	2699	4052083	1971-10-15	1971-10-15 00:00:00	1971-10-15	5001	0	\N	0	0	\N	\N	0	178715	0	23426006	4052083		
16311	1486	3027231	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	99139	0	6276-0	3027231		
143505	4411	4052083	1993-08-16	1993-08-16 00:00:00	1993-08-16	5001	0	\N	0	0	\N	\N	0	293231	0	23426006	4052083		
41089	1273	4052083	2004-09-03	2004-09-03 00:00:00	2004-09-03	5001	0	\N	0	0	\N	\N	0	83977	0	23426006	4052083		
3337	321	3006322	1998-10-08	1998-10-08 00:00:00	1998-10-08	5001	0	\N	0	0	\N	\N	0	21291	0	8331-1	3006322		
49567	4509	3011505	1993-04-13	1993-04-13 00:00:00	1993-04-13	5001	0	\N	0	0	\N	\N	0	300360	0	19926-5	3011505		
164699	5053	4052083	1986-02-18	1986-02-18 00:00:00	1986-02-18	5001	0	\N	0	0	\N	\N	0	336040	0	23426006	4052083		
50665	4622	3006322	1968-11-04	1968-11-04 00:00:00	1968-11-04	5001	0	\N	0	0	\N	\N	0	307814	0	8331-1	3006322		
34214	3118	3006451	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	207442	0	6273-7	3006451		
34254	3118	3001488	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	207486	0	7258-7	3001488		
42478	3926	3011505	1981-10-12	1981-10-12 00:00:00	1981-10-12	5001	0	\N	0	0	\N	\N	0	260948	0	19926-5	3011505		
2129	191	3051031	1976-09-10	1976-09-10 00:00:00	1976-09-10	5001	0	\N	0	0	\N	\N	0	13075	0	46240-8	3051031		
27250	2530	3006322	1979-04-10	1979-04-10 00:00:00	1979-04-10	5001	0	\N	0	0	\N	\N	0	167245	0	8331-1	3006322		
136240	4200	4052083	1991-05-07	1991-05-07 00:00:00	1991-05-07	5001	0	\N	0	0	\N	\N	0	278728	0	23426006	4052083		
38683	3576	3006322	1984-02-26	1984-02-26 00:00:00	1984-02-26	5001	0	\N	0	0	\N	\N	0	237747	0	8331-1	3006322		
11940	1138	3001488	1996-08-08	1996-08-08 00:00:00	1996-08-08	5001	0	\N	0	0	\N	\N	0	75088	0	7258-7	3001488		
38823	3589	3020655	1997-07-08	1997-07-08 00:00:00	1997-07-08	5001	0	\N	0	0	\N	\N	0	238474	0	6844-5	3020655		
13939	1309	21494966	1994-03-21	1994-03-21 00:00:00	1994-03-21	5001	0	\N	0	0	\N	\N	0	86444	0	80271-0	21494966		
50426	4595	3006322	1966-03-25	1966-03-25 00:00:00	1966-03-25	5001	0	\N	0	0	\N	\N	0	306183	0	8331-1	3006322		
32213	2925	40769194	1963-05-08	1963-05-08 00:00:00	1963-05-08	5001	0	\N	0	0	\N	\N	0	194995	0	66534-9	40769194		
47950	4390	3006322	2012-02-13	2012-02-13 00:00:00	2012-02-13	5001	0	\N	0	0	\N	\N	0	291891	0	8331-1	3006322		
36810	3376	3006322	1981-03-28	1981-03-28 00:00:00	1981-03-28	5001	0	\N	0	0	\N	\N	0	224028	0	8331-1	3006322		
15610	1431	3036780	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	95212	0	6095-4	3036780		
118119	3636	4052083	2006-05-03	2006-05-03 00:00:00	2006-05-03	5001	0	\N	0	0	\N	\N	0	241783	0	23426006	4052083		
49237	4498	3023430	1978-03-01	1978-03-01 00:00:00	1978-03-01	5001	0	\N	0	0	\N	\N	0	299481	0	6833-8	3023430		
49305	4501	40758406	1974-01-29	1974-01-29 00:00:00	1974-01-29	5001	0	\N	0	0	\N	\N	0	299678	0	55277-8	40758406		
31521	2889	3006322	1969-09-29	1969-09-29 00:00:00	1969-09-29	5001	0	\N	0	0	\N	\N	0	192123	0	8331-1	3006322		
31600	2893	3006322	1978-04-27	1978-04-27 00:00:00	1978-04-27	5001	0	\N	0	0	\N	\N	0	192500	0	8331-1	3006322		
53077	4878	3019406	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	324320	0	6158-0	3019406		
33433	3025	3014599	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	201615	0	6106-9	3014599		
44769	4133	3006322	2018-11-25	2018-11-25 00:00:00	2018-11-25	5001	0	\N	0	0	\N	\N	0	274789	0	8331-1	3006322		
16512	1506	3006322	1978-11-28	1978-11-28 00:00:00	1978-11-28	5001	0	\N	0	0	\N	\N	0	100413	0	8331-1	3006322		
51162	4677	3006322	2016-11-30	2016-11-30 00:00:00	2016-11-30	5001	0	\N	0	0	\N	\N	0	311669	0	8331-1	3006322		
40392	3754	3020655	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	249539	0	6844-5	3020655		
55348	5068	3006322	1934-09-12	1934-09-12 00:00:00	1934-09-12	5001	0	\N	0	0	\N	\N	0	336913	0	8331-1	3006322		
66040	2025	4024958	2017-08-10	2017-08-10 00:00:00	2017-08-10	5001	0	\N	0	0	\N	\N	0	134702	0	117015009	4024958		
29169	2686	40758406	2002-10-09	2002-10-09 00:00:00	2002-10-09	5001	0	\N	0	0	\N	\N	0	178030	0	55277-8	40758406		
12123	1149	3006322	2003-10-07	2003-10-07 00:00:00	2003-10-07	5001	0	\N	0	0	\N	\N	0	75952	0	8331-1	3006322		
33763	3064	3006322	1938-09-19	1938-09-19 00:00:00	1938-09-19	5001	0	\N	0	0	\N	\N	0	203952	0	8331-1	3006322		
84400	2615	4052083	1961-04-28	1961-04-28 00:00:00	1961-04-28	5001	0	\N	0	0	\N	\N	0	172926	0	23426006	4052083		
26825	2481	3006322	1996-10-12	1996-10-12 00:00:00	1996-10-12	5001	0	\N	0	0	\N	\N	0	164408	0	8331-1	3006322		
47273	1441	4024958	1974-06-03	1974-06-03 00:00:00	1974-06-03	5001	0	\N	0	0	\N	\N	0	96028	0	117015009	4024958		
40231	3744	40769179	2002-12-28	2002-12-28 00:00:00	2002-12-28	5001	0	\N	0	0	\N	\N	0	248749	0	66519-0	40769179		
20025	1843	3006322	1986-05-28	1986-05-28 00:00:00	1986-05-28	5001	0	\N	0	0	\N	\N	0	123056	0	8331-1	3006322		
49704	4520	3011505	1991-01-05	1991-01-05 00:00:00	1991-01-05	5001	0	\N	0	0	\N	\N	0	300927	0	19926-5	3011505		
32235	2926	3006322	1992-12-06	1992-12-06 00:00:00	1992-12-06	5001	0	\N	0	0	\N	\N	0	195191	0	8331-1	3006322		
174305	5343	4052083	1985-01-23	1985-01-23 00:00:00	1985-01-23	5001	0	\N	0	0	\N	\N	0	355858	0	23426006	4052083		
26878	2487	3006322	1963-08-19	1963-08-19 00:00:00	1963-08-19	5001	0	\N	0	0	\N	\N	0	164787	0	8331-1	3006322		
78489	2409	4024958	2016-01-02	2016-01-02 00:00:00	2016-01-02	5001	0	\N	0	0	\N	\N	0	159952	0	117015009	4024958		
21196	1958	3006322	1987-12-22	1987-12-22 00:00:00	1987-12-22	5001	0	\N	0	0	\N	\N	0	130272	0	8331-1	3006322		
6559	615	3019406	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	40960	0	6158-0	3019406		
17916	1626	3013682	1989-12-17	1989-12-17 00:00:00	1989-12-17	5001	0	\N	0	0	\N	\N	0	109189	0	3094-0	3013682		
1788	158	3006322	2001-03-30	2001-03-30 00:00:00	2001-03-30	5001	0	\N	0	0	\N	\N	0	10796	0	8331-1	3006322		
34441	3141	3006322	2014-11-03	2014-11-03 00:00:00	2014-11-03	5001	0	\N	0	0	\N	\N	0	209002	0	8331-1	3006322		
31800	975	4052083	2009-07-27	2009-07-27 00:00:00	2009-07-27	5001	0	\N	0	0	\N	\N	0	65005	0	23426006	4052083		
6316	597	3006322	1963-03-26	1963-03-26 00:00:00	1963-03-26	5001	0	\N	0	0	\N	\N	0	39472	0	8331-1	3006322		
18434	579	4052083	2014-09-12	2014-09-12 00:00:00	2014-09-12	5001	0	\N	0	0	\N	\N	0	38326	0	23426006	4052083		
17729	1611	3006322	1977-02-16	1977-02-16 00:00:00	1977-02-16	5001	0	\N	0	0	\N	\N	0	108275	0	8331-1	3006322		
1424	124	3014599	2000-09-12	2000-09-12 00:00:00	2000-09-12	5001	0	\N	0	0	\N	\N	0	8277	0	6106-9	3014599		
22688	711	4052083	1983-04-05	1983-04-05 00:00:00	1983-04-05	5001	0	\N	0	0	\N	\N	0	47194	0	23426006	4052083		
22719	711	4024958	1954-08-06	1954-08-06 00:00:00	1954-08-06	5001	0	\N	0	0	\N	\N	0	47191	0	117015009	4024958		
3125	96	4133840	1951-05-26	1951-05-26 00:00:00	1951-05-26	5001	0	\N	0	0	\N	\N	0	6487	0	127783003	4133840		
36987	3399	3000876	1999-08-17	1999-08-17 00:00:00	1999-08-17	5001	0	\N	0	0	\N	\N	0	225448	0	6082-2	3000876		
87300	2699	4052083	2018-06-03	2018-06-03 00:00:00	2018-06-03	5001	0	\N	0	0	\N	\N	0	178756	0	23426006	4052083		
16312	1486	3023430	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	99139	0	6833-8	3023430		
143511	4411	4052083	1951-04-24	1951-04-24 00:00:00	1951-04-24	5001	0	\N	0	0	\N	\N	0	293227	0	23426006	4052083		
41110	1273	4024958	1972-06-02	1972-06-02 00:00:00	1972-06-02	5001	0	\N	0	0	\N	\N	0	84062	0	117015009	4024958		
3349	326	3006322	1979-09-23	1979-09-23 00:00:00	1979-09-23	5001	0	\N	0	0	\N	\N	0	21553	0	8331-1	3006322		
49568	4509	3006322	1994-05-27	1994-05-27 00:00:00	1994-05-27	5001	0	\N	0	0	\N	\N	0	300385	0	8331-1	3006322		
42904	1320	4024958	1976-01-25	1976-01-25 00:00:00	1976-01-25	5001	0	\N	0	0	\N	\N	0	87482	0	117015009	4024958		
50666	4622	3006322	1961-09-28	1961-09-28 00:00:00	1961-09-28	5001	0	\N	0	0	\N	\N	0	307830	0	8331-1	3006322		
34215	3118	3021226	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	207442	0	6246-3	3021226		
34255	3118	3006734	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	207486	0	6189-5	3006734		
42479	3926	3011505	2003-12-01	2003-12-01 00:00:00	2003-12-01	5001	0	\N	0	0	\N	\N	0	260954	0	19926-5	3011505		
2130	191	46235214	1976-09-10	1976-09-10 00:00:00	1976-09-10	5001	0	\N	0	0	\N	\N	0	13075	0	76690-7	46235214		
8951	857	3011505	1994-09-25	1994-09-25 00:00:00	1994-09-25	5001	0	\N	0	0	\N	\N	0	56630	0	19926-5	3011505		
136256	4200	4052083	2016-12-24	2016-12-24 00:00:00	2016-12-24	5001	0	\N	0	0	\N	\N	0	278750	0	23426006	4052083		
38684	3577	3006322	2012-03-13	2012-03-13 00:00:00	2012-03-13	5001	0	\N	0	0	\N	\N	0	237816	0	8331-1	3006322		
11941	1138	3023430	1996-08-08	1996-08-08 00:00:00	1996-08-08	5001	0	\N	0	0	\N	\N	0	75088	0	6833-8	3023430		
38824	3589	3021226	1997-07-08	1997-07-08 00:00:00	1997-07-08	5001	0	\N	0	0	\N	\N	0	238474	0	6246-3	3021226		
13940	1309	3013721	1994-03-21	1994-03-21 00:00:00	1994-03-21	5001	0	\N	0	0	\N	\N	0	86444	0	1920-8	3013721		
50427	4595	3006322	1992-11-20	1992-11-20 00:00:00	1992-11-20	5001	0	\N	0	0	\N	\N	0	306170	0	8331-1	3006322		
32214	2925	40769179	1963-05-08	1963-05-08 00:00:00	1963-05-08	5001	0	\N	0	0	\N	\N	0	194995	0	66519-0	40769179		
47951	4390	3006322	2009-02-11	2009-02-11 00:00:00	2009-02-11	5001	0	\N	0	0	\N	\N	0	291922	0	8331-1	3006322		
36811	3376	3006322	1977-04-07	1977-04-07 00:00:00	1977-04-07	5001	0	\N	0	0	\N	\N	0	223954	0	8331-1	3006322		
15611	1431	3014599	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	95212	0	6106-9	3014599		
118134	3636	4052083	1993-11-17	1993-11-17 00:00:00	1993-11-17	5001	0	\N	0	0	\N	\N	0	241780	0	23426006	4052083		
49238	4498	3006734	1978-03-01	1978-03-01 00:00:00	1978-03-01	5001	0	\N	0	0	\N	\N	0	299481	0	6189-5	3006734		
49306	4501	40766240	1974-01-29	1974-01-29 00:00:00	1974-01-29	5001	0	\N	0	0	\N	\N	0	299678	0	63513-6	40766240		
31522	2890	3006322	2016-09-15	2016-09-15 00:00:00	2016-09-15	5001	0	\N	0	0	\N	\N	0	192224	0	8331-1	3006322		
31601	2893	3006322	1952-08-23	1952-08-23 00:00:00	1952-08-23	5001	0	\N	0	0	\N	\N	0	192452	0	8331-1	3006322		
53078	4878	3012494	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	324320	0	6206-7	3012494		
33434	3025	3036780	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	201615	0	6095-4	3036780		
44770	4134	3006322	1981-09-09	1981-09-09 00:00:00	1981-09-09	5001	0	\N	0	0	\N	\N	0	274896	0	8331-1	3006322		
16513	1506	3006322	1948-10-22	1948-10-22 00:00:00	1948-10-22	5001	0	\N	0	0	\N	\N	0	100445	0	8331-1	3006322		
51163	4677	3006322	1964-01-14	1964-01-14 00:00:00	1964-01-14	5001	0	\N	0	0	\N	\N	0	311642	0	8331-1	3006322		
40393	3754	3036780	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	249539	0	6095-4	3036780		
55349	5068	3006322	1953-04-22	1953-04-22 00:00:00	1953-04-22	5001	0	\N	0	0	\N	\N	0	336968	0	8331-1	3006322		
42644	1314	4024958	1941-05-25	1941-05-25 00:00:00	1941-05-25	5001	0	\N	0	0	\N	\N	0	86981	0	117015009	4024958		
29171	2686	3051031	2002-10-09	2002-10-09 00:00:00	2002-10-09	5001	0	\N	0	0	\N	\N	0	178030	0	46240-8	3051031		
12124	1149	3006322	2011-04-12	2011-04-12 00:00:00	2011-04-12	5001	0	\N	0	0	\N	\N	0	75954	0	8331-1	3006322		
33764	3065	3006322	1989-10-26	1989-10-26 00:00:00	1989-10-26	5001	0	\N	0	0	\N	\N	0	204003	0	8331-1	3006322		
84414	2615	4052083	1993-01-28	1993-01-28 00:00:00	1993-01-28	5001	0	\N	0	0	\N	\N	0	172929	0	23426006	4052083		
26826	2482	3006322	1984-02-24	1984-02-24 00:00:00	1984-02-24	5001	0	\N	0	0	\N	\N	0	164424	0	8331-1	3006322		
39264	1222	4024958	2017-08-10	2017-08-10 00:00:00	2017-08-10	5001	0	\N	0	0	\N	\N	0	80405	0	117015009	4024958		
40232	3745	3011505	2011-09-07	2011-09-07 00:00:00	2011-09-07	5001	0	\N	0	0	\N	\N	0	248964	0	19926-5	3011505		
20026	1843	3006322	2000-08-22	2000-08-22 00:00:00	2000-08-22	5001	0	\N	0	0	\N	\N	0	123042	0	8331-1	3006322		
49705	4520	3011505	1985-12-07	1985-12-07 00:00:00	1985-12-07	5001	0	\N	0	0	\N	\N	0	300932	0	19926-5	3011505		
32236	2926	3006322	1992-08-25	1992-08-25 00:00:00	1992-08-25	5001	0	\N	0	0	\N	\N	0	195190	0	8331-1	3006322		
174329	5343	4024958	2010-04-01	2010-04-01 00:00:00	2010-04-01	5001	0	\N	0	0	\N	\N	0	355826	0	117015009	4024958		
26879	2487	3006322	1966-03-16	1966-03-16 00:00:00	1966-03-16	5001	0	\N	0	0	\N	\N	0	164812	0	8331-1	3006322		
78496	2409	4024958	1982-02-16	1982-02-16 00:00:00	1982-02-16	5001	0	\N	0	0	\N	\N	0	159945	0	117015009	4024958		
21197	1958	3006322	1981-05-19	1981-05-19 00:00:00	1981-05-19	5001	0	\N	0	0	\N	\N	0	130255	0	8331-1	3006322		
6560	615	3015076	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	40960	0	6248-9	3015076		
17917	1626	3023103	1989-12-17	1989-12-17 00:00:00	1989-12-17	5001	0	\N	0	0	\N	\N	0	109189	0	2823-3	3023103		
1789	158	3006322	1955-05-05	1955-05-05 00:00:00	1955-05-05	5001	0	\N	0	0	\N	\N	0	10820	0	8331-1	3006322		
34442	3141	3006322	2010-11-13	2010-11-13 00:00:00	2010-11-13	5001	0	\N	0	0	\N	\N	0	208981	0	8331-1	3006322		
31805	975	4052083	2003-01-27	2003-01-27 00:00:00	2003-01-27	5001	0	\N	0	0	\N	\N	0	65024	0	23426006	4052083		
6317	597	3006322	1962-06-14	1962-06-14 00:00:00	1962-06-14	5001	0	\N	0	0	\N	\N	0	39422	0	8331-1	3006322		
29731	918	4024958	1948-05-27	1948-05-27 00:00:00	1948-05-27	5001	0	\N	0	0	\N	\N	0	61188	0	117015009	4024958		
17730	1611	3006322	1981-04-10	1981-04-10 00:00:00	1981-04-10	5001	0	\N	0	0	\N	\N	0	108276	0	8331-1	3006322		
1425	124	3006451	2000-09-12	2000-09-12 00:00:00	2000-09-12	5001	0	\N	0	0	\N	\N	0	8277	0	6273-7	3006451		
22701	711	4024958	1959-10-19	1959-10-19 00:00:00	1959-10-19	5001	0	\N	0	0	\N	\N	0	47163	0	117015009	4024958		
51694	1565	4052083	1998-03-14	1998-03-14 00:00:00	1998-03-14	5001	0	\N	0	0	\N	\N	0	104919	0	23426006	4052083		
47561	4372	3014599	1993-05-13	1993-05-13 00:00:00	1993-05-13	5001	0	\N	0	0	\N	\N	0	290262	0	6106-9	3014599		
36988	3399	3006322	2010-08-01	2010-08-01 00:00:00	2010-08-01	5001	0	\N	0	0	\N	\N	0	225538	0	8331-1	3006322		
87312	2699	4052083	1980-11-18	1980-11-18 00:00:00	1980-11-18	5001	0	\N	0	0	\N	\N	0	178717	0	23426006	4052083		
16313	1486	3020655	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	99139	0	6844-5	3020655		
143515	4411	4052083	1946-03-13	1946-03-13 00:00:00	1946-03-13	5001	0	\N	0	0	\N	\N	0	293185	0	23426006	4052083		
100424	3081	4024958	1980-08-19	1980-08-19 00:00:00	1980-08-19	5001	0	\N	0	0	\N	\N	0	205118	0	117015009	4024958		
3350	326	3006322	1985-03-11	1985-03-11 00:00:00	1985-03-11	5001	0	\N	0	0	\N	\N	0	21554	0	8331-1	3006322		
49569	4509	3011505	2005-04-26	2005-04-26 00:00:00	2005-04-26	5001	0	\N	0	0	\N	\N	0	300398	0	19926-5	3011505		
42909	1320	4052083	1985-10-11	1985-10-11 00:00:00	1985-10-11	5001	0	\N	0	0	\N	\N	0	87483	0	23426006	4052083		
50667	4622	3006322	2017-07-31	2017-07-31 00:00:00	2017-07-31	5001	0	\N	0	0	\N	\N	0	307841	0	8331-1	3006322		
34216	3118	3000876	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	207442	0	6082-2	3000876		
34256	3118	3001247	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	207486	0	6085-5	3001247		
42480	3926	3011505	2015-07-13	2015-07-13 00:00:00	2015-07-13	5001	0	\N	0	0	\N	\N	0	260957	0	19926-5	3011505		
2132	191	3011505	2001-11-06	2001-11-06 00:00:00	2001-11-06	5001	0	\N	0	0	\N	\N	0	13130	0	19926-5	3011505		
8952	857	3011505	2002-03-03	2002-03-03 00:00:00	2002-03-03	5001	0	\N	0	0	\N	\N	0	56623	0	19926-5	3011505		
136572	4210	4052083	2007-02-02	2007-02-02 00:00:00	2007-02-02	5001	0	\N	0	0	\N	\N	0	279523	0	23426006	4052083		
38685	3577	3006322	2014-05-14	2014-05-14 00:00:00	2014-05-14	5001	0	\N	0	0	\N	\N	0	237802	0	8331-1	3006322		
11942	1138	3014599	1996-08-08	1996-08-08 00:00:00	1996-08-08	5001	0	\N	0	0	\N	\N	0	75088	0	6106-9	3014599		
38825	3589	3005136	1997-07-08	1997-07-08 00:00:00	1997-07-08	5001	0	\N	0	0	\N	\N	0	238474	0	6075-6	3005136		
13941	1309	3009542	1994-03-21	1994-03-21 00:00:00	1994-03-21	5001	0	\N	0	0	\N	\N	0	86444	0	20570-8	3009542		
50428	4595	3006322	1981-05-11	1981-05-11 00:00:00	1981-05-11	5001	0	\N	0	0	\N	\N	0	306169	0	8331-1	3006322		
32215	2925	40769189	1963-05-08	1963-05-08 00:00:00	1963-05-08	5001	0	\N	0	0	\N	\N	0	194995	0	66529-9	40769189		
47952	4390	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	291804	0	6085-5	3001247		
36812	3376	3049273	2017-10-08	2017-10-08 00:00:00	2017-10-08	5001	0	\N	0	0	\N	\N	0	224003	0	38265-5	3049273		
15612	1431	3027231	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	95212	0	6276-0	3027231		
8696	842	3011505	1991-06-08	1991-06-08 00:00:00	1991-06-08	5001	0	\N	0	0	\N	\N	0	55740	0	19926-5	3011505		
49239	4498	3006451	1978-03-01	1978-03-01 00:00:00	1978-03-01	5001	0	\N	0	0	\N	\N	0	299481	0	6273-7	3006451		
49307	4501	3006322	1973-11-29	1973-11-29 00:00:00	1973-11-29	5001	0	\N	0	0	\N	\N	0	299677	0	8331-1	3006322		
31523	2890	3006322	2015-03-16	2015-03-16 00:00:00	2015-03-16	5001	0	\N	0	0	\N	\N	0	192223	0	8331-1	3006322		
31602	2893	3006322	1970-11-10	1970-11-10 00:00:00	1970-11-10	5001	0	\N	0	0	\N	\N	0	192540	0	8331-1	3006322		
53079	4878	3027231	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	324320	0	6276-0	3027231		
35165	1097	4024958	1986-06-23	1986-06-23 00:00:00	1986-06-23	5001	0	\N	0	0	\N	\N	0	72006	0	117015009	4024958		
44771	4134	3006322	1985-08-18	1985-08-18 00:00:00	1985-08-18	5001	0	\N	0	0	\N	\N	0	274897	0	8331-1	3006322		
16514	1506	3049273	2006-04-01	2006-04-01 00:00:00	2006-04-01	5001	0	\N	0	0	\N	\N	0	100480	0	38265-5	3049273		
51164	4677	3006322	1983-11-06	1983-11-06 00:00:00	1983-11-06	5001	0	\N	0	0	\N	\N	0	311646	0	8331-1	3006322		
40394	3754	3012494	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	249539	0	6206-7	3012494		
55350	5068	3006322	1974-04-16	1974-04-16 00:00:00	1974-04-16	5001	0	\N	0	0	\N	\N	0	336947	0	8331-1	3006322		
42645	1314	4024958	1977-01-01	1977-01-01 00:00:00	1977-01-01	5001	0	\N	0	0	\N	\N	0	86988	0	117015009	4024958		
29172	2686	3006322	1956-11-02	1956-11-02 00:00:00	1956-11-02	5001	0	\N	0	0	\N	\N	0	178015	0	8331-1	3006322		
12125	1149	3006322	1997-05-28	1997-05-28 00:00:00	1997-05-28	5001	0	\N	0	0	\N	\N	0	75951	0	8331-1	3006322		
33765	3065	3006322	2001-10-05	2001-10-05 00:00:00	2001-10-05	5001	0	\N	0	0	\N	\N	0	204023	0	8331-1	3006322		
84429	2615	4024958	1986-03-22	1986-03-22 00:00:00	1986-03-22	5001	0	\N	0	0	\N	\N	0	172897	0	117015009	4024958		
171428	5259	4024958	1994-09-03	1994-09-03 00:00:00	1994-09-03	5001	0	\N	0	0	\N	\N	0	349996	0	117015009	4024958		
39281	1222	4052083	1988-12-27	1988-12-27 00:00:00	1988-12-27	5001	0	\N	0	0	\N	\N	0	80370	0	23426006	4052083		
40233	3745	3011505	2013-09-18	2013-09-18 00:00:00	2013-09-18	5001	0	\N	0	0	\N	\N	0	248965	0	19926-5	3011505		
20027	1843	3006322	1994-08-12	1994-08-12 00:00:00	1994-08-12	5001	0	\N	0	0	\N	\N	0	123013	0	8331-1	3006322		
49706	4520	3011505	1957-09-14	1957-09-14 00:00:00	1957-09-14	5001	0	\N	0	0	\N	\N	0	300899	0	19926-5	3011505		
32237	2927	3006322	1994-11-18	1994-11-18 00:00:00	1994-11-18	5001	0	\N	0	0	\N	\N	0	195211	0	8331-1	3006322		
174341	5343	4024958	1994-08-30	1994-08-30 00:00:00	1994-08-30	5001	0	\N	0	0	\N	\N	0	355876	0	117015009	4024958		
26880	2487	3006322	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	164790	0	8331-1	3006322		
78497	2409	4052083	1993-11-12	1993-11-12 00:00:00	1993-11-12	5001	0	\N	0	0	\N	\N	0	159901	0	23426006	4052083		
21198	1958	3006322	1972-04-23	1972-04-23 00:00:00	1972-04-23	5001	0	\N	0	0	\N	\N	0	130254	0	8331-1	3006322		
6561	615	3012494	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	40960	0	6206-7	3012494		
17918	1626	3015632	1989-12-17	1989-12-17 00:00:00	1989-12-17	5001	0	\N	0	0	\N	\N	0	109189	0	2028-9	3015632		
1790	159	3006322	1968-08-29	1968-08-29 00:00:00	1968-08-29	5001	0	\N	0	0	\N	\N	0	10855	0	8331-1	3006322		
34448	3144	3006322	1981-07-10	1981-07-10 00:00:00	1981-07-10	5001	0	\N	0	0	\N	\N	0	209202	0	8331-1	3006322		
86369	2672	4052083	1958-08-17	1958-08-17 00:00:00	1958-08-17	5001	0	\N	0	0	\N	\N	0	176962	0	23426006	4052083		
6318	597	3006322	2003-06-21	2003-06-21 00:00:00	2003-06-21	5001	0	\N	0	0	\N	\N	0	39447	0	8331-1	3006322		
29746	918	4052083	1941-10-11	1941-10-11 00:00:00	1941-10-11	5001	0	\N	0	0	\N	\N	0	61187	0	23426006	4052083		
17731	1611	3006322	1998-12-23	1998-12-23 00:00:00	1998-12-23	5001	0	\N	0	0	\N	\N	0	108318	0	8331-1	3006322		
1426	124	3001488	2000-09-12	2000-09-12 00:00:00	2000-09-12	5001	0	\N	0	0	\N	\N	0	8277	0	7258-7	3001488		
109144	3370	4024958	1976-06-08	1976-06-08 00:00:00	1976-06-08	5001	0	\N	0	0	\N	\N	0	223396	0	117015009	4024958		
51714	1565	4024958	1972-02-07	1972-02-07 00:00:00	1972-02-07	5001	0	\N	0	0	\N	\N	0	104916	0	117015009	4024958		
47562	4372	3001247	1993-05-13	1993-05-13 00:00:00	1993-05-13	5001	0	\N	0	0	\N	\N	0	290262	0	6085-5	3001247		
36989	3399	3001247	1996-02-12	1996-02-12 00:00:00	1996-02-12	5001	0	\N	0	0	\N	\N	0	225512	0	6085-5	3001247		
37016	3403	3006322	1980-11-01	1980-11-01 00:00:00	1980-11-01	5001	0	\N	0	0	\N	\N	0	225740	0	8331-1	3006322		
16314	1486	3001488	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	99139	0	7258-7	3001488		
143628	4413	4052083	1976-08-04	1976-08-04 00:00:00	1976-08-04	5001	0	\N	0	0	\N	\N	0	293490	0	23426006	4052083		
100428	3081	4052083	1975-05-31	1975-05-31 00:00:00	1975-05-31	5001	0	\N	0	0	\N	\N	0	205159	0	23426006	4052083		
3351	326	3006322	1972-02-22	1972-02-22 00:00:00	1972-02-22	5001	0	\N	0	0	\N	\N	0	21542	0	8331-1	3006322		
49570	4509	3011505	2015-09-22	2015-09-22 00:00:00	2015-09-22	5001	0	\N	0	0	\N	\N	0	300350	0	19926-5	3011505		
42919	1321	4052083	1965-02-01	1965-02-01 00:00:00	1965-02-01	5001	0	\N	0	0	\N	\N	0	87657	0	23426006	4052083		
50668	4622	3006322	1994-11-01	1994-11-01 00:00:00	1994-11-01	5001	0	\N	0	0	\N	\N	0	307806	0	8331-1	3006322		
34217	3118	3027231	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	207442	0	6276-0	3027231		
34257	3119	3006322	1984-09-26	1984-09-26 00:00:00	1984-09-26	5001	0	\N	0	0	\N	\N	0	207584	0	8331-1	3006322		
42481	3926	3011505	2013-07-01	2013-07-01 00:00:00	2013-07-01	5001	0	\N	0	0	\N	\N	0	260934	0	19926-5	3011505		
2134	191	3011505	1997-10-14	1997-10-14 00:00:00	1997-10-14	5001	0	\N	0	0	\N	\N	0	13026	0	19926-5	3011505		
8953	858	3006322	1997-12-22	1997-12-22 00:00:00	1997-12-22	5001	0	\N	0	0	\N	\N	0	56689	0	8331-1	3006322		
136573	4210	4024958	1978-10-17	1978-10-17 00:00:00	1978-10-17	5001	0	\N	0	0	\N	\N	0	279519	0	117015009	4024958		
38686	3577	3006322	1993-07-13	1993-07-13 00:00:00	1993-07-13	5001	0	\N	0	0	\N	\N	0	237793	0	8331-1	3006322		
11943	1138	3005136	1996-08-08	1996-08-08 00:00:00	1996-08-08	5001	0	\N	0	0	\N	\N	0	75088	0	6075-6	3005136		
38826	3589	3012494	1997-07-08	1997-07-08 00:00:00	1997-07-08	5001	0	\N	0	0	\N	\N	0	238474	0	6206-7	3012494		
13942	1310	40758406	2003-06-14	2003-06-14 00:00:00	2003-06-14	5001	0	\N	0	0	\N	\N	0	86621	0	55277-8	40758406		
50429	4595	3006322	1975-11-23	1975-11-23 00:00:00	1975-11-23	5001	0	\N	0	0	\N	\N	0	306185	0	8331-1	3006322		
32216	2925	3006322	1962-03-01	1962-03-01 00:00:00	1962-03-01	5001	0	\N	0	0	\N	\N	0	195089	0	8331-1	3006322		
47953	4390	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	291804	0	6189-5	3006734		
36815	3378	3049273	2017-04-20	2017-04-20 00:00:00	2017-04-20	5001	0	\N	0	0	\N	\N	0	224120	0	38265-5	3049273		
15613	1431	3005136	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	95212	0	6075-6	3005136		
8697	842	3011505	1965-10-16	1965-10-16 00:00:00	1965-10-16	5001	0	\N	0	0	\N	\N	0	55731	0	19926-5	3011505		
49240	4498	3014599	1978-03-01	1978-03-01 00:00:00	1978-03-01	5001	0	\N	0	0	\N	\N	0	299481	0	6106-9	3014599		
49309	4501	3051031	1974-09-26	1974-09-26 00:00:00	1974-09-26	5001	0	\N	0	0	\N	\N	0	299703	0	46240-8	3051031		
31524	2890	40758406	1963-02-06	1963-02-06 00:00:00	1963-02-06	5001	0	\N	0	0	\N	\N	0	192231	0	55277-8	40758406		
31603	2893	3006322	1966-01-23	1966-01-23 00:00:00	1966-01-23	5001	0	\N	0	0	\N	\N	0	192456	0	8331-1	3006322		
53080	4878	3005136	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	324320	0	6075-6	3005136		
35169	1097	4024958	1969-09-25	1969-09-25 00:00:00	1969-09-25	5001	0	\N	0	0	\N	\N	0	72014	0	117015009	4024958		
44772	4134	3006322	1964-01-20	1964-01-20 00:00:00	1964-01-20	5001	0	\N	0	0	\N	\N	0	274843	0	8331-1	3006322		
16515	1506	3006322	1959-07-08	1959-07-08 00:00:00	1959-07-08	5001	0	\N	0	0	\N	\N	0	100411	0	8331-1	3006322		
51165	4677	3006322	1965-10-18	1965-10-18 00:00:00	1965-10-18	5001	0	\N	0	0	\N	\N	0	311643	0	8331-1	3006322		
40395	3754	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	249504	0	6833-8	3023430		
55351	5068	3006322	1946-12-15	1946-12-15 00:00:00	1946-12-15	5001	0	\N	0	0	\N	\N	0	337007	0	8331-1	3006322		
42657	1314	4052083	1970-12-14	1970-12-14 00:00:00	1970-12-14	5001	0	\N	0	0	\N	\N	0	87037	0	23426006	4052083		
29173	2686	3051031	2003-03-08	2003-03-08 00:00:00	2003-03-08	5001	0	\N	0	0	\N	\N	0	178052	0	46240-8	3051031		
12126	1150	3006322	1998-04-03	1998-04-03 00:00:00	1998-04-03	5001	0	\N	0	0	\N	\N	0	76001	0	8331-1	3006322		
33766	3065	3006322	1977-11-13	1977-11-13 00:00:00	1977-11-13	5001	0	\N	0	0	\N	\N	0	204035	0	8331-1	3006322		
84441	2616	4024958	1966-03-02	1966-03-02 00:00:00	1966-03-02	5001	0	\N	0	0	\N	\N	0	173011	0	117015009	4024958		
171431	5259	4024958	1973-08-24	1973-08-24 00:00:00	1973-08-24	5001	0	\N	0	0	\N	\N	0	349943	0	117015009	4024958		
39288	1222	4052083	1975-06-12	1975-06-12 00:00:00	1975-06-12	5001	0	\N	0	0	\N	\N	0	80427	0	23426006	4052083		
40234	3745	3011505	2012-09-12	2012-09-12 00:00:00	2012-09-12	5001	0	\N	0	0	\N	\N	0	248970	0	19926-5	3011505		
20028	1843	3006322	2002-08-25	2002-08-25 00:00:00	2002-08-25	5001	0	\N	0	0	\N	\N	0	122993	0	8331-1	3006322		
49707	4520	40758406	1928-06-07	1928-06-07 00:00:00	1928-06-07	5001	0	\N	0	0	\N	\N	0	300896	0	55277-8	40758406		
32238	2927	3049273	2010-09-13	2010-09-13 00:00:00	2010-09-13	5001	0	\N	0	0	\N	\N	0	195300	0	38265-5	3049273		
720	49	3006322	2011-06-14	2011-06-14 00:00:00	2011-06-14	5001	0	\N	0	0	\N	\N	0	3565	0	8331-1	3006322		
26907	2495	3006322	1987-05-30	1987-05-30 00:00:00	1987-05-30	5001	0	\N	0	0	\N	\N	0	165124	0	8331-1	3006322		
78502	2409	4024958	1996-09-19	1996-09-19 00:00:00	1996-09-19	5001	0	\N	0	0	\N	\N	0	159914	0	117015009	4024958		
21199	1958	3006322	1996-11-26	1996-11-26 00:00:00	1996-11-26	5001	0	\N	0	0	\N	\N	0	130248	0	8331-1	3006322		
6562	615	3006322	2004-06-18	2004-06-18 00:00:00	2004-06-18	5001	0	\N	0	0	\N	\N	0	40905	0	8331-1	3006322		
17919	1626	3006923	1989-12-17	1989-12-17 00:00:00	1989-12-17	5001	0	\N	0	0	\N	\N	0	109189	0	1742-6	3006923		
121103	3739	4024958	2005-03-26	2005-03-26 00:00:00	2005-03-26	5001	0	\N	0	0	\N	\N	0	248422	0	117015009	4024958		
34449	3144	3006322	1964-01-28	1964-01-28 00:00:00	1964-01-28	5001	0	\N	0	0	\N	\N	0	209179	0	8331-1	3006322		
86377	2672	4024958	1986-05-17	1986-05-17 00:00:00	1986-05-17	5001	0	\N	0	0	\N	\N	0	176985	0	117015009	4024958		
6319	598	3006322	2001-11-10	2001-11-10 00:00:00	2001-11-10	5001	0	\N	0	0	\N	\N	0	39476	0	8331-1	3006322		
7085	680	3027231	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	44996	0	6276-0	3027231		
17732	1611	3006322	2002-12-18	2002-12-18 00:00:00	2002-12-18	5001	0	\N	0	0	\N	\N	0	108351	0	8331-1	3006322		
1427	124	3036780	2000-09-12	2000-09-12 00:00:00	2000-09-12	5001	0	\N	0	0	\N	\N	0	8277	0	6095-4	3036780		
109155	3371	4024958	1982-07-21	1982-07-21 00:00:00	1982-07-21	5001	0	\N	0	0	\N	\N	0	223574	0	117015009	4024958		
120495	3717	4052083	1989-11-14	1989-11-14 00:00:00	1989-11-14	5001	0	\N	0	0	\N	\N	0	247078	0	23426006	4052083		
47563	4372	3006734	1993-05-13	1993-05-13 00:00:00	1993-05-13	5001	0	\N	0	0	\N	\N	0	290262	0	6189-5	3006734		
36990	3399	3001488	1996-02-12	1996-02-12 00:00:00	1996-02-12	5001	0	\N	0	0	\N	\N	0	225512	0	7258-7	3001488		
37017	3403	3006322	1997-06-15	1997-06-15 00:00:00	1997-06-15	5001	0	\N	0	0	\N	\N	0	225756	0	8331-1	3006322		
16315	1486	3005136	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	99139	0	6075-6	3005136		
143640	4413	4024958	1986-01-20	1986-01-20 00:00:00	1986-01-20	5001	0	\N	0	0	\N	\N	0	293457	0	117015009	4024958		
100448	3082	4024958	1987-02-06	1987-02-06 00:00:00	1987-02-06	5001	0	\N	0	0	\N	\N	0	205236	0	117015009	4024958		
3352	327	3006322	1990-10-20	1990-10-20 00:00:00	1990-10-20	5001	0	\N	0	0	\N	\N	0	21594	0	8331-1	3006322		
49571	4509	3011505	2002-04-23	2002-04-23 00:00:00	2002-04-23	5001	0	\N	0	0	\N	\N	0	300397	0	19926-5	3011505		
42940	1321	4052083	1968-01-26	1968-01-26 00:00:00	1968-01-26	5001	0	\N	0	0	\N	\N	0	87650	0	23426006	4052083		
50669	4622	3006322	2018-12-04	2018-12-04 00:00:00	2018-12-04	5001	0	\N	0	0	\N	\N	0	307783	0	8331-1	3006322		
34218	3118	3001247	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	207442	0	6085-5	3001247		
34280	3123	3006322	2013-07-31	2013-07-31 00:00:00	2013-07-31	5001	0	\N	0	0	\N	\N	0	207836	0	8331-1	3006322		
2790	270	3006322	1993-08-24	1993-08-24 00:00:00	1993-08-24	5001	0	\N	0	0	\N	\N	0	17960	0	8331-1	3006322		
2136	191	3051031	1963-01-17	1963-01-17 00:00:00	1963-01-17	5001	0	\N	0	0	\N	\N	0	13056	0	46240-8	3051031		
8954	858	3006322	1975-02-10	1975-02-10 00:00:00	1975-02-10	5001	0	\N	0	0	\N	\N	0	56697	0	8331-1	3006322		
147855	4531	4024958	1923-10-12	1923-10-12 00:00:00	1923-10-12	5001	0	\N	0	0	\N	\N	0	301736	0	117015009	4024958		
38687	3577	3006322	2015-02-18	2015-02-18 00:00:00	2015-02-18	5001	0	\N	0	0	\N	\N	0	237803	0	8331-1	3006322		
11944	1138	3015076	1996-08-08	1996-08-08 00:00:00	1996-08-08	5001	0	\N	0	0	\N	\N	0	75088	0	6248-9	3015076		
38827	3589	3014599	1997-07-08	1997-07-08 00:00:00	1997-07-08	5001	0	\N	0	0	\N	\N	0	238474	0	6106-9	3014599		
13943	1310	40766240	2003-06-14	2003-06-14 00:00:00	2003-06-14	5001	0	\N	0	0	\N	\N	0	86621	0	63513-6	40766240		
50430	4596	3006322	1941-01-25	1941-01-25 00:00:00	1941-01-25	5001	0	\N	0	0	\N	\N	0	306259	0	8331-1	3006322		
32217	2925	3006322	1999-11-05	1999-11-05 00:00:00	1999-11-05	5001	0	\N	0	0	\N	\N	0	195009	0	8331-1	3006322		
47954	4390	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	291804	0	7258-7	3001488		
36816	3378	3006322	1998-12-10	1998-12-10 00:00:00	1998-12-10	5001	0	\N	0	0	\N	\N	0	224127	0	8331-1	3006322		
15614	1431	3019406	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	95212	0	6158-0	3019406		
8698	842	3011505	1978-12-30	1978-12-30 00:00:00	1978-12-30	5001	0	\N	0	0	\N	\N	0	55735	0	19926-5	3011505		
49241	4498	3015076	1978-03-01	1978-03-01 00:00:00	1978-03-01	5001	0	\N	0	0	\N	\N	0	299481	0	6248-9	3015076		
49310	4501	40766240	1974-09-26	1974-09-26 00:00:00	1974-09-26	5001	0	\N	0	0	\N	\N	0	299703	0	63513-6	40766240		
31526	2890	3051031	1963-02-06	1963-02-06 00:00:00	1963-02-06	5001	0	\N	0	0	\N	\N	0	192231	0	46240-8	3051031		
31604	2893	3006322	1980-11-25	1980-11-25 00:00:00	1980-11-25	5001	0	\N	0	0	\N	\N	0	192532	0	8331-1	3006322		
53081	4878	3014599	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	324320	0	6106-9	3014599		
35170	1097	4052083	1978-07-10	1978-07-10 00:00:00	1978-07-10	5001	0	\N	0	0	\N	\N	0	72015	0	23426006	4052083		
44773	4134	3006322	2000-11-12	2000-11-12 00:00:00	2000-11-12	5001	0	\N	0	0	\N	\N	0	274832	0	8331-1	3006322		
16516	1506	3006322	1971-02-01	1971-02-01 00:00:00	1971-02-01	5001	0	\N	0	0	\N	\N	0	100401	0	8331-1	3006322		
51166	4677	3006322	2016-04-22	2016-04-22 00:00:00	2016-04-22	5001	0	\N	0	0	\N	\N	0	311648	0	8331-1	3006322		
40396	3754	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	249504	0	6189-5	3006734		
55352	5068	3006322	1931-08-20	1931-08-20 00:00:00	1931-08-20	5001	0	\N	0	0	\N	\N	0	336967	0	8331-1	3006322		
42660	1314	4024958	1935-06-21	1935-06-21 00:00:00	1935-06-21	5001	0	\N	0	0	\N	\N	0	87019	0	117015009	4024958		
29174	2686	40758406	2003-03-08	2003-03-08 00:00:00	2003-03-08	5001	0	\N	0	0	\N	\N	0	178052	0	55277-8	40758406		
12127	1150	3006322	1973-05-25	1973-05-25 00:00:00	1973-05-25	5001	0	\N	0	0	\N	\N	0	76002	0	8331-1	3006322		
33767	3067	3049273	2015-11-09	2015-11-09 00:00:00	2015-11-09	5001	0	\N	0	0	\N	\N	0	204189	0	38265-5	3049273		
61768	1892	4133840	2018-08-30	2018-08-30 00:00:00	2018-08-30	5001	0	\N	0	0	\N	\N	0	126023	0	127783003	4133840		
171447	5259	4024958	1966-05-20	1966-05-20 00:00:00	1966-05-20	5001	0	\N	0	0	\N	\N	0	349933	0	117015009	4024958		
39293	1222	4052083	1969-06-04	1969-06-04 00:00:00	1969-06-04	5001	0	\N	0	0	\N	\N	0	80432	0	23426006	4052083		
40235	3745	3011505	2010-09-01	2010-09-01 00:00:00	2010-09-01	5001	0	\N	0	0	\N	\N	0	248969	0	19926-5	3011505		
20029	1843	3001247	1998-02-25	1998-02-25 00:00:00	1998-02-25	5001	0	\N	0	0	\N	\N	0	123041	0	6085-5	3001247		
49708	4520	46235214	1928-06-07	1928-06-07 00:00:00	1928-06-07	5001	0	\N	0	0	\N	\N	0	300896	0	76690-7	46235214		
32240	2929	3006322	1994-01-06	1994-01-06 00:00:00	1994-01-06	5001	0	\N	0	0	\N	\N	0	195366	0	8331-1	3006322		
721	49	3006322	1988-02-03	1988-02-03 00:00:00	1988-02-03	5001	0	\N	0	0	\N	\N	0	3515	0	8331-1	3006322		
26908	2495	3006322	2013-04-05	2013-04-05 00:00:00	2013-04-05	5001	0	\N	0	0	\N	\N	0	165163	0	8331-1	3006322		
78507	2409	4024958	2017-04-10	2017-04-10 00:00:00	2017-04-10	5001	0	\N	0	0	\N	\N	0	159937	0	117015009	4024958		
21200	1958	3006322	1995-04-24	1995-04-24 00:00:00	1995-04-24	5001	0	\N	0	0	\N	\N	0	130258	0	8331-1	3006322		
6563	615	3006322	1911-07-20	1911-07-20 00:00:00	1911-07-20	5001	0	\N	0	0	\N	\N	0	40862	0	8331-1	3006322		
17920	1626	3024731	1989-12-17	1989-12-17 00:00:00	1989-12-17	5001	0	\N	0	0	\N	\N	0	109189	0	30428-7	3024731		
121108	3739	4024958	2000-09-19	2000-09-19 00:00:00	2000-09-19	5001	0	\N	0	0	\N	\N	0	248446	0	117015009	4024958		
34450	3145	3006322	1973-04-19	1973-04-19 00:00:00	1973-04-19	5001	0	\N	0	0	\N	\N	0	209262	0	8331-1	3006322		
86383	2672	4052083	1978-07-13	1978-07-13 00:00:00	1978-07-13	5001	0	\N	0	0	\N	\N	0	177025	0	23426006	4052083		
6320	598	3006322	2000-05-07	2000-05-07 00:00:00	2000-05-07	5001	0	\N	0	0	\N	\N	0	39503	0	8331-1	3006322		
7086	680	3014599	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	44996	0	6106-9	3014599		
17733	1611	3006322	1952-08-09	1952-08-09 00:00:00	1952-08-09	5001	0	\N	0	0	\N	\N	0	108347	0	8331-1	3006322		
1428	124	3020655	2000-09-12	2000-09-12 00:00:00	2000-09-12	5001	0	\N	0	0	\N	\N	0	8277	0	6844-5	3020655		
109166	3371	4052083	1999-08-11	1999-08-11 00:00:00	1999-08-11	5001	0	\N	0	0	\N	\N	0	223570	0	23426006	4052083		
120505	3717	4024958	1977-07-05	1977-07-05 00:00:00	1977-07-05	5001	0	\N	0	0	\N	\N	0	246995	0	117015009	4024958		
47564	4372	3020655	1993-05-13	1993-05-13 00:00:00	1993-05-13	5001	0	\N	0	0	\N	\N	0	290262	0	6844-5	3020655		
36991	3399	3006734	1996-02-12	1996-02-12 00:00:00	1996-02-12	5001	0	\N	0	0	\N	\N	0	225512	0	6189-5	3006734		
37018	3403	3006322	2011-04-11	2011-04-11 00:00:00	2011-04-11	5001	0	\N	0	0	\N	\N	0	225758	0	8331-1	3006322		
16316	1486	3019406	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	99139	0	6158-0	3019406		
143643	4413	4024958	1992-03-02	1992-03-02 00:00:00	1992-03-02	5001	0	\N	0	0	\N	\N	0	293491	0	117015009	4024958		
100453	3082	4024958	1977-08-04	1977-08-04 00:00:00	1977-08-04	5001	0	\N	0	0	\N	\N	0	205179	0	117015009	4024958		
3353	328	3006322	2002-11-16	2002-11-16 00:00:00	2002-11-16	5001	0	\N	0	0	\N	\N	0	21664	0	8331-1	3006322		
49572	4509	3011505	1999-04-20	1999-04-20 00:00:00	1999-04-20	5001	0	\N	0	0	\N	\N	0	300396	0	19926-5	3011505		
42941	1321	4024958	1966-06-26	1966-06-26 00:00:00	1966-06-26	5001	0	\N	0	0	\N	\N	0	87639	0	117015009	4024958		
50670	4623	3006322	1943-09-22	1943-09-22 00:00:00	1943-09-22	5001	0	\N	0	0	\N	\N	0	307965	0	8331-1	3006322		
34219	3118	3023430	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	207442	0	6833-8	3023430		
34281	3123	3000876	1978-02-19	1978-02-19 00:00:00	1978-02-19	5001	0	\N	0	0	\N	\N	0	207805	0	6082-2	3000876		
2791	270	3006322	1968-07-15	1968-07-15 00:00:00	1968-07-15	5001	0	\N	0	0	\N	\N	0	18013	0	8331-1	3006322		
2138	191	40766240	1963-01-17	1963-01-17 00:00:00	1963-01-17	5001	0	\N	0	0	\N	\N	0	13056	0	63513-6	40766240		
8955	859	3006322	1963-10-02	1963-10-02 00:00:00	1963-10-02	5001	0	\N	0	0	\N	\N	0	56896	0	8331-1	3006322		
147859	4531	4052083	1941-09-17	1941-09-17 00:00:00	1941-09-17	5001	0	\N	0	0	\N	\N	0	301739	0	23426006	4052083		
38688	3578	3006322	1992-06-28	1992-06-28 00:00:00	1992-06-28	5001	0	\N	0	0	\N	\N	0	237869	0	8331-1	3006322		
11945	1138	3036780	1996-08-08	1996-08-08 00:00:00	1996-08-08	5001	0	\N	0	0	\N	\N	0	75088	0	6095-4	3036780		
38828	3589	3000876	1997-07-08	1997-07-08 00:00:00	1997-07-08	5001	0	\N	0	0	\N	\N	0	238474	0	6082-2	3000876		
13945	1310	46235214	2003-06-14	2003-06-14 00:00:00	2003-06-14	5001	0	\N	0	0	\N	\N	0	86621	0	76690-7	46235214		
50431	4596	3006322	2012-06-26	2012-06-26 00:00:00	2012-06-26	5001	0	\N	0	0	\N	\N	0	306293	0	8331-1	3006322		
32218	2925	3027231	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	195093	0	6276-0	3027231		
47955	4390	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	291804	0	6095-4	3036780		
36817	3378	3006322	1988-04-06	1988-04-06 00:00:00	1988-04-06	5001	0	\N	0	0	\N	\N	0	224125	0	8331-1	3006322		
15615	1431	3015076	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	95212	0	6248-9	3015076		
8699	842	3011505	1999-07-24	1999-07-24 00:00:00	1999-07-24	5001	0	\N	0	0	\N	\N	0	55698	0	19926-5	3011505		
49242	4498	3019406	1978-03-01	1978-03-01 00:00:00	1978-03-01	5001	0	\N	0	0	\N	\N	0	299481	0	6158-0	3019406		
49312	4501	46235214	1974-09-26	1974-09-26 00:00:00	1974-09-26	5001	0	\N	0	0	\N	\N	0	299703	0	76690-7	46235214		
31528	2890	40766240	1963-02-06	1963-02-06 00:00:00	1963-02-06	5001	0	\N	0	0	\N	\N	0	192231	0	63513-6	40766240		
31605	2894	3006322	2005-03-03	2005-03-03 00:00:00	2005-03-03	5001	0	\N	0	0	\N	\N	0	192587	0	8331-1	3006322		
53082	4878	3006451	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	324320	0	6273-7	3006451		
35182	1098	4024958	1995-07-21	1995-07-21 00:00:00	1995-07-21	5001	0	\N	0	0	\N	\N	0	72035	0	117015009	4024958		
44774	4134	3006322	1972-12-14	1972-12-14 00:00:00	1972-12-14	5001	0	\N	0	0	\N	\N	0	274895	0	8331-1	3006322		
16517	1506	3006322	1980-05-02	1980-05-02 00:00:00	1980-05-02	5001	0	\N	0	0	\N	\N	0	100414	0	8331-1	3006322		
51167	4678	3006322	1973-07-29	1973-07-29 00:00:00	1973-07-29	5001	0	\N	0	0	\N	\N	0	311736	0	8331-1	3006322		
40397	3754	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	249504	0	6273-7	3006451		
55353	5068	3006322	1971-12-06	1971-12-06 00:00:00	1971-12-06	5001	0	\N	0	0	\N	\N	0	336942	0	8331-1	3006322		
42662	1314	4024958	1938-03-31	1938-03-31 00:00:00	1938-03-31	5001	0	\N	0	0	\N	\N	0	87006	0	117015009	4024958		
29175	2686	40766240	2003-03-08	2003-03-08 00:00:00	2003-03-08	5001	0	\N	0	0	\N	\N	0	178052	0	63513-6	40766240		
12128	1150	3006322	1988-01-04	1988-01-04 00:00:00	1988-01-04	5001	0	\N	0	0	\N	\N	0	76004	0	8331-1	3006322		
33768	3067	3006322	2009-05-26	2009-05-26 00:00:00	2009-05-26	5001	0	\N	0	0	\N	\N	0	204117	0	8331-1	3006322		
61772	1892	4133840	2007-05-17	2007-05-17 00:00:00	2007-05-17	5001	0	\N	0	0	\N	\N	0	126021	0	127783003	4133840		
171475	5262	4024958	1977-12-01	1977-12-01 00:00:00	1977-12-01	5001	0	\N	0	0	\N	\N	0	350100	0	117015009	4024958		
39294	1222	4024958	1968-04-13	1968-04-13 00:00:00	1968-04-13	5001	0	\N	0	0	\N	\N	0	80413	0	117015009	4024958		
40236	3745	3006322	1934-06-22	1934-06-22 00:00:00	1934-06-22	5001	0	\N	0	0	\N	\N	0	248908	0	8331-1	3006322		
20030	1843	3006734	1998-02-25	1998-02-25 00:00:00	1998-02-25	5001	0	\N	0	0	\N	\N	0	123041	0	6189-5	3006734		
10750	340	4024958	2010-12-05	2010-12-05 00:00:00	2010-12-05	5001	0	\N	0	0	\N	\N	0	22673	0	117015009	4024958		
32241	2929	3006322	1999-02-21	1999-02-21 00:00:00	1999-02-21	5001	0	\N	0	0	\N	\N	0	195389	0	8331-1	3006322		
722	49	3049273	1980-02-26	1980-02-26 00:00:00	1980-02-26	5001	0	\N	0	0	\N	\N	0	3525	0	38265-5	3049273		
26909	2495	3006322	2010-10-06	2010-10-06 00:00:00	2010-10-06	5001	0	\N	0	0	\N	\N	0	165137	0	8331-1	3006322		
78510	2409	4024958	1992-12-30	1992-12-30 00:00:00	1992-12-30	5001	0	\N	0	0	\N	\N	0	159913	0	117015009	4024958		
21202	1960	3006322	1950-11-17	1950-11-17 00:00:00	1950-11-17	5001	0	\N	0	0	\N	\N	0	130321	0	8331-1	3006322		
6564	615	3006322	1929-07-17	1929-07-17 00:00:00	1929-07-17	5001	0	\N	0	0	\N	\N	0	40994	0	8331-1	3006322		
17921	1626	3004501	1989-12-17	1989-12-17 00:00:00	1989-12-17	5001	0	\N	0	0	\N	\N	0	109189	0	2345-7	3004501		
121109	3739	4024958	1979-07-17	1979-07-17 00:00:00	1979-07-17	5001	0	\N	0	0	\N	\N	0	248427	0	117015009	4024958		
34451	3147	3011505	2010-04-26	2010-04-26 00:00:00	2010-04-26	5001	0	\N	0	0	\N	\N	0	209389	0	19926-5	3011505		
86385	2672	4052083	1995-12-12	1995-12-12 00:00:00	1995-12-12	5001	0	\N	0	0	\N	\N	0	176941	0	23426006	4052083		
6323	600	3006322	2006-01-31	2006-01-31 00:00:00	2006-01-31	5001	0	\N	0	0	\N	\N	0	39620	0	8331-1	3006322		
7087	680	3006322	1991-06-20	1991-06-20 00:00:00	1991-06-20	5001	0	\N	0	0	\N	\N	0	45024	0	8331-1	3006322		
17735	1611	3006322	2003-01-28	2003-01-28 00:00:00	2003-01-28	5001	0	\N	0	0	\N	\N	0	108319	0	8331-1	3006322		
1429	124	3001247	2000-09-12	2000-09-12 00:00:00	2000-09-12	5001	0	\N	0	0	\N	\N	0	8277	0	6085-5	3001247		
109189	3371	4024958	1981-02-17	1981-02-17 00:00:00	1981-02-17	5001	0	\N	0	0	\N	\N	0	223602	0	117015009	4024958		
120516	3717	4024958	2010-02-02	2010-02-02 00:00:00	2010-02-02	5001	0	\N	0	0	\N	\N	0	246992	0	117015009	4024958		
47565	4372	3001488	1993-05-13	1993-05-13 00:00:00	1993-05-13	5001	0	\N	0	0	\N	\N	0	290262	0	7258-7	3001488		
36992	3399	3020655	1996-02-12	1996-02-12 00:00:00	1996-02-12	5001	0	\N	0	0	\N	\N	0	225512	0	6844-5	3020655		
48331	4436	3012494	1984-06-17	1984-06-17 00:00:00	1984-06-17	5001	0	\N	0	0	\N	\N	0	294875	0	6206-7	3012494		
16317	1486	3015076	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	99139	0	6248-9	3015076		
52931	4859	3013721	1971-06-05	1971-06-05 00:00:00	1971-06-05	5001	0	\N	0	0	\N	\N	0	323226	0	1920-8	3013721		
66241	2030	4052083	1995-07-13	1995-07-13 00:00:00	1995-07-13	5001	0	\N	0	0	\N	\N	0	135120	0	23426006	4052083		
3354	328	3009542	2004-10-22	2004-10-22 00:00:00	2004-10-22	5001	0	\N	0	0	\N	\N	0	21677	0	20570-8	3009542		
49573	4509	3011505	2007-09-04	2007-09-04 00:00:00	2007-09-04	5001	0	\N	0	0	\N	\N	0	300399	0	19926-5	3011505		
42950	1321	4024958	2007-06-22	2007-06-22 00:00:00	2007-06-22	5001	0	\N	0	0	\N	\N	0	87641	0	117015009	4024958		
50671	4623	3006322	1942-01-20	1942-01-20 00:00:00	1942-01-20	5001	0	\N	0	0	\N	\N	0	307964	0	8331-1	3006322		
34220	3118	3020655	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	207442	0	6844-5	3020655		
34282	3123	3012494	1978-02-19	1978-02-19 00:00:00	1978-02-19	5001	0	\N	0	0	\N	\N	0	207805	0	6206-7	3012494		
2792	270	3006322	1976-09-10	1976-09-10 00:00:00	1976-09-10	5001	0	\N	0	0	\N	\N	0	17958	0	8331-1	3006322		
2139	191	40758406	1963-01-17	1963-01-17 00:00:00	1963-01-17	5001	0	\N	0	0	\N	\N	0	13056	0	55277-8	40758406		
8956	859	3006322	1982-07-09	1982-07-09 00:00:00	1982-07-09	5001	0	\N	0	0	\N	\N	0	56794	0	8331-1	3006322		
147899	4532	4024958	1937-01-17	1937-01-17 00:00:00	1937-01-17	5001	0	\N	0	0	\N	\N	0	301906	0	117015009	4024958		
38689	3578	3006322	1973-12-27	1973-12-27 00:00:00	1973-12-27	5001	0	\N	0	0	\N	\N	0	237873	0	8331-1	3006322		
11946	1138	3020655	1996-08-08	1996-08-08 00:00:00	1996-08-08	5001	0	\N	0	0	\N	\N	0	75088	0	6844-5	3020655		
38829	3589	3027231	1997-07-08	1997-07-08 00:00:00	1997-07-08	5001	0	\N	0	0	\N	\N	0	238474	0	6276-0	3027231		
13946	1310	3051031	2003-06-14	2003-06-14 00:00:00	2003-06-14	5001	0	\N	0	0	\N	\N	0	86621	0	46240-8	3051031		
50432	4596	3006322	2016-06-16	2016-06-16 00:00:00	2016-06-16	5001	0	\N	0	0	\N	\N	0	306258	0	8331-1	3006322		
32219	2925	3006451	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	195093	0	6273-7	3006451		
47956	4390	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	291804	0	6246-3	3021226		
36818	3378	3006322	1977-05-03	1977-05-03 00:00:00	1977-05-03	5001	0	\N	0	0	\N	\N	0	224123	0	8331-1	3006322		
15616	1431	3006451	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	95212	0	6273-7	3006451		
8700	842	3006322	1917-09-19	1917-09-19 00:00:00	1917-09-19	5001	0	\N	0	0	\N	\N	0	55632	0	8331-1	3006322		
49243	4498	3006322	2015-03-25	2015-03-25 00:00:00	2015-03-25	5001	0	\N	0	0	\N	\N	0	299486	0	8331-1	3006322		
49313	4501	40758406	1974-09-26	1974-09-26 00:00:00	1974-09-26	5001	0	\N	0	0	\N	\N	0	299703	0	55277-8	40758406		
31529	2890	46235214	1963-02-06	1963-02-06 00:00:00	1963-02-06	5001	0	\N	0	0	\N	\N	0	192231	0	76690-7	46235214		
31606	2894	3006322	1996-02-06	1996-02-06 00:00:00	1996-02-06	5001	0	\N	0	0	\N	\N	0	192585	0	8331-1	3006322		
53083	4878	3015076	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	324320	0	6248-9	3015076		
35189	1098	4024958	1962-03-10	1962-03-10 00:00:00	1962-03-10	5001	0	\N	0	0	\N	\N	0	72033	0	117015009	4024958		
44775	4134	3006322	1985-07-02	1985-07-02 00:00:00	1985-07-02	5001	0	\N	0	0	\N	\N	0	274862	0	8331-1	3006322		
16518	1506	3006322	1948-01-12	1948-01-12 00:00:00	1948-01-12	5001	0	\N	0	0	\N	\N	0	100399	0	8331-1	3006322		
51168	4678	3006322	1956-01-25	1956-01-25 00:00:00	1956-01-25	5001	0	\N	0	0	\N	\N	0	311761	0	8331-1	3006322		
40398	3754	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	249504	0	6106-9	3014599		
116195	3580	4024958	1975-10-07	1975-10-07 00:00:00	1975-10-07	5001	0	\N	0	0	\N	\N	0	237994	0	117015009	4024958		
42667	1315	4024958	1990-08-03	1990-08-03 00:00:00	1990-08-03	5001	0	\N	0	0	\N	\N	0	87116	0	117015009	4024958		
40456	3759	3005136	1983-08-31	1983-08-31 00:00:00	1983-08-31	5001	0	\N	0	0	\N	\N	0	249968	0	6075-6	3005136		
12129	1150	3006322	1959-08-25	1959-08-25 00:00:00	1959-08-25	5001	0	\N	0	0	\N	\N	0	75998	0	8331-1	3006322		
33769	3067	3000963	1969-12-11	1969-12-11 00:00:00	1969-12-11	5001	0	\N	0	0	\N	\N	0	204102	0	718-7	3000963		
61773	1892	4133840	2013-08-01	2013-08-01 00:00:00	2013-08-01	5001	0	\N	0	0	\N	\N	0	126015	0	127783003	4133840		
9313	882	3006322	1965-06-07	1965-06-07 00:00:00	1965-06-07	5001	0	\N	0	0	\N	\N	0	58725	0	8331-1	3006322		
39295	1222	4024958	1988-10-06	1988-10-06 00:00:00	1988-10-06	5001	0	\N	0	0	\N	\N	0	80434	0	117015009	4024958		
99654	3059	4024958	1979-08-18	1979-08-18 00:00:00	1979-08-18	5001	0	\N	0	0	\N	\N	0	203505	0	117015009	4024958		
20031	1843	3020655	1998-02-25	1998-02-25 00:00:00	1998-02-25	5001	0	\N	0	0	\N	\N	0	123041	0	6844-5	3020655		
10764	340	4052083	1996-02-26	1996-02-26 00:00:00	1996-02-26	5001	0	\N	0	0	\N	\N	0	22712	0	23426006	4052083		
32247	2933	3006322	1956-09-25	1956-09-25 00:00:00	1956-09-25	5001	0	\N	0	0	\N	\N	0	195628	0	8331-1	3006322		
14125	445	4052083	1968-03-15	1968-03-15 00:00:00	1968-03-15	5001	0	\N	0	0	\N	\N	0	29606	0	23426006	4052083		
15464	484	4024958	2001-11-07	2001-11-07 00:00:00	2001-11-07	5001	0	\N	0	0	\N	\N	0	32317	0	117015009	4024958		
78517	2411	4024958	2008-02-12	2008-02-12 00:00:00	2008-02-12	5001	0	\N	0	0	\N	\N	0	159988	0	117015009	4024958		
21203	1960	3006322	1944-01-13	1944-01-13 00:00:00	1944-01-13	5001	0	\N	0	0	\N	\N	0	130319	0	8331-1	3006322		
6565	616	3006322	2006-06-24	2006-06-24 00:00:00	2006-06-24	5001	0	\N	0	0	\N	\N	0	41120	0	8331-1	3006322		
17922	1626	3026361	1989-12-17	1989-12-17 00:00:00	1989-12-17	5001	0	\N	0	0	\N	\N	0	109189	0	26453-1	3026361		
121111	3739	4024958	2014-12-15	2014-12-15 00:00:00	2014-12-15	5001	0	\N	0	0	\N	\N	0	248423	0	117015009	4024958		
34452	3147	3011505	1979-02-19	1979-02-19 00:00:00	1979-02-19	5001	0	\N	0	0	\N	\N	0	209382	0	19926-5	3011505		
86396	2672	4024958	1964-11-26	1964-11-26 00:00:00	1964-11-26	5001	0	\N	0	0	\N	\N	0	176885	0	117015009	4024958		
6324	600	3006322	1974-01-06	1974-01-06 00:00:00	1974-01-06	5001	0	\N	0	0	\N	\N	0	39626	0	8331-1	3006322		
7088	680	3006322	1994-05-17	1994-05-17 00:00:00	1994-05-17	5001	0	\N	0	0	\N	\N	0	45041	0	8331-1	3006322		
17736	1611	3006322	2012-05-27	2012-05-27 00:00:00	2012-05-27	5001	0	\N	0	0	\N	\N	0	108329	0	8331-1	3006322		
1430	124	3023430	2000-09-12	2000-09-12 00:00:00	2000-09-12	5001	0	\N	0	0	\N	\N	0	8277	0	6833-8	3023430		
120480	3717	4024958	1999-06-22	1999-06-22 00:00:00	1999-06-22	5001	0	\N	0	0	\N	\N	0	246978	0	117015009	4024958		
120523	3717	4052083	1977-07-04	1977-07-04 00:00:00	1977-07-04	5001	0	\N	0	0	\N	\N	0	247075	0	23426006	4052083		
47566	4372	3000876	1993-05-13	1993-05-13 00:00:00	1993-05-13	5001	0	\N	0	0	\N	\N	0	290262	0	6082-2	3000876		
36993	3399	3021226	1996-02-12	1996-02-12 00:00:00	1996-02-12	5001	0	\N	0	0	\N	\N	0	225512	0	6246-3	3021226		
48332	4436	3021226	1984-06-17	1984-06-17 00:00:00	1984-06-17	5001	0	\N	0	0	\N	\N	0	294875	0	6246-3	3021226		
16318	1486	3006451	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	99139	0	6273-7	3006451		
52932	4859	3020630	1971-06-05	1971-06-05 00:00:00	1971-06-05	5001	0	\N	0	0	\N	\N	0	323226	0	2885-2	3020630		
66247	2030	4024958	1989-11-24	1989-11-24 00:00:00	1989-11-24	5001	0	\N	0	0	\N	\N	0	135146	0	117015009	4024958		
3355	328	3000963	2004-10-22	2004-10-22 00:00:00	2004-10-22	5001	0	\N	0	0	\N	\N	0	21677	0	718-7	3000963		
49574	4509	3011505	2011-09-13	2011-09-13 00:00:00	2011-09-13	5001	0	\N	0	0	\N	\N	0	300405	0	19926-5	3011505		
42953	1321	4024958	1973-12-28	1973-12-28 00:00:00	1973-12-28	5001	0	\N	0	0	\N	\N	0	87651	0	117015009	4024958		
50672	4623	40769194	1955-05-18	1955-05-18 00:00:00	1955-05-18	5001	0	\N	0	0	\N	\N	0	308008	0	66534-9	40769194		
34221	3118	3036780	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	207442	0	6095-4	3036780		
34283	3123	3036780	1978-02-19	1978-02-19 00:00:00	1978-02-19	5001	0	\N	0	0	\N	\N	0	207805	0	6095-4	3036780		
2793	270	3006322	2019-03-07	2019-03-07 00:00:00	2019-03-07	5001	0	\N	0	0	\N	\N	0	17957	0	8331-1	3006322		
2141	191	46235214	1963-01-17	1963-01-17 00:00:00	1963-01-17	5001	0	\N	0	0	\N	\N	0	13056	0	76690-7	46235214		
8957	859	3001488	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	56883	0	7258-7	3001488		
147909	4532	4052083	1949-03-04	1949-03-04 00:00:00	1949-03-04	5001	0	\N	0	0	\N	\N	0	301917	0	23426006	4052083		
38690	3578	3006322	1976-08-28	1976-08-28 00:00:00	1976-08-28	5001	0	\N	0	0	\N	\N	0	237862	0	8331-1	3006322		
11947	1138	3000876	1996-08-08	1996-08-08 00:00:00	1996-08-08	5001	0	\N	0	0	\N	\N	0	75088	0	6082-2	3000876		
38830	3589	3006451	1997-07-08	1997-07-08 00:00:00	1997-07-08	5001	0	\N	0	0	\N	\N	0	238474	0	6273-7	3006451		
13948	1310	3006322	2011-01-24	2011-01-24 00:00:00	2011-01-24	5001	0	\N	0	0	\N	\N	0	86574	0	8331-1	3006322		
50433	4596	3006322	1958-04-15	1958-04-15 00:00:00	1958-04-15	5001	0	\N	0	0	\N	\N	0	306319	0	8331-1	3006322		
32220	2925	3014599	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	195093	0	6106-9	3014599		
47957	4390	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	291804	0	6206-7	3012494		
36819	3378	3006322	2011-04-17	2011-04-17 00:00:00	2011-04-17	5001	0	\N	0	0	\N	\N	0	224132	0	8331-1	3006322		
15617	1431	3006734	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	95212	0	6189-5	3006734		
8701	842	3011505	1993-06-19	1993-06-19 00:00:00	1993-06-19	5001	0	\N	0	0	\N	\N	0	55679	0	19926-5	3011505		
49244	4500	3006322	2008-06-02	2008-06-02 00:00:00	2008-06-02	5001	0	\N	0	0	\N	\N	0	299657	0	8331-1	3006322		
49315	4501	40758406	1974-02-28	1974-02-28 00:00:00	1974-02-28	5001	0	\N	0	0	\N	\N	0	299676	0	55277-8	40758406		
31530	2890	3006322	1983-02-17	1983-02-17 00:00:00	1983-02-17	5001	0	\N	0	0	\N	\N	0	192197	0	8331-1	3006322		
31607	2894	3049273	1991-02-24	1991-02-24 00:00:00	1991-02-24	5001	0	\N	0	0	\N	\N	0	192600	0	38265-5	3049273		
53084	4878	3021226	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	324320	0	6246-3	3021226		
35200	1098	4052083	1999-11-30	1999-11-30 00:00:00	1999-11-30	5001	0	\N	0	0	\N	\N	0	72084	0	23426006	4052083		
44776	4134	3006322	2018-10-19	2018-10-19 00:00:00	2018-10-19	5001	0	\N	0	0	\N	\N	0	274899	0	8331-1	3006322		
16524	1508	3006322	1941-12-12	1941-12-12 00:00:00	1941-12-12	5001	0	\N	0	0	\N	\N	0	100586	0	8331-1	3006322		
51169	4678	3006322	2015-06-06	2015-06-06 00:00:00	2015-06-06	5001	0	\N	0	0	\N	\N	0	311741	0	8331-1	3006322		
40399	3754	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	249504	0	6248-9	3015076		
116202	3580	4024958	2015-10-17	2015-10-17 00:00:00	2015-10-17	5001	0	\N	0	0	\N	\N	0	238008	0	117015009	4024958		
42678	1315	4024958	1965-10-08	1965-10-08 00:00:00	1965-10-08	5001	0	\N	0	0	\N	\N	0	87128	0	117015009	4024958		
40457	3759	3006734	1983-08-31	1983-08-31 00:00:00	1983-08-31	5001	0	\N	0	0	\N	\N	0	249968	0	6189-5	3006734		
12130	1150	3006322	1977-05-15	1977-05-15 00:00:00	1977-05-15	5001	0	\N	0	0	\N	\N	0	76066	0	8331-1	3006322		
33770	3067	3009542	1969-12-11	1969-12-11 00:00:00	1969-12-11	5001	0	\N	0	0	\N	\N	0	204102	0	20570-8	3009542		
61776	1892	4024958	1987-12-16	1987-12-16 00:00:00	1987-12-16	5001	0	\N	0	0	\N	\N	0	126034	0	117015009	4024958		
9314	882	3006322	1957-06-07	1957-06-07 00:00:00	1957-06-07	5001	0	\N	0	0	\N	\N	0	58675	0	8331-1	3006322		
39298	1223	4052083	1989-05-23	1989-05-23 00:00:00	1989-05-23	5001	0	\N	0	0	\N	\N	0	80455	0	23426006	4052083		
99668	3060	4052083	1994-03-18	1994-03-18 00:00:00	1994-03-18	5001	0	\N	0	0	\N	\N	0	203658	0	23426006	4052083		
20032	1843	3019406	1998-02-25	1998-02-25 00:00:00	1998-02-25	5001	0	\N	0	0	\N	\N	0	123041	0	6158-0	3019406		
10783	341	4024958	1969-10-24	1969-10-24 00:00:00	1969-10-24	5001	0	\N	0	0	\N	\N	0	22761	0	117015009	4024958		
32248	2933	3006322	2011-07-24	2011-07-24 00:00:00	2011-07-24	5001	0	\N	0	0	\N	\N	0	195617	0	8331-1	3006322		
14129	445	4024958	1954-01-20	1954-01-20 00:00:00	1954-01-20	5001	0	\N	0	0	\N	\N	0	29587	0	117015009	4024958		
15465	484	4024958	2010-06-05	2010-06-05 00:00:00	2010-06-05	5001	0	\N	0	0	\N	\N	0	32381	0	117015009	4024958		
78523	2411	4024958	1995-12-05	1995-12-05 00:00:00	1995-12-05	5001	0	\N	0	0	\N	\N	0	159970	0	117015009	4024958		
21204	1960	3006322	1935-03-15	1935-03-15 00:00:00	1935-03-15	5001	0	\N	0	0	\N	\N	0	130317	0	8331-1	3006322		
6566	616	3006322	2018-10-13	2018-10-13 00:00:00	2018-10-13	5001	0	\N	0	0	\N	\N	0	41073	0	8331-1	3006322		
17923	1626	3016723	1989-12-17	1989-12-17 00:00:00	1989-12-17	5001	0	\N	0	0	\N	\N	0	109189	0	2160-0	3016723		
121112	3739	4024958	2007-02-01	2007-02-01 00:00:00	2007-02-01	5001	0	\N	0	0	\N	\N	0	248451	0	117015009	4024958		
34453	3147	3011505	2014-05-19	2014-05-19 00:00:00	2014-05-19	5001	0	\N	0	0	\N	\N	0	209368	0	19926-5	3011505		
86409	2672	4024958	1953-07-15	1953-07-15 00:00:00	1953-07-15	5001	0	\N	0	0	\N	\N	0	176882	0	117015009	4024958		
6325	600	3006322	1983-08-17	1983-08-17 00:00:00	1983-08-17	5001	0	\N	0	0	\N	\N	0	39640	0	8331-1	3006322		
7089	680	3027231	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	45008	0	6276-0	3027231		
17737	1612	3006322	2011-08-28	2011-08-28 00:00:00	2011-08-28	5001	0	\N	0	0	\N	\N	0	108389	0	8331-1	3006322		
1431	124	3019406	2000-09-12	2000-09-12 00:00:00	2000-09-12	5001	0	\N	0	0	\N	\N	0	8277	0	6158-0	3019406		
109366	3375	4024958	1976-12-06	1976-12-06 00:00:00	1976-12-06	5001	0	\N	0	0	\N	\N	0	223912	0	117015009	4024958		
120529	3718	4024958	1979-06-28	1979-06-28 00:00:00	1979-06-28	5001	0	\N	0	0	\N	\N	0	247108	0	117015009	4024958		
47567	4372	3006322	2007-09-13	2007-09-13 00:00:00	2007-09-13	5001	0	\N	0	0	\N	\N	0	290245	0	8331-1	3006322		
36994	3399	3023430	1996-02-12	1996-02-12 00:00:00	1996-02-12	5001	0	\N	0	0	\N	\N	0	225512	0	6833-8	3023430		
48333	4436	3005136	1984-06-17	1984-06-17 00:00:00	1984-06-17	5001	0	\N	0	0	\N	\N	0	294875	0	6075-6	3005136		
16319	1486	3006734	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	99139	0	6189-5	3006734		
52933	4859	3002385	1971-06-05	1971-06-05 00:00:00	1971-06-05	5001	0	\N	0	0	\N	\N	0	323226	0	30385-9	3002385		
66249	2030	4024958	1975-08-01	1975-08-01 00:00:00	1975-08-01	5001	0	\N	0	0	\N	\N	0	135139	0	117015009	4024958		
3356	328	3006322	1995-09-12	1995-09-12 00:00:00	1995-09-12	5001	0	\N	0	0	\N	\N	0	21662	0	8331-1	3006322		
49575	4509	3011505	2009-09-08	2009-09-08 00:00:00	2009-09-08	5001	0	\N	0	0	\N	\N	0	300361	0	19926-5	3011505		
42959	1321	4024958	2003-12-29	2003-12-29 00:00:00	2003-12-29	5001	0	\N	0	0	\N	\N	0	87612	0	117015009	4024958		
50673	4623	40769189	1955-05-18	1955-05-18 00:00:00	1955-05-18	5001	0	\N	0	0	\N	\N	0	308008	0	66529-9	40769189		
34222	3118	3019406	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	207442	0	6158-0	3019406		
34284	3123	3015076	1978-02-19	1978-02-19 00:00:00	1978-02-19	5001	0	\N	0	0	\N	\N	0	207805	0	6248-9	3015076		
2794	270	3006322	2007-09-22	2007-09-22 00:00:00	2007-09-22	5001	0	\N	0	0	\N	\N	0	18014	0	8331-1	3006322		
2142	191	3006322	1987-07-25	1987-07-25 00:00:00	1987-07-25	5001	0	\N	0	0	\N	\N	0	13025	0	8331-1	3006322		
8958	859	3023430	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	56883	0	6833-8	3023430		
147920	4532	4024958	1911-04-27	1911-04-27 00:00:00	1911-04-27	5001	0	\N	0	0	\N	\N	0	301912	0	117015009	4024958		
38691	3578	3006322	1978-05-31	1978-05-31 00:00:00	1978-05-31	5001	0	\N	0	0	\N	\N	0	237875	0	8331-1	3006322		
11948	1138	3006322	1981-07-26	1981-07-26 00:00:00	1981-07-26	5001	0	\N	0	0	\N	\N	0	75059	0	8331-1	3006322		
38831	3589	3019406	1997-07-08	1997-07-08 00:00:00	1997-07-08	5001	0	\N	0	0	\N	\N	0	238474	0	6158-0	3019406		
13949	1310	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	86613	0	6075-6	3005136		
50434	4596	3006322	1993-08-25	1993-08-25 00:00:00	1993-08-25	5001	0	\N	0	0	\N	\N	0	306292	0	8331-1	3006322		
43498	4022	3006322	1977-06-24	1977-06-24 00:00:00	1977-06-24	5001	0	\N	0	0	\N	\N	0	267411	0	8331-1	3006322		
47958	4390	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	291804	0	6082-2	3000876		
36820	3378	3006322	1989-02-15	1989-02-15 00:00:00	1989-02-15	5001	0	\N	0	0	\N	\N	0	224126	0	8331-1	3006322		
15618	1431	3021226	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	95212	0	6246-3	3021226		
8702	842	3006322	1923-09-26	1923-09-26 00:00:00	1923-09-26	5001	0	\N	0	0	\N	\N	0	55633	0	8331-1	3006322		
49245	4500	3006322	2006-08-28	2006-08-28 00:00:00	2006-08-28	5001	0	\N	0	0	\N	\N	0	299584	0	8331-1	3006322		
49316	4501	46235214	1974-02-28	1974-02-28 00:00:00	1974-02-28	5001	0	\N	0	0	\N	\N	0	299676	0	76690-7	46235214		
31531	2891	3006322	1977-02-08	1977-02-08 00:00:00	1977-02-08	5001	0	\N	0	0	\N	\N	0	192344	0	8331-1	3006322		
31608	2894	3006322	1974-06-15	1974-06-15 00:00:00	1974-06-15	5001	0	\N	0	0	\N	\N	0	192648	0	8331-1	3006322		
53085	4878	3001247	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	324320	0	6085-5	3001247		
124621	3851	4024958	1927-10-21	1927-10-21 00:00:00	1927-10-21	5001	0	\N	0	0	\N	\N	0	255608	0	117015009	4024958		
44781	4137	3011505	2012-02-01	2012-02-01 00:00:00	2012-02-01	5001	0	\N	0	0	\N	\N	0	275026	0	19926-5	3011505		
16525	1508	3006322	1959-07-07	1959-07-07 00:00:00	1959-07-07	5001	0	\N	0	0	\N	\N	0	100641	0	8331-1	3006322		
51170	4678	3006322	1963-03-02	1963-03-02 00:00:00	1963-03-02	5001	0	\N	0	0	\N	\N	0	311762	0	8331-1	3006322		
40400	3754	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	249504	0	6158-0	3019406		
116214	3580	4052083	2006-10-15	2006-10-15 00:00:00	2006-10-15	5001	0	\N	0	0	\N	\N	0	238004	0	23426006	4052083		
42686	1315	4024958	1982-03-06	1982-03-06 00:00:00	1982-03-06	5001	0	\N	0	0	\N	\N	0	87129	0	117015009	4024958		
40458	3759	3023430	1983-08-31	1983-08-31 00:00:00	1983-08-31	5001	0	\N	0	0	\N	\N	0	249968	0	6833-8	3023430		
12131	1150	3006322	1990-03-02	1990-03-02 00:00:00	1990-03-02	5001	0	\N	0	0	\N	\N	0	76030	0	8331-1	3006322		
33771	3067	3006322	1997-11-09	1997-11-09 00:00:00	1997-11-09	5001	0	\N	0	0	\N	\N	0	204179	0	8331-1	3006322		
61777	1892	4133840	2012-07-26	2012-07-26 00:00:00	2012-07-26	5001	0	\N	0	0	\N	\N	0	125988	0	127783003	4133840		
9315	882	3006322	1950-11-24	1950-11-24 00:00:00	1950-11-24	5001	0	\N	0	0	\N	\N	0	58674	0	8331-1	3006322		
39317	1223	4024958	1953-04-01	1953-04-01 00:00:00	1953-04-01	5001	0	\N	0	0	\N	\N	0	80475	0	117015009	4024958		
99682	3060	4024958	1934-10-07	1934-10-07 00:00:00	1934-10-07	5001	0	\N	0	0	\N	\N	0	203605	0	117015009	4024958		
20033	1843	3014599	1998-02-25	1998-02-25 00:00:00	1998-02-25	5001	0	\N	0	0	\N	\N	0	123041	0	6106-9	3014599		
10785	341	4052083	1990-06-06	1990-06-06 00:00:00	1990-06-06	5001	0	\N	0	0	\N	\N	0	22763	0	23426006	4052083		
32249	2933	3006322	1958-01-09	1958-01-09 00:00:00	1958-01-09	5001	0	\N	0	0	\N	\N	0	195624	0	8331-1	3006322		
25430	793	4024958	1980-03-06	1980-03-06 00:00:00	1980-03-06	5001	0	\N	0	0	\N	\N	0	52623	0	117015009	4024958		
15468	484	4052083	1976-06-12	1976-06-12 00:00:00	1976-06-12	5001	0	\N	0	0	\N	\N	0	32378	0	23426006	4052083		
78524	2411	4052083	2014-11-09	2014-11-09 00:00:00	2014-11-09	5001	0	\N	0	0	\N	\N	0	159989	0	23426006	4052083		
21206	1960	3006322	1968-08-05	1968-08-05 00:00:00	1968-08-05	5001	0	\N	0	0	\N	\N	0	130339	0	8331-1	3006322		
6567	616	3006322	1977-08-11	1977-08-11 00:00:00	1977-08-11	5001	0	\N	0	0	\N	\N	0	41112	0	8331-1	3006322		
17924	1626	3009542	1989-12-17	1989-12-17 00:00:00	1989-12-17	5001	0	\N	0	0	\N	\N	0	109189	0	20570-8	3009542		
121114	3739	4052083	2005-05-27	2005-05-27 00:00:00	2005-05-27	5001	0	\N	0	0	\N	\N	0	248439	0	23426006	4052083		
34454	3147	3011505	2019-06-17	2019-06-17 00:00:00	2019-06-17	5001	0	\N	0	0	\N	\N	0	209426	0	19926-5	3011505		
86531	2673	4052083	2007-10-30	2007-10-30 00:00:00	2007-10-30	5001	0	\N	0	0	\N	\N	0	177051	0	23426006	4052083		
6326	600	3006322	1967-06-30	1967-06-30 00:00:00	1967-06-30	5001	0	\N	0	0	\N	\N	0	39569	0	8331-1	3006322		
7090	680	3012494	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	45008	0	6206-7	3012494		
17738	1612	3006322	1969-09-29	1969-09-29 00:00:00	1969-09-29	5001	0	\N	0	0	\N	\N	0	108385	0	8331-1	3006322		
1432	124	3012494	2000-09-12	2000-09-12 00:00:00	2000-09-12	5001	0	\N	0	0	\N	\N	0	8277	0	6206-7	3012494		
120654	3721	4052083	1965-10-06	1965-10-06 00:00:00	1965-10-06	5001	0	\N	0	0	\N	\N	0	247324	0	23426006	4052083		
120537	3718	4052083	1994-02-02	1994-02-02 00:00:00	1994-02-02	5001	0	\N	0	0	\N	\N	0	247129	0	23426006	4052083		
47568	4372	3006451	1996-11-14	1996-11-14 00:00:00	1996-11-14	5001	0	\N	0	0	\N	\N	0	290277	0	6273-7	3006451		
36995	3399	3006451	1996-02-12	1996-02-12 00:00:00	1996-02-12	5001	0	\N	0	0	\N	\N	0	225512	0	6273-7	3006451		
48334	4437	3006322	2000-10-07	2000-10-07 00:00:00	2000-10-07	5001	0	\N	0	0	\N	\N	0	294887	0	8331-1	3006322		
16320	1486	3006322	2006-08-07	2006-08-07 00:00:00	2006-08-07	5001	0	\N	0	0	\N	\N	0	99100	0	8331-1	3006322		
52934	4859	3045716	1971-06-05	1971-06-05 00:00:00	1971-06-05	5001	0	\N	0	0	\N	\N	0	323226	0	33037-3	3045716		
66309	2033	4052083	1959-05-11	1959-05-11 00:00:00	1959-05-11	5001	0	\N	0	0	\N	\N	0	135329	0	23426006	4052083		
3357	328	3006322	1989-04-05	1989-04-05 00:00:00	1989-04-05	5001	0	\N	0	0	\N	\N	0	21642	0	8331-1	3006322		
49576	4509	3011505	1990-04-10	1990-04-10 00:00:00	1990-04-10	5001	0	\N	0	0	\N	\N	0	300359	0	19926-5	3011505		
42960	1321	4052083	2015-12-11	2015-12-11 00:00:00	2015-12-11	5001	0	\N	0	0	\N	\N	0	87642	0	23426006	4052083		
50674	4623	40769179	1955-05-18	1955-05-18 00:00:00	1955-05-18	5001	0	\N	0	0	\N	\N	0	308008	0	66519-0	40769179		
34223	3118	3015076	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	207442	0	6248-9	3015076		
34285	3123	3021226	1978-02-19	1978-02-19 00:00:00	1978-02-19	5001	0	\N	0	0	\N	\N	0	207805	0	6246-3	3021226		
2856	273	3006322	2005-09-26	2005-09-26 00:00:00	2005-09-26	5001	0	\N	0	0	\N	\N	0	18242	0	8331-1	3006322		
2143	191	3011505	1996-10-08	1996-10-08 00:00:00	1996-10-08	5001	0	\N	0	0	\N	\N	0	13053	0	19926-5	3011505		
8959	859	3001247	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	56883	0	6085-5	3001247		
8972	859	3006734	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	56795	0	6189-5	3006734		
38692	3579	3006322	1990-10-19	1990-10-19 00:00:00	1990-10-19	5001	0	\N	0	0	\N	\N	0	237953	0	8331-1	3006322		
11949	1138	3006322	1994-12-15	1994-12-15 00:00:00	1994-12-15	5001	0	\N	0	0	\N	\N	0	75014	0	8331-1	3006322		
38832	3589	3036780	1997-07-08	1997-07-08 00:00:00	1997-07-08	5001	0	\N	0	0	\N	\N	0	238474	0	6095-4	3036780		
13950	1310	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	86613	0	6248-9	3015076		
50435	4596	3006322	1939-03-24	1939-03-24 00:00:00	1939-03-24	5001	0	\N	0	0	\N	\N	0	306285	0	8331-1	3006322		
43500	4024	3011505	2003-08-24	2003-08-24 00:00:00	2003-08-24	5001	0	\N	0	0	\N	\N	0	267535	0	19926-5	3011505		
47959	4390	3006322	2000-09-30	2000-09-30 00:00:00	2000-09-30	5001	0	\N	0	0	\N	\N	0	291920	0	8331-1	3006322		
36821	3378	3006322	1974-07-22	1974-07-22 00:00:00	1974-07-22	5001	0	\N	0	0	\N	\N	0	224198	0	8331-1	3006322		
15619	1431	3012494	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	95212	0	6206-7	3012494		
8703	842	3011505	1970-11-14	1970-11-14 00:00:00	1970-11-14	5001	0	\N	0	0	\N	\N	0	55692	0	19926-5	3011505		
49246	4500	3006322	2008-07-16	2008-07-16 00:00:00	2008-07-16	5001	0	\N	0	0	\N	\N	0	299593	0	8331-1	3006322		
49318	4501	3051031	1974-02-28	1974-02-28 00:00:00	1974-02-28	5001	0	\N	0	0	\N	\N	0	299676	0	46240-8	3051031		
31532	2891	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	192290	0	6206-7	3012494		
31610	2894	3006322	1974-04-04	1974-04-04 00:00:00	1974-04-04	5001	0	\N	0	0	\N	\N	0	192626	0	8331-1	3006322		
53086	4878	3020655	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	324320	0	6844-5	3020655		
124635	3851	4052083	1918-12-22	1918-12-22 00:00:00	1918-12-22	5001	0	\N	0	0	\N	\N	0	255573	0	23426006	4052083		
44782	4137	3011505	2013-02-06	2013-02-06 00:00:00	2013-02-06	5001	0	\N	0	0	\N	\N	0	275036	0	19926-5	3011505		
16526	1508	3006322	1976-06-09	1976-06-09 00:00:00	1976-06-09	5001	0	\N	0	0	\N	\N	0	100653	0	8331-1	3006322		
51171	4678	3006322	1970-08-03	1970-08-03 00:00:00	1970-08-03	5001	0	\N	0	0	\N	\N	0	311729	0	8331-1	3006322		
40401	3754	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	249504	0	6075-6	3005136		
116251	3582	4133840	2016-07-24	2016-07-24 00:00:00	2016-07-24	5001	0	\N	0	0	\N	\N	0	238107	0	127783003	4133840		
42701	1316	4052083	1952-03-18	1952-03-18 00:00:00	1952-03-18	5001	0	\N	0	0	\N	\N	0	87216	0	23426006	4052083		
40459	3759	3015076	1983-08-31	1983-08-31 00:00:00	1983-08-31	5001	0	\N	0	0	\N	\N	0	249968	0	6248-9	3015076		
12132	1151	3006322	1986-11-14	1986-11-14 00:00:00	1986-11-14	5001	0	\N	0	0	\N	\N	0	76123	0	8331-1	3006322		
33772	3067	3006322	1955-07-12	1955-07-12 00:00:00	1955-07-12	5001	0	\N	0	0	\N	\N	0	204100	0	8331-1	3006322		
61778	1892	4133840	2010-07-15	2010-07-15 00:00:00	2010-07-15	5001	0	\N	0	0	\N	\N	0	125987	0	127783003	4133840		
9316	882	3006322	2007-05-01	2007-05-01 00:00:00	2007-05-01	5001	0	\N	0	0	\N	\N	0	58678	0	8331-1	3006322		
47024	4329	3006322	2001-12-06	2001-12-06 00:00:00	2001-12-06	5001	0	\N	0	0	\N	\N	0	287122	0	8331-1	3006322		
99697	3060	4024958	1937-05-11	1937-05-11 00:00:00	1937-05-11	5001	0	\N	0	0	\N	\N	0	203542	0	117015009	4024958		
20034	1843	3001488	1998-02-25	1998-02-25 00:00:00	1998-02-25	5001	0	\N	0	0	\N	\N	0	123041	0	7258-7	3001488		
10794	341	4024958	1978-10-19	1978-10-19 00:00:00	1978-10-19	5001	0	\N	0	0	\N	\N	0	22805	0	117015009	4024958		
32250	2933	3006322	1954-07-25	1954-07-25 00:00:00	1954-07-25	5001	0	\N	0	0	\N	\N	0	195594	0	8331-1	3006322		
15484	484	4024958	1944-01-21	1944-01-21 00:00:00	1944-01-21	5001	0	\N	0	0	\N	\N	0	32306	0	117015009	4024958		
78535	2412	4024958	1954-12-04	1954-12-04 00:00:00	1954-12-04	5001	0	\N	0	0	\N	\N	0	160064	0	117015009	4024958		
21209	1960	3006322	1958-11-16	1958-11-16 00:00:00	1958-11-16	5001	0	\N	0	0	\N	\N	0	130338	0	8331-1	3006322		
6568	616	3006322	1974-12-11	1974-12-11 00:00:00	1974-12-11	5001	0	\N	0	0	\N	\N	0	41111	0	8331-1	3006322		
17925	1626	3028833	1989-12-17	1989-12-17 00:00:00	1989-12-17	5001	0	\N	0	0	\N	\N	0	109189	0	42719-5	3028833		
121123	3739	4024958	1973-04-26	1973-04-26 00:00:00	1973-04-26	5001	0	\N	0	0	\N	\N	0	248421	0	117015009	4024958		
34455	3147	3011505	1988-01-18	1988-01-18 00:00:00	1988-01-18	5001	0	\N	0	0	\N	\N	0	209384	0	19926-5	3011505		
86553	2674	4052083	1987-01-01	1987-01-01 00:00:00	1987-01-01	5001	0	\N	0	0	\N	\N	0	177183	0	23426006	4052083		
6327	600	3006322	2008-01-30	2008-01-30 00:00:00	2008-01-30	5001	0	\N	0	0	\N	\N	0	39621	0	8331-1	3006322		
7091	680	3036780	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	45008	0	6095-4	3036780		
17739	1612	3006322	2014-08-24	2014-08-24 00:00:00	2014-08-24	5001	0	\N	0	0	\N	\N	0	108376	0	8331-1	3006322		
36038	3314	3006322	1999-12-11	1999-12-11 00:00:00	1999-12-11	5001	0	\N	0	0	\N	\N	0	220066	0	8331-1	3006322		
120655	3721	4024958	1968-03-25	1968-03-25 00:00:00	1968-03-25	5001	0	\N	0	0	\N	\N	0	247355	0	117015009	4024958		
120538	3718	4052083	1989-08-01	1989-08-01 00:00:00	1989-08-01	5001	0	\N	0	0	\N	\N	0	247138	0	23426006	4052083		
47569	4372	3019406	1996-11-14	1996-11-14 00:00:00	1996-11-14	5001	0	\N	0	0	\N	\N	0	290277	0	6158-0	3019406		
36996	3399	3019406	1996-02-12	1996-02-12 00:00:00	1996-02-12	5001	0	\N	0	0	\N	\N	0	225512	0	6158-0	3019406		
48335	4437	3006322	1999-06-07	1999-06-07 00:00:00	1999-06-07	5001	0	\N	0	0	\N	\N	0	294886	0	8331-1	3006322		
16321	1486	3006322	1958-12-25	1958-12-25 00:00:00	1958-12-25	5001	0	\N	0	0	\N	\N	0	99133	0	8331-1	3006322		
52935	4859	3023103	1971-06-05	1971-06-05 00:00:00	1971-06-05	5001	0	\N	0	0	\N	\N	0	323226	0	2823-3	3023103		
43827	1352	4133840	1998-06-28	1998-06-28 00:00:00	1998-06-28	5001	0	\N	0	0	\N	\N	0	89572	0	127783003	4133840		
3362	331	3006322	1993-01-28	1993-01-28 00:00:00	1993-01-28	5001	0	\N	0	0	\N	\N	0	21860	0	8331-1	3006322		
49577	4509	3011505	2018-09-04	2018-09-04 00:00:00	2018-09-04	5001	0	\N	0	0	\N	\N	0	300406	0	19926-5	3011505		
97549	2985	4052083	2006-05-01	2006-05-01 00:00:00	2006-05-01	5001	0	\N	0	0	\N	\N	0	199209	0	23426006	4052083		
50675	4623	40769184	1955-05-18	1955-05-18 00:00:00	1955-05-18	5001	0	\N	0	0	\N	\N	0	308008	0	66524-0	40769184		
34224	3118	3005136	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	207442	0	6075-6	3005136		
34286	3123	3014599	1978-02-19	1978-02-19 00:00:00	1978-02-19	5001	0	\N	0	0	\N	\N	0	207805	0	6106-9	3014599		
2857	273	3006322	1976-02-14	1976-02-14 00:00:00	1976-02-14	5001	0	\N	0	0	\N	\N	0	18223	0	8331-1	3006322		
2144	191	3011505	2000-10-31	2000-10-31 00:00:00	2000-10-31	5001	0	\N	0	0	\N	\N	0	13109	0	19926-5	3011505		
8960	859	3006734	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	56883	0	6189-5	3006734		
8973	859	3019406	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	56795	0	6158-0	3019406		
38693	3579	3006322	2006-09-07	2006-09-07 00:00:00	2006-09-07	5001	0	\N	0	0	\N	\N	0	237954	0	8331-1	3006322		
11950	1138	3006734	1985-02-26	1985-02-26 00:00:00	1985-02-26	5001	0	\N	0	0	\N	\N	0	75060	0	6189-5	3006734		
38833	3589	3006322	1991-06-25	1991-06-25 00:00:00	1991-06-25	5001	0	\N	0	0	\N	\N	0	238399	0	8331-1	3006322		
13951	1310	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	86613	0	6082-2	3000876		
50436	4596	3006322	1951-11-09	1951-11-09 00:00:00	1951-11-09	5001	0	\N	0	0	\N	\N	0	306260	0	8331-1	3006322		
43501	4024	3011505	2009-05-10	2009-05-10 00:00:00	2009-05-10	5001	0	\N	0	0	\N	\N	0	267566	0	19926-5	3011505		
47960	4391	3006322	1955-07-06	1955-07-06 00:00:00	1955-07-06	5001	0	\N	0	0	\N	\N	0	292011	0	8331-1	3006322		
36822	3378	3006322	1975-01-29	1975-01-29 00:00:00	1975-01-29	5001	0	\N	0	0	\N	\N	0	224175	0	8331-1	3006322		
15620	1431	3000876	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	95212	0	6082-2	3000876		
8704	842	3011505	1964-02-01	1964-02-01 00:00:00	1964-02-01	5001	0	\N	0	0	\N	\N	0	55660	0	19926-5	3011505		
49247	4500	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	299610	0	6276-0	3027231		
49319	4501	40766240	1974-02-28	1974-02-28 00:00:00	1974-02-28	5001	0	\N	0	0	\N	\N	0	299676	0	63513-6	40766240		
31533	2891	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	192290	0	7258-7	3001488		
31612	2894	3006322	1925-06-29	1925-06-29 00:00:00	1925-06-29	5001	0	\N	0	0	\N	\N	0	192632	0	8331-1	3006322		
53087	4878	3001488	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	324320	0	7258-7	3001488		
124658	3852	4052083	1997-01-02	1997-01-02 00:00:00	1997-01-02	5001	0	\N	0	0	\N	\N	0	255756	0	23426006	4052083		
44783	4137	3011505	2019-03-13	2019-03-13 00:00:00	2019-03-13	5001	0	\N	0	0	\N	\N	0	275046	0	19926-5	3011505		
16527	1508	3006322	1949-10-13	1949-10-13 00:00:00	1949-10-13	5001	0	\N	0	0	\N	\N	0	100648	0	8331-1	3006322		
51174	4680	3006322	1957-12-13	1957-12-13 00:00:00	1957-12-13	5001	0	\N	0	0	\N	\N	0	311879	0	8331-1	3006322		
40402	3754	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	249504	0	6276-0	3027231		
116254	3582	4133840	2017-02-19	2017-02-19 00:00:00	2017-02-19	5001	0	\N	0	0	\N	\N	0	238120	0	127783003	4133840		
42704	1316	4024958	1950-04-23	1950-04-23 00:00:00	1950-04-23	5001	0	\N	0	0	\N	\N	0	87226	0	117015009	4024958		
40460	3759	3006451	1983-08-31	1983-08-31 00:00:00	1983-08-31	5001	0	\N	0	0	\N	\N	0	249968	0	6273-7	3006451		
12133	1151	3006322	1989-12-10	1989-12-10 00:00:00	1989-12-10	5001	0	\N	0	0	\N	\N	0	76087	0	8331-1	3006322		
33773	3067	3006322	1951-06-22	1951-06-22 00:00:00	1951-06-22	5001	0	\N	0	0	\N	\N	0	204098	0	8331-1	3006322		
61780	1892	4052083	2006-05-24	2006-05-24 00:00:00	2006-05-24	5001	0	\N	0	0	\N	\N	0	126030	0	23426006	4052083		
9317	882	3006322	1971-01-24	1971-01-24 00:00:00	1971-01-24	5001	0	\N	0	0	\N	\N	0	58758	0	8331-1	3006322		
47025	4329	3006322	1997-07-20	1997-07-20 00:00:00	1997-07-20	5001	0	\N	0	0	\N	\N	0	287147	0	8331-1	3006322		
99703	3060	4052083	1925-06-24	1925-06-24 00:00:00	1925-06-24	5001	0	\N	0	0	\N	\N	0	203554	0	23426006	4052083		
20035	1843	3015076	1998-02-25	1998-02-25 00:00:00	1998-02-25	5001	0	\N	0	0	\N	\N	0	123041	0	6248-9	3015076		
10796	341	4133840	2018-09-03	2018-09-03 00:00:00	2018-09-03	5001	0	\N	0	0	\N	\N	0	22813	0	127783003	4133840		
32251	2933	3006322	1957-10-31	1957-10-31 00:00:00	1957-10-31	5001	0	\N	0	0	\N	\N	0	195615	0	8331-1	3006322		
15532	486	4024958	1986-09-21	1986-09-21 00:00:00	1986-09-21	5001	0	\N	0	0	\N	\N	0	32506	0	117015009	4024958		
78545	2412	4052083	1990-11-02	1990-11-02 00:00:00	1990-11-02	5001	0	\N	0	0	\N	\N	0	160096	0	23426006	4052083		
21210	1960	3006322	1983-05-27	1983-05-27 00:00:00	1983-05-27	5001	0	\N	0	0	\N	\N	0	130341	0	8331-1	3006322		
6569	616	3006322	2014-01-27	2014-01-27 00:00:00	2014-01-27	5001	0	\N	0	0	\N	\N	0	41138	0	8331-1	3006322		
17926	1626	3027970	1989-12-17	1989-12-17 00:00:00	1989-12-17	5001	0	\N	0	0	\N	\N	0	109189	0	10834-0	3027970		
6804	212	4052083	1980-08-27	1980-08-27 00:00:00	1980-08-27	5001	0	\N	0	0	\N	\N	0	14466	0	23426006	4052083		
34456	3147	3011505	2002-03-11	2002-03-11 00:00:00	2002-03-11	5001	0	\N	0	0	\N	\N	0	209407	0	19926-5	3011505		
86566	2674	4052083	2007-03-23	2007-03-23 00:00:00	2007-03-23	5001	0	\N	0	0	\N	\N	0	177205	0	23426006	4052083		
6328	600	3006322	1980-09-17	1980-09-17 00:00:00	1980-09-17	5001	0	\N	0	0	\N	\N	0	39639	0	8331-1	3006322		
7092	680	3005136	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	45008	0	6075-6	3005136		
17740	1613	3006322	2006-09-29	2006-09-29 00:00:00	2006-09-29	5001	0	\N	0	0	\N	\N	0	108442	0	8331-1	3006322		
36039	3314	3006322	1980-04-30	1980-04-30 00:00:00	1980-04-30	5001	0	\N	0	0	\N	\N	0	220075	0	8331-1	3006322		
109505	3378	4052083	2000-06-12	2000-06-12 00:00:00	2000-06-12	5001	0	\N	0	0	\N	\N	0	224150	0	23426006	4052083		
120539	3718	4024958	1977-02-27	1977-02-27 00:00:00	1977-02-27	5001	0	\N	0	0	\N	\N	0	247107	0	117015009	4024958		
47570	4372	3023430	1996-11-14	1996-11-14 00:00:00	1996-11-14	5001	0	\N	0	0	\N	\N	0	290277	0	6833-8	3023430		
36997	3399	3036780	1996-02-12	1996-02-12 00:00:00	1996-02-12	5001	0	\N	0	0	\N	\N	0	225512	0	6095-4	3036780		
48336	4437	3006322	1981-01-17	1981-01-17 00:00:00	1981-01-17	5001	0	\N	0	0	\N	\N	0	294931	0	8331-1	3006322		
16322	1486	3005136	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	99099	0	6075-6	3005136		
52936	4859	3013682	1971-06-05	1971-06-05 00:00:00	1971-06-05	5001	0	\N	0	0	\N	\N	0	323226	0	3094-0	3013682		
43830	1352	4133840	2005-04-24	2005-04-24 00:00:00	2005-04-24	5001	0	\N	0	0	\N	\N	0	89556	0	127783003	4133840		
3363	331	3006322	1957-12-21	1957-12-21 00:00:00	1957-12-21	5001	0	\N	0	0	\N	\N	0	21768	0	8331-1	3006322		
49578	4509	3011505	2017-08-29	2017-08-29 00:00:00	2017-08-29	5001	0	\N	0	0	\N	\N	0	300351	0	19926-5	3011505		
108842	3363	4052083	1985-04-30	1985-04-30 00:00:00	1985-04-30	5001	0	\N	0	0	\N	\N	0	222994	0	23426006	4052083		
50676	4623	3049273	1989-09-26	1989-09-26 00:00:00	1989-09-26	5001	0	\N	0	0	\N	\N	0	307998	0	38265-5	3049273		
34225	3118	3012494	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	207442	0	6206-7	3012494		
34287	3123	3019406	1978-02-19	1978-02-19 00:00:00	1978-02-19	5001	0	\N	0	0	\N	\N	0	207805	0	6158-0	3019406		
2858	273	3015076	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	18196	0	6248-9	3015076		
2145	191	3011505	1992-09-15	1992-09-15 00:00:00	1992-09-15	5001	0	\N	0	0	\N	\N	0	13068	0	19926-5	3011505		
8961	859	3000876	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	56883	0	6082-2	3000876		
8974	859	3005136	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	56795	0	6075-6	3005136		
38694	3580	40758406	1997-04-17	1997-04-17 00:00:00	1997-04-17	5001	0	\N	0	0	\N	\N	0	237999	0	55277-8	40758406		
11951	1138	3001247	1985-02-26	1985-02-26 00:00:00	1985-02-26	5001	0	\N	0	0	\N	\N	0	75060	0	6085-5	3001247		
38834	3589	3006322	2009-02-04	2009-02-04 00:00:00	2009-02-04	5001	0	\N	0	0	\N	\N	0	238445	0	8331-1	3006322		
13952	1310	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	86613	0	6246-3	3021226		
50463	4602	3006322	1996-06-16	1996-06-16 00:00:00	1996-06-16	5001	0	\N	0	0	\N	\N	0	306538	0	8331-1	3006322		
43502	4024	3006322	2006-09-14	2006-09-14 00:00:00	2006-09-14	5001	0	\N	0	0	\N	\N	0	267559	0	8331-1	3006322		
47961	4391	3006322	2013-10-23	2013-10-23 00:00:00	2013-10-23	5001	0	\N	0	0	\N	\N	0	291963	0	8331-1	3006322		
36823	3378	3006322	1978-11-10	1978-11-10 00:00:00	1978-11-10	5001	0	\N	0	0	\N	\N	0	224124	0	8331-1	3006322		
15621	1431	3001247	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	95212	0	6085-5	3001247		
8705	842	3011505	1996-07-06	1996-07-06 00:00:00	1996-07-06	5001	0	\N	0	0	\N	\N	0	55687	0	19926-5	3011505		
49248	4500	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	299610	0	6158-0	3019406		
49320	4503	3006322	1948-03-23	1948-03-23 00:00:00	1948-03-23	5001	0	\N	0	0	\N	\N	0	299808	0	8331-1	3006322		
31534	2891	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	192290	0	6189-5	3006734		
31613	2894	3006322	1966-08-01	1966-08-01 00:00:00	1966-08-01	5001	0	\N	0	0	\N	\N	0	192636	0	8331-1	3006322		
53088	4878	3000876	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	324320	0	6082-2	3000876		
124662	3852	4024958	1993-04-17	1993-04-17 00:00:00	1993-04-17	5001	0	\N	0	0	\N	\N	0	255753	0	117015009	4024958		
44784	4137	3011505	2015-02-18	2015-02-18 00:00:00	2015-02-18	5001	0	\N	0	0	\N	\N	0	275044	0	19926-5	3011505		
16528	1508	3006322	2000-01-19	2000-01-19 00:00:00	2000-01-19	5001	0	\N	0	0	\N	\N	0	100574	0	8331-1	3006322		
51175	4680	3049273	1985-06-24	1985-06-24 00:00:00	1985-06-24	5001	0	\N	0	0	\N	\N	0	311949	0	38265-5	3049273		
40403	3754	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	249504	0	7258-7	3001488		
116255	3582	4133840	2000-06-11	2000-06-11 00:00:00	2000-06-11	5001	0	\N	0	0	\N	\N	0	238098	0	127783003	4133840		
42709	1316	4052083	1949-12-22	1949-12-22 00:00:00	1949-12-22	5001	0	\N	0	0	\N	\N	0	87225	0	23426006	4052083		
40461	3759	3012494	1983-08-31	1983-08-31 00:00:00	1983-08-31	5001	0	\N	0	0	\N	\N	0	249968	0	6206-7	3012494		
12139	1154	3006322	1991-07-03	1991-07-03 00:00:00	1991-07-03	5001	0	\N	0	0	\N	\N	0	76216	0	8331-1	3006322		
33774	3067	3049273	2010-12-05	2010-12-05 00:00:00	2010-12-05	5001	0	\N	0	0	\N	\N	0	204188	0	38265-5	3049273		
61785	1892	4024958	1969-09-28	1969-09-28 00:00:00	1969-09-28	5001	0	\N	0	0	\N	\N	0	126024	0	117015009	4024958		
9318	883	3006322	1972-09-10	1972-09-10 00:00:00	1972-09-10	5001	0	\N	0	0	\N	\N	0	58813	0	8331-1	3006322		
47026	4329	3006322	2013-10-04	2013-10-04 00:00:00	2013-10-04	5001	0	\N	0	0	\N	\N	0	287124	0	8331-1	3006322		
110983	3430	4133840	2001-03-17	2001-03-17 00:00:00	2001-03-17	5001	0	\N	0	0	\N	\N	0	227371	0	127783003	4133840		
20036	1843	3027231	1998-02-25	1998-02-25 00:00:00	1998-02-25	5001	0	\N	0	0	\N	\N	0	123041	0	6276-0	3027231		
10799	341	4024958	1986-11-26	1986-11-26 00:00:00	1986-11-26	5001	0	\N	0	0	\N	\N	0	22783	0	117015009	4024958		
32252	2933	3006322	1978-07-08	1978-07-08 00:00:00	1978-07-08	5001	0	\N	0	0	\N	\N	0	195629	0	8331-1	3006322		
15537	487	4052083	2007-05-27	2007-05-27 00:00:00	2007-05-27	5001	0	\N	0	0	\N	\N	0	32543	0	23426006	4052083		
128886	3967	4052083	2013-02-25	2013-02-25 00:00:00	2013-02-25	5001	0	\N	0	0	\N	\N	0	263774	0	23426006	4052083		
10132	964	3006322	1982-10-18	1982-10-18 00:00:00	1982-10-18	5001	0	\N	0	0	\N	\N	0	64192	0	8331-1	3006322		
6594	621	3049273	2003-01-08	2003-01-08 00:00:00	2003-01-08	5001	0	\N	0	0	\N	\N	0	41389	0	38265-5	3049273		
17927	1626	3013721	1989-12-17	1989-12-17 00:00:00	1989-12-17	5001	0	\N	0	0	\N	\N	0	109189	0	1920-8	3013721		
6807	212	4024958	1984-12-18	1984-12-18 00:00:00	1984-12-18	5001	0	\N	0	0	\N	\N	0	14467	0	117015009	4024958		
34457	3147	3011505	1990-01-22	1990-01-22 00:00:00	1990-01-22	5001	0	\N	0	0	\N	\N	0	209427	0	19926-5	3011505		
86569	2674	4052083	1971-05-25	1971-05-25 00:00:00	1971-05-25	5001	0	\N	0	0	\N	\N	0	177182	0	23426006	4052083		
6329	601	3006322	1971-10-21	1971-10-21 00:00:00	1971-10-21	5001	0	\N	0	0	\N	\N	0	39717	0	8331-1	3006322		
7093	680	3021226	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	45008	0	6246-3	3021226		
17741	1613	3006322	1990-07-30	1990-07-30 00:00:00	1990-07-30	5001	0	\N	0	0	\N	\N	0	108483	0	8331-1	3006322		
36040	3315	3006322	2008-05-19	2008-05-19 00:00:00	2008-05-19	5001	0	\N	0	0	\N	\N	0	220170	0	8331-1	3006322		
109513	3378	4024958	1974-07-22	1974-07-22 00:00:00	1974-07-22	5001	0	\N	0	0	\N	\N	0	224198	0	117015009	4024958		
120555	3718	4052083	1973-10-15	1973-10-15 00:00:00	1973-10-15	5001	0	\N	0	0	\N	\N	0	247106	0	23426006	4052083		
47571	4372	3014599	1996-11-14	1996-11-14 00:00:00	1996-11-14	5001	0	\N	0	0	\N	\N	0	290277	0	6106-9	3014599		
36998	3399	3027231	1996-02-12	1996-02-12 00:00:00	1996-02-12	5001	0	\N	0	0	\N	\N	0	225512	0	6276-0	3027231		
48337	4437	3006322	1976-10-01	1976-10-01 00:00:00	1976-10-01	5001	0	\N	0	0	\N	\N	0	294941	0	8331-1	3006322		
16323	1486	3019406	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	99099	0	6158-0	3019406		
52937	4859	3006322	1980-11-07	1980-11-07 00:00:00	1980-11-07	5001	0	\N	0	0	\N	\N	0	323249	0	8331-1	3006322		
43835	1352	4133840	2010-05-23	2010-05-23 00:00:00	2010-05-23	5001	0	\N	0	0	\N	\N	0	89544	0	127783003	4133840		
3364	331	3006322	2001-02-28	2001-02-28 00:00:00	2001-02-28	5001	0	\N	0	0	\N	\N	0	21862	0	8331-1	3006322		
41132	3827	3006322	2011-04-05	2011-04-05 00:00:00	2011-04-05	5001	0	\N	0	0	\N	\N	0	254211	0	8331-1	3006322		
121559	3752	4024958	1959-04-07	1959-04-07 00:00:00	1959-04-07	5001	0	\N	0	0	\N	\N	0	249342	0	117015009	4024958		
50677	4623	3006322	1958-02-20	1958-02-20 00:00:00	1958-02-20	5001	0	\N	0	0	\N	\N	0	307927	0	8331-1	3006322		
34226	3118	3014599	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	207442	0	6106-9	3014599		
34288	3123	3006734	1978-02-19	1978-02-19 00:00:00	1978-02-19	5001	0	\N	0	0	\N	\N	0	207805	0	6189-5	3006734		
2859	273	3005136	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	18196	0	6075-6	3005136		
2146	191	3006322	1977-07-04	1977-07-04 00:00:00	1977-07-04	5001	0	\N	0	0	\N	\N	0	13024	0	8331-1	3006322		
8962	859	3005136	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	56883	0	6075-6	3005136		
8975	859	3027231	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	56795	0	6276-0	3027231		
38696	3580	3051031	1997-04-17	1997-04-17 00:00:00	1997-04-17	5001	0	\N	0	0	\N	\N	0	237999	0	46240-8	3051031		
11952	1138	3006451	1985-02-26	1985-02-26 00:00:00	1985-02-26	5001	0	\N	0	0	\N	\N	0	75060	0	6273-7	3006451		
38835	3589	3001488	1994-01-03	1994-01-03 00:00:00	1994-01-03	5001	0	\N	0	0	\N	\N	0	238450	0	7258-7	3001488		
13953	1310	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	86613	0	6833-8	3023430		
50464	4602	3006322	2004-02-20	2004-02-20 00:00:00	2004-02-20	5001	0	\N	0	0	\N	\N	0	306567	0	8331-1	3006322		
43503	4024	3011505	2012-05-13	2012-05-13 00:00:00	2012-05-13	5001	0	\N	0	0	\N	\N	0	267567	0	19926-5	3011505		
47962	4391	3049273	2016-11-26	2016-11-26 00:00:00	2016-11-26	5001	0	\N	0	0	\N	\N	0	291943	0	38265-5	3049273		
36829	3381	3006322	1972-12-13	1972-12-13 00:00:00	1972-12-13	5001	0	\N	0	0	\N	\N	0	224382	0	8331-1	3006322		
15622	1431	3023430	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	95212	0	6833-8	3023430		
8706	842	3011505	1989-05-27	1989-05-27 00:00:00	1989-05-27	5001	0	\N	0	0	\N	\N	0	55739	0	19926-5	3011505		
49249	4500	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	299610	0	6075-6	3005136		
49321	4503	3006322	1977-04-06	1977-04-06 00:00:00	1977-04-06	5001	0	\N	0	0	\N	\N	0	299880	0	8331-1	3006322		
31535	2891	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	192290	0	6276-0	3027231		
31614	2894	3049273	1995-10-22	1995-10-22 00:00:00	1995-10-22	5001	0	\N	0	0	\N	\N	0	192602	0	38265-5	3049273		
53089	4878	3006322	1963-11-02	1963-11-02 00:00:00	1963-11-02	5001	0	\N	0	0	\N	\N	0	324400	0	8331-1	3006322		
43019	3976	3051031	1964-09-14	1964-09-14 00:00:00	1964-09-14	5001	0	\N	0	0	\N	\N	0	264381	0	46240-8	3051031		
44785	4137	3011505	2014-02-12	2014-02-12 00:00:00	2014-02-12	5001	0	\N	0	0	\N	\N	0	275033	0	19926-5	3011505		
16529	1508	3006322	1974-07-09	1974-07-09 00:00:00	1974-07-09	5001	0	\N	0	0	\N	\N	0	100652	0	8331-1	3006322		
51176	4680	3006322	1989-02-18	1989-02-18 00:00:00	1989-02-18	5001	0	\N	0	0	\N	\N	0	311889	0	8331-1	3006322		
40404	3754	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	249504	0	6085-5	3001247		
116258	3582	4133840	1996-06-02	1996-06-02 00:00:00	1996-06-02	5001	0	\N	0	0	\N	\N	0	238104	0	127783003	4133840		
42711	1316	4052083	1953-03-23	1953-03-23 00:00:00	1953-03-23	5001	0	\N	0	0	\N	\N	0	87217	0	23426006	4052083		
40462	3759	3001247	1983-08-31	1983-08-31 00:00:00	1983-08-31	5001	0	\N	0	0	\N	\N	0	249968	0	6085-5	3001247		
12140	1154	3049273	2002-05-21	2002-05-21 00:00:00	2002-05-21	5001	0	\N	0	0	\N	\N	0	76272	0	38265-5	3049273		
7161	225	4024958	1974-07-29	1974-07-29 00:00:00	1974-07-29	5001	0	\N	0	0	\N	\N	0	15163	0	117015009	4024958		
61791	1892	4133840	2011-07-21	2011-07-21 00:00:00	2011-07-21	5001	0	\N	0	0	\N	\N	0	126014	0	127783003	4133840		
9319	883	3006322	2003-08-24	2003-08-24 00:00:00	2003-08-24	5001	0	\N	0	0	\N	\N	0	58773	0	8331-1	3006322		
47027	4329	3006322	2014-06-18	2014-06-18 00:00:00	2014-06-18	5001	0	\N	0	0	\N	\N	0	287126	0	8331-1	3006322		
110986	3430	4133840	1989-03-04	1989-03-04 00:00:00	1989-03-04	5001	0	\N	0	0	\N	\N	0	227354	0	127783003	4133840		
20037	1843	3000876	1998-02-25	1998-02-25 00:00:00	1998-02-25	5001	0	\N	0	0	\N	\N	0	123041	0	6082-2	3000876		
10801	341	4133840	2017-08-28	2017-08-28 00:00:00	2017-08-28	5001	0	\N	0	0	\N	\N	0	22799	0	127783003	4133840		
32273	2935	3006322	2001-01-27	2001-01-27 00:00:00	2001-01-27	5001	0	\N	0	0	\N	\N	0	195686	0	8331-1	3006322		
126896	3906	4052083	1990-06-23	1990-06-23 00:00:00	1990-06-23	5001	0	\N	0	0	\N	\N	0	259731	0	23426006	4052083		
128892	3967	4024958	1994-12-14	1994-12-14 00:00:00	1994-12-14	5001	0	\N	0	0	\N	\N	0	263765	0	117015009	4024958		
10133	964	3006322	1984-06-23	1984-06-23 00:00:00	1984-06-23	5001	0	\N	0	0	\N	\N	0	64184	0	8331-1	3006322		
6595	621	3006322	1945-05-29	1945-05-29 00:00:00	1945-05-29	5001	0	\N	0	0	\N	\N	0	41449	0	8331-1	3006322		
17928	1626	3024561	1989-12-17	1989-12-17 00:00:00	1989-12-17	5001	0	\N	0	0	\N	\N	0	109189	0	1751-7	3024561		
6833	213	4024958	1986-09-05	1986-09-05 00:00:00	1986-09-05	5001	0	\N	0	0	\N	\N	0	14511	0	117015009	4024958		
34458	3147	3011505	2012-05-07	2012-05-07 00:00:00	2012-05-07	5001	0	\N	0	0	\N	\N	0	209367	0	19926-5	3011505		
86570	2674	4052083	1989-02-03	1989-02-03 00:00:00	1989-02-03	5001	0	\N	0	0	\N	\N	0	177226	0	23426006	4052083		
6330	601	3006322	1983-07-04	1983-07-04 00:00:00	1983-07-04	5001	0	\N	0	0	\N	\N	0	39758	0	8331-1	3006322		
7094	680	3023430	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	45008	0	6833-8	3023430		
17743	1613	3006322	1981-07-31	1981-07-31 00:00:00	1981-07-31	5001	0	\N	0	0	\N	\N	0	108457	0	8331-1	3006322		
36041	3315	3006322	2013-02-07	2013-02-07 00:00:00	2013-02-07	5001	0	\N	0	0	\N	\N	0	220154	0	8331-1	3006322		
109523	3378	4052083	1970-05-05	1970-05-05 00:00:00	1970-05-05	5001	0	\N	0	0	\N	\N	0	224197	0	23426006	4052083		
120558	3719	4024958	1998-10-21	1998-10-21 00:00:00	1998-10-21	5001	0	\N	0	0	\N	\N	0	247151	0	117015009	4024958		
47572	4372	3012494	1996-11-14	1996-11-14 00:00:00	1996-11-14	5001	0	\N	0	0	\N	\N	0	290277	0	6206-7	3012494		
36999	3399	3014599	1996-02-12	1996-02-12 00:00:00	1996-02-12	5001	0	\N	0	0	\N	\N	0	225512	0	6106-9	3014599		
48338	4437	3006322	1984-03-15	1984-03-15 00:00:00	1984-03-15	5001	0	\N	0	0	\N	\N	0	294942	0	8331-1	3006322		
16324	1486	3015076	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	99099	0	6248-9	3015076		
52938	4859	3006322	1999-10-29	1999-10-29 00:00:00	1999-10-29	5001	0	\N	0	0	\N	\N	0	323254	0	8331-1	3006322		
43837	1352	4133840	1993-08-15	1993-08-15 00:00:00	1993-08-15	5001	0	\N	0	0	\N	\N	0	89553	0	127783003	4133840		
3365	331	3006322	2018-11-30	2018-11-30 00:00:00	2018-11-30	5001	0	\N	0	0	\N	\N	0	21863	0	8331-1	3006322		
41133	3827	3006322	2009-04-03	2009-04-03 00:00:00	2009-04-03	5001	0	\N	0	0	\N	\N	0	254161	0	8331-1	3006322		
121561	3752	4024958	1966-03-14	1966-03-14 00:00:00	1966-03-14	5001	0	\N	0	0	\N	\N	0	249296	0	117015009	4024958		
50678	4623	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	307945	0	6095-4	3036780		
34227	3118	3001488	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	207442	0	7258-7	3001488		
34289	3123	3020655	1978-02-19	1978-02-19 00:00:00	1978-02-19	5001	0	\N	0	0	\N	\N	0	207805	0	6844-5	3020655		
2860	273	3012494	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	18196	0	6206-7	3012494		
2147	192	3006322	2014-02-09	2014-02-09 00:00:00	2014-02-09	5001	0	\N	0	0	\N	\N	0	13150	0	8331-1	3006322		
8963	859	3019406	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	56883	0	6158-0	3019406		
8976	859	3014599	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	56795	0	6106-9	3014599		
38698	3580	46235214	1997-04-17	1997-04-17 00:00:00	1997-04-17	5001	0	\N	0	0	\N	\N	0	237999	0	76690-7	46235214		
11953	1138	3012494	1985-02-26	1985-02-26 00:00:00	1985-02-26	5001	0	\N	0	0	\N	\N	0	75060	0	6206-7	3012494		
38836	3589	3001247	1994-01-03	1994-01-03 00:00:00	1994-01-03	5001	0	\N	0	0	\N	\N	0	238450	0	6085-5	3001247		
5392	512	3051031	1960-06-17	1960-06-17 00:00:00	1960-06-17	5001	0	\N	0	0	\N	\N	0	34199	0	46240-8	3051031		
50465	4602	3006322	1985-12-26	1985-12-26 00:00:00	1985-12-26	5001	0	\N	0	0	\N	\N	0	306532	0	8331-1	3006322		
43504	4024	3011505	2018-05-20	2018-05-20 00:00:00	2018-05-20	5001	0	\N	0	0	\N	\N	0	267569	0	19926-5	3011505		
47963	4391	3006322	1983-09-19	1983-09-19 00:00:00	1983-09-19	5001	0	\N	0	0	\N	\N	0	291960	0	8331-1	3006322		
36830	3381	3006322	1988-01-08	1988-01-08 00:00:00	1988-01-08	5001	0	\N	0	0	\N	\N	0	224389	0	8331-1	3006322		
15623	1431	3020655	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	95212	0	6844-5	3020655		
8707	842	3011505	2013-10-12	2013-10-12 00:00:00	2013-10-12	5001	0	\N	0	0	\N	\N	0	55684	0	19926-5	3011505		
49250	4500	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	299610	0	6248-9	3015076		
49322	4503	3006322	1987-09-20	1987-09-20 00:00:00	1987-09-20	5001	0	\N	0	0	\N	\N	0	299801	0	8331-1	3006322		
31536	2891	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	192290	0	6273-7	3006451		
31618	2895	3006322	1975-06-04	1975-06-04 00:00:00	1975-06-04	5001	0	\N	0	0	\N	\N	0	192691	0	8331-1	3006322		
53090	4878	3000876	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	324403	0	6082-2	3000876		
43021	3976	40766240	1964-09-14	1964-09-14 00:00:00	1964-09-14	5001	0	\N	0	0	\N	\N	0	264381	0	63513-6	40766240		
44786	4137	3006322	1964-01-11	1964-01-11 00:00:00	1964-01-11	5001	0	\N	0	0	\N	\N	0	274991	0	8331-1	3006322		
16530	1508	3006322	1972-07-08	1972-07-08 00:00:00	1972-07-08	5001	0	\N	0	0	\N	\N	0	100572	0	8331-1	3006322		
51178	4680	3049273	1995-01-24	1995-01-24 00:00:00	1995-01-24	5001	0	\N	0	0	\N	\N	0	311952	0	38265-5	3049273		
40405	3754	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	249504	0	6246-3	3021226		
116260	3582	4133840	2012-07-01	2012-07-01 00:00:00	2012-07-01	5001	0	\N	0	0	\N	\N	0	238119	0	127783003	4133840		
53324	4898	3006322	2005-04-01	2005-04-01 00:00:00	2005-04-01	5001	0	\N	0	0	\N	\N	0	325696	0	8331-1	3006322		
40463	3759	3036780	1983-08-31	1983-08-31 00:00:00	1983-08-31	5001	0	\N	0	0	\N	\N	0	249968	0	6095-4	3036780		
12141	1154	3006322	1981-02-14	1981-02-14 00:00:00	1981-02-14	5001	0	\N	0	0	\N	\N	0	76279	0	8331-1	3006322		
7180	227	4024958	2003-07-25	2003-07-25 00:00:00	2003-07-25	5001	0	\N	0	0	\N	\N	0	15367	0	117015009	4024958		
61794	1892	4133840	2015-08-13	2015-08-13 00:00:00	2015-08-13	5001	0	\N	0	0	\N	\N	0	126016	0	127783003	4133840		
9320	883	3006322	1993-01-03	1993-01-03 00:00:00	1993-01-03	5001	0	\N	0	0	\N	\N	0	58822	0	8331-1	3006322		
47028	4329	3006322	2008-09-17	2008-09-17 00:00:00	2008-09-17	5001	0	\N	0	0	\N	\N	0	287079	0	8331-1	3006322		
110990	3430	4133840	2007-03-31	2007-03-31 00:00:00	2007-03-31	5001	0	\N	0	0	\N	\N	0	227375	0	127783003	4133840		
20038	1843	3005136	1998-02-25	1998-02-25 00:00:00	1998-02-25	5001	0	\N	0	0	\N	\N	0	123041	0	6075-6	3005136		
10803	341	4133840	2018-12-03	2018-12-03 00:00:00	2018-12-03	5001	0	\N	0	0	\N	\N	0	22765	0	127783003	4133840		
32274	2936	3006322	2019-01-08	2019-01-08 00:00:00	2019-01-08	5001	0	\N	0	0	\N	\N	0	195747	0	8331-1	3006322		
126897	3906	4052083	1978-03-13	1978-03-13 00:00:00	1978-03-13	5001	0	\N	0	0	\N	\N	0	259655	0	23426006	4052083		
128894	3967	4024958	1964-03-14	1964-03-14 00:00:00	1964-03-14	5001	0	\N	0	0	\N	\N	0	263766	0	117015009	4024958		
10134	964	3006322	1980-11-04	1980-11-04 00:00:00	1980-11-04	5001	0	\N	0	0	\N	\N	0	64183	0	8331-1	3006322		
6596	621	3006322	1973-08-19	1973-08-19 00:00:00	1973-08-19	5001	0	\N	0	0	\N	\N	0	41362	0	8331-1	3006322		
17929	1626	3011505	2007-11-04	2007-11-04 00:00:00	2007-11-04	5001	0	\N	0	0	\N	\N	0	109202	0	19926-5	3011505		
6834	213	4024958	1990-01-31	1990-01-31 00:00:00	1990-01-31	5001	0	\N	0	0	\N	\N	0	14518	0	117015009	4024958		
34459	3147	3011505	2018-06-11	2018-06-11 00:00:00	2018-06-11	5001	0	\N	0	0	\N	\N	0	209350	0	19926-5	3011505		
86583	2675	4052083	1976-05-31	1976-05-31 00:00:00	1976-05-31	5001	0	\N	0	0	\N	\N	0	177289	0	23426006	4052083		
6331	601	3012494	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	39740	0	6206-7	3012494		
7095	680	3006734	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	45008	0	6189-5	3006734		
17744	1613	3006322	2005-02-25	2005-02-25 00:00:00	2005-02-25	5001	0	\N	0	0	\N	\N	0	108441	0	8331-1	3006322		
36042	3315	3006322	1981-05-05	1981-05-05 00:00:00	1981-05-05	5001	0	\N	0	0	\N	\N	0	220137	0	8331-1	3006322		
166853	5121	4024958	1965-09-13	1965-09-13 00:00:00	1965-09-13	5001	0	\N	0	0	\N	\N	0	340472	0	117015009	4024958		
120724	3725	4024958	2016-03-20	2016-03-20 00:00:00	2016-03-20	5001	0	\N	0	0	\N	\N	0	247567	0	117015009	4024958		
47573	4372	3000876	1996-11-14	1996-11-14 00:00:00	1996-11-14	5001	0	\N	0	0	\N	\N	0	290277	0	6082-2	3000876		
37000	3399	3005136	1996-02-12	1996-02-12 00:00:00	1996-02-12	5001	0	\N	0	0	\N	\N	0	225512	0	6075-6	3005136		
130324	4017	4052083	1986-10-14	1986-10-14 00:00:00	1986-10-14	5001	0	\N	0	0	\N	\N	0	266947	0	23426006	4052083		
16325	1486	3006451	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	99099	0	6273-7	3006451		
52939	4859	3006322	1958-09-02	1958-09-02 00:00:00	1958-09-02	5001	0	\N	0	0	\N	\N	0	323229	0	8331-1	3006322		
43840	1352	4133840	2013-06-09	2013-06-09 00:00:00	2013-06-09	5001	0	\N	0	0	\N	\N	0	89579	0	127783003	4133840		
3366	331	3006322	2017-02-24	2017-02-24 00:00:00	2017-02-24	5001	0	\N	0	0	\N	\N	0	21826	0	8331-1	3006322		
41134	3827	3006322	1987-04-17	1987-04-17 00:00:00	1987-04-17	5001	0	\N	0	0	\N	\N	0	254175	0	8331-1	3006322		
121607	3754	4024958	1973-07-17	1973-07-17 00:00:00	1973-07-17	5001	0	\N	0	0	\N	\N	0	249444	0	117015009	4024958		
50679	4623	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	307945	0	6106-9	3014599		
34228	3118	3006734	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	207442	0	6189-5	3006734		
34290	3123	3023430	1978-02-19	1978-02-19 00:00:00	1978-02-19	5001	0	\N	0	0	\N	\N	0	207805	0	6833-8	3023430		
2861	273	3006734	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	18196	0	6189-5	3006734		
2148	192	3006322	1986-03-10	1986-03-10 00:00:00	1986-03-10	5001	0	\N	0	0	\N	\N	0	13149	0	8331-1	3006322		
8964	859	3012494	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	56883	0	6206-7	3012494		
8977	859	3036780	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	56795	0	6095-4	3036780		
38699	3580	40766240	1997-04-17	1997-04-17 00:00:00	1997-04-17	5001	0	\N	0	0	\N	\N	0	237999	0	63513-6	40766240		
11954	1138	3001488	1985-02-26	1985-02-26 00:00:00	1985-02-26	5001	0	\N	0	0	\N	\N	0	75060	0	7258-7	3001488		
38837	3589	3015076	1994-01-03	1994-01-03 00:00:00	1994-01-03	5001	0	\N	0	0	\N	\N	0	238450	0	6248-9	3015076		
5393	512	40758406	1960-06-17	1960-06-17 00:00:00	1960-06-17	5001	0	\N	0	0	\N	\N	0	34199	0	55277-8	40758406		
50466	4603	3049273	2010-10-28	2010-10-28 00:00:00	2010-10-28	5001	0	\N	0	0	\N	\N	0	306633	0	38265-5	3049273		
43505	4024	3011505	2015-05-17	2015-05-17 00:00:00	2015-05-17	5001	0	\N	0	0	\N	\N	0	267547	0	19926-5	3011505		
47964	4391	3006322	1953-11-03	1953-11-03 00:00:00	1953-11-03	5001	0	\N	0	0	\N	\N	0	292009	0	8331-1	3006322		
36831	3381	3006322	1979-12-23	1979-12-23 00:00:00	1979-12-23	5001	0	\N	0	0	\N	\N	0	224337	0	8331-1	3006322		
15624	1431	3001488	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	95212	0	7258-7	3001488		
8708	842	3011505	2017-11-04	2017-11-04 00:00:00	2017-11-04	5001	0	\N	0	0	\N	\N	0	55686	0	19926-5	3011505		
49251	4500	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	299610	0	6082-2	3000876		
49323	4503	3006322	1992-04-07	1992-04-07 00:00:00	1992-04-07	5001	0	\N	0	0	\N	\N	0	299881	0	8331-1	3006322		
31537	2891	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	192290	0	6106-9	3014599		
31619	2895	3006322	1976-08-08	1976-08-08 00:00:00	1976-08-08	5001	0	\N	0	0	\N	\N	0	192719	0	8331-1	3006322		
53091	4878	3001488	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	324403	0	7258-7	3001488		
43024	3976	3051031	1966-06-06	1966-06-06 00:00:00	1966-06-06	5001	0	\N	0	0	\N	\N	0	264384	0	46240-8	3051031		
44787	4137	3006322	2018-01-09	2018-01-09 00:00:00	2018-01-09	5001	0	\N	0	0	\N	\N	0	274994	0	8331-1	3006322		
16531	1508	3049273	1984-12-11	1984-12-11 00:00:00	1984-12-11	5001	0	\N	0	0	\N	\N	0	100596	0	38265-5	3049273		
51179	4680	3006322	1982-01-14	1982-01-14 00:00:00	1982-01-14	5001	0	\N	0	0	\N	\N	0	311936	0	8331-1	3006322		
40406	3754	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	249504	0	6844-5	3020655		
116261	3582	4133840	2011-06-26	2011-06-26 00:00:00	2011-06-26	5001	0	\N	0	0	\N	\N	0	238134	0	127783003	4133840		
53325	4898	3006322	2017-05-09	2017-05-09 00:00:00	2017-05-09	5001	0	\N	0	0	\N	\N	0	325698	0	8331-1	3006322		
40464	3759	3019406	1983-08-31	1983-08-31 00:00:00	1983-08-31	5001	0	\N	0	0	\N	\N	0	249968	0	6158-0	3019406		
12142	1154	3006322	2013-08-28	2013-08-28 00:00:00	2013-08-28	5001	0	\N	0	0	\N	\N	0	76243	0	8331-1	3006322		
7181	227	4024958	2008-10-17	2008-10-17 00:00:00	2008-10-17	5001	0	\N	0	0	\N	\N	0	15328	0	117015009	4024958		
61797	1892	4052083	1981-03-28	1981-03-28 00:00:00	1981-03-28	5001	0	\N	0	0	\N	\N	0	126027	0	23426006	4052083		
9321	883	3006322	2005-04-26	2005-04-26 00:00:00	2005-04-26	5001	0	\N	0	0	\N	\N	0	58795	0	8331-1	3006322		
47029	4329	3006322	1982-11-22	1982-11-22 00:00:00	1982-11-22	5001	0	\N	0	0	\N	\N	0	287117	0	8331-1	3006322		
110991	3430	4133840	1992-03-07	1992-03-07 00:00:00	1992-03-07	5001	0	\N	0	0	\N	\N	0	227368	0	127783003	4133840		
20039	1843	3012494	1998-02-25	1998-02-25 00:00:00	1998-02-25	5001	0	\N	0	0	\N	\N	0	123041	0	6206-7	3012494		
123154	3796	4052083	1973-09-14	1973-09-14 00:00:00	1973-09-14	5001	0	\N	0	0	\N	\N	0	252354	0	23426006	4052083		
32275	2936	3006322	2009-08-18	2009-08-18 00:00:00	2009-08-18	5001	0	\N	0	0	\N	\N	0	195758	0	8331-1	3006322		
126902	3906	4024958	1982-04-01	1982-04-01 00:00:00	1982-04-01	5001	0	\N	0	0	\N	\N	0	259675	0	117015009	4024958		
128897	3967	4052083	2009-07-23	2009-07-23 00:00:00	2009-07-23	5001	0	\N	0	0	\N	\N	0	263772	0	23426006	4052083		
10135	964	3006322	1981-11-13	1981-11-13 00:00:00	1981-11-13	5001	0	\N	0	0	\N	\N	0	64202	0	8331-1	3006322		
6597	621	3051031	1973-06-02	1973-06-02 00:00:00	1973-06-02	5001	0	\N	0	0	\N	\N	0	41457	0	46240-8	3051031		
17930	1626	3006322	1958-09-15	1958-09-15 00:00:00	1958-09-15	5001	0	\N	0	0	\N	\N	0	109203	0	8331-1	3006322		
6838	213	4052083	2016-06-09	2016-06-09 00:00:00	2016-06-09	5001	0	\N	0	0	\N	\N	0	14527	0	23426006	4052083		
34460	3147	3011505	1972-02-14	1972-02-14 00:00:00	1972-02-14	5001	0	\N	0	0	\N	\N	0	209418	0	19926-5	3011505		
86594	2675	4052083	1993-02-19	1993-02-19 00:00:00	1993-02-19	5001	0	\N	0	0	\N	\N	0	177290	0	23426006	4052083		
6332	601	3006451	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	39740	0	6273-7	3006451		
7096	680	3019406	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	45008	0	6158-0	3019406		
17745	1613	3006322	1960-09-11	1960-09-11 00:00:00	1960-09-11	5001	0	\N	0	0	\N	\N	0	108466	0	8331-1	3006322		
36043	3315	3006322	1981-11-11	1981-11-11 00:00:00	1981-11-11	5001	0	\N	0	0	\N	\N	0	220205	0	8331-1	3006322		
6652	207	4024958	2018-08-09	2018-08-09 00:00:00	2018-08-09	5001	0	\N	0	0	\N	\N	0	14106	0	117015009	4024958		
120736	3725	4024958	2006-10-24	2006-10-24 00:00:00	2006-10-24	5001	0	\N	0	0	\N	\N	0	247566	0	117015009	4024958		
47574	4372	3020655	1996-11-14	1996-11-14 00:00:00	1996-11-14	5001	0	\N	0	0	\N	\N	0	290277	0	6844-5	3020655		
37001	3399	3015076	1996-02-12	1996-02-12 00:00:00	1996-02-12	5001	0	\N	0	0	\N	\N	0	225512	0	6248-9	3015076		
130329	4017	4052083	1936-05-08	1936-05-08 00:00:00	1936-05-08	5001	0	\N	0	0	\N	\N	0	267034	0	23426006	4052083		
16326	1486	3006734	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	99099	0	6189-5	3006734		
52940	4859	3006322	1974-07-01	1974-07-01 00:00:00	1974-07-01	5001	0	\N	0	0	\N	\N	0	323278	0	8331-1	3006322		
43844	1352	4133840	1996-08-25	1996-08-25 00:00:00	1996-08-25	5001	0	\N	0	0	\N	\N	0	89571	0	127783003	4133840		
3367	331	3006322	1944-01-19	1944-01-19 00:00:00	1944-01-19	5001	0	\N	0	0	\N	\N	0	21815	0	8331-1	3006322		
41135	3827	3006322	1969-01-21	1969-01-21 00:00:00	1969-01-21	5001	0	\N	0	0	\N	\N	0	254159	0	8331-1	3006322		
121631	3754	4024958	1970-11-18	1970-11-18 00:00:00	1970-11-18	5001	0	\N	0	0	\N	\N	0	249487	0	117015009	4024958		
50680	4623	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	307945	0	6248-9	3015076		
34229	3118	3011505	1983-06-05	1983-06-05 00:00:00	1983-06-05	5001	0	\N	0	0	\N	\N	0	207508	0	19926-5	3011505		
34291	3123	3001247	1978-02-19	1978-02-19 00:00:00	1978-02-19	5001	0	\N	0	0	\N	\N	0	207805	0	6085-5	3001247		
2862	273	3036780	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	18196	0	6095-4	3036780		
13426	1272	3027231	1992-09-18	1992-09-18 00:00:00	1992-09-18	5001	0	\N	0	0	\N	\N	0	83866	0	6276-0	3027231		
8965	859	3021226	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	56883	0	6246-3	3021226		
8978	859	3001247	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	56795	0	6085-5	3001247		
38700	3580	40766240	1997-08-15	1997-08-15 00:00:00	1997-08-15	5001	0	\N	0	0	\N	\N	0	238002	0	63513-6	40766240		
11955	1138	3021226	1985-02-26	1985-02-26 00:00:00	1985-02-26	5001	0	\N	0	0	\N	\N	0	75060	0	6246-3	3021226		
38838	3589	3006734	1994-01-03	1994-01-03 00:00:00	1994-01-03	5001	0	\N	0	0	\N	\N	0	238450	0	6189-5	3006734		
5396	512	46235214	1960-04-18	1960-04-18 00:00:00	1960-04-18	5001	0	\N	0	0	\N	\N	0	34185	0	76690-7	46235214		
50467	4603	3006322	1970-05-17	1970-05-17 00:00:00	1970-05-17	5001	0	\N	0	0	\N	\N	0	306638	0	8331-1	3006322		
43506	4024	3006322	1989-08-04	1989-08-04 00:00:00	1989-08-04	5001	0	\N	0	0	\N	\N	0	267517	0	8331-1	3006322		
47966	4391	46235214	2008-03-22	2008-03-22 00:00:00	2008-03-22	5001	0	\N	0	0	\N	\N	0	292017	0	76690-7	46235214		
36832	3381	3006322	1972-03-09	1972-03-09 00:00:00	1972-03-09	5001	0	\N	0	0	\N	\N	0	224381	0	8331-1	3006322		
15625	1431	3006322	1984-12-26	1984-12-26 00:00:00	1984-12-26	5001	0	\N	0	0	\N	\N	0	95287	0	8331-1	3006322		
8709	842	3011505	1960-01-09	1960-01-09 00:00:00	1960-01-09	5001	0	\N	0	0	\N	\N	0	55758	0	19926-5	3011505		
49252	4500	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	299610	0	6085-5	3001247		
49324	4504	3006322	2005-12-08	2005-12-08 00:00:00	2005-12-08	5001	0	\N	0	0	\N	\N	0	299932	0	8331-1	3006322		
31538	2891	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	192290	0	6158-0	3019406		
31620	2895	3006322	1967-07-06	1967-07-06 00:00:00	1967-07-06	5001	0	\N	0	0	\N	\N	0	192745	0	8331-1	3006322		
53092	4878	3021226	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	324403	0	6246-3	3021226		
43025	3976	46235214	1966-06-06	1966-06-06 00:00:00	1966-06-06	5001	0	\N	0	0	\N	\N	0	264384	0	76690-7	46235214		
44788	4137	3011505	2018-03-07	2018-03-07 00:00:00	2018-03-07	5001	0	\N	0	0	\N	\N	0	275035	0	19926-5	3011505		
16533	1508	46235214	1951-03-25	1951-03-25 00:00:00	1951-03-25	5001	0	\N	0	0	\N	\N	0	100640	0	76690-7	46235214		
51180	4680	3049273	1928-09-25	1928-09-25 00:00:00	1928-09-25	5001	0	\N	0	0	\N	\N	0	311940	0	38265-5	3049273		
40407	3754	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	249504	0	6095-4	3036780		
116262	3582	4133840	2002-06-16	2002-06-16 00:00:00	2002-06-16	5001	0	\N	0	0	\N	\N	0	238161	0	127783003	4133840		
53326	4898	3006322	1978-03-28	1978-03-28 00:00:00	1978-03-28	5001	0	\N	0	0	\N	\N	0	325694	0	8331-1	3006322		
40465	3759	3036780	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	249857	0	6095-4	3036780		
12143	1154	3006322	2011-11-29	2011-11-29 00:00:00	2011-11-29	5001	0	\N	0	0	\N	\N	0	76221	0	8331-1	3006322		
7183	227	4024958	1972-03-17	1972-03-17 00:00:00	1972-03-17	5001	0	\N	0	0	\N	\N	0	15364	0	117015009	4024958		
65566	2012	4052083	2014-02-23	2014-02-23 00:00:00	2014-02-23	5001	0	\N	0	0	\N	\N	0	133846	0	23426006	4052083		
9322	883	3006322	1969-04-07	1969-04-07 00:00:00	1969-04-07	5001	0	\N	0	0	\N	\N	0	58793	0	8331-1	3006322		
47030	4329	3006322	1981-12-16	1981-12-16 00:00:00	1981-12-16	5001	0	\N	0	0	\N	\N	0	287145	0	8331-1	3006322		
110992	3430	4133840	2005-03-26	2005-03-26 00:00:00	2005-03-26	5001	0	\N	0	0	\N	\N	0	227340	0	127783003	4133840		
20771	1911	40766240	1947-06-24	1947-06-24 00:00:00	1947-06-24	5001	0	\N	0	0	\N	\N	0	127140	0	63513-6	40766240		
123156	3796	4052083	2016-09-07	2016-09-07 00:00:00	2016-09-07	5001	0	\N	0	0	\N	\N	0	252371	0	23426006	4052083		
32276	2936	3006322	1999-10-14	1999-10-14 00:00:00	1999-10-14	5001	0	\N	0	0	\N	\N	0	195741	0	8331-1	3006322		
126903	3906	4052083	1955-07-17	1955-07-17 00:00:00	1955-07-17	5001	0	\N	0	0	\N	\N	0	259671	0	23426006	4052083		
128903	3967	4052083	1980-01-18	1980-01-18 00:00:00	1980-01-18	5001	0	\N	0	0	\N	\N	0	263764	0	23426006	4052083		
10139	967	3049273	2002-02-15	2002-02-15 00:00:00	2002-02-15	5001	0	\N	0	0	\N	\N	0	64317	0	38265-5	3049273		
6598	621	40758406	1973-06-02	1973-06-02 00:00:00	1973-06-02	5001	0	\N	0	0	\N	\N	0	41457	0	55277-8	40758406		
17931	1627	3006322	1965-04-26	1965-04-26 00:00:00	1965-04-26	5001	0	\N	0	0	\N	\N	0	109329	0	8331-1	3006322		
6842	213	4052083	2013-10-01	2013-10-01 00:00:00	2013-10-01	5001	0	\N	0	0	\N	\N	0	14503	0	23426006	4052083		
34461	3147	3011505	1996-02-05	1996-02-05 00:00:00	1996-02-05	5001	0	\N	0	0	\N	\N	0	209346	0	19926-5	3011505		
33077	2986	3006322	2013-07-21	2013-07-21 00:00:00	2013-07-21	5001	0	\N	0	0	\N	\N	0	199334	0	8331-1	3006322		
6333	601	3019406	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	39740	0	6158-0	3019406		
7097	680	3014599	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	45008	0	6106-9	3014599		
23518	736	4024958	1979-05-24	1979-05-24 00:00:00	1979-05-24	5001	0	\N	0	0	\N	\N	0	48784	0	117015009	4024958		
36044	3315	3006322	1969-07-27	1969-07-27 00:00:00	1969-07-27	5001	0	\N	0	0	\N	\N	0	220165	0	8331-1	3006322		
6672	207	4052083	2009-03-23	2009-03-23 00:00:00	2009-03-23	5001	0	\N	0	0	\N	\N	0	14149	0	23426006	4052083		
120849	3730	4024958	1954-05-03	1954-05-03 00:00:00	1954-05-03	5001	0	\N	0	0	\N	\N	0	247832	0	117015009	4024958		
47575	4372	3006734	1996-11-14	1996-11-14 00:00:00	1996-11-14	5001	0	\N	0	0	\N	\N	0	290277	0	6189-5	3006734		
37002	3399	3012494	1996-02-12	1996-02-12 00:00:00	1996-02-12	5001	0	\N	0	0	\N	\N	0	225512	0	6206-7	3012494		
130340	4017	4024958	1922-08-20	1922-08-20 00:00:00	1922-08-20	5001	0	\N	0	0	\N	\N	0	266962	0	117015009	4024958		
16327	1486	3021226	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	99099	0	6246-3	3021226		
52941	4860	3006322	1995-12-03	1995-12-03 00:00:00	1995-12-03	5001	0	\N	0	0	\N	\N	0	323344	0	8331-1	3006322		
43845	1352	4133840	2007-05-06	2007-05-06 00:00:00	2007-05-06	5001	0	\N	0	0	\N	\N	0	89588	0	127783003	4133840		
3368	331	3024731	1997-04-18	1997-04-18 00:00:00	1997-04-18	5001	0	\N	0	0	\N	\N	0	21811	0	30428-7	3024731		
41140	3830	3006322	1983-03-13	1983-03-13 00:00:00	1983-03-13	5001	0	\N	0	0	\N	\N	0	254280	0	8331-1	3006322		
48732	4452	3006322	1958-05-07	1958-05-07 00:00:00	1958-05-07	5001	0	\N	0	0	\N	\N	0	296244	0	8331-1	3006322		
50681	4623	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	307945	0	6273-7	3006451		
34230	3118	3011505	1990-12-16	1990-12-16 00:00:00	1990-12-16	5001	0	\N	0	0	\N	\N	0	207498	0	19926-5	3011505		
34292	3123	3001488	1978-02-19	1978-02-19 00:00:00	1978-02-19	5001	0	\N	0	0	\N	\N	0	207805	0	7258-7	3001488		
2863	273	3000876	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	18196	0	6082-2	3000876		
13427	1272	3006322	2010-01-13	2010-01-13 00:00:00	2010-01-13	5001	0	\N	0	0	\N	\N	0	83953	0	8331-1	3006322		
8966	859	3015076	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	56883	0	6248-9	3015076		
8979	859	3001488	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	56795	0	7258-7	3001488		
38702	3580	46235214	1997-08-15	1997-08-15 00:00:00	1997-08-15	5001	0	\N	0	0	\N	\N	0	238002	0	76690-7	46235214		
11956	1138	3019406	1985-02-26	1985-02-26 00:00:00	1985-02-26	5001	0	\N	0	0	\N	\N	0	75060	0	6158-0	3019406		
38839	3589	3020655	1994-01-03	1994-01-03 00:00:00	1994-01-03	5001	0	\N	0	0	\N	\N	0	238450	0	6844-5	3020655		
5397	512	40766240	1960-04-18	1960-04-18 00:00:00	1960-04-18	5001	0	\N	0	0	\N	\N	0	34185	0	63513-6	40766240		
50468	4603	3006322	1990-05-17	1990-05-17 00:00:00	1990-05-17	5001	0	\N	0	0	\N	\N	0	306653	0	8331-1	3006322		
43508	4024	40758406	2013-04-19	2013-04-19 00:00:00	2013-04-19	5001	0	\N	0	0	\N	\N	0	267546	0	55277-8	40758406		
47967	4391	40766240	2008-03-22	2008-03-22 00:00:00	2008-03-22	5001	0	\N	0	0	\N	\N	0	292017	0	63513-6	40766240		
36833	3381	3006322	2008-08-19	2008-08-19 00:00:00	2008-08-19	5001	0	\N	0	0	\N	\N	0	224350	0	8331-1	3006322		
15626	1431	3023430	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	95274	0	6833-8	3023430		
8710	842	3011505	1983-03-26	1983-03-26 00:00:00	1983-03-26	5001	0	\N	0	0	\N	\N	0	55666	0	19926-5	3011505		
49253	4500	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	299610	0	7258-7	3001488		
49325	4504	3006322	2007-04-18	2007-04-18 00:00:00	2007-04-18	5001	0	\N	0	0	\N	\N	0	299948	0	8331-1	3006322		
31539	2891	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	192290	0	6075-6	3005136		
31621	2895	3006322	2007-08-07	2007-08-07 00:00:00	2007-08-07	5001	0	\N	0	0	\N	\N	0	192694	0	8331-1	3006322		
53093	4878	3015076	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	324403	0	6248-9	3015076		
43026	3976	40758406	1966-06-06	1966-06-06 00:00:00	1966-06-06	5001	0	\N	0	0	\N	\N	0	264384	0	55277-8	40758406		
44789	4137	3011505	2017-03-01	2017-03-01 00:00:00	2017-03-01	5001	0	\N	0	0	\N	\N	0	275045	0	19926-5	3011505		
16534	1508	40766240	1951-03-25	1951-03-25 00:00:00	1951-03-25	5001	0	\N	0	0	\N	\N	0	100640	0	63513-6	40766240		
51181	4680	3049273	1987-05-15	1987-05-15 00:00:00	1987-05-15	5001	0	\N	0	0	\N	\N	0	311950	0	38265-5	3049273		
40408	3754	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	249504	0	6206-7	3012494		
116266	3582	4133840	2007-06-03	2007-06-03 00:00:00	2007-06-03	5001	0	\N	0	0	\N	\N	0	238132	0	127783003	4133840		
53327	4898	3006322	1983-02-11	1983-02-11 00:00:00	1983-02-11	5001	0	\N	0	0	\N	\N	0	325666	0	8331-1	3006322		
40466	3759	3012494	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	249857	0	6206-7	3012494		
12144	1155	3006322	1984-10-03	1984-10-03 00:00:00	1984-10-03	5001	0	\N	0	0	\N	\N	0	76314	0	8331-1	3006322		
7193	227	4024958	1999-08-07	1999-08-07 00:00:00	1999-08-07	5001	0	\N	0	0	\N	\N	0	15316	0	117015009	4024958		
65572	2012	4024958	1977-05-20	1977-05-20 00:00:00	1977-05-20	5001	0	\N	0	0	\N	\N	0	133918	0	117015009	4024958		
9323	883	3006322	1969-09-14	1969-09-14 00:00:00	1969-09-14	5001	0	\N	0	0	\N	\N	0	58791	0	8331-1	3006322		
47031	4330	3006322	2004-03-29	2004-03-29 00:00:00	2004-03-29	5001	0	\N	0	0	\N	\N	0	287214	0	8331-1	3006322		
110998	3430	4052083	1975-03-06	1975-03-06 00:00:00	1975-03-06	5001	0	\N	0	0	\N	\N	0	227391	0	23426006	4052083		
20772	1911	40758406	1947-06-24	1947-06-24 00:00:00	1947-06-24	5001	0	\N	0	0	\N	\N	0	127140	0	55277-8	40758406		
123166	3796	4024958	2010-11-10	2010-11-10 00:00:00	2010-11-10	5001	0	\N	0	0	\N	\N	0	252413	0	117015009	4024958		
32277	2936	3006322	1978-02-21	1978-02-21 00:00:00	1978-02-21	5001	0	\N	0	0	\N	\N	0	195817	0	8331-1	3006322		
138198	4260	4024958	1939-01-27	1939-01-27 00:00:00	1939-01-27	5001	0	\N	0	0	\N	\N	0	282762	0	117015009	4024958		
128920	3968	4052083	2007-05-21	2007-05-21 00:00:00	2007-05-21	5001	0	\N	0	0	\N	\N	0	263855	0	23426006	4052083		
10140	967	3006322	1990-11-04	1990-11-04 00:00:00	1990-11-04	5001	0	\N	0	0	\N	\N	0	64354	0	8331-1	3006322		
6600	621	46235214	1973-06-02	1973-06-02 00:00:00	1973-06-02	5001	0	\N	0	0	\N	\N	0	41457	0	76690-7	46235214		
17932	1627	3006322	2000-06-03	2000-06-03 00:00:00	2000-06-03	5001	0	\N	0	0	\N	\N	0	109368	0	8331-1	3006322		
104638	3221	4024958	1970-02-26	1970-02-26 00:00:00	1970-02-26	5001	0	\N	0	0	\N	\N	0	214071	0	117015009	4024958		
34462	3147	3011505	2013-05-13	2013-05-13 00:00:00	2013-05-13	5001	0	\N	0	0	\N	\N	0	209410	0	19926-5	3011505		
33078	2986	3006322	2002-01-07	2002-01-07 00:00:00	2002-01-07	5001	0	\N	0	0	\N	\N	0	199286	0	8331-1	3006322		
6334	601	3001247	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	39740	0	6085-5	3001247		
7098	680	3020655	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	45008	0	6844-5	3020655		
23524	738	4024958	1986-08-22	1986-08-22 00:00:00	1986-08-22	5001	0	\N	0	0	\N	\N	0	48866	0	117015009	4024958		
36045	3315	3006322	2002-02-07	2002-02-07 00:00:00	2002-02-07	5001	0	\N	0	0	\N	\N	0	220208	0	8331-1	3006322		
6674	207	4024958	1973-09-10	1973-09-10 00:00:00	1973-09-10	5001	0	\N	0	0	\N	\N	0	14113	0	117015009	4024958		
120850	3730	4052083	2007-01-24	2007-01-24 00:00:00	2007-01-24	5001	0	\N	0	0	\N	\N	0	247877	0	23426006	4052083		
47576	4372	3001247	1996-11-14	1996-11-14 00:00:00	1996-11-14	5001	0	\N	0	0	\N	\N	0	290277	0	6085-5	3001247		
37003	3399	3000876	1996-02-12	1996-02-12 00:00:00	1996-02-12	5001	0	\N	0	0	\N	\N	0	225512	0	6082-2	3000876		
130348	4017	4024958	1927-07-10	1927-07-10 00:00:00	1927-07-10	5001	0	\N	0	0	\N	\N	0	266943	0	117015009	4024958		
16328	1486	3012494	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	99099	0	6206-7	3012494		
52942	4860	3006322	1997-10-05	1997-10-05 00:00:00	1997-10-05	5001	0	\N	0	0	\N	\N	0	323345	0	8331-1	3006322		
43848	1352	4133840	2008-05-11	2008-05-11 00:00:00	2008-05-11	5001	0	\N	0	0	\N	\N	0	89543	0	127783003	4133840		
3369	331	3006923	1997-04-18	1997-04-18 00:00:00	1997-04-18	5001	0	\N	0	0	\N	\N	0	21811	0	1742-6	3006923		
41141	3830	3006322	1987-03-01	1987-03-01 00:00:00	1987-03-01	5001	0	\N	0	0	\N	\N	0	254290	0	8331-1	3006322		
48733	4452	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	296214	0	6075-6	3005136		
50682	4623	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	307945	0	6833-8	3023430		
34231	3118	3011505	2005-12-25	2005-12-25 00:00:00	2005-12-25	5001	0	\N	0	0	\N	\N	0	207422	0	19926-5	3011505		
34293	3123	3005136	1978-02-19	1978-02-19 00:00:00	1978-02-19	5001	0	\N	0	0	\N	\N	0	207805	0	6075-6	3005136		
2864	273	3001247	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	18196	0	6085-5	3001247		
13428	1272	3006322	1990-12-16	1990-12-16 00:00:00	1990-12-16	5001	0	\N	0	0	\N	\N	0	83902	0	8331-1	3006322		
8967	859	3006451	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	56883	0	6273-7	3006451		
45592	4205	3001247	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	279249	0	6085-5	3001247		
38704	3580	3051031	1997-08-15	1997-08-15 00:00:00	1997-08-15	5001	0	\N	0	0	\N	\N	0	238002	0	46240-8	3051031		
11957	1138	3027231	1985-02-26	1985-02-26 00:00:00	1985-02-26	5001	0	\N	0	0	\N	\N	0	75060	0	6276-0	3027231		
38840	3589	3023430	1994-01-03	1994-01-03 00:00:00	1994-01-03	5001	0	\N	0	0	\N	\N	0	238450	0	6833-8	3023430		
5398	512	3051031	1960-04-18	1960-04-18 00:00:00	1960-04-18	5001	0	\N	0	0	\N	\N	0	34185	0	46240-8	3051031		
50469	4603	3049273	2004-09-07	2004-09-07 00:00:00	2004-09-07	5001	0	\N	0	0	\N	\N	0	306623	0	38265-5	3049273		
43509	4024	46235214	2013-04-19	2013-04-19 00:00:00	2013-04-19	5001	0	\N	0	0	\N	\N	0	267546	0	76690-7	46235214		
47969	4391	3051031	2008-03-22	2008-03-22 00:00:00	2008-03-22	5001	0	\N	0	0	\N	\N	0	292017	0	46240-8	3051031		
36834	3381	3006322	1982-01-25	1982-01-25 00:00:00	1982-01-25	5001	0	\N	0	0	\N	\N	0	224365	0	8331-1	3006322		
15627	1431	3020655	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	95274	0	6844-5	3020655		
8711	842	3011505	2010-09-25	2010-09-25 00:00:00	2010-09-25	5001	0	\N	0	0	\N	\N	0	55700	0	19926-5	3011505		
49254	4500	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	299610	0	6095-4	3036780		
49326	4504	3006322	1981-07-07	1981-07-07 00:00:00	1981-07-07	5001	0	\N	0	0	\N	\N	0	299904	0	8331-1	3006322		
31540	2891	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	192290	0	6248-9	3015076		
31622	2895	40769194	1985-12-27	1985-12-27 00:00:00	1985-12-27	5001	0	\N	0	0	\N	\N	0	192692	0	66534-9	40769194		
53094	4878	3014599	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	324403	0	6106-9	3014599		
43027	3976	40766240	1966-06-06	1966-06-06 00:00:00	1966-06-06	5001	0	\N	0	0	\N	\N	0	264384	0	63513-6	40766240		
44790	4137	3011505	2016-02-24	2016-02-24 00:00:00	2016-02-24	5001	0	\N	0	0	\N	\N	0	275034	0	19926-5	3011505		
16535	1508	40758406	1951-03-25	1951-03-25 00:00:00	1951-03-25	5001	0	\N	0	0	\N	\N	0	100640	0	55277-8	40758406		
51182	4680	3006322	1991-11-19	1991-11-19 00:00:00	1991-11-19	5001	0	\N	0	0	\N	\N	0	311891	0	8331-1	3006322		
40409	3754	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	249504	0	6082-2	3000876		
116267	3582	4052083	2017-02-14	2017-02-14 00:00:00	2017-02-14	5001	0	\N	0	0	\N	\N	0	238109	0	23426006	4052083		
53328	4898	3006322	1954-02-12	1954-02-12 00:00:00	1954-02-12	5001	0	\N	0	0	\N	\N	0	325693	0	8331-1	3006322		
40467	3759	3001247	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	249857	0	6085-5	3001247		
12145	1155	3006322	2015-11-22	2015-11-22 00:00:00	2015-11-22	5001	0	\N	0	0	\N	\N	0	76391	0	8331-1	3006322		
7195	227	4052083	2005-10-20	2005-10-20 00:00:00	2005-10-20	5001	0	\N	0	0	\N	\N	0	15349	0	23426006	4052083		
65578	2012	4052083	1968-03-10	1968-03-10 00:00:00	1968-03-10	5001	0	\N	0	0	\N	\N	0	133844	0	23426006	4052083		
9324	884	3036780	1994-03-15	1994-03-15 00:00:00	1994-03-15	5001	0	\N	0	0	\N	\N	0	58863	0	6095-4	3036780		
47032	4330	3049273	2006-02-18	2006-02-18 00:00:00	2006-02-18	5001	0	\N	0	0	\N	\N	0	287247	0	38265-5	3049273		
111001	3430	4133840	2018-05-19	2018-05-19 00:00:00	2018-05-19	5001	0	\N	0	0	\N	\N	0	227330	0	127783003	4133840		
20774	1911	3051031	1947-06-24	1947-06-24 00:00:00	1947-06-24	5001	0	\N	0	0	\N	\N	0	127140	0	46240-8	3051031		
20853	1923	3049273	1993-02-12	1993-02-12 00:00:00	1993-02-12	5001	0	\N	0	0	\N	\N	0	127980	0	38265-5	3049273		
32278	2936	3006322	1967-03-09	1967-03-09 00:00:00	1967-03-09	5001	0	\N	0	0	\N	\N	0	195764	0	8331-1	3006322		
138205	4260	4024958	1940-05-02	1940-05-02 00:00:00	1940-05-02	5001	0	\N	0	0	\N	\N	0	282808	0	117015009	4024958		
128942	3968	4024958	1954-03-29	1954-03-29 00:00:00	1954-03-29	5001	0	\N	0	0	\N	\N	0	263851	0	117015009	4024958		
10141	967	3006322	1937-10-31	1937-10-31 00:00:00	1937-10-31	5001	0	\N	0	0	\N	\N	0	64333	0	8331-1	3006322		
6602	621	40766240	1973-06-02	1973-06-02 00:00:00	1973-06-02	5001	0	\N	0	0	\N	\N	0	41457	0	63513-6	40766240		
17933	1627	3006322	1995-11-15	1995-11-15 00:00:00	1995-11-15	5001	0	\N	0	0	\N	\N	0	109341	0	8331-1	3006322		
23053	2119	3020655	1983-06-29	1983-06-29 00:00:00	1983-06-29	5001	0	\N	0	0	\N	\N	0	141050	0	6844-5	3020655		
34463	3147	3011505	1980-01-07	1980-01-07 00:00:00	1980-01-07	5001	0	\N	0	0	\N	\N	0	209383	0	19926-5	3011505		
33079	2986	3011505	1992-11-03	1992-11-03 00:00:00	1992-11-03	5001	0	\N	0	0	\N	\N	0	199363	0	19926-5	3011505		
6335	601	3001488	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	39740	0	7258-7	3001488		
7099	680	3001247	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	45008	0	6085-5	3001247		
23531	738	4024958	2007-02-28	2007-02-28 00:00:00	2007-02-28	5001	0	\N	0	0	\N	\N	0	48903	0	117015009	4024958		
36103	3320	3006322	2012-10-01	2012-10-01 00:00:00	2012-10-01	5001	0	\N	0	0	\N	\N	0	220446	0	8331-1	3006322		
6681	207	4024958	1940-12-20	1940-12-20 00:00:00	1940-12-20	5001	0	\N	0	0	\N	\N	0	14115	0	117015009	4024958		
120851	3730	4024958	1958-11-23	1958-11-23 00:00:00	1958-11-23	5001	0	\N	0	0	\N	\N	0	247843	0	117015009	4024958		
47577	4372	3027231	1996-11-14	1996-11-14 00:00:00	1996-11-14	5001	0	\N	0	0	\N	\N	0	290277	0	6276-0	3027231		
37004	3399	3006322	1990-10-23	1990-10-23 00:00:00	1990-10-23	5001	0	\N	0	0	\N	\N	0	225488	0	8331-1	3006322		
130358	4017	4052083	1984-03-04	1984-03-04 00:00:00	1984-03-04	5001	0	\N	0	0	\N	\N	0	266946	0	23426006	4052083		
16329	1486	3014599	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	99099	0	6106-9	3014599		
52943	4861	3006322	1995-12-03	1995-12-03 00:00:00	1995-12-03	5001	0	\N	0	0	\N	\N	0	323418	0	8331-1	3006322		
43850	1352	4133840	2016-01-17	2016-01-17 00:00:00	2016-01-17	5001	0	\N	0	0	\N	\N	0	89574	0	127783003	4133840		
3370	331	3004501	1997-04-18	1997-04-18 00:00:00	1997-04-18	5001	0	\N	0	0	\N	\N	0	21811	0	2345-7	3004501		
41142	3830	3006322	2012-04-01	2012-04-01 00:00:00	2012-04-01	5001	0	\N	0	0	\N	\N	0	254301	0	8331-1	3006322		
48734	4452	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	296214	0	6246-3	3021226		
50683	4623	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	307945	0	6189-5	3006734		
34232	3118	3011505	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	207454	0	19926-5	3011505		
34294	3123	3027231	1978-02-19	1978-02-19 00:00:00	1978-02-19	5001	0	\N	0	0	\N	\N	0	207805	0	6276-0	3027231		
14142	1322	3006322	1942-07-30	1942-07-30 00:00:00	1942-07-30	5001	0	\N	0	0	\N	\N	0	87786	0	8331-1	3006322		
13429	1272	3006322	2018-12-14	2018-12-14 00:00:00	2018-12-14	5001	0	\N	0	0	\N	\N	0	83970	0	8331-1	3006322		
8968	859	3020655	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	56883	0	6844-5	3020655		
45593	4205	3000876	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	279249	0	6082-2	3000876		
38705	3580	40758406	1997-08-15	1997-08-15 00:00:00	1997-08-15	5001	0	\N	0	0	\N	\N	0	238002	0	55277-8	40758406		
11958	1138	3015076	1985-02-26	1985-02-26 00:00:00	1985-02-26	5001	0	\N	0	0	\N	\N	0	75060	0	6248-9	3015076		
38841	3589	3021226	1994-01-03	1994-01-03 00:00:00	1994-01-03	5001	0	\N	0	0	\N	\N	0	238450	0	6246-3	3021226		
5399	512	40758406	1960-04-18	1960-04-18 00:00:00	1960-04-18	5001	0	\N	0	0	\N	\N	0	34185	0	55277-8	40758406		
50470	4603	3006322	1939-12-13	1939-12-13 00:00:00	1939-12-13	5001	0	\N	0	0	\N	\N	0	306592	0	8331-1	3006322		
43510	4024	3051031	2013-04-19	2013-04-19 00:00:00	2013-04-19	5001	0	\N	0	0	\N	\N	0	267546	0	46240-8	3051031		
47970	4391	40758406	2008-03-22	2008-03-22 00:00:00	2008-03-22	5001	0	\N	0	0	\N	\N	0	292017	0	55277-8	40758406		
36835	3381	3006322	2005-04-21	2005-04-21 00:00:00	2005-04-21	5001	0	\N	0	0	\N	\N	0	224384	0	8331-1	3006322		
15628	1431	3001488	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	95274	0	7258-7	3001488		
8712	842	3011505	1985-04-06	1985-04-06 00:00:00	1985-04-06	5001	0	\N	0	0	\N	\N	0	55667	0	19926-5	3011505		
49255	4500	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	299610	0	6833-8	3023430		
49327	4504	3006322	2017-12-05	2017-12-05 00:00:00	2017-12-05	5001	0	\N	0	0	\N	\N	0	299942	0	8331-1	3006322		
31541	2891	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	192290	0	6082-2	3000876		
31623	2895	40769189	1985-12-27	1985-12-27 00:00:00	1985-12-27	5001	0	\N	0	0	\N	\N	0	192692	0	66529-9	40769189		
53095	4878	3027231	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	324403	0	6276-0	3027231		
43029	3976	3006322	2018-10-13	2018-10-13 00:00:00	2018-10-13	5001	0	\N	0	0	\N	\N	0	264360	0	8331-1	3006322		
44792	4139	3006322	2016-04-10	2016-04-10 00:00:00	2016-04-10	5001	0	\N	0	0	\N	\N	0	275136	0	8331-1	3006322		
16536	1508	3051031	1951-03-25	1951-03-25 00:00:00	1951-03-25	5001	0	\N	0	0	\N	\N	0	100640	0	46240-8	3051031		
51183	4680	3049273	1979-10-24	1979-10-24 00:00:00	1979-10-24	5001	0	\N	0	0	\N	\N	0	311948	0	38265-5	3049273		
40410	3754	3006322	2000-09-20	2000-09-20 00:00:00	2000-09-20	5001	0	\N	0	0	\N	\N	0	249464	0	8331-1	3006322		
34599	3167	3006322	1978-09-14	1978-09-14 00:00:00	1978-09-14	5001	0	\N	0	0	\N	\N	0	210531	0	8331-1	3006322		
53329	4898	3006322	1954-07-21	1954-07-21 00:00:00	1954-07-21	5001	0	\N	0	0	\N	\N	0	325689	0	8331-1	3006322		
40468	3759	3019406	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	249857	0	6158-0	3019406		
12146	1155	3006322	1975-12-03	1975-12-03 00:00:00	1975-12-03	5001	0	\N	0	0	\N	\N	0	76326	0	8331-1	3006322		
17273	1571	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	105461	0	7258-7	3001488		
65579	2012	4052083	2009-11-21	2009-11-21 00:00:00	2009-11-21	5001	0	\N	0	0	\N	\N	0	133845	0	23426006	4052083		
9325	884	3006734	1994-03-15	1994-03-15 00:00:00	1994-03-15	5001	0	\N	0	0	\N	\N	0	58863	0	6189-5	3006734		
47033	4330	3006322	2007-05-24	2007-05-24 00:00:00	2007-05-24	5001	0	\N	0	0	\N	\N	0	287240	0	8331-1	3006322		
134200	4130	4052083	2019-05-17	2019-05-17 00:00:00	2019-05-17	5001	0	\N	0	0	\N	\N	0	274647	0	23426006	4052083		
20775	1911	46235214	1947-06-24	1947-06-24 00:00:00	1947-06-24	5001	0	\N	0	0	\N	\N	0	127140	0	76690-7	46235214		
20855	1923	3006322	1973-03-21	1973-03-21 00:00:00	1973-03-21	5001	0	\N	0	0	\N	\N	0	128004	0	8331-1	3006322		
32279	2936	3006322	2019-06-17	2019-06-17 00:00:00	2019-06-17	5001	0	\N	0	0	\N	\N	0	195784	0	8331-1	3006322		
138216	4260	4052083	1976-12-15	1976-12-15 00:00:00	1976-12-15	5001	0	\N	0	0	\N	\N	0	282785	0	23426006	4052083		
128948	3968	4052083	2019-01-27	2019-01-27 00:00:00	2019-01-27	5001	0	\N	0	0	\N	\N	0	263857	0	23426006	4052083		
10142	967	3009201	1993-09-30	1993-09-30 00:00:00	1993-09-30	5001	0	\N	0	0	\N	\N	0	64356	0	3016-3	3009201		
6603	621	3051031	1973-07-02	1973-07-02 00:00:00	1973-07-02	5001	0	\N	0	0	\N	\N	0	41361	0	46240-8	3051031		
17934	1627	3006322	1971-02-09	1971-02-09 00:00:00	1971-02-09	5001	0	\N	0	0	\N	\N	0	109364	0	8331-1	3006322		
23054	2119	3023430	1983-06-29	1983-06-29 00:00:00	1983-06-29	5001	0	\N	0	0	\N	\N	0	141050	0	6833-8	3023430		
34464	3147	3011505	1986-01-13	1986-01-13 00:00:00	1986-01-13	5001	0	\N	0	0	\N	\N	0	209362	0	19926-5	3011505		
33080	2986	3011505	2019-06-18	2019-06-18 00:00:00	2019-06-18	5001	0	\N	0	0	\N	\N	0	199345	0	19926-5	3011505		
6336	601	3006734	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	39740	0	6189-5	3006734		
7100	680	3000876	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	45008	0	6082-2	3000876		
23540	738	4052083	2000-08-29	2000-08-29 00:00:00	2000-08-29	5001	0	\N	0	0	\N	\N	0	48892	0	23426006	4052083		
36104	3320	3006322	1977-04-23	1977-04-23 00:00:00	1977-04-23	5001	0	\N	0	0	\N	\N	0	220485	0	8331-1	3006322		
41223	1276	4024958	1963-10-17	1963-10-17 00:00:00	1963-10-17	5001	0	\N	0	0	\N	\N	0	84141	0	117015009	4024958		
120853	3730	4024958	1983-01-26	1983-01-26 00:00:00	1983-01-26	5001	0	\N	0	0	\N	\N	0	247845	0	117015009	4024958		
47578	4372	3015076	1996-11-14	1996-11-14 00:00:00	1996-11-14	5001	0	\N	0	0	\N	\N	0	290277	0	6248-9	3015076		
37005	3399	3006322	1983-05-12	1983-05-12 00:00:00	1983-05-12	5001	0	\N	0	0	\N	\N	0	225503	0	8331-1	3006322		
14409	1348	3006322	1972-06-01	1972-06-01 00:00:00	1972-06-01	5001	0	\N	0	0	\N	\N	0	89294	0	8331-1	3006322		
16330	1486	3001247	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	99099	0	6085-5	3001247		
52944	4861	3049273	2007-05-22	2007-05-22 00:00:00	2007-05-22	5001	0	\N	0	0	\N	\N	0	323399	0	38265-5	3049273		
43853	1352	4133840	2000-03-26	2000-03-26 00:00:00	2000-03-26	5001	0	\N	0	0	\N	\N	0	89576	0	127783003	4133840		
3371	331	3026361	1997-04-18	1997-04-18 00:00:00	1997-04-18	5001	0	\N	0	0	\N	\N	0	21811	0	26453-1	3026361		
41143	3831	3006322	1955-09-24	1955-09-24 00:00:00	1955-09-24	5001	0	\N	0	0	\N	\N	0	254371	0	8331-1	3006322		
48735	4452	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	296214	0	6158-0	3019406		
50684	4623	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	307945	0	6844-5	3020655		
34233	3118	3006322	1950-03-03	1950-03-03 00:00:00	1950-03-03	5001	0	\N	0	0	\N	\N	0	207465	0	8331-1	3006322		
34295	3123	3006451	1978-02-19	1978-02-19 00:00:00	1978-02-19	5001	0	\N	0	0	\N	\N	0	207805	0	6273-7	3006451		
14143	1322	3006322	2014-07-30	2014-07-30 00:00:00	2014-07-30	5001	0	\N	0	0	\N	\N	0	87775	0	8331-1	3006322		
13430	1272	3000876	1996-03-22	1996-03-22 00:00:00	1996-03-22	5001	0	\N	0	0	\N	\N	0	83928	0	6082-2	3000876		
8969	859	3027231	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	56883	0	6276-0	3027231		
45594	4205	3019406	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	279249	0	6158-0	3019406		
38706	3580	3006322	2015-10-17	2015-10-17 00:00:00	2015-10-17	5001	0	\N	0	0	\N	\N	0	238008	0	8331-1	3006322		
11959	1138	3005136	1985-02-26	1985-02-26 00:00:00	1985-02-26	5001	0	\N	0	0	\N	\N	0	75060	0	6075-6	3005136		
38842	3589	3005136	1994-01-03	1994-01-03 00:00:00	1994-01-03	5001	0	\N	0	0	\N	\N	0	238450	0	6075-6	3005136		
5402	512	3006322	1960-05-03	1960-05-03 00:00:00	1960-05-03	5001	0	\N	0	0	\N	\N	0	34198	0	8331-1	3006322		
50471	4603	3006322	1931-05-18	1931-05-18 00:00:00	1931-05-18	5001	0	\N	0	0	\N	\N	0	306627	0	8331-1	3006322		
43512	4024	40766240	2013-04-19	2013-04-19 00:00:00	2013-04-19	5001	0	\N	0	0	\N	\N	0	267546	0	63513-6	40766240		
129886	4005	4024958	1978-12-04	1978-12-04 00:00:00	1978-12-04	5001	0	\N	0	0	\N	\N	0	266117	0	117015009	4024958		
16997	1550	3011505	2018-01-06	2018-01-06 00:00:00	2018-01-06	5001	0	\N	0	0	\N	\N	0	103782	0	19926-5	3011505		
15629	1431	3005136	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	95274	0	6075-6	3005136		
8713	842	3006322	1980-02-21	1980-02-21 00:00:00	1980-02-21	5001	0	\N	0	0	\N	\N	0	55639	0	8331-1	3006322		
49256	4500	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	299610	0	6189-5	3006734		
49328	4505	3006322	1951-11-04	1951-11-04 00:00:00	1951-11-04	5001	0	\N	0	0	\N	\N	0	299964	0	8331-1	3006322		
31542	2891	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	192290	0	6085-5	3001247		
31624	2895	40769179	1985-12-27	1985-12-27 00:00:00	1985-12-27	5001	0	\N	0	0	\N	\N	0	192692	0	66519-0	40769179		
53096	4878	3006451	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	324403	0	6273-7	3006451		
43031	3976	3051031	1966-03-08	1966-03-08 00:00:00	1966-03-08	5001	0	\N	0	0	\N	\N	0	264383	0	46240-8	3051031		
44793	4139	3006322	1989-01-18	1989-01-18 00:00:00	1989-01-18	5001	0	\N	0	0	\N	\N	0	275134	0	8331-1	3006322		
16538	1508	3006322	1933-09-11	1933-09-11 00:00:00	1933-09-11	5001	0	\N	0	0	\N	\N	0	100580	0	8331-1	3006322		
51184	4680	3006322	1975-11-02	1975-11-02 00:00:00	1975-11-02	5001	0	\N	0	0	\N	\N	0	311933	0	8331-1	3006322		
40411	3754	3006322	1966-06-28	1966-06-28 00:00:00	1966-06-28	5001	0	\N	0	0	\N	\N	0	249421	0	8331-1	3006322		
34600	3167	3006322	2011-09-29	2011-09-29 00:00:00	2011-09-29	5001	0	\N	0	0	\N	\N	0	210589	0	8331-1	3006322		
53330	4899	3006322	1994-07-22	1994-07-22 00:00:00	1994-07-22	5001	0	\N	0	0	\N	\N	0	325778	0	8331-1	3006322		
40469	3759	3000876	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	249857	0	6082-2	3000876		
12147	1155	3006322	1976-08-14	1976-08-14 00:00:00	1976-08-14	5001	0	\N	0	0	\N	\N	0	76302	0	8331-1	3006322		
17274	1571	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	105461	0	6189-5	3006734		
27807	866	4024958	1966-05-08	1966-05-08 00:00:00	1966-05-08	5001	0	\N	0	0	\N	\N	0	57464	0	117015009	4024958		
9326	884	3001247	1994-03-15	1994-03-15 00:00:00	1994-03-15	5001	0	\N	0	0	\N	\N	0	58863	0	6085-5	3001247		
47034	4330	3006322	1951-07-27	1951-07-27 00:00:00	1951-07-27	5001	0	\N	0	0	\N	\N	0	287181	0	8331-1	3006322		
134201	4130	4052083	1997-03-02	1997-03-02 00:00:00	1997-03-02	5001	0	\N	0	0	\N	\N	0	274535	0	23426006	4052083		
20778	1911	40766240	1960-09-18	1960-09-18 00:00:00	1960-09-18	5001	0	\N	0	0	\N	\N	0	127125	0	63513-6	40766240		
20856	1923	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	127936	0	6082-2	3000876		
32280	2936	3006322	2000-12-19	2000-12-19 00:00:00	2000-12-19	5001	0	\N	0	0	\N	\N	0	195782	0	8331-1	3006322		
138219	4261	4024958	1932-10-28	1932-10-28 00:00:00	1932-10-28	5001	0	\N	0	0	\N	\N	0	282856	0	117015009	4024958		
128955	3968	4052083	1965-02-19	1965-02-19 00:00:00	1965-02-19	5001	0	\N	0	0	\N	\N	0	263899	0	23426006	4052083		
10143	967	3008598	1993-09-30	1993-09-30 00:00:00	1993-09-30	5001	0	\N	0	0	\N	\N	0	64356	0	3024-7	3008598		
6604	621	40758406	1973-07-02	1973-07-02 00:00:00	1973-07-02	5001	0	\N	0	0	\N	\N	0	41361	0	55277-8	40758406		
17955	1632	3006322	1966-02-18	1966-02-18 00:00:00	1966-02-18	5001	0	\N	0	0	\N	\N	0	109588	0	8331-1	3006322		
23055	2119	3001247	1983-06-29	1983-06-29 00:00:00	1983-06-29	5001	0	\N	0	0	\N	\N	0	141050	0	6085-5	3001247		
34465	3147	3011505	2016-05-30	2016-05-30 00:00:00	2016-05-30	5001	0	\N	0	0	\N	\N	0	209369	0	19926-5	3011505		
33081	2986	3011505	2014-04-08	2014-04-08 00:00:00	2014-04-08	5001	0	\N	0	0	\N	\N	0	199318	0	19926-5	3011505		
6337	601	3020655	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	39740	0	6844-5	3020655		
7101	680	3006451	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	45008	0	6273-7	3006451		
23560	739	4024958	1949-10-08	1949-10-08 00:00:00	1949-10-08	5001	0	\N	0	0	\N	\N	0	48973	0	117015009	4024958		
36105	3320	3006322	1974-10-28	1974-10-28 00:00:00	1974-10-28	5001	0	\N	0	0	\N	\N	0	220458	0	8331-1	3006322		
41243	1276	4024958	1962-03-15	1962-03-15 00:00:00	1962-03-15	5001	0	\N	0	0	\N	\N	0	84138	0	117015009	4024958		
120863	3731	4024958	1985-07-09	1985-07-09 00:00:00	1985-07-09	5001	0	\N	0	0	\N	\N	0	247915	0	117015009	4024958		
47579	4372	3005136	1996-11-14	1996-11-14 00:00:00	1996-11-14	5001	0	\N	0	0	\N	\N	0	290277	0	6075-6	3005136		
37006	3399	3006322	2018-10-03	2018-10-03 00:00:00	2018-10-03	5001	0	\N	0	0	\N	\N	0	225493	0	8331-1	3006322		
14410	1348	3006322	1985-11-29	1985-11-29 00:00:00	1985-11-29	5001	0	\N	0	0	\N	\N	0	89295	0	8331-1	3006322		
16331	1486	3036780	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	99099	0	6095-4	3036780		
52945	4861	3006322	2017-11-30	2017-11-30 00:00:00	2017-11-30	5001	0	\N	0	0	\N	\N	0	323410	0	8331-1	3006322		
43855	1352	4024958	2016-03-26	2016-03-26 00:00:00	2016-03-26	5001	0	\N	0	0	\N	\N	0	89609	0	117015009	4024958		
3372	331	3016723	1997-04-18	1997-04-18 00:00:00	1997-04-18	5001	0	\N	0	0	\N	\N	0	21811	0	2160-0	3016723		
41144	3832	3036780	1984-11-17	1984-11-17 00:00:00	1984-11-17	5001	0	\N	0	0	\N	\N	0	254407	0	6095-4	3036780		
48736	4452	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	296214	0	6248-9	3015076		
50685	4623	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	307945	0	6246-3	3021226		
34234	3118	3011505	1994-12-25	1994-12-25 00:00:00	1994-12-25	5001	0	\N	0	0	\N	\N	0	207424	0	19926-5	3011505		
34296	3123	3006322	2015-01-03	2015-01-03 00:00:00	2015-01-03	5001	0	\N	0	0	\N	\N	0	207799	0	8331-1	3006322		
14144	1322	3006322	1945-05-02	1945-05-02 00:00:00	1945-05-02	5001	0	\N	0	0	\N	\N	0	87792	0	8331-1	3006322		
13431	1272	3001488	1996-03-22	1996-03-22 00:00:00	1996-03-22	5001	0	\N	0	0	\N	\N	0	83928	0	7258-7	3001488		
8970	859	3014599	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	56883	0	6106-9	3014599		
45595	4205	3015076	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	279249	0	6248-9	3015076		
38707	3580	3006322	1975-10-07	1975-10-07 00:00:00	1975-10-07	5001	0	\N	0	0	\N	\N	0	237994	0	8331-1	3006322		
11960	1138	3014599	1985-02-26	1985-02-26 00:00:00	1985-02-26	5001	0	\N	0	0	\N	\N	0	75060	0	6106-9	3014599		
38843	3589	3000876	1994-01-03	1994-01-03 00:00:00	1994-01-03	5001	0	\N	0	0	\N	\N	0	238450	0	6082-2	3000876		
5406	515	3049273	2012-08-02	2012-08-02 00:00:00	2012-08-02	5001	0	\N	0	0	\N	\N	0	34392	0	38265-5	3049273		
50472	4603	3006322	1996-09-24	1996-09-24 00:00:00	1996-09-24	5001	0	\N	0	0	\N	\N	0	306658	0	8331-1	3006322		
43513	4024	3011505	2006-05-07	2006-05-07 00:00:00	2006-05-07	5001	0	\N	0	0	\N	\N	0	267565	0	19926-5	3011505		
129888	4005	4024958	1979-05-15	1979-05-15 00:00:00	1979-05-15	5001	0	\N	0	0	\N	\N	0	266110	0	117015009	4024958		
16998	1550	3011505	2013-12-28	2013-12-28 00:00:00	2013-12-28	5001	0	\N	0	0	\N	\N	0	103800	0	19926-5	3011505		
15630	1431	3019406	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	95274	0	6158-0	3019406		
8714	842	3006322	1933-01-22	1933-01-22 00:00:00	1933-01-22	5001	0	\N	0	0	\N	\N	0	55636	0	8331-1	3006322		
49257	4500	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	299610	0	6844-5	3020655		
49329	4505	3006322	2009-10-22	2009-10-22 00:00:00	2009-10-22	5001	0	\N	0	0	\N	\N	0	299999	0	8331-1	3006322		
31543	2891	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	192290	0	6844-5	3020655		
31625	2895	40769184	1985-12-27	1985-12-27 00:00:00	1985-12-27	5001	0	\N	0	0	\N	\N	0	192692	0	66524-0	40769184		
53097	4878	3005136	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	324403	0	6075-6	3005136		
43032	3976	40758406	1966-03-08	1966-03-08 00:00:00	1966-03-08	5001	0	\N	0	0	\N	\N	0	264383	0	55277-8	40758406		
6108	571	3006322	1958-04-14	1958-04-14 00:00:00	1958-04-14	5001	0	\N	0	0	\N	\N	0	37825	0	8331-1	3006322		
51059	4657	3006322	1972-05-27	1972-05-27 00:00:00	1972-05-27	5001	0	\N	0	0	\N	\N	0	310503	0	8331-1	3006322		
51185	4680	3006322	1963-09-27	1963-09-27 00:00:00	1963-09-27	5001	0	\N	0	0	\N	\N	0	311880	0	8331-1	3006322		
40412	3754	3006322	1990-03-03	1990-03-03 00:00:00	1990-03-03	5001	0	\N	0	0	\N	\N	0	249446	0	8331-1	3006322		
34601	3167	3006322	2016-12-16	2016-12-16 00:00:00	2016-12-16	5001	0	\N	0	0	\N	\N	0	210591	0	8331-1	3006322		
53331	4899	3011505	1990-09-25	1990-09-25 00:00:00	1990-09-25	5001	0	\N	0	0	\N	\N	0	325850	0	19926-5	3011505		
40470	3759	3014599	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	249857	0	6106-9	3014599		
12148	1155	3049273	1981-03-04	1981-03-04 00:00:00	1981-03-04	5001	0	\N	0	0	\N	\N	0	76312	0	38265-5	3049273		
17275	1571	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	105461	0	6844-5	3020655		
27809	866	4024958	2015-12-16	2015-12-16 00:00:00	2015-12-16	5001	0	\N	0	0	\N	\N	0	57492	0	117015009	4024958		
9327	884	3001488	1994-03-15	1994-03-15 00:00:00	1994-03-15	5001	0	\N	0	0	\N	\N	0	58863	0	7258-7	3001488		
47035	4331	3006322	2005-01-09	2005-01-09 00:00:00	2005-01-09	5001	0	\N	0	0	\N	\N	0	287329	0	8331-1	3006322		
134210	4130	4052083	1986-07-28	1986-07-28 00:00:00	1986-07-28	5001	0	\N	0	0	\N	\N	0	274527	0	23426006	4052083		
20779	1911	46235214	1960-09-18	1960-09-18 00:00:00	1960-09-18	5001	0	\N	0	0	\N	\N	0	127125	0	76690-7	46235214		
20857	1923	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	127936	0	6106-9	3014599		
4042	404	3001488	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	26607	0	7258-7	3001488		
138233	4261	4024958	1995-11-03	1995-11-03 00:00:00	1995-11-03	5001	0	\N	0	0	\N	\N	0	282941	0	117015009	4024958		
9770	917	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	61073	0	6158-0	3019406		
10144	967	3049273	2003-03-12	2003-03-12 00:00:00	2003-03-12	5001	0	\N	0	0	\N	\N	0	64318	0	38265-5	3049273		
6606	621	46235214	1973-07-02	1973-07-02 00:00:00	1973-07-02	5001	0	\N	0	0	\N	\N	0	41361	0	76690-7	46235214		
17956	1632	3006322	1989-09-10	1989-09-10 00:00:00	1989-09-10	5001	0	\N	0	0	\N	\N	0	109570	0	8331-1	3006322		
23056	2119	3015076	1983-06-29	1983-06-29 00:00:00	1983-06-29	5001	0	\N	0	0	\N	\N	0	141050	0	6248-9	3015076		
34466	3147	3011505	2000-02-28	2000-02-28 00:00:00	2000-02-28	5001	0	\N	0	0	\N	\N	0	209425	0	19926-5	3011505		
33082	2986	3011505	2009-03-10	2009-03-10 00:00:00	2009-03-10	5001	0	\N	0	0	\N	\N	0	199305	0	19926-5	3011505		
6338	601	3021226	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	39740	0	6246-3	3021226		
7102	680	3001488	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	45008	0	7258-7	3001488		
23562	739	4052083	1927-10-11	1927-10-11 00:00:00	1927-10-11	5001	0	\N	0	0	\N	\N	0	48972	0	23426006	4052083		
36106	3321	3006322	2005-10-08	2005-10-08 00:00:00	2005-10-08	5001	0	\N	0	0	\N	\N	0	220512	0	8331-1	3006322		
18608	1709	3006322	1978-03-19	1978-03-19 00:00:00	1978-03-19	5001	0	\N	0	0	\N	\N	0	114301	0	8331-1	3006322		
120864	3731	4052083	2016-09-15	2016-09-15 00:00:00	2016-09-15	5001	0	\N	0	0	\N	\N	0	247919	0	23426006	4052083		
47580	4372	3021226	1996-11-14	1996-11-14 00:00:00	1996-11-14	5001	0	\N	0	0	\N	\N	0	290277	0	6246-3	3021226		
37007	3399	3006322	1996-11-02	1996-11-02 00:00:00	1996-11-02	5001	0	\N	0	0	\N	\N	0	225492	0	8331-1	3006322		
14411	1348	3006322	1948-06-25	1948-06-25 00:00:00	1948-06-25	5001	0	\N	0	0	\N	\N	0	89335	0	8331-1	3006322		
16332	1486	3000876	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	99099	0	6082-2	3000876		
52946	4861	3006322	1985-04-21	1985-04-21 00:00:00	1985-04-21	5001	0	\N	0	0	\N	\N	0	323423	0	8331-1	3006322		
55135	1670	4052083	2002-12-24	2002-12-24 00:00:00	2002-12-24	5001	0	\N	0	0	\N	\N	0	112138	0	23426006	4052083		
3373	331	3009542	1997-04-18	1997-04-18 00:00:00	1997-04-18	5001	0	\N	0	0	\N	\N	0	21811	0	20570-8	3009542		
41145	3832	3021226	1984-11-17	1984-11-17 00:00:00	1984-11-17	5001	0	\N	0	0	\N	\N	0	254407	0	6246-3	3021226		
48737	4452	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	296214	0	6085-5	3001247		
50686	4623	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	307945	0	6075-6	3005136		
34235	3118	3011505	1998-12-06	1998-12-06 00:00:00	1998-12-06	5001	0	\N	0	0	\N	\N	0	207408	0	19926-5	3011505		
34299	3125	3006322	1966-07-02	1966-07-02 00:00:00	1966-07-02	5001	0	\N	0	0	\N	\N	0	207924	0	8331-1	3006322		
14145	1322	3006322	1937-06-18	1937-06-18 00:00:00	1937-06-18	5001	0	\N	0	0	\N	\N	0	87791	0	8331-1	3006322		
84013	2597	4024958	2012-02-12	2012-02-12 00:00:00	2012-02-12	5001	0	\N	0	0	\N	\N	0	171840	0	117015009	4024958		
8971	859	3036780	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	56883	0	6095-4	3036780		
45596	4205	3005136	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	279249	0	6075-6	3005136		
38708	3580	40758406	1997-06-16	1997-06-16 00:00:00	1997-06-16	5001	0	\N	0	0	\N	\N	0	237971	0	55277-8	40758406		
11961	1138	3000876	1985-02-26	1985-02-26 00:00:00	1985-02-26	5001	0	\N	0	0	\N	\N	0	75060	0	6082-2	3000876		
50122	4569	3006322	1996-07-07	1996-07-07 00:00:00	1996-07-07	5001	0	\N	0	0	\N	\N	0	304375	0	8331-1	3006322		
5407	515	3006322	2005-06-12	2005-06-12 00:00:00	2005-06-12	5001	0	\N	0	0	\N	\N	0	34415	0	8331-1	3006322		
50473	4603	3006322	2007-05-12	2007-05-12 00:00:00	2007-05-12	5001	0	\N	0	0	\N	\N	0	306666	0	8331-1	3006322		
43515	4026	3011505	2019-06-09	2019-06-09 00:00:00	2019-06-09	5001	0	\N	0	0	\N	\N	0	267679	0	19926-5	3011505		
129903	4005	4052083	1971-02-12	1971-02-12 00:00:00	1971-02-12	5001	0	\N	0	0	\N	\N	0	266124	0	23426006	4052083		
16999	1550	3006322	1981-12-18	1981-12-18 00:00:00	1981-12-18	5001	0	\N	0	0	\N	\N	0	103756	0	8331-1	3006322		
15631	1431	3015076	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	95274	0	6248-9	3015076		
8715	842	3011505	2003-08-16	2003-08-16 00:00:00	2003-08-16	5001	0	\N	0	0	\N	\N	0	55672	0	19926-5	3011505		
49258	4500	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	299610	0	6206-7	3012494		
49330	4505	3006322	1958-08-11	1958-08-11 00:00:00	1958-08-11	5001	0	\N	0	0	\N	\N	0	300041	0	8331-1	3006322		
31544	2891	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	192290	0	6246-3	3021226		
31626	2895	3000876	1986-01-09	1986-01-09 00:00:00	1986-01-09	5001	0	\N	0	0	\N	\N	0	192693	0	6082-2	3000876		
53098	4878	3019406	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	324403	0	6158-0	3019406		
43033	3976	46235214	1966-03-08	1966-03-08 00:00:00	1966-03-08	5001	0	\N	0	0	\N	\N	0	264383	0	76690-7	46235214		
6109	571	3006322	2004-01-24	2004-01-24 00:00:00	2004-01-24	5001	0	\N	0	0	\N	\N	0	37774	0	8331-1	3006322		
51060	4657	3006322	1982-05-25	1982-05-25 00:00:00	1982-05-25	5001	0	\N	0	0	\N	\N	0	310561	0	8331-1	3006322		
51186	4680	3006322	1924-01-01	1924-01-01 00:00:00	1924-01-01	5001	0	\N	0	0	\N	\N	0	311954	0	8331-1	3006322		
40413	3754	3006322	1965-05-25	1965-05-25 00:00:00	1965-05-25	5001	0	\N	0	0	\N	\N	0	249441	0	8331-1	3006322		
34602	3167	3006322	1973-08-30	1973-08-30 00:00:00	1973-08-30	5001	0	\N	0	0	\N	\N	0	210530	0	8331-1	3006322		
53332	4899	3006322	1984-12-19	1984-12-19 00:00:00	1984-12-19	5001	0	\N	0	0	\N	\N	0	325776	0	8331-1	3006322		
40471	3759	3015076	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	249857	0	6248-9	3015076		
16370	510	4052083	2006-08-03	2006-08-03 00:00:00	2006-08-03	5001	0	\N	0	0	\N	\N	0	34077	0	23426006	4052083		
17276	1571	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	105461	0	6248-9	3015076		
27814	866	4052083	1972-10-31	1972-10-31 00:00:00	1972-10-31	5001	0	\N	0	0	\N	\N	0	57489	0	23426006	4052083		
9328	884	3020655	1994-03-15	1994-03-15 00:00:00	1994-03-15	5001	0	\N	0	0	\N	\N	0	58863	0	6844-5	3020655		
47037	4333	3006322	1996-11-10	1996-11-10 00:00:00	1996-11-10	5001	0	\N	0	0	\N	\N	0	287418	0	8331-1	3006322		
134212	4131	4052083	1988-06-09	1988-06-09 00:00:00	1988-06-09	5001	0	\N	0	0	\N	\N	0	274683	0	23426006	4052083		
20780	1911	40758406	1960-09-18	1960-09-18 00:00:00	1960-09-18	5001	0	\N	0	0	\N	\N	0	127125	0	55277-8	40758406		
20858	1923	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	127936	0	6158-0	3019406		
4043	404	3001247	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	26607	0	6085-5	3001247		
138252	4261	4052083	1962-07-19	1962-07-19 00:00:00	1962-07-19	5001	0	\N	0	0	\N	\N	0	282860	0	23426006	4052083		
9771	917	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	61073	0	6075-6	3005136		
10145	967	3006322	1936-05-28	1936-05-28 00:00:00	1936-05-28	5001	0	\N	0	0	\N	\N	0	64332	0	8331-1	3006322		
6608	621	40766240	1973-07-02	1973-07-02 00:00:00	1973-07-02	5001	0	\N	0	0	\N	\N	0	41361	0	63513-6	40766240		
17957	1632	3006322	1996-10-16	1996-10-16 00:00:00	1996-10-16	5001	0	\N	0	0	\N	\N	0	109623	0	8331-1	3006322		
23057	2119	3021226	1983-06-29	1983-06-29 00:00:00	1983-06-29	5001	0	\N	0	0	\N	\N	0	141050	0	6246-3	3021226		
34467	3147	3011505	1983-01-10	1983-01-10 00:00:00	1983-01-10	5001	0	\N	0	0	\N	\N	0	209419	0	19926-5	3011505		
33083	2986	3011505	1995-10-17	1995-10-17 00:00:00	1995-10-17	5001	0	\N	0	0	\N	\N	0	199312	0	19926-5	3011505		
6339	601	3023430	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	39740	0	6833-8	3023430		
7103	680	3015076	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	45008	0	6248-9	3015076		
23569	739	4024958	1992-09-01	1992-09-01 00:00:00	1992-09-01	5001	0	\N	0	0	\N	\N	0	48952	0	117015009	4024958		
36107	3321	3006322	1977-06-26	1977-06-26 00:00:00	1977-06-26	5001	0	\N	0	0	\N	\N	0	220524	0	8331-1	3006322		
18609	1709	3006322	1955-09-05	1955-09-05 00:00:00	1955-09-05	5001	0	\N	0	0	\N	\N	0	114263	0	8331-1	3006322		
120878	3731	4052083	1978-10-28	1978-10-28 00:00:00	1978-10-28	5001	0	\N	0	0	\N	\N	0	247913	0	23426006	4052083		
47581	4372	3001488	1996-11-14	1996-11-14 00:00:00	1996-11-14	5001	0	\N	0	0	\N	\N	0	290277	0	7258-7	3001488		
37010	3401	3006322	1977-10-23	1977-10-23 00:00:00	1977-10-23	5001	0	\N	0	0	\N	\N	0	225602	0	8331-1	3006322		
14413	1348	3006322	1979-07-22	1979-07-22 00:00:00	1979-07-22	5001	0	\N	0	0	\N	\N	0	89339	0	8331-1	3006322		
16333	1486	3027231	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	99099	0	6276-0	3027231		
52947	4861	3006322	1952-04-19	1952-04-19 00:00:00	1952-04-19	5001	0	\N	0	0	\N	\N	0	323393	0	8331-1	3006322		
55137	1670	4024958	2002-08-04	2002-08-04 00:00:00	2002-08-04	5001	0	\N	0	0	\N	\N	0	112137	0	117015009	4024958		
3374	331	3028833	1997-04-18	1997-04-18 00:00:00	1997-04-18	5001	0	\N	0	0	\N	\N	0	21811	0	42719-5	3028833		
41146	3832	3001488	1984-11-17	1984-11-17 00:00:00	1984-11-17	5001	0	\N	0	0	\N	\N	0	254407	0	7258-7	3001488		
48738	4452	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	296214	0	6189-5	3006734		
50687	4623	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	307945	0	6082-2	3000876		
34236	3118	3011505	2004-12-19	2004-12-19 00:00:00	2004-12-19	5001	0	\N	0	0	\N	\N	0	207426	0	19926-5	3011505		
34300	3125	3006322	1962-04-16	1962-04-16 00:00:00	1962-04-16	5001	0	\N	0	0	\N	\N	0	207933	0	8331-1	3006322		
14146	1323	3006322	1986-10-19	1986-10-19 00:00:00	1986-10-19	5001	0	\N	0	0	\N	\N	0	87874	0	8331-1	3006322		
84029	2598	4052083	2017-04-29	2017-04-29 00:00:00	2017-04-29	5001	0	\N	0	0	\N	\N	0	171938	0	23426006	4052083		
171243	5253	4133840	1988-07-30	1988-07-30 00:00:00	1988-07-30	5001	0	\N	0	0	\N	\N	0	349541	0	127783003	4133840		
45597	4205	3014599	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	279249	0	6106-9	3014599		
38710	3580	3051031	1997-06-16	1997-06-16 00:00:00	1997-06-16	5001	0	\N	0	0	\N	\N	0	237971	0	46240-8	3051031		
11962	1138	3020655	1985-02-26	1985-02-26 00:00:00	1985-02-26	5001	0	\N	0	0	\N	\N	0	75060	0	6844-5	3020655		
50123	4569	3006322	1976-06-09	1976-06-09 00:00:00	1976-06-09	5001	0	\N	0	0	\N	\N	0	304399	0	8331-1	3006322		
5408	515	3009201	2009-03-05	2009-03-05 00:00:00	2009-03-05	5001	0	\N	0	0	\N	\N	0	34416	0	3016-3	3009201		
50474	4604	3006322	1976-09-12	1976-09-12 00:00:00	1976-09-12	5001	0	\N	0	0	\N	\N	0	306762	0	8331-1	3006322		
43516	4026	3021226	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	267711	0	6246-3	3021226		
129910	4005	4052083	1973-04-10	1973-04-10 00:00:00	1973-04-10	5001	0	\N	0	0	\N	\N	0	266109	0	23426006	4052083		
17000	1550	3006322	1982-12-21	1982-12-21 00:00:00	1982-12-21	5001	0	\N	0	0	\N	\N	0	103766	0	8331-1	3006322		
15632	1431	3006451	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	95274	0	6273-7	3006451		
8716	842	3011505	2001-08-04	2001-08-04 00:00:00	2001-08-04	5001	0	\N	0	0	\N	\N	0	55671	0	19926-5	3011505		
49259	4500	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	299610	0	6273-7	3006451		
49331	4505	3006322	1981-05-21	1981-05-21 00:00:00	1981-05-21	5001	0	\N	0	0	\N	\N	0	300042	0	8331-1	3006322		
31545	2891	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	192290	0	6833-8	3023430		
31627	2895	3012494	1986-01-09	1986-01-09 00:00:00	1986-01-09	5001	0	\N	0	0	\N	\N	0	192693	0	6206-7	3012494		
53099	4878	3020655	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	324403	0	6844-5	3020655		
43034	3976	40766240	1966-03-08	1966-03-08 00:00:00	1966-03-08	5001	0	\N	0	0	\N	\N	0	264383	0	63513-6	40766240		
6110	571	3006322	2009-12-09	2009-12-09 00:00:00	2009-12-09	5001	0	\N	0	0	\N	\N	0	37775	0	8331-1	3006322		
51061	4657	3006322	1990-12-21	1990-12-21 00:00:00	1990-12-21	5001	0	\N	0	0	\N	\N	0	310516	0	8331-1	3006322		
51194	4682	3006322	1996-02-21	1996-02-21 00:00:00	1996-02-21	5001	0	\N	0	0	\N	\N	0	312023	0	8331-1	3006322		
40414	3754	3006322	1963-02-18	1963-02-18 00:00:00	1963-02-18	5001	0	\N	0	0	\N	\N	0	249501	0	8331-1	3006322		
34603	3167	3006322	2005-06-21	2005-06-21 00:00:00	2005-06-21	5001	0	\N	0	0	\N	\N	0	210587	0	8331-1	3006322		
53333	4899	46235214	1921-09-29	1921-09-29 00:00:00	1921-09-29	5001	0	\N	0	0	\N	\N	0	325772	0	76690-7	46235214		
40472	3759	3027231	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	249857	0	6276-0	3027231		
16371	510	4024958	1979-11-02	1979-11-02 00:00:00	1979-11-02	5001	0	\N	0	0	\N	\N	0	34074	0	117015009	4024958		
17277	1571	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	105461	0	6206-7	3012494		
27820	866	4024958	1979-09-19	1979-09-19 00:00:00	1979-09-19	5001	0	\N	0	0	\N	\N	0	57445	0	117015009	4024958		
9329	884	3015076	1994-03-15	1994-03-15 00:00:00	1994-03-15	5001	0	\N	0	0	\N	\N	0	58863	0	6248-9	3015076		
47046	4337	3006322	2006-07-29	2006-07-29 00:00:00	2006-07-29	5001	0	\N	0	0	\N	\N	0	287592	0	8331-1	3006322		
134215	4131	4052083	2014-09-23	2014-09-23 00:00:00	2014-09-23	5001	0	\N	0	0	\N	\N	0	274715	0	23426006	4052083		
20782	1911	3051031	1960-09-18	1960-09-18 00:00:00	1960-09-18	5001	0	\N	0	0	\N	\N	0	127125	0	46240-8	3051031		
20859	1923	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	127936	0	6075-6	3005136		
4044	404	3036780	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	26607	0	6095-4	3036780		
51764	1567	4024958	1981-02-07	1981-02-07 00:00:00	1981-02-07	5001	0	\N	0	0	\N	\N	0	105110	0	117015009	4024958		
9772	917	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	61073	0	6106-9	3014599		
10164	969	3006322	1988-02-02	1988-02-02 00:00:00	1988-02-02	5001	0	\N	0	0	\N	\N	0	64461	0	8331-1	3006322		
6609	621	3006322	1978-12-14	1978-12-14 00:00:00	1978-12-14	5001	0	\N	0	0	\N	\N	0	41459	0	8331-1	3006322		
17958	1632	3006322	1969-11-12	1969-11-12 00:00:00	1969-11-12	5001	0	\N	0	0	\N	\N	0	109589	0	8331-1	3006322		
23058	2119	3014599	1983-06-29	1983-06-29 00:00:00	1983-06-29	5001	0	\N	0	0	\N	\N	0	141050	0	6106-9	3014599		
34468	3147	3011505	2005-03-28	2005-03-28 00:00:00	2005-03-28	5001	0	\N	0	0	\N	\N	0	209347	0	19926-5	3011505		
33084	2986	3011505	1988-10-25	1988-10-25 00:00:00	1988-10-25	5001	0	\N	0	0	\N	\N	0	199300	0	19926-5	3011505		
6340	601	3036780	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	39740	0	6095-4	3036780		
7104	680	3006322	1995-02-26	1995-02-26 00:00:00	1995-02-26	5001	0	\N	0	0	\N	\N	0	45009	0	8331-1	3006322		
23579	739	4024958	1971-11-28	1971-11-28 00:00:00	1971-11-28	5001	0	\N	0	0	\N	\N	0	48937	0	117015009	4024958		
36115	3325	40766240	1964-09-14	1964-09-14 00:00:00	1964-09-14	5001	0	\N	0	0	\N	\N	0	220728	0	63513-6	40766240		
18610	1709	3006322	2005-12-16	2005-12-16 00:00:00	2005-12-16	5001	0	\N	0	0	\N	\N	0	114303	0	8331-1	3006322		
120883	3731	4024958	1989-01-28	1989-01-28 00:00:00	1989-01-28	5001	0	\N	0	0	\N	\N	0	247939	0	117015009	4024958		
47582	4372	3036780	1996-11-14	1996-11-14 00:00:00	1996-11-14	5001	0	\N	0	0	\N	\N	0	290277	0	6095-4	3036780		
37011	3401	3006322	2001-12-01	2001-12-01 00:00:00	2001-12-01	5001	0	\N	0	0	\N	\N	0	225595	0	8331-1	3006322		
14414	1348	3006322	1918-09-09	1918-09-09 00:00:00	1918-09-09	5001	0	\N	0	0	\N	\N	0	89280	0	8331-1	3006322		
16334	1486	3023430	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	99099	0	6833-8	3023430		
52948	4861	3006322	1961-05-19	1961-05-19 00:00:00	1961-05-19	5001	0	\N	0	0	\N	\N	0	323355	0	8331-1	3006322		
55144	1670	4024958	1998-01-15	1998-01-15 00:00:00	1998-01-15	5001	0	\N	0	0	\N	\N	0	112150	0	117015009	4024958		
3375	331	3027970	1997-04-18	1997-04-18 00:00:00	1997-04-18	5001	0	\N	0	0	\N	\N	0	21811	0	10834-0	3027970		
41147	3832	3023430	1984-11-17	1984-11-17 00:00:00	1984-11-17	5001	0	\N	0	0	\N	\N	0	254407	0	6833-8	3023430		
48739	4452	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	296214	0	6095-4	3036780		
50688	4623	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	307945	0	6206-7	3012494		
34237	3118	3011505	2000-12-17	2000-12-17 00:00:00	2000-12-17	5001	0	\N	0	0	\N	\N	0	207409	0	19926-5	3011505		
34301	3125	3006322	1969-06-12	1969-06-12 00:00:00	1969-06-12	5001	0	\N	0	0	\N	\N	0	207927	0	8331-1	3006322		
14147	1323	3006322	1971-05-18	1971-05-18 00:00:00	1971-05-18	5001	0	\N	0	0	\N	\N	0	87872	0	8331-1	3006322		
84062	2599	4024958	1990-12-06	1990-12-06 00:00:00	1990-12-06	5001	0	\N	0	0	\N	\N	0	171975	0	117015009	4024958		
171244	5253	4133840	1990-11-17	1990-11-17 00:00:00	1990-11-17	5001	0	\N	0	0	\N	\N	0	349535	0	127783003	4133840		
45598	4205	3006451	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	279249	0	6273-7	3006451		
38712	3580	46235214	1997-06-16	1997-06-16 00:00:00	1997-06-16	5001	0	\N	0	0	\N	\N	0	237971	0	76690-7	46235214		
11963	1138	3023430	1985-02-26	1985-02-26 00:00:00	1985-02-26	5001	0	\N	0	0	\N	\N	0	75060	0	6833-8	3023430		
50124	4570	3006322	1993-08-03	1993-08-03 00:00:00	1993-08-03	5001	0	\N	0	0	\N	\N	0	304428	0	8331-1	3006322		
5409	515	3008598	2009-03-05	2009-03-05 00:00:00	2009-03-05	5001	0	\N	0	0	\N	\N	0	34416	0	3024-7	3008598		
50475	4604	3006322	1979-03-12	1979-03-12 00:00:00	1979-03-12	5001	0	\N	0	0	\N	\N	0	306713	0	8331-1	3006322		
43517	4026	3006451	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	267711	0	6273-7	3006451		
129917	4006	4024958	1993-07-12	1993-07-12 00:00:00	1993-07-12	5001	0	\N	0	0	\N	\N	0	266162	0	117015009	4024958		
17001	1550	3011505	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	103788	0	19926-5	3011505		
15633	1431	3006734	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	95274	0	6189-5	3006734		
8717	842	3011505	1974-12-07	1974-12-07 00:00:00	1974-12-07	5001	0	\N	0	0	\N	\N	0	55694	0	19926-5	3011505		
49260	4500	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	299610	0	6106-9	3014599		
49332	4505	3006322	2015-11-02	2015-11-02 00:00:00	2015-11-02	5001	0	\N	0	0	\N	\N	0	300071	0	8331-1	3006322		
31546	2891	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	192290	0	6095-4	3036780		
31628	2895	3005136	1986-01-09	1986-01-09 00:00:00	1986-01-09	5001	0	\N	0	0	\N	\N	0	192693	0	6075-6	3005136		
53100	4878	3012494	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	324403	0	6206-7	3012494		
43036	3976	3049273	2017-11-10	2017-11-10 00:00:00	2017-11-10	5001	0	\N	0	0	\N	\N	0	264353	0	38265-5	3049273		
6111	572	3006322	1975-01-29	1975-01-29 00:00:00	1975-01-29	5001	0	\N	0	0	\N	\N	0	37868	0	8331-1	3006322		
51062	4657	3006322	1968-05-01	1968-05-01 00:00:00	1968-05-01	5001	0	\N	0	0	\N	\N	0	310502	0	8331-1	3006322		
104750	3223	4052083	1923-07-14	1923-07-14 00:00:00	1923-07-14	5001	0	\N	0	0	\N	\N	0	214258	0	23426006	4052083		
40415	3754	3006322	1970-11-18	1970-11-18 00:00:00	1970-11-18	5001	0	\N	0	0	\N	\N	0	249487	0	8331-1	3006322		
34604	3167	3006322	1985-04-26	1985-04-26 00:00:00	1985-04-26	5001	0	\N	0	0	\N	\N	0	210585	0	8331-1	3006322		
53335	4899	3051031	1921-09-29	1921-09-29 00:00:00	1921-09-29	5001	0	\N	0	0	\N	\N	0	325772	0	46240-8	3051031		
40473	3759	3021226	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	249857	0	6246-3	3021226		
16374	510	4024958	1979-07-22	1979-07-22 00:00:00	1979-07-22	5001	0	\N	0	0	\N	\N	0	34073	0	117015009	4024958		
17278	1571	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	105461	0	6082-2	3000876		
27823	866	4024958	1994-04-16	1994-04-16 00:00:00	1994-04-16	5001	0	\N	0	0	\N	\N	0	57491	0	117015009	4024958		
52693	4837	3006322	1956-08-15	1956-08-15 00:00:00	1956-08-15	5001	0	\N	0	0	\N	\N	0	321836	0	8331-1	3006322		
47047	4337	3006322	1996-10-04	1996-10-04 00:00:00	1996-10-04	5001	0	\N	0	0	\N	\N	0	287641	0	8331-1	3006322		
134223	4131	4024958	1996-09-07	1996-09-07 00:00:00	1996-09-07	5001	0	\N	0	0	\N	\N	0	274684	0	117015009	4024958		
20783	1911	3006322	1953-02-05	1953-02-05 00:00:00	1953-02-05	5001	0	\N	0	0	\N	\N	0	127142	0	8331-1	3006322		
20860	1923	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	127936	0	6246-3	3021226		
4045	404	3000876	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	26607	0	6082-2	3000876		
51768	1567	4024958	1989-10-07	1989-10-07 00:00:00	1989-10-07	5001	0	\N	0	0	\N	\N	0	105080	0	117015009	4024958		
9773	917	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	61073	0	6189-5	3006734		
10165	969	3006322	1979-05-05	1979-05-05 00:00:00	1979-05-05	5001	0	\N	0	0	\N	\N	0	64416	0	8331-1	3006322		
6610	621	3006322	1931-10-15	1931-10-15 00:00:00	1931-10-15	5001	0	\N	0	0	\N	\N	0	41414	0	8331-1	3006322		
17959	1632	3006322	2011-09-24	2011-09-24 00:00:00	2011-09-24	5001	0	\N	0	0	\N	\N	0	109573	0	8331-1	3006322		
23059	2119	3012494	1983-06-29	1983-06-29 00:00:00	1983-06-29	5001	0	\N	0	0	\N	\N	0	141050	0	6206-7	3012494		
34469	3147	3006322	1953-06-20	1953-06-20 00:00:00	1953-06-20	5001	0	\N	0	0	\N	\N	0	209357	0	8331-1	3006322		
33085	2986	3011505	2016-04-19	2016-04-19 00:00:00	2016-04-19	5001	0	\N	0	0	\N	\N	0	199307	0	19926-5	3011505		
6341	601	3027231	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	39740	0	6276-0	3027231		
7109	682	3006322	1975-12-24	1975-12-24 00:00:00	1975-12-24	5001	0	\N	0	0	\N	\N	0	45146	0	8331-1	3006322		
40953	3796	3006322	1995-03-01	1995-03-01 00:00:00	1995-03-01	5001	0	\N	0	0	\N	\N	0	252391	0	8331-1	3006322		
36116	3325	40758406	1964-09-14	1964-09-14 00:00:00	1964-09-14	5001	0	\N	0	0	\N	\N	0	220728	0	55277-8	40758406		
18611	1709	3006322	1971-03-13	1971-03-13 00:00:00	1971-03-13	5001	0	\N	0	0	\N	\N	0	114264	0	8331-1	3006322		
120904	3732	4024958	1980-01-02	1980-01-02 00:00:00	1980-01-02	5001	0	\N	0	0	\N	\N	0	247979	0	117015009	4024958		
47583	4372	3006322	1987-07-04	1987-07-04 00:00:00	1987-07-04	5001	0	\N	0	0	\N	\N	0	290329	0	8331-1	3006322		
37012	3401	3006322	1971-03-19	1971-03-19 00:00:00	1971-03-19	5001	0	\N	0	0	\N	\N	0	225601	0	8331-1	3006322		
14416	1348	3006322	1954-08-06	1954-08-06 00:00:00	1954-08-06	5001	0	\N	0	0	\N	\N	0	89336	0	8331-1	3006322		
16335	1486	3020655	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	99099	0	6844-5	3020655		
52949	4861	3006322	1947-06-02	1947-06-02 00:00:00	1947-06-02	5001	0	\N	0	0	\N	\N	0	323420	0	8331-1	3006322		
135895	4191	4024958	1977-07-10	1977-07-10 00:00:00	1977-07-10	5001	0	\N	0	0	\N	\N	0	278126	0	117015009	4024958		
3376	331	3013721	1997-04-18	1997-04-18 00:00:00	1997-04-18	5001	0	\N	0	0	\N	\N	0	21811	0	1920-8	3013721		
41148	3832	3019406	1984-11-17	1984-11-17 00:00:00	1984-11-17	5001	0	\N	0	0	\N	\N	0	254407	0	6158-0	3019406		
48740	4452	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	296214	0	6082-2	3000876		
50689	4623	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	307945	0	6276-0	3027231		
34238	3118	3011505	1988-12-11	1988-12-11 00:00:00	1988-12-11	5001	0	\N	0	0	\N	\N	0	207406	0	19926-5	3011505		
34302	3125	3006322	2017-10-18	2017-10-18 00:00:00	2017-10-18	5001	0	\N	0	0	\N	\N	0	207949	0	8331-1	3006322		
96348	2951	4052083	1968-10-24	1968-10-24 00:00:00	1968-10-24	5001	0	\N	0	0	\N	\N	0	197031	0	23426006	4052083		
84067	2599	4024958	1984-01-29	1984-01-29 00:00:00	1984-01-29	5001	0	\N	0	0	\N	\N	0	171989	0	117015009	4024958		
171245	5253	4133840	1984-08-25	1984-08-25 00:00:00	1984-08-25	5001	0	\N	0	0	\N	\N	0	349557	0	127783003	4133840		
45599	4205	3027231	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	279249	0	6276-0	3027231		
38713	3580	40766240	1997-06-16	1997-06-16 00:00:00	1997-06-16	5001	0	\N	0	0	\N	\N	0	237971	0	63513-6	40766240		
11964	1138	3036780	1985-02-26	1985-02-26 00:00:00	1985-02-26	5001	0	\N	0	0	\N	\N	0	75060	0	6095-4	3036780		
50125	4570	3006322	1976-12-16	1976-12-16 00:00:00	1976-12-16	5001	0	\N	0	0	\N	\N	0	304461	0	8331-1	3006322		
5410	515	3006322	1961-11-14	1961-11-14 00:00:00	1961-11-14	5001	0	\N	0	0	\N	\N	0	34413	0	8331-1	3006322		
50476	4604	3006322	2008-02-21	2008-02-21 00:00:00	2008-02-21	5001	0	\N	0	0	\N	\N	0	306728	0	8331-1	3006322		
43518	4026	3015076	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	267711	0	6248-9	3015076		
129922	4006	4052083	1951-04-11	1951-04-11 00:00:00	1951-04-11	5001	0	\N	0	0	\N	\N	0	266135	0	23426006	4052083		
17002	1550	3011505	1999-10-23	1999-10-23 00:00:00	1999-10-23	5001	0	\N	0	0	\N	\N	0	103787	0	19926-5	3011505		
15634	1431	3036780	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	95274	0	6095-4	3036780		
8718	842	3011505	1986-04-12	1986-04-12 00:00:00	1986-04-12	5001	0	\N	0	0	\N	\N	0	55748	0	19926-5	3011505		
49261	4500	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	299610	0	6246-3	3021226		
49333	4505	3006322	2007-07-20	2007-07-20 00:00:00	2007-07-20	5001	0	\N	0	0	\N	\N	0	300064	0	8331-1	3006322		
31547	2891	3006322	2019-05-11	2019-05-11 00:00:00	2019-05-11	5001	0	\N	0	0	\N	\N	0	192328	0	8331-1	3006322		
31629	2895	3006451	1986-01-09	1986-01-09 00:00:00	1986-01-09	5001	0	\N	0	0	\N	\N	0	192693	0	6273-7	3006451		
53101	4878	3001247	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	324403	0	6085-5	3001247		
43038	3976	3051031	1966-05-07	1966-05-07 00:00:00	1966-05-07	5001	0	\N	0	0	\N	\N	0	264355	0	46240-8	3051031		
6112	572	3006322	1999-12-11	1999-12-11 00:00:00	1999-12-11	5001	0	\N	0	0	\N	\N	0	37875	0	8331-1	3006322		
51063	4657	3006322	1973-01-02	1973-01-02 00:00:00	1973-01-02	5001	0	\N	0	0	\N	\N	0	310549	0	8331-1	3006322		
104753	3224	4052083	1971-01-18	1971-01-18 00:00:00	1971-01-18	5001	0	\N	0	0	\N	\N	0	214369	0	23426006	4052083		
17631	1604	3006322	1953-11-30	1953-11-30 00:00:00	1953-11-30	5001	0	\N	0	0	\N	\N	0	107623	0	8331-1	3006322		
34605	3168	3006322	1988-09-07	1988-09-07 00:00:00	1988-09-07	5001	0	\N	0	0	\N	\N	0	210643	0	8331-1	3006322		
53337	4899	40758406	1921-09-29	1921-09-29 00:00:00	1921-09-29	5001	0	\N	0	0	\N	\N	0	325772	0	55277-8	40758406		
40474	3759	3006451	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	249857	0	6273-7	3006451		
16389	510	4052083	2012-07-27	2012-07-27 00:00:00	2012-07-27	5001	0	\N	0	0	\N	\N	0	34115	0	23426006	4052083		
17279	1571	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	105461	0	6833-8	3023430		
27840	867	4024958	1933-07-09	1933-07-09 00:00:00	1933-07-09	5001	0	\N	0	0	\N	\N	0	57575	0	117015009	4024958		
52694	4837	3006322	2002-09-19	2002-09-19 00:00:00	2002-09-19	5001	0	\N	0	0	\N	\N	0	321823	0	8331-1	3006322		
47048	4337	3006322	1974-08-04	1974-08-04 00:00:00	1974-08-04	5001	0	\N	0	0	\N	\N	0	287588	0	8331-1	3006322		
77057	2359	4024958	1945-10-12	1945-10-12 00:00:00	1945-10-12	5001	0	\N	0	0	\N	\N	0	157176	0	117015009	4024958		
20784	1911	40758406	1947-01-25	1947-01-25 00:00:00	1947-01-25	5001	0	\N	0	0	\N	\N	0	127162	0	55277-8	40758406		
20861	1923	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	127936	0	6206-7	3012494		
4046	404	3005136	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	26607	0	6075-6	3005136		
51776	1567	4052083	2018-05-12	2018-05-12 00:00:00	2018-05-12	5001	0	\N	0	0	\N	\N	0	105136	0	23426006	4052083		
9774	917	3006322	2015-06-26	2015-06-26 00:00:00	2015-06-26	5001	0	\N	0	0	\N	\N	0	61060	0	8331-1	3006322		
10166	970	3006322	2001-12-26	2001-12-26 00:00:00	2001-12-26	5001	0	\N	0	0	\N	\N	0	64526	0	8331-1	3006322		
6611	621	3006322	2013-07-24	2013-07-24 00:00:00	2013-07-24	5001	0	\N	0	0	\N	\N	0	41460	0	8331-1	3006322		
17960	1632	3006322	2002-06-01	2002-06-01 00:00:00	2002-06-01	5001	0	\N	0	0	\N	\N	0	109572	0	8331-1	3006322		
23060	2119	3036780	1983-06-29	1983-06-29 00:00:00	1983-06-29	5001	0	\N	0	0	\N	\N	0	141050	0	6095-4	3036780		
34470	3147	3011505	1999-02-22	1999-02-22 00:00:00	1999-02-22	5001	0	\N	0	0	\N	\N	0	209364	0	19926-5	3011505		
33086	2986	3011505	2008-03-04	2008-03-04 00:00:00	2008-03-04	5001	0	\N	0	0	\N	\N	0	199296	0	19926-5	3011505		
6342	601	3014599	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	39740	0	6106-9	3014599		
7110	682	3006322	1981-09-04	1981-09-04 00:00:00	1981-09-04	5001	0	\N	0	0	\N	\N	0	45156	0	8331-1	3006322		
40954	3796	3006322	2010-11-10	2010-11-10 00:00:00	2010-11-10	5001	0	\N	0	0	\N	\N	0	252413	0	8331-1	3006322		
36117	3325	46235214	1964-09-14	1964-09-14 00:00:00	1964-09-14	5001	0	\N	0	0	\N	\N	0	220728	0	76690-7	46235214		
18612	1709	3006322	1990-08-23	1990-08-23 00:00:00	1990-08-23	5001	0	\N	0	0	\N	\N	0	114302	0	8331-1	3006322		
120920	3732	4024958	1961-07-16	1961-07-16 00:00:00	1961-07-16	5001	0	\N	0	0	\N	\N	0	247998	0	117015009	4024958		
47584	4372	3006322	2001-02-04	2001-02-04 00:00:00	2001-02-04	5001	0	\N	0	0	\N	\N	0	290290	0	8331-1	3006322		
37013	3401	3006322	2007-05-13	2007-05-13 00:00:00	2007-05-13	5001	0	\N	0	0	\N	\N	0	225597	0	8331-1	3006322		
14419	1348	3006322	2000-06-09	2000-06-09 00:00:00	2000-06-09	5001	0	\N	0	0	\N	\N	0	89282	0	8331-1	3006322		
16336	1486	3001488	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	99099	0	7258-7	3001488		
52950	4861	3006322	2012-10-18	2012-10-18 00:00:00	2012-10-18	5001	0	\N	0	0	\N	\N	0	323407	0	8331-1	3006322		
135896	4191	4024958	1962-03-21	1962-03-21 00:00:00	1962-03-21	5001	0	\N	0	0	\N	\N	0	278150	0	117015009	4024958		
3377	331	3024561	1997-04-18	1997-04-18 00:00:00	1997-04-18	5001	0	\N	0	0	\N	\N	0	21811	0	1751-7	3024561		
41149	3832	3012494	1984-11-17	1984-11-17 00:00:00	1984-11-17	5001	0	\N	0	0	\N	\N	0	254407	0	6206-7	3012494		
48741	4452	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	296214	0	6833-8	3023430		
50690	4623	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	307945	0	6158-0	3019406		
34239	3118	3006322	1950-10-15	1950-10-15 00:00:00	1950-10-15	5001	0	\N	0	0	\N	\N	0	207482	0	8331-1	3006322		
34303	3125	3006322	1968-05-07	1968-05-07 00:00:00	1968-05-07	5001	0	\N	0	0	\N	\N	0	207926	0	8331-1	3006322		
96350	2951	4052083	1963-08-23	1963-08-23 00:00:00	1963-08-23	5001	0	\N	0	0	\N	\N	0	197021	0	23426006	4052083		
153024	4694	4052083	1982-02-07	1982-02-07 00:00:00	1982-02-07	5001	0	\N	0	0	\N	\N	0	312747	0	23426006	4052083		
171246	5253	4133840	2013-01-19	2013-01-19 00:00:00	2013-01-19	5001	0	\N	0	0	\N	\N	0	349519	0	127783003	4133840		
45600	4205	3020655	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	279249	0	6844-5	3020655		
137838	4247	4052083	2002-04-30	2002-04-30 00:00:00	2002-04-30	5001	0	\N	0	0	\N	\N	0	282076	0	23426006	4052083		
11965	1138	3012494	1993-02-04	1993-02-04 00:00:00	1993-02-04	5001	0	\N	0	0	\N	\N	0	75062	0	6206-7	3012494		
50126	4570	3006322	2018-11-11	2018-11-11 00:00:00	2018-11-11	5001	0	\N	0	0	\N	\N	0	304466	0	8331-1	3006322		
5411	515	3006322	1989-11-18	1989-11-18 00:00:00	1989-11-18	5001	0	\N	0	0	\N	\N	0	34333	0	8331-1	3006322		
50477	4604	3006322	1971-02-27	1971-02-27 00:00:00	1971-02-27	5001	0	\N	0	0	\N	\N	0	306761	0	8331-1	3006322		
43519	4026	3019406	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	267711	0	6158-0	3019406		
129926	4006	4024958	1957-09-06	1957-09-06 00:00:00	1957-09-06	5001	0	\N	0	0	\N	\N	0	266201	0	117015009	4024958		
17003	1550	3006322	1972-05-29	1972-05-29 00:00:00	1972-05-29	5001	0	\N	0	0	\N	\N	0	103801	0	8331-1	3006322		
15635	1431	3001247	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	95274	0	6085-5	3001247		
8719	842	3011505	1961-01-14	1961-01-14 00:00:00	1961-01-14	5001	0	\N	0	0	\N	\N	0	55743	0	19926-5	3011505		
49262	4500	3006322	2014-03-03	2014-03-03 00:00:00	2014-03-03	5001	0	\N	0	0	\N	\N	0	299595	0	8331-1	3006322		
49334	4505	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	299977	0	6844-5	3020655		
31548	2891	3001247	1975-04-27	1975-04-27 00:00:00	1975-04-27	5001	0	\N	0	0	\N	\N	0	192353	0	6085-5	3001247		
31630	2895	3001247	1986-01-09	1986-01-09 00:00:00	1986-01-09	5001	0	\N	0	0	\N	\N	0	192693	0	6085-5	3001247		
53102	4878	3023430	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	324403	0	6833-8	3023430		
43039	3976	46235214	1966-05-07	1966-05-07 00:00:00	1966-05-07	5001	0	\N	0	0	\N	\N	0	264355	0	76690-7	46235214		
6113	572	3006322	1992-09-06	1992-09-06 00:00:00	1992-09-06	5001	0	\N	0	0	\N	\N	0	37869	0	8331-1	3006322		
51064	4657	3006322	2012-09-06	2012-09-06 00:00:00	2012-09-06	5001	0	\N	0	0	\N	\N	0	310519	0	8331-1	3006322		
104754	3224	4052083	1981-02-18	1981-02-18 00:00:00	1981-02-18	5001	0	\N	0	0	\N	\N	0	214397	0	23426006	4052083		
17632	1604	3011505	2016-09-08	2016-09-08 00:00:00	2016-09-08	5001	0	\N	0	0	\N	\N	0	107638	0	19926-5	3011505		
34606	3168	3006322	1997-02-06	1997-02-06 00:00:00	1997-02-06	5001	0	\N	0	0	\N	\N	0	210652	0	8331-1	3006322		
53338	4899	40766240	1921-09-29	1921-09-29 00:00:00	1921-09-29	5001	0	\N	0	0	\N	\N	0	325772	0	63513-6	40766240		
40475	3759	3006734	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	249857	0	6189-5	3006734		
16393	510	4052083	1984-09-27	1984-09-27 00:00:00	1984-09-27	5001	0	\N	0	0	\N	\N	0	34070	0	23426006	4052083		
17280	1571	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	105461	0	6273-7	3006451		
27849	867	4052083	1963-08-31	1963-08-31 00:00:00	1963-08-31	5001	0	\N	0	0	\N	\N	0	57541	0	23426006	4052083		
52695	4837	3006322	1992-03-06	1992-03-06 00:00:00	1992-03-06	5001	0	\N	0	0	\N	\N	0	321838	0	8331-1	3006322		
47049	4337	3006322	1987-02-11	1987-02-11 00:00:00	1987-02-11	5001	0	\N	0	0	\N	\N	0	287640	0	8331-1	3006322		
77059	2359	4052083	2004-03-21	2004-03-21 00:00:00	2004-03-21	5001	0	\N	0	0	\N	\N	0	157271	0	23426006	4052083		
20785	1911	3051031	1947-01-25	1947-01-25 00:00:00	1947-01-25	5001	0	\N	0	0	\N	\N	0	127162	0	46240-8	3051031		
20862	1923	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	127936	0	6273-7	3006451		
4047	404	3006734	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	26607	0	6189-5	3006734		
51777	1567	4024958	2017-01-15	2017-01-15 00:00:00	2017-01-15	5001	0	\N	0	0	\N	\N	0	105135	0	117015009	4024958		
9775	918	3049273	1985-04-27	1985-04-27 00:00:00	1985-04-27	5001	0	\N	0	0	\N	\N	0	61201	0	38265-5	3049273		
10167	970	3006322	1965-01-11	1965-01-11 00:00:00	1965-01-11	5001	0	\N	0	0	\N	\N	0	64518	0	8331-1	3006322		
6612	621	3006322	1926-04-21	1926-04-21 00:00:00	1926-04-21	5001	0	\N	0	0	\N	\N	0	41447	0	8331-1	3006322		
17961	1632	3006322	1962-07-26	1962-07-26 00:00:00	1962-07-26	5001	0	\N	0	0	\N	\N	0	109587	0	8331-1	3006322		
23061	2119	3000876	1983-06-29	1983-06-29 00:00:00	1983-06-29	5001	0	\N	0	0	\N	\N	0	141050	0	6082-2	3000876		
34471	3147	3011505	2004-03-22	2004-03-22 00:00:00	2004-03-22	5001	0	\N	0	0	\N	\N	0	209408	0	19926-5	3011505		
33087	2986	3011505	1995-12-26	1995-12-26 00:00:00	1995-12-26	5001	0	\N	0	0	\N	\N	0	199349	0	19926-5	3011505		
6343	601	3005136	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	39740	0	6075-6	3005136		
7111	682	3006322	2005-09-09	2005-09-09 00:00:00	2005-09-09	5001	0	\N	0	0	\N	\N	0	45165	0	8331-1	3006322		
40955	3796	3006322	2001-01-14	2001-01-14 00:00:00	2001-01-14	5001	0	\N	0	0	\N	\N	0	252392	0	8331-1	3006322		
36119	3325	3051031	1964-09-14	1964-09-14 00:00:00	1964-09-14	5001	0	\N	0	0	\N	\N	0	220728	0	46240-8	3051031		
18613	1709	3006322	1955-03-18	1955-03-18 00:00:00	1955-03-18	5001	0	\N	0	0	\N	\N	0	114253	0	8331-1	3006322		
166866	5121	4024958	2006-10-29	2006-10-29 00:00:00	2006-10-29	5001	0	\N	0	0	\N	\N	0	340475	0	117015009	4024958		
47585	4373	3021226	1976-07-18	1976-07-18 00:00:00	1976-07-18	5001	0	\N	0	0	\N	\N	0	290341	0	6246-3	3021226		
41409	3859	40758406	1989-08-25	1989-08-25 00:00:00	1989-08-25	5001	0	\N	0	0	\N	\N	0	256271	0	55277-8	40758406		
14421	1348	3006322	1936-06-18	1936-06-18 00:00:00	1936-06-18	5001	0	\N	0	0	\N	\N	0	89333	0	8331-1	3006322		
16337	1486	3006322	2018-07-18	2018-07-18 00:00:00	2018-07-18	5001	0	\N	0	0	\N	\N	0	99078	0	8331-1	3006322		
52951	4865	3006322	2015-05-22	2015-05-22 00:00:00	2015-05-22	5001	0	\N	0	0	\N	\N	0	323522	0	8331-1	3006322		
135902	4191	4024958	1961-04-12	1961-04-12 00:00:00	1961-04-12	5001	0	\N	0	0	\N	\N	0	278136	0	117015009	4024958		
3378	331	3007461	1997-04-18	1997-04-18 00:00:00	1997-04-18	5001	0	\N	0	0	\N	\N	0	21811	0	26515-7	3007461		
41150	3832	3006734	1984-11-17	1984-11-17 00:00:00	1984-11-17	5001	0	\N	0	0	\N	\N	0	254407	0	6189-5	3006734		
48742	4452	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	296214	0	6844-5	3020655		
50691	4623	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	307945	0	6085-5	3001247		
34240	3118	3011505	2004-06-27	2004-06-27 00:00:00	2004-06-27	5001	0	\N	0	0	\N	\N	0	207458	0	19926-5	3011505		
34304	3125	3006322	1994-08-10	1994-08-10 00:00:00	1994-08-10	5001	0	\N	0	0	\N	\N	0	207947	0	8331-1	3006322		
96362	2951	4052083	2017-09-10	2017-09-10 00:00:00	2017-09-10	5001	0	\N	0	0	\N	\N	0	197049	0	23426006	4052083		
153029	4694	4024958	1986-05-17	1986-05-17 00:00:00	1986-05-17	5001	0	\N	0	0	\N	\N	0	312722	0	117015009	4024958		
171247	5253	4133840	2014-01-25	2014-01-25 00:00:00	2014-01-25	5001	0	\N	0	0	\N	\N	0	349517	0	127783003	4133840		
45601	4205	3006734	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	279249	0	6189-5	3006734		
137843	4247	4052083	1994-01-21	1994-01-21 00:00:00	1994-01-21	5001	0	\N	0	0	\N	\N	0	282045	0	23426006	4052083		
11966	1138	3006451	1993-02-04	1993-02-04 00:00:00	1993-02-04	5001	0	\N	0	0	\N	\N	0	75062	0	6273-7	3006451		
50127	4570	3006322	2002-11-09	2002-11-09 00:00:00	2002-11-09	5001	0	\N	0	0	\N	\N	0	304458	0	8331-1	3006322		
5412	515	3006322	1955-10-07	1955-10-07 00:00:00	1955-10-07	5001	0	\N	0	0	\N	\N	0	34348	0	8331-1	3006322		
104029	3200	4052083	2012-03-13	2012-03-13 00:00:00	2012-03-13	5001	0	\N	0	0	\N	\N	0	212824	0	23426006	4052083		
43520	4026	3027231	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	267711	0	6276-0	3027231		
129930	4006	4052083	1981-08-17	1981-08-17 00:00:00	1981-08-17	5001	0	\N	0	0	\N	\N	0	266139	0	23426006	4052083		
17004	1550	3006322	1993-10-08	1993-10-08 00:00:00	1993-10-08	5001	0	\N	0	0	\N	\N	0	103757	0	8331-1	3006322		
15636	1431	3027231	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	95274	0	6276-0	3027231		
8720	842	3011505	1980-03-08	1980-03-08 00:00:00	1980-03-08	5001	0	\N	0	0	\N	\N	0	55736	0	19926-5	3011505		
49263	4500	3006322	2006-07-18	2006-07-18 00:00:00	2006-07-18	5001	0	\N	0	0	\N	\N	0	299592	0	8331-1	3006322		
49335	4505	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	299977	0	6189-5	3006734		
31549	2891	3000876	1975-04-27	1975-04-27 00:00:00	1975-04-27	5001	0	\N	0	0	\N	\N	0	192353	0	6082-2	3000876		
31631	2895	3006734	1986-01-09	1986-01-09 00:00:00	1986-01-09	5001	0	\N	0	0	\N	\N	0	192693	0	6189-5	3006734		
53103	4878	3036780	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	324403	0	6095-4	3036780		
43040	3976	40758406	1966-05-07	1966-05-07 00:00:00	1966-05-07	5001	0	\N	0	0	\N	\N	0	264355	0	55277-8	40758406		
6114	572	3006322	1961-11-29	1961-11-29 00:00:00	1961-11-29	5001	0	\N	0	0	\N	\N	0	37871	0	8331-1	3006322		
51066	4660	3006322	1968-07-26	1968-07-26 00:00:00	1968-07-26	5001	0	\N	0	0	\N	\N	0	310657	0	8331-1	3006322		
104805	3226	4052083	2008-06-25	2008-06-25 00:00:00	2008-06-25	5001	0	\N	0	0	\N	\N	0	214477	0	23426006	4052083		
17633	1604	3011505	2007-07-19	2007-07-19 00:00:00	2007-07-19	5001	0	\N	0	0	\N	\N	0	107637	0	19926-5	3011505		
34613	3170	3006322	1960-01-05	1960-01-05 00:00:00	1960-01-05	5001	0	\N	0	0	\N	\N	0	210722	0	8331-1	3006322		
53339	4899	3011505	1998-11-10	1998-11-10 00:00:00	1998-11-10	5001	0	\N	0	0	\N	\N	0	325847	0	19926-5	3011505		
40476	3759	3023430	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	249857	0	6833-8	3023430		
16416	512	4024958	1973-08-15	1973-08-15 00:00:00	1973-08-15	5001	0	\N	0	0	\N	\N	0	34204	0	117015009	4024958		
17281	1571	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	105461	0	6246-3	3021226		
27856	867	4052083	1971-05-29	1971-05-29 00:00:00	1971-05-29	5001	0	\N	0	0	\N	\N	0	57577	0	23426006	4052083		
52696	4837	3006322	2005-12-16	2005-12-16 00:00:00	2005-12-16	5001	0	\N	0	0	\N	\N	0	321865	0	8331-1	3006322		
47050	4338	3006322	1989-01-09	1989-01-09 00:00:00	1989-01-09	5001	0	\N	0	0	\N	\N	0	287688	0	8331-1	3006322		
77060	2359	4024958	1955-09-06	1955-09-06 00:00:00	1955-09-06	5001	0	\N	0	0	\N	\N	0	157246	0	117015009	4024958		
20787	1911	46235214	1947-01-25	1947-01-25 00:00:00	1947-01-25	5001	0	\N	0	0	\N	\N	0	127162	0	76690-7	46235214		
20863	1923	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	127936	0	6833-8	3023430		
4048	404	3023430	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	26607	0	6833-8	3023430		
51799	1568	4024958	1966-04-23	1966-04-23 00:00:00	1966-04-23	5001	0	\N	0	0	\N	\N	0	105154	0	117015009	4024958		
9776	918	3049273	1969-01-21	1969-01-21 00:00:00	1969-01-21	5001	0	\N	0	0	\N	\N	0	61200	0	38265-5	3049273		
10168	970	3006322	1960-05-11	1960-05-11 00:00:00	1960-05-11	5001	0	\N	0	0	\N	\N	0	64517	0	8331-1	3006322		
6613	621	3006322	1929-04-14	1929-04-14 00:00:00	1929-04-14	5001	0	\N	0	0	\N	\N	0	41469	0	8331-1	3006322		
17966	1634	3006322	1975-09-28	1975-09-28 00:00:00	1975-09-28	5001	0	\N	0	0	\N	\N	0	109739	0	8331-1	3006322		
23062	2119	3019406	1983-06-29	1983-06-29 00:00:00	1983-06-29	5001	0	\N	0	0	\N	\N	0	141050	0	6158-0	3019406		
34472	3147	3011505	2011-05-02	2011-05-02 00:00:00	2011-05-02	5001	0	\N	0	0	\N	\N	0	209409	0	19926-5	3011505		
33088	2986	3011505	2003-02-04	2003-02-04 00:00:00	2003-02-04	5001	0	\N	0	0	\N	\N	0	199315	0	19926-5	3011505		
6344	601	3015076	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	39740	0	6248-9	3015076		
7112	682	3006322	1983-04-12	1983-04-12 00:00:00	1983-04-12	5001	0	\N	0	0	\N	\N	0	45163	0	8331-1	3006322		
40956	3796	3006322	1969-09-05	1969-09-05 00:00:00	1969-09-05	5001	0	\N	0	0	\N	\N	0	252367	0	8331-1	3006322		
3760	117	4052083	1974-07-08	1974-07-08 00:00:00	1974-07-08	5001	0	\N	0	0	\N	\N	0	7757	0	23426006	4052083		
18614	1709	3049273	2017-02-04	2017-02-04 00:00:00	2017-02-04	5001	0	\N	0	0	\N	\N	0	114283	0	38265-5	3049273		
6707	209	4052083	1958-10-15	1958-10-15 00:00:00	1958-10-15	5001	0	\N	0	0	\N	\N	0	14258	0	23426006	4052083		
47586	4373	3006451	1976-07-18	1976-07-18 00:00:00	1976-07-18	5001	0	\N	0	0	\N	\N	0	290341	0	6273-7	3006451		
41410	3859	3011505	1998-08-15	1998-08-15 00:00:00	1998-08-15	5001	0	\N	0	0	\N	\N	0	256237	0	19926-5	3011505		
14428	1352	3011505	2011-05-29	2011-05-29 00:00:00	2011-05-29	5001	0	\N	0	0	\N	\N	0	89573	0	19926-5	3011505		
16338	1486	3006322	1971-07-31	1971-07-31 00:00:00	1971-07-31	5001	0	\N	0	0	\N	\N	0	99134	0	8331-1	3006322		
52952	4865	3006322	1981-12-22	1981-12-22 00:00:00	1981-12-22	5001	0	\N	0	0	\N	\N	0	323543	0	8331-1	3006322		
135906	4191	4024958	1958-11-10	1958-11-10 00:00:00	1958-11-10	5001	0	\N	0	0	\N	\N	0	278123	0	117015009	4024958		
3379	331	3045716	1997-04-18	1997-04-18 00:00:00	1997-04-18	5001	0	\N	0	0	\N	\N	0	21811	0	33037-3	3045716		
41151	3832	3014599	1984-11-17	1984-11-17 00:00:00	1984-11-17	5001	0	\N	0	0	\N	\N	0	254407	0	6106-9	3014599		
48743	4452	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	296214	0	7258-7	3001488		
50692	4623	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	307945	0	7258-7	3001488		
34241	3118	3011505	1986-06-08	1986-06-08 00:00:00	1986-06-08	5001	0	\N	0	0	\N	\N	0	207509	0	19926-5	3011505		
34305	3125	3006322	1955-06-10	1955-06-10 00:00:00	1955-06-10	5001	0	\N	0	0	\N	\N	0	207994	0	8331-1	3006322		
96363	2951	4052083	1983-09-21	1983-09-21 00:00:00	1983-09-21	5001	0	\N	0	0	\N	\N	0	197047	0	23426006	4052083		
164328	5048	4024958	1970-06-27	1970-06-27 00:00:00	1970-06-27	5001	0	\N	0	0	\N	\N	0	335403	0	117015009	4024958		
171248	5253	4133840	2004-01-03	2004-01-03 00:00:00	2004-01-03	5001	0	\N	0	0	\N	\N	0	349509	0	127783003	4133840		
45602	4205	3012494	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	279249	0	6206-7	3012494		
137845	4247	4024958	1995-07-16	1995-07-16 00:00:00	1995-07-16	5001	0	\N	0	0	\N	\N	0	282100	0	117015009	4024958		
11967	1138	3001247	1993-02-04	1993-02-04 00:00:00	1993-02-04	5001	0	\N	0	0	\N	\N	0	75062	0	6085-5	3001247		
50128	4570	3006322	1994-05-11	1994-05-11 00:00:00	1994-05-11	5001	0	\N	0	0	\N	\N	0	304456	0	8331-1	3006322		
5413	515	3006322	1969-01-21	1969-01-21 00:00:00	1969-01-21	5001	0	\N	0	0	\N	\N	0	34324	0	8331-1	3006322		
104048	3200	4052083	1961-09-03	1961-09-03 00:00:00	1961-09-03	5001	0	\N	0	0	\N	\N	0	212831	0	23426006	4052083		
43521	4026	3014599	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	267711	0	6106-9	3014599		
25395	2334	3011505	1999-04-15	1999-04-15 00:00:00	1999-04-15	5001	0	\N	0	0	\N	\N	0	155301	0	19926-5	3011505		
17005	1550	3011505	2004-05-22	2004-05-22 00:00:00	2004-05-22	5001	0	\N	0	0	\N	\N	0	103779	0	19926-5	3011505		
15637	1431	3012494	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	95274	0	6206-7	3012494		
8721	842	3011505	2011-10-01	2011-10-01 00:00:00	2011-10-01	5001	0	\N	0	0	\N	\N	0	55691	0	19926-5	3011505		
49264	4500	3006322	1968-09-08	1968-09-08 00:00:00	1968-09-08	5001	0	\N	0	0	\N	\N	0	299547	0	8331-1	3006322		
49336	4505	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	299977	0	6206-7	3012494		
31550	2891	3019406	1975-04-27	1975-04-27 00:00:00	1975-04-27	5001	0	\N	0	0	\N	\N	0	192353	0	6158-0	3019406		
31632	2895	3036780	1986-01-09	1986-01-09 00:00:00	1986-01-09	5001	0	\N	0	0	\N	\N	0	192693	0	6095-4	3036780		
53104	4878	3006734	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	324403	0	6189-5	3006734		
43041	3976	40766240	1966-05-07	1966-05-07 00:00:00	1966-05-07	5001	0	\N	0	0	\N	\N	0	264355	0	63513-6	40766240		
6115	572	3006322	2010-05-27	2010-05-27 00:00:00	2010-05-27	5001	0	\N	0	0	\N	\N	0	37877	0	8331-1	3006322		
51067	4661	3006322	2008-02-23	2008-02-23 00:00:00	2008-02-23	5001	0	\N	0	0	\N	\N	0	310675	0	8331-1	3006322		
104816	3226	4052083	1982-01-28	1982-01-28 00:00:00	1982-01-28	5001	0	\N	0	0	\N	\N	0	214494	0	23426006	4052083		
17634	1605	3006322	2007-08-10	2007-08-10 00:00:00	2007-08-10	5001	0	\N	0	0	\N	\N	0	107759	0	8331-1	3006322		
34614	3170	3006322	1975-02-10	1975-02-10 00:00:00	1975-02-10	5001	0	\N	0	0	\N	\N	0	210697	0	8331-1	3006322		
53340	4899	3011505	1981-08-04	1981-08-04 00:00:00	1981-08-04	5001	0	\N	0	0	\N	\N	0	325829	0	19926-5	3011505		
40477	3759	3020655	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	249857	0	6844-5	3020655		
16418	512	4024958	1998-12-16	1998-12-16 00:00:00	1998-12-16	5001	0	\N	0	0	\N	\N	0	34164	0	117015009	4024958		
17282	1571	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	105461	0	6276-0	3027231		
73937	2272	4024958	2010-06-20	2010-06-20 00:00:00	2010-06-20	5001	0	\N	0	0	\N	\N	0	151033	0	117015009	4024958		
52697	4837	3006322	1966-05-09	1966-05-09 00:00:00	1966-05-09	5001	0	\N	0	0	\N	\N	0	321837	0	8331-1	3006322		
47051	4338	3006322	1967-12-01	1967-12-01 00:00:00	1967-12-01	5001	0	\N	0	0	\N	\N	0	287644	0	8331-1	3006322		
77068	2359	4024958	1962-11-18	1962-11-18 00:00:00	1962-11-18	5001	0	\N	0	0	\N	\N	0	157177	0	117015009	4024958		
20789	1911	40766240	1947-01-25	1947-01-25 00:00:00	1947-01-25	5001	0	\N	0	0	\N	\N	0	127162	0	63513-6	40766240		
20864	1923	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	127936	0	6844-5	3020655		
4049	404	3020655	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	26607	0	6844-5	3020655		
51808	1568	4052083	1960-01-22	1960-01-22 00:00:00	1960-01-22	5001	0	\N	0	0	\N	\N	0	105198	0	23426006	4052083		
9777	918	3006322	1959-10-09	1959-10-09 00:00:00	1959-10-09	5001	0	\N	0	0	\N	\N	0	61137	0	8331-1	3006322		
10169	970	3006322	2016-05-01	2016-05-01 00:00:00	2016-05-01	5001	0	\N	0	0	\N	\N	0	64528	0	8331-1	3006322		
6614	621	3006322	1952-12-12	1952-12-12 00:00:00	1952-12-12	5001	0	\N	0	0	\N	\N	0	41452	0	8331-1	3006322		
17967	1634	3006322	1997-08-17	1997-08-17 00:00:00	1997-08-17	5001	0	\N	0	0	\N	\N	0	109725	0	8331-1	3006322		
23063	2119	3001488	1983-06-29	1983-06-29 00:00:00	1983-06-29	5001	0	\N	0	0	\N	\N	0	141050	0	7258-7	3001488		
34473	3147	3006322	1948-07-05	1948-07-05 00:00:00	1948-07-05	5001	0	\N	0	0	\N	\N	0	209413	0	8331-1	3006322		
33089	2986	3011505	2000-01-18	2000-01-18 00:00:00	2000-01-18	5001	0	\N	0	0	\N	\N	0	199321	0	19926-5	3011505		
6345	601	3000876	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	39740	0	6082-2	3000876		
7113	682	3006322	1994-03-28	1994-03-28 00:00:00	1994-03-28	5001	0	\N	0	0	\N	\N	0	45157	0	8331-1	3006322		
40962	3799	3006322	1984-03-09	1984-03-09 00:00:00	1984-03-09	5001	0	\N	0	0	\N	\N	0	252563	0	8331-1	3006322		
3762	117	4024958	2011-12-26	2011-12-26 00:00:00	2011-12-26	5001	0	\N	0	0	\N	\N	0	7760	0	117015009	4024958		
18615	1709	3006322	2017-04-15	2017-04-15 00:00:00	2017-04-15	5001	0	\N	0	0	\N	\N	0	114259	0	8331-1	3006322		
6711	209	4024958	1964-10-14	1964-10-14 00:00:00	1964-10-14	5001	0	\N	0	0	\N	\N	0	14262	0	117015009	4024958		
47587	4373	3015076	1976-07-18	1976-07-18 00:00:00	1976-07-18	5001	0	\N	0	0	\N	\N	0	290341	0	6248-9	3015076		
41411	3859	3011505	2007-10-06	2007-10-06 00:00:00	2007-10-06	5001	0	\N	0	0	\N	\N	0	256160	0	19926-5	3011505		
14429	1352	3011505	2016-01-17	2016-01-17 00:00:00	2016-01-17	5001	0	\N	0	0	\N	\N	0	89574	0	19926-5	3011505		
16360	1490	3006322	1999-06-27	1999-06-27 00:00:00	1999-06-27	5001	0	\N	0	0	\N	\N	0	99374	0	8331-1	3006322		
52953	4865	3006322	2010-01-08	2010-01-08 00:00:00	2010-01-08	5001	0	\N	0	0	\N	\N	0	323521	0	8331-1	3006322		
135919	4191	4052083	1999-08-15	1999-08-15 00:00:00	1999-08-15	5001	0	\N	0	0	\N	\N	0	278129	0	23426006	4052083		
3380	331	3013682	1997-04-18	1997-04-18 00:00:00	1997-04-18	5001	0	\N	0	0	\N	\N	0	21811	0	3094-0	3013682		
41152	3832	3006451	1984-11-17	1984-11-17 00:00:00	1984-11-17	5001	0	\N	0	0	\N	\N	0	254407	0	6273-7	3006451		
48744	4452	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	296214	0	6273-7	3006451		
50693	4623	3006322	1968-02-05	1968-02-05 00:00:00	1968-02-05	5001	0	\N	0	0	\N	\N	0	307897	0	8331-1	3006322		
34242	3118	3027231	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	207486	0	6276-0	3027231		
34308	3128	3012494	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	208224	0	6206-7	3012494		
96394	2953	4024958	2009-05-15	2009-05-15 00:00:00	2009-05-15	5001	0	\N	0	0	\N	\N	0	197109	0	117015009	4024958		
164338	5048	4052083	1992-08-24	1992-08-24 00:00:00	1992-08-24	5001	0	\N	0	0	\N	\N	0	335496	0	23426006	4052083		
171249	5253	4133840	1993-09-11	1993-09-11 00:00:00	1993-09-11	5001	0	\N	0	0	\N	\N	0	349543	0	127783003	4133840		
45603	4205	3001488	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	279249	0	7258-7	3001488		
137856	4247	4024958	2000-12-01	2000-12-01 00:00:00	2000-12-01	5001	0	\N	0	0	\N	\N	0	282021	0	117015009	4024958		
11968	1138	3006734	1993-02-04	1993-02-04 00:00:00	1993-02-04	5001	0	\N	0	0	\N	\N	0	75062	0	6189-5	3006734		
50129	4570	3049273	1997-01-25	1997-01-25 00:00:00	1997-01-25	5001	0	\N	0	0	\N	\N	0	304494	0	38265-5	3049273		
5470	518	3006322	1981-03-07	1981-03-07 00:00:00	1981-03-07	5001	0	\N	0	0	\N	\N	0	34619	0	8331-1	3006322		
104050	3200	4024958	2001-01-21	2001-01-21 00:00:00	2001-01-21	5001	0	\N	0	0	\N	\N	0	212834	0	117015009	4024958		
43522	4026	3005136	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	267711	0	6075-6	3005136		
25396	2334	3011505	1971-05-06	1971-05-06 00:00:00	1971-05-06	5001	0	\N	0	0	\N	\N	0	155333	0	19926-5	3011505		
28283	2611	3006322	1985-05-03	1985-05-03 00:00:00	1985-05-03	5001	0	\N	0	0	\N	\N	0	172702	0	8331-1	3006322		
15638	1431	3000876	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	95274	0	6082-2	3000876		
8722	842	3011505	2000-07-29	2000-07-29 00:00:00	2000-07-29	5001	0	\N	0	0	\N	\N	0	55680	0	19926-5	3011505		
49265	4500	3006322	2004-06-17	2004-06-17 00:00:00	2004-06-17	5001	0	\N	0	0	\N	\N	0	299579	0	8331-1	3006322		
49337	4505	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	299977	0	6095-4	3036780		
31551	2891	3015076	1975-04-27	1975-04-27 00:00:00	1975-04-27	5001	0	\N	0	0	\N	\N	0	192353	0	6248-9	3015076		
31633	2895	3019406	1986-01-09	1986-01-09 00:00:00	1986-01-09	5001	0	\N	0	0	\N	\N	0	192693	0	6158-0	3019406		
53105	4878	3006322	2000-04-19	2000-04-19 00:00:00	2000-04-19	5001	0	\N	0	0	\N	\N	0	324442	0	8331-1	3006322		
43043	3976	3006322	1988-10-27	1988-10-27 00:00:00	1988-10-27	5001	0	\N	0	0	\N	\N	0	264327	0	8331-1	3006322		
6116	572	3006322	1954-05-24	1954-05-24 00:00:00	1954-05-24	5001	0	\N	0	0	\N	\N	0	37893	0	8331-1	3006322		
51068	4661	3006322	2013-04-10	2013-04-10 00:00:00	2013-04-10	5001	0	\N	0	0	\N	\N	0	310676	0	8331-1	3006322		
104821	3227	4024958	1982-03-07	1982-03-07 00:00:00	1982-03-07	5001	0	\N	0	0	\N	\N	0	214502	0	117015009	4024958		
17635	1605	3006322	2018-12-08	2018-12-08 00:00:00	2018-12-08	5001	0	\N	0	0	\N	\N	0	107783	0	8331-1	3006322		
34615	3170	3006322	1975-10-23	1975-10-23 00:00:00	1975-10-23	5001	0	\N	0	0	\N	\N	0	210725	0	8331-1	3006322		
53341	4899	3011505	1974-06-25	1974-06-25 00:00:00	1974-06-25	5001	0	\N	0	0	\N	\N	0	325794	0	19926-5	3011505		
40478	3759	3005136	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	249857	0	6075-6	3005136		
16433	512	4052083	1963-10-02	1963-10-02 00:00:00	1963-10-02	5001	0	\N	0	0	\N	\N	0	34200	0	23426006	4052083		
17283	1571	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	105461	0	6158-0	3019406		
73954	2272	4052083	1994-09-14	1994-09-14 00:00:00	1994-09-14	5001	0	\N	0	0	\N	\N	0	151022	0	23426006	4052083		
52708	4843	3006322	1965-09-04	1965-09-04 00:00:00	1965-09-04	5001	0	\N	0	0	\N	\N	0	322157	0	8331-1	3006322		
47052	4338	3006322	1983-08-23	1983-08-23 00:00:00	1983-08-23	5001	0	\N	0	0	\N	\N	0	287687	0	8331-1	3006322		
77073	2359	4024958	1983-04-13	1983-04-13 00:00:00	1983-04-13	5001	0	\N	0	0	\N	\N	0	157178	0	117015009	4024958		
20822	1915	3006322	2011-12-18	2011-12-18 00:00:00	2011-12-18	5001	0	\N	0	0	\N	\N	0	127381	0	8331-1	3006322		
20865	1923	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	127936	0	6276-0	3027231		
4050	404	3021226	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	26607	0	6246-3	3021226		
51834	1569	4024958	1943-06-04	1943-06-04 00:00:00	1943-06-04	5001	0	\N	0	0	\N	\N	0	105241	0	117015009	4024958		
9778	918	3006322	1948-05-27	1948-05-27 00:00:00	1948-05-27	5001	0	\N	0	0	\N	\N	0	61188	0	8331-1	3006322		
10170	970	3006322	1988-11-10	1988-11-10 00:00:00	1988-11-10	5001	0	\N	0	0	\N	\N	0	64548	0	8331-1	3006322		
6615	621	3006322	1974-09-25	1974-09-25 00:00:00	1974-09-25	5001	0	\N	0	0	\N	\N	0	41363	0	8331-1	3006322		
17968	1634	3006322	1945-11-03	1945-11-03 00:00:00	1945-11-03	5001	0	\N	0	0	\N	\N	0	109721	0	8331-1	3006322		
23064	2119	3006322	1961-10-13	1961-10-13 00:00:00	1961-10-13	5001	0	\N	0	0	\N	\N	0	140998	0	8331-1	3006322		
34474	3147	3011505	1998-02-16	1998-02-16 00:00:00	1998-02-16	5001	0	\N	0	0	\N	\N	0	209424	0	19926-5	3011505		
33090	2986	3011505	2010-03-16	2010-03-16 00:00:00	2010-03-16	5001	0	\N	0	0	\N	\N	0	199316	0	19926-5	3011505		
6346	601	3006322	2007-06-21	2007-06-21 00:00:00	2007-06-21	5001	0	\N	0	0	\N	\N	0	39742	0	8331-1	3006322		
7114	682	3006322	2018-03-21	2018-03-21 00:00:00	2018-03-21	5001	0	\N	0	0	\N	\N	0	45158	0	8331-1	3006322		
40963	3799	3006322	1983-09-01	1983-09-01 00:00:00	1983-09-01	5001	0	\N	0	0	\N	\N	0	252572	0	8331-1	3006322		
3768	117	4052083	2002-03-21	2002-03-21 00:00:00	2002-03-21	5001	0	\N	0	0	\N	\N	0	7806	0	23426006	4052083		
29919	2757	3006322	1977-12-11	1977-12-11 00:00:00	1977-12-11	5001	0	\N	0	0	\N	\N	0	182369	0	8331-1	3006322		
6720	209	4024958	1954-09-18	1954-09-18 00:00:00	1954-09-18	5001	0	\N	0	0	\N	\N	0	14257	0	117015009	4024958		
47588	4373	3019406	1976-07-18	1976-07-18 00:00:00	1976-07-18	5001	0	\N	0	0	\N	\N	0	290341	0	6158-0	3019406		
41412	3859	3051031	1989-12-23	1989-12-23 00:00:00	1989-12-23	5001	0	\N	0	0	\N	\N	0	256177	0	46240-8	3051031		
14430	1352	3011505	1993-08-15	1993-08-15 00:00:00	1993-08-15	5001	0	\N	0	0	\N	\N	0	89553	0	19926-5	3011505		
16361	1490	3006322	1959-01-01	1959-01-01 00:00:00	1959-01-01	5001	0	\N	0	0	\N	\N	0	99360	0	8331-1	3006322		
52954	4865	3006322	1995-11-14	1995-11-14 00:00:00	1995-11-14	5001	0	\N	0	0	\N	\N	0	323507	0	8331-1	3006322		
170170	5222	4133840	2011-03-24	2011-03-24 00:00:00	2011-03-24	5001	0	\N	0	0	\N	\N	0	347424	0	127783003	4133840		
3381	331	3023103	1997-04-18	1997-04-18 00:00:00	1997-04-18	5001	0	\N	0	0	\N	\N	0	21811	0	2823-3	3023103		
41153	3832	3027231	1984-11-17	1984-11-17 00:00:00	1984-11-17	5001	0	\N	0	0	\N	\N	0	254407	0	6276-0	3027231		
48745	4452	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	296214	0	6206-7	3012494		
50694	4623	3006451	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	307872	0	6273-7	3006451		
34243	3118	3006451	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	207486	0	6273-7	3006451		
34309	3128	3014599	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	208224	0	6106-9	3014599		
96401	2953	4024958	2017-07-27	2017-07-27 00:00:00	2017-07-27	5001	0	\N	0	0	\N	\N	0	197136	0	117015009	4024958		
164346	5048	4024958	1981-06-11	1981-06-11 00:00:00	1981-06-11	5001	0	\N	0	0	\N	\N	0	335461	0	117015009	4024958		
171251	5253	4133840	2012-01-14	2012-01-14 00:00:00	2012-01-14	5001	0	\N	0	0	\N	\N	0	349538	0	127783003	4133840		
45604	4205	3036780	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	279249	0	6095-4	3036780		
43988	1355	4024958	1998-09-25	1998-09-25 00:00:00	1998-09-25	5001	0	\N	0	0	\N	\N	0	89798	0	117015009	4024958		
11969	1138	3027231	1993-02-04	1993-02-04 00:00:00	1993-02-04	5001	0	\N	0	0	\N	\N	0	75062	0	6276-0	3027231		
50130	4570	3006322	1958-12-12	1958-12-12 00:00:00	1958-12-12	5001	0	\N	0	0	\N	\N	0	304510	0	8331-1	3006322		
5471	518	3006322	1982-05-14	1982-05-14 00:00:00	1982-05-14	5001	0	\N	0	0	\N	\N	0	34613	0	8331-1	3006322		
104051	3200	4052083	1983-09-04	1983-09-04 00:00:00	1983-09-04	5001	0	\N	0	0	\N	\N	0	212832	0	23426006	4052083		
43523	4026	3006734	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	267711	0	6189-5	3006734		
25397	2334	3011505	2011-06-23	2011-06-23 00:00:00	2011-06-23	5001	0	\N	0	0	\N	\N	0	155281	0	19926-5	3011505		
28284	2611	3006322	1953-11-06	1953-11-06 00:00:00	1953-11-06	5001	0	\N	0	0	\N	\N	0	172682	0	8331-1	3006322		
15639	1431	3021226	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	95274	0	6246-3	3021226		
8723	842	3011505	1976-12-18	1976-12-18 00:00:00	1976-12-18	5001	0	\N	0	0	\N	\N	0	55734	0	19926-5	3011505		
49266	4500	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	299570	0	6206-7	3012494		
49338	4505	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	299977	0	6833-8	3023430		
31552	2891	3005136	1975-04-27	1975-04-27 00:00:00	1975-04-27	5001	0	\N	0	0	\N	\N	0	192353	0	6075-6	3005136		
31634	2895	3021226	1986-01-09	1986-01-09 00:00:00	1986-01-09	5001	0	\N	0	0	\N	\N	0	192693	0	6246-3	3021226		
53108	4881	3006322	1957-05-10	1957-05-10 00:00:00	1957-05-10	5001	0	\N	0	0	\N	\N	0	324536	0	8331-1	3006322		
43044	3976	3051031	1964-06-16	1964-06-16 00:00:00	1964-06-16	5001	0	\N	0	0	\N	\N	0	264380	0	46240-8	3051031		
6117	573	3006322	1965-07-27	1965-07-27 00:00:00	1965-07-27	5001	0	\N	0	0	\N	\N	0	37956	0	8331-1	3006322		
51069	4661	3006322	1994-05-25	1994-05-25 00:00:00	1994-05-25	5001	0	\N	0	0	\N	\N	0	310674	0	8331-1	3006322		
1178	96	3011505	1994-04-16	1994-04-16 00:00:00	1994-04-16	5001	0	\N	0	0	\N	\N	0	6516	0	19926-5	3011505		
17637	1605	3006322	2010-11-09	2010-11-09 00:00:00	2010-11-09	5001	0	\N	0	0	\N	\N	0	107674	0	8331-1	3006322		
34617	3170	3006322	1969-12-25	1969-12-25 00:00:00	1969-12-25	5001	0	\N	0	0	\N	\N	0	210720	0	8331-1	3006322		
53342	4899	3011505	1976-07-06	1976-07-06 00:00:00	1976-07-06	5001	0	\N	0	0	\N	\N	0	325795	0	19926-5	3011505		
40479	3759	3001488	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	249857	0	7258-7	3001488		
89467	2770	4024958	1935-06-23	1935-06-23 00:00:00	1935-06-23	5001	0	\N	0	0	\N	\N	0	183332	0	117015009	4024958		
17284	1571	3006322	1979-02-15	1979-02-15 00:00:00	1979-02-15	5001	0	\N	0	0	\N	\N	0	105482	0	8331-1	3006322		
73968	2272	4024958	2001-03-14	2001-03-14 00:00:00	2001-03-14	5001	0	\N	0	0	\N	\N	0	150987	0	117015009	4024958		
52709	4843	3006322	2019-02-27	2019-02-27 00:00:00	2019-02-27	5001	0	\N	0	0	\N	\N	0	322161	0	8331-1	3006322		
47053	4338	3006322	2005-04-28	2005-04-28 00:00:00	2005-04-28	5001	0	\N	0	0	\N	\N	0	287674	0	8331-1	3006322		
77084	2359	4052083	1978-11-29	1978-11-29 00:00:00	1978-11-29	5001	0	\N	0	0	\N	\N	0	157278	0	23426006	4052083		
20823	1916	3006322	2007-04-30	2007-04-30 00:00:00	2007-04-30	5001	0	\N	0	0	\N	\N	0	127498	0	8331-1	3006322		
20866	1923	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	127936	0	6248-9	3015076		
4051	404	3014599	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	26607	0	6106-9	3014599		
51939	1571	4024958	1973-08-22	1973-08-22 00:00:00	1973-08-22	5001	0	\N	0	0	\N	\N	0	105428	0	117015009	4024958		
9779	918	3006322	1935-06-25	1935-06-25 00:00:00	1935-06-25	5001	0	\N	0	0	\N	\N	0	61136	0	8331-1	3006322		
10171	970	3006322	1976-09-05	1976-09-05 00:00:00	1976-09-05	5001	0	\N	0	0	\N	\N	0	64481	0	8331-1	3006322		
6616	621	3051031	1973-01-03	1973-01-03 00:00:00	1973-01-03	5001	0	\N	0	0	\N	\N	0	41473	0	46240-8	3051031		
17972	1634	3006322	2004-12-23	2004-12-23 00:00:00	2004-12-23	5001	0	\N	0	0	\N	\N	0	109726	0	8331-1	3006322		
23065	2119	3006322	1984-05-30	1984-05-30 00:00:00	1984-05-30	5001	0	\N	0	0	\N	\N	0	140965	0	8331-1	3006322		
34475	3147	3011505	2008-04-14	2008-04-14 00:00:00	2008-04-14	5001	0	\N	0	0	\N	\N	0	209388	0	19926-5	3011505		
33091	2986	3011505	1990-10-30	1990-10-30 00:00:00	1990-10-30	5001	0	\N	0	0	\N	\N	0	199301	0	19926-5	3011505		
6347	601	3006322	1984-08-09	1984-08-09 00:00:00	1984-08-09	5001	0	\N	0	0	\N	\N	0	39656	0	8331-1	3006322		
7116	685	3006322	1988-01-31	1988-01-31 00:00:00	1988-01-31	5001	0	\N	0	0	\N	\N	0	45278	0	8331-1	3006322		
40964	3799	3006322	1999-10-29	1999-10-29 00:00:00	1999-10-29	5001	0	\N	0	0	\N	\N	0	252533	0	8331-1	3006322		
3772	117	4052083	2015-01-21	2015-01-21 00:00:00	2015-01-21	5001	0	\N	0	0	\N	\N	0	7778	0	23426006	4052083		
29920	2757	3006322	2000-07-25	2000-07-25 00:00:00	2000-07-25	5001	0	\N	0	0	\N	\N	0	182370	0	8331-1	3006322		
6781	211	4024958	1998-05-14	1998-05-14 00:00:00	1998-05-14	5001	0	\N	0	0	\N	\N	0	14353	0	117015009	4024958		
47589	4373	3014599	1976-07-18	1976-07-18 00:00:00	1976-07-18	5001	0	\N	0	0	\N	\N	0	290341	0	6106-9	3014599		
41413	3859	40766240	1989-12-23	1989-12-23 00:00:00	1989-12-23	5001	0	\N	0	0	\N	\N	0	256177	0	63513-6	40766240		
14431	1352	3006322	1951-09-21	1951-09-21 00:00:00	1951-09-21	5001	0	\N	0	0	\N	\N	0	89536	0	8331-1	3006322		
16362	1490	3049273	1993-01-10	1993-01-10 00:00:00	1993-01-10	5001	0	\N	0	0	\N	\N	0	99306	0	38265-5	3049273		
52955	4865	3006322	1991-08-12	1991-08-12 00:00:00	1991-08-12	5001	0	\N	0	0	\N	\N	0	323506	0	8331-1	3006322		
170176	5222	4133840	1999-01-14	1999-01-14 00:00:00	1999-01-14	5001	0	\N	0	0	\N	\N	0	347528	0	127783003	4133840		
3382	331	3015632	1997-04-18	1997-04-18 00:00:00	1997-04-18	5001	0	\N	0	0	\N	\N	0	21811	0	2028-9	3015632		
41154	3832	3001247	1984-11-17	1984-11-17 00:00:00	1984-11-17	5001	0	\N	0	0	\N	\N	0	254407	0	6085-5	3001247		
48746	4452	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	296214	0	6106-9	3014599		
50695	4623	3000876	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	307872	0	6082-2	3000876		
34244	3118	3021226	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	207486	0	6246-3	3021226		
34310	3128	3027231	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	208224	0	6276-0	3027231		
96403	2953	4024958	2012-08-10	2012-08-10 00:00:00	2012-08-10	5001	0	\N	0	0	\N	\N	0	197110	0	117015009	4024958		
164348	5048	4052083	1978-01-22	1978-01-22 00:00:00	1978-01-22	5001	0	\N	0	0	\N	\N	0	335471	0	23426006	4052083		
171252	5253	4133840	2010-01-02	2010-01-02 00:00:00	2010-01-02	5001	0	\N	0	0	\N	\N	0	349568	0	127783003	4133840		
45605	4205	3021226	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	279249	0	6246-3	3021226		
43994	1355	4052083	1965-11-28	1965-11-28 00:00:00	1965-11-28	5001	0	\N	0	0	\N	\N	0	89851	0	23426006	4052083		
136386	4204	4024958	1962-10-29	1962-10-29 00:00:00	1962-10-29	5001	0	\N	0	0	\N	\N	0	279113	0	117015009	4024958		
50131	4570	3006322	2009-08-28	2009-08-28 00:00:00	2009-08-28	5001	0	\N	0	0	\N	\N	0	304432	0	8331-1	3006322		
5472	520	3006322	2012-06-28	2012-06-28 00:00:00	2012-06-28	5001	0	\N	0	0	\N	\N	0	34731	0	8331-1	3006322		
104058	3200	4024958	1950-01-05	1950-01-05 00:00:00	1950-01-05	5001	0	\N	0	0	\N	\N	0	212788	0	117015009	4024958		
43524	4026	3001488	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	267711	0	7258-7	3001488		
25398	2334	3011505	1982-05-27	1982-05-27 00:00:00	1982-05-27	5001	0	\N	0	0	\N	\N	0	155298	0	19926-5	3011505		
28285	2611	3006322	2008-08-26	2008-08-26 00:00:00	2008-08-26	5001	0	\N	0	0	\N	\N	0	172669	0	8331-1	3006322		
15640	1431	3014599	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	95274	0	6106-9	3014599		
8724	842	3011505	1968-11-02	1968-11-02 00:00:00	1968-11-02	5001	0	\N	0	0	\N	\N	0	55730	0	19926-5	3011505		
49267	4500	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	299570	0	6273-7	3006451		
49339	4505	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	299977	0	6085-5	3001247		
31553	2891	3014599	1975-04-27	1975-04-27 00:00:00	1975-04-27	5001	0	\N	0	0	\N	\N	0	192353	0	6106-9	3014599		
31635	2895	3027231	1986-01-09	1986-01-09 00:00:00	1986-01-09	5001	0	\N	0	0	\N	\N	0	192693	0	6276-0	3027231		
53109	4881	3006322	1957-02-27	1957-02-27 00:00:00	1957-02-27	5001	0	\N	0	0	\N	\N	0	324524	0	8331-1	3006322		
43045	3976	46235214	1964-06-16	1964-06-16 00:00:00	1964-06-16	5001	0	\N	0	0	\N	\N	0	264380	0	76690-7	46235214		
6118	573	3006322	2008-04-19	2008-04-19 00:00:00	2008-04-19	5001	0	\N	0	0	\N	\N	0	38002	0	8331-1	3006322		
51070	4661	3006322	1986-06-26	1986-06-26 00:00:00	1986-06-26	5001	0	\N	0	0	\N	\N	0	310708	0	8331-1	3006322		
1179	96	3011505	1988-03-12	1988-03-12 00:00:00	1988-03-12	5001	0	\N	0	0	\N	\N	0	6482	0	19926-5	3011505		
17638	1605	3006322	1950-08-15	1950-08-15 00:00:00	1950-08-15	5001	0	\N	0	0	\N	\N	0	107694	0	8331-1	3006322		
34643	3172	3006322	1997-02-15	1997-02-15 00:00:00	1997-02-15	5001	0	\N	0	0	\N	\N	0	210835	0	8331-1	3006322		
4926	152	4052083	2010-09-23	2010-09-23 00:00:00	2010-09-23	5001	0	\N	0	0	\N	\N	0	10268	0	23426006	4052083		
40480	3759	3006322	1997-01-02	1997-01-02 00:00:00	1997-01-02	5001	0	\N	0	0	\N	\N	0	249974	0	8331-1	3006322		
89493	2770	4024958	1938-11-18	1938-11-18 00:00:00	1938-11-18	5001	0	\N	0	0	\N	\N	0	183363	0	117015009	4024958		
17285	1571	3006322	1991-07-04	1991-07-04 00:00:00	1991-07-04	5001	0	\N	0	0	\N	\N	0	105500	0	8331-1	3006322		
73992	2273	4024958	1994-06-04	1994-06-04 00:00:00	1994-06-04	5001	0	\N	0	0	\N	\N	0	151115	0	117015009	4024958		
52710	4843	3049273	1974-06-17	1974-06-17 00:00:00	1974-06-17	5001	0	\N	0	0	\N	\N	0	322106	0	38265-5	3049273		
47054	4338	3006322	2011-10-09	2011-10-09 00:00:00	2011-10-09	5001	0	\N	0	0	\N	\N	0	287675	0	8331-1	3006322		
77090	2359	4052083	1927-12-03	1927-12-03 00:00:00	1927-12-03	5001	0	\N	0	0	\N	\N	0	157175	0	23426006	4052083		
20825	1917	3006322	1984-03-01	1984-03-01 00:00:00	1984-03-01	5001	0	\N	0	0	\N	\N	0	127522	0	8331-1	3006322		
20867	1923	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	127936	0	7258-7	3001488		
4052	404	3019406	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	26607	0	6158-0	3019406		
51979	1572	4024958	1997-06-10	1997-06-10 00:00:00	1997-06-10	5001	0	\N	0	0	\N	\N	0	105559	0	117015009	4024958		
9780	918	3006322	1917-08-20	1917-08-20 00:00:00	1917-08-20	5001	0	\N	0	0	\N	\N	0	61119	0	8331-1	3006322		
10172	970	3006322	1985-09-14	1985-09-14 00:00:00	1985-09-14	5001	0	\N	0	0	\N	\N	0	64520	0	8331-1	3006322		
6617	621	40758406	1973-01-03	1973-01-03 00:00:00	1973-01-03	5001	0	\N	0	0	\N	\N	0	41473	0	55277-8	40758406		
17973	1634	3006322	1948-08-05	1948-08-05 00:00:00	1948-08-05	5001	0	\N	0	0	\N	\N	0	109724	0	8331-1	3006322		
23066	2119	3006322	1989-06-04	1989-06-04 00:00:00	1989-06-04	5001	0	\N	0	0	\N	\N	0	141056	0	8331-1	3006322		
34476	3147	3011505	2017-06-05	2017-06-05 00:00:00	2017-06-05	5001	0	\N	0	0	\N	\N	0	209412	0	19926-5	3011505		
33092	2986	3011505	2006-02-21	2006-02-21 00:00:00	2006-02-21	5001	0	\N	0	0	\N	\N	0	199295	0	19926-5	3011505		
6348	601	3006451	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	39759	0	6273-7	3006451		
7117	685	3006322	1982-05-18	1982-05-18 00:00:00	1982-05-18	5001	0	\N	0	0	\N	\N	0	45300	0	8331-1	3006322		
40965	3799	3006322	2013-12-26	2013-12-26 00:00:00	2013-12-26	5001	0	\N	0	0	\N	\N	0	252591	0	8331-1	3006322		
3781	117	4024958	1969-10-03	1969-10-03 00:00:00	1969-10-03	5001	0	\N	0	0	\N	\N	0	7774	0	117015009	4024958		
29921	2758	3006322	1976-06-24	1976-06-24 00:00:00	1976-06-24	5001	0	\N	0	0	\N	\N	0	182435	0	8331-1	3006322		
6783	211	4024958	1972-11-16	1972-11-16 00:00:00	1972-11-16	5001	0	\N	0	0	\N	\N	0	14372	0	117015009	4024958		
47590	4373	3006734	1976-07-18	1976-07-18 00:00:00	1976-07-18	5001	0	\N	0	0	\N	\N	0	290341	0	6189-5	3006734		
41415	3859	46235214	1989-12-23	1989-12-23 00:00:00	1989-12-23	5001	0	\N	0	0	\N	\N	0	256177	0	76690-7	46235214		
14432	1352	3011505	1996-08-25	1996-08-25 00:00:00	1996-08-25	5001	0	\N	0	0	\N	\N	0	89571	0	19926-5	3011505		
16363	1490	3006322	1953-08-19	1953-08-19 00:00:00	1953-08-19	5001	0	\N	0	0	\N	\N	0	99380	0	8331-1	3006322		
52956	4865	3006322	1991-10-26	1991-10-26 00:00:00	1991-10-26	5001	0	\N	0	0	\N	\N	0	323545	0	8331-1	3006322		
170179	5222	4133840	2006-02-23	2006-02-23 00:00:00	2006-02-23	5001	0	\N	0	0	\N	\N	0	347467	0	127783003	4133840		
3383	331	3002385	1997-04-18	1997-04-18 00:00:00	1997-04-18	5001	0	\N	0	0	\N	\N	0	21811	0	30385-9	3002385		
41155	3832	3020655	1984-11-17	1984-11-17 00:00:00	1984-11-17	5001	0	\N	0	0	\N	\N	0	254407	0	6844-5	3020655		
48747	4452	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	296214	0	6276-0	3027231		
50696	4623	3023430	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	307872	0	6833-8	3023430		
34245	3118	3019406	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	207486	0	6158-0	3019406		
34311	3128	3000876	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	208224	0	6082-2	3000876		
96405	2953	4024958	1988-05-17	1988-05-17 00:00:00	1988-05-17	5001	0	\N	0	0	\N	\N	0	197122	0	117015009	4024958		
153959	4722	4052083	1967-02-05	1967-02-05 00:00:00	1967-02-05	5001	0	\N	0	0	\N	\N	0	314575	0	23426006	4052083		
171254	5253	4133840	1995-12-16	1995-12-16 00:00:00	1995-12-16	5001	0	\N	0	0	\N	\N	0	349508	0	127783003	4133840		
45606	4205	3023430	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	279249	0	6833-8	3023430		
43997	1355	4052083	1971-12-24	1971-12-24 00:00:00	1971-12-24	5001	0	\N	0	0	\N	\N	0	89839	0	23426006	4052083		
147689	4527	4024958	1988-04-27	1988-04-27 00:00:00	1988-04-27	5001	0	\N	0	0	\N	\N	0	301428	0	117015009	4024958		
50132	4570	3006322	2008-04-25	2008-04-25 00:00:00	2008-04-25	5001	0	\N	0	0	\N	\N	0	304430	0	8331-1	3006322		
5473	520	40758406	1952-02-07	1952-02-07 00:00:00	1952-02-07	5001	0	\N	0	0	\N	\N	0	34693	0	55277-8	40758406		
104060	3200	4024958	1980-01-05	1980-01-05 00:00:00	1980-01-05	5001	0	\N	0	0	\N	\N	0	212791	0	117015009	4024958		
43525	4026	3001247	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	267711	0	6085-5	3001247		
25399	2334	3011505	1991-02-28	1991-02-28 00:00:00	1991-02-28	5001	0	\N	0	0	\N	\N	0	155358	0	19926-5	3011505		
28286	2611	3006322	2002-03-15	2002-03-15 00:00:00	2002-03-15	5001	0	\N	0	0	\N	\N	0	172668	0	8331-1	3006322		
15641	1431	3049273	2018-11-08	2018-11-08 00:00:00	2018-11-08	5001	0	\N	0	0	\N	\N	0	95254	0	38265-5	3049273		
8725	842	3011505	1949-12-03	1949-12-03 00:00:00	1949-12-03	5001	0	\N	0	0	\N	\N	0	55756	0	19926-5	3011505		
49268	4500	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	299570	0	6106-9	3014599		
49340	4505	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	299977	0	6248-9	3015076		
31554	2891	3006451	1975-04-27	1975-04-27 00:00:00	1975-04-27	5001	0	\N	0	0	\N	\N	0	192353	0	6273-7	3006451		
31636	2895	3015076	1986-01-09	1986-01-09 00:00:00	1986-01-09	5001	0	\N	0	0	\N	\N	0	192693	0	6248-9	3015076		
31660	2896	3023430	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	192836	0	6833-8	3023430		
43046	3976	40758406	1964-06-16	1964-06-16 00:00:00	1964-06-16	5001	0	\N	0	0	\N	\N	0	264380	0	55277-8	40758406		
6119	573	3006322	1963-08-24	1963-08-24 00:00:00	1963-08-24	5001	0	\N	0	0	\N	\N	0	37968	0	8331-1	3006322		
51071	4662	3006322	1958-01-16	1958-01-16 00:00:00	1958-01-16	5001	0	\N	0	0	\N	\N	0	310785	0	8331-1	3006322		
1181	96	3006322	1985-08-26	1985-08-26 00:00:00	1985-08-26	5001	0	\N	0	0	\N	\N	0	6470	0	8331-1	3006322		
17639	1605	3006322	1991-03-22	1991-03-22 00:00:00	1991-03-22	5001	0	\N	0	0	\N	\N	0	107669	0	8331-1	3006322		
34644	3172	3006322	1985-08-21	1985-08-21 00:00:00	1985-08-21	5001	0	\N	0	0	\N	\N	0	210868	0	8331-1	3006322		
4928	152	4024958	1998-10-22	1998-10-22 00:00:00	1998-10-22	5001	0	\N	0	0	\N	\N	0	10252	0	117015009	4024958		
40481	3759	3006322	1978-09-13	1978-09-13 00:00:00	1978-09-13	5001	0	\N	0	0	\N	\N	0	249935	0	8331-1	3006322		
100810	3096	4024958	2016-07-11	2016-07-11 00:00:00	2016-07-11	5001	0	\N	0	0	\N	\N	0	206094	0	117015009	4024958		
17286	1571	3006322	1988-06-10	1988-06-10 00:00:00	1988-06-10	5001	0	\N	0	0	\N	\N	0	105468	0	8331-1	3006322		
24230	757	4024958	1964-01-04	1964-01-04 00:00:00	1964-01-04	5001	0	\N	0	0	\N	\N	0	50192	0	117015009	4024958		
52711	4843	3006322	1981-12-22	1981-12-22 00:00:00	1981-12-22	5001	0	\N	0	0	\N	\N	0	322150	0	8331-1	3006322		
47058	4340	3006322	1973-06-23	1973-06-23 00:00:00	1973-06-23	5001	0	\N	0	0	\N	\N	0	287774	0	8331-1	3006322		
77097	2359	4024958	1926-10-10	1926-10-10 00:00:00	1926-10-10	5001	0	\N	0	0	\N	\N	0	157268	0	117015009	4024958		
20826	1917	3006322	1986-07-30	1986-07-30 00:00:00	1986-07-30	5001	0	\N	0	0	\N	\N	0	127541	0	8331-1	3006322		
20868	1923	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	127936	0	6085-5	3001247		
4053	404	3006322	2002-01-06	2002-01-06 00:00:00	2002-01-06	5001	0	\N	0	0	\N	\N	0	26592	0	8331-1	3006322		
51980	1572	4024958	2018-09-27	2018-09-27 00:00:00	2018-09-27	5001	0	\N	0	0	\N	\N	0	105560	0	117015009	4024958		
9781	918	3006322	1962-01-07	1962-01-07 00:00:00	1962-01-07	5001	0	\N	0	0	\N	\N	0	61128	0	8331-1	3006322		
10173	970	3006322	1997-03-10	1997-03-10 00:00:00	1997-03-10	5001	0	\N	0	0	\N	\N	0	64521	0	8331-1	3006322		
6619	621	46235214	1973-01-03	1973-01-03 00:00:00	1973-01-03	5001	0	\N	0	0	\N	\N	0	41473	0	76690-7	46235214		
17974	1635	3006322	2019-05-01	2019-05-01 00:00:00	2019-05-01	5001	0	\N	0	0	\N	\N	0	109804	0	8331-1	3006322		
23067	2119	40769184	1983-06-18	1983-06-18 00:00:00	1983-06-18	5001	0	\N	0	0	\N	\N	0	140964	0	66524-0	40769184		
34477	3147	3006322	1962-10-04	1962-10-04 00:00:00	1962-10-04	5001	0	\N	0	0	\N	\N	0	209359	0	8331-1	3006322		
33093	2986	3011505	1996-12-31	1996-12-31 00:00:00	1996-12-31	5001	0	\N	0	0	\N	\N	0	199293	0	19926-5	3011505		
6349	601	3005136	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	39759	0	6075-6	3005136		
7118	686	3006322	2002-06-18	2002-06-18 00:00:00	2002-06-18	5001	0	\N	0	0	\N	\N	0	45399	0	8331-1	3006322		
40966	3799	3006322	1978-03-22	1978-03-22 00:00:00	1978-03-22	5001	0	\N	0	0	\N	\N	0	252571	0	8331-1	3006322		
3806	119	4024958	1962-09-30	1962-09-30 00:00:00	1962-09-30	5001	0	\N	0	0	\N	\N	0	7895	0	117015009	4024958		
29922	2758	3006322	1975-08-19	1975-08-19 00:00:00	1975-08-19	5001	0	\N	0	0	\N	\N	0	182488	0	8331-1	3006322		
29976	2764	3000963	2015-08-14	2015-08-14 00:00:00	2015-08-14	5001	0	\N	0	0	\N	\N	0	182791	0	718-7	3000963		
47591	4373	3001488	1976-07-18	1976-07-18 00:00:00	1976-07-18	5001	0	\N	0	0	\N	\N	0	290341	0	7258-7	3001488		
41417	3859	40758406	1989-12-23	1989-12-23 00:00:00	1989-12-23	5001	0	\N	0	0	\N	\N	0	256177	0	55277-8	40758406		
14433	1352	3011505	2000-03-26	2000-03-26 00:00:00	2000-03-26	5001	0	\N	0	0	\N	\N	0	89576	0	19926-5	3011505		
16364	1490	3049273	2018-10-01	2018-10-01 00:00:00	2018-10-01	5001	0	\N	0	0	\N	\N	0	99329	0	38265-5	3049273		
52961	4867	3006322	1965-10-14	1965-10-14 00:00:00	1965-10-14	5001	0	\N	0	0	\N	\N	0	323681	0	8331-1	3006322		
170184	5222	4133840	1998-01-08	1998-01-08 00:00:00	1998-01-08	5001	0	\N	0	0	\N	\N	0	347464	0	127783003	4133840		
3384	331	3014576	1997-04-18	1997-04-18 00:00:00	1997-04-18	5001	0	\N	0	0	\N	\N	0	21811	0	2075-0	3014576		
41156	3832	3005136	1984-11-17	1984-11-17 00:00:00	1984-11-17	5001	0	\N	0	0	\N	\N	0	254407	0	6075-6	3005136		
48748	4452	3006322	1955-11-03	1955-11-03 00:00:00	1955-11-03	5001	0	\N	0	0	\N	\N	0	296242	0	8331-1	3006322		
50697	4623	3006734	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	307872	0	6189-5	3006734		
34246	3118	3000876	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	207486	0	6082-2	3000876		
34312	3128	3001488	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	208224	0	7258-7	3001488		
96407	2953	4052083	2002-03-20	2002-03-20 00:00:00	2002-03-20	5001	0	\N	0	0	\N	\N	0	197125	0	23426006	4052083		
153964	4722	4052083	1941-02-23	1941-02-23 00:00:00	1941-02-23	5001	0	\N	0	0	\N	\N	0	314499	0	23426006	4052083		
171255	5253	4133840	1991-10-26	1991-10-26 00:00:00	1991-10-26	5001	0	\N	0	0	\N	\N	0	349510	0	127783003	4133840		
45607	4205	3009542	1995-01-02	1995-01-02 00:00:00	1995-01-02	5001	0	\N	0	0	\N	\N	0	279207	0	20570-8	3009542		
44003	1355	4024958	1987-07-02	1987-07-02 00:00:00	1987-07-02	5001	0	\N	0	0	\N	\N	0	89778	0	117015009	4024958		
147692	4527	4052083	2012-03-21	2012-03-21 00:00:00	2012-03-21	5001	0	\N	0	0	\N	\N	0	301416	0	23426006	4052083		
50133	4570	3006322	1938-02-18	1938-02-18 00:00:00	1938-02-18	5001	0	\N	0	0	\N	\N	0	304508	0	8331-1	3006322		
51531	4719	3020655	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	314267	0	6844-5	3020655		
50608	4615	3006322	2002-06-21	2002-06-21 00:00:00	2002-06-21	5001	0	\N	0	0	\N	\N	0	307454	0	8331-1	3006322		
43526	4026	3000876	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	267711	0	6082-2	3000876		
25400	2334	3011505	1976-05-13	1976-05-13 00:00:00	1976-05-13	5001	0	\N	0	0	\N	\N	0	155335	0	19926-5	3011505		
28303	2613	3006322	2004-10-29	2004-10-29 00:00:00	2004-10-29	5001	0	\N	0	0	\N	\N	0	172775	0	8331-1	3006322		
15642	1431	3006322	1961-01-05	1961-01-05 00:00:00	1961-01-05	5001	0	\N	0	0	\N	\N	0	95286	0	8331-1	3006322		
8726	842	3011505	1987-04-18	1987-04-18 00:00:00	1987-04-18	5001	0	\N	0	0	\N	\N	0	55695	0	19926-5	3011505		
119954	3698	4024958	1954-08-18	1954-08-18 00:00:00	1954-08-18	5001	0	\N	0	0	\N	\N	0	245852	0	117015009	4024958		
49341	4505	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	299977	0	6246-3	3021226		
31555	2891	3020655	1975-04-27	1975-04-27 00:00:00	1975-04-27	5001	0	\N	0	0	\N	\N	0	192353	0	6844-5	3020655		
31637	2895	3014599	1986-01-09	1986-01-09 00:00:00	1986-01-09	5001	0	\N	0	0	\N	\N	0	192693	0	6106-9	3014599		
31661	2896	3001247	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	192836	0	6085-5	3001247		
43048	3976	40766240	1964-06-16	1964-06-16 00:00:00	1964-06-16	5001	0	\N	0	0	\N	\N	0	264380	0	63513-6	40766240		
6120	573	3006322	1998-10-28	1998-10-28 00:00:00	1998-10-28	5001	0	\N	0	0	\N	\N	0	38001	0	8331-1	3006322		
51072	4662	3006322	1976-02-11	1976-02-11 00:00:00	1976-02-11	5001	0	\N	0	0	\N	\N	0	310788	0	8331-1	3006322		
1182	96	3006322	1947-09-22	1947-09-22 00:00:00	1947-09-22	5001	0	\N	0	0	\N	\N	0	6550	0	8331-1	3006322		
17640	1605	3049273	2011-06-01	2011-06-01 00:00:00	2011-06-01	5001	0	\N	0	0	\N	\N	0	107751	0	38265-5	3049273		
34645	3172	3006322	1977-07-23	1977-07-23 00:00:00	1977-07-23	5001	0	\N	0	0	\N	\N	0	210833	0	8331-1	3006322		
4943	152	4024958	2017-01-26	2017-01-26 00:00:00	2017-01-26	5001	0	\N	0	0	\N	\N	0	10270	0	117015009	4024958		
40482	3759	3006322	2005-09-01	2005-09-01 00:00:00	2005-09-01	5001	0	\N	0	0	\N	\N	0	249926	0	8331-1	3006322		
100820	3096	4024958	1968-05-02	1968-05-02 00:00:00	1968-05-02	5001	0	\N	0	0	\N	\N	0	206100	0	117015009	4024958		
17287	1571	3006322	2003-02-12	2003-02-12 00:00:00	2003-02-12	5001	0	\N	0	0	\N	\N	0	105511	0	8331-1	3006322		
24238	757	4024958	1942-02-03	1942-02-03 00:00:00	1942-02-03	5001	0	\N	0	0	\N	\N	0	50208	0	117015009	4024958		
52712	4843	3006322	2001-02-18	2001-02-18 00:00:00	2001-02-18	5001	0	\N	0	0	\N	\N	0	322154	0	8331-1	3006322		
47059	4340	3006322	1985-04-16	1985-04-16 00:00:00	1985-04-16	5001	0	\N	0	0	\N	\N	0	287775	0	8331-1	3006322		
83234	2570	4052083	1936-10-17	1936-10-17 00:00:00	1936-10-17	5001	0	\N	0	0	\N	\N	0	170192	0	23426006	4052083		
20827	1917	3006322	1953-03-15	1953-03-15 00:00:00	1953-03-15	5001	0	\N	0	0	\N	\N	0	127525	0	8331-1	3006322		
20869	1923	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	127936	0	6189-5	3006734		
4054	404	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	26618	0	6248-9	3015076		
51998	1572	4052083	2016-07-27	2016-07-27 00:00:00	2016-07-27	5001	0	\N	0	0	\N	\N	0	105579	0	23426006	4052083		
9782	918	3006322	2001-04-28	2001-04-28 00:00:00	2001-04-28	5001	0	\N	0	0	\N	\N	0	61131	0	8331-1	3006322		
10174	970	3006322	2010-05-23	2010-05-23 00:00:00	2010-05-23	5001	0	\N	0	0	\N	\N	0	64485	0	8331-1	3006322		
6621	621	40766240	1973-01-03	1973-01-03 00:00:00	1973-01-03	5001	0	\N	0	0	\N	\N	0	41473	0	63513-6	40766240		
17975	1635	3006322	1983-03-29	1983-03-29 00:00:00	1983-03-29	5001	0	\N	0	0	\N	\N	0	109819	0	8331-1	3006322		
23068	2119	40769189	1983-06-18	1983-06-18 00:00:00	1983-06-18	5001	0	\N	0	0	\N	\N	0	140964	0	66529-9	40769189		
34478	3147	3006322	1955-08-20	1955-08-20 00:00:00	1955-08-20	5001	0	\N	0	0	\N	\N	0	209370	0	8331-1	3006322		
33094	2987	3006322	1992-10-01	1992-10-01 00:00:00	1992-10-01	5001	0	\N	0	0	\N	\N	0	199413	0	8331-1	3006322		
6350	601	3015076	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	39759	0	6248-9	3015076		
7119	686	3006322	1960-08-28	1960-08-28 00:00:00	1960-08-28	5001	0	\N	0	0	\N	\N	0	45395	0	8331-1	3006322		
52269	4804	3051031	1983-09-16	1983-09-16 00:00:00	1983-09-16	5001	0	\N	0	0	\N	\N	0	319633	0	46240-8	3051031		
3807	119	4024958	1958-11-08	1958-11-08 00:00:00	1958-11-08	5001	0	\N	0	0	\N	\N	0	7882	0	117015009	4024958		
29923	2758	3006322	1954-11-16	1954-11-16 00:00:00	1954-11-16	5001	0	\N	0	0	\N	\N	0	182434	0	8331-1	3006322		
29977	2764	3009542	2015-08-14	2015-08-14 00:00:00	2015-08-14	5001	0	\N	0	0	\N	\N	0	182791	0	20570-8	3009542		
47592	4373	3001247	1976-07-18	1976-07-18 00:00:00	1976-07-18	5001	0	\N	0	0	\N	\N	0	290341	0	6085-5	3001247		
41418	3859	3006322	1974-02-13	1974-02-13 00:00:00	1974-02-13	5001	0	\N	0	0	\N	\N	0	256244	0	8331-1	3006322		
14434	1352	3006322	1996-10-09	1996-10-09 00:00:00	1996-10-09	5001	0	\N	0	0	\N	\N	0	89594	0	8331-1	3006322		
16365	1490	3006322	1999-04-18	1999-04-18 00:00:00	1999-04-18	5001	0	\N	0	0	\N	\N	0	99352	0	8331-1	3006322		
52962	4867	3006322	1962-12-18	1962-12-18 00:00:00	1962-12-18	5001	0	\N	0	0	\N	\N	0	323708	0	8331-1	3006322		
170185	5222	4024958	1962-05-09	1962-05-09 00:00:00	1962-05-09	5001	0	\N	0	0	\N	\N	0	347354	0	117015009	4024958		
3385	331	3035995	1997-04-18	1997-04-18 00:00:00	1997-04-18	5001	0	\N	0	0	\N	\N	0	21811	0	6768-6	3035995		
41157	3832	3015076	1984-11-17	1984-11-17 00:00:00	1984-11-17	5001	0	\N	0	0	\N	\N	0	254407	0	6248-9	3015076		
48749	4454	3049273	2018-02-23	2018-02-23 00:00:00	2018-02-23	5001	0	\N	0	0	\N	\N	0	296460	0	38265-5	3049273		
50698	4623	3005136	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	307872	0	6075-6	3005136		
34247	3118	3036780	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	207486	0	6095-4	3036780		
34313	3128	3020655	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	208224	0	6844-5	3020655		
37670	3477	3001488	1986-04-20	1986-04-20 00:00:00	1986-04-20	5001	0	\N	0	0	\N	\N	0	230612	0	7258-7	3001488		
16205	1478	3006322	1961-10-19	1961-10-19 00:00:00	1961-10-19	5001	0	\N	0	0	\N	\N	0	98621	0	8331-1	3006322		
171256	5253	4024958	1990-11-03	1990-11-03 00:00:00	1990-11-03	5001	0	\N	0	0	\N	\N	0	349542	0	117015009	4024958		
45608	4205	3000963	1995-01-02	1995-01-02 00:00:00	1995-01-02	5001	0	\N	0	0	\N	\N	0	279207	0	718-7	3000963		
44012	1355	4052083	1995-11-07	1995-11-07 00:00:00	1995-11-07	5001	0	\N	0	0	\N	\N	0	89856	0	23426006	4052083		
147700	4527	4024958	1974-10-12	1974-10-12 00:00:00	1974-10-12	5001	0	\N	0	0	\N	\N	0	301456	0	117015009	4024958		
50134	4570	3006322	2014-02-18	2014-02-18 00:00:00	2014-02-18	5001	0	\N	0	0	\N	\N	0	304433	0	8331-1	3006322		
51532	4719	3023430	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	314267	0	6833-8	3023430		
50609	4615	3006322	2003-01-02	2003-01-02 00:00:00	2003-01-02	5001	0	\N	0	0	\N	\N	0	307424	0	8331-1	3006322		
43527	4026	3020655	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	267711	0	6844-5	3020655		
25401	2334	3006322	1975-06-05	1975-06-05 00:00:00	1975-06-05	5001	0	\N	0	0	\N	\N	0	155316	0	8331-1	3006322		
28304	2613	3006322	2018-09-11	2018-09-11 00:00:00	2018-09-11	5001	0	\N	0	0	\N	\N	0	172786	0	8331-1	3006322		
15643	1432	3006322	1991-05-03	1991-05-03 00:00:00	1991-05-03	5001	0	\N	0	0	\N	\N	0	95409	0	8331-1	3006322		
8727	842	3011505	2006-09-02	2006-09-02 00:00:00	2006-09-02	5001	0	\N	0	0	\N	\N	0	55683	0	19926-5	3011505		
119960	3699	4024958	1985-07-16	1985-07-16 00:00:00	1985-07-16	5001	0	\N	0	0	\N	\N	0	245929	0	117015009	4024958		
49342	4505	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	299977	0	6106-9	3014599		
31556	2891	3006734	1975-04-27	1975-04-27 00:00:00	1975-04-27	5001	0	\N	0	0	\N	\N	0	192353	0	6189-5	3006734		
31638	2895	3001488	1986-01-09	1986-01-09 00:00:00	1986-01-09	5001	0	\N	0	0	\N	\N	0	192693	0	7258-7	3001488		
31662	2896	3001488	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	192836	0	7258-7	3001488		
43050	3976	46235214	1966-01-07	1966-01-07 00:00:00	1966-01-07	5001	0	\N	0	0	\N	\N	0	264325	0	76690-7	46235214		
6121	573	3006322	2008-08-28	2008-08-28 00:00:00	2008-08-28	5001	0	\N	0	0	\N	\N	0	37957	0	8331-1	3006322		
51073	4662	3024731	1989-07-27	1989-07-27 00:00:00	1989-07-27	5001	0	\N	0	0	\N	\N	0	310773	0	30428-7	3024731		
1183	96	3011505	1976-01-03	1976-01-03 00:00:00	1976-01-03	5001	0	\N	0	0	\N	\N	0	6490	0	19926-5	3011505		
17641	1606	3006322	1957-08-24	1957-08-24 00:00:00	1957-08-24	5001	0	\N	0	0	\N	\N	0	107873	0	8331-1	3006322		
34646	3172	3006322	2016-09-17	2016-09-17 00:00:00	2016-09-17	5001	0	\N	0	0	\N	\N	0	210862	0	8331-1	3006322		
4945	152	4024958	1969-09-16	1969-09-16 00:00:00	1969-09-16	5001	0	\N	0	0	\N	\N	0	10226	0	117015009	4024958		
40483	3759	40769184	1983-08-18	1983-08-18 00:00:00	1983-08-18	5001	0	\N	0	0	\N	\N	0	249936	0	66524-0	40769184		
53565	4917	3006322	1991-01-22	1991-01-22 00:00:00	1991-01-22	5001	0	\N	0	0	\N	\N	0	326757	0	8331-1	3006322		
17288	1572	3006322	1991-04-02	1991-04-02 00:00:00	1991-04-02	5001	0	\N	0	0	\N	\N	0	105608	0	8331-1	3006322		
24239	757	4052083	1940-10-09	1940-10-09 00:00:00	1940-10-09	5001	0	\N	0	0	\N	\N	0	50207	0	23426006	4052083		
52713	4844	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	322296	0	6158-0	3019406		
47060	4340	3006322	2003-02-07	2003-02-07 00:00:00	2003-02-07	5001	0	\N	0	0	\N	\N	0	287749	0	8331-1	3006322		
94514	2905	4024958	1971-08-19	1971-08-19 00:00:00	1971-08-19	5001	0	\N	0	0	\N	\N	0	193554	0	117015009	4024958		
20828	1917	3006322	1959-06-27	1959-06-27 00:00:00	1959-06-27	5001	0	\N	0	0	\N	\N	0	127561	0	8331-1	3006322		
20870	1923	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	127936	0	6095-4	3036780		
4055	404	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	26618	0	6276-0	3027231		
52002	1572	4024958	1991-04-02	1991-04-02 00:00:00	1991-04-02	5001	0	\N	0	0	\N	\N	0	105608	0	117015009	4024958		
9784	919	3006322	1974-10-13	1974-10-13 00:00:00	1974-10-13	5001	0	\N	0	0	\N	\N	0	61251	0	8331-1	3006322		
10175	970	3006322	1982-11-18	1982-11-18 00:00:00	1982-11-18	5001	0	\N	0	0	\N	\N	0	64483	0	8331-1	3006322		
6622	621	3051031	1972-10-05	1972-10-05 00:00:00	1972-10-05	5001	0	\N	0	0	\N	\N	0	41472	0	46240-8	3051031		
17976	1636	3006322	1966-12-07	1966-12-07 00:00:00	1966-12-07	5001	0	\N	0	0	\N	\N	0	109897	0	8331-1	3006322		
23069	2119	40769194	1983-06-18	1983-06-18 00:00:00	1983-06-18	5001	0	\N	0	0	\N	\N	0	140964	0	66534-9	40769194		
34479	3147	3011505	2003-03-17	2003-03-17 00:00:00	2003-03-17	5001	0	\N	0	0	\N	\N	0	209366	0	19926-5	3011505		
33095	2987	3006322	1989-11-30	1989-11-30 00:00:00	1989-11-30	5001	0	\N	0	0	\N	\N	0	199403	0	8331-1	3006322		
6351	601	3012494	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	39759	0	6206-7	3012494		
7120	686	3006322	1979-06-05	1979-06-05 00:00:00	1979-06-05	5001	0	\N	0	0	\N	\N	0	45379	0	8331-1	3006322		
52270	4804	46235214	1983-09-16	1983-09-16 00:00:00	1983-09-16	5001	0	\N	0	0	\N	\N	0	319633	0	76690-7	46235214		
3810	119	4024958	1956-03-29	1956-03-29 00:00:00	1956-03-29	5001	0	\N	0	0	\N	\N	0	7863	0	117015009	4024958		
29924	2758	3006322	1979-12-26	1979-12-26 00:00:00	1979-12-26	5001	0	\N	0	0	\N	\N	0	182489	0	8331-1	3006322		
29978	2765	3011505	2010-11-23	2010-11-23 00:00:00	2010-11-23	5001	0	\N	0	0	\N	\N	0	182835	0	19926-5	3011505		
47593	4373	3000876	1976-07-18	1976-07-18 00:00:00	1976-07-18	5001	0	\N	0	0	\N	\N	0	290341	0	6082-2	3000876		
41419	3859	40758406	1989-11-23	1989-11-23 00:00:00	1989-11-23	5001	0	\N	0	0	\N	\N	0	256272	0	55277-8	40758406		
14435	1352	3011505	2017-01-22	2017-01-22 00:00:00	2017-01-22	5001	0	\N	0	0	\N	\N	0	89547	0	19926-5	3011505		
16366	1491	3006322	1970-12-28	1970-12-28 00:00:00	1970-12-28	5001	0	\N	0	0	\N	\N	0	99410	0	8331-1	3006322		
52963	4867	3006322	1960-02-19	1960-02-19 00:00:00	1960-02-19	5001	0	\N	0	0	\N	\N	0	323607	0	8331-1	3006322		
170186	5222	4133840	2005-02-17	2005-02-17 00:00:00	2005-02-17	5001	0	\N	0	0	\N	\N	0	347425	0	127783003	4133840		
3386	331	3006906	1997-04-18	1997-04-18 00:00:00	1997-04-18	5001	0	\N	0	0	\N	\N	0	21811	0	17861-6	3006906		
41158	3832	3000876	1984-11-17	1984-11-17 00:00:00	1984-11-17	5001	0	\N	0	0	\N	\N	0	254407	0	6082-2	3000876		
48750	4454	3049273	2007-03-23	2007-03-23 00:00:00	2007-03-23	5001	0	\N	0	0	\N	\N	0	296504	0	38265-5	3049273		
50699	4623	3021226	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	307872	0	6246-3	3021226		
82059	2540	4052083	1991-11-30	1991-11-30 00:00:00	1991-11-30	5001	0	\N	0	0	\N	\N	0	167996	0	23426006	4052083		
34314	3128	3036780	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	208224	0	6095-4	3036780		
37671	3477	3020655	1986-04-20	1986-04-20 00:00:00	1986-04-20	5001	0	\N	0	0	\N	\N	0	230612	0	6844-5	3020655		
16206	1478	3006322	2008-11-10	2008-11-10 00:00:00	2008-11-10	5001	0	\N	0	0	\N	\N	0	98661	0	8331-1	3006322		
171257	5253	4052083	1991-10-18	1991-10-18 00:00:00	1991-10-18	5001	0	\N	0	0	\N	\N	0	349524	0	23426006	4052083		
45609	4205	3006322	1984-12-24	1984-12-24 00:00:00	1984-12-24	5001	0	\N	0	0	\N	\N	0	279165	0	8331-1	3006322		
55314	1679	4052083	2019-02-17	2019-02-17 00:00:00	2019-02-17	5001	0	\N	0	0	\N	\N	0	112593	0	23426006	4052083		
147732	4529	4133840	2011-12-11	2011-12-11 00:00:00	2011-12-11	5001	0	\N	0	0	\N	\N	0	301556	0	127783003	4133840		
50135	4570	3006322	1944-05-03	1944-05-03 00:00:00	1944-05-03	5001	0	\N	0	0	\N	\N	0	304459	0	8331-1	3006322		
51533	4719	3036780	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	314267	0	6095-4	3036780		
50610	4615	3006322	1991-04-03	1991-04-03 00:00:00	1991-04-03	5001	0	\N	0	0	\N	\N	0	307453	0	8331-1	3006322		
43528	4026	3023430	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	267711	0	6833-8	3023430		
25402	2334	3011505	2001-04-26	2001-04-26 00:00:00	2001-04-26	5001	0	\N	0	0	\N	\N	0	155374	0	19926-5	3011505		
28305	2613	3006322	1982-05-03	1982-05-03 00:00:00	1982-05-03	5001	0	\N	0	0	\N	\N	0	172767	0	8331-1	3006322		
15644	1432	3006322	1979-08-22	1979-08-22 00:00:00	1979-08-22	5001	0	\N	0	0	\N	\N	0	95369	0	8331-1	3006322		
8728	842	3011505	2012-10-06	2012-10-06 00:00:00	2012-10-06	5001	0	\N	0	0	\N	\N	0	55701	0	19926-5	3011505		
119968	3699	4024958	2010-01-25	2010-01-25 00:00:00	2010-01-25	5001	0	\N	0	0	\N	\N	0	245898	0	117015009	4024958		
49343	4505	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	299977	0	6158-0	3019406		
3023	94	4052083	1960-10-04	1960-10-04 00:00:00	1960-10-04	5001	0	\N	0	0	\N	\N	0	6315	0	23426006	4052083		
31639	2895	3020655	1986-01-09	1986-01-09 00:00:00	1986-01-09	5001	0	\N	0	0	\N	\N	0	192693	0	6844-5	3020655		
31663	2896	3036780	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	192836	0	6095-4	3036780		
43052	3976	40766240	1966-01-07	1966-01-07 00:00:00	1966-01-07	5001	0	\N	0	0	\N	\N	0	264325	0	63513-6	40766240		
6122	573	3006322	2009-06-09	2009-06-09 00:00:00	2009-06-09	5001	0	\N	0	0	\N	\N	0	37973	0	8331-1	3006322		
51074	4662	3010813	1989-07-27	1989-07-27 00:00:00	1989-07-27	5001	0	\N	0	0	\N	\N	0	310773	0	26464-8	3010813		
1184	96	3011505	1991-03-30	1991-03-30 00:00:00	1991-03-30	5001	0	\N	0	0	\N	\N	0	6483	0	19926-5	3011505		
17642	1606	3006322	1986-11-12	1986-11-12 00:00:00	1986-11-12	5001	0	\N	0	0	\N	\N	0	107847	0	8331-1	3006322		
34647	3172	3006322	1991-09-30	1991-09-30 00:00:00	1991-09-30	5001	0	\N	0	0	\N	\N	0	210860	0	8331-1	3006322		
4947	152	4024958	1976-04-11	1976-04-11 00:00:00	1976-04-11	5001	0	\N	0	0	\N	\N	0	10241	0	117015009	4024958		
40484	3759	40769179	1983-08-18	1983-08-18 00:00:00	1983-08-18	5001	0	\N	0	0	\N	\N	0	249936	0	66519-0	40769179		
53566	4917	3006322	1989-02-16	1989-02-16 00:00:00	1989-02-16	5001	0	\N	0	0	\N	\N	0	326737	0	8331-1	3006322		
17289	1572	3006322	2018-09-27	2018-09-27 00:00:00	2018-09-27	5001	0	\N	0	0	\N	\N	0	105560	0	8331-1	3006322		
24262	757	4024958	1921-08-05	1921-08-05 00:00:00	1921-08-05	5001	0	\N	0	0	\N	\N	0	50204	0	117015009	4024958		
52714	4844	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	322296	0	6075-6	3005136		
47061	4340	3006322	1978-11-03	1978-11-03 00:00:00	1978-11-03	5001	0	\N	0	0	\N	\N	0	287747	0	8331-1	3006322		
94517	2905	4024958	2004-06-16	2004-06-16 00:00:00	2004-06-16	5001	0	\N	0	0	\N	\N	0	193561	0	117015009	4024958		
20829	1918	3006322	2017-01-13	2017-01-13 00:00:00	2017-01-13	5001	0	\N	0	0	\N	\N	0	127653	0	8331-1	3006322		
20871	1923	3006322	1958-12-13	1958-12-13 00:00:00	1958-12-13	5001	0	\N	0	0	\N	\N	0	128002	0	8331-1	3006322		
4056	404	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	26618	0	6273-7	3006451		
52126	1577	4024958	2007-01-10	2007-01-10 00:00:00	2007-01-10	5001	0	\N	0	0	\N	\N	0	105941	0	117015009	4024958		
9785	919	3006322	1992-05-08	1992-05-08 00:00:00	1992-05-08	5001	0	\N	0	0	\N	\N	0	61253	0	8331-1	3006322		
10176	970	3006322	1972-12-11	1972-12-11 00:00:00	1972-12-11	5001	0	\N	0	0	\N	\N	0	64546	0	8331-1	3006322		
6623	621	40758406	1972-10-05	1972-10-05 00:00:00	1972-10-05	5001	0	\N	0	0	\N	\N	0	41472	0	55277-8	40758406		
17977	1636	3049273	2016-04-23	2016-04-23 00:00:00	2016-04-23	5001	0	\N	0	0	\N	\N	0	109885	0	38265-5	3049273		
23070	2119	40769179	1983-06-18	1983-06-18 00:00:00	1983-06-18	5001	0	\N	0	0	\N	\N	0	140964	0	66519-0	40769179		
34480	3147	3011505	2007-04-09	2007-04-09 00:00:00	2007-04-09	5001	0	\N	0	0	\N	\N	0	209348	0	19926-5	3011505		
33096	2987	3006322	1973-07-23	1973-07-23 00:00:00	1973-07-23	5001	0	\N	0	0	\N	\N	0	199402	0	8331-1	3006322		
6352	601	3000876	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	39759	0	6082-2	3000876		
7121	686	3006322	1961-03-05	1961-03-05 00:00:00	1961-03-05	5001	0	\N	0	0	\N	\N	0	45396	0	8331-1	3006322		
52271	4804	3021226	1990-03-26	1990-03-26 00:00:00	1990-03-26	5001	0	\N	0	0	\N	\N	0	319661	0	6246-3	3021226		
3813	119	4024958	1957-02-04	1957-02-04 00:00:00	1957-02-04	5001	0	\N	0	0	\N	\N	0	7864	0	117015009	4024958		
29925	2758	3006322	1947-01-27	1947-01-27 00:00:00	1947-01-27	5001	0	\N	0	0	\N	\N	0	182400	0	8331-1	3006322		
29979	2765	3011505	2011-11-29	2011-11-29 00:00:00	2011-11-29	5001	0	\N	0	0	\N	\N	0	182825	0	19926-5	3011505		
47594	4373	3020655	1976-07-18	1976-07-18 00:00:00	1976-07-18	5001	0	\N	0	0	\N	\N	0	290341	0	6844-5	3020655		
41420	3859	3051031	1989-11-23	1989-11-23 00:00:00	1989-11-23	5001	0	\N	0	0	\N	\N	0	256272	0	46240-8	3051031		
14436	1352	3011505	2008-05-11	2008-05-11 00:00:00	2008-05-11	5001	0	\N	0	0	\N	\N	0	89543	0	19926-5	3011505		
16367	1491	3006322	2008-11-13	2008-11-13 00:00:00	2008-11-13	5001	0	\N	0	0	\N	\N	0	99436	0	8331-1	3006322		
52964	4867	3049273	1987-05-29	1987-05-29 00:00:00	1987-05-29	5001	0	\N	0	0	\N	\N	0	323685	0	38265-5	3049273		
170210	5222	4133840	2000-01-20	2000-01-20 00:00:00	2000-01-20	5001	0	\N	0	0	\N	\N	0	347465	0	127783003	4133840		
3387	331	3010813	1997-04-18	1997-04-18 00:00:00	1997-04-18	5001	0	\N	0	0	\N	\N	0	21811	0	26464-8	3010813		
41159	3833	3006322	1971-01-02	1971-01-02 00:00:00	1971-01-02	5001	0	\N	0	0	\N	\N	0	254482	0	8331-1	3006322		
48751	4454	3049273	1996-02-28	1996-02-28 00:00:00	1996-02-28	5001	0	\N	0	0	\N	\N	0	296501	0	38265-5	3049273		
50700	4623	3027231	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	307872	0	6276-0	3027231		
82078	2540	4052083	1971-08-23	1971-08-23 00:00:00	1971-08-23	5001	0	\N	0	0	\N	\N	0	167880	0	23426006	4052083		
34315	3128	3006451	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	208224	0	6273-7	3006451		
37672	3477	3005136	1986-04-20	1986-04-20 00:00:00	1986-04-20	5001	0	\N	0	0	\N	\N	0	230612	0	6075-6	3005136		
16207	1478	3006322	1994-01-08	1994-01-08 00:00:00	1994-01-08	5001	0	\N	0	0	\N	\N	0	98618	0	8331-1	3006322		
171259	5253	4133840	2016-02-06	2016-02-06 00:00:00	2016-02-06	5001	0	\N	0	0	\N	\N	0	349518	0	127783003	4133840		
45610	4205	3006322	1982-09-25	1982-09-25 00:00:00	1982-09-25	5001	0	\N	0	0	\N	\N	0	279154	0	8331-1	3006322		
55318	1679	4024958	2012-06-30	2012-06-30 00:00:00	2012-06-30	5001	0	\N	0	0	\N	\N	0	112592	0	117015009	4024958		
147736	4529	4133840	1988-12-04	1988-12-04 00:00:00	1988-12-04	5001	0	\N	0	0	\N	\N	0	301590	0	127783003	4133840		
50136	4570	3006322	1947-07-29	1947-07-29 00:00:00	1947-07-29	5001	0	\N	0	0	\N	\N	0	304509	0	8331-1	3006322		
51534	4719	3012494	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	314267	0	6206-7	3012494		
50611	4615	3006322	1995-02-10	1995-02-10 00:00:00	1995-02-10	5001	0	\N	0	0	\N	\N	0	307438	0	8331-1	3006322		
43529	4026	3012494	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	267711	0	6206-7	3012494		
25403	2334	3011505	2008-06-05	2008-06-05 00:00:00	2008-06-05	5001	0	\N	0	0	\N	\N	0	155302	0	19926-5	3011505		
28306	2613	3006322	1960-09-17	1960-09-17 00:00:00	1960-09-17	5001	0	\N	0	0	\N	\N	0	172752	0	8331-1	3006322		
15645	1432	3006322	2014-11-12	2014-11-12 00:00:00	2014-11-12	5001	0	\N	0	0	\N	\N	0	95381	0	8331-1	3006322		
8729	842	3011505	1952-12-20	1952-12-20 00:00:00	1952-12-20	5001	0	\N	0	0	\N	\N	0	55727	0	19926-5	3011505		
119977	3699	4024958	2008-08-23	2008-08-23 00:00:00	2008-08-23	5001	0	\N	0	0	\N	\N	0	245913	0	117015009	4024958		
49344	4505	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	299977	0	6075-6	3005136		
140683	4340	4024958	1978-11-03	1978-11-03 00:00:00	1978-11-03	5001	0	\N	0	0	\N	\N	0	287747	0	117015009	4024958		
31640	2895	3023430	1986-01-09	1986-01-09 00:00:00	1986-01-09	5001	0	\N	0	0	\N	\N	0	192693	0	6833-8	3023430		
31664	2896	3000876	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	192836	0	6082-2	3000876		
43053	3976	40758406	1966-01-07	1966-01-07 00:00:00	1966-01-07	5001	0	\N	0	0	\N	\N	0	264325	0	55277-8	40758406		
6123	573	3006322	1960-03-03	1960-03-03 00:00:00	1960-03-03	5001	0	\N	0	0	\N	\N	0	37967	0	8331-1	3006322		
51075	4662	3004501	1989-07-27	1989-07-27 00:00:00	1989-07-27	5001	0	\N	0	0	\N	\N	0	310773	0	2345-7	3004501		
1185	96	3006322	1927-08-26	1927-08-26 00:00:00	1927-08-26	5001	0	\N	0	0	\N	\N	0	6547	0	8331-1	3006322		
17643	1606	3006322	1958-04-01	1958-04-01 00:00:00	1958-04-01	5001	0	\N	0	0	\N	\N	0	107844	0	8331-1	3006322		
34651	3174	3006322	1998-05-25	1998-05-25 00:00:00	1998-05-25	5001	0	\N	0	0	\N	\N	0	210956	0	8331-1	3006322		
4953	152	4052083	1976-09-10	1976-09-10 00:00:00	1976-09-10	5001	0	\N	0	0	\N	\N	0	10278	0	23426006	4052083		
40485	3759	40769189	1983-08-18	1983-08-18 00:00:00	1983-08-18	5001	0	\N	0	0	\N	\N	0	249936	0	66529-9	40769189		
53575	4922	3006322	1985-07-16	1985-07-16 00:00:00	1985-07-16	5001	0	\N	0	0	\N	\N	0	326987	0	8331-1	3006322		
17290	1572	3006322	1997-06-10	1997-06-10 00:00:00	1997-06-10	5001	0	\N	0	0	\N	\N	0	105559	0	8331-1	3006322		
24268	757	4052083	1935-05-24	1935-05-24 00:00:00	1935-05-24	5001	0	\N	0	0	\N	\N	0	50182	0	23426006	4052083		
52715	4844	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	322296	0	6276-0	3027231		
47062	4340	3006322	1994-10-07	1994-10-07 00:00:00	1994-10-07	5001	0	\N	0	0	\N	\N	0	287762	0	8331-1	3006322		
94520	2905	4024958	1967-03-01	1967-03-01 00:00:00	1967-03-01	5001	0	\N	0	0	\N	\N	0	193553	0	117015009	4024958		
20830	1918	3006322	2005-05-23	2005-05-23 00:00:00	2005-05-23	5001	0	\N	0	0	\N	\N	0	127594	0	8331-1	3006322		
20873	1923	3006322	1970-10-22	1970-10-22 00:00:00	1970-10-22	5001	0	\N	0	0	\N	\N	0	127904	0	8331-1	3006322		
4057	404	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	26618	0	6206-7	3012494		
52139	1577	4024958	1922-10-16	1922-10-16 00:00:00	1922-10-16	5001	0	\N	0	0	\N	\N	0	105858	0	117015009	4024958		
9786	919	3006322	1999-05-13	1999-05-13 00:00:00	1999-05-13	5001	0	\N	0	0	\N	\N	0	61255	0	8331-1	3006322		
10177	970	3006322	1953-08-03	1953-08-03 00:00:00	1953-08-03	5001	0	\N	0	0	\N	\N	0	64486	0	8331-1	3006322		
17901	1626	3006322	1948-08-21	1948-08-21 00:00:00	1948-08-21	5001	0	\N	0	0	\N	\N	0	109259	0	8331-1	3006322		
17978	1636	3049273	2012-01-15	2012-01-15 00:00:00	2012-01-15	5001	0	\N	0	0	\N	\N	0	109884	0	38265-5	3049273		
23073	2122	3006322	1987-06-21	1987-06-21 00:00:00	1987-06-21	5001	0	\N	0	0	\N	\N	0	141173	0	8331-1	3006322		
34481	3147	3011505	1973-02-12	1973-02-12 00:00:00	1973-02-12	5001	0	\N	0	0	\N	\N	0	209439	0	19926-5	3011505		
33097	2987	3006322	1983-02-24	1983-02-24 00:00:00	1983-02-24	5001	0	\N	0	0	\N	\N	0	199411	0	8331-1	3006322		
6353	601	3001247	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	39759	0	6085-5	3001247		
7122	686	3006322	1967-06-12	1967-06-12 00:00:00	1967-06-12	5001	0	\N	0	0	\N	\N	0	45382	0	8331-1	3006322		
52272	4804	3006451	1990-03-26	1990-03-26 00:00:00	1990-03-26	5001	0	\N	0	0	\N	\N	0	319661	0	6273-7	3006451		
3833	120	4052083	2000-11-08	2000-11-08 00:00:00	2000-11-08	5001	0	\N	0	0	\N	\N	0	8006	0	23426006	4052083		
29926	2758	3006322	2000-03-08	2000-03-08 00:00:00	2000-03-08	5001	0	\N	0	0	\N	\N	0	182404	0	8331-1	3006322		
29980	2765	3006322	1949-03-21	1949-03-21 00:00:00	1949-03-21	5001	0	\N	0	0	\N	\N	0	182918	0	8331-1	3006322		
47595	4373	3023430	1976-07-18	1976-07-18 00:00:00	1976-07-18	5001	0	\N	0	0	\N	\N	0	290341	0	6833-8	3023430		
41421	3859	40766240	1989-11-23	1989-11-23 00:00:00	1989-11-23	5001	0	\N	0	0	\N	\N	0	256272	0	63513-6	40766240		
14437	1352	3011505	2018-01-28	2018-01-28 00:00:00	2018-01-28	5001	0	\N	0	0	\N	\N	0	89575	0	19926-5	3011505		
16368	1491	3006322	1979-05-08	1979-05-08 00:00:00	1979-05-08	5001	0	\N	0	0	\N	\N	0	99432	0	8331-1	3006322		
52965	4867	3006322	1975-04-22	1975-04-22 00:00:00	1975-04-22	5001	0	\N	0	0	\N	\N	0	323709	0	8331-1	3006322		
170221	5222	4133840	2010-03-18	2010-03-18 00:00:00	2010-03-18	5001	0	\N	0	0	\N	\N	0	347349	0	127783003	4133840		
3388	331	21494966	1997-04-18	1997-04-18 00:00:00	1997-04-18	5001	0	\N	0	0	\N	\N	0	21811	0	80271-0	21494966		
41160	3834	3006322	1965-07-27	1965-07-27 00:00:00	1965-07-27	5001	0	\N	0	0	\N	\N	0	254601	0	8331-1	3006322		
48752	4454	3049273	1998-02-17	1998-02-17 00:00:00	1998-02-17	5001	0	\N	0	0	\N	\N	0	296502	0	38265-5	3049273		
121646	3754	4052083	1995-11-25	1995-11-25 00:00:00	1995-11-25	5001	0	\N	0	0	\N	\N	0	249500	0	23426006	4052083		
82104	2541	4052083	1987-03-01	1987-03-01 00:00:00	1987-03-01	5001	0	\N	0	0	\N	\N	0	168016	0	23426006	4052083		
34316	3128	3005136	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	208224	0	6075-6	3005136		
37673	3477	3019406	1986-04-20	1986-04-20 00:00:00	1986-04-20	5001	0	\N	0	0	\N	\N	0	230612	0	6158-0	3019406		
16208	1478	3006322	1966-01-11	1966-01-11 00:00:00	1966-01-11	5001	0	\N	0	0	\N	\N	0	98629	0	8331-1	3006322		
171260	5253	4133840	1999-12-25	1999-12-25 00:00:00	1999-12-25	5001	0	\N	0	0	\N	\N	0	349511	0	127783003	4133840		
45611	4206	3006322	1955-06-08	1955-06-08 00:00:00	1955-06-08	5001	0	\N	0	0	\N	\N	0	279284	0	8331-1	3006322		
55319	1679	4052083	2009-04-04	2009-04-04 00:00:00	2009-04-04	5001	0	\N	0	0	\N	\N	0	112591	0	23426006	4052083		
147738	4529	4133840	2007-12-02	2007-12-02 00:00:00	2007-12-02	5001	0	\N	0	0	\N	\N	0	301591	0	127783003	4133840		
50137	4571	3006322	1958-02-09	1958-02-09 00:00:00	1958-02-09	5001	0	\N	0	0	\N	\N	0	304556	0	8331-1	3006322		
51535	4719	3006734	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	314267	0	6189-5	3006734		
50612	4615	3006322	1994-03-01	1994-03-01 00:00:00	1994-03-01	5001	0	\N	0	0	\N	\N	0	307423	0	8331-1	3006322		
43530	4026	3036780	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	267711	0	6095-4	3036780		
25404	2334	3011505	1980-05-22	1980-05-22 00:00:00	1980-05-22	5001	0	\N	0	0	\N	\N	0	155369	0	19926-5	3011505		
28307	2613	3006322	2007-06-27	2007-06-27 00:00:00	2007-06-27	5001	0	\N	0	0	\N	\N	0	172807	0	8331-1	3006322		
15646	1432	3006322	1962-11-24	1962-11-24 00:00:00	1962-11-24	5001	0	\N	0	0	\N	\N	0	95391	0	8331-1	3006322		
8730	842	3011505	1962-01-20	1962-01-20 00:00:00	1962-01-20	5001	0	\N	0	0	\N	\N	0	55759	0	19926-5	3011505		
119992	3700	4024958	1983-09-04	1983-09-04 00:00:00	1983-09-04	5001	0	\N	0	0	\N	\N	0	245963	0	117015009	4024958		
49345	4505	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	299977	0	7258-7	3001488		
140685	4340	4024958	1985-04-16	1985-04-16 00:00:00	1985-04-16	5001	0	\N	0	0	\N	\N	0	287775	0	117015009	4024958		
31641	2896	3006322	1984-01-05	1984-01-05 00:00:00	1984-01-05	5001	0	\N	0	0	\N	\N	0	192764	0	8331-1	3006322		
31665	2896	3015076	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	192836	0	6248-9	3015076		
43054	3976	3051031	1966-01-07	1966-01-07 00:00:00	1966-01-07	5001	0	\N	0	0	\N	\N	0	264325	0	46240-8	3051031		
6124	573	3006322	1974-01-22	1974-01-22 00:00:00	1974-01-22	5001	0	\N	0	0	\N	\N	0	37970	0	8331-1	3006322		
51076	4662	3035995	1989-07-27	1989-07-27 00:00:00	1989-07-27	5001	0	\N	0	0	\N	\N	0	310773	0	6768-6	3035995		
1186	96	3006322	1951-05-16	1951-05-16 00:00:00	1951-05-16	5001	0	\N	0	0	\N	\N	0	6511	0	8331-1	3006322		
17644	1606	3006322	1994-01-31	1994-01-31 00:00:00	1994-01-31	5001	0	\N	0	0	\N	\N	0	107819	0	8331-1	3006322		
34652	3174	3006322	2001-10-18	2001-10-18 00:00:00	2001-10-18	5001	0	\N	0	0	\N	\N	0	210978	0	8331-1	3006322		
4957	152	4024958	1970-06-28	1970-06-28 00:00:00	1970-06-28	5001	0	\N	0	0	\N	\N	0	10275	0	117015009	4024958		
40486	3759	40769194	1983-08-18	1983-08-18 00:00:00	1983-08-18	5001	0	\N	0	0	\N	\N	0	249936	0	66534-9	40769194		
53576	4922	3006322	1984-01-09	1984-01-09 00:00:00	1984-01-09	5001	0	\N	0	0	\N	\N	0	326968	0	8331-1	3006322		
17291	1572	3006322	1980-01-20	1980-01-20 00:00:00	1980-01-20	5001	0	\N	0	0	\N	\N	0	105606	0	8331-1	3006322		
24287	758	4024958	2007-03-22	2007-03-22 00:00:00	2007-03-22	5001	0	\N	0	0	\N	\N	0	50301	0	117015009	4024958		
52716	4844	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	322296	0	6106-9	3014599		
47063	4340	3006322	2005-06-05	2005-06-05 00:00:00	2005-06-05	5001	0	\N	0	0	\N	\N	0	287770	0	8331-1	3006322		
94524	2905	4024958	2004-04-03	2004-04-03 00:00:00	2004-04-03	5001	0	\N	0	0	\N	\N	0	193541	0	117015009	4024958		
20831	1918	3006322	2010-10-06	2010-10-06 00:00:00	2010-10-06	5001	0	\N	0	0	\N	\N	0	127652	0	8331-1	3006322		
20874	1923	3006322	2007-08-12	2007-08-12 00:00:00	2007-08-12	5001	0	\N	0	0	\N	\N	0	127969	0	8331-1	3006322		
4058	404	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	26618	0	7258-7	3001488		
52173	1578	4024958	1981-12-27	1981-12-27 00:00:00	1981-12-27	5001	0	\N	0	0	\N	\N	0	105956	0	117015009	4024958		
9787	919	3006322	1986-08-24	1986-08-24 00:00:00	1986-08-24	5001	0	\N	0	0	\N	\N	0	61249	0	8331-1	3006322		
10178	970	3006322	2016-09-07	2016-09-07 00:00:00	2016-09-07	5001	0	\N	0	0	\N	\N	0	64529	0	8331-1	3006322		
17902	1626	3006322	1956-07-19	1956-07-19 00:00:00	1956-07-19	5001	0	\N	0	0	\N	\N	0	109260	0	8331-1	3006322		
17979	1636	3006322	1987-03-20	1987-03-20 00:00:00	1987-03-20	5001	0	\N	0	0	\N	\N	0	109858	0	8331-1	3006322		
23074	2122	3006322	1990-04-28	1990-04-28 00:00:00	1990-04-28	5001	0	\N	0	0	\N	\N	0	141189	0	8331-1	3006322		
34482	3147	3011505	1992-01-27	1992-01-27 00:00:00	1992-01-27	5001	0	\N	0	0	\N	\N	0	209385	0	19926-5	3011505		
33098	2987	3006322	1992-12-13	1992-12-13 00:00:00	1992-12-13	5001	0	\N	0	0	\N	\N	0	199392	0	8331-1	3006322		
6354	601	3001488	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	39759	0	7258-7	3001488		
7123	686	3006322	2007-01-05	2007-01-05 00:00:00	2007-01-05	5001	0	\N	0	0	\N	\N	0	45419	0	8331-1	3006322		
52273	4804	3019406	1990-03-26	1990-03-26 00:00:00	1990-03-26	5001	0	\N	0	0	\N	\N	0	319661	0	6158-0	3019406		
3838	120	4024958	1988-04-28	1988-04-28 00:00:00	1988-04-28	5001	0	\N	0	0	\N	\N	0	7974	0	117015009	4024958		
29927	2758	3006322	2012-05-21	2012-05-21 00:00:00	2012-05-21	5001	0	\N	0	0	\N	\N	0	182405	0	8331-1	3006322		
29981	2765	3011505	2014-12-16	2014-12-16 00:00:00	2014-12-16	5001	0	\N	0	0	\N	\N	0	182836	0	19926-5	3011505		
47596	4373	3005136	1976-07-18	1976-07-18 00:00:00	1976-07-18	5001	0	\N	0	0	\N	\N	0	290341	0	6075-6	3005136		
41423	3859	46235214	1989-11-23	1989-11-23 00:00:00	1989-11-23	5001	0	\N	0	0	\N	\N	0	256272	0	76690-7	46235214		
14438	1352	3006322	2016-01-12	2016-01-12 00:00:00	2016-01-12	5001	0	\N	0	0	\N	\N	0	89540	0	8331-1	3006322		
16369	1491	3006322	1996-11-12	1996-11-12 00:00:00	1996-11-12	5001	0	\N	0	0	\N	\N	0	99405	0	8331-1	3006322		
52966	4867	3049273	1995-04-01	1995-04-01 00:00:00	1995-04-01	5001	0	\N	0	0	\N	\N	0	323687	0	38265-5	3049273		
170224	5222	4133840	2009-03-12	2009-03-12 00:00:00	2009-03-12	5001	0	\N	0	0	\N	\N	0	347423	0	127783003	4133840		
3389	331	3020630	1997-04-18	1997-04-18 00:00:00	1997-04-18	5001	0	\N	0	0	\N	\N	0	21811	0	2885-2	3020630		
41161	3834	3006322	1993-11-12	1993-11-12 00:00:00	1993-11-12	5001	0	\N	0	0	\N	\N	0	254581	0	8331-1	3006322		
48753	4454	3006322	2005-12-09	2005-12-09 00:00:00	2005-12-09	5001	0	\N	0	0	\N	\N	0	296405	0	8331-1	3006322		
121714	3756	4133840	2017-07-15	2017-07-15 00:00:00	2017-07-15	5001	0	\N	0	0	\N	\N	0	249709	0	127783003	4133840		
82110	2541	4052083	2011-08-08	2011-08-08 00:00:00	2011-08-08	5001	0	\N	0	0	\N	\N	0	168034	0	23426006	4052083		
34317	3128	3019406	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	208224	0	6158-0	3019406		
37674	3477	3015076	1986-04-20	1986-04-20 00:00:00	1986-04-20	5001	0	\N	0	0	\N	\N	0	230612	0	6248-9	3015076		
16209	1478	3006322	1969-11-01	1969-11-01 00:00:00	1969-11-01	5001	0	\N	0	0	\N	\N	0	98612	0	8331-1	3006322		
171263	5253	4133840	1986-10-04	1986-10-04 00:00:00	1986-10-04	5001	0	\N	0	0	\N	\N	0	349533	0	127783003	4133840		
45612	4206	3006322	1974-05-10	1974-05-10 00:00:00	1974-05-10	5001	0	\N	0	0	\N	\N	0	279287	0	8331-1	3006322		
55324	1679	4024958	2001-11-09	2001-11-09 00:00:00	2001-11-09	5001	0	\N	0	0	\N	\N	0	112566	0	117015009	4024958		
147741	4529	4133840	2014-11-23	2014-11-23 00:00:00	2014-11-23	5001	0	\N	0	0	\N	\N	0	301602	0	127783003	4133840		
50138	4571	3006322	2009-01-24	2009-01-24 00:00:00	2009-01-24	5001	0	\N	0	0	\N	\N	0	304524	0	8331-1	3006322		
51536	4719	3006451	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	314267	0	6273-7	3006451		
50613	4615	3006322	1977-03-07	1977-03-07 00:00:00	1977-03-07	5001	0	\N	0	0	\N	\N	0	307405	0	8331-1	3006322		
43531	4026	3006322	2000-04-21	2000-04-21 00:00:00	2000-04-21	5001	0	\N	0	0	\N	\N	0	267624	0	8331-1	3006322		
25405	2334	3011505	2002-05-02	2002-05-02 00:00:00	2002-05-02	5001	0	\N	0	0	\N	\N	0	155361	0	19926-5	3011505		
28308	2613	3006322	1984-06-04	1984-06-04 00:00:00	1984-06-04	5001	0	\N	0	0	\N	\N	0	172748	0	8331-1	3006322		
15647	1432	3006322	1972-05-17	1972-05-17 00:00:00	1972-05-17	5001	0	\N	0	0	\N	\N	0	95414	0	8331-1	3006322		
8731	842	3011505	1998-07-18	1998-07-18 00:00:00	1998-07-18	5001	0	\N	0	0	\N	\N	0	55688	0	19926-5	3011505		
119999	3700	4052083	1973-12-23	1973-12-23 00:00:00	1973-12-23	5001	0	\N	0	0	\N	\N	0	245970	0	23426006	4052083		
49346	4505	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	299977	0	6082-2	3000876		
152000	4655	4024958	1968-02-24	1968-02-24 00:00:00	1968-02-24	5001	0	\N	0	0	\N	\N	0	310307	0	117015009	4024958		
31642	2896	3012494	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	192802	0	6206-7	3012494		
31666	2896	3027231	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	192836	0	6276-0	3027231		
43056	3976	3006322	1964-04-13	1964-04-13 00:00:00	1964-04-13	5001	0	\N	0	0	\N	\N	0	264379	0	8331-1	3006322		
6129	576	3006322	1997-07-31	1997-07-31 00:00:00	1997-07-31	5001	0	\N	0	0	\N	\N	0	38073	0	8331-1	3006322		
51077	4662	3014576	1989-07-27	1989-07-27 00:00:00	1989-07-27	5001	0	\N	0	0	\N	\N	0	310773	0	2075-0	3014576		
1187	96	3011505	1987-03-07	1987-03-07 00:00:00	1987-03-07	5001	0	\N	0	0	\N	\N	0	6527	0	19926-5	3011505		
17645	1606	3006322	1987-09-20	1987-09-20 00:00:00	1987-09-20	5001	0	\N	0	0	\N	\N	0	107849	0	8331-1	3006322		
34653	3174	3006322	1991-12-18	1991-12-18 00:00:00	1991-12-18	5001	0	\N	0	0	\N	\N	0	210976	0	8331-1	3006322		
4964	153	4052083	1944-06-06	1944-06-06 00:00:00	1944-06-06	5001	0	\N	0	0	\N	\N	0	10404	0	23426006	4052083		
40487	3759	3006322	1982-06-08	1982-06-08 00:00:00	1982-06-08	5001	0	\N	0	0	\N	\N	0	249948	0	8331-1	3006322		
53577	4922	3006322	1981-08-11	1981-08-11 00:00:00	1981-08-11	5001	0	\N	0	0	\N	\N	0	326967	0	8331-1	3006322		
17292	1574	46235214	1959-12-02	1959-12-02 00:00:00	1959-12-02	5001	0	\N	0	0	\N	\N	0	105658	0	76690-7	46235214		
24291	758	4052083	2000-07-12	2000-07-12 00:00:00	2000-07-12	5001	0	\N	0	0	\N	\N	0	50314	0	23426006	4052083		
52717	4844	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	322296	0	6095-4	3036780		
74096	2277	4024958	1970-07-15	1970-07-15 00:00:00	1970-07-15	5001	0	\N	0	0	\N	\N	0	151351	0	117015009	4024958		
94530	2905	4052083	2019-06-17	2019-06-17 00:00:00	2019-06-17	5001	0	\N	0	0	\N	\N	0	193603	0	23426006	4052083		
20832	1918	3006322	1977-08-05	1977-08-05 00:00:00	1977-08-05	5001	0	\N	0	0	\N	\N	0	127626	0	8331-1	3006322		
20875	1923	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	127864	0	6082-2	3000876		
4059	404	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	26618	0	6085-5	3001247		
52190	1578	4024958	1997-04-19	1997-04-19 00:00:00	1997-04-19	5001	0	\N	0	0	\N	\N	0	105957	0	117015009	4024958		
9806	921	3006322	2009-08-05	2009-08-05 00:00:00	2009-08-05	5001	0	\N	0	0	\N	\N	0	61371	0	8331-1	3006322		
10179	970	3006322	1960-07-25	1960-07-25 00:00:00	1960-07-25	5001	0	\N	0	0	\N	\N	0	64487	0	8331-1	3006322		
17903	1626	3011505	2003-10-12	2003-10-12 00:00:00	2003-10-12	5001	0	\N	0	0	\N	\N	0	109257	0	19926-5	3011505		
17980	1636	3006322	2013-04-27	2013-04-27 00:00:00	2013-04-27	5001	0	\N	0	0	\N	\N	0	109860	0	8331-1	3006322		
23075	2122	3006322	1980-01-18	1980-01-18 00:00:00	1980-01-18	5001	0	\N	0	0	\N	\N	0	141187	0	8331-1	3006322		
34483	3147	3011505	2001-03-05	2001-03-05 00:00:00	2001-03-05	5001	0	\N	0	0	\N	\N	0	209365	0	19926-5	3011505		
33099	2987	3006322	1981-08-22	1981-08-22 00:00:00	1981-08-22	5001	0	\N	0	0	\N	\N	0	199391	0	8331-1	3006322		
6355	601	3006734	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	39759	0	6189-5	3006734		
7124	686	3006322	1967-09-21	1967-09-21 00:00:00	1967-09-21	5001	0	\N	0	0	\N	\N	0	45439	0	8331-1	3006322		
52274	4804	3012494	1990-03-26	1990-03-26 00:00:00	1990-03-26	5001	0	\N	0	0	\N	\N	0	319661	0	6206-7	3012494		
14056	1313	3006322	2012-04-03	2012-04-03 00:00:00	2012-04-03	5001	0	\N	0	0	\N	\N	0	86933	0	8331-1	3006322		
29928	2758	3006322	1985-11-08	1985-11-08 00:00:00	1985-11-08	5001	0	\N	0	0	\N	\N	0	182480	0	8331-1	3006322		
29982	2765	3006322	1936-05-15	1936-05-15 00:00:00	1936-05-15	5001	0	\N	0	0	\N	\N	0	182905	0	8331-1	3006322		
47597	4373	3012494	1976-07-18	1976-07-18 00:00:00	1976-07-18	5001	0	\N	0	0	\N	\N	0	290341	0	6206-7	3012494		
41425	3859	3011505	1990-02-17	1990-02-17 00:00:00	1990-02-17	5001	0	\N	0	0	\N	\N	0	256273	0	19926-5	3011505		
14439	1352	3011505	1995-08-20	1995-08-20 00:00:00	1995-08-20	5001	0	\N	0	0	\N	\N	0	89586	0	19926-5	3011505		
16370	1491	3006322	1980-10-13	1980-10-13 00:00:00	1980-10-13	5001	0	\N	0	0	\N	\N	0	99433	0	8331-1	3006322		
52967	4867	3006322	2006-09-19	2006-09-19 00:00:00	2006-09-19	5001	0	\N	0	0	\N	\N	0	323727	0	8331-1	3006322		
173424	5322	4052083	1989-04-21	1989-04-21 00:00:00	1989-04-21	5001	0	\N	0	0	\N	\N	0	354124	0	23426006	4052083		
3390	331	3000963	1997-04-18	1997-04-18 00:00:00	1997-04-18	5001	0	\N	0	0	\N	\N	0	21811	0	718-7	3000963		
41162	3834	3006322	1974-03-07	1974-03-07 00:00:00	1974-03-07	5001	0	\N	0	0	\N	\N	0	254579	0	8331-1	3006322		
48754	4454	3006322	1980-03-08	1980-03-08 00:00:00	1980-03-08	5001	0	\N	0	0	\N	\N	0	296416	0	8331-1	3006322		
121716	3756	4133840	2003-04-26	2003-04-26 00:00:00	2003-04-26	5001	0	\N	0	0	\N	\N	0	249689	0	127783003	4133840		
82112	2541	4024958	2017-05-05	2017-05-05 00:00:00	2017-05-05	5001	0	\N	0	0	\N	\N	0	168061	0	117015009	4024958		
34318	3128	3021226	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	208224	0	6246-3	3021226		
37675	3477	3006734	1986-04-20	1986-04-20 00:00:00	1986-04-20	5001	0	\N	0	0	\N	\N	0	230612	0	6189-5	3006734		
16210	1478	21494966	1975-05-03	1975-05-03 00:00:00	1975-05-03	5001	0	\N	0	0	\N	\N	0	98639	0	80271-0	21494966		
171266	5253	4133840	2007-12-22	2007-12-22 00:00:00	2007-12-22	5001	0	\N	0	0	\N	\N	0	349567	0	127783003	4133840		
45613	4206	3011505	1994-09-12	1994-09-12 00:00:00	1994-09-12	5001	0	\N	0	0	\N	\N	0	279323	0	19926-5	3011505		
55327	1679	4024958	1991-10-10	1991-10-10 00:00:00	1991-10-10	5001	0	\N	0	0	\N	\N	0	112599	0	117015009	4024958		
2495	78	4052083	2009-04-14	2009-04-14 00:00:00	2009-04-14	5001	0	\N	0	0	\N	\N	0	5193	0	23426006	4052083		
50139	4572	3006322	1999-08-28	1999-08-28 00:00:00	1999-08-28	5001	0	\N	0	0	\N	\N	0	304602	0	8331-1	3006322		
51537	4719	3014599	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	314267	0	6106-9	3014599		
50614	4615	3006322	1998-01-28	1998-01-28 00:00:00	1998-01-28	5001	0	\N	0	0	\N	\N	0	307395	0	8331-1	3006322		
43532	4026	3006322	1980-07-14	1980-07-14 00:00:00	1980-07-14	5001	0	\N	0	0	\N	\N	0	267663	0	8331-1	3006322		
25406	2334	3006322	1939-02-15	1939-02-15 00:00:00	1939-02-15	5001	0	\N	0	0	\N	\N	0	155282	0	8331-1	3006322		
28309	2615	3006322	1980-06-27	1980-06-27 00:00:00	1980-06-27	5001	0	\N	0	0	\N	\N	0	172852	0	8331-1	3006322		
15648	1432	3006322	2018-03-27	2018-03-27 00:00:00	2018-03-27	5001	0	\N	0	0	\N	\N	0	95395	0	8331-1	3006322		
8732	842	3011505	1956-12-29	1956-12-29 00:00:00	1956-12-29	5001	0	\N	0	0	\N	\N	0	55621	0	19926-5	3011505		
120024	3701	4052083	1986-03-26	1986-03-26 00:00:00	1986-03-26	5001	0	\N	0	0	\N	\N	0	246033	0	23426006	4052083		
49347	4505	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	299977	0	6276-0	3027231		
152006	4655	4024958	2015-02-17	2015-02-17 00:00:00	2015-02-17	5001	0	\N	0	0	\N	\N	0	310337	0	117015009	4024958		
31643	2896	3019406	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	192802	0	6158-0	3019406		
31667	2896	3014599	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	192836	0	6106-9	3014599		
43058	3976	3051031	1965-09-09	1965-09-09 00:00:00	1965-09-09	5001	0	\N	0	0	\N	\N	0	264382	0	46240-8	3051031		
6130	576	3006322	1969-03-22	1969-03-22 00:00:00	1969-03-22	5001	0	\N	0	0	\N	\N	0	38095	0	8331-1	3006322		
51078	4662	3006923	1989-07-27	1989-07-27 00:00:00	1989-07-27	5001	0	\N	0	0	\N	\N	0	310773	0	1742-6	3006923		
1188	96	3011505	1978-01-14	1978-01-14 00:00:00	1978-01-14	5001	0	\N	0	0	\N	\N	0	6491	0	19926-5	3011505		
17646	1606	3006322	1958-06-12	1958-06-12 00:00:00	1958-06-12	5001	0	\N	0	0	\N	\N	0	107879	0	8331-1	3006322		
34654	3175	3006322	1987-02-12	1987-02-12 00:00:00	1987-02-12	5001	0	\N	0	0	\N	\N	0	211002	0	8331-1	3006322		
4969	153	4024958	1951-07-07	1951-07-07 00:00:00	1951-07-07	5001	0	\N	0	0	\N	\N	0	10405	0	117015009	4024958		
40488	3759	3001488	1983-08-31	1983-08-31 00:00:00	1983-08-31	5001	0	\N	0	0	\N	\N	0	249968	0	7258-7	3001488		
53578	4922	3006322	2013-01-04	2013-01-04 00:00:00	2013-01-04	5001	0	\N	0	0	\N	\N	0	327044	0	8331-1	3006322		
17294	1574	3051031	1959-12-02	1959-12-02 00:00:00	1959-12-02	5001	0	\N	0	0	\N	\N	0	105658	0	46240-8	3051031		
24292	758	4052083	1996-08-23	1996-08-23 00:00:00	1996-08-23	5001	0	\N	0	0	\N	\N	0	50315	0	23426006	4052083		
52718	4844	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	322296	0	6189-5	3006734		
85408	2644	4024958	1985-01-19	1985-01-19 00:00:00	1985-01-19	5001	0	\N	0	0	\N	\N	0	174974	0	117015009	4024958		
94536	2906	4024958	2004-06-10	2004-06-10 00:00:00	2004-06-10	5001	0	\N	0	0	\N	\N	0	193625	0	117015009	4024958		
20833	1918	3006322	1998-01-15	1998-01-15 00:00:00	1998-01-15	5001	0	\N	0	0	\N	\N	0	127619	0	8331-1	3006322		
20876	1923	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	127864	0	6106-9	3014599		
4060	404	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	26618	0	6095-4	3036780		
98137	3001	4024958	1995-01-04	1995-01-04 00:00:00	1995-01-04	5001	0	\N	0	0	\N	\N	0	200271	0	117015009	4024958		
9809	923	3006322	2017-09-10	2017-09-10 00:00:00	2017-09-10	5001	0	\N	0	0	\N	\N	0	61447	0	8331-1	3006322		
10180	971	3006322	1981-07-24	1981-07-24 00:00:00	1981-07-24	5001	0	\N	0	0	\N	\N	0	64593	0	8331-1	3006322		
17904	1626	3006322	1987-10-28	1987-10-28 00:00:00	1987-10-28	5001	0	\N	0	0	\N	\N	0	109274	0	8331-1	3006322		
17981	1636	3006322	1969-05-09	1969-05-09 00:00:00	1969-05-09	5001	0	\N	0	0	\N	\N	0	109898	0	8331-1	3006322		
23076	2122	3006322	1987-10-27	1987-10-27 00:00:00	1987-10-27	5001	0	\N	0	0	\N	\N	0	141195	0	8331-1	3006322		
34484	3147	3011505	1994-01-31	1994-01-31 00:00:00	1994-01-31	5001	0	\N	0	0	\N	\N	0	209363	0	19926-5	3011505		
33100	2988	40758406	1978-01-02	1978-01-02 00:00:00	1978-01-02	5001	0	\N	0	0	\N	\N	0	199468	0	55277-8	40758406		
6356	601	3020655	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	39759	0	6844-5	3020655		
7125	687	3006322	1975-11-18	1975-11-18 00:00:00	1975-11-18	5001	0	\N	0	0	\N	\N	0	45573	0	8331-1	3006322		
52275	4804	3000876	1990-03-26	1990-03-26 00:00:00	1990-03-26	5001	0	\N	0	0	\N	\N	0	319661	0	6082-2	3000876		
14057	1313	3006322	1997-09-28	1997-09-28 00:00:00	1997-09-28	5001	0	\N	0	0	\N	\N	0	86928	0	8331-1	3006322		
29929	2758	3006322	1961-07-17	1961-07-17 00:00:00	1961-07-17	5001	0	\N	0	0	\N	\N	0	182479	0	8331-1	3006322		
29983	2765	3006322	1981-12-13	1981-12-13 00:00:00	1981-12-13	5001	0	\N	0	0	\N	\N	0	182900	0	8331-1	3006322		
47598	4373	3036780	1976-07-18	1976-07-18 00:00:00	1976-07-18	5001	0	\N	0	0	\N	\N	0	290341	0	6095-4	3036780		
41426	3859	3011505	1987-09-10	1987-09-10 00:00:00	1987-09-10	5001	0	\N	0	0	\N	\N	0	256254	0	19926-5	3011505		
14440	1352	3011505	2019-02-03	2019-02-03 00:00:00	2019-02-03	5001	0	\N	0	0	\N	\N	0	89548	0	19926-5	3011505		
16372	1491	3006322	1985-06-02	1985-06-02 00:00:00	1985-06-02	5001	0	\N	0	0	\N	\N	0	99434	0	8331-1	3006322		
52968	4867	3006322	1947-08-27	1947-08-27 00:00:00	1947-08-27	5001	0	\N	0	0	\N	\N	0	323678	0	8331-1	3006322		
11278	1085	3006322	1995-10-02	1995-10-02 00:00:00	1995-10-02	5001	0	\N	0	0	\N	\N	0	71270	0	8331-1	3006322		
3391	331	3019550	1997-04-18	1997-04-18 00:00:00	1997-04-18	5001	0	\N	0	0	\N	\N	0	21811	0	2951-2	3019550		
41163	3834	3006322	2005-03-09	2005-03-09 00:00:00	2005-03-09	5001	0	\N	0	0	\N	\N	0	254553	0	8331-1	3006322		
48755	4454	3006322	1932-12-25	1932-12-25 00:00:00	1932-12-25	5001	0	\N	0	0	\N	\N	0	296385	0	8331-1	3006322		
121718	3756	4133840	2007-05-19	2007-05-19 00:00:00	2007-05-19	5001	0	\N	0	0	\N	\N	0	249691	0	127783003	4133840		
82121	2541	4052083	2007-09-27	2007-09-27 00:00:00	2007-09-27	5001	0	\N	0	0	\N	\N	0	168060	0	23426006	4052083		
34319	3128	3001247	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	208224	0	6085-5	3001247		
37676	3477	3036780	1986-04-20	1986-04-20 00:00:00	1986-04-20	5001	0	\N	0	0	\N	\N	0	230612	0	6095-4	3036780		
16211	1478	3023103	1975-05-03	1975-05-03 00:00:00	1975-05-03	5001	0	\N	0	0	\N	\N	0	98639	0	2823-3	3023103		
171270	5253	4052083	1980-04-13	1980-04-13 00:00:00	1980-04-13	5001	0	\N	0	0	\N	\N	0	349540	0	23426006	4052083		
45614	4206	3006322	1968-02-12	1968-02-12 00:00:00	1968-02-12	5001	0	\N	0	0	\N	\N	0	279325	0	8331-1	3006322		
54045	4945	3006322	1992-04-11	1992-04-11 00:00:00	1992-04-11	5001	0	\N	0	0	\N	\N	0	328726	0	8331-1	3006322		
2497	78	4052083	1991-10-28	1991-10-28 00:00:00	1991-10-28	5001	0	\N	0	0	\N	\N	0	5203	0	23426006	4052083		
50140	4572	3006322	1977-01-08	1977-01-08 00:00:00	1977-01-08	5001	0	\N	0	0	\N	\N	0	304610	0	8331-1	3006322		
51538	4719	3015076	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	314267	0	6248-9	3015076		
50615	4615	3006322	2019-02-08	2019-02-08 00:00:00	2019-02-08	5001	0	\N	0	0	\N	\N	0	307457	0	8331-1	3006322		
43533	4026	40769179	1977-01-30	1977-01-30 00:00:00	1977-01-30	5001	0	\N	0	0	\N	\N	0	267723	0	66519-0	40769179		
25407	2334	3006322	1949-08-12	1949-08-12 00:00:00	1949-08-12	5001	0	\N	0	0	\N	\N	0	155286	0	8331-1	3006322		
28310	2615	3006322	1984-04-17	1984-04-17 00:00:00	1984-04-17	5001	0	\N	0	0	\N	\N	0	172927	0	8331-1	3006322		
15649	1432	3006322	2016-09-16	2016-09-16 00:00:00	2016-09-16	5001	0	\N	0	0	\N	\N	0	95419	0	8331-1	3006322		
8733	842	3011505	2015-10-24	2015-10-24 00:00:00	2015-10-24	5001	0	\N	0	0	\N	\N	0	55685	0	19926-5	3011505		
63001	1936	4024958	1953-07-04	1953-07-04 00:00:00	1953-07-04	5001	0	\N	0	0	\N	\N	0	128826	0	117015009	4024958		
49348	4505	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	299977	0	6273-7	3006451		
152011	4655	4052083	1998-06-14	1998-06-14 00:00:00	1998-06-14	5001	0	\N	0	0	\N	\N	0	310369	0	23426006	4052083		
31644	2896	3027231	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	192802	0	6276-0	3027231		
31668	2896	3006451	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	192836	0	6273-7	3006451		
43059	3976	40758406	1965-09-09	1965-09-09 00:00:00	1965-09-09	5001	0	\N	0	0	\N	\N	0	264382	0	55277-8	40758406		
6131	576	3006322	1971-06-24	1971-06-24 00:00:00	1971-06-24	5001	0	\N	0	0	\N	\N	0	38092	0	8331-1	3006322		
51079	4662	3028833	1989-07-27	1989-07-27 00:00:00	1989-07-27	5001	0	\N	0	0	\N	\N	0	310773	0	42719-5	3028833		
1189	96	3011505	1974-12-28	1974-12-28 00:00:00	1974-12-28	5001	0	\N	0	0	\N	\N	0	6479	0	19926-5	3011505		
17647	1606	3006322	2014-03-01	2014-03-01 00:00:00	2014-03-01	5001	0	\N	0	0	\N	\N	0	107806	0	8331-1	3006322		
34655	3175	3006322	1999-05-16	1999-05-16 00:00:00	1999-05-16	5001	0	\N	0	0	\N	\N	0	211007	0	8331-1	3006322		
78022	2392	4133840	1981-12-04	1981-12-04 00:00:00	1981-12-04	5001	0	\N	0	0	\N	\N	0	159078	0	127783003	4133840		
40489	3759	3020655	1983-08-31	1983-08-31 00:00:00	1983-08-31	5001	0	\N	0	0	\N	\N	0	249968	0	6844-5	3020655		
53579	4923	3006322	2005-07-11	2005-07-11 00:00:00	2005-07-11	5001	0	\N	0	0	\N	\N	0	327139	0	8331-1	3006322		
17295	1574	40766240	1959-12-02	1959-12-02 00:00:00	1959-12-02	5001	0	\N	0	0	\N	\N	0	105658	0	63513-6	40766240		
24294	758	4024958	1985-12-03	1985-12-03 00:00:00	1985-12-03	5001	0	\N	0	0	\N	\N	0	50326	0	117015009	4024958		
52719	4844	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	322296	0	6085-5	3001247		
85419	2644	4052083	2018-10-28	2018-10-28 00:00:00	2018-10-28	5001	0	\N	0	0	\N	\N	0	174963	0	23426006	4052083		
94538	2906	4052083	1977-01-15	1977-01-15 00:00:00	1977-01-15	5001	0	\N	0	0	\N	\N	0	193691	0	23426006	4052083		
20834	1918	3006322	1976-05-02	1976-05-02 00:00:00	1976-05-02	5001	0	\N	0	0	\N	\N	0	127575	0	8331-1	3006322		
20877	1923	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	127864	0	6158-0	3019406		
4061	404	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	26618	0	6075-6	3005136		
98138	3001	4024958	1959-07-03	1959-07-03 00:00:00	1959-07-03	5001	0	\N	0	0	\N	\N	0	200269	0	117015009	4024958		
9810	923	3006322	1959-09-12	1959-09-12 00:00:00	1959-09-12	5001	0	\N	0	0	\N	\N	0	61415	0	8331-1	3006322		
10181	971	3006322	1991-04-18	1991-04-18 00:00:00	1991-04-18	5001	0	\N	0	0	\N	\N	0	64610	0	8331-1	3006322		
17905	1626	3010813	1989-12-17	1989-12-17 00:00:00	1989-12-17	5001	0	\N	0	0	\N	\N	0	109189	0	26464-8	3010813		
17982	1636	3006322	1997-08-05	1997-08-05 00:00:00	1997-08-05	5001	0	\N	0	0	\N	\N	0	109914	0	8331-1	3006322		
23077	2123	3006322	1952-01-08	1952-01-08 00:00:00	1952-01-08	5001	0	\N	0	0	\N	\N	0	141276	0	8331-1	3006322		
34485	3147	3006322	1962-05-26	1962-05-26 00:00:00	1962-05-26	5001	0	\N	0	0	\N	\N	0	209372	0	8331-1	3006322		
33102	2988	3051031	1978-01-02	1978-01-02 00:00:00	1978-01-02	5001	0	\N	0	0	\N	\N	0	199468	0	46240-8	3051031		
6357	601	3023430	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	39759	0	6833-8	3023430		
7126	687	3006322	1968-03-18	1968-03-18 00:00:00	1968-03-18	5001	0	\N	0	0	\N	\N	0	45509	0	8331-1	3006322		
52276	4804	3001488	1990-03-26	1990-03-26 00:00:00	1990-03-26	5001	0	\N	0	0	\N	\N	0	319661	0	7258-7	3001488		
14058	1313	3006322	1996-01-23	1996-01-23 00:00:00	1996-01-23	5001	0	\N	0	0	\N	\N	0	86927	0	8331-1	3006322		
29930	2758	3006322	1959-04-10	1959-04-10 00:00:00	1959-04-10	5001	0	\N	0	0	\N	\N	0	182477	0	8331-1	3006322		
29984	2765	3011505	2018-01-02	2018-01-02 00:00:00	2018-01-02	5001	0	\N	0	0	\N	\N	0	182827	0	19926-5	3011505		
47599	4373	3027231	1976-07-18	1976-07-18 00:00:00	1976-07-18	5001	0	\N	0	0	\N	\N	0	290341	0	6276-0	3027231		
41427	3859	3011505	2003-09-13	2003-09-13 00:00:00	2003-09-13	5001	0	\N	0	0	\N	\N	0	256156	0	19926-5	3011505		
14441	1352	3006322	1986-08-24	1986-08-24 00:00:00	1986-08-24	5001	0	\N	0	0	\N	\N	0	89538	0	8331-1	3006322		
16373	1491	3006322	1975-09-13	1975-09-13 00:00:00	1975-09-13	5001	0	\N	0	0	\N	\N	0	99442	0	8331-1	3006322		
52969	4867	3006322	1988-04-12	1988-04-12 00:00:00	1988-04-12	5001	0	\N	0	0	\N	\N	0	323597	0	8331-1	3006322		
11279	1085	3006322	1988-04-28	1988-04-28 00:00:00	1988-04-28	5001	0	\N	0	0	\N	\N	0	71258	0	8331-1	3006322		
3392	331	3006322	2009-12-22	2009-12-22 00:00:00	2009-12-22	5001	0	\N	0	0	\N	\N	0	21785	0	8331-1	3006322		
41164	3834	3006322	1989-12-21	1989-12-21 00:00:00	1989-12-21	5001	0	\N	0	0	\N	\N	0	254551	0	8331-1	3006322		
48756	4454	3006322	1964-05-21	1964-05-21 00:00:00	1964-05-21	5001	0	\N	0	0	\N	\N	0	296387	0	8331-1	3006322		
121719	3756	4133840	2011-06-11	2011-06-11 00:00:00	2011-06-11	5001	0	\N	0	0	\N	\N	0	249661	0	127783003	4133840		
48000	1464	4024958	2002-06-01	2002-06-01 00:00:00	2002-06-01	5001	0	\N	0	0	\N	\N	0	97550	0	117015009	4024958		
34320	3128	3015076	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	208224	0	6248-9	3015076		
37677	3477	3000876	1986-04-20	1986-04-20 00:00:00	1986-04-20	5001	0	\N	0	0	\N	\N	0	230612	0	6082-2	3000876		
16212	1478	3013682	1975-05-03	1975-05-03 00:00:00	1975-05-03	5001	0	\N	0	0	\N	\N	0	98639	0	3094-0	3013682		
171295	5255	4024958	1971-07-27	1971-07-27 00:00:00	1971-07-27	5001	0	\N	0	0	\N	\N	0	349634	0	117015009	4024958		
45615	4206	3011505	1987-09-21	1987-09-21 00:00:00	1987-09-21	5001	0	\N	0	0	\N	\N	0	279307	0	19926-5	3011505		
54046	4945	3006322	2010-08-28	2010-08-28 00:00:00	2010-08-28	5001	0	\N	0	0	\N	\N	0	328671	0	8331-1	3006322		
2498	78	4024958	1998-02-28	1998-02-28 00:00:00	1998-02-28	5001	0	\N	0	0	\N	\N	0	5180	0	117015009	4024958		
50141	4572	3006322	2018-07-16	2018-07-16 00:00:00	2018-07-16	5001	0	\N	0	0	\N	\N	0	304626	0	8331-1	3006322		
51539	4719	3019406	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	314267	0	6158-0	3019406		
50616	4615	3006322	1995-09-25	1995-09-25 00:00:00	1995-09-25	5001	0	\N	0	0	\N	\N	0	307406	0	8331-1	3006322		
43534	4026	40769184	1977-01-30	1977-01-30 00:00:00	1977-01-30	5001	0	\N	0	0	\N	\N	0	267723	0	66524-0	40769184		
25408	2334	3011505	2004-05-13	2004-05-13 00:00:00	2004-05-13	5001	0	\N	0	0	\N	\N	0	155362	0	19926-5	3011505		
28311	2615	3006322	1986-03-22	1986-03-22 00:00:00	1986-03-22	5001	0	\N	0	0	\N	\N	0	172897	0	8331-1	3006322		
15650	1433	3006322	2017-03-21	2017-03-21 00:00:00	2017-03-21	5001	0	\N	0	0	\N	\N	0	95485	0	8331-1	3006322		
8734	842	3011505	2005-08-27	2005-08-27 00:00:00	2005-08-27	5001	0	\N	0	0	\N	\N	0	55702	0	19926-5	3011505		
15744	1441	3000876	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	96030	0	6082-2	3000876		
49349	4505	3005136	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	299990	0	6075-6	3005136		
152013	4655	4024958	1962-10-27	1962-10-27 00:00:00	1962-10-27	5001	0	\N	0	0	\N	\N	0	310391	0	117015009	4024958		
31645	2896	3014599	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	192802	0	6106-9	3014599		
31669	2896	3012494	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	192836	0	6206-7	3012494		
43060	3976	46235214	1965-09-09	1965-09-09 00:00:00	1965-09-09	5001	0	\N	0	0	\N	\N	0	264382	0	76690-7	46235214		
6132	576	3006322	1979-01-22	1979-01-22 00:00:00	1979-01-22	5001	0	\N	0	0	\N	\N	0	38071	0	8331-1	3006322		
51080	4662	3016723	1989-07-27	1989-07-27 00:00:00	1989-07-27	5001	0	\N	0	0	\N	\N	0	310773	0	2160-0	3016723		
1190	96	3011505	1984-02-18	1984-02-18 00:00:00	1984-02-18	5001	0	\N	0	0	\N	\N	0	6514	0	19926-5	3011505		
17648	1606	3006322	1959-06-23	1959-06-23 00:00:00	1959-06-23	5001	0	\N	0	0	\N	\N	0	107880	0	8331-1	3006322		
34656	3175	3006322	2009-09-03	2009-09-03 00:00:00	2009-09-03	5001	0	\N	0	0	\N	\N	0	211028	0	8331-1	3006322		
78024	2392	4133840	2004-06-25	2004-06-25 00:00:00	2004-06-25	5001	0	\N	0	0	\N	\N	0	158980	0	127783003	4133840		
40490	3759	3000876	1983-08-31	1983-08-31 00:00:00	1983-08-31	5001	0	\N	0	0	\N	\N	0	249968	0	6082-2	3000876		
53580	4923	3006322	2007-02-14	2007-02-14 00:00:00	2007-02-14	5001	0	\N	0	0	\N	\N	0	327130	0	8331-1	3006322		
17297	1574	40758406	1959-12-02	1959-12-02 00:00:00	1959-12-02	5001	0	\N	0	0	\N	\N	0	105658	0	55277-8	40758406		
24482	761	4052083	2008-01-16	2008-01-16 00:00:00	2008-01-16	5001	0	\N	0	0	\N	\N	0	50614	0	23426006	4052083		
52720	4844	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	322296	0	7258-7	3001488		
35000	3189	3006322	1982-03-01	1982-03-01 00:00:00	1982-03-01	5001	0	\N	0	0	\N	\N	0	212255	0	8331-1	3006322		
94548	2906	4052083	1977-03-24	1977-03-24 00:00:00	1977-03-24	5001	0	\N	0	0	\N	\N	0	193747	0	23426006	4052083		
20835	1918	3006322	1986-09-30	1986-09-30 00:00:00	1986-09-30	5001	0	\N	0	0	\N	\N	0	127650	0	8331-1	3006322		
20878	1923	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	127864	0	6075-6	3005136		
4062	404	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	26618	0	6246-3	3021226		
98143	3001	4052083	1998-12-27	1998-12-27 00:00:00	1998-12-27	5001	0	\N	0	0	\N	\N	0	200273	0	23426006	4052083		
9811	923	3006322	1986-11-05	1986-11-05 00:00:00	1986-11-05	5001	0	\N	0	0	\N	\N	0	61475	0	8331-1	3006322		
10182	971	3006322	1966-08-18	1966-08-18 00:00:00	1966-08-18	5001	0	\N	0	0	\N	\N	0	64607	0	8331-1	3006322		
17906	1626	21494966	1989-12-17	1989-12-17 00:00:00	1989-12-17	5001	0	\N	0	0	\N	\N	0	109189	0	80271-0	21494966		
17983	1636	3006322	1963-09-12	1963-09-12 00:00:00	1963-09-12	5001	0	\N	0	0	\N	\N	0	109896	0	8331-1	3006322		
23078	2123	3049273	2009-06-19	2009-06-19 00:00:00	2009-06-19	5001	0	\N	0	0	\N	\N	0	141303	0	38265-5	3049273		
34486	3147	3006322	1970-01-04	1970-01-04 00:00:00	1970-01-04	5001	0	\N	0	0	\N	\N	0	209414	0	8331-1	3006322		
33103	2988	46235214	1978-01-02	1978-01-02 00:00:00	1978-01-02	5001	0	\N	0	0	\N	\N	0	199468	0	76690-7	46235214		
6358	601	3021226	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	39759	0	6246-3	3021226		
7127	687	40769184	1967-11-30	1967-11-30 00:00:00	1967-11-30	5001	0	\N	0	0	\N	\N	0	45508	0	66524-0	40769184		
52277	4804	3023430	1990-03-26	1990-03-26 00:00:00	1990-03-26	5001	0	\N	0	0	\N	\N	0	319661	0	6833-8	3023430		
14059	1313	3006322	1989-07-17	1989-07-17 00:00:00	1989-07-17	5001	0	\N	0	0	\N	\N	0	86926	0	8331-1	3006322		
29931	2758	3006322	1979-07-18	1979-07-18 00:00:00	1979-07-18	5001	0	\N	0	0	\N	\N	0	182390	0	8331-1	3006322		
29985	2765	3011505	2015-12-22	2015-12-22 00:00:00	2015-12-22	5001	0	\N	0	0	\N	\N	0	182917	0	19926-5	3011505		
47600	4373	3021226	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	290425	0	6246-3	3021226		
41428	3859	3011505	2006-09-30	2006-09-30 00:00:00	2006-09-30	5001	0	\N	0	0	\N	\N	0	256258	0	19926-5	3011505		
14442	1352	3011505	2015-03-22	2015-03-22 00:00:00	2015-03-22	5001	0	\N	0	0	\N	\N	0	89546	0	19926-5	3011505		
16374	1491	3006322	2008-05-05	2008-05-05 00:00:00	2008-05-05	5001	0	\N	0	0	\N	\N	0	99414	0	8331-1	3006322		
52970	4867	3006322	1967-09-16	1967-09-16 00:00:00	1967-09-16	5001	0	\N	0	0	\N	\N	0	323666	0	8331-1	3006322		
11280	1085	3006322	1971-06-03	1971-06-03 00:00:00	1971-06-03	5001	0	\N	0	0	\N	\N	0	71242	0	8331-1	3006322		
3393	332	3006322	1994-08-17	1994-08-17 00:00:00	1994-08-17	5001	0	\N	0	0	\N	\N	0	21922	0	8331-1	3006322		
41165	3834	3006322	2004-12-27	2004-12-27 00:00:00	2004-12-27	5001	0	\N	0	0	\N	\N	0	254625	0	8331-1	3006322		
48760	4456	3006322	1999-11-03	1999-11-03 00:00:00	1999-11-03	5001	0	\N	0	0	\N	\N	0	296576	0	8331-1	3006322		
19600	1789	3006451	1976-03-06	1976-03-06 00:00:00	1976-03-06	5001	0	\N	0	0	\N	\N	0	119926	0	6273-7	3006451		
48011	1464	4024958	1968-05-03	1968-05-03 00:00:00	1968-05-03	5001	0	\N	0	0	\N	\N	0	97533	0	117015009	4024958		
34321	3128	3006734	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	208224	0	6189-5	3006734		
37678	3477	3006451	1986-04-20	1986-04-20 00:00:00	1986-04-20	5001	0	\N	0	0	\N	\N	0	230612	0	6273-7	3006451		
16213	1478	3020630	1975-05-03	1975-05-03 00:00:00	1975-05-03	5001	0	\N	0	0	\N	\N	0	98639	0	2885-2	3020630		
171296	5255	4024958	2018-06-24	2018-06-24 00:00:00	2018-06-24	5001	0	\N	0	0	\N	\N	0	349668	0	117015009	4024958		
45617	4206	3006322	1970-12-12	1970-12-12 00:00:00	1970-12-12	5001	0	\N	0	0	\N	\N	0	279278	0	8331-1	3006322		
54047	4945	3006322	1994-11-08	1994-11-08 00:00:00	1994-11-08	5001	0	\N	0	0	\N	\N	0	328727	0	8331-1	3006322		
2500	78	4024958	2003-08-23	2003-08-23 00:00:00	2003-08-23	5001	0	\N	0	0	\N	\N	0	5181	0	117015009	4024958		
50142	4572	3006322	1994-03-15	1994-03-15 00:00:00	1994-03-15	5001	0	\N	0	0	\N	\N	0	304601	0	8331-1	3006322		
51540	4719	3005136	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	314267	0	6075-6	3005136		
50617	4615	3006322	2009-05-16	2009-05-16 00:00:00	2009-05-16	5001	0	\N	0	0	\N	\N	0	307377	0	8331-1	3006322		
43535	4026	40769194	1977-01-30	1977-01-30 00:00:00	1977-01-30	5001	0	\N	0	0	\N	\N	0	267723	0	66534-9	40769194		
25409	2334	3011505	2017-07-27	2017-07-27 00:00:00	2017-07-27	5001	0	\N	0	0	\N	\N	0	155366	0	19926-5	3011505		
28312	2616	3006322	1963-09-27	1963-09-27 00:00:00	1963-09-27	5001	0	\N	0	0	\N	\N	0	173010	0	8331-1	3006322		
15651	1433	3006322	1963-07-18	1963-07-18 00:00:00	1963-07-18	5001	0	\N	0	0	\N	\N	0	95459	0	8331-1	3006322		
8735	842	3006322	1955-02-18	1955-02-18 00:00:00	1955-02-18	5001	0	\N	0	0	\N	\N	0	55638	0	8331-1	3006322		
15745	1441	3019406	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	96030	0	6158-0	3019406		
49350	4505	3027231	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	299990	0	6276-0	3027231		
152018	4655	4024958	1974-01-19	1974-01-19 00:00:00	1974-01-19	5001	0	\N	0	0	\N	\N	0	310309	0	117015009	4024958		
31646	2896	3006451	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	192802	0	6273-7	3006451		
31670	2896	3020655	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	192836	0	6844-5	3020655		
43061	3976	40766240	1965-09-09	1965-09-09 00:00:00	1965-09-09	5001	0	\N	0	0	\N	\N	0	264382	0	63513-6	40766240		
6135	578	46235214	2010-08-18	2010-08-18 00:00:00	2010-08-18	5001	0	\N	0	0	\N	\N	0	38276	0	76690-7	46235214		
51081	4662	3013721	1989-07-27	1989-07-27 00:00:00	1989-07-27	5001	0	\N	0	0	\N	\N	0	310773	0	1920-8	3013721		
1191	96	3011505	1965-06-12	1965-06-12 00:00:00	1965-06-12	5001	0	\N	0	0	\N	\N	0	6489	0	19926-5	3011505		
17652	1608	3006322	2017-11-02	2017-11-02 00:00:00	2017-11-02	5001	0	\N	0	0	\N	\N	0	108048	0	8331-1	3006322		
34657	3175	3006322	1992-07-28	1992-07-28 00:00:00	1992-07-28	5001	0	\N	0	0	\N	\N	0	211049	0	8331-1	3006322		
78030	2392	4133840	1979-11-23	1979-11-23 00:00:00	1979-11-23	5001	0	\N	0	0	\N	\N	0	159077	0	127783003	4133840		
40491	3759	3014599	1983-08-31	1983-08-31 00:00:00	1983-08-31	5001	0	\N	0	0	\N	\N	0	249968	0	6106-9	3014599		
53581	4923	3006322	1969-01-10	1969-01-10 00:00:00	1969-01-10	5001	0	\N	0	0	\N	\N	0	327096	0	8331-1	3006322		
17298	1574	3006322	1970-03-25	1970-03-25 00:00:00	1970-03-25	5001	0	\N	0	0	\N	\N	0	105660	0	8331-1	3006322		
24493	761	4052083	1991-04-19	1991-04-19 00:00:00	1991-04-19	5001	0	\N	0	0	\N	\N	0	50546	0	23426006	4052083		
52721	4844	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	322296	0	6833-8	3023430		
35001	3189	3006322	2005-04-20	2005-04-20 00:00:00	2005-04-20	5001	0	\N	0	0	\N	\N	0	212236	0	8331-1	3006322		
117894	3628	4052083	1931-02-06	1931-02-06 00:00:00	1931-02-06	5001	0	\N	0	0	\N	\N	0	241358	0	23426006	4052083		
20843	1921	3006322	1978-03-18	1978-03-18 00:00:00	1978-03-18	5001	0	\N	0	0	\N	\N	0	127743	0	8331-1	3006322		
20879	1923	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	127864	0	6246-3	3021226		
4063	404	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	26618	0	6189-5	3006734		
98154	3002	4052083	2014-11-27	2014-11-27 00:00:00	2014-11-27	5001	0	\N	0	0	\N	\N	0	200348	0	23426006	4052083		
9812	923	3006322	2015-12-07	2015-12-07 00:00:00	2015-12-07	5001	0	\N	0	0	\N	\N	0	61478	0	8331-1	3006322		
10183	971	3006322	1947-04-01	1947-04-01 00:00:00	1947-04-01	5001	0	\N	0	0	\N	\N	0	64584	0	8331-1	3006322		
61588	1885	4052083	2019-04-01	2019-04-01 00:00:00	2019-04-01	5001	0	\N	0	0	\N	\N	0	125691	0	23426006	4052083		
17984	1636	3006322	1960-08-18	1960-08-18 00:00:00	1960-08-18	5001	0	\N	0	0	\N	\N	0	109857	0	8331-1	3006322		
23079	2123	3049273	2002-05-19	2002-05-19 00:00:00	2002-05-19	5001	0	\N	0	0	\N	\N	0	141321	0	38265-5	3049273		
34487	3147	3011505	2015-05-25	2015-05-25 00:00:00	2015-05-25	5001	0	\N	0	0	\N	\N	0	209411	0	19926-5	3011505		
33104	2988	40766240	1978-01-02	1978-01-02 00:00:00	1978-01-02	5001	0	\N	0	0	\N	\N	0	199468	0	63513-6	40766240		
6359	601	3036780	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	39759	0	6095-4	3036780		
7128	687	40769189	1967-11-30	1967-11-30 00:00:00	1967-11-30	5001	0	\N	0	0	\N	\N	0	45508	0	66529-9	40769189		
52278	4804	3020655	1990-03-26	1990-03-26 00:00:00	1990-03-26	5001	0	\N	0	0	\N	\N	0	319661	0	6844-5	3020655		
14060	1313	3006322	1999-08-30	1999-08-30 00:00:00	1999-08-30	5001	0	\N	0	0	\N	\N	0	86891	0	8331-1	3006322		
29932	2758	3006322	1947-03-12	1947-03-12 00:00:00	1947-03-12	5001	0	\N	0	0	\N	\N	0	182475	0	8331-1	3006322		
29986	2765	3011505	2006-10-31	2006-10-31 00:00:00	2006-10-31	5001	0	\N	0	0	\N	\N	0	182833	0	19926-5	3011505		
47601	4373	3006451	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	290425	0	6273-7	3006451		
41429	3859	3011505	1994-07-23	1994-07-23 00:00:00	1994-07-23	5001	0	\N	0	0	\N	\N	0	256171	0	19926-5	3011505		
14443	1352	3011505	2002-04-07	2002-04-07 00:00:00	2002-04-07	5001	0	\N	0	0	\N	\N	0	89577	0	19926-5	3011505		
16375	1491	3006322	2002-05-26	2002-05-26 00:00:00	2002-05-26	5001	0	\N	0	0	\N	\N	0	99406	0	8331-1	3006322		
52971	4867	3006322	1983-05-26	1983-05-26 00:00:00	1983-05-26	5001	0	\N	0	0	\N	\N	0	323710	0	8331-1	3006322		
11281	1085	3006322	2002-10-07	2002-10-07 00:00:00	2002-10-07	5001	0	\N	0	0	\N	\N	0	71290	0	8331-1	3006322		
3394	332	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	22053	0	6082-2	3000876		
41166	3834	3006322	1973-04-27	1973-04-27 00:00:00	1973-04-27	5001	0	\N	0	0	\N	\N	0	254604	0	8331-1	3006322		
48761	4456	3006322	1982-09-19	1982-09-19 00:00:00	1982-09-19	5001	0	\N	0	0	\N	\N	0	296574	0	8331-1	3006322		
19601	1789	3021226	1976-03-06	1976-03-06 00:00:00	1976-03-06	5001	0	\N	0	0	\N	\N	0	119926	0	6246-3	3021226		
48022	1466	4024958	1998-11-04	1998-11-04 00:00:00	1998-11-04	5001	0	\N	0	0	\N	\N	0	97662	0	117015009	4024958		
34322	3128	3023430	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	208224	0	6833-8	3023430		
37679	3477	3021226	1986-04-20	1986-04-20 00:00:00	1986-04-20	5001	0	\N	0	0	\N	\N	0	230612	0	6246-3	3021226		
16214	1478	3045716	1975-05-03	1975-05-03 00:00:00	1975-05-03	5001	0	\N	0	0	\N	\N	0	98639	0	33037-3	3045716		
171297	5255	4052083	1962-01-14	1962-01-14 00:00:00	1962-01-14	5001	0	\N	0	0	\N	\N	0	349628	0	23426006	4052083		
45618	4206	3011505	1989-09-25	1989-09-25 00:00:00	1989-09-25	5001	0	\N	0	0	\N	\N	0	279330	0	19926-5	3011505		
147923	4532	4052083	1980-06-28	1980-06-28 00:00:00	1980-06-28	5001	0	\N	0	0	\N	\N	0	301920	0	23426006	4052083		
2501	78	4024958	1967-02-07	1967-02-07 00:00:00	1967-02-07	5001	0	\N	0	0	\N	\N	0	5155	0	117015009	4024958		
50143	4572	3006322	1980-05-08	1980-05-08 00:00:00	1980-05-08	5001	0	\N	0	0	\N	\N	0	304621	0	8331-1	3006322		
51541	4719	3027231	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	314267	0	6276-0	3027231		
50618	4615	3006322	1969-04-07	1969-04-07 00:00:00	1969-04-07	5001	0	\N	0	0	\N	\N	0	307426	0	8331-1	3006322		
43536	4026	40769189	1977-01-30	1977-01-30 00:00:00	1977-01-30	5001	0	\N	0	0	\N	\N	0	267723	0	66529-9	40769189		
25410	2334	3011505	2010-06-17	2010-06-17 00:00:00	2010-06-17	5001	0	\N	0	0	\N	\N	0	155283	0	19926-5	3011505		
28313	2616	3006322	2002-07-04	2002-07-04 00:00:00	2002-07-04	5001	0	\N	0	0	\N	\N	0	172942	0	8331-1	3006322		
15654	1435	3006322	2018-10-16	2018-10-16 00:00:00	2018-10-16	5001	0	\N	0	0	\N	\N	0	95588	0	8331-1	3006322		
8736	842	3011505	1966-10-22	1966-10-22 00:00:00	1966-10-22	5001	0	\N	0	0	\N	\N	0	55729	0	19926-5	3011505		
15746	1441	3005136	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	96030	0	6075-6	3005136		
120032	3701	4024958	1959-12-16	1959-12-16 00:00:00	1959-12-16	5001	0	\N	0	0	\N	\N	0	246057	0	117015009	4024958		
37629	1169	4052083	1944-04-13	1944-04-13 00:00:00	1944-04-13	5001	0	\N	0	0	\N	\N	0	77029	0	23426006	4052083		
31647	2896	3021226	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	192802	0	6246-3	3021226		
31671	2896	3019406	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	192836	0	6158-0	3019406		
43063	3976	3006322	2007-09-27	2007-09-27 00:00:00	2007-09-27	5001	0	\N	0	0	\N	\N	0	264358	0	8331-1	3006322		
6137	578	3051031	2010-08-18	2010-08-18 00:00:00	2010-08-18	5001	0	\N	0	0	\N	\N	0	38276	0	46240-8	3051031		
51082	4662	3009542	1989-07-27	1989-07-27 00:00:00	1989-07-27	5001	0	\N	0	0	\N	\N	0	310773	0	20570-8	3009542		
1192	96	3006322	1925-08-26	1925-08-26 00:00:00	1925-08-26	5001	0	\N	0	0	\N	\N	0	6540	0	8331-1	3006322		
17653	1608	3006322	1943-08-05	1943-08-05 00:00:00	1943-08-05	5001	0	\N	0	0	\N	\N	0	108016	0	8331-1	3006322		
34658	3175	3006322	1957-01-07	1957-01-07 00:00:00	1957-01-07	5001	0	\N	0	0	\N	\N	0	211017	0	8331-1	3006322		
78031	2392	4133840	1966-02-04	1966-02-04 00:00:00	1966-02-04	5001	0	\N	0	0	\N	\N	0	159083	0	127783003	4133840		
40492	3759	3027231	1983-08-31	1983-08-31 00:00:00	1983-08-31	5001	0	\N	0	0	\N	\N	0	249968	0	6276-0	3027231		
53582	4924	3006322	2014-03-18	2014-03-18 00:00:00	2014-03-18	5001	0	\N	0	0	\N	\N	0	327192	0	8331-1	3006322		
17299	1574	3006322	1965-11-26	1965-11-26 00:00:00	1965-11-26	5001	0	\N	0	0	\N	\N	0	105693	0	8331-1	3006322		
24499	762	4052083	1996-12-31	1996-12-31 00:00:00	1996-12-31	5001	0	\N	0	0	\N	\N	0	50658	0	23426006	4052083		
52722	4844	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	322296	0	6844-5	3020655		
35002	3189	3006322	1968-08-31	1968-08-31 00:00:00	1968-08-31	5001	0	\N	0	0	\N	\N	0	212217	0	8331-1	3006322		
117901	3628	4052083	2000-08-16	2000-08-16 00:00:00	2000-08-16	5001	0	\N	0	0	\N	\N	0	241395	0	23426006	4052083		
20844	1921	3006322	1954-10-09	1954-10-09 00:00:00	1954-10-09	5001	0	\N	0	0	\N	\N	0	127762	0	8331-1	3006322		
20880	1923	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	127864	0	6206-7	3012494		
4064	404	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	26618	0	6833-8	3023430		
98162	3002	4024958	1980-04-28	1980-04-28 00:00:00	1980-04-28	5001	0	\N	0	0	\N	\N	0	200384	0	117015009	4024958		
9813	923	3006322	1970-11-02	1970-11-02 00:00:00	1970-11-02	5001	0	\N	0	0	\N	\N	0	61472	0	8331-1	3006322		
10184	971	3006322	1960-11-04	1960-11-04 00:00:00	1960-11-04	5001	0	\N	0	0	\N	\N	0	64589	0	8331-1	3006322		
61600	1885	4024958	2009-02-19	2009-02-19 00:00:00	2009-02-19	5001	0	\N	0	0	\N	\N	0	125675	0	117015009	4024958		
134251	4133	4024958	1993-09-25	1993-09-25 00:00:00	1993-09-25	5001	0	\N	0	0	\N	\N	0	274767	0	117015009	4024958		
23080	2123	3006322	1963-05-23	1963-05-23 00:00:00	1963-05-23	5001	0	\N	0	0	\N	\N	0	141260	0	8331-1	3006322		
34488	3147	3011505	2006-04-03	2006-04-03 00:00:00	2006-04-03	5001	0	\N	0	0	\N	\N	0	209387	0	19926-5	3011505		
33106	2988	3006322	1974-01-20	1974-01-20 00:00:00	1974-01-20	5001	0	\N	0	0	\N	\N	0	199482	0	8331-1	3006322		
6360	601	3027231	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	39759	0	6276-0	3027231		
7129	687	40769179	1967-11-30	1967-11-30 00:00:00	1967-11-30	5001	0	\N	0	0	\N	\N	0	45508	0	66519-0	40769179		
52279	4804	3006734	1990-03-26	1990-03-26 00:00:00	1990-03-26	5001	0	\N	0	0	\N	\N	0	319661	0	6189-5	3006734		
14062	1314	3006322	1977-01-01	1977-01-01 00:00:00	1977-01-01	5001	0	\N	0	0	\N	\N	0	86988	0	8331-1	3006322		
29933	2758	3006322	2013-01-01	2013-01-01 00:00:00	2013-01-01	5001	0	\N	0	0	\N	\N	0	182406	0	8331-1	3006322		
29987	2765	3011505	2008-11-11	2008-11-11 00:00:00	2008-11-11	5001	0	\N	0	0	\N	\N	0	182834	0	19926-5	3011505		
47602	4373	3015076	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	290425	0	6248-9	3015076		
41430	3859	3011505	2018-04-28	2018-04-28 00:00:00	2018-04-28	5001	0	\N	0	0	\N	\N	0	256183	0	19926-5	3011505		
14444	1352	3011505	2006-04-30	2006-04-30 00:00:00	2006-04-30	5001	0	\N	0	0	\N	\N	0	89542	0	19926-5	3011505		
29609	917	4052083	1981-02-11	1981-02-11 00:00:00	1981-02-11	5001	0	\N	0	0	\N	\N	0	61016	0	23426006	4052083		
52972	4867	3006322	1996-11-13	1996-11-13 00:00:00	1996-11-13	5001	0	\N	0	0	\N	\N	0	323598	0	8331-1	3006322		
11282	1086	3006322	2007-03-07	2007-03-07 00:00:00	2007-03-07	5001	0	\N	0	0	\N	\N	0	71322	0	8331-1	3006322		
3395	332	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	22053	0	6075-6	3005136		
41167	3835	3006322	1967-12-10	1967-12-10 00:00:00	1967-12-10	5001	0	\N	0	0	\N	\N	0	254635	0	8331-1	3006322		
48762	4456	3006322	2004-07-19	2004-07-19 00:00:00	2004-07-19	5001	0	\N	0	0	\N	\N	0	296554	0	8331-1	3006322		
19602	1789	3000876	1976-03-06	1976-03-06 00:00:00	1976-03-06	5001	0	\N	0	0	\N	\N	0	119926	0	6082-2	3000876		
48034	1466	4024958	1978-02-27	1978-02-27 00:00:00	1978-02-27	5001	0	\N	0	0	\N	\N	0	97621	0	117015009	4024958		
34323	3128	3006322	2011-01-10	2011-01-10 00:00:00	2011-01-10	5001	0	\N	0	0	\N	\N	0	208175	0	8331-1	3006322		
37680	3477	3012494	1986-04-20	1986-04-20 00:00:00	1986-04-20	5001	0	\N	0	0	\N	\N	0	230612	0	6206-7	3012494		
16215	1478	3015632	1975-05-03	1975-05-03 00:00:00	1975-05-03	5001	0	\N	0	0	\N	\N	0	98639	0	2028-9	3015632		
171301	5255	4024958	1993-07-02	1993-07-02 00:00:00	1993-07-02	5001	0	\N	0	0	\N	\N	0	349677	0	117015009	4024958		
45619	4206	3011505	1993-09-06	1993-09-06 00:00:00	1993-09-06	5001	0	\N	0	0	\N	\N	0	279309	0	19926-5	3011505		
147939	4532	4024958	1910-08-13	1910-08-13 00:00:00	1910-08-13	5001	0	\N	0	0	\N	\N	0	301911	0	117015009	4024958		
2502	78	4024958	1985-05-13	1985-05-13 00:00:00	1985-05-13	5001	0	\N	0	0	\N	\N	0	5178	0	117015009	4024958		
50144	4572	3006322	2016-08-13	2016-08-13 00:00:00	2016-08-13	5001	0	\N	0	0	\N	\N	0	304603	0	8331-1	3006322		
51542	4719	3021226	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	314267	0	6246-3	3021226		
127259	3916	4052083	2012-10-07	2012-10-07 00:00:00	2012-10-07	5001	0	\N	0	0	\N	\N	0	260309	0	23426006	4052083		
43537	4026	3011505	2019-03-17	2019-03-17 00:00:00	2019-03-17	5001	0	\N	0	0	\N	\N	0	267602	0	19926-5	3011505		
25411	2334	3011505	2015-07-16	2015-07-16 00:00:00	2015-07-16	5001	0	\N	0	0	\N	\N	0	155365	0	19926-5	3011505		
28314	2616	3049273	2012-01-10	2012-01-10 00:00:00	2012-01-10	5001	0	\N	0	0	\N	\N	0	173007	0	38265-5	3049273		
15655	1435	3006322	1975-11-17	1975-11-17 00:00:00	1975-11-17	5001	0	\N	0	0	\N	\N	0	95574	0	8331-1	3006322		
8737	842	3011505	1994-06-25	1994-06-25 00:00:00	1994-06-25	5001	0	\N	0	0	\N	\N	0	55750	0	19926-5	3011505		
15747	1441	3006451	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	96030	0	6273-7	3006451		
120038	3701	4052083	1980-06-16	1980-06-16 00:00:00	1980-06-16	5001	0	\N	0	0	\N	\N	0	246119	0	23426006	4052083		
129583	3991	4024958	1972-02-22	1972-02-22 00:00:00	1972-02-22	5001	0	\N	0	0	\N	\N	0	265342	0	117015009	4024958		
31648	2896	3005136	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	192802	0	6075-6	3005136		
31672	2897	3006322	1967-07-29	1967-07-29 00:00:00	1967-07-29	5001	0	\N	0	0	\N	\N	0	192963	0	8331-1	3006322		
43074	3980	3006322	1981-12-20	1981-12-20 00:00:00	1981-12-20	5001	0	\N	0	0	\N	\N	0	264614	0	8331-1	3006322		
6138	578	40758406	2010-08-18	2010-08-18 00:00:00	2010-08-18	5001	0	\N	0	0	\N	\N	0	38276	0	55277-8	40758406		
51083	4662	21494966	1989-07-27	1989-07-27 00:00:00	1989-07-27	5001	0	\N	0	0	\N	\N	0	310773	0	80271-0	21494966		
1193	96	3011505	1957-06-01	1957-06-01 00:00:00	1957-06-01	5001	0	\N	0	0	\N	\N	0	6561	0	19926-5	3011505		
17654	1608	3006322	1985-06-01	1985-06-01 00:00:00	1985-06-01	5001	0	\N	0	0	\N	\N	0	107977	0	8331-1	3006322		
34659	3175	3006322	1993-04-04	1993-04-04 00:00:00	1993-04-04	5001	0	\N	0	0	\N	\N	0	211006	0	8331-1	3006322		
78034	2392	4133840	1988-03-25	1988-03-25 00:00:00	1988-03-25	5001	0	\N	0	0	\N	\N	0	159059	0	127783003	4133840		
40493	3759	3021226	1983-08-31	1983-08-31 00:00:00	1983-08-31	5001	0	\N	0	0	\N	\N	0	249968	0	6246-3	3021226		
53583	4924	3006322	1996-07-04	1996-07-04 00:00:00	1996-07-04	5001	0	\N	0	0	\N	\N	0	327250	0	8331-1	3006322		
17301	1574	40766240	1988-07-22	1988-07-22 00:00:00	1988-07-22	5001	0	\N	0	0	\N	\N	0	105696	0	63513-6	40766240		
24508	762	4052083	2017-01-23	2017-01-23 00:00:00	2017-01-23	5001	0	\N	0	0	\N	\N	0	50678	0	23426006	4052083		
52723	4844	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	322296	0	6273-7	3006451		
35003	3189	3006322	1987-12-08	1987-12-08 00:00:00	1987-12-08	5001	0	\N	0	0	\N	\N	0	212232	0	8331-1	3006322		
117904	3628	4052083	1965-10-25	1965-10-25 00:00:00	1965-10-25	5001	0	\N	0	0	\N	\N	0	241361	0	23426006	4052083		
20845	1921	3006322	1999-10-07	1999-10-07 00:00:00	1999-10-07	5001	0	\N	0	0	\N	\N	0	127746	0	8331-1	3006322		
20881	1923	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	127864	0	6273-7	3006451		
4065	404	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	26618	0	6082-2	3000876		
98178	3004	4052083	2008-07-17	2008-07-17 00:00:00	2008-07-17	5001	0	\N	0	0	\N	\N	0	200502	0	23426006	4052083		
9814	923	3006322	1978-02-06	1978-02-06 00:00:00	1978-02-06	5001	0	\N	0	0	\N	\N	0	61420	0	8331-1	3006322		
10185	971	3006322	1966-11-29	1966-11-29 00:00:00	1966-11-29	5001	0	\N	0	0	\N	\N	0	64608	0	8331-1	3006322		
119202	3672	4024958	1967-09-26	1967-09-26 00:00:00	1967-09-26	5001	0	\N	0	0	\N	\N	0	244285	0	117015009	4024958		
134252	4133	4024958	2018-11-25	2018-11-25 00:00:00	2018-11-25	5001	0	\N	0	0	\N	\N	0	274789	0	117015009	4024958		
23081	2123	3006322	1984-11-11	1984-11-11 00:00:00	1984-11-11	5001	0	\N	0	0	\N	\N	0	141309	0	8331-1	3006322		
34489	3147	3011505	1976-02-16	1976-02-16 00:00:00	1976-02-16	5001	0	\N	0	0	\N	\N	0	209345	0	19926-5	3011505		
33107	2988	3006322	2011-10-04	2011-10-04 00:00:00	2011-10-04	5001	0	\N	0	0	\N	\N	0	199444	0	8331-1	3006322		
6361	601	3014599	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	39759	0	6106-9	3014599		
7130	687	40769194	1967-11-30	1967-11-30 00:00:00	1967-11-30	5001	0	\N	0	0	\N	\N	0	45508	0	66534-9	40769194		
52280	4804	3000876	1978-01-28	1978-01-28 00:00:00	1978-01-28	5001	0	\N	0	0	\N	\N	0	319658	0	6082-2	3000876		
14063	1314	3006322	1966-03-17	1966-03-17 00:00:00	1966-03-17	5001	0	\N	0	0	\N	\N	0	87047	0	8331-1	3006322		
29934	2758	3006322	1960-03-15	1960-03-15 00:00:00	1960-03-15	5001	0	\N	0	0	\N	\N	0	182478	0	8331-1	3006322		
29988	2765	3001488	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	182987	0	7258-7	3001488		
47603	4373	3019406	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	290425	0	6158-0	3019406		
41431	3859	3011505	2004-09-18	2004-09-18 00:00:00	2004-09-18	5001	0	\N	0	0	\N	\N	0	256240	0	19926-5	3011505		
14445	1352	3006322	1972-07-13	1972-07-13 00:00:00	1972-07-13	5001	0	\N	0	0	\N	\N	0	89560	0	8331-1	3006322		
29635	917	4052083	1996-11-18	1996-11-18 00:00:00	1996-11-18	5001	0	\N	0	0	\N	\N	0	60928	0	23426006	4052083		
52973	4867	3006322	1948-02-09	1948-02-09 00:00:00	1948-02-09	5001	0	\N	0	0	\N	\N	0	323665	0	8331-1	3006322		
11283	1086	3006322	2004-04-05	2004-04-05 00:00:00	2004-04-05	5001	0	\N	0	0	\N	\N	0	71339	0	8331-1	3006322		
3396	332	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	22053	0	6248-9	3015076		
41168	3835	3006322	1997-05-27	1997-05-27 00:00:00	1997-05-27	5001	0	\N	0	0	\N	\N	0	254644	0	8331-1	3006322		
48763	4457	3006322	2003-11-02	2003-11-02 00:00:00	2003-11-02	5001	0	\N	0	0	\N	\N	0	296621	0	8331-1	3006322		
19603	1789	3001488	1976-03-06	1976-03-06 00:00:00	1976-03-06	5001	0	\N	0	0	\N	\N	0	119926	0	7258-7	3001488		
48039	1466	4024958	2008-11-24	2008-11-24 00:00:00	2008-11-24	5001	0	\N	0	0	\N	\N	0	97612	0	117015009	4024958		
34324	3128	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	208215	0	6082-2	3000876		
37681	3477	3014599	1986-04-20	1986-04-20 00:00:00	1986-04-20	5001	0	\N	0	0	\N	\N	0	230612	0	6106-9	3014599		
16216	1478	3007461	1975-05-03	1975-05-03 00:00:00	1975-05-03	5001	0	\N	0	0	\N	\N	0	98639	0	26515-7	3007461		
9130	870	3006322	2006-09-05	2006-09-05 00:00:00	2006-09-05	5001	0	\N	0	0	\N	\N	0	57864	0	8331-1	3006322		
45620	4206	3011505	1995-09-18	1995-09-18 00:00:00	1995-09-18	5001	0	\N	0	0	\N	\N	0	279310	0	19926-5	3011505		
147978	4534	4052083	2003-02-11	2003-02-11 00:00:00	2003-02-11	5001	0	\N	0	0	\N	\N	0	302025	0	23426006	4052083		
2506	78	4024958	1997-10-20	1997-10-20 00:00:00	1997-10-20	5001	0	\N	0	0	\N	\N	0	5179	0	117015009	4024958		
50145	4572	3006322	1993-12-01	1993-12-01 00:00:00	1993-12-01	5001	0	\N	0	0	\N	\N	0	304639	0	8331-1	3006322		
51543	4719	3001488	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	314267	0	7258-7	3001488		
138589	4274	4052083	1938-04-27	1938-04-27 00:00:00	1938-04-27	5001	0	\N	0	0	\N	\N	0	283633	0	23426006	4052083		
43538	4026	3015076	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	267614	0	6248-9	3015076		
25412	2334	3011505	1996-03-28	1996-03-28 00:00:00	1996-03-28	5001	0	\N	0	0	\N	\N	0	155292	0	19926-5	3011505		
28315	2616	3006322	2009-10-08	2009-10-08 00:00:00	2009-10-08	5001	0	\N	0	0	\N	\N	0	172944	0	8331-1	3006322		
15656	1435	3006322	1997-01-29	1997-01-29 00:00:00	1997-01-29	5001	0	\N	0	0	\N	\N	0	95561	0	8331-1	3006322		
8738	842	3011505	2008-09-13	2008-09-13 00:00:00	2008-09-13	5001	0	\N	0	0	\N	\N	0	55699	0	19926-5	3011505		
15748	1441	3001488	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	96030	0	7258-7	3001488		
74391	2283	4052083	1960-01-15	1960-01-15 00:00:00	1960-01-15	5001	0	\N	0	0	\N	\N	0	151878	0	23426006	4052083		
164190	5043	4024958	1976-09-17	1976-09-17 00:00:00	1976-09-17	5001	0	\N	0	0	\N	\N	0	335162	0	117015009	4024958		
31649	2896	3015076	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	192802	0	6248-9	3015076		
31673	2897	3006322	1998-03-11	1998-03-11 00:00:00	1998-03-11	5001	0	\N	0	0	\N	\N	0	192925	0	8331-1	3006322		
43075	3980	3006322	2001-08-01	2001-08-01 00:00:00	2001-08-01	5001	0	\N	0	0	\N	\N	0	264581	0	8331-1	3006322		
6140	578	40766240	2010-08-18	2010-08-18 00:00:00	2010-08-18	5001	0	\N	0	0	\N	\N	0	38276	0	63513-6	40766240		
51084	4662	3024561	1989-07-27	1989-07-27 00:00:00	1989-07-27	5001	0	\N	0	0	\N	\N	0	310773	0	1751-7	3024561		
1194	96	3011505	1979-01-20	1979-01-20 00:00:00	1979-01-20	5001	0	\N	0	0	\N	\N	0	6481	0	19926-5	3011505		
17655	1608	3006322	1987-05-06	1987-05-06 00:00:00	1987-05-06	5001	0	\N	0	0	\N	\N	0	108001	0	8331-1	3006322		
34660	3175	3006322	1954-05-09	1954-05-09 00:00:00	1954-05-09	5001	0	\N	0	0	\N	\N	0	211016	0	8331-1	3006322		
78036	2392	4133840	2002-06-14	2002-06-14 00:00:00	2002-06-14	5001	0	\N	0	0	\N	\N	0	158979	0	127783003	4133840		
40494	3759	3006322	1973-02-26	1973-02-26 00:00:00	1973-02-26	5001	0	\N	0	0	\N	\N	0	249881	0	8331-1	3006322		
53584	4924	3006322	1985-05-24	1985-05-24 00:00:00	1985-05-24	5001	0	\N	0	0	\N	\N	0	327279	0	8331-1	3006322		
17302	1574	46235214	1988-07-22	1988-07-22 00:00:00	1988-07-22	5001	0	\N	0	0	\N	\N	0	105696	0	76690-7	46235214		
139213	4288	4024958	1960-08-22	1960-08-22 00:00:00	1960-08-22	5001	0	\N	0	0	\N	\N	0	284698	0	117015009	4024958		
52724	4844	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	322296	0	6248-9	3015076		
35005	3191	3006322	2013-11-12	2013-11-12 00:00:00	2013-11-12	5001	0	\N	0	0	\N	\N	0	212338	0	8331-1	3006322		
117909	3628	4052083	1999-03-10	1999-03-10 00:00:00	1999-03-10	5001	0	\N	0	0	\N	\N	0	241299	0	23426006	4052083		
20849	1923	3006322	1946-08-09	1946-08-09 00:00:00	1946-08-09	5001	0	\N	0	0	\N	\N	0	127951	0	8331-1	3006322		
20882	1923	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	127864	0	6833-8	3023430		
4066	404	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	26618	0	6844-5	3020655		
98180	3004	4024958	1961-10-08	1961-10-08 00:00:00	1961-10-08	5001	0	\N	0	0	\N	\N	0	200455	0	117015009	4024958		
9815	923	3006322	2012-10-27	2012-10-27 00:00:00	2012-10-27	5001	0	\N	0	0	\N	\N	0	61436	0	8331-1	3006322		
10186	971	3006322	2008-03-03	2008-03-03 00:00:00	2008-03-03	5001	0	\N	0	0	\N	\N	0	64586	0	8331-1	3006322		
119211	3672	4024958	1975-08-27	1975-08-27 00:00:00	1975-08-27	5001	0	\N	0	0	\N	\N	0	244287	0	117015009	4024958		
134253	4133	4024958	1992-06-19	1992-06-19 00:00:00	1992-06-19	5001	0	\N	0	0	\N	\N	0	274797	0	117015009	4024958		
23089	2127	3006322	2016-12-21	2016-12-21 00:00:00	2016-12-21	5001	0	\N	0	0	\N	\N	0	141455	0	8331-1	3006322		
34490	3147	3011505	2009-04-20	2009-04-20 00:00:00	2009-04-20	5001	0	\N	0	0	\N	\N	0	209349	0	19926-5	3011505		
33108	2988	3006322	1979-08-08	1979-08-08 00:00:00	1979-08-08	5001	0	\N	0	0	\N	\N	0	199491	0	8331-1	3006322		
6362	601	3019406	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	39759	0	6158-0	3019406		
7131	687	3006322	1992-08-30	1992-08-30 00:00:00	1992-08-30	5001	0	\N	0	0	\N	\N	0	45463	0	8331-1	3006322		
52281	4804	3021226	1978-01-28	1978-01-28 00:00:00	1978-01-28	5001	0	\N	0	0	\N	\N	0	319658	0	6246-3	3021226		
14065	1314	3006322	1945-03-15	1945-03-15 00:00:00	1945-03-15	5001	0	\N	0	0	\N	\N	0	87016	0	8331-1	3006322		
29937	2760	3006322	1963-05-29	1963-05-29 00:00:00	1963-05-29	5001	0	\N	0	0	\N	\N	0	182548	0	8331-1	3006322		
29989	2765	3027231	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	182987	0	6276-0	3027231		
47604	4373	3027231	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	290425	0	6276-0	3027231		
41432	3859	3011505	1992-02-29	1992-02-29 00:00:00	1992-02-29	5001	0	\N	0	0	\N	\N	0	256236	0	19926-5	3011505		
14446	1352	3011505	2012-06-03	2012-06-03 00:00:00	2012-06-03	5001	0	\N	0	0	\N	\N	0	89545	0	19926-5	3011505		
124424	3843	4024958	2013-06-20	2013-06-20 00:00:00	2013-06-20	5001	0	\N	0	0	\N	\N	0	255070	0	117015009	4024958		
52974	4867	3006322	2003-03-23	2003-03-23 00:00:00	2003-03-23	5001	0	\N	0	0	\N	\N	0	323610	0	8331-1	3006322		
139474	4299	4024958	1978-11-15	1978-11-15 00:00:00	1978-11-15	5001	0	\N	0	0	\N	\N	0	285284	0	117015009	4024958		
3397	332	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	22053	0	6206-7	3012494		
41169	3835	3006322	1976-11-30	1976-11-30 00:00:00	1976-11-30	5001	0	\N	0	0	\N	\N	0	254642	0	8331-1	3006322		
48764	4457	3006322	1994-06-10	1994-06-10 00:00:00	1994-06-10	5001	0	\N	0	0	\N	\N	0	296631	0	8331-1	3006322		
19604	1789	3023430	1976-03-06	1976-03-06 00:00:00	1976-03-06	5001	0	\N	0	0	\N	\N	0	119926	0	6833-8	3023430		
48047	1466	4024958	2013-08-12	2013-08-12 00:00:00	2013-08-12	5001	0	\N	0	0	\N	\N	0	97650	0	117015009	4024958		
34325	3128	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	208215	0	6095-4	3036780		
37682	3477	3027231	1986-04-20	1986-04-20 00:00:00	1986-04-20	5001	0	\N	0	0	\N	\N	0	230612	0	6276-0	3027231		
16217	1478	3002385	1975-05-03	1975-05-03 00:00:00	1975-05-03	5001	0	\N	0	0	\N	\N	0	98639	0	30385-9	3002385		
9131	870	3049273	1993-04-02	1993-04-02 00:00:00	1993-04-02	5001	0	\N	0	0	\N	\N	0	57849	0	38265-5	3049273		
45621	4206	3011505	1985-09-16	1985-09-16 00:00:00	1985-09-16	5001	0	\N	0	0	\N	\N	0	279341	0	19926-5	3011505		
147980	4534	4052083	1995-01-05	1995-01-05 00:00:00	1995-01-05	5001	0	\N	0	0	\N	\N	0	302023	0	23426006	4052083		
148009	4534	4024958	1951-04-28	1951-04-28 00:00:00	1951-04-28	5001	0	\N	0	0	\N	\N	0	302054	0	117015009	4024958		
50146	4572	3006322	1985-03-09	1985-03-09 00:00:00	1985-03-09	5001	0	\N	0	0	\N	\N	0	304647	0	8331-1	3006322		
51544	4719	3006322	2006-10-15	2006-10-15 00:00:00	2006-10-15	5001	0	\N	0	0	\N	\N	0	314195	0	8331-1	3006322		
138597	4274	4052083	1978-11-10	1978-11-10 00:00:00	1978-11-10	5001	0	\N	0	0	\N	\N	0	283620	0	23426006	4052083		
43539	4026	3019406	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	267614	0	6158-0	3019406		
25413	2334	3011505	2005-05-19	2005-05-19 00:00:00	2005-05-19	5001	0	\N	0	0	\N	\N	0	155376	0	19926-5	3011505		
28316	2616	3006322	1966-03-02	1966-03-02 00:00:00	1966-03-02	5001	0	\N	0	0	\N	\N	0	173011	0	8331-1	3006322		
15657	1435	3006322	1996-12-16	1996-12-16 00:00:00	1996-12-16	5001	0	\N	0	0	\N	\N	0	95548	0	8331-1	3006322		
8739	842	3011505	1982-03-20	1982-03-20 00:00:00	1982-03-20	5001	0	\N	0	0	\N	\N	0	55737	0	19926-5	3011505		
15749	1441	3027231	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	96030	0	6276-0	3027231		
74393	2283	4052083	1986-06-21	1986-06-21 00:00:00	1986-06-21	5001	0	\N	0	0	\N	\N	0	151909	0	23426006	4052083		
164195	5043	4052083	2013-09-16	2013-09-16 00:00:00	2013-09-16	5001	0	\N	0	0	\N	\N	0	335158	0	23426006	4052083		
31650	2896	3006734	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	192802	0	6189-5	3006734		
31674	2897	3006322	2001-12-06	2001-12-06 00:00:00	2001-12-06	5001	0	\N	0	0	\N	\N	0	192926	0	8331-1	3006322		
43076	3980	3006322	2016-08-27	2016-08-27 00:00:00	2016-08-27	5001	0	\N	0	0	\N	\N	0	264564	0	8331-1	3006322		
6141	578	3006322	1979-05-31	1979-05-31 00:00:00	1979-05-31	5001	0	\N	0	0	\N	\N	0	38278	0	8331-1	3006322		
51085	4662	3027970	1989-07-27	1989-07-27 00:00:00	1989-07-27	5001	0	\N	0	0	\N	\N	0	310773	0	10834-0	3027970		
1195	97	3011505	2017-08-21	2017-08-21 00:00:00	2017-08-21	5001	0	\N	0	0	\N	\N	0	6605	0	19926-5	3011505		
17656	1608	3006322	1953-01-12	1953-01-12 00:00:00	1953-01-12	5001	0	\N	0	0	\N	\N	0	108041	0	8331-1	3006322		
34661	3175	3006322	1954-02-25	1954-02-25 00:00:00	1954-02-25	5001	0	\N	0	0	\N	\N	0	211048	0	8331-1	3006322		
78040	2392	4133840	1980-11-28	1980-11-28 00:00:00	1980-11-28	5001	0	\N	0	0	\N	\N	0	159087	0	127783003	4133840		
40495	3759	3000876	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	249969	0	6082-2	3000876		
53585	4924	3012494	1994-06-22	1994-06-22 00:00:00	1994-06-22	5001	0	\N	0	0	\N	\N	0	327174	0	6206-7	3012494		
17303	1574	40758406	1988-07-22	1988-07-22 00:00:00	1988-07-22	5001	0	\N	0	0	\N	\N	0	105696	0	55277-8	40758406		
139215	4288	4052083	1998-12-01	1998-12-01 00:00:00	1998-12-01	5001	0	\N	0	0	\N	\N	0	284700	0	23426006	4052083		
52725	4844	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	322296	0	6206-7	3012494		
35006	3191	3006322	2012-04-07	2012-04-07 00:00:00	2012-04-07	5001	0	\N	0	0	\N	\N	0	212334	0	8331-1	3006322		
117919	3628	4052083	1920-04-30	1920-04-30 00:00:00	1920-04-30	5001	0	\N	0	0	\N	\N	0	241296	0	23426006	4052083		
19503	1782	3004501	1956-01-11	1956-01-11 00:00:00	1956-01-11	5001	0	\N	0	0	\N	\N	0	119339	0	2345-7	3004501		
20883	1923	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	127864	0	6844-5	3020655		
4067	404	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	26618	0	6106-9	3014599		
98196	3004	4024958	1968-12-11	1968-12-11 00:00:00	1968-12-11	5001	0	\N	0	0	\N	\N	0	200497	0	117015009	4024958		
9816	923	3006322	1965-09-21	1965-09-21 00:00:00	1965-09-21	5001	0	\N	0	0	\N	\N	0	61419	0	8331-1	3006322		
10187	972	3006322	1998-12-23	1998-12-23 00:00:00	1998-12-23	5001	0	\N	0	0	\N	\N	0	64707	0	8331-1	3006322		
44973	1381	4133840	2015-08-22	2015-08-22 00:00:00	2015-08-22	5001	0	\N	0	0	\N	\N	0	91576	0	127783003	4133840		
134259	4133	4052083	1985-04-15	1985-04-15 00:00:00	1985-04-15	5001	0	\N	0	0	\N	\N	0	274764	0	23426006	4052083		
23090	2127	3006322	2005-09-10	2005-09-10 00:00:00	2005-09-10	5001	0	\N	0	0	\N	\N	0	141463	0	8331-1	3006322		
34491	3147	3011505	1997-02-10	1997-02-10 00:00:00	1997-02-10	5001	0	\N	0	0	\N	\N	0	209386	0	19926-5	3011505		
33109	2988	3006322	1972-10-18	1972-10-18 00:00:00	1972-10-18	5001	0	\N	0	0	\N	\N	0	199465	0	8331-1	3006322		
6363	601	3006322	1971-01-11	1971-01-11 00:00:00	1971-01-11	5001	0	\N	0	0	\N	\N	0	39731	0	8331-1	3006322		
7132	689	3006322	1989-01-18	1989-01-18 00:00:00	1989-01-18	5001	0	\N	0	0	\N	\N	0	45609	0	8331-1	3006322		
52282	4804	3019406	1978-01-28	1978-01-28 00:00:00	1978-01-28	5001	0	\N	0	0	\N	\N	0	319658	0	6158-0	3019406		
14066	1314	3006322	1935-06-21	1935-06-21 00:00:00	1935-06-21	5001	0	\N	0	0	\N	\N	0	87019	0	8331-1	3006322		
29938	2760	3006322	1971-10-30	1971-10-30 00:00:00	1971-10-30	5001	0	\N	0	0	\N	\N	0	182533	0	8331-1	3006322		
29990	2765	3005136	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	182987	0	6075-6	3005136		
47605	4373	3014599	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	290425	0	6106-9	3014599		
41433	3859	3006322	1996-08-25	1996-08-25 00:00:00	1996-08-25	5001	0	\N	0	0	\N	\N	0	256276	0	8331-1	3006322		
14447	1352	3011505	1999-03-21	1999-03-21 00:00:00	1999-03-21	5001	0	\N	0	0	\N	\N	0	89541	0	19926-5	3011505		
124429	3844	4052083	1975-07-01	1975-07-01 00:00:00	1975-07-01	5001	0	\N	0	0	\N	\N	0	255132	0	23426006	4052083		
52975	4867	3049273	1979-09-08	1979-09-08 00:00:00	1979-09-08	5001	0	\N	0	0	\N	\N	0	323684	0	38265-5	3049273		
139476	4299	4052083	1978-03-18	1978-03-18 00:00:00	1978-03-18	5001	0	\N	0	0	\N	\N	0	285254	0	23426006	4052083		
3398	332	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	22053	0	6273-7	3006451		
41170	3836	3006322	2015-03-18	2015-03-18 00:00:00	2015-03-18	5001	0	\N	0	0	\N	\N	0	254738	0	8331-1	3006322		
48765	4457	3006322	1991-09-10	1991-09-10 00:00:00	1991-09-10	5001	0	\N	0	0	\N	\N	0	296662	0	8331-1	3006322		
19605	1789	3012494	1976-03-06	1976-03-06 00:00:00	1976-03-06	5001	0	\N	0	0	\N	\N	0	119926	0	6206-7	3012494		
151498	4642	4024958	1985-12-27	1985-12-27 00:00:00	1985-12-27	5001	0	\N	0	0	\N	\N	0	309370	0	117015009	4024958		
34326	3128	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	208215	0	6085-5	3001247		
37683	3477	3001247	1986-04-20	1986-04-20 00:00:00	1986-04-20	5001	0	\N	0	0	\N	\N	0	230612	0	6085-5	3001247		
16218	1478	3004501	1975-05-03	1975-05-03 00:00:00	1975-05-03	5001	0	\N	0	0	\N	\N	0	98639	0	2345-7	3004501		
9132	871	3006322	1986-06-18	1986-06-18 00:00:00	1986-06-18	5001	0	\N	0	0	\N	\N	0	57917	0	8331-1	3006322		
45622	4206	3011505	1983-09-06	1983-09-06 00:00:00	1983-09-06	5001	0	\N	0	0	\N	\N	0	279322	0	19926-5	3011505		
147982	4534	4024958	1953-01-01	1953-01-01 00:00:00	1953-01-01	5001	0	\N	0	0	\N	\N	0	302086	0	117015009	4024958		
159330	4898	4052083	1991-08-26	1991-08-26 00:00:00	1991-08-26	5001	0	\N	0	0	\N	\N	0	325723	0	23426006	4052083		
50147	4572	3006322	1981-05-17	1981-05-17 00:00:00	1981-05-17	5001	0	\N	0	0	\N	\N	0	304600	0	8331-1	3006322		
51545	4719	3001247	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	314267	0	6085-5	3001247		
138600	4274	4052083	1999-07-31	1999-07-31 00:00:00	1999-07-31	5001	0	\N	0	0	\N	\N	0	283623	0	23426006	4052083		
43540	4026	3027231	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	267614	0	6276-0	3027231		
25414	2334	3011505	1984-05-31	1984-05-31 00:00:00	1984-05-31	5001	0	\N	0	0	\N	\N	0	155336	0	19926-5	3011505		
28317	2617	3006322	1995-05-30	1995-05-30 00:00:00	1995-05-30	5001	0	\N	0	0	\N	\N	0	173029	0	8331-1	3006322		
15658	1435	3006322	1969-09-08	1969-09-08 00:00:00	1969-09-08	5001	0	\N	0	0	\N	\N	0	95539	0	8331-1	3006322		
8740	842	3011505	2002-08-10	2002-08-10 00:00:00	2002-08-10	5001	0	\N	0	0	\N	\N	0	55681	0	19926-5	3011505		
15750	1441	3006734	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	96030	0	6189-5	3006734		
74398	2283	4024958	1940-01-07	1940-01-07 00:00:00	1940-01-07	5001	0	\N	0	0	\N	\N	0	151873	0	117015009	4024958		
164210	5044	4052083	1993-05-15	1993-05-15 00:00:00	1993-05-15	5001	0	\N	0	0	\N	\N	0	335210	0	23426006	4052083		
31651	2896	3023430	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	192802	0	6833-8	3023430		
31675	2897	3049273	2017-11-15	2017-11-15 00:00:00	2017-11-15	5001	0	\N	0	0	\N	\N	0	192945	0	38265-5	3049273		
43077	3980	3006322	1988-06-02	1988-06-02 00:00:00	1988-06-02	5001	0	\N	0	0	\N	\N	0	264580	0	8331-1	3006322		
6142	578	3006322	2008-02-01	2008-02-01 00:00:00	2008-02-01	5001	0	\N	0	0	\N	\N	0	38273	0	8331-1	3006322		
51086	4662	3026361	1989-07-27	1989-07-27 00:00:00	1989-07-27	5001	0	\N	0	0	\N	\N	0	310773	0	26453-1	3026361		
1196	97	3011505	1980-07-28	1980-07-28 00:00:00	1980-07-28	5001	0	\N	0	0	\N	\N	0	6606	0	19926-5	3011505		
17657	1608	3006322	1960-01-16	1960-01-16 00:00:00	1960-01-16	5001	0	\N	0	0	\N	\N	0	107966	0	8331-1	3006322		
34662	3176	3001247	2005-06-26	2005-06-26 00:00:00	2005-06-26	5001	0	\N	0	0	\N	\N	0	211098	0	6085-5	3001247		
78042	2392	4052083	1942-09-17	1942-09-17 00:00:00	1942-09-17	5001	0	\N	0	0	\N	\N	0	159039	0	23426006	4052083		
40496	3759	3019406	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	249969	0	6158-0	3019406		
53586	4924	3001488	1994-06-22	1994-06-22 00:00:00	1994-06-22	5001	0	\N	0	0	\N	\N	0	327174	0	7258-7	3001488		
17304	1574	3051031	1988-07-22	1988-07-22 00:00:00	1988-07-22	5001	0	\N	0	0	\N	\N	0	105696	0	46240-8	3051031		
139220	4288	4052083	1974-06-28	1974-06-28 00:00:00	1974-06-28	5001	0	\N	0	0	\N	\N	0	284675	0	23426006	4052083		
52726	4844	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	322296	0	6246-3	3021226		
35007	3191	3006322	1958-12-23	1958-12-23 00:00:00	1958-12-23	5001	0	\N	0	0	\N	\N	0	212331	0	8331-1	3006322		
117931	3628	4024958	1927-05-27	1927-05-27 00:00:00	1927-05-27	5001	0	\N	0	0	\N	\N	0	241297	0	117015009	4024958		
19504	1782	3000963	1956-01-11	1956-01-11 00:00:00	1956-01-11	5001	0	\N	0	0	\N	\N	0	119339	0	718-7	3000963		
20884	1923	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	127864	0	7258-7	3001488		
4068	404	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	26618	0	6158-0	3019406		
98200	3004	4024958	1976-04-13	1976-04-13 00:00:00	1976-04-13	5001	0	\N	0	0	\N	\N	0	200499	0	117015009	4024958		
9817	923	3006322	2014-01-05	2014-01-05 00:00:00	2014-01-05	5001	0	\N	0	0	\N	\N	0	61477	0	8331-1	3006322		
10188	972	3006322	1987-08-11	1987-08-11 00:00:00	1987-08-11	5001	0	\N	0	0	\N	\N	0	64721	0	8331-1	3006322		
44975	1381	4133840	2019-05-11	2019-05-11 00:00:00	2019-05-11	5001	0	\N	0	0	\N	\N	0	91603	0	127783003	4133840		
134266	4134	4024958	1981-09-09	1981-09-09 00:00:00	1981-09-09	5001	0	\N	0	0	\N	\N	0	274896	0	117015009	4024958		
34369	3133	46235214	2004-08-08	2004-08-08 00:00:00	2004-08-08	5001	0	\N	0	0	\N	\N	0	208457	0	76690-7	46235214		
6890	217	4024958	1980-08-04	1980-08-04 00:00:00	1980-08-04	5001	0	\N	0	0	\N	\N	0	14646	0	117015009	4024958		
33110	2988	40758406	1978-04-02	1978-04-02 00:00:00	1978-04-02	5001	0	\N	0	0	\N	\N	0	199469	0	55277-8	40758406		
29512	2715	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	180095	0	6206-7	3012494		
7133	689	3006322	2009-04-29	2009-04-29 00:00:00	2009-04-29	5001	0	\N	0	0	\N	\N	0	45614	0	8331-1	3006322		
52283	4804	3006451	1978-01-28	1978-01-28 00:00:00	1978-01-28	5001	0	\N	0	0	\N	\N	0	319658	0	6273-7	3006451		
14067	1314	3006322	1938-03-31	1938-03-31 00:00:00	1938-03-31	5001	0	\N	0	0	\N	\N	0	87006	0	8331-1	3006322		
29939	2760	3006322	1987-11-17	1987-11-17 00:00:00	1987-11-17	5001	0	\N	0	0	\N	\N	0	182538	0	8331-1	3006322		
29991	2765	3012494	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	182987	0	6206-7	3012494		
47606	4373	3006734	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	290425	0	6189-5	3006734		
41434	3859	3006322	1965-03-18	1965-03-18 00:00:00	1965-03-18	5001	0	\N	0	0	\N	\N	0	256207	0	8331-1	3006322		
14448	1352	3011505	2010-05-23	2010-05-23 00:00:00	2010-05-23	5001	0	\N	0	0	\N	\N	0	89544	0	19926-5	3011505		
124433	3844	4024958	1965-10-22	1965-10-22 00:00:00	1965-10-22	5001	0	\N	0	0	\N	\N	0	255126	0	117015009	4024958		
52976	4867	3006322	1931-09-07	1931-09-07 00:00:00	1931-09-07	5001	0	\N	0	0	\N	\N	0	323642	0	8331-1	3006322		
139477	4299	4024958	1995-02-09	1995-02-09 00:00:00	1995-02-09	5001	0	\N	0	0	\N	\N	0	285285	0	117015009	4024958		
3399	332	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	22053	0	6158-0	3019406		
52448	4822	3011505	2019-06-26	2019-06-26 00:00:00	2019-06-26	5001	0	\N	0	0	\N	\N	0	320775	0	19926-5	3011505		
48766	4457	3006322	2015-09-11	2015-09-11 00:00:00	2015-09-11	5001	0	\N	0	0	\N	\N	0	296632	0	8331-1	3006322		
19606	1789	3005136	1976-03-06	1976-03-06 00:00:00	1976-03-06	5001	0	\N	0	0	\N	\N	0	119926	0	6075-6	3005136		
151507	4642	4052083	1965-10-05	1965-10-05 00:00:00	1965-10-05	5001	0	\N	0	0	\N	\N	0	309356	0	23426006	4052083		
34327	3128	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	208215	0	6189-5	3006734		
37684	3477	3023430	1986-04-20	1986-04-20 00:00:00	1986-04-20	5001	0	\N	0	0	\N	\N	0	230612	0	6833-8	3023430		
16219	1478	3010813	1975-05-03	1975-05-03 00:00:00	1975-05-03	5001	0	\N	0	0	\N	\N	0	98639	0	26464-8	3010813		
9133	871	3006322	1971-01-24	1971-01-24 00:00:00	1971-01-24	5001	0	\N	0	0	\N	\N	0	57930	0	8331-1	3006322		
45623	4206	3011505	1991-09-30	1991-09-30 00:00:00	1991-09-30	5001	0	\N	0	0	\N	\N	0	279308	0	19926-5	3011505		
147985	4534	4024958	1949-07-29	1949-07-29 00:00:00	1949-07-29	5001	0	\N	0	0	\N	\N	0	302053	0	117015009	4024958		
159332	4898	4052083	1983-03-29	1983-03-29 00:00:00	1983-03-29	5001	0	\N	0	0	\N	\N	0	325691	0	23426006	4052083		
50148	4574	3006322	2013-09-10	2013-09-10 00:00:00	2013-09-10	5001	0	\N	0	0	\N	\N	0	304697	0	8331-1	3006322		
51546	4719	3000876	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	314267	0	6082-2	3000876		
121224	3742	4024958	1988-03-25	1988-03-25 00:00:00	1988-03-25	5001	0	\N	0	0	\N	\N	0	248680	0	117015009	4024958		
43541	4026	3014599	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	267614	0	6106-9	3014599		
25415	2334	3011505	2018-08-02	2018-08-02 00:00:00	2018-08-02	5001	0	\N	0	0	\N	\N	0	155323	0	19926-5	3011505		
28318	2617	3006322	1972-05-22	1972-05-22 00:00:00	1972-05-22	5001	0	\N	0	0	\N	\N	0	173027	0	8331-1	3006322		
15659	1435	3006322	1976-08-21	1976-08-21 00:00:00	1976-08-21	5001	0	\N	0	0	\N	\N	0	95547	0	8331-1	3006322		
8741	842	3000963	1991-11-07	1991-11-07 00:00:00	1991-11-07	5001	0	\N	0	0	\N	\N	0	55625	0	718-7	3000963		
15751	1441	3020655	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	96030	0	6844-5	3020655		
74417	2283	4024958	1943-01-29	1943-01-29 00:00:00	1943-01-29	5001	0	\N	0	0	\N	\N	0	151874	0	117015009	4024958		
164222	5044	4024958	1976-04-02	1976-04-02 00:00:00	1976-04-02	5001	0	\N	0	0	\N	\N	0	335189	0	117015009	4024958		
31652	2896	3001247	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	192802	0	6085-5	3001247		
31676	2897	3006322	1983-12-13	1983-12-13 00:00:00	1983-12-13	5001	0	\N	0	0	\N	\N	0	192889	0	8331-1	3006322		
43082	3982	3051031	1940-06-08	1940-06-08 00:00:00	1940-06-08	5001	0	\N	0	0	\N	\N	0	264651	0	46240-8	3051031		
6143	578	46235214	2011-06-14	2011-06-14 00:00:00	2011-06-14	5001	0	\N	0	0	\N	\N	0	38219	0	76690-7	46235214		
51087	4662	3019550	1989-07-27	1989-07-27 00:00:00	1989-07-27	5001	0	\N	0	0	\N	\N	0	310773	0	2951-2	3019550		
1198	97	3006322	1948-07-17	1948-07-17 00:00:00	1948-07-17	5001	0	\N	0	0	\N	\N	0	6663	0	8331-1	3006322		
17658	1608	3006322	1960-06-23	1960-06-23 00:00:00	1960-06-23	5001	0	\N	0	0	\N	\N	0	108043	0	8331-1	3006322		
34663	3176	3012494	2005-06-26	2005-06-26 00:00:00	2005-06-26	5001	0	\N	0	0	\N	\N	0	211098	0	6206-7	3012494		
78044	2392	4133840	1964-02-07	1964-02-07 00:00:00	1964-02-07	5001	0	\N	0	0	\N	\N	0	159074	0	127783003	4133840		
40497	3759	3001488	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	249969	0	7258-7	3001488		
53587	4924	3006734	1994-06-22	1994-06-22 00:00:00	1994-06-22	5001	0	\N	0	0	\N	\N	0	327174	0	6189-5	3006734		
17306	1574	46235214	1986-02-23	1986-02-23 00:00:00	1986-02-23	5001	0	\N	0	0	\N	\N	0	105638	0	76690-7	46235214		
139223	4288	4024958	1973-02-21	1973-02-21 00:00:00	1973-02-21	5001	0	\N	0	0	\N	\N	0	284699	0	117015009	4024958		
52727	4844	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	322296	0	6082-2	3000876		
35008	3191	3006322	1981-10-21	1981-10-21 00:00:00	1981-10-21	5001	0	\N	0	0	\N	\N	0	212360	0	8331-1	3006322		
117934	3628	4024958	1955-04-28	1955-04-28 00:00:00	1955-04-28	5001	0	\N	0	0	\N	\N	0	241407	0	117015009	4024958		
19505	1782	3027970	1956-01-11	1956-01-11 00:00:00	1956-01-11	5001	0	\N	0	0	\N	\N	0	119339	0	10834-0	3027970		
20885	1923	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	127864	0	6276-0	3027231		
4069	406	3006322	1994-07-26	1994-07-26 00:00:00	1994-07-26	5001	0	\N	0	0	\N	\N	0	26769	0	8331-1	3006322		
6991	222	4024958	2015-12-11	2015-12-11 00:00:00	2015-12-11	5001	0	\N	0	0	\N	\N	0	14886	0	117015009	4024958		
9818	924	3006322	1963-07-31	1963-07-31 00:00:00	1963-07-31	5001	0	\N	0	0	\N	\N	0	61560	0	8331-1	3006322		
10189	972	3006322	2012-03-07	2012-03-07 00:00:00	2012-03-07	5001	0	\N	0	0	\N	\N	0	64709	0	8331-1	3006322		
44979	1381	4024958	1986-02-22	1986-02-22 00:00:00	1986-02-22	5001	0	\N	0	0	\N	\N	0	91604	0	117015009	4024958		
134275	4134	4052083	1976-12-19	1976-12-19 00:00:00	1976-12-19	5001	0	\N	0	0	\N	\N	0	274846	0	23426006	4052083		
34372	3133	3051031	2004-08-08	2004-08-08 00:00:00	2004-08-08	5001	0	\N	0	0	\N	\N	0	208457	0	46240-8	3051031		
6894	217	4052083	2016-03-06	2016-03-06 00:00:00	2016-03-06	5001	0	\N	0	0	\N	\N	0	14655	0	23426006	4052083		
33112	2988	46235214	1978-04-02	1978-04-02 00:00:00	1978-04-02	5001	0	\N	0	0	\N	\N	0	199469	0	76690-7	46235214		
29513	2715	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	180095	0	6095-4	3036780		
7134	689	3006322	1991-02-18	1991-02-18 00:00:00	1991-02-18	5001	0	\N	0	0	\N	\N	0	45610	0	8331-1	3006322		
52284	4804	3012494	1978-01-28	1978-01-28 00:00:00	1978-01-28	5001	0	\N	0	0	\N	\N	0	319658	0	6206-7	3012494		
14068	1314	3006322	1941-05-25	1941-05-25 00:00:00	1941-05-25	5001	0	\N	0	0	\N	\N	0	86981	0	8331-1	3006322		
29940	2761	3006322	1992-12-23	1992-12-23 00:00:00	1992-12-23	5001	0	\N	0	0	\N	\N	0	182621	0	8331-1	3006322		
29992	2765	3001247	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	182987	0	6085-5	3001247		
47607	4373	3001488	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	290425	0	7258-7	3001488		
41435	3859	3011505	1995-07-29	1995-07-29 00:00:00	1995-07-29	5001	0	\N	0	0	\N	\N	0	256256	0	19926-5	3011505		
14449	1352	3011505	2003-04-13	2003-04-13 00:00:00	2003-04-13	5001	0	\N	0	0	\N	\N	0	89555	0	19926-5	3011505		
67585	2073	4024958	1965-10-06	1965-10-06 00:00:00	1965-10-06	5001	0	\N	0	0	\N	\N	0	137881	0	117015009	4024958		
143806	4419	4024958	1965-10-30	1965-10-30 00:00:00	1965-10-30	5001	0	\N	0	0	\N	\N	0	293862	0	117015009	4024958		
128525	3957	4133840	2009-09-24	2009-09-24 00:00:00	2009-09-24	5001	0	\N	0	0	\N	\N	0	263069	0	127783003	4133840		
3400	332	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	22053	0	6085-5	3001247		
52450	4822	46235214	1971-05-06	1971-05-06 00:00:00	1971-05-06	5001	0	\N	0	0	\N	\N	0	320713	0	76690-7	46235214		
48767	4457	3006322	1985-06-01	1985-06-01 00:00:00	1985-06-01	5001	0	\N	0	0	\N	\N	0	296661	0	8331-1	3006322		
19607	1789	3014599	1976-03-06	1976-03-06 00:00:00	1976-03-06	5001	0	\N	0	0	\N	\N	0	119926	0	6106-9	3014599		
151523	4642	4024958	1971-07-04	1971-07-04 00:00:00	1971-07-04	5001	0	\N	0	0	\N	\N	0	309358	0	117015009	4024958		
34328	3128	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	208215	0	6833-8	3023430		
37685	3477	3006322	2000-05-23	2000-05-23 00:00:00	2000-05-23	5001	0	\N	0	0	\N	\N	0	230677	0	8331-1	3006322		
16220	1478	3024731	1975-05-03	1975-05-03 00:00:00	1975-05-03	5001	0	\N	0	0	\N	\N	0	98639	0	30428-7	3024731		
33845	1058	4024958	1999-07-10	1999-07-10 00:00:00	1999-07-10	5001	0	\N	0	0	\N	\N	0	69394	0	117015009	4024958		
45624	4206	3011505	1996-09-23	1996-09-23 00:00:00	1996-09-23	5001	0	\N	0	0	\N	\N	0	279324	0	19926-5	3011505		
534	28	3006322	1991-11-29	1991-11-29 00:00:00	1991-11-29	5001	0	\N	0	0	\N	\N	0	1956	0	8331-1	3006322		
159346	4898	4052083	2003-09-16	2003-09-16 00:00:00	2003-09-16	5001	0	\N	0	0	\N	\N	0	325668	0	23426006	4052083		
50149	4574	3000963	1974-03-12	1974-03-12 00:00:00	1974-03-12	5001	0	\N	0	0	\N	\N	0	304682	0	718-7	3000963		
51547	4719	3006322	2012-05-01	2012-05-01 00:00:00	2012-05-01	5001	0	\N	0	0	\N	\N	0	314333	0	8331-1	3006322		
121232	3743	4024958	1986-03-02	1986-03-02 00:00:00	1986-03-02	5001	0	\N	0	0	\N	\N	0	248694	0	117015009	4024958		
43542	4026	3005136	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	267614	0	6075-6	3005136		
25417	2334	3011505	1989-02-16	1989-02-16 00:00:00	1989-02-16	5001	0	\N	0	0	\N	\N	0	155338	0	19926-5	3011505		
28319	2617	3006322	1962-08-18	1962-08-18 00:00:00	1962-08-18	5001	0	\N	0	0	\N	\N	0	173058	0	8331-1	3006322		
134451	4142	4024958	1988-06-08	1988-06-08 00:00:00	1988-06-08	5001	0	\N	0	0	\N	\N	0	275319	0	117015009	4024958		
8742	842	3009542	1991-11-07	1991-11-07 00:00:00	1991-11-07	5001	0	\N	0	0	\N	\N	0	55625	0	20570-8	3009542		
15752	1441	3036780	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	96030	0	6095-4	3036780		
74427	2283	4052083	2001-08-07	2001-08-07 00:00:00	2001-08-07	5001	0	\N	0	0	\N	\N	0	151910	0	23426006	4052083		
164224	5044	4024958	1985-04-11	1985-04-11 00:00:00	1985-04-11	5001	0	\N	0	0	\N	\N	0	335215	0	117015009	4024958		
31653	2896	3001488	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	192802	0	7258-7	3001488		
31677	2898	3006322	2006-04-21	2006-04-21 00:00:00	2006-04-21	5001	0	\N	0	0	\N	\N	0	192976	0	8331-1	3006322		
43083	3982	40766240	1940-06-08	1940-06-08 00:00:00	1940-06-08	5001	0	\N	0	0	\N	\N	0	264651	0	63513-6	40766240		
6144	578	40766240	2011-06-14	2011-06-14 00:00:00	2011-06-14	5001	0	\N	0	0	\N	\N	0	38219	0	63513-6	40766240		
51088	4662	3045716	1989-07-27	1989-07-27 00:00:00	1989-07-27	5001	0	\N	0	0	\N	\N	0	310773	0	33037-3	3045716		
1199	97	3011505	2016-08-15	2016-08-15 00:00:00	2016-08-15	5001	0	\N	0	0	\N	\N	0	6633	0	19926-5	3011505		
17659	1608	3006322	1967-07-28	1967-07-28 00:00:00	1967-07-28	5001	0	\N	0	0	\N	\N	0	107968	0	8331-1	3006322		
34664	3176	3023430	2005-06-26	2005-06-26 00:00:00	2005-06-26	5001	0	\N	0	0	\N	\N	0	211098	0	6833-8	3023430		
89322	2765	4133840	2013-12-10	2013-12-10 00:00:00	2013-12-10	5001	0	\N	0	0	\N	\N	0	182826	0	127783003	4133840		
40498	3759	3006734	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	249969	0	6189-5	3006734		
53588	4924	3023430	1994-06-22	1994-06-22 00:00:00	1994-06-22	5001	0	\N	0	0	\N	\N	0	327174	0	6833-8	3023430		
17307	1574	3051031	1986-02-23	1986-02-23 00:00:00	1986-02-23	5001	0	\N	0	0	\N	\N	0	105638	0	46240-8	3051031		
139226	4288	4024958	2010-10-16	2010-10-16 00:00:00	2010-10-16	5001	0	\N	0	0	\N	\N	0	284653	0	117015009	4024958		
52728	4844	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	322229	0	6085-5	3001247		
35009	3191	3006322	1960-03-31	1960-03-31 00:00:00	1960-03-31	5001	0	\N	0	0	\N	\N	0	212332	0	8331-1	3006322		
117951	3629	4024958	1975-08-27	1975-08-27 00:00:00	1975-08-27	5001	0	\N	0	0	\N	\N	0	241495	0	117015009	4024958		
19506	1782	3013721	1956-01-11	1956-01-11 00:00:00	1956-01-11	5001	0	\N	0	0	\N	\N	0	119339	0	1920-8	3013721		
20886	1923	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	127864	0	6248-9	3015076		
4070	406	40769184	1974-02-22	1974-02-22 00:00:00	1974-02-22	5001	0	\N	0	0	\N	\N	0	26810	0	66524-0	40769184		
6994	222	4024958	1993-01-09	1993-01-09 00:00:00	1993-01-09	5001	0	\N	0	0	\N	\N	0	14895	0	117015009	4024958		
9819	924	3006322	1992-08-12	1992-08-12 00:00:00	1992-08-12	5001	0	\N	0	0	\N	\N	0	61529	0	8331-1	3006322		
10191	972	3006322	1999-07-04	1999-07-04 00:00:00	1999-07-04	5001	0	\N	0	0	\N	\N	0	64708	0	8331-1	3006322		
44980	1381	4133840	2006-08-12	2006-08-12 00:00:00	2006-08-12	5001	0	\N	0	0	\N	\N	0	91573	0	127783003	4133840		
134285	4134	4052083	2017-06-13	2017-06-13 00:00:00	2017-06-13	5001	0	\N	0	0	\N	\N	0	274864	0	23426006	4052083		
34373	3133	3006322	1965-10-19	1965-10-19 00:00:00	1965-10-19	5001	0	\N	0	0	\N	\N	0	208520	0	8331-1	3006322		
6896	217	4024958	1997-08-29	1997-08-29 00:00:00	1997-08-29	5001	0	\N	0	0	\N	\N	0	14645	0	117015009	4024958		
33113	2988	40766240	1978-04-02	1978-04-02 00:00:00	1978-04-02	5001	0	\N	0	0	\N	\N	0	199469	0	63513-6	40766240		
29514	2715	3006322	1975-07-11	1975-07-11 00:00:00	1975-07-11	5001	0	\N	0	0	\N	\N	0	180004	0	8331-1	3006322		
7136	691	3006322	1974-08-25	1974-08-25 00:00:00	1974-08-25	5001	0	\N	0	0	\N	\N	0	45743	0	8331-1	3006322		
52285	4804	3027231	1978-01-28	1978-01-28 00:00:00	1978-01-28	5001	0	\N	0	0	\N	\N	0	319658	0	6276-0	3027231		
14069	1314	3006322	1936-04-28	1936-04-28 00:00:00	1936-04-28	5001	0	\N	0	0	\N	\N	0	87020	0	8331-1	3006322		
29941	2761	3006322	1997-05-12	1997-05-12 00:00:00	1997-05-12	5001	0	\N	0	0	\N	\N	0	182627	0	8331-1	3006322		
29993	2765	3006734	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	182987	0	6189-5	3006734		
47608	4373	3001247	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	290425	0	6085-5	3001247		
41436	3859	3011505	1991-02-23	1991-02-23 00:00:00	1991-02-23	5001	0	\N	0	0	\N	\N	0	256152	0	19926-5	3011505		
14450	1352	3011505	2014-06-15	2014-06-15 00:00:00	2014-06-15	5001	0	\N	0	0	\N	\N	0	89557	0	19926-5	3011505		
67590	2073	4024958	1995-03-29	1995-03-29 00:00:00	1995-03-29	5001	0	\N	0	0	\N	\N	0	137935	0	117015009	4024958		
16379	1493	3006322	2000-02-02	2000-02-02 00:00:00	2000-02-02	5001	0	\N	0	0	\N	\N	0	99567	0	8331-1	3006322		
128528	3957	4052083	1989-11-26	1989-11-26 00:00:00	1989-11-26	5001	0	\N	0	0	\N	\N	0	263139	0	23426006	4052083		
3401	332	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	22053	0	7258-7	3001488		
52451	4822	40758406	1971-05-06	1971-05-06 00:00:00	1971-05-06	5001	0	\N	0	0	\N	\N	0	320713	0	55277-8	40758406		
48768	4459	3006322	1972-08-20	1972-08-20 00:00:00	1972-08-20	5001	0	\N	0	0	\N	\N	0	296720	0	8331-1	3006322		
19608	1789	3036780	1976-03-06	1976-03-06 00:00:00	1976-03-06	5001	0	\N	0	0	\N	\N	0	119926	0	6095-4	3036780		
151567	4643	4024958	1953-02-06	1953-02-06 00:00:00	1953-02-06	5001	0	\N	0	0	\N	\N	0	309525	0	117015009	4024958		
34329	3128	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	208215	0	7258-7	3001488		
37686	3477	3006322	1968-02-22	1968-02-22 00:00:00	1968-02-22	5001	0	\N	0	0	\N	\N	0	230687	0	8331-1	3006322		
16221	1478	3006923	1975-05-03	1975-05-03 00:00:00	1975-05-03	5001	0	\N	0	0	\N	\N	0	98639	0	1742-6	3006923		
33846	1058	4024958	1962-03-06	1962-03-06 00:00:00	1962-03-06	5001	0	\N	0	0	\N	\N	0	69382	0	117015009	4024958		
45625	4208	3006322	1959-05-06	1959-05-06 00:00:00	1959-05-06	5001	0	\N	0	0	\N	\N	0	279442	0	8331-1	3006322		
535	28	3006322	1983-05-15	1983-05-15 00:00:00	1983-05-15	5001	0	\N	0	0	\N	\N	0	1978	0	8331-1	3006322		
159350	4898	4024958	1983-02-11	1983-02-11 00:00:00	1983-02-11	5001	0	\N	0	0	\N	\N	0	325666	0	117015009	4024958		
50150	4574	3009542	1974-03-12	1974-03-12 00:00:00	1974-03-12	5001	0	\N	0	0	\N	\N	0	304682	0	20570-8	3009542		
51548	4719	3006322	1957-09-04	1957-09-04 00:00:00	1957-09-04	5001	0	\N	0	0	\N	\N	0	314188	0	8331-1	3006322		
121240	3743	4052083	1981-11-22	1981-11-22 00:00:00	1981-11-22	5001	0	\N	0	0	\N	\N	0	248692	0	23426006	4052083		
43543	4026	3006734	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	267614	0	6189-5	3006734		
25418	2334	3006322	1977-09-03	1977-09-03 00:00:00	1977-09-03	5001	0	\N	0	0	\N	\N	0	155306	0	8331-1	3006322		
28320	2617	3006322	1965-04-18	1965-04-18 00:00:00	1965-04-18	5001	0	\N	0	0	\N	\N	0	173043	0	8331-1	3006322		
134460	4142	4052083	2003-08-28	2003-08-28 00:00:00	2003-08-28	5001	0	\N	0	0	\N	\N	0	275321	0	23426006	4052083		
8743	842	3011505	1988-04-23	1988-04-23 00:00:00	1988-04-23	5001	0	\N	0	0	\N	\N	0	55749	0	19926-5	3011505		
27030	2503	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	165695	0	6276-0	3027231		
74432	2283	4024958	1948-07-17	1948-07-17 00:00:00	1948-07-17	5001	0	\N	0	0	\N	\N	0	151847	0	117015009	4024958		
164228	5045	4024958	1999-12-08	1999-12-08 00:00:00	1999-12-08	5001	0	\N	0	0	\N	\N	0	335287	0	117015009	4024958		
31654	2896	3036780	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	192802	0	6095-4	3036780		
31678	2898	3006322	1991-09-27	1991-09-27 00:00:00	1991-09-27	5001	0	\N	0	0	\N	\N	0	193067	0	8331-1	3006322		
43085	3982	40758406	1940-06-08	1940-06-08 00:00:00	1940-06-08	5001	0	\N	0	0	\N	\N	0	264651	0	55277-8	40758406		
6147	578	40758406	2011-06-14	2011-06-14 00:00:00	2011-06-14	5001	0	\N	0	0	\N	\N	0	38219	0	55277-8	40758406		
51089	4662	3007461	1989-07-27	1989-07-27 00:00:00	1989-07-27	5001	0	\N	0	0	\N	\N	0	310773	0	26515-7	3007461		
1200	97	3011505	1993-07-19	1993-07-19 00:00:00	1993-07-19	5001	0	\N	0	0	\N	\N	0	6626	0	19926-5	3011505		
17660	1608	3006322	2012-11-04	2012-11-04 00:00:00	2012-11-04	5001	0	\N	0	0	\N	\N	0	107971	0	8331-1	3006322		
34665	3176	3020655	2005-06-26	2005-06-26 00:00:00	2005-06-26	5001	0	\N	0	0	\N	\N	0	211098	0	6844-5	3020655		
89327	2765	4133840	2005-10-25	2005-10-25 00:00:00	2005-10-25	5001	0	\N	0	0	\N	\N	0	182914	0	127783003	4133840		
40499	3759	3023430	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	249969	0	6833-8	3023430		
53589	4924	3020655	1994-06-22	1994-06-22 00:00:00	1994-06-22	5001	0	\N	0	0	\N	\N	0	327174	0	6844-5	3020655		
17308	1574	40766240	1986-02-23	1986-02-23 00:00:00	1986-02-23	5001	0	\N	0	0	\N	\N	0	105638	0	63513-6	40766240		
139231	4288	4052083	1955-09-18	1955-09-18 00:00:00	1955-09-18	5001	0	\N	0	0	\N	\N	0	284714	0	23426006	4052083		
52729	4844	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	322229	0	7258-7	3001488		
35010	3191	3006322	2015-09-18	2015-09-18 00:00:00	2015-09-18	5001	0	\N	0	0	\N	\N	0	212340	0	8331-1	3006322		
47658	4374	3021226	1979-06-16	1979-06-16 00:00:00	1979-06-16	5001	0	\N	0	0	\N	\N	0	290554	0	6246-3	3021226		
19507	1782	3024731	1956-01-11	1956-01-11 00:00:00	1956-01-11	5001	0	\N	0	0	\N	\N	0	119339	0	30428-7	3024731		
20887	1923	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	127864	0	6085-5	3001247		
4071	406	40769194	1974-02-22	1974-02-22 00:00:00	1974-02-22	5001	0	\N	0	0	\N	\N	0	26810	0	66534-9	40769194		
6997	222	4024958	1974-03-09	1974-03-09 00:00:00	1974-03-09	5001	0	\N	0	0	\N	\N	0	14884	0	117015009	4024958		
9820	924	3006322	2018-06-03	2018-06-03 00:00:00	2018-06-03	5001	0	\N	0	0	\N	\N	0	61517	0	8331-1	3006322		
10192	973	3006322	1977-05-28	1977-05-28 00:00:00	1977-05-28	5001	0	\N	0	0	\N	\N	0	64740	0	8331-1	3006322		
44982	1381	4024958	2016-08-21	2016-08-21 00:00:00	2016-08-21	5001	0	\N	0	0	\N	\N	0	91583	0	117015009	4024958		
134294	4134	4024958	1985-07-02	1985-07-02 00:00:00	1985-07-02	5001	0	\N	0	0	\N	\N	0	274862	0	117015009	4024958		
34375	3133	40766240	2004-07-09	2004-07-09 00:00:00	2004-07-09	5001	0	\N	0	0	\N	\N	0	208524	0	63513-6	40766240		
6897	217	4024958	2017-10-24	2017-10-24 00:00:00	2017-10-24	5001	0	\N	0	0	\N	\N	0	14652	0	117015009	4024958		
33114	2988	3051031	1978-04-02	1978-04-02 00:00:00	1978-04-02	5001	0	\N	0	0	\N	\N	0	199469	0	46240-8	3051031		
29515	2715	3006322	2003-08-28	2003-08-28 00:00:00	2003-08-28	5001	0	\N	0	0	\N	\N	0	180057	0	8331-1	3006322		
7137	691	3006322	1959-05-07	1959-05-07 00:00:00	1959-05-07	5001	0	\N	0	0	\N	\N	0	45783	0	8331-1	3006322		
52286	4804	3005136	1978-01-28	1978-01-28 00:00:00	1978-01-28	5001	0	\N	0	0	\N	\N	0	319658	0	6075-6	3005136		
14070	1314	3006322	1982-05-19	1982-05-19 00:00:00	1982-05-19	5001	0	\N	0	0	\N	\N	0	87010	0	8331-1	3006322		
29942	2761	3006322	1985-07-24	1985-07-24 00:00:00	1985-07-24	5001	0	\N	0	0	\N	\N	0	182648	0	8331-1	3006322		
29994	2765	3020655	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	182987	0	6844-5	3020655		
47609	4373	3000876	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	290425	0	6082-2	3000876		
41437	3859	3011505	2017-04-22	2017-04-22 00:00:00	2017-04-22	5001	0	\N	0	0	\N	\N	0	256162	0	19926-5	3011505		
14451	1352	3006322	2016-03-26	2016-03-26 00:00:00	2016-03-26	5001	0	\N	0	0	\N	\N	0	89609	0	8331-1	3006322		
67591	2073	4052083	2007-11-18	2007-11-18 00:00:00	2007-11-18	5001	0	\N	0	0	\N	\N	0	137924	0	23426006	4052083		
16380	1493	3006322	1971-10-03	1971-10-03 00:00:00	1971-10-03	5001	0	\N	0	0	\N	\N	0	99552	0	8331-1	3006322		
128533	3957	4024958	1964-03-10	1964-03-10 00:00:00	1964-03-10	5001	0	\N	0	0	\N	\N	0	263134	0	117015009	4024958		
14683	1367	3006322	2000-05-17	2000-05-17 00:00:00	2000-05-17	5001	0	\N	0	0	\N	\N	0	90599	0	8331-1	3006322		
52452	4822	3051031	1971-05-06	1971-05-06 00:00:00	1971-05-06	5001	0	\N	0	0	\N	\N	0	320713	0	46240-8	3051031		
48769	4459	3006322	1964-01-21	1964-01-21 00:00:00	1964-01-21	5001	0	\N	0	0	\N	\N	0	296710	0	8331-1	3006322		
19609	1789	3019406	1976-03-06	1976-03-06 00:00:00	1976-03-06	5001	0	\N	0	0	\N	\N	0	119926	0	6158-0	3019406		
164810	5058	4052083	1991-04-19	1991-04-19 00:00:00	1991-04-19	5001	0	\N	0	0	\N	\N	0	336306	0	23426006	4052083		
82124	2541	4024958	2014-05-08	2014-05-08 00:00:00	2014-05-08	5001	0	\N	0	0	\N	\N	0	168054	0	117015009	4024958		
37687	3477	3006322	1977-11-27	1977-11-27 00:00:00	1977-11-27	5001	0	\N	0	0	\N	\N	0	230611	0	8331-1	3006322		
16222	1478	3014576	1975-05-03	1975-05-03 00:00:00	1975-05-03	5001	0	\N	0	0	\N	\N	0	98639	0	2075-0	3014576		
71526	2189	4024958	2009-10-13	2009-10-13 00:00:00	2009-10-13	5001	0	\N	0	0	\N	\N	0	145955	0	117015009	4024958		
45627	4208	3006322	1972-08-17	1972-08-17 00:00:00	1972-08-17	5001	0	\N	0	0	\N	\N	0	279443	0	8331-1	3006322		
536	28	3006322	1995-02-27	1995-02-27 00:00:00	1995-02-27	5001	0	\N	0	0	\N	\N	0	1963	0	8331-1	3006322		
159352	4898	4052083	2012-03-28	2012-03-28 00:00:00	2012-03-28	5001	0	\N	0	0	\N	\N	0	325743	0	23426006	4052083		
50151	4574	3006322	2007-01-05	2007-01-05 00:00:00	2007-01-05	5001	0	\N	0	0	\N	\N	0	304703	0	8331-1	3006322		
51549	4719	3000876	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	314290	0	6082-2	3000876		
121254	3744	4052083	2016-03-03	2016-03-03 00:00:00	2016-03-03	5001	0	\N	0	0	\N	\N	0	248835	0	23426006	4052083		
43544	4026	3001488	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	267614	0	7258-7	3001488		
36696	3371	3006322	1984-01-26	1984-01-26 00:00:00	1984-01-26	5001	0	\N	0	0	\N	\N	0	223604	0	8331-1	3006322		
28321	2617	3006322	2018-07-10	2018-07-10 00:00:00	2018-07-10	5001	0	\N	0	0	\N	\N	0	173061	0	8331-1	3006322		
134481	4143	4052083	1991-04-26	1991-04-26 00:00:00	1991-04-26	5001	0	\N	0	0	\N	\N	0	275380	0	23426006	4052083		
8744	842	3011505	1990-06-02	1990-06-02 00:00:00	1990-06-02	5001	0	\N	0	0	\N	\N	0	55669	0	19926-5	3011505		
27031	2503	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	165695	0	6844-5	3020655		
74439	2283	4024958	1980-02-23	1980-02-23 00:00:00	1980-02-23	5001	0	\N	0	0	\N	\N	0	151908	0	117015009	4024958		
164232	5045	4052083	1985-02-08	1985-02-08 00:00:00	1985-02-08	5001	0	\N	0	0	\N	\N	0	335268	0	23426006	4052083		
31655	2896	3000876	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	192802	0	6082-2	3000876		
31679	2898	3006322	1986-08-09	1986-08-09 00:00:00	1986-08-09	5001	0	\N	0	0	\N	\N	0	193066	0	8331-1	3006322		
43086	3982	46235214	1940-06-08	1940-06-08 00:00:00	1940-06-08	5001	0	\N	0	0	\N	\N	0	264651	0	76690-7	46235214		
6148	578	3051031	2011-06-14	2011-06-14 00:00:00	2011-06-14	5001	0	\N	0	0	\N	\N	0	38219	0	46240-8	3051031		
51090	4662	3002385	1989-07-27	1989-07-27 00:00:00	1989-07-27	5001	0	\N	0	0	\N	\N	0	310773	0	30385-9	3002385		
1201	97	3006322	1963-04-13	1963-04-13 00:00:00	1963-04-13	5001	0	\N	0	0	\N	\N	0	6576	0	8331-1	3006322		
17661	1608	3006322	2014-10-08	2014-10-08 00:00:00	2014-10-08	5001	0	\N	0	0	\N	\N	0	108047	0	8331-1	3006322		
34666	3176	3001488	2005-06-26	2005-06-26 00:00:00	2005-06-26	5001	0	\N	0	0	\N	\N	0	211098	0	7258-7	3001488		
89339	2765	4133840	2018-01-02	2018-01-02 00:00:00	2018-01-02	5001	0	\N	0	0	\N	\N	0	182827	0	127783003	4133840		
40500	3759	3020655	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	249969	0	6844-5	3020655		
53590	4924	3005136	1994-06-22	1994-06-22 00:00:00	1994-06-22	5001	0	\N	0	0	\N	\N	0	327174	0	6075-6	3005136		
17311	1574	40758406	1986-02-23	1986-02-23 00:00:00	1986-02-23	5001	0	\N	0	0	\N	\N	0	105638	0	55277-8	40758406		
57555	5285	40766240	1990-09-15	1990-09-15 00:00:00	1990-09-15	5001	0	\N	0	0	\N	\N	0	351626	0	63513-6	40766240		
52730	4844	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	322229	0	6833-8	3023430		
35011	3191	3006322	1996-10-13	1996-10-13 00:00:00	1996-10-13	5001	0	\N	0	0	\N	\N	0	212333	0	8331-1	3006322		
47659	4374	3005136	1979-06-16	1979-06-16 00:00:00	1979-06-16	5001	0	\N	0	0	\N	\N	0	290554	0	6075-6	3005136		
19508	1782	3035995	1956-01-11	1956-01-11 00:00:00	1956-01-11	5001	0	\N	0	0	\N	\N	0	119339	0	6768-6	3035995		
20888	1923	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	127864	0	6189-5	3006734		
4072	406	40769179	1974-02-22	1974-02-22 00:00:00	1974-02-22	5001	0	\N	0	0	\N	\N	0	26810	0	66519-0	40769179		
7005	222	4024958	1960-12-13	1960-12-13 00:00:00	1960-12-13	5001	0	\N	0	0	\N	\N	0	14890	0	117015009	4024958		
9821	924	3006322	1995-08-11	1995-08-11 00:00:00	1995-08-11	5001	0	\N	0	0	\N	\N	0	61548	0	8331-1	3006322		
10193	973	3049273	1994-09-12	1994-09-12 00:00:00	1994-09-12	5001	0	\N	0	0	\N	\N	0	64851	0	38265-5	3049273		
44986	1381	4133840	2017-05-06	2017-05-06 00:00:00	2017-05-06	5001	0	\N	0	0	\N	\N	0	91577	0	127783003	4133840		
134295	4134	4052083	1972-01-06	1972-01-06 00:00:00	1972-01-06	5001	0	\N	0	0	\N	\N	0	274844	0	23426006	4052083		
34376	3133	3051031	2004-07-09	2004-07-09 00:00:00	2004-07-09	5001	0	\N	0	0	\N	\N	0	208524	0	46240-8	3051031		
6899	217	4024958	1979-05-18	1979-05-18 00:00:00	1979-05-18	5001	0	\N	0	0	\N	\N	0	14643	0	117015009	4024958		
44393	4100	46235214	1980-04-29	1980-04-29 00:00:00	1980-04-29	5001	0	\N	0	0	\N	\N	0	272394	0	76690-7	46235214		
40817	3786	3006322	1981-09-11	1981-09-11 00:00:00	1981-09-11	5001	0	\N	0	0	\N	\N	0	251711	0	8331-1	3006322		
7138	691	3006322	1999-09-30	1999-09-30 00:00:00	1999-09-30	5001	0	\N	0	0	\N	\N	0	45746	0	8331-1	3006322		
52287	4804	3015076	1978-01-28	1978-01-28 00:00:00	1978-01-28	5001	0	\N	0	0	\N	\N	0	319658	0	6248-9	3015076		
14071	1314	3006322	1955-12-28	1955-12-28 00:00:00	1955-12-28	5001	0	\N	0	0	\N	\N	0	87007	0	8331-1	3006322		
54705	1658	4052083	1928-07-31	1928-07-31 00:00:00	1928-07-31	5001	0	\N	0	0	\N	\N	0	111320	0	23426006	4052083		
29995	2765	3019406	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	182987	0	6158-0	3019406		
47610	4373	3020655	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	290425	0	6844-5	3020655		
41438	3859	3049273	1993-03-06	1993-03-06 00:00:00	1993-03-06	5001	0	\N	0	0	\N	\N	0	256153	0	38265-5	3049273		
14452	1352	3006322	1947-04-05	1947-04-05 00:00:00	1947-04-05	5001	0	\N	0	0	\N	\N	0	89533	0	8331-1	3006322		
67594	2073	4024958	2015-07-08	2015-07-08 00:00:00	2015-07-08	5001	0	\N	0	0	\N	\N	0	137925	0	117015009	4024958		
16381	1493	3006322	1957-09-21	1957-09-21 00:00:00	1957-09-21	5001	0	\N	0	0	\N	\N	0	99549	0	8331-1	3006322		
128535	3957	4133840	2007-09-13	2007-09-13 00:00:00	2007-09-13	5001	0	\N	0	0	\N	\N	0	263104	0	127783003	4133840		
14684	1367	3006322	1966-08-24	1966-08-24 00:00:00	1966-08-24	5001	0	\N	0	0	\N	\N	0	90585	0	8331-1	3006322		
52454	4822	40766240	1971-05-06	1971-05-06 00:00:00	1971-05-06	5001	0	\N	0	0	\N	\N	0	320713	0	63513-6	40766240		
48770	4459	3006322	2005-01-14	2005-01-14 00:00:00	2005-01-14	5001	0	\N	0	0	\N	\N	0	296711	0	8331-1	3006322		
19610	1789	3020655	1976-03-06	1976-03-06 00:00:00	1976-03-06	5001	0	\N	0	0	\N	\N	0	119926	0	6844-5	3020655		
2687	263	3051031	2003-03-05	2003-03-05 00:00:00	2003-03-05	5001	0	\N	0	0	\N	\N	0	17449	0	46240-8	3051031		
82132	2542	4024958	1965-12-18	1965-12-18 00:00:00	1965-12-18	5001	0	\N	0	0	\N	\N	0	168074	0	117015009	4024958		
37688	3477	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	230651	0	7258-7	3001488		
16223	1478	3035995	1975-05-03	1975-05-03 00:00:00	1975-05-03	5001	0	\N	0	0	\N	\N	0	98639	0	6768-6	3035995		
71532	2189	4052083	2004-04-08	2004-04-08 00:00:00	2004-04-08	5001	0	\N	0	0	\N	\N	0	145906	0	23426006	4052083		
45628	4208	3006322	2000-04-30	2000-04-30 00:00:00	2000-04-30	5001	0	\N	0	0	\N	\N	0	279353	0	8331-1	3006322		
537	28	3006322	1985-03-19	1985-03-19 00:00:00	1985-03-19	5001	0	\N	0	0	\N	\N	0	1955	0	8331-1	3006322		
159354	4898	4024958	2005-04-01	2005-04-01 00:00:00	2005-04-01	5001	0	\N	0	0	\N	\N	0	325696	0	117015009	4024958		
50152	4574	3006322	1990-06-24	1990-06-24 00:00:00	1990-06-24	5001	0	\N	0	0	\N	\N	0	304740	0	8331-1	3006322		
51550	4719	3001488	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	314290	0	7258-7	3001488		
121260	3744	4052083	1979-09-18	1979-09-18 00:00:00	1979-09-18	5001	0	\N	0	0	\N	\N	0	248747	0	23426006	4052083		
43545	4026	3001247	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	267614	0	6085-5	3001247		
36697	3371	3006322	1988-12-11	1988-12-11 00:00:00	1988-12-11	5001	0	\N	0	0	\N	\N	0	223606	0	8331-1	3006322		
28324	2619	3006322	1987-06-10	1987-06-10 00:00:00	1987-06-10	5001	0	\N	0	0	\N	\N	0	173150	0	8331-1	3006322		
134488	4143	4024958	1971-03-31	1971-03-31 00:00:00	1971-03-31	5001	0	\N	0	0	\N	\N	0	275344	0	117015009	4024958		
8745	842	3011505	2009-09-19	2009-09-19 00:00:00	2009-09-19	5001	0	\N	0	0	\N	\N	0	55690	0	19926-5	3011505		
27032	2503	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	165695	0	7258-7	3001488		
27134	2518	3006322	2013-01-17	2013-01-17 00:00:00	2013-01-17	5001	0	\N	0	0	\N	\N	0	166533	0	8331-1	3006322		
164237	5045	4024958	1997-01-12	1997-01-12 00:00:00	1997-01-12	5001	0	\N	0	0	\N	\N	0	335232	0	117015009	4024958		
31656	2896	3020655	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	192802	0	6844-5	3020655		
31680	2898	3036780	1992-01-21	1992-01-21 00:00:00	1992-01-21	5001	0	\N	0	0	\N	\N	0	193068	0	6095-4	3036780		
43088	3982	40758406	1940-03-10	1940-03-10 00:00:00	1940-03-10	5001	0	\N	0	0	\N	\N	0	264650	0	55277-8	40758406		
6149	578	46235214	2010-09-17	2010-09-17 00:00:00	2010-09-17	5001	0	\N	0	0	\N	\N	0	38218	0	76690-7	46235214		
51091	4662	3013682	1989-07-27	1989-07-27 00:00:00	1989-07-27	5001	0	\N	0	0	\N	\N	0	310773	0	3094-0	3013682		
1202	97	3011505	1994-07-25	1994-07-25 00:00:00	1994-07-25	5001	0	\N	0	0	\N	\N	0	6609	0	19926-5	3011505		
17662	1608	3006322	1949-09-14	1949-09-14 00:00:00	1949-09-14	5001	0	\N	0	0	\N	\N	0	107964	0	8331-1	3006322		
34667	3176	3006734	2005-06-26	2005-06-26 00:00:00	2005-06-26	5001	0	\N	0	0	\N	\N	0	211098	0	6189-5	3006734		
89343	2765	4024958	2013-07-08	2013-07-08 00:00:00	2013-07-08	5001	0	\N	0	0	\N	\N	0	182988	0	117015009	4024958		
40501	3759	3005136	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	249969	0	6075-6	3005136		
53591	4924	3021226	1994-06-22	1994-06-22 00:00:00	1994-06-22	5001	0	\N	0	0	\N	\N	0	327174	0	6246-3	3021226		
17312	1574	3006322	1967-03-02	1967-03-02 00:00:00	1967-03-02	5001	0	\N	0	0	\N	\N	0	105710	0	8331-1	3006322		
57556	5285	40758406	1990-09-15	1990-09-15 00:00:00	1990-09-15	5001	0	\N	0	0	\N	\N	0	351626	0	55277-8	40758406		
52731	4844	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	322229	0	6844-5	3020655		
35014	3194	40769194	1968-06-19	1968-06-19 00:00:00	1968-06-19	5001	0	\N	0	0	\N	\N	0	212490	0	66534-9	40769194		
47660	4374	3014599	1979-06-16	1979-06-16 00:00:00	1979-06-16	5001	0	\N	0	0	\N	\N	0	290554	0	6106-9	3014599		
19509	1782	3006906	1956-01-11	1956-01-11 00:00:00	1956-01-11	5001	0	\N	0	0	\N	\N	0	119339	0	17861-6	3006906		
20889	1923	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	127864	0	6095-4	3036780		
4073	406	40769189	1974-02-22	1974-02-22 00:00:00	1974-02-22	5001	0	\N	0	0	\N	\N	0	26810	0	66529-9	40769189		
7037	224	4024958	1959-07-04	1959-07-04 00:00:00	1959-07-04	5001	0	\N	0	0	\N	\N	0	15084	0	117015009	4024958		
9822	924	3006322	2011-04-30	2011-04-30 00:00:00	2011-04-30	5001	0	\N	0	0	\N	\N	0	61530	0	8331-1	3006322		
10194	973	3006322	1945-04-07	1945-04-07 00:00:00	1945-04-07	5001	0	\N	0	0	\N	\N	0	64809	0	8331-1	3006322		
44987	1381	4052083	2017-04-25	2017-04-25 00:00:00	2017-04-25	5001	0	\N	0	0	\N	\N	0	91584	0	23426006	4052083		
134298	4134	4024958	1964-01-20	1964-01-20 00:00:00	1964-01-20	5001	0	\N	0	0	\N	\N	0	274843	0	117015009	4024958		
34377	3133	40758406	2004-07-09	2004-07-09 00:00:00	2004-07-09	5001	0	\N	0	0	\N	\N	0	208524	0	55277-8	40758406		
6900	217	4052083	1981-05-08	1981-05-08 00:00:00	1981-05-08	5001	0	\N	0	0	\N	\N	0	14637	0	23426006	4052083		
44394	4100	3006322	2013-12-31	2013-12-31 00:00:00	2013-12-31	5001	0	\N	0	0	\N	\N	0	272456	0	8331-1	3006322		
40818	3786	3006322	1966-12-12	1966-12-12 00:00:00	1966-12-12	5001	0	\N	0	0	\N	\N	0	251712	0	8331-1	3006322		
7139	691	3049273	2019-06-20	2019-06-20 00:00:00	2019-06-20	5001	0	\N	0	0	\N	\N	0	45788	0	38265-5	3049273		
52288	4804	3001247	1978-01-28	1978-01-28 00:00:00	1978-01-28	5001	0	\N	0	0	\N	\N	0	319658	0	6085-5	3001247		
14072	1315	3006322	1982-03-06	1982-03-06 00:00:00	1982-03-06	5001	0	\N	0	0	\N	\N	0	87129	0	8331-1	3006322		
54706	1658	4052083	1952-01-16	1952-01-16 00:00:00	1952-01-16	5001	0	\N	0	0	\N	\N	0	111323	0	23426006	4052083		
29996	2765	3021226	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	182987	0	6246-3	3021226		
47611	4373	3023430	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	290425	0	6833-8	3023430		
41439	3859	3011505	1993-03-06	1993-03-06 00:00:00	1993-03-06	5001	0	\N	0	0	\N	\N	0	256153	0	19926-5	3011505		
14453	1352	3006322	1985-07-16	1985-07-16 00:00:00	1985-07-16	5001	0	\N	0	0	\N	\N	0	89593	0	8331-1	3006322		
67600	2073	4052083	1982-04-07	1982-04-07 00:00:00	1982-04-07	5001	0	\N	0	0	\N	\N	0	137934	0	23426006	4052083		
16382	1493	3006322	1958-08-31	1958-08-31 00:00:00	1958-08-31	5001	0	\N	0	0	\N	\N	0	99550	0	8331-1	3006322		
128537	3957	4133840	2006-01-12	2006-01-12 00:00:00	2006-01-12	5001	0	\N	0	0	\N	\N	0	263117	0	127783003	4133840		
108237	3343	4052083	1995-11-26	1995-11-26 00:00:00	1995-11-26	5001	0	\N	0	0	\N	\N	0	221765	0	23426006	4052083		
52456	4822	40766240	1949-03-22	1949-03-22 00:00:00	1949-03-22	5001	0	\N	0	0	\N	\N	0	320777	0	63513-6	40766240		
48771	4460	3006322	1956-06-05	1956-06-05 00:00:00	1956-06-05	5001	0	\N	0	0	\N	\N	0	296773	0	8331-1	3006322		
19611	1789	3001247	1976-03-06	1976-03-06 00:00:00	1976-03-06	5001	0	\N	0	0	\N	\N	0	119926	0	6085-5	3001247		
2688	263	40758406	2003-03-05	2003-03-05 00:00:00	2003-03-05	5001	0	\N	0	0	\N	\N	0	17449	0	55277-8	40758406		
93457	2876	4133840	2005-10-20	2005-10-20 00:00:00	2005-10-20	5001	0	\N	0	0	\N	\N	0	191389	0	127783003	4133840		
37689	3477	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	230651	0	6075-6	3005136		
16224	1478	3006906	1975-05-03	1975-05-03 00:00:00	1975-05-03	5001	0	\N	0	0	\N	\N	0	98639	0	17861-6	3006906		
71535	2189	4024958	1999-07-07	1999-07-07 00:00:00	1999-07-07	5001	0	\N	0	0	\N	\N	0	145892	0	117015009	4024958		
45629	4208	3006322	1944-05-13	1944-05-13 00:00:00	1944-05-13	5001	0	\N	0	0	\N	\N	0	279394	0	8331-1	3006322		
11826	1123	3006322	1988-11-05	1988-11-05 00:00:00	1988-11-05	5001	0	\N	0	0	\N	\N	0	73996	0	8331-1	3006322		
159358	4898	4024958	1954-07-21	1954-07-21 00:00:00	1954-07-21	5001	0	\N	0	0	\N	\N	0	325689	0	117015009	4024958		
50153	4574	3006322	1982-09-21	1982-09-21 00:00:00	1982-09-21	5001	0	\N	0	0	\N	\N	0	304727	0	8331-1	3006322		
51551	4719	3001247	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	314290	0	6085-5	3001247		
146438	4492	4052083	1959-06-09	1959-06-09 00:00:00	1959-06-09	5001	0	\N	0	0	\N	\N	0	299083	0	23426006	4052083		
43546	4026	3000876	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	267614	0	6082-2	3000876		
36698	3371	3006322	1981-02-17	1981-02-17 00:00:00	1981-02-17	5001	0	\N	0	0	\N	\N	0	223602	0	8331-1	3006322		
28325	2619	3006322	1949-02-16	1949-02-16 00:00:00	1949-02-16	5001	0	\N	0	0	\N	\N	0	173147	0	8331-1	3006322		
128721	3962	4052083	1969-02-22	1969-02-22 00:00:00	1969-02-22	5001	0	\N	0	0	\N	\N	0	263447	0	23426006	4052083		
8746	842	3011505	1977-12-24	1977-12-24 00:00:00	1977-12-24	5001	0	\N	0	0	\N	\N	0	55663	0	19926-5	3011505		
27033	2503	3006322	2006-02-06	2006-02-06 00:00:00	2006-02-06	5001	0	\N	0	0	\N	\N	0	165690	0	8331-1	3006322		
27135	2518	3011505	2016-01-22	2016-01-22 00:00:00	2016-01-22	5001	0	\N	0	0	\N	\N	0	166593	0	19926-5	3011505		
164242	5045	4052083	1989-12-29	1989-12-29 00:00:00	1989-12-29	5001	0	\N	0	0	\N	\N	0	335286	0	23426006	4052083		
31657	2896	3021226	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	192836	0	6246-3	3021226		
31681	2898	3020655	1992-01-21	1992-01-21 00:00:00	1992-01-21	5001	0	\N	0	0	\N	\N	0	193068	0	6844-5	3020655		
43089	3982	46235214	1940-03-10	1940-03-10 00:00:00	1940-03-10	5001	0	\N	0	0	\N	\N	0	264650	0	76690-7	46235214		
6151	578	40766240	2010-09-17	2010-09-17 00:00:00	2010-09-17	5001	0	\N	0	0	\N	\N	0	38218	0	63513-6	40766240		
51092	4662	3020630	1989-07-27	1989-07-27 00:00:00	1989-07-27	5001	0	\N	0	0	\N	\N	0	310773	0	2885-2	3020630		
1203	97	3011505	1995-07-31	1995-07-31 00:00:00	1995-07-31	5001	0	\N	0	0	\N	\N	0	6635	0	19926-5	3011505		
17663	1609	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	108191	0	6248-9	3015076		
34668	3176	3036780	2005-06-26	2005-06-26 00:00:00	2005-06-26	5001	0	\N	0	0	\N	\N	0	211098	0	6095-4	3036780		
89347	2765	4133840	2016-12-27	2016-12-27 00:00:00	2016-12-27	5001	0	\N	0	0	\N	\N	0	182837	0	127783003	4133840		
40502	3759	3021226	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	249969	0	6246-3	3021226		
53592	4924	3019406	1994-06-22	1994-06-22 00:00:00	1994-06-22	5001	0	\N	0	0	\N	\N	0	327174	0	6158-0	3019406		
17313	1574	3006322	2007-04-24	2007-04-24 00:00:00	2007-04-24	5001	0	\N	0	0	\N	\N	0	105718	0	8331-1	3006322		
57557	5285	3051031	1990-09-15	1990-09-15 00:00:00	1990-09-15	5001	0	\N	0	0	\N	\N	0	351626	0	46240-8	3051031		
52732	4844	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	322229	0	6273-7	3006451		
35015	3194	40769184	1968-06-19	1968-06-19 00:00:00	1968-06-19	5001	0	\N	0	0	\N	\N	0	212490	0	66524-0	40769184		
47661	4374	3036780	1979-06-16	1979-06-16 00:00:00	1979-06-16	5001	0	\N	0	0	\N	\N	0	290554	0	6095-4	3036780		
19510	1782	3006322	2008-03-05	2008-03-05 00:00:00	2008-03-05	5001	0	\N	0	0	\N	\N	0	119326	0	8331-1	3006322		
20890	1923	3006322	1999-03-17	1999-03-17 00:00:00	1999-03-17	5001	0	\N	0	0	\N	\N	0	127922	0	8331-1	3006322		
4074	406	3006322	1955-01-08	1955-01-08 00:00:00	1955-01-08	5001	0	\N	0	0	\N	\N	0	26717	0	8331-1	3006322		
7057	224	4024958	1945-05-02	1945-05-02 00:00:00	1945-05-02	5001	0	\N	0	0	\N	\N	0	15043	0	117015009	4024958		
9823	924	3006322	1978-11-21	1978-11-21 00:00:00	1978-11-21	5001	0	\N	0	0	\N	\N	0	61505	0	8331-1	3006322		
128964	3968	4024958	1985-05-02	1985-05-02 00:00:00	1985-05-02	5001	0	\N	0	0	\N	\N	0	263839	0	117015009	4024958		
44988	1381	4133840	2012-08-18	2012-08-18 00:00:00	2012-08-18	5001	0	\N	0	0	\N	\N	0	91575	0	127783003	4133840		
134330	4137	4052083	1976-08-23	1976-08-23 00:00:00	1976-08-23	5001	0	\N	0	0	\N	\N	0	274993	0	23426006	4052083		
34379	3133	46235214	2004-07-09	2004-07-09 00:00:00	2004-07-09	5001	0	\N	0	0	\N	\N	0	208524	0	76690-7	46235214		
6918	219	4024958	1970-08-19	1970-08-19 00:00:00	1970-08-19	5001	0	\N	0	0	\N	\N	0	14707	0	117015009	4024958		
44395	4100	3006322	1949-09-01	1949-09-01 00:00:00	1949-09-01	5001	0	\N	0	0	\N	\N	0	272454	0	8331-1	3006322		
40819	3786	3006322	1979-05-13	1979-05-13 00:00:00	1979-05-13	5001	0	\N	0	0	\N	\N	0	251669	0	8331-1	3006322		
7140	691	3006322	2007-04-03	2007-04-03 00:00:00	2007-04-03	5001	0	\N	0	0	\N	\N	0	45782	0	8331-1	3006322		
52289	4804	3036780	1978-01-28	1978-01-28 00:00:00	1978-01-28	5001	0	\N	0	0	\N	\N	0	319658	0	6095-4	3036780		
14073	1315	3006322	1990-08-03	1990-08-03 00:00:00	1990-08-03	5001	0	\N	0	0	\N	\N	0	87116	0	8331-1	3006322		
54715	1658	4052083	2016-04-18	2016-04-18 00:00:00	2016-04-18	5001	0	\N	0	0	\N	\N	0	111297	0	23426006	4052083		
29997	2765	3006451	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	182987	0	6273-7	3006451		
47612	4373	3005136	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	290425	0	6075-6	3005136		
41440	3859	3051031	1990-02-21	1990-02-21 00:00:00	1990-02-21	5001	0	\N	0	0	\N	\N	0	256274	0	46240-8	3051031		
14454	1352	3011505	2007-05-06	2007-05-06 00:00:00	2007-05-06	5001	0	\N	0	0	\N	\N	0	89588	0	19926-5	3011505		
67647	2075	4024958	1968-08-18	1968-08-18 00:00:00	1968-08-18	5001	0	\N	0	0	\N	\N	0	138075	0	117015009	4024958		
16383	1493	3006322	1982-06-22	1982-06-22 00:00:00	1982-06-22	5001	0	\N	0	0	\N	\N	0	99581	0	8331-1	3006322		
128538	3957	4133840	2008-09-18	2008-09-18 00:00:00	2008-09-18	5001	0	\N	0	0	\N	\N	0	263079	0	127783003	4133840		
108242	3343	4052083	2001-03-30	2001-03-30 00:00:00	2001-03-30	5001	0	\N	0	0	\N	\N	0	221786	0	23426006	4052083		
52457	4822	40758406	1949-03-22	1949-03-22 00:00:00	1949-03-22	5001	0	\N	0	0	\N	\N	0	320777	0	55277-8	40758406		
48772	4460	3006322	1968-02-17	1968-02-17 00:00:00	1968-02-17	5001	0	\N	0	0	\N	\N	0	296809	0	8331-1	3006322		
19612	1789	3006734	1976-03-06	1976-03-06 00:00:00	1976-03-06	5001	0	\N	0	0	\N	\N	0	119926	0	6189-5	3006734		
2689	263	46235214	2003-03-05	2003-03-05 00:00:00	2003-03-05	5001	0	\N	0	0	\N	\N	0	17449	0	76690-7	46235214		
93458	2876	4133840	2010-06-17	2010-06-17 00:00:00	2010-06-17	5001	0	\N	0	0	\N	\N	0	191353	0	127783003	4133840		
37690	3477	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	230651	0	6158-0	3019406		
16225	1478	3019550	1975-05-03	1975-05-03 00:00:00	1975-05-03	5001	0	\N	0	0	\N	\N	0	98639	0	2951-2	3019550		
71568	2190	4024958	1961-12-23	1961-12-23 00:00:00	1961-12-23	5001	0	\N	0	0	\N	\N	0	146068	0	117015009	4024958		
45630	4208	3006322	1999-01-23	1999-01-23 00:00:00	1999-01-23	5001	0	\N	0	0	\N	\N	0	279351	0	8331-1	3006322		
11827	1123	3006322	1971-05-29	1971-05-29 00:00:00	1971-05-29	5001	0	\N	0	0	\N	\N	0	73977	0	8331-1	3006322		
159361	4898	4052083	1999-06-23	1999-06-23 00:00:00	1999-06-23	5001	0	\N	0	0	\N	\N	0	325667	0	23426006	4052083		
50154	4574	3006322	1964-12-15	1964-12-15 00:00:00	1964-12-15	5001	0	\N	0	0	\N	\N	0	304681	0	8331-1	3006322		
51552	4719	3021226	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	314290	0	6246-3	3021226		
146448	4492	4024958	1955-03-08	1955-03-08 00:00:00	1955-03-08	5001	0	\N	0	0	\N	\N	0	299071	0	117015009	4024958		
43547	4026	3020655	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	267614	0	6844-5	3020655		
36699	3371	3006322	2006-08-18	2006-08-18 00:00:00	2006-08-18	5001	0	\N	0	0	\N	\N	0	223572	0	8331-1	3006322		
28326	2619	3006322	1982-08-15	1982-08-15 00:00:00	1982-08-15	5001	0	\N	0	0	\N	\N	0	173145	0	8331-1	3006322		
128737	3962	4024958	1957-12-16	1957-12-16 00:00:00	1957-12-16	5001	0	\N	0	0	\N	\N	0	263468	0	117015009	4024958		
8747	842	3006322	1940-07-24	1940-07-24 00:00:00	1940-07-24	5001	0	\N	0	0	\N	\N	0	55642	0	8331-1	3006322		
27034	2504	3006322	1971-05-06	1971-05-06 00:00:00	1971-05-06	5001	0	\N	0	0	\N	\N	0	165774	0	8331-1	3006322		
27136	2518	3011505	1993-06-11	1993-06-11 00:00:00	1993-06-11	5001	0	\N	0	0	\N	\N	0	166566	0	19926-5	3011505		
164245	5045	4024958	1965-07-25	1965-07-25 00:00:00	1965-07-25	5001	0	\N	0	0	\N	\N	0	335260	0	117015009	4024958		
31658	2896	3005136	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	192836	0	6075-6	3005136		
31682	2898	3023430	1992-01-21	1992-01-21 00:00:00	1992-01-21	5001	0	\N	0	0	\N	\N	0	193068	0	6833-8	3023430		
43091	3982	3051031	1940-03-10	1940-03-10 00:00:00	1940-03-10	5001	0	\N	0	0	\N	\N	0	264650	0	46240-8	3051031		
6153	578	3051031	2010-09-17	2010-09-17 00:00:00	2010-09-17	5001	0	\N	0	0	\N	\N	0	38218	0	46240-8	3051031		
51093	4662	3015632	1989-07-27	1989-07-27 00:00:00	1989-07-27	5001	0	\N	0	0	\N	\N	0	310773	0	2028-9	3015632		
1204	97	3011505	2012-07-23	2012-07-23 00:00:00	2012-07-23	5001	0	\N	0	0	\N	\N	0	6631	0	19926-5	3011505		
17664	1609	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	108191	0	6075-6	3005136		
34669	3176	3021226	2005-06-26	2005-06-26 00:00:00	2005-06-26	5001	0	\N	0	0	\N	\N	0	211098	0	6246-3	3021226		
89356	2765	4133840	2018-01-09	2018-01-09 00:00:00	2018-01-09	5001	0	\N	0	0	\N	\N	0	182948	0	127783003	4133840		
40503	3759	3006451	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	249969	0	6273-7	3006451		
53593	4924	3015076	1994-06-22	1994-06-22 00:00:00	1994-06-22	5001	0	\N	0	0	\N	\N	0	327174	0	6248-9	3015076		
17314	1574	40758406	1998-10-18	1998-10-18 00:00:00	1998-10-18	5001	0	\N	0	0	\N	\N	0	105717	0	55277-8	40758406		
57559	5285	46235214	1990-09-15	1990-09-15 00:00:00	1990-09-15	5001	0	\N	0	0	\N	\N	0	351626	0	76690-7	46235214		
52733	4844	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	322229	0	6248-9	3015076		
35016	3194	40769179	1968-06-19	1968-06-19 00:00:00	1968-06-19	5001	0	\N	0	0	\N	\N	0	212490	0	66519-0	40769179		
47662	4374	3019406	1979-06-16	1979-06-16 00:00:00	1979-06-16	5001	0	\N	0	0	\N	\N	0	290554	0	6158-0	3019406		
19511	1782	3006322	2003-02-03	2003-02-03 00:00:00	2003-02-03	5001	0	\N	0	0	\N	\N	0	119325	0	8331-1	3006322		
20891	1924	3006322	1980-02-21	1980-02-21 00:00:00	1980-02-21	5001	0	\N	0	0	\N	\N	0	128027	0	8331-1	3006322		
4075	406	3006322	1984-09-29	1984-09-29 00:00:00	1984-09-29	5001	0	\N	0	0	\N	\N	0	26811	0	8331-1	3006322		
7059	224	4052083	2008-02-27	2008-02-27 00:00:00	2008-02-27	5001	0	\N	0	0	\N	\N	0	15039	0	23426006	4052083		
9824	924	3006322	1984-12-04	1984-12-04 00:00:00	1984-12-04	5001	0	\N	0	0	\N	\N	0	61547	0	8331-1	3006322		
128972	3968	4024958	1923-04-12	1923-04-12 00:00:00	1923-04-12	5001	0	\N	0	0	\N	\N	0	263790	0	117015009	4024958		
44999	1382	4052083	1987-12-25	1987-12-25 00:00:00	1987-12-25	5001	0	\N	0	0	\N	\N	0	91651	0	23426006	4052083		
55695	1695	4052083	1999-09-01	1999-09-01 00:00:00	1999-09-01	5001	0	\N	0	0	\N	\N	0	113487	0	23426006	4052083		
34381	3133	40766240	2004-11-06	2004-11-06 00:00:00	2004-11-06	5001	0	\N	0	0	\N	\N	0	208458	0	63513-6	40766240		
6938	219	4052083	1991-11-27	1991-11-27 00:00:00	1991-11-27	5001	0	\N	0	0	\N	\N	0	14727	0	23426006	4052083		
44396	4100	3006322	2003-06-07	2003-06-07 00:00:00	2003-06-07	5001	0	\N	0	0	\N	\N	0	272395	0	8331-1	3006322		
40820	3786	3006322	2013-12-09	2013-12-09 00:00:00	2013-12-09	5001	0	\N	0	0	\N	\N	0	251718	0	8331-1	3006322		
7141	691	3006322	1999-05-24	1999-05-24 00:00:00	1999-05-24	5001	0	\N	0	0	\N	\N	0	45777	0	8331-1	3006322		
52290	4804	3001488	1978-01-28	1978-01-28 00:00:00	1978-01-28	5001	0	\N	0	0	\N	\N	0	319658	0	7258-7	3001488		
14074	1315	3006322	2010-10-31	2010-10-31 00:00:00	2010-10-31	5001	0	\N	0	0	\N	\N	0	87117	0	8331-1	3006322		
54718	1658	4052083	1984-09-17	1984-09-17 00:00:00	1984-09-17	5001	0	\N	0	0	\N	\N	0	111327	0	23426006	4052083		
29998	2765	3000876	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	182987	0	6082-2	3000876		
47613	4373	3012494	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	290425	0	6206-7	3012494		
41441	3859	40766240	1990-02-21	1990-02-21 00:00:00	1990-02-21	5001	0	\N	0	0	\N	\N	0	256274	0	63513-6	40766240		
14455	1352	3011505	1997-08-31	1997-08-31 00:00:00	1997-08-31	5001	0	\N	0	0	\N	\N	0	89587	0	19926-5	3011505		
48388	4439	3006322	1985-12-22	1985-12-22 00:00:00	1985-12-22	5001	0	\N	0	0	\N	\N	0	295122	0	8331-1	3006322		
16399	1496	3006322	1932-01-29	1932-01-29 00:00:00	1932-01-29	5001	0	\N	0	0	\N	\N	0	99719	0	8331-1	3006322		
128542	3957	4133840	2003-01-02	2003-01-02 00:00:00	2003-01-02	5001	0	\N	0	0	\N	\N	0	263078	0	127783003	4133840		
108270	3343	4024958	1983-08-02	1983-08-02 00:00:00	1983-08-02	5001	0	\N	0	0	\N	\N	0	221772	0	117015009	4024958		
52458	4822	3051031	1949-03-22	1949-03-22 00:00:00	1949-03-22	5001	0	\N	0	0	\N	\N	0	320777	0	46240-8	3051031		
48773	4460	3006322	1954-10-03	1954-10-03 00:00:00	1954-10-03	5001	0	\N	0	0	\N	\N	0	296772	0	8331-1	3006322		
19613	1789	3006322	2014-09-10	2014-09-10 00:00:00	2014-09-10	5001	0	\N	0	0	\N	\N	0	119877	0	8331-1	3006322		
2690	263	40766240	2003-03-05	2003-03-05 00:00:00	2003-03-05	5001	0	\N	0	0	\N	\N	0	17449	0	63513-6	40766240		
93460	2876	4133840	1989-08-03	1989-08-03 00:00:00	1989-08-03	5001	0	\N	0	0	\N	\N	0	191372	0	127783003	4133840		
37691	3477	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	230651	0	6248-9	3015076		
16226	1478	3000963	1975-05-03	1975-05-03 00:00:00	1975-05-03	5001	0	\N	0	0	\N	\N	0	98639	0	718-7	3000963		
71569	2190	4024958	2017-06-05	2017-06-05 00:00:00	2017-06-05	5001	0	\N	0	0	\N	\N	0	146013	0	117015009	4024958		
45631	4208	3006322	1976-09-06	1976-09-06 00:00:00	1976-09-06	5001	0	\N	0	0	\N	\N	0	279349	0	8331-1	3006322		
11828	1123	3006322	1995-10-16	1995-10-16 00:00:00	1995-10-16	5001	0	\N	0	0	\N	\N	0	73978	0	8331-1	3006322		
20457	1878	3006322	2010-06-28	2010-06-28 00:00:00	2010-06-28	5001	0	\N	0	0	\N	\N	0	125330	0	8331-1	3006322		
50155	4574	3006322	2008-06-11	2008-06-11 00:00:00	2008-06-11	5001	0	\N	0	0	\N	\N	0	304684	0	8331-1	3006322		
87558	2706	4024958	1968-12-24	1968-12-24 00:00:00	1968-12-24	5001	0	\N	0	0	\N	\N	0	179310	0	117015009	4024958		
146455	4493	4024958	1987-04-30	1987-04-30 00:00:00	1987-04-30	5001	0	\N	0	0	\N	\N	0	299153	0	117015009	4024958		
43548	4026	3023430	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	267614	0	6833-8	3023430		
36700	3371	3006322	1982-07-21	1982-07-21 00:00:00	1982-07-21	5001	0	\N	0	0	\N	\N	0	223574	0	8331-1	3006322		
28327	2619	3006322	1948-03-24	1948-03-24 00:00:00	1948-03-24	5001	0	\N	0	0	\N	\N	0	173203	0	8331-1	3006322		
128739	3962	4024958	2003-11-13	2003-11-13 00:00:00	2003-11-13	5001	0	\N	0	0	\N	\N	0	263441	0	117015009	4024958		
8748	842	3011505	1947-04-12	1947-04-12 00:00:00	1947-04-12	5001	0	\N	0	0	\N	\N	0	55726	0	19926-5	3011505		
27035	2504	3006322	1997-06-27	1997-06-27 00:00:00	1997-06-27	5001	0	\N	0	0	\N	\N	0	165802	0	8331-1	3006322		
27137	2518	3011505	2000-01-28	2000-01-28 00:00:00	2000-01-28	5001	0	\N	0	0	\N	\N	0	166590	0	19926-5	3011505		
31557	2891	3027231	1975-04-27	1975-04-27 00:00:00	1975-04-27	5001	0	\N	0	0	\N	\N	0	192353	0	6276-0	3027231		
31659	2896	3006734	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	192836	0	6189-5	3006734		
31683	2898	3019406	1992-01-21	1992-01-21 00:00:00	1992-01-21	5001	0	\N	0	0	\N	\N	0	193068	0	6158-0	3019406		
43092	3982	40766240	1940-03-10	1940-03-10 00:00:00	1940-03-10	5001	0	\N	0	0	\N	\N	0	264650	0	63513-6	40766240		
6154	578	40758406	2010-09-17	2010-09-17 00:00:00	2010-09-17	5001	0	\N	0	0	\N	\N	0	38218	0	55277-8	40758406		
51094	4662	3023103	1989-07-27	1989-07-27 00:00:00	1989-07-27	5001	0	\N	0	0	\N	\N	0	310773	0	2823-3	3023103		
1205	97	3011505	1991-08-12	1991-08-12 00:00:00	1991-08-12	5001	0	\N	0	0	\N	\N	0	6625	0	19926-5	3011505		
17665	1609	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	108191	0	6273-7	3006451		
34670	3176	3005136	2005-06-26	2005-06-26 00:00:00	2005-06-26	5001	0	\N	0	0	\N	\N	0	211098	0	6075-6	3005136		
89377	2767	4052083	1947-03-31	1947-03-31 00:00:00	1947-03-31	5001	0	\N	0	0	\N	\N	0	183048	0	23426006	4052083		
40504	3759	3015076	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	249969	0	6248-9	3015076		
53594	4924	3036780	1994-06-22	1994-06-22 00:00:00	1994-06-22	5001	0	\N	0	0	\N	\N	0	327174	0	6095-4	3036780		
17315	1574	40766240	1998-10-18	1998-10-18 00:00:00	1998-10-18	5001	0	\N	0	0	\N	\N	0	105717	0	63513-6	40766240		
57563	5285	40758406	1944-05-04	1944-05-04 00:00:00	1944-05-04	5001	0	\N	0	0	\N	\N	0	351642	0	55277-8	40758406		
52734	4844	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	322229	0	6206-7	3012494		
35017	3194	40769189	1968-06-19	1968-06-19 00:00:00	1968-06-19	5001	0	\N	0	0	\N	\N	0	212490	0	66529-9	40769189		
47663	4374	3015076	1979-06-16	1979-06-16 00:00:00	1979-06-16	5001	0	\N	0	0	\N	\N	0	290554	0	6248-9	3015076		
30838	2825	3049273	2007-12-24	2007-12-24 00:00:00	2007-12-24	5001	0	\N	0	0	\N	\N	0	187334	0	38265-5	3049273		
20892	1924	3006322	2015-10-27	2015-10-27 00:00:00	2015-10-27	5001	0	\N	0	0	\N	\N	0	128076	0	8331-1	3006322		
4076	406	3005136	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	26726	0	6075-6	3005136		
53098	1609	4052083	1986-11-14	1986-11-14 00:00:00	1986-11-14	5001	0	\N	0	0	\N	\N	0	108149	0	23426006	4052083		
9825	925	3006322	1999-09-22	1999-09-22 00:00:00	1999-09-22	5001	0	\N	0	0	\N	\N	0	61602	0	8331-1	3006322		
128973	3968	4052083	1913-10-01	1913-10-01 00:00:00	1913-10-01	5001	0	\N	0	0	\N	\N	0	263789	0	23426006	4052083		
122897	3788	4024958	1974-03-22	1974-03-22 00:00:00	1974-03-22	5001	0	\N	0	0	\N	\N	0	251816	0	117015009	4024958		
55704	1695	4024958	1970-11-08	1970-11-08 00:00:00	1970-11-08	5001	0	\N	0	0	\N	\N	0	113435	0	117015009	4024958		
34382	3133	40758406	2004-11-06	2004-11-06 00:00:00	2004-11-06	5001	0	\N	0	0	\N	\N	0	208458	0	55277-8	40758406		
6949	220	4024958	2011-06-06	2011-06-06 00:00:00	2011-06-06	5001	0	\N	0	0	\N	\N	0	14815	0	117015009	4024958		
44397	4101	3006322	1968-11-05	1968-11-05 00:00:00	1968-11-05	5001	0	\N	0	0	\N	\N	0	272509	0	8331-1	3006322		
40821	3786	3006322	1974-03-27	1974-03-27 00:00:00	1974-03-27	5001	0	\N	0	0	\N	\N	0	251710	0	8331-1	3006322		
7145	693	3006322	2007-10-04	2007-10-04 00:00:00	2007-10-04	5001	0	\N	0	0	\N	\N	0	45909	0	8331-1	3006322		
52291	4804	3014599	1978-01-28	1978-01-28 00:00:00	1978-01-28	5001	0	\N	0	0	\N	\N	0	319658	0	6106-9	3014599		
14075	1315	3006322	1971-03-21	1971-03-21 00:00:00	1971-03-21	5001	0	\N	0	0	\N	\N	0	87133	0	8331-1	3006322		
54724	1658	4024958	2005-02-26	2005-02-26 00:00:00	2005-02-26	5001	0	\N	0	0	\N	\N	0	111346	0	117015009	4024958		
29999	2765	3023430	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	182987	0	6833-8	3023430		
47614	4373	3036780	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	290425	0	6095-4	3036780		
41443	3859	46235214	1990-02-21	1990-02-21 00:00:00	1990-02-21	5001	0	\N	0	0	\N	\N	0	256274	0	76690-7	46235214		
14456	1352	3014576	1976-07-29	1976-07-29 00:00:00	1976-07-29	5001	0	\N	0	0	\N	\N	0	89606	0	2075-0	3014576		
48389	4439	3006322	1958-10-22	1958-10-22 00:00:00	1958-10-22	5001	0	\N	0	0	\N	\N	0	295120	0	8331-1	3006322		
16400	1496	3006322	1968-12-01	1968-12-01 00:00:00	1968-12-01	5001	0	\N	0	0	\N	\N	0	99723	0	8331-1	3006322		
128547	3957	4133840	2017-11-09	2017-11-09 00:00:00	2017-11-09	5001	0	\N	0	0	\N	\N	0	263082	0	127783003	4133840		
108293	3343	4024958	2005-07-13	2005-07-13 00:00:00	2005-07-13	5001	0	\N	0	0	\N	\N	0	221742	0	117015009	4024958		
52460	4822	46235214	1949-03-22	1949-03-22 00:00:00	1949-03-22	5001	0	\N	0	0	\N	\N	0	320777	0	76690-7	46235214		
48774	4460	3006322	1973-12-26	1973-12-26 00:00:00	1973-12-26	5001	0	\N	0	0	\N	\N	0	296775	0	8331-1	3006322		
19636	1791	3006322	1976-10-19	1976-10-19 00:00:00	1976-10-19	5001	0	\N	0	0	\N	\N	0	120086	0	8331-1	3006322		
2693	263	3049273	2010-11-05	2010-11-05 00:00:00	2010-11-05	5001	0	\N	0	0	\N	\N	0	17423	0	38265-5	3049273		
93462	2876	4133840	1995-08-10	1995-08-10 00:00:00	1995-08-10	5001	0	\N	0	0	\N	\N	0	191386	0	127783003	4133840		
37692	3477	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	230651	0	6189-5	3006734		
16227	1478	3026361	1975-05-03	1975-05-03 00:00:00	1975-05-03	5001	0	\N	0	0	\N	\N	0	98639	0	26453-1	3026361		
71856	2199	4024958	1991-01-05	1991-01-05 00:00:00	1991-01-05	5001	0	\N	0	0	\N	\N	0	146545	0	117015009	4024958		
45632	4208	3006322	2012-09-06	2012-09-06 00:00:00	2012-09-06	5001	0	\N	0	0	\N	\N	0	279451	0	8331-1	3006322		
11829	1123	3006322	2001-04-28	2001-04-28 00:00:00	2001-04-28	5001	0	\N	0	0	\N	\N	0	73979	0	8331-1	3006322		
20458	1878	3006322	1996-08-01	1996-08-01 00:00:00	1996-08-01	5001	0	\N	0	0	\N	\N	0	125322	0	8331-1	3006322		
50156	4574	3006322	2009-10-17	2009-10-17 00:00:00	2009-10-17	5001	0	\N	0	0	\N	\N	0	304704	0	8331-1	3006322		
87574	2706	4024958	1967-10-16	1967-10-16 00:00:00	1967-10-16	5001	0	\N	0	0	\N	\N	0	179252	0	117015009	4024958		
146456	4493	4024958	2004-07-11	2004-07-11 00:00:00	2004-07-11	5001	0	\N	0	0	\N	\N	0	299142	0	117015009	4024958		
43549	4026	3012494	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	267614	0	6206-7	3012494		
16916	1538	3006322	2009-09-26	2009-09-26 00:00:00	2009-09-26	5001	0	\N	0	0	\N	\N	0	102991	0	8331-1	3006322		
28328	2619	3006322	1986-12-02	1986-12-02 00:00:00	1986-12-02	5001	0	\N	0	0	\N	\N	0	173149	0	8331-1	3006322		
128740	3962	4024958	1969-08-03	1969-08-03 00:00:00	1969-08-03	5001	0	\N	0	0	\N	\N	0	263438	0	117015009	4024958		
8749	842	3011505	1984-03-31	1984-03-31 00:00:00	1984-03-31	5001	0	\N	0	0	\N	\N	0	55738	0	19926-5	3011505		
27036	2504	3009542	1981-10-19	1981-10-19 00:00:00	1981-10-19	5001	0	\N	0	0	\N	\N	0	165791	0	20570-8	3009542		
27138	2518	3011505	1997-06-20	1997-06-20 00:00:00	1997-06-20	5001	0	\N	0	0	\N	\N	0	166548	0	19926-5	3011505		
31558	2891	3012494	1975-04-27	1975-04-27 00:00:00	1975-04-27	5001	0	\N	0	0	\N	\N	0	192353	0	6206-7	3012494		
43198	3991	40758406	1957-04-24	1957-04-24 00:00:00	1957-04-24	5001	0	\N	0	0	\N	\N	0	265321	0	55277-8	40758406		
42970	3972	3006322	1997-01-16	1997-01-16 00:00:00	1997-01-16	5001	0	\N	0	0	\N	\N	0	264142	0	8331-1	3006322		
43094	3982	3006322	1964-03-15	1964-03-15 00:00:00	1964-03-15	5001	0	\N	0	0	\N	\N	0	264705	0	8331-1	3006322		
6155	578	3051031	2011-07-14	2011-07-14 00:00:00	2011-07-14	5001	0	\N	0	0	\N	\N	0	38199	0	46240-8	3051031		
51095	4662	3006906	1989-07-27	1989-07-27 00:00:00	1989-07-27	5001	0	\N	0	0	\N	\N	0	310773	0	17861-6	3006906		
1207	97	3011505	2013-07-29	2013-07-29 00:00:00	2013-07-29	5001	0	\N	0	0	\N	\N	0	6612	0	19926-5	3011505		
17666	1609	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	108191	0	6276-0	3027231		
34671	3176	3000876	2005-06-26	2005-06-26 00:00:00	2005-06-26	5001	0	\N	0	0	\N	\N	0	211098	0	6082-2	3000876		
51061	1550	4133840	2018-01-06	2018-01-06 00:00:00	2018-01-06	5001	0	\N	0	0	\N	\N	0	103782	0	127783003	4133840		
40505	3759	3014599	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	249969	0	6106-9	3014599		
53595	4924	3027231	1994-06-22	1994-06-22 00:00:00	1994-06-22	5001	0	\N	0	0	\N	\N	0	327174	0	6276-0	3027231		
17316	1574	46235214	1998-10-18	1998-10-18 00:00:00	1998-10-18	5001	0	\N	0	0	\N	\N	0	105717	0	76690-7	46235214		
57564	5285	40766240	1944-05-04	1944-05-04 00:00:00	1944-05-04	5001	0	\N	0	0	\N	\N	0	351642	0	63513-6	40766240		
52735	4844	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	322229	0	6082-2	3000876		
35018	3194	3006322	1957-02-27	1957-02-27 00:00:00	1957-02-27	5001	0	\N	0	0	\N	\N	0	212454	0	8331-1	3006322		
47664	4374	3001247	1979-06-16	1979-06-16 00:00:00	1979-06-16	5001	0	\N	0	0	\N	\N	0	290554	0	6085-5	3001247		
30839	2825	3006322	1938-10-15	1938-10-15 00:00:00	1938-10-15	5001	0	\N	0	0	\N	\N	0	187282	0	8331-1	3006322		
20893	1925	3006322	1997-12-15	1997-12-15 00:00:00	1997-12-15	5001	0	\N	0	0	\N	\N	0	128127	0	8331-1	3006322		
4077	406	3001247	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	26726	0	6085-5	3001247		
53138	1609	4052083	1992-11-03	1992-11-03 00:00:00	1992-11-03	5001	0	\N	0	0	\N	\N	0	108132	0	23426006	4052083		
9826	925	3011505	2009-05-15	2009-05-15 00:00:00	2009-05-15	5001	0	\N	0	0	\N	\N	0	61615	0	19926-5	3011505		
128983	3968	4024958	1923-11-24	1923-11-24 00:00:00	1923-11-24	5001	0	\N	0	0	\N	\N	0	263895	0	117015009	4024958		
122898	3788	4052083	1987-04-22	1987-04-22 00:00:00	1987-04-22	5001	0	\N	0	0	\N	\N	0	251858	0	23426006	4052083		
55771	1699	4024958	1969-10-18	1969-10-18 00:00:00	1969-10-18	5001	0	\N	0	0	\N	\N	0	113628	0	117015009	4024958		
34384	3133	46235214	2004-11-06	2004-11-06 00:00:00	2004-11-06	5001	0	\N	0	0	\N	\N	0	208458	0	76690-7	46235214		
6953	220	4052083	1984-11-21	1984-11-21 00:00:00	1984-11-21	5001	0	\N	0	0	\N	\N	0	14863	0	23426006	4052083		
44398	4101	3006322	1971-06-08	1971-06-08 00:00:00	1971-06-08	5001	0	\N	0	0	\N	\N	0	272510	0	8331-1	3006322		
40822	3786	3006322	1969-05-13	1969-05-13 00:00:00	1969-05-13	5001	0	\N	0	0	\N	\N	0	251698	0	8331-1	3006322		
7146	693	3006322	1966-04-01	1966-04-01 00:00:00	1966-04-01	5001	0	\N	0	0	\N	\N	0	45963	0	8331-1	3006322		
52292	4804	3006734	1978-01-28	1978-01-28 00:00:00	1978-01-28	5001	0	\N	0	0	\N	\N	0	319658	0	6189-5	3006734		
14076	1315	3006322	1965-10-08	1965-10-08 00:00:00	1965-10-08	5001	0	\N	0	0	\N	\N	0	87128	0	8331-1	3006322		
54728	1659	4052083	1971-06-07	1971-06-07 00:00:00	1971-06-07	5001	0	\N	0	0	\N	\N	0	111453	0	23426006	4052083		
30000	2765	3036780	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	182987	0	6095-4	3036780		
94285	2898	4052083	2000-08-02	2000-08-02 00:00:00	2000-08-02	5001	0	\N	0	0	\N	\N	0	192975	0	23426006	4052083		
41445	3859	40758406	1990-02-21	1990-02-21 00:00:00	1990-02-21	5001	0	\N	0	0	\N	\N	0	256274	0	55277-8	40758406		
14457	1352	3026361	1976-07-29	1976-07-29 00:00:00	1976-07-29	5001	0	\N	0	0	\N	\N	0	89606	0	26453-1	3026361		
48390	4439	3006322	2005-12-22	2005-12-22 00:00:00	2005-12-22	5001	0	\N	0	0	\N	\N	0	295103	0	8331-1	3006322		
16401	1496	3006322	1923-12-01	1923-12-01 00:00:00	1923-12-01	5001	0	\N	0	0	\N	\N	0	99724	0	8331-1	3006322		
128551	3957	4133840	2018-11-15	2018-11-15 00:00:00	2018-11-15	5001	0	\N	0	0	\N	\N	0	263106	0	127783003	4133840		
49448	4506	40758406	1956-02-22	1956-02-22 00:00:00	1956-02-22	5001	0	\N	0	0	\N	\N	0	300203	0	55277-8	40758406		
52461	4822	3011505	2018-06-20	2018-06-20 00:00:00	2018-06-20	5001	0	\N	0	0	\N	\N	0	320793	0	19926-5	3011505		
48775	4460	3006322	1985-02-08	1985-02-08 00:00:00	1985-02-08	5001	0	\N	0	0	\N	\N	0	296776	0	8331-1	3006322		
19637	1791	3006322	1971-04-08	1971-04-08 00:00:00	1971-04-08	5001	0	\N	0	0	\N	\N	0	120065	0	8331-1	3006322		
2694	263	3006322	1960-10-20	1960-10-20 00:00:00	1960-10-20	5001	0	\N	0	0	\N	\N	0	17443	0	8331-1	3006322		
93465	2876	4133840	2007-10-25	2007-10-25 00:00:00	2007-10-25	5001	0	\N	0	0	\N	\N	0	191374	0	127783003	4133840		
37693	3477	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	230651	0	6095-4	3036780		
16228	1478	3009542	1975-05-03	1975-05-03 00:00:00	1975-05-03	5001	0	\N	0	0	\N	\N	0	98639	0	20570-8	3009542		
71857	2199	4052083	2016-02-27	2016-02-27 00:00:00	2016-02-27	5001	0	\N	0	0	\N	\N	0	146591	0	23426006	4052083		
45634	4208	3006322	1962-04-03	1962-04-03 00:00:00	1962-04-03	5001	0	\N	0	0	\N	\N	0	279432	0	8331-1	3006322		
11830	1123	3006322	2002-10-03	2002-10-03 00:00:00	2002-10-03	5001	0	\N	0	0	\N	\N	0	74000	0	8331-1	3006322		
20459	1878	3006322	1992-01-14	1992-01-14 00:00:00	1992-01-14	5001	0	\N	0	0	\N	\N	0	125297	0	8331-1	3006322		
50157	4574	3006322	1958-12-02	1958-12-02 00:00:00	1958-12-02	5001	0	\N	0	0	\N	\N	0	304738	0	8331-1	3006322		
133573	4113	4052083	1972-02-04	1972-02-04 00:00:00	1972-02-04	5001	0	\N	0	0	\N	\N	0	273427	0	23426006	4052083		
146467	4493	4052083	1995-06-05	1995-06-05 00:00:00	1995-06-05	5001	0	\N	0	0	\N	\N	0	299154	0	23426006	4052083		
43550	4026	3036780	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	267614	0	6095-4	3036780		
16917	1538	3006322	1982-07-08	1982-07-08 00:00:00	1982-07-08	5001	0	\N	0	0	\N	\N	0	102974	0	8331-1	3006322		
28329	2619	46235214	1990-02-26	1990-02-26 00:00:00	1990-02-26	5001	0	\N	0	0	\N	\N	0	173164	0	76690-7	46235214		
150859	4625	4052083	2003-09-27	2003-09-27 00:00:00	2003-09-27	5001	0	\N	0	0	\N	\N	0	308116	0	23426006	4052083		
8750	842	3011505	2018-11-10	2018-11-10 00:00:00	2018-11-10	5001	0	\N	0	0	\N	\N	0	55705	0	19926-5	3011505		
27037	2504	3000963	1981-10-19	1981-10-19 00:00:00	1981-10-19	5001	0	\N	0	0	\N	\N	0	165791	0	718-7	3000963		
27139	2518	3011505	2008-09-05	2008-09-05 00:00:00	2008-09-05	5001	0	\N	0	0	\N	\N	0	166569	0	19926-5	3011505		
31559	2891	3001488	1975-04-27	1975-04-27 00:00:00	1975-04-27	5001	0	\N	0	0	\N	\N	0	192353	0	7258-7	3001488		
43200	3991	46235214	1957-04-24	1957-04-24 00:00:00	1957-04-24	5001	0	\N	0	0	\N	\N	0	265321	0	76690-7	46235214		
42971	3972	3006322	1964-07-30	1964-07-30 00:00:00	1964-07-30	5001	0	\N	0	0	\N	\N	0	264158	0	8331-1	3006322		
43095	3982	3006322	1950-04-13	1950-04-13 00:00:00	1950-04-13	5001	0	\N	0	0	\N	\N	0	264652	0	8331-1	3006322		
6157	578	40758406	2011-07-14	2011-07-14 00:00:00	2011-07-14	5001	0	\N	0	0	\N	\N	0	38199	0	55277-8	40758406		
51096	4662	3000963	1989-07-27	1989-07-27 00:00:00	1989-07-27	5001	0	\N	0	0	\N	\N	0	310773	0	718-7	3000963		
1208	97	3011505	2004-06-07	2004-06-07 00:00:00	2004-06-07	5001	0	\N	0	0	\N	\N	0	6602	0	19926-5	3011505		
17667	1609	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	108191	0	6158-0	3019406		
34672	3176	3014599	2005-06-26	2005-06-26 00:00:00	2005-06-26	5001	0	\N	0	0	\N	\N	0	211098	0	6106-9	3014599		
51063	1550	4133840	2013-12-28	2013-12-28 00:00:00	2013-12-28	5001	0	\N	0	0	\N	\N	0	103800	0	127783003	4133840		
40506	3759	3027231	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	249969	0	6276-0	3027231		
53596	4924	3006451	1994-06-22	1994-06-22 00:00:00	1994-06-22	5001	0	\N	0	0	\N	\N	0	327174	0	6273-7	3006451		
17318	1574	3051031	1998-10-18	1998-10-18 00:00:00	1998-10-18	5001	0	\N	0	0	\N	\N	0	105717	0	46240-8	3051031		
57565	5285	3051031	1944-05-04	1944-05-04 00:00:00	1944-05-04	5001	0	\N	0	0	\N	\N	0	351642	0	46240-8	3051031		
52736	4844	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	322229	0	6189-5	3006734		
35020	3195	3006322	1976-10-26	1976-10-26 00:00:00	1976-10-26	5001	0	\N	0	0	\N	\N	0	212512	0	8331-1	3006322		
47665	4374	3000876	1979-06-16	1979-06-16 00:00:00	1979-06-16	5001	0	\N	0	0	\N	\N	0	290554	0	6082-2	3000876		
30840	2825	3006322	2005-08-01	2005-08-01 00:00:00	2005-08-01	5001	0	\N	0	0	\N	\N	0	187286	0	8331-1	3006322		
20894	1925	3006322	2013-04-24	2013-04-24 00:00:00	2013-04-24	5001	0	\N	0	0	\N	\N	0	128135	0	8331-1	3006322		
4078	406	3023430	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	26726	0	6833-8	3023430		
64446	1977	4052083	1922-01-10	1922-01-10 00:00:00	1922-01-10	5001	0	\N	0	0	\N	\N	0	131505	0	23426006	4052083		
9827	925	3011505	2016-10-07	2016-10-07 00:00:00	2016-10-07	5001	0	\N	0	0	\N	\N	0	61635	0	19926-5	3011505		
49427	1506	4024958	1959-07-08	1959-07-08 00:00:00	1959-07-08	5001	0	\N	0	0	\N	\N	0	100411	0	117015009	4024958		
122902	3788	4024958	1997-11-24	1997-11-24 00:00:00	1997-11-24	5001	0	\N	0	0	\N	\N	0	251820	0	117015009	4024958		
55772	1699	4052083	1991-06-20	1991-06-20 00:00:00	1991-06-20	5001	0	\N	0	0	\N	\N	0	113647	0	23426006	4052083		
34385	3133	3051031	2004-11-06	2004-11-06 00:00:00	2004-11-06	5001	0	\N	0	0	\N	\N	0	208458	0	46240-8	3051031		
6954	220	4024958	1986-07-23	1986-07-23 00:00:00	1986-07-23	5001	0	\N	0	0	\N	\N	0	14808	0	117015009	4024958		
44399	4101	3006322	1984-04-01	1984-04-01 00:00:00	1984-04-01	5001	0	\N	0	0	\N	\N	0	272534	0	8331-1	3006322		
40823	3786	3006322	2017-08-02	2017-08-02 00:00:00	2017-08-02	5001	0	\N	0	0	\N	\N	0	251644	0	8331-1	3006322		
7147	693	3006322	2005-05-31	2005-05-31 00:00:00	2005-05-31	5001	0	\N	0	0	\N	\N	0	45901	0	8331-1	3006322		
52293	4804	3020655	1978-01-28	1978-01-28 00:00:00	1978-01-28	5001	0	\N	0	0	\N	\N	0	319658	0	6844-5	3020655		
14077	1316	3049273	2018-09-27	2018-09-27 00:00:00	2018-09-27	5001	0	\N	0	0	\N	\N	0	87224	0	38265-5	3049273		
54759	1659	4024958	1969-08-15	1969-08-15 00:00:00	1969-08-15	5001	0	\N	0	0	\N	\N	0	111578	0	117015009	4024958		
30001	2765	3006322	1963-11-28	1963-11-28 00:00:00	1963-11-28	5001	0	\N	0	0	\N	\N	0	182898	0	8331-1	3006322		
94309	2898	4052083	2017-04-02	2017-04-02 00:00:00	2017-04-02	5001	0	\N	0	0	\N	\N	0	193110	0	23426006	4052083		
41446	3859	3011505	2014-11-15	2014-11-15 00:00:00	2014-11-15	5001	0	\N	0	0	\N	\N	0	256280	0	19926-5	3011505		
14458	1352	3027970	1976-07-29	1976-07-29 00:00:00	1976-07-29	5001	0	\N	0	0	\N	\N	0	89606	0	10834-0	3027970		
48391	4439	3006322	1961-12-19	1961-12-19 00:00:00	1961-12-19	5001	0	\N	0	0	\N	\N	0	295121	0	8331-1	3006322		
16402	1496	3006322	1980-06-12	1980-06-12 00:00:00	1980-06-12	5001	0	\N	0	0	\N	\N	0	99733	0	8331-1	3006322		
128559	3957	4133840	2013-10-17	2013-10-17 00:00:00	2013-10-17	5001	0	\N	0	0	\N	\N	0	263062	0	127783003	4133840		
49450	4506	40766240	2014-08-11	2014-08-11 00:00:00	2014-08-11	5001	0	\N	0	0	\N	\N	0	300179	0	63513-6	40766240		
52462	4822	3051031	1948-10-23	1948-10-23 00:00:00	1948-10-23	5001	0	\N	0	0	\N	\N	0	320740	0	46240-8	3051031		
48776	4460	3049273	2003-07-19	2003-07-19 00:00:00	2003-07-19	5001	0	\N	0	0	\N	\N	0	296741	0	38265-5	3049273		
19638	1791	3006322	1965-01-11	1965-01-11 00:00:00	1965-01-11	5001	0	\N	0	0	\N	\N	0	120063	0	8331-1	3006322		
2695	263	3006322	1991-04-25	1991-04-25 00:00:00	1991-04-25	5001	0	\N	0	0	\N	\N	0	17437	0	8331-1	3006322		
93469	2876	4133840	1992-08-06	1992-08-06 00:00:00	1992-08-06	5001	0	\N	0	0	\N	\N	0	191373	0	127783003	4133840		
37694	3477	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	230651	0	6082-2	3000876		
16229	1478	3016723	1975-05-03	1975-05-03 00:00:00	1975-05-03	5001	0	\N	0	0	\N	\N	0	98639	0	2160-0	3016723		
71858	2199	4024958	1980-02-21	1980-02-21 00:00:00	1980-02-21	5001	0	\N	0	0	\N	\N	0	146543	0	117015009	4024958		
45635	4208	3006322	1943-08-01	1943-08-01 00:00:00	1943-08-01	5001	0	\N	0	0	\N	\N	0	279393	0	8331-1	3006322		
11831	1124	3006322	1965-03-19	1965-03-19 00:00:00	1965-03-19	5001	0	\N	0	0	\N	\N	0	74097	0	8331-1	3006322		
20460	1878	3006322	2013-07-12	2013-07-12 00:00:00	2013-07-12	5001	0	\N	0	0	\N	\N	0	125325	0	8331-1	3006322		
50158	4576	3006322	1991-11-28	1991-11-28 00:00:00	1991-11-28	5001	0	\N	0	0	\N	\N	0	304853	0	8331-1	3006322		
133578	4113	4052083	1978-05-25	1978-05-25 00:00:00	1978-05-25	5001	0	\N	0	0	\N	\N	0	273456	0	23426006	4052083		
123997	3825	4052083	1958-02-21	1958-02-21 00:00:00	1958-02-21	5001	0	\N	0	0	\N	\N	0	254058	0	23426006	4052083		
43551	4026	3011505	2013-02-10	2013-02-10 00:00:00	2013-02-10	5001	0	\N	0	0	\N	\N	0	267656	0	19926-5	3011505		
16918	1538	3006322	2004-07-09	2004-07-09 00:00:00	2004-07-09	5001	0	\N	0	0	\N	\N	0	102990	0	8331-1	3006322		
28331	2619	40758406	1990-02-26	1990-02-26 00:00:00	1990-02-26	5001	0	\N	0	0	\N	\N	0	173164	0	55277-8	40758406		
150861	4625	4024958	2017-05-31	2017-05-31 00:00:00	2017-05-31	5001	0	\N	0	0	\N	\N	0	308074	0	117015009	4024958		
8751	842	3011505	1980-01-05	1980-01-05 00:00:00	1980-01-05	5001	0	\N	0	0	\N	\N	0	55664	0	19926-5	3011505		
27038	2504	3006322	1957-12-06	1957-12-06 00:00:00	1957-12-06	5001	0	\N	0	0	\N	\N	0	165813	0	8331-1	3006322		
27140	2518	3011505	2006-08-25	2006-08-25 00:00:00	2006-08-25	5001	0	\N	0	0	\N	\N	0	166568	0	19926-5	3011505		
31560	2891	3036780	1975-04-27	1975-04-27 00:00:00	1975-04-27	5001	0	\N	0	0	\N	\N	0	192353	0	6095-4	3036780		
43202	3991	40758406	1977-11-15	1977-11-15 00:00:00	1977-11-15	5001	0	\N	0	0	\N	\N	0	265382	0	55277-8	40758406		
42972	3972	3006322	2013-06-14	2013-06-14 00:00:00	2013-06-14	5001	0	\N	0	0	\N	\N	0	264163	0	8331-1	3006322		
43096	3982	46235214	1966-01-28	1966-01-28 00:00:00	1966-01-28	5001	0	\N	0	0	\N	\N	0	264729	0	76690-7	46235214		
6159	578	40766240	2011-07-14	2011-07-14 00:00:00	2011-07-14	5001	0	\N	0	0	\N	\N	0	38199	0	63513-6	40766240		
51097	4662	3006322	1971-11-21	1971-11-21 00:00:00	1971-11-21	5001	0	\N	0	0	\N	\N	0	310730	0	8331-1	3006322		
1209	97	3011505	2014-08-04	2014-08-04 00:00:00	2014-08-04	5001	0	\N	0	0	\N	\N	0	6632	0	19926-5	3011505		
17668	1609	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	108191	0	6085-5	3001247		
544	30	3006322	1992-02-15	1992-02-15 00:00:00	1992-02-15	5001	0	\N	0	0	\N	\N	0	2103	0	8331-1	3006322		
51064	1550	4133840	1999-10-23	1999-10-23 00:00:00	1999-10-23	5001	0	\N	0	0	\N	\N	0	103787	0	127783003	4133840		
40507	3759	3012494	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	249969	0	6206-7	3012494		
53597	4924	3014599	1994-06-22	1994-06-22 00:00:00	1994-06-22	5001	0	\N	0	0	\N	\N	0	327174	0	6106-9	3014599		
17321	1574	40758406	1959-11-02	1959-11-02 00:00:00	1959-11-02	5001	0	\N	0	0	\N	\N	0	105630	0	55277-8	40758406		
57566	5285	46235214	1944-05-04	1944-05-04 00:00:00	1944-05-04	5001	0	\N	0	0	\N	\N	0	351642	0	76690-7	46235214		
52737	4844	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	322229	0	6246-3	3021226		
35021	3195	3006322	1959-04-01	1959-04-01 00:00:00	1959-04-01	5001	0	\N	0	0	\N	\N	0	212564	0	8331-1	3006322		
47666	4374	3027231	1979-06-16	1979-06-16 00:00:00	1979-06-16	5001	0	\N	0	0	\N	\N	0	290554	0	6276-0	3027231		
30841	2825	3006322	1960-07-02	1960-07-02 00:00:00	1960-07-02	5001	0	\N	0	0	\N	\N	0	187269	0	8331-1	3006322		
20895	1925	3006322	1990-05-03	1990-05-03 00:00:00	1990-05-03	5001	0	\N	0	0	\N	\N	0	128162	0	8331-1	3006322		
4079	406	3020655	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	26726	0	6844-5	3020655		
9828	925	3011505	2014-08-22	2014-08-22 00:00:00	2014-08-22	5001	0	\N	0	0	\N	\N	0	61583	0	19926-5	3011505		
49459	1508	4052083	1967-09-13	1967-09-13 00:00:00	1967-09-13	5001	0	\N	0	0	\N	\N	0	100649	0	23426006	4052083		
122910	3788	4024958	1985-08-29	1985-08-29 00:00:00	1985-08-29	5001	0	\N	0	0	\N	\N	0	251857	0	117015009	4024958		
153141	4696	4024958	1953-02-02	1953-02-02 00:00:00	1953-02-02	5001	0	\N	0	0	\N	\N	0	312820	0	117015009	4024958		
34387	3133	40766240	2005-06-04	2005-06-04 00:00:00	2005-06-04	5001	0	\N	0	0	\N	\N	0	208471	0	63513-6	40766240		
6964	220	4052083	1998-06-15	1998-06-15 00:00:00	1998-06-15	5001	0	\N	0	0	\N	\N	0	14814	0	23426006	4052083		
44400	4101	3006322	1978-05-17	1978-05-17 00:00:00	1978-05-17	5001	0	\N	0	0	\N	\N	0	272511	0	8331-1	3006322		
40824	3786	3006322	1985-06-06	1985-06-06 00:00:00	1985-06-06	5001	0	\N	0	0	\N	\N	0	251713	0	8331-1	3006322		
7148	693	3006322	1954-09-15	1954-09-15 00:00:00	1954-09-15	5001	0	\N	0	0	\N	\N	0	45961	0	8331-1	3006322		
52294	4804	3023430	1978-01-28	1978-01-28 00:00:00	1978-01-28	5001	0	\N	0	0	\N	\N	0	319658	0	6833-8	3023430		
14078	1316	3006322	1950-04-23	1950-04-23 00:00:00	1950-04-23	5001	0	\N	0	0	\N	\N	0	87226	0	8331-1	3006322		
54765	1659	4024958	1992-05-06	1992-05-06 00:00:00	1992-05-06	5001	0	\N	0	0	\N	\N	0	111566	0	117015009	4024958		
30002	2765	3011505	2005-10-25	2005-10-25 00:00:00	2005-10-25	5001	0	\N	0	0	\N	\N	0	182914	0	19926-5	3011505		
94330	2899	4052083	1960-08-29	1960-08-29 00:00:00	1960-08-29	5001	0	\N	0	0	\N	\N	0	193171	0	23426006	4052083		
41447	3859	3011505	2015-11-21	2015-11-21 00:00:00	2015-11-21	5001	0	\N	0	0	\N	\N	0	256247	0	19926-5	3011505		
14459	1352	3013721	1976-07-29	1976-07-29 00:00:00	1976-07-29	5001	0	\N	0	0	\N	\N	0	89606	0	1920-8	3013721		
48454	4442	3006322	1993-05-14	1993-05-14 00:00:00	1993-05-14	5001	0	\N	0	0	\N	\N	0	295286	0	8331-1	3006322		
16406	1496	3006322	1976-08-21	1976-08-21 00:00:00	1976-08-21	5001	0	\N	0	0	\N	\N	0	99697	0	8331-1	3006322		
128561	3957	4133840	2006-09-07	2006-09-07 00:00:00	2006-09-07	5001	0	\N	0	0	\N	\N	0	263080	0	127783003	4133840		
49451	4506	40758406	2014-08-11	2014-08-11 00:00:00	2014-08-11	5001	0	\N	0	0	\N	\N	0	300179	0	55277-8	40758406		
52463	4822	40758406	1948-10-23	1948-10-23 00:00:00	1948-10-23	5001	0	\N	0	0	\N	\N	0	320740	0	55277-8	40758406		
48777	4460	3006322	1951-12-08	1951-12-08 00:00:00	1951-12-08	5001	0	\N	0	0	\N	\N	0	296816	0	8331-1	3006322		
19639	1791	3006322	1955-08-24	1955-08-24 00:00:00	1955-08-24	5001	0	\N	0	0	\N	\N	0	120062	0	8331-1	3006322		
2697	264	3006322	1961-09-12	1961-09-12 00:00:00	1961-09-12	5001	0	\N	0	0	\N	\N	0	17510	0	8331-1	3006322		
93471	2876	4133840	2016-10-27	2016-10-27 00:00:00	2016-10-27	5001	0	\N	0	0	\N	\N	0	191385	0	127783003	4133840		
37695	3477	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	230651	0	6273-7	3006451		
16230	1478	3028833	1975-05-03	1975-05-03 00:00:00	1975-05-03	5001	0	\N	0	0	\N	\N	0	98639	0	42719-5	3028833		
71861	2199	4024958	1993-09-05	1993-09-05 00:00:00	1993-09-05	5001	0	\N	0	0	\N	\N	0	146569	0	117015009	4024958		
45637	4208	3049273	2013-10-04	2013-10-04 00:00:00	2013-10-04	5001	0	\N	0	0	\N	\N	0	279460	0	38265-5	3049273		
11832	1124	3006322	1950-08-20	1950-08-20 00:00:00	1950-08-20	5001	0	\N	0	0	\N	\N	0	74092	0	8331-1	3006322		
20461	1878	3006322	1987-09-13	1987-09-13 00:00:00	1987-09-13	5001	0	\N	0	0	\N	\N	0	125320	0	8331-1	3006322		
50159	4576	3006322	1986-01-12	1986-01-12 00:00:00	1986-01-12	5001	0	\N	0	0	\N	\N	0	304786	0	8331-1	3006322		
133597	4113	4024958	1984-05-05	1984-05-05 00:00:00	1984-05-05	5001	0	\N	0	0	\N	\N	0	273458	0	117015009	4024958		
124006	3825	4024958	1988-11-25	1988-11-25 00:00:00	1988-11-25	5001	0	\N	0	0	\N	\N	0	254081	0	117015009	4024958		
43552	4026	3011505	2014-02-16	2014-02-16 00:00:00	2014-02-16	5001	0	\N	0	0	\N	\N	0	267758	0	19926-5	3011505		
16919	1538	3006322	1937-06-28	1937-06-28 00:00:00	1937-06-28	5001	0	\N	0	0	\N	\N	0	102950	0	8331-1	3006322		
28332	2619	3051031	1990-02-26	1990-02-26 00:00:00	1990-02-26	5001	0	\N	0	0	\N	\N	0	173164	0	46240-8	3051031		
150870	4625	4024958	2015-12-28	2015-12-28 00:00:00	2015-12-28	5001	0	\N	0	0	\N	\N	0	308108	0	117015009	4024958		
8752	842	3006322	2004-01-28	2004-01-28 00:00:00	2004-01-28	5001	0	\N	0	0	\N	\N	0	55647	0	8331-1	3006322		
27060	2509	3006322	1983-10-26	1983-10-26 00:00:00	1983-10-26	5001	0	\N	0	0	\N	\N	0	166095	0	8331-1	3006322		
27141	2518	3011505	2017-01-27	2017-01-27 00:00:00	2017-01-27	5001	0	\N	0	0	\N	\N	0	166527	0	19926-5	3011505		
31561	2891	3021226	1975-04-27	1975-04-27 00:00:00	1975-04-27	5001	0	\N	0	0	\N	\N	0	192353	0	6246-3	3021226		
43203	3991	40766240	1977-11-15	1977-11-15 00:00:00	1977-11-15	5001	0	\N	0	0	\N	\N	0	265382	0	63513-6	40766240		
42973	3972	3006322	1979-07-09	1979-07-09 00:00:00	1979-07-09	5001	0	\N	0	0	\N	\N	0	264141	0	8331-1	3006322		
43098	3982	3051031	1966-01-28	1966-01-28 00:00:00	1966-01-28	5001	0	\N	0	0	\N	\N	0	264729	0	46240-8	3051031		
6160	578	46235214	2011-07-14	2011-07-14 00:00:00	2011-07-14	5001	0	\N	0	0	\N	\N	0	38199	0	76690-7	46235214		
51098	4662	3006322	2004-11-24	2004-11-24 00:00:00	2004-11-24	5001	0	\N	0	0	\N	\N	0	310775	0	8331-1	3006322		
1210	97	3011505	2007-06-25	2007-06-25 00:00:00	2007-06-25	5001	0	\N	0	0	\N	\N	0	6639	0	19926-5	3011505		
17669	1609	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	108191	0	6844-5	3020655		
545	30	40769184	1971-01-24	1971-01-24 00:00:00	1971-01-24	5001	0	\N	0	0	\N	\N	0	2060	0	66524-0	40769184		
51066	1550	4133840	2016-01-02	2016-01-02 00:00:00	2016-01-02	5001	0	\N	0	0	\N	\N	0	103790	0	127783003	4133840		
40508	3759	3001247	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	249969	0	6085-5	3001247		
53598	4924	3000876	1994-06-22	1994-06-22 00:00:00	1994-06-22	5001	0	\N	0	0	\N	\N	0	327174	0	6082-2	3000876		
17322	1574	3051031	1959-11-02	1959-11-02 00:00:00	1959-11-02	5001	0	\N	0	0	\N	\N	0	105630	0	46240-8	3051031		
57568	5285	3006322	1950-09-27	1950-09-27 00:00:00	1950-09-27	5001	0	\N	0	0	\N	\N	0	351710	0	8331-1	3006322		
52738	4844	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	322229	0	6158-0	3019406		
35022	3195	3006322	1962-03-30	1962-03-30 00:00:00	1962-03-30	5001	0	\N	0	0	\N	\N	0	212515	0	8331-1	3006322		
47667	4374	3020655	1979-06-16	1979-06-16 00:00:00	1979-06-16	5001	0	\N	0	0	\N	\N	0	290554	0	6844-5	3020655		
30842	2825	3006322	1999-07-19	1999-07-19 00:00:00	1999-07-19	5001	0	\N	0	0	\N	\N	0	187230	0	8331-1	3006322		
20896	1925	3006322	1991-01-11	1991-01-11 00:00:00	1991-01-11	5001	0	\N	0	0	\N	\N	0	128132	0	8331-1	3006322		
4080	406	3014599	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	26726	0	6106-9	3014599		
9829	925	3011505	2014-10-03	2014-10-03 00:00:00	2014-10-03	5001	0	\N	0	0	\N	\N	0	61605	0	19926-5	3011505		
49464	1508	4024958	1959-07-07	1959-07-07 00:00:00	1959-07-07	5001	0	\N	0	0	\N	\N	0	100641	0	117015009	4024958		
122916	3788	4024958	1979-01-19	1979-01-19 00:00:00	1979-01-19	5001	0	\N	0	0	\N	\N	0	251818	0	117015009	4024958		
153155	4696	4052083	1962-02-03	1962-02-03 00:00:00	1962-02-03	5001	0	\N	0	0	\N	\N	0	312823	0	23426006	4052083		
34388	3133	40758406	2005-06-04	2005-06-04 00:00:00	2005-06-04	5001	0	\N	0	0	\N	\N	0	208471	0	55277-8	40758406		
101446	3118	4133840	1996-12-29	1996-12-29 00:00:00	1996-12-29	5001	0	\N	0	0	\N	\N	0	207407	0	127783003	4133840		
44401	4101	3006322	1963-09-20	1963-09-20 00:00:00	1963-09-20	5001	0	\N	0	0	\N	\N	0	272507	0	8331-1	3006322		
40825	3786	3006322	1992-03-12	1992-03-12 00:00:00	1992-03-12	5001	0	\N	0	0	\N	\N	0	251715	0	8331-1	3006322		
7149	693	3006322	1992-10-25	1992-10-25 00:00:00	1992-10-25	5001	0	\N	0	0	\N	\N	0	45947	0	8331-1	3006322		
52295	4804	3036780	1993-09-27	1993-09-27 00:00:00	1993-09-27	5001	0	\N	0	0	\N	\N	0	319586	0	6095-4	3036780		
14079	1316	3006322	1963-09-29	1963-09-29 00:00:00	1963-09-29	5001	0	\N	0	0	\N	\N	0	87219	0	8331-1	3006322		
66056	2025	4052083	2012-10-26	2012-10-26 00:00:00	2012-10-26	5001	0	\N	0	0	\N	\N	0	134634	0	23426006	4052083		
30003	2765	3011505	2019-01-15	2019-01-15 00:00:00	2019-01-15	5001	0	\N	0	0	\N	\N	0	182883	0	19926-5	3011505		
106822	3293	4052083	1998-10-02	1998-10-02 00:00:00	1998-10-02	5001	0	\N	0	0	\N	\N	0	218735	0	23426006	4052083		
41448	3859	3011505	1988-09-17	1988-09-17 00:00:00	1988-09-17	5001	0	\N	0	0	\N	\N	0	256169	0	19926-5	3011505		
14460	1352	3010813	1976-07-29	1976-07-29 00:00:00	1976-07-29	5001	0	\N	0	0	\N	\N	0	89606	0	26464-8	3010813		
48455	4442	3006322	2007-02-22	2007-02-22 00:00:00	2007-02-22	5001	0	\N	0	0	\N	\N	0	295322	0	8331-1	3006322		
16407	1496	3006322	1952-08-04	1952-08-04 00:00:00	1952-08-04	5001	0	\N	0	0	\N	\N	0	99721	0	8331-1	3006322		
128563	3957	4133840	2005-01-06	2005-01-06 00:00:00	2005-01-06	5001	0	\N	0	0	\N	\N	0	263103	0	127783003	4133840		
49452	4506	46235214	2014-08-11	2014-08-11 00:00:00	2014-08-11	5001	0	\N	0	0	\N	\N	0	300179	0	76690-7	46235214		
52464	4822	46235214	1948-10-23	1948-10-23 00:00:00	1948-10-23	5001	0	\N	0	0	\N	\N	0	320740	0	76690-7	46235214		
48778	4460	3049273	2012-04-02	2012-04-02 00:00:00	2012-04-02	5001	0	\N	0	0	\N	\N	0	296797	0	38265-5	3049273		
19640	1791	3006322	2016-11-10	2016-11-10 00:00:00	2016-11-10	5001	0	\N	0	0	\N	\N	0	120025	0	8331-1	3006322		
2698	264	3006322	1969-06-18	1969-06-18 00:00:00	1969-06-18	5001	0	\N	0	0	\N	\N	0	17512	0	8331-1	3006322		
93472	2876	4133840	2015-10-22	2015-10-22 00:00:00	2015-10-22	5001	0	\N	0	0	\N	\N	0	191356	0	127783003	4133840		
37696	3477	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	230651	0	6246-3	3021226		
16231	1478	3024561	1975-05-03	1975-05-03 00:00:00	1975-05-03	5001	0	\N	0	0	\N	\N	0	98639	0	1751-7	3024561		
71862	2199	4024958	1996-01-02	1996-01-02 00:00:00	1996-01-02	5001	0	\N	0	0	\N	\N	0	146588	0	117015009	4024958		
45641	4210	3006322	1999-05-17	1999-05-17 00:00:00	1999-05-17	5001	0	\N	0	0	\N	\N	0	279521	0	8331-1	3006322		
11833	1125	3006322	2009-08-17	2009-08-17 00:00:00	2009-08-17	5001	0	\N	0	0	\N	\N	0	74151	0	8331-1	3006322		
20462	1878	3006322	2011-09-07	2011-09-07 00:00:00	2011-09-07	5001	0	\N	0	0	\N	\N	0	125311	0	8331-1	3006322		
50160	4576	3006322	2013-08-22	2013-08-22 00:00:00	2013-08-22	5001	0	\N	0	0	\N	\N	0	304789	0	8331-1	3006322		
133598	4113	4024958	1986-05-21	1986-05-21 00:00:00	1986-05-21	5001	0	\N	0	0	\N	\N	0	273459	0	117015009	4024958		
124019	3825	4052083	1992-06-06	1992-06-06 00:00:00	1992-06-06	5001	0	\N	0	0	\N	\N	0	254038	0	23426006	4052083		
43553	4026	3020655	1977-02-07	1977-02-07 00:00:00	1977-02-07	5001	0	\N	0	0	\N	\N	0	267662	0	6844-5	3020655		
16920	1538	3006322	1994-05-19	1994-05-19 00:00:00	1994-05-19	5001	0	\N	0	0	\N	\N	0	103038	0	8331-1	3006322		
28333	2619	40766240	1990-02-26	1990-02-26 00:00:00	1990-02-26	5001	0	\N	0	0	\N	\N	0	173164	0	63513-6	40766240		
150873	4625	4052083	1976-10-23	1976-10-23 00:00:00	1976-10-23	5001	0	\N	0	0	\N	\N	0	308092	0	23426006	4052083		
8753	842	3011505	2007-09-08	2007-09-08 00:00:00	2007-09-08	5001	0	\N	0	0	\N	\N	0	55689	0	19926-5	3011505		
27061	2509	3006322	1998-05-02	1998-05-02 00:00:00	1998-05-02	5001	0	\N	0	0	\N	\N	0	166068	0	8331-1	3006322		
27142	2518	3011505	2010-09-17	2010-09-17 00:00:00	2010-09-17	5001	0	\N	0	0	\N	\N	0	166570	0	19926-5	3011505		
31562	2891	3023430	1975-04-27	1975-04-27 00:00:00	1975-04-27	5001	0	\N	0	0	\N	\N	0	192353	0	6833-8	3023430		
43204	3991	3051031	1977-11-15	1977-11-15 00:00:00	1977-11-15	5001	0	\N	0	0	\N	\N	0	265382	0	46240-8	3051031		
42974	3972	3006322	1962-04-29	1962-04-29 00:00:00	1962-04-29	5001	0	\N	0	0	\N	\N	0	264157	0	8331-1	3006322		
43099	3982	40766240	1966-01-28	1966-01-28 00:00:00	1966-01-28	5001	0	\N	0	0	\N	\N	0	264729	0	63513-6	40766240		
6161	578	3006322	1996-10-07	1996-10-07 00:00:00	1996-10-07	5001	0	\N	0	0	\N	\N	0	38216	0	8331-1	3006322		
51099	4662	3006322	1953-08-23	1953-08-23 00:00:00	1953-08-23	5001	0	\N	0	0	\N	\N	0	310728	0	8331-1	3006322		
1212	97	3011505	2015-08-10	2015-08-10 00:00:00	2015-08-10	5001	0	\N	0	0	\N	\N	0	6613	0	19926-5	3011505		
17670	1609	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	108191	0	6246-3	3021226		
546	30	40769194	1971-01-24	1971-01-24 00:00:00	1971-01-24	5001	0	\N	0	0	\N	\N	0	2060	0	66534-9	40769194		
51070	1550	4133840	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	103788	0	127783003	4133840		
40509	3759	3036780	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	249969	0	6095-4	3036780		
53599	4924	3001247	1994-06-22	1994-06-22 00:00:00	1994-06-22	5001	0	\N	0	0	\N	\N	0	327174	0	6085-5	3001247		
17323	1574	40766240	1959-11-02	1959-11-02 00:00:00	1959-11-02	5001	0	\N	0	0	\N	\N	0	105630	0	63513-6	40766240		
57569	5285	3006322	1971-10-26	1971-10-26 00:00:00	1971-10-26	5001	0	\N	0	0	\N	\N	0	351624	0	8331-1	3006322		
52739	4844	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	322229	0	6075-6	3005136		
35023	3195	3006322	2018-06-08	2018-06-08 00:00:00	2018-06-08	5001	0	\N	0	0	\N	\N	0	212575	0	8331-1	3006322		
47668	4374	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	290564	0	7258-7	3001488		
30843	2825	3049273	1991-03-02	1991-03-02 00:00:00	1991-03-02	5001	0	\N	0	0	\N	\N	0	187332	0	38265-5	3049273		
20897	1925	3006322	2007-12-06	2007-12-06 00:00:00	2007-12-06	5001	0	\N	0	0	\N	\N	0	128163	0	8331-1	3006322		
4081	406	3027231	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	26726	0	6276-0	3027231		
9830	925	3011505	2013-05-24	2013-05-24 00:00:00	2013-05-24	5001	0	\N	0	0	\N	\N	0	61598	0	19926-5	3011505		
49468	1508	4024958	1972-07-08	1972-07-08 00:00:00	1972-07-08	5001	0	\N	0	0	\N	\N	0	100572	0	117015009	4024958		
122917	3788	4024958	2004-03-06	2004-03-06 00:00:00	2004-03-06	5001	0	\N	0	0	\N	\N	0	251859	0	117015009	4024958		
10466	334	4024958	1945-09-29	1945-09-29 00:00:00	1945-09-29	5001	0	\N	0	0	\N	\N	0	22143	0	117015009	4024958		
34390	3133	46235214	2005-06-04	2005-06-04 00:00:00	2005-06-04	5001	0	\N	0	0	\N	\N	0	208471	0	76690-7	46235214		
101447	3118	4133840	2000-12-17	2000-12-17 00:00:00	2000-12-17	5001	0	\N	0	0	\N	\N	0	207409	0	127783003	4133840		
44402	4101	3006322	2016-05-21	2016-05-21 00:00:00	2016-05-21	5001	0	\N	0	0	\N	\N	0	272526	0	8331-1	3006322		
40826	3786	3006322	1997-06-28	1997-06-28 00:00:00	1997-06-28	5001	0	\N	0	0	\N	\N	0	251700	0	8331-1	3006322		
18438	1690	3006322	1981-10-05	1981-10-05 00:00:00	1981-10-05	5001	0	\N	0	0	\N	\N	0	113208	0	8331-1	3006322		
52296	4804	3001247	1993-09-27	1993-09-27 00:00:00	1993-09-27	5001	0	\N	0	0	\N	\N	0	319586	0	6085-5	3001247		
14080	1316	3006322	2004-08-16	2004-08-16 00:00:00	2004-08-16	5001	0	\N	0	0	\N	\N	0	87229	0	8331-1	3006322		
41963	3881	3006322	1958-07-14	1958-07-14 00:00:00	1958-07-14	5001	0	\N	0	0	\N	\N	0	257943	0	8331-1	3006322		
30004	2765	3011505	2013-12-10	2013-12-10 00:00:00	2013-12-10	5001	0	\N	0	0	\N	\N	0	182826	0	19926-5	3011505		
106831	3293	4024958	1920-11-16	1920-11-16 00:00:00	1920-11-16	5001	0	\N	0	0	\N	\N	0	218703	0	117015009	4024958		
41449	3859	3011505	1997-08-09	1997-08-09 00:00:00	1997-08-09	5001	0	\N	0	0	\N	\N	0	256257	0	19926-5	3011505		
14461	1352	3024731	1976-07-29	1976-07-29 00:00:00	1976-07-29	5001	0	\N	0	0	\N	\N	0	89606	0	30428-7	3024731		
89012	2758	4024958	1975-08-19	1975-08-19 00:00:00	1975-08-19	5001	0	\N	0	0	\N	\N	0	182488	0	117015009	4024958		
16409	1496	3006322	1993-08-19	1993-08-19 00:00:00	1993-08-19	5001	0	\N	0	0	\N	\N	0	99649	0	8331-1	3006322		
128564	3957	4052083	1971-03-04	1971-03-04 00:00:00	1971-03-04	5001	0	\N	0	0	\N	\N	0	263099	0	23426006	4052083		
49454	4506	3051031	2014-08-11	2014-08-11 00:00:00	2014-08-11	5001	0	\N	0	0	\N	\N	0	300179	0	46240-8	3051031		
52467	4822	40766240	1948-10-23	1948-10-23 00:00:00	1948-10-23	5001	0	\N	0	0	\N	\N	0	320740	0	63513-6	40766240		
48779	4462	3006322	1967-09-01	1967-09-01 00:00:00	1967-09-01	5001	0	\N	0	0	\N	\N	0	296910	0	8331-1	3006322		
19641	1791	3006322	1966-02-19	1966-02-19 00:00:00	1966-02-19	5001	0	\N	0	0	\N	\N	0	120085	0	8331-1	3006322		
2699	264	3006322	1977-02-28	1977-02-28 00:00:00	1977-02-28	5001	0	\N	0	0	\N	\N	0	17593	0	8331-1	3006322		
93476	2876	4133840	2003-10-16	2003-10-16 00:00:00	2003-10-16	5001	0	\N	0	0	\N	\N	0	191352	0	127783003	4133840		
37697	3477	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	230651	0	6206-7	3012494		
16232	1478	3013721	1975-05-03	1975-05-03 00:00:00	1975-05-03	5001	0	\N	0	0	\N	\N	0	98639	0	1920-8	3013721		
71865	2199	4052083	1981-05-13	1981-05-13 00:00:00	1981-05-13	5001	0	\N	0	0	\N	\N	0	146544	0	23426006	4052083		
45642	4210	3006322	2002-06-16	2002-06-16 00:00:00	2002-06-16	5001	0	\N	0	0	\N	\N	0	279574	0	8331-1	3006322		
11834	1125	3049273	2014-07-30	2014-07-30 00:00:00	2014-07-30	5001	0	\N	0	0	\N	\N	0	74138	0	38265-5	3049273		
20463	1878	3006322	1990-03-12	1990-03-12 00:00:00	1990-03-12	5001	0	\N	0	0	\N	\N	0	125321	0	8331-1	3006322		
50161	4576	3006322	1970-03-21	1970-03-21 00:00:00	1970-03-21	5001	0	\N	0	0	\N	\N	0	304800	0	8331-1	3006322		
133599	4113	4024958	1985-02-11	1985-02-11 00:00:00	1985-02-11	5001	0	\N	0	0	\N	\N	0	273421	0	117015009	4024958		
124040	3827	4024958	1987-04-17	1987-04-17 00:00:00	1987-04-17	5001	0	\N	0	0	\N	\N	0	254175	0	117015009	4024958		
43554	4026	3023430	1977-02-07	1977-02-07 00:00:00	1977-02-07	5001	0	\N	0	0	\N	\N	0	267662	0	6833-8	3023430		
16921	1538	3006322	1950-12-03	1950-12-03 00:00:00	1950-12-03	5001	0	\N	0	0	\N	\N	0	103054	0	8331-1	3006322		
28335	2619	3006322	2008-05-04	2008-05-04 00:00:00	2008-05-04	5001	0	\N	0	0	\N	\N	0	173152	0	8331-1	3006322		
150895	4626	4052083	2017-11-16	2017-11-16 00:00:00	2017-11-16	5001	0	\N	0	0	\N	\N	0	308170	0	23426006	4052083		
8754	842	3011505	1975-12-13	1975-12-13 00:00:00	1975-12-13	5001	0	\N	0	0	\N	\N	0	55747	0	19926-5	3011505		
27062	2509	3006322	1984-03-03	1984-03-03 00:00:00	1984-03-03	5001	0	\N	0	0	\N	\N	0	166096	0	8331-1	3006322		
27143	2518	3006322	1993-12-21	1993-12-21 00:00:00	1993-12-21	5001	0	\N	0	0	\N	\N	0	166506	0	8331-1	3006322		
31563	2891	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	192356	0	6833-8	3023430		
43206	3991	46235214	1977-11-15	1977-11-15 00:00:00	1977-11-15	5001	0	\N	0	0	\N	\N	0	265382	0	76690-7	46235214		
42975	3972	3006322	2012-12-05	2012-12-05 00:00:00	2012-12-05	5001	0	\N	0	0	\N	\N	0	264096	0	8331-1	3006322		
22377	2053	3051031	1964-01-26	1964-01-26 00:00:00	1964-01-26	5001	0	\N	0	0	\N	\N	0	136557	0	46240-8	3051031		
6162	578	3051031	2010-06-19	2010-06-19 00:00:00	2010-06-19	5001	0	\N	0	0	\N	\N	0	38217	0	46240-8	3051031		
51104	4665	3006322	1986-12-03	1986-12-03 00:00:00	1986-12-03	5001	0	\N	0	0	\N	\N	0	310899	0	8331-1	3006322		
1213	97	3011505	2006-06-19	2006-06-19 00:00:00	2006-06-19	5001	0	\N	0	0	\N	\N	0	6603	0	19926-5	3011505		
17671	1609	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	108191	0	6106-9	3014599		
547	30	40769179	1971-01-24	1971-01-24 00:00:00	1971-01-24	5001	0	\N	0	0	\N	\N	0	2060	0	66519-0	40769179		
51071	1550	4133840	1996-10-19	1996-10-19 00:00:00	1996-10-19	5001	0	\N	0	0	\N	\N	0	103786	0	127783003	4133840		
40510	3761	3006322	1959-11-14	1959-11-14 00:00:00	1959-11-14	5001	0	\N	0	0	\N	\N	0	250065	0	8331-1	3006322		
53600	4924	3006322	2000-09-24	2000-09-24 00:00:00	2000-09-24	5001	0	\N	0	0	\N	\N	0	327200	0	8331-1	3006322		
17325	1574	46235214	1959-11-02	1959-11-02 00:00:00	1959-11-02	5001	0	\N	0	0	\N	\N	0	105630	0	76690-7	46235214		
57570	5285	3006322	2015-05-13	2015-05-13 00:00:00	2015-05-13	5001	0	\N	0	0	\N	\N	0	351703	0	8331-1	3006322		
52740	4844	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	322229	0	6276-0	3027231		
35024	3195	3006322	2007-01-24	2007-01-24 00:00:00	2007-01-24	5001	0	\N	0	0	\N	\N	0	212544	0	8331-1	3006322		
47669	4374	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	290564	0	6189-5	3006734		
30845	2827	3006322	1926-10-16	1926-10-16 00:00:00	1926-10-16	5001	0	\N	0	0	\N	\N	0	187516	0	8331-1	3006322		
20898	1925	3006322	1985-12-11	1985-12-11 00:00:00	1985-12-11	5001	0	\N	0	0	\N	\N	0	128126	0	8331-1	3006322		
4082	406	3036780	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	26726	0	6095-4	3036780		
9831	925	3011505	2018-10-12	2018-10-12 00:00:00	2018-10-12	5001	0	\N	0	0	\N	\N	0	61616	0	19926-5	3011505		
49477	1508	4024958	1949-10-13	1949-10-13 00:00:00	1949-10-13	5001	0	\N	0	0	\N	\N	0	100648	0	117015009	4024958		
122933	3789	4052083	1974-11-30	1974-11-30 00:00:00	1974-11-30	5001	0	\N	0	0	\N	\N	0	251871	0	23426006	4052083		
10474	334	4052083	1963-11-22	1963-11-22 00:00:00	1963-11-22	5001	0	\N	0	0	\N	\N	0	22122	0	23426006	4052083		
34391	3133	3051031	2005-06-04	2005-06-04 00:00:00	2005-06-04	5001	0	\N	0	0	\N	\N	0	208471	0	46240-8	3051031		
101451	3118	4133840	1992-12-20	1992-12-20 00:00:00	1992-12-20	5001	0	\N	0	0	\N	\N	0	207452	0	127783003	4133840		
44403	4101	3006322	2008-08-16	2008-08-16 00:00:00	2008-08-16	5001	0	\N	0	0	\N	\N	0	272535	0	8331-1	3006322		
40827	3786	3006322	1961-10-27	1961-10-27 00:00:00	1961-10-27	5001	0	\N	0	0	\N	\N	0	251667	0	8331-1	3006322		
18440	1691	3006322	1972-05-16	1972-05-16 00:00:00	1972-05-16	5001	0	\N	0	0	\N	\N	0	113260	0	8331-1	3006322		
52297	4804	3021226	1993-09-27	1993-09-27 00:00:00	1993-09-27	5001	0	\N	0	0	\N	\N	0	319586	0	6246-3	3021226		
14081	1316	3006322	2009-12-10	2009-12-10 00:00:00	2009-12-10	5001	0	\N	0	0	\N	\N	0	87182	0	8331-1	3006322		
41964	3881	3006322	1982-06-02	1982-06-02 00:00:00	1982-06-02	5001	0	\N	0	0	\N	\N	0	257945	0	8331-1	3006322		
30005	2765	3011505	2007-11-06	2007-11-06 00:00:00	2007-11-06	5001	0	\N	0	0	\N	\N	0	182915	0	19926-5	3011505		
106837	3293	4052083	1960-12-12	1960-12-12 00:00:00	1960-12-12	5001	0	\N	0	0	\N	\N	0	218679	0	23426006	4052083		
41450	3859	3006322	2009-02-05	2009-02-05 00:00:00	2009-02-05	5001	0	\N	0	0	\N	\N	0	256277	0	8331-1	3006322		
14462	1352	3006923	1976-07-29	1976-07-29 00:00:00	1976-07-29	5001	0	\N	0	0	\N	\N	0	89606	0	1742-6	3006923		
64196	1973	4024958	1981-05-18	1981-05-18 00:00:00	1981-05-18	5001	0	\N	0	0	\N	\N	0	131145	0	117015009	4024958		
16410	1496	3049273	1979-08-29	1979-08-29 00:00:00	1979-08-29	5001	0	\N	0	0	\N	\N	0	99741	0	38265-5	3049273		
128567	3957	4133840	2016-11-03	2016-11-03 00:00:00	2016-11-03	5001	0	\N	0	0	\N	\N	0	263105	0	127783003	4133840		
49455	4506	40766240	1983-12-12	1983-12-12 00:00:00	1983-12-12	5001	0	\N	0	0	\N	\N	0	300225	0	63513-6	40766240		
52468	4822	3000963	1993-09-12	1993-09-12 00:00:00	1993-09-12	5001	0	\N	0	0	\N	\N	0	320747	0	718-7	3000963		
48780	4462	3011505	2010-03-04	2010-03-04 00:00:00	2010-03-04	5001	0	\N	0	0	\N	\N	0	296881	0	19926-5	3011505		
19642	1791	3006322	2011-03-30	2011-03-30 00:00:00	2011-03-30	5001	0	\N	0	0	\N	\N	0	120069	0	8331-1	3006322		
2700	264	3006322	1970-09-22	1970-09-22 00:00:00	1970-09-22	5001	0	\N	0	0	\N	\N	0	17539	0	8331-1	3006322		
93477	2876	4024958	2017-12-12	2017-12-12 00:00:00	2017-12-12	5001	0	\N	0	0	\N	\N	0	191364	0	117015009	4024958		
37698	3477	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	230651	0	6106-9	3014599		
16233	1478	3027970	1975-05-03	1975-05-03 00:00:00	1975-05-03	5001	0	\N	0	0	\N	\N	0	98639	0	10834-0	3027970		
60777	1852	4024958	2011-01-24	2011-01-24 00:00:00	2011-01-24	5001	0	\N	0	0	\N	\N	0	123877	0	117015009	4024958		
45643	4210	3006322	2012-02-10	2012-02-10 00:00:00	2012-02-10	5001	0	\N	0	0	\N	\N	0	279524	0	8331-1	3006322		
11840	1128	3006322	1993-03-04	1993-03-04 00:00:00	1993-03-04	5001	0	\N	0	0	\N	\N	0	74331	0	8331-1	3006322		
20464	1879	3006322	1995-12-17	1995-12-17 00:00:00	1995-12-17	5001	0	\N	0	0	\N	\N	0	125394	0	8331-1	3006322		
50162	4576	3006322	2011-09-23	2011-09-23 00:00:00	2011-09-23	5001	0	\N	0	0	\N	\N	0	304855	0	8331-1	3006322		
133600	4113	4052083	2007-01-01	2007-01-01 00:00:00	2007-01-01	5001	0	\N	0	0	\N	\N	0	273397	0	23426006	4052083		
66933	2054	4024958	1979-10-13	1979-10-13 00:00:00	1979-10-13	5001	0	\N	0	0	\N	\N	0	136585	0	117015009	4024958		
43555	4026	3005136	1977-02-07	1977-02-07 00:00:00	1977-02-07	5001	0	\N	0	0	\N	\N	0	267662	0	6075-6	3005136		
16922	1538	3023430	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	103037	0	6833-8	3023430		
28336	2619	3006322	1948-05-08	1948-05-08 00:00:00	1948-05-08	5001	0	\N	0	0	\N	\N	0	173204	0	8331-1	3006322		
162191	4976	4024958	1956-09-17	1956-09-17 00:00:00	1956-09-17	5001	0	\N	0	0	\N	\N	0	330968	0	117015009	4024958		
8755	842	3011505	1969-11-08	1969-11-08 00:00:00	1969-11-08	5001	0	\N	0	0	\N	\N	0	55733	0	19926-5	3011505		
27063	2509	3049273	1975-11-04	1975-11-04 00:00:00	1975-11-04	5001	0	\N	0	0	\N	\N	0	166089	0	38265-5	3049273		
27144	2518	3011505	2004-08-13	2004-08-13 00:00:00	2004-08-13	5001	0	\N	0	0	\N	\N	0	166574	0	19926-5	3011505		
31564	2891	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	192356	0	6158-0	3019406		
43207	3991	40766240	1957-06-23	1957-06-23 00:00:00	1957-06-23	5001	0	\N	0	0	\N	\N	0	265339	0	63513-6	40766240		
42976	3972	3006322	1974-05-25	1974-05-25 00:00:00	1974-05-25	5001	0	\N	0	0	\N	\N	0	264162	0	8331-1	3006322		
22379	2053	40758406	1964-01-26	1964-01-26 00:00:00	1964-01-26	5001	0	\N	0	0	\N	\N	0	136557	0	55277-8	40758406		
6164	578	40758406	2010-06-19	2010-06-19 00:00:00	2010-06-19	5001	0	\N	0	0	\N	\N	0	38217	0	55277-8	40758406		
51105	4665	3006322	1988-09-07	1988-09-07 00:00:00	1988-09-07	5001	0	\N	0	0	\N	\N	0	310874	0	8331-1	3006322		
1214	97	3011505	1997-08-11	1997-08-11 00:00:00	1997-08-11	5001	0	\N	0	0	\N	\N	0	6636	0	19926-5	3011505		
17672	1609	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	108191	0	6082-2	3000876		
548	30	40769189	1971-01-24	1971-01-24 00:00:00	1971-01-24	5001	0	\N	0	0	\N	\N	0	2060	0	66529-9	40769189		
51072	1550	4133840	2007-05-26	2007-05-26 00:00:00	2007-05-26	5001	0	\N	0	0	\N	\N	0	103780	0	127783003	4133840		
40511	3761	3006322	1960-12-09	1960-12-09 00:00:00	1960-12-09	5001	0	\N	0	0	\N	\N	0	250095	0	8331-1	3006322		
53601	4924	3006322	2002-02-09	2002-02-09 00:00:00	2002-02-09	5001	0	\N	0	0	\N	\N	0	327176	0	8331-1	3006322		
17326	1574	3051031	1986-03-25	1986-03-25 00:00:00	1986-03-25	5001	0	\N	0	0	\N	\N	0	105715	0	46240-8	3051031		
57572	5285	3051031	1944-03-05	1944-03-05 00:00:00	1944-03-05	5001	0	\N	0	0	\N	\N	0	351708	0	46240-8	3051031		
52741	4844	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	322229	0	6095-4	3036780		
35025	3195	3049273	2006-11-23	2006-11-23 00:00:00	2006-11-23	5001	0	\N	0	0	\N	\N	0	212593	0	38265-5	3049273		
47670	4374	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	290564	0	6833-8	3023430		
30846	2827	3006322	1923-01-21	1923-01-21 00:00:00	1923-01-21	5001	0	\N	0	0	\N	\N	0	187440	0	8331-1	3006322		
20899	1925	3006322	1966-01-01	1966-01-01 00:00:00	1966-01-01	5001	0	\N	0	0	\N	\N	0	128124	0	8331-1	3006322		
4083	406	3001488	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	26726	0	7258-7	3001488		
9832	925	3011505	2011-05-20	2011-05-20 00:00:00	2011-05-20	5001	0	\N	0	0	\N	\N	0	61597	0	19926-5	3011505		
27006	2503	3006451	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	165689	0	6273-7	3006451		
122934	3789	4024958	1953-08-12	1953-08-12 00:00:00	1953-08-12	5001	0	\N	0	0	\N	\N	0	251934	0	117015009	4024958		
10477	334	4052083	1992-03-25	1992-03-25 00:00:00	1992-03-25	5001	0	\N	0	0	\N	\N	0	22131	0	23426006	4052083		
34392	3133	3051031	2004-04-10	2004-04-10 00:00:00	2004-04-10	5001	0	\N	0	0	\N	\N	0	208523	0	46240-8	3051031		
101452	3118	4133840	1986-06-08	1986-06-08 00:00:00	1986-06-08	5001	0	\N	0	0	\N	\N	0	207509	0	127783003	4133840		
44404	4101	3006322	1988-01-23	1988-01-23 00:00:00	1988-01-23	5001	0	\N	0	0	\N	\N	0	272512	0	8331-1	3006322		
40828	3786	3006322	2013-05-01	2013-05-01 00:00:00	2013-05-01	5001	0	\N	0	0	\N	\N	0	251717	0	8331-1	3006322		
18441	1691	3006322	1951-01-11	1951-01-11 00:00:00	1951-01-11	5001	0	\N	0	0	\N	\N	0	113255	0	8331-1	3006322		
52298	4804	3006451	1993-09-27	1993-09-27 00:00:00	1993-09-27	5001	0	\N	0	0	\N	\N	0	319586	0	6273-7	3006451		
14082	1316	3006322	2006-04-21	2006-04-21 00:00:00	2006-04-21	5001	0	\N	0	0	\N	\N	0	87141	0	8331-1	3006322		
41965	3881	3006322	2011-07-11	2011-07-11 00:00:00	2011-07-11	5001	0	\N	0	0	\N	\N	0	257916	0	8331-1	3006322		
30006	2765	3006322	2013-08-17	2013-08-17 00:00:00	2013-08-17	5001	0	\N	0	0	\N	\N	0	182846	0	8331-1	3006322		
106842	3293	4052083	1912-08-14	1912-08-14 00:00:00	1912-08-14	5001	0	\N	0	0	\N	\N	0	218744	0	23426006	4052083		
41451	3860	3006322	2013-09-16	2013-09-16 00:00:00	2013-09-16	5001	0	\N	0	0	\N	\N	0	256322	0	8331-1	3006322		
14463	1352	3004501	1976-07-29	1976-07-29 00:00:00	1976-07-29	5001	0	\N	0	0	\N	\N	0	89606	0	2345-7	3004501		
64203	1973	4052083	1985-08-24	1985-08-24 00:00:00	1985-08-24	5001	0	\N	0	0	\N	\N	0	131151	0	23426006	4052083		
16411	1496	3006322	1948-08-17	1948-08-17 00:00:00	1948-08-17	5001	0	\N	0	0	\N	\N	0	99726	0	8331-1	3006322		
128569	3957	4133840	2014-10-23	2014-10-23 00:00:00	2014-10-23	5001	0	\N	0	0	\N	\N	0	263060	0	127783003	4133840		
49457	4506	3051031	1983-12-12	1983-12-12 00:00:00	1983-12-12	5001	0	\N	0	0	\N	\N	0	300225	0	46240-8	3051031		
52469	4822	3009542	1993-09-12	1993-09-12 00:00:00	1993-09-12	5001	0	\N	0	0	\N	\N	0	320747	0	20570-8	3009542		
48781	4462	3006322	1993-03-11	1993-03-11 00:00:00	1993-03-11	5001	0	\N	0	0	\N	\N	0	296942	0	8331-1	3006322		
19643	1791	3006322	1986-03-29	1986-03-29 00:00:00	1986-03-29	5001	0	\N	0	0	\N	\N	0	120066	0	8331-1	3006322		
2701	264	3006322	1955-12-04	1955-12-04 00:00:00	1955-12-04	5001	0	\N	0	0	\N	\N	0	17551	0	8331-1	3006322		
93478	2876	4133840	2012-06-21	2012-06-21 00:00:00	2012-06-21	5001	0	\N	0	0	\N	\N	0	191390	0	127783003	4133840		
37699	3477	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	230651	0	6276-0	3027231		
16234	1478	3006322	2005-10-18	2005-10-18 00:00:00	2005-10-18	5001	0	\N	0	0	\N	\N	0	98655	0	8331-1	3006322		
60793	1852	4024958	1976-07-22	1976-07-22 00:00:00	1976-07-22	5001	0	\N	0	0	\N	\N	0	123950	0	117015009	4024958		
45644	4210	3006322	1978-10-17	1978-10-17 00:00:00	1978-10-17	5001	0	\N	0	0	\N	\N	0	279519	0	8331-1	3006322		
11841	1128	3006322	2002-11-26	2002-11-26 00:00:00	2002-11-26	5001	0	\N	0	0	\N	\N	0	74332	0	8331-1	3006322		
20465	1879	3006322	1967-10-31	1967-10-31 00:00:00	1967-10-31	5001	0	\N	0	0	\N	\N	0	125434	0	8331-1	3006322		
50163	4576	3006322	2014-08-30	2014-08-30 00:00:00	2014-08-30	5001	0	\N	0	0	\N	\N	0	304790	0	8331-1	3006322		
110833	3423	4052083	1992-04-16	1992-04-16 00:00:00	1992-04-16	5001	0	\N	0	0	\N	\N	0	227064	0	23426006	4052083		
155818	4784	4052083	1971-01-15	1971-01-15 00:00:00	1971-01-15	5001	0	\N	0	0	\N	\N	0	318494	0	23426006	4052083		
68207	2087	4052083	1938-04-16	1938-04-16 00:00:00	1938-04-16	5001	0	\N	0	0	\N	\N	0	139027	0	23426006	4052083		
16923	1538	3020655	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	103037	0	6844-5	3020655		
28337	2619	40758406	1940-01-10	1940-01-10 00:00:00	1940-01-10	5001	0	\N	0	0	\N	\N	0	173138	0	55277-8	40758406		
34689	1083	4052083	1987-10-28	1987-10-28 00:00:00	1987-10-28	5001	0	\N	0	0	\N	\N	0	71088	0	23426006	4052083		
8756	842	3011505	1971-11-20	1971-11-20 00:00:00	1971-11-20	5001	0	\N	0	0	\N	\N	0	55745	0	19926-5	3011505		
27064	2509	3006322	2010-11-20	2010-11-20 00:00:00	2010-11-20	5001	0	\N	0	0	\N	\N	0	166069	0	8331-1	3006322		
27145	2518	3011505	2018-02-02	2018-02-02 00:00:00	2018-02-02	5001	0	\N	0	0	\N	\N	0	166594	0	19926-5	3011505		
31565	2891	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	192356	0	6276-0	3027231		
43208	3991	3051031	1957-06-23	1957-06-23 00:00:00	1957-06-23	5001	0	\N	0	0	\N	\N	0	265339	0	46240-8	3051031		
42977	3973	3006322	1991-10-07	1991-10-07 00:00:00	1991-10-07	5001	0	\N	0	0	\N	\N	0	264179	0	8331-1	3006322		
22380	2053	46235214	1964-01-26	1964-01-26 00:00:00	1964-01-26	5001	0	\N	0	0	\N	\N	0	136557	0	76690-7	46235214		
6166	578	40766240	2010-06-19	2010-06-19 00:00:00	2010-06-19	5001	0	\N	0	0	\N	\N	0	38217	0	63513-6	40766240		
51106	4665	3006322	2018-03-30	2018-03-30 00:00:00	2018-03-30	5001	0	\N	0	0	\N	\N	0	310903	0	8331-1	3006322		
1215	97	3011505	2011-07-18	2011-07-18 00:00:00	2011-07-18	5001	0	\N	0	0	\N	\N	0	6611	0	19926-5	3011505		
17673	1609	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	108191	0	6833-8	3023430		
549	30	3006322	2017-03-11	2017-03-11 00:00:00	2017-03-11	5001	0	\N	0	0	\N	\N	0	2133	0	8331-1	3006322		
51073	1550	4052083	2007-12-03	2007-12-03 00:00:00	2007-12-03	5001	0	\N	0	0	\N	\N	0	103751	0	23426006	4052083		
40512	3761	3006322	1960-09-27	1960-09-27 00:00:00	1960-09-27	5001	0	\N	0	0	\N	\N	0	250066	0	8331-1	3006322		
53602	4924	3006322	1980-03-07	1980-03-07 00:00:00	1980-03-07	5001	0	\N	0	0	\N	\N	0	327149	0	8331-1	3006322		
17327	1574	40766240	1986-03-25	1986-03-25 00:00:00	1986-03-25	5001	0	\N	0	0	\N	\N	0	105715	0	63513-6	40766240		
57573	5285	40758406	1944-03-05	1944-03-05 00:00:00	1944-03-05	5001	0	\N	0	0	\N	\N	0	351708	0	55277-8	40758406		
52742	4844	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	322229	0	6106-9	3014599		
35026	3195	3006322	2002-12-03	2002-12-03 00:00:00	2002-12-03	5001	0	\N	0	0	\N	\N	0	212566	0	8331-1	3006322		
47671	4374	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	290564	0	6273-7	3006451		
30847	2827	3006322	1953-10-10	1953-10-10 00:00:00	1953-10-10	5001	0	\N	0	0	\N	\N	0	187444	0	8331-1	3006322		
20900	1925	3006322	1966-02-13	1966-02-13 00:00:00	1966-02-13	5001	0	\N	0	0	\N	\N	0	128118	0	8331-1	3006322		
4084	406	3019406	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	26726	0	6158-0	3019406		
21124	1954	40758406	1967-08-20	1967-08-20 00:00:00	1967-08-20	5001	0	\N	0	0	\N	\N	0	130011	0	55277-8	40758406		
27007	2503	3005136	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	165689	0	6075-6	3005136		
122936	3789	4052083	1949-05-24	1949-05-24 00:00:00	1949-05-24	5001	0	\N	0	0	\N	\N	0	251922	0	23426006	4052083		
10478	334	4024958	1958-08-02	1958-08-02 00:00:00	1958-08-02	5001	0	\N	0	0	\N	\N	0	22121	0	117015009	4024958		
34393	3133	40758406	2004-04-10	2004-04-10 00:00:00	2004-04-10	5001	0	\N	0	0	\N	\N	0	208523	0	55277-8	40758406		
101458	3118	4133840	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	207454	0	127783003	4133840		
44405	4101	3006322	1961-08-21	1961-08-21 00:00:00	1961-08-21	5001	0	\N	0	0	\N	\N	0	272473	0	8331-1	3006322		
40829	3786	3006322	2011-03-29	2011-03-29 00:00:00	2011-03-29	5001	0	\N	0	0	\N	\N	0	251702	0	8331-1	3006322		
18442	1691	3006322	1977-07-31	1977-07-31 00:00:00	1977-07-31	5001	0	\N	0	0	\N	\N	0	113224	0	8331-1	3006322		
52299	4804	3012494	1993-09-27	1993-09-27 00:00:00	1993-09-27	5001	0	\N	0	0	\N	\N	0	319586	0	6206-7	3012494		
14083	1316	3006322	1989-06-25	1989-06-25 00:00:00	1989-06-25	5001	0	\N	0	0	\N	\N	0	87155	0	8331-1	3006322		
41966	3881	3006322	1994-01-15	1994-01-15 00:00:00	1994-01-15	5001	0	\N	0	0	\N	\N	0	257946	0	8331-1	3006322		
30007	2765	3006322	1966-08-23	1966-08-23 00:00:00	1966-08-23	5001	0	\N	0	0	\N	\N	0	182899	0	8331-1	3006322		
106853	3293	4024958	1927-11-23	1927-11-23 00:00:00	1927-11-23	5001	0	\N	0	0	\N	\N	0	218705	0	117015009	4024958		
41452	3860	3006322	1993-10-11	1993-10-11 00:00:00	1993-10-11	5001	0	\N	0	0	\N	\N	0	256330	0	8331-1	3006322		
14464	1352	3009542	1976-07-29	1976-07-29 00:00:00	1976-07-29	5001	0	\N	0	0	\N	\N	0	89606	0	20570-8	3009542		
64211	1973	4052083	1995-09-22	1995-09-22 00:00:00	1995-09-22	5001	0	\N	0	0	\N	\N	0	131162	0	23426006	4052083		
16412	1496	3006322	1933-10-07	1933-10-07 00:00:00	1933-10-07	5001	0	\N	0	0	\N	\N	0	99720	0	8331-1	3006322		
128576	3957	4133840	1996-12-19	1996-12-19 00:00:00	1996-12-19	5001	0	\N	0	0	\N	\N	0	263068	0	127783003	4133840		
49458	4506	40758406	1983-12-12	1983-12-12 00:00:00	1983-12-12	5001	0	\N	0	0	\N	\N	0	300225	0	55277-8	40758406		
52471	4822	46235214	1955-04-15	1955-04-15 00:00:00	1955-04-15	5001	0	\N	0	0	\N	\N	0	320741	0	76690-7	46235214		
48782	4462	3011505	1997-03-27	1997-03-27 00:00:00	1997-03-27	5001	0	\N	0	0	\N	\N	0	296906	0	19926-5	3011505		
19644	1791	3006322	1983-01-29	1983-01-29 00:00:00	1983-01-29	5001	0	\N	0	0	\N	\N	0	120021	0	8331-1	3006322		
2702	264	3006322	1958-09-13	1958-09-13 00:00:00	1958-09-13	5001	0	\N	0	0	\N	\N	0	17509	0	8331-1	3006322		
162492	4986	4052083	1955-12-25	1955-12-25 00:00:00	1955-12-25	5001	0	\N	0	0	\N	\N	0	331688	0	23426006	4052083		
37700	3477	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	230651	0	6085-5	3001247		
16235	1478	3006322	2015-07-21	2015-07-21 00:00:00	2015-07-21	5001	0	\N	0	0	\N	\N	0	98633	0	8331-1	3006322		
60827	1854	4024958	1973-08-23	1973-08-23 00:00:00	1973-08-23	5001	0	\N	0	0	\N	\N	0	124121	0	117015009	4024958		
56923	5222	3011505	2002-01-31	2002-01-31 00:00:00	2002-01-31	5001	0	\N	0	0	\N	\N	0	347347	0	19926-5	3011505		
11842	1128	3006322	1987-01-21	1987-01-21 00:00:00	1987-01-21	5001	0	\N	0	0	\N	\N	0	74316	0	8331-1	3006322		
20466	1879	3049273	2019-05-04	2019-05-04 00:00:00	2019-05-04	5001	0	\N	0	0	\N	\N	0	125427	0	38265-5	3049273		
38984	3604	3014599	2000-11-10	2000-11-10 00:00:00	2000-11-10	5001	0	\N	0	0	\N	\N	0	239496	0	6106-9	3014599		
22736	712	4052083	2018-12-25	2018-12-25 00:00:00	2018-12-25	5001	0	\N	0	0	\N	\N	0	47233	0	23426006	4052083		
155819	4784	4052083	2009-05-16	2009-05-16 00:00:00	2009-05-16	5001	0	\N	0	0	\N	\N	0	318432	0	23426006	4052083		
68219	2088	4052083	1972-07-10	1972-07-10 00:00:00	1972-07-10	5001	0	\N	0	0	\N	\N	0	139261	0	23426006	4052083		
16924	1538	3005136	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	103037	0	6075-6	3005136		
28338	2619	3051031	1940-01-10	1940-01-10 00:00:00	1940-01-10	5001	0	\N	0	0	\N	\N	0	173138	0	46240-8	3051031		
34713	1083	4052083	2006-11-12	2006-11-12 00:00:00	2006-11-12	5001	0	\N	0	0	\N	\N	0	71174	0	23426006	4052083		
8757	842	3011505	1997-07-12	1997-07-12 00:00:00	1997-07-12	5001	0	\N	0	0	\N	\N	0	55697	0	19926-5	3011505		
27065	2509	3006322	1976-06-20	1976-06-20 00:00:00	1976-06-20	5001	0	\N	0	0	\N	\N	0	166090	0	8331-1	3006322		
27146	2518	3011505	2002-02-01	2002-02-01 00:00:00	2002-02-01	5001	0	\N	0	0	\N	\N	0	166549	0	19926-5	3011505		
31566	2891	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	192356	0	6206-7	3012494		
43210	3991	40758406	1957-06-23	1957-06-23 00:00:00	1957-06-23	5001	0	\N	0	0	\N	\N	0	265339	0	55277-8	40758406		
42978	3973	3006322	2012-08-07	2012-08-07 00:00:00	2012-08-07	5001	0	\N	0	0	\N	\N	0	264174	0	8331-1	3006322		
22381	2053	40766240	1964-01-26	1964-01-26 00:00:00	1964-01-26	5001	0	\N	0	0	\N	\N	0	136557	0	63513-6	40766240		
6167	578	46235214	2010-06-19	2010-06-19 00:00:00	2010-06-19	5001	0	\N	0	0	\N	\N	0	38217	0	76690-7	46235214		
51107	4665	3006322	1982-08-11	1982-08-11 00:00:00	1982-08-11	5001	0	\N	0	0	\N	\N	0	310898	0	8331-1	3006322		
1216	97	3011505	2002-05-27	2002-05-27 00:00:00	2002-05-27	5001	0	\N	0	0	\N	\N	0	6610	0	19926-5	3011505		
17674	1609	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	108191	0	6206-7	3012494		
550	30	3006322	1998-02-04	1998-02-04 00:00:00	1998-02-04	5001	0	\N	0	0	\N	\N	0	2097	0	8331-1	3006322		
51075	1550	4052083	1993-05-07	1993-05-07 00:00:00	1993-05-07	5001	0	\N	0	0	\N	\N	0	103805	0	23426006	4052083		
76665	2349	4024958	1973-05-07	1973-05-07 00:00:00	1973-05-07	5001	0	\N	0	0	\N	\N	0	156365	0	117015009	4024958		
53603	4924	3020655	1990-12-19	1990-12-19 00:00:00	1990-12-19	5001	0	\N	0	0	\N	\N	0	327151	0	6844-5	3020655		
17330	1574	40758406	1986-03-25	1986-03-25 00:00:00	1986-03-25	5001	0	\N	0	0	\N	\N	0	105715	0	55277-8	40758406		
57574	5285	40766240	1944-03-05	1944-03-05 00:00:00	1944-03-05	5001	0	\N	0	0	\N	\N	0	351708	0	63513-6	40766240		
52750	4847	3011505	1994-06-08	1994-06-08 00:00:00	1994-06-08	5001	0	\N	0	0	\N	\N	0	322417	0	19926-5	3011505		
35027	3195	3006322	1979-06-24	1979-06-24 00:00:00	1979-06-24	5001	0	\N	0	0	\N	\N	0	212565	0	8331-1	3006322		
47672	4374	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	290564	0	6206-7	3012494		
30848	2827	40766240	1921-07-31	1921-07-31 00:00:00	1921-07-31	5001	0	\N	0	0	\N	\N	0	187467	0	63513-6	40766240		
20901	1926	3006322	2007-01-07	2007-01-07 00:00:00	2007-01-07	5001	0	\N	0	0	\N	\N	0	128256	0	8331-1	3006322		
4085	406	3015076	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	26726	0	6248-9	3015076		
21125	1954	40766240	1967-08-20	1967-08-20 00:00:00	1967-08-20	5001	0	\N	0	0	\N	\N	0	130011	0	63513-6	40766240		
27008	2503	3019406	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	165689	0	6158-0	3019406		
122938	3789	4052083	2006-06-10	2006-06-10 00:00:00	2006-06-10	5001	0	\N	0	0	\N	\N	0	251881	0	23426006	4052083		
10494	335	4052083	1974-07-22	1974-07-22 00:00:00	1974-07-22	5001	0	\N	0	0	\N	\N	0	22271	0	23426006	4052083		
34395	3133	46235214	2004-04-10	2004-04-10 00:00:00	2004-04-10	5001	0	\N	0	0	\N	\N	0	208523	0	76690-7	46235214		
101461	3118	4133840	1998-12-06	1998-12-06 00:00:00	1998-12-06	5001	0	\N	0	0	\N	\N	0	207408	0	127783003	4133840		
44406	4102	3006322	1972-08-16	1972-08-16 00:00:00	1972-08-16	5001	0	\N	0	0	\N	\N	0	272596	0	8331-1	3006322		
40830	3786	3000963	2015-11-25	2015-11-25 00:00:00	2015-11-25	5001	0	\N	0	0	\N	\N	0	251654	0	718-7	3000963		
18443	1691	3006322	2000-01-17	2000-01-17 00:00:00	2000-01-17	5001	0	\N	0	0	\N	\N	0	113289	0	8331-1	3006322		
52300	4804	3019406	1993-09-27	1993-09-27 00:00:00	1993-09-27	5001	0	\N	0	0	\N	\N	0	319586	0	6158-0	3019406		
14084	1317	3011505	2006-12-08	2006-12-08 00:00:00	2006-12-08	5001	0	\N	0	0	\N	\N	0	87311	0	19926-5	3011505		
41967	3881	3049273	1960-11-27	1960-11-27 00:00:00	1960-11-27	5001	0	\N	0	0	\N	\N	0	257918	0	38265-5	3049273		
30008	2765	3011505	2018-01-09	2018-01-09 00:00:00	2018-01-09	5001	0	\N	0	0	\N	\N	0	182948	0	19926-5	3011505		
106863	3293	4024958	1996-11-07	1996-11-07 00:00:00	1996-11-07	5001	0	\N	0	0	\N	\N	0	218734	0	117015009	4024958		
41453	3860	3006322	1986-09-04	1986-09-04 00:00:00	1986-09-04	5001	0	\N	0	0	\N	\N	0	256281	0	8331-1	3006322		
14465	1352	3024561	1976-07-29	1976-07-29 00:00:00	1976-07-29	5001	0	\N	0	0	\N	\N	0	89606	0	1751-7	3024561		
64237	1975	4024958	1936-02-10	1936-02-10 00:00:00	1936-02-10	5001	0	\N	0	0	\N	\N	0	131269	0	117015009	4024958		
16414	1496	3049273	1994-06-16	1994-06-16 00:00:00	1994-06-16	5001	0	\N	0	0	\N	\N	0	99743	0	38265-5	3049273		
128586	3957	4133840	2000-12-28	2000-12-28 00:00:00	2000-12-28	5001	0	\N	0	0	\N	\N	0	263077	0	127783003	4133840		
49460	4506	46235214	1983-12-12	1983-12-12 00:00:00	1983-12-12	5001	0	\N	0	0	\N	\N	0	300225	0	76690-7	46235214		
52472	4822	40758406	1955-04-15	1955-04-15 00:00:00	1955-04-15	5001	0	\N	0	0	\N	\N	0	320741	0	55277-8	40758406		
48783	4462	3011505	1990-09-20	1990-09-20 00:00:00	1990-09-20	5001	0	\N	0	0	\N	\N	0	296905	0	19926-5	3011505		
19649	1793	3006322	1987-10-08	1987-10-08 00:00:00	1987-10-08	5001	0	\N	0	0	\N	\N	0	120182	0	8331-1	3006322		
2703	264	3006322	1958-05-04	1958-05-04 00:00:00	1958-05-04	5001	0	\N	0	0	\N	\N	0	17507	0	8331-1	3006322		
162493	4986	4024958	1958-01-14	1958-01-14 00:00:00	1958-01-14	5001	0	\N	0	0	\N	\N	0	331676	0	117015009	4024958		
37701	3477	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	230651	0	6833-8	3023430		
16238	1480	3049273	1973-07-13	1973-07-13 00:00:00	1973-07-13	5001	0	\N	0	0	\N	\N	0	98759	0	38265-5	3049273		
60829	1854	4052083	1993-05-07	1993-05-07 00:00:00	1993-05-07	5001	0	\N	0	0	\N	\N	0	124063	0	23426006	4052083		
56924	5222	3011505	1998-01-08	1998-01-08 00:00:00	1998-01-08	5001	0	\N	0	0	\N	\N	0	347464	0	19926-5	3011505		
11844	1131	3006322	1984-03-16	1984-03-16 00:00:00	1984-03-16	5001	0	\N	0	0	\N	\N	0	74443	0	8331-1	3006322		
20467	1879	3006322	1968-09-11	1968-09-11 00:00:00	1968-09-11	5001	0	\N	0	0	\N	\N	0	125358	0	8331-1	3006322		
38985	3604	3021226	1997-05-09	1997-05-09 00:00:00	1997-05-09	5001	0	\N	0	0	\N	\N	0	239521	0	6246-3	3021226		
22754	712	4024958	1990-07-13	1990-07-13 00:00:00	1990-07-13	5001	0	\N	0	0	\N	\N	0	47224	0	117015009	4024958		
155826	4784	4024958	2004-02-08	2004-02-08 00:00:00	2004-02-08	5001	0	\N	0	0	\N	\N	0	318482	0	117015009	4024958		
68222	2088	4133840	2018-08-07	2018-08-07 00:00:00	2018-08-07	5001	0	\N	0	0	\N	\N	0	139290	0	127783003	4133840		
16925	1538	3015076	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	103037	0	6248-9	3015076		
28339	2619	40766240	1940-01-10	1940-01-10 00:00:00	1940-01-10	5001	0	\N	0	0	\N	\N	0	173138	0	63513-6	40766240		
5214	502	3006322	1990-12-06	1990-12-06 00:00:00	1990-12-06	5001	0	\N	0	0	\N	\N	0	33583	0	8331-1	3006322		
8758	842	3011505	1972-11-25	1972-11-25 00:00:00	1972-11-25	5001	0	\N	0	0	\N	\N	0	55693	0	19926-5	3011505		
27066	2509	3006322	1970-05-08	1970-05-08 00:00:00	1970-05-08	5001	0	\N	0	0	\N	\N	0	166094	0	8331-1	3006322		
27147	2518	3011505	2015-01-16	2015-01-16 00:00:00	2015-01-16	5001	0	\N	0	0	\N	\N	0	166576	0	19926-5	3011505		
31567	2891	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	192356	0	6246-3	3021226		
43212	3991	46235214	1957-06-23	1957-06-23 00:00:00	1957-06-23	5001	0	\N	0	0	\N	\N	0	265339	0	76690-7	46235214		
42979	3973	3006322	1977-05-26	1977-05-26 00:00:00	1977-05-26	5001	0	\N	0	0	\N	\N	0	264177	0	8331-1	3006322		
22383	2053	3006322	1955-07-25	1955-07-25 00:00:00	1955-07-25	5001	0	\N	0	0	\N	\N	0	136508	0	8331-1	3006322		
6168	578	3006322	1996-12-18	1996-12-18 00:00:00	1996-12-18	5001	0	\N	0	0	\N	\N	0	38269	0	8331-1	3006322		
51108	4665	3006322	2010-10-23	2010-10-23 00:00:00	2010-10-23	5001	0	\N	0	0	\N	\N	0	310901	0	8331-1	3006322		
1217	97	3011505	2003-06-02	2003-06-02 00:00:00	2003-06-02	5001	0	\N	0	0	\N	\N	0	6629	0	19926-5	3011505		
17675	1609	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	108191	0	7258-7	3001488		
554	32	3006322	1984-07-29	1984-07-29 00:00:00	1984-07-29	5001	0	\N	0	0	\N	\N	0	2261	0	8331-1	3006322		
51081	1550	4133840	2007-12-15	2007-12-15 00:00:00	2007-12-15	5001	0	\N	0	0	\N	\N	0	103789	0	127783003	4133840		
76669	2349	4024958	2016-09-01	2016-09-01 00:00:00	2016-09-01	5001	0	\N	0	0	\N	\N	0	156334	0	117015009	4024958		
53604	4924	3006734	1990-12-19	1990-12-19 00:00:00	1990-12-19	5001	0	\N	0	0	\N	\N	0	327151	0	6189-5	3006734		
17331	1574	46235214	1986-03-25	1986-03-25 00:00:00	1986-03-25	5001	0	\N	0	0	\N	\N	0	105715	0	76690-7	46235214		
57576	5285	46235214	1944-03-05	1944-03-05 00:00:00	1944-03-05	5001	0	\N	0	0	\N	\N	0	351708	0	76690-7	46235214		
100243	3077	4024958	1983-02-10	1983-02-10 00:00:00	1983-02-10	5001	0	\N	0	0	\N	\N	0	204767	0	117015009	4024958		
35028	3196	3006322	1989-06-28	1989-06-28 00:00:00	1989-06-28	5001	0	\N	0	0	\N	\N	0	212647	0	8331-1	3006322		
47673	4374	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	290564	0	6246-3	3021226		
30849	2827	40758406	1921-07-31	1921-07-31 00:00:00	1921-07-31	5001	0	\N	0	0	\N	\N	0	187467	0	55277-8	40758406		
20902	1926	3006322	1978-11-10	1978-11-10 00:00:00	1978-11-10	5001	0	\N	0	0	\N	\N	0	128242	0	8331-1	3006322		
4086	406	3006451	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	26726	0	6273-7	3006451		
21126	1954	46235214	1967-08-20	1967-08-20 00:00:00	1967-08-20	5001	0	\N	0	0	\N	\N	0	130011	0	76690-7	46235214		
27009	2503	3015076	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	165689	0	6248-9	3015076		
122944	3789	4024958	1953-07-04	1953-07-04 00:00:00	1953-07-04	5001	0	\N	0	0	\N	\N	0	251872	0	117015009	4024958		
10506	335	4052083	2005-12-15	2005-12-15 00:00:00	2005-12-15	5001	0	\N	0	0	\N	\N	0	22280	0	23426006	4052083		
34397	3133	40766240	2004-04-10	2004-04-10 00:00:00	2004-04-10	5001	0	\N	0	0	\N	\N	0	208523	0	63513-6	40766240		
101469	3118	4133840	1994-12-25	1994-12-25 00:00:00	1994-12-25	5001	0	\N	0	0	\N	\N	0	207424	0	127783003	4133840		
44407	4102	3006322	1997-12-13	1997-12-13 00:00:00	1997-12-13	5001	0	\N	0	0	\N	\N	0	272567	0	8331-1	3006322		
40831	3786	3009542	2015-11-25	2015-11-25 00:00:00	2015-11-25	5001	0	\N	0	0	\N	\N	0	251654	0	20570-8	3009542		
43185	1328	4133840	2012-03-22	2012-03-22 00:00:00	2012-03-22	5001	0	\N	0	0	\N	\N	0	88214	0	127783003	4133840		
52301	4804	3000876	1993-09-27	1993-09-27 00:00:00	1993-09-27	5001	0	\N	0	0	\N	\N	0	319586	0	6082-2	3000876		
14085	1317	3006322	1995-08-03	1995-08-03 00:00:00	1995-08-03	5001	0	\N	0	0	\N	\N	0	87246	0	8331-1	3006322		
41968	3881	3006322	2000-01-25	2000-01-25 00:00:00	2000-01-25	5001	0	\N	0	0	\N	\N	0	257949	0	8331-1	3006322		
30009	2765	3011505	2012-12-04	2012-12-04 00:00:00	2012-12-04	5001	0	\N	0	0	\N	\N	0	182842	0	19926-5	3011505		
118145	3637	4052083	1973-04-09	1973-04-09 00:00:00	1973-04-09	5001	0	\N	0	0	\N	\N	0	241942	0	23426006	4052083		
41454	3860	3006322	1984-12-03	1984-12-03 00:00:00	1984-12-03	5001	0	\N	0	0	\N	\N	0	256319	0	8331-1	3006322		
14466	1352	3028833	1976-07-29	1976-07-29 00:00:00	1976-07-29	5001	0	\N	0	0	\N	\N	0	89606	0	42719-5	3028833		
54818	1659	4024958	1999-10-07	1999-10-07 00:00:00	1999-10-07	5001	0	\N	0	0	\N	\N	0	111473	0	117015009	4024958		
16415	1496	3006322	1961-12-30	1961-12-30 00:00:00	1961-12-30	5001	0	\N	0	0	\N	\N	0	99722	0	8331-1	3006322		
128587	3957	4133840	2011-10-06	2011-10-06 00:00:00	2011-10-06	5001	0	\N	0	0	\N	\N	0	263061	0	127783003	4133840		
49463	4506	40766240	2011-09-26	2011-09-26 00:00:00	2011-09-26	5001	0	\N	0	0	\N	\N	0	300165	0	63513-6	40766240		
52473	4822	3051031	1955-04-15	1955-04-15 00:00:00	1955-04-15	5001	0	\N	0	0	\N	\N	0	320741	0	46240-8	3051031		
48784	4462	3006322	2014-03-29	2014-03-29 00:00:00	2014-03-29	5001	0	\N	0	0	\N	\N	0	296935	0	8331-1	3006322		
19650	1793	3006322	2005-12-28	2005-12-28 00:00:00	2005-12-28	5001	0	\N	0	0	\N	\N	0	120247	0	8331-1	3006322		
2706	266	3049273	2018-09-26	2018-09-26 00:00:00	2018-09-26	5001	0	\N	0	0	\N	\N	0	17694	0	38265-5	3049273		
162496	4986	4024958	2018-03-10	2018-03-10 00:00:00	2018-03-10	5001	0	\N	0	0	\N	\N	0	331653	0	117015009	4024958		
37702	3477	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	230651	0	6844-5	3020655		
16239	1480	3006322	1978-07-29	1978-07-29 00:00:00	1978-07-29	5001	0	\N	0	0	\N	\N	0	98740	0	8331-1	3006322		
60830	1854	4052083	2012-12-12	2012-12-12 00:00:00	2012-12-12	5001	0	\N	0	0	\N	\N	0	124091	0	23426006	4052083		
56925	5222	3006322	1937-07-18	1937-07-18 00:00:00	1937-07-18	5001	0	\N	0	0	\N	\N	0	347403	0	8331-1	3006322		
11845	1131	3006322	2012-03-04	2012-03-04 00:00:00	2012-03-04	5001	0	\N	0	0	\N	\N	0	74425	0	8331-1	3006322		
20468	1879	3006322	1984-02-05	1984-02-05 00:00:00	1984-02-05	5001	0	\N	0	0	\N	\N	0	125393	0	8331-1	3006322		
38986	3604	3005136	1997-05-09	1997-05-09 00:00:00	1997-05-09	5001	0	\N	0	0	\N	\N	0	239521	0	6075-6	3005136		
22764	715	4024958	1984-08-11	1984-08-11 00:00:00	1984-08-11	5001	0	\N	0	0	\N	\N	0	47333	0	117015009	4024958		
155846	4784	4052083	1996-03-02	1996-03-02 00:00:00	1996-03-02	5001	0	\N	0	0	\N	\N	0	318481	0	23426006	4052083		
68225	2088	4133840	2012-03-06	2012-03-06 00:00:00	2012-03-06	5001	0	\N	0	0	\N	\N	0	139284	0	127783003	4133840		
16926	1538	3014599	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	103037	0	6106-9	3014599		
28341	2619	46235214	1940-01-10	1940-01-10 00:00:00	1940-01-10	5001	0	\N	0	0	\N	\N	0	173138	0	76690-7	46235214		
5215	502	3006322	2016-10-15	2016-10-15 00:00:00	2016-10-15	5001	0	\N	0	0	\N	\N	0	33636	0	8331-1	3006322		
8759	843	3006322	1986-12-23	1986-12-23 00:00:00	1986-12-23	5001	0	\N	0	0	\N	\N	0	55788	0	8331-1	3006322		
27067	2509	3006322	2006-05-02	2006-05-02 00:00:00	2006-05-02	5001	0	\N	0	0	\N	\N	0	166050	0	8331-1	3006322		
27148	2518	3011505	2011-12-30	2011-12-30 00:00:00	2011-12-30	5001	0	\N	0	0	\N	\N	0	166571	0	19926-5	3011505		
31568	2891	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	192356	0	7258-7	3001488		
43213	3991	3049273	2016-01-23	2016-01-23 00:00:00	2016-01-23	5001	0	\N	0	0	\N	\N	0	265352	0	38265-5	3049273		
42980	3973	3006322	1976-10-13	1976-10-13 00:00:00	1976-10-13	5001	0	\N	0	0	\N	\N	0	264236	0	8331-1	3006322		
22384	2053	3006322	1959-09-08	1959-09-08 00:00:00	1959-09-08	5001	0	\N	0	0	\N	\N	0	136501	0	8331-1	3006322		
6169	578	3051031	2010-07-19	2010-07-19 00:00:00	2010-07-19	5001	0	\N	0	0	\N	\N	0	38271	0	46240-8	3051031		
51109	4666	3006322	2005-07-13	2005-07-13 00:00:00	2005-07-13	5001	0	\N	0	0	\N	\N	0	310950	0	8331-1	3006322		
1218	97	3011505	2001-05-21	2001-05-21 00:00:00	2001-05-21	5001	0	\N	0	0	\N	\N	0	6628	0	19926-5	3011505		
17676	1609	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	108191	0	6095-4	3036780		
555	32	3006322	1962-10-29	1962-10-29 00:00:00	1962-10-29	5001	0	\N	0	0	\N	\N	0	2255	0	8331-1	3006322		
51085	1550	4133840	2004-05-22	2004-05-22 00:00:00	2004-05-22	5001	0	\N	0	0	\N	\N	0	103779	0	127783003	4133840		
99851	3064	4052083	1993-12-29	1993-12-29 00:00:00	1993-12-29	5001	0	\N	0	0	\N	\N	0	203940	0	23426006	4052083		
53605	4924	3023430	1990-12-19	1990-12-19 00:00:00	1990-12-19	5001	0	\N	0	0	\N	\N	0	327151	0	6833-8	3023430		
17334	1576	3006322	1972-01-18	1972-01-18 00:00:00	1972-01-18	5001	0	\N	0	0	\N	\N	0	105770	0	8331-1	3006322		
57577	5285	46235214	1991-02-12	1991-02-12 00:00:00	1991-02-12	5001	0	\N	0	0	\N	\N	0	351699	0	76690-7	46235214		
100267	3077	4024958	1987-07-03	1987-07-03 00:00:00	1987-07-03	5001	0	\N	0	0	\N	\N	0	204782	0	117015009	4024958		
35029	3196	3006322	1998-05-24	1998-05-24 00:00:00	1998-05-24	5001	0	\N	0	0	\N	\N	0	212614	0	8331-1	3006322		
47674	4374	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	290564	0	6075-6	3005136		
30851	2827	46235214	1921-07-31	1921-07-31 00:00:00	1921-07-31	5001	0	\N	0	0	\N	\N	0	187467	0	76690-7	46235214		
20903	1926	3006322	1997-05-16	1997-05-16 00:00:00	1997-05-16	5001	0	\N	0	0	\N	\N	0	128235	0	8331-1	3006322		
4087	406	3006734	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	26726	0	6189-5	3006734		
21128	1954	3051031	1967-08-20	1967-08-20 00:00:00	1967-08-20	5001	0	\N	0	0	\N	\N	0	130011	0	46240-8	3051031		
27010	2503	3027231	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	165689	0	6276-0	3027231		
122950	3789	4024958	1975-11-10	1975-11-10 00:00:00	1975-11-10	5001	0	\N	0	0	\N	\N	0	251877	0	117015009	4024958		
10509	335	4024958	1973-10-24	1973-10-24 00:00:00	1973-10-24	5001	0	\N	0	0	\N	\N	0	22277	0	117015009	4024958		
34398	3133	40758406	2005-04-05	2005-04-05 00:00:00	2005-04-05	5001	0	\N	0	0	\N	\N	0	208525	0	55277-8	40758406		
101491	3118	4133840	2004-06-27	2004-06-27 00:00:00	2004-06-27	5001	0	\N	0	0	\N	\N	0	207458	0	127783003	4133840		
44408	4102	3006322	1973-04-25	1973-04-25 00:00:00	1973-04-25	5001	0	\N	0	0	\N	\N	0	272591	0	8331-1	3006322		
40833	3787	3006322	2008-12-23	2008-12-23 00:00:00	2008-12-23	5001	0	\N	0	0	\N	\N	0	251766	0	8331-1	3006322		
43186	1328	4133840	2013-03-28	2013-03-28 00:00:00	2013-03-28	5001	0	\N	0	0	\N	\N	0	88233	0	127783003	4133840		
52302	4804	3001488	1993-09-27	1993-09-27 00:00:00	1993-09-27	5001	0	\N	0	0	\N	\N	0	319586	0	7258-7	3001488		
14086	1317	3006322	1964-10-04	1964-10-04 00:00:00	1964-10-04	5001	0	\N	0	0	\N	\N	0	87288	0	8331-1	3006322		
41969	3881	3006322	1974-10-31	1974-10-31 00:00:00	1974-10-31	5001	0	\N	0	0	\N	\N	0	257881	0	8331-1	3006322		
30010	2765	3015076	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	182987	0	6248-9	3015076		
118153	3637	4052083	2009-01-24	2009-01-24 00:00:00	2009-01-24	5001	0	\N	0	0	\N	\N	0	241925	0	23426006	4052083		
41455	3860	3006322	2012-04-12	2012-04-12 00:00:00	2012-04-12	5001	0	\N	0	0	\N	\N	0	256332	0	8331-1	3006322		
14467	1352	3016723	1976-07-29	1976-07-29 00:00:00	1976-07-29	5001	0	\N	0	0	\N	\N	0	89606	0	2160-0	3016723		
161947	4971	4133840	2002-12-17	2002-12-17 00:00:00	2002-12-17	5001	0	\N	0	0	\N	\N	0	330504	0	127783003	4133840		
16416	1496	3006322	1947-04-11	1947-04-11 00:00:00	1947-04-11	5001	0	\N	0	0	\N	\N	0	99729	0	8331-1	3006322		
128593	3957	4133840	1998-12-24	1998-12-24 00:00:00	1998-12-24	5001	0	\N	0	0	\N	\N	0	263116	0	127783003	4133840		
49464	4506	3051031	2011-09-26	2011-09-26 00:00:00	2011-09-26	5001	0	\N	0	0	\N	\N	0	300165	0	46240-8	3051031		
52475	4822	40766240	1955-04-15	1955-04-15 00:00:00	1955-04-15	5001	0	\N	0	0	\N	\N	0	320741	0	63513-6	40766240		
48785	4462	3011505	2012-03-15	2012-03-15 00:00:00	2012-03-15	5001	0	\N	0	0	\N	\N	0	296923	0	19926-5	3011505		
19651	1793	3006322	1919-10-06	1919-10-06 00:00:00	1919-10-06	5001	0	\N	0	0	\N	\N	0	120248	0	8331-1	3006322		
65695	2017	4052083	1980-07-03	1980-07-03 00:00:00	1980-07-03	5001	0	\N	0	0	\N	\N	0	134191	0	23426006	4052083		
162516	4986	4052083	1959-07-23	1959-07-23 00:00:00	1959-07-23	5001	0	\N	0	0	\N	\N	0	331656	0	23426006	4052083		
37703	3477	40769179	1986-04-02	1986-04-02 00:00:00	1986-04-02	5001	0	\N	0	0	\N	\N	0	230714	0	66519-0	40769179		
16241	1480	3006322	1993-01-24	1993-01-24 00:00:00	1993-01-24	5001	0	\N	0	0	\N	\N	0	98708	0	8331-1	3006322		
60831	1854	4052083	1992-08-17	1992-08-17 00:00:00	1992-08-17	5001	0	\N	0	0	\N	\N	0	124080	0	23426006	4052083		
56926	5222	3011505	2009-03-12	2009-03-12 00:00:00	2009-03-12	5001	0	\N	0	0	\N	\N	0	347423	0	19926-5	3011505		
11846	1131	3006322	2010-08-25	2010-08-25 00:00:00	2010-08-25	5001	0	\N	0	0	\N	\N	0	74436	0	8331-1	3006322		
20469	1879	3006322	1961-05-23	1961-05-23 00:00:00	1961-05-23	5001	0	\N	0	0	\N	\N	0	125433	0	8331-1	3006322		
38987	3604	3012494	1997-05-09	1997-05-09 00:00:00	1997-05-09	5001	0	\N	0	0	\N	\N	0	239521	0	6206-7	3012494		
22780	715	4052083	1992-11-26	1992-11-26 00:00:00	1992-11-26	5001	0	\N	0	0	\N	\N	0	47290	0	23426006	4052083		
142140	4374	4024958	2001-10-05	2001-10-05 00:00:00	2001-10-05	5001	0	\N	0	0	\N	\N	0	290566	0	117015009	4024958		
68228	2088	4133840	1986-07-08	1986-07-08 00:00:00	1986-07-08	5001	0	\N	0	0	\N	\N	0	139286	0	127783003	4133840		
16927	1538	3019406	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	103037	0	6158-0	3019406		
28343	2619	3006322	1979-12-15	1979-12-15 00:00:00	1979-12-15	5001	0	\N	0	0	\N	\N	0	173144	0	8331-1	3006322		
5216	502	3006322	2011-11-15	2011-11-15 00:00:00	2011-11-15	5001	0	\N	0	0	\N	\N	0	33635	0	8331-1	3006322		
8760	843	3012494	1983-05-08	1983-05-08 00:00:00	1983-05-08	5001	0	\N	0	0	\N	\N	0	55804	0	6206-7	3012494		
144246	4433	4052083	2008-08-02	2008-08-02 00:00:00	2008-08-02	5001	0	\N	0	0	\N	\N	0	294657	0	23426006	4052083		
27149	2518	3006322	2010-12-18	2010-12-18 00:00:00	2010-12-18	5001	0	\N	0	0	\N	\N	0	166583	0	8331-1	3006322		
31569	2891	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	192356	0	6189-5	3006734		
43214	3991	3006322	2002-02-19	2002-02-19 00:00:00	2002-02-19	5001	0	\N	0	0	\N	\N	0	265396	0	8331-1	3006322		
42981	3973	3006322	2019-02-15	2019-02-15 00:00:00	2019-02-15	5001	0	\N	0	0	\N	\N	0	264205	0	8331-1	3006322		
22386	2053	40758406	1964-09-22	1964-09-22 00:00:00	1964-09-22	5001	0	\N	0	0	\N	\N	0	136505	0	55277-8	40758406		
6171	578	40758406	2010-07-19	2010-07-19 00:00:00	2010-07-19	5001	0	\N	0	0	\N	\N	0	38271	0	55277-8	40758406		
51111	4668	3006322	2018-09-02	2018-09-02 00:00:00	2018-09-02	5001	0	\N	0	0	\N	\N	0	311083	0	8331-1	3006322		
1219	97	3011505	1983-07-25	1983-07-25 00:00:00	1983-07-25	5001	0	\N	0	0	\N	\N	0	6607	0	19926-5	3011505		
17677	1609	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	108191	0	6189-5	3006734		
559	32	3006322	1947-08-08	1947-08-08 00:00:00	1947-08-08	5001	0	\N	0	0	\N	\N	0	2267	0	8331-1	3006322		
51087	1550	4133840	2009-12-19	2009-12-19 00:00:00	2009-12-19	5001	0	\N	0	0	\N	\N	0	103781	0	127783003	4133840		
99869	3064	4024958	2017-10-03	2017-10-03 00:00:00	2017-10-03	5001	0	\N	0	0	\N	\N	0	203943	0	117015009	4024958		
53606	4924	3001488	1990-12-19	1990-12-19 00:00:00	1990-12-19	5001	0	\N	0	0	\N	\N	0	327151	0	7258-7	3001488		
17335	1576	3006322	1980-03-19	1980-03-19 00:00:00	1980-03-19	5001	0	\N	0	0	\N	\N	0	105818	0	8331-1	3006322		
57579	5285	3051031	1991-02-12	1991-02-12 00:00:00	1991-02-12	5001	0	\N	0	0	\N	\N	0	351699	0	46240-8	3051031		
154532	4739	4052083	1943-12-27	1943-12-27 00:00:00	1943-12-27	5001	0	\N	0	0	\N	\N	0	315701	0	23426006	4052083		
35030	3196	3006322	2011-01-10	2011-01-10 00:00:00	2011-01-10	5001	0	\N	0	0	\N	\N	0	212617	0	8331-1	3006322		
47675	4374	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	290564	0	6106-9	3014599		
30852	2827	3051031	1921-07-31	1921-07-31 00:00:00	1921-07-31	5001	0	\N	0	0	\N	\N	0	187467	0	46240-8	3051031		
20904	1926	3006322	1980-06-19	1980-06-19 00:00:00	1980-06-19	5001	0	\N	0	0	\N	\N	0	128232	0	8331-1	3006322		
4088	406	3021226	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	26726	0	6246-3	3021226		
80194	2468	4052083	1986-11-19	1986-11-19 00:00:00	1986-11-19	5001	0	\N	0	0	\N	\N	0	163604	0	23426006	4052083		
27011	2503	3014599	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	165689	0	6106-9	3014599		
122954	3790	4024958	1991-01-14	1991-01-14 00:00:00	1991-01-14	5001	0	\N	0	0	\N	\N	0	251999	0	117015009	4024958		
10517	335	4052083	1978-04-23	1978-04-23 00:00:00	1978-04-23	5001	0	\N	0	0	\N	\N	0	22278	0	23426006	4052083		
34399	3133	46235214	2005-04-05	2005-04-05 00:00:00	2005-04-05	5001	0	\N	0	0	\N	\N	0	208525	0	76690-7	46235214		
101493	3118	4133840	1988-12-11	1988-12-11 00:00:00	1988-12-11	5001	0	\N	0	0	\N	\N	0	207406	0	127783003	4133840		
44409	4102	3006322	1979-09-09	1979-09-09 00:00:00	1979-09-09	5001	0	\N	0	0	\N	\N	0	272618	0	8331-1	3006322		
40834	3787	3006322	2004-07-02	2004-07-02 00:00:00	2004-07-02	5001	0	\N	0	0	\N	\N	0	251735	0	8331-1	3006322		
43189	1328	4133840	2019-05-02	2019-05-02 00:00:00	2019-05-02	5001	0	\N	0	0	\N	\N	0	88175	0	127783003	4133840		
52303	4804	3014599	1993-09-27	1993-09-27 00:00:00	1993-09-27	5001	0	\N	0	0	\N	\N	0	319586	0	6106-9	3014599		
14088	1317	3006322	2011-09-13	2011-09-13 00:00:00	2011-09-13	5001	0	\N	0	0	\N	\N	0	87257	0	8331-1	3006322		
41971	3884	3006322	2014-04-18	2014-04-18 00:00:00	2014-04-18	5001	0	\N	0	0	\N	\N	0	258191	0	8331-1	3006322		
30011	2765	3014599	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	182987	0	6106-9	3014599		
15291	480	4024958	1945-06-20	1945-06-20 00:00:00	1945-06-20	5001	0	\N	0	0	\N	\N	0	32123	0	117015009	4024958		
41456	3860	3006322	2004-02-02	2004-02-02 00:00:00	2004-02-02	5001	0	\N	0	0	\N	\N	0	256331	0	8331-1	3006322		
14468	1352	3015632	1976-07-29	1976-07-29 00:00:00	1976-07-29	5001	0	\N	0	0	\N	\N	0	89606	0	2028-9	3015632		
161949	4971	4133840	2015-02-24	2015-02-24 00:00:00	2015-02-24	5001	0	\N	0	0	\N	\N	0	330583	0	127783003	4133840		
16417	1496	3006322	1971-03-06	1971-03-06 00:00:00	1971-03-06	5001	0	\N	0	0	\N	\N	0	99696	0	8331-1	3006322		
128597	3957	4052083	1994-01-22	1994-01-22 00:00:00	1994-01-22	5001	0	\N	0	0	\N	\N	0	263087	0	23426006	4052083		
49465	4506	40758406	2011-09-26	2011-09-26 00:00:00	2011-09-26	5001	0	\N	0	0	\N	\N	0	300165	0	55277-8	40758406		
52476	4822	3011505	2016-01-06	2016-01-06 00:00:00	2016-01-06	5001	0	\N	0	0	\N	\N	0	320721	0	19926-5	3011505		
48786	4462	3006322	2005-11-26	2005-11-26 00:00:00	2005-11-26	5001	0	\N	0	0	\N	\N	0	296943	0	8331-1	3006322		
19652	1793	3006322	1967-06-13	1967-06-13 00:00:00	1967-06-13	5001	0	\N	0	0	\N	\N	0	120240	0	8331-1	3006322		
65697	2017	4052083	2001-08-08	2001-08-08 00:00:00	2001-08-08	5001	0	\N	0	0	\N	\N	0	134154	0	23426006	4052083		
162525	4986	4024958	1959-04-20	1959-04-20 00:00:00	1959-04-20	5001	0	\N	0	0	\N	\N	0	331650	0	117015009	4024958		
37704	3477	40769189	1986-04-02	1986-04-02 00:00:00	1986-04-02	5001	0	\N	0	0	\N	\N	0	230714	0	66529-9	40769189		
16242	1480	3006322	1969-03-08	1969-03-08 00:00:00	1969-03-08	5001	0	\N	0	0	\N	\N	0	98752	0	8331-1	3006322		
13432	1272	3015076	1996-03-22	1996-03-22 00:00:00	1996-03-22	5001	0	\N	0	0	\N	\N	0	83928	0	6248-9	3015076		
56927	5222	3011505	2005-02-17	2005-02-17 00:00:00	2005-02-17	5001	0	\N	0	0	\N	\N	0	347425	0	19926-5	3011505		
11847	1131	3006322	1991-09-21	1991-09-21 00:00:00	1991-09-21	5001	0	\N	0	0	\N	\N	0	74445	0	8331-1	3006322		
20470	1879	3006322	2019-04-24	2019-04-24 00:00:00	2019-04-24	5001	0	\N	0	0	\N	\N	0	125403	0	8331-1	3006322		
38988	3604	3014599	1997-05-09	1997-05-09 00:00:00	1997-05-09	5001	0	\N	0	0	\N	\N	0	239521	0	6106-9	3014599		
11719	370	4024958	1969-02-18	1969-02-18 00:00:00	1969-02-18	5001	0	\N	0	0	\N	\N	0	24588	0	117015009	4024958		
142147	4374	4052083	1976-08-20	1976-08-20 00:00:00	1976-08-20	5001	0	\N	0	0	\N	\N	0	290573	0	23426006	4052083		
68232	2088	4133840	1984-06-26	1984-06-26 00:00:00	1984-06-26	5001	0	\N	0	0	\N	\N	0	139285	0	127783003	4133840		
16928	1538	3006451	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	103037	0	6273-7	3006451		
28344	2620	3006322	1992-08-01	1992-08-01 00:00:00	1992-08-01	5001	0	\N	0	0	\N	\N	0	173302	0	8331-1	3006322		
5217	502	3006322	1960-11-01	1960-11-01 00:00:00	1960-11-01	5001	0	\N	0	0	\N	\N	0	33611	0	8331-1	3006322		
8761	843	3000876	1983-05-08	1983-05-08 00:00:00	1983-05-08	5001	0	\N	0	0	\N	\N	0	55804	0	6082-2	3000876		
144256	4433	4024958	2019-03-19	2019-03-19 00:00:00	2019-03-19	5001	0	\N	0	0	\N	\N	0	294647	0	117015009	4024958		
27150	2518	3011505	2003-08-22	2003-08-22 00:00:00	2003-08-22	5001	0	\N	0	0	\N	\N	0	166567	0	19926-5	3011505		
31570	2891	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	192356	0	6844-5	3020655		
43236	3993	3006322	2004-02-07	2004-02-07 00:00:00	2004-02-07	5001	0	\N	0	0	\N	\N	0	265471	0	8331-1	3006322		
42982	3973	3006322	1987-12-13	1987-12-13 00:00:00	1987-12-13	5001	0	\N	0	0	\N	\N	0	264178	0	8331-1	3006322		
22388	2053	3051031	1964-09-22	1964-09-22 00:00:00	1964-09-22	5001	0	\N	0	0	\N	\N	0	136505	0	46240-8	3051031		
6173	578	40766240	2010-07-19	2010-07-19 00:00:00	2010-07-19	5001	0	\N	0	0	\N	\N	0	38271	0	63513-6	40766240		
51112	4668	3006322	1989-03-25	1989-03-25 00:00:00	1989-03-25	5001	0	\N	0	0	\N	\N	0	311079	0	8331-1	3006322		
1220	97	3011505	2008-06-30	2008-06-30 00:00:00	2008-06-30	5001	0	\N	0	0	\N	\N	0	6604	0	19926-5	3011505		
17678	1609	3006322	1994-04-27	1994-04-27 00:00:00	1994-04-27	5001	0	\N	0	0	\N	\N	0	108111	0	8331-1	3006322		
560	32	3006322	1998-04-12	1998-04-12 00:00:00	1998-04-12	5001	0	\N	0	0	\N	\N	0	2246	0	8331-1	3006322		
51089	1550	4133840	2011-12-24	2011-12-24 00:00:00	2011-12-24	5001	0	\N	0	0	\N	\N	0	103793	0	127783003	4133840		
111161	3434	4024958	1964-01-19	1964-01-19 00:00:00	1964-01-19	5001	0	\N	0	0	\N	\N	0	227694	0	117015009	4024958		
53607	4924	3036780	1990-12-19	1990-12-19 00:00:00	1990-12-19	5001	0	\N	0	0	\N	\N	0	327151	0	6095-4	3036780		
17336	1576	3006322	2003-04-15	2003-04-15 00:00:00	2003-04-15	5001	0	\N	0	0	\N	\N	0	105819	0	8331-1	3006322		
57581	5285	40758406	1991-02-12	1991-02-12 00:00:00	1991-02-12	5001	0	\N	0	0	\N	\N	0	351699	0	55277-8	40758406		
154536	4739	4024958	1960-12-06	1960-12-06 00:00:00	1960-12-06	5001	0	\N	0	0	\N	\N	0	315685	0	117015009	4024958		
83118	2566	4024958	2002-02-17	2002-02-17 00:00:00	2002-02-17	5001	0	\N	0	0	\N	\N	0	169998	0	117015009	4024958		
47676	4374	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	290564	0	6095-4	3036780		
30855	2827	3006322	1946-12-20	1946-12-20 00:00:00	1946-12-20	5001	0	\N	0	0	\N	\N	0	187443	0	8331-1	3006322		
20905	1926	3006322	1987-07-23	1987-07-23 00:00:00	1987-07-23	5001	0	\N	0	0	\N	\N	0	128233	0	8331-1	3006322		
4089	406	3012494	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	26726	0	6206-7	3012494		
80206	2469	4024958	1990-05-24	1990-05-24 00:00:00	1990-05-24	5001	0	\N	0	0	\N	\N	0	163726	0	117015009	4024958		
27012	2503	3020655	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	165689	0	6844-5	3020655		
122960	3790	4024958	2004-08-03	2004-08-03 00:00:00	2004-08-03	5001	0	\N	0	0	\N	\N	0	252022	0	117015009	4024958		
45054	1384	4024958	1994-11-22	1994-11-22 00:00:00	1994-11-22	5001	0	\N	0	0	\N	\N	0	91767	0	117015009	4024958		
34402	3133	40766240	2005-04-05	2005-04-05 00:00:00	2005-04-05	5001	0	\N	0	0	\N	\N	0	208525	0	63513-6	40766240		
168358	5168	4052083	2009-08-04	2009-08-04 00:00:00	2009-08-04	5001	0	\N	0	0	\N	\N	0	343610	0	23426006	4052083		
44410	4102	3006322	1973-11-29	1973-11-29 00:00:00	1973-11-29	5001	0	\N	0	0	\N	\N	0	272592	0	8331-1	3006322		
40835	3788	3006322	2004-03-06	2004-03-06 00:00:00	2004-03-06	5001	0	\N	0	0	\N	\N	0	251859	0	8331-1	3006322		
43192	1328	4133840	1999-08-19	1999-08-19 00:00:00	1999-08-19	5001	0	\N	0	0	\N	\N	0	88168	0	127783003	4133840		
52304	4804	3006734	1993-09-27	1993-09-27 00:00:00	1993-09-27	5001	0	\N	0	0	\N	\N	0	319586	0	6189-5	3006734		
14089	1317	3011505	2001-11-09	2001-11-09 00:00:00	2001-11-09	5001	0	\N	0	0	\N	\N	0	87313	0	19926-5	3011505		
41972	3884	3006322	1980-01-18	1980-01-18 00:00:00	1980-01-18	5001	0	\N	0	0	\N	\N	0	258146	0	8331-1	3006322		
30012	2765	3011505	2009-11-17	2009-11-17 00:00:00	2009-11-17	5001	0	\N	0	0	\N	\N	0	182916	0	19926-5	3011505		
15303	480	4052083	1984-03-03	1984-03-03 00:00:00	1984-03-03	5001	0	\N	0	0	\N	\N	0	31995	0	23426006	4052083		
41457	3860	3006322	2004-03-13	2004-03-13 00:00:00	2004-03-13	5001	0	\N	0	0	\N	\N	0	256320	0	8331-1	3006322		
14469	1352	3013682	1976-07-29	1976-07-29 00:00:00	1976-07-29	5001	0	\N	0	0	\N	\N	0	89606	0	3094-0	3013682		
161965	4971	4133840	1999-11-30	1999-11-30 00:00:00	1999-11-30	5001	0	\N	0	0	\N	\N	0	330579	0	127783003	4133840		
16418	1497	3006322	2014-08-10	2014-08-10 00:00:00	2014-08-10	5001	0	\N	0	0	\N	\N	0	99907	0	8331-1	3006322		
128601	3957	4133840	2010-09-30	2010-09-30 00:00:00	2010-09-30	5001	0	\N	0	0	\N	\N	0	263058	0	127783003	4133840		
49466	4506	46235214	2011-09-26	2011-09-26 00:00:00	2011-09-26	5001	0	\N	0	0	\N	\N	0	300165	0	76690-7	46235214		
52478	4822	40766240	1970-08-09	1970-08-09 00:00:00	1970-08-09	5001	0	\N	0	0	\N	\N	0	320710	0	63513-6	40766240		
48787	4462	3011505	2016-04-07	2016-04-07 00:00:00	2016-04-07	5001	0	\N	0	0	\N	\N	0	296925	0	19926-5	3011505		
19653	1793	3006322	1999-07-18	1999-07-18 00:00:00	1999-07-18	5001	0	\N	0	0	\N	\N	0	120267	0	8331-1	3006322		
123379	3803	4024958	2003-04-14	2003-04-14 00:00:00	2003-04-14	5001	0	\N	0	0	\N	\N	0	252766	0	117015009	4024958		
173817	5331	4024958	1977-03-30	1977-03-30 00:00:00	1977-03-30	5001	0	\N	0	0	\N	\N	0	354900	0	117015009	4024958		
37705	3477	40769184	1986-04-02	1986-04-02 00:00:00	1986-04-02	5001	0	\N	0	0	\N	\N	0	230714	0	66524-0	40769184		
16243	1480	3006322	1998-09-07	1998-09-07 00:00:00	1998-09-07	5001	0	\N	0	0	\N	\N	0	98743	0	8331-1	3006322		
13433	1272	3012494	1996-03-22	1996-03-22 00:00:00	1996-03-22	5001	0	\N	0	0	\N	\N	0	83928	0	6206-7	3012494		
56928	5222	3011505	2004-02-12	2004-02-12 00:00:00	2004-02-12	5001	0	\N	0	0	\N	\N	0	347466	0	19926-5	3011505		
11848	1131	3006322	1974-10-25	1974-10-25 00:00:00	1974-10-25	5001	0	\N	0	0	\N	\N	0	74452	0	8331-1	3006322		
20488	1882	3014599	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	125508	0	6106-9	3014599		
38989	3604	3001247	1997-05-09	1997-05-09 00:00:00	1997-05-09	5001	0	\N	0	0	\N	\N	0	239521	0	6085-5	3001247		
11723	370	4024958	1974-02-05	1974-02-05 00:00:00	1974-02-05	5001	0	\N	0	0	\N	\N	0	24636	0	117015009	4024958		
14864	1378	3011505	2015-11-10	2015-11-10 00:00:00	2015-11-10	5001	0	\N	0	0	\N	\N	0	91355	0	19926-5	3011505		
68234	2088	4052083	1909-09-18	1909-09-18 00:00:00	1909-09-18	5001	0	\N	0	0	\N	\N	0	139225	0	23426006	4052083		
16929	1538	3027231	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	103037	0	6276-0	3027231		
28345	2620	3006322	2001-11-25	2001-11-25 00:00:00	2001-11-25	5001	0	\N	0	0	\N	\N	0	173276	0	8331-1	3006322		
5218	502	3006322	2007-08-24	2007-08-24 00:00:00	2007-08-24	5001	0	\N	0	0	\N	\N	0	33586	0	8331-1	3006322		
8762	843	3006734	1983-05-08	1983-05-08 00:00:00	1983-05-08	5001	0	\N	0	0	\N	\N	0	55804	0	6189-5	3006734		
155566	4773	4024958	1987-01-28	1987-01-28 00:00:00	1987-01-28	5001	0	\N	0	0	\N	\N	0	317849	0	117015009	4024958		
27151	2518	3011505	2019-02-08	2019-02-08 00:00:00	2019-02-08	5001	0	\N	0	0	\N	\N	0	166528	0	19926-5	3011505		
31571	2891	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	192356	0	6106-9	3014599		
43237	3993	3006322	1966-03-23	1966-03-23 00:00:00	1966-03-23	5001	0	\N	0	0	\N	\N	0	265526	0	8331-1	3006322		
42983	3973	3006322	2007-07-25	2007-07-25 00:00:00	2007-07-25	5001	0	\N	0	0	\N	\N	0	264180	0	8331-1	3006322		
22389	2053	46235214	1964-09-22	1964-09-22 00:00:00	1964-09-22	5001	0	\N	0	0	\N	\N	0	136505	0	76690-7	46235214		
6174	578	46235214	2010-07-19	2010-07-19 00:00:00	2010-07-19	5001	0	\N	0	0	\N	\N	0	38271	0	76690-7	46235214		
51113	4668	3006322	1961-04-11	1961-04-11 00:00:00	1961-04-11	5001	0	\N	0	0	\N	\N	0	311104	0	8331-1	3006322		
1221	97	3006322	1943-09-19	1943-09-19 00:00:00	1943-09-19	5001	0	\N	0	0	\N	\N	0	6575	0	8331-1	3006322		
17679	1609	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	108150	0	6082-2	3000876		
561	32	3006322	1982-07-26	1982-07-26 00:00:00	1982-07-26	5001	0	\N	0	0	\N	\N	0	2259	0	8331-1	3006322		
51091	1550	4133840	2019-01-12	2019-01-12 00:00:00	2019-01-12	5001	0	\N	0	0	\N	\N	0	103791	0	127783003	4133840		
111163	3434	4024958	1961-08-16	1961-08-16 00:00:00	1961-08-16	5001	0	\N	0	0	\N	\N	0	227687	0	117015009	4024958		
53608	4924	3027231	1990-12-19	1990-12-19 00:00:00	1990-12-19	5001	0	\N	0	0	\N	\N	0	327151	0	6276-0	3027231		
17337	1576	3006322	1999-10-18	1999-10-18 00:00:00	1999-10-18	5001	0	\N	0	0	\N	\N	0	105795	0	8331-1	3006322		
57582	5285	40766240	1991-02-12	1991-02-12 00:00:00	1991-02-12	5001	0	\N	0	0	\N	\N	0	351699	0	63513-6	40766240		
154540	4739	4024958	1920-08-16	1920-08-16 00:00:00	1920-08-16	5001	0	\N	0	0	\N	\N	0	315681	0	117015009	4024958		
83166	2567	4024958	2018-07-09	2018-07-09 00:00:00	2018-07-09	5001	0	\N	0	0	\N	\N	0	170079	0	117015009	4024958		
47677	4374	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	290564	0	6158-0	3019406		
30856	2827	3006322	1934-10-14	1934-10-14 00:00:00	1934-10-14	5001	0	\N	0	0	\N	\N	0	187468	0	8331-1	3006322		
20906	1926	3006322	1978-07-02	1978-07-02 00:00:00	1978-07-02	5001	0	\N	0	0	\N	\N	0	128252	0	8331-1	3006322		
4090	406	3000876	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	26726	0	6082-2	3000876		
80214	2469	4052083	2017-02-07	2017-02-07 00:00:00	2017-02-07	5001	0	\N	0	0	\N	\N	0	163735	0	23426006	4052083		
27013	2503	3001488	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	165689	0	7258-7	3001488		
122964	3790	4024958	2001-02-05	2001-02-05 00:00:00	2001-02-05	5001	0	\N	0	0	\N	\N	0	251980	0	117015009	4024958		
45055	1384	4024958	1987-09-20	1987-09-20 00:00:00	1987-09-20	5001	0	\N	0	0	\N	\N	0	91765	0	117015009	4024958		
34403	3133	3051031	2005-04-05	2005-04-05 00:00:00	2005-04-05	5001	0	\N	0	0	\N	\N	0	208525	0	46240-8	3051031		
168361	5168	4052083	1973-05-17	1973-05-17 00:00:00	1973-05-17	5001	0	\N	0	0	\N	\N	0	343649	0	23426006	4052083		
44414	4105	3006322	1973-11-15	1973-11-15 00:00:00	1973-11-15	5001	0	\N	0	0	\N	\N	0	272759	0	8331-1	3006322		
40836	3788	3006322	1991-03-16	1991-03-16 00:00:00	1991-03-16	5001	0	\N	0	0	\N	\N	0	251819	0	8331-1	3006322		
43195	1328	4133840	2001-08-30	2001-08-30 00:00:00	2001-08-30	5001	0	\N	0	0	\N	\N	0	88169	0	127783003	4133840		
52305	4804	3020655	1993-09-27	1993-09-27 00:00:00	1993-09-27	5001	0	\N	0	0	\N	\N	0	319586	0	6844-5	3020655		
14090	1317	3011505	1997-07-11	1997-07-11 00:00:00	1997-07-11	5001	0	\N	0	0	\N	\N	0	87328	0	19926-5	3011505		
41973	3884	3001488	1975-04-23	1975-04-23 00:00:00	1975-04-23	5001	0	\N	0	0	\N	\N	0	258017	0	7258-7	3001488		
30013	2765	3006322	1956-07-26	1956-07-26 00:00:00	1956-07-26	5001	0	\N	0	0	\N	\N	0	182875	0	8331-1	3006322		
15319	480	4024958	1980-02-29	1980-02-29 00:00:00	1980-02-29	5001	0	\N	0	0	\N	\N	0	32070	0	117015009	4024958		
41479	3862	3006322	1976-05-31	1976-05-31 00:00:00	1976-05-31	5001	0	\N	0	0	\N	\N	0	256425	0	8331-1	3006322		
14470	1352	3020630	1976-07-29	1976-07-29 00:00:00	1976-07-29	5001	0	\N	0	0	\N	\N	0	89606	0	2885-2	3020630		
161970	4971	4133840	2007-01-09	2007-01-09 00:00:00	2007-01-09	5001	0	\N	0	0	\N	\N	0	330506	0	127783003	4133840		
16419	1497	3006322	1978-06-08	1978-06-08 00:00:00	1978-06-08	5001	0	\N	0	0	\N	\N	0	99847	0	8331-1	3006322		
25665	800	4024958	1979-02-05	1979-02-05 00:00:00	1979-02-05	5001	0	\N	0	0	\N	\N	0	53119	0	117015009	4024958		
49467	4506	3051031	1970-06-18	1970-06-18 00:00:00	1970-06-18	5001	0	\N	0	0	\N	\N	0	300170	0	46240-8	3051031		
52479	4822	40758406	1970-08-09	1970-08-09 00:00:00	1970-08-09	5001	0	\N	0	0	\N	\N	0	320710	0	55277-8	40758406		
48788	4462	3011505	2018-04-19	2018-04-19 00:00:00	2018-04-19	5001	0	\N	0	0	\N	\N	0	296926	0	19926-5	3011505		
19654	1793	3049273	1988-06-01	1988-06-01 00:00:00	1988-06-01	5001	0	\N	0	0	\N	\N	0	120170	0	38265-5	3049273		
123381	3803	4052083	1966-07-12	1966-07-12 00:00:00	1966-07-12	5001	0	\N	0	0	\N	\N	0	252803	0	23426006	4052083		
48082	1467	4024958	1966-09-15	1966-09-15 00:00:00	1966-09-15	5001	0	\N	0	0	\N	\N	0	97716	0	117015009	4024958		
37706	3477	40769194	1986-04-02	1986-04-02 00:00:00	1986-04-02	5001	0	\N	0	0	\N	\N	0	230714	0	66534-9	40769194		
16245	1482	3011505	2018-11-03	2018-11-03 00:00:00	2018-11-03	5001	0	\N	0	0	\N	\N	0	98893	0	19926-5	3011505		
13434	1272	3006451	1996-03-22	1996-03-22 00:00:00	1996-03-22	5001	0	\N	0	0	\N	\N	0	83928	0	6273-7	3006451		
56929	5222	3011505	1999-01-14	1999-01-14 00:00:00	1999-01-14	5001	0	\N	0	0	\N	\N	0	347528	0	19926-5	3011505		
11849	1132	3006322	1990-12-02	1990-12-02 00:00:00	1990-12-02	5001	0	\N	0	0	\N	\N	0	74536	0	8331-1	3006322		
20489	1882	3006734	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	125508	0	6189-5	3006734		
38990	3604	3023430	1997-05-09	1997-05-09 00:00:00	1997-05-09	5001	0	\N	0	0	\N	\N	0	239521	0	6833-8	3023430		
11730	370	4052083	2004-09-25	2004-09-25 00:00:00	2004-09-25	5001	0	\N	0	0	\N	\N	0	24632	0	23426006	4052083		
14865	1378	3011505	2009-10-06	2009-10-06 00:00:00	2009-10-06	5001	0	\N	0	0	\N	\N	0	91352	0	19926-5	3011505		
68236	2088	4133840	2016-07-26	2016-07-26 00:00:00	2016-07-26	5001	0	\N	0	0	\N	\N	0	139292	0	127783003	4133840		
16930	1538	3021226	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	103037	0	6246-3	3021226		
28346	2620	3006322	1966-02-03	1966-02-03 00:00:00	1966-02-03	5001	0	\N	0	0	\N	\N	0	173275	0	8331-1	3006322		
5219	502	3006322	2015-08-06	2015-08-06 00:00:00	2015-08-06	5001	0	\N	0	0	\N	\N	0	33612	0	8331-1	3006322		
8763	843	3001247	1983-05-08	1983-05-08 00:00:00	1983-05-08	5001	0	\N	0	0	\N	\N	0	55804	0	6085-5	3001247		
155574	4773	4024958	2002-11-01	2002-11-01 00:00:00	2002-11-01	5001	0	\N	0	0	\N	\N	0	317851	0	117015009	4024958		
27152	2518	3011505	1980-11-21	1980-11-21 00:00:00	1980-11-21	5001	0	\N	0	0	\N	\N	0	166547	0	19926-5	3011505		
31572	2891	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	192356	0	6273-7	3006451		
43238	3993	3006322	1988-04-17	1988-04-17 00:00:00	1988-04-17	5001	0	\N	0	0	\N	\N	0	265469	0	8331-1	3006322		
42991	3976	40766240	1964-10-14	1964-10-14 00:00:00	1964-10-14	5001	0	\N	0	0	\N	\N	0	264337	0	63513-6	40766240		
22390	2053	40766240	1964-09-22	1964-09-22 00:00:00	1964-09-22	5001	0	\N	0	0	\N	\N	0	136505	0	63513-6	40766240		
6175	578	3051031	2011-01-15	2011-01-15 00:00:00	2011-01-15	5001	0	\N	0	0	\N	\N	0	38197	0	46240-8	3051031		
51130	4670	3006322	1977-03-21	1977-03-21 00:00:00	1977-03-21	5001	0	\N	0	0	\N	\N	0	311193	0	8331-1	3006322		
1222	97	3011505	1996-08-05	1996-08-05 00:00:00	1996-08-05	5001	0	\N	0	0	\N	\N	0	6661	0	19926-5	3011505		
17680	1609	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	108150	0	6844-5	3020655		
564	32	3006322	1987-03-31	1987-03-31 00:00:00	1987-03-31	5001	0	\N	0	0	\N	\N	0	2198	0	8331-1	3006322		
51093	1551	4052083	1996-12-05	1996-12-05 00:00:00	1996-12-05	5001	0	\N	0	0	\N	\N	0	103868	0	23426006	4052083		
111165	3434	4024958	1994-07-30	1994-07-30 00:00:00	1994-07-30	5001	0	\N	0	0	\N	\N	0	227746	0	117015009	4024958		
53609	4924	3006451	1990-12-19	1990-12-19 00:00:00	1990-12-19	5001	0	\N	0	0	\N	\N	0	327151	0	6273-7	3006451		
17338	1577	3006322	1922-10-16	1922-10-16 00:00:00	1922-10-16	5001	0	\N	0	0	\N	\N	0	105858	0	8331-1	3006322		
57583	5285	40758406	1991-08-11	1991-08-11 00:00:00	1991-08-11	5001	0	\N	0	0	\N	\N	0	351700	0	55277-8	40758406		
154567	4739	4052083	1938-11-26	1938-11-26 00:00:00	1938-11-26	5001	0	\N	0	0	\N	\N	0	315683	0	23426006	4052083		
83170	2567	4052083	1977-11-14	1977-11-14 00:00:00	1977-11-14	5001	0	\N	0	0	\N	\N	0	170076	0	23426006	4052083		
47678	4374	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	290564	0	6085-5	3001247		
30858	2827	40758406	1921-07-01	1921-07-01 00:00:00	1921-07-01	5001	0	\N	0	0	\N	\N	0	187505	0	55277-8	40758406		
20908	1928	3006322	1979-04-27	1979-04-27 00:00:00	1979-04-27	5001	0	\N	0	0	\N	\N	0	128346	0	8331-1	3006322		
4091	406	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	26758	0	7258-7	3001488		
80222	2470	4024958	1981-08-15	1981-08-15 00:00:00	1981-08-15	5001	0	\N	0	0	\N	\N	0	163763	0	117015009	4024958		
27014	2503	3006322	2003-11-09	2003-11-09 00:00:00	2003-11-09	5001	0	\N	0	0	\N	\N	0	165652	0	8331-1	3006322		
122972	3790	4052083	1981-03-29	1981-03-29 00:00:00	1981-03-29	5001	0	\N	0	0	\N	\N	0	252021	0	23426006	4052083		
45071	1384	4024958	1995-03-04	1995-03-04 00:00:00	1995-03-04	5001	0	\N	0	0	\N	\N	0	91786	0	117015009	4024958		
34404	3133	3006322	1995-07-14	1995-07-14 00:00:00	1995-07-14	5001	0	\N	0	0	\N	\N	0	208468	0	8331-1	3006322		
168363	5168	4024958	2014-02-20	2014-02-20 00:00:00	2014-02-20	5001	0	\N	0	0	\N	\N	0	343611	0	117015009	4024958		
44415	4105	3006322	1969-01-28	1969-01-28 00:00:00	1969-01-28	5001	0	\N	0	0	\N	\N	0	272697	0	8331-1	3006322		
40837	3788	3006322	1979-01-19	1979-01-19 00:00:00	1979-01-19	5001	0	\N	0	0	\N	\N	0	251818	0	8331-1	3006322		
43200	1328	4024958	2010-04-08	2010-04-08 00:00:00	2010-04-08	5001	0	\N	0	0	\N	\N	0	88224	0	117015009	4024958		
52306	4804	3023430	1993-09-27	1993-09-27 00:00:00	1993-09-27	5001	0	\N	0	0	\N	\N	0	319586	0	6833-8	3023430		
14091	1317	3011505	2010-12-31	2010-12-31 00:00:00	2010-12-31	5001	0	\N	0	0	\N	\N	0	87301	0	19926-5	3011505		
41974	3884	3006734	1975-04-23	1975-04-23 00:00:00	1975-04-23	5001	0	\N	0	0	\N	\N	0	258017	0	6189-5	3006734		
30014	2765	3006322	2013-07-08	2013-07-08 00:00:00	2013-07-08	5001	0	\N	0	0	\N	\N	0	182988	0	8331-1	3006322		
15326	480	4052083	2013-09-12	2013-09-12 00:00:00	2013-09-12	5001	0	\N	0	0	\N	\N	0	31984	0	23426006	4052083		
41480	3862	3006322	1998-04-20	1998-04-20 00:00:00	1998-04-20	5001	0	\N	0	0	\N	\N	0	256394	0	8331-1	3006322		
14471	1352	3007461	1976-07-29	1976-07-29 00:00:00	1976-07-29	5001	0	\N	0	0	\N	\N	0	89606	0	26515-7	3007461		
161978	4971	4133840	2013-02-12	2013-02-12 00:00:00	2013-02-12	5001	0	\N	0	0	\N	\N	0	330582	0	127783003	4133840		
16420	1497	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	99807	0	6246-3	3021226		
25677	800	4024958	1965-02-04	1965-02-04 00:00:00	1965-02-04	5001	0	\N	0	0	\N	\N	0	53106	0	117015009	4024958		
49468	4506	40758406	1970-06-18	1970-06-18 00:00:00	1970-06-18	5001	0	\N	0	0	\N	\N	0	300170	0	55277-8	40758406		
52480	4822	3051031	1970-08-09	1970-08-09 00:00:00	1970-08-09	5001	0	\N	0	0	\N	\N	0	320710	0	46240-8	3051031		
48789	4462	3011505	2001-04-05	2001-04-05 00:00:00	2001-04-05	5001	0	\N	0	0	\N	\N	0	296878	0	19926-5	3011505		
19655	1794	3006322	1986-12-15	1986-12-15 00:00:00	1986-12-15	5001	0	\N	0	0	\N	\N	0	120307	0	8331-1	3006322		
123384	3803	4052083	1983-08-29	1983-08-29 00:00:00	1983-08-29	5001	0	\N	0	0	\N	\N	0	252764	0	23426006	4052083		
48088	1467	4024958	1957-11-20	1957-11-20 00:00:00	1957-11-20	5001	0	\N	0	0	\N	\N	0	97745	0	117015009	4024958		
37707	3477	3006322	1988-03-18	1988-03-18 00:00:00	1988-03-18	5001	0	\N	0	0	\N	\N	0	230632	0	8331-1	3006322		
16246	1482	3001488	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	98888	0	7258-7	3001488		
13435	1272	3001247	1996-03-22	1996-03-22 00:00:00	1996-03-22	5001	0	\N	0	0	\N	\N	0	83928	0	6085-5	3001247		
56930	5222	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	347449	0	6206-7	3012494		
11850	1132	3006322	1997-02-09	1997-02-09 00:00:00	1997-02-09	5001	0	\N	0	0	\N	\N	0	74508	0	8331-1	3006322		
20490	1882	3021226	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	125508	0	6246-3	3021226		
38991	3604	3036780	1997-05-09	1997-05-09 00:00:00	1997-05-09	5001	0	\N	0	0	\N	\N	0	239521	0	6095-4	3036780		
11737	370	4024958	1965-12-21	1965-12-21 00:00:00	1965-12-21	5001	0	\N	0	0	\N	\N	0	24594	0	117015009	4024958		
14866	1378	3011505	2016-11-15	2016-11-15 00:00:00	2016-11-15	5001	0	\N	0	0	\N	\N	0	91430	0	19926-5	3011505		
68242	2088	4133840	1983-06-21	1983-06-21 00:00:00	1983-06-21	5001	0	\N	0	0	\N	\N	0	139170	0	127783003	4133840		
16931	1538	3012494	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	103037	0	6206-7	3012494		
28347	2621	3006322	1957-01-24	1957-01-24 00:00:00	1957-01-24	5001	0	\N	0	0	\N	\N	0	173331	0	8331-1	3006322		
5220	502	3049273	2000-10-13	2000-10-13 00:00:00	2000-10-13	5001	0	\N	0	0	\N	\N	0	33650	0	38265-5	3049273		
8764	843	3020655	1983-05-08	1983-05-08 00:00:00	1983-05-08	5001	0	\N	0	0	\N	\N	0	55804	0	6844-5	3020655		
155575	4773	4024958	1967-07-12	1967-07-12 00:00:00	1967-07-12	5001	0	\N	0	0	\N	\N	0	317846	0	117015009	4024958		
27153	2518	3011505	1989-12-01	1989-12-01 00:00:00	1989-12-01	5001	0	\N	0	0	\N	\N	0	166516	0	19926-5	3011505		
31573	2891	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	192356	0	6075-6	3005136		
43239	3993	3006322	1965-04-15	1965-04-15 00:00:00	1965-04-15	5001	0	\N	0	0	\N	\N	0	265482	0	8331-1	3006322		
42992	3976	46235214	1964-10-14	1964-10-14 00:00:00	1964-10-14	5001	0	\N	0	0	\N	\N	0	264337	0	76690-7	46235214		
22391	2053	3006322	1983-12-04	1983-12-04 00:00:00	1983-12-04	5001	0	\N	0	0	\N	\N	0	136513	0	8331-1	3006322		
6177	578	40758406	2011-01-15	2011-01-15 00:00:00	2011-01-15	5001	0	\N	0	0	\N	\N	0	38197	0	55277-8	40758406		
51131	4670	3006322	1961-06-24	1961-06-24 00:00:00	1961-06-24	5001	0	\N	0	0	\N	\N	0	311191	0	8331-1	3006322		
1223	97	3008598	2008-07-02	2008-07-02 00:00:00	2008-07-02	5001	0	\N	0	0	\N	\N	0	6587	0	3024-7	3008598		
17681	1609	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	108150	0	6106-9	3014599		
570	35	3006322	2011-02-21	2011-02-21 00:00:00	2011-02-21	5001	0	\N	0	0	\N	\N	0	2408	0	8331-1	3006322		
51109	1551	4052083	1958-07-12	1958-07-12 00:00:00	1958-07-12	5001	0	\N	0	0	\N	\N	0	103851	0	23426006	4052083		
111182	3434	4024958	1989-09-29	1989-09-29 00:00:00	1989-09-29	5001	0	\N	0	0	\N	\N	0	227691	0	117015009	4024958		
53610	4924	3000876	1990-12-19	1990-12-19 00:00:00	1990-12-19	5001	0	\N	0	0	\N	\N	0	327151	0	6082-2	3000876		
17339	1577	3006322	1965-04-19	1965-04-19 00:00:00	1965-04-19	5001	0	\N	0	0	\N	\N	0	105860	0	8331-1	3006322		
57584	5285	3051031	1991-08-11	1991-08-11 00:00:00	1991-08-11	5001	0	\N	0	0	\N	\N	0	351700	0	46240-8	3051031		
154571	4739	4024958	1937-09-18	1937-09-18 00:00:00	1937-09-18	5001	0	\N	0	0	\N	\N	0	315700	0	117015009	4024958		
83175	2567	4052083	1986-10-24	1986-10-24 00:00:00	1986-10-24	5001	0	\N	0	0	\N	\N	0	170082	0	23426006	4052083		
47679	4374	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	290564	0	6082-2	3000876		
30860	2827	3051031	1921-07-01	1921-07-01 00:00:00	1921-07-01	5001	0	\N	0	0	\N	\N	0	187505	0	46240-8	3051031		
20909	1928	3006322	2011-06-03	2011-06-03 00:00:00	2011-06-03	5001	0	\N	0	0	\N	\N	0	128340	0	8331-1	3006322		
4092	406	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	26758	0	6158-0	3019406		
80231	2470	4052083	2000-01-11	2000-01-11 00:00:00	2000-01-11	5001	0	\N	0	0	\N	\N	0	163819	0	23426006	4052083		
27015	2503	3006322	2009-06-01	2009-06-01 00:00:00	2009-06-01	5001	0	\N	0	0	\N	\N	0	165653	0	8331-1	3006322		
96485	2957	4052083	1954-02-15	1954-02-15 00:00:00	1954-02-15	5001	0	\N	0	0	\N	\N	0	197305	0	23426006	4052083		
45079	1385	4024958	1991-06-30	1991-06-30 00:00:00	1991-06-30	5001	0	\N	0	0	\N	\N	0	91825	0	117015009	4024958		
34405	3133	3006322	1999-06-09	1999-06-09 00:00:00	1999-06-09	5001	0	\N	0	0	\N	\N	0	208521	0	8331-1	3006322		
168364	5168	4024958	1999-02-16	1999-02-16 00:00:00	1999-02-16	5001	0	\N	0	0	\N	\N	0	343637	0	117015009	4024958		
44416	4105	3006322	2010-02-24	2010-02-24 00:00:00	2010-02-24	5001	0	\N	0	0	\N	\N	0	272731	0	8331-1	3006322		
40838	3788	3006322	1974-03-22	1974-03-22 00:00:00	1974-03-22	5001	0	\N	0	0	\N	\N	0	251816	0	8331-1	3006322		
43204	1328	4133840	1985-12-12	1985-12-12 00:00:00	1985-12-12	5001	0	\N	0	0	\N	\N	0	88221	0	127783003	4133840		
52307	4804	3027231	1993-09-27	1993-09-27 00:00:00	1993-09-27	5001	0	\N	0	0	\N	\N	0	319586	0	6276-0	3027231		
14092	1317	3011505	2003-11-21	2003-11-21 00:00:00	2003-11-21	5001	0	\N	0	0	\N	\N	0	87314	0	19926-5	3011505		
41975	3884	3021226	1975-04-23	1975-04-23 00:00:00	1975-04-23	5001	0	\N	0	0	\N	\N	0	258017	0	6246-3	3021226		
30015	2765	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	182879	0	6833-8	3023430		
15327	480	4052083	2010-05-02	2010-05-02 00:00:00	2010-05-02	5001	0	\N	0	0	\N	\N	0	32033	0	23426006	4052083		
41481	3862	3006322	1973-07-03	1973-07-03 00:00:00	1973-07-03	5001	0	\N	0	0	\N	\N	0	256392	0	8331-1	3006322		
14472	1352	3045716	1976-07-29	1976-07-29 00:00:00	1976-07-29	5001	0	\N	0	0	\N	\N	0	89606	0	33037-3	3045716		
161979	4971	4133840	2018-03-13	2018-03-13 00:00:00	2018-03-13	5001	0	\N	0	0	\N	\N	0	330533	0	127783003	4133840		
16421	1497	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	99807	0	6075-6	3005136		
25682	800	4024958	2013-03-15	2013-03-15 00:00:00	2013-03-15	5001	0	\N	0	0	\N	\N	0	53132	0	117015009	4024958		
49470	4506	46235214	1970-06-18	1970-06-18 00:00:00	1970-06-18	5001	0	\N	0	0	\N	\N	0	300170	0	76690-7	46235214		
52482	4822	46235214	1970-08-09	1970-08-09 00:00:00	1970-08-09	5001	0	\N	0	0	\N	\N	0	320710	0	76690-7	46235214		
48790	4462	3011505	2011-03-10	2011-03-10 00:00:00	2011-03-10	5001	0	\N	0	0	\N	\N	0	296909	0	19926-5	3011505		
19656	1794	3006322	2000-08-16	2000-08-16 00:00:00	2000-08-16	5001	0	\N	0	0	\N	\N	0	120308	0	8331-1	3006322		
123399	3803	4024958	1973-05-09	1973-05-09 00:00:00	1973-05-09	5001	0	\N	0	0	\N	\N	0	252768	0	117015009	4024958		
48089	1467	4024958	1953-04-03	1953-04-03 00:00:00	1953-04-03	5001	0	\N	0	0	\N	\N	0	97714	0	117015009	4024958		
37708	3477	3006322	1976-04-22	1976-04-22 00:00:00	1976-04-22	5001	0	\N	0	0	\N	\N	0	230689	0	8331-1	3006322		
16247	1482	3027231	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	98888	0	6276-0	3027231		
13436	1272	3006734	1996-03-22	1996-03-22 00:00:00	1996-03-22	5001	0	\N	0	0	\N	\N	0	83928	0	6189-5	3006734		
56931	5222	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	347449	0	6075-6	3005136		
11851	1132	3006322	1959-05-05	1959-05-05 00:00:00	1959-05-05	5001	0	\N	0	0	\N	\N	0	74505	0	8331-1	3006322		
20491	1882	3027231	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	125508	0	6276-0	3027231		
38992	3604	3020655	1997-05-09	1997-05-09 00:00:00	1997-05-09	5001	0	\N	0	0	\N	\N	0	239521	0	6844-5	3020655		
11738	370	4024958	1977-04-19	1977-04-19 00:00:00	1977-04-19	5001	0	\N	0	0	\N	\N	0	24637	0	117015009	4024958		
14867	1378	40769184	1974-06-26	1974-06-26 00:00:00	1974-06-26	5001	0	\N	0	0	\N	\N	0	91434	0	66524-0	40769184		
68245	2088	4133840	2002-06-18	2002-06-18 00:00:00	2002-06-18	5001	0	\N	0	0	\N	\N	0	139173	0	127783003	4133840		
16932	1538	3000876	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	103037	0	6082-2	3000876		
28348	2621	3006322	1994-11-17	1994-11-17 00:00:00	1994-11-17	5001	0	\N	0	0	\N	\N	0	173340	0	8331-1	3006322		
5239	505	3001247	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	33756	0	6085-5	3001247		
8765	843	3023430	1983-05-08	1983-05-08 00:00:00	1983-05-08	5001	0	\N	0	0	\N	\N	0	55804	0	6833-8	3023430		
155586	4773	4052083	1977-12-26	1977-12-26 00:00:00	1977-12-26	5001	0	\N	0	0	\N	\N	0	317904	0	23426006	4052083		
27154	2518	3011505	1986-11-28	1986-11-28 00:00:00	1986-11-28	5001	0	\N	0	0	\N	\N	0	166515	0	19926-5	3011505		
31574	2891	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	192356	0	6095-4	3036780		
43240	3993	3006322	1980-10-15	1980-10-15 00:00:00	1980-10-15	5001	0	\N	0	0	\N	\N	0	265483	0	8331-1	3006322		
42993	3976	40758406	1964-10-14	1964-10-14 00:00:00	1964-10-14	5001	0	\N	0	0	\N	\N	0	264337	0	55277-8	40758406		
22392	2053	40758406	1964-02-25	1964-02-25 00:00:00	1964-02-25	5001	0	\N	0	0	\N	\N	0	136530	0	55277-8	40758406		
6179	578	40766240	2011-01-15	2011-01-15 00:00:00	2011-01-15	5001	0	\N	0	0	\N	\N	0	38197	0	63513-6	40766240		
51132	4670	3006322	1963-11-21	1963-11-21 00:00:00	1963-11-21	5001	0	\N	0	0	\N	\N	0	311160	0	8331-1	3006322		
1224	97	3009201	2008-07-02	2008-07-02 00:00:00	2008-07-02	5001	0	\N	0	0	\N	\N	0	6587	0	3016-3	3009201		
17682	1609	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	108150	0	6246-3	3021226		
571	35	3006322	1992-04-15	1992-04-15 00:00:00	1992-04-15	5001	0	\N	0	0	\N	\N	0	2429	0	8331-1	3006322		
42146	3895	3006322	1946-02-19	1946-02-19 00:00:00	1946-02-19	5001	0	\N	0	0	\N	\N	0	259085	0	8331-1	3006322		
131650	4055	4052083	2013-12-23	2013-12-23 00:00:00	2013-12-23	5001	0	\N	0	0	\N	\N	0	269558	0	23426006	4052083		
53611	4924	3001247	1990-12-19	1990-12-19 00:00:00	1990-12-19	5001	0	\N	0	0	\N	\N	0	327151	0	6085-5	3001247		
17340	1577	3049273	1991-01-16	1991-01-16 00:00:00	1991-01-16	5001	0	\N	0	0	\N	\N	0	105930	0	38265-5	3049273		
57585	5285	46235214	1991-08-11	1991-08-11 00:00:00	1991-08-11	5001	0	\N	0	0	\N	\N	0	351700	0	76690-7	46235214		
112300	3464	4024958	1983-08-30	1983-08-30 00:00:00	1983-08-30	5001	0	\N	0	0	\N	\N	0	229903	0	117015009	4024958		
83178	2567	4052083	2011-10-21	2011-10-21 00:00:00	2011-10-21	5001	0	\N	0	0	\N	\N	0	170084	0	23426006	4052083		
47680	4374	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	290564	0	6248-9	3015076		
30861	2827	46235214	1921-07-01	1921-07-01 00:00:00	1921-07-01	5001	0	\N	0	0	\N	\N	0	187505	0	76690-7	46235214		
20910	1928	3006322	1998-09-26	1998-09-26 00:00:00	1998-09-26	5001	0	\N	0	0	\N	\N	0	128312	0	8331-1	3006322		
4093	406	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	26758	0	6075-6	3005136		
80239	2470	4024958	1971-10-12	1971-10-12 00:00:00	1971-10-12	5001	0	\N	0	0	\N	\N	0	163762	0	117015009	4024958		
27016	2503	3006322	1985-09-17	1985-09-17 00:00:00	1985-09-17	5001	0	\N	0	0	\N	\N	0	165711	0	8331-1	3006322		
96491	2957	4052083	1981-11-30	1981-11-30 00:00:00	1981-11-30	5001	0	\N	0	0	\N	\N	0	197308	0	23426006	4052083		
45081	1385	4024958	1970-07-21	1970-07-21 00:00:00	1970-07-21	5001	0	\N	0	0	\N	\N	0	91864	0	117015009	4024958		
34406	3133	3006322	1960-07-03	1960-07-03 00:00:00	1960-07-03	5001	0	\N	0	0	\N	\N	0	208442	0	8331-1	3006322		
168372	5168	4024958	1975-10-06	1975-10-06 00:00:00	1975-10-06	5001	0	\N	0	0	\N	\N	0	343647	0	117015009	4024958		
44417	4105	3006322	2009-05-18	2009-05-18 00:00:00	2009-05-18	5001	0	\N	0	0	\N	\N	0	272760	0	8331-1	3006322		
40839	3788	3006322	1965-02-10	1965-02-10 00:00:00	1965-02-10	5001	0	\N	0	0	\N	\N	0	251840	0	8331-1	3006322		
43207	1328	4133840	2005-09-22	2005-09-22 00:00:00	2005-09-22	5001	0	\N	0	0	\N	\N	0	88171	0	127783003	4133840		
52308	4804	3005136	1993-09-27	1993-09-27 00:00:00	1993-09-27	5001	0	\N	0	0	\N	\N	0	319586	0	6075-6	3005136		
14093	1317	3006322	2001-09-10	2001-09-10 00:00:00	2001-09-10	5001	0	\N	0	0	\N	\N	0	87247	0	8331-1	3006322		
41976	3884	3005136	1975-04-23	1975-04-23 00:00:00	1975-04-23	5001	0	\N	0	0	\N	\N	0	258017	0	6075-6	3005136		
30016	2765	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	182879	0	6082-2	3000876		
15335	480	4052083	1994-11-07	1994-11-07 00:00:00	1994-11-07	5001	0	\N	0	0	\N	\N	0	32027	0	23426006	4052083		
41482	3864	3006322	1998-11-16	1998-11-16 00:00:00	1998-11-16	5001	0	\N	0	0	\N	\N	0	256478	0	8331-1	3006322		
14473	1352	3023103	1976-07-29	1976-07-29 00:00:00	1976-07-29	5001	0	\N	0	0	\N	\N	0	89606	0	2823-3	3023103		
161982	4971	4133840	2003-12-23	2003-12-23 00:00:00	2003-12-23	5001	0	\N	0	0	\N	\N	0	330575	0	127783003	4133840		
16422	1497	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	99807	0	6248-9	3015076		
47121	4343	3006322	1979-02-16	1979-02-16 00:00:00	1979-02-16	5001	0	\N	0	0	\N	\N	0	287991	0	8331-1	3006322		
49472	4506	40766240	1970-06-18	1970-06-18 00:00:00	1970-06-18	5001	0	\N	0	0	\N	\N	0	300170	0	63513-6	40766240		
52483	4822	40766240	1970-10-08	1970-10-08 00:00:00	1970-10-08	5001	0	\N	0	0	\N	\N	0	320744	0	63513-6	40766240		
48791	4462	3011505	2003-04-10	2003-04-10 00:00:00	2003-04-10	5001	0	\N	0	0	\N	\N	0	296921	0	19926-5	3011505		
19659	1796	3006322	2014-11-01	2014-11-01 00:00:00	2014-11-01	5001	0	\N	0	0	\N	\N	0	120401	0	8331-1	3006322		
123404	3803	4052083	1975-05-04	1975-05-04 00:00:00	1975-05-04	5001	0	\N	0	0	\N	\N	0	252755	0	23426006	4052083		
48101	1467	4024958	1935-04-17	1935-04-17 00:00:00	1935-04-17	5001	0	\N	0	0	\N	\N	0	97769	0	117015009	4024958		
37709	3477	3001247	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	230607	0	6085-5	3001247		
16248	1482	3005136	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	98888	0	6075-6	3005136		
13437	1272	3036780	1996-03-22	1996-03-22 00:00:00	1996-03-22	5001	0	\N	0	0	\N	\N	0	83928	0	6095-4	3036780		
56932	5222	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	347449	0	6276-0	3027231		
11852	1132	3006322	2016-02-14	2016-02-14 00:00:00	2016-02-14	5001	0	\N	0	0	\N	\N	0	74539	0	8331-1	3006322		
20492	1882	3001488	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	125508	0	7258-7	3001488		
38993	3604	3001488	1997-05-09	1997-05-09 00:00:00	1997-05-09	5001	0	\N	0	0	\N	\N	0	239521	0	7258-7	3001488		
11739	371	4052083	1991-12-10	1991-12-10 00:00:00	1991-12-10	5001	0	\N	0	0	\N	\N	0	24673	0	23426006	4052083		
14868	1378	40769179	1974-06-26	1974-06-26 00:00:00	1974-06-26	5001	0	\N	0	0	\N	\N	0	91434	0	66519-0	40769179		
68248	2088	4133840	1990-07-31	1990-07-31 00:00:00	1990-07-31	5001	0	\N	0	0	\N	\N	0	139236	0	127783003	4133840		
16933	1538	3036780	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	103037	0	6095-4	3036780		
28349	2621	3006322	1957-12-04	1957-12-04 00:00:00	1957-12-04	5001	0	\N	0	0	\N	\N	0	173350	0	8331-1	3006322		
5240	505	3020655	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	33756	0	6844-5	3020655		
8766	843	3019406	1983-05-08	1983-05-08 00:00:00	1983-05-08	5001	0	\N	0	0	\N	\N	0	55804	0	6158-0	3019406		
16654	1518	3006322	1992-05-09	1992-05-09 00:00:00	1992-05-09	5001	0	\N	0	0	\N	\N	0	101528	0	8331-1	3006322		
27155	2518	3011505	2014-01-10	2014-01-10 00:00:00	2014-01-10	5001	0	\N	0	0	\N	\N	0	166592	0	19926-5	3011505		
31575	2891	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	192356	0	6248-9	3015076		
43241	3993	3006322	1949-05-26	1949-05-26 00:00:00	1949-05-26	5001	0	\N	0	0	\N	\N	0	265505	0	8331-1	3006322		
42994	3976	3051031	1964-10-14	1964-10-14 00:00:00	1964-10-14	5001	0	\N	0	0	\N	\N	0	264337	0	46240-8	3051031		
22393	2053	3051031	1964-02-25	1964-02-25 00:00:00	1964-02-25	5001	0	\N	0	0	\N	\N	0	136530	0	46240-8	3051031		
6180	578	46235214	2011-01-15	2011-01-15 00:00:00	2011-01-15	5001	0	\N	0	0	\N	\N	0	38197	0	76690-7	46235214		
51133	4670	3006322	2019-03-28	2019-03-28 00:00:00	2019-03-28	5001	0	\N	0	0	\N	\N	0	311232	0	8331-1	3006322		
1225	97	3011505	1999-07-12	1999-07-12 00:00:00	1999-07-12	5001	0	\N	0	0	\N	\N	0	6637	0	19926-5	3011505		
17683	1609	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	108150	0	6085-5	3001247		
572	35	3006322	1988-06-24	1988-06-24 00:00:00	1988-06-24	5001	0	\N	0	0	\N	\N	0	2426	0	8331-1	3006322		
42147	3895	3006322	1943-02-24	1943-02-24 00:00:00	1943-02-24	5001	0	\N	0	0	\N	\N	0	259056	0	8331-1	3006322		
40816	1266	4052083	2000-06-26	2000-06-26 00:00:00	2000-06-26	5001	0	\N	0	0	\N	\N	0	83470	0	23426006	4052083		
53612	4924	3014599	1990-12-19	1990-12-19 00:00:00	1990-12-19	5001	0	\N	0	0	\N	\N	0	327151	0	6106-9	3014599		
17341	1577	3006322	2007-01-10	2007-01-10 00:00:00	2007-01-10	5001	0	\N	0	0	\N	\N	0	105941	0	8331-1	3006322		
57586	5285	40766240	1991-08-11	1991-08-11 00:00:00	1991-08-11	5001	0	\N	0	0	\N	\N	0	351700	0	63513-6	40766240		
7980	761	3006322	1987-01-04	1987-01-04 00:00:00	1987-01-04	5001	0	\N	0	0	\N	\N	0	50568	0	8331-1	3006322		
47382	4366	3005136	1994-05-10	1994-05-10 00:00:00	1994-05-10	5001	0	\N	0	0	\N	\N	0	289673	0	6075-6	3005136		
47681	4374	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	290564	0	6276-0	3027231		
44162	1359	4024958	1975-06-29	1975-06-29 00:00:00	1975-06-29	5001	0	\N	0	0	\N	\N	0	90205	0	117015009	4024958		
20911	1929	3006322	1998-06-19	1998-06-19 00:00:00	1998-06-19	5001	0	\N	0	0	\N	\N	0	128426	0	8331-1	3006322		
4094	406	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	26758	0	6273-7	3006451		
80246	2470	4024958	1974-08-09	1974-08-09 00:00:00	1974-08-09	5001	0	\N	0	0	\N	\N	0	163779	0	117015009	4024958		
27017	2503	3006322	1998-07-25	1998-07-25 00:00:00	1998-07-25	5001	0	\N	0	0	\N	\N	0	165745	0	8331-1	3006322		
96492	2957	4024958	1988-04-04	1988-04-04 00:00:00	1988-04-04	5001	0	\N	0	0	\N	\N	0	197301	0	117015009	4024958		
45084	1385	4024958	2000-10-09	2000-10-09 00:00:00	2000-10-09	5001	0	\N	0	0	\N	\N	0	91838	0	117015009	4024958		
34407	3134	3006322	1996-06-06	1996-06-06 00:00:00	1996-06-06	5001	0	\N	0	0	\N	\N	0	208561	0	8331-1	3006322		
168373	5168	4024958	2017-08-15	2017-08-15 00:00:00	2017-08-15	5001	0	\N	0	0	\N	\N	0	343626	0	117015009	4024958		
44418	4105	3006322	1950-05-24	1950-05-24 00:00:00	1950-05-24	5001	0	\N	0	0	\N	\N	0	272757	0	8331-1	3006322		
40840	3788	3006322	1975-11-25	1975-11-25 00:00:00	1975-11-25	5001	0	\N	0	0	\N	\N	0	251838	0	8331-1	3006322		
43208	1328	4024958	1956-04-27	1956-04-27 00:00:00	1956-04-27	5001	0	\N	0	0	\N	\N	0	88161	0	117015009	4024958		
52309	4804	3015076	1993-09-27	1993-09-27 00:00:00	1993-09-27	5001	0	\N	0	0	\N	\N	0	319586	0	6248-9	3015076		
14094	1317	3011505	2002-11-15	2002-11-15 00:00:00	2002-11-15	5001	0	\N	0	0	\N	\N	0	87309	0	19926-5	3011505		
41977	3884	3036780	1975-04-23	1975-04-23 00:00:00	1975-04-23	5001	0	\N	0	0	\N	\N	0	258017	0	6095-4	3036780		
30017	2765	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	182879	0	6246-3	3021226		
15355	480	4052083	1975-09-23	1975-09-23 00:00:00	1975-09-23	5001	0	\N	0	0	\N	\N	0	32022	0	23426006	4052083		
41483	3864	3006322	2010-01-31	2010-01-31 00:00:00	2010-01-31	5001	0	\N	0	0	\N	\N	0	256509	0	8331-1	3006322		
14474	1352	3002385	1976-07-29	1976-07-29 00:00:00	1976-07-29	5001	0	\N	0	0	\N	\N	0	89606	0	30385-9	3002385		
161985	4971	4133840	2019-04-09	2019-04-09 00:00:00	2019-04-09	5001	0	\N	0	0	\N	\N	0	330534	0	127783003	4133840		
16423	1497	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	99807	0	6276-0	3027231		
47122	4343	3006322	2004-08-14	2004-08-14 00:00:00	2004-08-14	5001	0	\N	0	0	\N	\N	0	288034	0	8331-1	3006322		
49474	4506	40766240	2002-12-02	2002-12-02 00:00:00	2002-12-02	5001	0	\N	0	0	\N	\N	0	300163	0	63513-6	40766240		
52485	4822	40758406	1970-10-08	1970-10-08 00:00:00	1970-10-08	5001	0	\N	0	0	\N	\N	0	320744	0	55277-8	40758406		
48792	4462	3006322	2003-11-26	2003-11-26 00:00:00	2003-11-26	5001	0	\N	0	0	\N	\N	0	296895	0	8331-1	3006322		
19660	1796	3006322	1986-11-07	1986-11-07 00:00:00	1986-11-07	5001	0	\N	0	0	\N	\N	0	120409	0	8331-1	3006322		
123424	3804	4024958	2001-05-30	2001-05-30 00:00:00	2001-05-30	5001	0	\N	0	0	\N	\N	0	252866	0	117015009	4024958		
48107	1468	4024958	1977-02-25	1977-02-25 00:00:00	1977-02-25	5001	0	\N	0	0	\N	\N	0	97859	0	117015009	4024958		
37710	3477	3020655	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	230607	0	6844-5	3020655		
16249	1482	3012494	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	98888	0	6206-7	3012494		
13438	1272	3005136	1996-03-22	1996-03-22 00:00:00	1996-03-22	5001	0	\N	0	0	\N	\N	0	83928	0	6075-6	3005136		
56933	5222	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	347449	0	6106-9	3014599		
11853	1133	3006322	1968-05-12	1968-05-12 00:00:00	1968-05-12	5001	0	\N	0	0	\N	\N	0	74586	0	8331-1	3006322		
20493	1882	3020655	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	125508	0	6844-5	3020655		
38994	3604	3006734	1997-05-09	1997-05-09 00:00:00	1997-05-09	5001	0	\N	0	0	\N	\N	0	239521	0	6189-5	3006734		
11754	371	4052083	1968-08-30	1968-08-30 00:00:00	1968-08-30	5001	0	\N	0	0	\N	\N	0	24671	0	23426006	4052083		
14869	1378	40769189	1974-06-26	1974-06-26 00:00:00	1974-06-26	5001	0	\N	0	0	\N	\N	0	91434	0	66529-9	40769189		
68249	2088	4133840	1978-08-29	1978-08-29 00:00:00	1978-08-29	5001	0	\N	0	0	\N	\N	0	139322	0	127783003	4133840		
16934	1538	3001247	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	103037	0	6085-5	3001247		
28350	2621	3006322	2009-03-15	2009-03-15 00:00:00	2009-03-15	5001	0	\N	0	0	\N	\N	0	173383	0	8331-1	3006322		
5241	505	3000876	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	33756	0	6082-2	3000876		
8767	843	3015076	1983-05-08	1983-05-08 00:00:00	1983-05-08	5001	0	\N	0	0	\N	\N	0	55804	0	6248-9	3015076		
16655	1518	3006322	1978-06-21	1978-06-21 00:00:00	1978-06-21	5001	0	\N	0	0	\N	\N	0	101493	0	8331-1	3006322		
27156	2518	3011505	1992-12-04	1992-12-04 00:00:00	1992-12-04	5001	0	\N	0	0	\N	\N	0	166572	0	19926-5	3011505		
31576	2891	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	192356	0	6082-2	3000876		
43242	3993	3006322	2008-09-23	2008-09-23 00:00:00	2008-09-23	5001	0	\N	0	0	\N	\N	0	265472	0	8331-1	3006322		
42996	3976	3006322	1994-05-22	1994-05-22 00:00:00	1994-05-22	5001	0	\N	0	0	\N	\N	0	264345	0	8331-1	3006322		
22395	2053	46235214	1964-02-25	1964-02-25 00:00:00	1964-02-25	5001	0	\N	0	0	\N	\N	0	136530	0	76690-7	46235214		
6181	578	3051031	2011-02-14	2011-02-14 00:00:00	2011-02-14	5001	0	\N	0	0	\N	\N	0	38256	0	46240-8	3051031		
93404	2872	4024958	1959-06-07	1959-06-07 00:00:00	1959-06-07	5001	0	\N	0	0	\N	\N	0	191216	0	117015009	4024958		
1226	97	3011505	1985-07-29	1985-07-29 00:00:00	1985-07-29	5001	0	\N	0	0	\N	\N	0	6624	0	19926-5	3011505		
17684	1609	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	108150	0	6189-5	3006734		
573	35	3006322	1996-07-02	1996-07-02 00:00:00	1996-07-02	5001	0	\N	0	0	\N	\N	0	2405	0	8331-1	3006322		
42149	3895	40758406	1924-10-05	1924-10-05 00:00:00	1924-10-05	5001	0	\N	0	0	\N	\N	0	259054	0	55277-8	40758406		
40818	1266	4052083	1974-09-09	1974-09-09 00:00:00	1974-09-09	5001	0	\N	0	0	\N	\N	0	83480	0	23426006	4052083		
53613	4924	3005136	1990-12-19	1990-12-19 00:00:00	1990-12-19	5001	0	\N	0	0	\N	\N	0	327151	0	6075-6	3005136		
17342	1577	3006322	1969-04-07	1969-04-07 00:00:00	1969-04-07	5001	0	\N	0	0	\N	\N	0	105861	0	8331-1	3006322		
57590	5285	3051031	1989-08-21	1989-08-21 00:00:00	1989-08-21	5001	0	\N	0	0	\N	\N	0	351633	0	46240-8	3051031		
7981	762	3006322	1996-05-14	1996-05-14 00:00:00	1996-05-14	5001	0	\N	0	0	\N	\N	0	50657	0	8331-1	3006322		
47383	4366	3021226	1994-05-10	1994-05-10 00:00:00	1994-05-10	5001	0	\N	0	0	\N	\N	0	289673	0	6246-3	3021226		
47682	4374	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	290564	0	6844-5	3020655		
44167	1359	4024958	1941-07-26	1941-07-26 00:00:00	1941-07-26	5001	0	\N	0	0	\N	\N	0	90192	0	117015009	4024958		
20912	1929	3006322	1987-01-08	1987-01-08 00:00:00	1987-01-08	5001	0	\N	0	0	\N	\N	0	128463	0	8331-1	3006322		
4095	406	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	26758	0	6248-9	3015076		
10031	956	46235214	1973-06-25	1973-06-25 00:00:00	1973-06-25	5001	0	\N	0	0	\N	\N	0	63443	0	76690-7	46235214		
27018	2503	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	165695	0	6075-6	3005136		
96502	2957	4052083	2007-01-10	2007-01-10 00:00:00	2007-01-10	5001	0	\N	0	0	\N	\N	0	197357	0	23426006	4052083		
45088	1385	4052083	2007-05-14	2007-05-14 00:00:00	2007-05-14	5001	0	\N	0	0	\N	\N	0	91828	0	23426006	4052083		
34408	3134	3006322	2006-11-12	2006-11-12 00:00:00	2006-11-12	5001	0	\N	0	0	\N	\N	0	208604	0	8331-1	3006322		
107972	3334	4024958	2019-04-27	2019-04-27 00:00:00	2019-04-27	5001	0	\N	0	0	\N	\N	0	221179	0	117015009	4024958		
44419	4105	3006322	2001-07-04	2001-07-04 00:00:00	2001-07-04	5001	0	\N	0	0	\N	\N	0	272777	0	8331-1	3006322		
40841	3788	3006322	1965-10-23	1965-10-23 00:00:00	1965-10-23	5001	0	\N	0	0	\N	\N	0	251836	0	8331-1	3006322		
43209	1328	4133840	2017-04-20	2017-04-20 00:00:00	2017-04-20	5001	0	\N	0	0	\N	\N	0	88174	0	127783003	4133840		
52310	4804	3006322	1990-04-13	1990-04-13 00:00:00	1990-04-13	5001	0	\N	0	0	\N	\N	0	319565	0	8331-1	3006322		
14095	1317	3011505	2009-12-25	2009-12-25 00:00:00	2009-12-25	5001	0	\N	0	0	\N	\N	0	87331	0	19926-5	3011505		
41978	3884	3006451	1975-04-23	1975-04-23 00:00:00	1975-04-23	5001	0	\N	0	0	\N	\N	0	258017	0	6273-7	3006451		
30018	2765	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	182879	0	6189-5	3006734		
84288	2610	4024958	1967-01-27	1967-01-27 00:00:00	1967-01-27	5001	0	\N	0	0	\N	\N	0	172538	0	117015009	4024958		
41484	3865	3006322	1991-11-09	1991-11-09 00:00:00	1991-11-09	5001	0	\N	0	0	\N	\N	0	256626	0	8331-1	3006322		
14475	1352	21494966	1976-07-29	1976-07-29 00:00:00	1976-07-29	5001	0	\N	0	0	\N	\N	0	89606	0	80271-0	21494966		
161990	4971	4133840	2017-03-07	2017-03-07 00:00:00	2017-03-07	5001	0	\N	0	0	\N	\N	0	330660	0	127783003	4133840		
16424	1497	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	99807	0	7258-7	3001488		
47123	4343	3006322	2005-11-22	2005-11-22 00:00:00	2005-11-22	5001	0	\N	0	0	\N	\N	0	287995	0	8331-1	3006322		
49475	4506	40758406	2002-12-02	2002-12-02 00:00:00	2002-12-02	5001	0	\N	0	0	\N	\N	0	300163	0	55277-8	40758406		
52486	4822	3051031	1970-10-08	1970-10-08 00:00:00	1970-10-08	5001	0	\N	0	0	\N	\N	0	320744	0	46240-8	3051031		
48793	4462	3011505	1995-03-23	1995-03-23 00:00:00	1995-03-23	5001	0	\N	0	0	\N	\N	0	296920	0	19926-5	3011505		
19661	1796	3006322	1991-05-10	1991-05-10 00:00:00	1991-05-10	5001	0	\N	0	0	\N	\N	0	120424	0	8331-1	3006322		
89234	2765	4133840	2012-12-04	2012-12-04 00:00:00	2012-12-04	5001	0	\N	0	0	\N	\N	0	182842	0	127783003	4133840		
48109	1468	4024958	1967-09-05	1967-09-05 00:00:00	1967-09-05	5001	0	\N	0	0	\N	\N	0	97853	0	117015009	4024958		
37711	3477	3001488	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	230607	0	7258-7	3001488		
16250	1482	3001247	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	98888	0	6085-5	3001247		
13439	1272	3014599	1996-03-22	1996-03-22 00:00:00	1996-03-22	5001	0	\N	0	0	\N	\N	0	83928	0	6106-9	3014599		
56934	5222	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	347449	0	6844-5	3020655		
11854	1133	3006322	1966-05-09	1966-05-09 00:00:00	1966-05-09	5001	0	\N	0	0	\N	\N	0	74595	0	8331-1	3006322		
20494	1882	3023430	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	125508	0	6833-8	3023430		
38995	3604	3000876	1997-05-09	1997-05-09 00:00:00	1997-05-09	5001	0	\N	0	0	\N	\N	0	239521	0	6082-2	3000876		
11756	371	4024958	1970-08-23	1970-08-23 00:00:00	1970-08-23	5001	0	\N	0	0	\N	\N	0	24672	0	117015009	4024958		
14870	1378	40769194	1974-06-26	1974-06-26 00:00:00	1974-06-26	5001	0	\N	0	0	\N	\N	0	91434	0	66534-9	40769194		
68253	2088	4133840	1993-08-17	1993-08-17 00:00:00	1993-08-17	5001	0	\N	0	0	\N	\N	0	139278	0	127783003	4133840		
16935	1538	3006734	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	103037	0	6189-5	3006734		
28351	2621	3006322	2006-11-13	2006-11-13 00:00:00	2006-11-13	5001	0	\N	0	0	\N	\N	0	173395	0	8331-1	3006322		
5242	505	3012494	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	33756	0	6206-7	3012494		
8768	843	3021226	1983-05-08	1983-05-08 00:00:00	1983-05-08	5001	0	\N	0	0	\N	\N	0	55804	0	6246-3	3021226		
16656	1518	3006322	1994-03-12	1994-03-12 00:00:00	1994-03-12	5001	0	\N	0	0	\N	\N	0	101538	0	8331-1	3006322		
27157	2518	3006322	2004-08-06	2004-08-06 00:00:00	2004-08-06	5001	0	\N	0	0	\N	\N	0	166520	0	8331-1	3006322		
31577	2891	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	192356	0	6085-5	3001247		
43246	3995	3006322	2018-08-06	2018-08-06 00:00:00	2018-08-06	5001	0	\N	0	0	\N	\N	0	265596	0	8331-1	3006322		
42997	3976	46235214	1966-02-06	1966-02-06 00:00:00	1966-02-06	5001	0	\N	0	0	\N	\N	0	264354	0	76690-7	46235214		
22396	2053	40766240	1964-02-25	1964-02-25 00:00:00	1964-02-25	5001	0	\N	0	0	\N	\N	0	136530	0	63513-6	40766240		
6183	578	40758406	2011-02-14	2011-02-14 00:00:00	2011-02-14	5001	0	\N	0	0	\N	\N	0	38256	0	55277-8	40758406		
93408	2872	4024958	1960-01-12	1960-01-12 00:00:00	1960-01-12	5001	0	\N	0	0	\N	\N	0	191218	0	117015009	4024958		
1227	97	3011505	2000-07-17	2000-07-17 00:00:00	2000-07-17	5001	0	\N	0	0	\N	\N	0	6627	0	19926-5	3011505		
17685	1609	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	108150	0	6095-4	3036780		
574	35	3006322	2011-01-05	2011-01-05 00:00:00	2011-01-05	5001	0	\N	0	0	\N	\N	0	2449	0	8331-1	3006322		
42151	3895	40766240	1924-10-05	1924-10-05 00:00:00	1924-10-05	5001	0	\N	0	0	\N	\N	0	259054	0	63513-6	40766240		
40837	1267	4052083	1981-01-17	1981-01-17 00:00:00	1981-01-17	5001	0	\N	0	0	\N	\N	0	83599	0	23426006	4052083		
53614	4924	3021226	1990-12-19	1990-12-19 00:00:00	1990-12-19	5001	0	\N	0	0	\N	\N	0	327151	0	6246-3	3021226		
17343	1577	3049273	1992-07-03	1992-07-03 00:00:00	1992-07-03	5001	0	\N	0	0	\N	\N	0	105935	0	38265-5	3049273		
57591	5285	40766240	1989-08-21	1989-08-21 00:00:00	1989-08-21	5001	0	\N	0	0	\N	\N	0	351633	0	63513-6	40766240		
7982	762	3006322	2003-08-19	2003-08-19 00:00:00	2003-08-19	5001	0	\N	0	0	\N	\N	0	50710	0	8331-1	3006322		
47384	4366	3019406	1994-05-10	1994-05-10 00:00:00	1994-05-10	5001	0	\N	0	0	\N	\N	0	289673	0	6158-0	3019406		
47683	4375	3006322	1957-05-26	1957-05-26 00:00:00	1957-05-26	5001	0	\N	0	0	\N	\N	0	290654	0	8331-1	3006322		
44198	1359	4024958	1961-06-02	1961-06-02 00:00:00	1961-06-02	5001	0	\N	0	0	\N	\N	0	90167	0	117015009	4024958		
20913	1929	3006322	2019-01-12	2019-01-12 00:00:00	2019-01-12	5001	0	\N	0	0	\N	\N	0	128452	0	8331-1	3006322		
4096	406	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	26758	0	6246-3	3021226		
10032	956	3051031	1973-06-25	1973-06-25 00:00:00	1973-06-25	5001	0	\N	0	0	\N	\N	0	63443	0	46240-8	3051031		
27019	2503	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	165695	0	6158-0	3019406		
16626	518	4024958	1982-05-14	1982-05-14 00:00:00	1982-05-14	5001	0	\N	0	0	\N	\N	0	34613	0	117015009	4024958		
45093	1385	4052083	2012-01-26	2012-01-26 00:00:00	2012-01-26	5001	0	\N	0	0	\N	\N	0	91841	0	23426006	4052083		
34409	3134	3006322	2002-01-20	2002-01-20 00:00:00	2002-01-20	5001	0	\N	0	0	\N	\N	0	208632	0	8331-1	3006322		
107985	3335	4052083	2014-05-27	2014-05-27 00:00:00	2014-05-27	5001	0	\N	0	0	\N	\N	0	221244	0	23426006	4052083		
44420	4105	3006322	2007-10-13	2007-10-13 00:00:00	2007-10-13	5001	0	\N	0	0	\N	\N	0	272712	0	8331-1	3006322		
40842	3788	3006322	1997-11-24	1997-11-24 00:00:00	1997-11-24	5001	0	\N	0	0	\N	\N	0	251820	0	8331-1	3006322		
43211	1328	4052083	2008-02-17	2008-02-17 00:00:00	2008-02-17	5001	0	\N	0	0	\N	\N	0	88223	0	23426006	4052083		
52311	4805	3006322	1985-08-26	1985-08-26 00:00:00	1985-08-26	5001	0	\N	0	0	\N	\N	0	319671	0	8331-1	3006322		
14096	1317	3011505	1997-12-19	1997-12-19 00:00:00	1997-12-19	5001	0	\N	0	0	\N	\N	0	87329	0	19926-5	3011505		
41979	3884	3015076	1975-04-23	1975-04-23 00:00:00	1975-04-23	5001	0	\N	0	0	\N	\N	0	258017	0	6248-9	3015076		
30019	2765	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	182879	0	6844-5	3020655		
84300	2610	4024958	1964-05-01	1964-05-01 00:00:00	1964-05-01	5001	0	\N	0	0	\N	\N	0	172537	0	117015009	4024958		
41485	3865	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	256669	0	6844-5	3020655		
14476	1352	3035995	1976-07-29	1976-07-29 00:00:00	1976-07-29	5001	0	\N	0	0	\N	\N	0	89606	0	6768-6	3035995		
161993	4971	4133840	2011-02-01	2011-02-01 00:00:00	2011-02-01	5001	0	\N	0	0	\N	\N	0	330581	0	127783003	4133840		
16425	1497	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	99807	0	6844-5	3020655		
47124	4343	3049273	2014-12-15	2014-12-15 00:00:00	2014-12-15	5001	0	\N	0	0	\N	\N	0	288073	0	38265-5	3049273		
49476	4506	3051031	2002-12-02	2002-12-02 00:00:00	2002-12-02	5001	0	\N	0	0	\N	\N	0	300163	0	46240-8	3051031		
52488	4822	46235214	1970-10-08	1970-10-08 00:00:00	1970-10-08	5001	0	\N	0	0	\N	\N	0	320744	0	76690-7	46235214		
48794	4462	3011505	2008-02-21	2008-02-21 00:00:00	2008-02-21	5001	0	\N	0	0	\N	\N	0	296880	0	19926-5	3011505		
19662	1796	3006322	2005-07-10	2005-07-10 00:00:00	2005-07-10	5001	0	\N	0	0	\N	\N	0	120386	0	8331-1	3006322		
89238	2765	4133840	2019-01-15	2019-01-15 00:00:00	2019-01-15	5001	0	\N	0	0	\N	\N	0	182883	0	127783003	4133840		
48119	1468	4024958	1983-01-11	1983-01-11 00:00:00	1983-01-11	5001	0	\N	0	0	\N	\N	0	97861	0	117015009	4024958		
37712	3477	3012494	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	230607	0	6206-7	3012494		
16251	1482	3006734	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	98888	0	6189-5	3006734		
13440	1272	3023430	1996-03-22	1996-03-22 00:00:00	1996-03-22	5001	0	\N	0	0	\N	\N	0	83928	0	6833-8	3023430		
56935	5222	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	347449	0	6189-5	3006734		
11855	1133	3006322	2014-12-22	2014-12-22 00:00:00	2014-12-22	5001	0	\N	0	0	\N	\N	0	74577	0	8331-1	3006322		
20594	1889	3006322	2012-07-03	2012-07-03 00:00:00	2012-07-03	5001	0	\N	0	0	\N	\N	0	125937	0	8331-1	3006322		
38996	3604	3019406	1997-05-09	1997-05-09 00:00:00	1997-05-09	5001	0	\N	0	0	\N	\N	0	239521	0	6158-0	3019406		
11774	372	4024958	1969-07-18	1969-07-18 00:00:00	1969-07-18	5001	0	\N	0	0	\N	\N	0	24713	0	117015009	4024958		
14871	1378	3011505	2008-09-30	2008-09-30 00:00:00	2008-09-30	5001	0	\N	0	0	\N	\N	0	91344	0	19926-5	3011505		
68254	2088	4052083	1915-12-29	1915-12-29 00:00:00	1915-12-29	5001	0	\N	0	0	\N	\N	0	139164	0	23426006	4052083		
16936	1538	3001488	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	103037	0	7258-7	3001488		
28352	2621	3006322	1961-01-03	1961-01-03 00:00:00	1961-01-03	5001	0	\N	0	0	\N	\N	0	173380	0	8331-1	3006322		
5243	505	3001488	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	33756	0	7258-7	3001488		
8769	843	3005136	1983-05-08	1983-05-08 00:00:00	1983-05-08	5001	0	\N	0	0	\N	\N	0	55804	0	6075-6	3005136		
16657	1518	3006322	1956-10-05	1956-10-05 00:00:00	1956-10-05	5001	0	\N	0	0	\N	\N	0	101526	0	8331-1	3006322		
27158	2518	3011505	2009-09-11	2009-09-11 00:00:00	2009-09-11	5001	0	\N	0	0	\N	\N	0	166551	0	19926-5	3011505		
31857	2909	3011505	1992-04-26	1992-04-26 00:00:00	1992-04-26	5001	0	\N	0	0	\N	\N	0	193920	0	19926-5	3011505		
43247	3995	3006322	2001-07-26	2001-07-26 00:00:00	2001-07-26	5001	0	\N	0	0	\N	\N	0	265616	0	8331-1	3006322		
42998	3976	3051031	1966-02-06	1966-02-06 00:00:00	1966-02-06	5001	0	\N	0	0	\N	\N	0	264354	0	46240-8	3051031		
22398	2054	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	136626	0	6085-5	3001247		
6185	578	40766240	2011-02-14	2011-02-14 00:00:00	2011-02-14	5001	0	\N	0	0	\N	\N	0	38256	0	63513-6	40766240		
104727	3223	4024958	1948-07-05	1948-07-05 00:00:00	1948-07-05	5001	0	\N	0	0	\N	\N	0	214240	0	117015009	4024958		
1228	97	3011505	2018-08-27	2018-08-27 00:00:00	2018-08-27	5001	0	\N	0	0	\N	\N	0	6641	0	19926-5	3011505		
17686	1609	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	108150	0	7258-7	3001488		
575	35	3006322	2002-04-14	2002-04-14 00:00:00	2002-04-14	5001	0	\N	0	0	\N	\N	0	2448	0	8331-1	3006322		
42152	3895	3051031	1924-10-05	1924-10-05 00:00:00	1924-10-05	5001	0	\N	0	0	\N	\N	0	259054	0	46240-8	3051031		
40848	1267	4052083	1990-01-25	1990-01-25 00:00:00	1990-01-25	5001	0	\N	0	0	\N	\N	0	83519	0	23426006	4052083		
53615	4924	3019406	1990-12-19	1990-12-19 00:00:00	1990-12-19	5001	0	\N	0	0	\N	\N	0	327151	0	6158-0	3019406		
17344	1577	3006322	2006-06-02	2006-06-02 00:00:00	2006-06-02	5001	0	\N	0	0	\N	\N	0	105940	0	8331-1	3006322		
57593	5285	40758406	1989-08-21	1989-08-21 00:00:00	1989-08-21	5001	0	\N	0	0	\N	\N	0	351633	0	55277-8	40758406		
7983	762	3006322	1979-01-06	1979-01-06 00:00:00	1979-01-06	5001	0	\N	0	0	\N	\N	0	50661	0	8331-1	3006322		
47385	4366	3015076	1994-05-10	1994-05-10 00:00:00	1994-05-10	5001	0	\N	0	0	\N	\N	0	289673	0	6248-9	3015076		
47684	4375	3006322	1939-06-11	1939-06-11 00:00:00	1939-06-11	5001	0	\N	0	0	\N	\N	0	290634	0	8331-1	3006322		
44208	1359	4052083	1962-01-22	1962-01-22 00:00:00	1962-01-22	5001	0	\N	0	0	\N	\N	0	90168	0	23426006	4052083		
20914	1929	3006322	1974-01-07	1974-01-07 00:00:00	1974-01-07	5001	0	\N	0	0	\N	\N	0	128461	0	8331-1	3006322		
4097	406	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	26758	0	6189-5	3006734		
10033	956	40758406	1973-06-25	1973-06-25 00:00:00	1973-06-25	5001	0	\N	0	0	\N	\N	0	63443	0	55277-8	40758406		
27020	2503	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	165695	0	6248-9	3015076		
16636	518	4024958	1981-03-07	1981-03-07 00:00:00	1981-03-07	5001	0	\N	0	0	\N	\N	0	34619	0	117015009	4024958		
45097	1385	4052083	1997-05-17	1997-05-17 00:00:00	1997-05-17	5001	0	\N	0	0	\N	\N	0	91811	0	23426006	4052083		
34410	3134	3049273	1988-12-07	1988-12-07 00:00:00	1988-12-07	5001	0	\N	0	0	\N	\N	0	208557	0	38265-5	3049273		
108022	3335	4024958	2008-08-30	2008-08-30 00:00:00	2008-08-30	5001	0	\N	0	0	\N	\N	0	221264	0	117015009	4024958		
44421	4106	3006322	1989-04-21	1989-04-21 00:00:00	1989-04-21	5001	0	\N	0	0	\N	\N	0	272785	0	8331-1	3006322		
40843	3788	3006322	1985-08-29	1985-08-29 00:00:00	1985-08-29	5001	0	\N	0	0	\N	\N	0	251857	0	8331-1	3006322		
43213	1328	4133840	2009-03-05	2009-03-05 00:00:00	2009-03-05	5001	0	\N	0	0	\N	\N	0	88172	0	127783003	4133840		
10668	1036	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	68103	0	6276-0	3027231		
14097	1317	3011505	2004-11-26	2004-11-26 00:00:00	2004-11-26	5001	0	\N	0	0	\N	\N	0	87310	0	19926-5	3011505		
41980	3884	3023430	1975-04-23	1975-04-23 00:00:00	1975-04-23	5001	0	\N	0	0	\N	\N	0	258017	0	6833-8	3023430		
30020	2765	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	182879	0	6158-0	3019406		
137630	4240	4052083	1964-07-23	1964-07-23 00:00:00	1964-07-23	5001	0	\N	0	0	\N	\N	0	281689	0	23426006	4052083		
41486	3865	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	256669	0	6206-7	3012494		
14477	1352	3006906	1976-07-29	1976-07-29 00:00:00	1976-07-29	5001	0	\N	0	0	\N	\N	0	89606	0	17861-6	3006906		
18250	1662	3006322	2004-08-27	2004-08-27 00:00:00	2004-08-27	5001	0	\N	0	0	\N	\N	0	111735	0	8331-1	3006322		
16426	1497	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	99807	0	6085-5	3001247		
47125	4343	3006322	1974-06-03	1974-06-03 00:00:00	1974-06-03	5001	0	\N	0	0	\N	\N	0	287990	0	8331-1	3006322		
49478	4506	46235214	2002-12-02	2002-12-02 00:00:00	2002-12-02	5001	0	\N	0	0	\N	\N	0	300163	0	76690-7	46235214		
52490	4822	40766240	1948-11-22	1948-11-22 00:00:00	1948-11-22	5001	0	\N	0	0	\N	\N	0	320729	0	63513-6	40766240		
48795	4462	3011505	2015-04-02	2015-04-02 00:00:00	2015-04-02	5001	0	\N	0	0	\N	\N	0	296874	0	19926-5	3011505		
19663	1796	3006322	1987-01-18	1987-01-18 00:00:00	1987-01-18	5001	0	\N	0	0	\N	\N	0	120400	0	8331-1	3006322		
89240	2765	4133840	2007-11-06	2007-11-06 00:00:00	2007-11-06	5001	0	\N	0	0	\N	\N	0	182915	0	127783003	4133840		
48129	1468	4052083	1981-06-16	1981-06-16 00:00:00	1981-06-16	5001	0	\N	0	0	\N	\N	0	97827	0	23426006	4052083		
37713	3477	3014599	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	230607	0	6106-9	3014599		
16252	1482	3020655	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	98888	0	6844-5	3020655		
13441	1272	3019406	1996-03-22	1996-03-22 00:00:00	1996-03-22	5001	0	\N	0	0	\N	\N	0	83928	0	6158-0	3019406		
56936	5222	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	347449	0	6833-8	3023430		
11856	1134	3049273	1999-06-16	1999-06-16 00:00:00	1999-06-16	5001	0	\N	0	0	\N	\N	0	74730	0	38265-5	3049273		
20595	1889	3006322	1995-10-15	1995-10-15 00:00:00	1995-10-15	5001	0	\N	0	0	\N	\N	0	125924	0	8331-1	3006322		
38997	3604	3015076	1997-05-09	1997-05-09 00:00:00	1997-05-09	5001	0	\N	0	0	\N	\N	0	239521	0	6248-9	3015076		
11781	372	4024958	1973-02-09	1973-02-09 00:00:00	1973-02-09	5001	0	\N	0	0	\N	\N	0	24764	0	117015009	4024958		
14872	1378	3011505	2002-03-05	2002-03-05 00:00:00	2002-03-05	5001	0	\N	0	0	\N	\N	0	91441	0	19926-5	3011505		
68255	2088	4133840	1972-07-25	1972-07-25 00:00:00	1972-07-25	5001	0	\N	0	0	\N	\N	0	139311	0	127783003	4133840		
16937	1538	3019406	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	102975	0	6158-0	3019406		
28353	2621	3006322	1999-04-08	1999-04-08 00:00:00	1999-04-08	5001	0	\N	0	0	\N	\N	0	173393	0	8331-1	3006322		
5244	505	3023430	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	33756	0	6833-8	3023430		
8770	843	3036780	1983-05-08	1983-05-08 00:00:00	1983-05-08	5001	0	\N	0	0	\N	\N	0	55804	0	6095-4	3036780		
16658	1518	3006322	1981-08-20	1981-08-20 00:00:00	1981-08-20	5001	0	\N	0	0	\N	\N	0	101494	0	8331-1	3006322		
27159	2518	3011505	2013-01-04	2013-01-04 00:00:00	2013-01-04	5001	0	\N	0	0	\N	\N	0	166575	0	19926-5	3011505		
31858	2909	3002385	1962-04-07	1962-04-07 00:00:00	1962-04-07	5001	0	\N	0	0	\N	\N	0	193910	0	30385-9	3002385		
43248	3995	3006322	1977-02-15	1977-02-15 00:00:00	1977-02-15	5001	0	\N	0	0	\N	\N	0	265593	0	8331-1	3006322		
42999	3976	40758406	1966-02-06	1966-02-06 00:00:00	1966-02-06	5001	0	\N	0	0	\N	\N	0	264354	0	55277-8	40758406		
22399	2054	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	136626	0	6248-9	3015076		
6186	578	46235214	2011-02-14	2011-02-14 00:00:00	2011-02-14	5001	0	\N	0	0	\N	\N	0	38256	0	76690-7	46235214		
104739	3223	4052083	1944-02-09	1944-02-09 00:00:00	1944-02-09	5001	0	\N	0	0	\N	\N	0	214323	0	23426006	4052083		
1229	97	3006322	1945-07-22	1945-07-22 00:00:00	1945-07-22	5001	0	\N	0	0	\N	\N	0	6650	0	8331-1	3006322		
17687	1609	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	108150	0	6206-7	3012494		
576	36	3006322	1962-10-18	1962-10-18 00:00:00	1962-10-18	5001	0	\N	0	0	\N	\N	0	2503	0	8331-1	3006322		
42153	3895	46235214	1924-10-05	1924-10-05 00:00:00	1924-10-05	5001	0	\N	0	0	\N	\N	0	259054	0	76690-7	46235214		
39473	3650	3006322	2015-07-03	2015-07-03 00:00:00	2015-07-03	5001	0	\N	0	0	\N	\N	0	242949	0	8331-1	3006322		
53616	4924	3015076	1990-12-19	1990-12-19 00:00:00	1990-12-19	5001	0	\N	0	0	\N	\N	0	327151	0	6248-9	3015076		
17345	1577	3015632	1997-01-31	1997-01-31 00:00:00	1997-01-31	5001	0	\N	0	0	\N	\N	0	105932	0	2028-9	3015632		
57594	5285	46235214	1989-08-21	1989-08-21 00:00:00	1989-08-21	5001	0	\N	0	0	\N	\N	0	351633	0	76690-7	46235214		
7984	762	3006322	1987-11-03	1987-11-03 00:00:00	1987-11-03	5001	0	\N	0	0	\N	\N	0	50664	0	8331-1	3006322		
8517	807	46235214	1996-09-01	1996-09-01 00:00:00	1996-09-01	5001	0	\N	0	0	\N	\N	0	53627	0	76690-7	46235214		
47685	4375	3006322	1946-04-14	1946-04-14 00:00:00	1946-04-14	5001	0	\N	0	0	\N	\N	0	290612	0	8331-1	3006322		
44213	1359	4052083	1976-08-21	1976-08-21 00:00:00	1976-08-21	5001	0	\N	0	0	\N	\N	0	90193	0	23426006	4052083		
135187	4165	4024958	1951-01-22	1951-01-22 00:00:00	1951-01-22	5001	0	\N	0	0	\N	\N	0	276697	0	117015009	4024958		
4098	406	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	26758	0	6206-7	3012494		
10036	956	40766240	1973-06-25	1973-06-25 00:00:00	1973-06-25	5001	0	\N	0	0	\N	\N	0	63443	0	63513-6	40766240		
27021	2503	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	165695	0	6273-7	3006451		
27955	869	4024958	1970-06-25	1970-06-25 00:00:00	1970-06-25	5001	0	\N	0	0	\N	\N	0	57791	0	117015009	4024958		
61714	1889	4024958	2012-07-03	2012-07-03 00:00:00	2012-07-03	5001	0	\N	0	0	\N	\N	0	125937	0	117015009	4024958		
34411	3134	3006322	1945-09-20	1945-09-20 00:00:00	1945-09-20	5001	0	\N	0	0	\N	\N	0	208538	0	8331-1	3006322		
29357	2703	3006322	1977-07-16	1977-07-16 00:00:00	1977-07-16	5001	0	\N	0	0	\N	\N	0	179084	0	8331-1	3006322		
44422	4106	3006322	1986-10-03	1986-10-03 00:00:00	1986-10-03	5001	0	\N	0	0	\N	\N	0	272836	0	8331-1	3006322		
40844	3789	3006322	1999-12-14	1999-12-14 00:00:00	1999-12-14	5001	0	\N	0	0	\N	\N	0	251939	0	8331-1	3006322		
43215	1328	4024958	1950-05-03	1950-05-03 00:00:00	1950-05-03	5001	0	\N	0	0	\N	\N	0	88191	0	117015009	4024958		
10669	1036	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	68103	0	6248-9	3015076		
14098	1317	3011505	1996-05-24	1996-05-24 00:00:00	1996-05-24	5001	0	\N	0	0	\N	\N	0	87299	0	19926-5	3011505		
41981	3884	3027231	1975-04-23	1975-04-23 00:00:00	1975-04-23	5001	0	\N	0	0	\N	\N	0	258017	0	6276-0	3027231		
30021	2765	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	182879	0	6206-7	3012494		
137633	4240	4052083	1963-04-29	1963-04-29 00:00:00	1963-04-29	5001	0	\N	0	0	\N	\N	0	281626	0	23426006	4052083		
41487	3865	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	256669	0	6158-0	3019406		
14478	1352	3019550	1976-07-29	1976-07-29 00:00:00	1976-07-29	5001	0	\N	0	0	\N	\N	0	89606	0	2951-2	3019550		
18251	1662	3006322	2017-11-27	2017-11-27 00:00:00	2017-11-27	5001	0	\N	0	0	\N	\N	0	111723	0	8331-1	3006322		
16427	1497	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	99807	0	6189-5	3006734		
47126	4343	3006322	1989-03-11	1989-03-11 00:00:00	1989-03-11	5001	0	\N	0	0	\N	\N	0	287993	0	8331-1	3006322		
49479	4506	3051031	1983-09-13	1983-09-13 00:00:00	1983-09-13	5001	0	\N	0	0	\N	\N	0	300160	0	46240-8	3051031		
11106	1072	3006322	1979-07-24	1979-07-24 00:00:00	1979-07-24	5001	0	\N	0	0	\N	\N	0	70240	0	8331-1	3006322		
48796	4462	3011505	2005-02-03	2005-02-03 00:00:00	2005-02-03	5001	0	\N	0	0	\N	\N	0	296922	0	19926-5	3011505		
19664	1796	3006322	1980-04-30	1980-04-30 00:00:00	1980-04-30	5001	0	\N	0	0	\N	\N	0	120379	0	8331-1	3006322		
89250	2765	4133840	2009-11-17	2009-11-17 00:00:00	2009-11-17	5001	0	\N	0	0	\N	\N	0	182916	0	127783003	4133840		
48139	1468	4024958	1958-09-12	1958-09-12 00:00:00	1958-09-12	5001	0	\N	0	0	\N	\N	0	97851	0	117015009	4024958		
37714	3477	3027231	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	230607	0	6276-0	3027231		
16253	1482	3019406	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	98888	0	6158-0	3019406		
13442	1272	3020655	1996-03-22	1996-03-22 00:00:00	1996-03-22	5001	0	\N	0	0	\N	\N	0	83928	0	6844-5	3020655		
56937	5222	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	347449	0	6095-4	3036780		
11857	1134	3006322	1940-07-26	1940-07-26 00:00:00	1940-07-26	5001	0	\N	0	0	\N	\N	0	74661	0	8331-1	3006322		
20597	1892	3011505	2010-07-15	2010-07-15 00:00:00	2010-07-15	5001	0	\N	0	0	\N	\N	0	125987	0	19926-5	3011505		
38998	3604	3027231	1997-05-09	1997-05-09 00:00:00	1997-05-09	5001	0	\N	0	0	\N	\N	0	239521	0	6276-0	3027231		
149340	4580	4052083	1972-11-29	1972-11-29 00:00:00	1972-11-29	5001	0	\N	0	0	\N	\N	0	305112	0	23426006	4052083		
14873	1378	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	91435	0	6273-7	3006451		
68256	2088	4133840	1987-07-14	1987-07-14 00:00:00	1987-07-14	5001	0	\N	0	0	\N	\N	0	139254	0	127783003	4133840		
16938	1538	3006451	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	102975	0	6273-7	3006451		
28354	2622	3006322	1933-05-27	1933-05-27 00:00:00	1933-05-27	5001	0	\N	0	0	\N	\N	0	173469	0	8331-1	3006322		
5245	505	3036780	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	33756	0	6095-4	3036780		
8771	843	3006451	1983-05-08	1983-05-08 00:00:00	1983-05-08	5001	0	\N	0	0	\N	\N	0	55804	0	6273-7	3006451		
16659	1518	3006322	1955-07-03	1955-07-03 00:00:00	1955-07-03	5001	0	\N	0	0	\N	\N	0	101537	0	8331-1	3006322		
27160	2518	3011505	2010-12-24	2010-12-24 00:00:00	2010-12-24	5001	0	\N	0	0	\N	\N	0	166552	0	19926-5	3011505		
31859	2909	3013682	1962-04-07	1962-04-07 00:00:00	1962-04-07	5001	0	\N	0	0	\N	\N	0	193910	0	3094-0	3013682		
43249	3995	3006322	1992-02-06	1992-02-06 00:00:00	1992-02-06	5001	0	\N	0	0	\N	\N	0	265592	0	8331-1	3006322		
43001	3976	40766240	1966-02-06	1966-02-06 00:00:00	1966-02-06	5001	0	\N	0	0	\N	\N	0	264354	0	63513-6	40766240		
22400	2054	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	136626	0	6082-2	3000876		
6187	578	46235214	2011-04-15	2011-04-15 00:00:00	2011-04-15	5001	0	\N	0	0	\N	\N	0	38198	0	76690-7	46235214		
104743	3223	4024958	1985-09-24	1985-09-24 00:00:00	1985-09-24	5001	0	\N	0	0	\N	\N	0	214315	0	117015009	4024958		
1230	97	3011505	1989-08-07	1989-08-07 00:00:00	1989-08-07	5001	0	\N	0	0	\N	\N	0	6608	0	19926-5	3011505		
17688	1609	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	108150	0	6248-9	3015076		
577	36	3006322	2004-04-22	2004-04-22 00:00:00	2004-04-22	5001	0	\N	0	0	\N	\N	0	2561	0	8331-1	3006322		
42154	3895	3006322	1980-09-22	1980-09-22 00:00:00	1980-09-22	5001	0	\N	0	0	\N	\N	0	259052	0	8331-1	3006322		
39474	3650	3006322	1991-05-30	1991-05-30 00:00:00	1991-05-30	5001	0	\N	0	0	\N	\N	0	242904	0	8331-1	3006322		
53617	4924	3012494	1990-12-19	1990-12-19 00:00:00	1990-12-19	5001	0	\N	0	0	\N	\N	0	327151	0	6206-7	3012494		
17346	1577	3007461	1997-01-31	1997-01-31 00:00:00	1997-01-31	5001	0	\N	0	0	\N	\N	0	105932	0	26515-7	3007461		
57598	5285	3051031	1991-03-14	1991-03-14 00:00:00	1991-03-14	5001	0	\N	0	0	\N	\N	0	351627	0	46240-8	3051031		
7985	762	3049273	2014-09-10	2014-09-10 00:00:00	2014-09-10	5001	0	\N	0	0	\N	\N	0	50729	0	38265-5	3049273		
8518	807	40766240	1996-09-01	1996-09-01 00:00:00	1996-09-01	5001	0	\N	0	0	\N	\N	0	53627	0	63513-6	40766240		
47686	4375	3049273	2018-03-04	2018-03-04 00:00:00	2018-03-04	5001	0	\N	0	0	\N	\N	0	290599	0	38265-5	3049273		
55492	1685	4052083	1997-10-29	1997-10-29 00:00:00	1997-10-29	5001	0	\N	0	0	\N	\N	0	112912	0	23426006	4052083		
30862	2827	40766240	1921-07-01	1921-07-01 00:00:00	1921-07-01	5001	0	\N	0	0	\N	\N	0	187505	0	63513-6	40766240		
4099	406	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	26758	0	6085-5	3001247		
10037	956	3006322	1983-06-18	1983-06-18 00:00:00	1983-06-18	5001	0	\N	0	0	\N	\N	0	63448	0	8331-1	3006322		
27022	2503	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	165695	0	6189-5	3006734		
27975	869	4024958	1961-01-02	1961-01-02 00:00:00	1961-01-02	5001	0	\N	0	0	\N	\N	0	57750	0	117015009	4024958		
61729	1889	4024958	1995-10-15	1995-10-15 00:00:00	1995-10-15	5001	0	\N	0	0	\N	\N	0	125924	0	117015009	4024958		
59346	1808	4052083	1963-03-05	1963-03-05 00:00:00	1963-03-05	5001	0	\N	0	0	\N	\N	0	121018	0	23426006	4052083		
29358	2703	3006322	1979-09-20	1979-09-20 00:00:00	1979-09-20	5001	0	\N	0	0	\N	\N	0	179052	0	8331-1	3006322		
44423	4106	3006322	1988-09-08	1988-09-08 00:00:00	1988-09-08	5001	0	\N	0	0	\N	\N	0	272863	0	8331-1	3006322		
40845	3789	3006322	1953-07-04	1953-07-04 00:00:00	1953-07-04	5001	0	\N	0	0	\N	\N	0	251872	0	8331-1	3006322		
43217	1328	4133840	2000-08-24	2000-08-24 00:00:00	2000-08-24	5001	0	\N	0	0	\N	\N	0	88186	0	127783003	4133840		
10670	1036	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	68103	0	6206-7	3012494		
14099	1317	3011505	2007-12-14	2007-12-14 00:00:00	2007-12-14	5001	0	\N	0	0	\N	\N	0	87330	0	19926-5	3011505		
41982	3884	3014599	1975-04-23	1975-04-23 00:00:00	1975-04-23	5001	0	\N	0	0	\N	\N	0	258017	0	6106-9	3014599		
30022	2765	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	182879	0	6085-5	3001247		
137634	4240	4024958	1950-07-10	1950-07-10 00:00:00	1950-07-10	5001	0	\N	0	0	\N	\N	0	281664	0	117015009	4024958		
41488	3865	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	256669	0	6075-6	3005136		
14479	1352	3000963	1976-07-29	1976-07-29 00:00:00	1976-07-29	5001	0	\N	0	0	\N	\N	0	89606	0	718-7	3000963		
18252	1662	3006322	1999-02-12	1999-02-12 00:00:00	1999-02-12	5001	0	\N	0	0	\N	\N	0	111722	0	8331-1	3006322		
16428	1497	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	99807	0	6833-8	3023430		
47127	4343	3006322	2017-01-18	2017-01-18 00:00:00	2017-01-18	5001	0	\N	0	0	\N	\N	0	288036	0	8331-1	3006322		
49480	4506	40758406	1983-09-13	1983-09-13 00:00:00	1983-09-13	5001	0	\N	0	0	\N	\N	0	300160	0	55277-8	40758406		
11107	1072	3006322	1987-07-22	1987-07-22 00:00:00	1987-07-22	5001	0	\N	0	0	\N	\N	0	70250	0	8331-1	3006322		
48797	4462	3011505	2009-02-26	2009-02-26 00:00:00	2009-02-26	5001	0	\N	0	0	\N	\N	0	296908	0	19926-5	3011505		
63916	1965	4024958	1990-04-11	1990-04-11 00:00:00	1990-04-11	5001	0	\N	0	0	\N	\N	0	130617	0	117015009	4024958		
89267	2765	4133840	2014-12-16	2014-12-16 00:00:00	2014-12-16	5001	0	\N	0	0	\N	\N	0	182836	0	127783003	4133840		
48140	1468	4052083	1965-08-11	1965-08-11 00:00:00	1965-08-11	5001	0	\N	0	0	\N	\N	0	97852	0	23426006	4052083		
37715	3477	3023430	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	230607	0	6833-8	3023430		
16254	1482	3021226	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	98888	0	6246-3	3021226		
13443	1272	3027231	1996-03-22	1996-03-22 00:00:00	1996-03-22	5001	0	\N	0	0	\N	\N	0	83928	0	6276-0	3027231		
56938	5222	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	347449	0	6082-2	3000876		
11858	1134	3006322	1952-05-03	1952-05-03 00:00:00	1952-05-03	5001	0	\N	0	0	\N	\N	0	74664	0	8331-1	3006322		
20598	1892	3011505	2018-08-30	2018-08-30 00:00:00	2018-08-30	5001	0	\N	0	0	\N	\N	0	126023	0	19926-5	3011505		
38999	3604	3006451	1997-05-09	1997-05-09 00:00:00	1997-05-09	5001	0	\N	0	0	\N	\N	0	239521	0	6273-7	3006451		
149344	4580	4052083	1971-01-21	1971-01-21 00:00:00	1971-01-21	5001	0	\N	0	0	\N	\N	0	305111	0	23426006	4052083		
14874	1378	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	91435	0	7258-7	3001488		
68261	2088	4133840	1985-07-02	1985-07-02 00:00:00	1985-07-02	5001	0	\N	0	0	\N	\N	0	139171	0	127783003	4133840		
16939	1538	3027231	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	102975	0	6276-0	3027231		
28355	2622	3006322	1942-12-17	1942-12-17 00:00:00	1942-12-17	5001	0	\N	0	0	\N	\N	0	173488	0	8331-1	3006322		
5246	505	3021226	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	33756	0	6246-3	3021226		
20049	1843	3015076	1982-09-26	1982-09-26 00:00:00	1982-09-26	5001	0	\N	0	0	\N	\N	0	123101	0	6248-9	3015076		
16661	1520	3006322	1941-11-02	1941-11-02 00:00:00	1941-11-02	5001	0	\N	0	0	\N	\N	0	101622	0	8331-1	3006322		
27161	2518	3011505	1983-11-25	1983-11-25 00:00:00	1983-11-25	5001	0	\N	0	0	\N	\N	0	166514	0	19926-5	3011505		
31860	2909	3023103	1962-04-07	1962-04-07 00:00:00	1962-04-07	5001	0	\N	0	0	\N	\N	0	193910	0	2823-3	3023103		
43250	3996	3006322	1995-09-19	1995-09-19 00:00:00	1995-09-19	5001	0	\N	0	0	\N	\N	0	265687	0	8331-1	3006322		
43004	3976	3051031	1965-01-12	1965-01-12 00:00:00	1965-01-12	5001	0	\N	0	0	\N	\N	0	264322	0	46240-8	3051031		
22401	2054	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	136626	0	6158-0	3019406		
6188	578	3051031	2011-04-15	2011-04-15 00:00:00	2011-04-15	5001	0	\N	0	0	\N	\N	0	38198	0	46240-8	3051031		
11791	1115	3023430	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	73440	0	6833-8	3023430		
1231	97	3011505	2009-07-06	2009-07-06 00:00:00	2009-07-06	5001	0	\N	0	0	\N	\N	0	6640	0	19926-5	3011505		
17689	1609	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	108150	0	6075-6	3005136		
578	36	3019406	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	2539	0	6158-0	3019406		
42155	3895	3006322	1950-05-10	1950-05-10 00:00:00	1950-05-10	5001	0	\N	0	0	\N	\N	0	259117	0	8331-1	3006322		
39475	3650	3006322	1938-10-10	1938-10-10 00:00:00	1938-10-10	5001	0	\N	0	0	\N	\N	0	242899	0	8331-1	3006322		
53618	4924	3019406	1978-06-24	1978-06-24 00:00:00	1978-06-24	5001	0	\N	0	0	\N	\N	0	327278	0	6158-0	3019406		
17347	1577	3020630	1997-01-31	1997-01-31 00:00:00	1997-01-31	5001	0	\N	0	0	\N	\N	0	105932	0	2885-2	3020630		
57599	5285	40758406	1991-03-14	1991-03-14 00:00:00	1991-03-14	5001	0	\N	0	0	\N	\N	0	351627	0	55277-8	40758406		
7986	762	3006322	1994-10-09	1994-10-09 00:00:00	1994-10-09	5001	0	\N	0	0	\N	\N	0	50665	0	8331-1	3006322		
8519	807	3051031	1952-05-15	1952-05-15 00:00:00	1952-05-15	5001	0	\N	0	0	\N	\N	0	53565	0	46240-8	3051031		
47687	4375	3006322	1996-01-03	1996-01-03 00:00:00	1996-01-03	5001	0	\N	0	0	\N	\N	0	290616	0	8331-1	3006322		
55495	1686	4024958	1969-03-11	1969-03-11 00:00:00	1969-03-11	5001	0	\N	0	0	\N	\N	0	112931	0	117015009	4024958		
30864	2827	3049273	1987-05-28	1987-05-28 00:00:00	1987-05-28	5001	0	\N	0	0	\N	\N	0	187513	0	38265-5	3049273		
4100	406	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	26758	0	6833-8	3023430		
10038	956	3006322	1958-03-01	1958-03-01 00:00:00	1958-03-01	5001	0	\N	0	0	\N	\N	0	63539	0	8331-1	3006322		
27023	2503	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	165695	0	6082-2	3000876		
45197	1387	4024958	1978-09-15	1978-09-15 00:00:00	1978-09-15	5001	0	\N	0	0	\N	\N	0	91995	0	117015009	4024958		
45237	1387	4024958	1995-11-24	1995-11-24 00:00:00	1995-11-24	5001	0	\N	0	0	\N	\N	0	92089	0	117015009	4024958		
59355	1808	4052083	1971-08-03	1971-08-03 00:00:00	1971-08-03	5001	0	\N	0	0	\N	\N	0	121028	0	23426006	4052083		
29359	2704	3006322	2002-07-16	2002-07-16 00:00:00	2002-07-16	5001	0	\N	0	0	\N	\N	0	179151	0	8331-1	3006322		
44424	4106	3006322	2000-04-29	2000-04-29 00:00:00	2000-04-29	5001	0	\N	0	0	\N	\N	0	272838	0	8331-1	3006322		
40846	3789	3049273	2010-07-29	2010-07-29 00:00:00	2010-07-29	5001	0	\N	0	0	\N	\N	0	251914	0	38265-5	3049273		
43220	1328	4133840	2011-03-17	2011-03-17 00:00:00	2011-03-17	5001	0	\N	0	0	\N	\N	0	88173	0	127783003	4133840		
10671	1036	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	68103	0	6085-5	3001247		
14100	1317	3011505	2014-01-17	2014-01-17 00:00:00	2014-01-17	5001	0	\N	0	0	\N	\N	0	87333	0	19926-5	3011505		
41983	3884	3020655	1975-04-23	1975-04-23 00:00:00	1975-04-23	5001	0	\N	0	0	\N	\N	0	258017	0	6844-5	3020655		
30023	2765	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	182879	0	7258-7	3001488		
137651	4240	4024958	1948-06-10	1948-06-10 00:00:00	1948-06-10	5001	0	\N	0	0	\N	\N	0	281669	0	117015009	4024958		
41489	3865	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	256669	0	6248-9	3015076		
14480	1352	3011505	2004-04-18	2004-04-18 00:00:00	2004-04-18	5001	0	\N	0	0	\N	\N	0	89578	0	19926-5	3011505		
29601	2721	40758406	1969-06-08	1969-06-08 00:00:00	1969-06-08	5001	0	\N	0	0	\N	\N	0	180307	0	55277-8	40758406		
16429	1497	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	99807	0	6095-4	3036780		
47128	4343	3006322	1967-09-26	1967-09-26 00:00:00	1967-09-26	5001	0	\N	0	0	\N	\N	0	287989	0	8331-1	3006322		
49481	4506	46235214	1983-09-13	1983-09-13 00:00:00	1983-09-13	5001	0	\N	0	0	\N	\N	0	300160	0	76690-7	46235214		
11108	1072	3006322	1977-11-20	1977-11-20 00:00:00	1977-11-20	5001	0	\N	0	0	\N	\N	0	70247	0	8331-1	3006322		
48799	4462	3011505	2007-02-15	2007-02-15 00:00:00	2007-02-15	5001	0	\N	0	0	\N	\N	0	296907	0	19926-5	3011505		
63927	1965	4024958	2009-06-16	2009-06-16 00:00:00	2009-06-16	5001	0	\N	0	0	\N	\N	0	130646	0	117015009	4024958		
89269	2765	4133840	2015-12-22	2015-12-22 00:00:00	2015-12-22	5001	0	\N	0	0	\N	\N	0	182917	0	127783003	4133840		
151576	4643	4052083	1956-02-06	1956-02-06 00:00:00	1956-02-06	5001	0	\N	0	0	\N	\N	0	309590	0	23426006	4052083		
37716	3477	3021226	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	230607	0	6246-3	3021226		
16255	1482	3000876	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	98888	0	6082-2	3000876		
13444	1272	3021226	1996-03-22	1996-03-22 00:00:00	1996-03-22	5001	0	\N	0	0	\N	\N	0	83928	0	6246-3	3021226		
56939	5222	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	347449	0	6246-3	3021226		
11859	1134	3006322	1973-05-22	1973-05-22 00:00:00	1973-05-22	5001	0	\N	0	0	\N	\N	0	74667	0	8331-1	3006322		
20599	1892	3011505	2013-08-01	2013-08-01 00:00:00	2013-08-01	5001	0	\N	0	0	\N	\N	0	126015	0	19926-5	3011505		
39000	3604	3006322	1984-08-05	1984-08-05 00:00:00	1984-08-05	5001	0	\N	0	0	\N	\N	0	239539	0	8331-1	3006322		
149348	4580	4024958	1987-01-23	1987-01-23 00:00:00	1987-01-23	5001	0	\N	0	0	\N	\N	0	305123	0	117015009	4024958		
14875	1378	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	91435	0	6844-5	3020655		
68266	2088	4133840	1992-08-11	1992-08-11 00:00:00	1992-08-11	5001	0	\N	0	0	\N	\N	0	139237	0	127783003	4133840		
16940	1538	3021226	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	102975	0	6246-3	3021226		
99119	3040	4024958	2000-05-15	2000-05-15 00:00:00	2000-05-15	5001	0	\N	0	0	\N	\N	0	202369	0	117015009	4024958		
5247	505	3019406	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	33756	0	6158-0	3019406		
20050	1843	3001488	1982-09-26	1982-09-26 00:00:00	1982-09-26	5001	0	\N	0	0	\N	\N	0	123101	0	7258-7	3001488		
16662	1520	3006322	1978-07-12	1978-07-12 00:00:00	1978-07-12	5001	0	\N	0	0	\N	\N	0	101713	0	8331-1	3006322		
27162	2518	3011505	2007-08-31	2007-08-31 00:00:00	2007-08-31	5001	0	\N	0	0	\N	\N	0	166550	0	19926-5	3011505		
31861	2909	3015632	1962-04-07	1962-04-07 00:00:00	1962-04-07	5001	0	\N	0	0	\N	\N	0	193910	0	2028-9	3015632		
43251	3996	3006322	2012-02-15	2012-02-15 00:00:00	2012-02-15	5001	0	\N	0	0	\N	\N	0	265668	0	8331-1	3006322		
43006	3976	40766240	1965-01-12	1965-01-12 00:00:00	1965-01-12	5001	0	\N	0	0	\N	\N	0	264322	0	63513-6	40766240		
22402	2054	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	136626	0	7258-7	3001488		
26029	2392	3011505	2010-07-30	2010-07-30 00:00:00	2010-07-30	5001	0	\N	0	0	\N	\N	0	158974	0	19926-5	3011505		
11792	1115	3015076	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	73440	0	6248-9	3015076		
1232	97	3011505	1987-08-03	1987-08-03 00:00:00	1987-08-03	5001	0	\N	0	0	\N	\N	0	6660	0	19926-5	3011505		
17690	1609	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	108150	0	6276-0	3027231		
579	36	3012494	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	2539	0	6206-7	3012494		
42156	3895	3006322	1949-08-28	1949-08-28 00:00:00	1949-08-28	5001	0	\N	0	0	\N	\N	0	259048	0	8331-1	3006322		
39476	3650	3006322	1953-04-16	1953-04-16 00:00:00	1953-04-16	5001	0	\N	0	0	\N	\N	0	242990	0	8331-1	3006322		
53619	4924	3021226	1978-06-24	1978-06-24 00:00:00	1978-06-24	5001	0	\N	0	0	\N	\N	0	327278	0	6246-3	3021226		
17348	1577	3002385	1997-01-31	1997-01-31 00:00:00	1997-01-31	5001	0	\N	0	0	\N	\N	0	105932	0	30385-9	3002385		
57600	5285	40766240	1991-03-14	1991-03-14 00:00:00	1991-03-14	5001	0	\N	0	0	\N	\N	0	351627	0	63513-6	40766240		
7987	763	3006322	1993-11-13	1993-11-13 00:00:00	1993-11-13	5001	0	\N	0	0	\N	\N	0	50744	0	8331-1	3006322		
8522	807	40766240	1952-05-15	1952-05-15 00:00:00	1952-05-15	5001	0	\N	0	0	\N	\N	0	53565	0	63513-6	40766240		
47688	4375	3006322	1959-01-08	1959-01-08 00:00:00	1959-01-08	5001	0	\N	0	0	\N	\N	0	290604	0	8331-1	3006322		
55510	1686	4052083	1976-11-27	1976-11-27 00:00:00	1976-11-27	5001	0	\N	0	0	\N	\N	0	112932	0	23426006	4052083		
30866	2827	3006322	1978-02-14	1978-02-14 00:00:00	1978-02-14	5001	0	\N	0	0	\N	\N	0	187447	0	8331-1	3006322		
4101	406	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	26758	0	6095-4	3036780		
10039	956	3006322	1961-10-20	1961-10-20 00:00:00	1961-10-20	5001	0	\N	0	0	\N	\N	0	63447	0	8331-1	3006322		
27024	2503	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	165695	0	6246-3	3021226		
45207	1387	4052083	1989-03-19	1989-03-19 00:00:00	1989-03-19	5001	0	\N	0	0	\N	\N	0	92044	0	23426006	4052083		
45245	1387	4052083	2000-08-26	2000-08-26 00:00:00	2000-08-26	5001	0	\N	0	0	\N	\N	0	92015	0	23426006	4052083		
59358	1808	4052083	2014-04-27	2014-04-27 00:00:00	2014-04-27	5001	0	\N	0	0	\N	\N	0	121050	0	23426006	4052083		
29360	2704	3006322	2015-08-15	2015-08-15 00:00:00	2015-08-15	5001	0	\N	0	0	\N	\N	0	179154	0	8331-1	3006322		
44425	4106	3006322	1967-10-18	1967-10-18 00:00:00	1967-10-18	5001	0	\N	0	0	\N	\N	0	272834	0	8331-1	3006322		
40847	3789	3006322	2017-01-09	2017-01-09 00:00:00	2017-01-09	5001	0	\N	0	0	\N	\N	0	251941	0	8331-1	3006322		
43222	1328	4133840	1995-07-27	1995-07-27 00:00:00	1995-07-27	5001	0	\N	0	0	\N	\N	0	88206	0	127783003	4133840		
10672	1036	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	68103	0	6246-3	3021226		
14101	1317	3011505	2008-12-19	2008-12-19 00:00:00	2008-12-19	5001	0	\N	0	0	\N	\N	0	87300	0	19926-5	3011505		
41984	3884	3000876	1975-04-23	1975-04-23 00:00:00	1975-04-23	5001	0	\N	0	0	\N	\N	0	258017	0	6082-2	3000876		
30024	2765	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	182879	0	6276-0	3027231		
148934	4563	4052083	2001-11-03	2001-11-03 00:00:00	2001-11-03	5001	0	\N	0	0	\N	\N	0	304127	0	23426006	4052083		
132284	4072	4052083	2002-11-10	2002-11-10 00:00:00	2002-11-10	5001	0	\N	0	0	\N	\N	0	270696	0	23426006	4052083		
14481	1352	3011505	2005-04-24	2005-04-24 00:00:00	2005-04-24	5001	0	\N	0	0	\N	\N	0	89556	0	19926-5	3011505		
29602	2721	40766240	1969-06-08	1969-06-08 00:00:00	1969-06-08	5001	0	\N	0	0	\N	\N	0	180307	0	63513-6	40766240		
16430	1497	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	99807	0	6206-7	3012494		
47129	4343	3006322	1960-04-23	1960-04-23 00:00:00	1960-04-23	5001	0	\N	0	0	\N	\N	0	287988	0	8331-1	3006322		
49483	4506	40766240	1983-09-13	1983-09-13 00:00:00	1983-09-13	5001	0	\N	0	0	\N	\N	0	300160	0	63513-6	40766240		
11109	1072	3006322	2002-05-21	2002-05-21 00:00:00	2002-05-21	5001	0	\N	0	0	\N	\N	0	70278	0	8331-1	3006322		
48800	4462	3011505	1999-04-01	1999-04-01 00:00:00	1999-04-01	5001	0	\N	0	0	\N	\N	0	296872	0	19926-5	3011505		
63936	1966	4052083	2016-07-20	2016-07-20 00:00:00	2016-07-20	5001	0	\N	0	0	\N	\N	0	130706	0	23426006	4052083		
89274	2765	4133840	2008-11-11	2008-11-11 00:00:00	2008-11-11	5001	0	\N	0	0	\N	\N	0	182834	0	127783003	4133840		
151583	4643	4052083	1916-04-19	1916-04-19 00:00:00	1916-04-19	5001	0	\N	0	0	\N	\N	0	309600	0	23426006	4052083		
37717	3477	3005136	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	230607	0	6075-6	3005136		
16256	1482	3023430	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	98888	0	6833-8	3023430		
13445	1272	3019406	1992-09-18	1992-09-18 00:00:00	1992-09-18	5001	0	\N	0	0	\N	\N	0	83866	0	6158-0	3019406		
56940	5222	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	347449	0	6158-0	3019406		
11860	1134	3006322	1948-01-30	1948-01-30 00:00:00	1948-01-30	5001	0	\N	0	0	\N	\N	0	74662	0	8331-1	3006322		
20600	1892	3011505	2012-07-26	2012-07-26 00:00:00	2012-07-26	5001	0	\N	0	0	\N	\N	0	125988	0	19926-5	3011505		
39001	3604	3000876	1984-12-12	1984-12-12 00:00:00	1984-12-12	5001	0	\N	0	0	\N	\N	0	239520	0	6082-2	3000876		
28602	884	4052083	1981-04-19	1981-04-19 00:00:00	1981-04-19	5001	0	\N	0	0	\N	\N	0	58939	0	23426006	4052083		
14876	1378	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	91435	0	6246-3	3021226		
68270	2088	4133840	1997-05-20	1997-05-20 00:00:00	1997-05-20	5001	0	\N	0	0	\N	\N	0	139280	0	127783003	4133840		
16941	1538	3001247	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	102975	0	6085-5	3001247		
99129	3041	4024958	1992-11-23	1992-11-23 00:00:00	1992-11-23	5001	0	\N	0	0	\N	\N	0	202431	0	117015009	4024958		
5248	505	3015076	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	33756	0	6248-9	3015076		
20051	1843	3023430	1982-09-26	1982-09-26 00:00:00	1982-09-26	5001	0	\N	0	0	\N	\N	0	123101	0	6833-8	3023430		
16663	1520	3006322	1955-10-29	1955-10-29 00:00:00	1955-10-29	5001	0	\N	0	0	\N	\N	0	101629	0	8331-1	3006322		
27163	2518	3011505	1999-06-25	1999-06-25 00:00:00	1999-06-25	5001	0	\N	0	0	\N	\N	0	166573	0	19926-5	3011505		
31862	2909	3014576	1962-04-07	1962-04-07 00:00:00	1962-04-07	5001	0	\N	0	0	\N	\N	0	193910	0	2075-0	3014576		
43252	3996	3006322	2001-06-01	2001-06-01 00:00:00	2001-06-01	5001	0	\N	0	0	\N	\N	0	265688	0	8331-1	3006322		
43007	3976	46235214	1965-01-12	1965-01-12 00:00:00	1965-01-12	5001	0	\N	0	0	\N	\N	0	264322	0	76690-7	46235214		
22403	2054	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	136626	0	6206-7	3012494		
26030	2392	3011505	1969-02-14	1969-02-14 00:00:00	1969-02-14	5001	0	\N	0	0	\N	\N	0	159054	0	19926-5	3011505		
11793	1115	3027231	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	73440	0	6276-0	3027231		
1233	97	3011505	1998-08-17	1998-08-17 00:00:00	1998-08-17	5001	0	\N	0	0	\N	\N	0	6662	0	19926-5	3011505		
17691	1609	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	108150	0	6273-7	3006451		
580	36	3027231	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	2539	0	6276-0	3027231		
42157	3895	46235214	1924-07-07	1924-07-07 00:00:00	1924-07-07	5001	0	\N	0	0	\N	\N	0	259053	0	76690-7	46235214		
39477	3650	3006322	1961-09-18	1961-09-18 00:00:00	1961-09-18	5001	0	\N	0	0	\N	\N	0	242901	0	8331-1	3006322		
53620	4924	3015076	1978-06-24	1978-06-24 00:00:00	1978-06-24	5001	0	\N	0	0	\N	\N	0	327278	0	6248-9	3015076		
17349	1577	3045716	1997-01-31	1997-01-31 00:00:00	1997-01-31	5001	0	\N	0	0	\N	\N	0	105932	0	33037-3	3045716		
57601	5285	46235214	1991-03-14	1991-03-14 00:00:00	1991-03-14	5001	0	\N	0	0	\N	\N	0	351627	0	76690-7	46235214		
7988	763	3006322	1970-01-10	1970-01-10 00:00:00	1970-01-10	5001	0	\N	0	0	\N	\N	0	50747	0	8331-1	3006322		
8523	807	46235214	1952-05-15	1952-05-15 00:00:00	1952-05-15	5001	0	\N	0	0	\N	\N	0	53565	0	76690-7	46235214		
47689	4375	3006322	1957-12-04	1957-12-04 00:00:00	1957-12-04	5001	0	\N	0	0	\N	\N	0	290636	0	8331-1	3006322		
3939	394	3006322	1967-09-27	1967-09-27 00:00:00	1967-09-27	5001	0	\N	0	0	\N	\N	0	25895	0	8331-1	3006322		
30869	2827	3006322	1952-08-06	1952-08-06 00:00:00	1952-08-06	5001	0	\N	0	0	\N	\N	0	187470	0	8331-1	3006322		
4102	406	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	26758	0	6106-9	3014599		
10040	956	46235214	1998-12-16	1998-12-16 00:00:00	1998-12-16	5001	0	\N	0	0	\N	\N	0	63492	0	76690-7	46235214		
27025	2503	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	165695	0	6085-5	3001247		
55258	5053	3049273	1991-06-24	1991-06-24 00:00:00	1991-06-24	5001	0	\N	0	0	\N	\N	0	336019	0	38265-5	3049273		
45284	1389	4052083	1972-08-15	1972-08-15 00:00:00	1972-08-15	5001	0	\N	0	0	\N	\N	0	92151	0	23426006	4052083		
59362	1809	4024958	1970-02-25	1970-02-25 00:00:00	1970-02-25	5001	0	\N	0	0	\N	\N	0	121098	0	117015009	4024958		
29361	2704	3006322	2014-08-05	2014-08-05 00:00:00	2014-08-05	5001	0	\N	0	0	\N	\N	0	179122	0	8331-1	3006322		
44426	4106	3006322	1995-04-03	1995-04-03 00:00:00	1995-04-03	5001	0	\N	0	0	\N	\N	0	272786	0	8331-1	3006322		
40848	3789	3006322	2002-02-16	2002-02-16 00:00:00	2002-02-16	5001	0	\N	0	0	\N	\N	0	251880	0	8331-1	3006322		
43226	1328	4133840	2006-09-28	2006-09-28 00:00:00	2006-09-28	5001	0	\N	0	0	\N	\N	0	88195	0	127783003	4133840		
10673	1036	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	68103	0	6075-6	3005136		
14102	1317	3011505	2005-12-02	2005-12-02 00:00:00	2005-12-02	5001	0	\N	0	0	\N	\N	0	87315	0	19926-5	3011505		
41985	3884	3012494	1975-04-23	1975-04-23 00:00:00	1975-04-23	5001	0	\N	0	0	\N	\N	0	258017	0	6206-7	3012494		
30025	2765	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	182879	0	6075-6	3005136		
148939	4563	4024958	1997-09-15	1997-09-15 00:00:00	1997-09-15	5001	0	\N	0	0	\N	\N	0	304066	0	117015009	4024958		
132348	4077	4024958	1988-10-26	1988-10-26 00:00:00	1988-10-26	5001	0	\N	0	0	\N	\N	0	270890	0	117015009	4024958		
14482	1352	3011505	2013-06-09	2013-06-09 00:00:00	2013-06-09	5001	0	\N	0	0	\N	\N	0	89579	0	19926-5	3011505		
29603	2721	46235214	1969-06-08	1969-06-08 00:00:00	1969-06-08	5001	0	\N	0	0	\N	\N	0	180307	0	76690-7	46235214		
16431	1497	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	99807	0	6273-7	3006451		
47130	4343	3006322	2012-03-03	2012-03-03 00:00:00	2012-03-03	5001	0	\N	0	0	\N	\N	0	288054	0	8331-1	3006322		
49485	4506	40766240	2013-11-14	2013-11-14 00:00:00	2013-11-14	5001	0	\N	0	0	\N	\N	0	300177	0	63513-6	40766240		
11110	1072	3006322	1994-07-23	1994-07-23 00:00:00	1994-07-23	5001	0	\N	0	0	\N	\N	0	70259	0	8331-1	3006322		
48801	4462	3011505	2017-04-13	2017-04-13 00:00:00	2017-04-13	5001	0	\N	0	0	\N	\N	0	296875	0	19926-5	3011505		
63944	1966	4024958	1991-12-10	1991-12-10 00:00:00	1991-12-10	5001	0	\N	0	0	\N	\N	0	130672	0	117015009	4024958		
108957	3365	4024958	1978-07-23	1978-07-23 00:00:00	1978-07-23	5001	0	\N	0	0	\N	\N	0	223173	0	117015009	4024958		
151589	4643	4052083	1937-10-04	1937-10-04 00:00:00	1937-10-04	5001	0	\N	0	0	\N	\N	0	309536	0	23426006	4052083		
37718	3477	3019406	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	230607	0	6158-0	3019406		
16257	1482	3036780	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	98888	0	6095-4	3036780		
13446	1272	3020655	1992-09-18	1992-09-18 00:00:00	1992-09-18	5001	0	\N	0	0	\N	\N	0	83866	0	6844-5	3020655		
56941	5222	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	347449	0	7258-7	3001488		
11861	1134	3049273	2013-07-02	2013-07-02 00:00:00	2013-07-02	5001	0	\N	0	0	\N	\N	0	74731	0	38265-5	3049273		
20601	1892	3011505	2009-05-21	2009-05-21 00:00:00	2009-05-21	5001	0	\N	0	0	\N	\N	0	126013	0	19926-5	3011505		
39002	3604	3019406	1984-12-12	1984-12-12 00:00:00	1984-12-12	5001	0	\N	0	0	\N	\N	0	239520	0	6158-0	3019406		
28618	884	4052083	2013-11-26	2013-11-26 00:00:00	2013-11-26	5001	0	\N	0	0	\N	\N	0	58932	0	23426006	4052083		
14877	1378	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	91435	0	6206-7	3012494		
68271	2088	4052083	1932-12-07	1932-12-07 00:00:00	1932-12-07	5001	0	\N	0	0	\N	\N	0	139166	0	23426006	4052083		
16942	1538	3006734	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	102975	0	6189-5	3006734		
99134	3041	4024958	2014-05-09	2014-05-09 00:00:00	2014-05-09	5001	0	\N	0	0	\N	\N	0	202477	0	117015009	4024958		
5249	505	3005136	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	33756	0	6075-6	3005136		
20052	1843	3012494	1982-09-26	1982-09-26 00:00:00	1982-09-26	5001	0	\N	0	0	\N	\N	0	123101	0	6206-7	3012494		
16664	1520	3049273	2002-10-29	2002-10-29 00:00:00	2002-10-29	5001	0	\N	0	0	\N	\N	0	101710	0	38265-5	3049273		
27164	2518	3011505	2005-08-19	2005-08-19 00:00:00	2005-08-19	5001	0	\N	0	0	\N	\N	0	166591	0	19926-5	3011505		
43142	3984	3006322	1967-08-11	1967-08-11 00:00:00	1967-08-11	5001	0	\N	0	0	\N	\N	0	264807	0	8331-1	3006322		
43253	3996	3006322	1979-07-03	1979-07-03 00:00:00	1979-07-03	5001	0	\N	0	0	\N	\N	0	265665	0	8331-1	3006322		
43008	3976	40758406	1965-01-12	1965-01-12 00:00:00	1965-01-12	5001	0	\N	0	0	\N	\N	0	264322	0	55277-8	40758406		
22404	2054	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	136626	0	6189-5	3006734		
26031	2392	3011505	1973-03-09	1973-03-09 00:00:00	1973-03-09	5001	0	\N	0	0	\N	\N	0	159056	0	19926-5	3011505		
11794	1115	3014599	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	73440	0	6106-9	3014599		
1234	97	3011505	2010-07-12	2010-07-12 00:00:00	2010-07-12	5001	0	\N	0	0	\N	\N	0	6630	0	19926-5	3011505		
17692	1609	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	108150	0	6158-0	3019406		
581	36	3021226	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	2539	0	6246-3	3021226		
42158	3895	3051031	1924-07-07	1924-07-07 00:00:00	1924-07-07	5001	0	\N	0	0	\N	\N	0	259053	0	46240-8	3051031		
39478	3650	3006322	1938-05-31	1938-05-31 00:00:00	1938-05-31	5001	0	\N	0	0	\N	\N	0	242965	0	8331-1	3006322		
53621	4924	3012494	1978-06-24	1978-06-24 00:00:00	1978-06-24	5001	0	\N	0	0	\N	\N	0	327278	0	6206-7	3012494		
17350	1577	3023103	1997-01-31	1997-01-31 00:00:00	1997-01-31	5001	0	\N	0	0	\N	\N	0	105932	0	2823-3	3023103		
57602	5285	3006322	1995-01-15	1995-01-15 00:00:00	1995-01-15	5001	0	\N	0	0	\N	\N	0	351701	0	8331-1	3006322		
7989	763	3006322	2018-07-01	2018-07-01 00:00:00	2018-07-01	5001	0	\N	0	0	\N	\N	0	50758	0	8331-1	3006322		
8524	807	40758406	1952-05-15	1952-05-15 00:00:00	1952-05-15	5001	0	\N	0	0	\N	\N	0	53565	0	55277-8	40758406		
47690	4375	3008598	1982-06-26	1982-06-26 00:00:00	1982-06-26	5001	0	\N	0	0	\N	\N	0	290614	0	3024-7	3008598		
3940	394	3006322	1987-05-11	1987-05-11 00:00:00	1987-05-11	5001	0	\N	0	0	\N	\N	0	25917	0	8331-1	3006322		
30873	2829	3006322	1979-05-17	1979-05-17 00:00:00	1979-05-17	5001	0	\N	0	0	\N	\N	0	187663	0	8331-1	3006322		
4103	406	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	26758	0	6276-0	3027231		
10041	956	3051031	1998-12-16	1998-12-16 00:00:00	1998-12-16	5001	0	\N	0	0	\N	\N	0	63492	0	46240-8	3051031		
27026	2503	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	165695	0	6833-8	3023430		
55259	5053	3006322	1948-02-11	1948-02-11 00:00:00	1948-02-11	5001	0	\N	0	0	\N	\N	0	336049	0	8331-1	3006322		
45286	1389	4024958	2012-03-28	2012-03-28 00:00:00	2012-03-28	5001	0	\N	0	0	\N	\N	0	92222	0	117015009	4024958		
59379	1809	4024958	1995-09-09	1995-09-09 00:00:00	1995-09-09	5001	0	\N	0	0	\N	\N	0	121119	0	117015009	4024958		
29362	2704	3006322	1973-07-07	1973-07-07 00:00:00	1973-07-07	5001	0	\N	0	0	\N	\N	0	179148	0	8331-1	3006322		
44427	4106	3006322	2007-04-09	2007-04-09 00:00:00	2007-04-09	5001	0	\N	0	0	\N	\N	0	272787	0	8331-1	3006322		
40849	3789	3006322	1975-11-10	1975-11-10 00:00:00	1975-11-10	5001	0	\N	0	0	\N	\N	0	251877	0	8331-1	3006322		
43230	1328	4133840	2008-02-28	2008-02-28 00:00:00	2008-02-28	5001	0	\N	0	0	\N	\N	0	88212	0	127783003	4133840		
10674	1036	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	68103	0	6082-2	3000876		
14103	1317	3011505	1999-12-24	1999-12-24 00:00:00	1999-12-24	5001	0	\N	0	0	\N	\N	0	87308	0	19926-5	3011505		
41986	3884	3019406	1975-04-23	1975-04-23 00:00:00	1975-04-23	5001	0	\N	0	0	\N	\N	0	258017	0	6158-0	3019406		
30026	2765	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	182879	0	6095-4	3036780		
148956	4565	4024958	1977-12-21	1977-12-21 00:00:00	1977-12-21	5001	0	\N	0	0	\N	\N	0	304237	0	117015009	4024958		
132361	4077	4024958	1976-12-03	1976-12-03 00:00:00	1976-12-03	5001	0	\N	0	0	\N	\N	0	270908	0	117015009	4024958		
14483	1352	3011505	2001-04-01	2001-04-01 00:00:00	2001-04-01	5001	0	\N	0	0	\N	\N	0	89554	0	19926-5	3011505		
29606	2721	3051031	1969-06-08	1969-06-08 00:00:00	1969-06-08	5001	0	\N	0	0	\N	\N	0	180307	0	46240-8	3051031		
16432	1497	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	99807	0	6106-9	3014599		
47131	4343	3006322	2019-06-24	2019-06-24 00:00:00	2019-06-24	5001	0	\N	0	0	\N	\N	0	288037	0	8331-1	3006322		
49488	4506	3051031	2013-11-14	2013-11-14 00:00:00	2013-11-14	5001	0	\N	0	0	\N	\N	0	300177	0	46240-8	3051031		
11111	1072	3006322	2003-12-25	2003-12-25 00:00:00	2003-12-25	5001	0	\N	0	0	\N	\N	0	70244	0	8331-1	3006322		
48802	4462	3011505	2013-03-21	2013-03-21 00:00:00	2013-03-21	5001	0	\N	0	0	\N	\N	0	296873	0	19926-5	3011505		
63952	1966	4024958	1992-09-19	1992-09-19 00:00:00	1992-09-19	5001	0	\N	0	0	\N	\N	0	130717	0	117015009	4024958		
108980	3365	4052083	2001-05-06	2001-05-06 00:00:00	2001-05-06	5001	0	\N	0	0	\N	\N	0	223156	0	23426006	4052083		
151601	4643	4052083	1963-01-12	1963-01-12 00:00:00	1963-01-12	5001	0	\N	0	0	\N	\N	0	309591	0	23426006	4052083		
37719	3477	3006734	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	230607	0	6189-5	3006734		
16258	1482	3006451	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	98888	0	6273-7	3006451		
13447	1272	3023430	1992-09-18	1992-09-18 00:00:00	1992-09-18	5001	0	\N	0	0	\N	\N	0	83866	0	6833-8	3023430		
56942	5222	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	347449	0	6085-5	3001247		
11862	1134	3006322	2001-07-10	2001-07-10 00:00:00	2001-07-10	5001	0	\N	0	0	\N	\N	0	74691	0	8331-1	3006322		
20602	1892	3011505	2014-08-07	2014-08-07 00:00:00	2014-08-07	5001	0	\N	0	0	\N	\N	0	125989	0	19926-5	3011505		
39003	3604	3015076	1984-12-12	1984-12-12 00:00:00	1984-12-12	5001	0	\N	0	0	\N	\N	0	239520	0	6248-9	3015076		
39942	1242	4052083	2007-05-20	2007-05-20 00:00:00	2007-05-20	5001	0	\N	0	0	\N	\N	0	81759	0	23426006	4052083		
14878	1378	3011505	2018-07-31	2018-07-31 00:00:00	2018-07-31	5001	0	\N	0	0	\N	\N	0	91431	0	19926-5	3011505		
68275	2088	4133840	1981-09-15	1981-09-15 00:00:00	1981-09-15	5001	0	\N	0	0	\N	\N	0	139312	0	127783003	4133840		
16943	1538	3001488	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	102975	0	7258-7	3001488		
110451	3409	4052083	1982-05-27	1982-05-27 00:00:00	1982-05-27	5001	0	\N	0	0	\N	\N	0	226090	0	23426006	4052083		
5250	505	3014599	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	33756	0	6106-9	3014599		
20053	1843	3005136	1982-09-26	1982-09-26 00:00:00	1982-09-26	5001	0	\N	0	0	\N	\N	0	123101	0	6075-6	3005136		
16665	1520	3006322	1982-08-31	1982-08-31 00:00:00	1982-08-31	5001	0	\N	0	0	\N	\N	0	101624	0	8331-1	3006322		
27165	2518	3011505	1995-06-16	1995-06-16 00:00:00	1995-06-16	5001	0	\N	0	0	\N	\N	0	166589	0	19926-5	3011505		
43143	3984	3006322	2005-12-16	2005-12-16 00:00:00	2005-12-16	5001	0	\N	0	0	\N	\N	0	264843	0	8331-1	3006322		
43254	3996	3006322	1974-07-16	1974-07-16 00:00:00	1974-07-16	5001	0	\N	0	0	\N	\N	0	265653	0	8331-1	3006322		
43010	3976	46235214	1965-10-09	1965-10-09 00:00:00	1965-10-09	5001	0	\N	0	0	\N	\N	0	264324	0	76690-7	46235214		
22405	2054	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	136626	0	6844-5	3020655		
26032	2392	3011505	1980-11-28	1980-11-28 00:00:00	1980-11-28	5001	0	\N	0	0	\N	\N	0	159087	0	19926-5	3011505		
11795	1115	3006451	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	73440	0	6273-7	3006451		
1235	97	3011505	2005-06-13	2005-06-13 00:00:00	2005-06-13	5001	0	\N	0	0	\N	\N	0	6638	0	19926-5	3011505		
17693	1609	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	108150	0	6833-8	3023430		
582	36	3015076	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	2539	0	6248-9	3015076		
42159	3895	40766240	1924-07-07	1924-07-07 00:00:00	1924-07-07	5001	0	\N	0	0	\N	\N	0	259053	0	63513-6	40766240		
39479	3650	3006322	1971-10-17	1971-10-17 00:00:00	1971-10-17	5001	0	\N	0	0	\N	\N	0	242988	0	8331-1	3006322		
53622	4924	3001488	1978-06-24	1978-06-24 00:00:00	1978-06-24	5001	0	\N	0	0	\N	\N	0	327278	0	7258-7	3001488		
17351	1577	3013682	1997-01-31	1997-01-31 00:00:00	1997-01-31	5001	0	\N	0	0	\N	\N	0	105932	0	3094-0	3013682		
57603	5285	3006322	1984-02-02	1984-02-02 00:00:00	1984-02-02	5001	0	\N	0	0	\N	\N	0	351659	0	8331-1	3006322		
7990	763	3006322	1991-12-12	1991-12-12 00:00:00	1991-12-12	5001	0	\N	0	0	\N	\N	0	50751	0	8331-1	3006322		
8525	807	3006322	1957-10-14	1957-10-14 00:00:00	1957-10-14	5001	0	\N	0	0	\N	\N	0	53572	0	8331-1	3006322		
47691	4375	3009201	1982-06-26	1982-06-26 00:00:00	1982-06-26	5001	0	\N	0	0	\N	\N	0	290614	0	3016-3	3009201		
3941	394	3006322	1978-08-11	1978-08-11 00:00:00	1978-08-11	5001	0	\N	0	0	\N	\N	0	25896	0	8331-1	3006322		
30874	2829	3006322	1968-01-05	1968-01-05 00:00:00	1968-01-05	5001	0	\N	0	0	\N	\N	0	187633	0	8331-1	3006322		
4104	406	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	26758	0	6082-2	3000876		
10042	956	40758406	1998-12-16	1998-12-16 00:00:00	1998-12-16	5001	0	\N	0	0	\N	\N	0	63492	0	55277-8	40758406		
27027	2503	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	165695	0	6206-7	3012494		
55260	5053	3006322	1956-12-08	1956-12-08 00:00:00	1956-12-08	5001	0	\N	0	0	\N	\N	0	336039	0	8331-1	3006322		
56582	1727	4133840	2010-10-21	2010-10-21 00:00:00	2010-10-21	5001	0	\N	0	0	\N	\N	0	115500	0	127783003	4133840		
59384	1809	4052083	1971-03-02	1971-03-02 00:00:00	1971-03-02	5001	0	\N	0	0	\N	\N	0	121099	0	23426006	4052083		
29363	2704	3006322	2003-12-22	2003-12-22 00:00:00	2003-12-22	5001	0	\N	0	0	\N	\N	0	179152	0	8331-1	3006322		
44428	4106	3006322	1944-07-05	1944-07-05 00:00:00	1944-07-05	5001	0	\N	0	0	\N	\N	0	272831	0	8331-1	3006322		
40850	3789	3006322	1965-03-22	1965-03-22 00:00:00	1965-03-22	5001	0	\N	0	0	\N	\N	0	251925	0	8331-1	3006322		
43232	1328	4133840	2014-04-03	2014-04-03 00:00:00	2014-04-03	5001	0	\N	0	0	\N	\N	0	88196	0	127783003	4133840		
10675	1036	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	68103	0	6106-9	3014599		
14104	1317	3011505	2015-01-23	2015-01-23 00:00:00	2015-01-23	5001	0	\N	0	0	\N	\N	0	87316	0	19926-5	3011505		
41987	3884	3001247	1975-04-23	1975-04-23 00:00:00	1975-04-23	5001	0	\N	0	0	\N	\N	0	258017	0	6085-5	3001247		
30027	2765	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	182879	0	6248-9	3015076		
148976	4565	4024958	1948-03-25	1948-03-25 00:00:00	1948-03-25	5001	0	\N	0	0	\N	\N	0	304215	0	117015009	4024958		
132362	4077	4052083	1983-11-22	1983-11-22 00:00:00	1983-11-22	5001	0	\N	0	0	\N	\N	0	270910	0	23426006	4052083		
14484	1352	3011505	2009-05-17	2009-05-17 00:00:00	2009-05-17	5001	0	\N	0	0	\N	\N	0	89589	0	19926-5	3011505		
13618	431	4024958	1951-07-18	1951-07-18 00:00:00	1951-07-18	5001	0	\N	0	0	\N	\N	0	28612	0	117015009	4024958		
16433	1497	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	99807	0	6158-0	3019406		
47132	4343	3006322	1997-01-11	1997-01-11 00:00:00	1997-01-11	5001	0	\N	0	0	\N	\N	0	288053	0	8331-1	3006322		
49489	4506	40758406	2013-11-14	2013-11-14 00:00:00	2013-11-14	5001	0	\N	0	0	\N	\N	0	300177	0	55277-8	40758406		
11112	1072	3006322	2008-08-16	2008-08-16 00:00:00	2008-08-16	5001	0	\N	0	0	\N	\N	0	70263	0	8331-1	3006322		
48803	4462	3006322	1988-08-22	1988-08-22 00:00:00	1988-08-22	5001	0	\N	0	0	\N	\N	0	296934	0	8331-1	3006322		
63964	1967	4052083	2016-03-17	2016-03-17 00:00:00	2016-03-17	5001	0	\N	0	0	\N	\N	0	130829	0	23426006	4052083		
84908	2630	4024958	1991-03-03	1991-03-03 00:00:00	1991-03-03	5001	0	\N	0	0	\N	\N	0	173932	0	117015009	4024958		
151603	4643	4024958	1994-06-20	1994-06-20 00:00:00	1994-06-20	5001	0	\N	0	0	\N	\N	0	309596	0	117015009	4024958		
37720	3477	3036780	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	230607	0	6095-4	3036780		
16259	1482	3015076	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	98888	0	6248-9	3015076		
13448	1272	3036780	1992-09-18	1992-09-18 00:00:00	1992-09-18	5001	0	\N	0	0	\N	\N	0	83866	0	6095-4	3036780		
56943	5222	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	347449	0	6248-9	3015076		
11863	1134	3006322	1949-06-01	1949-06-01 00:00:00	1949-06-01	5001	0	\N	0	0	\N	\N	0	74663	0	8331-1	3006322		
20603	1892	3011505	2016-08-18	2016-08-18 00:00:00	2016-08-18	5001	0	\N	0	0	\N	\N	0	126022	0	19926-5	3011505		
39004	3604	3036780	1984-12-12	1984-12-12 00:00:00	1984-12-12	5001	0	\N	0	0	\N	\N	0	239520	0	6095-4	3036780		
39949	1242	4052083	1975-10-14	1975-10-14 00:00:00	1975-10-14	5001	0	\N	0	0	\N	\N	0	81821	0	23426006	4052083		
14879	1378	3006322	1962-10-29	1962-10-29 00:00:00	1962-10-29	5001	0	\N	0	0	\N	\N	0	91432	0	8331-1	3006322		
68278	2088	4133840	2014-07-15	2014-07-15 00:00:00	2014-07-15	5001	0	\N	0	0	\N	\N	0	139291	0	127783003	4133840		
16944	1538	3036780	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	102975	0	6095-4	3036780		
110456	3409	4052083	1985-10-25	1985-10-25 00:00:00	1985-10-25	5001	0	\N	0	0	\N	\N	0	226091	0	23426006	4052083		
5251	505	3006451	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	33756	0	6273-7	3006451		
20054	1843	3036780	1982-09-26	1982-09-26 00:00:00	1982-09-26	5001	0	\N	0	0	\N	\N	0	123101	0	6095-4	3036780		
16666	1520	3049273	2010-10-17	2010-10-17 00:00:00	2010-10-17	5001	0	\N	0	0	\N	\N	0	101711	0	38265-5	3049273		
27171	2521	3051031	1949-03-19	1949-03-19 00:00:00	1949-03-19	5001	0	\N	0	0	\N	\N	0	166722	0	46240-8	3051031		
43144	3984	3006322	1958-04-04	1958-04-04 00:00:00	1958-04-04	5001	0	\N	0	0	\N	\N	0	264820	0	8331-1	3006322		
43255	3997	3006322	1973-04-27	1973-04-27 00:00:00	1973-04-27	5001	0	\N	0	0	\N	\N	0	265730	0	8331-1	3006322		
43011	3976	40766240	1965-10-09	1965-10-09 00:00:00	1965-10-09	5001	0	\N	0	0	\N	\N	0	264324	0	63513-6	40766240		
22406	2054	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	136626	0	6276-0	3027231		
26033	2392	3011505	1976-01-30	1976-01-30 00:00:00	1976-01-30	5001	0	\N	0	0	\N	\N	0	159085	0	19926-5	3011505		
11796	1115	3012494	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	73440	0	6206-7	3012494		
1237	99	3011505	2019-04-27	2019-04-27 00:00:00	2019-04-27	5001	0	\N	0	0	\N	\N	0	6754	0	19926-5	3011505		
17694	1609	3006322	2008-09-24	2008-09-24 00:00:00	2008-09-24	5001	0	\N	0	0	\N	\N	0	108139	0	8331-1	3006322		
583	36	3006734	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	2539	0	6189-5	3006734		
42161	3895	40758406	1924-07-07	1924-07-07 00:00:00	1924-07-07	5001	0	\N	0	0	\N	\N	0	259053	0	55277-8	40758406		
39480	3650	3006322	1961-11-25	1961-11-25 00:00:00	1961-11-25	5001	0	\N	0	0	\N	\N	0	242991	0	8331-1	3006322		
53623	4924	3020655	1978-06-24	1978-06-24 00:00:00	1978-06-24	5001	0	\N	0	0	\N	\N	0	327278	0	6844-5	3020655		
17352	1577	3006923	1997-01-31	1997-01-31 00:00:00	1997-01-31	5001	0	\N	0	0	\N	\N	0	105932	0	1742-6	3006923		
57604	5285	46235214	1990-07-17	1990-07-17 00:00:00	1990-07-17	5001	0	\N	0	0	\N	\N	0	351661	0	76690-7	46235214		
7991	763	3006322	1966-10-13	1966-10-13 00:00:00	1966-10-13	5001	0	\N	0	0	\N	\N	0	50752	0	8331-1	3006322		
8526	807	3006322	2015-07-14	2015-07-14 00:00:00	2015-07-14	5001	0	\N	0	0	\N	\N	0	53576	0	8331-1	3006322		
47692	4376	3049273	2010-09-19	2010-09-19 00:00:00	2010-09-19	5001	0	\N	0	0	\N	\N	0	290735	0	38265-5	3049273		
3942	395	3006322	1971-10-20	1971-10-20 00:00:00	1971-10-20	5001	0	\N	0	0	\N	\N	0	25986	0	8331-1	3006322		
30875	2829	3006322	1961-05-12	1961-05-12 00:00:00	1961-05-12	5001	0	\N	0	0	\N	\N	0	187632	0	8331-1	3006322		
4105	406	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	26758	0	6844-5	3020655		
10044	956	40766240	1998-12-16	1998-12-16 00:00:00	1998-12-16	5001	0	\N	0	0	\N	\N	0	63492	0	63513-6	40766240		
27028	2503	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	165695	0	6095-4	3036780		
55261	5053	3009201	2017-02-07	2017-02-07 00:00:00	2017-02-07	5001	0	\N	0	0	\N	\N	0	336012	0	3016-3	3009201		
56585	1727	4133840	2015-11-18	2015-11-18 00:00:00	2015-11-18	5001	0	\N	0	0	\N	\N	0	115479	0	127783003	4133840		
23725	2180	3006322	1984-10-13	1984-10-13 00:00:00	1984-10-13	5001	0	\N	0	0	\N	\N	0	145399	0	8331-1	3006322		
29364	2705	3006322	1985-04-18	1985-04-18 00:00:00	1985-04-18	5001	0	\N	0	0	\N	\N	0	179180	0	8331-1	3006322		
44429	4106	3006322	1985-01-25	1985-01-25 00:00:00	1985-01-25	5001	0	\N	0	0	\N	\N	0	272864	0	8331-1	3006322		
40851	3789	3006322	1953-08-12	1953-08-12 00:00:00	1953-08-12	5001	0	\N	0	0	\N	\N	0	251934	0	8331-1	3006322		
43239	1328	4133840	2015-04-09	2015-04-09 00:00:00	2015-04-09	5001	0	\N	0	0	\N	\N	0	88234	0	127783003	4133840		
10676	1036	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	68103	0	6158-0	3019406		
14105	1317	3011505	2012-01-06	2012-01-06 00:00:00	2012-01-06	5001	0	\N	0	0	\N	\N	0	87332	0	19926-5	3011505		
41988	3884	3006322	2005-05-22	2005-05-22 00:00:00	2005-05-22	5001	0	\N	0	0	\N	\N	0	258155	0	8331-1	3006322		
30028	2765	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	182879	0	6273-7	3006451		
46289	1411	4024958	1978-12-11	1978-12-11 00:00:00	1978-12-11	5001	0	\N	0	0	\N	\N	0	93964	0	117015009	4024958		
4861	469	3006322	1951-05-27	1951-05-27 00:00:00	1951-05-27	5001	0	\N	0	0	\N	\N	0	31324	0	8331-1	3006322		
14485	1352	3011505	1998-06-28	1998-06-28 00:00:00	1998-06-28	5001	0	\N	0	0	\N	\N	0	89572	0	19926-5	3011505		
13620	431	4024958	1975-09-30	1975-09-30 00:00:00	1975-09-30	5001	0	\N	0	0	\N	\N	0	28584	0	117015009	4024958		
16434	1497	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	99807	0	6082-2	3000876		
47188	4347	3006322	1987-02-21	1987-02-21 00:00:00	1987-02-21	5001	0	\N	0	0	\N	\N	0	288302	0	8331-1	3006322		
49490	4506	46235214	2013-11-14	2013-11-14 00:00:00	2013-11-14	5001	0	\N	0	0	\N	\N	0	300177	0	76690-7	46235214		
11113	1073	3049273	1996-08-29	1996-08-29 00:00:00	1996-08-29	5001	0	\N	0	0	\N	\N	0	70353	0	38265-5	3049273		
48804	4462	3011505	2014-03-27	2014-03-27 00:00:00	2014-03-27	5001	0	\N	0	0	\N	\N	0	296924	0	19926-5	3011505		
63978	1967	4024958	2019-04-26	2019-04-26 00:00:00	2019-04-26	5001	0	\N	0	0	\N	\N	0	130878	0	117015009	4024958		
84914	2630	4052083	1980-04-27	1980-04-27 00:00:00	1980-04-27	5001	0	\N	0	0	\N	\N	0	173949	0	23426006	4052083		
162895	5000	4052083	1983-01-28	1983-01-28 00:00:00	1983-01-28	5001	0	\N	0	0	\N	\N	0	332545	0	23426006	4052083		
37721	3477	3000876	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	230607	0	6082-2	3000876		
16260	1482	3014599	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	98888	0	6106-9	3014599		
13449	1272	3005136	1992-09-18	1992-09-18 00:00:00	1992-09-18	5001	0	\N	0	0	\N	\N	0	83866	0	6075-6	3005136		
56944	5222	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	347449	0	6273-7	3006451		
11864	1135	3006322	1974-12-17	1974-12-17 00:00:00	1974-12-17	5001	0	\N	0	0	\N	\N	0	74739	0	8331-1	3006322		
20604	1892	3011505	2011-07-21	2011-07-21 00:00:00	2011-07-21	5001	0	\N	0	0	\N	\N	0	126014	0	19926-5	3011505		
39005	3604	3001488	1984-12-12	1984-12-12 00:00:00	1984-12-12	5001	0	\N	0	0	\N	\N	0	239520	0	7258-7	3001488		
154800	4749	4024958	2001-04-06	2001-04-06 00:00:00	2001-04-06	5001	0	\N	0	0	\N	\N	0	316270	0	117015009	4024958		
14880	1379	3011505	2000-02-19	2000-02-19 00:00:00	2000-02-19	5001	0	\N	0	0	\N	\N	0	91469	0	19926-5	3011505		
68279	2088	4133840	1996-05-14	1996-05-14 00:00:00	1996-05-14	5001	0	\N	0	0	\N	\N	0	139239	0	127783003	4133840		
16945	1538	3023430	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	102975	0	6833-8	3023430		
110459	3410	4052083	2007-02-01	2007-02-01 00:00:00	2007-02-01	5001	0	\N	0	0	\N	\N	0	226209	0	23426006	4052083		
5252	505	3027231	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	33756	0	6276-0	3027231		
57680	5290	3006322	1994-11-03	1994-11-03 00:00:00	1994-11-03	5001	0	\N	0	0	\N	\N	0	352008	0	8331-1	3006322		
16667	1520	3006322	2000-03-13	2000-03-13 00:00:00	2000-03-13	5001	0	\N	0	0	\N	\N	0	101636	0	8331-1	3006322		
27172	2521	40758406	1949-03-19	1949-03-19 00:00:00	1949-03-19	5001	0	\N	0	0	\N	\N	0	166722	0	55277-8	40758406		
43145	3984	3006322	1959-04-11	1959-04-11 00:00:00	1959-04-11	5001	0	\N	0	0	\N	\N	0	264841	0	8331-1	3006322		
43256	3997	3006322	1981-03-16	1981-03-16 00:00:00	1981-03-16	5001	0	\N	0	0	\N	\N	0	265737	0	8331-1	3006322		
43012	3976	3051031	1965-10-09	1965-10-09 00:00:00	1965-10-09	5001	0	\N	0	0	\N	\N	0	264324	0	46240-8	3051031		
22407	2054	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	136626	0	6273-7	3006451		
26034	2392	3011505	2009-07-24	2009-07-24 00:00:00	2009-07-24	5001	0	\N	0	0	\N	\N	0	159066	0	19926-5	3011505		
11797	1116	3006322	2006-10-23	2006-10-23 00:00:00	2006-10-23	5001	0	\N	0	0	\N	\N	0	73524	0	8331-1	3006322		
1238	99	3011505	2010-07-24	2010-07-24 00:00:00	2010-07-24	5001	0	\N	0	0	\N	\N	0	6768	0	19926-5	3011505		
17695	1609	3049273	2014-02-15	2014-02-15 00:00:00	2014-02-15	5001	0	\N	0	0	\N	\N	0	108165	0	38265-5	3049273		
584	36	3001488	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	2539	0	7258-7	3001488		
42163	3895	3049273	1994-05-20	1994-05-20 00:00:00	1994-05-20	5001	0	\N	0	0	\N	\N	0	259028	0	38265-5	3049273		
39481	3650	3006322	1940-11-06	1940-11-06 00:00:00	1940-11-06	5001	0	\N	0	0	\N	\N	0	242900	0	8331-1	3006322		
53624	4924	3006734	1978-06-24	1978-06-24 00:00:00	1978-06-24	5001	0	\N	0	0	\N	\N	0	327278	0	6189-5	3006734		
17353	1577	3010813	1997-01-31	1997-01-31 00:00:00	1997-01-31	5001	0	\N	0	0	\N	\N	0	105932	0	26464-8	3010813		
57606	5285	3051031	1990-07-17	1990-07-17 00:00:00	1990-07-17	5001	0	\N	0	0	\N	\N	0	351661	0	46240-8	3051031		
7992	763	3006322	1973-06-10	1973-06-10 00:00:00	1973-06-10	5001	0	\N	0	0	\N	\N	0	50748	0	8331-1	3006322		
8539	812	3006322	1977-08-20	1977-08-20 00:00:00	1977-08-20	5001	0	\N	0	0	\N	\N	0	53853	0	8331-1	3006322		
47693	4376	46235214	1947-10-18	1947-10-18 00:00:00	1947-10-18	5001	0	\N	0	0	\N	\N	0	290761	0	76690-7	46235214		
3943	395	3006322	2019-03-09	2019-03-09 00:00:00	2019-03-09	5001	0	\N	0	0	\N	\N	0	25956	0	8331-1	3006322		
30876	2829	3009201	2017-08-18	2017-08-18 00:00:00	2017-08-18	5001	0	\N	0	0	\N	\N	0	187647	0	3016-3	3009201		
4106	406	3006322	2016-03-13	2016-03-13 00:00:00	2016-03-13	5001	0	\N	0	0	\N	\N	0	26727	0	8331-1	3006322		
10046	956	3051031	1999-03-16	1999-03-16 00:00:00	1999-03-16	5001	0	\N	0	0	\N	\N	0	63493	0	46240-8	3051031		
27029	2503	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	165695	0	6106-9	3014599		
55262	5053	3008598	2017-02-07	2017-02-07 00:00:00	2017-02-07	5001	0	\N	0	0	\N	\N	0	336012	0	3024-7	3008598		
130511	4021	4024958	1999-03-14	1999-03-14 00:00:00	1999-03-14	5001	0	\N	0	0	\N	\N	0	267294	0	117015009	4024958		
23726	2180	3006322	2000-12-30	2000-12-30 00:00:00	2000-12-30	5001	0	\N	0	0	\N	\N	0	145401	0	8331-1	3006322		
29365	2706	3006322	1999-08-09	1999-08-09 00:00:00	1999-08-09	5001	0	\N	0	0	\N	\N	0	179254	0	8331-1	3006322		
44430	4106	3006322	1999-04-21	1999-04-21 00:00:00	1999-04-21	5001	0	\N	0	0	\N	\N	0	272866	0	8331-1	3006322		
40852	3790	3006322	1991-01-14	1991-01-14 00:00:00	1991-01-14	5001	0	\N	0	0	\N	\N	0	251999	0	8331-1	3006322		
43240	1328	4052083	1987-12-25	1987-12-25 00:00:00	1987-12-25	5001	0	\N	0	0	\N	\N	0	88162	0	23426006	4052083		
10677	1036	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	68103	0	6273-7	3006451		
14106	1317	3006322	2005-12-26	2005-12-26 00:00:00	2005-12-26	5001	0	\N	0	0	\N	\N	0	87248	0	8331-1	3006322		
41989	3884	3021226	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	258114	0	6246-3	3021226		
30029	2765	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	182879	0	6106-9	3014599		
46294	1412	4052083	2002-02-25	2002-02-25 00:00:00	2002-02-25	5001	0	\N	0	0	\N	\N	0	93997	0	23426006	4052083		
4862	469	3049273	2014-12-19	2014-12-19 00:00:00	2014-12-19	5001	0	\N	0	0	\N	\N	0	31366	0	38265-5	3049273		
14486	1353	3006322	1981-05-11	1981-05-11 00:00:00	1981-05-11	5001	0	\N	0	0	\N	\N	0	89666	0	8331-1	3006322		
13632	431	4024958	1964-09-30	1964-09-30 00:00:00	1964-09-30	5001	0	\N	0	0	\N	\N	0	28613	0	117015009	4024958		
16435	1497	3000963	1983-03-05	1983-03-05 00:00:00	1983-03-05	5001	0	\N	0	0	\N	\N	0	99768	0	718-7	3000963		
47189	4348	3006322	2017-07-29	2017-07-29 00:00:00	2017-07-29	5001	0	\N	0	0	\N	\N	0	288379	0	8331-1	3006322		
49491	4506	40766240	2003-03-02	2003-03-02 00:00:00	2003-03-02	5001	0	\N	0	0	\N	\N	0	300164	0	63513-6	40766240		
11114	1073	3006322	1983-06-20	1983-06-20 00:00:00	1983-06-20	5001	0	\N	0	0	\N	\N	0	70390	0	8331-1	3006322		
48805	4462	3011505	1993-03-18	1993-03-18 00:00:00	1993-03-18	5001	0	\N	0	0	\N	\N	0	296877	0	19926-5	3011505		
63990	1967	4024958	1993-04-22	1993-04-22 00:00:00	1993-04-22	5001	0	\N	0	0	\N	\N	0	130832	0	117015009	4024958		
84923	2631	4052083	1963-04-12	1963-04-12 00:00:00	1963-04-12	5001	0	\N	0	0	\N	\N	0	174051	0	23426006	4052083		
162902	5000	4024958	1944-08-11	1944-08-11 00:00:00	1944-08-11	5001	0	\N	0	0	\N	\N	0	332510	0	117015009	4024958		
37722	3477	3006451	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	230607	0	6273-7	3006451		
16261	1482	3011505	2011-11-26	2011-11-26 00:00:00	2011-11-26	5001	0	\N	0	0	\N	\N	0	98825	0	19926-5	3011505		
13450	1272	3014599	1992-09-18	1992-09-18 00:00:00	1992-09-18	5001	0	\N	0	0	\N	\N	0	83866	0	6106-9	3014599		
56945	5222	3011505	2014-04-10	2014-04-10 00:00:00	2014-04-10	5001	0	\N	0	0	\N	\N	0	347427	0	19926-5	3011505		
11865	1135	3006322	1972-03-19	1972-03-19 00:00:00	1972-03-19	5001	0	\N	0	0	\N	\N	0	74738	0	8331-1	3006322		
20605	1892	3011505	2017-08-24	2017-08-24 00:00:00	2017-08-24	5001	0	\N	0	0	\N	\N	0	126006	0	19926-5	3011505		
39006	3604	3006734	1984-12-12	1984-12-12 00:00:00	1984-12-12	5001	0	\N	0	0	\N	\N	0	239520	0	6189-5	3006734		
154808	4749	4024958	2003-08-10	2003-08-10 00:00:00	2003-08-10	5001	0	\N	0	0	\N	\N	0	316261	0	117015009	4024958		
14881	1379	3011505	2011-03-12	2011-03-12 00:00:00	2011-03-12	5001	0	\N	0	0	\N	\N	0	91472	0	19926-5	3011505		
68283	2088	4133840	1967-11-14	1967-11-14 00:00:00	1967-11-14	5001	0	\N	0	0	\N	\N	0	139249	0	127783003	4133840		
16946	1538	3020655	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	102975	0	6844-5	3020655		
110461	3410	4024958	1967-03-02	1967-03-02 00:00:00	1967-03-02	5001	0	\N	0	0	\N	\N	0	226192	0	117015009	4024958		
5253	505	3006734	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	33756	0	6189-5	3006734		
57681	5290	3006322	2005-05-23	2005-05-23 00:00:00	2005-05-23	5001	0	\N	0	0	\N	\N	0	351953	0	8331-1	3006322		
16668	1520	3006322	1955-06-18	1955-06-18 00:00:00	1955-06-18	5001	0	\N	0	0	\N	\N	0	101723	0	8331-1	3006322		
27174	2521	40766240	1949-03-19	1949-03-19 00:00:00	1949-03-19	5001	0	\N	0	0	\N	\N	0	166722	0	63513-6	40766240		
43146	3984	3049273	2018-07-21	2018-07-21 00:00:00	2018-07-21	5001	0	\N	0	0	\N	\N	0	264888	0	38265-5	3049273		
43257	3997	3000963	2018-11-08	2018-11-08 00:00:00	2018-11-08	5001	0	\N	0	0	\N	\N	0	265735	0	718-7	3000963		
43013	3976	40758406	1965-10-09	1965-10-09 00:00:00	1965-10-09	5001	0	\N	0	0	\N	\N	0	264324	0	55277-8	40758406		
22408	2054	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	136626	0	6106-9	3014599		
26035	2392	3006322	1967-01-27	1967-01-27 00:00:00	1967-01-27	5001	0	\N	0	0	\N	\N	0	159044	0	8331-1	3006322		
11798	1116	3006322	1972-12-04	1972-12-04 00:00:00	1972-12-04	5001	0	\N	0	0	\N	\N	0	73549	0	8331-1	3006322		
1239	99	3011505	2015-04-04	2015-04-04 00:00:00	2015-04-04	5001	0	\N	0	0	\N	\N	0	6752	0	19926-5	3011505		
53840	1632	4024958	1989-09-10	1989-09-10 00:00:00	1989-09-10	5001	0	\N	0	0	\N	\N	0	109570	0	117015009	4024958		
585	36	3036780	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	2539	0	6095-4	3036780		
42164	3895	3006322	1946-06-02	1946-06-02 00:00:00	1946-06-02	5001	0	\N	0	0	\N	\N	0	259047	0	8331-1	3006322		
39482	3650	3049273	1997-05-30	1997-05-30 00:00:00	1997-05-30	5001	0	\N	0	0	\N	\N	0	242923	0	38265-5	3049273		
53625	4924	3023430	1978-06-24	1978-06-24 00:00:00	1978-06-24	5001	0	\N	0	0	\N	\N	0	327278	0	6833-8	3023430		
17354	1577	3004501	1997-01-31	1997-01-31 00:00:00	1997-01-31	5001	0	\N	0	0	\N	\N	0	105932	0	2345-7	3004501		
57607	5285	40758406	1990-07-17	1990-07-17 00:00:00	1990-07-17	5001	0	\N	0	0	\N	\N	0	351661	0	55277-8	40758406		
7993	763	3006322	2017-02-25	2017-02-25 00:00:00	2017-02-25	5001	0	\N	0	0	\N	\N	0	50746	0	8331-1	3006322		
8540	812	3006322	2016-10-11	2016-10-11 00:00:00	2016-10-11	5001	0	\N	0	0	\N	\N	0	53865	0	8331-1	3006322		
47696	4376	40758406	1947-10-18	1947-10-18 00:00:00	1947-10-18	5001	0	\N	0	0	\N	\N	0	290761	0	55277-8	40758406		
3944	395	3006322	2017-04-05	2017-04-05 00:00:00	2017-04-05	5001	0	\N	0	0	\N	\N	0	25976	0	8331-1	3006322		
30877	2829	3008598	2017-08-18	2017-08-18 00:00:00	2017-08-18	5001	0	\N	0	0	\N	\N	0	187647	0	3024-7	3008598		
4107	406	3006322	1959-12-25	1959-12-25 00:00:00	1959-12-25	5001	0	\N	0	0	\N	\N	0	26807	0	8331-1	3006322		
10047	956	46235214	1999-03-16	1999-03-16 00:00:00	1999-03-16	5001	0	\N	0	0	\N	\N	0	63493	0	76690-7	46235214		
38307	3528	3006322	1989-02-18	1989-02-18 00:00:00	1989-02-18	5001	0	\N	0	0	\N	\N	0	234262	0	8331-1	3006322		
55263	5053	3006322	1967-03-14	1967-03-14 00:00:00	1967-03-14	5001	0	\N	0	0	\N	\N	0	335971	0	8331-1	3006322		
130519	4021	4024958	1960-12-12	1960-12-12 00:00:00	1960-12-12	5001	0	\N	0	0	\N	\N	0	267290	0	117015009	4024958		
23727	2180	3006322	1979-01-30	1979-01-30 00:00:00	1979-01-30	5001	0	\N	0	0	\N	\N	0	145404	0	8331-1	3006322		
29366	2706	40758406	1979-07-04	1979-07-04 00:00:00	1979-07-04	5001	0	\N	0	0	\N	\N	0	179263	0	55277-8	40758406		
44431	4107	3006322	1995-01-21	1995-01-21 00:00:00	1995-01-21	5001	0	\N	0	0	\N	\N	0	272890	0	8331-1	3006322		
40853	3790	3006322	1983-09-29	1983-09-29 00:00:00	1983-09-29	5001	0	\N	0	0	\N	\N	0	252002	0	8331-1	3006322		
43241	1328	4133840	2010-03-11	2010-03-11 00:00:00	2010-03-11	5001	0	\N	0	0	\N	\N	0	88213	0	127783003	4133840		
10678	1036	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	68103	0	6833-8	3023430		
14107	1317	3011505	2013-01-11	2013-01-11 00:00:00	2013-01-11	5001	0	\N	0	0	\N	\N	0	87302	0	19926-5	3011505		
41990	3884	3006734	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	258114	0	6189-5	3006734		
30031	2765	3011505	2016-12-27	2016-12-27 00:00:00	2016-12-27	5001	0	\N	0	0	\N	\N	0	182837	0	19926-5	3011505		
46302	1412	4052083	1991-02-08	1991-02-08 00:00:00	1991-02-08	5001	0	\N	0	0	\N	\N	0	94094	0	23426006	4052083		
4863	469	3006322	1936-11-28	1936-11-28 00:00:00	1936-11-28	5001	0	\N	0	0	\N	\N	0	31243	0	8331-1	3006322		
14487	1353	3006322	2007-02-21	2007-02-21 00:00:00	2007-02-21	5001	0	\N	0	0	\N	\N	0	89668	0	8331-1	3006322		
13633	431	4024958	1985-05-01	1985-05-01 00:00:00	1985-05-01	5001	0	\N	0	0	\N	\N	0	28614	0	117015009	4024958		
16436	1497	3009542	1983-03-05	1983-03-05 00:00:00	1983-03-05	5001	0	\N	0	0	\N	\N	0	99768	0	20570-8	3009542		
47190	4348	3006322	2007-07-11	2007-07-11 00:00:00	2007-07-11	5001	0	\N	0	0	\N	\N	0	288311	0	8331-1	3006322		
49492	4506	40758406	2003-03-02	2003-03-02 00:00:00	2003-03-02	5001	0	\N	0	0	\N	\N	0	300164	0	55277-8	40758406		
11115	1073	3006322	1986-02-19	1986-02-19 00:00:00	1986-02-19	5001	0	\N	0	0	\N	\N	0	70312	0	8331-1	3006322		
48806	4462	3011505	2006-02-09	2006-02-09 00:00:00	2006-02-09	5001	0	\N	0	0	\N	\N	0	296879	0	19926-5	3011505		
28344	877	4024958	2016-04-20	2016-04-20 00:00:00	2016-04-20	5001	0	\N	0	0	\N	\N	0	58468	0	117015009	4024958		
84929	2631	4024958	1960-02-29	1960-02-29 00:00:00	1960-02-29	5001	0	\N	0	0	\N	\N	0	174080	0	117015009	4024958		
162916	5001	4024958	1963-04-10	1963-04-10 00:00:00	1963-04-10	5001	0	\N	0	0	\N	\N	0	332644	0	117015009	4024958		
37723	3477	3015076	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	230607	0	6248-9	3015076		
16262	1482	3006322	2016-09-20	2016-09-20 00:00:00	2016-09-20	5001	0	\N	0	0	\N	\N	0	98839	0	8331-1	3006322		
13451	1272	3006734	1992-09-18	1992-09-18 00:00:00	1992-09-18	5001	0	\N	0	0	\N	\N	0	83866	0	6189-5	3006734		
56946	5222	3011505	2007-03-01	2007-03-01 00:00:00	2007-03-01	5001	0	\N	0	0	\N	\N	0	347426	0	19926-5	3011505		
11866	1135	3006322	2003-04-30	2003-04-30 00:00:00	2003-04-30	5001	0	\N	0	0	\N	\N	0	74742	0	8331-1	3006322		
20606	1892	3011505	2015-08-13	2015-08-13 00:00:00	2015-08-13	5001	0	\N	0	0	\N	\N	0	126016	0	19926-5	3011505		
39007	3604	3001247	1984-12-12	1984-12-12 00:00:00	1984-12-12	5001	0	\N	0	0	\N	\N	0	239520	0	6085-5	3001247		
154809	4749	4024958	1986-07-11	1986-07-11 00:00:00	1986-07-11	5001	0	\N	0	0	\N	\N	0	316250	0	117015009	4024958		
14882	1379	3011505	2009-02-28	2009-02-28 00:00:00	2009-02-28	5001	0	\N	0	0	\N	\N	0	91471	0	19926-5	3011505		
68284	2088	4133840	2010-02-23	2010-02-23 00:00:00	2010-02-23	5001	0	\N	0	0	\N	\N	0	139283	0	127783003	4133840		
16947	1538	3005136	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	102975	0	6075-6	3005136		
110462	3410	4024958	1980-07-03	1980-07-03 00:00:00	1980-07-03	5001	0	\N	0	0	\N	\N	0	226189	0	117015009	4024958		
5254	505	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	33739	0	6189-5	3006734		
57682	5290	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	351997	0	6082-2	3000876		
16669	1520	3006322	1946-05-22	1946-05-22 00:00:00	1946-05-22	5001	0	\N	0	0	\N	\N	0	101712	0	8331-1	3006322		
27175	2521	46235214	1949-03-19	1949-03-19 00:00:00	1949-03-19	5001	0	\N	0	0	\N	\N	0	166722	0	76690-7	46235214		
43147	3984	3006322	1968-01-21	1968-01-21 00:00:00	1968-01-21	5001	0	\N	0	0	\N	\N	0	264822	0	8331-1	3006322		
43258	3997	3009542	2018-11-08	2018-11-08 00:00:00	2018-11-08	5001	0	\N	0	0	\N	\N	0	265735	0	20570-8	3009542		
43015	3976	3006322	1967-09-07	1967-09-07 00:00:00	1967-09-07	5001	0	\N	0	0	\N	\N	0	264356	0	8331-1	3006322		
22409	2054	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	136626	0	6075-6	3005136		
26036	2392	3011505	1977-02-04	1977-02-04 00:00:00	1977-02-04	5001	0	\N	0	0	\N	\N	0	159076	0	19926-5	3011505		
11799	1117	3006322	1998-05-25	1998-05-25 00:00:00	1998-05-25	5001	0	\N	0	0	\N	\N	0	73565	0	8331-1	3006322		
1240	99	3011505	2012-08-04	2012-08-04 00:00:00	2012-08-04	5001	0	\N	0	0	\N	\N	0	6757	0	19926-5	3011505		
53841	1632	4024958	2011-09-24	2011-09-24 00:00:00	2011-09-24	5001	0	\N	0	0	\N	\N	0	109573	0	117015009	4024958		
586	36	3020655	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	2539	0	6844-5	3020655		
42165	3895	3006322	1964-08-05	1964-08-05 00:00:00	1964-08-05	5001	0	\N	0	0	\N	\N	0	259057	0	8331-1	3006322		
39483	3650	3006322	1980-06-13	1980-06-13 00:00:00	1980-06-13	5001	0	\N	0	0	\N	\N	0	242943	0	8331-1	3006322		
53626	4924	3036780	1978-06-24	1978-06-24 00:00:00	1978-06-24	5001	0	\N	0	0	\N	\N	0	327278	0	6095-4	3036780		
40601	3769	3006322	1978-04-29	1978-04-29 00:00:00	1978-04-29	5001	0	\N	0	0	\N	\N	0	250544	0	8331-1	3006322		
57608	5285	40766240	1990-07-17	1990-07-17 00:00:00	1990-07-17	5001	0	\N	0	0	\N	\N	0	351661	0	63513-6	40766240		
7994	764	3006322	1985-10-21	1985-10-21 00:00:00	1985-10-21	5001	0	\N	0	0	\N	\N	0	50814	0	8331-1	3006322		
8541	812	3006322	2005-05-01	2005-05-01 00:00:00	2005-05-01	5001	0	\N	0	0	\N	\N	0	53856	0	8331-1	3006322		
47697	4376	40766240	1947-10-18	1947-10-18 00:00:00	1947-10-18	5001	0	\N	0	0	\N	\N	0	290761	0	63513-6	40766240		
3945	395	3006322	1983-12-16	1983-12-16 00:00:00	1983-12-16	5001	0	\N	0	0	\N	\N	0	25954	0	8331-1	3006322		
30878	2829	3006322	1966-05-06	1966-05-06 00:00:00	1966-05-06	5001	0	\N	0	0	\N	\N	0	187658	0	8331-1	3006322		
4110	408	3006322	1964-08-22	1964-08-22 00:00:00	1964-08-22	5001	0	\N	0	0	\N	\N	0	26985	0	8331-1	3006322		
10049	956	40758406	1999-03-16	1999-03-16 00:00:00	1999-03-16	5001	0	\N	0	0	\N	\N	0	63493	0	55277-8	40758406		
38308	3529	3006322	1949-01-16	1949-01-16 00:00:00	1949-01-16	5001	0	\N	0	0	\N	\N	0	234433	0	8331-1	3006322		
55274	5056	3006322	1983-08-29	1983-08-29 00:00:00	1983-08-29	5001	0	\N	0	0	\N	\N	0	336199	0	8331-1	3006322		
130527	4021	4052083	1970-06-24	1970-06-24 00:00:00	1970-06-24	5001	0	\N	0	0	\N	\N	0	267306	0	23426006	4052083		
23747	2184	3006322	2003-04-19	2003-04-19 00:00:00	2003-04-19	5001	0	\N	0	0	\N	\N	0	145595	0	8331-1	3006322		
29368	2706	46235214	1979-07-04	1979-07-04 00:00:00	1979-07-04	5001	0	\N	0	0	\N	\N	0	179263	0	76690-7	46235214		
44432	4107	3006322	2004-10-25	2004-10-25 00:00:00	2004-10-25	5001	0	\N	0	0	\N	\N	0	272929	0	8331-1	3006322		
40854	3790	3006322	1979-05-09	1979-05-09 00:00:00	1979-05-09	5001	0	\N	0	0	\N	\N	0	252001	0	8331-1	3006322		
43244	1328	4133840	2018-04-26	2018-04-26 00:00:00	2018-04-26	5001	0	\N	0	0	\N	\N	0	88216	0	127783003	4133840		
10679	1036	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	68103	0	6844-5	3020655		
14108	1318	3006322	1953-07-13	1953-07-13 00:00:00	1953-07-13	5001	0	\N	0	0	\N	\N	0	87340	0	8331-1	3006322		
41991	3884	3023430	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	258114	0	6833-8	3023430		
30033	2765	3006322	2007-08-26	2007-08-26 00:00:00	2007-08-26	5001	0	\N	0	0	\N	\N	0	183002	0	8331-1	3006322		
46307	1412	4052083	1975-11-27	1975-11-27 00:00:00	1975-11-27	5001	0	\N	0	0	\N	\N	0	94081	0	23426006	4052083		
4864	470	3006322	1960-02-15	1960-02-15 00:00:00	1960-02-15	5001	0	\N	0	0	\N	\N	0	31412	0	8331-1	3006322		
14488	1353	3049273	1968-08-09	1968-08-09 00:00:00	1968-08-09	5001	0	\N	0	0	\N	\N	0	89640	0	38265-5	3049273		
13635	431	4052083	1989-05-04	1989-05-04 00:00:00	1989-05-04	5001	0	\N	0	0	\N	\N	0	28597	0	23426006	4052083		
16437	1497	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	99821	0	6082-2	3000876		
47191	4349	3006322	1999-06-19	1999-06-19 00:00:00	1999-06-19	5001	0	\N	0	0	\N	\N	0	288422	0	8331-1	3006322		
49493	4506	3051031	2003-03-02	2003-03-02 00:00:00	2003-03-02	5001	0	\N	0	0	\N	\N	0	300164	0	46240-8	3051031		
11116	1073	3006322	1996-08-08	1996-08-08 00:00:00	1996-08-08	5001	0	\N	0	0	\N	\N	0	70422	0	8331-1	3006322		
48811	4465	3006322	2006-03-08	2006-03-08 00:00:00	2006-03-08	5001	0	\N	0	0	\N	\N	0	297057	0	8331-1	3006322		
28345	877	4052083	1998-03-16	1998-03-16 00:00:00	1998-03-16	5001	0	\N	0	0	\N	\N	0	58461	0	23426006	4052083		
84932	2631	4052083	1991-10-20	1991-10-20 00:00:00	1991-10-20	5001	0	\N	0	0	\N	\N	0	174102	0	23426006	4052083		
162919	5001	4024958	2001-02-25	2001-02-25 00:00:00	2001-02-25	5001	0	\N	0	0	\N	\N	0	332618	0	117015009	4024958		
37724	3477	3006322	2006-01-02	2006-01-02 00:00:00	2006-01-02	5001	0	\N	0	0	\N	\N	0	230679	0	8331-1	3006322		
16263	1482	3011505	2008-11-22	2008-11-22 00:00:00	2008-11-22	5001	0	\N	0	0	\N	\N	0	98824	0	19926-5	3011505		
13452	1272	3006451	1980-05-24	1980-05-24 00:00:00	1980-05-24	5001	0	\N	0	0	\N	\N	0	83864	0	6273-7	3006451		
56947	5222	3011505	2000-01-20	2000-01-20 00:00:00	2000-01-20	5001	0	\N	0	0	\N	\N	0	347465	0	19926-5	3011505		
11867	1135	3006322	2009-10-06	2009-10-06 00:00:00	2009-10-06	5001	0	\N	0	0	\N	\N	0	74772	0	8331-1	3006322		
20607	1892	3006322	1987-12-16	1987-12-16 00:00:00	1987-12-16	5001	0	\N	0	0	\N	\N	0	126034	0	8331-1	3006322		
39008	3604	3023430	1984-12-12	1984-12-12 00:00:00	1984-12-12	5001	0	\N	0	0	\N	\N	0	239520	0	6833-8	3023430		
154812	4749	4024958	1981-10-07	1981-10-07 00:00:00	1981-10-07	5001	0	\N	0	0	\N	\N	0	316249	0	117015009	4024958		
14883	1379	3011505	2000-08-12	2000-08-12 00:00:00	2000-08-12	5001	0	\N	0	0	\N	\N	0	91449	0	19926-5	3011505		
68288	2088	4133840	1973-07-31	1973-07-31 00:00:00	1973-07-31	5001	0	\N	0	0	\N	\N	0	139211	0	127783003	4133840		
16948	1538	3015076	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	102975	0	6248-9	3015076		
110464	3410	4052083	2018-03-14	2018-03-14 00:00:00	2018-03-14	5001	0	\N	0	0	\N	\N	0	226179	0	23426006	4052083		
5255	505	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	33739	0	6095-4	3036780		
57683	5290	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	351997	0	6158-0	3019406		
16680	1523	3006322	1996-10-11	1996-10-11 00:00:00	1996-10-11	5001	0	\N	0	0	\N	\N	0	101885	0	8331-1	3006322		
27176	2521	3006322	1967-04-15	1967-04-15 00:00:00	1967-04-15	5001	0	\N	0	0	\N	\N	0	166730	0	8331-1	3006322		
43151	3986	3006322	1974-04-03	1974-04-03 00:00:00	1974-04-03	5001	0	\N	0	0	\N	\N	0	264982	0	8331-1	3006322		
43259	3997	3006322	1969-08-23	1969-08-23 00:00:00	1969-08-23	5001	0	\N	0	0	\N	\N	0	265728	0	8331-1	3006322		
43016	3976	3006322	1989-09-03	1989-09-03 00:00:00	1989-09-03	5001	0	\N	0	0	\N	\N	0	264344	0	8331-1	3006322		
22410	2054	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	136626	0	6246-3	3021226		
26037	2392	3011505	1975-03-21	1975-03-21 00:00:00	1975-03-21	5001	0	\N	0	0	\N	\N	0	159084	0	19926-5	3011505		
11800	1117	3006322	1957-11-30	1957-11-30 00:00:00	1957-11-30	5001	0	\N	0	0	\N	\N	0	73622	0	8331-1	3006322		
1241	99	3006322	1992-04-11	1992-04-11 00:00:00	1992-04-11	5001	0	\N	0	0	\N	\N	0	6720	0	8331-1	3006322		
120133	3703	4024958	2014-07-22	2014-07-22 00:00:00	2014-07-22	5001	0	\N	0	0	\N	\N	0	246231	0	117015009	4024958		
587	36	3001247	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	2539	0	6085-5	3001247		
42166	3896	3006322	1987-02-21	1987-02-21 00:00:00	1987-02-21	5001	0	\N	0	0	\N	\N	0	259187	0	8331-1	3006322		
39484	3651	3006322	1979-08-15	1979-08-15 00:00:00	1979-08-15	5001	0	\N	0	0	\N	\N	0	243068	0	8331-1	3006322		
53627	4924	3027231	1978-06-24	1978-06-24 00:00:00	1978-06-24	5001	0	\N	0	0	\N	\N	0	327278	0	6276-0	3027231		
40602	3769	40758406	2017-12-06	2017-12-06 00:00:00	2017-12-06	5001	0	\N	0	0	\N	\N	0	250579	0	55277-8	40758406		
57610	5285	3006322	1959-07-20	1959-07-20 00:00:00	1959-07-20	5001	0	\N	0	0	\N	\N	0	351697	0	8331-1	3006322		
7996	764	40766240	1973-11-11	1973-11-11 00:00:00	1973-11-11	5001	0	\N	0	0	\N	\N	0	50806	0	63513-6	40766240		
8542	812	3006322	1973-10-30	1973-10-30 00:00:00	1973-10-30	5001	0	\N	0	0	\N	\N	0	53833	0	8331-1	3006322		
47698	4376	3051031	1947-10-18	1947-10-18 00:00:00	1947-10-18	5001	0	\N	0	0	\N	\N	0	290761	0	46240-8	3051031		
3946	395	3006322	1984-12-24	1984-12-24 00:00:00	1984-12-24	5001	0	\N	0	0	\N	\N	0	25987	0	8331-1	3006322		
30879	2829	3006322	1989-01-08	1989-01-08 00:00:00	1989-01-08	5001	0	\N	0	0	\N	\N	0	187660	0	8331-1	3006322		
4111	408	3006322	1991-08-24	1991-08-24 00:00:00	1991-08-24	5001	0	\N	0	0	\N	\N	0	26988	0	8331-1	3006322		
10050	956	40766240	1999-03-16	1999-03-16 00:00:00	1999-03-16	5001	0	\N	0	0	\N	\N	0	63493	0	63513-6	40766240		
38309	3529	3049273	2004-08-04	2004-08-04 00:00:00	2004-08-04	5001	0	\N	0	0	\N	\N	0	234354	0	38265-5	3049273		
55275	5056	3049273	2005-10-12	2005-10-12 00:00:00	2005-10-12	5001	0	\N	0	0	\N	\N	0	336181	0	38265-5	3049273		
130536	4022	4024958	1978-10-04	1978-10-04 00:00:00	1978-10-04	5001	0	\N	0	0	\N	\N	0	267389	0	117015009	4024958		
23748	2184	3006322	1973-01-15	1973-01-15 00:00:00	1973-01-15	5001	0	\N	0	0	\N	\N	0	145594	0	8331-1	3006322		
29369	2706	3051031	1979-06-04	1979-06-04 00:00:00	1979-06-04	5001	0	\N	0	0	\N	\N	0	179311	0	46240-8	3051031		
44433	4107	3006322	2018-01-15	2018-01-15 00:00:00	2018-01-15	5001	0	\N	0	0	\N	\N	0	272893	0	8331-1	3006322		
40855	3790	3006322	1984-01-08	1984-01-08 00:00:00	1984-01-08	5001	0	\N	0	0	\N	\N	0	251996	0	8331-1	3006322		
43246	1328	4024958	1951-11-09	1951-11-09 00:00:00	1951-11-09	5001	0	\N	0	0	\N	\N	0	88176	0	117015009	4024958		
10680	1036	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	68103	0	7258-7	3001488		
14109	1318	3006322	1950-04-18	1950-04-18 00:00:00	1950-04-18	5001	0	\N	0	0	\N	\N	0	87339	0	8331-1	3006322		
41992	3884	3001247	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	258114	0	6085-5	3001247		
30034	2765	3006322	2001-02-11	2001-02-11 00:00:00	2001-02-11	5001	0	\N	0	0	\N	\N	0	183001	0	8331-1	3006322		
46308	1412	4052083	2018-07-31	2018-07-31 00:00:00	2018-07-31	5001	0	\N	0	0	\N	\N	0	93989	0	23426006	4052083		
4865	470	3006322	2017-10-26	2017-10-26 00:00:00	2017-10-26	5001	0	\N	0	0	\N	\N	0	31421	0	8331-1	3006322		
14489	1353	3006322	1966-01-04	1966-01-04 00:00:00	1966-01-04	5001	0	\N	0	0	\N	\N	0	89700	0	8331-1	3006322		
13640	431	4024958	1960-09-09	1960-09-09 00:00:00	1960-09-09	5001	0	\N	0	0	\N	\N	0	28552	0	117015009	4024958		
16438	1497	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	99821	0	6246-3	3021226		
47192	4349	3006322	1992-07-14	1992-07-14 00:00:00	1992-07-14	5001	0	\N	0	0	\N	\N	0	288431	0	8331-1	3006322		
49494	4506	46235214	2003-03-02	2003-03-02 00:00:00	2003-03-02	5001	0	\N	0	0	\N	\N	0	300164	0	76690-7	46235214		
11117	1073	3006322	1980-03-23	1980-03-23 00:00:00	1980-03-23	5001	0	\N	0	0	\N	\N	0	70311	0	8331-1	3006322		
48812	4465	3006322	2009-01-31	2009-01-31 00:00:00	2009-01-31	5001	0	\N	0	0	\N	\N	0	297087	0	8331-1	3006322		
28352	877	4024958	1992-07-15	1992-07-15 00:00:00	1992-07-15	5001	0	\N	0	0	\N	\N	0	58430	0	117015009	4024958		
84943	2631	4024958	1962-02-02	1962-02-02 00:00:00	1962-02-02	5001	0	\N	0	0	\N	\N	0	174050	0	117015009	4024958		
65738	2020	4024958	1999-11-27	1999-11-27 00:00:00	1999-11-27	5001	0	\N	0	0	\N	\N	0	134246	0	117015009	4024958		
142561	4380	4052083	1971-09-13	1971-09-13 00:00:00	1971-09-13	5001	0	\N	0	0	\N	\N	0	291028	0	23426006	4052083		
16264	1482	3011505	2014-10-25	2014-10-25 00:00:00	2014-10-25	5001	0	\N	0	0	\N	\N	0	98826	0	19926-5	3011505		
13453	1272	3015076	1980-05-24	1980-05-24 00:00:00	1980-05-24	5001	0	\N	0	0	\N	\N	0	83864	0	6248-9	3015076		
56948	5222	3011505	2018-08-23	2018-08-23 00:00:00	2018-08-23	5001	0	\N	0	0	\N	\N	0	347345	0	19926-5	3011505		
11868	1136	3006322	1989-11-15	1989-11-15 00:00:00	1989-11-15	5001	0	\N	0	0	\N	\N	0	74859	0	8331-1	3006322		
20608	1892	3006322	1969-09-28	1969-09-28 00:00:00	1969-09-28	5001	0	\N	0	0	\N	\N	0	126024	0	8331-1	3006322		
39009	3604	3020655	1984-12-12	1984-12-12 00:00:00	1984-12-12	5001	0	\N	0	0	\N	\N	0	239520	0	6844-5	3020655		
154828	4750	4024958	1980-04-10	1980-04-10 00:00:00	1980-04-10	5001	0	\N	0	0	\N	\N	0	316335	0	117015009	4024958		
14884	1379	3006322	1972-01-11	1972-01-11 00:00:00	1972-01-11	5001	0	\N	0	0	\N	\N	0	91492	0	8331-1	3006322		
137278	4227	4052083	1993-10-27	1993-10-27 00:00:00	1993-10-27	5001	0	\N	0	0	\N	\N	0	280854	0	23426006	4052083		
16949	1538	3014599	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	102975	0	6106-9	3014599		
110471	3410	4024958	1969-04-05	1969-04-05 00:00:00	1969-04-05	5001	0	\N	0	0	\N	\N	0	226193	0	117015009	4024958		
5256	505	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	33739	0	6206-7	3012494		
57684	5290	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	351997	0	6085-5	3001247		
16681	1524	3006322	1969-01-04	1969-01-04 00:00:00	1969-01-04	5001	0	\N	0	0	\N	\N	0	101915	0	8331-1	3006322		
27177	2521	3006322	2012-11-29	2012-11-29 00:00:00	2012-11-29	5001	0	\N	0	0	\N	\N	0	166770	0	8331-1	3006322		
43152	3986	3006322	1967-02-27	1967-02-27 00:00:00	1967-02-27	5001	0	\N	0	0	\N	\N	0	264985	0	8331-1	3006322		
43260	3997	3006322	2018-03-28	2018-03-28 00:00:00	2018-03-28	5001	0	\N	0	0	\N	\N	0	265734	0	8331-1	3006322		
43017	3976	46235214	1964-09-14	1964-09-14 00:00:00	1964-09-14	5001	0	\N	0	0	\N	\N	0	264381	0	76690-7	46235214		
22411	2054	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	136626	0	6833-8	3023430		
26038	2392	3011505	1960-01-29	1960-01-29 00:00:00	1960-01-29	5001	0	\N	0	0	\N	\N	0	159082	0	19926-5	3011505		
11801	1117	3006322	1997-02-14	1997-02-14 00:00:00	1997-02-14	5001	0	\N	0	0	\N	\N	0	73643	0	8331-1	3006322		
1242	99	3011505	2013-08-10	2013-08-10 00:00:00	2013-08-10	5001	0	\N	0	0	\N	\N	0	6750	0	19926-5	3011505		
120137	3703	4024958	2006-05-13	2006-05-13 00:00:00	2006-05-13	5001	0	\N	0	0	\N	\N	0	246275	0	117015009	4024958		
588	36	3023430	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	2539	0	6833-8	3023430		
42167	3896	3006322	1988-03-28	1988-03-28 00:00:00	1988-03-28	5001	0	\N	0	0	\N	\N	0	259139	0	8331-1	3006322		
39485	3651	3006322	1996-08-06	1996-08-06 00:00:00	1996-08-06	5001	0	\N	0	0	\N	\N	0	243047	0	8331-1	3006322		
53628	4924	3006451	1978-06-24	1978-06-24 00:00:00	1978-06-24	5001	0	\N	0	0	\N	\N	0	327278	0	6273-7	3006451		
40603	3769	3051031	2017-12-06	2017-12-06 00:00:00	2017-12-06	5001	0	\N	0	0	\N	\N	0	250579	0	46240-8	3051031		
57611	5285	46235214	1989-12-19	1989-12-19 00:00:00	1989-12-19	5001	0	\N	0	0	\N	\N	0	351625	0	76690-7	46235214		
7998	764	40758406	1973-11-11	1973-11-11 00:00:00	1973-11-11	5001	0	\N	0	0	\N	\N	0	50806	0	55277-8	40758406		
8543	812	3006322	1994-12-03	1994-12-03 00:00:00	1994-12-03	5001	0	\N	0	0	\N	\N	0	53836	0	8331-1	3006322		
47699	4376	3011505	2012-01-03	2012-01-03 00:00:00	2012-01-03	5001	0	\N	0	0	\N	\N	0	290822	0	19926-5	3011505		
3947	395	3006322	2014-06-05	2014-06-05 00:00:00	2014-06-05	5001	0	\N	0	0	\N	\N	0	25955	0	8331-1	3006322		
30880	2829	3006322	1963-03-12	1963-03-12 00:00:00	1963-03-12	5001	0	\N	0	0	\N	\N	0	187657	0	8331-1	3006322		
4112	408	3006322	1967-11-17	1967-11-17 00:00:00	1967-11-17	5001	0	\N	0	0	\N	\N	0	26940	0	8331-1	3006322		
10052	956	46235214	1998-08-18	1998-08-18 00:00:00	1998-08-18	5001	0	\N	0	0	\N	\N	0	63450	0	76690-7	46235214		
38310	3529	3006322	1989-05-19	1989-05-19 00:00:00	1989-05-19	5001	0	\N	0	0	\N	\N	0	234440	0	8331-1	3006322		
55276	5056	3006322	1981-04-27	1981-04-27 00:00:00	1981-04-27	5001	0	\N	0	0	\N	\N	0	336229	0	8331-1	3006322		
27977	869	4024958	1922-06-02	1922-06-02 00:00:00	1922-06-02	5001	0	\N	0	0	\N	\N	0	57808	0	117015009	4024958		
23749	2185	3006322	2013-10-25	2013-10-25 00:00:00	2013-10-25	5001	0	\N	0	0	\N	\N	0	145684	0	8331-1	3006322		
29370	2706	40766240	1979-06-04	1979-06-04 00:00:00	1979-06-04	5001	0	\N	0	0	\N	\N	0	179311	0	63513-6	40766240		
44434	4107	3006322	1996-09-22	1996-09-22 00:00:00	1996-09-22	5001	0	\N	0	0	\N	\N	0	272903	0	8331-1	3006322		
40856	3790	3006322	2004-08-03	2004-08-03 00:00:00	2004-08-03	5001	0	\N	0	0	\N	\N	0	252022	0	8331-1	3006322		
43247	1328	4024958	1993-02-22	1993-02-22 00:00:00	1993-02-22	5001	0	\N	0	0	\N	\N	0	88136	0	117015009	4024958		
10681	1036	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	68103	0	6095-4	3036780		
14115	1318	3006322	1949-10-09	1949-10-09 00:00:00	1949-10-09	5001	0	\N	0	0	\N	\N	0	87335	0	8331-1	3006322		
41993	3884	3036780	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	258114	0	6095-4	3036780		
30036	2767	40758406	2015-05-19	2015-05-19 00:00:00	2015-05-19	5001	0	\N	0	0	\N	\N	0	183023	0	55277-8	40758406		
46314	1412	4052083	2011-01-12	2011-01-12 00:00:00	2011-01-12	5001	0	\N	0	0	\N	\N	0	93986	0	23426006	4052083		
4866	470	3006322	1964-05-05	1964-05-05 00:00:00	1964-05-05	5001	0	\N	0	0	\N	\N	0	31405	0	8331-1	3006322		
14490	1353	3006322	2009-12-22	2009-12-22 00:00:00	2009-12-22	5001	0	\N	0	0	\N	\N	0	89669	0	8331-1	3006322		
13641	431	4024958	1978-08-26	1978-08-26 00:00:00	1978-08-26	5001	0	\N	0	0	\N	\N	0	28620	0	117015009	4024958		
16439	1497	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	99821	0	6106-9	3014599		
26008	812	4052083	1996-09-26	1996-09-26 00:00:00	1996-09-26	5001	0	\N	0	0	\N	\N	0	53855	0	23426006	4052083		
49497	4506	3006322	2017-08-04	2017-08-04 00:00:00	2017-08-04	5001	0	\N	0	0	\N	\N	0	300180	0	8331-1	3006322		
11118	1073	3006322	1972-01-22	1972-01-22 00:00:00	1972-01-22	5001	0	\N	0	0	\N	\N	0	70388	0	8331-1	3006322		
48813	4466	3006322	1976-02-09	1976-02-09 00:00:00	1976-02-09	5001	0	\N	0	0	\N	\N	0	297092	0	8331-1	3006322		
28366	877	4052083	2014-07-22	2014-07-22 00:00:00	2014-07-22	5001	0	\N	0	0	\N	\N	0	58384	0	23426006	4052083		
66764	2051	4024958	1993-06-13	1993-06-13 00:00:00	1993-06-13	5001	0	\N	0	0	\N	\N	0	136350	0	117015009	4024958		
65740	2020	4024958	1974-05-15	1974-05-15 00:00:00	1974-05-15	5001	0	\N	0	0	\N	\N	0	134267	0	117015009	4024958		
142566	4380	4024958	1986-06-07	1986-06-07 00:00:00	1986-06-07	5001	0	\N	0	0	\N	\N	0	291033	0	117015009	4024958		
16265	1482	3005136	1975-07-28	1975-07-28 00:00:00	1975-07-28	5001	0	\N	0	0	\N	\N	0	98904	0	6075-6	3005136		
13454	1272	3012494	1980-05-24	1980-05-24 00:00:00	1980-05-24	5001	0	\N	0	0	\N	\N	0	83864	0	6206-7	3012494		
56949	5222	3011505	2015-08-06	2015-08-06 00:00:00	2015-08-06	5001	0	\N	0	0	\N	\N	0	347469	0	19926-5	3011505		
11869	1136	3006322	2001-10-18	2001-10-18 00:00:00	2001-10-18	5001	0	\N	0	0	\N	\N	0	74869	0	8331-1	3006322		
20609	1892	3006322	1999-10-29	1999-10-29 00:00:00	1999-10-29	5001	0	\N	0	0	\N	\N	0	125991	0	8331-1	3006322		
39010	3604	3027231	1984-12-12	1984-12-12 00:00:00	1984-12-12	5001	0	\N	0	0	\N	\N	0	239520	0	6276-0	3027231		
154835	4750	4024958	2001-07-15	2001-07-15 00:00:00	2001-07-15	5001	0	\N	0	0	\N	\N	0	316402	0	117015009	4024958		
14885	1379	3011505	2007-02-24	2007-02-24 00:00:00	2007-02-24	5001	0	\N	0	0	\N	\N	0	91507	0	19926-5	3011505		
137279	4227	4024958	1961-05-27	1961-05-27 00:00:00	1961-05-27	5001	0	\N	0	0	\N	\N	0	280819	0	117015009	4024958		
16950	1538	3012494	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	102975	0	6206-7	3012494		
145155	4454	4024958	1932-12-25	1932-12-25 00:00:00	1932-12-25	5001	0	\N	0	0	\N	\N	0	296385	0	117015009	4024958		
5257	505	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	33739	0	7258-7	3001488		
57685	5290	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	351997	0	6273-7	3006451		
16682	1524	3006322	1968-09-21	1968-09-21 00:00:00	1968-09-21	5001	0	\N	0	0	\N	\N	0	101910	0	8331-1	3006322		
27178	2521	3006322	1955-02-07	1955-02-07 00:00:00	1955-02-07	5001	0	\N	0	0	\N	\N	0	166729	0	8331-1	3006322		
43153	3986	3006322	2000-04-01	2000-04-01 00:00:00	2000-04-01	5001	0	\N	0	0	\N	\N	0	264984	0	8331-1	3006322		
43261	3997	3006322	1967-05-21	1967-05-21 00:00:00	1967-05-21	5001	0	\N	0	0	\N	\N	0	265774	0	8331-1	3006322		
43018	3976	40758406	1964-09-14	1964-09-14 00:00:00	1964-09-14	5001	0	\N	0	0	\N	\N	0	264381	0	55277-8	40758406		
22412	2054	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	136626	0	6095-4	3036780		
26039	2392	3011505	2018-11-02	2018-11-02 00:00:00	2018-11-02	5001	0	\N	0	0	\N	\N	0	158978	0	19926-5	3011505		
11802	1118	3006322	1994-03-29	1994-03-29 00:00:00	1994-03-29	5001	0	\N	0	0	\N	\N	0	73677	0	8331-1	3006322		
1243	99	3006322	1972-01-30	1972-01-30 00:00:00	1972-01-30	5001	0	\N	0	0	\N	\N	0	6772	0	8331-1	3006322		
120145	3703	4024958	2010-01-01	2010-01-01 00:00:00	2010-01-01	5001	0	\N	0	0	\N	\N	0	246297	0	117015009	4024958		
589	36	3000876	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	2539	0	6082-2	3000876		
42168	3896	3006322	1990-01-26	1990-01-26 00:00:00	1990-01-26	5001	0	\N	0	0	\N	\N	0	259165	0	8331-1	3006322		
39486	3651	3006322	2005-06-06	2005-06-06 00:00:00	2005-06-06	5001	0	\N	0	0	\N	\N	0	243049	0	8331-1	3006322		
53629	4924	3014599	1978-06-24	1978-06-24 00:00:00	1978-06-24	5001	0	\N	0	0	\N	\N	0	327278	0	6106-9	3014599		
40604	3769	46235214	2017-12-06	2017-12-06 00:00:00	2017-12-06	5001	0	\N	0	0	\N	\N	0	250579	0	76690-7	46235214		
57612	5285	40758406	1989-12-19	1989-12-19 00:00:00	1989-12-19	5001	0	\N	0	0	\N	\N	0	351625	0	55277-8	40758406		
7999	764	46235214	1973-11-11	1973-11-11 00:00:00	1973-11-11	5001	0	\N	0	0	\N	\N	0	50806	0	76690-7	46235214		
8544	812	3006322	1971-10-01	1971-10-01 00:00:00	1971-10-01	5001	0	\N	0	0	\N	\N	0	53862	0	8331-1	3006322		
47700	4376	40766240	1999-02-02	1999-02-02 00:00:00	1999-02-02	5001	0	\N	0	0	\N	\N	0	290746	0	63513-6	40766240		
3948	395	3006322	1995-06-28	1995-06-28 00:00:00	1995-06-28	5001	0	\N	0	0	\N	\N	0	25949	0	8331-1	3006322		
30881	2830	3006322	1983-06-29	1983-06-29 00:00:00	1983-06-29	5001	0	\N	0	0	\N	\N	0	187785	0	8331-1	3006322		
4113	408	3006322	2010-06-29	2010-06-29 00:00:00	2010-06-29	5001	0	\N	0	0	\N	\N	0	26968	0	8331-1	3006322		
10053	956	3051031	1998-08-18	1998-08-18 00:00:00	1998-08-18	5001	0	\N	0	0	\N	\N	0	63450	0	46240-8	3051031		
38311	3529	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	234409	0	6246-3	3021226		
55277	5056	3006322	2004-11-25	2004-11-25 00:00:00	2004-11-25	5001	0	\N	0	0	\N	\N	0	336125	0	8331-1	3006322		
27995	870	4052083	2008-03-10	2008-03-10 00:00:00	2008-03-10	5001	0	\N	0	0	\N	\N	0	57854	0	23426006	4052083		
23750	2185	3049273	2000-09-28	2000-09-28 00:00:00	2000-09-28	5001	0	\N	0	0	\N	\N	0	145629	0	38265-5	3049273		
29373	2706	46235214	1979-06-04	1979-06-04 00:00:00	1979-06-04	5001	0	\N	0	0	\N	\N	0	179311	0	76690-7	46235214		
44435	4107	3006322	1987-04-18	1987-04-18 00:00:00	1987-04-18	5001	0	\N	0	0	\N	\N	0	272928	0	8331-1	3006322		
40857	3790	3006322	2001-02-05	2001-02-05 00:00:00	2001-02-05	5001	0	\N	0	0	\N	\N	0	251980	0	8331-1	3006322		
43249	1328	4133840	1980-12-04	1980-12-04 00:00:00	1980-12-04	5001	0	\N	0	0	\N	\N	0	88227	0	127783003	4133840		
10682	1036	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	68103	0	6189-5	3006734		
14118	1320	3049273	1993-08-09	1993-08-09 00:00:00	1993-08-09	5001	0	\N	0	0	\N	\N	0	87476	0	38265-5	3049273		
41994	3884	3015076	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	258114	0	6248-9	3015076		
30038	2767	3051031	2015-05-19	2015-05-19 00:00:00	2015-05-19	5001	0	\N	0	0	\N	\N	0	183023	0	46240-8	3051031		
46322	1412	4024958	1995-07-20	1995-07-20 00:00:00	1995-07-20	5001	0	\N	0	0	\N	\N	0	93984	0	117015009	4024958		
4867	470	3006322	1989-01-14	1989-01-14 00:00:00	1989-01-14	5001	0	\N	0	0	\N	\N	0	31407	0	8331-1	3006322		
41926	1294	4024958	2014-07-12	2014-07-12 00:00:00	2014-07-12	5001	0	\N	0	0	\N	\N	0	85615	0	117015009	4024958		
117108	3609	4024958	2008-07-26	2008-07-26 00:00:00	2008-07-26	5001	0	\N	0	0	\N	\N	0	239791	0	117015009	4024958		
16440	1497	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	99821	0	6158-0	3019406		
26014	812	4024958	1971-10-01	1971-10-01 00:00:00	1971-10-01	5001	0	\N	0	0	\N	\N	0	53862	0	117015009	4024958		
49498	4506	40766240	2002-08-04	2002-08-04 00:00:00	2002-08-04	5001	0	\N	0	0	\N	\N	0	300238	0	63513-6	40766240		
11126	1076	3006322	2009-06-26	2009-06-26 00:00:00	2009-06-26	5001	0	\N	0	0	\N	\N	0	70550	0	8331-1	3006322		
73487	2260	4024958	1975-11-14	1975-11-14 00:00:00	1975-11-14	5001	0	\N	0	0	\N	\N	0	150233	0	117015009	4024958		
28406	879	4024958	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	58583	0	117015009	4024958		
66766	2052	4052083	1973-03-28	1973-03-28 00:00:00	1973-03-28	5001	0	\N	0	0	\N	\N	0	136438	0	23426006	4052083		
65741	2020	4024958	2015-05-20	2015-05-20 00:00:00	2015-05-20	5001	0	\N	0	0	\N	\N	0	134284	0	117015009	4024958		
142575	4381	4024958	1994-11-01	1994-11-01 00:00:00	1994-11-01	5001	0	\N	0	0	\N	\N	0	291071	0	117015009	4024958		
16266	1482	3036780	1975-07-28	1975-07-28 00:00:00	1975-07-28	5001	0	\N	0	0	\N	\N	0	98904	0	6095-4	3036780		
13455	1272	3021226	1980-05-24	1980-05-24 00:00:00	1980-05-24	5001	0	\N	0	0	\N	\N	0	83864	0	6246-3	3021226		
56950	5222	3011505	2010-03-18	2010-03-18 00:00:00	2010-03-18	5001	0	\N	0	0	\N	\N	0	347349	0	19926-5	3011505		
11870	1136	3006322	1980-12-24	1980-12-24 00:00:00	1980-12-24	5001	0	\N	0	0	\N	\N	0	74826	0	8331-1	3006322		
20610	1892	3011505	2007-05-17	2007-05-17 00:00:00	2007-05-17	5001	0	\N	0	0	\N	\N	0	126021	0	19926-5	3011505		
39011	3604	3006451	1984-12-12	1984-12-12 00:00:00	1984-12-12	5001	0	\N	0	0	\N	\N	0	239520	0	6273-7	3006451		
166122	5107	4024958	1994-06-29	1994-06-29 00:00:00	1994-06-29	5001	0	\N	0	0	\N	\N	0	339333	0	117015009	4024958		
14886	1379	3006322	1985-02-11	1985-02-11 00:00:00	1985-02-11	5001	0	\N	0	0	\N	\N	0	91474	0	8331-1	3006322		
137282	4227	4024958	1986-06-10	1986-06-10 00:00:00	1986-06-10	5001	0	\N	0	0	\N	\N	0	280847	0	117015009	4024958		
16951	1538	3000876	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	102975	0	6082-2	3000876		
156461	4807	4024958	1961-02-19	1961-02-19 00:00:00	1961-02-19	5001	0	\N	0	0	\N	\N	0	319787	0	117015009	4024958		
5258	505	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	33739	0	6246-3	3021226		
57686	5290	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	351997	0	6075-6	3005136		
16683	1524	3006322	1988-03-16	1988-03-16 00:00:00	1988-03-16	5001	0	\N	0	0	\N	\N	0	101918	0	8331-1	3006322		
27179	2521	3006322	1969-03-18	1969-03-18 00:00:00	1969-03-18	5001	0	\N	0	0	\N	\N	0	166713	0	8331-1	3006322		
43154	3987	3006322	1980-08-31	1980-08-31 00:00:00	1980-08-31	5001	0	\N	0	0	\N	\N	0	265041	0	8331-1	3006322		
43262	3997	3006322	1978-06-17	1978-06-17 00:00:00	1978-06-17	5001	0	\N	0	0	\N	\N	0	265731	0	8331-1	3006322		
43281	4005	3006322	1978-12-04	1978-12-04 00:00:00	1978-12-04	5001	0	\N	0	0	\N	\N	0	266117	0	8331-1	3006322		
22413	2054	3006322	1999-03-14	1999-03-14 00:00:00	1999-03-14	5001	0	\N	0	0	\N	\N	0	136627	0	8331-1	3006322		
26040	2392	3009542	1939-01-29	1939-01-29 00:00:00	1939-01-29	5001	0	\N	0	0	\N	\N	0	159038	0	20570-8	3009542		
11804	1120	3006322	2018-04-29	2018-04-29 00:00:00	2018-04-29	5001	0	\N	0	0	\N	\N	0	73862	0	8331-1	3006322		
1244	99	3011505	2008-07-12	2008-07-12 00:00:00	2008-07-12	5001	0	\N	0	0	\N	\N	0	6767	0	19926-5	3011505		
120160	3703	4052083	1995-03-09	1995-03-09 00:00:00	1995-03-09	5001	0	\N	0	0	\N	\N	0	246228	0	23426006	4052083		
590	36	3005136	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	2539	0	6075-6	3005136		
42169	3896	3006322	2006-10-09	2006-10-09 00:00:00	2006-10-09	5001	0	\N	0	0	\N	\N	0	259150	0	8331-1	3006322		
39487	3651	3006322	2014-01-31	2014-01-31 00:00:00	2014-01-31	5001	0	\N	0	0	\N	\N	0	243070	0	8331-1	3006322		
53630	4924	3000876	1978-06-24	1978-06-24 00:00:00	1978-06-24	5001	0	\N	0	0	\N	\N	0	327278	0	6082-2	3000876		
40605	3769	40766240	2017-12-06	2017-12-06 00:00:00	2017-12-06	5001	0	\N	0	0	\N	\N	0	250579	0	63513-6	40766240		
57613	5285	40766240	1989-12-19	1989-12-19 00:00:00	1989-12-19	5001	0	\N	0	0	\N	\N	0	351625	0	63513-6	40766240		
8000	764	3051031	1973-11-11	1973-11-11 00:00:00	1973-11-11	5001	0	\N	0	0	\N	\N	0	50806	0	46240-8	3051031		
8545	812	3006322	1996-10-05	1996-10-05 00:00:00	1996-10-05	5001	0	\N	0	0	\N	\N	0	53869	0	8331-1	3006322		
47701	4376	40758406	1999-02-02	1999-02-02 00:00:00	1999-02-02	5001	0	\N	0	0	\N	\N	0	290746	0	55277-8	40758406		
3949	395	3006322	1989-01-16	1989-01-16 00:00:00	1989-01-16	5001	0	\N	0	0	\N	\N	0	25988	0	8331-1	3006322		
30882	2830	3006322	2015-05-16	2015-05-16 00:00:00	2015-05-16	5001	0	\N	0	0	\N	\N	0	187743	0	8331-1	3006322		
4114	409	3006322	1999-04-11	1999-04-11 00:00:00	1999-04-11	5001	0	\N	0	0	\N	\N	0	27131	0	8331-1	3006322		
10054	956	40758406	1998-08-18	1998-08-18 00:00:00	1998-08-18	5001	0	\N	0	0	\N	\N	0	63450	0	55277-8	40758406		
38312	3529	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	234409	0	6075-6	3005136		
55278	5056	3006322	1996-10-30	1996-10-30 00:00:00	1996-10-30	5001	0	\N	0	0	\N	\N	0	336143	0	8331-1	3006322		
27996	870	4052083	1962-09-24	1962-09-24 00:00:00	1962-09-24	5001	0	\N	0	0	\N	\N	0	57905	0	23426006	4052083		
23751	2185	3006322	1948-06-09	1948-06-09 00:00:00	1948-06-09	5001	0	\N	0	0	\N	\N	0	145676	0	8331-1	3006322		
29374	2706	40758406	1979-06-04	1979-06-04 00:00:00	1979-06-04	5001	0	\N	0	0	\N	\N	0	179311	0	55277-8	40758406		
41433	1280	4024958	2016-12-14	2016-12-14 00:00:00	2016-12-14	5001	0	\N	0	0	\N	\N	0	84536	0	117015009	4024958		
40858	3791	3006322	1944-09-24	1944-09-24 00:00:00	1944-09-24	5001	0	\N	0	0	\N	\N	0	252134	0	8331-1	3006322		
43250	1328	4133840	1996-08-01	1996-08-01 00:00:00	1996-08-01	5001	0	\N	0	0	\N	\N	0	88230	0	127783003	4133840		
10683	1036	3006322	1981-03-23	1981-03-23 00:00:00	1981-03-23	5001	0	\N	0	0	\N	\N	0	68096	0	8331-1	3006322		
14119	1320	3006322	1976-01-25	1976-01-25 00:00:00	1976-01-25	5001	0	\N	0	0	\N	\N	0	87482	0	8331-1	3006322		
41995	3884	3006451	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	258114	0	6273-7	3006451		
30040	2767	40766240	2015-05-19	2015-05-19 00:00:00	2015-05-19	5001	0	\N	0	0	\N	\N	0	183023	0	63513-6	40766240		
46325	1412	4024958	1969-02-02	1969-02-02 00:00:00	1969-02-02	5001	0	\N	0	0	\N	\N	0	94091	0	117015009	4024958		
4868	470	3006322	1965-10-06	1965-10-06 00:00:00	1965-10-06	5001	0	\N	0	0	\N	\N	0	31418	0	8331-1	3006322		
41928	1294	4052083	2000-10-06	2000-10-06 00:00:00	2000-10-06	5001	0	\N	0	0	\N	\N	0	85625	0	23426006	4052083		
117117	3609	4024958	1995-11-21	1995-11-21 00:00:00	1995-11-21	5001	0	\N	0	0	\N	\N	0	239743	0	117015009	4024958		
16441	1497	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	99821	0	6273-7	3006451		
26031	812	4052083	1988-09-30	1988-09-30 00:00:00	1988-09-30	5001	0	\N	0	0	\N	\N	0	53848	0	23426006	4052083		
49499	4506	3051031	2002-08-04	2002-08-04 00:00:00	2002-08-04	5001	0	\N	0	0	\N	\N	0	300238	0	46240-8	3051031		
11127	1076	3006322	2005-05-08	2005-05-08 00:00:00	2005-05-08	5001	0	\N	0	0	\N	\N	0	70549	0	8331-1	3006322		
73508	2260	4052083	1997-05-29	1997-05-29 00:00:00	1997-05-29	5001	0	\N	0	0	\N	\N	0	150181	0	23426006	4052083		
10016	954	3006322	1994-04-14	1994-04-14 00:00:00	1994-04-14	5001	0	\N	0	0	\N	\N	0	63376	0	8331-1	3006322		
78048	2392	4133840	2007-07-13	2007-07-13 00:00:00	2007-07-13	5001	0	\N	0	0	\N	\N	0	159065	0	127783003	4133840		
123467	3807	4052083	1958-06-09	1958-06-09 00:00:00	1958-06-09	5001	0	\N	0	0	\N	\N	0	252997	0	23426006	4052083		
142581	4381	4024958	1965-02-28	1965-02-28 00:00:00	1965-02-28	5001	0	\N	0	0	\N	\N	0	291147	0	117015009	4024958		
16267	1482	3006451	1975-07-28	1975-07-28 00:00:00	1975-07-28	5001	0	\N	0	0	\N	\N	0	98904	0	6273-7	3006451		
13456	1272	3001247	1980-05-24	1980-05-24 00:00:00	1980-05-24	5001	0	\N	0	0	\N	\N	0	83864	0	6085-5	3001247		
57130	5245	3021226	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	349045	0	6246-3	3021226		
11871	1136	3006322	2014-04-13	2014-04-13 00:00:00	2014-04-13	5001	0	\N	0	0	\N	\N	0	74815	0	8331-1	3006322		
20611	1892	3006322	1979-11-19	1979-11-19 00:00:00	1979-11-19	5001	0	\N	0	0	\N	\N	0	126026	0	8331-1	3006322		
39012	3604	3021226	1984-12-12	1984-12-12 00:00:00	1984-12-12	5001	0	\N	0	0	\N	\N	0	239520	0	6246-3	3021226		
166134	5107	4024958	1997-05-26	1997-05-26 00:00:00	1997-05-26	5001	0	\N	0	0	\N	\N	0	339319	0	117015009	4024958		
14887	1379	3011505	2001-02-10	2001-02-10 00:00:00	2001-02-10	5001	0	\N	0	0	\N	\N	0	91470	0	19926-5	3011505		
137286	4227	4052083	2001-06-25	2001-06-25 00:00:00	2001-06-25	5001	0	\N	0	0	\N	\N	0	280784	0	23426006	4052083		
16952	1538	3006322	1965-12-07	1965-12-07 00:00:00	1965-12-07	5001	0	\N	0	0	\N	\N	0	102973	0	8331-1	3006322		
156469	4807	4052083	1957-10-24	1957-10-24 00:00:00	1957-10-24	5001	0	\N	0	0	\N	\N	0	319855	0	23426006	4052083		
5259	505	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	33739	0	6833-8	3023430		
57687	5290	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	351997	0	6248-9	3015076		
16684	1524	3006322	1968-03-08	1968-03-08 00:00:00	1968-03-08	5001	0	\N	0	0	\N	\N	0	101914	0	8331-1	3006322		
27180	2521	3006322	1986-01-02	1986-01-02 00:00:00	1986-01-02	5001	0	\N	0	0	\N	\N	0	166715	0	8331-1	3006322		
43155	3987	3049273	2008-03-01	2008-03-01 00:00:00	2008-03-01	5001	0	\N	0	0	\N	\N	0	265029	0	38265-5	3049273		
43263	3997	3006322	1969-12-04	1969-12-04 00:00:00	1969-12-04	5001	0	\N	0	0	\N	\N	0	265729	0	8331-1	3006322		
43282	4005	3006322	2013-09-08	2013-09-08 00:00:00	2013-09-08	5001	0	\N	0	0	\N	\N	0	266119	0	8331-1	3006322		
22414	2054	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	136668	0	7258-7	3001488		
26041	2392	3000963	1939-01-29	1939-01-29 00:00:00	1939-01-29	5001	0	\N	0	0	\N	\N	0	159038	0	718-7	3000963		
11805	1120	3006322	1972-07-30	1972-07-30 00:00:00	1972-07-30	5001	0	\N	0	0	\N	\N	0	73788	0	8331-1	3006322		
1245	99	3000963	2016-10-10	2016-10-10 00:00:00	2016-10-10	5001	0	\N	0	0	\N	\N	0	6774	0	718-7	3000963		
17979	564	4133840	2007-07-26	2007-07-26 00:00:00	2007-07-26	5001	0	\N	0	0	\N	\N	0	37382	0	127783003	4133840		
591	36	3014599	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	2539	0	6106-9	3014599		
42173	3899	3006322	2006-10-04	2006-10-04 00:00:00	2006-10-04	5001	0	\N	0	0	\N	\N	0	259289	0	8331-1	3006322		
39488	3651	3006322	1985-02-23	1985-02-23 00:00:00	1985-02-23	5001	0	\N	0	0	\N	\N	0	243045	0	8331-1	3006322		
53631	4924	3001247	1978-06-24	1978-06-24 00:00:00	1978-06-24	5001	0	\N	0	0	\N	\N	0	327278	0	6085-5	3001247		
40608	3769	46235214	2017-09-07	2017-09-07 00:00:00	2017-09-07	5001	0	\N	0	0	\N	\N	0	250578	0	76690-7	46235214		
57615	5285	3051031	1989-12-19	1989-12-19 00:00:00	1989-12-19	5001	0	\N	0	0	\N	\N	0	351625	0	46240-8	3051031		
8001	764	40766240	1973-12-11	1973-12-11 00:00:00	1973-12-11	5001	0	\N	0	0	\N	\N	0	50812	0	63513-6	40766240		
8563	814	3006322	1993-05-29	1993-05-29 00:00:00	1993-05-29	5001	0	\N	0	0	\N	\N	0	53994	0	8331-1	3006322		
47702	4376	3051031	1999-02-02	1999-02-02 00:00:00	1999-02-02	5001	0	\N	0	0	\N	\N	0	290746	0	46240-8	3051031		
3950	395	3006322	1975-02-14	1975-02-14 00:00:00	1975-02-14	5001	0	\N	0	0	\N	\N	0	25948	0	8331-1	3006322		
30883	2830	3006322	1986-01-24	1986-01-24 00:00:00	1986-01-24	5001	0	\N	0	0	\N	\N	0	187806	0	8331-1	3006322		
4115	409	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	27130	0	6095-4	3036780		
10057	956	40766240	1998-08-18	1998-08-18 00:00:00	1998-08-18	5001	0	\N	0	0	\N	\N	0	63450	0	63513-6	40766240		
38313	3529	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	234409	0	6248-9	3015076		
55280	5056	3006322	1967-05-25	1967-05-25 00:00:00	1967-05-25	5001	0	\N	0	0	\N	\N	0	336228	0	8331-1	3006322		
28007	870	4024958	2011-11-23	2011-11-23 00:00:00	2011-11-23	5001	0	\N	0	0	\N	\N	0	57855	0	117015009	4024958		
23752	2185	3049273	1992-09-03	1992-09-03 00:00:00	1992-09-03	5001	0	\N	0	0	\N	\N	0	145626	0	38265-5	3049273		
29375	2706	3006322	1968-12-24	1968-12-24 00:00:00	1968-12-24	5001	0	\N	0	0	\N	\N	0	179310	0	8331-1	3006322		
41443	1280	4024958	1974-07-02	1974-07-02 00:00:00	1974-07-02	5001	0	\N	0	0	\N	\N	0	84557	0	117015009	4024958		
40859	3791	3006322	2007-10-19	2007-10-19 00:00:00	2007-10-19	5001	0	\N	0	0	\N	\N	0	252040	0	8331-1	3006322		
43251	1328	4133840	2007-10-04	2007-10-04 00:00:00	2007-10-04	5001	0	\N	0	0	\N	\N	0	88232	0	127783003	4133840		
10684	1036	3006322	2013-07-17	2013-07-17 00:00:00	2013-07-17	5001	0	\N	0	0	\N	\N	0	68121	0	8331-1	3006322		
14120	1320	3049273	1995-06-15	1995-06-15 00:00:00	1995-06-15	5001	0	\N	0	0	\N	\N	0	87506	0	38265-5	3049273		
41996	3884	3027231	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	258114	0	6276-0	3027231		
30041	2767	46235214	2015-05-19	2015-05-19 00:00:00	2015-05-19	5001	0	\N	0	0	\N	\N	0	183023	0	76690-7	46235214		
46354	1415	4052083	1995-01-27	1995-01-27 00:00:00	1995-01-27	5001	0	\N	0	0	\N	\N	0	94190	0	23426006	4052083		
4869	471	3006322	2012-02-29	2012-02-29 00:00:00	2012-02-29	5001	0	\N	0	0	\N	\N	0	31467	0	8331-1	3006322		
41937	1294	4052083	1997-04-11	1997-04-11 00:00:00	1997-04-11	5001	0	\N	0	0	\N	\N	0	85651	0	23426006	4052083		
117124	3609	4024958	2007-05-17	2007-05-17 00:00:00	2007-05-17	5001	0	\N	0	0	\N	\N	0	239755	0	117015009	4024958		
16442	1497	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	99821	0	6075-6	3005136		
26072	814	4024958	1989-06-08	1989-06-08 00:00:00	1989-06-08	5001	0	\N	0	0	\N	\N	0	53955	0	117015009	4024958		
49500	4506	40758406	2002-08-04	2002-08-04 00:00:00	2002-08-04	5001	0	\N	0	0	\N	\N	0	300238	0	55277-8	40758406		
11128	1076	3006322	1981-05-31	1981-05-31 00:00:00	1981-05-31	5001	0	\N	0	0	\N	\N	0	70546	0	8331-1	3006322		
73517	2260	4024958	1982-02-10	1982-02-10 00:00:00	1982-02-10	5001	0	\N	0	0	\N	\N	0	150195	0	117015009	4024958		
10017	954	3006322	1984-03-16	1984-03-16 00:00:00	1984-03-16	5001	0	\N	0	0	\N	\N	0	63370	0	8331-1	3006322		
78053	2392	4133840	1973-03-09	1973-03-09 00:00:00	1973-03-09	5001	0	\N	0	0	\N	\N	0	159056	0	127783003	4133840		
123473	3807	4052083	1977-03-06	1977-03-06 00:00:00	1977-03-06	5001	0	\N	0	0	\N	\N	0	252971	0	23426006	4052083		
142591	4381	4052083	1987-10-23	1987-10-23 00:00:00	1987-10-23	5001	0	\N	0	0	\N	\N	0	291106	0	23426006	4052083		
16268	1482	3015076	1975-07-28	1975-07-28 00:00:00	1975-07-28	5001	0	\N	0	0	\N	\N	0	98904	0	6248-9	3015076		
13457	1272	3001488	1980-05-24	1980-05-24 00:00:00	1980-05-24	5001	0	\N	0	0	\N	\N	0	83864	0	7258-7	3001488		
57131	5245	3006451	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	349045	0	6273-7	3006451		
11872	1136	3049273	2007-06-05	2007-06-05 00:00:00	2007-06-05	5001	0	\N	0	0	\N	\N	0	74856	0	38265-5	3049273		
20663	1898	3006322	1976-07-09	1976-07-09 00:00:00	1976-07-09	5001	0	\N	0	0	\N	\N	0	126395	0	8331-1	3006322		
39013	3604	3005136	1984-12-12	1984-12-12 00:00:00	1984-12-12	5001	0	\N	0	0	\N	\N	0	239520	0	6075-6	3005136		
166144	5107	4052083	1984-05-21	1984-05-21 00:00:00	1984-05-21	5001	0	\N	0	0	\N	\N	0	339345	0	23426006	4052083		
14888	1379	3011505	2012-03-17	2012-03-17 00:00:00	2012-03-17	5001	0	\N	0	0	\N	\N	0	91452	0	19926-5	3011505		
4118	409	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	27130	0	6082-2	3000876		
16953	1538	3006322	1965-09-26	1965-09-26 00:00:00	1965-09-26	5001	0	\N	0	0	\N	\N	0	102953	0	8331-1	3006322		
156471	4807	4024958	1967-07-12	1967-07-12 00:00:00	1967-07-12	5001	0	\N	0	0	\N	\N	0	319797	0	117015009	4024958		
5260	505	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	33739	0	6276-0	3027231		
57688	5290	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	351997	0	6206-7	3012494		
16685	1524	3006322	1993-06-02	1993-06-02 00:00:00	1993-06-02	5001	0	\N	0	0	\N	\N	0	101954	0	8331-1	3006322		
27181	2521	3006322	1997-05-18	1997-05-18 00:00:00	1997-05-18	5001	0	\N	0	0	\N	\N	0	166746	0	8331-1	3006322		
43156	3987	3006322	1956-05-15	1956-05-15 00:00:00	1956-05-15	5001	0	\N	0	0	\N	\N	0	265062	0	8331-1	3006322		
43264	3997	3006322	2001-01-13	2001-01-13 00:00:00	2001-01-13	5001	0	\N	0	0	\N	\N	0	265771	0	8331-1	3006322		
43283	4005	3006322	2009-07-06	2009-07-06 00:00:00	2009-07-06	5001	0	\N	0	0	\N	\N	0	266112	0	8331-1	3006322		
22415	2054	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	136668	0	6206-7	3012494		
26042	2392	3011505	1985-03-08	1985-03-08 00:00:00	1985-03-08	5001	0	\N	0	0	\N	\N	0	159089	0	19926-5	3011505		
11806	1120	3006322	1989-11-22	1989-11-22 00:00:00	1989-11-22	5001	0	\N	0	0	\N	\N	0	73861	0	8331-1	3006322		
1246	99	3009542	2016-10-10	2016-10-10 00:00:00	2016-10-10	5001	0	\N	0	0	\N	\N	0	6774	0	20570-8	3009542		
17982	564	4133840	2006-07-20	2006-07-20 00:00:00	2006-07-20	5001	0	\N	0	0	\N	\N	0	37357	0	127783003	4133840		
592	36	3006451	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	2539	0	6273-7	3006451		
42174	3899	3006322	1988-01-17	1988-01-17 00:00:00	1988-01-17	5001	0	\N	0	0	\N	\N	0	259266	0	8331-1	3006322		
39489	3652	3006322	1987-04-16	1987-04-16 00:00:00	1987-04-16	5001	0	\N	0	0	\N	\N	0	243080	0	8331-1	3006322		
53632	4924	3005136	1978-06-24	1978-06-24 00:00:00	1978-06-24	5001	0	\N	0	0	\N	\N	0	327278	0	6075-6	3005136		
40610	3769	40766240	2017-09-07	2017-09-07 00:00:00	2017-09-07	5001	0	\N	0	0	\N	\N	0	250578	0	63513-6	40766240		
57619	5285	46235214	1989-10-20	1989-10-20 00:00:00	1989-10-20	5001	0	\N	0	0	\N	\N	0	351660	0	76690-7	46235214		
8003	764	3051031	1973-12-11	1973-12-11 00:00:00	1973-12-11	5001	0	\N	0	0	\N	\N	0	50812	0	46240-8	3051031		
8564	814	3006322	1989-06-08	1989-06-08 00:00:00	1989-06-08	5001	0	\N	0	0	\N	\N	0	53955	0	8331-1	3006322		
47705	4376	46235214	1999-02-02	1999-02-02 00:00:00	1999-02-02	5001	0	\N	0	0	\N	\N	0	290746	0	76690-7	46235214		
17514	550	4052083	1974-10-25	1974-10-25 00:00:00	1974-10-25	5001	0	\N	0	0	\N	\N	0	36491	0	23426006	4052083		
30884	2830	3006322	2008-02-06	2008-02-06 00:00:00	2008-02-06	5001	0	\N	0	0	\N	\N	0	187689	0	8331-1	3006322		
4116	409	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	27130	0	6206-7	3012494		
10058	956	3006322	1941-11-04	1941-11-04 00:00:00	1941-11-04	5001	0	\N	0	0	\N	\N	0	63504	0	8331-1	3006322		
38314	3529	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	234409	0	6276-0	3027231		
55282	5058	3006322	2002-09-04	2002-09-04 00:00:00	2002-09-04	5001	0	\N	0	0	\N	\N	0	336333	0	8331-1	3006322		
28011	870	4052083	1977-09-15	1977-09-15 00:00:00	1977-09-15	5001	0	\N	0	0	\N	\N	0	57885	0	23426006	4052083		
23753	2185	3006322	1965-09-23	1965-09-23 00:00:00	1965-09-23	5001	0	\N	0	0	\N	\N	0	145655	0	8331-1	3006322		
29378	2706	40766240	1979-05-05	1979-05-05 00:00:00	1979-05-05	5001	0	\N	0	0	\N	\N	0	179290	0	63513-6	40766240		
41448	1280	4024958	1958-08-10	1958-08-10 00:00:00	1958-08-10	5001	0	\N	0	0	\N	\N	0	84596	0	117015009	4024958		
40860	3791	3049273	1982-10-13	1982-10-13 00:00:00	1982-10-13	5001	0	\N	0	0	\N	\N	0	252161	0	38265-5	3049273		
43253	1328	4052083	1980-11-16	1980-11-16 00:00:00	1980-11-16	5001	0	\N	0	0	\N	\N	0	88222	0	23426006	4052083		
10685	1036	3006322	1975-09-07	1975-09-07 00:00:00	1975-09-07	5001	0	\N	0	0	\N	\N	0	68095	0	8331-1	3006322		
14122	1320	3006322	1949-09-14	1949-09-14 00:00:00	1949-09-14	5001	0	\N	0	0	\N	\N	0	87538	0	8331-1	3006322		
41997	3884	3014599	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	258114	0	6106-9	3014599		
30042	2767	3006322	1943-04-14	1943-04-14 00:00:00	1943-04-14	5001	0	\N	0	0	\N	\N	0	183021	0	8331-1	3006322		
57645	1760	4024958	1980-03-09	1980-03-09 00:00:00	1980-03-09	5001	0	\N	0	0	\N	\N	0	117671	0	117015009	4024958		
4870	471	3006322	2000-03-18	2000-03-18 00:00:00	2000-03-18	5001	0	\N	0	0	\N	\N	0	31497	0	8331-1	3006322		
41962	1297	4052083	2000-12-26	2000-12-26 00:00:00	2000-12-26	5001	0	\N	0	0	\N	\N	0	85732	0	23426006	4052083		
117141	3610	4024958	1961-08-07	1961-08-07 00:00:00	1961-08-07	5001	0	\N	0	0	\N	\N	0	239887	0	117015009	4024958		
16443	1497	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	99821	0	6248-9	3015076		
26079	814	4024958	1988-02-05	1988-02-05 00:00:00	1988-02-05	5001	0	\N	0	0	\N	\N	0	53991	0	117015009	4024958		
49502	4506	46235214	2002-08-04	2002-08-04 00:00:00	2002-08-04	5001	0	\N	0	0	\N	\N	0	300238	0	76690-7	46235214		
11129	1077	3006322	2004-04-03	2004-04-03 00:00:00	2004-04-03	5001	0	\N	0	0	\N	\N	0	70652	0	8331-1	3006322		
73527	2260	4052083	1952-02-17	1952-02-17 00:00:00	1952-02-17	5001	0	\N	0	0	\N	\N	0	150179	0	23426006	4052083		
10018	954	3006322	2006-03-24	2006-03-24 00:00:00	2006-03-24	5001	0	\N	0	0	\N	\N	0	63384	0	8331-1	3006322		
78060	2392	4133840	1983-12-16	1983-12-16 00:00:00	1983-12-16	5001	0	\N	0	0	\N	\N	0	159079	0	127783003	4133840		
123483	3807	4052083	1951-10-27	1951-10-27 00:00:00	1951-10-27	5001	0	\N	0	0	\N	\N	0	252968	0	23426006	4052083		
142594	4381	4024958	1980-11-19	1980-11-19 00:00:00	1980-11-19	5001	0	\N	0	0	\N	\N	0	291105	0	117015009	4024958		
16269	1482	3014599	1975-07-28	1975-07-28 00:00:00	1975-07-28	5001	0	\N	0	0	\N	\N	0	98904	0	6106-9	3014599		
13458	1272	3027231	1980-05-24	1980-05-24 00:00:00	1980-05-24	5001	0	\N	0	0	\N	\N	0	83864	0	6276-0	3027231		
57132	5245	3036780	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	349045	0	6095-4	3036780		
11873	1136	3006322	1993-03-08	1993-03-08 00:00:00	1993-03-08	5001	0	\N	0	0	\N	\N	0	74867	0	8331-1	3006322		
20665	1898	40758406	1972-01-06	1972-01-06 00:00:00	1972-01-06	5001	0	\N	0	0	\N	\N	0	126390	0	55277-8	40758406		
39014	3604	3012494	1984-12-12	1984-12-12 00:00:00	1984-12-12	5001	0	\N	0	0	\N	\N	0	239520	0	6206-7	3012494		
166145	5107	4024958	1987-08-04	1987-08-04 00:00:00	1987-08-04	5001	0	\N	0	0	\N	\N	0	339346	0	117015009	4024958		
14889	1379	3011505	1997-04-12	1997-04-12 00:00:00	1997-04-12	5001	0	\N	0	0	\N	\N	0	91483	0	19926-5	3011505		
4119	409	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	27130	0	6844-5	3020655		
16954	1538	3006322	1980-05-06	1980-05-06 00:00:00	1980-05-06	5001	0	\N	0	0	\N	\N	0	103056	0	8331-1	3006322		
156472	4807	4024958	1975-01-17	1975-01-17 00:00:00	1975-01-17	5001	0	\N	0	0	\N	\N	0	319789	0	117015009	4024958		
5261	505	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	33739	0	6844-5	3020655		
57689	5290	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	351997	0	6246-3	3021226		
16686	1524	3006322	1997-06-27	1997-06-27 00:00:00	1997-06-27	5001	0	\N	0	0	\N	\N	0	101919	0	8331-1	3006322		
27182	2521	3006322	1959-10-30	1959-10-30 00:00:00	1959-10-30	5001	0	\N	0	0	\N	\N	0	166758	0	8331-1	3006322		
43157	3987	3049273	1964-11-19	1964-11-19 00:00:00	1964-11-19	5001	0	\N	0	0	\N	\N	0	265027	0	38265-5	3049273		
43265	3998	3006322	2011-10-25	2011-10-25 00:00:00	2011-10-25	5001	0	\N	0	0	\N	\N	0	265862	0	8331-1	3006322		
43284	4005	3006322	2013-04-27	2013-04-27 00:00:00	2013-04-27	5001	0	\N	0	0	\N	\N	0	266113	0	8331-1	3006322		
22416	2054	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	136668	0	6276-0	3027231		
26043	2392	3011505	2000-06-02	2000-06-02 00:00:00	2000-06-02	5001	0	\N	0	0	\N	\N	0	159062	0	19926-5	3011505		
11807	1120	3006322	2013-08-12	2013-08-12 00:00:00	2013-08-12	5001	0	\N	0	0	\N	\N	0	73831	0	8331-1	3006322		
1247	99	3049273	2011-09-11	2011-09-11 00:00:00	2011-09-11	5001	0	\N	0	0	\N	\N	0	6732	0	38265-5	3049273		
17983	564	4133840	2018-09-27	2018-09-27 00:00:00	2018-09-27	5001	0	\N	0	0	\N	\N	0	37355	0	127783003	4133840		
593	36	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	2523	0	6158-0	3019406		
42175	3899	3006322	2018-04-26	2018-04-26 00:00:00	2018-04-26	5001	0	\N	0	0	\N	\N	0	259257	0	8331-1	3006322		
39490	3652	3006322	1978-04-06	1978-04-06 00:00:00	1978-04-06	5001	0	\N	0	0	\N	\N	0	243079	0	8331-1	3006322		
53633	4924	40769189	1979-06-15	1979-06-15 00:00:00	1979-06-15	5001	0	\N	0	0	\N	\N	0	327259	0	66529-9	40769189		
40612	3769	40758406	2017-09-07	2017-09-07 00:00:00	2017-09-07	5001	0	\N	0	0	\N	\N	0	250578	0	55277-8	40758406		
57620	5285	3051031	1989-10-20	1989-10-20 00:00:00	1989-10-20	5001	0	\N	0	0	\N	\N	0	351660	0	46240-8	3051031		
8004	764	40758406	1973-12-11	1973-12-11 00:00:00	1973-12-11	5001	0	\N	0	0	\N	\N	0	50812	0	55277-8	40758406		
8565	814	3006322	1988-02-05	1988-02-05 00:00:00	1988-02-05	5001	0	\N	0	0	\N	\N	0	53991	0	8331-1	3006322		
47706	4376	40766240	1922-02-26	1922-02-26 00:00:00	1922-02-26	5001	0	\N	0	0	\N	\N	0	290767	0	63513-6	40766240		
17521	550	4052083	1963-09-30	1963-09-30 00:00:00	1963-09-30	5001	0	\N	0	0	\N	\N	0	36454	0	23426006	4052083		
30885	2830	3021226	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	187787	0	6246-3	3021226		
4117	409	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	27130	0	6106-9	3014599		
10059	956	3006322	1996-04-25	1996-04-25 00:00:00	1996-04-25	5001	0	\N	0	0	\N	\N	0	63449	0	8331-1	3006322		
38315	3529	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	234409	0	7258-7	3001488		
55283	5058	3049273	2011-10-31	2011-10-31 00:00:00	2011-10-31	5001	0	\N	0	0	\N	\N	0	336347	0	38265-5	3049273		
28014	870	4024958	2014-07-03	2014-07-03 00:00:00	2014-07-03	5001	0	\N	0	0	\N	\N	0	57914	0	117015009	4024958		
23754	2185	3006322	1946-12-04	1946-12-04 00:00:00	1946-12-04	5001	0	\N	0	0	\N	\N	0	145680	0	8331-1	3006322		
29379	2706	3051031	1979-05-05	1979-05-05 00:00:00	1979-05-05	5001	0	\N	0	0	\N	\N	0	179290	0	46240-8	3051031		
41453	1280	4024958	1974-11-08	1974-11-08 00:00:00	1974-11-08	5001	0	\N	0	0	\N	\N	0	84543	0	117015009	4024958		
40861	3791	3049273	1980-11-22	1980-11-22 00:00:00	1980-11-22	5001	0	\N	0	0	\N	\N	0	252160	0	38265-5	3049273		
43254	1328	4133840	1993-12-30	1993-12-30 00:00:00	1993-12-30	5001	0	\N	0	0	\N	\N	0	88229	0	127783003	4133840		
10686	1036	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	68117	0	6246-3	3021226		
14125	1320	3006322	1983-04-15	1983-04-15 00:00:00	1983-04-15	5001	0	\N	0	0	\N	\N	0	87491	0	8331-1	3006322		
41998	3884	3001488	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	258114	0	7258-7	3001488		
30043	2767	3049273	1996-06-05	1996-06-05 00:00:00	1996-06-05	5001	0	\N	0	0	\N	\N	0	183042	0	38265-5	3049273		
46461	1418	4052083	2016-01-18	2016-01-18 00:00:00	2016-01-18	5001	0	\N	0	0	\N	\N	0	94415	0	23426006	4052083		
4871	472	40769189	1998-01-30	1998-01-30 00:00:00	1998-01-30	5001	0	\N	0	0	\N	\N	0	31536	0	66529-9	40769189		
41963	1297	4052083	2007-10-16	2007-10-16 00:00:00	2007-10-16	5001	0	\N	0	0	\N	\N	0	85711	0	23426006	4052083		
14261	449	4133840	2003-07-10	2003-07-10 00:00:00	2003-07-10	5001	0	\N	0	0	\N	\N	0	29992	0	127783003	4133840		
16444	1497	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	99821	0	7258-7	3001488		
26084	814	4024958	1993-05-29	1993-05-29 00:00:00	1993-05-29	5001	0	\N	0	0	\N	\N	0	53994	0	117015009	4024958		
49504	4506	3051031	2014-07-12	2014-07-12 00:00:00	2014-07-12	5001	0	\N	0	0	\N	\N	0	300141	0	46240-8	3051031		
11130	1077	3006322	1989-09-28	1989-09-28 00:00:00	1989-09-28	5001	0	\N	0	0	\N	\N	0	70594	0	8331-1	3006322		
73534	2261	4052083	2012-03-31	2012-03-31 00:00:00	2012-03-31	5001	0	\N	0	0	\N	\N	0	150273	0	23426006	4052083		
10019	954	3006322	1985-12-15	1985-12-15 00:00:00	1985-12-15	5001	0	\N	0	0	\N	\N	0	63382	0	8331-1	3006322		
78062	2392	4133840	1956-05-18	1956-05-18 00:00:00	1956-05-18	5001	0	\N	0	0	\N	\N	0	159073	0	127783003	4133840		
123486	3807	4024958	1965-06-15	1965-06-15 00:00:00	1965-06-15	5001	0	\N	0	0	\N	\N	0	252977	0	117015009	4024958		
142616	4382	4052083	1965-06-16	1965-06-16 00:00:00	1965-06-16	5001	0	\N	0	0	\N	\N	0	291266	0	23426006	4052083		
16270	1482	3012494	1975-07-28	1975-07-28 00:00:00	1975-07-28	5001	0	\N	0	0	\N	\N	0	98904	0	6206-7	3012494		
13459	1272	3020655	1980-05-24	1980-05-24 00:00:00	1980-05-24	5001	0	\N	0	0	\N	\N	0	83864	0	6844-5	3020655		
57133	5245	3014599	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	349045	0	6106-9	3014599		
11874	1136	3006322	2009-02-22	2009-02-22 00:00:00	2009-02-22	5001	0	\N	0	0	\N	\N	0	74814	0	8331-1	3006322		
20666	1898	40766240	1972-01-06	1972-01-06 00:00:00	1972-01-06	5001	0	\N	0	0	\N	\N	0	126390	0	63513-6	40766240		
39015	3604	3014599	1984-12-12	1984-12-12 00:00:00	1984-12-12	5001	0	\N	0	0	\N	\N	0	239520	0	6106-9	3014599		
50164	4576	3006322	1965-02-05	1965-02-05 00:00:00	1965-02-05	5001	0	\N	0	0	\N	\N	0	304799	0	8331-1	3006322		
14890	1379	3011505	2019-04-27	2019-04-27 00:00:00	2019-04-27	5001	0	\N	0	0	\N	\N	0	91525	0	19926-5	3011505		
4120	409	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	27130	0	6085-5	3001247		
16958	1540	3006322	1966-07-31	1966-07-31 00:00:00	1966-07-31	5001	0	\N	0	0	\N	\N	0	103215	0	8331-1	3006322		
133720	4116	4024958	2002-11-12	2002-11-12 00:00:00	2002-11-12	5001	0	\N	0	0	\N	\N	0	273631	0	117015009	4024958		
5262	505	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	33739	0	6106-9	3014599		
57690	5290	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	351997	0	6276-0	3027231		
16687	1524	3006322	1998-06-02	1998-06-02 00:00:00	1998-06-02	5001	0	\N	0	0	\N	\N	0	101920	0	8331-1	3006322		
27183	2521	3006322	1952-08-29	1952-08-29 00:00:00	1952-08-29	5001	0	\N	0	0	\N	\N	0	166766	0	8331-1	3006322		
43158	3987	3006322	1965-12-06	1965-12-06 00:00:00	1965-12-06	5001	0	\N	0	0	\N	\N	0	265039	0	8331-1	3006322		
43266	3998	3006322	2005-05-13	2005-05-13 00:00:00	2005-05-13	5001	0	\N	0	0	\N	\N	0	265776	0	8331-1	3006322		
43285	4005	3006322	1989-01-08	1989-01-08 00:00:00	1989-01-08	5001	0	\N	0	0	\N	\N	0	266130	0	8331-1	3006322		
22417	2054	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	136668	0	6844-5	3020655		
26044	2392	3006322	1922-06-06	1922-06-06 00:00:00	1922-06-06	5001	0	\N	0	0	\N	\N	0	159043	0	8331-1	3006322		
11808	1120	3006322	2012-12-04	2012-12-04 00:00:00	2012-12-04	5001	0	\N	0	0	\N	\N	0	73829	0	8331-1	3006322		
1248	99	3011505	2000-11-25	2000-11-25 00:00:00	2000-11-25	5001	0	\N	0	0	\N	\N	0	6766	0	19926-5	3011505		
17986	564	4133840	1990-08-16	1990-08-16 00:00:00	1990-08-16	5001	0	\N	0	0	\N	\N	0	37378	0	127783003	4133840		
594	36	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	2523	0	6206-7	3012494		
42176	3899	3006322	1993-11-01	1993-11-01 00:00:00	1993-11-01	5001	0	\N	0	0	\N	\N	0	259288	0	8331-1	3006322		
39491	3652	3006322	1981-05-03	1981-05-03 00:00:00	1981-05-03	5001	0	\N	0	0	\N	\N	0	243099	0	8331-1	3006322		
53634	4924	40769184	1979-06-15	1979-06-15 00:00:00	1979-06-15	5001	0	\N	0	0	\N	\N	0	327259	0	66524-0	40769184		
40613	3769	3051031	2017-09-07	2017-09-07 00:00:00	2017-09-07	5001	0	\N	0	0	\N	\N	0	250578	0	46240-8	3051031		
57621	5285	40758406	1989-10-20	1989-10-20 00:00:00	1989-10-20	5001	0	\N	0	0	\N	\N	0	351660	0	55277-8	40758406		
8006	764	46235214	1973-12-11	1973-12-11 00:00:00	1973-12-11	5001	0	\N	0	0	\N	\N	0	50812	0	76690-7	46235214		
8573	817	3006322	1982-07-05	1982-07-05 00:00:00	1982-07-05	5001	0	\N	0	0	\N	\N	0	54163	0	8331-1	3006322		
47707	4376	3051031	1922-02-26	1922-02-26 00:00:00	1922-02-26	5001	0	\N	0	0	\N	\N	0	290767	0	46240-8	3051031		
17541	550	4052083	1975-12-14	1975-12-14 00:00:00	1975-12-14	5001	0	\N	0	0	\N	\N	0	36518	0	23426006	4052083		
30886	2830	3006451	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	187787	0	6273-7	3006451		
15395	1409	3006322	1966-04-17	1966-04-17 00:00:00	1966-04-17	5001	0	\N	0	0	\N	\N	0	93713	0	8331-1	3006322		
10060	956	3006322	2004-07-22	2004-07-22 00:00:00	2004-07-22	5001	0	\N	0	0	\N	\N	0	63516	0	8331-1	3006322		
38316	3529	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	234409	0	6844-5	3020655		
55284	5058	3006322	2001-05-30	2001-05-30 00:00:00	2001-05-30	5001	0	\N	0	0	\N	\N	0	336332	0	8331-1	3006322		
28018	870	4024958	2006-09-05	2006-09-05 00:00:00	2006-09-05	5001	0	\N	0	0	\N	\N	0	57864	0	117015009	4024958		
23755	2186	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	145818	0	6082-2	3000876		
29380	2706	46235214	1979-05-05	1979-05-05 00:00:00	1979-05-05	5001	0	\N	0	0	\N	\N	0	179290	0	76690-7	46235214		
41456	1280	4052083	1975-12-23	1975-12-23 00:00:00	1975-12-23	5001	0	\N	0	0	\N	\N	0	84605	0	23426006	4052083		
40862	3791	3049273	2012-04-08	2012-04-08 00:00:00	2012-04-08	5001	0	\N	0	0	\N	\N	0	252162	0	38265-5	3049273		
43256	1328	4133840	2004-09-16	2004-09-16 00:00:00	2004-09-16	5001	0	\N	0	0	\N	\N	0	88211	0	127783003	4133840		
10687	1036	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	68117	0	6075-6	3005136		
14126	1320	3006322	1979-08-22	1979-08-22 00:00:00	1979-08-22	5001	0	\N	0	0	\N	\N	0	87514	0	8331-1	3006322		
41999	3884	3000876	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	258114	0	6082-2	3000876		
30044	2767	3009542	1951-04-05	1951-04-05 00:00:00	1951-04-05	5001	0	\N	0	0	\N	\N	0	183068	0	20570-8	3009542		
33532	3041	3001488	1993-09-09	1993-09-09 00:00:00	1993-09-09	5001	0	\N	0	0	\N	\N	0	202546	0	7258-7	3001488		
4872	472	40769194	1998-01-30	1998-01-30 00:00:00	1998-01-30	5001	0	\N	0	0	\N	\N	0	31536	0	66534-9	40769194		
41970	1297	4052083	1983-09-18	1983-09-18 00:00:00	1983-09-18	5001	0	\N	0	0	\N	\N	0	85707	0	23426006	4052083		
14262	449	4133840	2010-07-29	2010-07-29 00:00:00	2010-07-29	5001	0	\N	0	0	\N	\N	0	29890	0	127783003	4133840		
16445	1497	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	99821	0	6276-0	3027231		
14969	469	4024958	1936-11-28	1936-11-28 00:00:00	1936-11-28	5001	0	\N	0	0	\N	\N	0	31243	0	117015009	4024958		
49505	4506	40766240	2014-07-12	2014-07-12 00:00:00	2014-07-12	5001	0	\N	0	0	\N	\N	0	300141	0	63513-6	40766240		
11131	1077	3006322	1996-02-05	1996-02-05 00:00:00	1996-02-05	5001	0	\N	0	0	\N	\N	0	70636	0	8331-1	3006322		
166330	5113	4024958	2013-05-02	2013-05-02 00:00:00	2013-05-02	5001	0	\N	0	0	\N	\N	0	339669	0	117015009	4024958		
10020	954	3006322	2017-02-10	2017-02-10 00:00:00	2017-02-10	5001	0	\N	0	0	\N	\N	0	63417	0	8331-1	3006322		
78063	2392	4133840	2003-06-20	2003-06-20 00:00:00	2003-06-20	5001	0	\N	0	0	\N	\N	0	158995	0	127783003	4133840		
123487	3807	4052083	1965-10-18	1965-10-18 00:00:00	1965-10-18	5001	0	\N	0	0	\N	\N	0	252961	0	23426006	4052083		
142619	4382	4024958	2016-04-07	2016-04-07 00:00:00	2016-04-07	5001	0	\N	0	0	\N	\N	0	291240	0	117015009	4024958		
16271	1482	3001247	1975-07-28	1975-07-28 00:00:00	1975-07-28	5001	0	\N	0	0	\N	\N	0	98904	0	6085-5	3001247		
13460	1272	3023430	1980-05-24	1980-05-24 00:00:00	1980-05-24	5001	0	\N	0	0	\N	\N	0	83864	0	6833-8	3023430		
57134	5245	3020655	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	349045	0	6844-5	3020655		
11875	1136	3006322	1999-09-19	1999-09-19 00:00:00	1999-09-19	5001	0	\N	0	0	\N	\N	0	74811	0	8331-1	3006322		
20668	1898	3051031	1972-01-06	1972-01-06 00:00:00	1972-01-06	5001	0	\N	0	0	\N	\N	0	126390	0	46240-8	3051031		
39016	3604	3006322	1992-06-03	1992-06-03 00:00:00	1992-06-03	5001	0	\N	0	0	\N	\N	0	239526	0	8331-1	3006322		
50165	4577	3006322	1986-07-25	1986-07-25 00:00:00	1986-07-25	5001	0	\N	0	0	\N	\N	0	304885	0	8331-1	3006322		
14891	1379	3011505	2016-04-09	2016-04-09 00:00:00	2016-04-09	5001	0	\N	0	0	\N	\N	0	91508	0	19926-5	3011505		
4121	409	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	27130	0	6248-9	3015076		
16959	1540	3006322	1979-09-06	1979-09-06 00:00:00	1979-09-06	5001	0	\N	0	0	\N	\N	0	103216	0	8331-1	3006322		
133721	4116	4024958	1980-08-16	1980-08-16 00:00:00	1980-08-16	5001	0	\N	0	0	\N	\N	0	273626	0	117015009	4024958		
5263	505	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	33739	0	6273-7	3006451		
57691	5290	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	351997	0	6106-9	3014599		
16688	1524	3006322	2004-05-27	2004-05-27 00:00:00	2004-05-27	5001	0	\N	0	0	\N	\N	0	101934	0	8331-1	3006322		
27184	2521	3006322	1953-01-10	1953-01-10 00:00:00	1953-01-10	5001	0	\N	0	0	\N	\N	0	166757	0	8331-1	3006322		
43159	3987	3006322	1990-10-22	1990-10-22 00:00:00	1990-10-22	5001	0	\N	0	0	\N	\N	0	265071	0	8331-1	3006322		
43267	3998	3006322	1953-03-15	1953-03-15 00:00:00	1953-03-15	5001	0	\N	0	0	\N	\N	0	265833	0	8331-1	3006322		
43286	4005	3006322	1979-05-15	1979-05-15 00:00:00	1979-05-15	5001	0	\N	0	0	\N	\N	0	266110	0	8331-1	3006322		
22418	2054	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	136668	0	6189-5	3006734		
26045	2392	3011505	2003-06-20	2003-06-20 00:00:00	2003-06-20	5001	0	\N	0	0	\N	\N	0	158995	0	19926-5	3011505		
11809	1120	3006322	1979-11-01	1979-11-01 00:00:00	1979-11-01	5001	0	\N	0	0	\N	\N	0	73789	0	8331-1	3006322		
1249	99	3006322	1967-10-11	1967-10-11 00:00:00	1967-10-11	5001	0	\N	0	0	\N	\N	0	6718	0	8331-1	3006322		
17989	564	4133840	1991-10-24	1991-10-24 00:00:00	1991-10-24	5001	0	\N	0	0	\N	\N	0	37324	0	127783003	4133840		
595	36	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	2523	0	6276-0	3027231		
42177	3899	3006322	2012-12-14	2012-12-14 00:00:00	2012-12-14	5001	0	\N	0	0	\N	\N	0	259268	0	8331-1	3006322		
39492	3652	3006322	2002-05-11	2002-05-11 00:00:00	2002-05-11	5001	0	\N	0	0	\N	\N	0	243081	0	8331-1	3006322		
53635	4924	40769194	1979-06-15	1979-06-15 00:00:00	1979-06-15	5001	0	\N	0	0	\N	\N	0	327259	0	66534-9	40769194		
40614	3771	3006322	2009-08-03	2009-08-03 00:00:00	2009-08-03	5001	0	\N	0	0	\N	\N	0	250600	0	8331-1	3006322		
57622	5285	40766240	1989-10-20	1989-10-20 00:00:00	1989-10-20	5001	0	\N	0	0	\N	\N	0	351660	0	63513-6	40766240		
8007	764	40766240	1974-02-09	1974-02-09 00:00:00	1974-02-09	5001	0	\N	0	0	\N	\N	0	50807	0	63513-6	40766240		
8574	817	3006322	1967-05-25	1967-05-25 00:00:00	1967-05-25	5001	0	\N	0	0	\N	\N	0	54144	0	8331-1	3006322		
47708	4376	40758406	1922-02-26	1922-02-26 00:00:00	1922-02-26	5001	0	\N	0	0	\N	\N	0	290767	0	55277-8	40758406		
17542	550	4024958	1964-09-10	1964-09-10 00:00:00	1964-09-10	5001	0	\N	0	0	\N	\N	0	36534	0	117015009	4024958		
30887	2830	3015076	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	187787	0	6248-9	3015076		
15396	1409	3006322	1967-11-17	1967-11-17 00:00:00	1967-11-17	5001	0	\N	0	0	\N	\N	0	93763	0	8331-1	3006322		
10061	956	3049273	2006-05-03	2006-05-03 00:00:00	2006-05-03	5001	0	\N	0	0	\N	\N	0	63525	0	38265-5	3049273		
38317	3529	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	234409	0	6085-5	3001247		
55285	5058	3049273	2017-03-05	2017-03-05 00:00:00	2017-03-05	5001	0	\N	0	0	\N	\N	0	336327	0	38265-5	3049273		
28021	870	4052083	1979-05-19	1979-05-19 00:00:00	1979-05-19	5001	0	\N	0	0	\N	\N	0	57863	0	23426006	4052083		
23756	2186	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	145818	0	6273-7	3006451		
29381	2706	40758406	1979-05-05	1979-05-05 00:00:00	1979-05-05	5001	0	\N	0	0	\N	\N	0	179290	0	55277-8	40758406		
41466	1281	4052083	1997-11-30	1997-11-30 00:00:00	1997-11-30	5001	0	\N	0	0	\N	\N	0	84687	0	23426006	4052083		
40863	3791	3006322	1948-02-16	1948-02-16 00:00:00	1948-02-16	5001	0	\N	0	0	\N	\N	0	252135	0	8331-1	3006322		
9074	286	4052083	1934-05-22	1934-05-22 00:00:00	1934-05-22	5001	0	\N	0	0	\N	\N	0	19082	0	23426006	4052083		
10688	1036	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	68117	0	6082-2	3000876		
14127	1320	3006322	2004-10-02	2004-10-02 00:00:00	2004-10-02	5001	0	\N	0	0	\N	\N	0	87518	0	8331-1	3006322		
42000	3884	3020655	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	258114	0	6844-5	3020655		
30045	2767	3000963	1951-04-05	1951-04-05 00:00:00	1951-04-05	5001	0	\N	0	0	\N	\N	0	183068	0	718-7	3000963		
33533	3041	3000876	1993-09-09	1993-09-09 00:00:00	1993-09-09	5001	0	\N	0	0	\N	\N	0	202546	0	6082-2	3000876		
4873	472	40769179	1998-01-30	1998-01-30 00:00:00	1998-01-30	5001	0	\N	0	0	\N	\N	0	31536	0	66519-0	40769179		
41974	1297	4024958	2002-02-09	2002-02-09 00:00:00	2002-02-09	5001	0	\N	0	0	\N	\N	0	85719	0	117015009	4024958		
14268	449	4133840	1999-11-11	1999-11-11 00:00:00	1999-11-11	5001	0	\N	0	0	\N	\N	0	29982	0	127783003	4133840		
16446	1497	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	99821	0	6844-5	3020655		
14992	469	4052083	2004-10-20	2004-10-20 00:00:00	2004-10-20	5001	0	\N	0	0	\N	\N	0	31328	0	23426006	4052083		
49508	4506	46235214	2014-07-12	2014-07-12 00:00:00	2014-07-12	5001	0	\N	0	0	\N	\N	0	300141	0	76690-7	46235214		
11132	1077	3006322	1987-05-30	1987-05-30 00:00:00	1987-05-30	5001	0	\N	0	0	\N	\N	0	70587	0	8331-1	3006322		
166335	5113	4024958	2011-07-31	2011-07-31 00:00:00	2011-07-31	5001	0	\N	0	0	\N	\N	0	339708	0	117015009	4024958		
10021	954	3006322	1978-03-06	1978-03-06 00:00:00	1978-03-06	5001	0	\N	0	0	\N	\N	0	63380	0	8331-1	3006322		
78066	2392	4024958	1956-05-13	1956-05-13 00:00:00	1956-05-13	5001	0	\N	0	0	\N	\N	0	159040	0	117015009	4024958		
89291	2765	4024958	1949-03-21	1949-03-21 00:00:00	1949-03-21	5001	0	\N	0	0	\N	\N	0	182918	0	117015009	4024958		
142626	4382	4024958	1974-10-07	1974-10-07 00:00:00	1974-10-07	5001	0	\N	0	0	\N	\N	0	291181	0	117015009	4024958		
16272	1482	3006734	1975-07-28	1975-07-28 00:00:00	1975-07-28	5001	0	\N	0	0	\N	\N	0	98904	0	6189-5	3006734		
13461	1272	3036780	1980-05-24	1980-05-24 00:00:00	1980-05-24	5001	0	\N	0	0	\N	\N	0	83864	0	6095-4	3036780		
57135	5245	3023430	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	349045	0	6833-8	3023430		
11877	1137	40758406	1984-10-30	1984-10-30 00:00:00	1984-10-30	5001	0	\N	0	0	\N	\N	0	74984	0	55277-8	40758406		
20669	1898	46235214	1972-01-06	1972-01-06 00:00:00	1972-01-06	5001	0	\N	0	0	\N	\N	0	126390	0	76690-7	46235214		
39017	3604	3006322	1998-02-16	1998-02-16 00:00:00	1998-02-16	5001	0	\N	0	0	\N	\N	0	239481	0	8331-1	3006322		
50166	4577	3006322	2015-03-30	2015-03-30 00:00:00	2015-03-30	5001	0	\N	0	0	\N	\N	0	304907	0	8331-1	3006322		
14892	1379	3011505	2014-03-29	2014-03-29 00:00:00	2014-03-29	5001	0	\N	0	0	\N	\N	0	91453	0	19926-5	3011505		
4122	409	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	27130	0	6276-0	3027231		
16960	1540	3006322	1986-04-12	1986-04-12 00:00:00	1986-04-12	5001	0	\N	0	0	\N	\N	0	103217	0	8331-1	3006322		
133727	4116	4052083	2008-12-23	2008-12-23 00:00:00	2008-12-23	5001	0	\N	0	0	\N	\N	0	273615	0	23426006	4052083		
5264	505	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	33739	0	6085-5	3001247		
57692	5290	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	351997	0	6844-5	3020655		
16689	1524	3006322	2003-04-19	2003-04-19 00:00:00	2003-04-19	5001	0	\N	0	0	\N	\N	0	101955	0	8331-1	3006322		
155638	4776	4024958	1999-02-11	1999-02-11 00:00:00	1999-02-11	5001	0	\N	0	0	\N	\N	0	317994	0	117015009	4024958		
43160	3987	3049273	2014-02-22	2014-02-22 00:00:00	2014-02-22	5001	0	\N	0	0	\N	\N	0	265059	0	38265-5	3049273		
43268	3998	3006322	1993-02-04	1993-02-04 00:00:00	1993-02-04	5001	0	\N	0	0	\N	\N	0	265788	0	8331-1	3006322		
43288	4006	3006322	1957-09-06	1957-09-06 00:00:00	1957-09-06	5001	0	\N	0	0	\N	\N	0	266201	0	8331-1	3006322		
22419	2054	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	136668	0	6246-3	3021226		
26046	2392	3011505	2004-06-25	2004-06-25 00:00:00	2004-06-25	5001	0	\N	0	0	\N	\N	0	158980	0	19926-5	3011505		
11810	1120	3006322	1966-03-23	1966-03-23 00:00:00	1966-03-23	5001	0	\N	0	0	\N	\N	0	73786	0	8331-1	3006322		
1250	99	3011505	2004-12-04	2004-12-04 00:00:00	2004-12-04	5001	0	\N	0	0	\N	\N	0	6716	0	19926-5	3011505		
17990	564	4133840	2015-09-10	2015-09-10 00:00:00	2015-09-10	5001	0	\N	0	0	\N	\N	0	37359	0	127783003	4133840		
596	36	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	2523	0	6246-3	3021226		
42178	3900	3006322	1967-08-06	1967-08-06 00:00:00	1967-08-06	5001	0	\N	0	0	\N	\N	0	259323	0	8331-1	3006322		
39493	3652	3006322	1977-09-22	1977-09-22 00:00:00	1977-09-22	5001	0	\N	0	0	\N	\N	0	243078	0	8331-1	3006322		
53636	4924	40769179	1979-06-15	1979-06-15 00:00:00	1979-06-15	5001	0	\N	0	0	\N	\N	0	327259	0	66519-0	40769179		
40615	3771	3006322	2007-11-03	2007-11-03 00:00:00	2007-11-03	5001	0	\N	0	0	\N	\N	0	250597	0	8331-1	3006322		
57624	5285	3008598	2011-11-19	2011-11-19 00:00:00	2011-11-19	5001	0	\N	0	0	\N	\N	0	351664	0	3024-7	3008598		
8010	764	46235214	1974-02-09	1974-02-09 00:00:00	1974-02-09	5001	0	\N	0	0	\N	\N	0	50807	0	76690-7	46235214		
8575	817	3000963	1976-05-11	1976-05-11 00:00:00	1976-05-11	5001	0	\N	0	0	\N	\N	0	54162	0	718-7	3000963		
47711	4376	46235214	1922-02-26	1922-02-26 00:00:00	1922-02-26	5001	0	\N	0	0	\N	\N	0	290767	0	76690-7	46235214		
28853	893	4052083	2001-01-22	2001-01-22 00:00:00	2001-01-22	5001	0	\N	0	0	\N	\N	0	59477	0	23426006	4052083		
30888	2830	3019406	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	187787	0	6158-0	3019406		
15397	1409	3006322	1933-04-17	1933-04-17 00:00:00	1933-04-17	5001	0	\N	0	0	\N	\N	0	93709	0	8331-1	3006322		
10062	956	3006322	1942-11-11	1942-11-11 00:00:00	1942-11-11	5001	0	\N	0	0	\N	\N	0	63494	0	8331-1	3006322		
38318	3529	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	234409	0	6189-5	3006734		
55286	5058	3006322	1991-10-07	1991-10-07 00:00:00	1991-10-07	5001	0	\N	0	0	\N	\N	0	336284	0	8331-1	3006322		
28044	871	4024958	1971-01-24	1971-01-24 00:00:00	1971-01-24	5001	0	\N	0	0	\N	\N	0	57930	0	117015009	4024958		
23757	2186	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	145818	0	6248-9	3015076		
29382	2706	3006322	1967-10-16	1967-10-16 00:00:00	1967-10-16	5001	0	\N	0	0	\N	\N	0	179252	0	8331-1	3006322		
19009	1743	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	116503	0	6082-2	3000876		
172662	5299	4052083	2000-04-20	2000-04-20 00:00:00	2000-04-20	5001	0	\N	0	0	\N	\N	0	352529	0	23426006	4052083		
9083	287	4052083	2014-08-28	2014-08-28 00:00:00	2014-08-28	5001	0	\N	0	0	\N	\N	0	19191	0	23426006	4052083		
10689	1036	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	68117	0	6085-5	3001247		
14128	1320	3006322	1960-08-01	1960-08-01 00:00:00	1960-08-01	5001	0	\N	0	0	\N	\N	0	87559	0	8331-1	3006322		
42001	3884	3012494	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	258114	0	6206-7	3012494		
30046	2767	40758406	2015-04-19	2015-04-19 00:00:00	2015-04-19	5001	0	\N	0	0	\N	\N	0	183031	0	55277-8	40758406		
33534	3041	3019406	1993-09-09	1993-09-09 00:00:00	1993-09-09	5001	0	\N	0	0	\N	\N	0	202546	0	6158-0	3019406		
4874	472	40769184	1998-01-30	1998-01-30 00:00:00	1998-01-30	5001	0	\N	0	0	\N	\N	0	31536	0	66524-0	40769184		
39142	1217	4133840	2003-07-11	2003-07-11 00:00:00	2003-07-11	5001	0	\N	0	0	\N	\N	0	80143	0	127783003	4133840		
14272	449	4133840	2007-07-19	2007-07-19 00:00:00	2007-07-19	5001	0	\N	0	0	\N	\N	0	29972	0	127783003	4133840		
16447	1497	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	99821	0	6085-5	3001247		
129764	3998	4052083	1964-02-15	1964-02-15 00:00:00	1964-02-15	5001	0	\N	0	0	\N	\N	0	265845	0	23426006	4052083		
49509	4506	40758406	2014-07-12	2014-07-12 00:00:00	2014-07-12	5001	0	\N	0	0	\N	\N	0	300141	0	55277-8	40758406		
11133	1077	3006322	1978-07-02	1978-07-02 00:00:00	1978-07-02	5001	0	\N	0	0	\N	\N	0	70590	0	8331-1	3006322		
166348	5113	4024958	1979-01-17	1979-01-17 00:00:00	1979-01-17	5001	0	\N	0	0	\N	\N	0	339707	0	117015009	4024958		
10022	954	3006322	1975-04-11	1975-04-11 00:00:00	1975-04-11	5001	0	\N	0	0	\N	\N	0	63378	0	8331-1	3006322		
78068	2392	4133840	1995-05-05	1995-05-05 00:00:00	1995-05-05	5001	0	\N	0	0	\N	\N	0	158970	0	127783003	4133840		
89292	2765	4052083	1994-08-17	1994-08-17 00:00:00	1994-08-17	5001	0	\N	0	0	\N	\N	0	182998	0	23426006	4052083		
142628	4382	4052083	2010-08-13	2010-08-13 00:00:00	2010-08-13	5001	0	\N	0	0	\N	\N	0	291257	0	23426006	4052083		
16273	1482	3020655	1975-07-28	1975-07-28 00:00:00	1975-07-28	5001	0	\N	0	0	\N	\N	0	98904	0	6844-5	3020655		
13462	1272	3019406	1980-05-24	1980-05-24 00:00:00	1980-05-24	5001	0	\N	0	0	\N	\N	0	83864	0	6158-0	3019406		
57136	5245	3006322	2006-04-29	2006-04-29 00:00:00	2006-04-29	5001	0	\N	0	0	\N	\N	0	349047	0	8331-1	3006322		
11879	1137	46235214	1984-10-30	1984-10-30 00:00:00	1984-10-30	5001	0	\N	0	0	\N	\N	0	74984	0	76690-7	46235214		
20671	1898	40758406	1972-04-05	1972-04-05 00:00:00	1972-04-05	5001	0	\N	0	0	\N	\N	0	126391	0	55277-8	40758406		
39018	3604	3006322	2014-12-09	2014-12-09 00:00:00	2014-12-09	5001	0	\N	0	0	\N	\N	0	239552	0	8331-1	3006322		
50167	4577	3006322	2015-06-13	2015-06-13 00:00:00	2015-06-13	5001	0	\N	0	0	\N	\N	0	304871	0	8331-1	3006322		
14893	1379	3011505	2010-03-06	2010-03-06 00:00:00	2010-03-06	5001	0	\N	0	0	\N	\N	0	91451	0	19926-5	3011505		
4123	409	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	27130	0	6158-0	3019406		
16961	1540	3006322	1960-01-23	1960-01-23 00:00:00	1960-01-23	5001	0	\N	0	0	\N	\N	0	103212	0	8331-1	3006322		
133734	4117	4024958	2017-10-18	2017-10-18 00:00:00	2017-10-18	5001	0	\N	0	0	\N	\N	0	273716	0	117015009	4024958		
5265	505	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	33739	0	6082-2	3000876		
57693	5290	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	351997	0	7258-7	3001488		
16690	1524	3006322	2005-10-31	2005-10-31 00:00:00	2005-10-31	5001	0	\N	0	0	\N	\N	0	101921	0	8331-1	3006322		
155642	4776	4052083	2008-04-23	2008-04-23 00:00:00	2008-04-23	5001	0	\N	0	0	\N	\N	0	318043	0	23426006	4052083		
43161	3987	3049273	2010-04-20	2010-04-20 00:00:00	2010-04-20	5001	0	\N	0	0	\N	\N	0	265030	0	38265-5	3049273		
43269	3998	3006322	1962-02-08	1962-02-08 00:00:00	1962-02-08	5001	0	\N	0	0	\N	\N	0	265834	0	8331-1	3006322		
43289	4006	3006322	1993-07-12	1993-07-12 00:00:00	1993-07-12	5001	0	\N	0	0	\N	\N	0	266162	0	8331-1	3006322		
22420	2054	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	136668	0	6833-8	3023430		
26047	2392	3011505	2008-07-18	2008-07-18 00:00:00	2008-07-18	5001	0	\N	0	0	\N	\N	0	158973	0	19926-5	3011505		
23140	2130	3006322	1977-02-18	1977-02-18 00:00:00	1977-02-18	5001	0	\N	0	0	\N	\N	0	141696	0	8331-1	3006322		
1251	99	3006322	1974-05-02	1974-05-02 00:00:00	1974-05-02	5001	0	\N	0	0	\N	\N	0	6776	0	8331-1	3006322		
17995	564	4133840	2010-08-12	2010-08-12 00:00:00	2010-08-12	5001	0	\N	0	0	\N	\N	0	37327	0	127783003	4133840		
597	36	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	2523	0	6248-9	3015076		
42179	3900	3011505	2004-09-21	2004-09-21 00:00:00	2004-09-21	5001	0	\N	0	0	\N	\N	0	259319	0	19926-5	3011505		
39494	3652	3006322	2018-01-28	2018-01-28 00:00:00	2018-01-28	5001	0	\N	0	0	\N	\N	0	243124	0	8331-1	3006322		
53637	4924	3006322	2001-07-02	2001-07-02 00:00:00	2001-07-02	5001	0	\N	0	0	\N	\N	0	327175	0	8331-1	3006322		
40616	3771	3006322	1972-05-19	1972-05-19 00:00:00	1972-05-19	5001	0	\N	0	0	\N	\N	0	250611	0	8331-1	3006322		
57625	5285	3009201	2011-11-19	2011-11-19 00:00:00	2011-11-19	5001	0	\N	0	0	\N	\N	0	351664	0	3016-3	3009201		
8011	764	3051031	1974-02-09	1974-02-09 00:00:00	1974-02-09	5001	0	\N	0	0	\N	\N	0	50807	0	46240-8	3051031		
8576	817	3009542	1976-05-11	1976-05-11 00:00:00	1976-05-11	5001	0	\N	0	0	\N	\N	0	54162	0	20570-8	3009542		
47712	4376	3006322	1951-05-01	1951-05-01 00:00:00	1951-05-01	5001	0	\N	0	0	\N	\N	0	290743	0	8331-1	3006322		
28861	893	4052083	1963-08-31	1963-08-31 00:00:00	1963-08-31	5001	0	\N	0	0	\N	\N	0	59488	0	23426006	4052083		
30889	2830	3020655	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	187787	0	6844-5	3020655		
15398	1409	3006322	1993-05-27	1993-05-27 00:00:00	1993-05-27	5001	0	\N	0	0	\N	\N	0	93714	0	8331-1	3006322		
10065	958	3006322	1969-05-06	1969-05-06 00:00:00	1969-05-06	5001	0	\N	0	0	\N	\N	0	63591	0	8331-1	3006322		
38319	3529	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	234409	0	6833-8	3023430		
55287	5058	3006322	1937-07-08	1937-07-08 00:00:00	1937-07-08	5001	0	\N	0	0	\N	\N	0	336290	0	8331-1	3006322		
28048	871	4052083	2001-09-03	2001-09-03 00:00:00	2001-09-03	5001	0	\N	0	0	\N	\N	0	57933	0	23426006	4052083		
23758	2186	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	145818	0	6206-7	3012494		
29383	2706	3006322	1973-02-14	1973-02-14 00:00:00	1973-02-14	5001	0	\N	0	0	\N	\N	0	179289	0	8331-1	3006322		
19010	1743	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	116503	0	6273-7	3006451		
172711	5300	4024958	1953-08-07	1953-08-07 00:00:00	1953-08-07	5001	0	\N	0	0	\N	\N	0	352631	0	117015009	4024958		
9088	287	4024958	1997-02-03	1997-02-03 00:00:00	1997-02-03	5001	0	\N	0	0	\N	\N	0	19190	0	117015009	4024958		
10690	1036	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	68117	0	6106-9	3014599		
14129	1321	3006322	2007-06-22	2007-06-22 00:00:00	2007-06-22	5001	0	\N	0	0	\N	\N	0	87641	0	8331-1	3006322		
42002	3884	3019406	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	258114	0	6158-0	3019406		
30048	2767	3051031	2015-04-19	2015-04-19 00:00:00	2015-04-19	5001	0	\N	0	0	\N	\N	0	183031	0	46240-8	3051031		
33535	3041	3012494	1993-09-09	1993-09-09 00:00:00	1993-09-09	5001	0	\N	0	0	\N	\N	0	202546	0	6206-7	3012494		
4875	472	3006322	1983-12-16	1983-12-16 00:00:00	1983-12-16	5001	0	\N	0	0	\N	\N	0	31513	0	8331-1	3006322		
39143	1217	4052083	2015-05-28	2015-05-28 00:00:00	2015-05-28	5001	0	\N	0	0	\N	\N	0	80169	0	23426006	4052083		
14273	449	4052083	1985-08-17	1985-08-17 00:00:00	1985-08-17	5001	0	\N	0	0	\N	\N	0	29863	0	23426006	4052083		
16448	1497	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	99821	0	6189-5	3006734		
129772	3998	4024958	1953-03-15	1953-03-15 00:00:00	1953-03-15	5001	0	\N	0	0	\N	\N	0	265833	0	117015009	4024958		
49510	4506	40766240	2013-08-16	2013-08-16 00:00:00	2013-08-16	5001	0	\N	0	0	\N	\N	0	300176	0	63513-6	40766240		
11137	1079	3006322	1970-10-15	1970-10-15 00:00:00	1970-10-15	5001	0	\N	0	0	\N	\N	0	70757	0	8331-1	3006322		
166349	5113	4024958	2007-01-10	2007-01-10 00:00:00	2007-01-10	5001	0	\N	0	0	\N	\N	0	339668	0	117015009	4024958		
10024	956	3006322	1964-11-12	1964-11-12 00:00:00	1964-11-12	5001	0	\N	0	0	\N	\N	0	63541	0	8331-1	3006322		
78071	2392	4133840	1970-02-20	1970-02-20 00:00:00	1970-02-20	5001	0	\N	0	0	\N	\N	0	159002	0	127783003	4133840		
89294	2765	4052083	1949-06-04	1949-06-04 00:00:00	1949-06-04	5001	0	\N	0	0	\N	\N	0	182938	0	23426006	4052083		
120388	3714	4024958	1924-05-09	1924-05-09 00:00:00	1924-05-09	5001	0	\N	0	0	\N	\N	0	246851	0	117015009	4024958		
16274	1482	3019406	1975-07-28	1975-07-28 00:00:00	1975-07-28	5001	0	\N	0	0	\N	\N	0	98904	0	6158-0	3019406		
13463	1272	3005136	1980-05-24	1980-05-24 00:00:00	1980-05-24	5001	0	\N	0	0	\N	\N	0	83864	0	6075-6	3005136		
57137	5245	3006322	2011-02-16	2011-02-16 00:00:00	2011-02-16	5001	0	\N	0	0	\N	\N	0	348955	0	8331-1	3006322		
11880	1137	40766240	1984-10-30	1984-10-30 00:00:00	1984-10-30	5001	0	\N	0	0	\N	\N	0	74984	0	63513-6	40766240		
20672	1898	3051031	1972-04-05	1972-04-05 00:00:00	1972-04-05	5001	0	\N	0	0	\N	\N	0	126391	0	46240-8	3051031		
39019	3604	3006322	1992-04-24	1992-04-24 00:00:00	1992-04-24	5001	0	\N	0	0	\N	\N	0	239474	0	8331-1	3006322		
50168	4577	3006322	1996-05-15	1996-05-15 00:00:00	1996-05-15	5001	0	\N	0	0	\N	\N	0	304859	0	8331-1	3006322		
14894	1379	3006322	1994-11-03	1994-11-03 00:00:00	1994-11-03	5001	0	\N	0	0	\N	\N	0	91458	0	8331-1	3006322		
4124	409	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	27130	0	6273-7	3006451		
16962	1541	3006322	1966-12-20	1966-12-20 00:00:00	1966-12-20	5001	0	\N	0	0	\N	\N	0	103234	0	8331-1	3006322		
133737	4117	4024958	1966-04-11	1966-04-11 00:00:00	1966-04-11	5001	0	\N	0	0	\N	\N	0	273736	0	117015009	4024958		
5266	505	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	33739	0	6158-0	3019406		
57694	5290	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	351997	0	6189-5	3006734		
16691	1524	3006322	1987-09-08	1987-09-08 00:00:00	1987-09-08	5001	0	\N	0	0	\N	\N	0	101917	0	8331-1	3006322		
16769	1528	3006322	1980-08-18	1980-08-18 00:00:00	1980-08-18	5001	0	\N	0	0	\N	\N	0	102263	0	8331-1	3006322		
43162	3987	3006322	2012-08-13	2012-08-13 00:00:00	2012-08-13	5001	0	\N	0	0	\N	\N	0	265069	0	8331-1	3006322		
43270	3998	3049273	2016-10-24	2016-10-24 00:00:00	2016-10-24	5001	0	\N	0	0	\N	\N	0	265850	0	38265-5	3049273		
54596	4990	3006322	1965-05-12	1965-05-12 00:00:00	1965-05-12	5001	0	\N	0	0	\N	\N	0	331972	0	8331-1	3006322		
22421	2054	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	136668	0	6095-4	3036780		
26048	2392	3011505	2011-08-05	2011-08-05 00:00:00	2011-08-05	5001	0	\N	0	0	\N	\N	0	159067	0	19926-5	3011505		
23141	2130	3006322	1971-08-24	1971-08-24 00:00:00	1971-08-24	5001	0	\N	0	0	\N	\N	0	141695	0	8331-1	3006322		
1252	99	3011505	2014-08-16	2014-08-16 00:00:00	2014-08-16	5001	0	\N	0	0	\N	\N	0	6758	0	19926-5	3011505		
17999	564	4133840	2009-08-06	2009-08-06 00:00:00	2009-08-06	5001	0	\N	0	0	\N	\N	0	37320	0	127783003	4133840		
598	36	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	2523	0	6189-5	3006734		
42181	3901	3006322	2011-06-09	2011-06-09 00:00:00	2011-06-09	5001	0	\N	0	0	\N	\N	0	259449	0	8331-1	3006322		
39508	3654	3006322	1983-02-13	1983-02-13 00:00:00	1983-02-13	5001	0	\N	0	0	\N	\N	0	243240	0	8331-1	3006322		
62480	1917	4024958	1953-03-15	1953-03-15 00:00:00	1953-03-15	5001	0	\N	0	0	\N	\N	0	127525	0	117015009	4024958		
40617	3771	3006322	1981-04-13	1981-04-13 00:00:00	1981-04-13	5001	0	\N	0	0	\N	\N	0	250632	0	8331-1	3006322		
15386	1409	46235214	1918-02-28	1918-02-28 00:00:00	1918-02-28	5001	0	\N	0	0	\N	\N	0	93708	0	76690-7	46235214		
8012	764	40758406	1974-02-09	1974-02-09 00:00:00	1974-02-09	5001	0	\N	0	0	\N	\N	0	50807	0	55277-8	40758406		
8577	817	3006322	2017-04-11	2017-04-11 00:00:00	2017-04-11	5001	0	\N	0	0	\N	\N	0	54151	0	8331-1	3006322		
47713	4376	3011505	1977-07-12	1977-07-12 00:00:00	1977-07-12	5001	0	\N	0	0	\N	\N	0	290817	0	19926-5	3011505		
29014	895	4052083	1980-02-22	1980-02-22 00:00:00	1980-02-22	5001	0	\N	0	0	\N	\N	0	59719	0	23426006	4052083		
30890	2830	3023430	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	187787	0	6833-8	3023430		
15399	1409	3051031	1961-07-17	1961-07-17 00:00:00	1961-07-17	5001	0	\N	0	0	\N	\N	0	93762	0	46240-8	3051031		
10066	958	3006322	1975-06-17	1975-06-17 00:00:00	1975-06-17	5001	0	\N	0	0	\N	\N	0	63595	0	8331-1	3006322		
38320	3529	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	234409	0	6095-4	3036780		
55288	5060	3006322	1977-07-01	1977-07-01 00:00:00	1977-07-01	5001	0	\N	0	0	\N	\N	0	336419	0	8331-1	3006322		
131372	4044	4052083	2004-03-12	2004-03-12 00:00:00	2004-03-12	5001	0	\N	0	0	\N	\N	0	268952	0	23426006	4052083		
23759	2186	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	145818	0	6085-5	3001247		
29384	2706	3051031	1979-07-04	1979-07-04 00:00:00	1979-07-04	5001	0	\N	0	0	\N	\N	0	179263	0	46240-8	3051031		
19011	1743	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	116503	0	6248-9	3015076		
172713	5300	4052083	2007-06-15	2007-06-15 00:00:00	2007-06-15	5001	0	\N	0	0	\N	\N	0	352616	0	23426006	4052083		
55534	5097	3014599	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	338637	0	6106-9	3014599		
10691	1036	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	68117	0	6158-0	3019406		
14130	1321	3006322	2018-05-01	2018-05-01 00:00:00	2018-05-01	5001	0	\N	0	0	\N	\N	0	87675	0	8331-1	3006322		
42003	3884	3005136	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	258114	0	6075-6	3005136		
66067	2025	4024958	1911-08-09	1911-08-09 00:00:00	1911-08-09	5001	0	\N	0	0	\N	\N	0	134630	0	117015009	4024958		
33536	3041	3021226	1993-09-09	1993-09-09 00:00:00	1993-09-09	5001	0	\N	0	0	\N	\N	0	202546	0	6246-3	3021226		
4876	472	3006322	2014-04-01	2014-04-01 00:00:00	2014-04-01	5001	0	\N	0	0	\N	\N	0	31527	0	8331-1	3006322		
39145	1217	4133840	1995-06-30	1995-06-30 00:00:00	1995-06-30	5001	0	\N	0	0	\N	\N	0	80192	0	127783003	4133840		
14275	449	4133840	2016-09-01	2016-09-01 00:00:00	2016-09-01	5001	0	\N	0	0	\N	\N	0	29984	0	127783003	4133840		
16449	1497	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	99821	0	6833-8	3023430		
141105	4352	4024958	2003-04-22	2003-04-22 00:00:00	2003-04-22	5001	0	\N	0	0	\N	\N	0	288708	0	117015009	4024958		
49511	4506	3051031	2013-08-16	2013-08-16 00:00:00	2013-08-16	5001	0	\N	0	0	\N	\N	0	300176	0	46240-8	3051031		
11138	1079	3008598	2016-03-05	2016-03-05 00:00:00	2016-03-05	5001	0	\N	0	0	\N	\N	0	70716	0	3024-7	3008598		
14816	1376	3000963	1979-11-11	1979-11-11 00:00:00	1979-11-11	5001	0	\N	0	0	\N	\N	0	91181	0	718-7	3000963		
21321	1971	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	131017	0	6276-0	3027231		
78072	2392	4052083	1955-05-18	1955-05-18 00:00:00	1955-05-18	5001	0	\N	0	0	\N	\N	0	159026	0	23426006	4052083		
89298	2765	4133840	2011-11-29	2011-11-29 00:00:00	2011-11-29	5001	0	\N	0	0	\N	\N	0	182825	0	127783003	4133840		
15759	1441	3006322	2004-02-14	2004-02-14 00:00:00	2004-02-14	5001	0	\N	0	0	\N	\N	0	95965	0	8331-1	3006322		
16275	1482	3021226	1975-07-28	1975-07-28 00:00:00	1975-07-28	5001	0	\N	0	0	\N	\N	0	98904	0	6246-3	3021226		
13464	1272	3014599	1980-05-24	1980-05-24 00:00:00	1980-05-24	5001	0	\N	0	0	\N	\N	0	83864	0	6106-9	3014599		
57138	5245	3006322	2016-01-07	2016-01-07 00:00:00	2016-01-07	5001	0	\N	0	0	\N	\N	0	349035	0	8331-1	3006322		
11881	1137	3051031	1984-10-30	1984-10-30 00:00:00	1984-10-30	5001	0	\N	0	0	\N	\N	0	74984	0	46240-8	3051031		
20673	1898	46235214	1972-04-05	1972-04-05 00:00:00	1972-04-05	5001	0	\N	0	0	\N	\N	0	126391	0	76690-7	46235214		
39020	3604	3006322	1985-06-18	1985-06-18 00:00:00	1985-06-18	5001	0	\N	0	0	\N	\N	0	239525	0	8331-1	3006322		
50169	4577	3006322	1996-10-26	1996-10-26 00:00:00	1996-10-26	5001	0	\N	0	0	\N	\N	0	304860	0	8331-1	3006322		
14895	1379	3011505	2015-04-04	2015-04-04 00:00:00	2015-04-04	5001	0	\N	0	0	\N	\N	0	91523	0	19926-5	3011505		
4125	409	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	27130	0	6075-6	3005136		
16963	1541	3006322	1998-12-29	1998-12-29 00:00:00	1998-12-29	5001	0	\N	0	0	\N	\N	0	103249	0	8331-1	3006322		
133742	4117	4052083	2012-06-30	2012-06-30 00:00:00	2012-06-30	5001	0	\N	0	0	\N	\N	0	273695	0	23426006	4052083		
5267	505	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	33739	0	6248-9	3015076		
57695	5290	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	351997	0	6833-8	3023430		
16692	1525	3006322	1976-01-05	1976-01-05 00:00:00	1976-01-05	5001	0	\N	0	0	\N	\N	0	101963	0	8331-1	3006322		
16770	1528	3006322	1964-09-12	1964-09-12 00:00:00	1964-09-12	5001	0	\N	0	0	\N	\N	0	102261	0	8331-1	3006322		
43163	3989	3006322	1935-02-09	1935-02-09 00:00:00	1935-02-09	5001	0	\N	0	0	\N	\N	0	265149	0	8331-1	3006322		
157405	4837	4024958	1956-08-15	1956-08-15 00:00:00	1956-08-15	5001	0	\N	0	0	\N	\N	0	321836	0	117015009	4024958		
54597	4990	3006322	2008-02-04	2008-02-04 00:00:00	2008-02-04	5001	0	\N	0	0	\N	\N	0	331986	0	8331-1	3006322		
22422	2054	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	136668	0	6158-0	3019406		
26049	2392	3011505	2016-10-21	2016-10-21 00:00:00	2016-10-21	5001	0	\N	0	0	\N	\N	0	158977	0	19926-5	3011505		
23142	2130	3006322	1974-12-19	1974-12-19 00:00:00	1974-12-19	5001	0	\N	0	0	\N	\N	0	141727	0	8331-1	3006322		
1253	99	3011505	2006-12-09	2006-12-09 00:00:00	2006-12-09	5001	0	\N	0	0	\N	\N	0	6748	0	19926-5	3011505		
18000	564	4133840	1994-10-27	1994-10-27 00:00:00	1994-10-27	5001	0	\N	0	0	\N	\N	0	37325	0	127783003	4133840		
599	36	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	2523	0	7258-7	3001488		
42182	3901	3006322	2008-09-10	2008-09-10 00:00:00	2008-09-10	5001	0	\N	0	0	\N	\N	0	259419	0	8331-1	3006322		
39509	3654	3006322	1971-10-31	1971-10-31 00:00:00	1971-10-31	5001	0	\N	0	0	\N	\N	0	243238	0	8331-1	3006322		
62484	1917	4052083	1982-08-08	1982-08-08 00:00:00	1982-08-08	5001	0	\N	0	0	\N	\N	0	127513	0	23426006	4052083		
40618	3772	3001488	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	250664	0	7258-7	3001488		
15389	1409	40758406	1918-02-28	1918-02-28 00:00:00	1918-02-28	5001	0	\N	0	0	\N	\N	0	93708	0	55277-8	40758406		
8013	764	3006322	2006-11-13	2006-11-13 00:00:00	2006-11-13	5001	0	\N	0	0	\N	\N	0	50835	0	8331-1	3006322		
8578	817	3006322	1970-01-22	1970-01-22 00:00:00	1970-01-22	5001	0	\N	0	0	\N	\N	0	54131	0	8331-1	3006322		
47714	4376	3011505	1994-09-27	1994-09-27 00:00:00	1994-09-27	5001	0	\N	0	0	\N	\N	0	290704	0	19926-5	3011505		
29018	895	4024958	2011-10-15	2011-10-15 00:00:00	2011-10-15	5001	0	\N	0	0	\N	\N	0	59721	0	117015009	4024958		
30891	2830	3012494	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	187787	0	6206-7	3012494		
15400	1409	46235214	1961-07-17	1961-07-17 00:00:00	1961-07-17	5001	0	\N	0	0	\N	\N	0	93762	0	76690-7	46235214		
10067	958	3006322	2012-12-07	2012-12-07 00:00:00	2012-12-07	5001	0	\N	0	0	\N	\N	0	63646	0	8331-1	3006322		
38321	3529	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	234409	0	6206-7	3012494		
55308	5063	3006322	1954-11-23	1954-11-23 00:00:00	1954-11-23	5001	0	\N	0	0	\N	\N	0	336628	0	8331-1	3006322		
131374	4044	4024958	2003-10-17	2003-10-17 00:00:00	2003-10-17	5001	0	\N	0	0	\N	\N	0	268973	0	117015009	4024958		
23760	2186	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	145818	0	7258-7	3001488		
29385	2706	40766240	1979-07-04	1979-07-04 00:00:00	1979-07-04	5001	0	\N	0	0	\N	\N	0	179263	0	63513-6	40766240		
19012	1743	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	116503	0	6206-7	3012494		
172724	5300	4052083	1965-04-09	1965-04-09 00:00:00	1965-04-09	5001	0	\N	0	0	\N	\N	0	352635	0	23426006	4052083		
55535	5097	3027231	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	338637	0	6276-0	3027231		
10692	1036	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	68117	0	6273-7	3006451		
14131	1321	3006322	2013-09-27	2013-09-27 00:00:00	2013-09-27	5001	0	\N	0	0	\N	\N	0	87613	0	8331-1	3006322		
42004	3884	3023430	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	258142	0	6833-8	3023430		
66079	2025	4052083	1965-10-30	1965-10-30 00:00:00	1965-10-30	5001	0	\N	0	0	\N	\N	0	134692	0	23426006	4052083		
33537	3041	3006451	1993-09-09	1993-09-09 00:00:00	1993-09-09	5001	0	\N	0	0	\N	\N	0	202546	0	6273-7	3006451		
4877	472	3006322	1996-09-20	1996-09-20 00:00:00	1996-09-20	5001	0	\N	0	0	\N	\N	0	31514	0	8331-1	3006322		
39147	1217	4133840	2006-07-14	2006-07-14 00:00:00	2006-07-14	5001	0	\N	0	0	\N	\N	0	80144	0	127783003	4133840		
14284	449	4133840	2005-07-14	2005-07-14 00:00:00	2005-07-14	5001	0	\N	0	0	\N	\N	0	29889	0	127783003	4133840		
16450	1497	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	99821	0	6095-4	3036780		
38283	1189	4024958	2001-12-28	2001-12-28 00:00:00	2001-12-28	5001	0	\N	0	0	\N	\N	0	78319	0	117015009	4024958		
49512	4506	40758406	2013-08-16	2013-08-16 00:00:00	2013-08-16	5001	0	\N	0	0	\N	\N	0	300176	0	55277-8	40758406		
11139	1079	3009201	2016-03-05	2016-03-05 00:00:00	2016-03-05	5001	0	\N	0	0	\N	\N	0	70716	0	3016-3	3009201		
14817	1376	3009542	1979-11-11	1979-11-11 00:00:00	1979-11-11	5001	0	\N	0	0	\N	\N	0	91181	0	20570-8	3009542		
21322	1971	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	131017	0	6844-5	3020655		
78074	2392	4133840	1978-11-17	1978-11-17 00:00:00	1978-11-17	5001	0	\N	0	0	\N	\N	0	159057	0	127783003	4133840		
89307	2765	4133840	2006-10-31	2006-10-31 00:00:00	2006-10-31	5001	0	\N	0	0	\N	\N	0	182833	0	127783003	4133840		
15760	1441	3006734	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	95975	0	6189-5	3006734		
16276	1482	3000876	1975-07-28	1975-07-28 00:00:00	1975-07-28	5001	0	\N	0	0	\N	\N	0	98904	0	6082-2	3000876		
13465	1272	3006734	1980-05-24	1980-05-24 00:00:00	1980-05-24	5001	0	\N	0	0	\N	\N	0	83864	0	6189-5	3006734		
57139	5245	3006322	1984-03-11	1984-03-11 00:00:00	1984-03-11	5001	0	\N	0	0	\N	\N	0	348985	0	8331-1	3006322		
11884	1137	40766240	1984-11-29	1984-11-29 00:00:00	1984-11-29	5001	0	\N	0	0	\N	\N	0	74941	0	63513-6	40766240		
12381	1176	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	77634	0	6273-7	3006451		
11360	358	4052083	1957-03-27	1957-03-27 00:00:00	1957-03-27	5001	0	\N	0	0	\N	\N	0	23807	0	23426006	4052083		
50170	4578	40766240	1965-09-21	1965-09-21 00:00:00	1965-09-21	5001	0	\N	0	0	\N	\N	0	304958	0	63513-6	40766240		
14896	1379	3006322	1964-09-09	1964-09-09 00:00:00	1964-09-09	5001	0	\N	0	0	\N	\N	0	91490	0	8331-1	3006322		
4126	409	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	27130	0	6246-3	3021226		
16964	1541	3006322	2006-10-29	2006-10-29 00:00:00	2006-10-29	5001	0	\N	0	0	\N	\N	0	103289	0	8331-1	3006322		
133747	4117	4052083	1998-11-05	1998-11-05 00:00:00	1998-11-05	5001	0	\N	0	0	\N	\N	0	273682	0	23426006	4052083		
5268	505	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	33739	0	6075-6	3005136		
57696	5290	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	351997	0	6095-4	3036780		
16693	1525	3006322	1999-02-19	1999-02-19 00:00:00	1999-02-19	5001	0	\N	0	0	\N	\N	0	101990	0	8331-1	3006322		
16771	1528	3006322	2009-04-13	2009-04-13 00:00:00	2009-04-13	5001	0	\N	0	0	\N	\N	0	102272	0	8331-1	3006322		
43164	3989	3049273	2003-11-21	2003-11-21 00:00:00	2003-11-21	5001	0	\N	0	0	\N	\N	0	265248	0	38265-5	3049273		
157428	4837	4052083	1979-01-15	1979-01-15 00:00:00	1979-01-15	5001	0	\N	0	0	\N	\N	0	321820	0	23426006	4052083		
54598	4990	3006322	1975-02-06	1975-02-06 00:00:00	1975-02-06	5001	0	\N	0	0	\N	\N	0	331975	0	8331-1	3006322		
22423	2054	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	136668	0	6082-2	3000876		
26050	2392	3011505	1958-05-23	1958-05-23 00:00:00	1958-05-23	5001	0	\N	0	0	\N	\N	0	159052	0	19926-5	3011505		
23143	2130	3006322	2008-04-21	2008-04-21 00:00:00	2008-04-21	5001	0	\N	0	0	\N	\N	0	141733	0	8331-1	3006322		
23150	2131	40766240	1952-08-24	1952-08-24 00:00:00	1952-08-24	5001	0	\N	0	0	\N	\N	0	141840	0	63513-6	40766240		
18001	564	4024958	1970-07-01	1970-07-01 00:00:00	1970-07-01	5001	0	\N	0	0	\N	\N	0	37313	0	117015009	4024958		
600	36	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	2523	0	6095-4	3036780		
42183	3901	3006322	1975-03-26	1975-03-26 00:00:00	1975-03-26	5001	0	\N	0	0	\N	\N	0	259344	0	8331-1	3006322		
39510	3654	3006322	2016-01-16	2016-01-16 00:00:00	2016-01-16	5001	0	\N	0	0	\N	\N	0	243242	0	8331-1	3006322		
62535	1918	4024958	1977-08-05	1977-08-05 00:00:00	1977-08-05	5001	0	\N	0	0	\N	\N	0	127626	0	117015009	4024958		
40619	3772	3021226	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	250664	0	6246-3	3021226		
15390	1409	40766240	1918-02-28	1918-02-28 00:00:00	1918-02-28	5001	0	\N	0	0	\N	\N	0	93708	0	63513-6	40766240		
8015	764	46235214	1973-09-12	1973-09-12 00:00:00	1973-09-12	5001	0	\N	0	0	\N	\N	0	50811	0	76690-7	46235214		
8579	817	3006322	1970-06-30	1970-06-30 00:00:00	1970-06-30	5001	0	\N	0	0	\N	\N	0	54161	0	8331-1	3006322		
47715	4376	3011505	2015-01-20	2015-01-20 00:00:00	2015-01-20	5001	0	\N	0	0	\N	\N	0	290839	0	19926-5	3011505		
29025	895	4024958	2007-08-11	2007-08-11 00:00:00	2007-08-11	5001	0	\N	0	0	\N	\N	0	59674	0	117015009	4024958		
30892	2830	3036780	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	187787	0	6095-4	3036780		
40276	1253	4052083	2017-01-28	2017-01-28 00:00:00	2017-01-28	5001	0	\N	0	0	\N	\N	0	82512	0	23426006	4052083		
10068	959	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	63775	0	6246-3	3021226		
38322	3529	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	234409	0	6273-7	3006451		
55309	5063	3049273	2019-02-08	2019-02-08 00:00:00	2019-02-08	5001	0	\N	0	0	\N	\N	0	336541	0	38265-5	3049273		
131375	4044	4052083	2008-06-06	2008-06-06 00:00:00	2008-06-06	5001	0	\N	0	0	\N	\N	0	268923	0	23426006	4052083		
23761	2186	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	145818	0	6246-3	3021226		
29402	2708	3006322	1996-11-09	1996-11-09 00:00:00	1996-11-09	5001	0	\N	0	0	\N	\N	0	179355	0	8331-1	3006322		
19013	1743	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	116503	0	6075-6	3005136		
145860	4477	4052083	2009-12-21	2009-12-21 00:00:00	2009-12-21	5001	0	\N	0	0	\N	\N	0	297951	0	23426006	4052083		
55536	5097	3001247	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	338637	0	6085-5	3001247		
10693	1036	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	68117	0	7258-7	3001488		
14132	1321	3006322	2014-09-07	2014-09-07 00:00:00	2014-09-07	5001	0	\N	0	0	\N	\N	0	87660	0	8331-1	3006322		
42005	3884	3001488	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	258142	0	7258-7	3001488		
66095	2026	4024958	1955-10-05	1955-10-05 00:00:00	1955-10-05	5001	0	\N	0	0	\N	\N	0	134789	0	117015009	4024958		
33538	3041	3027231	1993-09-09	1993-09-09 00:00:00	1993-09-09	5001	0	\N	0	0	\N	\N	0	202546	0	6276-0	3027231		
4878	472	3019406	1998-02-10	1998-02-10 00:00:00	1998-02-10	5001	0	\N	0	0	\N	\N	0	31515	0	6158-0	3019406		
39148	1217	4133840	2012-12-07	2012-12-07 00:00:00	2012-12-07	5001	0	\N	0	0	\N	\N	0	80133	0	127783003	4133840		
35680	3260	3006322	1974-07-21	1974-07-21 00:00:00	1974-07-21	5001	0	\N	0	0	\N	\N	0	216729	0	8331-1	3006322		
16451	1497	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	99821	0	6206-7	3012494		
38285	1189	4024958	2010-11-17	2010-11-17 00:00:00	2010-11-17	5001	0	\N	0	0	\N	\N	0	78306	0	117015009	4024958		
49515	4506	46235214	2013-08-16	2013-08-16 00:00:00	2013-08-16	5001	0	\N	0	0	\N	\N	0	300176	0	76690-7	46235214		
11140	1079	3006322	1962-07-16	1962-07-16 00:00:00	1962-07-16	5001	0	\N	0	0	\N	\N	0	70746	0	8331-1	3006322		
14818	1376	3006322	2002-07-03	2002-07-03 00:00:00	2002-07-03	5001	0	\N	0	0	\N	\N	0	91179	0	8331-1	3006322		
21323	1971	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	131017	0	6082-2	3000876		
78078	2392	4133840	2001-06-08	2001-06-08 00:00:00	2001-06-08	5001	0	\N	0	0	\N	\N	0	158994	0	127783003	4133840		
89309	2765	4133840	2010-11-23	2010-11-23 00:00:00	2010-11-23	5001	0	\N	0	0	\N	\N	0	182835	0	127783003	4133840		
15761	1441	3020655	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	95975	0	6844-5	3020655		
16277	1482	3023430	1975-07-28	1975-07-28 00:00:00	1975-07-28	5001	0	\N	0	0	\N	\N	0	98904	0	6833-8	3023430		
13466	1272	3000876	1980-05-24	1980-05-24 00:00:00	1980-05-24	5001	0	\N	0	0	\N	\N	0	83864	0	6082-2	3000876		
57143	5249	3006322	1957-09-21	1957-09-21 00:00:00	1957-09-21	5001	0	\N	0	0	\N	\N	0	349193	0	8331-1	3006322		
11885	1137	40758406	1984-11-29	1984-11-29 00:00:00	1984-11-29	5001	0	\N	0	0	\N	\N	0	74941	0	55277-8	40758406		
12382	1176	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	77634	0	6206-7	3012494		
11368	358	4024958	1960-12-27	1960-12-27 00:00:00	1960-12-27	5001	0	\N	0	0	\N	\N	0	23848	0	117015009	4024958		
50171	4578	3051031	1965-09-21	1965-09-21 00:00:00	1965-09-21	5001	0	\N	0	0	\N	\N	0	304958	0	46240-8	3051031		
14897	1379	3006322	2002-07-05	2002-07-05 00:00:00	2002-07-05	5001	0	\N	0	0	\N	\N	0	91460	0	8331-1	3006322		
4127	409	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	27130	0	6189-5	3006734		
16965	1541	3006322	1972-08-04	1972-08-04 00:00:00	1972-08-04	5001	0	\N	0	0	\N	\N	0	103240	0	8331-1	3006322		
133758	4117	4024958	1970-03-02	1970-03-02 00:00:00	1970-03-02	5001	0	\N	0	0	\N	\N	0	273711	0	117015009	4024958		
5269	505	3006322	1979-05-10	1979-05-10 00:00:00	1979-05-10	5001	0	\N	0	0	\N	\N	0	33736	0	8331-1	3006322		
57697	5290	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	351927	0	6082-2	3000876		
16694	1525	3006322	2009-01-07	2009-01-07 00:00:00	2009-01-07	5001	0	\N	0	0	\N	\N	0	102023	0	8331-1	3006322		
16772	1528	3006322	1989-12-13	1989-12-13 00:00:00	1989-12-13	5001	0	\N	0	0	\N	\N	0	102211	0	8331-1	3006322		
43165	3989	3006322	2006-11-08	2006-11-08 00:00:00	2006-11-08	5001	0	\N	0	0	\N	\N	0	265163	0	8331-1	3006322		
70511	2160	4024958	2003-03-20	2003-03-20 00:00:00	2003-03-20	5001	0	\N	0	0	\N	\N	0	143984	0	117015009	4024958		
54599	4990	3006322	2012-03-26	2012-03-26 00:00:00	2012-03-26	5001	0	\N	0	0	\N	\N	0	331957	0	8331-1	3006322		
22424	2054	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	136668	0	6085-5	3001247		
26051	2392	3011505	1999-05-28	1999-05-28 00:00:00	1999-05-28	5001	0	\N	0	0	\N	\N	0	158972	0	19926-5	3011505		
23144	2131	3006322	1993-11-28	1993-11-28 00:00:00	1993-11-28	5001	0	\N	0	0	\N	\N	0	141766	0	8331-1	3006322		
23152	2131	3051031	1953-05-21	1953-05-21 00:00:00	1953-05-21	5001	0	\N	0	0	\N	\N	0	141842	0	46240-8	3051031		
18002	564	4133840	2004-11-18	2004-11-18 00:00:00	2004-11-18	5001	0	\N	0	0	\N	\N	0	37380	0	127783003	4133840		
601	36	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	2523	0	6844-5	3020655		
42184	3901	3006322	1939-12-29	1939-12-29 00:00:00	1939-12-29	5001	0	\N	0	0	\N	\N	0	259341	0	8331-1	3006322		
39511	3654	3006322	2004-06-07	2004-06-07 00:00:00	2004-06-07	5001	0	\N	0	0	\N	\N	0	243241	0	8331-1	3006322		
62537	1918	4052083	2002-05-25	2002-05-25 00:00:00	2002-05-25	5001	0	\N	0	0	\N	\N	0	127651	0	23426006	4052083		
40620	3772	3005136	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	250664	0	6075-6	3005136		
15391	1409	3006322	2007-03-23	2007-03-23 00:00:00	2007-03-23	5001	0	\N	0	0	\N	\N	0	93824	0	8331-1	3006322		
8016	764	3051031	1973-09-12	1973-09-12 00:00:00	1973-09-12	5001	0	\N	0	0	\N	\N	0	50811	0	46240-8	3051031		
8585	820	3006322	1999-06-09	1999-06-09 00:00:00	1999-06-09	5001	0	\N	0	0	\N	\N	0	54352	0	8331-1	3006322		
47716	4376	3011505	1984-07-31	1984-07-31 00:00:00	1984-07-31	5001	0	\N	0	0	\N	\N	0	290703	0	19926-5	3011505		
29183	902	4024958	1957-07-06	1957-07-06 00:00:00	1957-07-06	5001	0	\N	0	0	\N	\N	0	60002	0	117015009	4024958		
30893	2830	3027231	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	187787	0	6276-0	3027231		
40279	1253	4052083	2012-04-20	2012-04-20 00:00:00	2012-04-20	5001	0	\N	0	0	\N	\N	0	82517	0	23426006	4052083		
10069	959	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	63775	0	6276-0	3027231		
38323	3529	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	234409	0	6106-9	3014599		
55310	5063	3006322	2000-05-25	2000-05-25 00:00:00	2000-05-25	5001	0	\N	0	0	\N	\N	0	336535	0	8331-1	3006322		
131382	4045	4024958	2003-03-19	2003-03-19 00:00:00	2003-03-19	5001	0	\N	0	0	\N	\N	0	269041	0	117015009	4024958		
23762	2186	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	145818	0	6276-0	3027231		
29403	2708	3006322	2013-03-30	2013-03-30 00:00:00	2013-03-30	5001	0	\N	0	0	\N	\N	0	179362	0	8331-1	3006322		
19014	1743	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	116503	0	6106-9	3014599		
145864	4477	4024958	1975-08-28	1975-08-28 00:00:00	1975-08-28	5001	0	\N	0	0	\N	\N	0	297941	0	117015009	4024958		
55537	5097	3000876	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	338637	0	6082-2	3000876		
10694	1036	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	68117	0	6189-5	3006734		
96072	2945	4133840	1990-10-30	1990-10-30 00:00:00	1990-10-30	5001	0	\N	0	0	\N	\N	0	196501	0	127783003	4133840		
42006	3884	3005136	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	258142	0	6075-6	3005136		
66101	2026	4024958	1954-05-02	1954-05-02 00:00:00	1954-05-02	5001	0	\N	0	0	\N	\N	0	134853	0	117015009	4024958		
33539	3041	3015076	1993-09-09	1993-09-09 00:00:00	1993-09-09	5001	0	\N	0	0	\N	\N	0	202546	0	6248-9	3015076		
4879	472	3005136	1998-02-10	1998-02-10 00:00:00	1998-02-10	5001	0	\N	0	0	\N	\N	0	31515	0	6075-6	3005136		
39149	1217	4052083	2003-07-05	2003-07-05 00:00:00	2003-07-05	5001	0	\N	0	0	\N	\N	0	80159	0	23426006	4052083		
35681	3260	3006322	2003-03-31	2003-03-31 00:00:00	2003-03-31	5001	0	\N	0	0	\N	\N	0	216708	0	8331-1	3006322		
16452	1497	3049273	2007-02-18	2007-02-18 00:00:00	2007-02-18	5001	0	\N	0	0	\N	\N	0	99782	0	38265-5	3049273		
38289	1189	4024958	2005-07-06	2005-07-06 00:00:00	2005-07-06	5001	0	\N	0	0	\N	\N	0	78305	0	117015009	4024958		
49516	4506	3051031	2013-05-18	2013-05-18 00:00:00	2013-05-18	5001	0	\N	0	0	\N	\N	0	300175	0	46240-8	3051031		
11141	1079	3006322	1988-03-27	1988-03-27 00:00:00	1988-03-27	5001	0	\N	0	0	\N	\N	0	70712	0	8331-1	3006322		
14819	1376	3006322	1992-06-26	1992-06-26 00:00:00	1992-06-26	5001	0	\N	0	0	\N	\N	0	91182	0	8331-1	3006322		
21324	1971	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	131017	0	6158-0	3019406		
78083	2392	4133840	1976-01-30	1976-01-30 00:00:00	1976-01-30	5001	0	\N	0	0	\N	\N	0	159085	0	127783003	4133840		
100608	3087	4024958	2013-03-21	2013-03-21 00:00:00	2013-03-21	5001	0	\N	0	0	\N	\N	0	205520	0	117015009	4024958		
15762	1441	3006322	2004-12-24	2004-12-24 00:00:00	2004-12-24	5001	0	\N	0	0	\N	\N	0	96054	0	8331-1	3006322		
16278	1482	3001488	1975-07-28	1975-07-28 00:00:00	1975-07-28	5001	0	\N	0	0	\N	\N	0	98904	0	7258-7	3001488		
13468	1273	3006322	1989-06-13	1989-06-13 00:00:00	1989-06-13	5001	0	\N	0	0	\N	\N	0	84064	0	8331-1	3006322		
57144	5249	3006322	1988-03-02	1988-03-02 00:00:00	1988-03-02	5001	0	\N	0	0	\N	\N	0	349234	0	8331-1	3006322		
11886	1137	46235214	1984-11-29	1984-11-29 00:00:00	1984-11-29	5001	0	\N	0	0	\N	\N	0	74941	0	76690-7	46235214		
12383	1176	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	77634	0	6246-3	3021226		
11371	358	4052083	1976-02-16	1976-02-16 00:00:00	1976-02-16	5001	0	\N	0	0	\N	\N	0	23794	0	23426006	4052083		
50174	4578	46235214	1965-09-21	1965-09-21 00:00:00	1965-09-21	5001	0	\N	0	0	\N	\N	0	304958	0	76690-7	46235214		
14898	1379	3011505	2003-02-15	2003-02-15 00:00:00	2003-02-15	5001	0	\N	0	0	\N	\N	0	91522	0	19926-5	3011505		
4128	409	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	27130	0	6833-8	3023430		
16966	1541	3006322	1989-04-22	1989-04-22 00:00:00	1989-04-22	5001	0	\N	0	0	\N	\N	0	103242	0	8331-1	3006322		
133794	4119	4052083	2018-04-10	2018-04-10 00:00:00	2018-04-10	5001	0	\N	0	0	\N	\N	0	273873	0	23426006	4052083		
5270	505	3006322	1982-04-07	1982-04-07 00:00:00	1982-04-07	5001	0	\N	0	0	\N	\N	0	33815	0	8331-1	3006322		
57698	5290	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	351927	0	6844-5	3020655		
16695	1525	3006322	2012-10-29	2012-10-29 00:00:00	2012-10-29	5001	0	\N	0	0	\N	\N	0	102024	0	8331-1	3006322		
16773	1528	3006322	1973-01-11	1973-01-11 00:00:00	1973-01-11	5001	0	\N	0	0	\N	\N	0	102262	0	8331-1	3006322		
43166	3989	3006322	1996-11-05	1996-11-05 00:00:00	1996-11-05	5001	0	\N	0	0	\N	\N	0	265172	0	8331-1	3006322		
70524	2160	4024958	1994-01-24	1994-01-24 00:00:00	1994-01-24	5001	0	\N	0	0	\N	\N	0	143955	0	117015009	4024958		
54600	4990	3006322	2016-03-21	2016-03-21 00:00:00	2016-03-21	5001	0	\N	0	0	\N	\N	0	331964	0	8331-1	3006322		
22425	2054	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	136668	0	6273-7	3006451		
26052	2392	3011505	1992-04-17	1992-04-17 00:00:00	1992-04-17	5001	0	\N	0	0	\N	\N	0	158993	0	19926-5	3011505		
23145	2131	3006322	1953-06-16	1953-06-16 00:00:00	1953-06-16	5001	0	\N	0	0	\N	\N	0	141761	0	8331-1	3006322		
23153	2131	40758406	1953-05-21	1953-05-21 00:00:00	1953-05-21	5001	0	\N	0	0	\N	\N	0	141842	0	55277-8	40758406		
18007	564	4133840	1996-10-31	1996-10-31 00:00:00	1996-10-31	5001	0	\N	0	0	\N	\N	0	37379	0	127783003	4133840		
602	36	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	2523	0	6085-5	3001247		
42185	3901	3006322	1949-09-27	1949-09-27 00:00:00	1949-09-27	5001	0	\N	0	0	\N	\N	0	259426	0	8331-1	3006322		
39512	3655	3006322	1989-07-02	1989-07-02 00:00:00	1989-07-02	5001	0	\N	0	0	\N	\N	0	243251	0	8331-1	3006322		
169921	5215	4052083	2008-07-29	2008-07-29 00:00:00	2008-07-29	5001	0	\N	0	0	\N	\N	0	346890	0	23426006	4052083		
40621	3772	3023430	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	250664	0	6833-8	3023430		
15392	1409	3006322	1962-08-24	1962-08-24 00:00:00	1962-08-24	5001	0	\N	0	0	\N	\N	0	93823	0	8331-1	3006322		
8017	764	40758406	1973-09-12	1973-09-12 00:00:00	1973-09-12	5001	0	\N	0	0	\N	\N	0	50811	0	55277-8	40758406		
8586	820	3006322	2008-05-02	2008-05-02 00:00:00	2008-05-02	5001	0	\N	0	0	\N	\N	0	54328	0	8331-1	3006322		
47717	4376	3011505	2014-01-14	2014-01-14 00:00:00	2014-01-14	5001	0	\N	0	0	\N	\N	0	290823	0	19926-5	3011505		
29188	902	4052083	1970-05-23	1970-05-23 00:00:00	1970-05-23	5001	0	\N	0	0	\N	\N	0	60004	0	23426006	4052083		
30894	2830	3014599	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	187787	0	6106-9	3014599		
40287	1253	4052083	2010-09-20	2010-09-20 00:00:00	2010-09-20	5001	0	\N	0	0	\N	\N	0	82494	0	23426006	4052083		
10070	959	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	63775	0	6273-7	3006451		
38324	3529	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	234409	0	6158-0	3019406		
55311	5063	3006322	1997-06-30	1997-06-30 00:00:00	1997-06-30	5001	0	\N	0	0	\N	\N	0	336635	0	8331-1	3006322		
142670	4383	4024958	1983-06-27	1983-06-27 00:00:00	1983-06-27	5001	0	\N	0	0	\N	\N	0	291286	0	117015009	4024958		
23763	2186	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	145818	0	6158-0	3019406		
29404	2708	3006322	1990-05-02	1990-05-02 00:00:00	1990-05-02	5001	0	\N	0	0	\N	\N	0	179353	0	8331-1	3006322		
19015	1743	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	116503	0	6085-5	3001247		
145883	4477	4024958	1974-03-27	1974-03-27 00:00:00	1974-03-27	5001	0	\N	0	0	\N	\N	0	297950	0	117015009	4024958		
55538	5097	3019406	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	338637	0	6158-0	3019406		
10695	1036	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	68117	0	6095-4	3036780		
96075	2945	4133840	1979-12-11	1979-12-11 00:00:00	1979-12-11	5001	0	\N	0	0	\N	\N	0	196485	0	127783003	4133840		
42007	3884	3021226	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	258142	0	6246-3	3021226		
66103	2026	4024958	1984-11-07	1984-11-07 00:00:00	1984-11-07	5001	0	\N	0	0	\N	\N	0	134792	0	117015009	4024958		
33540	3041	3001247	1993-09-09	1993-09-09 00:00:00	1993-09-09	5001	0	\N	0	0	\N	\N	0	202546	0	6085-5	3001247		
4880	472	3021226	1998-02-10	1998-02-10 00:00:00	1998-02-10	5001	0	\N	0	0	\N	\N	0	31515	0	6246-3	3021226		
39150	1217	4133840	2001-07-06	2001-07-06 00:00:00	2001-07-06	5001	0	\N	0	0	\N	\N	0	80194	0	127783003	4133840		
35682	3260	3006322	2010-02-02	2010-02-02 00:00:00	2010-02-02	5001	0	\N	0	0	\N	\N	0	216709	0	8331-1	3006322		
16453	1497	3006322	1953-04-09	1953-04-09 00:00:00	1953-04-09	5001	0	\N	0	0	\N	\N	0	99857	0	8331-1	3006322		
38298	1189	4024958	1970-12-29	1970-12-29 00:00:00	1970-12-29	5001	0	\N	0	0	\N	\N	0	78348	0	117015009	4024958		
49517	4506	40766240	2013-05-18	2013-05-18 00:00:00	2013-05-18	5001	0	\N	0	0	\N	\N	0	300175	0	63513-6	40766240		
11173	1081	3006322	2003-07-01	2003-07-01 00:00:00	2003-07-01	5001	0	\N	0	0	\N	\N	0	70837	0	8331-1	3006322		
14820	1376	3006322	1995-04-27	1995-04-27 00:00:00	1995-04-27	5001	0	\N	0	0	\N	\N	0	91183	0	8331-1	3006322		
21325	1971	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	131017	0	6206-7	3012494		
78086	2392	4133840	2006-07-07	2006-07-07 00:00:00	2006-07-07	5001	0	\N	0	0	\N	\N	0	158981	0	127783003	4133840		
100619	3088	4052083	1964-08-11	1964-08-11 00:00:00	1964-08-11	5001	0	\N	0	0	\N	\N	0	205610	0	23426006	4052083		
15763	1441	3006322	1997-08-07	1997-08-07 00:00:00	1997-08-07	5001	0	\N	0	0	\N	\N	0	96053	0	8331-1	3006322		
16279	1482	3027231	1975-07-28	1975-07-28 00:00:00	1975-07-28	5001	0	\N	0	0	\N	\N	0	98904	0	6276-0	3027231		
13471	1273	3006322	1980-10-11	1980-10-11 00:00:00	1980-10-11	5001	0	\N	0	0	\N	\N	0	84019	0	8331-1	3006322		
57145	5249	3006322	1967-06-14	1967-06-14 00:00:00	1967-06-14	5001	0	\N	0	0	\N	\N	0	349183	0	8331-1	3006322		
82352	2546	4052083	1990-05-19	1990-05-19 00:00:00	1990-05-19	5001	0	\N	0	0	\N	\N	0	168509	0	23426006	4052083		
12384	1176	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	77634	0	6075-6	3005136		
11372	358	4024958	2009-03-23	2009-03-23 00:00:00	2009-03-23	5001	0	\N	0	0	\N	\N	0	23854	0	117015009	4024958		
50175	4578	40758406	1965-09-21	1965-09-21 00:00:00	1965-09-21	5001	0	\N	0	0	\N	\N	0	304958	0	55277-8	40758406		
14899	1379	3011505	2017-04-15	2017-04-15 00:00:00	2017-04-15	5001	0	\N	0	0	\N	\N	0	91524	0	19926-5	3011505		
4129	409	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	27130	0	7258-7	3001488		
16967	1541	3006322	1997-10-19	1997-10-19 00:00:00	1997-10-19	5001	0	\N	0	0	\N	\N	0	103236	0	8331-1	3006322		
19676	615	4052083	1920-07-16	1920-07-16 00:00:00	1920-07-16	5001	0	\N	0	0	\N	\N	0	40933	0	23426006	4052083		
5271	505	3009542	1995-05-29	1995-05-29 00:00:00	1995-05-29	5001	0	\N	0	0	\N	\N	0	33760	0	20570-8	3009542		
57699	5290	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	351927	0	6106-9	3014599		
16696	1525	3006322	1968-12-03	1968-12-03 00:00:00	1968-12-03	5001	0	\N	0	0	\N	\N	0	101972	0	8331-1	3006322		
16774	1529	3006322	1993-09-12	1993-09-12 00:00:00	1993-09-12	5001	0	\N	0	0	\N	\N	0	102320	0	8331-1	3006322		
43167	3989	3006322	1981-12-11	1981-12-11 00:00:00	1981-12-11	5001	0	\N	0	0	\N	\N	0	265170	0	8331-1	3006322		
152094	4657	4024958	1968-05-01	1968-05-01 00:00:00	1968-05-01	5001	0	\N	0	0	\N	\N	0	310502	0	117015009	4024958		
54601	4991	3014599	1997-08-01	1997-08-01 00:00:00	1997-08-01	5001	0	\N	0	0	\N	\N	0	332033	0	6106-9	3014599		
22426	2054	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	136668	0	6106-9	3014599		
26053	2392	3011505	2006-07-07	2006-07-07 00:00:00	2006-07-07	5001	0	\N	0	0	\N	\N	0	158981	0	19926-5	3011505		
23147	2131	3051031	1952-08-24	1952-08-24 00:00:00	1952-08-24	5001	0	\N	0	0	\N	\N	0	141840	0	46240-8	3051031		
23154	2131	46235214	1953-05-21	1953-05-21 00:00:00	1953-05-21	5001	0	\N	0	0	\N	\N	0	141842	0	76690-7	46235214		
18008	564	4133840	2013-08-29	2013-08-29 00:00:00	2013-08-29	5001	0	\N	0	0	\N	\N	0	37322	0	127783003	4133840		
603	36	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	2523	0	6833-8	3023430		
42186	3901	3006322	1941-06-03	1941-06-03 00:00:00	1941-06-03	5001	0	\N	0	0	\N	\N	0	259401	0	8331-1	3006322		
39513	3655	3006322	1997-03-06	1997-03-06 00:00:00	1997-03-06	5001	0	\N	0	0	\N	\N	0	243252	0	8331-1	3006322		
169931	5215	4052083	1944-02-23	1944-02-23 00:00:00	1944-02-23	5001	0	\N	0	0	\N	\N	0	346832	0	23426006	4052083		
40622	3772	3006734	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	250664	0	6189-5	3006734		
15393	1409	3006322	1930-12-18	1930-12-18 00:00:00	1930-12-18	5001	0	\N	0	0	\N	\N	0	93812	0	8331-1	3006322		
8018	764	40766240	1973-09-12	1973-09-12 00:00:00	1973-09-12	5001	0	\N	0	0	\N	\N	0	50811	0	63513-6	40766240		
8587	820	3006322	1992-06-30	1992-06-30 00:00:00	1992-06-30	5001	0	\N	0	0	\N	\N	0	54306	0	8331-1	3006322		
47718	4376	3011505	1996-10-08	1996-10-08 00:00:00	1996-10-08	5001	0	\N	0	0	\N	\N	0	290802	0	19926-5	3011505		
29193	902	4024958	2006-04-11	2006-04-11 00:00:00	2006-04-11	5001	0	\N	0	0	\N	\N	0	59986	0	117015009	4024958		
30895	2830	3005136	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	187787	0	6075-6	3005136		
40290	1253	4052083	2012-07-05	2012-07-05 00:00:00	2012-07-05	5001	0	\N	0	0	\N	\N	0	82511	0	23426006	4052083		
10071	959	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	63775	0	6206-7	3012494		
38325	3529	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	234409	0	6082-2	3000876		
131356	4044	4052083	1999-04-29	1999-04-29 00:00:00	1999-04-29	5001	0	\N	0	0	\N	\N	0	268972	0	23426006	4052083		
142672	4383	4024958	1991-09-11	1991-09-11 00:00:00	1991-09-11	5001	0	\N	0	0	\N	\N	0	291288	0	117015009	4024958		
23764	2186	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	145818	0	6844-5	3020655		
29405	2709	3006322	2008-01-31	2008-01-31 00:00:00	2008-01-31	5001	0	\N	0	0	\N	\N	0	179494	0	8331-1	3006322		
19016	1743	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	116503	0	6189-5	3006734		
157165	4828	4052083	2000-07-17	2000-07-17 00:00:00	2000-07-17	5001	0	\N	0	0	\N	\N	0	321286	0	23426006	4052083		
55539	5097	3012494	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	338637	0	6206-7	3012494		
10696	1036	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	68117	0	6833-8	3023430		
96078	2945	4133840	2002-08-27	2002-08-27 00:00:00	2002-08-27	5001	0	\N	0	0	\N	\N	0	196503	0	127783003	4133840		
42008	3884	3014599	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	258142	0	6106-9	3014599		
66105	2026	4052083	2009-02-11	2009-02-11 00:00:00	2009-02-11	5001	0	\N	0	0	\N	\N	0	134858	0	23426006	4052083		
33541	3041	3036780	1993-09-09	1993-09-09 00:00:00	1993-09-09	5001	0	\N	0	0	\N	\N	0	202546	0	6095-4	3036780		
4881	472	3001488	1998-02-10	1998-02-10 00:00:00	1998-02-10	5001	0	\N	0	0	\N	\N	0	31515	0	7258-7	3001488		
39155	1217	4133840	1994-09-23	1994-09-23 00:00:00	1994-09-23	5001	0	\N	0	0	\N	\N	0	80180	0	127783003	4133840		
35688	3263	3049273	2018-01-18	2018-01-18 00:00:00	2018-01-18	5001	0	\N	0	0	\N	\N	0	216905	0	38265-5	3049273		
16454	1498	3006322	1974-04-11	1974-04-11 00:00:00	1974-04-11	5001	0	\N	0	0	\N	\N	0	99934	0	8331-1	3006322		
49599	1510	4052083	1960-05-26	1960-05-26 00:00:00	1960-05-26	5001	0	\N	0	0	\N	\N	0	100778	0	23426006	4052083		
49520	4506	46235214	2013-05-18	2013-05-18 00:00:00	2013-05-18	5001	0	\N	0	0	\N	\N	0	300175	0	76690-7	46235214		
11174	1081	3006322	1984-07-15	1984-07-15 00:00:00	1984-07-15	5001	0	\N	0	0	\N	\N	0	70863	0	8331-1	3006322		
14821	1377	3006322	2017-11-16	2017-11-16 00:00:00	2017-11-16	5001	0	\N	0	0	\N	\N	0	91240	0	8331-1	3006322		
21326	1971	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	131017	0	6085-5	3001247		
78088	2392	4133840	1987-03-20	1987-03-20 00:00:00	1987-03-20	5001	0	\N	0	0	\N	\N	0	159004	0	127783003	4133840		
100635	3088	4024958	1952-01-08	1952-01-08 00:00:00	1952-01-08	5001	0	\N	0	0	\N	\N	0	205616	0	117015009	4024958		
15764	1441	3006322	2013-08-18	2013-08-18 00:00:00	2013-08-18	5001	0	\N	0	0	\N	\N	0	96056	0	8331-1	3006322		
16280	1482	3000876	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	98836	0	6082-2	3000876		
13474	1273	3006322	1972-06-02	1972-06-02 00:00:00	1972-06-02	5001	0	\N	0	0	\N	\N	0	84062	0	8331-1	3006322		
57146	5249	3006322	1994-03-17	1994-03-17 00:00:00	1994-03-17	5001	0	\N	0	0	\N	\N	0	349159	0	8331-1	3006322		
82364	2546	4052083	1989-09-12	1989-09-12 00:00:00	1989-09-12	5001	0	\N	0	0	\N	\N	0	168508	0	23426006	4052083		
12385	1176	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	77634	0	6248-9	3015076		
11378	358	4024958	1982-02-27	1982-02-27 00:00:00	1982-02-27	5001	0	\N	0	0	\N	\N	0	23828	0	117015009	4024958		
50176	4578	3006322	1998-12-07	1998-12-07 00:00:00	1998-12-07	5001	0	\N	0	0	\N	\N	0	304921	0	8331-1	3006322		
14900	1379	3011505	2013-03-23	2013-03-23 00:00:00	2013-03-23	5001	0	\N	0	0	\N	\N	0	91473	0	19926-5	3011505		
4130	409	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	27073	0	6844-5	3020655		
16968	1541	3006322	1964-01-26	1964-01-26 00:00:00	1964-01-26	5001	0	\N	0	0	\N	\N	0	103238	0	8331-1	3006322		
19681	615	4024958	1913-12-21	1913-12-21 00:00:00	1913-12-21	5001	0	\N	0	0	\N	\N	0	41001	0	117015009	4024958		
5272	505	3000963	1995-05-29	1995-05-29 00:00:00	1995-05-29	5001	0	\N	0	0	\N	\N	0	33760	0	718-7	3000963		
57700	5290	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	351927	0	6246-3	3021226		
16697	1526	3006322	1979-09-23	1979-09-23 00:00:00	1979-09-23	5001	0	\N	0	0	\N	\N	0	102078	0	8331-1	3006322		
16775	1529	3006322	1994-02-21	1994-02-21 00:00:00	1994-02-21	5001	0	\N	0	0	\N	\N	0	102359	0	8331-1	3006322		
43168	3989	3049273	2018-01-29	2018-01-29 00:00:00	2018-01-29	5001	0	\N	0	0	\N	\N	0	265193	0	38265-5	3049273		
152096	4657	4024958	1982-05-25	1982-05-25 00:00:00	1982-05-25	5001	0	\N	0	0	\N	\N	0	310561	0	117015009	4024958		
54602	4991	3006451	1997-08-01	1997-08-01 00:00:00	1997-08-01	5001	0	\N	0	0	\N	\N	0	332033	0	6273-7	3006451		
22427	2054	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	136668	0	6075-6	3005136		
26054	2392	3006322	1928-06-17	1928-06-17 00:00:00	1928-06-17	5001	0	\N	0	0	\N	\N	0	159015	0	8331-1	3006322		
23148	2131	40758406	1952-08-24	1952-08-24 00:00:00	1952-08-24	5001	0	\N	0	0	\N	\N	0	141840	0	55277-8	40758406		
23155	2131	40766240	1953-05-21	1953-05-21 00:00:00	1953-05-21	5001	0	\N	0	0	\N	\N	0	141842	0	63513-6	40766240		
18010	564	4133840	2011-08-18	2011-08-18 00:00:00	2011-08-18	5001	0	\N	0	0	\N	\N	0	37321	0	127783003	4133840		
604	36	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	2523	0	6082-2	3000876		
42187	3901	3006322	1947-06-28	1947-06-28 00:00:00	1947-06-28	5001	0	\N	0	0	\N	\N	0	259402	0	8331-1	3006322		
39514	3655	3006322	1949-05-12	1949-05-12 00:00:00	1949-05-12	5001	0	\N	0	0	\N	\N	0	243249	0	8331-1	3006322		
169933	5215	4024958	1949-06-18	1949-06-18 00:00:00	1949-06-18	5001	0	\N	0	0	\N	\N	0	346822	0	117015009	4024958		
40623	3772	3019406	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	250664	0	6158-0	3019406		
15394	1409	3006322	2016-12-15	2016-12-15 00:00:00	2016-12-15	5001	0	\N	0	0	\N	\N	0	93776	0	8331-1	3006322		
19337	1773	3006322	1959-07-19	1959-07-19 00:00:00	1959-07-19	5001	0	\N	0	0	\N	\N	0	118554	0	8331-1	3006322		
8588	820	3006322	1969-05-09	1969-05-09 00:00:00	1969-05-09	5001	0	\N	0	0	\N	\N	0	54292	0	8331-1	3006322		
47719	4376	40758406	1921-08-30	1921-08-30 00:00:00	1921-08-30	5001	0	\N	0	0	\N	\N	0	290766	0	55277-8	40758406		
29194	902	4052083	1960-08-05	1960-08-05 00:00:00	1960-08-05	5001	0	\N	0	0	\N	\N	0	60047	0	23426006	4052083		
30896	2830	3006734	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	187787	0	6189-5	3006734		
29172	902	4024958	1955-03-06	1955-03-06 00:00:00	1955-03-06	5001	0	\N	0	0	\N	\N	0	60012	0	117015009	4024958		
10072	959	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	63775	0	6082-2	3000876		
38326	3529	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	234436	0	6833-8	3023430		
131369	4044	4052083	1971-03-18	1971-03-18 00:00:00	1971-03-18	5001	0	\N	0	0	\N	\N	0	268948	0	23426006	4052083		
142673	4383	4024958	1984-10-05	1984-10-05 00:00:00	1984-10-05	5001	0	\N	0	0	\N	\N	0	291287	0	117015009	4024958		
23765	2186	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	145818	0	6833-8	3023430		
29406	2709	3006322	2008-03-14	2008-03-14 00:00:00	2008-03-14	5001	0	\N	0	0	\N	\N	0	179489	0	8331-1	3006322		
19017	1743	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	116503	0	6095-4	3036780		
157170	4829	4024958	1998-03-24	1998-03-24 00:00:00	1998-03-24	5001	0	\N	0	0	\N	\N	0	321310	0	117015009	4024958		
55540	5097	3036780	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	338637	0	6095-4	3036780		
10697	1036	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	68117	0	6844-5	3020655		
96079	2945	4052083	1984-10-10	1984-10-10 00:00:00	1984-10-10	5001	0	\N	0	0	\N	\N	0	196544	0	23426006	4052083		
42009	3884	3006734	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	258142	0	6189-5	3006734		
66109	2026	4024958	1975-06-17	1975-06-17 00:00:00	1975-06-17	5001	0	\N	0	0	\N	\N	0	134814	0	117015009	4024958		
33542	3041	3005136	1993-09-09	1993-09-09 00:00:00	1993-09-09	5001	0	\N	0	0	\N	\N	0	202546	0	6075-6	3005136		
4882	472	3001247	1998-02-10	1998-02-10 00:00:00	1998-02-10	5001	0	\N	0	0	\N	\N	0	31515	0	6085-5	3001247		
39159	1217	4024958	2012-11-21	2012-11-21 00:00:00	2012-11-21	5001	0	\N	0	0	\N	\N	0	80139	0	117015009	4024958		
35689	3263	3006322	1968-08-05	1968-08-05 00:00:00	1968-08-05	5001	0	\N	0	0	\N	\N	0	216876	0	8331-1	3006322		
16455	1498	3006322	1966-04-08	1966-04-08 00:00:00	1966-04-08	5001	0	\N	0	0	\N	\N	0	99933	0	8331-1	3006322		
49521	4506	40758406	2013-05-18	2013-05-18 00:00:00	2013-05-18	5001	0	\N	0	0	\N	\N	0	300175	0	55277-8	40758406		
11175	1081	3006322	1962-09-14	1962-09-14 00:00:00	1962-09-14	5001	0	\N	0	0	\N	\N	0	70861	0	8331-1	3006322		
14822	1378	3006322	1957-03-18	1957-03-18 00:00:00	1957-03-18	5001	0	\N	0	0	\N	\N	0	91363	0	8331-1	3006322		
21327	1971	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	131017	0	6095-4	3036780		
78090	2392	4133840	2017-10-27	2017-10-27 00:00:00	2017-10-27	5001	0	\N	0	0	\N	\N	0	159070	0	127783003	4133840		
78120	2394	4024958	1978-11-29	1978-11-29 00:00:00	1978-11-29	5001	0	\N	0	0	\N	\N	0	159121	0	117015009	4024958		
15765	1441	3006322	1993-03-20	1993-03-20 00:00:00	1993-03-20	5001	0	\N	0	0	\N	\N	0	96010	0	8331-1	3006322		
51296	1556	4024958	1997-02-04	1997-02-04 00:00:00	1997-02-04	5001	0	\N	0	0	\N	\N	0	104186	0	117015009	4024958		
13475	1273	3006322	2011-01-29	2011-01-29 00:00:00	2011-01-29	5001	0	\N	0	0	\N	\N	0	84066	0	8331-1	3006322		
57147	5249	3006322	1986-03-31	1986-03-31 00:00:00	1986-03-31	5001	0	\N	0	0	\N	\N	0	349158	0	8331-1	3006322		
82368	2546	4052083	1992-09-01	1992-09-01 00:00:00	1992-09-01	5001	0	\N	0	0	\N	\N	0	168519	0	23426006	4052083		
12386	1176	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	77634	0	6276-0	3027231		
11381	358	4024958	1988-08-16	1988-08-16 00:00:00	1988-08-16	5001	0	\N	0	0	\N	\N	0	23791	0	117015009	4024958		
50177	4578	46235214	1966-06-18	1966-06-18 00:00:00	1966-06-18	5001	0	\N	0	0	\N	\N	0	304917	0	76690-7	46235214		
14901	1379	3011505	2018-04-21	2018-04-21 00:00:00	2018-04-21	5001	0	\N	0	0	\N	\N	0	91465	0	19926-5	3011505		
4131	409	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	27073	0	6085-5	3001247		
16969	1542	3006322	1992-03-24	1992-03-24 00:00:00	1992-03-24	5001	0	\N	0	0	\N	\N	0	103321	0	8331-1	3006322		
123076	3793	4052083	1994-04-14	1994-04-14 00:00:00	1994-04-14	5001	0	\N	0	0	\N	\N	0	252233	0	23426006	4052083		
5274	507	40758406	1958-06-10	1958-06-10 00:00:00	1958-06-10	5001	0	\N	0	0	\N	\N	0	33977	0	55277-8	40758406		
57701	5290	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	351927	0	6276-0	3027231		
16699	1526	40758406	1978-01-27	1978-01-27 00:00:00	1978-01-27	5001	0	\N	0	0	\N	\N	0	102076	0	55277-8	40758406		
16776	1529	3006322	1968-05-03	1968-05-03 00:00:00	1968-05-03	5001	0	\N	0	0	\N	\N	0	102360	0	8331-1	3006322		
43169	3989	3006322	2003-01-18	2003-01-18 00:00:00	2003-01-18	5001	0	\N	0	0	\N	\N	0	265259	0	8331-1	3006322		
37731	1173	4052083	1957-08-06	1957-08-06 00:00:00	1957-08-06	5001	0	\N	0	0	\N	\N	0	77221	0	23426006	4052083		
54603	4991	3020655	1997-08-01	1997-08-01 00:00:00	1997-08-01	5001	0	\N	0	0	\N	\N	0	332033	0	6844-5	3020655		
22428	2054	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	136668	0	6248-9	3015076		
26055	2392	3011505	1978-11-17	1978-11-17 00:00:00	1978-11-17	5001	0	\N	0	0	\N	\N	0	159057	0	19926-5	3011505		
23149	2131	46235214	1952-08-24	1952-08-24 00:00:00	1952-08-24	5001	0	\N	0	0	\N	\N	0	141840	0	76690-7	46235214		
23158	2131	3051031	1953-02-20	1953-02-20 00:00:00	1953-02-20	5001	0	\N	0	0	\N	\N	0	141841	0	46240-8	3051031		
18011	564	4133840	2014-09-04	2014-09-04 00:00:00	2014-09-04	5001	0	\N	0	0	\N	\N	0	37329	0	127783003	4133840		
605	36	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	2523	0	6075-6	3005136		
42188	3901	3006322	2017-01-23	2017-01-23 00:00:00	2017-01-23	5001	0	\N	0	0	\N	\N	0	259428	0	8331-1	3006322		
39515	3655	3006322	2008-03-09	2008-03-09 00:00:00	2008-03-09	5001	0	\N	0	0	\N	\N	0	243272	0	8331-1	3006322		
169951	5215	4052083	2014-09-04	2014-09-04 00:00:00	2014-09-04	5001	0	\N	0	0	\N	\N	0	346826	0	23426006	4052083		
40624	3772	3000876	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	250664	0	6082-2	3000876		
26672	2458	3006322	1975-09-25	1975-09-25 00:00:00	1975-09-25	5001	0	\N	0	0	\N	\N	0	162965	0	8331-1	3006322		
19338	1773	3001488	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	118614	0	7258-7	3001488		
8589	820	3006322	1974-12-26	1974-12-26 00:00:00	1974-12-26	5001	0	\N	0	0	\N	\N	0	54287	0	8331-1	3006322		
47720	4376	40766240	1921-08-30	1921-08-30 00:00:00	1921-08-30	5001	0	\N	0	0	\N	\N	0	290766	0	63513-6	40766240		
29201	902	4052083	1973-12-30	1973-12-30 00:00:00	1973-12-30	5001	0	\N	0	0	\N	\N	0	60036	0	23426006	4052083		
30897	2830	3001488	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	187787	0	7258-7	3001488		
29174	902	4024958	1969-09-13	1969-09-13 00:00:00	1969-09-13	5001	0	\N	0	0	\N	\N	0	60049	0	117015009	4024958		
10073	959	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	63775	0	6833-8	3023430		
38327	3529	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	234436	0	6189-5	3006734		
81593	2524	4024958	1970-12-08	1970-12-08 00:00:00	1970-12-08	5001	0	\N	0	0	\N	\N	0	166901	0	117015009	4024958		
142674	4384	4024958	1991-10-03	1991-10-03 00:00:00	1991-10-03	5001	0	\N	0	0	\N	\N	0	291419	0	117015009	4024958		
23766	2186	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	145818	0	6095-4	3036780		
29407	2709	3006322	1950-12-09	1950-12-09 00:00:00	1950-12-09	5001	0	\N	0	0	\N	\N	0	179491	0	8331-1	3006322		
19018	1743	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	116503	0	7258-7	3001488		
157171	4829	4052083	1983-09-10	1983-09-10 00:00:00	1983-09-10	5001	0	\N	0	0	\N	\N	0	321355	0	23426006	4052083		
55558	5099	3006322	1999-02-27	1999-02-27 00:00:00	1999-02-27	5001	0	\N	0	0	\N	\N	0	338891	0	8331-1	3006322		
10698	1036	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	68117	0	6276-0	3027231		
96080	2945	4133840	2008-01-08	2008-01-08 00:00:00	2008-01-08	5001	0	\N	0	0	\N	\N	0	196517	0	127783003	4133840		
42010	3884	3027231	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	258142	0	6276-0	3027231		
66123	2027	4052083	1963-04-16	1963-04-16 00:00:00	1963-04-16	5001	0	\N	0	0	\N	\N	0	134867	0	23426006	4052083		
33543	3041	3014599	1993-09-09	1993-09-09 00:00:00	1993-09-09	5001	0	\N	0	0	\N	\N	0	202546	0	6106-9	3014599		
4883	472	3020655	1998-02-10	1998-02-10 00:00:00	1998-02-10	5001	0	\N	0	0	\N	\N	0	31515	0	6844-5	3020655		
39162	1217	4133840	2015-01-09	2015-01-09 00:00:00	2015-01-09	5001	0	\N	0	0	\N	\N	0	80186	0	127783003	4133840		
35690	3263	3006322	1999-05-21	1999-05-21 00:00:00	1999-05-21	5001	0	\N	0	0	\N	\N	0	216931	0	8331-1	3006322		
16456	1498	3006322	2012-08-29	2012-08-29 00:00:00	2012-08-29	5001	0	\N	0	0	\N	\N	0	99948	0	8331-1	3006322		
49522	4506	40766240	2013-02-17	2013-02-17 00:00:00	2013-02-17	5001	0	\N	0	0	\N	\N	0	300174	0	63513-6	40766240		
11176	1081	3006322	1995-09-30	1995-09-30 00:00:00	1995-09-30	5001	0	\N	0	0	\N	\N	0	70836	0	8331-1	3006322		
14823	1378	3011505	2001-02-27	2001-02-27 00:00:00	2001-02-27	5001	0	\N	0	0	\N	\N	0	91309	0	19926-5	3011505		
21328	1971	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	131017	0	7258-7	3001488		
78094	2392	4052083	1984-02-24	1984-02-24 00:00:00	1984-02-24	5001	0	\N	0	0	\N	\N	0	159045	0	23426006	4052083		
78155	2395	4024958	1975-05-03	1975-05-03 00:00:00	1975-05-03	5001	0	\N	0	0	\N	\N	0	159219	0	117015009	4024958		
15766	1441	3006322	1989-10-26	1989-10-26 00:00:00	1989-10-26	5001	0	\N	0	0	\N	\N	0	96038	0	8331-1	3006322		
75516	2318	4052083	1979-09-01	1979-09-01 00:00:00	1979-09-01	5001	0	\N	0	0	\N	\N	0	154089	0	23426006	4052083		
13476	1273	3006322	1973-12-07	1973-12-07 00:00:00	1973-12-07	5001	0	\N	0	0	\N	\N	0	84017	0	8331-1	3006322		
57148	5249	3006322	1985-05-20	1985-05-20 00:00:00	1985-05-20	5001	0	\N	0	0	\N	\N	0	349172	0	8331-1	3006322		
82370	2546	4052083	2014-12-13	2014-12-13 00:00:00	2014-12-13	5001	0	\N	0	0	\N	\N	0	168482	0	23426006	4052083		
12387	1176	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	77634	0	6106-9	3014599		
11388	358	4024958	1955-07-17	1955-07-17 00:00:00	1955-07-17	5001	0	\N	0	0	\N	\N	0	23778	0	117015009	4024958		
50179	4578	3051031	1966-06-18	1966-06-18 00:00:00	1966-06-18	5001	0	\N	0	0	\N	\N	0	304917	0	46240-8	3051031		
14902	1379	3006322	1961-06-11	1961-06-11 00:00:00	1961-06-11	5001	0	\N	0	0	\N	\N	0	91489	0	8331-1	3006322		
4132	409	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	27073	0	6082-2	3000876		
16970	1542	3006322	2003-04-12	2003-04-12 00:00:00	2003-04-12	5001	0	\N	0	0	\N	\N	0	103322	0	8331-1	3006322		
123088	3793	4024958	1983-08-22	1983-08-22 00:00:00	1983-08-22	5001	0	\N	0	0	\N	\N	0	252251	0	117015009	4024958		
5276	507	40766240	1958-06-10	1958-06-10 00:00:00	1958-06-10	5001	0	\N	0	0	\N	\N	0	33977	0	63513-6	40766240		
57702	5290	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	351927	0	6158-0	3019406		
16701	1526	40766240	1978-01-27	1978-01-27 00:00:00	1978-01-27	5001	0	\N	0	0	\N	\N	0	102076	0	63513-6	40766240		
16777	1529	3006322	1976-07-31	1976-07-31 00:00:00	1976-07-31	5001	0	\N	0	0	\N	\N	0	102361	0	8331-1	3006322		
43170	3989	3006322	1939-10-28	1939-10-28 00:00:00	1939-10-28	5001	0	\N	0	0	\N	\N	0	265150	0	8331-1	3006322		
37748	1173	4052083	1994-08-27	1994-08-27 00:00:00	1994-08-27	5001	0	\N	0	0	\N	\N	0	77269	0	23426006	4052083		
54604	4991	3001488	1997-08-01	1997-08-01 00:00:00	1997-08-01	5001	0	\N	0	0	\N	\N	0	332033	0	7258-7	3001488		
22429	2054	3006322	1979-10-13	1979-10-13 00:00:00	1979-10-13	5001	0	\N	0	0	\N	\N	0	136585	0	8331-1	3006322		
26056	2392	3011505	1978-02-10	1978-02-10 00:00:00	1978-02-10	5001	0	\N	0	0	\N	\N	0	159086	0	19926-5	3011505		
1114	94	3006322	1955-10-12	1955-10-12 00:00:00	1955-10-12	5001	0	\N	0	0	\N	\N	0	6314	0	8331-1	3006322		
23159	2131	40758406	1953-02-20	1953-02-20 00:00:00	1953-02-20	5001	0	\N	0	0	\N	\N	0	141841	0	55277-8	40758406		
18013	564	4133840	2008-07-31	2008-07-31 00:00:00	2008-07-31	5001	0	\N	0	0	\N	\N	0	37358	0	127783003	4133840		
606	36	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	2523	0	6106-9	3014599		
42189	3901	3006322	1941-11-13	1941-11-13 00:00:00	1941-11-13	5001	0	\N	0	0	\N	\N	0	259435	0	8331-1	3006322		
39516	3655	3006322	1945-01-11	1945-01-11 00:00:00	1945-01-11	5001	0	\N	0	0	\N	\N	0	243291	0	8331-1	3006322		
169952	5215	4024958	1945-08-28	1945-08-28 00:00:00	1945-08-28	5001	0	\N	0	0	\N	\N	0	346865	0	117015009	4024958		
40625	3772	3020655	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	250664	0	6844-5	3020655		
26673	2459	3006322	2019-04-21	2019-04-21 00:00:00	2019-04-21	5001	0	\N	0	0	\N	\N	0	163032	0	8331-1	3006322		
5995	184	4024958	1950-06-12	1950-06-12 00:00:00	1950-06-12	5001	0	\N	0	0	\N	\N	0	12496	0	117015009	4024958		
8590	820	3006322	1978-07-20	1978-07-20 00:00:00	1978-07-20	5001	0	\N	0	0	\N	\N	0	54305	0	8331-1	3006322		
47721	4376	3051031	1921-08-30	1921-08-30 00:00:00	1921-08-30	5001	0	\N	0	0	\N	\N	0	290766	0	46240-8	3051031		
63898	1964	4052083	1997-08-22	1997-08-22 00:00:00	1997-08-22	5001	0	\N	0	0	\N	\N	0	130564	0	23426006	4052083		
30898	2830	3001247	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	187787	0	6085-5	3001247		
40485	1259	4052083	1994-02-27	1994-02-27 00:00:00	1994-02-27	5001	0	\N	0	0	\N	\N	0	82983	0	23426006	4052083		
10074	959	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	63775	0	6844-5	3020655		
38328	3529	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	234436	0	6095-4	3036780		
81596	2524	4024958	1986-01-28	1986-01-28 00:00:00	1986-01-28	5001	0	\N	0	0	\N	\N	0	166903	0	117015009	4024958		
142687	4384	4052083	1978-10-17	1978-10-17 00:00:00	1978-10-17	5001	0	\N	0	0	\N	\N	0	291418	0	23426006	4052083		
23767	2186	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	145818	0	6075-6	3005136		
29408	2709	3006322	1973-01-01	1973-01-01 00:00:00	1973-01-01	5001	0	\N	0	0	\N	\N	0	179462	0	8331-1	3006322		
19019	1743	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	116503	0	6833-8	3023430		
157173	4829	4052083	1999-12-03	1999-12-03 00:00:00	1999-12-03	5001	0	\N	0	0	\N	\N	0	321356	0	23426006	4052083		
55559	5099	3006322	1972-11-04	1972-11-04 00:00:00	1972-11-04	5001	0	\N	0	0	\N	\N	0	338838	0	8331-1	3006322		
10699	1036	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	68117	0	6206-7	3012494		
96085	2945	4133840	2003-09-02	2003-09-02 00:00:00	2003-09-02	5001	0	\N	0	0	\N	\N	0	196487	0	127783003	4133840		
42011	3884	3001247	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	258142	0	6085-5	3001247		
66125	2027	4024958	1963-10-04	1963-10-04 00:00:00	1963-10-04	5001	0	\N	0	0	\N	\N	0	134872	0	117015009	4024958		
33544	3041	3023430	1993-09-09	1993-09-09 00:00:00	1993-09-09	5001	0	\N	0	0	\N	\N	0	202546	0	6833-8	3023430		
4884	472	3006734	1998-02-10	1998-02-10 00:00:00	1998-02-10	5001	0	\N	0	0	\N	\N	0	31515	0	6189-5	3006734		
39164	1217	4133840	2009-12-25	2009-12-25 00:00:00	2009-12-25	5001	0	\N	0	0	\N	\N	0	80196	0	127783003	4133840		
35691	3263	3006322	1947-09-10	1947-09-10 00:00:00	1947-09-10	5001	0	\N	0	0	\N	\N	0	216874	0	8331-1	3006322		
89025	2758	4024958	1979-07-18	1979-07-18 00:00:00	1979-07-18	5001	0	\N	0	0	\N	\N	0	182390	0	117015009	4024958		
49525	4506	3051031	2013-02-17	2013-02-17 00:00:00	2013-02-17	5001	0	\N	0	0	\N	\N	0	300174	0	46240-8	3051031		
11177	1081	3006322	1964-09-17	1964-09-17 00:00:00	1964-09-17	5001	0	\N	0	0	\N	\N	0	70831	0	8331-1	3006322		
14824	1378	3011505	2010-10-12	2010-10-12 00:00:00	2010-10-12	5001	0	\N	0	0	\N	\N	0	91319	0	19926-5	3011505		
21329	1971	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	131017	0	6189-5	3006734		
78095	2392	4133840	1958-08-01	1958-08-01 00:00:00	1958-08-01	5001	0	\N	0	0	\N	\N	0	159081	0	127783003	4133840		
78169	2395	4024958	1972-08-06	1972-08-06 00:00:00	1972-08-06	5001	0	\N	0	0	\N	\N	0	159243	0	117015009	4024958		
15767	1442	3006322	1996-05-18	1996-05-18 00:00:00	1996-05-18	5001	0	\N	0	0	\N	\N	0	96137	0	8331-1	3006322		
75517	2318	4024958	1978-01-10	1978-01-10 00:00:00	1978-01-10	5001	0	\N	0	0	\N	\N	0	154119	0	117015009	4024958		
13478	1276	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	84260	0	6206-7	3012494		
57149	5249	3006322	2004-07-06	2004-07-06 00:00:00	2004-07-06	5001	0	\N	0	0	\N	\N	0	349236	0	8331-1	3006322		
9054	862	3006322	1986-02-09	1986-02-09 00:00:00	1986-02-09	5001	0	\N	0	0	\N	\N	0	57087	0	8331-1	3006322		
12388	1176	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	77634	0	6158-0	3019406		
11392	359	4024958	1978-09-18	1978-09-18 00:00:00	1978-09-18	5001	0	\N	0	0	\N	\N	0	23873	0	117015009	4024958		
50181	4578	40758406	1966-06-18	1966-06-18 00:00:00	1966-06-18	5001	0	\N	0	0	\N	\N	0	304917	0	55277-8	40758406		
14903	1379	3011505	2005-02-19	2005-02-19 00:00:00	2005-02-19	5001	0	\N	0	0	\N	\N	0	91450	0	19926-5	3011505		
4133	409	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	27073	0	6248-9	3015076		
16971	1542	3006322	2013-04-01	2013-04-01 00:00:00	2013-04-01	5001	0	\N	0	0	\N	\N	0	103309	0	8331-1	3006322		
123098	3793	4052083	2008-08-07	2008-08-07 00:00:00	2008-08-07	5001	0	\N	0	0	\N	\N	0	252253	0	23426006	4052083		
5277	507	46235214	1958-06-10	1958-06-10 00:00:00	1958-06-10	5001	0	\N	0	0	\N	\N	0	33977	0	76690-7	46235214		
57703	5290	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	351927	0	6273-7	3006451		
16702	1526	3051031	1978-01-27	1978-01-27 00:00:00	1978-01-27	5001	0	\N	0	0	\N	\N	0	102076	0	46240-8	3051031		
57210	1746	4024958	1970-10-26	1970-10-26 00:00:00	1970-10-26	5001	0	\N	0	0	\N	\N	0	116715	0	117015009	4024958		
43172	3989	3006322	1972-06-18	1972-06-18 00:00:00	1972-06-18	5001	0	\N	0	0	\N	\N	0	265157	0	8331-1	3006322		
37765	1174	4052083	2016-05-29	2016-05-29 00:00:00	2016-05-29	5001	0	\N	0	0	\N	\N	0	77365	0	23426006	4052083		
54605	4991	3006734	1997-08-01	1997-08-01 00:00:00	1997-08-01	5001	0	\N	0	0	\N	\N	0	332033	0	6189-5	3006734		
22431	2056	3006322	2017-07-22	2017-07-22 00:00:00	2017-07-22	5001	0	\N	0	0	\N	\N	0	136710	0	8331-1	3006322		
26057	2392	3011505	2017-10-27	2017-10-27 00:00:00	2017-10-27	5001	0	\N	0	0	\N	\N	0	159070	0	19926-5	3011505		
1115	94	40758406	1953-08-25	1953-08-25 00:00:00	1953-08-25	5001	0	\N	0	0	\N	\N	0	6336	0	55277-8	40758406		
23160	2131	46235214	1953-02-20	1953-02-20 00:00:00	1953-02-20	5001	0	\N	0	0	\N	\N	0	141841	0	76690-7	46235214		
18015	564	4133840	2017-09-21	2017-09-21 00:00:00	2017-09-21	5001	0	\N	0	0	\N	\N	0	37360	0	127783003	4133840		
607	36	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	2523	0	6273-7	3006451		
34673	3176	3019406	2005-06-26	2005-06-26 00:00:00	2005-06-26	5001	0	\N	0	0	\N	\N	0	211098	0	6158-0	3019406		
39517	3655	3006322	1948-11-02	1948-11-02 00:00:00	1948-11-02	5001	0	\N	0	0	\N	\N	0	243292	0	8331-1	3006322		
15247	1399	3006322	1961-04-26	1961-04-26 00:00:00	1961-04-26	5001	0	\N	0	0	\N	\N	0	92993	0	8331-1	3006322		
40626	3772	3014599	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	250664	0	6106-9	3014599		
26674	2459	3006322	1977-07-19	1977-07-19 00:00:00	1977-07-19	5001	0	\N	0	0	\N	\N	0	163049	0	8331-1	3006322		
6006	184	4024958	1966-10-28	1966-10-28 00:00:00	1966-10-28	5001	0	\N	0	0	\N	\N	0	12433	0	117015009	4024958		
8591	820	3006322	1980-10-19	1980-10-19 00:00:00	1980-10-19	5001	0	\N	0	0	\N	\N	0	54325	0	8331-1	3006322		
47724	4376	46235214	1921-08-30	1921-08-30 00:00:00	1921-08-30	5001	0	\N	0	0	\N	\N	0	290766	0	76690-7	46235214		
148898	4561	4024958	1980-04-12	1980-04-12 00:00:00	1980-04-12	5001	0	\N	0	0	\N	\N	0	303920	0	117015009	4024958		
30899	2830	3000876	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	187787	0	6082-2	3000876		
40486	1259	4052083	2008-03-15	2008-03-15 00:00:00	2008-03-15	5001	0	\N	0	0	\N	\N	0	83005	0	23426006	4052083		
10075	959	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	63775	0	6248-9	3015076		
38329	3529	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	234436	0	6206-7	3012494		
81602	2524	4024958	1993-06-02	1993-06-02 00:00:00	1993-06-02	5001	0	\N	0	0	\N	\N	0	166915	0	117015009	4024958		
142693	4384	4024958	1973-07-29	1973-07-29 00:00:00	1973-07-29	5001	0	\N	0	0	\N	\N	0	291368	0	117015009	4024958		
23768	2186	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	145818	0	6106-9	3014599		
29410	2709	3049273	2017-10-06	2017-10-06 00:00:00	2017-10-06	5001	0	\N	0	0	\N	\N	0	179451	0	38265-5	3049273		
19020	1743	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	116503	0	6158-0	3019406		
157175	4829	4052083	2007-10-07	2007-10-07 00:00:00	2007-10-07	5001	0	\N	0	0	\N	\N	0	321312	0	23426006	4052083		
55560	5099	3006322	1944-03-31	1944-03-31 00:00:00	1944-03-31	5001	0	\N	0	0	\N	\N	0	338833	0	8331-1	3006322		
10700	1036	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	68117	0	6248-9	3015076		
96087	2945	4133840	2001-08-21	2001-08-21 00:00:00	2001-08-21	5001	0	\N	0	0	\N	\N	0	196457	0	127783003	4133840		
42012	3884	3015076	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	258142	0	6248-9	3015076		
66133	2027	4052083	1961-08-15	1961-08-15 00:00:00	1961-08-15	5001	0	\N	0	0	\N	\N	0	134876	0	23426006	4052083		
33545	3041	3006734	1993-09-09	1993-09-09 00:00:00	1993-09-09	5001	0	\N	0	0	\N	\N	0	202546	0	6189-5	3006734		
4885	472	3015076	1998-02-10	1998-02-10 00:00:00	1998-02-10	5001	0	\N	0	0	\N	\N	0	31515	0	6248-9	3015076		
39165	1217	4133840	2013-01-04	2013-01-04 00:00:00	2013-01-04	5001	0	\N	0	0	\N	\N	0	80152	0	127783003	4133840		
35692	3263	3006322	1987-08-25	1987-08-25 00:00:00	1987-08-25	5001	0	\N	0	0	\N	\N	0	216912	0	8331-1	3006322		
89026	2758	4024958	2012-05-21	2012-05-21 00:00:00	2012-05-21	5001	0	\N	0	0	\N	\N	0	182405	0	117015009	4024958		
49526	4506	46235214	2013-02-17	2013-02-17 00:00:00	2013-02-17	5001	0	\N	0	0	\N	\N	0	300174	0	76690-7	46235214		
11178	1081	3006322	2018-04-25	2018-04-25 00:00:00	2018-04-25	5001	0	\N	0	0	\N	\N	0	70847	0	8331-1	3006322		
14825	1378	3011505	2007-09-25	2007-09-25 00:00:00	2007-09-25	5001	0	\N	0	0	\N	\N	0	91429	0	19926-5	3011505		
21330	1971	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	131017	0	6833-8	3023430		
78096	2392	4133840	2012-08-10	2012-08-10 00:00:00	2012-08-10	5001	0	\N	0	0	\N	\N	0	158975	0	127783003	4133840		
78192	2396	4024958	1937-12-27	1937-12-27 00:00:00	1937-12-27	5001	0	\N	0	0	\N	\N	0	159302	0	117015009	4024958		
15768	1442	3006322	1965-11-20	1965-11-20 00:00:00	1965-11-20	5001	0	\N	0	0	\N	\N	0	96134	0	8331-1	3006322		
75518	2318	4024958	1999-03-09	1999-03-09 00:00:00	1999-03-09	5001	0	\N	0	0	\N	\N	0	154095	0	117015009	4024958		
13479	1276	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	84260	0	6273-7	3006451		
57171	5251	3006322	1952-01-30	1952-01-30 00:00:00	1952-01-30	5001	0	\N	0	0	\N	\N	0	349318	0	8331-1	3006322		
9055	862	3006322	1973-01-29	1973-01-29 00:00:00	1973-01-29	5001	0	\N	0	0	\N	\N	0	57080	0	8331-1	3006322		
12389	1176	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	77634	0	6085-5	3001247		
11394	359	4024958	2008-03-06	2008-03-06 00:00:00	2008-03-06	5001	0	\N	0	0	\N	\N	0	23870	0	117015009	4024958		
50182	4578	40766240	1966-06-18	1966-06-18 00:00:00	1966-06-18	5001	0	\N	0	0	\N	\N	0	304917	0	63513-6	40766240		
14905	1381	3006322	2001-07-24	2001-07-24 00:00:00	2001-07-24	5001	0	\N	0	0	\N	\N	0	91579	0	8331-1	3006322		
4134	409	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	27073	0	6276-0	3027231		
16972	1542	3006322	1984-10-16	1984-10-16 00:00:00	1984-10-16	5001	0	\N	0	0	\N	\N	0	103308	0	8331-1	3006322		
123111	3793	4024958	1953-07-19	1953-07-19 00:00:00	1953-07-19	5001	0	\N	0	0	\N	\N	0	252261	0	117015009	4024958		
5279	507	3051031	1958-06-10	1958-06-10 00:00:00	1958-06-10	5001	0	\N	0	0	\N	\N	0	33977	0	46240-8	3051031		
57704	5290	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	351927	0	6075-6	3005136		
16703	1526	46235214	1978-01-27	1978-01-27 00:00:00	1978-01-27	5001	0	\N	0	0	\N	\N	0	102076	0	76690-7	46235214		
57212	1746	4024958	2014-03-27	2014-03-27 00:00:00	2014-03-27	5001	0	\N	0	0	\N	\N	0	116801	0	117015009	4024958		
43173	3989	3006322	1951-04-21	1951-04-21 00:00:00	1951-04-21	5001	0	\N	0	0	\N	\N	0	265254	0	8331-1	3006322		
49047	1496	4024958	1961-12-30	1961-12-30 00:00:00	1961-12-30	5001	0	\N	0	0	\N	\N	0	99722	0	117015009	4024958		
54606	4991	3001247	1997-08-01	1997-08-01 00:00:00	1997-08-01	5001	0	\N	0	0	\N	\N	0	332033	0	6085-5	3001247		
22432	2056	3006322	1981-05-17	1981-05-17 00:00:00	1981-05-17	5001	0	\N	0	0	\N	\N	0	136741	0	8331-1	3006322		
26058	2392	3011505	1956-05-18	1956-05-18 00:00:00	1956-05-18	5001	0	\N	0	0	\N	\N	0	159073	0	19926-5	3011505		
1116	94	46235214	1953-08-25	1953-08-25 00:00:00	1953-08-25	5001	0	\N	0	0	\N	\N	0	6336	0	76690-7	46235214		
23161	2131	40766240	1953-02-20	1953-02-20 00:00:00	1953-02-20	5001	0	\N	0	0	\N	\N	0	141841	0	63513-6	40766240		
18016	564	4133840	2005-07-14	2005-07-14 00:00:00	2005-07-14	5001	0	\N	0	0	\N	\N	0	37381	0	127783003	4133840		
608	36	3006322	2006-11-22	2006-11-22 00:00:00	2006-11-22	5001	0	\N	0	0	\N	\N	0	2562	0	8331-1	3006322		
34674	3176	3006451	2005-06-26	2005-06-26 00:00:00	2005-06-26	5001	0	\N	0	0	\N	\N	0	211098	0	6273-7	3006451		
39518	3655	3006322	1999-10-07	1999-10-07 00:00:00	1999-10-07	5001	0	\N	0	0	\N	\N	0	243279	0	8331-1	3006322		
15248	1399	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	93012	0	6246-3	3021226		
40627	3772	3027231	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	250664	0	6276-0	3027231		
26675	2459	3006322	1984-03-09	1984-03-09 00:00:00	1984-03-09	5001	0	\N	0	0	\N	\N	0	163030	0	8331-1	3006322		
6018	185	4133840	2019-06-09	2019-06-09 00:00:00	2019-06-09	5001	0	\N	0	0	\N	\N	0	12576	0	127783003	4133840		
8592	820	3006322	1964-10-22	1964-10-22 00:00:00	1964-10-22	5001	0	\N	0	0	\N	\N	0	54304	0	8331-1	3006322		
47725	4376	3011505	2003-11-18	2003-11-18 00:00:00	2003-11-18	5001	0	\N	0	0	\N	\N	0	290837	0	19926-5	3011505		
148905	4562	4052083	1975-09-14	1975-09-14 00:00:00	1975-09-14	5001	0	\N	0	0	\N	\N	0	304057	0	23426006	4052083		
30900	2830	3006322	2017-12-13	2017-12-13 00:00:00	2017-12-13	5001	0	\N	0	0	\N	\N	0	187772	0	8331-1	3006322		
40487	1259	4024958	1957-12-17	1957-12-17 00:00:00	1957-12-17	5001	0	\N	0	0	\N	\N	0	82981	0	117015009	4024958		
10076	959	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	63775	0	6189-5	3006734		
38330	3529	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	234436	0	6158-0	3019406		
81604	2524	4133840	2002-07-06	2002-07-06 00:00:00	2002-07-06	5001	0	\N	0	0	\N	\N	0	166932	0	127783003	4133840		
92972	2863	4052083	1990-03-18	1990-03-18 00:00:00	1990-03-18	5001	0	\N	0	0	\N	\N	0	190429	0	23426006	4052083		
48446	1476	4052083	1978-08-18	1978-08-18 00:00:00	1978-08-18	5001	0	\N	0	0	\N	\N	0	98352	0	23426006	4052083		
29411	2709	3006322	1953-08-04	1953-08-04 00:00:00	1953-08-04	5001	0	\N	0	0	\N	\N	0	179486	0	8331-1	3006322		
19021	1743	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	116503	0	6276-0	3027231		
1080	28	4024958	1985-03-19	1985-03-19 00:00:00	1985-03-19	5001	0	\N	0	0	\N	\N	0	1955	0	117015009	4024958		
55561	5099	3006322	1988-03-13	1988-03-13 00:00:00	1988-03-13	5001	0	\N	0	0	\N	\N	0	338890	0	8331-1	3006322		
10730	1039	3006322	2012-06-03	2012-06-03 00:00:00	2012-06-03	5001	0	\N	0	0	\N	\N	0	68399	0	8331-1	3006322		
96089	2945	4024958	1957-12-09	1957-12-09 00:00:00	1957-12-09	5001	0	\N	0	0	\N	\N	0	196522	0	117015009	4024958		
42013	3884	3036780	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	258142	0	6095-4	3036780		
66135	2027	4024958	2013-05-08	2013-05-08 00:00:00	2013-05-08	5001	0	\N	0	0	\N	\N	0	134874	0	117015009	4024958		
33546	3041	3000876	1978-08-06	1978-08-06 00:00:00	1978-08-06	5001	0	\N	0	0	\N	\N	0	202463	0	6082-2	3000876		
4886	472	3027231	1998-02-10	1998-02-10 00:00:00	1998-02-10	5001	0	\N	0	0	\N	\N	0	31515	0	6276-0	3027231		
39166	1217	4024958	1973-06-12	1973-06-12 00:00:00	1973-06-12	5001	0	\N	0	0	\N	\N	0	80153	0	117015009	4024958		
35693	3263	3006322	1985-04-23	1985-04-23 00:00:00	1985-04-23	5001	0	\N	0	0	\N	\N	0	216878	0	8331-1	3006322		
89030	2758	4024958	2013-01-01	2013-01-01 00:00:00	2013-01-01	5001	0	\N	0	0	\N	\N	0	182406	0	117015009	4024958		
49527	4506	40758406	2013-02-17	2013-02-17 00:00:00	2013-02-17	5001	0	\N	0	0	\N	\N	0	300174	0	55277-8	40758406		
11179	1082	3006322	1997-09-18	1997-09-18 00:00:00	1997-09-18	5001	0	\N	0	0	\N	\N	0	70960	0	8331-1	3006322		
14826	1378	3011505	2011-10-18	2011-10-18 00:00:00	2011-10-18	5001	0	\N	0	0	\N	\N	0	91353	0	19926-5	3011505		
21331	1971	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	131017	0	6075-6	3005136		
26208	2411	3006322	2008-02-12	2008-02-12 00:00:00	2008-02-12	5001	0	\N	0	0	\N	\N	0	159988	0	8331-1	3006322		
78197	2396	4052083	1986-03-06	1986-03-06 00:00:00	1986-03-06	5001	0	\N	0	0	\N	\N	0	159346	0	23426006	4052083		
15769	1442	3008598	2016-01-19	2016-01-19 00:00:00	2016-01-19	5001	0	\N	0	0	\N	\N	0	96178	0	3024-7	3008598		
75519	2318	4024958	1972-01-02	1972-01-02 00:00:00	1972-01-02	5001	0	\N	0	0	\N	\N	0	154037	0	117015009	4024958		
13480	1276	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	84260	0	6085-5	3001247		
57175	5251	3006322	1943-01-20	1943-01-20 00:00:00	1943-01-20	5001	0	\N	0	0	\N	\N	0	349317	0	8331-1	3006322		
9056	862	3006322	1981-02-24	1981-02-24 00:00:00	1981-02-24	5001	0	\N	0	0	\N	\N	0	57101	0	8331-1	3006322		
12390	1176	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	77634	0	7258-7	3001488		
11400	359	4024958	1992-02-15	1992-02-15 00:00:00	1992-02-15	5001	0	\N	0	0	\N	\N	0	23867	0	117015009	4024958		
50183	4578	3006322	1979-08-15	1979-08-15 00:00:00	1979-08-15	5001	0	\N	0	0	\N	\N	0	304945	0	8331-1	3006322		
14906	1381	3011505	2017-05-06	2017-05-06 00:00:00	2017-05-06	5001	0	\N	0	0	\N	\N	0	91577	0	19926-5	3011505		
4135	409	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	27073	0	6158-0	3019406		
16973	1543	3006322	1969-04-25	1969-04-25 00:00:00	1969-04-25	5001	0	\N	0	0	\N	\N	0	103370	0	8331-1	3006322		
123114	3793	4024958	2002-02-06	2002-02-06 00:00:00	2002-02-06	5001	0	\N	0	0	\N	\N	0	252183	0	117015009	4024958		
5280	507	46235214	1957-09-13	1957-09-13 00:00:00	1957-09-13	5001	0	\N	0	0	\N	\N	0	33975	0	76690-7	46235214		
57705	5290	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	351927	0	6248-9	3015076		
16704	1526	3006322	2004-12-30	2004-12-30 00:00:00	2004-12-30	5001	0	\N	0	0	\N	\N	0	102080	0	8331-1	3006322		
57216	1746	4052083	1997-05-30	1997-05-30 00:00:00	1997-05-30	5001	0	\N	0	0	\N	\N	0	116781	0	23426006	4052083		
43174	3989	3006322	1948-01-25	1948-01-25 00:00:00	1948-01-25	5001	0	\N	0	0	\N	\N	0	265153	0	8331-1	3006322		
49051	1496	4024958	1952-08-04	1952-08-04 00:00:00	1952-08-04	5001	0	\N	0	0	\N	\N	0	99721	0	117015009	4024958		
54607	4991	3000876	1997-08-01	1997-08-01 00:00:00	1997-08-01	5001	0	\N	0	0	\N	\N	0	332033	0	6082-2	3000876		
22433	2056	3051031	2015-03-03	2015-03-03 00:00:00	2015-03-03	5001	0	\N	0	0	\N	\N	0	136734	0	46240-8	3051031		
26059	2392	3011505	2001-06-08	2001-06-08 00:00:00	2001-06-08	5001	0	\N	0	0	\N	\N	0	158994	0	19926-5	3011505		
1117	94	40766240	1953-08-25	1953-08-25 00:00:00	1953-08-25	5001	0	\N	0	0	\N	\N	0	6336	0	63513-6	40766240		
23164	2131	3051031	1952-09-23	1952-09-23 00:00:00	1952-09-23	5001	0	\N	0	0	\N	\N	0	141765	0	46240-8	3051031		
18018	564	4133840	1998-11-05	1998-11-05 00:00:00	1998-11-05	5001	0	\N	0	0	\N	\N	0	37319	0	127783003	4133840		
609	36	3006322	1959-11-18	1959-11-18 00:00:00	1959-11-18	5001	0	\N	0	0	\N	\N	0	2512	0	8331-1	3006322		
34675	3176	3027231	2005-06-26	2005-06-26 00:00:00	2005-06-26	5001	0	\N	0	0	\N	\N	0	211098	0	6276-0	3027231		
39519	3655	3006322	1972-08-17	1972-08-17 00:00:00	1972-08-17	5001	0	\N	0	0	\N	\N	0	243266	0	8331-1	3006322		
15249	1399	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	93012	0	6075-6	3005136		
40628	3772	3006322	2018-06-01	2018-06-01 00:00:00	2018-06-01	5001	0	\N	0	0	\N	\N	0	250714	0	8331-1	3006322		
26676	2459	3006322	2006-02-15	2006-02-15 00:00:00	2006-02-15	5001	0	\N	0	0	\N	\N	0	163031	0	8331-1	3006322		
6027	185	4133840	2018-06-03	2018-06-03 00:00:00	2018-06-03	5001	0	\N	0	0	\N	\N	0	12581	0	127783003	4133840		
139953	4312	4052083	2005-09-02	2005-09-02 00:00:00	2005-09-02	5001	0	\N	0	0	\N	\N	0	286060	0	23426006	4052083		
47726	4376	3011505	1983-07-26	1983-07-26 00:00:00	1983-07-26	5001	0	\N	0	0	\N	\N	0	290834	0	19926-5	3011505		
148912	4562	4052083	2015-10-09	2015-10-09 00:00:00	2015-10-09	5001	0	\N	0	0	\N	\N	0	304044	0	23426006	4052083		
30901	2830	3027231	1975-06-22	1975-06-22 00:00:00	1975-06-22	5001	0	\N	0	0	\N	\N	0	187706	0	6276-0	3027231		
40488	1259	4024958	1953-04-03	1953-04-03 00:00:00	1953-04-03	5001	0	\N	0	0	\N	\N	0	82980	0	117015009	4024958		
10077	959	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	63775	0	7258-7	3001488		
38331	3529	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	234436	0	6246-3	3021226		
81610	2525	4024958	2014-03-28	2014-03-28 00:00:00	2014-03-28	5001	0	\N	0	0	\N	\N	0	166955	0	117015009	4024958		
92998	2863	4024958	2015-05-07	2015-05-07 00:00:00	2015-05-07	5001	0	\N	0	0	\N	\N	0	190416	0	117015009	4024958		
48447	1476	4024958	1961-11-28	1961-11-28 00:00:00	1961-11-28	5001	0	\N	0	0	\N	\N	0	98537	0	117015009	4024958		
29415	2709	3006322	2003-04-11	2003-04-11 00:00:00	2003-04-11	5001	0	\N	0	0	\N	\N	0	179488	0	8331-1	3006322		
19022	1743	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	116503	0	6246-3	3021226		
1081	28	4024958	1991-11-29	1991-11-29 00:00:00	1991-11-29	5001	0	\N	0	0	\N	\N	0	1956	0	117015009	4024958		
55562	5099	3006322	1986-03-09	1986-03-09 00:00:00	1986-03-09	5001	0	\N	0	0	\N	\N	0	338863	0	8331-1	3006322		
10731	1039	3006322	2003-08-05	2003-08-05 00:00:00	2003-08-05	5001	0	\N	0	0	\N	\N	0	68375	0	8331-1	3006322		
96090	2945	4133840	2004-09-07	2004-09-07 00:00:00	2004-09-07	5001	0	\N	0	0	\N	\N	0	196504	0	127783003	4133840		
42014	3884	3006451	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	258142	0	6273-7	3006451		
75723	2325	4024958	1999-12-09	1999-12-09 00:00:00	1999-12-09	5001	0	\N	0	0	\N	\N	0	154602	0	117015009	4024958		
33547	3041	3015076	1978-08-06	1978-08-06 00:00:00	1978-08-06	5001	0	\N	0	0	\N	\N	0	202463	0	6248-9	3015076		
4887	472	3006451	1998-02-10	1998-02-10 00:00:00	1998-02-10	5001	0	\N	0	0	\N	\N	0	31515	0	6273-7	3006451		
39168	1217	4133840	2019-01-18	2019-01-18 00:00:00	2019-01-18	5001	0	\N	0	0	\N	\N	0	80134	0	127783003	4133840		
35694	3263	3006322	1995-11-25	1995-11-25 00:00:00	1995-11-25	5001	0	\N	0	0	\N	\N	0	216930	0	8331-1	3006322		
89055	2758	4024958	1954-11-16	1954-11-16 00:00:00	1954-11-16	5001	0	\N	0	0	\N	\N	0	182434	0	117015009	4024958		
49528	4506	46235214	2002-06-05	2002-06-05 00:00:00	2002-06-05	5001	0	\N	0	0	\N	\N	0	300162	0	76690-7	46235214		
11180	1082	3009542	2006-08-07	2006-08-07 00:00:00	2006-08-07	5001	0	\N	0	0	\N	\N	0	70962	0	20570-8	3009542		
14827	1378	3011505	2006-03-28	2006-03-28 00:00:00	2006-03-28	5001	0	\N	0	0	\N	\N	0	91428	0	19926-5	3011505		
21332	1971	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	131017	0	6246-3	3021226		
26209	2412	3006322	2009-12-24	2009-12-24 00:00:00	2009-12-24	5001	0	\N	0	0	\N	\N	0	160098	0	8331-1	3006322		
78198	2396	4052083	1967-09-19	1967-09-19 00:00:00	1967-09-19	5001	0	\N	0	0	\N	\N	0	159398	0	23426006	4052083		
15770	1442	3009201	2016-01-19	2016-01-19 00:00:00	2016-01-19	5001	0	\N	0	0	\N	\N	0	96178	0	3016-3	3009201		
75522	2318	4024958	1964-01-24	1964-01-24 00:00:00	1964-01-24	5001	0	\N	0	0	\N	\N	0	154040	0	117015009	4024958		
13481	1276	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	84260	0	6189-5	3006734		
57177	5251	3006322	1933-01-04	1933-01-04 00:00:00	1933-01-04	5001	0	\N	0	0	\N	\N	0	349338	0	8331-1	3006322		
9057	862	3006322	1976-11-21	1976-11-21 00:00:00	1976-11-21	5001	0	\N	0	0	\N	\N	0	57041	0	8331-1	3006322		
12391	1176	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	77634	0	6833-8	3023430		
39163	3621	3011505	1995-06-03	1995-06-03 00:00:00	1995-06-03	5001	0	\N	0	0	\N	\N	0	240598	0	19926-5	3011505		
50184	4578	3006322	1967-09-08	1967-09-08 00:00:00	1967-09-08	5001	0	\N	0	0	\N	\N	0	304918	0	8331-1	3006322		
14907	1381	3006322	1993-02-24	1993-02-24 00:00:00	1993-02-24	5001	0	\N	0	0	\N	\N	0	91612	0	8331-1	3006322		
4136	409	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	27073	0	6273-7	3006451		
16974	1543	3006322	1986-04-23	1986-04-23 00:00:00	1986-04-23	5001	0	\N	0	0	\N	\N	0	103436	0	8331-1	3006322		
123130	3795	4052083	2004-04-03	2004-04-03 00:00:00	2004-04-03	5001	0	\N	0	0	\N	\N	0	252301	0	23426006	4052083		
5281	507	40758406	1957-09-13	1957-09-13 00:00:00	1957-09-13	5001	0	\N	0	0	\N	\N	0	33975	0	55277-8	40758406		
57706	5290	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	351927	0	6085-5	3001247		
16705	1526	3006322	2018-12-03	2018-12-03 00:00:00	2018-12-03	5001	0	\N	0	0	\N	\N	0	102085	0	8331-1	3006322		
57226	1746	4024958	1972-01-04	1972-01-04 00:00:00	1972-01-04	5001	0	\N	0	0	\N	\N	0	116722	0	117015009	4024958		
43175	3989	3006322	1951-10-27	1951-10-27 00:00:00	1951-10-27	5001	0	\N	0	0	\N	\N	0	265255	0	8331-1	3006322		
49052	1496	4024958	1947-04-11	1947-04-11 00:00:00	1947-04-11	5001	0	\N	0	0	\N	\N	0	99729	0	117015009	4024958		
54608	4991	3036780	1997-08-01	1997-08-01 00:00:00	1997-08-01	5001	0	\N	0	0	\N	\N	0	332033	0	6095-4	3036780		
22434	2056	40758406	2015-03-03	2015-03-03 00:00:00	2015-03-03	5001	0	\N	0	0	\N	\N	0	136734	0	55277-8	40758406		
26060	2392	3011505	1968-02-09	1968-02-09 00:00:00	1968-02-09	5001	0	\N	0	0	\N	\N	0	159001	0	19926-5	3011505		
1120	94	3051031	1953-08-25	1953-08-25 00:00:00	1953-08-25	5001	0	\N	0	0	\N	\N	0	6336	0	46240-8	3051031		
23165	2131	40758406	1952-09-23	1952-09-23 00:00:00	1952-09-23	5001	0	\N	0	0	\N	\N	0	141765	0	55277-8	40758406		
18019	564	4133840	2016-09-15	2016-09-15 00:00:00	2016-09-15	5001	0	\N	0	0	\N	\N	0	37354	0	127783003	4133840		
610	36	40769189	1960-06-21	1960-06-21 00:00:00	1960-06-21	5001	0	\N	0	0	\N	\N	0	2502	0	66529-9	40769189		
34676	3176	3015076	2005-06-26	2005-06-26 00:00:00	2005-06-26	5001	0	\N	0	0	\N	\N	0	211098	0	6248-9	3015076		
159007	4890	4052083	1971-01-29	1971-01-29 00:00:00	1971-01-29	5001	0	\N	0	0	\N	\N	0	325183	0	23426006	4052083		
15250	1399	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	93012	0	6158-0	3019406		
40629	3772	3006451	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	250664	0	6273-7	3006451		
26677	2459	3006322	1994-08-04	1994-08-04 00:00:00	1994-08-04	5001	0	\N	0	0	\N	\N	0	163048	0	8331-1	3006322		
6028	185	4024958	1962-08-29	1962-08-29 00:00:00	1962-08-29	5001	0	\N	0	0	\N	\N	0	12567	0	117015009	4024958		
151267	4636	4024958	2000-11-14	2000-11-14 00:00:00	2000-11-14	5001	0	\N	0	0	\N	\N	0	308969	0	117015009	4024958		
47727	4376	3006322	1977-07-17	1977-07-17 00:00:00	1977-07-17	5001	0	\N	0	0	\N	\N	0	290738	0	8331-1	3006322		
148920	4562	4052083	1978-04-09	1978-04-09 00:00:00	1978-04-09	5001	0	\N	0	0	\N	\N	0	304002	0	23426006	4052083		
30902	2830	3014599	1975-06-22	1975-06-22 00:00:00	1975-06-22	5001	0	\N	0	0	\N	\N	0	187706	0	6106-9	3014599		
40637	1261	4052083	1990-06-08	1990-06-08 00:00:00	1990-06-08	5001	0	\N	0	0	\N	\N	0	83243	0	23426006	4052083		
10078	959	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	63775	0	6085-5	3001247		
38332	3529	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	234436	0	6106-9	3014599		
81617	2525	4052083	1996-05-09	1996-05-09 00:00:00	1996-05-09	5001	0	\N	0	0	\N	\N	0	166953	0	23426006	4052083		
93012	2863	4024958	1969-08-27	1969-08-27 00:00:00	1969-08-27	5001	0	\N	0	0	\N	\N	0	190426	0	117015009	4024958		
48491	1478	4024958	2015-07-21	2015-07-21 00:00:00	2015-07-21	5001	0	\N	0	0	\N	\N	0	98633	0	117015009	4024958		
145707	4474	4052083	1981-09-29	1981-09-29 00:00:00	1981-09-29	5001	0	\N	0	0	\N	\N	0	297652	0	23426006	4052083		
19023	1743	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	116503	0	6844-5	3020655		
1086	28	4024958	1983-05-15	1983-05-15 00:00:00	1983-05-15	5001	0	\N	0	0	\N	\N	0	1978	0	117015009	4024958		
55563	5099	3006322	1946-04-28	1946-04-28 00:00:00	1946-04-28	5001	0	\N	0	0	\N	\N	0	338834	0	8331-1	3006322		
1239	35	4052083	2014-07-26	2014-07-26 00:00:00	2014-07-26	5001	0	\N	0	0	\N	\N	0	2450	0	23426006	4052083		
96093	2945	4133840	2010-01-19	2010-01-19 00:00:00	2010-01-19	5001	0	\N	0	0	\N	\N	0	196518	0	127783003	4133840		
42015	3884	3020655	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	258142	0	6844-5	3020655		
75730	2325	4052083	1983-07-04	1983-07-04 00:00:00	1983-07-04	5001	0	\N	0	0	\N	\N	0	154557	0	23426006	4052083		
33548	3041	3001247	1978-08-06	1978-08-06 00:00:00	1978-08-06	5001	0	\N	0	0	\N	\N	0	202463	0	6085-5	3001247		
4888	472	3036780	1998-02-10	1998-02-10 00:00:00	1998-02-10	5001	0	\N	0	0	\N	\N	0	31515	0	6095-4	3036780		
39171	1217	4133840	2012-12-14	2012-12-14 00:00:00	2012-12-14	5001	0	\N	0	0	\N	\N	0	80146	0	127783003	4133840		
35695	3263	3006322	2009-07-09	2009-07-09 00:00:00	2009-07-09	5001	0	\N	0	0	\N	\N	0	216914	0	8331-1	3006322		
89091	2760	4024958	1987-11-17	1987-11-17 00:00:00	1987-11-17	5001	0	\N	0	0	\N	\N	0	182538	0	117015009	4024958		
49529	4506	3051031	2002-06-05	2002-06-05 00:00:00	2002-06-05	5001	0	\N	0	0	\N	\N	0	300162	0	46240-8	3051031		
11181	1082	3000963	2006-08-07	2006-08-07 00:00:00	2006-08-07	5001	0	\N	0	0	\N	\N	0	70962	0	718-7	3000963		
14828	1378	3011505	2004-03-16	2004-03-16 00:00:00	2004-03-16	5001	0	\N	0	0	\N	\N	0	91325	0	19926-5	3011505		
21333	1971	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	131017	0	6273-7	3006451		
26210	2412	3006322	1954-12-04	1954-12-04 00:00:00	1954-12-04	5001	0	\N	0	0	\N	\N	0	160064	0	8331-1	3006322		
78200	2396	4024958	1959-06-11	1959-06-11 00:00:00	1959-06-11	5001	0	\N	0	0	\N	\N	0	159305	0	117015009	4024958		
15771	1442	3006322	1965-06-07	1965-06-07 00:00:00	1965-06-07	5001	0	\N	0	0	\N	\N	0	96105	0	8331-1	3006322		
75530	2318	4024958	1967-01-17	1967-01-17 00:00:00	1967-01-17	5001	0	\N	0	0	\N	\N	0	154041	0	117015009	4024958		
13482	1276	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	84260	0	6276-0	3027231		
57178	5251	3006322	1965-10-03	1965-10-03 00:00:00	1965-10-03	5001	0	\N	0	0	\N	\N	0	349343	0	8331-1	3006322		
9058	862	3006322	1972-05-23	1972-05-23 00:00:00	1972-05-23	5001	0	\N	0	0	\N	\N	0	57100	0	8331-1	3006322		
12392	1176	3006322	1965-10-05	1965-10-05 00:00:00	1965-10-05	5001	0	\N	0	0	\N	\N	0	77648	0	8331-1	3006322		
39164	3621	3011505	1996-06-08	1996-06-08 00:00:00	1996-06-08	5001	0	\N	0	0	\N	\N	0	240607	0	19926-5	3011505		
50185	4578	46235214	1965-12-20	1965-12-20 00:00:00	1965-12-20	5001	0	\N	0	0	\N	\N	0	304959	0	76690-7	46235214		
14908	1381	3011505	2015-08-22	2015-08-22 00:00:00	2015-08-22	5001	0	\N	0	0	\N	\N	0	91576	0	19926-5	3011505		
4137	409	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	27073	0	6075-6	3005136		
16976	1543	3006322	1974-01-13	1974-01-13 00:00:00	1974-01-13	5001	0	\N	0	0	\N	\N	0	103429	0	8331-1	3006322		
123133	3795	4024958	1994-04-26	1994-04-26 00:00:00	1994-04-26	5001	0	\N	0	0	\N	\N	0	252311	0	117015009	4024958		
5283	507	3051031	1957-09-13	1957-09-13 00:00:00	1957-09-13	5001	0	\N	0	0	\N	\N	0	33975	0	46240-8	3051031		
57707	5290	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	351927	0	6206-7	3012494		
16707	1526	40758406	1978-02-26	1978-02-26 00:00:00	1978-02-26	5001	0	\N	0	0	\N	\N	0	102062	0	55277-8	40758406		
57228	1746	4052083	1954-04-08	1954-04-08 00:00:00	1954-04-08	5001	0	\N	0	0	\N	\N	0	116718	0	23426006	4052083		
43177	3989	3006322	1928-08-29	1928-08-29 00:00:00	1928-08-29	5001	0	\N	0	0	\N	\N	0	265148	0	8331-1	3006322		
49068	1496	4024958	1923-12-01	1923-12-01 00:00:00	1923-12-01	5001	0	\N	0	0	\N	\N	0	99724	0	117015009	4024958		
54609	4991	3023430	1997-08-01	1997-08-01 00:00:00	1997-08-01	5001	0	\N	0	0	\N	\N	0	332033	0	6833-8	3023430		
22435	2056	40766240	2015-03-03	2015-03-03 00:00:00	2015-03-03	5001	0	\N	0	0	\N	\N	0	136734	0	63513-6	40766240		
26061	2392	3011505	1971-02-26	1971-02-26 00:00:00	1971-02-26	5001	0	\N	0	0	\N	\N	0	159055	0	19926-5	3011505		
1121	94	3051031	1953-11-23	1953-11-23 00:00:00	1953-11-23	5001	0	\N	0	0	\N	\N	0	6337	0	46240-8	3051031		
23166	2131	46235214	1952-09-23	1952-09-23 00:00:00	1952-09-23	5001	0	\N	0	0	\N	\N	0	141765	0	76690-7	46235214		
18020	564	4133840	2012-08-23	2012-08-23 00:00:00	2012-08-23	5001	0	\N	0	0	\N	\N	0	37328	0	127783003	4133840		
611	36	40769179	1960-06-21	1960-06-21 00:00:00	1960-06-21	5001	0	\N	0	0	\N	\N	0	2502	0	66519-0	40769179		
34677	3176	3006322	1984-02-01	1984-02-01 00:00:00	1984-02-01	5001	0	\N	0	0	\N	\N	0	211148	0	8331-1	3006322		
159030	4890	4024958	1923-03-05	1923-03-05 00:00:00	1923-03-05	5001	0	\N	0	0	\N	\N	0	325219	0	117015009	4024958		
15251	1399	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	93012	0	6276-0	3027231		
40630	3772	3015076	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	250664	0	6248-9	3015076		
26678	2459	3006322	1978-08-25	1978-08-25 00:00:00	1978-08-25	5001	0	\N	0	0	\N	\N	0	163050	0	8331-1	3006322		
6031	185	4133840	2013-05-26	2013-05-26 00:00:00	2013-05-26	5001	0	\N	0	0	\N	\N	0	12564	0	127783003	4133840		
151279	4637	4024958	1988-04-22	1988-04-22 00:00:00	1988-04-22	5001	0	\N	0	0	\N	\N	0	309034	0	117015009	4024958		
47728	4376	3011505	1976-07-06	1976-07-06 00:00:00	1976-07-06	5001	0	\N	0	0	\N	\N	0	290795	0	19926-5	3011505		
148922	4562	4024958	1963-08-20	1963-08-20 00:00:00	1963-08-20	5001	0	\N	0	0	\N	\N	0	304031	0	117015009	4024958		
30903	2830	3006734	1975-06-22	1975-06-22 00:00:00	1975-06-22	5001	0	\N	0	0	\N	\N	0	187706	0	6189-5	3006734		
40640	1261	4133840	2006-11-11	2006-11-11 00:00:00	2006-11-11	5001	0	\N	0	0	\N	\N	0	83227	0	127783003	4133840		
10079	959	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	63775	0	6075-6	3005136		
38333	3529	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	234436	0	6082-2	3000876		
81623	2525	4024958	1987-06-28	1987-06-28 00:00:00	1987-06-28	5001	0	\N	0	0	\N	\N	0	166968	0	117015009	4024958		
93021	2863	4024958	1964-03-12	1964-03-12 00:00:00	1964-03-12	5001	0	\N	0	0	\N	\N	0	190422	0	117015009	4024958		
48492	1478	4052083	1997-12-22	1997-12-22 00:00:00	1997-12-22	5001	0	\N	0	0	\N	\N	0	98632	0	23426006	4052083		
145710	4474	4024958	1969-10-22	1969-10-22 00:00:00	1969-10-22	5001	0	\N	0	0	\N	\N	0	297696	0	117015009	4024958		
19024	1743	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	116534	0	6082-2	3000876		
1104	30	4052083	2004-11-28	2004-11-28 00:00:00	2004-11-28	5001	0	\N	0	0	\N	\N	0	2130	0	23426006	4052083		
55564	5099	3006322	1950-05-20	1950-05-20 00:00:00	1950-05-20	5001	0	\N	0	0	\N	\N	0	338861	0	8331-1	3006322		
1240	35	4024958	1992-04-15	1992-04-15 00:00:00	1992-04-15	5001	0	\N	0	0	\N	\N	0	2429	0	117015009	4024958		
96095	2945	4133840	1999-08-10	1999-08-10 00:00:00	1999-08-10	5001	0	\N	0	0	\N	\N	0	196456	0	127783003	4133840		
42016	3884	3000876	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	258142	0	6082-2	3000876		
75745	2326	4052083	1963-01-07	1963-01-07 00:00:00	1963-01-07	5001	0	\N	0	0	\N	\N	0	154673	0	23426006	4052083		
33549	3041	3020655	1978-08-06	1978-08-06 00:00:00	1978-08-06	5001	0	\N	0	0	\N	\N	0	202463	0	6844-5	3020655		
4889	472	3023430	1998-02-10	1998-02-10 00:00:00	1998-02-10	5001	0	\N	0	0	\N	\N	0	31515	0	6833-8	3023430		
39179	1219	4052083	2013-10-08	2013-10-08 00:00:00	2013-10-08	5001	0	\N	0	0	\N	\N	0	80213	0	23426006	4052083		
35704	3268	3006322	2003-02-21	2003-02-21 00:00:00	2003-02-21	5001	0	\N	0	0	\N	\N	0	217187	0	8331-1	3006322		
89103	2760	4052083	1993-07-01	1993-07-01 00:00:00	1993-07-01	5001	0	\N	0	0	\N	\N	0	182539	0	23426006	4052083		
5535	170	4024958	1983-06-16	1983-06-16 00:00:00	1983-06-16	5001	0	\N	0	0	\N	\N	0	11531	0	117015009	4024958		
11182	1082	3006322	1985-04-13	1985-04-13 00:00:00	1985-04-13	5001	0	\N	0	0	\N	\N	0	70930	0	8331-1	3006322		
14829	1378	3011505	2013-10-29	2013-10-29 00:00:00	2013-10-29	5001	0	\N	0	0	\N	\N	0	91354	0	19926-5	3011505		
21334	1971	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	131017	0	6248-9	3015076		
26211	2412	3006322	2001-06-26	2001-06-26 00:00:00	2001-06-26	5001	0	\N	0	0	\N	\N	0	160079	0	8331-1	3006322		
21012	662	4024958	1979-03-05	1979-03-05 00:00:00	1979-03-05	5001	0	\N	0	0	\N	\N	0	43720	0	117015009	4024958		
15772	1442	3006322	1994-03-17	1994-03-17 00:00:00	1994-03-17	5001	0	\N	0	0	\N	\N	0	96177	0	8331-1	3006322		
86821	2682	4052083	1974-08-10	1974-08-10 00:00:00	1974-08-10	5001	0	\N	0	0	\N	\N	0	177708	0	23426006	4052083		
13483	1276	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	84260	0	6158-0	3019406		
57179	5251	3006322	1947-12-11	1947-12-11 00:00:00	1947-12-11	5001	0	\N	0	0	\N	\N	0	349334	0	8331-1	3006322		
9059	863	3006322	1945-03-10	1945-03-10 00:00:00	1945-03-10	5001	0	\N	0	0	\N	\N	0	57162	0	8331-1	3006322		
12394	1176	46235214	2011-09-02	2011-09-02 00:00:00	2011-09-02	5001	0	\N	0	0	\N	\N	0	77637	0	76690-7	46235214		
39165	3622	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	240803	0	6273-7	3006451		
50186	4578	3051031	1965-12-20	1965-12-20 00:00:00	1965-12-20	5001	0	\N	0	0	\N	\N	0	304959	0	46240-8	3051031		
14909	1381	3011505	2006-08-12	2006-08-12 00:00:00	2006-08-12	5001	0	\N	0	0	\N	\N	0	91573	0	19926-5	3011505		
4138	409	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	27073	0	6246-3	3021226		
16995	1550	3011505	1996-10-19	1996-10-19 00:00:00	1996-10-19	5001	0	\N	0	0	\N	\N	0	103786	0	19926-5	3011505		
18624	1715	3006322	2006-03-15	2006-03-15 00:00:00	2006-03-15	5001	0	\N	0	0	\N	\N	0	114546	0	8331-1	3006322		
5284	507	40766240	1957-09-13	1957-09-13 00:00:00	1957-09-13	5001	0	\N	0	0	\N	\N	0	33975	0	63513-6	40766240		
57708	5290	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	351927	0	7258-7	3001488		
16709	1526	40766240	1978-02-26	1978-02-26 00:00:00	1978-02-26	5001	0	\N	0	0	\N	\N	0	102062	0	63513-6	40766240		
57229	1746	4052083	1967-10-13	1967-10-13 00:00:00	1967-10-13	5001	0	\N	0	0	\N	\N	0	116785	0	23426006	4052083		
43178	3991	3006322	1973-10-23	1973-10-23 00:00:00	1973-10-23	5001	0	\N	0	0	\N	\N	0	265301	0	8331-1	3006322		
140959	4348	4052083	1982-11-16	1982-11-16 00:00:00	1982-11-16	5001	0	\N	0	0	\N	\N	0	288342	0	23426006	4052083		
54610	4991	3027231	1997-08-01	1997-08-01 00:00:00	1997-08-01	5001	0	\N	0	0	\N	\N	0	332033	0	6276-0	3027231		
22438	2056	46235214	2015-03-03	2015-03-03 00:00:00	2015-03-03	5001	0	\N	0	0	\N	\N	0	136734	0	76690-7	46235214		
26062	2392	3011505	1995-05-05	1995-05-05 00:00:00	1995-05-05	5001	0	\N	0	0	\N	\N	0	158970	0	19926-5	3011505		
1124	94	40766240	1953-11-23	1953-11-23 00:00:00	1953-11-23	5001	0	\N	0	0	\N	\N	0	6337	0	63513-6	40766240		
23167	2131	40766240	1952-09-23	1952-09-23 00:00:00	1952-09-23	5001	0	\N	0	0	\N	\N	0	141765	0	63513-6	40766240		
18023	564	4133840	2000-11-09	2000-11-09 00:00:00	2000-11-09	5001	0	\N	0	0	\N	\N	0	37353	0	127783003	4133840		
612	36	40769184	1960-06-21	1960-06-21 00:00:00	1960-06-21	5001	0	\N	0	0	\N	\N	0	2502	0	66524-0	40769184		
34678	3176	3006322	1985-09-05	1985-09-05 00:00:00	1985-09-05	5001	0	\N	0	0	\N	\N	0	211165	0	8331-1	3006322		
159033	4890	4024958	2010-06-16	2010-06-16 00:00:00	2010-06-16	5001	0	\N	0	0	\N	\N	0	325190	0	117015009	4024958		
15252	1399	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	93012	0	6106-9	3014599		
40631	3772	3036780	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	250664	0	6095-4	3036780		
26679	2459	3006322	1984-06-15	1984-06-15 00:00:00	1984-06-15	5001	0	\N	0	0	\N	\N	0	163052	0	8331-1	3006322		
6032	185	4133840	2016-06-12	2016-06-12 00:00:00	2016-06-12	5001	0	\N	0	0	\N	\N	0	12519	0	127783003	4133840		
151281	4637	4024958	1993-06-28	1993-06-28 00:00:00	1993-06-28	5001	0	\N	0	0	\N	\N	0	309016	0	117015009	4024958		
47730	4376	46235214	2012-05-29	2012-05-29 00:00:00	2012-05-29	5001	0	\N	0	0	\N	\N	0	290786	0	76690-7	46235214		
148923	4562	4024958	2018-05-11	2018-05-11 00:00:00	2018-05-11	5001	0	\N	0	0	\N	\N	0	304045	0	117015009	4024958		
30904	2830	3001488	1975-06-22	1975-06-22 00:00:00	1975-06-22	5001	0	\N	0	0	\N	\N	0	187706	0	7258-7	3001488		
40660	1261	4133840	2013-11-23	2013-11-23 00:00:00	2013-11-23	5001	0	\N	0	0	\N	\N	0	83135	0	127783003	4133840		
10080	959	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	63775	0	6106-9	3014599		
38334	3529	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	234436	0	6273-7	3006451		
92915	2861	4024958	1992-05-12	1992-05-12 00:00:00	1992-05-12	5001	0	\N	0	0	\N	\N	0	190207	0	117015009	4024958		
93224	2869	4052083	1968-11-20	1968-11-20 00:00:00	1968-11-20	5001	0	\N	0	0	\N	\N	0	190888	0	23426006	4052083		
48495	1478	4052083	2009-12-13	2009-12-13 00:00:00	2009-12-13	5001	0	\N	0	0	\N	\N	0	98657	0	23426006	4052083		
145716	4474	4024958	1998-04-01	1998-04-01 00:00:00	1998-04-01	5001	0	\N	0	0	\N	\N	0	297654	0	117015009	4024958		
19025	1743	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	116534	0	6273-7	3006451		
1124	30	4052083	1998-04-21	1998-04-21 00:00:00	1998-04-21	5001	0	\N	0	0	\N	\N	0	2129	0	23426006	4052083		
55565	5099	3006322	2017-04-07	2017-04-07 00:00:00	2017-04-07	5001	0	\N	0	0	\N	\N	0	338843	0	8331-1	3006322		
1243	35	4024958	2011-02-21	2011-02-21 00:00:00	2011-02-21	5001	0	\N	0	0	\N	\N	0	2408	0	117015009	4024958		
96098	2945	4133840	2007-09-25	2007-09-25 00:00:00	2007-09-25	5001	0	\N	0	0	\N	\N	0	196489	0	127783003	4133840		
42017	3884	3012494	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	258142	0	6206-7	3012494		
75746	2326	4024958	1983-02-05	1983-02-05 00:00:00	1983-02-05	5001	0	\N	0	0	\N	\N	0	154647	0	117015009	4024958		
33550	3041	3001488	1978-08-06	1978-08-06 00:00:00	1978-08-06	5001	0	\N	0	0	\N	\N	0	202463	0	7258-7	3001488		
4890	472	3014599	1998-02-10	1998-02-10 00:00:00	1998-02-10	5001	0	\N	0	0	\N	\N	0	31515	0	6106-9	3014599		
39184	1219	4024958	1952-09-20	1952-09-20 00:00:00	1952-09-20	5001	0	\N	0	0	\N	\N	0	80235	0	117015009	4024958		
35705	3268	3006322	1991-02-09	1991-02-09 00:00:00	1991-02-09	5001	0	\N	0	0	\N	\N	0	217173	0	8331-1	3006322		
54889	1661	4024958	1977-01-07	1977-01-07 00:00:00	1977-01-07	5001	0	\N	0	0	\N	\N	0	111665	0	117015009	4024958		
5539	170	4024958	2003-12-21	2003-12-21 00:00:00	2003-12-21	5001	0	\N	0	0	\N	\N	0	11535	0	117015009	4024958		
11183	1082	40769184	1988-08-22	1988-08-22 00:00:00	1988-08-22	5001	0	\N	0	0	\N	\N	0	70909	0	66524-0	40769184		
14830	1378	3011505	2012-10-23	2012-10-23 00:00:00	2012-10-23	5001	0	\N	0	0	\N	\N	0	91443	0	19926-5	3011505		
21335	1971	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	131017	0	6106-9	3014599		
26212	2412	3006322	1955-08-12	1955-08-12 00:00:00	1955-08-12	5001	0	\N	0	0	\N	\N	0	160032	0	8331-1	3006322		
21016	662	4024958	1997-03-26	1997-03-26 00:00:00	1997-03-26	5001	0	\N	0	0	\N	\N	0	43685	0	117015009	4024958		
15773	1442	3006322	1966-05-02	1966-05-02 00:00:00	1966-05-02	5001	0	\N	0	0	\N	\N	0	96143	0	8331-1	3006322		
86828	2682	4024958	1978-08-21	1978-08-21 00:00:00	1978-08-21	5001	0	\N	0	0	\N	\N	0	177738	0	117015009	4024958		
13484	1276	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	84260	0	6246-3	3021226		
57180	5252	3011505	1999-04-13	1999-04-13 00:00:00	1999-04-13	5001	0	\N	0	0	\N	\N	0	349425	0	19926-5	3011505		
9060	863	3006322	1970-11-20	1970-11-20 00:00:00	1970-11-20	5001	0	\N	0	0	\N	\N	0	57140	0	8331-1	3006322		
12395	1176	40766240	2011-09-02	2011-09-02 00:00:00	2011-09-02	5001	0	\N	0	0	\N	\N	0	77637	0	63513-6	40766240		
39166	3622	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	240803	0	6276-0	3027231		
50188	4578	40766240	1965-12-20	1965-12-20 00:00:00	1965-12-20	5001	0	\N	0	0	\N	\N	0	304959	0	63513-6	40766240		
14910	1381	3011505	2009-08-15	2009-08-15 00:00:00	2009-08-15	5001	0	\N	0	0	\N	\N	0	91574	0	19926-5	3011505		
23187	726	4052083	1988-06-24	1988-06-24 00:00:00	1988-06-24	5001	0	\N	0	0	\N	\N	0	48076	0	23426006	4052083		
16996	1550	3011505	2016-01-02	2016-01-02 00:00:00	2016-01-02	5001	0	\N	0	0	\N	\N	0	103790	0	19926-5	3011505		
18625	1715	3006322	2003-09-14	2003-09-14 00:00:00	2003-09-14	5001	0	\N	0	0	\N	\N	0	114545	0	8331-1	3006322		
5286	507	3006322	1961-01-09	1961-01-09 00:00:00	1961-01-09	5001	0	\N	0	0	\N	\N	0	33966	0	8331-1	3006322		
57709	5290	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	351927	0	6095-4	3036780		
16710	1526	3051031	1978-02-26	1978-02-26 00:00:00	1978-02-26	5001	0	\N	0	0	\N	\N	0	102062	0	46240-8	3051031		
57231	1746	4024958	1997-08-09	1997-08-09 00:00:00	1997-08-09	5001	0	\N	0	0	\N	\N	0	116723	0	117015009	4024958		
43179	3991	3006322	1972-02-22	1972-02-22 00:00:00	1972-02-22	5001	0	\N	0	0	\N	\N	0	265342	0	8331-1	3006322		
140974	4348	4052083	2007-05-17	2007-05-17 00:00:00	2007-05-17	5001	0	\N	0	0	\N	\N	0	288346	0	23426006	4052083		
54611	4991	3021226	1997-08-01	1997-08-01 00:00:00	1997-08-01	5001	0	\N	0	0	\N	\N	0	332033	0	6246-3	3021226		
22439	2056	3006322	2019-02-21	2019-02-21 00:00:00	2019-02-21	5001	0	\N	0	0	\N	\N	0	136745	0	8331-1	3006322		
26063	2392	3011505	1991-04-12	1991-04-12 00:00:00	1991-04-12	5001	0	\N	0	0	\N	\N	0	159060	0	19926-5	3011505		
1125	94	46235214	1953-11-23	1953-11-23 00:00:00	1953-11-23	5001	0	\N	0	0	\N	\N	0	6337	0	76690-7	46235214		
23172	2133	3006322	2003-11-18	2003-11-18 00:00:00	2003-11-18	5001	0	\N	0	0	\N	\N	0	141935	0	8331-1	3006322		
18026	564	4133840	2002-11-14	2002-11-14 00:00:00	2002-11-14	5001	0	\N	0	0	\N	\N	0	37326	0	127783003	4133840		
613	36	40769194	1960-06-21	1960-06-21 00:00:00	1960-06-21	5001	0	\N	0	0	\N	\N	0	2502	0	66534-9	40769194		
34679	3176	3001488	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	211108	0	7258-7	3001488		
159039	4890	4052083	1938-10-12	1938-10-12 00:00:00	1938-10-12	5001	0	\N	0	0	\N	\N	0	325195	0	23426006	4052083		
15253	1399	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	93012	0	6273-7	3006451		
40632	3772	3001247	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	250664	0	6085-5	3001247		
26680	2460	3006322	2006-08-17	2006-08-17 00:00:00	2006-08-17	5001	0	\N	0	0	\N	\N	0	163092	0	8331-1	3006322		
6040	185	4024958	1948-10-01	1948-10-01 00:00:00	1948-10-01	5001	0	\N	0	0	\N	\N	0	12566	0	117015009	4024958		
45268	4190	3006322	1989-05-04	1989-05-04 00:00:00	1989-05-04	5001	0	\N	0	0	\N	\N	0	278081	0	8331-1	3006322		
47731	4376	40766240	2012-05-29	2012-05-29 00:00:00	2012-05-29	5001	0	\N	0	0	\N	\N	0	290786	0	63513-6	40766240		
45868	1399	4024958	1961-04-26	1961-04-26 00:00:00	1961-04-26	5001	0	\N	0	0	\N	\N	0	92993	0	117015009	4024958		
30905	2830	3001247	1975-06-22	1975-06-22 00:00:00	1975-06-22	5001	0	\N	0	0	\N	\N	0	187706	0	6085-5	3001247		
40669	1261	4133840	2006-05-06	2006-05-06 00:00:00	2006-05-06	5001	0	\N	0	0	\N	\N	0	83136	0	127783003	4133840		
10081	959	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	63775	0	6095-4	3036780		
38335	3529	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	234436	0	6075-6	3005136		
92922	2861	4024958	1970-03-15	1970-03-15 00:00:00	1970-03-15	5001	0	\N	0	0	\N	\N	0	190206	0	117015009	4024958		
104547	3219	4024958	1983-05-04	1983-05-04 00:00:00	1983-05-04	5001	0	\N	0	0	\N	\N	0	213887	0	117015009	4024958		
60969	1861	4024958	1981-12-31	1981-12-31 00:00:00	1981-12-31	5001	0	\N	0	0	\N	\N	0	124417	0	117015009	4024958		
145719	4474	4052083	1994-08-01	1994-08-01 00:00:00	1994-08-01	5001	0	\N	0	0	\N	\N	0	297631	0	23426006	4052083		
19026	1743	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	116534	0	6248-9	3015076		
1125	30	4024958	1990-09-13	1990-09-13 00:00:00	1990-09-13	5001	0	\N	0	0	\N	\N	0	2046	0	117015009	4024958		
55568	5101	3006322	1989-02-21	1989-02-21 00:00:00	1989-02-21	5001	0	\N	0	0	\N	\N	0	338950	0	8331-1	3006322		
12544	403	4024958	1960-10-13	1960-10-13 00:00:00	1960-10-13	5001	0	\N	0	0	\N	\N	0	26434	0	117015009	4024958		
96101	2945	4133840	1967-09-19	1967-09-19 00:00:00	1967-09-19	5001	0	\N	0	0	\N	\N	0	196537	0	127783003	4133840		
42018	3884	3019406	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	258142	0	6158-0	3019406		
75765	2326	4052083	1999-04-05	1999-04-05 00:00:00	1999-04-05	5001	0	\N	0	0	\N	\N	0	154676	0	23426006	4052083		
33551	3041	3036780	1978-08-06	1978-08-06 00:00:00	1978-08-06	5001	0	\N	0	0	\N	\N	0	202463	0	6095-4	3036780		
4891	472	3012494	1998-02-10	1998-02-10 00:00:00	1998-02-10	5001	0	\N	0	0	\N	\N	0	31515	0	6206-7	3012494		
39185	1219	4024958	1956-01-17	1956-01-17 00:00:00	1956-01-17	5001	0	\N	0	0	\N	\N	0	80285	0	117015009	4024958		
35706	3268	3006322	1974-09-15	1974-09-15 00:00:00	1974-09-15	5001	0	\N	0	0	\N	\N	0	217172	0	8331-1	3006322		
54916	1661	4052083	1994-02-11	1994-02-11 00:00:00	1994-02-11	5001	0	\N	0	0	\N	\N	0	111637	0	23426006	4052083		
5543	171	4024958	2005-06-13	2005-06-13 00:00:00	2005-06-13	5001	0	\N	0	0	\N	\N	0	11618	0	117015009	4024958		
11184	1082	40769179	1988-08-22	1988-08-22 00:00:00	1988-08-22	5001	0	\N	0	0	\N	\N	0	70909	0	66519-0	40769179		
14831	1378	3011505	2000-07-25	2000-07-25 00:00:00	2000-07-25	5001	0	\N	0	0	\N	\N	0	91440	0	19926-5	3011505		
21336	1971	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	130989	0	6189-5	3006734		
26248	2414	3006322	1965-02-06	1965-02-06 00:00:00	1965-02-06	5001	0	\N	0	0	\N	\N	0	160197	0	8331-1	3006322		
21082	664	4024958	1985-03-22	1985-03-22 00:00:00	1985-03-22	5001	0	\N	0	0	\N	\N	0	43803	0	117015009	4024958		
15774	1442	3049273	2004-12-18	2004-12-18 00:00:00	2004-12-18	5001	0	\N	0	0	\N	\N	0	96187	0	38265-5	3049273		
86852	2684	4024958	1986-01-03	1986-01-03 00:00:00	1986-01-03	5001	0	\N	0	0	\N	\N	0	177858	0	117015009	4024958		
13485	1276	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	84260	0	7258-7	3001488		
57181	5252	3011505	2010-12-21	2010-12-21 00:00:00	2010-12-21	5001	0	\N	0	0	\N	\N	0	349427	0	19926-5	3011505		
9061	863	3006322	1923-04-14	1923-04-14 00:00:00	1923-04-14	5001	0	\N	0	0	\N	\N	0	57160	0	8331-1	3006322		
12396	1176	40758406	2011-09-02	2011-09-02 00:00:00	2011-09-02	5001	0	\N	0	0	\N	\N	0	77637	0	55277-8	40758406		
39167	3622	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	240803	0	7258-7	3001488		
50190	4578	40758406	1965-12-20	1965-12-20 00:00:00	1965-12-20	5001	0	\N	0	0	\N	\N	0	304959	0	55277-8	40758406		
14911	1381	3006322	2016-08-21	2016-08-21 00:00:00	2016-08-21	5001	0	\N	0	0	\N	\N	0	91583	0	8331-1	3006322		
23207	727	4052083	1951-08-04	1951-08-04 00:00:00	1951-08-04	5001	0	\N	0	0	\N	\N	0	48251	0	23426006	4052083		
99095	3040	4052083	1985-06-17	1985-06-17 00:00:00	1985-06-17	5001	0	\N	0	0	\N	\N	0	202373	0	23426006	4052083		
18626	1715	3006322	1960-04-21	1960-04-21 00:00:00	1960-04-21	5001	0	\N	0	0	\N	\N	0	114566	0	8331-1	3006322		
5287	507	40758406	1957-10-13	1957-10-13 00:00:00	1957-10-13	5001	0	\N	0	0	\N	\N	0	33899	0	55277-8	40758406		
57710	5290	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	351927	0	6189-5	3006734		
16711	1526	46235214	1978-02-26	1978-02-26 00:00:00	1978-02-26	5001	0	\N	0	0	\N	\N	0	102062	0	76690-7	46235214		
57247	1748	4052083	2012-03-06	2012-03-06 00:00:00	2012-03-06	5001	0	\N	0	0	\N	\N	0	116860	0	23426006	4052083		
43180	3991	46235214	1957-01-24	1957-01-24 00:00:00	1957-01-24	5001	0	\N	0	0	\N	\N	0	265320	0	76690-7	46235214		
140975	4348	4024958	2007-07-11	2007-07-11 00:00:00	2007-07-11	5001	0	\N	0	0	\N	\N	0	288311	0	117015009	4024958		
54612	4991	3005136	1997-08-01	1997-08-01 00:00:00	1997-08-01	5001	0	\N	0	0	\N	\N	0	332033	0	6075-6	3005136		
22441	2058	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	136841	0	6082-2	3000876		
26064	2392	3011505	1981-12-04	1981-12-04 00:00:00	1981-12-04	5001	0	\N	0	0	\N	\N	0	159078	0	19926-5	3011505		
1126	94	40758406	1953-11-23	1953-11-23 00:00:00	1953-11-23	5001	0	\N	0	0	\N	\N	0	6337	0	55277-8	40758406		
23173	2133	3006322	2014-02-10	2014-02-10 00:00:00	2014-02-10	5001	0	\N	0	0	\N	\N	0	141937	0	8331-1	3006322		
18030	565	4052083	1967-12-12	1967-12-12 00:00:00	1967-12-12	5001	0	\N	0	0	\N	\N	0	37435	0	23426006	4052083		
617	38	3006322	1967-10-01	1967-10-01 00:00:00	1967-10-01	5001	0	\N	0	0	\N	\N	0	2722	0	8331-1	3006322		
34680	3176	3006734	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	211108	0	6189-5	3006734		
159066	4890	4052083	1951-06-16	1951-06-16 00:00:00	1951-06-16	5001	0	\N	0	0	\N	\N	0	325196	0	23426006	4052083		
15254	1399	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	93012	0	6206-7	3012494		
40633	3772	3012494	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	250664	0	6206-7	3012494		
26681	2460	3006322	2015-05-17	2015-05-17 00:00:00	2015-05-17	5001	0	\N	0	0	\N	\N	0	163074	0	8331-1	3006322		
6041	185	4052083	2018-05-23	2018-05-23 00:00:00	2018-05-23	5001	0	\N	0	0	\N	\N	0	12570	0	23426006	4052083		
45269	4191	3006322	1977-07-10	1977-07-10 00:00:00	1977-07-10	5001	0	\N	0	0	\N	\N	0	278126	0	8331-1	3006322		
47732	4376	3051031	2012-05-29	2012-05-29 00:00:00	2012-05-29	5001	0	\N	0	0	\N	\N	0	290786	0	46240-8	3051031		
45890	1401	4024958	1996-06-26	1996-06-26 00:00:00	1996-06-26	5001	0	\N	0	0	\N	\N	0	93136	0	117015009	4024958		
30906	2830	3000876	1975-06-22	1975-06-22 00:00:00	1975-06-22	5001	0	\N	0	0	\N	\N	0	187706	0	6082-2	3000876		
40670	1261	4133840	2017-12-02	2017-12-02 00:00:00	2017-12-02	5001	0	\N	0	0	\N	\N	0	83139	0	127783003	4133840		
10082	959	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	63775	0	6158-0	3019406		
38336	3529	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	234436	0	6248-9	3015076		
92934	2862	4024958	1967-10-28	1967-10-28 00:00:00	1967-10-28	5001	0	\N	0	0	\N	\N	0	190267	0	117015009	4024958		
22990	2114	3006322	2016-10-11	2016-10-11 00:00:00	2016-10-11	5001	0	\N	0	0	\N	\N	0	140646	0	8331-1	3006322		
60994	1864	4133840	2018-12-21	2018-12-21 00:00:00	2018-12-21	5001	0	\N	0	0	\N	\N	0	124531	0	127783003	4133840		
145725	4474	4052083	1966-10-04	1966-10-04 00:00:00	1966-10-04	5001	0	\N	0	0	\N	\N	0	297670	0	23426006	4052083		
19027	1743	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	116534	0	6075-6	3005136		
1126	30	4024958	1998-02-04	1998-02-04 00:00:00	1998-02-04	5001	0	\N	0	0	\N	\N	0	2097	0	117015009	4024958		
55569	5101	3006322	1986-07-26	1986-07-26 00:00:00	1986-07-26	5001	0	\N	0	0	\N	\N	0	338964	0	8331-1	3006322		
12545	403	4052083	1951-12-18	1951-12-18 00:00:00	1951-12-18	5001	0	\N	0	0	\N	\N	0	26512	0	23426006	4052083		
96103	2945	4133840	1984-10-16	1984-10-16 00:00:00	1984-10-16	5001	0	\N	0	0	\N	\N	0	196491	0	127783003	4133840		
42019	3885	3006322	1973-06-17	1973-06-17 00:00:00	1973-06-17	5001	0	\N	0	0	\N	\N	0	258282	0	8331-1	3006322		
75766	2326	4024958	1966-11-19	1966-11-19 00:00:00	1966-11-19	5001	0	\N	0	0	\N	\N	0	154645	0	117015009	4024958		
33552	3041	3005136	1978-08-06	1978-08-06 00:00:00	1978-08-06	5001	0	\N	0	0	\N	\N	0	202463	0	6075-6	3005136		
4892	472	3000876	1998-02-10	1998-02-10 00:00:00	1998-02-10	5001	0	\N	0	0	\N	\N	0	31515	0	6082-2	3000876		
39198	1219	4024958	1951-05-14	1951-05-14 00:00:00	1951-05-14	5001	0	\N	0	0	\N	\N	0	80234	0	117015009	4024958		
35707	3268	3006322	1984-10-02	1984-10-02 00:00:00	1984-10-02	5001	0	\N	0	0	\N	\N	0	217164	0	8331-1	3006322		
54920	1662	4024958	1999-02-12	1999-02-12 00:00:00	1999-02-12	5001	0	\N	0	0	\N	\N	0	111722	0	117015009	4024958		
5547	171	4024958	1972-03-22	1972-03-22 00:00:00	1972-03-22	5001	0	\N	0	0	\N	\N	0	11582	0	117015009	4024958		
11185	1082	40769189	1988-08-22	1988-08-22 00:00:00	1988-08-22	5001	0	\N	0	0	\N	\N	0	70909	0	66529-9	40769189		
14832	1378	3011505	2014-11-04	2014-11-04 00:00:00	2014-11-04	5001	0	\N	0	0	\N	\N	0	91444	0	19926-5	3011505		
21337	1971	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	130989	0	6833-8	3023430		
26250	2414	3006322	1937-09-07	1937-09-07 00:00:00	1937-09-07	5001	0	\N	0	0	\N	\N	0	160220	0	8331-1	3006322		
31042	2834	40758406	1991-01-06	1991-01-06 00:00:00	1991-01-06	5001	0	\N	0	0	\N	\N	0	188124	0	55277-8	40758406		
15775	1442	3049273	2012-09-07	2012-09-07 00:00:00	2012-09-07	5001	0	\N	0	0	\N	\N	0	96188	0	38265-5	3049273		
86861	2684	4024958	2005-11-10	2005-11-10 00:00:00	2005-11-10	5001	0	\N	0	0	\N	\N	0	177879	0	117015009	4024958		
13486	1276	3049273	2010-08-11	2010-08-11 00:00:00	2010-08-11	5001	0	\N	0	0	\N	\N	0	84135	0	38265-5	3049273		
57182	5252	3011505	2019-06-11	2019-06-11 00:00:00	2019-06-11	5001	0	\N	0	0	\N	\N	0	349403	0	19926-5	3011505		
9062	863	3006322	1965-04-05	1965-04-05 00:00:00	1965-04-05	5001	0	\N	0	0	\N	\N	0	57150	0	8331-1	3006322		
12397	1176	3051031	2011-09-02	2011-09-02 00:00:00	2011-09-02	5001	0	\N	0	0	\N	\N	0	77637	0	46240-8	3051031		
39168	3622	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	240803	0	6189-5	3006734		
50191	4578	40758406	1966-05-19	1966-05-19 00:00:00	1966-05-19	5001	0	\N	0	0	\N	\N	0	304943	0	55277-8	40758406		
14912	1381	3006322	1986-02-22	1986-02-22 00:00:00	1986-02-22	5001	0	\N	0	0	\N	\N	0	91604	0	8331-1	3006322		
121311	3744	4024958	1992-09-30	1992-09-30 00:00:00	1992-09-30	5001	0	\N	0	0	\N	\N	0	248792	0	117015009	4024958		
99097	3040	4052083	1987-04-24	1987-04-24 00:00:00	1987-04-24	5001	0	\N	0	0	\N	\N	0	202402	0	23426006	4052083		
18627	1715	3006322	1958-03-19	1958-03-19 00:00:00	1958-03-19	5001	0	\N	0	0	\N	\N	0	114520	0	8331-1	3006322		
5289	507	3051031	1957-10-13	1957-10-13 00:00:00	1957-10-13	5001	0	\N	0	0	\N	\N	0	33899	0	46240-8	3051031		
57711	5290	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	351927	0	6833-8	3023430		
16712	1526	3006322	1985-08-05	1985-08-05 00:00:00	1985-08-05	5001	0	\N	0	0	\N	\N	0	102082	0	8331-1	3006322		
57250	1748	4052083	2006-02-21	2006-02-21 00:00:00	2006-02-21	5001	0	\N	0	0	\N	\N	0	116927	0	23426006	4052083		
43181	3991	3006322	1955-06-12	1955-06-12 00:00:00	1955-06-12	5001	0	\N	0	0	\N	\N	0	265338	0	8331-1	3006322		
140997	4349	4052083	2008-05-20	2008-05-20 00:00:00	2008-05-20	5001	0	\N	0	0	\N	\N	0	288423	0	23426006	4052083		
54613	4991	3019406	1997-08-01	1997-08-01 00:00:00	1997-08-01	5001	0	\N	0	0	\N	\N	0	332033	0	6158-0	3019406		
22442	2058	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	136841	0	6189-5	3006734		
26065	2392	3011505	1964-02-07	1964-02-07 00:00:00	1964-02-07	5001	0	\N	0	0	\N	\N	0	159074	0	19926-5	3011505		
1127	94	46235214	1953-09-24	1953-09-24 00:00:00	1953-09-24	5001	0	\N	0	0	\N	\N	0	6313	0	76690-7	46235214		
23174	2134	3006322	2007-04-09	2007-04-09 00:00:00	2007-04-09	5001	0	\N	0	0	\N	\N	0	142017	0	8331-1	3006322		
18047	565	4024958	1974-01-13	1974-01-13 00:00:00	1974-01-13	5001	0	\N	0	0	\N	\N	0	37437	0	117015009	4024958		
618	38	3006322	1988-03-28	1988-03-28 00:00:00	1988-03-28	5001	0	\N	0	0	\N	\N	0	2719	0	8331-1	3006322		
34681	3176	3036780	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	211108	0	6095-4	3036780		
148553	4550	4024958	1966-10-21	1966-10-21 00:00:00	1966-10-21	5001	0	\N	0	0	\N	\N	0	303157	0	117015009	4024958		
15255	1399	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	93012	0	6248-9	3015076		
51911	4761	3012494	1984-05-29	1984-05-29 00:00:00	1984-05-29	5001	0	\N	0	0	\N	\N	0	317259	0	6206-7	3012494		
26682	2460	3006322	2016-10-20	2016-10-20 00:00:00	2016-10-20	5001	0	\N	0	0	\N	\N	0	163114	0	8331-1	3006322		
6044	185	4133840	2014-06-01	2014-06-01 00:00:00	2014-06-01	5001	0	\N	0	0	\N	\N	0	12518	0	127783003	4133840		
45271	4191	3006322	1986-12-21	1986-12-21 00:00:00	1986-12-21	5001	0	\N	0	0	\N	\N	0	278128	0	8331-1	3006322		
47733	4376	40758406	2012-05-29	2012-05-29 00:00:00	2012-05-29	5001	0	\N	0	0	\N	\N	0	290786	0	55277-8	40758406		
45896	1401	4024958	1982-09-11	1982-09-11 00:00:00	1982-09-11	5001	0	\N	0	0	\N	\N	0	93153	0	117015009	4024958		
30907	2830	3020655	1975-06-22	1975-06-22 00:00:00	1975-06-22	5001	0	\N	0	0	\N	\N	0	187706	0	6844-5	3020655		
86644	2677	4024958	1974-06-07	1974-06-07 00:00:00	1974-06-07	5001	0	\N	0	0	\N	\N	0	177372	0	117015009	4024958		
10083	959	3006322	1985-05-26	1985-05-26 00:00:00	1985-05-26	5001	0	\N	0	0	\N	\N	0	63739	0	8331-1	3006322		
38337	3529	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	234436	0	6276-0	3027231		
92935	2862	4052083	2008-10-08	2008-10-08 00:00:00	2008-10-08	5001	0	\N	0	0	\N	\N	0	190271	0	23426006	4052083		
22991	2114	3006322	2003-11-08	2003-11-08 00:00:00	2003-11-08	5001	0	\N	0	0	\N	\N	0	140672	0	8331-1	3006322		
61001	1864	4133840	2017-12-15	2017-12-15 00:00:00	2017-12-15	5001	0	\N	0	0	\N	\N	0	124546	0	127783003	4133840		
145744	4475	4024958	2018-09-29	2018-09-29 00:00:00	2018-09-29	5001	0	\N	0	0	\N	\N	0	297755	0	117015009	4024958		
19028	1743	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	116534	0	6106-9	3014599		
1156	32	4052083	1966-02-08	1966-02-08 00:00:00	1966-02-08	5001	0	\N	0	0	\N	\N	0	2243	0	23426006	4052083		
55570	5101	3006322	1999-12-09	1999-12-09 00:00:00	1999-12-09	5001	0	\N	0	0	\N	\N	0	338966	0	8331-1	3006322		
12548	403	4024958	1983-01-31	1983-01-31 00:00:00	1983-01-31	5001	0	\N	0	0	\N	\N	0	26436	0	117015009	4024958		
96104	2945	4133840	2006-09-19	2006-09-19 00:00:00	2006-09-19	5001	0	\N	0	0	\N	\N	0	196505	0	127783003	4133840		
42020	3885	3006322	2009-04-02	2009-04-02 00:00:00	2009-04-02	5001	0	\N	0	0	\N	\N	0	258259	0	8331-1	3006322		
75771	2326	4024958	1985-01-10	1985-01-10 00:00:00	1985-01-10	5001	0	\N	0	0	\N	\N	0	154675	0	117015009	4024958		
33553	3041	3014599	1978-08-06	1978-08-06 00:00:00	1978-08-06	5001	0	\N	0	0	\N	\N	0	202463	0	6106-9	3014599		
4894	474	3006322	2015-05-05	2015-05-05 00:00:00	2015-05-05	5001	0	\N	0	0	\N	\N	0	31628	0	8331-1	3006322		
52090	4784	40758406	1950-07-30	1950-07-30 00:00:00	1950-07-30	5001	0	\N	0	0	\N	\N	0	318492	0	55277-8	40758406		
35724	3270	3006322	1981-01-14	1981-01-14 00:00:00	1981-01-14	5001	0	\N	0	0	\N	\N	0	217259	0	8331-1	3006322		
54922	1662	4024958	2004-08-27	2004-08-27 00:00:00	2004-08-27	5001	0	\N	0	0	\N	\N	0	111735	0	117015009	4024958		
11284	1086	3006322	1970-02-17	1970-02-17 00:00:00	1970-02-17	5001	0	\N	0	0	\N	\N	0	71311	0	8331-1	3006322		
11186	1082	40769194	1988-08-22	1988-08-22 00:00:00	1988-08-22	5001	0	\N	0	0	\N	\N	0	70909	0	66534-9	40769194		
14833	1378	3011505	1999-07-20	1999-07-20 00:00:00	1999-07-20	5001	0	\N	0	0	\N	\N	0	91349	0	19926-5	3011505		
21338	1971	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	130989	0	7258-7	3001488		
26251	2414	3006322	1999-11-16	1999-11-16 00:00:00	1999-11-16	5001	0	\N	0	0	\N	\N	0	160279	0	8331-1	3006322		
31043	2834	40758406	1991-05-06	1991-05-06 00:00:00	1991-05-06	5001	0	\N	0	0	\N	\N	0	188183	0	55277-8	40758406		
15776	1442	3006322	1946-07-07	1946-07-07 00:00:00	1946-07-07	5001	0	\N	0	0	\N	\N	0	96141	0	8331-1	3006322		
86870	2684	4052083	1991-04-25	1991-04-25 00:00:00	1991-04-25	5001	0	\N	0	0	\N	\N	0	177859	0	23426006	4052083		
13487	1276	3006322	2014-02-16	2014-02-16 00:00:00	2014-02-16	5001	0	\N	0	0	\N	\N	0	84267	0	8331-1	3006322		
57183	5252	3011505	2003-04-22	2003-04-22 00:00:00	2003-04-22	5001	0	\N	0	0	\N	\N	0	349470	0	19926-5	3011505		
9063	863	3006322	2002-05-17	2002-05-17 00:00:00	2002-05-17	5001	0	\N	0	0	\N	\N	0	57142	0	8331-1	3006322		
12400	1176	40766240	2012-07-28	2012-07-28 00:00:00	2012-07-28	5001	0	\N	0	0	\N	\N	0	77712	0	63513-6	40766240		
39169	3622	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	240803	0	6085-5	3001247		
50193	4578	40766240	1966-05-19	1966-05-19 00:00:00	1966-05-19	5001	0	\N	0	0	\N	\N	0	304943	0	63513-6	40766240		
14913	1381	3006322	2018-03-28	2018-03-28 00:00:00	2018-03-28	5001	0	\N	0	0	\N	\N	0	91589	0	8331-1	3006322		
121319	3744	4052083	1971-06-23	1971-06-23 00:00:00	1971-06-23	5001	0	\N	0	0	\N	\N	0	248790	0	23426006	4052083		
99109	3040	4052083	2011-10-02	2011-10-02 00:00:00	2011-10-02	5001	0	\N	0	0	\N	\N	0	202371	0	23426006	4052083		
18628	1716	3006322	2013-01-09	2013-01-09 00:00:00	2013-01-09	5001	0	\N	0	0	\N	\N	0	114668	0	8331-1	3006322		
5291	507	40766240	1957-10-13	1957-10-13 00:00:00	1957-10-13	5001	0	\N	0	0	\N	\N	0	33899	0	63513-6	40766240		
57712	5291	3006322	2000-09-09	2000-09-09 00:00:00	2000-09-09	5001	0	\N	0	0	\N	\N	0	352075	0	8331-1	3006322		
16713	1526	3006322	1991-01-04	1991-01-04 00:00:00	1991-01-04	5001	0	\N	0	0	\N	\N	0	102079	0	8331-1	3006322		
57259	1748	4052083	1949-04-23	1949-04-23 00:00:00	1949-04-23	5001	0	\N	0	0	\N	\N	0	116837	0	23426006	4052083		
43182	3991	40766240	1957-01-24	1957-01-24 00:00:00	1957-01-24	5001	0	\N	0	0	\N	\N	0	265320	0	63513-6	40766240		
164279	5046	4052083	2009-05-18	2009-05-18 00:00:00	2009-05-18	5001	0	\N	0	0	\N	\N	0	335365	0	23426006	4052083		
54614	4991	3012494	1997-08-01	1997-08-01 00:00:00	1997-08-01	5001	0	\N	0	0	\N	\N	0	332033	0	6206-7	3012494		
22443	2058	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	136841	0	6085-5	3001247		
26066	2392	3011505	1970-02-20	1970-02-20 00:00:00	1970-02-20	5001	0	\N	0	0	\N	\N	0	159002	0	19926-5	3011505		
1128	94	40758406	1953-09-24	1953-09-24 00:00:00	1953-09-24	5001	0	\N	0	0	\N	\N	0	6313	0	55277-8	40758406		
23175	2134	3006322	2010-02-05	2010-02-05 00:00:00	2010-02-05	5001	0	\N	0	0	\N	\N	0	141991	0	8331-1	3006322		
16639	1516	3049273	1998-03-02	1998-03-02 00:00:00	1998-03-02	5001	0	\N	0	0	\N	\N	0	101252	0	38265-5	3049273		
619	38	3006322	2005-06-06	2005-06-06 00:00:00	2005-06-06	5001	0	\N	0	0	\N	\N	0	2720	0	8331-1	3006322		
34682	3176	3023430	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	211108	0	6833-8	3023430		
159853	4916	4024958	2010-07-10	2010-07-10 00:00:00	2010-07-10	5001	0	\N	0	0	\N	\N	0	326664	0	117015009	4024958		
15256	1399	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	93012	0	6189-5	3006734		
51912	4761	3000876	1984-05-29	1984-05-29 00:00:00	1984-05-29	5001	0	\N	0	0	\N	\N	0	317259	0	6082-2	3000876		
26683	2461	3006322	1987-08-17	1987-08-17 00:00:00	1987-08-17	5001	0	\N	0	0	\N	\N	0	163182	0	8331-1	3006322		
6049	185	4133840	2015-06-07	2015-06-07 00:00:00	2015-06-07	5001	0	\N	0	0	\N	\N	0	12565	0	127783003	4133840		
45272	4191	3006322	1961-04-12	1961-04-12 00:00:00	1961-04-12	5001	0	\N	0	0	\N	\N	0	278136	0	8331-1	3006322		
47735	4376	3006322	1973-01-29	1973-01-29 00:00:00	1973-01-29	5001	0	\N	0	0	\N	\N	0	290764	0	8331-1	3006322		
149181	4574	4024958	1964-12-15	1964-12-15 00:00:00	1964-12-15	5001	0	\N	0	0	\N	\N	0	304681	0	117015009	4024958		
30908	2830	3023430	1975-06-22	1975-06-22 00:00:00	1975-06-22	5001	0	\N	0	0	\N	\N	0	187706	0	6833-8	3023430		
86691	2680	4024958	1999-04-22	1999-04-22 00:00:00	1999-04-22	5001	0	\N	0	0	\N	\N	0	177528	0	117015009	4024958		
10084	959	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	63712	0	6075-6	3005136		
38338	3529	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	234436	0	7258-7	3001488		
92938	2862	4052083	2016-08-06	2016-08-06 00:00:00	2016-08-06	5001	0	\N	0	0	\N	\N	0	190284	0	23426006	4052083		
22993	2114	46235214	1997-02-18	1997-02-18 00:00:00	1997-02-18	5001	0	\N	0	0	\N	\N	0	140644	0	76690-7	46235214		
61006	1864	4133840	2011-12-23	2011-12-23 00:00:00	2011-12-23	5001	0	\N	0	0	\N	\N	0	124551	0	127783003	4133840		
145751	4475	4052083	2012-09-10	2012-09-10 00:00:00	2012-09-10	5001	0	\N	0	0	\N	\N	0	297706	0	23426006	4052083		
19029	1743	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	116534	0	6206-7	3012494		
2528	246	3011505	2019-06-20	2019-06-20 00:00:00	2019-06-20	5001	0	\N	0	0	\N	\N	0	16517	0	19926-5	3011505		
55587	5103	3006322	1968-02-01	1968-02-01 00:00:00	1968-02-01	5001	0	\N	0	0	\N	\N	0	339096	0	8331-1	3006322		
12557	403	4052083	1935-01-04	1935-01-04 00:00:00	1935-01-04	5001	0	\N	0	0	\N	\N	0	26510	0	23426006	4052083		
96105	2945	4133840	1994-04-05	1994-04-05 00:00:00	1994-04-05	5001	0	\N	0	0	\N	\N	0	196502	0	127783003	4133840		
42021	3885	3006322	1977-06-06	1977-06-06 00:00:00	1977-06-06	5001	0	\N	0	0	\N	\N	0	258256	0	8331-1	3006322		
75776	2326	4052083	2010-02-20	2010-02-20 00:00:00	2010-02-20	5001	0	\N	0	0	\N	\N	0	154663	0	23426006	4052083		
33554	3041	3023430	1978-08-06	1978-08-06 00:00:00	1978-08-06	5001	0	\N	0	0	\N	\N	0	202463	0	6833-8	3023430		
4895	474	3006322	1993-05-23	1993-05-23 00:00:00	1993-05-23	5001	0	\N	0	0	\N	\N	0	31610	0	8331-1	3006322		
52091	4784	40766240	1950-08-29	1950-08-29 00:00:00	1950-08-29	5001	0	\N	0	0	\N	\N	0	318420	0	63513-6	40766240		
35725	3270	3006322	1985-01-02	1985-01-02 00:00:00	1985-01-02	5001	0	\N	0	0	\N	\N	0	217255	0	8331-1	3006322		
54931	1662	4052083	1969-11-14	1969-11-14 00:00:00	1969-11-14	5001	0	\N	0	0	\N	\N	0	111710	0	23426006	4052083		
11300	1088	3006322	2008-02-25	2008-02-25 00:00:00	2008-02-25	5001	0	\N	0	0	\N	\N	0	71418	0	8331-1	3006322		
11373	1091	3051031	1957-09-05	1957-09-05 00:00:00	1957-09-05	5001	0	\N	0	0	\N	\N	0	71674	0	46240-8	3051031		
14834	1378	3011505	2006-09-19	2006-09-19 00:00:00	2006-09-19	5001	0	\N	0	0	\N	\N	0	91343	0	19926-5	3011505		
21339	1971	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	130989	0	6248-9	3015076		
26254	2414	3006322	1940-07-07	1940-07-07 00:00:00	1940-07-07	5001	0	\N	0	0	\N	\N	0	160274	0	8331-1	3006322		
31044	2834	46235214	1991-05-06	1991-05-06 00:00:00	1991-05-06	5001	0	\N	0	0	\N	\N	0	188183	0	76690-7	46235214		
15777	1443	3006322	1990-08-19	1990-08-19 00:00:00	1990-08-19	5001	0	\N	0	0	\N	\N	0	96244	0	8331-1	3006322		
121378	3745	4133840	2003-07-23	2003-07-23 00:00:00	2003-07-23	5001	0	\N	0	0	\N	\N	0	248972	0	127783003	4133840		
13488	1276	3006322	2015-04-22	2015-04-22 00:00:00	2015-04-22	5001	0	\N	0	0	\N	\N	0	84172	0	8331-1	3006322		
57184	5252	3011505	2009-12-15	2009-12-15 00:00:00	2009-12-15	5001	0	\N	0	0	\N	\N	0	349473	0	19926-5	3011505		
9064	863	3006322	1942-04-14	1942-04-14 00:00:00	1942-04-14	5001	0	\N	0	0	\N	\N	0	57165	0	8331-1	3006322		
12401	1176	40758406	2012-07-28	2012-07-28 00:00:00	2012-07-28	5001	0	\N	0	0	\N	\N	0	77712	0	55277-8	40758406		
39170	3622	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	240803	0	6106-9	3014599		
50194	4578	46235214	1966-05-19	1966-05-19 00:00:00	1966-05-19	5001	0	\N	0	0	\N	\N	0	304943	0	76690-7	46235214		
14914	1381	3011505	2012-08-18	2012-08-18 00:00:00	2012-08-18	5001	0	\N	0	0	\N	\N	0	91575	0	19926-5	3011505		
121340	3745	4133840	2016-10-05	2016-10-05 00:00:00	2016-10-05	5001	0	\N	0	0	\N	\N	0	248975	0	127783003	4133840		
145102	4452	4024958	1958-05-07	1958-05-07 00:00:00	1958-05-07	5001	0	\N	0	0	\N	\N	0	296244	0	117015009	4024958		
18629	1716	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	114632	0	7258-7	3001488		
5292	507	46235214	1957-10-13	1957-10-13 00:00:00	1957-10-13	5001	0	\N	0	0	\N	\N	0	33899	0	76690-7	46235214		
57719	5295	3006322	1914-09-05	1914-09-05 00:00:00	1914-09-05	5001	0	\N	0	0	\N	\N	0	352278	0	8331-1	3006322		
16714	1526	3006322	1988-04-04	1988-04-04 00:00:00	1988-04-04	5001	0	\N	0	0	\N	\N	0	102056	0	8331-1	3006322		
57270	1748	4052083	1955-05-01	1955-05-01 00:00:00	1955-05-01	5001	0	\N	0	0	\N	\N	0	116916	0	23426006	4052083		
43183	3991	40758406	1957-01-24	1957-01-24 00:00:00	1957-01-24	5001	0	\N	0	0	\N	\N	0	265320	0	55277-8	40758406		
164320	5048	4052083	1995-02-26	1995-02-26 00:00:00	1995-02-26	5001	0	\N	0	0	\N	\N	0	335500	0	23426006	4052083		
54615	4991	3015076	1997-08-01	1997-08-01 00:00:00	1997-08-01	5001	0	\N	0	0	\N	\N	0	332033	0	6248-9	3015076		
22444	2058	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	136841	0	6095-4	3036780		
26067	2394	3006322	1964-04-21	1964-04-21 00:00:00	1964-04-21	5001	0	\N	0	0	\N	\N	0	159150	0	8331-1	3006322		
1130	94	3051031	1953-09-24	1953-09-24 00:00:00	1953-09-24	5001	0	\N	0	0	\N	\N	0	6313	0	46240-8	3051031		
23176	2134	3006322	1993-10-04	1993-10-04 00:00:00	1993-10-04	5001	0	\N	0	0	\N	\N	0	141947	0	8331-1	3006322		
16642	1516	3006322	1958-04-09	1958-04-09 00:00:00	1958-04-09	5001	0	\N	0	0	\N	\N	0	101351	0	8331-1	3006322		
624	40	3049273	2018-06-14	2018-06-14 00:00:00	2018-06-14	5001	0	\N	0	0	\N	\N	0	2866	0	38265-5	3049273		
34683	3176	3020655	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	211108	0	6844-5	3020655		
159854	4917	4024958	2002-02-15	2002-02-15 00:00:00	2002-02-15	5001	0	\N	0	0	\N	\N	0	326759	0	117015009	4024958		
15257	1399	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	93012	0	6833-8	3023430		
51913	4761	3036780	1984-05-29	1984-05-29 00:00:00	1984-05-29	5001	0	\N	0	0	\N	\N	0	317259	0	6095-4	3036780		
26684	2461	3006322	1996-03-29	1996-03-29 00:00:00	1996-03-29	5001	0	\N	0	0	\N	\N	0	163146	0	8331-1	3006322		
6051	185	4024958	1982-09-24	1982-09-24 00:00:00	1982-09-24	5001	0	\N	0	0	\N	\N	0	12526	0	117015009	4024958		
45273	4191	3006322	2012-09-05	2012-09-05 00:00:00	2012-09-05	5001	0	\N	0	0	\N	\N	0	278137	0	8331-1	3006322		
47736	4376	3011505	2019-02-12	2019-02-12 00:00:00	2019-02-12	5001	0	\N	0	0	\N	\N	0	290759	0	19926-5	3011505		
149184	4574	4024958	1982-09-21	1982-09-21 00:00:00	1982-09-21	5001	0	\N	0	0	\N	\N	0	304727	0	117015009	4024958		
30909	2830	3005136	1975-06-22	1975-06-22 00:00:00	1975-06-22	5001	0	\N	0	0	\N	\N	0	187706	0	6075-6	3005136		
86693	2680	4052083	1978-12-18	1978-12-18 00:00:00	1978-12-18	5001	0	\N	0	0	\N	\N	0	177560	0	23426006	4052083		
10085	959	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	63712	0	6106-9	3014599		
38339	3529	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	234436	0	6844-5	3020655		
92945	2862	4052083	1994-03-16	1994-03-16 00:00:00	1994-03-16	5001	0	\N	0	0	\N	\N	0	190273	0	23426006	4052083		
22994	2114	40766240	1997-02-18	1997-02-18 00:00:00	1997-02-18	5001	0	\N	0	0	\N	\N	0	140644	0	63513-6	40766240		
61008	1864	4133840	2016-12-09	2016-12-09 00:00:00	2016-12-09	5001	0	\N	0	0	\N	\N	0	124530	0	127783003	4133840		
145752	4475	4024958	1981-08-06	1981-08-06 00:00:00	1981-08-06	5001	0	\N	0	0	\N	\N	0	297736	0	117015009	4024958		
19030	1743	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	116534	0	6085-5	3001247		
2529	246	3011505	2007-04-19	2007-04-19 00:00:00	2007-04-19	5001	0	\N	0	0	\N	\N	0	16572	0	19926-5	3011505		
55588	5103	3006322	1984-10-19	1984-10-19 00:00:00	1984-10-19	5001	0	\N	0	0	\N	\N	0	339098	0	8331-1	3006322		
12593	404	4052083	1988-02-10	1988-02-10 00:00:00	1988-02-10	5001	0	\N	0	0	\N	\N	0	26680	0	23426006	4052083		
96106	2945	4052083	1973-11-18	1973-11-18 00:00:00	1973-11-18	5001	0	\N	0	0	\N	\N	0	196540	0	23426006	4052083		
42022	3885	3006322	1966-10-29	1966-10-29 00:00:00	1966-10-29	5001	0	\N	0	0	\N	\N	0	258280	0	8331-1	3006322		
75777	2326	4052083	1988-10-14	1988-10-14 00:00:00	1988-10-14	5001	0	\N	0	0	\N	\N	0	154661	0	23426006	4052083		
33555	3041	3006734	1978-08-06	1978-08-06 00:00:00	1978-08-06	5001	0	\N	0	0	\N	\N	0	202463	0	6189-5	3006734		
4896	474	3006322	1998-04-12	1998-04-12 00:00:00	1998-04-12	5001	0	\N	0	0	\N	\N	0	31653	0	8331-1	3006322		
52094	4784	3051031	1950-08-29	1950-08-29 00:00:00	1950-08-29	5001	0	\N	0	0	\N	\N	0	318420	0	46240-8	3051031		
35726	3270	3006322	2006-12-20	2006-12-20 00:00:00	2006-12-20	5001	0	\N	0	0	\N	\N	0	217331	0	8331-1	3006322		
66231	2030	4052083	1990-06-22	1990-06-22 00:00:00	1990-06-22	5001	0	\N	0	0	\N	\N	0	135142	0	23426006	4052083		
11301	1088	3006322	2005-07-08	2005-07-08 00:00:00	2005-07-08	5001	0	\N	0	0	\N	\N	0	71408	0	8331-1	3006322		
11375	1091	46235214	1957-09-05	1957-09-05 00:00:00	1957-09-05	5001	0	\N	0	0	\N	\N	0	71674	0	76690-7	46235214		
14835	1378	3011505	2003-03-11	2003-03-11 00:00:00	2003-03-11	5001	0	\N	0	0	\N	\N	0	91351	0	19926-5	3011505		
21340	1971	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	130989	0	6273-7	3006451		
26255	2414	3006322	1921-08-18	1921-08-18 00:00:00	1921-08-18	5001	0	\N	0	0	\N	\N	0	160218	0	8331-1	3006322		
31046	2834	40766240	1991-05-06	1991-05-06 00:00:00	1991-05-06	5001	0	\N	0	0	\N	\N	0	188183	0	63513-6	40766240		
15778	1443	3006322	2011-03-14	2011-03-14 00:00:00	2011-03-14	5001	0	\N	0	0	\N	\N	0	96196	0	8331-1	3006322		
121381	3745	4133840	2012-09-12	2012-09-12 00:00:00	2012-09-12	5001	0	\N	0	0	\N	\N	0	248970	0	127783003	4133840		
13489	1276	3049273	2009-07-17	2009-07-17 00:00:00	2009-07-17	5001	0	\N	0	0	\N	\N	0	84134	0	38265-5	3049273		
57185	5252	3011505	2012-05-01	2012-05-01 00:00:00	2012-05-01	5001	0	\N	0	0	\N	\N	0	349436	0	19926-5	3011505		
9066	864	3049273	2001-07-11	2001-07-11 00:00:00	2001-07-11	5001	0	\N	0	0	\N	\N	0	57326	0	38265-5	3049273		
12403	1176	46235214	2012-07-28	2012-07-28 00:00:00	2012-07-28	5001	0	\N	0	0	\N	\N	0	77712	0	76690-7	46235214		
39171	3622	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	240803	0	6206-7	3012494		
50196	4578	3051031	1966-05-19	1966-05-19 00:00:00	1966-05-19	5001	0	\N	0	0	\N	\N	0	304943	0	46240-8	3051031		
14915	1381	3011505	2019-05-11	2019-05-11 00:00:00	2019-05-11	5001	0	\N	0	0	\N	\N	0	91603	0	19926-5	3011505		
121343	3745	4024958	1934-06-22	1934-06-22 00:00:00	1934-06-22	5001	0	\N	0	0	\N	\N	0	248908	0	117015009	4024958		
145113	4452	4052083	1987-07-15	1987-07-15 00:00:00	1987-07-15	5001	0	\N	0	0	\N	\N	0	296249	0	23426006	4052083		
18630	1716	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	114632	0	6844-5	3020655		
18735	1724	3009542	2016-08-26	2016-08-26 00:00:00	2016-08-26	5001	0	\N	0	0	\N	\N	0	115252	0	20570-8	3009542		
57720	5295	3006322	1941-10-13	1941-10-13 00:00:00	1941-10-13	5001	0	\N	0	0	\N	\N	0	352280	0	8331-1	3006322		
16715	1526	46235214	1978-04-27	1978-04-27 00:00:00	1978-04-27	5001	0	\N	0	0	\N	\N	0	102077	0	76690-7	46235214		
57468	1753	4024958	1965-04-03	1965-04-03 00:00:00	1965-04-03	5001	0	\N	0	0	\N	\N	0	117192	0	117015009	4024958		
43185	3991	3051031	1957-01-24	1957-01-24 00:00:00	1957-01-24	5001	0	\N	0	0	\N	\N	0	265320	0	46240-8	3051031		
2149	192	3006322	1953-05-22	1953-05-22 00:00:00	1953-05-22	5001	0	\N	0	0	\N	\N	0	13204	0	8331-1	3006322		
54616	4991	3006322	2009-03-04	2009-03-04 00:00:00	2009-03-04	5001	0	\N	0	0	\N	\N	0	332075	0	8331-1	3006322		
22445	2058	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	136841	0	6106-9	3014599		
26068	2394	3006322	1962-11-17	1962-11-17 00:00:00	1962-11-17	5001	0	\N	0	0	\N	\N	0	159201	0	8331-1	3006322		
1132	94	40766240	1953-09-24	1953-09-24 00:00:00	1953-09-24	5001	0	\N	0	0	\N	\N	0	6313	0	63513-6	40766240		
23177	2134	3006322	1983-08-18	1983-08-18 00:00:00	1983-08-18	5001	0	\N	0	0	\N	\N	0	141989	0	8331-1	3006322		
16643	1516	3006322	1944-02-15	1944-02-15 00:00:00	1944-02-15	5001	0	\N	0	0	\N	\N	0	101348	0	8331-1	3006322		
625	40	3006322	2007-05-31	2007-05-31 00:00:00	2007-05-31	5001	0	\N	0	0	\N	\N	0	2835	0	8331-1	3006322		
34684	3176	3001247	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	211108	0	6085-5	3001247		
159858	4917	4024958	2015-09-16	2015-09-16 00:00:00	2015-09-16	5001	0	\N	0	0	\N	\N	0	326752	0	117015009	4024958		
15258	1399	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	93012	0	6085-5	3001247		
51914	4761	3020655	1993-05-10	1993-05-10 00:00:00	1993-05-10	5001	0	\N	0	0	\N	\N	0	317261	0	6844-5	3020655		
26685	2461	3006322	1981-12-16	1981-12-16 00:00:00	1981-12-16	5001	0	\N	0	0	\N	\N	0	163176	0	8331-1	3006322		
6053	185	4133840	2017-06-18	2017-06-18 00:00:00	2017-06-18	5001	0	\N	0	0	\N	\N	0	12580	0	127783003	4133840		
45274	4191	3006322	1981-10-03	1981-10-03 00:00:00	1981-10-03	5001	0	\N	0	0	\N	\N	0	278127	0	8331-1	3006322		
47738	4376	46235214	2013-02-23	2013-02-23 00:00:00	2013-02-23	5001	0	\N	0	0	\N	\N	0	290787	0	76690-7	46235214		
149202	4576	4024958	1965-02-05	1965-02-05 00:00:00	1965-02-05	5001	0	\N	0	0	\N	\N	0	304799	0	117015009	4024958		
30910	2830	3012494	1975-06-22	1975-06-22 00:00:00	1975-06-22	5001	0	\N	0	0	\N	\N	0	187706	0	6206-7	3012494		
171676	5267	4024958	1985-10-12	1985-10-12 00:00:00	1985-10-12	5001	0	\N	0	0	\N	\N	0	350429	0	117015009	4024958		
10086	959	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	63712	0	6085-5	3001247		
38340	3529	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	234436	0	6085-5	3001247		
93125	2866	4133840	2017-08-13	2017-08-13 00:00:00	2017-08-13	5001	0	\N	0	0	\N	\N	0	190694	0	127783003	4133840		
22996	2114	40758406	1997-02-18	1997-02-18 00:00:00	1997-02-18	5001	0	\N	0	0	\N	\N	0	140644	0	55277-8	40758406		
61012	1864	4133840	2015-12-04	2015-12-04 00:00:00	2015-12-04	5001	0	\N	0	0	\N	\N	0	124545	0	127783003	4133840		
145755	4475	4052083	1992-10-06	1992-10-06 00:00:00	1992-10-06	5001	0	\N	0	0	\N	\N	0	297738	0	23426006	4052083		
19031	1743	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	116534	0	6189-5	3006734		
2530	246	3006322	1962-11-12	1962-11-12 00:00:00	1962-11-12	5001	0	\N	0	0	\N	\N	0	16518	0	8331-1	3006322		
55589	5103	3006322	1946-08-29	1946-08-29 00:00:00	1946-08-29	5001	0	\N	0	0	\N	\N	0	339060	0	8331-1	3006322		
1275	101	3006322	2007-01-22	2007-01-22 00:00:00	2007-01-22	5001	0	\N	0	0	\N	\N	0	6913	0	8331-1	3006322		
96107	2945	4133840	1986-10-21	1986-10-21 00:00:00	1986-10-21	5001	0	\N	0	0	\N	\N	0	196511	0	127783003	4133840		
42023	3885	3006322	1967-06-05	1967-06-05 00:00:00	1967-06-05	5001	0	\N	0	0	\N	\N	0	258281	0	8331-1	3006322		
75786	2327	4024958	1976-07-20	1976-07-20 00:00:00	1976-07-20	5001	0	\N	0	0	\N	\N	0	154777	0	117015009	4024958		
33556	3041	3006451	1978-08-06	1978-08-06 00:00:00	1978-08-06	5001	0	\N	0	0	\N	\N	0	202463	0	6273-7	3006451		
4897	474	3006322	1976-02-14	1976-02-14 00:00:00	1976-02-14	5001	0	\N	0	0	\N	\N	0	31608	0	8331-1	3006322		
52095	4784	40758406	1950-08-29	1950-08-29 00:00:00	1950-08-29	5001	0	\N	0	0	\N	\N	0	318420	0	55277-8	40758406		
35727	3270	3006322	1983-05-16	1983-05-16 00:00:00	1983-05-16	5001	0	\N	0	0	\N	\N	0	217306	0	8331-1	3006322		
66232	2030	4052083	1974-04-29	1974-04-29 00:00:00	1974-04-29	5001	0	\N	0	0	\N	\N	0	135118	0	23426006	4052083		
11302	1088	3006322	1984-09-10	1984-09-10 00:00:00	1984-09-10	5001	0	\N	0	0	\N	\N	0	71460	0	8331-1	3006322		
11377	1091	40758406	1957-09-05	1957-09-05 00:00:00	1957-09-05	5001	0	\N	0	0	\N	\N	0	71674	0	55277-8	40758406		
14836	1378	3006322	1967-03-15	1967-03-15 00:00:00	1967-03-15	5001	0	\N	0	0	\N	\N	0	91294	0	8331-1	3006322		
21341	1971	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	130989	0	6246-3	3021226		
26256	2414	3006322	1961-12-27	1961-12-27 00:00:00	1961-12-27	5001	0	\N	0	0	\N	\N	0	160196	0	8331-1	3006322		
31047	2834	3051031	1991-05-06	1991-05-06 00:00:00	1991-05-06	5001	0	\N	0	0	\N	\N	0	188183	0	46240-8	3051031		
15809	1446	3006322	1987-10-12	1987-10-12 00:00:00	1987-10-12	5001	0	\N	0	0	\N	\N	0	96366	0	8331-1	3006322		
121382	3745	4133840	2008-08-20	2008-08-20 00:00:00	2008-08-20	5001	0	\N	0	0	\N	\N	0	248968	0	127783003	4133840		
13490	1276	3006322	1963-10-17	1963-10-17 00:00:00	1963-10-17	5001	0	\N	0	0	\N	\N	0	84141	0	8331-1	3006322		
57186	5252	3011505	2016-05-24	2016-05-24 00:00:00	2016-05-24	5001	0	\N	0	0	\N	\N	0	349477	0	19926-5	3011505		
9067	864	3006322	1974-10-07	1974-10-07 00:00:00	1974-10-07	5001	0	\N	0	0	\N	\N	0	57234	0	8331-1	3006322		
12404	1176	3051031	2012-07-28	2012-07-28 00:00:00	2012-07-28	5001	0	\N	0	0	\N	\N	0	77712	0	46240-8	3051031		
39172	3622	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	240803	0	6095-4	3036780		
50197	4578	3006322	2005-11-14	2005-11-14 00:00:00	2005-11-14	5001	0	\N	0	0	\N	\N	0	304966	0	8331-1	3006322		
14916	1382	3006322	1997-01-25	1997-01-25 00:00:00	1997-01-25	5001	0	\N	0	0	\N	\N	0	91633	0	8331-1	3006322		
121345	3745	4133840	2014-09-24	2014-09-24 00:00:00	2014-09-24	5001	0	\N	0	0	\N	\N	0	248974	0	127783003	4133840		
145120	4452	4024958	1962-07-29	1962-07-29 00:00:00	1962-07-29	5001	0	\N	0	0	\N	\N	0	296210	0	117015009	4024958		
18631	1716	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	114632	0	6833-8	3023430		
18736	1724	3000963	2016-08-26	2016-08-26 00:00:00	2016-08-26	5001	0	\N	0	0	\N	\N	0	115252	0	718-7	3000963		
57721	5295	3006322	1985-08-06	1985-08-06 00:00:00	1985-08-06	5001	0	\N	0	0	\N	\N	0	352244	0	8331-1	3006322		
16717	1526	40758406	1978-04-27	1978-04-27 00:00:00	1978-04-27	5001	0	\N	0	0	\N	\N	0	102077	0	55277-8	40758406		
57474	1753	4052083	1988-06-02	1988-06-02 00:00:00	1988-06-02	5001	0	\N	0	0	\N	\N	0	117214	0	23426006	4052083		
43187	3991	40766240	1977-09-16	1977-09-16 00:00:00	1977-09-16	5001	0	\N	0	0	\N	\N	0	265302	0	63513-6	40766240		
2150	192	3006322	2018-05-19	2018-05-19 00:00:00	2018-05-19	5001	0	\N	0	0	\N	\N	0	13210	0	8331-1	3006322		
54617	4991	3006322	2005-07-08	2005-07-08 00:00:00	2005-07-08	5001	0	\N	0	0	\N	\N	0	332023	0	8331-1	3006322		
22446	2058	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	136841	0	6276-0	3027231		
26069	2394	3049273	1988-01-06	1988-01-06 00:00:00	1988-01-06	5001	0	\N	0	0	\N	\N	0	159215	0	38265-5	3049273		
1133	94	3006322	2004-12-08	2004-12-08 00:00:00	2004-12-08	5001	0	\N	0	0	\N	\N	0	6358	0	8331-1	3006322		
23178	2135	3006322	1967-02-16	1967-02-16 00:00:00	1967-02-16	5001	0	\N	0	0	\N	\N	0	142071	0	8331-1	3006322		
16644	1516	3006322	1945-12-15	1945-12-15 00:00:00	1945-12-15	5001	0	\N	0	0	\N	\N	0	101241	0	8331-1	3006322		
61420	1878	4024958	1990-03-12	1990-03-12 00:00:00	1990-03-12	5001	0	\N	0	0	\N	\N	0	125321	0	117015009	4024958		
34685	3176	3021226	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	211108	0	6246-3	3021226		
159859	4917	4024958	1991-01-22	1991-01-22 00:00:00	1991-01-22	5001	0	\N	0	0	\N	\N	0	326757	0	117015009	4024958		
15259	1399	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	93012	0	7258-7	3001488		
51915	4761	3006734	1993-05-10	1993-05-10 00:00:00	1993-05-10	5001	0	\N	0	0	\N	\N	0	317261	0	6189-5	3006734		
26686	2461	3006322	1984-03-15	1984-03-15 00:00:00	1984-03-15	5001	0	\N	0	0	\N	\N	0	163180	0	8331-1	3006322		
6068	186	4024958	2012-11-28	2012-11-28 00:00:00	2012-11-28	5001	0	\N	0	0	\N	\N	0	12599	0	117015009	4024958		
45275	4191	3006322	1958-11-10	1958-11-10 00:00:00	1958-11-10	5001	0	\N	0	0	\N	\N	0	278123	0	8331-1	3006322		
47739	4376	40766240	2013-02-23	2013-02-23 00:00:00	2013-02-23	5001	0	\N	0	0	\N	\N	0	290787	0	63513-6	40766240		
149206	4576	4052083	1963-04-02	1963-04-02 00:00:00	1963-04-02	5001	0	\N	0	0	\N	\N	0	304828	0	23426006	4052083		
30911	2830	3036780	1975-06-22	1975-06-22 00:00:00	1975-06-22	5001	0	\N	0	0	\N	\N	0	187706	0	6095-4	3036780		
57325	1750	4052083	2017-11-03	2017-11-03 00:00:00	2017-11-03	5001	0	\N	0	0	\N	\N	0	117021	0	23426006	4052083		
10087	959	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	63712	0	7258-7	3001488		
38341	3529	3006322	1947-08-13	1947-08-13 00:00:00	1947-08-13	5001	0	\N	0	0	\N	\N	0	234300	0	8331-1	3006322		
93128	2866	4133840	2006-08-13	2006-08-13 00:00:00	2006-08-13	5001	0	\N	0	0	\N	\N	0	190648	0	127783003	4133840		
22997	2114	3051031	1997-02-18	1997-02-18 00:00:00	1997-02-18	5001	0	\N	0	0	\N	\N	0	140644	0	46240-8	3051031		
61015	1864	4133840	2009-12-18	2009-12-18 00:00:00	2009-12-18	5001	0	\N	0	0	\N	\N	0	124529	0	127783003	4133840		
19032	1743	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	116534	0	6095-4	3036780		
2531	246	3011505	2013-05-16	2013-05-16 00:00:00	2013-05-16	5001	0	\N	0	0	\N	\N	0	16569	0	19926-5	3011505		
55590	5103	3006322	1967-05-23	1967-05-23 00:00:00	1967-05-23	5001	0	\N	0	0	\N	\N	0	339095	0	8331-1	3006322		
1276	101	3049273	2014-07-21	2014-07-21 00:00:00	2014-07-21	5001	0	\N	0	0	\N	\N	0	6944	0	38265-5	3049273		
96108	2945	4133840	2012-01-31	2012-01-31 00:00:00	2012-01-31	5001	0	\N	0	0	\N	\N	0	196519	0	127783003	4133840		
64379	1977	4024958	1988-05-20	1988-05-20 00:00:00	1988-05-20	5001	0	\N	0	0	\N	\N	0	131560	0	117015009	4024958		
31959	986	4024958	1923-07-28	1923-07-28 00:00:00	1923-07-28	5001	0	\N	0	0	\N	\N	0	65457	0	117015009	4024958		
33557	3041	3027231	1978-08-06	1978-08-06 00:00:00	1978-08-06	5001	0	\N	0	0	\N	\N	0	202463	0	6276-0	3027231		
4898	474	3006322	1982-12-04	1982-12-04 00:00:00	1982-12-04	5001	0	\N	0	0	\N	\N	0	31646	0	8331-1	3006322		
52096	4784	46235214	1950-08-29	1950-08-29 00:00:00	1950-08-29	5001	0	\N	0	0	\N	\N	0	318420	0	76690-7	46235214		
35728	3270	3006322	1984-01-24	1984-01-24 00:00:00	1984-01-24	5001	0	\N	0	0	\N	\N	0	217252	0	8331-1	3006322		
66233	2030	4024958	1978-12-24	1978-12-24 00:00:00	1978-12-24	5001	0	\N	0	0	\N	\N	0	135119	0	117015009	4024958		
11303	1088	3006322	1975-08-18	1975-08-18 00:00:00	1975-08-18	5001	0	\N	0	0	\N	\N	0	71451	0	8331-1	3006322		
11378	1091	40766240	1957-09-05	1957-09-05 00:00:00	1957-09-05	5001	0	\N	0	0	\N	\N	0	71674	0	63513-6	40766240		
14837	1378	3020655	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	91332	0	6844-5	3020655		
21342	1971	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	130989	0	6844-5	3020655		
26257	2414	3006322	1964-11-23	1964-11-23 00:00:00	1964-11-23	5001	0	\N	0	0	\N	\N	0	160169	0	8331-1	3006322		
31049	2834	40766240	1990-11-07	1990-11-07 00:00:00	1990-11-07	5001	0	\N	0	0	\N	\N	0	188181	0	63513-6	40766240		
15810	1446	3006322	2010-09-11	2010-09-11 00:00:00	2010-09-11	5001	0	\N	0	0	\N	\N	0	96361	0	8331-1	3006322		
121384	3745	4133840	2004-07-28	2004-07-28 00:00:00	2004-07-28	5001	0	\N	0	0	\N	\N	0	248893	0	127783003	4133840		
13491	1276	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	84174	0	6206-7	3012494		
57187	5252	3011505	2014-05-13	2014-05-13 00:00:00	2014-05-13	5001	0	\N	0	0	\N	\N	0	349476	0	19926-5	3011505		
9068	864	3006322	1949-08-25	1949-08-25 00:00:00	1949-08-25	5001	0	\N	0	0	\N	\N	0	57297	0	8331-1	3006322		
12405	1176	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	77590	0	6844-5	3020655		
39173	3622	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	240803	0	6082-2	3000876		
50198	4578	40766240	1965-08-22	1965-08-22 00:00:00	1965-08-22	5001	0	\N	0	0	\N	\N	0	304942	0	63513-6	40766240		
14917	1382	3006322	1992-12-05	1992-12-05 00:00:00	1992-12-05	5001	0	\N	0	0	\N	\N	0	91644	0	8331-1	3006322		
121352	3745	4133840	2007-08-15	2007-08-15 00:00:00	2007-08-15	5001	0	\N	0	0	\N	\N	0	248962	0	127783003	4133840		
122354	3773	4024958	1968-02-11	1968-02-11 00:00:00	1968-02-11	5001	0	\N	0	0	\N	\N	0	250804	0	117015009	4024958		
18632	1716	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	114632	0	6189-5	3006734		
18737	1724	3006322	1997-03-15	1997-03-15 00:00:00	1997-03-15	5001	0	\N	0	0	\N	\N	0	115300	0	8331-1	3006322		
57722	5295	3049273	1977-12-13	1977-12-13 00:00:00	1977-12-13	5001	0	\N	0	0	\N	\N	0	352212	0	38265-5	3049273		
16719	1526	40766240	1978-04-27	1978-04-27 00:00:00	1978-04-27	5001	0	\N	0	0	\N	\N	0	102077	0	63513-6	40766240		
57475	1753	4024958	1976-03-31	1976-03-31 00:00:00	1976-03-31	5001	0	\N	0	0	\N	\N	0	117212	0	117015009	4024958		
43188	3991	3051031	1977-09-16	1977-09-16 00:00:00	1977-09-16	5001	0	\N	0	0	\N	\N	0	265302	0	46240-8	3051031		
2151	192	3006322	1998-02-22	1998-02-22 00:00:00	1998-02-22	5001	0	\N	0	0	\N	\N	0	13186	0	8331-1	3006322		
54618	4991	3006322	1973-06-01	1973-06-01 00:00:00	1973-06-01	5001	0	\N	0	0	\N	\N	0	332027	0	8331-1	3006322		
22447	2058	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	136841	0	6833-8	3023430		
26070	2394	3006322	1973-06-18	1973-06-18 00:00:00	1973-06-18	5001	0	\N	0	0	\N	\N	0	159138	0	8331-1	3006322		
1134	94	40766240	1953-07-26	1953-07-26 00:00:00	1953-07-26	5001	0	\N	0	0	\N	\N	0	6341	0	63513-6	40766240		
23179	2135	40769194	1968-02-10	1968-02-10 00:00:00	1968-02-10	5001	0	\N	0	0	\N	\N	0	142127	0	66534-9	40769194		
16646	1516	3006322	1982-06-15	1982-06-15 00:00:00	1982-06-15	5001	0	\N	0	0	\N	\N	0	101337	0	8331-1	3006322		
61424	1879	4024958	2019-04-24	2019-04-24 00:00:00	2019-04-24	5001	0	\N	0	0	\N	\N	0	125403	0	117015009	4024958		
34686	3176	3005136	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	211108	0	6075-6	3005136		
159869	4917	4024958	1996-04-04	1996-04-04 00:00:00	1996-04-04	5001	0	\N	0	0	\N	\N	0	326758	0	117015009	4024958		
15260	1399	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	93012	0	6095-4	3036780		
51916	4761	3023430	1993-05-10	1993-05-10 00:00:00	1993-05-10	5001	0	\N	0	0	\N	\N	0	317261	0	6833-8	3023430		
26687	2461	3006322	1984-04-23	1984-04-23 00:00:00	1984-04-23	5001	0	\N	0	0	\N	\N	0	163181	0	8331-1	3006322		
32641	1017	4024958	1997-07-22	1997-07-22 00:00:00	1997-07-22	5001	0	\N	0	0	\N	\N	0	67007	0	117015009	4024958		
45276	4191	3006322	1962-03-21	1962-03-21 00:00:00	1962-03-21	5001	0	\N	0	0	\N	\N	0	278150	0	8331-1	3006322		
3665	114	4052083	1999-11-18	1999-11-18 00:00:00	1999-11-18	5001	0	\N	0	0	\N	\N	0	7517	0	23426006	4052083		
149209	4576	4052083	1955-10-23	1955-10-23 00:00:00	1955-10-23	5001	0	\N	0	0	\N	\N	0	304852	0	23426006	4052083		
30912	2830	3021226	1975-06-22	1975-06-22 00:00:00	1975-06-22	5001	0	\N	0	0	\N	\N	0	187706	0	6246-3	3021226		
57331	1750	4024958	2006-09-11	2006-09-11 00:00:00	2006-09-11	5001	0	\N	0	0	\N	\N	0	117020	0	117015009	4024958		
10088	959	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	63712	0	6189-5	3006734		
38342	3529	3006322	1962-03-14	1962-03-14 00:00:00	1962-03-14	5001	0	\N	0	0	\N	\N	0	234302	0	8331-1	3006322		
93134	2866	4133840	2015-07-19	2015-07-19 00:00:00	2015-07-19	5001	0	\N	0	0	\N	\N	0	190643	0	127783003	4133840		
22998	2115	3006322	2010-08-12	2010-08-12 00:00:00	2010-08-12	5001	0	\N	0	0	\N	\N	0	140753	0	8331-1	3006322		
61016	1864	4133840	2013-12-27	2013-12-27 00:00:00	2013-12-27	5001	0	\N	0	0	\N	\N	0	124544	0	127783003	4133840		
19033	1743	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	116534	0	6833-8	3023430		
2532	246	3006322	1984-12-03	1984-12-03 00:00:00	1984-12-03	5001	0	\N	0	0	\N	\N	0	16589	0	8331-1	3006322		
55591	5103	3009542	1984-09-30	1984-09-30 00:00:00	1984-09-30	5001	0	\N	0	0	\N	\N	0	339107	0	20570-8	3009542		
1277	102	3006322	1991-03-22	1991-03-22 00:00:00	1991-03-22	5001	0	\N	0	0	\N	\N	0	6962	0	8331-1	3006322		
96110	2945	4133840	2009-01-13	2009-01-13 00:00:00	2009-01-13	5001	0	\N	0	0	\N	\N	0	196490	0	127783003	4133840		
64391	1977	4024958	1917-11-18	1917-11-18 00:00:00	1917-11-18	5001	0	\N	0	0	\N	\N	0	131572	0	117015009	4024958		
31960	986	4024958	1940-01-03	1940-01-03 00:00:00	1940-01-03	5001	0	\N	0	0	\N	\N	0	65448	0	117015009	4024958		
33558	3041	3019406	1978-08-06	1978-08-06 00:00:00	1978-08-06	5001	0	\N	0	0	\N	\N	0	202463	0	6158-0	3019406		
4899	474	3006322	2002-03-03	2002-03-03 00:00:00	2002-03-03	5001	0	\N	0	0	\N	\N	0	31654	0	8331-1	3006322		
52097	4784	40758406	1950-01-31	1950-01-31 00:00:00	1950-01-31	5001	0	\N	0	0	\N	\N	0	318496	0	55277-8	40758406		
35729	3270	3006322	1976-04-25	1976-04-25 00:00:00	1976-04-25	5001	0	\N	0	0	\N	\N	0	217300	0	8331-1	3006322		
66236	2030	4024958	1987-12-20	1987-12-20 00:00:00	1987-12-20	5001	0	\N	0	0	\N	\N	0	135140	0	117015009	4024958		
11304	1088	3006322	2008-10-31	2008-10-31 00:00:00	2008-10-31	5001	0	\N	0	0	\N	\N	0	71410	0	8331-1	3006322		
11379	1091	3006322	1967-09-23	1967-09-23 00:00:00	1967-09-23	5001	0	\N	0	0	\N	\N	0	71678	0	8331-1	3006322		
14838	1378	3001488	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	91332	0	7258-7	3001488		
21343	1971	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	130989	0	6075-6	3005136		
26259	2414	3049273	1933-04-29	1933-04-29 00:00:00	1933-04-29	5001	0	\N	0	0	\N	\N	0	160249	0	38265-5	3049273		
31050	2834	46235214	1990-11-07	1990-11-07 00:00:00	1990-11-07	5001	0	\N	0	0	\N	\N	0	188181	0	76690-7	46235214		
15811	1446	3006322	1993-05-22	1993-05-22 00:00:00	1993-05-22	5001	0	\N	0	0	\N	\N	0	96362	0	8331-1	3006322		
121390	3745	4133840	1993-05-26	1993-05-26 00:00:00	1993-05-26	5001	0	\N	0	0	\N	\N	0	248891	0	127783003	4133840		
13492	1276	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	84174	0	6276-0	3027231		
57188	5252	3011505	2006-04-18	2006-04-18 00:00:00	2006-04-18	5001	0	\N	0	0	\N	\N	0	349480	0	19926-5	3011505		
9069	864	3006322	1973-01-01	1973-01-01 00:00:00	1973-01-01	5001	0	\N	0	0	\N	\N	0	57312	0	8331-1	3006322		
12406	1176	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	77590	0	6095-4	3036780		
39174	3622	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	240803	0	6075-6	3005136		
50199	4578	46235214	1965-08-22	1965-08-22 00:00:00	1965-08-22	5001	0	\N	0	0	\N	\N	0	304942	0	76690-7	46235214		
14918	1382	3006322	2007-08-17	2007-08-17 00:00:00	2007-08-17	5001	0	\N	0	0	\N	\N	0	91665	0	8331-1	3006322		
121354	3745	4133840	2000-07-05	2000-07-05 00:00:00	2000-07-05	5001	0	\N	0	0	\N	\N	0	248961	0	127783003	4133840		
122419	3776	4052083	2006-10-08	2006-10-08 00:00:00	2006-10-08	5001	0	\N	0	0	\N	\N	0	250984	0	23426006	4052083		
18633	1716	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	114632	0	6082-2	3000876		
18738	1724	3006322	2013-04-29	2013-04-29 00:00:00	2013-04-29	5001	0	\N	0	0	\N	\N	0	115281	0	8331-1	3006322		
57724	5295	3006322	1917-02-12	1917-02-12 00:00:00	1917-02-12	5001	0	\N	0	0	\N	\N	0	352270	0	8331-1	3006322		
16720	1526	3051031	1978-04-27	1978-04-27 00:00:00	1978-04-27	5001	0	\N	0	0	\N	\N	0	102077	0	46240-8	3051031		
57486	1755	4052083	2006-05-27	2006-05-27 00:00:00	2006-05-27	5001	0	\N	0	0	\N	\N	0	117387	0	23426006	4052083		
43190	3991	40758406	1977-09-16	1977-09-16 00:00:00	1977-09-16	5001	0	\N	0	0	\N	\N	0	265302	0	55277-8	40758406		
2152	192	3006322	1944-12-24	1944-12-24 00:00:00	1944-12-24	5001	0	\N	0	0	\N	\N	0	13180	0	8331-1	3006322		
54619	4991	40769184	1997-07-13	1997-07-13 00:00:00	1997-07-13	5001	0	\N	0	0	\N	\N	0	332032	0	66524-0	40769184		
22448	2058	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	136841	0	6246-3	3021226		
26075	2394	3006322	1978-11-29	1978-11-29 00:00:00	1978-11-29	5001	0	\N	0	0	\N	\N	0	159121	0	8331-1	3006322		
1137	94	3051031	1953-07-26	1953-07-26 00:00:00	1953-07-26	5001	0	\N	0	0	\N	\N	0	6341	0	46240-8	3051031		
23180	2135	40769184	1968-02-10	1968-02-10 00:00:00	1968-02-10	5001	0	\N	0	0	\N	\N	0	142127	0	66524-0	40769184		
16647	1516	3006322	1948-06-17	1948-06-17 00:00:00	1948-06-17	5001	0	\N	0	0	\N	\N	0	101350	0	8331-1	3006322		
61438	1879	4024958	1984-02-05	1984-02-05 00:00:00	1984-02-05	5001	0	\N	0	0	\N	\N	0	125393	0	117015009	4024958		
34687	3176	3000876	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	211108	0	6082-2	3000876		
55437	5086	3006322	1980-12-27	1980-12-27 00:00:00	1980-12-27	5001	0	\N	0	0	\N	\N	0	338197	0	8331-1	3006322		
15261	1399	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	93012	0	6082-2	3000876		
51917	4761	3021226	1993-05-10	1993-05-10 00:00:00	1993-05-10	5001	0	\N	0	0	\N	\N	0	317261	0	6246-3	3021226		
26688	2461	3006322	1994-02-22	1994-02-22 00:00:00	1994-02-22	5001	0	\N	0	0	\N	\N	0	163178	0	8331-1	3006322		
32650	1017	4024958	1967-03-28	1967-03-28 00:00:00	1967-03-28	5001	0	\N	0	0	\N	\N	0	66952	0	117015009	4024958		
45277	4191	3006322	1989-11-19	1989-11-19 00:00:00	1989-11-19	5001	0	\N	0	0	\N	\N	0	278165	0	8331-1	3006322		
3673	115	4024958	1980-11-08	1980-11-08 00:00:00	1980-11-08	5001	0	\N	0	0	\N	\N	0	7568	0	117015009	4024958		
149221	4576	4024958	1970-03-21	1970-03-21 00:00:00	1970-03-21	5001	0	\N	0	0	\N	\N	0	304800	0	117015009	4024958		
30913	2830	3006451	1975-06-22	1975-06-22 00:00:00	1975-06-22	5001	0	\N	0	0	\N	\N	0	187706	0	6273-7	3006451		
57332	1750	4052083	2001-05-22	2001-05-22 00:00:00	2001-05-22	5001	0	\N	0	0	\N	\N	0	117019	0	23426006	4052083		
10089	959	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	63712	0	6844-5	3020655		
38343	3529	3006322	1957-12-22	1957-12-22 00:00:00	1957-12-22	5001	0	\N	0	0	\N	\N	0	234439	0	8331-1	3006322		
93137	2866	4024958	1992-05-30	1992-05-30 00:00:00	1992-05-30	5001	0	\N	0	0	\N	\N	0	190687	0	117015009	4024958		
22999	2116	3006322	1984-12-21	1984-12-21 00:00:00	1984-12-21	5001	0	\N	0	0	\N	\N	0	140804	0	8331-1	3006322		
61018	1864	4024958	1994-06-15	1994-06-15 00:00:00	1994-06-15	5001	0	\N	0	0	\N	\N	0	124555	0	117015009	4024958		
19034	1743	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	116534	0	6158-0	3019406		
2533	246	3011505	2000-09-07	2000-09-07 00:00:00	2000-09-07	5001	0	\N	0	0	\N	\N	0	16541	0	19926-5	3011505		
55592	5103	3000963	1984-09-30	1984-09-30 00:00:00	1984-09-30	5001	0	\N	0	0	\N	\N	0	339107	0	718-7	3000963		
1278	102	3006322	2014-08-02	2014-08-02 00:00:00	2014-08-02	5001	0	\N	0	0	\N	\N	0	6970	0	8331-1	3006322		
96113	2945	4133840	2011-01-25	2011-01-25 00:00:00	2011-01-25	5001	0	\N	0	0	\N	\N	0	196483	0	127783003	4133840		
64431	1977	4024958	1913-02-25	1913-02-25 00:00:00	1913-02-25	5001	0	\N	0	0	\N	\N	0	131554	0	117015009	4024958		
31980	986	4024958	1934-06-21	1934-06-21 00:00:00	1934-06-21	5001	0	\N	0	0	\N	\N	0	65506	0	117015009	4024958		
33559	3041	3012494	1978-08-06	1978-08-06 00:00:00	1978-08-06	5001	0	\N	0	0	\N	\N	0	202463	0	6206-7	3012494		
4900	474	3006322	1980-08-02	1980-08-02 00:00:00	1980-08-02	5001	0	\N	0	0	\N	\N	0	31601	0	8331-1	3006322		
52098	4784	40766240	1950-01-31	1950-01-31 00:00:00	1950-01-31	5001	0	\N	0	0	\N	\N	0	318496	0	63513-6	40766240		
35736	3272	3006322	1979-07-26	1979-07-26 00:00:00	1979-07-26	5001	0	\N	0	0	\N	\N	0	217467	0	8331-1	3006322		
41025	1272	4024958	2010-01-13	2010-01-13 00:00:00	2010-01-13	5001	0	\N	0	0	\N	\N	0	83953	0	117015009	4024958		
11305	1088	3006322	2005-08-24	2005-08-24 00:00:00	2005-08-24	5001	0	\N	0	0	\N	\N	0	71447	0	8331-1	3006322		
11380	1091	3006322	1961-12-12	1961-12-12 00:00:00	1961-12-12	5001	0	\N	0	0	\N	\N	0	71688	0	8331-1	3006322		
14839	1378	3006451	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	91332	0	6273-7	3006451		
21344	1971	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	130989	0	6082-2	3000876		
26286	2418	3006322	2011-04-30	2011-04-30 00:00:00	2011-04-30	5001	0	\N	0	0	\N	\N	0	160445	0	8331-1	3006322		
31053	2834	40758406	1990-11-07	1990-11-07 00:00:00	1990-11-07	5001	0	\N	0	0	\N	\N	0	188181	0	55277-8	40758406		
15812	1446	3006322	2002-04-01	2002-04-01 00:00:00	2002-04-01	5001	0	\N	0	0	\N	\N	0	96365	0	8331-1	3006322		
121392	3745	4133840	2001-07-11	2001-07-11 00:00:00	2001-07-11	5001	0	\N	0	0	\N	\N	0	248871	0	127783003	4133840		
13493	1276	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	84174	0	6085-5	3001247		
57189	5252	3006322	1967-03-19	1967-03-19 00:00:00	1967-03-19	5001	0	\N	0	0	\N	\N	0	349442	0	8331-1	3006322		
9070	864	3006322	1956-11-27	1956-11-27 00:00:00	1956-11-27	5001	0	\N	0	0	\N	\N	0	57299	0	8331-1	3006322		
12407	1176	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	77590	0	6085-5	3001247		
39175	3622	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	240803	0	6246-3	3021226		
50201	4578	3051031	1965-08-22	1965-08-22 00:00:00	1965-08-22	5001	0	\N	0	0	\N	\N	0	304942	0	46240-8	3051031		
14922	1384	3006322	2015-04-23	2015-04-23 00:00:00	2015-04-23	5001	0	\N	0	0	\N	\N	0	91790	0	8331-1	3006322		
121356	3745	4133840	2013-09-18	2013-09-18 00:00:00	2013-09-18	5001	0	\N	0	0	\N	\N	0	248965	0	127783003	4133840		
122426	3776	4024958	2008-01-23	2008-01-23 00:00:00	2008-01-23	5001	0	\N	0	0	\N	\N	0	250985	0	117015009	4024958		
18634	1716	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	114632	0	6095-4	3036780		
18739	1724	3006322	2016-07-23	2016-07-23 00:00:00	2016-07-23	5001	0	\N	0	0	\N	\N	0	115244	0	8331-1	3006322		
57725	5295	3049273	1990-08-08	1990-08-08 00:00:00	1990-08-08	5001	0	\N	0	0	\N	\N	0	352293	0	38265-5	3049273		
57147	1743	4052083	2012-06-21	2012-06-21 00:00:00	2012-06-21	5001	0	\N	0	0	\N	\N	0	116552	0	23426006	4052083		
57498	1755	4024958	1963-11-24	1963-11-24 00:00:00	1963-11-24	5001	0	\N	0	0	\N	\N	0	117382	0	117015009	4024958		
43192	3991	46235214	1977-09-16	1977-09-16 00:00:00	1977-09-16	5001	0	\N	0	0	\N	\N	0	265302	0	76690-7	46235214		
2153	192	3006322	2015-11-16	2015-11-16 00:00:00	2015-11-16	5001	0	\N	0	0	\N	\N	0	13233	0	8331-1	3006322		
54620	4991	40769194	1997-07-13	1997-07-13 00:00:00	1997-07-13	5001	0	\N	0	0	\N	\N	0	332032	0	66534-9	40769194		
168839	5184	4024958	1973-02-03	1973-02-03 00:00:00	1973-02-03	5001	0	\N	0	0	\N	\N	0	344579	0	117015009	4024958		
26076	2394	3006322	1919-01-23	1919-01-23 00:00:00	1919-01-23	5001	0	\N	0	0	\N	\N	0	159147	0	8331-1	3006322		
1138	94	40758406	1953-07-26	1953-07-26 00:00:00	1953-07-26	5001	0	\N	0	0	\N	\N	0	6341	0	55277-8	40758406		
23181	2135	40769189	1968-02-10	1968-02-10 00:00:00	1968-02-10	5001	0	\N	0	0	\N	\N	0	142127	0	66529-9	40769189		
27925	2566	3051031	2017-03-28	2017-03-28 00:00:00	2017-03-28	5001	0	\N	0	0	\N	\N	0	169994	0	46240-8	3051031		
61440	1879	4024958	1961-05-23	1961-05-23 00:00:00	1961-05-23	5001	0	\N	0	0	\N	\N	0	125433	0	117015009	4024958		
34688	3176	3014599	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	211108	0	6106-9	3014599		
55438	5086	3006322	1980-02-16	1980-02-16 00:00:00	1980-02-16	5001	0	\N	0	0	\N	\N	0	338196	0	8331-1	3006322		
15262	1399	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	93012	0	6844-5	3020655		
51918	4761	3019406	1993-05-10	1993-05-10 00:00:00	1993-05-10	5001	0	\N	0	0	\N	\N	0	317261	0	6158-0	3019406		
26689	2462	3006322	2018-05-23	2018-05-23 00:00:00	2018-05-23	5001	0	\N	0	0	\N	\N	0	163309	0	8331-1	3006322		
32658	1017	4052083	1971-03-11	1971-03-11 00:00:00	1971-03-11	5001	0	\N	0	0	\N	\N	0	66928	0	23426006	4052083		
56565	5194	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	345299	0	6158-0	3019406		
3677	115	4024958	1961-05-26	1961-05-26 00:00:00	1961-05-26	5001	0	\N	0	0	\N	\N	0	7570	0	117015009	4024958		
149224	4576	4024958	1986-01-12	1986-01-12 00:00:00	1986-01-12	5001	0	\N	0	0	\N	\N	0	304786	0	117015009	4024958		
30914	2830	3015076	1975-06-22	1975-06-22 00:00:00	1975-06-22	5001	0	\N	0	0	\N	\N	0	187706	0	6248-9	3015076		
57339	1750	4024958	1979-07-20	1979-07-20 00:00:00	1979-07-20	5001	0	\N	0	0	\N	\N	0	117031	0	117015009	4024958		
10090	959	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	63712	0	6833-8	3023430		
38344	3529	3006322	1957-05-13	1957-05-13 00:00:00	1957-05-13	5001	0	\N	0	0	\N	\N	0	234319	0	8331-1	3006322		
93145	2867	4024958	1989-06-19	1989-06-19 00:00:00	1989-06-19	5001	0	\N	0	0	\N	\N	0	190742	0	117015009	4024958		
23000	2116	3006322	1979-12-05	1979-12-05 00:00:00	1979-12-05	5001	0	\N	0	0	\N	\N	0	140794	0	8331-1	3006322		
38436	1193	4024958	1987-01-05	1987-01-05 00:00:00	1987-01-05	5001	0	\N	0	0	\N	\N	0	78643	0	117015009	4024958		
19035	1743	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	116534	0	6276-0	3027231		
2534	246	3011505	2003-04-10	2003-04-10 00:00:00	2003-04-10	5001	0	\N	0	0	\N	\N	0	16542	0	19926-5	3011505		
55593	5104	3006322	2005-06-19	2005-06-19 00:00:00	2005-06-19	5001	0	\N	0	0	\N	\N	0	339186	0	8331-1	3006322		
1279	103	3006322	1979-07-11	1979-07-11 00:00:00	1979-07-11	5001	0	\N	0	0	\N	\N	0	7044	0	8331-1	3006322		
96118	2945	4133840	1973-12-04	1973-12-04 00:00:00	1973-12-04	5001	0	\N	0	0	\N	\N	0	196508	0	127783003	4133840		
9394	297	4024958	2015-09-16	2015-09-16 00:00:00	2015-09-16	5001	0	\N	0	0	\N	\N	0	19782	0	117015009	4024958		
31988	986	4052083	1932-02-09	1932-02-09 00:00:00	1932-02-09	5001	0	\N	0	0	\N	\N	0	65477	0	23426006	4052083		
33560	3041	3021226	1978-08-06	1978-08-06 00:00:00	1978-08-06	5001	0	\N	0	0	\N	\N	0	202463	0	6246-3	3021226		
4903	476	3006322	2015-02-11	2015-02-11 00:00:00	2015-02-11	5001	0	\N	0	0	\N	\N	0	31751	0	8331-1	3006322		
52101	4784	3051031	1950-01-31	1950-01-31 00:00:00	1950-01-31	5001	0	\N	0	0	\N	\N	0	318496	0	46240-8	3051031		
35737	3272	3006322	1982-11-17	1982-11-17 00:00:00	1982-11-17	5001	0	\N	0	0	\N	\N	0	217440	0	8331-1	3006322		
124542	3849	4024958	1975-08-02	1975-08-02 00:00:00	1975-08-02	5001	0	\N	0	0	\N	\N	0	255406	0	117015009	4024958		
11381	1091	3006322	2017-02-26	2017-02-26 00:00:00	2017-02-26	5001	0	\N	0	0	\N	\N	0	71650	0	8331-1	3006322		
14840	1378	3015076	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	91332	0	6248-9	3015076		
21345	1971	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	130989	0	6106-9	3014599		
26287	2418	3006322	1983-04-19	1983-04-19 00:00:00	1983-04-19	5001	0	\N	0	0	\N	\N	0	160419	0	8331-1	3006322		
31054	2834	3051031	1990-11-07	1990-11-07 00:00:00	1990-11-07	5001	0	\N	0	0	\N	\N	0	188181	0	46240-8	3051031		
15813	1446	3021226	1984-09-08	1984-09-08 00:00:00	1984-09-08	5001	0	\N	0	0	\N	\N	0	96389	0	6246-3	3021226		
121396	3745	4133840	2009-08-26	2009-08-26 00:00:00	2009-08-26	5001	0	\N	0	0	\N	\N	0	248963	0	127783003	4133840		
13494	1276	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	84174	0	6189-5	3006734		
57190	5252	3011505	2018-06-05	2018-06-05 00:00:00	2018-06-05	5001	0	\N	0	0	\N	\N	0	349481	0	19926-5	3011505		
9072	864	3006322	1927-12-01	1927-12-01 00:00:00	1927-12-01	5001	0	\N	0	0	\N	\N	0	57272	0	8331-1	3006322		
12408	1176	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	77590	0	7258-7	3001488		
39176	3622	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	240803	0	6248-9	3015076		
50203	4578	40758406	1965-08-22	1965-08-22 00:00:00	1965-08-22	5001	0	\N	0	0	\N	\N	0	304942	0	55277-8	40758406		
14923	1384	3006322	2002-03-22	2002-03-22 00:00:00	2002-03-22	5001	0	\N	0	0	\N	\N	0	91730	0	8331-1	3006322		
121359	3745	4052083	2003-12-03	2003-12-03 00:00:00	2003-12-03	5001	0	\N	0	0	\N	\N	0	248915	0	23426006	4052083		
122433	3776	4024958	2003-12-03	2003-12-03 00:00:00	2003-12-03	5001	0	\N	0	0	\N	\N	0	250948	0	117015009	4024958		
18635	1716	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	114632	0	6085-5	3001247		
18740	1724	3006322	1953-01-10	1953-01-10 00:00:00	1953-01-10	5001	0	\N	0	0	\N	\N	0	115240	0	8331-1	3006322		
57727	5295	3049273	1971-02-18	1971-02-18 00:00:00	1971-02-18	5001	0	\N	0	0	\N	\N	0	352210	0	38265-5	3049273		
57150	1744	4024958	2006-11-13	2006-11-13 00:00:00	2006-11-13	5001	0	\N	0	0	\N	\N	0	116619	0	117015009	4024958		
57500	1755	4024958	2000-04-21	2000-04-21 00:00:00	2000-04-21	5001	0	\N	0	0	\N	\N	0	117386	0	117015009	4024958		
43193	3991	3006322	1981-08-23	1981-08-23 00:00:00	1981-08-23	5001	0	\N	0	0	\N	\N	0	265343	0	8331-1	3006322		
2157	194	3006322	1991-11-11	1991-11-11 00:00:00	1991-11-11	5001	0	\N	0	0	\N	\N	0	13301	0	8331-1	3006322		
54621	4991	40769189	1997-07-13	1997-07-13 00:00:00	1997-07-13	5001	0	\N	0	0	\N	\N	0	332032	0	66529-9	40769189		
168865	5185	4024958	1949-10-25	1949-10-25 00:00:00	1949-10-25	5001	0	\N	0	0	\N	\N	0	344648	0	117015009	4024958		
26078	2394	3049273	1979-10-20	1979-10-20 00:00:00	1979-10-20	5001	0	\N	0	0	\N	\N	0	159214	0	38265-5	3049273		
1139	94	46235214	1953-07-26	1953-07-26 00:00:00	1953-07-26	5001	0	\N	0	0	\N	\N	0	6341	0	76690-7	46235214		
23182	2135	40769179	1968-02-10	1968-02-10 00:00:00	1968-02-10	5001	0	\N	0	0	\N	\N	0	142127	0	66519-0	40769179		
27926	2566	40766240	2017-03-28	2017-03-28 00:00:00	2017-03-28	5001	0	\N	0	0	\N	\N	0	169994	0	63513-6	40766240		
38852	1211	4052083	1992-01-31	1992-01-31 00:00:00	1992-01-31	5001	0	\N	0	0	\N	\N	0	79652	0	23426006	4052083		
34689	3176	3019406	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	211108	0	6158-0	3019406		
55439	5086	3006322	2018-07-25	2018-07-25 00:00:00	2018-07-25	5001	0	\N	0	0	\N	\N	0	338140	0	8331-1	3006322		
15263	1399	3006322	1978-08-08	1978-08-08 00:00:00	1978-08-08	5001	0	\N	0	0	\N	\N	0	92995	0	8331-1	3006322		
51919	4761	3001488	1993-05-10	1993-05-10 00:00:00	1993-05-10	5001	0	\N	0	0	\N	\N	0	317261	0	7258-7	3001488		
26690	2462	3015076	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	163320	0	6248-9	3015076		
32659	1017	4024958	1995-10-09	1995-10-09 00:00:00	1995-10-09	5001	0	\N	0	0	\N	\N	0	67006	0	117015009	4024958		
56566	5194	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	345299	0	6206-7	3012494		
3680	115	4052083	1997-10-13	1997-10-13 00:00:00	1997-10-13	5001	0	\N	0	0	\N	\N	0	7575	0	23426006	4052083		
149225	4576	4052083	1956-03-30	1956-03-30 00:00:00	1956-03-30	5001	0	\N	0	0	\N	\N	0	304784	0	23426006	4052083		
30915	2830	3019406	1975-06-22	1975-06-22 00:00:00	1975-06-22	5001	0	\N	0	0	\N	\N	0	187706	0	6158-0	3019406		
57342	1751	4052083	2017-05-24	2017-05-24 00:00:00	2017-05-24	5001	0	\N	0	0	\N	\N	0	117051	0	23426006	4052083		
10091	959	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	63712	0	6082-2	3000876		
38345	3529	3006322	1972-01-04	1972-01-04 00:00:00	1972-01-04	5001	0	\N	0	0	\N	\N	0	234396	0	8331-1	3006322		
93149	2867	4052083	2003-10-05	2003-10-05 00:00:00	2003-10-05	5001	0	\N	0	0	\N	\N	0	190704	0	23426006	4052083		
23001	2116	3049273	2015-09-27	2015-09-27 00:00:00	2015-09-27	5001	0	\N	0	0	\N	\N	0	140842	0	38265-5	3049273		
38473	1194	4024958	1971-06-19	1971-06-19 00:00:00	1971-06-19	5001	0	\N	0	0	\N	\N	0	78726	0	117015009	4024958		
19036	1743	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	116534	0	7258-7	3001488		
2535	246	3006322	1972-04-28	1972-04-28 00:00:00	1972-04-28	5001	0	\N	0	0	\N	\N	0	16588	0	8331-1	3006322		
55594	5104	3006322	2009-06-08	2009-06-08 00:00:00	2009-06-08	5001	0	\N	0	0	\N	\N	0	339172	0	8331-1	3006322		
1280	103	3006322	2009-08-26	2009-08-26 00:00:00	2009-08-26	5001	0	\N	0	0	\N	\N	0	7035	0	8331-1	3006322		
96119	2945	4133840	1997-07-29	1997-07-29 00:00:00	1997-07-29	5001	0	\N	0	0	\N	\N	0	196455	0	127783003	4133840		
9399	298	4052083	1973-07-16	1973-07-16 00:00:00	1973-07-16	5001	0	\N	0	0	\N	\N	0	19946	0	23426006	4052083		
31990	986	4024958	1967-05-23	1967-05-23 00:00:00	1967-05-23	5001	0	\N	0	0	\N	\N	0	65508	0	117015009	4024958		
33561	3041	3006322	1993-11-28	1993-11-28 00:00:00	1993-11-28	5001	0	\N	0	0	\N	\N	0	202435	0	8331-1	3006322		
4904	476	3006322	2006-05-21	2006-05-21 00:00:00	2006-05-21	5001	0	\N	0	0	\N	\N	0	31748	0	8331-1	3006322		
52102	4784	46235214	1950-01-31	1950-01-31 00:00:00	1950-01-31	5001	0	\N	0	0	\N	\N	0	318496	0	76690-7	46235214		
35750	3275	3006322	1971-02-07	1971-02-07 00:00:00	1971-02-07	5001	0	\N	0	0	\N	\N	0	217628	0	8331-1	3006322		
124547	3849	4024958	1980-01-17	1980-01-17 00:00:00	1980-01-17	5001	0	\N	0	0	\N	\N	0	255407	0	117015009	4024958		
11382	1091	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	71626	0	6082-2	3000876		
14841	1378	3012494	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	91332	0	6206-7	3012494		
21346	1971	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	130989	0	6158-0	3019406		
26288	2419	3006322	2013-11-05	2013-11-05 00:00:00	2013-11-05	5001	0	\N	0	0	\N	\N	0	160611	0	8331-1	3006322		
31055	2834	40758406	1991-02-05	1991-02-05 00:00:00	1991-02-05	5001	0	\N	0	0	\N	\N	0	188182	0	55277-8	40758406		
15814	1446	3012494	1984-09-08	1984-09-08 00:00:00	1984-09-08	5001	0	\N	0	0	\N	\N	0	96389	0	6206-7	3012494		
121398	3745	4133840	1994-06-01	1994-06-01 00:00:00	1994-06-01	5001	0	\N	0	0	\N	\N	0	248958	0	127783003	4133840		
13495	1276	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	84174	0	6273-7	3006451		
57191	5252	3006322	1992-01-23	1992-01-23 00:00:00	1992-01-23	5001	0	\N	0	0	\N	\N	0	349388	0	8331-1	3006322		
9075	864	3006322	1935-03-08	1935-03-08 00:00:00	1935-03-08	5001	0	\N	0	0	\N	\N	0	57273	0	8331-1	3006322		
12409	1176	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	77590	0	6833-8	3023430		
39177	3622	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	240803	0	6158-0	3019406		
50204	4578	3006322	1978-02-04	1978-02-04 00:00:00	1978-02-04	5001	0	\N	0	0	\N	\N	0	304977	0	8331-1	3006322		
14924	1384	3006322	1995-03-04	1995-03-04 00:00:00	1995-03-04	5001	0	\N	0	0	\N	\N	0	91786	0	8331-1	3006322		
121361	3745	4133840	2002-07-17	2002-07-17 00:00:00	2002-07-17	5001	0	\N	0	0	\N	\N	0	248892	0	127783003	4133840		
19602	613	4052083	2007-08-07	2007-08-07 00:00:00	2007-08-07	5001	0	\N	0	0	\N	\N	0	40749	0	23426006	4052083		
18636	1716	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	114632	0	6248-9	3015076		
18741	1724	3006322	1984-05-07	1984-05-07 00:00:00	1984-05-07	5001	0	\N	0	0	\N	\N	0	115299	0	8331-1	3006322		
57728	5295	3006322	1998-07-24	1998-07-24 00:00:00	1998-07-24	5001	0	\N	0	0	\N	\N	0	352258	0	8331-1	3006322		
57151	1744	4024958	1996-06-27	1996-06-27 00:00:00	1996-06-27	5001	0	\N	0	0	\N	\N	0	116614	0	117015009	4024958		
57501	1755	4024958	1999-03-15	1999-03-15 00:00:00	1999-03-15	5001	0	\N	0	0	\N	\N	0	117344	0	117015009	4024958		
43194	3991	3006322	2004-01-24	2004-01-24 00:00:00	2004-01-24	5001	0	\N	0	0	\N	\N	0	265345	0	8331-1	3006322		
2158	194	3006322	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	13339	0	8331-1	3006322		
54622	4991	40769179	1997-07-13	1997-07-13 00:00:00	1997-07-13	5001	0	\N	0	0	\N	\N	0	332032	0	66519-0	40769179		
168867	5185	4052083	1955-03-05	1955-03-05 00:00:00	1955-03-05	5001	0	\N	0	0	\N	\N	0	344599	0	23426006	4052083		
26079	2395	3006322	2015-10-08	2015-10-08 00:00:00	2015-10-08	5001	0	\N	0	0	\N	\N	0	159274	0	8331-1	3006322		
1140	94	40766240	1953-10-24	1953-10-24 00:00:00	1953-10-24	5001	0	\N	0	0	\N	\N	0	6342	0	63513-6	40766240		
23183	2135	3012494	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	142038	0	6206-7	3012494		
27928	2566	3006322	2002-02-17	2002-02-17 00:00:00	2002-02-17	5001	0	\N	0	0	\N	\N	0	169998	0	8331-1	3006322		
38874	1211	4052083	1967-01-07	1967-01-07 00:00:00	1967-01-07	5001	0	\N	0	0	\N	\N	0	79516	0	23426006	4052083		
34690	3176	3006451	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	211108	0	6273-7	3006451		
55440	5086	3006322	1976-11-18	1976-11-18 00:00:00	1976-11-18	5001	0	\N	0	0	\N	\N	0	338158	0	8331-1	3006322		
15264	1399	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	92997	0	6106-9	3014599		
51920	4761	3001247	1993-05-10	1993-05-10 00:00:00	1993-05-10	5001	0	\N	0	0	\N	\N	0	317261	0	6085-5	3001247		
26691	2462	3012494	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	163320	0	6206-7	3012494		
32660	1017	4024958	1995-11-19	1995-11-19 00:00:00	1995-11-19	5001	0	\N	0	0	\N	\N	0	66930	0	117015009	4024958		
56567	5194	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	345299	0	6082-2	3000876		
3682	115	4133840	2019-03-03	2019-03-03 00:00:00	2019-03-03	5001	0	\N	0	0	\N	\N	0	7602	0	127783003	4133840		
103938	3195	4052083	1990-03-19	1990-03-19 00:00:00	1990-03-19	5001	0	\N	0	0	\N	\N	0	212513	0	23426006	4052083		
30916	2830	3021226	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	187752	0	6246-3	3021226		
57350	1751	4024958	1993-06-03	1993-06-03 00:00:00	1993-06-03	5001	0	\N	0	0	\N	\N	0	117048	0	117015009	4024958		
10092	959	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	63712	0	6248-9	3015076		
38346	3530	3006322	1972-09-24	1972-09-24 00:00:00	1972-09-24	5001	0	\N	0	0	\N	\N	0	234467	0	8331-1	3006322		
93154	2867	4024958	1979-09-13	1979-09-13 00:00:00	1979-09-13	5001	0	\N	0	0	\N	\N	0	190740	0	117015009	4024958		
23003	2116	3006322	1971-07-04	1971-07-04 00:00:00	1971-07-04	5001	0	\N	0	0	\N	\N	0	140802	0	8331-1	3006322		
38478	1194	4052083	1999-03-30	1999-03-30 00:00:00	1999-03-30	5001	0	\N	0	0	\N	\N	0	78695	0	23426006	4052083		
19037	1743	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	116534	0	6246-3	3021226		
2536	246	3011505	2017-06-08	2017-06-08 00:00:00	2017-06-08	5001	0	\N	0	0	\N	\N	0	16544	0	19926-5	3011505		
55595	5104	3006322	2013-08-30	2013-08-30 00:00:00	2013-08-30	5001	0	\N	0	0	\N	\N	0	339178	0	8331-1	3006322		
1281	103	3006322	1981-06-14	1981-06-14 00:00:00	1981-06-14	5001	0	\N	0	0	\N	\N	0	7045	0	8331-1	3006322		
96122	2945	4133840	1995-07-18	1995-07-18 00:00:00	1995-07-18	5001	0	\N	0	0	\N	\N	0	196477	0	127783003	4133840		
9407	298	4052083	2004-11-11	2004-11-11 00:00:00	2004-11-11	5001	0	\N	0	0	\N	\N	0	19871	0	23426006	4052083		
31991	986	4052083	1977-07-02	1977-07-02 00:00:00	1977-07-02	5001	0	\N	0	0	\N	\N	0	65443	0	23426006	4052083		
33562	3041	3006322	1983-10-02	1983-10-02 00:00:00	1983-10-02	5001	0	\N	0	0	\N	\N	0	202528	0	8331-1	3006322		
4905	476	3006322	1968-06-14	1968-06-14 00:00:00	1968-06-14	5001	0	\N	0	0	\N	\N	0	31747	0	8331-1	3006322		
52103	4784	46235214	1950-03-02	1950-03-02 00:00:00	1950-03-02	5001	0	\N	0	0	\N	\N	0	318419	0	76690-7	46235214		
35751	3275	3006322	1965-06-16	1965-06-16 00:00:00	1965-06-16	5001	0	\N	0	0	\N	\N	0	217646	0	8331-1	3006322		
124555	3849	4052083	1983-12-07	1983-12-07 00:00:00	1983-12-07	5001	0	\N	0	0	\N	\N	0	255429	0	23426006	4052083		
11383	1091	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	71626	0	6085-5	3001247		
14842	1378	3021226	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	91332	0	6246-3	3021226		
21347	1971	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	130989	0	6276-0	3027231		
26289	2419	3006322	1970-08-01	1970-08-01 00:00:00	1970-08-01	5001	0	\N	0	0	\N	\N	0	160511	0	8331-1	3006322		
31056	2834	46235214	1991-02-05	1991-02-05 00:00:00	1991-02-05	5001	0	\N	0	0	\N	\N	0	188182	0	76690-7	46235214		
15815	1446	3019406	1984-09-08	1984-09-08 00:00:00	1984-09-08	5001	0	\N	0	0	\N	\N	0	96389	0	6158-0	3019406		
121404	3745	4133840	1996-06-12	1996-06-12 00:00:00	1996-06-12	5001	0	\N	0	0	\N	\N	0	248959	0	127783003	4133840		
13496	1276	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	84174	0	6095-4	3036780		
57192	5252	3011505	2007-12-04	2007-12-04 00:00:00	2007-12-04	5001	0	\N	0	0	\N	\N	0	349472	0	19926-5	3011505		
9076	864	3006322	1947-07-19	1947-07-19 00:00:00	1947-07-19	5001	0	\N	0	0	\N	\N	0	57296	0	8331-1	3006322		
12410	1176	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	77590	0	6248-9	3015076		
39178	3622	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	240803	0	6844-5	3020655		
50205	4578	3006322	1975-01-10	1975-01-10 00:00:00	1975-01-10	5001	0	\N	0	0	\N	\N	0	304976	0	8331-1	3006322		
14925	1384	3006322	1997-08-30	1997-08-30 00:00:00	1997-08-30	5001	0	\N	0	0	\N	\N	0	91729	0	8331-1	3006322		
149607	4587	4024958	2004-10-12	2004-10-12 00:00:00	2004-10-12	5001	0	\N	0	0	\N	\N	0	305589	0	117015009	4024958		
19604	613	4052083	2015-05-15	2015-05-15 00:00:00	2015-05-15	5001	0	\N	0	0	\N	\N	0	40709	0	23426006	4052083		
18637	1716	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	114632	0	6246-3	3021226		
18742	1724	3006322	1952-08-29	1952-08-29 00:00:00	1952-08-29	5001	0	\N	0	0	\N	\N	0	115246	0	8331-1	3006322		
57729	5295	3006322	1937-11-18	1937-11-18 00:00:00	1937-11-18	5001	0	\N	0	0	\N	\N	0	352299	0	8331-1	3006322		
57156	1744	4052083	1999-01-09	1999-01-09 00:00:00	1999-01-09	5001	0	\N	0	0	\N	\N	0	116621	0	23426006	4052083		
57511	1755	4052083	1969-09-03	1969-09-03 00:00:00	1969-09-03	5001	0	\N	0	0	\N	\N	0	117333	0	23426006	4052083		
43195	3991	40766240	1957-04-24	1957-04-24 00:00:00	1957-04-24	5001	0	\N	0	0	\N	\N	0	265321	0	63513-6	40766240		
2159	194	3006322	1995-01-06	1995-01-06 00:00:00	1995-01-06	5001	0	\N	0	0	\N	\N	0	13340	0	8331-1	3006322		
54623	4991	3006322	2001-12-13	2001-12-13 00:00:00	2001-12-13	5001	0	\N	0	0	\N	\N	0	332074	0	8331-1	3006322		
168871	5185	4052083	1965-09-17	1965-09-17 00:00:00	1965-09-17	5001	0	\N	0	0	\N	\N	0	344651	0	23426006	4052083		
26080	2395	3006322	2015-07-27	2015-07-27 00:00:00	2015-07-27	5001	0	\N	0	0	\N	\N	0	159223	0	8331-1	3006322		
1142	94	3051031	1953-10-24	1953-10-24 00:00:00	1953-10-24	5001	0	\N	0	0	\N	\N	0	6342	0	46240-8	3051031		
23184	2135	3015076	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	142038	0	6248-9	3015076		
27929	2566	46235214	2016-05-02	2016-05-02 00:00:00	2016-05-02	5001	0	\N	0	0	\N	\N	0	169944	0	76690-7	46235214		
18347	1679	3006322	2000-03-06	2000-03-06 00:00:00	2000-03-06	5001	0	\N	0	0	\N	\N	0	112560	0	8331-1	3006322		
34691	3176	3027231	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	211108	0	6276-0	3027231		
55441	5086	3006322	1974-07-18	1974-07-18 00:00:00	1974-07-18	5001	0	\N	0	0	\N	\N	0	338157	0	8331-1	3006322		
15265	1399	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	92997	0	6273-7	3006451		
51921	4761	3006451	1993-05-10	1993-05-10 00:00:00	1993-05-10	5001	0	\N	0	0	\N	\N	0	317261	0	6273-7	3006451		
26692	2462	3021226	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	163320	0	6246-3	3021226		
32664	1017	4024958	2001-01-11	2001-01-11 00:00:00	2001-01-11	5001	0	\N	0	0	\N	\N	0	67008	0	117015009	4024958		
56568	5194	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	345299	0	6844-5	3020655		
3696	115	4024958	2004-10-27	2004-10-27 00:00:00	2004-10-27	5001	0	\N	0	0	\N	\N	0	7596	0	117015009	4024958		
103959	3196	4052083	1978-04-27	1978-04-27 00:00:00	1978-04-27	5001	0	\N	0	0	\N	\N	0	212597	0	23426006	4052083		
30917	2830	3006451	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	187752	0	6273-7	3006451		
57360	1751	4024958	2011-05-15	2011-05-15 00:00:00	2011-05-15	5001	0	\N	0	0	\N	\N	0	117049	0	117015009	4024958		
10093	959	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	63712	0	6095-4	3036780		
38348	3530	3006322	1963-10-04	1963-10-04 00:00:00	1963-10-04	5001	0	\N	0	0	\N	\N	0	234466	0	8331-1	3006322		
93184	2868	4024958	1969-08-21	1969-08-21 00:00:00	1969-08-21	5001	0	\N	0	0	\N	\N	0	190802	0	117015009	4024958		
23016	2119	3001488	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	141083	0	7258-7	3001488		
29948	925	4133840	2014-08-22	2014-08-22 00:00:00	2014-08-22	5001	0	\N	0	0	\N	\N	0	61583	0	127783003	4133840		
19038	1743	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	116534	0	6844-5	3020655		
2537	246	3011505	2005-04-14	2005-04-14 00:00:00	2005-04-14	5001	0	\N	0	0	\N	\N	0	16534	0	19926-5	3011505		
55598	5107	3006322	2015-10-30	2015-10-30 00:00:00	2015-10-30	5001	0	\N	0	0	\N	\N	0	339347	0	8331-1	3006322		
1282	103	3006322	1974-02-22	1974-02-22 00:00:00	1974-02-22	5001	0	\N	0	0	\N	\N	0	7033	0	8331-1	3006322		
107426	3313	4052083	1958-08-05	1958-08-05 00:00:00	1958-08-05	5001	0	\N	0	0	\N	\N	0	219986	0	23426006	4052083		
9435	299	4133840	2016-01-02	2016-01-02 00:00:00	2016-01-02	5001	0	\N	0	0	\N	\N	0	19992	0	127783003	4133840		
42027	3887	3006322	1970-03-24	1970-03-24 00:00:00	1970-03-24	5001	0	\N	0	0	\N	\N	0	258388	0	8331-1	3006322		
33567	3044	3006322	2017-01-30	2017-01-30 00:00:00	2017-01-30	5001	0	\N	0	0	\N	\N	0	202643	0	8331-1	3006322		
4906	476	3006322	1990-06-01	1990-06-01 00:00:00	1990-06-01	5001	0	\N	0	0	\N	\N	0	31739	0	8331-1	3006322		
52104	4784	3051031	1950-03-02	1950-03-02 00:00:00	1950-03-02	5001	0	\N	0	0	\N	\N	0	318419	0	46240-8	3051031		
35752	3275	3006322	1982-03-24	1982-03-24 00:00:00	1982-03-24	5001	0	\N	0	0	\N	\N	0	217581	0	8331-1	3006322		
124561	3849	4024958	1968-04-13	1968-04-13 00:00:00	1968-04-13	5001	0	\N	0	0	\N	\N	0	255428	0	117015009	4024958		
11384	1091	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	71626	0	6844-5	3020655		
14843	1378	3005136	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	91332	0	6075-6	3005136		
21348	1971	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	130989	0	6206-7	3012494		
9658	308	4052083	1963-01-11	1963-01-11 00:00:00	1963-01-11	5001	0	\N	0	0	\N	\N	0	20421	0	23426006	4052083		
31058	2834	3051031	1991-02-05	1991-02-05 00:00:00	1991-02-05	5001	0	\N	0	0	\N	\N	0	188182	0	46240-8	3051031		
15816	1446	3000876	1984-09-08	1984-09-08 00:00:00	1984-09-08	5001	0	\N	0	0	\N	\N	0	96389	0	6082-2	3000876		
121405	3745	4133840	1999-06-30	1999-06-30 00:00:00	1999-06-30	5001	0	\N	0	0	\N	\N	0	248967	0	127783003	4133840		
13497	1276	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	84174	0	6248-9	3015076		
57193	5252	3006322	1978-02-03	1978-02-03 00:00:00	1978-02-03	5001	0	\N	0	0	\N	\N	0	349414	0	8331-1	3006322		
9077	864	3006322	1947-11-26	1947-11-26 00:00:00	1947-11-26	5001	0	\N	0	0	\N	\N	0	57262	0	8331-1	3006322		
12411	1176	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	77590	0	6276-0	3027231		
39179	3622	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	240803	0	6833-8	3023430		
50206	4578	40758406	1965-10-21	1965-10-21 00:00:00	1965-10-21	5001	0	\N	0	0	\N	\N	0	304975	0	55277-8	40758406		
14926	1384	3006322	1994-11-22	1994-11-22 00:00:00	1994-11-22	5001	0	\N	0	0	\N	\N	0	91767	0	8331-1	3006322		
149621	4587	4024958	1953-08-07	1953-08-07 00:00:00	1953-08-07	5001	0	\N	0	0	\N	\N	0	305597	0	117015009	4024958		
19620	613	4024958	1970-01-03	1970-01-03 00:00:00	1970-01-03	5001	0	\N	0	0	\N	\N	0	40727	0	117015009	4024958		
18638	1716	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	114632	0	6273-7	3006451		
18744	1727	3011505	1999-03-31	1999-03-31 00:00:00	1999-03-31	5001	0	\N	0	0	\N	\N	0	115511	0	19926-5	3011505		
57730	5295	3006322	1917-01-01	1917-01-01 00:00:00	1917-01-01	5001	0	\N	0	0	\N	\N	0	352269	0	8331-1	3006322		
57158	1744	4052083	1993-02-15	1993-02-15 00:00:00	1993-02-15	5001	0	\N	0	0	\N	\N	0	116618	0	23426006	4052083		
57522	1756	4052083	1995-11-06	1995-11-06 00:00:00	1995-11-06	5001	0	\N	0	0	\N	\N	0	117448	0	23426006	4052083		
43196	3991	3051031	1957-04-24	1957-04-24 00:00:00	1957-04-24	5001	0	\N	0	0	\N	\N	0	265321	0	46240-8	3051031		
2160	194	3006322	1986-06-18	1986-06-18 00:00:00	1986-06-18	5001	0	\N	0	0	\N	\N	0	13329	0	8331-1	3006322		
54624	4992	3006322	2014-03-01	2014-03-01 00:00:00	2014-03-01	5001	0	\N	0	0	\N	\N	0	332097	0	8331-1	3006322		
168873	5185	4052083	1993-01-01	1993-01-01 00:00:00	1993-01-01	5001	0	\N	0	0	\N	\N	0	344706	0	23426006	4052083		
26081	2395	3006322	1975-05-03	1975-05-03 00:00:00	1975-05-03	5001	0	\N	0	0	\N	\N	0	159219	0	8331-1	3006322		
1143	94	46235214	1953-10-24	1953-10-24 00:00:00	1953-10-24	5001	0	\N	0	0	\N	\N	0	6342	0	76690-7	46235214		
23185	2135	3019406	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	142038	0	6158-0	3019406		
27930	2566	40758406	2016-05-02	2016-05-02 00:00:00	2016-05-02	5001	0	\N	0	0	\N	\N	0	169944	0	55277-8	40758406		
18348	1679	3006322	2012-06-30	2012-06-30 00:00:00	2012-06-30	5001	0	\N	0	0	\N	\N	0	112592	0	8331-1	3006322		
34692	3176	3015076	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	211108	0	6248-9	3015076		
55460	5094	3020655	1999-05-19	1999-05-19 00:00:00	1999-05-19	5001	0	\N	0	0	\N	\N	0	338442	0	6844-5	3020655		
15266	1399	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	92997	0	6206-7	3012494		
51922	4761	3000876	1993-05-10	1993-05-10 00:00:00	1993-05-10	5001	0	\N	0	0	\N	\N	0	317261	0	6082-2	3000876		
26693	2462	3019406	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	163320	0	6158-0	3019406		
6171	189	4024958	2003-03-27	2003-03-27 00:00:00	2003-03-27	5001	0	\N	0	0	\N	\N	0	12881	0	117015009	4024958		
56569	5194	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	345299	0	6833-8	3023430		
3702	115	4024958	1965-09-15	1965-09-15 00:00:00	1965-09-15	5001	0	\N	0	0	\N	\N	0	7564	0	117015009	4024958		
103966	3196	4052083	1984-12-18	1984-12-18 00:00:00	1984-12-18	5001	0	\N	0	0	\N	\N	0	212612	0	23426006	4052083		
30918	2830	3015076	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	187752	0	6248-9	3015076		
57363	1751	4052083	1979-04-22	1979-04-22 00:00:00	1979-04-22	5001	0	\N	0	0	\N	\N	0	117095	0	23426006	4052083		
10094	959	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	63712	0	6273-7	3006451		
38349	3530	3006322	1980-10-05	1980-10-05 00:00:00	1980-10-05	5001	0	\N	0	0	\N	\N	0	234462	0	8331-1	3006322		
93195	2869	4052083	1991-05-06	1991-05-06 00:00:00	1991-05-06	5001	0	\N	0	0	\N	\N	0	190863	0	23426006	4052083		
23017	2119	3005136	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	141083	0	6075-6	3005136		
29957	925	4133840	2011-05-20	2011-05-20 00:00:00	2011-05-20	5001	0	\N	0	0	\N	\N	0	61597	0	127783003	4133840		
19039	1743	3006322	1997-11-13	1997-11-13 00:00:00	1997-11-13	5001	0	\N	0	0	\N	\N	0	116493	0	8331-1	3006322		
2538	246	3006322	1970-11-26	1970-11-26 00:00:00	1970-11-26	5001	0	\N	0	0	\N	\N	0	16523	0	8331-1	3006322		
55599	5107	3006322	1997-05-26	1997-05-26 00:00:00	1997-05-26	5001	0	\N	0	0	\N	\N	0	339319	0	8331-1	3006322		
1283	103	3006322	1981-09-24	1981-09-24 00:00:00	1981-09-24	5001	0	\N	0	0	\N	\N	0	7061	0	8331-1	3006322		
107427	3313	4052083	1967-01-29	1967-01-29 00:00:00	1967-01-29	5001	0	\N	0	0	\N	\N	0	219977	0	23426006	4052083		
9440	299	4133840	2014-12-27	2014-12-27 00:00:00	2014-12-27	5001	0	\N	0	0	\N	\N	0	19981	0	127783003	4133840		
42028	3887	3006322	1957-09-20	1957-09-20 00:00:00	1957-09-20	5001	0	\N	0	0	\N	\N	0	258401	0	8331-1	3006322		
33568	3044	3006322	1972-12-04	1972-12-04 00:00:00	1972-12-04	5001	0	\N	0	0	\N	\N	0	202625	0	8331-1	3006322		
56156	1715	4052083	1994-03-06	1994-03-06 00:00:00	1994-03-06	5001	0	\N	0	0	\N	\N	0	114558	0	23426006	4052083		
52105	4784	40758406	1950-03-02	1950-03-02 00:00:00	1950-03-02	5001	0	\N	0	0	\N	\N	0	318419	0	55277-8	40758406		
35753	3275	3006322	2012-01-27	2012-01-27 00:00:00	2012-01-27	5001	0	\N	0	0	\N	\N	0	217583	0	8331-1	3006322		
124569	3849	4024958	1969-04-20	1969-04-20 00:00:00	1969-04-20	5001	0	\N	0	0	\N	\N	0	255452	0	117015009	4024958		
11385	1091	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	71626	0	7258-7	3001488		
14844	1378	3023430	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	91332	0	6833-8	3023430		
21349	1971	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	130989	0	6085-5	3001247		
20999	662	4024958	1999-12-22	1999-12-22 00:00:00	1999-12-22	5001	0	\N	0	0	\N	\N	0	43700	0	117015009	4024958		
31059	2834	40766240	1991-02-05	1991-02-05 00:00:00	1991-02-05	5001	0	\N	0	0	\N	\N	0	188182	0	63513-6	40766240		
15817	1446	3036780	1984-09-08	1984-09-08 00:00:00	1984-09-08	5001	0	\N	0	0	\N	\N	0	96389	0	6095-4	3036780		
121406	3745	4133840	1992-05-20	1992-05-20 00:00:00	1992-05-20	5001	0	\N	0	0	\N	\N	0	248870	0	127783003	4133840		
13498	1276	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	84174	0	6075-6	3005136		
57194	5252	3011505	1997-04-08	1997-04-08 00:00:00	1997-04-08	5001	0	\N	0	0	\N	\N	0	349479	0	19926-5	3011505		
9079	864	3006322	1967-12-16	1967-12-16 00:00:00	1967-12-16	5001	0	\N	0	0	\N	\N	0	57232	0	8331-1	3006322		
12412	1176	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	77590	0	6106-9	3014599		
39180	3622	3006322	2004-04-02	2004-04-02 00:00:00	2004-04-02	5001	0	\N	0	0	\N	\N	0	240734	0	8331-1	3006322		
50207	4578	40766240	1965-10-21	1965-10-21 00:00:00	1965-10-21	5001	0	\N	0	0	\N	\N	0	304975	0	63513-6	40766240		
14927	1384	3006322	1987-09-20	1987-09-20 00:00:00	1987-09-20	5001	0	\N	0	0	\N	\N	0	91765	0	8331-1	3006322		
149628	4587	4024958	1976-11-17	1976-11-17 00:00:00	1976-11-17	5001	0	\N	0	0	\N	\N	0	305586	0	117015009	4024958		
19638	614	4052083	1994-05-31	1994-05-31 00:00:00	1994-05-31	5001	0	\N	0	0	\N	\N	0	40859	0	23426006	4052083		
18639	1716	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	114632	0	6106-9	3014599		
18745	1727	3006322	1954-02-05	1954-02-05 00:00:00	1954-02-05	5001	0	\N	0	0	\N	\N	0	115524	0	8331-1	3006322		
57731	5295	3006322	1993-09-08	1993-09-08 00:00:00	1993-09-08	5001	0	\N	0	0	\N	\N	0	352285	0	8331-1	3006322		
57160	1744	4052083	2014-10-20	2014-10-20 00:00:00	2014-10-20	5001	0	\N	0	0	\N	\N	0	116631	0	23426006	4052083		
57525	1756	4024958	1993-08-06	1993-08-06 00:00:00	1993-08-06	5001	0	\N	0	0	\N	\N	0	117451	0	117015009	4024958		
41591	3874	3006322	2009-03-09	2009-03-09 00:00:00	2009-03-09	5001	0	\N	0	0	\N	\N	0	257228	0	8331-1	3006322		
2161	194	3006322	1998-06-01	1998-06-01 00:00:00	1998-06-01	5001	0	\N	0	0	\N	\N	0	13302	0	8331-1	3006322		
54625	4992	3006322	1996-08-19	1996-08-19 00:00:00	1996-08-19	5001	0	\N	0	0	\N	\N	0	332148	0	8331-1	3006322		
168882	5185	4024958	1936-05-13	1936-05-13 00:00:00	1936-05-13	5001	0	\N	0	0	\N	\N	0	344647	0	117015009	4024958		
26082	2395	3006322	1978-12-25	1978-12-25 00:00:00	1978-12-25	5001	0	\N	0	0	\N	\N	0	159265	0	8331-1	3006322		
1144	94	40758406	1953-10-24	1953-10-24 00:00:00	1953-10-24	5001	0	\N	0	0	\N	\N	0	6342	0	55277-8	40758406		
23186	2135	3027231	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	142038	0	6276-0	3027231		
27932	2566	3051031	2016-05-02	2016-05-02 00:00:00	2016-05-02	5001	0	\N	0	0	\N	\N	0	169944	0	46240-8	3051031		
18349	1679	3006322	1974-08-06	1974-08-06 00:00:00	1974-08-06	5001	0	\N	0	0	\N	\N	0	112588	0	8331-1	3006322		
34693	3176	3012494	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	211108	0	6206-7	3012494		
55461	5094	3001488	1999-05-19	1999-05-19 00:00:00	1999-05-19	5001	0	\N	0	0	\N	\N	0	338442	0	7258-7	3001488		
15267	1399	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	92997	0	6158-0	3019406		
51923	4761	3015076	1993-05-10	1993-05-10 00:00:00	1993-05-10	5001	0	\N	0	0	\N	\N	0	317261	0	6248-9	3015076		
26694	2462	3005136	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	163320	0	6075-6	3005136		
6178	190	4052083	1979-03-02	1979-03-02 00:00:00	1979-03-02	5001	0	\N	0	0	\N	\N	0	12964	0	23426006	4052083		
56570	5194	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	345299	0	6189-5	3006734		
3705	115	4024958	1983-11-08	1983-11-08 00:00:00	1983-11-08	5001	0	\N	0	0	\N	\N	0	7615	0	117015009	4024958		
103969	3196	4024958	2011-01-10	2011-01-10 00:00:00	2011-01-10	5001	0	\N	0	0	\N	\N	0	212617	0	117015009	4024958		
30919	2830	3019406	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	187752	0	6158-0	3019406		
160602	4933	4024958	1984-08-01	1984-08-01 00:00:00	1984-08-01	5001	0	\N	0	0	\N	\N	0	327972	0	117015009	4024958		
10095	959	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	63712	0	6246-3	3021226		
38350	3530	3006322	1977-02-10	1977-02-10 00:00:00	1977-02-10	5001	0	\N	0	0	\N	\N	0	234468	0	8331-1	3006322		
22915	2097	3006322	2011-04-09	2011-04-09 00:00:00	2011-04-09	5001	0	\N	0	0	\N	\N	0	139764	0	8331-1	3006322		
23018	2119	3001247	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	141083	0	6085-5	3001247		
30013	929	4024958	1965-10-04	1965-10-04 00:00:00	1965-10-04	5001	0	\N	0	0	\N	\N	0	61824	0	117015009	4024958		
19040	1744	3006322	2006-11-13	2006-11-13 00:00:00	2006-11-13	5001	0	\N	0	0	\N	\N	0	116619	0	8331-1	3006322		
2539	246	3011505	2018-06-14	2018-06-14 00:00:00	2018-06-14	5001	0	\N	0	0	\N	\N	0	16574	0	19926-5	3011505		
55600	5107	3006322	1994-06-29	1994-06-29 00:00:00	1994-06-29	5001	0	\N	0	0	\N	\N	0	339333	0	8331-1	3006322		
1284	103	3006322	2000-12-25	2000-12-25 00:00:00	2000-12-25	5001	0	\N	0	0	\N	\N	0	7062	0	8331-1	3006322		
72750	2233	4052083	2009-04-10	2009-04-10 00:00:00	2009-04-10	5001	0	\N	0	0	\N	\N	0	148587	0	23426006	4052083		
9441	299	4024958	1967-04-09	1967-04-09 00:00:00	1967-04-09	5001	0	\N	0	0	\N	\N	0	20023	0	117015009	4024958		
42029	3887	3006322	2014-09-28	2014-09-28 00:00:00	2014-09-28	5001	0	\N	0	0	\N	\N	0	258352	0	8331-1	3006322		
33569	3044	3006322	1995-07-14	1995-07-14 00:00:00	1995-07-14	5001	0	\N	0	0	\N	\N	0	202594	0	8331-1	3006322		
56163	1715	4052083	2019-06-27	2019-06-27 00:00:00	2019-06-27	5001	0	\N	0	0	\N	\N	0	114547	0	23426006	4052083		
52106	4784	40766240	1950-03-02	1950-03-02 00:00:00	1950-03-02	5001	0	\N	0	0	\N	\N	0	318419	0	63513-6	40766240		
35754	3275	3006322	1967-08-18	1967-08-18 00:00:00	1967-08-18	5001	0	\N	0	0	\N	\N	0	217627	0	8331-1	3006322		
64256	1975	4024958	1961-09-21	1961-09-21 00:00:00	1961-09-21	5001	0	\N	0	0	\N	\N	0	131298	0	117015009	4024958		
11386	1091	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	71626	0	6189-5	3006734		
14845	1378	3036780	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	91332	0	6095-4	3036780		
21350	1971	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	130989	0	6095-4	3036780		
21006	662	4052083	1989-03-01	1989-03-01 00:00:00	1989-03-01	5001	0	\N	0	0	\N	\N	0	43743	0	23426006	4052083		
31061	2834	3006322	1999-10-11	1999-10-11 00:00:00	1999-10-11	5001	0	\N	0	0	\N	\N	0	188125	0	8331-1	3006322		
15818	1446	3006734	1984-09-08	1984-09-08 00:00:00	1984-09-08	5001	0	\N	0	0	\N	\N	0	96389	0	6189-5	3006734		
121410	3745	4133840	2017-10-11	2017-10-11 00:00:00	2017-10-11	5001	0	\N	0	0	\N	\N	0	248896	0	127783003	4133840		
13499	1276	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	84174	0	6106-9	3014599		
57195	5252	3011505	2011-12-27	2011-12-27 00:00:00	2011-12-27	5001	0	\N	0	0	\N	\N	0	349474	0	19926-5	3011505		
9080	865	3006322	1969-04-14	1969-04-14 00:00:00	1969-04-14	5001	0	\N	0	0	\N	\N	0	57437	0	8331-1	3006322		
12413	1176	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	77590	0	6158-0	3019406		
39181	3622	3006322	1961-05-15	1961-05-15 00:00:00	1961-05-15	5001	0	\N	0	0	\N	\N	0	240776	0	8331-1	3006322		
50208	4578	46235214	1965-10-21	1965-10-21 00:00:00	1965-10-21	5001	0	\N	0	0	\N	\N	0	304975	0	76690-7	46235214		
14928	1385	3006322	1975-09-27	1975-09-27 00:00:00	1975-09-27	5001	0	\N	0	0	\N	\N	0	91835	0	8331-1	3006322		
149643	4587	4052083	1967-02-25	1967-02-25 00:00:00	1967-02-25	5001	0	\N	0	0	\N	\N	0	305609	0	23426006	4052083		
19648	614	4024958	1984-05-26	1984-05-26 00:00:00	1984-05-26	5001	0	\N	0	0	\N	\N	0	40820	0	117015009	4024958		
18640	1716	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	114632	0	6158-0	3019406		
18746	1727	3006322	1997-04-26	1997-04-26 00:00:00	1997-04-26	5001	0	\N	0	0	\N	\N	0	115426	0	8331-1	3006322		
57732	5295	3006322	1934-01-26	1934-01-26 00:00:00	1934-01-26	5001	0	\N	0	0	\N	\N	0	352271	0	8331-1	3006322		
57179	1745	4024958	1979-08-16	1979-08-16 00:00:00	1979-08-16	5001	0	\N	0	0	\N	\N	0	116670	0	117015009	4024958		
57527	1756	4024958	2009-04-25	2009-04-25 00:00:00	2009-04-25	5001	0	\N	0	0	\N	\N	0	117463	0	117015009	4024958		
41592	3874	3051031	1983-02-21	1983-02-21 00:00:00	1983-02-21	5001	0	\N	0	0	\N	\N	0	257305	0	46240-8	3051031		
2162	195	3006322	2014-10-15	2014-10-15 00:00:00	2014-10-15	5001	0	\N	0	0	\N	\N	0	13393	0	8331-1	3006322		
18888	1737	3049273	2000-10-12	2000-10-12 00:00:00	2000-10-12	5001	0	\N	0	0	\N	\N	0	115964	0	38265-5	3049273		
168898	5185	4024958	2014-10-27	2014-10-27 00:00:00	2014-10-27	5001	0	\N	0	0	\N	\N	0	344700	0	117015009	4024958		
26083	2395	3006322	1972-08-06	1972-08-06 00:00:00	1972-08-06	5001	0	\N	0	0	\N	\N	0	159243	0	8331-1	3006322		
1146	94	3006322	1959-12-30	1959-12-30 00:00:00	1959-12-30	5001	0	\N	0	0	\N	\N	0	6353	0	8331-1	3006322		
23187	2135	3005136	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	142038	0	6075-6	3005136		
27933	2566	40766240	2016-05-02	2016-05-02 00:00:00	2016-05-02	5001	0	\N	0	0	\N	\N	0	169944	0	63513-6	40766240		
18350	1679	3006322	1975-06-15	1975-06-15 00:00:00	1975-06-15	5001	0	\N	0	0	\N	\N	0	112604	0	8331-1	3006322		
34694	3176	3006322	2012-03-03	2012-03-03 00:00:00	2012-03-03	5001	0	\N	0	0	\N	\N	0	211100	0	8331-1	3006322		
55462	5094	3005136	1999-05-19	1999-05-19 00:00:00	1999-05-19	5001	0	\N	0	0	\N	\N	0	338442	0	6075-6	3005136		
15268	1399	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	92997	0	6844-5	3020655		
51924	4761	3012494	1993-05-10	1993-05-10 00:00:00	1993-05-10	5001	0	\N	0	0	\N	\N	0	317261	0	6206-7	3012494		
26695	2462	3001247	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	163320	0	6085-5	3001247		
6192	190	4024958	1961-03-13	1961-03-13 00:00:00	1961-03-13	5001	0	\N	0	0	\N	\N	0	12981	0	117015009	4024958		
56571	5194	3006322	1975-06-03	1975-06-03 00:00:00	1975-06-03	5001	0	\N	0	0	\N	\N	0	345318	0	8331-1	3006322		
3716	116	4024958	1931-10-13	1931-10-13 00:00:00	1931-10-13	5001	0	\N	0	0	\N	\N	0	7674	0	117015009	4024958		
103972	3196	4024958	1989-06-28	1989-06-28 00:00:00	1989-06-28	5001	0	\N	0	0	\N	\N	0	212647	0	117015009	4024958		
30920	2830	3027231	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	187752	0	6276-0	3027231		
160636	4935	4024958	1973-03-03	1973-03-03 00:00:00	1973-03-03	5001	0	\N	0	0	\N	\N	0	328035	0	117015009	4024958		
10096	959	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	63712	0	6276-0	3027231		
38351	3531	3006322	1976-12-18	1976-12-18 00:00:00	1976-12-18	5001	0	\N	0	0	\N	\N	0	234520	0	8331-1	3006322		
22916	2097	3006322	2010-12-28	2010-12-28 00:00:00	2010-12-28	5001	0	\N	0	0	\N	\N	0	139799	0	8331-1	3006322		
23019	2119	3000876	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	141083	0	6082-2	3000876		
30023	929	4024958	1937-06-19	1937-06-19 00:00:00	1937-06-19	5001	0	\N	0	0	\N	\N	0	61821	0	117015009	4024958		
19041	1744	3006322	1996-06-27	1996-06-27 00:00:00	1996-06-27	5001	0	\N	0	0	\N	\N	0	116614	0	8331-1	3006322		
2540	246	3011505	2015-05-28	2015-05-28 00:00:00	2015-05-28	5001	0	\N	0	0	\N	\N	0	16543	0	19926-5	3011505		
55601	5107	3006322	1987-08-04	1987-08-04 00:00:00	1987-08-04	5001	0	\N	0	0	\N	\N	0	339346	0	8331-1	3006322		
1285	103	3009542	2002-05-19	2002-05-19 00:00:00	2002-05-19	5001	0	\N	0	0	\N	\N	0	7047	0	20570-8	3009542		
72754	2233	4052083	2013-06-03	2013-06-03 00:00:00	2013-06-03	5001	0	\N	0	0	\N	\N	0	148562	0	23426006	4052083		
9442	299	4133840	2019-01-19	2019-01-19 00:00:00	2019-01-19	5001	0	\N	0	0	\N	\N	0	19983	0	127783003	4133840		
42030	3887	3006322	1977-04-02	1977-04-02 00:00:00	1977-04-02	5001	0	\N	0	0	\N	\N	0	258367	0	8331-1	3006322		
33570	3044	3006322	1991-06-26	1991-06-26 00:00:00	1991-06-26	5001	0	\N	0	0	\N	\N	0	202626	0	8331-1	3006322		
56165	1715	4024958	1958-03-19	1958-03-19 00:00:00	1958-03-19	5001	0	\N	0	0	\N	\N	0	114520	0	117015009	4024958		
52109	4784	3006322	2007-07-04	2007-07-04 00:00:00	2007-07-04	5001	0	\N	0	0	\N	\N	0	318457	0	8331-1	3006322		
35756	3277	3006322	1978-05-11	1978-05-11 00:00:00	1978-05-11	5001	0	\N	0	0	\N	\N	0	217720	0	8331-1	3006322		
75540	2319	4024958	1966-10-03	1966-10-03 00:00:00	1966-10-03	5001	0	\N	0	0	\N	\N	0	154162	0	117015009	4024958		
11387	1091	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	71626	0	6273-7	3006451		
14846	1378	3006734	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	91332	0	6189-5	3006734		
21351	1971	3006322	1996-02-17	1996-02-17 00:00:00	1996-02-17	5001	0	\N	0	0	\N	\N	0	131002	0	8331-1	3006322		
30968	2832	3019406	1997-09-06	1997-09-06 00:00:00	1997-09-06	5001	0	\N	0	0	\N	\N	0	187932	0	6158-0	3019406		
31062	2834	40758406	1990-08-09	1990-08-09 00:00:00	1990-08-09	5001	0	\N	0	0	\N	\N	0	188180	0	55277-8	40758406		
15819	1446	3005136	1984-09-08	1984-09-08 00:00:00	1984-09-08	5001	0	\N	0	0	\N	\N	0	96389	0	6075-6	3005136		
121411	3745	4133840	2005-08-03	2005-08-03 00:00:00	2005-08-03	5001	0	\N	0	0	\N	\N	0	248973	0	127783003	4133840		
13500	1276	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	84174	0	6158-0	3019406		
57196	5252	3011505	2015-05-19	2015-05-19 00:00:00	2015-05-19	5001	0	\N	0	0	\N	\N	0	349447	0	19926-5	3011505		
9081	865	3006322	1987-04-22	1987-04-22 00:00:00	1987-04-22	5001	0	\N	0	0	\N	\N	0	57395	0	8331-1	3006322		
12414	1176	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	77590	0	6082-2	3000876		
39182	3622	3006322	1932-10-16	1932-10-16 00:00:00	1932-10-16	5001	0	\N	0	0	\N	\N	0	240768	0	8331-1	3006322		
50210	4578	3051031	1965-10-21	1965-10-21 00:00:00	1965-10-21	5001	0	\N	0	0	\N	\N	0	304975	0	46240-8	3051031		
14929	1385	3000963	2007-05-02	2007-05-02 00:00:00	2007-05-02	5001	0	\N	0	0	\N	\N	0	91820	0	718-7	3000963		
160923	4943	4024958	1965-05-14	1965-05-14 00:00:00	1965-05-14	5001	0	\N	0	0	\N	\N	0	328553	0	117015009	4024958		
19656	614	4024958	1967-06-16	1967-06-16 00:00:00	1967-06-16	5001	0	\N	0	0	\N	\N	0	40855	0	117015009	4024958		
18641	1716	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	114632	0	6075-6	3005136		
18747	1727	3006322	1970-03-21	1970-03-21 00:00:00	1970-03-21	5001	0	\N	0	0	\N	\N	0	115465	0	8331-1	3006322		
169397	5199	4052083	1999-01-08	1999-01-08 00:00:00	1999-01-08	5001	0	\N	0	0	\N	\N	0	345769	0	23426006	4052083		
57180	1745	4052083	2018-03-18	2018-03-18 00:00:00	2018-03-18	5001	0	\N	0	0	\N	\N	0	116653	0	23426006	4052083		
57547	1756	4024958	1980-08-03	1980-08-03 00:00:00	1980-08-03	5001	0	\N	0	0	\N	\N	0	117460	0	117015009	4024958		
41593	3874	40766240	1983-02-21	1983-02-21 00:00:00	1983-02-21	5001	0	\N	0	0	\N	\N	0	257305	0	63513-6	40766240		
2163	195	3006322	2004-05-29	2004-05-29 00:00:00	2004-05-29	5001	0	\N	0	0	\N	\N	0	13392	0	8331-1	3006322		
18889	1737	3006322	1918-08-19	1918-08-19 00:00:00	1918-08-19	5001	0	\N	0	0	\N	\N	0	116036	0	8331-1	3006322		
54666	4998	3006322	1995-07-10	1995-07-10 00:00:00	1995-07-10	5001	0	\N	0	0	\N	\N	0	332331	0	8331-1	3006322		
26084	2396	3049273	1997-10-19	1997-10-19 00:00:00	1997-10-19	5001	0	\N	0	0	\N	\N	0	159323	0	38265-5	3049273		
1147	94	3006322	1963-11-21	1963-11-21 00:00:00	1963-11-21	5001	0	\N	0	0	\N	\N	0	6338	0	8331-1	3006322		
23188	2135	3014599	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	142038	0	6106-9	3014599		
27935	2567	3006322	2018-07-09	2018-07-09 00:00:00	2018-07-09	5001	0	\N	0	0	\N	\N	0	170079	0	8331-1	3006322		
18397	1683	3006322	1978-10-17	1978-10-17 00:00:00	1978-10-17	5001	0	\N	0	0	\N	\N	0	112774	0	8331-1	3006322		
34695	3176	40769189	2001-12-09	2001-12-09 00:00:00	2001-12-09	5001	0	\N	0	0	\N	\N	0	211153	0	66529-9	40769189		
55463	5094	3019406	1999-05-19	1999-05-19 00:00:00	1999-05-19	5001	0	\N	0	0	\N	\N	0	338442	0	6158-0	3019406		
15269	1399	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	92997	0	6246-3	3021226		
51925	4761	3036780	1993-05-10	1993-05-10 00:00:00	1993-05-10	5001	0	\N	0	0	\N	\N	0	317261	0	6095-4	3036780		
26696	2462	3000876	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	163320	0	6082-2	3000876		
6193	190	4052083	1949-12-26	1949-12-26 00:00:00	1949-12-26	5001	0	\N	0	0	\N	\N	0	12913	0	23426006	4052083		
56572	5194	3006322	1981-12-08	1981-12-08 00:00:00	1981-12-08	5001	0	\N	0	0	\N	\N	0	345366	0	8331-1	3006322		
3726	116	4052083	1952-11-22	1952-11-22 00:00:00	1952-11-22	5001	0	\N	0	0	\N	\N	0	7656	0	23426006	4052083		
56675	5200	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	345811	0	6082-2	3000876		
30921	2830	3014599	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	187752	0	6106-9	3014599		
10097	959	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	63712	0	6158-0	3019406		
38352	3531	3006322	1981-09-07	1981-09-07 00:00:00	1981-09-07	5001	0	\N	0	0	\N	\N	0	234541	0	8331-1	3006322		
22917	2097	3006322	1990-11-05	1990-11-05 00:00:00	1990-11-05	5001	0	\N	0	0	\N	\N	0	139770	0	8331-1	3006322		
23020	2119	3019406	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	141083	0	6158-0	3019406		
30026	929	4052083	1967-11-16	1967-11-16 00:00:00	1967-11-16	5001	0	\N	0	0	\N	\N	0	61840	0	23426006	4052083		
19042	1744	3006322	2016-12-03	2016-12-03 00:00:00	2016-12-03	5001	0	\N	0	0	\N	\N	0	116640	0	8331-1	3006322		
2541	246	3011505	2014-05-22	2014-05-22 00:00:00	2014-05-22	5001	0	\N	0	0	\N	\N	0	16516	0	19926-5	3011505		
55602	5107	3006322	1990-12-02	1990-12-02 00:00:00	1990-12-02	5001	0	\N	0	0	\N	\N	0	339339	0	8331-1	3006322		
1286	103	3000963	2002-05-19	2002-05-19 00:00:00	2002-05-19	5001	0	\N	0	0	\N	\N	0	7047	0	718-7	3000963		
72761	2233	4052083	1986-01-03	1986-01-03 00:00:00	1986-01-03	5001	0	\N	0	0	\N	\N	0	148585	0	23426006	4052083		
9448	299	4052083	2011-11-27	2011-11-27 00:00:00	2011-11-27	5001	0	\N	0	0	\N	\N	0	19993	0	23426006	4052083		
42033	3889	3006322	1939-04-07	1939-04-07 00:00:00	1939-04-07	5001	0	\N	0	0	\N	\N	0	258495	0	8331-1	3006322		
33571	3044	3006322	1977-10-21	1977-10-21 00:00:00	1977-10-21	5001	0	\N	0	0	\N	\N	0	202604	0	8331-1	3006322		
56166	1715	4024958	1960-04-21	1960-04-21 00:00:00	1960-04-21	5001	0	\N	0	0	\N	\N	0	114566	0	117015009	4024958		
52110	4784	3006322	2004-02-08	2004-02-08 00:00:00	2004-02-08	5001	0	\N	0	0	\N	\N	0	318482	0	8331-1	3006322		
35757	3277	3006322	1963-07-08	1963-07-08 00:00:00	1963-07-08	5001	0	\N	0	0	\N	\N	0	217719	0	8331-1	3006322		
75542	2319	4052083	1980-10-11	1980-10-11 00:00:00	1980-10-11	5001	0	\N	0	0	\N	\N	0	154164	0	23426006	4052083		
11388	1091	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	71626	0	6106-9	3014599		
14847	1378	3001247	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	91332	0	6085-5	3001247		
21352	1971	3006322	1993-06-16	1993-06-16 00:00:00	1993-06-16	5001	0	\N	0	0	\N	\N	0	131026	0	8331-1	3006322		
30969	2832	3014599	1994-03-05	1994-03-05 00:00:00	1994-03-05	5001	0	\N	0	0	\N	\N	0	187897	0	6106-9	3014599		
31063	2834	3051031	1990-08-09	1990-08-09 00:00:00	1990-08-09	5001	0	\N	0	0	\N	\N	0	188180	0	46240-8	3051031		
15820	1446	3027231	1984-09-08	1984-09-08 00:00:00	1984-09-08	5001	0	\N	0	0	\N	\N	0	96389	0	6276-0	3027231		
121412	3745	4133840	2018-10-17	2018-10-17 00:00:00	2018-10-17	5001	0	\N	0	0	\N	\N	0	248976	0	127783003	4133840		
13501	1276	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	84174	0	6246-3	3021226		
57197	5252	3011505	2013-05-07	2013-05-07 00:00:00	2013-05-07	5001	0	\N	0	0	\N	\N	0	349428	0	19926-5	3011505		
9082	865	3006322	1955-12-10	1955-12-10 00:00:00	1955-12-10	5001	0	\N	0	0	\N	\N	0	57359	0	8331-1	3006322		
12415	1176	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	77590	0	6189-5	3006734		
39183	3622	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	240676	0	6833-8	3023430		
50212	4578	46235214	1966-03-20	1966-03-20 00:00:00	1966-03-20	5001	0	\N	0	0	\N	\N	0	304960	0	76690-7	46235214		
14930	1385	3009542	2007-05-02	2007-05-02 00:00:00	2007-05-02	5001	0	\N	0	0	\N	\N	0	91820	0	20570-8	3009542		
115457	3561	4052083	1977-07-15	1977-07-15 00:00:00	1977-07-15	5001	0	\N	0	0	\N	\N	0	236487	0	23426006	4052083		
34246	1072	4024958	1987-07-22	1987-07-22 00:00:00	1987-07-22	5001	0	\N	0	0	\N	\N	0	70250	0	117015009	4024958		
18642	1716	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	114632	0	6276-0	3027231		
18748	1727	3011505	2017-11-29	2017-11-29 00:00:00	2017-11-29	5001	0	\N	0	0	\N	\N	0	115480	0	19926-5	3011505		
169406	5199	4052083	1978-05-15	1978-05-15 00:00:00	1978-05-15	5001	0	\N	0	0	\N	\N	0	345772	0	23426006	4052083		
57183	1745	4024958	2002-09-09	2002-09-09 00:00:00	2002-09-09	5001	0	\N	0	0	\N	\N	0	116695	0	117015009	4024958		
10375	1015	3051031	2006-01-06	2006-01-06 00:00:00	2006-01-06	5001	0	\N	0	0	\N	\N	0	66770	0	46240-8	3051031		
41596	3874	40758406	1983-02-21	1983-02-21 00:00:00	1983-02-21	5001	0	\N	0	0	\N	\N	0	257305	0	55277-8	40758406		
2164	195	3006322	1987-10-12	1987-10-12 00:00:00	1987-10-12	5001	0	\N	0	0	\N	\N	0	13401	0	8331-1	3006322		
18890	1737	3006322	1956-02-12	1956-02-12 00:00:00	1956-02-12	5001	0	\N	0	0	\N	\N	0	116017	0	8331-1	3006322		
54667	4998	3006322	1993-02-08	1993-02-08 00:00:00	1993-02-08	5001	0	\N	0	0	\N	\N	0	332406	0	8331-1	3006322		
26085	2396	3006322	1973-06-13	1973-06-13 00:00:00	1973-06-13	5001	0	\N	0	0	\N	\N	0	159345	0	8331-1	3006322		
1148	94	3006322	1972-01-19	1972-01-19 00:00:00	1972-01-19	5001	0	\N	0	0	\N	\N	0	6343	0	8331-1	3006322		
23189	2135	3036780	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	142038	0	6095-4	3036780		
27936	2567	3006322	1978-11-09	1978-11-09 00:00:00	1978-11-09	5001	0	\N	0	0	\N	\N	0	170077	0	8331-1	3006322		
18398	1683	3006322	1987-11-25	1987-11-25 00:00:00	1987-11-25	5001	0	\N	0	0	\N	\N	0	112787	0	8331-1	3006322		
34696	3176	40769179	2001-12-09	2001-12-09 00:00:00	2001-12-09	5001	0	\N	0	0	\N	\N	0	211153	0	66519-0	40769179		
55464	5094	3015076	1999-05-19	1999-05-19 00:00:00	1999-05-19	5001	0	\N	0	0	\N	\N	0	338442	0	6248-9	3015076		
15270	1399	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	92997	0	6075-6	3005136		
51926	4761	3005136	1993-05-10	1993-05-10 00:00:00	1993-05-10	5001	0	\N	0	0	\N	\N	0	317261	0	6075-6	3005136		
26697	2462	3006451	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	163320	0	6273-7	3006451		
6196	190	4024958	1994-07-14	1994-07-14 00:00:00	1994-07-14	5001	0	\N	0	0	\N	\N	0	12966	0	117015009	4024958		
56573	5194	3006322	1969-12-19	1969-12-19 00:00:00	1969-12-19	5001	0	\N	0	0	\N	\N	0	345309	0	8331-1	3006322		
3732	116	4052083	1980-01-25	1980-01-25 00:00:00	1980-01-25	5001	0	\N	0	0	\N	\N	0	7678	0	23426006	4052083		
56676	5200	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	345811	0	6106-9	3014599		
30922	2830	3005136	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	187752	0	6075-6	3005136		
10098	959	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	63712	0	6206-7	3012494		
38353	3531	3006322	1999-01-27	1999-01-27 00:00:00	1999-01-27	5001	0	\N	0	0	\N	\N	0	234543	0	8331-1	3006322		
22918	2097	3006322	1986-12-15	1986-12-15 00:00:00	1986-12-15	5001	0	\N	0	0	\N	\N	0	139769	0	8331-1	3006322		
23021	2119	3036780	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	141083	0	6095-4	3036780		
76055	2334	4133840	2012-06-28	2012-06-28 00:00:00	2012-06-28	5001	0	\N	0	0	\N	\N	0	155284	0	127783003	4133840		
19043	1744	3006322	1994-05-24	1994-05-24 00:00:00	1994-05-24	5001	0	\N	0	0	\N	\N	0	116613	0	8331-1	3006322		
2549	248	3006322	1983-12-06	1983-12-06 00:00:00	1983-12-06	5001	0	\N	0	0	\N	\N	0	16687	0	8331-1	3006322		
55603	5107	3006322	2018-03-02	2018-03-02 00:00:00	2018-03-02	5001	0	\N	0	0	\N	\N	0	339334	0	8331-1	3006322		
1288	105	3006322	1986-09-30	1986-09-30 00:00:00	1986-09-30	5001	0	\N	0	0	\N	\N	0	7100	0	8331-1	3006322		
72762	2233	4052083	1973-01-28	1973-01-28 00:00:00	1973-01-28	5001	0	\N	0	0	\N	\N	0	148549	0	23426006	4052083		
9450	299	4133840	2013-12-21	2013-12-21 00:00:00	2013-12-21	5001	0	\N	0	0	\N	\N	0	19991	0	127783003	4133840		
42034	3889	3006322	1998-11-18	1998-11-18 00:00:00	1998-11-18	5001	0	\N	0	0	\N	\N	0	258455	0	8331-1	3006322		
33574	3047	3006322	1990-06-10	1990-06-10 00:00:00	1990-06-10	5001	0	\N	0	0	\N	\N	0	202721	0	8331-1	3006322		
56167	1715	4052083	1970-06-20	1970-06-20 00:00:00	1970-06-20	5001	0	\N	0	0	\N	\N	0	114562	0	23426006	4052083		
52111	4784	3051031	1950-06-30	1950-06-30 00:00:00	1950-06-30	5001	0	\N	0	0	\N	\N	0	318454	0	46240-8	3051031		
35758	3277	3049273	2017-06-24	2017-06-24 00:00:00	2017-06-24	5001	0	\N	0	0	\N	\N	0	217742	0	38265-5	3049273		
75555	2319	4024958	1964-11-25	1964-11-25 00:00:00	1964-11-25	5001	0	\N	0	0	\N	\N	0	154227	0	117015009	4024958		
11389	1091	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	71626	0	6075-6	3005136		
14848	1378	3000876	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	91332	0	6082-2	3000876		
21353	1971	3006322	1980-03-03	1980-03-03 00:00:00	1980-03-03	5001	0	\N	0	0	\N	\N	0	131084	0	8331-1	3006322		
30970	2832	3012494	1994-03-05	1994-03-05 00:00:00	1994-03-05	5001	0	\N	0	0	\N	\N	0	187897	0	6206-7	3012494		
31064	2834	46235214	1990-08-09	1990-08-09 00:00:00	1990-08-09	5001	0	\N	0	0	\N	\N	0	188180	0	76690-7	46235214		
15821	1446	3014599	1984-09-08	1984-09-08 00:00:00	1984-09-08	5001	0	\N	0	0	\N	\N	0	96389	0	6106-9	3014599		
121416	3745	4133840	2010-09-01	2010-09-01 00:00:00	2010-09-01	5001	0	\N	0	0	\N	\N	0	248969	0	127783003	4133840		
13502	1276	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	84174	0	7258-7	3001488		
57198	5252	3011505	2001-04-17	2001-04-17 00:00:00	2001-04-17	5001	0	\N	0	0	\N	\N	0	349402	0	19926-5	3011505		
9083	865	3006322	2002-10-13	2002-10-13 00:00:00	2002-10-13	5001	0	\N	0	0	\N	\N	0	57401	0	8331-1	3006322		
12416	1176	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	77590	0	6273-7	3006451		
39184	3622	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	240676	0	6158-0	3019406		
50214	4578	3051031	1966-03-20	1966-03-20 00:00:00	1966-03-20	5001	0	\N	0	0	\N	\N	0	304960	0	46240-8	3051031		
14931	1385	3006322	1991-06-30	1991-06-30 00:00:00	1991-06-30	5001	0	\N	0	0	\N	\N	0	91825	0	8331-1	3006322		
138618	4274	4024958	1930-03-10	1930-03-10 00:00:00	1930-03-10	5001	0	\N	0	0	\N	\N	0	283661	0	117015009	4024958		
34266	1072	4024958	2002-05-21	2002-05-21 00:00:00	2002-05-21	5001	0	\N	0	0	\N	\N	0	70278	0	117015009	4024958		
18643	1716	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	114632	0	6206-7	3012494		
18749	1727	3011505	2006-09-28	2006-09-28 00:00:00	2006-09-28	5001	0	\N	0	0	\N	\N	0	115478	0	19926-5	3011505		
169413	5199	4052083	2005-06-06	2005-06-06 00:00:00	2005-06-06	5001	0	\N	0	0	\N	\N	0	345782	0	23426006	4052083		
57185	1745	4024958	1985-07-28	1985-07-28 00:00:00	1985-07-28	5001	0	\N	0	0	\N	\N	0	116650	0	117015009	4024958		
10376	1015	40766240	2019-05-28	2019-05-28 00:00:00	2019-05-28	5001	0	\N	0	0	\N	\N	0	66797	0	63513-6	40766240		
41597	3874	46235214	1983-02-21	1983-02-21 00:00:00	1983-02-21	5001	0	\N	0	0	\N	\N	0	257305	0	76690-7	46235214		
2165	195	3006322	1965-12-07	1965-12-07 00:00:00	1965-12-07	5001	0	\N	0	0	\N	\N	0	13352	0	8331-1	3006322		
18891	1737	3006322	1935-08-15	1935-08-15 00:00:00	1935-08-15	5001	0	\N	0	0	\N	\N	0	115977	0	8331-1	3006322		
54668	4998	3006322	1975-01-19	1975-01-19 00:00:00	1975-01-19	5001	0	\N	0	0	\N	\N	0	332404	0	8331-1	3006322		
26086	2396	3006322	1937-12-27	1937-12-27 00:00:00	1937-12-27	5001	0	\N	0	0	\N	\N	0	159302	0	8331-1	3006322		
1149	94	40766240	1953-06-26	1953-06-26 00:00:00	1953-06-26	5001	0	\N	0	0	\N	\N	0	6312	0	63513-6	40766240		
23190	2135	3006451	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	142038	0	6273-7	3006451		
27937	2567	3006322	2008-01-20	2008-01-20 00:00:00	2008-01-20	5001	0	\N	0	0	\N	\N	0	170100	0	8331-1	3006322		
18399	1683	3006322	1983-11-04	1983-11-04 00:00:00	1983-11-04	5001	0	\N	0	0	\N	\N	0	112798	0	8331-1	3006322		
34697	3176	40769184	2001-12-09	2001-12-09 00:00:00	2001-12-09	5001	0	\N	0	0	\N	\N	0	211153	0	66524-0	40769184		
55465	5094	3006451	1999-05-19	1999-05-19 00:00:00	1999-05-19	5001	0	\N	0	0	\N	\N	0	338442	0	6273-7	3006451		
15271	1399	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	92997	0	6248-9	3015076		
51927	4761	3027231	1993-05-10	1993-05-10 00:00:00	1993-05-10	5001	0	\N	0	0	\N	\N	0	317261	0	6276-0	3027231		
26698	2462	3014599	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	163320	0	6106-9	3014599		
6208	190	4024958	1963-10-10	1963-10-10 00:00:00	1963-10-10	5001	0	\N	0	0	\N	\N	0	12982	0	117015009	4024958		
56574	5194	3006322	2012-10-11	2012-10-11 00:00:00	2012-10-11	5001	0	\N	0	0	\N	\N	0	345352	0	8331-1	3006322		
3740	116	4024958	2004-10-03	2004-10-03 00:00:00	2004-10-03	5001	0	\N	0	0	\N	\N	0	7723	0	117015009	4024958		
56677	5200	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	345811	0	6158-0	3019406		
30923	2830	3006734	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	187752	0	6189-5	3006734		
10099	959	3006322	1972-01-13	1972-01-13 00:00:00	1972-01-13	5001	0	\N	0	0	\N	\N	0	63749	0	8331-1	3006322		
38354	3531	3006322	1972-08-30	1972-08-30 00:00:00	1972-08-30	5001	0	\N	0	0	\N	\N	0	234519	0	8331-1	3006322		
22919	2098	3006322	1999-11-16	1999-11-16 00:00:00	1999-11-16	5001	0	\N	0	0	\N	\N	0	139897	0	8331-1	3006322		
23022	2119	3027231	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	141083	0	6276-0	3027231		
76056	2334	4133840	1996-03-28	1996-03-28 00:00:00	1996-03-28	5001	0	\N	0	0	\N	\N	0	155292	0	127783003	4133840		
19044	1745	3006322	2002-09-09	2002-09-09 00:00:00	2002-09-09	5001	0	\N	0	0	\N	\N	0	116695	0	8331-1	3006322		
2550	248	3006322	2013-01-16	2013-01-16 00:00:00	2013-01-16	5001	0	\N	0	0	\N	\N	0	16681	0	8331-1	3006322		
55604	5108	3006322	1963-10-23	1963-10-23 00:00:00	1963-10-23	5001	0	\N	0	0	\N	\N	0	339432	0	8331-1	3006322		
1289	105	3006322	1979-03-03	1979-03-03 00:00:00	1979-03-03	5001	0	\N	0	0	\N	\N	0	7143	0	8331-1	3006322		
72782	2235	4024958	2000-10-19	2000-10-19 00:00:00	2000-10-19	5001	0	\N	0	0	\N	\N	0	148691	0	117015009	4024958		
9452	299	4133840	2017-06-24	2017-06-24 00:00:00	2017-06-24	5001	0	\N	0	0	\N	\N	0	19984	0	127783003	4133840		
42035	3889	3006322	1966-02-25	1966-02-25 00:00:00	1966-02-25	5001	0	\N	0	0	\N	\N	0	258478	0	8331-1	3006322		
33575	3047	3006322	1976-11-06	1976-11-06 00:00:00	1976-11-06	5001	0	\N	0	0	\N	\N	0	202718	0	8331-1	3006322		
56168	1716	4052083	1965-03-06	1965-03-06 00:00:00	1965-03-06	5001	0	\N	0	0	\N	\N	0	114733	0	23426006	4052083		
52112	4784	40758406	1950-06-30	1950-06-30 00:00:00	1950-06-30	5001	0	\N	0	0	\N	\N	0	318454	0	55277-8	40758406		
35759	3277	3006322	1974-06-20	1974-06-20 00:00:00	1974-06-20	5001	0	\N	0	0	\N	\N	0	217701	0	8331-1	3006322		
75565	2319	4024958	1984-02-06	1984-02-06 00:00:00	1984-02-06	5001	0	\N	0	0	\N	\N	0	154208	0	117015009	4024958		
11390	1091	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	71626	0	6248-9	3015076		
147384	4520	4133840	1992-01-11	1992-01-11 00:00:00	1992-01-11	5001	0	\N	0	0	\N	\N	0	300935	0	127783003	4133840		
21354	1971	3006322	1985-12-16	1985-12-16 00:00:00	1985-12-16	5001	0	\N	0	0	\N	\N	0	130988	0	8331-1	3006322		
30971	2832	3015076	1994-03-05	1994-03-05 00:00:00	1994-03-05	5001	0	\N	0	0	\N	\N	0	187897	0	6248-9	3015076		
31066	2834	40766240	1990-08-09	1990-08-09 00:00:00	1990-08-09	5001	0	\N	0	0	\N	\N	0	188180	0	63513-6	40766240		
15822	1446	3015076	1984-09-08	1984-09-08 00:00:00	1984-09-08	5001	0	\N	0	0	\N	\N	0	96389	0	6248-9	3015076		
121420	3745	4133840	2015-09-30	2015-09-30 00:00:00	2015-09-30	5001	0	\N	0	0	\N	\N	0	248895	0	127783003	4133840		
13503	1276	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	84174	0	6833-8	3023430		
57199	5252	3011505	2004-04-13	2004-04-13 00:00:00	2004-04-13	5001	0	\N	0	0	\N	\N	0	349445	0	19926-5	3011505		
9084	866	3006322	1966-05-08	1966-05-08 00:00:00	1966-05-08	5001	0	\N	0	0	\N	\N	0	57464	0	8331-1	3006322		
12417	1176	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	77590	0	6206-7	3012494		
39185	3622	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	240676	0	6844-5	3020655		
50216	4578	40758406	1966-03-20	1966-03-20 00:00:00	1966-03-20	5001	0	\N	0	0	\N	\N	0	304960	0	55277-8	40758406		
14932	1385	3006322	1983-11-24	1983-11-24 00:00:00	1983-11-24	5001	0	\N	0	0	\N	\N	0	91819	0	8331-1	3006322		
138622	4274	4024958	1960-05-16	1960-05-16 00:00:00	1960-05-16	5001	0	\N	0	0	\N	\N	0	283636	0	117015009	4024958		
34268	1072	4052083	1979-01-12	1979-01-12 00:00:00	1979-01-12	5001	0	\N	0	0	\N	\N	0	70248	0	23426006	4052083		
18644	1716	3006322	1969-11-22	1969-11-22 00:00:00	1969-11-22	5001	0	\N	0	0	\N	\N	0	114735	0	8331-1	3006322		
18750	1727	3011505	2018-12-05	2018-12-05 00:00:00	2018-12-05	5001	0	\N	0	0	\N	\N	0	115484	0	19926-5	3011505		
169416	5199	4024958	1974-09-25	1974-09-25 00:00:00	1974-09-25	5001	0	\N	0	0	\N	\N	0	345780	0	117015009	4024958		
57192	1745	4052083	2007-06-19	2007-06-19 00:00:00	2007-06-19	5001	0	\N	0	0	\N	\N	0	116688	0	23426006	4052083		
10378	1015	46235214	2019-05-28	2019-05-28 00:00:00	2019-05-28	5001	0	\N	0	0	\N	\N	0	66797	0	76690-7	46235214		
41598	3874	3006322	1998-05-25	1998-05-25 00:00:00	1998-05-25	5001	0	\N	0	0	\N	\N	0	257270	0	8331-1	3006322		
2166	195	3006322	1976-11-22	1976-11-22 00:00:00	1976-11-22	5001	0	\N	0	0	\N	\N	0	13390	0	8331-1	3006322		
18892	1737	3006322	1993-03-31	1993-03-31 00:00:00	1993-03-31	5001	0	\N	0	0	\N	\N	0	116037	0	8331-1	3006322		
54669	4998	40769184	1965-05-20	1965-05-20 00:00:00	1965-05-20	5001	0	\N	0	0	\N	\N	0	332366	0	66524-0	40769184		
26087	2396	3006322	1991-09-14	1991-09-14 00:00:00	1991-09-14	5001	0	\N	0	0	\N	\N	0	159347	0	8331-1	3006322		
1150	94	46235214	1953-06-26	1953-06-26 00:00:00	1953-06-26	5001	0	\N	0	0	\N	\N	0	6312	0	76690-7	46235214		
23191	2135	3006734	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	142038	0	6189-5	3006734		
27992	2570	3049273	2015-05-22	2015-05-22 00:00:00	2015-05-22	5001	0	\N	0	0	\N	\N	0	170200	0	38265-5	3049273		
65189	1999	4024958	1990-03-22	1990-03-22 00:00:00	1990-03-22	5001	0	\N	0	0	\N	\N	0	133070	0	117015009	4024958		
34698	3176	40769194	2001-12-09	2001-12-09 00:00:00	2001-12-09	5001	0	\N	0	0	\N	\N	0	211153	0	66534-9	40769194		
55466	5094	3006734	1999-05-19	1999-05-19 00:00:00	1999-05-19	5001	0	\N	0	0	\N	\N	0	338442	0	6189-5	3006734		
15272	1399	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	92997	0	6276-0	3027231		
51928	4761	3014599	1993-05-10	1993-05-10 00:00:00	1993-05-10	5001	0	\N	0	0	\N	\N	0	317261	0	6106-9	3014599		
26699	2462	3027231	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	163320	0	6276-0	3027231		
6214	191	4133840	2001-11-06	2001-11-06 00:00:00	2001-11-06	5001	0	\N	0	0	\N	\N	0	13130	0	127783003	4133840		
56575	5194	3006322	2013-05-21	2013-05-21 00:00:00	2013-05-21	5001	0	\N	0	0	\N	\N	0	345353	0	8331-1	3006322		
35742	1108	4052083	2000-05-12	2000-05-12 00:00:00	2000-05-12	5001	0	\N	0	0	\N	\N	0	72985	0	23426006	4052083		
56678	5200	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	345811	0	6075-6	3005136		
30924	2830	3001488	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	187752	0	7258-7	3001488		
10100	959	3006322	1979-01-16	1979-01-16 00:00:00	1979-01-16	5001	0	\N	0	0	\N	\N	0	63698	0	8331-1	3006322		
38355	3531	3006322	1990-02-03	1990-02-03 00:00:00	1990-02-03	5001	0	\N	0	0	\N	\N	0	234571	0	8331-1	3006322		
22920	2098	3006322	2004-06-18	2004-06-18 00:00:00	2004-06-18	5001	0	\N	0	0	\N	\N	0	139828	0	8331-1	3006322		
23023	2119	3006451	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	141083	0	6273-7	3006451		
76058	2334	4133840	1989-02-16	1989-02-16 00:00:00	1989-02-16	5001	0	\N	0	0	\N	\N	0	155338	0	127783003	4133840		
19045	1745	3006322	1985-07-28	1985-07-28 00:00:00	1985-07-28	5001	0	\N	0	0	\N	\N	0	116650	0	8331-1	3006322		
2551	249	3006322	2013-07-21	2013-07-21 00:00:00	2013-07-21	5001	0	\N	0	0	\N	\N	0	16757	0	8331-1	3006322		
55605	5108	3006322	1962-10-18	1962-10-18 00:00:00	1962-10-18	5001	0	\N	0	0	\N	\N	0	339431	0	8331-1	3006322		
1298	110	3006322	1984-04-06	1984-04-06 00:00:00	1984-04-06	5001	0	\N	0	0	\N	\N	0	7317	0	8331-1	3006322		
72786	2235	4024958	1992-07-19	1992-07-19 00:00:00	1992-07-19	5001	0	\N	0	0	\N	\N	0	148690	0	117015009	4024958		
9456	299	4133840	2017-01-07	2017-01-07 00:00:00	2017-01-07	5001	0	\N	0	0	\N	\N	0	19982	0	127783003	4133840		
42036	3890	3006322	1987-01-19	1987-01-19 00:00:00	1987-01-19	5001	0	\N	0	0	\N	\N	0	258559	0	8331-1	3006322		
33576	3047	3006322	1993-01-07	1993-01-07 00:00:00	1993-01-07	5001	0	\N	0	0	\N	\N	0	202722	0	8331-1	3006322		
56169	1716	4024958	1963-02-17	1963-02-17 00:00:00	1963-02-17	5001	0	\N	0	0	\N	\N	0	114603	0	117015009	4024958		
52113	4784	40766240	1950-06-30	1950-06-30 00:00:00	1950-06-30	5001	0	\N	0	0	\N	\N	0	318454	0	63513-6	40766240		
35760	3278	3006322	2012-04-13	2012-04-13 00:00:00	2012-04-13	5001	0	\N	0	0	\N	\N	0	217780	0	8331-1	3006322		
75569	2319	4024958	2001-12-25	2001-12-25 00:00:00	2001-12-25	5001	0	\N	0	0	\N	\N	0	154228	0	117015009	4024958		
11391	1091	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	71626	0	6276-0	3027231		
147386	4520	4133840	1968-09-28	1968-09-28 00:00:00	1968-09-28	5001	0	\N	0	0	\N	\N	0	300930	0	127783003	4133840		
21355	1971	3006322	1971-04-07	1971-04-07 00:00:00	1971-04-07	5001	0	\N	0	0	\N	\N	0	131020	0	8331-1	3006322		
30972	2832	3027231	1994-03-05	1994-03-05 00:00:00	1994-03-05	5001	0	\N	0	0	\N	\N	0	187897	0	6276-0	3027231		
31068	2835	3006322	1968-08-14	1968-08-14 00:00:00	1968-08-14	5001	0	\N	0	0	\N	\N	0	188269	0	8331-1	3006322		
15823	1446	3006451	1984-09-08	1984-09-08 00:00:00	1984-09-08	5001	0	\N	0	0	\N	\N	0	96389	0	6273-7	3006451		
121423	3745	4133840	1998-06-24	1998-06-24 00:00:00	1998-06-24	5001	0	\N	0	0	\N	\N	0	248960	0	127783003	4133840		
13504	1276	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	84174	0	6844-5	3020655		
57200	5252	3006322	1990-02-15	1990-02-15 00:00:00	1990-02-15	5001	0	\N	0	0	\N	\N	0	349459	0	8331-1	3006322		
9085	866	3006322	1979-09-19	1979-09-19 00:00:00	1979-09-19	5001	0	\N	0	0	\N	\N	0	57445	0	8331-1	3006322		
12418	1176	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	77590	0	6246-3	3021226		
39186	3622	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	240676	0	6248-9	3015076		
50217	4578	3006322	1993-04-26	1993-04-26 00:00:00	1993-04-26	5001	0	\N	0	0	\N	\N	0	304965	0	8331-1	3006322		
14933	1385	3006322	1972-05-22	1972-05-22 00:00:00	1972-05-22	5001	0	\N	0	0	\N	\N	0	91818	0	8331-1	3006322		
138634	4274	4024958	1986-01-06	1986-01-06 00:00:00	1986-01-06	5001	0	\N	0	0	\N	\N	0	283554	0	117015009	4024958		
34269	1072	4024958	1994-07-23	1994-07-23 00:00:00	1994-07-23	5001	0	\N	0	0	\N	\N	0	70259	0	117015009	4024958		
18645	1716	3049273	2010-08-25	2010-08-25 00:00:00	2010-08-25	5001	0	\N	0	0	\N	\N	0	114709	0	38265-5	3049273		
18751	1727	3006322	1961-10-23	1961-10-23 00:00:00	1961-10-23	5001	0	\N	0	0	\N	\N	0	115520	0	8331-1	3006322		
169432	5200	4052083	1995-01-27	1995-01-27 00:00:00	1995-01-27	5001	0	\N	0	0	\N	\N	0	345812	0	23426006	4052083		
57195	1745	4024958	2003-11-19	2003-11-19 00:00:00	2003-11-19	5001	0	\N	0	0	\N	\N	0	116687	0	117015009	4024958		
10379	1015	40758406	2019-05-28	2019-05-28 00:00:00	2019-05-28	5001	0	\N	0	0	\N	\N	0	66797	0	55277-8	40758406		
41599	3874	3001247	1984-01-20	1984-01-20 00:00:00	1984-01-20	5001	0	\N	0	0	\N	\N	0	257211	0	6085-5	3001247		
2167	195	3006322	2014-12-25	2014-12-25 00:00:00	2014-12-25	5001	0	\N	0	0	\N	\N	0	13394	0	8331-1	3006322		
18893	1737	3006322	1988-10-10	1988-10-10 00:00:00	1988-10-10	5001	0	\N	0	0	\N	\N	0	116098	0	8331-1	3006322		
54670	4998	40769189	1965-05-20	1965-05-20 00:00:00	1965-05-20	5001	0	\N	0	0	\N	\N	0	332366	0	66529-9	40769189		
26088	2396	3006322	1985-07-04	1985-07-04 00:00:00	1985-07-04	5001	0	\N	0	0	\N	\N	0	159374	0	8331-1	3006322		
1151	94	40758406	1953-06-26	1953-06-26 00:00:00	1953-06-26	5001	0	\N	0	0	\N	\N	0	6312	0	55277-8	40758406		
23192	2135	3021226	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	142038	0	6246-3	3021226		
27993	2570	3006322	1975-11-09	1975-11-09 00:00:00	1975-11-09	5001	0	\N	0	0	\N	\N	0	170267	0	8331-1	3006322		
65225	1999	4052083	1981-03-08	1981-03-08 00:00:00	1981-03-08	5001	0	\N	0	0	\N	\N	0	133053	0	23426006	4052083		
34699	3176	3000876	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	211108	0	6082-2	3000876		
55467	5094	3000876	1999-05-19	1999-05-19 00:00:00	1999-05-19	5001	0	\N	0	0	\N	\N	0	338442	0	6082-2	3000876		
15273	1399	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	92997	0	6189-5	3006734		
51929	4761	3006322	1989-03-23	1989-03-23 00:00:00	1989-03-23	5001	0	\N	0	0	\N	\N	0	317213	0	8331-1	3006322		
26700	2462	3036780	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	163320	0	6095-4	3036780		
6216	191	4024958	1957-04-03	1957-04-03 00:00:00	1957-04-03	5001	0	\N	0	0	\N	\N	0	13021	0	117015009	4024958		
56576	5194	3006322	1948-12-15	1948-12-15 00:00:00	1948-12-15	5001	0	\N	0	0	\N	\N	0	345297	0	8331-1	3006322		
35795	1110	4052083	1988-10-11	1988-10-11 00:00:00	1988-10-11	5001	0	\N	0	0	\N	\N	0	73100	0	23426006	4052083		
56679	5200	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	345811	0	6246-3	3021226		
30925	2830	3000876	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	187752	0	6082-2	3000876		
10101	959	3006322	2017-06-01	2017-06-01 00:00:00	2017-06-01	5001	0	\N	0	0	\N	\N	0	63778	0	8331-1	3006322		
38356	3531	3006322	2014-07-18	2014-07-18 00:00:00	2014-07-18	5001	0	\N	0	0	\N	\N	0	234563	0	8331-1	3006322		
22921	2098	3006322	1968-02-06	1968-02-06 00:00:00	1968-02-06	5001	0	\N	0	0	\N	\N	0	139893	0	8331-1	3006322		
23024	2119	3012494	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	141083	0	6206-7	3012494		
76060	2334	4133840	1976-05-13	1976-05-13 00:00:00	1976-05-13	5001	0	\N	0	0	\N	\N	0	155335	0	127783003	4133840		
19046	1745	3006322	2003-11-19	2003-11-19 00:00:00	2003-11-19	5001	0	\N	0	0	\N	\N	0	116687	0	8331-1	3006322		
2552	249	3006322	1992-02-29	1992-02-29 00:00:00	1992-02-29	5001	0	\N	0	0	\N	\N	0	16767	0	8331-1	3006322		
55606	5108	3006322	1982-01-23	1982-01-23 00:00:00	1982-01-23	5001	0	\N	0	0	\N	\N	0	339410	0	8331-1	3006322		
1299	110	3006322	2012-12-17	2012-12-17 00:00:00	2012-12-17	5001	0	\N	0	0	\N	\N	0	7325	0	8331-1	3006322		
127355	3917	4024958	1971-04-20	1971-04-20 00:00:00	1971-04-20	5001	0	\N	0	0	\N	\N	0	260498	0	117015009	4024958		
9458	299	4052083	2019-01-12	2019-01-12 00:00:00	2019-01-12	5001	0	\N	0	0	\N	\N	0	19995	0	23426006	4052083		
42037	3890	3006322	1995-07-04	1995-07-04 00:00:00	1995-07-04	5001	0	\N	0	0	\N	\N	0	258554	0	8331-1	3006322		
33577	3049	3006322	2014-10-10	2014-10-10 00:00:00	2014-10-10	5001	0	\N	0	0	\N	\N	0	202851	0	8331-1	3006322		
56188	1716	4052083	1982-07-02	1982-07-02 00:00:00	1982-07-02	5001	0	\N	0	0	\N	\N	0	114604	0	23426006	4052083		
52116	4784	46235214	1950-06-30	1950-06-30 00:00:00	1950-06-30	5001	0	\N	0	0	\N	\N	0	318454	0	76690-7	46235214		
35761	3278	3006322	2018-12-02	2018-12-02 00:00:00	2018-12-02	5001	0	\N	0	0	\N	\N	0	217786	0	8331-1	3006322		
75585	2320	4052083	2001-08-23	2001-08-23 00:00:00	2001-08-23	5001	0	\N	0	0	\N	\N	0	154287	0	23426006	4052083		
11392	1091	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	71626	0	6246-3	3021226		
147389	4520	4133840	1987-12-19	1987-12-19 00:00:00	1987-12-19	5001	0	\N	0	0	\N	\N	0	300933	0	127783003	4133840		
21357	1973	3006322	1981-05-18	1981-05-18 00:00:00	1981-05-18	5001	0	\N	0	0	\N	\N	0	131145	0	8331-1	3006322		
30973	2832	3006451	1994-03-05	1994-03-05 00:00:00	1994-03-05	5001	0	\N	0	0	\N	\N	0	187897	0	6273-7	3006451		
31069	2835	3006322	1936-09-07	1936-09-07 00:00:00	1936-09-07	5001	0	\N	0	0	\N	\N	0	188314	0	8331-1	3006322		
15824	1446	3020655	1984-09-08	1984-09-08 00:00:00	1984-09-08	5001	0	\N	0	0	\N	\N	0	96389	0	6844-5	3020655		
121424	3745	4133840	2006-08-09	2006-08-09 00:00:00	2006-08-09	5001	0	\N	0	0	\N	\N	0	248894	0	127783003	4133840		
13505	1276	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	84174	0	6082-2	3000876		
57201	5252	3011505	2008-12-09	2008-12-09 00:00:00	2008-12-09	5001	0	\N	0	0	\N	\N	0	349426	0	19926-5	3011505		
9086	866	3006322	1966-08-18	1966-08-18 00:00:00	1966-08-18	5001	0	\N	0	0	\N	\N	0	57465	0	8331-1	3006322		
12419	1176	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	77590	0	6075-6	3005136		
39187	3622	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	240676	0	6075-6	3005136		
50218	4578	40766240	1966-03-20	1966-03-20 00:00:00	1966-03-20	5001	0	\N	0	0	\N	\N	0	304960	0	63513-6	40766240		
14934	1385	3006322	2016-11-12	2016-11-12 00:00:00	2016-11-12	5001	0	\N	0	0	\N	\N	0	91830	0	8331-1	3006322		
138639	4274	4024958	1964-06-06	1964-06-06 00:00:00	1964-06-06	5001	0	\N	0	0	\N	\N	0	283618	0	117015009	4024958		
34271	1072	4024958	2003-12-25	2003-12-25 00:00:00	2003-12-25	5001	0	\N	0	0	\N	\N	0	70244	0	117015009	4024958		
18646	1716	3006322	1977-08-05	1977-08-05 00:00:00	1977-08-05	5001	0	\N	0	0	\N	\N	0	114645	0	8331-1	3006322		
18752	1727	3011505	2014-11-12	2014-11-12 00:00:00	2014-11-12	5001	0	\N	0	0	\N	\N	0	115453	0	19926-5	3011505		
20666	648	4052083	1994-11-05	1994-11-05 00:00:00	1994-11-05	5001	0	\N	0	0	\N	\N	0	42952	0	23426006	4052083		
46110	1407	4024958	2012-10-02	2012-10-02 00:00:00	2012-10-02	5001	0	\N	0	0	\N	\N	0	93485	0	117015009	4024958		
10381	1015	3051031	2019-05-28	2019-05-28 00:00:00	2019-05-28	5001	0	\N	0	0	\N	\N	0	66797	0	46240-8	3051031		
41600	3874	3001488	1984-01-20	1984-01-20 00:00:00	1984-01-20	5001	0	\N	0	0	\N	\N	0	257211	0	7258-7	3001488		
2168	196	3006322	2009-01-30	2009-01-30 00:00:00	2009-01-30	5001	0	\N	0	0	\N	\N	0	13447	0	8331-1	3006322		
18894	1737	3006322	1973-06-21	1973-06-21 00:00:00	1973-06-21	5001	0	\N	0	0	\N	\N	0	116012	0	8331-1	3006322		
54671	4998	40769179	1965-05-20	1965-05-20 00:00:00	1965-05-20	5001	0	\N	0	0	\N	\N	0	332366	0	66519-0	40769179		
26089	2396	3006322	1949-08-09	1949-08-09 00:00:00	1949-08-09	5001	0	\N	0	0	\N	\N	0	159397	0	8331-1	3006322		
1154	94	3051031	1953-06-26	1953-06-26 00:00:00	1953-06-26	5001	0	\N	0	0	\N	\N	0	6312	0	46240-8	3051031		
23193	2135	3001247	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	142038	0	6085-5	3001247		
27994	2570	3006322	1967-11-09	1967-11-09 00:00:00	1967-11-09	5001	0	\N	0	0	\N	\N	0	170195	0	8331-1	3006322		
99710	3060	4052083	1932-12-16	1932-12-16 00:00:00	1932-12-16	5001	0	\N	0	0	\N	\N	0	203570	0	23426006	4052083		
34700	3176	3019406	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	211108	0	6158-0	3019406		
55468	5094	3021226	1999-05-19	1999-05-19 00:00:00	1999-05-19	5001	0	\N	0	0	\N	\N	0	338442	0	6246-3	3021226		
15274	1399	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	92997	0	6833-8	3023430		
51933	4763	3006322	1962-12-18	1962-12-18 00:00:00	1962-12-18	5001	0	\N	0	0	\N	\N	0	317414	0	8331-1	3006322		
26701	2462	3020655	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	163320	0	6844-5	3020655		
6223	191	4133840	2002-11-12	2002-11-12 00:00:00	2002-11-12	5001	0	\N	0	0	\N	\N	0	13110	0	127783003	4133840		
56577	5194	3051031	1995-07-09	1995-07-09 00:00:00	1995-07-09	5001	0	\N	0	0	\N	\N	0	345350	0	46240-8	3051031		
47283	1441	4024958	1997-08-07	1997-08-07 00:00:00	1997-08-07	5001	0	\N	0	0	\N	\N	0	96053	0	117015009	4024958		
56680	5200	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	345811	0	6206-7	3012494		
30926	2830	3001247	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	187752	0	6085-5	3001247		
10102	959	3006322	2016-12-24	2016-12-24 00:00:00	2016-12-24	5001	0	\N	0	0	\N	\N	0	63727	0	8331-1	3006322		
38357	3532	3006322	1989-12-13	1989-12-13 00:00:00	1989-12-13	5001	0	\N	0	0	\N	\N	0	234634	0	8331-1	3006322		
22922	2098	3006322	1973-07-22	1973-07-22 00:00:00	1973-07-22	5001	0	\N	0	0	\N	\N	0	139825	0	8331-1	3006322		
23025	2119	3014599	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	141083	0	6106-9	3014599		
76062	2334	4133840	2002-05-02	2002-05-02 00:00:00	2002-05-02	5001	0	\N	0	0	\N	\N	0	155361	0	127783003	4133840		
19047	1745	3006322	1979-08-16	1979-08-16 00:00:00	1979-08-16	5001	0	\N	0	0	\N	\N	0	116670	0	8331-1	3006322		
2553	250	3006322	1983-02-12	1983-02-12 00:00:00	1983-02-12	5001	0	\N	0	0	\N	\N	0	16783	0	8331-1	3006322		
52830	1602	4024958	1964-05-13	1964-05-13 00:00:00	1964-05-13	5001	0	\N	0	0	\N	\N	0	107528	0	117015009	4024958		
1300	111	3006322	1979-01-13	1979-01-13 00:00:00	1979-01-13	5001	0	\N	0	0	\N	\N	0	7413	0	8331-1	3006322		
127627	3927	4024958	1967-10-21	1967-10-21 00:00:00	1967-10-21	5001	0	\N	0	0	\N	\N	0	261052	0	117015009	4024958		
9468	299	4133840	2018-06-30	2018-06-30 00:00:00	2018-06-30	5001	0	\N	0	0	\N	\N	0	19986	0	127783003	4133840		
42038	3890	3006322	1990-04-19	1990-04-19 00:00:00	1990-04-19	5001	0	\N	0	0	\N	\N	0	258553	0	8331-1	3006322		
33578	3049	3006322	2006-08-27	2006-08-27 00:00:00	2006-08-27	5001	0	\N	0	0	\N	\N	0	202850	0	8331-1	3006322		
56199	1716	4052083	1990-01-30	1990-01-30 00:00:00	1990-01-30	5001	0	\N	0	0	\N	\N	0	114622	0	23426006	4052083		
52117	4784	46235214	1950-05-01	1950-05-01 00:00:00	1950-05-01	5001	0	\N	0	0	\N	\N	0	318491	0	76690-7	46235214		
14581	455	4024958	1981-12-19	1981-12-19 00:00:00	1981-12-19	5001	0	\N	0	0	\N	\N	0	30407	0	117015009	4024958		
75589	2320	4052083	1947-11-01	1947-11-01 00:00:00	1947-11-01	5001	0	\N	0	0	\N	\N	0	154277	0	23426006	4052083		
11393	1091	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	71626	0	6158-0	3019406		
147393	4520	4133840	1986-12-13	1986-12-13 00:00:00	1986-12-13	5001	0	\N	0	0	\N	\N	0	300925	0	127783003	4133840		
21358	1973	3006322	2010-12-21	2010-12-21 00:00:00	2010-12-21	5001	0	\N	0	0	\N	\N	0	131163	0	8331-1	3006322		
30974	2832	3019406	1994-03-05	1994-03-05 00:00:00	1994-03-05	5001	0	\N	0	0	\N	\N	0	187897	0	6158-0	3019406		
31070	2835	3006322	1981-10-28	1981-10-28 00:00:00	1981-10-28	5001	0	\N	0	0	\N	\N	0	188270	0	8331-1	3006322		
15825	1446	3023430	1984-09-08	1984-09-08 00:00:00	1984-09-08	5001	0	\N	0	0	\N	\N	0	96389	0	6833-8	3023430		
121425	3745	4133840	1997-06-18	1997-06-18 00:00:00	1997-06-18	5001	0	\N	0	0	\N	\N	0	248966	0	127783003	4133840		
13506	1276	3006322	1962-03-15	1962-03-15 00:00:00	1962-03-15	5001	0	\N	0	0	\N	\N	0	84138	0	8331-1	3006322		
57202	5252	3049273	2005-03-31	2005-03-31 00:00:00	2005-03-31	5001	0	\N	0	0	\N	\N	0	349451	0	38265-5	3049273		
9087	866	3006322	2003-06-12	2003-06-12 00:00:00	2003-06-12	5001	0	\N	0	0	\N	\N	0	57479	0	8331-1	3006322		
12421	1176	40766240	2012-11-25	2012-11-25 00:00:00	2012-11-25	5001	0	\N	0	0	\N	\N	0	77700	0	63513-6	40766240		
39188	3622	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	240676	0	6246-3	3021226		
50219	4578	3006322	1985-10-22	1985-10-22 00:00:00	1985-10-22	5001	0	\N	0	0	\N	\N	0	304920	0	8331-1	3006322		
14935	1385	3006322	1972-11-29	1972-11-29 00:00:00	1972-11-29	5001	0	\N	0	0	\N	\N	0	91834	0	8331-1	3006322		
138644	4274	4052083	1947-05-09	1947-05-09 00:00:00	1947-05-09	5001	0	\N	0	0	\N	\N	0	283664	0	23426006	4052083		
34272	1072	4024958	1979-07-24	1979-07-24 00:00:00	1979-07-24	5001	0	\N	0	0	\N	\N	0	70240	0	117015009	4024958		
18647	1716	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	114761	0	6189-5	3006734		
18753	1727	3011505	2012-11-01	2012-11-01 00:00:00	2012-11-01	5001	0	\N	0	0	\N	\N	0	115501	0	19926-5	3011505		
20669	648	4024958	2016-05-28	2016-05-28 00:00:00	2016-05-28	5001	0	\N	0	0	\N	\N	0	42915	0	117015009	4024958		
46137	1408	4052083	2007-07-07	2007-07-07 00:00:00	2007-07-07	5001	0	\N	0	0	\N	\N	0	93593	0	23426006	4052083		
10382	1015	40766240	2018-06-02	2018-06-02 00:00:00	2018-06-02	5001	0	\N	0	0	\N	\N	0	66809	0	63513-6	40766240		
41601	3874	3006451	1984-01-20	1984-01-20 00:00:00	1984-01-20	5001	0	\N	0	0	\N	\N	0	257211	0	6273-7	3006451		
2169	196	3006322	1991-02-05	1991-02-05 00:00:00	1991-02-05	5001	0	\N	0	0	\N	\N	0	13518	0	8331-1	3006322		
18895	1737	3006322	2012-11-29	2012-11-29 00:00:00	2012-11-29	5001	0	\N	0	0	\N	\N	0	115966	0	8331-1	3006322		
54672	4998	40769194	1965-05-20	1965-05-20 00:00:00	1965-05-20	5001	0	\N	0	0	\N	\N	0	332366	0	66534-9	40769194		
26091	2396	3006322	1959-06-11	1959-06-11 00:00:00	1959-06-11	5001	0	\N	0	0	\N	\N	0	159305	0	8331-1	3006322		
1155	95	3006322	1969-11-06	1969-11-06 00:00:00	1969-11-06	5001	0	\N	0	0	\N	\N	0	6454	0	8331-1	3006322		
23194	2135	3001488	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	142038	0	7258-7	3001488		
27995	2570	3006322	1982-10-02	1982-10-02 00:00:00	1982-10-02	5001	0	\N	0	0	\N	\N	0	170271	0	8331-1	3006322		
99715	3060	4024958	1944-05-20	1944-05-20 00:00:00	1944-05-20	5001	0	\N	0	0	\N	\N	0	203557	0	117015009	4024958		
34701	3176	3015076	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	211108	0	6248-9	3015076		
55469	5094	3012494	1999-05-19	1999-05-19 00:00:00	1999-05-19	5001	0	\N	0	0	\N	\N	0	338442	0	6206-7	3012494		
15275	1399	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	92997	0	6085-5	3001247		
51934	4763	3006322	2005-04-29	2005-04-29 00:00:00	2005-04-29	5001	0	\N	0	0	\N	\N	0	317407	0	8331-1	3006322		
26702	2462	3006734	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	163320	0	6189-5	3006734		
6231	191	4133840	1990-09-25	1990-09-25 00:00:00	1990-09-25	5001	0	\N	0	0	\N	\N	0	13120	0	127783003	4133840		
56578	5194	40758406	1995-07-09	1995-07-09 00:00:00	1995-07-09	5001	0	\N	0	0	\N	\N	0	345350	0	55277-8	40758406		
47311	1442	4052083	2006-08-23	2006-08-23 00:00:00	2006-08-23	5001	0	\N	0	0	\N	\N	0	96150	0	23426006	4052083		
56681	5200	3006322	1978-02-19	1978-02-19 00:00:00	1978-02-19	5001	0	\N	0	0	\N	\N	0	345932	0	8331-1	3006322		
30927	2830	3020655	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	187752	0	6844-5	3020655		
10106	962	3006322	1994-03-02	1994-03-02 00:00:00	1994-03-02	5001	0	\N	0	0	\N	\N	0	64028	0	8331-1	3006322		
38358	3532	3006322	1978-12-14	1978-12-14 00:00:00	1978-12-14	5001	0	\N	0	0	\N	\N	0	234596	0	8331-1	3006322		
22923	2098	3006322	2002-01-17	2002-01-17 00:00:00	2002-01-17	5001	0	\N	0	0	\N	\N	0	139898	0	8331-1	3006322		
23026	2119	3021226	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	141083	0	6246-3	3021226		
76063	2334	4133840	2013-07-04	2013-07-04 00:00:00	2013-07-04	5001	0	\N	0	0	\N	\N	0	155364	0	127783003	4133840		
19048	1746	3006322	1970-10-26	1970-10-26 00:00:00	1970-10-26	5001	0	\N	0	0	\N	\N	0	116715	0	8331-1	3006322		
2554	250	3006322	1987-08-02	1987-08-02 00:00:00	1987-08-02	5001	0	\N	0	0	\N	\N	0	16796	0	8331-1	3006322		
52843	1602	4024958	1973-12-19	1973-12-19 00:00:00	1973-12-19	5001	0	\N	0	0	\N	\N	0	107502	0	117015009	4024958		
1301	111	3006322	1994-09-21	1994-09-21 00:00:00	1994-09-21	5001	0	\N	0	0	\N	\N	0	7364	0	8331-1	3006322		
138945	4282	4024958	1997-11-06	1997-11-06 00:00:00	1997-11-06	5001	0	\N	0	0	\N	\N	0	284198	0	117015009	4024958		
9470	299	4052083	1975-01-31	1975-01-31 00:00:00	1975-01-31	5001	0	\N	0	0	\N	\N	0	20024	0	23426006	4052083		
42039	3890	3006322	1960-03-16	1960-03-16 00:00:00	1960-03-16	5001	0	\N	0	0	\N	\N	0	258548	0	8331-1	3006322		
33579	3049	3006322	2013-10-03	2013-10-03 00:00:00	2013-10-03	5001	0	\N	0	0	\N	\N	0	202890	0	8331-1	3006322		
75874	2330	4024958	2009-08-30	2009-08-30 00:00:00	2009-08-30	5001	0	\N	0	0	\N	\N	0	154987	0	117015009	4024958		
52118	4784	3051031	1950-05-01	1950-05-01 00:00:00	1950-05-01	5001	0	\N	0	0	\N	\N	0	318491	0	46240-8	3051031		
14582	455	4052083	1951-05-28	1951-05-28 00:00:00	1951-05-28	5001	0	\N	0	0	\N	\N	0	30398	0	23426006	4052083		
75605	2320	4024958	1950-02-18	1950-02-18 00:00:00	1950-02-18	5001	0	\N	0	0	\N	\N	0	154314	0	117015009	4024958		
11394	1091	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	71626	0	6206-7	3012494		
147394	4520	4133840	1963-09-21	1963-09-21 00:00:00	1963-09-21	5001	0	\N	0	0	\N	\N	0	300929	0	127783003	4133840		
147468	4521	4052083	1996-05-06	1996-05-06 00:00:00	1996-05-06	5001	0	\N	0	0	\N	\N	0	300983	0	23426006	4052083		
30975	2832	3005136	1994-03-05	1994-03-05 00:00:00	1994-03-05	5001	0	\N	0	0	\N	\N	0	187897	0	6075-6	3005136		
31071	2835	3006322	1948-02-06	1948-02-06 00:00:00	1948-02-06	5001	0	\N	0	0	\N	\N	0	188259	0	8331-1	3006322		
15826	1446	3001488	1984-09-08	1984-09-08 00:00:00	1984-09-08	5001	0	\N	0	0	\N	\N	0	96389	0	7258-7	3001488		
121428	3746	4024958	1956-03-06	1956-03-06 00:00:00	1956-03-06	5001	0	\N	0	0	\N	\N	0	249038	0	117015009	4024958		
13507	1276	3006322	1967-09-10	1967-09-10 00:00:00	1967-09-10	5001	0	\N	0	0	\N	\N	0	84139	0	8331-1	3006322		
57203	5252	3011505	2017-05-30	2017-05-30 00:00:00	2017-05-30	5001	0	\N	0	0	\N	\N	0	349448	0	19926-5	3011505		
9088	866	3006322	1994-04-16	1994-04-16 00:00:00	1994-04-16	5001	0	\N	0	0	\N	\N	0	57491	0	8331-1	3006322		
12422	1176	3051031	2012-11-25	2012-11-25 00:00:00	2012-11-25	5001	0	\N	0	0	\N	\N	0	77700	0	46240-8	3051031		
39189	3622	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	240676	0	6082-2	3000876		
50220	4579	3006322	1973-04-15	1973-04-15 00:00:00	1973-04-15	5001	0	\N	0	0	\N	\N	0	305023	0	8331-1	3006322		
14936	1385	3006322	2000-10-09	2000-10-09 00:00:00	2000-10-09	5001	0	\N	0	0	\N	\N	0	91838	0	8331-1	3006322		
138655	4275	4024958	2008-07-29	2008-07-29 00:00:00	2008-07-29	5001	0	\N	0	0	\N	\N	0	283710	0	117015009	4024958		
34289	1073	4052083	2006-01-25	2006-01-25 00:00:00	2006-01-25	5001	0	\N	0	0	\N	\N	0	70323	0	23426006	4052083		
18648	1716	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	114761	0	6095-4	3036780		
18754	1727	3011505	2009-10-15	2009-10-15 00:00:00	2009-10-15	5001	0	\N	0	0	\N	\N	0	115457	0	19926-5	3011505		
20670	648	4052083	1937-02-19	1937-02-19 00:00:00	1937-02-19	5001	0	\N	0	0	\N	\N	0	42947	0	23426006	4052083		
46162	1408	4024958	1948-01-19	1948-01-19 00:00:00	1948-01-19	5001	0	\N	0	0	\N	\N	0	93639	0	117015009	4024958		
21660	1999	3021226	2011-10-05	2011-10-05 00:00:00	2011-10-05	5001	0	\N	0	0	\N	\N	0	133114	0	6246-3	3021226		
41602	3874	3015076	1984-01-20	1984-01-20 00:00:00	1984-01-20	5001	0	\N	0	0	\N	\N	0	257211	0	6248-9	3015076		
81853	2534	4024958	2008-08-16	2008-08-16 00:00:00	2008-08-16	5001	0	\N	0	0	\N	\N	0	167389	0	117015009	4024958		
18896	1737	3006322	1922-12-08	1922-12-08 00:00:00	1922-12-08	5001	0	\N	0	0	\N	\N	0	115976	0	8331-1	3006322		
54673	4998	3006322	1983-01-20	1983-01-20 00:00:00	1983-01-20	5001	0	\N	0	0	\N	\N	0	332329	0	8331-1	3006322		
26092	2396	3006322	1958-07-03	1958-07-03 00:00:00	1958-07-03	5001	0	\N	0	0	\N	\N	0	159295	0	8331-1	3006322		
1156	95	3006322	1965-11-18	1965-11-18 00:00:00	1965-11-18	5001	0	\N	0	0	\N	\N	0	6453	0	8331-1	3006322		
23195	2135	3020655	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	142038	0	6844-5	3020655		
27996	2570	3006322	1998-11-06	1998-11-06 00:00:00	1998-11-06	5001	0	\N	0	0	\N	\N	0	170172	0	8331-1	3006322		
42603	1313	4052083	1993-12-22	1993-12-22 00:00:00	1993-12-22	5001	0	\N	0	0	\N	\N	0	86918	0	23426006	4052083		
34702	3176	3027231	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	211108	0	6276-0	3027231		
55470	5094	3001247	1999-05-19	1999-05-19 00:00:00	1999-05-19	5001	0	\N	0	0	\N	\N	0	338442	0	6085-5	3001247		
15276	1399	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	92997	0	7258-7	3001488		
51935	4763	3006322	1979-10-04	1979-10-04 00:00:00	1979-10-04	5001	0	\N	0	0	\N	\N	0	317405	0	8331-1	3006322		
26703	2462	3023430	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	163320	0	6833-8	3023430		
6233	191	4133840	2000-10-31	2000-10-31 00:00:00	2000-10-31	5001	0	\N	0	0	\N	\N	0	13109	0	127783003	4133840		
56579	5194	40766240	1995-07-09	1995-07-09 00:00:00	1995-07-09	5001	0	\N	0	0	\N	\N	0	345350	0	63513-6	40766240		
47314	1442	4052083	1963-01-25	1963-01-25 00:00:00	1963-01-25	5001	0	\N	0	0	\N	\N	0	96145	0	23426006	4052083		
56682	5200	3000876	1982-09-04	1982-09-04 00:00:00	1982-09-04	5001	0	\N	0	0	\N	\N	0	345935	0	6082-2	3000876		
30928	2830	3023430	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	187752	0	6833-8	3023430		
10107	962	3006322	2006-02-18	2006-02-18 00:00:00	2006-02-18	5001	0	\N	0	0	\N	\N	0	64060	0	8331-1	3006322		
38359	3532	3006322	1976-09-10	1976-09-10 00:00:00	1976-09-10	5001	0	\N	0	0	\N	\N	0	234590	0	8331-1	3006322		
22924	2098	3006322	2009-02-03	2009-02-03 00:00:00	2009-02-03	5001	0	\N	0	0	\N	\N	0	139902	0	8331-1	3006322		
23027	2119	3023430	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	141083	0	6833-8	3023430		
76065	2334	4133840	2017-07-27	2017-07-27 00:00:00	2017-07-27	5001	0	\N	0	0	\N	\N	0	155366	0	127783003	4133840		
19049	1746	3006322	2014-03-27	2014-03-27 00:00:00	2014-03-27	5001	0	\N	0	0	\N	\N	0	116801	0	8331-1	3006322		
2555	250	3006322	1977-03-02	1977-03-02 00:00:00	1977-03-02	5001	0	\N	0	0	\N	\N	0	16797	0	8331-1	3006322		
52852	1604	4133840	2003-06-26	2003-06-26 00:00:00	2003-06-26	5001	0	\N	0	0	\N	\N	0	107635	0	127783003	4133840		
1302	111	3006322	1994-12-30	1994-12-30 00:00:00	1994-12-30	5001	0	\N	0	0	\N	\N	0	7374	0	8331-1	3006322		
138956	4282	4024958	1975-06-20	1975-06-20 00:00:00	1975-06-20	5001	0	\N	0	0	\N	\N	0	284166	0	117015009	4024958		
2868	273	3021226	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	18196	0	6246-3	3021226		
42040	3890	3006322	1974-12-12	1974-12-12 00:00:00	1974-12-12	5001	0	\N	0	0	\N	\N	0	258558	0	8331-1	3006322		
33580	3049	3006322	1998-03-31	1998-03-31 00:00:00	1998-03-31	5001	0	\N	0	0	\N	\N	0	202889	0	8331-1	3006322		
75894	2330	4052083	2015-10-21	2015-10-21 00:00:00	2015-10-21	5001	0	\N	0	0	\N	\N	0	154988	0	23426006	4052083		
52119	4784	40758406	1950-05-01	1950-05-01 00:00:00	1950-05-01	5001	0	\N	0	0	\N	\N	0	318491	0	55277-8	40758406		
14591	455	4052083	1985-08-10	1985-08-10 00:00:00	1985-08-10	5001	0	\N	0	0	\N	\N	0	30399	0	23426006	4052083		
75609	2320	4052083	1955-08-11	1955-08-11 00:00:00	1955-08-11	5001	0	\N	0	0	\N	\N	0	154278	0	23426006	4052083		
11395	1091	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	71626	0	6833-8	3023430		
147395	4520	4133840	1982-11-20	1982-11-20 00:00:00	1982-11-20	5001	0	\N	0	0	\N	\N	0	300960	0	127783003	4133840		
147491	4521	4024958	1991-01-17	1991-01-17 00:00:00	1991-01-17	5001	0	\N	0	0	\N	\N	0	301021	0	117015009	4024958		
30976	2832	3000876	1994-03-05	1994-03-05 00:00:00	1994-03-05	5001	0	\N	0	0	\N	\N	0	187897	0	6082-2	3000876		
31072	2835	3006322	1929-03-31	1929-03-31 00:00:00	1929-03-31	5001	0	\N	0	0	\N	\N	0	188348	0	8331-1	3006322		
15827	1446	3001247	1984-09-08	1984-09-08 00:00:00	1984-09-08	5001	0	\N	0	0	\N	\N	0	96389	0	6085-5	3001247		
121444	3746	4052083	1999-12-24	1999-12-24 00:00:00	1999-12-24	5001	0	\N	0	0	\N	\N	0	249031	0	23426006	4052083		
13508	1276	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	84260	0	6106-9	3014599		
57204	5253	3011505	1993-01-09	1993-01-09 00:00:00	1993-01-09	5001	0	\N	0	0	\N	\N	0	349536	0	19926-5	3011505		
9089	866	3006322	2017-04-24	2017-04-24 00:00:00	2017-04-24	5001	0	\N	0	0	\N	\N	0	57493	0	8331-1	3006322		
12424	1176	46235214	2012-11-25	2012-11-25 00:00:00	2012-11-25	5001	0	\N	0	0	\N	\N	0	77700	0	76690-7	46235214		
39190	3622	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	240676	0	6206-7	3012494		
50221	4579	3006322	1997-03-08	1997-03-08 00:00:00	1997-03-08	5001	0	\N	0	0	\N	\N	0	305061	0	8331-1	3006322		
14937	1385	3006322	1992-11-06	1992-11-06 00:00:00	1992-11-06	5001	0	\N	0	0	\N	\N	0	91826	0	8331-1	3006322		
138665	4275	4052083	1993-03-27	1993-03-27 00:00:00	1993-03-27	5001	0	\N	0	0	\N	\N	0	283678	0	23426006	4052083		
122992	3791	4052083	1944-06-01	1944-06-01 00:00:00	1944-06-01	5001	0	\N	0	0	\N	\N	0	252046	0	23426006	4052083		
18649	1716	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	114761	0	6085-5	3001247		
18755	1727	3011505	2016-11-23	2016-11-23 00:00:00	2016-11-23	5001	0	\N	0	0	\N	\N	0	115483	0	19926-5	3011505		
20681	649	4024958	1975-09-19	1975-09-19 00:00:00	1975-09-19	5001	0	\N	0	0	\N	\N	0	43016	0	117015009	4024958		
46166	1408	4024958	1992-11-20	1992-11-20 00:00:00	1992-11-20	5001	0	\N	0	0	\N	\N	0	93651	0	117015009	4024958		
21661	1999	3006451	2011-10-05	2011-10-05 00:00:00	2011-10-05	5001	0	\N	0	0	\N	\N	0	133114	0	6273-7	3006451		
41603	3874	3036780	1984-01-20	1984-01-20 00:00:00	1984-01-20	5001	0	\N	0	0	\N	\N	0	257211	0	6095-4	3036780		
102710	3158	4052083	1979-02-12	1979-02-12 00:00:00	1979-02-12	5001	0	\N	0	0	\N	\N	0	209916	0	23426006	4052083		
18897	1738	3006322	1976-07-13	1976-07-13 00:00:00	1976-07-13	5001	0	\N	0	0	\N	\N	0	116104	0	8331-1	3006322		
54674	4998	3006322	2008-04-13	2008-04-13 00:00:00	2008-04-13	5001	0	\N	0	0	\N	\N	0	332407	0	8331-1	3006322		
26093	2396	3006322	1934-03-09	1934-03-09 00:00:00	1934-03-09	5001	0	\N	0	0	\N	\N	0	159399	0	8331-1	3006322		
1157	96	3011505	1960-06-04	1960-06-04 00:00:00	1960-06-04	5001	0	\N	0	0	\N	\N	0	6562	0	19926-5	3011505		
23196	2135	3023430	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	142038	0	6833-8	3023430		
27997	2570	3006322	1976-11-20	1976-11-20 00:00:00	1976-11-20	5001	0	\N	0	0	\N	\N	0	170179	0	8331-1	3006322		
42605	1313	4024958	1989-07-17	1989-07-17 00:00:00	1989-07-17	5001	0	\N	0	0	\N	\N	0	86926	0	117015009	4024958		
34703	3176	3006451	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	211108	0	6273-7	3006451		
55471	5094	3036780	1999-05-19	1999-05-19 00:00:00	1999-05-19	5001	0	\N	0	0	\N	\N	0	338442	0	6095-4	3036780		
15277	1399	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	92997	0	6095-4	3036780		
51937	4763	46235214	2009-10-06	2009-10-06 00:00:00	2009-10-06	5001	0	\N	0	0	\N	\N	0	317432	0	76690-7	46235214		
26704	2462	3001488	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	163320	0	7258-7	3001488		
6236	191	4052083	1957-10-12	1957-10-12 00:00:00	1957-10-12	5001	0	\N	0	0	\N	\N	0	13065	0	23426006	4052083		
56580	5194	46235214	1995-07-09	1995-07-09 00:00:00	1995-07-09	5001	0	\N	0	0	\N	\N	0	345350	0	76690-7	46235214		
47319	1442	4052083	2005-03-11	2005-03-11 00:00:00	2005-03-11	5001	0	\N	0	0	\N	\N	0	96140	0	23426006	4052083		
56683	5200	3014599	1982-09-04	1982-09-04 00:00:00	1982-09-04	5001	0	\N	0	0	\N	\N	0	345935	0	6106-9	3014599		
30929	2830	3012494	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	187752	0	6206-7	3012494		
10108	962	3006322	1983-04-18	1983-04-18 00:00:00	1983-04-18	5001	0	\N	0	0	\N	\N	0	64083	0	8331-1	3006322		
38360	3532	3006322	2017-02-12	2017-02-12 00:00:00	2017-02-12	5001	0	\N	0	0	\N	\N	0	234593	0	8331-1	3006322		
22926	2100	3000963	1990-08-25	1990-08-25 00:00:00	1990-08-25	5001	0	\N	0	0	\N	\N	0	139958	0	718-7	3000963		
23028	2119	3015076	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	141083	0	6248-9	3015076		
76070	2334	4133840	2004-05-13	2004-05-13 00:00:00	2004-05-13	5001	0	\N	0	0	\N	\N	0	155362	0	127783003	4133840		
19050	1746	3006322	1962-06-28	1962-06-28 00:00:00	1962-06-28	5001	0	\N	0	0	\N	\N	0	116806	0	8331-1	3006322		
2556	250	3006322	1996-11-28	1996-11-28 00:00:00	1996-11-28	5001	0	\N	0	0	\N	\N	0	16816	0	8331-1	3006322		
52854	1604	4052083	1997-02-27	1997-02-27 00:00:00	1997-02-27	5001	0	\N	0	0	\N	\N	0	107608	0	23426006	4052083		
1303	111	3006322	1979-07-28	1979-07-28 00:00:00	1979-07-28	5001	0	\N	0	0	\N	\N	0	7414	0	8331-1	3006322		
138970	4282	4052083	1977-09-06	1977-09-06 00:00:00	1977-09-06	5001	0	\N	0	0	\N	\N	0	284196	0	23426006	4052083		
2869	273	3014599	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	18196	0	6106-9	3014599		
42041	3891	3001488	1995-11-29	1995-11-29 00:00:00	1995-11-29	5001	0	\N	0	0	\N	\N	0	258675	0	7258-7	3001488		
63020	1936	4052083	1979-07-11	1979-07-11 00:00:00	1979-07-11	5001	0	\N	0	0	\N	\N	0	128771	0	23426006	4052083		
75896	2330	4024958	1995-04-08	1995-04-08 00:00:00	1995-04-08	5001	0	\N	0	0	\N	\N	0	154979	0	117015009	4024958		
52120	4784	40766240	1950-05-01	1950-05-01 00:00:00	1950-05-01	5001	0	\N	0	0	\N	\N	0	318491	0	63513-6	40766240		
14597	455	4024958	1950-12-29	1950-12-29 00:00:00	1950-12-29	5001	0	\N	0	0	\N	\N	0	30403	0	117015009	4024958		
75610	2320	4024958	1997-01-19	1997-01-19 00:00:00	1997-01-19	5001	0	\N	0	0	\N	\N	0	154283	0	117015009	4024958		
11396	1091	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	71626	0	6095-4	3036780		
147399	4520	4133840	1994-01-22	1994-01-22 00:00:00	1994-01-22	5001	0	\N	0	0	\N	\N	0	300938	0	127783003	4133840		
158808	4883	4052083	2006-03-11	2006-03-11 00:00:00	2006-03-11	5001	0	\N	0	0	\N	\N	0	324690	0	23426006	4052083		
30977	2832	3001488	1994-03-05	1994-03-05 00:00:00	1994-03-05	5001	0	\N	0	0	\N	\N	0	187897	0	7258-7	3001488		
31073	2835	3049273	1993-05-04	1993-05-04 00:00:00	1993-05-04	5001	0	\N	0	0	\N	\N	0	188308	0	38265-5	3049273		
15828	1446	3006322	2004-01-05	2004-01-05 00:00:00	2004-01-05	5001	0	\N	0	0	\N	\N	0	96360	0	8331-1	3006322		
121457	3746	4024958	1969-06-11	1969-06-11 00:00:00	1969-06-11	5001	0	\N	0	0	\N	\N	0	248984	0	117015009	4024958		
13509	1276	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	84260	0	6075-6	3005136		
57205	5253	3011505	1988-07-30	1988-07-30 00:00:00	1988-07-30	5001	0	\N	0	0	\N	\N	0	349541	0	19926-5	3011505		
9090	866	3006322	2015-12-16	2015-12-16 00:00:00	2015-12-16	5001	0	\N	0	0	\N	\N	0	57492	0	8331-1	3006322		
12425	1176	40758406	2012-11-25	2012-11-25 00:00:00	2012-11-25	5001	0	\N	0	0	\N	\N	0	77700	0	55277-8	40758406		
39191	3622	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	240676	0	6095-4	3036780		
50222	4579	3006322	2016-10-04	2016-10-04 00:00:00	2016-10-04	5001	0	\N	0	0	\N	\N	0	305010	0	8331-1	3006322		
14938	1385	3006322	2006-11-20	2006-11-20 00:00:00	2006-11-20	5001	0	\N	0	0	\N	\N	0	91813	0	8331-1	3006322		
138674	4276	4052083	1953-01-25	1953-01-25 00:00:00	1953-01-25	5001	0	\N	0	0	\N	\N	0	283758	0	23426006	4052083		
122997	3791	4052083	2000-07-04	2000-07-04 00:00:00	2000-07-04	5001	0	\N	0	0	\N	\N	0	252086	0	23426006	4052083		
18650	1716	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	114761	0	6248-9	3015076		
18756	1727	3011505	2001-04-12	2001-04-12 00:00:00	2001-04-12	5001	0	\N	0	0	\N	\N	0	115475	0	19926-5	3011505		
20684	649	4052083	1973-08-16	1973-08-16 00:00:00	1973-08-16	5001	0	\N	0	0	\N	\N	0	42990	0	23426006	4052083		
46167	1408	4024958	1943-12-31	1943-12-31 00:00:00	1943-12-31	5001	0	\N	0	0	\N	\N	0	93636	0	117015009	4024958		
21662	1999	3019406	2011-10-05	2011-10-05 00:00:00	2011-10-05	5001	0	\N	0	0	\N	\N	0	133114	0	6158-0	3019406		
41604	3874	3012494	1984-01-20	1984-01-20 00:00:00	1984-01-20	5001	0	\N	0	0	\N	\N	0	257211	0	6206-7	3012494		
102718	3158	4024958	1950-08-01	1950-08-01 00:00:00	1950-08-01	5001	0	\N	0	0	\N	\N	0	209906	0	117015009	4024958		
18898	1738	3006322	1972-05-01	1972-05-01 00:00:00	1972-05-01	5001	0	\N	0	0	\N	\N	0	116100	0	8331-1	3006322		
54675	4999	3006322	1996-08-07	1996-08-07 00:00:00	1996-08-07	5001	0	\N	0	0	\N	\N	0	332461	0	8331-1	3006322		
26094	2396	3049273	1971-02-08	1971-02-08 00:00:00	1971-02-08	5001	0	\N	0	0	\N	\N	0	159322	0	38265-5	3049273		
1158	96	3011505	1995-04-22	1995-04-22 00:00:00	1995-04-22	5001	0	\N	0	0	\N	\N	0	6529	0	19926-5	3011505		
23197	2135	3000876	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	142038	0	6082-2	3000876		
12543	1193	3006322	1974-01-21	1974-01-21 00:00:00	1974-01-21	5001	0	\N	0	0	\N	\N	0	78629	0	8331-1	3006322		
42609	1313	4024958	1996-01-23	1996-01-23 00:00:00	1996-01-23	5001	0	\N	0	0	\N	\N	0	86927	0	117015009	4024958		
34704	3176	3014599	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	211108	0	6106-9	3014599		
55472	5094	3014599	1999-05-19	1999-05-19 00:00:00	1999-05-19	5001	0	\N	0	0	\N	\N	0	338442	0	6106-9	3014599		
15278	1399	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	92997	0	6082-2	3000876		
51939	4763	40766240	2009-10-06	2009-10-06 00:00:00	2009-10-06	5001	0	\N	0	0	\N	\N	0	317432	0	63513-6	40766240		
26705	2462	3001488	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	163274	0	7258-7	3001488		
6237	191	4133840	1989-09-19	1989-09-19 00:00:00	1989-09-19	5001	0	\N	0	0	\N	\N	0	13126	0	127783003	4133840		
56583	5194	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	345320	0	6246-3	3021226		
47342	1442	4024958	1946-07-07	1946-07-07 00:00:00	1946-07-07	5001	0	\N	0	0	\N	\N	0	96141	0	117015009	4024958		
56684	5200	3019406	1982-09-04	1982-09-04 00:00:00	1982-09-04	5001	0	\N	0	0	\N	\N	0	345935	0	6158-0	3019406		
30930	2830	3036780	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	187752	0	6095-4	3036780		
10109	962	3006322	1994-12-07	1994-12-07 00:00:00	1994-12-07	5001	0	\N	0	0	\N	\N	0	64089	0	8331-1	3006322		
38361	3532	3006322	2002-11-04	2002-11-04 00:00:00	2002-11-04	5001	0	\N	0	0	\N	\N	0	234600	0	8331-1	3006322		
22927	2100	3009542	1990-08-25	1990-08-25 00:00:00	1990-08-25	5001	0	\N	0	0	\N	\N	0	139958	0	20570-8	3009542		
23029	2119	3020655	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	141083	0	6844-5	3020655		
76072	2334	4133840	2011-06-23	2011-06-23 00:00:00	2011-06-23	5001	0	\N	0	0	\N	\N	0	155281	0	127783003	4133840		
19051	1746	3006322	1972-01-04	1972-01-04 00:00:00	1972-01-04	5001	0	\N	0	0	\N	\N	0	116722	0	8331-1	3006322		
2560	254	3006322	1986-06-08	1986-06-08 00:00:00	1986-06-08	5001	0	\N	0	0	\N	\N	0	16965	0	8331-1	3006322		
52855	1604	4133840	2015-09-03	2015-09-03 00:00:00	2015-09-03	5001	0	\N	0	0	\N	\N	0	107647	0	127783003	4133840		
1304	111	3006322	2011-12-18	2011-12-18 00:00:00	2011-12-18	5001	0	\N	0	0	\N	\N	0	7371	0	8331-1	3006322		
57376	5267	3015076	1999-06-26	1999-06-26 00:00:00	1999-06-26	5001	0	\N	0	0	\N	\N	0	350412	0	6248-9	3015076		
2870	273	3006451	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	18196	0	6273-7	3006451		
42042	3891	3006734	1995-11-29	1995-11-29 00:00:00	1995-11-29	5001	0	\N	0	0	\N	\N	0	258675	0	6189-5	3006734		
63031	1936	4052083	2013-08-15	2013-08-15 00:00:00	2013-08-15	5001	0	\N	0	0	\N	\N	0	128773	0	23426006	4052083		
87180	2693	4052083	1967-09-22	1967-09-22 00:00:00	1967-09-22	5001	0	\N	0	0	\N	\N	0	178425	0	23426006	4052083		
153934	4722	4052083	1946-04-17	1946-04-17 00:00:00	1946-04-17	5001	0	\N	0	0	\N	\N	0	314563	0	23426006	4052083		
14599	455	4024958	1992-12-19	1992-12-19 00:00:00	1992-12-19	5001	0	\N	0	0	\N	\N	0	30379	0	117015009	4024958		
67660	2075	4024958	2007-02-11	2007-02-11 00:00:00	2007-02-11	5001	0	\N	0	0	\N	\N	0	138031	0	117015009	4024958		
11397	1091	3006322	2007-11-20	2007-11-20 00:00:00	2007-11-20	5001	0	\N	0	0	\N	\N	0	71702	0	8331-1	3006322		
147401	4520	4133840	1981-11-14	1981-11-14 00:00:00	1981-11-14	5001	0	\N	0	0	\N	\N	0	300936	0	127783003	4133840		
10025	320	4133840	2006-02-19	2006-02-19 00:00:00	2006-02-19	5001	0	\N	0	0	\N	\N	0	21183	0	127783003	4133840		
30978	2832	3006734	1994-03-05	1994-03-05 00:00:00	1994-03-05	5001	0	\N	0	0	\N	\N	0	187897	0	6189-5	3006734		
31074	2835	3006322	2006-12-06	2006-12-06 00:00:00	2006-12-06	5001	0	\N	0	0	\N	\N	0	188322	0	8331-1	3006322		
15829	1446	3006322	1997-02-15	1997-02-15 00:00:00	1997-02-15	5001	0	\N	0	0	\N	\N	0	96391	0	8331-1	3006322		
144564	4442	4024958	1999-11-23	1999-11-23 00:00:00	1999-11-23	5001	0	\N	0	0	\N	\N	0	295287	0	117015009	4024958		
13510	1276	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	84260	0	6248-9	3015076		
57206	5253	3011505	1990-11-17	1990-11-17 00:00:00	1990-11-17	5001	0	\N	0	0	\N	\N	0	349535	0	19926-5	3011505		
9091	867	3006322	1974-09-24	1974-09-24 00:00:00	1974-09-24	5001	0	\N	0	0	\N	\N	0	57542	0	8331-1	3006322		
12426	1176	40766240	2012-12-25	2012-12-25 00:00:00	2012-12-25	5001	0	\N	0	0	\N	\N	0	77703	0	63513-6	40766240		
39192	3622	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	240676	0	6106-9	3014599		
50223	4579	3006322	1976-05-11	1976-05-11 00:00:00	1976-05-11	5001	0	\N	0	0	\N	\N	0	305024	0	8331-1	3006322		
14939	1385	3006322	1970-07-21	1970-07-21 00:00:00	1970-07-21	5001	0	\N	0	0	\N	\N	0	91864	0	8331-1	3006322		
138677	4276	4052083	1964-01-07	1964-01-07 00:00:00	1964-01-07	5001	0	\N	0	0	\N	\N	0	283774	0	23426006	4052083		
123009	3791	4024958	1948-02-16	1948-02-16 00:00:00	1948-02-16	5001	0	\N	0	0	\N	\N	0	252135	0	117015009	4024958		
18651	1716	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	114761	0	6276-0	3027231		
18757	1727	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	115467	0	6095-4	3036780		
20722	651	4052083	1997-01-22	1997-01-22 00:00:00	1997-01-22	5001	0	\N	0	0	\N	\N	0	43101	0	23426006	4052083		
46176	1409	4024958	1971-04-10	1971-04-10 00:00:00	1971-04-10	5001	0	\N	0	0	\N	\N	0	93764	0	117015009	4024958		
21663	1999	3021226	2011-10-05	2011-10-05 00:00:00	2011-10-05	5001	0	\N	0	0	\N	\N	0	133114	0	6246-3	3021226		
41605	3874	3019406	1984-01-20	1984-01-20 00:00:00	1984-01-20	5001	0	\N	0	0	\N	\N	0	257211	0	6158-0	3019406		
102719	3158	4024958	1958-12-04	1958-12-04 00:00:00	1958-12-04	5001	0	\N	0	0	\N	\N	0	210009	0	117015009	4024958		
18899	1738	3006322	1985-06-08	1985-06-08 00:00:00	1985-06-08	5001	0	\N	0	0	\N	\N	0	116148	0	8331-1	3006322		
54676	4999	3006322	1968-05-20	1968-05-20 00:00:00	1968-05-20	5001	0	\N	0	0	\N	\N	0	332444	0	8331-1	3006322		
26095	2396	3006322	1979-02-22	1979-02-22 00:00:00	1979-02-22	5001	0	\N	0	0	\N	\N	0	159385	0	8331-1	3006322		
1159	96	3011505	1980-01-26	1980-01-26 00:00:00	1980-01-26	5001	0	\N	0	0	\N	\N	0	6492	0	19926-5	3011505		
23198	2135	3014599	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	142128	0	6106-9	3014599		
12544	1193	3006322	1953-03-12	1953-03-12 00:00:00	1953-03-12	5001	0	\N	0	0	\N	\N	0	78595	0	8331-1	3006322		
42625	1314	4024958	1945-03-15	1945-03-15 00:00:00	1945-03-15	5001	0	\N	0	0	\N	\N	0	87016	0	117015009	4024958		
34705	3176	3012494	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	211108	0	6206-7	3012494		
55473	5094	3027231	1999-05-19	1999-05-19 00:00:00	1999-05-19	5001	0	\N	0	0	\N	\N	0	338442	0	6276-0	3027231		
15279	1401	3006322	1982-09-11	1982-09-11 00:00:00	1982-09-11	5001	0	\N	0	0	\N	\N	0	93153	0	8331-1	3006322		
51940	4763	40758406	2009-10-06	2009-10-06 00:00:00	2009-10-06	5001	0	\N	0	0	\N	\N	0	317432	0	55277-8	40758406		
26706	2462	3027231	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	163274	0	6276-0	3027231		
6242	191	4133840	1994-09-27	1994-09-27 00:00:00	1994-09-27	5001	0	\N	0	0	\N	\N	0	13052	0	127783003	4133840		
56584	5194	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	345320	0	6276-0	3027231		
47348	1442	4024958	1996-05-18	1996-05-18 00:00:00	1996-05-18	5001	0	\N	0	0	\N	\N	0	96137	0	117015009	4024958		
56685	5200	3005136	1982-09-04	1982-09-04 00:00:00	1982-09-04	5001	0	\N	0	0	\N	\N	0	345935	0	6075-6	3005136		
30932	2832	3001488	1994-03-05	1994-03-05 00:00:00	1994-03-05	5001	0	\N	0	0	\N	\N	0	187897	0	7258-7	3001488		
10110	962	3006322	2010-12-06	2010-12-06 00:00:00	2010-12-06	5001	0	\N	0	0	\N	\N	0	64099	0	8331-1	3006322		
38362	3532	3006322	2018-07-19	2018-07-19 00:00:00	2018-07-19	5001	0	\N	0	0	\N	\N	0	234649	0	8331-1	3006322		
22928	2100	3006322	2002-05-09	2002-05-09 00:00:00	2002-05-09	5001	0	\N	0	0	\N	\N	0	140012	0	8331-1	3006322		
23030	2119	3006734	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	141083	0	6189-5	3006734		
76075	2334	4133840	1963-02-14	1963-02-14 00:00:00	1963-02-14	5001	0	\N	0	0	\N	\N	0	155368	0	127783003	4133840		
19052	1746	3006322	1987-02-25	1987-02-25 00:00:00	1987-02-25	5001	0	\N	0	0	\N	\N	0	116795	0	8331-1	3006322		
2561	254	3006322	1954-12-01	1954-12-01 00:00:00	1954-12-01	5001	0	\N	0	0	\N	\N	0	16906	0	8331-1	3006322		
52857	1604	4133840	1999-06-17	1999-06-17 00:00:00	1999-06-17	5001	0	\N	0	0	\N	\N	0	107597	0	127783003	4133840		
1325	114	3006322	1975-10-07	1975-10-07 00:00:00	1975-10-07	5001	0	\N	0	0	\N	\N	0	7527	0	8331-1	3006322		
57377	5267	3019406	1999-06-26	1999-06-26 00:00:00	1999-06-26	5001	0	\N	0	0	\N	\N	0	350412	0	6158-0	3019406		
2871	273	3027231	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	18196	0	6276-0	3027231		
42043	3891	3023430	1995-11-29	1995-11-29 00:00:00	1995-11-29	5001	0	\N	0	0	\N	\N	0	258675	0	6833-8	3023430		
63047	1937	4052083	2015-04-06	2015-04-06 00:00:00	2015-04-06	5001	0	\N	0	0	\N	\N	0	128879	0	23426006	4052083		
87185	2693	4024958	1959-01-14	1959-01-14 00:00:00	1959-01-14	5001	0	\N	0	0	\N	\N	0	178420	0	117015009	4024958		
18179	1655	3006322	1992-09-16	1992-09-16 00:00:00	1992-09-16	5001	0	\N	0	0	\N	\N	0	110993	0	8331-1	3006322		
14643	457	4024958	1964-12-22	1964-12-22 00:00:00	1964-12-22	5001	0	\N	0	0	\N	\N	0	30556	0	117015009	4024958		
78945	2425	4024958	1961-10-13	1961-10-13 00:00:00	1961-10-13	5001	0	\N	0	0	\N	\N	0	160939	0	117015009	4024958		
11398	1091	40766240	1957-10-05	1957-10-05 00:00:00	1957-10-05	5001	0	\N	0	0	\N	\N	0	71687	0	63513-6	40766240		
147402	4520	4133840	1976-10-16	1976-10-16 00:00:00	1976-10-16	5001	0	\N	0	0	\N	\N	0	300931	0	127783003	4133840		
10027	320	4133840	2000-03-05	2000-03-05 00:00:00	2000-03-05	5001	0	\N	0	0	\N	\N	0	21178	0	127783003	4133840		
30979	2832	3036780	1994-03-05	1994-03-05 00:00:00	1994-03-05	5001	0	\N	0	0	\N	\N	0	187897	0	6095-4	3036780		
31075	2835	3006322	1977-04-12	1977-04-12 00:00:00	1977-04-12	5001	0	\N	0	0	\N	\N	0	188261	0	8331-1	3006322		
15830	1447	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	96445	0	7258-7	3001488		
28476	2636	3006322	1962-10-05	1962-10-05 00:00:00	1962-10-05	5001	0	\N	0	0	\N	\N	0	174464	0	8331-1	3006322		
13511	1276	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	84260	0	6095-4	3036780		
57207	5253	3011505	2006-12-16	2006-12-16 00:00:00	2006-12-16	5001	0	\N	0	0	\N	\N	0	349512	0	19926-5	3011505		
9092	867	3006322	1933-07-09	1933-07-09 00:00:00	1933-07-09	5001	0	\N	0	0	\N	\N	0	57575	0	8331-1	3006322		
12428	1176	40758406	2012-12-25	2012-12-25 00:00:00	2012-12-25	5001	0	\N	0	0	\N	\N	0	77703	0	55277-8	40758406		
39193	3622	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	240676	0	6189-5	3006734		
50224	4580	3006322	1987-01-23	1987-01-23 00:00:00	1987-01-23	5001	0	\N	0	0	\N	\N	0	305123	0	8331-1	3006322		
85622	2651	4024958	2014-07-28	2014-07-28 00:00:00	2014-07-28	5001	0	\N	0	0	\N	\N	0	175432	0	117015009	4024958		
138682	4276	4052083	2001-02-03	2001-02-03 00:00:00	2001-02-03	5001	0	\N	0	0	\N	\N	0	283763	0	23426006	4052083		
123040	3791	4052083	2003-11-25	2003-11-25 00:00:00	2003-11-25	5001	0	\N	0	0	\N	\N	0	252057	0	23426006	4052083		
18652	1716	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	114761	0	6206-7	3012494		
18758	1727	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	115467	0	7258-7	3001488		
20730	651	4024958	1985-09-07	1985-09-07 00:00:00	1985-09-07	5001	0	\N	0	0	\N	\N	0	43105	0	117015009	4024958		
10308	992	3049273	2009-12-25	2009-12-25 00:00:00	2009-12-25	5001	0	\N	0	0	\N	\N	0	65751	0	38265-5	3049273		
21664	1999	3006451	2011-10-05	2011-10-05 00:00:00	2011-10-05	5001	0	\N	0	0	\N	\N	0	133114	0	6273-7	3006451		
41606	3874	3023430	1984-01-20	1984-01-20 00:00:00	1984-01-20	5001	0	\N	0	0	\N	\N	0	257211	0	6833-8	3023430		
102722	3158	4052083	1950-11-20	1950-11-20 00:00:00	1950-11-20	5001	0	\N	0	0	\N	\N	0	209994	0	23426006	4052083		
18900	1738	3006322	2005-11-29	2005-11-29 00:00:00	2005-11-29	5001	0	\N	0	0	\N	\N	0	116151	0	8331-1	3006322		
54677	4999	3006322	2003-01-19	2003-01-19 00:00:00	2003-01-19	5001	0	\N	0	0	\N	\N	0	332447	0	8331-1	3006322		
26096	2396	3009542	1995-10-31	1995-10-31 00:00:00	1995-10-31	5001	0	\N	0	0	\N	\N	0	159375	0	20570-8	3009542		
1160	96	3011505	1967-06-17	1967-06-17 00:00:00	1967-06-17	5001	0	\N	0	0	\N	\N	0	6478	0	19926-5	3011505		
23199	2135	3036780	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	142128	0	6095-4	3036780		
12545	1193	3006322	1977-05-16	1977-05-16 00:00:00	1977-05-16	5001	0	\N	0	0	\N	\N	0	78631	0	8331-1	3006322		
42635	1314	4052083	2012-04-22	2012-04-22 00:00:00	2012-04-22	5001	0	\N	0	0	\N	\N	0	87051	0	23426006	4052083		
34706	3176	3023430	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	211108	0	6833-8	3023430		
55474	5094	3023430	1999-05-19	1999-05-19 00:00:00	1999-05-19	5001	0	\N	0	0	\N	\N	0	338442	0	6833-8	3023430		
15280	1401	3006322	1991-01-14	1991-01-14 00:00:00	1991-01-14	5001	0	\N	0	0	\N	\N	0	93141	0	8331-1	3006322		
51941	4763	3051031	2009-10-06	2009-10-06 00:00:00	2009-10-06	5001	0	\N	0	0	\N	\N	0	317432	0	46240-8	3051031		
26707	2462	3006451	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	163274	0	6273-7	3006451		
6243	191	4133840	1992-09-15	1992-09-15 00:00:00	1992-09-15	5001	0	\N	0	0	\N	\N	0	13068	0	127783003	4133840		
56585	5194	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	345320	0	6158-0	3019406		
47350	1442	4052083	1968-12-02	1968-12-02 00:00:00	1968-12-02	5001	0	\N	0	0	\N	\N	0	96144	0	23426006	4052083		
56686	5200	3021226	1982-09-04	1982-09-04 00:00:00	1982-09-04	5001	0	\N	0	0	\N	\N	0	345935	0	6246-3	3021226		
30933	2832	3006734	1994-03-05	1994-03-05 00:00:00	1994-03-05	5001	0	\N	0	0	\N	\N	0	187897	0	6189-5	3006734		
10111	962	3006322	1955-09-30	1955-09-30 00:00:00	1955-09-30	5001	0	\N	0	0	\N	\N	0	64021	0	8331-1	3006322		
38363	3532	3006322	2014-03-15	2014-03-15 00:00:00	2014-03-15	5001	0	\N	0	0	\N	\N	0	234648	0	8331-1	3006322		
22929	2100	3006322	1951-09-06	1951-09-06 00:00:00	1951-09-06	5001	0	\N	0	0	\N	\N	0	139982	0	8331-1	3006322		
23031	2119	3006322	1988-01-25	1988-01-25 00:00:00	1988-01-25	5001	0	\N	0	0	\N	\N	0	141051	0	8331-1	3006322		
156952	4826	4052083	1996-05-10	1996-05-10 00:00:00	1996-05-10	5001	0	\N	0	0	\N	\N	0	321031	0	23426006	4052083		
19053	1746	3006322	1997-08-09	1997-08-09 00:00:00	1997-08-09	5001	0	\N	0	0	\N	\N	0	116723	0	8331-1	3006322		
2562	254	3006322	1971-07-15	1971-07-15 00:00:00	1971-07-15	5001	0	\N	0	0	\N	\N	0	16956	0	8331-1	3006322		
52861	1604	4133840	2014-08-28	2014-08-28 00:00:00	2014-08-28	5001	0	\N	0	0	\N	\N	0	107655	0	127783003	4133840		
1326	114	3009542	2006-03-05	2006-03-05 00:00:00	2006-03-05	5001	0	\N	0	0	\N	\N	0	7511	0	20570-8	3009542		
57378	5267	3000876	1999-06-26	1999-06-26 00:00:00	1999-06-26	5001	0	\N	0	0	\N	\N	0	350412	0	6082-2	3000876		
2872	273	3019406	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	18196	0	6158-0	3019406		
42044	3891	3006451	1995-11-29	1995-11-29 00:00:00	1995-11-29	5001	0	\N	0	0	\N	\N	0	258675	0	6273-7	3006451		
63057	1937	4024958	1970-12-27	1970-12-27 00:00:00	1970-12-27	5001	0	\N	0	0	\N	\N	0	128847	0	117015009	4024958		
18188	571	4052083	2005-08-03	2005-08-03 00:00:00	2005-08-03	5001	0	\N	0	0	\N	\N	0	37844	0	23426006	4052083		
18180	1655	3006322	1986-04-10	1986-04-10 00:00:00	1986-04-10	5001	0	\N	0	0	\N	\N	0	110983	0	8331-1	3006322		
14648	457	4024958	1961-03-27	1961-03-27 00:00:00	1961-03-27	5001	0	\N	0	0	\N	\N	0	30569	0	117015009	4024958		
78948	2425	4024958	1994-08-22	1994-08-22 00:00:00	1994-08-22	5001	0	\N	0	0	\N	\N	0	160915	0	117015009	4024958		
11399	1091	3051031	1957-10-05	1957-10-05 00:00:00	1957-10-05	5001	0	\N	0	0	\N	\N	0	71687	0	46240-8	3051031		
147404	4520	4133840	1984-12-01	1984-12-01 00:00:00	1984-12-01	5001	0	\N	0	0	\N	\N	0	300924	0	127783003	4133840		
10030	320	4133840	2002-03-10	2002-03-10 00:00:00	2002-03-10	5001	0	\N	0	0	\N	\N	0	21217	0	127783003	4133840		
30980	2832	3023430	1994-03-05	1994-03-05 00:00:00	1994-03-05	5001	0	\N	0	0	\N	\N	0	187897	0	6833-8	3023430		
31076	2835	3006322	1917-05-24	1917-05-24 00:00:00	1917-05-24	5001	0	\N	0	0	\N	\N	0	188312	0	8331-1	3006322		
15831	1447	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	96445	0	6273-7	3006451		
28477	2636	3006322	2006-04-18	2006-04-18 00:00:00	2006-04-18	5001	0	\N	0	0	\N	\N	0	174415	0	8331-1	3006322		
13512	1276	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	84260	0	6833-8	3023430		
57208	5253	3011505	2005-12-10	2005-12-10 00:00:00	2005-12-10	5001	0	\N	0	0	\N	\N	0	349566	0	19926-5	3011505		
9093	867	3049273	2005-04-25	2005-04-25 00:00:00	2005-04-25	5001	0	\N	0	0	\N	\N	0	57584	0	38265-5	3049273		
12430	1176	46235214	2012-12-25	2012-12-25 00:00:00	2012-12-25	5001	0	\N	0	0	\N	\N	0	77703	0	76690-7	46235214		
39194	3622	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	240676	0	6085-5	3001247		
50225	4580	3006322	1976-11-04	1976-11-04 00:00:00	1976-11-04	5001	0	\N	0	0	\N	\N	0	305113	0	8331-1	3006322		
85623	2651	4052083	2008-09-23	2008-09-23 00:00:00	2008-09-23	5001	0	\N	0	0	\N	\N	0	175384	0	23426006	4052083		
138683	4276	4024958	2019-02-25	2019-02-25 00:00:00	2019-02-25	5001	0	\N	0	0	\N	\N	0	283743	0	117015009	4024958		
123052	3791	4052083	1932-06-26	1932-06-26 00:00:00	1932-06-26	5001	0	\N	0	0	\N	\N	0	252053	0	23426006	4052083		
18653	1716	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	114761	0	6246-3	3021226		
18759	1727	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	115467	0	6833-8	3023430		
20734	651	4024958	1988-11-29	1988-11-29 00:00:00	1988-11-29	5001	0	\N	0	0	\N	\N	0	43107	0	117015009	4024958		
10309	992	3006322	2004-09-19	2004-09-19 00:00:00	2004-09-19	5001	0	\N	0	0	\N	\N	0	65773	0	8331-1	3006322		
21665	1999	3012494	2011-10-05	2011-10-05 00:00:00	2011-10-05	5001	0	\N	0	0	\N	\N	0	133114	0	6206-7	3012494		
41607	3874	3006734	1984-01-20	1984-01-20 00:00:00	1984-01-20	5001	0	\N	0	0	\N	\N	0	257211	0	6189-5	3006734		
102731	3159	4052083	2002-08-01	2002-08-01 00:00:00	2002-08-01	5001	0	\N	0	0	\N	\N	0	210076	0	23426006	4052083		
18901	1738	3006322	1975-09-07	1975-09-07 00:00:00	1975-09-07	5001	0	\N	0	0	\N	\N	0	116130	0	8331-1	3006322		
54678	5000	3006322	1977-07-04	1977-07-04 00:00:00	1977-07-04	5001	0	\N	0	0	\N	\N	0	332544	0	8331-1	3006322		
26097	2396	3000963	1995-10-31	1995-10-31 00:00:00	1995-10-31	5001	0	\N	0	0	\N	\N	0	159375	0	718-7	3000963		
1161	96	3011505	1993-04-10	1993-04-10 00:00:00	1993-04-10	5001	0	\N	0	0	\N	\N	0	6528	0	19926-5	3011505		
23200	2135	3020655	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	142128	0	6844-5	3020655		
12546	1193	3006322	1987-01-05	1987-01-05 00:00:00	1987-01-05	5001	0	\N	0	0	\N	\N	0	78643	0	8331-1	3006322		
18416	1685	3006322	1980-09-10	1980-09-10 00:00:00	1980-09-10	5001	0	\N	0	0	\N	\N	0	112883	0	8331-1	3006322		
34707	3176	3021226	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	211108	0	6246-3	3021226		
55475	5094	3006322	2006-01-06	2006-01-06 00:00:00	2006-01-06	5001	0	\N	0	0	\N	\N	0	338448	0	8331-1	3006322		
15281	1401	3006322	1996-06-26	1996-06-26 00:00:00	1996-06-26	5001	0	\N	0	0	\N	\N	0	93136	0	8331-1	3006322		
51942	4763	3006322	1962-03-13	1962-03-13 00:00:00	1962-03-13	5001	0	\N	0	0	\N	\N	0	317458	0	8331-1	3006322		
26708	2462	3000876	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	163274	0	6082-2	3000876		
6245	191	4133840	1993-09-21	1993-09-21 00:00:00	1993-09-21	5001	0	\N	0	0	\N	\N	0	13085	0	127783003	4133840		
56586	5194	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	345320	0	6206-7	3012494		
47355	1442	4052083	1973-04-09	1973-04-09 00:00:00	1973-04-09	5001	0	\N	0	0	\N	\N	0	96106	0	23426006	4052083		
56687	5200	3012494	1982-09-04	1982-09-04 00:00:00	1982-09-04	5001	0	\N	0	0	\N	\N	0	345935	0	6206-7	3012494		
30934	2832	3036780	1994-03-05	1994-03-05 00:00:00	1994-03-05	5001	0	\N	0	0	\N	\N	0	187897	0	6095-4	3036780		
10112	962	3006322	1951-02-09	1951-02-09 00:00:00	1951-02-09	5001	0	\N	0	0	\N	\N	0	64085	0	8331-1	3006322		
38364	3532	3006322	1981-10-13	1981-10-13 00:00:00	1981-10-13	5001	0	\N	0	0	\N	\N	0	234644	0	8331-1	3006322		
22930	2100	3006322	1945-10-27	1945-10-27 00:00:00	1945-10-27	5001	0	\N	0	0	\N	\N	0	139981	0	8331-1	3006322		
23032	2119	3006322	1962-11-20	1962-11-20 00:00:00	1962-11-20	5001	0	\N	0	0	\N	\N	0	140962	0	8331-1	3006322		
156955	4826	4024958	1992-04-17	1992-04-17 00:00:00	1992-04-17	5001	0	\N	0	0	\N	\N	0	320943	0	117015009	4024958		
112831	3483	4052083	1965-10-20	1965-10-20 00:00:00	1965-10-20	5001	0	\N	0	0	\N	\N	0	231059	0	23426006	4052083		
2594	260	3036780	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	17262	0	6095-4	3036780		
52864	1604	4133840	2011-08-11	2011-08-11 00:00:00	2011-08-11	5001	0	\N	0	0	\N	\N	0	107645	0	127783003	4133840		
1327	114	3000963	2006-03-05	2006-03-05 00:00:00	2006-03-05	5001	0	\N	0	0	\N	\N	0	7511	0	718-7	3000963		
57379	5267	3036780	1999-06-26	1999-06-26 00:00:00	1999-06-26	5001	0	\N	0	0	\N	\N	0	350412	0	6095-4	3036780		
2873	273	3015076	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	18241	0	6248-9	3015076		
42045	3891	3012494	1995-11-29	1995-11-29 00:00:00	1995-11-29	5001	0	\N	0	0	\N	\N	0	258675	0	6206-7	3012494		
24135	755	4052083	1979-12-15	1979-12-15 00:00:00	1979-12-15	5001	0	\N	0	0	\N	\N	0	50063	0	23426006	4052083		
18191	571	4052083	2014-05-27	2014-05-27 00:00:00	2014-05-27	5001	0	\N	0	0	\N	\N	0	37828	0	23426006	4052083		
18181	1655	3006322	2000-10-19	2000-10-19 00:00:00	2000-10-19	5001	0	\N	0	0	\N	\N	0	110984	0	8331-1	3006322		
129597	3991	4052083	1994-01-17	1994-01-17 00:00:00	1994-01-17	5001	0	\N	0	0	\N	\N	0	265344	0	23426006	4052083		
78951	2425	4024958	1971-09-29	1971-09-29 00:00:00	1971-09-29	5001	0	\N	0	0	\N	\N	0	160875	0	117015009	4024958		
11401	1091	40758406	1957-10-05	1957-10-05 00:00:00	1957-10-05	5001	0	\N	0	0	\N	\N	0	71687	0	55277-8	40758406		
147414	4520	4133840	1980-11-08	1980-11-08 00:00:00	1980-11-08	5001	0	\N	0	0	\N	\N	0	300959	0	127783003	4133840		
10032	320	4133840	2004-03-14	2004-03-14 00:00:00	2004-03-14	5001	0	\N	0	0	\N	\N	0	21182	0	127783003	4133840		
30981	2832	3020655	1994-03-05	1994-03-05 00:00:00	1994-03-05	5001	0	\N	0	0	\N	\N	0	187897	0	6844-5	3020655		
31077	2835	3006322	1982-05-04	1982-05-04 00:00:00	1982-05-04	5001	0	\N	0	0	\N	\N	0	188214	0	8331-1	3006322		
15832	1447	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	96445	0	6106-9	3014599		
28478	2636	3006322	1997-07-12	1997-07-12 00:00:00	1997-07-12	5001	0	\N	0	0	\N	\N	0	174422	0	8331-1	3006322		
13513	1276	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	84260	0	6844-5	3020655		
57209	5253	3011505	2004-01-03	2004-01-03 00:00:00	2004-01-03	5001	0	\N	0	0	\N	\N	0	349509	0	19926-5	3011505		
9094	867	3006322	2007-12-09	2007-12-09 00:00:00	2007-12-09	5001	0	\N	0	0	\N	\N	0	57525	0	8331-1	3006322		
12431	1176	3051031	2012-12-25	2012-12-25 00:00:00	2012-12-25	5001	0	\N	0	0	\N	\N	0	77703	0	46240-8	3051031		
39195	3622	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	240676	0	6276-0	3027231		
50343	4586	3006322	1992-04-26	1992-04-26 00:00:00	1992-04-26	5001	0	\N	0	0	\N	\N	0	305521	0	8331-1	3006322		
85628	2651	4052083	1969-11-20	1969-11-20 00:00:00	1969-11-20	5001	0	\N	0	0	\N	\N	0	175487	0	23426006	4052083		
138684	4276	4052083	2016-11-14	2016-11-14 00:00:00	2016-11-14	5001	0	\N	0	0	\N	\N	0	283779	0	23426006	4052083		
123066	3793	4024958	2004-10-05	2004-10-05 00:00:00	2004-10-05	5001	0	\N	0	0	\N	\N	0	252235	0	117015009	4024958		
18654	1716	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	114761	0	6273-7	3006451		
18760	1727	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	115467	0	6189-5	3006734		
39739	3695	3000876	1981-06-13	1981-06-13 00:00:00	1981-06-13	5001	0	\N	0	0	\N	\N	0	245609	0	6082-2	3000876		
10310	992	3006322	2000-07-04	2000-07-04 00:00:00	2000-07-04	5001	0	\N	0	0	\N	\N	0	65787	0	8331-1	3006322		
21666	1999	3000876	2011-10-05	2011-10-05 00:00:00	2011-10-05	5001	0	\N	0	0	\N	\N	0	133114	0	6082-2	3000876		
41608	3874	3020655	1984-01-20	1984-01-20 00:00:00	1984-01-20	5001	0	\N	0	0	\N	\N	0	257211	0	6844-5	3020655		
102733	3159	4024958	1970-11-17	1970-11-17 00:00:00	1970-11-17	5001	0	\N	0	0	\N	\N	0	210024	0	117015009	4024958		
18902	1738	3006322	1974-01-30	1974-01-30 00:00:00	1974-01-30	5001	0	\N	0	0	\N	\N	0	116129	0	8331-1	3006322		
54680	5000	3049273	2000-06-01	2000-06-01 00:00:00	2000-06-01	5001	0	\N	0	0	\N	\N	0	332554	0	38265-5	3049273		
26098	2396	3049273	2000-09-03	2000-09-03 00:00:00	2000-09-03	5001	0	\N	0	0	\N	\N	0	159324	0	38265-5	3049273		
1162	96	3011505	1982-02-06	1982-02-06 00:00:00	1982-02-06	5001	0	\N	0	0	\N	\N	0	6513	0	19926-5	3011505		
23201	2135	3023430	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	142128	0	6833-8	3023430		
12547	1193	3006322	2006-06-17	2006-06-17 00:00:00	2006-06-17	5001	0	\N	0	0	\N	\N	0	78644	0	8331-1	3006322		
18417	1685	3006322	1999-01-01	1999-01-01 00:00:00	1999-01-01	5001	0	\N	0	0	\N	\N	0	112872	0	8331-1	3006322		
34708	3176	3020655	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	211108	0	6844-5	3020655		
55476	5094	3006322	2004-12-26	2004-12-26 00:00:00	2004-12-26	5001	0	\N	0	0	\N	\N	0	338447	0	8331-1	3006322		
15282	1401	3006322	1998-05-01	1998-05-01 00:00:00	1998-05-01	5001	0	\N	0	0	\N	\N	0	93154	0	8331-1	3006322		
51943	4763	3006322	1950-10-22	1950-10-22 00:00:00	1950-10-22	5001	0	\N	0	0	\N	\N	0	317403	0	8331-1	3006322		
26709	2462	3001247	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	163274	0	6085-5	3001247		
6377	195	4024958	1976-11-22	1976-11-22 00:00:00	1976-11-22	5001	0	\N	0	0	\N	\N	0	13390	0	117015009	4024958		
56587	5194	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	345320	0	6082-2	3000876		
47360	1443	4052083	1983-03-25	1983-03-25 00:00:00	1983-03-25	5001	0	\N	0	0	\N	\N	0	96201	0	23426006	4052083		
56688	5200	3006451	1982-09-04	1982-09-04 00:00:00	1982-09-04	5001	0	\N	0	0	\N	\N	0	345935	0	6273-7	3006451		
30935	2832	3023430	1994-03-05	1994-03-05 00:00:00	1994-03-05	5001	0	\N	0	0	\N	\N	0	187897	0	6833-8	3023430		
152291	4668	4052083	1976-05-22	1976-05-22 00:00:00	1976-05-22	5001	0	\N	0	0	\N	\N	0	311033	0	23426006	4052083		
26905	842	4133840	2006-09-02	2006-09-02 00:00:00	2006-09-02	5001	0	\N	0	0	\N	\N	0	55683	0	127783003	4133840		
22931	2100	3006322	1977-11-23	1977-11-23 00:00:00	1977-11-23	5001	0	\N	0	0	\N	\N	0	139984	0	8331-1	3006322		
23033	2119	3027231	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	140966	0	6276-0	3027231		
156974	4826	4024958	2011-07-31	2011-07-31 00:00:00	2011-07-31	5001	0	\N	0	0	\N	\N	0	321045	0	117015009	4024958		
112855	3483	4052083	2006-06-25	2006-06-25 00:00:00	2006-06-25	5001	0	\N	0	0	\N	\N	0	231089	0	23426006	4052083		
2595	260	3001488	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	17262	0	7258-7	3001488		
52865	1604	4133840	2004-07-01	2004-07-01 00:00:00	2004-07-01	5001	0	\N	0	0	\N	\N	0	107598	0	127783003	4133840		
1328	114	3006322	1976-01-17	1976-01-17 00:00:00	1976-01-17	5001	0	\N	0	0	\N	\N	0	7530	0	8331-1	3006322		
57380	5267	3021226	1999-06-26	1999-06-26 00:00:00	1999-06-26	5001	0	\N	0	0	\N	\N	0	350412	0	6246-3	3021226		
2874	273	3005136	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	18241	0	6075-6	3005136		
42046	3891	3021226	1995-11-29	1995-11-29 00:00:00	1995-11-29	5001	0	\N	0	0	\N	\N	0	258675	0	6246-3	3021226		
24141	755	4024958	2014-01-24	2014-01-24 00:00:00	2014-01-24	5001	0	\N	0	0	\N	\N	0	50069	0	117015009	4024958		
18218	571	4024958	1958-04-14	1958-04-14 00:00:00	1958-04-14	5001	0	\N	0	0	\N	\N	0	37825	0	117015009	4024958		
18182	1655	3006322	1984-06-02	1984-06-02 00:00:00	1984-06-02	5001	0	\N	0	0	\N	\N	0	111028	0	8331-1	3006322		
129601	3991	4024958	1955-06-12	1955-06-12 00:00:00	1955-06-12	5001	0	\N	0	0	\N	\N	0	265338	0	117015009	4024958		
78957	2425	4052083	1971-06-21	1971-06-21 00:00:00	1971-06-21	5001	0	\N	0	0	\N	\N	0	160913	0	23426006	4052083		
11403	1091	46235214	1957-10-05	1957-10-05 00:00:00	1957-10-05	5001	0	\N	0	0	\N	\N	0	71687	0	76690-7	46235214		
147417	4520	4133840	1993-01-16	1993-01-16 00:00:00	1993-01-16	5001	0	\N	0	0	\N	\N	0	300928	0	127783003	4133840		
10033	320	4133840	2018-03-25	2018-03-25 00:00:00	2018-03-25	5001	0	\N	0	0	\N	\N	0	21254	0	127783003	4133840		
30982	2832	3021226	1994-03-05	1994-03-05 00:00:00	1994-03-05	5001	0	\N	0	0	\N	\N	0	187897	0	6246-3	3021226		
31078	2835	3006322	1968-05-05	1968-05-05 00:00:00	1968-05-05	5001	0	\N	0	0	\N	\N	0	188210	0	8331-1	3006322		
15833	1447	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	96445	0	6095-4	3036780		
28479	2636	3006322	1968-03-17	1968-03-17 00:00:00	1968-03-17	5001	0	\N	0	0	\N	\N	0	174484	0	8331-1	3006322		
95423	2925	4024958	1999-11-05	1999-11-05 00:00:00	1999-11-05	5001	0	\N	0	0	\N	\N	0	195009	0	117015009	4024958		
57210	5253	3011505	2012-01-14	2012-01-14 00:00:00	2012-01-14	5001	0	\N	0	0	\N	\N	0	349538	0	19926-5	3011505		
9095	867	3049273	1998-09-29	1998-09-29 00:00:00	1998-09-29	5001	0	\N	0	0	\N	\N	0	57582	0	38265-5	3049273		
12432	1176	3006322	1988-01-24	1988-01-24 00:00:00	1988-01-24	5001	0	\N	0	0	\N	\N	0	77601	0	8331-1	3006322		
39196	3622	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	240676	0	7258-7	3001488		
50344	4586	3006322	2003-08-22	2003-08-22 00:00:00	2003-08-22	5001	0	\N	0	0	\N	\N	0	305508	0	8331-1	3006322		
85632	2651	4024958	1973-11-08	1973-11-08 00:00:00	1973-11-08	5001	0	\N	0	0	\N	\N	0	175488	0	117015009	4024958		
138688	4276	4024958	1997-07-24	1997-07-24 00:00:00	1997-07-24	5001	0	\N	0	0	\N	\N	0	283775	0	117015009	4024958		
123067	3793	4024958	1959-10-28	1959-10-28 00:00:00	1959-10-28	5001	0	\N	0	0	\N	\N	0	252182	0	117015009	4024958		
18655	1716	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	114761	0	6106-9	3014599		
18761	1727	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	115467	0	6844-5	3020655		
39740	3695	3023430	1981-06-13	1981-06-13 00:00:00	1981-06-13	5001	0	\N	0	0	\N	\N	0	245609	0	6833-8	3023430		
10311	992	3000963	1969-08-19	1969-08-19 00:00:00	1969-08-19	5001	0	\N	0	0	\N	\N	0	65770	0	718-7	3000963		
21667	1999	3006322	1990-03-22	1990-03-22 00:00:00	1990-03-22	5001	0	\N	0	0	\N	\N	0	133070	0	8331-1	3006322		
41609	3874	3000876	1984-01-20	1984-01-20 00:00:00	1984-01-20	5001	0	\N	0	0	\N	\N	0	257211	0	6082-2	3000876		
102740	3159	4024958	1964-06-30	1964-06-30 00:00:00	1964-06-30	5001	0	\N	0	0	\N	\N	0	210036	0	117015009	4024958		
18903	1739	3006322	1969-03-11	1969-03-11 00:00:00	1969-03-11	5001	0	\N	0	0	\N	\N	0	116209	0	8331-1	3006322		
54681	5000	3006322	1944-08-11	1944-08-11 00:00:00	1944-08-11	5001	0	\N	0	0	\N	\N	0	332510	0	8331-1	3006322		
21115	1954	3051031	2003-05-08	2003-05-08 00:00:00	2003-05-08	5001	0	\N	0	0	\N	\N	0	130002	0	46240-8	3051031		
1163	96	3011505	1977-01-08	1977-01-08 00:00:00	1977-01-08	5001	0	\N	0	0	\N	\N	0	6480	0	19926-5	3011505		
23202	2135	3000876	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	142128	0	6082-2	3000876		
12548	1193	3006322	1954-03-23	1954-03-23 00:00:00	1954-03-23	5001	0	\N	0	0	\N	\N	0	78596	0	8331-1	3006322		
18418	1685	3006322	1989-01-10	1989-01-10 00:00:00	1989-01-10	5001	0	\N	0	0	\N	\N	0	112892	0	8331-1	3006322		
34709	3176	3001247	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	211108	0	6085-5	3001247		
55477	5094	3006322	2006-10-18	2006-10-18 00:00:00	2006-10-18	5001	0	\N	0	0	\N	\N	0	338459	0	8331-1	3006322		
21132	665	4024958	1958-03-21	1958-03-21 00:00:00	1958-03-21	5001	0	\N	0	0	\N	\N	0	43951	0	117015009	4024958		
51944	4763	3006322	1953-04-20	1953-04-20 00:00:00	1953-04-20	5001	0	\N	0	0	\N	\N	0	317426	0	8331-1	3006322		
26710	2462	3014599	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	163274	0	6106-9	3014599		
6384	195	4024958	2014-12-25	2014-12-25 00:00:00	2014-12-25	5001	0	\N	0	0	\N	\N	0	13394	0	117015009	4024958		
56588	5194	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	345320	0	6844-5	3020655		
150693	4621	4024958	1979-10-12	1979-10-12 00:00:00	1979-10-12	5001	0	\N	0	0	\N	\N	0	307746	0	117015009	4024958		
56689	5200	3023430	1982-09-04	1982-09-04 00:00:00	1982-09-04	5001	0	\N	0	0	\N	\N	0	345935	0	6833-8	3023430		
30936	2832	3020655	1994-03-05	1994-03-05 00:00:00	1994-03-05	5001	0	\N	0	0	\N	\N	0	187897	0	6844-5	3020655		
152323	4670	4024958	1963-11-21	1963-11-21 00:00:00	1963-11-21	5001	0	\N	0	0	\N	\N	0	311160	0	117015009	4024958		
26906	842	4133840	1978-12-30	1978-12-30 00:00:00	1978-12-30	5001	0	\N	0	0	\N	\N	0	55735	0	127783003	4133840		
22932	2100	3006322	2015-12-19	2015-12-19 00:00:00	2015-12-19	5001	0	\N	0	0	\N	\N	0	139960	0	8331-1	3006322		
23034	2119	3006451	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	140966	0	6273-7	3006451		
168266	5166	4024958	1963-12-23	1963-12-23 00:00:00	1963-12-23	5001	0	\N	0	0	\N	\N	0	343423	0	117015009	4024958		
132546	4081	4024958	1956-12-03	1956-12-03 00:00:00	1956-12-03	5001	0	\N	0	0	\N	\N	0	271221	0	117015009	4024958		
2596	260	3023430	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	17262	0	6833-8	3023430		
52868	1604	4133840	2001-06-21	2001-06-21 00:00:00	2001-06-21	5001	0	\N	0	0	\N	\N	0	107652	0	127783003	4133840		
1329	114	3006322	1974-12-31	1974-12-31 00:00:00	1974-12-31	5001	0	\N	0	0	\N	\N	0	7529	0	8331-1	3006322		
57381	5267	3005136	1999-06-26	1999-06-26 00:00:00	1999-06-26	5001	0	\N	0	0	\N	\N	0	350412	0	6075-6	3005136		
2875	273	3012494	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	18241	0	6206-7	3012494		
42047	3891	3005136	1995-11-29	1995-11-29 00:00:00	1995-11-29	5001	0	\N	0	0	\N	\N	0	258675	0	6075-6	3005136		
24148	755	4052083	2004-04-16	2004-04-16 00:00:00	2004-04-16	5001	0	\N	0	0	\N	\N	0	50068	0	23426006	4052083		
18227	572	4024958	1975-01-29	1975-01-29 00:00:00	1975-01-29	5001	0	\N	0	0	\N	\N	0	37868	0	117015009	4024958		
18183	1655	3006322	1981-08-03	1981-08-03 00:00:00	1981-08-03	5001	0	\N	0	0	\N	\N	0	111006	0	8331-1	3006322		
129636	3993	4024958	1965-04-15	1965-04-15 00:00:00	1965-04-15	5001	0	\N	0	0	\N	\N	0	265482	0	117015009	4024958		
78980	2427	4024958	2007-09-06	2007-09-06 00:00:00	2007-09-06	5001	0	\N	0	0	\N	\N	0	161000	0	117015009	4024958		
11404	1091	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	71682	0	6106-9	3014599		
147420	4520	4133840	1996-02-03	1996-02-03 00:00:00	1996-02-03	5001	0	\N	0	0	\N	\N	0	300939	0	127783003	4133840		
10034	320	4133840	2019-03-31	2019-03-31 00:00:00	2019-03-31	5001	0	\N	0	0	\N	\N	0	21220	0	127783003	4133840		
30983	2832	3001247	1994-03-05	1994-03-05 00:00:00	1994-03-05	5001	0	\N	0	0	\N	\N	0	187897	0	6085-5	3001247		
31079	2835	3006322	1938-05-16	1938-05-16 00:00:00	1938-05-16	5001	0	\N	0	0	\N	\N	0	188333	0	8331-1	3006322		
15834	1447	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	96445	0	6246-3	3021226		
28480	2636	3006322	1996-08-29	1996-08-29 00:00:00	1996-08-29	5001	0	\N	0	0	\N	\N	0	174414	0	8331-1	3006322		
95425	2925	4024958	1973-12-09	1973-12-09 00:00:00	1973-12-09	5001	0	\N	0	0	\N	\N	0	194996	0	117015009	4024958		
57211	5253	3011505	2015-01-31	2015-01-31 00:00:00	2015-01-31	5001	0	\N	0	0	\N	\N	0	349520	0	19926-5	3011505		
9099	867	3006322	1970-09-05	1970-09-05 00:00:00	1970-09-05	5001	0	\N	0	0	\N	\N	0	57515	0	8331-1	3006322		
12433	1176	40758406	2011-10-02	2011-10-02 00:00:00	2011-10-02	5001	0	\N	0	0	\N	\N	0	77680	0	55277-8	40758406		
39197	3622	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	240676	0	6273-7	3006451		
50345	4586	3006322	1995-03-21	1995-03-21 00:00:00	1995-03-21	5001	0	\N	0	0	\N	\N	0	305488	0	8331-1	3006322		
85639	2651	4024958	1969-08-19	1969-08-19 00:00:00	1969-08-19	5001	0	\N	0	0	\N	\N	0	175444	0	117015009	4024958		
48635	4446	3006322	1982-01-27	1982-01-27 00:00:00	1982-01-27	5001	0	\N	0	0	\N	\N	0	295650	0	8331-1	3006322		
7272	703	3006322	1956-09-18	1956-09-18 00:00:00	1956-09-18	5001	0	\N	0	0	\N	\N	0	46472	0	8331-1	3006322		
18656	1716	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	114761	0	6158-0	3019406		
18762	1727	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	115467	0	6106-9	3014599		
39741	3695	3012494	1981-06-13	1981-06-13 00:00:00	1981-06-13	5001	0	\N	0	0	\N	\N	0	245609	0	6206-7	3012494		
10312	992	3009542	1969-08-19	1969-08-19 00:00:00	1969-08-19	5001	0	\N	0	0	\N	\N	0	65770	0	20570-8	3009542		
21668	1999	3006734	2015-04-08	2015-04-08 00:00:00	2015-04-08	5001	0	\N	0	0	\N	\N	0	133128	0	6189-5	3006734		
41610	3874	3005136	1984-01-20	1984-01-20 00:00:00	1984-01-20	5001	0	\N	0	0	\N	\N	0	257211	0	6075-6	3005136		
102741	3159	4024958	1975-07-03	1975-07-03 00:00:00	1975-07-03	5001	0	\N	0	0	\N	\N	0	210037	0	117015009	4024958		
18904	1739	3006322	1996-04-13	1996-04-13 00:00:00	1996-04-13	5001	0	\N	0	0	\N	\N	0	116211	0	8331-1	3006322		
54682	5000	3049273	2011-03-06	2011-03-06 00:00:00	2011-03-06	5001	0	\N	0	0	\N	\N	0	332555	0	38265-5	3049273		
21116	1954	46235214	2003-05-08	2003-05-08 00:00:00	2003-05-08	5001	0	\N	0	0	\N	\N	0	130002	0	76690-7	46235214		
1164	96	3011505	1971-06-26	1971-06-26 00:00:00	1971-06-26	5001	0	\N	0	0	\N	\N	0	6564	0	19926-5	3011505		
23203	2135	3005136	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	142128	0	6075-6	3005136		
12549	1193	3006322	1992-09-14	1992-09-14 00:00:00	1992-09-14	5001	0	\N	0	0	\N	\N	0	78668	0	8331-1	3006322		
18419	1685	3006322	2004-03-16	2004-03-16 00:00:00	2004-03-16	5001	0	\N	0	0	\N	\N	0	112885	0	8331-1	3006322		
34710	3176	3005136	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	211108	0	6075-6	3005136		
55478	5094	40769184	1999-05-04	1999-05-04 00:00:00	1999-05-04	5001	0	\N	0	0	\N	\N	0	338446	0	66524-0	40769184		
21135	665	4024958	2007-07-09	2007-07-09 00:00:00	2007-07-09	5001	0	\N	0	0	\N	\N	0	43943	0	117015009	4024958		
51945	4763	46235214	2009-12-05	2009-12-05 00:00:00	2009-12-05	5001	0	\N	0	0	\N	\N	0	317420	0	76690-7	46235214		
26711	2462	3005136	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	163274	0	6075-6	3005136		
6391	196	4052083	1959-10-22	1959-10-22 00:00:00	1959-10-22	5001	0	\N	0	0	\N	\N	0	13440	0	23426006	4052083		
56589	5194	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	345320	0	6833-8	3023430		
150704	4622	4052083	2010-11-23	2010-11-23 00:00:00	2010-11-23	5001	0	\N	0	0	\N	\N	0	307817	0	23426006	4052083		
56690	5200	3020655	1982-09-04	1982-09-04 00:00:00	1982-09-04	5001	0	\N	0	0	\N	\N	0	345935	0	6844-5	3020655		
30937	2832	3021226	1994-03-05	1994-03-05 00:00:00	1994-03-05	5001	0	\N	0	0	\N	\N	0	187897	0	6246-3	3021226		
152324	4670	4024958	1961-06-24	1961-06-24 00:00:00	1961-06-24	5001	0	\N	0	0	\N	\N	0	311191	0	117015009	4024958		
26910	842	4133840	2018-11-10	2018-11-10 00:00:00	2018-11-10	5001	0	\N	0	0	\N	\N	0	55705	0	127783003	4133840		
22933	2100	3006322	2000-11-06	2000-11-06 00:00:00	2000-11-06	5001	0	\N	0	0	\N	\N	0	139943	0	8331-1	3006322		
23035	2119	3001488	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	140966	0	7258-7	3001488		
168267	5166	4024958	2011-04-23	2011-04-23 00:00:00	2011-04-23	5001	0	\N	0	0	\N	\N	0	343465	0	117015009	4024958		
132548	4081	4052083	1968-02-04	1968-02-04 00:00:00	1968-02-04	5001	0	\N	0	0	\N	\N	0	271253	0	23426006	4052083		
2597	260	3019406	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	17262	0	6158-0	3019406		
52870	1604	4133840	2012-08-16	2012-08-16 00:00:00	2012-08-16	5001	0	\N	0	0	\N	\N	0	107654	0	127783003	4133840		
1330	115	3006322	1961-05-26	1961-05-26 00:00:00	1961-05-26	5001	0	\N	0	0	\N	\N	0	7570	0	8331-1	3006322		
57382	5267	3001488	1999-06-26	1999-06-26 00:00:00	1999-06-26	5001	0	\N	0	0	\N	\N	0	350412	0	7258-7	3001488		
2876	273	3006734	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	18241	0	6189-5	3006734		
42048	3891	3014599	1995-11-29	1995-11-29 00:00:00	1995-11-29	5001	0	\N	0	0	\N	\N	0	258675	0	6106-9	3014599		
24158	755	4024958	1981-08-18	1981-08-18 00:00:00	1981-08-18	5001	0	\N	0	0	\N	\N	0	50046	0	117015009	4024958		
119033	3666	4024958	1972-05-27	1972-05-27 00:00:00	1972-05-27	5001	0	\N	0	0	\N	\N	0	243874	0	117015009	4024958		
18184	1655	3006322	1974-04-28	1974-04-28 00:00:00	1974-04-28	5001	0	\N	0	0	\N	\N	0	111005	0	8331-1	3006322		
129638	3993	4052083	1990-07-20	1990-07-20 00:00:00	1990-07-20	5001	0	\N	0	0	\N	\N	0	265458	0	23426006	4052083		
78986	2427	4024958	2000-09-03	2000-09-03 00:00:00	2000-09-03	5001	0	\N	0	0	\N	\N	0	161032	0	117015009	4024958		
11405	1091	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	71682	0	6273-7	3006451		
147424	4520	4133840	1989-12-30	1989-12-30 00:00:00	1989-12-30	5001	0	\N	0	0	\N	\N	0	300934	0	127783003	4133840		
10038	320	4133840	2017-03-19	2017-03-19 00:00:00	2017-03-19	5001	0	\N	0	0	\N	\N	0	21219	0	127783003	4133840		
30984	2832	3006322	2014-03-07	2014-03-07 00:00:00	2014-03-07	5001	0	\N	0	0	\N	\N	0	187937	0	8331-1	3006322		
31080	2836	3006322	2001-02-02	2001-02-02 00:00:00	2001-02-02	5001	0	\N	0	0	\N	\N	0	188387	0	8331-1	3006322		
15835	1447	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	96445	0	6085-5	3001247		
28482	2636	3006322	2001-08-01	2001-08-01 00:00:00	2001-08-01	5001	0	\N	0	0	\N	\N	0	174423	0	8331-1	3006322		
95432	2925	4024958	1962-03-01	1962-03-01 00:00:00	1962-03-01	5001	0	\N	0	0	\N	\N	0	195089	0	117015009	4024958		
1773	49	4024958	1988-02-03	1988-02-03 00:00:00	1988-02-03	5001	0	\N	0	0	\N	\N	0	3515	0	117015009	4024958		
9101	867	3049273	2002-06-10	2002-06-10 00:00:00	2002-06-10	5001	0	\N	0	0	\N	\N	0	57583	0	38265-5	3049273		
12434	1176	40766240	2011-10-02	2011-10-02 00:00:00	2011-10-02	5001	0	\N	0	0	\N	\N	0	77680	0	63513-6	40766240		
39198	3622	3006322	2012-09-04	2012-09-04 00:00:00	2012-09-04	5001	0	\N	0	0	\N	\N	0	240781	0	8331-1	3006322		
50346	4587	3006322	2004-10-12	2004-10-12 00:00:00	2004-10-12	5001	0	\N	0	0	\N	\N	0	305589	0	8331-1	3006322		
85647	2651	4052083	1956-04-11	1956-04-11 00:00:00	1956-04-11	5001	0	\N	0	0	\N	\N	0	175485	0	23426006	4052083		
48636	4446	3006322	1964-04-12	1964-04-12 00:00:00	1964-04-12	5001	0	\N	0	0	\N	\N	0	295634	0	8331-1	3006322		
7273	703	3006322	1981-07-25	1981-07-25 00:00:00	1981-07-25	5001	0	\N	0	0	\N	\N	0	46440	0	8331-1	3006322		
18657	1716	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	114761	0	6075-6	3005136		
18763	1727	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	115467	0	6082-2	3000876		
39742	3695	3005136	1981-06-13	1981-06-13 00:00:00	1981-06-13	5001	0	\N	0	0	\N	\N	0	245609	0	6075-6	3005136		
10313	992	3006322	1993-08-24	1993-08-24 00:00:00	1993-08-24	5001	0	\N	0	0	\N	\N	0	65778	0	8331-1	3006322		
21669	1999	3001488	2015-04-08	2015-04-08 00:00:00	2015-04-08	5001	0	\N	0	0	\N	\N	0	133128	0	7258-7	3001488		
41611	3874	3021226	1984-01-20	1984-01-20 00:00:00	1984-01-20	5001	0	\N	0	0	\N	\N	0	257211	0	6246-3	3021226		
102742	3159	4052083	1971-05-25	1971-05-25 00:00:00	1971-05-25	5001	0	\N	0	0	\N	\N	0	210089	0	23426006	4052083		
18905	1739	3006322	1994-09-11	1994-09-11 00:00:00	1994-09-11	5001	0	\N	0	0	\N	\N	0	116201	0	8331-1	3006322		
54684	5000	3006322	1941-04-13	1941-04-13 00:00:00	1941-04-13	5001	0	\N	0	0	\N	\N	0	332586	0	8331-1	3006322		
21117	1954	40758406	2003-05-08	2003-05-08 00:00:00	2003-05-08	5001	0	\N	0	0	\N	\N	0	130002	0	55277-8	40758406		
1165	96	3011505	1986-03-01	1986-03-01 00:00:00	1986-03-01	5001	0	\N	0	0	\N	\N	0	6515	0	19926-5	3011505		
23204	2135	3027231	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	142128	0	6276-0	3027231		
12550	1194	3006322	1960-10-23	1960-10-23 00:00:00	1960-10-23	5001	0	\N	0	0	\N	\N	0	78685	0	8331-1	3006322		
18420	1686	3006322	1969-03-11	1969-03-11 00:00:00	1969-03-11	5001	0	\N	0	0	\N	\N	0	112931	0	8331-1	3006322		
34711	3176	3036780	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	211108	0	6095-4	3036780		
55479	5094	40769194	1999-05-04	1999-05-04 00:00:00	1999-05-04	5001	0	\N	0	0	\N	\N	0	338446	0	66534-9	40769194		
21144	665	4052083	2011-08-23	2011-08-23 00:00:00	2011-08-23	5001	0	\N	0	0	\N	\N	0	43975	0	23426006	4052083		
51946	4763	40766240	2009-12-05	2009-12-05 00:00:00	2009-12-05	5001	0	\N	0	0	\N	\N	0	317420	0	63513-6	40766240		
26712	2462	3021226	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	163274	0	6246-3	3021226		
6427	197	4024958	2015-02-26	2015-02-26 00:00:00	2015-02-26	5001	0	\N	0	0	\N	\N	0	13548	0	117015009	4024958		
56590	5194	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	345320	0	6189-5	3006734		
150715	4622	4052083	1996-01-15	1996-01-15 00:00:00	1996-01-15	5001	0	\N	0	0	\N	\N	0	307807	0	23426006	4052083		
56691	5200	3001488	1982-09-04	1982-09-04 00:00:00	1982-09-04	5001	0	\N	0	0	\N	\N	0	345935	0	7258-7	3001488		
30938	2832	3014599	1994-03-05	1994-03-05 00:00:00	1994-03-05	5001	0	\N	0	0	\N	\N	0	187897	0	6106-9	3014599		
138266	4261	4052083	1998-03-14	1998-03-14 00:00:00	1998-03-14	5001	0	\N	0	0	\N	\N	0	282968	0	23426006	4052083		
26913	842	4133840	2014-10-18	2014-10-18 00:00:00	2014-10-18	5001	0	\N	0	0	\N	\N	0	55703	0	127783003	4133840		
22934	2100	3049273	2012-08-28	2012-08-28 00:00:00	2012-08-28	5001	0	\N	0	0	\N	\N	0	139973	0	38265-5	3049273		
23036	2119	3001247	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	140966	0	6085-5	3001247		
168269	5166	4052083	1969-10-31	1969-10-31 00:00:00	1969-10-31	5001	0	\N	0	0	\N	\N	0	343438	0	23426006	4052083		
132593	4084	4024958	1972-02-10	1972-02-10 00:00:00	1972-02-10	5001	0	\N	0	0	\N	\N	0	271398	0	117015009	4024958		
2598	260	3027231	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	17262	0	6276-0	3027231		
52879	1604	4133840	2008-07-24	2008-07-24 00:00:00	2008-07-24	5001	0	\N	0	0	\N	\N	0	107600	0	127783003	4133840		
1331	115	3006322	2015-01-29	2015-01-29 00:00:00	2015-01-29	5001	0	\N	0	0	\N	\N	0	7577	0	8331-1	3006322		
57383	5267	3006451	1999-06-26	1999-06-26 00:00:00	1999-06-26	5001	0	\N	0	0	\N	\N	0	350412	0	6273-7	3006451		
2877	273	3001488	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	18241	0	7258-7	3001488		
42049	3891	3036780	1995-11-29	1995-11-29 00:00:00	1995-11-29	5001	0	\N	0	0	\N	\N	0	258675	0	6095-4	3036780		
24159	755	4052083	1989-02-12	1989-02-12 00:00:00	1989-02-12	5001	0	\N	0	0	\N	\N	0	50040	0	23426006	4052083		
119034	3666	4024958	1999-03-27	1999-03-27 00:00:00	1999-03-27	5001	0	\N	0	0	\N	\N	0	243876	0	117015009	4024958		
18185	1655	3006322	1973-05-25	1973-05-25 00:00:00	1973-05-25	5001	0	\N	0	0	\N	\N	0	111021	0	8331-1	3006322		
129644	3993	4052083	2013-09-05	2013-09-05 00:00:00	2013-09-05	5001	0	\N	0	0	\N	\N	0	265459	0	23426006	4052083		
78988	2427	4024958	1943-12-06	1943-12-06 00:00:00	1943-12-06	5001	0	\N	0	0	\N	\N	0	160978	0	117015009	4024958		
11406	1091	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	71682	0	6844-5	3020655		
147428	4520	4133840	1995-01-28	1995-01-28 00:00:00	1995-01-28	5001	0	\N	0	0	\N	\N	0	300961	0	127783003	4133840		
10042	320	4133840	2009-02-01	2009-02-01 00:00:00	2009-02-01	5001	0	\N	0	0	\N	\N	0	21192	0	127783003	4133840		
30986	2833	3006322	1967-07-14	1967-07-14 00:00:00	1967-07-14	5001	0	\N	0	0	\N	\N	0	188049	0	8331-1	3006322		
31081	2836	3006322	1985-08-09	1985-08-09 00:00:00	1985-08-09	5001	0	\N	0	0	\N	\N	0	188386	0	8331-1	3006322		
15836	1447	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	96445	0	6833-8	3023430		
53203	1611	4052083	1968-12-13	1968-12-13 00:00:00	1968-12-13	5001	0	\N	0	0	\N	\N	0	108349	0	23426006	4052083		
164396	5049	4052083	1969-11-07	1969-11-07 00:00:00	1969-11-07	5001	0	\N	0	0	\N	\N	0	335589	0	23426006	4052083		
105022	3234	4024958	1972-07-21	1972-07-21 00:00:00	1972-07-21	5001	0	\N	0	0	\N	\N	0	214931	0	117015009	4024958		
9103	869	3006322	1971-03-01	1971-03-01 00:00:00	1971-03-01	5001	0	\N	0	0	\N	\N	0	57765	0	8331-1	3006322		
12436	1176	3051031	2011-10-02	2011-10-02 00:00:00	2011-10-02	5001	0	\N	0	0	\N	\N	0	77680	0	46240-8	3051031		
39199	3622	3006322	1925-09-08	1925-09-08 00:00:00	1925-09-08	5001	0	\N	0	0	\N	\N	0	240774	0	8331-1	3006322		
50350	4587	3049273	2011-09-29	2011-09-29 00:00:00	2011-09-29	5001	0	\N	0	0	\N	\N	0	305570	0	38265-5	3049273		
35990	1115	4052083	2000-10-11	2000-10-11 00:00:00	2000-10-11	5001	0	\N	0	0	\N	\N	0	73373	0	23426006	4052083		
48637	4446	3006322	1985-07-27	1985-07-27 00:00:00	1985-07-27	5001	0	\N	0	0	\N	\N	0	295635	0	8331-1	3006322		
7274	703	3006322	2015-11-05	2015-11-05 00:00:00	2015-11-05	5001	0	\N	0	0	\N	\N	0	46459	0	8331-1	3006322		
18658	1716	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	114761	0	6082-2	3000876		
18764	1727	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	115467	0	6085-5	3001247		
39743	3695	3014599	1981-06-13	1981-06-13 00:00:00	1981-06-13	5001	0	\N	0	0	\N	\N	0	245609	0	6106-9	3014599		
10315	994	3006322	1992-09-07	1992-09-07 00:00:00	1992-09-07	5001	0	\N	0	0	\N	\N	0	65908	0	8331-1	3006322		
21670	1999	3020655	2015-04-08	2015-04-08 00:00:00	2015-04-08	5001	0	\N	0	0	\N	\N	0	133128	0	6844-5	3020655		
41612	3874	3027231	1984-01-20	1984-01-20 00:00:00	1984-01-20	5001	0	\N	0	0	\N	\N	0	257211	0	6276-0	3027231		
31517	967	4052083	2018-03-08	2018-03-08 00:00:00	2018-03-08	5001	0	\N	0	0	\N	\N	0	64366	0	23426006	4052083		
18906	1739	3006322	2018-01-28	2018-01-28 00:00:00	2018-01-28	5001	0	\N	0	0	\N	\N	0	116217	0	8331-1	3006322		
54685	5001	3006322	2010-07-16	2010-07-16 00:00:00	2010-07-16	5001	0	\N	0	0	\N	\N	0	332620	0	8331-1	3006322		
21119	1954	3006322	1940-06-08	1940-06-08 00:00:00	1940-06-08	5001	0	\N	0	0	\N	\N	0	129947	0	8331-1	3006322		
1166	96	3011505	1989-03-18	1989-03-18 00:00:00	1989-03-18	5001	0	\N	0	0	\N	\N	0	6493	0	19926-5	3011505		
23205	2135	3012494	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	142128	0	6206-7	3012494		
12551	1194	3006322	1971-06-19	1971-06-19 00:00:00	1971-06-19	5001	0	\N	0	0	\N	\N	0	78726	0	8331-1	3006322		
18421	1686	3006322	2002-04-09	2002-04-09 00:00:00	2002-04-09	5001	0	\N	0	0	\N	\N	0	112936	0	8331-1	3006322		
34712	3176	3006734	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	211108	0	6189-5	3006734		
55480	5094	40769179	1999-05-04	1999-05-04 00:00:00	1999-05-04	5001	0	\N	0	0	\N	\N	0	338446	0	66519-0	40769179		
21157	665	4052083	2006-07-31	2006-07-31 00:00:00	2006-07-31	5001	0	\N	0	0	\N	\N	0	43982	0	23426006	4052083		
51949	4763	40758406	2009-12-05	2009-12-05 00:00:00	2009-12-05	5001	0	\N	0	0	\N	\N	0	317420	0	55277-8	40758406		
26713	2462	3019406	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	163274	0	6158-0	3019406		
52409	1588	4024958	2004-02-25	2004-02-25 00:00:00	2004-02-25	5001	0	\N	0	0	\N	\N	0	106614	0	117015009	4024958		
56591	5194	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	345320	0	6095-4	3036780		
161997	4971	4133840	2001-12-11	2001-12-11 00:00:00	2001-12-11	5001	0	\N	0	0	\N	\N	0	330580	0	127783003	4133840		
56692	5200	3027231	1982-09-04	1982-09-04 00:00:00	1982-09-04	5001	0	\N	0	0	\N	\N	0	345935	0	6276-0	3027231		
30939	2832	3019406	1994-03-05	1994-03-05 00:00:00	1994-03-05	5001	0	\N	0	0	\N	\N	0	187897	0	6158-0	3019406		
38097	1180	4024958	2008-10-21	2008-10-21 00:00:00	2008-10-21	5001	0	\N	0	0	\N	\N	0	77936	0	117015009	4024958		
26916	842	4133840	1993-06-19	1993-06-19 00:00:00	1993-06-19	5001	0	\N	0	0	\N	\N	0	55679	0	127783003	4133840		
22935	2100	3006322	2015-04-11	2015-04-11 00:00:00	2015-04-11	5001	0	\N	0	0	\N	\N	0	140014	0	8331-1	3006322		
23037	2119	3005136	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	140966	0	6075-6	3005136		
18005	1640	3006322	2005-03-24	2005-03-24 00:00:00	2005-03-24	5001	0	\N	0	0	\N	\N	0	110103	0	8331-1	3006322		
132611	4084	4052083	1987-01-26	1987-01-26 00:00:00	1987-01-26	5001	0	\N	0	0	\N	\N	0	271405	0	23426006	4052083		
2599	260	3021226	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	17262	0	6246-3	3021226		
52882	1604	4133840	2016-09-08	2016-09-08 00:00:00	2016-09-08	5001	0	\N	0	0	\N	\N	0	107638	0	127783003	4133840		
1332	115	3006322	1965-09-15	1965-09-15 00:00:00	1965-09-15	5001	0	\N	0	0	\N	\N	0	7564	0	8331-1	3006322		
57384	5267	3014599	1999-06-26	1999-06-26 00:00:00	1999-06-26	5001	0	\N	0	0	\N	\N	0	350412	0	6106-9	3014599		
2878	273	3021226	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	18241	0	6246-3	3021226		
42050	3891	3019406	1995-11-29	1995-11-29 00:00:00	1995-11-29	5001	0	\N	0	0	\N	\N	0	258675	0	6158-0	3019406		
24165	755	4052083	2011-04-01	2011-04-01 00:00:00	2011-04-01	5001	0	\N	0	0	\N	\N	0	50057	0	23426006	4052083		
150309	4608	4133840	1989-01-26	1989-01-26 00:00:00	1989-01-26	5001	0	\N	0	0	\N	\N	0	307057	0	127783003	4133840		
18186	1656	3006322	2000-03-19	2000-03-19 00:00:00	2000-03-19	5001	0	\N	0	0	\N	\N	0	111069	0	8331-1	3006322		
26808	842	4133840	1998-07-18	1998-07-18 00:00:00	1998-07-18	5001	0	\N	0	0	\N	\N	0	55688	0	127783003	4133840		
79007	2427	4052083	1972-05-11	1972-05-11 00:00:00	1972-05-11	5001	0	\N	0	0	\N	\N	0	161035	0	23426006	4052083		
11407	1091	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	71682	0	7258-7	3001488		
147430	4520	4133840	1983-11-26	1983-11-26 00:00:00	1983-11-26	5001	0	\N	0	0	\N	\N	0	300937	0	127783003	4133840		
10044	320	4133840	2010-02-07	2010-02-07 00:00:00	2010-02-07	5001	0	\N	0	0	\N	\N	0	21185	0	127783003	4133840		
30988	2833	3006322	1936-12-09	1936-12-09 00:00:00	1936-12-09	5001	0	\N	0	0	\N	\N	0	188097	0	8331-1	3006322		
31082	2836	3006322	2009-06-04	2009-06-04 00:00:00	2009-06-04	5001	0	\N	0	0	\N	\N	0	188400	0	8331-1	3006322		
15837	1447	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	96445	0	6189-5	3006734		
53206	1611	4024958	1977-02-16	1977-02-16 00:00:00	1977-02-16	5001	0	\N	0	0	\N	\N	0	108275	0	117015009	4024958		
164425	5049	4052083	1981-05-21	1981-05-21 00:00:00	1981-05-21	5001	0	\N	0	0	\N	\N	0	335576	0	23426006	4052083		
105039	3234	4024958	2002-03-07	2002-03-07 00:00:00	2002-03-07	5001	0	\N	0	0	\N	\N	0	214929	0	117015009	4024958		
9104	869	3006322	1922-06-02	1922-06-02 00:00:00	1922-06-02	5001	0	\N	0	0	\N	\N	0	57808	0	8331-1	3006322		
12438	1176	46235214	2011-10-02	2011-10-02 00:00:00	2011-10-02	5001	0	\N	0	0	\N	\N	0	77680	0	76690-7	46235214		
39200	3622	3006322	2002-01-05	2002-01-05 00:00:00	2002-01-05	5001	0	\N	0	0	\N	\N	0	240779	0	8331-1	3006322		
50351	4587	3006322	1953-08-07	1953-08-07 00:00:00	1953-08-07	5001	0	\N	0	0	\N	\N	0	305597	0	8331-1	3006322		
36003	1115	4024958	2013-11-07	2013-11-07 00:00:00	2013-11-07	5001	0	\N	0	0	\N	\N	0	73374	0	117015009	4024958		
48638	4446	3006322	1972-02-23	1972-02-23 00:00:00	1972-02-23	5001	0	\N	0	0	\N	\N	0	295668	0	8331-1	3006322		
7275	703	3006322	1984-08-07	1984-08-07 00:00:00	1984-08-07	5001	0	\N	0	0	\N	\N	0	46457	0	8331-1	3006322		
18659	1716	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	114761	0	7258-7	3001488		
18765	1727	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	115467	0	6206-7	3012494		
39744	3695	3027231	1981-06-13	1981-06-13 00:00:00	1981-06-13	5001	0	\N	0	0	\N	\N	0	245609	0	6276-0	3027231		
10316	994	3006322	2008-10-11	2008-10-11 00:00:00	2008-10-11	5001	0	\N	0	0	\N	\N	0	65913	0	8331-1	3006322		
21671	1999	3023430	2015-04-08	2015-04-08 00:00:00	2015-04-08	5001	0	\N	0	0	\N	\N	0	133128	0	6833-8	3023430		
41613	3874	3014599	1984-01-20	1984-01-20 00:00:00	1984-01-20	5001	0	\N	0	0	\N	\N	0	257211	0	6106-9	3014599		
31521	967	4052083	2014-06-01	2014-06-01 00:00:00	2014-06-01	5001	0	\N	0	0	\N	\N	0	64279	0	23426006	4052083		
18907	1739	3000963	1986-04-07	1986-04-07 00:00:00	1986-04-07	5001	0	\N	0	0	\N	\N	0	116216	0	718-7	3000963		
54686	5001	3006322	2007-10-02	2007-10-02 00:00:00	2007-10-02	5001	0	\N	0	0	\N	\N	0	332619	0	8331-1	3006322		
21120	1954	3006322	1944-09-28	1944-09-28 00:00:00	1944-09-28	5001	0	\N	0	0	\N	\N	0	129954	0	8331-1	3006322		
1167	96	3011505	1969-06-21	1969-06-21 00:00:00	1969-06-21	5001	0	\N	0	0	\N	\N	0	6523	0	19926-5	3011505		
23206	2135	3019406	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	142128	0	6158-0	3019406		
12552	1194	3006322	1963-11-15	1963-11-15 00:00:00	1963-11-15	5001	0	\N	0	0	\N	\N	0	78725	0	8331-1	3006322		
18422	1686	3006322	1991-10-23	1991-10-23 00:00:00	1991-10-23	5001	0	\N	0	0	\N	\N	0	112933	0	8331-1	3006322		
34713	3176	3001488	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	211108	0	7258-7	3001488		
55481	5094	40769189	1999-05-04	1999-05-04 00:00:00	1999-05-04	5001	0	\N	0	0	\N	\N	0	338446	0	66529-9	40769189		
21158	665	4024958	1964-07-26	1964-07-26 00:00:00	1964-07-26	5001	0	\N	0	0	\N	\N	0	43952	0	117015009	4024958		
51950	4763	3051031	2009-12-05	2009-12-05 00:00:00	2009-12-05	5001	0	\N	0	0	\N	\N	0	317420	0	46240-8	3051031		
26714	2462	3015076	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	163274	0	6248-9	3015076		
52416	1588	4024958	2016-02-05	2016-02-05 00:00:00	2016-02-05	5001	0	\N	0	0	\N	\N	0	106579	0	117015009	4024958		
56592	5194	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	345320	0	6248-9	3015076		
161998	4971	4052083	2000-05-27	2000-05-27 00:00:00	2000-05-27	5001	0	\N	0	0	\N	\N	0	330552	0	23426006	4052083		
56693	5200	3015076	1982-09-04	1982-09-04 00:00:00	1982-09-04	5001	0	\N	0	0	\N	\N	0	345935	0	6248-9	3015076		
30940	2832	3006451	1994-03-05	1994-03-05 00:00:00	1994-03-05	5001	0	\N	0	0	\N	\N	0	187897	0	6273-7	3006451		
38105	1180	4024958	1994-09-23	1994-09-23 00:00:00	1994-09-23	5001	0	\N	0	0	\N	\N	0	77896	0	117015009	4024958		
26919	842	4133840	1947-04-12	1947-04-12 00:00:00	1947-04-12	5001	0	\N	0	0	\N	\N	0	55726	0	127783003	4133840		
22936	2100	3006322	1961-01-08	1961-01-08 00:00:00	1961-01-08	5001	0	\N	0	0	\N	\N	0	140034	0	8331-1	3006322		
23038	2119	3019406	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	140966	0	6158-0	3019406		
18006	1640	3049273	1996-05-08	1996-05-08 00:00:00	1996-05-08	5001	0	\N	0	0	\N	\N	0	110023	0	38265-5	3049273		
6973	220	4052083	1993-07-20	1993-07-20 00:00:00	1993-07-20	5001	0	\N	0	0	\N	\N	0	14853	0	23426006	4052083		
2600	260	3020655	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	17262	0	6844-5	3020655		
52884	1604	4133840	2013-08-22	2013-08-22 00:00:00	2013-08-22	5001	0	\N	0	0	\N	\N	0	107646	0	127783003	4133840		
1333	115	3006322	2004-10-27	2004-10-27 00:00:00	2004-10-27	5001	0	\N	0	0	\N	\N	0	7596	0	8331-1	3006322		
57385	5267	3027231	1999-06-26	1999-06-26 00:00:00	1999-06-26	5001	0	\N	0	0	\N	\N	0	350412	0	6276-0	3027231		
2879	273	3014599	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	18241	0	6106-9	3014599		
42051	3891	3015076	1995-11-29	1995-11-29 00:00:00	1995-11-29	5001	0	\N	0	0	\N	\N	0	258675	0	6248-9	3015076		
25579	2346	3006322	1959-10-17	1959-10-17 00:00:00	1959-10-17	5001	0	\N	0	0	\N	\N	0	156168	0	8331-1	3006322		
18092	1649	3006322	1976-06-03	1976-06-03 00:00:00	1976-06-03	5001	0	\N	0	0	\N	\N	0	110648	0	8331-1	3006322		
18187	1656	3006322	1992-07-14	1992-07-14 00:00:00	1992-07-14	5001	0	\N	0	0	\N	\N	0	111067	0	8331-1	3006322		
26810	842	4133840	1956-12-29	1956-12-29 00:00:00	1956-12-29	5001	0	\N	0	0	\N	\N	0	55621	0	127783003	4133840		
79008	2427	4024958	1948-06-21	1948-06-21 00:00:00	1948-06-21	5001	0	\N	0	0	\N	\N	0	160979	0	117015009	4024958		
11408	1091	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	71682	0	6189-5	3006734		
147434	4520	4133840	1988-12-24	1988-12-24 00:00:00	1988-12-24	5001	0	\N	0	0	\N	\N	0	300926	0	127783003	4133840		
10045	320	4133840	2016-03-13	2016-03-13 00:00:00	2016-03-13	5001	0	\N	0	0	\N	\N	0	21253	0	127783003	4133840		
30990	2833	3006322	1978-06-13	1978-06-13 00:00:00	1978-06-13	5001	0	\N	0	0	\N	\N	0	188022	0	8331-1	3006322		
31083	2836	3006322	2011-02-05	2011-02-05 00:00:00	2011-02-05	5001	0	\N	0	0	\N	\N	0	188406	0	8331-1	3006322		
15838	1447	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	96445	0	6082-2	3000876		
53209	1611	4024958	1952-08-09	1952-08-09 00:00:00	1952-08-09	5001	0	\N	0	0	\N	\N	0	108347	0	117015009	4024958		
164429	5049	4133840	2019-02-06	2019-02-06 00:00:00	2019-02-06	5001	0	\N	0	0	\N	\N	0	335639	0	127783003	4133840		
105070	3236	4052083	2003-06-28	2003-06-28 00:00:00	2003-06-28	5001	0	\N	0	0	\N	\N	0	215128	0	23426006	4052083		
9105	869	3006322	1971-12-11	1971-12-11 00:00:00	1971-12-11	5001	0	\N	0	0	\N	\N	0	57792	0	8331-1	3006322		
12439	1176	40758406	1964-03-17	1964-03-17 00:00:00	1964-03-17	5001	0	\N	0	0	\N	\N	0	77599	0	55277-8	40758406		
39201	3622	3006322	1939-12-24	1939-12-24 00:00:00	1939-12-24	5001	0	\N	0	0	\N	\N	0	240793	0	8331-1	3006322		
50352	4587	3006322	1978-07-20	1978-07-20 00:00:00	1978-07-20	5001	0	\N	0	0	\N	\N	0	305587	0	8331-1	3006322		
31302	2861	3006322	1980-10-17	1980-10-17 00:00:00	1980-10-17	5001	0	\N	0	0	\N	\N	0	190171	0	8331-1	3006322		
48639	4446	3006322	2003-10-21	2003-10-21 00:00:00	2003-10-21	5001	0	\N	0	0	\N	\N	0	295660	0	8331-1	3006322		
7276	703	3006322	1981-12-06	1981-12-06 00:00:00	1981-12-06	5001	0	\N	0	0	\N	\N	0	46436	0	8331-1	3006322		
18660	1716	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	114761	0	6844-5	3020655		
18766	1727	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	115467	0	6248-9	3015076		
39745	3695	3019406	1981-06-13	1981-06-13 00:00:00	1981-06-13	5001	0	\N	0	0	\N	\N	0	245609	0	6158-0	3019406		
10317	994	3006322	1961-07-12	1961-07-12 00:00:00	1961-07-12	5001	0	\N	0	0	\N	\N	0	65906	0	8331-1	3006322		
21672	1999	3001247	2015-04-08	2015-04-08 00:00:00	2015-04-08	5001	0	\N	0	0	\N	\N	0	133128	0	6085-5	3001247		
41614	3874	3006322	1986-06-14	1986-06-14 00:00:00	1986-06-14	5001	0	\N	0	0	\N	\N	0	257238	0	8331-1	3006322		
31528	967	4052083	1984-08-01	1984-08-01 00:00:00	1984-08-01	5001	0	\N	0	0	\N	\N	0	64303	0	23426006	4052083		
18908	1739	3009542	1986-04-07	1986-04-07 00:00:00	1986-04-07	5001	0	\N	0	0	\N	\N	0	116216	0	20570-8	3009542		
54687	5001	3006322	2001-02-25	2001-02-25 00:00:00	2001-02-25	5001	0	\N	0	0	\N	\N	0	332618	0	8331-1	3006322		
21121	1954	3006322	1995-10-08	1995-10-08 00:00:00	1995-10-08	5001	0	\N	0	0	\N	\N	0	129958	0	8331-1	3006322		
1168	96	3011505	1973-06-30	1973-06-30 00:00:00	1973-06-30	5001	0	\N	0	0	\N	\N	0	6512	0	19926-5	3011505		
23207	2135	3015076	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	142128	0	6248-9	3015076		
12553	1194	3006322	2011-01-13	2011-01-13 00:00:00	2011-01-13	5001	0	\N	0	0	\N	\N	0	78733	0	8331-1	3006322		
18426	1689	3006322	2000-11-28	2000-11-28 00:00:00	2000-11-28	5001	0	\N	0	0	\N	\N	0	113068	0	8331-1	3006322		
34714	3177	3006322	1968-02-06	1968-02-06 00:00:00	1968-02-06	5001	0	\N	0	0	\N	\N	0	211316	0	8331-1	3006322		
55482	5094	3006322	1989-10-04	1989-10-04 00:00:00	1989-10-04	5001	0	\N	0	0	\N	\N	0	338443	0	8331-1	3006322		
125931	3881	4024958	1994-01-15	1994-01-15 00:00:00	1994-01-15	5001	0	\N	0	0	\N	\N	0	257946	0	117015009	4024958		
51951	4763	3006322	2005-02-12	2005-02-12 00:00:00	2005-02-12	5001	0	\N	0	0	\N	\N	0	317431	0	8331-1	3006322		
26715	2462	3012494	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	163274	0	6206-7	3012494		
52417	1588	4052083	2010-09-03	2010-09-03 00:00:00	2010-09-03	5001	0	\N	0	0	\N	\N	0	106613	0	23426006	4052083		
162001	4971	4133840	2000-12-05	2000-12-05 00:00:00	2000-12-05	5001	0	\N	0	0	\N	\N	0	330636	0	127783003	4133840		
56694	5200	3001247	1982-09-04	1982-09-04 00:00:00	1982-09-04	5001	0	\N	0	0	\N	\N	0	345935	0	6085-5	3001247		
30941	2832	3027231	1994-03-05	1994-03-05 00:00:00	1994-03-05	5001	0	\N	0	0	\N	\N	0	187897	0	6276-0	3027231		
49406	1506	4024958	1950-09-26	1950-09-26 00:00:00	1950-09-26	5001	0	\N	0	0	\N	\N	0	100446	0	117015009	4024958		
26921	842	4133840	2004-08-21	2004-08-21 00:00:00	2004-08-21	5001	0	\N	0	0	\N	\N	0	55682	0	127783003	4133840		
22937	2100	3006322	1951-11-17	1951-11-17 00:00:00	1951-11-17	5001	0	\N	0	0	\N	\N	0	139937	0	8331-1	3006322		
23039	2119	3020655	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	140966	0	6844-5	3020655		
18007	1640	3006322	1996-01-24	1996-01-24 00:00:00	1996-01-24	5001	0	\N	0	0	\N	\N	0	110084	0	8331-1	3006322		
18261	573	4052083	1971-04-08	1971-04-08 00:00:00	1971-04-08	5001	0	\N	0	0	\N	\N	0	37954	0	23426006	4052083		
2601	260	3000876	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	17262	0	6082-2	3000876		
52885	1604	4133840	2017-09-14	2017-09-14 00:00:00	2017-09-14	5001	0	\N	0	0	\N	\N	0	107601	0	127783003	4133840		
1334	115	3006322	1983-11-08	1983-11-08 00:00:00	1983-11-08	5001	0	\N	0	0	\N	\N	0	7615	0	8331-1	3006322		
57386	5267	3006322	1972-02-23	1972-02-23 00:00:00	1972-02-23	5001	0	\N	0	0	\N	\N	0	350428	0	8331-1	3006322		
2880	273	3006451	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	18241	0	6273-7	3006451		
42052	3891	3001247	1995-11-29	1995-11-29 00:00:00	1995-11-29	5001	0	\N	0	0	\N	\N	0	258675	0	6085-5	3001247		
25580	2346	3006322	1953-07-12	1953-07-12 00:00:00	1953-07-12	5001	0	\N	0	0	\N	\N	0	156166	0	8331-1	3006322		
18093	1649	3006322	1963-08-29	1963-08-29 00:00:00	1963-08-29	5001	0	\N	0	0	\N	\N	0	110657	0	8331-1	3006322		
18188	1657	3006322	2004-11-07	2004-11-07 00:00:00	2004-11-07	5001	0	\N	0	0	\N	\N	0	111231	0	8331-1	3006322		
26812	842	4133840	1963-01-26	1963-01-26 00:00:00	1963-01-26	5001	0	\N	0	0	\N	\N	0	55744	0	127783003	4133840		
79012	2427	4024958	1974-07-29	1974-07-29 00:00:00	1974-07-29	5001	0	\N	0	0	\N	\N	0	161029	0	117015009	4024958		
11409	1091	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	71682	0	6085-5	3001247		
147437	4520	4052083	1981-02-24	1981-02-24 00:00:00	1981-02-24	5001	0	\N	0	0	\N	\N	0	300874	0	23426006	4052083		
10047	320	4024958	2008-10-09	2008-10-09 00:00:00	2008-10-09	5001	0	\N	0	0	\N	\N	0	21239	0	117015009	4024958		
30991	2833	3006322	2001-09-22	2001-09-22 00:00:00	2001-09-22	5001	0	\N	0	0	\N	\N	0	188024	0	8331-1	3006322		
31084	2837	3006322	1974-05-09	1974-05-09 00:00:00	1974-05-09	5001	0	\N	0	0	\N	\N	0	188435	0	8331-1	3006322		
15839	1447	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	96445	0	6276-0	3027231		
53215	1611	4024958	1981-04-10	1981-04-10 00:00:00	1981-04-10	5001	0	\N	0	0	\N	\N	0	108276	0	117015009	4024958		
27390	2540	40766240	1958-10-13	1958-10-13 00:00:00	1958-10-13	5001	0	\N	0	0	\N	\N	0	167991	0	63513-6	40766240		
507	23	3006322	2013-12-06	2013-12-06 00:00:00	2013-12-06	5001	0	\N	0	0	\N	\N	0	1786	0	8331-1	3006322		
9106	869	3006322	2007-06-18	2007-06-18 00:00:00	2007-06-18	5001	0	\N	0	0	\N	\N	0	57755	0	8331-1	3006322		
12440	1176	3051031	1964-03-17	1964-03-17 00:00:00	1964-03-17	5001	0	\N	0	0	\N	\N	0	77599	0	46240-8	3051031		
50484	4606	3006322	1996-08-22	1996-08-22 00:00:00	1996-08-22	5001	0	\N	0	0	\N	\N	0	306840	0	8331-1	3006322		
50353	4587	3006322	1976-11-17	1976-11-17 00:00:00	1976-11-17	5001	0	\N	0	0	\N	\N	0	305586	0	8331-1	3006322		
31303	2861	3006322	1964-07-05	1964-07-05 00:00:00	1964-07-05	5001	0	\N	0	0	\N	\N	0	190204	0	8331-1	3006322		
48640	4446	3006322	1975-05-25	1975-05-25 00:00:00	1975-05-25	5001	0	\N	0	0	\N	\N	0	295641	0	8331-1	3006322		
7277	704	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	46596	0	6189-5	3006734		
18661	1716	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	114761	0	6833-8	3023430		
18767	1727	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	115467	0	6075-6	3005136		
39746	3695	3036780	1981-06-13	1981-06-13 00:00:00	1981-06-13	5001	0	\N	0	0	\N	\N	0	245609	0	6095-4	3036780		
10318	994	3006322	2007-02-06	2007-02-06 00:00:00	2007-02-06	5001	0	\N	0	0	\N	\N	0	65892	0	8331-1	3006322		
21673	1999	3005136	2015-04-08	2015-04-08 00:00:00	2015-04-08	5001	0	\N	0	0	\N	\N	0	133128	0	6075-6	3005136		
41615	3874	3005136	1998-07-01	1998-07-01 00:00:00	1998-07-01	5001	0	\N	0	0	\N	\N	0	257227	0	6075-6	3005136		
31530	967	4052083	1939-01-14	1939-01-14 00:00:00	1939-01-14	5001	0	\N	0	0	\N	\N	0	64349	0	23426006	4052083		
18909	1740	46235214	1953-11-05	1953-11-05 00:00:00	1953-11-05	5001	0	\N	0	0	\N	\N	0	116293	0	76690-7	46235214		
54688	5001	3006322	1963-04-10	1963-04-10 00:00:00	1963-04-10	5001	0	\N	0	0	\N	\N	0	332644	0	8331-1	3006322		
21122	1954	3006322	1976-08-16	1976-08-16 00:00:00	1976-08-16	5001	0	\N	0	0	\N	\N	0	129950	0	8331-1	3006322		
1169	96	3011505	1981-01-31	1981-01-31 00:00:00	1981-01-31	5001	0	\N	0	0	\N	\N	0	6524	0	19926-5	3011505		
23208	2135	3001488	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	142128	0	7258-7	3001488		
12554	1194	3006322	1972-05-25	1972-05-25 00:00:00	1972-05-25	5001	0	\N	0	0	\N	\N	0	78727	0	8331-1	3006322		
18427	1689	3006322	2007-02-06	2007-02-06 00:00:00	2007-02-06	5001	0	\N	0	0	\N	\N	0	113124	0	8331-1	3006322		
34716	3177	3049273	1976-10-20	1976-10-20 00:00:00	1976-10-20	5001	0	\N	0	0	\N	\N	0	211302	0	38265-5	3049273		
55483	5094	3006322	1990-04-15	1990-04-15 00:00:00	1990-04-15	5001	0	\N	0	0	\N	\N	0	338444	0	8331-1	3006322		
11531	364	4052083	2016-09-10	2016-09-10 00:00:00	2016-09-10	5001	0	\N	0	0	\N	\N	0	24135	0	23426006	4052083		
51953	4763	46235214	2009-09-06	2009-09-06 00:00:00	2009-09-06	5001	0	\N	0	0	\N	\N	0	317419	0	76690-7	46235214		
26716	2462	3006734	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	163274	0	6189-5	3006734		
52420	1588	4052083	2004-01-17	2004-01-17 00:00:00	2004-01-17	5001	0	\N	0	0	\N	\N	0	106577	0	23426006	4052083		
162004	4971	4133840	2010-01-26	2010-01-26 00:00:00	2010-01-26	5001	0	\N	0	0	\N	\N	0	330637	0	127783003	4133840		
56695	5200	3006734	1982-09-04	1982-09-04 00:00:00	1982-09-04	5001	0	\N	0	0	\N	\N	0	345935	0	6189-5	3006734		
30942	2832	3015076	1994-03-05	1994-03-05 00:00:00	1994-03-05	5001	0	\N	0	0	\N	\N	0	187897	0	6248-9	3015076		
49411	1506	4024958	1972-09-05	1972-09-05 00:00:00	1972-09-05	5001	0	\N	0	0	\N	\N	0	100398	0	117015009	4024958		
26923	842	4133840	2017-11-04	2017-11-04 00:00:00	2017-11-04	5001	0	\N	0	0	\N	\N	0	55686	0	127783003	4133840		
22944	2103	3006322	2015-09-07	2015-09-07 00:00:00	2015-09-07	5001	0	\N	0	0	\N	\N	0	140164	0	8331-1	3006322		
23040	2119	3023430	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	140966	0	6833-8	3023430		
18008	1640	3006322	1959-02-09	1959-02-09 00:00:00	1959-02-09	5001	0	\N	0	0	\N	\N	0	110102	0	8331-1	3006322		
18262	573	4052083	1992-07-07	1992-07-07 00:00:00	1992-07-07	5001	0	\N	0	0	\N	\N	0	37999	0	23426006	4052083		
2602	260	3006451	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	17262	0	6273-7	3006451		
52887	1604	4133840	2007-07-19	2007-07-19 00:00:00	2007-07-19	5001	0	\N	0	0	\N	\N	0	107637	0	127783003	4133840		
1335	115	3011505	2019-03-03	2019-03-03 00:00:00	2019-03-03	5001	0	\N	0	0	\N	\N	0	7602	0	19926-5	3011505		
57387	5267	3006734	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	350431	0	6189-5	3006734		
2881	273	3027231	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	18241	0	6276-0	3027231		
42053	3891	3020655	1995-11-29	1995-11-29 00:00:00	1995-11-29	5001	0	\N	0	0	\N	\N	0	258675	0	6844-5	3020655		
25581	2346	3006322	2019-02-13	2019-02-13 00:00:00	2019-02-13	5001	0	\N	0	0	\N	\N	0	156172	0	8331-1	3006322		
150500	4615	4024958	1994-03-01	1994-03-01 00:00:00	1994-03-01	5001	0	\N	0	0	\N	\N	0	307423	0	117015009	4024958		
18189	1657	3006322	1977-10-12	1977-10-12 00:00:00	1977-10-12	5001	0	\N	0	0	\N	\N	0	111229	0	8331-1	3006322		
26813	842	4133840	1972-11-25	1972-11-25 00:00:00	1972-11-25	5001	0	\N	0	0	\N	\N	0	55693	0	127783003	4133840		
11410	1091	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	71682	0	6082-2	3000876		
147442	4520	4133840	1972-10-07	1972-10-07 00:00:00	1972-10-07	5001	0	\N	0	0	\N	\N	0	300912	0	127783003	4133840		
10048	320	4133840	1990-06-17	1990-06-17 00:00:00	1990-06-17	5001	0	\N	0	0	\N	\N	0	21203	0	127783003	4133840		
30992	2833	3006322	1940-04-03	1940-04-03 00:00:00	1940-04-03	5001	0	\N	0	0	\N	\N	0	188087	0	8331-1	3006322		
31085	2837	3006322	2018-10-18	2018-10-18 00:00:00	2018-10-18	5001	0	\N	0	0	\N	\N	0	188464	0	8331-1	3006322		
15840	1447	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	96445	0	6158-0	3019406		
53226	1611	4052083	1990-09-07	1990-09-07 00:00:00	1990-09-07	5001	0	\N	0	0	\N	\N	0	108337	0	23426006	4052083		
27392	2540	46235214	1958-10-13	1958-10-13 00:00:00	1958-10-13	5001	0	\N	0	0	\N	\N	0	167991	0	76690-7	46235214		
70960	2173	4024958	1972-10-02	1972-10-02 00:00:00	1972-10-02	5001	0	\N	0	0	\N	\N	0	144866	0	117015009	4024958		
9107	869	3006322	1993-01-23	1993-01-23 00:00:00	1993-01-23	5001	0	\N	0	0	\N	\N	0	57753	0	8331-1	3006322		
12442	1176	46235214	1964-03-17	1964-03-17 00:00:00	1964-03-17	5001	0	\N	0	0	\N	\N	0	77599	0	76690-7	46235214		
50485	4606	3006322	2003-09-01	2003-09-01 00:00:00	2003-09-01	5001	0	\N	0	0	\N	\N	0	306859	0	8331-1	3006322		
50354	4587	3049273	2018-04-25	2018-04-25 00:00:00	2018-04-25	5001	0	\N	0	0	\N	\N	0	305571	0	38265-5	3049273		
31304	2861	3006322	1999-01-16	1999-01-16 00:00:00	1999-01-16	5001	0	\N	0	0	\N	\N	0	190186	0	8331-1	3006322		
48641	4446	3006322	1993-08-28	1993-08-28 00:00:00	1993-08-28	5001	0	\N	0	0	\N	\N	0	295636	0	8331-1	3006322		
7278	704	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	46596	0	6844-5	3020655		
18662	1716	3006322	1977-05-28	1977-05-28 00:00:00	1977-05-28	5001	0	\N	0	0	\N	\N	0	114619	0	8331-1	3006322		
18768	1727	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	115467	0	6273-7	3006451		
39747	3695	3001247	1996-08-12	1996-08-12 00:00:00	1996-08-12	5001	0	\N	0	0	\N	\N	0	245675	0	6085-5	3001247		
10331	1000	3006322	1989-08-10	1989-08-10 00:00:00	1989-08-10	5001	0	\N	0	0	\N	\N	0	66200	0	8331-1	3006322		
21674	1999	3015076	2015-04-08	2015-04-08 00:00:00	2015-04-08	5001	0	\N	0	0	\N	\N	0	133128	0	6248-9	3015076		
41616	3874	3021226	1998-07-01	1998-07-01 00:00:00	1998-07-01	5001	0	\N	0	0	\N	\N	0	257227	0	6246-3	3021226		
31534	967	4052083	1987-06-16	1987-06-16 00:00:00	1987-06-16	5001	0	\N	0	0	\N	\N	0	64353	0	23426006	4052083		
18910	1740	40758406	1953-11-05	1953-11-05 00:00:00	1953-11-05	5001	0	\N	0	0	\N	\N	0	116293	0	55277-8	40758406		
54689	5001	3006322	2013-09-10	2013-09-10 00:00:00	2013-09-10	5001	0	\N	0	0	\N	\N	0	332687	0	8331-1	3006322		
32400	2943	3006322	2005-03-26	2005-03-26 00:00:00	2005-03-26	5001	0	\N	0	0	\N	\N	0	196363	0	8331-1	3006322		
1170	96	3011505	1996-04-27	1996-04-27 00:00:00	1996-04-27	5001	0	\N	0	0	\N	\N	0	6496	0	19926-5	3011505		
23209	2135	3001247	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	142128	0	6085-5	3001247		
12565	1197	3006322	1982-12-25	1982-12-25 00:00:00	1982-12-25	5001	0	\N	0	0	\N	\N	0	78866	0	8331-1	3006322		
18428	1689	3006322	1953-01-07	1953-01-07 00:00:00	1953-01-07	5001	0	\N	0	0	\N	\N	0	113066	0	8331-1	3006322		
34717	3177	3006322	1949-04-21	1949-04-21 00:00:00	1949-04-21	5001	0	\N	0	0	\N	\N	0	211354	0	8331-1	3006322		
55484	5094	3006322	1994-09-08	1994-09-08 00:00:00	1994-09-08	5001	0	\N	0	0	\N	\N	0	338471	0	8331-1	3006322		
11541	364	4052083	1948-01-20	1948-01-20 00:00:00	1948-01-20	5001	0	\N	0	0	\N	\N	0	24214	0	23426006	4052083		
76775	2352	4024958	2018-08-02	2018-08-02 00:00:00	2018-08-02	5001	0	\N	0	0	\N	\N	0	156742	0	117015009	4024958		
26717	2462	3023430	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	163274	0	6833-8	3023430		
52431	1588	4052083	1992-03-23	1992-03-23 00:00:00	1992-03-23	5001	0	\N	0	0	\N	\N	0	106634	0	23426006	4052083		
162006	4971	4133840	2018-04-03	2018-04-03 00:00:00	2018-04-03	5001	0	\N	0	0	\N	\N	0	330661	0	127783003	4133840		
56696	5200	3036780	1982-09-04	1982-09-04 00:00:00	1982-09-04	5001	0	\N	0	0	\N	\N	0	345935	0	6095-4	3036780		
30943	2832	3012494	1994-03-05	1994-03-05 00:00:00	1994-03-05	5001	0	\N	0	0	\N	\N	0	187897	0	6206-7	3012494		
49421	1506	4024958	1948-01-12	1948-01-12 00:00:00	1948-01-12	5001	0	\N	0	0	\N	\N	0	100399	0	117015009	4024958		
26926	842	4133840	2002-08-10	2002-08-10 00:00:00	2002-08-10	5001	0	\N	0	0	\N	\N	0	55681	0	127783003	4133840		
22945	2103	3006322	2017-03-10	2017-03-10 00:00:00	2017-03-10	5001	0	\N	0	0	\N	\N	0	140153	0	8331-1	3006322		
23041	2119	3012494	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	140966	0	6206-7	3012494		
18009	1640	3006322	1987-09-09	1987-09-09 00:00:00	1987-09-09	5001	0	\N	0	0	\N	\N	0	110082	0	8331-1	3006322		
18265	573	4052083	2014-08-08	2014-08-08 00:00:00	2014-08-08	5001	0	\N	0	0	\N	\N	0	37974	0	23426006	4052083		
2603	260	3015076	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	17262	0	6248-9	3015076		
52889	1604	4133840	2005-07-07	2005-07-07 00:00:00	2005-07-07	5001	0	\N	0	0	\N	\N	0	107636	0	127783003	4133840		
1336	115	3006322	2019-04-20	2019-04-20 00:00:00	2019-04-20	5001	0	\N	0	0	\N	\N	0	7622	0	8331-1	3006322		
57388	5267	3015076	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	350431	0	6248-9	3015076		
2882	273	3036780	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	18241	0	6095-4	3036780		
42054	3891	3000876	1995-11-29	1995-11-29 00:00:00	1995-11-29	5001	0	\N	0	0	\N	\N	0	258675	0	6082-2	3000876		
25582	2346	3049273	2016-09-10	2016-09-10 00:00:00	2016-09-10	5001	0	\N	0	0	\N	\N	0	156220	0	38265-5	3049273		
150503	4615	4052083	1963-08-08	1963-08-08 00:00:00	1963-08-08	5001	0	\N	0	0	\N	\N	0	307421	0	23426006	4052083		
18190	1657	3006322	2010-08-20	2010-08-20 00:00:00	2010-08-20	5001	0	\N	0	0	\N	\N	0	111246	0	8331-1	3006322		
26815	842	4133840	1996-07-06	1996-07-06 00:00:00	1996-07-06	5001	0	\N	0	0	\N	\N	0	55687	0	127783003	4133840		
11411	1091	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	71682	0	6095-4	3036780		
147445	4520	4133840	1957-04-20	1957-04-20 00:00:00	1957-04-20	5001	0	\N	0	0	\N	\N	0	300885	0	127783003	4133840		
10053	320	4133840	1996-02-25	1996-02-25 00:00:00	1996-02-25	5001	0	\N	0	0	\N	\N	0	21181	0	127783003	4133840		
30994	2833	3006322	1972-05-05	1972-05-05 00:00:00	1972-05-05	5001	0	\N	0	0	\N	\N	0	188021	0	8331-1	3006322		
31086	2837	3006322	1978-09-01	1978-09-01 00:00:00	1978-09-01	5001	0	\N	0	0	\N	\N	0	188415	0	8331-1	3006322		
39870	1238	4024958	1976-06-06	1976-06-06 00:00:00	1976-06-06	5001	0	\N	0	0	\N	\N	0	81596	0	117015009	4024958		
53267	1613	4024958	1981-07-31	1981-07-31 00:00:00	1981-07-31	5001	0	\N	0	0	\N	\N	0	108457	0	117015009	4024958		
27394	2540	40758406	1958-10-13	1958-10-13 00:00:00	1958-10-13	5001	0	\N	0	0	\N	\N	0	167991	0	55277-8	40758406		
70980	2174	4052083	2000-08-02	2000-08-02 00:00:00	2000-08-02	5001	0	\N	0	0	\N	\N	0	144937	0	23426006	4052083		
9108	869	3006322	1984-09-24	1984-09-24 00:00:00	1984-09-24	5001	0	\N	0	0	\N	\N	0	57752	0	8331-1	3006322		
12443	1176	40766240	1964-03-17	1964-03-17 00:00:00	1964-03-17	5001	0	\N	0	0	\N	\N	0	77599	0	63513-6	40766240		
50486	4606	3006322	2017-11-07	2017-11-07 00:00:00	2017-11-07	5001	0	\N	0	0	\N	\N	0	306841	0	8331-1	3006322		
50405	4590	3006322	1988-06-27	1988-06-27 00:00:00	1988-06-27	5001	0	\N	0	0	\N	\N	0	305886	0	8331-1	3006322		
31305	2861	3006322	1970-04-28	1970-04-28 00:00:00	1970-04-28	5001	0	\N	0	0	\N	\N	0	190227	0	8331-1	3006322		
48642	4446	3006322	1970-11-17	1970-11-17 00:00:00	1970-11-17	5001	0	\N	0	0	\N	\N	0	295649	0	8331-1	3006322		
7279	704	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	46596	0	6075-6	3005136		
18663	1716	3006322	1963-02-17	1963-02-17 00:00:00	1963-02-17	5001	0	\N	0	0	\N	\N	0	114603	0	8331-1	3006322		
18769	1727	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	115467	0	6158-0	3019406		
39748	3695	3001488	1996-08-12	1996-08-12 00:00:00	1996-08-12	5001	0	\N	0	0	\N	\N	0	245675	0	7258-7	3001488		
10332	1000	3006322	1995-12-16	1995-12-16 00:00:00	1995-12-16	5001	0	\N	0	0	\N	\N	0	66158	0	8331-1	3006322		
21675	1999	3027231	2015-04-08	2015-04-08 00:00:00	2015-04-08	5001	0	\N	0	0	\N	\N	0	133128	0	6276-0	3027231		
41617	3874	3027231	1998-07-01	1998-07-01 00:00:00	1998-07-01	5001	0	\N	0	0	\N	\N	0	257227	0	6276-0	3027231		
31537	967	4024958	1936-05-28	1936-05-28 00:00:00	1936-05-28	5001	0	\N	0	0	\N	\N	0	64332	0	117015009	4024958		
18911	1740	3051031	1953-11-05	1953-11-05 00:00:00	1953-11-05	5001	0	\N	0	0	\N	\N	0	116293	0	46240-8	3051031		
54690	5001	3006322	2010-01-31	2010-01-31 00:00:00	2010-01-31	5001	0	\N	0	0	\N	\N	0	332657	0	8331-1	3006322		
32401	2943	3006322	1972-09-21	1972-09-21 00:00:00	1972-09-21	5001	0	\N	0	0	\N	\N	0	196293	0	8331-1	3006322		
1171	96	3011505	1990-03-24	1990-03-24 00:00:00	1990-03-24	5001	0	\N	0	0	\N	\N	0	6494	0	19926-5	3011505		
23210	2135	3006734	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	142128	0	6189-5	3006734		
12566	1197	3006322	2016-04-26	2016-04-26 00:00:00	2016-04-26	5001	0	\N	0	0	\N	\N	0	78846	0	8331-1	3006322		
105550	3249	4052083	2001-08-10	2001-08-10 00:00:00	2001-08-10	5001	0	\N	0	0	\N	\N	0	215966	0	23426006	4052083		
34718	3177	3006322	1928-01-21	1928-01-21 00:00:00	1928-01-21	5001	0	\N	0	0	\N	\N	0	211248	0	8331-1	3006322		
55485	5095	3006322	2003-02-15	2003-02-15 00:00:00	2003-02-15	5001	0	\N	0	0	\N	\N	0	338517	0	8331-1	3006322		
11581	366	4052083	1949-05-31	1949-05-31 00:00:00	1949-05-31	5001	0	\N	0	0	\N	\N	0	24383	0	23426006	4052083		
88071	2721	4052083	2013-04-07	2013-04-07 00:00:00	2013-04-07	5001	0	\N	0	0	\N	\N	0	180310	0	23426006	4052083		
26718	2462	3036780	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	163274	0	6095-4	3036780		
137436	4235	4024958	1979-11-30	1979-11-30 00:00:00	1979-11-30	5001	0	\N	0	0	\N	\N	0	281187	0	117015009	4024958		
162008	4971	4052083	1964-08-29	1964-08-29 00:00:00	1964-08-29	5001	0	\N	0	0	\N	\N	0	330547	0	23426006	4052083		
56697	5200	3006322	1982-06-25	1982-06-25 00:00:00	1982-06-25	5001	0	\N	0	0	\N	\N	0	345934	0	8331-1	3006322		
55514	1686	4024958	2002-04-09	2002-04-09 00:00:00	2002-04-09	5001	0	\N	0	0	\N	\N	0	112936	0	117015009	4024958		
49424	1506	4024958	1975-12-30	1975-12-30 00:00:00	1975-12-30	5001	0	\N	0	0	\N	\N	0	100402	0	117015009	4024958		
26929	842	4133840	1985-04-06	1985-04-06 00:00:00	1985-04-06	5001	0	\N	0	0	\N	\N	0	55667	0	127783003	4133840		
22946	2103	3006322	1994-08-04	1994-08-04 00:00:00	1994-08-04	5001	0	\N	0	0	\N	\N	0	140125	0	8331-1	3006322		
23042	2119	3036780	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	140966	0	6095-4	3036780		
18010	1640	3006322	1968-03-08	1968-03-08 00:00:00	1968-03-08	5001	0	\N	0	0	\N	\N	0	110012	0	8331-1	3006322		
18273	573	4052083	1964-03-10	1964-03-10 00:00:00	1964-03-10	5001	0	\N	0	0	\N	\N	0	37969	0	23426006	4052083		
2604	260	3012494	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	17262	0	6206-7	3012494		
52891	1604	4024958	1957-02-24	1957-02-24 00:00:00	1957-02-24	5001	0	\N	0	0	\N	\N	0	107624	0	117015009	4024958		
1337	115	3006322	2011-04-10	2011-04-10 00:00:00	2011-04-10	5001	0	\N	0	0	\N	\N	0	7578	0	8331-1	3006322		
57389	5267	3012494	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	350431	0	6206-7	3012494		
2883	273	3019406	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	18241	0	6158-0	3019406		
42055	3891	3027231	1995-11-29	1995-11-29 00:00:00	1995-11-29	5001	0	\N	0	0	\N	\N	0	258675	0	6276-0	3027231		
25583	2346	3006322	1950-01-19	1950-01-19 00:00:00	1950-01-19	5001	0	\N	0	0	\N	\N	0	156124	0	8331-1	3006322		
150510	4615	4024958	1977-03-07	1977-03-07 00:00:00	1977-03-07	5001	0	\N	0	0	\N	\N	0	307405	0	117015009	4024958		
18191	1657	3006322	1990-07-29	1990-07-29 00:00:00	1990-07-29	5001	0	\N	0	0	\N	\N	0	111230	0	8331-1	3006322		
26818	842	4133840	1987-04-18	1987-04-18 00:00:00	1987-04-18	5001	0	\N	0	0	\N	\N	0	55695	0	127783003	4133840		
11412	1091	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	71682	0	6833-8	3023430		
147446	4520	4133840	1970-10-03	1970-10-03 00:00:00	1970-10-03	5001	0	\N	0	0	\N	\N	0	300957	0	127783003	4133840		
10055	320	4133840	2013-02-24	2013-02-24 00:00:00	2013-02-24	5001	0	\N	0	0	\N	\N	0	21194	0	127783003	4133840		
30995	2833	3006322	1947-12-09	1947-12-09 00:00:00	1947-12-09	5001	0	\N	0	0	\N	\N	0	188035	0	8331-1	3006322		
31087	2837	3006322	2001-04-08	2001-04-08 00:00:00	2001-04-08	5001	0	\N	0	0	\N	\N	0	188419	0	8331-1	3006322		
39871	1238	4024958	2002-05-05	2002-05-05 00:00:00	2002-05-05	5001	0	\N	0	0	\N	\N	0	81612	0	117015009	4024958		
99225	3044	4024958	1972-12-04	1972-12-04 00:00:00	1972-12-04	5001	0	\N	0	0	\N	\N	0	202625	0	117015009	4024958		
27395	2540	3051031	1958-10-13	1958-10-13 00:00:00	1958-10-13	5001	0	\N	0	0	\N	\N	0	167991	0	46240-8	3051031		
71017	2175	4024958	2000-11-02	2000-11-02 00:00:00	2000-11-02	5001	0	\N	0	0	\N	\N	0	145005	0	117015009	4024958		
9109	869	3006322	1970-06-25	1970-06-25 00:00:00	1970-06-25	5001	0	\N	0	0	\N	\N	0	57791	0	8331-1	3006322		
12445	1177	3006322	1980-07-22	1980-07-22 00:00:00	1980-07-22	5001	0	\N	0	0	\N	\N	0	77731	0	8331-1	3006322		
50487	4606	3006322	2010-06-07	2010-06-07 00:00:00	2010-06-07	5001	0	\N	0	0	\N	\N	0	306849	0	8331-1	3006322		
50406	4590	3006322	1990-05-02	1990-05-02 00:00:00	1990-05-02	5001	0	\N	0	0	\N	\N	0	305849	0	8331-1	3006322		
31306	2861	3006322	1981-11-27	1981-11-27 00:00:00	1981-11-27	5001	0	\N	0	0	\N	\N	0	190195	0	8331-1	3006322		
48643	4447	3006322	1959-02-24	1959-02-24 00:00:00	1959-02-24	5001	0	\N	0	0	\N	\N	0	295705	0	8331-1	3006322		
7280	704	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	46596	0	7258-7	3001488		
18666	1718	3006322	2010-09-10	2010-09-10 00:00:00	2010-09-10	5001	0	\N	0	0	\N	\N	0	114858	0	8331-1	3006322		
18770	1727	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	115467	0	6276-0	3027231		
39749	3695	3006734	1996-08-12	1996-08-12 00:00:00	1996-08-12	5001	0	\N	0	0	\N	\N	0	245675	0	6189-5	3006734		
10333	1000	3006322	1967-12-22	1967-12-22 00:00:00	1967-12-22	5001	0	\N	0	0	\N	\N	0	66132	0	8331-1	3006322		
21676	1999	3014599	2015-04-08	2015-04-08 00:00:00	2015-04-08	5001	0	\N	0	0	\N	\N	0	133128	0	6106-9	3014599		
41618	3874	3014599	1998-07-01	1998-07-01 00:00:00	1998-07-01	5001	0	\N	0	0	\N	\N	0	257227	0	6106-9	3014599		
187	3	40758406	1994-03-04	1994-03-04 00:00:00	1994-03-04	5001	0	\N	0	0	\N	\N	0	225	0	55277-8	40758406		
18912	1740	40766240	1953-11-05	1953-11-05 00:00:00	1953-11-05	5001	0	\N	0	0	\N	\N	0	116293	0	63513-6	40766240		
54691	5001	3006322	1969-12-19	1969-12-19 00:00:00	1969-12-19	5001	0	\N	0	0	\N	\N	0	332647	0	8331-1	3006322		
32402	2943	3049273	1997-02-05	1997-02-05 00:00:00	1997-02-05	5001	0	\N	0	0	\N	\N	0	196325	0	38265-5	3049273		
1172	96	3011505	1951-05-26	1951-05-26 00:00:00	1951-05-26	5001	0	\N	0	0	\N	\N	0	6487	0	19926-5	3011505		
23211	2135	3021226	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	142128	0	6246-3	3021226		
12567	1197	3006322	2012-06-04	2012-06-04 00:00:00	2012-06-04	5001	0	\N	0	0	\N	\N	0	78875	0	8331-1	3006322		
105553	3249	4024958	1966-04-02	1966-04-02 00:00:00	1966-04-02	5001	0	\N	0	0	\N	\N	0	216007	0	117015009	4024958		
34719	3177	3006322	1948-02-12	1948-02-12 00:00:00	1948-02-12	5001	0	\N	0	0	\N	\N	0	211353	0	8331-1	3006322		
55486	5095	3006322	2006-06-11	2006-06-11 00:00:00	2006-06-11	5001	0	\N	0	0	\N	\N	0	338519	0	8331-1	3006322		
11584	366	4052083	1987-01-14	1987-01-14 00:00:00	1987-01-14	5001	0	\N	0	0	\N	\N	0	24323	0	23426006	4052083		
88110	2724	4024958	1957-01-24	1957-01-24 00:00:00	1957-01-24	5001	0	\N	0	0	\N	\N	0	180491	0	117015009	4024958		
26719	2462	3020655	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	163274	0	6844-5	3020655		
137449	4235	4052083	2001-12-23	2001-12-23 00:00:00	2001-12-23	5001	0	\N	0	0	\N	\N	0	281205	0	23426006	4052083		
162009	4971	4024958	2001-08-01	2001-08-01 00:00:00	2001-08-01	5001	0	\N	0	0	\N	\N	0	330655	0	117015009	4024958		
56698	5200	3006322	2010-06-09	2010-06-09 00:00:00	2010-06-09	5001	0	\N	0	0	\N	\N	0	345832	0	8331-1	3006322		
55544	1689	4052083	2000-09-20	2000-09-20 00:00:00	2000-09-20	5001	0	\N	0	0	\N	\N	0	113123	0	23426006	4052083		
15553	487	4024958	2013-10-06	2013-10-06 00:00:00	2013-10-06	5001	0	\N	0	0	\N	\N	0	32600	0	117015009	4024958		
26930	842	4133840	1962-01-20	1962-01-20 00:00:00	1962-01-20	5001	0	\N	0	0	\N	\N	0	55759	0	127783003	4133840		
22947	2103	3006322	2015-04-01	2015-04-01 00:00:00	2015-04-01	5001	0	\N	0	0	\N	\N	0	140138	0	8331-1	3006322		
23043	2119	3000876	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	140966	0	6082-2	3000876		
18011	1640	3006322	1994-12-16	1994-12-16 00:00:00	1994-12-16	5001	0	\N	0	0	\N	\N	0	110044	0	8331-1	3006322		
18275	573	4052083	1977-03-25	1977-03-25 00:00:00	1977-03-25	5001	0	\N	0	0	\N	\N	0	37930	0	23426006	4052083		
2605	260	3005136	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	17262	0	6075-6	3005136		
52895	1604	4133840	1999-03-11	1999-03-11 00:00:00	1999-03-11	5001	0	\N	0	0	\N	\N	0	107634	0	127783003	4133840		
1338	115	3006322	1980-11-08	1980-11-08 00:00:00	1980-11-08	5001	0	\N	0	0	\N	\N	0	7568	0	8331-1	3006322		
57390	5267	3020655	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	350431	0	6844-5	3020655		
2884	273	3000876	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	18241	0	6082-2	3000876		
42056	3891	3006322	2004-08-17	2004-08-17 00:00:00	2004-08-17	5001	0	\N	0	0	\N	\N	0	258642	0	8331-1	3006322		
25584	2346	3006322	1959-09-05	1959-09-05 00:00:00	1959-09-05	5001	0	\N	0	0	\N	\N	0	156167	0	8331-1	3006322		
150513	4615	4024958	1998-01-28	1998-01-28 00:00:00	1998-01-28	5001	0	\N	0	0	\N	\N	0	307395	0	117015009	4024958		
18192	1657	3006322	1949-04-02	1949-04-02 00:00:00	1949-04-02	5001	0	\N	0	0	\N	\N	0	111211	0	8331-1	3006322		
26820	842	4133840	1966-10-22	1966-10-22 00:00:00	1966-10-22	5001	0	\N	0	0	\N	\N	0	55729	0	127783003	4133840		
11413	1091	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	71682	0	6276-0	3027231		
147447	4520	4133840	1979-11-03	1979-11-03 00:00:00	1979-11-03	5001	0	\N	0	0	\N	\N	0	300888	0	127783003	4133840		
10057	320	4133840	2015-03-08	2015-03-08 00:00:00	2015-03-08	5001	0	\N	0	0	\N	\N	0	21218	0	127783003	4133840		
30997	2834	3006322	1965-03-17	1965-03-17 00:00:00	1965-03-17	5001	0	\N	0	0	\N	\N	0	188178	0	8331-1	3006322		
31088	2837	3006322	1969-08-18	1969-08-18 00:00:00	1969-08-18	5001	0	\N	0	0	\N	\N	0	188460	0	8331-1	3006322		
39872	1238	4024958	2007-07-20	2007-07-20 00:00:00	2007-07-20	5001	0	\N	0	0	\N	\N	0	81574	0	117015009	4024958		
99243	3044	4024958	2017-01-30	2017-01-30 00:00:00	2017-01-30	5001	0	\N	0	0	\N	\N	0	202643	0	117015009	4024958		
27396	2540	3006322	1994-05-22	1994-05-22 00:00:00	1994-05-22	5001	0	\N	0	0	\N	\N	0	167882	0	8331-1	3006322		
2330	70	4052083	1960-01-10	1960-01-10 00:00:00	1960-01-10	5001	0	\N	0	0	\N	\N	0	4715	0	23426006	4052083		
9110	869	3006322	1973-03-13	1973-03-13 00:00:00	1973-03-13	5001	0	\N	0	0	\N	\N	0	57811	0	8331-1	3006322		
12446	1177	3006322	1978-04-23	1978-04-23 00:00:00	1978-04-23	5001	0	\N	0	0	\N	\N	0	77737	0	8331-1	3006322		
50488	4607	3006322	2011-12-04	2011-12-04 00:00:00	2011-12-04	5001	0	\N	0	0	\N	\N	0	306922	0	8331-1	3006322		
50407	4590	3006322	2012-04-19	2012-04-19 00:00:00	2012-04-19	5001	0	\N	0	0	\N	\N	0	305888	0	8331-1	3006322		
31307	2862	3006322	1967-10-28	1967-10-28 00:00:00	1967-10-28	5001	0	\N	0	0	\N	\N	0	190267	0	8331-1	3006322		
48644	4447	3006322	1955-09-03	1955-09-03 00:00:00	1955-09-03	5001	0	\N	0	0	\N	\N	0	295773	0	8331-1	3006322		
7281	704	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	46596	0	6276-0	3027231		
18667	1718	3006322	1989-08-04	1989-08-04 00:00:00	1989-08-04	5001	0	\N	0	0	\N	\N	0	114845	0	8331-1	3006322		
18771	1727	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	115467	0	6246-3	3021226		
39750	3695	3020655	1996-08-12	1996-08-12 00:00:00	1996-08-12	5001	0	\N	0	0	\N	\N	0	245675	0	6844-5	3020655		
10341	1004	3006322	1964-07-06	1964-07-06 00:00:00	1964-07-06	5001	0	\N	0	0	\N	\N	0	66357	0	8331-1	3006322		
21677	1999	3036780	2015-04-08	2015-04-08 00:00:00	2015-04-08	5001	0	\N	0	0	\N	\N	0	133128	0	6095-4	3036780		
41619	3874	3020655	1998-07-01	1998-07-01 00:00:00	1998-07-01	5001	0	\N	0	0	\N	\N	0	257227	0	6844-5	3020655		
188	3	3051031	1994-03-04	1994-03-04 00:00:00	1994-03-04	5001	0	\N	0	0	\N	\N	0	225	0	46240-8	3051031		
18915	1740	3049273	2010-08-24	2010-08-24 00:00:00	2010-08-24	5001	0	\N	0	0	\N	\N	0	116292	0	38265-5	3049273		
54692	5001	3006322	1984-01-14	1984-01-14 00:00:00	1984-01-14	5001	0	\N	0	0	\N	\N	0	332653	0	8331-1	3006322		
32403	2943	3006322	1931-03-20	1931-03-20 00:00:00	1931-03-20	5001	0	\N	0	0	\N	\N	0	196334	0	8331-1	3006322		
1173	96	3011505	1985-02-23	1985-02-23 00:00:00	1985-02-23	5001	0	\N	0	0	\N	\N	0	6526	0	19926-5	3011505		
23212	2135	3006451	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	142128	0	6273-7	3006451		
12568	1197	3006322	1981-12-17	1981-12-17 00:00:00	1981-12-17	5001	0	\N	0	0	\N	\N	0	78842	0	8331-1	3006322		
105557	3249	4024958	2004-09-08	2004-09-08 00:00:00	2004-09-08	5001	0	\N	0	0	\N	\N	0	215967	0	117015009	4024958		
34720	3177	3006322	1955-02-04	1955-02-04 00:00:00	1955-02-04	5001	0	\N	0	0	\N	\N	0	211268	0	8331-1	3006322		
55487	5096	3006322	1980-08-17	1980-08-17 00:00:00	1980-08-17	5001	0	\N	0	0	\N	\N	0	338562	0	8331-1	3006322		
11588	366	4052083	1966-10-18	1966-10-18 00:00:00	1966-10-18	5001	0	\N	0	0	\N	\N	0	24321	0	23426006	4052083		
88119	2724	4024958	1994-12-30	1994-12-30 00:00:00	1994-12-30	5001	0	\N	0	0	\N	\N	0	180443	0	117015009	4024958		
26720	2462	3006322	1980-10-24	1980-10-24 00:00:00	1980-10-24	5001	0	\N	0	0	\N	\N	0	163220	0	8331-1	3006322		
137451	4235	4052083	2011-05-13	2011-05-13 00:00:00	2011-05-13	5001	0	\N	0	0	\N	\N	0	281216	0	23426006	4052083		
162011	4971	4133840	2014-02-18	2014-02-18 00:00:00	2014-02-18	5001	0	\N	0	0	\N	\N	0	330555	0	127783003	4133840		
56699	5200	40769184	1982-08-21	1982-08-21 00:00:00	1982-08-21	5001	0	\N	0	0	\N	\N	0	345867	0	66524-0	40769184		
55550	1689	4052083	1975-02-19	1975-02-19 00:00:00	1975-02-19	5001	0	\N	0	0	\N	\N	0	113067	0	23426006	4052083		
15554	487	4024958	1972-08-12	1972-08-12 00:00:00	1972-08-12	5001	0	\N	0	0	\N	\N	0	32603	0	117015009	4024958		
26932	842	4133840	1988-04-23	1988-04-23 00:00:00	1988-04-23	5001	0	\N	0	0	\N	\N	0	55749	0	127783003	4133840		
22948	2103	3049273	1975-02-27	1975-02-27 00:00:00	1975-02-27	5001	0	\N	0	0	\N	\N	0	140121	0	38265-5	3049273		
23044	2119	3006734	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	140966	0	6189-5	3006734		
18013	1640	3006322	1956-08-11	1956-08-11 00:00:00	1956-08-11	5001	0	\N	0	0	\N	\N	0	110029	0	8331-1	3006322		
18285	573	4024958	1963-08-24	1963-08-24 00:00:00	1963-08-24	5001	0	\N	0	0	\N	\N	0	37968	0	117015009	4024958		
2606	260	3014599	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	17262	0	6106-9	3014599		
52896	1604	4133840	2006-07-13	2006-07-13 00:00:00	2006-07-13	5001	0	\N	0	0	\N	\N	0	107599	0	127783003	4133840		
1339	116	3006322	1937-07-25	1937-07-25 00:00:00	1937-07-25	5001	0	\N	0	0	\N	\N	0	7702	0	8331-1	3006322		
57391	5267	3023430	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	350431	0	6833-8	3023430		
2885	273	3001247	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	18241	0	6085-5	3001247		
42057	3891	3015076	1999-06-02	1999-06-02 00:00:00	1999-06-02	5001	0	\N	0	0	\N	\N	0	258689	0	6248-9	3015076		
25585	2346	3006322	1958-10-28	1958-10-28 00:00:00	1958-10-28	5001	0	\N	0	0	\N	\N	0	156126	0	8331-1	3006322		
150519	4615	4024958	2009-05-16	2009-05-16 00:00:00	2009-05-16	5001	0	\N	0	0	\N	\N	0	307377	0	117015009	4024958		
18193	1657	3006322	1955-11-22	1955-11-22 00:00:00	1955-11-22	5001	0	\N	0	0	\N	\N	0	111175	0	8331-1	3006322		
26821	842	4133840	1969-11-08	1969-11-08 00:00:00	1969-11-08	5001	0	\N	0	0	\N	\N	0	55733	0	127783003	4133840		
11414	1091	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	71682	0	6246-3	3021226		
147449	4520	4133840	1957-09-14	1957-09-14 00:00:00	1957-09-14	5001	0	\N	0	0	\N	\N	0	300899	0	127783003	4133840		
10062	321	4024958	1965-12-07	1965-12-07 00:00:00	1965-12-07	5001	0	\N	0	0	\N	\N	0	21304	0	117015009	4024958		
30999	2834	40766240	1990-07-10	1990-07-10 00:00:00	1990-07-10	5001	0	\N	0	0	\N	\N	0	188192	0	63513-6	40766240		
31089	2837	3006322	1998-03-15	1998-03-15 00:00:00	1998-03-15	5001	0	\N	0	0	\N	\N	0	188439	0	8331-1	3006322		
39881	1239	4024958	1982-04-26	1982-04-26 00:00:00	1982-04-26	5001	0	\N	0	0	\N	\N	0	81645	0	117015009	4024958		
99285	3047	4052083	1990-03-26	1990-03-26 00:00:00	1990-03-26	5001	0	\N	0	0	\N	\N	0	202752	0	23426006	4052083		
27397	2540	40766240	1958-11-12	1958-11-12 00:00:00	1958-11-12	5001	0	\N	0	0	\N	\N	0	167974	0	63513-6	40766240		
2331	70	4052083	2007-12-03	2007-12-03 00:00:00	2007-12-03	5001	0	\N	0	0	\N	\N	0	4745	0	23426006	4052083		
9111	869	3006322	1961-01-02	1961-01-02 00:00:00	1961-01-02	5001	0	\N	0	0	\N	\N	0	57750	0	8331-1	3006322		
12447	1177	3006322	2006-03-19	2006-03-19 00:00:00	2006-03-19	5001	0	\N	0	0	\N	\N	0	77800	0	8331-1	3006322		
50489	4607	3006322	1984-03-18	1984-03-18 00:00:00	1984-03-18	5001	0	\N	0	0	\N	\N	0	306894	0	8331-1	3006322		
50408	4591	3006322	2016-06-16	2016-06-16 00:00:00	2016-06-16	5001	0	\N	0	0	\N	\N	0	305932	0	8331-1	3006322		
31308	2862	3006322	1989-07-29	1989-07-29 00:00:00	1989-07-29	5001	0	\N	0	0	\N	\N	0	190272	0	8331-1	3006322		
48645	4448	3006322	1966-01-26	1966-01-26 00:00:00	1966-01-26	5001	0	\N	0	0	\N	\N	0	295853	0	8331-1	3006322		
7282	704	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	46596	0	6273-7	3006451		
18668	1718	3006322	1972-07-21	1972-07-21 00:00:00	1972-07-21	5001	0	\N	0	0	\N	\N	0	114848	0	8331-1	3006322		
18772	1727	3006322	1985-01-17	1985-01-17 00:00:00	1985-01-17	5001	0	\N	0	0	\N	\N	0	115526	0	8331-1	3006322		
39751	3695	3036780	1993-02-08	1993-02-08 00:00:00	1993-02-08	5001	0	\N	0	0	\N	\N	0	245611	0	6095-4	3036780		
10342	1004	3006322	2014-04-01	2014-04-01 00:00:00	2014-04-01	5001	0	\N	0	0	\N	\N	0	66384	0	8331-1	3006322		
21678	1999	3019406	2015-04-08	2015-04-08 00:00:00	2015-04-08	5001	0	\N	0	0	\N	\N	0	133128	0	6158-0	3019406		
41620	3874	3000876	1998-07-01	1998-07-01 00:00:00	1998-07-01	5001	0	\N	0	0	\N	\N	0	257227	0	6082-2	3000876		
190	3	46235214	1994-03-04	1994-03-04 00:00:00	1994-03-04	5001	0	\N	0	0	\N	\N	0	225	0	76690-7	46235214		
18916	1740	40758406	1954-08-02	1954-08-02 00:00:00	1954-08-02	5001	0	\N	0	0	\N	\N	0	116295	0	55277-8	40758406		
49164	1497	4024958	1953-04-09	1953-04-09 00:00:00	1953-04-09	5001	0	\N	0	0	\N	\N	0	99857	0	117015009	4024958		
32404	2943	3006322	2000-02-06	2000-02-06 00:00:00	2000-02-06	5001	0	\N	0	0	\N	\N	0	196294	0	8331-1	3006322		
1174	96	3011505	1963-06-08	1963-06-08 00:00:00	1963-06-08	5001	0	\N	0	0	\N	\N	0	6563	0	19926-5	3011505		
23213	2135	3006322	1966-06-12	1966-06-12 00:00:00	1966-06-12	5001	0	\N	0	0	\N	\N	0	142160	0	8331-1	3006322		
12571	1201	3006322	2000-11-01	2000-11-01 00:00:00	2000-11-01	5001	0	\N	0	0	\N	\N	0	78998	0	8331-1	3006322		
105558	3249	4024958	1967-02-06	1967-02-06 00:00:00	1967-02-06	5001	0	\N	0	0	\N	\N	0	215993	0	117015009	4024958		
34721	3177	3006322	1932-01-27	1932-01-27 00:00:00	1932-01-27	5001	0	\N	0	0	\N	\N	0	211265	0	8331-1	3006322		
55488	5096	3006322	2014-10-03	2014-10-03 00:00:00	2014-10-03	5001	0	\N	0	0	\N	\N	0	338580	0	8331-1	3006322		
11590	366	4052083	1999-07-03	1999-07-03 00:00:00	1999-07-03	5001	0	\N	0	0	\N	\N	0	24297	0	23426006	4052083		
88126	2724	4024958	1955-08-19	1955-08-19 00:00:00	1955-08-19	5001	0	\N	0	0	\N	\N	0	180490	0	117015009	4024958		
26721	2462	3006322	1994-10-26	1994-10-26 00:00:00	1994-10-26	5001	0	\N	0	0	\N	\N	0	163290	0	8331-1	3006322		
34391	1076	4052083	1976-04-10	1976-04-10 00:00:00	1976-04-10	5001	0	\N	0	0	\N	\N	0	70565	0	23426006	4052083		
162018	4971	4133840	2009-01-20	2009-01-20 00:00:00	2009-01-20	5001	0	\N	0	0	\N	\N	0	330531	0	127783003	4133840		
56700	5200	40769194	1982-08-21	1982-08-21 00:00:00	1982-08-21	5001	0	\N	0	0	\N	\N	0	345867	0	66534-9	40769194		
55551	1689	4024958	1960-05-15	1960-05-15 00:00:00	1960-05-15	5001	0	\N	0	0	\N	\N	0	113093	0	117015009	4024958		
26854	842	4133840	1992-06-13	1992-06-13 00:00:00	1992-06-13	5001	0	\N	0	0	\N	\N	0	55670	0	127783003	4133840		
26933	842	4133840	1989-05-27	1989-05-27 00:00:00	1989-05-27	5001	0	\N	0	0	\N	\N	0	55739	0	127783003	4133840		
22949	2103	3006322	1983-08-15	1983-08-15 00:00:00	1983-08-15	5001	0	\N	0	0	\N	\N	0	140162	0	8331-1	3006322		
23045	2119	3015076	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	140966	0	6248-9	3015076		
18014	1640	3006322	2011-06-06	2011-06-06 00:00:00	2011-06-06	5001	0	\N	0	0	\N	\N	0	110090	0	8331-1	3006322		
18290	573	4024958	1965-07-27	1965-07-27 00:00:00	1965-07-27	5001	0	\N	0	0	\N	\N	0	37956	0	117015009	4024958		
2607	260	3001247	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	17262	0	6085-5	3001247		
52898	1604	4052083	1990-06-18	1990-06-18 00:00:00	1990-06-18	5001	0	\N	0	0	\N	\N	0	107616	0	23426006	4052083		
1340	116	3006322	1931-10-13	1931-10-13 00:00:00	1931-10-13	5001	0	\N	0	0	\N	\N	0	7674	0	8331-1	3006322		
57392	5267	3001247	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	350431	0	6085-5	3001247		
16268	507	4052083	1944-01-21	1944-01-21 00:00:00	1944-01-21	5001	0	\N	0	0	\N	\N	0	33961	0	23426006	4052083		
42058	3891	3027231	1999-06-02	1999-06-02 00:00:00	1999-06-02	5001	0	\N	0	0	\N	\N	0	258689	0	6276-0	3027231		
25586	2347	3006322	2015-02-26	2015-02-26 00:00:00	2015-02-26	5001	0	\N	0	0	\N	\N	0	156255	0	8331-1	3006322		
150528	4615	4024958	1969-04-07	1969-04-07 00:00:00	1969-04-07	5001	0	\N	0	0	\N	\N	0	307426	0	117015009	4024958		
18194	1657	3049273	2013-01-12	2013-01-12 00:00:00	2013-01-12	5001	0	\N	0	0	\N	\N	0	111189	0	38265-5	3049273		
26823	842	4024958	1917-09-19	1917-09-19 00:00:00	1917-09-19	5001	0	\N	0	0	\N	\N	0	55632	0	117015009	4024958		
11415	1091	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	71682	0	6075-6	3005136		
147457	4521	4052083	1976-02-19	1976-02-19 00:00:00	1976-02-19	5001	0	\N	0	0	\N	\N	0	301007	0	23426006	4052083		
10064	321	4052083	1973-04-13	1973-04-13 00:00:00	1973-04-13	5001	0	\N	0	0	\N	\N	0	21271	0	23426006	4052083		
31001	2834	3051031	1990-07-10	1990-07-10 00:00:00	1990-07-10	5001	0	\N	0	0	\N	\N	0	188192	0	46240-8	3051031		
31090	2837	3006322	1991-06-04	1991-06-04 00:00:00	1991-06-04	5001	0	\N	0	0	\N	\N	0	188417	0	8331-1	3006322		
39885	1239	4133840	2016-07-14	2016-07-14 00:00:00	2016-07-14	5001	0	\N	0	0	\N	\N	0	81667	0	127783003	4133840		
32917	2975	3006322	1973-04-13	1973-04-13 00:00:00	1973-04-13	5001	0	\N	0	0	\N	\N	0	198622	0	8331-1	3006322		
27399	2540	40758406	1958-11-12	1958-11-12 00:00:00	1958-11-12	5001	0	\N	0	0	\N	\N	0	167974	0	55277-8	40758406		
2341	70	4024958	1993-04-29	1993-04-29 00:00:00	1993-04-29	5001	0	\N	0	0	\N	\N	0	4763	0	117015009	4024958		
9112	869	3006322	1950-07-15	1950-07-15 00:00:00	1950-07-15	5001	0	\N	0	0	\N	\N	0	57749	0	8331-1	3006322		
12448	1177	3006322	1978-01-11	1978-01-11 00:00:00	1978-01-11	5001	0	\N	0	0	\N	\N	0	77775	0	8331-1	3006322		
50490	4607	3006322	1973-09-15	1973-09-15 00:00:00	1973-09-15	5001	0	\N	0	0	\N	\N	0	306918	0	8331-1	3006322		
50409	4591	3006322	1997-02-10	1997-02-10 00:00:00	1997-02-10	5001	0	\N	0	0	\N	\N	0	305945	0	8331-1	3006322		
31309	2862	3006322	1968-01-05	1968-01-05 00:00:00	1968-01-05	5001	0	\N	0	0	\N	\N	0	190282	0	8331-1	3006322		
48646	4448	3006322	1994-07-10	1994-07-10 00:00:00	1994-07-10	5001	0	\N	0	0	\N	\N	0	295846	0	8331-1	3006322		
7283	704	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	46596	0	6833-8	3023430		
18669	1718	3006322	2013-09-09	2013-09-09 00:00:00	2013-09-09	5001	0	\N	0	0	\N	\N	0	114853	0	8331-1	3006322		
18773	1727	3024561	1982-03-24	1982-03-24 00:00:00	1982-03-24	5001	0	\N	0	0	\N	\N	0	115482	0	1751-7	3024561		
39752	3695	3005136	1993-02-08	1993-02-08 00:00:00	1993-02-08	5001	0	\N	0	0	\N	\N	0	245611	0	6075-6	3005136		
10343	1004	3006322	1981-02-02	1981-02-02 00:00:00	1981-02-02	5001	0	\N	0	0	\N	\N	0	66381	0	8331-1	3006322		
21679	1999	3021226	2015-04-08	2015-04-08 00:00:00	2015-04-08	5001	0	\N	0	0	\N	\N	0	133128	0	6246-3	3021226		
41621	3874	3001247	1998-07-01	1998-07-01 00:00:00	1998-07-01	5001	0	\N	0	0	\N	\N	0	257227	0	6085-5	3001247		
191	3	46235214	1993-09-05	1993-09-05 00:00:00	1993-09-05	5001	0	\N	0	0	\N	\N	0	223	0	76690-7	46235214		
18917	1740	3051031	1954-08-02	1954-08-02 00:00:00	1954-08-02	5001	0	\N	0	0	\N	\N	0	116295	0	46240-8	3051031		
49199	1498	4052083	1987-10-15	1987-10-15 00:00:00	1987-10-15	5001	0	\N	0	0	\N	\N	0	99936	0	23426006	4052083		
32405	2943	3006322	1915-09-28	1915-09-28 00:00:00	1915-09-28	5001	0	\N	0	0	\N	\N	0	196332	0	8331-1	3006322		
1175	96	3011505	1983-02-12	1983-02-12 00:00:00	1983-02-12	5001	0	\N	0	0	\N	\N	0	6525	0	19926-5	3011505		
23214	2135	3006322	1958-02-13	1958-02-13 00:00:00	1958-02-13	5001	0	\N	0	0	\N	\N	0	142069	0	8331-1	3006322		
12572	1201	3006322	1976-08-24	1976-08-24 00:00:00	1976-08-24	5001	0	\N	0	0	\N	\N	0	79028	0	8331-1	3006322		
105567	3249	4024958	2000-06-19	2000-06-19 00:00:00	2000-06-19	5001	0	\N	0	0	\N	\N	0	216013	0	117015009	4024958		
34722	3177	3006322	1980-04-25	1980-04-25 00:00:00	1980-04-25	5001	0	\N	0	0	\N	\N	0	211312	0	8331-1	3006322		
55489	5096	3006322	1968-10-06	1968-10-06 00:00:00	1968-10-06	5001	0	\N	0	0	\N	\N	0	338594	0	8331-1	3006322		
11593	366	4024958	2011-12-23	2011-12-23 00:00:00	2011-12-23	5001	0	\N	0	0	\N	\N	0	24346	0	117015009	4024958		
111291	3437	4052083	1980-11-30	1980-11-30 00:00:00	1980-11-30	5001	0	\N	0	0	\N	\N	0	227970	0	23426006	4052083		
26722	2462	40769179	1988-10-12	1988-10-12 00:00:00	1988-10-12	5001	0	\N	0	0	\N	\N	0	163232	0	66519-0	40769179		
34399	1076	4052083	1974-05-07	1974-05-07 00:00:00	1974-05-07	5001	0	\N	0	0	\N	\N	0	70563	0	23426006	4052083		
162025	4971	4133840	2008-01-15	2008-01-15 00:00:00	2008-01-15	5001	0	\N	0	0	\N	\N	0	330659	0	127783003	4133840		
56701	5200	40769179	1982-08-21	1982-08-21 00:00:00	1982-08-21	5001	0	\N	0	0	\N	\N	0	345867	0	66519-0	40769179		
55553	1689	4024958	1963-02-07	1963-02-07 00:00:00	1963-02-07	5001	0	\N	0	0	\N	\N	0	113079	0	117015009	4024958		
26860	842	4133840	1980-03-08	1980-03-08 00:00:00	1980-03-08	5001	0	\N	0	0	\N	\N	0	55736	0	127783003	4133840		
26937	842	4133840	1999-07-24	1999-07-24 00:00:00	1999-07-24	5001	0	\N	0	0	\N	\N	0	55698	0	127783003	4133840		
22952	2105	3006322	1996-07-22	1996-07-22 00:00:00	1996-07-22	5001	0	\N	0	0	\N	\N	0	140256	0	8331-1	3006322		
23046	2119	3014599	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	140966	0	6106-9	3014599		
18018	1640	3006322	1948-05-11	1948-05-11 00:00:00	1948-05-11	5001	0	\N	0	0	\N	\N	0	110028	0	8331-1	3006322		
45845	4226	3014599	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	280641	0	6106-9	3014599		
2608	260	3006734	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	17262	0	6189-5	3006734		
52899	1604	4133840	2010-08-05	2010-08-05 00:00:00	2010-08-05	5001	0	\N	0	0	\N	\N	0	107653	0	127783003	4133840		
1341	116	3006322	1934-07-25	1934-07-25 00:00:00	1934-07-25	5001	0	\N	0	0	\N	\N	0	7712	0	8331-1	3006322		
57393	5267	3000876	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	350431	0	6082-2	3000876		
27600	862	4024958	1986-02-09	1986-02-09 00:00:00	1986-02-09	5001	0	\N	0	0	\N	\N	0	57087	0	117015009	4024958		
42059	3891	3020655	1999-06-02	1999-06-02 00:00:00	1999-06-02	5001	0	\N	0	0	\N	\N	0	258689	0	6844-5	3020655		
25587	2347	3006322	1974-06-06	1974-06-06 00:00:00	1974-06-06	5001	0	\N	0	0	\N	\N	0	156274	0	8331-1	3006322		
150530	4615	4052083	2002-08-11	2002-08-11 00:00:00	2002-08-11	5001	0	\N	0	0	\N	\N	0	307455	0	23426006	4052083		
18195	1657	3006322	1951-12-01	1951-12-01 00:00:00	1951-12-01	5001	0	\N	0	0	\N	\N	0	111174	0	8331-1	3006322		
26824	842	4133840	2005-08-27	2005-08-27 00:00:00	2005-08-27	5001	0	\N	0	0	\N	\N	0	55702	0	127783003	4133840		
11416	1091	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	71682	0	6158-0	3019406		
147464	4521	4024958	1967-12-03	1967-12-03 00:00:00	1967-12-03	5001	0	\N	0	0	\N	\N	0	301018	0	117015009	4024958		
10085	321	4052083	1991-12-29	1991-12-29 00:00:00	1991-12-29	5001	0	\N	0	0	\N	\N	0	21258	0	23426006	4052083		
31002	2834	46235214	1990-07-10	1990-07-10 00:00:00	1990-07-10	5001	0	\N	0	0	\N	\N	0	188192	0	76690-7	46235214		
31094	2841	3006322	1968-01-01	1968-01-01 00:00:00	1968-01-01	5001	0	\N	0	0	\N	\N	0	188612	0	8331-1	3006322		
39886	1239	4133840	2018-07-19	2018-07-19 00:00:00	2018-07-19	5001	0	\N	0	0	\N	\N	0	81659	0	127783003	4133840		
32918	2975	3014599	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	198625	0	6106-9	3014599		
27400	2540	46235214	1958-11-12	1958-11-12 00:00:00	1958-11-12	5001	0	\N	0	0	\N	\N	0	167974	0	76690-7	46235214		
2344	70	4024958	2019-04-24	2019-04-24 00:00:00	2019-04-24	5001	0	\N	0	0	\N	\N	0	4766	0	117015009	4024958		
9113	870	3006322	2011-11-23	2011-11-23 00:00:00	2011-11-23	5001	0	\N	0	0	\N	\N	0	57855	0	8331-1	3006322		
12451	1180	3006322	2000-03-07	2000-03-07 00:00:00	2000-03-07	5001	0	\N	0	0	\N	\N	0	77897	0	8331-1	3006322		
50491	4607	3006322	1976-10-12	1976-10-12 00:00:00	1976-10-12	5001	0	\N	0	0	\N	\N	0	306893	0	8331-1	3006322		
50410	4591	3006322	1991-12-26	1991-12-26 00:00:00	1991-12-26	5001	0	\N	0	0	\N	\N	0	305930	0	8331-1	3006322		
31310	2863	3006322	1964-03-12	1964-03-12 00:00:00	1964-03-12	5001	0	\N	0	0	\N	\N	0	190422	0	8331-1	3006322		
48647	4448	3006322	1961-12-20	1961-12-20 00:00:00	1961-12-20	5001	0	\N	0	0	\N	\N	0	295849	0	8331-1	3006322		
7284	704	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	46596	0	6085-5	3001247		
18670	1718	3006322	1982-11-23	1982-11-23 00:00:00	1982-11-23	5001	0	\N	0	0	\N	\N	0	114850	0	8331-1	3006322		
18774	1727	3006923	1982-03-24	1982-03-24 00:00:00	1982-03-24	5001	0	\N	0	0	\N	\N	0	115482	0	1742-6	3006923		
39753	3695	3014599	1993-02-08	1993-02-08 00:00:00	1993-02-08	5001	0	\N	0	0	\N	\N	0	245611	0	6106-9	3014599		
10344	1004	3006322	1999-11-04	1999-11-04 00:00:00	1999-11-04	5001	0	\N	0	0	\N	\N	0	66359	0	8331-1	3006322		
21680	1999	3006451	2015-04-08	2015-04-08 00:00:00	2015-04-08	5001	0	\N	0	0	\N	\N	0	133128	0	6273-7	3006451		
41622	3874	3036780	1998-07-01	1998-07-01 00:00:00	1998-07-01	5001	0	\N	0	0	\N	\N	0	257227	0	6095-4	3036780		
192	3	40766240	1993-09-05	1993-09-05 00:00:00	1993-09-05	5001	0	\N	0	0	\N	\N	0	223	0	63513-6	40766240		
18918	1740	40766240	1954-08-02	1954-08-02 00:00:00	1954-08-02	5001	0	\N	0	0	\N	\N	0	116295	0	63513-6	40766240		
49201	1498	4052083	2008-09-11	2008-09-11 00:00:00	2008-09-11	5001	0	\N	0	0	\N	\N	0	99960	0	23426006	4052083		
32406	2943	3049273	2008-02-08	2008-02-08 00:00:00	2008-02-08	5001	0	\N	0	0	\N	\N	0	196326	0	38265-5	3049273		
1176	96	3011505	1992-04-04	1992-04-04 00:00:00	1992-04-04	5001	0	\N	0	0	\N	\N	0	6495	0	19926-5	3011505		
23215	2135	3006322	2000-12-30	2000-12-30 00:00:00	2000-12-30	5001	0	\N	0	0	\N	\N	0	142108	0	8331-1	3006322		
12573	1202	3006322	1989-12-07	1989-12-07 00:00:00	1989-12-07	5001	0	\N	0	0	\N	\N	0	79060	0	8331-1	3006322		
105569	3249	4024958	1959-12-13	1959-12-13 00:00:00	1959-12-13	5001	0	\N	0	0	\N	\N	0	215959	0	117015009	4024958		
34723	3177	3006322	1931-11-14	1931-11-14 00:00:00	1931-11-14	5001	0	\N	0	0	\N	\N	0	211264	0	8331-1	3006322		
55490	5097	40769194	1992-07-02	1992-07-02 00:00:00	1992-07-02	5001	0	\N	0	0	\N	\N	0	338657	0	66534-9	40769194		
114850	3539	4052083	1998-08-02	1998-08-02 00:00:00	1998-08-02	5001	0	\N	0	0	\N	\N	0	235099	0	23426006	4052083		
111326	3438	4052083	1927-01-03	1927-01-03 00:00:00	1927-01-03	5001	0	\N	0	0	\N	\N	0	228072	0	23426006	4052083		
26723	2462	40769189	1988-10-12	1988-10-12 00:00:00	1988-10-12	5001	0	\N	0	0	\N	\N	0	163232	0	66529-9	40769189		
34404	1076	4024958	2005-05-08	2005-05-08 00:00:00	2005-05-08	5001	0	\N	0	0	\N	\N	0	70549	0	117015009	4024958		
162027	4971	4133840	2012-02-07	2012-02-07 00:00:00	2012-02-07	5001	0	\N	0	0	\N	\N	0	330554	0	127783003	4133840		
56702	5200	40769189	1982-08-21	1982-08-21 00:00:00	1982-08-21	5001	0	\N	0	0	\N	\N	0	345867	0	66529-9	40769189		
55554	1689	4052083	1982-03-23	1982-03-23 00:00:00	1982-03-23	5001	0	\N	0	0	\N	\N	0	113096	0	23426006	4052083		
26861	842	4052083	2011-07-13	2011-07-13 00:00:00	2011-07-13	5001	0	\N	0	0	\N	\N	0	55606	0	23426006	4052083		
26938	842	4133840	1968-11-02	1968-11-02 00:00:00	1968-11-02	5001	0	\N	0	0	\N	\N	0	55730	0	127783003	4133840		
22953	2105	3006322	2012-07-10	2012-07-10 00:00:00	2012-07-10	5001	0	\N	0	0	\N	\N	0	140257	0	8331-1	3006322		
23047	2119	3021226	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	140966	0	6246-3	3021226		
18019	1641	3006322	1963-08-09	1963-08-09 00:00:00	1963-08-09	5001	0	\N	0	0	\N	\N	0	110118	0	8331-1	3006322		
45846	4226	3023430	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	280641	0	6833-8	3023430		
2609	260	3006322	1986-05-18	1986-05-18 00:00:00	1986-05-18	5001	0	\N	0	0	\N	\N	0	17198	0	8331-1	3006322		
52902	1604	4133840	2009-07-30	2009-07-30 00:00:00	2009-07-30	5001	0	\N	0	0	\N	\N	0	107644	0	127783003	4133840		
1343	116	3006322	1934-05-10	1934-05-10 00:00:00	1934-05-10	5001	0	\N	0	0	\N	\N	0	7649	0	8331-1	3006322		
57394	5267	3036780	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	350431	0	6095-4	3036780		
27604	862	4024958	1976-11-21	1976-11-21 00:00:00	1976-11-21	5001	0	\N	0	0	\N	\N	0	57041	0	117015009	4024958		
42060	3891	3001488	1999-06-02	1999-06-02 00:00:00	1999-06-02	5001	0	\N	0	0	\N	\N	0	258689	0	7258-7	3001488		
25588	2347	3006322	1975-03-13	1975-03-13 00:00:00	1975-03-13	5001	0	\N	0	0	\N	\N	0	156278	0	8331-1	3006322		
161818	4970	4052083	1927-02-27	1927-02-27 00:00:00	1927-02-27	5001	0	\N	0	0	\N	\N	0	330379	0	23426006	4052083		
18196	1657	3006322	1996-06-09	1996-06-09 00:00:00	1996-06-09	5001	0	\N	0	0	\N	\N	0	111177	0	8331-1	3006322		
26827	842	4133840	1954-12-25	1954-12-25 00:00:00	1954-12-25	5001	0	\N	0	0	\N	\N	0	55757	0	127783003	4133840		
11417	1091	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	71682	0	6206-7	3012494		
5552	528	3006322	2007-12-03	2007-12-03 00:00:00	2007-12-03	5001	0	\N	0	0	\N	\N	0	35158	0	8331-1	3006322		
10087	321	4024958	1998-10-08	1998-10-08 00:00:00	1998-10-08	5001	0	\N	0	0	\N	\N	0	21291	0	117015009	4024958		
31003	2834	40758406	1990-07-10	1990-07-10 00:00:00	1990-07-10	5001	0	\N	0	0	\N	\N	0	188192	0	55277-8	40758406		
31095	2841	3006322	1983-02-23	1983-02-23 00:00:00	1983-02-23	5001	0	\N	0	0	\N	\N	0	188618	0	8331-1	3006322		
39888	1239	4133840	2012-07-05	2012-07-05 00:00:00	2012-07-05	5001	0	\N	0	0	\N	\N	0	81682	0	127783003	4133840		
32919	2975	3006734	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	198625	0	6189-5	3006734		
27402	2540	3051031	1958-11-12	1958-11-12 00:00:00	1958-11-12	5001	0	\N	0	0	\N	\N	0	167974	0	46240-8	3051031		
2353	70	4024958	1948-08-11	1948-08-11 00:00:00	1948-08-11	5001	0	\N	0	0	\N	\N	0	4762	0	117015009	4024958		
9114	870	3006322	2013-04-29	2013-04-29 00:00:00	2013-04-29	5001	0	\N	0	0	\N	\N	0	57913	0	8331-1	3006322		
12452	1180	3006322	2005-08-19	2005-08-19 00:00:00	2005-08-19	5001	0	\N	0	0	\N	\N	0	77905	0	8331-1	3006322		
50492	4608	3011505	2008-01-03	2008-01-03 00:00:00	2008-01-03	5001	0	\N	0	0	\N	\N	0	306942	0	19926-5	3011505		
50416	4593	3006322	2002-08-03	2002-08-03 00:00:00	2002-08-03	5001	0	\N	0	0	\N	\N	0	306036	0	8331-1	3006322		
31311	2863	3006322	2015-05-07	2015-05-07 00:00:00	2015-05-07	5001	0	\N	0	0	\N	\N	0	190416	0	8331-1	3006322		
48648	4448	3006322	1994-09-16	1994-09-16 00:00:00	1994-09-16	5001	0	\N	0	0	\N	\N	0	295855	0	8331-1	3006322		
7285	704	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	46596	0	6248-9	3015076		
18671	1718	3006322	2003-05-06	2003-05-06 00:00:00	2003-05-06	5001	0	\N	0	0	\N	\N	0	114852	0	8331-1	3006322		
18775	1727	3024731	1982-03-24	1982-03-24 00:00:00	1982-03-24	5001	0	\N	0	0	\N	\N	0	115482	0	30428-7	3024731		
39754	3695	3015076	1993-02-08	1993-02-08 00:00:00	1993-02-08	5001	0	\N	0	0	\N	\N	0	245611	0	6248-9	3015076		
10345	1004	3006322	1977-09-10	1977-09-10 00:00:00	1977-09-10	5001	0	\N	0	0	\N	\N	0	66376	0	8331-1	3006322		
21681	1999	3012494	2015-04-08	2015-04-08 00:00:00	2015-04-08	5001	0	\N	0	0	\N	\N	0	133128	0	6206-7	3012494		
41623	3874	3019406	1998-07-01	1998-07-01 00:00:00	1998-07-01	5001	0	\N	0	0	\N	\N	0	257227	0	6158-0	3019406		
193	3	3051031	1993-09-05	1993-09-05 00:00:00	1993-09-05	5001	0	\N	0	0	\N	\N	0	223	0	46240-8	3051031		
18921	1740	46235214	1954-08-02	1954-08-02 00:00:00	1954-08-02	5001	0	\N	0	0	\N	\N	0	116295	0	76690-7	46235214		
60504	1846	4052083	1979-09-29	1979-09-29 00:00:00	1979-09-29	5001	0	\N	0	0	\N	\N	0	123400	0	23426006	4052083		
32407	2943	3006322	1989-02-19	1989-02-19 00:00:00	1989-02-19	5001	0	\N	0	0	\N	\N	0	196322	0	8331-1	3006322		
1177	96	3011505	1954-05-29	1954-05-29 00:00:00	1954-05-29	5001	0	\N	0	0	\N	\N	0	6488	0	19926-5	3011505		
23216	2135	3006322	2006-10-10	2006-10-10 00:00:00	2006-10-10	5001	0	\N	0	0	\N	\N	0	142096	0	8331-1	3006322		
12574	1202	3006322	2015-01-29	2015-01-29 00:00:00	2015-01-29	5001	0	\N	0	0	\N	\N	0	79082	0	8331-1	3006322		
105580	3249	4024958	1963-03-05	1963-03-05 00:00:00	1963-03-05	5001	0	\N	0	0	\N	\N	0	215946	0	117015009	4024958		
34724	3177	3006322	2006-02-24	2006-02-24 00:00:00	2006-02-24	5001	0	\N	0	0	\N	\N	0	211346	0	8331-1	3006322		
24139	2217	3006322	1983-08-11	1983-08-11 00:00:00	1983-08-11	5001	0	\N	0	0	\N	\N	0	147667	0	8331-1	3006322		
114853	3539	4024958	2006-04-29	2006-04-29 00:00:00	2006-04-29	5001	0	\N	0	0	\N	\N	0	235101	0	117015009	4024958		
111329	3438	4024958	1916-08-10	1916-08-10 00:00:00	1916-08-10	5001	0	\N	0	0	\N	\N	0	228070	0	117015009	4024958		
26724	2462	40769184	1988-10-12	1988-10-12 00:00:00	1988-10-12	5001	0	\N	0	0	\N	\N	0	163232	0	66524-0	40769184		
126362	3891	4024958	2004-08-17	2004-08-17 00:00:00	2004-08-17	5001	0	\N	0	0	\N	\N	0	258642	0	117015009	4024958		
95892	2942	4024958	1975-03-03	1975-03-03 00:00:00	1975-03-03	5001	0	\N	0	0	\N	\N	0	196090	0	117015009	4024958		
56703	5201	3006322	1980-10-25	1980-10-25 00:00:00	1980-10-25	5001	0	\N	0	0	\N	\N	0	345951	0	8331-1	3006322		
55555	1689	4024958	1984-02-12	1984-02-12 00:00:00	1984-02-12	5001	0	\N	0	0	\N	\N	0	113107	0	117015009	4024958		
26864	842	4133840	2010-09-25	2010-09-25 00:00:00	2010-09-25	5001	0	\N	0	0	\N	\N	0	55700	0	127783003	4133840		
26943	842	4133840	1950-12-16	1950-12-16 00:00:00	1950-12-16	5001	0	\N	0	0	\N	\N	0	55741	0	127783003	4133840		
22954	2105	3006322	1980-07-31	1980-07-31 00:00:00	1980-07-31	5001	0	\N	0	0	\N	\N	0	140216	0	8331-1	3006322		
23048	2119	3006322	1982-10-21	1982-10-21 00:00:00	1982-10-21	5001	0	\N	0	0	\N	\N	0	141049	0	8331-1	3006322		
18020	1641	3006322	2010-11-24	2010-11-24 00:00:00	2010-11-24	5001	0	\N	0	0	\N	\N	0	110154	0	8331-1	3006322		
45847	4226	3020655	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	280641	0	6844-5	3020655		
163286	5017	4052083	2011-10-15	2011-10-15 00:00:00	2011-10-15	5001	0	\N	0	0	\N	\N	0	333440	0	23426006	4052083		
52903	1604	4133840	2018-09-20	2018-09-20 00:00:00	2018-09-20	5001	0	\N	0	0	\N	\N	0	107666	0	127783003	4133840		
1344	116	3006322	1989-11-11	1989-11-11 00:00:00	1989-11-11	5001	0	\N	0	0	\N	\N	0	7679	0	8331-1	3006322		
57395	5267	3005136	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	350431	0	6075-6	3005136		
27607	862	4024958	1991-12-20	1991-12-20 00:00:00	1991-12-20	5001	0	\N	0	0	\N	\N	0	57088	0	117015009	4024958		
42061	3891	3006734	1999-06-02	1999-06-02 00:00:00	1999-06-02	5001	0	\N	0	0	\N	\N	0	258689	0	6189-5	3006734		
36875	3389	3006322	2004-09-02	2004-09-02 00:00:00	2004-09-02	5001	0	\N	0	0	\N	\N	0	224780	0	8331-1	3006322		
161851	4970	4052083	1983-01-21	1983-01-21 00:00:00	1983-01-21	5001	0	\N	0	0	\N	\N	0	330427	0	23426006	4052083		
18197	1657	3006322	1984-03-21	1984-03-21 00:00:00	1984-03-21	5001	0	\N	0	0	\N	\N	0	111242	0	8331-1	3006322		
26828	842	4133840	2016-10-29	2016-10-29 00:00:00	2016-10-29	5001	0	\N	0	0	\N	\N	0	55704	0	127783003	4133840		
11418	1091	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	71682	0	6248-9	3015076		
5553	528	3006322	2011-09-28	2011-09-28 00:00:00	2011-09-28	5001	0	\N	0	0	\N	\N	0	35159	0	8331-1	3006322		
10088	321	4024958	1965-09-25	1965-09-25 00:00:00	1965-09-25	5001	0	\N	0	0	\N	\N	0	21270	0	117015009	4024958		
31004	2834	3006322	1968-01-14	1968-01-14 00:00:00	1968-01-14	5001	0	\N	0	0	\N	\N	0	188190	0	8331-1	3006322		
31097	2841	3006322	1953-03-09	1953-03-09 00:00:00	1953-03-09	5001	0	\N	0	0	\N	\N	0	188611	0	8331-1	3006322		
39894	1239	4133840	2014-07-10	2014-07-10 00:00:00	2014-07-10	5001	0	\N	0	0	\N	\N	0	81688	0	127783003	4133840		
32920	2975	3021226	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	198625	0	6246-3	3021226		
27405	2540	40766240	1958-07-15	1958-07-15 00:00:00	1958-07-15	5001	0	\N	0	0	\N	\N	0	167892	0	63513-6	40766240		
2371	72	4024958	1968-02-12	1968-02-12 00:00:00	1968-02-12	5001	0	\N	0	0	\N	\N	0	4916	0	117015009	4024958		
9115	870	3006322	1970-04-17	1970-04-17 00:00:00	1970-04-17	5001	0	\N	0	0	\N	\N	0	57904	0	8331-1	3006322		
12453	1180	3006322	2006-10-21	2006-10-21 00:00:00	2006-10-21	5001	0	\N	0	0	\N	\N	0	77887	0	8331-1	3006322		
50493	4608	3011505	2017-02-23	2017-02-23 00:00:00	2017-02-23	5001	0	\N	0	0	\N	\N	0	306945	0	19926-5	3011505		
50417	4593	3006322	1975-09-11	1975-09-11 00:00:00	1975-09-11	5001	0	\N	0	0	\N	\N	0	306078	0	8331-1	3006322		
31312	2863	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	190371	0	6075-6	3005136		
48649	4448	3006322	2008-02-22	2008-02-22 00:00:00	2008-02-22	5001	0	\N	0	0	\N	\N	0	295899	0	8331-1	3006322		
7286	704	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	46596	0	6246-3	3021226		
18672	1718	3006322	1976-04-16	1976-04-16 00:00:00	1976-04-16	5001	0	\N	0	0	\N	\N	0	114842	0	8331-1	3006322		
18776	1727	3026361	1982-03-24	1982-03-24 00:00:00	1982-03-24	5001	0	\N	0	0	\N	\N	0	115482	0	26453-1	3026361		
39755	3695	3000876	1993-02-08	1993-02-08 00:00:00	1993-02-08	5001	0	\N	0	0	\N	\N	0	245611	0	6082-2	3000876		
10346	1005	3006322	1970-04-20	1970-04-20 00:00:00	1970-04-20	5001	0	\N	0	0	\N	\N	0	66405	0	8331-1	3006322		
21682	1999	3000876	2015-04-08	2015-04-08 00:00:00	2015-04-08	5001	0	\N	0	0	\N	\N	0	133128	0	6082-2	3000876		
41624	3874	3023430	1998-07-01	1998-07-01 00:00:00	1998-07-01	5001	0	\N	0	0	\N	\N	0	257227	0	6833-8	3023430		
196	3	40758406	1993-09-05	1993-09-05 00:00:00	1993-09-05	5001	0	\N	0	0	\N	\N	0	223	0	55277-8	40758406		
18922	1740	3006322	1994-08-06	1994-08-06 00:00:00	1994-08-06	5001	0	\N	0	0	\N	\N	0	116238	0	8331-1	3006322		
60505	1846	4024958	1968-11-04	1968-11-04 00:00:00	1968-11-04	5001	0	\N	0	0	\N	\N	0	123397	0	117015009	4024958		
32408	2944	3006322	2000-01-03	2000-01-03 00:00:00	2000-01-03	5001	0	\N	0	0	\N	\N	0	196422	0	8331-1	3006322		
37239	1150	4024958	1988-01-04	1988-01-04 00:00:00	1988-01-04	5001	0	\N	0	0	\N	\N	0	76004	0	117015009	4024958		
23217	2136	3006322	1995-10-10	1995-10-10 00:00:00	1995-10-10	5001	0	\N	0	0	\N	\N	0	142303	0	8331-1	3006322		
12575	1202	3006322	2004-02-22	2004-02-22 00:00:00	2004-02-22	5001	0	\N	0	0	\N	\N	0	79081	0	8331-1	3006322		
105581	3249	4024958	2008-02-04	2008-02-04 00:00:00	2008-02-04	5001	0	\N	0	0	\N	\N	0	216015	0	117015009	4024958		
34725	3177	3006322	1968-07-13	1968-07-13 00:00:00	1968-07-13	5001	0	\N	0	0	\N	\N	0	211251	0	8331-1	3006322		
24140	2217	3006322	2015-05-20	2015-05-20 00:00:00	2015-05-20	5001	0	\N	0	0	\N	\N	0	147631	0	8331-1	3006322		
114872	3540	4024958	1977-10-25	1977-10-25 00:00:00	1977-10-25	5001	0	\N	0	0	\N	\N	0	235142	0	117015009	4024958		
111332	3438	4052083	1944-01-03	1944-01-03 00:00:00	1944-01-03	5001	0	\N	0	0	\N	\N	0	228115	0	23426006	4052083		
26725	2462	40769194	1988-10-12	1988-10-12 00:00:00	1988-10-12	5001	0	\N	0	0	\N	\N	0	163232	0	66534-9	40769194		
137655	4240	4024958	1945-12-30	1945-12-30 00:00:00	1945-12-30	5001	0	\N	0	0	\N	\N	0	281686	0	117015009	4024958		
95896	2942	4024958	1961-06-02	1961-06-02 00:00:00	1961-06-02	5001	0	\N	0	0	\N	\N	0	196128	0	117015009	4024958		
56704	5201	3006322	2005-05-16	2005-05-16 00:00:00	2005-05-16	5001	0	\N	0	0	\N	\N	0	345965	0	8331-1	3006322		
55557	1689	4024958	1945-12-03	1945-12-03 00:00:00	1945-12-03	5001	0	\N	0	0	\N	\N	0	113137	0	117015009	4024958		
26870	842	4133840	1986-04-12	1986-04-12 00:00:00	1986-04-12	5001	0	\N	0	0	\N	\N	0	55748	0	127783003	4133840		
26946	842	4133840	2007-09-08	2007-09-08 00:00:00	2007-09-08	5001	0	\N	0	0	\N	\N	0	55689	0	127783003	4133840		
22955	2105	3006322	1978-10-27	1978-10-27 00:00:00	1978-10-27	5001	0	\N	0	0	\N	\N	0	140237	0	8331-1	3006322		
23049	2119	3005136	1983-06-29	1983-06-29 00:00:00	1983-06-29	5001	0	\N	0	0	\N	\N	0	141050	0	6075-6	3005136		
18021	1641	3006322	1968-11-23	1968-11-23 00:00:00	1968-11-23	5001	0	\N	0	0	\N	\N	0	110191	0	8331-1	3006322		
45848	4226	3019406	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	280641	0	6158-0	3019406		
163290	5017	4024958	1981-11-05	1981-11-05 00:00:00	1981-11-05	5001	0	\N	0	0	\N	\N	0	333446	0	117015009	4024958		
52909	1605	4052083	1992-08-20	1992-08-20 00:00:00	1992-08-20	5001	0	\N	0	0	\N	\N	0	107671	0	23426006	4052083		
1348	116	3006322	2004-10-03	2004-10-03 00:00:00	2004-10-03	5001	0	\N	0	0	\N	\N	0	7723	0	8331-1	3006322		
57396	5267	3001488	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	350431	0	7258-7	3001488		
27611	862	4052083	1995-08-31	1995-08-31 00:00:00	1995-08-31	5001	0	\N	0	0	\N	\N	0	57084	0	23426006	4052083		
42062	3891	3023430	1999-06-02	1999-06-02 00:00:00	1999-06-02	5001	0	\N	0	0	\N	\N	0	258689	0	6833-8	3023430		
36876	3389	3006322	2010-03-14	2010-03-14 00:00:00	2010-03-14	5001	0	\N	0	0	\N	\N	0	224747	0	8331-1	3006322		
36201	1123	4024958	2002-10-03	2002-10-03 00:00:00	2002-10-03	5001	0	\N	0	0	\N	\N	0	74000	0	117015009	4024958		
18198	1657	3049273	2008-01-09	2008-01-09 00:00:00	2008-01-09	5001	0	\N	0	0	\N	\N	0	111187	0	38265-5	3049273		
26830	842	4133840	2003-08-16	2003-08-16 00:00:00	2003-08-16	5001	0	\N	0	0	\N	\N	0	55672	0	127783003	4133840		
11419	1091	3006322	1990-12-10	1990-12-10 00:00:00	1990-12-10	5001	0	\N	0	0	\N	\N	0	71733	0	8331-1	3006322		
5554	528	3006322	1977-05-28	1977-05-28 00:00:00	1977-05-28	5001	0	\N	0	0	\N	\N	0	35223	0	8331-1	3006322		
98562	3017	4052083	2003-03-28	2003-03-28 00:00:00	2003-03-28	5001	0	\N	0	0	\N	\N	0	201256	0	23426006	4052083		
31005	2834	40758406	1991-08-04	1991-08-04 00:00:00	1991-08-04	5001	0	\N	0	0	\N	\N	0	188184	0	55277-8	40758406		
31098	2842	3006322	1996-02-12	1996-02-12 00:00:00	1996-02-12	5001	0	\N	0	0	\N	\N	0	188703	0	8331-1	3006322		
39898	1239	4052083	2015-10-20	2015-10-20 00:00:00	2015-10-20	5001	0	\N	0	0	\N	\N	0	81642	0	23426006	4052083		
32921	2975	3027231	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	198625	0	6276-0	3027231		
27406	2540	46235214	1958-07-15	1958-07-15 00:00:00	1958-07-15	5001	0	\N	0	0	\N	\N	0	167892	0	76690-7	46235214		
945	78	3006322	1985-05-13	1985-05-13 00:00:00	1985-05-13	5001	0	\N	0	0	\N	\N	0	5178	0	8331-1	3006322		
9116	870	40758406	1961-04-06	1961-04-06 00:00:00	1961-04-06	5001	0	\N	0	0	\N	\N	0	57881	0	55277-8	40758406		
12454	1180	3006322	2008-10-21	2008-10-21 00:00:00	2008-10-21	5001	0	\N	0	0	\N	\N	0	77936	0	8331-1	3006322		
50494	4608	3011505	2019-03-07	2019-03-07 00:00:00	2019-03-07	5001	0	\N	0	0	\N	\N	0	306946	0	19926-5	3011505		
50424	4595	3006322	2016-01-28	2016-01-28 00:00:00	2016-01-28	5001	0	\N	0	0	\N	\N	0	306189	0	8331-1	3006322		
31313	2863	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	190371	0	6273-7	3006451		
48650	4448	3006322	1955-05-14	1955-05-14 00:00:00	1955-05-14	5001	0	\N	0	0	\N	\N	0	295843	0	8331-1	3006322		
7287	704	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	46596	0	6106-9	3014599		
18673	1719	3006322	2015-04-15	2015-04-15 00:00:00	2015-04-15	5001	0	\N	0	0	\N	\N	0	114963	0	8331-1	3006322		
18777	1727	3000963	1982-03-24	1982-03-24 00:00:00	1982-03-24	5001	0	\N	0	0	\N	\N	0	115482	0	718-7	3000963		
39756	3695	3023430	1993-02-08	1993-02-08 00:00:00	1993-02-08	5001	0	\N	0	0	\N	\N	0	245611	0	6833-8	3023430		
10347	1005	3006322	1969-09-09	1969-09-09 00:00:00	1969-09-09	5001	0	\N	0	0	\N	\N	0	66424	0	8331-1	3006322		
21683	1999	3012494	2011-10-05	2011-10-05 00:00:00	2011-10-05	5001	0	\N	0	0	\N	\N	0	133114	0	6206-7	3012494		
41625	3874	3006734	1998-07-01	1998-07-01 00:00:00	1998-07-01	5001	0	\N	0	0	\N	\N	0	257227	0	6189-5	3006734		
198	5	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	486	0	6075-6	3005136		
18923	1740	3006322	1977-07-16	1977-07-16 00:00:00	1977-07-16	5001	0	\N	0	0	\N	\N	0	116263	0	8331-1	3006322		
152428	4674	4052083	2012-01-25	2012-01-25 00:00:00	2012-01-25	5001	0	\N	0	0	\N	\N	0	311383	0	23426006	4052083		
32409	2945	3011505	1992-03-31	1992-03-31 00:00:00	1992-03-31	5001	0	\N	0	0	\N	\N	0	196492	0	19926-5	3011505		
37252	1151	4024958	1989-12-10	1989-12-10 00:00:00	1989-12-10	5001	0	\N	0	0	\N	\N	0	76087	0	117015009	4024958		
23218	2136	3006734	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	142306	0	6189-5	3006734		
12576	1202	3006322	2006-03-23	2006-03-23 00:00:00	2006-03-23	5001	0	\N	0	0	\N	\N	0	79067	0	8331-1	3006322		
105582	3249	4024958	1990-04-27	1990-04-27 00:00:00	1990-04-27	5001	0	\N	0	0	\N	\N	0	216010	0	117015009	4024958		
34726	3178	3006322	1996-05-28	1996-05-28 00:00:00	1996-05-28	5001	0	\N	0	0	\N	\N	0	211408	0	8331-1	3006322		
24141	2217	3006322	2015-08-04	2015-08-04 00:00:00	2015-08-04	5001	0	\N	0	0	\N	\N	0	147671	0	8331-1	3006322		
114880	3540	4024958	2005-04-18	2005-04-18 00:00:00	2005-04-18	5001	0	\N	0	0	\N	\N	0	235135	0	117015009	4024958		
111333	3438	4052083	1918-03-02	1918-03-02 00:00:00	1918-03-02	5001	0	\N	0	0	\N	\N	0	228094	0	23426006	4052083		
26726	2462	3006322	1964-09-25	1964-09-25 00:00:00	1964-09-25	5001	0	\N	0	0	\N	\N	0	163292	0	8331-1	3006322		
137660	4241	4024958	1985-10-08	1985-10-08 00:00:00	1985-10-08	5001	0	\N	0	0	\N	\N	0	281693	0	117015009	4024958		
95935	2942	4052083	1992-04-27	1992-04-27 00:00:00	1992-04-27	5001	0	\N	0	0	\N	\N	0	196169	0	23426006	4052083		
56705	5201	3006322	1987-11-05	1987-11-05 00:00:00	1987-11-05	5001	0	\N	0	0	\N	\N	0	345952	0	8331-1	3006322		
55586	1690	4024958	1983-01-07	1983-01-07 00:00:00	1983-01-07	5001	0	\N	0	0	\N	\N	0	113164	0	117015009	4024958		
26872	842	4133840	1949-12-03	1949-12-03 00:00:00	1949-12-03	5001	0	\N	0	0	\N	\N	0	55756	0	127783003	4133840		
26948	842	4133840	1967-10-28	1967-10-28 00:00:00	1967-10-28	5001	0	\N	0	0	\N	\N	0	55732	0	127783003	4133840		
22956	2108	3006322	1995-07-08	1995-07-08 00:00:00	1995-07-08	5001	0	\N	0	0	\N	\N	0	140383	0	8331-1	3006322		
23050	2119	3027231	1983-06-29	1983-06-29 00:00:00	1983-06-29	5001	0	\N	0	0	\N	\N	0	141050	0	6276-0	3027231		
18022	1641	3006322	1976-02-12	1976-02-12 00:00:00	1976-02-12	5001	0	\N	0	0	\N	\N	0	110153	0	8331-1	3006322		
45849	4226	3006451	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	280641	0	6273-7	3006451		
163297	5017	4052083	1997-07-21	1997-07-21 00:00:00	1997-07-21	5001	0	\N	0	0	\N	\N	0	333439	0	23426006	4052083		
114660	3532	4052083	1995-10-31	1995-10-31 00:00:00	1995-10-31	5001	0	\N	0	0	\N	\N	0	234598	0	23426006	4052083		
1350	116	3006322	1959-06-11	1959-06-11 00:00:00	1959-06-11	5001	0	\N	0	0	\N	\N	0	7706	0	8331-1	3006322		
57397	5267	3021226	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	350431	0	6246-3	3021226		
27614	862	4024958	1973-01-29	1973-01-29 00:00:00	1973-01-29	5001	0	\N	0	0	\N	\N	0	57080	0	117015009	4024958		
42063	3891	3006451	1999-06-02	1999-06-02 00:00:00	1999-06-02	5001	0	\N	0	0	\N	\N	0	258689	0	6273-7	3006451		
36877	3389	3006322	2003-03-28	2003-03-28 00:00:00	2003-03-28	5001	0	\N	0	0	\N	\N	0	224779	0	8331-1	3006322		
36209	1123	4024958	1971-05-29	1971-05-29 00:00:00	1971-05-29	5001	0	\N	0	0	\N	\N	0	73977	0	117015009	4024958		
18199	1658	3006322	1946-11-27	1946-11-27 00:00:00	1946-11-27	5001	0	\N	0	0	\N	\N	0	111322	0	8331-1	3006322		
26834	842	4133840	1984-03-31	1984-03-31 00:00:00	1984-03-31	5001	0	\N	0	0	\N	\N	0	55738	0	127783003	4133840		
11420	1091	3006322	1976-07-29	1976-07-29 00:00:00	1976-07-29	5001	0	\N	0	0	\N	\N	0	71677	0	8331-1	3006322		
37178	1148	4024958	1978-05-23	1978-05-23 00:00:00	1978-05-23	5001	0	\N	0	0	\N	\N	0	75887	0	117015009	4024958		
92157	2841	4024958	1953-03-09	1953-03-09 00:00:00	1953-03-09	5001	0	\N	0	0	\N	\N	0	188611	0	117015009	4024958		
31006	2834	3051031	1991-08-04	1991-08-04 00:00:00	1991-08-04	5001	0	\N	0	0	\N	\N	0	188184	0	46240-8	3051031		
31099	2842	3006322	1983-04-29	1983-04-29 00:00:00	1983-04-29	5001	0	\N	0	0	\N	\N	0	188702	0	8331-1	3006322		
15939	1454	46235214	1972-12-08	1972-12-08 00:00:00	1972-12-08	5001	0	\N	0	0	\N	\N	0	96986	0	76690-7	46235214		
32922	2975	3015076	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	198625	0	6248-9	3015076		
27408	2540	3051031	1958-07-15	1958-07-15 00:00:00	1958-07-15	5001	0	\N	0	0	\N	\N	0	167892	0	46240-8	3051031		
946	78	3006322	1998-02-28	1998-02-28 00:00:00	1998-02-28	5001	0	\N	0	0	\N	\N	0	5180	0	8331-1	3006322		
9118	870	40766240	1961-04-06	1961-04-06 00:00:00	1961-04-06	5001	0	\N	0	0	\N	\N	0	57881	0	63513-6	40766240		
12455	1180	3006322	1994-09-23	1994-09-23 00:00:00	1994-09-23	5001	0	\N	0	0	\N	\N	0	77896	0	8331-1	3006322		
50495	4608	3006322	1967-10-13	1967-10-13 00:00:00	1967-10-13	5001	0	\N	0	0	\N	\N	0	306991	0	8331-1	3006322		
100233	3077	4052083	2007-10-09	2007-10-09 00:00:00	2007-10-09	5001	0	\N	0	0	\N	\N	0	204768	0	23426006	4052083		
31314	2863	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	190371	0	6833-8	3023430		
48651	4448	3006322	1965-03-17	1965-03-17 00:00:00	1965-03-17	5001	0	\N	0	0	\N	\N	0	295852	0	8331-1	3006322		
7288	704	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	46596	0	6095-4	3036780		
18674	1719	3006322	1985-12-23	1985-12-23 00:00:00	1985-12-23	5001	0	\N	0	0	\N	\N	0	114947	0	8331-1	3006322		
18778	1727	3010813	1982-03-24	1982-03-24 00:00:00	1982-03-24	5001	0	\N	0	0	\N	\N	0	115482	0	26464-8	3010813		
39757	3695	3001247	1993-02-08	1993-02-08 00:00:00	1993-02-08	5001	0	\N	0	0	\N	\N	0	245611	0	6085-5	3001247		
10370	1015	40758406	2006-01-06	2006-01-06 00:00:00	2006-01-06	5001	0	\N	0	0	\N	\N	0	66770	0	55277-8	40758406		
21684	1999	3000876	2011-10-05	2011-10-05 00:00:00	2011-10-05	5001	0	\N	0	0	\N	\N	0	133114	0	6082-2	3000876		
41626	3874	3001488	1998-07-01	1998-07-01 00:00:00	1998-07-01	5001	0	\N	0	0	\N	\N	0	257227	0	7258-7	3001488		
199	5	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	486	0	6158-0	3019406		
18924	1740	3006322	1986-05-10	1986-05-10 00:00:00	1986-05-10	5001	0	\N	0	0	\N	\N	0	116237	0	8331-1	3006322		
152433	4674	4024958	1982-05-12	1982-05-12 00:00:00	1982-05-12	5001	0	\N	0	0	\N	\N	0	311389	0	117015009	4024958		
32410	2945	3011505	1988-10-25	1988-10-25 00:00:00	1988-10-25	5001	0	\N	0	0	\N	\N	0	196476	0	19926-5	3011505		
37253	1151	4052083	2019-04-01	2019-04-01 00:00:00	2019-04-01	5001	0	\N	0	0	\N	\N	0	76089	0	23426006	4052083		
23219	2136	3023430	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	142306	0	6833-8	3023430		
12577	1202	3006322	2013-02-24	2013-02-24 00:00:00	2013-02-24	5001	0	\N	0	0	\N	\N	0	79074	0	8331-1	3006322		
105584	3249	4024958	1958-03-12	1958-03-12 00:00:00	1958-03-12	5001	0	\N	0	0	\N	\N	0	215945	0	117015009	4024958		
46004	4240	3006322	2003-11-17	2003-11-17 00:00:00	2003-11-17	5001	0	\N	0	0	\N	\N	0	281674	0	8331-1	3006322		
60155	1837	4052083	2015-07-02	2015-07-02 00:00:00	2015-07-02	5001	0	\N	0	0	\N	\N	0	122731	0	23426006	4052083		
114883	3540	4052083	1994-10-19	1994-10-19 00:00:00	1994-10-19	5001	0	\N	0	0	\N	\N	0	235114	0	23426006	4052083		
111336	3438	4024958	1957-11-20	1957-11-20 00:00:00	1957-11-20	5001	0	\N	0	0	\N	\N	0	228095	0	117015009	4024958		
26727	2462	3006322	1966-10-27	1966-10-27 00:00:00	1966-10-27	5001	0	\N	0	0	\N	\N	0	163318	0	8331-1	3006322		
137665	4241	4024958	2008-10-02	2008-10-02 00:00:00	2008-10-02	5001	0	\N	0	0	\N	\N	0	281758	0	117015009	4024958		
107229	3307	4024958	1995-05-03	1995-05-03 00:00:00	1995-05-03	5001	0	\N	0	0	\N	\N	0	219616	0	117015009	4024958		
56708	5203	3006322	1985-11-18	1985-11-18 00:00:00	1985-11-18	5001	0	\N	0	0	\N	\N	0	346080	0	8331-1	3006322		
55592	1690	4024958	1981-10-05	1981-10-05 00:00:00	1981-10-05	5001	0	\N	0	0	\N	\N	0	113208	0	117015009	4024958		
26873	842	4133840	1990-06-02	1990-06-02 00:00:00	1990-06-02	5001	0	\N	0	0	\N	\N	0	55669	0	127783003	4133840		
26949	842	4133840	2011-10-01	2011-10-01 00:00:00	2011-10-01	5001	0	\N	0	0	\N	\N	0	55691	0	127783003	4133840		
22957	2108	3006322	1976-09-18	1976-09-18 00:00:00	1976-09-18	5001	0	\N	0	0	\N	\N	0	140337	0	8331-1	3006322		
23051	2119	3006451	1983-06-29	1983-06-29 00:00:00	1983-06-29	5001	0	\N	0	0	\N	\N	0	141050	0	6273-7	3006451		
18023	1641	3006322	1970-11-23	1970-11-23 00:00:00	1970-11-23	5001	0	\N	0	0	\N	\N	0	110127	0	8331-1	3006322		
45850	4226	3027231	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	280641	0	6276-0	3027231		
163301	5017	4024958	1988-07-14	1988-07-14 00:00:00	1988-07-14	5001	0	\N	0	0	\N	\N	0	333424	0	117015009	4024958		
114661	3532	4024958	1989-12-13	1989-12-13 00:00:00	1989-12-13	5001	0	\N	0	0	\N	\N	0	234634	0	117015009	4024958		
1351	117	3006322	2006-04-18	2006-04-18 00:00:00	2006-04-18	5001	0	\N	0	0	\N	\N	0	7777	0	8331-1	3006322		
57398	5267	3019406	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	350431	0	6158-0	3019406		
27615	862	4052083	1987-02-21	1987-02-21 00:00:00	1987-02-21	5001	0	\N	0	0	\N	\N	0	57044	0	23426006	4052083		
42064	3891	3012494	1999-06-02	1999-06-02 00:00:00	1999-06-02	5001	0	\N	0	0	\N	\N	0	258689	0	6206-7	3012494		
36882	3391	3006322	1990-09-09	1990-09-09 00:00:00	1990-09-09	5001	0	\N	0	0	\N	\N	0	224926	0	8331-1	3006322		
36220	1123	4024958	1995-10-16	1995-10-16 00:00:00	1995-10-16	5001	0	\N	0	0	\N	\N	0	73978	0	117015009	4024958		
18200	1658	3006322	1918-10-07	1918-10-07 00:00:00	1918-10-07	5001	0	\N	0	0	\N	\N	0	111383	0	8331-1	3006322		
26836	842	4133840	1973-12-01	1973-12-01 00:00:00	1973-12-01	5001	0	\N	0	0	\N	\N	0	55746	0	127783003	4133840		
11421	1091	40766240	1957-08-06	1957-08-06 00:00:00	1957-08-06	5001	0	\N	0	0	\N	\N	0	71592	0	63513-6	40766240		
37181	1148	4024958	1958-08-17	1958-08-17 00:00:00	1958-08-17	5001	0	\N	0	0	\N	\N	0	75886	0	117015009	4024958		
92179	2842	4024958	1996-02-12	1996-02-12 00:00:00	1996-02-12	5001	0	\N	0	0	\N	\N	0	188703	0	117015009	4024958		
31007	2834	46235214	1991-08-04	1991-08-04 00:00:00	1991-08-04	5001	0	\N	0	0	\N	\N	0	188184	0	76690-7	46235214		
31100	2842	3006322	1970-06-25	1970-06-25 00:00:00	1970-06-25	5001	0	\N	0	0	\N	\N	0	188700	0	8331-1	3006322		
15940	1454	40766240	1972-12-08	1972-12-08 00:00:00	1972-12-08	5001	0	\N	0	0	\N	\N	0	96986	0	63513-6	40766240		
32923	2975	3000876	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	198625	0	6082-2	3000876		
27409	2540	40758406	1958-07-15	1958-07-15 00:00:00	1958-07-15	5001	0	\N	0	0	\N	\N	0	167892	0	55277-8	40758406		
947	78	3006322	2003-08-23	2003-08-23 00:00:00	2003-08-23	5001	0	\N	0	0	\N	\N	0	5181	0	8331-1	3006322		
9120	870	46235214	1961-04-06	1961-04-06 00:00:00	1961-04-06	5001	0	\N	0	0	\N	\N	0	57881	0	76690-7	46235214		
12456	1180	3049273	2010-09-28	2010-09-28 00:00:00	2010-09-28	5001	0	\N	0	0	\N	\N	0	77962	0	38265-5	3049273		
50496	4608	3006322	2017-10-10	2017-10-10 00:00:00	2017-10-10	5001	0	\N	0	0	\N	\N	0	307036	0	8331-1	3006322		
111520	3443	4024958	1986-06-23	1986-06-23 00:00:00	1986-06-23	5001	0	\N	0	0	\N	\N	0	228481	0	117015009	4024958		
31315	2863	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	190371	0	6085-5	3001247		
142202	4374	4052083	1980-09-15	1980-09-15 00:00:00	1980-09-15	5001	0	\N	0	0	\N	\N	0	290458	0	23426006	4052083		
7289	704	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	46596	0	6082-2	3000876		
18675	1719	3006322	2015-05-27	2015-05-27 00:00:00	2015-05-27	5001	0	\N	0	0	\N	\N	0	114964	0	8331-1	3006322		
18779	1727	3004501	1982-03-24	1982-03-24 00:00:00	1982-03-24	5001	0	\N	0	0	\N	\N	0	115482	0	2345-7	3004501		
39758	3695	3001488	1993-02-08	1993-02-08 00:00:00	1993-02-08	5001	0	\N	0	0	\N	\N	0	245611	0	7258-7	3001488		
10372	1015	40766240	2006-01-06	2006-01-06 00:00:00	2006-01-06	5001	0	\N	0	0	\N	\N	0	66770	0	63513-6	40766240		
10472	1015	40766240	1987-01-16	1987-01-16 00:00:00	1987-01-16	5001	0	\N	0	0	\N	\N	0	66793	0	63513-6	40766240		
41627	3874	3006451	1998-07-01	1998-07-01 00:00:00	1998-07-01	5001	0	\N	0	0	\N	\N	0	257227	0	6273-7	3006451		
200	5	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	486	0	6248-9	3015076		
18925	1740	3051031	1954-05-04	1954-05-04 00:00:00	1954-05-04	5001	0	\N	0	0	\N	\N	0	116294	0	46240-8	3051031		
152443	4674	4024958	1982-09-21	1982-09-21 00:00:00	1982-09-21	5001	0	\N	0	0	\N	\N	0	311373	0	117015009	4024958		
32411	2945	3011505	2009-01-13	2009-01-13 00:00:00	2009-01-13	5001	0	\N	0	0	\N	\N	0	196490	0	19926-5	3011505		
37255	1151	4052083	2000-01-15	2000-01-15 00:00:00	2000-01-15	5001	0	\N	0	0	\N	\N	0	76088	0	23426006	4052083		
23220	2136	3020655	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	142306	0	6844-5	3020655		
12578	1202	3006322	1982-12-27	1982-12-27 00:00:00	1982-12-27	5001	0	\N	0	0	\N	\N	0	79065	0	8331-1	3006322		
105596	3250	4052083	1986-08-15	1986-08-15 00:00:00	1986-08-15	5001	0	\N	0	0	\N	\N	0	216077	0	23426006	4052083		
46005	4241	3006322	1973-11-13	1973-11-13 00:00:00	1973-11-13	5001	0	\N	0	0	\N	\N	0	281692	0	8331-1	3006322		
60170	1837	4052083	1961-01-10	1961-01-10 00:00:00	1961-01-10	5001	0	\N	0	0	\N	\N	0	122701	0	23426006	4052083		
114900	3541	4024958	2018-09-27	2018-09-27 00:00:00	2018-09-27	5001	0	\N	0	0	\N	\N	0	235213	0	117015009	4024958		
122620	3783	4052083	1985-07-21	1985-07-21 00:00:00	1985-07-21	5001	0	\N	0	0	\N	\N	0	251369	0	23426006	4052083		
26728	2462	3006322	2008-03-30	2008-03-30 00:00:00	2008-03-30	5001	0	\N	0	0	\N	\N	0	163302	0	8331-1	3006322		
137668	4241	4024958	1979-08-27	1979-08-27 00:00:00	1979-08-27	5001	0	\N	0	0	\N	\N	0	281700	0	117015009	4024958		
107231	3307	4024958	1968-08-25	1968-08-25 00:00:00	1968-08-25	5001	0	\N	0	0	\N	\N	0	219579	0	117015009	4024958		
56709	5203	3006322	1940-11-16	1940-11-16 00:00:00	1940-11-16	5001	0	\N	0	0	\N	\N	0	346100	0	8331-1	3006322		
3972	398	3006322	1940-04-08	1940-04-08 00:00:00	1940-04-08	5001	0	\N	0	0	\N	\N	0	26068	0	8331-1	3006322		
26875	842	4133840	1974-12-07	1974-12-07 00:00:00	1974-12-07	5001	0	\N	0	0	\N	\N	0	55694	0	127783003	4133840		
26983	843	4024958	2016-04-17	2016-04-17 00:00:00	2016-04-17	5001	0	\N	0	0	\N	\N	0	55855	0	117015009	4024958		
22958	2108	3006322	1950-11-25	1950-11-25 00:00:00	1950-11-25	5001	0	\N	0	0	\N	\N	0	140373	0	8331-1	3006322		
23052	2119	3006734	1983-06-29	1983-06-29 00:00:00	1983-06-29	5001	0	\N	0	0	\N	\N	0	141050	0	6189-5	3006734		
18024	1642	3000963	1979-05-15	1979-05-15 00:00:00	1979-05-15	5001	0	\N	0	0	\N	\N	0	110279	0	718-7	3000963		
45851	4226	3021226	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	280641	0	6246-3	3021226		
163306	5018	4052083	1942-05-06	1942-05-06 00:00:00	1942-05-06	5001	0	\N	0	0	\N	\N	0	333531	0	23426006	4052083		
114668	3532	4024958	1978-12-14	1978-12-14 00:00:00	1978-12-14	5001	0	\N	0	0	\N	\N	0	234596	0	117015009	4024958		
1352	117	3006322	2008-03-21	2008-03-21 00:00:00	2008-03-21	5001	0	\N	0	0	\N	\N	0	7759	0	8331-1	3006322		
57399	5267	3027231	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	350431	0	6276-0	3027231		
138977	4283	4052083	1981-12-29	1981-12-29 00:00:00	1981-12-29	5001	0	\N	0	0	\N	\N	0	284231	0	23426006	4052083		
42065	3891	3021226	1999-06-02	1999-06-02 00:00:00	1999-06-02	5001	0	\N	0	0	\N	\N	0	258689	0	6246-3	3021226		
36883	3392	3006322	2010-06-19	2010-06-19 00:00:00	2010-06-19	5001	0	\N	0	0	\N	\N	0	224991	0	8331-1	3006322		
36234	1124	4052083	1951-09-20	1951-09-20 00:00:00	1951-09-20	5001	0	\N	0	0	\N	\N	0	74096	0	23426006	4052083		
18201	1658	3049273	1992-01-27	1992-01-27 00:00:00	1992-01-27	5001	0	\N	0	0	\N	\N	0	111287	0	38265-5	3049273		
26838	842	4133840	1994-06-25	1994-06-25 00:00:00	1994-06-25	5001	0	\N	0	0	\N	\N	0	55750	0	127783003	4133840		
11422	1091	3051031	1957-08-06	1957-08-06 00:00:00	1957-08-06	5001	0	\N	0	0	\N	\N	0	71592	0	46240-8	3051031		
37200	1149	4024958	1997-05-28	1997-05-28 00:00:00	1997-05-28	5001	0	\N	0	0	\N	\N	0	75951	0	117015009	4024958		
92182	2842	4024958	1970-06-25	1970-06-25 00:00:00	1970-06-25	5001	0	\N	0	0	\N	\N	0	188700	0	117015009	4024958		
31009	2834	40766240	1991-08-04	1991-08-04 00:00:00	1991-08-04	5001	0	\N	0	0	\N	\N	0	188184	0	63513-6	40766240		
31101	2842	3006322	1985-03-02	1985-03-02 00:00:00	1985-03-02	5001	0	\N	0	0	\N	\N	0	188645	0	8331-1	3006322		
15941	1454	40758406	1972-12-08	1972-12-08 00:00:00	1972-12-08	5001	0	\N	0	0	\N	\N	0	96986	0	55277-8	40758406		
32924	2975	3001488	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	198625	0	7258-7	3001488		
27410	2540	3051031	1958-12-12	1958-12-12 00:00:00	1958-12-12	5001	0	\N	0	0	\N	\N	0	167935	0	46240-8	3051031		
948	78	3006322	2003-07-14	2003-07-14 00:00:00	2003-07-14	5001	0	\N	0	0	\N	\N	0	5204	0	8331-1	3006322		
9121	870	3051031	1961-04-06	1961-04-06 00:00:00	1961-04-06	5001	0	\N	0	0	\N	\N	0	57881	0	46240-8	3051031		
45334	1390	4024958	1981-04-22	1981-04-22 00:00:00	1981-04-22	5001	0	\N	0	0	\N	\N	0	92290	0	117015009	4024958		
50497	4608	3011505	2004-12-16	2004-12-16 00:00:00	2004-12-16	5001	0	\N	0	0	\N	\N	0	307089	0	19926-5	3011505		
23329	2149	3006322	1998-11-12	1998-11-12 00:00:00	1998-11-12	5001	0	\N	0	0	\N	\N	0	143061	0	8331-1	3006322		
31316	2863	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	190371	0	6158-0	3019406		
142219	4374	4024958	1986-08-22	1986-08-22 00:00:00	1986-08-22	5001	0	\N	0	0	\N	\N	0	290488	0	117015009	4024958		
7290	704	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	46596	0	6206-7	3012494		
18676	1719	3006322	2010-01-28	2010-01-28 00:00:00	2010-01-28	5001	0	\N	0	0	\N	\N	0	114896	0	8331-1	3006322		
18780	1727	3014576	1982-03-24	1982-03-24 00:00:00	1982-03-24	5001	0	\N	0	0	\N	\N	0	115482	0	2075-0	3014576		
39759	3695	3006734	1993-02-08	1993-02-08 00:00:00	1993-02-08	5001	0	\N	0	0	\N	\N	0	245611	0	6189-5	3006734		
10373	1015	46235214	2006-01-06	2006-01-06 00:00:00	2006-01-06	5001	0	\N	0	0	\N	\N	0	66770	0	76690-7	46235214		
10473	1015	3051031	1987-01-16	1987-01-16 00:00:00	1987-01-16	5001	0	\N	0	0	\N	\N	0	66793	0	46240-8	3051031		
41628	3874	3015076	1998-07-01	1998-07-01 00:00:00	1998-07-01	5001	0	\N	0	0	\N	\N	0	257227	0	6248-9	3015076		
201	5	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	486	0	6189-5	3006734		
18926	1740	40758406	1954-05-04	1954-05-04 00:00:00	1954-05-04	5001	0	\N	0	0	\N	\N	0	116294	0	55277-8	40758406		
152460	4675	4052083	1953-09-11	1953-09-11 00:00:00	1953-09-11	5001	0	\N	0	0	\N	\N	0	311429	0	23426006	4052083		
32412	2945	3011505	2001-08-21	2001-08-21 00:00:00	2001-08-21	5001	0	\N	0	0	\N	\N	0	196457	0	19926-5	3011505		
37258	1151	4052083	1994-12-30	1994-12-30 00:00:00	1994-12-30	5001	0	\N	0	0	\N	\N	0	76086	0	23426006	4052083		
23221	2136	3005136	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	142306	0	6075-6	3005136		
12579	1202	3006322	1992-08-07	1992-08-07 00:00:00	1992-08-07	5001	0	\N	0	0	\N	\N	0	79070	0	8331-1	3006322		
105606	3250	4024958	1977-06-07	1977-06-07 00:00:00	1977-06-07	5001	0	\N	0	0	\N	\N	0	216051	0	117015009	4024958		
46006	4241	3006322	1985-10-08	1985-10-08 00:00:00	1985-10-08	5001	0	\N	0	0	\N	\N	0	281693	0	8331-1	3006322		
60197	1840	4024958	1986-10-02	1986-10-02 00:00:00	1986-10-02	5001	0	\N	0	0	\N	\N	0	122824	0	117015009	4024958		
114902	3541	4024958	1992-02-22	1992-02-22 00:00:00	1992-02-22	5001	0	\N	0	0	\N	\N	0	235177	0	117015009	4024958		
54166	1646	4052083	1948-02-18	1948-02-18 00:00:00	1948-02-18	5001	0	\N	0	0	\N	\N	0	110380	0	23426006	4052083		
26729	2463	3000963	2008-03-31	2008-03-31 00:00:00	2008-03-31	5001	0	\N	0	0	\N	\N	0	163392	0	718-7	3000963		
137673	4241	4052083	1977-01-01	1977-01-01 00:00:00	1977-01-01	5001	0	\N	0	0	\N	\N	0	281752	0	23426006	4052083		
107244	3308	4052083	1977-08-02	1977-08-02 00:00:00	1977-08-02	5001	0	\N	0	0	\N	\N	0	219640	0	23426006	4052083		
56711	5203	3006322	1949-11-23	1949-11-23 00:00:00	1949-11-23	5001	0	\N	0	0	\N	\N	0	346077	0	8331-1	3006322		
3974	398	3006322	1964-11-12	1964-11-12 00:00:00	1964-11-12	5001	0	\N	0	0	\N	\N	0	26057	0	8331-1	3006322		
26878	842	4133840	1988-05-21	1988-05-21 00:00:00	1988-05-21	5001	0	\N	0	0	\N	\N	0	55668	0	127783003	4133840		
63205	1945	4024958	2007-10-22	2007-10-22 00:00:00	2007-10-22	5001	0	\N	0	0	\N	\N	0	129208	0	117015009	4024958		
22959	2108	3006322	2015-12-04	2015-12-04 00:00:00	2015-12-04	5001	0	\N	0	0	\N	\N	0	140316	0	8331-1	3006322		
59262	1804	4024958	1945-07-23	1945-07-23 00:00:00	1945-07-23	5001	0	\N	0	0	\N	\N	0	120890	0	117015009	4024958		
18025	1642	3009542	1979-05-15	1979-05-15 00:00:00	1979-05-15	5001	0	\N	0	0	\N	\N	0	110279	0	20570-8	3009542		
45852	4226	3001247	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	280641	0	6085-5	3001247		
163310	5018	4024958	1957-12-13	1957-12-13 00:00:00	1957-12-13	5001	0	\N	0	0	\N	\N	0	333532	0	117015009	4024958		
114676	3532	4024958	2014-03-15	2014-03-15 00:00:00	2014-03-15	5001	0	\N	0	0	\N	\N	0	234648	0	117015009	4024958		
1353	117	3006322	2016-09-16	2016-09-16 00:00:00	2016-09-16	5001	0	\N	0	0	\N	\N	0	7786	0	8331-1	3006322		
57400	5267	3006451	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	350431	0	6273-7	3006451		
138997	4283	4024958	1970-09-15	1970-09-15 00:00:00	1970-09-15	5001	0	\N	0	0	\N	\N	0	284236	0	117015009	4024958		
53343	4899	3011505	1994-10-18	1994-10-18 00:00:00	1994-10-18	5001	0	\N	0	0	\N	\N	0	325861	0	19926-5	3011505		
36884	3392	3006322	1979-11-04	1979-11-04 00:00:00	1979-11-04	5001	0	\N	0	0	\N	\N	0	224967	0	8331-1	3006322		
36265	1124	4052083	1991-05-11	1991-05-11 00:00:00	1991-05-11	5001	0	\N	0	0	\N	\N	0	74047	0	23426006	4052083		
18202	1658	3006322	1913-01-24	1913-01-24 00:00:00	1913-01-24	5001	0	\N	0	0	\N	\N	0	111411	0	8331-1	3006322		
26840	842	4133840	1961-01-14	1961-01-14 00:00:00	1961-01-14	5001	0	\N	0	0	\N	\N	0	55743	0	127783003	4133840		
11424	1091	46235214	1957-08-06	1957-08-06 00:00:00	1957-08-06	5001	0	\N	0	0	\N	\N	0	71592	0	76690-7	46235214		
37209	1149	4024958	2011-04-12	2011-04-12 00:00:00	2011-04-12	5001	0	\N	0	0	\N	\N	0	75954	0	117015009	4024958		
30306	939	4052083	2014-09-13	2014-09-13 00:00:00	2014-09-13	5001	0	\N	0	0	\N	\N	0	62443	0	23426006	4052083		
31011	2834	3006322	1947-08-02	1947-08-02 00:00:00	1947-08-02	5001	0	\N	0	0	\N	\N	0	188185	0	8331-1	3006322		
31102	2843	3006322	1988-04-15	1988-04-15 00:00:00	1988-04-15	5001	0	\N	0	0	\N	\N	0	188777	0	8331-1	3006322		
15942	1454	3051031	1972-12-08	1972-12-08 00:00:00	1972-12-08	5001	0	\N	0	0	\N	\N	0	96986	0	46240-8	3051031		
32925	2975	3020655	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	198625	0	6844-5	3020655		
27411	2540	40758406	1958-12-12	1958-12-12 00:00:00	1958-12-12	5001	0	\N	0	0	\N	\N	0	167935	0	55277-8	40758406		
949	78	3006322	2014-09-07	2014-09-07 00:00:00	2014-09-07	5001	0	\N	0	0	\N	\N	0	5182	0	8331-1	3006322		
9122	870	3006322	2014-07-03	2014-07-03 00:00:00	2014-07-03	5001	0	\N	0	0	\N	\N	0	57914	0	8331-1	3006322		
45338	1390	4024958	1972-07-27	1972-07-27 00:00:00	1972-07-27	5001	0	\N	0	0	\N	\N	0	92253	0	117015009	4024958		
50498	4608	3011505	1992-01-30	1992-01-30 00:00:00	1992-01-30	5001	0	\N	0	0	\N	\N	0	306976	0	19926-5	3011505		
23330	2150	3006322	1953-07-04	1953-07-04 00:00:00	1953-07-04	5001	0	\N	0	0	\N	\N	0	143145	0	8331-1	3006322		
31317	2863	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	190371	0	6206-7	3012494		
142252	4375	4024958	1939-06-11	1939-06-11 00:00:00	1939-06-11	5001	0	\N	0	0	\N	\N	0	290634	0	117015009	4024958		
7291	704	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	46596	0	6158-0	3019406		
18677	1719	3006322	1965-06-12	1965-06-12 00:00:00	1965-06-12	5001	0	\N	0	0	\N	\N	0	114943	0	8331-1	3006322		
18781	1727	3035995	1982-03-24	1982-03-24 00:00:00	1982-03-24	5001	0	\N	0	0	\N	\N	0	115482	0	6768-6	3035995		
39760	3695	3020655	1993-02-08	1993-02-08 00:00:00	1993-02-08	5001	0	\N	0	0	\N	\N	0	245611	0	6844-5	3020655		
10390	1015	40758406	2018-09-30	2018-09-30 00:00:00	2018-09-30	5001	0	\N	0	0	\N	\N	0	66840	0	55277-8	40758406		
10474	1015	46235214	1987-01-16	1987-01-16 00:00:00	1987-01-16	5001	0	\N	0	0	\N	\N	0	66793	0	76690-7	46235214		
41629	3874	3012494	1998-07-01	1998-07-01 00:00:00	1998-07-01	5001	0	\N	0	0	\N	\N	0	257227	0	6206-7	3012494		
202	5	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	486	0	6082-2	3000876		
18927	1740	40766240	1954-05-04	1954-05-04 00:00:00	1954-05-04	5001	0	\N	0	0	\N	\N	0	116294	0	63513-6	40766240		
2298	207	3006322	1986-05-21	1986-05-21 00:00:00	1986-05-21	5001	0	\N	0	0	\N	\N	0	14098	0	8331-1	3006322		
32413	2945	3006322	1950-05-21	1950-05-21 00:00:00	1950-05-21	5001	0	\N	0	0	\N	\N	0	196478	0	8331-1	3006322		
136041	4194	4024958	2003-08-08	2003-08-08 00:00:00	2003-08-08	5001	0	\N	0	0	\N	\N	0	278407	0	117015009	4024958		
23222	2136	3014599	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	142306	0	6106-9	3014599		
12583	1205	3006322	1963-04-07	1963-04-07 00:00:00	1963-04-07	5001	0	\N	0	0	\N	\N	0	79183	0	8331-1	3006322		
116893	3603	4052083	2009-07-26	2009-07-26 00:00:00	2009-07-26	5001	0	\N	0	0	\N	\N	0	239369	0	23426006	4052083		
46007	4241	3006322	2008-10-02	2008-10-02 00:00:00	2008-10-02	5001	0	\N	0	0	\N	\N	0	281758	0	8331-1	3006322		
60199	1840	4024958	1983-01-22	1983-01-22 00:00:00	1983-01-22	5001	0	\N	0	0	\N	\N	0	122836	0	117015009	4024958		
114910	3541	4052083	2014-08-18	2014-08-18 00:00:00	2014-08-18	5001	0	\N	0	0	\N	\N	0	235174	0	23426006	4052083		
54176	1646	4024958	1981-10-22	1981-10-22 00:00:00	1981-10-22	5001	0	\N	0	0	\N	\N	0	110381	0	117015009	4024958		
26730	2463	3009542	2008-03-31	2008-03-31 00:00:00	2008-03-31	5001	0	\N	0	0	\N	\N	0	163392	0	20570-8	3009542		
137691	4241	4024958	1973-11-13	1973-11-13 00:00:00	1973-11-13	5001	0	\N	0	0	\N	\N	0	281692	0	117015009	4024958		
2100	61	4024958	1990-05-10	1990-05-10 00:00:00	1990-05-10	5001	0	\N	0	0	\N	\N	0	4140	0	117015009	4024958		
56712	5203	3006322	1950-02-04	1950-02-04 00:00:00	1950-02-04	5001	0	\N	0	0	\N	\N	0	346054	0	8331-1	3006322		
3975	399	3021226	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	26131	0	6246-3	3021226		
26880	842	4133840	1995-07-01	1995-07-01 00:00:00	1995-07-01	5001	0	\N	0	0	\N	\N	0	55696	0	127783003	4133840		
63212	1945	4024958	1976-07-01	1976-07-01 00:00:00	1976-07-01	5001	0	\N	0	0	\N	\N	0	129199	0	117015009	4024958		
22960	2108	3006322	1980-05-14	1980-05-14 00:00:00	1980-05-14	5001	0	\N	0	0	\N	\N	0	140396	0	8331-1	3006322		
59270	1804	4052083	1989-07-12	1989-07-12 00:00:00	1989-07-12	5001	0	\N	0	0	\N	\N	0	120891	0	23426006	4052083		
18030	1646	3006322	1981-10-22	1981-10-22 00:00:00	1981-10-22	5001	0	\N	0	0	\N	\N	0	110381	0	8331-1	3006322		
70802	2168	4052083	1967-01-20	1967-01-20 00:00:00	1967-01-20	5001	0	\N	0	0	\N	\N	0	144486	0	23426006	4052083		
163350	5018	4052083	1963-05-07	1963-05-07 00:00:00	1963-05-07	5001	0	\N	0	0	\N	\N	0	333462	0	23426006	4052083		
114696	3533	4024958	2003-07-09	2003-07-09 00:00:00	2003-07-09	5001	0	\N	0	0	\N	\N	0	234710	0	117015009	4024958		
1354	117	3006322	2000-09-03	2000-09-03 00:00:00	2000-09-03	5001	0	\N	0	0	\N	\N	0	7776	0	8331-1	3006322		
57401	5267	3014599	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	350431	0	6106-9	3014599		
139001	4283	4024958	1990-09-11	1990-09-11 00:00:00	1990-09-11	5001	0	\N	0	0	\N	\N	0	284263	0	117015009	4024958		
53344	4899	3011505	1975-07-01	1975-07-01 00:00:00	1975-07-01	5001	0	\N	0	0	\N	\N	0	325855	0	19926-5	3011505		
36885	3392	3006322	2016-06-27	2016-06-27 00:00:00	2016-06-27	5001	0	\N	0	0	\N	\N	0	224969	0	8331-1	3006322		
36266	1124	4052083	1954-05-29	1954-05-29 00:00:00	1954-05-29	5001	0	\N	0	0	\N	\N	0	74093	0	23426006	4052083		
18203	1658	3006322	1991-01-13	1991-01-13 00:00:00	1991-01-13	5001	0	\N	0	0	\N	\N	0	111328	0	8331-1	3006322		
26844	842	4133840	1964-02-01	1964-02-01 00:00:00	1964-02-01	5001	0	\N	0	0	\N	\N	0	55660	0	127783003	4133840		
11426	1091	40758406	1957-08-06	1957-08-06 00:00:00	1957-08-06	5001	0	\N	0	0	\N	\N	0	71592	0	55277-8	40758406		
37212	1150	4052083	1951-12-04	1951-12-04 00:00:00	1951-12-04	5001	0	\N	0	0	\N	\N	0	75999	0	23426006	4052083		
30311	939	4024958	1997-11-01	1997-11-01 00:00:00	1997-11-01	5001	0	\N	0	0	\N	\N	0	62440	0	117015009	4024958		
31012	2834	40766240	1990-10-08	1990-10-08 00:00:00	1990-10-08	5001	0	\N	0	0	\N	\N	0	188193	0	63513-6	40766240		
31103	2843	3006322	1959-12-04	1959-12-04 00:00:00	1959-12-04	5001	0	\N	0	0	\N	\N	0	188719	0	8331-1	3006322		
15944	1454	3006322	1998-07-28	1998-07-28 00:00:00	1998-07-28	5001	0	\N	0	0	\N	\N	0	97026	0	8331-1	3006322		
32926	2975	3036780	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	198625	0	6095-4	3036780		
27412	2540	40766240	1958-12-12	1958-12-12 00:00:00	1958-12-12	5001	0	\N	0	0	\N	\N	0	167935	0	63513-6	40766240		
950	78	3006322	1997-10-20	1997-10-20 00:00:00	1997-10-20	5001	0	\N	0	0	\N	\N	0	5179	0	8331-1	3006322		
9123	870	3006322	2001-01-20	2001-01-20 00:00:00	2001-01-20	5001	0	\N	0	0	\N	\N	0	57852	0	8331-1	3006322		
45340	1391	4024958	1961-01-19	1961-01-19 00:00:00	1961-01-19	5001	0	\N	0	0	\N	\N	0	92398	0	117015009	4024958		
50499	4608	3011505	1996-12-26	1996-12-26 00:00:00	1996-12-26	5001	0	\N	0	0	\N	\N	0	307017	0	19926-5	3011505		
23331	2150	3049273	2005-11-07	2005-11-07 00:00:00	2005-11-07	5001	0	\N	0	0	\N	\N	0	143153	0	38265-5	3049273		
31318	2863	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	190371	0	6189-5	3006734		
142253	4375	4052083	1933-06-09	1933-06-09 00:00:00	1933-06-09	5001	0	\N	0	0	\N	\N	0	290601	0	23426006	4052083		
7292	704	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	46536	0	6206-7	3012494		
18678	1719	3006322	1967-02-15	1967-02-15 00:00:00	1967-02-15	5001	0	\N	0	0	\N	\N	0	114888	0	8331-1	3006322		
18782	1727	3019550	1982-03-24	1982-03-24 00:00:00	1982-03-24	5001	0	\N	0	0	\N	\N	0	115482	0	2951-2	3019550		
39761	3695	3012494	1993-02-08	1993-02-08 00:00:00	1993-02-08	5001	0	\N	0	0	\N	\N	0	245611	0	6206-7	3012494		
10391	1015	3051031	2018-09-30	2018-09-30 00:00:00	2018-09-30	5001	0	\N	0	0	\N	\N	0	66840	0	46240-8	3051031		
10475	1016	3006322	2002-10-22	2002-10-22 00:00:00	2002-10-22	5001	0	\N	0	0	\N	\N	0	66918	0	8331-1	3006322		
41630	3874	3020655	1994-12-28	1994-12-28 00:00:00	1994-12-28	5001	0	\N	0	0	\N	\N	0	257207	0	6844-5	3020655		
203	5	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	486	0	6273-7	3006451		
18930	1740	46235214	1954-05-04	1954-05-04 00:00:00	1954-05-04	5001	0	\N	0	0	\N	\N	0	116294	0	76690-7	46235214		
2299	207	3006322	1973-09-10	1973-09-10 00:00:00	1973-09-10	5001	0	\N	0	0	\N	\N	0	14113	0	8331-1	3006322		
32414	2945	3011505	2011-01-25	2011-01-25 00:00:00	2011-01-25	5001	0	\N	0	0	\N	\N	0	196483	0	19926-5	3011505		
136051	4194	4024958	1976-08-28	1976-08-28 00:00:00	1976-08-28	5001	0	\N	0	0	\N	\N	0	278369	0	117015009	4024958		
23223	2136	3001247	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	142306	0	6085-5	3001247		
12584	1205	3006322	2001-07-27	2001-07-27 00:00:00	2001-07-27	5001	0	\N	0	0	\N	\N	0	79212	0	8331-1	3006322		
48911	4476	40769179	1962-05-30	1962-05-30 00:00:00	1962-05-30	5001	0	\N	0	0	\N	\N	0	297888	0	66519-0	40769179		
46008	4241	3006322	1991-12-16	1991-12-16 00:00:00	1991-12-16	5001	0	\N	0	0	\N	\N	0	281702	0	8331-1	3006322		
60202	1840	4052083	2017-07-20	2017-07-20 00:00:00	2017-07-20	5001	0	\N	0	0	\N	\N	0	122826	0	23426006	4052083		
69628	2135	4024958	2000-12-30	2000-12-30 00:00:00	2000-12-30	5001	0	\N	0	0	\N	\N	0	142108	0	117015009	4024958		
54188	1646	4052083	1941-05-30	1941-05-30 00:00:00	1941-05-30	5001	0	\N	0	0	\N	\N	0	110379	0	23426006	4052083		
26731	2463	3006322	1975-10-08	1975-10-08 00:00:00	1975-10-08	5001	0	\N	0	0	\N	\N	0	163384	0	8331-1	3006322		
137713	4243	4024958	1970-09-07	1970-09-07 00:00:00	1970-09-07	5001	0	\N	0	0	\N	\N	0	281839	0	117015009	4024958		
2131	63	4024958	1973-08-27	1973-08-27 00:00:00	1973-08-27	5001	0	\N	0	0	\N	\N	0	4242	0	117015009	4024958		
56713	5203	3006322	1967-01-14	1967-01-14 00:00:00	1967-01-14	5001	0	\N	0	0	\N	\N	0	346122	0	8331-1	3006322		
3976	399	3005136	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	26131	0	6075-6	3005136		
26882	842	4133840	1982-03-20	1982-03-20 00:00:00	1982-03-20	5001	0	\N	0	0	\N	\N	0	55737	0	127783003	4133840		
63216	1945	4024958	2003-08-21	2003-08-21 00:00:00	2003-08-21	5001	0	\N	0	0	\N	\N	0	129205	0	117015009	4024958		
22961	2108	3049273	2017-07-23	2017-07-23 00:00:00	2017-07-23	5001	0	\N	0	0	\N	\N	0	140360	0	38265-5	3049273		
59271	1804	4024958	1950-05-12	1950-05-12 00:00:00	1950-05-12	5001	0	\N	0	0	\N	\N	0	120835	0	117015009	4024958		
18031	1646	3006322	1956-03-12	1956-03-12 00:00:00	1956-03-12	5001	0	\N	0	0	\N	\N	0	110369	0	8331-1	3006322		
70852	2172	4024958	1991-11-11	1991-11-11 00:00:00	1991-11-11	5001	0	\N	0	0	\N	\N	0	144666	0	117015009	4024958		
13245	1261	3011505	2017-12-02	2017-12-02 00:00:00	2017-12-02	5001	0	\N	0	0	\N	\N	0	83139	0	19926-5	3011505		
19145	1753	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	117203	0	6189-5	3006734		
1355	117	3006322	2011-12-26	2011-12-26 00:00:00	2011-12-26	5001	0	\N	0	0	\N	\N	0	7760	0	8331-1	3006322		
57402	5267	40769184	1995-12-09	1995-12-09 00:00:00	1995-12-09	5001	0	\N	0	0	\N	\N	0	350362	0	66524-0	40769184		
139011	4283	4052083	1964-11-03	1964-11-03 00:00:00	1964-11-03	5001	0	\N	0	0	\N	\N	0	284307	0	23426006	4052083		
53345	4899	3011505	1978-07-18	1978-07-18 00:00:00	1978-07-18	5001	0	\N	0	0	\N	\N	0	325857	0	19926-5	3011505		
36886	3392	3006322	1973-08-28	1973-08-28 00:00:00	1973-08-28	5001	0	\N	0	0	\N	\N	0	224966	0	8331-1	3006322		
36273	1124	4024958	1950-08-20	1950-08-20 00:00:00	1950-08-20	5001	0	\N	0	0	\N	\N	0	74092	0	117015009	4024958		
18204	1658	3006322	1929-06-15	1929-06-15 00:00:00	1929-06-15	5001	0	\N	0	0	\N	\N	0	111385	0	8331-1	3006322		
26845	842	4133840	1965-10-16	1965-10-16 00:00:00	1965-10-16	5001	0	\N	0	0	\N	\N	0	55731	0	127783003	4133840		
11427	1091	3006322	1972-11-07	1972-11-07 00:00:00	1972-11-07	5001	0	\N	0	0	\N	\N	0	71595	0	8331-1	3006322		
37220	1150	4024958	1973-05-25	1973-05-25 00:00:00	1973-05-25	5001	0	\N	0	0	\N	\N	0	76002	0	117015009	4024958		
30341	940	4052083	1947-05-05	1947-05-05 00:00:00	1947-05-05	5001	0	\N	0	0	\N	\N	0	62537	0	23426006	4052083		
31013	2834	40758406	1990-10-08	1990-10-08 00:00:00	1990-10-08	5001	0	\N	0	0	\N	\N	0	188193	0	55277-8	40758406		
31104	2843	3006322	2008-10-11	2008-10-11 00:00:00	2008-10-11	5001	0	\N	0	0	\N	\N	0	188764	0	8331-1	3006322		
15945	1454	3006322	1984-04-06	1984-04-06 00:00:00	1984-04-06	5001	0	\N	0	0	\N	\N	0	96977	0	8331-1	3006322		
32927	2975	3019406	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	198625	0	6158-0	3019406		
27415	2540	46235214	1958-12-12	1958-12-12 00:00:00	1958-12-12	5001	0	\N	0	0	\N	\N	0	167935	0	76690-7	46235214		
951	78	3006322	1967-02-07	1967-02-07 00:00:00	1967-02-07	5001	0	\N	0	0	\N	\N	0	5155	0	8331-1	3006322		
9124	870	40758406	1961-03-07	1961-03-07 00:00:00	1961-03-07	5001	0	\N	0	0	\N	\N	0	57868	0	55277-8	40758406		
45341	1391	4024958	1936-02-09	1936-02-09 00:00:00	1936-02-09	5001	0	\N	0	0	\N	\N	0	92313	0	117015009	4024958		
50500	4608	3011505	1989-01-26	1989-01-26 00:00:00	1989-01-26	5001	0	\N	0	0	\N	\N	0	307057	0	19926-5	3011505		
23332	2150	3006322	1966-11-03	1966-11-03 00:00:00	1966-11-03	5001	0	\N	0	0	\N	\N	0	143166	0	8331-1	3006322		
31319	2863	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	190371	0	6246-3	3021226		
142256	4375	4024958	1957-05-26	1957-05-26 00:00:00	1957-05-26	5001	0	\N	0	0	\N	\N	0	290654	0	117015009	4024958		
7293	704	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	46536	0	6158-0	3019406		
18679	1719	3049273	2017-06-13	2017-06-13 00:00:00	2017-06-13	5001	0	\N	0	0	\N	\N	0	114975	0	38265-5	3049273		
18783	1727	3027970	1982-03-24	1982-03-24 00:00:00	1982-03-24	5001	0	\N	0	0	\N	\N	0	115482	0	10834-0	3027970		
39762	3695	3006451	1993-02-08	1993-02-08 00:00:00	1993-02-08	5001	0	\N	0	0	\N	\N	0	245611	0	6273-7	3006451		
10392	1015	46235214	2018-09-30	2018-09-30 00:00:00	2018-09-30	5001	0	\N	0	0	\N	\N	0	66840	0	76690-7	46235214		
10476	1016	3006322	1996-03-16	1996-03-16 00:00:00	1996-03-16	5001	0	\N	0	0	\N	\N	0	66897	0	8331-1	3006322		
41631	3874	3000876	1994-12-28	1994-12-28 00:00:00	1994-12-28	5001	0	\N	0	0	\N	\N	0	257207	0	6082-2	3000876		
204	5	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	486	0	6106-9	3014599		
18931	1740	3006322	1955-06-27	1955-06-27 00:00:00	1955-06-27	5001	0	\N	0	0	\N	\N	0	116235	0	8331-1	3006322		
2300	207	3006322	2008-04-06	2008-04-06 00:00:00	2008-04-06	5001	0	\N	0	0	\N	\N	0	14100	0	8331-1	3006322		
32415	2945	3011505	1990-10-30	1990-10-30 00:00:00	1990-10-30	5001	0	\N	0	0	\N	\N	0	196501	0	19926-5	3011505		
136053	4194	4024958	1984-04-03	1984-04-03 00:00:00	1984-04-03	5001	0	\N	0	0	\N	\N	0	278370	0	117015009	4024958		
23224	2136	3015076	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	142306	0	6248-9	3015076		
12585	1206	3019406	1988-02-28	1988-02-28 00:00:00	1988-02-28	5001	0	\N	0	0	\N	\N	0	79246	0	6158-0	3019406		
48912	4476	3036780	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	297826	0	6095-4	3036780		
46009	4241	3006322	1979-08-27	1979-08-27 00:00:00	1979-08-27	5001	0	\N	0	0	\N	\N	0	281700	0	8331-1	3006322		
60206	1840	4024958	1985-12-21	1985-12-21 00:00:00	1985-12-21	5001	0	\N	0	0	\N	\N	0	122797	0	117015009	4024958		
22353	2053	3051031	1964-08-23	1964-08-23 00:00:00	1964-08-23	5001	0	\N	0	0	\N	\N	0	136473	0	46240-8	3051031		
84310	2611	4024958	1954-12-14	1954-12-14 00:00:00	1954-12-14	5001	0	\N	0	0	\N	\N	0	172656	0	117015009	4024958		
26732	2463	3006322	1992-09-18	1992-09-18 00:00:00	1992-09-18	5001	0	\N	0	0	\N	\N	0	163385	0	8331-1	3006322		
137715	4243	4052083	2015-05-11	2015-05-11 00:00:00	2015-05-11	5001	0	\N	0	0	\N	\N	0	281861	0	23426006	4052083		
35031	3196	3006322	2006-04-26	2006-04-26 00:00:00	2006-04-26	5001	0	\N	0	0	\N	\N	0	212619	0	8331-1	3006322		
56714	5203	3006322	1947-01-24	1947-01-24 00:00:00	1947-01-24	5001	0	\N	0	0	\N	\N	0	346113	0	8331-1	3006322		
3977	399	3012494	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	26131	0	6206-7	3012494		
26885	842	4133840	1960-01-09	1960-01-09 00:00:00	1960-01-09	5001	0	\N	0	0	\N	\N	0	55758	0	127783003	4133840		
63229	1946	4052083	2017-10-20	2017-10-20 00:00:00	2017-10-20	5001	0	\N	0	0	\N	\N	0	129264	0	23426006	4052083		
22962	2108	3006322	1948-03-28	1948-03-28 00:00:00	1948-03-28	5001	0	\N	0	0	\N	\N	0	140393	0	8331-1	3006322		
59274	1804	4024958	1943-03-07	1943-03-07 00:00:00	1943-03-07	5001	0	\N	0	0	\N	\N	0	120826	0	117015009	4024958		
18032	1646	3049273	2012-03-22	2012-03-22 00:00:00	2012-03-22	5001	0	\N	0	0	\N	\N	0	110450	0	38265-5	3049273		
70853	2172	4024958	1985-05-06	1985-05-06 00:00:00	1985-05-06	5001	0	\N	0	0	\N	\N	0	144662	0	117015009	4024958		
13246	1261	3006322	1973-06-01	1973-06-01 00:00:00	1973-06-01	5001	0	\N	0	0	\N	\N	0	83246	0	8331-1	3006322		
19146	1753	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	117203	0	6085-5	3001247		
1356	117	3006322	1969-10-03	1969-10-03 00:00:00	1969-10-03	5001	0	\N	0	0	\N	\N	0	7774	0	8331-1	3006322		
57403	5267	40769194	1995-12-09	1995-12-09 00:00:00	1995-12-09	5001	0	\N	0	0	\N	\N	0	350362	0	66534-9	40769194		
139020	4284	4024958	1998-04-01	1998-04-01 00:00:00	1998-04-01	5001	0	\N	0	0	\N	\N	0	284394	0	117015009	4024958		
53348	4899	3051031	1921-12-28	1921-12-28 00:00:00	1921-12-28	5001	0	\N	0	0	\N	\N	0	325773	0	46240-8	3051031		
36887	3392	3006322	2006-09-26	2006-09-26 00:00:00	2006-09-26	5001	0	\N	0	0	\N	\N	0	224961	0	8331-1	3006322		
36274	1124	4024958	1965-03-19	1965-03-19 00:00:00	1965-03-19	5001	0	\N	0	0	\N	\N	0	74097	0	117015009	4024958		
18205	1658	3006322	1926-06-21	1926-06-21 00:00:00	1926-06-21	5001	0	\N	0	0	\N	\N	0	111342	0	8331-1	3006322		
26847	842	4052083	1992-01-28	1992-01-28 00:00:00	1992-01-28	5001	0	\N	0	0	\N	\N	0	55646	0	23426006	4052083		
11428	1091	3006322	2009-06-27	2009-06-27 00:00:00	2009-06-27	5001	0	\N	0	0	\N	\N	0	71703	0	8331-1	3006322		
37224	1150	4024958	1990-03-02	1990-03-02 00:00:00	1990-03-02	5001	0	\N	0	0	\N	\N	0	76030	0	117015009	4024958		
101932	3132	4024958	1974-08-22	1974-08-22 00:00:00	1974-08-22	5001	0	\N	0	0	\N	\N	0	208389	0	117015009	4024958		
31015	2834	3051031	1990-10-08	1990-10-08 00:00:00	1990-10-08	5001	0	\N	0	0	\N	\N	0	188193	0	46240-8	3051031		
31105	2843	3000963	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	188762	0	718-7	3000963		
58337	1776	4024958	1926-08-30	1926-08-30 00:00:00	1926-08-30	5001	0	\N	0	0	\N	\N	0	118777	0	117015009	4024958		
32928	2975	3005136	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	198625	0	6075-6	3005136		
27417	2540	40766240	1959-04-11	1959-04-11 00:00:00	1959-04-11	5001	0	\N	0	0	\N	\N	0	167992	0	63513-6	40766240		
953	79	40758406	1947-11-21	1947-11-21 00:00:00	1947-11-21	5001	0	\N	0	0	\N	\N	0	5358	0	55277-8	40758406		
9126	870	3051031	1961-03-07	1961-03-07 00:00:00	1961-03-07	5001	0	\N	0	0	\N	\N	0	57868	0	46240-8	3051031		
45350	1391	4052083	1961-02-02	1961-02-02 00:00:00	1961-02-02	5001	0	\N	0	0	\N	\N	0	92382	0	23426006	4052083		
50501	4608	3011505	1999-02-18	1999-02-18 00:00:00	1999-02-18	5001	0	\N	0	0	\N	\N	0	307018	0	19926-5	3011505		
23333	2150	3049273	1958-04-08	1958-04-08 00:00:00	1958-04-08	5001	0	\N	0	0	\N	\N	0	143148	0	38265-5	3049273		
31320	2863	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	190371	0	6106-9	3014599		
142263	4375	4024958	1957-12-04	1957-12-04 00:00:00	1957-12-04	5001	0	\N	0	0	\N	\N	0	290636	0	117015009	4024958		
7294	704	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	46536	0	6075-6	3005136		
18680	1719	3006322	1965-03-30	1965-03-30 00:00:00	1965-03-30	5001	0	\N	0	0	\N	\N	0	114942	0	8331-1	3006322		
18784	1727	3009542	1982-03-24	1982-03-24 00:00:00	1982-03-24	5001	0	\N	0	0	\N	\N	0	115482	0	20570-8	3009542		
39763	3695	3021226	1993-02-08	1993-02-08 00:00:00	1993-02-08	5001	0	\N	0	0	\N	\N	0	245611	0	6246-3	3021226		
10394	1015	40766240	2018-09-30	2018-09-30 00:00:00	2018-09-30	5001	0	\N	0	0	\N	\N	0	66840	0	63513-6	40766240		
10477	1016	3006322	2011-11-16	2011-11-16 00:00:00	2011-11-16	5001	0	\N	0	0	\N	\N	0	66920	0	8331-1	3006322		
41632	3874	3001247	1994-12-28	1994-12-28 00:00:00	1994-12-28	5001	0	\N	0	0	\N	\N	0	257207	0	6085-5	3001247		
205	5	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	486	0	6276-0	3027231		
18932	1740	46235214	1954-04-04	1954-04-04 00:00:00	1954-04-04	5001	0	\N	0	0	\N	\N	0	116303	0	76690-7	46235214		
2301	207	3049273	2011-04-10	2011-04-10 00:00:00	2011-04-10	5001	0	\N	0	0	\N	\N	0	14096	0	38265-5	3049273		
32416	2945	3011505	1984-07-10	1984-07-10 00:00:00	1984-07-10	5001	0	\N	0	0	\N	\N	0	196475	0	19926-5	3011505		
136056	4194	4052083	2012-06-18	2012-06-18 00:00:00	2012-06-18	5001	0	\N	0	0	\N	\N	0	278372	0	23426006	4052083		
23225	2136	3021226	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	142306	0	6246-3	3021226		
12586	1206	3012494	1988-02-28	1988-02-28 00:00:00	1988-02-28	5001	0	\N	0	0	\N	\N	0	79246	0	6206-7	3012494		
48913	4476	3000876	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	297826	0	6082-2	3000876		
46011	4243	3006322	1992-10-24	1992-10-24 00:00:00	1992-10-24	5001	0	\N	0	0	\N	\N	0	281826	0	8331-1	3006322		
60216	1840	4052083	2006-09-04	2006-09-04 00:00:00	2006-09-04	5001	0	\N	0	0	\N	\N	0	122800	0	23426006	4052083		
22354	2053	46235214	1964-08-23	1964-08-23 00:00:00	1964-08-23	5001	0	\N	0	0	\N	\N	0	136473	0	76690-7	46235214		
84317	2611	4024958	1953-11-06	1953-11-06 00:00:00	1953-11-06	5001	0	\N	0	0	\N	\N	0	172682	0	117015009	4024958		
26733	2463	3006322	2004-05-30	2004-05-30 00:00:00	2004-05-30	5001	0	\N	0	0	\N	\N	0	163391	0	8331-1	3006322		
137717	4243	4052083	1989-12-26	1989-12-26 00:00:00	1989-12-26	5001	0	\N	0	0	\N	\N	0	281850	0	23426006	4052083		
35032	3196	3006322	2012-09-14	2012-09-14 00:00:00	2012-09-14	5001	0	\N	0	0	\N	\N	0	212621	0	8331-1	3006322		
56721	5206	3006322	1999-06-23	1999-06-23 00:00:00	1999-06-23	5001	0	\N	0	0	\N	\N	0	346258	0	8331-1	3006322		
3978	399	3001247	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	26131	0	6085-5	3001247		
26887	842	4133840	1959-01-03	1959-01-03 00:00:00	1959-01-03	5001	0	\N	0	0	\N	\N	0	55742	0	127783003	4133840		
63235	1946	4024958	1963-10-18	1963-10-18 00:00:00	1963-10-18	5001	0	\N	0	0	\N	\N	0	129333	0	117015009	4024958		
22963	2109	3006322	1992-11-19	1992-11-19 00:00:00	1992-11-19	5001	0	\N	0	0	\N	\N	0	140407	0	8331-1	3006322		
59282	1804	4052083	1981-09-14	1981-09-14 00:00:00	1981-09-14	5001	0	\N	0	0	\N	\N	0	120893	0	23426006	4052083		
18033	1646	3006322	1967-05-31	1967-05-31 00:00:00	1967-05-31	5001	0	\N	0	0	\N	\N	0	110370	0	8331-1	3006322		
154186	4725	4024958	1977-05-11	1977-05-11 00:00:00	1977-05-11	5001	0	\N	0	0	\N	\N	0	314868	0	117015009	4024958		
24524	2261	3051031	1966-07-27	1966-07-27 00:00:00	1966-07-27	5001	0	\N	0	0	\N	\N	0	150313	0	46240-8	3051031		
19147	1753	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	117203	0	7258-7	3001488		
35980	3311	3001488	1993-10-01	1993-10-01 00:00:00	1993-10-01	5001	0	\N	0	0	\N	\N	0	219768	0	7258-7	3001488		
57404	5267	40769179	1995-12-09	1995-12-09 00:00:00	1995-12-09	5001	0	\N	0	0	\N	\N	0	350362	0	66519-0	40769179		
139025	4284	4052083	1979-12-29	1979-12-29 00:00:00	1979-12-29	5001	0	\N	0	0	\N	\N	0	284327	0	23426006	4052083		
53350	4899	40758406	1921-12-28	1921-12-28 00:00:00	1921-12-28	5001	0	\N	0	0	\N	\N	0	325773	0	55277-8	40758406		
36888	3392	3006322	1987-03-14	1987-03-14 00:00:00	1987-03-14	5001	0	\N	0	0	\N	\N	0	224976	0	8331-1	3006322		
116572	3592	4024958	1966-05-23	1966-05-23 00:00:00	1966-05-23	5001	0	\N	0	0	\N	\N	0	238584	0	117015009	4024958		
18206	1658	3006322	1989-09-03	1989-09-03 00:00:00	1989-09-03	5001	0	\N	0	0	\N	\N	0	111344	0	8331-1	3006322		
26848	842	4133840	1997-07-12	1997-07-12 00:00:00	1997-07-12	5001	0	\N	0	0	\N	\N	0	55697	0	127783003	4133840		
11429	1091	3006322	1987-01-16	1987-01-16 00:00:00	1987-01-16	5001	0	\N	0	0	\N	\N	0	71596	0	8331-1	3006322		
37229	1150	4024958	1977-05-15	1977-05-15 00:00:00	1977-05-15	5001	0	\N	0	0	\N	\N	0	76066	0	117015009	4024958		
101948	3132	4024958	1971-10-26	1971-10-26 00:00:00	1971-10-26	5001	0	\N	0	0	\N	\N	0	208388	0	117015009	4024958		
31016	2834	46235214	1990-10-08	1990-10-08 00:00:00	1990-10-08	5001	0	\N	0	0	\N	\N	0	188193	0	76690-7	46235214		
31106	2843	3009542	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	188762	0	20570-8	3009542		
102752	3159	4024958	2004-01-12	2004-01-12 00:00:00	2004-01-12	5001	0	\N	0	0	\N	\N	0	210040	0	117015009	4024958		
32929	2975	3006451	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	198625	0	6273-7	3006451		
27418	2540	46235214	1959-04-11	1959-04-11 00:00:00	1959-04-11	5001	0	\N	0	0	\N	\N	0	167992	0	76690-7	46235214		
954	79	3051031	1947-11-21	1947-11-21 00:00:00	1947-11-21	5001	0	\N	0	0	\N	\N	0	5358	0	46240-8	3051031		
9128	870	40766240	1961-03-07	1961-03-07 00:00:00	1961-03-07	5001	0	\N	0	0	\N	\N	0	57868	0	63513-6	40766240		
45353	1391	4024958	1954-08-14	1954-08-14 00:00:00	1954-08-14	5001	0	\N	0	0	\N	\N	0	92345	0	117015009	4024958		
50502	4608	3011505	2014-02-06	2014-02-06 00:00:00	2014-02-06	5001	0	\N	0	0	\N	\N	0	307091	0	19926-5	3011505		
23334	2150	3006322	1973-09-09	1973-09-09 00:00:00	1973-09-09	5001	0	\N	0	0	\N	\N	0	143176	0	8331-1	3006322		
31321	2863	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	190371	0	7258-7	3001488		
142265	4375	4052083	1976-10-27	1976-10-27 00:00:00	1976-10-27	5001	0	\N	0	0	\N	\N	0	290639	0	23426006	4052083		
7295	704	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	46536	0	7258-7	3001488		
18681	1720	3006322	1980-02-27	1980-02-27 00:00:00	1980-02-27	5001	0	\N	0	0	\N	\N	0	115028	0	8331-1	3006322		
18785	1727	3028833	1982-03-24	1982-03-24 00:00:00	1982-03-24	5001	0	\N	0	0	\N	\N	0	115482	0	42719-5	3028833		
39764	3695	3027231	1993-02-08	1993-02-08 00:00:00	1993-02-08	5001	0	\N	0	0	\N	\N	0	245611	0	6276-0	3027231		
10395	1015	3006322	1959-06-01	1959-06-01 00:00:00	1959-06-01	5001	0	\N	0	0	\N	\N	0	66817	0	8331-1	3006322		
10478	1017	3006322	1995-11-19	1995-11-19 00:00:00	1995-11-19	5001	0	\N	0	0	\N	\N	0	66930	0	8331-1	3006322		
41633	3874	3001488	1994-12-28	1994-12-28 00:00:00	1994-12-28	5001	0	\N	0	0	\N	\N	0	257207	0	7258-7	3001488		
206	5	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	486	0	6095-4	3036780		
18933	1740	3051031	1954-04-04	1954-04-04 00:00:00	1954-04-04	5001	0	\N	0	0	\N	\N	0	116303	0	46240-8	3051031		
2302	207	3049273	2009-07-25	2009-07-25 00:00:00	2009-07-25	5001	0	\N	0	0	\N	\N	0	14132	0	38265-5	3049273		
32417	2945	3011505	1967-09-19	1967-09-19 00:00:00	1967-09-19	5001	0	\N	0	0	\N	\N	0	196537	0	19926-5	3011505		
1495	129	3006322	1993-08-01	1993-08-01 00:00:00	1993-08-01	5001	0	\N	0	0	\N	\N	0	8674	0	8331-1	3006322		
23226	2136	3012494	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	142306	0	6206-7	3012494		
12587	1206	3021226	1988-02-28	1988-02-28 00:00:00	1988-02-28	5001	0	\N	0	0	\N	\N	0	79246	0	6246-3	3021226		
48914	4476	3006734	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	297826	0	6189-5	3006734		
46012	4243	3006322	1970-09-07	1970-09-07 00:00:00	1970-09-07	5001	0	\N	0	0	\N	\N	0	281839	0	8331-1	3006322		
60218	1840	4052083	2016-02-17	2016-02-17 00:00:00	2016-02-17	5001	0	\N	0	0	\N	\N	0	122825	0	23426006	4052083		
22355	2053	40766240	1964-08-23	1964-08-23 00:00:00	1964-08-23	5001	0	\N	0	0	\N	\N	0	136473	0	63513-6	40766240		
84325	2611	4024958	2002-03-15	2002-03-15 00:00:00	2002-03-15	5001	0	\N	0	0	\N	\N	0	172668	0	117015009	4024958		
26734	2463	3006322	2011-06-05	2011-06-05 00:00:00	2011-06-05	5001	0	\N	0	0	\N	\N	0	163365	0	8331-1	3006322		
92447	2849	4024958	2003-03-02	2003-03-02 00:00:00	2003-03-02	5001	0	\N	0	0	\N	\N	0	189272	0	117015009	4024958		
35036	3199	3006322	2010-07-04	2010-07-04 00:00:00	2010-07-04	5001	0	\N	0	0	\N	\N	0	212742	0	8331-1	3006322		
56722	5206	3006322	1995-11-15	1995-11-15 00:00:00	1995-11-15	5001	0	\N	0	0	\N	\N	0	346271	0	8331-1	3006322		
3979	399	3023430	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	26131	0	6833-8	3023430		
26889	842	4133840	2001-08-04	2001-08-04 00:00:00	2001-08-04	5001	0	\N	0	0	\N	\N	0	55671	0	127783003	4133840		
63236	1946	4024958	1926-07-25	1926-07-25 00:00:00	1926-07-25	5001	0	\N	0	0	\N	\N	0	129256	0	117015009	4024958		
22964	2109	3006322	2017-02-28	2017-02-28 00:00:00	2017-02-28	5001	0	\N	0	0	\N	\N	0	140447	0	8331-1	3006322		
18034	1646	3006322	2008-09-12	2008-09-12 00:00:00	2008-09-12	5001	0	\N	0	0	\N	\N	0	110374	0	8331-1	3006322		
154229	4729	4052083	1984-12-27	1984-12-27 00:00:00	1984-12-27	5001	0	\N	0	0	\N	\N	0	315098	0	23426006	4052083		
24526	2261	40766240	1965-01-03	1965-01-03 00:00:00	1965-01-03	5001	0	\N	0	0	\N	\N	0	150342	0	63513-6	40766240		
19148	1753	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	117203	0	6248-9	3015076		
35981	3311	3001247	1993-10-01	1993-10-01 00:00:00	1993-10-01	5001	0	\N	0	0	\N	\N	0	219768	0	6085-5	3001247		
57405	5267	40769189	1995-12-09	1995-12-09 00:00:00	1995-12-09	5001	0	\N	0	0	\N	\N	0	350362	0	66529-9	40769189		
139028	4284	4052083	1965-11-04	1965-11-04 00:00:00	1965-11-04	5001	0	\N	0	0	\N	\N	0	284381	0	23426006	4052083		
53351	4899	40766240	1921-12-28	1921-12-28 00:00:00	1921-12-28	5001	0	\N	0	0	\N	\N	0	325773	0	63513-6	40766240		
36889	3392	3006322	2005-09-19	2005-09-19 00:00:00	2005-09-19	5001	0	\N	0	0	\N	\N	0	224960	0	8331-1	3006322		
116579	3592	4052083	2007-04-01	2007-04-01 00:00:00	2007-04-01	5001	0	\N	0	0	\N	\N	0	238571	0	23426006	4052083		
18207	1658	3049273	1989-05-01	1989-05-01 00:00:00	1989-05-01	5001	0	\N	0	0	\N	\N	0	111379	0	38265-5	3049273		
26850	842	4133840	1980-01-05	1980-01-05 00:00:00	1980-01-05	5001	0	\N	0	0	\N	\N	0	55664	0	127783003	4133840		
11430	1092	3006322	1989-04-21	1989-04-21 00:00:00	1989-04-21	5001	0	\N	0	0	\N	\N	0	71752	0	8331-1	3006322		
48520	1478	4024958	1966-01-11	1966-01-11 00:00:00	1966-01-11	5001	0	\N	0	0	\N	\N	0	98629	0	117015009	4024958		
101956	3132	4024958	1995-05-05	1995-05-05 00:00:00	1995-05-05	5001	0	\N	0	0	\N	\N	0	208430	0	117015009	4024958		
31019	2834	40758406	1991-09-03	1991-09-03 00:00:00	1991-09-03	5001	0	\N	0	0	\N	\N	0	188145	0	55277-8	40758406		
31107	2844	3006322	2002-02-04	2002-02-04 00:00:00	2002-02-04	5001	0	\N	0	0	\N	\N	0	188871	0	8331-1	3006322		
102754	3159	4024958	1966-01-02	1966-01-02 00:00:00	1966-01-02	5001	0	\N	0	0	\N	\N	0	210021	0	117015009	4024958		
32930	2975	3012494	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	198625	0	6206-7	3012494		
27420	2540	3051031	1959-04-11	1959-04-11 00:00:00	1959-04-11	5001	0	\N	0	0	\N	\N	0	167992	0	46240-8	3051031		
955	79	46235214	1947-11-21	1947-11-21 00:00:00	1947-11-21	5001	0	\N	0	0	\N	\N	0	5358	0	76690-7	46235214		
9129	870	46235214	1961-03-07	1961-03-07 00:00:00	1961-03-07	5001	0	\N	0	0	\N	\N	0	57868	0	76690-7	46235214		
45356	1391	4052083	1954-01-25	1954-01-25 00:00:00	1954-01-25	5001	0	\N	0	0	\N	\N	0	92322	0	23426006	4052083		
50503	4608	3006322	1976-06-11	1976-06-11 00:00:00	1976-06-11	5001	0	\N	0	0	\N	\N	0	306934	0	8331-1	3006322		
23335	2150	3006322	2017-08-30	2017-08-30 00:00:00	2017-08-30	5001	0	\N	0	0	\N	\N	0	143179	0	8331-1	3006322		
31322	2863	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	190371	0	6248-9	3015076		
142271	4375	4052083	1936-03-12	1936-03-12 00:00:00	1936-03-12	5001	0	\N	0	0	\N	\N	0	290633	0	23426006	4052083		
7296	704	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	46536	0	6189-5	3006734		
62835	1928	4052083	1997-09-23	1997-09-23 00:00:00	1997-09-23	5001	0	\N	0	0	\N	\N	0	128370	0	23426006	4052083		
18786	1727	3016723	1982-03-24	1982-03-24 00:00:00	1982-03-24	5001	0	\N	0	0	\N	\N	0	115482	0	2160-0	3016723		
39765	3695	3019406	1993-02-08	1993-02-08 00:00:00	1993-02-08	5001	0	\N	0	0	\N	\N	0	245611	0	6158-0	3019406		
10396	1015	40758406	2018-08-01	2018-08-01 00:00:00	2018-08-01	5001	0	\N	0	0	\N	\N	0	66851	0	55277-8	40758406		
10479	1017	3006322	1966-10-15	1966-10-15 00:00:00	1966-10-15	5001	0	\N	0	0	\N	\N	0	66988	0	8331-1	3006322		
41634	3874	3006451	1994-12-28	1994-12-28 00:00:00	1994-12-28	5001	0	\N	0	0	\N	\N	0	257207	0	6273-7	3006451		
207	5	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	486	0	6246-3	3021226		
18934	1740	40758406	1954-04-04	1954-04-04 00:00:00	1954-04-04	5001	0	\N	0	0	\N	\N	0	116303	0	55277-8	40758406		
2303	207	3006322	1940-12-20	1940-12-20 00:00:00	1940-12-20	5001	0	\N	0	0	\N	\N	0	14115	0	8331-1	3006322		
32418	2945	3011505	1998-08-04	1998-08-04 00:00:00	1998-08-04	5001	0	\N	0	0	\N	\N	0	196494	0	19926-5	3011505		
1496	129	3006322	1996-12-23	1996-12-23 00:00:00	1996-12-23	5001	0	\N	0	0	\N	\N	0	8675	0	8331-1	3006322		
23227	2136	3019406	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	142306	0	6158-0	3019406		
12588	1206	3014599	1988-02-28	1988-02-28 00:00:00	1988-02-28	5001	0	\N	0	0	\N	\N	0	79246	0	6106-9	3014599		
48915	4476	3020655	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	297826	0	6844-5	3020655		
46013	4243	3006322	1999-11-07	1999-11-07 00:00:00	1999-11-07	5001	0	\N	0	0	\N	\N	0	281828	0	8331-1	3006322		
24429	2256	3006322	2004-11-18	2004-11-18 00:00:00	2004-11-18	5001	0	\N	0	0	\N	\N	0	149906	0	8331-1	3006322		
22357	2053	3049273	2010-03-24	2010-03-24 00:00:00	2010-03-24	5001	0	\N	0	0	\N	\N	0	136571	0	38265-5	3049273		
84332	2611	4024958	2008-08-26	2008-08-26 00:00:00	2008-08-26	5001	0	\N	0	0	\N	\N	0	172669	0	117015009	4024958		
35615	3253	3006322	1972-04-09	1972-04-09 00:00:00	1972-04-09	5001	0	\N	0	0	\N	\N	0	216329	0	8331-1	3006322		
92449	2849	4052083	1933-01-13	1933-01-13 00:00:00	1933-01-13	5001	0	\N	0	0	\N	\N	0	189276	0	23426006	4052083		
35037	3199	3006322	2015-07-17	2015-07-17 00:00:00	2015-07-17	5001	0	\N	0	0	\N	\N	0	212738	0	8331-1	3006322		
56723	5206	3006322	1996-04-26	1996-04-26 00:00:00	1996-04-26	5001	0	\N	0	0	\N	\N	0	346257	0	8331-1	3006322		
3980	399	3020655	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	26131	0	6844-5	3020655		
26892	842	4133840	2009-09-19	2009-09-19 00:00:00	2009-09-19	5001	0	\N	0	0	\N	\N	0	55690	0	127783003	4133840		
63240	1946	4024958	1973-01-16	1973-01-16 00:00:00	1973-01-16	5001	0	\N	0	0	\N	\N	0	129273	0	117015009	4024958		
22965	2109	3006322	1974-02-01	1974-02-01 00:00:00	1974-02-01	5001	0	\N	0	0	\N	\N	0	140445	0	8331-1	3006322		
18035	1646	3006322	2018-10-06	2018-10-06 00:00:00	2018-10-06	5001	0	\N	0	0	\N	\N	0	110375	0	8331-1	3006322		
154233	4729	4052083	1980-05-03	1980-05-03 00:00:00	1980-05-03	5001	0	\N	0	0	\N	\N	0	315085	0	23426006	4052083		
24527	2261	40758406	1965-01-03	1965-01-03 00:00:00	1965-01-03	5001	0	\N	0	0	\N	\N	0	150342	0	55277-8	40758406		
19149	1753	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	117203	0	6206-7	3012494		
35982	3311	3036780	1993-10-01	1993-10-01 00:00:00	1993-10-01	5001	0	\N	0	0	\N	\N	0	219768	0	6095-4	3036780		
57406	5268	3006322	1984-03-22	1984-03-22 00:00:00	1984-03-22	5001	0	\N	0	0	\N	\N	0	350501	0	8331-1	3006322		
139029	4284	4024958	1964-01-07	1964-01-07 00:00:00	1964-01-07	5001	0	\N	0	0	\N	\N	0	284401	0	117015009	4024958		
53352	4899	46235214	1921-12-28	1921-12-28 00:00:00	1921-12-28	5001	0	\N	0	0	\N	\N	0	325773	0	76690-7	46235214		
101632	3123	4024958	2013-07-31	2013-07-31 00:00:00	2013-07-31	5001	0	\N	0	0	\N	\N	0	207836	0	117015009	4024958		
116581	3592	4024958	1967-07-31	1967-07-31 00:00:00	1967-07-31	5001	0	\N	0	0	\N	\N	0	238585	0	117015009	4024958		
18208	1658	3006322	1925-03-16	1925-03-16 00:00:00	1925-03-16	5001	0	\N	0	0	\N	\N	0	111384	0	8331-1	3006322		
107097	3301	4024958	1976-08-02	1976-08-02 00:00:00	1976-08-02	5001	0	\N	0	0	\N	\N	0	219331	0	117015009	4024958		
11431	1092	3006322	2010-03-17	2010-03-17 00:00:00	2010-03-17	5001	0	\N	0	0	\N	\N	0	71823	0	8331-1	3006322		
111907	3456	4024958	1982-03-03	1982-03-03 00:00:00	1982-03-03	5001	0	\N	0	0	\N	\N	0	229288	0	117015009	4024958		
101961	3132	4052083	1967-07-18	1967-07-18 00:00:00	1967-07-18	5001	0	\N	0	0	\N	\N	0	208404	0	23426006	4052083		
31020	2834	3051031	1991-09-03	1991-09-03 00:00:00	1991-09-03	5001	0	\N	0	0	\N	\N	0	188145	0	46240-8	3051031		
31108	2844	3006322	1981-05-15	1981-05-15 00:00:00	1981-05-15	5001	0	\N	0	0	\N	\N	0	188812	0	8331-1	3006322		
92768	2858	4052083	1977-03-02	1977-03-02 00:00:00	1977-03-02	5001	0	\N	0	0	\N	\N	0	189744	0	23426006	4052083		
32931	2975	3023430	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	198625	0	6833-8	3023430		
27421	2540	40758406	1959-04-11	1959-04-11 00:00:00	1959-04-11	5001	0	\N	0	0	\N	\N	0	167992	0	55277-8	40758406		
956	79	40766240	1947-11-21	1947-11-21 00:00:00	1947-11-21	5001	0	\N	0	0	\N	\N	0	5358	0	63513-6	40766240		
9241	877	3027231	1990-05-08	1990-05-08 00:00:00	1990-05-08	5001	0	\N	0	0	\N	\N	0	58446	0	6276-0	3027231		
45368	1391	4024958	1927-08-14	1927-08-14 00:00:00	1927-08-14	5001	0	\N	0	0	\N	\N	0	92310	0	117015009	4024958		
50504	4608	3011505	2006-12-28	2006-12-28 00:00:00	2006-12-28	5001	0	\N	0	0	\N	\N	0	307090	0	19926-5	3011505		
23336	2150	3006322	1977-04-07	1977-04-07 00:00:00	1977-04-07	5001	0	\N	0	0	\N	\N	0	143169	0	8331-1	3006322		
31323	2863	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	190371	0	6276-0	3027231		
14970	1387	3006322	1978-09-15	1978-09-15 00:00:00	1978-09-15	5001	0	\N	0	0	\N	\N	0	91995	0	8331-1	3006322		
7297	704	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	46536	0	6844-5	3020655		
157964	4852	4052083	1967-10-29	1967-10-29 00:00:00	1967-10-29	5001	0	\N	0	0	\N	\N	0	322849	0	23426006	4052083		
129068	3972	4024958	1964-07-30	1964-07-30 00:00:00	1964-07-30	5001	0	\N	0	0	\N	\N	0	264158	0	117015009	4024958		
39766	3695	3006322	2013-05-12	2013-05-12 00:00:00	2013-05-12	5001	0	\N	0	0	\N	\N	0	245581	0	8331-1	3006322		
10397	1015	40766240	2018-08-01	2018-08-01 00:00:00	2018-08-01	5001	0	\N	0	0	\N	\N	0	66851	0	63513-6	40766240		
10480	1017	3006322	1995-10-09	1995-10-09 00:00:00	1995-10-09	5001	0	\N	0	0	\N	\N	0	67006	0	8331-1	3006322		
41635	3874	3015076	1994-12-28	1994-12-28 00:00:00	1994-12-28	5001	0	\N	0	0	\N	\N	0	257207	0	6248-9	3015076		
208	5	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	486	0	6206-7	3012494		
18935	1740	40766240	1954-04-04	1954-04-04 00:00:00	1954-04-04	5001	0	\N	0	0	\N	\N	0	116303	0	63513-6	40766240		
2304	207	3006322	2018-08-09	2018-08-09 00:00:00	2018-08-09	5001	0	\N	0	0	\N	\N	0	14106	0	8331-1	3006322		
32419	2945	3011505	1981-07-07	1981-07-07 00:00:00	1981-07-07	5001	0	\N	0	0	\N	\N	0	196474	0	19926-5	3011505		
1497	129	3006322	2004-10-04	2004-10-04 00:00:00	2004-10-04	5001	0	\N	0	0	\N	\N	0	8712	0	8331-1	3006322		
23228	2136	3000876	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	142306	0	6082-2	3000876		
12589	1206	3006451	1988-02-28	1988-02-28 00:00:00	1988-02-28	5001	0	\N	0	0	\N	\N	0	79246	0	6273-7	3006451		
48916	4476	3001247	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	297826	0	6085-5	3001247		
46014	4243	3006322	2018-03-15	2018-03-15 00:00:00	2018-03-15	5001	0	\N	0	0	\N	\N	0	281816	0	8331-1	3006322		
24430	2256	3006322	1993-05-12	1993-05-12 00:00:00	1993-05-12	5001	0	\N	0	0	\N	\N	0	149917	0	8331-1	3006322		
22358	2053	3006322	1965-12-30	1965-12-30 00:00:00	1965-12-30	5001	0	\N	0	0	\N	\N	0	136474	0	8331-1	3006322		
84368	2613	4052083	1990-11-19	1990-11-19 00:00:00	1990-11-19	5001	0	\N	0	0	\N	\N	0	172768	0	23426006	4052083		
35616	3253	3006322	2005-09-19	2005-09-19 00:00:00	2005-09-19	5001	0	\N	0	0	\N	\N	0	216295	0	8331-1	3006322		
45152	4167	3005136	1995-03-29	1995-03-29 00:00:00	1995-03-29	5001	0	\N	0	0	\N	\N	0	276898	0	6075-6	3005136		
35038	3199	3006322	1976-03-17	1976-03-17 00:00:00	1976-03-17	5001	0	\N	0	0	\N	\N	0	212760	0	8331-1	3006322		
56724	5206	3006322	1985-10-27	1985-10-27 00:00:00	1985-10-27	5001	0	\N	0	0	\N	\N	0	346264	0	8331-1	3006322		
3981	399	3027231	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	26131	0	6276-0	3027231		
26893	842	4133840	2013-10-12	2013-10-12 00:00:00	2013-10-12	5001	0	\N	0	0	\N	\N	0	55684	0	127783003	4133840		
63241	1946	4052083	1953-12-19	1953-12-19 00:00:00	1953-12-19	5001	0	\N	0	0	\N	\N	0	129316	0	23426006	4052083		
22966	2109	3006322	1985-11-11	1985-11-11 00:00:00	1985-11-11	5001	0	\N	0	0	\N	\N	0	140411	0	8331-1	3006322		
55781	1699	4024958	1973-02-12	1973-02-12 00:00:00	1973-02-12	5001	0	\N	0	0	\N	\N	0	113645	0	117015009	4024958		
154245	4729	4024958	1973-10-08	1973-10-08 00:00:00	1973-10-08	5001	0	\N	0	0	\N	\N	0	315083	0	117015009	4024958		
24529	2261	3051031	1965-01-03	1965-01-03 00:00:00	1965-01-03	5001	0	\N	0	0	\N	\N	0	150342	0	46240-8	3051031		
19150	1753	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	117203	0	6844-5	3020655		
35983	3311	3006734	1993-10-01	1993-10-01 00:00:00	1993-10-01	5001	0	\N	0	0	\N	\N	0	219768	0	6189-5	3006734		
57408	5272	3006322	1918-05-14	1918-05-14 00:00:00	1918-05-14	5001	0	\N	0	0	\N	\N	0	350651	0	8331-1	3006322		
139039	4284	4052083	1996-01-31	1996-01-31 00:00:00	1996-01-31	5001	0	\N	0	0	\N	\N	0	284330	0	23426006	4052083		
53353	4899	40758406	1922-04-27	1922-04-27 00:00:00	1922-04-27	5001	0	\N	0	0	\N	\N	0	325764	0	55277-8	40758406		
101653	3123	4024958	2015-01-03	2015-01-03 00:00:00	2015-01-03	5001	0	\N	0	0	\N	\N	0	207799	0	117015009	4024958		
116589	3593	4024958	1985-01-02	1985-01-02 00:00:00	1985-01-02	5001	0	\N	0	0	\N	\N	0	238670	0	117015009	4024958		
18209	1658	3006322	2001-01-01	2001-01-01 00:00:00	2001-01-01	5001	0	\N	0	0	\N	\N	0	111345	0	8331-1	3006322		
107103	3301	4024958	1954-02-07	1954-02-07 00:00:00	1954-02-07	5001	0	\N	0	0	\N	\N	0	219305	0	117015009	4024958		
11432	1092	3006322	1969-02-09	1969-02-09 00:00:00	1969-02-09	5001	0	\N	0	0	\N	\N	0	71816	0	8331-1	3006322		
111952	3457	4052083	2011-04-18	2011-04-18 00:00:00	2011-04-18	5001	0	\N	0	0	\N	\N	0	229332	0	23426006	4052083		
101963	3132	4024958	1983-09-20	1983-09-20 00:00:00	1983-09-20	5001	0	\N	0	0	\N	\N	0	208391	0	117015009	4024958		
31021	2834	46235214	1991-09-03	1991-09-03 00:00:00	1991-09-03	5001	0	\N	0	0	\N	\N	0	188145	0	76690-7	46235214		
31109	2844	3049273	2018-07-02	2018-07-02 00:00:00	2018-07-02	5001	0	\N	0	0	\N	\N	0	188899	0	38265-5	3049273		
92795	2858	4052083	2010-05-30	2010-05-30 00:00:00	2010-05-30	5001	0	\N	0	0	\N	\N	0	189958	0	23426006	4052083		
32932	2975	3001247	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	198625	0	6085-5	3001247		
27422	2541	3006322	1984-10-13	1984-10-13 00:00:00	1984-10-13	5001	0	\N	0	0	\N	\N	0	168050	0	8331-1	3006322		
959	79	3051031	1947-09-23	1947-09-23 00:00:00	1947-09-23	5001	0	\N	0	0	\N	\N	0	5249	0	46240-8	3051031		
9242	877	3019406	1990-05-08	1990-05-08 00:00:00	1990-05-08	5001	0	\N	0	0	\N	\N	0	58446	0	6158-0	3019406		
125720	3876	4024958	1981-06-22	1981-06-22 00:00:00	1981-06-22	5001	0	\N	0	0	\N	\N	0	257451	0	117015009	4024958		
50505	4608	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	307083	0	6248-9	3015076		
23337	2150	3049273	2003-10-19	2003-10-19 00:00:00	2003-10-19	5001	0	\N	0	0	\N	\N	0	143152	0	38265-5	3049273		
31324	2863	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	190371	0	6082-2	3000876		
14971	1387	3006322	1995-11-24	1995-11-24 00:00:00	1995-11-24	5001	0	\N	0	0	\N	\N	0	92089	0	8331-1	3006322		
7298	704	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	46536	0	6833-8	3023430		
157980	4852	4052083	1962-12-15	1962-12-15 00:00:00	1962-12-15	5001	0	\N	0	0	\N	\N	0	322785	0	23426006	4052083		
129076	3972	4052083	2018-05-27	2018-05-27 00:00:00	2018-05-27	5001	0	\N	0	0	\N	\N	0	264098	0	23426006	4052083		
39767	3695	3035995	1996-03-20	1996-03-20 00:00:00	1996-03-20	5001	0	\N	0	0	\N	\N	0	245605	0	6768-6	3035995		
10399	1015	3051031	2018-08-01	2018-08-01 00:00:00	2018-08-01	5001	0	\N	0	0	\N	\N	0	66851	0	46240-8	3051031		
10481	1017	3000963	1964-06-13	1964-06-13 00:00:00	1964-06-13	5001	0	\N	0	0	\N	\N	0	67005	0	718-7	3000963		
41636	3874	3012494	1994-12-28	1994-12-28 00:00:00	1994-12-28	5001	0	\N	0	0	\N	\N	0	257207	0	6206-7	3012494		
209	5	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	486	0	6085-5	3001247		
18938	1740	46235214	1953-12-05	1953-12-05 00:00:00	1953-12-05	5001	0	\N	0	0	\N	\N	0	116260	0	76690-7	46235214		
2305	207	3006322	2010-06-11	2010-06-11 00:00:00	2010-06-11	5001	0	\N	0	0	\N	\N	0	14105	0	8331-1	3006322		
32420	2945	3011505	2010-01-19	2010-01-19 00:00:00	2010-01-19	5001	0	\N	0	0	\N	\N	0	196518	0	19926-5	3011505		
1498	129	3006322	2002-09-07	2002-09-07 00:00:00	2002-09-07	5001	0	\N	0	0	\N	\N	0	8672	0	8331-1	3006322		
23229	2136	3036780	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	142306	0	6095-4	3036780		
12590	1206	3027231	1988-02-28	1988-02-28 00:00:00	1988-02-28	5001	0	\N	0	0	\N	\N	0	79246	0	6276-0	3027231		
48917	4476	3027231	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	297826	0	6276-0	3027231		
46015	4243	3006322	1998-09-01	1998-09-01 00:00:00	1998-09-01	5001	0	\N	0	0	\N	\N	0	281840	0	8331-1	3006322		
24431	2256	3006322	1989-05-17	1989-05-17 00:00:00	1989-05-17	5001	0	\N	0	0	\N	\N	0	149961	0	8331-1	3006322		
22360	2053	3051031	1964-10-22	1964-10-22 00:00:00	1964-10-22	5001	0	\N	0	0	\N	\N	0	136512	0	46240-8	3051031		
61756	1892	4133840	2009-05-21	2009-05-21 00:00:00	2009-05-21	5001	0	\N	0	0	\N	\N	0	126013	0	127783003	4133840		
35617	3253	40769184	1972-05-17	1972-05-17 00:00:00	1972-05-17	5001	0	\N	0	0	\N	\N	0	216330	0	66524-0	40769184		
45153	4167	3015076	1995-03-29	1995-03-29 00:00:00	1995-03-29	5001	0	\N	0	0	\N	\N	0	276898	0	6248-9	3015076		
35039	3200	3006322	1951-02-12	1951-02-12 00:00:00	1951-02-12	5001	0	\N	0	0	\N	\N	0	212830	0	8331-1	3006322		
3982	399	3006451	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	26131	0	6273-7	3006451		
26895	842	4133840	1991-06-08	1991-06-08 00:00:00	1991-06-08	5001	0	\N	0	0	\N	\N	0	55740	0	127783003	4133840		
63260	1946	4052083	1985-07-21	1985-07-21 00:00:00	1985-07-21	5001	0	\N	0	0	\N	\N	0	129274	0	23426006	4052083		
12256	1169	3006322	1975-09-09	1975-09-09 00:00:00	1975-09-09	5001	0	\N	0	0	\N	\N	0	76961	0	8331-1	3006322		
55847	1702	4024958	1967-04-22	1967-04-22 00:00:00	1967-04-22	5001	0	\N	0	0	\N	\N	0	113786	0	117015009	4024958		
35128	3212	3016723	2018-07-21	2018-07-21 00:00:00	2018-07-21	5001	0	\N	0	0	\N	\N	0	213430	0	2160-0	3016723		
24530	2261	46235214	1965-01-03	1965-01-03 00:00:00	1965-01-03	5001	0	\N	0	0	\N	\N	0	150342	0	76690-7	46235214		
19151	1753	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	117203	0	6833-8	3023430		
35984	3311	3000876	1993-10-01	1993-10-01 00:00:00	1993-10-01	5001	0	\N	0	0	\N	\N	0	219768	0	6082-2	3000876		
57409	5272	3006322	2014-01-27	2014-01-27 00:00:00	2014-01-27	5001	0	\N	0	0	\N	\N	0	350633	0	8331-1	3006322		
139040	4284	4024958	1947-03-14	1947-03-14 00:00:00	1947-03-14	5001	0	\N	0	0	\N	\N	0	284325	0	117015009	4024958		
53354	4899	46235214	1922-04-27	1922-04-27 00:00:00	1922-04-27	5001	0	\N	0	0	\N	\N	0	325764	0	76690-7	46235214		
101654	3123	4052083	2016-10-06	2016-10-06 00:00:00	2016-10-06	5001	0	\N	0	0	\N	\N	0	207837	0	23426006	4052083		
116594	3593	4024958	1966-09-08	1966-09-08 00:00:00	1966-09-08	5001	0	\N	0	0	\N	\N	0	238717	0	117015009	4024958		
18210	1658	3009542	1912-04-30	1912-04-30 00:00:00	1912-04-30	5001	0	\N	0	0	\N	\N	0	111353	0	20570-8	3009542		
107109	3301	4024958	1949-08-21	1949-08-21 00:00:00	1949-08-21	5001	0	\N	0	0	\N	\N	0	219263	0	117015009	4024958		
11433	1092	3006322	1966-08-24	1966-08-24 00:00:00	1966-08-24	5001	0	\N	0	0	\N	\N	0	71814	0	8331-1	3006322		
111954	3457	4052083	1919-06-19	1919-06-19 00:00:00	1919-06-19	5001	0	\N	0	0	\N	\N	0	229396	0	23426006	4052083		
101970	3133	4024958	1987-06-10	1987-06-10 00:00:00	1987-06-10	5001	0	\N	0	0	\N	\N	0	208470	0	117015009	4024958		
31022	2834	40766240	1991-09-03	1991-09-03 00:00:00	1991-09-03	5001	0	\N	0	0	\N	\N	0	188145	0	63513-6	40766240		
31110	2844	3006322	2002-09-19	2002-09-19 00:00:00	2002-09-19	5001	0	\N	0	0	\N	\N	0	188814	0	8331-1	3006322		
92801	2858	4024958	1962-04-23	1962-04-23 00:00:00	1962-04-23	5001	0	\N	0	0	\N	\N	0	189741	0	117015009	4024958		
32933	2975	3020655	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	198641	0	6844-5	3020655		
27423	2541	3006322	2000-06-05	2000-06-05 00:00:00	2000-06-05	5001	0	\N	0	0	\N	\N	0	168044	0	8331-1	3006322		
961	79	40766240	1947-09-23	1947-09-23 00:00:00	1947-09-23	5001	0	\N	0	0	\N	\N	0	5249	0	63513-6	40766240		
9243	877	3036780	1990-05-08	1990-05-08 00:00:00	1990-05-08	5001	0	\N	0	0	\N	\N	0	58446	0	6095-4	3036780		
125726	3876	4052083	1974-04-17	1974-04-17 00:00:00	1974-04-17	5001	0	\N	0	0	\N	\N	0	257431	0	23426006	4052083		
50506	4608	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	307083	0	6082-2	3000876		
23338	2150	3006322	1980-10-04	1980-10-04 00:00:00	1980-10-04	5001	0	\N	0	0	\N	\N	0	143190	0	8331-1	3006322		
31325	2863	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	190371	0	6095-4	3036780		
14977	1389	3006322	1959-07-16	1959-07-16 00:00:00	1959-07-16	5001	0	\N	0	0	\N	\N	0	92179	0	8331-1	3006322		
7299	704	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	46536	0	6085-5	3001247		
157984	4852	4024958	1970-05-08	1970-05-08 00:00:00	1970-05-08	5001	0	\N	0	0	\N	\N	0	322850	0	117015009	4024958		
129090	3972	4052083	1960-04-06	1960-04-06 00:00:00	1960-04-06	5001	0	\N	0	0	\N	\N	0	264093	0	23426006	4052083		
39768	3695	3006923	1996-03-20	1996-03-20 00:00:00	1996-03-20	5001	0	\N	0	0	\N	\N	0	245605	0	1742-6	3006923		
10401	1015	46235214	2018-08-01	2018-08-01 00:00:00	2018-08-01	5001	0	\N	0	0	\N	\N	0	66851	0	76690-7	46235214		
10482	1017	3009542	1964-06-13	1964-06-13 00:00:00	1964-06-13	5001	0	\N	0	0	\N	\N	0	67005	0	20570-8	3009542		
41637	3874	3036780	1994-12-28	1994-12-28 00:00:00	1994-12-28	5001	0	\N	0	0	\N	\N	0	257207	0	6095-4	3036780		
210	5	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	486	0	6833-8	3023430		
18940	1740	3051031	1953-12-05	1953-12-05 00:00:00	1953-12-05	5001	0	\N	0	0	\N	\N	0	116260	0	46240-8	3051031		
2307	209	3006322	1951-04-26	1951-04-26 00:00:00	1951-04-26	5001	0	\N	0	0	\N	\N	0	14229	0	8331-1	3006322		
32421	2945	3006322	1992-03-25	1992-03-25 00:00:00	1992-03-25	5001	0	\N	0	0	\N	\N	0	196542	0	8331-1	3006322		
1499	129	3006322	1987-01-20	1987-01-20 00:00:00	1987-01-20	5001	0	\N	0	0	\N	\N	0	8706	0	8331-1	3006322		
23230	2136	3001488	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	142306	0	7258-7	3001488		
12591	1206	3023430	1988-02-28	1988-02-28 00:00:00	1988-02-28	5001	0	\N	0	0	\N	\N	0	79246	0	6833-8	3023430		
48918	4476	3019406	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	297826	0	6158-0	3019406		
46020	4246	46235214	1977-02-23	1977-02-23 00:00:00	1977-02-23	5001	0	\N	0	0	\N	\N	0	281987	0	76690-7	46235214		
24435	2258	3006322	1987-06-14	1987-06-14 00:00:00	1987-06-14	5001	0	\N	0	0	\N	\N	0	150091	0	8331-1	3006322		
22361	2053	46235214	1964-10-22	1964-10-22 00:00:00	1964-10-22	5001	0	\N	0	0	\N	\N	0	136512	0	76690-7	46235214		
61762	1892	4133840	2017-08-24	2017-08-24 00:00:00	2017-08-24	5001	0	\N	0	0	\N	\N	0	126006	0	127783003	4133840		
35618	3253	40769179	1972-05-17	1972-05-17 00:00:00	1972-05-17	5001	0	\N	0	0	\N	\N	0	216330	0	66519-0	40769179		
45154	4167	3014599	1995-03-29	1995-03-29 00:00:00	1995-03-29	5001	0	\N	0	0	\N	\N	0	276898	0	6106-9	3014599		
35040	3200	3049273	2014-09-13	2014-09-13 00:00:00	2014-09-13	5001	0	\N	0	0	\N	\N	0	212829	0	38265-5	3049273		
3983	399	3036780	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	26131	0	6095-4	3036780		
26897	842	4133840	1964-10-10	1964-10-10 00:00:00	1964-10-10	5001	0	\N	0	0	\N	\N	0	55604	0	127783003	4133840		
63265	1946	4052083	1942-10-30	1942-10-30 00:00:00	1942-10-30	5001	0	\N	0	0	\N	\N	0	129315	0	23426006	4052083		
12257	1169	3006322	2003-04-08	2003-04-08 00:00:00	2003-04-08	5001	0	\N	0	0	\N	\N	0	77005	0	8331-1	3006322		
55848	1702	4024958	1973-05-04	1973-05-04 00:00:00	1973-05-04	5001	0	\N	0	0	\N	\N	0	113801	0	117015009	4024958		
35129	3212	3013721	2018-07-21	2018-07-21 00:00:00	2018-07-21	5001	0	\N	0	0	\N	\N	0	213430	0	1920-8	3013721		
24531	2261	46235214	1965-05-03	1965-05-03 00:00:00	1965-05-03	5001	0	\N	0	0	\N	\N	0	150311	0	76690-7	46235214		
19152	1753	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	117203	0	6082-2	3000876		
35985	3311	3014599	1993-10-01	1993-10-01 00:00:00	1993-10-01	5001	0	\N	0	0	\N	\N	0	219768	0	6106-9	3014599		
57410	5272	3006322	1966-12-25	1966-12-25 00:00:00	1966-12-25	5001	0	\N	0	0	\N	\N	0	350673	0	8331-1	3006322		
139049	4284	4024958	2011-09-29	2011-09-29 00:00:00	2011-09-29	5001	0	\N	0	0	\N	\N	0	284395	0	117015009	4024958		
53357	4899	3051031	1922-04-27	1922-04-27 00:00:00	1922-04-27	5001	0	\N	0	0	\N	\N	0	325764	0	46240-8	3051031		
101672	3123	4052083	1989-10-03	1989-10-03 00:00:00	1989-10-03	5001	0	\N	0	0	\N	\N	0	207768	0	23426006	4052083		
116595	3593	4052083	1961-09-29	1961-09-29 00:00:00	1961-09-29	5001	0	\N	0	0	\N	\N	0	238666	0	23426006	4052083		
18211	1658	3000963	1912-04-30	1912-04-30 00:00:00	1912-04-30	5001	0	\N	0	0	\N	\N	0	111353	0	718-7	3000963		
107119	3301	4024958	1996-07-08	1996-07-08 00:00:00	1996-07-08	5001	0	\N	0	0	\N	\N	0	219267	0	117015009	4024958		
11434	1092	3006322	1959-08-21	1959-08-21 00:00:00	1959-08-21	5001	0	\N	0	0	\N	\N	0	71755	0	8331-1	3006322		
111965	3458	4052083	1985-05-22	1985-05-22 00:00:00	1985-05-22	5001	0	\N	0	0	\N	\N	0	229468	0	23426006	4052083		
101972	3133	4052083	2010-04-08	2010-04-08 00:00:00	2010-04-08	5001	0	\N	0	0	\N	\N	0	208459	0	23426006	4052083		
31024	2834	46235214	1991-06-05	1991-06-05 00:00:00	1991-06-05	5001	0	\N	0	0	\N	\N	0	188144	0	76690-7	46235214		
31111	2844	3006322	2006-07-11	2006-07-11 00:00:00	2006-07-11	5001	0	\N	0	0	\N	\N	0	188807	0	8331-1	3006322		
92825	2859	4024958	2005-04-08	2005-04-08 00:00:00	2005-04-08	5001	0	\N	0	0	\N	\N	0	189981	0	117015009	4024958		
32934	2975	3036780	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	198641	0	6095-4	3036780		
27424	2541	3006322	2014-05-08	2014-05-08 00:00:00	2014-05-08	5001	0	\N	0	0	\N	\N	0	168054	0	8331-1	3006322		
962	79	46235214	1947-09-23	1947-09-23 00:00:00	1947-09-23	5001	0	\N	0	0	\N	\N	0	5249	0	76690-7	46235214		
9244	877	3006734	1990-05-08	1990-05-08 00:00:00	1990-05-08	5001	0	\N	0	0	\N	\N	0	58446	0	6189-5	3006734		
125731	3876	4024958	1977-05-03	1977-05-03 00:00:00	1977-05-03	5001	0	\N	0	0	\N	\N	0	257432	0	117015009	4024958		
50507	4608	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	307083	0	6075-6	3005136		
23339	2151	3006322	1925-07-06	1925-07-06 00:00:00	1925-07-06	5001	0	\N	0	0	\N	\N	0	143306	0	8331-1	3006322		
42607	3938	3006322	1997-08-08	1997-08-08 00:00:00	1997-08-08	5001	0	\N	0	0	\N	\N	0	261741	0	8331-1	3006322		
14978	1389	3006322	2012-03-28	2012-03-28 00:00:00	2012-03-28	5001	0	\N	0	0	\N	\N	0	92222	0	8331-1	3006322		
7300	704	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	46536	0	6248-9	3015076		
157988	4852	4052083	1975-11-23	1975-11-23 00:00:00	1975-11-23	5001	0	\N	0	0	\N	\N	0	322773	0	23426006	4052083		
129092	3972	4052083	2014-01-09	2014-01-09 00:00:00	2014-01-09	5001	0	\N	0	0	\N	\N	0	264164	0	23426006	4052083		
39769	3695	3024731	1996-03-20	1996-03-20 00:00:00	1996-03-20	5001	0	\N	0	0	\N	\N	0	245605	0	30428-7	3024731		
10402	1015	40766240	2005-06-10	2005-06-10 00:00:00	2005-06-10	5001	0	\N	0	0	\N	\N	0	66826	0	63513-6	40766240		
10483	1017	3006322	1997-07-22	1997-07-22 00:00:00	1997-07-22	5001	0	\N	0	0	\N	\N	0	67007	0	8331-1	3006322		
41638	3874	3019406	1994-12-28	1994-12-28 00:00:00	1994-12-28	5001	0	\N	0	0	\N	\N	0	257207	0	6158-0	3019406		
211	5	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	486	0	6844-5	3020655		
18941	1740	40758406	1953-12-05	1953-12-05 00:00:00	1953-12-05	5001	0	\N	0	0	\N	\N	0	116260	0	55277-8	40758406		
2308	209	3006322	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	14210	0	8331-1	3006322		
32422	2945	3006322	1957-12-09	1957-12-09 00:00:00	1957-12-09	5001	0	\N	0	0	\N	\N	0	196522	0	8331-1	3006322		
1500	129	3006322	1986-10-07	1986-10-07 00:00:00	1986-10-07	5001	0	\N	0	0	\N	\N	0	8673	0	8331-1	3006322		
23231	2136	3027231	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	142306	0	6276-0	3027231		
12592	1206	3036780	1988-02-28	1988-02-28 00:00:00	1988-02-28	5001	0	\N	0	0	\N	\N	0	79246	0	6095-4	3036780		
48919	4476	3005136	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	297826	0	6075-6	3005136		
46021	4246	3051031	1977-02-23	1977-02-23 00:00:00	1977-02-23	5001	0	\N	0	0	\N	\N	0	281987	0	46240-8	3051031		
24436	2258	3006322	1960-11-26	1960-11-26 00:00:00	1960-11-26	5001	0	\N	0	0	\N	\N	0	150041	0	8331-1	3006322		
22362	2053	40766240	1964-10-22	1964-10-22 00:00:00	1964-10-22	5001	0	\N	0	0	\N	\N	0	136512	0	63513-6	40766240		
24172	755	4024958	1975-06-02	1975-06-02 00:00:00	1975-06-02	5001	0	\N	0	0	\N	\N	0	50045	0	117015009	4024958		
35619	3253	40769194	1972-05-17	1972-05-17 00:00:00	1972-05-17	5001	0	\N	0	0	\N	\N	0	216330	0	66534-9	40769194		
45155	4167	3000876	1995-03-29	1995-03-29 00:00:00	1995-03-29	5001	0	\N	0	0	\N	\N	0	276898	0	6082-2	3000876		
35041	3200	3006322	1950-01-05	1950-01-05 00:00:00	1950-01-05	5001	0	\N	0	0	\N	\N	0	212788	0	8331-1	3006322		
3984	399	3001488	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	26131	0	7258-7	3001488		
26899	842	4133840	2008-09-13	2008-09-13 00:00:00	2008-09-13	5001	0	\N	0	0	\N	\N	0	55699	0	127783003	4133840		
63393	1950	4024958	1945-04-23	1945-04-23 00:00:00	1945-04-23	5001	0	\N	0	0	\N	\N	0	129644	0	117015009	4024958		
12258	1169	3006322	2001-03-06	2001-03-06 00:00:00	2001-03-06	5001	0	\N	0	0	\N	\N	0	77032	0	8331-1	3006322		
134337	4137	4133840	2015-02-18	2015-02-18 00:00:00	2015-02-18	5001	0	\N	0	0	\N	\N	0	275044	0	127783003	4133840		
35130	3212	3027970	2018-07-21	2018-07-21 00:00:00	2018-07-21	5001	0	\N	0	0	\N	\N	0	213430	0	10834-0	3027970		
24532	2261	40766240	1965-05-03	1965-05-03 00:00:00	1965-05-03	5001	0	\N	0	0	\N	\N	0	150311	0	63513-6	40766240		
19153	1753	3006322	1965-04-03	1965-04-03 00:00:00	1965-04-03	5001	0	\N	0	0	\N	\N	0	117192	0	8331-1	3006322		
35986	3311	3021226	1993-10-01	1993-10-01 00:00:00	1993-10-01	5001	0	\N	0	0	\N	\N	0	219768	0	6246-3	3021226		
57411	5272	3006322	1959-06-24	1959-06-24 00:00:00	1959-06-24	5001	0	\N	0	0	\N	\N	0	350672	0	8331-1	3006322		
57458	5279	3006322	1957-05-17	1957-05-17 00:00:00	1957-05-17	5001	0	\N	0	0	\N	\N	0	351230	0	8331-1	3006322		
53358	4899	40766240	1922-04-27	1922-04-27 00:00:00	1922-04-27	5001	0	\N	0	0	\N	\N	0	325764	0	63513-6	40766240		
112959	3486	4052083	1969-08-05	1969-08-05 00:00:00	1969-08-05	5001	0	\N	0	0	\N	\N	0	231201	0	23426006	4052083		
116619	3593	4024958	1957-06-25	1957-06-25 00:00:00	1957-06-25	5001	0	\N	0	0	\N	\N	0	238644	0	117015009	4024958		
18212	1658	3006322	1982-07-02	1982-07-02 00:00:00	1982-07-02	5001	0	\N	0	0	\N	\N	0	111319	0	8331-1	3006322		
11435	1092	3006322	1970-11-11	1970-11-11 00:00:00	1970-11-11	5001	0	\N	0	0	\N	\N	0	71756	0	8331-1	3006322		
111967	3458	4024958	2000-07-31	2000-07-31 00:00:00	2000-07-31	5001	0	\N	0	0	\N	\N	0	229471	0	117015009	4024958		
76330	2340	4024958	1967-12-21	1967-12-21 00:00:00	1967-12-21	5001	0	\N	0	0	\N	\N	0	155766	0	117015009	4024958		
31025	2834	40758406	1991-06-05	1991-06-05 00:00:00	1991-06-05	5001	0	\N	0	0	\N	\N	0	188144	0	55277-8	40758406		
31112	2844	3006322	1988-03-28	1988-03-28 00:00:00	1988-03-28	5001	0	\N	0	0	\N	\N	0	188806	0	8331-1	3006322		
92830	2859	4024958	1953-05-29	1953-05-29 00:00:00	1953-05-29	5001	0	\N	0	0	\N	\N	0	190032	0	117015009	4024958		
32935	2975	3000876	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	198641	0	6082-2	3000876		
27425	2541	3006322	2017-05-05	2017-05-05 00:00:00	2017-05-05	5001	0	\N	0	0	\N	\N	0	168061	0	8331-1	3006322		
963	79	40758406	1947-09-23	1947-09-23 00:00:00	1947-09-23	5001	0	\N	0	0	\N	\N	0	5249	0	55277-8	40758406		
9245	877	3001247	1990-05-08	1990-05-08 00:00:00	1990-05-08	5001	0	\N	0	0	\N	\N	0	58446	0	6085-5	3001247		
38767	3583	3019406	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	238256	0	6158-0	3019406		
50508	4608	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	307083	0	6206-7	3012494		
23340	2151	3006322	1959-06-04	1959-06-04 00:00:00	1959-06-04	5001	0	\N	0	0	\N	\N	0	143303	0	8331-1	3006322		
42608	3938	3049273	1990-08-15	1990-08-15 00:00:00	1990-08-15	5001	0	\N	0	0	\N	\N	0	261731	0	38265-5	3049273		
14979	1389	3006322	1967-06-01	1967-06-01 00:00:00	1967-06-01	5001	0	\N	0	0	\N	\N	0	92150	0	8331-1	3006322		
7301	704	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	46536	0	6246-3	3021226		
157991	4852	4024958	2003-07-24	2003-07-24 00:00:00	2003-07-24	5001	0	\N	0	0	\N	\N	0	322763	0	117015009	4024958		
129093	3973	4052083	1996-11-15	1996-11-15 00:00:00	1996-11-15	5001	0	\N	0	0	\N	\N	0	264171	0	23426006	4052083		
39770	3695	21494966	1996-03-20	1996-03-20 00:00:00	1996-03-20	5001	0	\N	0	0	\N	\N	0	245605	0	80271-0	21494966		
10403	1015	46235214	2005-06-10	2005-06-10 00:00:00	2005-06-10	5001	0	\N	0	0	\N	\N	0	66826	0	76690-7	46235214		
10484	1017	3049273	2009-09-27	2009-09-27 00:00:00	2009-09-27	5001	0	\N	0	0	\N	\N	0	67004	0	38265-5	3049273		
41639	3874	3023430	1994-12-28	1994-12-28 00:00:00	1994-12-28	5001	0	\N	0	0	\N	\N	0	257207	0	6833-8	3023430		
212	5	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	486	0	7258-7	3001488		
18942	1740	40766240	1953-12-05	1953-12-05 00:00:00	1953-12-05	5001	0	\N	0	0	\N	\N	0	116260	0	63513-6	40766240		
2309	209	3006322	1960-02-28	1960-02-28 00:00:00	1960-02-28	5001	0	\N	0	0	\N	\N	0	14259	0	8331-1	3006322		
32423	2945	3011505	1995-07-18	1995-07-18 00:00:00	1995-07-18	5001	0	\N	0	0	\N	\N	0	196477	0	19926-5	3011505		
1501	129	3006322	2010-08-14	2010-08-14 00:00:00	2010-08-14	5001	0	\N	0	0	\N	\N	0	8713	0	8331-1	3006322		
37311	1154	4024958	2011-11-29	2011-11-29 00:00:00	2011-11-29	5001	0	\N	0	0	\N	\N	0	76221	0	117015009	4024958		
12593	1206	3006734	1988-02-28	1988-02-28 00:00:00	1988-02-28	5001	0	\N	0	0	\N	\N	0	79246	0	6189-5	3006734		
48920	4476	3014599	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	297826	0	6106-9	3014599		
46022	4246	40758406	1977-02-23	1977-02-23 00:00:00	1977-02-23	5001	0	\N	0	0	\N	\N	0	281987	0	55277-8	40758406		
24437	2258	3006322	1999-04-06	1999-04-06 00:00:00	1999-04-06	5001	0	\N	0	0	\N	\N	0	150086	0	8331-1	3006322		
22364	2053	40758406	1964-10-22	1964-10-22 00:00:00	1964-10-22	5001	0	\N	0	0	\N	\N	0	136512	0	55277-8	40758406		
24185	756	4052083	1973-08-23	1973-08-23 00:00:00	1973-08-23	5001	0	\N	0	0	\N	\N	0	50118	0	23426006	4052083		
35620	3253	40769189	1972-05-17	1972-05-17 00:00:00	1972-05-17	5001	0	\N	0	0	\N	\N	0	216330	0	66529-9	40769189		
45156	4167	3019406	1995-03-29	1995-03-29 00:00:00	1995-03-29	5001	0	\N	0	0	\N	\N	0	276898	0	6158-0	3019406		
35042	3200	3006322	1992-04-14	1992-04-14 00:00:00	1992-04-14	5001	0	\N	0	0	\N	\N	0	212874	0	8331-1	3006322		
3985	399	3006734	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	26131	0	6189-5	3006734		
26901	842	4133840	1983-03-26	1983-03-26 00:00:00	1983-03-26	5001	0	\N	0	0	\N	\N	0	55666	0	127783003	4133840		
63396	1950	4133840	1985-01-10	1985-01-10 00:00:00	1985-01-10	5001	0	\N	0	0	\N	\N	0	129690	0	127783003	4133840		
12259	1169	3006322	1955-01-12	1955-01-12 00:00:00	1955-01-12	5001	0	\N	0	0	\N	\N	0	76967	0	8331-1	3006322		
134338	4137	4133840	2018-03-07	2018-03-07 00:00:00	2018-03-07	5001	0	\N	0	0	\N	\N	0	275035	0	127783003	4133840		
35131	3212	3009542	2018-07-21	2018-07-21 00:00:00	2018-07-21	5001	0	\N	0	0	\N	\N	0	213430	0	20570-8	3009542		
24533	2261	40758406	1965-05-03	1965-05-03 00:00:00	1965-05-03	5001	0	\N	0	0	\N	\N	0	150311	0	55277-8	40758406		
30432	2786	3006322	1978-07-22	1978-07-22 00:00:00	1978-07-22	5001	0	\N	0	0	\N	\N	0	184651	0	8331-1	3006322		
35987	3311	3020655	1993-10-01	1993-10-01 00:00:00	1993-10-01	5001	0	\N	0	0	\N	\N	0	219768	0	6844-5	3020655		
57412	5272	3006322	1950-12-18	1950-12-18 00:00:00	1950-12-18	5001	0	\N	0	0	\N	\N	0	350671	0	8331-1	3006322		
57459	5279	3006322	1973-10-28	1973-10-28 00:00:00	1973-10-28	5001	0	\N	0	0	\N	\N	0	351171	0	8331-1	3006322		
53359	4899	3011505	1980-07-29	1980-07-29 00:00:00	1980-07-29	5001	0	\N	0	0	\N	\N	0	325858	0	19926-5	3011505		
8443	270	4024958	1968-07-15	1968-07-15 00:00:00	1968-07-15	5001	0	\N	0	0	\N	\N	0	18013	0	117015009	4024958		
116622	3593	4052083	1974-06-17	1974-06-17 00:00:00	1974-06-17	5001	0	\N	0	0	\N	\N	0	238702	0	23426006	4052083		
18213	1658	3006322	2005-02-26	2005-02-26 00:00:00	2005-02-26	5001	0	\N	0	0	\N	\N	0	111346	0	8331-1	3006322		
11436	1092	3049273	2000-11-29	2000-11-29 00:00:00	2000-11-29	5001	0	\N	0	0	\N	\N	0	71801	0	38265-5	3049273		
111968	3458	4024958	2008-09-06	2008-09-06 00:00:00	2008-09-06	5001	0	\N	0	0	\N	\N	0	229491	0	117015009	4024958		
76368	2341	4052083	2008-03-26	2008-03-26 00:00:00	2008-03-26	5001	0	\N	0	0	\N	\N	0	155819	0	23426006	4052083		
31026	2834	3051031	1991-06-05	1991-06-05 00:00:00	1991-06-05	5001	0	\N	0	0	\N	\N	0	188144	0	46240-8	3051031		
31113	2844	3006322	1967-02-14	1967-02-14 00:00:00	1967-02-14	5001	0	\N	0	0	\N	\N	0	188883	0	8331-1	3006322		
92838	2859	4024958	1948-03-19	1948-03-19 00:00:00	1948-03-19	5001	0	\N	0	0	\N	\N	0	190057	0	117015009	4024958		
32936	2975	3019406	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	198641	0	6158-0	3019406		
27426	2542	3027231	1986-06-26	1986-06-26 00:00:00	1986-06-26	5001	0	\N	0	0	\N	\N	0	168123	0	6276-0	3027231		
964	79	3006322	2016-05-14	2016-05-14 00:00:00	2016-05-14	5001	0	\N	0	0	\N	\N	0	5329	0	8331-1	3006322		
9246	877	3001488	1990-05-08	1990-05-08 00:00:00	1990-05-08	5001	0	\N	0	0	\N	\N	0	58446	0	7258-7	3001488		
38768	3583	3005136	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	238256	0	6075-6	3005136		
50509	4608	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	307083	0	6158-0	3019406		
23341	2151	3006322	1957-12-27	1957-12-27 00:00:00	1957-12-27	5001	0	\N	0	0	\N	\N	0	143302	0	8331-1	3006322		
42609	3938	3006322	1952-05-24	1952-05-24 00:00:00	1952-05-24	5001	0	\N	0	0	\N	\N	0	261791	0	8331-1	3006322		
14980	1389	3009542	1962-03-03	1962-03-03 00:00:00	1962-03-03	5001	0	\N	0	0	\N	\N	0	92180	0	20570-8	3009542		
7302	704	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	46536	0	6106-9	3014599		
158005	4852	4052083	1977-07-25	1977-07-25 00:00:00	1977-07-25	5001	0	\N	0	0	\N	\N	0	322851	0	23426006	4052083		
129099	3973	4024958	1976-10-13	1976-10-13 00:00:00	1976-10-13	5001	0	\N	0	0	\N	\N	0	264236	0	117015009	4024958		
39771	3695	3004501	1996-03-20	1996-03-20 00:00:00	1996-03-20	5001	0	\N	0	0	\N	\N	0	245605	0	2345-7	3004501		
10404	1015	40758406	2005-06-10	2005-06-10 00:00:00	2005-06-10	5001	0	\N	0	0	\N	\N	0	66826	0	55277-8	40758406		
10485	1017	3006322	1967-03-28	1967-03-28 00:00:00	1967-03-28	5001	0	\N	0	0	\N	\N	0	66952	0	8331-1	3006322		
41640	3874	3006734	1994-12-28	1994-12-28 00:00:00	1994-12-28	5001	0	\N	0	0	\N	\N	0	257207	0	6189-5	3006734		
213	5	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	408	0	6158-0	3019406		
43658	1345	4052083	2001-02-10	2001-02-10 00:00:00	2001-02-10	5001	0	\N	0	0	\N	\N	0	89161	0	23426006	4052083		
2310	209	3006322	1954-09-18	1954-09-18 00:00:00	1954-09-18	5001	0	\N	0	0	\N	\N	0	14257	0	8331-1	3006322		
32424	2945	3011505	2005-09-13	2005-09-13 00:00:00	2005-09-13	5001	0	\N	0	0	\N	\N	0	196488	0	19926-5	3011505		
1528	133	3006322	2002-11-06	2002-11-06 00:00:00	2002-11-06	5001	0	\N	0	0	\N	\N	0	8969	0	8331-1	3006322		
37326	1154	4052083	2014-07-19	2014-07-19 00:00:00	2014-07-19	5001	0	\N	0	0	\N	\N	0	76255	0	23426006	4052083		
12594	1206	3000876	1988-02-28	1988-02-28 00:00:00	1988-02-28	5001	0	\N	0	0	\N	\N	0	79246	0	6082-2	3000876		
48921	4476	3006451	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	297826	0	6273-7	3006451		
46025	4246	40766240	1977-02-23	1977-02-23 00:00:00	1977-02-23	5001	0	\N	0	0	\N	\N	0	281987	0	63513-6	40766240		
24438	2258	3006322	1972-11-16	1972-11-16 00:00:00	1972-11-16	5001	0	\N	0	0	\N	\N	0	150075	0	8331-1	3006322		
22365	2053	3051031	1963-12-27	1963-12-27 00:00:00	1963-12-27	5001	0	\N	0	0	\N	\N	0	136504	0	46240-8	3051031		
24187	756	4024958	1967-03-01	1967-03-01 00:00:00	1967-03-01	5001	0	\N	0	0	\N	\N	0	50129	0	117015009	4024958		
35621	3253	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	216383	0	7258-7	3001488		
45157	4167	3006451	1995-03-29	1995-03-29 00:00:00	1995-03-29	5001	0	\N	0	0	\N	\N	0	276898	0	6273-7	3006451		
35043	3200	3049273	2013-08-19	2013-08-19 00:00:00	2013-08-19	5001	0	\N	0	0	\N	\N	0	212828	0	38265-5	3049273		
3986	399	3000876	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	26131	0	6082-2	3000876		
26902	842	4133840	1970-11-14	1970-11-14 00:00:00	1970-11-14	5001	0	\N	0	0	\N	\N	0	55692	0	127783003	4133840		
63399	1950	4133840	2005-12-08	2005-12-08 00:00:00	2005-12-08	5001	0	\N	0	0	\N	\N	0	129662	0	127783003	4133840		
12260	1169	3006322	1952-02-18	1952-02-18 00:00:00	1952-02-18	5001	0	\N	0	0	\N	\N	0	76959	0	8331-1	3006322		
134340	4137	4133840	2019-03-13	2019-03-13 00:00:00	2019-03-13	5001	0	\N	0	0	\N	\N	0	275046	0	127783003	4133840		
35132	3212	3028833	2018-07-21	2018-07-21 00:00:00	2018-07-21	5001	0	\N	0	0	\N	\N	0	213430	0	42719-5	3028833		
24534	2261	3051031	1965-05-03	1965-05-03 00:00:00	1965-05-03	5001	0	\N	0	0	\N	\N	0	150311	0	46240-8	3051031		
30435	2788	3006322	1979-01-14	1979-01-14 00:00:00	1979-01-14	5001	0	\N	0	0	\N	\N	0	184730	0	8331-1	3006322		
35988	3311	3023430	1993-10-01	1993-10-01 00:00:00	1993-10-01	5001	0	\N	0	0	\N	\N	0	219768	0	6833-8	3023430		
57413	5272	3006322	1926-12-05	1926-12-05 00:00:00	1926-12-05	5001	0	\N	0	0	\N	\N	0	350587	0	8331-1	3006322		
142306	4376	4133840	1980-07-08	1980-07-08 00:00:00	1980-07-08	5001	0	\N	0	0	\N	\N	0	290701	0	127783003	4133840		
53360	4899	3011505	1991-10-01	1991-10-01 00:00:00	1991-10-01	5001	0	\N	0	0	\N	\N	0	325830	0	19926-5	3011505		
8449	270	4024958	1976-09-10	1976-09-10 00:00:00	1976-09-10	5001	0	\N	0	0	\N	\N	0	17958	0	117015009	4024958		
116625	3593	4024958	1960-11-20	1960-11-20 00:00:00	1960-11-20	5001	0	\N	0	0	\N	\N	0	238645	0	117015009	4024958		
18214	1659	3006322	1992-05-06	1992-05-06 00:00:00	1992-05-06	5001	0	\N	0	0	\N	\N	0	111566	0	8331-1	3006322		
11437	1092	3006322	1967-01-06	1967-01-06 00:00:00	1967-01-06	5001	0	\N	0	0	\N	\N	0	71815	0	8331-1	3006322		
111969	3458	4052083	1991-06-12	1991-06-12 00:00:00	1991-06-12	5001	0	\N	0	0	\N	\N	0	229450	0	23426006	4052083		
76392	2341	4024958	1959-08-19	1959-08-19 00:00:00	1959-08-19	5001	0	\N	0	0	\N	\N	0	155788	0	117015009	4024958		
31029	2834	40766240	1991-06-05	1991-06-05 00:00:00	1991-06-05	5001	0	\N	0	0	\N	\N	0	188144	0	63513-6	40766240		
31114	2844	3006322	2000-10-20	2000-10-20 00:00:00	2000-10-20	5001	0	\N	0	0	\N	\N	0	188869	0	8331-1	3006322		
92842	2859	4052083	1948-06-02	1948-06-02 00:00:00	1948-06-02	5001	0	\N	0	0	\N	\N	0	190030	0	23426006	4052083		
44219	4077	3006322	2010-06-28	2010-06-28 00:00:00	2010-06-28	5001	0	\N	0	0	\N	\N	0	270900	0	8331-1	3006322		
27427	2542	3006451	1986-06-26	1986-06-26 00:00:00	1986-06-26	5001	0	\N	0	0	\N	\N	0	168123	0	6273-7	3006451		
965	79	3006322	1957-02-13	1957-02-13 00:00:00	1957-02-13	5001	0	\N	0	0	\N	\N	0	5276	0	8331-1	3006322		
9247	877	3015076	1990-05-08	1990-05-08 00:00:00	1990-05-08	5001	0	\N	0	0	\N	\N	0	58446	0	6248-9	3015076		
38769	3583	3014599	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	238256	0	6106-9	3014599		
50510	4608	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	307083	0	6189-5	3006734		
23343	2152	3006322	1995-11-25	1995-11-25 00:00:00	1995-11-25	5001	0	\N	0	0	\N	\N	0	143451	0	8331-1	3006322		
42610	3939	3006322	1995-07-27	1995-07-27 00:00:00	1995-07-27	5001	0	\N	0	0	\N	\N	0	261818	0	8331-1	3006322		
14981	1389	3000963	1962-03-03	1962-03-03 00:00:00	1962-03-03	5001	0	\N	0	0	\N	\N	0	92180	0	718-7	3000963		
7303	704	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	46536	0	6095-4	3036780		
158008	4852	4052083	1956-12-28	1956-12-28 00:00:00	1956-12-28	5001	0	\N	0	0	\N	\N	0	322848	0	23426006	4052083		
129100	3973	4024958	1977-05-26	1977-05-26 00:00:00	1977-05-26	5001	0	\N	0	0	\N	\N	0	264177	0	117015009	4024958		
39772	3695	3006906	1996-03-20	1996-03-20 00:00:00	1996-03-20	5001	0	\N	0	0	\N	\N	0	245605	0	17861-6	3006906		
10406	1015	3051031	2005-06-10	2005-06-10 00:00:00	2005-06-10	5001	0	\N	0	0	\N	\N	0	66826	0	46240-8	3051031		
10486	1017	3006322	1961-04-02	1961-04-02 00:00:00	1961-04-02	5001	0	\N	0	0	\N	\N	0	66936	0	8331-1	3006322		
41641	3874	3005136	1994-12-28	1994-12-28 00:00:00	1994-12-28	5001	0	\N	0	0	\N	\N	0	257207	0	6075-6	3005136		
214	5	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	408	0	6248-9	3015076		
43664	1345	4052083	2013-10-13	2013-10-13 00:00:00	2013-10-13	5001	0	\N	0	0	\N	\N	0	89129	0	23426006	4052083		
2311	209	3006322	1976-05-02	1976-05-02 00:00:00	1976-05-02	5001	0	\N	0	0	\N	\N	0	14281	0	8331-1	3006322		
32425	2945	3011505	1979-12-11	1979-12-11 00:00:00	1979-12-11	5001	0	\N	0	0	\N	\N	0	196485	0	19926-5	3011505		
1529	133	3006322	1990-05-31	1990-05-31 00:00:00	1990-05-31	5001	0	\N	0	0	\N	\N	0	8958	0	8331-1	3006322		
37327	1154	4024958	1981-02-14	1981-02-14 00:00:00	1981-02-14	5001	0	\N	0	0	\N	\N	0	76279	0	117015009	4024958		
12595	1206	3020655	1988-02-28	1988-02-28 00:00:00	1988-02-28	5001	0	\N	0	0	\N	\N	0	79246	0	6844-5	3020655		
48922	4476	3001488	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	297826	0	7258-7	3001488		
46026	4246	3051031	1977-07-23	1977-07-23 00:00:00	1977-07-23	5001	0	\N	0	0	\N	\N	0	281939	0	46240-8	3051031		
24439	2258	3006322	2007-12-31	2007-12-31 00:00:00	2007-12-31	5001	0	\N	0	0	\N	\N	0	150100	0	8331-1	3006322		
22366	2053	40758406	1963-12-27	1963-12-27 00:00:00	1963-12-27	5001	0	\N	0	0	\N	\N	0	136504	0	55277-8	40758406		
24189	756	4024958	1971-07-07	1971-07-07 00:00:00	1971-07-07	5001	0	\N	0	0	\N	\N	0	50117	0	117015009	4024958		
46899	4317	3006322	1971-03-06	1971-03-06 00:00:00	1971-03-06	5001	0	\N	0	0	\N	\N	0	286553	0	8331-1	3006322		
45158	4167	3027231	1995-03-29	1995-03-29 00:00:00	1995-03-29	5001	0	\N	0	0	\N	\N	0	276898	0	6276-0	3027231		
35044	3200	3006322	2018-11-05	2018-11-05 00:00:00	2018-11-05	5001	0	\N	0	0	\N	\N	0	212854	0	8331-1	3006322		
3987	399	3014599	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	26131	0	6106-9	3014599		
26958	2497	3006322	1968-07-27	1968-07-27 00:00:00	1968-07-27	5001	0	\N	0	0	\N	\N	0	165349	0	8331-1	3006322		
63401	1950	4133840	1989-01-19	1989-01-19 00:00:00	1989-01-19	5001	0	\N	0	0	\N	\N	0	129616	0	127783003	4133840		
134341	4137	4133840	2016-02-24	2016-02-24 00:00:00	2016-02-24	5001	0	\N	0	0	\N	\N	0	275034	0	127783003	4133840		
35133	3212	3026361	2018-07-21	2018-07-21 00:00:00	2018-07-21	5001	0	\N	0	0	\N	\N	0	213430	0	26453-1	3026361		
24539	2261	40766240	1966-08-26	1966-08-26 00:00:00	1966-08-26	5001	0	\N	0	0	\N	\N	0	150284	0	63513-6	40766240		
30487	2790	3006322	1958-03-08	1958-03-08 00:00:00	1958-03-08	5001	0	\N	0	0	\N	\N	0	184867	0	8331-1	3006322		
35989	3311	3036780	1990-03-30	1990-03-30 00:00:00	1990-03-30	5001	0	\N	0	0	\N	\N	0	219805	0	6095-4	3036780		
57414	5272	3006322	1921-01-12	1921-01-12 00:00:00	1921-01-12	5001	0	\N	0	0	\N	\N	0	350586	0	8331-1	3006322		
142309	4376	4133840	1998-10-20	1998-10-20 00:00:00	1998-10-20	5001	0	\N	0	0	\N	\N	0	290803	0	127783003	4133840		
53362	4899	3051031	1921-11-28	1921-11-28 00:00:00	1921-11-28	5001	0	\N	0	0	\N	\N	0	325834	0	46240-8	3051031		
118887	3660	4024958	1976-11-30	1976-11-30 00:00:00	1976-11-30	5001	0	\N	0	0	\N	\N	0	243583	0	117015009	4024958		
2849	90	4024958	1970-01-15	1970-01-15 00:00:00	1970-01-15	5001	0	\N	0	0	\N	\N	0	5987	0	117015009	4024958		
18215	1659	3006322	1969-08-15	1969-08-15 00:00:00	1969-08-15	5001	0	\N	0	0	\N	\N	0	111578	0	8331-1	3006322		
70527	2160	4052083	1989-01-11	1989-01-11 00:00:00	1989-01-11	5001	0	\N	0	0	\N	\N	0	143981	0	23426006	4052083		
111975	3458	4052083	1997-09-29	1997-09-29 00:00:00	1997-09-29	5001	0	\N	0	0	\N	\N	0	229452	0	23426006	4052083		
76396	2341	4024958	2014-08-17	2014-08-17 00:00:00	2014-08-17	5001	0	\N	0	0	\N	\N	0	155862	0	117015009	4024958		
31031	2834	40758406	1990-05-11	1990-05-11 00:00:00	1990-05-11	5001	0	\N	0	0	\N	\N	0	188179	0	55277-8	40758406		
31115	2844	3006322	2000-11-30	2000-11-30 00:00:00	2000-11-30	5001	0	\N	0	0	\N	\N	0	188870	0	8331-1	3006322		
60055	1834	4052083	1969-10-02	1969-10-02 00:00:00	1969-10-02	5001	0	\N	0	0	\N	\N	0	122557	0	23426006	4052083		
44220	4077	3006322	1984-11-03	1984-11-03 00:00:00	1984-11-03	5001	0	\N	0	0	\N	\N	0	270911	0	8331-1	3006322		
27428	2542	3021226	1986-06-26	1986-06-26 00:00:00	1986-06-26	5001	0	\N	0	0	\N	\N	0	168123	0	6246-3	3021226		
967	79	3051031	1947-07-25	1947-07-25 00:00:00	1947-07-25	5001	0	\N	0	0	\N	\N	0	5239	0	46240-8	3051031		
9248	877	3012494	1990-05-08	1990-05-08 00:00:00	1990-05-08	5001	0	\N	0	0	\N	\N	0	58446	0	6206-7	3012494		
38770	3583	3006451	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	238256	0	6273-7	3006451		
50511	4608	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	307083	0	6833-8	3023430		
23344	2152	3006322	1939-03-25	1939-03-25 00:00:00	1939-03-25	5001	0	\N	0	0	\N	\N	0	143433	0	8331-1	3006322		
42611	3939	3006322	1982-12-22	1982-12-22 00:00:00	1982-12-22	5001	0	\N	0	0	\N	\N	0	261813	0	8331-1	3006322		
14982	1389	3006322	1981-05-01	1981-05-01 00:00:00	1981-05-01	5001	0	\N	0	0	\N	\N	0	92152	0	8331-1	3006322		
7304	704	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	46536	0	6082-2	3000876		
9228	295	4052083	1980-07-18	1980-07-18 00:00:00	1980-07-18	5001	0	\N	0	0	\N	\N	0	19592	0	23426006	4052083		
129111	3973	4052083	1984-09-01	1984-09-01 00:00:00	1984-09-01	5001	0	\N	0	0	\N	\N	0	264167	0	23426006	4052083		
39773	3695	3016723	1996-03-20	1996-03-20 00:00:00	1996-03-20	5001	0	\N	0	0	\N	\N	0	245605	0	2160-0	3016723		
10408	1015	40758406	2018-05-03	2018-05-03 00:00:00	2018-05-03	5001	0	\N	0	0	\N	\N	0	66771	0	55277-8	40758406		
10487	1017	3006322	2018-08-26	2018-08-26 00:00:00	2018-08-26	5001	0	\N	0	0	\N	\N	0	66981	0	8331-1	3006322		
41642	3874	3021226	1994-12-28	1994-12-28 00:00:00	1994-12-28	5001	0	\N	0	0	\N	\N	0	257207	0	6246-3	3021226		
215	5	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	408	0	6189-5	3006734		
43671	1345	4052083	2015-03-15	2015-03-15 00:00:00	2015-03-15	5001	0	\N	0	0	\N	\N	0	89168	0	23426006	4052083		
2312	209	3006322	1974-12-29	1974-12-29 00:00:00	1974-12-29	5001	0	\N	0	0	\N	\N	0	14263	0	8331-1	3006322		
32426	2945	3011505	1994-04-05	1994-04-05 00:00:00	1994-04-05	5001	0	\N	0	0	\N	\N	0	196502	0	19926-5	3011505		
1530	135	3006322	1973-07-07	1973-07-07 00:00:00	1973-07-07	5001	0	\N	0	0	\N	\N	0	9080	0	8331-1	3006322		
37344	1155	4024958	1995-10-15	1995-10-15 00:00:00	1995-10-15	5001	0	\N	0	0	\N	\N	0	76315	0	117015009	4024958		
12596	1206	3001488	1988-02-28	1988-02-28 00:00:00	1988-02-28	5001	0	\N	0	0	\N	\N	0	79246	0	7258-7	3001488		
48923	4476	3023430	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	297826	0	6833-8	3023430		
46029	4246	40766240	1977-07-23	1977-07-23 00:00:00	1977-07-23	5001	0	\N	0	0	\N	\N	0	281939	0	63513-6	40766240		
24440	2258	3006322	1991-02-05	1991-02-05 00:00:00	1991-02-05	5001	0	\N	0	0	\N	\N	0	150084	0	8331-1	3006322		
22368	2053	40766240	1963-12-27	1963-12-27 00:00:00	1963-12-27	5001	0	\N	0	0	\N	\N	0	136504	0	63513-6	40766240		
24202	756	4052083	1981-04-01	1981-04-01 00:00:00	1981-04-01	5001	0	\N	0	0	\N	\N	0	50131	0	23426006	4052083		
46900	4317	3006322	1987-07-02	1987-07-02 00:00:00	1987-07-02	5001	0	\N	0	0	\N	\N	0	286501	0	8331-1	3006322		
45159	4167	3021226	1995-03-29	1995-03-29 00:00:00	1995-03-29	5001	0	\N	0	0	\N	\N	0	276898	0	6246-3	3021226		
35045	3200	3006322	2001-01-21	2001-01-21 00:00:00	2001-01-21	5001	0	\N	0	0	\N	\N	0	212834	0	8331-1	3006322		
3988	399	3019406	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	26131	0	6158-0	3019406		
26959	2497	3006322	2000-11-20	2000-11-20 00:00:00	2000-11-20	5001	0	\N	0	0	\N	\N	0	165320	0	8331-1	3006322		
63403	1950	4133840	1999-11-04	1999-11-04 00:00:00	1999-11-04	5001	0	\N	0	0	\N	\N	0	129618	0	127783003	4133840		
134345	4137	4133840	2017-03-01	2017-03-01 00:00:00	2017-03-01	5001	0	\N	0	0	\N	\N	0	275045	0	127783003	4133840		
35134	3212	3019550	2018-07-21	2018-07-21 00:00:00	2018-07-21	5001	0	\N	0	0	\N	\N	0	213430	0	2951-2	3019550		
24540	2261	46235214	1966-01-28	1966-01-28 00:00:00	1966-01-28	5001	0	\N	0	0	\N	\N	0	150312	0	76690-7	46235214		
30488	2790	3049273	2009-04-13	2009-04-13 00:00:00	2009-04-13	5001	0	\N	0	0	\N	\N	0	184875	0	38265-5	3049273		
35990	3311	3006734	1990-03-30	1990-03-30 00:00:00	1990-03-30	5001	0	\N	0	0	\N	\N	0	219805	0	6189-5	3006734		
57415	5272	3006322	1929-06-03	1929-06-03 00:00:00	1929-06-03	5001	0	\N	0	0	\N	\N	0	350709	0	8331-1	3006322		
142313	4376	4133840	1984-07-31	1984-07-31 00:00:00	1984-07-31	5001	0	\N	0	0	\N	\N	0	290703	0	127783003	4133840		
53363	4899	46235214	1921-11-28	1921-11-28 00:00:00	1921-11-28	5001	0	\N	0	0	\N	\N	0	325834	0	76690-7	46235214		
118888	3660	4024958	1988-01-27	1988-01-27 00:00:00	1988-01-27	5001	0	\N	0	0	\N	\N	0	243563	0	117015009	4024958		
2157	64	4024958	1985-11-12	1985-11-12 00:00:00	1985-11-12	5001	0	\N	0	0	\N	\N	0	4320	0	117015009	4024958		
18216	1659	3006322	1999-10-07	1999-10-07 00:00:00	1999-10-07	5001	0	\N	0	0	\N	\N	0	111473	0	8331-1	3006322		
119676	3691	4052083	2005-08-28	2005-08-28 00:00:00	2005-08-28	5001	0	\N	0	0	\N	\N	0	245348	0	23426006	4052083		
53630	1623	4024958	2017-07-05	2017-07-05 00:00:00	2017-07-05	5001	0	\N	0	0	\N	\N	0	109088	0	117015009	4024958		
31032	2834	3051031	1990-05-11	1990-05-11 00:00:00	1990-05-11	5001	0	\N	0	0	\N	\N	0	188179	0	46240-8	3051031		
31116	2844	3006322	1995-08-05	1995-08-05 00:00:00	1995-08-05	5001	0	\N	0	0	\N	\N	0	188868	0	8331-1	3006322		
60057	1834	4052083	1988-12-08	1988-12-08 00:00:00	1988-12-08	5001	0	\N	0	0	\N	\N	0	122560	0	23426006	4052083		
44221	4077	3006322	1976-12-03	1976-12-03 00:00:00	1976-12-03	5001	0	\N	0	0	\N	\N	0	270908	0	8331-1	3006322		
27429	2542	3019406	1986-06-26	1986-06-26 00:00:00	1986-06-26	5001	0	\N	0	0	\N	\N	0	168123	0	6158-0	3019406		
969	79	40766240	1947-07-25	1947-07-25 00:00:00	1947-07-25	5001	0	\N	0	0	\N	\N	0	5239	0	63513-6	40766240		
9249	877	3020655	1990-05-08	1990-05-08 00:00:00	1990-05-08	5001	0	\N	0	0	\N	\N	0	58446	0	6844-5	3020655		
38771	3583	3021226	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	238256	0	6246-3	3021226		
50512	4608	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	307083	0	7258-7	3001488		
23345	2152	3006322	1959-06-18	1959-06-18 00:00:00	1959-06-18	5001	0	\N	0	0	\N	\N	0	143435	0	8331-1	3006322		
42612	3939	3006322	1978-08-01	1978-08-01 00:00:00	1978-08-01	5001	0	\N	0	0	\N	\N	0	261862	0	8331-1	3006322		
14983	1389	3006322	1995-02-01	1995-02-01 00:00:00	1995-02-01	5001	0	\N	0	0	\N	\N	0	92219	0	8331-1	3006322		
7305	704	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	46536	0	6276-0	3027231		
9247	295	4052083	1984-10-04	1984-10-04 00:00:00	1984-10-04	5001	0	\N	0	0	\N	\N	0	19593	0	23426006	4052083		
129116	3973	4024958	2012-08-07	2012-08-07 00:00:00	2012-08-07	5001	0	\N	0	0	\N	\N	0	264174	0	117015009	4024958		
39774	3695	3013721	1996-03-20	1996-03-20 00:00:00	1996-03-20	5001	0	\N	0	0	\N	\N	0	245605	0	1920-8	3013721		
10410	1015	3051031	2018-05-03	2018-05-03 00:00:00	2018-05-03	5001	0	\N	0	0	\N	\N	0	66771	0	46240-8	3051031		
10488	1017	3006322	2001-01-11	2001-01-11 00:00:00	2001-01-11	5001	0	\N	0	0	\N	\N	0	67008	0	8331-1	3006322		
41643	3874	3027231	1994-12-28	1994-12-28 00:00:00	1994-12-28	5001	0	\N	0	0	\N	\N	0	257207	0	6276-0	3027231		
216	5	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	408	0	6082-2	3000876		
114091	3518	4052083	2018-08-24	2018-08-24 00:00:00	2018-08-24	5001	0	\N	0	0	\N	\N	0	233597	0	23426006	4052083		
2313	209	3006322	1990-02-05	1990-02-05 00:00:00	1990-02-05	5001	0	\N	0	0	\N	\N	0	14231	0	8331-1	3006322		
32427	2945	3011505	1996-07-23	1996-07-23 00:00:00	1996-07-23	5001	0	\N	0	0	\N	\N	0	196493	0	19926-5	3011505		
1533	137	3006322	1977-09-28	1977-09-28 00:00:00	1977-09-28	5001	0	\N	0	0	\N	\N	0	9131	0	8331-1	3006322		
37347	1155	4024958	1975-12-03	1975-12-03 00:00:00	1975-12-03	5001	0	\N	0	0	\N	\N	0	76326	0	117015009	4024958		
12597	1206	3001247	1988-02-28	1988-02-28 00:00:00	1988-02-28	5001	0	\N	0	0	\N	\N	0	79246	0	6085-5	3001247		
48924	4477	3006322	1966-11-09	1966-11-09 00:00:00	1966-11-09	5001	0	\N	0	0	\N	\N	0	297962	0	8331-1	3006322		
46030	4246	40758406	1977-07-23	1977-07-23 00:00:00	1977-07-23	5001	0	\N	0	0	\N	\N	0	281939	0	55277-8	40758406		
24441	2258	3006322	2008-04-13	2008-04-13 00:00:00	2008-04-13	5001	0	\N	0	0	\N	\N	0	150044	0	8331-1	3006322		
22370	2053	46235214	1963-12-27	1963-12-27 00:00:00	1963-12-27	5001	0	\N	0	0	\N	\N	0	136504	0	76690-7	46235214		
24206	757	4024958	1925-04-27	1925-04-27 00:00:00	1925-04-27	5001	0	\N	0	0	\N	\N	0	50181	0	117015009	4024958		
46901	4317	3006322	1966-05-23	1966-05-23 00:00:00	1966-05-23	5001	0	\N	0	0	\N	\N	0	286551	0	8331-1	3006322		
45160	4167	3001247	1995-03-29	1995-03-29 00:00:00	1995-03-29	5001	0	\N	0	0	\N	\N	0	276898	0	6085-5	3001247		
35046	3200	3006322	1980-01-05	1980-01-05 00:00:00	1980-01-05	5001	0	\N	0	0	\N	\N	0	212791	0	8331-1	3006322		
3989	399	3015076	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	26131	0	6248-9	3015076		
26960	2497	3006322	2001-04-04	2001-04-04 00:00:00	2001-04-04	5001	0	\N	0	0	\N	\N	0	165321	0	8331-1	3006322		
63405	1950	4133840	1990-09-13	1990-09-13 00:00:00	1990-09-13	5001	0	\N	0	0	\N	\N	0	129617	0	127783003	4133840		
134351	4137	4133840	2014-02-12	2014-02-12 00:00:00	2014-02-12	5001	0	\N	0	0	\N	\N	0	275033	0	127783003	4133840		
35135	3212	3035995	2018-07-21	2018-07-21 00:00:00	2018-07-21	5001	0	\N	0	0	\N	\N	0	213430	0	6768-6	3035995		
24541	2261	3051031	1966-01-28	1966-01-28 00:00:00	1966-01-28	5001	0	\N	0	0	\N	\N	0	150312	0	46240-8	3051031		
30489	2790	3006322	1982-11-18	1982-11-18 00:00:00	1982-11-18	5001	0	\N	0	0	\N	\N	0	184891	0	8331-1	3006322		
35991	3311	3019406	1990-03-30	1990-03-30 00:00:00	1990-03-30	5001	0	\N	0	0	\N	\N	0	219805	0	6158-0	3019406		
57416	5272	3049273	1977-02-09	1977-02-09 00:00:00	1977-02-09	5001	0	\N	0	0	\N	\N	0	350685	0	38265-5	3049273		
142318	4376	4133840	2004-11-23	2004-11-23 00:00:00	2004-11-23	5001	0	\N	0	0	\N	\N	0	290706	0	127783003	4133840		
53364	4899	40758406	1921-11-28	1921-11-28 00:00:00	1921-11-28	5001	0	\N	0	0	\N	\N	0	325834	0	55277-8	40758406		
118889	3660	4052083	2003-03-14	2003-03-14 00:00:00	2003-03-14	5001	0	\N	0	0	\N	\N	0	243596	0	23426006	4052083		
2165	64	4024958	1982-02-15	1982-02-15 00:00:00	1982-02-15	5001	0	\N	0	0	\N	\N	0	4368	0	117015009	4024958		
18217	1659	3006322	1977-09-13	1977-09-13 00:00:00	1977-09-13	5001	0	\N	0	0	\N	\N	0	111557	0	8331-1	3006322		
119746	3694	4052083	1961-06-18	1961-06-18 00:00:00	1961-06-18	5001	0	\N	0	0	\N	\N	0	245475	0	23426006	4052083		
53656	1626	4133840	2009-11-15	2009-11-15 00:00:00	2009-11-15	5001	0	\N	0	0	\N	\N	0	109227	0	127783003	4133840		
31033	2834	40766240	1990-05-11	1990-05-11 00:00:00	1990-05-11	5001	0	\N	0	0	\N	\N	0	188179	0	63513-6	40766240		
31117	2844	3006322	1949-11-01	1949-11-01 00:00:00	1949-11-01	5001	0	\N	0	0	\N	\N	0	188879	0	8331-1	3006322		
60064	1834	4024958	2016-05-17	2016-05-17 00:00:00	2016-05-17	5001	0	\N	0	0	\N	\N	0	122517	0	117015009	4024958		
44222	4077	3006322	1988-10-26	1988-10-26 00:00:00	1988-10-26	5001	0	\N	0	0	\N	\N	0	270890	0	8331-1	3006322		
27430	2542	3000876	1986-06-26	1986-06-26 00:00:00	1986-06-26	5001	0	\N	0	0	\N	\N	0	168123	0	6082-2	3000876		
970	79	46235214	1947-07-25	1947-07-25 00:00:00	1947-07-25	5001	0	\N	0	0	\N	\N	0	5239	0	76690-7	46235214		
9250	877	3023430	1990-05-08	1990-05-08 00:00:00	1990-05-08	5001	0	\N	0	0	\N	\N	0	58446	0	6833-8	3023430		
38772	3583	3036780	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	238256	0	6095-4	3036780		
50513	4608	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	307083	0	6273-7	3006451		
23346	2152	3006322	1985-07-27	1985-07-27 00:00:00	1985-07-27	5001	0	\N	0	0	\N	\N	0	143426	0	8331-1	3006322		
127982	3939	4052083	2013-03-29	2013-03-29 00:00:00	2013-03-29	5001	0	\N	0	0	\N	\N	0	261843	0	23426006	4052083		
14984	1389	3006322	1966-06-22	1966-06-22 00:00:00	1966-06-22	5001	0	\N	0	0	\N	\N	0	92149	0	8331-1	3006322		
7306	704	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	46536	0	6273-7	3006451		
9255	295	4024958	1992-05-22	1992-05-22 00:00:00	1992-05-22	5001	0	\N	0	0	\N	\N	0	19601	0	117015009	4024958		
28356	2622	3006322	1996-03-24	1996-03-24 00:00:00	1996-03-24	5001	0	\N	0	0	\N	\N	0	173427	0	8331-1	3006322		
39775	3695	3027970	1996-03-20	1996-03-20 00:00:00	1996-03-20	5001	0	\N	0	0	\N	\N	0	245605	0	10834-0	3027970		
10412	1015	46235214	2018-05-03	2018-05-03 00:00:00	2018-05-03	5001	0	\N	0	0	\N	\N	0	66771	0	76690-7	46235214		
10489	1018	3006322	1989-10-05	1989-10-05 00:00:00	1989-10-05	5001	0	\N	0	0	\N	\N	0	67013	0	8331-1	3006322		
41644	3874	3014599	1994-12-28	1994-12-28 00:00:00	1994-12-28	5001	0	\N	0	0	\N	\N	0	257207	0	6106-9	3014599		
217	5	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	408	0	6273-7	3006451		
114093	3518	4024958	1963-02-05	1963-02-05 00:00:00	1963-02-05	5001	0	\N	0	0	\N	\N	0	233551	0	117015009	4024958		
2314	209	3006322	1964-10-14	1964-10-14 00:00:00	1964-10-14	5001	0	\N	0	0	\N	\N	0	14262	0	8331-1	3006322		
32428	2945	3011505	2008-01-08	2008-01-08 00:00:00	2008-01-08	5001	0	\N	0	0	\N	\N	0	196517	0	19926-5	3011505		
1534	137	3006322	1978-11-04	1978-11-04 00:00:00	1978-11-04	5001	0	\N	0	0	\N	\N	0	9124	0	8331-1	3006322		
1536	137	3006322	2003-10-17	2003-10-17 00:00:00	2003-10-17	5001	0	\N	0	0	\N	\N	0	9150	0	8331-1	3006322		
12598	1206	3005136	1988-02-28	1988-02-28 00:00:00	1988-02-28	5001	0	\N	0	0	\N	\N	0	79246	0	6075-6	3005136		
48925	4477	3006322	1974-03-27	1974-03-27 00:00:00	1974-03-27	5001	0	\N	0	0	\N	\N	0	297950	0	8331-1	3006322		
46031	4246	46235214	1977-07-23	1977-07-23 00:00:00	1977-07-23	5001	0	\N	0	0	\N	\N	0	281939	0	76690-7	46235214		
24442	2258	3006322	1968-04-01	1968-04-01 00:00:00	1968-04-01	5001	0	\N	0	0	\N	\N	0	150074	0	8331-1	3006322		
22371	2053	40766240	1964-12-21	1964-12-21 00:00:00	1964-12-21	5001	0	\N	0	0	\N	\N	0	136506	0	63513-6	40766240		
16441	512	4052083	2013-06-07	2013-06-07 00:00:00	2013-06-07	5001	0	\N	0	0	\N	\N	0	34220	0	23426006	4052083		
46902	4317	3006322	1953-02-05	1953-02-05 00:00:00	1953-02-05	5001	0	\N	0	0	\N	\N	0	286490	0	8331-1	3006322		
45161	4167	3006734	1995-03-29	1995-03-29 00:00:00	1995-03-29	5001	0	\N	0	0	\N	\N	0	276898	0	6189-5	3006734		
35047	3200	3006322	1993-02-20	1993-02-20 00:00:00	1993-02-20	5001	0	\N	0	0	\N	\N	0	212833	0	8331-1	3006322		
3990	399	3006322	1967-12-05	1967-12-05 00:00:00	1967-12-05	5001	0	\N	0	0	\N	\N	0	26172	0	8331-1	3006322		
26961	2498	3006322	1996-10-25	1996-10-25 00:00:00	1996-10-25	5001	0	\N	0	0	\N	\N	0	165376	0	8331-1	3006322		
63409	1950	4133840	2002-11-21	2002-11-21 00:00:00	2002-11-21	5001	0	\N	0	0	\N	\N	0	129694	0	127783003	4133840		
134352	4137	4133840	2012-02-01	2012-02-01 00:00:00	2012-02-01	5001	0	\N	0	0	\N	\N	0	275026	0	127783003	4133840		
35136	3212	3015632	2018-07-21	2018-07-21 00:00:00	2018-07-21	5001	0	\N	0	0	\N	\N	0	213430	0	2028-9	3015632		
24542	2261	40766240	1966-01-28	1966-01-28 00:00:00	1966-01-28	5001	0	\N	0	0	\N	\N	0	150312	0	63513-6	40766240		
30490	2790	3006322	1983-05-28	1983-05-28 00:00:00	1983-05-28	5001	0	\N	0	0	\N	\N	0	184869	0	8331-1	3006322		
35992	3311	3006451	1990-03-30	1990-03-30 00:00:00	1990-03-30	5001	0	\N	0	0	\N	\N	0	219805	0	6273-7	3006451		
57417	5272	3006322	1923-09-09	1923-09-09 00:00:00	1923-09-09	5001	0	\N	0	0	\N	\N	0	350652	0	8331-1	3006322		
142321	4376	4133840	1977-07-12	1977-07-12 00:00:00	1977-07-12	5001	0	\N	0	0	\N	\N	0	290817	0	127783003	4133840		
53365	4899	40766240	1921-11-28	1921-11-28 00:00:00	1921-11-28	5001	0	\N	0	0	\N	\N	0	325834	0	63513-6	40766240		
118898	3660	4052083	2005-04-28	2005-04-28 00:00:00	2005-04-28	5001	0	\N	0	0	\N	\N	0	243565	0	23426006	4052083		
2183	65	4024958	2011-09-21	2011-09-21 00:00:00	2011-09-21	5001	0	\N	0	0	\N	\N	0	4405	0	117015009	4024958		
18244	1661	3006322	1994-08-28	1994-08-28 00:00:00	1994-08-28	5001	0	\N	0	0	\N	\N	0	111692	0	8331-1	3006322		
80898	2497	4052083	1983-09-24	1983-09-24 00:00:00	1983-09-24	5001	0	\N	0	0	\N	\N	0	165350	0	23426006	4052083		
53658	1626	4133840	2008-11-09	2008-11-09 00:00:00	2008-11-09	5001	0	\N	0	0	\N	\N	0	109237	0	127783003	4133840		
31034	2834	46235214	1990-05-11	1990-05-11 00:00:00	1990-05-11	5001	0	\N	0	0	\N	\N	0	188179	0	76690-7	46235214		
31118	2844	3006322	1982-08-19	1982-08-19 00:00:00	1982-08-19	5001	0	\N	0	0	\N	\N	0	188885	0	8331-1	3006322		
60066	1834	4024958	1985-01-13	1985-01-13 00:00:00	1985-01-13	5001	0	\N	0	0	\N	\N	0	122483	0	117015009	4024958		
44223	4077	3006322	1998-04-18	1998-04-18 00:00:00	1998-04-18	5001	0	\N	0	0	\N	\N	0	270914	0	8331-1	3006322		
27431	2542	3036780	1986-06-26	1986-06-26 00:00:00	1986-06-26	5001	0	\N	0	0	\N	\N	0	168123	0	6095-4	3036780		
971	79	40758406	1947-07-25	1947-07-25 00:00:00	1947-07-25	5001	0	\N	0	0	\N	\N	0	5239	0	55277-8	40758406		
9251	877	3000876	1990-05-08	1990-05-08 00:00:00	1990-05-08	5001	0	\N	0	0	\N	\N	0	58446	0	6082-2	3000876		
38773	3583	3006734	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	238256	0	6189-5	3006734		
50514	4608	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	307083	0	6106-9	3014599		
23347	2152	3006322	1958-11-08	1958-11-08 00:00:00	1958-11-08	5001	0	\N	0	0	\N	\N	0	143423	0	8331-1	3006322		
139269	4289	4024958	2002-08-03	2002-08-03 00:00:00	2002-08-03	5001	0	\N	0	0	\N	\N	0	284748	0	117015009	4024958		
14985	1389	3006322	2006-01-17	2006-01-17 00:00:00	2006-01-17	5001	0	\N	0	0	\N	\N	0	92221	0	8331-1	3006322		
7307	704	3019406	1986-12-25	1986-12-25 00:00:00	1986-12-25	5001	0	\N	0	0	\N	\N	0	46535	0	6158-0	3019406		
9258	295	4052083	1990-04-02	1990-04-02 00:00:00	1990-04-02	5001	0	\N	0	0	\N	\N	0	19632	0	23426006	4052083		
28357	2622	3049273	1998-10-03	1998-10-03 00:00:00	1998-10-03	5001	0	\N	0	0	\N	\N	0	173404	0	38265-5	3049273		
39776	3695	3009542	1996-03-20	1996-03-20 00:00:00	1996-03-20	5001	0	\N	0	0	\N	\N	0	245605	0	20570-8	3009542		
10413	1015	40766240	2018-05-03	2018-05-03 00:00:00	2018-05-03	5001	0	\N	0	0	\N	\N	0	66771	0	63513-6	40766240		
10490	1018	3006322	2018-01-14	2018-01-14 00:00:00	2018-01-14	5001	0	\N	0	0	\N	\N	0	67032	0	8331-1	3006322		
41645	3874	46235214	1983-04-22	1983-04-22 00:00:00	1983-04-22	5001	0	\N	0	0	\N	\N	0	257206	0	76690-7	46235214		
218	5	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	408	0	6246-3	3021226		
114099	3518	4024958	1984-03-20	1984-03-20 00:00:00	1984-03-20	5001	0	\N	0	0	\N	\N	0	233594	0	117015009	4024958		
2316	211	3006322	1998-05-14	1998-05-14 00:00:00	1998-05-14	5001	0	\N	0	0	\N	\N	0	14353	0	8331-1	3006322		
32429	2945	3011505	1976-12-07	1976-12-07 00:00:00	1976-12-07	5001	0	\N	0	0	\N	\N	0	196509	0	19926-5	3011505		
1535	137	3006322	2005-11-15	2005-11-15 00:00:00	2005-11-15	5001	0	\N	0	0	\N	\N	0	9231	0	8331-1	3006322		
1537	137	3006322	1989-04-01	1989-04-01 00:00:00	1989-04-01	5001	0	\N	0	0	\N	\N	0	9133	0	8331-1	3006322		
12599	1206	3015076	1988-02-28	1988-02-28 00:00:00	1988-02-28	5001	0	\N	0	0	\N	\N	0	79246	0	6248-9	3015076		
48926	4477	3006322	1971-11-24	1971-11-24 00:00:00	1971-11-24	5001	0	\N	0	0	\N	\N	0	297963	0	8331-1	3006322		
626	40	3006322	2003-02-05	2003-02-05 00:00:00	2003-02-05	5001	0	\N	0	0	\N	\N	0	2802	0	8331-1	3006322		
24463	2260	3049273	2012-09-30	2012-09-30 00:00:00	2012-09-30	5001	0	\N	0	0	\N	\N	0	150193	0	38265-5	3049273		
22372	2053	46235214	1964-12-21	1964-12-21 00:00:00	1964-12-21	5001	0	\N	0	0	\N	\N	0	136506	0	76690-7	46235214		
27783	865	4052083	1945-09-01	1945-09-01 00:00:00	1945-09-01	5001	0	\N	0	0	\N	\N	0	57392	0	23426006	4052083		
46903	4317	3006322	1955-02-06	1955-02-06 00:00:00	1955-02-06	5001	0	\N	0	0	\N	\N	0	286497	0	8331-1	3006322		
45162	4167	3001488	1995-03-29	1995-03-29 00:00:00	1995-03-29	5001	0	\N	0	0	\N	\N	0	276898	0	7258-7	3001488		
35048	3200	3006322	1963-09-17	1963-09-17 00:00:00	1963-09-17	5001	0	\N	0	0	\N	\N	0	212789	0	8331-1	3006322		
3991	399	3036780	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	26139	0	6095-4	3036780		
26962	2498	3006322	1975-12-19	1975-12-19 00:00:00	1975-12-19	5001	0	\N	0	0	\N	\N	0	165384	0	8331-1	3006322		
63413	1950	4052083	1998-12-09	1998-12-09 00:00:00	1998-12-09	5001	0	\N	0	0	\N	\N	0	129667	0	23426006	4052083		
134355	4137	4024958	1964-01-11	1964-01-11 00:00:00	1964-01-11	5001	0	\N	0	0	\N	\N	0	274991	0	117015009	4024958		
35137	3212	3000963	2018-07-21	2018-07-21 00:00:00	2018-07-21	5001	0	\N	0	0	\N	\N	0	213430	0	718-7	3000963		
24543	2261	40758406	1966-01-28	1966-01-28 00:00:00	1966-01-28	5001	0	\N	0	0	\N	\N	0	150312	0	55277-8	40758406		
30491	2790	3006322	1967-08-28	1967-08-28 00:00:00	1967-08-28	5001	0	\N	0	0	\N	\N	0	184868	0	8331-1	3006322		
35993	3311	3005136	1990-03-30	1990-03-30 00:00:00	1990-03-30	5001	0	\N	0	0	\N	\N	0	219805	0	6075-6	3005136		
57418	5272	3006322	1957-05-24	1957-05-24 00:00:00	1957-05-24	5001	0	\N	0	0	\N	\N	0	350712	0	8331-1	3006322		
142329	4376	4133840	2018-02-06	2018-02-06 00:00:00	2018-02-06	5001	0	\N	0	0	\N	\N	0	290829	0	127783003	4133840		
53367	4899	40758406	1922-01-27	1922-01-27 00:00:00	1922-01-27	5001	0	\N	0	0	\N	\N	0	325763	0	55277-8	40758406		
118909	3660	4024958	1978-02-04	1978-02-04 00:00:00	1978-02-04	5001	0	\N	0	0	\N	\N	0	243584	0	117015009	4024958		
2194	65	4024958	2004-11-06	2004-11-06 00:00:00	2004-11-06	5001	0	\N	0	0	\N	\N	0	4404	0	117015009	4024958		
18245	1661	3049273	2018-11-16	2018-11-16 00:00:00	2018-11-16	5001	0	\N	0	0	\N	\N	0	111657	0	38265-5	3049273		
80905	2498	4052083	1992-01-22	1992-01-22 00:00:00	1992-01-22	5001	0	\N	0	0	\N	\N	0	165375	0	23426006	4052083		
53660	1626	4024958	1987-10-28	1987-10-28 00:00:00	1987-10-28	5001	0	\N	0	0	\N	\N	0	109274	0	117015009	4024958		
31037	2834	40766240	1991-01-06	1991-01-06 00:00:00	1991-01-06	5001	0	\N	0	0	\N	\N	0	188124	0	63513-6	40766240		
31119	2845	3006322	2009-05-13	2009-05-13 00:00:00	2009-05-13	5001	0	\N	0	0	\N	\N	0	188959	0	8331-1	3006322		
60074	1834	4024958	1989-06-13	1989-06-13 00:00:00	1989-06-13	5001	0	\N	0	0	\N	\N	0	122561	0	117015009	4024958		
44224	4078	3006322	2006-07-26	2006-07-26 00:00:00	2006-07-26	5001	0	\N	0	0	\N	\N	0	271080	0	8331-1	3006322		
27432	2542	3015076	1986-06-26	1986-06-26 00:00:00	1986-06-26	5001	0	\N	0	0	\N	\N	0	168123	0	6248-9	3015076		
973	79	3051031	1947-06-25	1947-06-25 00:00:00	1947-06-25	5001	0	\N	0	0	\N	\N	0	5248	0	46240-8	3051031		
9252	877	3005136	1990-05-08	1990-05-08 00:00:00	1990-05-08	5001	0	\N	0	0	\N	\N	0	58446	0	6075-6	3005136		
38774	3583	3001247	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	238256	0	6085-5	3001247		
50515	4608	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	307083	0	6844-5	3020655		
23348	2152	3006322	1924-05-05	1924-05-05 00:00:00	1924-05-05	5001	0	\N	0	0	\N	\N	0	143431	0	8331-1	3006322		
139275	4289	4024958	1944-11-07	1944-11-07 00:00:00	1944-11-07	5001	0	\N	0	0	\N	\N	0	284762	0	117015009	4024958		
14986	1390	3006322	2001-02-22	2001-02-22 00:00:00	2001-02-22	5001	0	\N	0	0	\N	\N	0	92261	0	8331-1	3006322		
7308	704	3005136	1986-12-25	1986-12-25 00:00:00	1986-12-25	5001	0	\N	0	0	\N	\N	0	46535	0	6075-6	3005136		
146795	4503	4024958	1948-03-23	1948-03-23 00:00:00	1948-03-23	5001	0	\N	0	0	\N	\N	0	299808	0	117015009	4024958		
28358	2622	3006322	1953-01-30	1953-01-30 00:00:00	1953-01-30	5001	0	\N	0	0	\N	\N	0	173426	0	8331-1	3006322		
39777	3695	3028833	1996-03-20	1996-03-20 00:00:00	1996-03-20	5001	0	\N	0	0	\N	\N	0	245605	0	42719-5	3028833		
10416	1015	3051031	2018-03-04	2018-03-04 00:00:00	2018-03-04	5001	0	\N	0	0	\N	\N	0	66808	0	46240-8	3051031		
10495	1022	3006322	1965-06-26	1965-06-26 00:00:00	1965-06-26	5001	0	\N	0	0	\N	\N	0	67268	0	8331-1	3006322		
41647	3874	40766240	1983-04-22	1983-04-22 00:00:00	1983-04-22	5001	0	\N	0	0	\N	\N	0	257206	0	63513-6	40766240		
219	5	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	408	0	6206-7	3012494		
114107	3518	4024958	1987-05-16	1987-05-16 00:00:00	1987-05-16	5001	0	\N	0	0	\N	\N	0	233556	0	117015009	4024958		
2317	211	3006322	1972-11-16	1972-11-16 00:00:00	1972-11-16	5001	0	\N	0	0	\N	\N	0	14372	0	8331-1	3006322		
32430	2945	3006322	1998-11-02	1998-11-02 00:00:00	1998-11-02	5001	0	\N	0	0	\N	\N	0	196458	0	8331-1	3006322		
162655	4990	4024958	2006-09-03	2006-09-03 00:00:00	2006-09-03	5001	0	\N	0	0	\N	\N	0	331956	0	117015009	4024958		
1538	137	3006322	1990-07-04	1990-07-04 00:00:00	1990-07-04	5001	0	\N	0	0	\N	\N	0	9216	0	8331-1	3006322		
12600	1206	3006322	1995-05-02	1995-05-02 00:00:00	1995-05-02	5001	0	\N	0	0	\N	\N	0	79249	0	8331-1	3006322		
48927	4477	3006322	1975-08-28	1975-08-28 00:00:00	1975-08-28	5001	0	\N	0	0	\N	\N	0	297941	0	8331-1	3006322		
627	40	3006322	1977-12-15	1977-12-15 00:00:00	1977-12-15	5001	0	\N	0	0	\N	\N	0	2833	0	8331-1	3006322		
24464	2260	3006322	1982-02-10	1982-02-10 00:00:00	1982-02-10	5001	0	\N	0	0	\N	\N	0	150195	0	8331-1	3006322		
22374	2053	40758406	1964-12-21	1964-12-21 00:00:00	1964-12-21	5001	0	\N	0	0	\N	\N	0	136506	0	55277-8	40758406		
27787	865	4052083	1957-06-05	1957-06-05 00:00:00	1957-06-05	5001	0	\N	0	0	\N	\N	0	57414	0	23426006	4052083		
46904	4317	3006322	1981-08-22	1981-08-22 00:00:00	1981-08-22	5001	0	\N	0	0	\N	\N	0	286500	0	8331-1	3006322		
45163	4167	3036780	1995-03-29	1995-03-29 00:00:00	1995-03-29	5001	0	\N	0	0	\N	\N	0	276898	0	6095-4	3036780		
35049	3201	3006322	1971-10-14	1971-10-14 00:00:00	1971-10-14	5001	0	\N	0	0	\N	\N	0	212897	0	8331-1	3006322		
3992	399	3001488	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	26139	0	7258-7	3001488		
26963	2498	3006322	1985-11-09	1985-11-09 00:00:00	1985-11-09	5001	0	\N	0	0	\N	\N	0	165406	0	8331-1	3006322		
63416	1950	4133840	1987-01-15	1987-01-15 00:00:00	1987-01-15	5001	0	\N	0	0	\N	\N	0	129680	0	127783003	4133840		
134356	4137	4133840	2013-02-06	2013-02-06 00:00:00	2013-02-06	5001	0	\N	0	0	\N	\N	0	275036	0	127783003	4133840		
35138	3212	3013682	2018-07-21	2018-07-21 00:00:00	2018-07-21	5001	0	\N	0	0	\N	\N	0	213430	0	3094-0	3013682		
24546	2261	40766240	1966-02-27	1966-02-27 00:00:00	1966-02-27	5001	0	\N	0	0	\N	\N	0	150282	0	63513-6	40766240		
30492	2790	3049273	2013-04-11	2013-04-11 00:00:00	2013-04-11	5001	0	\N	0	0	\N	\N	0	184866	0	38265-5	3049273		
35994	3311	3015076	1990-03-30	1990-03-30 00:00:00	1990-03-30	5001	0	\N	0	0	\N	\N	0	219805	0	6248-9	3015076		
57422	5274	3006322	1965-07-13	1965-07-13 00:00:00	1965-07-13	5001	0	\N	0	0	\N	\N	0	350799	0	8331-1	3006322		
142333	4376	4133840	2001-11-06	2001-11-06 00:00:00	2001-11-06	5001	0	\N	0	0	\N	\N	0	290836	0	127783003	4133840		
53368	4899	40766240	1922-01-27	1922-01-27 00:00:00	1922-01-27	5001	0	\N	0	0	\N	\N	0	325763	0	63513-6	40766240		
56063	1709	4024958	1955-09-05	1955-09-05 00:00:00	1955-09-05	5001	0	\N	0	0	\N	\N	0	114263	0	117015009	4024958		
2196	65	4024958	1991-07-04	1991-07-04 00:00:00	1991-07-04	5001	0	\N	0	0	\N	\N	0	4403	0	117015009	4024958		
18246	1661	3006322	1977-01-07	1977-01-07 00:00:00	1977-01-07	5001	0	\N	0	0	\N	\N	0	111665	0	8331-1	3006322		
92186	2842	4052083	2002-02-23	2002-02-23 00:00:00	2002-02-23	5001	0	\N	0	0	\N	\N	0	188650	0	23426006	4052083		
53672	1626	4133840	2007-11-04	2007-11-04 00:00:00	2007-11-04	5001	0	\N	0	0	\N	\N	0	109202	0	127783003	4133840		
31038	2834	3051031	1991-01-06	1991-01-06 00:00:00	1991-01-06	5001	0	\N	0	0	\N	\N	0	188124	0	46240-8	3051031		
31120	2845	3006322	1994-12-16	1994-12-16 00:00:00	1994-12-16	5001	0	\N	0	0	\N	\N	0	188902	0	8331-1	3006322		
60084	1834	4024958	1987-05-14	1987-05-14 00:00:00	1987-05-14	5001	0	\N	0	0	\N	\N	0	122484	0	117015009	4024958		
44225	4078	3006322	2007-05-07	2007-05-07 00:00:00	2007-05-07	5001	0	\N	0	0	\N	\N	0	271092	0	8331-1	3006322		
27433	2542	3005136	1986-06-26	1986-06-26 00:00:00	1986-06-26	5001	0	\N	0	0	\N	\N	0	168123	0	6075-6	3005136		
974	79	40758406	1947-06-25	1947-06-25 00:00:00	1947-06-25	5001	0	\N	0	0	\N	\N	0	5248	0	55277-8	40758406		
9253	877	3014599	1990-05-08	1990-05-08 00:00:00	1990-05-08	5001	0	\N	0	0	\N	\N	0	58446	0	6106-9	3014599		
38775	3583	3001488	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	238256	0	7258-7	3001488		
50516	4608	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	307083	0	6085-5	3001247		
23349	2152	3006322	1973-04-16	1973-04-16 00:00:00	1973-04-16	5001	0	\N	0	0	\N	\N	0	143436	0	8331-1	3006322		
139277	4289	4024958	2001-06-24	2001-06-24 00:00:00	2001-06-24	5001	0	\N	0	0	\N	\N	0	284747	0	117015009	4024958		
14987	1390	3006322	1972-07-27	1972-07-27 00:00:00	1972-07-27	5001	0	\N	0	0	\N	\N	0	92253	0	8331-1	3006322		
7309	704	3001247	1986-12-25	1986-12-25 00:00:00	1986-12-25	5001	0	\N	0	0	\N	\N	0	46535	0	6085-5	3001247		
146796	4503	4052083	1992-06-11	1992-06-11 00:00:00	1992-06-11	5001	0	\N	0	0	\N	\N	0	299866	0	23426006	4052083		
28359	2622	3006322	1945-06-15	1945-06-15 00:00:00	1945-06-15	5001	0	\N	0	0	\N	\N	0	173472	0	8331-1	3006322		
39778	3695	3024561	1996-03-20	1996-03-20 00:00:00	1996-03-20	5001	0	\N	0	0	\N	\N	0	245605	0	1751-7	3024561		
10417	1015	40758406	2018-03-04	2018-03-04 00:00:00	2018-03-04	5001	0	\N	0	0	\N	\N	0	66808	0	55277-8	40758406		
10496	1022	3006322	1990-10-10	1990-10-10 00:00:00	1990-10-10	5001	0	\N	0	0	\N	\N	0	67224	0	8331-1	3006322		
41649	3874	3051031	1983-04-22	1983-04-22 00:00:00	1983-04-22	5001	0	\N	0	0	\N	\N	0	257206	0	46240-8	3051031		
220	5	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	408	0	6085-5	3001247		
114108	3518	4052083	2014-06-29	2014-06-29 00:00:00	2014-06-29	5001	0	\N	0	0	\N	\N	0	233536	0	23426006	4052083		
2318	211	3006322	2016-02-22	2016-02-22 00:00:00	2016-02-22	5001	0	\N	0	0	\N	\N	0	14376	0	8331-1	3006322		
32431	2945	3006322	1951-07-29	1951-07-29 00:00:00	1951-07-29	5001	0	\N	0	0	\N	\N	0	196479	0	8331-1	3006322		
162669	4991	4024958	2009-03-04	2009-03-04 00:00:00	2009-03-04	5001	0	\N	0	0	\N	\N	0	332075	0	117015009	4024958		
1539	137	3006322	2011-01-02	2011-01-02 00:00:00	2011-01-02	5001	0	\N	0	0	\N	\N	0	9163	0	8331-1	3006322		
12601	1206	40769184	1988-02-14	1988-02-14 00:00:00	1988-02-14	5001	0	\N	0	0	\N	\N	0	79237	0	66524-0	40769184		
48976	4480	3006322	1969-02-28	1969-02-28 00:00:00	1969-02-28	5001	0	\N	0	0	\N	\N	0	298135	0	8331-1	3006322		
628	40	3006322	2016-02-23	2016-02-23 00:00:00	2016-02-23	5001	0	\N	0	0	\N	\N	0	2886	0	8331-1	3006322		
24465	2260	3006322	1975-11-14	1975-11-14 00:00:00	1975-11-14	5001	0	\N	0	0	\N	\N	0	150233	0	8331-1	3006322		
22375	2053	3051031	1964-12-21	1964-12-21 00:00:00	1964-12-21	5001	0	\N	0	0	\N	\N	0	136506	0	46240-8	3051031		
41246	3849	3006322	1975-08-02	1975-08-02 00:00:00	1975-08-02	5001	0	\N	0	0	\N	\N	0	255406	0	8331-1	3006322		
46905	4317	3049273	1998-11-05	1998-11-05 00:00:00	1998-11-05	5001	0	\N	0	0	\N	\N	0	286479	0	38265-5	3049273		
45164	4167	3012494	1995-03-29	1995-03-29 00:00:00	1995-03-29	5001	0	\N	0	0	\N	\N	0	276898	0	6206-7	3012494		
35050	3201	3006322	1956-11-04	1956-11-04 00:00:00	1956-11-04	5001	0	\N	0	0	\N	\N	0	212920	0	8331-1	3006322		
3993	399	3006734	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	26139	0	6189-5	3006734		
26964	2498	3006322	2008-06-10	2008-06-10 00:00:00	2008-06-10	5001	0	\N	0	0	\N	\N	0	165392	0	8331-1	3006322		
63418	1950	4133840	2015-01-29	2015-01-29 00:00:00	2015-01-29	5001	0	\N	0	0	\N	\N	0	129684	0	127783003	4133840		
134385	4139	4052083	2017-05-04	2017-05-04 00:00:00	2017-05-04	5001	0	\N	0	0	\N	\N	0	275157	0	23426006	4052083		
35139	3212	3020630	2018-07-21	2018-07-21 00:00:00	2018-07-21	5001	0	\N	0	0	\N	\N	0	213430	0	2885-2	3020630		
24547	2261	40758406	1966-02-27	1966-02-27 00:00:00	1966-02-27	5001	0	\N	0	0	\N	\N	0	150282	0	55277-8	40758406		
30493	2790	3006322	1994-01-17	1994-01-17 00:00:00	1994-01-17	5001	0	\N	0	0	\N	\N	0	184877	0	8331-1	3006322		
35995	3311	3012494	1990-03-30	1990-03-30 00:00:00	1990-03-30	5001	0	\N	0	0	\N	\N	0	219805	0	6206-7	3012494		
57423	5274	3049273	2006-06-16	2006-06-16 00:00:00	2006-06-16	5001	0	\N	0	0	\N	\N	0	350844	0	38265-5	3049273		
142335	4376	4133840	1976-07-06	1976-07-06 00:00:00	1976-07-06	5001	0	\N	0	0	\N	\N	0	290795	0	127783003	4133840		
53371	4899	3051031	1922-01-27	1922-01-27 00:00:00	1922-01-27	5001	0	\N	0	0	\N	\N	0	325763	0	46240-8	3051031		
56104	1713	4052083	2000-04-10	2000-04-10 00:00:00	2000-04-10	5001	0	\N	0	0	\N	\N	0	114469	0	23426006	4052083		
2198	65	4052083	2009-05-28	2009-05-28 00:00:00	2009-05-28	5001	0	\N	0	0	\N	\N	0	4422	0	23426006	4052083		
18247	1661	3006322	2008-05-29	2008-05-29 00:00:00	2008-05-29	5001	0	\N	0	0	\N	\N	0	111639	0	8331-1	3006322		
92192	2842	4052083	2017-02-12	2017-02-12 00:00:00	2017-02-12	5001	0	\N	0	0	\N	\N	0	188667	0	23426006	4052083		
53673	1626	4133840	2004-10-17	2004-10-17 00:00:00	2004-10-17	5001	0	\N	0	0	\N	\N	0	109218	0	127783003	4133840		
31040	2834	46235214	1991-01-06	1991-01-06 00:00:00	1991-01-06	5001	0	\N	0	0	\N	\N	0	188124	0	76690-7	46235214		
31121	2845	3006322	2015-04-24	2015-04-24 00:00:00	2015-04-24	5001	0	\N	0	0	\N	\N	0	188961	0	8331-1	3006322		
60426	1845	4024958	1962-01-17	1962-01-17 00:00:00	1962-01-17	5001	0	\N	0	0	\N	\N	0	123269	0	117015009	4024958		
44226	4078	40769179	1953-03-10	1953-03-10 00:00:00	1953-03-10	5001	0	\N	0	0	\N	\N	0	270974	0	66519-0	40769179		
27434	2542	3012494	1986-06-26	1986-06-26 00:00:00	1986-06-26	5001	0	\N	0	0	\N	\N	0	168123	0	6206-7	3012494		
975	79	40766240	1947-06-25	1947-06-25 00:00:00	1947-06-25	5001	0	\N	0	0	\N	\N	0	5248	0	63513-6	40766240		
9254	877	3006451	1990-05-08	1990-05-08 00:00:00	1990-05-08	5001	0	\N	0	0	\N	\N	0	58446	0	6273-7	3006451		
38776	3583	3020655	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	238256	0	6844-5	3020655		
50517	4608	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	307083	0	6095-4	3036780		
23350	2152	3006322	1949-07-14	1949-07-14 00:00:00	1949-07-14	5001	0	\N	0	0	\N	\N	0	143449	0	8331-1	3006322		
139289	4289	4024958	2016-09-24	2016-09-24 00:00:00	2016-09-24	5001	0	\N	0	0	\N	\N	0	284798	0	117015009	4024958		
14988	1390	3006322	1981-04-22	1981-04-22 00:00:00	1981-04-22	5001	0	\N	0	0	\N	\N	0	92290	0	8331-1	3006322		
7310	704	3001488	1986-12-25	1986-12-25 00:00:00	1986-12-25	5001	0	\N	0	0	\N	\N	0	46535	0	7258-7	3001488		
146801	4503	4052083	1977-08-20	1977-08-20 00:00:00	1977-08-20	5001	0	\N	0	0	\N	\N	0	299810	0	23426006	4052083		
28360	2622	3006322	1950-06-04	1950-06-04 00:00:00	1950-06-04	5001	0	\N	0	0	\N	\N	0	173473	0	8331-1	3006322		
39779	3695	3000963	1996-03-20	1996-03-20 00:00:00	1996-03-20	5001	0	\N	0	0	\N	\N	0	245605	0	718-7	3000963		
10418	1015	40766240	2018-03-04	2018-03-04 00:00:00	2018-03-04	5001	0	\N	0	0	\N	\N	0	66808	0	63513-6	40766240		
10497	1022	3006322	1968-01-25	1968-01-25 00:00:00	1968-01-25	5001	0	\N	0	0	\N	\N	0	67222	0	8331-1	3006322		
41650	3874	40758406	1983-04-22	1983-04-22 00:00:00	1983-04-22	5001	0	\N	0	0	\N	\N	0	257206	0	55277-8	40758406		
221	5	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	408	0	6833-8	3023430		
20951	1933	3006322	1999-10-20	1999-10-20 00:00:00	1999-10-20	5001	0	\N	0	0	\N	\N	0	128564	0	8331-1	3006322		
2319	211	3006322	1997-08-05	1997-08-05 00:00:00	1997-08-05	5001	0	\N	0	0	\N	\N	0	14396	0	8331-1	3006322		
32432	2945	3006322	1991-02-13	1991-02-13 00:00:00	1991-02-13	5001	0	\N	0	0	\N	\N	0	196546	0	8331-1	3006322		
162673	4991	4052083	1983-01-18	1983-01-18 00:00:00	1983-01-18	5001	0	\N	0	0	\N	\N	0	332029	0	23426006	4052083		
1540	137	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	9162	0	6189-5	3006734		
12602	1206	40769189	1988-02-14	1988-02-14 00:00:00	1988-02-14	5001	0	\N	0	0	\N	\N	0	79237	0	66529-9	40769189		
48977	4480	3006322	2002-12-11	2002-12-11 00:00:00	2002-12-11	5001	0	\N	0	0	\N	\N	0	298139	0	8331-1	3006322		
629	40	3006322	1974-12-21	1974-12-21 00:00:00	1974-12-21	5001	0	\N	0	0	\N	\N	0	2879	0	8331-1	3006322		
24466	2260	3006322	1992-08-28	1992-08-28 00:00:00	1992-08-28	5001	0	\N	0	0	\N	\N	0	150180	0	8331-1	3006322		
33653	3056	3006322	2016-12-28	2016-12-28 00:00:00	2016-12-28	5001	0	\N	0	0	\N	\N	0	203302	0	8331-1	3006322		
41247	3849	3006322	1965-02-14	1965-02-14 00:00:00	1965-02-14	5001	0	\N	0	0	\N	\N	0	255451	0	8331-1	3006322		
46906	4319	3011505	2012-04-18	2012-04-18 00:00:00	2012-04-18	5001	0	\N	0	0	\N	\N	0	286627	0	19926-5	3011505		
45165	4167	3006322	1983-10-24	1983-10-24 00:00:00	1983-10-24	5001	0	\N	0	0	\N	\N	0	276908	0	8331-1	3006322		
35052	3201	3006322	1959-06-02	1959-06-02 00:00:00	1959-06-02	5001	0	\N	0	0	\N	\N	0	212893	0	8331-1	3006322		
3994	399	3000876	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	26139	0	6082-2	3000876		
26990	2501	3006322	2014-07-11	2014-07-11 00:00:00	2014-07-11	5001	0	\N	0	0	\N	\N	0	165539	0	8331-1	3006322		
63423	1950	4133840	2000-11-09	2000-11-09 00:00:00	2000-11-09	5001	0	\N	0	0	\N	\N	0	129693	0	127783003	4133840		
134389	4139	4024958	1971-12-03	1971-12-03 00:00:00	1971-12-03	5001	0	\N	0	0	\N	\N	0	275133	0	117015009	4024958		
35140	3212	3045716	2018-07-21	2018-07-21 00:00:00	2018-07-21	5001	0	\N	0	0	\N	\N	0	213430	0	33037-3	3045716		
24548	2261	46235214	1966-02-27	1966-02-27 00:00:00	1966-02-27	5001	0	\N	0	0	\N	\N	0	150282	0	76690-7	46235214		
30494	2790	3006322	1953-05-21	1953-05-21 00:00:00	1953-05-21	5001	0	\N	0	0	\N	\N	0	184927	0	8331-1	3006322		
35996	3311	3001247	1990-03-30	1990-03-30 00:00:00	1990-03-30	5001	0	\N	0	0	\N	\N	0	219805	0	6085-5	3001247		
57424	5274	3006322	1954-11-26	1954-11-26 00:00:00	1954-11-26	5001	0	\N	0	0	\N	\N	0	350822	0	8331-1	3006322		
142336	4376	4133840	1987-08-18	1987-08-18 00:00:00	1987-08-18	5001	0	\N	0	0	\N	\N	0	290818	0	127783003	4133840		
53372	4899	46235214	1922-01-27	1922-01-27 00:00:00	1922-01-27	5001	0	\N	0	0	\N	\N	0	325763	0	76690-7	46235214		
56105	1713	4024958	2013-05-19	2013-05-19 00:00:00	2013-05-19	5001	0	\N	0	0	\N	\N	0	114497	0	117015009	4024958		
2207	65	4024958	2005-12-10	2005-12-10 00:00:00	2005-12-10	5001	0	\N	0	0	\N	\N	0	4398	0	117015009	4024958		
18248	1661	3006322	1991-11-03	1991-11-03 00:00:00	1991-11-03	5001	0	\N	0	0	\N	\N	0	111685	0	8331-1	3006322		
92204	2842	4052083	1989-07-16	1989-07-16 00:00:00	1989-07-16	5001	0	\N	0	0	\N	\N	0	188646	0	23426006	4052083		
53679	1626	4133840	2005-10-23	2005-10-23 00:00:00	2005-10-23	5001	0	\N	0	0	\N	\N	0	109201	0	127783003	4133840		
4502	437	3006322	1994-02-04	1994-02-04 00:00:00	1994-02-04	5001	0	\N	0	0	\N	\N	0	29029	0	8331-1	3006322		
31122	2845	3006322	1982-03-12	1982-03-12 00:00:00	1982-03-12	5001	0	\N	0	0	\N	\N	0	188901	0	8331-1	3006322		
60432	1845	4024958	1979-02-19	1979-02-19 00:00:00	1979-02-19	5001	0	\N	0	0	\N	\N	0	123327	0	117015009	4024958		
44227	4078	40769189	1953-03-10	1953-03-10 00:00:00	1953-03-10	5001	0	\N	0	0	\N	\N	0	270974	0	66529-9	40769189		
27435	2542	3014599	1986-06-26	1986-06-26 00:00:00	1986-06-26	5001	0	\N	0	0	\N	\N	0	168123	0	6106-9	3014599		
976	79	3006322	1954-01-17	1954-01-17 00:00:00	1954-01-17	5001	0	\N	0	0	\N	\N	0	5254	0	8331-1	3006322		
9255	877	3021226	1990-05-08	1990-05-08 00:00:00	1990-05-08	5001	0	\N	0	0	\N	\N	0	58446	0	6246-3	3021226		
38777	3583	3015076	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	238256	0	6248-9	3015076		
50518	4608	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	307083	0	6276-0	3027231		
23351	2152	3006322	2010-08-20	2010-08-20 00:00:00	2010-08-20	5001	0	\N	0	0	\N	\N	0	143380	0	8331-1	3006322		
23426	2160	3006322	2003-03-20	2003-03-20 00:00:00	2003-03-20	5001	0	\N	0	0	\N	\N	0	143984	0	8331-1	3006322		
14990	1391	3006322	1927-08-14	1927-08-14 00:00:00	1927-08-14	5001	0	\N	0	0	\N	\N	0	92310	0	8331-1	3006322		
7311	704	3027231	1986-12-25	1986-12-25 00:00:00	1986-12-25	5001	0	\N	0	0	\N	\N	0	46535	0	6276-0	3027231		
146819	4503	4052083	1998-12-24	1998-12-24 00:00:00	1998-12-24	5001	0	\N	0	0	\N	\N	0	299882	0	23426006	4052083		
28361	2622	3006322	1990-01-13	1990-01-13 00:00:00	1990-01-13	5001	0	\N	0	0	\N	\N	0	173477	0	8331-1	3006322		
39780	3695	3014576	1996-03-20	1996-03-20 00:00:00	1996-03-20	5001	0	\N	0	0	\N	\N	0	245605	0	2075-0	3014576		
10419	1015	46235214	2018-03-04	2018-03-04 00:00:00	2018-03-04	5001	0	\N	0	0	\N	\N	0	66808	0	76690-7	46235214		
10498	1022	3006322	1973-11-09	1973-11-09 00:00:00	1973-11-09	5001	0	\N	0	0	\N	\N	0	67230	0	8331-1	3006322		
41651	3874	3006322	1985-03-08	1985-03-08 00:00:00	1985-03-08	5001	0	\N	0	0	\N	\N	0	257237	0	8331-1	3006322		
222	5	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	408	0	6095-4	3036780		
20952	1933	3006322	1968-06-25	1968-06-25 00:00:00	1968-06-25	5001	0	\N	0	0	\N	\N	0	128545	0	8331-1	3006322		
2320	211	3006322	1976-07-15	1976-07-15 00:00:00	1976-07-15	5001	0	\N	0	0	\N	\N	0	14374	0	8331-1	3006322		
32433	2945	3006322	2002-02-25	2002-02-25 00:00:00	2002-02-25	5001	0	\N	0	0	\N	\N	0	196459	0	8331-1	3006322		
162683	4991	4052083	1985-04-23	1985-04-23 00:00:00	1985-04-23	5001	0	\N	0	0	\N	\N	0	332021	0	23426006	4052083		
1541	137	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	9162	0	6833-8	3023430		
12603	1206	40769194	1988-02-14	1988-02-14 00:00:00	1988-02-14	5001	0	\N	0	0	\N	\N	0	79237	0	66534-9	40769194		
48978	4480	3006322	1977-12-24	1977-12-24 00:00:00	1977-12-24	5001	0	\N	0	0	\N	\N	0	298191	0	8331-1	3006322		
630	40	3006322	1959-07-30	1959-07-30 00:00:00	1959-07-30	5001	0	\N	0	0	\N	\N	0	2876	0	8331-1	3006322		
24467	2260	3006322	1976-03-28	1976-03-28 00:00:00	1976-03-28	5001	0	\N	0	0	\N	\N	0	150234	0	8331-1	3006322		
33654	3056	3006322	1988-09-18	1988-09-18 00:00:00	1988-09-18	5001	0	\N	0	0	\N	\N	0	203231	0	8331-1	3006322		
41248	3849	3009542	2015-11-08	2015-11-08 00:00:00	2015-11-08	5001	0	\N	0	0	\N	\N	0	255395	0	20570-8	3009542		
46907	4319	3011505	2002-12-25	2002-12-25 00:00:00	2002-12-25	5001	0	\N	0	0	\N	\N	0	286589	0	19926-5	3011505		
45166	4167	3006322	1990-07-02	1990-07-02 00:00:00	1990-07-02	5001	0	\N	0	0	\N	\N	0	276923	0	8331-1	3006322		
46362	4269	3006322	1981-10-04	1981-10-04 00:00:00	1981-10-04	5001	0	\N	0	0	\N	\N	0	283366	0	8331-1	3006322		
3995	399	3014599	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	26139	0	6106-9	3014599		
26991	2501	3006322	1974-05-27	1974-05-27 00:00:00	1974-05-27	5001	0	\N	0	0	\N	\N	0	165547	0	8331-1	3006322		
63424	1950	4052083	2017-02-03	2017-02-03 00:00:00	2017-02-03	5001	0	\N	0	0	\N	\N	0	129632	0	23426006	4052083		
10204	327	4024958	1990-10-20	1990-10-20 00:00:00	1990-10-20	5001	0	\N	0	0	\N	\N	0	21594	0	117015009	4024958		
35141	3212	3006322	2006-08-18	2006-08-18 00:00:00	2006-08-18	5001	0	\N	0	0	\N	\N	0	213420	0	8331-1	3006322		
24549	2261	3051031	1966-02-27	1966-02-27 00:00:00	1966-02-27	5001	0	\N	0	0	\N	\N	0	150282	0	46240-8	3051031		
44518	4109	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	273200	0	6085-5	3001247		
35997	3311	3001488	1990-03-30	1990-03-30 00:00:00	1990-03-30	5001	0	\N	0	0	\N	\N	0	219805	0	7258-7	3001488		
57425	5274	3006322	2002-10-01	2002-10-01 00:00:00	2002-10-01	5001	0	\N	0	0	\N	\N	0	350768	0	8331-1	3006322		
142339	4376	4133840	1978-07-18	1978-07-18 00:00:00	1978-07-18	5001	0	\N	0	0	\N	\N	0	290796	0	127783003	4133840		
53373	4899	3011505	1982-08-10	1982-08-10 00:00:00	1982-08-10	5001	0	\N	0	0	\N	\N	0	325859	0	19926-5	3011505		
56110	1713	4052083	1999-01-14	1999-01-14 00:00:00	1999-01-14	5001	0	\N	0	0	\N	\N	0	114435	0	23426006	4052083		
105702	3253	4024958	2005-09-19	2005-09-19 00:00:00	2005-09-19	5001	0	\N	0	0	\N	\N	0	216295	0	117015009	4024958		
18249	1661	3006322	2010-06-03	2010-06-03 00:00:00	2010-06-03	5001	0	\N	0	0	\N	\N	0	111693	0	8331-1	3006322		
92224	2843	4052083	1960-02-29	1960-02-29 00:00:00	1960-02-29	5001	0	\N	0	0	\N	\N	0	188730	0	23426006	4052083		
53682	1626	4133840	2002-10-06	2002-10-06 00:00:00	2002-10-06	5001	0	\N	0	0	\N	\N	0	109217	0	127783003	4133840		
4503	437	3049273	2017-11-06	2017-11-06 00:00:00	2017-11-06	5001	0	\N	0	0	\N	\N	0	29054	0	38265-5	3049273		
2707	266	3036780	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	17652	0	6095-4	3036780		
60434	1845	4052083	1972-04-22	1972-04-22 00:00:00	1972-04-22	5001	0	\N	0	0	\N	\N	0	123365	0	23426006	4052083		
44228	4078	40769184	1953-03-10	1953-03-10 00:00:00	1953-03-10	5001	0	\N	0	0	\N	\N	0	270974	0	66524-0	40769184		
27436	2542	3001488	1986-06-26	1986-06-26 00:00:00	1986-06-26	5001	0	\N	0	0	\N	\N	0	168123	0	7258-7	3001488		
979	79	3051031	1947-10-22	1947-10-22 00:00:00	1947-10-22	5001	0	\N	0	0	\N	\N	0	5240	0	46240-8	3051031		
9256	877	3005136	1993-11-09	1993-11-09 00:00:00	1993-11-09	5001	0	\N	0	0	\N	\N	0	58381	0	6075-6	3005136		
38778	3583	3012494	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	238256	0	6206-7	3012494		
50519	4608	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	307083	0	6246-3	3021226		
23352	2152	3006322	1936-06-28	1936-06-28 00:00:00	1936-06-28	5001	0	\N	0	0	\N	\N	0	143421	0	8331-1	3006322		
23427	2160	3006322	1974-05-16	1974-05-16 00:00:00	1974-05-16	5001	0	\N	0	0	\N	\N	0	143977	0	8331-1	3006322		
14991	1391	3049273	1980-11-19	1980-11-19 00:00:00	1980-11-19	5001	0	\N	0	0	\N	\N	0	92309	0	38265-5	3049273		
7312	704	3006451	1986-12-25	1986-12-25 00:00:00	1986-12-25	5001	0	\N	0	0	\N	\N	0	46535	0	6273-7	3006451		
146822	4503	4052083	1944-07-11	1944-07-11 00:00:00	1944-07-11	5001	0	\N	0	0	\N	\N	0	299864	0	23426006	4052083		
28362	2622	3006322	1971-02-08	1971-02-08 00:00:00	1971-02-08	5001	0	\N	0	0	\N	\N	0	173475	0	8331-1	3006322		
39781	3695	3010813	1996-03-20	1996-03-20 00:00:00	1996-03-20	5001	0	\N	0	0	\N	\N	0	245605	0	26464-8	3010813		
10420	1015	40758406	2005-04-11	2005-04-11 00:00:00	2005-04-11	5001	0	\N	0	0	\N	\N	0	66794	0	55277-8	40758406		
10499	1022	3006322	1985-02-23	1985-02-23 00:00:00	1985-02-23	5001	0	\N	0	0	\N	\N	0	67270	0	8331-1	3006322		
41652	3874	3006322	2016-06-09	2016-06-09 00:00:00	2016-06-09	5001	0	\N	0	0	\N	\N	0	257288	0	8331-1	3006322		
223	5	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	408	0	6106-9	3014599		
20953	1933	3006322	2016-11-05	2016-11-05 00:00:00	2016-11-05	5001	0	\N	0	0	\N	\N	0	128550	0	8331-1	3006322		
2321	212	3006322	1984-12-18	1984-12-18 00:00:00	1984-12-18	5001	0	\N	0	0	\N	\N	0	14467	0	8331-1	3006322		
32434	2945	3011505	2003-09-02	2003-09-02 00:00:00	2003-09-02	5001	0	\N	0	0	\N	\N	0	196487	0	19926-5	3011505		
94022	2894	4024958	1966-08-01	1966-08-01 00:00:00	1966-08-01	5001	0	\N	0	0	\N	\N	0	192636	0	117015009	4024958		
1542	137	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	9162	0	6085-5	3001247		
12604	1206	40769179	1988-02-14	1988-02-14 00:00:00	1988-02-14	5001	0	\N	0	0	\N	\N	0	79237	0	66519-0	40769179		
48979	4480	3006322	1966-09-01	1966-09-01 00:00:00	1966-09-01	5001	0	\N	0	0	\N	\N	0	298190	0	8331-1	3006322		
631	40	3006322	1983-09-01	1983-09-01 00:00:00	1983-09-01	5001	0	\N	0	0	\N	\N	0	2870	0	8331-1	3006322		
24468	2260	3049273	1994-09-02	1994-09-02 00:00:00	1994-09-02	5001	0	\N	0	0	\N	\N	0	150220	0	38265-5	3049273		
33655	3056	3006322	1977-09-01	1977-09-01 00:00:00	1977-09-01	5001	0	\N	0	0	\N	\N	0	203288	0	8331-1	3006322		
41249	3849	3000963	2015-11-08	2015-11-08 00:00:00	2015-11-08	5001	0	\N	0	0	\N	\N	0	255395	0	718-7	3000963		
46908	4319	3011505	2017-12-13	2017-12-13 00:00:00	2017-12-13	5001	0	\N	0	0	\N	\N	0	286610	0	19926-5	3011505		
45167	4168	3006322	1973-04-26	1973-04-26 00:00:00	1973-04-26	5001	0	\N	0	0	\N	\N	0	277038	0	8331-1	3006322		
46363	4269	3006322	2005-03-29	2005-03-29 00:00:00	2005-03-29	5001	0	\N	0	0	\N	\N	0	283358	0	8331-1	3006322		
3996	399	3019406	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	26139	0	6158-0	3019406		
26992	2501	3006322	1987-04-01	1987-04-01 00:00:00	1987-04-01	5001	0	\N	0	0	\N	\N	0	165599	0	8331-1	3006322		
63426	1950	4133840	1994-10-06	1994-10-06 00:00:00	1994-10-06	5001	0	\N	0	0	\N	\N	0	129682	0	127783003	4133840		
10224	328	4052083	1985-04-27	1985-04-27 00:00:00	1985-04-27	5001	0	\N	0	0	\N	\N	0	21641	0	23426006	4052083		
35142	3212	3006322	2015-11-10	2015-11-10 00:00:00	2015-11-10	5001	0	\N	0	0	\N	\N	0	213422	0	8331-1	3006322		
24552	2261	40766240	1965-04-03	1965-04-03 00:00:00	1965-04-03	5001	0	\N	0	0	\N	\N	0	150343	0	63513-6	40766240		
44519	4109	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	273200	0	7258-7	3001488		
35998	3311	3023430	1990-03-30	1990-03-30 00:00:00	1990-03-30	5001	0	\N	0	0	\N	\N	0	219805	0	6833-8	3023430		
57426	5274	3006322	1966-11-01	1966-11-01 00:00:00	1966-11-01	5001	0	\N	0	0	\N	\N	0	350834	0	8331-1	3006322		
142341	4376	4133840	1993-09-21	1993-09-21 00:00:00	1993-09-21	5001	0	\N	0	0	\N	\N	0	290806	0	127783003	4133840		
53374	4899	3011505	1985-08-27	1985-08-27 00:00:00	1985-08-27	5001	0	\N	0	0	\N	\N	0	325844	0	19926-5	3011505		
56115	1713	4024958	2010-10-20	2010-10-20 00:00:00	2010-10-20	5001	0	\N	0	0	\N	\N	0	114496	0	117015009	4024958		
105703	3253	4024958	2004-02-16	2004-02-16 00:00:00	2004-02-16	5001	0	\N	0	0	\N	\N	0	216368	0	117015009	4024958		
96668	2959	4052083	1977-08-19	1977-08-19 00:00:00	1977-08-19	5001	0	\N	0	0	\N	\N	0	197470	0	23426006	4052083		
87169	2693	4052083	1995-10-15	1995-10-15 00:00:00	1995-10-15	5001	0	\N	0	0	\N	\N	0	178428	0	23426006	4052083		
53692	1626	4133840	2000-09-24	2000-09-24 00:00:00	2000-09-24	5001	0	\N	0	0	\N	\N	0	109226	0	127783003	4133840		
4504	437	3006322	2003-09-26	2003-09-26 00:00:00	2003-09-26	5001	0	\N	0	0	\N	\N	0	28976	0	8331-1	3006322		
2708	266	3019406	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	17652	0	6158-0	3019406		
60452	1845	4052083	2006-02-07	2006-02-07 00:00:00	2006-02-07	5001	0	\N	0	0	\N	\N	0	123356	0	23426006	4052083		
44229	4078	40769194	1953-03-10	1953-03-10 00:00:00	1953-03-10	5001	0	\N	0	0	\N	\N	0	270974	0	66534-9	40769194		
27437	2542	3006734	1986-06-26	1986-06-26 00:00:00	1986-06-26	5001	0	\N	0	0	\N	\N	0	168123	0	6189-5	3006734		
980	79	46235214	1947-10-22	1947-10-22 00:00:00	1947-10-22	5001	0	\N	0	0	\N	\N	0	5240	0	76690-7	46235214		
9257	877	3014599	1993-11-09	1993-11-09 00:00:00	1993-11-09	5001	0	\N	0	0	\N	\N	0	58381	0	6106-9	3014599		
38779	3583	3023430	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	238256	0	6833-8	3023430		
50520	4608	3011505	2011-01-20	2011-01-20 00:00:00	2011-01-20	5001	0	\N	0	0	\N	\N	0	307020	0	19926-5	3011505		
23353	2152	3006322	1991-07-07	1991-07-07 00:00:00	1991-07-07	5001	0	\N	0	0	\N	\N	0	143438	0	8331-1	3006322		
23428	2160	3006322	1988-12-12	1988-12-12 00:00:00	1988-12-12	5001	0	\N	0	0	\N	\N	0	143978	0	8331-1	3006322		
14992	1391	3006322	1954-08-14	1954-08-14 00:00:00	1954-08-14	5001	0	\N	0	0	\N	\N	0	92345	0	8331-1	3006322		
7313	704	3006734	1986-12-25	1986-12-25 00:00:00	1986-12-25	5001	0	\N	0	0	\N	\N	0	46535	0	6189-5	3006734		
146833	4504	4024958	1981-07-07	1981-07-07 00:00:00	1981-07-07	5001	0	\N	0	0	\N	\N	0	299904	0	117015009	4024958		
28363	2624	3006322	2009-09-11	2009-09-11 00:00:00	2009-09-11	5001	0	\N	0	0	\N	\N	0	173594	0	8331-1	3006322		
39782	3695	3045716	1996-03-20	1996-03-20 00:00:00	1996-03-20	5001	0	\N	0	0	\N	\N	0	245605	0	33037-3	3045716		
10423	1015	3051031	2005-04-11	2005-04-11 00:00:00	2005-04-11	5001	0	\N	0	0	\N	\N	0	66794	0	46240-8	3051031		
10552	1024	3011505	2019-06-16	2019-06-16 00:00:00	2019-06-16	5001	0	\N	0	0	\N	\N	0	67448	0	19926-5	3011505		
41653	3875	3006322	2008-06-21	2008-06-21 00:00:00	2008-06-21	5001	0	\N	0	0	\N	\N	0	257327	0	8331-1	3006322		
224	5	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	408	0	6276-0	3027231		
20954	1933	3006322	1963-06-07	1963-06-07 00:00:00	1963-06-07	5001	0	\N	0	0	\N	\N	0	128549	0	8331-1	3006322		
2323	212	3006322	1972-09-07	1972-09-07 00:00:00	1972-09-07	5001	0	\N	0	0	\N	\N	0	14465	0	8331-1	3006322		
32435	2945	3011505	1973-12-04	1973-12-04 00:00:00	1973-12-04	5001	0	\N	0	0	\N	\N	0	196508	0	19926-5	3011505		
94048	2894	4052083	1986-11-30	1986-11-30 00:00:00	1986-11-30	5001	0	\N	0	0	\N	\N	0	192658	0	23426006	4052083		
1543	137	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	9162	0	7258-7	3001488		
12607	1208	3006322	1954-07-10	1954-07-10 00:00:00	1954-07-10	5001	0	\N	0	0	\N	\N	0	79393	0	8331-1	3006322		
48980	4480	3006322	1964-10-01	1964-10-01 00:00:00	1964-10-01	5001	0	\N	0	0	\N	\N	0	298140	0	8331-1	3006322		
632	41	3006322	1974-08-20	1974-08-20 00:00:00	1974-08-20	5001	0	\N	0	0	\N	\N	0	2906	0	8331-1	3006322		
24470	2261	3051031	1965-03-04	1965-03-04 00:00:00	1965-03-04	5001	0	\N	0	0	\N	\N	0	150279	0	46240-8	3051031		
33656	3057	3006322	1941-09-24	1941-09-24 00:00:00	1941-09-24	5001	0	\N	0	0	\N	\N	0	203360	0	8331-1	3006322		
41250	3849	3006322	1980-01-17	1980-01-17 00:00:00	1980-01-17	5001	0	\N	0	0	\N	\N	0	255407	0	8331-1	3006322		
46909	4319	3011505	2005-12-28	2005-12-28 00:00:00	2005-12-28	5001	0	\N	0	0	\N	\N	0	286590	0	19926-5	3011505		
45180	4173	3006322	1987-06-29	1987-06-29 00:00:00	1987-06-29	5001	0	\N	0	0	\N	\N	0	277343	0	8331-1	3006322		
46365	4269	46235214	1969-12-27	1969-12-27 00:00:00	1969-12-27	5001	0	\N	0	0	\N	\N	0	283364	0	76690-7	46235214		
3997	399	3015076	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	26139	0	6248-9	3015076		
26993	2501	3006322	1991-10-18	1991-10-18 00:00:00	1991-10-18	5001	0	\N	0	0	\N	\N	0	165529	0	8331-1	3006322		
63429	1950	4133840	1996-10-17	1996-10-17 00:00:00	1996-10-17	5001	0	\N	0	0	\N	\N	0	129683	0	127783003	4133840		
10228	328	4024958	1995-09-12	1995-09-12 00:00:00	1995-09-12	5001	0	\N	0	0	\N	\N	0	21662	0	117015009	4024958		
35143	3214	3006322	1976-06-26	1976-06-26 00:00:00	1976-06-26	5001	0	\N	0	0	\N	\N	0	213522	0	8331-1	3006322		
24553	2261	40758406	1965-04-03	1965-04-03 00:00:00	1965-04-03	5001	0	\N	0	0	\N	\N	0	150343	0	55277-8	40758406		
44520	4109	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	273200	0	6206-7	3012494		
35999	3311	3020655	1990-03-30	1990-03-30 00:00:00	1990-03-30	5001	0	\N	0	0	\N	\N	0	219805	0	6844-5	3020655		
57427	5274	3006322	2002-11-09	2002-11-09 00:00:00	2002-11-09	5001	0	\N	0	0	\N	\N	0	350812	0	8331-1	3006322		
142346	4376	4133840	2002-11-12	2002-11-12 00:00:00	2002-11-12	5001	0	\N	0	0	\N	\N	0	290705	0	127783003	4133840		
53375	4899	3011505	1987-09-08	1987-09-08 00:00:00	1987-09-08	5001	0	\N	0	0	\N	\N	0	325845	0	19926-5	3011505		
56126	1713	4024958	1999-07-09	1999-07-09 00:00:00	1999-07-09	5001	0	\N	0	0	\N	\N	0	114479	0	117015009	4024958		
24239	2237	3006322	1991-02-04	1991-02-04 00:00:00	1991-02-04	5001	0	\N	0	0	\N	\N	0	148850	0	8331-1	3006322		
96671	2960	4024958	1998-02-18	1998-02-18 00:00:00	1998-02-18	5001	0	\N	0	0	\N	\N	0	197619	0	117015009	4024958		
136920	4220	4024958	1953-11-28	1953-11-28 00:00:00	1953-11-28	5001	0	\N	0	0	\N	\N	0	280195	0	117015009	4024958		
53695	1626	4133840	2003-10-12	2003-10-12 00:00:00	2003-10-12	5001	0	\N	0	0	\N	\N	0	109257	0	127783003	4133840		
4505	437	3006322	2007-06-03	2007-06-03 00:00:00	2007-06-03	5001	0	\N	0	0	\N	\N	0	28977	0	8331-1	3006322		
2709	266	3012494	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	17652	0	6206-7	3012494		
60458	1845	4024958	1969-10-24	1969-10-24 00:00:00	1969-10-24	5001	0	\N	0	0	\N	\N	0	123259	0	117015009	4024958		
44230	4078	3006734	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	271070	0	6189-5	3006734		
27438	2542	3001247	1986-06-26	1986-06-26 00:00:00	1986-06-26	5001	0	\N	0	0	\N	\N	0	168123	0	6085-5	3001247		
981	79	40758406	1947-10-22	1947-10-22 00:00:00	1947-10-22	5001	0	\N	0	0	\N	\N	0	5240	0	55277-8	40758406		
9258	877	3006451	1993-11-09	1993-11-09 00:00:00	1993-11-09	5001	0	\N	0	0	\N	\N	0	58381	0	6273-7	3006451		
38780	3583	3000876	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	238256	0	6082-2	3000876		
50521	4608	3011505	1994-12-22	1994-12-22 00:00:00	1994-12-22	5001	0	\N	0	0	\N	\N	0	307088	0	19926-5	3011505		
23354	2152	3006322	2016-02-29	2016-02-29 00:00:00	2016-02-29	5001	0	\N	0	0	\N	\N	0	143369	0	8331-1	3006322		
23429	2160	3006322	1994-01-24	1994-01-24 00:00:00	1994-01-24	5001	0	\N	0	0	\N	\N	0	143955	0	8331-1	3006322		
14994	1391	3006322	1987-07-02	1987-07-02 00:00:00	1987-07-02	5001	0	\N	0	0	\N	\N	0	92386	0	8331-1	3006322		
7314	704	3020655	1986-12-25	1986-12-25 00:00:00	1986-12-25	5001	0	\N	0	0	\N	\N	0	46535	0	6844-5	3020655		
146844	4504	4052083	2012-03-05	2012-03-05 00:00:00	2012-03-05	5001	0	\N	0	0	\N	\N	0	299941	0	23426006	4052083		
28364	2624	3009542	1996-12-27	1996-12-27 00:00:00	1996-12-27	5001	0	\N	0	0	\N	\N	0	173602	0	20570-8	3009542		
39783	3695	3002385	1996-03-20	1996-03-20 00:00:00	1996-03-20	5001	0	\N	0	0	\N	\N	0	245605	0	30385-9	3002385		
10424	1015	46235214	2005-04-11	2005-04-11 00:00:00	2005-04-11	5001	0	\N	0	0	\N	\N	0	66794	0	76690-7	46235214		
12241	395	4024958	1971-10-20	1971-10-20 00:00:00	1971-10-20	5001	0	\N	0	0	\N	\N	0	25986	0	117015009	4024958		
41654	3875	3006322	1965-04-16	1965-04-16 00:00:00	1965-04-16	5001	0	\N	0	0	\N	\N	0	257343	0	8331-1	3006322		
225	5	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	408	0	6844-5	3020655		
20955	1934	3006322	1992-07-24	1992-07-24 00:00:00	1992-07-24	5001	0	\N	0	0	\N	\N	0	128652	0	8331-1	3006322		
2324	212	3006322	2015-12-30	2015-12-30 00:00:00	2015-12-30	5001	0	\N	0	0	\N	\N	0	14414	0	8331-1	3006322		
32436	2945	3011505	1986-10-21	1986-10-21 00:00:00	1986-10-21	5001	0	\N	0	0	\N	\N	0	196511	0	19926-5	3011505		
94059	2895	4052083	1962-02-08	1962-02-08 00:00:00	1962-02-08	5001	0	\N	0	0	\N	\N	0	192700	0	23426006	4052083		
1544	137	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	9162	0	6844-5	3020655		
12608	1208	3006322	1951-12-06	1951-12-06 00:00:00	1951-12-06	5001	0	\N	0	0	\N	\N	0	79329	0	8331-1	3006322		
48981	4480	3006322	2014-06-24	2014-06-24 00:00:00	2014-06-24	5001	0	\N	0	0	\N	\N	0	298143	0	8331-1	3006322		
633	41	3006322	2006-02-27	2006-02-27 00:00:00	2006-02-27	5001	0	\N	0	0	\N	\N	0	2911	0	8331-1	3006322		
24472	2261	40766240	1965-03-04	1965-03-04 00:00:00	1965-03-04	5001	0	\N	0	0	\N	\N	0	150279	0	63513-6	40766240		
33657	3057	3049273	1997-03-03	1997-03-03 00:00:00	1997-03-03	5001	0	\N	0	0	\N	\N	0	203418	0	38265-5	3049273		
41251	3849	3006322	2016-12-27	2016-12-27 00:00:00	2016-12-27	5001	0	\N	0	0	\N	\N	0	255396	0	8331-1	3006322		
46910	4319	3011505	1999-12-22	1999-12-22 00:00:00	1999-12-22	5001	0	\N	0	0	\N	\N	0	286588	0	19926-5	3011505		
45181	4173	3006322	1974-03-03	1974-03-03 00:00:00	1974-03-03	5001	0	\N	0	0	\N	\N	0	277369	0	8331-1	3006322		
46366	4269	40758406	1969-12-27	1969-12-27 00:00:00	1969-12-27	5001	0	\N	0	0	\N	\N	0	283364	0	55277-8	40758406		
3998	399	3027231	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	26139	0	6276-0	3027231		
26994	2501	3006322	2010-01-21	2010-01-21 00:00:00	2010-01-21	5001	0	\N	0	0	\N	\N	0	165532	0	8331-1	3006322		
63432	1950	4133840	2013-01-17	2013-01-17 00:00:00	2013-01-17	5001	0	\N	0	0	\N	\N	0	129661	0	127783003	4133840		
10236	328	4052083	2004-08-12	2004-08-12 00:00:00	2004-08-12	5001	0	\N	0	0	\N	\N	0	21665	0	23426006	4052083		
35144	3214	3006322	2011-04-06	2011-04-06 00:00:00	2011-04-06	5001	0	\N	0	0	\N	\N	0	213552	0	8331-1	3006322		
24554	2261	46235214	1965-04-03	1965-04-03 00:00:00	1965-04-03	5001	0	\N	0	0	\N	\N	0	150343	0	76690-7	46235214		
44521	4109	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	273200	0	6189-5	3006734		
36000	3311	3000876	1990-03-30	1990-03-30 00:00:00	1990-03-30	5001	0	\N	0	0	\N	\N	0	219805	0	6082-2	3000876		
57428	5274	3006322	2002-03-26	2002-03-26 00:00:00	2002-03-26	5001	0	\N	0	0	\N	\N	0	350762	0	8331-1	3006322		
142351	4376	4133840	2009-12-22	2009-12-22 00:00:00	2009-12-22	5001	0	\N	0	0	\N	\N	0	290821	0	127783003	4133840		
53377	4899	3006322	1921-10-27	1921-10-27 00:00:00	1921-10-27	5001	0	\N	0	0	\N	\N	0	325786	0	8331-1	3006322		
75805	2327	4024958	1979-05-15	1979-05-15 00:00:00	1979-05-15	5001	0	\N	0	0	\N	\N	0	154733	0	117015009	4024958		
24240	2237	3049273	1991-03-17	1991-03-17 00:00:00	1991-03-17	5001	0	\N	0	0	\N	\N	0	148808	0	38265-5	3049273		
96677	2960	4024958	2016-04-13	2016-04-13 00:00:00	2016-04-13	5001	0	\N	0	0	\N	\N	0	197617	0	117015009	4024958		
136928	4220	4052083	2012-07-26	2012-07-26 00:00:00	2012-07-26	5001	0	\N	0	0	\N	\N	0	280203	0	23426006	4052083		
64978	1992	4024958	1983-07-22	1983-07-22 00:00:00	1983-07-22	5001	0	\N	0	0	\N	\N	0	132731	0	117015009	4024958		
4506	437	3006322	2005-01-28	2005-01-28 00:00:00	2005-01-28	5001	0	\N	0	0	\N	\N	0	28981	0	8331-1	3006322		
2710	266	3021226	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	17652	0	6246-3	3021226		
60465	1845	4052083	1979-01-31	1979-01-31 00:00:00	1979-01-31	5001	0	\N	0	0	\N	\N	0	123326	0	23426006	4052083		
44231	4078	3005136	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	271070	0	6075-6	3005136		
27439	2542	3023430	1986-06-26	1986-06-26 00:00:00	1986-06-26	5001	0	\N	0	0	\N	\N	0	168123	0	6833-8	3023430		
982	79	40766240	1947-10-22	1947-10-22 00:00:00	1947-10-22	5001	0	\N	0	0	\N	\N	0	5240	0	63513-6	40766240		
9259	877	3021226	1993-11-09	1993-11-09 00:00:00	1993-11-09	5001	0	\N	0	0	\N	\N	0	58381	0	6246-3	3021226		
38781	3583	3006322	1989-08-21	1989-08-21 00:00:00	1989-08-21	5001	0	\N	0	0	\N	\N	0	238235	0	8331-1	3006322		
109787	3389	4024958	1998-02-12	1998-02-12 00:00:00	1998-02-12	5001	0	\N	0	0	\N	\N	0	224778	0	117015009	4024958		
23355	2152	3006322	1924-06-18	1924-06-18 00:00:00	1924-06-18	5001	0	\N	0	0	\N	\N	0	143341	0	8331-1	3006322		
23430	2160	3006322	1967-10-06	1967-10-06 00:00:00	1967-10-06	5001	0	\N	0	0	\N	\N	0	143961	0	8331-1	3006322		
14996	1391	3006322	1937-10-14	1937-10-14 00:00:00	1937-10-14	5001	0	\N	0	0	\N	\N	0	92318	0	8331-1	3006322		
7315	704	3023430	1986-12-25	1986-12-25 00:00:00	1986-12-25	5001	0	\N	0	0	\N	\N	0	46535	0	6833-8	3023430		
89705	2774	4052083	1968-03-03	1968-03-03 00:00:00	1968-03-03	5001	0	\N	0	0	\N	\N	0	183656	0	23426006	4052083		
28365	2624	3000963	1996-12-27	1996-12-27 00:00:00	1996-12-27	5001	0	\N	0	0	\N	\N	0	173602	0	718-7	3000963		
39784	3695	3020630	1996-03-20	1996-03-20 00:00:00	1996-03-20	5001	0	\N	0	0	\N	\N	0	245605	0	2885-2	3020630		
10425	1015	40766240	2005-04-11	2005-04-11 00:00:00	2005-04-11	5001	0	\N	0	0	\N	\N	0	66794	0	63513-6	40766240		
12245	395	4024958	1975-02-14	1975-02-14 00:00:00	1975-02-14	5001	0	\N	0	0	\N	\N	0	25948	0	117015009	4024958		
41655	3875	3006322	2006-11-17	2006-11-17 00:00:00	2006-11-17	5001	0	\N	0	0	\N	\N	0	257326	0	8331-1	3006322		
226	5	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	408	0	7258-7	3001488		
20956	1934	3006322	1963-02-15	1963-02-15 00:00:00	1963-02-15	5001	0	\N	0	0	\N	\N	0	128632	0	8331-1	3006322		
2325	212	3006322	1993-12-15	1993-12-15 00:00:00	1993-12-15	5001	0	\N	0	0	\N	\N	0	14468	0	8331-1	3006322		
32437	2945	3011505	1997-07-29	1997-07-29 00:00:00	1997-07-29	5001	0	\N	0	0	\N	\N	0	196455	0	19926-5	3011505		
94066	2895	4052083	1968-06-23	1968-06-23 00:00:00	1968-06-23	5001	0	\N	0	0	\N	\N	0	192717	0	23426006	4052083		
1545	137	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	9162	0	6276-0	3027231		
12609	1208	3006322	1945-05-02	1945-05-02 00:00:00	1945-05-02	5001	0	\N	0	0	\N	\N	0	79342	0	8331-1	3006322		
48982	4480	3006322	1964-03-20	1964-03-20 00:00:00	1964-03-20	5001	0	\N	0	0	\N	\N	0	298151	0	8331-1	3006322		
634	41	3006322	1999-09-18	1999-09-18 00:00:00	1999-09-18	5001	0	\N	0	0	\N	\N	0	2990	0	8331-1	3006322		
24473	2261	40758406	1965-03-04	1965-03-04 00:00:00	1965-03-04	5001	0	\N	0	0	\N	\N	0	150279	0	55277-8	40758406		
33658	3057	3006322	1942-03-08	1942-03-08 00:00:00	1942-03-08	5001	0	\N	0	0	\N	\N	0	203353	0	8331-1	3006322		
41252	3849	3006322	2013-08-01	2013-08-01 00:00:00	2013-08-01	5001	0	\N	0	0	\N	\N	0	255394	0	8331-1	3006322		
46911	4319	3006322	2019-06-02	2019-06-02 00:00:00	2019-06-02	5001	0	\N	0	0	\N	\N	0	286614	0	8331-1	3006322		
45182	4173	3006322	1989-10-26	1989-10-26 00:00:00	1989-10-26	5001	0	\N	0	0	\N	\N	0	277330	0	8331-1	3006322		
46367	4269	40766240	1969-12-27	1969-12-27 00:00:00	1969-12-27	5001	0	\N	0	0	\N	\N	0	283364	0	63513-6	40766240		
3999	399	3006451	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	26139	0	6273-7	3006451		
26999	2503	3012494	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	165689	0	6206-7	3012494		
63434	1950	4133840	1998-10-29	1998-10-29 00:00:00	1998-10-29	5001	0	\N	0	0	\N	\N	0	129692	0	127783003	4133840		
10237	328	4024958	2002-11-16	2002-11-16 00:00:00	2002-11-16	5001	0	\N	0	0	\N	\N	0	21664	0	117015009	4024958		
35145	3214	3006322	1990-06-11	1990-06-11 00:00:00	1990-06-11	5001	0	\N	0	0	\N	\N	0	213537	0	8331-1	3006322		
24556	2261	3051031	1965-04-03	1965-04-03 00:00:00	1965-04-03	5001	0	\N	0	0	\N	\N	0	150343	0	46240-8	3051031		
44522	4109	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	273200	0	6095-4	3036780		
36001	3311	3014599	1990-03-30	1990-03-30 00:00:00	1990-03-30	5001	0	\N	0	0	\N	\N	0	219805	0	6106-9	3014599		
57429	5274	3006322	1999-01-26	1999-01-26 00:00:00	1999-01-26	5001	0	\N	0	0	\N	\N	0	350802	0	8331-1	3006322		
142355	4376	4052083	1929-02-15	1929-02-15 00:00:00	1929-02-15	5001	0	\N	0	0	\N	\N	0	290825	0	23426006	4052083		
53378	4899	40758406	1922-02-26	1922-02-26 00:00:00	1922-02-26	5001	0	\N	0	0	\N	\N	0	325835	0	55277-8	40758406		
75811	2327	4052083	1970-11-08	1970-11-08 00:00:00	1970-11-08	5001	0	\N	0	0	\N	\N	0	154732	0	23426006	4052083		
24241	2237	3006322	1955-10-18	1955-10-18 00:00:00	1955-10-18	5001	0	\N	0	0	\N	\N	0	148760	0	8331-1	3006322		
96682	2960	4024958	1961-12-30	1961-12-30 00:00:00	1961-12-30	5001	0	\N	0	0	\N	\N	0	197654	0	117015009	4024958		
136932	4220	4052083	1995-01-21	1995-01-21 00:00:00	1995-01-21	5001	0	\N	0	0	\N	\N	0	280223	0	23426006	4052083		
48541	1480	4024958	1969-03-08	1969-03-08 00:00:00	1969-03-08	5001	0	\N	0	0	\N	\N	0	98752	0	117015009	4024958		
4511	439	3006322	2008-04-01	2008-04-01 00:00:00	2008-04-01	5001	0	\N	0	0	\N	\N	0	29159	0	8331-1	3006322		
2711	266	3006451	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	17652	0	6273-7	3006451		
49337	1504	4052083	2004-10-17	2004-10-17 00:00:00	2004-10-17	5001	0	\N	0	0	\N	\N	0	100278	0	23426006	4052083		
44232	4078	3006451	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	271070	0	6273-7	3006451		
27440	2542	3020655	1986-06-26	1986-06-26 00:00:00	1986-06-26	5001	0	\N	0	0	\N	\N	0	168123	0	6844-5	3020655		
983	79	3006322	1999-01-28	1999-01-28 00:00:00	1999-01-28	5001	0	\N	0	0	\N	\N	0	5347	0	8331-1	3006322		
9260	877	3027231	1993-11-09	1993-11-09 00:00:00	1993-11-09	5001	0	\N	0	0	\N	\N	0	58381	0	6276-0	3027231		
38782	3583	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	238244	0	7258-7	3001488		
109788	3389	4052083	2005-02-04	2005-02-04 00:00:00	2005-02-04	5001	0	\N	0	0	\N	\N	0	224789	0	23426006	4052083		
23356	2153	3006322	1974-10-06	1974-10-06 00:00:00	1974-10-06	5001	0	\N	0	0	\N	\N	0	143475	0	8331-1	3006322		
34727	3178	3006322	1980-06-12	1980-06-12 00:00:00	1980-06-12	5001	0	\N	0	0	\N	\N	0	211425	0	8331-1	3006322		
14997	1391	3006322	1969-11-17	1969-11-17 00:00:00	1969-11-17	5001	0	\N	0	0	\N	\N	0	92384	0	8331-1	3006322		
7316	704	3015076	1986-12-25	1986-12-25 00:00:00	1986-12-25	5001	0	\N	0	0	\N	\N	0	46535	0	6248-9	3015076		
89710	2774	4024958	1945-02-25	1945-02-25 00:00:00	1945-02-25	5001	0	\N	0	0	\N	\N	0	183637	0	117015009	4024958		
28366	2624	3006322	2012-09-11	2012-09-11 00:00:00	2012-09-11	5001	0	\N	0	0	\N	\N	0	173552	0	8331-1	3006322		
39785	3695	3019550	1996-03-20	1996-03-20 00:00:00	1996-03-20	5001	0	\N	0	0	\N	\N	0	245605	0	2951-2	3019550		
10426	1015	40758406	2005-05-11	2005-05-11 00:00:00	2005-05-11	5001	0	\N	0	0	\N	\N	0	66821	0	55277-8	40758406		
12254	395	4052083	1982-02-22	1982-02-22 00:00:00	1982-02-22	5001	0	\N	0	0	\N	\N	0	25953	0	23426006	4052083		
41656	3875	3049273	2018-07-14	2018-07-14 00:00:00	2018-07-14	5001	0	\N	0	0	\N	\N	0	257341	0	38265-5	3049273		
227	5	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	408	0	6075-6	3005136		
20957	1934	3006322	2001-04-22	2001-04-22 00:00:00	2001-04-22	5001	0	\N	0	0	\N	\N	0	128653	0	8331-1	3006322		
2326	213	3006322	1990-01-31	1990-01-31 00:00:00	1990-01-31	5001	0	\N	0	0	\N	\N	0	14518	0	8331-1	3006322		
32438	2945	3011505	1972-07-18	1972-07-18 00:00:00	1972-07-18	5001	0	\N	0	0	\N	\N	0	196514	0	19926-5	3011505		
54460	4977	3006322	1999-12-06	1999-12-06 00:00:00	1999-12-06	5001	0	\N	0	0	\N	\N	0	331192	0	8331-1	3006322		
1546	137	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	9162	0	6248-9	3015076		
12610	1209	3006322	2009-11-16	2009-11-16 00:00:00	2009-11-16	5001	0	\N	0	0	\N	\N	0	79423	0	8331-1	3006322		
48983	4480	3006322	1995-10-07	1995-10-07 00:00:00	1995-10-07	5001	0	\N	0	0	\N	\N	0	298137	0	8331-1	3006322		
635	41	3006322	2012-01-12	2012-01-12 00:00:00	2012-01-12	5001	0	\N	0	0	\N	\N	0	2944	0	8331-1	3006322		
24474	2261	46235214	1965-03-04	1965-03-04 00:00:00	1965-03-04	5001	0	\N	0	0	\N	\N	0	150279	0	76690-7	46235214		
33659	3057	3006322	1949-01-08	1949-01-08 00:00:00	1949-01-08	5001	0	\N	0	0	\N	\N	0	203334	0	8331-1	3006322		
41253	3849	3006322	1968-04-13	1968-04-13 00:00:00	1968-04-13	5001	0	\N	0	0	\N	\N	0	255428	0	8331-1	3006322		
46912	4319	3011505	2015-04-22	2015-04-22 00:00:00	2015-04-22	5001	0	\N	0	0	\N	\N	0	286628	0	19926-5	3011505		
45183	4173	3006322	2014-07-28	2014-07-28 00:00:00	2014-07-28	5001	0	\N	0	0	\N	\N	0	277331	0	8331-1	3006322		
46368	4269	3051031	1969-12-27	1969-12-27 00:00:00	1969-12-27	5001	0	\N	0	0	\N	\N	0	283364	0	46240-8	3051031		
4000	399	3021226	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	26139	0	6246-3	3021226		
27000	2503	3006734	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	165689	0	6189-5	3006734		
63436	1950	4133840	1991-09-19	1991-09-19 00:00:00	1991-09-19	5001	0	\N	0	0	\N	\N	0	129655	0	127783003	4133840		
10283	331	4052083	2004-03-27	2004-03-27 00:00:00	2004-03-27	5001	0	\N	0	0	\N	\N	0	21824	0	23426006	4052083		
35146	3214	3006322	1984-02-27	1984-02-27 00:00:00	1984-02-27	5001	0	\N	0	0	\N	\N	0	213524	0	8331-1	3006322		
24558	2261	3006322	2016-09-19	2016-09-19 00:00:00	2016-09-19	5001	0	\N	0	0	\N	\N	0	150314	0	8331-1	3006322		
44523	4109	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	273200	0	6833-8	3023430		
36002	3311	3021226	1990-03-30	1990-03-30 00:00:00	1990-03-30	5001	0	\N	0	0	\N	\N	0	219805	0	6246-3	3021226		
57430	5274	3006322	1966-02-20	1966-02-20 00:00:00	1966-02-20	5001	0	\N	0	0	\N	\N	0	350833	0	8331-1	3006322		
142360	4376	4133840	2006-12-05	2006-12-05 00:00:00	2006-12-05	5001	0	\N	0	0	\N	\N	0	290707	0	127783003	4133840		
53379	4899	40766240	1922-02-26	1922-02-26 00:00:00	1922-02-26	5001	0	\N	0	0	\N	\N	0	325835	0	63513-6	40766240		
75816	2328	4024958	2016-07-08	2016-07-08 00:00:00	2016-07-08	5001	0	\N	0	0	\N	\N	0	154871	0	117015009	4024958		
24242	2237	3049273	1999-10-24	1999-10-24 00:00:00	1999-10-24	5001	0	\N	0	0	\N	\N	0	148826	0	38265-5	3049273		
96683	2960	4024958	1956-03-19	1956-03-19 00:00:00	1956-03-19	5001	0	\N	0	0	\N	\N	0	197629	0	117015009	4024958		
52492	4822	46235214	1948-11-22	1948-11-22 00:00:00	1948-11-22	5001	0	\N	0	0	\N	\N	0	320729	0	76690-7	46235214		
48553	1480	4052083	1971-10-24	1971-10-24 00:00:00	1971-10-24	5001	0	\N	0	0	\N	\N	0	98704	0	23426006	4052083		
4512	439	3006322	1988-03-16	1988-03-16 00:00:00	1988-03-16	5001	0	\N	0	0	\N	\N	0	29156	0	8331-1	3006322		
2712	266	3027231	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	17652	0	6276-0	3027231		
49338	1504	4052083	1993-12-05	1993-12-05 00:00:00	1993-12-05	5001	0	\N	0	0	\N	\N	0	100271	0	23426006	4052083		
44233	4078	3027231	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	271070	0	6276-0	3027231		
27441	2542	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	168112	0	6082-2	3000876		
985	79	46235214	1947-06-25	1947-06-25 00:00:00	1947-06-25	5001	0	\N	0	0	\N	\N	0	5248	0	76690-7	46235214		
9261	877	3019406	1993-11-09	1993-11-09 00:00:00	1993-11-09	5001	0	\N	0	0	\N	\N	0	58381	0	6158-0	3019406		
38783	3583	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	238244	0	6844-5	3020655		
109791	3389	4052083	1998-04-05	1998-04-05 00:00:00	1998-04-05	5001	0	\N	0	0	\N	\N	0	224788	0	23426006	4052083		
23357	2153	3006322	2007-04-22	2007-04-22 00:00:00	2007-04-22	5001	0	\N	0	0	\N	\N	0	143474	0	8331-1	3006322		
34728	3178	3027970	2014-03-13	2014-03-13 00:00:00	2014-03-13	5001	0	\N	0	0	\N	\N	0	211388	0	10834-0	3027970		
14998	1391	3006322	1951-09-14	1951-09-14 00:00:00	1951-09-14	5001	0	\N	0	0	\N	\N	0	92321	0	8331-1	3006322		
7317	704	3021226	1986-12-25	1986-12-25 00:00:00	1986-12-25	5001	0	\N	0	0	\N	\N	0	46535	0	6246-3	3021226		
89717	2774	4052083	1971-07-11	1971-07-11 00:00:00	1971-07-11	5001	0	\N	0	0	\N	\N	0	183703	0	23426006	4052083		
28367	2624	3006322	2002-10-06	2002-10-06 00:00:00	2002-10-06	5001	0	\N	0	0	\N	\N	0	173593	0	8331-1	3006322		
39786	3695	3026361	1996-03-20	1996-03-20 00:00:00	1996-03-20	5001	0	\N	0	0	\N	\N	0	245605	0	26453-1	3026361		
10428	1015	3051031	2005-05-11	2005-05-11 00:00:00	2005-05-11	5001	0	\N	0	0	\N	\N	0	66821	0	46240-8	3051031		
12255	395	4024958	1983-12-16	1983-12-16 00:00:00	1983-12-16	5001	0	\N	0	0	\N	\N	0	25954	0	117015009	4024958		
41657	3875	3006322	2019-01-05	2019-01-05 00:00:00	2019-01-05	5001	0	\N	0	0	\N	\N	0	257361	0	8331-1	3006322		
228	5	3006322	1977-06-08	1977-06-08 00:00:00	1977-06-08	5001	0	\N	0	0	\N	\N	0	521	0	8331-1	3006322		
20958	1934	3006322	2017-04-07	2017-04-07 00:00:00	2017-04-07	5001	0	\N	0	0	\N	\N	0	128649	0	8331-1	3006322		
2327	213	3006322	1967-12-01	1967-12-01 00:00:00	1967-12-01	5001	0	\N	0	0	\N	\N	0	14498	0	8331-1	3006322		
32439	2945	3011505	1984-10-16	1984-10-16 00:00:00	1984-10-16	5001	0	\N	0	0	\N	\N	0	196491	0	19926-5	3011505		
54461	4977	3013682	2010-12-07	2010-12-07 00:00:00	2010-12-07	5001	0	\N	0	0	\N	\N	0	331120	0	3094-0	3013682		
1547	137	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	9162	0	6075-6	3005136		
12611	1209	3006322	2014-12-31	2014-12-31 00:00:00	2014-12-31	5001	0	\N	0	0	\N	\N	0	79434	0	8331-1	3006322		
65954	2025	4052083	1938-07-18	1938-07-18 00:00:00	1938-07-18	5001	0	\N	0	0	\N	\N	0	134771	0	23426006	4052083		
636	41	3006322	1983-01-01	1983-01-01 00:00:00	1983-01-01	5001	0	\N	0	0	\N	\N	0	2923	0	8331-1	3006322		
24475	2261	40758406	1965-02-02	1965-02-02 00:00:00	1965-02-02	5001	0	\N	0	0	\N	\N	0	150310	0	55277-8	40758406		
33660	3057	3006322	1973-08-20	1973-08-20 00:00:00	1973-08-20	5001	0	\N	0	0	\N	\N	0	203336	0	8331-1	3006322		
41254	3849	3006322	1969-04-20	1969-04-20 00:00:00	1969-04-20	5001	0	\N	0	0	\N	\N	0	255452	0	8331-1	3006322		
46913	4319	3011505	2009-04-15	2009-04-15 00:00:00	2009-04-15	5001	0	\N	0	0	\N	\N	0	286626	0	19926-5	3011505		
45184	4173	3006322	1965-10-06	1965-10-06 00:00:00	1965-10-06	5001	0	\N	0	0	\N	\N	0	277340	0	8331-1	3006322		
46370	4269	40766240	1969-09-28	1969-09-28 00:00:00	1969-09-28	5001	0	\N	0	0	\N	\N	0	283363	0	63513-6	40766240		
4001	399	3005136	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	26139	0	6075-6	3005136		
27001	2503	3000876	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	165689	0	6082-2	3000876		
63438	1950	4133840	2006-12-14	2006-12-14 00:00:00	2006-12-14	5001	0	\N	0	0	\N	\N	0	129660	0	127783003	4133840		
61749	1892	4133840	2016-08-18	2016-08-18 00:00:00	2016-08-18	5001	0	\N	0	0	\N	\N	0	126022	0	127783003	4133840		
35147	3214	3006322	2016-09-14	2016-09-14 00:00:00	2016-09-14	5001	0	\N	0	0	\N	\N	0	213527	0	8331-1	3006322		
24559	2261	3051031	1967-02-22	1967-02-22 00:00:00	1967-02-22	5001	0	\N	0	0	\N	\N	0	150286	0	46240-8	3051031		
119536	3686	4052083	1972-09-25	1972-09-25 00:00:00	1972-09-25	5001	0	\N	0	0	\N	\N	0	245065	0	23426006	4052083		
36003	3311	3027231	1990-03-30	1990-03-30 00:00:00	1990-03-30	5001	0	\N	0	0	\N	\N	0	219805	0	6276-0	3027231		
57432	5276	3006322	1999-11-21	1999-11-21 00:00:00	1999-11-21	5001	0	\N	0	0	\N	\N	0	350887	0	8331-1	3006322		
142366	4376	4133840	1983-07-26	1983-07-26 00:00:00	1983-07-26	5001	0	\N	0	0	\N	\N	0	290834	0	127783003	4133840		
53381	4899	46235214	1922-02-26	1922-02-26 00:00:00	1922-02-26	5001	0	\N	0	0	\N	\N	0	325835	0	76690-7	46235214		
75818	2328	4052083	1975-09-06	1975-09-06 00:00:00	1975-09-06	5001	0	\N	0	0	\N	\N	0	154864	0	23426006	4052083		
24243	2237	3006322	1973-01-29	1973-01-29 00:00:00	1973-01-29	5001	0	\N	0	0	\N	\N	0	148849	0	8331-1	3006322		
96693	2960	4024958	1969-08-12	1969-08-12 00:00:00	1969-08-12	5001	0	\N	0	0	\N	\N	0	197631	0	117015009	4024958		
52493	4822	40758406	1948-11-22	1948-11-22 00:00:00	1948-11-22	5001	0	\N	0	0	\N	\N	0	320729	0	55277-8	40758406		
48554	1480	4052083	1982-02-23	1982-02-23 00:00:00	1982-02-23	5001	0	\N	0	0	\N	\N	0	98741	0	23426006	4052083		
4513	439	3006322	2009-04-06	2009-04-06 00:00:00	2009-04-06	5001	0	\N	0	0	\N	\N	0	29116	0	8331-1	3006322		
2713	266	3005136	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	17652	0	6075-6	3005136		
49379	1505	4052083	1983-12-02	1983-12-02 00:00:00	1983-12-02	5001	0	\N	0	0	\N	\N	0	100349	0	23426006	4052083		
44234	4078	3001247	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	271070	0	6085-5	3001247		
27442	2542	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	168112	0	6095-4	3036780		
986	79	3051031	1947-12-21	1947-12-21 00:00:00	1947-12-21	5001	0	\N	0	0	\N	\N	0	5250	0	46240-8	3051031		
9262	877	3036780	1993-11-09	1993-11-09 00:00:00	1993-11-09	5001	0	\N	0	0	\N	\N	0	58381	0	6095-4	3036780		
38784	3583	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	238244	0	6248-9	3015076		
109801	3389	4024958	2003-03-28	2003-03-28 00:00:00	2003-03-28	5001	0	\N	0	0	\N	\N	0	224779	0	117015009	4024958		
23358	2153	3006322	2009-12-18	2009-12-18 00:00:00	2009-12-18	5001	0	\N	0	0	\N	\N	0	143508	0	8331-1	3006322		
34729	3178	3013721	2014-03-13	2014-03-13 00:00:00	2014-03-13	5001	0	\N	0	0	\N	\N	0	211388	0	1920-8	3013721		
14999	1391	3049273	1994-10-25	1994-10-25 00:00:00	1994-10-25	5001	0	\N	0	0	\N	\N	0	92308	0	38265-5	3049273		
7318	704	3014599	1986-12-25	1986-12-25 00:00:00	1986-12-25	5001	0	\N	0	0	\N	\N	0	46535	0	6106-9	3014599		
89718	2774	4052083	1946-11-01	1946-11-01 00:00:00	1946-11-01	5001	0	\N	0	0	\N	\N	0	183638	0	23426006	4052083		
28370	2626	3006322	1975-06-13	1975-06-13 00:00:00	1975-06-13	5001	0	\N	0	0	\N	\N	0	173708	0	8331-1	3006322		
39787	3695	3015632	1996-03-20	1996-03-20 00:00:00	1996-03-20	5001	0	\N	0	0	\N	\N	0	245605	0	2028-9	3015632		
10430	1015	46235214	2005-05-11	2005-05-11 00:00:00	2005-05-11	5001	0	\N	0	0	\N	\N	0	66821	0	76690-7	46235214		
12299	398	4024958	1940-04-08	1940-04-08 00:00:00	1940-04-08	5001	0	\N	0	0	\N	\N	0	26068	0	117015009	4024958		
41658	3876	3006451	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	257503	0	6273-7	3006451		
229	5	3006322	1983-08-04	1983-08-04 00:00:00	1983-08-04	5001	0	\N	0	0	\N	\N	0	406	0	8331-1	3006322		
20959	1935	3006322	1981-05-01	1981-05-01 00:00:00	1981-05-01	5001	0	\N	0	0	\N	\N	0	128711	0	8331-1	3006322		
13610	1280	3006322	1975-12-15	1975-12-15 00:00:00	1975-12-15	5001	0	\N	0	0	\N	\N	0	84544	0	8331-1	3006322		
32440	2945	3011505	2006-09-19	2006-09-19 00:00:00	2006-09-19	5001	0	\N	0	0	\N	\N	0	196505	0	19926-5	3011505		
54462	4977	3007461	2010-12-07	2010-12-07 00:00:00	2010-12-07	5001	0	\N	0	0	\N	\N	0	331120	0	26515-7	3007461		
1548	137	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	9162	0	6246-3	3021226		
12612	1209	3006322	1991-05-13	1991-05-13 00:00:00	1991-05-13	5001	0	\N	0	0	\N	\N	0	79443	0	8331-1	3006322		
65955	2025	4024958	1950-09-04	1950-09-04 00:00:00	1950-09-04	5001	0	\N	0	0	\N	\N	0	134772	0	117015009	4024958		
637	41	3006322	1975-04-03	1975-04-03 00:00:00	1975-04-03	5001	0	\N	0	0	\N	\N	0	2977	0	8331-1	3006322		
24476	2261	46235214	1965-02-02	1965-02-02 00:00:00	1965-02-02	5001	0	\N	0	0	\N	\N	0	150310	0	76690-7	46235214		
33661	3057	3006322	1966-07-16	1966-07-16 00:00:00	1966-07-16	5001	0	\N	0	0	\N	\N	0	203362	0	8331-1	3006322		
41260	3851	3006322	1927-10-21	1927-10-21 00:00:00	1927-10-21	5001	0	\N	0	0	\N	\N	0	255608	0	8331-1	3006322		
46914	4319	3011505	2008-12-31	2008-12-31 00:00:00	2008-12-31	5001	0	\N	0	0	\N	\N	0	286591	0	19926-5	3011505		
45185	4173	3006322	1985-11-22	1985-11-22 00:00:00	1985-11-22	5001	0	\N	0	0	\N	\N	0	277363	0	8331-1	3006322		
46371	4269	3051031	1969-09-28	1969-09-28 00:00:00	1969-09-28	5001	0	\N	0	0	\N	\N	0	283363	0	46240-8	3051031		
4002	399	3012494	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	26139	0	6206-7	3012494		
27002	2503	3021226	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	165689	0	6246-3	3021226		
63443	1950	4133840	2004-12-02	2004-12-02 00:00:00	2004-12-02	5001	0	\N	0	0	\N	\N	0	129659	0	127783003	4133840		
61753	1892	4133840	2014-08-07	2014-08-07 00:00:00	2014-08-07	5001	0	\N	0	0	\N	\N	0	125989	0	127783003	4133840		
35148	3215	3006322	1992-12-16	1992-12-16 00:00:00	1992-12-16	5001	0	\N	0	0	\N	\N	0	213681	0	8331-1	3006322		
24560	2261	40766240	1967-02-22	1967-02-22 00:00:00	1967-02-22	5001	0	\N	0	0	\N	\N	0	150286	0	63513-6	40766240		
119543	3686	4052083	1985-02-25	1985-02-25 00:00:00	1985-02-25	5001	0	\N	0	0	\N	\N	0	245083	0	23426006	4052083		
36004	3311	3006322	2015-10-02	2015-10-02 00:00:00	2015-10-02	5001	0	\N	0	0	\N	\N	0	219817	0	8331-1	3006322		
57433	5276	40758406	2003-03-09	2003-03-09 00:00:00	2003-03-09	5001	0	\N	0	0	\N	\N	0	350877	0	55277-8	40758406		
142370	4376	4133840	2016-01-26	2016-01-26 00:00:00	2016-01-26	5001	0	\N	0	0	\N	\N	0	290708	0	127783003	4133840		
53383	4899	3051031	1922-02-26	1922-02-26 00:00:00	1922-02-26	5001	0	\N	0	0	\N	\N	0	325835	0	46240-8	3051031		
75828	2328	4024958	1960-12-26	1960-12-26 00:00:00	1960-12-26	5001	0	\N	0	0	\N	\N	0	154813	0	117015009	4024958		
24244	2238	3006322	1970-12-26	1970-12-26 00:00:00	1970-12-26	5001	0	\N	0	0	\N	\N	0	148974	0	8331-1	3006322		
96694	2960	4024958	2011-02-25	2011-02-25 00:00:00	2011-02-25	5001	0	\N	0	0	\N	\N	0	197621	0	117015009	4024958		
52494	4822	3051031	1948-11-22	1948-11-22 00:00:00	1948-11-22	5001	0	\N	0	0	\N	\N	0	320729	0	46240-8	3051031		
48558	1480	4024958	1993-01-24	1993-01-24 00:00:00	1993-01-24	5001	0	\N	0	0	\N	\N	0	98708	0	117015009	4024958		
4514	439	3006322	1979-09-03	1979-09-03 00:00:00	1979-09-03	5001	0	\N	0	0	\N	\N	0	29155	0	8331-1	3006322		
2714	266	3014599	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	17652	0	6106-9	3014599		
49388	1505	4024958	1961-01-29	1961-01-29 00:00:00	1961-01-29	5001	0	\N	0	0	\N	\N	0	100327	0	117015009	4024958		
44235	4078	3001488	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	271070	0	7258-7	3001488		
27443	2542	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	168112	0	6158-0	3019406		
987	79	46235214	1947-12-21	1947-12-21 00:00:00	1947-12-21	5001	0	\N	0	0	\N	\N	0	5250	0	76690-7	46235214		
9263	877	3000876	1993-11-09	1993-11-09 00:00:00	1993-11-09	5001	0	\N	0	0	\N	\N	0	58381	0	6082-2	3000876		
38785	3583	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	238244	0	6206-7	3012494		
109824	3389	4024958	1996-02-15	1996-02-15 00:00:00	1996-02-15	5001	0	\N	0	0	\N	\N	0	224764	0	117015009	4024958		
23359	2153	3006322	1981-12-23	1981-12-23 00:00:00	1981-12-23	5001	0	\N	0	0	\N	\N	0	143506	0	8331-1	3006322		
34730	3178	3010813	2014-03-13	2014-03-13 00:00:00	2014-03-13	5001	0	\N	0	0	\N	\N	0	211388	0	26464-8	3010813		
15001	1391	3006322	1936-02-09	1936-02-09 00:00:00	1936-02-09	5001	0	\N	0	0	\N	\N	0	92313	0	8331-1	3006322		
7319	704	3012494	1986-12-25	1986-12-25 00:00:00	1986-12-25	5001	0	\N	0	0	\N	\N	0	46535	0	6206-7	3012494		
89730	2774	4024958	2004-04-06	2004-04-06 00:00:00	2004-04-06	5001	0	\N	0	0	\N	\N	0	183660	0	117015009	4024958		
28371	2626	3006322	1981-01-26	1981-01-26 00:00:00	1981-01-26	5001	0	\N	0	0	\N	\N	0	173712	0	8331-1	3006322		
39788	3695	3013682	1996-03-20	1996-03-20 00:00:00	1996-03-20	5001	0	\N	0	0	\N	\N	0	245605	0	3094-0	3013682		
10431	1015	40766240	2005-05-11	2005-05-11 00:00:00	2005-05-11	5001	0	\N	0	0	\N	\N	0	66821	0	63513-6	40766240		
12308	398	4052083	1948-02-13	1948-02-13 00:00:00	1948-02-13	5001	0	\N	0	0	\N	\N	0	26085	0	23426006	4052083		
41659	3876	3021226	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	257503	0	6246-3	3021226		
230	5	3006322	1980-08-05	1980-08-05 00:00:00	1980-08-05	5001	0	\N	0	0	\N	\N	0	478	0	8331-1	3006322		
20960	1935	3006322	1977-10-06	1977-10-06 00:00:00	1977-10-06	5001	0	\N	0	0	\N	\N	0	128735	0	8331-1	3006322		
54693	5002	3006322	1989-05-19	1989-05-19 00:00:00	1989-05-19	5001	0	\N	0	0	\N	\N	0	332725	0	8331-1	3006322		
32441	2945	3006322	1964-01-21	1964-01-21 00:00:00	1964-01-21	5001	0	\N	0	0	\N	\N	0	196482	0	8331-1	3006322		
54463	4977	3016723	2010-12-07	2010-12-07 00:00:00	2010-12-07	5001	0	\N	0	0	\N	\N	0	331120	0	2160-0	3016723		
1549	137	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	9162	0	6082-2	3000876		
12613	1209	3006322	1978-04-10	1978-04-10 00:00:00	1978-04-10	5001	0	\N	0	0	\N	\N	0	79471	0	8331-1	3006322		
65956	2025	4024958	1956-06-18	1956-06-18 00:00:00	1956-06-18	5001	0	\N	0	0	\N	\N	0	134667	0	117015009	4024958		
638	42	3006322	1939-04-12	1939-04-12 00:00:00	1939-04-12	5001	0	\N	0	0	\N	\N	0	3063	0	8331-1	3006322		
24479	2261	40766240	1965-02-02	1965-02-02 00:00:00	1965-02-02	5001	0	\N	0	0	\N	\N	0	150310	0	63513-6	40766240		
33662	3057	3006322	1995-03-28	1995-03-28 00:00:00	1995-03-28	5001	0	\N	0	0	\N	\N	0	203380	0	8331-1	3006322		
41261	3851	3006322	1958-10-30	1958-10-30 00:00:00	1958-10-30	5001	0	\N	0	0	\N	\N	0	255562	0	8331-1	3006322		
46915	4320	3006322	2018-07-10	2018-07-10 00:00:00	2018-07-10	5001	0	\N	0	0	\N	\N	0	286684	0	8331-1	3006322		
45186	4173	3006322	1977-11-23	1977-11-23 00:00:00	1977-11-23	5001	0	\N	0	0	\N	\N	0	277341	0	8331-1	3006322		
46373	4269	46235214	1969-09-28	1969-09-28 00:00:00	1969-09-28	5001	0	\N	0	0	\N	\N	0	283363	0	76690-7	46235214		
4003	399	3001247	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	26139	0	6085-5	3001247		
27003	2503	3001247	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	165689	0	6085-5	3001247		
63444	1950	4133840	2019-02-28	2019-02-28 00:00:00	2019-02-28	5001	0	\N	0	0	\N	\N	0	129697	0	127783003	4133840		
73042	2242	4052083	1976-02-23	1976-02-23 00:00:00	1976-02-23	5001	0	\N	0	0	\N	\N	0	149233	0	23426006	4052083		
35149	3215	3001488	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	213667	0	7258-7	3001488		
24561	2261	40758406	1967-02-22	1967-02-22 00:00:00	1967-02-22	5001	0	\N	0	0	\N	\N	0	150286	0	55277-8	40758406		
119544	3686	4052083	1991-11-29	1991-11-29 00:00:00	1991-11-29	5001	0	\N	0	0	\N	\N	0	245085	0	23426006	4052083		
36005	3311	3006322	1968-11-15	1968-11-15 00:00:00	1968-11-15	5001	0	\N	0	0	\N	\N	0	219859	0	8331-1	3006322		
57434	5276	3051031	2003-03-09	2003-03-09 00:00:00	2003-03-09	5001	0	\N	0	0	\N	\N	0	350877	0	46240-8	3051031		
142371	4376	4133840	1982-07-20	1982-07-20 00:00:00	1982-07-20	5001	0	\N	0	0	\N	\N	0	290702	0	127783003	4133840		
53384	4899	3011505	1979-07-24	1979-07-24 00:00:00	1979-07-24	5001	0	\N	0	0	\N	\N	0	325828	0	19926-5	3011505		
75831	2328	4052083	2009-12-08	2009-12-08 00:00:00	2009-12-08	5001	0	\N	0	0	\N	\N	0	154870	0	23426006	4052083		
24245	2238	3006322	2010-09-19	2010-09-19 00:00:00	2010-09-19	5001	0	\N	0	0	\N	\N	0	148926	0	8331-1	3006322		
96695	2960	4052083	1958-10-16	1958-10-16 00:00:00	1958-10-16	5001	0	\N	0	0	\N	\N	0	197662	0	23426006	4052083		
52495	4822	3011505	2018-06-13	2018-06-13 00:00:00	2018-06-13	5001	0	\N	0	0	\N	\N	0	320708	0	19926-5	3011505		
48559	1480	4024958	1978-07-29	1978-07-29 00:00:00	1978-07-29	5001	0	\N	0	0	\N	\N	0	98740	0	117015009	4024958		
4515	439	3006322	1981-07-07	1981-07-07 00:00:00	1981-07-07	5001	0	\N	0	0	\N	\N	0	29163	0	8331-1	3006322		
2715	266	3023430	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	17652	0	6833-8	3023430		
49396	1506	4024958	1958-08-28	1958-08-28 00:00:00	1958-08-28	5001	0	\N	0	0	\N	\N	0	100397	0	117015009	4024958		
44236	4078	3000876	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	271070	0	6082-2	3000876		
27444	2542	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	168112	0	6248-9	3015076		
988	79	40766240	1947-12-21	1947-12-21 00:00:00	1947-12-21	5001	0	\N	0	0	\N	\N	0	5250	0	63513-6	40766240		
9264	877	3001247	1993-11-09	1993-11-09 00:00:00	1993-11-09	5001	0	\N	0	0	\N	\N	0	58381	0	6085-5	3001247		
38786	3583	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	238244	0	6833-8	3023430		
11686	368	4024958	2008-03-20	2008-03-20 00:00:00	2008-03-20	5001	0	\N	0	0	\N	\N	0	24477	0	117015009	4024958		
23360	2153	3006322	2012-05-23	2012-05-23 00:00:00	2012-05-23	5001	0	\N	0	0	\N	\N	0	143509	0	8331-1	3006322		
34731	3178	3004501	2014-03-13	2014-03-13 00:00:00	2014-03-13	5001	0	\N	0	0	\N	\N	0	211388	0	2345-7	3004501		
15002	1391	3006322	1961-01-19	1961-01-19 00:00:00	1961-01-19	5001	0	\N	0	0	\N	\N	0	92398	0	8331-1	3006322		
7320	704	3036780	1986-12-25	1986-12-25 00:00:00	1986-12-25	5001	0	\N	0	0	\N	\N	0	46535	0	6095-4	3036780		
89736	2774	4024958	1978-08-28	1978-08-28 00:00:00	1978-08-28	5001	0	\N	0	0	\N	\N	0	183726	0	117015009	4024958		
28372	2626	3006322	1988-07-01	1988-07-01 00:00:00	1988-07-01	5001	0	\N	0	0	\N	\N	0	173717	0	8331-1	3006322		
39789	3695	3023103	1996-03-20	1996-03-20 00:00:00	1996-03-20	5001	0	\N	0	0	\N	\N	0	245605	0	2823-3	3023103		
10432	1015	46235214	2005-11-07	2005-11-07 00:00:00	2005-11-07	5001	0	\N	0	0	\N	\N	0	66822	0	76690-7	46235214		
138434	4268	4024958	1956-01-13	1956-01-13 00:00:00	1956-01-13	5001	0	\N	0	0	\N	\N	0	283265	0	117015009	4024958		
41660	3876	3000876	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	257503	0	6082-2	3000876		
231	6	3006322	2001-09-24	2001-09-24 00:00:00	2001-09-24	5001	0	\N	0	0	\N	\N	0	582	0	8331-1	3006322		
20961	1935	3006322	1972-12-21	1972-12-21 00:00:00	1972-12-21	5001	0	\N	0	0	\N	\N	0	128740	0	8331-1	3006322		
54694	5002	3006322	1977-04-06	1977-04-06 00:00:00	1977-04-06	5001	0	\N	0	0	\N	\N	0	332715	0	8331-1	3006322		
32442	2945	3011505	2000-08-15	2000-08-15 00:00:00	2000-08-15	5001	0	\N	0	0	\N	\N	0	196495	0	19926-5	3011505		
54464	4977	3028833	2010-12-07	2010-12-07 00:00:00	2010-12-07	5001	0	\N	0	0	\N	\N	0	331120	0	42719-5	3028833		
1550	137	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	9162	0	6106-9	3014599		
12614	1211	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	79522	0	6106-9	3014599		
65960	2025	4052083	2013-10-03	2013-10-03 00:00:00	2013-10-03	5001	0	\N	0	0	\N	\N	0	134726	0	23426006	4052083		
639	42	3006322	2009-12-06	2009-12-06 00:00:00	2009-12-06	5001	0	\N	0	0	\N	\N	0	2999	0	8331-1	3006322		
24480	2261	3051031	1965-02-02	1965-02-02 00:00:00	1965-02-02	5001	0	\N	0	0	\N	\N	0	150310	0	46240-8	3051031		
33663	3057	3006322	2008-09-01	2008-09-01 00:00:00	2008-09-01	5001	0	\N	0	0	\N	\N	0	203338	0	8331-1	3006322		
41262	3851	3006322	1912-10-26	1912-10-26 00:00:00	1912-10-26	5001	0	\N	0	0	\N	\N	0	255561	0	8331-1	3006322		
46916	4320	3006322	1984-03-16	1984-03-16 00:00:00	1984-03-16	5001	0	\N	0	0	\N	\N	0	286650	0	8331-1	3006322		
45188	4176	3006322	1991-02-08	1991-02-08 00:00:00	1991-02-08	5001	0	\N	0	0	\N	\N	0	277447	0	8331-1	3006322		
46375	4269	40758406	1969-09-28	1969-09-28 00:00:00	1969-09-28	5001	0	\N	0	0	\N	\N	0	283363	0	55277-8	40758406		
4004	399	3023430	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	26139	0	6833-8	3023430		
27004	2503	3023430	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	165689	0	6833-8	3023430		
63446	1950	4133840	2014-01-23	2014-01-23 00:00:00	2014-01-23	5001	0	\N	0	0	\N	\N	0	129664	0	127783003	4133840		
73043	2242	4024958	1980-10-22	1980-10-22 00:00:00	1980-10-22	5001	0	\N	0	0	\N	\N	0	149234	0	117015009	4024958		
35150	3215	3020655	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	213667	0	6844-5	3020655		
24562	2261	46235214	1967-02-22	1967-02-22 00:00:00	1967-02-22	5001	0	\N	0	0	\N	\N	0	150286	0	76690-7	46235214		
50943	1545	4052083	1996-09-12	1996-09-12 00:00:00	1996-09-12	5001	0	\N	0	0	\N	\N	0	103521	0	23426006	4052083		
36006	3311	3020655	1990-03-30	1990-03-30 00:00:00	1990-03-30	5001	0	\N	0	0	\N	\N	0	219805	0	6844-5	3020655		
57436	5276	46235214	2003-03-09	2003-03-09 00:00:00	2003-03-09	5001	0	\N	0	0	\N	\N	0	350877	0	76690-7	46235214		
73749	2267	4024958	1966-06-13	1966-06-13 00:00:00	1966-06-13	5001	0	\N	0	0	\N	\N	0	150682	0	117015009	4024958		
53385	4899	3011505	1984-08-21	1984-08-21 00:00:00	1984-08-21	5001	0	\N	0	0	\N	\N	0	325856	0	19926-5	3011505		
75839	2328	4052083	1969-12-09	1969-12-09 00:00:00	1969-12-09	5001	0	\N	0	0	\N	\N	0	154806	0	23426006	4052083		
24246	2238	3036780	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	148980	0	6095-4	3036780		
96700	2961	4052083	1994-06-29	1994-06-29 00:00:00	1994-06-29	5001	0	\N	0	0	\N	\N	0	197752	0	23426006	4052083		
52496	4822	3011505	2006-11-15	2006-11-15 00:00:00	2006-11-15	5001	0	\N	0	0	\N	\N	0	320790	0	19926-5	3011505		
48606	1482	4133840	2016-10-29	2016-10-29 00:00:00	2016-10-29	5001	0	\N	0	0	\N	\N	0	98827	0	127783003	4133840		
4516	439	3006322	1979-07-24	1979-07-24 00:00:00	1979-07-24	5001	0	\N	0	0	\N	\N	0	29102	0	8331-1	3006322		
2716	266	3006734	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	17652	0	6189-5	3006734		
49401	1506	4024958	1947-09-27	1947-09-27 00:00:00	1947-09-27	5001	0	\N	0	0	\N	\N	0	100409	0	117015009	4024958		
44237	4078	3012494	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	271070	0	6206-7	3012494		
27445	2542	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	168112	0	6075-6	3005136		
991	79	40758406	1947-12-21	1947-12-21 00:00:00	1947-12-21	5001	0	\N	0	0	\N	\N	0	5250	0	55277-8	40758406		
9265	877	3001488	1993-11-09	1993-11-09 00:00:00	1993-11-09	5001	0	\N	0	0	\N	\N	0	58381	0	7258-7	3001488		
38787	3583	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	238244	0	6082-2	3000876		
11688	368	4024958	1990-09-29	1990-09-29 00:00:00	1990-09-29	5001	0	\N	0	0	\N	\N	0	24515	0	117015009	4024958		
23361	2153	3006322	1981-05-14	1981-05-14 00:00:00	1981-05-14	5001	0	\N	0	0	\N	\N	0	143473	0	8331-1	3006322		
34732	3178	3009542	2014-03-13	2014-03-13 00:00:00	2014-03-13	5001	0	\N	0	0	\N	\N	0	211388	0	20570-8	3009542		
36041	1116	4024958	1972-12-04	1972-12-04 00:00:00	1972-12-04	5001	0	\N	0	0	\N	\N	0	73549	0	117015009	4024958		
7321	704	3000876	1986-12-25	1986-12-25 00:00:00	1986-12-25	5001	0	\N	0	0	\N	\N	0	46535	0	6082-2	3000876		
34338	1073	4024958	1980-03-23	1980-03-23 00:00:00	1980-03-23	5001	0	\N	0	0	\N	\N	0	70311	0	117015009	4024958		
28373	2626	3006322	1968-11-03	1968-11-03 00:00:00	1968-11-03	5001	0	\N	0	0	\N	\N	0	173706	0	8331-1	3006322		
39790	3695	3007461	1996-03-20	1996-03-20 00:00:00	1996-03-20	5001	0	\N	0	0	\N	\N	0	245605	0	26515-7	3007461		
10433	1015	40766240	2005-11-07	2005-11-07 00:00:00	2005-11-07	5001	0	\N	0	0	\N	\N	0	66822	0	63513-6	40766240		
138436	4268	4052083	1993-05-26	1993-05-26 00:00:00	1993-05-26	5001	0	\N	0	0	\N	\N	0	283246	0	23426006	4052083		
41661	3876	3027231	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	257503	0	6276-0	3027231		
233	6	3006322	1993-09-27	1993-09-27 00:00:00	1993-09-27	5001	0	\N	0	0	\N	\N	0	565	0	8331-1	3006322		
20962	1936	3006322	1949-07-12	1949-07-12 00:00:00	1949-07-12	5001	0	\N	0	0	\N	\N	0	128810	0	8331-1	3006322		
54698	5004	3015076	1993-09-14	1993-09-14 00:00:00	1993-09-14	5001	0	\N	0	0	\N	\N	0	332834	0	6248-9	3015076		
32443	2945	3006322	1945-10-19	1945-10-19 00:00:00	1945-10-19	5001	0	\N	0	0	\N	\N	0	196520	0	8331-1	3006322		
54465	4977	3004501	2010-12-07	2010-12-07 00:00:00	2010-12-07	5001	0	\N	0	0	\N	\N	0	331120	0	2345-7	3004501		
1551	137	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	9162	0	6158-0	3019406		
12615	1211	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	79522	0	6273-7	3006451		
4848	149	4052083	1999-03-29	1999-03-29 00:00:00	1999-03-29	5001	0	\N	0	0	\N	\N	0	10049	0	23426006	4052083		
640	42	3006322	1962-12-24	1962-12-24 00:00:00	1962-12-24	5001	0	\N	0	0	\N	\N	0	3052	0	8331-1	3006322		
24481	2261	3006322	1984-08-19	1984-08-19 00:00:00	1984-08-19	5001	0	\N	0	0	\N	\N	0	150270	0	8331-1	3006322		
33664	3057	3006322	1991-06-30	1991-06-30 00:00:00	1991-06-30	5001	0	\N	0	0	\N	\N	0	203365	0	8331-1	3006322		
41263	3851	3006322	1982-10-20	1982-10-20 00:00:00	1982-10-20	5001	0	\N	0	0	\N	\N	0	255495	0	8331-1	3006322		
46917	4320	3006322	1989-08-28	1989-08-28 00:00:00	1989-08-28	5001	0	\N	0	0	\N	\N	0	286662	0	8331-1	3006322		
45189	4176	3006322	1979-02-14	1979-02-14 00:00:00	1979-02-14	5001	0	\N	0	0	\N	\N	0	277551	0	8331-1	3006322		
46377	4269	40766240	1969-05-31	1969-05-31 00:00:00	1969-05-31	5001	0	\N	0	0	\N	\N	0	283315	0	63513-6	40766240		
4005	399	3020655	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	26139	0	6844-5	3020655		
27005	2503	3036780	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	165689	0	6095-4	3036780		
63453	1950	4133840	1992-09-24	1992-09-24 00:00:00	1992-09-24	5001	0	\N	0	0	\N	\N	0	129681	0	127783003	4133840		
73058	2242	4024958	1933-12-19	1933-12-19 00:00:00	1933-12-19	5001	0	\N	0	0	\N	\N	0	149264	0	117015009	4024958		
35151	3215	3006734	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	213667	0	6189-5	3006734		
24565	2261	46235214	1966-11-24	1966-11-24 00:00:00	1966-11-24	5001	0	\N	0	0	\N	\N	0	150285	0	76690-7	46235214		
62294	1911	4133840	2009-11-09	2009-11-09 00:00:00	2009-11-09	5001	0	\N	0	0	\N	\N	0	127123	0	127783003	4133840		
36007	3311	3014599	1990-03-30	1990-03-30 00:00:00	1990-03-30	5001	0	\N	0	0	\N	\N	0	219805	0	6106-9	3014599		
57437	5276	40766240	2003-03-09	2003-03-09 00:00:00	2003-03-09	5001	0	\N	0	0	\N	\N	0	350877	0	63513-6	40766240		
73755	2267	4024958	1993-07-19	1993-07-19 00:00:00	1993-07-19	5001	0	\N	0	0	\N	\N	0	150725	0	117015009	4024958		
121853	3759	4024958	1973-02-26	1973-02-26 00:00:00	1973-02-26	5001	0	\N	0	0	\N	\N	0	249881	0	117015009	4024958		
75844	2328	4052083	2015-12-26	2015-12-26 00:00:00	2015-12-26	5001	0	\N	0	0	\N	\N	0	154858	0	23426006	4052083		
24247	2238	3019406	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	148980	0	6158-0	3019406		
96701	2961	4052083	2005-12-28	2005-12-28 00:00:00	2005-12-28	5001	0	\N	0	0	\N	\N	0	197706	0	23426006	4052083		
52498	4822	40766240	1970-11-07	1970-11-07 00:00:00	1970-11-07	5001	0	\N	0	0	\N	\N	0	320711	0	63513-6	40766240		
92241	2843	4024958	1959-12-04	1959-12-04 00:00:00	1959-12-04	5001	0	\N	0	0	\N	\N	0	188719	0	117015009	4024958		
4517	439	3006322	1990-03-20	1990-03-20 00:00:00	1990-03-20	5001	0	\N	0	0	\N	\N	0	29157	0	8331-1	3006322		
2717	266	3001247	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	17652	0	6085-5	3001247		
49402	1506	4024958	1978-11-28	1978-11-28 00:00:00	1978-11-28	5001	0	\N	0	0	\N	\N	0	100413	0	117015009	4024958		
44238	4078	3020655	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	271070	0	6844-5	3020655		
27446	2542	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	168112	0	6206-7	3012494		
992	79	3006322	1997-12-20	1997-12-20 00:00:00	1997-12-20	5001	0	\N	0	0	\N	\N	0	5284	0	8331-1	3006322		
9266	877	3015076	1993-11-09	1993-11-09 00:00:00	1993-11-09	5001	0	\N	0	0	\N	\N	0	58381	0	6248-9	3015076		
38788	3583	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	238244	0	6075-6	3005136		
11691	368	4024958	2008-04-30	2008-04-30 00:00:00	2008-04-30	5001	0	\N	0	0	\N	\N	0	24516	0	117015009	4024958		
23362	2155	3049273	1996-01-11	1996-01-11 00:00:00	1996-01-11	5001	0	\N	0	0	\N	\N	0	143617	0	38265-5	3049273		
34733	3178	3024561	2014-03-13	2014-03-13 00:00:00	2014-03-13	5001	0	\N	0	0	\N	\N	0	211388	0	1751-7	3024561		
36044	1116	4052083	1997-09-25	1997-09-25 00:00:00	1997-09-25	5001	0	\N	0	0	\N	\N	0	73550	0	23426006	4052083		
7322	704	40769189	1986-12-15	1986-12-15 00:00:00	1986-12-15	5001	0	\N	0	0	\N	\N	0	46534	0	66529-9	40769189		
34343	1073	4024958	1996-08-08	1996-08-08 00:00:00	1996-08-08	5001	0	\N	0	0	\N	\N	0	70422	0	117015009	4024958		
28374	2626	3006322	2003-12-20	2003-12-20 00:00:00	2003-12-20	5001	0	\N	0	0	\N	\N	0	173716	0	8331-1	3006322		
39793	3697	3006322	1971-05-23	1971-05-23 00:00:00	1971-05-23	5001	0	\N	0	0	\N	\N	0	245781	0	8331-1	3006322		
10436	1015	3051031	2005-11-07	2005-11-07 00:00:00	2005-11-07	5001	0	\N	0	0	\N	\N	0	66822	0	46240-8	3051031		
138455	4268	4024958	1965-05-09	1965-05-09 00:00:00	1965-05-09	5001	0	\N	0	0	\N	\N	0	283276	0	117015009	4024958		
41662	3876	3015076	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	257503	0	6248-9	3015076		
234	7	3006322	1997-04-12	1997-04-12 00:00:00	1997-04-12	5001	0	\N	0	0	\N	\N	0	601	0	8331-1	3006322		
20963	1936	3009542	2007-02-06	2007-02-06 00:00:00	2007-02-06	5001	0	\N	0	0	\N	\N	0	128829	0	20570-8	3009542		
54699	5004	3001488	1993-09-14	1993-09-14 00:00:00	1993-09-14	5001	0	\N	0	0	\N	\N	0	332834	0	7258-7	3001488		
32444	2945	3006322	1948-10-17	1948-10-17 00:00:00	1948-10-17	5001	0	\N	0	0	\N	\N	0	196512	0	8331-1	3006322		
54466	4977	3006923	2010-12-07	2010-12-07 00:00:00	2010-12-07	5001	0	\N	0	0	\N	\N	0	331120	0	1742-6	3006923		
1552	137	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	9162	0	6273-7	3006451		
12616	1211	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	79522	0	6844-5	3020655		
4856	149	4024958	1971-07-10	1971-07-10 00:00:00	1971-07-10	5001	0	\N	0	0	\N	\N	0	10048	0	117015009	4024958		
641	42	3006322	1985-05-25	1985-05-25 00:00:00	1985-05-25	5001	0	\N	0	0	\N	\N	0	2998	0	8331-1	3006322		
24482	2261	3051031	1965-12-29	1965-12-29 00:00:00	1965-12-29	5001	0	\N	0	0	\N	\N	0	150269	0	46240-8	3051031		
33665	3057	3006322	1938-10-28	1938-10-28 00:00:00	1938-10-28	5001	0	\N	0	0	\N	\N	0	203357	0	8331-1	3006322		
41264	3851	3006322	1959-01-13	1959-01-13 00:00:00	1959-01-13	5001	0	\N	0	0	\N	\N	0	255599	0	8331-1	3006322		
46918	4320	3016723	1970-05-14	1970-05-14 00:00:00	1970-05-14	5001	0	\N	0	0	\N	\N	0	286692	0	2160-0	3016723		
45190	4176	3006322	1984-03-03	1984-03-03 00:00:00	1984-03-03	5001	0	\N	0	0	\N	\N	0	277446	0	8331-1	3006322		
46378	4269	3051031	1969-05-31	1969-05-31 00:00:00	1969-05-31	5001	0	\N	0	0	\N	\N	0	283315	0	46240-8	3051031		
4006	399	3006322	1960-01-22	1960-01-22 00:00:00	1960-01-22	5001	0	\N	0	0	\N	\N	0	26251	0	8331-1	3006322		
51865	1569	4052083	1943-03-03	1943-03-03 00:00:00	1943-03-03	5001	0	\N	0	0	\N	\N	0	105240	0	23426006	4052083		
63455	1950	4133840	2001-11-15	2001-11-15 00:00:00	2001-11-15	5001	0	\N	0	0	\N	\N	0	129619	0	127783003	4133840		
73060	2242	4024958	1929-09-28	1929-09-28 00:00:00	1929-09-28	5001	0	\N	0	0	\N	\N	0	149232	0	117015009	4024958		
35152	3215	3006322	1986-02-06	1986-02-06 00:00:00	1986-02-06	5001	0	\N	0	0	\N	\N	0	213560	0	8331-1	3006322		
24566	2261	3051031	1966-11-24	1966-11-24 00:00:00	1966-11-24	5001	0	\N	0	0	\N	\N	0	150285	0	46240-8	3051031		
127455	3921	4052083	2008-02-25	2008-02-25 00:00:00	2008-02-25	5001	0	\N	0	0	\N	\N	0	260727	0	23426006	4052083		
36008	3311	3021226	1990-03-30	1990-03-30 00:00:00	1990-03-30	5001	0	\N	0	0	\N	\N	0	219805	0	6246-3	3021226		
57439	5276	3006322	1981-04-18	1981-04-18 00:00:00	1981-04-18	5001	0	\N	0	0	\N	\N	0	350925	0	8331-1	3006322		
73767	2267	4052083	1979-07-05	1979-07-05 00:00:00	1979-07-05	5001	0	\N	0	0	\N	\N	0	150721	0	23426006	4052083		
121878	3759	4024958	1982-06-08	1982-06-08 00:00:00	1982-06-08	5001	0	\N	0	0	\N	\N	0	249948	0	117015009	4024958		
75852	2329	4052083	2008-07-27	2008-07-27 00:00:00	2008-07-27	5001	0	\N	0	0	\N	\N	0	154926	0	23426006	4052083		
24248	2238	3015076	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	148980	0	6248-9	3015076		
26616	2456	3006322	1995-08-01	1995-08-01 00:00:00	1995-08-01	5001	0	\N	0	0	\N	\N	0	162755	0	8331-1	3006322		
52500	4822	46235214	1970-11-07	1970-11-07 00:00:00	1970-11-07	5001	0	\N	0	0	\N	\N	0	320711	0	76690-7	46235214		
92244	2843	4052083	2001-05-29	2001-05-29 00:00:00	2001-05-29	5001	0	\N	0	0	\N	\N	0	188780	0	23426006	4052083		
4518	440	3006322	1997-03-23	1997-03-23 00:00:00	1997-03-23	5001	0	\N	0	0	\N	\N	0	29198	0	8331-1	3006322		
2718	266	3015076	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	17652	0	6248-9	3015076		
60687	1851	4024958	1992-09-23	1992-09-23 00:00:00	1992-09-23	5001	0	\N	0	0	\N	\N	0	123838	0	117015009	4024958		
44239	4078	3023430	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	271070	0	6833-8	3023430		
27447	2542	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	168112	0	6106-9	3014599		
995	79	3051031	1947-05-26	1947-05-26 00:00:00	1947-05-26	5001	0	\N	0	0	\N	\N	0	5357	0	46240-8	3051031		
9267	877	3012494	1993-11-09	1993-11-09 00:00:00	1993-11-09	5001	0	\N	0	0	\N	\N	0	58381	0	6206-7	3012494		
38789	3583	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	238244	0	6106-9	3014599		
149288	4578	4024958	1975-01-10	1975-01-10 00:00:00	1975-01-10	5001	0	\N	0	0	\N	\N	0	304976	0	117015009	4024958		
23363	2155	3006322	1986-01-02	1986-01-02 00:00:00	1986-01-02	5001	0	\N	0	0	\N	\N	0	143656	0	8331-1	3006322		
34734	3178	3026361	2014-03-13	2014-03-13 00:00:00	2014-03-13	5001	0	\N	0	0	\N	\N	0	211388	0	26453-1	3026361		
36056	1117	4052083	1974-05-03	1974-05-03 00:00:00	1974-05-03	5001	0	\N	0	0	\N	\N	0	73569	0	23426006	4052083		
7323	704	40769194	1986-12-15	1986-12-15 00:00:00	1986-12-15	5001	0	\N	0	0	\N	\N	0	46534	0	66534-9	40769194		
4221	419	46235214	1913-09-22	1913-09-22 00:00:00	1913-09-22	5001	0	\N	0	0	\N	\N	0	27717	0	76690-7	46235214		
28400	2630	3049273	2013-03-30	2013-03-30 00:00:00	2013-03-30	5001	0	\N	0	0	\N	\N	0	173997	0	38265-5	3049273		
39794	3697	3006322	2002-06-29	2002-06-29 00:00:00	2002-06-29	5001	0	\N	0	0	\N	\N	0	245731	0	8331-1	3006322		
10437	1015	40758406	2005-11-07	2005-11-07 00:00:00	2005-11-07	5001	0	\N	0	0	\N	\N	0	66822	0	55277-8	40758406		
138479	4269	4052083	2010-03-23	2010-03-23 00:00:00	2010-03-23	5001	0	\N	0	0	\N	\N	0	283368	0	23426006	4052083		
41663	3876	3001488	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	257503	0	7258-7	3001488		
239	9	3006322	1996-02-09	1996-02-09 00:00:00	1996-02-09	5001	0	\N	0	0	\N	\N	0	846	0	8331-1	3006322		
20964	1936	3000963	2007-02-06	2007-02-06 00:00:00	2007-02-06	5001	0	\N	0	0	\N	\N	0	128829	0	718-7	3000963		
54700	5004	3027231	1993-09-14	1993-09-14 00:00:00	1993-09-14	5001	0	\N	0	0	\N	\N	0	332834	0	6276-0	3027231		
32445	2945	3011505	2004-09-07	2004-09-07 00:00:00	2004-09-07	5001	0	\N	0	0	\N	\N	0	196504	0	19926-5	3011505		
54467	4977	3000963	2010-12-07	2010-12-07 00:00:00	2010-12-07	5001	0	\N	0	0	\N	\N	0	331120	0	718-7	3000963		
1553	137	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	9162	0	6095-4	3036780		
12617	1211	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	79522	0	7258-7	3001488		
4860	149	4024958	1960-05-28	1960-05-28 00:00:00	1960-05-28	5001	0	\N	0	0	\N	\N	0	10072	0	117015009	4024958		
642	42	3049273	1970-06-04	1970-06-04 00:00:00	1970-06-04	5001	0	\N	0	0	\N	\N	0	3106	0	38265-5	3049273		
24483	2261	40766240	1965-12-29	1965-12-29 00:00:00	1965-12-29	5001	0	\N	0	0	\N	\N	0	150269	0	63513-6	40766240		
33666	3059	3006322	1987-12-15	1987-12-15 00:00:00	1987-12-15	5001	0	\N	0	0	\N	\N	0	203503	0	8331-1	3006322		
41267	3851	3006322	1950-10-29	1950-10-29 00:00:00	1950-10-29	5001	0	\N	0	0	\N	\N	0	255597	0	8331-1	3006322		
46919	4320	3028833	1970-05-14	1970-05-14 00:00:00	1970-05-14	5001	0	\N	0	0	\N	\N	0	286692	0	42719-5	3028833		
45191	4176	3006322	2005-12-31	2005-12-31 00:00:00	2005-12-31	5001	0	\N	0	0	\N	\N	0	277449	0	8331-1	3006322		
46379	4269	40758406	1969-05-31	1969-05-31 00:00:00	1969-05-31	5001	0	\N	0	0	\N	\N	0	283315	0	55277-8	40758406		
4007	399	3006322	2001-01-28	2001-01-28 00:00:00	2001-01-28	5001	0	\N	0	0	\N	\N	0	26155	0	8331-1	3006322		
51867	1569	4024958	2006-06-15	2006-06-15 00:00:00	2006-06-15	5001	0	\N	0	0	\N	\N	0	105272	0	117015009	4024958		
63558	1952	4024958	1960-08-04	1960-08-04 00:00:00	1960-08-04	5001	0	\N	0	0	\N	\N	0	129813	0	117015009	4024958		
73072	2242	4024958	1948-08-18	1948-08-18 00:00:00	1948-08-18	5001	0	\N	0	0	\N	\N	0	149299	0	117015009	4024958		
35153	3215	3006322	2007-10-08	2007-10-08 00:00:00	2007-10-08	5001	0	\N	0	0	\N	\N	0	213598	0	8331-1	3006322		
24567	2261	40766240	1966-11-24	1966-11-24 00:00:00	1966-11-24	5001	0	\N	0	0	\N	\N	0	150285	0	63513-6	40766240		
127527	3926	4133840	1986-09-29	1986-09-29 00:00:00	1986-09-29	5001	0	\N	0	0	\N	\N	0	260998	0	127783003	4133840		
36009	3311	3027231	1990-03-30	1990-03-30 00:00:00	1990-03-30	5001	0	\N	0	0	\N	\N	0	219805	0	6276-0	3027231		
57440	5276	3006322	1972-03-21	1972-03-21 00:00:00	1972-03-21	5001	0	\N	0	0	\N	\N	0	350866	0	8331-1	3006322		
3684	351	3006322	1978-12-27	1978-12-27 00:00:00	1978-12-27	5001	0	\N	0	0	\N	\N	0	23404	0	8331-1	3006322		
27662	863	4024958	1945-03-10	1945-03-10 00:00:00	1945-03-10	5001	0	\N	0	0	\N	\N	0	57162	0	117015009	4024958		
75870	2329	4024958	1996-04-01	1996-04-01 00:00:00	1996-04-01	5001	0	\N	0	0	\N	\N	0	154939	0	117015009	4024958		
24249	2238	3005136	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	148980	0	6075-6	3005136		
26617	2456	3006322	1992-04-04	1992-04-04 00:00:00	1992-04-04	5001	0	\N	0	0	\N	\N	0	162828	0	8331-1	3006322		
52501	4822	40758406	1970-11-07	1970-11-07 00:00:00	1970-11-07	5001	0	\N	0	0	\N	\N	0	320711	0	55277-8	40758406		
92247	2843	4052083	1998-01-06	1998-01-06 00:00:00	1998-01-06	5001	0	\N	0	0	\N	\N	0	188791	0	23426006	4052083		
4519	440	3006322	1995-12-17	1995-12-17 00:00:00	1995-12-17	5001	0	\N	0	0	\N	\N	0	29183	0	8331-1	3006322		
2719	266	3020655	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	17652	0	6844-5	3020655		
1991	180	3027231	1990-04-26	1990-04-26 00:00:00	1990-04-26	5001	0	\N	0	0	\N	\N	0	12108	0	6276-0	3027231		
44240	4078	3036780	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	271070	0	6095-4	3036780		
27448	2542	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	168112	0	7258-7	3001488		
996	79	46235214	1947-05-26	1947-05-26 00:00:00	1947-05-26	5001	0	\N	0	0	\N	\N	0	5357	0	76690-7	46235214		
9268	877	3020655	1993-11-09	1993-11-09 00:00:00	1993-11-09	5001	0	\N	0	0	\N	\N	0	58381	0	6844-5	3020655		
38790	3583	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	238244	0	6273-7	3006451		
149295	4578	4024958	1985-10-22	1985-10-22 00:00:00	1985-10-22	5001	0	\N	0	0	\N	\N	0	304920	0	117015009	4024958		
23364	2155	3006322	2006-05-29	2006-05-29 00:00:00	2006-05-29	5001	0	\N	0	0	\N	\N	0	143604	0	8331-1	3006322		
34735	3178	3024731	2014-03-13	2014-03-13 00:00:00	2014-03-13	5001	0	\N	0	0	\N	\N	0	211388	0	30428-7	3024731		
36077	1117	4052083	2002-06-30	2002-06-30 00:00:00	2002-06-30	5001	0	\N	0	0	\N	\N	0	73566	0	23426006	4052083		
7324	704	40769179	1986-12-15	1986-12-15 00:00:00	1986-12-15	5001	0	\N	0	0	\N	\N	0	46534	0	66519-0	40769179		
4222	419	40758406	1913-09-22	1913-09-22 00:00:00	1913-09-22	5001	0	\N	0	0	\N	\N	0	27717	0	55277-8	40758406		
28401	2630	3006322	1962-01-09	1962-01-09 00:00:00	1962-01-09	5001	0	\N	0	0	\N	\N	0	173982	0	8331-1	3006322		
39795	3697	3006322	1996-11-17	1996-11-17 00:00:00	1996-11-17	5001	0	\N	0	0	\N	\N	0	245730	0	8331-1	3006322		
10439	1015	40758406	2005-12-07	2005-12-07 00:00:00	2005-12-07	5001	0	\N	0	0	\N	\N	0	66850	0	55277-8	40758406		
138481	4269	4024958	1988-08-10	1988-08-10 00:00:00	1988-08-10	5001	0	\N	0	0	\N	\N	0	283305	0	117015009	4024958		
41664	3876	3023430	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	257503	0	6833-8	3023430		
240	9	3006322	2000-05-28	2000-05-28 00:00:00	2000-05-28	5001	0	\N	0	0	\N	\N	0	856	0	8331-1	3006322		
20965	1936	3006322	1953-07-04	1953-07-04 00:00:00	1953-07-04	5001	0	\N	0	0	\N	\N	0	128826	0	8331-1	3006322		
54701	5004	3005136	1993-09-14	1993-09-14 00:00:00	1993-09-14	5001	0	\N	0	0	\N	\N	0	332834	0	6075-6	3005136		
32447	2945	3011505	1999-08-10	1999-08-10 00:00:00	1999-08-10	5001	0	\N	0	0	\N	\N	0	196456	0	19926-5	3011505		
54468	4977	3019550	2010-12-07	2010-12-07 00:00:00	2010-12-07	5001	0	\N	0	0	\N	\N	0	331120	0	2951-2	3019550		
1554	137	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	9162	0	6206-7	3012494		
12618	1211	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	79522	0	6189-5	3006734		
4864	149	4052083	1960-02-21	1960-02-21 00:00:00	1960-02-21	5001	0	\N	0	0	\N	\N	0	10029	0	23426006	4052083		
643	42	3006322	1940-10-20	1940-10-20 00:00:00	1940-10-20	5001	0	\N	0	0	\N	\N	0	3051	0	8331-1	3006322		
24484	2261	40758406	1965-12-29	1965-12-29 00:00:00	1965-12-29	5001	0	\N	0	0	\N	\N	0	150269	0	55277-8	40758406		
33667	3059	3006322	1972-08-08	1972-08-08 00:00:00	1972-08-08	5001	0	\N	0	0	\N	\N	0	203502	0	8331-1	3006322		
41268	3852	3006322	1968-11-10	1968-11-10 00:00:00	1968-11-10	5001	0	\N	0	0	\N	\N	0	255707	0	8331-1	3006322		
46920	4320	3009542	1970-05-14	1970-05-14 00:00:00	1970-05-14	5001	0	\N	0	0	\N	\N	0	286692	0	20570-8	3009542		
46380	4269	46235214	1969-05-31	1969-05-31 00:00:00	1969-05-31	5001	0	\N	0	0	\N	\N	0	283315	0	76690-7	46235214		
4008	399	3006322	1994-12-09	1994-12-09 00:00:00	1994-12-09	5001	0	\N	0	0	\N	\N	0	26124	0	8331-1	3006322		
51868	1569	4052083	2016-06-24	2016-06-24 00:00:00	2016-06-24	5001	0	\N	0	0	\N	\N	0	105273	0	23426006	4052083		
63595	1953	4024958	1969-08-21	1969-08-21 00:00:00	1969-08-21	5001	0	\N	0	0	\N	\N	0	129902	0	117015009	4024958		
73103	2243	4024958	1967-08-16	1967-08-16 00:00:00	1967-08-16	5001	0	\N	0	0	\N	\N	0	149372	0	117015009	4024958		
35154	3215	3006322	1978-06-02	1978-06-02 00:00:00	1978-06-02	5001	0	\N	0	0	\N	\N	0	213640	0	8331-1	3006322		
24568	2261	40758406	1966-11-24	1966-11-24 00:00:00	1966-11-24	5001	0	\N	0	0	\N	\N	0	150285	0	55277-8	40758406		
45977	4238	3006322	1967-01-03	1967-01-03 00:00:00	1967-01-03	5001	0	\N	0	0	\N	\N	0	281388	0	8331-1	3006322		
36010	3311	3019406	1990-03-30	1990-03-30 00:00:00	1990-03-30	5001	0	\N	0	0	\N	\N	0	219805	0	6158-0	3019406		
57441	5276	3006322	1962-10-26	1962-10-26 00:00:00	1962-10-26	5001	0	\N	0	0	\N	\N	0	350903	0	8331-1	3006322		
3685	351	3006322	1986-04-04	1986-04-04 00:00:00	1986-04-04	5001	0	\N	0	0	\N	\N	0	23340	0	8331-1	3006322		
142375	4376	4133840	2017-01-31	2017-01-31 00:00:00	2017-01-31	5001	0	\N	0	0	\N	\N	0	290758	0	127783003	4133840		
120593	3720	4052083	2010-10-04	2010-10-04 00:00:00	2010-10-04	5001	0	\N	0	0	\N	\N	0	247247	0	23426006	4052083		
24250	2238	3012494	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	148980	0	6206-7	3012494		
26618	2456	3006322	2016-09-23	2016-09-23 00:00:00	2016-09-23	5001	0	\N	0	0	\N	\N	0	162773	0	8331-1	3006322		
52502	4822	3051031	1970-11-07	1970-11-07 00:00:00	1970-11-07	5001	0	\N	0	0	\N	\N	0	320711	0	46240-8	3051031		
92256	2844	4052083	1953-02-07	1953-02-07 00:00:00	1953-02-07	5001	0	\N	0	0	\N	\N	0	188810	0	23426006	4052083		
4521	442	3021226	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	29416	0	6246-3	3021226		
2720	266	3001488	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	17652	0	7258-7	3001488		
1992	180	3005136	1990-04-26	1990-04-26 00:00:00	1990-04-26	5001	0	\N	0	0	\N	\N	0	12108	0	6075-6	3005136		
44241	4078	3014599	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	271070	0	6106-9	3014599		
27449	2542	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	168112	0	6189-5	3006734		
997	79	40758406	1947-05-26	1947-05-26 00:00:00	1947-05-26	5001	0	\N	0	0	\N	\N	0	5357	0	55277-8	40758406		
9269	877	3006734	1993-11-09	1993-11-09 00:00:00	1993-11-09	5001	0	\N	0	0	\N	\N	0	58381	0	6189-5	3006734		
38791	3583	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	238244	0	6246-3	3021226		
149296	4578	4024958	1978-02-04	1978-02-04 00:00:00	1978-02-04	5001	0	\N	0	0	\N	\N	0	304977	0	117015009	4024958		
23365	2155	3049273	2007-04-25	2007-04-25 00:00:00	2007-04-25	5001	0	\N	0	0	\N	\N	0	143622	0	38265-5	3049273		
34736	3178	3006923	2014-03-13	2014-03-13 00:00:00	2014-03-13	5001	0	\N	0	0	\N	\N	0	211388	0	1742-6	3006923		
139386	4295	4052083	2009-04-09	2009-04-09 00:00:00	2009-04-09	5001	0	\N	0	0	\N	\N	0	285045	0	23426006	4052083		
7325	704	40769184	1986-12-15	1986-12-15 00:00:00	1986-12-15	5001	0	\N	0	0	\N	\N	0	46534	0	66524-0	40769184		
4223	419	40766240	1913-09-22	1913-09-22 00:00:00	1913-09-22	5001	0	\N	0	0	\N	\N	0	27717	0	63513-6	40766240		
28402	2630	3006322	2007-02-18	2007-02-18 00:00:00	2007-02-18	5001	0	\N	0	0	\N	\N	0	173934	0	8331-1	3006322		
39796	3697	3006322	1953-07-12	1953-07-12 00:00:00	1953-07-12	5001	0	\N	0	0	\N	\N	0	245768	0	8331-1	3006322		
10440	1015	3051031	2005-12-07	2005-12-07 00:00:00	2005-12-07	5001	0	\N	0	0	\N	\N	0	66850	0	46240-8	3051031		
138489	4269	4024958	1981-10-04	1981-10-04 00:00:00	1981-10-04	5001	0	\N	0	0	\N	\N	0	283366	0	117015009	4024958		
41665	3876	3036780	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	257503	0	6095-4	3036780		
241	9	3020655	1979-01-30	1979-01-30 00:00:00	1979-01-30	5001	0	\N	0	0	\N	\N	0	707	0	6844-5	3020655		
20966	1936	3049273	2009-07-31	2009-07-31 00:00:00	2009-07-31	5001	0	\N	0	0	\N	\N	0	128759	0	38265-5	3049273		
54702	5004	3001247	1993-09-14	1993-09-14 00:00:00	1993-09-14	5001	0	\N	0	0	\N	\N	0	332834	0	6085-5	3001247		
32448	2945	3011505	1970-09-22	1970-09-22 00:00:00	1970-09-22	5001	0	\N	0	0	\N	\N	0	196506	0	19926-5	3011505		
54469	4977	3035995	2010-12-07	2010-12-07 00:00:00	2010-12-07	5001	0	\N	0	0	\N	\N	0	331120	0	6768-6	3035995		
1555	137	3006322	1985-11-10	1985-11-10 00:00:00	1985-11-10	5001	0	\N	0	0	\N	\N	0	9196	0	8331-1	3006322		
37352	1155	4052083	1981-03-09	1981-03-09 00:00:00	1981-03-09	5001	0	\N	0	0	\N	\N	0	76305	0	23426006	4052083		
103061	3170	4052083	1972-12-18	1972-12-18 00:00:00	1972-12-18	5001	0	\N	0	0	\N	\N	0	210721	0	23426006	4052083		
644	42	3006322	1913-07-15	1913-07-15 00:00:00	1913-07-15	5001	0	\N	0	0	\N	\N	0	3060	0	8331-1	3006322		
24485	2261	46235214	1965-12-29	1965-12-29 00:00:00	1965-12-29	5001	0	\N	0	0	\N	\N	0	150269	0	76690-7	46235214		
33668	3059	3006322	2006-06-02	2006-06-02 00:00:00	2006-06-02	5001	0	\N	0	0	\N	\N	0	203496	0	8331-1	3006322		
41269	3852	40769179	1970-10-12	1970-10-12 00:00:00	1970-10-12	5001	0	\N	0	0	\N	\N	0	255635	0	66519-0	40769179		
46921	4320	3013721	1970-05-14	1970-05-14 00:00:00	1970-05-14	5001	0	\N	0	0	\N	\N	0	286692	0	1920-8	3013721		
46382	4269	46235214	1988-02-21	1988-02-21 00:00:00	1988-02-21	5001	0	\N	0	0	\N	\N	0	283324	0	76690-7	46235214		
4009	399	3006322	1979-09-17	1979-09-17 00:00:00	1979-09-17	5001	0	\N	0	0	\N	\N	0	26253	0	8331-1	3006322		
51869	1569	4052083	2005-02-12	2005-02-12 00:00:00	2005-02-12	5001	0	\N	0	0	\N	\N	0	105259	0	23426006	4052083		
63597	1953	4024958	1997-08-17	1997-08-17 00:00:00	1997-08-17	5001	0	\N	0	0	\N	\N	0	129900	0	117015009	4024958		
130606	4024	4052083	2006-04-29	2006-04-29 00:00:00	2006-04-29	5001	0	\N	0	0	\N	\N	0	267558	0	23426006	4052083		
35155	3215	3005136	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	213667	0	6075-6	3005136		
24573	2261	3051031	1964-12-04	1964-12-04 00:00:00	1964-12-04	5001	0	\N	0	0	\N	\N	0	150278	0	46240-8	3051031		
45978	4238	3006322	1993-06-23	1993-06-23 00:00:00	1993-06-23	5001	0	\N	0	0	\N	\N	0	281418	0	8331-1	3006322		
36011	3311	3006451	1990-03-30	1990-03-30 00:00:00	1990-03-30	5001	0	\N	0	0	\N	\N	0	219805	0	6273-7	3006451		
57442	5276	3006322	2005-06-08	2005-06-08 00:00:00	2005-06-08	5001	0	\N	0	0	\N	\N	0	350878	0	8331-1	3006322		
3686	352	3006322	1992-12-27	1992-12-27 00:00:00	1992-12-27	5001	0	\N	0	0	\N	\N	0	23449	0	8331-1	3006322		
142381	4376	4133840	1981-07-14	1981-07-14 00:00:00	1981-07-14	5001	0	\N	0	0	\N	\N	0	290833	0	127783003	4133840		
120599	3720	4024958	1966-01-19	1966-01-19 00:00:00	1966-01-19	5001	0	\N	0	0	\N	\N	0	247293	0	117015009	4024958		
24251	2238	3014599	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	148980	0	6106-9	3014599		
26619	2456	3006322	1981-10-21	1981-10-21 00:00:00	1981-10-21	5001	0	\N	0	0	\N	\N	0	162754	0	8331-1	3006322		
52503	4822	3011505	2009-12-02	2009-12-02 00:00:00	2009-12-02	5001	0	\N	0	0	\N	\N	0	320773	0	19926-5	3011505		
92257	2844	4052083	1959-09-19	1959-09-19 00:00:00	1959-09-19	5001	0	\N	0	0	\N	\N	0	188826	0	23426006	4052083		
4522	442	3006451	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	29416	0	6273-7	3006451		
2721	266	3000876	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	17652	0	6082-2	3000876		
1993	180	3019406	1990-04-26	1990-04-26 00:00:00	1990-04-26	5001	0	\N	0	0	\N	\N	0	12108	0	6158-0	3019406		
44242	4078	3021226	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	271070	0	6246-3	3021226		
27450	2542	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	168112	0	6085-5	3001247		
998	79	40766240	1947-05-26	1947-05-26 00:00:00	1947-05-26	5001	0	\N	0	0	\N	\N	0	5357	0	63513-6	40766240		
9270	877	3023430	1993-11-09	1993-11-09 00:00:00	1993-11-09	5001	0	\N	0	0	\N	\N	0	58381	0	6833-8	3023430		
38792	3583	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	238244	0	6276-0	3027231		
149303	4579	4052083	1985-09-18	1985-09-18 00:00:00	1985-09-18	5001	0	\N	0	0	\N	\N	0	305028	0	23426006	4052083		
23366	2155	3006322	1979-09-19	1979-09-19 00:00:00	1979-09-19	5001	0	\N	0	0	\N	\N	0	143655	0	8331-1	3006322		
34737	3178	3014576	2014-03-13	2014-03-13 00:00:00	2014-03-13	5001	0	\N	0	0	\N	\N	0	211388	0	2075-0	3014576		
139389	4295	4024958	2018-01-04	2018-01-04 00:00:00	2018-01-04	5001	0	\N	0	0	\N	\N	0	285075	0	117015009	4024958		
7326	704	3006322	2007-09-12	2007-09-12 00:00:00	2007-09-12	5001	0	\N	0	0	\N	\N	0	46598	0	8331-1	3006322		
4225	419	3049273	1969-07-21	1969-07-21 00:00:00	1969-07-21	5001	0	\N	0	0	\N	\N	0	27711	0	38265-5	3049273		
28403	2630	3006322	1991-03-03	1991-03-03 00:00:00	1991-03-03	5001	0	\N	0	0	\N	\N	0	173932	0	8331-1	3006322		
141409	4359	4052083	1970-10-17	1970-10-17 00:00:00	1970-10-17	5001	0	\N	0	0	\N	\N	0	289222	0	23426006	4052083		
10441	1015	46235214	2005-12-07	2005-12-07 00:00:00	2005-12-07	5001	0	\N	0	0	\N	\N	0	66850	0	76690-7	46235214		
138494	4270	4024958	1991-03-15	1991-03-15 00:00:00	1991-03-15	5001	0	\N	0	0	\N	\N	0	283435	0	117015009	4024958		
41666	3876	3012494	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	257503	0	6206-7	3012494		
242	9	3000876	1979-01-30	1979-01-30 00:00:00	1979-01-30	5001	0	\N	0	0	\N	\N	0	707	0	6082-2	3000876		
20967	1936	3006322	1960-01-12	1960-01-12 00:00:00	1960-01-12	5001	0	\N	0	0	\N	\N	0	128769	0	8331-1	3006322		
54703	5004	3006734	1993-09-14	1993-09-14 00:00:00	1993-09-14	5001	0	\N	0	0	\N	\N	0	332834	0	6189-5	3006734		
32449	2945	3011505	2002-08-27	2002-08-27 00:00:00	2002-08-27	5001	0	\N	0	0	\N	\N	0	196503	0	19926-5	3011505		
54470	4977	3026361	2010-12-07	2010-12-07 00:00:00	2010-12-07	5001	0	\N	0	0	\N	\N	0	331120	0	26453-1	3026361		
1556	137	3006322	1995-06-18	1995-06-18 00:00:00	1995-06-18	5001	0	\N	0	0	\N	\N	0	9149	0	8331-1	3006322		
37357	1155	4052083	1972-10-19	1972-10-19 00:00:00	1972-10-19	5001	0	\N	0	0	\N	\N	0	76324	0	23426006	4052083		
114394	3528	4024958	1991-10-16	1991-10-16 00:00:00	1991-10-16	5001	0	\N	0	0	\N	\N	0	234173	0	117015009	4024958		
645	42	3006322	1950-04-16	1950-04-16 00:00:00	1950-04-16	5001	0	\N	0	0	\N	\N	0	3015	0	8331-1	3006322		
24489	2261	40766240	1966-09-25	1966-09-25 00:00:00	1966-09-25	5001	0	\N	0	0	\N	\N	0	150299	0	63513-6	40766240		
33669	3059	3006322	1979-08-18	1979-08-18 00:00:00	1979-08-18	5001	0	\N	0	0	\N	\N	0	203505	0	8331-1	3006322		
41270	3852	40769189	1970-10-12	1970-10-12 00:00:00	1970-10-12	5001	0	\N	0	0	\N	\N	0	255635	0	66529-9	40769189		
46922	4320	3004501	1970-05-14	1970-05-14 00:00:00	1970-05-14	5001	0	\N	0	0	\N	\N	0	286692	0	2345-7	3004501		
46385	4269	3051031	1988-02-21	1988-02-21 00:00:00	1988-02-21	5001	0	\N	0	0	\N	\N	0	283324	0	46240-8	3051031		
4010	399	3006322	1962-02-22	1962-02-22 00:00:00	1962-02-22	5001	0	\N	0	0	\N	\N	0	26161	0	8331-1	3006322		
51890	1571	4024958	1979-02-15	1979-02-15 00:00:00	1979-02-15	5001	0	\N	0	0	\N	\N	0	105482	0	117015009	4024958		
63604	1954	4024958	1940-06-08	1940-06-08 00:00:00	1940-06-08	5001	0	\N	0	0	\N	\N	0	129947	0	117015009	4024958		
130609	4024	4133840	2015-05-17	2015-05-17 00:00:00	2015-05-17	5001	0	\N	0	0	\N	\N	0	267547	0	127783003	4133840		
35156	3215	3021226	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	213667	0	6246-3	3021226		
24574	2261	40766240	1964-12-04	1964-12-04 00:00:00	1964-12-04	5001	0	\N	0	0	\N	\N	0	150278	0	63513-6	40766240		
45979	4238	3006322	1997-04-19	1997-04-19 00:00:00	1997-04-19	5001	0	\N	0	0	\N	\N	0	281390	0	8331-1	3006322		
36012	3311	3005136	1990-03-30	1990-03-30 00:00:00	1990-03-30	5001	0	\N	0	0	\N	\N	0	219805	0	6075-6	3005136		
57443	5276	40758406	2003-02-07	2003-02-07 00:00:00	2003-02-07	5001	0	\N	0	0	\N	\N	0	350934	0	55277-8	40758406		
3687	352	3006322	1994-08-31	1994-08-31 00:00:00	1994-08-31	5001	0	\N	0	0	\N	\N	0	23438	0	8331-1	3006322		
142384	4376	4133840	1997-10-14	1997-10-14 00:00:00	1997-10-14	5001	0	\N	0	0	\N	\N	0	290808	0	127783003	4133840		
120600	3720	4024958	2002-09-02	2002-09-02 00:00:00	2002-09-02	5001	0	\N	0	0	\N	\N	0	247286	0	117015009	4024958		
24252	2238	3001488	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	148980	0	7258-7	3001488		
26620	2456	3006322	1969-04-14	1969-04-14 00:00:00	1969-04-14	5001	0	\N	0	0	\N	\N	0	162826	0	8331-1	3006322		
52504	4822	3011505	2007-11-21	2007-11-21 00:00:00	2007-11-21	5001	0	\N	0	0	\N	\N	0	320772	0	19926-5	3011505		
92266	2844	4052083	1986-09-07	1986-09-07 00:00:00	1986-09-07	5001	0	\N	0	0	\N	\N	0	188805	0	23426006	4052083		
4523	442	3015076	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	29416	0	6248-9	3015076		
2722	266	3006322	1973-12-25	1973-12-25 00:00:00	1973-12-25	5001	0	\N	0	0	\N	\N	0	17650	0	8331-1	3006322		
1994	180	3015076	1990-04-26	1990-04-26 00:00:00	1990-04-26	5001	0	\N	0	0	\N	\N	0	12108	0	6248-9	3015076		
44243	4078	3019406	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	271070	0	6158-0	3019406		
27451	2542	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	168112	0	6833-8	3023430		
999	80	3006322	2003-09-14	2003-09-14 00:00:00	2003-09-14	5001	0	\N	0	0	\N	\N	0	5412	0	8331-1	3006322		
9271	877	3006322	1996-06-05	1996-06-05 00:00:00	1996-06-05	5001	0	\N	0	0	\N	\N	0	58460	0	8331-1	3006322		
38793	3583	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	238244	0	6158-0	3019406		
149309	4579	4052083	1976-11-12	1976-11-12 00:00:00	1976-11-12	5001	0	\N	0	0	\N	\N	0	305072	0	23426006	4052083		
23367	2155	3006322	1961-08-11	1961-08-11 00:00:00	1961-08-11	5001	0	\N	0	0	\N	\N	0	143654	0	8331-1	3006322		
34738	3178	3000963	2014-03-13	2014-03-13 00:00:00	2014-03-13	5001	0	\N	0	0	\N	\N	0	211388	0	718-7	3000963		
139397	4295	4052083	2017-03-02	2017-03-02 00:00:00	2017-03-02	5001	0	\N	0	0	\N	\N	0	285063	0	23426006	4052083		
7327	704	3006322	1970-05-20	1970-05-20 00:00:00	1970-05-20	5001	0	\N	0	0	\N	\N	0	46514	0	8331-1	3006322		
4226	419	3006322	1928-09-11	1928-09-11 00:00:00	1928-09-11	5001	0	\N	0	0	\N	\N	0	27686	0	8331-1	3006322		
28404	2630	3006322	2017-04-10	2017-04-10 00:00:00	2017-04-10	5001	0	\N	0	0	\N	\N	0	174021	0	8331-1	3006322		
152689	4680	4052083	1933-01-13	1933-01-13 00:00:00	1933-01-13	5001	0	\N	0	0	\N	\N	0	311878	0	23426006	4052083		
10443	1015	40766240	2005-12-07	2005-12-07 00:00:00	2005-12-07	5001	0	\N	0	0	\N	\N	0	66850	0	63513-6	40766240		
138513	4270	4024958	2005-03-11	2005-03-11 00:00:00	2005-03-11	5001	0	\N	0	0	\N	\N	0	283401	0	117015009	4024958		
41667	3876	3005136	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	257503	0	6075-6	3005136		
243	9	3019406	1979-01-30	1979-01-30 00:00:00	1979-01-30	5001	0	\N	0	0	\N	\N	0	707	0	6158-0	3019406		
20968	1937	3006322	1966-08-10	1966-08-10 00:00:00	1966-08-10	5001	0	\N	0	0	\N	\N	0	128845	0	8331-1	3006322		
54704	5004	3020655	1993-09-14	1993-09-14 00:00:00	1993-09-14	5001	0	\N	0	0	\N	\N	0	332834	0	6844-5	3020655		
32450	2945	3011505	2012-01-31	2012-01-31 00:00:00	2012-01-31	5001	0	\N	0	0	\N	\N	0	196519	0	19926-5	3011505		
54471	4977	3015632	2010-12-07	2010-12-07 00:00:00	2010-12-07	5001	0	\N	0	0	\N	\N	0	331120	0	2028-9	3015632		
1557	137	3006322	2011-03-17	2011-03-17 00:00:00	2011-03-17	5001	0	\N	0	0	\N	\N	0	9164	0	8331-1	3006322		
37394	1158	4024958	1998-02-15	1998-02-15 00:00:00	1998-02-15	5001	0	\N	0	0	\N	\N	0	76505	0	117015009	4024958		
114399	3528	4052083	2011-11-04	2011-11-04 00:00:00	2011-11-04	5001	0	\N	0	0	\N	\N	0	234240	0	23426006	4052083		
646	42	3006322	1988-10-15	1988-10-15 00:00:00	1988-10-15	5001	0	\N	0	0	\N	\N	0	3068	0	8331-1	3006322		
24490	2261	40758406	1966-09-25	1966-09-25 00:00:00	1966-09-25	5001	0	\N	0	0	\N	\N	0	150299	0	55277-8	40758406		
33670	3059	3006322	2001-11-13	2001-11-13 00:00:00	2001-11-13	5001	0	\N	0	0	\N	\N	0	203474	0	8331-1	3006322		
41271	3852	40769194	1970-10-12	1970-10-12 00:00:00	1970-10-12	5001	0	\N	0	0	\N	\N	0	255635	0	66534-9	40769194		
46923	4320	3006923	1970-05-14	1970-05-14 00:00:00	1970-05-14	5001	0	\N	0	0	\N	\N	0	286692	0	1742-6	3006923		
46386	4269	40766240	1988-02-21	1988-02-21 00:00:00	1988-02-21	5001	0	\N	0	0	\N	\N	0	283324	0	63513-6	40766240		
4011	399	3006322	1955-09-02	1955-09-02 00:00:00	1955-09-02	5001	0	\N	0	0	\N	\N	0	26250	0	8331-1	3006322		
51895	1571	4024958	1968-12-05	1968-12-05 00:00:00	1968-12-05	5001	0	\N	0	0	\N	\N	0	105481	0	117015009	4024958		
63611	1954	4024958	1997-11-05	1997-11-05 00:00:00	1997-11-05	5001	0	\N	0	0	\N	\N	0	130052	0	117015009	4024958		
130614	4024	4133840	2003-08-24	2003-08-24 00:00:00	2003-08-24	5001	0	\N	0	0	\N	\N	0	267535	0	127783003	4133840		
35157	3215	3012494	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	213667	0	6206-7	3012494		
24575	2261	40758406	1964-12-04	1964-12-04 00:00:00	1964-12-04	5001	0	\N	0	0	\N	\N	0	150278	0	55277-8	40758406		
45980	4238	3006322	1987-06-11	1987-06-11 00:00:00	1987-06-11	5001	0	\N	0	0	\N	\N	0	281361	0	8331-1	3006322		
36013	3311	3015076	1990-03-30	1990-03-30 00:00:00	1990-03-30	5001	0	\N	0	0	\N	\N	0	219805	0	6248-9	3015076		
57445	5276	3051031	2003-02-07	2003-02-07 00:00:00	2003-02-07	5001	0	\N	0	0	\N	\N	0	350934	0	46240-8	3051031		
3720	354	3011505	2019-03-21	2019-03-21 00:00:00	2019-03-21	5001	0	\N	0	0	\N	\N	0	23524	0	19926-5	3011505		
142385	4376	4133840	2013-01-08	2013-01-08 00:00:00	2013-01-08	5001	0	\N	0	0	\N	\N	0	290782	0	127783003	4133840		
120623	3720	4024958	1983-06-01	1983-06-01 00:00:00	1983-06-01	5001	0	\N	0	0	\N	\N	0	247245	0	117015009	4024958		
24253	2238	3006734	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	148980	0	6189-5	3006734		
150317	4608	4133840	2012-01-26	2012-01-26 00:00:00	2012-01-26	5001	0	\N	0	0	\N	\N	0	306944	0	127783003	4133840		
52505	4822	3011505	2005-11-09	2005-11-09 00:00:00	2005-11-09	5001	0	\N	0	0	\N	\N	0	320771	0	19926-5	3011505		
92274	2844	4024958	1988-03-28	1988-03-28 00:00:00	1988-03-28	5001	0	\N	0	0	\N	\N	0	188806	0	117015009	4024958		
4524	442	3027231	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	29416	0	6276-0	3027231		
2723	266	3021226	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	17657	0	6246-3	3021226		
1995	180	3000876	1990-04-26	1990-04-26 00:00:00	1990-04-26	5001	0	\N	0	0	\N	\N	0	12108	0	6082-2	3000876		
44244	4078	3015076	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	271070	0	6248-9	3015076		
27452	2542	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	168112	0	6844-5	3020655		
1000	80	3006322	1975-12-30	1975-12-30 00:00:00	1975-12-30	5001	0	\N	0	0	\N	\N	0	5400	0	8331-1	3006322		
9272	877	3006322	2016-04-20	2016-04-20 00:00:00	2016-04-20	5001	0	\N	0	0	\N	\N	0	58468	0	8331-1	3006322		
38794	3583	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	238244	0	6095-4	3036780		
149315	4579	4024958	1976-05-11	1976-05-11 00:00:00	1976-05-11	5001	0	\N	0	0	\N	\N	0	305024	0	117015009	4024958		
23368	2155	3006322	1987-06-12	1987-06-12 00:00:00	1987-06-12	5001	0	\N	0	0	\N	\N	0	143577	0	8331-1	3006322		
34739	3178	3019550	2014-03-13	2014-03-13 00:00:00	2014-03-13	5001	0	\N	0	0	\N	\N	0	211388	0	2951-2	3019550		
34772	3179	3049273	1979-12-29	1979-12-29 00:00:00	1979-12-29	5001	0	\N	0	0	\N	\N	0	211522	0	38265-5	3049273		
18618	1713	3006322	2010-10-20	2010-10-20 00:00:00	2010-10-20	5001	0	\N	0	0	\N	\N	0	114496	0	8331-1	3006322		
4227	419	3006322	1915-01-11	1915-01-11 00:00:00	1915-01-11	5001	0	\N	0	0	\N	\N	0	27749	0	8331-1	3006322		
28405	2630	3006322	1972-12-23	1972-12-23 00:00:00	1972-12-23	5001	0	\N	0	0	\N	\N	0	174010	0	8331-1	3006322		
152699	4680	4052083	1950-06-21	1950-06-21 00:00:00	1950-06-21	5001	0	\N	0	0	\N	\N	0	311886	0	23426006	4052083		
10444	1015	3006322	2009-10-29	2009-10-29 00:00:00	2009-10-29	5001	0	\N	0	0	\N	\N	0	66836	0	8331-1	3006322		
145975	4480	4024958	1995-10-07	1995-10-07 00:00:00	1995-10-07	5001	0	\N	0	0	\N	\N	0	298137	0	117015009	4024958		
41668	3876	3014599	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	257503	0	6106-9	3014599		
244	9	3036780	1979-01-30	1979-01-30 00:00:00	1979-01-30	5001	0	\N	0	0	\N	\N	0	707	0	6095-4	3036780		
20969	1937	3006322	1970-12-27	1970-12-27 00:00:00	1970-12-27	5001	0	\N	0	0	\N	\N	0	128847	0	8331-1	3006322		
54705	5004	3012494	1993-09-14	1993-09-14 00:00:00	1993-09-14	5001	0	\N	0	0	\N	\N	0	332834	0	6206-7	3012494		
32451	2945	3011505	2007-09-25	2007-09-25 00:00:00	2007-09-25	5001	0	\N	0	0	\N	\N	0	196489	0	19926-5	3011505		
54472	4977	3045716	2010-12-07	2010-12-07 00:00:00	2010-12-07	5001	0	\N	0	0	\N	\N	0	331120	0	33037-3	3045716		
1558	137	40769179	2002-06-30	2002-06-30 00:00:00	2002-06-30	5001	0	\N	0	0	\N	\N	0	9230	0	66519-0	40769179		
37396	1158	4024958	2015-02-15	2015-02-15 00:00:00	2015-02-15	5001	0	\N	0	0	\N	\N	0	76523	0	117015009	4024958		
53207	4890	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	325066	0	6158-0	3019406		
647	42	3006322	1981-10-29	1981-10-29 00:00:00	1981-10-29	5001	0	\N	0	0	\N	\N	0	3135	0	8331-1	3006322		
24491	2261	3051031	1966-09-25	1966-09-25 00:00:00	1966-09-25	5001	0	\N	0	0	\N	\N	0	150299	0	46240-8	3051031		
33671	3059	3006322	2009-05-09	2009-05-09 00:00:00	2009-05-09	5001	0	\N	0	0	\N	\N	0	203476	0	8331-1	3006322		
41272	3852	40769184	1970-10-12	1970-10-12 00:00:00	1970-10-12	5001	0	\N	0	0	\N	\N	0	255635	0	66524-0	40769184		
46924	4320	3024731	1970-05-14	1970-05-14 00:00:00	1970-05-14	5001	0	\N	0	0	\N	\N	0	286692	0	30428-7	3024731		
46387	4269	40758406	1988-02-21	1988-02-21 00:00:00	1988-02-21	5001	0	\N	0	0	\N	\N	0	283324	0	55277-8	40758406		
4012	399	3006322	1998-10-01	1998-10-01 00:00:00	1998-10-01	5001	0	\N	0	0	\N	\N	0	26140	0	8331-1	3006322		
52017	1574	4024958	1967-03-02	1967-03-02 00:00:00	1967-03-02	5001	0	\N	0	0	\N	\N	0	105710	0	117015009	4024958		
63621	1954	4024958	1969-05-15	1969-05-15 00:00:00	1969-05-15	5001	0	\N	0	0	\N	\N	0	129949	0	117015009	4024958		
130620	4024	4133840	2018-05-20	2018-05-20 00:00:00	2018-05-20	5001	0	\N	0	0	\N	\N	0	267569	0	127783003	4133840		
35158	3215	3014599	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	213667	0	6106-9	3014599		
24576	2261	46235214	1964-12-04	1964-12-04 00:00:00	1964-12-04	5001	0	\N	0	0	\N	\N	0	150278	0	76690-7	46235214		
45981	4238	3006322	2010-07-25	2010-07-25 00:00:00	2010-07-25	5001	0	\N	0	0	\N	\N	0	281373	0	8331-1	3006322		
36014	3311	3012494	1990-03-30	1990-03-30 00:00:00	1990-03-30	5001	0	\N	0	0	\N	\N	0	219805	0	6206-7	3012494		
57446	5276	40766240	2003-02-07	2003-02-07 00:00:00	2003-02-07	5001	0	\N	0	0	\N	\N	0	350934	0	63513-6	40766240		
3721	354	3011505	2015-02-26	2015-02-26 00:00:00	2015-02-26	5001	0	\N	0	0	\N	\N	0	23593	0	19926-5	3011505		
142388	4376	4133840	1975-07-01	1975-07-01 00:00:00	1975-07-01	5001	0	\N	0	0	\N	\N	0	290816	0	127783003	4133840		
120629	3720	4052083	2008-05-09	2008-05-09 00:00:00	2008-05-09	5001	0	\N	0	0	\N	\N	0	247287	0	23426006	4052083		
24254	2238	3001247	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	148980	0	6085-5	3001247		
150325	4608	4133840	2017-02-23	2017-02-23 00:00:00	2017-02-23	5001	0	\N	0	0	\N	\N	0	306945	0	127783003	4133840		
52506	4822	40758406	1949-02-20	1949-02-20 00:00:00	1949-02-20	5001	0	\N	0	0	\N	\N	0	320730	0	55277-8	40758406		
92275	2844	4024958	1949-11-01	1949-11-01 00:00:00	1949-11-01	5001	0	\N	0	0	\N	\N	0	188879	0	117015009	4024958		
4525	442	3001488	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	29416	0	7258-7	3001488		
2724	266	3027231	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	17657	0	6276-0	3027231		
1996	180	3006734	1990-04-26	1990-04-26 00:00:00	1990-04-26	5001	0	\N	0	0	\N	\N	0	12108	0	6189-5	3006734		
44245	4078	3006322	1964-01-17	1964-01-17 00:00:00	1964-01-17	5001	0	\N	0	0	\N	\N	0	270976	0	8331-1	3006322		
27453	2542	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	168112	0	6276-0	3027231		
1001	80	3006322	1951-03-25	1951-03-25 00:00:00	1951-03-25	5001	0	\N	0	0	\N	\N	0	5439	0	8331-1	3006322		
9273	877	3015076	1978-06-07	1978-06-07 00:00:00	1978-06-07	5001	0	\N	0	0	\N	\N	0	58348	0	6248-9	3015076		
38795	3583	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	238244	0	6189-5	3006734		
149318	4579	4052083	2001-02-28	2001-02-28 00:00:00	2001-02-28	5001	0	\N	0	0	\N	\N	0	305030	0	23426006	4052083		
23369	2155	3006322	2000-10-14	2000-10-14 00:00:00	2000-10-14	5001	0	\N	0	0	\N	\N	0	143580	0	8331-1	3006322		
34740	3178	3028833	2014-03-13	2014-03-13 00:00:00	2014-03-13	5001	0	\N	0	0	\N	\N	0	211388	0	42719-5	3028833		
34773	3179	3006322	1922-05-23	1922-05-23 00:00:00	1922-05-23	5001	0	\N	0	0	\N	\N	0	211486	0	8331-1	3006322		
18619	1713	3006322	2013-05-19	2013-05-19 00:00:00	2013-05-19	5001	0	\N	0	0	\N	\N	0	114497	0	8331-1	3006322		
4228	419	40758406	1912-10-27	1912-10-27 00:00:00	1912-10-27	5001	0	\N	0	0	\N	\N	0	27738	0	55277-8	40758406		
28406	2631	3006322	1960-02-29	1960-02-29 00:00:00	1960-02-29	5001	0	\N	0	0	\N	\N	0	174080	0	8331-1	3006322		
152715	4682	4024958	1996-02-21	1996-02-21 00:00:00	1996-02-21	5001	0	\N	0	0	\N	\N	0	312023	0	117015009	4024958		
10445	1015	40758406	2019-02-27	2019-02-27 00:00:00	2019-02-27	5001	0	\N	0	0	\N	\N	0	66811	0	55277-8	40758406		
145987	4480	4052083	2013-10-15	2013-10-15 00:00:00	2013-10-15	5001	0	\N	0	0	\N	\N	0	298125	0	23426006	4052083		
7443	711	3014576	1967-01-29	1967-01-29 00:00:00	1967-01-29	5001	0	\N	0	0	\N	\N	0	47196	0	2075-0	3014576		
245	9	3006734	1979-01-30	1979-01-30 00:00:00	1979-01-30	5001	0	\N	0	0	\N	\N	0	707	0	6189-5	3006734		
20970	1937	3006322	1965-03-06	1965-03-06 00:00:00	1965-03-06	5001	0	\N	0	0	\N	\N	0	128871	0	8331-1	3006322		
54706	5004	3019406	1993-09-14	1993-09-14 00:00:00	1993-09-14	5001	0	\N	0	0	\N	\N	0	332834	0	6158-0	3019406		
19160	1756	3006322	1993-08-06	1993-08-06 00:00:00	1993-08-06	5001	0	\N	0	0	\N	\N	0	117451	0	8331-1	3006322		
54473	4977	3020630	2010-12-07	2010-12-07 00:00:00	2010-12-07	5001	0	\N	0	0	\N	\N	0	331120	0	2885-2	3020630		
1559	137	40769189	2002-06-30	2002-06-30 00:00:00	2002-06-30	5001	0	\N	0	0	\N	\N	0	9230	0	66529-9	40769189		
37400	1158	4024958	2010-01-07	2010-01-07 00:00:00	2010-01-07	5001	0	\N	0	0	\N	\N	0	76508	0	117015009	4024958		
53208	4890	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	325066	0	6844-5	3020655		
648	43	3006322	1967-07-18	1967-07-18 00:00:00	1967-07-18	5001	0	\N	0	0	\N	\N	0	3143	0	8331-1	3006322		
24492	2261	46235214	1966-09-25	1966-09-25 00:00:00	1966-09-25	5001	0	\N	0	0	\N	\N	0	150299	0	76690-7	46235214		
33672	3059	3006322	2007-03-10	2007-03-10 00:00:00	2007-03-10	5001	0	\N	0	0	\N	\N	0	203483	0	8331-1	3006322		
41273	3852	3006322	1993-04-17	1993-04-17 00:00:00	1993-04-17	5001	0	\N	0	0	\N	\N	0	255753	0	8331-1	3006322		
46925	4320	3006906	1970-05-14	1970-05-14 00:00:00	1970-05-14	5001	0	\N	0	0	\N	\N	0	286692	0	17861-6	3006906		
46388	4269	3006322	1988-08-10	1988-08-10 00:00:00	1988-08-10	5001	0	\N	0	0	\N	\N	0	283305	0	8331-1	3006322		
4022	403	3049273	1991-08-29	1991-08-29 00:00:00	1991-08-29	5001	0	\N	0	0	\N	\N	0	26465	0	38265-5	3049273		
52018	1574	4052083	2017-09-26	2017-09-26 00:00:00	2017-09-26	5001	0	\N	0	0	\N	\N	0	105648	0	23426006	4052083		
109606	3381	4052083	2007-01-29	2007-01-29 00:00:00	2007-01-29	5001	0	\N	0	0	\N	\N	0	224367	0	23426006	4052083		
130626	4024	4052083	1981-09-16	1981-09-16 00:00:00	1981-09-16	5001	0	\N	0	0	\N	\N	0	267515	0	23426006	4052083		
35159	3215	3001488	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	213667	0	7258-7	3001488		
24577	2261	46235214	1965-09-30	1965-09-30 00:00:00	1965-09-30	5001	0	\N	0	0	\N	\N	0	150268	0	76690-7	46235214		
45982	4238	3006322	1973-06-10	1973-06-10 00:00:00	1973-06-10	5001	0	\N	0	0	\N	\N	0	281359	0	8331-1	3006322		
36015	3311	3001247	1990-03-30	1990-03-30 00:00:00	1990-03-30	5001	0	\N	0	0	\N	\N	0	219805	0	6085-5	3001247		
57448	5276	46235214	2003-02-07	2003-02-07 00:00:00	2003-02-07	5001	0	\N	0	0	\N	\N	0	350934	0	76690-7	46235214		
3722	354	3011505	2008-01-17	2008-01-17 00:00:00	2008-01-17	5001	0	\N	0	0	\N	\N	0	23589	0	19926-5	3011505		
142392	4376	4133840	1996-10-08	1996-10-08 00:00:00	1996-10-08	5001	0	\N	0	0	\N	\N	0	290802	0	127783003	4133840		
120630	3720	4024958	1963-02-20	1963-02-20 00:00:00	1963-02-20	5001	0	\N	0	0	\N	\N	0	247292	0	117015009	4024958		
24255	2238	3023430	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	148980	0	6833-8	3023430		
150328	4608	4133840	2010-01-14	2010-01-14 00:00:00	2010-01-14	5001	0	\N	0	0	\N	\N	0	306943	0	127783003	4133840		
52507	4822	3051031	1949-02-20	1949-02-20 00:00:00	1949-02-20	5001	0	\N	0	0	\N	\N	0	320730	0	46240-8	3051031		
92276	2844	4024958	1967-02-14	1967-02-14 00:00:00	1967-02-14	5001	0	\N	0	0	\N	\N	0	188883	0	117015009	4024958		
4526	442	3023430	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	29416	0	6833-8	3023430		
2725	266	3019406	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	17657	0	6158-0	3019406		
1997	180	3036780	1990-04-26	1990-04-26 00:00:00	1990-04-26	5001	0	\N	0	0	\N	\N	0	12108	0	6095-4	3036780		
44246	4078	3019406	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	271017	0	6158-0	3019406		
27454	2542	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	168112	0	6273-7	3006451		
1002	80	3006322	1986-08-29	1986-08-29 00:00:00	1986-08-29	5001	0	\N	0	0	\N	\N	0	5382	0	8331-1	3006322		
9274	877	3020655	1978-06-07	1978-06-07 00:00:00	1978-06-07	5001	0	\N	0	0	\N	\N	0	58348	0	6844-5	3020655		
38796	3583	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	238244	0	6085-5	3001247		
149325	4579	4024958	1973-04-15	1973-04-15 00:00:00	1973-04-15	5001	0	\N	0	0	\N	\N	0	305023	0	117015009	4024958		
23371	2156	3006322	1969-10-27	1969-10-27 00:00:00	1969-10-27	5001	0	\N	0	0	\N	\N	0	143744	0	8331-1	3006322		
34741	3178	3016723	2014-03-13	2014-03-13 00:00:00	2014-03-13	5001	0	\N	0	0	\N	\N	0	211388	0	2160-0	3016723		
34774	3179	3006322	1928-02-04	1928-02-04 00:00:00	1928-02-04	5001	0	\N	0	0	\N	\N	0	211511	0	8331-1	3006322		
18620	1713	3006322	1989-11-04	1989-11-04 00:00:00	1989-11-04	5001	0	\N	0	0	\N	\N	0	114452	0	8331-1	3006322		
4229	419	40766240	1912-10-27	1912-10-27 00:00:00	1912-10-27	5001	0	\N	0	0	\N	\N	0	27738	0	63513-6	40766240		
28411	2631	3006322	1962-02-02	1962-02-02 00:00:00	1962-02-02	5001	0	\N	0	0	\N	\N	0	174050	0	8331-1	3006322		
152716	4682	4052083	1992-05-11	1992-05-11 00:00:00	1992-05-11	5001	0	\N	0	0	\N	\N	0	312004	0	23426006	4052083		
10447	1015	3051031	2019-02-27	2019-02-27 00:00:00	2019-02-27	5001	0	\N	0	0	\N	\N	0	66811	0	46240-8	3051031		
145989	4480	4024958	1966-09-01	1966-09-01 00:00:00	1966-09-01	5001	0	\N	0	0	\N	\N	0	298190	0	117015009	4024958		
7444	711	3035995	1967-01-29	1967-01-29 00:00:00	1967-01-29	5001	0	\N	0	0	\N	\N	0	47196	0	6768-6	3035995		
246	9	3023430	1979-01-30	1979-01-30 00:00:00	1979-01-30	5001	0	\N	0	0	\N	\N	0	707	0	6833-8	3023430		
20971	1937	3006322	2010-09-10	2010-09-10 00:00:00	2010-09-10	5001	0	\N	0	0	\N	\N	0	128849	0	8331-1	3006322		
54707	5004	3021226	1993-09-14	1993-09-14 00:00:00	1993-09-14	5001	0	\N	0	0	\N	\N	0	332834	0	6246-3	3021226		
19161	1756	3006322	2009-04-25	2009-04-25 00:00:00	2009-04-25	5001	0	\N	0	0	\N	\N	0	117463	0	8331-1	3006322		
54474	4977	3023103	2010-12-07	2010-12-07 00:00:00	2010-12-07	5001	0	\N	0	0	\N	\N	0	331120	0	2823-3	3023103		
1560	137	40769194	2002-06-30	2002-06-30 00:00:00	2002-06-30	5001	0	\N	0	0	\N	\N	0	9230	0	66534-9	40769194		
37402	1158	4052083	2004-06-14	2004-06-14 00:00:00	2004-06-14	5001	0	\N	0	0	\N	\N	0	76528	0	23426006	4052083		
53209	4890	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	325066	0	7258-7	3001488		
649	43	3006322	2007-10-28	2007-10-28 00:00:00	2007-10-28	5001	0	\N	0	0	\N	\N	0	3174	0	8331-1	3006322		
24493	2261	46235214	1965-06-02	1965-06-02 00:00:00	1965-06-02	5001	0	\N	0	0	\N	\N	0	150280	0	76690-7	46235214		
33673	3060	3006322	1971-12-29	1971-12-29 00:00:00	1971-12-29	5001	0	\N	0	0	\N	\N	0	203543	0	8331-1	3006322		
41274	3852	3001488	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	255735	0	7258-7	3001488		
46926	4320	21494966	1970-05-14	1970-05-14 00:00:00	1970-05-14	5001	0	\N	0	0	\N	\N	0	286692	0	80271-0	21494966		
46389	4270	3006322	1991-03-15	1991-03-15 00:00:00	1991-03-15	5001	0	\N	0	0	\N	\N	0	283435	0	8331-1	3006322		
4023	403	3006322	1992-03-25	1992-03-25 00:00:00	1992-03-25	5001	0	\N	0	0	\N	\N	0	26437	0	8331-1	3006322		
52083	1576	4024958	1972-01-18	1972-01-18 00:00:00	1972-01-18	5001	0	\N	0	0	\N	\N	0	105770	0	117015009	4024958		
109626	3381	4052083	1974-08-23	1974-08-23 00:00:00	1974-08-23	5001	0	\N	0	0	\N	\N	0	224364	0	23426006	4052083		
130638	4024	4133840	2006-05-07	2006-05-07 00:00:00	2006-05-07	5001	0	\N	0	0	\N	\N	0	267565	0	127783003	4133840		
35160	3215	3020655	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	213667	0	6844-5	3020655		
24580	2261	3051031	1965-09-30	1965-09-30 00:00:00	1965-09-30	5001	0	\N	0	0	\N	\N	0	150268	0	46240-8	3051031		
45984	4239	40758406	1949-10-25	1949-10-25 00:00:00	1949-10-25	5001	0	\N	0	0	\N	\N	0	281512	0	55277-8	40758406		
36016	3311	3001488	1990-03-30	1990-03-30 00:00:00	1990-03-30	5001	0	\N	0	0	\N	\N	0	219805	0	7258-7	3001488		
57449	5276	3006322	2010-02-27	2010-02-27 00:00:00	2010-02-27	5001	0	\N	0	0	\N	\N	0	350935	0	8331-1	3006322		
3723	354	3011505	2017-03-09	2017-03-09 00:00:00	2017-03-09	5001	0	\N	0	0	\N	\N	0	23594	0	19926-5	3011505		
142396	4376	4133840	2015-01-20	2015-01-20 00:00:00	2015-01-20	5001	0	\N	0	0	\N	\N	0	290839	0	127783003	4133840		
120632	3721	4052083	1981-05-19	1981-05-19 00:00:00	1981-05-19	5001	0	\N	0	0	\N	\N	0	247333	0	23426006	4052083		
24256	2238	3020655	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	148980	0	6844-5	3020655		
150332	4608	4133840	1999-02-18	1999-02-18 00:00:00	1999-02-18	5001	0	\N	0	0	\N	\N	0	307018	0	127783003	4133840		
52509	4822	46235214	1949-02-20	1949-02-20 00:00:00	1949-02-20	5001	0	\N	0	0	\N	\N	0	320730	0	76690-7	46235214		
92283	2844	4052083	1978-08-03	1978-08-03 00:00:00	1978-08-03	5001	0	\N	0	0	\N	\N	0	188866	0	23426006	4052083		
4527	442	3020655	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	29416	0	6844-5	3020655		
2726	266	3012494	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	17657	0	6206-7	3012494		
1998	181	3006322	1994-07-01	1994-07-01 00:00:00	1994-07-01	5001	0	\N	0	0	\N	\N	0	12204	0	8331-1	3006322		
44247	4078	3012494	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	271017	0	6206-7	3012494		
27455	2542	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	168112	0	6246-3	3021226		
1003	80	3006322	1985-05-27	1985-05-27 00:00:00	1985-05-27	5001	0	\N	0	0	\N	\N	0	5381	0	8331-1	3006322		
9275	877	3012494	1978-06-07	1978-06-07 00:00:00	1978-06-07	5001	0	\N	0	0	\N	\N	0	58348	0	6206-7	3012494		
38797	3583	3006322	1999-03-12	1999-03-12 00:00:00	1999-03-12	5001	0	\N	0	0	\N	\N	0	238271	0	8331-1	3006322		
149333	4580	4052083	1984-06-18	1984-06-18 00:00:00	1984-06-18	5001	0	\N	0	0	\N	\N	0	305114	0	23426006	4052083		
23372	2156	3006322	2005-10-28	2005-10-28 00:00:00	2005-10-28	5001	0	\N	0	0	\N	\N	0	143721	0	8331-1	3006322		
34742	3178	3015632	2014-03-13	2014-03-13 00:00:00	2014-03-13	5001	0	\N	0	0	\N	\N	0	211388	0	2028-9	3015632		
34776	3179	3051031	1920-11-30	1920-11-30 00:00:00	1920-11-30	5001	0	\N	0	0	\N	\N	0	211489	0	46240-8	3051031		
18621	1713	3006322	1994-09-18	1994-09-18 00:00:00	1994-09-18	5001	0	\N	0	0	\N	\N	0	114467	0	8331-1	3006322		
8593	821	3006322	1981-03-01	1981-03-01 00:00:00	1981-03-01	5001	0	\N	0	0	\N	\N	0	54411	0	8331-1	3006322		
28412	2631	3006322	2005-08-27	2005-08-27 00:00:00	2005-08-27	5001	0	\N	0	0	\N	\N	0	174065	0	8331-1	3006322		
152726	4682	4024958	1997-02-25	1997-02-25 00:00:00	1997-02-25	5001	0	\N	0	0	\N	\N	0	312006	0	117015009	4024958		
10449	1015	46235214	2019-02-27	2019-02-27 00:00:00	2019-02-27	5001	0	\N	0	0	\N	\N	0	66811	0	76690-7	46235214		
145992	4480	4024958	1964-03-20	1964-03-20 00:00:00	1964-03-20	5001	0	\N	0	0	\N	\N	0	298151	0	117015009	4024958		
7445	711	3010813	1967-01-29	1967-01-29 00:00:00	1967-01-29	5001	0	\N	0	0	\N	\N	0	47196	0	26464-8	3010813		
247	9	3014599	1979-01-30	1979-01-30 00:00:00	1979-01-30	5001	0	\N	0	0	\N	\N	0	707	0	6106-9	3014599		
20980	1945	3006322	2003-08-21	2003-08-21 00:00:00	2003-08-21	5001	0	\N	0	0	\N	\N	0	129205	0	8331-1	3006322		
54708	5004	3000876	1993-09-14	1993-09-14 00:00:00	1993-09-14	5001	0	\N	0	0	\N	\N	0	332834	0	6082-2	3000876		
19162	1756	3006322	1980-08-03	1980-08-03 00:00:00	1980-08-03	5001	0	\N	0	0	\N	\N	0	117460	0	8331-1	3006322		
54475	4977	3002385	2010-12-07	2010-12-07 00:00:00	2010-12-07	5001	0	\N	0	0	\N	\N	0	331120	0	30385-9	3002385		
1561	137	40769184	2002-06-30	2002-06-30 00:00:00	2002-06-30	5001	0	\N	0	0	\N	\N	0	9230	0	66524-0	40769184		
37406	1158	4024958	2010-06-16	2010-06-16 00:00:00	2010-06-16	5001	0	\N	0	0	\N	\N	0	76491	0	117015009	4024958		
53210	4890	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	325066	0	6082-2	3000876		
650	43	3006322	2018-07-19	2018-07-19 00:00:00	2018-07-19	5001	0	\N	0	0	\N	\N	0	3149	0	8331-1	3006322		
24494	2261	40766240	1965-06-02	1965-06-02 00:00:00	1965-06-02	5001	0	\N	0	0	\N	\N	0	150280	0	63513-6	40766240		
33674	3060	3006322	1995-03-22	1995-03-22 00:00:00	1995-03-22	5001	0	\N	0	0	\N	\N	0	203546	0	8331-1	3006322		
41275	3852	3020655	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	255735	0	6844-5	3020655		
46927	4320	3035995	1970-05-14	1970-05-14 00:00:00	1970-05-14	5001	0	\N	0	0	\N	\N	0	286692	0	6768-6	3035995		
151376	4639	4024958	1971-07-18	1971-07-18 00:00:00	1971-07-18	5001	0	\N	0	0	\N	\N	0	309185	0	117015009	4024958		
4024	403	3006322	1936-08-22	1936-08-22 00:00:00	1936-08-22	5001	0	\N	0	0	\N	\N	0	26532	0	8331-1	3006322		
52194	1578	4024958	1952-01-11	1952-01-11 00:00:00	1952-01-11	5001	0	\N	0	0	\N	\N	0	105975	0	117015009	4024958		
109627	3381	4024958	1979-12-23	1979-12-23 00:00:00	1979-12-23	5001	0	\N	0	0	\N	\N	0	224337	0	117015009	4024958		
130641	4024	4133840	2012-05-13	2012-05-13 00:00:00	2012-05-13	5001	0	\N	0	0	\N	\N	0	267567	0	127783003	4133840		
35161	3215	3006734	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	213667	0	6189-5	3006734		
24581	2261	40758406	1965-09-30	1965-09-30 00:00:00	1965-09-30	5001	0	\N	0	0	\N	\N	0	150268	0	55277-8	40758406		
45986	4239	40766240	1949-10-25	1949-10-25 00:00:00	1949-10-25	5001	0	\N	0	0	\N	\N	0	281512	0	63513-6	40766240		
36017	3311	3036780	1990-03-30	1990-03-30 00:00:00	1990-03-30	5001	0	\N	0	0	\N	\N	0	219805	0	6095-4	3036780		
57450	5277	3006322	2004-03-07	2004-03-07 00:00:00	2004-03-07	5001	0	\N	0	0	\N	\N	0	350963	0	8331-1	3006322		
3724	354	3011505	1998-01-15	1998-01-15 00:00:00	1998-01-15	5001	0	\N	0	0	\N	\N	0	23566	0	19926-5	3011505		
142399	4376	4133840	1999-10-26	1999-10-26 00:00:00	1999-10-26	5001	0	\N	0	0	\N	\N	0	290779	0	127783003	4133840		
30050	2767	40766240	2015-04-19	2015-04-19 00:00:00	2015-04-19	5001	0	\N	0	0	\N	\N	0	183031	0	63513-6	40766240		
24257	2238	3000876	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	148980	0	6082-2	3000876		
150333	4608	4133840	2013-01-31	2013-01-31 00:00:00	2013-01-31	5001	0	\N	0	0	\N	\N	0	307021	0	127783003	4133840		
52511	4822	40766240	1949-02-20	1949-02-20 00:00:00	1949-02-20	5001	0	\N	0	0	\N	\N	0	320730	0	63513-6	40766240		
92297	2845	4024958	1982-03-12	1982-03-12 00:00:00	1982-03-12	5001	0	\N	0	0	\N	\N	0	188901	0	117015009	4024958		
4528	442	3019406	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	29416	0	6158-0	3019406		
2727	266	3006451	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	17657	0	6273-7	3006451		
1999	181	3006322	2008-05-11	2008-05-11 00:00:00	2008-05-11	5001	0	\N	0	0	\N	\N	0	12238	0	8331-1	3006322		
44248	4078	3020655	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	271017	0	6844-5	3020655		
27456	2542	40769184	1986-06-07	1986-06-07 00:00:00	1986-06-07	5001	0	\N	0	0	\N	\N	0	168107	0	66524-0	40769184		
1004	80	3006322	1947-12-16	1947-12-16 00:00:00	1947-12-16	5001	0	\N	0	0	\N	\N	0	5437	0	8331-1	3006322		
9276	877	3023430	1978-06-07	1978-06-07 00:00:00	1978-06-07	5001	0	\N	0	0	\N	\N	0	58348	0	6833-8	3023430		
38902	3595	3051031	1990-07-03	1990-07-03 00:00:00	1990-07-03	5001	0	\N	0	0	\N	\N	0	238788	0	46240-8	3051031		
138079	4255	4024958	1984-02-03	1984-02-03 00:00:00	1984-02-03	5001	0	\N	0	0	\N	\N	0	282539	0	117015009	4024958		
23373	2156	3006322	2016-01-25	2016-01-25 00:00:00	2016-01-25	5001	0	\N	0	0	\N	\N	0	143699	0	8331-1	3006322		
34743	3178	3013682	2014-03-13	2014-03-13 00:00:00	2014-03-13	5001	0	\N	0	0	\N	\N	0	211388	0	3094-0	3013682		
34777	3179	46235214	1920-11-30	1920-11-30 00:00:00	1920-11-30	5001	0	\N	0	0	\N	\N	0	211489	0	76690-7	46235214		
18622	1713	3006322	1999-07-09	1999-07-09 00:00:00	1999-07-09	5001	0	\N	0	0	\N	\N	0	114479	0	8331-1	3006322		
8594	821	3006322	2003-09-18	2003-09-18 00:00:00	2003-09-18	5001	0	\N	0	0	\N	\N	0	54401	0	8331-1	3006322		
28425	2633	3006322	1999-10-27	1999-10-27 00:00:00	1999-10-27	5001	0	\N	0	0	\N	\N	0	174221	0	8331-1	3006322		
152731	4682	4052083	2005-04-02	2005-04-02 00:00:00	2005-04-02	5001	0	\N	0	0	\N	\N	0	312035	0	23426006	4052083		
10450	1015	40766240	2019-02-27	2019-02-27 00:00:00	2019-02-27	5001	0	\N	0	0	\N	\N	0	66811	0	63513-6	40766240		
145996	4480	4024958	1964-10-01	1964-10-01 00:00:00	1964-10-01	5001	0	\N	0	0	\N	\N	0	298140	0	117015009	4024958		
7446	711	3006923	1967-01-29	1967-01-29 00:00:00	1967-01-29	5001	0	\N	0	0	\N	\N	0	47196	0	1742-6	3006923		
248	9	3021226	1979-01-30	1979-01-30 00:00:00	1979-01-30	5001	0	\N	0	0	\N	\N	0	707	0	6246-3	3021226		
20981	1945	3006322	2007-06-09	2007-06-09 00:00:00	2007-06-09	5001	0	\N	0	0	\N	\N	0	129207	0	8331-1	3006322		
54709	5004	3023430	1993-09-14	1993-09-14 00:00:00	1993-09-14	5001	0	\N	0	0	\N	\N	0	332834	0	6833-8	3023430		
19163	1756	3006322	1977-05-13	1977-05-13 00:00:00	1977-05-13	5001	0	\N	0	0	\N	\N	0	117424	0	8331-1	3006322		
54476	4977	3024561	2010-12-07	2010-12-07 00:00:00	2010-12-07	5001	0	\N	0	0	\N	\N	0	331120	0	1751-7	3024561		
1562	137	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	9127	0	6273-7	3006451		
12896	1227	40758406	1938-11-23	1938-11-23 00:00:00	1938-11-23	5001	0	\N	0	0	\N	\N	0	80723	0	55277-8	40758406		
53211	4890	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	325066	0	6206-7	3012494		
651	43	3006322	1996-07-14	1996-07-14 00:00:00	1996-07-14	5001	0	\N	0	0	\N	\N	0	3173	0	8331-1	3006322		
24495	2261	40758406	1965-06-02	1965-06-02 00:00:00	1965-06-02	5001	0	\N	0	0	\N	\N	0	150280	0	55277-8	40758406		
33675	3060	3006322	1985-07-01	1985-07-01 00:00:00	1985-07-01	5001	0	\N	0	0	\N	\N	0	203612	0	8331-1	3006322		
41276	3852	3023430	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	255735	0	6833-8	3023430		
46928	4320	3010813	1970-05-14	1970-05-14 00:00:00	1970-05-14	5001	0	\N	0	0	\N	\N	0	286692	0	26464-8	3010813		
151385	4639	4052083	2004-10-09	2004-10-09 00:00:00	2004-10-09	5001	0	\N	0	0	\N	\N	0	309201	0	23426006	4052083		
4025	403	3006322	1974-09-12	1974-09-12 00:00:00	1974-09-12	5001	0	\N	0	0	\N	\N	0	26534	0	8331-1	3006322		
52198	1578	4024958	1972-03-04	1972-03-04 00:00:00	1972-03-04	5001	0	\N	0	0	\N	\N	0	105977	0	117015009	4024958		
109628	3381	4024958	1972-12-13	1972-12-13 00:00:00	1972-12-13	5001	0	\N	0	0	\N	\N	0	224382	0	117015009	4024958		
130645	4024	4133840	2009-05-10	2009-05-10 00:00:00	2009-05-10	5001	0	\N	0	0	\N	\N	0	267566	0	127783003	4133840		
35162	3215	3036780	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	213667	0	6095-4	3036780		
24582	2261	40766240	1965-09-30	1965-09-30 00:00:00	1965-09-30	5001	0	\N	0	0	\N	\N	0	150268	0	63513-6	40766240		
45987	4239	3051031	1949-10-25	1949-10-25 00:00:00	1949-10-25	5001	0	\N	0	0	\N	\N	0	281512	0	46240-8	3051031		
36018	3311	3006734	1990-03-30	1990-03-30 00:00:00	1990-03-30	5001	0	\N	0	0	\N	\N	0	219805	0	6189-5	3006734		
57451	5277	3006322	2004-10-13	2004-10-13 00:00:00	2004-10-13	5001	0	\N	0	0	\N	\N	0	351005	0	8331-1	3006322		
3725	354	3011505	2000-01-20	2000-01-20 00:00:00	2000-01-20	5001	0	\N	0	0	\N	\N	0	23575	0	19926-5	3011505		
142403	4376	4024958	1925-06-08	1925-06-08 00:00:00	1925-06-08	5001	0	\N	0	0	\N	\N	0	290760	0	117015009	4024958		
30051	2767	46235214	2015-04-19	2015-04-19 00:00:00	2015-04-19	5001	0	\N	0	0	\N	\N	0	183031	0	76690-7	46235214		
24258	2238	3006322	1997-02-16	1997-02-16 00:00:00	1997-02-16	5001	0	\N	0	0	\N	\N	0	149016	0	8331-1	3006322		
150336	4608	4133840	2015-02-12	2015-02-12 00:00:00	2015-02-12	5001	0	\N	0	0	\N	\N	0	307061	0	127783003	4133840		
52512	4822	46235214	1971-04-06	1971-04-06 00:00:00	1971-04-06	5001	0	\N	0	0	\N	\N	0	320745	0	76690-7	46235214		
92305	2845	4052083	1965-08-11	1965-08-11 00:00:00	1965-08-11	5001	0	\N	0	0	\N	\N	0	188900	0	23426006	4052083		
4529	442	3005136	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	29416	0	6075-6	3005136		
2728	266	3023430	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	17657	0	6833-8	3023430		
2000	181	3006322	2006-10-08	2006-10-08 00:00:00	2006-10-08	5001	0	\N	0	0	\N	\N	0	12205	0	8331-1	3006322		
44249	4078	3023430	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	271017	0	6833-8	3023430		
27457	2542	40769189	1986-06-07	1986-06-07 00:00:00	1986-06-07	5001	0	\N	0	0	\N	\N	0	168107	0	66529-9	40769189		
1005	80	3006322	1950-03-20	1950-03-20 00:00:00	1950-03-20	5001	0	\N	0	0	\N	\N	0	5462	0	8331-1	3006322		
9277	877	3000876	1978-06-07	1978-06-07 00:00:00	1978-06-07	5001	0	\N	0	0	\N	\N	0	58348	0	6082-2	3000876		
38903	3595	40758406	1990-07-03	1990-07-03 00:00:00	1990-07-03	5001	0	\N	0	0	\N	\N	0	238788	0	55277-8	40758406		
138081	4255	4052083	1990-09-07	1990-09-07 00:00:00	1990-09-07	5001	0	\N	0	0	\N	\N	0	282490	0	23426006	4052083		
23374	2156	3006322	2011-08-08	2011-08-08 00:00:00	2011-08-08	5001	0	\N	0	0	\N	\N	0	143703	0	8331-1	3006322		
34744	3178	3020630	2014-03-13	2014-03-13 00:00:00	2014-03-13	5001	0	\N	0	0	\N	\N	0	211388	0	2885-2	3020630		
34778	3179	40766240	1920-11-30	1920-11-30 00:00:00	1920-11-30	5001	0	\N	0	0	\N	\N	0	211489	0	63513-6	40766240		
146578	4498	4052083	1979-12-12	1979-12-12 00:00:00	1979-12-12	5001	0	\N	0	0	\N	\N	0	299469	0	23426006	4052083		
8595	821	3006322	1978-04-04	1978-04-04 00:00:00	1978-04-04	5001	0	\N	0	0	\N	\N	0	54381	0	8331-1	3006322		
28426	2633	3006322	1970-05-06	1970-05-06 00:00:00	1970-05-06	5001	0	\N	0	0	\N	\N	0	174231	0	8331-1	3006322		
20316	1864	3011505	2011-12-23	2011-12-23 00:00:00	2011-12-23	5001	0	\N	0	0	\N	\N	0	124551	0	19926-5	3011505		
10451	1015	40758406	2018-06-02	2018-06-02 00:00:00	2018-06-02	5001	0	\N	0	0	\N	\N	0	66809	0	55277-8	40758406		
146007	4480	4052083	2016-09-19	2016-09-19 00:00:00	2016-09-19	5001	0	\N	0	0	\N	\N	0	298126	0	23426006	4052083		
7447	711	3006906	1967-01-29	1967-01-29 00:00:00	1967-01-29	5001	0	\N	0	0	\N	\N	0	47196	0	17861-6	3006906		
249	9	3027231	1979-01-30	1979-01-30 00:00:00	1979-01-30	5001	0	\N	0	0	\N	\N	0	707	0	6276-0	3027231		
20982	1945	3006322	2007-10-22	2007-10-22 00:00:00	2007-10-22	5001	0	\N	0	0	\N	\N	0	129208	0	8331-1	3006322		
54710	5004	3036780	1993-09-14	1993-09-14 00:00:00	1993-09-14	5001	0	\N	0	0	\N	\N	0	332834	0	6095-4	3036780		
19166	1758	3006322	1975-07-12	1975-07-12 00:00:00	1975-07-12	5001	0	\N	0	0	\N	\N	0	117503	0	8331-1	3006322		
54477	4977	3027970	2010-12-07	2010-12-07 00:00:00	2010-12-07	5001	0	\N	0	0	\N	\N	0	331120	0	10834-0	3027970		
1563	137	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	9127	0	6206-7	3012494		
12897	1227	40766240	1938-11-23	1938-11-23 00:00:00	1938-11-23	5001	0	\N	0	0	\N	\N	0	80723	0	63513-6	40766240		
53212	4890	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	325066	0	6085-5	3001247		
652	43	3006322	1959-08-08	1959-08-08 00:00:00	1959-08-08	5001	0	\N	0	0	\N	\N	0	3183	0	8331-1	3006322		
24497	2261	3051031	1965-06-02	1965-06-02 00:00:00	1965-06-02	5001	0	\N	0	0	\N	\N	0	150280	0	46240-8	3051031		
33676	3060	3049273	1994-08-26	1994-08-26 00:00:00	1994-08-26	5001	0	\N	0	0	\N	\N	0	203627	0	38265-5	3049273		
41277	3852	3006734	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	255735	0	6189-5	3006734		
46929	4320	3026361	1970-05-14	1970-05-14 00:00:00	1970-05-14	5001	0	\N	0	0	\N	\N	0	286692	0	26453-1	3026361		
151387	4639	4024958	1982-04-02	1982-04-02 00:00:00	1982-04-02	5001	0	\N	0	0	\N	\N	0	309192	0	117015009	4024958		
4026	403	3006322	1932-12-16	1932-12-16 00:00:00	1932-12-16	5001	0	\N	0	0	\N	\N	0	26431	0	8331-1	3006322		
52224	1579	4024958	1973-11-03	1973-11-03 00:00:00	1973-11-03	5001	0	\N	0	0	\N	\N	0	106054	0	117015009	4024958		
109644	3382	4024958	1990-01-19	1990-01-19 00:00:00	1990-01-19	5001	0	\N	0	0	\N	\N	0	224415	0	117015009	4024958		
21852	687	4052083	1981-03-18	1981-03-18 00:00:00	1981-03-18	5001	0	\N	0	0	\N	\N	0	45575	0	23426006	4052083		
35163	3215	3000876	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	213667	0	6082-2	3000876		
24583	2261	40758406	1966-08-26	1966-08-26 00:00:00	1966-08-26	5001	0	\N	0	0	\N	\N	0	150284	0	55277-8	40758406		
45988	4239	46235214	1949-10-25	1949-10-25 00:00:00	1949-10-25	5001	0	\N	0	0	\N	\N	0	281512	0	76690-7	46235214		
36019	3311	3023430	1990-03-30	1990-03-30 00:00:00	1990-03-30	5001	0	\N	0	0	\N	\N	0	219805	0	6833-8	3023430		
57452	5277	3006322	1968-09-26	1968-09-26 00:00:00	1968-09-26	5001	0	\N	0	0	\N	\N	0	351041	0	8331-1	3006322		
3726	354	3011505	2006-01-05	2006-01-05 00:00:00	2006-01-05	5001	0	\N	0	0	\N	\N	0	23588	0	19926-5	3011505		
142404	4376	4133840	1979-07-03	1979-07-03 00:00:00	1979-07-03	5001	0	\N	0	0	\N	\N	0	290719	0	127783003	4133840		
30052	2767	3027970	1939-05-23	1939-05-23 00:00:00	1939-05-23	5001	0	\N	0	0	\N	\N	0	183063	0	10834-0	3027970		
24259	2238	3006322	1993-01-28	1993-01-28 00:00:00	1993-01-28	5001	0	\N	0	0	\N	\N	0	148921	0	8331-1	3006322		
150341	4608	4133840	2019-03-07	2019-03-07 00:00:00	2019-03-07	5001	0	\N	0	0	\N	\N	0	306946	0	127783003	4133840		
52514	4822	40766240	1971-04-06	1971-04-06 00:00:00	1971-04-06	5001	0	\N	0	0	\N	\N	0	320745	0	63513-6	40766240		
92311	2845	4052083	2014-02-10	2014-02-10 00:00:00	2014-02-10	5001	0	\N	0	0	\N	\N	0	188940	0	23426006	4052083		
4530	442	3012494	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	29416	0	6206-7	3012494		
2729	266	3006734	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	17657	0	6189-5	3006734		
2001	182	3006322	2019-02-04	2019-02-04 00:00:00	2019-02-04	5001	0	\N	0	0	\N	\N	0	12253	0	8331-1	3006322		
44250	4078	3001247	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	271017	0	6085-5	3001247		
27458	2542	40769194	1986-06-07	1986-06-07 00:00:00	1986-06-07	5001	0	\N	0	0	\N	\N	0	168107	0	66534-9	40769194		
1006	81	3006322	1993-07-18	1993-07-18 00:00:00	1993-07-18	5001	0	\N	0	0	\N	\N	0	5483	0	8331-1	3006322		
9278	877	3027231	1978-06-07	1978-06-07 00:00:00	1978-06-07	5001	0	\N	0	0	\N	\N	0	58348	0	6276-0	3027231		
38904	3595	3006322	2017-07-03	2017-07-03 00:00:00	2017-07-03	5001	0	\N	0	0	\N	\N	0	238850	0	8331-1	3006322		
138103	4256	4024958	1961-11-01	1961-11-01 00:00:00	1961-11-01	5001	0	\N	0	0	\N	\N	0	282608	0	117015009	4024958		
159445	4899	4133840	1981-08-04	1981-08-04 00:00:00	1981-08-04	5001	0	\N	0	0	\N	\N	0	325829	0	127783003	4133840		
34745	3178	3007461	2014-03-13	2014-03-13 00:00:00	2014-03-13	5001	0	\N	0	0	\N	\N	0	211388	0	26515-7	3007461		
34780	3179	40758406	1920-11-30	1920-11-30 00:00:00	1920-11-30	5001	0	\N	0	0	\N	\N	0	211489	0	55277-8	40758406		
146600	4498	4024958	2015-03-25	2015-03-25 00:00:00	2015-03-25	5001	0	\N	0	0	\N	\N	0	299486	0	117015009	4024958		
8596	821	3006322	1956-11-30	1956-11-30 00:00:00	1956-11-30	5001	0	\N	0	0	\N	\N	0	54379	0	8331-1	3006322		
28427	2633	3006322	1957-08-28	1957-08-28 00:00:00	1957-08-28	5001	0	\N	0	0	\N	\N	0	174193	0	8331-1	3006322		
20317	1864	3011505	2009-12-18	2009-12-18 00:00:00	2009-12-18	5001	0	\N	0	0	\N	\N	0	124529	0	19926-5	3011505		
10453	1015	3051031	2018-06-02	2018-06-02 00:00:00	2018-06-02	5001	0	\N	0	0	\N	\N	0	66809	0	46240-8	3051031		
146010	4480	4024958	1969-02-28	1969-02-28 00:00:00	1969-02-28	5001	0	\N	0	0	\N	\N	0	298135	0	117015009	4024958		
7448	711	3023103	1967-01-29	1967-01-29 00:00:00	1967-01-29	5001	0	\N	0	0	\N	\N	0	47196	0	2823-3	3023103		
250	9	3006451	1979-01-30	1979-01-30 00:00:00	1979-01-30	5001	0	\N	0	0	\N	\N	0	707	0	6273-7	3006451		
20983	1945	3006322	1976-07-01	1976-07-01 00:00:00	1976-07-01	5001	0	\N	0	0	\N	\N	0	129199	0	8331-1	3006322		
54711	5004	3006451	1993-09-14	1993-09-14 00:00:00	1993-09-14	5001	0	\N	0	0	\N	\N	0	332834	0	6273-7	3006451		
19167	1758	3006322	1973-11-12	1973-11-12 00:00:00	1973-11-12	5001	0	\N	0	0	\N	\N	0	117543	0	8331-1	3006322		
54478	4977	3009542	2010-12-07	2010-12-07 00:00:00	2010-12-07	5001	0	\N	0	0	\N	\N	0	331120	0	20570-8	3009542		
1564	137	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	9127	0	6833-8	3023430		
12898	1227	3051031	1938-11-23	1938-11-23 00:00:00	1938-11-23	5001	0	\N	0	0	\N	\N	0	80723	0	46240-8	3051031		
53213	4890	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	325066	0	6833-8	3023430		
653	43	3006322	1961-02-11	1961-02-11 00:00:00	1961-02-11	5001	0	\N	0	0	\N	\N	0	3190	0	8331-1	3006322		
83585	2583	4024958	1973-12-10	1973-12-10 00:00:00	1973-12-10	5001	0	\N	0	0	\N	\N	0	171057	0	117015009	4024958		
33677	3060	3006322	1952-11-14	1952-11-14 00:00:00	1952-11-14	5001	0	\N	0	0	\N	\N	0	203606	0	8331-1	3006322		
41278	3852	3036780	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	255735	0	6095-4	3036780		
46930	4320	3002385	1970-05-14	1970-05-14 00:00:00	1970-05-14	5001	0	\N	0	0	\N	\N	0	286692	0	30385-9	3002385		
100381	3081	4024958	1984-09-07	1984-09-07 00:00:00	1984-09-07	5001	0	\N	0	0	\N	\N	0	205100	0	117015009	4024958		
4027	403	3006322	1983-01-31	1983-01-31 00:00:00	1983-01-31	5001	0	\N	0	0	\N	\N	0	26436	0	8331-1	3006322		
52227	1579	4052083	2000-11-30	2000-11-30 00:00:00	2000-11-30	5001	0	\N	0	0	\N	\N	0	106092	0	23426006	4052083		
109645	3382	4024958	1979-04-08	1979-04-08 00:00:00	1979-04-08	5001	0	\N	0	0	\N	\N	0	224414	0	117015009	4024958		
21866	687	4024958	1975-11-18	1975-11-18 00:00:00	1975-11-18	5001	0	\N	0	0	\N	\N	0	45573	0	117015009	4024958		
35164	3215	3001247	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	213667	0	6085-5	3001247		
24584	2261	46235214	1966-08-26	1966-08-26 00:00:00	1966-08-26	5001	0	\N	0	0	\N	\N	0	150284	0	76690-7	46235214		
45989	4239	3006322	1972-01-21	1972-01-21 00:00:00	1972-01-21	5001	0	\N	0	0	\N	\N	0	281520	0	8331-1	3006322		
36020	3311	3000876	1990-03-30	1990-03-30 00:00:00	1990-03-30	5001	0	\N	0	0	\N	\N	0	219805	0	6082-2	3000876		
57453	5278	3049273	1971-06-28	1971-06-28 00:00:00	1971-06-28	5001	0	\N	0	0	\N	\N	0	351125	0	38265-5	3049273		
3727	354	3011505	2013-02-14	2013-02-14 00:00:00	2013-02-14	5001	0	\N	0	0	\N	\N	0	23592	0	19926-5	3011505		
142409	4376	4133840	2010-12-28	2010-12-28 00:00:00	2010-12-28	5001	0	\N	0	0	\N	\N	0	290781	0	127783003	4133840		
30053	2767	3024561	1939-05-23	1939-05-23 00:00:00	1939-05-23	5001	0	\N	0	0	\N	\N	0	183063	0	1751-7	3024561		
24260	2238	3027231	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	148967	0	6276-0	3027231		
150348	4608	4052083	1962-11-18	1962-11-18 00:00:00	1962-11-18	5001	0	\N	0	0	\N	\N	0	306990	0	23426006	4052083		
52516	4822	40758406	1971-04-06	1971-04-06 00:00:00	1971-04-06	5001	0	\N	0	0	\N	\N	0	320745	0	55277-8	40758406		
113534	3505	4052083	1946-02-20	1946-02-20 00:00:00	1946-02-20	5001	0	\N	0	0	\N	\N	0	232394	0	23426006	4052083		
4531	442	3000876	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	29416	0	6082-2	3000876		
2730	266	3005136	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	17657	0	6075-6	3005136		
2002	182	3006322	2003-12-14	2003-12-14 00:00:00	2003-12-14	5001	0	\N	0	0	\N	\N	0	12319	0	8331-1	3006322		
44251	4078	3006734	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	271017	0	6189-5	3006734		
27459	2542	40769179	1986-06-07	1986-06-07 00:00:00	1986-06-07	5001	0	\N	0	0	\N	\N	0	168107	0	66519-0	40769179		
1007	81	3006322	1963-09-14	1963-09-14 00:00:00	1963-09-14	5001	0	\N	0	0	\N	\N	0	5529	0	8331-1	3006322		
9279	877	3021226	1978-06-07	1978-06-07 00:00:00	1978-06-07	5001	0	\N	0	0	\N	\N	0	58348	0	6246-3	3021226		
38905	3595	46235214	1990-12-30	1990-12-30 00:00:00	1990-12-30	5001	0	\N	0	0	\N	\N	0	238789	0	76690-7	46235214		
138109	4256	4052083	1958-03-09	1958-03-09 00:00:00	1958-03-09	5001	0	\N	0	0	\N	\N	0	282580	0	23426006	4052083		
159446	4899	4133840	1992-10-06	1992-10-06 00:00:00	1992-10-06	5001	0	\N	0	0	\N	\N	0	325860	0	127783003	4133840		
34746	3178	3045716	2014-03-13	2014-03-13 00:00:00	2014-03-13	5001	0	\N	0	0	\N	\N	0	211388	0	33037-3	3045716		
34782	3179	3006322	1933-11-15	1933-11-15 00:00:00	1933-11-15	5001	0	\N	0	0	\N	\N	0	211512	0	8331-1	3006322		
51410	1558	4024958	2000-12-04	2000-12-04 00:00:00	2000-12-04	5001	0	\N	0	0	\N	\N	0	104373	0	117015009	4024958		
8597	821	3006322	1968-12-07	1968-12-07 00:00:00	1968-12-07	5001	0	\N	0	0	\N	\N	0	54429	0	8331-1	3006322		
28428	2633	3006322	2002-09-27	2002-09-27 00:00:00	2002-09-27	5001	0	\N	0	0	\N	\N	0	174200	0	8331-1	3006322		
20318	1864	3011505	2013-12-27	2013-12-27 00:00:00	2013-12-27	5001	0	\N	0	0	\N	\N	0	124544	0	19926-5	3011505		
10455	1015	46235214	2018-06-02	2018-06-02 00:00:00	2018-06-02	5001	0	\N	0	0	\N	\N	0	66809	0	76690-7	46235214		
101718	3125	4052083	1972-04-19	1972-04-19 00:00:00	1972-04-19	5001	0	\N	0	0	\N	\N	0	207946	0	23426006	4052083		
7449	711	3045716	1967-01-29	1967-01-29 00:00:00	1967-01-29	5001	0	\N	0	0	\N	\N	0	47196	0	33037-3	3045716		
251	9	3005136	1979-01-30	1979-01-30 00:00:00	1979-01-30	5001	0	\N	0	0	\N	\N	0	707	0	6075-6	3005136		
20984	1946	3006322	1977-09-20	1977-09-20 00:00:00	1977-09-20	5001	0	\N	0	0	\N	\N	0	129279	0	8331-1	3006322		
54712	5004	3014599	1993-09-14	1993-09-14 00:00:00	1993-09-14	5001	0	\N	0	0	\N	\N	0	332834	0	6106-9	3014599		
19168	1758	3006322	1974-03-24	1974-03-24 00:00:00	1974-03-24	5001	0	\N	0	0	\N	\N	0	117544	0	8331-1	3006322		
54479	4977	3013721	2010-12-07	2010-12-07 00:00:00	2010-12-07	5001	0	\N	0	0	\N	\N	0	331120	0	1920-8	3013721		
1565	137	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	9127	0	6189-5	3006734		
12899	1227	3006322	2018-02-04	2018-02-04 00:00:00	2018-02-04	5001	0	\N	0	0	\N	\N	0	80855	0	8331-1	3006322		
53214	4890	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	325066	0	6189-5	3006734		
654	43	3006322	1993-05-16	1993-05-16 00:00:00	1993-05-16	5001	0	\N	0	0	\N	\N	0	3146	0	8331-1	3006322		
83587	2583	4052083	2018-10-25	2018-10-25 00:00:00	2018-10-25	5001	0	\N	0	0	\N	\N	0	171021	0	23426006	4052083		
33678	3060	3006322	1999-12-07	1999-12-07 00:00:00	1999-12-07	5001	0	\N	0	0	\N	\N	0	203641	0	8331-1	3006322		
41279	3852	3001247	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	255735	0	6085-5	3001247		
46931	4320	3013682	1970-05-14	1970-05-14 00:00:00	1970-05-14	5001	0	\N	0	0	\N	\N	0	286692	0	3094-0	3013682		
100389	3081	4024958	1970-09-15	1970-09-15 00:00:00	1970-09-15	5001	0	\N	0	0	\N	\N	0	205158	0	117015009	4024958		
4028	403	3006322	2016-08-15	2016-08-15 00:00:00	2016-08-15	5001	0	\N	0	0	\N	\N	0	26495	0	8331-1	3006322		
52229	1579	4024958	1968-08-20	1968-08-20 00:00:00	1968-08-20	5001	0	\N	0	0	\N	\N	0	106082	0	117015009	4024958		
109647	3382	4024958	1967-06-20	1967-06-20 00:00:00	1967-06-20	5001	0	\N	0	0	\N	\N	0	224462	0	117015009	4024958		
21868	687	4052083	1983-12-21	1983-12-21 00:00:00	1983-12-21	5001	0	\N	0	0	\N	\N	0	45530	0	23426006	4052083		
35165	3215	3023430	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	213667	0	6833-8	3023430		
24585	2261	3051031	1966-08-26	1966-08-26 00:00:00	1966-08-26	5001	0	\N	0	0	\N	\N	0	150284	0	46240-8	3051031		
45990	4239	3006322	2016-10-09	2016-10-09 00:00:00	2016-10-09	5001	0	\N	0	0	\N	\N	0	281558	0	8331-1	3006322		
36021	3311	40769179	1990-03-21	1990-03-21 00:00:00	1990-03-21	5001	0	\N	0	0	\N	\N	0	219862	0	66519-0	40769179		
57454	5278	3006322	2006-01-24	2006-01-24 00:00:00	2006-01-24	5001	0	\N	0	0	\N	\N	0	351097	0	8331-1	3006322		
3728	354	3011505	2014-02-20	2014-02-20 00:00:00	2014-02-20	5001	0	\N	0	0	\N	\N	0	23568	0	19926-5	3011505		
142410	4376	4133840	1994-09-27	1994-09-27 00:00:00	1994-09-27	5001	0	\N	0	0	\N	\N	0	290704	0	127783003	4133840		
30054	2767	3024731	1939-05-23	1939-05-23 00:00:00	1939-05-23	5001	0	\N	0	0	\N	\N	0	183063	0	30428-7	3024731		
24261	2238	3006451	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	148967	0	6273-7	3006451		
150349	4608	4024958	1976-06-11	1976-06-11 00:00:00	1976-06-11	5001	0	\N	0	0	\N	\N	0	306934	0	117015009	4024958		
52517	4822	3051031	1971-04-06	1971-04-06 00:00:00	1971-04-06	5001	0	\N	0	0	\N	\N	0	320745	0	46240-8	3051031		
113582	3508	4052083	2013-03-10	2013-03-10 00:00:00	2013-03-10	5001	0	\N	0	0	\N	\N	0	232627	0	23426006	4052083		
4532	442	3036780	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	29416	0	6095-4	3036780		
2731	266	3014599	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	17657	0	6106-9	3014599		
2003	182	3006322	1988-02-24	1988-02-24 00:00:00	1988-02-24	5001	0	\N	0	0	\N	\N	0	12278	0	8331-1	3006322		
44252	4078	3000876	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	271017	0	6082-2	3000876		
27460	2542	3006322	1986-02-26	1986-02-26 00:00:00	1986-02-26	5001	0	\N	0	0	\N	\N	0	168167	0	8331-1	3006322		
1008	81	3006322	2005-08-09	2005-08-09 00:00:00	2005-08-09	5001	0	\N	0	0	\N	\N	0	5489	0	8331-1	3006322		
9280	877	3006451	1978-06-07	1978-06-07 00:00:00	1978-06-07	5001	0	\N	0	0	\N	\N	0	58348	0	6273-7	3006451		
38908	3595	40758406	1990-12-30	1990-12-30 00:00:00	1990-12-30	5001	0	\N	0	0	\N	\N	0	238789	0	55277-8	40758406		
138114	4256	4052083	1985-11-21	1985-11-21 00:00:00	1985-11-21	5001	0	\N	0	0	\N	\N	0	282584	0	23426006	4052083		
159450	4899	4133840	1995-10-24	1995-10-24 00:00:00	1995-10-24	5001	0	\N	0	0	\N	\N	0	325832	0	127783003	4133840		
34747	3178	3023103	2014-03-13	2014-03-13 00:00:00	2014-03-13	5001	0	\N	0	0	\N	\N	0	211388	0	2823-3	3023103		
34786	3181	3011505	2009-09-25	2009-09-25 00:00:00	2009-09-25	5001	0	\N	0	0	\N	\N	0	211710	0	19926-5	3011505		
51433	1560	4024958	1936-02-12	1936-02-12 00:00:00	1936-02-12	5001	0	\N	0	0	\N	\N	0	104436	0	117015009	4024958		
8598	822	3006322	2007-01-21	2007-01-21 00:00:00	2007-01-21	5001	0	\N	0	0	\N	\N	0	54461	0	8331-1	3006322		
28429	2633	3006322	1991-08-27	1991-08-27 00:00:00	1991-08-27	5001	0	\N	0	0	\N	\N	0	174197	0	8331-1	3006322		
20319	1864	3011505	2018-12-21	2018-12-21 00:00:00	2018-12-21	5001	0	\N	0	0	\N	\N	0	124531	0	19926-5	3011505		
10456	1015	3006322	1982-08-12	1982-08-12 00:00:00	1982-08-12	5001	0	\N	0	0	\N	\N	0	66818	0	8331-1	3006322		
101719	3125	4052083	1979-06-22	1979-06-22 00:00:00	1979-06-22	5001	0	\N	0	0	\N	\N	0	207937	0	23426006	4052083		
7450	711	3004501	1967-01-29	1967-01-29 00:00:00	1967-01-29	5001	0	\N	0	0	\N	\N	0	47196	0	2345-7	3004501		
252	9	3015076	1979-01-30	1979-01-30 00:00:00	1979-01-30	5001	0	\N	0	0	\N	\N	0	707	0	6248-9	3015076		
20985	1946	3006322	1974-07-23	1974-07-23 00:00:00	1974-07-23	5001	0	\N	0	0	\N	\N	0	129260	0	8331-1	3006322		
54713	5004	3027231	1990-03-13	1990-03-13 00:00:00	1990-03-13	5001	0	\N	0	0	\N	\N	0	332871	0	6276-0	3027231		
19169	1758	3006322	1974-11-02	1974-11-02 00:00:00	1974-11-02	5001	0	\N	0	0	\N	\N	0	117504	0	8331-1	3006322		
54480	4977	3024731	2010-12-07	2010-12-07 00:00:00	2010-12-07	5001	0	\N	0	0	\N	\N	0	331120	0	30428-7	3024731		
1566	137	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	9127	0	6095-4	3036780		
12901	1227	40766240	1958-04-17	1958-04-17 00:00:00	1958-04-17	5001	0	\N	0	0	\N	\N	0	80748	0	63513-6	40766240		
53215	4890	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	325066	0	6095-4	3036780		
655	43	3006322	2018-11-30	2018-11-30 00:00:00	2018-11-30	5001	0	\N	0	0	\N	\N	0	3175	0	8331-1	3006322		
83593	2583	4052083	1985-10-26	1985-10-26 00:00:00	1985-10-26	5001	0	\N	0	0	\N	\N	0	171019	0	23426006	4052083		
33679	3060	3049273	1998-06-06	1998-06-06 00:00:00	1998-06-06	5001	0	\N	0	0	\N	\N	0	203628	0	38265-5	3049273		
41280	3852	3015076	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	255735	0	6248-9	3015076		
46932	4320	3020630	1970-05-14	1970-05-14 00:00:00	1970-05-14	5001	0	\N	0	0	\N	\N	0	286692	0	2885-2	3020630		
100400	3081	4052083	1969-09-20	1969-09-20 00:00:00	1969-09-20	5001	0	\N	0	0	\N	\N	0	205157	0	23426006	4052083		
4029	403	3006322	1934-03-27	1934-03-27 00:00:00	1934-03-27	5001	0	\N	0	0	\N	\N	0	26432	0	8331-1	3006322		
52236	1579	4024958	1989-03-10	1989-03-10 00:00:00	1989-03-10	5001	0	\N	0	0	\N	\N	0	106089	0	117015009	4024958		
109649	3382	4024958	2013-05-02	2013-05-02 00:00:00	2013-05-02	5001	0	\N	0	0	\N	\N	0	224446	0	117015009	4024958		
21889	689	4024958	2009-04-29	2009-04-29 00:00:00	2009-04-29	5001	0	\N	0	0	\N	\N	0	45614	0	117015009	4024958		
35166	3215	3006451	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	213667	0	6273-7	3006451		
84548	2619	4052083	1980-06-27	1980-06-27 00:00:00	1980-06-27	5001	0	\N	0	0	\N	\N	0	173208	0	23426006	4052083		
45991	4239	3006322	1958-02-24	1958-02-24 00:00:00	1958-02-24	5001	0	\N	0	0	\N	\N	0	281465	0	8331-1	3006322		
36022	3311	40769184	1990-03-21	1990-03-21 00:00:00	1990-03-21	5001	0	\N	0	0	\N	\N	0	219862	0	66524-0	40769184		
57455	5278	3006322	1984-05-24	1984-05-24 00:00:00	1984-05-24	5001	0	\N	0	0	\N	\N	0	351071	0	8331-1	3006322		
3729	354	3006322	1993-10-18	1993-10-18 00:00:00	1993-10-18	5001	0	\N	0	0	\N	\N	0	23526	0	8331-1	3006322		
142414	4376	4133840	2014-01-14	2014-01-14 00:00:00	2014-01-14	5001	0	\N	0	0	\N	\N	0	290823	0	127783003	4133840		
30055	2767	3006906	1939-05-23	1939-05-23 00:00:00	1939-05-23	5001	0	\N	0	0	\N	\N	0	183063	0	17861-6	3006906		
24262	2238	3021226	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	148967	0	6246-3	3021226		
150353	4608	4133840	1992-01-30	1992-01-30 00:00:00	1992-01-30	5001	0	\N	0	0	\N	\N	0	306976	0	127783003	4133840		
52518	4822	3011505	2012-12-19	2012-12-19 00:00:00	2012-12-19	5001	0	\N	0	0	\N	\N	0	320706	0	19926-5	3011505		
113597	3508	4052083	2010-12-25	2010-12-25 00:00:00	2010-12-25	5001	0	\N	0	0	\N	\N	0	232626	0	23426006	4052083		
4533	442	3006734	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	29416	0	6189-5	3006734		
2732	266	3036780	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	17657	0	6095-4	3036780		
2004	182	3006322	2011-10-01	2011-10-01 00:00:00	2011-10-01	5001	0	\N	0	0	\N	\N	0	12252	0	8331-1	3006322		
44253	4078	3001488	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	271017	0	7258-7	3001488		
16281	1482	3006734	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	98836	0	6189-5	3006734		
1009	81	3006322	1964-09-18	1964-09-18 00:00:00	1964-09-18	5001	0	\N	0	0	\N	\N	0	5487	0	8331-1	3006322		
9281	877	3014599	1978-06-07	1978-06-07 00:00:00	1978-06-07	5001	0	\N	0	0	\N	\N	0	58348	0	6106-9	3014599		
38909	3595	40766240	1990-12-30	1990-12-30 00:00:00	1990-12-30	5001	0	\N	0	0	\N	\N	0	238789	0	63513-6	40766240		
138125	4256	4052083	1991-06-01	1991-06-01 00:00:00	1991-06-01	5001	0	\N	0	0	\N	\N	0	282611	0	23426006	4052083		
159451	4899	4133840	1975-07-01	1975-07-01 00:00:00	1975-07-01	5001	0	\N	0	0	\N	\N	0	325855	0	127783003	4133840		
34748	3178	3002385	2014-03-13	2014-03-13 00:00:00	2014-03-13	5001	0	\N	0	0	\N	\N	0	211388	0	30385-9	3002385		
34787	3181	3011505	2007-09-14	2007-09-14 00:00:00	2007-09-14	5001	0	\N	0	0	\N	\N	0	211709	0	19926-5	3011505		
51440	1560	4052083	1997-12-12	1997-12-12 00:00:00	1997-12-12	5001	0	\N	0	0	\N	\N	0	104443	0	23426006	4052083		
8599	822	3006322	1978-09-08	1978-09-08 00:00:00	1978-09-08	5001	0	\N	0	0	\N	\N	0	54490	0	8331-1	3006322		
28430	2633	3049273	2018-02-19	2018-02-19 00:00:00	2018-02-19	5001	0	\N	0	0	\N	\N	0	174229	0	38265-5	3049273		
20320	1864	3011505	2015-12-04	2015-12-04 00:00:00	2015-12-04	5001	0	\N	0	0	\N	\N	0	124545	0	19926-5	3011505		
10457	1015	40758406	2005-07-10	2005-07-10 00:00:00	2005-07-10	5001	0	\N	0	0	\N	\N	0	66769	0	55277-8	40758406		
101728	3125	4024958	1968-05-07	1968-05-07 00:00:00	1968-05-07	5001	0	\N	0	0	\N	\N	0	207926	0	117015009	4024958		
7451	711	21494966	1967-01-29	1967-01-29 00:00:00	1967-01-29	5001	0	\N	0	0	\N	\N	0	47196	0	80271-0	21494966		
253	9	3012494	1979-01-30	1979-01-30 00:00:00	1979-01-30	5001	0	\N	0	0	\N	\N	0	707	0	6206-7	3012494		
20986	1946	3006322	1960-06-22	1960-06-22 00:00:00	1960-06-22	5001	0	\N	0	0	\N	\N	0	129257	0	8331-1	3006322		
54714	5004	3001488	1990-03-13	1990-03-13 00:00:00	1990-03-13	5001	0	\N	0	0	\N	\N	0	332871	0	7258-7	3001488		
19170	1758	3006322	2017-01-16	2017-01-16 00:00:00	2017-01-16	5001	0	\N	0	0	\N	\N	0	117519	0	8331-1	3006322		
54481	4977	3010813	2010-12-07	2010-12-07 00:00:00	2010-12-07	5001	0	\N	0	0	\N	\N	0	331120	0	26464-8	3010813		
1567	137	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	9127	0	6085-5	3001247		
12902	1227	40758406	1958-04-17	1958-04-17 00:00:00	1958-04-17	5001	0	\N	0	0	\N	\N	0	80748	0	55277-8	40758406		
53216	4890	3049273	2000-09-06	2000-09-06 00:00:00	2000-09-06	5001	0	\N	0	0	\N	\N	0	325251	0	38265-5	3049273		
3781	358	3006322	1960-12-27	1960-12-27 00:00:00	1960-12-27	5001	0	\N	0	0	\N	\N	0	23848	0	8331-1	3006322		
94877	2915	4052083	2007-07-07	2007-07-07 00:00:00	2007-07-07	5001	0	\N	0	0	\N	\N	0	194275	0	23426006	4052083		
33680	3060	3006322	1934-10-07	1934-10-07 00:00:00	1934-10-07	5001	0	\N	0	0	\N	\N	0	203605	0	8331-1	3006322		
41281	3852	3021226	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	255735	0	6246-3	3021226		
46933	4320	3019550	1970-05-14	1970-05-14 00:00:00	1970-05-14	5001	0	\N	0	0	\N	\N	0	286692	0	2951-2	3019550		
100407	3081	4024958	1968-04-15	1968-04-15 00:00:00	1968-04-15	5001	0	\N	0	0	\N	\N	0	205097	0	117015009	4024958		
4030	403	3006322	1960-10-13	1960-10-13 00:00:00	1960-10-13	5001	0	\N	0	0	\N	\N	0	26434	0	8331-1	3006322		
63550	1952	4024958	1962-07-04	1962-07-04 00:00:00	1962-07-04	5001	0	\N	0	0	\N	\N	0	129821	0	117015009	4024958		
109653	3382	4024958	2014-07-10	2014-07-10 00:00:00	2014-07-10	5001	0	\N	0	0	\N	\N	0	224447	0	117015009	4024958		
21892	689	4024958	1989-01-18	1989-01-18 00:00:00	1989-01-18	5001	0	\N	0	0	\N	\N	0	45609	0	117015009	4024958		
35167	3215	3015076	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	213667	0	6248-9	3015076		
84557	2619	4052083	2010-05-30	2010-05-30 00:00:00	2010-05-30	5001	0	\N	0	0	\N	\N	0	173210	0	23426006	4052083		
45992	4239	3006322	2018-08-12	2018-08-12 00:00:00	2018-08-12	5001	0	\N	0	0	\N	\N	0	281570	0	8331-1	3006322		
36023	3311	40769194	1990-03-21	1990-03-21 00:00:00	1990-03-21	5001	0	\N	0	0	\N	\N	0	219862	0	66534-9	40769194		
57456	5278	3006322	1997-09-27	1997-09-27 00:00:00	1997-09-27	5001	0	\N	0	0	\N	\N	0	351116	0	8331-1	3006322		
3730	354	3011505	2007-01-11	2007-01-11 00:00:00	2007-01-11	5001	0	\N	0	0	\N	\N	0	23576	0	19926-5	3011505		
142419	4376	4133840	1991-09-10	1991-09-10 00:00:00	1991-09-10	5001	0	\N	0	0	\N	\N	0	290805	0	127783003	4133840		
30056	2767	3004501	1939-05-23	1939-05-23 00:00:00	1939-05-23	5001	0	\N	0	0	\N	\N	0	183063	0	2345-7	3004501		
24263	2238	3019406	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	148967	0	6158-0	3019406		
52521	4826	3006322	2011-07-31	2011-07-31 00:00:00	2011-07-31	5001	0	\N	0	0	\N	\N	0	321045	0	8331-1	3006322		
52573	4827	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	321224	0	6075-6	3005136		
4534	442	3014599	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	29416	0	6106-9	3014599		
2733	266	3001247	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	17657	0	6085-5	3001247		
2005	182	3006322	1976-06-12	1976-06-12 00:00:00	1976-06-12	5001	0	\N	0	0	\N	\N	0	12283	0	8331-1	3006322		
44254	4078	3036780	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	271017	0	6095-4	3036780		
16282	1482	3020655	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	98836	0	6844-5	3020655		
1010	81	3006322	1967-05-19	1967-05-19 00:00:00	1967-05-19	5001	0	\N	0	0	\N	\N	0	5482	0	8331-1	3006322		
9282	877	3005136	1978-06-07	1978-06-07 00:00:00	1978-06-07	5001	0	\N	0	0	\N	\N	0	58348	0	6075-6	3005136		
38910	3595	3051031	1990-12-30	1990-12-30 00:00:00	1990-12-30	5001	0	\N	0	0	\N	\N	0	238789	0	46240-8	3051031		
92588	2853	4024958	1993-02-13	1993-02-13 00:00:00	1993-02-13	5001	0	\N	0	0	\N	\N	0	189513	0	117015009	4024958		
159458	4899	4133840	1977-07-12	1977-07-12 00:00:00	1977-07-12	5001	0	\N	0	0	\N	\N	0	325827	0	127783003	4133840		
34749	3178	21494966	2014-03-13	2014-03-13 00:00:00	2014-03-13	5001	0	\N	0	0	\N	\N	0	211388	0	80271-0	21494966		
34788	3181	3011505	2004-08-27	2004-08-27 00:00:00	2004-08-27	5001	0	\N	0	0	\N	\N	0	211679	0	19926-5	3011505		
51454	1560	4024958	1944-03-18	1944-03-18 00:00:00	1944-03-18	5001	0	\N	0	0	\N	\N	0	104500	0	117015009	4024958		
8600	822	3006322	1976-03-26	1976-03-26 00:00:00	1976-03-26	5001	0	\N	0	0	\N	\N	0	54480	0	8331-1	3006322		
78928	2424	4052083	1991-10-31	1991-10-31 00:00:00	1991-10-31	5001	0	\N	0	0	\N	\N	0	160820	0	23426006	4052083		
20321	1864	3006322	1994-06-15	1994-06-15 00:00:00	1994-06-15	5001	0	\N	0	0	\N	\N	0	124555	0	8331-1	3006322		
10459	1015	3051031	2005-07-10	2005-07-10 00:00:00	2005-07-10	5001	0	\N	0	0	\N	\N	0	66769	0	46240-8	3051031		
101729	3125	4024958	1962-04-16	1962-04-16 00:00:00	1962-04-16	5001	0	\N	0	0	\N	\N	0	207933	0	117015009	4024958		
7452	711	3026361	1967-01-29	1967-01-29 00:00:00	1967-01-29	5001	0	\N	0	0	\N	\N	0	47196	0	26453-1	3026361		
254	9	3001247	1979-01-30	1979-01-30 00:00:00	1979-01-30	5001	0	\N	0	0	\N	\N	0	707	0	6085-5	3001247		
20987	1946	3006322	1963-10-18	1963-10-18 00:00:00	1963-10-18	5001	0	\N	0	0	\N	\N	0	129333	0	8331-1	3006322		
54715	5004	3023430	1990-03-13	1990-03-13 00:00:00	1990-03-13	5001	0	\N	0	0	\N	\N	0	332871	0	6833-8	3023430		
19171	1759	3006322	1999-09-16	1999-09-16 00:00:00	1999-09-16	5001	0	\N	0	0	\N	\N	0	117575	0	8331-1	3006322		
54482	4977	21494966	2010-12-07	2010-12-07 00:00:00	2010-12-07	5001	0	\N	0	0	\N	\N	0	331120	0	80271-0	21494966		
1568	137	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	9127	0	7258-7	3001488		
12904	1227	3051031	1958-04-17	1958-04-17 00:00:00	1958-04-17	5001	0	\N	0	0	\N	\N	0	80748	0	46240-8	3051031		
53217	4890	3006322	1923-03-05	1923-03-05 00:00:00	1923-03-05	5001	0	\N	0	0	\N	\N	0	325219	0	8331-1	3006322		
3783	358	3006322	1996-11-13	1996-11-13 00:00:00	1996-11-13	5001	0	\N	0	0	\N	\N	0	23808	0	8331-1	3006322		
94886	2915	4024958	1986-11-13	1986-11-13 00:00:00	1986-11-13	5001	0	\N	0	0	\N	\N	0	194326	0	117015009	4024958		
33681	3060	3006322	1944-05-20	1944-05-20 00:00:00	1944-05-20	5001	0	\N	0	0	\N	\N	0	203557	0	8331-1	3006322		
41282	3852	3006451	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	255735	0	6273-7	3006451		
46934	4320	3014576	1970-05-14	1970-05-14 00:00:00	1970-05-14	5001	0	\N	0	0	\N	\N	0	286692	0	2075-0	3014576		
100413	3081	4052083	2005-10-30	2005-10-30 00:00:00	2005-10-30	5001	0	\N	0	0	\N	\N	0	205122	0	23426006	4052083		
4031	403	3009542	1999-02-08	1999-02-08 00:00:00	1999-02-08	5001	0	\N	0	0	\N	\N	0	26500	0	20570-8	3009542		
98242	3007	4024958	2016-12-03	2016-12-03 00:00:00	2016-12-03	5001	0	\N	0	0	\N	\N	0	200639	0	117015009	4024958		
18444	579	4052083	2008-08-22	2008-08-22 00:00:00	2008-08-22	5001	0	\N	0	0	\N	\N	0	38350	0	23426006	4052083		
56477	1724	4052083	2015-06-30	2015-06-30 00:00:00	2015-06-30	5001	0	\N	0	0	\N	\N	0	115326	0	23426006	4052083		
35168	3215	3027231	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	213667	0	6276-0	3027231		
84561	2619	4052083	2013-02-24	2013-02-24 00:00:00	2013-02-24	5001	0	\N	0	0	\N	\N	0	173166	0	23426006	4052083		
45993	4239	3006322	1953-11-01	1953-11-01 00:00:00	1953-11-01	5001	0	\N	0	0	\N	\N	0	281514	0	8331-1	3006322		
36024	3311	40769189	1990-03-21	1990-03-21 00:00:00	1990-03-21	5001	0	\N	0	0	\N	\N	0	219862	0	66529-9	40769189		
57457	5279	3006322	1968-04-16	1968-04-16 00:00:00	1968-04-16	5001	0	\N	0	0	\N	\N	0	351233	0	8331-1	3006322		
3731	354	3011505	2012-02-09	2012-02-09 00:00:00	2012-02-09	5001	0	\N	0	0	\N	\N	0	23567	0	19926-5	3011505		
142422	4376	4133840	1989-08-29	1989-08-29 00:00:00	1989-08-29	5001	0	\N	0	0	\N	\N	0	290804	0	127783003	4133840		
30057	2767	3010813	1939-05-23	1939-05-23 00:00:00	1939-05-23	5001	0	\N	0	0	\N	\N	0	183063	0	26464-8	3010813		
24264	2238	3000876	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	148967	0	6082-2	3000876		
52522	4826	3006322	1976-01-19	1976-01-19 00:00:00	1976-01-19	5001	0	\N	0	0	\N	\N	0	321015	0	8331-1	3006322		
52574	4827	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	321224	0	6246-3	3021226		
4535	442	3001247	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	29416	0	6085-5	3001247		
2734	266	3015076	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	17657	0	6248-9	3015076		
2006	182	3006322	1961-06-16	1961-06-16 00:00:00	1961-06-16	5001	0	\N	0	0	\N	\N	0	12313	0	8331-1	3006322		
44255	4078	3014599	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	271017	0	6106-9	3014599		
16283	1482	3023430	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	98836	0	6833-8	3023430		
1011	81	3006322	2003-06-11	2003-06-11 00:00:00	2003-06-11	5001	0	\N	0	0	\N	\N	0	5486	0	8331-1	3006322		
9283	877	3006734	1978-06-07	1978-06-07 00:00:00	1978-06-07	5001	0	\N	0	0	\N	\N	0	58348	0	6189-5	3006734		
38913	3598	3006322	1980-09-10	1980-09-10 00:00:00	1980-09-10	5001	0	\N	0	0	\N	\N	0	238925	0	8331-1	3006322		
92595	2853	4024958	1963-07-26	1963-07-26 00:00:00	1963-07-26	5001	0	\N	0	0	\N	\N	0	189548	0	117015009	4024958		
159460	4899	4133840	1985-08-27	1985-08-27 00:00:00	1985-08-27	5001	0	\N	0	0	\N	\N	0	325844	0	127783003	4133840		
34750	3178	3035995	2014-03-13	2014-03-13 00:00:00	2014-03-13	5001	0	\N	0	0	\N	\N	0	211388	0	6768-6	3035995		
34789	3181	3049273	2018-11-15	2018-11-15 00:00:00	2018-11-15	5001	0	\N	0	0	\N	\N	0	211691	0	38265-5	3049273		
51474	1560	4024958	1944-11-27	1944-11-27 00:00:00	1944-11-27	5001	0	\N	0	0	\N	\N	0	104501	0	117015009	4024958		
8601	822	3006322	1976-08-04	1976-08-04 00:00:00	1976-08-04	5001	0	\N	0	0	\N	\N	0	54489	0	8331-1	3006322		
90253	2786	4052083	2003-11-17	2003-11-17 00:00:00	2003-11-17	5001	0	\N	0	0	\N	\N	0	184620	0	23426006	4052083		
20322	1864	3011505	2016-12-09	2016-12-09 00:00:00	2016-12-09	5001	0	\N	0	0	\N	\N	0	124530	0	19926-5	3011505		
10460	1015	46235214	2005-07-10	2005-07-10 00:00:00	2005-07-10	5001	0	\N	0	0	\N	\N	0	66769	0	76690-7	46235214		
101730	3125	4052083	1954-04-15	1954-04-15 00:00:00	1954-04-15	5001	0	\N	0	0	\N	\N	0	207993	0	23426006	4052083		
7453	711	3019550	1967-01-29	1967-01-29 00:00:00	1967-01-29	5001	0	\N	0	0	\N	\N	0	47196	0	2951-2	3019550		
255	9	3001488	1979-01-30	1979-01-30 00:00:00	1979-01-30	5001	0	\N	0	0	\N	\N	0	707	0	7258-7	3001488		
20988	1946	3006322	1969-06-26	1969-06-26 00:00:00	1969-06-26	5001	0	\N	0	0	\N	\N	0	129319	0	8331-1	3006322		
54716	5004	3036780	1990-03-13	1990-03-13 00:00:00	1990-03-13	5001	0	\N	0	0	\N	\N	0	332871	0	6095-4	3036780		
19172	1760	3006322	1985-01-21	1985-01-21 00:00:00	1985-01-21	5001	0	\N	0	0	\N	\N	0	117655	0	8331-1	3006322		
54483	4977	3006906	2010-12-07	2010-12-07 00:00:00	2010-12-07	5001	0	\N	0	0	\N	\N	0	331120	0	17861-6	3006906		
1569	137	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	9127	0	6844-5	3020655		
12905	1227	46235214	1958-04-17	1958-04-17 00:00:00	1958-04-17	5001	0	\N	0	0	\N	\N	0	80748	0	76690-7	46235214		
53218	4890	40769189	1946-11-23	1946-11-23 00:00:00	1946-11-23	5001	0	\N	0	0	\N	\N	0	325181	0	66529-9	40769189		
3784	358	3006322	1982-10-08	1982-10-08 00:00:00	1982-10-08	5001	0	\N	0	0	\N	\N	0	23795	0	8331-1	3006322		
94887	2915	4024958	1949-04-13	1949-04-13 00:00:00	1949-04-13	5001	0	\N	0	0	\N	\N	0	194350	0	117015009	4024958		
33682	3060	3006322	1955-06-15	1955-06-15 00:00:00	1955-06-15	5001	0	\N	0	0	\N	\N	0	203571	0	8331-1	3006322		
41283	3852	3014599	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	255735	0	6106-9	3014599		
46935	4320	3024561	1970-05-14	1970-05-14 00:00:00	1970-05-14	5001	0	\N	0	0	\N	\N	0	286692	0	1751-7	3024561		
111701	3446	4052083	1968-09-23	1968-09-23 00:00:00	1968-09-23	5001	0	\N	0	0	\N	\N	0	228808	0	23426006	4052083		
4032	403	3000963	1999-02-08	1999-02-08 00:00:00	1999-02-08	5001	0	\N	0	0	\N	\N	0	26500	0	718-7	3000963		
98243	3007	4024958	1968-07-02	1968-07-02 00:00:00	1968-07-02	5001	0	\N	0	0	\N	\N	0	200637	0	117015009	4024958		
18446	579	4024958	1984-06-13	1984-06-13 00:00:00	1984-06-13	5001	0	\N	0	0	\N	\N	0	38367	0	117015009	4024958		
96610	2959	4024958	1985-11-04	1985-11-04 00:00:00	1985-11-04	5001	0	\N	0	0	\N	\N	0	197483	0	117015009	4024958		
35169	3215	3019406	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	213667	0	6158-0	3019406		
84562	2619	4024958	1979-12-15	1979-12-15 00:00:00	1979-12-15	5001	0	\N	0	0	\N	\N	0	173144	0	117015009	4024958		
45995	4240	3049273	2010-10-04	2010-10-04 00:00:00	2010-10-04	5001	0	\N	0	0	\N	\N	0	281594	0	38265-5	3049273		
36027	3313	3006322	2014-12-14	2014-12-14 00:00:00	2014-12-14	5001	0	\N	0	0	\N	\N	0	219973	0	8331-1	3006322		
93666	2883	4024958	1991-11-04	1991-11-04 00:00:00	1991-11-04	5001	0	\N	0	0	\N	\N	0	191769	0	117015009	4024958		
3732	354	3006322	2004-07-09	2004-07-09 00:00:00	2004-07-09	5001	0	\N	0	0	\N	\N	0	23527	0	8331-1	3006322		
142430	4376	4133840	2003-11-18	2003-11-18 00:00:00	2003-11-18	5001	0	\N	0	0	\N	\N	0	290837	0	127783003	4133840		
30058	2767	3014576	1939-05-23	1939-05-23 00:00:00	1939-05-23	5001	0	\N	0	0	\N	\N	0	183063	0	2075-0	3014576		
24265	2238	3036780	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	148967	0	6095-4	3036780		
52523	4826	3006322	1990-04-20	1990-04-20 00:00:00	1990-04-20	5001	0	\N	0	0	\N	\N	0	321016	0	8331-1	3006322		
52575	4827	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	321224	0	6206-7	3012494		
4536	442	3006451	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	29296	0	6273-7	3006451		
2735	266	3020655	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	17657	0	6844-5	3020655		
2007	182	3006322	2008-03-07	2008-03-07 00:00:00	2008-03-07	5001	0	\N	0	0	\N	\N	0	12320	0	8331-1	3006322		
44256	4078	3021226	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	271017	0	6246-3	3021226		
16284	1482	3036780	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	98836	0	6095-4	3036780		
1012	82	3006322	1978-03-03	1978-03-03 00:00:00	1978-03-03	5001	0	\N	0	0	\N	\N	0	5604	0	8331-1	3006322		
9284	877	3036780	1978-06-07	1978-06-07 00:00:00	1978-06-07	5001	0	\N	0	0	\N	\N	0	58348	0	6095-4	3036780		
38914	3598	3006322	1980-10-24	1980-10-24 00:00:00	1980-10-24	5001	0	\N	0	0	\N	\N	0	238954	0	8331-1	3006322		
92600	2853	4024958	1964-08-29	1964-08-29 00:00:00	1964-08-29	5001	0	\N	0	0	\N	\N	0	189503	0	117015009	4024958		
170771	5239	4052083	1968-10-11	1968-10-11 00:00:00	1968-10-11	5001	0	\N	0	0	\N	\N	0	348547	0	23426006	4052083		
34751	3178	3006906	2014-03-13	2014-03-13 00:00:00	2014-03-13	5001	0	\N	0	0	\N	\N	0	211388	0	17861-6	3006906		
34790	3181	3006322	1984-07-23	1984-07-23 00:00:00	1984-07-23	5001	0	\N	0	0	\N	\N	0	211663	0	8331-1	3006322		
9130	289	4052083	2010-10-17	2010-10-17 00:00:00	2010-10-17	5001	0	\N	0	0	\N	\N	0	19283	0	23426006	4052083		
8602	822	3006322	1973-11-26	1973-11-26 00:00:00	1973-11-26	5001	0	\N	0	0	\N	\N	0	54458	0	8331-1	3006322		
46295	4261	3051031	1957-04-27	1957-04-27 00:00:00	1957-04-27	5001	0	\N	0	0	\N	\N	0	282887	0	46240-8	3051031		
20323	1864	3011505	2017-12-15	2017-12-15 00:00:00	2017-12-15	5001	0	\N	0	0	\N	\N	0	124546	0	19926-5	3011505		
10461	1015	40766240	2005-07-10	2005-07-10 00:00:00	2005-07-10	5001	0	\N	0	0	\N	\N	0	66769	0	63513-6	40766240		
101734	3125	4024958	1955-06-10	1955-06-10 00:00:00	1955-06-10	5001	0	\N	0	0	\N	\N	0	207994	0	117015009	4024958		
7454	711	3024731	1967-01-29	1967-01-29 00:00:00	1967-01-29	5001	0	\N	0	0	\N	\N	0	47196	0	30428-7	3024731		
256	9	3006322	1982-05-01	1982-05-01 00:00:00	1982-05-01	5001	0	\N	0	0	\N	\N	0	835	0	8331-1	3006322		
20989	1946	3006322	2000-06-05	2000-06-05 00:00:00	2000-06-05	5001	0	\N	0	0	\N	\N	0	129311	0	8331-1	3006322		
54717	5004	3019406	1990-03-13	1990-03-13 00:00:00	1990-03-13	5001	0	\N	0	0	\N	\N	0	332871	0	6158-0	3019406		
19173	1760	3006322	2016-04-03	2016-04-03 00:00:00	2016-04-03	5001	0	\N	0	0	\N	\N	0	117657	0	8331-1	3006322		
54484	4977	3014576	2010-12-07	2010-12-07 00:00:00	2010-12-07	5001	0	\N	0	0	\N	\N	0	331120	0	2075-0	3014576		
1570	137	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	9127	0	6276-0	3027231		
12906	1227	3006322	1967-01-21	1967-01-21 00:00:00	1967-01-21	5001	0	\N	0	0	\N	\N	0	80780	0	8331-1	3006322		
53219	4890	40769194	1946-11-23	1946-11-23 00:00:00	1946-11-23	5001	0	\N	0	0	\N	\N	0	325181	0	66534-9	40769194		
3785	358	3006322	1955-07-17	1955-07-17 00:00:00	1955-07-17	5001	0	\N	0	0	\N	\N	0	23778	0	8331-1	3006322		
13335	1265	3021226	1983-06-08	1983-06-08 00:00:00	1983-06-08	5001	0	\N	0	0	\N	\N	0	83401	0	6246-3	3021226		
33683	3060	3006322	2017-08-14	2017-08-14 00:00:00	2017-08-14	5001	0	\N	0	0	\N	\N	0	203548	0	8331-1	3006322		
41284	3852	3019406	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	255735	0	6158-0	3019406		
46936	4320	3027970	1970-05-14	1970-05-14 00:00:00	1970-05-14	5001	0	\N	0	0	\N	\N	0	286692	0	10834-0	3027970		
111705	3446	4024958	1984-04-29	1984-04-29 00:00:00	1984-04-29	5001	0	\N	0	0	\N	\N	0	228810	0	117015009	4024958		
4033	403	3006322	1926-03-10	1926-03-10 00:00:00	1926-03-10	5001	0	\N	0	0	\N	\N	0	26489	0	8331-1	3006322		
98250	3007	4024958	1987-05-18	1987-05-18 00:00:00	1987-05-18	5001	0	\N	0	0	\N	\N	0	200636	0	117015009	4024958		
18474	580	4052083	1980-12-01	1980-12-01 00:00:00	1980-12-01	5001	0	\N	0	0	\N	\N	0	38406	0	23426006	4052083		
107940	3332	4024958	1977-02-26	1977-02-26 00:00:00	1977-02-26	5001	0	\N	0	0	\N	\N	0	221099	0	117015009	4024958		
35170	3215	40769189	2002-10-08	2002-10-08 00:00:00	2002-10-08	5001	0	\N	0	0	\N	\N	0	213564	0	66529-9	40769189		
84579	2620	4052083	2015-11-09	2015-11-09 00:00:00	2015-11-09	5001	0	\N	0	0	\N	\N	0	173278	0	23426006	4052083		
45996	4240	3006322	1947-12-30	1947-12-30 00:00:00	1947-12-30	5001	0	\N	0	0	\N	\N	0	281687	0	8331-1	3006322		
36028	3313	3006322	1974-05-06	1974-05-06 00:00:00	1974-05-06	5001	0	\N	0	0	\N	\N	0	219967	0	8331-1	3006322		
93672	2883	4052083	1981-05-08	1981-05-08 00:00:00	1981-05-08	5001	0	\N	0	0	\N	\N	0	191785	0	23426006	4052083		
3733	354	3011505	2009-01-22	2009-01-22 00:00:00	2009-01-22	5001	0	\N	0	0	\N	\N	0	23577	0	19926-5	3011505		
142437	4376	4133840	2019-02-12	2019-02-12 00:00:00	2019-02-12	5001	0	\N	0	0	\N	\N	0	290759	0	127783003	4133840		
30059	2767	3035995	1939-05-23	1939-05-23 00:00:00	1939-05-23	5001	0	\N	0	0	\N	\N	0	183063	0	6768-6	3035995		
24266	2238	3015076	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	148967	0	6248-9	3015076		
52524	4826	3006322	1968-05-14	1968-05-14 00:00:00	1968-05-14	5001	0	\N	0	0	\N	\N	0	320921	0	8331-1	3006322		
52576	4827	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	321224	0	6189-5	3006734		
4537	442	3021226	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	29296	0	6246-3	3021226		
2736	266	3001488	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	17657	0	7258-7	3001488		
2008	183	3006322	2007-04-16	2007-04-16 00:00:00	2007-04-16	5001	0	\N	0	0	\N	\N	0	12361	0	8331-1	3006322		
76509	2346	4052083	1972-10-10	1972-10-10 00:00:00	1972-10-10	5001	0	\N	0	0	\N	\N	0	156169	0	23426006	4052083		
16285	1482	3014599	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	98836	0	6106-9	3014599		
1013	82	3006322	1970-01-05	1970-01-05 00:00:00	1970-01-05	5001	0	\N	0	0	\N	\N	0	5538	0	8331-1	3006322		
9285	877	3019406	1978-06-07	1978-06-07 00:00:00	1978-06-07	5001	0	\N	0	0	\N	\N	0	58348	0	6158-0	3019406		
38915	3598	3006322	1963-02-03	1963-02-03 00:00:00	1963-02-03	5001	0	\N	0	0	\N	\N	0	238928	0	8331-1	3006322		
92641	2857	4052083	1969-08-02	1969-08-02 00:00:00	1969-08-02	5001	0	\N	0	0	\N	\N	0	189732	0	23426006	4052083		
170782	5239	4024958	2001-01-20	2001-01-20 00:00:00	2001-01-20	5001	0	\N	0	0	\N	\N	0	348548	0	117015009	4024958		
34752	3178	3006322	1977-02-18	1977-02-18 00:00:00	1977-02-18	5001	0	\N	0	0	\N	\N	0	211419	0	8331-1	3006322		
34791	3181	3011505	2018-11-16	2018-11-16 00:00:00	2018-11-16	5001	0	\N	0	0	\N	\N	0	211729	0	19926-5	3011505		
9131	289	4024958	2005-08-13	2005-08-13 00:00:00	2005-08-13	5001	0	\N	0	0	\N	\N	0	19295	0	117015009	4024958		
8603	823	3011505	2019-02-04	2019-02-04 00:00:00	2019-02-04	5001	0	\N	0	0	\N	\N	0	54601	0	19926-5	3011505		
46296	4261	40766240	1957-04-27	1957-04-27 00:00:00	1957-04-27	5001	0	\N	0	0	\N	\N	0	282887	0	63513-6	40766240		
20332	1867	3006322	1972-11-20	1972-11-20 00:00:00	1972-11-20	5001	0	\N	0	0	\N	\N	0	124695	0	8331-1	3006322		
10463	1015	40758406	2018-04-03	2018-04-03 00:00:00	2018-04-03	5001	0	\N	0	0	\N	\N	0	66839	0	55277-8	40758406		
101736	3125	4052083	2010-07-06	2010-07-06 00:00:00	2010-07-06	5001	0	\N	0	0	\N	\N	0	207948	0	23426006	4052083		
7455	711	3000963	1967-01-29	1967-01-29 00:00:00	1967-01-29	5001	0	\N	0	0	\N	\N	0	47196	0	718-7	3000963		
257	9	3006322	1987-08-13	1987-08-13 00:00:00	1987-08-13	5001	0	\N	0	0	\N	\N	0	813	0	8331-1	3006322		
20990	1946	3006322	1936-09-13	1936-09-13 00:00:00	1936-09-13	5001	0	\N	0	0	\N	\N	0	129358	0	8331-1	3006322		
54718	5004	3006734	1990-03-13	1990-03-13 00:00:00	1990-03-13	5001	0	\N	0	0	\N	\N	0	332871	0	6189-5	3006734		
19174	1760	3006322	1980-03-09	1980-03-09 00:00:00	1980-03-09	5001	0	\N	0	0	\N	\N	0	117671	0	8331-1	3006322		
54485	4977	3006322	1999-08-30	1999-08-30 00:00:00	1999-08-30	5001	0	\N	0	0	\N	\N	0	331191	0	8331-1	3006322		
1571	137	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	9127	0	6248-9	3015076		
12907	1227	3049273	2017-09-11	2017-09-11 00:00:00	2017-09-11	5001	0	\N	0	0	\N	\N	0	80824	0	38265-5	3049273		
53220	4890	40769184	1946-11-23	1946-11-23 00:00:00	1946-11-23	5001	0	\N	0	0	\N	\N	0	325181	0	66524-0	40769184		
3786	358	3006322	1948-02-13	1948-02-13 00:00:00	1948-02-13	5001	0	\N	0	0	\N	\N	0	23846	0	8331-1	3006322		
13336	1265	3005136	1983-06-08	1983-06-08 00:00:00	1983-06-08	5001	0	\N	0	0	\N	\N	0	83401	0	6075-6	3005136		
33684	3060	3006322	1937-05-11	1937-05-11 00:00:00	1937-05-11	5001	0	\N	0	0	\N	\N	0	203542	0	8331-1	3006322		
41285	3852	3005136	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	255735	0	6075-6	3005136		
46937	4320	3000963	1970-05-14	1970-05-14 00:00:00	1970-05-14	5001	0	\N	0	0	\N	\N	0	286692	0	718-7	3000963		
111717	3446	4024958	1991-10-18	1991-10-18 00:00:00	1991-10-18	5001	0	\N	0	0	\N	\N	0	228850	0	117015009	4024958		
4034	403	3006322	1975-02-26	1975-02-26 00:00:00	1975-02-26	5001	0	\N	0	0	\N	\N	0	26496	0	8331-1	3006322		
98252	3007	4024958	1978-03-22	1978-03-22 00:00:00	1978-03-22	5001	0	\N	0	0	\N	\N	0	200631	0	117015009	4024958		
18484	580	4052083	1942-08-16	1942-08-16 00:00:00	1942-08-16	5001	0	\N	0	0	\N	\N	0	38404	0	23426006	4052083		
56589	1727	4024958	1961-10-23	1961-10-23 00:00:00	1961-10-23	5001	0	\N	0	0	\N	\N	0	115520	0	117015009	4024958		
35171	3215	40769179	2002-10-08	2002-10-08 00:00:00	2002-10-08	5001	0	\N	0	0	\N	\N	0	213564	0	66519-0	40769179		
84585	2620	4024958	1966-02-03	1966-02-03 00:00:00	1966-02-03	5001	0	\N	0	0	\N	\N	0	173275	0	117015009	4024958		
45997	4240	3006322	1945-12-30	1945-12-30 00:00:00	1945-12-30	5001	0	\N	0	0	\N	\N	0	281686	0	8331-1	3006322		
36029	3313	3006322	1958-02-18	1958-02-18 00:00:00	1958-02-18	5001	0	\N	0	0	\N	\N	0	219976	0	8331-1	3006322		
93677	2883	4024958	2003-01-19	2003-01-19 00:00:00	2003-01-19	5001	0	\N	0	0	\N	\N	0	191795	0	117015009	4024958		
3734	354	3011505	2010-01-28	2010-01-28 00:00:00	2010-01-28	5001	0	\N	0	0	\N	\N	0	23523	0	19926-5	3011505		
142443	4376	4133840	2000-10-31	2000-10-31 00:00:00	2000-10-31	5001	0	\N	0	0	\N	\N	0	290819	0	127783003	4133840		
30060	2767	3006923	1939-05-23	1939-05-23 00:00:00	1939-05-23	5001	0	\N	0	0	\N	\N	0	183063	0	1742-6	3006923		
24267	2238	3005136	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	148967	0	6075-6	3005136		
52525	4826	3015076	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	321004	0	6248-9	3015076		
52577	4827	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	321224	0	6833-8	3023430		
4538	442	3027231	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	29296	0	6276-0	3027231		
2737	266	3000876	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	17657	0	6082-2	3000876		
2009	183	3006322	1975-11-22	1975-11-22 00:00:00	1975-11-22	5001	0	\N	0	0	\N	\N	0	12390	0	8331-1	3006322		
76512	2346	4024958	1950-01-19	1950-01-19 00:00:00	1950-01-19	5001	0	\N	0	0	\N	\N	0	156124	0	117015009	4024958		
16286	1482	3015076	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	98836	0	6248-9	3015076		
1014	82	3006322	2006-08-17	2006-08-17 00:00:00	2006-08-17	5001	0	\N	0	0	\N	\N	0	5577	0	8331-1	3006322		
9286	877	3001247	1978-06-07	1978-06-07 00:00:00	1978-06-07	5001	0	\N	0	0	\N	\N	0	58348	0	6085-5	3001247		
38916	3598	3006322	1956-06-23	1956-06-23 00:00:00	1956-06-23	5001	0	\N	0	0	\N	\N	0	238948	0	8331-1	3006322		
92650	2857	4052083	1965-11-02	1965-11-02 00:00:00	1965-11-02	5001	0	\N	0	0	\N	\N	0	189708	0	23426006	4052083		
31863	2909	3035995	1962-04-07	1962-04-07 00:00:00	1962-04-07	5001	0	\N	0	0	\N	\N	0	193910	0	6768-6	3035995		
34753	3178	3006322	1958-12-04	1958-12-04 00:00:00	1958-12-04	5001	0	\N	0	0	\N	\N	0	211417	0	8331-1	3006322		
34792	3181	3011505	2008-09-19	2008-09-19 00:00:00	2008-09-19	5001	0	\N	0	0	\N	\N	0	211705	0	19926-5	3011505		
9181	292	4024958	2017-10-30	2017-10-30 00:00:00	2017-10-30	5001	0	\N	0	0	\N	\N	0	19462	0	117015009	4024958		
8604	823	3011505	2014-01-06	2014-01-06 00:00:00	2014-01-06	5001	0	\N	0	0	\N	\N	0	54526	0	19926-5	3011505		
46297	4261	40758406	1957-04-27	1957-04-27 00:00:00	1957-04-27	5001	0	\N	0	0	\N	\N	0	282887	0	55277-8	40758406		
20333	1867	3006322	1985-01-01	1985-01-01 00:00:00	1985-01-01	5001	0	\N	0	0	\N	\N	0	124704	0	8331-1	3006322		
10465	1015	3051031	2018-04-03	2018-04-03 00:00:00	2018-04-03	5001	0	\N	0	0	\N	\N	0	66839	0	46240-8	3051031		
101740	3125	4052083	1967-08-20	1967-08-20 00:00:00	1967-08-20	5001	0	\N	0	0	\N	\N	0	207925	0	23426006	4052083		
7456	711	3024561	1967-01-29	1967-01-29 00:00:00	1967-01-29	5001	0	\N	0	0	\N	\N	0	47196	0	1751-7	3024561		
258	9	3023430	1991-07-25	1991-07-25 00:00:00	1991-07-25	5001	0	\N	0	0	\N	\N	0	837	0	6833-8	3023430		
20991	1946	3049273	2008-10-23	2008-10-23 00:00:00	2008-10-23	5001	0	\N	0	0	\N	\N	0	129278	0	38265-5	3049273		
54719	5004	3001247	1990-03-13	1990-03-13 00:00:00	1990-03-13	5001	0	\N	0	0	\N	\N	0	332871	0	6085-5	3001247		
19175	1760	3006322	1993-03-19	1993-03-19 00:00:00	1993-03-19	5001	0	\N	0	0	\N	\N	0	117693	0	8331-1	3006322		
54486	4977	3006322	1971-07-31	1971-07-31 00:00:00	1971-07-31	5001	0	\N	0	0	\N	\N	0	331197	0	8331-1	3006322		
1572	137	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	9127	0	6246-3	3021226		
12909	1227	3006322	2013-02-19	2013-02-19 00:00:00	2013-02-19	5001	0	\N	0	0	\N	\N	0	80806	0	8331-1	3006322		
53221	4890	40769179	1946-11-23	1946-11-23 00:00:00	1946-11-23	5001	0	\N	0	0	\N	\N	0	325181	0	66519-0	40769179		
3787	358	3006322	2009-03-23	2009-03-23 00:00:00	2009-03-23	5001	0	\N	0	0	\N	\N	0	23854	0	8331-1	3006322		
13337	1265	3023430	1983-06-08	1983-06-08 00:00:00	1983-06-08	5001	0	\N	0	0	\N	\N	0	83401	0	6833-8	3023430		
33685	3060	3049273	2012-03-29	2012-03-29 00:00:00	2012-03-29	5001	0	\N	0	0	\N	\N	0	203631	0	38265-5	3049273		
41286	3852	3027231	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	255735	0	6276-0	3027231		
46938	4320	3015632	1970-05-14	1970-05-14 00:00:00	1970-05-14	5001	0	\N	0	0	\N	\N	0	286692	0	2028-9	3015632		
123759	3820	4024958	1992-05-21	1992-05-21 00:00:00	1992-05-21	5001	0	\N	0	0	\N	\N	0	253617	0	117015009	4024958		
4035	403	3006322	1940-05-18	1940-05-18 00:00:00	1940-05-18	5001	0	\N	0	0	\N	\N	0	26491	0	8331-1	3006322		
98261	3007	4024958	1977-02-09	1977-02-09 00:00:00	1977-02-09	5001	0	\N	0	0	\N	\N	0	200586	0	117015009	4024958		
64575	1980	4052083	1975-07-07	1975-07-07 00:00:00	1975-07-07	5001	0	\N	0	0	\N	\N	0	131823	0	23426006	4052083		
56600	1727	4133840	2017-11-29	2017-11-29 00:00:00	2017-11-29	5001	0	\N	0	0	\N	\N	0	115480	0	127783003	4133840		
35172	3215	40769194	2002-10-08	2002-10-08 00:00:00	2002-10-08	5001	0	\N	0	0	\N	\N	0	213564	0	66534-9	40769194		
84593	2621	4052083	2004-01-26	2004-01-26 00:00:00	2004-01-26	5001	0	\N	0	0	\N	\N	0	173394	0	23426006	4052083		
45998	4240	3006322	1950-07-10	1950-07-10 00:00:00	1950-07-10	5001	0	\N	0	0	\N	\N	0	281664	0	8331-1	3006322		
36030	3313	3006322	1956-07-17	1956-07-17 00:00:00	1956-07-17	5001	0	\N	0	0	\N	\N	0	219985	0	8331-1	3006322		
93729	2886	4024958	1959-12-28	1959-12-28 00:00:00	1959-12-28	5001	0	\N	0	0	\N	\N	0	191955	0	117015009	4024958		
3735	354	3011505	2016-03-03	2016-03-03 00:00:00	2016-03-03	5001	0	\N	0	0	\N	\N	0	23569	0	19926-5	3011505		
142444	4376	4133840	1995-10-03	1995-10-03 00:00:00	1995-10-03	5001	0	\N	0	0	\N	\N	0	290807	0	127783003	4133840		
30061	2767	3019550	1939-05-23	1939-05-23 00:00:00	1939-05-23	5001	0	\N	0	0	\N	\N	0	183063	0	2951-2	3019550		
24268	2238	3012494	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	148967	0	6206-7	3012494		
52526	4826	3027231	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	321004	0	6276-0	3027231		
52578	4827	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	321224	0	7258-7	3001488		
4539	442	3000876	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	29296	0	6082-2	3000876		
2738	266	3006322	1999-04-22	1999-04-22 00:00:00	1999-04-22	5001	0	\N	0	0	\N	\N	0	17659	0	8331-1	3006322		
2010	183	3006322	1996-11-26	1996-11-26 00:00:00	1996-11-26	5001	0	\N	0	0	\N	\N	0	12338	0	8331-1	3006322		
76513	2346	4052083	1983-05-14	1983-05-14 00:00:00	1983-05-14	5001	0	\N	0	0	\N	\N	0	156211	0	23426006	4052083		
16287	1482	3006451	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	98836	0	6273-7	3006451		
1018	84	3006322	2008-09-03	2008-09-03 00:00:00	2008-09-03	5001	0	\N	0	0	\N	\N	0	5657	0	8331-1	3006322		
9287	877	3001488	1978-06-07	1978-06-07 00:00:00	1978-06-07	5001	0	\N	0	0	\N	\N	0	58348	0	7258-7	3001488		
38917	3598	3006322	1979-10-04	1979-10-04 00:00:00	1979-10-04	5001	0	\N	0	0	\N	\N	0	238966	0	8331-1	3006322		
92654	2857	4024958	1992-11-15	1992-11-15 00:00:00	1992-11-15	5001	0	\N	0	0	\N	\N	0	189712	0	117015009	4024958		
31864	2909	3006906	1962-04-07	1962-04-07 00:00:00	1962-04-07	5001	0	\N	0	0	\N	\N	0	193910	0	17861-6	3006906		
34754	3178	3006322	1961-12-28	1961-12-28 00:00:00	1961-12-28	5001	0	\N	0	0	\N	\N	0	211404	0	8331-1	3006322		
34793	3181	3011505	2004-07-09	2004-07-09 00:00:00	2004-07-09	5001	0	\N	0	0	\N	\N	0	211831	0	19926-5	3011505		
9183	292	4024958	1984-08-28	1984-08-28 00:00:00	1984-08-28	5001	0	\N	0	0	\N	\N	0	19468	0	117015009	4024958		
8605	823	3011505	2012-12-31	2012-12-31 00:00:00	2012-12-31	5001	0	\N	0	0	\N	\N	0	54582	0	19926-5	3011505		
46298	4261	46235214	1926-06-09	1926-06-09 00:00:00	1926-06-09	5001	0	\N	0	0	\N	\N	0	282855	0	76690-7	46235214		
20384	1870	3006322	1924-10-26	1924-10-26 00:00:00	1924-10-26	5001	0	\N	0	0	\N	\N	0	124923	0	8331-1	3006322		
10467	1015	40766240	2018-04-03	2018-04-03 00:00:00	2018-04-03	5001	0	\N	0	0	\N	\N	0	66839	0	63513-6	40766240		
101741	3125	4024958	1969-06-12	1969-06-12 00:00:00	1969-06-12	5001	0	\N	0	0	\N	\N	0	207927	0	117015009	4024958		
7457	711	3016723	1967-01-29	1967-01-29 00:00:00	1967-01-29	5001	0	\N	0	0	\N	\N	0	47196	0	2160-0	3016723		
259	9	3036780	1991-07-25	1991-07-25 00:00:00	1991-07-25	5001	0	\N	0	0	\N	\N	0	837	0	6095-4	3036780		
20992	1946	3049273	1997-05-24	1997-05-24 00:00:00	1997-05-24	5001	0	\N	0	0	\N	\N	0	129277	0	38265-5	3049273		
54720	5004	3005136	1990-03-13	1990-03-13 00:00:00	1990-03-13	5001	0	\N	0	0	\N	\N	0	332871	0	6075-6	3005136		
19176	1761	3006322	1959-04-10	1959-04-10 00:00:00	1959-04-10	5001	0	\N	0	0	\N	\N	0	117786	0	8331-1	3006322		
54487	4977	3006322	2004-11-06	2004-11-06 00:00:00	2004-11-06	5001	0	\N	0	0	\N	\N	0	331126	0	8331-1	3006322		
1573	137	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	9127	0	6075-6	3005136		
12910	1227	3051031	1958-03-18	1958-03-18 00:00:00	1958-03-18	5001	0	\N	0	0	\N	\N	0	80846	0	46240-8	3051031		
39681	1232	4024958	1983-05-27	1983-05-27 00:00:00	1983-05-27	5001	0	\N	0	0	\N	\N	0	81219	0	117015009	4024958		
3788	359	3006322	1978-09-18	1978-09-18 00:00:00	1978-09-18	5001	0	\N	0	0	\N	\N	0	23873	0	8331-1	3006322		
13338	1265	3001247	1983-06-08	1983-06-08 00:00:00	1983-06-08	5001	0	\N	0	0	\N	\N	0	83401	0	6085-5	3001247		
56915	5222	3011505	2006-02-23	2006-02-23 00:00:00	2006-02-23	5001	0	\N	0	0	\N	\N	0	347467	0	19926-5	3011505		
41287	3852	3012494	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	255735	0	6206-7	3012494		
46939	4320	3007461	1970-05-14	1970-05-14 00:00:00	1970-05-14	5001	0	\N	0	0	\N	\N	0	286692	0	26515-7	3007461		
123765	3820	4024958	1968-11-10	1968-11-10 00:00:00	1968-11-10	5001	0	\N	0	0	\N	\N	0	253658	0	117015009	4024958		
4036	403	3006322	2004-02-07	2004-02-07 00:00:00	2004-02-07	5001	0	\N	0	0	\N	\N	0	26501	0	8331-1	3006322		
7127	225	4024958	2013-09-25	2013-09-25 00:00:00	2013-09-25	5001	0	\N	0	0	\N	\N	0	15199	0	117015009	4024958		
36968	1144	4052083	1981-06-10	1981-06-10 00:00:00	1981-06-10	5001	0	\N	0	0	\N	\N	0	75518	0	23426006	4052083		
56603	1727	4133840	2002-04-18	2002-04-18 00:00:00	2002-04-18	5001	0	\N	0	0	\N	\N	0	115417	0	127783003	4133840		
35173	3215	40769184	2002-10-08	2002-10-08 00:00:00	2002-10-08	5001	0	\N	0	0	\N	\N	0	213564	0	66524-0	40769184		
84596	2621	4024958	1999-04-08	1999-04-08 00:00:00	1999-04-08	5001	0	\N	0	0	\N	\N	0	173393	0	117015009	4024958		
46000	4240	3006322	2011-12-20	2011-12-20 00:00:00	2011-12-20	5001	0	\N	0	0	\N	\N	0	281637	0	8331-1	3006322		
36031	3314	3006322	1989-06-24	1989-06-24 00:00:00	1989-06-24	5001	0	\N	0	0	\N	\N	0	220077	0	8331-1	3006322		
58052	5322	40769179	1947-03-02	1947-03-02 00:00:00	1947-03-02	5001	0	\N	0	0	\N	\N	0	354070	0	66519-0	40769179		
3736	354	3011505	2018-03-15	2018-03-15 00:00:00	2018-03-15	5001	0	\N	0	0	\N	\N	0	23579	0	19926-5	3011505		
142447	4376	4133840	2005-11-29	2005-11-29 00:00:00	2005-11-29	5001	0	\N	0	0	\N	\N	0	290838	0	127783003	4133840		
30062	2767	3000963	1939-05-23	1939-05-23 00:00:00	1939-05-23	5001	0	\N	0	0	\N	\N	0	183063	0	718-7	3000963		
24269	2238	3014599	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	148967	0	6106-9	3014599		
52527	4826	3014599	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	321004	0	6106-9	3014599		
52579	4827	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	321224	0	6095-4	3036780		
4540	442	3015076	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	29296	0	6248-9	3015076		
2739	268	3006322	2004-12-04	2004-12-04 00:00:00	2004-12-04	5001	0	\N	0	0	\N	\N	0	17782	0	8331-1	3006322		
2011	183	3006322	1978-05-23	1978-05-23 00:00:00	1978-05-23	5001	0	\N	0	0	\N	\N	0	12370	0	8331-1	3006322		
76514	2346	4024958	2019-02-13	2019-02-13 00:00:00	2019-02-13	5001	0	\N	0	0	\N	\N	0	156172	0	117015009	4024958		
16288	1482	3019406	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	98836	0	6158-0	3019406		
1019	84	3006322	1974-06-28	1974-06-28 00:00:00	1974-06-28	5001	0	\N	0	0	\N	\N	0	5649	0	8331-1	3006322		
9288	877	3006322	1992-07-15	1992-07-15 00:00:00	1992-07-15	5001	0	\N	0	0	\N	\N	0	58430	0	8331-1	3006322		
38918	3598	3006322	1984-07-19	1984-07-19 00:00:00	1984-07-19	5001	0	\N	0	0	\N	\N	0	238931	0	8331-1	3006322		
92665	2857	4052083	1984-11-27	1984-11-27 00:00:00	1984-11-27	5001	0	\N	0	0	\N	\N	0	189686	0	23426006	4052083		
31865	2909	3026361	1962-04-07	1962-04-07 00:00:00	1962-04-07	5001	0	\N	0	0	\N	\N	0	193910	0	26453-1	3026361		
34755	3178	3006322	2003-05-03	2003-05-03 00:00:00	2003-05-03	5001	0	\N	0	0	\N	\N	0	211421	0	8331-1	3006322		
34794	3181	3011505	2016-11-04	2016-11-04 00:00:00	2016-11-04	5001	0	\N	0	0	\N	\N	0	211711	0	19926-5	3011505		
9209	293	4052083	1983-08-22	1983-08-22 00:00:00	1983-08-22	5001	0	\N	0	0	\N	\N	0	19534	0	23426006	4052083		
8606	823	3006322	1954-12-22	1954-12-22 00:00:00	1954-12-22	5001	0	\N	0	0	\N	\N	0	54585	0	8331-1	3006322		
46301	4261	3051031	1926-06-09	1926-06-09 00:00:00	1926-06-09	5001	0	\N	0	0	\N	\N	0	282855	0	46240-8	3051031		
20385	1870	3006322	1925-05-04	1925-05-04 00:00:00	1925-05-04	5001	0	\N	0	0	\N	\N	0	124915	0	8331-1	3006322		
10468	1015	46235214	2018-04-03	2018-04-03 00:00:00	2018-04-03	5001	0	\N	0	0	\N	\N	0	66839	0	76690-7	46235214		
172941	5309	4024958	1980-01-21	1980-01-21 00:00:00	1980-01-21	5001	0	\N	0	0	\N	\N	0	353072	0	117015009	4024958		
7458	711	3013721	1967-01-29	1967-01-29 00:00:00	1967-01-29	5001	0	\N	0	0	\N	\N	0	47196	0	1920-8	3013721		
260	9	3006734	1991-07-25	1991-07-25 00:00:00	1991-07-25	5001	0	\N	0	0	\N	\N	0	837	0	6189-5	3006734		
20993	1946	3006322	1973-01-16	1973-01-16 00:00:00	1973-01-16	5001	0	\N	0	0	\N	\N	0	129273	0	8331-1	3006322		
31645	971	4052083	2010-01-26	2010-01-26 00:00:00	2010-01-26	5001	0	\N	0	0	\N	\N	0	64587	0	23426006	4052083		
19177	1761	3006322	1958-06-07	1958-06-07 00:00:00	1958-06-07	5001	0	\N	0	0	\N	\N	0	117768	0	8331-1	3006322		
54488	4977	3006322	1990-09-02	1990-09-02 00:00:00	1990-09-02	5001	0	\N	0	0	\N	\N	0	331189	0	8331-1	3006322		
1574	137	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	9127	0	6158-0	3019406		
12912	1227	40766240	1958-03-18	1958-03-18 00:00:00	1958-03-18	5001	0	\N	0	0	\N	\N	0	80846	0	63513-6	40766240		
39683	1232	4052083	1991-10-04	1991-10-04 00:00:00	1991-10-04	5001	0	\N	0	0	\N	\N	0	81220	0	23426006	4052083		
3789	359	3006322	1982-07-13	1982-07-13 00:00:00	1982-07-13	5001	0	\N	0	0	\N	\N	0	23887	0	8331-1	3006322		
13339	1265	3015076	1983-06-08	1983-06-08 00:00:00	1983-06-08	5001	0	\N	0	0	\N	\N	0	83401	0	6248-9	3015076		
56916	5222	3011505	2011-03-24	2011-03-24 00:00:00	2011-03-24	5001	0	\N	0	0	\N	\N	0	347424	0	19926-5	3011505		
41288	3852	3000876	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	255735	0	6082-2	3000876		
46940	4320	3045716	1970-05-14	1970-05-14 00:00:00	1970-05-14	5001	0	\N	0	0	\N	\N	0	286692	0	33037-3	3045716		
123767	3820	4052083	2015-12-11	2015-12-11 00:00:00	2015-12-11	5001	0	\N	0	0	\N	\N	0	253615	0	23426006	4052083		
4037	403	3049273	1988-08-14	1988-08-14 00:00:00	1988-08-14	5001	0	\N	0	0	\N	\N	0	26464	0	38265-5	3049273		
64448	1977	4052083	1926-11-07	1926-11-07 00:00:00	1926-11-07	5001	0	\N	0	0	\N	\N	0	131556	0	23426006	4052083		
36972	1144	4052083	1999-06-27	1999-06-27 00:00:00	1999-06-27	5001	0	\N	0	0	\N	\N	0	75517	0	23426006	4052083		
56605	1727	4133840	2006-09-28	2006-09-28 00:00:00	2006-09-28	5001	0	\N	0	0	\N	\N	0	115478	0	127783003	4133840		
35174	3215	3015076	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	213667	0	6248-9	3015076		
84604	2621	4052083	1966-11-03	1966-11-03 00:00:00	1966-11-03	5001	0	\N	0	0	\N	\N	0	173339	0	23426006	4052083		
46001	4240	3006322	1982-03-10	1982-03-10 00:00:00	1982-03-10	5001	0	\N	0	0	\N	\N	0	281677	0	8331-1	3006322		
36032	3314	3006322	1990-09-04	1990-09-04 00:00:00	1990-09-04	5001	0	\N	0	0	\N	\N	0	220119	0	8331-1	3006322		
58053	5322	40769189	1947-03-02	1947-03-02 00:00:00	1947-03-02	5001	0	\N	0	0	\N	\N	0	354070	0	66529-9	40769189		
3737	354	3011505	2011-02-03	2011-02-03 00:00:00	2011-02-03	5001	0	\N	0	0	\N	\N	0	23578	0	19926-5	3011505		
142450	4376	4024958	1971-09-27	1971-09-27 00:00:00	1971-09-27	5001	0	\N	0	0	\N	\N	0	290737	0	117015009	4024958		
30063	2767	3026361	1939-05-23	1939-05-23 00:00:00	1939-05-23	5001	0	\N	0	0	\N	\N	0	183063	0	26453-1	3026361		
24270	2238	3001488	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	148967	0	7258-7	3001488		
52528	4826	3019406	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	321004	0	6158-0	3019406		
52580	4827	3006322	1992-11-07	1992-11-07 00:00:00	1992-11-07	5001	0	\N	0	0	\N	\N	0	321173	0	8331-1	3006322		
4541	442	3012494	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	29296	0	6206-7	3012494		
2740	268	3006322	1979-07-06	1979-07-06 00:00:00	1979-07-06	5001	0	\N	0	0	\N	\N	0	17833	0	8331-1	3006322		
2012	183	3006322	1988-07-27	1988-07-27 00:00:00	1988-07-27	5001	0	\N	0	0	\N	\N	0	12409	0	8331-1	3006322		
76521	2346	4052083	1953-09-26	1953-09-26 00:00:00	1953-09-26	5001	0	\N	0	0	\N	\N	0	156149	0	23426006	4052083		
16289	1482	3021226	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	98836	0	6246-3	3021226		
1020	84	3006322	1999-07-10	1999-07-10 00:00:00	1999-07-10	5001	0	\N	0	0	\N	\N	0	5653	0	8331-1	3006322		
9289	877	3006322	2004-06-07	2004-06-07 00:00:00	2004-06-07	5001	0	\N	0	0	\N	\N	0	58410	0	8331-1	3006322		
38919	3598	3006322	1977-06-02	1977-06-02 00:00:00	1977-06-02	5001	0	\N	0	0	\N	\N	0	238924	0	8331-1	3006322		
127142	3913	4052083	1982-07-14	1982-07-14 00:00:00	1982-07-14	5001	0	\N	0	0	\N	\N	0	260079	0	23426006	4052083		
31866	2909	3019550	1962-04-07	1962-04-07 00:00:00	1962-04-07	5001	0	\N	0	0	\N	\N	0	193910	0	2951-2	3019550		
34756	3179	40758406	1948-01-23	1948-01-23 00:00:00	1948-01-23	5001	0	\N	0	0	\N	\N	0	211504	0	55277-8	40758406		
34795	3181	3011505	2013-10-18	2013-10-18 00:00:00	2013-10-18	5001	0	\N	0	0	\N	\N	0	211717	0	19926-5	3011505		
9211	293	4052083	1975-01-20	1975-01-20 00:00:00	1975-01-20	5001	0	\N	0	0	\N	\N	0	19533	0	23426006	4052083		
8607	823	3011505	2010-12-20	2010-12-20 00:00:00	2010-12-20	5001	0	\N	0	0	\N	\N	0	54570	0	19926-5	3011505		
46302	4261	40766240	1926-06-09	1926-06-09 00:00:00	1926-06-09	5001	0	\N	0	0	\N	\N	0	282855	0	63513-6	40766240		
20386	1870	3006322	1939-09-30	1939-09-30 00:00:00	1939-09-30	5001	0	\N	0	0	\N	\N	0	124947	0	8331-1	3006322		
10470	1015	40758406	1987-01-16	1987-01-16 00:00:00	1987-01-16	5001	0	\N	0	0	\N	\N	0	66793	0	55277-8	40758406		
172972	5312	4133840	1996-12-16	1996-12-16 00:00:00	1996-12-16	5001	0	\N	0	0	\N	\N	0	353240	0	127783003	4133840		
7459	711	3027970	1967-01-29	1967-01-29 00:00:00	1967-01-29	5001	0	\N	0	0	\N	\N	0	47196	0	10834-0	3027970		
261	9	3001247	1991-07-25	1991-07-25 00:00:00	1991-07-25	5001	0	\N	0	0	\N	\N	0	837	0	6085-5	3001247		
20994	1946	3006322	1926-07-25	1926-07-25 00:00:00	1926-07-25	5001	0	\N	0	0	\N	\N	0	129256	0	8331-1	3006322		
31655	971	4024958	1966-11-29	1966-11-29 00:00:00	1966-11-29	5001	0	\N	0	0	\N	\N	0	64608	0	117015009	4024958		
19178	1761	3006322	1994-08-29	1994-08-29 00:00:00	1994-08-29	5001	0	\N	0	0	\N	\N	0	117790	0	8331-1	3006322		
54489	4977	3006322	2000-03-18	2000-03-18 00:00:00	2000-03-18	5001	0	\N	0	0	\N	\N	0	331193	0	8331-1	3006322		
1575	137	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	9127	0	6082-2	3000876		
12913	1227	40758406	1958-03-18	1958-03-18 00:00:00	1958-03-18	5001	0	\N	0	0	\N	\N	0	80846	0	55277-8	40758406		
39688	1232	4024958	2002-05-10	2002-05-10 00:00:00	2002-05-10	5001	0	\N	0	0	\N	\N	0	81203	0	117015009	4024958		
3790	359	3006322	2008-03-06	2008-03-06 00:00:00	2008-03-06	5001	0	\N	0	0	\N	\N	0	23870	0	8331-1	3006322		
13340	1265	3027231	1983-06-08	1983-06-08 00:00:00	1983-06-08	5001	0	\N	0	0	\N	\N	0	83401	0	6276-0	3027231		
56917	5222	3011505	2012-03-29	2012-03-29 00:00:00	2012-03-29	5001	0	\N	0	0	\N	\N	0	347350	0	19926-5	3011505		
41289	3852	3014599	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	255637	0	6106-9	3014599		
46941	4320	3023103	1970-05-14	1970-05-14 00:00:00	1970-05-14	5001	0	\N	0	0	\N	\N	0	286692	0	2823-3	3023103		
15758	492	4024958	1948-02-07	1948-02-07 00:00:00	1948-02-07	5001	0	\N	0	0	\N	\N	0	32935	0	117015009	4024958		
4038	404	3015076	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	26607	0	6248-9	3015076		
64455	1977	4052083	1984-12-18	1984-12-18 00:00:00	1984-12-18	5001	0	\N	0	0	\N	\N	0	131650	0	23426006	4052083		
36975	1144	4024958	2013-09-13	2013-09-13 00:00:00	2013-09-13	5001	0	\N	0	0	\N	\N	0	75501	0	117015009	4024958		
56609	1727	4133840	2012-11-01	2012-11-01 00:00:00	2012-11-01	5001	0	\N	0	0	\N	\N	0	115501	0	127783003	4133840		
35175	3215	3027231	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	213667	0	6276-0	3027231		
84611	2621	4024958	1957-01-24	1957-01-24 00:00:00	1957-01-24	5001	0	\N	0	0	\N	\N	0	173331	0	117015009	4024958		
46002	4240	3006322	1948-06-10	1948-06-10 00:00:00	1948-06-10	5001	0	\N	0	0	\N	\N	0	281669	0	8331-1	3006322		
36033	3314	3006322	1995-03-22	1995-03-22 00:00:00	1995-03-22	5001	0	\N	0	0	\N	\N	0	220121	0	8331-1	3006322		
58054	5322	40769184	1947-03-02	1947-03-02 00:00:00	1947-03-02	5001	0	\N	0	0	\N	\N	0	354070	0	66524-0	40769184		
3738	354	3011505	2004-01-29	2004-01-29 00:00:00	2004-01-29	5001	0	\N	0	0	\N	\N	0	23587	0	19926-5	3011505		
138792	4278	4133840	2000-07-07	2000-07-07 00:00:00	2000-07-07	5001	0	\N	0	0	\N	\N	0	283839	0	127783003	4133840		
30064	2767	3009542	1939-05-23	1939-05-23 00:00:00	1939-05-23	5001	0	\N	0	0	\N	\N	0	183063	0	20570-8	3009542		
24271	2238	3006734	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	148967	0	6189-5	3006734		
52529	4826	3006451	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	321004	0	6273-7	3006451		
52581	4827	3006322	2017-12-29	2017-12-29 00:00:00	2017-12-29	5001	0	\N	0	0	\N	\N	0	321129	0	8331-1	3006322		
4542	442	3001488	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	29296	0	7258-7	3001488		
2741	268	3006322	1969-10-12	1969-10-12 00:00:00	1969-10-12	5001	0	\N	0	0	\N	\N	0	17832	0	8331-1	3006322		
2013	183	3006322	1984-08-01	1984-08-01 00:00:00	1984-08-01	5001	0	\N	0	0	\N	\N	0	12408	0	8331-1	3006322		
76532	2346	4052083	1952-11-03	1952-11-03 00:00:00	1952-11-03	5001	0	\N	0	0	\N	\N	0	156125	0	23426006	4052083		
27567	2546	3051031	1983-06-24	1983-06-24 00:00:00	1983-06-24	5001	0	\N	0	0	\N	\N	0	168518	0	46240-8	3051031		
1021	84	3006322	1984-06-19	1984-06-19 00:00:00	1984-06-19	5001	0	\N	0	0	\N	\N	0	5667	0	8331-1	3006322		
9292	879	3006322	1995-12-23	1995-12-23 00:00:00	1995-12-23	5001	0	\N	0	0	\N	\N	0	58583	0	8331-1	3006322		
38920	3599	3006322	1979-10-10	1979-10-10 00:00:00	1979-10-10	5001	0	\N	0	0	\N	\N	0	239065	0	8331-1	3006322		
127145	3913	4024958	1979-06-24	1979-06-24 00:00:00	1979-06-24	5001	0	\N	0	0	\N	\N	0	260172	0	117015009	4024958		
31867	2909	3006923	1962-04-07	1962-04-07 00:00:00	1962-04-07	5001	0	\N	0	0	\N	\N	0	193910	0	1742-6	3006923		
34757	3179	46235214	1948-01-23	1948-01-23 00:00:00	1948-01-23	5001	0	\N	0	0	\N	\N	0	211504	0	76690-7	46235214		
34796	3181	3011505	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	211715	0	19926-5	3011505		
23245	727	4052083	1926-11-26	1926-11-26 00:00:00	1926-11-26	5001	0	\N	0	0	\N	\N	0	48142	0	23426006	4052083		
8608	823	3006322	2007-12-04	2007-12-04 00:00:00	2007-12-04	5001	0	\N	0	0	\N	\N	0	54514	0	8331-1	3006322		
46303	4261	40758406	1926-06-09	1926-06-09 00:00:00	1926-06-09	5001	0	\N	0	0	\N	\N	0	282855	0	55277-8	40758406		
20387	1870	3006322	1943-05-27	1943-05-27 00:00:00	1943-05-27	5001	0	\N	0	0	\N	\N	0	124918	0	8331-1	3006322		
12189	393	4052083	1998-09-06	1998-09-06 00:00:00	1998-09-06	5001	0	\N	0	0	\N	\N	0	25774	0	23426006	4052083		
172973	5312	4133840	1986-12-08	1986-12-08 00:00:00	1986-12-08	5001	0	\N	0	0	\N	\N	0	353259	0	127783003	4133840		
7460	711	3028833	1967-01-29	1967-01-29 00:00:00	1967-01-29	5001	0	\N	0	0	\N	\N	0	47196	0	42719-5	3028833		
262	9	3001488	1991-07-25	1991-07-25 00:00:00	1991-07-25	5001	0	\N	0	0	\N	\N	0	837	0	7258-7	3001488		
20995	1947	3006322	1956-06-17	1956-06-17 00:00:00	1956-06-17	5001	0	\N	0	0	\N	\N	0	129432	0	8331-1	3006322		
31662	972	4024958	1987-08-11	1987-08-11 00:00:00	1987-08-11	5001	0	\N	0	0	\N	\N	0	64721	0	117015009	4024958		
19179	1761	3006322	1996-07-01	1996-07-01 00:00:00	1996-07-01	5001	0	\N	0	0	\N	\N	0	117791	0	8331-1	3006322		
54490	4977	3006322	1981-06-24	1981-06-24 00:00:00	1981-06-24	5001	0	\N	0	0	\N	\N	0	331124	0	8331-1	3006322		
1576	137	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	9127	0	6106-9	3014599		
12915	1227	46235214	1958-03-18	1958-03-18 00:00:00	1958-03-18	5001	0	\N	0	0	\N	\N	0	80846	0	76690-7	46235214		
39697	1232	4024958	2001-09-28	2001-09-28 00:00:00	2001-09-28	5001	0	\N	0	0	\N	\N	0	81222	0	117015009	4024958		
3791	359	3006322	1990-06-12	1990-06-12 00:00:00	1990-06-12	5001	0	\N	0	0	\N	\N	0	23874	0	8331-1	3006322		
13341	1265	3014599	1983-06-08	1983-06-08 00:00:00	1983-06-08	5001	0	\N	0	0	\N	\N	0	83401	0	6106-9	3014599		
56918	5222	40769179	1946-07-24	1946-07-24 00:00:00	1946-07-24	5001	0	\N	0	0	\N	\N	0	347353	0	66519-0	40769179		
41290	3852	3005136	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	255637	0	6075-6	3005136		
23508	2168	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	144562	0	6206-7	3012494		
15781	492	4024958	1954-03-18	1954-03-18 00:00:00	1954-03-18	5001	0	\N	0	0	\N	\N	0	32979	0	117015009	4024958		
4039	404	3027231	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	26607	0	6276-0	3027231		
64459	1977	4052083	2007-04-13	2007-04-13 00:00:00	2007-04-13	5001	0	\N	0	0	\N	\N	0	131603	0	23426006	4052083		
56623	1727	4133840	2008-10-09	2008-10-09 00:00:00	2008-10-09	5001	0	\N	0	0	\N	\N	0	115499	0	127783003	4133840		
35176	3215	3019406	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	213667	0	6158-0	3019406		
84622	2621	4052083	1984-07-12	1984-07-12 00:00:00	1984-07-12	5001	0	\N	0	0	\N	\N	0	173381	0	23426006	4052083		
46003	4240	3006322	2003-09-01	2003-09-01 00:00:00	2003-09-01	5001	0	\N	0	0	\N	\N	0	281673	0	8331-1	3006322		
36034	3314	3006322	2010-10-26	2010-10-26 00:00:00	2010-10-26	5001	0	\N	0	0	\N	\N	0	220068	0	8331-1	3006322		
58055	5322	40769194	1947-03-02	1947-03-02 00:00:00	1947-03-02	5001	0	\N	0	0	\N	\N	0	354070	0	66534-9	40769194		
3739	354	3011505	2002-01-24	2002-01-24 00:00:00	2002-01-24	5001	0	\N	0	0	\N	\N	0	23591	0	19926-5	3011505		
138796	4278	4133840	1986-10-31	1986-10-31 00:00:00	1986-10-31	5001	0	\N	0	0	\N	\N	0	283925	0	127783003	4133840		
30065	2767	3013721	1939-05-23	1939-05-23 00:00:00	1939-05-23	5001	0	\N	0	0	\N	\N	0	183063	0	1920-8	3013721		
24272	2238	3001247	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	148967	0	6085-5	3001247		
52530	4826	3012494	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	321004	0	6206-7	3012494		
52582	4827	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	321161	0	6248-9	3015076		
4543	442	3023430	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	29296	0	6833-8	3023430		
2742	268	3006322	2007-08-03	2007-08-03 00:00:00	2007-08-03	5001	0	\N	0	0	\N	\N	0	17780	0	8331-1	3006322		
2014	184	3006322	2012-08-19	2012-08-19 00:00:00	2012-08-19	5001	0	\N	0	0	\N	\N	0	12476	0	8331-1	3006322		
76543	2346	4024958	1953-07-12	1953-07-12 00:00:00	1953-07-12	5001	0	\N	0	0	\N	\N	0	156166	0	117015009	4024958		
27568	2546	40766240	1983-06-24	1983-06-24 00:00:00	1983-06-24	5001	0	\N	0	0	\N	\N	0	168518	0	63513-6	40766240		
88637	2745	4024958	1988-11-04	1988-11-04 00:00:00	1988-11-04	5001	0	\N	0	0	\N	\N	0	181564	0	117015009	4024958		
2427	74	4024958	1981-03-19	1981-03-19 00:00:00	1981-03-19	5001	0	\N	0	0	\N	\N	0	5011	0	117015009	4024958		
38921	3599	3006322	1966-07-06	1966-07-06 00:00:00	1966-07-06	5001	0	\N	0	0	\N	\N	0	239031	0	8331-1	3006322		
127166	3913	4052083	1972-01-01	1972-01-01 00:00:00	1972-01-01	5001	0	\N	0	0	\N	\N	0	260171	0	23426006	4052083		
31868	2909	3024731	1962-04-07	1962-04-07 00:00:00	1962-04-07	5001	0	\N	0	0	\N	\N	0	193910	0	30428-7	3024731		
34759	3179	3051031	1948-01-23	1948-01-23 00:00:00	1948-01-23	5001	0	\N	0	0	\N	\N	0	211504	0	46240-8	3051031		
34797	3181	3011505	2011-10-07	2011-10-07 00:00:00	2011-10-07	5001	0	\N	0	0	\N	\N	0	211716	0	19926-5	3011505		
23251	727	4024958	1916-11-11	1916-11-11 00:00:00	1916-11-11	5001	0	\N	0	0	\N	\N	0	48238	0	117015009	4024958		
8609	823	3006322	2009-12-08	2009-12-08 00:00:00	2009-12-08	5001	0	\N	0	0	\N	\N	0	54552	0	8331-1	3006322		
46304	4261	46235214	1956-08-30	1956-08-30 00:00:00	1956-08-30	5001	0	\N	0	0	\N	\N	0	282973	0	76690-7	46235214		
158249	4861	4024958	1985-04-21	1985-04-21 00:00:00	1985-04-21	5001	0	\N	0	0	\N	\N	0	323423	0	117015009	4024958		
12203	394	4052083	1997-01-28	1997-01-28 00:00:00	1997-01-28	5001	0	\N	0	0	\N	\N	0	25839	0	23426006	4052083		
172975	5312	4052083	1998-12-04	1998-12-04 00:00:00	1998-12-04	5001	0	\N	0	0	\N	\N	0	353294	0	23426006	4052083		
7461	711	3009542	1967-01-29	1967-01-29 00:00:00	1967-01-29	5001	0	\N	0	0	\N	\N	0	47196	0	20570-8	3009542		
263	9	3000876	1991-07-25	1991-07-25 00:00:00	1991-07-25	5001	0	\N	0	0	\N	\N	0	837	0	6082-2	3000876		
20996	1947	3006322	2017-01-03	2017-01-03 00:00:00	2017-01-03	5001	0	\N	0	0	\N	\N	0	129476	0	8331-1	3006322		
31672	972	4024958	1999-07-04	1999-07-04 00:00:00	1999-07-04	5001	0	\N	0	0	\N	\N	0	64708	0	117015009	4024958		
19180	1761	3006322	1958-02-25	1958-02-25 00:00:00	1958-02-25	5001	0	\N	0	0	\N	\N	0	117703	0	8331-1	3006322		
54491	4977	3006322	1970-04-29	1970-04-29 00:00:00	1970-04-29	5001	0	\N	0	0	\N	\N	0	331122	0	8331-1	3006322		
1579	140	3006322	1974-06-30	1974-06-30 00:00:00	1974-06-30	5001	0	\N	0	0	\N	\N	0	9352	0	8331-1	3006322		
12916	1227	3006322	2000-05-02	2000-05-02 00:00:00	2000-05-02	5001	0	\N	0	0	\N	\N	0	80734	0	8331-1	3006322		
77942	2392	4133840	1969-02-14	1969-02-14 00:00:00	1969-02-14	5001	0	\N	0	0	\N	\N	0	159054	0	127783003	4133840		
3792	359	3006322	1992-02-15	1992-02-15 00:00:00	1992-02-15	5001	0	\N	0	0	\N	\N	0	23867	0	8331-1	3006322		
13342	1265	3019406	1983-06-08	1983-06-08 00:00:00	1983-06-08	5001	0	\N	0	0	\N	\N	0	83401	0	6158-0	3019406		
56919	5222	40769189	1946-07-24	1946-07-24 00:00:00	1946-07-24	5001	0	\N	0	0	\N	\N	0	347353	0	66529-9	40769189		
41291	3852	3019406	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	255637	0	6158-0	3019406		
23509	2168	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	144562	0	6082-2	3000876		
15802	495	4024958	1979-07-25	1979-07-25 00:00:00	1979-07-25	5001	0	\N	0	0	\N	\N	0	33040	0	117015009	4024958		
4040	404	3006451	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	26607	0	6273-7	3006451		
64460	1977	4024958	1921-12-10	1921-12-10 00:00:00	1921-12-10	5001	0	\N	0	0	\N	\N	0	131555	0	117015009	4024958		
56627	1727	4133840	2009-10-15	2009-10-15 00:00:00	2009-10-15	5001	0	\N	0	0	\N	\N	0	115457	0	127783003	4133840		
35177	3215	3001247	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	213667	0	6085-5	3001247		
84624	2621	4052083	1986-01-29	1986-01-29 00:00:00	1986-01-29	5001	0	\N	0	0	\N	\N	0	173382	0	23426006	4052083		
57282	5262	3006322	2008-07-05	2008-07-05 00:00:00	2008-07-05	5001	0	\N	0	0	\N	\N	0	350079	0	8331-1	3006322		
36035	3314	3006322	1970-07-10	1970-07-10 00:00:00	1970-07-10	5001	0	\N	0	0	\N	\N	0	220073	0	8331-1	3006322		
58056	5322	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	354184	0	6844-5	3020655		
3740	354	3011505	1996-01-05	1996-01-05 00:00:00	1996-01-05	5001	0	\N	0	0	\N	\N	0	23586	0	19926-5	3011505		
138798	4278	4133840	2006-09-29	2006-09-29 00:00:00	2006-09-29	5001	0	\N	0	0	\N	\N	0	283929	0	127783003	4133840		
30066	2767	3028833	1939-05-23	1939-05-23 00:00:00	1939-05-23	5001	0	\N	0	0	\N	\N	0	183063	0	42719-5	3028833		
24273	2238	3023430	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	148967	0	6833-8	3023430		
52531	4826	3006734	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	321004	0	6189-5	3006734		
52583	4827	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	321161	0	6276-0	3027231		
4544	442	3020655	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	29296	0	6844-5	3020655		
120347	3714	4052083	1985-10-03	1985-10-03 00:00:00	1985-10-03	5001	0	\N	0	0	\N	\N	0	246792	0	23426006	4052083		
2015	184	3006322	1949-04-14	1949-04-14 00:00:00	1949-04-14	5001	0	\N	0	0	\N	\N	0	12428	0	8331-1	3006322		
76546	2346	4024958	1959-09-05	1959-09-05 00:00:00	1959-09-05	5001	0	\N	0	0	\N	\N	0	156167	0	117015009	4024958		
27569	2546	40758406	1983-06-24	1983-06-24 00:00:00	1983-06-24	5001	0	\N	0	0	\N	\N	0	168518	0	55277-8	40758406		
88638	2745	4024958	2004-11-02	2004-11-02 00:00:00	2004-11-02	5001	0	\N	0	0	\N	\N	0	181588	0	117015009	4024958		
2432	74	4024958	1989-01-29	1989-01-29 00:00:00	1989-01-29	5001	0	\N	0	0	\N	\N	0	5012	0	117015009	4024958		
38924	3601	3006322	1992-10-11	1992-10-11 00:00:00	1992-10-11	5001	0	\N	0	0	\N	\N	0	239145	0	8331-1	3006322		
37112	3414	3006322	2015-01-06	2015-01-06 00:00:00	2015-01-06	5001	0	\N	0	0	\N	\N	0	226491	0	8331-1	3006322		
31869	2909	3010813	1962-04-07	1962-04-07 00:00:00	1962-04-07	5001	0	\N	0	0	\N	\N	0	193910	0	26464-8	3010813		
34760	3179	40766240	1948-01-23	1948-01-23 00:00:00	1948-01-23	5001	0	\N	0	0	\N	\N	0	211504	0	63513-6	40766240		
34798	3181	3011505	2010-10-01	2010-10-01 00:00:00	2010-10-01	5001	0	\N	0	0	\N	\N	0	211832	0	19926-5	3011505		
23254	727	4052083	1917-04-10	1917-04-10 00:00:00	1917-04-10	5001	0	\N	0	0	\N	\N	0	48174	0	23426006	4052083		
8610	823	3011505	2008-12-15	2008-12-15 00:00:00	2008-12-15	5001	0	\N	0	0	\N	\N	0	54525	0	19926-5	3011505		
46307	4261	40766240	1956-08-30	1956-08-30 00:00:00	1956-08-30	5001	0	\N	0	0	\N	\N	0	282973	0	63513-6	40766240		
158280	4865	4024958	1991-08-12	1991-08-12 00:00:00	1991-08-12	5001	0	\N	0	0	\N	\N	0	323506	0	117015009	4024958		
12230	394	4024958	1966-01-23	1966-01-23 00:00:00	1966-01-23	5001	0	\N	0	0	\N	\N	0	25888	0	117015009	4024958		
172984	5312	4133840	1993-11-29	1993-11-29 00:00:00	1993-11-29	5001	0	\N	0	0	\N	\N	0	353268	0	127783003	4133840		
7462	712	46235214	2010-12-28	2010-12-28 00:00:00	2010-12-28	5001	0	\N	0	0	\N	\N	0	47226	0	76690-7	46235214		
264	9	3020655	1991-07-25	1991-07-25 00:00:00	1991-07-25	5001	0	\N	0	0	\N	\N	0	837	0	6844-5	3020655		
20997	1947	3006322	1998-03-30	1998-03-30 00:00:00	1998-03-30	5001	0	\N	0	0	\N	\N	0	129474	0	8331-1	3006322		
31678	972	4024958	2012-03-07	2012-03-07 00:00:00	2012-03-07	5001	0	\N	0	0	\N	\N	0	64709	0	117015009	4024958		
19181	1761	3049273	2014-04-21	2014-04-21 00:00:00	2014-04-21	5001	0	\N	0	0	\N	\N	0	117721	0	38265-5	3049273		
54492	4977	3006322	1987-11-04	1987-11-04 00:00:00	1987-11-04	5001	0	\N	0	0	\N	\N	0	331162	0	8331-1	3006322		
1580	140	3006322	1998-05-07	1998-05-07 00:00:00	1998-05-07	5001	0	\N	0	0	\N	\N	0	9379	0	8331-1	3006322		
12918	1227	40766240	1938-09-24	1938-09-24 00:00:00	1938-09-24	5001	0	\N	0	0	\N	\N	0	80798	0	63513-6	40766240		
77945	2392	4133840	1975-03-21	1975-03-21 00:00:00	1975-03-21	5001	0	\N	0	0	\N	\N	0	159084	0	127783003	4133840		
3797	362	3006322	2009-10-09	2009-10-09 00:00:00	2009-10-09	5001	0	\N	0	0	\N	\N	0	24019	0	8331-1	3006322		
13343	1265	3006451	1983-06-08	1983-06-08 00:00:00	1983-06-08	5001	0	\N	0	0	\N	\N	0	83401	0	6273-7	3006451		
56920	5222	40769194	1946-07-24	1946-07-24 00:00:00	1946-07-24	5001	0	\N	0	0	\N	\N	0	347353	0	66534-9	40769194		
41292	3852	3012494	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	255637	0	6206-7	3012494		
23510	2168	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	144562	0	6085-5	3001247		
4041	404	3012494	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	26607	0	6206-7	3012494		
64485	1977	4052083	1963-12-20	1963-12-20 00:00:00	1963-12-20	5001	0	\N	0	0	\N	\N	0	131576	0	23426006	4052083		
56628	1727	4133840	2004-09-16	2004-09-16 00:00:00	2004-09-16	5001	0	\N	0	0	\N	\N	0	115477	0	127783003	4133840		
35178	3215	3006451	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	213667	0	6273-7	3006451		
72479	2220	4052083	2007-01-31	2007-01-31 00:00:00	2007-01-31	5001	0	\N	0	0	\N	\N	0	147855	0	23426006	4052083		
57283	5262	3006322	2003-04-14	2003-04-14 00:00:00	2003-04-14	5001	0	\N	0	0	\N	\N	0	350113	0	8331-1	3006322		
36036	3314	3006322	2016-04-10	2016-04-10 00:00:00	2016-04-10	5001	0	\N	0	0	\N	\N	0	220122	0	8331-1	3006322		
58057	5322	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	354184	0	6082-2	3000876		
3742	357	3006322	1982-12-11	1982-12-11 00:00:00	1982-12-11	5001	0	\N	0	0	\N	\N	0	23664	0	8331-1	3006322		
138799	4278	4133840	2011-10-28	2011-10-28 00:00:00	2011-10-28	5001	0	\N	0	0	\N	\N	0	283866	0	127783003	4133840		
30067	2767	21494966	1939-05-23	1939-05-23 00:00:00	1939-05-23	5001	0	\N	0	0	\N	\N	0	183063	0	80271-0	21494966		
24274	2238	3020655	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	148967	0	6844-5	3020655		
52532	4826	3023430	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	321004	0	6833-8	3023430		
52584	4827	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	321161	0	6158-0	3019406		
4545	442	3036780	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	29296	0	6095-4	3036780		
120363	3714	4052083	1973-04-24	1973-04-24 00:00:00	1973-04-24	5001	0	\N	0	0	\N	\N	0	246797	0	23426006	4052083		
2016	184	3049273	2016-08-01	2016-08-01 00:00:00	2016-08-01	5001	0	\N	0	0	\N	\N	0	12437	0	38265-5	3049273		
76556	2347	4024958	2015-02-26	2015-02-26 00:00:00	2015-02-26	5001	0	\N	0	0	\N	\N	0	156255	0	117015009	4024958		
27570	2546	46235214	1983-06-24	1983-06-24 00:00:00	1983-06-24	5001	0	\N	0	0	\N	\N	0	168518	0	76690-7	46235214		
88647	2745	4052083	1995-06-24	1995-06-24 00:00:00	1995-06-24	5001	0	\N	0	0	\N	\N	0	181587	0	23426006	4052083		
2438	74	4052083	1973-09-28	1973-09-28 00:00:00	1973-09-28	5001	0	\N	0	0	\N	\N	0	5003	0	23426006	4052083		
38925	3601	3000963	2018-06-04	2018-06-04 00:00:00	2018-06-04	5001	0	\N	0	0	\N	\N	0	239253	0	718-7	3000963		
37113	3414	3006322	2001-08-13	2001-08-13 00:00:00	2001-08-13	5001	0	\N	0	0	\N	\N	0	226488	0	8331-1	3006322		
31870	2909	3024561	1962-04-07	1962-04-07 00:00:00	1962-04-07	5001	0	\N	0	0	\N	\N	0	193910	0	1751-7	3024561		
34764	3179	40766240	1948-04-22	1948-04-22 00:00:00	1948-04-22	5001	0	\N	0	0	\N	\N	0	211505	0	63513-6	40766240		
34799	3181	3011505	2000-09-22	2000-09-22 00:00:00	2000-09-22	5001	0	\N	0	0	\N	\N	0	211714	0	19926-5	3011505		
23265	728	4052083	1973-02-17	1973-02-17 00:00:00	1973-02-17	5001	0	\N	0	0	\N	\N	0	48350	0	23426006	4052083		
8611	823	3006322	2017-11-19	2017-11-19 00:00:00	2017-11-19	5001	0	\N	0	0	\N	\N	0	54533	0	8331-1	3006322		
46308	4261	3051031	1956-08-30	1956-08-30 00:00:00	1956-08-30	5001	0	\N	0	0	\N	\N	0	282973	0	46240-8	3051031		
158285	4865	4052083	2005-04-28	2005-04-28 00:00:00	2005-04-28	5001	0	\N	0	0	\N	\N	0	323492	0	23426006	4052083		
12238	395	4024958	1989-01-16	1989-01-16 00:00:00	1989-01-16	5001	0	\N	0	0	\N	\N	0	25988	0	117015009	4024958		
172986	5312	4024958	1961-07-13	1961-07-13 00:00:00	1961-07-13	5001	0	\N	0	0	\N	\N	0	353283	0	117015009	4024958		
7464	712	3051031	2010-12-28	2010-12-28 00:00:00	2010-12-28	5001	0	\N	0	0	\N	\N	0	47226	0	46240-8	3051031		
265	9	3014599	1991-07-25	1991-07-25 00:00:00	1991-07-25	5001	0	\N	0	0	\N	\N	0	837	0	6106-9	3014599		
20998	1947	3009542	1961-10-14	1961-10-14 00:00:00	1961-10-14	5001	0	\N	0	0	\N	\N	0	129425	0	20570-8	3009542		
42963	1321	4052083	1978-05-22	1978-05-22 00:00:00	1978-05-22	5001	0	\N	0	0	\N	\N	0	87653	0	23426006	4052083		
19182	1761	3006322	2001-01-01	2001-01-01 00:00:00	2001-01-01	5001	0	\N	0	0	\N	\N	0	117709	0	8331-1	3006322		
54496	4979	3006322	1986-04-05	1986-04-05 00:00:00	1986-04-05	5001	0	\N	0	0	\N	\N	0	331249	0	8331-1	3006322		
1581	140	3006322	1999-08-12	1999-08-12 00:00:00	1999-08-12	5001	0	\N	0	0	\N	\N	0	9354	0	8331-1	3006322		
12919	1227	46235214	1938-09-24	1938-09-24 00:00:00	1938-09-24	5001	0	\N	0	0	\N	\N	0	80798	0	76690-7	46235214		
77946	2392	4133840	2018-11-02	2018-11-02 00:00:00	2018-11-02	5001	0	\N	0	0	\N	\N	0	158978	0	127783003	4133840		
3798	362	3006322	1991-10-30	1991-10-30 00:00:00	1991-10-30	5001	0	\N	0	0	\N	\N	0	24024	0	8331-1	3006322		
13344	1265	3000876	1983-06-08	1983-06-08 00:00:00	1983-06-08	5001	0	\N	0	0	\N	\N	0	83401	0	6082-2	3000876		
56921	5222	40769184	1946-07-24	1946-07-24 00:00:00	1946-07-24	5001	0	\N	0	0	\N	\N	0	347353	0	66524-0	40769184		
41293	3852	3027231	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	255637	0	6276-0	3027231		
23511	2168	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	144562	0	7258-7	3001488		
28873	893	4024958	1971-06-04	1971-06-04 00:00:00	1971-06-04	5001	0	\N	0	0	\N	\N	0	59489	0	117015009	4024958		
64486	1977	4052083	1931-01-29	1931-01-29 00:00:00	1931-01-29	5001	0	\N	0	0	\N	\N	0	131506	0	23426006	4052083		
56629	1727	4133840	2005-09-22	2005-09-22 00:00:00	2005-09-22	5001	0	\N	0	0	\N	\N	0	115451	0	127783003	4133840		
35179	3215	3023430	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	213667	0	6833-8	3023430		
72482	2220	4052083	1947-12-16	1947-12-16 00:00:00	1947-12-16	5001	0	\N	0	0	\N	\N	0	147838	0	23426006	4052083		
57284	5262	3006322	2005-06-11	2005-06-11 00:00:00	2005-06-11	5001	0	\N	0	0	\N	\N	0	350089	0	8331-1	3006322		
36037	3314	3006322	1966-05-21	1966-05-21 00:00:00	1966-05-21	5001	0	\N	0	0	\N	\N	0	220116	0	8331-1	3006322		
58058	5322	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	354184	0	7258-7	3001488		
3743	357	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	23698	0	6158-0	3019406		
138803	4278	4133840	2015-11-20	2015-11-20 00:00:00	2015-11-20	5001	0	\N	0	0	\N	\N	0	283868	0	127783003	4133840		
30068	2767	3016723	1939-05-23	1939-05-23 00:00:00	1939-05-23	5001	0	\N	0	0	\N	\N	0	183063	0	2160-0	3016723		
24275	2238	3006322	1985-04-25	1985-04-25 00:00:00	1985-04-25	5001	0	\N	0	0	\N	\N	0	148889	0	8331-1	3006322		
52533	4826	3021226	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	321004	0	6246-3	3021226		
52585	4827	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	321161	0	6273-7	3006451		
4546	442	3005136	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	29296	0	6075-6	3005136		
120382	3714	4052083	1963-01-21	1963-01-21 00:00:00	1963-01-21	5001	0	\N	0	0	\N	\N	0	246766	0	23426006	4052083		
2017	184	40766240	2019-04-10	2019-04-10 00:00:00	2019-04-10	5001	0	\N	0	0	\N	\N	0	12498	0	63513-6	40766240		
76567	2347	4024958	1975-03-13	1975-03-13 00:00:00	1975-03-13	5001	0	\N	0	0	\N	\N	0	156278	0	117015009	4024958		
27573	2546	46235214	1984-07-18	1984-07-18 00:00:00	1984-07-18	5001	0	\N	0	0	\N	\N	0	168492	0	76690-7	46235214		
88653	2745	4052083	1977-01-20	1977-01-20 00:00:00	1977-01-20	5001	0	\N	0	0	\N	\N	0	181552	0	23426006	4052083		
2443	74	4052083	2012-07-01	2012-07-01 00:00:00	2012-07-01	5001	0	\N	0	0	\N	\N	0	4990	0	23426006	4052083		
38926	3601	3009542	2018-06-04	2018-06-04 00:00:00	2018-06-04	5001	0	\N	0	0	\N	\N	0	239253	0	20570-8	3009542		
37114	3414	3006322	2003-10-16	2003-10-16 00:00:00	2003-10-16	5001	0	\N	0	0	\N	\N	0	226489	0	8331-1	3006322		
31871	2909	3027970	1962-04-07	1962-04-07 00:00:00	1962-04-07	5001	0	\N	0	0	\N	\N	0	193910	0	10834-0	3027970		
34766	3179	40758406	1948-04-22	1948-04-22 00:00:00	1948-04-22	5001	0	\N	0	0	\N	\N	0	211505	0	55277-8	40758406		
34800	3181	3011505	2006-09-08	2006-09-08 00:00:00	2006-09-08	5001	0	\N	0	0	\N	\N	0	211704	0	19926-5	3011505		
34558	1082	4052083	1961-09-04	1961-09-04 00:00:00	1961-09-04	5001	0	\N	0	0	\N	\N	0	70939	0	23426006	4052083		
8612	823	3006322	1953-02-19	1953-02-19 00:00:00	1953-02-19	5001	0	\N	0	0	\N	\N	0	54529	0	8331-1	3006322		
46309	4261	40758406	1956-08-30	1956-08-30 00:00:00	1956-08-30	5001	0	\N	0	0	\N	\N	0	282973	0	55277-8	40758406		
89847	2777	4052083	1968-05-21	1968-05-21 00:00:00	1968-05-21	5001	0	\N	0	0	\N	\N	0	183964	0	23426006	4052083		
138427	4268	4052083	2011-12-12	2011-12-12 00:00:00	2011-12-12	5001	0	\N	0	0	\N	\N	0	283243	0	23426006	4052083		
172988	5312	4133840	1998-12-14	1998-12-14 00:00:00	1998-12-14	5001	0	\N	0	0	\N	\N	0	353233	0	127783003	4133840		
7465	712	40758406	2010-12-28	2010-12-28 00:00:00	2010-12-28	5001	0	\N	0	0	\N	\N	0	47226	0	55277-8	40758406		
266	9	3021226	1991-07-25	1991-07-25 00:00:00	1991-07-25	5001	0	\N	0	0	\N	\N	0	837	0	6246-3	3021226		
20999	1947	3000963	1961-10-14	1961-10-14 00:00:00	1961-10-14	5001	0	\N	0	0	\N	\N	0	129425	0	718-7	3000963		
42970	1322	4052083	1957-02-07	1957-02-07 00:00:00	1957-02-07	5001	0	\N	0	0	\N	\N	0	87741	0	23426006	4052083		
19183	1761	3006322	1963-11-27	1963-11-27 00:00:00	1963-11-27	5001	0	\N	0	0	\N	\N	0	117753	0	8331-1	3006322		
54497	4979	3006322	2008-04-30	2008-04-30 00:00:00	2008-04-30	5001	0	\N	0	0	\N	\N	0	331280	0	8331-1	3006322		
1582	140	46235214	2017-08-22	2017-08-22 00:00:00	2017-08-22	5001	0	\N	0	0	\N	\N	0	9397	0	76690-7	46235214		
12920	1227	40758406	1938-09-24	1938-09-24 00:00:00	1938-09-24	5001	0	\N	0	0	\N	\N	0	80798	0	55277-8	40758406		
77949	2392	4052083	2011-03-24	2011-03-24 00:00:00	2011-03-24	5001	0	\N	0	0	\N	\N	0	159104	0	23426006	4052083		
3799	363	3006322	2013-01-09	2013-01-09 00:00:00	2013-01-09	5001	0	\N	0	0	\N	\N	0	24077	0	8331-1	3006322		
13345	1265	3020655	1983-06-08	1983-06-08 00:00:00	1983-06-08	5001	0	\N	0	0	\N	\N	0	83401	0	6844-5	3020655		
56922	5222	3011505	2001-01-25	2001-01-25 00:00:00	2001-01-25	5001	0	\N	0	0	\N	\N	0	347422	0	19926-5	3011505		
41294	3852	3000876	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	255637	0	6082-2	3000876		
23512	2168	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	144562	0	6095-4	3036780		
29249	905	4052083	1997-10-07	1997-10-07 00:00:00	1997-10-07	5001	0	\N	0	0	\N	\N	0	60215	0	23426006	4052083		
56632	1727	4133840	2000-04-06	2000-04-06 00:00:00	2000-04-06	5001	0	\N	0	0	\N	\N	0	115427	0	127783003	4133840		
35180	3215	3036780	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	213667	0	6095-4	3036780		
83820	2591	4052083	1997-12-12	1997-12-12 00:00:00	1997-12-12	5001	0	\N	0	0	\N	\N	0	171511	0	23426006	4052083		
57285	5262	3006322	1977-12-01	1977-12-01 00:00:00	1977-12-01	5001	0	\N	0	0	\N	\N	0	350100	0	8331-1	3006322		
83927	2594	4052083	2013-05-23	2013-05-23 00:00:00	2013-05-23	5001	0	\N	0	0	\N	\N	0	171715	0	23426006	4052083		
58059	5322	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	354184	0	6273-7	3006451		
3744	357	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	23698	0	6248-9	3015076		
138805	4278	4133840	2000-08-25	2000-08-25 00:00:00	2000-08-25	5001	0	\N	0	0	\N	\N	0	283888	0	127783003	4133840		
30069	2767	3020630	1939-05-23	1939-05-23 00:00:00	1939-05-23	5001	0	\N	0	0	\N	\N	0	183063	0	2885-2	3020630		
24276	2238	3027231	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	148980	0	6276-0	3027231		
52534	4826	3005136	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	321004	0	6075-6	3005136		
52586	4827	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	321161	0	6075-6	3005136		
4547	442	3014599	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	29296	0	6106-9	3014599		
85002	2633	4024958	1970-05-06	1970-05-06 00:00:00	1970-05-06	5001	0	\N	0	0	\N	\N	0	174231	0	117015009	4024958		
2018	184	46235214	2019-04-10	2019-04-10 00:00:00	2019-04-10	5001	0	\N	0	0	\N	\N	0	12498	0	76690-7	46235214		
76568	2347	4052083	2006-08-01	2006-08-01 00:00:00	2006-08-01	5001	0	\N	0	0	\N	\N	0	156235	0	23426006	4052083		
27574	2546	40766240	1984-07-18	1984-07-18 00:00:00	1984-07-18	5001	0	\N	0	0	\N	\N	0	168492	0	63513-6	40766240		
88656	2745	4024958	1992-09-24	1992-09-24 00:00:00	1992-09-24	5001	0	\N	0	0	\N	\N	0	181553	0	117015009	4024958		
1022	84	3006322	1982-07-13	1982-07-13 00:00:00	1982-07-13	5001	0	\N	0	0	\N	\N	0	5666	0	8331-1	3006322		
38927	3601	40769194	1961-04-19	1961-04-19 00:00:00	1961-04-19	5001	0	\N	0	0	\N	\N	0	239228	0	66534-9	40769194		
37115	3415	3006322	1974-09-21	1974-09-21 00:00:00	1974-09-21	5001	0	\N	0	0	\N	\N	0	226517	0	8331-1	3006322		
31872	2909	3013721	1962-04-07	1962-04-07 00:00:00	1962-04-07	5001	0	\N	0	0	\N	\N	0	193910	0	1920-8	3013721		
34767	3179	46235214	1948-04-22	1948-04-22 00:00:00	1948-04-22	5001	0	\N	0	0	\N	\N	0	211505	0	76690-7	46235214		
34801	3181	3011505	2005-09-02	2005-09-02 00:00:00	2005-09-02	5001	0	\N	0	0	\N	\N	0	211708	0	19926-5	3011505		
34584	1082	4024958	1997-09-18	1997-09-18 00:00:00	1997-09-18	5001	0	\N	0	0	\N	\N	0	70960	0	117015009	4024958		
8613	823	3011505	2018-01-29	2018-01-29 00:00:00	2018-01-29	5001	0	\N	0	0	\N	\N	0	54517	0	19926-5	3011505		
46310	4261	40758406	1957-03-28	1957-03-28 00:00:00	1957-03-28	5001	0	\N	0	0	\N	\N	0	282960	0	55277-8	40758406		
89853	2777	4052083	2004-05-02	2004-05-02 00:00:00	2004-05-02	5001	0	\N	0	0	\N	\N	0	183951	0	23426006	4052083		
138429	4268	4052083	1996-04-25	1996-04-25 00:00:00	1996-04-25	5001	0	\N	0	0	\N	\N	0	283278	0	23426006	4052083		
172990	5312	4133840	1990-11-12	1990-11-12 00:00:00	1990-11-12	5001	0	\N	0	0	\N	\N	0	353260	0	127783003	4133840		
7466	712	40766240	2010-12-28	2010-12-28 00:00:00	2010-12-28	5001	0	\N	0	0	\N	\N	0	47226	0	63513-6	40766240		
267	9	3027231	1991-07-25	1991-07-25 00:00:00	1991-07-25	5001	0	\N	0	0	\N	\N	0	837	0	6276-0	3027231		
21000	1947	3049273	2009-06-21	2009-06-21 00:00:00	2009-06-21	5001	0	\N	0	0	\N	\N	0	129400	0	38265-5	3049273		
42978	1322	4024958	2014-07-30	2014-07-30 00:00:00	2014-07-30	5001	0	\N	0	0	\N	\N	0	87775	0	117015009	4024958		
19184	1761	3006322	1996-09-11	1996-09-11 00:00:00	1996-09-11	5001	0	\N	0	0	\N	\N	0	117743	0	8331-1	3006322		
54498	4979	3006322	1995-07-27	1995-07-27 00:00:00	1995-07-27	5001	0	\N	0	0	\N	\N	0	331300	0	8331-1	3006322		
1583	140	40766240	2017-08-22	2017-08-22 00:00:00	2017-08-22	5001	0	\N	0	0	\N	\N	0	9397	0	63513-6	40766240		
12922	1227	3051031	1938-09-24	1938-09-24 00:00:00	1938-09-24	5001	0	\N	0	0	\N	\N	0	80798	0	46240-8	3051031		
77953	2392	4133840	2009-07-24	2009-07-24 00:00:00	2009-07-24	5001	0	\N	0	0	\N	\N	0	159066	0	127783003	4133840		
3800	363	3006322	2002-01-07	2002-01-07 00:00:00	2002-01-07	5001	0	\N	0	0	\N	\N	0	24076	0	8331-1	3006322		
13346	1265	3001488	1983-06-08	1983-06-08 00:00:00	1983-06-08	5001	0	\N	0	0	\N	\N	0	83401	0	7258-7	3001488		
17213	1565	3006322	1972-02-07	1972-02-07 00:00:00	1972-02-07	5001	0	\N	0	0	\N	\N	0	104916	0	8331-1	3006322		
41295	3852	3020655	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	255637	0	6844-5	3020655		
23513	2168	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	144562	0	6075-6	3005136		
29272	905	4024958	2010-01-10	2010-01-10 00:00:00	2010-01-10	5001	0	\N	0	0	\N	\N	0	60200	0	117015009	4024958		
56636	1727	4133840	2014-11-12	2014-11-12 00:00:00	2014-11-12	5001	0	\N	0	0	\N	\N	0	115453	0	127783003	4133840		
35181	3215	3000876	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	213667	0	6082-2	3000876		
61242	1870	4024958	1925-05-04	1925-05-04 00:00:00	1925-05-04	5001	0	\N	0	0	\N	\N	0	124915	0	117015009	4024958		
57286	5262	3006322	2017-02-01	2017-02-01 00:00:00	2017-02-01	5001	0	\N	0	0	\N	\N	0	350081	0	8331-1	3006322		
83936	2594	4024958	1981-05-01	1981-05-01 00:00:00	1981-05-01	5001	0	\N	0	0	\N	\N	0	171710	0	117015009	4024958		
58060	5322	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	354184	0	6248-9	3015076		
3745	357	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	23698	0	6273-7	3006451		
138808	4278	4133840	2007-10-05	2007-10-05 00:00:00	2007-10-05	5001	0	\N	0	0	\N	\N	0	283861	0	127783003	4133840		
30070	2767	3007461	1939-05-23	1939-05-23 00:00:00	1939-05-23	5001	0	\N	0	0	\N	\N	0	183063	0	26515-7	3007461		
24277	2238	3006451	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	148980	0	6273-7	3006451		
52535	4826	3001247	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	321004	0	6085-5	3001247		
52587	4827	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	321161	0	6246-3	3021226		
4548	442	3019406	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	29296	0	6158-0	3019406		
96317	2950	4024958	1983-08-12	1983-08-12 00:00:00	1983-08-12	5001	0	\N	0	0	\N	\N	0	196982	0	117015009	4024958		
2019	184	3051031	2019-04-10	2019-04-10 00:00:00	2019-04-10	5001	0	\N	0	0	\N	\N	0	12498	0	46240-8	3051031		
76573	2347	4024958	1974-06-06	1974-06-06 00:00:00	1974-06-06	5001	0	\N	0	0	\N	\N	0	156274	0	117015009	4024958		
27575	2546	40758406	1984-07-18	1984-07-18 00:00:00	1984-07-18	5001	0	\N	0	0	\N	\N	0	168492	0	55277-8	40758406		
146347	4490	4024958	1971-03-29	1971-03-29 00:00:00	1971-03-29	5001	0	\N	0	0	\N	\N	0	298917	0	117015009	4024958		
1023	84	3006322	1974-11-10	1974-11-10 00:00:00	1974-11-10	5001	0	\N	0	0	\N	\N	0	5650	0	8331-1	3006322		
38928	3601	40769184	1961-04-19	1961-04-19 00:00:00	1961-04-19	5001	0	\N	0	0	\N	\N	0	239228	0	66524-0	40769184		
37116	3415	3006322	2008-09-28	2008-09-28 00:00:00	2008-09-28	5001	0	\N	0	0	\N	\N	0	226532	0	8331-1	3006322		
31873	2909	21494966	1962-04-07	1962-04-07 00:00:00	1962-04-07	5001	0	\N	0	0	\N	\N	0	193910	0	80271-0	21494966		
34768	3179	3051031	1948-04-22	1948-04-22 00:00:00	1948-04-22	5001	0	\N	0	0	\N	\N	0	211505	0	46240-8	3051031		
34802	3181	3051031	1952-11-12	1952-11-12 00:00:00	1952-11-12	5001	0	\N	0	0	\N	\N	0	211629	0	46240-8	3051031		
170625	5234	4024958	1948-01-20	1948-01-20 00:00:00	1948-01-20	5001	0	\N	0	0	\N	\N	0	348218	0	117015009	4024958		
8878	850	3006322	2000-10-05	2000-10-05 00:00:00	2000-10-05	5001	0	\N	0	0	\N	\N	0	56191	0	8331-1	3006322		
46311	4261	40766240	1957-03-28	1957-03-28 00:00:00	1957-03-28	5001	0	\N	0	0	\N	\N	0	282960	0	63513-6	40766240		
110563	3413	4024958	1977-12-24	1977-12-24 00:00:00	1977-12-24	5001	0	\N	0	0	\N	\N	0	226375	0	117015009	4024958		
138433	4268	4052083	1968-07-16	1968-07-16 00:00:00	1968-07-16	5001	0	\N	0	0	\N	\N	0	283244	0	23426006	4052083		
172991	5312	4052083	1961-05-04	1961-05-04 00:00:00	1961-05-04	5001	0	\N	0	0	\N	\N	0	353248	0	23426006	4052083		
7468	712	3006322	2008-07-25	2008-07-25 00:00:00	2008-07-25	5001	0	\N	0	0	\N	\N	0	47247	0	8331-1	3006322		
9651	911	3006322	1978-11-26	1978-11-26 00:00:00	1978-11-26	5001	0	\N	0	0	\N	\N	0	60526	0	8331-1	3006322		
21001	1947	3006322	1955-06-15	1955-06-15 00:00:00	1955-06-15	5001	0	\N	0	0	\N	\N	0	129424	0	8331-1	3006322		
42992	1322	4024958	1945-09-09	1945-09-09 00:00:00	1945-09-09	5001	0	\N	0	0	\N	\N	0	87787	0	117015009	4024958		
19185	1762	3011505	1999-04-15	1999-04-15 00:00:00	1999-04-15	5001	0	\N	0	0	\N	\N	0	117875	0	19926-5	3011505		
54499	4979	3006322	2017-04-25	2017-04-25 00:00:00	2017-04-25	5001	0	\N	0	0	\N	\N	0	331273	0	8331-1	3006322		
1584	140	3051031	2017-08-22	2017-08-22 00:00:00	2017-08-22	5001	0	\N	0	0	\N	\N	0	9397	0	46240-8	3051031		
12924	1227	3006322	1977-06-23	1977-06-23 00:00:00	1977-06-23	5001	0	\N	0	0	\N	\N	0	80847	0	8331-1	3006322		
77955	2392	4133840	1968-02-09	1968-02-09 00:00:00	1968-02-09	5001	0	\N	0	0	\N	\N	0	159001	0	127783003	4133840		
3801	363	3006322	2012-04-29	2012-04-29 00:00:00	2012-04-29	5001	0	\N	0	0	\N	\N	0	24100	0	8331-1	3006322		
13347	1265	3036780	1983-06-08	1983-06-08 00:00:00	1983-06-08	5001	0	\N	0	0	\N	\N	0	83401	0	6095-4	3036780		
17214	1566	3006322	1972-08-12	1972-08-12 00:00:00	1972-08-12	5001	0	\N	0	0	\N	\N	0	104994	0	8331-1	3006322		
41296	3852	3023430	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	255637	0	6833-8	3023430		
23514	2168	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	144562	0	6246-3	3021226		
29290	906	4024958	1979-01-07	1979-01-07 00:00:00	1979-01-07	5001	0	\N	0	0	\N	\N	0	60271	0	117015009	4024958		
56645	1727	4133840	2003-04-24	2003-04-24 00:00:00	2003-04-24	5001	0	\N	0	0	\N	\N	0	115476	0	127783003	4133840		
35182	3215	3005136	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	213667	0	6075-6	3005136		
61252	1870	4052083	1927-04-13	1927-04-13 00:00:00	1927-04-13	5001	0	\N	0	0	\N	\N	0	124924	0	23426006	4052083		
57287	5262	3006322	1981-08-27	1981-08-27 00:00:00	1981-08-27	5001	0	\N	0	0	\N	\N	0	350084	0	8331-1	3006322		
83937	2594	4024958	1979-07-29	1979-07-29 00:00:00	1979-07-29	5001	0	\N	0	0	\N	\N	0	171680	0	117015009	4024958		
58061	5322	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	354184	0	6095-4	3036780		
3746	357	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	23698	0	6189-5	3006734		
138813	4278	4133840	2003-09-12	2003-09-12 00:00:00	2003-09-12	5001	0	\N	0	0	\N	\N	0	283848	0	127783003	4133840		
30071	2767	3045716	1939-05-23	1939-05-23 00:00:00	1939-05-23	5001	0	\N	0	0	\N	\N	0	183063	0	33037-3	3045716		
24278	2238	3021226	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	148980	0	6246-3	3021226		
52536	4826	3000876	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	321004	0	6082-2	3000876		
52588	4827	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	321161	0	6189-5	3006734		
4549	442	3001247	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	29296	0	6085-5	3001247		
96329	2950	4024958	1952-11-23	1952-11-23 00:00:00	1952-11-23	5001	0	\N	0	0	\N	\N	0	196955	0	117015009	4024958		
2020	184	40758406	2019-04-10	2019-04-10 00:00:00	2019-04-10	5001	0	\N	0	0	\N	\N	0	12498	0	55277-8	40758406		
76576	2347	4052083	1982-03-25	1982-03-25 00:00:00	1982-03-25	5001	0	\N	0	0	\N	\N	0	156250	0	23426006	4052083		
27577	2546	3051031	1984-07-18	1984-07-18 00:00:00	1984-07-18	5001	0	\N	0	0	\N	\N	0	168492	0	46240-8	3051031		
146363	4491	4024958	1957-02-18	1957-02-18 00:00:00	1957-02-18	5001	0	\N	0	0	\N	\N	0	299015	0	117015009	4024958		
1024	84	3020655	1979-04-08	1979-04-08 00:00:00	1979-04-08	5001	0	\N	0	0	\N	\N	0	5665	0	6844-5	3020655		
38929	3601	40769179	1961-04-19	1961-04-19 00:00:00	1961-04-19	5001	0	\N	0	0	\N	\N	0	239228	0	66519-0	40769179		
37117	3415	3006322	1997-12-30	1997-12-30 00:00:00	1997-12-30	5001	0	\N	0	0	\N	\N	0	226497	0	8331-1	3006322		
31874	2909	3004501	1962-04-07	1962-04-07 00:00:00	1962-04-07	5001	0	\N	0	0	\N	\N	0	193910	0	2345-7	3004501		
93928	2892	4024958	1975-08-16	1975-08-16 00:00:00	1975-08-16	5001	0	\N	0	0	\N	\N	0	192422	0	117015009	4024958		
34804	3181	40758406	1952-11-12	1952-11-12 00:00:00	1952-11-12	5001	0	\N	0	0	\N	\N	0	211629	0	55277-8	40758406		
170629	5234	4133840	2000-06-14	2000-06-14 00:00:00	2000-06-14	5001	0	\N	0	0	\N	\N	0	348282	0	127783003	4133840		
8879	850	3006322	1987-07-03	1987-07-03 00:00:00	1987-07-03	5001	0	\N	0	0	\N	\N	0	56217	0	8331-1	3006322		
46313	4261	46235214	1957-03-28	1957-03-28 00:00:00	1957-03-28	5001	0	\N	0	0	\N	\N	0	282960	0	76690-7	46235214		
110574	3413	4052083	2009-03-12	2009-03-12 00:00:00	2009-03-12	5001	0	\N	0	0	\N	\N	0	226400	0	23426006	4052083		
161588	4963	4024958	1985-02-19	1985-02-19 00:00:00	1985-02-19	5001	0	\N	0	0	\N	\N	0	329964	0	117015009	4024958		
172993	5312	4133840	1992-11-23	1992-11-23 00:00:00	1992-11-23	5001	0	\N	0	0	\N	\N	0	353244	0	127783003	4133840		
7469	712	3006322	1989-04-05	1989-04-05 00:00:00	1989-04-05	5001	0	\N	0	0	\N	\N	0	47231	0	8331-1	3006322		
9652	911	3015076	1977-06-15	1977-06-15 00:00:00	1977-06-15	5001	0	\N	0	0	\N	\N	0	60471	0	6248-9	3015076		
21002	1947	3006322	1959-08-13	1959-08-13 00:00:00	1959-08-13	5001	0	\N	0	0	\N	\N	0	129481	0	8331-1	3006322		
42995	1322	4024958	1945-05-02	1945-05-02 00:00:00	1945-05-02	5001	0	\N	0	0	\N	\N	0	87792	0	117015009	4024958		
19186	1762	3011505	2004-02-12	2004-02-12 00:00:00	2004-02-12	5001	0	\N	0	0	\N	\N	0	117856	0	19926-5	3011505		
60602	1848	4052083	1960-08-23	1960-08-23 00:00:00	1960-08-23	5001	0	\N	0	0	\N	\N	0	123593	0	23426006	4052083		
1585	140	40758406	2017-08-22	2017-08-22 00:00:00	2017-08-22	5001	0	\N	0	0	\N	\N	0	9397	0	55277-8	40758406		
12925	1227	3006322	2003-09-26	2003-09-26 00:00:00	2003-09-26	5001	0	\N	0	0	\N	\N	0	80783	0	8331-1	3006322		
77958	2392	4133840	2005-07-01	2005-07-01 00:00:00	2005-07-01	5001	0	\N	0	0	\N	\N	0	158996	0	127783003	4133840		
3802	363	3006322	1974-06-19	1974-06-19 00:00:00	1974-06-19	5001	0	\N	0	0	\N	\N	0	24096	0	8331-1	3006322		
13348	1266	3006322	2018-10-21	2018-10-21 00:00:00	2018-10-21	5001	0	\N	0	0	\N	\N	0	83445	0	8331-1	3006322		
17215	1567	3006322	1981-02-07	1981-02-07 00:00:00	1981-02-07	5001	0	\N	0	0	\N	\N	0	105110	0	8331-1	3006322		
41297	3852	3001488	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	255637	0	7258-7	3001488		
23515	2168	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	144562	0	6844-5	3020655		
75263	2307	4024958	1977-05-25	1977-05-25 00:00:00	1977-05-25	5001	0	\N	0	0	\N	\N	0	153480	0	117015009	4024958		
56646	1727	4133840	2013-11-06	2013-11-06 00:00:00	2013-11-06	5001	0	\N	0	0	\N	\N	0	115459	0	127783003	4133840		
35183	3215	3021226	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	213667	0	6246-3	3021226		
61255	1870	4052083	1932-07-24	1932-07-24 00:00:00	1932-07-24	5001	0	\N	0	0	\N	\N	0	124916	0	23426006	4052083		
1941	57	4052083	1992-02-19	1992-02-19 00:00:00	1992-02-19	5001	0	\N	0	0	\N	\N	0	3850	0	23426006	4052083		
83938	2594	4052083	2002-04-25	2002-04-25 00:00:00	2002-04-25	5001	0	\N	0	0	\N	\N	0	171682	0	23426006	4052083		
58062	5322	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	354184	0	6206-7	3012494		
3747	357	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	23698	0	6075-6	3005136		
138864	4279	4024958	2007-03-03	2007-03-03 00:00:00	2007-03-03	5001	0	\N	0	0	\N	\N	0	284006	0	117015009	4024958		
30072	2767	3002385	1939-05-23	1939-05-23 00:00:00	1939-05-23	5001	0	\N	0	0	\N	\N	0	183063	0	30385-9	3002385		
24284	2240	3006322	2006-10-23	2006-10-23 00:00:00	2006-10-23	5001	0	\N	0	0	\N	\N	0	149146	0	8331-1	3006322		
52537	4826	3020655	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	321004	0	6844-5	3020655		
52589	4827	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	321161	0	6833-8	3023430		
4550	442	3006734	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	29296	0	6189-5	3006734		
96331	2950	4024958	1948-11-15	1948-11-15 00:00:00	1948-11-15	5001	0	\N	0	0	\N	\N	0	196882	0	117015009	4024958		
2023	184	3006322	1972-10-07	1972-10-07 00:00:00	1972-10-07	5001	0	\N	0	0	\N	\N	0	12474	0	8331-1	3006322		
115039	3547	4024958	1977-03-09	1977-03-09 00:00:00	1977-03-09	5001	0	\N	0	0	\N	\N	0	235564	0	117015009	4024958		
27578	2546	3006322	1981-04-27	1981-04-27 00:00:00	1981-04-27	5001	0	\N	0	0	\N	\N	0	168461	0	8331-1	3006322		
146365	4491	4052083	2001-05-29	2001-05-29 00:00:00	2001-05-29	5001	0	\N	0	0	\N	\N	0	299020	0	23426006	4052083		
1025	84	3023430	1979-04-08	1979-04-08 00:00:00	1979-04-08	5001	0	\N	0	0	\N	\N	0	5665	0	6833-8	3023430		
38930	3601	40769189	1961-04-19	1961-04-19 00:00:00	1961-04-19	5001	0	\N	0	0	\N	\N	0	239228	0	66529-9	40769189		
37118	3415	3006322	1991-08-19	1991-08-19 00:00:00	1991-08-19	5001	0	\N	0	0	\N	\N	0	226548	0	8331-1	3006322		
31875	2909	3000963	1962-04-07	1962-04-07 00:00:00	1962-04-07	5001	0	\N	0	0	\N	\N	0	193910	0	718-7	3000963		
93952	2892	4052083	1978-06-10	1978-06-10 00:00:00	1978-06-10	5001	0	\N	0	0	\N	\N	0	192419	0	23426006	4052083		
34805	3181	40766240	1952-11-12	1952-11-12 00:00:00	1952-11-12	5001	0	\N	0	0	\N	\N	0	211629	0	63513-6	40766240		
170635	5234	4133840	2006-07-19	2006-07-19 00:00:00	2006-07-19	5001	0	\N	0	0	\N	\N	0	348277	0	127783003	4133840		
8881	850	3006322	1955-09-06	1955-09-06 00:00:00	1955-09-06	5001	0	\N	0	0	\N	\N	0	56188	0	8331-1	3006322		
46315	4261	3051031	1957-03-28	1957-03-28 00:00:00	1957-03-28	5001	0	\N	0	0	\N	\N	0	282960	0	46240-8	3051031		
110578	3413	4024958	1976-07-18	1976-07-18 00:00:00	1976-07-18	5001	0	\N	0	0	\N	\N	0	226374	0	117015009	4024958		
161590	4963	4024958	2017-08-03	2017-08-03 00:00:00	2017-08-03	5001	0	\N	0	0	\N	\N	0	329941	0	117015009	4024958		
172995	5312	4133840	2006-01-23	2006-01-23 00:00:00	2006-01-23	5001	0	\N	0	0	\N	\N	0	353269	0	127783003	4133840		
7470	712	3006322	1990-07-13	1990-07-13 00:00:00	1990-07-13	5001	0	\N	0	0	\N	\N	0	47224	0	8331-1	3006322		
9653	911	3027231	1977-06-15	1977-06-15 00:00:00	1977-06-15	5001	0	\N	0	0	\N	\N	0	60471	0	6276-0	3027231		
21010	1950	3011505	2019-02-28	2019-02-28 00:00:00	2019-02-28	5001	0	\N	0	0	\N	\N	0	129697	0	19926-5	3011505		
53110	4881	3006322	2018-03-14	2018-03-14 00:00:00	2018-03-14	5001	0	\N	0	0	\N	\N	0	324539	0	8331-1	3006322		
19187	1762	3011505	1991-02-28	1991-02-28 00:00:00	1991-02-28	5001	0	\N	0	0	\N	\N	0	117819	0	19926-5	3011505		
60617	1848	4052083	2010-01-24	2010-01-24 00:00:00	2010-01-24	5001	0	\N	0	0	\N	\N	0	123602	0	23426006	4052083		
1588	140	3006322	1972-08-22	1972-08-22 00:00:00	1972-08-22	5001	0	\N	0	0	\N	\N	0	9406	0	8331-1	3006322		
12926	1227	3006322	1951-12-12	1951-12-12 00:00:00	1951-12-12	5001	0	\N	0	0	\N	\N	0	80844	0	8331-1	3006322		
77961	2392	4133840	1991-04-12	1991-04-12 00:00:00	1991-04-12	5001	0	\N	0	0	\N	\N	0	159060	0	127783003	4133840		
3803	364	3006322	1988-04-23	1988-04-23 00:00:00	1988-04-23	5001	0	\N	0	0	\N	\N	0	24177	0	8331-1	3006322		
13349	1266	3006322	1980-07-31	1980-07-31 00:00:00	1980-07-31	5001	0	\N	0	0	\N	\N	0	83485	0	8331-1	3006322		
17216	1567	3006322	2008-08-16	2008-08-16 00:00:00	2008-08-16	5001	0	\N	0	0	\N	\N	0	105147	0	8331-1	3006322		
41298	3852	3006734	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	255637	0	6189-5	3006734		
23516	2168	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	144562	0	6833-8	3023430		
75284	2307	4052083	1993-01-20	1993-01-20 00:00:00	1993-01-20	5001	0	\N	0	0	\N	\N	0	153486	0	23426006	4052083		
56647	1727	4133840	2016-11-23	2016-11-23 00:00:00	2016-11-23	5001	0	\N	0	0	\N	\N	0	115483	0	127783003	4133840		
35184	3215	3012494	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	213667	0	6206-7	3012494		
61256	1870	4024958	1924-10-26	1924-10-26 00:00:00	1924-10-26	5001	0	\N	0	0	\N	\N	0	124923	0	117015009	4024958		
1946	57	4052083	1982-01-01	1982-01-01 00:00:00	1982-01-01	5001	0	\N	0	0	\N	\N	0	3824	0	23426006	4052083		
83947	2594	4024958	1978-09-22	1978-09-22 00:00:00	1978-09-22	5001	0	\N	0	0	\N	\N	0	171697	0	117015009	4024958		
58063	5322	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	354184	0	6158-0	3019406		
3748	357	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	23698	0	6246-3	3021226		
138873	4279	4052083	1986-12-05	1986-12-05 00:00:00	1986-12-05	5001	0	\N	0	0	\N	\N	0	283964	0	23426006	4052083		
41350	3857	3011505	2005-08-16	2005-08-16 00:00:00	2005-08-16	5001	0	\N	0	0	\N	\N	0	256002	0	19926-5	3011505		
24285	2240	3006322	2005-04-06	2005-04-06 00:00:00	2005-04-06	5001	0	\N	0	0	\N	\N	0	149145	0	8331-1	3006322		
52538	4826	3001488	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	321004	0	7258-7	3001488		
52590	4827	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	321161	0	7258-7	3001488		
4551	442	3006322	1998-12-26	1998-12-26 00:00:00	1998-12-26	5001	0	\N	0	0	\N	\N	0	29368	0	8331-1	3006322		
96336	2950	4024958	1993-01-13	1993-01-13 00:00:00	1993-01-13	5001	0	\N	0	0	\N	\N	0	196989	0	117015009	4024958		
2024	184	40758406	2019-02-09	2019-02-09 00:00:00	2019-02-09	5001	0	\N	0	0	\N	\N	0	12477	0	55277-8	40758406		
115041	3547	4024958	1997-04-20	1997-04-20 00:00:00	1997-04-20	5001	0	\N	0	0	\N	\N	0	235585	0	117015009	4024958		
27580	2546	46235214	1983-11-21	1983-11-21 00:00:00	1983-11-21	5001	0	\N	0	0	\N	\N	0	168463	0	76690-7	46235214		
101004	3105	4052083	2007-09-10	2007-09-10 00:00:00	2007-09-10	5001	0	\N	0	0	\N	\N	0	206508	0	23426006	4052083		
1026	84	3036780	1979-04-08	1979-04-08 00:00:00	1979-04-08	5001	0	\N	0	0	\N	\N	0	5665	0	6095-4	3036780		
38931	3601	3006322	1969-01-30	1969-01-30 00:00:00	1969-01-30	5001	0	\N	0	0	\N	\N	0	239172	0	8331-1	3006322		
37119	3415	3006322	2008-05-22	2008-05-22 00:00:00	2008-05-22	5001	0	\N	0	0	\N	\N	0	226502	0	8331-1	3006322		
31876	2909	3007461	1962-04-07	1962-04-07 00:00:00	1962-04-07	5001	0	\N	0	0	\N	\N	0	193910	0	26515-7	3007461		
93959	2893	4024958	1966-01-23	1966-01-23 00:00:00	1966-01-23	5001	0	\N	0	0	\N	\N	0	192456	0	117015009	4024958		
34807	3181	46235214	1952-11-12	1952-11-12 00:00:00	1952-11-12	5001	0	\N	0	0	\N	\N	0	211629	0	76690-7	46235214		
170638	5234	4133840	2005-07-13	2005-07-13 00:00:00	2005-07-13	5001	0	\N	0	0	\N	\N	0	348210	0	127783003	4133840		
8882	850	3006322	2018-03-05	2018-03-05 00:00:00	2018-03-05	5001	0	\N	0	0	\N	\N	0	56230	0	8331-1	3006322		
46316	4261	3006322	2008-05-13	2008-05-13 00:00:00	2008-05-13	5001	0	\N	0	0	\N	\N	0	282943	0	8331-1	3006322		
110601	3414	4052083	2013-10-27	2013-10-27 00:00:00	2013-10-27	5001	0	\N	0	0	\N	\N	0	226476	0	23426006	4052083		
161596	4963	4052083	1976-05-29	1976-05-29 00:00:00	1976-05-29	5001	0	\N	0	0	\N	\N	0	329897	0	23426006	4052083		
172996	5312	4133840	2001-12-31	2001-12-31 00:00:00	2001-12-31	5001	0	\N	0	0	\N	\N	0	353242	0	127783003	4133840		
7471	712	3006322	1977-08-25	1977-08-25 00:00:00	1977-08-25	5001	0	\N	0	0	\N	\N	0	47242	0	8331-1	3006322		
9654	911	3014599	1977-06-15	1977-06-15 00:00:00	1977-06-15	5001	0	\N	0	0	\N	\N	0	60471	0	6106-9	3014599		
21011	1950	3011505	1998-10-29	1998-10-29 00:00:00	1998-10-29	5001	0	\N	0	0	\N	\N	0	129692	0	19926-5	3011505		
53111	4881	3006322	1992-03-16	1992-03-16 00:00:00	1992-03-16	5001	0	\N	0	0	\N	\N	0	324537	0	8331-1	3006322		
19188	1762	3011505	2002-01-31	2002-01-31 00:00:00	2002-01-31	5001	0	\N	0	0	\N	\N	0	117821	0	19926-5	3011505		
60623	1848	4052083	1970-12-15	1970-12-15 00:00:00	1970-12-15	5001	0	\N	0	0	\N	\N	0	123595	0	23426006	4052083		
1589	141	3006322	1993-09-22	1993-09-22 00:00:00	1993-09-22	5001	0	\N	0	0	\N	\N	0	9449	0	8331-1	3006322		
12927	1228	3020655	1979-07-31	1979-07-31 00:00:00	1979-07-31	5001	0	\N	0	0	\N	\N	0	80917	0	6844-5	3020655		
77963	2392	4133840	2016-10-21	2016-10-21 00:00:00	2016-10-21	5001	0	\N	0	0	\N	\N	0	158977	0	127783003	4133840		
3804	364	3006322	1987-02-19	1987-02-19 00:00:00	1987-02-19	5001	0	\N	0	0	\N	\N	0	24158	0	8331-1	3006322		
13350	1267	3006322	1969-12-26	1969-12-26 00:00:00	1969-12-26	5001	0	\N	0	0	\N	\N	0	83561	0	8331-1	3006322		
17217	1567	3006322	1980-07-29	1980-07-29 00:00:00	1980-07-29	5001	0	\N	0	0	\N	\N	0	105109	0	8331-1	3006322		
41299	3852	3001247	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	255637	0	6085-5	3001247		
23517	2168	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	144562	0	6189-5	3006734		
75317	2309	4024958	1999-04-04	1999-04-04 00:00:00	1999-04-04	5001	0	\N	0	0	\N	\N	0	153651	0	117015009	4024958		
56660	1727	4133840	2004-04-29	2004-04-29 00:00:00	2004-04-29	5001	0	\N	0	0	\N	\N	0	115450	0	127783003	4133840		
35185	3215	3014599	2002-10-26	2002-10-26 00:00:00	2002-10-26	5001	0	\N	0	0	\N	\N	0	213667	0	6106-9	3014599		
153414	4705	4024958	1978-04-19	1978-04-19 00:00:00	1978-04-19	5001	0	\N	0	0	\N	\N	0	313443	0	117015009	4024958		
1952	57	4052083	2013-02-24	2013-02-24 00:00:00	2013-02-24	5001	0	\N	0	0	\N	\N	0	3852	0	23426006	4052083		
13969	1310	3006322	1951-07-04	1951-07-04 00:00:00	1951-07-04	5001	0	\N	0	0	\N	\N	0	86568	0	8331-1	3006322		
58064	5322	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	354184	0	6085-5	3001247		
3749	357	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	23698	0	6206-7	3012494		
73894	2270	4052083	2016-04-12	2016-04-12 00:00:00	2016-04-12	5001	0	\N	0	0	\N	\N	0	150922	0	23426006	4052083		
41351	3857	3011505	1983-12-27	1983-12-27 00:00:00	1983-12-27	5001	0	\N	0	0	\N	\N	0	255991	0	19926-5	3011505		
24286	2240	3006322	2005-09-14	2005-09-14 00:00:00	2005-09-14	5001	0	\N	0	0	\N	\N	0	149101	0	8331-1	3006322		
52539	4826	3036780	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	321004	0	6095-4	3036780		
52591	4827	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	321161	0	6095-4	3036780		
4553	442	40769194	1980-08-24	1980-08-24 00:00:00	1980-08-24	5001	0	\N	0	0	\N	\N	0	29295	0	66534-9	40769194		
96340	2950	4024958	1936-07-11	1936-07-11 00:00:00	1936-07-11	5001	0	\N	0	0	\N	\N	0	196894	0	117015009	4024958		
2025	184	3051031	2019-02-09	2019-02-09 00:00:00	2019-02-09	5001	0	\N	0	0	\N	\N	0	12477	0	46240-8	3051031		
115044	3547	4024958	1982-10-23	1982-10-23 00:00:00	1982-10-23	5001	0	\N	0	0	\N	\N	0	235548	0	117015009	4024958		
27582	2546	40766240	1983-11-21	1983-11-21 00:00:00	1983-11-21	5001	0	\N	0	0	\N	\N	0	168463	0	63513-6	40766240		
101016	3105	4024958	2001-07-15	2001-07-15 00:00:00	2001-07-15	5001	0	\N	0	0	\N	\N	0	206490	0	117015009	4024958		
1027	84	3005136	1979-04-08	1979-04-08 00:00:00	1979-04-08	5001	0	\N	0	0	\N	\N	0	5665	0	6075-6	3005136		
38936	3603	3019406	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	239334	0	6158-0	3019406		
37120	3415	3006322	1980-03-07	1980-03-07 00:00:00	1980-03-07	5001	0	\N	0	0	\N	\N	0	226514	0	8331-1	3006322		
31877	2909	3045716	1962-04-07	1962-04-07 00:00:00	1962-04-07	5001	0	\N	0	0	\N	\N	0	193910	0	33037-3	3045716		
93967	2893	4024958	1952-08-23	1952-08-23 00:00:00	1952-08-23	5001	0	\N	0	0	\N	\N	0	192452	0	117015009	4024958		
34808	3181	3051031	1952-12-12	1952-12-12 00:00:00	1952-12-12	5001	0	\N	0	0	\N	\N	0	211694	0	46240-8	3051031		
170645	5234	4133840	1998-04-29	1998-04-29 00:00:00	1998-04-29	5001	0	\N	0	0	\N	\N	0	348208	0	127783003	4133840		
8883	850	3006322	2013-03-14	2013-03-14 00:00:00	2013-03-14	5001	0	\N	0	0	\N	\N	0	56241	0	8331-1	3006322		
46317	4261	40758406	1957-06-26	1957-06-26 00:00:00	1957-06-26	5001	0	\N	0	0	\N	\N	0	282961	0	55277-8	40758406		
110603	3414	4052083	1982-04-05	1982-04-05 00:00:00	1982-04-05	5001	0	\N	0	0	\N	\N	0	226449	0	23426006	4052083		
161605	4963	4024958	2001-10-03	2001-10-03 00:00:00	2001-10-03	5001	0	\N	0	0	\N	\N	0	329888	0	117015009	4024958		
172998	5312	4133840	1995-12-11	1995-12-11 00:00:00	1995-12-11	5001	0	\N	0	0	\N	\N	0	353310	0	127783003	4133840		
7474	715	3006322	1984-08-11	1984-08-11 00:00:00	1984-08-11	5001	0	\N	0	0	\N	\N	0	47333	0	8331-1	3006322		
9655	911	3019406	1977-06-15	1977-06-15 00:00:00	1977-06-15	5001	0	\N	0	0	\N	\N	0	60471	0	6158-0	3019406		
21012	1950	3006322	1951-04-08	1951-04-08 00:00:00	1951-04-08	5001	0	\N	0	0	\N	\N	0	129710	0	8331-1	3006322		
53150	4883	3006322	1986-12-16	1986-12-16 00:00:00	1986-12-16	5001	0	\N	0	0	\N	\N	0	324689	0	8331-1	3006322		
19189	1762	3011505	1961-03-09	1961-03-09 00:00:00	1961-03-09	5001	0	\N	0	0	\N	\N	0	117887	0	19926-5	3011505		
60666	1850	4052083	1979-10-05	1979-10-05 00:00:00	1979-10-05	5001	0	\N	0	0	\N	\N	0	123754	0	23426006	4052083		
1590	141	3006322	1991-01-26	1991-01-26 00:00:00	1991-01-26	5001	0	\N	0	0	\N	\N	0	9448	0	8331-1	3006322		
12928	1228	3023430	1979-07-31	1979-07-31 00:00:00	1979-07-31	5001	0	\N	0	0	\N	\N	0	80917	0	6833-8	3023430		
77968	2392	4133840	1989-03-31	1989-03-31 00:00:00	1989-03-31	5001	0	\N	0	0	\N	\N	0	159005	0	127783003	4133840		
3805	364	3049273	2018-07-05	2018-07-05 00:00:00	2018-07-05	5001	0	\N	0	0	\N	\N	0	24213	0	38265-5	3049273		
13351	1267	3006322	1961-06-29	1961-06-29 00:00:00	1961-06-29	5001	0	\N	0	0	\N	\N	0	83514	0	8331-1	3006322		
17218	1567	3006322	1997-05-06	1997-05-06 00:00:00	1997-05-06	5001	0	\N	0	0	\N	\N	0	105104	0	8331-1	3006322		
41300	3852	3036780	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	255637	0	6095-4	3036780		
23536	2172	3006322	1991-11-11	1991-11-11 00:00:00	1991-11-11	5001	0	\N	0	0	\N	\N	0	144666	0	8331-1	3006322		
75330	2309	4052083	1990-08-29	1990-08-29 00:00:00	1990-08-29	5001	0	\N	0	0	\N	\N	0	153622	0	23426006	4052083		
56661	1727	4052083	2004-09-10	2004-09-10 00:00:00	2004-09-10	5001	0	\N	0	0	\N	\N	0	115441	0	23426006	4052083		
35186	3215	3036780	2006-04-29	2006-04-29 00:00:00	2006-04-29	5001	0	\N	0	0	\N	\N	0	213597	0	6095-4	3036780		
153419	4705	4024958	2016-04-07	2016-04-07 00:00:00	2016-04-07	5001	0	\N	0	0	\N	\N	0	313494	0	117015009	4024958		
82235	2543	4024958	1991-01-15	1991-01-15 00:00:00	1991-01-15	5001	0	\N	0	0	\N	\N	0	168221	0	117015009	4024958		
13972	1310	46235214	2003-08-13	2003-08-13 00:00:00	2003-08-13	5001	0	\N	0	0	\N	\N	0	86660	0	76690-7	46235214		
58065	5322	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	354184	0	6833-8	3023430		
3750	357	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	23698	0	6085-5	3001247		
150363	4608	4133840	1992-05-28	1992-05-28 00:00:00	1992-05-28	5001	0	\N	0	0	\N	\N	0	307087	0	127783003	4133840		
41352	3857	3011505	2011-09-20	2011-09-20 00:00:00	2011-09-20	5001	0	\N	0	0	\N	\N	0	256023	0	19926-5	3011505		
24287	2240	3006322	2016-12-05	2016-12-05 00:00:00	2016-12-05	5001	0	\N	0	0	\N	\N	0	149104	0	8331-1	3006322		
52540	4826	3006322	1992-04-17	1992-04-17 00:00:00	1992-04-17	5001	0	\N	0	0	\N	\N	0	320943	0	8331-1	3006322		
52592	4827	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	321161	0	6206-7	3012494		
4554	442	40769184	1980-08-24	1980-08-24 00:00:00	1980-08-24	5001	0	\N	0	0	\N	\N	0	29295	0	66524-0	40769184		
4402	426	3006322	1969-12-05	1969-12-05 00:00:00	1969-12-05	5001	0	\N	0	0	\N	\N	0	28249	0	8331-1	3006322		
2026	184	46235214	2019-02-09	2019-02-09 00:00:00	2019-02-09	5001	0	\N	0	0	\N	\N	0	12477	0	76690-7	46235214		
115045	3547	4052083	1987-02-16	1987-02-16 00:00:00	1987-02-16	5001	0	\N	0	0	\N	\N	0	235569	0	23426006	4052083		
27583	2546	3051031	1983-11-21	1983-11-21 00:00:00	1983-11-21	5001	0	\N	0	0	\N	\N	0	168463	0	46240-8	3051031		
101035	3106	4052083	1973-12-23	1973-12-23 00:00:00	1973-12-23	5001	0	\N	0	0	\N	\N	0	206556	0	23426006	4052083		
1028	84	3006734	1979-04-08	1979-04-08 00:00:00	1979-04-08	5001	0	\N	0	0	\N	\N	0	5665	0	6189-5	3006734		
38937	3603	3036780	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	239334	0	6095-4	3036780		
37121	3417	3006322	2008-09-03	2008-09-03 00:00:00	2008-09-03	5001	0	\N	0	0	\N	\N	0	226620	0	8331-1	3006322		
31878	2909	3020630	1962-04-07	1962-04-07 00:00:00	1962-04-07	5001	0	\N	0	0	\N	\N	0	193910	0	2885-2	3020630		
93973	2893	4024958	1972-07-13	1972-07-13 00:00:00	1972-07-13	5001	0	\N	0	0	\N	\N	0	192499	0	117015009	4024958		
34810	3181	40758406	1952-12-12	1952-12-12 00:00:00	1952-12-12	5001	0	\N	0	0	\N	\N	0	211694	0	55277-8	40758406		
170650	5234	4133840	2001-06-20	2001-06-20 00:00:00	2001-06-20	5001	0	\N	0	0	\N	\N	0	348299	0	127783003	4133840		
8884	851	3006322	1999-01-23	1999-01-23 00:00:00	1999-01-23	5001	0	\N	0	0	\N	\N	0	56280	0	8331-1	3006322		
46318	4261	40766240	1957-06-26	1957-06-26 00:00:00	1957-06-26	5001	0	\N	0	0	\N	\N	0	282961	0	63513-6	40766240		
110621	3415	4052083	2005-11-12	2005-11-12 00:00:00	2005-11-12	5001	0	\N	0	0	\N	\N	0	226549	0	23426006	4052083		
161609	4963	4024958	1975-07-20	1975-07-20 00:00:00	1975-07-20	5001	0	\N	0	0	\N	\N	0	329960	0	117015009	4024958		
173000	5312	4133840	2004-01-12	2004-01-12 00:00:00	2004-01-12	5001	0	\N	0	0	\N	\N	0	353243	0	127783003	4133840		
7475	715	3006322	1997-10-11	1997-10-11 00:00:00	1997-10-11	5001	0	\N	0	0	\N	\N	0	47291	0	8331-1	3006322		
9656	911	3006451	1977-06-15	1977-06-15 00:00:00	1977-06-15	5001	0	\N	0	0	\N	\N	0	60471	0	6273-7	3006451		
21013	1950	3011505	1999-11-04	1999-11-04 00:00:00	1999-11-04	5001	0	\N	0	0	\N	\N	0	129618	0	19926-5	3011505		
53151	4883	3006322	1955-03-19	1955-03-19 00:00:00	1955-03-19	5001	0	\N	0	0	\N	\N	0	324701	0	8331-1	3006322		
19190	1762	3006322	1996-03-29	1996-03-29 00:00:00	1996-03-29	5001	0	\N	0	0	\N	\N	0	117804	0	8331-1	3006322		
60668	1850	4024958	1984-10-06	1984-10-06 00:00:00	1984-10-06	5001	0	\N	0	0	\N	\N	0	123755	0	117015009	4024958		
1609	143	3006322	1979-05-20	1979-05-20 00:00:00	1979-05-20	5001	0	\N	0	0	\N	\N	0	9568	0	8331-1	3006322		
12929	1228	3001247	1979-07-31	1979-07-31 00:00:00	1979-07-31	5001	0	\N	0	0	\N	\N	0	80917	0	6085-5	3001247		
77969	2392	4133840	2010-07-30	2010-07-30 00:00:00	2010-07-30	5001	0	\N	0	0	\N	\N	0	158974	0	127783003	4133840		
3806	364	3006322	1973-02-08	1973-02-08 00:00:00	1973-02-08	5001	0	\N	0	0	\N	\N	0	24217	0	8331-1	3006322		
13352	1267	3006322	2016-01-21	2016-01-21 00:00:00	2016-01-21	5001	0	\N	0	0	\N	\N	0	83552	0	8331-1	3006322		
17219	1567	3006322	1989-10-07	1989-10-07 00:00:00	1989-10-07	5001	0	\N	0	0	\N	\N	0	105080	0	8331-1	3006322		
41301	3852	3015076	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	255637	0	6248-9	3015076		
23537	2172	3006322	1985-05-06	1985-05-06 00:00:00	1985-05-06	5001	0	\N	0	0	\N	\N	0	144662	0	8331-1	3006322		
75334	2309	4052083	1999-03-15	1999-03-15 00:00:00	1999-03-15	5001	0	\N	0	0	\N	\N	0	153623	0	23426006	4052083		
56664	1727	4133840	2018-12-05	2018-12-05 00:00:00	2018-12-05	5001	0	\N	0	0	\N	\N	0	115484	0	127783003	4133840		
35187	3215	3000876	2006-04-29	2006-04-29 00:00:00	2006-04-29	5001	0	\N	0	0	\N	\N	0	213597	0	6082-2	3000876		
153421	4705	4052083	1973-03-14	1973-03-14 00:00:00	1973-03-14	5001	0	\N	0	0	\N	\N	0	313484	0	23426006	4052083		
82244	2543	4052083	2015-10-23	2015-10-23 00:00:00	2015-10-23	5001	0	\N	0	0	\N	\N	0	168254	0	23426006	4052083		
13973	1310	40766240	2003-08-13	2003-08-13 00:00:00	2003-08-13	5001	0	\N	0	0	\N	\N	0	86660	0	63513-6	40766240		
58066	5322	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	354184	0	6189-5	3006734		
3751	357	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	23698	0	6833-8	3023430		
150371	4608	4133840	1998-12-31	1998-12-31 00:00:00	1998-12-31	5001	0	\N	0	0	\N	\N	0	307058	0	127783003	4133840		
41353	3857	3011505	2010-09-14	2010-09-14 00:00:00	2010-09-14	5001	0	\N	0	0	\N	\N	0	255965	0	19926-5	3011505		
24288	2240	3006322	1988-12-09	1988-12-09 00:00:00	1988-12-09	5001	0	\N	0	0	\N	\N	0	149143	0	8331-1	3006322		
52541	4826	3006322	2009-11-27	2009-11-27 00:00:00	2009-11-27	5001	0	\N	0	0	\N	\N	0	321034	0	8331-1	3006322		
52593	4827	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	321161	0	6106-9	3014599		
4555	442	40769179	1980-08-24	1980-08-24 00:00:00	1980-08-24	5001	0	\N	0	0	\N	\N	0	29295	0	66519-0	40769179		
4403	426	3006322	1975-05-06	1975-05-06 00:00:00	1975-05-06	5001	0	\N	0	0	\N	\N	0	28265	0	8331-1	3006322		
2027	184	40766240	2019-02-09	2019-02-09 00:00:00	2019-02-09	5001	0	\N	0	0	\N	\N	0	12477	0	63513-6	40766240		
115047	3547	4052083	2009-10-05	2009-10-05 00:00:00	2009-10-05	5001	0	\N	0	0	\N	\N	0	235596	0	23426006	4052083		
27584	2546	40758406	1983-11-21	1983-11-21 00:00:00	1983-11-21	5001	0	\N	0	0	\N	\N	0	168463	0	55277-8	40758406		
101050	3106	4024958	1963-07-03	1963-07-03 00:00:00	1963-07-03	5001	0	\N	0	0	\N	\N	0	206567	0	117015009	4024958		
1029	84	3014599	1979-04-08	1979-04-08 00:00:00	1979-04-08	5001	0	\N	0	0	\N	\N	0	5665	0	6106-9	3014599		
38938	3603	3014599	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	239334	0	6106-9	3014599		
37122	3417	3006322	1947-04-17	1947-04-17 00:00:00	1947-04-17	5001	0	\N	0	0	\N	\N	0	226604	0	8331-1	3006322		
31879	2909	3016723	1962-04-07	1962-04-07 00:00:00	1962-04-07	5001	0	\N	0	0	\N	\N	0	193910	0	2160-0	3016723		
105254	3240	4024958	1975-05-06	1975-05-06 00:00:00	1975-05-06	5001	0	\N	0	0	\N	\N	0	215335	0	117015009	4024958		
34811	3181	40766240	1952-12-12	1952-12-12 00:00:00	1952-12-12	5001	0	\N	0	0	\N	\N	0	211694	0	63513-6	40766240		
170651	5234	4024958	1965-09-15	1965-09-15 00:00:00	1965-09-15	5001	0	\N	0	0	\N	\N	0	348245	0	117015009	4024958		
8885	851	3006322	1995-04-30	1995-04-30 00:00:00	1995-04-30	5001	0	\N	0	0	\N	\N	0	56270	0	8331-1	3006322		
46319	4261	3051031	1957-06-26	1957-06-26 00:00:00	1957-06-26	5001	0	\N	0	0	\N	\N	0	282961	0	46240-8	3051031		
156587	4812	4024958	1974-02-16	1974-02-16 00:00:00	1974-02-16	5001	0	\N	0	0	\N	\N	0	320093	0	117015009	4024958		
172920	5309	4052083	1954-04-14	1954-04-14 00:00:00	1954-04-14	5001	0	\N	0	0	\N	\N	0	353086	0	23426006	4052083		
173001	5312	4133840	2000-12-25	2000-12-25 00:00:00	2000-12-25	5001	0	\N	0	0	\N	\N	0	353234	0	127783003	4133840		
7481	718	3006322	1971-11-01	1971-11-01 00:00:00	1971-11-01	5001	0	\N	0	0	\N	\N	0	47529	0	8331-1	3006322		
9657	911	3012494	1977-06-15	1977-06-15 00:00:00	1977-06-15	5001	0	\N	0	0	\N	\N	0	60471	0	6206-7	3012494		
21014	1950	3011505	1989-01-19	1989-01-19 00:00:00	1989-01-19	5001	0	\N	0	0	\N	\N	0	129616	0	19926-5	3011505		
53152	4883	3006322	1993-08-19	1993-08-19 00:00:00	1993-08-19	5001	0	\N	0	0	\N	\N	0	324636	0	8331-1	3006322		
19191	1762	3011505	1996-03-28	1996-03-28 00:00:00	1996-03-28	5001	0	\N	0	0	\N	\N	0	117825	0	19926-5	3011505		
60670	1850	4052083	2006-11-29	2006-11-29 00:00:00	2006-11-29	5001	0	\N	0	0	\N	\N	0	123779	0	23426006	4052083		
1610	143	3006322	1988-06-14	1988-06-14 00:00:00	1988-06-14	5001	0	\N	0	0	\N	\N	0	9569	0	8331-1	3006322		
12930	1228	3000876	1979-07-31	1979-07-31 00:00:00	1979-07-31	5001	0	\N	0	0	\N	\N	0	80917	0	6082-2	3000876		
77974	2392	4133840	2015-10-16	2015-10-16 00:00:00	2015-10-16	5001	0	\N	0	0	\N	\N	0	159069	0	127783003	4133840		
3807	364	3006322	1981-04-08	1981-04-08 00:00:00	1981-04-08	5001	0	\N	0	0	\N	\N	0	24157	0	8331-1	3006322		
13353	1267	3006322	2012-12-20	2012-12-20 00:00:00	2012-12-20	5001	0	\N	0	0	\N	\N	0	83523	0	8331-1	3006322		
17220	1567	3021226	1975-10-07	1975-10-07 00:00:00	1975-10-07	5001	0	\N	0	0	\N	\N	0	105078	0	6246-3	3021226		
41302	3852	3006451	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	255637	0	6273-7	3006451		
23538	2173	3006322	1976-11-21	1976-11-21 00:00:00	1976-11-21	5001	0	\N	0	0	\N	\N	0	144730	0	8331-1	3006322		
160284	4927	4024958	2002-05-02	2002-05-02 00:00:00	2002-05-02	5001	0	\N	0	0	\N	\N	0	327437	0	117015009	4024958		
56666	1727	4133840	2011-10-27	2011-10-27 00:00:00	2011-10-27	5001	0	\N	0	0	\N	\N	0	115458	0	127783003	4133840		
35188	3215	3001247	2006-04-29	2006-04-29 00:00:00	2006-04-29	5001	0	\N	0	0	\N	\N	0	213597	0	6085-5	3001247		
153428	4705	4052083	1979-05-22	1979-05-22 00:00:00	1979-05-22	5001	0	\N	0	0	\N	\N	0	313466	0	23426006	4052083		
46603	4288	3006322	1966-10-11	1966-10-11 00:00:00	1966-10-11	5001	0	\N	0	0	\N	\N	0	284663	0	8331-1	3006322		
13974	1310	3051031	2003-08-13	2003-08-13 00:00:00	2003-08-13	5001	0	\N	0	0	\N	\N	0	86660	0	46240-8	3051031		
58067	5322	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	354184	0	6106-9	3014599		
3752	357	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	23698	0	6095-4	3036780		
150376	4608	4133840	2003-02-27	2003-02-27 00:00:00	2003-02-27	5001	0	\N	0	0	\N	\N	0	306941	0	127783003	4133840		
41354	3857	3011505	2002-07-30	2002-07-30 00:00:00	2002-07-30	5001	0	\N	0	0	\N	\N	0	256022	0	19926-5	3011505		
24289	2240	3006322	2004-06-01	2004-06-01 00:00:00	2004-06-01	5001	0	\N	0	0	\N	\N	0	149144	0	8331-1	3006322		
52542	4826	3001488	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	320923	0	7258-7	3001488		
52594	4827	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	321161	0	6844-5	3020655		
4556	442	40769189	1980-08-24	1980-08-24 00:00:00	1980-08-24	5001	0	\N	0	0	\N	\N	0	29295	0	66529-9	40769189		
4404	426	3006322	1971-06-14	1971-06-14 00:00:00	1971-06-14	5001	0	\N	0	0	\N	\N	0	28250	0	8331-1	3006322		
2030	184	3006322	1966-10-28	1966-10-28 00:00:00	1966-10-28	5001	0	\N	0	0	\N	\N	0	12433	0	8331-1	3006322		
115070	3549	4024958	1982-04-20	1982-04-20 00:00:00	1982-04-20	5001	0	\N	0	0	\N	\N	0	235679	0	117015009	4024958		
27586	2546	40758406	1984-01-20	1984-01-20 00:00:00	1984-01-20	5001	0	\N	0	0	\N	\N	0	168490	0	55277-8	40758406		
43895	1352	4133840	1999-03-21	1999-03-21 00:00:00	1999-03-21	5001	0	\N	0	0	\N	\N	0	89541	0	127783003	4133840		
1030	84	3000876	1979-04-08	1979-04-08 00:00:00	1979-04-08	5001	0	\N	0	0	\N	\N	0	5665	0	6082-2	3000876		
38939	3603	3027231	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	239334	0	6276-0	3027231		
37123	3417	3006322	1917-04-18	1917-04-18 00:00:00	1917-04-18	5001	0	\N	0	0	\N	\N	0	226602	0	8331-1	3006322		
31880	2909	3009542	1962-04-07	1962-04-07 00:00:00	1962-04-07	5001	0	\N	0	0	\N	\N	0	193910	0	20570-8	3009542		
105273	3240	4052083	2010-09-09	2010-09-09 00:00:00	2010-09-09	5001	0	\N	0	0	\N	\N	0	215389	0	23426006	4052083		
34813	3181	46235214	1952-12-12	1952-12-12 00:00:00	1952-12-12	5001	0	\N	0	0	\N	\N	0	211694	0	76690-7	46235214		
170655	5234	4133840	2002-06-26	2002-06-26 00:00:00	2002-06-26	5001	0	\N	0	0	\N	\N	0	348283	0	127783003	4133840		
8886	851	3006322	2011-11-06	2011-11-06 00:00:00	2011-11-06	5001	0	\N	0	0	\N	\N	0	56271	0	8331-1	3006322		
46321	4261	46235214	1957-06-26	1957-06-26 00:00:00	1957-06-26	5001	0	\N	0	0	\N	\N	0	282961	0	76690-7	46235214		
156588	4812	4024958	1986-07-26	1986-07-26 00:00:00	1986-07-26	5001	0	\N	0	0	\N	\N	0	320110	0	117015009	4024958		
172922	5309	4052083	1974-08-23	1974-08-23 00:00:00	1974-08-23	5001	0	\N	0	0	\N	\N	0	353115	0	23426006	4052083		
173002	5312	4133840	1977-01-03	1977-01-03 00:00:00	1977-01-03	5001	0	\N	0	0	\N	\N	0	353263	0	127783003	4133840		
7482	718	3001247	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	47487	0	6085-5	3001247		
9658	911	3006734	1977-06-15	1977-06-15 00:00:00	1977-06-15	5001	0	\N	0	0	\N	\N	0	60471	0	6189-5	3006734		
21015	1950	3011505	2015-01-29	2015-01-29 00:00:00	2015-01-29	5001	0	\N	0	0	\N	\N	0	129684	0	19926-5	3011505		
53153	4883	3006322	2015-12-05	2015-12-05 00:00:00	2015-12-05	5001	0	\N	0	0	\N	\N	0	324704	0	8331-1	3006322		
19192	1762	3011505	1984-02-09	1984-02-09 00:00:00	1984-02-09	5001	0	\N	0	0	\N	\N	0	117842	0	19926-5	3011505		
163824	5034	4052083	1930-12-22	1930-12-22 00:00:00	1930-12-22	5001	0	\N	0	0	\N	\N	0	334526	0	23426006	4052083		
1611	143	3006322	1990-02-20	1990-02-20 00:00:00	1990-02-20	5001	0	\N	0	0	\N	\N	0	9547	0	8331-1	3006322		
12931	1228	3015076	1979-07-31	1979-07-31 00:00:00	1979-07-31	5001	0	\N	0	0	\N	\N	0	80917	0	6248-9	3015076		
77977	2392	4133840	1951-10-12	1951-10-12 00:00:00	1951-10-12	5001	0	\N	0	0	\N	\N	0	158998	0	127783003	4133840		
3811	366	3006322	1995-07-26	1995-07-26 00:00:00	1995-07-26	5001	0	\N	0	0	\N	\N	0	24325	0	8331-1	3006322		
13354	1267	3006322	1954-10-26	1954-10-26 00:00:00	1954-10-26	5001	0	\N	0	0	\N	\N	0	83516	0	8331-1	3006322		
17221	1567	3001488	1975-10-07	1975-10-07 00:00:00	1975-10-07	5001	0	\N	0	0	\N	\N	0	105078	0	7258-7	3001488		
41303	3852	3021226	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	255637	0	6246-3	3021226		
23539	2173	3000963	1974-06-27	1974-06-27 00:00:00	1974-06-27	5001	0	\N	0	0	\N	\N	0	144867	0	718-7	3000963		
160291	4927	4052083	2014-11-20	2014-11-20 00:00:00	2014-11-20	5001	0	\N	0	0	\N	\N	0	327438	0	23426006	4052083		
142799	4387	4024958	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	291601	0	117015009	4024958		
35189	3215	3023430	2006-04-29	2006-04-29 00:00:00	2006-04-29	5001	0	\N	0	0	\N	\N	0	213597	0	6833-8	3023430		
153432	4705	4052083	1984-11-28	1984-11-28 00:00:00	1984-11-28	5001	0	\N	0	0	\N	\N	0	313476	0	23426006	4052083		
46604	4288	3006322	2010-03-07	2010-03-07 00:00:00	2010-03-07	5001	0	\N	0	0	\N	\N	0	284717	0	8331-1	3006322		
13975	1310	40758406	2003-08-13	2003-08-13 00:00:00	2003-08-13	5001	0	\N	0	0	\N	\N	0	86660	0	55277-8	40758406		
58068	5322	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	354184	0	6075-6	3005136		
3753	357	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	23698	0	6082-2	3000876		
24761	771	4024958	1993-12-31	1993-12-31 00:00:00	1993-12-31	5001	0	\N	0	0	\N	\N	0	51232	0	117015009	4024958		
41355	3857	3011505	2004-08-10	2004-08-10 00:00:00	2004-08-10	5001	0	\N	0	0	\N	\N	0	255989	0	19926-5	3011505		
24290	2240	3006322	2008-12-28	2008-12-28 00:00:00	2008-12-28	5001	0	\N	0	0	\N	\N	0	149147	0	8331-1	3006322		
52543	4826	3020655	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	320923	0	6844-5	3020655		
52595	4827	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	321161	0	6085-5	3001247		
4557	442	3006322	2015-09-29	2015-09-29 00:00:00	2015-09-29	5001	0	\N	0	0	\N	\N	0	29370	0	8331-1	3006322		
4405	426	3006322	1967-12-05	1967-12-05 00:00:00	1967-12-05	5001	0	\N	0	0	\N	\N	0	28257	0	8331-1	3006322		
2031	184	3006322	1950-06-12	1950-06-12 00:00:00	1950-06-12	5001	0	\N	0	0	\N	\N	0	12496	0	8331-1	3006322		
115072	3549	4024958	1981-11-07	1981-11-07 00:00:00	1981-11-07	5001	0	\N	0	0	\N	\N	0	235678	0	117015009	4024958		
27587	2546	46235214	1984-01-20	1984-01-20 00:00:00	1984-01-20	5001	0	\N	0	0	\N	\N	0	168490	0	76690-7	46235214		
43896	1352	4024958	1947-04-05	1947-04-05 00:00:00	1947-04-05	5001	0	\N	0	0	\N	\N	0	89533	0	117015009	4024958		
1031	84	3006451	1979-04-08	1979-04-08 00:00:00	1979-04-08	5001	0	\N	0	0	\N	\N	0	5665	0	6273-7	3006451		
38940	3603	3001247	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	239334	0	6085-5	3001247		
37124	3417	3006322	1916-10-09	1916-10-09 00:00:00	1916-10-09	5001	0	\N	0	0	\N	\N	0	226577	0	8331-1	3006322		
31881	2909	3028833	1962-04-07	1962-04-07 00:00:00	1962-04-07	5001	0	\N	0	0	\N	\N	0	193910	0	42719-5	3028833		
105275	3240	4052083	2006-07-10	2006-07-10 00:00:00	2006-07-10	5001	0	\N	0	0	\N	\N	0	215349	0	23426006	4052083		
34814	3181	3051031	1953-01-11	1953-01-11 00:00:00	1953-01-11	5001	0	\N	0	0	\N	\N	0	211806	0	46240-8	3051031		
170662	5234	4133840	2003-07-02	2003-07-02 00:00:00	2003-07-02	5001	0	\N	0	0	\N	\N	0	348209	0	127783003	4133840		
8887	851	3006322	1994-10-20	1994-10-20 00:00:00	1994-10-20	5001	0	\N	0	0	\N	\N	0	56305	0	8331-1	3006322		
46323	4261	3006322	1937-11-13	1937-11-13 00:00:00	1937-11-13	5001	0	\N	0	0	\N	\N	0	282937	0	8331-1	3006322		
156611	4814	4024958	1942-03-26	1942-03-26 00:00:00	1942-03-26	5001	0	\N	0	0	\N	\N	0	320301	0	117015009	4024958		
172928	5309	4052083	1966-04-20	1966-04-20 00:00:00	1966-04-20	5001	0	\N	0	0	\N	\N	0	353056	0	23426006	4052083		
173003	5312	4133840	1979-01-08	1979-01-08 00:00:00	1979-01-08	5001	0	\N	0	0	\N	\N	0	353238	0	127783003	4133840		
7483	718	3023430	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	47487	0	6833-8	3023430		
9659	911	3021226	1977-06-15	1977-06-15 00:00:00	1977-06-15	5001	0	\N	0	0	\N	\N	0	60471	0	6246-3	3021226		
21016	1950	3011505	2005-12-08	2005-12-08 00:00:00	2005-12-08	5001	0	\N	0	0	\N	\N	0	129662	0	19926-5	3011505		
53154	4883	3006322	1981-12-09	1981-12-09 00:00:00	1981-12-09	5001	0	\N	0	0	\N	\N	0	324634	0	8331-1	3006322		
19193	1762	3006322	1952-08-01	1952-08-01 00:00:00	1952-08-01	5001	0	\N	0	0	\N	\N	0	117891	0	8331-1	3006322		
163830	5034	4024958	1929-06-05	1929-06-05 00:00:00	1929-06-05	5001	0	\N	0	0	\N	\N	0	334434	0	117015009	4024958		
12889	1227	3006322	1984-12-27	1984-12-27 00:00:00	1984-12-27	5001	0	\N	0	0	\N	\N	0	80755	0	8331-1	3006322		
12932	1228	3027231	1979-07-31	1979-07-31 00:00:00	1979-07-31	5001	0	\N	0	0	\N	\N	0	80917	0	6276-0	3027231		
77978	2392	4133840	1954-10-15	1954-10-15 00:00:00	1954-10-15	5001	0	\N	0	0	\N	\N	0	158999	0	127783003	4133840		
3812	366	3006322	1981-06-14	1981-06-14 00:00:00	1981-06-14	5001	0	\N	0	0	\N	\N	0	24276	0	8331-1	3006322		
13355	1267	3006322	2005-09-14	2005-09-14 00:00:00	2005-09-14	5001	0	\N	0	0	\N	\N	0	83522	0	8331-1	3006322		
17222	1567	3001247	1975-10-07	1975-10-07 00:00:00	1975-10-07	5001	0	\N	0	0	\N	\N	0	105078	0	6085-5	3001247		
62577	1921	4052083	1991-07-06	1991-07-06 00:00:00	1991-07-06	5001	0	\N	0	0	\N	\N	0	127738	0	23426006	4052083		
23540	2173	3009542	1974-06-27	1974-06-27 00:00:00	1974-06-27	5001	0	\N	0	0	\N	\N	0	144867	0	20570-8	3009542		
160295	4927	4052083	1990-07-15	1990-07-15 00:00:00	1990-07-15	5001	0	\N	0	0	\N	\N	0	327482	0	23426006	4052083		
142809	4387	4024958	1979-08-03	1979-08-03 00:00:00	1979-08-03	5001	0	\N	0	0	\N	\N	0	291607	0	117015009	4024958		
35190	3215	3006451	2006-04-29	2006-04-29 00:00:00	2006-04-29	5001	0	\N	0	0	\N	\N	0	213597	0	6273-7	3006451		
153433	4705	4024958	1985-05-21	1985-05-21 00:00:00	1985-05-21	5001	0	\N	0	0	\N	\N	0	313477	0	117015009	4024958		
46605	4288	3006322	2006-12-09	2006-12-09 00:00:00	2006-12-09	5001	0	\N	0	0	\N	\N	0	284676	0	8331-1	3006322		
13976	1310	3006322	1979-05-03	1979-05-03 00:00:00	1979-05-03	5001	0	\N	0	0	\N	\N	0	86563	0	8331-1	3006322		
58069	5322	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	354184	0	6246-3	3021226		
3754	357	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	23698	0	6106-9	3014599		
24768	771	4024958	1967-05-29	1967-05-29 00:00:00	1967-05-29	5001	0	\N	0	0	\N	\N	0	51172	0	117015009	4024958		
41356	3857	3006322	1978-07-04	1978-07-04 00:00:00	1978-07-04	5001	0	\N	0	0	\N	\N	0	255957	0	8331-1	3006322		
24291	2240	3006322	2012-09-16	2012-09-16 00:00:00	2012-09-16	5001	0	\N	0	0	\N	\N	0	149118	0	8331-1	3006322		
52544	4826	3000876	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	320923	0	6082-2	3000876		
52596	4827	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	321161	0	6082-2	3000876		
4558	442	3006322	1970-12-23	1970-12-23 00:00:00	1970-12-23	5001	0	\N	0	0	\N	\N	0	29335	0	8331-1	3006322		
4415	430	3049273	2011-11-19	2011-11-19 00:00:00	2011-11-19	5001	0	\N	0	0	\N	\N	0	28547	0	38265-5	3049273		
2032	184	3006322	1950-02-25	1950-02-25 00:00:00	1950-02-25	5001	0	\N	0	0	\N	\N	0	12432	0	8331-1	3006322		
115076	3549	4024958	1972-01-19	1972-01-19 00:00:00	1972-01-19	5001	0	\N	0	0	\N	\N	0	235666	0	117015009	4024958		
27589	2546	40766240	1984-01-20	1984-01-20 00:00:00	1984-01-20	5001	0	\N	0	0	\N	\N	0	168490	0	63513-6	40766240		
43903	1352	4133840	2019-02-03	2019-02-03 00:00:00	2019-02-03	5001	0	\N	0	0	\N	\N	0	89548	0	127783003	4133840		
1032	84	3015076	1979-04-08	1979-04-08 00:00:00	1979-04-08	5001	0	\N	0	0	\N	\N	0	5665	0	6248-9	3015076		
38941	3603	3000876	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	239334	0	6082-2	3000876		
37125	3417	3006322	1925-09-01	1925-09-01 00:00:00	1925-09-01	5001	0	\N	0	0	\N	\N	0	226579	0	8331-1	3006322		
31882	2909	3011505	1972-03-26	1972-03-26 00:00:00	1972-03-26	5001	0	\N	0	0	\N	\N	0	193851	0	19926-5	3011505		
34816	3181	40758406	1953-01-11	1953-01-11 00:00:00	1953-01-11	5001	0	\N	0	0	\N	\N	0	211806	0	55277-8	40758406		
170664	5234	4133840	2000-05-10	2000-05-10 00:00:00	2000-05-10	5001	0	\N	0	0	\N	\N	0	348281	0	127783003	4133840		
8888	851	3006322	2009-07-08	2009-07-08 00:00:00	2009-07-08	5001	0	\N	0	0	\N	\N	0	56306	0	8331-1	3006322		
46324	4261	3006322	1928-08-10	1928-08-10 00:00:00	1928-08-10	5001	0	\N	0	0	\N	\N	0	282971	0	8331-1	3006322		
156624	4814	4024958	1947-06-29	1947-06-29 00:00:00	1947-06-29	5001	0	\N	0	0	\N	\N	0	320252	0	117015009	4024958		
8725	276	4052083	1983-04-11	1983-04-11 00:00:00	1983-04-11	5001	0	\N	0	0	\N	\N	0	18442	0	23426006	4052083		
173005	5312	4024958	1951-11-22	1951-11-22 00:00:00	1951-11-22	5001	0	\N	0	0	\N	\N	0	353247	0	117015009	4024958		
7484	718	3020655	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	47487	0	6844-5	3020655		
9660	911	3005136	1977-06-15	1977-06-15 00:00:00	1977-06-15	5001	0	\N	0	0	\N	\N	0	60471	0	6075-6	3005136		
21017	1950	3011505	2008-12-25	2008-12-25 00:00:00	2008-12-25	5001	0	\N	0	0	\N	\N	0	129708	0	19926-5	3011505		
53155	4883	3006322	1954-01-12	1954-01-12 00:00:00	1954-01-12	5001	0	\N	0	0	\N	\N	0	324683	0	8331-1	3006322		
19194	1762	3006322	1969-12-24	1969-12-24 00:00:00	1969-12-24	5001	0	\N	0	0	\N	\N	0	117848	0	8331-1	3006322		
163832	5034	4052083	1980-09-25	1980-09-25 00:00:00	1980-09-25	5001	0	\N	0	0	\N	\N	0	334442	0	23426006	4052083		
12890	1227	3006322	1966-11-09	1966-11-09 00:00:00	1966-11-09	5001	0	\N	0	0	\N	\N	0	80804	0	8331-1	3006322		
12933	1228	3019406	1979-07-31	1979-07-31 00:00:00	1979-07-31	5001	0	\N	0	0	\N	\N	0	80917	0	6158-0	3019406		
77981	2392	4133840	1985-03-08	1985-03-08 00:00:00	1985-03-08	5001	0	\N	0	0	\N	\N	0	159089	0	127783003	4133840		
3813	366	3006322	2011-12-23	2011-12-23 00:00:00	2011-12-23	5001	0	\N	0	0	\N	\N	0	24346	0	8331-1	3006322		
13356	1267	3006322	1999-01-05	1999-01-05 00:00:00	1999-01-05	5001	0	\N	0	0	\N	\N	0	83576	0	8331-1	3006322		
17223	1567	3012494	1975-10-07	1975-10-07 00:00:00	1975-10-07	5001	0	\N	0	0	\N	\N	0	105078	0	6206-7	3012494		
62579	1921	4024958	1954-10-09	1954-10-09 00:00:00	1954-10-09	5001	0	\N	0	0	\N	\N	0	127762	0	117015009	4024958		
23541	2173	3006322	1972-10-02	1972-10-02 00:00:00	1972-10-02	5001	0	\N	0	0	\N	\N	0	144866	0	8331-1	3006322		
160320	4927	4024958	1983-01-23	1983-01-23 00:00:00	1983-01-23	5001	0	\N	0	0	\N	\N	0	327481	0	117015009	4024958		
93050	2864	4052083	2012-03-19	2012-03-19 00:00:00	2012-03-19	5001	0	\N	0	0	\N	\N	0	190515	0	23426006	4052083		
35191	3215	3015076	2006-04-29	2006-04-29 00:00:00	2006-04-29	5001	0	\N	0	0	\N	\N	0	213597	0	6248-9	3015076		
153434	4705	4052083	1983-01-09	1983-01-09 00:00:00	1983-01-09	5001	0	\N	0	0	\N	\N	0	313490	0	23426006	4052083		
46606	4288	3006322	1973-02-21	1973-02-21 00:00:00	1973-02-21	5001	0	\N	0	0	\N	\N	0	284699	0	8331-1	3006322		
13977	1310	3006322	2010-12-11	2010-12-11 00:00:00	2010-12-11	5001	0	\N	0	0	\N	\N	0	86662	0	8331-1	3006322		
58070	5322	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	354184	0	6276-0	3027231		
3755	357	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	23698	0	6276-0	3027231		
24825	774	4052083	1994-12-22	1994-12-22 00:00:00	1994-12-22	5001	0	\N	0	0	\N	\N	0	51372	0	23426006	4052083		
41357	3857	3011505	1974-12-17	1974-12-17 00:00:00	1974-12-17	5001	0	\N	0	0	\N	\N	0	256043	0	19926-5	3011505		
24293	2242	3006322	1986-09-07	1986-09-07 00:00:00	1986-09-07	5001	0	\N	0	0	\N	\N	0	149235	0	8331-1	3006322		
52545	4826	3001247	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	320923	0	6085-5	3001247		
52597	4827	3006322	1980-08-16	1980-08-16 00:00:00	1980-08-16	5001	0	\N	0	0	\N	\N	0	321113	0	8331-1	3006322		
4559	442	3051031	1948-11-20	1948-11-20 00:00:00	1948-11-20	5001	0	\N	0	0	\N	\N	0	29333	0	46240-8	3051031		
4416	430	3006322	2008-04-30	2008-04-30 00:00:00	2008-04-30	5001	0	\N	0	0	\N	\N	0	28475	0	8331-1	3006322		
2033	185	3011505	2018-06-03	2018-06-03 00:00:00	2018-06-03	5001	0	\N	0	0	\N	\N	0	12581	0	19926-5	3011505		
115077	3549	4024958	1999-07-15	1999-07-15 00:00:00	1999-07-15	5001	0	\N	0	0	\N	\N	0	235683	0	117015009	4024958		
27590	2546	3051031	1984-01-20	1984-01-20 00:00:00	1984-01-20	5001	0	\N	0	0	\N	\N	0	168490	0	46240-8	3051031		
43905	1352	4024958	1985-07-16	1985-07-16 00:00:00	1985-07-16	5001	0	\N	0	0	\N	\N	0	89593	0	117015009	4024958		
1033	84	3012494	1979-04-08	1979-04-08 00:00:00	1979-04-08	5001	0	\N	0	0	\N	\N	0	5665	0	6206-7	3012494		
38942	3603	3006734	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	239334	0	6189-5	3006734		
37126	3417	3006322	1925-03-21	1925-03-21 00:00:00	1925-03-21	5001	0	\N	0	0	\N	\N	0	226578	0	8331-1	3006322		
31883	2909	3011505	2003-06-22	2003-06-22 00:00:00	2003-06-22	5001	0	\N	0	0	\N	\N	0	193879	0	19926-5	3011505		
34817	3181	40766240	1953-01-11	1953-01-11 00:00:00	1953-01-11	5001	0	\N	0	0	\N	\N	0	211806	0	63513-6	40766240		
170668	5234	4133840	2004-07-07	2004-07-07 00:00:00	2004-07-07	5001	0	\N	0	0	\N	\N	0	348276	0	127783003	4133840		
8889	851	3006322	1990-10-30	1990-10-30 00:00:00	1990-10-30	5001	0	\N	0	0	\N	\N	0	56321	0	8331-1	3006322		
46349	4268	3006322	1965-05-09	1965-05-09 00:00:00	1965-05-09	5001	0	\N	0	0	\N	\N	0	283276	0	8331-1	3006322		
167906	5153	4024958	1972-01-07	1972-01-07 00:00:00	1972-01-07	5001	0	\N	0	0	\N	\N	0	342679	0	117015009	4024958		
8732	276	4024958	1984-04-16	1984-04-16 00:00:00	1984-04-16	5001	0	\N	0	0	\N	\N	0	18417	0	117015009	4024958		
173006	5312	4133840	1984-12-03	1984-12-03 00:00:00	1984-12-03	5001	0	\N	0	0	\N	\N	0	353239	0	127783003	4133840		
7485	718	3001488	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	47487	0	7258-7	3001488		
9661	911	3023430	1977-06-15	1977-06-15 00:00:00	1977-06-15	5001	0	\N	0	0	\N	\N	0	60471	0	6833-8	3023430		
21018	1950	3011505	1985-01-10	1985-01-10 00:00:00	1985-01-10	5001	0	\N	0	0	\N	\N	0	129690	0	19926-5	3011505		
53156	4883	3006322	2017-01-09	2017-01-09 00:00:00	2017-01-09	5001	0	\N	0	0	\N	\N	0	324637	0	8331-1	3006322		
19195	1762	3011505	1967-10-12	1967-10-12 00:00:00	1967-10-12	5001	0	\N	0	0	\N	\N	0	117814	0	19926-5	3011505		
163842	5034	4052083	1923-01-08	1923-01-08 00:00:00	1923-01-08	5001	0	\N	0	0	\N	\N	0	334432	0	23426006	4052083		
12891	1227	3006322	1988-04-21	1988-04-21 00:00:00	1988-04-21	5001	0	\N	0	0	\N	\N	0	80756	0	8331-1	3006322		
12934	1228	3036780	1979-07-31	1979-07-31 00:00:00	1979-07-31	5001	0	\N	0	0	\N	\N	0	80917	0	6095-4	3036780		
77982	2392	4133840	1974-03-15	1974-03-15 00:00:00	1974-03-15	5001	0	\N	0	0	\N	\N	0	159075	0	127783003	4133840		
3814	366	3006322	1988-01-21	1988-01-21 00:00:00	1988-01-21	5001	0	\N	0	0	\N	\N	0	24324	0	8331-1	3006322		
13415	1271	3006322	1991-09-17	1991-09-17 00:00:00	1991-09-17	5001	0	\N	0	0	\N	\N	0	83839	0	8331-1	3006322		
17224	1567	3000876	1975-10-07	1975-10-07 00:00:00	1975-10-07	5001	0	\N	0	0	\N	\N	0	105078	0	6082-2	3000876		
24401	760	4024958	1971-10-22	1971-10-22 00:00:00	1971-10-22	5001	0	\N	0	0	\N	\N	0	50455	0	117015009	4024958		
23542	2173	3006322	1934-05-29	1934-05-29 00:00:00	1934-05-29	5001	0	\N	0	0	\N	\N	0	144863	0	8331-1	3006322		
160325	4927	4052083	2007-05-22	2007-05-22 00:00:00	2007-05-22	5001	0	\N	0	0	\N	\N	0	327495	0	23426006	4052083		
93053	2864	4052083	1990-06-10	1990-06-10 00:00:00	1990-06-10	5001	0	\N	0	0	\N	\N	0	190511	0	23426006	4052083		
35192	3215	3027231	2006-04-29	2006-04-29 00:00:00	2006-04-29	5001	0	\N	0	0	\N	\N	0	213597	0	6276-0	3027231		
153439	4705	4024958	1992-10-04	1992-10-04 00:00:00	1992-10-04	5001	0	\N	0	0	\N	\N	0	313488	0	117015009	4024958		
46607	4288	3006322	1960-08-22	1960-08-22 00:00:00	1960-08-22	5001	0	\N	0	0	\N	\N	0	284698	0	8331-1	3006322		
13978	1310	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	86685	0	6248-9	3015076		
58071	5322	3049273	2007-05-09	2007-05-09 00:00:00	2007-05-09	5001	0	\N	0	0	\N	\N	0	354256	0	38265-5	3049273		
3756	357	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	23698	0	6844-5	3020655		
24829	774	4024958	1969-12-08	1969-12-08 00:00:00	1969-12-08	5001	0	\N	0	0	\N	\N	0	51392	0	117015009	4024958		
41358	3857	3006322	1974-12-08	1974-12-08 00:00:00	1974-12-08	5001	0	\N	0	0	\N	\N	0	255950	0	8331-1	3006322		
24294	2242	3006322	1929-09-28	1929-09-28 00:00:00	1929-09-28	5001	0	\N	0	0	\N	\N	0	149232	0	8331-1	3006322		
52546	4826	3023430	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	320923	0	6833-8	3023430		
52598	4828	3006322	1989-06-06	1989-06-06 00:00:00	1989-06-06	5001	0	\N	0	0	\N	\N	0	321238	0	8331-1	3006322		
4561	442	40758406	1948-11-20	1948-11-20 00:00:00	1948-11-20	5001	0	\N	0	0	\N	\N	0	29333	0	55277-8	40758406		
4417	430	3009201	1990-06-05	1990-06-05 00:00:00	1990-06-05	5001	0	\N	0	0	\N	\N	0	28434	0	3016-3	3009201		
2034	185	3011505	2013-05-26	2013-05-26 00:00:00	2013-05-26	5001	0	\N	0	0	\N	\N	0	12564	0	19926-5	3011505		
115089	3549	4024958	2001-05-18	2001-05-18 00:00:00	2001-05-18	5001	0	\N	0	0	\N	\N	0	235655	0	117015009	4024958		
27591	2546	40758406	1983-08-23	1983-08-23 00:00:00	1983-08-23	5001	0	\N	0	0	\N	\N	0	168462	0	55277-8	40758406		
43908	1352	4133840	1997-08-31	1997-08-31 00:00:00	1997-08-31	5001	0	\N	0	0	\N	\N	0	89587	0	127783003	4133840		
1034	84	3001247	1979-04-08	1979-04-08 00:00:00	1979-04-08	5001	0	\N	0	0	\N	\N	0	5665	0	6085-5	3001247		
38943	3603	3023430	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	239334	0	6833-8	3023430		
37127	3417	3049273	1980-06-15	1980-06-15 00:00:00	1980-06-15	5001	0	\N	0	0	\N	\N	0	226624	0	38265-5	3049273		
31884	2909	3011505	1988-04-17	1988-04-17 00:00:00	1988-04-17	5001	0	\N	0	0	\N	\N	0	193852	0	19926-5	3011505		
34819	3181	46235214	1953-01-11	1953-01-11 00:00:00	1953-01-11	5001	0	\N	0	0	\N	\N	0	211806	0	76690-7	46235214		
170670	5235	4052083	1973-10-19	1973-10-19 00:00:00	1973-10-19	5001	0	\N	0	0	\N	\N	0	348355	0	23426006	4052083		
8890	851	3006322	1989-08-22	1989-08-22 00:00:00	1989-08-22	5001	0	\N	0	0	\N	\N	0	56320	0	8331-1	3006322		
46350	4268	3006322	1967-08-11	1967-08-11 00:00:00	1967-08-11	5001	0	\N	0	0	\N	\N	0	283266	0	8331-1	3006322		
167909	5153	4024958	1998-04-02	1998-04-02 00:00:00	1998-04-02	5001	0	\N	0	0	\N	\N	0	342670	0	117015009	4024958		
8738	276	4052083	1983-08-18	1983-08-18 00:00:00	1983-08-18	5001	0	\N	0	0	\N	\N	0	18406	0	23426006	4052083		
173008	5312	4133840	1973-12-31	1973-12-31 00:00:00	1973-12-31	5001	0	\N	0	0	\N	\N	0	353262	0	127783003	4133840		
7486	718	3006451	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	47487	0	6273-7	3006451		
9662	911	3001247	1977-06-15	1977-06-15 00:00:00	1977-06-15	5001	0	\N	0	0	\N	\N	0	60471	0	6085-5	3001247		
21019	1950	3011505	1991-09-19	1991-09-19 00:00:00	1991-09-19	5001	0	\N	0	0	\N	\N	0	129655	0	19926-5	3011505		
53157	4883	3006322	1982-12-20	1982-12-20 00:00:00	1982-12-20	5001	0	\N	0	0	\N	\N	0	324635	0	8331-1	3006322		
19196	1762	3011505	1964-03-12	1964-03-12 00:00:00	1964-03-12	5001	0	\N	0	0	\N	\N	0	117888	0	19926-5	3011505		
163850	5034	4052083	1965-01-30	1965-01-30 00:00:00	1965-01-30	5001	0	\N	0	0	\N	\N	0	334517	0	23426006	4052083		
12892	1227	3049273	2004-05-22	2004-05-22 00:00:00	2004-05-22	5001	0	\N	0	0	\N	\N	0	80823	0	38265-5	3049273		
12935	1228	3001488	1979-07-31	1979-07-31 00:00:00	1979-07-31	5001	0	\N	0	0	\N	\N	0	80917	0	7258-7	3001488		
77984	2392	4133840	2013-08-16	2013-08-16 00:00:00	2013-08-16	5001	0	\N	0	0	\N	\N	0	158982	0	127783003	4133840		
3815	366	3006322	2009-08-23	2009-08-23 00:00:00	2009-08-23	5001	0	\N	0	0	\N	\N	0	24343	0	8331-1	3006322		
13416	1271	3006322	2014-04-15	2014-04-15 00:00:00	2014-04-15	5001	0	\N	0	0	\N	\N	0	83806	0	8331-1	3006322		
17225	1567	3023430	1975-10-07	1975-10-07 00:00:00	1975-10-07	5001	0	\N	0	0	\N	\N	0	105078	0	6833-8	3023430		
24403	760	4024958	2017-06-28	2017-06-28 00:00:00	2017-06-28	5001	0	\N	0	0	\N	\N	0	50466	0	117015009	4024958		
23543	2173	3006322	1998-09-09	1998-09-09 00:00:00	1998-09-09	5001	0	\N	0	0	\N	\N	0	144872	0	8331-1	3006322		
149245	4577	4024958	1996-10-26	1996-10-26 00:00:00	1996-10-26	5001	0	\N	0	0	\N	\N	0	304860	0	117015009	4024958		
93059	2864	4024958	1963-05-26	1963-05-26 00:00:00	1963-05-26	5001	0	\N	0	0	\N	\N	0	190497	0	117015009	4024958		
35193	3215	3019406	2006-04-29	2006-04-29 00:00:00	2006-04-29	5001	0	\N	0	0	\N	\N	0	213597	0	6158-0	3019406		
4668	145	4024958	1952-09-28	1952-09-28 00:00:00	1952-09-28	5001	0	\N	0	0	\N	\N	0	9683	0	117015009	4024958		
46608	4288	3006322	2010-10-16	2010-10-16 00:00:00	2010-10-16	5001	0	\N	0	0	\N	\N	0	284653	0	8331-1	3006322		
13979	1310	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	86685	0	6082-2	3000876		
58072	5322	3006322	1978-03-05	1978-03-05 00:00:00	1978-03-05	5001	0	\N	0	0	\N	\N	0	354122	0	8331-1	3006322		
3757	357	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	23698	0	7258-7	3001488		
24830	774	4024958	2010-11-15	2010-11-15 00:00:00	2010-11-15	5001	0	\N	0	0	\N	\N	0	51394	0	117015009	4024958		
41359	3857	3011505	2017-07-25	2017-07-25 00:00:00	2017-07-25	5001	0	\N	0	0	\N	\N	0	256000	0	19926-5	3011505		
24295	2242	3006322	1948-08-18	1948-08-18 00:00:00	1948-08-18	5001	0	\N	0	0	\N	\N	0	149299	0	8331-1	3006322		
52547	4826	3012494	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	320923	0	6206-7	3012494		
52599	4828	3006322	1982-04-19	1982-04-19 00:00:00	1982-04-19	5001	0	\N	0	0	\N	\N	0	321266	0	8331-1	3006322		
4562	442	46235214	1948-11-20	1948-11-20 00:00:00	1948-11-20	5001	0	\N	0	0	\N	\N	0	29333	0	76690-7	46235214		
4418	430	3008598	1990-06-05	1990-06-05 00:00:00	1990-06-05	5001	0	\N	0	0	\N	\N	0	28434	0	3024-7	3008598		
2035	185	3011505	2016-06-12	2016-06-12 00:00:00	2016-06-12	5001	0	\N	0	0	\N	\N	0	12519	0	19926-5	3011505		
115116	3550	4024958	1993-09-06	1993-09-06 00:00:00	1993-09-06	5001	0	\N	0	0	\N	\N	0	235736	0	117015009	4024958		
27592	2546	40766240	1983-08-23	1983-08-23 00:00:00	1983-08-23	5001	0	\N	0	0	\N	\N	0	168462	0	63513-6	40766240		
43914	1352	4133840	2001-04-01	2001-04-01 00:00:00	2001-04-01	5001	0	\N	0	0	\N	\N	0	89554	0	127783003	4133840		
1035	84	3001488	1979-04-08	1979-04-08 00:00:00	1979-04-08	5001	0	\N	0	0	\N	\N	0	5665	0	7258-7	3001488		
38944	3603	3012494	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	239334	0	6206-7	3012494		
37128	3417	3049273	1999-09-04	1999-09-04 00:00:00	1999-09-04	5001	0	\N	0	0	\N	\N	0	226701	0	38265-5	3049273		
31885	2909	3006322	1997-02-08	1997-02-08 00:00:00	1997-02-08	5001	0	\N	0	0	\N	\N	0	193846	0	8331-1	3006322		
34820	3181	3011505	2015-10-30	2015-10-30 00:00:00	2015-10-30	5001	0	\N	0	0	\N	\N	0	211718	0	19926-5	3011505		
170673	5235	4024958	1940-10-27	1940-10-27 00:00:00	1940-10-27	5001	0	\N	0	0	\N	\N	0	348367	0	117015009	4024958		
8922	855	3006322	1997-03-27	1997-03-27 00:00:00	1997-03-27	5001	0	\N	0	0	\N	\N	0	56469	0	8331-1	3006322		
46351	4268	3049273	2016-01-11	2016-01-11 00:00:00	2016-01-11	5001	0	\N	0	0	\N	\N	0	283237	0	38265-5	3049273		
55080	5043	3006322	1976-09-17	1976-09-17 00:00:00	1976-09-17	5001	0	\N	0	0	\N	\N	0	335162	0	8331-1	3006322		
8748	277	4052083	1976-01-29	1976-01-29 00:00:00	1976-01-29	5001	0	\N	0	0	\N	\N	0	18491	0	23426006	4052083		
173010	5312	4133840	1988-10-31	1988-10-31 00:00:00	1988-10-31	5001	0	\N	0	0	\N	\N	0	353265	0	127783003	4133840		
7487	718	3021226	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	47487	0	6246-3	3021226		
9663	911	3020655	1977-06-15	1977-06-15 00:00:00	1977-06-15	5001	0	\N	0	0	\N	\N	0	60471	0	6844-5	3020655		
21020	1950	3011505	1997-10-23	1997-10-23 00:00:00	1997-10-23	5001	0	\N	0	0	\N	\N	0	129658	0	19926-5	3011505		
53158	4884	3006322	2013-03-21	2013-03-21 00:00:00	2013-03-21	5001	0	\N	0	0	\N	\N	0	324751	0	8331-1	3006322		
19197	1762	3011505	2014-04-10	2014-04-10 00:00:00	2014-04-10	5001	0	\N	0	0	\N	\N	0	117812	0	19926-5	3011505		
163858	5035	4024958	1938-07-23	1938-07-23 00:00:00	1938-07-23	5001	0	\N	0	0	\N	\N	0	334588	0	117015009	4024958		
12894	1227	46235214	1938-11-23	1938-11-23 00:00:00	1938-11-23	5001	0	\N	0	0	\N	\N	0	80723	0	76690-7	46235214		
12936	1228	3006734	1979-07-31	1979-07-31 00:00:00	1979-07-31	5001	0	\N	0	0	\N	\N	0	80917	0	6189-5	3006734		
77990	2392	4133840	1984-03-02	1984-03-02 00:00:00	1984-03-02	5001	0	\N	0	0	\N	\N	0	159080	0	127783003	4133840		
3816	366	3049273	1998-11-03	1998-11-03 00:00:00	1998-11-03	5001	0	\N	0	0	\N	\N	0	24356	0	38265-5	3049273		
36657	3371	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	223626	0	6085-5	3001247		
17226	1567	3006734	1975-10-07	1975-10-07 00:00:00	1975-10-07	5001	0	\N	0	0	\N	\N	0	105078	0	6189-5	3006734		
24433	761	4024958	2008-02-23	2008-02-23 00:00:00	2008-02-23	5001	0	\N	0	0	\N	\N	0	50583	0	117015009	4024958		
23544	2173	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	144731	0	6246-3	3021226		
149247	4577	4052083	2017-05-03	2017-05-03 00:00:00	2017-05-03	5001	0	\N	0	0	\N	\N	0	304908	0	23426006	4052083		
93070	2864	4052083	2013-05-05	2013-05-05 00:00:00	2013-05-05	5001	0	\N	0	0	\N	\N	0	190470	0	23426006	4052083		
35194	3215	3005136	2006-04-29	2006-04-29 00:00:00	2006-04-29	5001	0	\N	0	0	\N	\N	0	213597	0	6075-6	3005136		
4683	145	4024958	1951-12-19	1951-12-19 00:00:00	1951-12-19	5001	0	\N	0	0	\N	\N	0	9713	0	117015009	4024958		
46609	4288	3006322	1961-06-28	1961-06-28 00:00:00	1961-06-28	5001	0	\N	0	0	\N	\N	0	284661	0	8331-1	3006322		
13980	1310	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	86685	0	6075-6	3005136		
58073	5322	3006322	2009-07-14	2009-07-14 00:00:00	2009-07-14	5001	0	\N	0	0	\N	\N	0	354130	0	8331-1	3006322		
3758	357	3006322	1967-06-11	1967-06-11 00:00:00	1967-06-11	5001	0	\N	0	0	\N	\N	0	23735	0	8331-1	3006322		
105112	3236	4024958	1951-11-03	1951-11-03 00:00:00	1951-11-03	5001	0	\N	0	0	\N	\N	0	215063	0	117015009	4024958		
41360	3857	3006322	2002-01-18	2002-01-18 00:00:00	2002-01-18	5001	0	\N	0	0	\N	\N	0	255983	0	8331-1	3006322		
24296	2242	3006322	2010-09-14	2010-09-14 00:00:00	2010-09-14	5001	0	\N	0	0	\N	\N	0	149210	0	8331-1	3006322		
52548	4826	3021226	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	320923	0	6246-3	3021226		
52600	4828	3006322	1977-10-01	1977-10-01 00:00:00	1977-10-01	5001	0	\N	0	0	\N	\N	0	321246	0	8331-1	3006322		
4564	442	40766240	1948-11-20	1948-11-20 00:00:00	1948-11-20	5001	0	\N	0	0	\N	\N	0	29333	0	63513-6	40766240		
4419	430	3006322	1991-05-06	1991-05-06 00:00:00	1991-05-06	5001	0	\N	0	0	\N	\N	0	28495	0	8331-1	3006322		
2036	185	3006322	2009-10-19	2009-10-19 00:00:00	2009-10-19	5001	0	\N	0	0	\N	\N	0	12549	0	8331-1	3006322		
115123	3550	4052083	1995-10-03	1995-10-03 00:00:00	1995-10-03	5001	0	\N	0	0	\N	\N	0	235704	0	23426006	4052083		
27594	2546	3051031	1983-08-23	1983-08-23 00:00:00	1983-08-23	5001	0	\N	0	0	\N	\N	0	168462	0	46240-8	3051031		
43918	1353	4024958	1981-05-11	1981-05-11 00:00:00	1981-05-11	5001	0	\N	0	0	\N	\N	0	89666	0	117015009	4024958		
1036	84	3027231	1979-04-08	1979-04-08 00:00:00	1979-04-08	5001	0	\N	0	0	\N	\N	0	5665	0	6276-0	3027231		
38945	3603	3021226	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	239334	0	6246-3	3021226		
37129	3418	3006322	1990-06-14	1990-06-14 00:00:00	1990-06-14	5001	0	\N	0	0	\N	\N	0	226752	0	8331-1	3006322		
31887	2909	3011505	2002-06-16	2002-06-16 00:00:00	2002-06-16	5001	0	\N	0	0	\N	\N	0	193855	0	19926-5	3011505		
34821	3181	3006322	1989-11-21	1989-11-21 00:00:00	1989-11-21	5001	0	\N	0	0	\N	\N	0	211664	0	8331-1	3006322		
170691	5235	4024958	1939-03-22	1939-03-22 00:00:00	1939-03-22	5001	0	\N	0	0	\N	\N	0	348302	0	117015009	4024958		
8924	856	3006322	1981-03-15	1981-03-15 00:00:00	1981-03-15	5001	0	\N	0	0	\N	\N	0	56525	0	8331-1	3006322		
46352	4268	3006322	1979-04-22	1979-04-22 00:00:00	1979-04-22	5001	0	\N	0	0	\N	\N	0	283239	0	8331-1	3006322		
55081	5043	3006322	1998-06-07	1998-06-07 00:00:00	1998-06-07	5001	0	\N	0	0	\N	\N	0	335163	0	8331-1	3006322		
8754	277	4024958	1983-10-28	1983-10-28 00:00:00	1983-10-28	5001	0	\N	0	0	\N	\N	0	18499	0	117015009	4024958		
173011	5312	4133840	2007-01-29	2007-01-29 00:00:00	2007-01-29	5001	0	\N	0	0	\N	\N	0	353246	0	127783003	4133840		
7488	718	3012494	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	47487	0	6206-7	3012494		
9664	911	3001488	1977-06-15	1977-06-15 00:00:00	1977-06-15	5001	0	\N	0	0	\N	\N	0	60471	0	7258-7	3001488		
21021	1950	3011505	2011-01-06	2011-01-06 00:00:00	2011-01-06	5001	0	\N	0	0	\N	\N	0	129709	0	19926-5	3011505		
53159	4884	3006322	2004-08-22	2004-08-22 00:00:00	2004-08-22	5001	0	\N	0	0	\N	\N	0	324747	0	8331-1	3006322		
19198	1762	3011505	1981-02-05	1981-02-05 00:00:00	1981-02-05	5001	0	\N	0	0	\N	\N	0	117817	0	19926-5	3011505		
163860	5035	4024958	1943-09-19	1943-09-19 00:00:00	1943-09-19	5001	0	\N	0	0	\N	\N	0	334543	0	117015009	4024958		
71977	2202	4024958	1978-02-20	1978-02-20 00:00:00	1978-02-20	5001	0	\N	0	0	\N	\N	0	146787	0	117015009	4024958		
12937	1228	3006451	1979-07-31	1979-07-31 00:00:00	1979-07-31	5001	0	\N	0	0	\N	\N	0	80917	0	6273-7	3006451		
77992	2392	4133840	1982-12-10	1982-12-10 00:00:00	1982-12-10	5001	0	\N	0	0	\N	\N	0	159088	0	127783003	4133840		
3819	368	3006322	1990-09-29	1990-09-29 00:00:00	1990-09-29	5001	0	\N	0	0	\N	\N	0	24515	0	8331-1	3006322		
36658	3371	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	223626	0	6189-5	3006734		
17227	1567	3006451	1975-10-07	1975-10-07 00:00:00	1975-10-07	5001	0	\N	0	0	\N	\N	0	105078	0	6273-7	3006451		
24447	761	4024958	1987-01-04	1987-01-04 00:00:00	1987-01-04	5001	0	\N	0	0	\N	\N	0	50568	0	117015009	4024958		
23545	2173	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	144731	0	6276-0	3027231		
149249	4577	4024958	1986-07-25	1986-07-25 00:00:00	1986-07-25	5001	0	\N	0	0	\N	\N	0	304885	0	117015009	4024958		
93071	2864	4052083	1969-08-27	1969-08-27 00:00:00	1969-08-27	5001	0	\N	0	0	\N	\N	0	190498	0	23426006	4052083		
35195	3215	3021226	2006-04-29	2006-04-29 00:00:00	2006-04-29	5001	0	\N	0	0	\N	\N	0	213597	0	6246-3	3021226		
4696	145	4024958	1991-08-21	1991-08-21 00:00:00	1991-08-21	5001	0	\N	0	0	\N	\N	0	9747	0	117015009	4024958		
46610	4289	3049273	2017-05-10	2017-05-10 00:00:00	2017-05-10	5001	0	\N	0	0	\N	\N	0	284744	0	38265-5	3049273		
13981	1310	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	86685	0	6246-3	3021226		
58074	5322	3006322	1994-02-18	1994-02-18 00:00:00	1994-02-18	5001	0	\N	0	0	\N	\N	0	354140	0	8331-1	3006322		
3759	357	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	23666	0	7258-7	3001488		
105137	3236	4052083	1953-08-06	1953-08-06 00:00:00	1953-08-06	5001	0	\N	0	0	\N	\N	0	215126	0	23426006	4052083		
41361	3857	3011505	1969-03-11	1969-03-11 00:00:00	1969-03-11	5001	0	\N	0	0	\N	\N	0	256053	0	19926-5	3011505		
24297	2242	3006322	1954-05-31	1954-05-31 00:00:00	1954-05-31	5001	0	\N	0	0	\N	\N	0	149204	0	8331-1	3006322		
52549	4826	3005136	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	320923	0	6075-6	3005136		
52601	4828	3006322	1974-07-04	1974-07-04 00:00:00	1974-07-04	5001	0	\N	0	0	\N	\N	0	321265	0	8331-1	3006322		
4565	442	46235214	1949-03-20	1949-03-20 00:00:00	1949-03-20	5001	0	\N	0	0	\N	\N	0	29291	0	76690-7	46235214		
4422	430	3006322	1992-11-08	1992-11-08 00:00:00	1992-11-08	5001	0	\N	0	0	\N	\N	0	28435	0	8331-1	3006322		
2037	185	3011505	2015-06-07	2015-06-07 00:00:00	2015-06-07	5001	0	\N	0	0	\N	\N	0	12565	0	19926-5	3011505		
115125	3550	4024958	1992-07-23	1992-07-23 00:00:00	1992-07-23	5001	0	\N	0	0	\N	\N	0	235727	0	117015009	4024958		
27596	2546	46235214	1983-08-23	1983-08-23 00:00:00	1983-08-23	5001	0	\N	0	0	\N	\N	0	168462	0	76690-7	46235214		
43920	1353	4024958	1966-01-04	1966-01-04 00:00:00	1966-01-04	5001	0	\N	0	0	\N	\N	0	89700	0	117015009	4024958		
1037	84	3019406	1979-04-08	1979-04-08 00:00:00	1979-04-08	5001	0	\N	0	0	\N	\N	0	5665	0	6158-0	3019406		
38946	3603	3020655	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	239334	0	6844-5	3020655		
37130	3418	3006322	2000-09-04	2000-09-04 00:00:00	2000-09-04	5001	0	\N	0	0	\N	\N	0	226717	0	8331-1	3006322		
31888	2909	3009201	1999-02-12	1999-02-12 00:00:00	1999-02-12	5001	0	\N	0	0	\N	\N	0	193875	0	3016-3	3009201		
34822	3181	3011505	2002-06-28	2002-06-28 00:00:00	2002-06-28	5001	0	\N	0	0	\N	\N	0	211642	0	19926-5	3011505		
170699	5236	4024958	1985-06-06	1985-06-06 00:00:00	1985-06-06	5001	0	\N	0	0	\N	\N	0	348394	0	117015009	4024958		
8925	856	3006322	1982-04-24	1982-04-24 00:00:00	1982-04-24	5001	0	\N	0	0	\N	\N	0	56526	0	8331-1	3006322		
46353	4268	3006322	1956-01-13	1956-01-13 00:00:00	1956-01-13	5001	0	\N	0	0	\N	\N	0	283265	0	8331-1	3006322		
55082	5043	3006322	2007-07-31	2007-07-31 00:00:00	2007-07-31	5001	0	\N	0	0	\N	\N	0	335112	0	8331-1	3006322		
8756	277	4024958	1965-07-05	1965-07-05 00:00:00	1965-07-05	5001	0	\N	0	0	\N	\N	0	18457	0	117015009	4024958		
173017	5312	4024958	1948-02-14	1948-02-14 00:00:00	1948-02-14	5001	0	\N	0	0	\N	\N	0	353291	0	117015009	4024958		
7489	718	3014599	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	47487	0	6106-9	3014599		
9665	911	3000876	1977-06-15	1977-06-15 00:00:00	1977-06-15	5001	0	\N	0	0	\N	\N	0	60471	0	6082-2	3000876		
21022	1950	3049273	2011-01-06	2011-01-06 00:00:00	2011-01-06	5001	0	\N	0	0	\N	\N	0	129709	0	38265-5	3049273		
53160	4884	3006322	1975-11-09	1975-11-09 00:00:00	1975-11-09	5001	0	\N	0	0	\N	\N	0	324743	0	8331-1	3006322		
19199	1762	3011505	2010-03-18	2010-03-18 00:00:00	2010-03-18	5001	0	\N	0	0	\N	\N	0	117810	0	19926-5	3011505		
163871	5035	4024958	1976-04-21	1976-04-21 00:00:00	1976-04-21	5001	0	\N	0	0	\N	\N	0	334639	0	117015009	4024958		
71981	2202	4052083	1982-08-26	1982-08-26 00:00:00	1982-08-26	5001	0	\N	0	0	\N	\N	0	146789	0	23426006	4052083		
12938	1228	3012494	1979-07-31	1979-07-31 00:00:00	1979-07-31	5001	0	\N	0	0	\N	\N	0	80917	0	6206-7	3012494		
77993	2392	4133840	1994-04-29	1994-04-29 00:00:00	1994-04-29	5001	0	\N	0	0	\N	\N	0	159090	0	127783003	4133840		
3820	368	3006322	2008-04-30	2008-04-30 00:00:00	2008-04-30	5001	0	\N	0	0	\N	\N	0	24516	0	8331-1	3006322		
36659	3371	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	223626	0	6075-6	3005136		
17228	1567	3014599	1975-10-07	1975-10-07 00:00:00	1975-10-07	5001	0	\N	0	0	\N	\N	0	105078	0	6106-9	3014599		
24452	761	4052083	2004-01-31	2004-01-31 00:00:00	2004-01-31	5001	0	\N	0	0	\N	\N	0	50613	0	23426006	4052083		
23546	2173	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	144731	0	6206-7	3012494		
149264	4578	4052083	1970-11-21	1970-11-21 00:00:00	1970-11-21	5001	0	\N	0	0	\N	\N	0	304919	0	23426006	4052083		
93077	2864	4024958	1942-12-22	1942-12-22 00:00:00	1942-12-22	5001	0	\N	0	0	\N	\N	0	190463	0	117015009	4024958		
35196	3215	3012494	2006-04-29	2006-04-29 00:00:00	2006-04-29	5001	0	\N	0	0	\N	\N	0	213597	0	6206-7	3012494		
4703	145	4052083	1995-02-02	1995-02-02 00:00:00	1995-02-02	5001	0	\N	0	0	\N	\N	0	9726	0	23426006	4052083		
46611	4289	3000963	2005-07-03	2005-07-03 00:00:00	2005-07-03	5001	0	\N	0	0	\N	\N	0	284752	0	718-7	3000963		
13982	1310	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	86685	0	6833-8	3023430		
58075	5322	3006322	1949-07-12	1949-07-12 00:00:00	1949-07-12	5001	0	\N	0	0	\N	\N	0	354217	0	8331-1	3006322		
93789	2889	4052083	1961-06-15	1961-06-15 00:00:00	1961-06-15	5001	0	\N	0	0	\N	\N	0	192121	0	23426006	4052083		
105156	3237	4024958	1948-04-04	1948-04-04 00:00:00	1948-04-04	5001	0	\N	0	0	\N	\N	0	215220	0	117015009	4024958		
41362	3857	3011505	1992-05-12	1992-05-12 00:00:00	1992-05-12	5001	0	\N	0	0	\N	\N	0	255993	0	19926-5	3011505		
24298	2242	3006322	1980-10-22	1980-10-22 00:00:00	1980-10-22	5001	0	\N	0	0	\N	\N	0	149234	0	8331-1	3006322		
52550	4826	3036780	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	320923	0	6095-4	3036780		
52602	4828	3006322	2017-11-21	2017-11-21 00:00:00	2017-11-21	5001	0	\N	0	0	\N	\N	0	321290	0	8331-1	3006322		
4567	442	3051031	1949-03-20	1949-03-20 00:00:00	1949-03-20	5001	0	\N	0	0	\N	\N	0	29291	0	46240-8	3051031		
4424	430	3006322	1989-04-04	1989-04-04 00:00:00	1989-04-04	5001	0	\N	0	0	\N	\N	0	28439	0	8331-1	3006322		
2038	185	3006322	1962-08-29	1962-08-29 00:00:00	1962-08-29	5001	0	\N	0	0	\N	\N	0	12567	0	8331-1	3006322		
115127	3550	4024958	2018-05-14	2018-05-14 00:00:00	2018-05-14	5001	0	\N	0	0	\N	\N	0	235740	0	117015009	4024958		
27597	2546	3051031	1983-10-22	1983-10-22 00:00:00	1983-10-22	5001	0	\N	0	0	\N	\N	0	168489	0	46240-8	3051031		
43946	1353	4024958	1980-12-26	1980-12-26 00:00:00	1980-12-26	5001	0	\N	0	0	\N	\N	0	89660	0	117015009	4024958		
1038	84	3021226	1979-04-08	1979-04-08 00:00:00	1979-04-08	5001	0	\N	0	0	\N	\N	0	5665	0	6246-3	3021226		
38947	3603	3006451	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	239334	0	6273-7	3006451		
37131	3418	3006322	1980-12-17	1980-12-17 00:00:00	1980-12-17	5001	0	\N	0	0	\N	\N	0	226715	0	8331-1	3006322		
31889	2909	3008598	1999-02-12	1999-02-12 00:00:00	1999-02-12	5001	0	\N	0	0	\N	\N	0	193875	0	3024-7	3008598		
34823	3181	3011505	2012-10-12	2012-10-12 00:00:00	2012-10-12	5001	0	\N	0	0	\N	\N	0	211833	0	19926-5	3011505		
8793	843	3000876	1995-05-06	1995-05-06 00:00:00	1995-05-06	5001	0	\N	0	0	\N	\N	0	55807	0	6082-2	3000876		
8926	856	3006322	2005-04-06	2005-04-06 00:00:00	2005-04-06	5001	0	\N	0	0	\N	\N	0	56539	0	8331-1	3006322		
46354	4268	3006322	2015-12-22	2015-12-22 00:00:00	2015-12-22	5001	0	\N	0	0	\N	\N	0	283247	0	8331-1	3006322		
55083	5043	3006322	2012-08-14	2012-08-14 00:00:00	2012-08-14	5001	0	\N	0	0	\N	\N	0	335113	0	8331-1	3006322		
30146	2771	3002385	1974-09-02	1974-09-02 00:00:00	1974-09-02	5001	0	\N	0	0	\N	\N	0	183474	0	30385-9	3002385		
20059	624	4052083	1961-11-07	1961-11-07 00:00:00	1961-11-07	5001	0	\N	0	0	\N	\N	0	41682	0	23426006	4052083		
7490	718	3027231	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	47487	0	6276-0	3027231		
9666	911	3036780	1977-06-15	1977-06-15 00:00:00	1977-06-15	5001	0	\N	0	0	\N	\N	0	60471	0	6095-4	3036780		
21023	1950	3011505	1983-01-06	1983-01-06 00:00:00	1983-01-06	5001	0	\N	0	0	\N	\N	0	129654	0	19926-5	3011505		
53161	4884	3049273	1989-07-08	1989-07-08 00:00:00	1989-07-08	5001	0	\N	0	0	\N	\N	0	324736	0	38265-5	3049273		
19200	1762	3011505	1998-04-09	1998-04-09 00:00:00	1998-04-09	5001	0	\N	0	0	\N	\N	0	117826	0	19926-5	3011505		
163875	5035	4052083	1990-04-07	1990-04-07 00:00:00	1990-04-07	5001	0	\N	0	0	\N	\N	0	334591	0	23426006	4052083		
72009	2204	4024958	1984-10-28	1984-10-28 00:00:00	1984-10-28	5001	0	\N	0	0	\N	\N	0	146935	0	117015009	4024958		
12939	1228	3021226	1979-07-31	1979-07-31 00:00:00	1979-07-31	5001	0	\N	0	0	\N	\N	0	80917	0	6246-3	3021226		
77995	2392	4133840	2008-07-18	2008-07-18 00:00:00	2008-07-18	5001	0	\N	0	0	\N	\N	0	158973	0	127783003	4133840		
3821	368	3006322	2003-03-04	2003-03-04 00:00:00	2003-03-04	5001	0	\N	0	0	\N	\N	0	24483	0	8331-1	3006322		
36660	3371	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	223626	0	7258-7	3001488		
17229	1567	3015076	1975-10-07	1975-10-07 00:00:00	1975-10-07	5001	0	\N	0	0	\N	\N	0	105078	0	6248-9	3015076		
24455	761	4052083	2007-11-08	2007-11-08 00:00:00	2007-11-08	5001	0	\N	0	0	\N	\N	0	50627	0	23426006	4052083		
23547	2173	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	144731	0	6158-0	3019406		
149267	4578	4052083	1998-06-05	1998-06-05 00:00:00	1998-06-05	5001	0	\N	0	0	\N	\N	0	304948	0	23426006	4052083		
104366	3215	4052083	2016-07-21	2016-07-21 00:00:00	2016-07-21	5001	0	\N	0	0	\N	\N	0	213581	0	23426006	4052083		
35197	3215	3014599	2006-04-29	2006-04-29 00:00:00	2006-04-29	5001	0	\N	0	0	\N	\N	0	213597	0	6106-9	3014599		
115835	3569	4052083	1995-06-02	1995-06-02 00:00:00	1995-06-02	5001	0	\N	0	0	\N	\N	0	237160	0	23426006	4052083		
46612	4289	3009542	2005-07-03	2005-07-03 00:00:00	2005-07-03	5001	0	\N	0	0	\N	\N	0	284752	0	20570-8	3009542		
13983	1310	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	86685	0	6095-4	3036780		
58076	5322	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	354082	0	7258-7	3001488		
93791	2889	4024958	1977-08-05	1977-08-05 00:00:00	1977-08-05	5001	0	\N	0	0	\N	\N	0	192142	0	117015009	4024958		
105163	3237	4024958	1928-06-05	1928-06-05 00:00:00	1928-06-05	5001	0	\N	0	0	\N	\N	0	215217	0	117015009	4024958		
41363	3857	3011505	2001-07-24	2001-07-24 00:00:00	2001-07-24	5001	0	\N	0	0	\N	\N	0	255995	0	19926-5	3011505		
24299	2242	3006322	1933-12-19	1933-12-19 00:00:00	1933-12-19	5001	0	\N	0	0	\N	\N	0	149264	0	8331-1	3006322		
52551	4826	3015076	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	320923	0	6248-9	3015076		
52603	4828	3006322	1984-05-21	1984-05-21 00:00:00	1984-05-21	5001	0	\N	0	0	\N	\N	0	321267	0	8331-1	3006322		
4568	442	40758406	1949-03-20	1949-03-20 00:00:00	1949-03-20	5001	0	\N	0	0	\N	\N	0	29291	0	55277-8	40758406		
4425	430	3006322	1965-05-23	1965-05-23 00:00:00	1965-05-23	5001	0	\N	0	0	\N	\N	0	28457	0	8331-1	3006322		
2039	185	3011505	2019-06-09	2019-06-09 00:00:00	2019-06-09	5001	0	\N	0	0	\N	\N	0	12576	0	19926-5	3011505		
115135	3552	4052083	2014-01-23	2014-01-23 00:00:00	2014-01-23	5001	0	\N	0	0	\N	\N	0	235807	0	23426006	4052083		
27598	2546	40766240	1983-10-22	1983-10-22 00:00:00	1983-10-22	5001	0	\N	0	0	\N	\N	0	168489	0	63513-6	40766240		
43955	1354	4052083	1994-09-14	1994-09-14 00:00:00	1994-09-14	5001	0	\N	0	0	\N	\N	0	89726	0	23426006	4052083		
1039	84	3006322	1974-05-16	1974-05-16 00:00:00	1974-05-16	5001	0	\N	0	0	\N	\N	0	5679	0	8331-1	3006322		
38948	3603	3001488	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	239334	0	7258-7	3001488		
37132	3418	3006322	1974-05-09	1974-05-09 00:00:00	1974-05-09	5001	0	\N	0	0	\N	\N	0	226733	0	8331-1	3006322		
31890	2909	3011505	1981-04-05	1981-04-05 00:00:00	1981-04-05	5001	0	\N	0	0	\N	\N	0	193918	0	19926-5	3011505		
34824	3181	3011505	2014-10-24	2014-10-24 00:00:00	2014-10-24	5001	0	\N	0	0	\N	\N	0	211834	0	19926-5	3011505		
8794	843	3020655	1995-05-06	1995-05-06 00:00:00	1995-05-06	5001	0	\N	0	0	\N	\N	0	55807	0	6844-5	3020655		
8927	857	3011505	2016-05-22	2016-05-22 00:00:00	2016-05-22	5001	0	\N	0	0	\N	\N	0	56590	0	19926-5	3011505		
46355	4269	46235214	1969-07-30	1969-07-30 00:00:00	1969-07-30	5001	0	\N	0	0	\N	\N	0	283304	0	76690-7	46235214		
55084	5043	3006322	1975-11-06	1975-11-06 00:00:00	1975-11-06	5001	0	\N	0	0	\N	\N	0	335133	0	8331-1	3006322		
30147	2771	3020630	1974-09-02	1974-09-02 00:00:00	1974-09-02	5001	0	\N	0	0	\N	\N	0	183474	0	2885-2	3020630		
20061	624	4052083	1966-07-22	1966-07-22 00:00:00	1966-07-22	5001	0	\N	0	0	\N	\N	0	41621	0	23426006	4052083		
7491	718	3005136	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	47487	0	6075-6	3005136		
41669	3876	3019406	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	257503	0	6158-0	3019406		
21024	1950	3006322	1978-05-10	1978-05-10 00:00:00	1978-05-10	5001	0	\N	0	0	\N	\N	0	129625	0	8331-1	3006322		
53162	4884	3006322	2001-08-24	2001-08-24 00:00:00	2001-08-24	5001	0	\N	0	0	\N	\N	0	324756	0	8331-1	3006322		
19201	1762	3011505	1975-10-02	1975-10-02 00:00:00	1975-10-02	5001	0	\N	0	0	\N	\N	0	117839	0	19926-5	3011505		
163890	5035	4024958	1963-11-28	1963-11-28 00:00:00	1963-11-28	5001	0	\N	0	0	\N	\N	0	334624	0	117015009	4024958		
72011	2204	4024958	1966-05-16	1966-05-16 00:00:00	1966-05-16	5001	0	\N	0	0	\N	\N	0	146875	0	117015009	4024958		
12940	1228	3005136	1979-07-31	1979-07-31 00:00:00	1979-07-31	5001	0	\N	0	0	\N	\N	0	80917	0	6075-6	3005136		
77999	2392	4133840	1958-05-23	1958-05-23 00:00:00	1958-05-23	5001	0	\N	0	0	\N	\N	0	159052	0	127783003	4133840		
3822	368	3006322	2008-03-20	2008-03-20 00:00:00	2008-03-20	5001	0	\N	0	0	\N	\N	0	24477	0	8331-1	3006322		
36661	3371	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	223626	0	6276-0	3027231		
17230	1567	3019406	1975-10-07	1975-10-07 00:00:00	1975-10-07	5001	0	\N	0	0	\N	\N	0	105078	0	6158-0	3019406		
35512	3248	3015632	2016-06-26	2016-06-26 00:00:00	2016-06-26	5001	0	\N	0	0	\N	\N	0	215881	0	2028-9	3015632		
23548	2173	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	144731	0	6189-5	3006734		
149276	4578	4024958	1993-04-26	1993-04-26 00:00:00	1993-04-26	5001	0	\N	0	0	\N	\N	0	304965	0	117015009	4024958		
35198	3215	3001488	2006-04-29	2006-04-29 00:00:00	2006-04-29	5001	0	\N	0	0	\N	\N	0	213597	0	7258-7	3001488		
115850	3570	4024958	1968-03-09	1968-03-09 00:00:00	1968-03-09	5001	0	\N	0	0	\N	\N	0	237288	0	117015009	4024958		
46613	4289	3006322	1944-11-07	1944-11-07 00:00:00	1944-11-07	5001	0	\N	0	0	\N	\N	0	284762	0	8331-1	3006322		
13984	1310	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	86685	0	6276-0	3027231		
58077	5322	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	354082	0	6273-7	3006451		
93793	2889	4024958	1968-05-25	1968-05-25 00:00:00	1968-05-25	5001	0	\N	0	0	\N	\N	0	192175	0	117015009	4024958		
105171	3237	4052083	1981-12-04	1981-12-04 00:00:00	1981-12-04	5001	0	\N	0	0	\N	\N	0	215224	0	23426006	4052083		
41364	3857	3011505	2008-09-02	2008-09-02 00:00:00	2008-09-02	5001	0	\N	0	0	\N	\N	0	255964	0	19926-5	3011505		
24300	2243	3006322	2018-12-25	2018-12-25 00:00:00	2018-12-25	5001	0	\N	0	0	\N	\N	0	149339	0	8331-1	3006322		
52552	4826	3006451	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	320923	0	6273-7	3006451		
52604	4829	3006322	1998-03-24	1998-03-24 00:00:00	1998-03-24	5001	0	\N	0	0	\N	\N	0	321310	0	8331-1	3006322		
4569	442	40766240	1949-03-20	1949-03-20 00:00:00	1949-03-20	5001	0	\N	0	0	\N	\N	0	29291	0	63513-6	40766240		
4426	431	3049273	1999-01-22	1999-01-22 00:00:00	1999-01-22	5001	0	\N	0	0	\N	\N	0	28596	0	38265-5	3049273		
2040	185	3006322	1982-09-24	1982-09-24 00:00:00	1982-09-24	5001	0	\N	0	0	\N	\N	0	12526	0	8331-1	3006322		
115140	3552	4052083	2002-10-31	2002-10-31 00:00:00	2002-10-31	5001	0	\N	0	0	\N	\N	0	235824	0	23426006	4052083		
27599	2546	46235214	1983-10-22	1983-10-22 00:00:00	1983-10-22	5001	0	\N	0	0	\N	\N	0	168489	0	76690-7	46235214		
43959	1354	4024958	1980-02-28	1980-02-28 00:00:00	1980-02-28	5001	0	\N	0	0	\N	\N	0	89722	0	117015009	4024958		
1042	86	3006322	1953-05-03	1953-05-03 00:00:00	1953-05-03	5001	0	\N	0	0	\N	\N	0	5769	0	8331-1	3006322		
38949	3603	3005136	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	239334	0	6075-6	3005136		
37133	3418	3006322	2012-06-17	2012-06-17 00:00:00	2012-06-17	5001	0	\N	0	0	\N	\N	0	226723	0	8331-1	3006322		
31891	2909	3011505	2006-07-09	2006-07-09 00:00:00	2006-07-09	5001	0	\N	0	0	\N	\N	0	193928	0	19926-5	3011505		
34825	3181	3006322	1985-06-30	1985-06-30 00:00:00	1985-06-30	5001	0	\N	0	0	\N	\N	0	211830	0	8331-1	3006322		
8795	843	3012494	1995-05-06	1995-05-06 00:00:00	1995-05-06	5001	0	\N	0	0	\N	\N	0	55807	0	6206-7	3012494		
8928	857	3011505	2013-05-05	2013-05-05 00:00:00	2013-05-05	5001	0	\N	0	0	\N	\N	0	56643	0	19926-5	3011505		
46358	4269	40766240	1969-07-30	1969-07-30 00:00:00	1969-07-30	5001	0	\N	0	0	\N	\N	0	283304	0	63513-6	40766240		
55085	5044	3006322	1976-04-02	1976-04-02 00:00:00	1976-04-02	5001	0	\N	0	0	\N	\N	0	335189	0	8331-1	3006322		
30148	2771	3019550	1974-09-02	1974-09-02 00:00:00	1974-09-02	5001	0	\N	0	0	\N	\N	0	183474	0	2951-2	3019550		
20075	624	4052083	1969-10-17	1969-10-17 00:00:00	1969-10-17	5001	0	\N	0	0	\N	\N	0	41636	0	23426006	4052083		
7492	718	3019406	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	47487	0	6158-0	3019406		
41670	3876	3020655	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	257503	0	6844-5	3020655		
21025	1950	3011505	2013-01-17	2013-01-17 00:00:00	2013-01-17	5001	0	\N	0	0	\N	\N	0	129661	0	19926-5	3011505		
53163	4884	3006322	1979-09-08	1979-09-08 00:00:00	1979-09-08	5001	0	\N	0	0	\N	\N	0	324776	0	8331-1	3006322		
19202	1762	3006322	1964-06-28	1964-06-28 00:00:00	1964-06-28	5001	0	\N	0	0	\N	\N	0	117861	0	8331-1	3006322		
13693	1285	3000876	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	84976	0	6082-2	3000876		
72019	2204	4024958	1987-11-19	1987-11-19 00:00:00	1987-11-19	5001	0	\N	0	0	\N	\N	0	146936	0	117015009	4024958		
12941	1228	3014599	1979-07-31	1979-07-31 00:00:00	1979-07-31	5001	0	\N	0	0	\N	\N	0	80917	0	6106-9	3014599		
78000	2392	4024958	1928-06-17	1928-06-17 00:00:00	1928-06-17	5001	0	\N	0	0	\N	\N	0	159015	0	117015009	4024958		
3823	370	3006322	1999-05-05	1999-05-05 00:00:00	1999-05-05	5001	0	\N	0	0	\N	\N	0	24599	0	8331-1	3006322		
36662	3371	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	223626	0	6273-7	3006451		
17231	1567	3005136	1975-10-07	1975-10-07 00:00:00	1975-10-07	5001	0	\N	0	0	\N	\N	0	105078	0	6075-6	3005136		
35513	3248	3007461	2016-06-26	2016-06-26 00:00:00	2016-06-26	5001	0	\N	0	0	\N	\N	0	215881	0	26515-7	3007461		
23549	2173	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	144731	0	6248-9	3015076		
160571	4932	4052083	2016-09-09	2016-09-09 00:00:00	2016-09-09	5001	0	\N	0	0	\N	\N	0	327842	0	23426006	4052083		
35199	3215	3020655	2006-04-29	2006-04-29 00:00:00	2006-04-29	5001	0	\N	0	0	\N	\N	0	213597	0	6844-5	3020655		
115853	3570	4052083	1990-02-09	1990-02-09 00:00:00	1990-02-09	5001	0	\N	0	0	\N	\N	0	237291	0	23426006	4052083		
46614	4289	3006322	2010-03-21	2010-03-21 00:00:00	2010-03-21	5001	0	\N	0	0	\N	\N	0	284753	0	8331-1	3006322		
13985	1310	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	86685	0	6106-9	3014599		
58078	5322	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	354082	0	6248-9	3015076		
105076	3236	4024958	1942-03-14	1942-03-14 00:00:00	1942-03-14	5001	0	\N	0	0	\N	\N	0	215089	0	117015009	4024958		
58174	5337	3006451	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	355418	0	6273-7	3006451		
41365	3857	3011505	1995-01-10	1995-01-10 00:00:00	1995-01-10	5001	0	\N	0	0	\N	\N	0	256055	0	19926-5	3011505		
24301	2243	3006322	1993-01-25	1993-01-25 00:00:00	1993-01-25	5001	0	\N	0	0	\N	\N	0	149374	0	8331-1	3006322		
52553	4826	3006734	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	320923	0	6189-5	3006734		
52605	4829	3006322	2019-04-07	2019-04-07 00:00:00	2019-04-07	5001	0	\N	0	0	\N	\N	0	321346	0	8331-1	3006322		
4571	442	40766240	1948-10-21	1948-10-21 00:00:00	1948-10-21	5001	0	\N	0	0	\N	\N	0	29277	0	63513-6	40766240		
4427	431	3006322	1975-09-30	1975-09-30 00:00:00	1975-09-30	5001	0	\N	0	0	\N	\N	0	28584	0	8331-1	3006322		
2041	185	3006322	1948-10-01	1948-10-01 00:00:00	1948-10-01	5001	0	\N	0	0	\N	\N	0	12566	0	8331-1	3006322		
115148	3552	4052083	1964-02-14	1964-02-14 00:00:00	1964-02-14	5001	0	\N	0	0	\N	\N	0	235843	0	23426006	4052083		
27602	2546	40758406	1983-10-22	1983-10-22 00:00:00	1983-10-22	5001	0	\N	0	0	\N	\N	0	168489	0	55277-8	40758406		
43960	1354	4052083	1982-03-12	1982-03-12 00:00:00	1982-03-12	5001	0	\N	0	0	\N	\N	0	89745	0	23426006	4052083		
1043	86	3006322	1955-06-05	1955-06-05 00:00:00	1955-06-05	5001	0	\N	0	0	\N	\N	0	5803	0	8331-1	3006322		
38950	3603	3015076	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	239334	0	6248-9	3015076		
37137	3420	3006322	1980-01-22	1980-01-22 00:00:00	1980-01-22	5001	0	\N	0	0	\N	\N	0	226866	0	8331-1	3006322		
31892	2909	3011505	2005-07-03	2005-07-03 00:00:00	2005-07-03	5001	0	\N	0	0	\N	\N	0	193880	0	19926-5	3011505		
34826	3181	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	211666	0	7258-7	3001488		
8796	843	3001247	1995-05-06	1995-05-06 00:00:00	1995-05-06	5001	0	\N	0	0	\N	\N	0	55807	0	6085-5	3001247		
8929	857	3011505	2000-03-05	2000-03-05 00:00:00	2000-03-05	5001	0	\N	0	0	\N	\N	0	56586	0	19926-5	3011505		
46359	4269	3051031	1969-07-30	1969-07-30 00:00:00	1969-07-30	5001	0	\N	0	0	\N	\N	0	283304	0	46240-8	3051031		
55086	5044	3006322	1979-08-26	1979-08-26 00:00:00	1979-08-26	5001	0	\N	0	0	\N	\N	0	335190	0	8331-1	3006322		
30149	2771	3026361	1974-09-02	1974-09-02 00:00:00	1974-09-02	5001	0	\N	0	0	\N	\N	0	183474	0	26453-1	3026361		
20085	624	4052083	2019-05-16	2019-05-16 00:00:00	2019-05-16	5001	0	\N	0	0	\N	\N	0	41666	0	23426006	4052083		
7493	718	3015076	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	47487	0	6248-9	3015076		
41671	3876	3001247	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	257503	0	6085-5	3001247		
21026	1950	3011505	1994-10-06	1994-10-06 00:00:00	1994-10-06	5001	0	\N	0	0	\N	\N	0	129682	0	19926-5	3011505		
81981	2537	4052083	2006-10-08	2006-10-08 00:00:00	2006-10-08	5001	0	\N	0	0	\N	\N	0	167675	0	23426006	4052083		
19203	1762	3006322	1977-06-23	1977-06-23 00:00:00	1977-06-23	5001	0	\N	0	0	\N	\N	0	117800	0	8331-1	3006322		
13694	1285	3014599	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	84976	0	6106-9	3014599		
72021	2204	4052083	1986-09-18	1986-09-18 00:00:00	1986-09-18	5001	0	\N	0	0	\N	\N	0	146917	0	23426006	4052083		
12942	1229	3006322	1954-12-15	1954-12-15 00:00:00	1954-12-15	5001	0	\N	0	0	\N	\N	0	81005	0	8331-1	3006322		
78001	2392	4133840	1971-02-26	1971-02-26 00:00:00	1971-02-26	5001	0	\N	0	0	\N	\N	0	159055	0	127783003	4133840		
3824	370	3006322	1969-02-18	1969-02-18 00:00:00	1969-02-18	5001	0	\N	0	0	\N	\N	0	24588	0	8331-1	3006322		
36663	3371	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	223626	0	6106-9	3014599		
17232	1567	3027231	1975-10-07	1975-10-07 00:00:00	1975-10-07	5001	0	\N	0	0	\N	\N	0	105078	0	6276-0	3027231		
35514	3248	3023103	2016-06-26	2016-06-26 00:00:00	2016-06-26	5001	0	\N	0	0	\N	\N	0	215881	0	2823-3	3023103		
23550	2173	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	144731	0	6095-4	3036780		
160588	4933	4024958	1981-11-05	1981-11-05 00:00:00	1981-11-05	5001	0	\N	0	0	\N	\N	0	327928	0	117015009	4024958		
35200	3215	3006734	2006-04-29	2006-04-29 00:00:00	2006-04-29	5001	0	\N	0	0	\N	\N	0	213597	0	6189-5	3006734		
115859	3570	4052083	1952-04-19	1952-04-19 00:00:00	1952-04-19	5001	0	\N	0	0	\N	\N	0	237264	0	23426006	4052083		
46615	4289	3006322	2008-11-13	2008-11-13 00:00:00	2008-11-13	5001	0	\N	0	0	\N	\N	0	284749	0	8331-1	3006322		
13986	1310	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	86685	0	6206-7	3012494		
58079	5322	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	354082	0	6106-9	3014599		
105079	3236	4052083	1940-04-17	1940-04-17 00:00:00	1940-04-17	5001	0	\N	0	0	\N	\N	0	215125	0	23426006	4052083		
58175	5337	3019406	1993-07-04	1993-07-04 00:00:00	1993-07-04	5001	0	\N	0	0	\N	\N	0	355418	0	6158-0	3019406		
41366	3857	3006322	1982-03-05	1982-03-05 00:00:00	1982-03-05	5001	0	\N	0	0	\N	\N	0	255958	0	8331-1	3006322		
24302	2243	3006322	1988-06-09	1988-06-09 00:00:00	1988-06-09	5001	0	\N	0	0	\N	\N	0	149373	0	8331-1	3006322		
52554	4826	3014599	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	320923	0	6106-9	3014599		
52606	4829	3006322	2001-10-14	2001-10-14 00:00:00	2001-10-14	5001	0	\N	0	0	\N	\N	0	321345	0	8331-1	3006322		
4573	442	46235214	1948-10-21	1948-10-21 00:00:00	1948-10-21	5001	0	\N	0	0	\N	\N	0	29277	0	76690-7	46235214		
4428	431	3006322	1970-02-13	1970-02-13 00:00:00	1970-02-13	5001	0	\N	0	0	\N	\N	0	28553	0	8331-1	3006322		
2042	185	3011505	2017-06-18	2017-06-18 00:00:00	2017-06-18	5001	0	\N	0	0	\N	\N	0	12580	0	19926-5	3011505		
115149	3552	4052083	2016-08-30	2016-08-30 00:00:00	2016-08-30	5001	0	\N	0	0	\N	\N	0	235851	0	23426006	4052083		
27603	2546	40758406	1984-09-16	1984-09-16 00:00:00	1984-09-16	5001	0	\N	0	0	\N	\N	0	168506	0	55277-8	40758406		
43966	1354	4052083	1981-07-29	1981-07-29 00:00:00	1981-07-29	5001	0	\N	0	0	\N	\N	0	89724	0	23426006	4052083		
1044	86	3006322	1995-11-29	1995-11-29 00:00:00	1995-11-29	5001	0	\N	0	0	\N	\N	0	5796	0	8331-1	3006322		
38951	3603	3006322	1986-07-07	1986-07-07 00:00:00	1986-07-07	5001	0	\N	0	0	\N	\N	0	239416	0	8331-1	3006322		
37138	3420	3006322	1970-01-02	1970-01-02 00:00:00	1970-01-02	5001	0	\N	0	0	\N	\N	0	226843	0	8331-1	3006322		
31893	2909	3011505	1969-04-13	1969-04-13 00:00:00	1969-04-13	5001	0	\N	0	0	\N	\N	0	193872	0	19926-5	3011505		
34827	3181	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	211666	0	6276-0	3027231		
8797	843	3006734	1995-05-06	1995-05-06 00:00:00	1995-05-06	5001	0	\N	0	0	\N	\N	0	55807	0	6189-5	3006734		
8930	857	3011505	2008-04-06	2008-04-06 00:00:00	2008-04-06	5001	0	\N	0	0	\N	\N	0	56626	0	19926-5	3011505		
46360	4269	40758406	1969-07-30	1969-07-30 00:00:00	1969-07-30	5001	0	\N	0	0	\N	\N	0	283304	0	55277-8	40758406		
55087	5044	3006322	1985-04-11	1985-04-11 00:00:00	1985-04-11	5001	0	\N	0	0	\N	\N	0	335215	0	8331-1	3006322		
30150	2771	3009542	1974-09-02	1974-09-02 00:00:00	1974-09-02	5001	0	\N	0	0	\N	\N	0	183474	0	20570-8	3009542		
20106	625	4024958	1979-04-07	1979-04-07 00:00:00	1979-04-07	5001	0	\N	0	0	\N	\N	0	41774	0	117015009	4024958		
7494	718	3000876	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	47487	0	6082-2	3000876		
41672	3876	3006734	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	257503	0	6189-5	3006734		
21027	1950	3011505	1989-07-13	1989-07-13 00:00:00	1989-07-13	5001	0	\N	0	0	\N	\N	0	129691	0	19926-5	3011505		
30252	2776	3021226	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	183776	0	6246-3	3021226		
19204	1762	3011505	1986-02-13	1986-02-13 00:00:00	1986-02-13	5001	0	\N	0	0	\N	\N	0	117818	0	19926-5	3011505		
13695	1285	3036780	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	84976	0	6095-4	3036780		
72028	2204	4052083	1952-12-05	1952-12-05 00:00:00	1952-12-05	5001	0	\N	0	0	\N	\N	0	146903	0	23426006	4052083		
12943	1229	3006322	1986-12-11	1986-12-11 00:00:00	1986-12-11	5001	0	\N	0	0	\N	\N	0	81014	0	8331-1	3006322		
78003	2392	4052083	1957-02-13	1957-02-13 00:00:00	1957-02-13	5001	0	\N	0	0	\N	\N	0	159020	0	23426006	4052083		
3825	370	3006322	1977-04-19	1977-04-19 00:00:00	1977-04-19	5001	0	\N	0	0	\N	\N	0	24637	0	8331-1	3006322		
36664	3371	3006322	2000-09-07	2000-09-07 00:00:00	2000-09-07	5001	0	\N	0	0	\N	\N	0	223649	0	8331-1	3006322		
17233	1567	3020655	1975-10-07	1975-10-07 00:00:00	1975-10-07	5001	0	\N	0	0	\N	\N	0	105078	0	6844-5	3020655		
35515	3248	3013682	2016-06-26	2016-06-26 00:00:00	2016-06-26	5001	0	\N	0	0	\N	\N	0	215881	0	3094-0	3013682		
23551	2173	3001488	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	144731	0	7258-7	3001488		
35201	3216	3006322	1994-11-20	1994-11-20 00:00:00	1994-11-20	5001	0	\N	0	0	\N	\N	0	213732	0	8331-1	3006322		
115865	3570	4024958	1950-01-31	1950-01-31 00:00:00	1950-01-31	5001	0	\N	0	0	\N	\N	0	237286	0	117015009	4024958		
46616	4289	3006322	2001-06-24	2001-06-24 00:00:00	2001-06-24	5001	0	\N	0	0	\N	\N	0	284747	0	8331-1	3006322		
13987	1310	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	86685	0	6273-7	3006451		
58080	5322	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	354082	0	6844-5	3020655		
105090	3236	4024958	1931-08-25	1931-08-25 00:00:00	1931-08-25	5001	0	\N	0	0	\N	\N	0	215059	0	117015009	4024958		
94202	2897	4024958	2001-12-06	2001-12-06 00:00:00	2001-12-06	5001	0	\N	0	0	\N	\N	0	192926	0	117015009	4024958		
41367	3857	3011505	2015-07-14	2015-07-14 00:00:00	2015-07-14	5001	0	\N	0	0	\N	\N	0	255999	0	19926-5	3011505		
24303	2243	3006322	1967-08-16	1967-08-16 00:00:00	1967-08-16	5001	0	\N	0	0	\N	\N	0	149372	0	8331-1	3006322		
52555	4826	3019406	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	320923	0	6158-0	3019406		
52607	4829	3006322	2009-01-16	2009-01-16 00:00:00	2009-01-16	5001	0	\N	0	0	\N	\N	0	321357	0	8331-1	3006322		
4574	442	40758406	1948-10-21	1948-10-21 00:00:00	1948-10-21	5001	0	\N	0	0	\N	\N	0	29277	0	55277-8	40758406		
4429	431	3006322	2017-12-17	2017-12-17 00:00:00	2017-12-17	5001	0	\N	0	0	\N	\N	0	28587	0	8331-1	3006322		
2043	185	3011505	2014-06-01	2014-06-01 00:00:00	2014-06-01	5001	0	\N	0	0	\N	\N	0	12518	0	19926-5	3011505		
115161	3552	4052083	2018-01-13	2018-01-13 00:00:00	2018-01-13	5001	0	\N	0	0	\N	\N	0	235852	0	23426006	4052083		
27604	2546	46235214	1984-09-16	1984-09-16 00:00:00	1984-09-16	5001	0	\N	0	0	\N	\N	0	168506	0	76690-7	46235214		
53924	4942	3006322	1973-03-04	1973-03-04 00:00:00	1973-03-04	5001	0	\N	0	0	\N	\N	0	328503	0	8331-1	3006322		
1045	86	3006322	1990-03-14	1990-03-14 00:00:00	1990-03-14	5001	0	\N	0	0	\N	\N	0	5795	0	8331-1	3006322		
38952	3603	3006322	1973-10-01	1973-10-01 00:00:00	1973-10-01	5001	0	\N	0	0	\N	\N	0	239355	0	8331-1	3006322		
37139	3420	3006322	1991-08-07	1991-08-07 00:00:00	1991-08-07	5001	0	\N	0	0	\N	\N	0	226871	0	8331-1	3006322		
31894	2909	3006322	1998-08-17	1998-08-17 00:00:00	1998-08-17	5001	0	\N	0	0	\N	\N	0	193859	0	8331-1	3006322		
34828	3181	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	211666	0	6082-2	3000876		
8798	843	3036780	1995-05-06	1995-05-06 00:00:00	1995-05-06	5001	0	\N	0	0	\N	\N	0	55807	0	6095-4	3036780		
8931	857	3011505	1998-10-04	1998-10-04 00:00:00	1998-10-04	5001	0	\N	0	0	\N	\N	0	56640	0	19926-5	3011505		
46361	4269	3006322	1973-09-03	1973-09-03 00:00:00	1973-09-03	5001	0	\N	0	0	\N	\N	0	283365	0	8331-1	3006322		
55088	5045	3006322	1999-12-08	1999-12-08 00:00:00	1999-12-08	5001	0	\N	0	0	\N	\N	0	335287	0	8331-1	3006322		
30151	2771	3013721	1974-09-02	1974-09-02 00:00:00	1974-09-02	5001	0	\N	0	0	\N	\N	0	183474	0	1920-8	3013721		
20109	625	4024958	1990-11-28	1990-11-28 00:00:00	1990-11-28	5001	0	\N	0	0	\N	\N	0	41764	0	117015009	4024958		
7495	718	3006734	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	47487	0	6189-5	3006734		
41673	3876	3006322	1977-05-03	1977-05-03 00:00:00	1977-05-03	5001	0	\N	0	0	\N	\N	0	257432	0	8331-1	3006322		
21028	1950	3011505	1992-09-24	1992-09-24 00:00:00	1992-09-24	5001	0	\N	0	0	\N	\N	0	129681	0	19926-5	3011505		
30253	2776	3001247	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	183776	0	6085-5	3001247		
19205	1762	3006322	1992-01-06	1992-01-06 00:00:00	1992-01-06	5001	0	\N	0	0	\N	\N	0	117892	0	8331-1	3006322		
13696	1285	3021226	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	84976	0	6246-3	3021226		
72031	2204	4052083	1954-12-10	1954-12-10 00:00:00	1954-12-10	5001	0	\N	0	0	\N	\N	0	146873	0	23426006	4052083		
12947	1231	3006322	1990-12-28	1990-12-28 00:00:00	1990-12-28	5001	0	\N	0	0	\N	\N	0	81121	0	8331-1	3006322		
78006	2392	4133840	2013-10-04	2013-10-04 00:00:00	2013-10-04	5001	0	\N	0	0	\N	\N	0	159068	0	127783003	4133840		
3826	370	3006322	2014-07-31	2014-07-31 00:00:00	2014-07-31	5001	0	\N	0	0	\N	\N	0	24633	0	8331-1	3006322		
36665	3371	3006322	1990-01-17	1990-01-17 00:00:00	1990-01-17	5001	0	\N	0	0	\N	\N	0	223615	0	8331-1	3006322		
17234	1567	3036780	1975-10-07	1975-10-07 00:00:00	1975-10-07	5001	0	\N	0	0	\N	\N	0	105078	0	6095-4	3036780		
35516	3248	3024731	2016-06-26	2016-06-26 00:00:00	2016-06-26	5001	0	\N	0	0	\N	\N	0	215881	0	30428-7	3024731		
23552	2173	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	144731	0	6833-8	3023430		
35202	3216	3006322	2015-05-31	2015-05-31 00:00:00	2015-05-31	5001	0	\N	0	0	\N	\N	0	213715	0	8331-1	3006322		
115908	3571	4024958	2014-04-15	2014-04-15 00:00:00	2014-04-15	5001	0	\N	0	0	\N	\N	0	237315	0	117015009	4024958		
46617	4289	3006322	2016-09-24	2016-09-24 00:00:00	2016-09-24	5001	0	\N	0	0	\N	\N	0	284798	0	8331-1	3006322		
13988	1310	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	86685	0	6158-0	3019406		
58081	5322	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	354082	0	6082-2	3000876		
105092	3236	4052083	1948-05-26	1948-05-26 00:00:00	1948-05-26	5001	0	\N	0	0	\N	\N	0	215091	0	23426006	4052083		
94237	2898	4024958	2006-04-21	2006-04-21 00:00:00	2006-04-21	5001	0	\N	0	0	\N	\N	0	192976	0	117015009	4024958		
41368	3857	3011505	1990-01-09	1990-01-09 00:00:00	1990-01-09	5001	0	\N	0	0	\N	\N	0	255986	0	19926-5	3011505		
24304	2244	3006322	1983-07-29	1983-07-29 00:00:00	1983-07-29	5001	0	\N	0	0	\N	\N	0	149386	0	8331-1	3006322		
52556	4826	3027231	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	320923	0	6276-0	3027231		
52610	4831	3006322	1973-02-25	1973-02-25 00:00:00	1973-02-25	5001	0	\N	0	0	\N	\N	0	321429	0	8331-1	3006322		
4576	442	3051031	1948-10-21	1948-10-21 00:00:00	1948-10-21	5001	0	\N	0	0	\N	\N	0	29277	0	46240-8	3051031		
4430	431	3006322	1995-06-19	1995-06-19 00:00:00	1995-06-19	5001	0	\N	0	0	\N	\N	0	28623	0	8331-1	3006322		
2044	186	3006322	1998-06-18	1998-06-18 00:00:00	1998-06-18	5001	0	\N	0	0	\N	\N	0	12597	0	8331-1	3006322		
115168	3553	4052083	1948-05-01	1948-05-01 00:00:00	1948-05-01	5001	0	\N	0	0	\N	\N	0	235871	0	23426006	4052083		
27605	2546	40766240	1984-09-16	1984-09-16 00:00:00	1984-09-16	5001	0	\N	0	0	\N	\N	0	168506	0	63513-6	40766240		
53925	4942	3006322	2001-09-03	2001-09-03 00:00:00	2001-09-03	5001	0	\N	0	0	\N	\N	0	328469	0	8331-1	3006322		
1046	86	3006322	2010-11-21	2010-11-21 00:00:00	2010-11-21	5001	0	\N	0	0	\N	\N	0	5770	0	8331-1	3006322		
38953	3603	3021226	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	239365	0	6246-3	3021226		
37140	3420	3006322	1997-06-19	1997-06-19 00:00:00	1997-06-19	5001	0	\N	0	0	\N	\N	0	226872	0	8331-1	3006322		
31895	2909	3011505	2000-06-04	2000-06-04 00:00:00	2000-06-04	5001	0	\N	0	0	\N	\N	0	193854	0	19926-5	3011505		
34829	3181	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	211666	0	6833-8	3023430		
8799	843	3015076	1995-05-06	1995-05-06 00:00:00	1995-05-06	5001	0	\N	0	0	\N	\N	0	55807	0	6248-9	3015076		
8932	857	3011505	1990-03-11	1990-03-11 00:00:00	1990-03-11	5001	0	\N	0	0	\N	\N	0	56584	0	19926-5	3011505		
141301	4355	4024958	2007-04-20	2007-04-20 00:00:00	2007-04-20	5001	0	\N	0	0	\N	\N	0	288966	0	117015009	4024958		
55089	5045	3006322	1993-12-16	1993-12-16 00:00:00	1993-12-16	5001	0	\N	0	0	\N	\N	0	335263	0	8331-1	3006322		
30152	2771	3016723	1974-09-02	1974-09-02 00:00:00	1974-09-02	5001	0	\N	0	0	\N	\N	0	183474	0	2160-0	3016723		
30229	2776	3006451	2009-01-27	2009-01-27 00:00:00	2009-01-27	5001	0	\N	0	0	\N	\N	0	183868	0	6273-7	3006451		
7496	718	3036780	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	47487	0	6095-4	3036780		
41674	3876	3006322	1988-02-11	1988-02-11 00:00:00	1988-02-11	5001	0	\N	0	0	\N	\N	0	257433	0	8331-1	3006322		
21029	1950	3006322	1945-04-23	1945-04-23 00:00:00	1945-04-23	5001	0	\N	0	0	\N	\N	0	129644	0	8331-1	3006322		
30254	2776	3006734	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	183776	0	6189-5	3006734		
19206	1762	3011505	2003-02-06	2003-02-06 00:00:00	2003-02-06	5001	0	\N	0	0	\N	\N	0	117828	0	19926-5	3011505		
13697	1285	3012494	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	84976	0	6206-7	3012494		
163937	5037	4024958	2015-12-24	2015-12-24 00:00:00	2015-12-24	5001	0	\N	0	0	\N	\N	0	334713	0	117015009	4024958		
12948	1231	3006322	1978-04-15	1978-04-15 00:00:00	1978-04-15	5001	0	\N	0	0	\N	\N	0	81120	0	8331-1	3006322		
78008	2392	4133840	1972-03-03	1972-03-03 00:00:00	1972-03-03	5001	0	\N	0	0	\N	\N	0	159003	0	127783003	4133840		
3827	370	3006322	1974-02-05	1974-02-05 00:00:00	1974-02-05	5001	0	\N	0	0	\N	\N	0	24636	0	8331-1	3006322		
36666	3371	3005136	1976-03-23	1976-03-23 00:00:00	1976-03-23	5001	0	\N	0	0	\N	\N	0	223598	0	6075-6	3005136		
17235	1567	3006322	2017-01-15	2017-01-15 00:00:00	2017-01-15	5001	0	\N	0	0	\N	\N	0	105135	0	8331-1	3006322		
35517	3248	3006906	2016-06-26	2016-06-26 00:00:00	2016-06-26	5001	0	\N	0	0	\N	\N	0	215881	0	17861-6	3006906		
23553	2173	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	144731	0	6844-5	3020655		
35203	3216	3006322	2004-10-08	2004-10-08 00:00:00	2004-10-08	5001	0	\N	0	0	\N	\N	0	213713	0	8331-1	3006322		
116098	3576	4052083	1992-03-25	1992-03-25 00:00:00	1992-03-25	5001	0	\N	0	0	\N	\N	0	237716	0	23426006	4052083		
46618	4289	3006322	2002-08-03	2002-08-03 00:00:00	2002-08-03	5001	0	\N	0	0	\N	\N	0	284748	0	8331-1	3006322		
13989	1310	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	86685	0	6085-5	3001247		
58082	5322	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	354082	0	6095-4	3036780		
58112	5325	3006322	1979-09-10	1979-09-10 00:00:00	1979-09-10	5001	0	\N	0	0	\N	\N	0	354500	0	8331-1	3006322		
41369	3857	3011505	2009-09-08	2009-09-08 00:00:00	2009-09-08	5001	0	\N	0	0	\N	\N	0	256004	0	19926-5	3011505		
24305	2244	3006322	2006-05-09	2006-05-09 00:00:00	2006-05-09	5001	0	\N	0	0	\N	\N	0	149406	0	8331-1	3006322		
52557	4827	40769189	1967-12-16	1967-12-16 00:00:00	1967-12-16	5001	0	\N	0	0	\N	\N	0	321112	0	66529-9	40769189		
52611	4831	3006322	2007-10-01	2007-10-01 00:00:00	2007-10-01	5001	0	\N	0	0	\N	\N	0	321479	0	8331-1	3006322		
4577	442	3006322	1981-03-15	1981-03-15 00:00:00	1981-03-15	5001	0	\N	0	0	\N	\N	0	29280	0	8331-1	3006322		
4431	431	3006322	2004-08-14	2004-08-14 00:00:00	2004-08-14	5001	0	\N	0	0	\N	\N	0	28616	0	8331-1	3006322		
2045	186	3006322	2019-03-12	2019-03-12 00:00:00	2019-03-12	5001	0	\N	0	0	\N	\N	0	12610	0	8331-1	3006322		
115182	3553	4052083	1952-11-12	1952-11-12 00:00:00	1952-11-12	5001	0	\N	0	0	\N	\N	0	235924	0	23426006	4052083		
27606	2546	3051031	1984-09-16	1984-09-16 00:00:00	1984-09-16	5001	0	\N	0	0	\N	\N	0	168506	0	46240-8	3051031		
53926	4942	3006322	1960-03-29	1960-03-29 00:00:00	1960-03-29	5001	0	\N	0	0	\N	\N	0	328520	0	8331-1	3006322		
1050	90	3006322	1970-01-15	1970-01-15 00:00:00	1970-01-15	5001	0	\N	0	0	\N	\N	0	5987	0	8331-1	3006322		
38954	3603	3012494	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	239365	0	6206-7	3012494		
37141	3420	3006322	1970-08-13	1970-08-13 00:00:00	1970-08-13	5001	0	\N	0	0	\N	\N	0	226883	0	8331-1	3006322		
31896	2909	3011505	1978-04-02	1978-04-02 00:00:00	1978-04-02	5001	0	\N	0	0	\N	\N	0	193917	0	19926-5	3011505		
34830	3181	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	211666	0	6095-4	3036780		
8800	843	3005136	1995-05-06	1995-05-06 00:00:00	1995-05-06	5001	0	\N	0	0	\N	\N	0	55807	0	6075-6	3005136		
8933	857	3011505	2012-04-29	2012-04-29 00:00:00	2012-04-29	5001	0	\N	0	0	\N	\N	0	56632	0	19926-5	3011505		
79734	2456	4024958	1992-04-04	1992-04-04 00:00:00	1992-04-04	5001	0	\N	0	0	\N	\N	0	162828	0	117015009	4024958		
55090	5045	3006322	1974-09-16	1974-09-16 00:00:00	1974-09-16	5001	0	\N	0	0	\N	\N	0	335266	0	8331-1	3006322		
30153	2771	3024561	1974-09-02	1974-09-02 00:00:00	1974-09-02	5001	0	\N	0	0	\N	\N	0	183474	0	1751-7	3024561		
30230	2776	3015076	2009-01-27	2009-01-27 00:00:00	2009-01-27	5001	0	\N	0	0	\N	\N	0	183868	0	6248-9	3015076		
7497	718	3006322	1978-08-10	1978-08-10 00:00:00	1978-08-10	5001	0	\N	0	0	\N	\N	0	47499	0	8331-1	3006322		
41675	3876	3006322	2012-09-10	2012-09-10 00:00:00	2012-09-10	5001	0	\N	0	0	\N	\N	0	257468	0	8331-1	3006322		
21030	1950	40758406	1941-10-12	1941-10-12 00:00:00	1941-10-12	5001	0	\N	0	0	\N	\N	0	129623	0	55277-8	40758406		
30255	2776	3015076	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	183776	0	6248-9	3015076		
19207	1762	3011505	1970-10-15	1970-10-15 00:00:00	1970-10-15	5001	0	\N	0	0	\N	\N	0	117815	0	19926-5	3011505		
13698	1285	3001247	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	84976	0	6085-5	3001247		
1791	159	3006322	1997-12-11	1997-12-11 00:00:00	1997-12-11	5001	0	\N	0	0	\N	\N	0	10928	0	8331-1	3006322		
12949	1231	3049273	2000-11-01	2000-11-01 00:00:00	2000-11-01	5001	0	\N	0	0	\N	\N	0	81119	0	38265-5	3049273		
78010	2392	4133840	1977-02-04	1977-02-04 00:00:00	1977-02-04	5001	0	\N	0	0	\N	\N	0	159076	0	127783003	4133840		
3828	370	3006322	1975-07-12	1975-07-12 00:00:00	1975-07-12	5001	0	\N	0	0	\N	\N	0	24598	0	8331-1	3006322		
36667	3371	3001488	1976-03-23	1976-03-23 00:00:00	1976-03-23	5001	0	\N	0	0	\N	\N	0	223598	0	7258-7	3001488		
17236	1568	3006322	2012-12-03	2012-12-03 00:00:00	2012-12-03	5001	0	\N	0	0	\N	\N	0	105178	0	8331-1	3006322		
35518	3248	3027970	2016-06-26	2016-06-26 00:00:00	2016-06-26	5001	0	\N	0	0	\N	\N	0	215881	0	10834-0	3027970		
23554	2173	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	144731	0	6085-5	3001247		
35204	3217	3006322	1997-04-18	1997-04-18 00:00:00	1997-04-18	5001	0	\N	0	0	\N	\N	0	213765	0	8331-1	3006322		
116128	3577	4024958	2014-05-14	2014-05-14 00:00:00	2014-05-14	5001	0	\N	0	0	\N	\N	0	237802	0	117015009	4024958		
46621	4291	3006322	1997-03-25	1997-03-25 00:00:00	1997-03-25	5001	0	\N	0	0	\N	\N	0	284914	0	8331-1	3006322		
13990	1310	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	86685	0	7258-7	3001488		
58083	5322	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	354082	0	6206-7	3012494		
58113	5325	3006322	2009-02-28	2009-02-28 00:00:00	2009-02-28	5001	0	\N	0	0	\N	\N	0	354494	0	8331-1	3006322		
41370	3857	3011505	2012-09-25	2012-09-25 00:00:00	2012-09-25	5001	0	\N	0	0	\N	\N	0	255997	0	19926-5	3011505		
24306	2244	3006322	1979-08-05	1979-08-05 00:00:00	1979-08-05	5001	0	\N	0	0	\N	\N	0	149392	0	8331-1	3006322		
52558	4827	40769184	1967-12-16	1967-12-16 00:00:00	1967-12-16	5001	0	\N	0	0	\N	\N	0	321112	0	66524-0	40769184		
52612	4831	3006322	1980-07-31	1980-07-31 00:00:00	1980-07-31	5001	0	\N	0	0	\N	\N	0	321419	0	8331-1	3006322		
4578	442	3006451	1980-09-11	1980-09-11 00:00:00	1980-09-11	5001	0	\N	0	0	\N	\N	0	29313	0	6273-7	3006451		
4432	431	3006322	1960-09-09	1960-09-09 00:00:00	1960-09-09	5001	0	\N	0	0	\N	\N	0	28552	0	8331-1	3006322		
2046	186	3006322	1984-11-15	1984-11-15 00:00:00	1984-11-15	5001	0	\N	0	0	\N	\N	0	12607	0	8331-1	3006322		
115191	3553	4024958	1945-03-24	1945-03-24 00:00:00	1945-03-24	5001	0	\N	0	0	\N	\N	0	235870	0	117015009	4024958		
27609	2546	46235214	1984-04-19	1984-04-19 00:00:00	1984-04-19	5001	0	\N	0	0	\N	\N	0	168491	0	76690-7	46235214		
53927	4942	3006322	1979-04-15	1979-04-15 00:00:00	1979-04-15	5001	0	\N	0	0	\N	\N	0	328523	0	8331-1	3006322		
1051	90	3006322	1992-05-12	1992-05-12 00:00:00	1992-05-12	5001	0	\N	0	0	\N	\N	0	6050	0	8331-1	3006322		
38955	3603	3005136	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	239365	0	6075-6	3005136		
37142	3420	3006322	1972-10-15	1972-10-15 00:00:00	1972-10-15	5001	0	\N	0	0	\N	\N	0	226905	0	8331-1	3006322		
31897	2909	3011505	1990-04-22	1990-04-22 00:00:00	1990-04-22	5001	0	\N	0	0	\N	\N	0	193925	0	19926-5	3011505		
34831	3181	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	211666	0	6248-9	3015076		
8801	843	3001488	1995-05-06	1995-05-06 00:00:00	1995-05-06	5001	0	\N	0	0	\N	\N	0	55807	0	7258-7	3001488		
8934	857	3011505	2004-03-14	2004-03-14 00:00:00	2004-03-14	5001	0	\N	0	0	\N	\N	0	56624	0	19926-5	3011505		
79737	2456	4052083	1998-10-10	1998-10-10 00:00:00	1998-10-10	5001	0	\N	0	0	\N	\N	0	162771	0	23426006	4052083		
55091	5045	3006322	1965-07-25	1965-07-25 00:00:00	1965-07-25	5001	0	\N	0	0	\N	\N	0	335260	0	8331-1	3006322		
30154	2771	3028833	1974-09-02	1974-09-02 00:00:00	1974-09-02	5001	0	\N	0	0	\N	\N	0	183474	0	42719-5	3028833		
30231	2776	3012494	2009-01-27	2009-01-27 00:00:00	2009-01-27	5001	0	\N	0	0	\N	\N	0	183868	0	6206-7	3012494		
7498	718	3006322	1986-02-11	1986-02-11 00:00:00	1986-02-11	5001	0	\N	0	0	\N	\N	0	47441	0	8331-1	3006322		
41676	3876	3006322	2001-07-18	2001-07-18 00:00:00	2001-07-18	5001	0	\N	0	0	\N	\N	0	257442	0	8331-1	3006322		
7719	742	3011505	1990-04-09	1990-04-09 00:00:00	1990-04-09	5001	0	\N	0	0	\N	\N	0	49116	0	19926-5	3011505		
30256	2776	3006451	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	183776	0	6273-7	3006451		
19208	1762	3011505	2007-03-01	2007-03-01 00:00:00	2007-03-01	5001	0	\N	0	0	\N	\N	0	117830	0	19926-5	3011505		
13699	1285	3023430	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	84976	0	6833-8	3023430		
1792	159	3006322	1968-04-20	1968-04-20 00:00:00	1968-04-20	5001	0	\N	0	0	\N	\N	0	10926	0	8331-1	3006322		
12950	1231	3006322	1946-12-01	1946-12-01 00:00:00	1946-12-01	5001	0	\N	0	0	\N	\N	0	81150	0	8331-1	3006322		
78011	2392	4133840	2014-10-10	2014-10-10 00:00:00	2014-10-10	5001	0	\N	0	0	\N	\N	0	158976	0	127783003	4133840		
3829	370	3006322	1965-12-21	1965-12-21 00:00:00	1965-12-21	5001	0	\N	0	0	\N	\N	0	24594	0	8331-1	3006322		
36668	3371	3021226	1976-03-23	1976-03-23 00:00:00	1976-03-23	5001	0	\N	0	0	\N	\N	0	223598	0	6246-3	3021226		
17237	1568	3006322	2011-05-31	2011-05-31 00:00:00	2011-05-31	5001	0	\N	0	0	\N	\N	0	105199	0	8331-1	3006322		
35519	3248	3016723	2016-06-26	2016-06-26 00:00:00	2016-06-26	5001	0	\N	0	0	\N	\N	0	215881	0	2160-0	3016723		
23555	2173	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	144731	0	6273-7	3006451		
35205	3217	3006322	1993-07-27	1993-07-27 00:00:00	1993-07-27	5001	0	\N	0	0	\N	\N	0	213790	0	8331-1	3006322		
116138	3578	4024958	1978-05-31	1978-05-31 00:00:00	1978-05-31	5001	0	\N	0	0	\N	\N	0	237875	0	117015009	4024958		
46642	4295	3006322	2011-12-23	2011-12-23 00:00:00	2011-12-23	5001	0	\N	0	0	\N	\N	0	285074	0	8331-1	3006322		
13991	1310	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	86685	0	6189-5	3006734		
58084	5322	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	354082	0	6158-0	3019406		
58114	5325	3006322	1991-04-22	1991-04-22 00:00:00	1991-04-22	5001	0	\N	0	0	\N	\N	0	354514	0	8331-1	3006322		
41371	3857	3011505	1997-04-01	1997-04-01 00:00:00	1997-04-01	5001	0	\N	0	0	\N	\N	0	256019	0	19926-5	3011505		
24307	2244	3006322	1995-11-21	1995-11-21 00:00:00	1995-11-21	5001	0	\N	0	0	\N	\N	0	149398	0	8331-1	3006322		
52559	4827	40769179	1967-12-16	1967-12-16 00:00:00	1967-12-16	5001	0	\N	0	0	\N	\N	0	321112	0	66519-0	40769179		
52613	4831	3006322	1999-09-03	1999-09-03 00:00:00	1999-09-03	5001	0	\N	0	0	\N	\N	0	321478	0	8331-1	3006322		
4682	449	3011505	2012-08-09	2012-08-09 00:00:00	2012-08-09	5001	0	\N	0	0	\N	\N	0	29891	0	19926-5	3011505		
4433	431	3006322	1951-07-18	1951-07-18 00:00:00	1951-07-18	5001	0	\N	0	0	\N	\N	0	28612	0	8331-1	3006322		
2047	186	40769189	1972-06-28	1972-06-28 00:00:00	1972-06-28	5001	0	\N	0	0	\N	\N	0	12618	0	66529-9	40769189		
58354	1776	4024958	1923-07-07	1923-07-07 00:00:00	1923-07-07	5001	0	\N	0	0	\N	\N	0	118771	0	117015009	4024958		
27611	2546	3051031	1984-04-19	1984-04-19 00:00:00	1984-04-19	5001	0	\N	0	0	\N	\N	0	168491	0	46240-8	3051031		
53928	4943	3006322	1986-05-11	1986-05-11 00:00:00	1986-05-11	5001	0	\N	0	0	\N	\N	0	328554	0	8331-1	3006322		
1052	90	3006322	1991-12-05	1991-12-05 00:00:00	1991-12-05	5001	0	\N	0	0	\N	\N	0	6006	0	8331-1	3006322		
38956	3603	3015076	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	239365	0	6248-9	3015076		
37143	3420	3006322	1998-12-27	1998-12-27 00:00:00	1998-12-27	5001	0	\N	0	0	\N	\N	0	226873	0	8331-1	3006322		
31898	2909	3011505	1975-03-30	1975-03-30 00:00:00	1975-03-30	5001	0	\N	0	0	\N	\N	0	193923	0	19926-5	3011505		
34832	3181	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	211666	0	6106-9	3014599		
8802	843	3021226	1995-05-06	1995-05-06 00:00:00	1995-05-06	5001	0	\N	0	0	\N	\N	0	55807	0	6246-3	3021226		
8935	857	3011505	2010-04-18	2010-04-18 00:00:00	2010-04-18	5001	0	\N	0	0	\N	\N	0	56631	0	19926-5	3011505		
79743	2456	4052083	1959-11-30	1959-11-30 00:00:00	1959-11-30	5001	0	\N	0	0	\N	\N	0	162768	0	23426006	4052083		
55092	5045	3006322	1997-01-12	1997-01-12 00:00:00	1997-01-12	5001	0	\N	0	0	\N	\N	0	335232	0	8331-1	3006322		
30155	2771	3027970	1974-09-02	1974-09-02 00:00:00	1974-09-02	5001	0	\N	0	0	\N	\N	0	183474	0	10834-0	3027970		
30232	2776	3005136	2009-01-27	2009-01-27 00:00:00	2009-01-27	5001	0	\N	0	0	\N	\N	0	183868	0	6075-6	3005136		
7499	718	3001247	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	47491	0	6085-5	3001247		
41677	3876	3006322	1981-06-22	1981-06-22 00:00:00	1981-06-22	5001	0	\N	0	0	\N	\N	0	257451	0	8331-1	3006322		
7720	742	3011505	2004-06-28	2004-06-28 00:00:00	2004-06-28	5001	0	\N	0	0	\N	\N	0	49212	0	19926-5	3011505		
30257	2776	3005136	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	183776	0	6075-6	3005136		
19209	1762	3011505	2015-04-16	2015-04-16 00:00:00	2015-04-16	5001	0	\N	0	0	\N	\N	0	117834	0	19926-5	3011505		
13700	1285	3005136	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	84976	0	6075-6	3005136		
1793	159	3006322	1971-05-24	1971-05-24 00:00:00	1971-05-24	5001	0	\N	0	0	\N	\N	0	10891	0	8331-1	3006322		
12951	1231	3006322	1970-09-15	1970-09-15 00:00:00	1970-09-15	5001	0	\N	0	0	\N	\N	0	81071	0	8331-1	3006322		
78015	2392	4133840	1996-05-10	1996-05-10 00:00:00	1996-05-10	5001	0	\N	0	0	\N	\N	0	159063	0	127783003	4133840		
3830	371	3006322	1980-04-13	1980-04-13 00:00:00	1980-04-13	5001	0	\N	0	0	\N	\N	0	24693	0	8331-1	3006322		
36669	3371	3019406	1976-03-23	1976-03-23 00:00:00	1976-03-23	5001	0	\N	0	0	\N	\N	0	223598	0	6158-0	3019406		
17238	1568	3006322	1999-02-10	1999-02-10 00:00:00	1999-02-10	5001	0	\N	0	0	\N	\N	0	105177	0	8331-1	3006322		
35520	3248	3024561	2016-06-26	2016-06-26 00:00:00	2016-06-26	5001	0	\N	0	0	\N	\N	0	215881	0	1751-7	3024561		
23556	2173	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	144731	0	6106-9	3014599		
35206	3217	3006322	2006-12-08	2006-12-08 00:00:00	2006-12-08	5001	0	\N	0	0	\N	\N	0	213766	0	8331-1	3006322		
116146	3578	4024958	1992-06-28	1992-06-28 00:00:00	1992-06-28	5001	0	\N	0	0	\N	\N	0	237869	0	117015009	4024958		
46643	4295	3006322	2018-01-04	2018-01-04 00:00:00	2018-01-04	5001	0	\N	0	0	\N	\N	0	285075	0	8331-1	3006322		
13992	1310	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	86685	0	6844-5	3020655		
58085	5322	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	354082	0	6833-8	3023430		
58116	5325	3006322	1955-08-03	1955-08-03 00:00:00	1955-08-03	5001	0	\N	0	0	\N	\N	0	354497	0	8331-1	3006322		
41372	3857	3006322	1986-09-24	1986-09-24 00:00:00	1986-09-24	5001	0	\N	0	0	\N	\N	0	255959	0	8331-1	3006322		
24308	2244	3006322	1987-01-21	1987-01-21 00:00:00	1987-01-21	5001	0	\N	0	0	\N	\N	0	149405	0	8331-1	3006322		
52560	4827	40769194	1967-12-16	1967-12-16 00:00:00	1967-12-16	5001	0	\N	0	0	\N	\N	0	321112	0	66534-9	40769194		
52614	4831	3006322	1962-03-25	1962-03-25 00:00:00	1962-03-25	5001	0	\N	0	0	\N	\N	0	321433	0	8331-1	3006322		
4683	449	3011505	2001-07-05	2001-07-05 00:00:00	2001-07-05	5001	0	\N	0	0	\N	\N	0	29991	0	19926-5	3011505		
4434	431	3006322	1985-05-01	1985-05-01 00:00:00	1985-05-01	5001	0	\N	0	0	\N	\N	0	28614	0	8331-1	3006322		
2048	186	40769179	1972-06-28	1972-06-28 00:00:00	1972-06-28	5001	0	\N	0	0	\N	\N	0	12618	0	66519-0	40769179		
69650	2135	4052083	1953-02-06	1953-02-06 00:00:00	1953-02-06	5001	0	\N	0	0	\N	\N	0	142126	0	23426006	4052083		
27613	2546	40758406	1984-04-19	1984-04-19 00:00:00	1984-04-19	5001	0	\N	0	0	\N	\N	0	168491	0	55277-8	40758406		
53929	4943	3006322	1967-04-14	1967-04-14 00:00:00	1967-04-14	5001	0	\N	0	0	\N	\N	0	328564	0	8331-1	3006322		
1053	90	3006322	1963-02-13	1963-02-13 00:00:00	1963-02-13	5001	0	\N	0	0	\N	\N	0	6016	0	8331-1	3006322		
38957	3603	3006451	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	239365	0	6273-7	3006451		
37146	3422	40758406	1983-05-14	1983-05-14 00:00:00	1983-05-14	5001	0	\N	0	0	\N	\N	0	227026	0	55277-8	40758406		
31899	2909	3006322	1977-04-12	1977-04-12 00:00:00	1977-04-12	5001	0	\N	0	0	\N	\N	0	193858	0	8331-1	3006322		
34833	3181	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	211666	0	6075-6	3005136		
8803	843	3019406	1995-05-06	1995-05-06 00:00:00	1995-05-06	5001	0	\N	0	0	\N	\N	0	55807	0	6158-0	3019406		
8936	857	3006322	1976-07-19	1976-07-19 00:00:00	1976-07-19	5001	0	\N	0	0	\N	\N	0	56659	0	8331-1	3006322		
79754	2456	4024958	1995-08-01	1995-08-01 00:00:00	1995-08-01	5001	0	\N	0	0	\N	\N	0	162755	0	117015009	4024958		
55093	5045	3006322	1963-08-19	1963-08-19 00:00:00	1963-08-19	5001	0	\N	0	0	\N	\N	0	335261	0	8331-1	3006322		
30156	2771	3006322	1917-12-06	1917-12-06 00:00:00	1917-12-06	5001	0	\N	0	0	\N	\N	0	183416	0	8331-1	3006322		
30233	2776	3014599	2009-01-27	2009-01-27 00:00:00	2009-01-27	5001	0	\N	0	0	\N	\N	0	183868	0	6106-9	3014599		
7500	718	3023430	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	47491	0	6833-8	3023430		
41678	3876	3006322	1982-04-28	1982-04-28 00:00:00	1982-04-28	5001	0	\N	0	0	\N	\N	0	257502	0	8331-1	3006322		
7721	742	3011505	2007-07-16	2007-07-16 00:00:00	2007-07-16	5001	0	\N	0	0	\N	\N	0	49183	0	19926-5	3011505		
30258	2776	3014599	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	183776	0	6106-9	3014599		
19210	1762	3011505	2013-04-04	2013-04-04 00:00:00	2013-04-04	5001	0	\N	0	0	\N	\N	0	117833	0	19926-5	3011505		
13701	1285	3019406	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	84976	0	6158-0	3019406		
1794	159	3006322	1994-08-19	1994-08-19 00:00:00	1994-08-19	5001	0	\N	0	0	\N	\N	0	10893	0	8331-1	3006322		
12952	1231	3006322	1955-04-11	1955-04-11 00:00:00	1955-04-11	5001	0	\N	0	0	\N	\N	0	81151	0	8331-1	3006322		
78018	2392	4133840	1999-05-28	1999-05-28 00:00:00	1999-05-28	5001	0	\N	0	0	\N	\N	0	158972	0	127783003	4133840		
3831	371	3006322	1981-05-22	1981-05-22 00:00:00	1981-05-22	5001	0	\N	0	0	\N	\N	0	24663	0	8331-1	3006322		
36670	3371	3000876	1976-03-23	1976-03-23 00:00:00	1976-03-23	5001	0	\N	0	0	\N	\N	0	223598	0	6082-2	3000876		
17239	1568	3006322	2009-06-27	2009-06-27 00:00:00	2009-06-27	5001	0	\N	0	0	\N	\N	0	105187	0	8331-1	3006322		
35521	3248	3028833	2016-06-26	2016-06-26 00:00:00	2016-06-26	5001	0	\N	0	0	\N	\N	0	215881	0	42719-5	3028833		
23557	2173	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	144731	0	6075-6	3005136		
35207	3217	3006322	1989-07-06	1989-07-06 00:00:00	1989-07-06	5001	0	\N	0	0	\N	\N	0	213780	0	8331-1	3006322		
116154	3578	4052083	2008-05-03	2008-05-03 00:00:00	2008-05-03	5001	0	\N	0	0	\N	\N	0	237864	0	23426006	4052083		
46647	4297	21494966	1991-02-19	1991-02-19 00:00:00	1991-02-19	5001	0	\N	0	0	\N	\N	0	285178	0	80271-0	21494966		
13993	1310	3006322	2013-03-29	2013-03-29 00:00:00	2013-03-29	5001	0	\N	0	0	\N	\N	0	86622	0	8331-1	3006322		
58086	5322	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	354082	0	6189-5	3006734		
58117	5325	3006322	1952-10-03	1952-10-03 00:00:00	1952-10-03	5001	0	\N	0	0	\N	\N	0	354455	0	8331-1	3006322		
41373	3857	3011505	2000-07-18	2000-07-18 00:00:00	2000-07-18	5001	0	\N	0	0	\N	\N	0	256021	0	19926-5	3011505		
24309	2244	3006322	1956-09-07	1956-09-07 00:00:00	1956-09-07	5001	0	\N	0	0	\N	\N	0	149389	0	8331-1	3006322		
52561	4827	3006322	2008-05-10	2008-05-10 00:00:00	2008-05-10	5001	0	\N	0	0	\N	\N	0	321198	0	8331-1	3006322		
52615	4831	3006322	1966-08-14	1966-08-14 00:00:00	1966-08-14	5001	0	\N	0	0	\N	\N	0	321428	0	8331-1	3006322		
4684	449	3011505	2017-09-07	2017-09-07 00:00:00	2017-09-07	5001	0	\N	0	0	\N	\N	0	29994	0	19926-5	3011505		
4435	431	3006322	1978-08-26	1978-08-26 00:00:00	1978-08-26	5001	0	\N	0	0	\N	\N	0	28620	0	8331-1	3006322		
2049	186	40769184	1972-06-28	1972-06-28 00:00:00	1972-06-28	5001	0	\N	0	0	\N	\N	0	12618	0	66524-0	40769184		
69702	2136	4024958	1995-10-10	1995-10-10 00:00:00	1995-10-10	5001	0	\N	0	0	\N	\N	0	142303	0	117015009	4024958		
27614	2546	40766240	1984-04-19	1984-04-19 00:00:00	1984-04-19	5001	0	\N	0	0	\N	\N	0	168491	0	63513-6	40766240		
53930	4943	3006322	2017-05-02	2017-05-02 00:00:00	2017-05-02	5001	0	\N	0	0	\N	\N	0	328577	0	8331-1	3006322		
12352	1176	3006322	2011-10-30	2011-10-30 00:00:00	2011-10-30	5001	0	\N	0	0	\N	\N	0	77699	0	8331-1	3006322		
38958	3603	3001488	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	239365	0	7258-7	3001488		
37147	3422	40766240	1983-05-14	1983-05-14 00:00:00	1983-05-14	5001	0	\N	0	0	\N	\N	0	227026	0	63513-6	40766240		
31900	2909	3011505	1986-04-13	1986-04-13 00:00:00	1986-04-13	5001	0	\N	0	0	\N	\N	0	193924	0	19926-5	3011505		
34834	3181	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	211666	0	6206-7	3012494		
8804	843	3027231	1995-05-06	1995-05-06 00:00:00	1995-05-06	5001	0	\N	0	0	\N	\N	0	55807	0	6276-0	3027231		
8937	857	3011505	2014-05-11	2014-05-11 00:00:00	2014-05-11	5001	0	\N	0	0	\N	\N	0	56633	0	19926-5	3011505		
79756	2456	4024958	1981-10-21	1981-10-21 00:00:00	1981-10-21	5001	0	\N	0	0	\N	\N	0	162754	0	117015009	4024958		
55094	5046	3006322	2012-10-26	2012-10-26 00:00:00	2012-10-26	5001	0	\N	0	0	\N	\N	0	335345	0	8331-1	3006322		
30203	2774	3006322	1978-08-28	1978-08-28 00:00:00	1978-08-28	5001	0	\N	0	0	\N	\N	0	183726	0	8331-1	3006322		
30234	2776	3001247	2009-01-27	2009-01-27 00:00:00	2009-01-27	5001	0	\N	0	0	\N	\N	0	183868	0	6085-5	3001247		
7501	718	3020655	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	47491	0	6844-5	3020655		
41679	3876	3006322	2006-04-05	2006-04-05 00:00:00	2006-04-05	5001	0	\N	0	0	\N	\N	0	257443	0	8331-1	3006322		
7722	742	3006322	1968-10-31	1968-10-31 00:00:00	1968-10-31	5001	0	\N	0	0	\N	\N	0	49217	0	8331-1	3006322		
30259	2776	3012494	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	183776	0	6206-7	3012494		
19211	1762	3011505	1997-04-03	1997-04-03 00:00:00	1997-04-03	5001	0	\N	0	0	\N	\N	0	117845	0	19926-5	3011505		
13702	1285	3015076	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	84976	0	6248-9	3015076		
1795	159	3006322	1999-03-17	1999-03-17 00:00:00	1999-03-17	5001	0	\N	0	0	\N	\N	0	10904	0	8331-1	3006322		
12953	1231	3006322	2009-08-18	2009-08-18 00:00:00	2009-08-18	5001	0	\N	0	0	\N	\N	0	81110	0	8331-1	3006322		
5	1	4052083	1971-01-04	1971-01-04 00:00:00	1971-01-04	5001	0	\N	0	0	\N	\N	0	23	0	23426006	4052083		
3832	371	3006322	1970-08-23	1970-08-23 00:00:00	1970-08-23	5001	0	\N	0	0	\N	\N	0	24672	0	8331-1	3006322		
36671	3371	3036780	1976-03-23	1976-03-23 00:00:00	1976-03-23	5001	0	\N	0	0	\N	\N	0	223598	0	6095-4	3036780		
17240	1568	3006322	1966-04-23	1966-04-23 00:00:00	1966-04-23	5001	0	\N	0	0	\N	\N	0	105154	0	8331-1	3006322		
35522	3248	3013721	2016-06-26	2016-06-26 00:00:00	2016-06-26	5001	0	\N	0	0	\N	\N	0	215881	0	1920-8	3013721		
23558	2173	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	144731	0	6082-2	3000876		
35208	3218	3006322	2010-05-03	2010-05-03 00:00:00	2010-05-03	5001	0	\N	0	0	\N	\N	0	213878	0	8331-1	3006322		
116164	3579	4052083	2017-07-22	2017-07-22 00:00:00	2017-07-22	5001	0	\N	0	0	\N	\N	0	237924	0	23426006	4052083		
46648	4297	3009542	1991-02-19	1991-02-19 00:00:00	1991-02-19	5001	0	\N	0	0	\N	\N	0	285178	0	20570-8	3009542		
13995	1310	3006322	2010-04-01	2010-04-01 00:00:00	2010-04-01	5001	0	\N	0	0	\N	\N	0	86661	0	8331-1	3006322		
58087	5322	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	354082	0	6075-6	3005136		
58120	5328	3006322	1954-08-04	1954-08-04 00:00:00	1954-08-04	5001	0	\N	0	0	\N	\N	0	354707	0	8331-1	3006322		
41374	3857	3006322	1980-06-04	1980-06-04 00:00:00	1980-06-04	5001	0	\N	0	0	\N	\N	0	255951	0	8331-1	3006322		
24310	2244	3006322	1972-11-24	1972-11-24 00:00:00	1972-11-24	5001	0	\N	0	0	\N	\N	0	149391	0	8331-1	3006322		
52562	4827	3006322	1963-05-03	1963-05-03 00:00:00	1963-05-03	5001	0	\N	0	0	\N	\N	0	321134	0	8331-1	3006322		
52623	4834	3006322	1984-08-10	1984-08-10 00:00:00	1984-08-10	5001	0	\N	0	0	\N	\N	0	321616	0	8331-1	3006322		
4685	449	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	29911	0	6844-5	3020655		
4436	431	3006322	1964-09-30	1964-09-30 00:00:00	1964-09-30	5001	0	\N	0	0	\N	\N	0	28613	0	8331-1	3006322		
2050	186	40769194	1972-06-28	1972-06-28 00:00:00	1972-06-28	5001	0	\N	0	0	\N	\N	0	12618	0	66534-9	40769194		
92852	2859	4024958	1972-07-28	1972-07-28 00:00:00	1972-07-28	5001	0	\N	0	0	\N	\N	0	190061	0	117015009	4024958		
27615	2546	3051031	1984-05-19	1984-05-19 00:00:00	1984-05-19	5001	0	\N	0	0	\N	\N	0	168464	0	46240-8	3051031		
53931	4943	3006322	1965-05-14	1965-05-14 00:00:00	1965-05-14	5001	0	\N	0	0	\N	\N	0	328553	0	8331-1	3006322		
12354	1176	3051031	1964-02-16	1964-02-16 00:00:00	1964-02-16	5001	0	\N	0	0	\N	\N	0	77653	0	46240-8	3051031		
38959	3603	3020655	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	239365	0	6844-5	3020655		
37149	3422	3051031	1983-05-14	1983-05-14 00:00:00	1983-05-14	5001	0	\N	0	0	\N	\N	0	227026	0	46240-8	3051031		
31901	2909	3011505	1998-05-24	1998-05-24 00:00:00	1998-05-24	5001	0	\N	0	0	\N	\N	0	193853	0	19926-5	3011505		
34835	3181	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	211666	0	6085-5	3001247		
8805	843	3006451	1995-05-06	1995-05-06 00:00:00	1995-05-06	5001	0	\N	0	0	\N	\N	0	55807	0	6273-7	3006451		
8938	857	3011505	2003-03-09	2003-03-09 00:00:00	2003-03-09	5001	0	\N	0	0	\N	\N	0	56587	0	19926-5	3011505		
79761	2456	4052083	1971-12-03	1971-12-03 00:00:00	1971-12-03	5001	0	\N	0	0	\N	\N	0	162769	0	23426006	4052083		
55095	5046	3006322	1968-12-20	1968-12-20 00:00:00	1968-12-20	5001	0	\N	0	0	\N	\N	0	335324	0	8331-1	3006322		
30204	2774	3049273	2011-03-27	2011-03-27 00:00:00	2011-03-27	5001	0	\N	0	0	\N	\N	0	183692	0	38265-5	3049273		
30235	2776	3006734	2009-01-27	2009-01-27 00:00:00	2009-01-27	5001	0	\N	0	0	\N	\N	0	183868	0	6189-5	3006734		
7502	718	3001488	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	47491	0	7258-7	3001488		
41680	3876	3001488	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	257416	0	7258-7	3001488		
7723	742	3011505	1978-09-11	1978-09-11 00:00:00	1978-09-11	5001	0	\N	0	0	\N	\N	0	49109	0	19926-5	3011505		
30260	2776	3000876	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	183776	0	6082-2	3000876		
19212	1762	3006322	1985-08-23	1985-08-23 00:00:00	1985-08-23	5001	0	\N	0	0	\N	\N	0	117807	0	8331-1	3006322		
13703	1285	3006451	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	84976	0	6273-7	3006451		
1796	159	3006322	2007-03-17	2007-03-17 00:00:00	2007-03-17	5001	0	\N	0	0	\N	\N	0	10863	0	8331-1	3006322		
12954	1231	3006322	1958-05-09	1958-05-09 00:00:00	1958-05-09	5001	0	\N	0	0	\N	\N	0	81060	0	8331-1	3006322		
21	1	4024958	1991-01-31	1991-01-31 00:00:00	1991-01-31	5001	0	\N	0	0	\N	\N	0	45	0	117015009	4024958		
3833	371	3006322	2018-08-29	2018-08-29 00:00:00	2018-08-29	5001	0	\N	0	0	\N	\N	0	24666	0	8331-1	3006322		
36672	3371	3015076	1976-03-23	1976-03-23 00:00:00	1976-03-23	5001	0	\N	0	0	\N	\N	0	223598	0	6248-9	3015076		
17241	1569	3006322	1965-01-23	1965-01-23 00:00:00	1965-01-23	5001	0	\N	0	0	\N	\N	0	105292	0	8331-1	3006322		
35523	3248	3014576	2016-06-26	2016-06-26 00:00:00	2016-06-26	5001	0	\N	0	0	\N	\N	0	215881	0	2075-0	3014576		
23559	2173	3005136	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	144748	0	6075-6	3005136		
35209	3218	3006322	2017-09-07	2017-09-07 00:00:00	2017-09-07	5001	0	\N	0	0	\N	\N	0	213816	0	8331-1	3006322		
46649	4297	3013721	1991-02-19	1991-02-19 00:00:00	1991-02-19	5001	0	\N	0	0	\N	\N	0	285178	0	1920-8	3013721		
61392	1878	4052083	1990-03-27	1990-03-27 00:00:00	1990-03-27	5001	0	\N	0	0	\N	\N	0	125326	0	23426006	4052083		
58088	5322	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	354082	0	6246-3	3021226		
58121	5328	3006322	1981-05-26	1981-05-26 00:00:00	1981-05-26	5001	0	\N	0	0	\N	\N	0	354621	0	8331-1	3006322		
41375	3857	3011505	2016-07-19	2016-07-19 00:00:00	2016-07-19	5001	0	\N	0	0	\N	\N	0	256025	0	19926-5	3011505		
24320	2250	3006322	2013-10-19	2013-10-19 00:00:00	2013-10-19	5001	0	\N	0	0	\N	\N	0	149628	0	8331-1	3006322		
52563	4827	3006322	1983-03-18	1983-03-18 00:00:00	1983-03-18	5001	0	\N	0	0	\N	\N	0	321159	0	8331-1	3006322		
52624	4834	40766240	2010-08-01	2010-08-01 00:00:00	2010-08-01	5001	0	\N	0	0	\N	\N	0	321607	0	63513-6	40766240		
4686	449	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	29911	0	6189-5	3006734		
4437	432	3006322	1957-06-26	1957-06-26 00:00:00	1957-06-26	5001	0	\N	0	0	\N	\N	0	28722	0	8331-1	3006322		
2051	186	3006322	2012-10-17	2012-10-17 00:00:00	2012-10-17	5001	0	\N	0	0	\N	\N	0	12638	0	8331-1	3006322		
92854	2860	4052083	1952-02-24	1952-02-24 00:00:00	1952-02-24	5001	0	\N	0	0	\N	\N	0	190148	0	23426006	4052083		
27616	2546	40766240	1984-05-19	1984-05-19 00:00:00	1984-05-19	5001	0	\N	0	0	\N	\N	0	168464	0	63513-6	40766240		
53932	4943	3006322	1991-09-22	1991-09-22 00:00:00	1991-09-22	5001	0	\N	0	0	\N	\N	0	328540	0	8331-1	3006322		
12356	1176	46235214	1964-02-16	1964-02-16 00:00:00	1964-02-16	5001	0	\N	0	0	\N	\N	0	77653	0	76690-7	46235214		
38960	3603	3000876	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	239365	0	6082-2	3000876		
37150	3422	46235214	1983-05-14	1983-05-14 00:00:00	1983-05-14	5001	0	\N	0	0	\N	\N	0	227026	0	76690-7	46235214		
31902	2909	3011505	1994-05-01	1994-05-01 00:00:00	1994-05-01	5001	0	\N	0	0	\N	\N	0	193867	0	19926-5	3011505		
34836	3181	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	211666	0	6189-5	3006734		
8806	843	3014599	1995-05-06	1995-05-06 00:00:00	1995-05-06	5001	0	\N	0	0	\N	\N	0	55807	0	6106-9	3014599		
8939	857	3006322	1960-02-02	1960-02-02 00:00:00	1960-02-02	5001	0	\N	0	0	\N	\N	0	56634	0	8331-1	3006322		
133796	4119	4024958	1948-11-02	1948-11-02 00:00:00	1948-11-02	5001	0	\N	0	0	\N	\N	0	273791	0	117015009	4024958		
55096	5046	3006322	2006-01-16	2006-01-16 00:00:00	2006-01-16	5001	0	\N	0	0	\N	\N	0	335344	0	8331-1	3006322		
30205	2774	3006322	2004-04-06	2004-04-06 00:00:00	2004-04-06	5001	0	\N	0	0	\N	\N	0	183660	0	8331-1	3006322		
30236	2776	3036780	2009-01-27	2009-01-27 00:00:00	2009-01-27	5001	0	\N	0	0	\N	\N	0	183868	0	6095-4	3036780		
7503	718	3006451	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	47491	0	6273-7	3006451		
41681	3876	3023430	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	257416	0	6833-8	3023430		
7724	742	3006322	1978-01-11	1978-01-11 00:00:00	1978-01-11	5001	0	\N	0	0	\N	\N	0	49138	0	8331-1	3006322		
30261	2776	40769179	2005-07-13	2005-07-13 00:00:00	2005-07-13	5001	0	\N	0	0	\N	\N	0	183856	0	66519-0	40769179		
19213	1762	3011505	1994-03-17	1994-03-17 00:00:00	1994-03-17	5001	0	\N	0	0	\N	\N	0	117824	0	19926-5	3011505		
13704	1285	3006734	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	84976	0	6189-5	3006734		
1797	159	3006322	1957-12-02	1957-12-02 00:00:00	1957-12-02	5001	0	\N	0	0	\N	\N	0	10925	0	8331-1	3006322		
12955	1231	3006322	1958-06-21	1958-06-21 00:00:00	1958-06-21	5001	0	\N	0	0	\N	\N	0	81152	0	8331-1	3006322		
24	1	4024958	1961-07-05	1961-07-05 00:00:00	1961-07-05	5001	0	\N	0	0	\N	\N	0	22	0	117015009	4024958		
3834	371	3006322	1982-04-02	1982-04-02 00:00:00	1982-04-02	5001	0	\N	0	0	\N	\N	0	24664	0	8331-1	3006322		
36673	3371	3012494	1976-03-23	1976-03-23 00:00:00	1976-03-23	5001	0	\N	0	0	\N	\N	0	223598	0	6206-7	3012494		
17242	1569	3006322	1945-04-09	1945-04-09 00:00:00	1945-04-09	5001	0	\N	0	0	\N	\N	0	105242	0	8331-1	3006322		
35524	3248	3035995	2016-06-26	2016-06-26 00:00:00	2016-06-26	5001	0	\N	0	0	\N	\N	0	215881	0	6768-6	3035995		
23560	2173	3014599	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	144748	0	6106-9	3014599		
46650	4297	3028833	1991-02-19	1991-02-19 00:00:00	1991-02-19	5001	0	\N	0	0	\N	\N	0	285178	0	42719-5	3028833		
72676	2230	4024958	1993-12-02	1993-12-02 00:00:00	1993-12-02	5001	0	\N	0	0	\N	\N	0	148374	0	117015009	4024958		
58089	5322	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	354082	0	6276-0	3027231		
58122	5328	3006322	1923-05-07	1923-05-07 00:00:00	1923-05-07	5001	0	\N	0	0	\N	\N	0	354622	0	8331-1	3006322		
41376	3857	3011505	1980-12-23	1980-12-23 00:00:00	1980-12-23	5001	0	\N	0	0	\N	\N	0	256045	0	19926-5	3011505		
3128	96	4133840	1985-02-23	1985-02-23 00:00:00	1985-02-23	5001	0	\N	0	0	\N	\N	0	6526	0	127783003	4133840		
52564	4827	3006322	1993-08-15	1993-08-15 00:00:00	1993-08-15	5001	0	\N	0	0	\N	\N	0	321093	0	8331-1	3006322		
52625	4834	40758406	2010-08-01	2010-08-01 00:00:00	2010-08-01	5001	0	\N	0	0	\N	\N	0	321607	0	55277-8	40758406		
4687	449	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	29911	0	6833-8	3023430		
4438	432	3006322	2013-03-25	2013-03-25 00:00:00	2013-03-25	5001	0	\N	0	0	\N	\N	0	28771	0	8331-1	3006322		
2052	186	3006322	2012-11-28	2012-11-28 00:00:00	2012-11-28	5001	0	\N	0	0	\N	\N	0	12599	0	8331-1	3006322		
92858	2860	4024958	1944-12-03	1944-12-03 00:00:00	1944-12-03	5001	0	\N	0	0	\N	\N	0	190131	0	117015009	4024958		
27618	2546	40758406	1984-05-19	1984-05-19 00:00:00	1984-05-19	5001	0	\N	0	0	\N	\N	0	168464	0	55277-8	40758406		
53933	4943	3006322	2016-02-23	2016-02-23 00:00:00	2016-02-23	5001	0	\N	0	0	\N	\N	0	328583	0	8331-1	3006322		
12357	1176	40766240	1964-02-16	1964-02-16 00:00:00	1964-02-16	5001	0	\N	0	0	\N	\N	0	77653	0	63513-6	40766240		
38961	3603	3006734	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	239365	0	6189-5	3006734		
37151	3422	3021226	1994-01-09	1994-01-09 00:00:00	1994-01-09	5001	0	\N	0	0	\N	\N	0	227027	0	6246-3	3021226		
31903	2909	3006322	1999-01-25	1999-01-25 00:00:00	1999-01-25	5001	0	\N	0	0	\N	\N	0	193895	0	8331-1	3006322		
34837	3181	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	211666	0	6844-5	3020655		
8807	843	3006322	2016-04-17	2016-04-17 00:00:00	2016-04-17	5001	0	\N	0	0	\N	\N	0	55855	0	8331-1	3006322		
8940	857	3011505	2005-03-20	2005-03-20 00:00:00	2005-03-20	5001	0	\N	0	0	\N	\N	0	56588	0	19926-5	3011505		
133816	4119	4024958	2012-05-08	2012-05-08 00:00:00	2012-05-08	5001	0	\N	0	0	\N	\N	0	273793	0	117015009	4024958		
55097	5046	3006322	2002-07-24	2002-07-24 00:00:00	2002-07-24	5001	0	\N	0	0	\N	\N	0	335364	0	8331-1	3006322		
30206	2774	3006322	1945-02-25	1945-02-25 00:00:00	1945-02-25	5001	0	\N	0	0	\N	\N	0	183637	0	8331-1	3006322		
30237	2776	3020655	2009-01-27	2009-01-27 00:00:00	2009-01-27	5001	0	\N	0	0	\N	\N	0	183868	0	6844-5	3020655		
7504	718	3021226	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	47491	0	6246-3	3021226		
41682	3876	3020655	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	257416	0	6844-5	3020655		
7725	742	3011505	1991-04-15	1991-04-15 00:00:00	1991-04-15	5001	0	\N	0	0	\N	\N	0	49209	0	19926-5	3011505		
30262	2776	40769194	2005-07-13	2005-07-13 00:00:00	2005-07-13	5001	0	\N	0	0	\N	\N	0	183856	0	66534-9	40769194		
19214	1762	3011505	2018-05-03	2018-05-03 00:00:00	2018-05-03	5001	0	\N	0	0	\N	\N	0	117835	0	19926-5	3011505		
13705	1285	3006322	1972-06-19	1972-06-19 00:00:00	1972-06-19	5001	0	\N	0	0	\N	\N	0	85020	0	8331-1	3006322		
1798	159	3006322	1990-06-29	1990-06-29 00:00:00	1990-06-29	5001	0	\N	0	0	\N	\N	0	10927	0	8331-1	3006322		
12956	1231	3006322	2002-05-13	2002-05-13 00:00:00	2002-05-13	5001	0	\N	0	0	\N	\N	0	81109	0	8331-1	3006322		
30	1	4052083	1976-10-20	1976-10-20 00:00:00	1976-10-20	5001	0	\N	0	0	\N	\N	0	1	0	23426006	4052083		
3835	372	3006322	1973-02-09	1973-02-09 00:00:00	1973-02-09	5001	0	\N	0	0	\N	\N	0	24764	0	8331-1	3006322		
36674	3371	3020655	1976-03-23	1976-03-23 00:00:00	1976-03-23	5001	0	\N	0	0	\N	\N	0	223598	0	6844-5	3020655		
17243	1569	3006322	2006-06-15	2006-06-15 00:00:00	2006-06-15	5001	0	\N	0	0	\N	\N	0	105272	0	8331-1	3006322		
35525	3248	3019550	2016-06-26	2016-06-26 00:00:00	2016-06-26	5001	0	\N	0	0	\N	\N	0	215881	0	2951-2	3019550		
23561	2173	3006451	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	144748	0	6273-7	3006451		
71328	2185	4052083	1983-11-12	1983-11-12 00:00:00	1983-11-12	5001	0	\N	0	0	\N	\N	0	145683	0	23426006	4052083		
72695	2231	4024958	2012-12-02	2012-12-02 00:00:00	2012-12-02	5001	0	\N	0	0	\N	\N	0	148454	0	117015009	4024958		
58090	5322	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	354082	0	6085-5	3001247		
58123	5328	3006322	2019-06-17	2019-06-17 00:00:00	2019-06-17	5001	0	\N	0	0	\N	\N	0	354612	0	8331-1	3006322		
41378	3859	3011505	2019-05-04	2019-05-04 00:00:00	2019-05-04	5001	0	\N	0	0	\N	\N	0	256248	0	19926-5	3011505		
3130	96	4052083	1962-05-22	1962-05-22 00:00:00	1962-05-22	5001	0	\N	0	0	\N	\N	0	6551	0	23426006	4052083		
52565	4827	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	321224	0	6844-5	3020655		
52626	4834	46235214	2010-08-01	2010-08-01 00:00:00	2010-08-01	5001	0	\N	0	0	\N	\N	0	321607	0	76690-7	46235214		
4688	449	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	29911	0	6246-3	3021226		
4439	432	3006322	1960-06-20	1960-06-20 00:00:00	1960-06-20	5001	0	\N	0	0	\N	\N	0	28754	0	8331-1	3006322		
2053	187	3006322	1978-11-05	1978-11-05 00:00:00	1978-11-05	5001	0	\N	0	0	\N	\N	0	12741	0	8331-1	3006322		
92872	2860	4052083	1976-06-29	1976-06-29 00:00:00	1976-06-29	5001	0	\N	0	0	\N	\N	0	190124	0	23426006	4052083		
27620	2546	46235214	1984-05-19	1984-05-19 00:00:00	1984-05-19	5001	0	\N	0	0	\N	\N	0	168464	0	76690-7	46235214		
53934	4943	3006322	1984-04-11	1984-04-11 00:00:00	1984-04-11	5001	0	\N	0	0	\N	\N	0	328539	0	8331-1	3006322		
12358	1176	40758406	1964-02-16	1964-02-16 00:00:00	1964-02-16	5001	0	\N	0	0	\N	\N	0	77653	0	55277-8	40758406		
38962	3603	3001247	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	239365	0	6085-5	3001247		
37152	3422	3019406	1994-01-09	1994-01-09 00:00:00	1994-01-09	5001	0	\N	0	0	\N	\N	0	227027	0	6158-0	3019406		
31904	2909	3011505	1984-04-08	1984-04-08 00:00:00	1984-04-08	5001	0	\N	0	0	\N	\N	0	193919	0	19926-5	3011505		
34838	3181	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	211666	0	6158-0	3019406		
8808	844	3006322	1978-05-30	1978-05-30 00:00:00	1978-05-30	5001	0	\N	0	0	\N	\N	0	55951	0	8331-1	3006322		
8941	857	3011505	2011-04-24	2011-04-24 00:00:00	2011-04-24	5001	0	\N	0	0	\N	\N	0	56642	0	19926-5	3011505		
133835	4121	4024958	1930-12-30	1930-12-30 00:00:00	1930-12-30	5001	0	\N	0	0	\N	\N	0	273988	0	117015009	4024958		
55098	5046	3006322	2015-07-26	2015-07-26 00:00:00	2015-07-26	5001	0	\N	0	0	\N	\N	0	335346	0	8331-1	3006322		
30207	2774	3006322	1995-07-12	1995-07-12 00:00:00	1995-07-12	5001	0	\N	0	0	\N	\N	0	183704	0	8331-1	3006322		
30238	2776	3001488	2009-01-27	2009-01-27 00:00:00	2009-01-27	5001	0	\N	0	0	\N	\N	0	183868	0	7258-7	3001488		
7505	718	3012494	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	47491	0	6206-7	3012494		
41683	3876	3006451	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	257416	0	6273-7	3006451		
7726	742	3011505	1996-05-13	1996-05-13 00:00:00	1996-05-13	5001	0	\N	0	0	\N	\N	0	49180	0	19926-5	3011505		
30263	2776	40769184	2005-07-13	2005-07-13 00:00:00	2005-07-13	5001	0	\N	0	0	\N	\N	0	183856	0	66524-0	40769184		
19215	1762	3011505	1990-02-22	1990-02-22 00:00:00	1990-02-22	5001	0	\N	0	0	\N	\N	0	117874	0	19926-5	3011505		
13706	1285	3006322	1993-02-23	1993-02-23 00:00:00	1993-02-23	5001	0	\N	0	0	\N	\N	0	84957	0	8331-1	3006322		
1799	160	3006322	1961-10-28	1961-10-28 00:00:00	1961-10-28	5001	0	\N	0	0	\N	\N	0	10977	0	8331-1	3006322		
12957	1231	3006322	2015-03-31	2015-03-31 00:00:00	2015-03-31	5001	0	\N	0	0	\N	\N	0	81097	0	8331-1	3006322		
36	2	4133840	2000-07-25	2000-07-25 00:00:00	2000-07-25	5001	0	\N	0	0	\N	\N	0	186	0	127783003	4133840		
3836	372	3001488	1985-05-29	1985-05-29 00:00:00	1985-05-29	5001	0	\N	0	0	\N	\N	0	24765	0	7258-7	3001488		
36675	3371	3023430	1976-03-23	1976-03-23 00:00:00	1976-03-23	5001	0	\N	0	0	\N	\N	0	223598	0	6833-8	3023430		
17244	1569	3049273	2007-03-02	2007-03-02 00:00:00	2007-03-02	5001	0	\N	0	0	\N	\N	0	105336	0	38265-5	3049273		
35526	3248	3000963	2016-06-26	2016-06-26 00:00:00	2016-06-26	5001	0	\N	0	0	\N	\N	0	215881	0	718-7	3000963		
23562	2173	3020655	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	144748	0	6844-5	3020655		
71344	2185	4024958	1948-06-09	1948-06-09 00:00:00	1948-06-09	5001	0	\N	0	0	\N	\N	0	145676	0	117015009	4024958		
72698	2231	4024958	1977-11-29	1977-11-29 00:00:00	1977-11-29	5001	0	\N	0	0	\N	\N	0	148425	0	117015009	4024958		
58091	5322	3006322	1973-04-22	1973-04-22 00:00:00	1973-04-22	5001	0	\N	0	0	\N	\N	0	354180	0	8331-1	3006322		
58124	5328	3049273	2000-01-26	2000-01-26 00:00:00	2000-01-26	5001	0	\N	0	0	\N	\N	0	354600	0	38265-5	3049273		
41379	3859	3011505	1993-07-17	1993-07-17 00:00:00	1993-07-17	5001	0	\N	0	0	\N	\N	0	256255	0	19926-5	3011505		
3131	96	4133840	1957-06-01	1957-06-01 00:00:00	1957-06-01	5001	0	\N	0	0	\N	\N	0	6561	0	127783003	4133840		
52566	4827	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	321224	0	6085-5	3001247		
46748	1428	4052083	1979-11-17	1979-11-17 00:00:00	1979-11-17	5001	0	\N	0	0	\N	\N	0	95044	0	23426006	4052083		
4689	449	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	29911	0	6158-0	3019406		
4440	432	3006322	1994-02-20	1994-02-20 00:00:00	1994-02-20	5001	0	\N	0	0	\N	\N	0	28737	0	8331-1	3006322		
2054	187	3006322	2002-12-01	2002-12-01 00:00:00	2002-12-01	5001	0	\N	0	0	\N	\N	0	12746	0	8331-1	3006322		
92882	2860	4024958	1980-02-13	1980-02-13 00:00:00	1980-02-13	5001	0	\N	0	0	\N	\N	0	190137	0	117015009	4024958		
51302	1556	4024958	1978-09-03	1978-09-03 00:00:00	1978-09-03	5001	0	\N	0	0	\N	\N	0	104272	0	117015009	4024958		
53935	4943	3006322	1971-12-05	1971-12-05 00:00:00	1971-12-05	5001	0	\N	0	0	\N	\N	0	328538	0	8331-1	3006322		
12360	1176	46235214	2012-03-30	2012-03-30 00:00:00	2012-03-30	5001	0	\N	0	0	\N	\N	0	77701	0	76690-7	46235214		
38963	3603	3036780	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	239365	0	6095-4	3036780		
37153	3422	3001488	1994-01-09	1994-01-09 00:00:00	1994-01-09	5001	0	\N	0	0	\N	\N	0	227027	0	7258-7	3001488		
31905	2909	3011505	1999-05-30	1999-05-30 00:00:00	1999-05-30	5001	0	\N	0	0	\N	\N	0	193922	0	19926-5	3011505		
34839	3181	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	211666	0	6246-3	3021226		
8809	844	3006322	1992-01-28	1992-01-28 00:00:00	1992-01-28	5001	0	\N	0	0	\N	\N	0	55893	0	8331-1	3006322		
8942	857	3006322	1954-07-22	1954-07-22 00:00:00	1954-07-22	5001	0	\N	0	0	\N	\N	0	56628	0	8331-1	3006322		
133837	4121	4133840	1983-10-16	1983-10-16 00:00:00	1983-10-16	5001	0	\N	0	0	\N	\N	0	274009	0	127783003	4133840		
55099	5046	3006322	1994-04-20	1994-04-20 00:00:00	1994-04-20	5001	0	\N	0	0	\N	\N	0	335343	0	8331-1	3006322		
30208	2774	3006322	1968-11-02	1968-11-02 00:00:00	1968-11-02	5001	0	\N	0	0	\N	\N	0	183657	0	8331-1	3006322		
30239	2776	3023430	2009-01-27	2009-01-27 00:00:00	2009-01-27	5001	0	\N	0	0	\N	\N	0	183868	0	6833-8	3023430		
7506	718	3014599	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	47491	0	6106-9	3014599		
41684	3876	3021226	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	257416	0	6246-3	3021226		
7727	742	3011505	1986-10-27	1986-10-27 00:00:00	1986-10-27	5001	0	\N	0	0	\N	\N	0	49115	0	19926-5	3011505		
30264	2776	40769189	2005-07-13	2005-07-13 00:00:00	2005-07-13	5001	0	\N	0	0	\N	\N	0	183856	0	66529-9	40769189		
19216	1762	3011505	1973-10-18	1973-10-18 00:00:00	1973-10-18	5001	0	\N	0	0	\N	\N	0	117816	0	19926-5	3011505		
13727	1289	3006322	1973-12-14	1973-12-14 00:00:00	1973-12-14	5001	0	\N	0	0	\N	\N	0	85193	0	8331-1	3006322		
1800	160	3051031	1962-11-24	1962-11-24 00:00:00	1962-11-24	5001	0	\N	0	0	\N	\N	0	10978	0	46240-8	3051031		
12958	1231	3006322	2018-09-23	2018-09-23 00:00:00	2018-09-23	5001	0	\N	0	0	\N	\N	0	81111	0	8331-1	3006322		
47	2	4133840	1989-09-26	1989-09-26 00:00:00	1989-09-26	5001	0	\N	0	0	\N	\N	0	132	0	127783003	4133840		
3837	372	3006734	1985-05-29	1985-05-29 00:00:00	1985-05-29	5001	0	\N	0	0	\N	\N	0	24765	0	6189-5	3006734		
36676	3371	3001247	1976-03-23	1976-03-23 00:00:00	1976-03-23	5001	0	\N	0	0	\N	\N	0	223598	0	6085-5	3001247		
17245	1569	3006322	1986-10-15	1986-10-15 00:00:00	1986-10-15	5001	0	\N	0	0	\N	\N	0	105237	0	8331-1	3006322		
35527	3248	3045716	2016-06-26	2016-06-26 00:00:00	2016-06-26	5001	0	\N	0	0	\N	\N	0	215881	0	33037-3	3045716		
23563	2173	3001247	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	144748	0	6085-5	3001247		
71357	2185	4024958	1946-12-04	1946-12-04 00:00:00	1946-12-04	5001	0	\N	0	0	\N	\N	0	145680	0	117015009	4024958		
72707	2231	4052083	1981-07-11	1981-07-11 00:00:00	1981-07-11	5001	0	\N	0	0	\N	\N	0	148426	0	23426006	4052083		
82798	2555	4024958	1985-10-30	1985-10-30 00:00:00	1985-10-30	5001	0	\N	0	0	\N	\N	0	169339	0	117015009	4024958		
58125	5328	3006322	1922-03-29	1922-03-29 00:00:00	1922-03-29	5001	0	\N	0	0	\N	\N	0	354617	0	8331-1	3006322		
41380	3859	3011505	2000-08-26	2000-08-26 00:00:00	2000-08-26	5001	0	\N	0	0	\N	\N	0	256238	0	19926-5	3011505		
3132	96	4133840	1973-06-30	1973-06-30 00:00:00	1973-06-30	5001	0	\N	0	0	\N	\N	0	6512	0	127783003	4133840		
52567	4827	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	321224	0	6106-9	3014599		
4690	449	3011505	2003-07-10	2003-07-10 00:00:00	2003-07-10	5001	0	\N	0	0	\N	\N	0	29992	0	19926-5	3011505		
4441	432	3006322	1939-03-21	1939-03-21 00:00:00	1939-03-21	5001	0	\N	0	0	\N	\N	0	28747	0	8331-1	3006322		
2055	187	3049273	2012-04-15	2012-04-15 00:00:00	2012-04-15	5001	0	\N	0	0	\N	\N	0	12739	0	38265-5	3049273		
92887	2860	4024958	1953-11-14	1953-11-14 00:00:00	1953-11-14	5001	0	\N	0	0	\N	\N	0	190133	0	117015009	4024958		
62657	1923	4052083	2008-08-10	2008-08-10 00:00:00	2008-08-10	5001	0	\N	0	0	\N	\N	0	127938	0	23426006	4052083		
53936	4943	3006322	1999-05-29	1999-05-29 00:00:00	1999-05-29	5001	0	\N	0	0	\N	\N	0	328575	0	8331-1	3006322		
12361	1176	40766240	2012-03-30	2012-03-30 00:00:00	2012-03-30	5001	0	\N	0	0	\N	\N	0	77701	0	63513-6	40766240		
38964	3603	3014599	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	239365	0	6106-9	3014599		
37154	3422	3001247	1994-01-09	1994-01-09 00:00:00	1994-01-09	5001	0	\N	0	0	\N	\N	0	227027	0	6085-5	3001247		
31906	2909	3006322	2004-06-09	2004-06-09 00:00:00	2004-06-09	5001	0	\N	0	0	\N	\N	0	193860	0	8331-1	3006322		
34840	3181	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	211666	0	6273-7	3006451		
8810	844	3012494	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	55953	0	6206-7	3012494		
8944	857	3011505	2006-03-26	2006-03-26 00:00:00	2006-03-26	5001	0	\N	0	0	\N	\N	0	56625	0	19926-5	3011505		
133838	4121	4024958	1952-02-23	1952-02-23 00:00:00	1952-02-23	5001	0	\N	0	0	\N	\N	0	273976	0	117015009	4024958		
55102	5048	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	335441	0	6075-6	3005136		
128865	3966	4024958	1968-12-30	1968-12-30 00:00:00	1968-12-30	5001	0	\N	0	0	\N	\N	0	263709	0	117015009	4024958		
30240	2776	3006322	2001-04-13	2001-04-13 00:00:00	2001-04-13	5001	0	\N	0	0	\N	\N	0	183855	0	8331-1	3006322		
7507	718	3027231	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	47491	0	6276-0	3027231		
41685	3876	3027231	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	257416	0	6276-0	3027231		
7728	742	3011505	2006-07-10	2006-07-10 00:00:00	2006-07-10	5001	0	\N	0	0	\N	\N	0	49213	0	19926-5	3011505		
30265	2776	3001247	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	183776	0	6085-5	3001247		
19217	1762	3011505	1993-03-11	1993-03-11 00:00:00	1993-03-11	5001	0	\N	0	0	\N	\N	0	117843	0	19926-5	3011505		
13728	1289	3006322	1989-06-11	1989-06-11 00:00:00	1989-06-11	5001	0	\N	0	0	\N	\N	0	85195	0	8331-1	3006322		
1801	160	40766240	1962-11-24	1962-11-24 00:00:00	1962-11-24	5001	0	\N	0	0	\N	\N	0	10978	0	63513-6	40766240		
12959	1231	3006322	1989-06-27	1989-06-27 00:00:00	1989-06-27	5001	0	\N	0	0	\N	\N	0	81096	0	8331-1	3006322		
55	2	4133840	1994-06-21	1994-06-21 00:00:00	1994-06-21	5001	0	\N	0	0	\N	\N	0	133	0	127783003	4133840		
3838	372	3023430	1985-05-29	1985-05-29 00:00:00	1985-05-29	5001	0	\N	0	0	\N	\N	0	24765	0	6833-8	3023430		
36677	3371	3006734	1976-03-23	1976-03-23 00:00:00	1976-03-23	5001	0	\N	0	0	\N	\N	0	223598	0	6189-5	3006734		
17246	1569	3006322	1943-06-04	1943-06-04 00:00:00	1943-06-04	5001	0	\N	0	0	\N	\N	0	105241	0	8331-1	3006322		
35528	3248	3020630	2016-06-26	2016-06-26 00:00:00	2016-06-26	5001	0	\N	0	0	\N	\N	0	215881	0	2885-2	3020630		
23564	2173	3006734	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	144748	0	6189-5	3006734		
71370	2185	4052083	2018-11-23	2018-11-23 00:00:00	2018-11-23	5001	0	\N	0	0	\N	\N	0	145658	0	23426006	4052083		
72720	2232	4052083	2016-10-13	2016-10-13 00:00:00	2016-10-13	5001	0	\N	0	0	\N	\N	0	148523	0	23426006	4052083		
82805	2555	4052083	2013-08-10	2013-08-10 00:00:00	2013-08-10	5001	0	\N	0	0	\N	\N	0	169289	0	23426006	4052083		
58126	5329	3006322	1994-11-21	1994-11-21 00:00:00	1994-11-21	5001	0	\N	0	0	\N	\N	0	354758	0	8331-1	3006322		
41381	3859	3011505	2010-10-23	2010-10-23 00:00:00	2010-10-23	5001	0	\N	0	0	\N	\N	0	256181	0	19926-5	3011505		
3134	96	4133840	1967-06-17	1967-06-17 00:00:00	1967-06-17	5001	0	\N	0	0	\N	\N	0	6478	0	127783003	4133840		
52568	4827	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	321224	0	6082-2	3000876		
4691	449	3011505	2000-02-24	2000-02-24 00:00:00	2000-02-24	5001	0	\N	0	0	\N	\N	0	29971	0	19926-5	3011505		
4442	432	3049273	2001-04-09	2001-04-09 00:00:00	2001-04-09	5001	0	\N	0	0	\N	\N	0	28696	0	38265-5	3049273		
2056	187	3006322	1996-04-08	1996-04-08 00:00:00	1996-04-08	5001	0	\N	0	0	\N	\N	0	12744	0	8331-1	3006322		
92895	2861	4024958	1999-01-16	1999-01-16 00:00:00	1999-01-16	5001	0	\N	0	0	\N	\N	0	190186	0	117015009	4024958		
86880	2684	4052083	1985-06-07	1985-06-07 00:00:00	1985-06-07	5001	0	\N	0	0	\N	\N	0	177885	0	23426006	4052083		
53937	4943	3006322	2005-06-09	2005-06-09 00:00:00	2005-06-09	5001	0	\N	0	0	\N	\N	0	328571	0	8331-1	3006322		
12362	1176	40758406	2012-03-30	2012-03-30 00:00:00	2012-03-30	5001	0	\N	0	0	\N	\N	0	77701	0	55277-8	40758406		
38965	3603	3027231	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	239365	0	6276-0	3027231		
37155	3422	3015076	1994-01-09	1994-01-09 00:00:00	1994-01-09	5001	0	\N	0	0	\N	\N	0	227027	0	6248-9	3015076		
31907	2909	3011505	1995-05-07	1995-05-07 00:00:00	1995-05-07	5001	0	\N	0	0	\N	\N	0	193926	0	19926-5	3011505		
34841	3181	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	211757	0	6273-7	3006451		
8811	844	3006451	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	55953	0	6273-7	3006451		
8945	857	3011505	1992-09-20	1992-09-20 00:00:00	1992-09-20	5001	0	\N	0	0	\N	\N	0	56664	0	19926-5	3011505		
133841	4121	4133840	1984-10-21	1984-10-21 00:00:00	1984-10-21	5001	0	\N	0	0	\N	\N	0	273991	0	127783003	4133840		
55103	5048	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	335441	0	7258-7	3001488		
128872	3966	4024958	1978-08-20	1978-08-20 00:00:00	1978-08-20	5001	0	\N	0	0	\N	\N	0	263704	0	117015009	4024958		
30241	2776	3006322	2001-06-23	2001-06-23 00:00:00	2001-06-23	5001	0	\N	0	0	\N	\N	0	183775	0	8331-1	3006322		
7508	718	3005136	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	47491	0	6075-6	3005136		
41686	3876	3015076	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	257416	0	6248-9	3015076		
7729	742	3011505	2003-06-23	2003-06-23 00:00:00	2003-06-23	5001	0	\N	0	0	\N	\N	0	49181	0	19926-5	3011505		
30266	2776	3006734	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	183776	0	6189-5	3006734		
19218	1762	3011505	2008-03-06	2008-03-06 00:00:00	2008-03-06	5001	0	\N	0	0	\N	\N	0	117858	0	19926-5	3011505		
13729	1289	3006322	2017-06-07	2017-06-07 00:00:00	2017-06-07	5001	0	\N	0	0	\N	\N	0	85229	0	8331-1	3006322		
1802	160	46235214	1962-11-24	1962-11-24 00:00:00	1962-11-24	5001	0	\N	0	0	\N	\N	0	10978	0	76690-7	46235214		
12960	1231	3006322	1960-01-25	1960-01-25 00:00:00	1960-01-25	5001	0	\N	0	0	\N	\N	0	81068	0	8331-1	3006322		
56	2	4133840	2006-08-29	2006-08-29 00:00:00	2006-08-29	5001	0	\N	0	0	\N	\N	0	198	0	127783003	4133840		
3839	372	3005136	1985-05-29	1985-05-29 00:00:00	1985-05-29	5001	0	\N	0	0	\N	\N	0	24765	0	6075-6	3005136		
36678	3371	3027231	1976-03-23	1976-03-23 00:00:00	1976-03-23	5001	0	\N	0	0	\N	\N	0	223598	0	6276-0	3027231		
17247	1569	3006322	1945-06-22	1945-06-22 00:00:00	1945-06-22	5001	0	\N	0	0	\N	\N	0	105294	0	8331-1	3006322		
35529	3248	3006923	2016-06-26	2016-06-26 00:00:00	2016-06-26	5001	0	\N	0	0	\N	\N	0	215881	0	1742-6	3006923		
23565	2173	3023430	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	144748	0	6833-8	3023430		
71388	2186	4024958	1974-10-02	1974-10-02 00:00:00	1974-10-02	5001	0	\N	0	0	\N	\N	0	145816	0	117015009	4024958		
72726	2232	4024958	2019-06-18	2019-06-18 00:00:00	2019-06-18	5001	0	\N	0	0	\N	\N	0	148514	0	117015009	4024958		
82813	2555	4052083	2004-09-22	2004-09-22 00:00:00	2004-09-22	5001	0	\N	0	0	\N	\N	0	169324	0	23426006	4052083		
58127	5329	3006322	2009-08-17	2009-08-17 00:00:00	2009-08-17	5001	0	\N	0	0	\N	\N	0	354764	0	8331-1	3006322		
41382	3859	3011505	2012-11-03	2012-11-03 00:00:00	2012-11-03	5001	0	\N	0	0	\N	\N	0	256279	0	19926-5	3011505		
3135	96	4133840	1971-06-26	1971-06-26 00:00:00	1971-06-26	5001	0	\N	0	0	\N	\N	0	6564	0	127783003	4133840		
52569	4827	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	321224	0	6248-9	3015076		
4692	449	3011505	2001-03-01	2001-03-01 00:00:00	2001-03-01	5001	0	\N	0	0	\N	\N	0	29990	0	19926-5	3011505		
4443	432	3006322	1985-12-22	1985-12-22 00:00:00	1985-12-22	5001	0	\N	0	0	\N	\N	0	28724	0	8331-1	3006322		
2057	187	3006322	1990-06-29	1990-06-29 00:00:00	1990-06-29	5001	0	\N	0	0	\N	\N	0	12696	0	8331-1	3006322		
92897	2861	4024958	1981-11-27	1981-11-27 00:00:00	1981-11-27	5001	0	\N	0	0	\N	\N	0	190195	0	117015009	4024958		
86890	2685	4133840	2013-05-09	2013-05-09 00:00:00	2013-05-09	5001	0	\N	0	0	\N	\N	0	177980	0	127783003	4133840		
14312	1340	3006322	1935-03-03	1935-03-03 00:00:00	1935-03-03	5001	0	\N	0	0	\N	\N	0	88906	0	8331-1	3006322		
12363	1176	3051031	2012-03-30	2012-03-30 00:00:00	2012-03-30	5001	0	\N	0	0	\N	\N	0	77701	0	46240-8	3051031		
38966	3603	3019406	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	239365	0	6158-0	3019406		
37156	3422	3006451	1994-01-09	1994-01-09 00:00:00	1994-01-09	5001	0	\N	0	0	\N	\N	0	227027	0	6273-7	3006451		
31908	2909	3011505	1997-05-18	1997-05-18 00:00:00	1997-05-18	5001	0	\N	0	0	\N	\N	0	193921	0	19926-5	3011505		
34842	3181	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	211757	0	6248-9	3015076		
8812	844	3023430	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	55953	0	6833-8	3023430		
8946	857	3011505	2009-04-12	2009-04-12 00:00:00	2009-04-12	5001	0	\N	0	0	\N	\N	0	56641	0	19926-5	3011505		
133844	4121	4052083	1926-02-18	1926-02-18 00:00:00	1926-02-18	5001	0	\N	0	0	\N	\N	0	273941	0	23426006	4052083		
55104	5048	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	335441	0	6085-5	3001247		
140158	4319	4133840	2002-12-25	2002-12-25 00:00:00	2002-12-25	5001	0	\N	0	0	\N	\N	0	286589	0	127783003	4133840		
30242	2776	3019406	2009-01-27	2009-01-27 00:00:00	2009-01-27	5001	0	\N	0	0	\N	\N	0	183868	0	6158-0	3019406		
7509	718	3019406	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	47491	0	6158-0	3019406		
41687	3876	3001247	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	257416	0	6085-5	3001247		
7730	742	3011505	1964-10-19	1964-10-19 00:00:00	1964-10-19	5001	0	\N	0	0	\N	\N	0	49160	0	19926-5	3011505		
30267	2776	3036780	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	183776	0	6095-4	3036780		
19219	1762	3011505	2009-03-12	2009-03-12 00:00:00	2009-03-12	5001	0	\N	0	0	\N	\N	0	117831	0	19926-5	3011505		
13730	1289	3006322	2006-12-23	2006-12-23 00:00:00	2006-12-23	5001	0	\N	0	0	\N	\N	0	85197	0	8331-1	3006322		
1803	160	40758406	1962-11-24	1962-11-24 00:00:00	1962-11-24	5001	0	\N	0	0	\N	\N	0	10978	0	55277-8	40758406		
12961	1231	3006322	1952-10-12	1952-10-12 00:00:00	1952-10-12	5001	0	\N	0	0	\N	\N	0	81059	0	8331-1	3006322		
58	2	4133840	1997-07-08	1997-07-08 00:00:00	1997-07-08	5001	0	\N	0	0	\N	\N	0	197	0	127783003	4133840		
3840	372	3021226	1985-05-29	1985-05-29 00:00:00	1985-05-29	5001	0	\N	0	0	\N	\N	0	24765	0	6246-3	3021226		
36679	3371	3006451	1976-03-23	1976-03-23 00:00:00	1976-03-23	5001	0	\N	0	0	\N	\N	0	223598	0	6273-7	3006451		
17249	1571	3006322	1967-04-28	1967-04-28 00:00:00	1967-04-28	5001	0	\N	0	0	\N	\N	0	105519	0	8331-1	3006322		
35530	3248	3010813	2016-06-26	2016-06-26 00:00:00	2016-06-26	5001	0	\N	0	0	\N	\N	0	215881	0	26464-8	3010813		
23566	2173	3001488	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	144748	0	7258-7	3001488		
72733	2232	4052083	1979-03-18	1979-03-18 00:00:00	1979-03-18	5001	0	\N	0	0	\N	\N	0	148505	0	23426006	4052083		
164899	5063	4024958	1973-01-27	1973-01-27 00:00:00	1973-01-27	5001	0	\N	0	0	\N	\N	0	336569	0	117015009	4024958		
58128	5329	3006322	1985-01-28	1985-01-28 00:00:00	1985-01-28	5001	0	\N	0	0	\N	\N	0	354757	0	8331-1	3006322		
41383	3859	3006322	1980-05-27	1980-05-27 00:00:00	1980-05-27	5001	0	\N	0	0	\N	\N	0	256270	0	8331-1	3006322		
3136	96	4133840	1981-01-31	1981-01-31 00:00:00	1981-01-31	5001	0	\N	0	0	\N	\N	0	6524	0	127783003	4133840		
52570	4827	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	321224	0	6276-0	3027231		
4693	449	3011505	2015-08-27	2015-08-27 00:00:00	2015-08-27	5001	0	\N	0	0	\N	\N	0	29993	0	19926-5	3011505		
4444	432	3006322	2015-12-25	2015-12-25 00:00:00	2015-12-25	5001	0	\N	0	0	\N	\N	0	28772	0	8331-1	3006322		
2058	187	3006322	1962-02-08	1962-02-08 00:00:00	1962-02-08	5001	0	\N	0	0	\N	\N	0	12712	0	8331-1	3006322		
104202	3207	4052083	1968-07-22	1968-07-22 00:00:00	1968-07-22	5001	0	\N	0	0	\N	\N	0	213191	0	23426006	4052083		
86892	2685	4133840	1982-12-30	1982-12-30 00:00:00	1982-12-30	5001	0	\N	0	0	\N	\N	0	177900	0	127783003	4133840		
14313	1340	3006322	1978-05-13	1978-05-13 00:00:00	1978-05-13	5001	0	\N	0	0	\N	\N	0	88909	0	8331-1	3006322		
12365	1176	3051031	2013-03-25	2013-03-25 00:00:00	2013-03-25	5001	0	\N	0	0	\N	\N	0	77704	0	46240-8	3051031		
38967	3603	3023430	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	239365	0	6833-8	3023430		
37157	3422	3000876	1994-01-09	1994-01-09 00:00:00	1994-01-09	5001	0	\N	0	0	\N	\N	0	227027	0	6082-2	3000876		
31909	2909	3011505	2001-06-10	2001-06-10 00:00:00	2001-06-10	5001	0	\N	0	0	\N	\N	0	193878	0	19926-5	3011505		
34843	3181	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	211757	0	6106-9	3014599		
8813	844	3001247	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	55953	0	6085-5	3001247		
8947	857	3011505	1992-03-15	1992-03-15 00:00:00	1992-03-15	5001	0	\N	0	0	\N	\N	0	56639	0	19926-5	3011505		
133845	4121	4133840	1973-08-19	1973-08-19 00:00:00	1973-08-19	5001	0	\N	0	0	\N	\N	0	273975	0	127783003	4133840		
55105	5048	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	335441	0	6276-0	3027231		
140161	4319	4133840	2008-12-31	2008-12-31 00:00:00	2008-12-31	5001	0	\N	0	0	\N	\N	0	286591	0	127783003	4133840		
30243	2776	3027231	2009-01-27	2009-01-27 00:00:00	2009-01-27	5001	0	\N	0	0	\N	\N	0	183868	0	6276-0	3027231		
7510	718	3000876	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	47491	0	6082-2	3000876		
41688	3876	3006734	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	257416	0	6189-5	3006734		
7731	742	3011505	2010-08-02	2010-08-02 00:00:00	2010-08-02	5001	0	\N	0	0	\N	\N	0	49125	0	19926-5	3011505		
30268	2776	3001488	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	183776	0	7258-7	3001488		
19220	1762	3011505	2006-02-23	2006-02-23 00:00:00	2006-02-23	5001	0	\N	0	0	\N	\N	0	117857	0	19926-5	3011505		
13731	1289	3006322	1975-03-19	1975-03-19 00:00:00	1975-03-19	5001	0	\N	0	0	\N	\N	0	85187	0	8331-1	3006322		
1806	160	3009542	2000-07-17	2000-07-17 00:00:00	2000-07-17	5001	0	\N	0	0	\N	\N	0	11003	0	20570-8	3009542		
12962	1232	3006322	2002-05-10	2002-05-10 00:00:00	2002-05-10	5001	0	\N	0	0	\N	\N	0	81203	0	8331-1	3006322		
60	2	4133840	1993-10-19	1993-10-19 00:00:00	1993-10-19	5001	0	\N	0	0	\N	\N	0	185	0	127783003	4133840		
3841	372	3006451	1985-05-29	1985-05-29 00:00:00	1985-05-29	5001	0	\N	0	0	\N	\N	0	24765	0	6273-7	3006451		
36680	3371	3014599	1976-03-23	1976-03-23 00:00:00	1976-03-23	5001	0	\N	0	0	\N	\N	0	223598	0	6106-9	3014599		
17250	1571	3006322	1968-12-05	1968-12-05 00:00:00	1968-12-05	5001	0	\N	0	0	\N	\N	0	105481	0	8331-1	3006322		
35531	3248	3004501	2016-06-26	2016-06-26 00:00:00	2016-06-26	5001	0	\N	0	0	\N	\N	0	215881	0	2345-7	3004501		
23567	2173	3036780	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	144748	0	6095-4	3036780		
72741	2232	4052083	1999-07-18	1999-07-18 00:00:00	1999-07-18	5001	0	\N	0	0	\N	\N	0	148521	0	23426006	4052083		
164907	5063	4052083	2010-05-21	2010-05-21 00:00:00	2010-05-21	5001	0	\N	0	0	\N	\N	0	336572	0	23426006	4052083		
58129	5329	3006322	1950-06-18	1950-06-18 00:00:00	1950-06-18	5001	0	\N	0	0	\N	\N	0	354800	0	8331-1	3006322		
41385	3859	40758406	1989-06-26	1989-06-26 00:00:00	1989-06-26	5001	0	\N	0	0	\N	\N	0	256209	0	55277-8	40758406		
3139	96	4133840	1994-04-16	1994-04-16 00:00:00	1994-04-16	5001	0	\N	0	0	\N	\N	0	6516	0	127783003	4133840		
52571	4827	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	321224	0	6158-0	3019406		
4694	449	3011505	1991-08-29	1991-08-29 00:00:00	1991-08-29	5001	0	\N	0	0	\N	\N	0	29866	0	19926-5	3011505		
15753	1441	3012494	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	96030	0	6206-7	3012494		
2059	187	3006322	1977-06-01	1977-06-01 00:00:00	1977-06-01	5001	0	\N	0	0	\N	\N	0	12702	0	8331-1	3006322		
170351	5223	4024958	1968-04-22	1968-04-22 00:00:00	1968-04-22	5001	0	\N	0	0	\N	\N	0	347573	0	117015009	4024958		
86895	2685	4133840	1985-01-03	1985-01-03 00:00:00	1985-01-03	5001	0	\N	0	0	\N	\N	0	177974	0	127783003	4133840		
14314	1340	3006322	1913-08-03	1913-08-03 00:00:00	1913-08-03	5001	0	\N	0	0	\N	\N	0	88963	0	8331-1	3006322		
12367	1176	46235214	2013-03-25	2013-03-25 00:00:00	2013-03-25	5001	0	\N	0	0	\N	\N	0	77704	0	76690-7	46235214		
38968	3603	3006322	2002-09-24	2002-09-24 00:00:00	2002-09-24	5001	0	\N	0	0	\N	\N	0	239322	0	8331-1	3006322		
37158	3422	3036780	1994-01-09	1994-01-09 00:00:00	1994-01-09	5001	0	\N	0	0	\N	\N	0	227027	0	6095-4	3036780		
31910	2909	3011505	1996-05-12	1996-05-12 00:00:00	1996-05-12	5001	0	\N	0	0	\N	\N	0	193868	0	19926-5	3011505		
34844	3181	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	211757	0	6095-4	3036780		
8814	844	3006734	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	55953	0	6189-5	3006734		
8948	857	3011505	1996-09-29	1996-09-29 00:00:00	1996-09-29	5001	0	\N	0	0	\N	\N	0	56585	0	19926-5	3011505		
133848	4121	4133840	1979-09-23	1979-09-23 00:00:00	1979-09-23	5001	0	\N	0	0	\N	\N	0	273932	0	127783003	4133840		
55106	5048	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	335441	0	6844-5	3020655		
140162	4319	4133840	1999-12-22	1999-12-22 00:00:00	1999-12-22	5001	0	\N	0	0	\N	\N	0	286588	0	127783003	4133840		
30244	2776	3021226	2009-01-27	2009-01-27 00:00:00	2009-01-27	5001	0	\N	0	0	\N	\N	0	183868	0	6246-3	3021226		
7511	718	3006734	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	47491	0	6189-5	3006734		
41689	3876	3014599	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	257416	0	6106-9	3014599		
7732	742	3011505	2001-06-11	2001-06-11 00:00:00	2001-06-11	5001	0	\N	0	0	\N	\N	0	49124	0	19926-5	3011505		
30269	2776	3019406	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	183776	0	6158-0	3019406		
19221	1762	3006322	1997-08-06	1997-08-06 00:00:00	1997-08-06	5001	0	\N	0	0	\N	\N	0	117851	0	8331-1	3006322		
13737	1292	3006322	1965-10-09	1965-10-09 00:00:00	1965-10-09	5001	0	\N	0	0	\N	\N	0	85425	0	8331-1	3006322		
1807	160	3000963	2000-07-17	2000-07-17 00:00:00	2000-07-17	5001	0	\N	0	0	\N	\N	0	11003	0	718-7	3000963		
12963	1232	3006322	2001-09-28	2001-09-28 00:00:00	2001-09-28	5001	0	\N	0	0	\N	\N	0	81222	0	8331-1	3006322		
65	2	4024958	1995-04-18	1995-04-18 00:00:00	1995-04-18	5001	0	\N	0	0	\N	\N	0	92	0	117015009	4024958		
3842	372	3015076	1985-05-29	1985-05-29 00:00:00	1985-05-29	5001	0	\N	0	0	\N	\N	0	24765	0	6248-9	3015076		
36681	3371	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	223568	0	6844-5	3020655		
17251	1571	3006322	1974-08-29	1974-08-29 00:00:00	1974-08-29	5001	0	\N	0	0	\N	\N	0	105443	0	8331-1	3006322		
35532	3248	21494966	2016-06-26	2016-06-26 00:00:00	2016-06-26	5001	0	\N	0	0	\N	\N	0	215881	0	80271-0	21494966		
23568	2173	3021226	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	144748	0	6246-3	3021226		
72746	2232	4052083	2009-08-29	2009-08-29 00:00:00	2009-08-29	5001	0	\N	0	0	\N	\N	0	148522	0	23426006	4052083		
164908	5063	4052083	1985-08-11	1985-08-11 00:00:00	1985-08-11	5001	0	\N	0	0	\N	\N	0	336634	0	23426006	4052083		
58132	5331	3006322	1977-03-30	1977-03-30 00:00:00	1977-03-30	5001	0	\N	0	0	\N	\N	0	354900	0	8331-1	3006322		
41386	3859	46235214	1989-06-26	1989-06-26 00:00:00	1989-06-26	5001	0	\N	0	0	\N	\N	0	256209	0	76690-7	46235214		
3144	96	4133840	1991-03-30	1991-03-30 00:00:00	1991-03-30	5001	0	\N	0	0	\N	\N	0	6483	0	127783003	4133840		
52572	4827	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	321224	0	6273-7	3006451		
4695	449	3011505	2011-08-04	2011-08-04 00:00:00	2011-08-04	5001	0	\N	0	0	\N	\N	0	29871	0	19926-5	3011505		
15754	1441	3023430	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	96030	0	6833-8	3023430		
2060	187	3006322	1951-12-22	1951-12-22 00:00:00	1951-12-22	5001	0	\N	0	0	\N	\N	0	12693	0	8331-1	3006322		
170354	5223	4024958	1973-08-15	1973-08-15 00:00:00	1973-08-15	5001	0	\N	0	0	\N	\N	0	347597	0	117015009	4024958		
86896	2685	4133840	1996-12-19	1996-12-19 00:00:00	1996-12-19	5001	0	\N	0	0	\N	\N	0	177930	0	127783003	4133840		
14315	1340	3006322	1912-09-23	1912-09-23 00:00:00	1912-09-23	5001	0	\N	0	0	\N	\N	0	88874	0	8331-1	3006322		
12368	1176	40766240	2013-03-25	2013-03-25 00:00:00	2013-03-25	5001	0	\N	0	0	\N	\N	0	77704	0	63513-6	40766240		
38969	3604	3006322	2005-06-21	2005-06-21 00:00:00	2005-06-21	5001	0	\N	0	0	\N	\N	0	239497	0	8331-1	3006322		
37159	3422	3012494	1994-01-09	1994-01-09 00:00:00	1994-01-09	5001	0	\N	0	0	\N	\N	0	227027	0	6206-7	3012494		
31911	2909	3011505	2007-07-15	2007-07-15 00:00:00	2007-07-15	5001	0	\N	0	0	\N	\N	0	193881	0	19926-5	3011505		
34845	3181	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	211757	0	6246-3	3021226		
8815	844	3001488	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	55953	0	7258-7	3001488		
8949	857	3011505	2007-04-01	2007-04-01 00:00:00	2007-04-01	5001	0	\N	0	0	\N	\N	0	56589	0	19926-5	3011505		
133851	4121	4133840	1987-11-08	1987-11-08 00:00:00	1987-11-08	5001	0	\N	0	0	\N	\N	0	274011	0	127783003	4133840		
55107	5048	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	335441	0	6833-8	3023430		
140165	4319	4133840	2015-04-22	2015-04-22 00:00:00	2015-04-22	5001	0	\N	0	0	\N	\N	0	286628	0	127783003	4133840		
30245	2776	3000876	2009-01-27	2009-01-27 00:00:00	2009-01-27	5001	0	\N	0	0	\N	\N	0	183868	0	6082-2	3000876		
7512	718	3015076	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	47491	0	6248-9	3015076		
41690	3876	3036780	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	257416	0	6095-4	3036780		
7733	742	46235214	1934-06-12	1934-06-12 00:00:00	1934-06-12	5001	0	\N	0	0	\N	\N	0	49107	0	76690-7	46235214		
30270	2776	3027231	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	183776	0	6276-0	3027231		
19222	1762	3011505	2011-03-24	2011-03-24 00:00:00	2011-03-24	5001	0	\N	0	0	\N	\N	0	117822	0	19926-5	3011505		
13738	1292	3006322	1961-07-21	1961-07-21 00:00:00	1961-07-21	5001	0	\N	0	0	\N	\N	0	85381	0	8331-1	3006322		
1808	160	3049273	2016-08-05	2016-08-05 00:00:00	2016-08-05	5001	0	\N	0	0	\N	\N	0	10976	0	38265-5	3049273		
12964	1232	3006322	1983-05-27	1983-05-27 00:00:00	1983-05-27	5001	0	\N	0	0	\N	\N	0	81219	0	8331-1	3006322		
74	2	4133840	2001-07-31	2001-07-31 00:00:00	2001-07-31	5001	0	\N	0	0	\N	\N	0	89	0	127783003	4133840		
3843	372	3000876	1985-05-29	1985-05-29 00:00:00	1985-05-29	5001	0	\N	0	0	\N	\N	0	24765	0	6082-2	3000876		
36682	3371	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	223568	0	6833-8	3023430		
17252	1571	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	105445	0	6095-4	3036780		
35533	3248	3002385	2016-06-26	2016-06-26 00:00:00	2016-06-26	5001	0	\N	0	0	\N	\N	0	215881	0	30385-9	3002385		
23569	2173	3015076	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	144748	0	6248-9	3015076		
95996	2943	4024958	1915-09-28	1915-09-28 00:00:00	1915-09-28	5001	0	\N	0	0	\N	\N	0	196332	0	117015009	4024958		
164911	5063	4024958	1954-11-23	1954-11-23 00:00:00	1954-11-23	5001	0	\N	0	0	\N	\N	0	336628	0	117015009	4024958		
58133	5331	3006322	1965-11-18	1965-11-18 00:00:00	1965-11-18	5001	0	\N	0	0	\N	\N	0	354916	0	8331-1	3006322		
41388	3859	3051031	1989-06-26	1989-06-26 00:00:00	1989-06-26	5001	0	\N	0	0	\N	\N	0	256209	0	46240-8	3051031		
3147	96	4133840	1969-06-21	1969-06-21 00:00:00	1969-06-21	5001	0	\N	0	0	\N	\N	0	6523	0	127783003	4133840		
152564	4676	4024958	1993-03-24	1993-03-24 00:00:00	1993-03-24	5001	0	\N	0	0	\N	\N	0	311588	0	117015009	4024958		
4696	449	3020655	1984-11-21	1984-11-21 00:00:00	1984-11-21	5001	0	\N	0	0	\N	\N	0	29904	0	6844-5	3020655		
15755	1441	3001247	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	96030	0	6085-5	3001247		
2061	187	3006322	1979-03-17	1979-03-17 00:00:00	1979-03-17	5001	0	\N	0	0	\N	\N	0	12742	0	8331-1	3006322		
8243	782	3006322	1960-10-28	1960-10-28 00:00:00	1960-10-28	5001	0	\N	0	0	\N	\N	0	51981	0	8331-1	3006322		
86902	2685	4133840	2011-04-28	2011-04-28 00:00:00	2011-04-28	5001	0	\N	0	0	\N	\N	0	177965	0	127783003	4133840		
14316	1340	3049273	1971-07-15	1971-07-15 00:00:00	1971-07-15	5001	0	\N	0	0	\N	\N	0	88865	0	38265-5	3049273		
12370	1176	40758406	2013-03-25	2013-03-25 00:00:00	2013-03-25	5001	0	\N	0	0	\N	\N	0	77704	0	55277-8	40758406		
38970	3604	3027231	2000-11-10	2000-11-10 00:00:00	2000-11-10	5001	0	\N	0	0	\N	\N	0	239496	0	6276-0	3027231		
37160	3422	3005136	1994-01-09	1994-01-09 00:00:00	1994-01-09	5001	0	\N	0	0	\N	\N	0	227027	0	6075-6	3005136		
31912	2909	3011505	2004-06-27	2004-06-27 00:00:00	2004-06-27	5001	0	\N	0	0	\N	\N	0	193927	0	19926-5	3011505		
34846	3181	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	211757	0	6082-2	3000876		
8816	844	3020655	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	55953	0	6844-5	3020655		
8950	857	3011505	2015-05-17	2015-05-17 00:00:00	2015-05-17	5001	0	\N	0	0	\N	\N	0	56627	0	19926-5	3011505		
133853	4121	4133840	1970-04-19	1970-04-19 00:00:00	1970-04-19	5001	0	\N	0	0	\N	\N	0	273973	0	127783003	4133840		
55108	5048	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	335441	0	6206-7	3012494		
140166	4319	4052083	1998-09-19	1998-09-19 00:00:00	1998-09-19	5001	0	\N	0	0	\N	\N	0	286611	0	23426006	4052083		
30246	2776	3036780	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	183776	0	6095-4	3036780		
7513	718	3036780	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	47491	0	6095-4	3036780		
41691	3876	3019406	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	257416	0	6158-0	3019406		
7736	742	40766240	1934-06-12	1934-06-12 00:00:00	1934-06-12	5001	0	\N	0	0	\N	\N	0	49107	0	63513-6	40766240		
30271	2776	3021226	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	183776	0	6246-3	3021226		
19223	1762	3011505	2016-04-21	2016-04-21 00:00:00	2016-04-21	5001	0	\N	0	0	\N	\N	0	117832	0	19926-5	3011505		
13739	1292	3006322	2017-11-02	2017-11-02 00:00:00	2017-11-02	5001	0	\N	0	0	\N	\N	0	85428	0	8331-1	3006322		
1809	160	3006322	2016-09-06	2016-09-06 00:00:00	2016-09-06	5001	0	\N	0	0	\N	\N	0	10965	0	8331-1	3006322		
12965	1232	3006322	1965-09-14	1965-09-14 00:00:00	1965-09-14	5001	0	\N	0	0	\N	\N	0	81198	0	8331-1	3006322		
76	2	4133840	1995-06-27	1995-06-27 00:00:00	1995-06-27	5001	0	\N	0	0	\N	\N	0	196	0	127783003	4133840		
3844	372	3019406	1985-05-29	1985-05-29 00:00:00	1985-05-29	5001	0	\N	0	0	\N	\N	0	24765	0	6158-0	3019406		
36683	3371	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	223568	0	6189-5	3006734		
17253	1571	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	105445	0	6273-7	3006451		
35534	3248	3026361	2016-06-26	2016-06-26 00:00:00	2016-06-26	5001	0	\N	0	0	\N	\N	0	215881	0	26453-1	3026361		
23570	2173	3019406	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	144748	0	6158-0	3019406		
96000	2943	4052083	1977-08-02	1977-08-02 00:00:00	1977-08-02	5001	0	\N	0	0	\N	\N	0	196321	0	23426006	4052083		
164921	5063	4052083	1957-08-20	1957-08-20 00:00:00	1957-08-20	5001	0	\N	0	0	\N	\N	0	336552	0	23426006	4052083		
58134	5331	3006322	1983-06-06	1983-06-06 00:00:00	1983-06-06	5001	0	\N	0	0	\N	\N	0	354901	0	8331-1	3006322		
41389	3859	40766240	1989-06-26	1989-06-26 00:00:00	1989-06-26	5001	0	\N	0	0	\N	\N	0	256209	0	63513-6	40766240		
3149	96	4133840	1989-03-18	1989-03-18 00:00:00	1989-03-18	5001	0	\N	0	0	\N	\N	0	6493	0	127783003	4133840		
152565	4677	4024958	1971-08-29	1971-08-29 00:00:00	1971-08-29	5001	0	\N	0	0	\N	\N	0	311652	0	117015009	4024958		
4697	449	3006734	1984-11-21	1984-11-21 00:00:00	1984-11-21	5001	0	\N	0	0	\N	\N	0	29904	0	6189-5	3006734		
15756	1441	3015076	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	96030	0	6248-9	3015076		
2062	187	3006322	2006-12-22	2006-12-22 00:00:00	2006-12-22	5001	0	\N	0	0	\N	\N	0	12670	0	8331-1	3006322		
8244	782	3006322	1963-08-28	1963-08-28 00:00:00	1963-08-28	5001	0	\N	0	0	\N	\N	0	51966	0	8331-1	3006322		
86903	2685	4133840	2010-04-22	2010-04-22 00:00:00	2010-04-22	5001	0	\N	0	0	\N	\N	0	177905	0	127783003	4133840		
14317	1340	3006322	1934-02-24	1934-02-24 00:00:00	1934-02-24	5001	0	\N	0	0	\N	\N	0	88939	0	8331-1	3006322		
12371	1176	40766240	2012-09-26	2012-09-26 00:00:00	2012-09-26	5001	0	\N	0	0	\N	\N	0	77702	0	63513-6	40766240		
38971	3604	3006451	2000-11-10	2000-11-10 00:00:00	2000-11-10	5001	0	\N	0	0	\N	\N	0	239496	0	6273-7	3006451		
37161	3422	3027231	1994-01-09	1994-01-09 00:00:00	1994-01-09	5001	0	\N	0	0	\N	\N	0	227027	0	6276-0	3027231		
31920	2913	3006322	1959-12-27	1959-12-27 00:00:00	1959-12-27	5001	0	\N	0	0	\N	\N	0	194095	0	8331-1	3006322		
34847	3181	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	211757	0	7258-7	3001488		
8817	844	3036780	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	55953	0	6095-4	3036780		
20228	1852	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	123986	0	6189-5	3006734		
133854	4121	4133840	1977-09-11	1977-09-11 00:00:00	1977-09-11	5001	0	\N	0	0	\N	\N	0	274021	0	127783003	4133840		
55109	5048	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	335441	0	6189-5	3006734		
140167	4319	4133840	2012-04-18	2012-04-18 00:00:00	2012-04-18	5001	0	\N	0	0	\N	\N	0	286627	0	127783003	4133840		
30247	2776	3001488	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	183776	0	7258-7	3001488		
7514	719	3006322	1992-05-17	1992-05-17 00:00:00	1992-05-17	5001	0	\N	0	0	\N	\N	0	47567	0	8331-1	3006322		
41692	3876	3000876	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	257416	0	6082-2	3000876		
7737	742	40758406	1934-06-12	1934-06-12 00:00:00	1934-06-12	5001	0	\N	0	0	\N	\N	0	49107	0	55277-8	40758406		
30272	2776	3023430	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	183776	0	6833-8	3023430		
19224	1762	3006322	1961-02-27	1961-02-27 00:00:00	1961-02-27	5001	0	\N	0	0	\N	\N	0	117799	0	8331-1	3006322		
13740	1292	3006322	1986-05-04	1986-05-04 00:00:00	1986-05-04	5001	0	\N	0	0	\N	\N	0	85426	0	8331-1	3006322		
1810	160	40766240	1962-12-24	1962-12-24 00:00:00	1962-12-24	5001	0	\N	0	0	\N	\N	0	10935	0	63513-6	40766240		
12968	1235	3006322	2011-01-06	2011-01-06 00:00:00	2011-01-06	5001	0	\N	0	0	\N	\N	0	81315	0	8331-1	3006322		
165903	5099	4024958	1999-02-27	1999-02-27 00:00:00	1999-02-27	5001	0	\N	0	0	\N	\N	0	338891	0	117015009	4024958		
3845	372	3001247	1985-05-29	1985-05-29 00:00:00	1985-05-29	5001	0	\N	0	0	\N	\N	0	24765	0	6085-5	3001247		
36684	3371	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	223568	0	6082-2	3000876		
17254	1571	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	105445	0	6246-3	3021226		
35535	3248	3009542	2016-06-26	2016-06-26 00:00:00	2016-06-26	5001	0	\N	0	0	\N	\N	0	215881	0	20570-8	3009542		
23571	2173	3012494	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	144748	0	6206-7	3012494		
96030	2943	4052083	2003-03-23	2003-03-23 00:00:00	2003-03-23	5001	0	\N	0	0	\N	\N	0	196295	0	23426006	4052083		
164922	5063	4052083	1967-05-09	1967-05-09 00:00:00	1967-05-09	5001	0	\N	0	0	\N	\N	0	336590	0	23426006	4052083		
58135	5331	3006322	2015-04-06	2015-04-06 00:00:00	2015-04-06	5001	0	\N	0	0	\N	\N	0	354961	0	8331-1	3006322		
41390	3859	3011505	2002-09-07	2002-09-07 00:00:00	2002-09-07	5001	0	\N	0	0	\N	\N	0	256239	0	19926-5	3011505		
3154	96	4133840	1992-04-04	1992-04-04 00:00:00	1992-04-04	5001	0	\N	0	0	\N	\N	0	6495	0	127783003	4133840		
152571	4677	4052083	1981-03-02	1981-03-02 00:00:00	1981-03-02	5001	0	\N	0	0	\N	\N	0	311653	0	23426006	4052083		
4698	449	3023430	1984-11-21	1984-11-21 00:00:00	1984-11-21	5001	0	\N	0	0	\N	\N	0	29904	0	6833-8	3023430		
15757	1441	3021226	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	96030	0	6246-3	3021226		
2063	187	3006322	2000-10-27	2000-10-27 00:00:00	2000-10-27	5001	0	\N	0	0	\N	\N	0	12704	0	8331-1	3006322		
8246	782	3049273	1982-03-07	1982-03-07 00:00:00	1982-03-07	5001	0	\N	0	0	\N	\N	0	52050	0	38265-5	3049273		
86907	2685	4133840	2014-05-15	2014-05-15 00:00:00	2014-05-15	5001	0	\N	0	0	\N	\N	0	177934	0	127783003	4133840		
25606	2349	3014599	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	156449	0	6106-9	3014599		
12372	1176	3051031	2012-09-26	2012-09-26 00:00:00	2012-09-26	5001	0	\N	0	0	\N	\N	0	77702	0	46240-8	3051031		
38972	3604	3000876	2000-11-10	2000-11-10 00:00:00	2000-11-10	5001	0	\N	0	0	\N	\N	0	239496	0	6082-2	3000876		
37162	3422	3014599	1994-01-09	1994-01-09 00:00:00	1994-01-09	5001	0	\N	0	0	\N	\N	0	227027	0	6106-9	3014599		
31921	2913	3006322	1973-02-27	1973-02-27 00:00:00	1973-02-27	5001	0	\N	0	0	\N	\N	0	194111	0	8331-1	3006322		
34848	3181	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	211757	0	6276-0	3027231		
8818	844	3019406	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	55953	0	6158-0	3019406		
20229	1852	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	123986	0	6082-2	3000876		
133855	4121	4133840	1968-05-12	1968-05-12 00:00:00	1968-05-12	5001	0	\N	0	0	\N	\N	0	273972	0	127783003	4133840		
55110	5048	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	335441	0	6158-0	3019406		
140170	4319	4133840	2009-04-15	2009-04-15 00:00:00	2009-04-15	5001	0	\N	0	0	\N	\N	0	286626	0	127783003	4133840		
30248	2776	3023430	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	183776	0	6833-8	3023430		
7515	719	3006322	2007-04-13	2007-04-13 00:00:00	2007-04-13	5001	0	\N	0	0	\N	\N	0	47559	0	8331-1	3006322		
41693	3876	3012494	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	257416	0	6206-7	3012494		
7738	742	3051031	1934-06-12	1934-06-12 00:00:00	1934-06-12	5001	0	\N	0	0	\N	\N	0	49107	0	46240-8	3051031		
30273	2776	3020655	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	183776	0	6844-5	3020655		
19225	1762	3011505	2000-04-20	2000-04-20 00:00:00	2000-04-20	5001	0	\N	0	0	\N	\N	0	117820	0	19926-5	3011505		
13741	1293	3006322	1979-05-11	1979-05-11 00:00:00	1979-05-11	5001	0	\N	0	0	\N	\N	0	85522	0	8331-1	3006322		
1811	160	40758406	1962-12-24	1962-12-24 00:00:00	1962-12-24	5001	0	\N	0	0	\N	\N	0	10935	0	55277-8	40758406		
12969	1235	3006322	2005-02-20	2005-02-20 00:00:00	2005-02-20	5001	0	\N	0	0	\N	\N	0	81348	0	8331-1	3006322		
165910	5099	4024958	1946-04-28	1946-04-28 00:00:00	1946-04-28	5001	0	\N	0	0	\N	\N	0	338834	0	117015009	4024958		
3846	372	3012494	1985-05-29	1985-05-29 00:00:00	1985-05-29	5001	0	\N	0	0	\N	\N	0	24765	0	6206-7	3012494		
36685	3371	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	223568	0	6095-4	3036780		
17255	1571	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	105445	0	6276-0	3027231		
35536	3248	3006322	1954-03-08	1954-03-08 00:00:00	1954-03-08	5001	0	\N	0	0	\N	\N	0	215928	0	8331-1	3006322		
23572	2173	3027231	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	144748	0	6276-0	3027231		
96040	2944	4052083	1965-12-01	1965-12-01 00:00:00	1965-12-01	5001	0	\N	0	0	\N	\N	0	196426	0	23426006	4052083		
164933	5063	4052083	1999-06-08	1999-06-08 00:00:00	1999-06-08	5001	0	\N	0	0	\N	\N	0	336570	0	23426006	4052083		
58139	5333	3006322	1965-11-23	1965-11-23 00:00:00	1965-11-23	5001	0	\N	0	0	\N	\N	0	355147	0	8331-1	3006322		
41391	3859	3006322	2016-04-08	2016-04-08 00:00:00	2016-04-08	5001	0	\N	0	0	\N	\N	0	256262	0	8331-1	3006322		
3156	96	4133840	1980-01-26	1980-01-26 00:00:00	1980-01-26	5001	0	\N	0	0	\N	\N	0	6492	0	127783003	4133840		
152574	4677	4024958	2016-04-22	2016-04-22 00:00:00	2016-04-22	5001	0	\N	0	0	\N	\N	0	311648	0	117015009	4024958		
4699	449	3000876	1984-11-21	1984-11-21 00:00:00	1984-11-21	5001	0	\N	0	0	\N	\N	0	29904	0	6082-2	3000876		
15758	1441	3014599	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	96030	0	6106-9	3014599		
2064	188	3006322	1999-01-26	1999-01-26 00:00:00	1999-01-26	5001	0	\N	0	0	\N	\N	0	12787	0	8331-1	3006322		
8248	782	3006322	1938-09-27	1938-09-27 00:00:00	1938-09-27	5001	0	\N	0	0	\N	\N	0	51991	0	8331-1	3006322		
86909	2685	4024958	1989-05-05	1989-05-05 00:00:00	1989-05-05	5001	0	\N	0	0	\N	\N	0	177908	0	117015009	4024958		
25607	2349	3006451	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	156449	0	6273-7	3006451		
12374	1176	46235214	2012-09-26	2012-09-26 00:00:00	2012-09-26	5001	0	\N	0	0	\N	\N	0	77702	0	76690-7	46235214		
38973	3604	3019406	2000-11-10	2000-11-10 00:00:00	2000-11-10	5001	0	\N	0	0	\N	\N	0	239496	0	6158-0	3019406		
37163	3422	3020655	1994-01-09	1994-01-09 00:00:00	1994-01-09	5001	0	\N	0	0	\N	\N	0	227027	0	6844-5	3020655		
31922	2913	3006322	1989-09-15	1989-09-15 00:00:00	1989-09-15	5001	0	\N	0	0	\N	\N	0	194112	0	8331-1	3006322		
34849	3181	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	211757	0	6075-6	3005136		
8819	844	3005136	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	55953	0	6075-6	3005136		
20230	1852	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	123986	0	6246-3	3021226		
133858	4121	4024958	1921-01-16	1921-01-16 00:00:00	1921-01-16	5001	0	\N	0	0	\N	\N	0	273953	0	117015009	4024958		
55111	5048	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	335441	0	6246-3	3021226		
140178	4319	4133840	2017-12-13	2017-12-13 00:00:00	2017-12-13	5001	0	\N	0	0	\N	\N	0	286610	0	127783003	4133840		
30249	2776	3020655	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	183776	0	6844-5	3020655		
7516	719	3006322	2012-10-24	2012-10-24 00:00:00	2012-10-24	5001	0	\N	0	0	\N	\N	0	47561	0	8331-1	3006322		
41694	3876	3005136	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	257416	0	6075-6	3005136		
7739	742	3011505	2012-12-17	2012-12-17 00:00:00	2012-12-17	5001	0	\N	0	0	\N	\N	0	49197	0	19926-5	3011505		
30274	2776	3000876	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	183776	0	6082-2	3000876		
19226	1762	3011505	2001-01-25	2001-01-25 00:00:00	2001-01-25	5001	0	\N	0	0	\N	\N	0	117876	0	19926-5	3011505		
13742	1293	3006322	1981-01-22	1981-01-22 00:00:00	1981-01-22	5001	0	\N	0	0	\N	\N	0	85578	0	8331-1	3006322		
136151	4199	4024958	1953-06-06	1953-06-06 00:00:00	1953-06-06	5001	0	\N	0	0	\N	\N	0	278683	0	117015009	4024958		
12970	1236	3049273	2005-12-08	2005-12-08 00:00:00	2005-12-08	5001	0	\N	0	0	\N	\N	0	81489	0	38265-5	3049273		
165913	5099	4052083	1969-02-13	1969-02-13 00:00:00	1969-02-13	5001	0	\N	0	0	\N	\N	0	338868	0	23426006	4052083		
3847	372	3036780	1985-05-29	1985-05-29 00:00:00	1985-05-29	5001	0	\N	0	0	\N	\N	0	24765	0	6095-4	3036780		
36686	3371	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	223568	0	6248-9	3015076		
17256	1571	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	105445	0	6158-0	3019406		
35537	3248	3006322	1955-08-14	1955-08-14 00:00:00	1955-08-14	5001	0	\N	0	0	\N	\N	0	215918	0	8331-1	3006322		
23573	2173	3000876	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	144748	0	6082-2	3000876		
96050	2944	4052083	1998-03-08	1998-03-08 00:00:00	1998-03-08	5001	0	\N	0	0	\N	\N	0	196405	0	23426006	4052083		
164940	5063	4024958	1997-06-30	1997-06-30 00:00:00	1997-06-30	5001	0	\N	0	0	\N	\N	0	336635	0	117015009	4024958		
58141	5333	3006322	1987-09-01	1987-09-01 00:00:00	1987-09-01	5001	0	\N	0	0	\N	\N	0	355130	0	8331-1	3006322		
41392	3859	3011505	2009-10-17	2009-10-17 00:00:00	2009-10-17	5001	0	\N	0	0	\N	\N	0	256161	0	19926-5	3011505		
3159	96	4133840	1988-03-12	1988-03-12 00:00:00	1988-03-12	5001	0	\N	0	0	\N	\N	0	6482	0	127783003	4133840		
152580	4677	4024958	2002-01-10	2002-01-10 00:00:00	2002-01-10	5001	0	\N	0	0	\N	\N	0	311656	0	117015009	4024958		
4700	449	3001488	1984-11-21	1984-11-21 00:00:00	1984-11-21	5001	0	\N	0	0	\N	\N	0	29904	0	7258-7	3001488		
26290	2419	3006322	1971-07-09	1971-07-09 00:00:00	1971-07-09	5001	0	\N	0	0	\N	\N	0	160629	0	8331-1	3006322		
2065	188	3006322	2018-04-17	2018-04-17 00:00:00	2018-04-17	5001	0	\N	0	0	\N	\N	0	12788	0	8331-1	3006322		
8250	782	3006322	1945-06-09	1945-06-09 00:00:00	1945-06-09	5001	0	\N	0	0	\N	\N	0	52023	0	8331-1	3006322		
86911	2685	4133840	2016-05-26	2016-05-26 00:00:00	2016-05-26	5001	0	\N	0	0	\N	\N	0	177935	0	127783003	4133840		
25608	2349	3001488	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	156449	0	7258-7	3001488		
12375	1176	40758406	2012-09-26	2012-09-26 00:00:00	2012-09-26	5001	0	\N	0	0	\N	\N	0	77702	0	55277-8	40758406		
38974	3604	3015076	2000-11-10	2000-11-10 00:00:00	2000-11-10	5001	0	\N	0	0	\N	\N	0	239496	0	6248-9	3015076		
37164	3422	3006734	1994-01-09	1994-01-09 00:00:00	1994-01-09	5001	0	\N	0	0	\N	\N	0	227027	0	6189-5	3006734		
31923	2913	3006322	2003-04-19	2003-04-19 00:00:00	2003-04-19	5001	0	\N	0	0	\N	\N	0	194129	0	8331-1	3006322		
34850	3181	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	211757	0	6206-7	3012494		
8820	844	3021226	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	55953	0	6246-3	3021226		
20231	1852	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	123986	0	6206-7	3012494		
133861	4121	4133840	1976-09-05	1976-09-05 00:00:00	1976-09-05	5001	0	\N	0	0	\N	\N	0	274008	0	127783003	4133840		
55112	5048	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	335441	0	6273-7	3006451		
140183	4319	4133840	2005-12-28	2005-12-28 00:00:00	2005-12-28	5001	0	\N	0	0	\N	\N	0	286590	0	127783003	4133840		
30250	2776	3027231	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	183776	0	6276-0	3027231		
7517	719	3006322	2017-12-06	2017-12-06 00:00:00	2017-12-06	5001	0	\N	0	0	\N	\N	0	47606	0	8331-1	3006322		
18802	1727	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	115425	0	6106-9	3014599		
7741	742	3049273	1991-11-12	1991-11-12 00:00:00	1991-11-12	5001	0	\N	0	0	\N	\N	0	49190	0	38265-5	3049273		
30275	2776	3006451	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	183776	0	6273-7	3006451		
19227	1762	3011505	1992-03-05	1992-03-05 00:00:00	1992-03-05	5001	0	\N	0	0	\N	\N	0	117823	0	19926-5	3011505		
13743	1293	3006322	1988-02-01	1988-02-01 00:00:00	1988-02-01	5001	0	\N	0	0	\N	\N	0	85468	0	8331-1	3006322		
136155	4199	4024958	1960-01-24	1960-01-24 00:00:00	1960-01-24	5001	0	\N	0	0	\N	\N	0	278686	0	117015009	4024958		
12971	1236	3006322	1966-11-06	1966-11-06 00:00:00	1966-11-06	5001	0	\N	0	0	\N	\N	0	81422	0	8331-1	3006322		
165914	5099	4024958	1972-11-04	1972-11-04 00:00:00	1972-11-04	5001	0	\N	0	0	\N	\N	0	338838	0	117015009	4024958		
3848	372	3014599	1985-05-29	1985-05-29 00:00:00	1985-05-29	5001	0	\N	0	0	\N	\N	0	24765	0	6106-9	3014599		
36687	3371	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	223568	0	6206-7	3012494		
17257	1571	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	105445	0	6075-6	3005136		
35538	3248	3006322	2011-04-27	2011-04-27 00:00:00	2011-04-27	5001	0	\N	0	0	\N	\N	0	215858	0	8331-1	3006322		
23574	2173	3006322	1931-10-02	1931-10-02 00:00:00	1931-10-02	5001	0	\N	0	0	\N	\N	0	144724	0	8331-1	3006322		
96053	2944	4024958	2000-01-03	2000-01-03 00:00:00	2000-01-03	5001	0	\N	0	0	\N	\N	0	196422	0	117015009	4024958		
164970	5065	4024958	1984-11-26	1984-11-26 00:00:00	1984-11-26	5001	0	\N	0	0	\N	\N	0	336720	0	117015009	4024958		
58142	5333	3006322	1981-07-23	1981-07-23 00:00:00	1981-07-23	5001	0	\N	0	0	\N	\N	0	355108	0	8331-1	3006322		
41393	3859	3011505	2008-10-11	2008-10-11 00:00:00	2008-10-11	5001	0	\N	0	0	\N	\N	0	256180	0	19926-5	3011505		
3160	96	4133840	1960-06-04	1960-06-04 00:00:00	1960-06-04	5001	0	\N	0	0	\N	\N	0	6562	0	127783003	4133840		
152586	4677	4024958	1964-01-14	1964-01-14 00:00:00	1964-01-14	5001	0	\N	0	0	\N	\N	0	311642	0	117015009	4024958		
4701	449	3001247	1984-11-21	1984-11-21 00:00:00	1984-11-21	5001	0	\N	0	0	\N	\N	0	29904	0	6085-5	3001247		
26291	2419	3006322	2000-11-02	2000-11-02 00:00:00	2000-11-02	5001	0	\N	0	0	\N	\N	0	160527	0	8331-1	3006322		
2066	188	3006322	1967-10-25	1967-10-25 00:00:00	1967-10-25	5001	0	\N	0	0	\N	\N	0	12824	0	8331-1	3006322		
8251	782	3006322	1951-12-28	1951-12-28 00:00:00	1951-12-28	5001	0	\N	0	0	\N	\N	0	52025	0	8331-1	3006322		
86914	2685	4133840	1998-02-12	1998-02-12 00:00:00	1998-02-12	5001	0	\N	0	0	\N	\N	0	177962	0	127783003	4133840		
25609	2349	3023430	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	156449	0	6833-8	3023430		
12377	1176	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	77634	0	6844-5	3020655		
38975	3604	3001247	2000-11-10	2000-11-10 00:00:00	2000-11-10	5001	0	\N	0	0	\N	\N	0	239496	0	6085-5	3001247		
37165	3422	3023430	1994-01-09	1994-01-09 00:00:00	1994-01-09	5001	0	\N	0	0	\N	\N	0	227027	0	6833-8	3023430		
31924	2913	3006322	1956-12-28	1956-12-28 00:00:00	1956-12-28	5001	0	\N	0	0	\N	\N	0	194109	0	8331-1	3006322		
34851	3181	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	211757	0	6085-5	3001247		
8821	844	3027231	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	55953	0	6276-0	3027231		
20232	1852	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	123986	0	6085-5	3001247		
133863	4121	4133840	1980-09-28	1980-09-28 00:00:00	1980-09-28	5001	0	\N	0	0	\N	\N	0	273939	0	127783003	4133840		
55113	5048	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	335441	0	6082-2	3000876		
140190	4320	4024958	1984-03-16	1984-03-16 00:00:00	1984-03-16	5001	0	\N	0	0	\N	\N	0	286650	0	117015009	4024958		
30251	2776	3019406	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	183776	0	6158-0	3019406		
7518	720	3006322	2010-05-28	2010-05-28 00:00:00	2010-05-28	5001	0	\N	0	0	\N	\N	0	47633	0	8331-1	3006322		
18803	1727	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	115425	0	6246-3	3021226		
7742	742	3011505	2005-07-04	2005-07-04 00:00:00	2005-07-04	5001	0	\N	0	0	\N	\N	0	49182	0	19926-5	3011505		
30276	2776	3015076	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	183776	0	6248-9	3015076		
19228	1762	3011505	1979-02-01	1979-02-01 00:00:00	1979-02-01	5001	0	\N	0	0	\N	\N	0	117801	0	19926-5	3011505		
13744	1293	3006322	1979-10-22	1979-10-22 00:00:00	1979-10-22	5001	0	\N	0	0	\N	\N	0	85547	0	8331-1	3006322		
136157	4199	4052083	1976-01-04	1976-01-04 00:00:00	1976-01-04	5001	0	\N	0	0	\N	\N	0	278624	0	23426006	4052083		
12972	1236	3006322	2002-12-20	2002-12-20 00:00:00	2002-12-20	5001	0	\N	0	0	\N	\N	0	81365	0	8331-1	3006322		
165920	5099	4024958	2017-04-07	2017-04-07 00:00:00	2017-04-07	5001	0	\N	0	0	\N	\N	0	338843	0	117015009	4024958		
3849	372	3027231	1985-05-29	1985-05-29 00:00:00	1985-05-29	5001	0	\N	0	0	\N	\N	0	24765	0	6276-0	3027231		
36688	3371	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	223568	0	6085-5	3001247		
17258	1571	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	105445	0	6106-9	3014599		
35539	3248	3006322	1951-08-12	1951-08-12 00:00:00	1951-08-12	5001	0	\N	0	0	\N	\N	0	215892	0	8331-1	3006322		
23575	2173	3006322	1938-07-21	1938-07-21 00:00:00	1938-07-21	5001	0	\N	0	0	\N	\N	0	144725	0	8331-1	3006322		
96064	2945	4133840	1976-12-07	1976-12-07 00:00:00	1976-12-07	5001	0	\N	0	0	\N	\N	0	196509	0	127783003	4133840		
164972	5065	4024958	1973-07-05	1973-07-05 00:00:00	1973-07-05	5001	0	\N	0	0	\N	\N	0	336731	0	117015009	4024958		
58144	5333	3006322	1962-10-27	1962-10-27 00:00:00	1962-10-27	5001	0	\N	0	0	\N	\N	0	355106	0	8331-1	3006322		
41394	3859	3011505	2013-11-09	2013-11-09 00:00:00	2013-11-09	5001	0	\N	0	0	\N	\N	0	256246	0	19926-5	3011505		
3162	96	4133840	1982-02-06	1982-02-06 00:00:00	1982-02-06	5001	0	\N	0	0	\N	\N	0	6513	0	127783003	4133840		
152590	4678	4024958	1970-08-03	1970-08-03 00:00:00	1970-08-03	5001	0	\N	0	0	\N	\N	0	311729	0	117015009	4024958		
4702	449	3015076	1984-11-21	1984-11-21 00:00:00	1984-11-21	5001	0	\N	0	0	\N	\N	0	29904	0	6248-9	3015076		
26292	2419	3006322	2003-04-03	2003-04-03 00:00:00	2003-04-03	5001	0	\N	0	0	\N	\N	0	160609	0	8331-1	3006322		
2067	188	3006322	2011-02-09	2011-02-09 00:00:00	2011-02-09	5001	0	\N	0	0	\N	\N	0	12827	0	8331-1	3006322		
8252	782	3006322	1949-07-30	1949-07-30 00:00:00	1949-07-30	5001	0	\N	0	0	\N	\N	0	52053	0	8331-1	3006322		
86916	2685	4133840	1974-01-10	1974-01-10 00:00:00	1974-01-10	5001	0	\N	0	0	\N	\N	0	177957	0	127783003	4133840		
25610	2349	3000876	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	156449	0	6082-2	3000876		
12378	1176	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	77634	0	6095-4	3036780		
38976	3604	3023430	2000-11-10	2000-11-10 00:00:00	2000-11-10	5001	0	\N	0	0	\N	\N	0	239496	0	6833-8	3023430		
37166	3422	3006322	1975-03-08	1975-03-08 00:00:00	1975-03-08	5001	0	\N	0	0	\N	\N	0	226953	0	8331-1	3006322		
31925	2914	3009542	1956-09-30	1956-09-30 00:00:00	1956-09-30	5001	0	\N	0	0	\N	\N	0	194189	0	20570-8	3009542		
105304	3241	4024958	1980-09-29	1980-09-29 00:00:00	1980-09-29	5001	0	\N	0	0	\N	\N	0	215576	0	117015009	4024958		
8822	844	3015076	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	55953	0	6248-9	3015076		
20233	1852	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	123986	0	6106-9	3014599		
133866	4121	4133840	1986-11-02	1986-11-02 00:00:00	1986-11-02	5001	0	\N	0	0	\N	\N	0	273992	0	127783003	4133840		
55114	5048	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	335441	0	6095-4	3036780		
140193	4320	4052083	2004-02-01	2004-02-01 00:00:00	2004-02-01	5001	0	\N	0	0	\N	\N	0	286682	0	23426006	4052083		
41530	3869	3006322	1934-08-18	1934-08-18 00:00:00	1934-08-18	5001	0	\N	0	0	\N	\N	0	256925	0	8331-1	3006322		
18796	1727	3013682	1982-03-24	1982-03-24 00:00:00	1982-03-24	5001	0	\N	0	0	\N	\N	0	115482	0	3094-0	3013682		
18804	1727	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	115425	0	6276-0	3027231		
7743	742	3011505	1968-11-11	1968-11-11 00:00:00	1968-11-11	5001	0	\N	0	0	\N	\N	0	49161	0	19926-5	3011505		
30277	2776	3012494	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	183776	0	6206-7	3012494		
19229	1762	3011505	2012-03-29	2012-03-29 00:00:00	2012-03-29	5001	0	\N	0	0	\N	\N	0	117811	0	19926-5	3011505		
13745	1293	3006322	1951-01-28	1951-01-28 00:00:00	1951-01-28	5001	0	\N	0	0	\N	\N	0	85544	0	8331-1	3006322		
136159	4199	4052083	1987-12-15	1987-12-15 00:00:00	1987-12-15	5001	0	\N	0	0	\N	\N	0	278615	0	23426006	4052083		
12973	1236	3049273	2001-03-04	2001-03-04 00:00:00	2001-03-04	5001	0	\N	0	0	\N	\N	0	81488	0	38265-5	3049273		
165926	5099	4052083	1949-10-01	1949-10-01 00:00:00	1949-10-01	5001	0	\N	0	0	\N	\N	0	338829	0	23426006	4052083		
3850	372	3020655	1985-05-29	1985-05-29 00:00:00	1985-05-29	5001	0	\N	0	0	\N	\N	0	24765	0	6844-5	3020655		
36689	3371	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	223568	0	6276-0	3027231		
17259	1571	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	105445	0	6085-5	3001247		
35540	3248	3006322	2017-03-08	2017-03-08 00:00:00	2017-03-08	5001	0	\N	0	0	\N	\N	0	215929	0	8331-1	3006322		
23576	2175	40769189	2009-01-31	2009-01-31 00:00:00	2009-01-31	5001	0	\N	0	0	\N	\N	0	145071	0	66529-9	40769189		
96066	2945	4133840	2000-08-15	2000-08-15 00:00:00	2000-08-15	5001	0	\N	0	0	\N	\N	0	196495	0	127783003	4133840		
164974	5065	4052083	2002-01-06	2002-01-06 00:00:00	2002-01-06	5001	0	\N	0	0	\N	\N	0	336704	0	23426006	4052083		
58147	5333	3006322	1981-02-13	1981-02-13 00:00:00	1981-02-13	5001	0	\N	0	0	\N	\N	0	355129	0	8331-1	3006322		
41395	3859	3011505	2011-10-29	2011-10-29 00:00:00	2011-10-29	5001	0	\N	0	0	\N	\N	0	256245	0	19926-5	3011505		
3164	96	4133840	1979-01-20	1979-01-20 00:00:00	1979-01-20	5001	0	\N	0	0	\N	\N	0	6481	0	127783003	4133840		
152592	4678	4052083	1974-01-06	1974-01-06 00:00:00	1974-01-06	5001	0	\N	0	0	\N	\N	0	311739	0	23426006	4052083		
4703	449	3006451	1984-11-21	1984-11-21 00:00:00	1984-11-21	5001	0	\N	0	0	\N	\N	0	29904	0	6273-7	3006451		
26293	2419	3006322	2013-02-21	2013-02-21 00:00:00	2013-02-21	5001	0	\N	0	0	\N	\N	0	160610	0	8331-1	3006322		
2068	189	3006322	2014-03-07	2014-03-07 00:00:00	2014-03-07	5001	0	\N	0	0	\N	\N	0	12898	0	8331-1	3006322		
21635	680	4024958	1983-07-06	1983-07-06 00:00:00	1983-07-06	5001	0	\N	0	0	\N	\N	0	45003	0	117015009	4024958		
86917	2685	4133840	1995-12-14	1995-12-14 00:00:00	1995-12-14	5001	0	\N	0	0	\N	\N	0	177976	0	127783003	4133840		
25611	2349	3006734	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	156449	0	6189-5	3006734		
12379	1176	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	77634	0	6082-2	3000876		
38977	3604	3036780	2000-11-10	2000-11-10 00:00:00	2000-11-10	5001	0	\N	0	0	\N	\N	0	239496	0	6095-4	3036780		
37167	3422	40769189	1993-12-24	1993-12-24 00:00:00	1993-12-24	5001	0	\N	0	0	\N	\N	0	226956	0	66529-9	40769189		
31926	2914	3000963	1956-09-30	1956-09-30 00:00:00	1956-09-30	5001	0	\N	0	0	\N	\N	0	194189	0	718-7	3000963		
105307	3241	4052083	2013-08-02	2013-08-02 00:00:00	2013-08-02	5001	0	\N	0	0	\N	\N	0	215558	0	23426006	4052083		
8823	844	3000876	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	55953	0	6082-2	3000876		
43459	4017	3006322	2009-04-20	2009-04-20 00:00:00	2009-04-20	5001	0	\N	0	0	\N	\N	0	266949	0	8331-1	3006322		
133870	4121	4024958	1923-07-15	1923-07-15 00:00:00	1923-07-15	5001	0	\N	0	0	\N	\N	0	273987	0	117015009	4024958		
55115	5048	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	335441	0	6248-9	3015076		
140204	4320	4052083	2013-05-25	2013-05-25 00:00:00	2013-05-25	5001	0	\N	0	0	\N	\N	0	286663	0	23426006	4052083		
41533	3869	3006322	1994-01-02	1994-01-02 00:00:00	1994-01-02	5001	0	\N	0	0	\N	\N	0	256932	0	8331-1	3006322		
18797	1727	3011505	2008-10-09	2008-10-09 00:00:00	2008-10-09	5001	0	\N	0	0	\N	\N	0	115499	0	19926-5	3011505		
18805	1727	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	115425	0	6158-0	3019406		
7744	742	3011505	1987-11-02	1987-11-02 00:00:00	1987-11-02	5001	0	\N	0	0	\N	\N	0	49207	0	19926-5	3011505		
30278	2776	3005136	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	183776	0	6075-6	3005136		
19230	1762	3011505	1967-03-16	1967-03-16 00:00:00	1967-03-16	5001	0	\N	0	0	\N	\N	0	117889	0	19926-5	3011505		
13746	1293	3049273	2016-09-12	2016-09-12 00:00:00	2016-09-12	5001	0	\N	0	0	\N	\N	0	85594	0	38265-5	3049273		
136164	4199	4024958	1956-02-01	1956-02-01 00:00:00	1956-02-01	5001	0	\N	0	0	\N	\N	0	278685	0	117015009	4024958		
12974	1236	3006322	2010-12-25	2010-12-25 00:00:00	2010-12-25	5001	0	\N	0	0	\N	\N	0	81366	0	8331-1	3006322		
3760	357	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	23666	0	6082-2	3000876		
3851	372	40769194	1985-05-15	1985-05-15 00:00:00	1985-05-15	5001	0	\N	0	0	\N	\N	0	24746	0	66534-9	40769194		
36690	3371	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	223568	0	6273-7	3006451		
17260	1571	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	105445	0	7258-7	3001488		
35541	3248	3006322	1964-12-09	1964-12-09 00:00:00	1964-12-09	5001	0	\N	0	0	\N	\N	0	215894	0	8331-1	3006322		
23577	2175	40769184	2009-01-31	2009-01-31 00:00:00	2009-01-31	5001	0	\N	0	0	\N	\N	0	145071	0	66524-0	40769184		
96067	2945	4133840	1970-09-22	1970-09-22 00:00:00	1970-09-22	5001	0	\N	0	0	\N	\N	0	196506	0	127783003	4133840		
16187	505	4052083	2019-02-28	2019-02-28 00:00:00	2019-02-28	5001	0	\N	0	0	\N	\N	0	33779	0	23426006	4052083		
58149	5334	3006322	1965-10-12	1965-10-12 00:00:00	1965-10-12	5001	0	\N	0	0	\N	\N	0	355229	0	8331-1	3006322		
41396	3859	3011505	2005-09-24	2005-09-24 00:00:00	2005-09-24	5001	0	\N	0	0	\N	\N	0	256159	0	19926-5	3011505		
3165	96	4133840	1954-05-29	1954-05-29 00:00:00	1954-05-29	5001	0	\N	0	0	\N	\N	0	6488	0	127783003	4133840		
152599	4678	4024958	1956-01-25	1956-01-25 00:00:00	1956-01-25	5001	0	\N	0	0	\N	\N	0	311761	0	117015009	4024958		
4704	449	3036780	1984-11-21	1984-11-21 00:00:00	1984-11-21	5001	0	\N	0	0	\N	\N	0	29904	0	6095-4	3036780		
26294	2419	3006322	1965-02-15	1965-02-15 00:00:00	1965-02-15	5001	0	\N	0	0	\N	\N	0	160570	0	8331-1	3006322		
2069	189	3006322	1977-08-28	1977-08-28 00:00:00	1977-08-28	5001	0	\N	0	0	\N	\N	0	12879	0	8331-1	3006322		
21640	680	4052083	2001-03-01	2001-03-01 00:00:00	2001-03-01	5001	0	\N	0	0	\N	\N	0	45044	0	23426006	4052083		
86921	2685	4133840	1980-01-17	1980-01-17 00:00:00	1980-01-17	5001	0	\N	0	0	\N	\N	0	177959	0	127783003	4133840		
25612	2349	3020655	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	156449	0	6844-5	3020655		
12380	1176	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	77634	0	6189-5	3006734		
38978	3604	3020655	2000-11-10	2000-11-10 00:00:00	2000-11-10	5001	0	\N	0	0	\N	\N	0	239496	0	6844-5	3020655		
37168	3422	40769194	1993-12-24	1993-12-24 00:00:00	1993-12-24	5001	0	\N	0	0	\N	\N	0	226956	0	66534-9	40769194		
31927	2914	3006322	1999-01-20	1999-01-20 00:00:00	1999-01-20	5001	0	\N	0	0	\N	\N	0	194180	0	8331-1	3006322		
105308	3241	4052083	1992-09-10	1992-09-10 00:00:00	1992-09-10	5001	0	\N	0	0	\N	\N	0	215507	0	23426006	4052083		
8824	844	3014599	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	55953	0	6106-9	3014599		
43460	4017	3006322	1942-11-10	1942-11-10 00:00:00	1942-11-10	5001	0	\N	0	0	\N	\N	0	266965	0	8331-1	3006322		
133871	4121	4133840	1966-05-08	1966-05-08 00:00:00	1966-05-08	5001	0	\N	0	0	\N	\N	0	273937	0	127783003	4133840		
55116	5048	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	335441	0	6106-9	3014599		
140211	4320	4024958	1989-08-28	1989-08-28 00:00:00	1989-08-28	5001	0	\N	0	0	\N	\N	0	286662	0	117015009	4024958		
41534	3869	3006322	1974-12-14	1974-12-14 00:00:00	1974-12-14	5001	0	\N	0	0	\N	\N	0	256940	0	8331-1	3006322		
18798	1727	3011505	2010-10-21	2010-10-21 00:00:00	2010-10-21	5001	0	\N	0	0	\N	\N	0	115500	0	19926-5	3011505		
18806	1727	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	115425	0	6273-7	3006451		
7745	742	3011505	1975-08-25	1975-08-25 00:00:00	1975-08-25	5001	0	\N	0	0	\N	\N	0	49118	0	19926-5	3011505		
30279	2776	3014599	2005-07-26	2005-07-26 00:00:00	2005-07-26	5001	0	\N	0	0	\N	\N	0	183776	0	6106-9	3014599		
19231	1762	3011505	1982-02-04	1982-02-04 00:00:00	1982-02-04	5001	0	\N	0	0	\N	\N	0	117873	0	19926-5	3011505		
13747	1293	3006322	1976-07-11	1976-07-11 00:00:00	1976-07-11	5001	0	\N	0	0	\N	\N	0	85545	0	8331-1	3006322		
136167	4199	4024958	1973-09-07	1973-09-07 00:00:00	1973-09-07	5001	0	\N	0	0	\N	\N	0	278613	0	117015009	4024958		
12975	1236	3006322	1933-12-04	1933-12-04 00:00:00	1933-12-04	5001	0	\N	0	0	\N	\N	0	81363	0	8331-1	3006322		
3761	357	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	23666	0	6246-3	3021226		
3852	372	40769179	1985-05-15	1985-05-15 00:00:00	1985-05-15	5001	0	\N	0	0	\N	\N	0	24746	0	66519-0	40769179		
36691	3371	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	223568	0	6106-9	3014599		
17261	1571	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	105445	0	6189-5	3006734		
35542	3248	3006322	1963-05-07	1963-05-07 00:00:00	1963-05-07	5001	0	\N	0	0	\N	\N	0	215845	0	8331-1	3006322		
23578	2175	40769194	2009-01-31	2009-01-31 00:00:00	2009-01-31	5001	0	\N	0	0	\N	\N	0	145071	0	66534-9	40769194		
96068	2945	4024958	1992-03-25	1992-03-25 00:00:00	1992-03-25	5001	0	\N	0	0	\N	\N	0	196542	0	117015009	4024958		
16254	505	4052083	2013-11-06	2013-11-06 00:00:00	2013-11-06	5001	0	\N	0	0	\N	\N	0	33791	0	23426006	4052083		
58150	5334	3006322	1976-10-01	1976-10-01 00:00:00	1976-10-01	5001	0	\N	0	0	\N	\N	0	355230	0	8331-1	3006322		
41397	3859	3011505	1996-08-03	1996-08-03 00:00:00	1996-08-03	5001	0	\N	0	0	\N	\N	0	256172	0	19926-5	3011505		
3167	96	4133840	1987-03-07	1987-03-07 00:00:00	1987-03-07	5001	0	\N	0	0	\N	\N	0	6527	0	127783003	4133840		
152603	4678	4024958	1963-03-02	1963-03-02 00:00:00	1963-03-02	5001	0	\N	0	0	\N	\N	0	311762	0	117015009	4024958		
4705	449	3006322	1999-12-12	1999-12-12 00:00:00	1999-12-12	5001	0	\N	0	0	\N	\N	0	29963	0	8331-1	3006322		
26295	2419	3006322	1952-05-13	1952-05-13 00:00:00	1952-05-13	5001	0	\N	0	0	\N	\N	0	160568	0	8331-1	3006322		
2070	189	3006322	2003-03-27	2003-03-27 00:00:00	2003-03-27	5001	0	\N	0	0	\N	\N	0	12881	0	8331-1	3006322		
21648	680	4024958	1986-11-30	1986-11-30 00:00:00	1986-11-30	5001	0	\N	0	0	\N	\N	0	45017	0	117015009	4024958		
86923	2685	4133840	2001-03-01	2001-03-01 00:00:00	2001-03-01	5001	0	\N	0	0	\N	\N	0	177931	0	127783003	4133840		
25613	2349	3001247	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	156449	0	6085-5	3001247		
45296	1389	4024958	1981-05-01	1981-05-01 00:00:00	1981-05-01	5001	0	\N	0	0	\N	\N	0	92152	0	117015009	4024958		
38979	3604	3001488	2000-11-10	2000-11-10 00:00:00	2000-11-10	5001	0	\N	0	0	\N	\N	0	239496	0	7258-7	3001488		
37169	3422	40769184	1993-12-24	1993-12-24 00:00:00	1993-12-24	5001	0	\N	0	0	\N	\N	0	226956	0	66524-0	40769184		
31928	2914	3006322	1992-10-09	1992-10-09 00:00:00	1992-10-09	5001	0	\N	0	0	\N	\N	0	194179	0	8331-1	3006322		
105356	3241	4052083	1966-02-04	1966-02-04 00:00:00	1966-02-04	5001	0	\N	0	0	\N	\N	0	215445	0	23426006	4052083		
8825	844	3006322	2005-05-04	2005-05-04 00:00:00	2005-05-04	5001	0	\N	0	0	\N	\N	0	55966	0	8331-1	3006322		
43463	4017	3006322	2007-04-17	2007-04-17 00:00:00	2007-04-17	5001	0	\N	0	0	\N	\N	0	266970	0	8331-1	3006322		
133872	4121	4133840	1982-10-10	1982-10-10 00:00:00	1982-10-10	5001	0	\N	0	0	\N	\N	0	273940	0	127783003	4133840		
55117	5048	3006322	1981-06-11	1981-06-11 00:00:00	1981-06-11	5001	0	\N	0	0	\N	\N	0	335461	0	8331-1	3006322		
145262	4456	4052083	2010-03-31	2010-03-31 00:00:00	2010-03-31	5001	0	\N	0	0	\N	\N	0	296579	0	23426006	4052083		
41535	3869	3006322	1977-04-17	1977-04-17 00:00:00	1977-04-17	5001	0	\N	0	0	\N	\N	0	256916	0	8331-1	3006322		
18799	1727	3011505	2015-11-18	2015-11-18 00:00:00	2015-11-18	5001	0	\N	0	0	\N	\N	0	115479	0	19926-5	3011505		
18807	1727	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	115425	0	6075-6	3005136		
7746	742	3011505	1989-04-03	1989-04-03 00:00:00	1989-04-03	5001	0	\N	0	0	\N	\N	0	49208	0	19926-5	3011505		
30280	2776	3006322	1989-04-01	1989-04-01 00:00:00	1989-04-01	5001	0	\N	0	0	\N	\N	0	183854	0	8331-1	3006322		
19232	1762	3011505	1988-02-18	1988-02-18 00:00:00	1988-02-18	5001	0	\N	0	0	\N	\N	0	117890	0	19926-5	3011505		
13748	1293	3006322	1953-04-03	1953-04-03 00:00:00	1953-04-03	5001	0	\N	0	0	\N	\N	0	85481	0	8331-1	3006322		
136169	4199	4052083	1994-05-29	1994-05-29 00:00:00	1994-05-29	5001	0	\N	0	0	\N	\N	0	278616	0	23426006	4052083		
12976	1236	3006322	1938-08-26	1938-08-26 00:00:00	1938-08-26	5001	0	\N	0	0	\N	\N	0	81444	0	8331-1	3006322		
3762	357	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	23666	0	6206-7	3012494		
3853	372	40769189	1985-05-15	1985-05-15 00:00:00	1985-05-15	5001	0	\N	0	0	\N	\N	0	24746	0	66529-9	40769189		
36692	3371	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	223568	0	6158-0	3019406		
17262	1571	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	105445	0	6844-5	3020655		
35543	3248	3006322	2007-04-03	2007-04-03 00:00:00	2007-04-03	5001	0	\N	0	0	\N	\N	0	215857	0	8331-1	3006322		
23579	2175	40769179	2009-01-31	2009-01-31 00:00:00	2009-01-31	5001	0	\N	0	0	\N	\N	0	145071	0	66519-0	40769179		
96069	2945	4133840	1998-08-04	1998-08-04 00:00:00	1998-08-04	5001	0	\N	0	0	\N	\N	0	196494	0	127783003	4133840		
62410	1915	4052083	1984-05-13	1984-05-13 00:00:00	1984-05-13	5001	0	\N	0	0	\N	\N	0	127375	0	23426006	4052083		
58151	5334	3006322	2008-11-25	2008-11-25 00:00:00	2008-11-25	5001	0	\N	0	0	\N	\N	0	355198	0	8331-1	3006322		
41398	3859	3011505	2016-04-16	2016-04-16 00:00:00	2016-04-16	5001	0	\N	0	0	\N	\N	0	256182	0	19926-5	3011505		
3171	96	4133840	1995-04-22	1995-04-22 00:00:00	1995-04-22	5001	0	\N	0	0	\N	\N	0	6529	0	127783003	4133840		
152608	4678	4024958	1973-07-29	1973-07-29 00:00:00	1973-07-29	5001	0	\N	0	0	\N	\N	0	311736	0	117015009	4024958		
4706	449	3011505	2009-07-23	2009-07-23 00:00:00	2009-07-23	5001	0	\N	0	0	\N	\N	0	29870	0	19926-5	3011505		
26296	2419	3006322	1974-09-04	1974-09-04 00:00:00	1974-09-04	5001	0	\N	0	0	\N	\N	0	160489	0	8331-1	3006322		
2071	189	3006322	1959-10-06	1959-10-06 00:00:00	1959-10-06	5001	0	\N	0	0	\N	\N	0	12861	0	8331-1	3006322		
21650	680	4024958	1991-06-20	1991-06-20 00:00:00	1991-06-20	5001	0	\N	0	0	\N	\N	0	45024	0	117015009	4024958		
86927	2685	4133840	2015-05-21	2015-05-21 00:00:00	2015-05-21	5001	0	\N	0	0	\N	\N	0	177981	0	127783003	4133840		
25614	2349	3027231	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	156449	0	6276-0	3027231		
45301	1389	4024958	1966-06-22	1966-06-22 00:00:00	1966-06-22	5001	0	\N	0	0	\N	\N	0	92149	0	117015009	4024958		
38980	3604	3006734	2000-11-10	2000-11-10 00:00:00	2000-11-10	5001	0	\N	0	0	\N	\N	0	239496	0	6189-5	3006734		
37170	3422	40769179	1993-12-24	1993-12-24 00:00:00	1993-12-24	5001	0	\N	0	0	\N	\N	0	226956	0	66519-0	40769179		
31929	2914	3006322	1960-05-10	1960-05-10 00:00:00	1960-05-10	5001	0	\N	0	0	\N	\N	0	194190	0	8331-1	3006322		
25407	793	4052083	1982-03-23	1982-03-23 00:00:00	1982-03-23	5001	0	\N	0	0	\N	\N	0	52602	0	23426006	4052083		
8826	844	3006322	2008-03-01	2008-03-01 00:00:00	2008-03-01	5001	0	\N	0	0	\N	\N	0	55874	0	8331-1	3006322		
43464	4017	3049273	1980-09-25	1980-09-25 00:00:00	1980-09-25	5001	0	\N	0	0	\N	\N	0	266987	0	38265-5	3049273		
133876	4121	4133840	1975-08-31	1975-08-31 00:00:00	1975-08-31	5001	0	\N	0	0	\N	\N	0	273990	0	127783003	4133840		
55118	5048	3006322	2003-12-24	2003-12-24 00:00:00	2003-12-24	5001	0	\N	0	0	\N	\N	0	335443	0	8331-1	3006322		
145263	4456	4052083	1969-05-13	1969-05-13 00:00:00	1969-05-13	5001	0	\N	0	0	\N	\N	0	296578	0	23426006	4052083		
41536	3869	3006322	1919-05-27	1919-05-27 00:00:00	1919-05-27	5001	0	\N	0	0	\N	\N	0	256891	0	8331-1	3006322		
18800	1727	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	115425	0	6082-2	3000876		
18808	1727	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	115425	0	6248-9	3015076		
7747	742	3011505	2014-10-20	2014-10-20 00:00:00	2014-10-20	5001	0	\N	0	0	\N	\N	0	49198	0	19926-5	3011505		
30281	2777	3006322	2017-08-31	2017-08-31 00:00:00	2017-08-31	5001	0	\N	0	0	\N	\N	0	183927	0	8331-1	3006322		
19233	1762	3011505	2017-04-27	2017-04-27 00:00:00	2017-04-27	5001	0	\N	0	0	\N	\N	0	117859	0	19926-5	3011505		
13749	1293	3006322	1991-07-26	1991-07-26 00:00:00	1991-07-26	5001	0	\N	0	0	\N	\N	0	85579	0	8331-1	3006322		
136188	4200	4024958	1995-08-13	1995-08-13 00:00:00	1995-08-13	5001	0	\N	0	0	\N	\N	0	278770	0	117015009	4024958		
72039	2204	4024958	1958-06-18	1958-06-18 00:00:00	1958-06-18	5001	0	\N	0	0	\N	\N	0	146874	0	117015009	4024958		
3763	357	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	23666	0	6158-0	3019406		
3854	372	40769184	1985-05-15	1985-05-15 00:00:00	1985-05-15	5001	0	\N	0	0	\N	\N	0	24746	0	66524-0	40769184		
36693	3371	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	223568	0	7258-7	3001488		
17263	1571	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	105445	0	6248-9	3015076		
35544	3248	3006322	1975-06-27	1975-06-27 00:00:00	1975-06-27	5001	0	\N	0	0	\N	\N	0	215895	0	8331-1	3006322		
23580	2175	40766240	1977-08-26	1977-08-26 00:00:00	1977-08-26	5001	0	\N	0	0	\N	\N	0	145043	0	63513-6	40766240		
96070	2945	4024958	1951-07-29	1951-07-29 00:00:00	1951-07-29	5001	0	\N	0	0	\N	\N	0	196479	0	117015009	4024958		
62411	1915	4052083	2006-05-20	2006-05-20 00:00:00	2006-05-20	5001	0	\N	0	0	\N	\N	0	127355	0	23426006	4052083		
58152	5335	3006322	1973-05-07	1973-05-07 00:00:00	1973-05-07	5001	0	\N	0	0	\N	\N	0	355303	0	8331-1	3006322		
41399	3859	3006322	1992-04-08	1992-04-08 00:00:00	1992-04-08	5001	0	\N	0	0	\N	\N	0	256275	0	8331-1	3006322		
3179	97	4133840	2018-08-27	2018-08-27 00:00:00	2018-08-27	5001	0	\N	0	0	\N	\N	0	6641	0	127783003	4133840		
35397	1102	4052083	1970-10-06	1970-10-06 00:00:00	1970-10-06	5001	0	\N	0	0	\N	\N	0	72365	0	23426006	4052083		
4707	449	3011505	1995-12-14	1995-12-14 00:00:00	1995-12-14	5001	0	\N	0	0	\N	\N	0	29868	0	19926-5	3011505		
26297	2419	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	160617	0	7258-7	3001488		
2072	189	3006322	1963-08-01	1963-08-01 00:00:00	1963-08-01	5001	0	\N	0	0	\N	\N	0	12878	0	8331-1	3006322		
21651	680	4052083	1986-06-18	1986-06-18 00:00:00	1986-06-18	5001	0	\N	0	0	\N	\N	0	44959	0	23426006	4052083		
86928	2685	4052083	1967-12-17	1967-12-17 00:00:00	1967-12-17	5001	0	\N	0	0	\N	\N	0	177955	0	23426006	4052083		
25615	2349	3019406	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	156449	0	6158-0	3019406		
45307	1389	4024958	1959-07-16	1959-07-16 00:00:00	1959-07-16	5001	0	\N	0	0	\N	\N	0	92179	0	117015009	4024958		
38981	3604	3021226	2000-11-10	2000-11-10 00:00:00	2000-11-10	5001	0	\N	0	0	\N	\N	0	239496	0	6246-3	3021226		
37171	3422	3006322	2003-02-24	2003-02-24 00:00:00	2003-02-24	5001	0	\N	0	0	\N	\N	0	226987	0	8331-1	3006322		
31930	2914	3006322	1991-01-07	1991-01-07 00:00:00	1991-01-07	5001	0	\N	0	0	\N	\N	0	194213	0	8331-1	3006322		
25410	793	4052083	2017-11-18	2017-11-18 00:00:00	2017-11-18	5001	0	\N	0	0	\N	\N	0	52618	0	23426006	4052083		
8827	844	3014599	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	55919	0	6106-9	3014599		
43466	4017	3006322	1939-03-18	1939-03-18 00:00:00	1939-03-18	5001	0	\N	0	0	\N	\N	0	266964	0	8331-1	3006322		
36836	3382	3006322	2014-07-10	2014-07-10 00:00:00	2014-07-10	5001	0	\N	0	0	\N	\N	0	224447	0	8331-1	3006322		
55119	5048	3049273	2016-05-23	2016-05-23 00:00:00	2016-05-23	5001	0	\N	0	0	\N	\N	0	335506	0	38265-5	3049273		
145277	4457	4024958	1985-06-01	1985-06-01 00:00:00	1985-06-01	5001	0	\N	0	0	\N	\N	0	296661	0	117015009	4024958		
41537	3869	3006322	1944-08-09	1944-08-09 00:00:00	1944-08-09	5001	0	\N	0	0	\N	\N	0	256928	0	8331-1	3006322		
18801	1727	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	115425	0	6844-5	3020655		
18809	1727	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	115425	0	6206-7	3012494		
7748	742	3011505	1992-04-20	1992-04-20 00:00:00	1992-04-20	5001	0	\N	0	0	\N	\N	0	49117	0	19926-5	3011505		
30282	2778	3006322	2017-09-07	2017-09-07 00:00:00	2017-09-07	5001	0	\N	0	0	\N	\N	0	183997	0	8331-1	3006322		
19234	1762	3011505	2019-05-09	2019-05-09 00:00:00	2019-05-09	5001	0	\N	0	0	\N	\N	0	117860	0	19926-5	3011505		
13750	1294	3006322	1984-11-19	1984-11-19 00:00:00	1984-11-19	5001	0	\N	0	0	\N	\N	0	85614	0	8331-1	3006322		
25061	2300	3011505	2008-02-07	2008-02-07 00:00:00	2008-02-07	5001	0	\N	0	0	\N	\N	0	153163	0	19926-5	3011505		
72040	2204	4024958	1949-09-25	1949-09-25 00:00:00	1949-09-25	5001	0	\N	0	0	\N	\N	0	146929	0	117015009	4024958		
3764	357	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	23666	0	6248-9	3015076		
3855	372	3049273	2017-11-27	2017-11-27 00:00:00	2017-11-27	5001	0	\N	0	0	\N	\N	0	24790	0	38265-5	3049273		
36694	3371	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	223568	0	6075-6	3005136		
17264	1571	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	105445	0	6206-7	3012494		
35545	3248	3006322	1959-04-19	1959-04-19 00:00:00	1959-04-19	5001	0	\N	0	0	\N	\N	0	215852	0	8331-1	3006322		
23581	2175	40758406	1977-08-26	1977-08-26 00:00:00	1977-08-26	5001	0	\N	0	0	\N	\N	0	145043	0	55277-8	40758406		
153554	4712	4024958	1973-06-23	1973-06-23 00:00:00	1973-06-23	5001	0	\N	0	0	\N	\N	0	313782	0	117015009	4024958		
62416	1915	4052083	1987-06-06	1987-06-06 00:00:00	1987-06-06	5001	0	\N	0	0	\N	\N	0	127378	0	23426006	4052083		
58153	5335	3006322	1984-03-23	1984-03-23 00:00:00	1984-03-23	5001	0	\N	0	0	\N	\N	0	355261	0	8331-1	3006322		
41400	3859	3011505	1989-09-23	1989-09-23 00:00:00	1989-09-23	5001	0	\N	0	0	\N	\N	0	256170	0	19926-5	3011505		
3182	97	4133840	2016-08-15	2016-08-15 00:00:00	2016-08-15	5001	0	\N	0	0	\N	\N	0	6633	0	127783003	4133840		
35402	1102	4024958	2014-10-17	2014-10-17 00:00:00	2014-10-17	5001	0	\N	0	0	\N	\N	0	72409	0	117015009	4024958		
4708	449	3011505	1992-12-10	1992-12-10 00:00:00	1992-12-10	5001	0	\N	0	0	\N	\N	0	29867	0	19926-5	3011505		
26298	2419	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	160617	0	6189-5	3006734		
83962	2596	4024958	1990-04-12	1990-04-12 00:00:00	1990-04-12	5001	0	\N	0	0	\N	\N	0	171777	0	117015009	4024958		
21655	680	4024958	1995-02-26	1995-02-26 00:00:00	1995-02-26	5001	0	\N	0	0	\N	\N	0	45009	0	117015009	4024958		
86930	2685	4133840	2000-02-24	2000-02-24 00:00:00	2000-02-24	5001	0	\N	0	0	\N	\N	0	177977	0	127783003	4133840		
25616	2349	3005136	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	156449	0	6075-6	3005136		
45312	1389	4024958	1995-02-01	1995-02-01 00:00:00	1995-02-01	5001	0	\N	0	0	\N	\N	0	92219	0	117015009	4024958		
38982	3604	3005136	2000-11-10	2000-11-10 00:00:00	2000-11-10	5001	0	\N	0	0	\N	\N	0	239496	0	6075-6	3005136		
37172	3422	40758406	1968-01-18	1968-01-18 00:00:00	1968-01-18	5001	0	\N	0	0	\N	\N	0	226952	0	55277-8	40758406		
31931	2914	3006322	2019-04-19	2019-04-19 00:00:00	2019-04-19	5001	0	\N	0	0	\N	\N	0	194181	0	8331-1	3006322		
25417	793	4024958	1980-04-15	1980-04-15 00:00:00	1980-04-15	5001	0	\N	0	0	\N	\N	0	52615	0	117015009	4024958		
8828	844	3006734	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	55919	0	6189-5	3006734		
43468	4017	3006322	2014-02-01	2014-02-01 00:00:00	2014-02-01	5001	0	\N	0	0	\N	\N	0	266950	0	8331-1	3006322		
36837	3382	3006322	1990-01-19	1990-01-19 00:00:00	1990-01-19	5001	0	\N	0	0	\N	\N	0	224415	0	8331-1	3006322		
55120	5048	3006322	1970-06-27	1970-06-27 00:00:00	1970-06-27	5001	0	\N	0	0	\N	\N	0	335403	0	8331-1	3006322		
145286	4457	4024958	1991-09-10	1991-09-10 00:00:00	1991-09-10	5001	0	\N	0	0	\N	\N	0	296662	0	117015009	4024958		
41542	3871	3006322	1966-05-25	1966-05-25 00:00:00	1966-05-25	5001	0	\N	0	0	\N	\N	0	257007	0	8331-1	3006322		
102620	3157	4024958	1972-01-13	1972-01-13 00:00:00	1972-01-13	5001	0	\N	0	0	\N	\N	0	209865	0	117015009	4024958		
18810	1727	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	115425	0	6085-5	3001247		
7749	742	3011505	1966-10-24	1966-10-24 00:00:00	1966-10-24	5001	0	\N	0	0	\N	\N	0	49169	0	19926-5	3011505		
30283	2778	3006322	1977-07-23	1977-07-23 00:00:00	1977-07-23	5001	0	\N	0	0	\N	\N	0	184027	0	8331-1	3006322		
19235	1762	3011505	1995-03-23	1995-03-23 00:00:00	1995-03-23	5001	0	\N	0	0	\N	\N	0	117844	0	19926-5	3011505		
13751	1294	3006322	1999-03-17	1999-03-17 00:00:00	1999-03-17	5001	0	\N	0	0	\N	\N	0	85624	0	8331-1	3006322		
25062	2300	3006322	1975-04-26	1975-04-26 00:00:00	1975-04-26	5001	0	\N	0	0	\N	\N	0	153183	0	8331-1	3006322		
72041	2204	4024958	1967-06-22	1967-06-22 00:00:00	1967-06-22	5001	0	\N	0	0	\N	\N	0	146904	0	117015009	4024958		
3765	357	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	23666	0	6273-7	3006451		
3856	372	3006322	1966-08-18	1966-08-18 00:00:00	1966-08-18	5001	0	\N	0	0	\N	\N	0	24753	0	8331-1	3006322		
36695	3371	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	223568	0	6246-3	3021226		
17265	1571	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	105445	0	6082-2	3000876		
35546	3248	3006322	2002-07-13	2002-07-13 00:00:00	2002-07-13	5001	0	\N	0	0	\N	\N	0	215856	0	8331-1	3006322		
23582	2175	46235214	1977-08-26	1977-08-26 00:00:00	1977-08-26	5001	0	\N	0	0	\N	\N	0	145043	0	76690-7	46235214		
153568	4713	4024958	1969-11-19	1969-11-19 00:00:00	1969-11-19	5001	0	\N	0	0	\N	\N	0	313826	0	117015009	4024958		
62427	1915	4024958	2011-12-18	2011-12-18 00:00:00	2011-12-18	5001	0	\N	0	0	\N	\N	0	127381	0	117015009	4024958		
58154	5335	3006322	2001-07-01	2001-07-01 00:00:00	2001-07-01	5001	0	\N	0	0	\N	\N	0	355262	0	8331-1	3006322		
41401	3859	3006322	1931-06-03	1931-06-03 00:00:00	1931-06-03	5001	0	\N	0	0	\N	\N	0	256157	0	8331-1	3006322		
3183	97	4133840	2012-07-23	2012-07-23 00:00:00	2012-07-23	5001	0	\N	0	0	\N	\N	0	6631	0	127783003	4133840		
46723	1428	4052083	1962-12-07	1962-12-07 00:00:00	1962-12-07	5001	0	\N	0	0	\N	\N	0	95010	0	23426006	4052083		
4709	449	3011505	2014-08-21	2014-08-21 00:00:00	2014-08-21	5001	0	\N	0	0	\N	\N	0	29983	0	19926-5	3011505		
26299	2419	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	160617	0	6833-8	3023430		
83968	2596	4052083	1985-06-18	1985-06-18 00:00:00	1985-06-18	5001	0	\N	0	0	\N	\N	0	171770	0	23426006	4052083		
32946	1025	4024958	1968-05-30	1968-05-30 00:00:00	1968-05-30	5001	0	\N	0	0	\N	\N	0	67542	0	117015009	4024958		
86932	2685	4052083	1982-12-14	1982-12-14 00:00:00	1982-12-14	5001	0	\N	0	0	\N	\N	0	177936	0	23426006	4052083		
25617	2349	3015076	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	156449	0	6248-9	3015076		
114327	3527	4024958	2012-08-05	2012-08-05 00:00:00	2012-08-05	5001	0	\N	0	0	\N	\N	0	234036	0	117015009	4024958		
38983	3604	3012494	2000-11-10	2000-11-10 00:00:00	2000-11-10	5001	0	\N	0	0	\N	\N	0	239496	0	6206-7	3012494		
37173	3422	40766240	1968-01-18	1968-01-18 00:00:00	1968-01-18	5001	0	\N	0	0	\N	\N	0	226952	0	63513-6	40766240		
31933	2915	3051031	2011-08-19	2011-08-19 00:00:00	2011-08-19	5001	0	\N	0	0	\N	\N	0	194276	0	46240-8	3051031		
36696	1138	4024958	1994-04-04	1994-04-04 00:00:00	1994-04-04	5001	0	\N	0	0	\N	\N	0	75068	0	117015009	4024958		
8829	844	3021226	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	55919	0	6246-3	3021226		
43469	4018	3006322	1980-12-27	1980-12-27 00:00:00	1980-12-27	5001	0	\N	0	0	\N	\N	0	267104	0	8331-1	3006322		
36838	3382	3006322	1967-06-20	1967-06-20 00:00:00	1967-06-20	5001	0	\N	0	0	\N	\N	0	224462	0	8331-1	3006322		
55121	5048	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	335420	0	6095-4	3036780		
145299	4459	4024958	1964-01-21	1964-01-21 00:00:00	1964-01-21	5001	0	\N	0	0	\N	\N	0	296710	0	117015009	4024958		
41543	3871	3006322	1983-11-04	1983-11-04 00:00:00	1983-11-04	5001	0	\N	0	0	\N	\N	0	257059	0	8331-1	3006322		
102641	3157	4024958	1965-01-13	1965-01-13 00:00:00	1965-01-13	5001	0	\N	0	0	\N	\N	0	209813	0	117015009	4024958		
18811	1727	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	115425	0	7258-7	3001488		
7750	742	3011505	1998-05-25	1998-05-25 00:00:00	1998-05-25	5001	0	\N	0	0	\N	\N	0	49111	0	19926-5	3011505		
30284	2778	3006322	1998-03-29	1998-03-29 00:00:00	1998-03-29	5001	0	\N	0	0	\N	\N	0	184079	0	8331-1	3006322		
19236	1762	3006322	1967-08-25	1967-08-25 00:00:00	1967-08-25	5001	0	\N	0	0	\N	\N	0	117846	0	8331-1	3006322		
13752	1294	3006322	2014-07-12	2014-07-12 00:00:00	2014-07-12	5001	0	\N	0	0	\N	\N	0	85615	0	8331-1	3006322		
25063	2300	3006322	1966-03-29	1966-03-29 00:00:00	1966-03-29	5001	0	\N	0	0	\N	\N	0	153204	0	8331-1	3006322		
72074	2206	4052083	2006-08-25	2006-08-25 00:00:00	2006-08-25	5001	0	\N	0	0	\N	\N	0	147024	0	23426006	4052083		
3766	357	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	23666	0	6189-5	3006734		
3857	372	3006322	1969-07-18	1969-07-18 00:00:00	1969-07-18	5001	0	\N	0	0	\N	\N	0	24713	0	8331-1	3006322		
47974	4392	3006322	1991-06-15	1991-06-15 00:00:00	1991-06-15	5001	0	\N	0	0	\N	\N	0	292069	0	8331-1	3006322		
17266	1571	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	105445	0	6833-8	3023430		
35547	3248	3006322	1958-09-07	1958-09-07 00:00:00	1958-09-07	5001	0	\N	0	0	\N	\N	0	215844	0	8331-1	3006322		
23584	2175	3051031	1977-08-26	1977-08-26 00:00:00	1977-08-26	5001	0	\N	0	0	\N	\N	0	145043	0	46240-8	3051031		
4824	148	4052083	2008-09-09	2008-09-09 00:00:00	2008-09-09	5001	0	\N	0	0	\N	\N	0	10019	0	23426006	4052083		
62444	1916	4024958	2007-04-30	2007-04-30 00:00:00	2007-04-30	5001	0	\N	0	0	\N	\N	0	127498	0	117015009	4024958		
58158	5337	3019406	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	355395	0	6158-0	3019406		
41402	3859	3011505	2001-09-01	2001-09-01 00:00:00	2001-09-01	5001	0	\N	0	0	\N	\N	0	256155	0	19926-5	3011505		
3185	97	4133840	2008-06-30	2008-06-30 00:00:00	2008-06-30	5001	0	\N	0	0	\N	\N	0	6604	0	127783003	4133840		
46729	1428	4052083	1954-02-03	1954-02-03 00:00:00	1954-02-03	5001	0	\N	0	0	\N	\N	0	95009	0	23426006	4052083		
4710	449	3011505	2005-07-14	2005-07-14 00:00:00	2005-07-14	5001	0	\N	0	0	\N	\N	0	29889	0	19926-5	3011505		
26300	2419	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	160617	0	6273-7	3006451		
83982	2596	4052083	2018-11-09	2018-11-09 00:00:00	2018-11-09	5001	0	\N	0	0	\N	\N	0	171747	0	23426006	4052083		
124782	3856	4024958	1977-04-27	1977-04-27 00:00:00	1977-04-27	5001	0	\N	0	0	\N	\N	0	255919	0	117015009	4024958		
86934	2685	4133840	2005-03-24	2005-03-24 00:00:00	2005-03-24	5001	0	\N	0	0	\N	\N	0	177933	0	127783003	4133840		
25618	2349	3012494	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	156449	0	6206-7	3012494		
114339	3527	4024958	1962-11-08	1962-11-08 00:00:00	1962-11-08	5001	0	\N	0	0	\N	\N	0	234087	0	117015009	4024958		
119316	3676	4052083	1997-03-31	1997-03-31 00:00:00	1997-03-31	5001	0	\N	0	0	\N	\N	0	244550	0	23426006	4052083		
37176	3422	3051031	1968-01-18	1968-01-18 00:00:00	1968-01-18	5001	0	\N	0	0	\N	\N	0	226952	0	46240-8	3051031		
31935	2915	40758406	2011-08-19	2011-08-19 00:00:00	2011-08-19	5001	0	\N	0	0	\N	\N	0	194276	0	55277-8	40758406		
23986	2204	3006322	1987-11-19	1987-11-19 00:00:00	1987-11-19	5001	0	\N	0	0	\N	\N	0	146936	0	8331-1	3006322		
8830	844	3027231	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	55919	0	6276-0	3027231		
43470	4018	3006322	2017-12-09	2017-12-09 00:00:00	2017-12-09	5001	0	\N	0	0	\N	\N	0	267066	0	8331-1	3006322		
36839	3382	3006322	1979-04-08	1979-04-08 00:00:00	1979-04-08	5001	0	\N	0	0	\N	\N	0	224414	0	8331-1	3006322		
55122	5048	3006451	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	335420	0	6273-7	3006451		
145305	4459	4052083	1966-09-07	1966-09-07 00:00:00	1966-09-07	5001	0	\N	0	0	\N	\N	0	296727	0	23426006	4052083		
20137	1844	40758406	1986-04-30	1986-04-30 00:00:00	1986-04-30	5001	0	\N	0	0	\N	\N	0	123162	0	55277-8	40758406		
102642	3157	4024958	1957-03-11	1957-03-11 00:00:00	1957-03-11	5001	0	\N	0	0	\N	\N	0	209812	0	117015009	4024958		
18812	1727	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	115425	0	6095-4	3036780		
7751	742	3011505	1984-10-15	1984-10-15 00:00:00	1984-10-15	5001	0	\N	0	0	\N	\N	0	49114	0	19926-5	3011505		
30285	2778	3014599	1978-02-02	1978-02-02 00:00:00	1978-02-02	5001	0	\N	0	0	\N	\N	0	183994	0	6106-9	3014599		
19237	1762	3011505	2005-02-17	2005-02-17 00:00:00	2005-02-17	5001	0	\N	0	0	\N	\N	0	117829	0	19926-5	3011505		
13756	1297	3006322	2002-02-09	2002-02-09 00:00:00	2002-02-09	5001	0	\N	0	0	\N	\N	0	85719	0	8331-1	3006322		
25064	2300	3011505	1986-11-27	1986-11-27 00:00:00	1986-11-27	5001	0	\N	0	0	\N	\N	0	153195	0	19926-5	3011505		
72078	2206	4052083	1987-11-10	1987-11-10 00:00:00	1987-11-10	5001	0	\N	0	0	\N	\N	0	147051	0	23426006	4052083		
3767	357	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	23666	0	6075-6	3005136		
3858	374	3006322	1986-01-06	1986-01-06 00:00:00	1986-01-06	5001	0	\N	0	0	\N	\N	0	24811	0	8331-1	3006322		
47975	4392	3006322	1991-05-06	1991-05-06 00:00:00	1991-05-06	5001	0	\N	0	0	\N	\N	0	292059	0	8331-1	3006322		
17267	1571	3006322	1973-08-22	1973-08-22 00:00:00	1973-08-22	5001	0	\N	0	0	\N	\N	0	105428	0	8331-1	3006322		
35548	3249	3006322	2012-12-22	2012-12-22 00:00:00	2012-12-22	5001	0	\N	0	0	\N	\N	0	215951	0	8331-1	3006322		
23586	2175	3006322	2000-11-02	2000-11-02 00:00:00	2000-11-02	5001	0	\N	0	0	\N	\N	0	145005	0	8331-1	3006322		
16117	502	4052083	2017-06-20	2017-06-20 00:00:00	2017-06-20	5001	0	\N	0	0	\N	\N	0	33613	0	23426006	4052083		
62447	1916	4052083	2001-09-09	2001-09-09 00:00:00	2001-09-09	5001	0	\N	0	0	\N	\N	0	127434	0	23426006	4052083		
58159	5337	3005136	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	355395	0	6075-6	3005136		
41403	3859	3011505	1999-08-21	1999-08-21 00:00:00	1999-08-21	5001	0	\N	0	0	\N	\N	0	256154	0	19926-5	3011505		
3186	97	4024958	1948-07-17	1948-07-17 00:00:00	1948-07-17	5001	0	\N	0	0	\N	\N	0	6663	0	117015009	4024958		
46733	1428	4052083	1998-09-18	1998-09-18 00:00:00	1998-09-18	5001	0	\N	0	0	\N	\N	0	94995	0	23426006	4052083		
4711	449	3011505	2010-07-29	2010-07-29 00:00:00	2010-07-29	5001	0	\N	0	0	\N	\N	0	29890	0	19926-5	3011505		
26301	2419	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	160617	0	6206-7	3012494		
83991	2597	4052083	2008-10-05	2008-10-05 00:00:00	2008-10-05	5001	0	\N	0	0	\N	\N	0	171848	0	23426006	4052083		
124791	3856	4024958	1989-06-02	1989-06-02 00:00:00	1989-06-02	5001	0	\N	0	0	\N	\N	0	255891	0	117015009	4024958		
86937	2685	4133840	2003-03-13	2003-03-13 00:00:00	2003-03-13	5001	0	\N	0	0	\N	\N	0	177932	0	127783003	4133840		
25619	2349	3021226	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	156449	0	6246-3	3021226		
114365	3527	4052083	1969-06-03	1969-06-03 00:00:00	1969-06-03	5001	0	\N	0	0	\N	\N	0	234019	0	23426006	4052083		
119334	3678	4052083	1985-09-23	1985-09-23 00:00:00	1985-09-23	5001	0	\N	0	0	\N	\N	0	244580	0	23426006	4052083		
37177	3422	46235214	1968-01-18	1968-01-18 00:00:00	1968-01-18	5001	0	\N	0	0	\N	\N	0	226952	0	76690-7	46235214		
20756	1911	46235214	1947-02-24	1947-02-24 00:00:00	1947-02-24	5001	0	\N	0	0	\N	\N	0	127115	0	76690-7	46235214		
35264	3221	3006322	2012-02-27	2012-02-27 00:00:00	2012-02-27	5001	0	\N	0	0	\N	\N	0	214088	0	8331-1	3006322		
8831	844	3015076	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	55919	0	6248-9	3015076		
43471	4018	3006322	1987-06-09	1987-06-09 00:00:00	1987-06-09	5001	0	\N	0	0	\N	\N	0	267065	0	8331-1	3006322		
36840	3382	3006322	1969-10-03	1969-10-03 00:00:00	1969-10-03	5001	0	\N	0	0	\N	\N	0	224436	0	8331-1	3006322		
55123	5048	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	335420	0	6248-9	3015076		
145306	4459	4052083	1968-12-03	1968-12-03 00:00:00	1968-12-03	5001	0	\N	0	0	\N	\N	0	296728	0	23426006	4052083		
20138	1844	46235214	1986-04-30	1986-04-30 00:00:00	1986-04-30	5001	0	\N	0	0	\N	\N	0	123162	0	76690-7	46235214		
102643	3157	4052083	1984-06-17	1984-06-17 00:00:00	1984-06-17	5001	0	\N	0	0	\N	\N	0	209845	0	23426006	4052083		
18813	1727	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	115425	0	6189-5	3006734		
7752	742	3006322	1989-03-23	1989-03-23 00:00:00	1989-03-23	5001	0	\N	0	0	\N	\N	0	49219	0	8331-1	3006322		
30286	2778	3006734	1978-02-02	1978-02-02 00:00:00	1978-02-02	5001	0	\N	0	0	\N	\N	0	183994	0	6189-5	3006734		
19238	1762	3011505	1978-10-05	1978-10-05 00:00:00	1978-10-05	5001	0	\N	0	0	\N	\N	0	117840	0	19926-5	3011505		
125597	3874	4052083	2012-06-15	2012-06-15 00:00:00	2012-06-15	5001	0	\N	0	0	\N	\N	0	257271	0	23426006	4052083		
25065	2300	3011505	2002-01-03	2002-01-03 00:00:00	2002-01-03	5001	0	\N	0	0	\N	\N	0	153150	0	19926-5	3011505		
72082	2206	4024958	1984-09-29	1984-09-29 00:00:00	1984-09-29	5001	0	\N	0	0	\N	\N	0	147050	0	117015009	4024958		
3768	357	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	23666	0	6095-4	3036780		
3859	374	3006322	2002-07-24	2002-07-24 00:00:00	2002-07-24	5001	0	\N	0	0	\N	\N	0	24839	0	8331-1	3006322		
47976	4393	3006322	1987-10-02	1987-10-02 00:00:00	1987-10-02	5001	0	\N	0	0	\N	\N	0	292103	0	8331-1	3006322		
17268	1571	3006322	2007-05-05	2007-05-05 00:00:00	2007-05-05	5001	0	\N	0	0	\N	\N	0	105463	0	8331-1	3006322		
35549	3249	3006322	1983-02-22	1983-02-22 00:00:00	1983-02-22	5001	0	\N	0	0	\N	\N	0	215948	0	8331-1	3006322		
23587	2175	3006322	2016-02-23	2016-02-23 00:00:00	2016-02-23	5001	0	\N	0	0	\N	\N	0	145022	0	8331-1	3006322		
127298	3916	4024958	1979-09-03	1979-09-03 00:00:00	1979-09-03	5001	0	\N	0	0	\N	\N	0	260251	0	117015009	4024958		
62456	1916	4052083	1987-07-24	1987-07-24 00:00:00	1987-07-24	5001	0	\N	0	0	\N	\N	0	127476	0	23426006	4052083		
58160	5337	3021226	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	355395	0	6246-3	3021226		
41404	3859	3051031	1989-08-25	1989-08-25 00:00:00	1989-08-25	5001	0	\N	0	0	\N	\N	0	256271	0	46240-8	3051031		
3189	97	4133840	2010-07-12	2010-07-12 00:00:00	2010-07-12	5001	0	\N	0	0	\N	\N	0	6630	0	127783003	4133840		
46741	1428	4024958	1983-03-16	1983-03-16 00:00:00	1983-03-16	5001	0	\N	0	0	\N	\N	0	95027	0	117015009	4024958		
4712	449	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	29911	0	6085-5	3001247		
26302	2419	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	160617	0	6246-3	3021226		
83993	2597	4052083	2001-06-05	2001-06-05 00:00:00	2001-06-05	5001	0	\N	0	0	\N	\N	0	171839	0	23426006	4052083		
124798	3856	4024958	1986-08-08	1986-08-08 00:00:00	1986-08-08	5001	0	\N	0	0	\N	\N	0	255922	0	117015009	4024958		
86938	2685	4133840	2002-03-07	2002-03-07 00:00:00	2002-03-07	5001	0	\N	0	0	\N	\N	0	177978	0	127783003	4133840		
25620	2349	3036780	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	156449	0	6095-4	3036780		
125660	3876	4024958	1982-04-28	1982-04-28 00:00:00	1982-04-28	5001	0	\N	0	0	\N	\N	0	257502	0	117015009	4024958		
119338	3678	4024958	2004-04-08	2004-04-08 00:00:00	2004-04-08	5001	0	\N	0	0	\N	\N	0	244583	0	117015009	4024958		
37178	3422	46235214	1983-07-13	1983-07-13 00:00:00	1983-07-13	5001	0	\N	0	0	\N	\N	0	226955	0	76690-7	46235214		
20758	1911	40766240	1947-02-24	1947-02-24 00:00:00	1947-02-24	5001	0	\N	0	0	\N	\N	0	127115	0	63513-6	40766240		
35265	3221	3006322	1975-12-09	1975-12-09 00:00:00	1975-12-09	5001	0	\N	0	0	\N	\N	0	214087	0	8331-1	3006322		
8832	844	3001488	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	55919	0	7258-7	3001488		
43472	4019	3006322	2012-02-22	2012-02-22 00:00:00	2012-02-22	5001	0	\N	0	0	\N	\N	0	267152	0	8331-1	3006322		
36841	3382	3006322	1975-08-13	1975-08-13 00:00:00	1975-08-13	5001	0	\N	0	0	\N	\N	0	224437	0	8331-1	3006322		
55124	5048	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	335420	0	6106-9	3014599		
8037	260	4024958	1991-01-31	1991-01-31 00:00:00	1991-01-31	5001	0	\N	0	0	\N	\N	0	17228	0	117015009	4024958		
20139	1844	40766240	1986-04-30	1986-04-30 00:00:00	1986-04-30	5001	0	\N	0	0	\N	\N	0	123162	0	63513-6	40766240		
102652	3157	4024958	1970-06-07	1970-06-07 00:00:00	1970-06-07	5001	0	\N	0	0	\N	\N	0	209892	0	117015009	4024958		
18814	1727	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	115425	0	6833-8	3023430		
7753	743	3006322	1986-08-07	1986-08-07 00:00:00	1986-08-07	5001	0	\N	0	0	\N	\N	0	49276	0	8331-1	3006322		
30287	2778	3021226	1978-02-02	1978-02-02 00:00:00	1978-02-02	5001	0	\N	0	0	\N	\N	0	183994	0	6246-3	3021226		
19240	1764	3006322	2002-06-08	2002-06-08 00:00:00	2002-06-08	5001	0	\N	0	0	\N	\N	0	117941	0	8331-1	3006322		
125599	3874	4024958	2016-06-09	2016-06-09 00:00:00	2016-06-09	5001	0	\N	0	0	\N	\N	0	257288	0	117015009	4024958		
25066	2300	3011505	1993-12-09	1993-12-09 00:00:00	1993-12-09	5001	0	\N	0	0	\N	\N	0	153160	0	19926-5	3011505		
72090	2206	4052083	2017-09-09	2017-09-09 00:00:00	2017-09-09	5001	0	\N	0	0	\N	\N	0	146992	0	23426006	4052083		
3769	357	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	23666	0	6106-9	3014599		
3860	374	3006322	2015-10-17	2015-10-17 00:00:00	2015-10-17	5001	0	\N	0	0	\N	\N	0	24843	0	8331-1	3006322		
47977	4393	3006322	1990-12-30	1990-12-30 00:00:00	1990-12-30	5001	0	\N	0	0	\N	\N	0	292116	0	8331-1	3006322		
17269	1571	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	105461	0	6095-4	3036780		
35550	3249	3006322	2000-06-19	2000-06-19 00:00:00	2000-06-19	5001	0	\N	0	0	\N	\N	0	216013	0	8331-1	3006322		
23589	2175	3051031	1977-05-28	1977-05-28 00:00:00	1977-05-28	5001	0	\N	0	0	\N	\N	0	145042	0	46240-8	3051031		
127330	3916	4024958	1979-11-18	1979-11-18 00:00:00	1979-11-18	5001	0	\N	0	0	\N	\N	0	260279	0	117015009	4024958		
3602	343	3006734	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	22870	0	6189-5	3006734		
58161	5337	3012494	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	355395	0	6206-7	3012494		
41405	3859	40766240	1989-08-25	1989-08-25 00:00:00	1989-08-25	5001	0	\N	0	0	\N	\N	0	256271	0	63513-6	40766240		
3190	97	4133840	1995-07-31	1995-07-31 00:00:00	1995-07-31	5001	0	\N	0	0	\N	\N	0	6635	0	127783003	4133840		
79861	2458	4024958	1972-09-11	1972-09-11 00:00:00	1972-09-11	5001	0	\N	0	0	\N	\N	0	162957	0	117015009	4024958		
4713	449	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	29911	0	7258-7	3001488		
26303	2419	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	160617	0	6075-6	3005136		
83997	2597	4024958	2003-09-10	2003-09-10 00:00:00	2003-09-10	5001	0	\N	0	0	\N	\N	0	171834	0	117015009	4024958		
124804	3857	4133840	2014-10-07	2014-10-07 00:00:00	2014-10-07	5001	0	\N	0	0	\N	\N	0	255998	0	127783003	4133840		
86942	2685	4133840	1993-12-02	1993-12-02 00:00:00	1993-12-02	5001	0	\N	0	0	\N	\N	0	177975	0	127783003	4133840		
25621	2349	3006322	1981-06-08	1981-06-08 00:00:00	1981-06-08	5001	0	\N	0	0	\N	\N	0	156439	0	8331-1	3006322		
119273	3675	4052083	1970-03-03	1970-03-03 00:00:00	1970-03-03	5001	0	\N	0	0	\N	\N	0	244431	0	23426006	4052083		
119341	3678	4052083	2008-10-01	2008-10-01 00:00:00	2008-10-01	5001	0	\N	0	0	\N	\N	0	244595	0	23426006	4052083		
37179	3422	3051031	1983-07-13	1983-07-13 00:00:00	1983-07-13	5001	0	\N	0	0	\N	\N	0	226955	0	46240-8	3051031		
20759	1911	3011505	2004-10-11	2004-10-11 00:00:00	2004-10-11	5001	0	\N	0	0	\N	\N	0	127196	0	19926-5	3011505		
35266	3222	3006322	2015-09-06	2015-09-06 00:00:00	2015-09-06	5001	0	\N	0	0	\N	\N	0	214141	0	8331-1	3006322		
8833	844	3020655	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	55919	0	6844-5	3020655		
43473	4019	3006322	1973-07-15	1973-07-15 00:00:00	1973-07-15	5001	0	\N	0	0	\N	\N	0	267120	0	8331-1	3006322		
36842	3382	3006322	2013-05-02	2013-05-02 00:00:00	2013-05-02	5001	0	\N	0	0	\N	\N	0	224446	0	8331-1	3006322		
55125	5048	3001488	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	335420	0	7258-7	3001488		
129422	3986	4052083	1992-06-18	1992-06-18 00:00:00	1992-06-18	5001	0	\N	0	0	\N	\N	0	264983	0	23426006	4052083		
20141	1844	3051031	1989-06-23	1989-06-23 00:00:00	1989-06-23	5001	0	\N	0	0	\N	\N	0	123173	0	46240-8	3051031		
9537	902	3006322	1955-03-06	1955-03-06 00:00:00	1955-03-06	5001	0	\N	0	0	\N	\N	0	60012	0	8331-1	3006322		
18815	1727	3011505	2003-04-24	2003-04-24 00:00:00	2003-04-24	5001	0	\N	0	0	\N	\N	0	115476	0	19926-5	3011505		
7754	743	3006322	2015-03-01	2015-03-01 00:00:00	2015-03-01	5001	0	\N	0	0	\N	\N	0	49280	0	8331-1	3006322		
30288	2778	3027231	1978-02-02	1978-02-02 00:00:00	1978-02-02	5001	0	\N	0	0	\N	\N	0	183994	0	6276-0	3027231		
19241	1764	3006322	1994-08-04	1994-08-04 00:00:00	1994-08-04	5001	0	\N	0	0	\N	\N	0	117997	0	8331-1	3006322		
125634	3875	4052083	1963-06-26	1963-06-26 00:00:00	1963-06-26	5001	0	\N	0	0	\N	\N	0	257393	0	23426006	4052083		
25067	2300	3011505	2015-03-19	2015-03-19 00:00:00	2015-03-19	5001	0	\N	0	0	\N	\N	0	153154	0	19926-5	3011505		
72093	2206	4024958	1990-02-14	1990-02-14 00:00:00	1990-02-14	5001	0	\N	0	0	\N	\N	0	147052	0	117015009	4024958		
3770	357	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	23666	0	6276-0	3027231		
3861	374	3006322	2010-04-05	2010-04-05 00:00:00	2010-04-05	5001	0	\N	0	0	\N	\N	0	24800	0	8331-1	3006322		
47978	4393	3006322	1998-08-02	1998-08-02 00:00:00	1998-08-02	5001	0	\N	0	0	\N	\N	0	292104	0	8331-1	3006322		
17270	1571	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	105461	0	6075-6	3005136		
35551	3249	3006322	1963-03-05	1963-03-05 00:00:00	1963-03-05	5001	0	\N	0	0	\N	\N	0	215946	0	8331-1	3006322		
71677	2192	4052083	1972-04-23	1972-04-23 00:00:00	1972-04-23	5001	0	\N	0	0	\N	\N	0	146207	0	23426006	4052083		
127337	3917	4052083	1994-01-20	1994-01-20 00:00:00	1994-01-20	5001	0	\N	0	0	\N	\N	0	260449	0	23426006	4052083		
3603	343	3027231	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	22870	0	6276-0	3027231		
58162	5337	3006451	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	355395	0	6273-7	3006451		
41407	3859	46235214	1989-08-25	1989-08-25 00:00:00	1989-08-25	5001	0	\N	0	0	\N	\N	0	256271	0	76690-7	46235214		
3193	97	4133840	2007-06-25	2007-06-25 00:00:00	2007-06-25	5001	0	\N	0	0	\N	\N	0	6639	0	127783003	4133840		
79862	2458	4024958	1973-04-22	1973-04-22 00:00:00	1973-04-22	5001	0	\N	0	0	\N	\N	0	162946	0	117015009	4024958		
4714	449	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	29911	0	6248-9	3015076		
26304	2419	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	160617	0	6106-9	3014599		
84000	2597	4052083	1996-06-04	1996-06-04 00:00:00	1996-06-04	5001	0	\N	0	0	\N	\N	0	171832	0	23426006	4052083		
124805	3857	4133840	2007-08-28	2007-08-28 00:00:00	2007-08-28	5001	0	\N	0	0	\N	\N	0	256003	0	127783003	4133840		
86943	2685	4133840	1977-01-13	1977-01-13 00:00:00	1977-01-13	5001	0	\N	0	0	\N	\N	0	177958	0	127783003	4133840		
25622	2349	3006322	1973-05-07	1973-05-07 00:00:00	1973-05-07	5001	0	\N	0	0	\N	\N	0	156365	0	8331-1	3006322		
119277	3675	4024958	1974-10-24	1974-10-24 00:00:00	1974-10-24	5001	0	\N	0	0	\N	\N	0	244432	0	117015009	4024958		
119351	3678	4052083	2016-02-16	2016-02-16 00:00:00	2016-02-16	5001	0	\N	0	0	\N	\N	0	244589	0	23426006	4052083		
37180	3422	40766240	1983-07-13	1983-07-13 00:00:00	1983-07-13	5001	0	\N	0	0	\N	\N	0	226955	0	63513-6	40766240		
20760	1911	3006322	1986-07-08	1986-07-08 00:00:00	1986-07-08	5001	0	\N	0	0	\N	\N	0	127143	0	8331-1	3006322		
35267	3222	3006322	1971-03-19	1971-03-19 00:00:00	1971-03-19	5001	0	\N	0	0	\N	\N	0	214139	0	8331-1	3006322		
8834	844	3023430	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	55919	0	6833-8	3023430		
43474	4019	3006322	1985-10-20	1985-10-20 00:00:00	1985-10-20	5001	0	\N	0	0	\N	\N	0	267162	0	8331-1	3006322		
36843	3382	3006322	1968-07-28	1968-07-28 00:00:00	1968-07-28	5001	0	\N	0	0	\N	\N	0	224417	0	8331-1	3006322		
55126	5048	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	335420	0	6085-5	3001247		
129428	3986	4052083	1971-03-07	1971-03-07 00:00:00	1971-03-07	5001	0	\N	0	0	\N	\N	0	264965	0	23426006	4052083		
20143	1844	40758406	1989-06-23	1989-06-23 00:00:00	1989-06-23	5001	0	\N	0	0	\N	\N	0	123173	0	55277-8	40758406		
9538	902	3006322	1957-07-06	1957-07-06 00:00:00	1957-07-06	5001	0	\N	0	0	\N	\N	0	60002	0	8331-1	3006322		
18816	1727	3011505	2007-10-04	2007-10-04 00:00:00	2007-10-04	5001	0	\N	0	0	\N	\N	0	115452	0	19926-5	3011505		
7755	743	3006322	2001-07-15	2001-07-15 00:00:00	2001-07-15	5001	0	\N	0	0	\N	\N	0	49278	0	8331-1	3006322		
30289	2778	3023430	1978-02-02	1978-02-02 00:00:00	1978-02-02	5001	0	\N	0	0	\N	\N	0	183994	0	6833-8	3023430		
35247	1099	4024958	1979-03-23	1979-03-23 00:00:00	1979-03-23	5001	0	\N	0	0	\N	\N	0	72242	0	117015009	4024958		
125647	3875	4052083	2017-07-03	2017-07-03 00:00:00	2017-07-03	5001	0	\N	0	0	\N	\N	0	257329	0	23426006	4052083		
25068	2300	3011505	2000-12-28	2000-12-28 00:00:00	2000-12-28	5001	0	\N	0	0	\N	\N	0	153133	0	19926-5	3011505		
72094	2206	4052083	2001-04-08	2001-04-08 00:00:00	2001-04-08	5001	0	\N	0	0	\N	\N	0	146990	0	23426006	4052083		
3771	357	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	23666	0	6844-5	3020655		
3862	374	3006322	2007-02-11	2007-02-11 00:00:00	2007-02-11	5001	0	\N	0	0	\N	\N	0	24799	0	8331-1	3006322		
47979	4394	3006322	1985-05-28	1985-05-28 00:00:00	1985-05-28	5001	0	\N	0	0	\N	\N	0	292138	0	8331-1	3006322		
17271	1571	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	105461	0	6106-9	3014599		
35552	3249	3006322	1958-03-12	1958-03-12 00:00:00	1958-03-12	5001	0	\N	0	0	\N	\N	0	215945	0	8331-1	3006322		
170540	5232	4024958	1978-08-15	1978-08-15 00:00:00	1978-08-15	5001	0	\N	0	0	\N	\N	0	348082	0	117015009	4024958		
127530	3926	4133840	1999-11-08	1999-11-08 00:00:00	1999-11-08	5001	0	\N	0	0	\N	\N	0	260952	0	127783003	4133840		
3604	343	3019406	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	22870	0	6158-0	3019406		
58163	5337	3023430	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	355395	0	6833-8	3023430		
2692	84	4052083	1976-07-02	1976-07-02 00:00:00	1976-07-02	5001	0	\N	0	0	\N	\N	0	5669	0	23426006	4052083		
3195	97	4133840	1999-07-12	1999-07-12 00:00:00	1999-07-12	5001	0	\N	0	0	\N	\N	0	6637	0	127783003	4133840		
79870	2458	4024958	1985-03-20	1985-03-20 00:00:00	1985-03-20	5001	0	\N	0	0	\N	\N	0	162967	0	117015009	4024958		
4715	449	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	29911	0	6273-7	3006451		
26305	2419	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	160617	0	6095-4	3036780		
152925	4689	4052083	1981-07-27	1981-07-27 00:00:00	1981-07-27	5001	0	\N	0	0	\N	\N	0	312441	0	23426006	4052083		
124809	3857	4133840	1990-01-09	1990-01-09 00:00:00	1990-01-09	5001	0	\N	0	0	\N	\N	0	255986	0	127783003	4133840		
86944	2685	4133840	1994-12-08	1994-12-08 00:00:00	1994-12-08	5001	0	\N	0	0	\N	\N	0	177929	0	127783003	4133840		
25623	2349	3019406	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	156377	0	6158-0	3019406		
119279	3675	4024958	1994-12-01	1994-12-01 00:00:00	1994-12-01	5001	0	\N	0	0	\N	\N	0	244476	0	117015009	4024958		
81230	2509	4024958	2010-11-20	2010-11-20 00:00:00	2010-11-20	5001	0	\N	0	0	\N	\N	0	166069	0	117015009	4024958		
37181	3422	40758406	1983-07-13	1983-07-13 00:00:00	1983-07-13	5001	0	\N	0	0	\N	\N	0	226955	0	55277-8	40758406		
20761	1911	3011505	2001-09-24	2001-09-24 00:00:00	2001-09-24	5001	0	\N	0	0	\N	\N	0	127112	0	19926-5	3011505		
35268	3223	3006322	1985-09-24	1985-09-24 00:00:00	1985-09-24	5001	0	\N	0	0	\N	\N	0	214315	0	8331-1	3006322		
8835	844	3036780	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	55919	0	6095-4	3036780		
43475	4019	3006322	1997-10-09	1997-10-09 00:00:00	1997-10-09	5001	0	\N	0	0	\N	\N	0	267127	0	8331-1	3006322		
36844	3383	3006322	2016-09-11	2016-09-11 00:00:00	2016-09-11	5001	0	\N	0	0	\N	\N	0	224484	0	8331-1	3006322		
55127	5048	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	335420	0	6276-0	3027231		
129437	3986	4052083	1973-09-24	1973-09-24 00:00:00	1973-09-24	5001	0	\N	0	0	\N	\N	0	264966	0	23426006	4052083		
20144	1844	46235214	1989-06-23	1989-06-23 00:00:00	1989-06-23	5001	0	\N	0	0	\N	\N	0	123173	0	76690-7	46235214		
9539	902	3006322	2006-04-11	2006-04-11 00:00:00	2006-04-11	5001	0	\N	0	0	\N	\N	0	59986	0	8331-1	3006322		
18817	1727	3011505	2005-09-22	2005-09-22 00:00:00	2005-09-22	5001	0	\N	0	0	\N	\N	0	115451	0	19926-5	3011505		
7756	743	3006322	1991-02-22	1991-02-22 00:00:00	1991-02-22	5001	0	\N	0	0	\N	\N	0	49240	0	8331-1	3006322		
30290	2778	3001247	1978-02-02	1978-02-02 00:00:00	1978-02-02	5001	0	\N	0	0	\N	\N	0	183994	0	6085-5	3001247		
42342	1309	4052083	1957-02-18	1957-02-18 00:00:00	1957-02-18	5001	0	\N	0	0	\N	\N	0	86452	0	23426006	4052083		
32500	2947	3006322	1989-08-04	1989-08-04 00:00:00	1989-08-04	5001	0	\N	0	0	\N	\N	0	196702	0	8331-1	3006322		
25069	2300	3006322	1957-09-28	1957-09-28 00:00:00	1957-09-28	5001	0	\N	0	0	\N	\N	0	153203	0	8331-1	3006322		
72105	2207	4052083	1989-01-08	1989-01-08 00:00:00	1989-01-08	5001	0	\N	0	0	\N	\N	0	147078	0	23426006	4052083		
3772	357	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	23666	0	6085-5	3001247		
158506	4872	4024958	1946-11-05	1946-11-05 00:00:00	1946-11-05	5001	0	\N	0	0	\N	\N	0	323977	0	117015009	4024958		
47980	4394	3006322	1993-10-27	1993-10-27 00:00:00	1993-10-27	5001	0	\N	0	0	\N	\N	0	292141	0	8331-1	3006322		
17272	1571	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	105461	0	6085-5	3001247		
35553	3249	3006322	2008-02-04	2008-02-04 00:00:00	2008-02-04	5001	0	\N	0	0	\N	\N	0	216015	0	8331-1	3006322		
170552	5232	4024958	2004-01-12	2004-01-12 00:00:00	2004-01-12	5001	0	\N	0	0	\N	\N	0	348084	0	117015009	4024958		
127535	3926	4024958	1959-08-13	1959-08-13 00:00:00	1959-08-13	5001	0	\N	0	0	\N	\N	0	260924	0	117015009	4024958		
3605	343	3021226	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	22870	0	6246-3	3021226		
58164	5337	3020655	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	355395	0	6844-5	3020655		
2699	84	4024958	1999-07-10	1999-07-10 00:00:00	1999-07-10	5001	0	\N	0	0	\N	\N	0	5653	0	117015009	4024958		
3199	97	4133840	2014-08-04	2014-08-04 00:00:00	2014-08-04	5001	0	\N	0	0	\N	\N	0	6632	0	127783003	4133840		
79873	2458	4052083	1982-05-23	1982-05-23 00:00:00	1982-05-23	5001	0	\N	0	0	\N	\N	0	162958	0	23426006	4052083		
4716	449	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	29911	0	6082-2	3000876		
26306	2419	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	160617	0	6158-0	3019406		
152926	4689	4052083	1993-12-29	1993-12-29 00:00:00	1993-12-29	5001	0	\N	0	0	\N	\N	0	312404	0	23426006	4052083		
124812	3857	4133840	1988-01-05	1988-01-05 00:00:00	1988-01-05	5001	0	\N	0	0	\N	\N	0	256017	0	127783003	4133840		
86949	2685	4133840	2006-03-30	2006-03-30 00:00:00	2006-03-30	5001	0	\N	0	0	\N	\N	0	177903	0	127783003	4133840		
25624	2349	3001247	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	156377	0	6085-5	3001247		
119280	3675	4052083	2018-02-28	2018-02-28 00:00:00	2018-02-28	5001	0	\N	0	0	\N	\N	0	244415	0	23426006	4052083		
81236	2509	4024958	1970-05-08	1970-05-08 00:00:00	1970-05-08	5001	0	\N	0	0	\N	\N	0	166094	0	117015009	4024958		
37184	3422	3006322	2012-09-19	2012-09-19 00:00:00	2012-09-19	5001	0	\N	0	0	\N	\N	0	227029	0	8331-1	3006322		
20762	1911	3011505	2003-10-06	2003-10-06 00:00:00	2003-10-06	5001	0	\N	0	0	\N	\N	0	127113	0	19926-5	3011505		
35269	3223	3049273	1987-06-17	1987-06-17 00:00:00	1987-06-17	5001	0	\N	0	0	\N	\N	0	214244	0	38265-5	3049273		
8836	844	3000876	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	55919	0	6082-2	3000876		
43476	4019	3006322	2001-03-05	2001-03-05 00:00:00	2001-03-05	5001	0	\N	0	0	\N	\N	0	267128	0	8331-1	3006322		
36845	3383	3006322	2005-11-19	2005-11-19 00:00:00	2005-11-19	5001	0	\N	0	0	\N	\N	0	224483	0	8331-1	3006322		
55128	5048	3005136	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	335420	0	6075-6	3005136		
129439	3986	4024958	1974-04-03	1974-04-03 00:00:00	1974-04-03	5001	0	\N	0	0	\N	\N	0	264982	0	117015009	4024958		
20145	1844	40766240	1989-06-23	1989-06-23 00:00:00	1989-06-23	5001	0	\N	0	0	\N	\N	0	123173	0	63513-6	40766240		
9540	902	3006322	1969-09-13	1969-09-13 00:00:00	1969-09-13	5001	0	\N	0	0	\N	\N	0	60049	0	8331-1	3006322		
18818	1727	3011505	2004-09-16	2004-09-16 00:00:00	2004-09-16	5001	0	\N	0	0	\N	\N	0	115477	0	19926-5	3011505		
7757	743	3006322	2004-01-14	2004-01-14 00:00:00	2004-01-14	5001	0	\N	0	0	\N	\N	0	49254	0	8331-1	3006322		
30291	2778	3006451	1978-02-02	1978-02-02 00:00:00	1978-02-02	5001	0	\N	0	0	\N	\N	0	183994	0	6273-7	3006451		
42343	1309	4052083	1970-08-25	1970-08-25 00:00:00	1970-08-25	5001	0	\N	0	0	\N	\N	0	86458	0	23426006	4052083		
32502	2949	3006322	2019-04-11	2019-04-11 00:00:00	2019-04-11	5001	0	\N	0	0	\N	\N	0	196848	0	8331-1	3006322		
25070	2300	3011505	2018-04-05	2018-04-05 00:00:00	2018-04-05	5001	0	\N	0	0	\N	\N	0	153147	0	19926-5	3011505		
72107	2207	4024958	2014-11-22	2014-11-22 00:00:00	2014-11-22	5001	0	\N	0	0	\N	\N	0	147058	0	117015009	4024958		
3773	357	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	23666	0	6833-8	3023430		
158508	4872	4024958	1971-08-08	1971-08-08 00:00:00	1971-08-08	5001	0	\N	0	0	\N	\N	0	324028	0	117015009	4024958		
47981	4394	3006322	2004-03-13	2004-03-13 00:00:00	2004-03-13	5001	0	\N	0	0	\N	\N	0	292156	0	8331-1	3006322		
40513	3761	3006322	1957-02-16	1957-02-16 00:00:00	1957-02-16	5001	0	\N	0	0	\N	\N	0	250050	0	8331-1	3006322		
35554	3249	3006322	1959-12-13	1959-12-13 00:00:00	1959-12-13	5001	0	\N	0	0	\N	\N	0	215959	0	8331-1	3006322		
170553	5232	4024958	1968-09-15	1968-09-15 00:00:00	1968-09-15	5001	0	\N	0	0	\N	\N	0	348081	0	117015009	4024958		
127538	3926	4133840	1997-10-27	1997-10-27 00:00:00	1997-10-27	5001	0	\N	0	0	\N	\N	0	260931	0	127783003	4133840		
3606	343	3001488	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	22870	0	7258-7	3001488		
58165	5337	3001488	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	355395	0	7258-7	3001488		
2726	86	4024958	1955-06-05	1955-06-05 00:00:00	1955-06-05	5001	0	\N	0	0	\N	\N	0	5803	0	117015009	4024958		
3200	97	4133840	1985-07-29	1985-07-29 00:00:00	1985-07-29	5001	0	\N	0	0	\N	\N	0	6624	0	127783003	4133840		
79874	2458	4052083	2016-12-19	2016-12-19 00:00:00	2016-12-19	5001	0	\N	0	0	\N	\N	0	162949	0	23426006	4052083		
4717	449	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	29911	0	6075-6	3005136		
26307	2419	3015076	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	160617	0	6248-9	3015076		
152927	4689	4024958	1981-08-23	1981-08-23 00:00:00	1981-08-23	5001	0	\N	0	0	\N	\N	0	312414	0	117015009	4024958		
124813	3857	4024958	1974-12-08	1974-12-08 00:00:00	1974-12-08	5001	0	\N	0	0	\N	\N	0	255950	0	117015009	4024958		
86950	2685	4133840	1989-01-12	1989-01-12 00:00:00	1989-01-12	5001	0	\N	0	0	\N	\N	0	177927	0	127783003	4133840		
25625	2349	3027231	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	156377	0	6276-0	3027231		
119283	3675	4024958	1968-04-13	1968-04-13 00:00:00	1968-04-13	5001	0	\N	0	0	\N	\N	0	244407	0	117015009	4024958		
92575	2853	4052083	1995-03-24	1995-03-24 00:00:00	1995-03-24	5001	0	\N	0	0	\N	\N	0	189533	0	23426006	4052083		
37185	3423	3006322	2011-09-24	2011-09-24 00:00:00	2011-09-24	5001	0	\N	0	0	\N	\N	0	227060	0	8331-1	3006322		
20763	1911	3011505	2002-09-30	2002-09-30 00:00:00	2002-09-30	5001	0	\N	0	0	\N	\N	0	127195	0	19926-5	3011505		
35270	3223	3006322	1981-10-06	1981-10-06 00:00:00	1981-10-06	5001	0	\N	0	0	\N	\N	0	214314	0	8331-1	3006322		
8837	844	3019406	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	55919	0	6158-0	3019406		
43477	4019	3006322	1993-12-16	1993-12-16 00:00:00	1993-12-16	5001	0	\N	0	0	\N	\N	0	267151	0	8331-1	3006322		
36846	3383	3006322	1988-11-04	1988-11-04 00:00:00	1988-11-04	5001	0	\N	0	0	\N	\N	0	224477	0	8331-1	3006322		
55129	5048	3012494	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	335420	0	6206-7	3012494		
129440	3986	4052083	2005-10-17	2005-10-17 00:00:00	2005-10-17	5001	0	\N	0	0	\N	\N	0	265015	0	23426006	4052083		
20147	1845	3006322	1979-02-19	1979-02-19 00:00:00	1979-02-19	5001	0	\N	0	0	\N	\N	0	123327	0	8331-1	3006322		
9546	905	3006322	1972-01-18	1972-01-18 00:00:00	1972-01-18	5001	0	\N	0	0	\N	\N	0	60198	0	8331-1	3006322		
18819	1727	3011505	2004-04-29	2004-04-29 00:00:00	2004-04-29	5001	0	\N	0	0	\N	\N	0	115450	0	19926-5	3011505		
7758	744	3006322	1963-04-26	1963-04-26 00:00:00	1963-04-26	5001	0	\N	0	0	\N	\N	0	49327	0	8331-1	3006322		
30292	2778	3012494	1978-02-02	1978-02-02 00:00:00	1978-02-02	5001	0	\N	0	0	\N	\N	0	183994	0	6206-7	3012494		
161425	4957	4052083	1977-02-04	1977-02-04 00:00:00	1977-02-04	5001	0	\N	0	0	\N	\N	0	329513	0	23426006	4052083		
32503	2949	3006322	2002-02-27	2002-02-27 00:00:00	2002-02-27	5001	0	\N	0	0	\N	\N	0	196797	0	8331-1	3006322		
25071	2300	3011505	1997-12-18	1997-12-18 00:00:00	1997-12-18	5001	0	\N	0	0	\N	\N	0	153197	0	19926-5	3011505		
136212	4200	4024958	1979-06-26	1979-06-26 00:00:00	1979-06-26	5001	0	\N	0	0	\N	\N	0	278737	0	117015009	4024958		
3774	357	3006322	1973-05-22	1973-05-22 00:00:00	1973-05-22	5001	0	\N	0	0	\N	\N	0	23737	0	8331-1	3006322		
158519	4872	4052083	2005-12-21	2005-12-21 00:00:00	2005-12-21	5001	0	\N	0	0	\N	\N	0	324012	0	23426006	4052083		
47982	4394	3006322	1978-03-22	1978-03-22 00:00:00	1978-03-22	5001	0	\N	0	0	\N	\N	0	292140	0	8331-1	3006322		
40514	3761	3006322	2003-06-12	2003-06-12 00:00:00	2003-06-12	5001	0	\N	0	0	\N	\N	0	250075	0	8331-1	3006322		
35555	3249	3006322	1966-04-02	1966-04-02 00:00:00	1966-04-02	5001	0	\N	0	0	\N	\N	0	216007	0	8331-1	3006322		
170555	5232	4052083	2007-11-15	2007-11-15 00:00:00	2007-11-15	5001	0	\N	0	0	\N	\N	0	348090	0	23426006	4052083		
127539	3926	4133840	2002-11-25	2002-11-25 00:00:00	2002-11-25	5001	0	\N	0	0	\N	\N	0	261002	0	127783003	4133840		
3607	343	3023430	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	22870	0	6833-8	3023430		
58166	5337	3027231	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	355395	0	6276-0	3027231		
2737	86	4052083	1977-12-14	1977-12-14 00:00:00	1977-12-14	5001	0	\N	0	0	\N	\N	0	5805	0	23426006	4052083		
3203	97	4133840	2013-07-29	2013-07-29 00:00:00	2013-07-29	5001	0	\N	0	0	\N	\N	0	6612	0	127783003	4133840		
79875	2459	4024958	1994-08-04	1994-08-04 00:00:00	1994-08-04	5001	0	\N	0	0	\N	\N	0	163048	0	117015009	4024958		
4718	449	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	29911	0	6095-4	3036780		
26308	2419	3001247	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	160617	0	6085-5	3001247		
152949	4690	4052083	1978-10-14	1978-10-14 00:00:00	1978-10-14	5001	0	\N	0	0	\N	\N	0	312515	0	23426006	4052083		
124814	3857	4133840	1974-12-17	1974-12-17 00:00:00	1974-12-17	5001	0	\N	0	0	\N	\N	0	256043	0	127783003	4133840		
86952	2685	4133840	1968-01-04	1968-01-04 00:00:00	1968-01-04	5001	0	\N	0	0	\N	\N	0	177921	0	127783003	4133840		
25626	2349	3036780	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	156377	0	6095-4	3036780		
119284	3675	4024958	1988-10-24	1988-10-24 00:00:00	1988-10-24	5001	0	\N	0	0	\N	\N	0	244446	0	117015009	4024958		
92581	2853	4024958	1974-01-09	1974-01-09 00:00:00	1974-01-09	5001	0	\N	0	0	\N	\N	0	189546	0	117015009	4024958		
37186	3423	3006322	1993-08-03	1993-08-03 00:00:00	1993-08-03	5001	0	\N	0	0	\N	\N	0	227057	0	8331-1	3006322		
32042	2919	3006322	1969-03-02	1969-03-02 00:00:00	1969-03-02	5001	0	\N	0	0	\N	\N	0	194587	0	8331-1	3006322		
35271	3223	3006322	1948-07-05	1948-07-05 00:00:00	1948-07-05	5001	0	\N	0	0	\N	\N	0	214240	0	8331-1	3006322		
8838	844	3005136	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	55919	0	6075-6	3005136		
43478	4019	3006322	1968-01-04	1968-01-04 00:00:00	1968-01-04	5001	0	\N	0	0	\N	\N	0	267168	0	8331-1	3006322		
36847	3383	3006322	2016-03-05	2016-03-05 00:00:00	2016-03-05	5001	0	\N	0	0	\N	\N	0	224524	0	8331-1	3006322		
55130	5048	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	335420	0	6189-5	3006734		
129452	3987	4024958	1965-12-06	1965-12-06 00:00:00	1965-12-06	5001	0	\N	0	0	\N	\N	0	265039	0	117015009	4024958		
20148	1845	3006322	1992-11-21	1992-11-21 00:00:00	1992-11-21	5001	0	\N	0	0	\N	\N	0	123298	0	8331-1	3006322		
9547	905	3006322	1969-06-19	1969-06-19 00:00:00	1969-06-19	5001	0	\N	0	0	\N	\N	0	60212	0	8331-1	3006322		
18820	1727	3011505	2013-11-06	2013-11-06 00:00:00	2013-11-06	5001	0	\N	0	0	\N	\N	0	115459	0	19926-5	3011505		
7759	744	3006322	2009-11-03	2009-11-03 00:00:00	2009-11-03	5001	0	\N	0	0	\N	\N	0	49350	0	8331-1	3006322		
30293	2778	3019406	1978-02-02	1978-02-02 00:00:00	1978-02-02	5001	0	\N	0	0	\N	\N	0	183994	0	6158-0	3019406		
161432	4957	4024958	1983-07-16	1983-07-16 00:00:00	1983-07-16	5001	0	\N	0	0	\N	\N	0	329553	0	117015009	4024958		
32504	2949	3006322	1992-04-04	1992-04-04 00:00:00	1992-04-04	5001	0	\N	0	0	\N	\N	0	196846	0	8331-1	3006322		
25072	2300	3011505	2006-01-26	2006-01-26 00:00:00	2006-01-26	5001	0	\N	0	0	\N	\N	0	153162	0	19926-5	3011505		
147515	4521	4052083	1972-12-10	1972-12-10 00:00:00	1972-12-10	5001	0	\N	0	0	\N	\N	0	301006	0	23426006	4052083		
3775	357	3006322	1983-11-16	1983-11-16 00:00:00	1983-11-16	5001	0	\N	0	0	\N	\N	0	23703	0	8331-1	3006322		
158530	4872	4024958	1990-08-17	1990-08-17 00:00:00	1990-08-17	5001	0	\N	0	0	\N	\N	0	323993	0	117015009	4024958		
47983	4395	3006322	2010-05-30	2010-05-30 00:00:00	2010-05-30	5001	0	\N	0	0	\N	\N	0	292261	0	8331-1	3006322		
40515	3761	3006322	2009-08-19	2009-08-19 00:00:00	2009-08-19	5001	0	\N	0	0	\N	\N	0	250098	0	8331-1	3006322		
35556	3249	3006322	2004-09-08	2004-09-08 00:00:00	2004-09-08	5001	0	\N	0	0	\N	\N	0	215967	0	8331-1	3006322		
170560	5232	4024958	1968-04-06	1968-04-06 00:00:00	1968-04-06	5001	0	\N	0	0	\N	\N	0	348087	0	117015009	4024958		
127541	3926	4133840	2017-07-24	2017-07-24 00:00:00	2017-07-24	5001	0	\N	0	0	\N	\N	0	260958	0	127783003	4133840		
3608	343	3014599	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	22870	0	6106-9	3014599		
58167	5337	3015076	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	355395	0	6248-9	3015076		
2745	86	4024958	1990-03-14	1990-03-14 00:00:00	1990-03-14	5001	0	\N	0	0	\N	\N	0	5795	0	117015009	4024958		
3205	97	4133840	1991-08-12	1991-08-12 00:00:00	1991-08-12	5001	0	\N	0	0	\N	\N	0	6625	0	127783003	4133840		
79876	2459	4052083	2006-06-16	2006-06-16 00:00:00	2006-06-16	5001	0	\N	0	0	\N	\N	0	163055	0	23426006	4052083		
4719	449	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	29911	0	6206-7	3012494		
26309	2419	3000876	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	160617	0	6082-2	3000876		
152957	4690	4024958	2008-05-03	2008-05-03 00:00:00	2008-05-03	5001	0	\N	0	0	\N	\N	0	312538	0	117015009	4024958		
124816	3857	4133840	2010-09-14	2010-09-14 00:00:00	2010-09-14	5001	0	\N	0	0	\N	\N	0	255965	0	127783003	4133840		
86953	2685	4133840	2007-04-05	2007-04-05 00:00:00	2007-04-05	5001	0	\N	0	0	\N	\N	0	177963	0	127783003	4133840		
25627	2349	3000876	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	156377	0	6082-2	3000876		
119299	3676	4024958	2000-05-25	2000-05-25 00:00:00	2000-05-25	5001	0	\N	0	0	\N	\N	0	244499	0	117015009	4024958		
92583	2853	4052083	1973-04-13	1973-04-13 00:00:00	1973-04-13	5001	0	\N	0	0	\N	\N	0	189505	0	23426006	4052083		
37187	3423	3006322	1988-12-04	1988-12-04 00:00:00	1988-12-04	5001	0	\N	0	0	\N	\N	0	227063	0	8331-1	3006322		
32043	2919	3006322	1983-10-06	1983-10-06 00:00:00	1983-10-06	5001	0	\N	0	0	\N	\N	0	194563	0	8331-1	3006322		
35273	3223	3006322	1959-10-17	1959-10-17 00:00:00	1959-10-17	5001	0	\N	0	0	\N	\N	0	214325	0	8331-1	3006322		
8839	844	3006451	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	55919	0	6273-7	3006451		
43479	4020	3049273	2016-04-28	2016-04-28 00:00:00	2016-04-28	5001	0	\N	0	0	\N	\N	0	267275	0	38265-5	3049273		
36865	3386	3006322	1973-04-10	1973-04-10 00:00:00	1973-04-10	5001	0	\N	0	0	\N	\N	0	224678	0	8331-1	3006322		
55131	5048	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	335420	0	6844-5	3020655		
129472	3987	4024958	1956-05-15	1956-05-15 00:00:00	1956-05-15	5001	0	\N	0	0	\N	\N	0	265062	0	117015009	4024958		
20149	1845	3006322	1962-01-17	1962-01-17 00:00:00	1962-01-17	5001	0	\N	0	0	\N	\N	0	123269	0	8331-1	3006322		
9548	905	3006322	2010-01-10	2010-01-10 00:00:00	2010-01-10	5001	0	\N	0	0	\N	\N	0	60200	0	8331-1	3006322		
18821	1727	3006322	1955-02-12	1955-02-12 00:00:00	1955-02-12	5001	0	\N	0	0	\N	\N	0	115513	0	8331-1	3006322		
7760	744	3006322	2017-03-06	2017-03-06 00:00:00	2017-03-06	5001	0	\N	0	0	\N	\N	0	49351	0	8331-1	3006322		
30294	2778	3005136	1978-02-02	1978-02-02 00:00:00	1978-02-02	5001	0	\N	0	0	\N	\N	0	183994	0	6075-6	3005136		
161438	4957	4052083	1978-11-12	1978-11-12 00:00:00	1978-11-12	5001	0	\N	0	0	\N	\N	0	329515	0	23426006	4052083		
32505	2949	3006322	1970-09-11	1970-09-11 00:00:00	1970-09-11	5001	0	\N	0	0	\N	\N	0	196839	0	8331-1	3006322		
25073	2300	3006322	2010-09-25	2010-09-25 00:00:00	2010-09-25	5001	0	\N	0	0	\N	\N	0	153167	0	8331-1	3006322		
147527	4522	4052083	1985-04-23	1985-04-23 00:00:00	1985-04-23	5001	0	\N	0	0	\N	\N	0	301106	0	23426006	4052083		
3776	357	3049273	2014-12-10	2014-12-10 00:00:00	2014-12-10	5001	0	\N	0	0	\N	\N	0	23753	0	38265-5	3049273		
158533	4872	4052083	1968-03-01	1968-03-01 00:00:00	1968-03-01	5001	0	\N	0	0	\N	\N	0	324010	0	23426006	4052083		
47984	4395	3006322	1966-09-28	1966-09-28 00:00:00	1966-09-28	5001	0	\N	0	0	\N	\N	0	292265	0	8331-1	3006322		
40516	3761	3006322	1960-07-21	1960-07-21 00:00:00	1960-07-21	5001	0	\N	0	0	\N	\N	0	250094	0	8331-1	3006322		
35557	3249	3006322	1967-02-06	1967-02-06 00:00:00	1967-02-06	5001	0	\N	0	0	\N	\N	0	215993	0	8331-1	3006322		
143173	4398	4052083	2005-05-23	2005-05-23 00:00:00	2005-05-23	5001	0	\N	0	0	\N	\N	0	292465	0	23426006	4052083		
3609	343	3005136	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	22870	0	6075-6	3005136		
58168	5337	3001247	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	355395	0	6085-5	3001247		
2751	86	4024958	1995-11-29	1995-11-29 00:00:00	1995-11-29	5001	0	\N	0	0	\N	\N	0	5796	0	117015009	4024958		
118158	3637	4052083	1991-05-21	1991-05-21 00:00:00	1991-05-21	5001	0	\N	0	0	\N	\N	0	241922	0	23426006	4052083		
79881	2459	4024958	1978-08-25	1978-08-25 00:00:00	1978-08-25	5001	0	\N	0	0	\N	\N	0	163050	0	117015009	4024958		
4720	449	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	29911	0	6106-9	3014599		
26310	2419	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	160617	0	6276-0	3027231		
152974	4691	4024958	1968-05-08	1968-05-08 00:00:00	1968-05-08	5001	0	\N	0	0	\N	\N	0	312572	0	117015009	4024958		
124820	3857	4133840	2013-10-01	2013-10-01 00:00:00	2013-10-01	5001	0	\N	0	0	\N	\N	0	256024	0	127783003	4133840		
86956	2685	4133840	1965-01-28	1965-01-28 00:00:00	1965-01-28	5001	0	\N	0	0	\N	\N	0	177954	0	127783003	4133840		
25628	2349	3021226	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	156377	0	6246-3	3021226		
119307	3676	4052083	1979-10-23	1979-10-23 00:00:00	1979-10-23	5001	0	\N	0	0	\N	\N	0	244497	0	23426006	4052083		
115742	3566	4024958	1963-08-23	1963-08-23 00:00:00	1963-08-23	5001	0	\N	0	0	\N	\N	0	236918	0	117015009	4024958		
37188	3423	3006322	1998-11-19	1998-11-19 00:00:00	1998-11-19	5001	0	\N	0	0	\N	\N	0	227040	0	8331-1	3006322		
32044	2919	3011505	2017-12-16	2017-12-16 00:00:00	2017-12-16	5001	0	\N	0	0	\N	\N	0	194622	0	19926-5	3011505		
35277	3223	3006322	1986-06-06	1986-06-06 00:00:00	1986-06-06	5001	0	\N	0	0	\N	\N	0	214327	0	8331-1	3006322		
8840	844	3001247	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	55919	0	6085-5	3001247		
43480	4020	3006322	2016-02-16	2016-02-16 00:00:00	2016-02-16	5001	0	\N	0	0	\N	\N	0	267224	0	8331-1	3006322		
36866	3386	3006322	2012-04-06	2012-04-06 00:00:00	2012-04-06	5001	0	\N	0	0	\N	\N	0	224636	0	8331-1	3006322		
55132	5048	3019406	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	335420	0	6158-0	3019406		
152770	4685	4024958	1961-02-17	1961-02-17 00:00:00	1961-02-17	5001	0	\N	0	0	\N	\N	0	312105	0	117015009	4024958		
20150	1845	3006322	1969-10-24	1969-10-24 00:00:00	1969-10-24	5001	0	\N	0	0	\N	\N	0	123259	0	8331-1	3006322		
9549	906	3006322	1976-03-10	1976-03-10 00:00:00	1976-03-10	5001	0	\N	0	0	\N	\N	0	60242	0	8331-1	3006322		
18822	1727	3011505	2000-04-06	2000-04-06 00:00:00	2000-04-06	5001	0	\N	0	0	\N	\N	0	115427	0	19926-5	3011505		
7761	744	3006322	1963-01-14	1963-01-14 00:00:00	1963-01-14	5001	0	\N	0	0	\N	\N	0	49314	0	8331-1	3006322		
30295	2778	3001488	1978-02-02	1978-02-02 00:00:00	1978-02-02	5001	0	\N	0	0	\N	\N	0	183994	0	7258-7	3001488		
161442	4957	4024958	1979-09-22	1979-09-22 00:00:00	1979-09-22	5001	0	\N	0	0	\N	\N	0	329523	0	117015009	4024958		
32506	2950	3049273	2014-02-11	2014-02-11 00:00:00	2014-02-11	5001	0	\N	0	0	\N	\N	0	196943	0	38265-5	3049273		
25074	2300	3006322	2015-08-12	2015-08-12 00:00:00	2015-08-12	5001	0	\N	0	0	\N	\N	0	153207	0	8331-1	3006322		
147535	4522	4024958	1986-06-03	1986-06-03 00:00:00	1986-06-03	5001	0	\N	0	0	\N	\N	0	301127	0	117015009	4024958		
3777	357	3006322	1992-07-11	1992-07-11 00:00:00	1992-07-11	5001	0	\N	0	0	\N	\N	0	23725	0	8331-1	3006322		
158537	4872	4052083	1944-05-29	1944-05-29 00:00:00	1944-05-29	5001	0	\N	0	0	\N	\N	0	323976	0	23426006	4052083		
47985	4395	3006322	2018-05-31	2018-05-31 00:00:00	2018-05-31	5001	0	\N	0	0	\N	\N	0	292214	0	8331-1	3006322		
40549	3767	3006322	2003-04-09	2003-04-09 00:00:00	2003-04-09	5001	0	\N	0	0	\N	\N	0	250367	0	8331-1	3006322		
35558	3249	3006322	1990-04-27	1990-04-27 00:00:00	1990-04-27	5001	0	\N	0	0	\N	\N	0	216010	0	8331-1	3006322		
143192	4398	4024958	1994-05-14	1994-05-14 00:00:00	1994-05-14	5001	0	\N	0	0	\N	\N	0	292447	0	117015009	4024958		
3610	343	3015076	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	22870	0	6248-9	3015076		
58169	5337	3006734	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	355395	0	6189-5	3006734		
2968	285	3000876	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	18965	0	6082-2	3000876		
118184	3638	4024958	1999-10-29	1999-10-29 00:00:00	1999-10-29	5001	0	\N	0	0	\N	\N	0	241958	0	117015009	4024958		
79897	2459	4052083	2015-03-23	2015-03-23 00:00:00	2015-03-23	5001	0	\N	0	0	\N	\N	0	163063	0	23426006	4052083		
4721	449	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	29911	0	6276-0	3027231		
26311	2419	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	160617	0	6844-5	3020655		
124822	3857	4052083	2015-07-09	2015-07-09 00:00:00	2015-07-09	5001	0	\N	0	0	\N	\N	0	256007	0	23426006	4052083		
121465	3746	4052083	1945-01-04	1945-01-04 00:00:00	1945-01-04	5001	0	\N	0	0	\N	\N	0	248977	0	23426006	4052083		
25629	2349	3012494	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	156377	0	6206-7	3012494		
119310	3676	4024958	1989-08-07	1989-08-07 00:00:00	1989-08-07	5001	0	\N	0	0	\N	\N	0	244498	0	117015009	4024958		
115751	3566	4052083	1965-09-08	1965-09-08 00:00:00	1965-09-08	5001	0	\N	0	0	\N	\N	0	236910	0	23426006	4052083		
37189	3423	3006322	1992-10-27	1992-10-27 00:00:00	1992-10-27	5001	0	\N	0	0	\N	\N	0	227035	0	8331-1	3006322		
32045	2919	3006322	2007-12-09	2007-12-09 00:00:00	2007-12-09	5001	0	\N	0	0	\N	\N	0	194578	0	8331-1	3006322		
35279	3224	3006322	1971-09-05	1971-09-05 00:00:00	1971-09-05	5001	0	\N	0	0	\N	\N	0	214358	0	8331-1	3006322		
8841	844	3012494	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	55919	0	6206-7	3012494		
43481	4020	3006322	2011-07-31	2011-07-31 00:00:00	2011-07-31	5001	0	\N	0	0	\N	\N	0	267223	0	8331-1	3006322		
36867	3386	3006322	1982-06-04	1982-06-04 00:00:00	1982-06-04	5001	0	\N	0	0	\N	\N	0	224610	0	8331-1	3006322		
128190	3946	4052083	1970-04-01	1970-04-01 00:00:00	1970-04-01	5001	0	\N	0	0	\N	\N	0	262340	0	23426006	4052083		
152774	4685	4024958	1953-10-01	1953-10-01 00:00:00	1953-10-01	5001	0	\N	0	0	\N	\N	0	312101	0	117015009	4024958		
20151	1845	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	123301	0	6189-5	3006734		
9550	906	3006322	1981-04-07	1981-04-07 00:00:00	1981-04-07	5001	0	\N	0	0	\N	\N	0	60263	0	8331-1	3006322		
18823	1727	3011505	2002-04-18	2002-04-18 00:00:00	2002-04-18	5001	0	\N	0	0	\N	\N	0	115417	0	19926-5	3011505		
7762	744	3006322	1960-03-19	1960-03-19 00:00:00	1960-03-19	5001	0	\N	0	0	\N	\N	0	49313	0	8331-1	3006322		
30296	2778	3020655	1978-02-02	1978-02-02 00:00:00	1978-02-02	5001	0	\N	0	0	\N	\N	0	183994	0	6844-5	3020655		
172737	5300	4052083	1998-11-10	1998-11-10 00:00:00	1998-11-10	5001	0	\N	0	0	\N	\N	0	352642	0	23426006	4052083		
32508	2950	3006322	1949-01-26	1949-01-26 00:00:00	1949-01-26	5001	0	\N	0	0	\N	\N	0	196895	0	8331-1	3006322		
25075	2300	3011505	2007-02-01	2007-02-01 00:00:00	2007-02-01	5001	0	\N	0	0	\N	\N	0	153145	0	19926-5	3011505		
147541	4522	4024958	2017-02-12	2017-02-12 00:00:00	2017-02-12	5001	0	\N	0	0	\N	\N	0	301110	0	117015009	4024958		
3778	358	3006322	1978-03-08	1978-03-08 00:00:00	1978-03-08	5001	0	\N	0	0	\N	\N	0	23790	0	8331-1	3006322		
158546	4872	4024958	1933-11-07	1933-11-07 00:00:00	1933-11-07	5001	0	\N	0	0	\N	\N	0	323973	0	117015009	4024958		
47986	4395	3006322	1981-12-17	1981-12-17 00:00:00	1981-12-17	5001	0	\N	0	0	\N	\N	0	292266	0	8331-1	3006322		
40550	3767	3006322	1998-06-20	1998-06-20 00:00:00	1998-06-20	5001	0	\N	0	0	\N	\N	0	250338	0	8331-1	3006322		
35559	3250	3006322	1970-01-03	1970-01-03 00:00:00	1970-01-03	5001	0	\N	0	0	\N	\N	0	216050	0	8331-1	3006322		
33793	3069	3006322	2017-07-07	2017-07-07 00:00:00	2017-07-07	5001	0	\N	0	0	\N	\N	0	204256	0	8331-1	3006322		
3611	343	3036780	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	22870	0	6095-4	3036780		
58170	5337	3036780	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	355395	0	6095-4	3036780		
2969	285	3006734	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	18965	0	6189-5	3006734		
118186	3638	4024958	1970-05-11	1970-05-11 00:00:00	1970-05-11	5001	0	\N	0	0	\N	\N	0	241974	0	117015009	4024958		
69885	2141	4024958	1961-05-18	1961-05-18 00:00:00	1961-05-18	5001	0	\N	0	0	\N	\N	0	142612	0	117015009	4024958		
4722	449	40769194	1984-11-03	1984-11-03 00:00:00	1984-11-03	5001	0	\N	0	0	\N	\N	0	29946	0	66534-9	40769194		
26312	2419	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	160526	0	6095-4	3036780		
124823	3857	4133840	2008-09-02	2008-09-02 00:00:00	2008-09-02	5001	0	\N	0	0	\N	\N	0	255964	0	127783003	4133840		
121480	3748	4024958	1981-01-03	1981-01-03 00:00:00	1981-01-03	5001	0	\N	0	0	\N	\N	0	249126	0	117015009	4024958		
25630	2349	3015076	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	156377	0	6248-9	3015076		
56951	5222	3011505	2003-02-06	2003-02-06 00:00:00	2003-02-06	5001	0	\N	0	0	\N	\N	0	347529	0	19926-5	3011505		
115755	3566	4024958	1982-06-29	1982-06-29 00:00:00	1982-06-29	5001	0	\N	0	0	\N	\N	0	236870	0	117015009	4024958		
130672	4026	4024958	1994-10-11	1994-10-11 00:00:00	1994-10-11	5001	0	\N	0	0	\N	\N	0	267747	0	117015009	4024958		
32046	2919	3011505	2010-11-06	2010-11-06 00:00:00	2010-11-06	5001	0	\N	0	0	\N	\N	0	194635	0	19926-5	3011505		
35280	3224	3009201	2016-12-31	2016-12-31 00:00:00	2016-12-31	5001	0	\N	0	0	\N	\N	0	214381	0	3016-3	3009201		
8842	844	3006322	1972-05-22	1972-05-22 00:00:00	1972-05-22	5001	0	\N	0	0	\N	\N	0	55888	0	8331-1	3006322		
43482	4020	3006322	1975-10-06	1975-10-06 00:00:00	1975-10-06	5001	0	\N	0	0	\N	\N	0	267196	0	8331-1	3006322		
36872	3389	3006322	1996-02-15	1996-02-15 00:00:00	1996-02-15	5001	0	\N	0	0	\N	\N	0	224764	0	8331-1	3006322		
128192	3946	4024958	1988-11-13	1988-11-13 00:00:00	1988-11-13	5001	0	\N	0	0	\N	\N	0	262308	0	117015009	4024958		
152778	4685	4052083	1967-05-12	1967-05-12 00:00:00	1967-05-12	5001	0	\N	0	0	\N	\N	0	312106	0	23426006	4052083		
20152	1845	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	123301	0	6075-6	3005136		
9551	906	3006322	1979-01-07	1979-01-07 00:00:00	1979-01-07	5001	0	\N	0	0	\N	\N	0	60271	0	8331-1	3006322		
18824	1727	3011505	2011-10-27	2011-10-27 00:00:00	2011-10-27	5001	0	\N	0	0	\N	\N	0	115458	0	19926-5	3011505		
7763	744	3006322	2019-03-08	2019-03-08 00:00:00	2019-03-08	5001	0	\N	0	0	\N	\N	0	49332	0	8331-1	3006322		
30297	2778	3036780	1978-02-02	1978-02-02 00:00:00	1978-02-02	5001	0	\N	0	0	\N	\N	0	183994	0	6095-4	3036780		
172742	5300	4052083	2002-12-25	2002-12-25 00:00:00	2002-12-25	5001	0	\N	0	0	\N	\N	0	352606	0	23426006	4052083		
32510	2950	3006322	1936-07-11	1936-07-11 00:00:00	1936-07-11	5001	0	\N	0	0	\N	\N	0	196894	0	8331-1	3006322		
25076	2300	3006322	1977-05-26	1977-05-26 00:00:00	1977-05-26	5001	0	\N	0	0	\N	\N	0	153184	0	8331-1	3006322		
147544	4522	4024958	1988-09-12	1988-09-12 00:00:00	1988-09-12	5001	0	\N	0	0	\N	\N	0	301128	0	117015009	4024958		
3779	358	3006322	1982-02-27	1982-02-27 00:00:00	1982-02-27	5001	0	\N	0	0	\N	\N	0	23828	0	8331-1	3006322		
116968	3604	4052083	1996-03-24	1996-03-24 00:00:00	1996-03-24	5001	0	\N	0	0	\N	\N	0	239476	0	23426006	4052083		
47987	4395	3049273	2013-11-08	2013-11-08 00:00:00	2013-11-08	5001	0	\N	0	0	\N	\N	0	292288	0	38265-5	3049273		
40551	3767	3006322	2011-08-07	2011-08-07 00:00:00	2011-08-07	5001	0	\N	0	0	\N	\N	0	250350	0	8331-1	3006322		
35560	3250	3006322	1977-06-07	1977-06-07 00:00:00	1977-06-07	5001	0	\N	0	0	\N	\N	0	216051	0	8331-1	3006322		
33794	3069	3006322	1997-02-05	1997-02-05 00:00:00	1997-02-05	5001	0	\N	0	0	\N	\N	0	204248	0	8331-1	3006322		
3612	343	3020655	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	22870	0	6844-5	3020655		
58171	5337	3006322	1977-08-17	1977-08-17 00:00:00	1977-08-17	5001	0	\N	0	0	\N	\N	0	355394	0	8331-1	3006322		
2970	285	3020655	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	18965	0	6844-5	3020655		
118190	3638	4052083	2013-02-19	2013-02-19 00:00:00	2013-02-19	5001	0	\N	0	0	\N	\N	0	241946	0	23426006	4052083		
69894	2141	4024958	1956-07-26	1956-07-26 00:00:00	1956-07-26	5001	0	\N	0	0	\N	\N	0	142649	0	117015009	4024958		
4723	449	40769184	1984-11-03	1984-11-03 00:00:00	1984-11-03	5001	0	\N	0	0	\N	\N	0	29946	0	66524-0	40769184		
26313	2419	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	160526	0	7258-7	3001488		
124829	3857	4133840	2018-07-31	2018-07-31 00:00:00	2018-07-31	5001	0	\N	0	0	\N	\N	0	256032	0	127783003	4133840		
121488	3748	4052083	2009-06-14	2009-06-14 00:00:00	2009-06-14	5001	0	\N	0	0	\N	\N	0	249146	0	23426006	4052083		
25631	2349	3001488	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	156377	0	7258-7	3001488		
56952	5222	3006322	1965-06-06	1965-06-06 00:00:00	1965-06-06	5001	0	\N	0	0	\N	\N	0	347486	0	8331-1	3006322		
115768	3567	4052083	2012-03-03	2012-03-03 00:00:00	2012-03-03	5001	0	\N	0	0	\N	\N	0	237052	0	23426006	4052083		
130673	4026	4133840	2015-02-22	2015-02-22 00:00:00	2015-02-22	5001	0	\N	0	0	\N	\N	0	267677	0	127783003	4133840		
32047	2919	3011505	2007-10-06	2007-10-06 00:00:00	2007-10-06	5001	0	\N	0	0	\N	\N	0	194619	0	19926-5	3011505		
35281	3224	3008598	2016-12-31	2016-12-31 00:00:00	2016-12-31	5001	0	\N	0	0	\N	\N	0	214381	0	3024-7	3008598		
8859	847	3006322	1992-01-23	1992-01-23 00:00:00	1992-01-23	5001	0	\N	0	0	\N	\N	0	56092	0	8331-1	3006322		
43483	4020	3006322	1987-01-19	1987-01-19 00:00:00	1987-01-19	5001	0	\N	0	0	\N	\N	0	267221	0	8331-1	3006322		
36873	3389	3006322	2013-12-08	2013-12-08 00:00:00	2013-12-08	5001	0	\N	0	0	\N	\N	0	224790	0	8331-1	3006322		
128197	3946	4024958	1980-06-19	1980-06-19 00:00:00	1980-06-19	5001	0	\N	0	0	\N	\N	0	262306	0	117015009	4024958		
152779	4685	4024958	1948-07-18	1948-07-18 00:00:00	1948-07-18	5001	0	\N	0	0	\N	\N	0	312137	0	117015009	4024958		
20153	1845	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	123301	0	6276-0	3027231		
43499	1338	4052083	1997-02-22	1997-02-22 00:00:00	1997-02-22	5001	0	\N	0	0	\N	\N	0	88688	0	23426006	4052083		
18826	1729	3006322	2018-03-04	2018-03-04 00:00:00	2018-03-04	5001	0	\N	0	0	\N	\N	0	115628	0	8331-1	3006322		
7768	747	3006322	2005-07-07	2005-07-07 00:00:00	2005-07-07	5001	0	\N	0	0	\N	\N	0	49490	0	8331-1	3006322		
30298	2778	3000876	1978-02-02	1978-02-02 00:00:00	1978-02-02	5001	0	\N	0	0	\N	\N	0	183994	0	6082-2	3000876		
135510	4173	4024958	1985-11-22	1985-11-22 00:00:00	1985-11-22	5001	0	\N	0	0	\N	\N	0	277363	0	117015009	4024958		
32511	2950	3006322	1959-09-01	1959-09-01 00:00:00	1959-09-01	5001	0	\N	0	0	\N	\N	0	196979	0	8331-1	3006322		
25077	2300	3011505	1989-11-30	1989-11-30 00:00:00	1989-11-30	5001	0	\N	0	0	\N	\N	0	153196	0	19926-5	3011505		
147546	4522	4024958	1988-08-04	1988-08-04 00:00:00	1988-08-04	5001	0	\N	0	0	\N	\N	0	301109	0	117015009	4024958		
3780	358	3006322	1988-08-16	1988-08-16 00:00:00	1988-08-16	5001	0	\N	0	0	\N	\N	0	23791	0	8331-1	3006322		
9671	310	4052083	1952-02-04	1952-02-04 00:00:00	1952-02-04	5001	0	\N	0	0	\N	\N	0	20500	0	23426006	4052083		
47995	4398	3006322	2013-08-17	2013-08-17 00:00:00	2013-08-17	5001	0	\N	0	0	\N	\N	0	292454	0	8331-1	3006322		
40552	3767	3006322	2019-06-28	2019-06-28 00:00:00	2019-06-28	5001	0	\N	0	0	\N	\N	0	250353	0	8331-1	3006322		
15339	1407	3000876	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	93526	0	6082-2	3000876		
33795	3069	3006322	1966-09-20	1966-09-20 00:00:00	1966-09-20	5001	0	\N	0	0	\N	\N	0	204244	0	8331-1	3006322		
3613	343	3000876	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	22870	0	6082-2	3000876		
58172	5337	3000876	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	355395	0	6082-2	3000876		
2971	285	3001247	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	18965	0	6085-5	3001247		
118191	3638	4024958	1966-07-17	1966-07-17 00:00:00	1966-07-17	5001	0	\N	0	0	\N	\N	0	241969	0	117015009	4024958		
69897	2141	4024958	1949-09-07	1949-09-07 00:00:00	1949-09-07	5001	0	\N	0	0	\N	\N	0	142636	0	117015009	4024958		
4724	449	40769189	1984-11-03	1984-11-03 00:00:00	1984-11-03	5001	0	\N	0	0	\N	\N	0	29946	0	66529-9	40769189		
37591	3464	3027231	2009-05-29	2009-05-29 00:00:00	2009-05-29	5001	0	\N	0	0	\N	\N	0	229905	0	6276-0	3027231		
124832	3857	4133840	1999-07-13	1999-07-13 00:00:00	1999-07-13	5001	0	\N	0	0	\N	\N	0	255994	0	127783003	4133840		
121514	3750	4024958	2001-10-16	2001-10-16 00:00:00	2001-10-16	5001	0	\N	0	0	\N	\N	0	249228	0	117015009	4024958		
25632	2349	3014599	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	156377	0	6106-9	3014599		
56953	5222	3006322	2003-02-01	2003-02-01 00:00:00	2003-02-01	5001	0	\N	0	0	\N	\N	0	347501	0	8331-1	3006322		
115781	3567	4024958	2010-03-01	2010-03-01 00:00:00	2010-03-01	5001	0	\N	0	0	\N	\N	0	237051	0	117015009	4024958		
130676	4026	4133840	2016-02-28	2016-02-28 00:00:00	2016-02-28	5001	0	\N	0	0	\N	\N	0	267759	0	127783003	4133840		
32054	2921	3011505	1985-05-21	1985-05-21 00:00:00	1985-05-21	5001	0	\N	0	0	\N	\N	0	194739	0	19926-5	3011505		
35282	3224	3006322	1960-03-19	1960-03-19 00:00:00	1960-03-19	5001	0	\N	0	0	\N	\N	0	214395	0	8331-1	3006322		
8860	847	3006322	1993-05-29	1993-05-29 00:00:00	1993-05-29	5001	0	\N	0	0	\N	\N	0	56098	0	8331-1	3006322		
43484	4020	3006322	1979-04-04	1979-04-04 00:00:00	1979-04-04	5001	0	\N	0	0	\N	\N	0	267219	0	8331-1	3006322		
36874	3389	3006322	1998-02-12	1998-02-12 00:00:00	1998-02-12	5001	0	\N	0	0	\N	\N	0	224778	0	8331-1	3006322		
128199	3946	4024958	2001-08-02	2001-08-02 00:00:00	2001-08-02	5001	0	\N	0	0	\N	\N	0	262357	0	117015009	4024958		
58294	5343	3006322	1991-03-04	1991-03-04 00:00:00	1991-03-04	5001	0	\N	0	0	\N	\N	0	355861	0	8331-1	3006322		
20154	1845	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	123301	0	6106-9	3014599		
43510	1339	4052083	2018-07-16	2018-07-16 00:00:00	2018-07-16	5001	0	\N	0	0	\N	\N	0	88825	0	23426006	4052083		
18827	1729	3006322	2015-01-03	2015-01-03 00:00:00	2015-01-03	5001	0	\N	0	0	\N	\N	0	115658	0	8331-1	3006322		
7769	747	3006322	1965-05-16	1965-05-16 00:00:00	1965-05-16	5001	0	\N	0	0	\N	\N	0	49467	0	8331-1	3006322		
30299	2778	3015076	1978-02-02	1978-02-02 00:00:00	1978-02-02	5001	0	\N	0	0	\N	\N	0	183994	0	6248-9	3015076		
135527	4173	4024958	1965-10-06	1965-10-06 00:00:00	1965-10-06	5001	0	\N	0	0	\N	\N	0	277340	0	117015009	4024958		
32512	2950	3006322	1991-11-06	1991-11-06 00:00:00	1991-11-06	5001	0	\N	0	0	\N	\N	0	196883	0	8331-1	3006322		
25078	2300	3006322	2001-04-12	2001-04-12 00:00:00	2001-04-12	5001	0	\N	0	0	\N	\N	0	153178	0	8331-1	3006322		
147549	4523	4024958	1978-07-01	1978-07-01 00:00:00	1978-07-01	5001	0	\N	0	0	\N	\N	0	301181	0	117015009	4024958		
30765	2821	3006322	1993-06-25	1993-06-25 00:00:00	1993-06-25	5001	0	\N	0	0	\N	\N	0	186866	0	8331-1	3006322		
9682	310	4024958	1998-01-28	1998-01-28 00:00:00	1998-01-28	5001	0	\N	0	0	\N	\N	0	20508	0	117015009	4024958		
47996	4398	3006322	1994-05-14	1994-05-14 00:00:00	1994-05-14	5001	0	\N	0	0	\N	\N	0	292447	0	8331-1	3006322		
40553	3767	3006322	2017-09-20	2017-09-20 00:00:00	2017-09-20	5001	0	\N	0	0	\N	\N	0	250352	0	8331-1	3006322		
15340	1407	3036780	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	93526	0	6095-4	3036780		
33796	3069	3006322	1967-07-30	1967-07-30 00:00:00	1967-07-30	5001	0	\N	0	0	\N	\N	0	204285	0	8331-1	3006322		
3620	347	3011505	2002-11-10	2002-11-10 00:00:00	2002-11-10	5001	0	\N	0	0	\N	\N	0	23109	0	19926-5	3011505		
58173	5337	3014599	1989-12-31	1989-12-31 00:00:00	1989-12-31	5001	0	\N	0	0	\N	\N	0	355395	0	6106-9	3014599		
2972	285	3014599	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	18983	0	6106-9	3014599		
118192	3638	4052083	1988-09-19	1988-09-19 00:00:00	1988-09-19	5001	0	\N	0	0	\N	\N	0	241990	0	23426006	4052083		
69907	2141	4024958	1947-11-04	1947-11-04 00:00:00	1947-11-04	5001	0	\N	0	0	\N	\N	0	142653	0	117015009	4024958		
4725	449	40769179	1984-11-03	1984-11-03 00:00:00	1984-11-03	5001	0	\N	0	0	\N	\N	0	29946	0	66519-0	40769179		
37592	3464	40769194	2009-05-20	2009-05-20 00:00:00	2009-05-20	5001	0	\N	0	0	\N	\N	0	229998	0	66534-9	40769194		
124835	3857	4133840	2005-08-16	2005-08-16 00:00:00	2005-08-16	5001	0	\N	0	0	\N	\N	0	256002	0	127783003	4133840		
121519	3750	4052083	2003-11-24	2003-11-24 00:00:00	2003-11-24	5001	0	\N	0	0	\N	\N	0	249250	0	23426006	4052083		
25633	2349	3006451	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	156377	0	6273-7	3006451		
56954	5222	3011505	2017-08-17	2017-08-17 00:00:00	2017-08-17	5001	0	\N	0	0	\N	\N	0	347351	0	19926-5	3011505		
115795	3568	4052083	1977-07-15	1977-07-15 00:00:00	1977-07-15	5001	0	\N	0	0	\N	\N	0	237094	0	23426006	4052083		
130682	4026	4133840	2019-06-09	2019-06-09 00:00:00	2019-06-09	5001	0	\N	0	0	\N	\N	0	267679	0	127783003	4133840		
32055	2921	3011505	1995-07-18	1995-07-18 00:00:00	1995-07-18	5001	0	\N	0	0	\N	\N	0	194740	0	19926-5	3011505		
35285	3226	3006322	1971-01-09	1971-01-09 00:00:00	1971-01-09	5001	0	\N	0	0	\N	\N	0	214455	0	8331-1	3006322		
8861	847	3006322	2008-10-27	2008-10-27 00:00:00	2008-10-27	5001	0	\N	0	0	\N	\N	0	56146	0	8331-1	3006322		
43485	4020	3006322	1972-08-08	1972-08-08 00:00:00	1972-08-08	5001	0	\N	0	0	\N	\N	0	267193	0	8331-1	3006322		
48152	4418	3006322	1976-01-18	1976-01-18 00:00:00	1976-01-18	5001	0	\N	0	0	\N	\N	0	293717	0	8331-1	3006322		
128203	3946	4024958	1970-10-27	1970-10-27 00:00:00	1970-10-27	5001	0	\N	0	0	\N	\N	0	262341	0	117015009	4024958		
58295	5343	3006322	2010-04-01	2010-04-01 00:00:00	2010-04-01	5001	0	\N	0	0	\N	\N	0	355826	0	8331-1	3006322		
20155	1845	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	123301	0	6248-9	3015076		
43531	1339	4052083	2001-05-12	2001-05-12 00:00:00	2001-05-12	5001	0	\N	0	0	\N	\N	0	88791	0	23426006	4052083		
18828	1729	3006322	2001-05-05	2001-05-05 00:00:00	2001-05-05	5001	0	\N	0	0	\N	\N	0	115611	0	8331-1	3006322		
7770	747	3006322	1968-11-05	1968-11-05 00:00:00	1968-11-05	5001	0	\N	0	0	\N	\N	0	49468	0	8331-1	3006322		
30300	2778	3006322	2013-07-17	2013-07-17 00:00:00	2013-07-17	5001	0	\N	0	0	\N	\N	0	184068	0	8331-1	3006322		
135535	4173	4024958	1987-06-29	1987-06-29 00:00:00	1987-06-29	5001	0	\N	0	0	\N	\N	0	277343	0	117015009	4024958		
32513	2950	3006322	1948-11-15	1948-11-15 00:00:00	1948-11-15	5001	0	\N	0	0	\N	\N	0	196882	0	8331-1	3006322		
25079	2300	3006322	1953-09-08	1953-09-08 00:00:00	1953-09-08	5001	0	\N	0	0	\N	\N	0	153148	0	8331-1	3006322		
147550	4523	4052083	2004-08-06	2004-08-06 00:00:00	2004-08-06	5001	0	\N	0	0	\N	\N	0	301184	0	23426006	4052083		
30766	2821	3006322	1991-12-17	1991-12-17 00:00:00	1991-12-17	5001	0	\N	0	0	\N	\N	0	186864	0	8331-1	3006322		
9717	311	4052083	1986-09-09	1986-09-09 00:00:00	1986-09-09	5001	0	\N	0	0	\N	\N	0	20628	0	23426006	4052083		
47997	4398	3006322	1964-01-25	1964-01-25 00:00:00	1964-01-25	5001	0	\N	0	0	\N	\N	0	292462	0	8331-1	3006322		
40554	3767	3006322	1986-05-13	1986-05-13 00:00:00	1986-05-13	5001	0	\N	0	0	\N	\N	0	250349	0	8331-1	3006322		
15341	1407	3015076	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	93526	0	6248-9	3015076		
33797	3070	3006322	2016-06-30	2016-06-30 00:00:00	2016-06-30	5001	0	\N	0	0	\N	\N	0	204363	0	8331-1	3006322		
3621	347	3006322	2002-11-22	2002-11-22 00:00:00	2002-11-22	5001	0	\N	0	0	\N	\N	0	23100	0	8331-1	3006322		
82847	2556	4024958	2012-01-16	2012-01-16 00:00:00	2012-01-16	5001	0	\N	0	0	\N	\N	0	169396	0	117015009	4024958		
2973	285	3006451	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	18983	0	6273-7	3006451		
118205	3639	4024958	1960-07-11	1960-07-11 00:00:00	1960-07-11	5001	0	\N	0	0	\N	\N	0	242062	0	117015009	4024958		
69947	2145	4052083	1978-07-27	1978-07-27 00:00:00	1978-07-27	5001	0	\N	0	0	\N	\N	0	142791	0	23426006	4052083		
4726	449	3011505	1998-12-17	1998-12-17 00:00:00	1998-12-17	5001	0	\N	0	0	\N	\N	0	29869	0	19926-5	3011505		
37593	3464	40769184	2009-05-20	2009-05-20 00:00:00	2009-05-20	5001	0	\N	0	0	\N	\N	0	229998	0	66524-0	40769184		
124838	3857	4133840	2011-09-20	2011-09-20 00:00:00	2011-09-20	5001	0	\N	0	0	\N	\N	0	256023	0	127783003	4133840		
121530	3750	4024958	1977-11-23	1977-11-23 00:00:00	1977-11-23	5001	0	\N	0	0	\N	\N	0	249225	0	117015009	4024958		
25634	2349	3005136	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	156377	0	6075-6	3005136		
56955	5222	3011505	2015-04-16	2015-04-16 00:00:00	2015-04-16	5001	0	\N	0	0	\N	\N	0	347468	0	19926-5	3011505		
115809	3568	4024958	1984-01-15	1984-01-15 00:00:00	1984-01-15	5001	0	\N	0	0	\N	\N	0	237095	0	117015009	4024958		
130683	4026	4133840	2017-03-05	2017-03-05 00:00:00	2017-03-05	5001	0	\N	0	0	\N	\N	0	267678	0	127783003	4133840		
32056	2921	3011505	1984-07-03	1984-07-03 00:00:00	1984-07-03	5001	0	\N	0	0	\N	\N	0	194764	0	19926-5	3011505		
35286	3226	3006322	1969-10-02	1969-10-02 00:00:00	1969-10-02	5001	0	\N	0	0	\N	\N	0	214438	0	8331-1	3006322		
8862	847	3006322	2008-05-22	2008-05-22 00:00:00	2008-05-22	5001	0	\N	0	0	\N	\N	0	56099	0	8331-1	3006322		
43486	4020	3006322	1991-03-08	1991-03-08 00:00:00	1991-03-08	5001	0	\N	0	0	\N	\N	0	267256	0	8331-1	3006322		
48153	4418	3006322	1961-06-23	1961-06-23 00:00:00	1961-06-23	5001	0	\N	0	0	\N	\N	0	293780	0	8331-1	3006322		
128204	3946	4024958	1963-10-07	1963-10-07 00:00:00	1963-10-07	5001	0	\N	0	0	\N	\N	0	262339	0	117015009	4024958		
58296	5343	3006322	2009-04-22	2009-04-22 00:00:00	2009-04-22	5001	0	\N	0	0	\N	\N	0	355825	0	8331-1	3006322		
20156	1845	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	123301	0	6273-7	3006451		
43533	1340	4052083	1916-06-04	1916-06-04 00:00:00	1916-06-04	5001	0	\N	0	0	\N	\N	0	88934	0	23426006	4052083		
18869	1733	3006322	2005-03-16	2005-03-16 00:00:00	2005-03-16	5001	0	\N	0	0	\N	\N	0	115837	0	8331-1	3006322		
7794	752	40766240	1963-01-05	1963-01-05 00:00:00	1963-01-05	5001	0	\N	0	0	\N	\N	0	49704	0	63513-6	40766240		
30301	2778	3006322	1994-05-06	1994-05-06 00:00:00	1994-05-06	5001	0	\N	0	0	\N	\N	0	184044	0	8331-1	3006322		
97324	2976	4133840	2003-07-17	2003-07-17 00:00:00	2003-07-17	5001	0	\N	0	0	\N	\N	0	198774	0	127783003	4133840		
32514	2950	3006322	2011-09-15	2011-09-15 00:00:00	2011-09-15	5001	0	\N	0	0	\N	\N	0	196900	0	8331-1	3006322		
25080	2300	3011505	1999-12-23	1999-12-23 00:00:00	1999-12-23	5001	0	\N	0	0	\N	\N	0	153149	0	19926-5	3011505		
1812	160	46235214	1962-12-24	1962-12-24 00:00:00	1962-12-24	5001	0	\N	0	0	\N	\N	0	10935	0	76690-7	46235214		
30767	2821	3006322	1927-03-14	1927-03-14 00:00:00	1927-03-14	5001	0	\N	0	0	\N	\N	0	186947	0	8331-1	3006322		
9722	311	4024958	2005-10-23	2005-10-23 00:00:00	2005-10-23	5001	0	\N	0	0	\N	\N	0	20603	0	117015009	4024958		
47998	4398	3006322	1965-01-31	1965-01-31 00:00:00	1965-01-31	5001	0	\N	0	0	\N	\N	0	292436	0	8331-1	3006322		
76712	2351	4024958	1953-05-26	1953-05-26 00:00:00	1953-05-26	5001	0	\N	0	0	\N	\N	0	156500	0	117015009	4024958		
15342	1407	3027231	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	93526	0	6276-0	3027231		
33798	3070	3006322	1978-06-08	1978-06-08 00:00:00	1978-06-08	5001	0	\N	0	0	\N	\N	0	204383	0	8331-1	3006322		
3622	347	3011505	2012-11-25	2012-11-25 00:00:00	2012-11-25	5001	0	\N	0	0	\N	\N	0	23098	0	19926-5	3011505		
82850	2556	4024958	1981-05-17	1981-05-17 00:00:00	1981-05-17	5001	0	\N	0	0	\N	\N	0	169420	0	117015009	4024958		
2974	285	3001488	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	18983	0	7258-7	3001488		
118208	3639	4024958	1928-02-14	1928-02-14 00:00:00	1928-02-14	5001	0	\N	0	0	\N	\N	0	242125	0	117015009	4024958		
69949	2145	4024958	1971-05-30	1971-05-30 00:00:00	1971-05-30	5001	0	\N	0	0	\N	\N	0	142790	0	117015009	4024958		
4727	449	3011505	1999-11-11	1999-11-11 00:00:00	1999-11-11	5001	0	\N	0	0	\N	\N	0	29982	0	19926-5	3011505		
37594	3464	40769189	2009-05-20	2009-05-20 00:00:00	2009-05-20	5001	0	\N	0	0	\N	\N	0	229998	0	66529-9	40769189		
124840	3857	4052083	1972-05-25	1972-05-25 00:00:00	1972-05-25	5001	0	\N	0	0	\N	\N	0	255982	0	23426006	4052083		
121538	3750	4024958	1990-10-05	1990-10-05 00:00:00	1990-10-05	5001	0	\N	0	0	\N	\N	0	249246	0	117015009	4024958		
25635	2349	3006734	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	156377	0	6189-5	3006734		
56956	5222	3006322	1956-05-24	1956-05-24 00:00:00	1956-05-24	5001	0	\N	0	0	\N	\N	0	347485	0	8331-1	3006322		
88753	2749	4024958	1972-08-14	1972-08-14 00:00:00	1972-08-14	5001	0	\N	0	0	\N	\N	0	181791	0	117015009	4024958		
130685	4026	4133840	2018-03-11	2018-03-11 00:00:00	2018-03-11	5001	0	\N	0	0	\N	\N	0	267760	0	127783003	4133840		
32057	2921	3011505	2003-09-02	2003-09-02 00:00:00	2003-09-02	5001	0	\N	0	0	\N	\N	0	194760	0	19926-5	3011505		
35287	3226	3006322	2004-10-24	2004-10-24 00:00:00	2004-10-24	5001	0	\N	0	0	\N	\N	0	214476	0	8331-1	3006322		
43395	4013	3006322	1989-04-20	1989-04-20 00:00:00	1989-04-20	5001	0	\N	0	0	\N	\N	0	266668	0	8331-1	3006322		
43487	4020	3006322	1979-07-15	1979-07-15 00:00:00	1979-07-15	5001	0	\N	0	0	\N	\N	0	267197	0	8331-1	3006322		
48154	4418	3006322	2010-02-22	2010-02-22 00:00:00	2010-02-22	5001	0	\N	0	0	\N	\N	0	293722	0	8331-1	3006322		
128207	3946	4024958	1965-02-14	1965-02-14 00:00:00	1965-02-14	5001	0	\N	0	0	\N	\N	0	262305	0	117015009	4024958		
58297	5343	3006734	1996-01-07	1996-01-07 00:00:00	1996-01-07	5001	0	\N	0	0	\N	\N	0	355877	0	6189-5	3006734		
20157	1845	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	123301	0	6844-5	3020655		
169732	5210	4024958	2013-07-03	2013-07-03 00:00:00	2013-07-03	5001	0	\N	0	0	\N	\N	0	346468	0	117015009	4024958		
18870	1733	3006322	2008-02-11	2008-02-11 00:00:00	2008-02-11	5001	0	\N	0	0	\N	\N	0	115843	0	8331-1	3006322		
7795	752	3051031	1963-01-05	1963-01-05 00:00:00	1963-01-05	5001	0	\N	0	0	\N	\N	0	49704	0	46240-8	3051031		
30302	2778	3014599	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	184015	0	6106-9	3014599		
97326	2976	4133840	1981-04-16	1981-04-16 00:00:00	1981-04-16	5001	0	\N	0	0	\N	\N	0	198770	0	127783003	4133840		
32517	2950	3006322	1952-11-23	1952-11-23 00:00:00	1952-11-23	5001	0	\N	0	0	\N	\N	0	196955	0	8331-1	3006322		
25081	2300	3011505	2016-03-24	2016-03-24 00:00:00	2016-03-24	5001	0	\N	0	0	\N	\N	0	153146	0	19926-5	3011505		
1815	160	3051031	1962-12-24	1962-12-24 00:00:00	1962-12-24	5001	0	\N	0	0	\N	\N	0	10935	0	46240-8	3051031		
30769	2822	3006322	1999-06-10	1999-06-10 00:00:00	1999-06-10	5001	0	\N	0	0	\N	\N	0	187012	0	8331-1	3006322		
9730	311	4024958	1980-09-10	1980-09-10 00:00:00	1980-09-10	5001	0	\N	0	0	\N	\N	0	20583	0	117015009	4024958		
47999	4398	3006322	2017-08-11	2017-08-11 00:00:00	2017-08-11	5001	0	\N	0	0	\N	\N	0	292467	0	8331-1	3006322		
76714	2351	4024958	1959-01-07	1959-01-07 00:00:00	1959-01-07	5001	0	\N	0	0	\N	\N	0	156513	0	117015009	4024958		
15343	1407	3014599	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	93526	0	6106-9	3014599		
33799	3070	3006322	2014-03-30	2014-03-30 00:00:00	2014-03-30	5001	0	\N	0	0	\N	\N	0	204369	0	8331-1	3006322		
3623	347	3011505	1999-11-07	1999-11-07 00:00:00	1999-11-07	5001	0	\N	0	0	\N	\N	0	23108	0	19926-5	3011505		
94183	2897	4024958	1983-12-13	1983-12-13 00:00:00	1983-12-13	5001	0	\N	0	0	\N	\N	0	192889	0	117015009	4024958		
2975	285	3023430	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	18983	0	6833-8	3023430		
118235	3639	4052083	1999-12-27	1999-12-27 00:00:00	1999-12-27	5001	0	\N	0	0	\N	\N	0	242171	0	23426006	4052083		
69952	2145	4024958	1974-02-23	1974-02-23 00:00:00	1974-02-23	5001	0	\N	0	0	\N	\N	0	142813	0	117015009	4024958		
4728	449	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	29947	0	6246-3	3021226		
37595	3464	40769179	2009-05-20	2009-05-20 00:00:00	2009-05-20	5001	0	\N	0	0	\N	\N	0	229998	0	66519-0	40769179		
124841	3857	4024958	1954-10-11	1954-10-11 00:00:00	1954-10-11	5001	0	\N	0	0	\N	\N	0	255979	0	117015009	4024958		
155926	4788	4024958	1985-02-18	1985-02-18 00:00:00	1985-02-18	5001	0	\N	0	0	\N	\N	0	318649	0	117015009	4024958		
25636	2349	3023430	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	156377	0	6833-8	3023430		
56957	5222	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	347357	0	6189-5	3006734		
88767	2750	4024958	1973-09-25	1973-09-25 00:00:00	1973-09-25	5001	0	\N	0	0	\N	\N	0	181888	0	117015009	4024958		
130691	4026	4052083	2013-06-05	2013-06-05 00:00:00	2013-06-05	5001	0	\N	0	0	\N	\N	0	267599	0	23426006	4052083		
32058	2921	3011505	2014-11-04	2014-11-04 00:00:00	2014-11-04	5001	0	\N	0	0	\N	\N	0	194762	0	19926-5	3011505		
35288	3227	3006322	1974-03-02	1974-03-02 00:00:00	1974-03-02	5001	0	\N	0	0	\N	\N	0	214529	0	8331-1	3006322		
43396	4013	3006322	1990-05-29	1990-05-29 00:00:00	1990-05-29	5001	0	\N	0	0	\N	\N	0	266649	0	8331-1	3006322		
43488	4021	3006322	1999-03-14	1999-03-14 00:00:00	1999-03-14	5001	0	\N	0	0	\N	\N	0	267294	0	8331-1	3006322		
48155	4419	3051031	1957-04-18	1957-04-18 00:00:00	1957-04-18	5001	0	\N	0	0	\N	\N	0	293861	0	46240-8	3051031		
128210	3946	4024958	1989-07-22	1989-07-22 00:00:00	1989-07-22	5001	0	\N	0	0	\N	\N	0	262315	0	117015009	4024958		
58298	5343	3001488	1996-01-07	1996-01-07 00:00:00	1996-01-07	5001	0	\N	0	0	\N	\N	0	355877	0	7258-7	3001488		
20158	1845	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	123301	0	6833-8	3023430		
112637	3477	4024958	1988-03-18	1988-03-18 00:00:00	1988-03-18	5001	0	\N	0	0	\N	\N	0	230632	0	117015009	4024958		
139791	4309	4052083	1963-01-20	1963-01-20 00:00:00	1963-01-20	5001	0	\N	0	0	\N	\N	0	285894	0	23426006	4052083		
7797	752	40758406	1963-01-05	1963-01-05 00:00:00	1963-01-05	5001	0	\N	0	0	\N	\N	0	49704	0	55277-8	40758406		
30303	2778	3006734	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	184015	0	6189-5	3006734		
97328	2976	4133840	1999-07-08	1999-07-08 00:00:00	1999-07-08	5001	0	\N	0	0	\N	\N	0	198730	0	127783003	4133840		
32518	2950	3006322	1993-01-13	1993-01-13 00:00:00	1993-01-13	5001	0	\N	0	0	\N	\N	0	196989	0	8331-1	3006322		
25082	2300	3011505	1972-12-07	1972-12-07 00:00:00	1972-12-07	5001	0	\N	0	0	\N	\N	0	153198	0	19926-5	3011505		
1816	160	3006322	1998-05-31	1998-05-31 00:00:00	1998-05-31	5001	0	\N	0	0	\N	\N	0	10980	0	8331-1	3006322		
30770	2822	3006322	2007-12-05	2007-12-05 00:00:00	2007-12-05	5001	0	\N	0	0	\N	\N	0	186979	0	8331-1	3006322		
9739	311	4052083	1993-11-10	1993-11-10 00:00:00	1993-11-10	5001	0	\N	0	0	\N	\N	0	20637	0	23426006	4052083		
48003	4401	3006322	1974-03-13	1974-03-13 00:00:00	1974-03-13	5001	0	\N	0	0	\N	\N	0	292544	0	8331-1	3006322		
76720	2351	4024958	1962-02-15	1962-02-15 00:00:00	1962-02-15	5001	0	\N	0	0	\N	\N	0	156584	0	117015009	4024958		
15344	1407	3019406	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	93526	0	6158-0	3019406		
33800	3070	3006322	1969-12-09	1969-12-09 00:00:00	1969-12-09	5001	0	\N	0	0	\N	\N	0	204360	0	8331-1	3006322		
3624	347	3011505	2014-11-30	2014-11-30 00:00:00	2014-11-30	5001	0	\N	0	0	\N	\N	0	23089	0	19926-5	3011505		
94184	2897	4052083	1985-12-30	1985-12-30 00:00:00	1985-12-30	5001	0	\N	0	0	\N	\N	0	192938	0	23426006	4052083		
2976	285	3015076	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	18983	0	6248-9	3015076		
15375	480	4052083	1958-10-13	1958-10-13 00:00:00	1958-10-13	5001	0	\N	0	0	\N	\N	0	31986	0	23426006	4052083		
69955	2145	4024958	2013-08-09	2013-08-09 00:00:00	2013-08-09	5001	0	\N	0	0	\N	\N	0	142802	0	117015009	4024958		
4729	449	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	29947	0	6158-0	3019406		
37596	3464	3021226	2012-11-30	2012-11-30 00:00:00	2012-11-30	5001	0	\N	0	0	\N	\N	0	229943	0	6246-3	3021226		
124844	3857	4133840	2016-07-19	2016-07-19 00:00:00	2016-07-19	5001	0	\N	0	0	\N	\N	0	256025	0	127783003	4133840		
155930	4788	4024958	1989-04-11	1989-04-11 00:00:00	1989-04-11	5001	0	\N	0	0	\N	\N	0	318650	0	117015009	4024958		
25637	2349	3020655	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	156377	0	6844-5	3020655		
56958	5222	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	347357	0	6833-8	3023430		
88768	2750	4024958	2000-09-10	2000-09-10 00:00:00	2000-09-10	5001	0	\N	0	0	\N	\N	0	181922	0	117015009	4024958		
130695	4026	4133840	2019-03-17	2019-03-17 00:00:00	2019-03-17	5001	0	\N	0	0	\N	\N	0	267602	0	127783003	4133840		
32059	2921	3011505	2009-10-06	2009-10-06 00:00:00	2009-10-06	5001	0	\N	0	0	\N	\N	0	194705	0	19926-5	3011505		
35289	3227	3006322	1982-03-07	1982-03-07 00:00:00	1982-03-07	5001	0	\N	0	0	\N	\N	0	214502	0	8331-1	3006322		
43397	4013	3006322	1996-05-12	1996-05-12 00:00:00	1996-05-12	5001	0	\N	0	0	\N	\N	0	266650	0	8331-1	3006322		
43489	4021	3006322	1970-10-02	1970-10-02 00:00:00	1970-10-02	5001	0	\N	0	0	\N	\N	0	267277	0	8331-1	3006322		
48158	4419	46235214	1957-04-18	1957-04-18 00:00:00	1957-04-18	5001	0	\N	0	0	\N	\N	0	293861	0	76690-7	46235214		
58299	5343	3005136	1996-01-07	1996-01-07 00:00:00	1996-01-07	5001	0	\N	0	0	\N	\N	0	355877	0	6075-6	3005136		
20159	1845	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	123301	0	7258-7	3001488		
112650	3477	4024958	1976-04-22	1976-04-22 00:00:00	1976-04-22	5001	0	\N	0	0	\N	\N	0	230689	0	117015009	4024958		
151082	4631	4052083	1913-10-09	1913-10-09 00:00:00	1913-10-09	5001	0	\N	0	0	\N	\N	0	308600	0	23426006	4052083		
7798	752	46235214	1963-01-05	1963-01-05 00:00:00	1963-01-05	5001	0	\N	0	0	\N	\N	0	49704	0	76690-7	46235214		
30304	2778	3021226	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	184015	0	6246-3	3021226		
97329	2976	4133840	1997-07-03	1997-07-03 00:00:00	1997-07-03	5001	0	\N	0	0	\N	\N	0	198762	0	127783003	4133840		
32520	2950	3006322	1983-08-12	1983-08-12 00:00:00	1983-08-12	5001	0	\N	0	0	\N	\N	0	196982	0	8331-1	3006322		
25083	2300	3011505	2010-02-18	2010-02-18 00:00:00	2010-02-18	5001	0	\N	0	0	\N	\N	0	153134	0	19926-5	3011505		
1817	161	3006322	2012-05-26	2012-05-26 00:00:00	2012-05-26	5001	0	\N	0	0	\N	\N	0	11047	0	8331-1	3006322		
30771	2822	3006322	1998-03-01	1998-03-01 00:00:00	1998-03-01	5001	0	\N	0	0	\N	\N	0	187011	0	8331-1	3006322		
9744	312	4024958	1975-01-12	1975-01-12 00:00:00	1975-01-12	5001	0	\N	0	0	\N	\N	0	20670	0	117015009	4024958		
48004	4401	3006322	2013-01-26	2013-01-26 00:00:00	2013-01-26	5001	0	\N	0	0	\N	\N	0	292593	0	8331-1	3006322		
76724	2351	4024958	1998-02-27	1998-02-27 00:00:00	1998-02-27	5001	0	\N	0	0	\N	\N	0	156518	0	117015009	4024958		
15345	1407	3006451	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	93526	0	6273-7	3006451		
33801	3070	3006322	1994-09-29	1994-09-29 00:00:00	1994-09-29	5001	0	\N	0	0	\N	\N	0	204386	0	8331-1	3006322		
3625	347	3011505	2018-12-09	2018-12-09 00:00:00	2018-12-09	5001	0	\N	0	0	\N	\N	0	23081	0	19926-5	3011505		
94190	2897	4052083	1974-06-22	1974-06-22 00:00:00	1974-06-22	5001	0	\N	0	0	\N	\N	0	192937	0	23426006	4052083		
2977	285	3012494	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	18983	0	6206-7	3012494		
15386	480	4052083	2004-04-11	2004-04-11 00:00:00	2004-04-11	5001	0	\N	0	0	\N	\N	0	32110	0	23426006	4052083		
69957	2145	4052083	1993-09-09	1993-09-09 00:00:00	1993-09-09	5001	0	\N	0	0	\N	\N	0	142814	0	23426006	4052083		
4730	449	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	29947	0	7258-7	3001488		
37597	3464	3000876	2012-11-30	2012-11-30 00:00:00	2012-11-30	5001	0	\N	0	0	\N	\N	0	229943	0	6082-2	3000876		
124845	3857	4133840	2003-08-05	2003-08-05 00:00:00	2003-08-05	5001	0	\N	0	0	\N	\N	0	255996	0	127783003	4133840		
28594	2644	3006322	1985-01-19	1985-01-19 00:00:00	1985-01-19	5001	0	\N	0	0	\N	\N	0	174974	0	8331-1	3006322		
25638	2349	3006322	2016-09-01	2016-09-01 00:00:00	2016-09-01	5001	0	\N	0	0	\N	\N	0	156334	0	8331-1	3006322		
56959	5222	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	347357	0	6844-5	3020655		
88769	2750	4052083	1935-03-18	1935-03-18 00:00:00	1935-03-18	5001	0	\N	0	0	\N	\N	0	181886	0	23426006	4052083		
130699	4026	4133840	2013-02-10	2013-02-10 00:00:00	2013-02-10	5001	0	\N	0	0	\N	\N	0	267656	0	127783003	4133840		
32060	2921	3011505	1999-08-10	1999-08-10 00:00:00	1999-08-10	5001	0	\N	0	0	\N	\N	0	194742	0	19926-5	3011505		
35290	3227	3006322	2009-09-05	2009-09-05 00:00:00	2009-09-05	5001	0	\N	0	0	\N	\N	0	214525	0	8331-1	3006322		
43398	4013	3006322	1976-09-09	1976-09-09 00:00:00	1976-09-09	5001	0	\N	0	0	\N	\N	0	266639	0	8331-1	3006322		
43490	4021	3006322	1960-12-12	1960-12-12 00:00:00	1960-12-12	5001	0	\N	0	0	\N	\N	0	267290	0	8331-1	3006322		
48159	4419	40758406	1957-04-18	1957-04-18 00:00:00	1957-04-18	5001	0	\N	0	0	\N	\N	0	293861	0	55277-8	40758406		
58300	5343	3023430	1996-01-07	1996-01-07 00:00:00	1996-01-07	5001	0	\N	0	0	\N	\N	0	355877	0	6833-8	3023430		
20160	1845	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	123301	0	6206-7	3012494		
173748	5329	4052083	1977-05-01	1977-05-01 00:00:00	1977-05-01	5001	0	\N	0	0	\N	\N	0	354749	0	23426006	4052083		
151092	4631	4024958	1924-05-09	1924-05-09 00:00:00	1924-05-09	5001	0	\N	0	0	\N	\N	0	308602	0	117015009	4024958		
81872	2535	4024958	1961-10-29	1961-10-29 00:00:00	1961-10-29	5001	0	\N	0	0	\N	\N	0	167488	0	117015009	4024958		
30305	2778	3027231	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	184015	0	6276-0	3027231		
97332	2976	4133840	2009-10-29	2009-10-29 00:00:00	2009-10-29	5001	0	\N	0	0	\N	\N	0	198733	0	127783003	4133840		
32521	2951	3006322	1962-03-31	1962-03-31 00:00:00	1962-03-31	5001	0	\N	0	0	\N	\N	0	197064	0	8331-1	3006322		
25084	2300	3011505	2005-01-20	2005-01-20 00:00:00	2005-01-20	5001	0	\N	0	0	\N	\N	0	153144	0	19926-5	3011505		
1818	162	3006322	1968-10-18	1968-10-18 00:00:00	1968-10-18	5001	0	\N	0	0	\N	\N	0	11107	0	8331-1	3006322		
42066	3891	3005136	1999-06-02	1999-06-02 00:00:00	1999-06-02	5001	0	\N	0	0	\N	\N	0	258689	0	6075-6	3005136		
114465	3528	4024958	1963-10-12	1963-10-12 00:00:00	1963-10-12	5001	0	\N	0	0	\N	\N	0	234228	0	117015009	4024958		
48005	4401	3006322	1993-03-15	1993-03-15 00:00:00	1993-03-15	5001	0	\N	0	0	\N	\N	0	292548	0	8331-1	3006322		
111191	3435	4024958	1994-02-18	1994-02-18 00:00:00	1994-02-18	5001	0	\N	0	0	\N	\N	0	227776	0	117015009	4024958		
15346	1407	3012494	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	93526	0	6206-7	3012494		
33803	3072	3006322	1987-11-26	1987-11-26 00:00:00	1987-11-26	5001	0	\N	0	0	\N	\N	0	204493	0	8331-1	3006322		
3626	347	3011505	2016-12-04	2016-12-04 00:00:00	2016-12-04	5001	0	\N	0	0	\N	\N	0	23112	0	19926-5	3011505		
94192	2897	4024958	1998-03-11	1998-03-11 00:00:00	1998-03-11	5001	0	\N	0	0	\N	\N	0	192925	0	117015009	4024958		
2978	285	3021226	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	18983	0	6246-3	3021226		
26674	836	4052083	2001-01-29	2001-01-29 00:00:00	2001-01-29	5001	0	\N	0	0	\N	\N	0	55310	0	23426006	4052083		
69961	2145	4052083	1968-06-29	1968-06-29 00:00:00	1968-06-29	5001	0	\N	0	0	\N	\N	0	142785	0	23426006	4052083		
4731	449	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	29947	0	6085-5	3001247		
37598	3464	3001247	2012-11-30	2012-11-30 00:00:00	2012-11-30	5001	0	\N	0	0	\N	\N	0	229943	0	6085-5	3001247		
124849	3857	4133840	1969-03-11	1969-03-11 00:00:00	1969-03-11	5001	0	\N	0	0	\N	\N	0	256053	0	127783003	4133840		
28599	2646	3006322	1998-07-05	1998-07-05 00:00:00	1998-07-05	5001	0	\N	0	0	\N	\N	0	175091	0	8331-1	3006322		
25639	2349	3006322	2013-12-01	2013-12-01 00:00:00	2013-12-01	5001	0	\N	0	0	\N	\N	0	156452	0	8331-1	3006322		
56960	5222	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	347357	0	6106-9	3014599		
88780	2750	4052083	1997-02-03	1997-02-03 00:00:00	1997-02-03	5001	0	\N	0	0	\N	\N	0	181880	0	23426006	4052083		
130713	4026	4024958	1980-07-14	1980-07-14 00:00:00	1980-07-14	5001	0	\N	0	0	\N	\N	0	267663	0	117015009	4024958		
32061	2921	3011505	2012-10-23	2012-10-23 00:00:00	2012-10-23	5001	0	\N	0	0	\N	\N	0	194745	0	19926-5	3011505		
35291	3227	3006322	1994-03-14	1994-03-14 00:00:00	1994-03-14	5001	0	\N	0	0	\N	\N	0	214512	0	8331-1	3006322		
43399	4013	3006322	2011-03-06	2011-03-06 00:00:00	2011-03-06	5001	0	\N	0	0	\N	\N	0	266651	0	8331-1	3006322		
43491	4021	3006322	1987-10-03	1987-10-03 00:00:00	1987-10-03	5001	0	\N	0	0	\N	\N	0	267293	0	8331-1	3006322		
48160	4419	40766240	1957-04-18	1957-04-18 00:00:00	1957-04-18	5001	0	\N	0	0	\N	\N	0	293861	0	63513-6	40766240		
58301	5343	3020655	1996-01-07	1996-01-07 00:00:00	1996-01-07	5001	0	\N	0	0	\N	\N	0	355877	0	6844-5	3020655		
20161	1845	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	123301	0	6082-2	3000876		
173802	5331	4024958	1965-11-18	1965-11-18 00:00:00	1965-11-18	5001	0	\N	0	0	\N	\N	0	354916	0	117015009	4024958		
151096	4631	4024958	1948-06-06	1948-06-06 00:00:00	1948-06-06	5001	0	\N	0	0	\N	\N	0	308582	0	117015009	4024958		
81875	2535	4024958	1994-12-04	1994-12-04 00:00:00	1994-12-04	5001	0	\N	0	0	\N	\N	0	167554	0	117015009	4024958		
30306	2778	3001488	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	184015	0	7258-7	3001488		
97335	2976	4133840	2017-08-03	2017-08-03 00:00:00	2017-08-03	5001	0	\N	0	0	\N	\N	0	198752	0	127783003	4133840		
32523	2953	3006322	1988-05-17	1988-05-17 00:00:00	1988-05-17	5001	0	\N	0	0	\N	\N	0	197122	0	8331-1	3006322		
25085	2300	3011505	2009-02-12	2009-02-12 00:00:00	2009-02-12	5001	0	\N	0	0	\N	\N	0	153151	0	19926-5	3011505		
1819	162	3006322	1951-06-19	1951-06-19 00:00:00	1951-06-19	5001	0	\N	0	0	\N	\N	0	11083	0	8331-1	3006322		
42067	3891	3019406	1999-06-02	1999-06-02 00:00:00	1999-06-02	5001	0	\N	0	0	\N	\N	0	258689	0	6158-0	3019406		
114475	3528	4024958	1989-02-18	1989-02-18 00:00:00	1989-02-18	5001	0	\N	0	0	\N	\N	0	234262	0	117015009	4024958		
48006	4401	3006322	2010-11-25	2010-11-25 00:00:00	2010-11-25	5001	0	\N	0	0	\N	\N	0	292567	0	8331-1	3006322		
111218	3436	4024958	1987-01-23	1987-01-23 00:00:00	1987-01-23	5001	0	\N	0	0	\N	\N	0	227863	0	117015009	4024958		
15347	1407	3006734	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	93526	0	6189-5	3006734		
33804	3072	3006322	1969-12-09	1969-12-09 00:00:00	1969-12-09	5001	0	\N	0	0	\N	\N	0	204485	0	8331-1	3006322		
3627	347	3006322	1998-12-27	1998-12-27 00:00:00	1998-12-27	5001	0	\N	0	0	\N	\N	0	23099	0	8331-1	3006322		
94196	2897	4052083	1977-02-21	1977-02-21 00:00:00	1977-02-21	5001	0	\N	0	0	\N	\N	0	192948	0	23426006	4052083		
2979	285	3036780	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	18983	0	6095-4	3036780		
26689	836	4052083	1983-06-11	1983-06-11 00:00:00	1983-06-11	5001	0	\N	0	0	\N	\N	0	55328	0	23426006	4052083		
61096	1867	4024958	1985-01-01	1985-01-01 00:00:00	1985-01-01	5001	0	\N	0	0	\N	\N	0	124704	0	117015009	4024958		
4732	449	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	29947	0	6248-9	3015076		
37599	3464	3005136	2012-11-30	2012-11-30 00:00:00	2012-11-30	5001	0	\N	0	0	\N	\N	0	229943	0	6075-6	3005136		
124851	3857	4133840	2012-09-25	2012-09-25 00:00:00	2012-09-25	5001	0	\N	0	0	\N	\N	0	255997	0	127783003	4133840		
28600	2646	3006322	1979-03-21	1979-03-21 00:00:00	1979-03-21	5001	0	\N	0	0	\N	\N	0	175044	0	8331-1	3006322		
25643	2351	3006322	1962-02-15	1962-02-15 00:00:00	1962-02-15	5001	0	\N	0	0	\N	\N	0	156584	0	8331-1	3006322		
56961	5222	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	347357	0	6276-0	3027231		
100076	3070	4024958	1978-06-08	1978-06-08 00:00:00	1978-06-08	5001	0	\N	0	0	\N	\N	0	204383	0	117015009	4024958		
130721	4026	4133840	2012-02-05	2012-02-05 00:00:00	2012-02-05	5001	0	\N	0	0	\N	\N	0	267676	0	127783003	4133840		
32062	2921	3011505	1989-05-30	1989-05-30 00:00:00	1989-05-30	5001	0	\N	0	0	\N	\N	0	194700	0	19926-5	3011505		
35299	3229	3006322	1991-04-10	1991-04-10 00:00:00	1991-04-10	5001	0	\N	0	0	\N	\N	0	214591	0	8331-1	3006322		
43400	4014	3014599	2001-06-12	2001-06-12 00:00:00	2001-06-12	5001	0	\N	0	0	\N	\N	0	266725	0	6106-9	3014599		
43492	4021	3006322	1974-06-28	1974-06-28 00:00:00	1974-06-28	5001	0	\N	0	0	\N	\N	0	267307	0	8331-1	3006322		
48162	4419	46235214	1957-05-18	1957-05-18 00:00:00	1957-05-18	5001	0	\N	0	0	\N	\N	0	293845	0	76690-7	46235214		
58302	5343	3021226	1996-01-07	1996-01-07 00:00:00	1996-01-07	5001	0	\N	0	0	\N	\N	0	355877	0	6246-3	3021226		
20162	1845	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	123301	0	6158-0	3019406		
173807	5331	4024958	2015-04-06	2015-04-06 00:00:00	2015-04-06	5001	0	\N	0	0	\N	\N	0	354961	0	117015009	4024958		
151114	4631	4024958	2009-09-08	2009-09-08 00:00:00	2009-09-08	5001	0	\N	0	0	\N	\N	0	308643	0	117015009	4024958		
81876	2535	4024958	1998-12-26	1998-12-26 00:00:00	1998-12-26	5001	0	\N	0	0	\N	\N	0	167496	0	117015009	4024958		
30307	2778	3020655	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	184015	0	6844-5	3020655		
97337	2976	4133840	2013-07-11	2013-07-11 00:00:00	2013-07-11	5001	0	\N	0	0	\N	\N	0	198749	0	127783003	4133840		
32524	2953	3006322	1993-12-14	1993-12-14 00:00:00	1993-12-14	5001	0	\N	0	0	\N	\N	0	197130	0	8331-1	3006322		
25086	2300	3011505	2003-01-09	2003-01-09 00:00:00	2003-01-09	5001	0	\N	0	0	\N	\N	0	153143	0	19926-5	3011505		
1820	162	3006322	1980-07-26	1980-07-26 00:00:00	1980-07-26	5001	0	\N	0	0	\N	\N	0	11163	0	8331-1	3006322		
42068	3891	3014599	1999-06-02	1999-06-02 00:00:00	1999-06-02	5001	0	\N	0	0	\N	\N	0	258689	0	6106-9	3014599		
83	2	4133840	1992-10-13	1992-10-13 00:00:00	1992-10-13	5001	0	\N	0	0	\N	\N	0	87	0	127783003	4133840		
48008	4403	3011505	1992-05-30	1992-05-30 00:00:00	1992-05-30	5001	0	\N	0	0	\N	\N	0	292737	0	19926-5	3011505		
111219	3436	4052083	1969-04-19	1969-04-19 00:00:00	1969-04-19	5001	0	\N	0	0	\N	\N	0	227875	0	23426006	4052083		
15348	1407	3023430	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	93526	0	6833-8	3023430		
33805	3072	3006322	1962-03-08	1962-03-08 00:00:00	1962-03-08	5001	0	\N	0	0	\N	\N	0	204428	0	8331-1	3006322		
3628	347	3011505	2008-11-16	2008-11-16 00:00:00	2008-11-16	5001	0	\N	0	0	\N	\N	0	23088	0	19926-5	3011505		
2980	285	3000876	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	18983	0	6082-2	3000876		
26690	836	4052083	1990-06-09	1990-06-09 00:00:00	1990-06-09	5001	0	\N	0	0	\N	\N	0	55295	0	23426006	4052083		
130045	4009	4052083	1952-11-26	1952-11-26 00:00:00	1952-11-26	5001	0	\N	0	0	\N	\N	0	266388	0	23426006	4052083		
4733	449	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	29947	0	6273-7	3006451		
37600	3464	3014599	2012-11-30	2012-11-30 00:00:00	2012-11-30	5001	0	\N	0	0	\N	\N	0	229943	0	6106-9	3014599		
124854	3857	4133840	1983-12-27	1983-12-27 00:00:00	1983-12-27	5001	0	\N	0	0	\N	\N	0	255991	0	127783003	4133840		
28601	2646	3006322	1992-05-24	1992-05-24 00:00:00	1992-05-24	5001	0	\N	0	0	\N	\N	0	175045	0	8331-1	3006322		
25644	2351	3006322	2013-10-22	2013-10-22 00:00:00	2013-10-22	5001	0	\N	0	0	\N	\N	0	156503	0	8331-1	3006322		
56962	5222	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	347357	0	6246-3	3021226		
100081	3070	4024958	1969-12-09	1969-12-09 00:00:00	1969-12-09	5001	0	\N	0	0	\N	\N	0	204360	0	117015009	4024958		
3423	332	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	21887	0	6206-7	3012494		
32063	2921	3011505	2006-09-19	2006-09-19 00:00:00	2006-09-19	5001	0	\N	0	0	\N	\N	0	194749	0	19926-5	3011505		
35300	3229	3006322	1999-01-15	1999-01-15 00:00:00	1999-01-15	5001	0	\N	0	0	\N	\N	0	214592	0	8331-1	3006322		
43401	4014	3019406	2001-06-12	2001-06-12 00:00:00	2001-06-12	5001	0	\N	0	0	\N	\N	0	266725	0	6158-0	3019406		
43493	4022	3006322	1985-05-13	1985-05-13 00:00:00	1985-05-13	5001	0	\N	0	0	\N	\N	0	267390	0	8331-1	3006322		
48163	4419	40758406	1957-05-18	1957-05-18 00:00:00	1957-05-18	5001	0	\N	0	0	\N	\N	0	293845	0	55277-8	40758406		
58303	5343	3006451	1996-01-07	1996-01-07 00:00:00	1996-01-07	5001	0	\N	0	0	\N	\N	0	355877	0	6273-7	3006451		
20163	1845	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	123301	0	6246-3	3021226		
181	3	46235214	1950-01-19	1950-01-19 00:00:00	1950-01-19	5001	0	\N	0	0	\N	\N	0	317	0	76690-7	46235214		
151117	4631	4052083	1921-10-25	1921-10-25 00:00:00	1921-10-25	5001	0	\N	0	0	\N	\N	0	308563	0	23426006	4052083		
81883	2535	4052083	1979-02-28	1979-02-28 00:00:00	1979-02-28	5001	0	\N	0	0	\N	\N	0	167552	0	23426006	4052083		
30308	2778	3036780	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	184015	0	6095-4	3036780		
97340	2976	4052083	2005-09-19	2005-09-19 00:00:00	2005-09-19	5001	0	\N	0	0	\N	\N	0	198709	0	23426006	4052083		
32525	2953	3006322	2012-08-10	2012-08-10 00:00:00	2012-08-10	5001	0	\N	0	0	\N	\N	0	197110	0	8331-1	3006322		
25087	2300	3011505	1980-11-20	1980-11-20 00:00:00	1980-11-20	5001	0	\N	0	0	\N	\N	0	153201	0	19926-5	3011505		
1821	162	3006322	1957-02-02	1957-02-02 00:00:00	1957-02-02	5001	0	\N	0	0	\N	\N	0	11159	0	8331-1	3006322		
42069	3891	3036780	1999-06-02	1999-06-02 00:00:00	1999-06-02	5001	0	\N	0	0	\N	\N	0	258689	0	6095-4	3036780		
85	2	4133840	1991-10-08	1991-10-08 00:00:00	1991-10-08	5001	0	\N	0	0	\N	\N	0	174	0	127783003	4133840		
48009	4403	3011505	1993-06-05	1993-06-05 00:00:00	1993-06-05	5001	0	\N	0	0	\N	\N	0	292733	0	19926-5	3011505		
111227	3436	4052083	1992-07-18	1992-07-18 00:00:00	1992-07-18	5001	0	\N	0	0	\N	\N	0	227880	0	23426006	4052083		
15349	1407	3021226	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	93526	0	6246-3	3021226		
33806	3072	3006322	1998-08-14	1998-08-14 00:00:00	1998-08-14	5001	0	\N	0	0	\N	\N	0	204447	0	8331-1	3006322		
3629	347	3011505	1996-11-03	1996-11-03 00:00:00	1996-11-03	5001	0	\N	0	0	\N	\N	0	23107	0	19926-5	3011505		
2981	285	3006734	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	18983	0	6189-5	3006734		
95684	2933	4024958	1956-09-25	1956-09-25 00:00:00	1956-09-25	5001	0	\N	0	0	\N	\N	0	195628	0	117015009	4024958		
130050	4009	4052083	1956-07-18	1956-07-18 00:00:00	1956-07-18	5001	0	\N	0	0	\N	\N	0	266378	0	23426006	4052083		
4734	449	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	29947	0	6082-2	3000876		
37601	3464	3019406	2012-11-30	2012-11-30 00:00:00	2012-11-30	5001	0	\N	0	0	\N	\N	0	229943	0	6158-0	3019406		
124855	3857	4133840	2015-07-14	2015-07-14 00:00:00	2015-07-14	5001	0	\N	0	0	\N	\N	0	255999	0	127783003	4133840		
28602	2647	3006322	1980-10-15	1980-10-15 00:00:00	1980-10-15	5001	0	\N	0	0	\N	\N	0	175112	0	8331-1	3006322		
25645	2351	3006322	1959-01-07	1959-01-07 00:00:00	1959-01-07	5001	0	\N	0	0	\N	\N	0	156513	0	8331-1	3006322		
56963	5222	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	347357	0	6158-0	3019406		
100087	3070	4052083	1986-12-11	1986-12-11 00:00:00	1986-12-11	5001	0	\N	0	0	\N	\N	0	204362	0	23426006	4052083		
3424	332	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	21887	0	6082-2	3000876		
32064	2921	3011505	2001-08-21	2001-08-21 00:00:00	2001-08-21	5001	0	\N	0	0	\N	\N	0	194759	0	19926-5	3011505		
35301	3229	3006322	2005-03-29	2005-03-29 00:00:00	2005-03-29	5001	0	\N	0	0	\N	\N	0	214608	0	8331-1	3006322		
43402	4014	3005136	2001-06-12	2001-06-12 00:00:00	2001-06-12	5001	0	\N	0	0	\N	\N	0	266725	0	6075-6	3005136		
43494	4022	3006322	1992-02-16	1992-02-16 00:00:00	1992-02-16	5001	0	\N	0	0	\N	\N	0	267417	0	8331-1	3006322		
48164	4419	40766240	1957-05-18	1957-05-18 00:00:00	1957-05-18	5001	0	\N	0	0	\N	\N	0	293845	0	63513-6	40766240		
58304	5343	3027231	1996-01-07	1996-01-07 00:00:00	1996-01-07	5001	0	\N	0	0	\N	\N	0	355877	0	6276-0	3027231		
20164	1845	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	123301	0	6085-5	3001247		
182	3	40766240	1950-01-19	1950-01-19 00:00:00	1950-01-19	5001	0	\N	0	0	\N	\N	0	317	0	63513-6	40766240		
43549	1340	4052083	1986-09-09	1986-09-09 00:00:00	1986-09-09	5001	0	\N	0	0	\N	\N	0	88958	0	23426006	4052083		
81884	2535	4024958	1972-09-09	1972-09-09 00:00:00	1972-09-09	5001	0	\N	0	0	\N	\N	0	167482	0	117015009	4024958		
30309	2778	3000876	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	184015	0	6082-2	3000876		
97341	2976	4133840	2005-10-06	2005-10-06 00:00:00	2005-10-06	5001	0	\N	0	0	\N	\N	0	198731	0	127783003	4133840		
32526	2953	3006322	2009-05-15	2009-05-15 00:00:00	2009-05-15	5001	0	\N	0	0	\N	\N	0	197109	0	8331-1	3006322		
25088	2300	3011505	1995-12-14	1995-12-14 00:00:00	1995-12-14	5001	0	\N	0	0	\N	\N	0	153202	0	19926-5	3011505		
1822	162	3049273	2009-10-20	2009-10-20 00:00:00	2009-10-20	5001	0	\N	0	0	\N	\N	0	11146	0	38265-5	3049273		
42070	3891	3001247	1999-06-02	1999-06-02 00:00:00	1999-06-02	5001	0	\N	0	0	\N	\N	0	258689	0	6085-5	3001247		
91	2	4133840	2003-08-12	2003-08-12 00:00:00	2003-08-12	5001	0	\N	0	0	\N	\N	0	90	0	127783003	4133840		
48010	4403	3011505	1996-06-22	1996-06-22 00:00:00	1996-06-22	5001	0	\N	0	0	\N	\N	0	292691	0	19926-5	3011505		
111229	3436	4024958	1963-04-13	1963-04-13 00:00:00	1963-04-13	5001	0	\N	0	0	\N	\N	0	227872	0	117015009	4024958		
15350	1407	3005136	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	93526	0	6075-6	3005136		
33807	3072	3006322	1974-01-27	1974-01-27 00:00:00	1974-01-27	5001	0	\N	0	0	\N	\N	0	204491	0	8331-1	3006322		
3630	347	3006322	2015-03-03	2015-03-03 00:00:00	2015-03-03	5001	0	\N	0	0	\N	\N	0	23091	0	8331-1	3006322		
2982	285	3020655	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	18983	0	6844-5	3020655		
95693	2933	4024958	1978-07-08	1978-07-08 00:00:00	1978-07-08	5001	0	\N	0	0	\N	\N	0	195629	0	117015009	4024958		
130077	4010	4024958	1994-01-17	1994-01-17 00:00:00	1994-01-17	5001	0	\N	0	0	\N	\N	0	266514	0	117015009	4024958		
4735	449	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	29947	0	6095-4	3036780		
37602	3464	3006451	2012-11-30	2012-11-30 00:00:00	2012-11-30	5001	0	\N	0	0	\N	\N	0	229943	0	6273-7	3006451		
124858	3857	4133840	2004-08-10	2004-08-10 00:00:00	2004-08-10	5001	0	\N	0	0	\N	\N	0	255989	0	127783003	4133840		
28603	2647	3000876	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	175217	0	6082-2	3000876		
25647	2351	3006322	1953-05-26	1953-05-26 00:00:00	1953-05-26	5001	0	\N	0	0	\N	\N	0	156500	0	8331-1	3006322		
56964	5222	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	347357	0	6095-4	3036780		
39081	3614	3006322	2010-11-07	2010-11-07 00:00:00	2010-11-07	5001	0	\N	0	0	\N	\N	0	240145	0	8331-1	3006322		
3425	332	3006322	1969-06-15	1969-06-15 00:00:00	1969-06-15	5001	0	\N	0	0	\N	\N	0	21993	0	8331-1	3006322		
32065	2921	3011505	2017-11-21	2017-11-21 00:00:00	2017-11-21	5001	0	\N	0	0	\N	\N	0	194752	0	19926-5	3011505		
35302	3229	3006322	2017-09-02	2017-09-02 00:00:00	2017-09-02	5001	0	\N	0	0	\N	\N	0	214609	0	8331-1	3006322		
43403	4014	3021226	2001-06-12	2001-06-12 00:00:00	2001-06-12	5001	0	\N	0	0	\N	\N	0	266725	0	6246-3	3021226		
43495	4022	3006322	2001-11-05	2001-11-05 00:00:00	2001-11-05	5001	0	\N	0	0	\N	\N	0	267392	0	8331-1	3006322		
48165	4419	3051031	1957-05-18	1957-05-18 00:00:00	1957-05-18	5001	0	\N	0	0	\N	\N	0	293845	0	46240-8	3051031		
58305	5343	3015076	1996-01-07	1996-01-07 00:00:00	1996-01-07	5001	0	\N	0	0	\N	\N	0	355877	0	6248-9	3015076		
20165	1845	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	123301	0	6095-4	3036780		
183	3	3006322	2008-10-05	2008-10-05 00:00:00	2008-10-05	5001	0	\N	0	0	\N	\N	0	230	0	8331-1	3006322		
43561	1340	4024958	1913-08-03	1913-08-03 00:00:00	1913-08-03	5001	0	\N	0	0	\N	\N	0	88963	0	117015009	4024958		
81888	2535	4024958	1969-02-15	1969-02-15 00:00:00	1969-02-15	5001	0	\N	0	0	\N	\N	0	167481	0	117015009	4024958		
30310	2778	3015076	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	184015	0	6248-9	3015076		
97343	2976	4133840	2015-07-23	2015-07-23 00:00:00	2015-07-23	5001	0	\N	0	0	\N	\N	0	198751	0	127783003	4133840		
32527	2953	3006322	2006-04-19	2006-04-19 00:00:00	2006-04-19	5001	0	\N	0	0	\N	\N	0	197126	0	8331-1	3006322		
25089	2300	3006322	2003-01-18	2003-01-18 00:00:00	2003-01-18	5001	0	\N	0	0	\N	\N	0	153179	0	8331-1	3006322		
1823	162	3006322	2016-09-25	2016-09-25 00:00:00	2016-09-25	5001	0	\N	0	0	\N	\N	0	11115	0	8331-1	3006322		
42071	3891	3000876	1999-06-02	1999-06-02 00:00:00	1999-06-02	5001	0	\N	0	0	\N	\N	0	258689	0	6082-2	3000876		
97	2	4133840	2007-09-04	2007-09-04 00:00:00	2007-09-04	5001	0	\N	0	0	\N	\N	0	137	0	127783003	4133840		
48012	4403	3011505	1991-05-25	1991-05-25 00:00:00	1991-05-25	5001	0	\N	0	0	\N	\N	0	292732	0	19926-5	3011505		
111230	3436	4024958	1987-04-06	1987-04-06 00:00:00	1987-04-06	5001	0	\N	0	0	\N	\N	0	227894	0	117015009	4024958		
15351	1407	3001247	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	93526	0	6085-5	3001247		
45109	4165	3006322	1968-12-22	1968-12-22 00:00:00	1968-12-22	5001	0	\N	0	0	\N	\N	0	276721	0	8331-1	3006322		
3631	347	3011505	2010-11-21	2010-11-21 00:00:00	2010-11-21	5001	0	\N	0	0	\N	\N	0	23111	0	19926-5	3011505		
2983	285	3001247	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	18983	0	6085-5	3001247		
130093	4010	4024958	1981-05-01	1981-05-01 00:00:00	1981-05-01	5001	0	\N	0	0	\N	\N	0	266513	0	117015009	4024958		
4736	449	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	29947	0	6206-7	3012494		
37603	3464	3027231	2012-11-30	2012-11-30 00:00:00	2012-11-30	5001	0	\N	0	0	\N	\N	0	229943	0	6276-0	3027231		
136460	4205	4024958	1984-12-24	1984-12-24 00:00:00	1984-12-24	5001	0	\N	0	0	\N	\N	0	279165	0	117015009	4024958		
28604	2647	3001488	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	175217	0	7258-7	3001488		
25648	2351	3006322	1982-10-09	1982-10-09 00:00:00	1982-10-09	5001	0	\N	0	0	\N	\N	0	156586	0	8331-1	3006322		
56965	5222	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	347357	0	6075-6	3005136		
39082	3614	3006322	2002-04-09	2002-04-09 00:00:00	2002-04-09	5001	0	\N	0	0	\N	\N	0	240149	0	8331-1	3006322		
3426	332	3006322	1991-12-20	1991-12-20 00:00:00	1991-12-20	5001	0	\N	0	0	\N	\N	0	22040	0	8331-1	3006322		
32066	2921	3011505	1992-06-30	1992-06-30 00:00:00	1992-06-30	5001	0	\N	0	0	\N	\N	0	194758	0	19926-5	3011505		
35303	3230	3006322	2009-02-07	2009-02-07 00:00:00	2009-02-07	5001	0	\N	0	0	\N	\N	0	214680	0	8331-1	3006322		
43404	4014	3012494	2001-06-12	2001-06-12 00:00:00	2001-06-12	5001	0	\N	0	0	\N	\N	0	266725	0	6206-7	3012494		
43496	4022	3006322	1968-11-28	1968-11-28 00:00:00	1968-11-28	5001	0	\N	0	0	\N	\N	0	267396	0	8331-1	3006322		
48167	4419	3006322	1972-12-02	1972-12-02 00:00:00	1972-12-02	5001	0	\N	0	0	\N	\N	0	293864	0	8331-1	3006322		
58306	5343	3014599	1996-01-07	1996-01-07 00:00:00	1996-01-07	5001	0	\N	0	0	\N	\N	0	355877	0	6106-9	3014599		
20166	1845	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	123389	0	6833-8	3023430		
184	3	3006322	2004-01-18	2004-01-18 00:00:00	2004-01-18	5001	0	\N	0	0	\N	\N	0	229	0	8331-1	3006322		
43579	1340	4024958	1912-09-23	1912-09-23 00:00:00	1912-09-23	5001	0	\N	0	0	\N	\N	0	88874	0	117015009	4024958		
81900	2537	4024958	1958-01-15	1958-01-15 00:00:00	1958-01-15	5001	0	\N	0	0	\N	\N	0	167754	0	117015009	4024958		
30311	2778	3019406	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	184015	0	6158-0	3019406		
97348	2976	4133840	1979-07-05	1979-07-05 00:00:00	1979-07-05	5001	0	\N	0	0	\N	\N	0	198729	0	127783003	4133840		
32528	2953	3006322	1993-11-02	1993-11-02 00:00:00	1993-11-02	5001	0	\N	0	0	\N	\N	0	197129	0	8331-1	3006322		
25090	2300	3011505	1977-11-17	1977-11-17 00:00:00	1977-11-17	5001	0	\N	0	0	\N	\N	0	153200	0	19926-5	3011505		
1824	163	3006322	2010-07-05	2010-07-05 00:00:00	2010-07-05	5001	0	\N	0	0	\N	\N	0	11198	0	8331-1	3006322		
42072	3891	3001488	1983-11-05	1983-11-05 00:00:00	1983-11-05	5001	0	\N	0	0	\N	\N	0	258719	0	7258-7	3001488		
100	2	4133840	2004-08-17	2004-08-17 00:00:00	2004-08-17	5001	0	\N	0	0	\N	\N	0	188	0	127783003	4133840		
48013	4403	3011505	1994-06-11	1994-06-11 00:00:00	1994-06-11	5001	0	\N	0	0	\N	\N	0	292690	0	19926-5	3011505		
111231	3436	4052083	1996-02-07	1996-02-07 00:00:00	1996-02-07	5001	0	\N	0	0	\N	\N	0	227895	0	23426006	4052083		
15352	1407	3020655	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	93526	0	6844-5	3020655		
45110	4165	3006322	1922-02-24	1922-02-24 00:00:00	1922-02-24	5001	0	\N	0	0	\N	\N	0	276719	0	8331-1	3006322		
3632	347	3006322	1991-05-29	1991-05-29 00:00:00	1991-05-29	5001	0	\N	0	0	\N	\N	0	23066	0	8331-1	3006322		
2984	285	3027231	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	18983	0	6276-0	3027231		
130096	4010	4024958	1983-08-29	1983-08-29 00:00:00	1983-08-29	5001	0	\N	0	0	\N	\N	0	266461	0	117015009	4024958		
4737	449	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	29947	0	6075-6	3005136		
37604	3464	3015076	2012-11-30	2012-11-30 00:00:00	2012-11-30	5001	0	\N	0	0	\N	\N	0	229943	0	6248-9	3015076		
136468	4205	4052083	2003-04-26	2003-04-26 00:00:00	2003-04-26	5001	0	\N	0	0	\N	\N	0	279209	0	23426006	4052083		
28605	2647	3020655	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	175217	0	6844-5	3020655		
25649	2351	3006322	1998-02-27	1998-02-27 00:00:00	1998-02-27	5001	0	\N	0	0	\N	\N	0	156518	0	8331-1	3006322		
56966	5222	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	347357	0	6206-7	3012494		
39083	3614	3011505	2009-12-06	2009-12-06 00:00:00	2009-12-06	5001	0	\N	0	0	\N	\N	0	240068	0	19926-5	3011505		
3427	332	3006322	1986-06-27	1986-06-27 00:00:00	1986-06-27	5001	0	\N	0	0	\N	\N	0	21996	0	8331-1	3006322		
32067	2921	3011505	2016-11-15	2016-11-15 00:00:00	2016-11-15	5001	0	\N	0	0	\N	\N	0	194719	0	19926-5	3011505		
35304	3230	3006322	1969-03-30	1969-03-30 00:00:00	1969-03-30	5001	0	\N	0	0	\N	\N	0	214655	0	8331-1	3006322		
43405	4014	3006451	2001-06-12	2001-06-12 00:00:00	2001-06-12	5001	0	\N	0	0	\N	\N	0	266725	0	6273-7	3006451		
43497	4022	3006322	1978-10-04	1978-10-04 00:00:00	1978-10-04	5001	0	\N	0	0	\N	\N	0	267389	0	8331-1	3006322		
48168	4419	3006322	1965-10-30	1965-10-30 00:00:00	1965-10-30	5001	0	\N	0	0	\N	\N	0	293862	0	8331-1	3006322		
58307	5343	3000876	1996-01-07	1996-01-07 00:00:00	1996-01-07	5001	0	\N	0	0	\N	\N	0	355877	0	6082-2	3000876		
20167	1845	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	123389	0	7258-7	3001488		
185	3	40766240	1994-03-04	1994-03-04 00:00:00	1994-03-04	5001	0	\N	0	0	\N	\N	0	225	0	63513-6	40766240		
51320	4694	3012494	1994-08-14	1994-08-14 00:00:00	1994-08-14	5001	0	\N	0	0	\N	\N	0	312751	0	6206-7	3012494		
81910	2537	4024958	1988-11-24	1988-11-24 00:00:00	1988-11-24	5001	0	\N	0	0	\N	\N	0	167586	0	117015009	4024958		
30312	2778	3005136	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	184015	0	6075-6	3005136		
97351	2976	4133840	2007-10-18	2007-10-18 00:00:00	2007-10-18	5001	0	\N	0	0	\N	\N	0	198732	0	127783003	4133840		
32529	2953	3006322	2017-07-27	2017-07-27 00:00:00	2017-07-27	5001	0	\N	0	0	\N	\N	0	197136	0	8331-1	3006322		
25091	2300	3006322	1990-03-30	1990-03-30 00:00:00	1990-03-30	5001	0	\N	0	0	\N	\N	0	153165	0	8331-1	3006322		
1825	163	3006322	1975-05-16	1975-05-16 00:00:00	1975-05-16	5001	0	\N	0	0	\N	\N	0	11189	0	8331-1	3006322		
42073	3891	3006734	1983-11-05	1983-11-05 00:00:00	1983-11-05	5001	0	\N	0	0	\N	\N	0	258719	0	6189-5	3006734		
108	2	4052083	1980-07-27	1980-07-27 00:00:00	1980-07-27	5001	0	\N	0	0	\N	\N	0	140	0	23426006	4052083		
48014	4403	3011505	1989-05-13	1989-05-13 00:00:00	1989-05-13	5001	0	\N	0	0	\N	\N	0	292735	0	19926-5	3011505		
111235	3436	4024958	1968-05-11	1968-05-11 00:00:00	1968-05-11	5001	0	\N	0	0	\N	\N	0	227857	0	117015009	4024958		
15353	1407	3001488	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	93526	0	7258-7	3001488		
45111	4165	3006322	1983-03-06	1983-03-06 00:00:00	1983-03-06	5001	0	\N	0	0	\N	\N	0	276755	0	8331-1	3006322		
3633	347	3011505	2005-11-13	2005-11-13 00:00:00	2005-11-13	5001	0	\N	0	0	\N	\N	0	23110	0	19926-5	3011505		
2985	285	3019406	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	18983	0	6158-0	3019406		
4738	449	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	29947	0	6276-0	3027231		
37605	3464	3012494	2012-11-30	2012-11-30 00:00:00	2012-11-30	5001	0	\N	0	0	\N	\N	0	229943	0	6206-7	3012494		
136477	4206	4133840	1996-09-23	1996-09-23 00:00:00	1996-09-23	5001	0	\N	0	0	\N	\N	0	279324	0	127783003	4133840		
28606	2647	3023430	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	175217	0	6833-8	3023430		
25650	2351	3006322	1959-07-22	1959-07-22 00:00:00	1959-07-22	5001	0	\N	0	0	\N	\N	0	156514	0	8331-1	3006322		
56967	5222	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	347357	0	6082-2	3000876		
39084	3614	3011505	2005-07-31	2005-07-31 00:00:00	2005-07-31	5001	0	\N	0	0	\N	\N	0	240102	0	19926-5	3011505		
3428	332	3006322	2007-05-26	2007-05-26 00:00:00	2007-05-26	5001	0	\N	0	0	\N	\N	0	21959	0	8331-1	3006322		
32068	2921	3011505	2008-09-30	2008-09-30 00:00:00	2008-09-30	5001	0	\N	0	0	\N	\N	0	194743	0	19926-5	3011505		
35305	3230	3006322	1966-12-28	1966-12-28 00:00:00	1966-12-28	5001	0	\N	0	0	\N	\N	0	214677	0	8331-1	3006322		
43406	4014	3023430	2001-06-12	2001-06-12 00:00:00	2001-06-12	5001	0	\N	0	0	\N	\N	0	266725	0	6833-8	3023430		
54791	5013	3006322	1973-04-07	1973-04-07 00:00:00	1973-04-07	5001	0	\N	0	0	\N	\N	0	333172	0	8331-1	3006322		
48169	4419	3051031	1957-02-17	1957-02-17 00:00:00	1957-02-17	5001	0	\N	0	0	\N	\N	0	293844	0	46240-8	3051031		
58308	5343	3019406	1996-01-07	1996-01-07 00:00:00	1996-01-07	5001	0	\N	0	0	\N	\N	0	355877	0	6158-0	3019406		
20168	1845	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	123389	0	6085-5	3001247		
51238	4689	3006322	2000-08-25	2000-08-25 00:00:00	2000-08-25	5001	0	\N	0	0	\N	\N	0	312380	0	8331-1	3006322		
51321	4694	3023430	1994-08-14	1994-08-14 00:00:00	1994-08-14	5001	0	\N	0	0	\N	\N	0	312751	0	6833-8	3023430		
81924	2537	4024958	1953-05-20	1953-05-20 00:00:00	1953-05-20	5001	0	\N	0	0	\N	\N	0	167710	0	117015009	4024958		
30313	2778	3023430	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	184015	0	6833-8	3023430		
50068	4557	3006322	1974-04-07	1974-04-07 00:00:00	1974-04-07	5001	0	\N	0	0	\N	\N	0	303623	0	8331-1	3006322		
32534	2955	3006322	1974-02-17	1974-02-17 00:00:00	1974-02-17	5001	0	\N	0	0	\N	\N	0	197202	0	8331-1	3006322		
25092	2300	3011505	1983-11-24	1983-11-24 00:00:00	1983-11-24	5001	0	\N	0	0	\N	\N	0	153194	0	19926-5	3011505		
1826	163	3006322	1997-10-28	1997-10-28 00:00:00	1997-10-28	5001	0	\N	0	0	\N	\N	0	11177	0	8331-1	3006322		
42074	3891	3023430	1983-11-05	1983-11-05 00:00:00	1983-11-05	5001	0	\N	0	0	\N	\N	0	258719	0	6833-8	3023430		
109	2	4133840	2005-08-23	2005-08-23 00:00:00	2005-08-23	5001	0	\N	0	0	\N	\N	0	136	0	127783003	4133840		
48015	4403	3006322	1959-09-23	1959-09-23 00:00:00	1959-09-23	5001	0	\N	0	0	\N	\N	0	292654	0	8331-1	3006322		
111237	3436	4024958	1967-06-03	1967-06-03 00:00:00	1967-06-03	5001	0	\N	0	0	\N	\N	0	227890	0	117015009	4024958		
15354	1407	3006322	1998-12-02	1998-12-02 00:00:00	1998-12-02	5001	0	\N	0	0	\N	\N	0	93495	0	8331-1	3006322		
45112	4165	3006322	1938-05-15	1938-05-15 00:00:00	1938-05-15	5001	0	\N	0	0	\N	\N	0	276740	0	8331-1	3006322		
3634	348	3006322	1986-03-16	1986-03-16 00:00:00	1986-03-16	5001	0	\N	0	0	\N	\N	0	23141	0	8331-1	3006322		
2986	285	3005136	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	18983	0	6075-6	3005136		
4739	449	3014599	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	29947	0	6106-9	3014599		
37606	3464	3001488	2012-11-30	2012-11-30 00:00:00	2012-11-30	5001	0	\N	0	0	\N	\N	0	229943	0	7258-7	3001488		
170990	5245	4024958	2011-02-16	2011-02-16 00:00:00	2011-02-16	5001	0	\N	0	0	\N	\N	0	348955	0	117015009	4024958		
28607	2647	3006734	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	175217	0	6189-5	3006734		
25651	2352	3006322	1997-06-25	1997-06-25 00:00:00	1997-06-25	5001	0	\N	0	0	\N	\N	0	156685	0	8331-1	3006322		
56968	5222	3006451	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	347357	0	6273-7	3006451		
39085	3614	3011505	2009-11-22	2009-11-22 00:00:00	2009-11-22	5001	0	\N	0	0	\N	\N	0	240138	0	19926-5	3011505		
3432	334	3006322	1974-09-05	1974-09-05 00:00:00	1974-09-05	5001	0	\N	0	0	\N	\N	0	22147	0	8331-1	3006322		
32069	2921	3011505	1980-06-24	1980-06-24 00:00:00	1980-06-24	5001	0	\N	0	0	\N	\N	0	194756	0	19926-5	3011505		
35306	3231	3006322	2000-10-22	2000-10-22 00:00:00	2000-10-22	5001	0	\N	0	0	\N	\N	0	214742	0	8331-1	3006322		
43407	4014	3020655	2001-06-12	2001-06-12 00:00:00	2001-06-12	5001	0	\N	0	0	\N	\N	0	266725	0	6844-5	3020655		
54792	5013	3006322	2000-02-26	2000-02-26 00:00:00	2000-02-26	5001	0	\N	0	0	\N	\N	0	333174	0	8331-1	3006322		
48171	4419	46235214	1957-02-17	1957-02-17 00:00:00	1957-02-17	5001	0	\N	0	0	\N	\N	0	293844	0	76690-7	46235214		
48285	4428	3006322	2011-04-05	2011-04-05 00:00:00	2011-04-05	5001	0	\N	0	0	\N	\N	0	294367	0	8331-1	3006322		
20169	1845	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	123389	0	6206-7	3012494		
51239	4689	3006322	2001-10-31	2001-10-31 00:00:00	2001-10-31	5001	0	\N	0	0	\N	\N	0	312406	0	8331-1	3006322		
51322	4694	3036780	1994-08-14	1994-08-14 00:00:00	1994-08-14	5001	0	\N	0	0	\N	\N	0	312751	0	6095-4	3036780		
268	9	3019406	1991-07-25	1991-07-25 00:00:00	1991-07-25	5001	0	\N	0	0	\N	\N	0	837	0	6158-0	3019406		
30314	2778	3001247	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	184015	0	6085-5	3001247		
50070	4557	40758406	1963-01-03	1963-01-03 00:00:00	1963-01-03	5001	0	\N	0	0	\N	\N	0	303655	0	55277-8	40758406		
32535	2955	3006322	2005-02-01	2005-02-01 00:00:00	2005-02-01	5001	0	\N	0	0	\N	\N	0	197263	0	8331-1	3006322		
25093	2300	3011505	2004-01-15	2004-01-15 00:00:00	2004-01-15	5001	0	\N	0	0	\N	\N	0	153161	0	19926-5	3011505		
1827	164	3006322	1997-05-03	1997-05-03 00:00:00	1997-05-03	5001	0	\N	0	0	\N	\N	0	11289	0	8331-1	3006322		
42075	3891	3006451	1983-11-05	1983-11-05 00:00:00	1983-11-05	5001	0	\N	0	0	\N	\N	0	258719	0	6273-7	3006451		
111	2	4133840	2002-08-06	2002-08-06 00:00:00	2002-08-06	5001	0	\N	0	0	\N	\N	0	187	0	127783003	4133840		
12715	406	4052083	2007-07-22	2007-07-22 00:00:00	2007-07-22	5001	0	\N	0	0	\N	\N	0	26746	0	23426006	4052083		
111246	3437	4052083	1980-05-19	1980-05-19 00:00:00	1980-05-19	5001	0	\N	0	0	\N	\N	0	227942	0	23426006	4052083		
15355	1407	3015076	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	93472	0	6248-9	3015076		
45113	4165	3006322	1960-02-27	1960-02-27 00:00:00	1960-02-27	5001	0	\N	0	0	\N	\N	0	276747	0	8331-1	3006322		
3635	348	3006322	1978-05-16	1978-05-16 00:00:00	1978-05-16	5001	0	\N	0	0	\N	\N	0	23143	0	8331-1	3006322		
2987	285	3006322	1996-04-23	1996-04-23 00:00:00	1996-04-23	5001	0	\N	0	0	\N	\N	0	19021	0	8331-1	3006322		
4740	449	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	29947	0	6844-5	3020655		
37607	3464	3036780	2012-11-30	2012-11-30 00:00:00	2012-11-30	5001	0	\N	0	0	\N	\N	0	229943	0	6095-4	3036780		
28608	2647	3036780	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	175217	0	6095-4	3036780		
25652	2352	3006322	2014-05-16	2014-05-16 00:00:00	2014-05-16	5001	0	\N	0	0	\N	\N	0	156740	0	8331-1	3006322		
56969	5222	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	347357	0	6248-9	3015076		
39086	3614	3000963	2009-06-11	2009-06-11 00:00:00	2009-06-11	5001	0	\N	0	0	\N	\N	0	240143	0	718-7	3000963		
3433	334	3006322	1986-05-16	1986-05-16 00:00:00	1986-05-16	5001	0	\N	0	0	\N	\N	0	22130	0	8331-1	3006322		
32070	2921	3011505	2018-11-27	2018-11-27 00:00:00	2018-11-27	5001	0	\N	0	0	\N	\N	0	194720	0	19926-5	3011505		
35307	3231	3006322	1983-03-11	1983-03-11 00:00:00	1983-03-11	5001	0	\N	0	0	\N	\N	0	214717	0	8331-1	3006322		
43408	4014	3001488	2001-06-12	2001-06-12 00:00:00	2001-06-12	5001	0	\N	0	0	\N	\N	0	266725	0	7258-7	3001488		
54793	5014	3006322	1965-06-26	1965-06-26 00:00:00	1965-06-26	5001	0	\N	0	0	\N	\N	0	333264	0	8331-1	3006322		
48172	4419	40758406	1957-02-17	1957-02-17 00:00:00	1957-02-17	5001	0	\N	0	0	\N	\N	0	293844	0	55277-8	40758406		
48286	4428	3006322	1966-12-24	1966-12-24 00:00:00	1966-12-24	5001	0	\N	0	0	\N	\N	0	294412	0	8331-1	3006322		
20170	1845	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	123389	0	6246-3	3021226		
51240	4689	3051031	2019-06-26	2019-06-26 00:00:00	2019-06-26	5001	0	\N	0	0	\N	\N	0	312382	0	46240-8	3051031		
51323	4694	3014599	1994-08-14	1994-08-14 00:00:00	1994-08-14	5001	0	\N	0	0	\N	\N	0	312751	0	6106-9	3014599		
269	9	3006451	1991-07-25	1991-07-25 00:00:00	1991-07-25	5001	0	\N	0	0	\N	\N	0	837	0	6273-7	3006451		
30315	2778	3006451	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	184015	0	6273-7	3006451		
50071	4557	40766240	1963-01-03	1963-01-03 00:00:00	1963-01-03	5001	0	\N	0	0	\N	\N	0	303655	0	63513-6	40766240		
32536	2955	3006322	1976-09-02	1976-09-02 00:00:00	1976-09-02	5001	0	\N	0	0	\N	\N	0	197275	0	8331-1	3006322		
25094	2300	3011505	2017-03-30	2017-03-30 00:00:00	2017-03-30	5001	0	\N	0	0	\N	\N	0	153164	0	19926-5	3011505		
1828	164	3006322	1989-12-14	1989-12-14 00:00:00	1989-12-14	5001	0	\N	0	0	\N	\N	0	11295	0	8331-1	3006322		
42076	3891	3012494	1983-11-05	1983-11-05 00:00:00	1983-11-05	5001	0	\N	0	0	\N	\N	0	258719	0	6206-7	3012494		
114	2	4133840	1996-07-02	1996-07-02 00:00:00	1996-07-02	5001	0	\N	0	0	\N	\N	0	134	0	127783003	4133840		
12754	406	4024958	1955-01-08	1955-01-08 00:00:00	1955-01-08	5001	0	\N	0	0	\N	\N	0	26717	0	117015009	4024958		
111255	3437	4024958	1956-06-03	1956-06-03 00:00:00	1956-06-03	5001	0	\N	0	0	\N	\N	0	228008	0	117015009	4024958		
15356	1407	3027231	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	93472	0	6276-0	3027231		
45114	4165	3049273	1990-08-18	1990-08-18 00:00:00	1990-08-18	5001	0	\N	0	0	\N	\N	0	276827	0	38265-5	3049273		
3636	349	3006322	1975-05-13	1975-05-13 00:00:00	1975-05-13	5001	0	\N	0	0	\N	\N	0	23206	0	8331-1	3006322		
2988	285	3006322	1971-08-20	1971-08-20 00:00:00	1971-08-20	5001	0	\N	0	0	\N	\N	0	19003	0	8331-1	3006322		
4741	449	3006734	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	29947	0	6189-5	3006734		
37608	3464	3006734	2012-11-30	2012-11-30 00:00:00	2012-11-30	5001	0	\N	0	0	\N	\N	0	229943	0	6189-5	3006734		
28609	2647	3001247	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	175217	0	6085-5	3001247		
25653	2352	3006322	2018-08-02	2018-08-02 00:00:00	2018-08-02	5001	0	\N	0	0	\N	\N	0	156742	0	8331-1	3006322		
56970	5222	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	347357	0	7258-7	3001488		
39087	3614	3009542	2009-06-11	2009-06-11 00:00:00	2009-06-11	5001	0	\N	0	0	\N	\N	0	240143	0	20570-8	3009542		
3435	334	3006322	1940-02-13	1940-02-13 00:00:00	1940-02-13	5001	0	\N	0	0	\N	\N	0	22141	0	8331-1	3006322		
32071	2921	3011505	2007-09-25	2007-09-25 00:00:00	2007-09-25	5001	0	\N	0	0	\N	\N	0	194704	0	19926-5	3011505		
35308	3231	3006322	1979-02-16	1979-02-16 00:00:00	1979-02-16	5001	0	\N	0	0	\N	\N	0	214799	0	8331-1	3006322		
43409	4014	3027231	2001-06-12	2001-06-12 00:00:00	2001-06-12	5001	0	\N	0	0	\N	\N	0	266725	0	6276-0	3027231		
54794	5014	3006322	1928-02-04	1928-02-04 00:00:00	1928-02-04	5001	0	\N	0	0	\N	\N	0	333313	0	8331-1	3006322		
48173	4419	40766240	1957-02-17	1957-02-17 00:00:00	1957-02-17	5001	0	\N	0	0	\N	\N	0	293844	0	63513-6	40766240		
48287	4428	3006322	1994-12-12	1994-12-12 00:00:00	1994-12-12	5001	0	\N	0	0	\N	\N	0	294400	0	8331-1	3006322		
20171	1845	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	123389	0	6082-2	3000876		
51241	4689	40758406	2019-06-26	2019-06-26 00:00:00	2019-06-26	5001	0	\N	0	0	\N	\N	0	312382	0	55277-8	40758406		
51324	4694	3021226	1994-08-14	1994-08-14 00:00:00	1994-08-14	5001	0	\N	0	0	\N	\N	0	312751	0	6246-3	3021226		
270	9	3005136	1991-07-25	1991-07-25 00:00:00	1991-07-25	5001	0	\N	0	0	\N	\N	0	837	0	6075-6	3005136		
30316	2778	3012494	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	184015	0	6206-7	3012494		
50073	4557	3051031	1963-01-03	1963-01-03 00:00:00	1963-01-03	5001	0	\N	0	0	\N	\N	0	303655	0	46240-8	3051031		
32537	2955	3006322	2012-07-10	2012-07-10 00:00:00	2012-07-10	5001	0	\N	0	0	\N	\N	0	197208	0	8331-1	3006322		
25095	2300	3011505	2011-02-24	2011-02-24 00:00:00	2011-02-24	5001	0	\N	0	0	\N	\N	0	153152	0	19926-5	3011505		
1829	164	3006322	2005-10-13	2005-10-13 00:00:00	2005-10-13	5001	0	\N	0	0	\N	\N	0	11283	0	8331-1	3006322		
42077	3891	3021226	1983-11-05	1983-11-05 00:00:00	1983-11-05	5001	0	\N	0	0	\N	\N	0	258719	0	6246-3	3021226		
118	2	4133840	1998-07-14	1998-07-14 00:00:00	1998-07-14	5001	0	\N	0	0	\N	\N	0	135	0	127783003	4133840		
12774	406	4052083	2014-10-08	2014-10-08 00:00:00	2014-10-08	5001	0	\N	0	0	\N	\N	0	26857	0	23426006	4052083		
111258	3437	4024958	1927-01-23	1927-01-23 00:00:00	1927-01-23	5001	0	\N	0	0	\N	\N	0	227983	0	117015009	4024958		
15357	1407	3014599	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	93472	0	6106-9	3014599		
45115	4165	3049273	1981-10-20	1981-10-20 00:00:00	1981-10-20	5001	0	\N	0	0	\N	\N	0	276831	0	38265-5	3049273		
3637	349	3006322	1969-02-11	1969-02-11 00:00:00	1969-02-11	5001	0	\N	0	0	\N	\N	0	23180	0	8331-1	3006322		
2989	286	3049273	2006-10-16	2006-10-16 00:00:00	2006-10-16	5001	0	\N	0	0	\N	\N	0	19043	0	38265-5	3049273		
4742	449	3023430	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	29947	0	6833-8	3023430		
37609	3464	3023430	2012-11-30	2012-11-30 00:00:00	2012-11-30	5001	0	\N	0	0	\N	\N	0	229943	0	6833-8	3023430		
28610	2647	3015076	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	175217	0	6248-9	3015076		
25654	2352	3001247	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	156675	0	6085-5	3001247		
56971	5222	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	347357	0	6085-5	3001247		
39088	3614	3011505	2003-07-20	2003-07-20 00:00:00	2003-07-20	5001	0	\N	0	0	\N	\N	0	240077	0	19926-5	3011505		
3437	334	3006322	2008-07-04	2008-07-04 00:00:00	2008-07-04	5001	0	\N	0	0	\N	\N	0	22185	0	8331-1	3006322		
32072	2921	3011505	2010-10-12	2010-10-12 00:00:00	2010-10-12	5001	0	\N	0	0	\N	\N	0	194744	0	19926-5	3011505		
35309	3231	3006322	1962-09-01	1962-09-01 00:00:00	1962-09-01	5001	0	\N	0	0	\N	\N	0	214798	0	8331-1	3006322		
43410	4014	3015076	2001-06-12	2001-06-12 00:00:00	2001-06-12	5001	0	\N	0	0	\N	\N	0	266725	0	6248-9	3015076		
54795	5014	3006322	1960-01-09	1960-01-09 00:00:00	1960-01-09	5001	0	\N	0	0	\N	\N	0	333282	0	8331-1	3006322		
48175	4419	3051031	1956-10-20	1956-10-20 00:00:00	1956-10-20	5001	0	\N	0	0	\N	\N	0	293860	0	46240-8	3051031		
48288	4428	3006322	1954-05-05	1954-05-05 00:00:00	1954-05-05	5001	0	\N	0	0	\N	\N	0	294377	0	8331-1	3006322		
20172	1845	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	123389	0	6158-0	3019406		
51242	4689	46235214	2019-06-26	2019-06-26 00:00:00	2019-06-26	5001	0	\N	0	0	\N	\N	0	312382	0	76690-7	46235214		
51325	4694	3015076	1994-08-14	1994-08-14 00:00:00	1994-08-14	5001	0	\N	0	0	\N	\N	0	312751	0	6248-9	3015076		
271	9	3015076	1991-07-25	1991-07-25 00:00:00	1991-07-25	5001	0	\N	0	0	\N	\N	0	837	0	6248-9	3015076		
30317	2778	3014599	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	183976	0	6106-9	3014599		
50074	4557	46235214	1963-01-03	1963-01-03 00:00:00	1963-01-03	5001	0	\N	0	0	\N	\N	0	303655	0	76690-7	46235214		
32538	2955	3006322	1995-01-27	1995-01-27 00:00:00	1995-01-27	5001	0	\N	0	0	\N	\N	0	197242	0	8331-1	3006322		
25096	2300	3011505	1991-12-05	1991-12-05 00:00:00	1991-12-05	5001	0	\N	0	0	\N	\N	0	153142	0	19926-5	3011505		
1830	164	3006322	1966-06-05	1966-06-05 00:00:00	1966-06-05	5001	0	\N	0	0	\N	\N	0	11243	0	8331-1	3006322		
42078	3891	3005136	1983-11-05	1983-11-05 00:00:00	1983-11-05	5001	0	\N	0	0	\N	\N	0	258719	0	6075-6	3005136		
120	2	4133840	1990-10-02	1990-10-02 00:00:00	1990-10-02	5001	0	\N	0	0	\N	\N	0	195	0	127783003	4133840		
12974	411	4052083	2005-10-13	2005-10-13 00:00:00	2005-10-13	5001	0	\N	0	0	\N	\N	0	27337	0	23426006	4052083		
111262	3437	4052083	1976-12-28	1976-12-28 00:00:00	1976-12-28	5001	0	\N	0	0	\N	\N	0	227969	0	23426006	4052083		
15358	1407	3019406	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	93472	0	6158-0	3019406		
45118	4167	3006322	1981-11-18	1981-11-18 00:00:00	1981-11-18	5001	0	\N	0	0	\N	\N	0	276980	0	8331-1	3006322		
3638	349	3049273	2018-04-28	2018-04-28 00:00:00	2018-04-28	5001	0	\N	0	0	\N	\N	0	23211	0	38265-5	3049273		
2990	286	3006322	1969-07-02	1969-07-02 00:00:00	1969-07-02	5001	0	\N	0	0	\N	\N	0	19118	0	8331-1	3006322		
4743	449	3011505	2007-07-19	2007-07-19 00:00:00	2007-07-19	5001	0	\N	0	0	\N	\N	0	29972	0	19926-5	3011505		
37610	3464	3020655	2012-11-30	2012-11-30 00:00:00	2012-11-30	5001	0	\N	0	0	\N	\N	0	229943	0	6844-5	3020655		
28611	2647	3021226	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	175217	0	6246-3	3021226		
25655	2352	3023430	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	156675	0	6833-8	3023430		
56972	5222	3006322	1962-05-09	1962-05-09 00:00:00	1962-05-09	5001	0	\N	0	0	\N	\N	0	347354	0	8331-1	3006322		
39089	3614	3011505	2010-11-21	2010-11-21 00:00:00	2010-11-21	5001	0	\N	0	0	\N	\N	0	240069	0	19926-5	3011505		
3438	334	3049273	2005-06-15	2005-06-15 00:00:00	2005-06-15	5001	0	\N	0	0	\N	\N	0	22137	0	38265-5	3049273		
32073	2921	3011505	1994-07-12	1994-07-12 00:00:00	1994-07-12	5001	0	\N	0	0	\N	\N	0	194701	0	19926-5	3011505		
35310	3232	3006322	2017-11-10	2017-11-10 00:00:00	2017-11-10	5001	0	\N	0	0	\N	\N	0	214837	0	8331-1	3006322		
43411	4014	3000876	2001-06-12	2001-06-12 00:00:00	2001-06-12	5001	0	\N	0	0	\N	\N	0	266725	0	6082-2	3000876		
54797	5014	3011505	1987-11-03	1987-11-03 00:00:00	1987-11-03	5001	0	\N	0	0	\N	\N	0	333308	0	19926-5	3011505		
48177	4419	46235214	1956-10-20	1956-10-20 00:00:00	1956-10-20	5001	0	\N	0	0	\N	\N	0	293860	0	76690-7	46235214		
48289	4428	3006322	1961-11-05	1961-11-05 00:00:00	1961-11-05	5001	0	\N	0	0	\N	\N	0	294415	0	8331-1	3006322		
20173	1845	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	123389	0	6095-4	3036780		
51245	4689	40766240	2019-06-26	2019-06-26 00:00:00	2019-06-26	5001	0	\N	0	0	\N	\N	0	312382	0	63513-6	40766240		
51326	4694	3005136	1994-08-14	1994-08-14 00:00:00	1994-08-14	5001	0	\N	0	0	\N	\N	0	312751	0	6075-6	3005136		
272	9	3012494	1991-07-25	1991-07-25 00:00:00	1991-07-25	5001	0	\N	0	0	\N	\N	0	837	0	6206-7	3012494		
30318	2778	3006734	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	183976	0	6189-5	3006734		
50075	4557	3006322	1960-02-24	1960-02-24 00:00:00	1960-02-24	5001	0	\N	0	0	\N	\N	0	303654	0	8331-1	3006322		
32539	2955	3006322	1997-12-13	1997-12-13 00:00:00	1997-12-13	5001	0	\N	0	0	\N	\N	0	197238	0	8331-1	3006322		
25097	2300	3011505	2019-04-11	2019-04-11 00:00:00	2019-04-11	5001	0	\N	0	0	\N	\N	0	153137	0	19926-5	3011505		
1831	164	3006322	1990-03-26	1990-03-26 00:00:00	1990-03-26	5001	0	\N	0	0	\N	\N	0	11244	0	8331-1	3006322		
42079	3891	3014599	1983-11-05	1983-11-05 00:00:00	1983-11-05	5001	0	\N	0	0	\N	\N	0	258719	0	6106-9	3014599		
124	2	4133840	1999-07-20	1999-07-20 00:00:00	1999-07-20	5001	0	\N	0	0	\N	\N	0	88	0	127783003	4133840		
12997	411	4052083	1973-11-17	1973-11-17 00:00:00	1973-11-17	5001	0	\N	0	0	\N	\N	0	27309	0	23426006	4052083		
54091	1641	4024958	1970-11-23	1970-11-23 00:00:00	1970-11-23	5001	0	\N	0	0	\N	\N	0	110127	0	117015009	4024958		
15359	1407	3006451	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	93472	0	6273-7	3006451		
45119	4167	3005136	1979-06-28	1979-06-28 00:00:00	1979-06-28	5001	0	\N	0	0	\N	\N	0	276979	0	6075-6	3005136		
3639	349	3006322	1970-08-14	1970-08-14 00:00:00	1970-08-14	5001	0	\N	0	0	\N	\N	0	23181	0	8331-1	3006322		
2991	286	3049273	2017-06-02	2017-06-02 00:00:00	2017-06-02	5001	0	\N	0	0	\N	\N	0	19047	0	38265-5	3049273		
4744	449	3011505	2016-09-01	2016-09-01 00:00:00	2016-09-01	5001	0	\N	0	0	\N	\N	0	29984	0	19926-5	3011505		
37611	3464	3006322	1983-08-30	1983-08-30 00:00:00	1983-08-30	5001	0	\N	0	0	\N	\N	0	229903	0	8331-1	3006322		
28612	2647	3006451	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	175217	0	6273-7	3006451		
25656	2352	3020655	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	156675	0	6844-5	3020655		
56973	5222	3011505	2008-03-06	2008-03-06 00:00:00	2008-03-06	5001	0	\N	0	0	\N	\N	0	347348	0	19926-5	3011505		
39090	3614	3006322	1986-05-12	1986-05-12 00:00:00	1986-05-12	5001	0	\N	0	0	\N	\N	0	240104	0	8331-1	3006322		
3439	334	3006322	1945-09-29	1945-09-29 00:00:00	1945-09-29	5001	0	\N	0	0	\N	\N	0	22143	0	8331-1	3006322		
32074	2921	3011505	2015-11-10	2015-11-10 00:00:00	2015-11-10	5001	0	\N	0	0	\N	\N	0	194751	0	19926-5	3011505		
35311	3232	40758406	1969-10-14	1969-10-14 00:00:00	1969-10-14	5001	0	\N	0	0	\N	\N	0	214817	0	55277-8	40758406		
43412	4014	3001247	2001-06-12	2001-06-12 00:00:00	2001-06-12	5001	0	\N	0	0	\N	\N	0	266725	0	6085-5	3001247		
54798	5014	3011505	1986-10-28	1986-10-28 00:00:00	1986-10-28	5001	0	\N	0	0	\N	\N	0	333277	0	19926-5	3011505		
48178	4419	40758406	1956-10-20	1956-10-20 00:00:00	1956-10-20	5001	0	\N	0	0	\N	\N	0	293860	0	55277-8	40758406		
48301	4432	3006322	1959-03-21	1959-03-21 00:00:00	1959-03-21	5001	0	\N	0	0	\N	\N	0	294567	0	8331-1	3006322		
20174	1845	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	123389	0	6189-5	3006734		
51246	4689	3006322	1981-01-08	1981-01-08 00:00:00	1981-01-08	5001	0	\N	0	0	\N	\N	0	312439	0	8331-1	3006322		
51327	4694	3006451	1994-08-14	1994-08-14 00:00:00	1994-08-14	5001	0	\N	0	0	\N	\N	0	312751	0	6273-7	3006451		
273	9	3006322	2003-10-23	2003-10-23 00:00:00	2003-10-23	5001	0	\N	0	0	\N	\N	0	798	0	8331-1	3006322		
30319	2778	3021226	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	183976	0	6246-3	3021226		
50076	4557	3006322	1942-09-13	1942-09-13 00:00:00	1942-09-13	5001	0	\N	0	0	\N	\N	0	303621	0	8331-1	3006322		
32540	2955	3006322	2018-10-26	2018-10-26 00:00:00	2018-10-26	5001	0	\N	0	0	\N	\N	0	197227	0	8331-1	3006322		
25098	2300	3011505	2012-03-01	2012-03-01 00:00:00	2012-03-01	5001	0	\N	0	0	\N	\N	0	153135	0	19926-5	3011505		
1832	164	3006322	2011-12-23	2011-12-23 00:00:00	2011-12-23	5001	0	\N	0	0	\N	\N	0	11284	0	8331-1	3006322		
42080	3891	3020655	1983-11-05	1983-11-05 00:00:00	1983-11-05	5001	0	\N	0	0	\N	\N	0	258719	0	6844-5	3020655		
144	3	4052083	1969-03-17	1969-03-17 00:00:00	1969-03-17	5001	0	\N	0	0	\N	\N	0	220	0	23426006	4052083		
13005	411	4024958	2001-02-24	2001-02-24 00:00:00	2001-02-24	5001	0	\N	0	0	\N	\N	0	27263	0	117015009	4024958		
54101	1642	4052083	1951-06-22	1951-06-22 00:00:00	1951-06-22	5001	0	\N	0	0	\N	\N	0	110247	0	23426006	4052083		
15360	1407	3012494	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	93472	0	6206-7	3012494		
45120	4167	3015076	1979-06-28	1979-06-28 00:00:00	1979-06-28	5001	0	\N	0	0	\N	\N	0	276979	0	6248-9	3015076		
3640	349	3006322	1974-04-04	1974-04-04 00:00:00	1974-04-04	5001	0	\N	0	0	\N	\N	0	23198	0	8331-1	3006322		
2992	286	3006322	1973-10-03	1973-10-03 00:00:00	1973-10-03	5001	0	\N	0	0	\N	\N	0	19085	0	8331-1	3006322		
4745	449	3006322	1980-09-09	1980-09-09 00:00:00	1980-09-09	5001	0	\N	0	0	\N	\N	0	29862	0	8331-1	3006322		
37612	3464	3006734	2009-05-29	2009-05-29 00:00:00	2009-05-29	5001	0	\N	0	0	\N	\N	0	229905	0	6189-5	3006734		
28613	2647	3014599	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	175217	0	6106-9	3014599		
25657	2352	3001488	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	156675	0	7258-7	3001488		
56974	5222	3006322	1922-12-21	1922-12-21 00:00:00	1922-12-21	5001	0	\N	0	0	\N	\N	0	347509	0	8331-1	3006322		
39091	3615	3006322	2017-05-09	2017-05-09 00:00:00	2017-05-09	5001	0	\N	0	0	\N	\N	0	240172	0	8331-1	3006322		
3441	334	3006322	1958-08-02	1958-08-02 00:00:00	1958-08-02	5001	0	\N	0	0	\N	\N	0	22121	0	8331-1	3006322		
32075	2921	3011505	1987-05-26	1987-05-26 00:00:00	1987-05-26	5001	0	\N	0	0	\N	\N	0	194765	0	19926-5	3011505		
35312	3232	3051031	1969-10-14	1969-10-14 00:00:00	1969-10-14	5001	0	\N	0	0	\N	\N	0	214817	0	46240-8	3051031		
43413	4014	3006734	2001-06-12	2001-06-12 00:00:00	2001-06-12	5001	0	\N	0	0	\N	\N	0	266725	0	6189-5	3006734		
54799	5014	3006322	1956-12-15	1956-12-15 00:00:00	1956-12-15	5001	0	\N	0	0	\N	\N	0	333286	0	8331-1	3006322		
48179	4419	40766240	1956-10-20	1956-10-20 00:00:00	1956-10-20	5001	0	\N	0	0	\N	\N	0	293860	0	63513-6	40766240		
48302	4432	3006322	2019-01-02	2019-01-02 00:00:00	2019-01-02	5001	0	\N	0	0	\N	\N	0	294592	0	8331-1	3006322		
20175	1845	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	123389	0	6276-0	3027231		
51247	4689	3006322	1981-08-23	1981-08-23 00:00:00	1981-08-23	5001	0	\N	0	0	\N	\N	0	312414	0	8331-1	3006322		
51328	4694	3027231	1994-08-14	1994-08-14 00:00:00	1994-08-14	5001	0	\N	0	0	\N	\N	0	312751	0	6276-0	3027231		
274	9	3014599	1995-01-26	1995-01-26 00:00:00	1995-01-26	5001	0	\N	0	0	\N	\N	0	845	0	6106-9	3014599		
30320	2778	3027231	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	183976	0	6276-0	3027231		
50078	4557	40758406	1962-12-04	1962-12-04 00:00:00	1962-12-04	5001	0	\N	0	0	\N	\N	0	303646	0	55277-8	40758406		
32541	2955	3006322	1991-03-02	1991-03-02 00:00:00	1991-03-02	5001	0	\N	0	0	\N	\N	0	197206	0	8331-1	3006322		
25099	2300	3011505	1974-11-14	1974-11-14 00:00:00	1974-11-14	5001	0	\N	0	0	\N	\N	0	153199	0	19926-5	3011505		
1833	164	3006322	2000-05-30	2000-05-30 00:00:00	2000-05-30	5001	0	\N	0	0	\N	\N	0	11246	0	8331-1	3006322		
42081	3891	3000876	1983-11-05	1983-11-05 00:00:00	1983-11-05	5001	0	\N	0	0	\N	\N	0	258719	0	6082-2	3000876		
103398	3178	4024958	1961-12-28	1961-12-28 00:00:00	1961-12-28	5001	0	\N	0	0	\N	\N	0	211404	0	117015009	4024958		
13006	411	4052083	1982-06-01	1982-06-01 00:00:00	1982-06-01	5001	0	\N	0	0	\N	\N	0	27255	0	23426006	4052083		
54162	1646	4052083	2010-12-12	2010-12-12 00:00:00	2010-12-12	5001	0	\N	0	0	\N	\N	0	110382	0	23426006	4052083		
15361	1407	3021226	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	93472	0	6246-3	3021226		
45121	4167	3014599	1979-06-28	1979-06-28 00:00:00	1979-06-28	5001	0	\N	0	0	\N	\N	0	276979	0	6106-9	3014599		
3641	349	3006322	1968-07-02	1968-07-02 00:00:00	1968-07-02	5001	0	\N	0	0	\N	\N	0	23204	0	8331-1	3006322		
2993	286	3006322	1994-09-25	1994-09-25 00:00:00	1994-09-25	5001	0	\N	0	0	\N	\N	0	19094	0	8331-1	3006322		
4746	449	3011505	2013-08-15	2013-08-15 00:00:00	2013-08-15	5001	0	\N	0	0	\N	\N	0	29872	0	19926-5	3011505		
37613	3464	3036780	2009-05-29	2009-05-29 00:00:00	2009-05-29	5001	0	\N	0	0	\N	\N	0	229905	0	6095-4	3036780		
28614	2647	3019406	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	175217	0	6158-0	3019406		
25658	2352	3006451	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	156675	0	6273-7	3006451		
56975	5222	3011505	2013-04-04	2013-04-04 00:00:00	2013-04-04	5001	0	\N	0	0	\N	\N	0	347344	0	19926-5	3011505		
39092	3615	3006322	1960-10-16	1960-10-16 00:00:00	1960-10-16	5001	0	\N	0	0	\N	\N	0	240211	0	8331-1	3006322		
3442	334	3006322	1965-01-13	1965-01-13 00:00:00	1965-01-13	5001	0	\N	0	0	\N	\N	0	22146	0	8331-1	3006322		
32076	2921	3011505	2013-10-29	2013-10-29 00:00:00	2013-10-29	5001	0	\N	0	0	\N	\N	0	194750	0	19926-5	3011505		
35313	3232	46235214	1969-10-14	1969-10-14 00:00:00	1969-10-14	5001	0	\N	0	0	\N	\N	0	214817	0	76690-7	46235214		
43414	4014	3036780	2001-06-12	2001-06-12 00:00:00	2001-06-12	5001	0	\N	0	0	\N	\N	0	266725	0	6095-4	3036780		
54800	5014	3011505	1988-11-08	1988-11-08 00:00:00	1988-11-08	5001	0	\N	0	0	\N	\N	0	333278	0	19926-5	3011505		
160102	4924	4024958	2000-09-24	2000-09-24 00:00:00	2000-09-24	5001	0	\N	0	0	\N	\N	0	327200	0	117015009	4024958		
48303	4432	3006322	1959-10-01	1959-10-01 00:00:00	1959-10-01	5001	0	\N	0	0	\N	\N	0	294611	0	8331-1	3006322		
20176	1845	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	123389	0	6106-9	3014599		
51248	4689	3006322	1968-07-07	1968-07-07 00:00:00	1968-07-07	5001	0	\N	0	0	\N	\N	0	312443	0	8331-1	3006322		
51331	4696	3006322	1953-02-02	1953-02-02 00:00:00	1953-02-02	5001	0	\N	0	0	\N	\N	0	312820	0	8331-1	3006322		
275	9	3021226	1995-01-26	1995-01-26 00:00:00	1995-01-26	5001	0	\N	0	0	\N	\N	0	845	0	6246-3	3021226		
30321	2778	3001488	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	183976	0	7258-7	3001488		
50079	4557	40766240	1962-12-04	1962-12-04 00:00:00	1962-12-04	5001	0	\N	0	0	\N	\N	0	303646	0	63513-6	40766240		
32542	2955	3006322	1969-12-29	1969-12-29 00:00:00	1969-12-29	5001	0	\N	0	0	\N	\N	0	197274	0	8331-1	3006322		
25116	2307	3006322	1973-11-01	1973-11-01 00:00:00	1973-11-01	5001	0	\N	0	0	\N	\N	0	153527	0	8331-1	3006322		
1834	165	3006322	2002-09-14	2002-09-14 00:00:00	2002-09-14	5001	0	\N	0	0	\N	\N	0	11340	0	8331-1	3006322		
42082	3891	3027231	1983-11-05	1983-11-05 00:00:00	1983-11-05	5001	0	\N	0	0	\N	\N	0	258719	0	6276-0	3027231		
103400	3178	4024958	1958-12-04	1958-12-04 00:00:00	1958-12-04	5001	0	\N	0	0	\N	\N	0	211417	0	117015009	4024958		
13009	411	4024958	1995-11-07	1995-11-07 00:00:00	1995-11-07	5001	0	\N	0	0	\N	\N	0	27336	0	117015009	4024958		
15362	1407	3006734	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	93472	0	6189-5	3006734		
45122	4167	3019406	1979-06-28	1979-06-28 00:00:00	1979-06-28	5001	0	\N	0	0	\N	\N	0	276979	0	6158-0	3019406		
3642	349	3006322	1964-01-13	1964-01-13 00:00:00	1964-01-13	5001	0	\N	0	0	\N	\N	0	23196	0	8331-1	3006322		
2994	286	3006322	1969-03-18	1969-03-18 00:00:00	1969-03-18	5001	0	\N	0	0	\N	\N	0	19117	0	8331-1	3006322		
4747	449	3011505	2018-09-13	2018-09-13 00:00:00	2018-09-13	5001	0	\N	0	0	\N	\N	0	29985	0	19926-5	3011505		
37614	3464	3023430	2009-05-29	2009-05-29 00:00:00	2009-05-29	5001	0	\N	0	0	\N	\N	0	229905	0	6833-8	3023430		
28615	2647	3005136	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	175217	0	6075-6	3005136		
25659	2352	3021226	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	156675	0	6246-3	3021226		
56976	5222	3006322	1979-06-07	1979-06-07 00:00:00	1979-06-07	5001	0	\N	0	0	\N	\N	0	347410	0	8331-1	3006322		
39093	3615	3006322	1951-11-22	1951-11-22 00:00:00	1951-11-22	5001	0	\N	0	0	\N	\N	0	240177	0	8331-1	3006322		
3444	335	3006322	1973-10-24	1973-10-24 00:00:00	1973-10-24	5001	0	\N	0	0	\N	\N	0	22277	0	8331-1	3006322		
32077	2921	3011505	1978-06-13	1978-06-13 00:00:00	1978-06-13	5001	0	\N	0	0	\N	\N	0	194755	0	19926-5	3011505		
35315	3232	40766240	1969-10-14	1969-10-14 00:00:00	1969-10-14	5001	0	\N	0	0	\N	\N	0	214817	0	63513-6	40766240		
43415	4014	3012494	1997-12-09	1997-12-09 00:00:00	1997-12-09	5001	0	\N	0	0	\N	\N	0	266770	0	6206-7	3012494		
54801	5014	3011505	1990-11-20	1990-11-20 00:00:00	1990-11-20	5001	0	\N	0	0	\N	\N	0	333309	0	19926-5	3011505		
160129	4924	4024958	2014-03-18	2014-03-18 00:00:00	2014-03-18	5001	0	\N	0	0	\N	\N	0	327192	0	117015009	4024958		
48304	4433	3006322	1951-01-01	1951-01-01 00:00:00	1951-01-01	5001	0	\N	0	0	\N	\N	0	294665	0	8331-1	3006322		
20177	1845	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	123389	0	6248-9	3015076		
51249	4690	3006322	2015-04-09	2015-04-09 00:00:00	2015-04-09	5001	0	\N	0	0	\N	\N	0	312539	0	8331-1	3006322		
51332	4696	3006322	2005-01-11	2005-01-11 00:00:00	2005-01-11	5001	0	\N	0	0	\N	\N	0	312858	0	8331-1	3006322		
276	9	3020655	1995-01-26	1995-01-26 00:00:00	1995-01-26	5001	0	\N	0	0	\N	\N	0	845	0	6844-5	3020655		
30322	2778	3020655	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	183976	0	6844-5	3020655		
50081	4557	3051031	1962-12-04	1962-12-04 00:00:00	1962-12-04	5001	0	\N	0	0	\N	\N	0	303646	0	46240-8	3051031		
32543	2955	3006322	2003-04-30	2003-04-30 00:00:00	2003-04-30	5001	0	\N	0	0	\N	\N	0	197262	0	8331-1	3006322		
25117	2307	3006322	1977-05-25	1977-05-25 00:00:00	1977-05-25	5001	0	\N	0	0	\N	\N	0	153480	0	8331-1	3006322		
1835	165	3006322	2014-04-06	2014-04-06 00:00:00	2014-04-06	5001	0	\N	0	0	\N	\N	0	11341	0	8331-1	3006322		
42083	3891	3001247	1983-11-05	1983-11-05 00:00:00	1983-11-05	5001	0	\N	0	0	\N	\N	0	258719	0	6085-5	3001247		
103411	3179	4052083	1988-12-19	1988-12-19 00:00:00	1988-12-19	5001	0	\N	0	0	\N	\N	0	211488	0	23426006	4052083		
13027	411	4052083	1972-08-14	1972-08-14 00:00:00	1972-08-14	5001	0	\N	0	0	\N	\N	0	27268	0	23426006	4052083		
15363	1407	3005136	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	93472	0	6075-6	3005136		
45123	4167	3006451	1979-06-28	1979-06-28 00:00:00	1979-06-28	5001	0	\N	0	0	\N	\N	0	276979	0	6273-7	3006451		
3643	349	3006322	1959-07-26	1959-07-26 00:00:00	1959-07-26	5001	0	\N	0	0	\N	\N	0	23195	0	8331-1	3006322		
2995	286	3006322	1997-05-28	1997-05-28 00:00:00	1997-05-28	5001	0	\N	0	0	\N	\N	0	19140	0	8331-1	3006322		
4748	449	3012494	1984-11-21	1984-11-21 00:00:00	1984-11-21	5001	0	\N	0	0	\N	\N	0	29904	0	6206-7	3012494		
37615	3464	3020655	2009-05-29	2009-05-29 00:00:00	2009-05-29	5001	0	\N	0	0	\N	\N	0	229905	0	6844-5	3020655		
28616	2647	3027231	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	175217	0	6276-0	3027231		
25660	2352	3012494	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	156675	0	6206-7	3012494		
56977	5222	3006322	1997-05-18	1997-05-18 00:00:00	1997-05-18	5001	0	\N	0	0	\N	\N	0	347429	0	8331-1	3006322		
39094	3615	3006322	2018-08-15	2018-08-15 00:00:00	2018-08-15	5001	0	\N	0	0	\N	\N	0	240221	0	8331-1	3006322		
3445	335	3006322	2014-06-06	2014-06-06 00:00:00	2014-06-06	5001	0	\N	0	0	\N	\N	0	22282	0	8331-1	3006322		
32078	2921	3011505	1990-06-19	1990-06-19 00:00:00	1990-06-19	5001	0	\N	0	0	\N	\N	0	194757	0	19926-5	3011505		
35317	3232	3006322	1969-06-17	1969-06-17 00:00:00	1969-06-17	5001	0	\N	0	0	\N	\N	0	214816	0	8331-1	3006322		
43416	4014	3006451	1997-12-09	1997-12-09 00:00:00	1997-12-09	5001	0	\N	0	0	\N	\N	0	266770	0	6273-7	3006451		
54802	5014	3011505	1989-11-14	1989-11-14 00:00:00	1989-11-14	5001	0	\N	0	0	\N	\N	0	333279	0	19926-5	3011505		
48305	4433	3006322	1967-05-20	1967-05-20 00:00:00	1967-05-20	5001	0	\N	0	0	\N	\N	0	294666	0	8331-1	3006322		
20178	1845	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	123389	0	6273-7	3006451		
51250	4690	3049273	2016-10-01	2016-10-01 00:00:00	2016-10-01	5001	0	\N	0	0	\N	\N	0	312474	0	38265-5	3049273		
51333	4696	3006322	2014-07-15	2014-07-15 00:00:00	2014-07-15	5001	0	\N	0	0	\N	\N	0	312898	0	8331-1	3006322		
277	9	3001247	1995-01-26	1995-01-26 00:00:00	1995-01-26	5001	0	\N	0	0	\N	\N	0	845	0	6085-5	3001247		
30323	2778	3036780	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	183976	0	6095-4	3036780		
50082	4557	46235214	1962-12-04	1962-12-04 00:00:00	1962-12-04	5001	0	\N	0	0	\N	\N	0	303646	0	76690-7	46235214		
32544	2955	3006322	1995-05-13	1995-05-13 00:00:00	1995-05-13	5001	0	\N	0	0	\N	\N	0	197243	0	8331-1	3006322		
25118	2307	3049273	2013-02-07	2013-02-07 00:00:00	2013-02-07	5001	0	\N	0	0	\N	\N	0	153485	0	38265-5	3049273		
1836	165	3006322	2010-11-11	2010-11-11 00:00:00	2010-11-11	5001	0	\N	0	0	\N	\N	0	11342	0	8331-1	3006322		
42084	3891	3019406	1983-11-05	1983-11-05 00:00:00	1983-11-05	5001	0	\N	0	0	\N	\N	0	258719	0	6158-0	3019406		
103431	3179	4052083	1987-06-13	1987-06-13 00:00:00	1987-06-13	5001	0	\N	0	0	\N	\N	0	211514	0	23426006	4052083		
127631	3927	4024958	1948-10-22	1948-10-22 00:00:00	1948-10-22	5001	0	\N	0	0	\N	\N	0	261040	0	117015009	4024958		
15364	1407	3023430	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	93472	0	6833-8	3023430		
45124	4167	3027231	1979-06-28	1979-06-28 00:00:00	1979-06-28	5001	0	\N	0	0	\N	\N	0	276979	0	6276-0	3027231		
3644	350	3006322	1991-11-03	1991-11-03 00:00:00	1991-11-03	5001	0	\N	0	0	\N	\N	0	23332	0	8331-1	3006322		
2996	286	3049273	2016-05-08	2016-05-08 00:00:00	2016-05-08	5001	0	\N	0	0	\N	\N	0	19046	0	38265-5	3049273		
4749	449	3005136	1984-11-21	1984-11-21 00:00:00	1984-11-21	5001	0	\N	0	0	\N	\N	0	29904	0	6075-6	3005136		
37616	3464	3021226	2009-05-29	2009-05-29 00:00:00	2009-05-29	5001	0	\N	0	0	\N	\N	0	229905	0	6246-3	3021226		
53268	1613	4052083	1973-03-30	1973-03-30 00:00:00	1973-03-30	5001	0	\N	0	0	\N	\N	0	108481	0	23426006	4052083		
25661	2352	3014599	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	156675	0	6106-9	3014599		
56978	5222	3011505	2016-08-11	2016-08-11 00:00:00	2016-08-11	5001	0	\N	0	0	\N	\N	0	347428	0	19926-5	3011505		
39095	3615	3006322	1994-12-23	1994-12-23 00:00:00	1994-12-23	5001	0	\N	0	0	\N	\N	0	240181	0	8331-1	3006322		
3493	337	40766240	2016-12-07	2016-12-07 00:00:00	2016-12-07	5001	0	\N	0	0	\N	\N	0	22457	0	63513-6	40766240		
32079	2921	3011505	2005-09-13	2005-09-13 00:00:00	2005-09-13	5001	0	\N	0	0	\N	\N	0	194761	0	19926-5	3011505		
35323	3234	3006322	1972-07-21	1972-07-21 00:00:00	1972-07-21	5001	0	\N	0	0	\N	\N	0	214931	0	8331-1	3006322		
43417	4014	3027231	1997-12-09	1997-12-09 00:00:00	1997-12-09	5001	0	\N	0	0	\N	\N	0	266770	0	6276-0	3027231		
54803	5014	3011505	1991-11-26	1991-11-26 00:00:00	1991-11-26	5001	0	\N	0	0	\N	\N	0	333280	0	19926-5	3011505		
48306	4433	3006322	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	294646	0	8331-1	3006322		
20179	1845	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	123389	0	6844-5	3020655		
51251	4690	3006322	1998-01-12	1998-01-12 00:00:00	1998-01-12	5001	0	\N	0	0	\N	\N	0	312517	0	8331-1	3006322		
51334	4696	3006322	2006-01-16	2006-01-16 00:00:00	2006-01-16	5001	0	\N	0	0	\N	\N	0	312859	0	8331-1	3006322		
278	9	3000876	1995-01-26	1995-01-26 00:00:00	1995-01-26	5001	0	\N	0	0	\N	\N	0	845	0	6082-2	3000876		
30324	2778	3015076	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	183976	0	6248-9	3015076		
50083	4557	3006322	1965-03-12	1965-03-12 00:00:00	1965-03-12	5001	0	\N	0	0	\N	\N	0	303647	0	8331-1	3006322		
32545	2955	3006322	1974-08-27	1974-08-27 00:00:00	1974-08-27	5001	0	\N	0	0	\N	\N	0	197235	0	8331-1	3006322		
54569	4986	3006322	1958-01-14	1958-01-14 00:00:00	1958-01-14	5001	0	\N	0	0	\N	\N	0	331676	0	8331-1	3006322		
1868	170	3006322	1983-06-16	1983-06-16 00:00:00	1983-06-16	5001	0	\N	0	0	\N	\N	0	11531	0	8331-1	3006322		
42085	3891	3015076	1983-11-05	1983-11-05 00:00:00	1983-11-05	5001	0	\N	0	0	\N	\N	0	258719	0	6248-9	3015076		
103435	3179	4024958	1933-11-15	1933-11-15 00:00:00	1933-11-15	5001	0	\N	0	0	\N	\N	0	211512	0	117015009	4024958		
127637	3928	4024958	1993-10-28	1993-10-28 00:00:00	1993-10-28	5001	0	\N	0	0	\N	\N	0	261135	0	117015009	4024958		
15365	1407	3001247	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	93472	0	6085-5	3001247		
45125	4167	3021226	1979-06-28	1979-06-28 00:00:00	1979-06-28	5001	0	\N	0	0	\N	\N	0	276979	0	6246-3	3021226		
3645	350	3006322	1989-02-04	1989-02-04 00:00:00	1989-02-04	5001	0	\N	0	0	\N	\N	0	23331	0	8331-1	3006322		
2997	286	3006322	1973-02-19	1973-02-19 00:00:00	1973-02-19	5001	0	\N	0	0	\N	\N	0	19092	0	8331-1	3006322		
4750	449	3027231	1984-11-21	1984-11-21 00:00:00	1984-11-21	5001	0	\N	0	0	\N	\N	0	29904	0	6276-0	3027231		
37617	3464	3000876	2009-05-29	2009-05-29 00:00:00	2009-05-29	5001	0	\N	0	0	\N	\N	0	229905	0	6082-2	3000876		
53274	1613	4052083	1979-10-13	1979-10-13 00:00:00	1979-10-13	5001	0	\N	0	0	\N	\N	0	108438	0	23426006	4052083		
25662	2352	3027231	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	156675	0	6276-0	3027231		
56979	5223	3006322	1973-08-15	1973-08-15 00:00:00	1973-08-15	5001	0	\N	0	0	\N	\N	0	347597	0	8331-1	3006322		
39096	3615	3006322	1967-12-29	1967-12-29 00:00:00	1967-12-29	5001	0	\N	0	0	\N	\N	0	240242	0	8331-1	3006322		
3494	337	40758406	2016-12-07	2016-12-07 00:00:00	2016-12-07	5001	0	\N	0	0	\N	\N	0	22457	0	55277-8	40758406		
32080	2921	3006322	2005-08-20	2005-08-20 00:00:00	2005-08-20	5001	0	\N	0	0	\N	\N	0	194710	0	8331-1	3006322		
35324	3234	3006322	2002-03-07	2002-03-07 00:00:00	2002-03-07	5001	0	\N	0	0	\N	\N	0	214929	0	8331-1	3006322		
43418	4014	3023430	1997-12-09	1997-12-09 00:00:00	1997-12-09	5001	0	\N	0	0	\N	\N	0	266770	0	6833-8	3023430		
54804	5014	3011505	1995-12-19	1995-12-19 00:00:00	1995-12-19	5001	0	\N	0	0	\N	\N	0	333290	0	19926-5	3011505		
48307	4433	3006322	1950-03-23	1950-03-23 00:00:00	1950-03-23	5001	0	\N	0	0	\N	\N	0	294642	0	8331-1	3006322		
20180	1845	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	123389	0	6075-6	3005136		
51252	4690	3006322	2008-05-03	2008-05-03 00:00:00	2008-05-03	5001	0	\N	0	0	\N	\N	0	312538	0	8331-1	3006322		
51335	4696	3000963	1997-03-02	1997-03-02 00:00:00	1997-03-02	5001	0	\N	0	0	\N	\N	0	312822	0	718-7	3000963		
279	9	3027231	1995-01-26	1995-01-26 00:00:00	1995-01-26	5001	0	\N	0	0	\N	\N	0	845	0	6276-0	3027231		
350	12	46235214	2016-01-12	2016-01-12 00:00:00	2016-01-12	5001	0	\N	0	0	\N	\N	0	1005	0	76690-7	46235214		
50084	4557	3006322	1934-10-05	1934-10-05 00:00:00	1934-10-05	5001	0	\N	0	0	\N	\N	0	303602	0	8331-1	3006322		
32546	2955	3006322	2016-03-31	2016-03-31 00:00:00	2016-03-31	5001	0	\N	0	0	\N	\N	0	197244	0	8331-1	3006322		
54570	4986	3006322	2018-03-10	2018-03-10 00:00:00	2018-03-10	5001	0	\N	0	0	\N	\N	0	331653	0	8331-1	3006322		
1869	170	3006322	2001-03-06	2001-03-06 00:00:00	2001-03-06	5001	0	\N	0	0	\N	\N	0	11523	0	8331-1	3006322		
42086	3891	3036780	1983-11-05	1983-11-05 00:00:00	1983-11-05	5001	0	\N	0	0	\N	\N	0	258719	0	6095-4	3036780		
103438	3179	4052083	1996-02-04	1996-02-04 00:00:00	1996-02-04	5001	0	\N	0	0	\N	\N	0	211515	0	23426006	4052083		
127645	3928	4024958	2006-06-02	2006-06-02 00:00:00	2006-06-02	5001	0	\N	0	0	\N	\N	0	261137	0	117015009	4024958		
15366	1407	3020655	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	93472	0	6844-5	3020655		
45126	4167	3001247	1979-06-28	1979-06-28 00:00:00	1979-06-28	5001	0	\N	0	0	\N	\N	0	276979	0	6085-5	3001247		
3646	350	3006322	2019-04-15	2019-04-15 00:00:00	2019-04-15	5001	0	\N	0	0	\N	\N	0	23260	0	8331-1	3006322		
2998	286	3006322	1934-02-04	1934-02-04 00:00:00	1934-02-04	5001	0	\N	0	0	\N	\N	0	19089	0	8331-1	3006322		
4751	449	3014599	1984-11-21	1984-11-21 00:00:00	1984-11-21	5001	0	\N	0	0	\N	\N	0	29904	0	6106-9	3014599		
37618	3464	3001247	2009-05-29	2009-05-29 00:00:00	2009-05-29	5001	0	\N	0	0	\N	\N	0	229905	0	6085-5	3001247		
53281	1613	4024958	1990-07-30	1990-07-30 00:00:00	1990-07-30	5001	0	\N	0	0	\N	\N	0	108483	0	117015009	4024958		
25663	2352	3005136	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	156675	0	6075-6	3005136		
56980	5223	3006322	2015-05-18	2015-05-18 00:00:00	2015-05-18	5001	0	\N	0	0	\N	\N	0	347532	0	8331-1	3006322		
39097	3615	3006322	1965-08-31	1965-08-31 00:00:00	1965-08-31	5001	0	\N	0	0	\N	\N	0	240212	0	8331-1	3006322		
3495	337	46235214	2016-12-07	2016-12-07 00:00:00	2016-12-07	5001	0	\N	0	0	\N	\N	0	22457	0	76690-7	46235214		
32081	2921	3011505	2011-10-18	2011-10-18 00:00:00	2011-10-18	5001	0	\N	0	0	\N	\N	0	194706	0	19926-5	3011505		
35325	3234	3006322	1975-11-12	1975-11-12 00:00:00	1975-11-12	5001	0	\N	0	0	\N	\N	0	214924	0	8331-1	3006322		
43419	4014	3020655	1997-12-09	1997-12-09 00:00:00	1997-12-09	5001	0	\N	0	0	\N	\N	0	266770	0	6844-5	3020655		
54805	5014	3006322	1981-08-17	1981-08-17 00:00:00	1981-08-17	5001	0	\N	0	0	\N	\N	0	333267	0	8331-1	3006322		
48308	4433	3006322	1997-07-31	1997-07-31 00:00:00	1997-07-31	5001	0	\N	0	0	\N	\N	0	294656	0	8331-1	3006322		
20181	1846	3049273	2018-01-26	2018-01-26 00:00:00	2018-01-26	5001	0	\N	0	0	\N	\N	0	123470	0	38265-5	3049273		
51253	4690	3006322	1997-10-03	1997-10-03 00:00:00	1997-10-03	5001	0	\N	0	0	\N	\N	0	312523	0	8331-1	3006322		
51336	4696	3009542	1997-03-02	1997-03-02 00:00:00	1997-03-02	5001	0	\N	0	0	\N	\N	0	312822	0	20570-8	3009542		
280	9	3019406	1995-01-26	1995-01-26 00:00:00	1995-01-26	5001	0	\N	0	0	\N	\N	0	845	0	6158-0	3019406		
11695	1107	3006322	2002-05-30	2002-05-30 00:00:00	2002-05-30	5001	0	\N	0	0	\N	\N	0	72930	0	8331-1	3006322		
50085	4557	3006322	1997-04-19	1997-04-19 00:00:00	1997-04-19	5001	0	\N	0	0	\N	\N	0	303579	0	8331-1	3006322		
32549	2957	3049273	2008-02-02	2008-02-02 00:00:00	2008-02-02	5001	0	\N	0	0	\N	\N	0	197327	0	38265-5	3049273		
54571	4986	3006322	1990-03-05	1990-03-05 00:00:00	1990-03-05	5001	0	\N	0	0	\N	\N	0	331693	0	8331-1	3006322		
1870	170	3006322	2003-12-21	2003-12-21 00:00:00	2003-12-21	5001	0	\N	0	0	\N	\N	0	11535	0	8331-1	3006322		
42087	3891	3006322	2018-09-19	2018-09-19 00:00:00	2018-09-19	5001	0	\N	0	0	\N	\N	0	258696	0	8331-1	3006322		
103443	3179	4024958	1922-05-23	1922-05-23 00:00:00	1922-05-23	5001	0	\N	0	0	\N	\N	0	211486	0	117015009	4024958		
127647	3929	4133840	2002-12-30	2002-12-30 00:00:00	2002-12-30	5001	0	\N	0	0	\N	\N	0	261164	0	127783003	4133840		
15367	1407	3000876	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	93472	0	6082-2	3000876		
45127	4167	3006734	1979-06-28	1979-06-28 00:00:00	1979-06-28	5001	0	\N	0	0	\N	\N	0	276979	0	6189-5	3006734		
3647	350	3006322	1994-03-03	1994-03-03 00:00:00	1994-03-03	5001	0	\N	0	0	\N	\N	0	23326	0	8331-1	3006322		
2999	287	3006322	1993-07-01	1993-07-01 00:00:00	1993-07-01	5001	0	\N	0	0	\N	\N	0	19188	0	8331-1	3006322		
4752	449	3021226	1984-11-21	1984-11-21 00:00:00	1984-11-21	5001	0	\N	0	0	\N	\N	0	29904	0	6246-3	3021226		
37619	3464	3005136	2009-05-29	2009-05-29 00:00:00	2009-05-29	5001	0	\N	0	0	\N	\N	0	229905	0	6075-6	3005136		
53283	1613	4052083	1959-12-17	1959-12-17 00:00:00	1959-12-17	5001	0	\N	0	0	\N	\N	0	108480	0	23426006	4052083		
25664	2352	3019406	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	156675	0	6158-0	3019406		
56981	5223	3006322	2014-11-06	2014-11-06 00:00:00	2014-11-06	5001	0	\N	0	0	\N	\N	0	347593	0	8331-1	3006322		
39098	3616	3006322	1982-04-04	1982-04-04 00:00:00	1982-04-04	5001	0	\N	0	0	\N	\N	0	240271	0	8331-1	3006322		
3496	337	3051031	2016-12-07	2016-12-07 00:00:00	2016-12-07	5001	0	\N	0	0	\N	\N	0	22457	0	46240-8	3051031		
32082	2921	3011505	2000-08-15	2000-08-15 00:00:00	2000-08-15	5001	0	\N	0	0	\N	\N	0	194746	0	19926-5	3011505		
35327	3234	3006322	1976-09-20	1976-09-20 00:00:00	1976-09-20	5001	0	\N	0	0	\N	\N	0	214925	0	8331-1	3006322		
43420	4014	3001488	1997-12-09	1997-12-09 00:00:00	1997-12-09	5001	0	\N	0	0	\N	\N	0	266770	0	7258-7	3001488		
54806	5014	3006322	1927-11-20	1927-11-20 00:00:00	1927-11-20	5001	0	\N	0	0	\N	\N	0	333259	0	8331-1	3006322		
48309	4433	3049273	2015-12-12	2015-12-12 00:00:00	2015-12-12	5001	0	\N	0	0	\N	\N	0	294731	0	38265-5	3049273		
20182	1846	3006322	1968-11-04	1968-11-04 00:00:00	1968-11-04	5001	0	\N	0	0	\N	\N	0	123397	0	8331-1	3006322		
51254	4691	3006322	1968-05-08	1968-05-08 00:00:00	1968-05-08	5001	0	\N	0	0	\N	\N	0	312572	0	8331-1	3006322		
51358	4700	3006322	1959-01-09	1959-01-09 00:00:00	1959-01-09	5001	0	\N	0	0	\N	\N	0	313021	0	8331-1	3006322		
281	9	3006451	1995-01-26	1995-01-26 00:00:00	1995-01-26	5001	0	\N	0	0	\N	\N	0	845	0	6273-7	3006451		
11696	1107	3006322	2001-03-21	2001-03-21 00:00:00	2001-03-21	5001	0	\N	0	0	\N	\N	0	72844	0	8331-1	3006322		
50086	4557	3006322	1934-11-16	1934-11-16 00:00:00	1934-11-16	5001	0	\N	0	0	\N	\N	0	303572	0	8331-1	3006322		
32550	2957	3006322	1948-08-29	1948-08-29 00:00:00	1948-08-29	5001	0	\N	0	0	\N	\N	0	197371	0	8331-1	3006322		
54572	4986	3006322	2009-03-03	2009-03-03 00:00:00	2009-03-03	5001	0	\N	0	0	\N	\N	0	331652	0	8331-1	3006322		
1871	170	3006322	1973-01-26	1973-01-26 00:00:00	1973-01-26	5001	0	\N	0	0	\N	\N	0	11522	0	8331-1	3006322		
42088	3891	3006322	1988-10-24	1988-10-24 00:00:00	1988-10-24	5001	0	\N	0	0	\N	\N	0	258722	0	8331-1	3006322		
114744	3536	4052083	1990-11-16	1990-11-16 00:00:00	1990-11-16	5001	0	\N	0	0	\N	\N	0	234842	0	23426006	4052083		
127650	3929	4133840	1993-01-11	1993-01-11 00:00:00	1993-01-11	5001	0	\N	0	0	\N	\N	0	261221	0	127783003	4133840		
15368	1407	3001488	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	93472	0	7258-7	3001488		
45128	4167	3001488	1979-06-28	1979-06-28 00:00:00	1979-06-28	5001	0	\N	0	0	\N	\N	0	276979	0	7258-7	3001488		
3648	350	3006322	1968-07-16	1968-07-16 00:00:00	1968-07-16	5001	0	\N	0	0	\N	\N	0	23298	0	8331-1	3006322		
3000	287	3006322	1997-02-03	1997-02-03 00:00:00	1997-02-03	5001	0	\N	0	0	\N	\N	0	19190	0	8331-1	3006322		
4753	449	3019406	1984-11-21	1984-11-21 00:00:00	1984-11-21	5001	0	\N	0	0	\N	\N	0	29904	0	6158-0	3019406		
37620	3464	3014599	2009-05-29	2009-05-29 00:00:00	2009-05-29	5001	0	\N	0	0	\N	\N	0	229905	0	6106-9	3014599		
53295	1613	4052083	1966-03-04	1966-03-04 00:00:00	1966-03-04	5001	0	\N	0	0	\N	\N	0	108437	0	23426006	4052083		
25665	2352	3000876	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	156675	0	6082-2	3000876		
56982	5223	3006322	1968-04-22	1968-04-22 00:00:00	1968-04-22	5001	0	\N	0	0	\N	\N	0	347573	0	8331-1	3006322		
39099	3616	3006322	1970-08-18	1970-08-18 00:00:00	1970-08-18	5001	0	\N	0	0	\N	\N	0	240298	0	8331-1	3006322		
3499	337	3006322	2010-01-09	2010-01-09 00:00:00	2010-01-09	5001	0	\N	0	0	\N	\N	0	22447	0	8331-1	3006322		
32083	2921	3011505	1975-06-10	1975-06-10 00:00:00	1975-06-10	5001	0	\N	0	0	\N	\N	0	194754	0	19926-5	3011505		
35328	3234	3006322	1987-10-09	1987-10-09 00:00:00	1987-10-09	5001	0	\N	0	0	\N	\N	0	214926	0	8331-1	3006322		
43421	4014	3015076	1997-12-09	1997-12-09 00:00:00	1997-12-09	5001	0	\N	0	0	\N	\N	0	266770	0	6248-9	3015076		
54807	5014	3006322	1916-09-24	1916-09-24 00:00:00	1916-09-24	5001	0	\N	0	0	\N	\N	0	333247	0	8331-1	3006322		
48310	4433	3006322	2019-03-19	2019-03-19 00:00:00	2019-03-19	5001	0	\N	0	0	\N	\N	0	294647	0	8331-1	3006322		
20183	1846	3006322	2010-12-18	2010-12-18 00:00:00	2010-12-18	5001	0	\N	0	0	\N	\N	0	123461	0	8331-1	3006322		
51255	4691	3006322	1980-05-14	1980-05-14 00:00:00	1980-05-14	5001	0	\N	0	0	\N	\N	0	312575	0	8331-1	3006322		
51359	4700	3006322	1955-08-31	1955-08-31 00:00:00	1955-08-31	5001	0	\N	0	0	\N	\N	0	313118	0	8331-1	3006322		
282	9	3005136	1995-01-26	1995-01-26 00:00:00	1995-01-26	5001	0	\N	0	0	\N	\N	0	845	0	6075-6	3005136		
11697	1107	3006322	1956-12-20	1956-12-20 00:00:00	1956-12-20	5001	0	\N	0	0	\N	\N	0	72928	0	8331-1	3006322		
50087	4557	3049273	1990-08-12	1990-08-12 00:00:00	1990-08-12	5001	0	\N	0	0	\N	\N	0	303660	0	38265-5	3049273		
32551	2957	3006322	1988-04-04	1988-04-04 00:00:00	1988-04-04	5001	0	\N	0	0	\N	\N	0	197301	0	8331-1	3006322		
54573	4986	3006322	1976-09-30	1976-09-30 00:00:00	1976-09-30	5001	0	\N	0	0	\N	\N	0	331623	0	8331-1	3006322		
1872	170	3006322	1992-09-06	1992-09-06 00:00:00	1992-09-06	5001	0	\N	0	0	\N	\N	0	11533	0	8331-1	3006322		
42089	3892	3006322	1977-06-22	1977-06-22 00:00:00	1977-06-22	5001	0	\N	0	0	\N	\N	0	258799	0	8331-1	3006322		
114746	3536	4052083	2005-12-09	2005-12-09 00:00:00	2005-12-09	5001	0	\N	0	0	\N	\N	0	234828	0	23426006	4052083		
127655	3929	4133840	1999-12-20	1999-12-20 00:00:00	1999-12-20	5001	0	\N	0	0	\N	\N	0	261163	0	127783003	4133840		
15369	1407	3036780	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	93472	0	6095-4	3036780		
45129	4167	3012494	1979-06-28	1979-06-28 00:00:00	1979-06-28	5001	0	\N	0	0	\N	\N	0	276979	0	6206-7	3012494		
3649	350	3006322	2017-05-10	2017-05-10 00:00:00	2017-05-10	5001	0	\N	0	0	\N	\N	0	23313	0	8331-1	3006322		
3001	287	3006322	1994-05-09	1994-05-09 00:00:00	1994-05-09	5001	0	\N	0	0	\N	\N	0	19189	0	8331-1	3006322		
4754	450	3006322	2003-03-16	2003-03-16 00:00:00	2003-03-16	5001	0	\N	0	0	\N	\N	0	30007	0	8331-1	3006322		
37621	3464	3019406	2009-05-29	2009-05-29 00:00:00	2009-05-29	5001	0	\N	0	0	\N	\N	0	229905	0	6158-0	3019406		
99321	3049	4052083	1997-10-14	1997-10-14 00:00:00	1997-10-14	5001	0	\N	0	0	\N	\N	0	202849	0	23426006	4052083		
25666	2352	3006734	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	156675	0	6189-5	3006734		
56983	5223	3006322	1990-05-01	1990-05-01 00:00:00	1990-05-01	5001	0	\N	0	0	\N	\N	0	347550	0	8331-1	3006322		
39100	3616	3006322	1998-10-19	1998-10-19 00:00:00	1998-10-19	5001	0	\N	0	0	\N	\N	0	240314	0	8331-1	3006322		
3500	337	40758406	2016-10-08	2016-10-08 00:00:00	2016-10-08	5001	0	\N	0	0	\N	\N	0	22449	0	55277-8	40758406		
32084	2921	3011505	1982-06-29	1982-06-29 00:00:00	1982-06-29	5001	0	\N	0	0	\N	\N	0	194785	0	19926-5	3011505		
35334	3236	3049273	2013-10-09	2013-10-09 00:00:00	2013-10-09	5001	0	\N	0	0	\N	\N	0	215033	0	38265-5	3049273		
43422	4014	3000876	1997-12-09	1997-12-09 00:00:00	1997-12-09	5001	0	\N	0	0	\N	\N	0	266770	0	6082-2	3000876		
54808	5014	3006322	1921-09-11	1921-09-11 00:00:00	1921-09-11	5001	0	\N	0	0	\N	\N	0	333234	0	8331-1	3006322		
48311	4435	3006322	1973-07-31	1973-07-31 00:00:00	1973-07-31	5001	0	\N	0	0	\N	\N	0	294780	0	8331-1	3006322		
20184	1846	3006322	1976-07-09	1976-07-09 00:00:00	1976-07-09	5001	0	\N	0	0	\N	\N	0	123458	0	8331-1	3006322		
51256	4691	3006322	1974-02-28	1974-02-28 00:00:00	1974-02-28	5001	0	\N	0	0	\N	\N	0	312587	0	8331-1	3006322		
51360	4700	3006322	1958-01-03	1958-01-03 00:00:00	1958-01-03	5001	0	\N	0	0	\N	\N	0	313052	0	8331-1	3006322		
283	9	3015076	1995-01-26	1995-01-26 00:00:00	1995-01-26	5001	0	\N	0	0	\N	\N	0	845	0	6248-9	3015076		
11698	1107	3049273	2004-12-09	2004-12-09 00:00:00	2004-12-09	5001	0	\N	0	0	\N	\N	0	72858	0	38265-5	3049273		
50088	4559	3006322	1985-12-28	1985-12-28 00:00:00	1985-12-28	5001	0	\N	0	0	\N	\N	0	303793	0	8331-1	3006322		
32552	2957	3006322	1977-06-21	1977-06-21 00:00:00	1977-06-21	5001	0	\N	0	0	\N	\N	0	197353	0	8331-1	3006322		
54574	4986	3006322	2017-12-24	2017-12-24 00:00:00	2017-12-24	5001	0	\N	0	0	\N	\N	0	331624	0	8331-1	3006322		
1873	170	3006322	2002-05-14	2002-05-14 00:00:00	2002-05-14	5001	0	\N	0	0	\N	\N	0	11578	0	8331-1	3006322		
42090	3892	3006322	1968-06-15	1968-06-15 00:00:00	1968-06-15	5001	0	\N	0	0	\N	\N	0	258792	0	8331-1	3006322		
114750	3536	4024958	1975-09-29	1975-09-29 00:00:00	1975-09-29	5001	0	\N	0	0	\N	\N	0	234827	0	117015009	4024958		
127657	3929	4133840	2005-01-10	2005-01-10 00:00:00	2005-01-10	5001	0	\N	0	0	\N	\N	0	261222	0	127783003	4133840		
15370	1407	3006322	2012-10-02	2012-10-02 00:00:00	2012-10-02	5001	0	\N	0	0	\N	\N	0	93485	0	8331-1	3006322		
45130	4167	3000876	1979-06-28	1979-06-28 00:00:00	1979-06-28	5001	0	\N	0	0	\N	\N	0	276979	0	6082-2	3000876		
3650	350	3006322	1980-06-10	1980-06-10 00:00:00	1980-06-10	5001	0	\N	0	0	\N	\N	0	23325	0	8331-1	3006322		
3002	287	3006322	2003-02-16	2003-02-16 00:00:00	2003-02-16	5001	0	\N	0	0	\N	\N	0	19208	0	8331-1	3006322		
4755	450	3006322	1998-03-30	1998-03-30 00:00:00	1998-03-30	5001	0	\N	0	0	\N	\N	0	29995	0	8331-1	3006322		
37622	3464	3006451	2009-05-29	2009-05-29 00:00:00	2009-05-29	5001	0	\N	0	0	\N	\N	0	229905	0	6273-7	3006451		
99324	3049	4052083	1997-09-05	1997-09-05 00:00:00	1997-09-05	5001	0	\N	0	0	\N	\N	0	202848	0	23426006	4052083		
25667	2352	3036780	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	156675	0	6095-4	3036780		
56984	5223	3006322	1972-06-08	1972-06-08 00:00:00	1972-06-08	5001	0	\N	0	0	\N	\N	0	347586	0	8331-1	3006322		
39101	3616	3006322	1969-01-11	1969-01-11 00:00:00	1969-01-11	5001	0	\N	0	0	\N	\N	0	240260	0	8331-1	3006322		
3501	337	46235214	2016-10-08	2016-10-08 00:00:00	2016-10-08	5001	0	\N	0	0	\N	\N	0	22449	0	76690-7	46235214		
32085	2921	3006322	1956-02-27	1956-02-27 00:00:00	1956-02-27	5001	0	\N	0	0	\N	\N	0	194722	0	8331-1	3006322		
35335	3236	3006322	1953-10-03	1953-10-03 00:00:00	1953-10-03	5001	0	\N	0	0	\N	\N	0	215064	0	8331-1	3006322		
43423	4014	3001247	1997-12-09	1997-12-09 00:00:00	1997-12-09	5001	0	\N	0	0	\N	\N	0	266770	0	6085-5	3001247		
54809	5014	3011505	1994-12-13	1994-12-13 00:00:00	1994-12-13	5001	0	\N	0	0	\N	\N	0	333257	0	19926-5	3011505		
48312	4435	3049273	2015-09-28	2015-09-28 00:00:00	2015-09-28	5001	0	\N	0	0	\N	\N	0	294783	0	38265-5	3049273		
20185	1846	3049273	2007-04-24	2007-04-24 00:00:00	2007-04-24	5001	0	\N	0	0	\N	\N	0	123469	0	38265-5	3049273		
51257	4691	3006322	1969-10-09	1969-10-09 00:00:00	1969-10-09	5001	0	\N	0	0	\N	\N	0	312600	0	8331-1	3006322		
51361	4701	3006322	1976-08-28	1976-08-28 00:00:00	1976-08-28	5001	0	\N	0	0	\N	\N	0	313125	0	8331-1	3006322		
284	9	3012494	1995-01-26	1995-01-26 00:00:00	1995-01-26	5001	0	\N	0	0	\N	\N	0	845	0	6206-7	3012494		
11699	1107	3006322	1979-04-07	1979-04-07 00:00:00	1979-04-07	5001	0	\N	0	0	\N	\N	0	72914	0	8331-1	3006322		
50089	4559	3006322	1956-11-18	1956-11-18 00:00:00	1956-11-18	5001	0	\N	0	0	\N	\N	0	303709	0	8331-1	3006322		
32553	2957	3006322	1958-02-20	1958-02-20 00:00:00	1958-02-20	5001	0	\N	0	0	\N	\N	0	197341	0	8331-1	3006322		
54575	4986	3006322	1959-04-20	1959-04-20 00:00:00	1959-04-20	5001	0	\N	0	0	\N	\N	0	331650	0	8331-1	3006322		
1874	171	3006322	1991-11-02	1991-11-02 00:00:00	1991-11-02	5001	0	\N	0	0	\N	\N	0	11626	0	8331-1	3006322		
42091	3892	3006322	1972-03-09	1972-03-09 00:00:00	1972-03-09	5001	0	\N	0	0	\N	\N	0	258798	0	8331-1	3006322		
114752	3536	4024958	1996-06-23	1996-06-23 00:00:00	1996-06-23	5001	0	\N	0	0	\N	\N	0	234815	0	117015009	4024958		
127659	3929	4133840	1990-04-09	1990-04-09 00:00:00	1990-04-09	5001	0	\N	0	0	\N	\N	0	261209	0	127783003	4133840		
15371	1408	3006322	1943-12-31	1943-12-31 00:00:00	1943-12-31	5001	0	\N	0	0	\N	\N	0	93636	0	8331-1	3006322		
45131	4167	3023430	1979-06-28	1979-06-28 00:00:00	1979-06-28	5001	0	\N	0	0	\N	\N	0	276979	0	6833-8	3023430		
3651	350	3006322	1971-10-25	1971-10-25 00:00:00	1971-10-25	5001	0	\N	0	0	\N	\N	0	23323	0	8331-1	3006322		
3003	287	3006322	1978-01-04	1978-01-04 00:00:00	1978-01-04	5001	0	\N	0	0	\N	\N	0	19177	0	8331-1	3006322		
4756	450	3006322	2017-04-25	2017-04-25 00:00:00	2017-04-25	5001	0	\N	0	0	\N	\N	0	30009	0	8331-1	3006322		
37623	3464	3027231	2009-05-29	2009-05-29 00:00:00	2009-05-29	5001	0	\N	0	0	\N	\N	0	229905	0	6276-0	3027231		
99327	3049	4024958	2013-10-03	2013-10-03 00:00:00	2013-10-03	5001	0	\N	0	0	\N	\N	0	202890	0	117015009	4024958		
25668	2352	3015076	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	156675	0	6248-9	3015076		
57006	5228	3049273	2013-08-30	2013-08-30 00:00:00	2013-08-30	5001	0	\N	0	0	\N	\N	0	347863	0	38265-5	3049273		
39102	3616	3006322	1967-02-09	1967-02-09 00:00:00	1967-02-09	5001	0	\N	0	0	\N	\N	0	240270	0	8331-1	3006322		
3502	337	40766240	2016-10-08	2016-10-08 00:00:00	2016-10-08	5001	0	\N	0	0	\N	\N	0	22449	0	63513-6	40766240		
32086	2921	3006322	1988-04-04	1988-04-04 00:00:00	1988-04-04	5001	0	\N	0	0	\N	\N	0	194768	0	8331-1	3006322		
35336	3236	3006322	1998-09-23	1998-09-23 00:00:00	1998-09-23	5001	0	\N	0	0	\N	\N	0	215113	0	8331-1	3006322		
43424	4014	3006734	1997-12-09	1997-12-09 00:00:00	1997-12-09	5001	0	\N	0	0	\N	\N	0	266770	0	6189-5	3006734		
54810	5014	3011505	1992-12-01	1992-12-01 00:00:00	1992-12-01	5001	0	\N	0	0	\N	\N	0	333310	0	19926-5	3011505		
48313	4435	3006322	1976-08-26	1976-08-26 00:00:00	1976-08-26	5001	0	\N	0	0	\N	\N	0	294758	0	8331-1	3006322		
20186	1846	3006322	1956-03-03	1956-03-03 00:00:00	1956-03-03	5001	0	\N	0	0	\N	\N	0	123429	0	8331-1	3006322		
51258	4691	3006322	1967-04-03	1967-04-03 00:00:00	1967-04-03	5001	0	\N	0	0	\N	\N	0	312574	0	8331-1	3006322		
51362	4701	3006322	2010-03-24	2010-03-24 00:00:00	2010-03-24	5001	0	\N	0	0	\N	\N	0	313164	0	8331-1	3006322		
285	9	3001488	1995-01-26	1995-01-26 00:00:00	1995-01-26	5001	0	\N	0	0	\N	\N	0	845	0	7258-7	3001488		
11700	1107	3006322	1930-08-13	1930-08-13 00:00:00	1930-08-13	5001	0	\N	0	0	\N	\N	0	72927	0	8331-1	3006322		
50090	4559	3006322	1995-09-20	1995-09-20 00:00:00	1995-09-20	5001	0	\N	0	0	\N	\N	0	303755	0	8331-1	3006322		
6824	653	3006322	1979-06-21	1979-06-21 00:00:00	1979-06-21	5001	0	\N	0	0	\N	\N	0	43220	0	8331-1	3006322		
54576	4987	3006322	1990-11-25	1990-11-25 00:00:00	1990-11-25	5001	0	\N	0	0	\N	\N	0	331759	0	8331-1	3006322		
1875	171	3006322	1972-03-22	1972-03-22 00:00:00	1972-03-22	5001	0	\N	0	0	\N	\N	0	11582	0	8331-1	3006322		
42092	3892	3006322	1984-01-27	1984-01-27 00:00:00	1984-01-27	5001	0	\N	0	0	\N	\N	0	258800	0	8331-1	3006322		
69465	2130	4024958	1971-08-24	1971-08-24 00:00:00	1971-08-24	5001	0	\N	0	0	\N	\N	0	141695	0	117015009	4024958		
127663	3929	4024958	1993-11-07	1993-11-07 00:00:00	1993-11-07	5001	0	\N	0	0	\N	\N	0	261156	0	117015009	4024958		
15372	1408	3006322	1989-06-26	1989-06-26 00:00:00	1989-06-26	5001	0	\N	0	0	\N	\N	0	93643	0	8331-1	3006322		
45132	4167	3020655	1979-06-28	1979-06-28 00:00:00	1979-06-28	5001	0	\N	0	0	\N	\N	0	276979	0	6844-5	3020655		
3652	350	3006322	1970-12-16	1970-12-16 00:00:00	1970-12-16	5001	0	\N	0	0	\N	\N	0	23324	0	8331-1	3006322		
3004	287	3006322	2013-12-31	2013-12-31 00:00:00	2013-12-31	5001	0	\N	0	0	\N	\N	0	19210	0	8331-1	3006322		
4757	450	3006322	2004-07-22	2004-07-22 00:00:00	2004-07-22	5001	0	\N	0	0	\N	\N	0	30022	0	8331-1	3006322		
37624	3464	3001488	2009-05-29	2009-05-29 00:00:00	2009-05-29	5001	0	\N	0	0	\N	\N	0	229905	0	7258-7	3001488		
99331	3049	4024958	2014-10-10	2014-10-10 00:00:00	2014-10-10	5001	0	\N	0	0	\N	\N	0	202851	0	117015009	4024958		
25669	2352	3006322	2013-02-10	2013-02-10 00:00:00	2013-02-10	5001	0	\N	0	0	\N	\N	0	156603	0	8331-1	3006322		
57007	5228	3006322	1956-09-30	1956-09-30 00:00:00	1956-09-30	5001	0	\N	0	0	\N	\N	0	347784	0	8331-1	3006322		
39103	3618	3049273	1982-06-20	1982-06-20 00:00:00	1982-06-20	5001	0	\N	0	0	\N	\N	0	240343	0	38265-5	3049273		
3503	337	3051031	2016-10-08	2016-10-08 00:00:00	2016-10-08	5001	0	\N	0	0	\N	\N	0	22449	0	46240-8	3051031		
32087	2921	3006322	1960-05-18	1960-05-18 00:00:00	1960-05-18	5001	0	\N	0	0	\N	\N	0	194695	0	8331-1	3006322		
35337	3236	3049273	2014-09-05	2014-09-05 00:00:00	2014-09-05	5001	0	\N	0	0	\N	\N	0	215106	0	38265-5	3049273		
43425	4014	3036780	1997-12-09	1997-12-09 00:00:00	1997-12-09	5001	0	\N	0	0	\N	\N	0	266770	0	6095-4	3036780		
54811	5014	3011505	1985-10-22	1985-10-22 00:00:00	1985-10-22	5001	0	\N	0	0	\N	\N	0	333307	0	19926-5	3011505		
48314	4435	3006322	2005-11-09	2005-11-09 00:00:00	2005-11-09	5001	0	\N	0	0	\N	\N	0	294806	0	8331-1	3006322		
20187	1847	3006322	1941-12-25	1941-12-25 00:00:00	1941-12-25	5001	0	\N	0	0	\N	\N	0	123574	0	8331-1	3006322		
51282	4694	3000876	1998-02-15	1998-02-15 00:00:00	1998-02-15	5001	0	\N	0	0	\N	\N	0	312735	0	6082-2	3000876		
51363	4701	3006322	1990-02-25	1990-02-25 00:00:00	1990-02-25	5001	0	\N	0	0	\N	\N	0	313162	0	8331-1	3006322		
286	9	3006734	1995-01-26	1995-01-26 00:00:00	1995-01-26	5001	0	\N	0	0	\N	\N	0	845	0	6189-5	3006734		
11701	1107	3006322	1929-04-09	1929-04-09 00:00:00	1929-04-09	5001	0	\N	0	0	\N	\N	0	72911	0	8331-1	3006322		
50091	4559	3049273	2015-07-28	2015-07-28 00:00:00	2015-07-28	5001	0	\N	0	0	\N	\N	0	303732	0	38265-5	3049273		
6825	653	3006322	1962-04-13	1962-04-13 00:00:00	1962-04-13	5001	0	\N	0	0	\N	\N	0	43252	0	8331-1	3006322		
54577	4987	3006322	2008-09-16	2008-09-16 00:00:00	2008-09-16	5001	0	\N	0	0	\N	\N	0	331712	0	8331-1	3006322		
1876	171	3006322	1996-08-17	1996-08-17 00:00:00	1996-08-17	5001	0	\N	0	0	\N	\N	0	11595	0	8331-1	3006322		
42093	3892	3006322	1967-06-06	1967-06-06 00:00:00	1967-06-06	5001	0	\N	0	0	\N	\N	0	258775	0	8331-1	3006322		
69472	2130	4024958	1977-02-18	1977-02-18 00:00:00	1977-02-18	5001	0	\N	0	0	\N	\N	0	141696	0	117015009	4024958		
127665	3929	4133840	2004-01-05	2004-01-05 00:00:00	2004-01-05	5001	0	\N	0	0	\N	\N	0	261183	0	127783003	4133840		
15373	1408	3006322	2011-11-07	2011-11-07 00:00:00	2011-11-07	5001	0	\N	0	0	\N	\N	0	93594	0	8331-1	3006322		
45133	4167	3036780	1979-06-28	1979-06-28 00:00:00	1979-06-28	5001	0	\N	0	0	\N	\N	0	276979	0	6095-4	3036780		
3653	350	3006322	1997-04-28	1997-04-28 00:00:00	1997-04-28	5001	0	\N	0	0	\N	\N	0	23301	0	8331-1	3006322		
3007	289	3006322	2005-08-13	2005-08-13 00:00:00	2005-08-13	5001	0	\N	0	0	\N	\N	0	19295	0	8331-1	3006322		
131110	4033	4052083	2010-09-06	2010-09-06 00:00:00	2010-09-06	5001	0	\N	0	0	\N	\N	0	268364	0	23426006	4052083		
37625	3464	3015076	2009-05-29	2009-05-29 00:00:00	2009-05-29	5001	0	\N	0	0	\N	\N	0	229905	0	6248-9	3015076		
99341	3049	4052083	1988-05-22	1988-05-22 00:00:00	1988-05-22	5001	0	\N	0	0	\N	\N	0	202854	0	23426006	4052083		
25670	2352	3001247	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	156717	0	6085-5	3001247		
57008	5228	3006322	1970-04-03	1970-04-03 00:00:00	1970-04-03	5001	0	\N	0	0	\N	\N	0	347761	0	8331-1	3006322		
39104	3618	3006322	1971-05-28	1971-05-28 00:00:00	1971-05-28	5001	0	\N	0	0	\N	\N	0	240374	0	8331-1	3006322		
74239	2280	4052083	1993-12-20	1993-12-20 00:00:00	1993-12-20	5001	0	\N	0	0	\N	\N	0	151607	0	23426006	4052083		
32088	2921	3011505	1998-08-04	1998-08-04 00:00:00	1998-08-04	5001	0	\N	0	0	\N	\N	0	194703	0	19926-5	3011505		
35338	3236	3049273	1988-07-26	1988-07-26 00:00:00	1988-07-26	5001	0	\N	0	0	\N	\N	0	215029	0	38265-5	3049273		
43426	4014	3006322	2006-08-29	2006-08-29 00:00:00	2006-08-29	5001	0	\N	0	0	\N	\N	0	266750	0	8331-1	3006322		
54812	5014	3011505	1993-12-07	1993-12-07 00:00:00	1993-12-07	5001	0	\N	0	0	\N	\N	0	333233	0	19926-5	3011505		
48315	4436	40769184	1984-06-02	1984-06-02 00:00:00	1984-06-02	5001	0	\N	0	0	\N	\N	0	294836	0	66524-0	40769184		
20188	1847	3006322	1923-11-03	1923-11-03 00:00:00	1923-11-03	5001	0	\N	0	0	\N	\N	0	123584	0	8331-1	3006322		
51283	4694	3001247	1982-07-22	1982-07-22 00:00:00	1982-07-22	5001	0	\N	0	0	\N	\N	0	312703	0	6085-5	3001247		
7698	742	40758406	1934-05-13	1934-05-13 00:00:00	1934-05-13	5001	0	\N	0	0	\N	\N	0	49136	0	55277-8	40758406		
287	9	3036780	1995-01-26	1995-01-26 00:00:00	1995-01-26	5001	0	\N	0	0	\N	\N	0	845	0	6095-4	3036780		
11703	1107	3006322	1939-05-13	1939-05-13 00:00:00	1939-05-13	5001	0	\N	0	0	\N	\N	0	72840	0	8331-1	3006322		
50092	4560	3006322	1984-06-06	1984-06-06 00:00:00	1984-06-06	5001	0	\N	0	0	\N	\N	0	303831	0	8331-1	3006322		
6826	654	3006322	1971-07-31	1971-07-31 00:00:00	1971-07-31	5001	0	\N	0	0	\N	\N	0	43337	0	8331-1	3006322		
54578	4987	3006322	1967-05-09	1967-05-09 00:00:00	1967-05-09	5001	0	\N	0	0	\N	\N	0	331764	0	8331-1	3006322		
1877	171	3006322	2005-06-13	2005-06-13 00:00:00	2005-06-13	5001	0	\N	0	0	\N	\N	0	11618	0	8331-1	3006322		
42094	3893	3006322	1979-10-07	1979-10-07 00:00:00	1979-10-07	5001	0	\N	0	0	\N	\N	0	258879	0	8331-1	3006322		
69473	2130	4052083	1962-02-11	1962-02-11 00:00:00	1962-02-11	5001	0	\N	0	0	\N	\N	0	141726	0	23426006	4052083		
127668	3929	4133840	1987-04-06	1987-04-06 00:00:00	1987-04-06	5001	0	\N	0	0	\N	\N	0	261161	0	127783003	4133840		
15374	1408	3006322	1948-01-19	1948-01-19 00:00:00	1948-01-19	5001	0	\N	0	0	\N	\N	0	93639	0	8331-1	3006322		
45134	4167	3006322	1980-12-11	1980-12-11 00:00:00	1980-12-11	5001	0	\N	0	0	\N	\N	0	276920	0	8331-1	3006322		
3654	350	3006322	1972-07-07	1972-07-07 00:00:00	1972-07-07	5001	0	\N	0	0	\N	\N	0	23299	0	8331-1	3006322		
3008	289	3006322	2000-04-27	2000-04-27 00:00:00	2000-04-27	5001	0	\N	0	0	\N	\N	0	19255	0	8331-1	3006322		
131112	4033	4052083	2016-04-11	2016-04-11 00:00:00	2016-04-11	5001	0	\N	0	0	\N	\N	0	268372	0	23426006	4052083		
37626	3464	3012494	2009-05-29	2009-05-29 00:00:00	2009-05-29	5001	0	\N	0	0	\N	\N	0	229905	0	6206-7	3012494		
110623	3415	4024958	1974-09-21	1974-09-21 00:00:00	1974-09-21	5001	0	\N	0	0	\N	\N	0	226517	0	117015009	4024958		
5719	176	4052083	2013-07-21	2013-07-21 00:00:00	2013-07-21	5001	0	\N	0	0	\N	\N	0	11907	0	23426006	4052083		
57009	5228	3006322	2015-05-03	2015-05-03 00:00:00	2015-05-03	5001	0	\N	0	0	\N	\N	0	347856	0	8331-1	3006322		
39106	3618	3006322	1961-11-04	1961-11-04 00:00:00	1961-11-04	5001	0	\N	0	0	\N	\N	0	240452	0	8331-1	3006322		
74244	2280	4052083	1984-05-02	1984-05-02 00:00:00	1984-05-02	5001	0	\N	0	0	\N	\N	0	151588	0	23426006	4052083		
32089	2921	3011505	1996-07-23	1996-07-23 00:00:00	1996-07-23	5001	0	\N	0	0	\N	\N	0	194702	0	19926-5	3011505		
35339	3236	3006322	1951-11-03	1951-11-03 00:00:00	1951-11-03	5001	0	\N	0	0	\N	\N	0	215063	0	8331-1	3006322		
43427	4014	40769184	1997-11-27	1997-11-27 00:00:00	1997-11-27	5001	0	\N	0	0	\N	\N	0	266731	0	66524-0	40769184		
54813	5015	3006322	1994-09-07	1994-09-07 00:00:00	1994-09-07	5001	0	\N	0	0	\N	\N	0	333361	0	8331-1	3006322		
48316	4436	40769194	1984-06-02	1984-06-02 00:00:00	1984-06-02	5001	0	\N	0	0	\N	\N	0	294836	0	66534-9	40769194		
20189	1847	3006322	1922-02-18	1922-02-18 00:00:00	1922-02-18	5001	0	\N	0	0	\N	\N	0	123582	0	8331-1	3006322		
51284	4694	3006734	1982-07-22	1982-07-22 00:00:00	1982-07-22	5001	0	\N	0	0	\N	\N	0	312703	0	6189-5	3006734		
7699	742	3051031	1934-05-13	1934-05-13 00:00:00	1934-05-13	5001	0	\N	0	0	\N	\N	0	49136	0	46240-8	3051031		
288	9	3023430	1995-01-26	1995-01-26 00:00:00	1995-01-26	5001	0	\N	0	0	\N	\N	0	845	0	6833-8	3023430		
11704	1108	3006322	1979-07-11	1979-07-11 00:00:00	1979-07-11	5001	0	\N	0	0	\N	\N	0	72946	0	8331-1	3006322		
50093	4560	3006322	1999-08-30	1999-08-30 00:00:00	1999-08-30	5001	0	\N	0	0	\N	\N	0	303820	0	8331-1	3006322		
6827	654	3006322	1990-05-16	1990-05-16 00:00:00	1990-05-16	5001	0	\N	0	0	\N	\N	0	43320	0	8331-1	3006322		
54579	4987	3006322	1960-12-31	1960-12-31 00:00:00	1960-12-31	5001	0	\N	0	0	\N	\N	0	331708	0	8331-1	3006322		
1878	171	3006322	1991-05-26	1991-05-26 00:00:00	1991-05-26	5001	0	\N	0	0	\N	\N	0	11625	0	8331-1	3006322		
42095	3893	3006322	2018-07-07	2018-07-07 00:00:00	2018-07-07	5001	0	\N	0	0	\N	\N	0	258845	0	8331-1	3006322		
69476	2130	4024958	1974-12-19	1974-12-19 00:00:00	1974-12-19	5001	0	\N	0	0	\N	\N	0	141727	0	117015009	4024958		
127669	3929	4133840	1995-01-16	1995-01-16 00:00:00	1995-01-16	5001	0	\N	0	0	\N	\N	0	261162	0	127783003	4133840		
15375	1408	3006322	2005-10-27	2005-10-27 00:00:00	2005-10-27	5001	0	\N	0	0	\N	\N	0	93653	0	8331-1	3006322		
45135	4167	3000876	1991-09-25	1991-09-25 00:00:00	1991-09-25	5001	0	\N	0	0	\N	\N	0	276909	0	6082-2	3000876		
3655	350	3014576	1995-09-11	1995-09-11 00:00:00	1995-09-11	5001	0	\N	0	0	\N	\N	0	23293	0	2075-0	3014576		
3009	289	3006322	1972-02-26	1972-02-26 00:00:00	1972-02-26	5001	0	\N	0	0	\N	\N	0	19281	0	8331-1	3006322		
131117	4033	4024958	2010-05-13	2010-05-13 00:00:00	2010-05-13	5001	0	\N	0	0	\N	\N	0	268363	0	117015009	4024958		
37631	3469	3006322	1968-08-20	1968-08-20 00:00:00	1968-08-20	5001	0	\N	0	0	\N	\N	0	230296	0	8331-1	3006322		
110626	3415	4024958	1980-03-07	1980-03-07 00:00:00	1980-03-07	5001	0	\N	0	0	\N	\N	0	226514	0	117015009	4024958		
5720	176	4052083	1986-08-20	1986-08-20 00:00:00	1986-08-20	5001	0	\N	0	0	\N	\N	0	11905	0	23426006	4052083		
57010	5228	3006322	1972-01-05	1972-01-05 00:00:00	1972-01-05	5001	0	\N	0	0	\N	\N	0	347787	0	8331-1	3006322		
39108	3618	3006322	1980-04-10	1980-04-10 00:00:00	1980-04-10	5001	0	\N	0	0	\N	\N	0	240453	0	8331-1	3006322		
74252	2280	4024958	1980-03-09	1980-03-09 00:00:00	1980-03-09	5001	0	\N	0	0	\N	\N	0	151561	0	117015009	4024958		
32090	2921	3011505	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	194767	0	19926-5	3011505		
35340	3236	3006322	2008-07-26	2008-07-26 00:00:00	2008-07-26	5001	0	\N	0	0	\N	\N	0	215061	0	8331-1	3006322		
43428	4014	40769194	1997-11-27	1997-11-27 00:00:00	1997-11-27	5001	0	\N	0	0	\N	\N	0	266731	0	66534-9	40769194		
54814	5015	3006322	1993-05-06	1993-05-06 00:00:00	1993-05-06	5001	0	\N	0	0	\N	\N	0	333383	0	8331-1	3006322		
48317	4436	40769179	1984-06-02	1984-06-02 00:00:00	1984-06-02	5001	0	\N	0	0	\N	\N	0	294836	0	66519-0	40769179		
20193	1847	3006322	1952-09-07	1952-09-07 00:00:00	1952-09-07	5001	0	\N	0	0	\N	\N	0	123565	0	8331-1	3006322		
51285	4694	3000876	1982-07-22	1982-07-22 00:00:00	1982-07-22	5001	0	\N	0	0	\N	\N	0	312703	0	6082-2	3000876		
7700	742	3011505	1983-10-10	1983-10-10 00:00:00	1983-10-10	5001	0	\N	0	0	\N	\N	0	49205	0	19926-5	3011505		
293	11	3006322	1971-08-08	1971-08-08 00:00:00	1971-08-08	5001	0	\N	0	0	\N	\N	0	945	0	8331-1	3006322		
11706	1110	3036780	1998-09-21	1998-09-21 00:00:00	1998-09-21	5001	0	\N	0	0	\N	\N	0	73077	0	6095-4	3036780		
50094	4561	3006322	1969-10-27	1969-10-27 00:00:00	1969-10-27	5001	0	\N	0	0	\N	\N	0	303910	0	8331-1	3006322		
6828	654	3006322	2017-06-05	2017-06-05 00:00:00	2017-06-05	5001	0	\N	0	0	\N	\N	0	43297	0	8331-1	3006322		
54580	4987	3006322	1979-05-29	1979-05-29 00:00:00	1979-05-29	5001	0	\N	0	0	\N	\N	0	331729	0	8331-1	3006322		
137018	4223	4024958	1984-12-06	1984-12-06 00:00:00	1984-12-06	5001	0	\N	0	0	\N	\N	0	280427	0	117015009	4024958		
42096	3893	3006322	2004-09-06	2004-09-06 00:00:00	2004-09-06	5001	0	\N	0	0	\N	\N	0	258882	0	8331-1	3006322		
69485	2131	4052083	1959-06-20	1959-06-20 00:00:00	1959-06-20	5001	0	\N	0	0	\N	\N	0	141792	0	23426006	4052083		
127671	3929	4133840	2001-12-24	2001-12-24 00:00:00	2001-12-24	5001	0	\N	0	0	\N	\N	0	261182	0	127783003	4133840		
15376	1408	3006322	1992-11-20	1992-11-20 00:00:00	1992-11-20	5001	0	\N	0	0	\N	\N	0	93651	0	8331-1	3006322		
45136	4167	3023430	1991-09-25	1991-09-25 00:00:00	1991-09-25	5001	0	\N	0	0	\N	\N	0	276909	0	6833-8	3023430		
3656	350	3010813	1995-09-11	1995-09-11 00:00:00	1995-09-11	5001	0	\N	0	0	\N	\N	0	23293	0	26464-8	3010813		
3010	289	3006322	1962-10-29	1962-10-29 00:00:00	1962-10-29	5001	0	\N	0	0	\N	\N	0	19305	0	8331-1	3006322		
131127	4033	4024958	1979-11-21	1979-11-21 00:00:00	1979-11-21	5001	0	\N	0	0	\N	\N	0	268316	0	117015009	4024958		
37632	3469	3006322	1956-08-14	1956-08-14 00:00:00	1956-08-14	5001	0	\N	0	0	\N	\N	0	230240	0	8331-1	3006322		
110629	3415	4024958	1991-08-19	1991-08-19 00:00:00	1991-08-19	5001	0	\N	0	0	\N	\N	0	226548	0	117015009	4024958		
5724	176	4024958	1969-01-07	1969-01-07 00:00:00	1969-01-07	5001	0	\N	0	0	\N	\N	0	11891	0	117015009	4024958		
57011	5229	3006322	2013-04-05	2013-04-05 00:00:00	2013-04-05	5001	0	\N	0	0	\N	\N	0	347874	0	8331-1	3006322		
39110	3618	3006322	1972-12-01	1972-12-01 00:00:00	1972-12-01	5001	0	\N	0	0	\N	\N	0	240375	0	8331-1	3006322		
74253	2280	4052083	1982-07-28	1982-07-28 00:00:00	1982-07-28	5001	0	\N	0	0	\N	\N	0	151562	0	23426006	4052083		
32091	2921	3011505	2002-08-27	2002-08-27 00:00:00	2002-08-27	5001	0	\N	0	0	\N	\N	0	194747	0	19926-5	3011505		
35341	3236	3006322	1942-03-14	1942-03-14 00:00:00	1942-03-14	5001	0	\N	0	0	\N	\N	0	215089	0	8331-1	3006322		
43429	4014	40769179	1997-11-27	1997-11-27 00:00:00	1997-11-27	5001	0	\N	0	0	\N	\N	0	266731	0	66519-0	40769179		
54815	5015	3006322	2008-08-10	2008-08-10 00:00:00	2008-08-10	5001	0	\N	0	0	\N	\N	0	333384	0	8331-1	3006322		
48318	4436	40769189	1984-06-02	1984-06-02 00:00:00	1984-06-02	5001	0	\N	0	0	\N	\N	0	294836	0	66529-9	40769189		
20195	1847	3006322	1922-11-24	1922-11-24 00:00:00	1922-11-24	5001	0	\N	0	0	\N	\N	0	123583	0	8331-1	3006322		
51286	4694	3001488	1982-07-22	1982-07-22 00:00:00	1982-07-22	5001	0	\N	0	0	\N	\N	0	312703	0	7258-7	3001488		
7701	742	3011505	2000-06-05	2000-06-05 00:00:00	2000-06-05	5001	0	\N	0	0	\N	\N	0	49112	0	19926-5	3011505		
294	11	3006322	1956-11-02	1956-11-02 00:00:00	1956-11-02	5001	0	\N	0	0	\N	\N	0	979	0	8331-1	3006322		
11707	1110	3021226	1998-09-21	1998-09-21 00:00:00	1998-09-21	5001	0	\N	0	0	\N	\N	0	73077	0	6246-3	3021226		
50095	4561	3006322	1959-04-12	1959-04-12 00:00:00	1959-04-12	5001	0	\N	0	0	\N	\N	0	303883	0	8331-1	3006322		
6829	654	3006322	1979-05-31	1979-05-31 00:00:00	1979-05-31	5001	0	\N	0	0	\N	\N	0	43310	0	8331-1	3006322		
54581	4987	3006322	1960-05-20	1960-05-20 00:00:00	1960-05-20	5001	0	\N	0	0	\N	\N	0	331754	0	8331-1	3006322		
137024	4223	4052083	1971-09-18	1971-09-18 00:00:00	1971-09-18	5001	0	\N	0	0	\N	\N	0	280413	0	23426006	4052083		
147110	4509	4133840	1999-04-20	1999-04-20 00:00:00	1999-04-20	5001	0	\N	0	0	\N	\N	0	300396	0	127783003	4133840		
69498	2131	4024958	1953-06-16	1953-06-16 00:00:00	1953-06-16	5001	0	\N	0	0	\N	\N	0	141761	0	117015009	4024958		
127676	3929	4052083	1968-02-13	1968-02-13 00:00:00	1968-02-13	5001	0	\N	0	0	\N	\N	0	261186	0	23426006	4052083		
15377	1409	3006322	1971-04-10	1971-04-10 00:00:00	1971-04-10	5001	0	\N	0	0	\N	\N	0	93764	0	8331-1	3006322		
45137	4167	3020655	1991-09-25	1991-09-25 00:00:00	1991-09-25	5001	0	\N	0	0	\N	\N	0	276909	0	6844-5	3020655		
3657	350	3004501	1995-09-11	1995-09-11 00:00:00	1995-09-11	5001	0	\N	0	0	\N	\N	0	23293	0	2345-7	3004501		
3011	289	3006322	2016-06-30	2016-06-30 00:00:00	2016-06-30	5001	0	\N	0	0	\N	\N	0	19311	0	8331-1	3006322		
131159	4035	4024958	1986-11-04	1986-11-04 00:00:00	1986-11-04	5001	0	\N	0	0	\N	\N	0	268470	0	117015009	4024958		
37633	3469	3006322	1986-03-06	1986-03-06 00:00:00	1986-03-06	5001	0	\N	0	0	\N	\N	0	230221	0	8331-1	3006322		
110630	3415	4052083	1999-06-20	1999-06-20 00:00:00	1999-06-20	5001	0	\N	0	0	\N	\N	0	226498	0	23426006	4052083		
5727	176	4024958	1986-08-26	1986-08-26 00:00:00	1986-08-26	5001	0	\N	0	0	\N	\N	0	11881	0	117015009	4024958		
57012	5229	3006322	1973-05-26	1973-05-26 00:00:00	1973-05-26	5001	0	\N	0	0	\N	\N	0	347871	0	8331-1	3006322		
39111	3618	3006322	1987-01-30	1987-01-30 00:00:00	1987-01-30	5001	0	\N	0	0	\N	\N	0	240454	0	8331-1	3006322		
74257	2280	4024958	1969-09-04	1969-09-04 00:00:00	1969-09-04	5001	0	\N	0	0	\N	\N	0	151551	0	117015009	4024958		
32092	2921	3011505	2004-09-07	2004-09-07 00:00:00	2004-09-07	5001	0	\N	0	0	\N	\N	0	194748	0	19926-5	3011505		
35342	3236	3006322	2008-02-17	2008-02-17 00:00:00	2008-02-17	5001	0	\N	0	0	\N	\N	0	215055	0	8331-1	3006322		
43430	4014	40769189	1997-11-27	1997-11-27 00:00:00	1997-11-27	5001	0	\N	0	0	\N	\N	0	266731	0	66529-9	40769189		
54816	5015	3006322	1969-04-02	1969-04-02 00:00:00	1969-04-02	5001	0	\N	0	0	\N	\N	0	333360	0	8331-1	3006322		
48319	4436	3001247	1984-06-17	1984-06-17 00:00:00	1984-06-17	5001	0	\N	0	0	\N	\N	0	294875	0	6085-5	3001247		
20196	1847	3006322	1960-09-10	1960-09-10 00:00:00	1960-09-10	5001	0	\N	0	0	\N	\N	0	123514	0	8331-1	3006322		
51287	4694	3019406	1982-07-22	1982-07-22 00:00:00	1982-07-22	5001	0	\N	0	0	\N	\N	0	312703	0	6158-0	3019406		
7702	742	3011505	2010-12-06	2010-12-06 00:00:00	2010-12-06	5001	0	\N	0	0	\N	\N	0	49174	0	19926-5	3011505		
295	11	3006322	1955-10-23	1955-10-23 00:00:00	1955-10-23	5001	0	\N	0	0	\N	\N	0	978	0	8331-1	3006322		
11708	1110	3023430	1998-09-21	1998-09-21 00:00:00	1998-09-21	5001	0	\N	0	0	\N	\N	0	73077	0	6833-8	3023430		
50096	4561	3006322	1954-05-25	1954-05-25 00:00:00	1954-05-25	5001	0	\N	0	0	\N	\N	0	303907	0	8331-1	3006322		
6830	655	3006322	1996-10-13	1996-10-13 00:00:00	1996-10-13	5001	0	\N	0	0	\N	\N	0	43388	0	8331-1	3006322		
54582	4987	3006322	1985-08-07	1985-08-07 00:00:00	1985-08-07	5001	0	\N	0	0	\N	\N	0	331710	0	8331-1	3006322		
137075	4224	4052083	1996-12-04	1996-12-04 00:00:00	1996-12-04	5001	0	\N	0	0	\N	\N	0	280453	0	23426006	4052083		
147112	4509	4133840	2015-09-22	2015-09-22 00:00:00	2015-09-22	5001	0	\N	0	0	\N	\N	0	300350	0	127783003	4133840		
69509	2131	4052083	1956-06-09	1956-06-09 00:00:00	1956-06-09	5001	0	\N	0	0	\N	\N	0	141843	0	23426006	4052083		
127677	3929	4052083	1999-12-14	1999-12-14 00:00:00	1999-12-14	5001	0	\N	0	0	\N	\N	0	261190	0	23426006	4052083		
15379	1409	40758406	1961-08-16	1961-08-16 00:00:00	1961-08-16	5001	0	\N	0	0	\N	\N	0	93822	0	55277-8	40758406		
45138	4167	3019406	1991-09-25	1991-09-25 00:00:00	1991-09-25	5001	0	\N	0	0	\N	\N	0	276909	0	6158-0	3019406		
3658	350	21494966	1995-09-11	1995-09-11 00:00:00	1995-09-11	5001	0	\N	0	0	\N	\N	0	23293	0	80271-0	21494966		
3012	289	3006322	1996-08-04	1996-08-04 00:00:00	1996-08-04	5001	0	\N	0	0	\N	\N	0	19261	0	8331-1	3006322		
50701	4623	3019406	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	307872	0	6158-0	3019406		
37634	3470	3006322	1962-06-19	1962-06-19 00:00:00	1962-06-19	5001	0	\N	0	0	\N	\N	0	230301	0	8331-1	3006322		
110635	3415	4052083	1992-01-28	1992-01-28 00:00:00	1992-01-28	5001	0	\N	0	0	\N	\N	0	226519	0	23426006	4052083		
5728	176	4024958	2003-12-19	2003-12-19 00:00:00	2003-12-19	5001	0	\N	0	0	\N	\N	0	11906	0	117015009	4024958		
57013	5229	3006322	1975-01-31	1975-01-31 00:00:00	1975-01-31	5001	0	\N	0	0	\N	\N	0	347880	0	8331-1	3006322		
39112	3618	3006322	1993-09-08	1993-09-08 00:00:00	1993-09-08	5001	0	\N	0	0	\N	\N	0	240356	0	8331-1	3006322		
74260	2280	4024958	1993-04-04	1993-04-04 00:00:00	1993-04-04	5001	0	\N	0	0	\N	\N	0	151670	0	117015009	4024958		
32093	2921	3011505	1991-06-25	1991-06-25 00:00:00	1991-06-25	5001	0	\N	0	0	\N	\N	0	194766	0	19926-5	3011505		
35343	3236	3006322	2016-06-27	2016-06-27 00:00:00	2016-06-27	5001	0	\N	0	0	\N	\N	0	215114	0	8331-1	3006322		
43431	4014	3000876	1997-12-09	1997-12-09 00:00:00	1997-12-09	5001	0	\N	0	0	\N	\N	0	266770	0	6082-2	3000876		
54817	5017	3006322	1981-11-05	1981-11-05 00:00:00	1981-11-05	5001	0	\N	0	0	\N	\N	0	333446	0	8331-1	3006322		
48320	4436	3001488	1984-06-17	1984-06-17 00:00:00	1984-06-17	5001	0	\N	0	0	\N	\N	0	294875	0	7258-7	3001488		
20198	1847	3006322	1926-09-03	1926-09-03 00:00:00	1926-09-03	5001	0	\N	0	0	\N	\N	0	123585	0	8331-1	3006322		
51288	4694	3012494	1982-07-22	1982-07-22 00:00:00	1982-07-22	5001	0	\N	0	0	\N	\N	0	312703	0	6206-7	3012494		
7703	742	3011505	2002-06-17	2002-06-17 00:00:00	2002-06-17	5001	0	\N	0	0	\N	\N	0	49103	0	19926-5	3011505		
296	11	3006322	1980-12-27	1980-12-27 00:00:00	1980-12-27	5001	0	\N	0	0	\N	\N	0	963	0	8331-1	3006322		
21032	1950	46235214	1941-10-12	1941-10-12 00:00:00	1941-10-12	5001	0	\N	0	0	\N	\N	0	129623	0	76690-7	46235214		
50097	4561	3006322	1980-04-12	1980-04-12 00:00:00	1980-04-12	5001	0	\N	0	0	\N	\N	0	303920	0	8331-1	3006322		
6831	655	3006322	1986-09-13	1986-09-13 00:00:00	1986-09-13	5001	0	\N	0	0	\N	\N	0	43400	0	8331-1	3006322		
54583	4987	3006322	2005-07-21	2005-07-21 00:00:00	2005-07-21	5001	0	\N	0	0	\N	\N	0	331769	0	8331-1	3006322		
43988	4064	3006322	1972-11-30	1972-11-30 00:00:00	1972-11-30	5001	0	\N	0	0	\N	\N	0	270110	0	8331-1	3006322		
147113	4509	4133840	2002-04-23	2002-04-23 00:00:00	2002-04-23	5001	0	\N	0	0	\N	\N	0	300397	0	127783003	4133840		
22198	2037	3006322	1982-08-01	1982-08-01 00:00:00	1982-08-01	5001	0	\N	0	0	\N	\N	0	135680	0	8331-1	3006322		
127678	3929	4133840	1999-01-25	1999-01-25 00:00:00	1999-01-25	5001	0	\N	0	0	\N	\N	0	261211	0	127783003	4133840		
15380	1409	40766240	1961-08-16	1961-08-16 00:00:00	1961-08-16	5001	0	\N	0	0	\N	\N	0	93822	0	63513-6	40766240		
45139	4167	3014599	1991-09-25	1991-09-25 00:00:00	1991-09-25	5001	0	\N	0	0	\N	\N	0	276909	0	6106-9	3014599		
3659	350	3024731	1995-09-11	1995-09-11 00:00:00	1995-09-11	5001	0	\N	0	0	\N	\N	0	23293	0	30428-7	3024731		
3015	292	3006322	2015-07-30	2015-07-30 00:00:00	2015-07-30	5001	0	\N	0	0	\N	\N	0	19456	0	8331-1	3006322		
50702	4623	3012494	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	307872	0	6206-7	3012494		
37635	3470	3006322	2012-08-01	2012-08-01 00:00:00	2012-08-01	5001	0	\N	0	0	\N	\N	0	230346	0	8331-1	3006322		
110649	3417	4024958	1947-04-17	1947-04-17 00:00:00	1947-04-17	5001	0	\N	0	0	\N	\N	0	226604	0	117015009	4024958		
17017	533	4024958	2002-12-26	2002-12-26 00:00:00	2002-12-26	5001	0	\N	0	0	\N	\N	0	35497	0	117015009	4024958		
57014	5229	3006322	1965-10-20	1965-10-20 00:00:00	1965-10-20	5001	0	\N	0	0	\N	\N	0	347922	0	8331-1	3006322		
39113	3618	3006322	1984-10-26	1984-10-26 00:00:00	1984-10-26	5001	0	\N	0	0	\N	\N	0	240376	0	8331-1	3006322		
13223	419	4024958	1928-09-11	1928-09-11 00:00:00	1928-09-11	5001	0	\N	0	0	\N	\N	0	27686	0	117015009	4024958		
32094	2921	3011505	1997-07-29	1997-07-29 00:00:00	1997-07-29	5001	0	\N	0	0	\N	\N	0	194741	0	19926-5	3011505		
35344	3236	3006322	1931-08-25	1931-08-25 00:00:00	1931-08-25	5001	0	\N	0	0	\N	\N	0	215059	0	8331-1	3006322		
43432	4014	3014599	1997-12-09	1997-12-09 00:00:00	1997-12-09	5001	0	\N	0	0	\N	\N	0	266770	0	6106-9	3014599		
54974	5031	3006322	1968-10-05	1968-10-05 00:00:00	1968-10-05	5001	0	\N	0	0	\N	\N	0	334330	0	8331-1	3006322		
48321	4436	3023430	1984-06-17	1984-06-17 00:00:00	1984-06-17	5001	0	\N	0	0	\N	\N	0	294875	0	6833-8	3023430		
20199	1847	3006322	1919-05-20	1919-05-20 00:00:00	1919-05-20	5001	0	\N	0	0	\N	\N	0	123481	0	8331-1	3006322		
51289	4694	3020655	1982-07-22	1982-07-22 00:00:00	1982-07-22	5001	0	\N	0	0	\N	\N	0	312703	0	6844-5	3020655		
7704	742	3011505	2008-07-21	2008-07-21 00:00:00	2008-07-21	5001	0	\N	0	0	\N	\N	0	49195	0	19926-5	3011505		
297	11	3006322	1970-06-01	1970-06-01 00:00:00	1970-06-01	5001	0	\N	0	0	\N	\N	0	971	0	8331-1	3006322		
21033	1950	40766240	1941-10-12	1941-10-12 00:00:00	1941-10-12	5001	0	\N	0	0	\N	\N	0	129623	0	63513-6	40766240		
50098	4561	3006322	2003-12-01	2003-12-01 00:00:00	2003-12-01	5001	0	\N	0	0	\N	\N	0	303912	0	8331-1	3006322		
6832	655	3006322	1989-09-05	1989-09-05 00:00:00	1989-09-05	5001	0	\N	0	0	\N	\N	0	43413	0	8331-1	3006322		
54584	4987	3006322	1970-07-31	1970-07-31 00:00:00	1970-07-31	5001	0	\N	0	0	\N	\N	0	331756	0	8331-1	3006322		
43989	4064	3006322	1966-11-18	1966-11-18 00:00:00	1966-11-18	5001	0	\N	0	0	\N	\N	0	270109	0	8331-1	3006322		
147114	4509	4133840	2009-09-08	2009-09-08 00:00:00	2009-09-08	5001	0	\N	0	0	\N	\N	0	300361	0	127783003	4133840		
22199	2037	3006322	1968-07-19	1968-07-19 00:00:00	1968-07-19	5001	0	\N	0	0	\N	\N	0	135676	0	8331-1	3006322		
127680	3929	4133840	2006-01-16	2006-01-16 00:00:00	2006-01-16	5001	0	\N	0	0	\N	\N	0	261206	0	127783003	4133840		
15382	1409	3051031	1961-08-16	1961-08-16 00:00:00	1961-08-16	5001	0	\N	0	0	\N	\N	0	93822	0	46240-8	3051031		
45140	4167	3015076	1991-09-25	1991-09-25 00:00:00	1991-09-25	5001	0	\N	0	0	\N	\N	0	276909	0	6248-9	3015076		
3660	350	3006906	1995-09-11	1995-09-11 00:00:00	1995-09-11	5001	0	\N	0	0	\N	\N	0	23293	0	17861-6	3006906		
3016	292	3006322	2017-10-30	2017-10-30 00:00:00	2017-10-30	5001	0	\N	0	0	\N	\N	0	19462	0	8331-1	3006322		
50703	4623	3001247	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	307872	0	6085-5	3001247		
37636	3470	3006322	1979-12-16	1979-12-16 00:00:00	1979-12-16	5001	0	\N	0	0	\N	\N	0	230318	0	8331-1	3006322		
110650	3417	4052083	1995-08-02	1995-08-02 00:00:00	1995-08-02	5001	0	\N	0	0	\N	\N	0	226655	0	23426006	4052083		
17056	533	4052083	1980-03-30	1980-03-30 00:00:00	1980-03-30	5001	0	\N	0	0	\N	\N	0	35426	0	23426006	4052083		
57015	5229	3006322	2004-08-06	2004-08-06 00:00:00	2004-08-06	5001	0	\N	0	0	\N	\N	0	347912	0	8331-1	3006322		
39114	3618	3006322	1952-12-08	1952-12-08 00:00:00	1952-12-08	5001	0	\N	0	0	\N	\N	0	240447	0	8331-1	3006322		
24527	763	4052083	1990-12-21	1990-12-21 00:00:00	1990-12-21	5001	0	\N	0	0	\N	\N	0	50753	0	23426006	4052083		
93874	2891	4024958	1977-02-08	1977-02-08 00:00:00	1977-02-08	5001	0	\N	0	0	\N	\N	0	192344	0	117015009	4024958		
42665	3941	3006322	2014-07-05	2014-07-05 00:00:00	2014-07-05	5001	0	\N	0	0	\N	\N	0	262043	0	8331-1	3006322		
43433	4014	3019406	1997-12-09	1997-12-09 00:00:00	1997-12-09	5001	0	\N	0	0	\N	\N	0	266770	0	6158-0	3019406		
54975	5031	3006322	2018-10-18	2018-10-18 00:00:00	2018-10-18	5001	0	\N	0	0	\N	\N	0	334291	0	8331-1	3006322		
48322	4436	3020655	1984-06-17	1984-06-17 00:00:00	1984-06-17	5001	0	\N	0	0	\N	\N	0	294875	0	6844-5	3020655		
20200	1848	3006322	1983-07-23	1983-07-23 00:00:00	1983-07-23	5001	0	\N	0	0	\N	\N	0	123686	0	8331-1	3006322		
51290	4694	3023430	1982-07-22	1982-07-22 00:00:00	1982-07-22	5001	0	\N	0	0	\N	\N	0	312703	0	6833-8	3023430		
7705	742	3011505	1980-09-22	1980-09-22 00:00:00	1980-09-22	5001	0	\N	0	0	\N	\N	0	49110	0	19926-5	3011505		
298	11	3006322	2003-12-07	2003-12-07 00:00:00	2003-12-07	5001	0	\N	0	0	\N	\N	0	966	0	8331-1	3006322		
21034	1950	3051031	1941-10-12	1941-10-12 00:00:00	1941-10-12	5001	0	\N	0	0	\N	\N	0	129623	0	46240-8	3051031		
50099	4561	3006322	1998-03-21	1998-03-21 00:00:00	1998-03-21	5001	0	\N	0	0	\N	\N	0	303939	0	8331-1	3006322		
6833	655	3006322	2008-09-20	2008-09-20 00:00:00	2008-09-20	5001	0	\N	0	0	\N	\N	0	43389	0	8331-1	3006322		
54585	4988	3006322	2006-12-10	2006-12-10 00:00:00	2006-12-10	5001	0	\N	0	0	\N	\N	0	331833	0	8331-1	3006322		
43990	4064	3006322	1999-10-06	1999-10-06 00:00:00	1999-10-06	5001	0	\N	0	0	\N	\N	0	270117	0	8331-1	3006322		
147115	4509	4133840	2017-08-29	2017-08-29 00:00:00	2017-08-29	5001	0	\N	0	0	\N	\N	0	300351	0	127783003	4133840		
22200	2037	3006322	2002-12-29	2002-12-29 00:00:00	2002-12-29	5001	0	\N	0	0	\N	\N	0	135638	0	8331-1	3006322		
127685	3929	4024958	1961-04-05	1961-04-05 00:00:00	1961-04-05	5001	0	\N	0	0	\N	\N	0	261196	0	117015009	4024958		
15383	1409	46235214	1961-08-16	1961-08-16 00:00:00	1961-08-16	5001	0	\N	0	0	\N	\N	0	93822	0	76690-7	46235214		
45141	4167	3005136	1991-09-25	1991-09-25 00:00:00	1991-09-25	5001	0	\N	0	0	\N	\N	0	276909	0	6075-6	3005136		
3661	350	3000963	1995-09-11	1995-09-11 00:00:00	1995-09-11	5001	0	\N	0	0	\N	\N	0	23293	0	718-7	3000963		
3017	292	3006322	1984-08-28	1984-08-28 00:00:00	1984-08-28	5001	0	\N	0	0	\N	\N	0	19468	0	8331-1	3006322		
50704	4623	3001488	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	307872	0	7258-7	3001488		
37637	3470	3006322	1967-05-06	1967-05-06 00:00:00	1967-05-06	5001	0	\N	0	0	\N	\N	0	230298	0	8331-1	3006322		
76599	2349	4024958	1981-06-08	1981-06-08 00:00:00	1981-06-08	5001	0	\N	0	0	\N	\N	0	156439	0	117015009	4024958		
107921	3332	4052083	1987-12-15	1987-12-15 00:00:00	1987-12-15	5001	0	\N	0	0	\N	\N	0	221088	0	23426006	4052083		
57016	5230	3006322	1991-07-10	1991-07-10 00:00:00	1991-07-10	5001	0	\N	0	0	\N	\N	0	347960	0	8331-1	3006322		
39126	3621	3011505	1989-10-28	1989-10-28 00:00:00	1989-10-28	5001	0	\N	0	0	\N	\N	0	240596	0	19926-5	3011505		
24528	763	4024958	1973-06-10	1973-06-10 00:00:00	1973-06-10	5001	0	\N	0	0	\N	\N	0	50748	0	117015009	4024958		
93887	2891	4052083	2000-09-21	2000-09-21 00:00:00	2000-09-21	5001	0	\N	0	0	\N	\N	0	192326	0	23426006	4052083		
42666	3941	3006322	1965-06-13	1965-06-13 00:00:00	1965-06-13	5001	0	\N	0	0	\N	\N	0	262057	0	8331-1	3006322		
43434	4014	3005136	1997-12-09	1997-12-09 00:00:00	1997-12-09	5001	0	\N	0	0	\N	\N	0	266770	0	6075-6	3005136		
54976	5031	3006322	1962-04-30	1962-04-30 00:00:00	1962-04-30	5001	0	\N	0	0	\N	\N	0	334362	0	8331-1	3006322		
48323	4436	3015076	1984-06-17	1984-06-17 00:00:00	1984-06-17	5001	0	\N	0	0	\N	\N	0	294875	0	6248-9	3015076		
20201	1848	3000963	2015-08-28	2015-08-28 00:00:00	2015-08-28	5001	0	\N	0	0	\N	\N	0	123652	0	718-7	3000963		
51291	4694	3036780	1982-07-22	1982-07-22 00:00:00	1982-07-22	5001	0	\N	0	0	\N	\N	0	312703	0	6095-4	3036780		
7706	742	3006322	1990-03-29	1990-03-29 00:00:00	1990-03-29	5001	0	\N	0	0	\N	\N	0	49220	0	8331-1	3006322		
299	11	3006322	1966-04-08	1966-04-08 00:00:00	1966-04-08	5001	0	\N	0	0	\N	\N	0	953	0	8331-1	3006322		
21036	1950	3011505	1995-10-12	1995-10-12 00:00:00	1995-10-12	5001	0	\N	0	0	\N	\N	0	129657	0	19926-5	3011505		
50100	4562	3006322	2006-02-01	2006-02-01 00:00:00	2006-02-01	5001	0	\N	0	0	\N	\N	0	304007	0	8331-1	3006322		
6834	655	3006322	1964-01-21	1964-01-21 00:00:00	1964-01-21	5001	0	\N	0	0	\N	\N	0	43398	0	8331-1	3006322		
54586	4988	3006322	2012-04-22	2012-04-22 00:00:00	2012-04-22	5001	0	\N	0	0	\N	\N	0	331834	0	8331-1	3006322		
43991	4064	3006322	1961-03-07	1961-03-07 00:00:00	1961-03-07	5001	0	\N	0	0	\N	\N	0	270071	0	8331-1	3006322		
147116	4509	4133840	2011-09-13	2011-09-13 00:00:00	2011-09-13	5001	0	\N	0	0	\N	\N	0	300405	0	127783003	4133840		
22201	2037	3006322	1980-10-01	1980-10-01 00:00:00	1980-10-01	5001	0	\N	0	0	\N	\N	0	135678	0	8331-1	3006322		
127687	3929	4133840	1997-01-20	1997-01-20 00:00:00	1997-01-20	5001	0	\N	0	0	\N	\N	0	261181	0	127783003	4133840		
15384	1409	3006322	2005-11-14	2005-11-14 00:00:00	2005-11-14	5001	0	\N	0	0	\N	\N	0	93744	0	8331-1	3006322		
45142	4167	3012494	1991-09-25	1991-09-25 00:00:00	1991-09-25	5001	0	\N	0	0	\N	\N	0	276909	0	6206-7	3012494		
3662	350	3019550	1995-09-11	1995-09-11 00:00:00	1995-09-11	5001	0	\N	0	0	\N	\N	0	23293	0	2951-2	3019550		
3018	293	3006322	1971-10-10	1971-10-10 00:00:00	1971-10-10	5001	0	\N	0	0	\N	\N	0	19504	0	8331-1	3006322		
50705	4623	3020655	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	307872	0	6844-5	3020655		
37638	3470	3006322	2001-01-20	2001-01-20 00:00:00	2001-01-20	5001	0	\N	0	0	\N	\N	0	230303	0	8331-1	3006322		
87931	2715	4024958	1975-07-11	1975-07-11 00:00:00	1975-07-11	5001	0	\N	0	0	\N	\N	0	180004	0	117015009	4024958		
107931	3332	4024958	2002-04-09	2002-04-09 00:00:00	2002-04-09	5001	0	\N	0	0	\N	\N	0	221074	0	117015009	4024958		
57017	5230	3006322	1990-01-22	1990-01-22 00:00:00	1990-01-22	5001	0	\N	0	0	\N	\N	0	347959	0	8331-1	3006322		
39127	3621	3011505	1972-07-22	1972-07-22 00:00:00	1972-07-22	5001	0	\N	0	0	\N	\N	0	240576	0	19926-5	3011505		
24533	763	4052083	1972-06-10	1972-06-10 00:00:00	1972-06-10	5001	0	\N	0	0	\N	\N	0	50750	0	23426006	4052083		
13951	442	4052083	2011-05-28	2011-05-28 00:00:00	2011-05-28	5001	0	\N	0	0	\N	\N	0	29392	0	23426006	4052083		
42667	3942	3006322	1991-09-29	1991-09-29 00:00:00	1991-09-29	5001	0	\N	0	0	\N	\N	0	262112	0	8331-1	3006322		
43435	4014	3021226	1997-12-09	1997-12-09 00:00:00	1997-12-09	5001	0	\N	0	0	\N	\N	0	266770	0	6246-3	3021226		
54977	5031	3049273	2000-10-14	2000-10-14 00:00:00	2000-10-14	5001	0	\N	0	0	\N	\N	0	334341	0	38265-5	3049273		
48324	4436	3027231	1984-06-17	1984-06-17 00:00:00	1984-06-17	5001	0	\N	0	0	\N	\N	0	294875	0	6276-0	3027231		
20202	1848	3009542	2015-08-28	2015-08-28 00:00:00	2015-08-28	5001	0	\N	0	0	\N	\N	0	123652	0	20570-8	3009542		
51292	4694	3014599	1982-07-22	1982-07-22 00:00:00	1982-07-22	5001	0	\N	0	0	\N	\N	0	312703	0	6106-9	3014599		
7707	742	3011505	1976-08-30	1976-08-30 00:00:00	1976-08-30	5001	0	\N	0	0	\N	\N	0	49108	0	19926-5	3011505		
300	11	3006322	1963-06-13	1963-06-13 00:00:00	1963-06-13	5001	0	\N	0	0	\N	\N	0	970	0	8331-1	3006322		
21037	1950	3011505	2016-02-04	2016-02-04 00:00:00	2016-02-04	5001	0	\N	0	0	\N	\N	0	129665	0	19926-5	3011505		
50101	4562	40769184	1961-08-04	1961-08-04 00:00:00	1961-08-04	5001	0	\N	0	0	\N	\N	0	304055	0	66524-0	40769184		
6835	655	3006322	1973-11-07	1973-11-07 00:00:00	1973-11-07	5001	0	\N	0	0	\N	\N	0	43412	0	8331-1	3006322		
54593	4990	3006322	2006-09-03	2006-09-03 00:00:00	2006-09-03	5001	0	\N	0	0	\N	\N	0	331956	0	8331-1	3006322		
43992	4064	40769179	1960-11-13	1960-11-13 00:00:00	1960-11-13	5001	0	\N	0	0	\N	\N	0	270090	0	66519-0	40769179		
147123	4509	4133840	2005-04-26	2005-04-26 00:00:00	2005-04-26	5001	0	\N	0	0	\N	\N	0	300398	0	127783003	4133840		
22202	2037	3006322	1962-02-08	1962-02-08 00:00:00	1962-02-08	5001	0	\N	0	0	\N	\N	0	135624	0	8331-1	3006322		
127688	3929	4133840	1991-01-07	1991-01-07 00:00:00	1991-01-07	5001	0	\N	0	0	\N	\N	0	261210	0	127783003	4133840		
15385	1409	3051031	1918-02-28	1918-02-28 00:00:00	1918-02-28	5001	0	\N	0	0	\N	\N	0	93708	0	46240-8	3051031		
45143	4167	3021226	1991-09-25	1991-09-25 00:00:00	1991-09-25	5001	0	\N	0	0	\N	\N	0	276909	0	6246-3	3021226		
3663	350	3026361	1995-09-11	1995-09-11 00:00:00	1995-09-11	5001	0	\N	0	0	\N	\N	0	23293	0	26453-1	3026361		
3020	295	3049273	2015-11-24	2015-11-24 00:00:00	2015-11-24	5001	0	\N	0	0	\N	\N	0	19645	0	38265-5	3049273		
50706	4623	3036780	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	307872	0	6095-4	3036780		
37639	3470	3006322	1999-08-16	1999-08-16 00:00:00	1999-08-16	5001	0	\N	0	0	\N	\N	0	230323	0	8331-1	3006322		
44257	4078	3015076	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	271017	0	6248-9	3015076		
107933	3332	4024958	1998-06-19	1998-06-19 00:00:00	1998-06-19	5001	0	\N	0	0	\N	\N	0	221126	0	117015009	4024958		
57018	5230	3006322	2005-02-19	2005-02-19 00:00:00	2005-02-19	5001	0	\N	0	0	\N	\N	0	347991	0	8331-1	3006322		
39128	3621	3011505	1991-05-11	1991-05-11 00:00:00	1991-05-11	5001	0	\N	0	0	\N	\N	0	240646	0	19926-5	3011505		
24542	763	4024958	1966-10-13	1966-10-13 00:00:00	1966-10-13	5001	0	\N	0	0	\N	\N	0	50752	0	117015009	4024958		
25251	784	4024958	1959-10-01	1959-10-01 00:00:00	1959-10-01	5001	0	\N	0	0	\N	\N	0	52241	0	117015009	4024958		
42668	3942	3006322	1981-04-08	1981-04-08 00:00:00	1981-04-08	5001	0	\N	0	0	\N	\N	0	262077	0	8331-1	3006322		
43436	4014	3012494	1997-12-09	1997-12-09 00:00:00	1997-12-09	5001	0	\N	0	0	\N	\N	0	266770	0	6206-7	3012494		
54978	5031	3006322	1984-09-22	1984-09-22 00:00:00	1984-09-22	5001	0	\N	0	0	\N	\N	0	334419	0	8331-1	3006322		
48325	4436	3014599	1984-06-17	1984-06-17 00:00:00	1984-06-17	5001	0	\N	0	0	\N	\N	0	294875	0	6106-9	3014599		
20203	1848	3006322	1973-10-30	1973-10-30 00:00:00	1973-10-30	5001	0	\N	0	0	\N	\N	0	123683	0	8331-1	3006322		
51293	4694	3021226	1982-07-22	1982-07-22 00:00:00	1982-07-22	5001	0	\N	0	0	\N	\N	0	312703	0	6246-3	3021226		
7708	742	3011505	1972-11-20	1972-11-20 00:00:00	1972-11-20	5001	0	\N	0	0	\N	\N	0	49151	0	19926-5	3011505		
301	12	3051031	2015-12-13	2015-12-13 00:00:00	2015-12-13	5001	0	\N	0	0	\N	\N	0	1031	0	46240-8	3051031		
21038	1950	3011505	1996-10-17	1996-10-17 00:00:00	1996-10-17	5001	0	\N	0	0	\N	\N	0	129683	0	19926-5	3011505		
50102	4562	40769179	1961-08-04	1961-08-04 00:00:00	1961-08-04	5001	0	\N	0	0	\N	\N	0	304055	0	66519-0	40769179		
6836	656	3006322	1972-09-14	1972-09-14 00:00:00	1972-09-14	5001	0	\N	0	0	\N	\N	0	43436	0	8331-1	3006322		
54594	4990	3006322	2001-10-15	2001-10-15 00:00:00	2001-10-15	5001	0	\N	0	0	\N	\N	0	332003	0	8331-1	3006322		
43993	4064	40769184	1960-11-13	1960-11-13 00:00:00	1960-11-13	5001	0	\N	0	0	\N	\N	0	270090	0	66524-0	40769184		
147125	4509	4133840	1996-04-16	1996-04-16 00:00:00	1996-04-16	5001	0	\N	0	0	\N	\N	0	300395	0	127783003	4133840		
22207	2041	3006322	1964-06-25	1964-06-25 00:00:00	1964-06-25	5001	0	\N	0	0	\N	\N	0	135857	0	8331-1	3006322		
127690	3929	4024958	1957-02-10	1957-02-10 00:00:00	1957-02-10	5001	0	\N	0	0	\N	\N	0	261184	0	117015009	4024958		
143090	4395	4024958	2018-05-31	2018-05-31 00:00:00	2018-05-31	5001	0	\N	0	0	\N	\N	0	292214	0	117015009	4024958		
45144	4167	3001488	1991-09-25	1991-09-25 00:00:00	1991-09-25	5001	0	\N	0	0	\N	\N	0	276909	0	7258-7	3001488		
3664	350	3006923	1995-09-11	1995-09-11 00:00:00	1995-09-11	5001	0	\N	0	0	\N	\N	0	23293	0	1742-6	3006923		
3021	295	3006322	1951-12-03	1951-12-03 00:00:00	1951-12-03	5001	0	\N	0	0	\N	\N	0	19628	0	8331-1	3006322		
10939	347	4133840	2018-12-09	2018-12-09 00:00:00	2018-12-09	5001	0	\N	0	0	\N	\N	0	23081	0	127783003	4133840		
4579	442	3021226	1980-09-11	1980-09-11 00:00:00	1980-09-11	5001	0	\N	0	0	\N	\N	0	29313	0	6246-3	3021226		
44258	4078	3005136	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	271017	0	6075-6	3005136		
107936	3332	4024958	1971-03-17	1971-03-17 00:00:00	1971-03-17	5001	0	\N	0	0	\N	\N	0	221068	0	117015009	4024958		
57019	5230	3049273	2002-03-05	2002-03-05 00:00:00	2002-03-05	5001	0	\N	0	0	\N	\N	0	347941	0	38265-5	3049273		
39130	3621	3011505	1986-10-11	1986-10-11 00:00:00	1986-10-11	5001	0	\N	0	0	\N	\N	0	240655	0	19926-5	3011505		
24544	763	4024958	1970-01-10	1970-01-10 00:00:00	1970-01-10	5001	0	\N	0	0	\N	\N	0	50747	0	117015009	4024958		
25267	784	4052083	1967-11-18	1967-11-18 00:00:00	1967-11-18	5001	0	\N	0	0	\N	\N	0	52217	0	23426006	4052083		
42669	3943	3006322	1977-12-14	1977-12-14 00:00:00	1977-12-14	5001	0	\N	0	0	\N	\N	0	262167	0	8331-1	3006322		
43437	4014	3006451	1997-12-09	1997-12-09 00:00:00	1997-12-09	5001	0	\N	0	0	\N	\N	0	266770	0	6273-7	3006451		
54979	5031	3006322	1985-10-28	1985-10-28 00:00:00	1985-10-28	5001	0	\N	0	0	\N	\N	0	334364	0	8331-1	3006322		
48326	4436	3019406	1984-06-17	1984-06-17 00:00:00	1984-06-17	5001	0	\N	0	0	\N	\N	0	294875	0	6158-0	3019406		
20204	1848	3006322	2004-04-24	2004-04-24 00:00:00	2004-04-24	5001	0	\N	0	0	\N	\N	0	123689	0	8331-1	3006322		
51294	4694	3015076	1982-07-22	1982-07-22 00:00:00	1982-07-22	5001	0	\N	0	0	\N	\N	0	312703	0	6248-9	3015076		
7709	742	3006322	1965-09-08	1965-09-08 00:00:00	1965-09-08	5001	0	\N	0	0	\N	\N	0	49137	0	8331-1	3006322		
303	12	40758406	2015-12-13	2015-12-13 00:00:00	2015-12-13	5001	0	\N	0	0	\N	\N	0	1031	0	55277-8	40758406		
21039	1950	3011505	2017-02-09	2017-02-09 00:00:00	2017-02-09	5001	0	\N	0	0	\N	\N	0	129695	0	19926-5	3011505		
50103	4562	40769194	1961-08-04	1961-08-04 00:00:00	1961-08-04	5001	0	\N	0	0	\N	\N	0	304055	0	66534-9	40769194		
6837	656	3006322	1971-06-06	1971-06-06 00:00:00	1971-06-06	5001	0	\N	0	0	\N	\N	0	43433	0	8331-1	3006322		
54595	4990	3006322	1980-01-22	1980-01-22 00:00:00	1980-01-22	5001	0	\N	0	0	\N	\N	0	331951	0	8331-1	3006322		
43994	4064	40769189	1960-11-13	1960-11-13 00:00:00	1960-11-13	5001	0	\N	0	0	\N	\N	0	270090	0	66529-9	40769189		
147126	4509	4133840	1993-04-13	1993-04-13 00:00:00	1993-04-13	5001	0	\N	0	0	\N	\N	0	300360	0	127783003	4133840		
22208	2041	3006322	1992-02-13	1992-02-13 00:00:00	1992-02-13	5001	0	\N	0	0	\N	\N	0	135859	0	8331-1	3006322		
127700	3930	4133840	1975-08-09	1975-08-09 00:00:00	1975-08-09	5001	0	\N	0	0	\N	\N	0	261255	0	127783003	4133840		
143096	4395	4024958	1966-09-28	1966-09-28 00:00:00	1966-09-28	5001	0	\N	0	0	\N	\N	0	292265	0	117015009	4024958		
45145	4167	3036780	1991-09-25	1991-09-25 00:00:00	1991-09-25	5001	0	\N	0	0	\N	\N	0	276909	0	6095-4	3036780		
3665	350	3035995	1995-09-11	1995-09-11 00:00:00	1995-09-11	5001	0	\N	0	0	\N	\N	0	23293	0	6768-6	3035995		
3022	295	3049273	2017-02-16	2017-02-16 00:00:00	2017-02-16	5001	0	\N	0	0	\N	\N	0	19646	0	38265-5	3049273		
10943	347	4133840	2005-11-13	2005-11-13 00:00:00	2005-11-13	5001	0	\N	0	0	\N	\N	0	23110	0	127783003	4133840		
4580	442	3027231	1980-09-11	1980-09-11 00:00:00	1980-09-11	5001	0	\N	0	0	\N	\N	0	29313	0	6276-0	3027231		
44259	4078	3006451	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	271017	0	6273-7	3006451		
119224	3672	4052083	1986-02-07	1986-02-07 00:00:00	1986-02-07	5001	0	\N	0	0	\N	\N	0	244289	0	23426006	4052083		
57020	5230	3049273	2005-11-09	2005-11-09 00:00:00	2005-11-09	5001	0	\N	0	0	\N	\N	0	348020	0	38265-5	3049273		
39131	3621	3006322	1950-09-19	1950-09-19 00:00:00	1950-09-19	5001	0	\N	0	0	\N	\N	0	240620	0	8331-1	3006322		
24545	763	4052083	2000-11-17	2000-11-17 00:00:00	2000-11-17	5001	0	\N	0	0	\N	\N	0	50745	0	23426006	4052083		
25269	784	4052083	1991-06-29	1991-06-29 00:00:00	1991-06-29	5001	0	\N	0	0	\N	\N	0	52180	0	23426006	4052083		
42670	3943	3049273	2018-07-23	2018-07-23 00:00:00	2018-07-23	5001	0	\N	0	0	\N	\N	0	262139	0	38265-5	3049273		
43438	4014	3023430	1997-12-09	1997-12-09 00:00:00	1997-12-09	5001	0	\N	0	0	\N	\N	0	266770	0	6833-8	3023430		
54980	5031	3006322	1969-12-15	1969-12-15 00:00:00	1969-12-15	5001	0	\N	0	0	\N	\N	0	334415	0	8331-1	3006322		
48327	4436	3036780	1984-06-17	1984-06-17 00:00:00	1984-06-17	5001	0	\N	0	0	\N	\N	0	294875	0	6095-4	3036780		
20205	1848	3006322	1954-11-24	1954-11-24 00:00:00	1954-11-24	5001	0	\N	0	0	\N	\N	0	123680	0	8331-1	3006322		
51295	4694	3005136	1982-07-22	1982-07-22 00:00:00	1982-07-22	5001	0	\N	0	0	\N	\N	0	312703	0	6075-6	3005136		
7710	742	3006322	1926-11-18	1926-11-18 00:00:00	1926-11-18	5001	0	\N	0	0	\N	\N	0	49105	0	8331-1	3006322		
304	12	40766240	2015-12-13	2015-12-13 00:00:00	2015-12-13	5001	0	\N	0	0	\N	\N	0	1031	0	63513-6	40766240		
21040	1950	3006322	1982-12-31	1982-12-31 00:00:00	1982-12-31	5001	0	\N	0	0	\N	\N	0	129699	0	8331-1	3006322		
50104	4562	40769189	1961-08-04	1961-08-04 00:00:00	1961-08-04	5001	0	\N	0	0	\N	\N	0	304055	0	66529-9	40769189		
6838	656	3006322	1972-10-29	1972-10-29 00:00:00	1972-10-29	5001	0	\N	0	0	\N	\N	0	43461	0	8331-1	3006322		
94144	2896	4052083	1985-06-29	1985-06-29 00:00:00	1985-06-29	5001	0	\N	0	0	\N	\N	0	192835	0	23426006	4052083		
43995	4064	40769194	1960-11-13	1960-11-13 00:00:00	1960-11-13	5001	0	\N	0	0	\N	\N	0	270090	0	66534-9	40769194		
103322	3177	4052083	1920-02-01	1920-02-01 00:00:00	1920-02-01	5001	0	\N	0	0	\N	\N	0	211246	0	23426006	4052083		
22210	2041	3051031	1965-08-23	1965-08-23 00:00:00	1965-08-23	5001	0	\N	0	0	\N	\N	0	135858	0	46240-8	3051031		
127701	3930	4133840	1979-09-01	1979-09-01 00:00:00	1979-09-01	5001	0	\N	0	0	\N	\N	0	261289	0	127783003	4133840		
170460	5229	4024958	1965-10-20	1965-10-20 00:00:00	1965-10-20	5001	0	\N	0	0	\N	\N	0	347922	0	117015009	4024958		
45146	4167	3001247	1991-09-25	1991-09-25 00:00:00	1991-09-25	5001	0	\N	0	0	\N	\N	0	276909	0	6085-5	3001247		
3666	350	3015632	1995-09-11	1995-09-11 00:00:00	1995-09-11	5001	0	\N	0	0	\N	\N	0	23293	0	2028-9	3015632		
3023	295	3006322	1975-08-06	1975-08-06 00:00:00	1975-08-06	5001	0	\N	0	0	\N	\N	0	19631	0	8331-1	3006322		
10948	347	4133840	2002-11-10	2002-11-10 00:00:00	2002-11-10	5001	0	\N	0	0	\N	\N	0	23109	0	127783003	4133840		
4581	442	3000876	1980-09-11	1980-09-11 00:00:00	1980-09-11	5001	0	\N	0	0	\N	\N	0	29313	0	6082-2	3000876		
44260	4078	3027231	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	271017	0	6276-0	3027231		
49174	4497	3051031	2008-01-11	2008-01-11 00:00:00	2008-01-11	5001	0	\N	0	0	\N	\N	0	299383	0	46240-8	3051031		
57021	5230	3006322	1990-10-02	1990-10-02 00:00:00	1990-10-02	5001	0	\N	0	0	\N	\N	0	347990	0	8331-1	3006322		
39132	3621	3011505	1981-09-12	1981-09-12 00:00:00	1981-09-12	5001	0	\N	0	0	\N	\N	0	240603	0	19926-5	3011505		
24546	763	4024958	1991-12-12	1991-12-12 00:00:00	1991-12-12	5001	0	\N	0	0	\N	\N	0	50751	0	117015009	4024958		
25273	785	4024958	1989-04-29	1989-04-29 00:00:00	1989-04-29	5001	0	\N	0	0	\N	\N	0	52298	0	117015009	4024958		
42671	3943	3006322	2005-04-16	2005-04-16 00:00:00	2005-04-16	5001	0	\N	0	0	\N	\N	0	262189	0	8331-1	3006322		
43439	4014	3020655	1997-12-09	1997-12-09 00:00:00	1997-12-09	5001	0	\N	0	0	\N	\N	0	266770	0	6844-5	3020655		
54981	5031	3006322	1959-08-03	1959-08-03 00:00:00	1959-08-03	5001	0	\N	0	0	\N	\N	0	334328	0	8331-1	3006322		
48328	4436	3000876	1984-06-17	1984-06-17 00:00:00	1984-06-17	5001	0	\N	0	0	\N	\N	0	294875	0	6082-2	3000876		
20206	1848	3006322	1989-11-29	1989-11-29 00:00:00	1989-11-29	5001	0	\N	0	0	\N	\N	0	123688	0	8331-1	3006322		
51296	4694	3006451	1982-07-22	1982-07-22 00:00:00	1982-07-22	5001	0	\N	0	0	\N	\N	0	312703	0	6273-7	3006451		
7712	742	3011505	1993-04-26	1993-04-26 00:00:00	1993-04-26	5001	0	\N	0	0	\N	\N	0	49210	0	19926-5	3011505		
306	12	46235214	2015-12-13	2015-12-13 00:00:00	2015-12-13	5001	0	\N	0	0	\N	\N	0	1031	0	76690-7	46235214		
21041	1950	3011505	2014-01-23	2014-01-23 00:00:00	2014-01-23	5001	0	\N	0	0	\N	\N	0	129664	0	19926-5	3011505		
50105	4562	3006322	1993-10-23	1993-10-23 00:00:00	1993-10-23	5001	0	\N	0	0	\N	\N	0	303983	0	8331-1	3006322		
6839	656	3006322	1979-10-06	1979-10-06 00:00:00	1979-10-06	5001	0	\N	0	0	\N	\N	0	43473	0	8331-1	3006322		
105440	3244	4024958	1986-01-13	1986-01-13 00:00:00	1986-01-13	5001	0	\N	0	0	\N	\N	0	215712	0	117015009	4024958		
25141	2309	3051031	1974-06-28	1974-06-28 00:00:00	1974-06-28	5001	0	\N	0	0	\N	\N	0	153611	0	46240-8	3051031		
103323	3177	4024958	1932-01-27	1932-01-27 00:00:00	1932-01-27	5001	0	\N	0	0	\N	\N	0	211265	0	117015009	4024958		
22211	2041	40766240	1965-08-23	1965-08-23 00:00:00	1965-08-23	5001	0	\N	0	0	\N	\N	0	135858	0	63513-6	40766240		
127706	3930	4133840	1968-12-21	1968-12-21 00:00:00	1968-12-21	5001	0	\N	0	0	\N	\N	0	261303	0	127783003	4133840		
170477	5229	4052083	2000-07-16	2000-07-16 00:00:00	2000-07-16	5001	0	\N	0	0	\N	\N	0	347892	0	23426006	4052083		
45147	4167	3006734	1991-09-25	1991-09-25 00:00:00	1991-09-25	5001	0	\N	0	0	\N	\N	0	276909	0	6189-5	3006734		
3667	350	3007461	1995-09-11	1995-09-11 00:00:00	1995-09-11	5001	0	\N	0	0	\N	\N	0	23293	0	26515-7	3007461		
3024	295	3006322	1959-09-04	1959-09-04 00:00:00	1959-09-04	5001	0	\N	0	0	\N	\N	0	19621	0	8331-1	3006322		
10951	347	4133840	1996-11-03	1996-11-03 00:00:00	1996-11-03	5001	0	\N	0	0	\N	\N	0	23107	0	127783003	4133840		
4582	442	3015076	1980-09-11	1980-09-11 00:00:00	1980-09-11	5001	0	\N	0	0	\N	\N	0	29313	0	6248-9	3015076		
44261	4078	3006322	1963-09-06	1963-09-06 00:00:00	1963-09-06	5001	0	\N	0	0	\N	\N	0	271056	0	8331-1	3006322		
49175	4497	40758406	2008-01-11	2008-01-11 00:00:00	2008-01-11	5001	0	\N	0	0	\N	\N	0	299383	0	55277-8	40758406		
57022	5230	3006322	1953-03-25	1953-03-25 00:00:00	1953-03-25	5001	0	\N	0	0	\N	\N	0	347947	0	8331-1	3006322		
39135	3621	3011505	1992-05-16	1992-05-16 00:00:00	1992-05-16	5001	0	\N	0	0	\N	\N	0	240604	0	19926-5	3011505		
24547	763	4052083	1990-05-17	1990-05-17 00:00:00	1990-05-17	5001	0	\N	0	0	\N	\N	0	50743	0	23426006	4052083		
25288	785	4052083	1966-09-24	1966-09-24 00:00:00	1966-09-24	5001	0	\N	0	0	\N	\N	0	52284	0	23426006	4052083		
42672	3943	3006322	2005-11-22	2005-11-22 00:00:00	2005-11-22	5001	0	\N	0	0	\N	\N	0	262169	0	8331-1	3006322		
43440	4014	3001488	1997-12-09	1997-12-09 00:00:00	1997-12-09	5001	0	\N	0	0	\N	\N	0	266770	0	7258-7	3001488		
54982	5031	3049273	1990-08-17	1990-08-17 00:00:00	1990-08-17	5001	0	\N	0	0	\N	\N	0	334281	0	38265-5	3049273		
48329	4436	3006734	1984-06-17	1984-06-17 00:00:00	1984-06-17	5001	0	\N	0	0	\N	\N	0	294875	0	6189-5	3006734		
51297	4694	3027231	1982-07-22	1982-07-22 00:00:00	1982-07-22	5001	0	\N	0	0	\N	\N	0	312703	0	6276-0	3027231		
7713	742	3011505	1981-09-28	1981-09-28 00:00:00	1981-09-28	5001	0	\N	0	0	\N	\N	0	49204	0	19926-5	3011505		
307	12	40766240	2016-03-12	2016-03-12 00:00:00	2016-03-12	5001	0	\N	0	0	\N	\N	0	1032	0	63513-6	40766240		
21042	1950	3011505	1993-09-30	1993-09-30 00:00:00	1993-09-30	5001	0	\N	0	0	\N	\N	0	129656	0	19926-5	3011505		
50106	4562	3006322	2018-05-11	2018-05-11 00:00:00	2018-05-11	5001	0	\N	0	0	\N	\N	0	304045	0	8331-1	3006322		
6840	656	3006322	2012-07-04	2012-07-04 00:00:00	2012-07-04	5001	0	\N	0	0	\N	\N	0	43447	0	8331-1	3006322		
105457	3246	4052083	2002-10-10	2002-10-10 00:00:00	2002-10-10	5001	0	\N	0	0	\N	\N	0	215779	0	23426006	4052083		
25142	2309	40758406	1974-06-28	1974-06-28 00:00:00	1974-06-28	5001	0	\N	0	0	\N	\N	0	153611	0	55277-8	40758406		
103324	3177	4052083	2006-04-08	2006-04-08 00:00:00	2006-04-08	5001	0	\N	0	0	\N	\N	0	211272	0	23426006	4052083		
22212	2041	46235214	1965-08-23	1965-08-23 00:00:00	1965-08-23	5001	0	\N	0	0	\N	\N	0	135858	0	76690-7	46235214		
127707	3930	4133840	1965-12-04	1965-12-04 00:00:00	1965-12-04	5001	0	\N	0	0	\N	\N	0	261253	0	127783003	4133840		
170478	5229	4024958	1973-05-26	1973-05-26 00:00:00	1973-05-26	5001	0	\N	0	0	\N	\N	0	347871	0	117015009	4024958		
45148	4167	3027231	1991-09-25	1991-09-25 00:00:00	1991-09-25	5001	0	\N	0	0	\N	\N	0	276909	0	6276-0	3027231		
3668	350	3045716	1995-09-11	1995-09-11 00:00:00	1995-09-11	5001	0	\N	0	0	\N	\N	0	23293	0	33037-3	3045716		
3025	295	3006322	1964-03-21	1964-03-21 00:00:00	1964-03-21	5001	0	\N	0	0	\N	\N	0	19629	0	8331-1	3006322		
10952	347	4024958	2002-11-22	2002-11-22 00:00:00	2002-11-22	5001	0	\N	0	0	\N	\N	0	23100	0	117015009	4024958		
4583	442	3001488	1980-09-11	1980-09-11 00:00:00	1980-09-11	5001	0	\N	0	0	\N	\N	0	29313	0	7258-7	3001488		
44262	4078	3006322	1989-03-15	1989-03-15 00:00:00	1989-03-15	5001	0	\N	0	0	\N	\N	0	270978	0	8331-1	3006322		
49176	4497	40766240	2008-01-11	2008-01-11 00:00:00	2008-01-11	5001	0	\N	0	0	\N	\N	0	299383	0	63513-6	40766240		
57023	5230	3006322	1989-02-09	1989-02-09 00:00:00	1989-02-09	5001	0	\N	0	0	\N	\N	0	347989	0	8331-1	3006322		
39136	3621	3011505	1976-08-14	1976-08-14 00:00:00	1976-08-14	5001	0	\N	0	0	\N	\N	0	240642	0	19926-5	3011505		
24563	764	4024958	2006-11-13	2006-11-13 00:00:00	2006-11-13	5001	0	\N	0	0	\N	\N	0	50835	0	117015009	4024958		
25290	785	4024958	1985-02-03	1985-02-03 00:00:00	1985-02-03	5001	0	\N	0	0	\N	\N	0	52297	0	117015009	4024958		
42673	3943	3006322	1977-08-31	1977-08-31 00:00:00	1977-08-31	5001	0	\N	0	0	\N	\N	0	262140	0	8331-1	3006322		
43441	4014	3027231	1997-12-09	1997-12-09 00:00:00	1997-12-09	5001	0	\N	0	0	\N	\N	0	266770	0	6276-0	3027231		
54983	5031	3006322	1944-11-08	1944-11-08 00:00:00	1944-11-08	5001	0	\N	0	0	\N	\N	0	334361	0	8331-1	3006322		
48330	4436	3006451	1984-06-17	1984-06-17 00:00:00	1984-06-17	5001	0	\N	0	0	\N	\N	0	294875	0	6273-7	3006451		
51298	4694	3006322	2016-10-18	2016-10-18 00:00:00	2016-10-18	5001	0	\N	0	0	\N	\N	0	312774	0	8331-1	3006322		
7714	742	3011505	1974-08-19	1974-08-19 00:00:00	1974-08-19	5001	0	\N	0	0	\N	\N	0	49171	0	19926-5	3011505		
309	12	40758406	2016-03-12	2016-03-12 00:00:00	2016-03-12	5001	0	\N	0	0	\N	\N	0	1032	0	55277-8	40758406		
21043	1950	3011505	2012-01-12	2012-01-12 00:00:00	2012-01-12	5001	0	\N	0	0	\N	\N	0	129663	0	19926-5	3011505		
50107	4562	3006322	1963-08-20	1963-08-20 00:00:00	1963-08-20	5001	0	\N	0	0	\N	\N	0	304031	0	8331-1	3006322		
6841	656	3006322	1966-02-24	1966-02-24 00:00:00	1966-02-24	5001	0	\N	0	0	\N	\N	0	43432	0	8331-1	3006322		
105458	3246	4024958	1988-01-10	1988-01-10 00:00:00	1988-01-10	5001	0	\N	0	0	\N	\N	0	215812	0	117015009	4024958		
25143	2309	46235214	1974-06-28	1974-06-28 00:00:00	1974-06-28	5001	0	\N	0	0	\N	\N	0	153611	0	76690-7	46235214		
103325	3177	4024958	1931-11-14	1931-11-14 00:00:00	1931-11-14	5001	0	\N	0	0	\N	\N	0	211264	0	117015009	4024958		
22213	2041	40758406	1965-08-23	1965-08-23 00:00:00	1965-08-23	5001	0	\N	0	0	\N	\N	0	135858	0	55277-8	40758406		
72859	2237	4024958	1939-05-22	1939-05-22 00:00:00	1939-05-22	5001	0	\N	0	0	\N	\N	0	148745	0	117015009	4024958		
170514	5230	4024958	1994-01-05	1994-01-05 00:00:00	1994-01-05	5001	0	\N	0	0	\N	\N	0	347982	0	117015009	4024958		
45149	4167	3006451	1991-09-25	1991-09-25 00:00:00	1991-09-25	5001	0	\N	0	0	\N	\N	0	276909	0	6273-7	3006451		
3669	350	3023103	1995-09-11	1995-09-11 00:00:00	1995-09-11	5001	0	\N	0	0	\N	\N	0	23293	0	2823-3	3023103		
3026	295	3006322	1992-05-22	1992-05-22 00:00:00	1992-05-22	5001	0	\N	0	0	\N	\N	0	19601	0	8331-1	3006322		
10953	347	4024958	2015-03-03	2015-03-03 00:00:00	2015-03-03	5001	0	\N	0	0	\N	\N	0	23091	0	117015009	4024958		
4584	442	3023430	1980-09-11	1980-09-11 00:00:00	1980-09-11	5001	0	\N	0	0	\N	\N	0	29313	0	6833-8	3023430		
44263	4078	3006322	2008-01-11	2008-01-11 00:00:00	2008-01-11	5001	0	\N	0	0	\N	\N	0	271081	0	8331-1	3006322		
49177	4497	46235214	2008-01-11	2008-01-11 00:00:00	2008-01-11	5001	0	\N	0	0	\N	\N	0	299383	0	76690-7	46235214		
57024	5230	3006322	1974-02-17	1974-02-17 00:00:00	1974-02-17	5001	0	\N	0	0	\N	\N	0	347981	0	8331-1	3006322		
39137	3621	3011505	1969-07-12	1969-07-12 00:00:00	1969-07-12	5001	0	\N	0	0	\N	\N	0	240650	0	19926-5	3011505		
24567	764	4052083	1997-01-08	1997-01-08 00:00:00	1997-01-08	5001	0	\N	0	0	\N	\N	0	50834	0	23426006	4052083		
56820	1737	4024958	1935-08-15	1935-08-15 00:00:00	1935-08-15	5001	0	\N	0	0	\N	\N	0	115977	0	117015009	4024958		
42674	3943	3006322	1983-11-26	1983-11-26 00:00:00	1983-11-26	5001	0	\N	0	0	\N	\N	0	262176	0	8331-1	3006322		
43442	4014	3015076	1997-12-09	1997-12-09 00:00:00	1997-12-09	5001	0	\N	0	0	\N	\N	0	266770	0	6248-9	3015076		
54984	5031	3006322	1931-09-09	1931-09-09 00:00:00	1931-09-09	5001	0	\N	0	0	\N	\N	0	334312	0	8331-1	3006322		
51299	4694	3001488	1998-02-15	1998-02-15 00:00:00	1998-02-15	5001	0	\N	0	0	\N	\N	0	312735	0	7258-7	3001488		
7715	742	3011505	1995-05-08	1995-05-08 00:00:00	1995-05-08	5001	0	\N	0	0	\N	\N	0	49211	0	19926-5	3011505		
310	12	46235214	2016-03-12	2016-03-12 00:00:00	2016-03-12	5001	0	\N	0	0	\N	\N	0	1032	0	76690-7	46235214		
21044	1950	3011505	2007-12-20	2007-12-20 00:00:00	2007-12-20	5001	0	\N	0	0	\N	\N	0	129621	0	19926-5	3011505		
50108	4563	3006322	1985-12-02	1985-12-02 00:00:00	1985-12-02	5001	0	\N	0	0	\N	\N	0	304092	0	8331-1	3006322		
6842	656	3006322	1980-01-13	1980-01-13 00:00:00	1980-01-13	5001	0	\N	0	0	\N	\N	0	43462	0	8331-1	3006322		
136938	4220	4052083	1986-03-09	1986-03-09 00:00:00	1986-03-09	5001	0	\N	0	0	\N	\N	0	280198	0	23426006	4052083		
25144	2309	40766240	1974-06-28	1974-06-28 00:00:00	1974-06-28	5001	0	\N	0	0	\N	\N	0	153611	0	63513-6	40766240		
103327	3177	4052083	1985-09-03	1985-09-03 00:00:00	1985-09-03	5001	0	\N	0	0	\N	\N	0	211344	0	23426006	4052083		
22216	2041	46235214	1965-10-22	1965-10-22 00:00:00	1965-10-22	5001	0	\N	0	0	\N	\N	0	135864	0	76690-7	46235214		
72868	2237	4052083	1936-05-05	1936-05-05 00:00:00	1936-05-05	5001	0	\N	0	0	\N	\N	0	148744	0	23426006	4052083		
170521	5230	4052083	1996-06-12	1996-06-12 00:00:00	1996-06-12	5001	0	\N	0	0	\N	\N	0	347961	0	23426006	4052083		
45150	4167	3023430	1995-03-29	1995-03-29 00:00:00	1995-03-29	5001	0	\N	0	0	\N	\N	0	276898	0	6833-8	3023430		
3670	350	3013682	1995-09-11	1995-09-11 00:00:00	1995-09-11	5001	0	\N	0	0	\N	\N	0	23293	0	3094-0	3013682		
120752	3725	4024958	1970-06-27	1970-06-27 00:00:00	1970-06-27	5001	0	\N	0	0	\N	\N	0	247587	0	117015009	4024958		
10954	347	4133840	1999-11-07	1999-11-07 00:00:00	1999-11-07	5001	0	\N	0	0	\N	\N	0	23108	0	127783003	4133840		
4585	442	3036780	1980-09-11	1980-09-11 00:00:00	1980-09-11	5001	0	\N	0	0	\N	\N	0	29313	0	6095-4	3036780		
44267	4081	3006322	2015-06-03	2015-06-03 00:00:00	2015-06-03	5001	0	\N	0	0	\N	\N	0	271250	0	8331-1	3006322		
49178	4497	3006322	1962-04-29	1962-04-29 00:00:00	1962-04-29	5001	0	\N	0	0	\N	\N	0	299415	0	8331-1	3006322		
57025	5230	3006322	1994-01-05	1994-01-05 00:00:00	1994-01-05	5001	0	\N	0	0	\N	\N	0	347982	0	8331-1	3006322		
39138	3621	3011505	1975-08-09	1975-08-09 00:00:00	1975-08-09	5001	0	\N	0	0	\N	\N	0	240653	0	19926-5	3011505		
127835	3934	4052083	1939-02-16	1939-02-16 00:00:00	1939-02-16	5001	0	\N	0	0	\N	\N	0	261448	0	23426006	4052083		
56824	1737	4052083	1941-08-31	1941-08-31 00:00:00	1941-08-31	5001	0	\N	0	0	\N	\N	0	115978	0	23426006	4052083		
42675	3943	3006322	1954-12-02	1954-12-02 00:00:00	1954-12-02	5001	0	\N	0	0	\N	\N	0	262133	0	8331-1	3006322		
43443	4014	3001247	1997-12-09	1997-12-09 00:00:00	1997-12-09	5001	0	\N	0	0	\N	\N	0	266770	0	6085-5	3001247		
54985	5031	3006322	1980-04-01	1980-04-01 00:00:00	1980-04-01	5001	0	\N	0	0	\N	\N	0	334417	0	8331-1	3006322		
51300	4694	3019406	1998-02-15	1998-02-15 00:00:00	1998-02-15	5001	0	\N	0	0	\N	\N	0	312735	0	6158-0	3019406		
7716	742	3011505	1970-11-16	1970-11-16 00:00:00	1970-11-16	5001	0	\N	0	0	\N	\N	0	49170	0	19926-5	3011505		
311	12	3051031	2016-03-12	2016-03-12 00:00:00	2016-03-12	5001	0	\N	0	0	\N	\N	0	1032	0	46240-8	3051031		
21045	1950	3011505	2002-11-21	2002-11-21 00:00:00	2002-11-21	5001	0	\N	0	0	\N	\N	0	129694	0	19926-5	3011505		
50109	4563	3006322	2010-05-12	2010-05-12 00:00:00	2010-05-12	5001	0	\N	0	0	\N	\N	0	304109	0	8331-1	3006322		
6897	662	3006322	1964-01-07	1964-01-07 00:00:00	1964-01-07	5001	0	\N	0	0	\N	\N	0	43749	0	8331-1	3006322		
136941	4220	4052083	1973-03-18	1973-03-18 00:00:00	1973-03-18	5001	0	\N	0	0	\N	\N	0	280197	0	23426006	4052083		
25146	2309	3006322	1983-05-19	1983-05-19 00:00:00	1983-05-19	5001	0	\N	0	0	\N	\N	0	153621	0	8331-1	3006322		
103337	3177	4052083	1946-07-10	1946-07-10 00:00:00	1946-07-10	5001	0	\N	0	0	\N	\N	0	211249	0	23426006	4052083		
22217	2041	40758406	1965-10-22	1965-10-22 00:00:00	1965-10-22	5001	0	\N	0	0	\N	\N	0	135864	0	55277-8	40758406		
72920	2238	4024958	2010-09-19	2010-09-19 00:00:00	2010-09-19	5001	0	\N	0	0	\N	\N	0	148926	0	117015009	4024958		
127791	3932	4024958	1981-11-08	1981-11-08 00:00:00	1981-11-08	5001	0	\N	0	0	\N	\N	0	261361	0	117015009	4024958		
45151	4167	3020655	1995-03-29	1995-03-29 00:00:00	1995-03-29	5001	0	\N	0	0	\N	\N	0	276898	0	6844-5	3020655		
3671	350	3002385	1995-09-11	1995-09-11 00:00:00	1995-09-11	5001	0	\N	0	0	\N	\N	0	23293	0	30385-9	3002385		
120805	3728	4024958	1984-06-13	1984-06-13 00:00:00	1984-06-13	5001	0	\N	0	0	\N	\N	0	247698	0	117015009	4024958		
10955	347	4133840	2012-11-25	2012-11-25 00:00:00	2012-11-25	5001	0	\N	0	0	\N	\N	0	23098	0	127783003	4133840		
4586	442	3005136	1980-09-11	1980-09-11 00:00:00	1980-09-11	5001	0	\N	0	0	\N	\N	0	29313	0	6075-6	3005136		
44268	4081	3006322	1956-12-03	1956-12-03 00:00:00	1956-12-03	5001	0	\N	0	0	\N	\N	0	271221	0	8331-1	3006322		
49179	4497	40766240	2008-03-11	2008-03-11 00:00:00	2008-03-11	5001	0	\N	0	0	\N	\N	0	299400	0	63513-6	40766240		
57029	5232	3006322	1968-09-15	1968-09-15 00:00:00	1968-09-15	5001	0	\N	0	0	\N	\N	0	348081	0	8331-1	3006322		
39139	3621	3006322	1984-11-21	1984-11-21 00:00:00	1984-11-21	5001	0	\N	0	0	\N	\N	0	240638	0	8331-1	3006322		
127837	3934	4024958	1976-11-15	1976-11-15 00:00:00	1976-11-15	5001	0	\N	0	0	\N	\N	0	261490	0	117015009	4024958		
56833	1737	4052083	1993-03-21	1993-03-21 00:00:00	1993-03-21	5001	0	\N	0	0	\N	\N	0	116099	0	23426006	4052083		
42676	3943	3006322	1960-03-19	1960-03-19 00:00:00	1960-03-19	5001	0	\N	0	0	\N	\N	0	262134	0	8331-1	3006322		
43444	4014	3006734	1997-12-09	1997-12-09 00:00:00	1997-12-09	5001	0	\N	0	0	\N	\N	0	266770	0	6189-5	3006734		
54986	5034	3006322	1982-05-20	1982-05-20 00:00:00	1982-05-20	5001	0	\N	0	0	\N	\N	0	334487	0	8331-1	3006322		
51301	4694	3012494	1998-02-15	1998-02-15 00:00:00	1998-02-15	5001	0	\N	0	0	\N	\N	0	312735	0	6206-7	3012494		
7717	742	3011505	2013-12-23	2013-12-23 00:00:00	2013-12-23	5001	0	\N	0	0	\N	\N	0	49186	0	19926-5	3011505		
313	12	3006322	1995-10-22	1995-10-22 00:00:00	1995-10-22	5001	0	\N	0	0	\N	\N	0	1017	0	8331-1	3006322		
21046	1950	3011505	2003-11-27	2003-11-27 00:00:00	2003-11-27	5001	0	\N	0	0	\N	\N	0	129620	0	19926-5	3011505		
50110	4563	3006322	1969-05-16	1969-05-16 00:00:00	1969-05-16	5001	0	\N	0	0	\N	\N	0	304090	0	8331-1	3006322		
6898	662	3006322	1986-01-08	1986-01-08 00:00:00	1986-01-08	5001	0	\N	0	0	\N	\N	0	43699	0	8331-1	3006322		
136981	4222	4052083	1956-03-12	1956-03-12 00:00:00	1956-03-12	5001	0	\N	0	0	\N	\N	0	280302	0	23426006	4052083		
25148	2309	40766240	1974-08-27	1974-08-27 00:00:00	1974-08-27	5001	0	\N	0	0	\N	\N	0	153619	0	63513-6	40766240		
103338	3177	4024958	1948-02-12	1948-02-12 00:00:00	1948-02-12	5001	0	\N	0	0	\N	\N	0	211353	0	117015009	4024958		
22218	2041	40766240	1965-10-22	1965-10-22 00:00:00	1965-10-22	5001	0	\N	0	0	\N	\N	0	135864	0	63513-6	40766240		
29788	2745	3006322	1992-09-24	1992-09-24 00:00:00	1992-09-24	5001	0	\N	0	0	\N	\N	0	181553	0	8331-1	3006322		
127795	3932	4024958	1995-12-08	1995-12-08 00:00:00	1995-12-08	5001	0	\N	0	0	\N	\N	0	261404	0	117015009	4024958		
3672	350	3020630	1995-09-11	1995-09-11 00:00:00	1995-09-11	5001	0	\N	0	0	\N	\N	0	23293	0	2885-2	3020630		
120808	3728	4024958	1990-02-24	1990-02-24 00:00:00	1990-02-24	5001	0	\N	0	0	\N	\N	0	247729	0	117015009	4024958		
10958	347	4133840	2014-11-30	2014-11-30 00:00:00	2014-11-30	5001	0	\N	0	0	\N	\N	0	23089	0	127783003	4133840		
4587	442	3006734	1980-09-11	1980-09-11 00:00:00	1980-09-11	5001	0	\N	0	0	\N	\N	0	29313	0	6189-5	3006734		
44269	4081	3006322	1962-07-01	1962-07-01 00:00:00	1962-07-01	5001	0	\N	0	0	\N	\N	0	271282	0	8331-1	3006322		
49180	4497	46235214	2008-03-11	2008-03-11 00:00:00	2008-03-11	5001	0	\N	0	0	\N	\N	0	299400	0	76690-7	46235214		
57030	5232	3006322	1989-04-14	1989-04-14 00:00:00	1989-04-14	5001	0	\N	0	0	\N	\N	0	348083	0	8331-1	3006322		
39140	3621	3011505	1980-09-06	1980-09-06 00:00:00	1980-09-06	5001	0	\N	0	0	\N	\N	0	240644	0	19926-5	3011505		
127843	3934	4052083	1952-03-26	1952-03-26 00:00:00	1952-03-26	5001	0	\N	0	0	\N	\N	0	261520	0	23426006	4052083		
56837	1737	4024958	1922-12-08	1922-12-08 00:00:00	1922-12-08	5001	0	\N	0	0	\N	\N	0	115976	0	117015009	4024958		
42683	3946	3006322	2013-03-15	2013-03-15 00:00:00	2013-03-15	5001	0	\N	0	0	\N	\N	0	262309	0	8331-1	3006322		
43445	4014	3036780	1997-12-09	1997-12-09 00:00:00	1997-12-09	5001	0	\N	0	0	\N	\N	0	266770	0	6095-4	3036780		
54987	5034	3006322	1970-08-28	1970-08-28 00:00:00	1970-08-28	5001	0	\N	0	0	\N	\N	0	334530	0	8331-1	3006322		
51302	4694	3020655	1998-02-15	1998-02-15 00:00:00	1998-02-15	5001	0	\N	0	0	\N	\N	0	312735	0	6844-5	3020655		
7718	742	3011505	1982-10-04	1982-10-04 00:00:00	1982-10-04	5001	0	\N	0	0	\N	\N	0	49113	0	19926-5	3011505		
314	12	3051031	2016-06-10	2016-06-10 00:00:00	2016-06-10	5001	0	\N	0	0	\N	\N	0	1033	0	46240-8	3051031		
21047	1950	3011505	2017-02-16	2017-02-16 00:00:00	2017-02-16	5001	0	\N	0	0	\N	\N	0	129696	0	19926-5	3011505		
50111	4563	3006322	1997-09-15	1997-09-15 00:00:00	1997-09-15	5001	0	\N	0	0	\N	\N	0	304066	0	8331-1	3006322		
6899	662	3006322	1979-03-05	1979-03-05 00:00:00	1979-03-05	5001	0	\N	0	0	\N	\N	0	43720	0	8331-1	3006322		
136991	4223	4024958	1967-07-04	1967-07-04 00:00:00	1967-07-04	5001	0	\N	0	0	\N	\N	0	280356	0	117015009	4024958		
25149	2309	46235214	1974-08-27	1974-08-27 00:00:00	1974-08-27	5001	0	\N	0	0	\N	\N	0	153619	0	76690-7	46235214		
103355	3177	4052083	1980-02-21	1980-02-21 00:00:00	1980-02-21	5001	0	\N	0	0	\N	\N	0	211311	0	23426006	4052083		
22220	2041	3051031	1965-10-22	1965-10-22 00:00:00	1965-10-22	5001	0	\N	0	0	\N	\N	0	135864	0	46240-8	3051031		
29789	2745	3006322	2004-11-02	2004-11-02 00:00:00	2004-11-02	5001	0	\N	0	0	\N	\N	0	181588	0	8331-1	3006322		
77498	2380	4024958	1951-11-19	1951-11-19 00:00:00	1951-11-19	5001	0	\N	0	0	\N	\N	0	158174	0	117015009	4024958		
3673	350	3009542	1995-09-11	1995-09-11 00:00:00	1995-09-11	5001	0	\N	0	0	\N	\N	0	23293	0	20570-8	3009542		
120960	3734	4024958	1957-10-31	1957-10-31 00:00:00	1957-10-31	5001	0	\N	0	0	\N	\N	0	248096	0	117015009	4024958		
10962	347	4052083	1975-08-21	1975-08-21 00:00:00	1975-08-21	5001	0	\N	0	0	\N	\N	0	23064	0	23426006	4052083		
4588	442	3012494	1980-09-11	1980-09-11 00:00:00	1980-09-11	5001	0	\N	0	0	\N	\N	0	29313	0	6206-7	3012494		
44270	4081	3006322	2012-10-05	2012-10-05 00:00:00	2012-10-05	5001	0	\N	0	0	\N	\N	0	271265	0	8331-1	3006322		
49183	4497	40758406	2008-03-11	2008-03-11 00:00:00	2008-03-11	5001	0	\N	0	0	\N	\N	0	299400	0	55277-8	40758406		
57031	5232	3006322	1978-08-15	1978-08-15 00:00:00	1978-08-15	5001	0	\N	0	0	\N	\N	0	348082	0	8331-1	3006322		
39141	3621	3011505	1973-07-28	1973-07-28 00:00:00	1973-07-28	5001	0	\N	0	0	\N	\N	0	240652	0	19926-5	3011505		
127853	3935	4052083	1987-05-16	1987-05-16 00:00:00	1987-05-16	5001	0	\N	0	0	\N	\N	0	261553	0	23426006	4052083		
23822	2189	3020655	2010-02-17	2010-02-17 00:00:00	2010-02-17	5001	0	\N	0	0	\N	\N	0	145893	0	6844-5	3020655		
42684	3946	3006322	1963-10-07	1963-10-07 00:00:00	1963-10-07	5001	0	\N	0	0	\N	\N	0	262339	0	8331-1	3006322		
43446	4014	3006322	1975-02-18	1975-02-18 00:00:00	1975-02-18	5001	0	\N	0	0	\N	\N	0	266693	0	8331-1	3006322		
54988	5034	3006322	1929-06-05	1929-06-05 00:00:00	1929-06-05	5001	0	\N	0	0	\N	\N	0	334434	0	8331-1	3006322		
51303	4694	3023430	1998-02-15	1998-02-15 00:00:00	1998-02-15	5001	0	\N	0	0	\N	\N	0	312735	0	6833-8	3023430		
124049	3827	4052083	1961-07-31	1961-07-31 00:00:00	1961-07-31	5001	0	\N	0	0	\N	\N	0	254156	0	23426006	4052083		
316	12	46235214	2016-06-10	2016-06-10 00:00:00	2016-06-10	5001	0	\N	0	0	\N	\N	0	1033	0	76690-7	46235214		
21048	1950	3011505	2004-12-02	2004-12-02 00:00:00	2004-12-02	5001	0	\N	0	0	\N	\N	0	129659	0	19926-5	3011505		
50112	4563	3006322	2005-02-17	2005-02-17 00:00:00	2005-02-17	5001	0	\N	0	0	\N	\N	0	304128	0	8331-1	3006322		
6900	662	3006322	1997-03-26	1997-03-26 00:00:00	1997-03-26	5001	0	\N	0	0	\N	\N	0	43685	0	8331-1	3006322		
136997	4223	4052083	1976-11-19	1976-11-19 00:00:00	1976-11-19	5001	0	\N	0	0	\N	\N	0	280359	0	23426006	4052083		
25150	2309	40758406	1974-08-27	1974-08-27 00:00:00	1974-08-27	5001	0	\N	0	0	\N	\N	0	153619	0	55277-8	40758406		
103363	3177	4024958	1949-04-21	1949-04-21 00:00:00	1949-04-21	5001	0	\N	0	0	\N	\N	0	211354	0	117015009	4024958		
22222	2041	46235214	1965-03-26	1965-03-26 00:00:00	1965-03-26	5001	0	\N	0	0	\N	\N	0	135810	0	76690-7	46235214		
29790	2745	3006322	1988-11-04	1988-11-04 00:00:00	1988-11-04	5001	0	\N	0	0	\N	\N	0	181564	0	8331-1	3006322		
77504	2380	4052083	1994-03-18	1994-03-18 00:00:00	1994-03-18	5001	0	\N	0	0	\N	\N	0	158228	0	23426006	4052083		
3674	350	3013721	1995-09-11	1995-09-11 00:00:00	1995-09-11	5001	0	\N	0	0	\N	\N	0	23293	0	1920-8	3013721		
120964	3734	4024958	1981-04-30	1981-04-30 00:00:00	1981-04-30	5001	0	\N	0	0	\N	\N	0	248097	0	117015009	4024958		
10963	347	4133840	2008-11-16	2008-11-16 00:00:00	2008-11-16	5001	0	\N	0	0	\N	\N	0	23088	0	127783003	4133840		
4589	442	3014599	1980-09-11	1980-09-11 00:00:00	1980-09-11	5001	0	\N	0	0	\N	\N	0	29313	0	6106-9	3014599		
44271	4081	3006322	1959-07-04	1959-07-04 00:00:00	1959-07-04	5001	0	\N	0	0	\N	\N	0	271233	0	8331-1	3006322		
49184	4497	3051031	2008-03-11	2008-03-11 00:00:00	2008-03-11	5001	0	\N	0	0	\N	\N	0	299400	0	46240-8	3051031		
57032	5232	3006322	1978-02-04	1978-02-04 00:00:00	1978-02-04	5001	0	\N	0	0	\N	\N	0	348096	0	8331-1	3006322		
39142	3621	3011505	1974-08-03	1974-08-03 00:00:00	1974-08-03	5001	0	\N	0	0	\N	\N	0	240577	0	19926-5	3011505		
127856	3935	4024958	1987-10-23	1987-10-23 00:00:00	1987-10-23	5001	0	\N	0	0	\N	\N	0	261567	0	117015009	4024958		
23823	2189	3006734	2010-02-17	2010-02-17 00:00:00	2010-02-17	5001	0	\N	0	0	\N	\N	0	145893	0	6189-5	3006734		
42685	3946	3006322	1988-11-13	1988-11-13 00:00:00	1988-11-13	5001	0	\N	0	0	\N	\N	0	262308	0	8331-1	3006322		
43447	4014	3014599	1997-12-09	1997-12-09 00:00:00	1997-12-09	5001	0	\N	0	0	\N	\N	0	266770	0	6106-9	3014599		
54989	5034	3006322	1969-04-24	1969-04-24 00:00:00	1969-04-24	5001	0	\N	0	0	\N	\N	0	334529	0	8331-1	3006322		
51304	4694	3036780	1998-02-15	1998-02-15 00:00:00	1998-02-15	5001	0	\N	0	0	\N	\N	0	312735	0	6095-4	3036780		
124054	3827	4052083	1967-08-03	1967-08-03 00:00:00	1967-08-03	5001	0	\N	0	0	\N	\N	0	254174	0	23426006	4052083		
317	12	40758406	2016-06-10	2016-06-10 00:00:00	2016-06-10	5001	0	\N	0	0	\N	\N	0	1033	0	55277-8	40758406		
21049	1950	3011505	2009-12-31	2009-12-31 00:00:00	2009-12-31	5001	0	\N	0	0	\N	\N	0	129622	0	19926-5	3011505		
50113	4563	3006322	2007-10-14	2007-10-14 00:00:00	2007-10-14	5001	0	\N	0	0	\N	\N	0	304108	0	8331-1	3006322		
6901	662	3006322	1999-12-22	1999-12-22 00:00:00	1999-12-22	5001	0	\N	0	0	\N	\N	0	43700	0	8331-1	3006322		
136998	4223	4052083	1966-07-08	1966-07-08 00:00:00	1966-07-08	5001	0	\N	0	0	\N	\N	0	280391	0	23426006	4052083		
25152	2309	3051031	1974-08-27	1974-08-27 00:00:00	1974-08-27	5001	0	\N	0	0	\N	\N	0	153619	0	46240-8	3051031		
103370	3178	4052083	1972-04-22	1972-04-22 00:00:00	1972-04-22	5001	0	\N	0	0	\N	\N	0	211370	0	23426006	4052083		
22223	2041	40758406	1965-03-26	1965-03-26 00:00:00	1965-03-26	5001	0	\N	0	0	\N	\N	0	135810	0	55277-8	40758406		
29808	2747	3006322	2005-05-23	2005-05-23 00:00:00	2005-05-23	5001	0	\N	0	0	\N	\N	0	181659	0	8331-1	3006322		
88786	2750	4024958	1927-07-30	1927-07-30 00:00:00	1927-07-30	5001	0	\N	0	0	\N	\N	0	181877	0	117015009	4024958		
3675	350	3016723	1995-09-11	1995-09-11 00:00:00	1995-09-11	5001	0	\N	0	0	\N	\N	0	23293	0	2160-0	3016723		
120981	3734	4024958	1989-04-04	1989-04-04 00:00:00	1989-04-04	5001	0	\N	0	0	\N	\N	0	248153	0	117015009	4024958		
10966	347	4133840	2016-12-04	2016-12-04 00:00:00	2016-12-04	5001	0	\N	0	0	\N	\N	0	23112	0	127783003	4133840		
4590	442	3019406	1980-09-11	1980-09-11 00:00:00	1980-09-11	5001	0	\N	0	0	\N	\N	0	29313	0	6158-0	3019406		
44272	4081	3006322	1969-07-09	1969-07-09 00:00:00	1969-07-09	5001	0	\N	0	0	\N	\N	0	271284	0	8331-1	3006322		
49187	4497	3051031	2008-04-10	2008-04-10 00:00:00	2008-04-10	5001	0	\N	0	0	\N	\N	0	299384	0	46240-8	3051031		
126640	3896	4052083	1990-12-29	1990-12-29 00:00:00	1990-12-29	5001	0	\N	0	0	\N	\N	0	259140	0	23426006	4052083		
39143	3621	3006322	1945-09-05	1945-09-05 00:00:00	1945-09-05	5001	0	\N	0	0	\N	\N	0	240608	0	8331-1	3006322		
127858	3935	4024958	1957-01-04	1957-01-04 00:00:00	1957-01-04	5001	0	\N	0	0	\N	\N	0	261558	0	117015009	4024958		
23824	2189	40769194	2010-02-03	2010-02-03 00:00:00	2010-02-03	5001	0	\N	0	0	\N	\N	0	145956	0	66534-9	40769194		
42686	3946	3006322	1989-07-22	1989-07-22 00:00:00	1989-07-22	5001	0	\N	0	0	\N	\N	0	262315	0	8331-1	3006322		
43448	4014	3019406	1997-12-09	1997-12-09 00:00:00	1997-12-09	5001	0	\N	0	0	\N	\N	0	266770	0	6158-0	3019406		
54990	5034	3006322	1951-01-19	1951-01-19 00:00:00	1951-01-19	5001	0	\N	0	0	\N	\N	0	334438	0	8331-1	3006322		
51305	4694	3014599	1998-02-15	1998-02-15 00:00:00	1998-02-15	5001	0	\N	0	0	\N	\N	0	312735	0	6106-9	3014599		
133456	4109	4024958	1982-04-16	1982-04-16 00:00:00	1982-04-16	5001	0	\N	0	0	\N	\N	0	273056	0	117015009	4024958		
318	12	40766240	2016-06-10	2016-06-10 00:00:00	2016-06-10	5001	0	\N	0	0	\N	\N	0	1033	0	63513-6	40766240		
21050	1950	3011505	2000-11-09	2000-11-09 00:00:00	2000-11-09	5001	0	\N	0	0	\N	\N	0	129693	0	19926-5	3011505		
50115	4565	3006322	1955-03-29	1955-03-29 00:00:00	1955-03-29	5001	0	\N	0	0	\N	\N	0	304256	0	8331-1	3006322		
6904	664	3001247	2014-01-28	2014-01-28 00:00:00	2014-01-28	5001	0	\N	0	0	\N	\N	0	43831	0	6085-5	3001247		
43856	4052	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	269336	0	6075-6	3005136		
25153	2309	46235214	1974-05-29	1974-05-29 00:00:00	1974-05-29	5001	0	\N	0	0	\N	\N	0	153659	0	76690-7	46235214		
103376	3178	4024958	1977-02-18	1977-02-18 00:00:00	1977-02-18	5001	0	\N	0	0	\N	\N	0	211419	0	117015009	4024958		
22225	2041	3051031	1965-03-26	1965-03-26 00:00:00	1965-03-26	5001	0	\N	0	0	\N	\N	0	135810	0	46240-8	3051031		
29809	2747	3006322	2008-05-01	2008-05-01 00:00:00	2008-05-01	5001	0	\N	0	0	\N	\N	0	181707	0	8331-1	3006322		
88832	2752	4024958	1955-11-23	1955-11-23 00:00:00	1955-11-23	5001	0	\N	0	0	\N	\N	0	182109	0	117015009	4024958		
3676	350	3024561	1995-09-11	1995-09-11 00:00:00	1995-09-11	5001	0	\N	0	0	\N	\N	0	23293	0	1751-7	3024561		
120983	3734	4052083	1957-03-07	1957-03-07 00:00:00	1957-03-07	5001	0	\N	0	0	\N	\N	0	248095	0	23426006	4052083		
10974	347	4133840	2010-11-21	2010-11-21 00:00:00	2010-11-21	5001	0	\N	0	0	\N	\N	0	23111	0	127783003	4133840		
4591	442	3020655	1980-09-11	1980-09-11 00:00:00	1980-09-11	5001	0	\N	0	0	\N	\N	0	29313	0	6844-5	3020655		
44275	4084	3006322	1966-11-25	1966-11-25 00:00:00	1966-11-25	5001	0	\N	0	0	\N	\N	0	271374	0	8331-1	3006322		
49188	4497	40758406	2008-04-10	2008-04-10 00:00:00	2008-04-10	5001	0	\N	0	0	\N	\N	0	299384	0	55277-8	40758406		
126671	3899	4024958	2018-04-26	2018-04-26 00:00:00	2018-04-26	5001	0	\N	0	0	\N	\N	0	259257	0	117015009	4024958		
39144	3621	3011505	1978-08-26	1978-08-26 00:00:00	1978-08-26	5001	0	\N	0	0	\N	\N	0	240643	0	19926-5	3011505		
127869	3935	4052083	1958-01-15	1958-01-15 00:00:00	1958-01-15	5001	0	\N	0	0	\N	\N	0	261559	0	23426006	4052083		
23825	2189	40769184	2010-02-03	2010-02-03 00:00:00	2010-02-03	5001	0	\N	0	0	\N	\N	0	145956	0	66524-0	40769184		
42687	3946	3006322	1980-06-19	1980-06-19 00:00:00	1980-06-19	5001	0	\N	0	0	\N	\N	0	262306	0	8331-1	3006322		
43449	4014	3005136	1997-12-09	1997-12-09 00:00:00	1997-12-09	5001	0	\N	0	0	\N	\N	0	266770	0	6075-6	3005136		
54992	5034	3006322	1973-06-24	1973-06-24 00:00:00	1973-06-24	5001	0	\N	0	0	\N	\N	0	334486	0	8331-1	3006322		
51306	4694	3021226	1998-02-15	1998-02-15 00:00:00	1998-02-15	5001	0	\N	0	0	\N	\N	0	312735	0	6246-3	3021226		
133468	4109	4052083	1988-09-17	1988-09-17 00:00:00	1988-09-17	5001	0	\N	0	0	\N	\N	0	273104	0	23426006	4052083		
320	12	3006322	1972-05-13	1972-05-13 00:00:00	1972-05-13	5001	0	\N	0	0	\N	\N	0	1028	0	8331-1	3006322		
21051	1950	3011505	2001-11-15	2001-11-15 00:00:00	2001-11-15	5001	0	\N	0	0	\N	\N	0	129619	0	19926-5	3011505		
50116	4565	3006322	1963-03-30	1963-03-30 00:00:00	1963-03-30	5001	0	\N	0	0	\N	\N	0	304162	0	8331-1	3006322		
6905	664	3020655	2014-01-28	2014-01-28 00:00:00	2014-01-28	5001	0	\N	0	0	\N	\N	0	43831	0	6844-5	3020655		
43857	4052	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	269336	0	6085-5	3001247		
25154	2309	40766240	1974-05-29	1974-05-29 00:00:00	1974-05-29	5001	0	\N	0	0	\N	\N	0	153659	0	63513-6	40766240		
103378	3178	4052083	2018-09-04	2018-09-04 00:00:00	2018-09-04	5001	0	\N	0	0	\N	\N	0	211377	0	23426006	4052083		
22226	2041	40766240	1965-03-26	1965-03-26 00:00:00	1965-03-26	5001	0	\N	0	0	\N	\N	0	135810	0	63513-6	40766240		
29810	2747	3006322	2012-08-20	2012-08-20 00:00:00	2012-08-20	5001	0	\N	0	0	\N	\N	0	181677	0	8331-1	3006322		
88834	2752	4052083	1956-07-14	1956-07-14 00:00:00	1956-07-14	5001	0	\N	0	0	\N	\N	0	182059	0	23426006	4052083		
3677	350	3028833	1995-09-11	1995-09-11 00:00:00	1995-09-11	5001	0	\N	0	0	\N	\N	0	23293	0	42719-5	3028833		
120985	3734	4052083	1952-11-04	1952-11-04 00:00:00	1952-11-04	5001	0	\N	0	0	\N	\N	0	248094	0	23426006	4052083		
10978	348	4024958	1978-05-16	1978-05-16 00:00:00	1978-05-16	5001	0	\N	0	0	\N	\N	0	23143	0	117015009	4024958		
4592	442	3001247	1980-09-11	1980-09-11 00:00:00	1980-09-11	5001	0	\N	0	0	\N	\N	0	29313	0	6085-5	3001247		
44276	4084	3006322	1972-02-10	1972-02-10 00:00:00	1972-02-10	5001	0	\N	0	0	\N	\N	0	271398	0	8331-1	3006322		
49189	4497	46235214	2008-04-10	2008-04-10 00:00:00	2008-04-10	5001	0	\N	0	0	\N	\N	0	299384	0	76690-7	46235214		
126672	3899	4052083	1991-10-29	1991-10-29 00:00:00	1991-10-29	5001	0	\N	0	0	\N	\N	0	259278	0	23426006	4052083		
39146	3621	3011505	1984-09-29	1984-09-29 00:00:00	1984-09-29	5001	0	\N	0	0	\N	\N	0	240654	0	19926-5	3011505		
127887	3936	4024958	1959-06-04	1959-06-04 00:00:00	1959-06-04	5001	0	\N	0	0	\N	\N	0	261638	0	117015009	4024958		
23826	2189	40769189	2010-02-03	2010-02-03 00:00:00	2010-02-03	5001	0	\N	0	0	\N	\N	0	145956	0	66529-9	40769189		
42688	3946	3006322	1970-10-27	1970-10-27 00:00:00	1970-10-27	5001	0	\N	0	0	\N	\N	0	262341	0	8331-1	3006322		
43450	4014	3021226	1997-12-09	1997-12-09 00:00:00	1997-12-09	5001	0	\N	0	0	\N	\N	0	266770	0	6246-3	3021226		
54993	5035	3006322	2011-10-21	2011-10-21 00:00:00	2011-10-21	5001	0	\N	0	0	\N	\N	0	334549	0	8331-1	3006322		
51307	4694	3015076	1998-02-15	1998-02-15 00:00:00	1998-02-15	5001	0	\N	0	0	\N	\N	0	312735	0	6248-9	3015076		
6011	563	3001488	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	37252	0	7258-7	3001488		
321	12	46235214	2016-02-11	2016-02-11 00:00:00	2016-02-11	5001	0	\N	0	0	\N	\N	0	1058	0	76690-7	46235214		
21052	1950	3011505	2006-12-14	2006-12-14 00:00:00	2006-12-14	5001	0	\N	0	0	\N	\N	0	129660	0	19926-5	3011505		
50117	4565	3049273	2016-11-04	2016-11-04 00:00:00	2016-11-04	5001	0	\N	0	0	\N	\N	0	304213	0	38265-5	3049273		
91534	2825	4052083	1991-10-16	1991-10-16 00:00:00	1991-10-16	5001	0	\N	0	0	\N	\N	0	187285	0	23426006	4052083		
43858	4052	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	269336	0	6844-5	3020655		
25156	2309	40758406	1974-05-29	1974-05-29 00:00:00	1974-05-29	5001	0	\N	0	0	\N	\N	0	153659	0	55277-8	40758406		
103381	3178	4024958	1980-06-12	1980-06-12 00:00:00	1980-06-12	5001	0	\N	0	0	\N	\N	0	211425	0	117015009	4024958		
22227	2041	3006322	1974-05-31	1974-05-31 00:00:00	1974-05-31	5001	0	\N	0	0	\N	\N	0	135789	0	8331-1	3006322		
29811	2747	3006322	2007-01-24	2007-01-24 00:00:00	2007-01-24	5001	0	\N	0	0	\N	\N	0	181706	0	8331-1	3006322		
88841	2752	4052083	2010-04-15	2010-04-15 00:00:00	2010-04-15	5001	0	\N	0	0	\N	\N	0	182064	0	23426006	4052083		
3678	350	3027970	1995-09-11	1995-09-11 00:00:00	1995-09-11	5001	0	\N	0	0	\N	\N	0	23293	0	10834-0	3027970		
120991	3734	4024958	1976-03-10	1976-03-10 00:00:00	1976-03-10	5001	0	\N	0	0	\N	\N	0	248176	0	117015009	4024958		
10979	348	4052083	2003-11-29	2003-11-29 00:00:00	2003-11-29	5001	0	\N	0	0	\N	\N	0	23146	0	23426006	4052083		
4593	442	3006322	1955-06-29	1955-06-29 00:00:00	1955-06-29	5001	0	\N	0	0	\N	\N	0	29310	0	8331-1	3006322		
44277	4085	3006322	2011-10-24	2011-10-24 00:00:00	2011-10-24	5001	0	\N	0	0	\N	\N	0	271455	0	8331-1	3006322		
49190	4497	40766240	2008-04-10	2008-04-10 00:00:00	2008-04-10	5001	0	\N	0	0	\N	\N	0	299384	0	63513-6	40766240		
126678	3899	4024958	1993-11-01	1993-11-01 00:00:00	1993-11-01	5001	0	\N	0	0	\N	\N	0	259288	0	117015009	4024958		
39147	3621	3049273	1989-01-16	1989-01-16 00:00:00	1989-01-16	5001	0	\N	0	0	\N	\N	0	240634	0	38265-5	3049273		
11970	1138	3019406	1993-02-04	1993-02-04 00:00:00	1993-02-04	5001	0	\N	0	0	\N	\N	0	75062	0	6158-0	3019406		
23827	2189	40769179	2010-02-03	2010-02-03 00:00:00	2010-02-03	5001	0	\N	0	0	\N	\N	0	145956	0	66519-0	40769179		
42689	3946	3006322	2001-08-02	2001-08-02 00:00:00	2001-08-02	5001	0	\N	0	0	\N	\N	0	262357	0	8331-1	3006322		
43451	4014	3006322	1976-05-29	1976-05-29 00:00:00	1976-05-29	5001	0	\N	0	0	\N	\N	0	266694	0	8331-1	3006322		
54995	5035	3006322	1938-07-23	1938-07-23 00:00:00	1938-07-23	5001	0	\N	0	0	\N	\N	0	334588	0	8331-1	3006322		
51308	4694	3005136	1998-02-15	1998-02-15 00:00:00	1998-02-15	5001	0	\N	0	0	\N	\N	0	312735	0	6075-6	3005136		
6012	563	3006734	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	37252	0	6189-5	3006734		
322	12	40766240	2016-02-11	2016-02-11 00:00:00	2016-02-11	5001	0	\N	0	0	\N	\N	0	1058	0	63513-6	40766240		
21053	1950	3006322	1952-10-10	1952-10-10 00:00:00	1952-10-10	5001	0	\N	0	0	\N	\N	0	129645	0	8331-1	3006322		
50118	4565	3006322	1948-03-25	1948-03-25 00:00:00	1948-03-25	5001	0	\N	0	0	\N	\N	0	304215	0	8331-1	3006322		
91538	2825	4024958	1960-07-02	1960-07-02 00:00:00	1960-07-02	5001	0	\N	0	0	\N	\N	0	187269	0	117015009	4024958		
43859	4052	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	269336	0	7258-7	3001488		
25157	2309	3051031	1974-05-29	1974-05-29 00:00:00	1974-05-29	5001	0	\N	0	0	\N	\N	0	153659	0	46240-8	3051031		
103383	3178	4024958	1996-05-28	1996-05-28 00:00:00	1996-05-28	5001	0	\N	0	0	\N	\N	0	211408	0	117015009	4024958		
22228	2041	46235214	1965-07-24	1965-07-24 00:00:00	1965-07-24	5001	0	\N	0	0	\N	\N	0	135863	0	76690-7	46235214		
29812	2747	3006322	1995-09-30	1995-09-30 00:00:00	1995-09-30	5001	0	\N	0	0	\N	\N	0	181694	0	8331-1	3006322		
88842	2752	4024958	2008-06-09	2008-06-09 00:00:00	2008-06-09	5001	0	\N	0	0	\N	\N	0	182063	0	117015009	4024958		
3679	350	3006322	2009-11-07	2009-11-07 00:00:00	2009-11-07	5001	0	\N	0	0	\N	\N	0	23303	0	8331-1	3006322		
91310	2821	4024958	1927-03-14	1927-03-14 00:00:00	1927-03-14	5001	0	\N	0	0	\N	\N	0	186947	0	117015009	4024958		
4595	442	3051031	1949-02-18	1949-02-18 00:00:00	1949-02-18	5001	0	\N	0	0	\N	\N	0	29334	0	46240-8	3051031		
44278	4085	3006322	2002-11-30	2002-11-30 00:00:00	2002-11-30	5001	0	\N	0	0	\N	\N	0	271522	0	8331-1	3006322		
49191	4497	46235214	2014-02-03	2014-02-03 00:00:00	2014-02-03	5001	0	\N	0	0	\N	\N	0	299421	0	76690-7	46235214		
126682	3899	4052083	2003-12-18	2003-12-18 00:00:00	2003-12-18	5001	0	\N	0	0	\N	\N	0	259267	0	23426006	4052083		
39148	3621	3011505	1979-09-01	1979-09-01 00:00:00	1979-09-01	5001	0	\N	0	0	\N	\N	0	240602	0	19926-5	3011505		
11971	1138	3001488	1993-02-04	1993-02-04 00:00:00	1993-02-04	5001	0	\N	0	0	\N	\N	0	75062	0	7258-7	3001488		
23828	2189	3006322	1999-07-07	1999-07-07 00:00:00	1999-07-07	5001	0	\N	0	0	\N	\N	0	145892	0	8331-1	3006322		
42690	3946	3006322	1965-02-14	1965-02-14 00:00:00	1965-02-14	5001	0	\N	0	0	\N	\N	0	262305	0	8331-1	3006322		
43457	4017	3006322	1922-08-20	1922-08-20 00:00:00	1922-08-20	5001	0	\N	0	0	\N	\N	0	266962	0	8331-1	3006322		
54996	5035	3006322	1963-11-28	1963-11-28 00:00:00	1963-11-28	5001	0	\N	0	0	\N	\N	0	334624	0	8331-1	3006322		
51309	4694	3006451	1998-02-15	1998-02-15 00:00:00	1998-02-15	5001	0	\N	0	0	\N	\N	0	312735	0	6273-7	3006451		
6013	563	3023430	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	37252	0	6833-8	3023430		
324	12	3051031	2016-02-11	2016-02-11 00:00:00	2016-02-11	5001	0	\N	0	0	\N	\N	0	1058	0	46240-8	3051031		
21054	1950	3011505	2018-02-22	2018-02-22 00:00:00	2018-02-22	5001	0	\N	0	0	\N	\N	0	129666	0	19926-5	3011505		
50119	4565	3006322	1993-11-08	1993-11-08 00:00:00	1993-11-08	5001	0	\N	0	0	\N	\N	0	304224	0	8331-1	3006322		
33856	3074	3006322	1952-08-01	1952-08-01 00:00:00	1952-08-01	5001	0	\N	0	0	\N	\N	0	204584	0	8331-1	3006322		
43860	4052	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	269336	0	6082-2	3000876		
25160	2309	40766240	1974-11-25	1974-11-25 00:00:00	1974-11-25	5001	0	\N	0	0	\N	\N	0	153620	0	63513-6	40766240		
56317	5168	3009542	2015-02-15	2015-02-15 00:00:00	2015-02-15	5001	0	\N	0	0	\N	\N	0	343612	0	20570-8	3009542		
22229	2041	40758406	1965-07-24	1965-07-24 00:00:00	1965-07-24	5001	0	\N	0	0	\N	\N	0	135863	0	55277-8	40758406		
29813	2747	3006322	1980-10-28	1980-10-28 00:00:00	1980-10-28	5001	0	\N	0	0	\N	\N	0	181715	0	8331-1	3006322		
3680	350	3006322	1962-10-05	1962-10-05 00:00:00	1962-10-05	5001	0	\N	0	0	\N	\N	0	23297	0	8331-1	3006322		
91315	2821	4052083	1999-03-26	1999-03-26 00:00:00	1999-03-26	5001	0	\N	0	0	\N	\N	0	186932	0	23426006	4052083		
4596	442	40758406	1949-02-18	1949-02-18 00:00:00	1949-02-18	5001	0	\N	0	0	\N	\N	0	29334	0	55277-8	40758406		
44279	4085	3006322	1986-07-24	1986-07-24 00:00:00	1986-07-24	5001	0	\N	0	0	\N	\N	0	271496	0	8331-1	3006322		
49192	4497	40766240	2014-02-03	2014-02-03 00:00:00	2014-02-03	5001	0	\N	0	0	\N	\N	0	299421	0	63513-6	40766240		
126683	3899	4024958	1988-01-17	1988-01-17 00:00:00	1988-01-17	5001	0	\N	0	0	\N	\N	0	259266	0	117015009	4024958		
39149	3621	3006322	1932-03-07	1932-03-07 00:00:00	1932-03-07	5001	0	\N	0	0	\N	\N	0	240618	0	8331-1	3006322		
11972	1138	3023430	1993-02-04	1993-02-04 00:00:00	1993-02-04	5001	0	\N	0	0	\N	\N	0	75062	0	6833-8	3023430		
23829	2189	3006322	2009-10-13	2009-10-13 00:00:00	2009-10-13	5001	0	\N	0	0	\N	\N	0	145955	0	8331-1	3006322		
42694	3949	3006322	2011-08-12	2011-08-12 00:00:00	2011-08-12	5001	0	\N	0	0	\N	\N	0	262462	0	8331-1	3006322		
43458	4017	3006322	1927-07-10	1927-07-10 00:00:00	1927-07-10	5001	0	\N	0	0	\N	\N	0	266943	0	8331-1	3006322		
68371	2088	4133840	1972-06-13	1972-06-13 00:00:00	1972-06-13	5001	0	\N	0	0	\N	\N	0	139199	0	127783003	4133840		
51310	4694	3027231	1998-02-15	1998-02-15 00:00:00	1998-02-15	5001	0	\N	0	0	\N	\N	0	312735	0	6276-0	3027231		
6014	563	3014599	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	37252	0	6106-9	3014599		
326	12	40758406	2016-02-11	2016-02-11 00:00:00	2016-02-11	5001	0	\N	0	0	\N	\N	0	1058	0	55277-8	40758406		
21055	1950	3011505	1987-01-15	1987-01-15 00:00:00	1987-01-15	5001	0	\N	0	0	\N	\N	0	129680	0	19926-5	3011505		
50120	4565	3006322	1977-12-21	1977-12-21 00:00:00	1977-12-21	5001	0	\N	0	0	\N	\N	0	304237	0	8331-1	3006322		
33857	3074	3006322	1981-06-25	1981-06-25 00:00:00	1981-06-25	5001	0	\N	0	0	\N	\N	0	204599	0	8331-1	3006322		
43861	4052	3036780	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	269336	0	6095-4	3036780		
25161	2309	46235214	1974-11-25	1974-11-25 00:00:00	1974-11-25	5001	0	\N	0	0	\N	\N	0	153620	0	76690-7	46235214		
56318	5168	3006322	1999-02-16	1999-02-16 00:00:00	1999-02-16	5001	0	\N	0	0	\N	\N	0	343637	0	8331-1	3006322		
22232	2041	3051031	1965-07-24	1965-07-24 00:00:00	1965-07-24	5001	0	\N	0	0	\N	\N	0	135863	0	46240-8	3051031		
29814	2747	3006322	1994-09-23	1994-09-23 00:00:00	1994-09-23	5001	0	\N	0	0	\N	\N	0	181717	0	8331-1	3006322		
3681	351	3006322	2000-05-02	2000-05-02 00:00:00	2000-05-02	5001	0	\N	0	0	\N	\N	0	23431	0	8331-1	3006322		
91319	2821	4052083	1960-12-14	1960-12-14 00:00:00	1960-12-14	5001	0	\N	0	0	\N	\N	0	186860	0	23426006	4052083		
4597	442	46235214	1949-02-18	1949-02-18 00:00:00	1949-02-18	5001	0	\N	0	0	\N	\N	0	29334	0	76690-7	46235214		
44280	4085	3006322	1999-08-07	1999-08-07 00:00:00	1999-08-07	5001	0	\N	0	0	\N	\N	0	271500	0	8331-1	3006322		
49193	4497	3051031	2014-02-03	2014-02-03 00:00:00	2014-02-03	5001	0	\N	0	0	\N	\N	0	299421	0	46240-8	3051031		
126696	3900	4133840	2004-09-21	2004-09-21 00:00:00	2004-09-21	5001	0	\N	0	0	\N	\N	0	259319	0	127783003	4133840		
39150	3621	3011505	1982-09-18	1982-09-18 00:00:00	1982-09-18	5001	0	\N	0	0	\N	\N	0	240645	0	19926-5	3011505		
11973	1138	3021226	1993-02-04	1993-02-04 00:00:00	1993-02-04	5001	0	\N	0	0	\N	\N	0	75062	0	6246-3	3021226		
23830	2189	3021226	2010-02-17	2010-02-17 00:00:00	2010-02-17	5001	0	\N	0	0	\N	\N	0	145893	0	6246-3	3021226		
42695	3949	3006322	1992-12-22	1992-12-22 00:00:00	1992-12-22	5001	0	\N	0	0	\N	\N	0	262509	0	8331-1	3006322		
43556	4026	3012494	1977-02-07	1977-02-07 00:00:00	1977-02-07	5001	0	\N	0	0	\N	\N	0	267662	0	6206-7	3012494		
68374	2088	4133840	2011-03-01	2011-03-01 00:00:00	2011-03-01	5001	0	\N	0	0	\N	\N	0	139243	0	127783003	4133840		
51311	4694	3001247	1998-02-15	1998-02-15 00:00:00	1998-02-15	5001	0	\N	0	0	\N	\N	0	312735	0	6085-5	3001247		
6015	563	3006451	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	37252	0	6273-7	3006451		
327	12	40758406	2015-11-13	2015-11-13 00:00:00	2015-11-13	5001	0	\N	0	0	\N	\N	0	1057	0	55277-8	40758406		
21056	1950	3011505	1990-09-13	1990-09-13 00:00:00	1990-09-13	5001	0	\N	0	0	\N	\N	0	129617	0	19926-5	3011505		
6471	199	4024958	1951-05-26	1951-05-26 00:00:00	1951-05-26	5001	0	\N	0	0	\N	\N	0	13676	0	117015009	4024958		
33858	3074	3006322	2009-04-18	2009-04-18 00:00:00	2009-04-18	5001	0	\N	0	0	\N	\N	0	204540	0	8331-1	3006322		
43862	4052	3015076	1977-12-04	1977-12-04 00:00:00	1977-12-04	5001	0	\N	0	0	\N	\N	0	269373	0	6248-9	3015076		
25162	2309	40758406	1974-11-25	1974-11-25 00:00:00	1974-11-25	5001	0	\N	0	0	\N	\N	0	153620	0	55277-8	40758406		
56319	5169	40758406	1954-07-01	1954-07-01 00:00:00	1954-07-01	5001	0	\N	0	0	\N	\N	0	343680	0	55277-8	40758406		
22233	2041	40766240	1965-07-24	1965-07-24 00:00:00	1965-07-24	5001	0	\N	0	0	\N	\N	0	135863	0	63513-6	40766240		
29818	2749	3006322	1961-12-16	1961-12-16 00:00:00	1961-12-16	5001	0	\N	0	0	\N	\N	0	181783	0	8331-1	3006322		
3682	351	3006322	2014-12-15	2014-12-15 00:00:00	2014-12-15	5001	0	\N	0	0	\N	\N	0	23343	0	8331-1	3006322		
91326	2821	4052083	2003-11-13	2003-11-13 00:00:00	2003-11-13	5001	0	\N	0	0	\N	\N	0	186933	0	23426006	4052083		
4599	442	40766240	1949-02-18	1949-02-18 00:00:00	1949-02-18	5001	0	\N	0	0	\N	\N	0	29334	0	63513-6	40766240		
44281	4085	3006322	1997-09-04	1997-09-04 00:00:00	1997-09-04	5001	0	\N	0	0	\N	\N	0	271541	0	8331-1	3006322		
49194	4497	40758406	2014-02-03	2014-02-03 00:00:00	2014-02-03	5001	0	\N	0	0	\N	\N	0	299421	0	55277-8	40758406		
126698	3900	4052083	1978-01-08	1978-01-08 00:00:00	1978-01-08	5001	0	\N	0	0	\N	\N	0	259298	0	23426006	4052083		
39151	3621	3011505	1990-11-03	1990-11-03 00:00:00	1990-11-03	5001	0	\N	0	0	\N	\N	0	240605	0	19926-5	3011505		
11974	1138	3014599	1993-02-04	1993-02-04 00:00:00	1993-02-04	5001	0	\N	0	0	\N	\N	0	75062	0	6106-9	3014599		
23831	2189	3019406	2010-02-17	2010-02-17 00:00:00	2010-02-17	5001	0	\N	0	0	\N	\N	0	145893	0	6158-0	3019406		
42696	3949	3006322	1975-05-17	1975-05-17 00:00:00	1975-05-17	5001	0	\N	0	0	\N	\N	0	262475	0	8331-1	3006322		
43557	4026	3036780	1977-02-07	1977-02-07 00:00:00	1977-02-07	5001	0	\N	0	0	\N	\N	0	267662	0	6095-4	3036780		
68378	2088	4133840	1995-05-09	1995-05-09 00:00:00	1995-05-09	5001	0	\N	0	0	\N	\N	0	139279	0	127783003	4133840		
51312	4694	3006734	1998-02-15	1998-02-15 00:00:00	1998-02-15	5001	0	\N	0	0	\N	\N	0	312735	0	6189-5	3006734		
6016	563	3015076	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	37252	0	6248-9	3015076		
328	12	46235214	2015-11-13	2015-11-13 00:00:00	2015-11-13	5001	0	\N	0	0	\N	\N	0	1057	0	76690-7	46235214		
21057	1951	3006322	1991-04-25	1991-04-25 00:00:00	1991-04-25	5001	0	\N	0	0	\N	\N	0	129776	0	8331-1	3006322		
6482	199	4024958	1993-08-14	1993-08-14 00:00:00	1993-08-14	5001	0	\N	0	0	\N	\N	0	13647	0	117015009	4024958		
33859	3074	3006322	2001-11-18	2001-11-18 00:00:00	2001-11-18	5001	0	\N	0	0	\N	\N	0	204580	0	8331-1	3006322		
43863	4052	3006451	1977-12-04	1977-12-04 00:00:00	1977-12-04	5001	0	\N	0	0	\N	\N	0	269373	0	6273-7	3006451		
25164	2309	3051031	1974-11-25	1974-11-25 00:00:00	1974-11-25	5001	0	\N	0	0	\N	\N	0	153620	0	46240-8	3051031		
56320	5169	3051031	1954-07-01	1954-07-01 00:00:00	1954-07-01	5001	0	\N	0	0	\N	\N	0	343680	0	46240-8	3051031		
22234	2041	3006322	1968-04-18	1968-04-18 00:00:00	1968-04-18	5001	0	\N	0	0	\N	\N	0	135865	0	8331-1	3006322		
29819	2749	46235214	2005-02-09	2005-02-09 00:00:00	2005-02-09	5001	0	\N	0	0	\N	\N	0	181832	0	76690-7	46235214		
3683	351	3006322	2002-04-07	2002-04-07 00:00:00	2002-04-07	5001	0	\N	0	0	\N	\N	0	23407	0	8331-1	3006322		
91327	2821	4024958	1947-06-19	1947-06-19 00:00:00	1947-06-19	5001	0	\N	0	0	\N	\N	0	186894	0	117015009	4024958		
4600	442	40766240	1949-04-19	1949-04-19 00:00:00	1949-04-19	5001	0	\N	0	0	\N	\N	0	29278	0	63513-6	40766240		
44282	4085	3006322	1969-09-08	1969-09-08 00:00:00	1969-09-08	5001	0	\N	0	0	\N	\N	0	271493	0	8331-1	3006322		
49197	4497	3006322	2003-10-12	2003-10-12 00:00:00	2003-10-12	5001	0	\N	0	0	\N	\N	0	299382	0	8331-1	3006322		
27543	2545	3006322	1988-05-16	1988-05-16 00:00:00	1988-05-16	5001	0	\N	0	0	\N	\N	0	168391	0	8331-1	3006322		
39152	3621	3011505	1971-07-17	1971-07-17 00:00:00	1971-07-17	5001	0	\N	0	0	\N	\N	0	240651	0	19926-5	3011505		
11975	1138	3005136	1993-02-04	1993-02-04 00:00:00	1993-02-04	5001	0	\N	0	0	\N	\N	0	75062	0	6075-6	3005136		
23832	2189	3001488	2010-02-17	2010-02-17 00:00:00	2010-02-17	5001	0	\N	0	0	\N	\N	0	145893	0	7258-7	3001488		
42697	3949	3006322	2017-07-11	2017-07-11 00:00:00	2017-07-11	5001	0	\N	0	0	\N	\N	0	262497	0	8331-1	3006322		
43558	4026	3021226	1977-02-07	1977-02-07 00:00:00	1977-02-07	5001	0	\N	0	0	\N	\N	0	267662	0	6246-3	3021226		
79656	2450	4024958	1974-05-07	1974-05-07 00:00:00	1974-05-07	5001	0	\N	0	0	\N	\N	0	162490	0	117015009	4024958		
51313	4694	3006322	1986-05-17	1986-05-17 00:00:00	1986-05-17	5001	0	\N	0	0	\N	\N	0	312722	0	8331-1	3006322		
6017	563	3036780	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	37252	0	6095-4	3036780		
329	12	3051031	2015-11-13	2015-11-13 00:00:00	2015-11-13	5001	0	\N	0	0	\N	\N	0	1057	0	46240-8	3051031		
21058	1951	3006322	2014-05-03	2014-05-03 00:00:00	2014-05-03	5001	0	\N	0	0	\N	\N	0	129761	0	8331-1	3006322		
6491	199	4052083	1951-01-12	1951-01-12 00:00:00	1951-01-12	5001	0	\N	0	0	\N	\N	0	13637	0	23426006	4052083		
33860	3074	3006322	1979-05-24	1979-05-24 00:00:00	1979-05-24	5001	0	\N	0	0	\N	\N	0	204539	0	8331-1	3006322		
43864	4052	3019406	1977-12-04	1977-12-04 00:00:00	1977-12-04	5001	0	\N	0	0	\N	\N	0	269373	0	6158-0	3019406		
25165	2309	40758406	1974-04-29	1974-04-29 00:00:00	1974-04-29	5001	0	\N	0	0	\N	\N	0	153648	0	55277-8	40758406		
56322	5169	46235214	1954-07-01	1954-07-01 00:00:00	1954-07-01	5001	0	\N	0	0	\N	\N	0	343680	0	76690-7	46235214		
22235	2043	3006322	2018-01-19	2018-01-19 00:00:00	2018-01-19	5001	0	\N	0	0	\N	\N	0	135937	0	8331-1	3006322		
29820	2749	40758406	2005-02-09	2005-02-09 00:00:00	2005-02-09	5001	0	\N	0	0	\N	\N	0	181832	0	55277-8	40758406		
91330	2821	4052083	1983-11-07	1983-11-07 00:00:00	1983-11-07	5001	0	\N	0	0	\N	\N	0	186952	0	23426006	4052083		
4602	442	46235214	1949-04-19	1949-04-19 00:00:00	1949-04-19	5001	0	\N	0	0	\N	\N	0	29278	0	76690-7	46235214		
44283	4086	3011505	2019-02-20	2019-02-20 00:00:00	2019-02-20	5001	0	\N	0	0	\N	\N	0	271613	0	19926-5	3011505		
49198	4497	3051031	2013-12-05	2013-12-05 00:00:00	2013-12-05	5001	0	\N	0	0	\N	\N	0	299403	0	46240-8	3051031		
27545	2545	3006322	1992-09-06	1992-09-06 00:00:00	1992-09-06	5001	0	\N	0	0	\N	\N	0	168441	0	8331-1	3006322		
39153	3621	3011505	1983-09-24	1983-09-24 00:00:00	1983-09-24	5001	0	\N	0	0	\N	\N	0	240578	0	19926-5	3011505		
11976	1138	3015076	1993-02-04	1993-02-04 00:00:00	1993-02-04	5001	0	\N	0	0	\N	\N	0	75062	0	6248-9	3015076		
23833	2189	3001247	2010-02-17	2010-02-17 00:00:00	2010-02-17	5001	0	\N	0	0	\N	\N	0	145893	0	6085-5	3001247		
42698	3949	3006322	2002-03-19	2002-03-19 00:00:00	2002-03-19	5001	0	\N	0	0	\N	\N	0	262510	0	8331-1	3006322		
43559	4026	3006451	1977-02-07	1977-02-07 00:00:00	1977-02-07	5001	0	\N	0	0	\N	\N	0	267662	0	6273-7	3006451		
160035	4922	4024958	2013-01-04	2013-01-04 00:00:00	2013-01-04	5001	0	\N	0	0	\N	\N	0	327044	0	117015009	4024958		
51314	4694	3001247	1994-08-14	1994-08-14 00:00:00	1994-08-14	5001	0	\N	0	0	\N	\N	0	312751	0	6085-5	3001247		
6018	563	3000876	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	37252	0	6082-2	3000876		
331	12	40766240	2015-11-13	2015-11-13 00:00:00	2015-11-13	5001	0	\N	0	0	\N	\N	0	1057	0	63513-6	40766240		
21059	1951	3006322	1995-05-21	1995-05-21 00:00:00	1995-05-21	5001	0	\N	0	0	\N	\N	0	129750	0	8331-1	3006322		
6498	199	4024958	1947-12-01	1947-12-01 00:00:00	1947-12-01	5001	0	\N	0	0	\N	\N	0	13636	0	117015009	4024958		
33861	3074	3006322	2002-12-09	2002-12-09 00:00:00	2002-12-09	5001	0	\N	0	0	\N	\N	0	204602	0	8331-1	3006322		
43865	4052	3014599	1977-12-04	1977-12-04 00:00:00	1977-12-04	5001	0	\N	0	0	\N	\N	0	269373	0	6106-9	3014599		
25167	2309	3051031	1974-04-29	1974-04-29 00:00:00	1974-04-29	5001	0	\N	0	0	\N	\N	0	153648	0	46240-8	3051031		
56323	5169	40766240	1954-07-01	1954-07-01 00:00:00	1954-07-01	5001	0	\N	0	0	\N	\N	0	343680	0	63513-6	40766240		
22236	2043	3006322	2005-04-15	2005-04-15 00:00:00	2005-04-15	5001	0	\N	0	0	\N	\N	0	135875	0	8331-1	3006322		
29821	2749	3051031	2005-02-09	2005-02-09 00:00:00	2005-02-09	5001	0	\N	0	0	\N	\N	0	181832	0	46240-8	3051031		
91332	2821	4024958	1921-08-28	1921-08-28 00:00:00	1921-08-28	5001	0	\N	0	0	\N	\N	0	186946	0	117015009	4024958		
4603	442	40758406	1949-04-19	1949-04-19 00:00:00	1949-04-19	5001	0	\N	0	0	\N	\N	0	29278	0	55277-8	40758406		
44284	4086	3011505	2012-12-12	2012-12-12 00:00:00	2012-12-12	5001	0	\N	0	0	\N	\N	0	271577	0	19926-5	3011505		
49199	4497	40758406	2013-12-05	2013-12-05 00:00:00	2013-12-05	5001	0	\N	0	0	\N	\N	0	299403	0	55277-8	40758406		
27547	2545	3006322	1952-08-20	1952-08-20 00:00:00	1952-08-20	5001	0	\N	0	0	\N	\N	0	168409	0	8331-1	3006322		
39154	3621	3011505	1987-10-17	1987-10-17 00:00:00	1987-10-17	5001	0	\N	0	0	\N	\N	0	240595	0	19926-5	3011505		
11977	1138	3036780	1993-02-04	1993-02-04 00:00:00	1993-02-04	5001	0	\N	0	0	\N	\N	0	75062	0	6095-4	3036780		
23834	2189	3015076	2010-02-17	2010-02-17 00:00:00	2010-02-17	5001	0	\N	0	0	\N	\N	0	145893	0	6248-9	3015076		
42699	3949	3006322	2014-10-12	2014-10-12 00:00:00	2014-10-12	5001	0	\N	0	0	\N	\N	0	262496	0	8331-1	3006322		
43560	4026	3015076	1977-02-07	1977-02-07 00:00:00	1977-02-07	5001	0	\N	0	0	\N	\N	0	267662	0	6248-9	3015076		
160066	4923	4052083	1980-11-18	1980-11-18 00:00:00	1980-11-18	5001	0	\N	0	0	\N	\N	0	327135	0	23426006	4052083		
51315	4694	3006734	1994-08-14	1994-08-14 00:00:00	1994-08-14	5001	0	\N	0	0	\N	\N	0	312751	0	6189-5	3006734		
6019	563	3001247	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	37252	0	6085-5	3001247		
333	12	3051031	2015-07-16	2015-07-16 00:00:00	2015-07-16	5001	0	\N	0	0	\N	\N	0	1004	0	46240-8	3051031		
21060	1951	3006322	2019-05-18	2019-05-18 00:00:00	2019-05-18	5001	0	\N	0	0	\N	\N	0	129754	0	8331-1	3006322		
5116	495	3006322	1998-04-09	1998-04-09 00:00:00	1998-04-09	5001	0	\N	0	0	\N	\N	0	33055	0	8331-1	3006322		
33862	3074	3006322	2002-06-02	2002-06-02 00:00:00	2002-06-02	5001	0	\N	0	0	\N	\N	0	204581	0	8331-1	3006322		
43866	4052	3027231	1977-12-04	1977-12-04 00:00:00	1977-12-04	5001	0	\N	0	0	\N	\N	0	269373	0	6276-0	3027231		
25169	2309	40766240	1974-04-29	1974-04-29 00:00:00	1974-04-29	5001	0	\N	0	0	\N	\N	0	153648	0	63513-6	40766240		
56325	5169	3006322	1998-12-06	1998-12-06 00:00:00	1998-12-06	5001	0	\N	0	0	\N	\N	0	343675	0	8331-1	3006322		
22237	2043	3006322	1970-05-28	1970-05-28 00:00:00	1970-05-28	5001	0	\N	0	0	\N	\N	0	135894	0	8331-1	3006322		
29823	2749	3006322	1972-08-14	1972-08-14 00:00:00	1972-08-14	5001	0	\N	0	0	\N	\N	0	181791	0	8331-1	3006322		
91335	2821	4024958	1933-05-24	1933-05-24 00:00:00	1933-05-24	5001	0	\N	0	0	\N	\N	0	186858	0	117015009	4024958		
4605	442	3051031	1949-04-19	1949-04-19 00:00:00	1949-04-19	5001	0	\N	0	0	\N	\N	0	29278	0	46240-8	3051031		
44285	4086	3011505	2010-12-08	2010-12-08 00:00:00	2010-12-08	5001	0	\N	0	0	\N	\N	0	271597	0	19926-5	3011505		
49202	4497	46235214	2013-12-05	2013-12-05 00:00:00	2013-12-05	5001	0	\N	0	0	\N	\N	0	299403	0	76690-7	46235214		
27548	2546	40758406	1984-08-17	1984-08-17 00:00:00	1984-08-17	5001	0	\N	0	0	\N	\N	0	168465	0	55277-8	40758406		
39155	3621	3006322	1924-12-29	1924-12-29 00:00:00	1924-12-29	5001	0	\N	0	0	\N	\N	0	240590	0	8331-1	3006322		
11978	1138	3020655	1993-02-04	1993-02-04 00:00:00	1993-02-04	5001	0	\N	0	0	\N	\N	0	75062	0	6844-5	3020655		
23835	2189	3006451	2010-02-17	2010-02-17 00:00:00	2010-02-17	5001	0	\N	0	0	\N	\N	0	145893	0	6273-7	3006451		
42700	3950	3006322	1999-07-16	1999-07-16 00:00:00	1999-07-16	5001	0	\N	0	0	\N	\N	0	262538	0	8331-1	3006322		
43561	4026	3019406	1977-02-07	1977-02-07 00:00:00	1977-02-07	5001	0	\N	0	0	\N	\N	0	267662	0	6158-0	3019406		
160067	4923	4052083	1977-04-15	1977-04-15 00:00:00	1977-04-15	5001	0	\N	0	0	\N	\N	0	327097	0	23426006	4052083		
51316	4694	3000876	1994-08-14	1994-08-14 00:00:00	1994-08-14	5001	0	\N	0	0	\N	\N	0	312751	0	6082-2	3000876		
6020	563	3012494	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	37252	0	6206-7	3012494		
335	12	40758406	2015-07-16	2015-07-16 00:00:00	2015-07-16	5001	0	\N	0	0	\N	\N	0	1004	0	55277-8	40758406		
21061	1951	3006322	2009-07-20	2009-07-20 00:00:00	2009-07-20	5001	0	\N	0	0	\N	\N	0	129760	0	8331-1	3006322		
5117	495	3006322	2009-05-25	2009-05-25 00:00:00	2009-05-25	5001	0	\N	0	0	\N	\N	0	33074	0	8331-1	3006322		
33863	3074	3006322	2009-05-30	2009-05-30 00:00:00	2009-05-30	5001	0	\N	0	0	\N	\N	0	204582	0	8331-1	3006322		
43867	4052	3001247	1977-12-04	1977-12-04 00:00:00	1977-12-04	5001	0	\N	0	0	\N	\N	0	269373	0	6085-5	3001247		
25170	2309	46235214	1974-04-29	1974-04-29 00:00:00	1974-04-29	5001	0	\N	0	0	\N	\N	0	153648	0	76690-7	46235214		
56326	5169	3006322	1997-01-28	1997-01-28 00:00:00	1997-01-28	5001	0	\N	0	0	\N	\N	0	343691	0	8331-1	3006322		
22238	2043	3006322	1978-10-21	1978-10-21 00:00:00	1978-10-21	5001	0	\N	0	0	\N	\N	0	135873	0	8331-1	3006322		
29824	2749	3006322	2006-02-19	2006-02-19 00:00:00	2006-02-19	5001	0	\N	0	0	\N	\N	0	181822	0	8331-1	3006322		
91342	2821	4024958	1993-06-25	1993-06-25 00:00:00	1993-06-25	5001	0	\N	0	0	\N	\N	0	186866	0	117015009	4024958		
4607	442	3006322	1947-09-24	1947-09-24 00:00:00	1947-09-24	5001	0	\N	0	0	\N	\N	0	29290	0	8331-1	3006322		
44286	4086	3011505	2010-06-10	2010-06-10 00:00:00	2010-06-10	5001	0	\N	0	0	\N	\N	0	271610	0	19926-5	3011505		
49203	4497	40766240	2013-12-05	2013-12-05 00:00:00	2013-12-05	5001	0	\N	0	0	\N	\N	0	299403	0	63513-6	40766240		
27549	2546	3051031	1984-08-17	1984-08-17 00:00:00	1984-08-17	5001	0	\N	0	0	\N	\N	0	168465	0	46240-8	3051031		
39156	3621	3011505	1977-08-20	1977-08-20 00:00:00	1977-08-20	5001	0	\N	0	0	\N	\N	0	240601	0	19926-5	3011505		
11979	1138	3000876	1993-02-04	1993-02-04 00:00:00	1993-02-04	5001	0	\N	0	0	\N	\N	0	75062	0	6082-2	3000876		
23836	2189	3000876	2010-02-17	2010-02-17 00:00:00	2010-02-17	5001	0	\N	0	0	\N	\N	0	145893	0	6082-2	3000876		
42701	3950	3006322	1981-08-08	1981-08-08 00:00:00	1981-08-08	5001	0	\N	0	0	\N	\N	0	262582	0	8331-1	3006322		
43562	4026	3027231	1977-02-07	1977-02-07 00:00:00	1977-02-07	5001	0	\N	0	0	\N	\N	0	267662	0	6276-0	3027231		
160074	4923	4052083	1974-03-13	1974-03-13 00:00:00	1974-03-13	5001	0	\N	0	0	\N	\N	0	327133	0	23426006	4052083		
51317	4694	3001488	1994-08-14	1994-08-14 00:00:00	1994-08-14	5001	0	\N	0	0	\N	\N	0	312751	0	7258-7	3001488		
6021	563	3019406	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	37252	0	6158-0	3019406		
336	12	40766240	2015-07-16	2015-07-16 00:00:00	2015-07-16	5001	0	\N	0	0	\N	\N	0	1004	0	63513-6	40766240		
21062	1952	3006322	1993-05-19	1993-05-19 00:00:00	1993-05-19	5001	0	\N	0	0	\N	\N	0	129822	0	8331-1	3006322		
5118	495	3006322	1979-07-25	1979-07-25 00:00:00	1979-07-25	5001	0	\N	0	0	\N	\N	0	33040	0	8331-1	3006322		
33864	3074	3006322	1964-06-27	1964-06-27 00:00:00	1964-06-27	5001	0	\N	0	0	\N	\N	0	204577	0	8331-1	3006322		
43868	4052	3021226	1977-12-04	1977-12-04 00:00:00	1977-12-04	5001	0	\N	0	0	\N	\N	0	269373	0	6246-3	3021226		
25171	2309	3006322	1977-09-07	1977-09-07 00:00:00	1977-09-07	5001	0	\N	0	0	\N	\N	0	153612	0	8331-1	3006322		
56327	5169	3006322	2005-07-14	2005-07-14 00:00:00	2005-07-14	5001	0	\N	0	0	\N	\N	0	343719	0	8331-1	3006322		
22239	2044	3051031	1962-12-13	1962-12-13 00:00:00	1962-12-13	5001	0	\N	0	0	\N	\N	0	135974	0	46240-8	3051031		
29825	2749	40766240	2005-02-09	2005-02-09 00:00:00	2005-02-09	5001	0	\N	0	0	\N	\N	0	181832	0	63513-6	40766240		
48617	1482	4133840	2011-11-26	2011-11-26 00:00:00	2011-11-26	5001	0	\N	0	0	\N	\N	0	98825	0	127783003	4133840		
4608	442	3006322	2007-02-27	2007-02-27 00:00:00	2007-02-27	5001	0	\N	0	0	\N	\N	0	29369	0	8331-1	3006322		
44287	4086	3011505	2016-11-23	2016-11-23 00:00:00	2016-11-23	5001	0	\N	0	0	\N	\N	0	271561	0	19926-5	3011505		
49204	4497	3006322	1983-02-12	1983-02-12 00:00:00	1983-02-12	5001	0	\N	0	0	\N	\N	0	299356	0	8331-1	3006322		
27552	2546	46235214	1984-08-17	1984-08-17 00:00:00	1984-08-17	5001	0	\N	0	0	\N	\N	0	168465	0	76690-7	46235214		
39157	3621	3011505	1985-10-05	1985-10-05 00:00:00	1985-10-05	5001	0	\N	0	0	\N	\N	0	240594	0	19926-5	3011505		
23271	2138	3006322	1972-05-19	1972-05-19 00:00:00	1972-05-19	5001	0	\N	0	0	\N	\N	0	142376	0	8331-1	3006322		
23837	2189	3036780	2010-02-17	2010-02-17 00:00:00	2010-02-17	5001	0	\N	0	0	\N	\N	0	145893	0	6095-4	3036780		
42702	3951	3006322	2013-08-26	2013-08-26 00:00:00	2013-08-26	5001	0	\N	0	0	\N	\N	0	262695	0	8331-1	3006322		
43563	4026	3014599	1977-02-07	1977-02-07 00:00:00	1977-02-07	5001	0	\N	0	0	\N	\N	0	267662	0	6106-9	3014599		
51318	4694	3020655	1994-08-14	1994-08-14 00:00:00	1994-08-14	5001	0	\N	0	0	\N	\N	0	312751	0	6844-5	3020655		
6022	563	3020655	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	37252	0	6844-5	3020655		
338	12	46235214	2015-07-16	2015-07-16 00:00:00	2015-07-16	5001	0	\N	0	0	\N	\N	0	1004	0	76690-7	46235214		
21063	1952	3006322	1962-07-04	1962-07-04 00:00:00	1962-07-04	5001	0	\N	0	0	\N	\N	0	129821	0	8331-1	3006322		
5119	495	3006322	1991-12-28	1991-12-28 00:00:00	1991-12-28	5001	0	\N	0	0	\N	\N	0	33054	0	8331-1	3006322		
33865	3074	3006322	1962-05-25	1962-05-25 00:00:00	1962-05-25	5001	0	\N	0	0	\N	\N	0	204536	0	8331-1	3006322		
43869	4052	3005136	1977-12-04	1977-12-04 00:00:00	1977-12-04	5001	0	\N	0	0	\N	\N	0	269373	0	6075-6	3005136		
25172	2309	3006322	1999-04-04	1999-04-04 00:00:00	1999-04-04	5001	0	\N	0	0	\N	\N	0	153651	0	8331-1	3006322		
56328	5169	3006322	1969-09-09	1969-09-09 00:00:00	1969-09-09	5001	0	\N	0	0	\N	\N	0	343682	0	8331-1	3006322		
22240	2044	40766240	1962-12-13	1962-12-13 00:00:00	1962-12-13	5001	0	\N	0	0	\N	\N	0	135974	0	63513-6	40766240		
29827	2749	3051031	2005-01-10	2005-01-10 00:00:00	2005-01-10	5001	0	\N	0	0	\N	\N	0	181821	0	46240-8	3051031		
48625	1482	4133840	2018-11-03	2018-11-03 00:00:00	2018-11-03	5001	0	\N	0	0	\N	\N	0	98893	0	127783003	4133840		
4610	443	3006322	2015-03-01	2015-03-01 00:00:00	2015-03-01	5001	0	\N	0	0	\N	\N	0	29478	0	8331-1	3006322		
44288	4086	3011505	2014-12-17	2014-12-17 00:00:00	2014-12-17	5001	0	\N	0	0	\N	\N	0	271611	0	19926-5	3011505		
49205	4497	3006322	2011-09-13	2011-09-13 00:00:00	2011-09-13	5001	0	\N	0	0	\N	\N	0	299420	0	8331-1	3006322		
27553	2546	40766240	1984-08-17	1984-08-17 00:00:00	1984-08-17	5001	0	\N	0	0	\N	\N	0	168465	0	63513-6	40766240		
39158	3621	3006322	1956-06-06	1956-06-06 00:00:00	1956-06-06	5001	0	\N	0	0	\N	\N	0	240609	0	8331-1	3006322		
23272	2138	3006322	1964-09-03	1964-09-03 00:00:00	1964-09-03	5001	0	\N	0	0	\N	\N	0	142374	0	8331-1	3006322		
23838	2189	3012494	2010-02-17	2010-02-17 00:00:00	2010-02-17	5001	0	\N	0	0	\N	\N	0	145893	0	6206-7	3012494		
42703	3951	3006322	1951-01-01	1951-01-01 00:00:00	1951-01-01	5001	0	\N	0	0	\N	\N	0	262649	0	8331-1	3006322		
43564	4026	3006734	1977-02-07	1977-02-07 00:00:00	1977-02-07	5001	0	\N	0	0	\N	\N	0	267662	0	6189-5	3006734		
51319	4694	3019406	1994-08-14	1994-08-14 00:00:00	1994-08-14	5001	0	\N	0	0	\N	\N	0	312751	0	6158-0	3019406		
6023	563	3006322	2002-03-14	2002-03-14 00:00:00	2002-03-14	5001	0	\N	0	0	\N	\N	0	37253	0	8331-1	3006322		
339	12	3051031	2015-03-18	2015-03-18 00:00:00	2015-03-18	5001	0	\N	0	0	\N	\N	0	1030	0	46240-8	3051031		
21064	1952	3006322	2004-09-14	2004-09-14 00:00:00	2004-09-14	5001	0	\N	0	0	\N	\N	0	129823	0	8331-1	3006322		
5167	498	3006322	2016-06-12	2016-06-12 00:00:00	2016-06-12	5001	0	\N	0	0	\N	\N	0	33292	0	8331-1	3006322		
33866	3076	3049273	2017-10-20	2017-10-20 00:00:00	2017-10-20	5001	0	\N	0	0	\N	\N	0	204649	0	38265-5	3049273		
43870	4052	3020655	1977-12-04	1977-12-04 00:00:00	1977-12-04	5001	0	\N	0	0	\N	\N	0	269373	0	6844-5	3020655		
25174	2309	40766240	1974-07-28	1974-07-28 00:00:00	1974-07-28	5001	0	\N	0	0	\N	\N	0	153649	0	63513-6	40766240		
56329	5169	46235214	1954-07-31	1954-07-31 00:00:00	1954-07-31	5001	0	\N	0	0	\N	\N	0	343688	0	76690-7	46235214		
22243	2044	46235214	1962-12-13	1962-12-13 00:00:00	1962-12-13	5001	0	\N	0	0	\N	\N	0	135974	0	76690-7	46235214		
29830	2749	46235214	2005-01-10	2005-01-10 00:00:00	2005-01-10	5001	0	\N	0	0	\N	\N	0	181821	0	76690-7	46235214		
48635	1482	4133840	2014-10-25	2014-10-25 00:00:00	2014-10-25	5001	0	\N	0	0	\N	\N	0	98826	0	127783003	4133840		
4611	443	3006322	1979-09-24	1979-09-24 00:00:00	1979-09-24	5001	0	\N	0	0	\N	\N	0	29434	0	8331-1	3006322		
44289	4086	3011505	2017-06-15	2017-06-15 00:00:00	2017-06-15	5001	0	\N	0	0	\N	\N	0	271578	0	19926-5	3011505		
49206	4497	3006322	1963-08-04	1963-08-04 00:00:00	1963-08-04	5001	0	\N	0	0	\N	\N	0	299396	0	8331-1	3006322		
27554	2546	40758406	1983-07-24	1983-07-24 00:00:00	1983-07-24	5001	0	\N	0	0	\N	\N	0	168488	0	55277-8	40758406		
39160	3621	3011505	1988-10-22	1988-10-22 00:00:00	1988-10-22	5001	0	\N	0	0	\N	\N	0	240656	0	19926-5	3011505		
23273	2138	3006322	2015-07-14	2015-07-14 00:00:00	2015-07-14	5001	0	\N	0	0	\N	\N	0	142422	0	8331-1	3006322		
23839	2189	3005136	2010-02-17	2010-02-17 00:00:00	2010-02-17	5001	0	\N	0	0	\N	\N	0	145893	0	6075-6	3005136		
42704	3951	3006322	1963-08-17	1963-08-17 00:00:00	1963-08-17	5001	0	\N	0	0	\N	\N	0	262632	0	8331-1	3006322		
43565	4026	3001488	1977-02-07	1977-02-07 00:00:00	1977-02-07	5001	0	\N	0	0	\N	\N	0	267662	0	7258-7	3001488		
133429	4109	4024958	2011-01-21	2011-01-21 00:00:00	2011-01-21	5001	0	\N	0	0	\N	\N	0	273115	0	117015009	4024958		
6024	563	40769184	1985-04-19	1985-04-19 00:00:00	1985-04-19	5001	0	\N	0	0	\N	\N	0	37197	0	66524-0	40769184		
341	12	40758406	2015-03-18	2015-03-18 00:00:00	2015-03-18	5001	0	\N	0	0	\N	\N	0	1030	0	55277-8	40758406		
21065	1952	3006322	1960-08-04	1960-08-04 00:00:00	1960-08-04	5001	0	\N	0	0	\N	\N	0	129813	0	8331-1	3006322		
5168	498	3006322	1998-02-07	1998-02-07 00:00:00	1998-02-07	5001	0	\N	0	0	\N	\N	0	33261	0	8331-1	3006322		
33867	3077	3006322	1975-03-13	1975-03-13 00:00:00	1975-03-13	5001	0	\N	0	0	\N	\N	0	204781	0	8331-1	3006322		
43871	4052	3012494	1977-12-04	1977-12-04 00:00:00	1977-12-04	5001	0	\N	0	0	\N	\N	0	269373	0	6206-7	3012494		
25175	2309	40758406	1974-07-28	1974-07-28 00:00:00	1974-07-28	5001	0	\N	0	0	\N	\N	0	153649	0	55277-8	40758406		
56331	5169	40766240	1954-07-31	1954-07-31 00:00:00	1954-07-31	5001	0	\N	0	0	\N	\N	0	343688	0	63513-6	40766240		
22244	2044	40758406	1962-12-13	1962-12-13 00:00:00	1962-12-13	5001	0	\N	0	0	\N	\N	0	135974	0	55277-8	40758406		
29831	2749	40758406	2005-01-10	2005-01-10 00:00:00	2005-01-10	5001	0	\N	0	0	\N	\N	0	181821	0	55277-8	40758406		
48646	1482	4133840	2008-11-22	2008-11-22 00:00:00	2008-11-22	5001	0	\N	0	0	\N	\N	0	98824	0	127783003	4133840		
4612	443	3006322	2016-11-06	2016-11-06 00:00:00	2016-11-06	5001	0	\N	0	0	\N	\N	0	29452	0	8331-1	3006322		
44290	4086	3006322	2017-06-10	2017-06-10 00:00:00	2017-06-10	5001	0	\N	0	0	\N	\N	0	271622	0	8331-1	3006322		
49209	4497	40758406	2008-10-07	2008-10-07 00:00:00	2008-10-07	5001	0	\N	0	0	\N	\N	0	299385	0	55277-8	40758406		
27557	2546	40766240	1983-07-24	1983-07-24 00:00:00	1983-07-24	5001	0	\N	0	0	\N	\N	0	168488	0	63513-6	40766240		
39161	3621	3011505	1993-05-22	1993-05-22 00:00:00	1993-05-22	5001	0	\N	0	0	\N	\N	0	240597	0	19926-5	3011505		
23274	2138	3006322	1958-07-24	1958-07-24 00:00:00	1958-07-24	5001	0	\N	0	0	\N	\N	0	142373	0	8331-1	3006322		
23840	2189	3027231	2010-02-17	2010-02-17 00:00:00	2010-02-17	5001	0	\N	0	0	\N	\N	0	145893	0	6276-0	3027231		
42705	3951	3006322	1948-12-31	1948-12-31 00:00:00	1948-12-31	5001	0	\N	0	0	\N	\N	0	262650	0	8331-1	3006322		
43566	4026	3001247	1977-02-07	1977-02-07 00:00:00	1977-02-07	5001	0	\N	0	0	\N	\N	0	267662	0	6085-5	3001247		
133435	4109	4024958	1990-10-15	1990-10-15 00:00:00	1990-10-15	5001	0	\N	0	0	\N	\N	0	273091	0	117015009	4024958		
6025	563	40769179	1985-04-19	1985-04-19 00:00:00	1985-04-19	5001	0	\N	0	0	\N	\N	0	37197	0	66519-0	40769179		
342	12	40766240	2015-03-18	2015-03-18 00:00:00	2015-03-18	5001	0	\N	0	0	\N	\N	0	1030	0	63513-6	40766240		
21066	1952	3049273	2015-03-02	2015-03-02 00:00:00	2015-03-02	5001	0	\N	0	0	\N	\N	0	129811	0	38265-5	3049273		
5169	498	3006322	1972-06-14	1972-06-14 00:00:00	1972-06-14	5001	0	\N	0	0	\N	\N	0	33245	0	8331-1	3006322		
33868	3077	3006322	1973-12-06	1973-12-06 00:00:00	1973-12-06	5001	0	\N	0	0	\N	\N	0	204762	0	8331-1	3006322		
43872	4052	3023430	1977-12-04	1977-12-04 00:00:00	1977-12-04	5001	0	\N	0	0	\N	\N	0	269373	0	6833-8	3023430		
25177	2309	3051031	1974-07-28	1974-07-28 00:00:00	1974-07-28	5001	0	\N	0	0	\N	\N	0	153649	0	46240-8	3051031		
56332	5169	3051031	1954-07-31	1954-07-31 00:00:00	1954-07-31	5001	0	\N	0	0	\N	\N	0	343688	0	46240-8	3051031		
22246	2044	40758406	1991-01-30	1991-01-30 00:00:00	1991-01-30	5001	0	\N	0	0	\N	\N	0	135958	0	55277-8	40758406		
29832	2749	40766240	2005-01-10	2005-01-10 00:00:00	2005-01-10	5001	0	\N	0	0	\N	\N	0	181821	0	63513-6	40766240		
48650	1482	4024958	2011-06-08	2011-06-08 00:00:00	2011-06-08	5001	0	\N	0	0	\N	\N	0	98838	0	117015009	4024958		
4617	445	3006322	1944-12-25	1944-12-25 00:00:00	1944-12-25	5001	0	\N	0	0	\N	\N	0	29571	0	8331-1	3006322		
44291	4086	3006322	2018-10-14	2018-10-14 00:00:00	2018-10-14	5001	0	\N	0	0	\N	\N	0	271562	0	8331-1	3006322		
49210	4497	3051031	2008-10-07	2008-10-07 00:00:00	2008-10-07	5001	0	\N	0	0	\N	\N	0	299385	0	46240-8	3051031		
27558	2546	3051031	1983-07-24	1983-07-24 00:00:00	1983-07-24	5001	0	\N	0	0	\N	\N	0	168488	0	46240-8	3051031		
39162	3621	3011505	1994-05-28	1994-05-28 00:00:00	1994-05-28	5001	0	\N	0	0	\N	\N	0	240606	0	19926-5	3011505		
23275	2138	3049273	1966-09-07	1966-09-07 00:00:00	1966-09-07	5001	0	\N	0	0	\N	\N	0	142412	0	38265-5	3049273		
23841	2189	3014599	2010-02-17	2010-02-17 00:00:00	2010-02-17	5001	0	\N	0	0	\N	\N	0	145893	0	6106-9	3014599		
42706	3951	3006322	2019-03-09	2019-03-09 00:00:00	2019-03-09	5001	0	\N	0	0	\N	\N	0	262696	0	8331-1	3006322		
43567	4026	3000876	1977-02-07	1977-02-07 00:00:00	1977-02-07	5001	0	\N	0	0	\N	\N	0	267662	0	6082-2	3000876		
139704	4305	4024958	1984-08-31	1984-08-31 00:00:00	1984-08-31	5001	0	\N	0	0	\N	\N	0	285575	0	117015009	4024958		
6026	563	40769194	1985-04-19	1985-04-19 00:00:00	1985-04-19	5001	0	\N	0	0	\N	\N	0	37197	0	66534-9	40769194		
344	12	46235214	2015-03-18	2015-03-18 00:00:00	2015-03-18	5001	0	\N	0	0	\N	\N	0	1030	0	76690-7	46235214		
21067	1952	3006322	1970-06-05	1970-06-05 00:00:00	1970-06-05	5001	0	\N	0	0	\N	\N	0	129778	0	8331-1	3006322		
5170	499	3006322	2000-05-22	2000-05-22 00:00:00	2000-05-22	5001	0	\N	0	0	\N	\N	0	33303	0	8331-1	3006322		
33869	3077	3006322	1983-02-10	1983-02-10 00:00:00	1983-02-10	5001	0	\N	0	0	\N	\N	0	204767	0	8331-1	3006322		
43873	4052	3006734	1977-12-04	1977-12-04 00:00:00	1977-12-04	5001	0	\N	0	0	\N	\N	0	269373	0	6189-5	3006734		
25178	2309	46235214	1974-07-28	1974-07-28 00:00:00	1974-07-28	5001	0	\N	0	0	\N	\N	0	153649	0	76690-7	46235214		
56333	5169	40758406	1954-07-31	1954-07-31 00:00:00	1954-07-31	5001	0	\N	0	0	\N	\N	0	343688	0	55277-8	40758406		
22247	2044	3051031	1991-01-30	1991-01-30 00:00:00	1991-01-30	5001	0	\N	0	0	\N	\N	0	135958	0	46240-8	3051031		
29833	2749	3006322	1968-12-22	1968-12-22 00:00:00	1968-12-22	5001	0	\N	0	0	\N	\N	0	181784	0	8331-1	3006322		
48660	1482	4133840	2005-11-19	2005-11-19 00:00:00	2005-11-19	5001	0	\N	0	0	\N	\N	0	98823	0	127783003	4133840		
4619	445	3006322	1996-01-29	1996-01-29 00:00:00	1996-01-29	5001	0	\N	0	0	\N	\N	0	29558	0	8331-1	3006322		
44292	4086	3011505	2015-11-25	2015-11-25 00:00:00	2015-11-25	5001	0	\N	0	0	\N	\N	0	271598	0	19926-5	3011505		
49211	4497	40766240	2008-10-07	2008-10-07 00:00:00	2008-10-07	5001	0	\N	0	0	\N	\N	0	299385	0	63513-6	40766240		
27559	2546	46235214	1983-07-24	1983-07-24 00:00:00	1983-07-24	5001	0	\N	0	0	\N	\N	0	168488	0	76690-7	46235214		
165525	5083	4024958	1973-12-14	1973-12-14 00:00:00	1973-12-14	5001	0	\N	0	0	\N	\N	0	338023	0	117015009	4024958		
23276	2138	3006322	1968-10-25	1968-10-25 00:00:00	1968-10-25	5001	0	\N	0	0	\N	\N	0	142419	0	8331-1	3006322		
23842	2189	3020655	2010-02-17	2010-02-17 00:00:00	2010-02-17	5001	0	\N	0	0	\N	\N	0	145893	0	6844-5	3020655		
42707	3951	3006322	1973-08-06	1973-08-06 00:00:00	1973-08-06	5001	0	\N	0	0	\N	\N	0	262652	0	8331-1	3006322		
43568	4026	3006322	1994-10-11	1994-10-11 00:00:00	1994-10-11	5001	0	\N	0	0	\N	\N	0	267747	0	8331-1	3006322		
139736	4308	4024958	1938-04-16	1938-04-16 00:00:00	1938-04-16	5001	0	\N	0	0	\N	\N	0	285766	0	117015009	4024958		
6027	563	40769189	1985-04-19	1985-04-19 00:00:00	1985-04-19	5001	0	\N	0	0	\N	\N	0	37197	0	66529-9	40769189		
345	12	3051031	2016-01-12	2016-01-12 00:00:00	2016-01-12	5001	0	\N	0	0	\N	\N	0	1005	0	46240-8	3051031		
21068	1952	3006322	1996-12-09	1996-12-09 00:00:00	1996-12-09	5001	0	\N	0	0	\N	\N	0	129816	0	8331-1	3006322		
5171	499	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	33371	0	6189-5	3006734		
33870	3077	3006322	1987-07-03	1987-07-03 00:00:00	1987-07-03	5001	0	\N	0	0	\N	\N	0	204782	0	8331-1	3006322		
43874	4052	3036780	1977-12-04	1977-12-04 00:00:00	1977-12-04	5001	0	\N	0	0	\N	\N	0	269373	0	6095-4	3036780		
25179	2311	3006322	1971-09-17	1971-09-17 00:00:00	1971-09-17	5001	0	\N	0	0	\N	\N	0	153742	0	8331-1	3006322		
56335	5170	3006322	1991-07-07	1991-07-07 00:00:00	1991-07-07	5001	0	\N	0	0	\N	\N	0	343794	0	8331-1	3006322		
22248	2044	40766240	1991-01-30	1991-01-30 00:00:00	1991-01-30	5001	0	\N	0	0	\N	\N	0	135958	0	63513-6	40766240		
29834	2749	3006322	1999-08-14	1999-08-14 00:00:00	1999-08-14	5001	0	\N	0	0	\N	\N	0	181820	0	8331-1	3006322		
48667	1482	4052083	2006-06-13	2006-06-13 00:00:00	2006-06-13	5001	0	\N	0	0	\N	\N	0	98901	0	23426006	4052083		
4621	445	3006322	1954-01-20	1954-01-20 00:00:00	1954-01-20	5001	0	\N	0	0	\N	\N	0	29587	0	8331-1	3006322		
44293	4086	3011505	2007-06-07	2007-06-07 00:00:00	2007-06-07	5001	0	\N	0	0	\N	\N	0	271609	0	19926-5	3011505		
49212	4497	46235214	2008-10-07	2008-10-07 00:00:00	2008-10-07	5001	0	\N	0	0	\N	\N	0	299385	0	76690-7	46235214		
27561	2546	46235214	1984-03-20	1984-03-20 00:00:00	1984-03-20	5001	0	\N	0	0	\N	\N	0	168505	0	76690-7	46235214		
165536	5083	4024958	1951-03-05	1951-03-05 00:00:00	1951-03-05	5001	0	\N	0	0	\N	\N	0	338051	0	117015009	4024958		
23278	2140	3006322	1955-08-18	1955-08-18 00:00:00	1955-08-18	5001	0	\N	0	0	\N	\N	0	142557	0	8331-1	3006322		
23843	2189	3006734	2010-02-17	2010-02-17 00:00:00	2010-02-17	5001	0	\N	0	0	\N	\N	0	145893	0	6189-5	3006734		
42708	3951	3006322	1977-04-28	1977-04-28 00:00:00	1977-04-28	5001	0	\N	0	0	\N	\N	0	262633	0	8331-1	3006322		
43569	4026	3011505	2018-03-11	2018-03-11 00:00:00	2018-03-11	5001	0	\N	0	0	\N	\N	0	267760	0	19926-5	3011505		
139737	4308	4052083	1992-08-29	1992-08-29 00:00:00	1992-08-29	5001	0	\N	0	0	\N	\N	0	285814	0	23426006	4052083		
6028	563	3006322	1969-08-15	1969-08-15 00:00:00	1969-08-15	5001	0	\N	0	0	\N	\N	0	37195	0	8331-1	3006322		
347	12	40758406	2016-01-12	2016-01-12 00:00:00	2016-01-12	5001	0	\N	0	0	\N	\N	0	1005	0	55277-8	40758406		
21069	1953	3049273	2014-10-27	2014-10-27 00:00:00	2014-10-27	5001	0	\N	0	0	\N	\N	0	129945	0	38265-5	3049273		
5172	499	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	33371	0	6082-2	3000876		
33871	3077	3006322	2016-06-14	2016-06-14 00:00:00	2016-06-14	5001	0	\N	0	0	\N	\N	0	204751	0	8331-1	3006322		
43875	4052	3001488	1977-12-04	1977-12-04 00:00:00	1977-12-04	5001	0	\N	0	0	\N	\N	0	269373	0	7258-7	3001488		
25180	2311	3006322	1993-11-04	1993-11-04 00:00:00	1993-11-04	5001	0	\N	0	0	\N	\N	0	153743	0	8331-1	3006322		
56336	5170	3006322	2012-05-01	2012-05-01 00:00:00	2012-05-01	5001	0	\N	0	0	\N	\N	0	343758	0	8331-1	3006322		
22249	2044	46235214	1991-01-30	1991-01-30 00:00:00	1991-01-30	5001	0	\N	0	0	\N	\N	0	135958	0	76690-7	46235214		
29835	2749	3006322	1974-03-17	1974-03-17 00:00:00	1974-03-17	5001	0	\N	0	0	\N	\N	0	181788	0	8331-1	3006322		
59967	1829	4024958	2001-12-05	2001-12-05 00:00:00	2001-12-05	5001	0	\N	0	0	\N	\N	0	122280	0	117015009	4024958		
4623	445	3006322	1956-06-21	1956-06-21 00:00:00	1956-06-21	5001	0	\N	0	0	\N	\N	0	29603	0	8331-1	3006322		
44294	4087	3006322	1985-11-08	1985-11-08 00:00:00	1985-11-08	5001	0	\N	0	0	\N	\N	0	271645	0	8331-1	3006322		
49213	4497	3006322	1971-04-07	1971-04-07 00:00:00	1971-04-07	5001	0	\N	0	0	\N	\N	0	299416	0	8331-1	3006322		
27563	2546	40758406	1984-03-20	1984-03-20 00:00:00	1984-03-20	5001	0	\N	0	0	\N	\N	0	168505	0	55277-8	40758406		
165550	5083	4024958	1980-03-25	1980-03-25 00:00:00	1980-03-25	5001	0	\N	0	0	\N	\N	0	338016	0	117015009	4024958		
23279	2140	3006322	1980-01-01	1980-01-01 00:00:00	1980-01-01	5001	0	\N	0	0	\N	\N	0	142506	0	8331-1	3006322		
23844	2189	3023430	2010-02-17	2010-02-17 00:00:00	2010-02-17	5001	0	\N	0	0	\N	\N	0	145893	0	6833-8	3023430		
42709	3951	3006322	1985-12-21	1985-12-21 00:00:00	1985-12-21	5001	0	\N	0	0	\N	\N	0	262684	0	8331-1	3006322		
43570	4026	3011505	2017-03-05	2017-03-05 00:00:00	2017-03-05	5001	0	\N	0	0	\N	\N	0	267678	0	19926-5	3011505		
139745	4308	4052083	1973-01-22	1973-01-22 00:00:00	1973-01-22	5001	0	\N	0	0	\N	\N	0	285833	0	23426006	4052083		
6029	563	3006322	1974-10-28	1974-10-28 00:00:00	1974-10-28	5001	0	\N	0	0	\N	\N	0	37293	0	8331-1	3006322		
348	12	40766240	2016-01-12	2016-01-12 00:00:00	2016-01-12	5001	0	\N	0	0	\N	\N	0	1005	0	63513-6	40766240		
21070	1953	3006322	1973-11-10	1973-11-10 00:00:00	1973-11-10	5001	0	\N	0	0	\N	\N	0	129903	0	8331-1	3006322		
5173	499	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	33371	0	6095-4	3036780		
33874	3079	3006322	1979-08-20	1979-08-20 00:00:00	1979-08-20	5001	0	\N	0	0	\N	\N	0	204906	0	8331-1	3006322		
43876	4052	3000876	1977-12-04	1977-12-04 00:00:00	1977-12-04	5001	0	\N	0	0	\N	\N	0	269373	0	6082-2	3000876		
25181	2311	3006322	1960-08-31	1960-08-31 00:00:00	1960-08-31	5001	0	\N	0	0	\N	\N	0	153751	0	8331-1	3006322		
56337	5170	3006322	1989-06-23	1989-06-23 00:00:00	1989-06-23	5001	0	\N	0	0	\N	\N	0	343792	0	8331-1	3006322		
22251	2044	46235214	1963-03-13	1963-03-13 00:00:00	1963-03-13	5001	0	\N	0	0	\N	\N	0	135975	0	76690-7	46235214		
29836	2750	3006322	1928-12-03	1928-12-03 00:00:00	1928-12-03	5001	0	\N	0	0	\N	\N	0	181942	0	8331-1	3006322		
48979	1493	4024958	1958-08-31	1958-08-31 00:00:00	1958-08-31	5001	0	\N	0	0	\N	\N	0	99550	0	117015009	4024958		
4624	445	3006322	1993-09-29	1993-09-29 00:00:00	1993-09-29	5001	0	\N	0	0	\N	\N	0	29627	0	8331-1	3006322		
44295	4087	3006322	1991-08-22	1991-08-22 00:00:00	1991-08-22	5001	0	\N	0	0	\N	\N	0	271646	0	8331-1	3006322		
49214	4497	3051031	2007-11-12	2007-11-12 00:00:00	2007-11-12	5001	0	\N	0	0	\N	\N	0	299419	0	46240-8	3051031		
27564	2546	3051031	1984-03-20	1984-03-20 00:00:00	1984-03-20	5001	0	\N	0	0	\N	\N	0	168505	0	46240-8	3051031		
165569	5085	4024958	1986-12-01	1986-12-01 00:00:00	1986-12-01	5001	0	\N	0	0	\N	\N	0	338093	0	117015009	4024958		
23280	2140	3006322	1989-11-22	1989-11-22 00:00:00	1989-11-22	5001	0	\N	0	0	\N	\N	0	142487	0	8331-1	3006322		
23845	2189	3006322	2012-04-15	2012-04-15 00:00:00	2012-04-15	5001	0	\N	0	0	\N	\N	0	145993	0	8331-1	3006322		
42710	3951	3006322	1988-05-23	1988-05-23 00:00:00	1988-05-23	5001	0	\N	0	0	\N	\N	0	262619	0	8331-1	3006322		
43571	4026	3011505	2012-02-05	2012-02-05 00:00:00	2012-02-05	5001	0	\N	0	0	\N	\N	0	267676	0	19926-5	3011505		
139756	4308	4052083	1956-11-14	1956-11-14 00:00:00	1956-11-14	5001	0	\N	0	0	\N	\N	0	285751	0	23426006	4052083		
6030	563	3000876	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	37291	0	6082-2	3000876		
124072	3827	4024958	1969-01-21	1969-01-21 00:00:00	1969-01-21	5001	0	\N	0	0	\N	\N	0	254159	0	117015009	4024958		
21071	1953	3006322	1969-08-21	1969-08-21 00:00:00	1969-08-21	5001	0	\N	0	0	\N	\N	0	129902	0	8331-1	3006322		
5174	499	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	33371	0	6248-9	3015076		
33875	3079	3006322	1934-06-18	1934-06-18 00:00:00	1934-06-18	5001	0	\N	0	0	\N	\N	0	204937	0	8331-1	3006322		
43877	4052	3015076	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	269343	0	6248-9	3015076		
25182	2311	3006322	2009-12-08	2009-12-08 00:00:00	2009-12-08	5001	0	\N	0	0	\N	\N	0	153756	0	8331-1	3006322		
56338	5170	3006322	1990-03-02	1990-03-02 00:00:00	1990-03-02	5001	0	\N	0	0	\N	\N	0	343754	0	8331-1	3006322		
22252	2044	40758406	1963-03-13	1963-03-13 00:00:00	1963-03-13	5001	0	\N	0	0	\N	\N	0	135975	0	55277-8	40758406		
29838	2750	3006322	1927-07-30	1927-07-30 00:00:00	1927-07-30	5001	0	\N	0	0	\N	\N	0	181877	0	8331-1	3006322		
48983	1493	4024958	1957-09-21	1957-09-21 00:00:00	1957-09-21	5001	0	\N	0	0	\N	\N	0	99549	0	117015009	4024958		
4626	445	3006322	1936-02-28	1936-02-28 00:00:00	1936-02-28	5001	0	\N	0	0	\N	\N	0	29570	0	8331-1	3006322		
126389	3891	4024958	1988-10-24	1988-10-24 00:00:00	1988-10-24	5001	0	\N	0	0	\N	\N	0	258722	0	117015009	4024958		
49217	4497	46235214	2007-11-12	2007-11-12 00:00:00	2007-11-12	5001	0	\N	0	0	\N	\N	0	299419	0	76690-7	46235214		
27565	2546	40766240	1984-03-20	1984-03-20 00:00:00	1984-03-20	5001	0	\N	0	0	\N	\N	0	168505	0	63513-6	40766240		
3402	332	3006734	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	22053	0	6189-5	3006734		
23281	2140	3006322	1966-10-29	1966-10-29 00:00:00	1966-10-29	5001	0	\N	0	0	\N	\N	0	142548	0	8331-1	3006322		
23846	2189	3006451	2013-08-21	2013-08-21 00:00:00	2013-08-21	5001	0	\N	0	0	\N	\N	0	145935	0	6273-7	3006451		
42711	3951	3049273	2011-05-31	2011-05-31 00:00:00	2011-05-31	5001	0	\N	0	0	\N	\N	0	262602	0	38265-5	3049273		
43572	4026	3006322	2018-04-01	2018-04-01 00:00:00	2018-04-01	5001	0	\N	0	0	\N	\N	0	267601	0	8331-1	3006322		
139767	4309	4024958	1990-12-12	1990-12-12 00:00:00	1990-12-12	5001	0	\N	0	0	\N	\N	0	285888	0	117015009	4024958		
6031	563	3012494	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	37291	0	6206-7	3012494		
124096	3830	4024958	1987-03-01	1987-03-01 00:00:00	1987-03-01	5001	0	\N	0	0	\N	\N	0	254290	0	117015009	4024958		
21072	1953	3006322	1990-05-12	1990-05-12 00:00:00	1990-05-12	5001	0	\N	0	0	\N	\N	0	129899	0	8331-1	3006322		
5175	499	3012494	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	33371	0	6206-7	3012494		
33876	3079	3006322	1986-04-28	1986-04-28 00:00:00	1986-04-28	5001	0	\N	0	0	\N	\N	0	204896	0	8331-1	3006322		
43878	4052	3027231	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	269343	0	6276-0	3027231		
25183	2311	3006322	2008-01-03	2008-01-03 00:00:00	2008-01-03	5001	0	\N	0	0	\N	\N	0	153744	0	8331-1	3006322		
56339	5170	3006322	2007-07-23	2007-07-23 00:00:00	2007-07-23	5001	0	\N	0	0	\N	\N	0	343756	0	8331-1	3006322		
22253	2044	3051031	1963-03-13	1963-03-13 00:00:00	1963-03-13	5001	0	\N	0	0	\N	\N	0	135975	0	46240-8	3051031		
29839	2750	3006322	2000-09-10	2000-09-10 00:00:00	2000-09-10	5001	0	\N	0	0	\N	\N	0	181922	0	8331-1	3006322		
49003	1493	4052083	2007-04-18	2007-04-18 00:00:00	2007-04-18	5001	0	\N	0	0	\N	\N	0	99555	0	23426006	4052083		
4627	445	3006322	1978-03-07	1978-03-07 00:00:00	1978-03-07	5001	0	\N	0	0	\N	\N	0	29557	0	8331-1	3006322		
126429	3892	4024958	1972-03-09	1972-03-09 00:00:00	1972-03-09	5001	0	\N	0	0	\N	\N	0	258798	0	117015009	4024958		
49218	4497	40766240	2007-11-12	2007-11-12 00:00:00	2007-11-12	5001	0	\N	0	0	\N	\N	0	299419	0	63513-6	40766240		
38844	3589	3012494	1994-01-03	1994-01-03 00:00:00	1994-01-03	5001	0	\N	0	0	\N	\N	0	238450	0	6206-7	3012494		
3403	332	3014599	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	22053	0	6106-9	3014599		
23282	2141	3006322	1961-05-18	1961-05-18 00:00:00	1961-05-18	5001	0	\N	0	0	\N	\N	0	142612	0	8331-1	3006322		
23847	2189	3000876	2013-08-21	2013-08-21 00:00:00	2013-08-21	5001	0	\N	0	0	\N	\N	0	145935	0	6082-2	3000876		
42712	3951	3006322	1955-11-18	1955-11-18 00:00:00	1955-11-18	5001	0	\N	0	0	\N	\N	0	262616	0	8331-1	3006322		
43573	4026	3011505	2015-02-22	2015-02-22 00:00:00	2015-02-22	5001	0	\N	0	0	\N	\N	0	267677	0	19926-5	3011505		
71083	2175	4052083	2003-04-16	2003-04-16 00:00:00	2003-04-16	5001	0	\N	0	0	\N	\N	0	144981	0	23426006	4052083		
6032	563	3019406	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	37291	0	6158-0	3019406		
124128	3831	4052083	1962-07-13	1962-07-13 00:00:00	1962-07-13	5001	0	\N	0	0	\N	\N	0	254372	0	23426006	4052083		
21073	1953	3006322	1997-08-17	1997-08-17 00:00:00	1997-08-17	5001	0	\N	0	0	\N	\N	0	129900	0	8331-1	3006322		
5176	499	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	33371	0	6844-5	3020655		
33877	3079	3006322	1972-04-14	1972-04-14 00:00:00	1972-04-14	5001	0	\N	0	0	\N	\N	0	204920	0	8331-1	3006322		
43879	4052	3014599	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	269343	0	6106-9	3014599		
25189	2314	3006322	2004-12-12	2004-12-12 00:00:00	2004-12-12	5001	0	\N	0	0	\N	\N	0	153844	0	8331-1	3006322		
56340	5170	3006322	2010-02-24	2010-02-24 00:00:00	2010-02-24	5001	0	\N	0	0	\N	\N	0	343757	0	8331-1	3006322		
22254	2044	40766240	1963-03-13	1963-03-13 00:00:00	1963-03-13	5001	0	\N	0	0	\N	\N	0	135975	0	63513-6	40766240		
29841	2750	3006322	1978-11-07	1978-11-07 00:00:00	1978-11-07	5001	0	\N	0	0	\N	\N	0	181932	0	8331-1	3006322		
49043	1496	4024958	1980-06-12	1980-06-12 00:00:00	1980-06-12	5001	0	\N	0	0	\N	\N	0	99733	0	117015009	4024958		
4628	445	3006322	1929-08-21	1929-08-21 00:00:00	1929-08-21	5001	0	\N	0	0	\N	\N	0	29647	0	8331-1	3006322		
126435	3892	4024958	1977-06-22	1977-06-22 00:00:00	1977-06-22	5001	0	\N	0	0	\N	\N	0	258799	0	117015009	4024958		
49219	4497	40758406	2007-11-12	2007-11-12 00:00:00	2007-11-12	5001	0	\N	0	0	\N	\N	0	299419	0	55277-8	40758406		
38845	3589	3014599	1994-01-03	1994-01-03 00:00:00	1994-01-03	5001	0	\N	0	0	\N	\N	0	238450	0	6106-9	3014599		
3404	332	3020655	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	22053	0	6844-5	3020655		
23283	2141	3006322	1947-11-04	1947-11-04 00:00:00	1947-11-04	5001	0	\N	0	0	\N	\N	0	142653	0	8331-1	3006322		
23848	2189	3036780	2013-08-21	2013-08-21 00:00:00	2013-08-21	5001	0	\N	0	0	\N	\N	0	145935	0	6095-4	3036780		
42718	3955	3006322	1996-01-15	1996-01-15 00:00:00	1996-01-15	5001	0	\N	0	0	\N	\N	0	262869	0	8331-1	3006322		
43574	4026	3006322	2019-02-08	2019-02-08 00:00:00	2019-02-08	5001	0	\N	0	0	\N	\N	0	267643	0	8331-1	3006322		
71089	2175	4052083	1992-02-06	1992-02-06 00:00:00	1992-02-06	5001	0	\N	0	0	\N	\N	0	145045	0	23426006	4052083		
6033	563	3020655	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	37291	0	6844-5	3020655		
124129	3831	4024958	1955-09-24	1955-09-24 00:00:00	1955-09-24	5001	0	\N	0	0	\N	\N	0	254371	0	117015009	4024958		
21074	1953	3006322	2008-08-05	2008-08-05 00:00:00	2008-08-05	5001	0	\N	0	0	\N	\N	0	129910	0	8331-1	3006322		
5177	499	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	33371	0	6833-8	3023430		
33878	3080	3009542	1941-12-12	1941-12-12 00:00:00	1941-12-12	5001	0	\N	0	0	\N	\N	0	204983	0	20570-8	3009542		
43880	4052	3019406	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	269343	0	6158-0	3019406		
25190	2314	3006322	2016-03-25	2016-03-25 00:00:00	2016-03-25	5001	0	\N	0	0	\N	\N	0	153893	0	8331-1	3006322		
56341	5170	3006322	2014-07-31	2014-07-31 00:00:00	2014-07-31	5001	0	\N	0	0	\N	\N	0	343773	0	8331-1	3006322		
22257	2044	3006322	1982-09-10	1982-09-10 00:00:00	1982-09-10	5001	0	\N	0	0	\N	\N	0	135966	0	8331-1	3006322		
29842	2750	3006322	1971-09-21	1971-09-21 00:00:00	1971-09-21	5001	0	\N	0	0	\N	\N	0	181878	0	8331-1	3006322		
49045	1496	4024958	1932-01-29	1932-01-29 00:00:00	1932-01-29	5001	0	\N	0	0	\N	\N	0	99719	0	117015009	4024958		
15936	1454	3006322	1992-12-17	1992-12-17 00:00:00	1992-12-17	5001	0	\N	0	0	\N	\N	0	97020	0	8331-1	3006322		
126442	3892	4024958	1967-06-06	1967-06-06 00:00:00	1967-06-06	5001	0	\N	0	0	\N	\N	0	258775	0	117015009	4024958		
49222	4497	40758406	2008-06-09	2008-06-09 00:00:00	2008-06-09	5001	0	\N	0	0	\N	\N	0	299401	0	55277-8	40758406		
38846	3589	3036780	1994-01-03	1994-01-03 00:00:00	1994-01-03	5001	0	\N	0	0	\N	\N	0	238450	0	6095-4	3036780		
3405	332	3023430	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	22053	0	6833-8	3023430		
23284	2141	3006322	1949-09-07	1949-09-07 00:00:00	1949-09-07	5001	0	\N	0	0	\N	\N	0	142636	0	8331-1	3006322		
23849	2189	3012494	2013-08-21	2013-08-21 00:00:00	2013-08-21	5001	0	\N	0	0	\N	\N	0	145935	0	6206-7	3012494		
42719	3955	3006322	1983-10-11	1983-10-11 00:00:00	1983-10-11	5001	0	\N	0	0	\N	\N	0	262892	0	8331-1	3006322		
43575	4026	3006322	1959-01-22	1959-01-22 00:00:00	1959-01-22	5001	0	\N	0	0	\N	\N	0	267728	0	8331-1	3006322		
71098	2176	4024958	1975-02-19	1975-02-19 00:00:00	1975-02-19	5001	0	\N	0	0	\N	\N	0	145158	0	117015009	4024958		
6034	563	3001247	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	37291	0	6085-5	3001247		
124135	3831	4052083	1958-03-11	1958-03-11 00:00:00	1958-03-11	5001	0	\N	0	0	\N	\N	0	254390	0	23426006	4052083		
21075	1953	3006322	1982-03-14	1982-03-14 00:00:00	1982-03-14	5001	0	\N	0	0	\N	\N	0	129898	0	8331-1	3006322		
5178	499	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	33371	0	6085-5	3001247		
33879	3080	3000963	1941-12-12	1941-12-12 00:00:00	1941-12-12	5001	0	\N	0	0	\N	\N	0	204983	0	718-7	3000963		
43881	4052	3006451	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	269343	0	6273-7	3006451		
25191	2314	3006322	1982-09-25	1982-09-25 00:00:00	1982-09-25	5001	0	\N	0	0	\N	\N	0	153843	0	8331-1	3006322		
56342	5170	3006322	1979-06-05	1979-06-05 00:00:00	1979-06-05	5001	0	\N	0	0	\N	\N	0	343764	0	8331-1	3006322		
22258	2044	46235214	1963-04-12	1963-04-12 00:00:00	1963-04-12	5001	0	\N	0	0	\N	\N	0	135954	0	76690-7	46235214		
29844	2750	3006322	1940-02-16	1940-02-16 00:00:00	1940-02-16	5001	0	\N	0	0	\N	\N	0	181887	0	8331-1	3006322		
60327	1843	4052083	2012-06-04	2012-06-04 00:00:00	2012-06-04	5001	0	\N	0	0	\N	\N	0	123086	0	23426006	4052083		
15937	1454	3006322	1984-07-17	1984-07-17 00:00:00	1984-07-17	5001	0	\N	0	0	\N	\N	0	97007	0	8331-1	3006322		
126451	3893	4052083	1994-07-07	1994-07-07 00:00:00	1994-07-07	5001	0	\N	0	0	\N	\N	0	258881	0	23426006	4052083		
49223	4497	3051031	2008-06-09	2008-06-09 00:00:00	2008-06-09	5001	0	\N	0	0	\N	\N	0	299401	0	46240-8	3051031		
38847	3589	3019406	1994-01-03	1994-01-03 00:00:00	1994-01-03	5001	0	\N	0	0	\N	\N	0	238450	0	6158-0	3019406		
3406	332	3021226	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	22053	0	6246-3	3021226		
23285	2141	40769179	1970-07-14	1970-07-14 00:00:00	1970-07-14	5001	0	\N	0	0	\N	\N	0	142640	0	66519-0	40769179		
23850	2189	3005136	2013-08-21	2013-08-21 00:00:00	2013-08-21	5001	0	\N	0	0	\N	\N	0	145935	0	6075-6	3005136		
42720	3956	3006322	1928-07-31	1928-07-31 00:00:00	1928-07-31	5001	0	\N	0	0	\N	\N	0	262939	0	8331-1	3006322		
43576	4026	3011505	2016-02-28	2016-02-28 00:00:00	2016-02-28	5001	0	\N	0	0	\N	\N	0	267759	0	19926-5	3011505		
71103	2176	4024958	1963-09-05	1963-09-05 00:00:00	1963-09-05	5001	0	\N	0	0	\N	\N	0	145085	0	117015009	4024958		
6035	563	3005136	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	37291	0	6075-6	3005136		
151162	4633	4024958	1991-03-26	1991-03-26 00:00:00	1991-03-26	5001	0	\N	0	0	\N	\N	0	308741	0	117015009	4024958		
21076	1954	40766240	1967-05-22	1967-05-22 00:00:00	1967-05-22	5001	0	\N	0	0	\N	\N	0	130010	0	63513-6	40766240		
5179	499	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	33371	0	6276-0	3027231		
33880	3080	3006322	1951-09-17	1951-09-17 00:00:00	1951-09-17	5001	0	\N	0	0	\N	\N	0	204986	0	8331-1	3006322		
43882	4052	3012494	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	269343	0	6206-7	3012494		
25192	2315	3006322	2004-07-09	2004-07-09 00:00:00	2004-07-09	5001	0	\N	0	0	\N	\N	0	153935	0	8331-1	3006322		
56343	5172	3006322	1975-11-30	1975-11-30 00:00:00	1975-11-30	5001	0	\N	0	0	\N	\N	0	343854	0	8331-1	3006322		
22259	2044	40758406	1963-04-12	1963-04-12 00:00:00	1963-04-12	5001	0	\N	0	0	\N	\N	0	135954	0	55277-8	40758406		
29845	2750	3006322	1942-06-18	1942-06-18 00:00:00	1942-06-18	5001	0	\N	0	0	\N	\N	0	181943	0	8331-1	3006322		
37906	1175	4024958	1947-10-07	1947-10-07 00:00:00	1947-10-07	5001	0	\N	0	0	\N	\N	0	77545	0	117015009	4024958		
142515	4379	4052083	1975-06-17	1975-06-17 00:00:00	1975-06-17	5001	0	\N	0	0	\N	\N	0	290970	0	23426006	4052083		
115204	3553	4052083	1990-03-05	1990-03-05 00:00:00	1990-03-05	5001	0	\N	0	0	\N	\N	0	235893	0	23426006	4052083		
49224	4497	46235214	2008-06-09	2008-06-09 00:00:00	2008-06-09	5001	0	\N	0	0	\N	\N	0	299401	0	76690-7	46235214		
38848	3589	3006451	1994-01-03	1994-01-03 00:00:00	1994-01-03	5001	0	\N	0	0	\N	\N	0	238450	0	6273-7	3006451		
3407	332	3036780	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	22053	0	6095-4	3036780		
23286	2141	40769189	1970-07-14	1970-07-14 00:00:00	1970-07-14	5001	0	\N	0	0	\N	\N	0	142640	0	66529-9	40769189		
23851	2189	3027231	2013-08-21	2013-08-21 00:00:00	2013-08-21	5001	0	\N	0	0	\N	\N	0	145935	0	6276-0	3027231		
42721	3956	3049273	2013-02-25	2013-02-25 00:00:00	2013-02-25	5001	0	\N	0	0	\N	\N	0	262908	0	38265-5	3049273		
43577	4026	3021226	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	267614	0	6246-3	3021226		
71105	2176	4024958	1991-09-13	1991-09-13 00:00:00	1991-09-13	5001	0	\N	0	0	\N	\N	0	145107	0	117015009	4024958		
6036	563	3021226	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	37291	0	6246-3	3021226		
151181	4633	4052083	1961-08-12	1961-08-12 00:00:00	1961-08-12	5001	0	\N	0	0	\N	\N	0	308746	0	23426006	4052083		
21077	1954	46235214	1967-05-22	1967-05-22 00:00:00	1967-05-22	5001	0	\N	0	0	\N	\N	0	130010	0	76690-7	46235214		
5180	499	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	33371	0	6273-7	3006451		
33881	3080	3006322	1978-12-08	1978-12-08 00:00:00	1978-12-08	5001	0	\N	0	0	\N	\N	0	205015	0	8331-1	3006322		
43883	4052	3006734	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	269343	0	6189-5	3006734		
25197	2318	3006322	1999-03-09	1999-03-09 00:00:00	1999-03-09	5001	0	\N	0	0	\N	\N	0	154095	0	8331-1	3006322		
56344	5172	3006322	1963-07-22	1963-07-22 00:00:00	1963-07-22	5001	0	\N	0	0	\N	\N	0	343851	0	8331-1	3006322		
22261	2044	40766240	1963-04-12	1963-04-12 00:00:00	1963-04-12	5001	0	\N	0	0	\N	\N	0	135954	0	63513-6	40766240		
29846	2750	3006322	1959-07-16	1959-07-16 00:00:00	1959-07-16	5001	0	\N	0	0	\N	\N	0	181945	0	8331-1	3006322		
37927	1176	4052083	1981-07-29	1981-07-29 00:00:00	1981-07-29	5001	0	\N	0	0	\N	\N	0	77652	0	23426006	4052083		
142520	4379	4052083	1997-07-08	1997-07-08 00:00:00	1997-07-08	5001	0	\N	0	0	\N	\N	0	290941	0	23426006	4052083		
115206	3553	4024958	1984-08-13	1984-08-13 00:00:00	1984-08-13	5001	0	\N	0	0	\N	\N	0	235876	0	117015009	4024958		
49225	4497	40766240	2008-06-09	2008-06-09 00:00:00	2008-06-09	5001	0	\N	0	0	\N	\N	0	299401	0	63513-6	40766240		
38849	3589	3027231	1994-01-03	1994-01-03 00:00:00	1994-01-03	5001	0	\N	0	0	\N	\N	0	238450	0	6276-0	3027231		
3408	332	3027231	1990-01-05	1990-01-05 00:00:00	1990-01-05	5001	0	\N	0	0	\N	\N	0	22053	0	6276-0	3027231		
23287	2141	40769194	1970-07-14	1970-07-14 00:00:00	1970-07-14	5001	0	\N	0	0	\N	\N	0	142640	0	66534-9	40769194		
23852	2189	3014599	2013-08-21	2013-08-21 00:00:00	2013-08-21	5001	0	\N	0	0	\N	\N	0	145935	0	6106-9	3014599		
42722	3956	3006322	1930-01-01	1930-01-01 00:00:00	1930-01-01	5001	0	\N	0	0	\N	\N	0	263027	0	8331-1	3006322		
43578	4026	3006451	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	267614	0	6273-7	3006451		
71112	2176	4024958	1956-11-20	1956-11-20 00:00:00	1956-11-20	5001	0	\N	0	0	\N	\N	0	145106	0	117015009	4024958		
6037	563	3001488	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	37291	0	7258-7	3001488		
151183	4633	4052083	1991-08-03	1991-08-03 00:00:00	1991-08-03	5001	0	\N	0	0	\N	\N	0	308805	0	23426006	4052083		
21079	1954	3051031	1967-05-22	1967-05-22 00:00:00	1967-05-22	5001	0	\N	0	0	\N	\N	0	130010	0	46240-8	3051031		
5181	499	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	33371	0	6106-9	3014599		
33882	3080	3006322	2019-01-19	2019-01-19 00:00:00	2019-01-19	5001	0	\N	0	0	\N	\N	0	204994	0	8331-1	3006322		
43884	4052	3021226	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	269343	0	6246-3	3021226		
25198	2318	3006322	1964-01-24	1964-01-24 00:00:00	1964-01-24	5001	0	\N	0	0	\N	\N	0	154040	0	8331-1	3006322		
56345	5172	3006322	2001-11-09	2001-11-09 00:00:00	2001-11-09	5001	0	\N	0	0	\N	\N	0	343827	0	8331-1	3006322		
22262	2044	3051031	1963-04-12	1963-04-12 00:00:00	1963-04-12	5001	0	\N	0	0	\N	\N	0	135954	0	46240-8	3051031		
29847	2750	3006322	1973-09-25	1973-09-25 00:00:00	1973-09-25	5001	0	\N	0	0	\N	\N	0	181888	0	8331-1	3006322		
164038	5039	4052083	2019-02-11	2019-02-11 00:00:00	2019-02-11	5001	0	\N	0	0	\N	\N	0	334895	0	23426006	4052083		
142532	4380	4024958	1994-06-08	1994-06-08 00:00:00	1994-06-08	5001	0	\N	0	0	\N	\N	0	291041	0	117015009	4024958		
69784	2138	4052083	1972-12-05	1972-12-05 00:00:00	1972-12-05	5001	0	\N	0	0	\N	\N	0	142430	0	23426006	4052083		
143235	4401	4024958	1974-03-13	1974-03-13 00:00:00	1974-03-13	5001	0	\N	0	0	\N	\N	0	292544	0	117015009	4024958		
38850	3589	3006322	1990-10-13	1990-10-13 00:00:00	1990-10-13	5001	0	\N	0	0	\N	\N	0	238428	0	8331-1	3006322		
3409	332	3006322	1988-03-27	1988-03-27 00:00:00	1988-03-27	5001	0	\N	0	0	\N	\N	0	21998	0	8331-1	3006322		
23288	2141	40769184	1970-07-14	1970-07-14 00:00:00	1970-07-14	5001	0	\N	0	0	\N	\N	0	142640	0	66524-0	40769184		
23853	2189	3020655	2013-08-21	2013-08-21 00:00:00	2013-08-21	5001	0	\N	0	0	\N	\N	0	145935	0	6844-5	3020655		
42723	3956	3006322	1995-08-24	1995-08-24 00:00:00	1995-08-24	5001	0	\N	0	0	\N	\N	0	262964	0	8331-1	3006322		
43579	4027	3006322	1989-02-26	1989-02-26 00:00:00	1989-02-26	5001	0	\N	0	0	\N	\N	0	267834	0	8331-1	3006322		
71120	2177	4052083	1971-04-16	1971-04-16 00:00:00	1971-04-16	5001	0	\N	0	0	\N	\N	0	145187	0	23426006	4052083		
6038	563	3006734	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	37291	0	6189-5	3006734		
151187	4633	4024958	1973-07-12	1973-07-12 00:00:00	1973-07-12	5001	0	\N	0	0	\N	\N	0	308740	0	117015009	4024958		
21081	1954	40758406	1967-05-22	1967-05-22 00:00:00	1967-05-22	5001	0	\N	0	0	\N	\N	0	130010	0	55277-8	40758406		
5182	499	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	33371	0	6075-6	3005136		
33883	3080	3006322	1991-05-16	1991-05-16 00:00:00	1991-05-16	5001	0	\N	0	0	\N	\N	0	205016	0	8331-1	3006322		
43885	4052	3005136	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	269343	0	6075-6	3005136		
25199	2318	3006322	1987-12-16	1987-12-16 00:00:00	1987-12-16	5001	0	\N	0	0	\N	\N	0	154042	0	8331-1	3006322		
56346	5172	3006322	1957-01-13	1957-01-13 00:00:00	1957-01-13	5001	0	\N	0	0	\N	\N	0	343850	0	8331-1	3006322		
22264	2044	3051031	1963-11-08	1963-11-08 00:00:00	1963-11-08	5001	0	\N	0	0	\N	\N	0	136026	0	46240-8	3051031		
29848	2750	3006322	1999-02-05	1999-02-05 00:00:00	1999-02-05	5001	0	\N	0	0	\N	\N	0	181957	0	8331-1	3006322		
164044	5039	4024958	1999-08-28	1999-08-28 00:00:00	1999-08-28	5001	0	\N	0	0	\N	\N	0	334894	0	117015009	4024958		
142550	4380	4024958	1986-04-28	1986-04-28 00:00:00	1986-04-28	5001	0	\N	0	0	\N	\N	0	291021	0	117015009	4024958		
69787	2138	4024958	1968-10-25	1968-10-25 00:00:00	1968-10-25	5001	0	\N	0	0	\N	\N	0	142419	0	117015009	4024958		
143239	4401	4052083	2011-05-25	2011-05-25 00:00:00	2011-05-25	5001	0	\N	0	0	\N	\N	0	292539	0	23426006	4052083		
38851	3589	3021226	1981-08-09	1981-08-09 00:00:00	1981-08-09	5001	0	\N	0	0	\N	\N	0	238475	0	6246-3	3021226		
3410	332	3023430	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	21887	0	6833-8	3023430		
23289	2141	3006322	1973-10-24	1973-10-24 00:00:00	1973-10-24	5001	0	\N	0	0	\N	\N	0	142661	0	8331-1	3006322		
23854	2189	3006734	2013-08-21	2013-08-21 00:00:00	2013-08-21	5001	0	\N	0	0	\N	\N	0	145935	0	6189-5	3006734		
42724	3956	3006322	1934-08-20	1934-08-20 00:00:00	1934-08-20	5001	0	\N	0	0	\N	\N	0	262972	0	8331-1	3006322		
43580	4027	3006322	1991-05-31	1991-05-31 00:00:00	1991-05-31	5001	0	\N	0	0	\N	\N	0	267839	0	8331-1	3006322		
71130	2177	4052083	1969-07-13	1969-07-13 00:00:00	1969-07-13	5001	0	\N	0	0	\N	\N	0	145214	0	23426006	4052083		
6039	563	3023430	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	37291	0	6833-8	3023430		
151197	4634	4024958	1989-06-30	1989-06-30 00:00:00	1989-06-30	5001	0	\N	0	0	\N	\N	0	308878	0	117015009	4024958		
21083	1954	40766240	1967-11-18	1967-11-18 00:00:00	1967-11-18	5001	0	\N	0	0	\N	\N	0	130012	0	63513-6	40766240		
5183	499	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	33371	0	7258-7	3001488		
33884	3080	3006322	1997-05-22	1997-05-22 00:00:00	1997-05-22	5001	0	\N	0	0	\N	\N	0	205019	0	8331-1	3006322		
43886	4052	3023430	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	269343	0	6833-8	3023430		
25200	2318	3006322	1967-01-17	1967-01-17 00:00:00	1967-01-17	5001	0	\N	0	0	\N	\N	0	154041	0	8331-1	3006322		
56347	5172	3006322	1946-03-31	1946-03-31 00:00:00	1946-03-31	5001	0	\N	0	0	\N	\N	0	343825	0	8331-1	3006322		
22265	2044	40766240	1963-11-08	1963-11-08 00:00:00	1963-11-08	5001	0	\N	0	0	\N	\N	0	136026	0	63513-6	40766240		
29849	2750	3006322	1943-12-24	1943-12-24 00:00:00	1943-12-24	5001	0	\N	0	0	\N	\N	0	181883	0	8331-1	3006322		
164045	5039	4052083	2014-04-13	2014-04-13 00:00:00	2014-04-13	5001	0	\N	0	0	\N	\N	0	334858	0	23426006	4052083		
4759	452	3006322	2003-08-28	2003-08-28 00:00:00	2003-08-28	5001	0	\N	0	0	\N	\N	0	30105	0	8331-1	3006322		
104246	3208	4024958	2004-01-19	2004-01-19 00:00:00	2004-01-19	5001	0	\N	0	0	\N	\N	0	213273	0	117015009	4024958		
143258	4403	4133840	2000-07-15	2000-07-15 00:00:00	2000-07-15	5001	0	\N	0	0	\N	\N	0	292650	0	127783003	4133840		
38852	3589	3005136	1981-08-09	1981-08-09 00:00:00	1981-08-09	5001	0	\N	0	0	\N	\N	0	238475	0	6075-6	3005136		
3411	332	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	21887	0	6246-3	3021226		
23290	2141	3006322	2004-07-25	2004-07-25 00:00:00	2004-07-25	5001	0	\N	0	0	\N	\N	0	142663	0	8331-1	3006322		
23855	2189	3023430	2013-08-21	2013-08-21 00:00:00	2013-08-21	5001	0	\N	0	0	\N	\N	0	145935	0	6833-8	3023430		
42725	3956	3000963	1996-10-18	1996-10-18 00:00:00	1996-10-18	5001	0	\N	0	0	\N	\N	0	262965	0	718-7	3000963		
43581	4027	3006322	1976-10-05	1976-10-05 00:00:00	1976-10-05	5001	0	\N	0	0	\N	\N	0	267896	0	8331-1	3006322		
71137	2177	4024958	1985-07-20	1985-07-20 00:00:00	1985-07-20	5001	0	\N	0	0	\N	\N	0	145215	0	117015009	4024958		
6040	563	3027231	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	37291	0	6276-0	3027231		
151198	4634	4024958	1988-04-20	1988-04-20 00:00:00	1988-04-20	5001	0	\N	0	0	\N	\N	0	308822	0	117015009	4024958		
21084	1954	46235214	1967-11-18	1967-11-18 00:00:00	1967-11-18	5001	0	\N	0	0	\N	\N	0	130012	0	76690-7	46235214		
5184	499	3021226	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	33371	0	6246-3	3021226		
33885	3080	3049273	2014-10-02	2014-10-02 00:00:00	2014-10-02	5001	0	\N	0	0	\N	\N	0	205010	0	38265-5	3049273		
43887	4052	3001247	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	269343	0	6085-5	3001247		
25201	2318	3028833	1969-03-09	1969-03-09 00:00:00	1969-03-09	5001	0	\N	0	0	\N	\N	0	154115	0	42719-5	3028833		
56348	5172	3006322	1990-04-26	1990-04-26 00:00:00	1990-04-26	5001	0	\N	0	0	\N	\N	0	343880	0	8331-1	3006322		
22268	2044	46235214	1963-11-08	1963-11-08 00:00:00	1963-11-08	5001	0	\N	0	0	\N	\N	0	136026	0	76690-7	46235214		
29850	2750	3006322	2007-09-17	2007-09-17 00:00:00	2007-09-17	5001	0	\N	0	0	\N	\N	0	181959	0	8331-1	3006322		
164046	5039	4024958	1979-12-27	1979-12-27 00:00:00	1979-12-27	5001	0	\N	0	0	\N	\N	0	334860	0	117015009	4024958		
4760	452	3006322	1973-03-17	1973-03-17 00:00:00	1973-03-17	5001	0	\N	0	0	\N	\N	0	30085	0	8331-1	3006322		
104265	3211	4024958	1966-02-22	1966-02-22 00:00:00	1966-02-22	5001	0	\N	0	0	\N	\N	0	213314	0	117015009	4024958		
143264	4403	4133840	1991-05-25	1991-05-25 00:00:00	1991-05-25	5001	0	\N	0	0	\N	\N	0	292732	0	127783003	4133840		
38853	3589	3012494	1981-08-09	1981-08-09 00:00:00	1981-08-09	5001	0	\N	0	0	\N	\N	0	238475	0	6206-7	3012494		
3412	332	3020655	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	21887	0	6844-5	3020655		
23291	2141	3006322	1956-07-26	1956-07-26 00:00:00	1956-07-26	5001	0	\N	0	0	\N	\N	0	142649	0	8331-1	3006322		
23856	2189	3021226	2013-08-21	2013-08-21 00:00:00	2013-08-21	5001	0	\N	0	0	\N	\N	0	145935	0	6246-3	3021226		
42726	3956	3009542	1996-10-18	1996-10-18 00:00:00	1996-10-18	5001	0	\N	0	0	\N	\N	0	262965	0	20570-8	3009542		
43582	4027	3006322	1986-03-30	1986-03-30 00:00:00	1986-03-30	5001	0	\N	0	0	\N	\N	0	267833	0	8331-1	3006322		
140309	4325	4024958	1969-12-10	1969-12-10 00:00:00	1969-12-10	5001	0	\N	0	0	\N	\N	0	286935	0	117015009	4024958		
6041	563	3014599	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	37291	0	6106-9	3014599		
151204	4634	4024958	1980-11-17	1980-11-17 00:00:00	1980-11-17	5001	0	\N	0	0	\N	\N	0	308831	0	117015009	4024958		
21087	1954	3051031	1967-11-18	1967-11-18 00:00:00	1967-11-18	5001	0	\N	0	0	\N	\N	0	130012	0	46240-8	3051031		
5185	499	3006322	2002-04-27	2002-04-27 00:00:00	2002-04-27	5001	0	\N	0	0	\N	\N	0	33396	0	8331-1	3006322		
33886	3080	3006322	1998-03-27	1998-03-27 00:00:00	1998-03-27	5001	0	\N	0	0	\N	\N	0	205060	0	8331-1	3006322		
43888	4052	3020655	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	269343	0	6844-5	3020655		
25202	2318	3024561	1969-03-09	1969-03-09 00:00:00	1969-03-09	5001	0	\N	0	0	\N	\N	0	154115	0	1751-7	3024561		
56351	5174	3006322	2000-06-18	2000-06-18 00:00:00	2000-06-18	5001	0	\N	0	0	\N	\N	0	344017	0	8331-1	3006322		
22269	2044	40758406	1963-11-08	1963-11-08 00:00:00	1963-11-08	5001	0	\N	0	0	\N	\N	0	136026	0	55277-8	40758406		
29851	2750	3006322	2007-11-28	2007-11-28 00:00:00	2007-11-28	5001	0	\N	0	0	\N	\N	0	181923	0	8331-1	3006322		
164067	5041	4024958	1972-01-20	1972-01-20 00:00:00	1972-01-20	5001	0	\N	0	0	\N	\N	0	334948	0	117015009	4024958		
4761	452	3006322	1998-09-02	1998-09-02 00:00:00	1998-09-02	5001	0	\N	0	0	\N	\N	0	30126	0	8331-1	3006322		
104266	3211	4024958	2009-03-31	2009-03-31 00:00:00	2009-03-31	5001	0	\N	0	0	\N	\N	0	213333	0	117015009	4024958		
154077	4724	4052083	2005-06-13	2005-06-13 00:00:00	2005-06-13	5001	0	\N	0	0	\N	\N	0	314718	0	23426006	4052083		
38854	3589	3014599	1981-08-09	1981-08-09 00:00:00	1981-08-09	5001	0	\N	0	0	\N	\N	0	238475	0	6106-9	3014599		
3413	332	3006734	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	21887	0	6189-5	3006734		
23292	2141	3006322	1955-10-20	1955-10-20 00:00:00	1955-10-20	5001	0	\N	0	0	\N	\N	0	142611	0	8331-1	3006322		
23857	2189	3019406	2013-08-21	2013-08-21 00:00:00	2013-08-21	5001	0	\N	0	0	\N	\N	0	145935	0	6158-0	3019406		
42727	3956	3006322	2014-11-05	2014-11-05 00:00:00	2014-11-05	5001	0	\N	0	0	\N	\N	0	263001	0	8331-1	3006322		
43583	4027	3006322	2014-05-25	2014-05-25 00:00:00	2014-05-25	5001	0	\N	0	0	\N	\N	0	267802	0	8331-1	3006322		
140313	4325	4024958	1979-08-01	1979-08-01 00:00:00	1979-08-01	5001	0	\N	0	0	\N	\N	0	286887	0	117015009	4024958		
6042	563	3006451	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	37291	0	6273-7	3006451		
151206	4634	4024958	2006-02-12	2006-02-12 00:00:00	2006-02-12	5001	0	\N	0	0	\N	\N	0	308880	0	117015009	4024958		
21088	1954	40758406	1967-11-18	1967-11-18 00:00:00	1967-11-18	5001	0	\N	0	0	\N	\N	0	130012	0	55277-8	40758406		
5186	499	3006322	2006-04-20	2006-04-20 00:00:00	2006-04-20	5001	0	\N	0	0	\N	\N	0	33304	0	8331-1	3006322		
33889	3081	46235214	1999-04-10	1999-04-10 00:00:00	1999-04-10	5001	0	\N	0	0	\N	\N	0	205160	0	76690-7	46235214		
43889	4052	3001488	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	269343	0	7258-7	3001488		
25203	2318	3000963	1969-03-09	1969-03-09 00:00:00	1969-03-09	5001	0	\N	0	0	\N	\N	0	154115	0	718-7	3000963		
56352	5174	3006322	1947-01-07	1947-01-07 00:00:00	1947-01-07	5001	0	\N	0	0	\N	\N	0	344022	0	8331-1	3006322		
45413	4194	3006322	1976-08-28	1976-08-28 00:00:00	1976-08-28	5001	0	\N	0	0	\N	\N	0	278369	0	8331-1	3006322		
29853	2750	3049273	1993-08-11	1993-08-11 00:00:00	1993-08-11	5001	0	\N	0	0	\N	\N	0	181919	0	38265-5	3049273		
164068	5041	4024958	1981-08-22	1981-08-22 00:00:00	1981-08-22	5001	0	\N	0	0	\N	\N	0	334949	0	117015009	4024958		
4762	452	3006322	1993-06-21	1993-06-21 00:00:00	1993-06-21	5001	0	\N	0	0	\N	\N	0	30138	0	8331-1	3006322		
104285	3211	4024958	1998-04-19	1998-04-19 00:00:00	1998-04-19	5001	0	\N	0	0	\N	\N	0	213367	0	117015009	4024958		
165401	5079	4024958	1991-12-28	1991-12-28 00:00:00	1991-12-28	5001	0	\N	0	0	\N	\N	0	337689	0	117015009	4024958		
38855	3589	3000876	1981-08-09	1981-08-09 00:00:00	1981-08-09	5001	0	\N	0	0	\N	\N	0	238475	0	6082-2	3000876		
3414	332	3006451	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	21887	0	6273-7	3006451		
23299	2145	3006322	1968-06-30	1968-06-30 00:00:00	1968-06-30	5001	0	\N	0	0	\N	\N	0	142789	0	8331-1	3006322		
23858	2189	3001488	2013-08-21	2013-08-21 00:00:00	2013-08-21	5001	0	\N	0	0	\N	\N	0	145935	0	7258-7	3001488		
42728	3956	3006322	2004-12-13	2004-12-13 00:00:00	2004-12-13	5001	0	\N	0	0	\N	\N	0	262966	0	8331-1	3006322		
43584	4027	3006322	1976-08-25	1976-08-25 00:00:00	1976-08-25	5001	0	\N	0	0	\N	\N	0	267868	0	8331-1	3006322		
140320	4325	4052083	2012-02-04	2012-02-04 00:00:00	2012-02-04	5001	0	\N	0	0	\N	\N	0	286927	0	23426006	4052083		
6043	563	3015076	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	37291	0	6248-9	3015076		
151207	4634	4024958	1976-11-27	1976-11-27 00:00:00	1976-11-27	5001	0	\N	0	0	\N	\N	0	308877	0	117015009	4024958		
21090	1954	3051031	1937-03-30	1937-03-30 00:00:00	1937-03-30	5001	0	\N	0	0	\N	\N	0	130032	0	46240-8	3051031		
5187	499	40769184	1959-10-31	1959-10-31 00:00:00	1959-10-31	5001	0	\N	0	0	\N	\N	0	33343	0	66524-0	40769184		
42370	1309	4024958	1989-09-02	1989-09-02 00:00:00	1989-09-02	5001	0	\N	0	0	\N	\N	0	86443	0	117015009	4024958		
43890	4052	3000876	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	269343	0	6082-2	3000876		
25204	2318	3014576	1969-03-09	1969-03-09 00:00:00	1969-03-09	5001	0	\N	0	0	\N	\N	0	154115	0	2075-0	3014576		
56353	5174	3006322	1955-09-04	1955-09-04 00:00:00	1955-09-04	5001	0	\N	0	0	\N	\N	0	343968	0	8331-1	3006322		
45414	4194	3006322	2005-04-23	2005-04-23 00:00:00	2005-04-23	5001	0	\N	0	0	\N	\N	0	278384	0	8331-1	3006322		
29856	2752	3006322	1998-04-21	1998-04-21 00:00:00	1998-04-21	5001	0	\N	0	0	\N	\N	0	182062	0	8331-1	3006322		
164073	5041	4024958	1976-12-05	1976-12-05 00:00:00	1976-12-05	5001	0	\N	0	0	\N	\N	0	334915	0	117015009	4024958		
4763	452	3006322	2019-04-17	2019-04-17 00:00:00	2019-04-17	5001	0	\N	0	0	\N	\N	0	30128	0	8331-1	3006322		
104287	3211	4024958	1972-02-29	1972-02-29 00:00:00	1972-02-29	5001	0	\N	0	0	\N	\N	0	213315	0	117015009	4024958		
8980	859	3023430	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	56795	0	6833-8	3023430		
38856	3589	3027231	1981-08-09	1981-08-09 00:00:00	1981-08-09	5001	0	\N	0	0	\N	\N	0	238475	0	6276-0	3027231		
3415	332	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	21887	0	6158-0	3019406		
23300	2145	3006322	1971-05-30	1971-05-30 00:00:00	1971-05-30	5001	0	\N	0	0	\N	\N	0	142790	0	8331-1	3006322		
23859	2189	3001247	2013-08-21	2013-08-21 00:00:00	2013-08-21	5001	0	\N	0	0	\N	\N	0	145935	0	6085-5	3001247		
42729	3956	3006322	1987-08-25	1987-08-25 00:00:00	1987-08-25	5001	0	\N	0	0	\N	\N	0	262998	0	8331-1	3006322		
43585	4027	3006322	2017-06-19	2017-06-19 00:00:00	2017-06-19	5001	0	\N	0	0	\N	\N	0	267827	0	8331-1	3006322		
140324	4325	4052083	1986-05-21	1986-05-21 00:00:00	1986-05-21	5001	0	\N	0	0	\N	\N	0	286895	0	23426006	4052083		
6044	563	3036780	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	37291	0	6095-4	3036780		
144819	4447	4052083	2015-01-05	2015-01-05 00:00:00	2015-01-05	5001	0	\N	0	0	\N	\N	0	295735	0	23426006	4052083		
21092	1954	40758406	1937-03-30	1937-03-30 00:00:00	1937-03-30	5001	0	\N	0	0	\N	\N	0	130032	0	55277-8	40758406		
5188	499	40769194	1959-10-31	1959-10-31 00:00:00	1959-10-31	5001	0	\N	0	0	\N	\N	0	33343	0	66534-9	40769194		
42373	1309	4024958	1973-12-18	1973-12-18 00:00:00	1973-12-18	5001	0	\N	0	0	\N	\N	0	86453	0	117015009	4024958		
43891	4052	3036780	1993-07-08	1993-07-08 00:00:00	1993-07-08	5001	0	\N	0	0	\N	\N	0	269343	0	6095-4	3036780		
25205	2318	3010813	1969-03-09	1969-03-09 00:00:00	1969-03-09	5001	0	\N	0	0	\N	\N	0	154115	0	26464-8	3010813		
56354	5174	3049273	1997-03-27	1997-03-27 00:00:00	1997-03-27	5001	0	\N	0	0	\N	\N	0	344008	0	38265-5	3049273		
45415	4194	3006322	1984-04-03	1984-04-03 00:00:00	1984-04-03	5001	0	\N	0	0	\N	\N	0	278370	0	8331-1	3006322		
29857	2752	3006322	2008-06-09	2008-06-09 00:00:00	2008-06-09	5001	0	\N	0	0	\N	\N	0	182063	0	8331-1	3006322		
164075	5041	4024958	1983-07-24	1983-07-24 00:00:00	1983-07-24	5001	0	\N	0	0	\N	\N	0	334951	0	117015009	4024958		
4764	452	3006322	1989-02-02	1989-02-02 00:00:00	1989-02-02	5001	0	\N	0	0	\N	\N	0	30137	0	8331-1	3006322		
8305	784	3051031	1971-05-29	1971-05-29 00:00:00	1971-05-29	5001	0	\N	0	0	\N	\N	0	52218	0	46240-8	3051031		
8981	859	3020655	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	56795	0	6844-5	3020655		
38857	3589	3006451	1981-08-09	1981-08-09 00:00:00	1981-08-09	5001	0	\N	0	0	\N	\N	0	238475	0	6273-7	3006451		
3416	332	3001247	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	21887	0	6085-5	3001247		
23301	2145	3006322	2016-12-04	2016-12-04 00:00:00	2016-12-04	5001	0	\N	0	0	\N	\N	0	142837	0	8331-1	3006322		
23860	2189	3015076	2013-08-21	2013-08-21 00:00:00	2013-08-21	5001	0	\N	0	0	\N	\N	0	145935	0	6248-9	3015076		
42730	3957	3011505	2008-09-18	2008-09-18 00:00:00	2008-09-18	5001	0	\N	0	0	\N	\N	0	263079	0	19926-5	3011505		
43586	4027	3000876	1975-02-13	1975-02-13 00:00:00	1975-02-13	5001	0	\N	0	0	\N	\N	0	267867	0	6082-2	3000876		
140326	4325	4052083	1972-09-14	1972-09-14 00:00:00	1972-09-14	5001	0	\N	0	0	\N	\N	0	286936	0	23426006	4052083		
6045	563	3036780	1985-05-03	1985-05-03 00:00:00	1985-05-03	5001	0	\N	0	0	\N	\N	0	37276	0	6095-4	3036780		
144825	4447	4024958	1955-09-03	1955-09-03 00:00:00	1955-09-03	5001	0	\N	0	0	\N	\N	0	295773	0	117015009	4024958		
21093	1954	40766240	1937-03-30	1937-03-30 00:00:00	1937-03-30	5001	0	\N	0	0	\N	\N	0	130032	0	63513-6	40766240		
5189	499	40769179	1959-10-31	1959-10-31 00:00:00	1959-10-31	5001	0	\N	0	0	\N	\N	0	33343	0	66519-0	40769179		
42399	1310	4052083	1954-07-27	1954-07-27 00:00:00	1954-07-27	5001	0	\N	0	0	\N	\N	0	86573	0	23426006	4052083		
43892	4053	3006322	1971-07-10	1971-07-10 00:00:00	1971-07-10	5001	0	\N	0	0	\N	\N	0	269426	0	8331-1	3006322		
25206	2318	3015632	1969-03-09	1969-03-09 00:00:00	1969-03-09	5001	0	\N	0	0	\N	\N	0	154115	0	2028-9	3015632		
56355	5174	3006322	2015-07-11	2015-07-11 00:00:00	2015-07-11	5001	0	\N	0	0	\N	\N	0	344019	0	8331-1	3006322		
45416	4194	3006322	2003-08-08	2003-08-08 00:00:00	2003-08-08	5001	0	\N	0	0	\N	\N	0	278407	0	8331-1	3006322		
29858	2752	3008598	2004-03-04	2004-03-04 00:00:00	2004-03-04	5001	0	\N	0	0	\N	\N	0	182104	0	3024-7	3008598		
72496	2222	4024958	2008-02-10	2008-02-10 00:00:00	2008-02-10	5001	0	\N	0	0	\N	\N	0	147927	0	117015009	4024958		
4765	452	3006322	2002-02-24	2002-02-24 00:00:00	2002-02-24	5001	0	\N	0	0	\N	\N	0	30079	0	8331-1	3006322		
8306	784	40766240	1971-05-29	1971-05-29 00:00:00	1971-05-29	5001	0	\N	0	0	\N	\N	0	52218	0	63513-6	40766240		
8982	859	3006451	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	56795	0	6273-7	3006451		
38858	3589	3019406	1981-08-09	1981-08-09 00:00:00	1981-08-09	5001	0	\N	0	0	\N	\N	0	238475	0	6158-0	3019406		
3417	332	3001488	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	21887	0	7258-7	3001488		
23302	2145	3006322	1974-02-23	1974-02-23 00:00:00	1974-02-23	5001	0	\N	0	0	\N	\N	0	142813	0	8331-1	3006322		
23861	2190	3006322	1953-10-23	1953-10-23 00:00:00	1953-10-23	5001	0	\N	0	0	\N	\N	0	146026	0	8331-1	3006322		
42731	3957	3006322	1988-08-13	1988-08-13 00:00:00	1988-08-13	5001	0	\N	0	0	\N	\N	0	263101	0	8331-1	3006322		
43587	4027	3019406	1975-02-13	1975-02-13 00:00:00	1975-02-13	5001	0	\N	0	0	\N	\N	0	267867	0	6158-0	3019406		
151623	4644	4024958	1980-11-01	1980-11-01 00:00:00	1980-11-01	5001	0	\N	0	0	\N	\N	0	309688	0	117015009	4024958		
6046	563	3001247	1985-05-03	1985-05-03 00:00:00	1985-05-03	5001	0	\N	0	0	\N	\N	0	37276	0	6085-5	3001247		
144840	4447	4052083	1998-06-03	1998-06-03 00:00:00	1998-06-03	5001	0	\N	0	0	\N	\N	0	295779	0	23426006	4052083		
21094	1954	46235214	1937-03-30	1937-03-30 00:00:00	1937-03-30	5001	0	\N	0	0	\N	\N	0	130032	0	76690-7	46235214		
5190	499	40769189	1959-10-31	1959-10-31 00:00:00	1959-10-31	5001	0	\N	0	0	\N	\N	0	33343	0	66529-9	40769189		
42402	1310	4024958	1979-05-03	1979-05-03 00:00:00	1979-05-03	5001	0	\N	0	0	\N	\N	0	86563	0	117015009	4024958		
43893	4053	3006322	1994-03-07	1994-03-07 00:00:00	1994-03-07	5001	0	\N	0	0	\N	\N	0	269476	0	8331-1	3006322		
25207	2318	3013682	1969-03-09	1969-03-09 00:00:00	1969-03-09	5001	0	\N	0	0	\N	\N	0	154115	0	3094-0	3013682		
58098	1770	4024958	2017-03-21	2017-03-21 00:00:00	2017-03-21	5001	0	\N	0	0	\N	\N	0	118347	0	117015009	4024958		
45417	4194	3006322	2010-03-06	2010-03-06 00:00:00	2010-03-06	5001	0	\N	0	0	\N	\N	0	278380	0	8331-1	3006322		
29859	2752	3009201	2004-03-04	2004-03-04 00:00:00	2004-03-04	5001	0	\N	0	0	\N	\N	0	182104	0	3016-3	3009201		
72503	2222	4052083	1967-07-03	1967-07-03 00:00:00	1967-07-03	5001	0	\N	0	0	\N	\N	0	147905	0	23426006	4052083		
4766	453	3006322	1975-04-23	1975-04-23 00:00:00	1975-04-23	5001	0	\N	0	0	\N	\N	0	30179	0	8331-1	3006322		
8307	784	40758406	1971-05-29	1971-05-29 00:00:00	1971-05-29	5001	0	\N	0	0	\N	\N	0	52218	0	55277-8	40758406		
8983	859	3015076	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	56795	0	6248-9	3015076		
38859	3589	3036780	1981-08-09	1981-08-09 00:00:00	1981-08-09	5001	0	\N	0	0	\N	\N	0	238475	0	6095-4	3036780		
3418	332	3036780	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	21887	0	6095-4	3036780		
23303	2145	3006322	2013-08-09	2013-08-09 00:00:00	2013-08-09	5001	0	\N	0	0	\N	\N	0	142802	0	8331-1	3006322		
23862	2190	3006322	2000-04-18	2000-04-18 00:00:00	2000-04-18	5001	0	\N	0	0	\N	\N	0	146007	0	8331-1	3006322		
42732	3957	3011505	2000-12-28	2000-12-28 00:00:00	2000-12-28	5001	0	\N	0	0	\N	\N	0	263077	0	19926-5	3011505		
43588	4027	3012494	1975-02-13	1975-02-13 00:00:00	1975-02-13	5001	0	\N	0	0	\N	\N	0	267867	0	6206-7	3012494		
151629	4644	4052083	2007-07-31	2007-07-31 00:00:00	2007-07-31	5001	0	\N	0	0	\N	\N	0	309668	0	23426006	4052083		
6047	563	3020655	1985-05-03	1985-05-03 00:00:00	1985-05-03	5001	0	\N	0	0	\N	\N	0	37276	0	6844-5	3020655		
144843	4448	4024958	1966-01-26	1966-01-26 00:00:00	1966-01-26	5001	0	\N	0	0	\N	\N	0	295853	0	117015009	4024958		
21096	1954	3006322	1969-05-15	1969-05-15 00:00:00	1969-05-15	5001	0	\N	0	0	\N	\N	0	129949	0	8331-1	3006322		
5191	499	3019406	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	33371	0	6158-0	3019406		
42419	1310	4024958	1951-07-04	1951-07-04 00:00:00	1951-07-04	5001	0	\N	0	0	\N	\N	0	86568	0	117015009	4024958		
43894	4053	3006322	1991-07-07	1991-07-07 00:00:00	1991-07-07	5001	0	\N	0	0	\N	\N	0	269475	0	8331-1	3006322		
25208	2318	3023103	1969-03-09	1969-03-09 00:00:00	1969-03-09	5001	0	\N	0	0	\N	\N	0	154115	0	2823-3	3023103		
58100	1770	4024958	1984-03-12	1984-03-12 00:00:00	1984-03-12	5001	0	\N	0	0	\N	\N	0	118357	0	117015009	4024958		
45424	4197	3006322	2016-03-10	2016-03-10 00:00:00	2016-03-10	5001	0	\N	0	0	\N	\N	0	278509	0	8331-1	3006322		
29860	2752	3006322	1955-11-23	1955-11-23 00:00:00	1955-11-23	5001	0	\N	0	0	\N	\N	0	182109	0	8331-1	3006322		
72505	2222	4052083	1973-05-08	1973-05-08 00:00:00	1973-05-08	5001	0	\N	0	0	\N	\N	0	147929	0	23426006	4052083		
4767	453	3006322	2000-01-03	2000-01-03 00:00:00	2000-01-03	5001	0	\N	0	0	\N	\N	0	30249	0	8331-1	3006322		
8309	784	46235214	1971-05-29	1971-05-29 00:00:00	1971-05-29	5001	0	\N	0	0	\N	\N	0	52218	0	76690-7	46235214		
8984	859	3012494	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	56795	0	6206-7	3012494		
38860	3589	3015076	1981-08-09	1981-08-09 00:00:00	1981-08-09	5001	0	\N	0	0	\N	\N	0	238475	0	6248-9	3015076		
3419	332	3014599	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	21887	0	6106-9	3014599		
23305	2147	3006322	1975-12-30	1975-12-30 00:00:00	1975-12-30	5001	0	\N	0	0	\N	\N	0	142888	0	8331-1	3006322		
23863	2190	3006322	1986-03-13	1986-03-13 00:00:00	1986-03-13	5001	0	\N	0	0	\N	\N	0	146000	0	8331-1	3006322		
42734	3957	40766240	1965-11-13	1965-11-13 00:00:00	1965-11-13	5001	0	\N	0	0	\N	\N	0	263097	0	63513-6	40766240		
43589	4027	3036780	1975-02-13	1975-02-13 00:00:00	1975-02-13	5001	0	\N	0	0	\N	\N	0	267867	0	6095-4	3036780		
151648	4646	4052083	1983-09-17	1983-09-17 00:00:00	1983-09-17	5001	0	\N	0	0	\N	\N	0	309724	0	23426006	4052083		
6048	563	3012494	1985-05-03	1985-05-03 00:00:00	1985-05-03	5001	0	\N	0	0	\N	\N	0	37276	0	6206-7	3012494		
144846	4448	4024958	1965-03-17	1965-03-17 00:00:00	1965-03-17	5001	0	\N	0	0	\N	\N	0	295852	0	117015009	4024958		
21098	1954	3051031	2003-03-09	2003-03-09 00:00:00	2003-03-09	5001	0	\N	0	0	\N	\N	0	130053	0	46240-8	3051031		
39700	3689	3006322	1998-10-16	1998-10-16 00:00:00	1998-10-16	5001	0	\N	0	0	\N	\N	0	245232	0	8331-1	3006322		
53708	1626	4133840	2006-10-29	2006-10-29 00:00:00	2006-10-29	5001	0	\N	0	0	\N	\N	0	109219	0	127783003	4133840		
43895	4055	3006322	1995-02-06	1995-02-06 00:00:00	1995-02-06	5001	0	\N	0	0	\N	\N	0	269527	0	8331-1	3006322		
25209	2318	3007461	1969-03-09	1969-03-09 00:00:00	1969-03-09	5001	0	\N	0	0	\N	\N	0	154115	0	26515-7	3007461		
58142	1773	4024958	1984-12-24	1984-12-24 00:00:00	1984-12-24	5001	0	\N	0	0	\N	\N	0	118537	0	117015009	4024958		
45426	4199	3006322	1939-01-25	1939-01-25 00:00:00	1939-01-25	5001	0	\N	0	0	\N	\N	0	278678	0	8331-1	3006322		
29861	2752	3006322	1997-06-09	1997-06-09 00:00:00	1997-06-09	5001	0	\N	0	0	\N	\N	0	182037	0	8331-1	3006322		
72561	2226	4024958	1999-03-09	1999-03-09 00:00:00	1999-03-09	5001	0	\N	0	0	\N	\N	0	148120	0	117015009	4024958		
4768	453	3006322	2017-05-19	2017-05-19 00:00:00	2017-05-19	5001	0	\N	0	0	\N	\N	0	30250	0	8331-1	3006322		
8311	784	3051031	1971-07-28	1971-07-28 00:00:00	1971-07-28	5001	0	\N	0	0	\N	\N	0	52179	0	46240-8	3051031		
8985	859	3021226	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	56795	0	6246-3	3021226		
38861	3589	3001488	1981-08-09	1981-08-09 00:00:00	1981-08-09	5001	0	\N	0	0	\N	\N	0	238475	0	7258-7	3001488		
3420	332	3027231	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	21887	0	6276-0	3027231		
23306	2147	3006322	1967-02-24	1967-02-24 00:00:00	1967-02-24	5001	0	\N	0	0	\N	\N	0	142885	0	8331-1	3006322		
23864	2190	3006322	1995-06-05	1995-06-05 00:00:00	1995-06-05	5001	0	\N	0	0	\N	\N	0	146011	0	8331-1	3006322		
42735	3957	46235214	1965-11-13	1965-11-13 00:00:00	1965-11-13	5001	0	\N	0	0	\N	\N	0	263097	0	76690-7	46235214		
43590	4027	3014599	1975-02-13	1975-02-13 00:00:00	1975-02-13	5001	0	\N	0	0	\N	\N	0	267867	0	6106-9	3014599		
5980	558	3006322	1983-09-02	1983-09-02 00:00:00	1983-09-02	5001	0	\N	0	0	\N	\N	0	36985	0	8331-1	3006322		
6049	563	3019406	1985-05-03	1985-05-03 00:00:00	1985-05-03	5001	0	\N	0	0	\N	\N	0	37276	0	6158-0	3019406		
144849	4448	4024958	1994-09-16	1994-09-16 00:00:00	1994-09-16	5001	0	\N	0	0	\N	\N	0	295855	0	117015009	4024958		
21099	1954	46235214	2003-03-09	2003-03-09 00:00:00	2003-03-09	5001	0	\N	0	0	\N	\N	0	130053	0	76690-7	46235214		
39701	3689	3006322	1988-10-19	1988-10-19 00:00:00	1988-10-19	5001	0	\N	0	0	\N	\N	0	245219	0	8331-1	3006322		
53710	1626	4024958	1956-07-19	1956-07-19 00:00:00	1956-07-19	5001	0	\N	0	0	\N	\N	0	109260	0	117015009	4024958		
43896	4055	3006322	1984-08-17	1984-08-17 00:00:00	1984-08-17	5001	0	\N	0	0	\N	\N	0	269526	0	8331-1	3006322		
25210	2318	3045716	1969-03-09	1969-03-09 00:00:00	1969-03-09	5001	0	\N	0	0	\N	\N	0	154115	0	33037-3	3045716		
10835	1057	3006322	2002-03-31	2002-03-31 00:00:00	2002-03-31	5001	0	\N	0	0	\N	\N	0	69309	0	8331-1	3006322		
45427	4199	3006322	2003-08-01	2003-08-01 00:00:00	2003-08-01	5001	0	\N	0	0	\N	\N	0	278617	0	8331-1	3006322		
29862	2752	3006322	2018-09-29	2018-09-29 00:00:00	2018-09-29	5001	0	\N	0	0	\N	\N	0	182038	0	8331-1	3006322		
72565	2226	4024958	2003-11-10	2003-11-10 00:00:00	2003-11-10	5001	0	\N	0	0	\N	\N	0	148076	0	117015009	4024958		
4769	453	3006322	1977-05-22	1977-05-22 00:00:00	1977-05-22	5001	0	\N	0	0	\N	\N	0	30220	0	8331-1	3006322		
8312	784	40766240	1971-07-28	1971-07-28 00:00:00	1971-07-28	5001	0	\N	0	0	\N	\N	0	52179	0	63513-6	40766240		
8986	859	3000876	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	56795	0	6082-2	3000876		
38862	3589	3001247	1981-08-09	1981-08-09 00:00:00	1981-08-09	5001	0	\N	0	0	\N	\N	0	238475	0	6085-5	3001247		
3421	332	3005136	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	21887	0	6075-6	3005136		
23307	2147	3006322	1971-07-15	1971-07-15 00:00:00	1971-07-15	5001	0	\N	0	0	\N	\N	0	143002	0	8331-1	3006322		
23865	2190	3006322	1961-12-23	1961-12-23 00:00:00	1961-12-23	5001	0	\N	0	0	\N	\N	0	146068	0	8331-1	3006322		
42736	3957	3051031	1965-11-13	1965-11-13 00:00:00	1965-11-13	5001	0	\N	0	0	\N	\N	0	263097	0	46240-8	3051031		
43591	4027	3027231	1975-02-13	1975-02-13 00:00:00	1975-02-13	5001	0	\N	0	0	\N	\N	0	267867	0	6276-0	3027231		
5981	558	3006322	1981-11-27	1981-11-27 00:00:00	1981-11-27	5001	0	\N	0	0	\N	\N	0	36971	0	8331-1	3006322		
6050	563	3000876	1985-05-03	1985-05-03 00:00:00	1985-05-03	5001	0	\N	0	0	\N	\N	0	37276	0	6082-2	3000876		
144862	4448	4052083	1987-11-28	1987-11-28 00:00:00	1987-11-28	5001	0	\N	0	0	\N	\N	0	295845	0	23426006	4052083		
21101	1954	40766240	2003-03-09	2003-03-09 00:00:00	2003-03-09	5001	0	\N	0	0	\N	\N	0	130053	0	63513-6	40766240		
39704	3691	3006322	2000-02-13	2000-02-13 00:00:00	2000-02-13	5001	0	\N	0	0	\N	\N	0	245319	0	8331-1	3006322		
53713	1626	4133840	2001-09-30	2001-09-30 00:00:00	2001-09-30	5001	0	\N	0	0	\N	\N	0	109236	0	127783003	4133840		
43897	4055	3006322	2006-05-13	2006-05-13 00:00:00	2006-05-13	5001	0	\N	0	0	\N	\N	0	269518	0	8331-1	3006322		
25211	2318	3002385	1969-03-09	1969-03-09 00:00:00	1969-03-09	5001	0	\N	0	0	\N	\N	0	154115	0	30385-9	3002385		
10836	1057	3006322	1971-08-01	1971-08-01 00:00:00	1971-08-01	5001	0	\N	0	0	\N	\N	0	69322	0	8331-1	3006322		
45428	4199	3006322	1960-01-24	1960-01-24 00:00:00	1960-01-24	5001	0	\N	0	0	\N	\N	0	278686	0	8331-1	3006322		
29863	2752	3006322	1962-01-05	1962-01-05 00:00:00	1962-01-05	5001	0	\N	0	0	\N	\N	0	182102	0	8331-1	3006322		
72566	2226	4052083	1957-08-11	1957-08-11 00:00:00	1957-08-11	5001	0	\N	0	0	\N	\N	0	148137	0	23426006	4052083		
4770	454	3006322	1952-02-23	1952-02-23 00:00:00	1952-02-23	5001	0	\N	0	0	\N	\N	0	30345	0	8331-1	3006322		
8313	784	40758406	1971-07-28	1971-07-28 00:00:00	1971-07-28	5001	0	\N	0	0	\N	\N	0	52179	0	55277-8	40758406		
8987	859	3006322	1996-09-08	1996-09-08 00:00:00	1996-09-08	5001	0	\N	0	0	\N	\N	0	56814	0	8331-1	3006322		
38863	3589	3023430	1981-08-09	1981-08-09 00:00:00	1981-08-09	5001	0	\N	0	0	\N	\N	0	238475	0	6833-8	3023430		
3422	332	3015076	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	21887	0	6248-9	3015076		
23308	2147	3006322	1962-04-08	1962-04-08 00:00:00	1962-04-08	5001	0	\N	0	0	\N	\N	0	142928	0	8331-1	3006322		
23866	2190	3006322	1978-12-07	1978-12-07 00:00:00	1978-12-07	5001	0	\N	0	0	\N	\N	0	146005	0	8331-1	3006322		
42738	3957	40758406	1965-11-13	1965-11-13 00:00:00	1965-11-13	5001	0	\N	0	0	\N	\N	0	263097	0	55277-8	40758406		
43592	4027	3001247	1975-02-13	1975-02-13 00:00:00	1975-02-13	5001	0	\N	0	0	\N	\N	0	267867	0	6085-5	3001247		
5982	558	3006322	1977-07-08	1977-07-08 00:00:00	1977-07-08	5001	0	\N	0	0	\N	\N	0	37026	0	8331-1	3006322		
6051	563	3005136	1985-05-03	1985-05-03 00:00:00	1985-05-03	5001	0	\N	0	0	\N	\N	0	37276	0	6075-6	3005136		
144865	4448	4024958	1994-07-10	1994-07-10 00:00:00	1994-07-10	5001	0	\N	0	0	\N	\N	0	295846	0	117015009	4024958		
21102	1954	40758406	2003-03-09	2003-03-09 00:00:00	2003-03-09	5001	0	\N	0	0	\N	\N	0	130053	0	55277-8	40758406		
39705	3691	3006322	1999-01-04	1999-01-04 00:00:00	1999-01-04	5001	0	\N	0	0	\N	\N	0	245318	0	8331-1	3006322		
53714	1626	4024958	1948-08-21	1948-08-21 00:00:00	1948-08-21	5001	0	\N	0	0	\N	\N	0	109259	0	117015009	4024958		
43898	4055	3006322	2007-05-20	2007-05-20 00:00:00	2007-05-20	5001	0	\N	0	0	\N	\N	0	269510	0	8331-1	3006322		
25212	2318	3020630	1969-03-09	1969-03-09 00:00:00	1969-03-09	5001	0	\N	0	0	\N	\N	0	154115	0	2885-2	3020630		
10837	1058	3006322	1999-07-10	1999-07-10 00:00:00	1999-07-10	5001	0	\N	0	0	\N	\N	0	69394	0	8331-1	3006322		
45429	4199	3006322	1973-09-07	1973-09-07 00:00:00	1973-09-07	5001	0	\N	0	0	\N	\N	0	278613	0	8331-1	3006322		
50305	1528	4052083	1970-05-12	1970-05-12 00:00:00	1970-05-12	5001	0	\N	0	0	\N	\N	0	102210	0	23426006	4052083		
141509	4364	4052083	2019-01-08	2019-01-08 00:00:00	2019-01-08	5001	0	\N	0	0	\N	\N	0	289458	0	23426006	4052083		
4772	454	3049273	2006-02-13	2006-02-13 00:00:00	2006-02-13	5001	0	\N	0	0	\N	\N	0	30276	0	38265-5	3049273		
8315	784	46235214	1971-07-28	1971-07-28 00:00:00	1971-07-28	5001	0	\N	0	0	\N	\N	0	52179	0	76690-7	46235214		
9052	862	3006322	1991-12-20	1991-12-20 00:00:00	1991-12-20	5001	0	\N	0	0	\N	\N	0	57088	0	8331-1	3006322		
38864	3589	3020655	1981-08-09	1981-08-09 00:00:00	1981-08-09	5001	0	\N	0	0	\N	\N	0	238475	0	6844-5	3020655		
98405	3013	4052083	2005-02-22	2005-02-22 00:00:00	2005-02-22	5001	0	\N	0	0	\N	\N	0	200905	0	23426006	4052083		
23309	2147	3006322	1995-01-17	1995-01-17 00:00:00	1995-01-17	5001	0	\N	0	0	\N	\N	0	142889	0	8331-1	3006322		
23867	2190	3006322	2017-06-05	2017-06-05 00:00:00	2017-06-05	5001	0	\N	0	0	\N	\N	0	146013	0	8331-1	3006322		
42739	3957	3006322	2016-09-18	2016-09-18 00:00:00	2016-09-18	5001	0	\N	0	0	\N	\N	0	263050	0	8331-1	3006322		
43593	4027	3001488	1975-02-13	1975-02-13 00:00:00	1975-02-13	5001	0	\N	0	0	\N	\N	0	267867	0	7258-7	3001488		
5983	559	3006322	1973-04-02	1973-04-02 00:00:00	1973-04-02	5001	0	\N	0	0	\N	\N	0	37046	0	8331-1	3006322		
6052	563	3021226	1985-05-03	1985-05-03 00:00:00	1985-05-03	5001	0	\N	0	0	\N	\N	0	37276	0	6246-3	3021226		
82536	2550	4024958	1993-08-03	1993-08-03 00:00:00	1993-08-03	5001	0	\N	0	0	\N	\N	0	168789	0	117015009	4024958		
21103	1954	3006322	1982-12-22	1982-12-22 00:00:00	1982-12-22	5001	0	\N	0	0	\N	\N	0	130014	0	8331-1	3006322		
39706	3691	3049273	2011-06-23	2011-06-23 00:00:00	2011-06-23	5001	0	\N	0	0	\N	\N	0	245331	0	38265-5	3049273		
53717	1627	4052083	1970-06-28	1970-06-28 00:00:00	1970-06-28	5001	0	\N	0	0	\N	\N	0	109330	0	23426006	4052083		
43899	4055	3006322	2001-10-26	2001-10-26 00:00:00	2001-10-26	5001	0	\N	0	0	\N	\N	0	269538	0	8331-1	3006322		
25213	2318	3006322	1983-06-27	1983-06-27 00:00:00	1983-06-27	5001	0	\N	0	0	\N	\N	0	154090	0	8331-1	3006322		
10838	1058	3006322	2006-03-25	2006-03-25 00:00:00	2006-03-25	5001	0	\N	0	0	\N	\N	0	69428	0	8331-1	3006322		
45430	4199	3006322	2016-09-13	2016-09-13 00:00:00	2016-09-13	5001	0	\N	0	0	\N	\N	0	278693	0	8331-1	3006322		
77361	2372	4024958	1977-11-13	1977-11-13 00:00:00	1977-11-13	5001	0	\N	0	0	\N	\N	0	157842	0	117015009	4024958		
141512	4364	4052083	2012-11-15	2012-11-15 00:00:00	2012-11-15	5001	0	\N	0	0	\N	\N	0	289469	0	23426006	4052083		
4773	454	3006322	2017-09-04	2017-09-04 00:00:00	2017-09-04	5001	0	\N	0	0	\N	\N	0	30291	0	8331-1	3006322		
8316	784	3006322	1997-04-05	1997-04-05 00:00:00	1997-04-05	5001	0	\N	0	0	\N	\N	0	52244	0	8331-1	3006322		
9053	862	3006322	1980-10-14	1980-10-14 00:00:00	1980-10-14	5001	0	\N	0	0	\N	\N	0	57086	0	8331-1	3006322		
38865	3589	3006734	1981-08-09	1981-08-09 00:00:00	1981-08-09	5001	0	\N	0	0	\N	\N	0	238475	0	6189-5	3006734		
98408	3013	4024958	1997-09-24	1997-09-24 00:00:00	1997-09-24	5001	0	\N	0	0	\N	\N	0	200941	0	117015009	4024958		
23310	2147	3006322	1989-10-03	1989-10-03 00:00:00	1989-10-03	5001	0	\N	0	0	\N	\N	0	142944	0	8331-1	3006322		
23868	2190	3049273	2014-09-23	2014-09-23 00:00:00	2014-09-23	5001	0	\N	0	0	\N	\N	0	146083	0	38265-5	3049273		
42740	3957	3011505	2005-01-06	2005-01-06 00:00:00	2005-01-06	5001	0	\N	0	0	\N	\N	0	263103	0	19926-5	3011505		
43594	4027	3006734	1975-02-13	1975-02-13 00:00:00	1975-02-13	5001	0	\N	0	0	\N	\N	0	267867	0	6189-5	3006734		
5984	559	3006322	1988-11-06	1988-11-06 00:00:00	1988-11-06	5001	0	\N	0	0	\N	\N	0	37109	0	8331-1	3006322		
6053	563	3001488	1985-05-03	1985-05-03 00:00:00	1985-05-03	5001	0	\N	0	0	\N	\N	0	37276	0	7258-7	3001488		
82566	2551	4052083	2014-12-22	2014-12-22 00:00:00	2014-12-22	5001	0	\N	0	0	\N	\N	0	168867	0	23426006	4052083		
21104	1954	3006322	1988-05-06	1988-05-06 00:00:00	1988-05-06	5001	0	\N	0	0	\N	\N	0	130051	0	8331-1	3006322		
39707	3691	3006322	1990-05-08	1990-05-08 00:00:00	1990-05-08	5001	0	\N	0	0	\N	\N	0	245342	0	8331-1	3006322		
76896	2356	4024958	1983-01-08	1983-01-08 00:00:00	1983-01-08	5001	0	\N	0	0	\N	\N	0	156864	0	117015009	4024958		
43900	4055	3006322	1996-06-08	1996-06-08 00:00:00	1996-06-08	5001	0	\N	0	0	\N	\N	0	269528	0	8331-1	3006322		
25214	2318	3035995	1969-03-09	1969-03-09 00:00:00	1969-03-09	5001	0	\N	0	0	\N	\N	0	154115	0	6768-6	3035995		
10839	1058	3006322	1969-12-04	1969-12-04 00:00:00	1969-12-04	5001	0	\N	0	0	\N	\N	0	69445	0	8331-1	3006322		
45431	4199	40769194	1962-05-03	1962-05-03 00:00:00	1962-05-03	5001	0	\N	0	0	\N	\N	0	278681	0	66534-9	40769194		
77363	2372	4024958	1970-04-22	1970-04-22 00:00:00	1970-04-22	5001	0	\N	0	0	\N	\N	0	157824	0	117015009	4024958		
141513	4364	4052083	2007-05-28	2007-05-28 00:00:00	2007-05-28	5001	0	\N	0	0	\N	\N	0	289451	0	23426006	4052083		
4776	454	3006322	1977-11-09	1977-11-09 00:00:00	1977-11-09	5001	0	\N	0	0	\N	\N	0	30350	0	8331-1	3006322		
8318	784	3051031	1971-06-28	1971-06-28 00:00:00	1971-06-28	5001	0	\N	0	0	\N	\N	0	52199	0	46240-8	3051031		
33925	1062	4024958	1994-02-18	1994-02-18 00:00:00	1994-02-18	5001	0	\N	0	0	\N	\N	0	69652	0	117015009	4024958		
38871	3592	3006322	1967-07-31	1967-07-31 00:00:00	1967-07-31	5001	0	\N	0	0	\N	\N	0	238585	0	8331-1	3006322		
98409	3013	4024958	1984-03-13	1984-03-13 00:00:00	1984-03-13	5001	0	\N	0	0	\N	\N	0	200933	0	117015009	4024958		
23311	2147	3006322	2016-06-10	2016-06-10 00:00:00	2016-06-10	5001	0	\N	0	0	\N	\N	0	142991	0	8331-1	3006322		
23869	2191	3006322	1995-03-31	1995-03-31 00:00:00	1995-03-31	5001	0	\N	0	0	\N	\N	0	146130	0	8331-1	3006322		
42741	3957	3051031	1965-04-17	1965-04-17 00:00:00	1965-04-17	5001	0	\N	0	0	\N	\N	0	263107	0	46240-8	3051031		
43595	4027	3023430	1975-02-13	1975-02-13 00:00:00	1975-02-13	5001	0	\N	0	0	\N	\N	0	267867	0	6833-8	3023430		
5985	559	3006322	2011-02-05	2011-02-05 00:00:00	2011-02-05	5001	0	\N	0	0	\N	\N	0	37058	0	8331-1	3006322		
6054	563	3006734	1985-05-03	1985-05-03 00:00:00	1985-05-03	5001	0	\N	0	0	\N	\N	0	37276	0	6189-5	3006734		
17370	1578	3006322	1981-12-27	1981-12-27 00:00:00	1981-12-27	5001	0	\N	0	0	\N	\N	0	105956	0	8331-1	3006322		
21106	1954	40758406	1967-10-19	1967-10-19 00:00:00	1967-10-19	5001	0	\N	0	0	\N	\N	0	130049	0	55277-8	40758406		
39708	3691	3006322	2002-10-15	2002-10-15 00:00:00	2002-10-15	5001	0	\N	0	0	\N	\N	0	245343	0	8331-1	3006322		
76926	2357	4052083	1973-05-02	1973-05-02 00:00:00	1973-05-02	5001	0	\N	0	0	\N	\N	0	157094	0	23426006	4052083		
49965	1518	4052083	1997-12-24	1997-12-24 00:00:00	1997-12-24	5001	0	\N	0	0	\N	\N	0	101514	0	23426006	4052083		
25215	2318	3006923	1969-03-09	1969-03-09 00:00:00	1969-03-09	5001	0	\N	0	0	\N	\N	0	154115	0	1742-6	3006923		
10840	1058	3006322	1962-03-06	1962-03-06 00:00:00	1962-03-06	5001	0	\N	0	0	\N	\N	0	69382	0	8331-1	3006322		
45432	4199	40769184	1962-05-03	1962-05-03 00:00:00	1962-05-03	5001	0	\N	0	0	\N	\N	0	278681	0	66524-0	40769184		
77368	2372	4052083	1998-10-30	1998-10-30 00:00:00	1998-10-30	5001	0	\N	0	0	\N	\N	0	157868	0	23426006	4052083		
141515	4364	4024958	1958-08-25	1958-08-25 00:00:00	1958-08-25	5001	0	\N	0	0	\N	\N	0	289467	0	117015009	4024958		
4777	454	3006322	1937-05-21	1937-05-21 00:00:00	1937-05-21	5001	0	\N	0	0	\N	\N	0	30288	0	8331-1	3006322		
8319	784	40766240	1971-06-28	1971-06-28 00:00:00	1971-06-28	5001	0	\N	0	0	\N	\N	0	52199	0	63513-6	40766240		
33927	1062	4052083	1992-08-22	1992-08-22 00:00:00	1992-08-22	5001	0	\N	0	0	\N	\N	0	69665	0	23426006	4052083		
38872	3592	3006322	1966-05-23	1966-05-23 00:00:00	1966-05-23	5001	0	\N	0	0	\N	\N	0	238584	0	8331-1	3006322		
98414	3013	4024958	1962-12-25	1962-12-25 00:00:00	1962-12-25	5001	0	\N	0	0	\N	\N	0	200937	0	117015009	4024958		
23315	2149	3006322	1968-07-12	1968-07-12 00:00:00	1968-07-12	5001	0	\N	0	0	\N	\N	0	143124	0	8331-1	3006322		
23870	2191	3006322	1971-12-13	1971-12-13 00:00:00	1971-12-13	5001	0	\N	0	0	\N	\N	0	146086	0	8331-1	3006322		
43596	4027	3001488	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	267897	0	7258-7	3001488		
5986	559	3006322	2009-06-30	2009-06-30 00:00:00	2009-06-30	5001	0	\N	0	0	\N	\N	0	37057	0	8331-1	3006322		
6055	563	3023430	1985-05-03	1985-05-03 00:00:00	1985-05-03	5001	0	\N	0	0	\N	\N	0	37276	0	6833-8	3023430		
17371	1578	3006322	1952-01-11	1952-01-11 00:00:00	1952-01-11	5001	0	\N	0	0	\N	\N	0	105975	0	8331-1	3006322		
21108	1954	3051031	1967-10-19	1967-10-19 00:00:00	1967-10-19	5001	0	\N	0	0	\N	\N	0	130049	0	46240-8	3051031		
39718	3694	3006322	1978-02-20	1978-02-20 00:00:00	1978-02-20	5001	0	\N	0	0	\N	\N	0	245497	0	8331-1	3006322		
19767	615	4024958	2004-06-18	2004-06-18 00:00:00	2004-06-18	5001	0	\N	0	0	\N	\N	0	40905	0	117015009	4024958		
50003	1520	4024958	1982-08-31	1982-08-31 00:00:00	1982-08-31	5001	0	\N	0	0	\N	\N	0	101624	0	117015009	4024958		
1440	40	4024958	1983-09-01	1983-09-01 00:00:00	1983-09-01	5001	0	\N	0	0	\N	\N	0	2870	0	117015009	4024958		
10841	1058	3014599	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	69483	0	6106-9	3014599		
45433	4199	40769189	1962-05-03	1962-05-03 00:00:00	1962-05-03	5001	0	\N	0	0	\N	\N	0	278681	0	66529-9	40769189		
77373	2372	4024958	1975-03-10	1975-03-10 00:00:00	1975-03-10	5001	0	\N	0	0	\N	\N	0	157823	0	117015009	4024958		
141533	4365	4052083	1989-08-27	1989-08-27 00:00:00	1989-08-27	5001	0	\N	0	0	\N	\N	0	289520	0	23426006	4052083		
4778	454	3006322	1937-07-28	1937-07-28 00:00:00	1937-07-28	5001	0	\N	0	0	\N	\N	0	30319	0	8331-1	3006322		
8320	784	46235214	1971-06-28	1971-06-28 00:00:00	1971-06-28	5001	0	\N	0	0	\N	\N	0	52199	0	76690-7	46235214		
33932	1062	4052083	1973-03-16	1973-03-16 00:00:00	1973-03-16	5001	0	\N	0	0	\N	\N	0	69684	0	23426006	4052083		
38873	3592	3006322	2014-11-03	2014-11-03 00:00:00	2014-11-03	5001	0	\N	0	0	\N	\N	0	238572	0	8331-1	3006322		
109742	3386	4024958	1973-04-10	1973-04-10 00:00:00	1973-04-10	5001	0	\N	0	0	\N	\N	0	224678	0	117015009	4024958		
23316	2149	3006322	1962-12-13	1962-12-13 00:00:00	1962-12-13	5001	0	\N	0	0	\N	\N	0	143071	0	8331-1	3006322		
23871	2191	3006322	1984-01-29	1984-01-29 00:00:00	1984-01-29	5001	0	\N	0	0	\N	\N	0	146114	0	8331-1	3006322		
43597	4027	3006734	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	267897	0	6189-5	3006734		
5987	559	3006322	2005-05-11	2005-05-11 00:00:00	2005-05-11	5001	0	\N	0	0	\N	\N	0	37111	0	8331-1	3006322		
6056	563	3027231	1985-05-03	1985-05-03 00:00:00	1985-05-03	5001	0	\N	0	0	\N	\N	0	37276	0	6276-0	3027231		
17372	1578	3049273	2018-11-01	2018-11-01 00:00:00	2018-11-01	5001	0	\N	0	0	\N	\N	0	105972	0	38265-5	3049273		
21109	1954	46235214	1967-10-19	1967-10-19 00:00:00	1967-10-19	5001	0	\N	0	0	\N	\N	0	130049	0	76690-7	46235214		
39719	3694	3006322	1988-01-14	1988-01-14 00:00:00	1988-01-14	5001	0	\N	0	0	\N	\N	0	245480	0	8331-1	3006322		
19803	616	4052083	2003-07-12	2003-07-12 00:00:00	2003-07-12	5001	0	\N	0	0	\N	\N	0	41071	0	23426006	4052083		
50009	1520	4024958	1946-05-22	1946-05-22 00:00:00	1946-05-22	5001	0	\N	0	0	\N	\N	0	101712	0	117015009	4024958		
1475	40	4052083	2002-03-21	2002-03-21 00:00:00	2002-03-21	5001	0	\N	0	0	\N	\N	0	2874	0	23426006	4052083		
10842	1058	3027231	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	69483	0	6276-0	3027231		
45434	4199	40769179	1962-05-03	1962-05-03 00:00:00	1962-05-03	5001	0	\N	0	0	\N	\N	0	278681	0	66519-0	40769179		
77379	2372	4024958	1984-08-17	1984-08-17 00:00:00	1984-08-17	5001	0	\N	0	0	\N	\N	0	157825	0	117015009	4024958		
141535	4365	4052083	2005-12-09	2005-12-09 00:00:00	2005-12-09	5001	0	\N	0	0	\N	\N	0	289524	0	23426006	4052083		
4779	454	3006322	1960-12-23	1960-12-23 00:00:00	1960-12-23	5001	0	\N	0	0	\N	\N	0	30281	0	8331-1	3006322		
8321	784	40758406	1971-06-28	1971-06-28 00:00:00	1971-06-28	5001	0	\N	0	0	\N	\N	0	52199	0	55277-8	40758406		
33934	1062	4024958	1967-05-31	1967-05-31 00:00:00	1967-05-31	5001	0	\N	0	0	\N	\N	0	69649	0	117015009	4024958		
38874	3592	3006322	2017-06-29	2017-06-29 00:00:00	2017-06-29	5001	0	\N	0	0	\N	\N	0	238633	0	8331-1	3006322		
109749	3386	4024958	2012-04-06	2012-04-06 00:00:00	2012-04-06	5001	0	\N	0	0	\N	\N	0	224636	0	117015009	4024958		
23317	2149	3006322	2016-06-27	2016-06-27 00:00:00	2016-06-27	5001	0	\N	0	0	\N	\N	0	143080	0	8331-1	3006322		
23872	2191	3006322	1979-01-16	1979-01-16 00:00:00	1979-01-16	5001	0	\N	0	0	\N	\N	0	146129	0	8331-1	3006322		
43598	4027	3023430	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	267897	0	6833-8	3023430		
5988	559	3006322	1992-04-03	1992-04-03 00:00:00	1992-04-03	5001	0	\N	0	0	\N	\N	0	37055	0	8331-1	3006322		
6057	563	3014599	1985-05-03	1985-05-03 00:00:00	1985-05-03	5001	0	\N	0	0	\N	\N	0	37276	0	6106-9	3014599		
17373	1578	3006322	2013-10-23	2013-10-23 00:00:00	2013-10-23	5001	0	\N	0	0	\N	\N	0	105960	0	8331-1	3006322		
21110	1954	40766240	1967-10-19	1967-10-19 00:00:00	1967-10-19	5001	0	\N	0	0	\N	\N	0	130049	0	63513-6	40766240		
39720	3694	3006322	1996-04-14	1996-04-14 00:00:00	1996-04-14	5001	0	\N	0	0	\N	\N	0	245517	0	8331-1	3006322		
50023	1520	4052083	2002-09-22	2002-09-22 00:00:00	2002-09-22	5001	0	\N	0	0	\N	\N	0	101626	0	23426006	4052083		
1481	40	4024958	1959-07-30	1959-07-30 00:00:00	1959-07-30	5001	0	\N	0	0	\N	\N	0	2876	0	117015009	4024958		
10843	1058	3001488	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	69483	0	7258-7	3001488		
45435	4199	3006322	1945-02-03	1945-02-03 00:00:00	1945-02-03	5001	0	\N	0	0	\N	\N	0	278679	0	8331-1	3006322		
77389	2373	4052083	1956-09-16	1956-09-16 00:00:00	1956-09-16	5001	0	\N	0	0	\N	\N	0	157956	0	23426006	4052083		
141547	4365	4052083	1958-03-18	1958-03-18 00:00:00	1958-03-18	5001	0	\N	0	0	\N	\N	0	289541	0	23426006	4052083		
4780	454	3006322	1980-11-08	1980-11-08 00:00:00	1980-11-08	5001	0	\N	0	0	\N	\N	0	30268	0	8331-1	3006322		
8323	784	3006322	1959-10-01	1959-10-01 00:00:00	1959-10-01	5001	0	\N	0	0	\N	\N	0	52241	0	8331-1	3006322		
33939	1062	4052083	1981-05-11	1981-05-11 00:00:00	1981-05-11	5001	0	\N	0	0	\N	\N	0	69675	0	23426006	4052083		
38875	3593	3006322	1974-06-08	1974-06-08 00:00:00	1974-06-08	5001	0	\N	0	0	\N	\N	0	238674	0	8331-1	3006322		
109753	3386	4024958	1982-06-04	1982-06-04 00:00:00	1982-06-04	5001	0	\N	0	0	\N	\N	0	224610	0	117015009	4024958		
23318	2149	3006322	2018-04-30	2018-04-30 00:00:00	2018-04-30	5001	0	\N	0	0	\N	\N	0	143081	0	8331-1	3006322		
23873	2191	3006322	1985-02-07	1985-02-07 00:00:00	1985-02-07	5001	0	\N	0	0	\N	\N	0	146118	0	8331-1	3006322		
43599	4027	3005136	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	267897	0	6075-6	3005136		
5989	559	3006322	1973-06-16	1973-06-16 00:00:00	1973-06-16	5001	0	\N	0	0	\N	\N	0	37074	0	8331-1	3006322		
6058	563	3006451	1985-05-03	1985-05-03 00:00:00	1985-05-03	5001	0	\N	0	0	\N	\N	0	37276	0	6273-7	3006451		
17374	1578	3006322	1998-05-30	1998-05-30 00:00:00	1998-05-30	5001	0	\N	0	0	\N	\N	0	105991	0	8331-1	3006322		
21111	1954	3006322	1967-06-15	1967-06-15 00:00:00	1967-06-15	5001	0	\N	0	0	\N	\N	0	130048	0	8331-1	3006322		
39721	3695	3006451	1996-08-12	1996-08-12 00:00:00	1996-08-12	5001	0	\N	0	0	\N	\N	0	245675	0	6273-7	3006451		
50028	1520	4024958	1978-07-12	1978-07-12 00:00:00	1978-07-12	5001	0	\N	0	0	\N	\N	0	101713	0	117015009	4024958		
1483	40	4024958	1974-12-21	1974-12-21 00:00:00	1974-12-21	5001	0	\N	0	0	\N	\N	0	2879	0	117015009	4024958		
10844	1058	3020655	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	69483	0	6844-5	3020655		
45436	4199	3006322	1986-05-19	1986-05-19 00:00:00	1986-05-19	5001	0	\N	0	0	\N	\N	0	278614	0	8331-1	3006322		
77391	2373	4052083	2017-07-16	2017-07-16 00:00:00	2017-07-16	5001	0	\N	0	0	\N	\N	0	157960	0	23426006	4052083		
141555	4365	4024958	1952-01-21	1952-01-21 00:00:00	1952-01-21	5001	0	\N	0	0	\N	\N	0	289507	0	117015009	4024958		
4783	455	3051031	2019-03-15	2019-03-15 00:00:00	2019-03-15	5001	0	\N	0	0	\N	\N	0	30382	0	46240-8	3051031		
8324	784	3006322	2007-01-24	2007-01-24 00:00:00	2007-01-24	5001	0	\N	0	0	\N	\N	0	52202	0	8331-1	3006322		
33949	1062	4052083	1983-09-16	1983-09-16 00:00:00	1983-09-16	5001	0	\N	0	0	\N	\N	0	69676	0	23426006	4052083		
38876	3593	3006322	1980-06-19	1980-06-19 00:00:00	1980-06-19	5001	0	\N	0	0	\N	\N	0	238669	0	8331-1	3006322		
157753	4847	4133840	1991-06-26	1991-06-26 00:00:00	1991-06-26	5001	0	\N	0	0	\N	\N	0	322474	0	127783003	4133840		
23320	2149	40766240	1960-06-16	1960-06-16 00:00:00	1960-06-16	5001	0	\N	0	0	\N	\N	0	143059	0	63513-6	40766240		
23874	2192	3006322	1986-06-02	1986-06-02 00:00:00	1986-06-02	5001	0	\N	0	0	\N	\N	0	146180	0	8331-1	3006322		
43600	4027	3021226	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	267897	0	6246-3	3021226		
6008	563	3005136	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	37252	0	6075-6	3005136		
6059	563	3015076	1985-05-03	1985-05-03 00:00:00	1985-05-03	5001	0	\N	0	0	\N	\N	0	37276	0	6248-9	3015076		
17375	1578	3006322	1997-04-19	1997-04-19 00:00:00	1997-04-19	5001	0	\N	0	0	\N	\N	0	105957	0	8331-1	3006322		
21113	1954	40766240	2003-05-08	2003-05-08 00:00:00	2003-05-08	5001	0	\N	0	0	\N	\N	0	130002	0	63513-6	40766240		
39722	3695	3021226	1996-08-12	1996-08-12 00:00:00	1996-08-12	5001	0	\N	0	0	\N	\N	0	245675	0	6246-3	3021226		
50031	1520	4052083	1969-08-08	1969-08-08 00:00:00	1969-08-08	5001	0	\N	0	0	\N	\N	0	101633	0	23426006	4052083		
1503	41	4052083	1974-10-19	1974-10-19 00:00:00	1974-10-19	5001	0	\N	0	0	\N	\N	0	2901	0	23426006	4052083		
10845	1058	3005136	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	69483	0	6075-6	3005136		
45437	4199	3006322	1953-06-06	1953-06-06 00:00:00	1953-06-06	5001	0	\N	0	0	\N	\N	0	278683	0	8331-1	3006322		
77393	2373	4024958	1967-06-05	1967-06-05 00:00:00	1967-06-05	5001	0	\N	0	0	\N	\N	0	157885	0	117015009	4024958		
4784	455	40758406	2019-03-15	2019-03-15 00:00:00	2019-03-15	5001	0	\N	0	0	\N	\N	0	30382	0	55277-8	40758406		
8326	784	3051031	1971-08-27	1971-08-27 00:00:00	1971-08-27	5001	0	\N	0	0	\N	\N	0	52219	0	46240-8	3051031		
33952	1062	4024958	1967-01-18	1967-01-18 00:00:00	1967-01-18	5001	0	\N	0	0	\N	\N	0	69683	0	117015009	4024958		
38877	3593	3006322	1985-01-02	1985-01-02 00:00:00	1985-01-02	5001	0	\N	0	0	\N	\N	0	238670	0	8331-1	3006322		
157755	4847	4133840	1981-01-28	1981-01-28 00:00:00	1981-01-28	5001	0	\N	0	0	\N	\N	0	322415	0	127783003	4133840		
23321	2149	46235214	1960-06-16	1960-06-16 00:00:00	1960-06-16	5001	0	\N	0	0	\N	\N	0	143059	0	76690-7	46235214		
23875	2192	3006322	1959-01-16	1959-01-16 00:00:00	1959-01-16	5001	0	\N	0	0	\N	\N	0	146220	0	8331-1	3006322		
43601	4027	3006451	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	267897	0	6273-7	3006451		
6009	563	3021226	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	37252	0	6246-3	3021226		
6061	564	3011505	2005-07-14	2005-07-14 00:00:00	2005-07-14	5001	0	\N	0	0	\N	\N	0	37381	0	19926-5	3011505		
17376	1578	3006322	1972-03-04	1972-03-04 00:00:00	1972-03-04	5001	0	\N	0	0	\N	\N	0	105977	0	8331-1	3006322		
54977	1666	4052083	1951-05-20	1951-05-20 00:00:00	1951-05-20	5001	0	\N	0	0	\N	\N	0	111852	0	23426006	4052083		
39723	3695	3027231	1996-08-12	1996-08-12 00:00:00	1996-08-12	5001	0	\N	0	0	\N	\N	0	245675	0	6276-0	3027231		
50039	1520	4024958	1941-11-02	1941-11-02 00:00:00	1941-11-02	5001	0	\N	0	0	\N	\N	0	101622	0	117015009	4024958		
1504	41	4052083	1984-11-04	1984-11-04 00:00:00	1984-11-04	5001	0	\N	0	0	\N	\N	0	2903	0	23426006	4052083		
10846	1058	3021226	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	69483	0	6246-3	3021226		
45438	4199	3006322	1956-02-01	1956-02-01 00:00:00	1956-02-01	5001	0	\N	0	0	\N	\N	0	278685	0	8331-1	3006322		
77395	2373	4024958	1962-07-03	1962-07-03 00:00:00	1962-07-03	5001	0	\N	0	0	\N	\N	0	157954	0	117015009	4024958		
4785	455	40766240	2019-03-15	2019-03-15 00:00:00	2019-03-15	5001	0	\N	0	0	\N	\N	0	30382	0	63513-6	40766240		
8327	784	40766240	1971-08-27	1971-08-27 00:00:00	1971-08-27	5001	0	\N	0	0	\N	\N	0	52219	0	63513-6	40766240		
114237	3526	4024958	1986-07-16	1986-07-16 00:00:00	1986-07-16	5001	0	\N	0	0	\N	\N	0	233910	0	117015009	4024958		
38878	3593	3006322	1960-11-20	1960-11-20 00:00:00	1960-11-20	5001	0	\N	0	0	\N	\N	0	238645	0	8331-1	3006322		
157759	4847	4133840	2004-02-11	2004-02-11 00:00:00	2004-02-11	5001	0	\N	0	0	\N	\N	0	322451	0	127783003	4133840		
23322	2149	40758406	1960-06-16	1960-06-16 00:00:00	1960-06-16	5001	0	\N	0	0	\N	\N	0	143059	0	55277-8	40758406		
23876	2192	3006322	2013-09-02	2013-09-02 00:00:00	2013-09-02	5001	0	\N	0	0	\N	\N	0	146149	0	8331-1	3006322		
43602	4027	3015076	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	267897	0	6248-9	3015076		
6010	563	3027231	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	37252	0	6276-0	3027231		
6062	564	3011505	2018-09-27	2018-09-27 00:00:00	2018-09-27	5001	0	\N	0	0	\N	\N	0	37355	0	19926-5	3011505		
17377	1579	3006322	1973-11-03	1973-11-03 00:00:00	1973-11-03	5001	0	\N	0	0	\N	\N	0	106054	0	8331-1	3006322		
55007	1666	4024958	1941-07-04	1941-07-04 00:00:00	1941-07-04	5001	0	\N	0	0	\N	\N	0	111883	0	117015009	4024958		
39724	3695	3019406	1996-08-12	1996-08-12 00:00:00	1996-08-12	5001	0	\N	0	0	\N	\N	0	245675	0	6158-0	3019406		
6906	664	3023430	2014-01-28	2014-01-28 00:00:00	2014-01-28	5001	0	\N	0	0	\N	\N	0	43831	0	6833-8	3023430		
1507	41	4024958	1974-08-20	1974-08-20 00:00:00	1974-08-20	5001	0	\N	0	0	\N	\N	0	2906	0	117015009	4024958		
10847	1058	3012494	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	69483	0	6206-7	3012494		
45439	4199	3006322	1972-01-04	1972-01-04 00:00:00	1972-01-04	5001	0	\N	0	0	\N	\N	0	278687	0	8331-1	3006322		
77398	2373	4052083	1996-06-12	1996-06-12 00:00:00	1996-06-12	5001	0	\N	0	0	\N	\N	0	157940	0	23426006	4052083		
4786	455	46235214	2019-03-15	2019-03-15 00:00:00	2019-03-15	5001	0	\N	0	0	\N	\N	0	30382	0	76690-7	46235214		
8328	784	46235214	1971-08-27	1971-08-27 00:00:00	1971-08-27	5001	0	\N	0	0	\N	\N	0	52219	0	76690-7	46235214		
114256	3526	4024958	1951-10-20	1951-10-20 00:00:00	1951-10-20	5001	0	\N	0	0	\N	\N	0	233948	0	117015009	4024958		
38879	3593	3006322	1957-06-25	1957-06-25 00:00:00	1957-06-25	5001	0	\N	0	0	\N	\N	0	238644	0	8331-1	3006322		
157761	4847	4133840	2009-03-04	2009-03-04 00:00:00	2009-03-04	5001	0	\N	0	0	\N	\N	0	322452	0	127783003	4133840		
23323	2149	3051031	1960-06-16	1960-06-16 00:00:00	1960-06-16	5001	0	\N	0	0	\N	\N	0	143059	0	46240-8	3051031		
23877	2192	3006322	1996-11-16	1996-11-16 00:00:00	1996-11-16	5001	0	\N	0	0	\N	\N	0	146198	0	8331-1	3006322		
43603	4027	3027231	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	267897	0	6276-0	3027231		
156677	4816	4052083	1994-03-08	1994-03-08 00:00:00	1994-03-08	5001	0	\N	0	0	\N	\N	0	320438	0	23426006	4052083		
6063	564	3011505	2000-11-09	2000-11-09 00:00:00	2000-11-09	5001	0	\N	0	0	\N	\N	0	37353	0	19926-5	3011505		
17378	1579	3006322	1989-03-10	1989-03-10 00:00:00	1989-03-10	5001	0	\N	0	0	\N	\N	0	106089	0	8331-1	3006322		
55011	1666	4024958	1994-06-07	1994-06-07 00:00:00	1994-06-07	5001	0	\N	0	0	\N	\N	0	111945	0	117015009	4024958		
39725	3695	3036780	1996-08-12	1996-08-12 00:00:00	1996-08-12	5001	0	\N	0	0	\N	\N	0	245675	0	6095-4	3036780		
6907	664	3021226	2014-01-28	2014-01-28 00:00:00	2014-01-28	5001	0	\N	0	0	\N	\N	0	43831	0	6246-3	3021226		
1508	41	4024958	1975-04-03	1975-04-03 00:00:00	1975-04-03	5001	0	\N	0	0	\N	\N	0	2977	0	117015009	4024958		
10848	1058	3001247	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	69483	0	6085-5	3001247		
45440	4199	3006322	2012-04-25	2012-04-25 00:00:00	2012-04-25	5001	0	\N	0	0	\N	\N	0	278618	0	8331-1	3006322		
4999	153	4024958	1945-08-10	1945-08-10 00:00:00	1945-08-10	5001	0	\N	0	0	\N	\N	0	10321	0	117015009	4024958		
4788	455	3006322	1969-05-10	1969-05-10 00:00:00	1969-05-10	5001	0	\N	0	0	\N	\N	0	30377	0	8331-1	3006322		
8329	784	40758406	1971-08-27	1971-08-27 00:00:00	1971-08-27	5001	0	\N	0	0	\N	\N	0	52219	0	55277-8	40758406		
114294	3527	4024958	1971-07-03	1971-07-03 00:00:00	1971-07-03	5001	0	\N	0	0	\N	\N	0	234089	0	117015009	4024958		
38880	3593	3006322	1966-09-08	1966-09-08 00:00:00	1966-09-08	5001	0	\N	0	0	\N	\N	0	238717	0	8331-1	3006322		
157762	4847	4133840	1998-07-01	1998-07-01 00:00:00	1998-07-01	5001	0	\N	0	0	\N	\N	0	322411	0	127783003	4133840		
23325	2149	3006322	1963-12-24	1963-12-24 00:00:00	1963-12-24	5001	0	\N	0	0	\N	\N	0	143072	0	8331-1	3006322		
23878	2192	3006322	1955-10-20	1955-10-20 00:00:00	1955-10-20	5001	0	\N	0	0	\N	\N	0	146194	0	8331-1	3006322		
43604	4027	3020655	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	267897	0	6844-5	3020655		
156747	4819	4024958	1962-10-18	1962-10-18 00:00:00	1962-10-18	5001	0	\N	0	0	\N	\N	0	320510	0	117015009	4024958		
6064	564	3011505	2014-09-04	2014-09-04 00:00:00	2014-09-04	5001	0	\N	0	0	\N	\N	0	37329	0	19926-5	3011505		
17379	1579	3006322	2019-01-15	2019-01-15 00:00:00	2019-01-15	5001	0	\N	0	0	\N	\N	0	106044	0	8331-1	3006322		
55016	1666	4052083	2018-05-04	2018-05-04 00:00:00	2018-05-04	5001	0	\N	0	0	\N	\N	0	111887	0	23426006	4052083		
39726	3695	3015076	1996-08-12	1996-08-12 00:00:00	1996-08-12	5001	0	\N	0	0	\N	\N	0	245675	0	6248-9	3015076		
6908	664	3014599	2014-01-28	2014-01-28 00:00:00	2014-01-28	5001	0	\N	0	0	\N	\N	0	43831	0	6106-9	3014599		
104837	3227	4024958	2009-09-05	2009-09-05 00:00:00	2009-09-05	5001	0	\N	0	0	\N	\N	0	214525	0	117015009	4024958		
10849	1058	3023430	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	69483	0	6833-8	3023430		
45441	4200	3006322	1979-06-26	1979-06-26 00:00:00	1979-06-26	5001	0	\N	0	0	\N	\N	0	278737	0	8331-1	3006322		
42723	1316	4024958	2004-08-16	2004-08-16 00:00:00	2004-08-16	5001	0	\N	0	0	\N	\N	0	87229	0	117015009	4024958		
4789	455	3006322	1992-12-19	1992-12-19 00:00:00	1992-12-19	5001	0	\N	0	0	\N	\N	0	30379	0	8331-1	3006322		
8331	784	3006322	1972-09-03	1972-09-03 00:00:00	1972-09-03	5001	0	\N	0	0	\N	\N	0	52220	0	8331-1	3006322		
114300	3527	4024958	1975-06-28	1975-06-28 00:00:00	1975-06-28	5001	0	\N	0	0	\N	\N	0	234051	0	117015009	4024958		
38881	3593	3006322	1965-04-06	1965-04-06 00:00:00	1965-04-06	5001	0	\N	0	0	\N	\N	0	238667	0	8331-1	3006322		
157766	4847	4133840	2010-03-10	2010-03-10 00:00:00	2010-03-10	5001	0	\N	0	0	\N	\N	0	322479	0	127783003	4133840		
23326	2149	3006322	1999-05-24	1999-05-24 00:00:00	1999-05-24	5001	0	\N	0	0	\N	\N	0	143129	0	8331-1	3006322		
23879	2192	3006322	1992-01-19	1992-01-19 00:00:00	1992-01-19	5001	0	\N	0	0	\N	\N	0	146172	0	8331-1	3006322		
43605	4027	3014599	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	267897	0	6106-9	3014599		
156750	4819	4024958	1995-01-19	1995-01-19 00:00:00	1995-01-19	5001	0	\N	0	0	\N	\N	0	320578	0	117015009	4024958		
6065	564	3011505	2015-09-10	2015-09-10 00:00:00	2015-09-10	5001	0	\N	0	0	\N	\N	0	37359	0	19926-5	3011505		
17380	1579	3006322	1968-08-20	1968-08-20 00:00:00	1968-08-20	5001	0	\N	0	0	\N	\N	0	106082	0	8331-1	3006322		
55023	1666	4052083	1948-08-25	1948-08-25 00:00:00	1948-08-25	5001	0	\N	0	0	\N	\N	0	111943	0	23426006	4052083		
39727	3695	3012494	1996-08-12	1996-08-12 00:00:00	1996-08-12	5001	0	\N	0	0	\N	\N	0	245675	0	6206-7	3012494		
6909	664	3006451	2014-01-28	2014-01-28 00:00:00	2014-01-28	5001	0	\N	0	0	\N	\N	0	43831	0	6273-7	3006451		
104840	3227	4024958	1974-03-02	1974-03-02 00:00:00	1974-03-02	5001	0	\N	0	0	\N	\N	0	214529	0	117015009	4024958		
10850	1058	3036780	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	69483	0	6095-4	3036780		
45442	4200	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	278741	0	6075-6	3005136		
42725	1316	4052083	1985-06-02	1985-06-02 00:00:00	1985-06-02	5001	0	\N	0	0	\N	\N	0	87180	0	23426006	4052083		
4790	455	3006322	1981-12-19	1981-12-19 00:00:00	1981-12-19	5001	0	\N	0	0	\N	\N	0	30407	0	8331-1	3006322		
8332	785	3006322	1969-10-10	1969-10-10 00:00:00	1969-10-10	5001	0	\N	0	0	\N	\N	0	52285	0	8331-1	3006322		
104300	3212	4052083	1995-09-18	1995-09-18 00:00:00	1995-09-18	5001	0	\N	0	0	\N	\N	0	213418	0	23426006	4052083		
38886	3595	3051031	1990-11-30	1990-11-30 00:00:00	1990-11-30	5001	0	\N	0	0	\N	\N	0	238836	0	46240-8	3051031		
157767	4847	4133840	2001-07-18	2001-07-18 00:00:00	2001-07-18	5001	0	\N	0	0	\N	\N	0	322449	0	127783003	4133840		
23327	2149	3006322	1961-10-08	1961-10-08 00:00:00	1961-10-08	5001	0	\N	0	0	\N	\N	0	143070	0	8331-1	3006322		
23880	2192	3006322	1963-04-12	1963-04-12 00:00:00	1963-04-12	5001	0	\N	0	0	\N	\N	0	146195	0	8331-1	3006322		
43606	4027	3012494	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	267897	0	6206-7	3012494		
156753	4819	4052083	2002-08-20	2002-08-20 00:00:00	2002-08-20	5001	0	\N	0	0	\N	\N	0	320579	0	23426006	4052083		
6066	564	3006322	2005-07-11	2005-07-11 00:00:00	2005-07-11	5001	0	\N	0	0	\N	\N	0	37367	0	8331-1	3006322		
17381	1579	3006322	1981-12-31	1981-12-31 00:00:00	1981-12-31	5001	0	\N	0	0	\N	\N	0	106083	0	8331-1	3006322		
7802	752	40766240	1988-08-26	1988-08-26 00:00:00	1988-08-26	5001	0	\N	0	0	\N	\N	0	49656	0	63513-6	40766240		
39728	3695	3000876	1996-08-12	1996-08-12 00:00:00	1996-08-12	5001	0	\N	0	0	\N	\N	0	245675	0	6082-2	3000876		
6910	664	3027231	2014-01-28	2014-01-28 00:00:00	2014-01-28	5001	0	\N	0	0	\N	\N	0	43831	0	6276-0	3027231		
104854	3229	4024958	1999-01-15	1999-01-15 00:00:00	1999-01-15	5001	0	\N	0	0	\N	\N	0	214592	0	117015009	4024958		
10851	1058	3000876	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	69483	0	6082-2	3000876		
45443	4200	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	278741	0	6246-3	3021226		
42736	1317	4133840	2004-11-26	2004-11-26 00:00:00	2004-11-26	5001	0	\N	0	0	\N	\N	0	87310	0	127783003	4133840		
4792	455	3051031	2019-06-13	2019-06-13 00:00:00	2019-06-13	5001	0	\N	0	0	\N	\N	0	30383	0	46240-8	3051031		
8333	785	3006322	1989-04-29	1989-04-29 00:00:00	1989-04-29	5001	0	\N	0	0	\N	\N	0	52298	0	8331-1	3006322		
104310	3212	4052083	1988-07-09	1988-07-09 00:00:00	1988-07-09	5001	0	\N	0	0	\N	\N	0	213431	0	23426006	4052083		
38887	3595	40766240	1990-11-30	1990-11-30 00:00:00	1990-11-30	5001	0	\N	0	0	\N	\N	0	238836	0	63513-6	40766240		
157775	4847	4133840	1983-06-08	1983-06-08 00:00:00	1983-06-08	5001	0	\N	0	0	\N	\N	0	322416	0	127783003	4133840		
23328	2149	3006322	2006-01-04	2006-01-04 00:00:00	2006-01-04	5001	0	\N	0	0	\N	\N	0	143078	0	8331-1	3006322		
23881	2192	3006322	1992-04-28	1992-04-28 00:00:00	1992-04-28	5001	0	\N	0	0	\N	\N	0	146173	0	8331-1	3006322		
43607	4027	3001247	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	267897	0	6085-5	3001247		
19406	607	4024958	1964-09-18	1964-09-18 00:00:00	1964-09-18	5001	0	\N	0	0	\N	\N	0	40322	0	117015009	4024958		
6067	564	3011505	2008-07-31	2008-07-31 00:00:00	2008-07-31	5001	0	\N	0	0	\N	\N	0	37358	0	19926-5	3011505		
17395	1585	3006322	1941-12-24	1941-12-24 00:00:00	1941-12-24	5001	0	\N	0	0	\N	\N	0	106296	0	8331-1	3006322		
7803	752	46235214	1988-08-26	1988-08-26 00:00:00	1988-08-26	5001	0	\N	0	0	\N	\N	0	49656	0	76690-7	46235214		
39729	3695	3023430	1996-08-12	1996-08-12 00:00:00	1996-08-12	5001	0	\N	0	0	\N	\N	0	245675	0	6833-8	3023430		
6911	664	3036780	2014-01-28	2014-01-28 00:00:00	2014-01-28	5001	0	\N	0	0	\N	\N	0	43831	0	6095-4	3036780		
104866	3229	4024958	2005-03-29	2005-03-29 00:00:00	2005-03-29	5001	0	\N	0	0	\N	\N	0	214608	0	117015009	4024958		
10852	1058	3019406	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	69483	0	6158-0	3019406		
45444	4200	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	278741	0	6206-7	3012494		
42743	1317	4133840	2012-01-06	2012-01-06 00:00:00	2012-01-06	5001	0	\N	0	0	\N	\N	0	87332	0	127783003	4133840		
4793	455	40758406	2019-06-13	2019-06-13 00:00:00	2019-06-13	5001	0	\N	0	0	\N	\N	0	30383	0	55277-8	40758406		
8334	785	3006322	1985-02-03	1985-02-03 00:00:00	1985-02-03	5001	0	\N	0	0	\N	\N	0	52297	0	8331-1	3006322		
104314	3212	4052083	1992-11-08	1992-11-08 00:00:00	1992-11-08	5001	0	\N	0	0	\N	\N	0	213417	0	23426006	4052083		
38888	3595	40758406	1990-11-30	1990-11-30 00:00:00	1990-11-30	5001	0	\N	0	0	\N	\N	0	238836	0	55277-8	40758406		
157777	4847	4133840	2006-02-22	2006-02-22 00:00:00	2006-02-22	5001	0	\N	0	0	\N	\N	0	322419	0	127783003	4133840		
82493	2548	4024958	2018-01-22	2018-01-22 00:00:00	2018-01-22	5001	0	\N	0	0	\N	\N	0	168712	0	117015009	4024958		
23882	2192	3006322	2013-10-15	2013-10-15 00:00:00	2013-10-15	5001	0	\N	0	0	\N	\N	0	146176	0	8331-1	3006322		
43608	4027	3000876	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	267897	0	6082-2	3000876		
19435	608	4024958	1977-10-03	1977-10-03 00:00:00	1977-10-03	5001	0	\N	0	0	\N	\N	0	40412	0	117015009	4024958		
6068	564	3011505	1998-11-05	1998-11-05 00:00:00	1998-11-05	5001	0	\N	0	0	\N	\N	0	37319	0	19926-5	3011505		
17396	1585	3006322	1942-09-30	1942-09-30 00:00:00	1942-09-30	5001	0	\N	0	0	\N	\N	0	106298	0	8331-1	3006322		
7804	752	3051031	1988-08-26	1988-08-26 00:00:00	1988-08-26	5001	0	\N	0	0	\N	\N	0	49656	0	46240-8	3051031		
39730	3695	3005136	1996-08-12	1996-08-12 00:00:00	1996-08-12	5001	0	\N	0	0	\N	\N	0	245675	0	6075-6	3005136		
6912	664	3019406	2014-01-28	2014-01-28 00:00:00	2014-01-28	5001	0	\N	0	0	\N	\N	0	43831	0	6158-0	3019406		
104872	3230	4024958	1966-12-28	1966-12-28 00:00:00	1966-12-28	5001	0	\N	0	0	\N	\N	0	214677	0	117015009	4024958		
10853	1058	3015076	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	69483	0	6248-9	3015076		
45445	4200	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	278741	0	6106-9	3014599		
42747	1317	4133840	2013-01-11	2013-01-11 00:00:00	2013-01-11	5001	0	\N	0	0	\N	\N	0	87302	0	127783003	4133840		
4794	455	40766240	2019-06-13	2019-06-13 00:00:00	2019-06-13	5001	0	\N	0	0	\N	\N	0	30383	0	63513-6	40766240		
8337	787	3006322	1988-06-14	1988-06-14 00:00:00	1988-06-14	5001	0	\N	0	0	\N	\N	0	52348	0	8331-1	3006322		
104315	3212	4052083	1987-05-30	1987-05-30 00:00:00	1987-05-30	5001	0	\N	0	0	\N	\N	0	213449	0	23426006	4052083		
38890	3595	46235214	1990-11-30	1990-11-30 00:00:00	1990-11-30	5001	0	\N	0	0	\N	\N	0	238836	0	76690-7	46235214		
157780	4847	4133840	2011-03-16	2011-03-16 00:00:00	2011-03-16	5001	0	\N	0	0	\N	\N	0	322453	0	127783003	4133840		
93803	2889	4024958	1995-02-13	1995-02-13 00:00:00	1995-02-13	5001	0	\N	0	0	\N	\N	0	192165	0	117015009	4024958		
23883	2192	3006322	1975-06-20	1975-06-20 00:00:00	1975-06-20	5001	0	\N	0	0	\N	\N	0	146208	0	8331-1	3006322		
43609	4027	3019406	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	267897	0	6158-0	3019406		
19443	609	4024958	1974-08-11	1974-08-11 00:00:00	1974-08-11	5001	0	\N	0	0	\N	\N	0	40415	0	117015009	4024958		
6069	564	3011505	2004-11-18	2004-11-18 00:00:00	2004-11-18	5001	0	\N	0	0	\N	\N	0	37380	0	19926-5	3011505		
17397	1585	3006322	1973-02-25	1973-02-25 00:00:00	1973-02-25	5001	0	\N	0	0	\N	\N	0	106273	0	8331-1	3006322		
7805	752	40758406	1988-08-26	1988-08-26 00:00:00	1988-08-26	5001	0	\N	0	0	\N	\N	0	49656	0	55277-8	40758406		
39731	3695	3014599	1996-08-12	1996-08-12 00:00:00	1996-08-12	5001	0	\N	0	0	\N	\N	0	245675	0	6106-9	3014599		
6913	664	3000876	2014-01-28	2014-01-28 00:00:00	2014-01-28	5001	0	\N	0	0	\N	\N	0	43831	0	6082-2	3000876		
116172	3579	4052083	1990-02-19	1990-02-19 00:00:00	1990-02-19	5001	0	\N	0	0	\N	\N	0	237923	0	23426006	4052083		
10854	1058	3006451	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	69483	0	6273-7	3006451		
45446	4200	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	278741	0	7258-7	3001488		
42750	1317	4133840	2002-11-15	2002-11-15 00:00:00	2002-11-15	5001	0	\N	0	0	\N	\N	0	87309	0	127783003	4133840		
4796	455	46235214	2019-06-13	2019-06-13 00:00:00	2019-06-13	5001	0	\N	0	0	\N	\N	0	30383	0	76690-7	46235214		
124861	3857	4133840	2017-07-25	2017-07-25 00:00:00	2017-07-25	5001	0	\N	0	0	\N	\N	0	256000	0	127783003	4133840		
104316	3212	4024958	2015-11-10	2015-11-10 00:00:00	2015-11-10	5001	0	\N	0	0	\N	\N	0	213422	0	117015009	4024958		
38891	3595	3006322	1996-08-09	1996-08-09 00:00:00	1996-08-09	5001	0	\N	0	0	\N	\N	0	238837	0	8331-1	3006322		
157784	4847	4133840	2007-02-28	2007-02-28 00:00:00	2007-02-28	5001	0	\N	0	0	\N	\N	0	322459	0	127783003	4133840		
93810	2889	4024958	1961-08-13	1961-08-13 00:00:00	1961-08-13	5001	0	\N	0	0	\N	\N	0	192122	0	117015009	4024958		
137147	4225	4052083	1983-11-11	1983-11-11 00:00:00	1983-11-11	5001	0	\N	0	0	\N	\N	0	280620	0	23426006	4052083		
43610	4027	3036780	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	267897	0	6095-4	3036780		
19444	609	4024958	1983-03-24	1983-03-24 00:00:00	1983-03-24	5001	0	\N	0	0	\N	\N	0	40429	0	117015009	4024958		
6070	564	3006322	1970-07-01	1970-07-01 00:00:00	1970-07-01	5001	0	\N	0	0	\N	\N	0	37313	0	8331-1	3006322		
17398	1585	3006322	1967-05-03	1967-05-03 00:00:00	1967-05-03	5001	0	\N	0	0	\N	\N	0	106299	0	8331-1	3006322		
7806	752	3006322	1962-06-04	1962-06-04 00:00:00	1962-06-04	5001	0	\N	0	0	\N	\N	0	49703	0	8331-1	3006322		
39732	3695	3006451	1981-06-13	1981-06-13 00:00:00	1981-06-13	5001	0	\N	0	0	\N	\N	0	245609	0	6273-7	3006451		
6914	664	3015076	2014-01-28	2014-01-28 00:00:00	2014-01-28	5001	0	\N	0	0	\N	\N	0	43831	0	6248-9	3015076		
116185	3579	4024958	2006-09-07	2006-09-07 00:00:00	2006-09-07	5001	0	\N	0	0	\N	\N	0	237954	0	117015009	4024958		
10855	1058	3006734	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	69483	0	6189-5	3006734		
45447	4200	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	278741	0	6844-5	3020655		
42754	1317	4133840	2007-12-14	2007-12-14 00:00:00	2007-12-14	5001	0	\N	0	0	\N	\N	0	87330	0	127783003	4133840		
4797	455	3006322	1993-11-26	1993-11-26 00:00:00	1993-11-26	5001	0	\N	0	0	\N	\N	0	30460	0	8331-1	3006322		
124862	3857	4133840	1994-01-04	1994-01-04 00:00:00	1994-01-04	5001	0	\N	0	0	\N	\N	0	256018	0	127783003	4133840		
104322	3212	4052083	1991-09-30	1991-09-30 00:00:00	1991-09-30	5001	0	\N	0	0	\N	\N	0	213401	0	23426006	4052083		
38892	3595	3051031	1990-08-02	1990-08-02 00:00:00	1990-08-02	5001	0	\N	0	0	\N	\N	0	238848	0	46240-8	3051031		
157786	4847	4133840	1997-06-25	1997-06-25 00:00:00	1997-06-25	5001	0	\N	0	0	\N	\N	0	322457	0	127783003	4133840		
93827	2890	4052083	1991-07-13	1991-07-13 00:00:00	1991-07-13	5001	0	\N	0	0	\N	\N	0	192222	0	23426006	4052083		
137155	4226	4133840	2010-01-10	2010-01-10 00:00:00	2010-01-10	5001	0	\N	0	0	\N	\N	0	280648	0	127783003	4133840		
43611	4027	3020655	1975-02-13	1975-02-13 00:00:00	1975-02-13	5001	0	\N	0	0	\N	\N	0	267867	0	6844-5	3020655		
19448	609	4024958	1980-11-21	1980-11-21 00:00:00	1980-11-21	5001	0	\N	0	0	\N	\N	0	40416	0	117015009	4024958		
6071	564	3011505	1996-10-31	1996-10-31 00:00:00	1996-10-31	5001	0	\N	0	0	\N	\N	0	37379	0	19926-5	3011505		
17399	1585	3006322	1970-09-25	1970-09-25 00:00:00	1970-09-25	5001	0	\N	0	0	\N	\N	0	106304	0	8331-1	3006322		
7807	752	3006322	1985-11-21	1985-11-21 00:00:00	1985-11-21	5001	0	\N	0	0	\N	\N	0	49655	0	8331-1	3006322		
39733	3695	3021226	1981-06-13	1981-06-13 00:00:00	1981-06-13	5001	0	\N	0	0	\N	\N	0	245609	0	6246-3	3021226		
6915	664	3005136	2014-01-28	2014-01-28 00:00:00	2014-01-28	5001	0	\N	0	0	\N	\N	0	43831	0	6075-6	3005136		
23232	2136	3006451	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	142306	0	6273-7	3006451		
10856	1058	40769179	1956-02-03	1956-02-03 00:00:00	1956-02-03	5001	0	\N	0	0	\N	\N	0	69442	0	66519-0	40769179		
45448	4200	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	278741	0	6189-5	3006734		
42756	1317	4133840	1999-12-24	1999-12-24 00:00:00	1999-12-24	5001	0	\N	0	0	\N	\N	0	87308	0	127783003	4133840		
4798	455	3006322	1950-12-29	1950-12-29 00:00:00	1950-12-29	5001	0	\N	0	0	\N	\N	0	30403	0	8331-1	3006322		
124865	3857	4024958	1980-06-04	1980-06-04 00:00:00	1980-06-04	5001	0	\N	0	0	\N	\N	0	255951	0	117015009	4024958		
104345	3214	4052083	2017-05-17	2017-05-17 00:00:00	2017-05-17	5001	0	\N	0	0	\N	\N	0	213553	0	23426006	4052083		
38893	3595	40766240	1990-08-02	1990-08-02 00:00:00	1990-08-02	5001	0	\N	0	0	\N	\N	0	238848	0	63513-6	40766240		
157790	4847	4133840	2013-03-27	2013-03-27 00:00:00	2013-03-27	5001	0	\N	0	0	\N	\N	0	322420	0	127783003	4133840		
93828	2890	4052083	2013-08-12	2013-08-12 00:00:00	2013-08-12	5001	0	\N	0	0	\N	\N	0	192202	0	23426006	4052083		
137163	4226	4133840	2013-01-20	2013-01-20 00:00:00	2013-01-20	5001	0	\N	0	0	\N	\N	0	280683	0	127783003	4133840		
43612	4027	3005136	1975-02-13	1975-02-13 00:00:00	1975-02-13	5001	0	\N	0	0	\N	\N	0	267867	0	6075-6	3005136		
19458	609	4024958	2010-01-03	2010-01-03 00:00:00	2010-01-03	5001	0	\N	0	0	\N	\N	0	40458	0	117015009	4024958		
6072	564	3011505	2016-09-15	2016-09-15 00:00:00	2016-09-15	5001	0	\N	0	0	\N	\N	0	37354	0	19926-5	3011505		
17400	1585	3006322	2011-06-23	2011-06-23 00:00:00	2011-06-23	5001	0	\N	0	0	\N	\N	0	106261	0	8331-1	3006322		
7808	752	40758406	2013-06-06	2013-06-06 00:00:00	2013-06-06	5001	0	\N	0	0	\N	\N	0	49682	0	55277-8	40758406		
39734	3695	3001247	1981-06-13	1981-06-13 00:00:00	1981-06-13	5001	0	\N	0	0	\N	\N	0	245609	0	6085-5	3001247		
6916	664	3012494	2014-01-28	2014-01-28 00:00:00	2014-01-28	5001	0	\N	0	0	\N	\N	0	43831	0	6206-7	3012494		
23233	2136	3006734	2004-12-24	2004-12-24 00:00:00	2004-12-24	5001	0	\N	0	0	\N	\N	0	142252	0	6189-5	3006734		
10857	1058	40769189	1956-02-03	1956-02-03 00:00:00	1956-02-03	5001	0	\N	0	0	\N	\N	0	69442	0	66529-9	40769189		
45449	4200	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	278781	0	6273-7	3006451		
42758	1317	4052083	1964-04-14	1964-04-14 00:00:00	1964-04-14	5001	0	\N	0	0	\N	\N	0	87287	0	23426006	4052083		
4799	455	3006322	1995-04-01	1995-04-01 00:00:00	1995-04-01	5001	0	\N	0	0	\N	\N	0	30461	0	8331-1	3006322		
124866	3857	4133840	1997-01-21	1997-01-21 00:00:00	1997-01-21	5001	0	\N	0	0	\N	\N	0	256001	0	127783003	4133840		
104347	3214	4024958	1976-06-26	1976-06-26 00:00:00	1976-06-26	5001	0	\N	0	0	\N	\N	0	213522	0	117015009	4024958		
38896	3595	46235214	1990-08-02	1990-08-02 00:00:00	1990-08-02	5001	0	\N	0	0	\N	\N	0	238848	0	76690-7	46235214		
157791	4847	4133840	2012-03-21	2012-03-21 00:00:00	2012-03-21	5001	0	\N	0	0	\N	\N	0	322480	0	127783003	4133840		
13883	439	4052083	1987-08-17	1987-08-17 00:00:00	1987-08-17	5001	0	\N	0	0	\N	\N	0	29103	0	23426006	4052083		
137165	4226	4133840	2018-11-25	2018-11-25 00:00:00	2018-11-25	5001	0	\N	0	0	\N	\N	0	280666	0	127783003	4133840		
43613	4027	3021226	1975-02-13	1975-02-13 00:00:00	1975-02-13	5001	0	\N	0	0	\N	\N	0	267867	0	6246-3	3021226		
19463	609	4024958	1993-02-13	1993-02-13 00:00:00	1993-02-13	5001	0	\N	0	0	\N	\N	0	40441	0	117015009	4024958		
6073	564	3011505	1991-10-24	1991-10-24 00:00:00	1991-10-24	5001	0	\N	0	0	\N	\N	0	37324	0	19926-5	3011505		
17401	1585	3006322	2007-06-05	2007-06-05 00:00:00	2007-06-05	5001	0	\N	0	0	\N	\N	0	106301	0	8331-1	3006322		
7810	752	46235214	2013-06-06	2013-06-06 00:00:00	2013-06-06	5001	0	\N	0	0	\N	\N	0	49682	0	76690-7	46235214		
39735	3695	3001488	1981-06-13	1981-06-13 00:00:00	1981-06-13	5001	0	\N	0	0	\N	\N	0	245609	0	7258-7	3001488		
6917	664	3006734	2014-01-28	2014-01-28 00:00:00	2014-01-28	5001	0	\N	0	0	\N	\N	0	43831	0	6189-5	3006734		
23234	2136	3020655	2004-12-24	2004-12-24 00:00:00	2004-12-24	5001	0	\N	0	0	\N	\N	0	142252	0	6844-5	3020655		
10858	1058	40769184	1956-02-03	1956-02-03 00:00:00	1956-02-03	5001	0	\N	0	0	\N	\N	0	69442	0	66524-0	40769184		
45450	4200	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	278781	0	6075-6	3005136		
42759	1317	4024958	1995-08-03	1995-08-03 00:00:00	1995-08-03	5001	0	\N	0	0	\N	\N	0	87246	0	117015009	4024958		
4800	455	3006322	1990-04-18	1990-04-18 00:00:00	1990-04-18	5001	0	\N	0	0	\N	\N	0	30458	0	8331-1	3006322		
124869	3857	4133840	1998-07-07	1998-07-07 00:00:00	1998-07-07	5001	0	\N	0	0	\N	\N	0	256020	0	127783003	4133840		
104353	3214	4024958	1990-06-11	1990-06-11 00:00:00	1990-06-11	5001	0	\N	0	0	\N	\N	0	213537	0	117015009	4024958		
38897	3595	40758406	1990-08-02	1990-08-02 00:00:00	1990-08-02	5001	0	\N	0	0	\N	\N	0	238848	0	55277-8	40758406		
157794	4847	4133840	1987-06-17	1987-06-17 00:00:00	1987-06-17	5001	0	\N	0	0	\N	\N	0	322473	0	127783003	4133840		
13885	439	4052083	1980-10-14	1980-10-14 00:00:00	1980-10-14	5001	0	\N	0	0	\N	\N	0	29162	0	23426006	4052083		
137170	4226	4133840	2014-01-26	2014-01-26 00:00:00	2014-01-26	5001	0	\N	0	0	\N	\N	0	280664	0	127783003	4133840		
43614	4027	3006451	1975-02-13	1975-02-13 00:00:00	1975-02-13	5001	0	\N	0	0	\N	\N	0	267867	0	6273-7	3006451		
19468	609	4024958	1994-09-22	1994-09-22 00:00:00	1994-09-22	5001	0	\N	0	0	\N	\N	0	40432	0	117015009	4024958		
6074	564	3011505	2013-08-29	2013-08-29 00:00:00	2013-08-29	5001	0	\N	0	0	\N	\N	0	37322	0	19926-5	3011505		
17402	1586	3006322	2003-07-27	2003-07-27 00:00:00	2003-07-27	5001	0	\N	0	0	\N	\N	0	106398	0	8331-1	3006322		
7811	752	3051031	2013-06-06	2013-06-06 00:00:00	2013-06-06	5001	0	\N	0	0	\N	\N	0	49682	0	46240-8	3051031		
39736	3695	3006734	1981-06-13	1981-06-13 00:00:00	1981-06-13	5001	0	\N	0	0	\N	\N	0	245609	0	6189-5	3006734		
6918	664	3001488	2014-01-28	2014-01-28 00:00:00	2014-01-28	5001	0	\N	0	0	\N	\N	0	43831	0	7258-7	3001488		
23235	2136	3023430	2004-12-24	2004-12-24 00:00:00	2004-12-24	5001	0	\N	0	0	\N	\N	0	142252	0	6833-8	3023430		
10859	1058	40769194	1956-02-03	1956-02-03 00:00:00	1956-02-03	5001	0	\N	0	0	\N	\N	0	69442	0	66534-9	40769194		
45451	4200	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	278781	0	6246-3	3021226		
42761	1317	4133840	1996-05-24	1996-05-24 00:00:00	1996-05-24	5001	0	\N	0	0	\N	\N	0	87299	0	127783003	4133840		
124871	3857	4133840	2000-07-18	2000-07-18 00:00:00	2000-07-18	5001	0	\N	0	0	\N	\N	0	256021	0	127783003	4133840		
104354	3214	4024958	2011-04-06	2011-04-06 00:00:00	2011-04-06	5001	0	\N	0	0	\N	\N	0	213552	0	117015009	4024958		
38898	3595	40766240	1990-07-03	1990-07-03 00:00:00	1990-07-03	5001	0	\N	0	0	\N	\N	0	238788	0	63513-6	40766240		
157796	4847	4133840	2008-02-27	2008-02-27 00:00:00	2008-02-27	5001	0	\N	0	0	\N	\N	0	322429	0	127783003	4133840		
13889	439	4024958	1990-03-20	1990-03-20 00:00:00	1990-03-20	5001	0	\N	0	0	\N	\N	0	29157	0	117015009	4024958		
137172	4226	4133840	2017-11-19	2017-11-19 00:00:00	2017-11-19	5001	0	\N	0	0	\N	\N	0	280685	0	127783003	4133840		
43615	4027	3015076	1975-02-13	1975-02-13 00:00:00	1975-02-13	5001	0	\N	0	0	\N	\N	0	267867	0	6248-9	3015076		
19472	610	4024958	1972-11-19	1972-11-19 00:00:00	1972-11-19	5001	0	\N	0	0	\N	\N	0	40528	0	117015009	4024958		
6075	564	3011505	1994-10-27	1994-10-27 00:00:00	1994-10-27	5001	0	\N	0	0	\N	\N	0	37325	0	19926-5	3011505		
17403	1586	3006322	1978-10-23	1978-10-23 00:00:00	1978-10-23	5001	0	\N	0	0	\N	\N	0	106450	0	8331-1	3006322		
7812	752	40766240	2013-06-06	2013-06-06 00:00:00	2013-06-06	5001	0	\N	0	0	\N	\N	0	49682	0	63513-6	40766240		
39737	3695	3020655	1981-06-13	1981-06-13 00:00:00	1981-06-13	5001	0	\N	0	0	\N	\N	0	245609	0	6844-5	3020655		
6919	664	3006322	2017-07-02	2017-07-02 00:00:00	2017-07-02	5001	0	\N	0	0	\N	\N	0	43859	0	8331-1	3006322		
23236	2136	3019406	2004-12-24	2004-12-24 00:00:00	2004-12-24	5001	0	\N	0	0	\N	\N	0	142252	0	6158-0	3019406		
10860	1058	3006322	1993-04-01	1993-04-01 00:00:00	1993-04-01	5001	0	\N	0	0	\N	\N	0	69424	0	8331-1	3006322		
45452	4200	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	278781	0	6206-7	3012494		
42765	1317	4133840	2008-12-19	2008-12-19 00:00:00	2008-12-19	5001	0	\N	0	0	\N	\N	0	87300	0	127783003	4133840		
124875	3857	4133840	1995-01-10	1995-01-10 00:00:00	1995-01-10	5001	0	\N	0	0	\N	\N	0	256055	0	127783003	4133840		
71584	2190	4024958	1986-03-13	1986-03-13 00:00:00	1986-03-13	5001	0	\N	0	0	\N	\N	0	146000	0	117015009	4024958		
38901	3595	46235214	1990-07-03	1990-07-03 00:00:00	1990-07-03	5001	0	\N	0	0	\N	\N	0	238788	0	76690-7	46235214		
157798	4847	4133840	2005-02-16	2005-02-16 00:00:00	2005-02-16	5001	0	\N	0	0	\N	\N	0	322458	0	127783003	4133840		
13894	439	4024958	1988-03-16	1988-03-16 00:00:00	1988-03-16	5001	0	\N	0	0	\N	\N	0	29156	0	117015009	4024958		
137175	4226	4024958	1992-08-04	1992-08-04 00:00:00	1992-08-04	5001	0	\N	0	0	\N	\N	0	280771	0	117015009	4024958		
43616	4027	3001488	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	267800	0	7258-7	3001488		
53906	1634	4052083	1985-02-03	1985-02-03 00:00:00	1985-02-03	5001	0	\N	0	0	\N	\N	0	109740	0	23426006	4052083		
6076	564	3006322	1968-09-27	1968-09-27 00:00:00	1968-09-27	5001	0	\N	0	0	\N	\N	0	37312	0	8331-1	3006322		
17404	1586	3049273	1999-10-17	1999-10-17 00:00:00	1999-10-17	5001	0	\N	0	0	\N	\N	0	106378	0	38265-5	3049273		
7814	752	40758406	2011-02-17	2011-02-17 00:00:00	2011-02-17	5001	0	\N	0	0	\N	\N	0	49720	0	55277-8	40758406		
39738	3695	3015076	1981-06-13	1981-06-13 00:00:00	1981-06-13	5001	0	\N	0	0	\N	\N	0	245609	0	6248-9	3015076		
6920	664	40769194	2010-07-15	2010-07-15 00:00:00	2010-07-15	5001	0	\N	0	0	\N	\N	0	43804	0	66534-9	40769194		
23237	2136	3012494	2004-12-24	2004-12-24 00:00:00	2004-12-24	5001	0	\N	0	0	\N	\N	0	142252	0	6206-7	3012494		
10861	1058	3019406	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	69393	0	6158-0	3019406		
45453	4200	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	278781	0	6106-9	3014599		
42768	1317	4133840	2015-01-23	2015-01-23 00:00:00	2015-01-23	5001	0	\N	0	0	\N	\N	0	87316	0	127783003	4133840		
124877	3857	4024958	1982-03-05	1982-03-05 00:00:00	1982-03-05	5001	0	\N	0	0	\N	\N	0	255958	0	117015009	4024958		
71585	2190	4052083	1952-06-28	1952-06-28 00:00:00	1952-06-28	5001	0	\N	0	0	\N	\N	0	146025	0	23426006	4052083		
19725	1801	3006322	2010-07-08	2010-07-08 00:00:00	2010-07-08	5001	0	\N	0	0	\N	\N	0	120757	0	8331-1	3006322		
157802	4847	4133840	2000-07-12	2000-07-12 00:00:00	2000-07-12	5001	0	\N	0	0	\N	\N	0	322412	0	127783003	4133840		
13903	439	4024958	1979-07-24	1979-07-24 00:00:00	1979-07-24	5001	0	\N	0	0	\N	\N	0	29102	0	117015009	4024958		
137186	4226	4133840	2016-11-13	2016-11-13 00:00:00	2016-11-13	5001	0	\N	0	0	\N	\N	0	280644	0	127783003	4133840		
43617	4027	3036780	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	267800	0	6095-4	3036780		
53909	1634	4024958	1948-08-05	1948-08-05 00:00:00	1948-08-05	5001	0	\N	0	0	\N	\N	0	109724	0	117015009	4024958		
6077	564	3011505	2009-08-06	2009-08-06 00:00:00	2009-08-06	5001	0	\N	0	0	\N	\N	0	37320	0	19926-5	3011505		
17405	1586	3006322	1952-07-02	1952-07-02 00:00:00	1952-07-02	5001	0	\N	0	0	\N	\N	0	106411	0	8331-1	3006322		
7815	752	40766240	2011-02-17	2011-02-17 00:00:00	2011-02-17	5001	0	\N	0	0	\N	\N	0	49720	0	63513-6	40766240		
51016	4655	3006322	1974-01-19	1974-01-19 00:00:00	1974-01-19	5001	0	\N	0	0	\N	\N	0	310309	0	8331-1	3006322		
6921	664	40769184	2010-07-15	2010-07-15 00:00:00	2010-07-15	5001	0	\N	0	0	\N	\N	0	43804	0	66524-0	40769184		
23238	2136	3036780	2004-12-24	2004-12-24 00:00:00	2004-12-24	5001	0	\N	0	0	\N	\N	0	142252	0	6095-4	3036780		
10862	1058	3015076	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	69393	0	6248-9	3015076		
45454	4200	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	278781	0	7258-7	3001488		
42770	1317	4133840	1997-12-19	1997-12-19 00:00:00	1997-12-19	5001	0	\N	0	0	\N	\N	0	87329	0	127783003	4133840		
124880	3857	4133840	1997-04-01	1997-04-01 00:00:00	1997-04-01	5001	0	\N	0	0	\N	\N	0	256019	0	127783003	4133840		
82934	2559	4024958	1965-10-15	1965-10-15 00:00:00	1965-10-15	5001	0	\N	0	0	\N	\N	0	169623	0	117015009	4024958		
19726	1801	3006322	2011-02-15	2011-02-15 00:00:00	2011-02-15	5001	0	\N	0	0	\N	\N	0	120762	0	8331-1	3006322		
157819	4848	4024958	1959-03-13	1959-03-13 00:00:00	1959-03-13	5001	0	\N	0	0	\N	\N	0	322491	0	117015009	4024958		
13904	439	4024958	1979-09-03	1979-09-03 00:00:00	1979-09-03	5001	0	\N	0	0	\N	\N	0	29155	0	117015009	4024958		
43618	4027	3001247	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	267800	0	6085-5	3001247		
53933	1635	4052083	2014-07-30	2014-07-30 00:00:00	2014-07-30	5001	0	\N	0	0	\N	\N	0	109822	0	23426006	4052083		
6078	564	3011505	2017-09-21	2017-09-21 00:00:00	2017-09-21	5001	0	\N	0	0	\N	\N	0	37360	0	19926-5	3011505		
17408	1588	3006322	1999-06-08	1999-06-08 00:00:00	1999-06-08	5001	0	\N	0	0	\N	\N	0	106628	0	8331-1	3006322		
7816	752	3051031	2011-02-17	2011-02-17 00:00:00	2011-02-17	5001	0	\N	0	0	\N	\N	0	49720	0	46240-8	3051031		
51017	4655	3012494	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	310265	0	6206-7	3012494		
6922	664	40769189	2010-07-15	2010-07-15 00:00:00	2010-07-15	5001	0	\N	0	0	\N	\N	0	43804	0	66529-9	40769189		
23239	2136	3000876	2004-12-24	2004-12-24 00:00:00	2004-12-24	5001	0	\N	0	0	\N	\N	0	142252	0	6082-2	3000876		
10863	1058	3006451	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	69393	0	6273-7	3006451		
45455	4200	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	278781	0	6844-5	3020655		
42775	1317	4133840	2006-12-08	2006-12-08 00:00:00	2006-12-08	5001	0	\N	0	0	\N	\N	0	87311	0	127783003	4133840		
124882	3857	4133840	1980-12-23	1980-12-23 00:00:00	1980-12-23	5001	0	\N	0	0	\N	\N	0	256045	0	127783003	4133840		
82936	2559	4024958	1996-03-15	1996-03-15 00:00:00	1996-03-15	5001	0	\N	0	0	\N	\N	0	169581	0	117015009	4024958		
19727	1801	3006322	1981-12-27	1981-12-27 00:00:00	1981-12-27	5001	0	\N	0	0	\N	\N	0	120761	0	8331-1	3006322		
157823	4848	4024958	1986-07-15	1986-07-15 00:00:00	1986-07-15	5001	0	\N	0	0	\N	\N	0	322496	0	117015009	4024958		
13909	440	4024958	1997-03-23	1997-03-23 00:00:00	1997-03-23	5001	0	\N	0	0	\N	\N	0	29198	0	117015009	4024958		
43619	4027	3012494	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	267800	0	6206-7	3012494		
53936	1635	4052083	1981-08-03	1981-08-03 00:00:00	1981-08-03	5001	0	\N	0	0	\N	\N	0	109844	0	23426006	4052083		
6079	564	3011505	2007-07-26	2007-07-26 00:00:00	2007-07-26	5001	0	\N	0	0	\N	\N	0	37382	0	19926-5	3011505		
17409	1588	3006322	2004-02-25	2004-02-25 00:00:00	2004-02-25	5001	0	\N	0	0	\N	\N	0	106614	0	8331-1	3006322		
7819	752	46235214	2011-02-17	2011-02-17 00:00:00	2011-02-17	5001	0	\N	0	0	\N	\N	0	49720	0	76690-7	46235214		
51018	4655	3019406	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	310265	0	6158-0	3019406		
6923	664	40769179	2010-07-15	2010-07-15 00:00:00	2010-07-15	5001	0	\N	0	0	\N	\N	0	43804	0	66519-0	40769179		
23240	2136	3014599	2004-12-24	2004-12-24 00:00:00	2004-12-24	5001	0	\N	0	0	\N	\N	0	142252	0	6106-9	3014599		
10864	1058	3005136	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	69393	0	6075-6	3005136		
45456	4200	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	278781	0	6189-5	3006734		
42779	1317	4133840	2014-01-17	2014-01-17 00:00:00	2014-01-17	5001	0	\N	0	0	\N	\N	0	87333	0	127783003	4133840		
124883	3857	4024958	1978-07-04	1978-07-04 00:00:00	1978-07-04	5001	0	\N	0	0	\N	\N	0	255957	0	117015009	4024958		
71946	2200	4052083	1981-09-27	1981-09-27 00:00:00	1981-09-27	5001	0	\N	0	0	\N	\N	0	146647	0	23426006	4052083		
19744	1804	3006322	1943-03-07	1943-03-07 00:00:00	1943-03-07	5001	0	\N	0	0	\N	\N	0	120826	0	8331-1	3006322		
157827	4848	4052083	1960-01-08	1960-01-08 00:00:00	1960-01-08	5001	0	\N	0	0	\N	\N	0	322564	0	23426006	4052083		
13925	440	4052083	1994-03-07	1994-03-07 00:00:00	1994-03-07	5001	0	\N	0	0	\N	\N	0	29204	0	23426006	4052083		
43620	4027	3019406	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	267800	0	6158-0	3019406		
53946	1635	4052083	2005-07-19	2005-07-19 00:00:00	2005-07-19	5001	0	\N	0	0	\N	\N	0	109854	0	23426006	4052083		
6080	564	3011505	2002-11-14	2002-11-14 00:00:00	2002-11-14	5001	0	\N	0	0	\N	\N	0	37326	0	19926-5	3011505		
17410	1588	3006322	1972-03-07	1972-03-07 00:00:00	1972-03-07	5001	0	\N	0	0	\N	\N	0	106631	0	8331-1	3006322		
7820	752	3006322	2016-02-13	2016-02-13 00:00:00	2016-02-13	5001	0	\N	0	0	\N	\N	0	49644	0	8331-1	3006322		
51019	4655	3005136	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	310265	0	6075-6	3005136		
6924	664	3000876	2010-07-27	2010-07-27 00:00:00	2010-07-27	5001	0	\N	0	0	\N	\N	0	43821	0	6082-2	3000876		
23241	2136	3015076	2004-12-24	2004-12-24 00:00:00	2004-12-24	5001	0	\N	0	0	\N	\N	0	142252	0	6248-9	3015076		
10865	1058	3006734	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	69393	0	6189-5	3006734		
45457	4200	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	278781	0	6095-4	3036780		
54059	1641	4024958	1963-08-09	1963-08-09 00:00:00	1963-08-09	5001	0	\N	0	0	\N	\N	0	110118	0	117015009	4024958		
124887	3857	4133840	1998-04-07	1998-04-07 00:00:00	1998-04-07	5001	0	\N	0	0	\N	\N	0	255988	0	127783003	4133840		
71947	2200	4024958	1995-09-28	1995-09-28 00:00:00	1995-09-28	5001	0	\N	0	0	\N	\N	0	146639	0	117015009	4024958		
19745	1804	3006322	1950-05-12	1950-05-12 00:00:00	1950-05-12	5001	0	\N	0	0	\N	\N	0	120835	0	8331-1	3006322		
157832	4848	4052083	1975-04-27	1975-04-27 00:00:00	1975-04-27	5001	0	\N	0	0	\N	\N	0	322508	0	23426006	4052083		
12475	1185	3006322	1973-02-04	1973-02-04 00:00:00	1973-02-04	5001	0	\N	0	0	\N	\N	0	78159	0	8331-1	3006322		
43621	4027	3000876	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	267800	0	6082-2	3000876		
53954	1636	4024958	1997-08-05	1997-08-05 00:00:00	1997-08-05	5001	0	\N	0	0	\N	\N	0	109914	0	117015009	4024958		
6081	564	3011505	1990-08-16	1990-08-16 00:00:00	1990-08-16	5001	0	\N	0	0	\N	\N	0	37378	0	19926-5	3011505		
17411	1588	3006322	2016-02-05	2016-02-05 00:00:00	2016-02-05	5001	0	\N	0	0	\N	\N	0	106579	0	8331-1	3006322		
7821	752	46235214	2012-10-09	2012-10-09 00:00:00	2012-10-09	5001	0	\N	0	0	\N	\N	0	49738	0	76690-7	46235214		
51020	4655	3015076	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	310265	0	6248-9	3015076		
6925	664	3001247	2010-07-27	2010-07-27 00:00:00	2010-07-27	5001	0	\N	0	0	\N	\N	0	43821	0	6085-5	3001247		
23242	2136	3021226	2004-12-24	2004-12-24 00:00:00	2004-12-24	5001	0	\N	0	0	\N	\N	0	142252	0	6246-3	3021226		
10866	1058	3021226	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	69393	0	6246-3	3021226		
45458	4200	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	278781	0	6248-9	3015076		
54064	1641	4052083	1963-12-05	1963-12-05 00:00:00	1963-12-05	5001	0	\N	0	0	\N	\N	0	110126	0	23426006	4052083		
124890	3857	4133840	1992-05-12	1992-05-12 00:00:00	1992-05-12	5001	0	\N	0	0	\N	\N	0	255993	0	127783003	4133840		
83237	2570	4024958	1976-11-20	1976-11-20 00:00:00	1976-11-20	5001	0	\N	0	0	\N	\N	0	170179	0	117015009	4024958		
19746	1804	3006322	1945-02-08	1945-02-08 00:00:00	1945-02-08	5001	0	\N	0	0	\N	\N	0	120827	0	8331-1	3006322		
123608	3814	4052083	1977-08-19	1977-08-19 00:00:00	1977-08-19	5001	0	\N	0	0	\N	\N	0	253333	0	23426006	4052083		
12476	1185	3006322	2018-06-22	2018-06-22 00:00:00	2018-06-22	5001	0	\N	0	0	\N	\N	0	78181	0	8331-1	3006322		
43622	4027	3014599	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	267800	0	6106-9	3014599		
53959	1636	4024958	1987-03-20	1987-03-20 00:00:00	1987-03-20	5001	0	\N	0	0	\N	\N	0	109858	0	117015009	4024958		
6082	564	3011505	2011-08-18	2011-08-18 00:00:00	2011-08-18	5001	0	\N	0	0	\N	\N	0	37321	0	19926-5	3011505		
17412	1588	3006322	1975-08-29	1975-08-29 00:00:00	1975-08-29	5001	0	\N	0	0	\N	\N	0	106643	0	8331-1	3006322		
7822	752	40758406	2012-10-09	2012-10-09 00:00:00	2012-10-09	5001	0	\N	0	0	\N	\N	0	49738	0	55277-8	40758406		
51021	4655	3027231	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	310265	0	6276-0	3027231		
6926	664	3020655	2010-07-27	2010-07-27 00:00:00	2010-07-27	5001	0	\N	0	0	\N	\N	0	43821	0	6844-5	3020655		
23243	2136	3027231	2004-12-24	2004-12-24 00:00:00	2004-12-24	5001	0	\N	0	0	\N	\N	0	142252	0	6276-0	3027231		
10867	1058	3012494	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	69393	0	6206-7	3012494		
45459	4200	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	278781	0	6276-0	3027231		
54066	1641	4052083	1981-05-23	1981-05-23 00:00:00	1981-05-23	5001	0	\N	0	0	\N	\N	0	110119	0	23426006	4052083		
124893	3857	4024958	1998-06-26	1998-06-26 00:00:00	1998-06-26	5001	0	\N	0	0	\N	\N	0	255962	0	117015009	4024958		
83240	2570	4024958	1945-04-05	1945-04-05 00:00:00	1945-04-05	5001	0	\N	0	0	\N	\N	0	170163	0	117015009	4024958		
19747	1804	3006322	1973-03-28	1973-03-28 00:00:00	1973-03-28	5001	0	\N	0	0	\N	\N	0	120862	0	8331-1	3006322		
123622	3814	4024958	1975-06-02	1975-06-02 00:00:00	1975-06-02	5001	0	\N	0	0	\N	\N	0	253354	0	117015009	4024958		
12477	1185	3006322	2015-01-24	2015-01-24 00:00:00	2015-01-24	5001	0	\N	0	0	\N	\N	0	78183	0	8331-1	3006322		
43623	4027	3027231	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	267800	0	6276-0	3027231		
53960	1636	4052083	1994-06-13	1994-06-13 00:00:00	1994-06-13	5001	0	\N	0	0	\N	\N	0	109862	0	23426006	4052083		
6083	564	3011505	2012-08-23	2012-08-23 00:00:00	2012-08-23	5001	0	\N	0	0	\N	\N	0	37328	0	19926-5	3011505		
17416	1590	3049273	2014-08-23	2014-08-23 00:00:00	2014-08-23	5001	0	\N	0	0	\N	\N	0	106721	0	38265-5	3049273		
7823	752	3051031	2012-10-09	2012-10-09 00:00:00	2012-10-09	5001	0	\N	0	0	\N	\N	0	49738	0	46240-8	3051031		
51022	4655	3000876	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	310265	0	6082-2	3000876		
6927	664	3023430	2010-07-27	2010-07-27 00:00:00	2010-07-27	5001	0	\N	0	0	\N	\N	0	43821	0	6833-8	3023430		
23244	2136	3006451	2004-12-24	2004-12-24 00:00:00	2004-12-24	5001	0	\N	0	0	\N	\N	0	142252	0	6273-7	3006451		
10868	1058	3001247	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	69393	0	6085-5	3001247		
45460	4200	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	278781	0	6158-0	3019406		
124894	3857	4133840	1992-01-14	1992-01-14 00:00:00	1992-01-14	5001	0	\N	0	0	\N	\N	0	255992	0	127783003	4133840		
83250	2570	4024958	1947-12-29	1947-12-29 00:00:00	1947-12-29	5001	0	\N	0	0	\N	\N	0	170165	0	117015009	4024958		
19748	1804	3006322	1945-07-23	1945-07-23 00:00:00	1945-07-23	5001	0	\N	0	0	\N	\N	0	120890	0	8331-1	3006322		
123624	3814	4052083	1983-02-01	1983-02-01 00:00:00	1983-02-01	5001	0	\N	0	0	\N	\N	0	253334	0	23426006	4052083		
12478	1185	3006322	1947-04-22	1947-04-22 00:00:00	1947-04-22	5001	0	\N	0	0	\N	\N	0	78178	0	8331-1	3006322		
43624	4027	3020655	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	267800	0	6844-5	3020655		
53972	1636	4052083	2019-02-16	2019-02-16 00:00:00	2019-02-16	5001	0	\N	0	0	\N	\N	0	109872	0	23426006	4052083		
6084	564	3011505	2010-08-12	2010-08-12 00:00:00	2010-08-12	5001	0	\N	0	0	\N	\N	0	37327	0	19926-5	3011505		
17417	1590	3006322	1976-01-08	1976-01-08 00:00:00	1976-01-08	5001	0	\N	0	0	\N	\N	0	106686	0	8331-1	3006322		
7824	752	40766240	2012-10-09	2012-10-09 00:00:00	2012-10-09	5001	0	\N	0	0	\N	\N	0	49738	0	63513-6	40766240		
51023	4655	3020655	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	310265	0	6844-5	3020655		
6928	664	3019406	2010-07-27	2010-07-27 00:00:00	2010-07-27	5001	0	\N	0	0	\N	\N	0	43821	0	6158-0	3019406		
23245	2136	3001488	2004-12-24	2004-12-24 00:00:00	2004-12-24	5001	0	\N	0	0	\N	\N	0	142252	0	7258-7	3001488		
10869	1058	3023430	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	69393	0	6833-8	3023430		
45461	4200	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	278781	0	6085-5	3001247		
124896	3857	4133840	2002-07-30	2002-07-30 00:00:00	2002-07-30	5001	0	\N	0	0	\N	\N	0	256022	0	127783003	4133840		
83294	2572	4024958	1979-08-05	1979-08-05 00:00:00	1979-08-05	5001	0	\N	0	0	\N	\N	0	170388	0	117015009	4024958		
19755	1808	3006322	1986-10-10	1986-10-10 00:00:00	1986-10-10	5001	0	\N	0	0	\N	\N	0	121073	0	8331-1	3006322		
123677	3817	4052083	1991-03-30	1991-03-30 00:00:00	1991-03-30	5001	0	\N	0	0	\N	\N	0	253491	0	23426006	4052083		
12479	1185	3006322	1987-04-07	1987-04-07 00:00:00	1987-04-07	5001	0	\N	0	0	\N	\N	0	78090	0	8331-1	3006322		
43625	4027	3021226	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	267800	0	6246-3	3021226		
53979	1636	4024958	1966-12-07	1966-12-07 00:00:00	1966-12-07	5001	0	\N	0	0	\N	\N	0	109897	0	117015009	4024958		
6085	564	3006322	1960-01-01	1960-01-01 00:00:00	1960-01-01	5001	0	\N	0	0	\N	\N	0	37356	0	8331-1	3006322		
17418	1590	3006322	1989-09-16	1989-09-16 00:00:00	1989-09-16	5001	0	\N	0	0	\N	\N	0	106671	0	8331-1	3006322		
7828	752	46235214	2011-04-18	2011-04-18 00:00:00	2011-04-18	5001	0	\N	0	0	\N	\N	0	49737	0	76690-7	46235214		
51024	4655	3036780	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	310265	0	6095-4	3036780		
6929	664	3001488	2010-07-27	2010-07-27 00:00:00	2010-07-27	5001	0	\N	0	0	\N	\N	0	43821	0	7258-7	3001488		
23246	2136	3001247	2004-12-24	2004-12-24 00:00:00	2004-12-24	5001	0	\N	0	0	\N	\N	0	142252	0	6085-5	3001247		
10870	1058	3000876	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	69393	0	6082-2	3000876		
45462	4200	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	278781	0	6833-8	3023430		
124899	3857	4133840	2001-07-24	2001-07-24 00:00:00	2001-07-24	5001	0	\N	0	0	\N	\N	0	255995	0	127783003	4133840		
60858	1855	4052083	1998-11-16	1998-11-16 00:00:00	1998-11-16	5001	0	\N	0	0	\N	\N	0	124144	0	23426006	4052083		
19756	1808	40766240	1980-09-29	1980-09-29 00:00:00	1980-09-29	5001	0	\N	0	0	\N	\N	0	121030	0	63513-6	40766240		
132990	4094	4024958	1957-10-15	1957-10-15 00:00:00	1957-10-15	5001	0	\N	0	0	\N	\N	0	272113	0	117015009	4024958		
12480	1185	3006322	1941-01-10	1941-01-10 00:00:00	1941-01-10	5001	0	\N	0	0	\N	\N	0	78102	0	8331-1	3006322		
43626	4027	3005136	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	267800	0	6075-6	3005136		
53982	1636	4024958	1963-09-12	1963-09-12 00:00:00	1963-09-12	5001	0	\N	0	0	\N	\N	0	109896	0	117015009	4024958		
6086	564	3011505	2006-07-20	2006-07-20 00:00:00	2006-07-20	5001	0	\N	0	0	\N	\N	0	37357	0	19926-5	3011505		
17419	1590	3006322	1989-06-07	1989-06-07 00:00:00	1989-06-07	5001	0	\N	0	0	\N	\N	0	106716	0	8331-1	3006322		
7829	752	40758406	2011-04-18	2011-04-18 00:00:00	2011-04-18	5001	0	\N	0	0	\N	\N	0	49737	0	55277-8	40758406		
51025	4655	3021226	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	310265	0	6246-3	3021226		
6930	664	3015076	2010-07-27	2010-07-27 00:00:00	2010-07-27	5001	0	\N	0	0	\N	\N	0	43821	0	6248-9	3015076		
23247	2136	3005136	2004-12-24	2004-12-24 00:00:00	2004-12-24	5001	0	\N	0	0	\N	\N	0	142252	0	6075-6	3005136		
10871	1058	3014599	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	69393	0	6106-9	3014599		
45463	4200	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	278781	0	6082-2	3000876		
124901	3857	4133840	1977-12-20	1977-12-20 00:00:00	1977-12-20	5001	0	\N	0	0	\N	\N	0	256044	0	127783003	4133840		
72141	2210	4052083	1982-09-08	1982-09-08 00:00:00	1982-09-08	5001	0	\N	0	0	\N	\N	0	147215	0	23426006	4052083		
19758	1808	40758406	1980-09-29	1980-09-29 00:00:00	1980-09-29	5001	0	\N	0	0	\N	\N	0	121030	0	55277-8	40758406		
144279	4435	4024958	2005-11-09	2005-11-09 00:00:00	2005-11-09	5001	0	\N	0	0	\N	\N	0	294806	0	117015009	4024958		
12481	1185	3006322	1957-07-12	1957-07-12 00:00:00	1957-07-12	5001	0	\N	0	0	\N	\N	0	78179	0	8331-1	3006322		
43627	4027	3023430	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	267800	0	6833-8	3023430		
53983	1636	4024958	1960-08-18	1960-08-18 00:00:00	1960-08-18	5001	0	\N	0	0	\N	\N	0	109857	0	117015009	4024958		
17364	1577	3027970	1997-01-31	1997-01-31 00:00:00	1997-01-31	5001	0	\N	0	0	\N	\N	0	105932	0	10834-0	3027970		
17420	1590	3006322	2008-02-20	2008-02-20 00:00:00	2008-02-20	5001	0	\N	0	0	\N	\N	0	106719	0	8331-1	3006322		
7830	752	3051031	2011-04-18	2011-04-18 00:00:00	2011-04-18	5001	0	\N	0	0	\N	\N	0	49737	0	46240-8	3051031		
51026	4655	3001247	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	310265	0	6085-5	3001247		
6931	664	3005136	2010-07-27	2010-07-27 00:00:00	2010-07-27	5001	0	\N	0	0	\N	\N	0	43821	0	6075-6	3005136		
23248	2136	3027231	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	142306	0	6276-0	3027231		
10872	1058	3027231	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	69393	0	6276-0	3027231		
45464	4200	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	278741	0	6095-4	3036780		
124904	3857	4133840	1996-01-16	1996-01-16 00:00:00	1996-01-16	5001	0	\N	0	0	\N	\N	0	255987	0	127783003	4133840		
72154	2210	4024958	1945-12-11	1945-12-11 00:00:00	1945-12-11	5001	0	\N	0	0	\N	\N	0	147235	0	117015009	4024958		
19759	1808	46235214	1980-09-29	1980-09-29 00:00:00	1980-09-29	5001	0	\N	0	0	\N	\N	0	121030	0	76690-7	46235214		
144281	4435	4052083	1989-12-01	1989-12-01 00:00:00	1989-12-01	5001	0	\N	0	0	\N	\N	0	294805	0	23426006	4052083		
12482	1185	3049273	1997-01-05	1997-01-05 00:00:00	1997-01-05	5001	0	\N	0	0	\N	\N	0	78100	0	38265-5	3049273		
43628	4027	3006734	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	267800	0	6189-5	3006734		
17365	1577	3016723	1997-01-31	1997-01-31 00:00:00	1997-01-31	5001	0	\N	0	0	\N	\N	0	105932	0	2160-0	3016723		
17421	1590	3006322	1971-11-14	1971-11-14 00:00:00	1971-11-14	5001	0	\N	0	0	\N	\N	0	106700	0	8331-1	3006322		
7831	752	40766240	2011-04-18	2011-04-18 00:00:00	2011-04-18	5001	0	\N	0	0	\N	\N	0	49737	0	63513-6	40766240		
51027	4655	3001488	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	310265	0	7258-7	3001488		
6932	664	3012494	2010-07-27	2010-07-27 00:00:00	2010-07-27	5001	0	\N	0	0	\N	\N	0	43821	0	6206-7	3012494		
23249	2136	3006451	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	142306	0	6273-7	3006451		
10873	1058	3036780	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	69393	0	6095-4	3036780		
45465	4200	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	278741	0	6082-2	3000876		
124905	3857	4133840	1972-03-14	1972-03-14 00:00:00	1972-03-14	5001	0	\N	0	0	\N	\N	0	256054	0	127783003	4133840		
72160	2210	4024958	2016-06-21	2016-06-21 00:00:00	2016-06-21	5001	0	\N	0	0	\N	\N	0	147220	0	117015009	4024958		
19761	1808	3051031	1980-09-29	1980-09-29 00:00:00	1980-09-29	5001	0	\N	0	0	\N	\N	0	121030	0	46240-8	3051031		
144286	4435	4024958	1973-07-31	1973-07-31 00:00:00	1973-07-31	5001	0	\N	0	0	\N	\N	0	294780	0	117015009	4024958		
12487	1188	3006322	1987-09-29	1987-09-29 00:00:00	1987-09-29	5001	0	\N	0	0	\N	\N	0	78259	0	8331-1	3006322		
43629	4027	3015076	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	267800	0	6248-9	3015076		
17366	1577	3024561	1997-01-31	1997-01-31 00:00:00	1997-01-31	5001	0	\N	0	0	\N	\N	0	105932	0	1751-7	3024561		
17422	1590	3006322	2011-09-16	2011-09-16 00:00:00	2011-09-16	5001	0	\N	0	0	\N	\N	0	106712	0	8331-1	3006322		
7835	752	40758406	2011-05-18	2011-05-18 00:00:00	2011-05-18	5001	0	\N	0	0	\N	\N	0	49721	0	55277-8	40758406		
51028	4655	3006451	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	310265	0	6273-7	3006451		
6933	664	3006734	2010-07-27	2010-07-27 00:00:00	2010-07-27	5001	0	\N	0	0	\N	\N	0	43821	0	6189-5	3006734		
23250	2136	3019406	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	142306	0	6158-0	3019406		
10874	1058	3020655	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	69393	0	6844-5	3020655		
45466	4200	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	278741	0	6085-5	3001247		
124908	3857	4133840	1985-12-31	1985-12-31 00:00:00	1985-12-31	5001	0	\N	0	0	\N	\N	0	255975	0	127783003	4133840		
72165	2210	4024958	1954-09-05	1954-09-05 00:00:00	1954-09-05	5001	0	\N	0	0	\N	\N	0	147264	0	117015009	4024958		
19762	1808	3006322	2016-01-19	2016-01-19 00:00:00	2016-01-19	5001	0	\N	0	0	\N	\N	0	121024	0	8331-1	3006322		
144289	4435	4052083	1982-03-15	1982-03-15 00:00:00	1982-03-15	5001	0	\N	0	0	\N	\N	0	294781	0	23426006	4052083		
12488	1189	3006322	2004-01-29	2004-01-29 00:00:00	2004-01-29	5001	0	\N	0	0	\N	\N	0	78320	0	8331-1	3006322		
43630	4027	3006451	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	267800	0	6273-7	3006451		
17367	1577	3028833	1997-01-31	1997-01-31 00:00:00	1997-01-31	5001	0	\N	0	0	\N	\N	0	105932	0	42719-5	3028833		
17423	1590	3006322	1964-09-11	1964-09-11 00:00:00	1964-09-11	5001	0	\N	0	0	\N	\N	0	106706	0	8331-1	3006322		
7836	752	46235214	2011-05-18	2011-05-18 00:00:00	2011-05-18	5001	0	\N	0	0	\N	\N	0	49721	0	76690-7	46235214		
51029	4655	3014599	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	310265	0	6106-9	3014599		
6934	664	3021226	2010-07-27	2010-07-27 00:00:00	2010-07-27	5001	0	\N	0	0	\N	\N	0	43821	0	6246-3	3021226		
23251	2136	3005136	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	142306	0	6075-6	3005136		
10875	1058	3001488	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	69393	0	7258-7	3001488		
56744	5207	3051031	2001-09-26	2001-09-26 00:00:00	2001-09-26	5001	0	\N	0	0	\N	\N	0	346350	0	46240-8	3051031		
124910	3857	4133840	2006-08-22	2006-08-22 00:00:00	2006-08-22	5001	0	\N	0	0	\N	\N	0	255990	0	127783003	4133840		
72166	2210	4024958	1978-12-26	1978-12-26 00:00:00	1978-12-26	5001	0	\N	0	0	\N	\N	0	147265	0	117015009	4024958		
19763	1808	40758406	1980-07-01	1980-07-01 00:00:00	1980-07-01	5001	0	\N	0	0	\N	\N	0	121029	0	55277-8	40758406		
144329	4437	4052083	1976-08-31	1976-08-31 00:00:00	1976-08-31	5001	0	\N	0	0	\N	\N	0	294930	0	23426006	4052083		
12489	1189	3006322	2010-11-17	2010-11-17 00:00:00	2010-11-17	5001	0	\N	0	0	\N	\N	0	78306	0	8331-1	3006322		
43631	4027	3006322	2004-05-02	2004-05-02 00:00:00	2004-05-02	5001	0	\N	0	0	\N	\N	0	267801	0	8331-1	3006322		
17368	1577	3014576	1997-01-31	1997-01-31 00:00:00	1997-01-31	5001	0	\N	0	0	\N	\N	0	105932	0	2075-0	3014576		
17427	1593	40758406	1967-01-31	1967-01-31 00:00:00	1967-01-31	5001	0	\N	0	0	\N	\N	0	106864	0	55277-8	40758406		
7837	752	3051031	2011-05-18	2011-05-18 00:00:00	2011-05-18	5001	0	\N	0	0	\N	\N	0	49721	0	46240-8	3051031		
51030	4655	3006734	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	310265	0	6189-5	3006734		
6935	664	3014599	2010-07-27	2010-07-27 00:00:00	2010-07-27	5001	0	\N	0	0	\N	\N	0	43821	0	6106-9	3014599		
23252	2136	3001488	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	142306	0	7258-7	3001488		
10876	1058	3006322	2003-10-26	2003-10-26 00:00:00	2003-10-26	5001	0	\N	0	0	\N	\N	0	69420	0	8331-1	3006322		
56746	5207	46235214	2001-09-26	2001-09-26 00:00:00	2001-09-26	5001	0	\N	0	0	\N	\N	0	346350	0	76690-7	46235214		
124913	3857	4133840	2009-09-08	2009-09-08 00:00:00	2009-09-08	5001	0	\N	0	0	\N	\N	0	256004	0	127783003	4133840		
72176	2210	4052083	2016-05-10	2016-05-10 00:00:00	2016-05-10	5001	0	\N	0	0	\N	\N	0	147219	0	23426006	4052083		
19765	1808	40766240	1980-07-01	1980-07-01 00:00:00	1980-07-01	5001	0	\N	0	0	\N	\N	0	121029	0	63513-6	40766240		
144331	4437	4024958	1984-03-15	1984-03-15 00:00:00	1984-03-15	5001	0	\N	0	0	\N	\N	0	294942	0	117015009	4024958		
12490	1189	3006322	2001-12-28	2001-12-28 00:00:00	2001-12-28	5001	0	\N	0	0	\N	\N	0	78319	0	8331-1	3006322		
68289	2088	4133840	1991-08-06	1991-08-06 00:00:00	1991-08-06	5001	0	\N	0	0	\N	\N	0	139277	0	127783003	4133840		
17369	1578	3049273	1999-08-22	1999-08-22 00:00:00	1999-08-22	5001	0	\N	0	0	\N	\N	0	105970	0	38265-5	3049273		
17428	1593	3051031	1967-01-31	1967-01-31 00:00:00	1967-01-31	5001	0	\N	0	0	\N	\N	0	106864	0	46240-8	3051031		
7838	752	40766240	2011-05-18	2011-05-18 00:00:00	2011-05-18	5001	0	\N	0	0	\N	\N	0	49721	0	63513-6	40766240		
51031	4655	3023430	1990-01-07	1990-01-07 00:00:00	1990-01-07	5001	0	\N	0	0	\N	\N	0	310265	0	6833-8	3023430		
6936	664	3006451	2010-07-27	2010-07-27 00:00:00	2010-07-27	5001	0	\N	0	0	\N	\N	0	43821	0	6273-7	3006451		
23253	2136	3006734	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	142306	0	6189-5	3006734		
10877	1058	3006322	1959-08-07	1959-08-07 00:00:00	1959-08-07	5001	0	\N	0	0	\N	\N	0	69480	0	8331-1	3006322		
56747	5207	40758406	2001-09-26	2001-09-26 00:00:00	2001-09-26	5001	0	\N	0	0	\N	\N	0	346350	0	55277-8	40758406		
136482	4206	4024958	1955-06-08	1955-06-08 00:00:00	1955-06-08	5001	0	\N	0	0	\N	\N	0	279284	0	117015009	4024958		
72184	2211	4024958	1992-04-09	1992-04-09 00:00:00	1992-04-09	5001	0	\N	0	0	\N	\N	0	147336	0	117015009	4024958		
19766	1808	46235214	1980-07-01	1980-07-01 00:00:00	1980-07-01	5001	0	\N	0	0	\N	\N	0	121029	0	76690-7	46235214		
144336	4437	4024958	1999-06-07	1999-06-07 00:00:00	1999-06-07	5001	0	\N	0	0	\N	\N	0	294886	0	117015009	4024958		
12491	1189	3006322	1970-12-29	1970-12-29 00:00:00	1970-12-29	5001	0	\N	0	0	\N	\N	0	78348	0	8331-1	3006322		
68291	2088	4133840	1976-08-17	1976-08-17 00:00:00	1976-08-17	5001	0	\N	0	0	\N	\N	0	139321	0	127783003	4133840		
156767	4819	4052083	1993-12-03	1993-12-03 00:00:00	1993-12-03	5001	0	\N	0	0	\N	\N	0	320515	0	23426006	4052083		
17430	1593	40766240	1967-01-31	1967-01-31 00:00:00	1967-01-31	5001	0	\N	0	0	\N	\N	0	106864	0	63513-6	40766240		
7839	752	46235214	2013-03-08	2013-03-08 00:00:00	2013-03-08	5001	0	\N	0	0	\N	\N	0	49681	0	76690-7	46235214		
51032	4655	3006322	1998-04-23	1998-04-23 00:00:00	1998-04-23	5001	0	\N	0	0	\N	\N	0	310336	0	8331-1	3006322		
6937	664	3027231	2010-07-27	2010-07-27 00:00:00	2010-07-27	5001	0	\N	0	0	\N	\N	0	43821	0	6276-0	3027231		
23254	2136	3020655	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	142306	0	6844-5	3020655		
10878	1058	3006322	1992-06-21	1992-06-21 00:00:00	1992-06-21	5001	0	\N	0	0	\N	\N	0	69473	0	8331-1	3006322		
56748	5207	46235214	2001-08-27	2001-08-27 00:00:00	2001-08-27	5001	0	\N	0	0	\N	\N	0	346365	0	76690-7	46235214		
136485	4206	4133840	1989-09-25	1989-09-25 00:00:00	1989-09-25	5001	0	\N	0	0	\N	\N	0	279330	0	127783003	4133840		
72189	2211	4024958	1981-05-30	1981-05-30 00:00:00	1981-05-30	5001	0	\N	0	0	\N	\N	0	147321	0	117015009	4024958		
19768	1808	3051031	1980-07-01	1980-07-01 00:00:00	1980-07-01	5001	0	\N	0	0	\N	\N	0	121029	0	46240-8	3051031		
144339	4437	4024958	1976-10-01	1976-10-01 00:00:00	1976-10-01	5001	0	\N	0	0	\N	\N	0	294941	0	117015009	4024958		
12492	1189	3006322	2005-07-06	2005-07-06 00:00:00	2005-07-06	5001	0	\N	0	0	\N	\N	0	78305	0	8331-1	3006322		
68294	2088	4133840	2003-06-24	2003-06-24 00:00:00	2003-06-24	5001	0	\N	0	0	\N	\N	0	139289	0	127783003	4133840		
156770	4819	4024958	1965-09-10	1965-09-10 00:00:00	1965-09-10	5001	0	\N	0	0	\N	\N	0	320521	0	117015009	4024958		
17431	1593	46235214	1967-01-31	1967-01-31 00:00:00	1967-01-31	5001	0	\N	0	0	\N	\N	0	106864	0	76690-7	46235214		
7840	752	40758406	2013-03-08	2013-03-08 00:00:00	2013-03-08	5001	0	\N	0	0	\N	\N	0	49681	0	55277-8	40758406		
51033	4655	3005136	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	310367	0	6075-6	3005136		
6938	664	3036780	2010-07-27	2010-07-27 00:00:00	2010-07-27	5001	0	\N	0	0	\N	\N	0	43821	0	6095-4	3036780		
23255	2136	3023430	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	142306	0	6833-8	3023430		
45412	4194	3006322	2003-12-16	2003-12-16 00:00:00	2003-12-16	5001	0	\N	0	0	\N	\N	0	278379	0	8331-1	3006322		
56750	5207	3051031	2001-08-27	2001-08-27 00:00:00	2001-08-27	5001	0	\N	0	0	\N	\N	0	346365	0	46240-8	3051031		
136490	4206	4024958	1970-12-12	1970-12-12 00:00:00	1970-12-12	5001	0	\N	0	0	\N	\N	0	279278	0	117015009	4024958		
72197	2211	4052083	2001-08-16	2001-08-16 00:00:00	2001-08-16	5001	0	\N	0	0	\N	\N	0	147329	0	23426006	4052083		
19769	1808	40758406	1980-05-02	1980-05-02 00:00:00	1980-05-02	5001	0	\N	0	0	\N	\N	0	121070	0	55277-8	40758406		
112442	3469	4052083	2001-07-18	2001-07-18 00:00:00	2001-07-18	5001	0	\N	0	0	\N	\N	0	230257	0	23426006	4052083		
68297	2088	4133840	1975-08-12	1975-08-12 00:00:00	1975-08-12	5001	0	\N	0	0	\N	\N	0	139251	0	127783003	4133840		
156781	4820	4024958	1968-04-18	1968-04-18 00:00:00	1968-04-18	5001	0	\N	0	0	\N	\N	0	320619	0	117015009	4024958		
17432	1593	40766240	1968-07-24	1968-07-24 00:00:00	1968-07-24	5001	0	\N	0	0	\N	\N	0	106897	0	63513-6	40766240		
7841	752	3051031	2013-03-08	2013-03-08 00:00:00	2013-03-08	5001	0	\N	0	0	\N	\N	0	49681	0	46240-8	3051031		
51034	4655	3015076	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	310367	0	6248-9	3015076		
6939	664	3006322	1985-03-22	1985-03-22 00:00:00	1985-03-22	5001	0	\N	0	0	\N	\N	0	43803	0	8331-1	3006322		
23256	2136	3001247	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	142306	0	6085-5	3001247		
167842	5151	4052083	2015-11-26	2015-11-26 00:00:00	2015-11-26	5001	0	\N	0	0	\N	\N	0	342513	0	23426006	4052083		
56752	5207	40766240	2001-08-27	2001-08-27 00:00:00	2001-08-27	5001	0	\N	0	0	\N	\N	0	346365	0	63513-6	40766240		
136492	4206	4133840	1987-09-21	1987-09-21 00:00:00	1987-09-21	5001	0	\N	0	0	\N	\N	0	279307	0	127783003	4133840		
72201	2211	4024958	1984-08-22	1984-08-22 00:00:00	1984-08-22	5001	0	\N	0	0	\N	\N	0	147302	0	117015009	4024958		
19771	1808	40766240	1980-05-02	1980-05-02 00:00:00	1980-05-02	5001	0	\N	0	0	\N	\N	0	121070	0	63513-6	40766240		
112446	3469	4024958	1956-08-14	1956-08-14 00:00:00	1956-08-14	5001	0	\N	0	0	\N	\N	0	230240	0	117015009	4024958		
68300	2088	4133840	2007-02-06	2007-02-06 00:00:00	2007-02-06	5001	0	\N	0	0	\N	\N	0	139267	0	127783003	4133840		
19504	610	4024958	1973-08-27	1973-08-27 00:00:00	1973-08-27	5001	0	\N	0	0	\N	\N	0	40578	0	117015009	4024958		
17434	1593	40758406	1968-07-24	1968-07-24 00:00:00	1968-07-24	5001	0	\N	0	0	\N	\N	0	106897	0	55277-8	40758406		
7842	752	40766240	2013-03-08	2013-03-08 00:00:00	2013-03-08	5001	0	\N	0	0	\N	\N	0	49681	0	63513-6	40766240		
51035	4655	3027231	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	310367	0	6276-0	3027231		
6940	664	3015076	2010-07-27	2010-07-27 00:00:00	2010-07-27	5001	0	\N	0	0	\N	\N	0	43821	0	6248-9	3015076		
23257	2136	3015076	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	142306	0	6248-9	3015076		
167844	5151	4024958	1992-01-15	1992-01-15 00:00:00	1992-01-15	5001	0	\N	0	0	\N	\N	0	342503	0	117015009	4024958		
56753	5207	40758406	2001-08-27	2001-08-27 00:00:00	2001-08-27	5001	0	\N	0	0	\N	\N	0	346365	0	55277-8	40758406		
136494	4206	4052083	1980-09-16	1980-09-16 00:00:00	1980-09-16	5001	0	\N	0	0	\N	\N	0	279298	0	23426006	4052083		
13514	1276	3000876	1993-07-09	1993-07-09 00:00:00	1993-07-09	5001	0	\N	0	0	\N	\N	0	84260	0	6082-2	3000876		
19772	1808	46235214	1980-05-02	1980-05-02 00:00:00	1980-05-02	5001	0	\N	0	0	\N	\N	0	121070	0	76690-7	46235214		
112451	3469	4024958	1968-08-20	1968-08-20 00:00:00	1968-08-20	5001	0	\N	0	0	\N	\N	0	230296	0	117015009	4024958		
68302	2088	4133840	2008-02-12	2008-02-12 00:00:00	2008-02-12	5001	0	\N	0	0	\N	\N	0	139282	0	127783003	4133840		
30799	956	4024958	1961-10-20	1961-10-20 00:00:00	1961-10-20	5001	0	\N	0	0	\N	\N	0	63447	0	117015009	4024958		
17436	1593	3051031	1968-07-24	1968-07-24 00:00:00	1968-07-24	5001	0	\N	0	0	\N	\N	0	106897	0	46240-8	3051031		
7845	752	3006322	1960-06-03	1960-06-03 00:00:00	1960-06-03	5001	0	\N	0	0	\N	\N	0	49654	0	8331-1	3006322		
51036	4655	3000876	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	310367	0	6082-2	3000876		
6941	664	3005136	2010-07-27	2010-07-27 00:00:00	2010-07-27	5001	0	\N	0	0	\N	\N	0	43821	0	6075-6	3005136		
23258	2136	3021226	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	142306	0	6246-3	3021226		
167857	5151	4024958	1964-12-13	1964-12-13 00:00:00	1964-12-13	5001	0	\N	0	0	\N	\N	0	342508	0	117015009	4024958		
56754	5207	40758406	2001-03-30	2001-03-30 00:00:00	2001-03-30	5001	0	\N	0	0	\N	\N	0	346348	0	55277-8	40758406		
136495	4206	4133840	1994-09-12	1994-09-12 00:00:00	1994-09-12	5001	0	\N	0	0	\N	\N	0	279323	0	127783003	4133840		
95463	2926	4024958	1992-08-25	1992-08-25 00:00:00	1992-08-25	5001	0	\N	0	0	\N	\N	0	195190	0	117015009	4024958		
19774	1808	3051031	1980-05-02	1980-05-02 00:00:00	1980-05-02	5001	0	\N	0	0	\N	\N	0	121070	0	46240-8	3051031		
112479	3470	4052083	2008-12-20	2008-12-20 00:00:00	2008-12-20	5001	0	\N	0	0	\N	\N	0	230351	0	23426006	4052083		
68304	2088	4024958	1934-12-07	1934-12-07 00:00:00	1934-12-07	5001	0	\N	0	0	\N	\N	0	139167	0	117015009	4024958		
30807	956	4024958	1941-11-04	1941-11-04 00:00:00	1941-11-04	5001	0	\N	0	0	\N	\N	0	63504	0	117015009	4024958		
17437	1593	46235214	1968-07-24	1968-07-24 00:00:00	1968-07-24	5001	0	\N	0	0	\N	\N	0	106897	0	76690-7	46235214		
7846	752	3006322	2014-05-08	2014-05-08 00:00:00	2014-05-08	5001	0	\N	0	0	\N	\N	0	49722	0	8331-1	3006322		
51037	4655	3012494	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	310367	0	6206-7	3012494		
6942	664	3012494	2010-07-27	2010-07-27 00:00:00	2010-07-27	5001	0	\N	0	0	\N	\N	0	43821	0	6206-7	3012494		
23259	2136	3014599	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	142306	0	6106-9	3014599		
167860	5151	4024958	1995-03-11	1995-03-11 00:00:00	1995-03-11	5001	0	\N	0	0	\N	\N	0	342549	0	117015009	4024958		
56756	5207	46235214	2001-03-30	2001-03-30 00:00:00	2001-03-30	5001	0	\N	0	0	\N	\N	0	346348	0	76690-7	46235214		
136497	4206	4133840	1991-09-30	1991-09-30 00:00:00	1991-09-30	5001	0	\N	0	0	\N	\N	0	279308	0	127783003	4133840		
95466	2926	4052083	1984-09-04	1984-09-04 00:00:00	1984-09-04	5001	0	\N	0	0	\N	\N	0	195195	0	23426006	4052083		
19776	1808	3051031	1980-03-03	1980-03-03 00:00:00	1980-03-03	5001	0	\N	0	0	\N	\N	0	121048	0	46240-8	3051031		
112482	3470	4052083	1980-10-18	1980-10-18 00:00:00	1980-10-18	5001	0	\N	0	0	\N	\N	0	230322	0	23426006	4052083		
68310	2088	4133840	2017-08-01	2017-08-01 00:00:00	2017-08-01	5001	0	\N	0	0	\N	\N	0	139274	0	127783003	4133840		
54014	1640	4024958	1959-02-09	1959-02-09 00:00:00	1959-02-09	5001	0	\N	0	0	\N	\N	0	110102	0	117015009	4024958		
17438	1593	3006322	1959-06-22	1959-06-22 00:00:00	1959-06-22	5001	0	\N	0	0	\N	\N	0	106941	0	8331-1	3006322		
7847	752	46235214	2012-11-08	2012-11-08 00:00:00	2012-11-08	5001	0	\N	0	0	\N	\N	0	49657	0	76690-7	46235214		
51038	4655	3019406	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	310367	0	6158-0	3019406		
6943	664	3006734	2010-07-27	2010-07-27 00:00:00	2010-07-27	5001	0	\N	0	0	\N	\N	0	43821	0	6189-5	3006734		
23260	2136	3012494	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	142306	0	6206-7	3012494		
167862	5151	4052083	1983-10-14	1983-10-14 00:00:00	1983-10-14	5001	0	\N	0	0	\N	\N	0	342509	0	23426006	4052083		
56758	5207	3051031	2001-03-30	2001-03-30 00:00:00	2001-03-30	5001	0	\N	0	0	\N	\N	0	346348	0	46240-8	3051031		
136500	4206	4133840	1995-09-18	1995-09-18 00:00:00	1995-09-18	5001	0	\N	0	0	\N	\N	0	279310	0	127783003	4133840		
95480	2926	4024958	2012-10-13	2012-10-13 00:00:00	2012-10-13	5001	0	\N	0	0	\N	\N	0	195179	0	117015009	4024958		
19777	1808	46235214	1980-03-03	1980-03-03 00:00:00	1980-03-03	5001	0	\N	0	0	\N	\N	0	121048	0	76690-7	46235214		
112483	3470	4024958	1979-12-16	1979-12-16 00:00:00	1979-12-16	5001	0	\N	0	0	\N	\N	0	230318	0	117015009	4024958		
68311	2088	4133840	2013-07-09	2013-07-09 00:00:00	2013-07-09	5001	0	\N	0	0	\N	\N	0	139196	0	127783003	4133840		
54032	1640	4052083	1992-03-25	1992-03-25 00:00:00	1992-03-25	5001	0	\N	0	0	\N	\N	0	110043	0	23426006	4052083		
17439	1593	40758406	1968-01-26	1968-01-26 00:00:00	1968-01-26	5001	0	\N	0	0	\N	\N	0	106895	0	55277-8	40758406		
7848	752	3051031	2012-11-08	2012-11-08 00:00:00	2012-11-08	5001	0	\N	0	0	\N	\N	0	49657	0	46240-8	3051031		
51039	4655	3020655	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	310367	0	6844-5	3020655		
6944	664	3001488	2010-07-27	2010-07-27 00:00:00	2010-07-27	5001	0	\N	0	0	\N	\N	0	43821	0	7258-7	3001488		
23261	2136	3036780	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	142306	0	6095-4	3036780		
167867	5152	4024958	2001-10-25	2001-10-25 00:00:00	2001-10-25	5001	0	\N	0	0	\N	\N	0	342618	0	117015009	4024958		
56759	5207	40766240	2001-03-30	2001-03-30 00:00:00	2001-03-30	5001	0	\N	0	0	\N	\N	0	346348	0	63513-6	40766240		
136502	4206	4133840	1983-09-06	1983-09-06 00:00:00	1983-09-06	5001	0	\N	0	0	\N	\N	0	279322	0	127783003	4133840		
95483	2926	4024958	1992-12-06	1992-12-06 00:00:00	1992-12-06	5001	0	\N	0	0	\N	\N	0	195191	0	117015009	4024958		
19778	1808	40758406	1980-03-03	1980-03-03 00:00:00	1980-03-03	5001	0	\N	0	0	\N	\N	0	121048	0	55277-8	40758406		
112491	3470	4052083	1969-04-12	1969-04-12 00:00:00	1969-04-12	5001	0	\N	0	0	\N	\N	0	230299	0	23426006	4052083		
68313	2088	4133840	1988-07-19	1988-07-19 00:00:00	1988-07-19	5001	0	\N	0	0	\N	\N	0	139276	0	127783003	4133840		
54033	1640	4052083	1989-03-18	1989-03-18 00:00:00	1989-03-18	5001	0	\N	0	0	\N	\N	0	110083	0	23426006	4052083		
17441	1593	3051031	1968-01-26	1968-01-26 00:00:00	1968-01-26	5001	0	\N	0	0	\N	\N	0	106895	0	46240-8	3051031		
7849	752	40766240	2012-11-08	2012-11-08 00:00:00	2012-11-08	5001	0	\N	0	0	\N	\N	0	49657	0	63513-6	40766240		
51040	4655	3036780	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	310367	0	6095-4	3036780		
6945	664	3021226	2010-07-27	2010-07-27 00:00:00	2010-07-27	5001	0	\N	0	0	\N	\N	0	43821	0	6246-3	3021226		
23262	2136	3000876	2001-06-22	2001-06-22 00:00:00	2001-06-22	5001	0	\N	0	0	\N	\N	0	142306	0	6082-2	3000876		
167882	5153	4052083	1982-11-21	1982-11-21 00:00:00	1982-11-21	5001	0	\N	0	0	\N	\N	0	342668	0	23426006	4052083		
56760	5207	40758406	2001-01-29	2001-01-29 00:00:00	2001-01-29	5001	0	\N	0	0	\N	\N	0	346380	0	55277-8	40758406		
136504	4206	4133840	1993-09-06	1993-09-06 00:00:00	1993-09-06	5001	0	\N	0	0	\N	\N	0	279309	0	127783003	4133840		
95498	2927	4052083	2004-07-05	2004-07-05 00:00:00	2004-07-05	5001	0	\N	0	0	\N	\N	0	195206	0	23426006	4052083		
81174	2507	4052083	1992-05-22	1992-05-22 00:00:00	1992-05-22	5001	0	\N	0	0	\N	\N	0	165948	0	23426006	4052083		
57033	5232	3006322	1968-04-06	1968-04-06 00:00:00	1968-04-06	5001	0	\N	0	0	\N	\N	0	348087	0	8331-1	3006322		
68317	2088	4133840	2013-03-12	2013-03-12 00:00:00	2013-03-12	5001	0	\N	0	0	\N	\N	0	139244	0	127783003	4133840		
54035	1640	4052083	2003-06-18	2003-06-18 00:00:00	2003-06-18	5001	0	\N	0	0	\N	\N	0	110024	0	23426006	4052083		
17443	1593	40766240	1968-01-26	1968-01-26 00:00:00	1968-01-26	5001	0	\N	0	0	\N	\N	0	106895	0	63513-6	40766240		
7852	752	40758406	2012-11-08	2012-11-08 00:00:00	2012-11-08	5001	0	\N	0	0	\N	\N	0	49657	0	55277-8	40758406		
51041	4655	3021226	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	310367	0	6246-3	3021226		
6946	664	3014599	2010-07-27	2010-07-27 00:00:00	2010-07-27	5001	0	\N	0	0	\N	\N	0	43821	0	6106-9	3014599		
23263	2136	40769184	2001-06-03	2001-06-03 00:00:00	2001-06-03	5001	0	\N	0	0	\N	\N	0	142305	0	66524-0	40769184		
167886	5153	4052083	1970-03-27	1970-03-27 00:00:00	1970-03-27	5001	0	\N	0	0	\N	\N	0	342733	0	23426006	4052083		
56761	5207	40766240	2001-01-29	2001-01-29 00:00:00	2001-01-29	5001	0	\N	0	0	\N	\N	0	346380	0	63513-6	40766240		
136507	4206	4024958	1968-02-12	1968-02-12 00:00:00	1968-02-12	5001	0	\N	0	0	\N	\N	0	279325	0	117015009	4024958		
95500	2927	4052083	1962-07-20	1962-07-20 00:00:00	1962-07-20	5001	0	\N	0	0	\N	\N	0	195209	0	23426006	4052083		
81221	2509	4052083	2004-04-06	2004-04-06 00:00:00	2004-04-06	5001	0	\N	0	0	\N	\N	0	166097	0	23426006	4052083		
57034	5232	3006322	1982-12-08	1982-12-08 00:00:00	1982-12-08	5001	0	\N	0	0	\N	\N	0	348088	0	8331-1	3006322		
68321	2088	4133840	2004-06-29	2004-06-29 00:00:00	2004-06-29	5001	0	\N	0	0	\N	\N	0	139174	0	127783003	4133840		
54047	1640	4024958	1968-03-08	1968-03-08 00:00:00	1968-03-08	5001	0	\N	0	0	\N	\N	0	110012	0	117015009	4024958		
17444	1593	46235214	1968-01-26	1968-01-26 00:00:00	1968-01-26	5001	0	\N	0	0	\N	\N	0	106895	0	76690-7	46235214		
7853	752	3006322	1983-11-22	1983-11-22 00:00:00	1983-11-22	5001	0	\N	0	0	\N	\N	0	49678	0	8331-1	3006322		
51042	4655	3001247	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	310367	0	6085-5	3001247		
6947	664	3027231	2010-07-27	2010-07-27 00:00:00	2010-07-27	5001	0	\N	0	0	\N	\N	0	43821	0	6276-0	3027231		
23264	2136	40769179	2001-06-03	2001-06-03 00:00:00	2001-06-03	5001	0	\N	0	0	\N	\N	0	142305	0	66519-0	40769179		
40419	3756	3011505	2006-05-13	2006-05-13 00:00:00	2006-05-13	5001	0	\N	0	0	\N	\N	0	249707	0	19926-5	3011505		
56762	5207	46235214	2001-01-29	2001-01-29 00:00:00	2001-01-29	5001	0	\N	0	0	\N	\N	0	346380	0	76690-7	46235214		
136508	4206	4133840	1985-09-16	1985-09-16 00:00:00	1985-09-16	5001	0	\N	0	0	\N	\N	0	279341	0	127783003	4133840		
95527	2927	4052083	1958-05-21	1958-05-21 00:00:00	1958-05-21	5001	0	\N	0	0	\N	\N	0	195199	0	23426006	4052083		
81226	2509	4052083	1972-06-24	1972-06-24 00:00:00	1972-06-24	5001	0	\N	0	0	\N	\N	0	166049	0	23426006	4052083		
57035	5232	3006322	2004-01-12	2004-01-12 00:00:00	2004-01-12	5001	0	\N	0	0	\N	\N	0	348084	0	8331-1	3006322		
68327	2088	4133840	1994-05-03	1994-05-03 00:00:00	1994-05-03	5001	0	\N	0	0	\N	\N	0	139203	0	127783003	4133840		
54052	1640	4024958	2005-03-24	2005-03-24 00:00:00	2005-03-24	5001	0	\N	0	0	\N	\N	0	110103	0	117015009	4024958		
17445	1593	3006322	2014-08-02	2014-08-02 00:00:00	2014-08-02	5001	0	\N	0	0	\N	\N	0	106892	0	8331-1	3006322		
7854	753	3006322	2011-07-05	2011-07-05 00:00:00	2011-07-05	5001	0	\N	0	0	\N	\N	0	49799	0	8331-1	3006322		
51043	4655	3001488	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	310367	0	7258-7	3001488		
6948	664	3036780	2010-07-27	2010-07-27 00:00:00	2010-07-27	5001	0	\N	0	0	\N	\N	0	43821	0	6095-4	3036780		
23265	2136	40769189	2001-06-03	2001-06-03 00:00:00	2001-06-03	5001	0	\N	0	0	\N	\N	0	142305	0	66529-9	40769189		
40420	3756	3006322	2004-08-09	2004-08-09 00:00:00	2004-08-09	5001	0	\N	0	0	\N	\N	0	249650	0	8331-1	3006322		
56764	5207	3051031	2001-01-29	2001-01-29 00:00:00	2001-01-29	5001	0	\N	0	0	\N	\N	0	346380	0	46240-8	3051031		
136509	4206	4052083	1973-01-29	1973-01-29 00:00:00	1973-01-29	5001	0	\N	0	0	\N	\N	0	279286	0	23426006	4052083		
2328	213	3006322	2014-06-17	2014-06-17 00:00:00	2014-06-17	5001	0	\N	0	0	\N	\N	0	14526	0	8331-1	3006322		
27732	2554	3015076	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	169268	0	6248-9	3015076		
57036	5233	3006322	2018-06-08	2018-06-08 00:00:00	2018-06-08	5001	0	\N	0	0	\N	\N	0	348157	0	8331-1	3006322		
68330	2088	4133840	2006-07-11	2006-07-11 00:00:00	2006-07-11	5001	0	\N	0	0	\N	\N	0	139281	0	127783003	4133840		
54053	1640	4024958	1994-12-16	1994-12-16 00:00:00	1994-12-16	5001	0	\N	0	0	\N	\N	0	110044	0	117015009	4024958		
17447	1593	40766240	1968-09-22	1968-09-22 00:00:00	1968-09-22	5001	0	\N	0	0	\N	\N	0	106849	0	63513-6	40766240		
7855	753	3006322	1976-02-26	1976-02-26 00:00:00	1976-02-26	5001	0	\N	0	0	\N	\N	0	49812	0	8331-1	3006322		
51044	4655	3006734	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	310367	0	6189-5	3006734		
6949	664	3006451	2010-07-27	2010-07-27 00:00:00	2010-07-27	5001	0	\N	0	0	\N	\N	0	43821	0	6273-7	3006451		
23266	2136	40769194	2001-06-03	2001-06-03 00:00:00	2001-06-03	5001	0	\N	0	0	\N	\N	0	142305	0	66534-9	40769194		
40421	3756	3011505	2010-06-05	2010-06-05 00:00:00	2010-06-05	5001	0	\N	0	0	\N	\N	0	249677	0	19926-5	3011505		
56766	5207	3006322	1971-01-24	1971-01-24 00:00:00	1971-01-24	5001	0	\N	0	0	\N	\N	0	346345	0	8331-1	3006322		
136526	4208	4024958	1943-08-01	1943-08-01 00:00:00	1943-08-01	5001	0	\N	0	0	\N	\N	0	279393	0	117015009	4024958		
2329	213	3006322	2001-12-09	2001-12-09 00:00:00	2001-12-09	5001	0	\N	0	0	\N	\N	0	14477	0	8331-1	3006322		
27733	2554	3019406	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	169268	0	6158-0	3019406		
57037	5233	3006322	1968-03-22	1968-03-22 00:00:00	1968-03-22	5001	0	\N	0	0	\N	\N	0	348138	0	8331-1	3006322		
68333	2088	4133840	1980-09-09	1980-09-09 00:00:00	1980-09-09	5001	0	\N	0	0	\N	\N	0	139275	0	127783003	4133840		
65341	2002	4024958	1999-04-09	1999-04-09 00:00:00	1999-04-09	5001	0	\N	0	0	\N	\N	0	133353	0	117015009	4024958		
17448	1593	3051031	1968-09-22	1968-09-22 00:00:00	1968-09-22	5001	0	\N	0	0	\N	\N	0	106849	0	46240-8	3051031		
7856	753	3006322	2017-03-31	2017-03-31 00:00:00	2017-03-31	5001	0	\N	0	0	\N	\N	0	49775	0	8331-1	3006322		
51045	4655	3006451	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	310367	0	6273-7	3006451		
6950	664	3019406	2010-07-27	2010-07-27 00:00:00	2010-07-27	5001	0	\N	0	0	\N	\N	0	43821	0	6158-0	3019406		
50093	1523	4052083	1974-07-29	1974-07-29 00:00:00	1974-07-29	5001	0	\N	0	0	\N	\N	0	101883	0	23426006	4052083		
40422	3756	3006322	1948-05-27	1948-05-27 00:00:00	1948-05-27	5001	0	\N	0	0	\N	\N	0	249667	0	8331-1	3006322		
56770	5210	40758406	1973-01-05	1973-01-05 00:00:00	1973-01-05	5001	0	\N	0	0	\N	\N	0	346473	0	55277-8	40758406		
136550	4208	4024958	1962-04-03	1962-04-03 00:00:00	1962-04-03	5001	0	\N	0	0	\N	\N	0	279432	0	117015009	4024958		
2330	213	3006322	1986-09-05	1986-09-05 00:00:00	1986-09-05	5001	0	\N	0	0	\N	\N	0	14511	0	8331-1	3006322		
27734	2554	3005136	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	169268	0	6075-6	3005136		
57038	5233	3006322	2012-07-23	2012-07-23 00:00:00	2012-07-23	5001	0	\N	0	0	\N	\N	0	348192	0	8331-1	3006322		
68336	2088	4133840	2000-06-06	2000-06-06 00:00:00	2000-06-06	5001	0	\N	0	0	\N	\N	0	139172	0	127783003	4133840		
151687	4646	4024958	1948-11-07	1948-11-07 00:00:00	1948-11-07	5001	0	\N	0	0	\N	\N	0	309784	0	117015009	4024958		
17449	1593	46235214	1968-09-22	1968-09-22 00:00:00	1968-09-22	5001	0	\N	0	0	\N	\N	0	106849	0	76690-7	46235214		
7857	753	3006322	2013-02-08	2013-02-08 00:00:00	2013-02-08	5001	0	\N	0	0	\N	\N	0	49747	0	8331-1	3006322		
51046	4655	3014599	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	310367	0	6106-9	3014599		
6951	664	3001247	2010-07-27	2010-07-27 00:00:00	2010-07-27	5001	0	\N	0	0	\N	\N	0	43821	0	6085-5	3001247		
50097	1523	4024958	1996-10-11	1996-10-11 00:00:00	1996-10-11	5001	0	\N	0	0	\N	\N	0	101885	0	117015009	4024958		
40423	3756	3011505	2014-06-28	2014-06-28 00:00:00	2014-06-28	5001	0	\N	0	0	\N	\N	0	249692	0	19926-5	3011505		
56771	5210	3051031	1973-01-05	1973-01-05 00:00:00	1973-01-05	5001	0	\N	0	0	\N	\N	0	346473	0	46240-8	3051031		
136556	4208	4052083	1961-02-17	1961-02-17 00:00:00	1961-02-17	5001	0	\N	0	0	\N	\N	0	279398	0	23426006	4052083		
2331	213	3006322	2017-03-16	2017-03-16 00:00:00	2017-03-16	5001	0	\N	0	0	\N	\N	0	14528	0	8331-1	3006322		
27735	2554	3006322	1969-03-14	1969-03-14 00:00:00	1969-03-14	5001	0	\N	0	0	\N	\N	0	169264	0	8331-1	3006322		
57039	5233	3006322	2001-02-07	2001-02-07 00:00:00	2001-02-07	5001	0	\N	0	0	\N	\N	0	348156	0	8331-1	3006322		
68339	2088	4133840	1977-08-23	1977-08-23 00:00:00	1977-08-23	5001	0	\N	0	0	\N	\N	0	139252	0	127783003	4133840		
3042	94	4052083	2015-11-30	2015-11-30 00:00:00	2015-11-30	5001	0	\N	0	0	\N	\N	0	6347	0	23426006	4052083		
17450	1593	40758406	1968-09-22	1968-09-22 00:00:00	1968-09-22	5001	0	\N	0	0	\N	\N	0	106849	0	55277-8	40758406		
7858	753	3006322	1973-04-27	1973-04-27 00:00:00	1973-04-27	5001	0	\N	0	0	\N	\N	0	49811	0	8331-1	3006322		
51047	4655	3023430	1993-07-11	1993-07-11 00:00:00	1993-07-11	5001	0	\N	0	0	\N	\N	0	310367	0	6833-8	3023430		
6952	664	3020655	2010-07-27	2010-07-27 00:00:00	2010-07-27	5001	0	\N	0	0	\N	\N	0	43821	0	6844-5	3020655		
50119	1524	4024958	1968-03-08	1968-03-08 00:00:00	1968-03-08	5001	0	\N	0	0	\N	\N	0	101914	0	117015009	4024958		
40424	3756	3049273	2001-08-02	2001-08-02 00:00:00	2001-08-02	5001	0	\N	0	0	\N	\N	0	249664	0	38265-5	3049273		
5751	539	3006322	1980-12-18	1980-12-18 00:00:00	1980-12-18	5001	0	\N	0	0	\N	\N	0	35815	0	8331-1	3006322		
171065	5249	4024958	1994-03-17	1994-03-17 00:00:00	1994-03-17	5001	0	\N	0	0	\N	\N	0	349159	0	117015009	4024958		
2333	217	3006322	1997-08-29	1997-08-29 00:00:00	1997-08-29	5001	0	\N	0	0	\N	\N	0	14645	0	8331-1	3006322		
27736	2554	3049273	2003-12-25	2003-12-25 00:00:00	2003-12-25	5001	0	\N	0	0	\N	\N	0	169107	0	38265-5	3049273		
57040	5234	3011505	2004-07-07	2004-07-07 00:00:00	2004-07-07	5001	0	\N	0	0	\N	\N	0	348276	0	19926-5	3011505		
68341	2088	4133840	2015-07-21	2015-07-21 00:00:00	2015-07-21	5001	0	\N	0	0	\N	\N	0	139197	0	127783003	4133840		
14321	449	4133840	2001-07-05	2001-07-05 00:00:00	2001-07-05	5001	0	\N	0	0	\N	\N	0	29991	0	127783003	4133840		
168183	5165	4024958	1973-01-03	1973-01-03 00:00:00	1973-01-03	5001	0	\N	0	0	\N	\N	0	343247	0	117015009	4024958		
7859	754	3006322	1952-01-11	1952-01-11 00:00:00	1952-01-11	5001	0	\N	0	0	\N	\N	0	49846	0	8331-1	3006322		
51048	4655	3006322	1970-03-27	1970-03-27 00:00:00	1970-03-27	5001	0	\N	0	0	\N	\N	0	310380	0	8331-1	3006322		
6953	664	3023430	2010-07-27	2010-07-27 00:00:00	2010-07-27	5001	0	\N	0	0	\N	\N	0	43821	0	6833-8	3023430		
61399	1878	4024958	2013-07-12	2013-07-12 00:00:00	2013-07-12	5001	0	\N	0	0	\N	\N	0	125325	0	117015009	4024958		
40425	3756	3011505	2017-07-15	2017-07-15 00:00:00	2017-07-15	5001	0	\N	0	0	\N	\N	0	249709	0	19926-5	3011505		
5753	539	3006322	1989-07-18	1989-07-18 00:00:00	1989-07-18	5001	0	\N	0	0	\N	\N	0	35796	0	8331-1	3006322		
171071	5249	4052083	1963-07-10	1963-07-10 00:00:00	1963-07-10	5001	0	\N	0	0	\N	\N	0	349194	0	23426006	4052083		
2334	217	3006322	2017-03-15	2017-03-15 00:00:00	2017-03-15	5001	0	\N	0	0	\N	\N	0	14670	0	8331-1	3006322		
27737	2554	3006322	2007-01-28	2007-01-28 00:00:00	2007-01-28	5001	0	\N	0	0	\N	\N	0	169223	0	8331-1	3006322		
57041	5234	3011505	1997-04-23	1997-04-23 00:00:00	1997-04-23	5001	0	\N	0	0	\N	\N	0	348274	0	19926-5	3011505		
68345	2088	4133840	1974-08-06	1974-08-06 00:00:00	1974-08-06	5001	0	\N	0	0	\N	\N	0	139320	0	127783003	4133840		
14324	449	4133840	2001-03-01	2001-03-01 00:00:00	2001-03-01	5001	0	\N	0	0	\N	\N	0	29990	0	127783003	4133840		
168185	5165	4052083	1993-04-29	1993-04-29 00:00:00	1993-04-29	5001	0	\N	0	0	\N	\N	0	343347	0	23426006	4052083		
7860	754	3049273	2008-04-09	2008-04-09 00:00:00	2008-04-09	5001	0	\N	0	0	\N	\N	0	49825	0	38265-5	3049273		
51049	4655	3006322	1962-10-27	1962-10-27 00:00:00	1962-10-27	5001	0	\N	0	0	\N	\N	0	310391	0	8331-1	3006322		
6954	664	3000876	2010-07-27	2010-07-27 00:00:00	2010-07-27	5001	0	\N	0	0	\N	\N	0	43821	0	6082-2	3000876		
61403	1878	4024958	1996-08-01	1996-08-01 00:00:00	1996-08-01	5001	0	\N	0	0	\N	\N	0	125322	0	117015009	4024958		
40426	3756	3011505	2012-06-16	2012-06-16 00:00:00	2012-06-16	5001	0	\N	0	0	\N	\N	0	249678	0	19926-5	3011505		
5754	539	3006322	1990-02-06	1990-02-06 00:00:00	1990-02-06	5001	0	\N	0	0	\N	\N	0	35837	0	8331-1	3006322		
171072	5249	4024958	1985-05-20	1985-05-20 00:00:00	1985-05-20	5001	0	\N	0	0	\N	\N	0	349172	0	117015009	4024958		
2335	217	3006322	1986-11-14	1986-11-14 00:00:00	1986-11-14	5001	0	\N	0	0	\N	\N	0	14680	0	8331-1	3006322		
27738	2554	3006322	1976-05-15	1976-05-15 00:00:00	1976-05-15	5001	0	\N	0	0	\N	\N	0	169267	0	8331-1	3006322		
57042	5234	3011505	2000-05-10	2000-05-10 00:00:00	2000-05-10	5001	0	\N	0	0	\N	\N	0	348281	0	19926-5	3011505		
68347	2088	4133840	1968-11-19	1968-11-19 00:00:00	1968-11-19	5001	0	\N	0	0	\N	\N	0	139318	0	127783003	4133840		
14326	449	4052083	1981-07-23	1981-07-23 00:00:00	1981-07-23	5001	0	\N	0	0	\N	\N	0	29874	0	23426006	4052083		
30852	958	4052083	1990-01-15	1990-01-15 00:00:00	1990-01-15	5001	0	\N	0	0	\N	\N	0	63635	0	23426006	4052083		
7861	754	3021226	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	49994	0	6246-3	3021226		
51050	4655	3006322	2015-02-17	2015-02-17 00:00:00	2015-02-17	5001	0	\N	0	0	\N	\N	0	310337	0	8331-1	3006322		
6955	664	3006322	1991-02-05	1991-02-05 00:00:00	1991-02-05	5001	0	\N	0	0	\N	\N	0	43866	0	8331-1	3006322		
27454	859	4024958	1963-10-02	1963-10-02 00:00:00	1963-10-02	5001	0	\N	0	0	\N	\N	0	56896	0	117015009	4024958		
40427	3756	3011505	2015-07-04	2015-07-04 00:00:00	2015-07-04	5001	0	\N	0	0	\N	\N	0	249708	0	19926-5	3011505		
5755	539	3006322	1989-11-26	1989-11-26 00:00:00	1989-11-26	5001	0	\N	0	0	\N	\N	0	35785	0	8331-1	3006322		
171079	5249	4052083	1979-02-02	1979-02-02 00:00:00	1979-02-02	5001	0	\N	0	0	\N	\N	0	349195	0	23426006	4052083		
2336	217	3006322	1979-05-18	1979-05-18 00:00:00	1979-05-18	5001	0	\N	0	0	\N	\N	0	14643	0	8331-1	3006322		
27739	2554	3000876	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	169268	0	6082-2	3000876		
57043	5234	3006322	1936-12-02	1936-12-02 00:00:00	1936-12-02	5001	0	\N	0	0	\N	\N	0	348242	0	8331-1	3006322		
68348	2088	4133840	1969-11-25	1969-11-25 00:00:00	1969-11-25	5001	0	\N	0	0	\N	\N	0	139250	0	127783003	4133840		
14329	449	4133840	2000-02-24	2000-02-24 00:00:00	2000-02-24	5001	0	\N	0	0	\N	\N	0	29971	0	127783003	4133840		
30859	958	4024958	2012-12-07	2012-12-07 00:00:00	2012-12-07	5001	0	\N	0	0	\N	\N	0	63646	0	117015009	4024958		
7862	754	3000876	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	49994	0	6082-2	3000876		
51051	4655	3006322	2006-06-20	2006-06-20 00:00:00	2006-06-20	5001	0	\N	0	0	\N	\N	0	310334	0	8331-1	3006322		
6956	665	3006322	1997-12-11	1997-12-11 00:00:00	1997-12-11	5001	0	\N	0	0	\N	\N	0	43993	0	8331-1	3006322		
27477	859	4052083	1971-07-09	1971-07-09 00:00:00	1971-07-09	5001	0	\N	0	0	\N	\N	0	56897	0	23426006	4052083		
40429	3756	40758406	2017-01-01	2017-01-01 00:00:00	2017-01-01	5001	0	\N	0	0	\N	\N	0	249611	0	55277-8	40758406		
5767	545	3006322	1983-06-04	1983-06-04 00:00:00	1983-06-04	5001	0	\N	0	0	\N	\N	0	36051	0	8331-1	3006322		
2337	217	3006322	1980-08-04	1980-08-04 00:00:00	1980-08-04	5001	0	\N	0	0	\N	\N	0	14646	0	8331-1	3006322		
27740	2554	3012494	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	169268	0	6206-7	3012494		
57044	5234	3011505	2005-07-13	2005-07-13 00:00:00	2005-07-13	5001	0	\N	0	0	\N	\N	0	348210	0	19926-5	3011505		
68351	2088	4133840	1982-09-21	1982-09-21 00:00:00	1982-09-21	5001	0	\N	0	0	\N	\N	0	139212	0	127783003	4133840		
14334	449	4133840	2009-07-23	2009-07-23 00:00:00	2009-07-23	5001	0	\N	0	0	\N	\N	0	29870	0	127783003	4133840		
30861	958	4024958	1969-05-06	1969-05-06 00:00:00	1969-05-06	5001	0	\N	0	0	\N	\N	0	63591	0	117015009	4024958		
7863	754	3012494	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	49994	0	6206-7	3012494		
51052	4655	3006322	1962-12-09	1962-12-09 00:00:00	1962-12-09	5001	0	\N	0	0	\N	\N	0	310263	0	8331-1	3006322		
6957	665	3006322	1964-07-26	1964-07-26 00:00:00	1964-07-26	5001	0	\N	0	0	\N	\N	0	43952	0	8331-1	3006322		
27500	859	4024958	1982-07-09	1982-07-09 00:00:00	1982-07-09	5001	0	\N	0	0	\N	\N	0	56794	0	117015009	4024958		
40430	3756	40766240	2017-01-01	2017-01-01 00:00:00	2017-01-01	5001	0	\N	0	0	\N	\N	0	249611	0	63513-6	40766240		
5768	545	3006322	1981-01-31	1981-01-31 00:00:00	1981-01-31	5001	0	\N	0	0	\N	\N	0	36134	0	8331-1	3006322		
2338	217	3006322	1979-12-27	1979-12-27 00:00:00	1979-12-27	5001	0	\N	0	0	\N	\N	0	14636	0	8331-1	3006322		
27741	2554	3021226	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	169268	0	6246-3	3021226		
57045	5234	3011505	2002-06-26	2002-06-26 00:00:00	2002-06-26	5001	0	\N	0	0	\N	\N	0	348283	0	19926-5	3011505		
68352	2088	4133840	1971-12-07	1971-12-07 00:00:00	1971-12-07	5001	0	\N	0	0	\N	\N	0	139310	0	127783003	4133840		
14341	449	4133840	2015-08-27	2015-08-27 00:00:00	2015-08-27	5001	0	\N	0	0	\N	\N	0	29993	0	127783003	4133840		
30869	959	4024958	1972-01-13	1972-01-13 00:00:00	1972-01-13	5001	0	\N	0	0	\N	\N	0	63749	0	117015009	4024958		
7864	754	3036780	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	49994	0	6095-4	3036780		
51053	4655	3006322	1968-02-24	1968-02-24 00:00:00	1968-02-24	5001	0	\N	0	0	\N	\N	0	310307	0	8331-1	3006322		
6958	665	3006322	2018-01-21	2018-01-21 00:00:00	2018-01-21	5001	0	\N	0	0	\N	\N	0	43976	0	8331-1	3006322		
541	30	3006322	1988-03-14	1988-03-14 00:00:00	1988-03-14	5001	0	\N	0	0	\N	\N	0	2102	0	8331-1	3006322		
40431	3756	46235214	2017-01-01	2017-01-01 00:00:00	2017-01-01	5001	0	\N	0	0	\N	\N	0	249611	0	76690-7	46235214		
5769	545	3006322	1974-08-27	1974-08-27 00:00:00	1974-08-27	5001	0	\N	0	0	\N	\N	0	36133	0	8331-1	3006322		
2339	217	3006322	2011-01-04	2011-01-04 00:00:00	2011-01-04	5001	0	\N	0	0	\N	\N	0	14639	0	8331-1	3006322		
27742	2554	3001488	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	169268	0	7258-7	3001488		
57046	5234	3049273	1989-07-20	1989-07-20 00:00:00	1989-07-20	5001	0	\N	0	0	\N	\N	0	348214	0	38265-5	3049273		
68355	2088	4133840	1999-06-01	1999-06-01 00:00:00	1999-06-01	5001	0	\N	0	0	\N	\N	0	139287	0	127783003	4133840		
14342	449	4133840	1991-08-29	1991-08-29 00:00:00	1991-08-29	5001	0	\N	0	0	\N	\N	0	29866	0	127783003	4133840		
30881	959	4052083	1992-04-17	1992-04-17 00:00:00	1992-04-17	5001	0	\N	0	0	\N	\N	0	63794	0	23426006	4052083		
7865	754	3020655	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	49994	0	6844-5	3020655		
51054	4656	3049273	2009-11-08	2009-11-08 00:00:00	2009-11-08	5001	0	\N	0	0	\N	\N	0	310440	0	38265-5	3049273		
6959	665	3006322	1958-03-21	1958-03-21 00:00:00	1958-03-21	5001	0	\N	0	0	\N	\N	0	43951	0	8331-1	3006322		
542	30	3006322	1993-03-19	1993-03-19 00:00:00	1993-03-19	5001	0	\N	0	0	\N	\N	0	2104	0	8331-1	3006322		
40432	3756	3051031	2017-01-01	2017-01-01 00:00:00	2017-01-01	5001	0	\N	0	0	\N	\N	0	249611	0	46240-8	3051031		
5770	545	3006322	2007-05-09	2007-05-09 00:00:00	2007-05-09	5001	0	\N	0	0	\N	\N	0	36063	0	8331-1	3006322		
2340	217	3006322	2017-10-24	2017-10-24 00:00:00	2017-10-24	5001	0	\N	0	0	\N	\N	0	14652	0	8331-1	3006322		
27743	2554	3001247	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	169268	0	6085-5	3001247		
57047	5234	3011505	1998-04-29	1998-04-29 00:00:00	1998-04-29	5001	0	\N	0	0	\N	\N	0	348208	0	19926-5	3011505		
68358	2088	4133840	1989-07-25	1989-07-25 00:00:00	1989-07-25	5001	0	\N	0	0	\N	\N	0	139235	0	127783003	4133840		
14354	449	4133840	1998-12-17	1998-12-17 00:00:00	1998-12-17	5001	0	\N	0	0	\N	\N	0	29869	0	127783003	4133840		
65350	2002	4052083	1980-05-17	1980-05-17 00:00:00	1980-05-17	5001	0	\N	0	0	\N	\N	0	133324	0	23426006	4052083		
7866	754	3023430	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	49994	0	6833-8	3023430		
51056	4656	3006322	1993-06-24	1993-06-24 00:00:00	1993-06-24	5001	0	\N	0	0	\N	\N	0	310457	0	8331-1	3006322		
6960	665	3006322	2007-07-09	2007-07-09 00:00:00	2007-07-09	5001	0	\N	0	0	\N	\N	0	43943	0	8331-1	3006322		
543	30	3006322	1990-09-13	1990-09-13 00:00:00	1990-09-13	5001	0	\N	0	0	\N	\N	0	2046	0	8331-1	3006322		
40434	3756	3006322	2003-10-27	2003-10-27 00:00:00	2003-10-27	5001	0	\N	0	0	\N	\N	0	249626	0	8331-1	3006322		
5771	545	3006322	2007-09-21	2007-09-21 00:00:00	2007-09-21	5001	0	\N	0	0	\N	\N	0	36064	0	8331-1	3006322		
2341	219	3006322	1970-08-19	1970-08-19 00:00:00	1970-08-19	5001	0	\N	0	0	\N	\N	0	14707	0	8331-1	3006322		
27744	2554	3027231	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	169268	0	6276-0	3027231		
57048	5234	3011505	2003-07-02	2003-07-02 00:00:00	2003-07-02	5001	0	\N	0	0	\N	\N	0	348209	0	19926-5	3011505		
68361	2088	4133840	2005-07-05	2005-07-05 00:00:00	2005-07-05	5001	0	\N	0	0	\N	\N	0	139241	0	127783003	4133840		
14360	449	4133840	2013-08-15	2013-08-15 00:00:00	2013-08-15	5001	0	\N	0	0	\N	\N	0	29872	0	127783003	4133840		
65361	2002	4052083	1996-02-09	1996-02-09 00:00:00	1996-02-09	5001	0	\N	0	0	\N	\N	0	133374	0	23426006	4052083		
7867	754	3006734	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	49994	0	6189-5	3006734		
51057	4656	3006322	1996-12-17	1996-12-17 00:00:00	1996-12-17	5001	0	\N	0	0	\N	\N	0	310451	0	8331-1	3006322		
76953	2357	4052083	1953-07-31	1953-07-31 00:00:00	1953-07-31	5001	0	\N	0	0	\N	\N	0	157080	0	23426006	4052083		
18269	1666	3006322	1944-11-01	1944-11-01 00:00:00	1944-11-01	5001	0	\N	0	0	\N	\N	0	111932	0	8331-1	3006322		
40435	3756	3011505	2018-07-21	2018-07-21 00:00:00	2018-07-21	5001	0	\N	0	0	\N	\N	0	249694	0	19926-5	3011505		
5772	545	3005136	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	36022	0	6075-6	3005136		
2342	219	3006322	2018-06-03	2018-06-03 00:00:00	2018-06-03	5001	0	\N	0	0	\N	\N	0	14730	0	8331-1	3006322		
27745	2554	3020655	1990-01-04	1990-01-04 00:00:00	1990-01-04	5001	0	\N	0	0	\N	\N	0	169268	0	6844-5	3020655		
57050	5234	3006322	1956-11-18	1956-11-18 00:00:00	1956-11-18	5001	0	\N	0	0	\N	\N	0	348244	0	8331-1	3006322		
68365	2088	4133840	2001-06-12	2001-06-12 00:00:00	2001-06-12	5001	0	\N	0	0	\N	\N	0	139288	0	127783003	4133840		
14370	450	4052083	2008-10-15	2008-10-15 00:00:00	2008-10-15	5001	0	\N	0	0	\N	\N	0	30008	0	23426006	4052083		
65363	2002	4052083	2010-04-19	2010-04-19 00:00:00	2010-04-19	5001	0	\N	0	0	\N	\N	0	133376	0	23426006	4052083		
7868	754	3006451	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	49994	0	6273-7	3006451		
51058	4656	3006322	1997-09-27	1997-09-27 00:00:00	1997-09-27	5001	0	\N	0	0	\N	\N	0	310482	0	8331-1	3006322		
76961	2357	4024958	1953-01-16	1953-01-16 00:00:00	1953-01-16	5001	0	\N	0	0	\N	\N	0	157079	0	117015009	4024958		
18270	1666	3006322	1949-02-18	1949-02-18 00:00:00	1949-02-18	5001	0	\N	0	0	\N	\N	0	111884	0	8331-1	3006322		
40436	3756	3011505	2005-05-07	2005-05-07 00:00:00	2005-05-07	5001	0	\N	0	0	\N	\N	0	249690	0	19926-5	3011505		
5773	545	3027231	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	36022	0	6276-0	3027231		
2343	219	3006322	1997-06-11	1997-06-11 00:00:00	1997-06-11	5001	0	\N	0	0	\N	\N	0	14736	0	8331-1	3006322		
39039	3609	3006322	2009-05-04	2009-05-04 00:00:00	2009-05-04	5001	0	\N	0	0	\N	\N	0	239769	0	8331-1	3006322		
57051	5234	3006322	1948-01-20	1948-01-20 00:00:00	1948-01-20	5001	0	\N	0	0	\N	\N	0	348218	0	8331-1	3006322		
68369	2088	4133840	1979-09-04	1979-09-04 00:00:00	1979-09-04	5001	0	\N	0	0	\N	\N	0	139253	0	127783003	4133840		
14386	450	4024958	2003-03-16	2003-03-16 00:00:00	2003-03-16	5001	0	\N	0	0	\N	\N	0	30007	0	117015009	4024958		
65390	2004	4052083	1988-08-05	1988-08-05 00:00:00	1988-08-05	5001	0	\N	0	0	\N	\N	0	133449	0	23426006	4052083		
7869	754	3014599	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	49994	0	6106-9	3014599		
6803	649	3006322	2013-10-24	2013-10-24 00:00:00	2013-10-24	5001	0	\N	0	0	\N	\N	0	42980	0	8331-1	3006322		
88253	2731	4024958	1963-05-01	1963-05-01 00:00:00	1963-05-01	5001	0	\N	0	0	\N	\N	0	180745	0	117015009	4024958		
18271	1666	3006322	1953-04-13	1953-04-13 00:00:00	1953-04-13	5001	0	\N	0	0	\N	\N	0	111853	0	8331-1	3006322		
40437	3756	3011505	2007-05-19	2007-05-19 00:00:00	2007-05-19	5001	0	\N	0	0	\N	\N	0	249691	0	19926-5	3011505		
5774	545	3012494	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	36022	0	6206-7	3012494		
2344	220	3006322	1986-07-23	1986-07-23 00:00:00	1986-07-23	5001	0	\N	0	0	\N	\N	0	14808	0	8331-1	3006322		
39040	3609	3006322	1995-11-21	1995-11-21 00:00:00	1995-11-21	5001	0	\N	0	0	\N	\N	0	239743	0	8331-1	3006322		
57052	5234	3006322	1988-08-28	1988-08-28 00:00:00	1988-08-28	5001	0	\N	0	0	\N	\N	0	348268	0	8331-1	3006322		
68370	2088	4052083	1930-05-09	1930-05-09 00:00:00	1930-05-09	5001	0	\N	0	0	\N	\N	0	139226	0	23426006	4052083		
152034	4655	4024958	1962-12-09	1962-12-09 00:00:00	1962-12-09	5001	0	\N	0	0	\N	\N	0	310263	0	117015009	4024958		
65399	2004	4024958	1979-12-18	1979-12-18 00:00:00	1979-12-18	5001	0	\N	0	0	\N	\N	0	133441	0	117015009	4024958		
7870	754	3027231	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	49994	0	6276-0	3027231		
6804	649	3006322	1975-09-19	1975-09-19 00:00:00	1975-09-19	5001	0	\N	0	0	\N	\N	0	43016	0	8331-1	3006322		
88269	2731	4052083	1964-02-22	1964-02-22 00:00:00	1964-02-22	5001	0	\N	0	0	\N	\N	0	180820	0	23426006	4052083		
18272	1666	3006322	1979-05-13	1979-05-13 00:00:00	1979-05-13	5001	0	\N	0	0	\N	\N	0	111913	0	8331-1	3006322		
40438	3756	3011505	2004-05-01	2004-05-01 00:00:00	2004-05-01	5001	0	\N	0	0	\N	\N	0	249706	0	19926-5	3011505		
5775	545	3019406	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	36022	0	6158-0	3019406		
2345	220	3006322	2011-06-06	2011-06-06 00:00:00	2011-06-06	5001	0	\N	0	0	\N	\N	0	14815	0	8331-1	3006322		
39041	3609	3006322	2013-02-23	2013-02-23 00:00:00	2013-02-23	5001	0	\N	0	0	\N	\N	0	239748	0	8331-1	3006322		
57053	5234	3006322	1965-09-15	1965-09-15 00:00:00	1965-09-15	5001	0	\N	0	0	\N	\N	0	348245	0	8331-1	3006322		
148638	4551	4024958	2005-07-18	2005-07-18 00:00:00	2005-07-18	5001	0	\N	0	0	\N	\N	0	303342	0	117015009	4024958		
152050	4656	4052083	2009-08-29	2009-08-29 00:00:00	2009-08-29	5001	0	\N	0	0	\N	\N	0	310483	0	23426006	4052083		
65402	2004	4052083	2005-11-13	2005-11-13 00:00:00	2005-11-13	5001	0	\N	0	0	\N	\N	0	133438	0	23426006	4052083		
7871	754	3001488	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	49994	0	7258-7	3001488		
6805	651	3006322	1985-09-07	1985-09-07 00:00:00	1985-09-07	5001	0	\N	0	0	\N	\N	0	43105	0	8331-1	3006322		
18273	1666	3006322	1994-06-07	1994-06-07 00:00:00	1994-06-07	5001	0	\N	0	0	\N	\N	0	111945	0	8331-1	3006322		
40439	3756	3006322	1949-09-14	1949-09-14 00:00:00	1949-09-14	5001	0	\N	0	0	\N	\N	0	249622	0	8331-1	3006322		
5776	545	3015076	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	36022	0	6248-9	3015076		
2346	220	3006322	1997-07-08	1997-07-08 00:00:00	1997-07-08	5001	0	\N	0	0	\N	\N	0	14855	0	8331-1	3006322		
39042	3609	3006322	2008-07-26	2008-07-26 00:00:00	2008-07-26	5001	0	\N	0	0	\N	\N	0	239791	0	8331-1	3006322		
57054	5234	3011505	2000-06-14	2000-06-14 00:00:00	2000-06-14	5001	0	\N	0	0	\N	\N	0	348282	0	19926-5	3011505		
148640	4551	4052083	1981-09-03	1981-09-03 00:00:00	1981-09-03	5001	0	\N	0	0	\N	\N	0	303340	0	23426006	4052083		
65409	2005	4024958	2017-07-28	2017-07-28 00:00:00	2017-07-28	5001	0	\N	0	0	\N	\N	0	133513	0	117015009	4024958		
7872	754	3001247	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	49994	0	6085-5	3001247		
6806	651	3006322	1983-09-05	1983-09-05 00:00:00	1983-09-05	5001	0	\N	0	0	\N	\N	0	43104	0	8331-1	3006322		
18274	1666	3006322	1941-07-04	1941-07-04 00:00:00	1941-07-04	5001	0	\N	0	0	\N	\N	0	111883	0	8331-1	3006322		
40440	3756	3006322	1999-05-07	1999-05-07 00:00:00	1999-05-07	5001	0	\N	0	0	\N	\N	0	249649	0	8331-1	3006322		
5777	545	3021226	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	36022	0	6246-3	3021226		
2347	220	3006322	1985-08-17	1985-08-17 00:00:00	1985-08-17	5001	0	\N	0	0	\N	\N	0	14812	0	8331-1	3006322		
39043	3609	3006322	1987-02-25	1987-02-25 00:00:00	1987-02-25	5001	0	\N	0	0	\N	\N	0	239745	0	8331-1	3006322		
57055	5234	3011505	2001-06-20	2001-06-20 00:00:00	2001-06-20	5001	0	\N	0	0	\N	\N	0	348299	0	19926-5	3011505		
148641	4551	4024958	1983-04-26	1983-04-26 00:00:00	1983-04-26	5001	0	\N	0	0	\N	\N	0	303326	0	117015009	4024958		
65411	2005	4024958	2005-04-21	2005-04-21 00:00:00	2005-04-21	5001	0	\N	0	0	\N	\N	0	133522	0	117015009	4024958		
7873	754	3015076	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	49994	0	6248-9	3015076		
6807	651	3006322	1988-11-29	1988-11-29 00:00:00	1988-11-29	5001	0	\N	0	0	\N	\N	0	43107	0	8331-1	3006322		
18293	1669	3011505	2002-02-25	2002-02-25 00:00:00	2002-02-25	5001	0	\N	0	0	\N	\N	0	112116	0	19926-5	3011505		
40441	3756	3006322	1948-09-07	1948-09-07 00:00:00	1948-09-07	5001	0	\N	0	0	\N	\N	0	249668	0	8331-1	3006322		
5778	545	3001488	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	36022	0	7258-7	3001488		
2348	222	3006322	1957-10-15	1957-10-15 00:00:00	1957-10-15	5001	0	\N	0	0	\N	\N	0	14882	0	8331-1	3006322		
39044	3609	3006322	2007-05-17	2007-05-17 00:00:00	2007-05-17	5001	0	\N	0	0	\N	\N	0	239755	0	8331-1	3006322		
57056	5234	3011505	1999-05-05	1999-05-05 00:00:00	1999-05-05	5001	0	\N	0	0	\N	\N	0	348275	0	19926-5	3011505		
65420	2005	4024958	2003-12-04	2003-12-04 00:00:00	2003-12-04	5001	0	\N	0	0	\N	\N	0	133525	0	117015009	4024958		
7874	754	3019406	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	49994	0	6158-0	3019406		
6808	652	3006322	1998-06-13	1998-06-13 00:00:00	1998-06-13	5001	0	\N	0	0	\N	\N	0	43162	0	8331-1	3006322		
18294	1669	3011505	2017-05-01	2017-05-01 00:00:00	2017-05-01	5001	0	\N	0	0	\N	\N	0	112108	0	19926-5	3011505		
40442	3756	3006322	1947-01-22	1947-01-22 00:00:00	1947-01-22	5001	0	\N	0	0	\N	\N	0	249640	0	8331-1	3006322		
5779	545	3001247	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	36022	0	6085-5	3001247		
39045	3609	3006322	1998-01-22	1998-01-22 00:00:00	1998-01-22	5001	0	\N	0	0	\N	\N	0	239747	0	8331-1	3006322		
57057	5234	3011505	2006-07-19	2006-07-19 00:00:00	2006-07-19	5001	0	\N	0	0	\N	\N	0	348277	0	19926-5	3011505		
8276	266	4024958	1973-12-25	1973-12-25 00:00:00	1973-12-25	5001	0	\N	0	0	\N	\N	0	17650	0	117015009	4024958		
7875	754	3005136	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	49994	0	6075-6	3005136		
6809	652	3006322	1995-06-16	1995-06-16 00:00:00	1995-06-16	5001	0	\N	0	0	\N	\N	0	43161	0	8331-1	3006322		
18295	1669	3011505	2010-03-22	2010-03-22 00:00:00	2010-03-22	5001	0	\N	0	0	\N	\N	0	112081	0	19926-5	3011505		
40443	3756	3011505	2016-07-09	2016-07-09 00:00:00	2016-07-09	5001	0	\N	0	0	\N	\N	0	249693	0	19926-5	3011505		
5780	545	3006734	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	36022	0	6189-5	3006734		
39046	3610	3006322	1978-10-19	1978-10-19 00:00:00	1978-10-19	5001	0	\N	0	0	\N	\N	0	239888	0	8331-1	3006322		
57059	5235	3006322	1940-10-27	1940-10-27 00:00:00	1940-10-27	5001	0	\N	0	0	\N	\N	0	348367	0	8331-1	3006322		
8293	266	4024958	1999-04-22	1999-04-22 00:00:00	1999-04-22	5001	0	\N	0	0	\N	\N	0	17659	0	117015009	4024958		
7876	754	3006322	1969-04-02	1969-04-02 00:00:00	1969-04-02	5001	0	\N	0	0	\N	\N	0	49980	0	8331-1	3006322		
6810	652	3006322	1968-06-15	1968-06-15 00:00:00	1968-06-15	5001	0	\N	0	0	\N	\N	0	43141	0	8331-1	3006322		
18296	1669	3011505	2019-05-13	2019-05-13 00:00:00	2019-05-13	5001	0	\N	0	0	\N	\N	0	112109	0	19926-5	3011505		
40444	3756	3011505	2009-05-30	2009-05-30 00:00:00	2009-05-30	5001	0	\N	0	0	\N	\N	0	249660	0	19926-5	3011505		
5781	545	3006451	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	36022	0	6273-7	3006451		
39047	3610	3006322	2003-07-05	2003-07-05 00:00:00	2003-07-05	5001	0	\N	0	0	\N	\N	0	239865	0	8331-1	3006322		
57060	5235	3006322	1956-04-20	1956-04-20 00:00:00	1956-04-20	5001	0	\N	0	0	\N	\N	0	348319	0	8331-1	3006322		
151754	4646	4052083	1947-07-03	1947-07-03 00:00:00	1947-07-03	5001	0	\N	0	0	\N	\N	0	309720	0	23426006	4052083		
19154	1753	3006322	2011-04-22	2011-04-22 00:00:00	2011-04-22	5001	0	\N	0	0	\N	\N	0	117207	0	8331-1	3006322		
6811	652	3006322	1984-07-30	1984-07-30 00:00:00	1984-07-30	5001	0	\N	0	0	\N	\N	0	43188	0	8331-1	3006322		
18297	1669	3011505	2011-03-28	2011-03-28 00:00:00	2011-03-28	5001	0	\N	0	0	\N	\N	0	112089	0	19926-5	3011505		
40445	3756	3011505	2013-06-22	2013-06-22 00:00:00	2013-06-22	5001	0	\N	0	0	\N	\N	0	249662	0	19926-5	3011505		
5782	545	3036780	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	36022	0	6095-4	3036780		
39048	3610	3006322	2012-12-24	2012-12-24 00:00:00	2012-12-24	5001	0	\N	0	0	\N	\N	0	239845	0	8331-1	3006322		
57061	5235	3006322	1939-03-22	1939-03-22 00:00:00	1939-03-22	5001	0	\N	0	0	\N	\N	0	348302	0	8331-1	3006322		
151755	4646	4052083	1945-09-22	1945-09-22 00:00:00	1945-09-22	5001	0	\N	0	0	\N	\N	0	309719	0	23426006	4052083		
19156	1755	3006322	2000-04-21	2000-04-21 00:00:00	2000-04-21	5001	0	\N	0	0	\N	\N	0	117386	0	8331-1	3006322		
6812	653	3006322	1999-12-31	1999-12-31 00:00:00	1999-12-31	5001	0	\N	0	0	\N	\N	0	43226	0	8331-1	3006322		
18298	1669	3006322	2007-12-21	2007-12-21 00:00:00	2007-12-21	5001	0	\N	0	0	\N	\N	0	112054	0	8331-1	3006322		
40446	3756	3011505	2003-04-26	2003-04-26 00:00:00	2003-04-26	5001	0	\N	0	0	\N	\N	0	249689	0	19926-5	3011505		
5783	545	3014599	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	36022	0	6106-9	3014599		
39049	3610	3006322	2001-04-06	2001-04-06 00:00:00	2001-04-06	5001	0	\N	0	0	\N	\N	0	239864	0	8331-1	3006322		
57063	5236	3006322	1982-07-11	1982-07-11 00:00:00	1982-07-11	5001	0	\N	0	0	\N	\N	0	348416	0	8331-1	3006322		
19157	1755	3006322	1963-11-24	1963-11-24 00:00:00	1963-11-24	5001	0	\N	0	0	\N	\N	0	117382	0	8331-1	3006322		
6813	653	3006322	1989-10-30	1989-10-30 00:00:00	1989-10-30	5001	0	\N	0	0	\N	\N	0	43260	0	8331-1	3006322		
18299	1669	3011505	2015-04-20	2015-04-20 00:00:00	2015-04-20	5001	0	\N	0	0	\N	\N	0	112107	0	19926-5	3011505		
40447	3756	3006322	2009-08-28	2009-08-28 00:00:00	2009-08-28	5001	0	\N	0	0	\N	\N	0	249643	0	8331-1	3006322		
5784	545	3020655	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	36022	0	6844-5	3020655		
39050	3610	3006322	1961-08-07	1961-08-07 00:00:00	1961-08-07	5001	0	\N	0	0	\N	\N	0	239887	0	8331-1	3006322		
57064	5236	3006322	1985-06-06	1985-06-06 00:00:00	1985-06-06	5001	0	\N	0	0	\N	\N	0	348394	0	8331-1	3006322		
19158	1755	3006322	1984-10-13	1984-10-13 00:00:00	1984-10-13	5001	0	\N	0	0	\N	\N	0	117362	0	8331-1	3006322		
6814	653	3006322	1969-07-16	1969-07-16 00:00:00	1969-07-16	5001	0	\N	0	0	\N	\N	0	43253	0	8331-1	3006322		
18300	1669	3011505	2006-03-06	2006-03-06 00:00:00	2006-03-06	5001	0	\N	0	0	\N	\N	0	112106	0	19926-5	3011505		
40448	3756	3011505	2011-06-11	2011-06-11 00:00:00	2011-06-11	5001	0	\N	0	0	\N	\N	0	249661	0	19926-5	3011505		
5785	545	3023430	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	36022	0	6833-8	3023430		
39059	3612	3006322	1996-01-11	1996-01-11 00:00:00	1996-01-11	5001	0	\N	0	0	\N	\N	0	239936	0	8331-1	3006322		
57072	5239	3006322	2001-01-20	2001-01-20 00:00:00	2001-01-20	5001	0	\N	0	0	\N	\N	0	348548	0	8331-1	3006322		
19159	1755	3006322	1999-03-15	1999-03-15 00:00:00	1999-03-15	5001	0	\N	0	0	\N	\N	0	117344	0	8331-1	3006322		
6815	653	3006322	1983-01-16	1983-01-16 00:00:00	1983-01-16	5001	0	\N	0	0	\N	\N	0	43221	0	8331-1	3006322		
18301	1669	3011505	2013-04-08	2013-04-08 00:00:00	2013-04-08	5001	0	\N	0	0	\N	\N	0	112090	0	19926-5	3011505		
40449	3756	3011505	2008-05-24	2008-05-24 00:00:00	2008-05-24	5001	0	\N	0	0	\N	\N	0	249676	0	19926-5	3011505		
5786	545	3000876	1993-07-10	1993-07-10 00:00:00	1993-07-10	5001	0	\N	0	0	\N	\N	0	36022	0	6082-2	3000876		
39060	3612	3006322	1989-07-08	1989-07-08 00:00:00	1989-07-08	5001	0	\N	0	0	\N	\N	0	239955	0	8331-1	3006322		
57073	5239	3006322	2007-05-17	2007-05-17 00:00:00	2007-05-17	5001	0	\N	0	0	\N	\N	0	348571	0	8331-1	3006322		
124168	3833	4052083	1966-09-24	1966-09-24 00:00:00	1966-09-24	5001	0	\N	0	0	\N	\N	0	254520	0	23426006	4052083		
6816	653	3006322	1978-03-13	1978-03-13 00:00:00	1978-03-13	5001	0	\N	0	0	\N	\N	0	43255	0	8331-1	3006322		
18302	1669	3011505	2000-02-21	2000-02-21 00:00:00	2000-02-21	5001	0	\N	0	0	\N	\N	0	112079	0	19926-5	3011505		
40450	3757	3006322	1968-07-13	1968-07-13 00:00:00	1968-07-13	5001	0	\N	0	0	\N	\N	0	249768	0	8331-1	3006322		
5787	545	3012494	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	36041	0	6206-7	3012494		
39061	3612	3006322	2017-06-02	2017-06-02 00:00:00	2017-06-02	5001	0	\N	0	0	\N	\N	0	239963	0	8331-1	3006322		
57074	5239	3006322	2002-11-24	2002-11-24 00:00:00	2002-11-24	5001	0	\N	0	0	\N	\N	0	348570	0	8331-1	3006322		
124172	3833	4052083	1985-09-23	1985-09-23 00:00:00	1985-09-23	5001	0	\N	0	0	\N	\N	0	254538	0	23426006	4052083		
6817	653	3006322	1998-06-26	1998-06-26 00:00:00	1998-06-26	5001	0	\N	0	0	\N	\N	0	43225	0	8331-1	3006322		
18303	1669	3011505	2016-04-25	2016-04-25 00:00:00	2016-04-25	5001	0	\N	0	0	\N	\N	0	112118	0	19926-5	3011505		
40451	3757	3006322	1947-01-15	1947-01-15 00:00:00	1947-01-15	5001	0	\N	0	0	\N	\N	0	249732	0	8331-1	3006322		
5788	545	3019406	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	36041	0	6158-0	3019406		
39062	3612	3006322	1985-06-20	1985-06-20 00:00:00	1985-06-20	5001	0	\N	0	0	\N	\N	0	239961	0	8331-1	3006322		
57075	5240	3006322	2001-04-28	2001-04-28 00:00:00	2001-04-28	5001	0	\N	0	0	\N	\N	0	348615	0	8331-1	3006322		
124175	3833	4052083	1999-02-14	1999-02-14 00:00:00	1999-02-14	5001	0	\N	0	0	\N	\N	0	254485	0	23426006	4052083		
6818	653	3006322	1988-02-29	1988-02-29 00:00:00	1988-02-29	5001	0	\N	0	0	\N	\N	0	43223	0	8331-1	3006322		
18304	1669	3006322	1985-01-20	1985-01-20 00:00:00	1985-01-20	5001	0	\N	0	0	\N	\N	0	112052	0	8331-1	3006322		
40452	3757	3006322	1997-05-06	1997-05-06 00:00:00	1997-05-06	5001	0	\N	0	0	\N	\N	0	249771	0	8331-1	3006322		
5789	545	3015076	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	36041	0	6248-9	3015076		
39063	3612	3006322	1967-07-12	1967-07-12 00:00:00	1967-07-12	5001	0	\N	0	0	\N	\N	0	239933	0	8331-1	3006322		
57076	5240	3006322	1947-08-16	1947-08-16 00:00:00	1947-08-16	5001	0	\N	0	0	\N	\N	0	348639	0	8331-1	3006322		
124193	3834	4024958	1989-12-21	1989-12-21 00:00:00	1989-12-21	5001	0	\N	0	0	\N	\N	0	254551	0	117015009	4024958		
6819	653	3006322	2008-12-15	2008-12-15 00:00:00	2008-12-15	5001	0	\N	0	0	\N	\N	0	43274	0	8331-1	3006322		
18305	1669	3011505	1998-02-16	1998-02-16 00:00:00	1998-02-16	5001	0	\N	0	0	\N	\N	0	112086	0	19926-5	3011505		
40453	3757	3006322	1952-09-26	1952-09-26 00:00:00	1952-09-26	5001	0	\N	0	0	\N	\N	0	249725	0	8331-1	3006322		
5790	545	3001488	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	36041	0	7258-7	3001488		
39064	3613	3006322	1991-10-18	1991-10-18 00:00:00	1991-10-18	5001	0	\N	0	0	\N	\N	0	240045	0	8331-1	3006322		
57077	5240	3049273	1997-04-08	1997-04-08 00:00:00	1997-04-08	5001	0	\N	0	0	\N	\N	0	348612	0	38265-5	3049273		
124200	3834	4024958	1993-11-12	1993-11-12 00:00:00	1993-11-12	5001	0	\N	0	0	\N	\N	0	254581	0	117015009	4024958		
6820	653	3006322	2002-10-01	2002-10-01 00:00:00	2002-10-01	5001	0	\N	0	0	\N	\N	0	43256	0	8331-1	3006322		
18306	1669	3011505	2008-03-10	2008-03-10 00:00:00	2008-03-10	5001	0	\N	0	0	\N	\N	0	112080	0	19926-5	3011505		
40454	3757	3006322	1988-11-06	1988-11-06 00:00:00	1988-11-06	5001	0	\N	0	0	\N	\N	0	249727	0	8331-1	3006322		
5791	545	3027231	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	36041	0	6276-0	3027231		
39065	3613	3006322	2013-07-04	2013-07-04 00:00:00	2013-07-04	5001	0	\N	0	0	\N	\N	0	240047	0	8331-1	3006322		
57078	5240	3006322	2011-03-03	2011-03-03 00:00:00	2011-03-03	5001	0	\N	0	0	\N	\N	0	348654	0	8331-1	3006322		
124203	3834	4024958	2005-03-09	2005-03-09 00:00:00	2005-03-09	5001	0	\N	0	0	\N	\N	0	254553	0	117015009	4024958		
6821	653	3006322	1959-02-01	1959-02-01 00:00:00	1959-02-01	5001	0	\N	0	0	\N	\N	0	43257	0	8331-1	3006322		
18307	1669	3011505	2012-04-02	2012-04-02 00:00:00	2012-04-02	5001	0	\N	0	0	\N	\N	0	112082	0	19926-5	3011505		
51732	4745	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	316007	0	7258-7	3001488		
5792	545	3005136	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	36041	0	6075-6	3005136		
39066	3613	3006322	1981-04-29	1981-04-29 00:00:00	1981-04-29	5001	0	\N	0	0	\N	\N	0	240022	0	8331-1	3006322		
57079	5240	3006322	1965-08-24	1965-08-24 00:00:00	1965-08-24	5001	0	\N	0	0	\N	\N	0	348692	0	8331-1	3006322		
124210	3834	4024958	1974-03-07	1974-03-07 00:00:00	1974-03-07	5001	0	\N	0	0	\N	\N	0	254579	0	117015009	4024958		
6822	653	3006322	1960-07-07	1960-07-07 00:00:00	1960-07-07	5001	0	\N	0	0	\N	\N	0	43251	0	8331-1	3006322		
18308	1669	3011505	2014-04-14	2014-04-14 00:00:00	2014-04-14	5001	0	\N	0	0	\N	\N	0	112117	0	19926-5	3011505		
51733	4745	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	316007	0	6189-5	3006734		
5793	545	3001247	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	36041	0	6085-5	3001247		
39068	3614	3011505	2006-11-05	2006-11-05 00:00:00	2006-11-05	5001	0	\N	0	0	\N	\N	0	240125	0	19926-5	3011505		
57080	5240	3006322	2004-08-20	2004-08-20 00:00:00	2004-08-20	5001	0	\N	0	0	\N	\N	0	348678	0	8331-1	3006322		
124216	3835	4024958	1997-05-27	1997-05-27 00:00:00	1997-05-27	5001	0	\N	0	0	\N	\N	0	254644	0	117015009	4024958		
6823	653	3006322	2015-02-21	2015-02-21 00:00:00	2015-02-21	5001	0	\N	0	0	\N	\N	0	43275	0	8331-1	3006322		
18309	1669	3011505	2004-03-01	2004-03-01 00:00:00	2004-03-01	5001	0	\N	0	0	\N	\N	0	112087	0	19926-5	3011505		
51734	4745	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	316007	0	6106-9	3014599		
5794	545	3006734	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	36041	0	6189-5	3006734		
39069	3614	3011505	2009-12-13	2009-12-13 00:00:00	2009-12-13	5001	0	\N	0	0	\N	\N	0	240127	0	19926-5	3011505		
57081	5241	3006322	1972-01-06	1972-01-06 00:00:00	1972-01-06	5001	0	\N	0	0	\N	\N	0	348752	0	8331-1	3006322		
124223	3835	4024958	1967-12-10	1967-12-10 00:00:00	1967-12-10	5001	0	\N	0	0	\N	\N	0	254635	0	117015009	4024958		
124698	3852	4052083	2013-05-05	2013-05-05 00:00:00	2013-05-05	5001	0	\N	0	0	\N	\N	0	255617	0	23426006	4052083		
18310	1669	3006322	1995-11-08	1995-11-08 00:00:00	1995-11-08	5001	0	\N	0	0	\N	\N	0	112091	0	8331-1	3006322		
51735	4745	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	316007	0	6075-6	3005136		
5795	545	3021226	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	36041	0	6246-3	3021226		
39070	3614	3006322	1958-06-11	1958-06-11 00:00:00	1958-06-11	5001	0	\N	0	0	\N	\N	0	240136	0	8331-1	3006322		
57082	5241	3049273	2017-05-17	2017-05-17 00:00:00	2017-05-17	5001	0	\N	0	0	\N	\N	0	348801	0	38265-5	3049273		
124225	3835	4024958	1976-11-30	1976-11-30 00:00:00	1976-11-30	5001	0	\N	0	0	\N	\N	0	254642	0	117015009	4024958		
124726	3852	4052083	1982-09-20	1982-09-20 00:00:00	1982-09-20	5001	0	\N	0	0	\N	\N	0	255615	0	23426006	4052083		
18311	1669	3011505	2018-05-07	2018-05-07 00:00:00	2018-05-07	5001	0	\N	0	0	\N	\N	0	112119	0	19926-5	3011505		
51736	4745	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	316007	0	6206-7	3012494		
5796	545	3006451	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	36041	0	6273-7	3006451		
39072	3614	3011505	2007-11-11	2007-11-11 00:00:00	2007-11-11	5001	0	\N	0	0	\N	\N	0	240114	0	19926-5	3011505		
57083	5241	3006322	2009-03-08	2009-03-08 00:00:00	2009-03-08	5001	0	\N	0	0	\N	\N	0	348725	0	8331-1	3006322		
151212	4634	4024958	1970-03-03	1970-03-03 00:00:00	1970-03-03	5001	0	\N	0	0	\N	\N	0	308821	0	117015009	4024958		
124730	3852	4024958	1968-11-10	1968-11-10 00:00:00	1968-11-10	5001	0	\N	0	0	\N	\N	0	255707	0	117015009	4024958		
18312	1669	3011505	2009-03-16	2009-03-16 00:00:00	2009-03-16	5001	0	\N	0	0	\N	\N	0	112088	0	19926-5	3011505		
51737	4745	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	316007	0	6095-4	3036780		
5797	545	3023430	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	36041	0	6833-8	3023430		
39074	3614	3006322	1967-07-06	1967-07-06 00:00:00	1967-07-06	5001	0	\N	0	0	\N	\N	0	240142	0	8331-1	3006322		
57084	5241	3006322	1975-08-27	1975-08-27 00:00:00	1975-08-27	5001	0	\N	0	0	\N	\N	0	348756	0	8331-1	3006322		
151219	4634	4024958	2008-04-14	2008-04-14 00:00:00	2008-04-14	5001	0	\N	0	0	\N	\N	0	308823	0	117015009	4024958		
163207	5014	4024958	1916-09-24	1916-09-24 00:00:00	1916-09-24	5001	0	\N	0	0	\N	\N	0	333247	0	117015009	4024958		
18313	1670	3006322	2002-08-04	2002-08-04 00:00:00	2002-08-04	5001	0	\N	0	0	\N	\N	0	112137	0	8331-1	3006322		
51738	4745	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	316007	0	6248-9	3015076		
5798	545	3036780	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	36041	0	6095-4	3036780		
39076	3614	3006322	1992-07-22	1992-07-22 00:00:00	1992-07-22	5001	0	\N	0	0	\N	\N	0	240106	0	8331-1	3006322		
57085	5241	3006322	1996-01-20	1996-01-20 00:00:00	1996-01-20	5001	0	\N	0	0	\N	\N	0	348719	0	8331-1	3006322		
151249	4636	4024958	1956-05-28	1956-05-28 00:00:00	1956-05-28	5001	0	\N	0	0	\N	\N	0	308932	0	117015009	4024958		
163209	5014	4133840	1988-11-08	1988-11-08 00:00:00	1988-11-08	5001	0	\N	0	0	\N	\N	0	333278	0	127783003	4133840		
18314	1670	3006322	2010-12-03	2010-12-03 00:00:00	2010-12-03	5001	0	\N	0	0	\N	\N	0	112157	0	8331-1	3006322		
51739	4745	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	316007	0	6158-0	3019406		
5799	545	3014599	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	36041	0	6106-9	3014599		
39077	3614	3011505	2005-10-30	2005-10-30 00:00:00	2005-10-30	5001	0	\N	0	0	\N	\N	0	240132	0	19926-5	3011505		
57086	5241	3006322	2012-04-02	2012-04-02 00:00:00	2012-04-02	5001	0	\N	0	0	\N	\N	0	348760	0	8331-1	3006322		
162538	4986	4024958	1990-03-05	1990-03-05 00:00:00	1990-03-05	5001	0	\N	0	0	\N	\N	0	331693	0	117015009	4024958		
163214	5014	4133840	1995-12-19	1995-12-19 00:00:00	1995-12-19	5001	0	\N	0	0	\N	\N	0	333290	0	127783003	4133840		
18315	1670	3006322	1984-08-13	1984-08-13 00:00:00	1984-08-13	5001	0	\N	0	0	\N	\N	0	112149	0	8331-1	3006322		
51740	4745	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	316007	0	6082-2	3000876		
5800	545	3020655	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	36041	0	6844-5	3020655		
39078	3614	3011505	2004-07-25	2004-07-25 00:00:00	2004-07-25	5001	0	\N	0	0	\N	\N	0	240067	0	19926-5	3011505		
57087	5241	3006322	2005-10-14	2005-10-14 00:00:00	2005-10-14	5001	0	\N	0	0	\N	\N	0	348759	0	8331-1	3006322		
162542	4987	4052083	2013-07-05	2013-07-05 00:00:00	2013-07-05	5001	0	\N	0	0	\N	\N	0	331736	0	23426006	4052083		
163218	5014	4133840	1993-12-07	1993-12-07 00:00:00	1993-12-07	5001	0	\N	0	0	\N	\N	0	333233	0	127783003	4133840		
18316	1670	3006322	1967-09-02	1967-09-02 00:00:00	1967-09-02	5001	0	\N	0	0	\N	\N	0	112154	0	8331-1	3006322		
51741	4745	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	316007	0	6273-7	3006451		
5801	545	3000876	1990-01-06	1990-01-06 00:00:00	1990-01-06	5001	0	\N	0	0	\N	\N	0	36041	0	6082-2	3000876		
39080	3614	3011505	2008-11-16	2008-11-16 00:00:00	2008-11-16	5001	0	\N	0	0	\N	\N	0	240126	0	19926-5	3011505		
57088	5242	3006322	2017-05-12	2017-05-12 00:00:00	2017-05-12	5001	0	\N	0	0	\N	\N	0	348845	0	8331-1	3006322		
162545	4987	4024958	1990-11-25	1990-11-25 00:00:00	1990-11-25	5001	0	\N	0	0	\N	\N	0	331759	0	117015009	4024958		
163219	5014	4133840	1986-10-28	1986-10-28 00:00:00	1986-10-28	5001	0	\N	0	0	\N	\N	0	333277	0	127783003	4133840		
18317	1670	3006322	1998-01-15	1998-01-15 00:00:00	1998-01-15	5001	0	\N	0	0	\N	\N	0	112150	0	8331-1	3006322		
51742	4745	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	316007	0	6246-3	3021226		
5803	546	40766240	1999-11-30	1999-11-30 00:00:00	1999-11-30	5001	0	\N	0	0	\N	\N	0	36203	0	63513-6	40766240		
115652	3566	4024958	1986-05-20	1986-05-20 00:00:00	1986-05-20	5001	0	\N	0	0	\N	\N	0	236921	0	117015009	4024958		
13137	418	4052083	1999-04-26	1999-04-26 00:00:00	1999-04-26	5001	0	\N	0	0	\N	\N	0	27643	0	23426006	4052083		
162550	4987	4024958	1985-08-07	1985-08-07 00:00:00	1985-08-07	5001	0	\N	0	0	\N	\N	0	331710	0	117015009	4024958		
163220	5014	4133840	1989-11-14	1989-11-14 00:00:00	1989-11-14	5001	0	\N	0	0	\N	\N	0	333279	0	127783003	4133840		
18318	1670	3006322	1964-06-07	1964-06-07 00:00:00	1964-06-07	5001	0	\N	0	0	\N	\N	0	112136	0	8331-1	3006322		
51743	4745	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	316007	0	6276-0	3027231		
5805	546	3051031	1999-11-30	1999-11-30 00:00:00	1999-11-30	5001	0	\N	0	0	\N	\N	0	36203	0	46240-8	3051031		
115716	3566	4052083	1992-01-01	1992-01-01 00:00:00	1992-01-01	5001	0	\N	0	0	\N	\N	0	236963	0	23426006	4052083		
13144	418	4024958	1996-01-06	1996-01-06 00:00:00	1996-01-06	5001	0	\N	0	0	\N	\N	0	27600	0	117015009	4024958		
162553	4987	4024958	1967-05-09	1967-05-09 00:00:00	1967-05-09	5001	0	\N	0	0	\N	\N	0	331764	0	117015009	4024958		
163221	5014	4133840	1985-10-22	1985-10-22 00:00:00	1985-10-22	5001	0	\N	0	0	\N	\N	0	333307	0	127783003	4133840		
18319	1672	3006322	1962-08-20	1962-08-20 00:00:00	1962-08-20	5001	0	\N	0	0	\N	\N	0	112221	0	8331-1	3006322		
51744	4745	3006451	1978-05-01	1978-05-01 00:00:00	1978-05-01	5001	0	\N	0	0	\N	\N	0	315993	0	6273-7	3006451		
5806	546	46235214	1999-11-30	1999-11-30 00:00:00	1999-11-30	5001	0	\N	0	0	\N	\N	0	36203	0	76690-7	46235214		
165449	5081	4024958	1944-04-10	1944-04-10 00:00:00	1944-04-10	5001	0	\N	0	0	\N	\N	0	337876	0	117015009	4024958		
13147	418	4052083	1990-10-01	1990-10-01 00:00:00	1990-10-01	5001	0	\N	0	0	\N	\N	0	27632	0	23426006	4052083		
162558	4987	4024958	1970-07-31	1970-07-31 00:00:00	1970-07-31	5001	0	\N	0	0	\N	\N	0	331756	0	117015009	4024958		
163222	5014	4133840	1991-11-26	1991-11-26 00:00:00	1991-11-26	5001	0	\N	0	0	\N	\N	0	333280	0	127783003	4133840		
18320	1672	3006322	1966-09-11	1966-09-11 00:00:00	1966-09-11	5001	0	\N	0	0	\N	\N	0	112240	0	8331-1	3006322		
51745	4745	3027231	1978-05-01	1978-05-01 00:00:00	1978-05-01	5001	0	\N	0	0	\N	\N	0	315993	0	6276-0	3027231		
5807	546	40758406	1999-11-30	1999-11-30 00:00:00	1999-11-30	5001	0	\N	0	0	\N	\N	0	36203	0	55277-8	40758406		
165452	5081	4024958	1928-10-04	1928-10-04 00:00:00	1928-10-04	5001	0	\N	0	0	\N	\N	0	337906	0	117015009	4024958		
13152	418	4024958	1958-01-24	1958-01-24 00:00:00	1958-01-24	5001	0	\N	0	0	\N	\N	0	27681	0	117015009	4024958		
144957	4450	4024958	1997-07-24	1997-07-24 00:00:00	1997-07-24	5001	0	\N	0	0	\N	\N	0	296069	0	117015009	4024958		
163223	5014	4024958	1956-12-15	1956-12-15 00:00:00	1956-12-15	5001	0	\N	0	0	\N	\N	0	333286	0	117015009	4024958		
18321	1672	3006322	2011-07-18	2011-07-18 00:00:00	2011-07-18	5001	0	\N	0	0	\N	\N	0	112258	0	8331-1	3006322		
51746	4745	3021226	1978-05-01	1978-05-01 00:00:00	1978-05-01	5001	0	\N	0	0	\N	\N	0	315993	0	6246-3	3021226		
5808	546	3006322	2014-06-14	2014-06-14 00:00:00	2014-06-14	5001	0	\N	0	0	\N	\N	0	36181	0	8331-1	3006322		
165459	5081	4024958	1944-05-21	1944-05-21 00:00:00	1944-05-21	5001	0	\N	0	0	\N	\N	0	337845	0	117015009	4024958		
13159	418	4024958	1963-11-04	1963-11-04 00:00:00	1963-11-04	5001	0	\N	0	0	\N	\N	0	27595	0	117015009	4024958		
144959	4450	4024958	1975-06-03	1975-06-03 00:00:00	1975-06-03	5001	0	\N	0	0	\N	\N	0	296037	0	117015009	4024958		
163227	5014	4133840	1992-12-01	1992-12-01 00:00:00	1992-12-01	5001	0	\N	0	0	\N	\N	0	333310	0	127783003	4133840		
18322	1672	3006322	1974-06-11	1974-06-11 00:00:00	1974-06-11	5001	0	\N	0	0	\N	\N	0	112255	0	8331-1	3006322		
51747	4745	3000876	1978-05-01	1978-05-01 00:00:00	1978-05-01	5001	0	\N	0	0	\N	\N	0	315993	0	6082-2	3000876		
5809	546	3006322	1977-07-18	1977-07-18 00:00:00	1977-07-18	5001	0	\N	0	0	\N	\N	0	36177	0	8331-1	3006322		
165483	5081	4024958	1918-10-12	1918-10-12 00:00:00	1918-10-12	5001	0	\N	0	0	\N	\N	0	337886	0	117015009	4024958		
13204	419	4024958	1915-01-11	1915-01-11 00:00:00	1915-01-11	5001	0	\N	0	0	\N	\N	0	27749	0	117015009	4024958		
17453	1593	3051031	1967-11-27	1967-11-27 00:00:00	1967-11-27	5001	0	\N	0	0	\N	\N	0	106888	0	46240-8	3051031		
163228	5014	4133840	1987-11-03	1987-11-03 00:00:00	1987-11-03	5001	0	\N	0	0	\N	\N	0	333308	0	127783003	4133840		
18323	1672	3006322	2006-02-03	2006-02-03 00:00:00	2006-02-03	5001	0	\N	0	0	\N	\N	0	112250	0	8331-1	3006322		
51748	4745	3019406	1978-05-01	1978-05-01 00:00:00	1978-05-01	5001	0	\N	0	0	\N	\N	0	315993	0	6158-0	3019406		
5810	546	3006322	1986-03-11	1986-03-11 00:00:00	1986-03-11	5001	0	\N	0	0	\N	\N	0	36178	0	8331-1	3006322		
165484	5081	4052083	1947-09-19	1947-09-19 00:00:00	1947-09-19	5001	0	\N	0	0	\N	\N	0	337879	0	23426006	4052083		
19780	1808	40766240	1980-03-03	1980-03-03 00:00:00	1980-03-03	5001	0	\N	0	0	\N	\N	0	121048	0	63513-6	40766240		
17455	1593	40766240	1967-11-27	1967-11-27 00:00:00	1967-11-27	5001	0	\N	0	0	\N	\N	0	106888	0	63513-6	40766240		
163240	5014	4133840	1990-11-20	1990-11-20 00:00:00	1990-11-20	5001	0	\N	0	0	\N	\N	0	333309	0	127783003	4133840		
18324	1672	3006322	1958-10-31	1958-10-31 00:00:00	1958-10-31	5001	0	\N	0	0	\N	\N	0	112247	0	8331-1	3006322		
51749	4745	3001247	1978-05-01	1978-05-01 00:00:00	1978-05-01	5001	0	\N	0	0	\N	\N	0	315993	0	6085-5	3001247		
5811	546	3009542	1987-11-03	1987-11-03 00:00:00	1987-11-03	5001	0	\N	0	0	\N	\N	0	36155	0	20570-8	3009542		
165486	5081	4052083	1989-08-12	1989-08-12 00:00:00	1989-08-12	5001	0	\N	0	0	\N	\N	0	337858	0	23426006	4052083		
19781	1808	40758406	1980-07-31	1980-07-31 00:00:00	1980-07-31	5001	0	\N	0	0	\N	\N	0	121071	0	55277-8	40758406		
17456	1593	46235214	1967-11-27	1967-11-27 00:00:00	1967-11-27	5001	0	\N	0	0	\N	\N	0	106888	0	76690-7	46235214		
163244	5014	4024958	1927-11-20	1927-11-20 00:00:00	1927-11-20	5001	0	\N	0	0	\N	\N	0	333259	0	117015009	4024958		
18329	1674	3006322	2006-01-07	2006-01-07 00:00:00	2006-01-07	5001	0	\N	0	0	\N	\N	0	112379	0	8331-1	3006322		
51750	4745	3023430	1978-05-01	1978-05-01 00:00:00	1978-05-01	5001	0	\N	0	0	\N	\N	0	315993	0	6833-8	3023430		
5812	546	3000963	1987-11-03	1987-11-03 00:00:00	1987-11-03	5001	0	\N	0	0	\N	\N	0	36155	0	718-7	3000963		
165497	5081	4024958	1974-04-27	1974-04-27 00:00:00	1974-04-27	5001	0	\N	0	0	\N	\N	0	337911	0	117015009	4024958		
19783	1808	40766240	1980-07-31	1980-07-31 00:00:00	1980-07-31	5001	0	\N	0	0	\N	\N	0	121071	0	63513-6	40766240		
17457	1593	40758406	1967-11-27	1967-11-27 00:00:00	1967-11-27	5001	0	\N	0	0	\N	\N	0	106888	0	55277-8	40758406		
163245	5014	4133840	1994-12-13	1994-12-13 00:00:00	1994-12-13	5001	0	\N	0	0	\N	\N	0	333257	0	127783003	4133840		
18330	1674	3006322	2003-04-10	2003-04-10 00:00:00	2003-04-10	5001	0	\N	0	0	\N	\N	0	112378	0	8331-1	3006322		
51751	4745	3020655	1978-05-01	1978-05-01 00:00:00	1978-05-01	5001	0	\N	0	0	\N	\N	0	315993	0	6844-5	3020655		
5813	546	3049273	2010-05-17	2010-05-17 00:00:00	2010-05-17	5001	0	\N	0	0	\N	\N	0	36154	0	38265-5	3049273		
165498	5081	4052083	1915-12-28	1915-12-28 00:00:00	1915-12-28	5001	0	\N	0	0	\N	\N	0	337885	0	23426006	4052083		
19784	1808	46235214	1980-07-31	1980-07-31 00:00:00	1980-07-31	5001	0	\N	0	0	\N	\N	0	121071	0	76690-7	46235214		
17458	1593	3006322	1935-06-12	1935-06-12 00:00:00	1935-06-12	5001	0	\N	0	0	\N	\N	0	106823	0	8331-1	3006322		
11709	1110	3001247	1998-09-21	1998-09-21 00:00:00	1998-09-21	5001	0	\N	0	0	\N	\N	0	73077	0	6085-5	3001247		
18331	1674	3006322	2011-12-20	2011-12-20 00:00:00	2011-12-20	5001	0	\N	0	0	\N	\N	0	112355	0	8331-1	3006322		
51752	4745	3006734	1978-05-01	1978-05-01 00:00:00	1978-05-01	5001	0	\N	0	0	\N	\N	0	315993	0	6189-5	3006734		
5814	546	3006322	1966-03-21	1966-03-21 00:00:00	1966-03-21	5001	0	\N	0	0	\N	\N	0	36199	0	8331-1	3006322		
165505	5081	4024958	1954-03-09	1954-03-09 00:00:00	1954-03-09	5001	0	\N	0	0	\N	\N	0	337846	0	117015009	4024958		
19786	1808	3051031	1980-07-31	1980-07-31 00:00:00	1980-07-31	5001	0	\N	0	0	\N	\N	0	121071	0	46240-8	3051031		
17459	1593	3051031	1967-10-28	1967-10-28 00:00:00	1967-10-28	5001	0	\N	0	0	\N	\N	0	106865	0	46240-8	3051031		
11710	1110	3020655	1998-09-21	1998-09-21 00:00:00	1998-09-21	5001	0	\N	0	0	\N	\N	0	73077	0	6844-5	3020655		
18332	1674	3006322	1980-06-23	1980-06-23 00:00:00	1980-06-23	5001	0	\N	0	0	\N	\N	0	112368	0	8331-1	3006322		
51753	4745	3005136	1978-05-01	1978-05-01 00:00:00	1978-05-01	5001	0	\N	0	0	\N	\N	0	315993	0	6075-6	3005136		
5815	546	3006322	1968-08-19	1968-08-19 00:00:00	1968-08-19	5001	0	\N	0	0	\N	\N	0	36176	0	8331-1	3006322		
98322	3010	4024958	1975-03-04	1975-03-04 00:00:00	1975-03-04	5001	0	\N	0	0	\N	\N	0	200780	0	117015009	4024958		
19787	1808	3006322	1969-06-03	1969-06-03 00:00:00	1969-06-03	5001	0	\N	0	0	\N	\N	0	121047	0	8331-1	3006322		
17461	1593	40766240	1967-10-28	1967-10-28 00:00:00	1967-10-28	5001	0	\N	0	0	\N	\N	0	106865	0	63513-6	40766240		
11711	1110	3000876	1998-09-21	1998-09-21 00:00:00	1998-09-21	5001	0	\N	0	0	\N	\N	0	73077	0	6082-2	3000876		
18335	1676	3049273	1999-06-02	1999-06-02 00:00:00	1999-06-02	5001	0	\N	0	0	\N	\N	0	112469	0	38265-5	3049273		
51754	4745	3012494	1978-05-01	1978-05-01 00:00:00	1978-05-01	5001	0	\N	0	0	\N	\N	0	315993	0	6206-7	3012494		
5816	546	40758406	1999-12-30	1999-12-30 00:00:00	1999-12-30	5001	0	\N	0	0	\N	\N	0	36156	0	55277-8	40758406		
98329	3010	4024958	1979-02-04	1979-02-04 00:00:00	1979-02-04	5001	0	\N	0	0	\N	\N	0	200781	0	117015009	4024958		
19788	1809	3006322	1970-02-25	1970-02-25 00:00:00	1970-02-25	5001	0	\N	0	0	\N	\N	0	121098	0	8331-1	3006322		
17462	1593	40758406	1967-10-28	1967-10-28 00:00:00	1967-10-28	5001	0	\N	0	0	\N	\N	0	106865	0	55277-8	40758406		
11712	1110	3019406	1998-09-21	1998-09-21 00:00:00	1998-09-21	5001	0	\N	0	0	\N	\N	0	73077	0	6158-0	3019406		
18336	1676	3006322	1998-01-10	1998-01-10 00:00:00	1998-01-10	5001	0	\N	0	0	\N	\N	0	112460	0	8331-1	3006322		
51755	4745	3014599	1978-05-01	1978-05-01 00:00:00	1978-05-01	5001	0	\N	0	0	\N	\N	0	315993	0	6106-9	3014599		
5818	546	40766240	1999-12-30	1999-12-30 00:00:00	1999-12-30	5001	0	\N	0	0	\N	\N	0	36156	0	63513-6	40766240		
98338	3010	4024958	1984-07-24	1984-07-24 00:00:00	1984-07-24	5001	0	\N	0	0	\N	\N	0	200771	0	117015009	4024958		
19789	1809	3006322	1995-09-09	1995-09-09 00:00:00	1995-09-09	5001	0	\N	0	0	\N	\N	0	121119	0	8331-1	3006322		
17463	1593	46235214	1967-10-28	1967-10-28 00:00:00	1967-10-28	5001	0	\N	0	0	\N	\N	0	106865	0	76690-7	46235214		
11713	1110	3015076	1998-09-21	1998-09-21 00:00:00	1998-09-21	5001	0	\N	0	0	\N	\N	0	73077	0	6248-9	3015076		
18337	1677	3006322	1991-12-09	1991-12-09 00:00:00	1991-12-09	5001	0	\N	0	0	\N	\N	0	112513	0	8331-1	3006322		
51756	4745	3001488	1978-05-01	1978-05-01 00:00:00	1978-05-01	5001	0	\N	0	0	\N	\N	0	315993	0	7258-7	3001488		
5819	546	46235214	1999-12-30	1999-12-30 00:00:00	1999-12-30	5001	0	\N	0	0	\N	\N	0	36156	0	76690-7	46235214		
98340	3011	4024958	1978-09-05	1978-09-05 00:00:00	1978-09-05	5001	0	\N	0	0	\N	\N	0	200852	0	117015009	4024958		
19790	1809	3006322	1969-05-21	1969-05-21 00:00:00	1969-05-21	5001	0	\N	0	0	\N	\N	0	121090	0	8331-1	3006322		
17465	1593	3006322	1998-04-10	1998-04-10 00:00:00	1998-04-10	5001	0	\N	0	0	\N	\N	0	106891	0	8331-1	3006322		
11714	1110	3001488	1998-09-21	1998-09-21 00:00:00	1998-09-21	5001	0	\N	0	0	\N	\N	0	73077	0	7258-7	3001488		
18338	1677	3006322	2000-07-11	2000-07-11 00:00:00	2000-07-11	5001	0	\N	0	0	\N	\N	0	112528	0	8331-1	3006322		
51757	4745	3015076	1978-05-01	1978-05-01 00:00:00	1978-05-01	5001	0	\N	0	0	\N	\N	0	315993	0	6248-9	3015076		
5820	546	3051031	1999-12-30	1999-12-30 00:00:00	1999-12-30	5001	0	\N	0	0	\N	\N	0	36156	0	46240-8	3051031		
98344	3011	4024958	2003-04-02	2003-04-02 00:00:00	2003-04-02	5001	0	\N	0	0	\N	\N	0	200824	0	117015009	4024958		
19791	1809	3006322	1964-07-05	1964-07-05 00:00:00	1964-07-05	5001	0	\N	0	0	\N	\N	0	121091	0	8331-1	3006322		
17466	1593	3006322	1946-11-03	1946-11-03 00:00:00	1946-11-03	5001	0	\N	0	0	\N	\N	0	106940	0	8331-1	3006322		
11715	1110	3005136	1998-09-21	1998-09-21 00:00:00	1998-09-21	5001	0	\N	0	0	\N	\N	0	73077	0	6075-6	3005136		
18339	1677	3006322	1985-06-02	1985-06-02 00:00:00	1985-06-02	5001	0	\N	0	0	\N	\N	0	112526	0	8331-1	3006322		
51758	4745	3036780	1978-05-01	1978-05-01 00:00:00	1978-05-01	5001	0	\N	0	0	\N	\N	0	315993	0	6095-4	3036780		
5822	546	40758406	2000-02-28	2000-02-28 00:00:00	2000-02-28	5001	0	\N	0	0	\N	\N	0	36204	0	55277-8	40758406		
98357	3011	4024958	1994-10-05	1994-10-05 00:00:00	1994-10-05	5001	0	\N	0	0	\N	\N	0	200853	0	117015009	4024958		
19792	1809	3006322	1996-05-21	1996-05-21 00:00:00	1996-05-21	5001	0	\N	0	0	\N	\N	0	121100	0	8331-1	3006322		
17467	1593	3006322	2006-02-06	2006-02-06 00:00:00	2006-02-06	5001	0	\N	0	0	\N	\N	0	106827	0	8331-1	3006322		
11716	1110	3014599	1998-09-21	1998-09-21 00:00:00	1998-09-21	5001	0	\N	0	0	\N	\N	0	73077	0	6106-9	3014599		
18340	1677	3006322	1979-09-19	1979-09-19 00:00:00	1979-09-19	5001	0	\N	0	0	\N	\N	0	112491	0	8331-1	3006322		
51759	4745	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	315971	0	6158-0	3019406		
5823	546	46235214	2000-02-28	2000-02-28 00:00:00	2000-02-28	5001	0	\N	0	0	\N	\N	0	36204	0	76690-7	46235214		
98361	3011	4052083	2014-05-12	2014-05-12 00:00:00	2014-05-12	5001	0	\N	0	0	\N	\N	0	200854	0	23426006	4052083		
19793	1809	3006322	1982-12-04	1982-12-04 00:00:00	1982-12-04	5001	0	\N	0	0	\N	\N	0	121141	0	8331-1	3006322		
17468	1593	3006322	1955-02-04	1955-02-04 00:00:00	1955-02-04	5001	0	\N	0	0	\N	\N	0	106862	0	8331-1	3006322		
11717	1110	3006451	1998-09-21	1998-09-21 00:00:00	1998-09-21	5001	0	\N	0	0	\N	\N	0	73077	0	6273-7	3006451		
18344	1679	3006322	1989-06-12	1989-06-12 00:00:00	1989-06-12	5001	0	\N	0	0	\N	\N	0	112590	0	8331-1	3006322		
51760	4745	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	315971	0	6082-2	3000876		
5824	546	3051031	2000-02-28	2000-02-28 00:00:00	2000-02-28	5001	0	\N	0	0	\N	\N	0	36204	0	46240-8	3051031		
98384	3013	4052083	2007-05-02	2007-05-02 00:00:00	2007-05-02	5001	0	\N	0	0	\N	\N	0	200974	0	23426006	4052083		
19802	1812	3006322	2018-05-08	2018-05-08 00:00:00	2018-05-08	5001	0	\N	0	0	\N	\N	0	121268	0	8331-1	3006322		
17469	1593	3006322	1944-10-03	1944-10-03 00:00:00	1944-10-03	5001	0	\N	0	0	\N	\N	0	106859	0	8331-1	3006322		
11718	1110	3006734	1998-09-21	1998-09-21 00:00:00	1998-09-21	5001	0	\N	0	0	\N	\N	0	73077	0	6189-5	3006734		
18345	1679	3006322	2001-11-09	2001-11-09 00:00:00	2001-11-09	5001	0	\N	0	0	\N	\N	0	112566	0	8331-1	3006322		
51761	4745	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	315971	0	6095-4	3036780		
5827	546	40766240	2000-02-28	2000-02-28 00:00:00	2000-02-28	5001	0	\N	0	0	\N	\N	0	36204	0	63513-6	40766240		
57212	5253	3011505	1983-04-23	1983-04-23 00:00:00	1983-04-23	5001	0	\N	0	0	\N	\N	0	349532	0	19926-5	3011505		
19803	1812	3006322	2003-01-26	2003-01-26 00:00:00	2003-01-26	5001	0	\N	0	0	\N	\N	0	121257	0	8331-1	3006322		
17470	1593	3051031	1967-03-02	1967-03-02 00:00:00	1967-03-02	5001	0	\N	0	0	\N	\N	0	106887	0	46240-8	3051031		
11719	1110	3012494	1998-09-21	1998-09-21 00:00:00	1998-09-21	5001	0	\N	0	0	\N	\N	0	73077	0	6206-7	3012494		
18346	1679	3006322	1991-10-10	1991-10-10 00:00:00	1991-10-10	5001	0	\N	0	0	\N	\N	0	112599	0	8331-1	3006322		
51762	4745	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	315971	0	6248-9	3015076		
5828	546	3006322	2011-03-15	2011-03-15 00:00:00	2011-03-15	5001	0	\N	0	0	\N	\N	0	36157	0	8331-1	3006322		
57213	5253	3011505	1993-09-11	1993-09-11 00:00:00	1993-09-11	5001	0	\N	0	0	\N	\N	0	349543	0	19926-5	3011505		
19804	1812	3006322	1971-03-04	1971-03-04 00:00:00	1971-03-04	5001	0	\N	0	0	\N	\N	0	121254	0	8331-1	3006322		
17471	1593	46235214	1967-03-02	1967-03-02 00:00:00	1967-03-02	5001	0	\N	0	0	\N	\N	0	106887	0	76690-7	46235214		
11720	1110	3027231	1998-09-21	1998-09-21 00:00:00	1998-09-21	5001	0	\N	0	0	\N	\N	0	73077	0	6276-0	3027231		
105469	3246	4052083	2009-05-16	2009-05-16 00:00:00	2009-05-16	5001	0	\N	0	0	\N	\N	0	215780	0	23426006	4052083		
51763	4745	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	315971	0	6075-6	3005136		
51782	4748	3006322	1963-07-14	1963-07-14 00:00:00	1963-07-14	5001	0	\N	0	0	\N	\N	0	316162	0	8331-1	3006322		
57214	5253	3011505	2016-05-07	2016-05-07 00:00:00	2016-05-07	5001	0	\N	0	0	\N	\N	0	349528	0	19926-5	3011505		
19805	1812	3006322	2018-01-21	2018-01-21 00:00:00	2018-01-21	5001	0	\N	0	0	\N	\N	0	121296	0	8331-1	3006322		
17473	1593	40766240	1967-03-02	1967-03-02 00:00:00	1967-03-02	5001	0	\N	0	0	\N	\N	0	106887	0	63513-6	40766240		
11721	1110	3036780	1995-03-20	1995-03-20 00:00:00	1995-03-20	5001	0	\N	0	0	\N	\N	0	73052	0	6095-4	3036780		
105470	3246	4024958	1997-06-05	1997-06-05 00:00:00	1997-06-05	5001	0	\N	0	0	\N	\N	0	215791	0	117015009	4024958		
51764	4745	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	315971	0	6206-7	3012494		
51783	4748	3006322	1946-11-27	1946-11-27 00:00:00	1946-11-27	5001	0	\N	0	0	\N	\N	0	316160	0	8331-1	3006322		
57215	5253	3011505	2013-01-19	2013-01-19 00:00:00	2013-01-19	5001	0	\N	0	0	\N	\N	0	349519	0	19926-5	3011505		
19806	1813	3006322	2007-09-03	2007-09-03 00:00:00	2007-09-03	5001	0	\N	0	0	\N	\N	0	121347	0	8331-1	3006322		
17475	1593	40758406	1967-03-02	1967-03-02 00:00:00	1967-03-02	5001	0	\N	0	0	\N	\N	0	106887	0	55277-8	40758406		
11722	1110	3021226	1995-03-20	1995-03-20 00:00:00	1995-03-20	5001	0	\N	0	0	\N	\N	0	73052	0	6246-3	3021226		
105478	3246	4052083	1984-12-14	1984-12-14 00:00:00	1984-12-14	5001	0	\N	0	0	\N	\N	0	215804	0	23426006	4052083		
51765	4745	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	315971	0	6106-9	3014599		
51784	4748	3006322	1999-02-13	1999-02-13 00:00:00	1999-02-13	5001	0	\N	0	0	\N	\N	0	316205	0	8331-1	3006322		
57216	5253	3011505	1984-08-25	1984-08-25 00:00:00	1984-08-25	5001	0	\N	0	0	\N	\N	0	349557	0	19926-5	3011505		
19807	1813	3006322	2002-06-04	2002-06-04 00:00:00	2002-06-04	5001	0	\N	0	0	\N	\N	0	121350	0	8331-1	3006322		
17476	1593	3051031	1968-05-25	1968-05-25 00:00:00	1968-05-25	5001	0	\N	0	0	\N	\N	0	106889	0	46240-8	3051031		
11723	1110	3023430	1995-03-20	1995-03-20 00:00:00	1995-03-20	5001	0	\N	0	0	\N	\N	0	73052	0	6833-8	3023430		
88330	2732	4052083	1972-07-23	1972-07-23 00:00:00	1972-07-23	5001	0	\N	0	0	\N	\N	0	180909	0	23426006	4052083		
51766	4745	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	315971	0	7258-7	3001488		
51785	4748	3006322	1978-04-25	1978-04-25 00:00:00	1978-04-25	5001	0	\N	0	0	\N	\N	0	316159	0	8331-1	3006322		
57217	5253	3011505	2018-05-19	2018-05-19 00:00:00	2018-05-19	5001	0	\N	0	0	\N	\N	0	349570	0	19926-5	3011505		
19808	1813	3006322	2004-05-07	2004-05-07 00:00:00	2004-05-07	5001	0	\N	0	0	\N	\N	0	121345	0	8331-1	3006322		
17477	1593	46235214	1968-05-25	1968-05-25 00:00:00	1968-05-25	5001	0	\N	0	0	\N	\N	0	106889	0	76690-7	46235214		
11724	1110	3012494	1995-03-20	1995-03-20 00:00:00	1995-03-20	5001	0	\N	0	0	\N	\N	0	73052	0	6206-7	3012494		
88334	2732	4024958	2014-01-30	2014-01-30 00:00:00	2014-01-30	5001	0	\N	0	0	\N	\N	0	180880	0	117015009	4024958		
51767	4745	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	315971	0	6189-5	3006734		
51786	4748	3006322	1969-08-11	1969-08-11 00:00:00	1969-08-11	5001	0	\N	0	0	\N	\N	0	316131	0	8331-1	3006322		
57218	5253	3011505	2008-12-27	2008-12-27 00:00:00	2008-12-27	5001	0	\N	0	0	\N	\N	0	349513	0	19926-5	3011505		
19809	1814	3049273	2009-12-12	2009-12-12 00:00:00	2009-12-12	5001	0	\N	0	0	\N	\N	0	121432	0	38265-5	3049273		
17479	1593	40766240	1968-05-25	1968-05-25 00:00:00	1968-05-25	5001	0	\N	0	0	\N	\N	0	106889	0	63513-6	40766240		
11725	1110	3006734	1995-03-20	1995-03-20 00:00:00	1995-03-20	5001	0	\N	0	0	\N	\N	0	73052	0	6189-5	3006734		
51768	4745	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	315971	0	6085-5	3001247		
51787	4748	3006322	1963-12-28	1963-12-28 00:00:00	1963-12-28	5001	0	\N	0	0	\N	\N	0	316129	0	8331-1	3006322		
57219	5253	3011505	2011-01-08	2011-01-08 00:00:00	2011-01-08	5001	0	\N	0	0	\N	\N	0	349514	0	19926-5	3011505		
19810	1814	40769194	1971-04-23	1971-04-23 00:00:00	1971-04-23	5001	0	\N	0	0	\N	\N	0	121382	0	66534-9	40769194		
17481	1593	40758406	1968-05-25	1968-05-25 00:00:00	1968-05-25	5001	0	\N	0	0	\N	\N	0	106889	0	55277-8	40758406		
11726	1110	3001488	1995-03-20	1995-03-20 00:00:00	1995-03-20	5001	0	\N	0	0	\N	\N	0	73052	0	7258-7	3001488		
51769	4745	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	315971	0	6833-8	3023430		
51788	4748	3006322	1969-12-23	1969-12-23 00:00:00	1969-12-23	5001	0	\N	0	0	\N	\N	0	316211	0	8331-1	3006322		
57220	5253	3011505	1997-12-20	1997-12-20 00:00:00	1997-12-20	5001	0	\N	0	0	\N	\N	0	349537	0	19926-5	3011505		
19811	1814	40769179	1971-04-23	1971-04-23 00:00:00	1971-04-23	5001	0	\N	0	0	\N	\N	0	121382	0	66519-0	40769179		
17482	1593	3051031	1967-09-28	1967-09-28 00:00:00	1967-09-28	5001	0	\N	0	0	\N	\N	0	106942	0	46240-8	3051031		
11727	1110	3014599	1995-03-20	1995-03-20 00:00:00	1995-03-20	5001	0	\N	0	0	\N	\N	0	73052	0	6106-9	3014599		
51770	4745	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	315971	0	6844-5	3020655		
51789	4749	3006322	2008-11-25	2008-11-25 00:00:00	2008-11-25	5001	0	\N	0	0	\N	\N	0	316240	0	8331-1	3006322		
57221	5253	3006322	1981-04-11	1981-04-11 00:00:00	1981-04-11	5001	0	\N	0	0	\N	\N	0	349564	0	8331-1	3006322		
19812	1814	40769189	1971-04-23	1971-04-23 00:00:00	1971-04-23	5001	0	\N	0	0	\N	\N	0	121382	0	66529-9	40769189		
17483	1593	46235214	1967-09-28	1967-09-28 00:00:00	1967-09-28	5001	0	\N	0	0	\N	\N	0	106942	0	76690-7	46235214		
11728	1110	3006451	1995-03-20	1995-03-20 00:00:00	1995-03-20	5001	0	\N	0	0	\N	\N	0	73052	0	6273-7	3006451		
51771	4745	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	315971	0	6273-7	3006451		
51790	4749	3006322	1986-07-11	1986-07-11 00:00:00	1986-07-11	5001	0	\N	0	0	\N	\N	0	316250	0	8331-1	3006322		
57222	5253	3011505	2014-01-25	2014-01-25 00:00:00	2014-01-25	5001	0	\N	0	0	\N	\N	0	349517	0	19926-5	3011505		
19813	1814	40769184	1971-04-23	1971-04-23 00:00:00	1971-04-23	5001	0	\N	0	0	\N	\N	0	121382	0	66524-0	40769184		
17484	1593	40758406	1967-09-28	1967-09-28 00:00:00	1967-09-28	5001	0	\N	0	0	\N	\N	0	106942	0	55277-8	40758406		
11729	1110	3027231	1995-03-20	1995-03-20 00:00:00	1995-03-20	5001	0	\N	0	0	\N	\N	0	73052	0	6276-0	3027231		
51772	4745	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	315971	0	6246-3	3021226		
51791	4749	3006322	1981-10-07	1981-10-07 00:00:00	1981-10-07	5001	0	\N	0	0	\N	\N	0	316249	0	8331-1	3006322		
57223	5253	3006322	1990-11-03	1990-11-03 00:00:00	1990-11-03	5001	0	\N	0	0	\N	\N	0	349542	0	8331-1	3006322		
19814	1814	3006322	1958-06-16	1958-06-16 00:00:00	1958-06-16	5001	0	\N	0	0	\N	\N	0	121415	0	8331-1	3006322		
17487	1593	40766240	1967-09-28	1967-09-28 00:00:00	1967-09-28	5001	0	\N	0	0	\N	\N	0	106942	0	63513-6	40766240		
11730	1110	3020655	1995-03-20	1995-03-20 00:00:00	1995-03-20	5001	0	\N	0	0	\N	\N	0	73052	0	6844-5	3020655		
51773	4745	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	315971	0	6276-0	3027231		
51792	4749	3006322	1983-12-09	1983-12-09 00:00:00	1983-12-09	5001	0	\N	0	0	\N	\N	0	316247	0	8331-1	3006322		
57224	5253	3011505	2017-05-13	2017-05-13 00:00:00	2017-05-13	5001	0	\N	0	0	\N	\N	0	349515	0	19926-5	3011505		
19815	1814	3000963	2018-04-03	2018-04-03 00:00:00	2018-04-03	5001	0	\N	0	0	\N	\N	0	121406	0	718-7	3000963		
17488	1593	3000963	1973-10-01	1973-10-01 00:00:00	1973-10-01	5001	0	\N	0	0	\N	\N	0	106850	0	718-7	3000963		
11731	1110	3019406	1995-03-20	1995-03-20 00:00:00	1995-03-20	5001	0	\N	0	0	\N	\N	0	73052	0	6158-0	3019406		
28999	2673	3027231	1993-08-16	1993-08-16 00:00:00	1993-08-16	5001	0	\N	0	0	\N	\N	0	177057	0	6276-0	3027231		
51793	4749	3006322	2015-08-05	2015-08-05 00:00:00	2015-08-05	5001	0	\N	0	0	\N	\N	0	316272	0	8331-1	3006322		
57225	5253	3006322	1993-01-03	1993-01-03 00:00:00	1993-01-03	5001	0	\N	0	0	\N	\N	0	349525	0	8331-1	3006322		
19816	1814	3015632	2018-04-03	2018-04-03 00:00:00	2018-04-03	5001	0	\N	0	0	\N	\N	0	121406	0	2028-9	3015632		
17489	1593	3009542	1973-10-01	1973-10-01 00:00:00	1973-10-01	5001	0	\N	0	0	\N	\N	0	106850	0	20570-8	3009542		
11732	1110	3015076	1995-03-20	1995-03-20 00:00:00	1995-03-20	5001	0	\N	0	0	\N	\N	0	73052	0	6248-9	3015076		
29000	2673	3006451	1993-08-16	1993-08-16 00:00:00	1993-08-16	5001	0	\N	0	0	\N	\N	0	177057	0	6273-7	3006451		
51794	4749	3006322	2003-08-10	2003-08-10 00:00:00	2003-08-10	5001	0	\N	0	0	\N	\N	0	316261	0	8331-1	3006322		
57226	5253	3011505	2007-12-22	2007-12-22 00:00:00	2007-12-22	5001	0	\N	0	0	\N	\N	0	349567	0	19926-5	3011505		
19817	1814	3007461	2018-04-03	2018-04-03 00:00:00	2018-04-03	5001	0	\N	0	0	\N	\N	0	121406	0	26515-7	3007461		
17491	1593	40766240	1967-12-27	1967-12-27 00:00:00	1967-12-27	5001	0	\N	0	0	\N	\N	0	106848	0	63513-6	40766240		
11733	1110	3005136	1995-03-20	1995-03-20 00:00:00	1995-03-20	5001	0	\N	0	0	\N	\N	0	73052	0	6075-6	3005136		
29001	2673	3006734	1993-08-16	1993-08-16 00:00:00	1993-08-16	5001	0	\N	0	0	\N	\N	0	177057	0	6189-5	3006734		
51795	4749	3006322	2001-04-06	2001-04-06 00:00:00	2001-04-06	5001	0	\N	0	0	\N	\N	0	316270	0	8331-1	3006322		
57227	5253	3006322	1976-02-28	1976-02-28 00:00:00	1976-02-28	5001	0	\N	0	0	\N	\N	0	349539	0	8331-1	3006322		
19818	1814	3045716	2018-04-03	2018-04-03 00:00:00	2018-04-03	5001	0	\N	0	0	\N	\N	0	121406	0	33037-3	3045716		
17492	1593	40758406	1967-12-27	1967-12-27 00:00:00	1967-12-27	5001	0	\N	0	0	\N	\N	0	106848	0	55277-8	40758406		
11734	1110	3001247	1995-03-20	1995-03-20 00:00:00	1995-03-20	5001	0	\N	0	0	\N	\N	0	73052	0	6085-5	3001247		
29002	2673	3020655	1993-08-16	1993-08-16 00:00:00	1993-08-16	5001	0	\N	0	0	\N	\N	0	177057	0	6844-5	3020655		
51796	4750	3006322	1973-11-29	1973-11-29 00:00:00	1973-11-29	5001	0	\N	0	0	\N	\N	0	316285	0	8331-1	3006322		
57228	5253	3011505	1991-03-23	1991-03-23 00:00:00	1991-03-23	5001	0	\N	0	0	\N	\N	0	349506	0	19926-5	3011505		
19819	1814	3023103	2018-04-03	2018-04-03 00:00:00	2018-04-03	5001	0	\N	0	0	\N	\N	0	121406	0	2823-3	3023103		
17494	1593	3051031	1967-12-27	1967-12-27 00:00:00	1967-12-27	5001	0	\N	0	0	\N	\N	0	106848	0	46240-8	3051031		
11735	1110	3000876	1995-03-20	1995-03-20 00:00:00	1995-03-20	5001	0	\N	0	0	\N	\N	0	73052	0	6082-2	3000876		
29003	2673	3023430	1993-08-16	1993-08-16 00:00:00	1993-08-16	5001	0	\N	0	0	\N	\N	0	177057	0	6833-8	3023430		
51797	4750	3006322	2001-07-15	2001-07-15 00:00:00	2001-07-15	5001	0	\N	0	0	\N	\N	0	316402	0	8331-1	3006322		
57229	5253	3006322	1974-07-24	1974-07-24 00:00:00	1974-07-24	5001	0	\N	0	0	\N	\N	0	349482	0	8331-1	3006322		
19820	1814	3002385	2018-04-03	2018-04-03 00:00:00	2018-04-03	5001	0	\N	0	0	\N	\N	0	121406	0	30385-9	3002385		
17495	1593	46235214	1967-12-27	1967-12-27 00:00:00	1967-12-27	5001	0	\N	0	0	\N	\N	0	106848	0	76690-7	46235214		
11736	1110	3006322	2003-07-07	2003-07-07 00:00:00	2003-07-07	5001	0	\N	0	0	\N	\N	0	73119	0	8331-1	3006322		
29004	2673	3001247	1993-08-16	1993-08-16 00:00:00	1993-08-16	5001	0	\N	0	0	\N	\N	0	177057	0	6085-5	3001247		
51798	4750	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	316352	0	6189-5	3006734		
57230	5253	3011505	1986-10-04	1986-10-04 00:00:00	1986-10-04	5001	0	\N	0	0	\N	\N	0	349533	0	19926-5	3011505		
19821	1814	3013682	2018-04-03	2018-04-03 00:00:00	2018-04-03	5001	0	\N	0	0	\N	\N	0	121406	0	3094-0	3013682		
17496	1593	40766240	1968-10-22	1968-10-22 00:00:00	1968-10-22	5001	0	\N	0	0	\N	\N	0	106898	0	63513-6	40766240		
11737	1110	3006322	1994-03-14	1994-03-14 00:00:00	1994-03-14	5001	0	\N	0	0	\N	\N	0	73028	0	8331-1	3006322		
29005	2673	3015076	1993-08-16	1993-08-16 00:00:00	1993-08-16	5001	0	\N	0	0	\N	\N	0	177057	0	6248-9	3015076		
51799	4750	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	316352	0	6158-0	3019406		
57231	5253	3011505	2010-01-02	2010-01-02 00:00:00	2010-01-02	5001	0	\N	0	0	\N	\N	0	349568	0	19926-5	3011505		
19822	1814	3020630	2018-04-03	2018-04-03 00:00:00	2018-04-03	5001	0	\N	0	0	\N	\N	0	121406	0	2885-2	3020630		
17497	1593	40758406	1968-10-22	1968-10-22 00:00:00	1968-10-22	5001	0	\N	0	0	\N	\N	0	106898	0	55277-8	40758406		
11738	1110	3006734	1983-04-24	1983-04-24 00:00:00	1983-04-24	5001	0	\N	0	0	\N	\N	0	73088	0	6189-5	3006734		
29006	2673	3021226	1993-08-16	1993-08-16 00:00:00	1993-08-16	5001	0	\N	0	0	\N	\N	0	177057	0	6246-3	3021226		
51800	4750	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	316352	0	6085-5	3001247		
57232	5253	3011505	2001-12-29	2001-12-29 00:00:00	2001-12-29	5001	0	\N	0	0	\N	\N	0	349558	0	19926-5	3011505		
19823	1814	3035995	2018-04-03	2018-04-03 00:00:00	2018-04-03	5001	0	\N	0	0	\N	\N	0	121406	0	6768-6	3035995		
17498	1593	3051031	1968-10-22	1968-10-22 00:00:00	1968-10-22	5001	0	\N	0	0	\N	\N	0	106898	0	46240-8	3051031		
11739	1110	3012494	1983-04-24	1983-04-24 00:00:00	1983-04-24	5001	0	\N	0	0	\N	\N	0	73088	0	6206-7	3012494		
29007	2673	3014599	1993-08-16	1993-08-16 00:00:00	1993-08-16	5001	0	\N	0	0	\N	\N	0	177057	0	6106-9	3014599		
51801	4750	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	316352	0	6273-7	3006451		
57233	5253	3011505	1991-10-26	1991-10-26 00:00:00	1991-10-26	5001	0	\N	0	0	\N	\N	0	349510	0	19926-5	3011505		
19824	1814	3010813	2018-04-03	2018-04-03 00:00:00	2018-04-03	5001	0	\N	0	0	\N	\N	0	121406	0	26464-8	3010813		
17499	1593	46235214	1968-10-22	1968-10-22 00:00:00	1968-10-22	5001	0	\N	0	0	\N	\N	0	106898	0	76690-7	46235214		
11740	1110	3001488	1983-04-24	1983-04-24 00:00:00	1983-04-24	5001	0	\N	0	0	\N	\N	0	73088	0	7258-7	3001488		
29008	2673	3012494	1993-08-16	1993-08-16 00:00:00	1993-08-16	5001	0	\N	0	0	\N	\N	0	177057	0	6206-7	3012494		
51802	4750	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	316352	0	6246-3	3021226		
57234	5253	3011505	1999-12-25	1999-12-25 00:00:00	1999-12-25	5001	0	\N	0	0	\N	\N	0	349511	0	19926-5	3011505		
19825	1814	3026361	2018-04-03	2018-04-03 00:00:00	2018-04-03	5001	0	\N	0	0	\N	\N	0	121406	0	26453-1	3026361		
17503	1593	40758406	1968-04-25	1968-04-25 00:00:00	1968-04-25	5001	0	\N	0	0	\N	\N	0	106896	0	55277-8	40758406		
11741	1110	3036780	1983-04-24	1983-04-24 00:00:00	1983-04-24	5001	0	\N	0	0	\N	\N	0	73088	0	6095-4	3036780		
29009	2673	3036780	1993-08-16	1993-08-16 00:00:00	1993-08-16	5001	0	\N	0	0	\N	\N	0	177057	0	6095-4	3036780		
51803	4750	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	316352	0	6082-2	3000876		
57235	5253	3011505	2016-02-06	2016-02-06 00:00:00	2016-02-06	5001	0	\N	0	0	\N	\N	0	349518	0	19926-5	3011505		
19826	1814	3016723	2018-04-03	2018-04-03 00:00:00	2018-04-03	5001	0	\N	0	0	\N	\N	0	121406	0	2160-0	3016723		
17504	1593	3051031	1968-04-25	1968-04-25 00:00:00	1968-04-25	5001	0	\N	0	0	\N	\N	0	106896	0	46240-8	3051031		
11742	1110	3021226	1983-04-24	1983-04-24 00:00:00	1983-04-24	5001	0	\N	0	0	\N	\N	0	73088	0	6246-3	3021226		
29010	2673	3000876	1993-08-16	1993-08-16 00:00:00	1993-08-16	5001	0	\N	0	0	\N	\N	0	177057	0	6082-2	3000876		
51804	4750	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	316352	0	7258-7	3001488		
57236	5253	3011505	2019-05-25	2019-05-25 00:00:00	2019-05-25	5001	0	\N	0	0	\N	\N	0	349516	0	19926-5	3011505		
19827	1814	3028833	2018-04-03	2018-04-03 00:00:00	2018-04-03	5001	0	\N	0	0	\N	\N	0	121406	0	42719-5	3028833		
17505	1593	46235214	1968-04-25	1968-04-25 00:00:00	1968-04-25	5001	0	\N	0	0	\N	\N	0	106896	0	76690-7	46235214		
11743	1110	3023430	1983-04-24	1983-04-24 00:00:00	1983-04-24	5001	0	\N	0	0	\N	\N	0	73088	0	6833-8	3023430		
29011	2674	3006322	1989-02-04	1989-02-04 00:00:00	1989-02-04	5001	0	\N	0	0	\N	\N	0	177184	0	8331-1	3006322		
51805	4750	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	316352	0	6276-0	3027231		
57237	5253	3011505	1995-12-16	1995-12-16 00:00:00	1995-12-16	5001	0	\N	0	0	\N	\N	0	349508	0	19926-5	3011505		
19828	1814	3009542	2018-04-03	2018-04-03 00:00:00	2018-04-03	5001	0	\N	0	0	\N	\N	0	121406	0	20570-8	3009542		
17507	1593	40766240	1968-04-25	1968-04-25 00:00:00	1968-04-25	5001	0	\N	0	0	\N	\N	0	106896	0	63513-6	40766240		
11744	1110	3001247	1983-04-24	1983-04-24 00:00:00	1983-04-24	5001	0	\N	0	0	\N	\N	0	73088	0	6085-5	3001247		
29012	2674	3006322	2000-02-20	2000-02-20 00:00:00	2000-02-20	5001	0	\N	0	0	\N	\N	0	177228	0	8331-1	3006322		
51806	4750	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	316352	0	6248-9	3015076		
57238	5253	3006322	1956-03-13	1956-03-13 00:00:00	1956-03-13	5001	0	\N	0	0	\N	\N	0	349559	0	8331-1	3006322		
19829	1814	3013721	2018-04-03	2018-04-03 00:00:00	2018-04-03	5001	0	\N	0	0	\N	\N	0	121406	0	1920-8	3013721		
168221	5165	4052083	1974-12-26	1974-12-26 00:00:00	1974-12-26	5001	0	\N	0	0	\N	\N	0	343268	0	23426006	4052083		
11745	1110	3000876	1983-04-24	1983-04-24 00:00:00	1983-04-24	5001	0	\N	0	0	\N	\N	0	73088	0	6082-2	3000876		
29013	2674	3006322	1973-02-14	1973-02-14 00:00:00	1973-02-14	5001	0	\N	0	0	\N	\N	0	177211	0	8331-1	3006322		
51807	4750	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	316352	0	6833-8	3023430		
57252	5255	3006322	1976-09-08	1976-09-08 00:00:00	1976-09-08	5001	0	\N	0	0	\N	\N	0	349635	0	8331-1	3006322		
19830	1814	3006923	2018-04-03	2018-04-03 00:00:00	2018-04-03	5001	0	\N	0	0	\N	\N	0	121406	0	1742-6	3006923		
168230	5165	4024958	1969-08-09	1969-08-09 00:00:00	1969-08-09	5001	0	\N	0	0	\N	\N	0	343288	0	117015009	4024958		
11746	1110	3019406	1983-04-24	1983-04-24 00:00:00	1983-04-24	5001	0	\N	0	0	\N	\N	0	73088	0	6158-0	3019406		
29014	2675	3006322	2006-12-25	2006-12-25 00:00:00	2006-12-25	5001	0	\N	0	0	\N	\N	0	177272	0	8331-1	3006322		
51808	4750	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	316352	0	6844-5	3020655		
57253	5255	3006322	2018-06-24	2018-06-24 00:00:00	2018-06-24	5001	0	\N	0	0	\N	\N	0	349668	0	8331-1	3006322		
19831	1814	3024731	2018-04-03	2018-04-03 00:00:00	2018-04-03	5001	0	\N	0	0	\N	\N	0	121406	0	30428-7	3024731		
168252	5166	4052083	2003-01-18	2003-01-18 00:00:00	2003-01-18	5001	0	\N	0	0	\N	\N	0	343463	0	23426006	4052083		
11747	1110	3015076	1983-04-24	1983-04-24 00:00:00	1983-04-24	5001	0	\N	0	0	\N	\N	0	73088	0	6248-9	3015076		
29015	2675	3006322	2000-02-07	2000-02-07 00:00:00	2000-02-07	5001	0	\N	0	0	\N	\N	0	177271	0	8331-1	3006322		
51809	4750	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	316352	0	6095-4	3036780		
57254	5255	3006322	1993-07-02	1993-07-02 00:00:00	1993-07-02	5001	0	\N	0	0	\N	\N	0	349677	0	8331-1	3006322		
19832	1814	3006906	2018-04-03	2018-04-03 00:00:00	2018-04-03	5001	0	\N	0	0	\N	\N	0	121406	0	17861-6	3006906		
168258	5166	4052083	1958-09-06	1958-09-06 00:00:00	1958-09-06	5001	0	\N	0	0	\N	\N	0	343415	0	23426006	4052083		
11748	1110	3005136	1983-04-24	1983-04-24 00:00:00	1983-04-24	5001	0	\N	0	0	\N	\N	0	73088	0	6075-6	3005136		
29016	2675	3006322	2001-04-14	2001-04-14 00:00:00	2001-04-14	5001	0	\N	0	0	\N	\N	0	177292	0	8331-1	3006322		
51810	4750	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	316352	0	6206-7	3012494		
57255	5255	3006322	2010-09-12	2010-09-12 00:00:00	2010-09-12	5001	0	\N	0	0	\N	\N	0	349624	0	8331-1	3006322		
19833	1814	3004501	2018-04-03	2018-04-03 00:00:00	2018-04-03	5001	0	\N	0	0	\N	\N	0	121406	0	2345-7	3004501		
6087	565	3006322	1974-01-13	1974-01-13 00:00:00	1974-01-13	5001	0	\N	0	0	\N	\N	0	37437	0	8331-1	3006322		
11749	1110	3020655	1983-04-24	1983-04-24 00:00:00	1983-04-24	5001	0	\N	0	0	\N	\N	0	73088	0	6844-5	3020655		
29032	2677	3006322	2004-07-08	2004-07-08 00:00:00	2004-07-08	5001	0	\N	0	0	\N	\N	0	177419	0	8331-1	3006322		
51811	4750	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	316352	0	6075-6	3005136		
57256	5255	3006322	1971-07-27	1971-07-27 00:00:00	1971-07-27	5001	0	\N	0	0	\N	\N	0	349634	0	8331-1	3006322		
19834	1814	21494966	2018-04-03	2018-04-03 00:00:00	2018-04-03	5001	0	\N	0	0	\N	\N	0	121406	0	80271-0	21494966		
6088	565	3006322	1963-02-24	1963-02-24 00:00:00	1963-02-24	5001	0	\N	0	0	\N	\N	0	37460	0	8331-1	3006322		
11750	1110	3014599	1983-04-24	1983-04-24 00:00:00	1983-04-24	5001	0	\N	0	0	\N	\N	0	73088	0	6106-9	3014599		
29033	2677	3006322	1974-06-07	1974-06-07 00:00:00	1974-06-07	5001	0	\N	0	0	\N	\N	0	177372	0	8331-1	3006322		
51812	4750	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	316352	0	6106-9	3014599		
57257	5255	3006322	1977-01-17	1977-01-17 00:00:00	1977-01-17	5001	0	\N	0	0	\N	\N	0	349665	0	8331-1	3006322		
19835	1814	3027970	2018-04-03	2018-04-03 00:00:00	2018-04-03	5001	0	\N	0	0	\N	\N	0	121406	0	10834-0	3027970		
6093	569	3006322	1922-01-07	1922-01-07 00:00:00	1922-01-07	5001	0	\N	0	0	\N	\N	0	37690	0	8331-1	3006322		
11751	1110	3006451	1983-04-24	1983-04-24 00:00:00	1983-04-24	5001	0	\N	0	0	\N	\N	0	73088	0	6273-7	3006451		
29034	2677	3006322	1991-02-02	1991-02-02 00:00:00	1991-02-02	5001	0	\N	0	0	\N	\N	0	177380	0	8331-1	3006322		
51813	4750	3027231	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	316286	0	6276-0	3027231		
57258	5255	3006322	2014-05-04	2014-05-04 00:00:00	2014-05-04	5001	0	\N	0	0	\N	\N	0	349625	0	8331-1	3006322		
19836	1814	3019550	2018-04-03	2018-04-03 00:00:00	2018-04-03	5001	0	\N	0	0	\N	\N	0	121406	0	2951-2	3019550		
6094	569	3006322	1958-01-24	1958-01-24 00:00:00	1958-01-24	5001	0	\N	0	0	\N	\N	0	37665	0	8331-1	3006322		
11752	1110	3027231	1983-04-24	1983-04-24 00:00:00	1983-04-24	5001	0	\N	0	0	\N	\N	0	73088	0	6276-0	3027231		
29035	2677	3006322	1981-12-08	1981-12-08 00:00:00	1981-12-08	5001	0	\N	0	0	\N	\N	0	177343	0	8331-1	3006322		
51814	4750	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	316286	0	6248-9	3015076		
57259	5256	3006322	1980-11-04	1980-11-04 00:00:00	1980-11-04	5001	0	\N	0	0	\N	\N	0	349743	0	8331-1	3006322		
19837	1814	3014576	2018-04-03	2018-04-03 00:00:00	2018-04-03	5001	0	\N	0	0	\N	\N	0	121406	0	2075-0	3014576		
6095	569	3006322	2017-12-12	2017-12-12 00:00:00	2017-12-12	5001	0	\N	0	0	\N	\N	0	37588	0	8331-1	3006322		
11753	1112	3006322	1988-05-05	1988-05-05 00:00:00	1988-05-05	5001	0	\N	0	0	\N	\N	0	73167	0	8331-1	3006322		
29036	2679	3006322	1978-09-29	1978-09-29 00:00:00	1978-09-29	5001	0	\N	0	0	\N	\N	0	177500	0	8331-1	3006322		
51815	4750	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	316286	0	6075-6	3005136		
57260	5256	3006322	1988-01-21	1988-01-21 00:00:00	1988-01-21	5001	0	\N	0	0	\N	\N	0	349775	0	8331-1	3006322		
19838	1814	3024561	2018-04-03	2018-04-03 00:00:00	2018-04-03	5001	0	\N	0	0	\N	\N	0	121406	0	1751-7	3024561		
6096	569	3006322	1923-05-15	1923-05-15 00:00:00	1923-05-15	5001	0	\N	0	0	\N	\N	0	37664	0	8331-1	3006322		
11754	1112	3006322	1982-01-23	1982-01-23 00:00:00	1982-01-23	5001	0	\N	0	0	\N	\N	0	73166	0	8331-1	3006322		
29037	2679	3006322	1985-10-04	1985-10-04 00:00:00	1985-10-04	5001	0	\N	0	0	\N	\N	0	177479	0	8331-1	3006322		
51816	4750	3014599	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	316286	0	6106-9	3014599		
57261	5256	3006322	2018-08-02	2018-08-02 00:00:00	2018-08-02	5001	0	\N	0	0	\N	\N	0	349777	0	8331-1	3006322		
19839	1814	3006322	2018-02-25	2018-02-25 00:00:00	2018-02-25	5001	0	\N	0	0	\N	\N	0	121445	0	8331-1	3006322		
6097	569	3006322	2017-10-01	2017-10-01 00:00:00	2017-10-01	5001	0	\N	0	0	\N	\N	0	37592	0	8331-1	3006322		
11755	1112	3006322	2004-08-18	2004-08-18 00:00:00	2004-08-18	5001	0	\N	0	0	\N	\N	0	73169	0	8331-1	3006322		
29038	2680	3006322	2003-06-10	2003-06-10 00:00:00	2003-06-10	5001	0	\N	0	0	\N	\N	0	177529	0	8331-1	3006322		
51817	4750	3036780	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	316286	0	6095-4	3036780		
57262	5256	3006322	1986-05-20	1986-05-20 00:00:00	1986-05-20	5001	0	\N	0	0	\N	\N	0	349719	0	8331-1	3006322		
19840	1814	3006322	1990-11-05	1990-11-05 00:00:00	1990-11-05	5001	0	\N	0	0	\N	\N	0	121385	0	8331-1	3006322		
6098	569	3006322	1981-01-03	1981-01-03 00:00:00	1981-01-03	5001	0	\N	0	0	\N	\N	0	37668	0	8331-1	3006322		
11756	1113	3006322	1986-10-11	1986-10-11 00:00:00	1986-10-11	5001	0	\N	0	0	\N	\N	0	73256	0	8331-1	3006322		
29039	2680	3006322	1985-01-14	1985-01-14 00:00:00	1985-01-14	5001	0	\N	0	0	\N	\N	0	177541	0	8331-1	3006322		
51818	4750	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	316286	0	6158-0	3019406		
57263	5256	3006322	1994-02-28	1994-02-28 00:00:00	1994-02-28	5001	0	\N	0	0	\N	\N	0	349713	0	8331-1	3006322		
19849	1819	3006322	2013-12-04	2013-12-04 00:00:00	2013-12-04	5001	0	\N	0	0	\N	\N	0	121647	0	8331-1	3006322		
6099	569	3049273	1976-04-08	1976-04-08 00:00:00	1976-04-08	5001	0	\N	0	0	\N	\N	0	37663	0	38265-5	3049273		
11757	1113	3006322	2010-10-03	2010-10-03 00:00:00	2010-10-03	5001	0	\N	0	0	\N	\N	0	73240	0	8331-1	3006322		
29040	2680	3006322	1977-09-13	1977-09-13 00:00:00	1977-09-13	5001	0	\N	0	0	\N	\N	0	177540	0	8331-1	3006322		
51819	4750	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	316286	0	6844-5	3020655		
57264	5256	3006322	1970-07-21	1970-07-21 00:00:00	1970-07-21	5001	0	\N	0	0	\N	\N	0	349742	0	8331-1	3006322		
19850	1819	3006322	2010-09-10	2010-09-10 00:00:00	2010-09-10	5001	0	\N	0	0	\N	\N	0	121689	0	8331-1	3006322		
6100	569	3049273	1993-03-20	1993-03-20 00:00:00	1993-03-20	5001	0	\N	0	0	\N	\N	0	37682	0	38265-5	3049273		
11758	1113	3006322	1976-05-27	1976-05-27 00:00:00	1976-05-27	5001	0	\N	0	0	\N	\N	0	73255	0	8331-1	3006322		
29041	2680	3006322	1999-04-22	1999-04-22 00:00:00	1999-04-22	5001	0	\N	0	0	\N	\N	0	177528	0	8331-1	3006322		
51820	4750	3001247	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	316286	0	6085-5	3001247		
57265	5257	3006322	1996-10-06	1996-10-06 00:00:00	1996-10-06	5001	0	\N	0	0	\N	\N	0	349836	0	8331-1	3006322		
19851	1819	3006322	1989-01-07	1989-01-07 00:00:00	1989-01-07	5001	0	\N	0	0	\N	\N	0	121644	0	8331-1	3006322		
6101	569	3006322	1993-04-14	1993-04-14 00:00:00	1993-04-14	5001	0	\N	0	0	\N	\N	0	37639	0	8331-1	3006322		
11759	1113	3006322	2010-05-25	2010-05-25 00:00:00	2010-05-25	5001	0	\N	0	0	\N	\N	0	73288	0	8331-1	3006322		
29042	2680	3006322	1991-10-20	1991-10-20 00:00:00	1991-10-20	5001	0	\N	0	0	\N	\N	0	177524	0	8331-1	3006322		
51821	4750	3006734	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	316286	0	6189-5	3006734		
57266	5257	3006322	1979-09-09	1979-09-09 00:00:00	1979-09-09	5001	0	\N	0	0	\N	\N	0	349823	0	8331-1	3006322		
19852	1819	3006322	2009-01-08	2009-01-08 00:00:00	2009-01-08	5001	0	\N	0	0	\N	\N	0	121664	0	8331-1	3006322		
6102	569	3006322	2007-12-09	2007-12-09 00:00:00	2007-12-09	5001	0	\N	0	0	\N	\N	0	37643	0	8331-1	3006322		
11760	1113	3006322	2010-03-13	2010-03-13 00:00:00	2010-03-13	5001	0	\N	0	0	\N	\N	0	73278	0	8331-1	3006322		
29043	2680	3006322	2013-07-02	2013-07-02 00:00:00	2013-07-02	5001	0	\N	0	0	\N	\N	0	177564	0	8331-1	3006322		
51822	4750	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	316286	0	7258-7	3001488		
57267	5257	3006322	1998-09-08	1998-09-08 00:00:00	1998-09-08	5001	0	\N	0	0	\N	\N	0	349826	0	8331-1	3006322		
19853	1819	3006322	1981-04-07	1981-04-07 00:00:00	1981-04-07	5001	0	\N	0	0	\N	\N	0	121673	0	8331-1	3006322		
6105	571	3006322	2018-07-09	2018-07-09 00:00:00	2018-07-09	5001	0	\N	0	0	\N	\N	0	37829	0	8331-1	3006322		
11761	1113	3006322	2009-07-05	2009-07-05 00:00:00	2009-07-05	5001	0	\N	0	0	\N	\N	0	73277	0	8331-1	3006322		
51823	4750	3023430	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	316286	0	6833-8	3023430		
57268	5257	3006322	1988-01-10	1988-01-10 00:00:00	1988-01-10	5001	0	\N	0	0	\N	\N	0	349834	0	8331-1	3006322		
19854	1820	3006322	1986-08-08	1986-08-08 00:00:00	1986-08-08	5001	0	\N	0	0	\N	\N	0	121739	0	8331-1	3006322		
6106	571	3009542	1956-08-29	1956-08-29 00:00:00	1956-08-29	5001	0	\N	0	0	\N	\N	0	37797	0	20570-8	3009542		
11762	1113	3006322	1992-05-23	1992-05-23 00:00:00	1992-05-23	5001	0	\N	0	0	\N	\N	0	73257	0	8331-1	3006322		
51824	4750	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	316286	0	6206-7	3012494		
57269	5258	3006322	1984-03-04	1984-03-04 00:00:00	1984-03-04	5001	0	\N	0	0	\N	\N	0	349849	0	8331-1	3006322		
19855	1820	3006322	1982-03-19	1982-03-19 00:00:00	1982-03-19	5001	0	\N	0	0	\N	\N	0	121738	0	8331-1	3006322		
6107	571	3000963	1956-08-29	1956-08-29 00:00:00	1956-08-29	5001	0	\N	0	0	\N	\N	0	37797	0	718-7	3000963		
11764	1115	3006322	1967-01-29	1967-01-29 00:00:00	1967-01-29	5001	0	\N	0	0	\N	\N	0	73452	0	8331-1	3006322		
51825	4750	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	316286	0	6273-7	3006451		
57270	5258	3006322	2000-04-09	2000-04-09 00:00:00	2000-04-09	5001	0	\N	0	0	\N	\N	0	349859	0	8331-1	3006322		
19856	1820	3006322	1999-05-22	1999-05-22 00:00:00	1999-05-22	5001	0	\N	0	0	\N	\N	0	121750	0	8331-1	3006322		
30952	959	4052083	1996-10-18	1996-10-18 00:00:00	1996-10-18	5001	0	\N	0	0	\N	\N	0	63776	0	23426006	4052083		
11765	1115	3021226	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	73497	0	6246-3	3021226		
51826	4750	3021226	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	316286	0	6246-3	3021226		
57271	5258	3006322	1993-03-26	1993-03-26 00:00:00	1993-03-26	5001	0	\N	0	0	\N	\N	0	349858	0	8331-1	3006322		
19857	1820	3006322	1999-02-09	1999-02-09 00:00:00	1999-02-09	5001	0	\N	0	0	\N	\N	0	121745	0	8331-1	3006322		
30956	959	4052083	1967-02-08	1967-02-08 00:00:00	1967-02-08	5001	0	\N	0	0	\N	\N	0	63695	0	23426006	4052083		
11766	1115	3005136	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	73497	0	6075-6	3005136		
51827	4750	3000876	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	316286	0	6082-2	3000876		
57272	5258	3006322	2014-02-20	2014-02-20 00:00:00	2014-02-20	5001	0	\N	0	0	\N	\N	0	349894	0	8331-1	3006322		
19858	1821	3006322	1944-07-30	1944-07-30 00:00:00	1944-07-30	5001	0	\N	0	0	\N	\N	0	121850	0	8331-1	3006322		
65440	2006	4052083	1950-03-30	1950-03-30 00:00:00	1950-03-30	5001	0	\N	0	0	\N	\N	0	133545	0	23426006	4052083		
11767	1115	3019406	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	73497	0	6158-0	3019406		
51828	4750	3006322	1973-02-19	1973-02-19 00:00:00	1973-02-19	5001	0	\N	0	0	\N	\N	0	316284	0	8331-1	3006322		
57273	5258	3006322	1994-10-27	1994-10-27 00:00:00	1994-10-27	5001	0	\N	0	0	\N	\N	0	349922	0	8331-1	3006322		
19859	1821	3006322	1950-06-09	1950-06-09 00:00:00	1950-06-09	5001	0	\N	0	0	\N	\N	0	121816	0	8331-1	3006322		
65447	2006	4024958	1961-12-11	1961-12-11 00:00:00	1961-12-11	5001	0	\N	0	0	\N	\N	0	133567	0	117015009	4024958		
11768	1115	3001247	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	73497	0	6085-5	3001247		
51829	4750	3006322	1980-04-10	1980-04-10 00:00:00	1980-04-10	5001	0	\N	0	0	\N	\N	0	316335	0	8331-1	3006322		
57274	5258	3006322	2009-09-01	2009-09-01 00:00:00	2009-09-01	5001	0	\N	0	0	\N	\N	0	349893	0	8331-1	3006322		
19860	1821	3006322	1971-08-17	1971-08-17 00:00:00	1971-08-17	5001	0	\N	0	0	\N	\N	0	121810	0	8331-1	3006322		
65461	2006	4052083	1959-11-28	1959-11-28 00:00:00	1959-11-28	5001	0	\N	0	0	\N	\N	0	133639	0	23426006	4052083		
11769	1115	3023430	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	73497	0	6833-8	3023430		
51830	4750	3006322	1998-11-13	1998-11-13 00:00:00	1998-11-13	5001	0	\N	0	0	\N	\N	0	316296	0	8331-1	3006322		
57275	5258	3006322	1966-09-18	1966-09-18 00:00:00	1966-09-18	5001	0	\N	0	0	\N	\N	0	349870	0	8331-1	3006322		
116467	3589	4024958	1990-10-13	1990-10-13 00:00:00	1990-10-13	5001	0	\N	0	0	\N	\N	0	238428	0	117015009	4024958		
65464	2006	4052083	1993-10-17	1993-10-17 00:00:00	1993-10-17	5001	0	\N	0	0	\N	\N	0	133569	0	23426006	4052083		
11770	1115	3015076	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	73497	0	6248-9	3015076		
51838	4753	3006322	1985-05-14	1985-05-14 00:00:00	1985-05-14	5001	0	\N	0	0	\N	\N	0	316570	0	8331-1	3006322		
57276	5259	3006322	1966-05-20	1966-05-20 00:00:00	1966-05-20	5001	0	\N	0	0	\N	\N	0	349933	0	8331-1	3006322		
116492	3589	4024958	1991-06-25	1991-06-25 00:00:00	1991-06-25	5001	0	\N	0	0	\N	\N	0	238399	0	117015009	4024958		
65470	2006	4024958	1972-02-28	1972-02-28 00:00:00	1972-02-28	5001	0	\N	0	0	\N	\N	0	133619	0	117015009	4024958		
11771	1115	3027231	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	73497	0	6276-0	3027231		
51839	4753	3006322	1982-12-31	1982-12-31 00:00:00	1982-12-31	5001	0	\N	0	0	\N	\N	0	316491	0	8331-1	3006322		
57277	5259	3006322	1994-09-03	1994-09-03 00:00:00	1994-09-03	5001	0	\N	0	0	\N	\N	0	349996	0	8331-1	3006322		
44534	1371	4024958	2008-11-13	2008-11-13 00:00:00	2008-11-13	5001	0	\N	0	0	\N	\N	0	90915	0	117015009	4024958		
65484	2007	4052083	1993-07-29	1993-07-29 00:00:00	1993-07-29	5001	0	\N	0	0	\N	\N	0	133692	0	23426006	4052083		
11772	1115	3014599	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	73497	0	6106-9	3014599		
51840	4753	3006322	1996-11-23	1996-11-23 00:00:00	1996-11-23	5001	0	\N	0	0	\N	\N	0	316492	0	8331-1	3006322		
57278	5259	3006322	1989-09-14	1989-09-14 00:00:00	1989-09-14	5001	0	\N	0	0	\N	\N	0	349967	0	8331-1	3006322		
44536	1371	4024958	2009-05-22	2009-05-22 00:00:00	2009-05-22	5001	0	\N	0	0	\N	\N	0	90902	0	117015009	4024958		
65486	2007	4024958	2002-11-22	2002-11-22 00:00:00	2002-11-22	5001	0	\N	0	0	\N	\N	0	133681	0	117015009	4024958		
11773	1115	3006451	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	73497	0	6273-7	3006451		
51841	4753	3006322	1984-11-03	1984-11-03 00:00:00	1984-11-03	5001	0	\N	0	0	\N	\N	0	316546	0	8331-1	3006322		
57279	5259	3006322	2011-03-21	2011-03-21 00:00:00	2011-03-21	5001	0	\N	0	0	\N	\N	0	349969	0	8331-1	3006322		
65498	2007	4052083	2015-01-14	2015-01-14 00:00:00	2015-01-14	5001	0	\N	0	0	\N	\N	0	133668	0	23426006	4052083		
11774	1115	3012494	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	73497	0	6206-7	3012494		
51842	4753	3006322	1975-02-28	1975-02-28 00:00:00	1975-02-28	5001	0	\N	0	0	\N	\N	0	316539	0	8331-1	3006322		
57280	5259	3006322	1973-08-24	1973-08-24 00:00:00	1973-08-24	5001	0	\N	0	0	\N	\N	0	349943	0	8331-1	3006322		
8338	268	4024958	1979-07-06	1979-07-06 00:00:00	1979-07-06	5001	0	\N	0	0	\N	\N	0	17833	0	117015009	4024958		
11775	1115	3000876	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	73497	0	6082-2	3000876		
51843	4754	3006322	2008-07-14	2008-07-14 00:00:00	2008-07-14	5001	0	\N	0	0	\N	\N	0	316656	0	8331-1	3006322		
146393	4491	4024958	2015-02-09	2015-02-09 00:00:00	2015-02-09	5001	0	\N	0	0	\N	\N	0	298999	0	117015009	4024958		
8349	268	4024958	2004-12-04	2004-12-04 00:00:00	2004-12-04	5001	0	\N	0	0	\N	\N	0	17782	0	117015009	4024958		
11776	1115	3001488	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	73497	0	7258-7	3001488		
51844	4754	3006322	1972-08-24	1972-08-24 00:00:00	1972-08-24	5001	0	\N	0	0	\N	\N	0	316654	0	8331-1	3006322		
157709	4847	4133840	1995-06-14	1995-06-14 00:00:00	1995-06-14	5001	0	\N	0	0	\N	\N	0	322456	0	127783003	4133840		
8360	268	4024958	2007-08-03	2007-08-03 00:00:00	2007-08-03	5001	0	\N	0	0	\N	\N	0	17780	0	117015009	4024958		
11777	1115	3006734	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	73497	0	6189-5	3006734		
51845	4754	3006322	1972-03-13	1972-03-13 00:00:00	1972-03-13	5001	0	\N	0	0	\N	\N	0	316639	0	8331-1	3006322		
157713	4847	4133840	1994-06-08	1994-06-08 00:00:00	1994-06-08	5001	0	\N	0	0	\N	\N	0	322417	0	127783003	4133840		
163108	5007	4052083	1999-08-02	1999-08-02 00:00:00	1999-08-02	5001	0	\N	0	0	\N	\N	0	333023	0	23426006	4052083		
11778	1115	3036780	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	73497	0	6095-4	3036780		
51846	4754	3006322	1994-04-12	1994-04-12 00:00:00	1994-04-12	5001	0	\N	0	0	\N	\N	0	316592	0	8331-1	3006322		
157716	4847	4133840	2014-04-02	2014-04-02 00:00:00	2014-04-02	5001	0	\N	0	0	\N	\N	0	322460	0	127783003	4133840		
163111	5007	4024958	2013-07-06	2013-07-06 00:00:00	2013-07-06	5001	0	\N	0	0	\N	\N	0	333011	0	117015009	4024958		
11779	1115	3020655	1993-07-05	1993-07-05 00:00:00	1993-07-05	5001	0	\N	0	0	\N	\N	0	73497	0	6844-5	3020655		
51847	4755	3006322	1941-09-11	1941-09-11 00:00:00	1941-09-11	5001	0	\N	0	0	\N	\N	0	316713	0	8331-1	3006322		
157719	4847	4133840	1985-06-12	1985-06-12 00:00:00	1985-06-12	5001	0	\N	0	0	\N	\N	0	322447	0	127783003	4133840		
163174	5013	4052083	1990-07-26	1990-07-26 00:00:00	1990-07-26	5001	0	\N	0	0	\N	\N	0	333205	0	23426006	4052083		
11780	1115	3049273	2014-12-12	2014-12-12 00:00:00	2014-12-12	5001	0	\N	0	0	\N	\N	0	73390	0	38265-5	3049273		
51848	4755	3006322	2018-08-14	2018-08-14 00:00:00	2018-08-14	5001	0	\N	0	0	\N	\N	0	316671	0	8331-1	3006322		
157720	4847	4133840	1996-06-19	1996-06-19 00:00:00	1996-06-19	5001	0	\N	0	0	\N	\N	0	322418	0	127783003	4133840		
163175	5013	4024958	1973-04-07	1973-04-07 00:00:00	1973-04-07	5001	0	\N	0	0	\N	\N	0	333172	0	117015009	4024958		
11781	1115	3006322	2013-11-07	2013-11-07 00:00:00	2013-11-07	5001	0	\N	0	0	\N	\N	0	73374	0	8331-1	3006322		
51849	4755	3006322	1947-04-06	1947-04-06 00:00:00	1947-04-06	5001	0	\N	0	0	\N	\N	0	316682	0	8331-1	3006322		
157723	4847	4052083	1959-12-06	1959-12-06 00:00:00	1959-12-06	5001	0	\N	0	0	\N	\N	0	322442	0	23426006	4052083		
14478	453	4024958	1977-05-22	1977-05-22 00:00:00	1977-05-22	5001	0	\N	0	0	\N	\N	0	30220	0	117015009	4024958		
11782	1115	3000876	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	73440	0	6082-2	3000876		
51850	4755	3006322	1944-09-06	1944-09-06 00:00:00	1944-09-06	5001	0	\N	0	0	\N	\N	0	316755	0	8331-1	3006322		
157724	4847	4133840	2002-01-30	2002-01-30 00:00:00	2002-01-30	5001	0	\N	0	0	\N	\N	0	322450	0	127783003	4133840		
11783	1115	3001488	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	73440	0	7258-7	3001488		
51851	4755	3049273	2014-05-24	2014-05-24 00:00:00	2014-05-24	5001	0	\N	0	0	\N	\N	0	316711	0	38265-5	3049273		
157727	4847	4133840	1978-01-25	1978-01-25 00:00:00	1978-01-25	5001	0	\N	0	0	\N	\N	0	322414	0	127783003	4133840		
11784	1115	3006734	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	73440	0	6189-5	3006734		
51852	4755	3006322	2017-03-14	2017-03-14 00:00:00	2017-03-14	5001	0	\N	0	0	\N	\N	0	316743	0	8331-1	3006322		
157728	4847	4133840	1993-06-02	1993-06-02 00:00:00	1993-06-02	5001	0	\N	0	0	\N	\N	0	322455	0	127783003	4133840		
11785	1115	3036780	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	73440	0	6095-4	3036780		
51853	4756	3006322	2003-12-02	2003-12-02 00:00:00	2003-12-02	5001	0	\N	0	0	\N	\N	0	316869	0	8331-1	3006322		
157733	4847	4133840	1999-07-07	1999-07-07 00:00:00	1999-07-07	5001	0	\N	0	0	\N	\N	0	322448	0	127783003	4133840		
11786	1115	3020655	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	73440	0	6844-5	3020655		
51854	4756	3006322	1946-10-11	1946-10-11 00:00:00	1946-10-11	5001	0	\N	0	0	\N	\N	0	316826	0	8331-1	3006322		
157734	4847	4133840	2003-02-05	2003-02-05 00:00:00	2003-02-05	5001	0	\N	0	0	\N	\N	0	322477	0	127783003	4133840		
11787	1115	3021226	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	73440	0	6246-3	3021226		
51855	4756	3006322	1990-02-03	1990-02-03 00:00:00	1990-02-03	5001	0	\N	0	0	\N	\N	0	316844	0	8331-1	3006322		
157738	4847	4133840	1989-06-21	1989-06-21 00:00:00	1989-06-21	5001	0	\N	0	0	\N	\N	0	322410	0	127783003	4133840		
11788	1115	3005136	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	73440	0	6075-6	3005136		
51856	4756	3006322	2006-04-02	2006-04-02 00:00:00	2006-04-02	5001	0	\N	0	0	\N	\N	0	316788	0	8331-1	3006322		
157741	4847	4133840	1975-01-22	1975-01-22 00:00:00	1975-01-22	5001	0	\N	0	0	\N	\N	0	322413	0	127783003	4133840		
11789	1115	3019406	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	73440	0	6158-0	3019406		
29091	2682	3006322	1978-08-21	1978-08-21 00:00:00	1978-08-21	5001	0	\N	0	0	\N	\N	0	177738	0	8331-1	3006322		
157745	4847	4133840	2015-04-08	2015-04-08 00:00:00	2015-04-08	5001	0	\N	0	0	\N	\N	0	322421	0	127783003	4133840		
11790	1115	3001247	1990-01-01	1990-01-01 00:00:00	1990-01-01	5001	0	\N	0	0	\N	\N	0	73440	0	6085-5	3001247		
29092	2682	3006322	1982-02-11	1982-02-11 00:00:00	1982-02-11	5001	0	\N	0	0	\N	\N	0	177727	0	8331-1	3006322		
157750	4847	4133840	1991-09-11	1991-09-11 00:00:00	1991-09-11	5001	0	\N	0	0	\N	\N	0	322454	0	127783003	4133840		
80172	2468	4024958	1972-09-18	1972-09-18 00:00:00	1972-09-18	5001	0	\N	0	0	\N	\N	0	163652	0	117015009	4024958		
29093	2682	3006322	2009-02-17	2009-02-17 00:00:00	2009-02-17	5001	0	\N	0	0	\N	\N	0	177758	0	8331-1	3006322		
62744	1925	4024958	1990-05-03	1990-05-03 00:00:00	1990-05-03	5001	0	\N	0	0	\N	\N	0	128162	0	117015009	4024958		
80184	2468	4052083	1981-08-08	1981-08-08 00:00:00	1981-08-08	5001	0	\N	0	0	\N	\N	0	163593	0	23426006	4052083		
29094	2682	3006322	1995-10-13	1995-10-13 00:00:00	1995-10-13	5001	0	\N	0	0	\N	\N	0	177710	0	8331-1	3006322		
62759	1925	4052083	1962-01-23	1962-01-23 00:00:00	1962-01-23	5001	0	\N	0	0	\N	\N	0	128122	0	23426006	4052083		
91514	2825	4024958	1938-10-15	1938-10-15 00:00:00	1938-10-15	5001	0	\N	0	0	\N	\N	0	187282	0	117015009	4024958		
29111	2684	3006322	1998-11-06	1998-11-06 00:00:00	1998-11-06	5001	0	\N	0	0	\N	\N	0	177878	0	8331-1	3006322		
62802	1926	4024958	1987-07-23	1987-07-23 00:00:00	1987-07-23	5001	0	\N	0	0	\N	\N	0	128233	0	117015009	4024958		
25841	806	4024958	2010-11-09	2010-11-09 00:00:00	2010-11-09	5001	0	\N	0	0	\N	\N	0	53516	0	117015009	4024958		
29112	2684	3049273	2014-04-08	2014-04-08 00:00:00	2014-04-08	5001	0	\N	0	0	\N	\N	0	177896	0	38265-5	3049273		
62810	1926	4052083	2016-01-11	2016-01-11 00:00:00	2016-01-11	5001	0	\N	0	0	\N	\N	0	128245	0	23426006	4052083		
25847	806	4024958	1960-07-13	1960-07-13 00:00:00	1960-07-13	5001	0	\N	0	0	\N	\N	0	53501	0	117015009	4024958		
29113	2684	3006322	2005-11-10	2005-11-10 00:00:00	2005-11-10	5001	0	\N	0	0	\N	\N	0	177879	0	8331-1	3006322		
62811	1926	4024958	1980-06-19	1980-06-19 00:00:00	1980-06-19	5001	0	\N	0	0	\N	\N	0	128232	0	117015009	4024958		
25860	806	4024958	1999-02-28	1999-02-28 00:00:00	1999-02-28	5001	0	\N	0	0	\N	\N	0	53503	0	117015009	4024958		
29114	2684	3006322	2012-04-18	2012-04-18 00:00:00	2012-04-18	5001	0	\N	0	0	\N	\N	0	177888	0	8331-1	3006322		
132903	4091	4052083	1999-05-22	1999-05-22 00:00:00	1999-05-22	5001	0	\N	0	0	\N	\N	0	271969	0	23426006	4052083		
25880	807	4024958	1960-05-17	1960-05-17 00:00:00	1960-05-17	5001	0	\N	0	0	\N	\N	0	53566	0	117015009	4024958		
29115	2684	3006322	1986-01-03	1986-01-03 00:00:00	1986-01-03	5001	0	\N	0	0	\N	\N	0	177858	0	8331-1	3006322		
132909	4091	4024958	1979-12-19	1979-12-19 00:00:00	1979-12-19	5001	0	\N	0	0	\N	\N	0	271947	0	117015009	4024958		
25882	807	4024958	1957-10-14	1957-10-14 00:00:00	1957-10-14	5001	0	\N	0	0	\N	\N	0	53572	0	117015009	4024958		
29116	2684	3006322	2014-12-17	2014-12-17 00:00:00	2014-12-17	5001	0	\N	0	0	\N	\N	0	177825	0	8331-1	3006322		
132910	4091	4052083	1990-11-09	1990-11-09 00:00:00	1990-11-09	5001	0	\N	0	0	\N	\N	0	271948	0	23426006	4052083		
25902	807	4024958	1970-06-24	1970-06-24 00:00:00	1970-06-24	5001	0	\N	0	0	\N	\N	0	53560	0	117015009	4024958		
29117	2685	3011505	2015-05-21	2015-05-21 00:00:00	2015-05-21	5001	0	\N	0	0	\N	\N	0	177981	0	19926-5	3011505		
132912	4091	4024958	2000-01-30	2000-01-30 00:00:00	2000-01-30	5001	0	\N	0	0	\N	\N	0	271989	0	117015009	4024958		
25903	807	4052083	1973-11-17	1973-11-17 00:00:00	1973-11-17	5001	0	\N	0	0	\N	\N	0	53624	0	23426006	4052083		
29118	2685	3011505	2016-05-26	2016-05-26 00:00:00	2016-05-26	5001	0	\N	0	0	\N	\N	0	177935	0	19926-5	3011505		
132914	4091	4052083	1994-03-08	1994-03-08 00:00:00	1994-03-08	5001	0	\N	0	0	\N	\N	0	271952	0	23426006	4052083		
25907	807	4024958	1971-03-06	1971-03-06 00:00:00	1971-03-06	5001	0	\N	0	0	\N	\N	0	53623	0	117015009	4024958		
29119	2685	3011505	1980-01-17	1980-01-17 00:00:00	1980-01-17	5001	0	\N	0	0	\N	\N	0	177959	0	19926-5	3011505		
132922	4091	4052083	1970-05-16	1970-05-16 00:00:00	1970-05-16	5001	0	\N	0	0	\N	\N	0	271985	0	23426006	4052083		
43101	3982	40758406	1966-01-28	1966-01-28 00:00:00	1966-01-28	5001	0	\N	0	0	\N	\N	0	264729	0	55277-8	40758406		
29120	2685	3006322	2011-12-20	2011-12-20 00:00:00	2011-12-20	5001	0	\N	0	0	\N	\N	0	177946	0	8331-1	3006322		
132928	4092	4052083	2018-04-09	2018-04-09 00:00:00	2018-04-09	5001	0	\N	0	0	\N	\N	0	272049	0	23426006	4052083		
43102	3982	3006322	2016-06-26	2016-06-26 00:00:00	2016-06-26	5001	0	\N	0	0	\N	\N	0	264658	0	8331-1	3006322		
29121	2685	3011505	2014-05-15	2014-05-15 00:00:00	2014-05-15	5001	0	\N	0	0	\N	\N	0	177934	0	19926-5	3011505		
132930	4092	4024958	1996-11-19	1996-11-19 00:00:00	1996-11-19	5001	0	\N	0	0	\N	\N	0	272046	0	117015009	4024958		
43103	3982	46235214	1965-12-29	1965-12-29 00:00:00	1965-12-29	5001	0	\N	0	0	\N	\N	0	264709	0	76690-7	46235214		
29122	2685	3011505	1977-01-13	1977-01-13 00:00:00	1977-01-13	5001	0	\N	0	0	\N	\N	0	177958	0	19926-5	3011505		
132931	4092	4024958	2001-07-11	2001-07-11 00:00:00	2001-07-11	5001	0	\N	0	0	\N	\N	0	272056	0	117015009	4024958		
43104	3982	40766240	1965-12-29	1965-12-29 00:00:00	1965-12-29	5001	0	\N	0	0	\N	\N	0	264709	0	63513-6	40766240		
29123	2685	3011505	1996-12-19	1996-12-19 00:00:00	1996-12-19	5001	0	\N	0	0	\N	\N	0	177930	0	19926-5	3011505		
132942	4092	4024958	2007-04-04	2007-04-04 00:00:00	2007-04-04	5001	0	\N	0	0	\N	\N	0	272048	0	117015009	4024958		
43106	3982	40758406	1965-12-29	1965-12-29 00:00:00	1965-12-29	5001	0	\N	0	0	\N	\N	0	264709	0	55277-8	40758406		
29124	2685	3011505	1993-12-02	1993-12-02 00:00:00	1993-12-02	5001	0	\N	0	0	\N	\N	0	177975	0	19926-5	3011505		
132944	4092	4024958	1996-08-08	1996-08-08 00:00:00	1996-08-08	5001	0	\N	0	0	\N	\N	0	272045	0	117015009	4024958		
43108	3982	3051031	1965-12-29	1965-12-29 00:00:00	1965-12-29	5001	0	\N	0	0	\N	\N	0	264709	0	46240-8	3051031		
29125	2685	3011505	1999-02-18	1999-02-18 00:00:00	1999-02-18	5001	0	\N	0	0	\N	\N	0	177902	0	19926-5	3011505		
132948	4092	4024958	1973-10-09	1973-10-09 00:00:00	1973-10-09	5001	0	\N	0	0	\N	\N	0	272019	0	117015009	4024958		
43110	3982	40758406	1965-08-31	1965-08-31 00:00:00	1965-08-31	5001	0	\N	0	0	\N	\N	0	264749	0	55277-8	40758406		
29126	2685	3011505	2012-05-03	2012-05-03 00:00:00	2012-05-03	5001	0	\N	0	0	\N	\N	0	177906	0	19926-5	3011505		
132949	4092	4052083	1987-09-24	1987-09-24 00:00:00	1987-09-24	5001	0	\N	0	0	\N	\N	0	272055	0	23426006	4052083		
43111	3982	46235214	1965-08-31	1965-08-31 00:00:00	1965-08-31	5001	0	\N	0	0	\N	\N	0	264749	0	76690-7	46235214		
29127	2685	3011505	2003-03-13	2003-03-13 00:00:00	2003-03-13	5001	0	\N	0	0	\N	\N	0	177932	0	19926-5	3011505		
132970	4094	4052083	1974-09-08	1974-09-08 00:00:00	1974-09-08	5001	0	\N	0	0	\N	\N	0	272123	0	23426006	4052083		
43113	3982	3051031	1965-08-31	1965-08-31 00:00:00	1965-08-31	5001	0	\N	0	0	\N	\N	0	264749	0	46240-8	3051031		
29128	2685	3011505	1968-01-04	1968-01-04 00:00:00	1968-01-04	5001	0	\N	0	0	\N	\N	0	177921	0	19926-5	3011505		
132977	4094	4052083	1959-12-17	1959-12-17 00:00:00	1959-12-17	5001	0	\N	0	0	\N	\N	0	272115	0	23426006	4052083		
43115	3982	40766240	1965-08-31	1965-08-31 00:00:00	1965-08-31	5001	0	\N	0	0	\N	\N	0	264749	0	63513-6	40766240		
29129	2685	3011505	1965-01-28	1965-01-28 00:00:00	1965-01-28	5001	0	\N	0	0	\N	\N	0	177954	0	19926-5	3011505		
132979	4094	4024958	2004-09-16	2004-09-16 00:00:00	2004-09-16	5001	0	\N	0	0	\N	\N	0	272116	0	117015009	4024958		
43116	3982	3006322	1988-02-11	1988-02-11 00:00:00	1988-02-11	5001	0	\N	0	0	\N	\N	0	264752	0	8331-1	3006322		
29130	2685	3011505	2017-06-01	2017-06-01 00:00:00	2017-06-01	5001	0	\N	0	0	\N	\N	0	177982	0	19926-5	3011505		
1789	49	4052083	1978-03-10	1978-03-10 00:00:00	1978-03-10	5001	0	\N	0	0	\N	\N	0	3540	0	23426006	4052083		
43117	3982	3006322	1987-06-04	1987-06-04 00:00:00	1987-06-04	5001	0	\N	0	0	\N	\N	0	264713	0	8331-1	3006322		
29131	2685	3011505	2009-04-16	2009-04-16 00:00:00	2009-04-16	5001	0	\N	0	0	\N	\N	0	177964	0	19926-5	3011505		
1790	49	4052083	1997-05-30	1997-05-30 00:00:00	1997-05-30	5001	0	\N	0	0	\N	\N	0	3562	0	23426006	4052083		
43118	3982	3006322	1965-02-20	1965-02-20 00:00:00	1965-02-20	5001	0	\N	0	0	\N	\N	0	264654	0	8331-1	3006322		
29132	2685	3011505	2002-03-07	2002-03-07 00:00:00	2002-03-07	5001	0	\N	0	0	\N	\N	0	177978	0	19926-5	3011505		
13081	412	4024958	1981-06-18	1981-06-18 00:00:00	1981-06-18	5001	0	\N	0	0	\N	\N	0	27463	0	117015009	4024958		
43119	3982	40758406	1940-04-09	1940-04-09 00:00:00	1940-04-09	5001	0	\N	0	0	\N	\N	0	264706	0	55277-8	40758406		
29133	2685	3011505	1987-01-08	1987-01-08 00:00:00	1987-01-08	5001	0	\N	0	0	\N	\N	0	177960	0	19926-5	3011505		
44431	1368	4024958	1976-09-02	1976-09-02 00:00:00	1976-09-02	5001	0	\N	0	0	\N	\N	0	90708	0	117015009	4024958		
43120	3982	46235214	1940-04-09	1940-04-09 00:00:00	1940-04-09	5001	0	\N	0	0	\N	\N	0	264706	0	76690-7	46235214		
29134	2685	3011505	2000-02-24	2000-02-24 00:00:00	2000-02-24	5001	0	\N	0	0	\N	\N	0	177977	0	19926-5	3011505		
44436	1368	4024958	1965-02-19	1965-02-19 00:00:00	1965-02-19	5001	0	\N	0	0	\N	\N	0	90661	0	117015009	4024958		
43122	3982	3051031	1940-04-09	1940-04-09 00:00:00	1940-04-09	5001	0	\N	0	0	\N	\N	0	264706	0	46240-8	3051031		
29135	2685	3011505	2001-03-01	2001-03-01 00:00:00	2001-03-01	5001	0	\N	0	0	\N	\N	0	177931	0	19926-5	3011505		
123529	3811	4024958	1994-03-31	1994-03-31 00:00:00	1994-03-31	5001	0	\N	0	0	\N	\N	0	253221	0	117015009	4024958		
43123	3982	40766240	1940-04-09	1940-04-09 00:00:00	1940-04-09	5001	0	\N	0	0	\N	\N	0	264706	0	63513-6	40766240		
29136	2685	3011505	1982-12-02	1982-12-02 00:00:00	1982-12-02	5001	0	\N	0	0	\N	\N	0	177926	0	19926-5	3011505		
123534	3811	4024958	1948-03-20	1948-03-20 00:00:00	1948-03-20	5001	0	\N	0	0	\N	\N	0	253117	0	117015009	4024958		
43127	3982	40758406	1940-07-08	1940-07-08 00:00:00	1940-07-08	5001	0	\N	0	0	\N	\N	0	264707	0	55277-8	40758406		
29137	2685	3011505	1998-02-12	1998-02-12 00:00:00	1998-02-12	5001	0	\N	0	0	\N	\N	0	177962	0	19926-5	3011505		
123547	3811	4024958	1944-12-24	1944-12-24 00:00:00	1944-12-24	5001	0	\N	0	0	\N	\N	0	253145	0	117015009	4024958		
43128	3982	46235214	1940-07-08	1940-07-08 00:00:00	1940-07-08	5001	0	\N	0	0	\N	\N	0	264707	0	76690-7	46235214		
29138	2685	3011505	2008-04-10	2008-04-10 00:00:00	2008-04-10	5001	0	\N	0	0	\N	\N	0	177904	0	19926-5	3011505		
123550	3811	4024958	2008-04-13	2008-04-13 00:00:00	2008-04-13	5001	0	\N	0	0	\N	\N	0	253184	0	117015009	4024958		
43130	3982	3051031	1940-07-08	1940-07-08 00:00:00	1940-07-08	5001	0	\N	0	0	\N	\N	0	264707	0	46240-8	3051031		
29139	2685	3011505	2007-04-05	2007-04-05 00:00:00	2007-04-05	5001	0	\N	0	0	\N	\N	0	177963	0	19926-5	3011505		
123554	3811	4052083	1963-10-02	1963-10-02 00:00:00	1963-10-02	5001	0	\N	0	0	\N	\N	0	253119	0	23426006	4052083		
43131	3982	40766240	1940-07-08	1940-07-08 00:00:00	1940-07-08	5001	0	\N	0	0	\N	\N	0	264707	0	63513-6	40766240		
29140	2685	3011505	1995-12-14	1995-12-14 00:00:00	1995-12-14	5001	0	\N	0	0	\N	\N	0	177976	0	19926-5	3011505		
123557	3811	4052083	1998-08-03	1998-08-03 00:00:00	1998-08-03	5001	0	\N	0	0	\N	\N	0	253217	0	23426006	4052083		
43133	3982	40758406	1939-12-11	1939-12-11 00:00:00	1939-12-11	5001	0	\N	0	0	\N	\N	0	264697	0	55277-8	40758406		
29141	2685	3011505	1991-01-17	1991-01-17 00:00:00	1991-01-17	5001	0	\N	0	0	\N	\N	0	177961	0	19926-5	3011505		
123584	3813	4052083	2012-10-01	2012-10-01 00:00:00	2012-10-01	5001	0	\N	0	0	\N	\N	0	253302	0	23426006	4052083		
43134	3982	46235214	1939-12-11	1939-12-11 00:00:00	1939-12-11	5001	0	\N	0	0	\N	\N	0	264697	0	76690-7	46235214		
29142	2685	3011505	1997-02-06	1997-02-06 00:00:00	1997-02-06	5001	0	\N	0	0	\N	\N	0	177937	0	19926-5	3011505		
123588	3813	4024958	1973-08-30	1973-08-30 00:00:00	1973-08-30	5001	0	\N	0	0	\N	\N	0	253258	0	117015009	4024958		
43136	3982	3051031	1939-12-11	1939-12-11 00:00:00	1939-12-11	5001	0	\N	0	0	\N	\N	0	264697	0	46240-8	3051031		
29143	2685	3011505	1985-01-03	1985-01-03 00:00:00	1985-01-03	5001	0	\N	0	0	\N	\N	0	177974	0	19926-5	3011505		
123595	3813	4052083	1995-08-06	1995-08-06 00:00:00	1995-08-06	5001	0	\N	0	0	\N	\N	0	253281	0	23426006	4052083		
43137	3982	40766240	1939-12-11	1939-12-11 00:00:00	1939-12-11	5001	0	\N	0	0	\N	\N	0	264697	0	63513-6	40766240		
29144	2685	3011505	2013-05-09	2013-05-09 00:00:00	2013-05-09	5001	0	\N	0	0	\N	\N	0	177980	0	19926-5	3011505		
101109	3109	4024958	1939-09-16	1939-09-16 00:00:00	1939-09-16	5001	0	\N	0	0	\N	\N	0	206733	0	117015009	4024958		
54417	4976	3020655	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	330938	0	6844-5	3020655		
29145	2685	3006322	2013-09-19	2013-09-19 00:00:00	2013-09-19	5001	0	\N	0	0	\N	\N	0	177939	0	8331-1	3006322		
136309	4202	4024958	1990-09-29	1990-09-29 00:00:00	1990-09-29	5001	0	\N	0	0	\N	\N	0	278967	0	117015009	4024958		
54418	4976	3023430	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	330938	0	6833-8	3023430		
29147	2685	3011505	1971-01-07	1971-01-07 00:00:00	1971-01-07	5001	0	\N	0	0	\N	\N	0	177956	0	19926-5	3011505		
136314	4202	4024958	1972-01-13	1972-01-13 00:00:00	1972-01-13	5001	0	\N	0	0	\N	\N	0	278934	0	117015009	4024958		
54419	4976	3001247	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	330938	0	6085-5	3001247		
29148	2685	3006322	1967-06-19	1967-06-19 00:00:00	1967-06-19	5001	0	\N	0	0	\N	\N	0	177907	0	8331-1	3006322		
136319	4202	4024958	2008-11-02	2008-11-02 00:00:00	2008-11-02	5001	0	\N	0	0	\N	\N	0	278936	0	117015009	4024958		
54420	4976	3005136	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	330938	0	6075-6	3005136		
29149	2685	3011505	1974-01-10	1974-01-10 00:00:00	1974-01-10	5001	0	\N	0	0	\N	\N	0	177957	0	19926-5	3011505		
136362	4204	4052083	1950-09-15	1950-09-15 00:00:00	1950-09-15	5001	0	\N	0	0	\N	\N	0	279112	0	23426006	4052083		
54421	4976	3015076	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	330938	0	6248-9	3015076		
29150	2685	3011505	2006-03-30	2006-03-30 00:00:00	2006-03-30	5001	0	\N	0	0	\N	\N	0	177903	0	19926-5	3011505		
136373	4204	4052083	2015-05-19	2015-05-19 00:00:00	2015-05-19	5001	0	\N	0	0	\N	\N	0	279084	0	23426006	4052083		
54422	4976	3006451	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	330938	0	6273-7	3006451		
29151	2685	3011505	2010-04-22	2010-04-22 00:00:00	2010-04-22	5001	0	\N	0	0	\N	\N	0	177905	0	19926-5	3011505		
136377	4204	4024958	2010-12-15	2010-12-15 00:00:00	2010-12-15	5001	0	\N	0	0	\N	\N	0	279083	0	117015009	4024958		
54423	4976	3036780	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	330938	0	6095-4	3036780		
29152	2685	3011505	2011-04-28	2011-04-28 00:00:00	2011-04-28	5001	0	\N	0	0	\N	\N	0	177965	0	19926-5	3011505		
136379	4204	4052083	1993-03-18	1993-03-18 00:00:00	1993-03-18	5001	0	\N	0	0	\N	\N	0	279071	0	23426006	4052083		
54424	4976	3000876	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	330938	0	6082-2	3000876		
29153	2685	3011505	1982-12-30	1982-12-30 00:00:00	1982-12-30	5001	0	\N	0	0	\N	\N	0	177900	0	19926-5	3011505		
116383	3583	4024958	1989-08-21	1989-08-21 00:00:00	1989-08-21	5001	0	\N	0	0	\N	\N	0	238235	0	117015009	4024958		
54425	4976	3006734	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	330938	0	6189-5	3006734		
54426	4976	3019406	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	330938	0	6158-0	3019406		
54427	4976	3012494	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	330938	0	6206-7	3012494		
54428	4976	3021226	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	330938	0	6246-3	3021226		
54429	4976	3027231	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	330938	0	6276-0	3027231		
54430	4976	3014599	1990-01-02	1990-01-02 00:00:00	1990-01-02	5001	0	\N	0	0	\N	\N	0	330938	0	6106-9	3014599		
54431	4976	3009542	1976-10-27	1976-10-27 00:00:00	1976-10-27	5001	0	\N	0	0	\N	\N	0	330970	0	20570-8	3009542		
54432	4976	3000963	1976-10-27	1976-10-27 00:00:00	1976-10-27	5001	0	\N	0	0	\N	\N	0	330970	0	718-7	3000963		
54433	4976	3006322	1913-01-15	1913-01-15 00:00:00	1913-01-15	5001	0	\N	0	0	\N	\N	0	331067	0	8331-1	3006322		
54434	4976	3006322	1956-09-17	1956-09-17 00:00:00	1956-09-17	5001	0	\N	0	0	\N	\N	0	330968	0	8331-1	3006322		
54435	4976	3006322	1979-12-10	1979-12-10 00:00:00	1979-12-10	5001	0	\N	0	0	\N	\N	0	330977	0	8331-1	3006322		
54438	4976	3009201	1983-10-26	1983-10-26 00:00:00	1983-10-26	5001	0	\N	0	0	\N	\N	0	330937	0	3016-3	3009201		
54439	4976	3008598	1983-10-26	1983-10-26 00:00:00	1983-10-26	5001	0	\N	0	0	\N	\N	0	330937	0	3024-7	3008598		
54440	4976	3006322	1928-06-06	1928-06-06 00:00:00	1928-06-06	5001	0	\N	0	0	\N	\N	0	330966	0	8331-1	3006322		
54441	4976	3006322	1970-08-16	1970-08-16 00:00:00	1970-08-16	5001	0	\N	0	0	\N	\N	0	330976	0	8331-1	3006322		
54444	4976	3005136	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	331016	0	6075-6	3005136		
54445	4976	3019406	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	331016	0	6158-0	3019406		
54446	4976	3015076	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	331016	0	6248-9	3015076		
54447	4976	3006451	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	331016	0	6273-7	3006451		
54448	4976	3006734	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	331016	0	6189-5	3006734		
54449	4976	3000876	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	331016	0	6082-2	3000876		
54450	4976	3021226	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	331016	0	6246-3	3021226		
54451	4976	3012494	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	331016	0	6206-7	3012494		
54452	4976	3001488	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	331016	0	7258-7	3001488		
54453	4976	3036780	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	331016	0	6095-4	3036780		
54454	4976	3014599	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	331016	0	6106-9	3014599		
54455	4976	3027231	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	331016	0	6276-0	3027231		
54456	4976	3001247	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	331016	0	6085-5	3001247		
54457	4976	3023430	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	331016	0	6833-8	3023430		
54458	4976	3020655	1993-07-06	1993-07-06 00:00:00	1993-07-06	5001	0	\N	0	0	\N	\N	0	331016	0	6844-5	3020655		
144968	4450	4052083	1968-07-09	1968-07-09 00:00:00	1968-07-09	5001	0	\N	0	0	\N	\N	0	296089	0	23426006	4052083		
144970	4450	4024958	2004-02-02	2004-02-02 00:00:00	2004-02-02	5001	0	\N	0	0	\N	\N	0	296071	0	117015009	4024958		
144973	4450	4024958	1980-05-29	1980-05-29 00:00:00	1980-05-29	5001	0	\N	0	0	\N	\N	0	296038	0	117015009	4024958		
144974	4450	4024958	1975-12-11	1975-12-11 00:00:00	1975-12-11	5001	0	\N	0	0	\N	\N	0	296091	0	117015009	4024958		
144983	4450	4052083	2000-08-28	2000-08-28 00:00:00	2000-08-28	5001	0	\N	0	0	\N	\N	0	296070	0	23426006	4052083		
43001	1322	4024958	1935-09-14	1935-09-14 00:00:00	1935-09-14	5001	0	\N	0	0	\N	\N	0	87735	0	117015009	4024958		
43010	1323	4052083	2011-08-23	2011-08-23 00:00:00	2011-08-23	5001	0	\N	0	0	\N	\N	0	87852	0	23426006	4052083		
43020	1323	4052083	1984-03-08	1984-03-08 00:00:00	1984-03-08	5001	0	\N	0	0	\N	\N	0	87876	0	23426006	4052083		
43021	1323	4024958	1986-10-19	1986-10-19 00:00:00	1986-10-19	5001	0	\N	0	0	\N	\N	0	87874	0	117015009	4024958		
43026	1323	4024958	1986-07-10	1986-07-10 00:00:00	1986-07-10	5001	0	\N	0	0	\N	\N	0	87870	0	117015009	4024958		
43068	1325	4024958	1974-03-05	1974-03-05 00:00:00	1974-03-05	5001	0	\N	0	0	\N	\N	0	87957	0	117015009	4024958		
43075	1325	4024958	2018-05-12	2018-05-12 00:00:00	2018-05-12	5001	0	\N	0	0	\N	\N	0	87963	0	117015009	4024958		
43076	1325	4052083	2001-04-06	2001-04-06 00:00:00	2001-04-06	5001	0	\N	0	0	\N	\N	0	87951	0	23426006	4052083		
43077	1325	4024958	2002-03-12	2002-03-12 00:00:00	2002-03-12	5001	0	\N	0	0	\N	\N	0	87972	0	117015009	4024958		
43078	1325	4024958	1965-09-07	1965-09-07 00:00:00	1965-09-07	5001	0	\N	0	0	\N	\N	0	87956	0	117015009	4024958		
38528	1197	4024958	2012-06-04	2012-06-04 00:00:00	2012-06-04	5001	0	\N	0	0	\N	\N	0	78875	0	117015009	4024958		
38529	1197	4024958	2016-04-26	2016-04-26 00:00:00	2016-04-26	5001	0	\N	0	0	\N	\N	0	78846	0	117015009	4024958		
38534	1197	4024958	1982-12-25	1982-12-25 00:00:00	1982-12-25	5001	0	\N	0	0	\N	\N	0	78866	0	117015009	4024958		
38590	1201	4024958	1976-08-24	1976-08-24 00:00:00	1976-08-24	5001	0	\N	0	0	\N	\N	0	79028	0	117015009	4024958		
80444	2480	4024958	1967-07-03	1967-07-03 00:00:00	1967-07-03	5001	0	\N	0	0	\N	\N	0	164297	0	117015009	4024958		
80445	2480	4052083	1975-07-21	1975-07-21 00:00:00	1975-07-21	5001	0	\N	0	0	\N	\N	0	164301	0	23426006	4052083		
80496	2482	4024958	1984-02-24	1984-02-24 00:00:00	1984-02-24	5001	0	\N	0	0	\N	\N	0	164424	0	117015009	4024958		
80501	2483	4024958	1981-04-06	1981-04-06 00:00:00	1981-04-06	5001	0	\N	0	0	\N	\N	0	164491	0	117015009	4024958		
80503	2483	4133840	1977-05-21	1977-05-21 00:00:00	1977-05-21	5001	0	\N	0	0	\N	\N	0	164507	0	127783003	4133840		
80505	2483	4052083	1946-07-24	1946-07-24 00:00:00	1946-07-24	5001	0	\N	0	0	\N	\N	0	164482	0	23426006	4052083		
80506	2483	4133840	1983-05-28	1983-05-28 00:00:00	1983-05-28	5001	0	\N	0	0	\N	\N	0	164509	0	127783003	4133840		
80508	2483	4133840	1987-06-06	1987-06-06 00:00:00	1987-06-06	5001	0	\N	0	0	\N	\N	0	164503	0	127783003	4133840		
80509	2483	4133840	1966-05-07	1966-05-07 00:00:00	1966-05-07	5001	0	\N	0	0	\N	\N	0	164490	0	127783003	4133840		
162587	4988	4024958	2006-12-10	2006-12-10 00:00:00	2006-12-10	5001	0	\N	0	0	\N	\N	0	331833	0	117015009	4024958		
162626	4990	4024958	1965-05-12	1965-05-12 00:00:00	1965-05-12	5001	0	\N	0	0	\N	\N	0	331972	0	117015009	4024958		
162633	4990	4052083	1975-04-09	1975-04-09 00:00:00	1975-04-09	5001	0	\N	0	0	\N	\N	0	331961	0	23426006	4052083		
162641	4990	4052083	2002-07-31	2002-07-31 00:00:00	2002-07-31	5001	0	\N	0	0	\N	\N	0	332004	0	23426006	4052083		
162646	4990	4024958	2008-02-04	2008-02-04 00:00:00	2008-02-04	5001	0	\N	0	0	\N	\N	0	331986	0	117015009	4024958		
162649	4990	4024958	2012-03-26	2012-03-26 00:00:00	2012-03-26	5001	0	\N	0	0	\N	\N	0	331957	0	117015009	4024958		
54721	5004	3012494	1990-03-13	1990-03-13 00:00:00	1990-03-13	5001	0	\N	0	0	\N	\N	0	332871	0	6206-7	3012494		
54722	5004	3006451	1990-03-13	1990-03-13 00:00:00	1990-03-13	5001	0	\N	0	0	\N	\N	0	332871	0	6273-7	3006451		
54723	5004	3014599	1990-03-13	1990-03-13 00:00:00	1990-03-13	5001	0	\N	0	0	\N	\N	0	332871	0	6106-9	3014599		
54724	5004	3015076	1990-03-13	1990-03-13 00:00:00	1990-03-13	5001	0	\N	0	0	\N	\N	0	332871	0	6248-9	3015076		
54725	5004	3020655	1990-03-13	1990-03-13 00:00:00	1990-03-13	5001	0	\N	0	0	\N	\N	0	332871	0	6844-5	3020655		
54726	5004	3021226	1990-03-13	1990-03-13 00:00:00	1990-03-13	5001	0	\N	0	0	\N	\N	0	332871	0	6246-3	3021226		
54727	5004	3000876	1990-03-13	1990-03-13 00:00:00	1990-03-13	5001	0	\N	0	0	\N	\N	0	332871	0	6082-2	3000876		
54728	5004	3014599	1977-11-26	1977-11-26 00:00:00	1977-11-26	5001	0	\N	0	0	\N	\N	0	332831	0	6106-9	3014599		
54729	5004	3000876	1977-11-26	1977-11-26 00:00:00	1977-11-26	5001	0	\N	0	0	\N	\N	0	332831	0	6082-2	3000876		
54730	5004	3015076	1977-11-26	1977-11-26 00:00:00	1977-11-26	5001	0	\N	0	0	\N	\N	0	332831	0	6248-9	3015076		
54731	5004	3006451	1977-11-26	1977-11-26 00:00:00	1977-11-26	5001	0	\N	0	0	\N	\N	0	332831	0	6273-7	3006451		
54732	5004	3036780	1977-11-26	1977-11-26 00:00:00	1977-11-26	5001	0	\N	0	0	\N	\N	0	332831	0	6095-4	3036780		
54733	5004	3020655	1977-11-26	1977-11-26 00:00:00	1977-11-26	5001	0	\N	0	0	\N	\N	0	332831	0	6844-5	3020655		
54734	5004	3023430	1977-11-26	1977-11-26 00:00:00	1977-11-26	5001	0	\N	0	0	\N	\N	0	332831	0	6833-8	3023430		
54735	5004	3006734	1977-11-26	1977-11-26 00:00:00	1977-11-26	5001	0	\N	0	0	\N	\N	0	332831	0	6189-5	3006734		
54736	5004	3019406	1977-11-26	1977-11-26 00:00:00	1977-11-26	5001	0	\N	0	0	\N	\N	0	332831	0	6158-0	3019406		
54737	5004	3021226	1977-11-26	1977-11-26 00:00:00	1977-11-26	5001	0	\N	0	0	\N	\N	0	332831	0	6246-3	3021226		
54738	5004	3001247	1977-11-26	1977-11-26 00:00:00	1977-11-26	5001	0	\N	0	0	\N	\N	0	332831	0	6085-5	3001247		
54739	5004	3012494	1977-11-26	1977-11-26 00:00:00	1977-11-26	5001	0	\N	0	0	\N	\N	0	332831	0	6206-7	3012494		
54740	5004	3005136	1977-11-26	1977-11-26 00:00:00	1977-11-26	5001	0	\N	0	0	\N	\N	0	332831	0	6075-6	3005136		
54741	5004	3001488	1977-11-26	1977-11-26 00:00:00	1977-11-26	5001	0	\N	0	0	\N	\N	0	332831	0	7258-7	3001488		
54742	5004	3027231	1977-11-26	1977-11-26 00:00:00	1977-11-26	5001	0	\N	0	0	\N	\N	0	332831	0	6276-0	3027231		
54743	5004	40769184	1977-11-14	1977-11-14 00:00:00	1977-11-14	5001	0	\N	0	0	\N	\N	0	332877	0	66524-0	40769184		
54744	5004	40769179	1977-11-14	1977-11-14 00:00:00	1977-11-14	5001	0	\N	0	0	\N	\N	0	332877	0	66519-0	40769179		
54745	5004	40769189	1977-11-14	1977-11-14 00:00:00	1977-11-14	5001	0	\N	0	0	\N	\N	0	332877	0	66529-9	40769189		
54746	5004	40769194	1977-11-14	1977-11-14 00:00:00	1977-11-14	5001	0	\N	0	0	\N	\N	0	332877	0	66534-9	40769194		
54747	5004	3006322	1998-02-17	1998-02-17 00:00:00	1998-02-17	5001	0	\N	0	0	\N	\N	0	332888	0	8331-1	3006322		
54751	5007	3006322	2012-12-23	2012-12-23 00:00:00	2012-12-23	5001	0	\N	0	0	\N	\N	0	333026	0	8331-1	3006322		
54752	5007	3006322	2013-07-06	2013-07-06 00:00:00	2013-07-06	5001	0	\N	0	0	\N	\N	0	333011	0	8331-1	3006322		
1433	124	3027231	2000-09-12	2000-09-12 00:00:00	2000-09-12	5001	0	\N	0	0	\N	\N	0	8277	0	6276-0	3027231		
1434	124	3021226	2000-09-12	2000-09-12 00:00:00	2000-09-12	5001	0	\N	0	0	\N	\N	0	8277	0	6246-3	3021226		
1435	124	3015076	2000-09-12	2000-09-12 00:00:00	2000-09-12	5001	0	\N	0	0	\N	\N	0	8277	0	6248-9	3015076		
1436	124	3006734	2000-09-12	2000-09-12 00:00:00	2000-09-12	5001	0	\N	0	0	\N	\N	0	8277	0	6189-5	3006734		
1437	124	3006322	2011-01-16	2011-01-16 00:00:00	2011-01-16	5001	0	\N	0	0	\N	\N	0	8283	0	8331-1	3006322		
1438	124	3011505	2017-03-28	2017-03-28 00:00:00	2017-03-28	5001	0	\N	0	0	\N	\N	0	8274	0	19926-5	3011505		
1442	126	3006322	2016-09-30	2016-09-30 00:00:00	2016-09-30	5001	0	\N	0	0	\N	\N	0	8414	0	8331-1	3006322		
1443	126	3006322	1952-08-16	1952-08-16 00:00:00	1952-08-16	5001	0	\N	0	0	\N	\N	0	8408	0	8331-1	3006322		
1444	126	3006322	1950-09-16	1950-09-16 00:00:00	1950-09-16	5001	0	\N	0	0	\N	\N	0	8407	0	8331-1	3006322		
1445	126	3006322	2004-02-27	2004-02-27 00:00:00	2004-02-27	5001	0	\N	0	0	\N	\N	0	8462	0	8331-1	3006322		
1446	126	3006322	1947-10-22	1947-10-22 00:00:00	1947-10-22	5001	0	\N	0	0	\N	\N	0	8428	0	8331-1	3006322		
22449	2058	3019406	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	136841	0	6158-0	3019406		
22450	2058	3001488	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	136841	0	7258-7	3001488		
22451	2058	3020655	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	136841	0	6844-5	3020655		
22452	2058	3012494	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	136841	0	6206-7	3012494		
22453	2058	3005136	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	136841	0	6075-6	3005136		
22454	2058	3015076	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	136841	0	6248-9	3015076		
22455	2058	3006451	1990-01-03	1990-01-03 00:00:00	1990-01-03	5001	0	\N	0	0	\N	\N	0	136841	0	6273-7	3006451		
22456	2058	3021226	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	136912	0	6246-3	3021226		
22457	2058	3036780	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	136912	0	6095-4	3036780		
22458	2058	3014599	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	136912	0	6106-9	3014599		
22459	2058	3027231	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	136912	0	6276-0	3027231		
22460	2058	3019406	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	136912	0	6158-0	3019406		
22461	2058	3023430	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	136912	0	6833-8	3023430		
22462	2058	3012494	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	136912	0	6206-7	3012494		
22463	2058	3005136	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	136912	0	6075-6	3005136		
22464	2058	3015076	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	136912	0	6248-9	3015076		
22465	2058	3006451	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	136912	0	6273-7	3006451		
22466	2058	3001488	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	136912	0	7258-7	3001488		
22467	2058	3020655	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	136912	0	6844-5	3020655		
22468	2058	3000876	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	136912	0	6082-2	3000876		
22469	2058	3006734	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	136912	0	6189-5	3006734		
22470	2058	3001247	1993-07-07	1993-07-07 00:00:00	1993-07-07	5001	0	\N	0	0	\N	\N	0	136912	0	6085-5	3001247		
22471	2058	3006322	2016-03-19	2016-03-19 00:00:00	2016-03-19	5001	0	\N	0	0	\N	\N	0	136915	0	8331-1	3006322		
22472	2058	3006322	2001-06-26	2001-06-26 00:00:00	2001-06-26	5001	0	\N	0	0	\N	\N	0	136813	0	8331-1	3006322		
22475	2060	3006322	1980-11-21	1980-11-21 00:00:00	1980-11-21	5001	0	\N	0	0	\N	\N	0	137034	0	8331-1	3006322		
22476	2060	3006322	1996-09-07	1996-09-07 00:00:00	1996-09-07	5001	0	\N	0	0	\N	\N	0	137010	0	8331-1	3006322		
22477	2060	3006322	1992-05-01	1992-05-01 00:00:00	1992-05-01	5001	0	\N	0	0	\N	\N	0	137007	0	8331-1	3006322		
22478	2060	3006322	1985-03-14	1985-03-14 00:00:00	1985-03-14	5001	0	\N	0	0	\N	\N	0	137009	0	8331-1	3006322		
22479	2060	3006322	1964-11-02	1964-11-02 00:00:00	1964-11-02	5001	0	\N	0	0	\N	\N	0	137032	0	8331-1	3006322		
22480	2060	3006322	1993-09-10	1993-09-10 00:00:00	1993-09-10	5001	0	\N	0	0	\N	\N	0	137037	0	8331-1	3006322		
22481	2060	3006322	1988-01-12	1988-01-12 00:00:00	1988-01-12	5001	0	\N	0	0	\N	\N	0	137006	0	8331-1	3006322		
22483	2062	3006322	1948-07-09	1948-07-09 00:00:00	1948-07-09	5001	0	\N	0	0	\N	\N	0	137163	0	8331-1	3006322		
22484	2062	3006322	2008-12-21	2008-12-21 00:00:00	2008-12-21	5001	0	\N	0	0	\N	\N	0	137126	0	8331-1	3006322		
22485	2062	3006322	1965-01-12	1965-01-12 00:00:00	1965-01-12	5001	0	\N	0	0	\N	\N	0	137167	0	8331-1	3006322		
22486	2062	3049273	2006-02-16	2006-02-16 00:00:00	2006-02-16	5001	0	\N	0	0	\N	\N	0	137200	0	38265-5	3049273		
22487	2062	3006322	1984-08-15	1984-08-15 00:00:00	1984-08-15	5001	0	\N	0	0	\N	\N	0	137125	0	8331-1	3006322		
22488	2062	3006322	1953-09-26	1953-09-26 00:00:00	1953-09-26	5001	0	\N	0	0	\N	\N	0	137123	0	8331-1	3006322		
22489	2063	3006322	2017-07-27	2017-07-27 00:00:00	2017-07-27	5001	0	\N	0	0	\N	\N	0	137211	0	8331-1	3006322		
22490	2063	3006322	1987-01-11	1987-01-11 00:00:00	1987-01-11	5001	0	\N	0	0	\N	\N	0	137203	0	8331-1	3006322		
22491	2063	3006322	1987-12-21	1987-12-21 00:00:00	1987-12-21	5001	0	\N	0	0	\N	\N	0	137205	0	8331-1	3006322		
22492	2063	3006322	1985-01-09	1985-01-09 00:00:00	1985-01-09	5001	0	\N	0	0	\N	\N	0	137218	0	8331-1	3006322		
22493	2064	3051031	2014-04-28	2014-04-28 00:00:00	2014-04-28	5001	0	\N	0	0	\N	\N	0	137268	0	46240-8	3051031		
22496	2064	40766240	2014-04-28	2014-04-28 00:00:00	2014-04-28	5001	0	\N	0	0	\N	\N	0	137268	0	63513-6	40766240		
22497	2064	46235214	2014-04-28	2014-04-28 00:00:00	2014-04-28	5001	0	\N	0	0	\N	\N	0	137268	0	76690-7	46235214		
22498	2064	40758406	2014-04-28	2014-04-28 00:00:00	2014-04-28	5001	0	\N	0	0	\N	\N	0	137268	0	55277-8	40758406		
22499	2064	3006322	2000-09-02	2000-09-02 00:00:00	2000-09-02	5001	0	\N	0	0	\N	\N	0	137259	0	8331-1	3006322		
76794	2352	4024958	1997-06-25	1997-06-25 00:00:00	1997-06-25	5001	0	\N	0	0	\N	\N	0	156685	0	117015009	4024958		
143007	4391	4052083	1947-12-04	1947-12-04 00:00:00	1947-12-04	5001	0	\N	0	0	\N	\N	0	292016	0	23426006	4052083		
143014	4392	4052083	2004-12-08	2004-12-08 00:00:00	2004-12-08	5001	0	\N	0	0	\N	\N	0	292061	0	23426006	4052083		
154303	4731	4024958	1973-05-12	1973-05-12 00:00:00	1973-05-12	5001	0	\N	0	0	\N	\N	0	315178	0	117015009	4024958		
154306	4731	4024958	1979-04-25	1979-04-25 00:00:00	1979-04-25	5001	0	\N	0	0	\N	\N	0	315192	0	117015009	4024958		
154328	4732	4024958	1966-08-07	1966-08-07 00:00:00	1966-08-07	5001	0	\N	0	0	\N	\N	0	315296	0	117015009	4024958		
154346	4732	4052083	1995-02-28	1995-02-28 00:00:00	1995-02-28	5001	0	\N	0	0	\N	\N	0	315282	0	23426006	4052083		
154349	4732	4024958	1985-02-10	1985-02-10 00:00:00	1985-02-10	5001	0	\N	0	0	\N	\N	0	315245	0	117015009	4024958		
19713	615	4024958	1929-07-17	1929-07-17 00:00:00	1929-07-17	5001	0	\N	0	0	\N	\N	0	40994	0	117015009	4024958		
19730	615	4052083	1982-05-22	1982-05-22 00:00:00	1982-05-22	5001	0	\N	0	0	\N	\N	0	40913	0	23426006	4052083		
19756	615	4052083	1933-06-28	1933-06-28 00:00:00	1933-06-28	5001	0	\N	0	0	\N	\N	0	40995	0	23426006	4052083		
\.


--
-- TOC entry 3903 (class 0 OID 3185550)
-- Dependencies: 225
-- Data for Name: metadata; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".metadata (metadata_concept_id, metadata_type_concept_id, name, value_as_string, value_as_concept_id, metadata_date, metadata_datetime) FROM stdin;
\.


--
-- TOC entry 3904 (class 0 OID 3185556)
-- Dependencies: 226
-- Data for Name: note; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".note (note_id, person_id, note_date, note_datetime, note_type_concept_id, note_class_concept_id, note_title, note_text, encoding_concept_id, language_concept_id, provider_id, visit_occurrence_id, visit_detail_id, note_source_value) FROM stdin;
\.


--
-- TOC entry 3905 (class 0 OID 3185562)
-- Dependencies: 227
-- Data for Name: note_nlp; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".note_nlp (note_nlp_id, note_id, section_concept_id, snippet, "offset", lexical_variant, note_nlp_concept_id, note_nlp_source_concept_id, nlp_system, nlp_date, nlp_datetime, term_exists, term_temporal, term_modifiers) FROM stdin;
\.


--
-- TOC entry 3906 (class 0 OID 3185568)
-- Dependencies: 228
-- Data for Name: observation; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".observation (observation_id, person_id, observation_concept_id, observation_date, observation_datetime, observation_type_concept_id, value_as_number, value_as_string, value_as_concept_id, qualifier_concept_id, unit_concept_id, provider_id, visit_occurrence_id, visit_detail_id, observation_source_value, observation_source_concept_id, unit_source_value, qualifier_source_value) FROM stdin;
25197	1504	4323208	1960-06-07	1960-06-07 00:00:00	38000276	\N		0	0	0	0	100221	0	428251008	4323208		
2546	149	45766064	1948-08-17	1948-08-17 00:00:00	38000276	\N		0	0	0	0	10102	0	703151001	45766064		
78904	4674	4323208	1978-08-20	1978-08-20 00:00:00	38000276	\N		0	0	0	0	311415	0	428251008	4323208		
15287	905	45766064	1974-09-20	1974-09-20 00:00:00	38000276	\N		0	0	0	0	60191	0	703151001	45766064		
14067	830	4323208	1973-11-24	1973-11-24 00:00:00	38000276	\N		0	0	0	0	55003	0	428251008	4323208		
25464	1516	4323208	1956-01-01	1956-01-01 00:00:00	38000276	\N		0	0	0	0	101347	0	428251008	4323208		
59499	3528	45766064	1958-11-03	1958-11-03 00:00:00	38000276	\N		0	0	0	0	234247	0	703151001	45766064		
59540	3530	4324181	2003-01-03	2003-01-03 00:00:00	38000276	\N		0	0	0	0	234457	0	429007001	4324181		
2679	4498	433644	1978-03-01	1978-03-01 00:00:00	38000280	\N		0	0	0	0	299481	0	300913006	433644		
48765	2889	4323208	2017-03-07	2017-03-07 00:00:00	38000276	\N		0	0	0	0	192188	0	428251008	4323208		
48833	2893	4323208	1959-05-30	1959-05-30 00:00:00	38000276	\N		0	0	0	0	192513	0	428251008	4323208		
10493	616	4323208	1962-01-03	1962-01-03 00:00:00	38000276	\N		0	0	0	0	41147	0	428251008	4323208		
61245	3622	4324181	1953-04-22	1953-04-22 00:00:00	38000276	\N		0	0	0	0	240710	0	429007001	4324181		
61395	3628	4163874	2006-08-19	2006-08-19 00:00:00	38000276	\N		0	0	0	0	241357	0	399211009	4163874		
39069	2320	45766064	1941-08-02	1941-08-02 00:00:00	38000276	\N		0	0	0	0	154315	0	703151001	45766064		
83101	4935	4323208	1995-09-18	1995-09-18 00:00:00	38000276	\N		0	0	0	0	328153	0	428251008	4323208		
50542	2989	4323208	1987-06-16	1987-06-16 00:00:00	38000276	\N		0	0	0	0	199561	0	428251008	4323208		
1070	1727	4304110	1949-10-09	1949-10-09 00:00:00	38000280	\N		0	0	0	0	115519	0	419474003	4304110		
180	343	4306014	1971-03-10	1971-03-10 00:00:00	38000280	\N		0	0	0	0	22851	0	419263009	4306014		
276	545	4219399	1972-10-16	1972-10-16 00:00:00	38000280	\N		0	0	0	0	36039	0	417532002	4219399		
73433	4365	45766064	1982-07-15	1982-07-15 00:00:00	38000276	\N		0	0	0	0	289586	0	703151001	45766064		
4982	293	4323208	2005-10-04	2005-10-04 00:00:00	38000276	\N		0	0	0	0	19503	0	428251008	4323208		
84905	5049	4324181	1998-02-18	1998-02-18 00:00:00	38000276	\N		0	0	0	0	335586	0	429007001	4324181		
28618	1692	45766064	1982-08-15	1982-08-15 00:00:00	38000276	\N		0	0	0	0	113360	0	703151001	45766064		
1159	1801	37017711	1955-05-28	1955-05-28 00:00:00	38000280	\N		0	0	0	0	120718	0	714035009	37017711		
1253	1906	439406	1964-12-08	1964-12-08 00:00:00	38000280	\N		0	0	0	0	126868	0	232347008	439406		
2948	4998	439406	1965-06-02	1965-06-02 00:00:00	38000280	\N		0	0	0	0	332367	0	232347008	439406		
21364	1281	4324181	2012-07-21	2012-07-21 00:00:00	38000276	\N		0	0	0	0	84706	0	429007001	4324181		
3647	209	4324181	1976-12-31	1976-12-31 00:00:00	38000276	\N		0	0	0	0	14267	0	429007001	4324181		
1973	3123	4302207	1978-02-19	1978-02-19 00:00:00	38000280	\N		0	0	0	0	207805	0	418689008	4302207		
2053	3370	4240902	1973-07-05	1973-07-05 00:00:00	38000280	\N		0	0	0	0	223517	0	91935009	4240902		
2136	3583	4174876	1970-01-11	1970-01-11 00:00:00	38000280	\N		0	0	0	0	238243	0	424213003	4174876		
30546	1801	45766064	1966-07-18	1966-07-18 00:00:00	38000276	\N		0	0	0	0	120750	0	703151001	45766064		
20935	1257	4323208	1976-10-28	1976-10-28 00:00:00	38000276	\N		0	0	0	0	82830	0	428251008	4323208		
41945	2497	4324181	2008-02-28	2008-02-28 00:00:00	38000276	\N		0	0	0	0	165316	0	429007001	4324181		
15010	884	4324181	2005-05-24	2005-05-24 00:00:00	38000276	\N		0	0	0	0	58952	0	429007001	4324181		
42542	2537	45766064	1960-08-13	1960-08-13 00:00:00	38000276	\N		0	0	0	0	167646	0	703151001	45766064		
53646	3177	4324181	2003-01-08	2003-01-08 00:00:00	38000276	\N		0	0	0	0	211350	0	429007001	4324181		
53947	3194	4324181	1983-03-28	1983-03-28 00:00:00	38000276	\N		0	0	0	0	212460	0	429007001	4324181		
54037	3199	4323208	2006-01-25	2006-01-25 00:00:00	38000276	\N		0	0	0	0	212740	0	428251008	4323208		
20086	1211	4323208	1971-10-23	1971-10-23 00:00:00	38000276	\N		0	0	0	0	79555	0	428251008	4323208		
66760	3950	4323208	2008-09-23	2008-09-23 00:00:00	38000276	\N		0	0	0	0	262599	0	428251008	4323208		
72	3	4323208	1972-12-20	1972-12-20 00:00:00	38000276	\N		0	0	0	0	312	0	428251008	4323208		
78199	4631	4323208	1934-08-04	1934-08-04 00:00:00	38000276	\N		0	0	0	0	308630	0	428251008	4323208		
67870	4010	45766064	1977-05-05	1977-05-05 00:00:00	38000276	\N		0	0	0	0	266485	0	703151001	45766064		
66891	3956	4323208	1952-10-30	1952-10-30 00:00:00	38000276	\N		0	0	0	0	262942	0	428251008	4323208		
6430	377	4324181	1996-11-07	1996-11-07 00:00:00	38000276	\N		0	0	0	0	24997	0	429007001	4324181		
23956	1430	4323208	1965-11-18	1965-11-18 00:00:00	38000276	\N		0	0	0	0	95124	0	428251008	4323208		
60537	3579	4324181	2006-05-20	2006-05-20 00:00:00	38000276	\N		0	0	0	0	237964	0	429007001	4324181		
34494	2046	4163874	2014-04-01	2014-04-01 00:00:00	38000276	\N		0	0	0	0	136154	0	399211009	4163874		
64115	3787	4323208	1981-11-07	1981-11-07 00:00:00	38000276	\N		0	0	0	0	251767	0	428251008	4323208		
40685	2418	4323208	1995-09-01	1995-09-01 00:00:00	38000276	\N		0	0	0	0	160468	0	428251008	4323208		
10104	600	4324181	1997-02-19	1997-02-19 00:00:00	38000276	\N		0	0	0	0	39649	0	429007001	4324181		
52134	3087	4324181	2001-02-28	2001-02-28 00:00:00	38000276	\N		0	0	0	0	205557	0	429007001	4324181		
52236	3092	4324181	1995-09-20	1995-09-20 00:00:00	38000276	\N		0	0	0	0	205906	0	429007001	4324181		
63607	3756	4323208	2017-12-03	2017-12-03 00:00:00	38000276	\N		0	0	0	0	249610	0	428251008	4323208		
81106	4811	4323208	1995-04-10	1995-04-10 00:00:00	38000276	\N		0	0	0	0	320081	0	428251008	4323208		
80227	4755	4323208	1933-11-06	1933-11-06 00:00:00	38000276	\N		0	0	0	0	316779	0	428251008	4323208		
80282	4757	45766064	2001-03-17	2001-03-17 00:00:00	38000276	\N		0	0	0	0	316963	0	703151001	45766064		
84619	5031	45766064	1941-02-01	1941-02-01 00:00:00	38000276	\N		0	0	0	0	334343	0	703151001	45766064		
66448	3934	4324181	1957-03-06	1957-03-06 00:00:00	38000276	\N		0	0	0	0	261501	0	429007001	4324181		
26025	1543	4163874	1994-10-23	1994-10-23 00:00:00	38000276	\N		0	0	0	0	103423	0	399211009	4163874		
39743	2352	45766064	1970-10-26	1970-10-26 00:00:00	38000276	\N		0	0	0	0	156656	0	703151001	45766064		
77975	4621	45766064	1976-07-26	1976-07-26 00:00:00	38000276	\N		0	0	0	0	307740	0	703151001	45766064		
67450	3986	45766064	2009-08-13	2009-08-13 00:00:00	38000276	\N		0	0	0	0	265023	0	703151001	45766064		
78828	4668	4324181	2011-04-26	2011-04-26 00:00:00	38000276	\N		0	0	0	0	311088	0	429007001	4324181		
62653	3700	4323208	2011-08-22	2011-08-22 00:00:00	38000276	\N		0	0	0	0	245974	0	428251008	4323208		
33834	2007	4324181	1994-07-17	1994-07-17 00:00:00	38000276	\N		0	0	0	0	133660	0	429007001	4324181		
1254	1923	4306014	1933-08-26	1933-08-26 00:00:00	38000280	\N		0	0	0	0	127850	0	419263009	4306014		
1346	2131	4240902	1952-06-02	1952-06-02 00:00:00	38000280	\N		0	0	0	0	141760	0	91935009	4240902		
25499	1517	45766064	1949-10-29	1949-10-29 00:00:00	38000276	\N		0	0	0	0	101446	0	703151001	45766064		
2592	4366	4048169	1982-04-19	1982-04-19 00:00:00	38000280	\N		0	0	0	0	289663	0	232350006	4048169		
2680	4500	4102123	1962-08-27	1962-08-27 00:00:00	38000280	\N		0	0	0	0	299644	0	300916003	4102123		
38469	2286	4323208	1971-08-31	1971-08-31 00:00:00	38000276	\N		0	0	0	0	152036	0	428251008	4323208		
49720	2942	4323208	2005-07-17	2005-07-17 00:00:00	38000276	\N		0	0	0	0	196179	0	428251008	4323208		
34166	2028	45766064	1977-11-27	1977-11-27 00:00:00	38000276	\N		0	0	0	0	134950	0	703151001	45766064		
61283	3623	4323208	2009-06-05	2009-06-05 00:00:00	38000276	\N		0	0	0	0	240878	0	428251008	4323208		
56926	3378	4324181	2014-05-10	2014-05-10 00:00:00	38000276	\N		0	0	0	0	224131	0	429007001	4324181		
71301	4227	4324181	2003-04-06	2003-04-06 00:00:00	38000276	\N		0	0	0	0	280798	0	429007001	4324181		
4128	239	4163874	2012-07-05	2012-07-05 00:00:00	38000276	\N		0	0	0	0	16054	0	399211009	4163874		
984	1556	4302207	1973-10-05	1973-10-05 00:00:00	38000280	\N		0	0	0	0	104192	0	418689008	4302207		
1071	1727	433644	1949-10-09	1949-10-09 00:00:00	38000280	\N		0	0	0	0	115519	0	300913006	433644		
181	343	4304110	1971-03-10	1971-03-10 00:00:00	38000280	\N		0	0	0	0	22851	0	419474003	4304110		
292	563	4304110	1985-05-03	1985-05-03 00:00:00	38000280	\N		0	0	0	0	37276	0	419474003	4304110		
596	1036	4302207	1974-09-30	1974-09-30 00:00:00	38000280	\N		0	0	0	0	68160	0	418689008	4302207		
632	1083	4048169	1966-11-08	1966-11-08 00:00:00	38000280	\N		0	0	0	0	71170	0	232350006	4048169		
704	1176	4048169	1963-10-28	1963-10-28 00:00:00	38000280	\N		0	0	0	0	77625	0	232350006	4048169		
24167	1441	4324181	1985-11-11	1985-11-11 00:00:00	38000276	\N		0	0	0	0	95949	0	429007001	4324181		
1194	1837	442116	1961-08-21	1961-08-21 00:00:00	38000280	\N		0	0	0	0	122733	0	91930004	442116		
50090	2959	4324181	1997-10-07	1997-10-07 00:00:00	38000276	\N		0	0	0	0	197605	0	429007001	4324181		
2949	4998	4304110	1965-06-02	1965-06-02 00:00:00	38000280	\N		0	0	0	0	332367	0	419474003	4304110		
36765	2175	4323208	1979-01-29	1979-01-29 00:00:00	38000276	\N		0	0	0	0	144977	0	428251008	4323208		
72923	4333	4323208	1980-08-22	1980-08-22 00:00:00	38000276	\N		0	0	0	0	287399	0	428251008	4323208		
1974	3123	4048169	1978-02-19	1978-02-19 00:00:00	38000280	\N		0	0	0	0	207805	0	232350006	4048169		
2054	3370	4174876	1973-07-05	1973-07-05 00:00:00	38000280	\N		0	0	0	0	223517	0	424213003	4174876		
2137	3583	438614	1970-01-11	1970-01-11 00:00:00	38000280	\N		0	0	0	0	238243	0	91934008	438614		
34570	2052	4324181	2015-10-19	2015-10-19 00:00:00	38000276	\N		0	0	0	0	136411	0	429007001	4324181		
55694	3296	4323208	1938-09-26	1938-09-26 00:00:00	38000276	\N		0	0	0	0	219076	0	428251008	4323208		
30779	1820	4323208	2015-01-31	2015-01-31 00:00:00	38000276	\N		0	0	0	0	121708	0	428251008	4323208		
43369	2583	4323208	2001-06-08	2001-06-08 00:00:00	38000276	\N		0	0	0	0	171074	0	428251008	4323208		
20005	1206	4323208	1972-02-10	1972-02-10 00:00:00	38000276	\N		0	0	0	0	79284	0	428251008	4323208		
43809	2609	4324181	2018-12-14	2018-12-14 00:00:00	38000276	\N		0	0	0	0	172469	0	429007001	4324181		
53959	3195	45766064	1953-11-21	1953-11-21 00:00:00	38000276	\N		0	0	0	0	212563	0	703151001	45766064		
31471	1860	4324181	1991-12-23	1991-12-23 00:00:00	38000276	\N		0	0	0	0	124407	0	429007001	4324181		
66353	3928	4323208	1995-12-06	1995-12-06 00:00:00	38000276	\N		0	0	0	0	261147	0	428251008	4323208		
52605	3115	4324181	1991-01-04	1991-01-04 00:00:00	38000276	\N		0	0	0	0	207279	0	429007001	4324181		
1612	2503	4240902	1973-10-31	1973-10-31 00:00:00	38000280	\N		0	0	0	0	165730	0	91935009	4240902		
55452	3285	4324181	2011-03-12	2011-03-12 00:00:00	38000276	\N		0	0	0	0	218180	0	429007001	4324181		
1778	2711	4306014	1951-01-10	1951-01-10 00:00:00	38000280	\N		0	0	0	0	179635	0	419263009	4306014		
12527	741	4324181	2000-05-26	2000-05-26 00:00:00	38000276	\N		0	0	0	0	49043	0	429007001	4324181		
15873	939	4323208	2003-07-07	2003-07-07 00:00:00	38000276	\N		0	0	0	0	62467	0	428251008	4323208		
35277	2090	4324181	1974-03-20	1974-03-20 00:00:00	38000276	\N		0	0	0	0	139372	0	429007001	4324181		
54555	3231	4323208	1983-10-09	1983-10-09 00:00:00	38000276	\N		0	0	0	0	214795	0	428251008	4323208		
46726	2780	4323208	1957-01-18	1957-01-18 00:00:00	38000276	\N		0	0	0	0	184230	0	428251008	4323208		
64121	3787	4163874	2016-08-27	2016-08-27 00:00:00	38000276	\N		0	0	0	0	251789	0	399211009	4163874		
45860	2731	4324181	2007-07-09	2007-07-09 00:00:00	38000276	\N		0	0	0	0	180794	0	429007001	4324181		
52092	3084	4324181	2015-10-21	2015-10-21 00:00:00	38000276	\N		0	0	0	0	205356	0	429007001	4324181		
75649	4487	4163874	2010-02-12	2010-02-12 00:00:00	38000276	\N		0	0	0	0	298687	0	399211009	4163874		
75698	4490	4163874	1988-04-23	1988-04-23 00:00:00	38000276	\N		0	0	0	0	298886	0	399211009	4163874		
87078	5185	4324181	1961-11-13	1961-11-13 00:00:00	38000276	\N		0	0	0	0	344602	0	429007001	4324181		
888	1431	433644	1950-06-11	1950-06-11 00:00:00	38000280	\N		0	0	0	0	95295	0	300913006	433644		
81215	4816	4323208	1982-11-11	1982-11-11 00:00:00	38000276	\N		0	0	0	0	320435	0	428251008	4323208		
80326	4758	4324181	1989-08-13	1989-08-13 00:00:00	38000276	\N		0	0	0	0	316967	0	429007001	4324181		
84646	5034	4163874	1993-11-13	1993-11-13 00:00:00	38000276	\N		0	0	0	0	334462	0	399211009	4163874		
6573	388	45766064	2017-08-29	2017-08-29 00:00:00	38000276	\N		0	0	0	0	25587	0	703151001	45766064		
55880	3308	4163874	1996-11-18	1996-11-18 00:00:00	38000276	\N		0	0	0	0	219656	0	399211009	4163874		
55634	3294	4323208	1977-10-13	1977-10-13 00:00:00	38000276	\N		0	0	0	0	218835	0	428251008	4323208		
36082	2138	4323208	1976-10-06	1976-10-06 00:00:00	38000276	\N		0	0	0	0	142417	0	428251008	4323208		
11006	649	4324181	2011-01-25	2011-01-25 00:00:00	38000276	\N		0	0	0	0	42970	0	429007001	4324181		
3885	224	45766064	1954-10-10	1954-10-10 00:00:00	38000276	\N		0	0	0	0	15088	0	703151001	45766064		
14346	847	4324181	1970-07-24	1970-07-24 00:00:00	38000276	\N		0	0	0	0	56137	0	429007001	4324181		
1255	1923	4240902	1933-08-26	1933-08-26 00:00:00	38000280	\N		0	0	0	0	127850	0	91935009	4240902		
1347	2133	433644	1966-01-16	1966-01-16 00:00:00	38000280	\N		0	0	0	0	141906	0	300913006	433644		
1424	2238	439406	1969-09-13	1969-09-13 00:00:00	38000280	\N		0	0	0	0	148973	0	232347008	439406		
2593	4366	4302207	1982-04-19	1982-04-19 00:00:00	38000280	\N		0	0	0	0	289663	0	418689008	4302207		
2681	4500	4306014	1962-08-27	1962-08-27 00:00:00	38000280	\N		0	0	0	0	299644	0	419263009	4306014		
7257	426	4323208	2007-01-04	2007-01-04 00:00:00	38000276	\N		0	0	0	0	28295	0	428251008	4323208		
61041	3613	4323208	1989-01-23	1989-01-23 00:00:00	38000276	\N		0	0	0	0	240060	0	428251008	4323208		
45481	2703	45766064	1974-03-03	1974-03-03 00:00:00	38000276	\N		0	0	0	0	179053	0	703151001	45766064		
30076	1779	4324181	1949-09-15	1949-09-15 00:00:00	38000276	\N		0	0	0	0	119064	0	429007001	4324181		
27717	1635	4324181	2013-03-27	2013-03-27 00:00:00	38000276	\N		0	0	0	0	109831	0	429007001	4324181		
40414	2396	4163874	2001-02-21	2001-02-21 00:00:00	38000276	\N		0	0	0	0	159325	0	399211009	4163874		
39165	2326	45766064	2011-01-24	2011-01-24 00:00:00	38000276	\N		0	0	0	0	154723	0	703151001	45766064		
985	1556	4048169	1973-10-05	1973-10-05 00:00:00	38000280	\N		0	0	0	0	104192	0	232350006	4048169		
53040	3141	4323208	1978-02-06	1978-02-06 00:00:00	38000276	\N		0	0	0	0	208992	0	428251008	4323208		
182	343	4302207	1971-03-10	1971-03-10 00:00:00	38000280	\N		0	0	0	0	22851	0	418689008	4302207		
293	576	433644	1967-12-07	1967-12-07 00:00:00	38000280	\N		0	0	0	0	38090	0	300913006	433644		
597	1036	4048169	1974-09-30	1974-09-30 00:00:00	38000280	\N		0	0	0	0	68160	0	232350006	4048169		
633	1083	4139681	1966-11-08	1966-11-08 00:00:00	38000280	\N		0	0	0	0	71170	0	425525006	4139681		
705	1176	442116	1963-10-28	1963-10-28 00:00:00	38000280	\N		0	0	0	0	77625	0	91930004	442116		
1083	1743	4304110	1966-03-14	1966-03-14 00:00:00	38000280	\N		0	0	0	0	116513	0	419474003	4304110		
1195	1837	4304110	1961-08-21	1961-08-21 00:00:00	38000280	\N		0	0	0	0	122733	0	419474003	4304110		
54636	3234	4163874	2010-01-18	2010-01-18 00:00:00	38000276	\N		0	0	0	0	214997	0	399211009	4163874		
2950	4998	4306014	1965-06-02	1965-06-02 00:00:00	38000280	\N		0	0	0	0	332367	0	419263009	4306014		
3031	5118	433644	1968-10-25	1968-10-25 00:00:00	38000280	\N		0	0	0	0	340216	0	300913006	433644		
9005	526	4323208	2008-02-16	2008-02-16 00:00:00	38000276	\N		0	0	0	0	35103	0	428251008	4323208		
1975	3123	433644	1978-02-19	1978-02-19 00:00:00	38000280	\N		0	0	0	0	207805	0	300913006	433644		
2055	3371	4048169	1976-03-23	1976-03-23 00:00:00	38000280	\N		0	0	0	0	223598	0	232350006	4048169		
2138	3583	4306014	1970-01-11	1970-01-11 00:00:00	38000280	\N		0	0	0	0	238243	0	419263009	4306014		
40136	2381	4324181	2013-01-30	2013-01-30 00:00:00	38000276	\N		0	0	0	0	158245	0	429007001	4324181		
50302	2975	4323208	1975-04-06	1975-04-06 00:00:00	38000276	\N		0	0	0	0	198629	0	428251008	4323208		
43321	2579	4323208	2008-04-07	2008-04-07 00:00:00	38000276	\N		0	0	0	0	170789	0	428251008	4323208		
43680	2602	4324181	1964-11-04	1964-11-04 00:00:00	38000276	\N		0	0	0	0	172145	0	429007001	4324181		
15030	885	4323208	2012-04-05	2012-04-05 00:00:00	38000276	\N		0	0	0	0	58983	0	428251008	4323208		
43814	2609	4323208	1967-05-02	1967-05-02 00:00:00	38000276	\N		0	0	0	0	172461	0	428251008	4323208		
31461	1860	4163874	1985-11-11	1985-11-11 00:00:00	38000276	\N		0	0	0	0	124404	0	399211009	4163874		
37880	2244	4323208	1964-07-23	1964-07-23 00:00:00	38000276	\N		0	0	0	0	149423	0	428251008	4323208		
66393	3930	4163874	1979-12-29	1979-12-29 00:00:00	38000276	\N		0	0	0	0	261309	0	399211009	4163874		
911	49	4324181	2003-07-12	2003-07-12 00:00:00	38000276	\N		0	0	0	0	3529	0	429007001	4324181		
1613	2503	4306014	1973-10-31	1973-10-31 00:00:00	38000280	\N		0	0	0	0	165730	0	419263009	4306014		
55479	3287	4324181	1967-07-10	1967-07-10 00:00:00	38000276	\N		0	0	0	0	218352	0	429007001	4324181		
1779	2711	4102123	1951-01-10	1951-01-10 00:00:00	38000280	\N		0	0	0	0	179635	0	300916003	4102123		
79526	4712	4323208	1972-01-20	1972-01-20 00:00:00	38000276	\N		0	0	0	0	313780	0	428251008	4323208		
15891	940	4324181	1993-03-04	1993-03-04 00:00:00	38000276	\N		0	0	0	0	62564	0	429007001	4324181		
60519	3578	4323208	1979-08-03	1979-08-03 00:00:00	38000276	\N		0	0	0	0	237906	0	428251008	4323208		
83681	4972	4323208	1991-01-04	1991-01-04 00:00:00	38000276	\N		0	0	0	0	330663	0	428251008	4323208		
9141	539	4163874	1999-07-25	1999-07-25 00:00:00	38000276	\N		0	0	0	0	35858	0	399211009	4163874		
38765	2300	45766064	1950-01-26	1950-01-26 00:00:00	38000276	\N		0	0	0	0	153124	0	703151001	45766064		
72063	4276	4323208	2006-12-14	2006-12-14 00:00:00	38000276	\N		0	0	0	0	283770	0	428251008	4323208		
58217	3446	45766064	1957-12-09	1957-12-09 00:00:00	38000276	\N		0	0	0	0	228777	0	703151001	45766064		
58314	3455	45766064	1991-05-21	1991-05-21 00:00:00	38000276	\N		0	0	0	0	229257	0	703151001	45766064		
719	1206	4302207	1988-02-28	1988-02-28 00:00:00	38000280	\N		0	0	0	0	79246	0	418689008	4302207		
68812	4072	4323208	2004-08-31	2004-08-31 00:00:00	38000276	\N		0	0	0	0	270692	0	428251008	4323208		
889	1446	433644	1984-09-08	1984-09-08 00:00:00	38000280	\N		0	0	0	0	96389	0	300913006	433644		
73152	4347	4323208	1993-04-05	1993-04-05 00:00:00	38000276	\N		0	0	0	0	288294	0	428251008	4323208		
80336	4759	45766064	2008-11-08	2008-11-08 00:00:00	38000276	\N		0	0	0	0	317067	0	703151001	45766064		
86461	5145	4324181	2018-01-13	2018-01-13 00:00:00	38000276	\N		0	0	0	0	342080	0	429007001	4324181		
16994	1015	4323208	1984-10-19	1984-10-19 00:00:00	38000276	\N		0	0	0	0	66860	0	428251008	4323208		
13665	807	4323208	1971-01-13	1971-01-13 00:00:00	38000276	\N		0	0	0	0	53555	0	428251008	4323208		
35981	2134	4323208	1997-09-01	1997-09-01 00:00:00	38000276	\N		0	0	0	0	142027	0	428251008	4323208		
87637	5215	4324181	1960-07-11	1960-07-11 00:00:00	38000276	\N		0	0	0	0	346837	0	429007001	4324181		
11035	651	4324181	1999-01-28	1999-01-28 00:00:00	38000276	\N		0	0	0	0	43079	0	429007001	4324181		
3996	232	4323208	1963-10-30	1963-10-30 00:00:00	38000276	\N		0	0	0	0	15612	0	428251008	4323208		
4057	235	45766064	1992-05-08	1992-05-08 00:00:00	38000276	\N		0	0	0	0	15757	0	703151001	45766064		
1262	1956	442116	1964-07-06	1964-07-06 00:00:00	38000280	\N		0	0	0	0	130174	0	91930004	442116		
1348	2149	433644	1959-10-30	1959-10-30 00:00:00	38000280	\N		0	0	0	0	143121	0	300913006	433644		
1425	2238	4219399	1969-09-13	1969-09-13 00:00:00	38000280	\N		0	0	0	0	148973	0	417532002	4219399		
2594	4366	4306014	1982-04-19	1982-04-19 00:00:00	38000280	\N		0	0	0	0	289663	0	419263009	4306014		
2682	4500	4304110	1962-08-27	1962-08-27 00:00:00	38000280	\N		0	0	0	0	299644	0	419474003	4304110		
56882	3375	4323208	1967-03-04	1967-03-04 00:00:00	38000276	\N		0	0	0	0	223887	0	428251008	4323208		
17518	1053	45766064	1982-01-28	1982-01-28 00:00:00	38000276	\N		0	0	0	0	69038	0	703151001	45766064		
27646	1632	4324181	1988-11-13	1988-11-13 00:00:00	38000276	\N		0	0	0	0	109551	0	429007001	4324181		
40504	2406	4324181	1961-05-11	1961-05-11 00:00:00	38000276	\N		0	0	0	0	159828	0	429007001	4324181		
50480	2986	4324181	1946-03-12	1946-03-12 00:00:00	38000276	\N		0	0	0	0	199353	0	429007001	4324181		
986	1556	4169137	1973-10-05	1973-10-05 00:00:00	38000280	\N		0	0	0	0	104192	0	420174000	4169137		
52040	3082	4324181	1988-05-04	1988-05-04 00:00:00	38000276	\N		0	0	0	0	205228	0	429007001	4324181		
183	343	4048169	1971-03-10	1971-03-10 00:00:00	38000280	\N		0	0	0	0	22851	0	232350006	4048169		
294	576	4306014	1967-12-07	1967-12-07 00:00:00	38000280	\N		0	0	0	0	38090	0	419263009	4306014		
598	1036	4174876	1974-09-30	1974-09-30 00:00:00	38000280	\N		0	0	0	0	68160	0	424213003	4174876		
634	1083	439406	1966-11-08	1966-11-08 00:00:00	38000280	\N		0	0	0	0	71170	0	232347008	439406		
706	1176	439406	1963-10-28	1963-10-28 00:00:00	38000280	\N		0	0	0	0	77625	0	232347008	439406		
1084	1743	4240902	1966-03-14	1966-03-14 00:00:00	38000280	\N		0	0	0	0	116513	0	91935009	4240902		
1196	1843	433644	1982-09-26	1982-09-26 00:00:00	38000280	\N		0	0	0	0	123101	0	300913006	433644		
2869	4924	4306014	1978-06-24	1978-06-24 00:00:00	38000280	\N		0	0	0	0	327278	0	419263009	4306014		
3009	5051	433644	1978-10-04	1978-10-04 00:00:00	38000280	\N		0	0	0	0	335893	0	300913006	433644		
7588	445	45766064	1925-09-18	1925-09-18 00:00:00	38000276	\N		0	0	0	0	29635	0	703151001	45766064		
7661	449	4323208	1968-10-27	1968-10-27 00:00:00	38000276	\N		0	0	0	0	29952	0	428251008	4323208		
1976	3123	4304110	1978-02-19	1978-02-19 00:00:00	38000280	\N		0	0	0	0	207805	0	419474003	4304110		
2056	3371	4302207	1976-03-23	1976-03-23 00:00:00	38000280	\N		0	0	0	0	223598	0	418689008	4302207		
2139	3583	4102123	1970-01-11	1970-01-11 00:00:00	38000280	\N		0	0	0	0	238243	0	300916003	4102123		
23630	1410	4324181	2010-03-25	2010-03-25 00:00:00	38000276	\N		0	0	0	0	93838	0	429007001	4324181		
50327	2976	45766064	1955-06-23	1955-06-23 00:00:00	38000276	\N		0	0	0	0	198734	0	703151001	45766064		
43333	2580	4324181	1979-05-07	1979-05-07 00:00:00	38000276	\N		0	0	0	0	170920	0	429007001	4324181		
50449	2985	4324181	1967-06-17	1967-06-17 00:00:00	38000276	\N		0	0	0	0	199186	0	429007001	4324181		
85164	5065	4163874	2005-03-15	2005-03-15 00:00:00	38000276	\N		0	0	0	0	336708	0	399211009	4163874		
61918	3655	4163874	2010-12-16	2010-12-16 00:00:00	38000276	\N		0	0	0	0	243260	0	399211009	4163874		
8607	502	4324181	2016-03-05	2016-03-05 00:00:00	38000276	\N		0	0	0	0	33579	0	429007001	4324181		
60883	3603	4323208	1967-02-08	1967-02-08 00:00:00	38000276	\N		0	0	0	0	239405	0	428251008	4323208		
85929	5113	4323208	2017-03-05	2017-03-05 00:00:00	38000276	\N		0	0	0	0	339717	0	428251008	4323208		
18307	1101	4324181	1982-08-22	1982-08-22 00:00:00	38000276	\N		0	0	0	0	72326	0	429007001	4324181		
1614	2503	439406	1973-10-31	1973-10-31 00:00:00	38000280	\N		0	0	0	0	165730	0	232347008	439406		
138	6	45766064	2003-12-21	2003-12-21 00:00:00	38000276	\N		0	0	0	0	559	0	703151001	45766064		
1780	2715	4169137	1966-11-20	1966-11-20 00:00:00	38000280	\N		0	0	0	0	180065	0	420174000	4169137		
41190	2448	4323208	2003-07-07	2003-07-07 00:00:00	38000276	\N		0	0	0	0	162353	0	428251008	4323208		
2770	4719	438614	1936-03-09	1936-03-09 00:00:00	38000280	\N		0	0	0	0	314249	0	91934008	438614		
15910	940	4163874	2001-11-29	2001-11-29 00:00:00	38000276	\N		0	0	0	0	62565	0	399211009	4163874		
27328	1611	4323208	1989-05-31	1989-05-31 00:00:00	38000276	\N		0	0	0	0	108288	0	428251008	4323208		
9145	539	4324181	1972-01-02	1972-01-02 00:00:00	38000276	\N		0	0	0	0	35857	0	429007001	4324181		
66002	3901	45766064	1936-03-18	1936-03-18 00:00:00	38000276	\N		0	0	0	0	259382	0	703151001	45766064		
70617	4190	4323208	1977-07-31	1977-07-31 00:00:00	38000276	\N		0	0	0	0	278066	0	428251008	4323208		
58230	3446	4323208	1953-12-12	1953-12-12 00:00:00	38000276	\N		0	0	0	0	228775	0	428251008	4323208		
58337	3456	4324181	1991-12-12	1991-12-12 00:00:00	38000276	\N		0	0	0	0	229296	0	429007001	4324181		
720	1211	4302207	1967-11-16	1967-11-16 00:00:00	38000280	\N		0	0	0	0	79593	0	418689008	4302207		
69723	4125	4324181	1988-10-25	1988-10-25 00:00:00	38000276	\N		0	0	0	0	274214	0	429007001	4324181		
890	1447	4139681	1958-09-06	1958-09-06 00:00:00	38000280	\N		0	0	0	0	96455	0	425525006	4139681		
1791	2732	4306014	1970-12-12	1970-12-12 00:00:00	38000280	\N		0	0	0	0	180890	0	419263009	4306014		
14501	857	4324181	1983-09-18	1983-09-18 00:00:00	38000276	\N		0	0	0	0	56579	0	429007001	4324181		
1966	3086	433644	1969-08-04	1969-08-04 00:00:00	38000280	\N		0	0	0	0	205434	0	300913006	433644		
16997	1015	4324181	1973-07-23	1973-07-23 00:00:00	38000276	\N		0	0	0	0	66813	0	429007001	4324181		
88581	5265	4324181	2008-06-05	2008-06-05 00:00:00	38000276	\N		0	0	0	0	350271	0	429007001	4324181		
65286	3860	4323208	1978-07-08	1978-07-08 00:00:00	38000276	\N		0	0	0	0	256340	0	428251008	4323208		
76661	4544	4163874	1994-02-01	1994-02-01 00:00:00	38000276	\N		0	0	0	0	302672	0	399211009	4163874		
89368	5315	4163874	1979-04-15	1979-04-15 00:00:00	38000276	\N		0	0	0	0	353459	0	399211009	4163874		
78475	4646	4323208	1964-07-29	1964-07-29 00:00:00	38000276	\N		0	0	0	0	309885	0	428251008	4323208		
1265	1967	4302207	1956-11-18	1956-11-18 00:00:00	38000280	\N		0	0	0	0	130849	0	418689008	4302207		
1349	2149	4306014	1959-10-30	1959-10-30 00:00:00	38000280	\N		0	0	0	0	143121	0	419263009	4306014		
5975	351	4323208	2016-11-21	2016-11-21 00:00:00	38000276	\N		0	0	0	0	23368	0	428251008	4323208		
2595	4366	4304110	1982-04-19	1982-04-19 00:00:00	38000280	\N		0	0	0	0	289663	0	419474003	4304110		
2683	4500	4240902	1962-08-27	1962-08-27 00:00:00	38000280	\N		0	0	0	0	299644	0	91935009	4240902		
68203	4027	4324181	2014-06-21	2014-06-21 00:00:00	38000276	\N		0	0	0	0	267885	0	429007001	4324181		
86637	5153	4323208	1963-12-25	1963-12-25 00:00:00	38000276	\N		0	0	0	0	342654	0	428251008	4323208		
27649	1632	45766064	1962-07-20	1962-07-20 00:00:00	38000276	\N		0	0	0	0	109549	0	703151001	45766064		
918	1476	4304110	1945-05-25	1945-05-25 00:00:00	38000280	\N		0	0	0	0	98529	0	419474003	4304110		
987	1556	439406	1973-10-05	1973-10-05 00:00:00	38000280	\N		0	0	0	0	104192	0	232347008	439406		
84282	5007	45766064	1995-03-24	1995-03-24 00:00:00	38000276	\N		0	0	0	0	332996	0	703151001	45766064		
184	357	442116	1955-09-26	1955-09-26 00:00:00	38000280	\N		0	0	0	0	23738	0	91930004	442116		
295	576	438614	1967-12-07	1967-12-07 00:00:00	38000280	\N		0	0	0	0	38090	0	91934008	438614		
599	1036	439406	1974-09-30	1974-09-30 00:00:00	38000280	\N		0	0	0	0	68160	0	232347008	439406		
635	1083	4169137	1966-11-08	1966-11-08 00:00:00	38000280	\N		0	0	0	0	71170	0	420174000	4169137		
707	1176	4304110	1963-10-28	1963-10-28 00:00:00	38000280	\N		0	0	0	0	77625	0	419474003	4304110		
1092	1753	433644	1965-10-09	1965-10-09 00:00:00	38000280	\N		0	0	0	0	117170	0	300913006	433644		
1197	1845	4302207	1962-07-29	1962-07-29 00:00:00	38000280	\N		0	0	0	0	123271	0	418689008	4302207		
2870	4924	4304110	1978-06-24	1978-06-24 00:00:00	38000280	\N		0	0	0	0	327278	0	419474003	4304110		
3021	5076	4302207	1940-04-05	1940-04-05 00:00:00	38000280	\N		0	0	0	0	337415	0	418689008	4302207		
3127	5290	439406	1955-02-12	1955-02-12 00:00:00	38000280	\N		0	0	0	0	351966	0	232347008	439406		
7799	455	4323208	1977-01-25	1977-01-25 00:00:00	38000276	\N		0	0	0	0	30394	0	428251008	4323208		
1977	3123	4102123	1978-02-19	1978-02-19 00:00:00	38000280	\N		0	0	0	0	207805	0	300916003	4102123		
2057	3371	439406	1976-03-23	1976-03-23 00:00:00	38000280	\N		0	0	0	0	223598	0	232347008	439406		
2140	3583	4304110	1970-01-11	1970-01-11 00:00:00	38000280	\N		0	0	0	0	238243	0	419474003	4304110		
89068	5299	45766064	1998-06-06	1998-06-06 00:00:00	38000276	\N		0	0	0	0	352525	0	703151001	45766064		
73606	4375	4323208	1946-07-06	1946-07-06 00:00:00	38000276	\N		0	0	0	0	290600	0	428251008	4323208		
55719	3296	45766064	1966-09-18	1966-09-18 00:00:00	38000276	\N		0	0	0	0	219093	0	703151001	45766064		
36354	2152	4323208	1962-02-03	1962-02-03 00:00:00	38000276	\N		0	0	0	0	143420	0	428251008	4323208		
27930	1649	4163874	2017-08-23	2017-08-23 00:00:00	38000276	\N		0	0	0	0	110618	0	399211009	4163874		
28038	1657	4324181	1998-04-22	1998-04-22 00:00:00	38000276	\N		0	0	0	0	111186	0	429007001	4324181		
78610	4655	45766064	1982-12-08	1982-12-08 00:00:00	38000276	\N		0	0	0	0	310302	0	703151001	45766064		
43888	2613	4323208	2003-05-03	2003-05-03 00:00:00	38000276	\N		0	0	0	0	172819	0	428251008	4323208		
45238	2690	4163874	2001-08-02	2001-08-02 00:00:00	38000276	\N		0	0	0	0	178255	0	399211009	4163874		
18311	1101	4323208	1985-08-17	1985-08-17 00:00:00	38000276	\N		0	0	0	0	72299	0	428251008	4323208		
1615	2503	4174876	1973-10-31	1973-10-31 00:00:00	38000280	\N		0	0	0	0	165730	0	424213003	4174876		
1715	2649	4048169	1958-09-12	1958-09-12 00:00:00	38000280	\N		0	0	0	0	175296	0	232350006	4048169		
1789	2732	4048169	1970-12-12	1970-12-12 00:00:00	38000280	\N		0	0	0	0	180890	0	232350006	4048169		
49049	2903	4323208	1975-09-13	1975-09-13 00:00:00	38000276	\N		0	0	0	0	193482	0	428251008	4323208		
2771	4724	433644	1942-02-13	1942-02-13 00:00:00	38000280	\N		0	0	0	0	314731	0	300913006	433644		
2852	4878	4306014	1963-08-21	1963-08-21 00:00:00	38000280	\N		0	0	0	0	324328	0	419263009	4306014		
85297	5073	4323208	1947-04-11	1947-04-11 00:00:00	38000276	\N		0	0	0	0	337258	0	428251008	4323208		
9157	539	45766064	1933-03-26	1933-03-26 00:00:00	38000276	\N		0	0	0	0	35823	0	703151001	45766064		
18896	1136	4324181	1972-10-07	1972-10-07 00:00:00	38000276	\N		0	0	0	0	74864	0	429007001	4324181		
70648	4191	4324181	2013-07-26	2013-07-26 00:00:00	38000276	\N		0	0	0	0	278185	0	429007001	4324181		
20698	1245	4323208	1985-08-27	1985-08-27 00:00:00	38000276	\N		0	0	0	0	81898	0	428251008	4323208		
32053	1903	45766064	1975-06-16	1975-06-16 00:00:00	38000276	\N		0	0	0	0	126664	0	703151001	45766064		
721	1211	4048169	1967-11-16	1967-11-16 00:00:00	38000280	\N		0	0	0	0	79593	0	232350006	4048169		
83054	4933	45766064	1978-03-03	1978-03-03 00:00:00	38000276	\N		0	0	0	0	327966	0	703151001	45766064		
3114	183	4323208	1986-10-22	1986-10-22 00:00:00	38000276	\N		0	0	0	0	12413	0	428251008	4323208		
1792	2732	4304110	1970-12-12	1970-12-12 00:00:00	38000280	\N		0	0	0	0	180890	0	419474003	4304110		
1885	2942	4174876	1954-12-06	1954-12-06 00:00:00	38000280	\N		0	0	0	0	196168	0	424213003	4174876		
1967	3119	433644	1974-12-27	1974-12-27 00:00:00	38000280	\N		0	0	0	0	207583	0	300913006	433644		
76147	4520	4163874	1996-09-28	1996-09-28 00:00:00	38000276	\N		0	0	0	0	300940	0	399211009	4163874		
89393	5316	4324181	1984-01-02	1984-01-02 00:00:00	38000276	\N		0	0	0	0	353608	0	429007001	4324181		
1266	1967	442116	1956-11-18	1956-11-18 00:00:00	38000280	\N		0	0	0	0	130849	0	91930004	442116		
1350	2149	4304110	1959-10-30	1959-10-30 00:00:00	38000280	\N		0	0	0	0	143121	0	419474003	4304110		
1516	2369	4139681	1982-01-16	1982-01-16 00:00:00	38000280	\N		0	0	0	0	157671	0	425525006	4139681		
2596	4366	4102123	1982-04-19	1982-04-19 00:00:00	38000280	\N		0	0	0	0	289663	0	300916003	4102123		
2684	4500	439406	1962-08-27	1962-08-27 00:00:00	38000280	\N		0	0	0	0	299644	0	232347008	439406		
37030	2192	4324181	2001-12-06	2001-12-06 00:00:00	38000276	\N		0	0	0	0	146244	0	429007001	4324181		
86690	5157	4323208	1985-04-06	1985-04-06 00:00:00	38000276	\N		0	0	0	0	342949	0	428251008	4323208		
919	1476	37017711	1945-05-25	1945-05-25 00:00:00	38000280	\N		0	0	0	0	98529	0	714035009	37017711		
988	1556	4306014	1973-10-05	1973-10-05 00:00:00	38000280	\N		0	0	0	0	104192	0	419263009	4306014		
185	372	4304110	1985-05-29	1985-05-29 00:00:00	38000280	\N		0	0	0	0	24765	0	419474003	4304110		
296	576	4102123	1967-12-07	1967-12-07 00:00:00	38000280	\N		0	0	0	0	38090	0	300916003	4102123		
600	1036	4304110	1974-09-30	1974-09-30 00:00:00	38000280	\N		0	0	0	0	68160	0	419474003	4304110		
636	1083	4304110	1966-11-08	1966-11-08 00:00:00	38000280	\N		0	0	0	0	71170	0	419474003	4304110		
708	1176	4219399	1963-10-28	1963-10-28 00:00:00	38000280	\N		0	0	0	0	77625	0	417532002	4219399		
1093	1753	439406	1965-10-09	1965-10-09 00:00:00	38000280	\N		0	0	0	0	117170	0	232347008	439406		
1198	1845	4048169	1962-07-29	1962-07-29 00:00:00	38000280	\N		0	0	0	0	123271	0	232350006	4048169		
2871	4924	4240902	1978-06-24	1978-06-24 00:00:00	38000280	\N		0	0	0	0	327278	0	91935009	4240902		
25406	1513	45766064	1981-05-23	1981-05-23 00:00:00	38000276	\N		0	0	0	0	101150	0	703151001	45766064		
3128	5290	4169137	1955-02-12	1955-02-12 00:00:00	38000280	\N		0	0	0	0	351966	0	420174000	4169137		
11652	687	4323208	1992-01-17	1992-01-17 00:00:00	38000276	\N		0	0	0	0	45498	0	428251008	4323208		
1978	3123	438614	1978-02-19	1978-02-19 00:00:00	38000280	\N		0	0	0	0	207805	0	91934008	438614		
2058	3371	37017711	1976-03-23	1976-03-23 00:00:00	38000280	\N		0	0	0	0	223598	0	714035009	37017711		
2148	3589	433644	1981-08-09	1981-08-09 00:00:00	38000280	\N		0	0	0	0	238475	0	300913006	433644		
62252	3676	4324181	1997-02-13	1997-02-13 00:00:00	38000276	\N		0	0	0	0	244486	0	429007001	4324181		
62527	3694	45766064	1969-04-06	1969-04-06 00:00:00	38000276	\N		0	0	0	0	245559	0	703151001	45766064		
55759	3300	4323208	1986-08-06	1986-08-06 00:00:00	38000276	\N		0	0	0	0	219244	0	428251008	4323208		
51717	3067	4324181	1960-12-20	1960-12-20 00:00:00	38000276	\N		0	0	0	0	204175	0	429007001	4324181		
82651	4907	4323208	1948-02-03	1948-02-03 00:00:00	38000276	\N		0	0	0	0	326167	0	428251008	4323208		
1836	105	4163874	2005-11-11	2005-11-11 00:00:00	38000276	\N		0	0	0	0	7147	0	399211009	4163874		
78641	4656	4163874	2008-06-29	2008-06-29 00:00:00	38000276	\N		0	0	0	0	310471	0	399211009	4163874		
59256	3514	4323208	2015-08-11	2015-08-11 00:00:00	38000276	\N		0	0	0	0	233189	0	428251008	4323208		
45265	2692	4163874	1998-06-29	1998-06-29 00:00:00	38000276	\N		0	0	0	0	178364	0	399211009	4163874		
49268	2914	4324181	1986-09-06	1986-09-06 00:00:00	38000276	\N		0	0	0	0	194195	0	429007001	4324181		
1624	2534	4240902	1973-08-02	1973-08-02 00:00:00	38000280	\N		0	0	0	0	167434	0	91935009	4240902		
1716	2649	433644	1958-09-12	1958-09-12 00:00:00	38000280	\N		0	0	0	0	175296	0	300913006	433644		
1790	2732	4302207	1970-12-12	1970-12-12 00:00:00	38000280	\N		0	0	0	0	180890	0	418689008	4302207		
72151	4282	4323208	1978-04-05	1978-04-05 00:00:00	38000276	\N		0	0	0	0	284194	0	428251008	4323208		
2772	4724	439406	1942-02-13	1942-02-13 00:00:00	38000280	\N		0	0	0	0	314731	0	232347008	439406		
2853	4878	4102123	1963-08-21	1963-08-21 00:00:00	38000280	\N		0	0	0	0	324328	0	300916003	4102123		
85362	5077	45766064	2017-03-04	2017-03-04 00:00:00	38000276	\N		0	0	0	0	337490	0	703151001	45766064		
71428	4238	4324181	1978-12-28	1978-12-28 00:00:00	38000276	\N		0	0	0	0	281383	0	429007001	4324181		
20715	1245	4324181	2003-10-10	2003-10-10 00:00:00	38000276	\N		0	0	0	0	81904	0	429007001	4324181		
19455	1169	4324181	2012-02-20	2012-02-20 00:00:00	38000276	\N		0	0	0	0	76990	0	429007001	4324181		
722	1211	4304110	1967-11-16	1967-11-16 00:00:00	38000280	\N		0	0	0	0	79593	0	419474003	4304110		
61716	3644	4324181	1982-02-24	1982-02-24 00:00:00	38000276	\N		0	0	0	0	242492	0	429007001	4324181		
53192	3150	4168004	1983-05-06	1983-05-06 00:00:00	38000276	\N		0	0	0	0	209581	0	48333001	4168004		
1793	2732	439406	1970-12-12	1970-12-12 00:00:00	38000280	\N		0	0	0	0	180890	0	232347008	439406		
1886	2942	439406	1954-12-06	1954-12-06 00:00:00	38000280	\N		0	0	0	0	196168	0	232347008	439406		
44480	2646	4324181	2007-12-14	2007-12-14 00:00:00	38000276	\N		0	0	0	0	175085	0	429007001	4324181		
53840	3184	4323208	2000-02-23	2000-02-23 00:00:00	38000276	\N		0	0	0	0	212007	0	428251008	4323208		
3795	219	45766064	1974-03-29	1974-03-29 00:00:00	38000276	\N		0	0	0	0	14749	0	703151001	45766064		
1267	1967	4306014	1956-11-18	1956-11-18 00:00:00	38000280	\N		0	0	0	0	130849	0	419263009	4306014		
1351	2149	4174876	1959-10-30	1959-10-30 00:00:00	38000280	\N		0	0	0	0	143121	0	424213003	4174876		
1517	2369	439406	1982-01-16	1982-01-16 00:00:00	38000280	\N		0	0	0	0	157671	0	232347008	439406		
2597	4366	439406	1982-04-19	1982-04-19 00:00:00	38000280	\N		0	0	0	0	289663	0	232347008	439406		
2685	4500	442116	1962-08-27	1962-08-27 00:00:00	38000280	\N		0	0	0	0	299644	0	91930004	442116		
75292	4472	4163874	2015-10-03	2015-10-03 00:00:00	38000276	\N		0	0	0	0	297547	0	399211009	4163874		
48425	2868	4163874	2016-02-10	2016-02-10 00:00:00	38000276	\N		0	0	0	0	190820	0	399211009	4163874		
927	1478	4302207	1961-12-29	1961-12-29 00:00:00	38000280	\N		0	0	0	0	98571	0	418689008	4302207		
989	1556	4304110	1973-10-05	1973-10-05 00:00:00	38000280	\N		0	0	0	0	104192	0	419474003	4304110		
194	399	4048169	1958-04-30	1958-04-30 00:00:00	38000280	\N		0	0	0	0	26160	0	232350006	4048169		
297	576	4240902	1967-12-07	1967-12-07 00:00:00	38000280	\N		0	0	0	0	38090	0	91935009	4240902		
606	1051	4048169	1966-03-19	1966-03-19 00:00:00	38000280	\N		0	0	0	0	68871	0	232350006	4048169		
637	1083	4219399	1966-11-08	1966-11-08 00:00:00	38000280	\N		0	0	0	0	71170	0	417532002	4219399		
709	1176	4306014	1963-10-28	1963-10-28 00:00:00	38000280	\N		0	0	0	0	77625	0	419263009	4306014		
1094	1753	4306014	1965-10-09	1965-10-09 00:00:00	38000280	\N		0	0	0	0	117170	0	419263009	4306014		
1199	1845	439406	1962-07-29	1962-07-29 00:00:00	38000280	\N		0	0	0	0	123271	0	232347008	439406		
2872	4924	439406	1978-06-24	1978-06-24 00:00:00	38000280	\N		0	0	0	0	327278	0	232347008	439406		
3054	5150	4048169	1940-02-26	1940-02-26 00:00:00	38000280	\N		0	0	0	0	342371	0	232350006	4048169		
3148	5322	439406	1947-03-14	1947-03-14 00:00:00	38000280	\N		0	0	0	0	354216	0	232347008	439406		
33271	1975	45766064	1973-01-29	1973-01-29 00:00:00	38000276	\N		0	0	0	0	131312	0	703151001	45766064		
1979	3123	4306014	1978-02-19	1978-02-19 00:00:00	38000280	\N		0	0	0	0	207805	0	419263009	4306014		
2059	3371	4304110	1976-03-23	1976-03-23 00:00:00	38000280	\N		0	0	0	0	223598	0	419474003	4304110		
6672	394	4163874	1989-03-27	1989-03-27 00:00:00	38000276	\N		0	0	0	0	25914	0	399211009	4163874		
44336	2636	4163874	2019-03-08	2019-03-08 00:00:00	38000276	\N		0	0	0	0	174490	0	399211009	4163874		
62546	3695	4324181	2007-02-12	2007-02-12 00:00:00	38000276	\N		0	0	0	0	245606	0	429007001	4324181		
16502	974	4323208	1993-06-16	1993-06-16 00:00:00	38000276	\N		0	0	0	0	64969	0	428251008	4323208		
75885	4500	45766064	1961-09-13	1961-09-13 00:00:00	38000276	\N		0	0	0	0	299601	0	703151001	45766064		
29655	1755	4324181	2015-08-26	2015-08-26 00:00:00	38000276	\N		0	0	0	0	117380	0	429007001	4324181		
63146	3730	4324181	1994-07-28	1994-07-28 00:00:00	38000276	\N		0	0	0	0	247807	0	429007001	4324181		
85465	5081	4324181	1935-05-17	1935-05-17 00:00:00	38000276	\N		0	0	0	0	337899	0	429007001	4324181		
2326	4026	4304110	1977-02-07	1977-02-07 00:00:00	38000280	\N		0	0	0	0	267662	0	419474003	4304110		
65111	3851	4324181	1985-10-14	1985-10-14 00:00:00	38000276	\N		0	0	0	0	255594	0	429007001	4324181		
76492	4534	45766064	1956-10-23	1956-10-23 00:00:00	38000276	\N		0	0	0	0	302074	0	703151001	45766064		
1625	2537	439406	1951-09-10	1951-09-10 00:00:00	38000280	\N		0	0	0	0	167614	0	232347008	439406		
1717	2649	4304110	1958-09-12	1958-09-12 00:00:00	38000280	\N		0	0	0	0	175296	0	419474003	4304110		
75401	4476	4324181	1975-05-04	1975-05-04 00:00:00	38000276	\N		0	0	0	0	297897	0	429007001	4324181		
2686	4500	4048169	1962-08-27	1962-08-27 00:00:00	38000280	\N		0	0	0	0	299644	0	232350006	4048169		
2773	4724	4306014	1942-02-13	1942-02-13 00:00:00	38000280	\N		0	0	0	0	314731	0	419263009	4306014		
2854	4878	4219399	1963-08-21	1963-08-21 00:00:00	38000280	\N		0	0	0	0	324328	0	417532002	4219399		
88740	5276	4323208	2011-01-07	2011-01-07 00:00:00	38000276	\N		0	0	0	0	350926	0	428251008	4323208		
71500	4240	4323208	1965-07-16	1965-07-16 00:00:00	38000276	\N		0	0	0	0	281640	0	428251008	4323208		
8055	471	4324181	1990-04-06	1990-04-06 00:00:00	38000276	\N		0	0	0	0	31462	0	429007001	4324181		
19465	1169	4163874	2018-08-20	2018-08-20 00:00:00	38000276	\N		0	0	0	0	76991	0	399211009	4163874		
723	1211	4306014	1967-11-16	1967-11-16 00:00:00	38000280	\N		0	0	0	0	79593	0	419263009	4306014		
856	1397	4304110	1977-11-27	1977-11-27 00:00:00	38000280	\N		0	0	0	0	92780	0	419474003	4304110		
1657	96	4163874	1997-01-25	1997-01-25 00:00:00	38000276	\N		0	0	0	0	6509	0	399211009	4163874		
1794	2732	4174876	1970-12-12	1970-12-12 00:00:00	38000280	\N		0	0	0	0	180890	0	424213003	4174876		
1887	2942	4304110	1954-12-06	1954-12-06 00:00:00	38000280	\N		0	0	0	0	196168	0	419474003	4304110		
55125	3263	4324181	2007-09-11	2007-09-11 00:00:00	38000276	\N		0	0	0	0	216903	0	429007001	4324181		
29404	1740	45766064	1952-09-06	1952-09-06 00:00:00	38000276	\N		0	0	0	0	116290	0	703151001	45766064		
1268	1967	4304110	1956-11-18	1956-11-18 00:00:00	38000280	\N		0	0	0	0	130849	0	419474003	4304110		
1352	2149	439406	1959-10-30	1959-10-30 00:00:00	38000280	\N		0	0	0	0	143121	0	232347008	439406		
1518	2369	4169137	1982-01-16	1982-01-16 00:00:00	38000280	\N		0	0	0	0	157671	0	420174000	4169137		
2598	4366	4174876	1982-04-19	1982-04-19 00:00:00	38000280	\N		0	0	0	0	289663	0	424213003	4174876		
6071	357	4323208	1997-10-04	1997-10-04 00:00:00	38000276	\N		0	0	0	0	23632	0	428251008	4323208		
928	1478	4048169	1961-12-29	1961-12-29 00:00:00	38000280	\N		0	0	0	0	98571	0	232350006	4048169		
1002	1567	439406	1975-10-07	1975-10-07 00:00:00	38000280	\N		0	0	0	0	105078	0	232347008	439406		
195	399	4302207	1958-04-30	1958-04-30 00:00:00	38000280	\N		0	0	0	0	26160	0	418689008	4302207		
298	576	4304110	1967-12-07	1967-12-07 00:00:00	38000280	\N		0	0	0	0	38090	0	419474003	4304110		
607	1051	442116	1966-03-19	1966-03-19 00:00:00	38000280	\N		0	0	0	0	68871	0	91930004	442116		
638	1083	4306014	1966-11-08	1966-11-08 00:00:00	38000280	\N		0	0	0	0	71170	0	419263009	4306014		
710	1176	433644	1963-10-28	1963-10-28 00:00:00	38000280	\N		0	0	0	0	77625	0	300913006	433644		
1095	1753	4304110	1965-10-09	1965-10-09 00:00:00	38000280	\N		0	0	0	0	117170	0	419474003	4304110		
1200	1845	4169137	1962-07-29	1962-07-29 00:00:00	38000280	\N		0	0	0	0	123271	0	420174000	4169137		
2873	4924	4302207	1978-06-24	1978-06-24 00:00:00	38000280	\N		0	0	0	0	327278	0	418689008	4302207		
3055	5150	433644	1940-02-26	1940-02-26 00:00:00	38000280	\N		0	0	0	0	342371	0	300913006	433644		
3149	5322	4304110	1947-03-14	1947-03-14 00:00:00	38000280	\N		0	0	0	0	354216	0	419474003	4304110		
57852	3432	45766064	1953-11-08	1953-11-08 00:00:00	38000276	\N		0	0	0	0	227483	0	703151001	45766064		
1980	3123	439406	1978-02-19	1978-02-19 00:00:00	38000280	\N		0	0	0	0	207805	0	232347008	439406		
2060	3371	4306014	1976-03-23	1976-03-23 00:00:00	38000280	\N		0	0	0	0	223598	0	419263009	4306014		
20553	1235	4323208	2009-05-19	2009-05-19 00:00:00	38000276	\N		0	0	0	0	81342	0	428251008	4323208		
528	911	4169137	1977-06-15	1977-06-15 00:00:00	38000280	\N		0	0	0	0	60471	0	420174000	4169137		
24906	1486	4324181	2001-12-23	2001-12-23 00:00:00	38000276	\N		0	0	0	0	99029	0	429007001	4324181		
16506	974	45766064	1956-06-24	1956-06-24 00:00:00	38000276	\N		0	0	0	0	64962	0	703151001	45766064		
22049	1318	4323208	1953-03-05	1953-03-05 00:00:00	38000276	\N		0	0	0	0	87438	0	428251008	4323208		
46172	2750	4324181	2011-05-25	2011-05-25 00:00:00	38000276	\N		0	0	0	0	181876	0	429007001	4324181		
2149	3601	439406	1960-08-23	1960-08-23 00:00:00	38000280	\N		0	0	0	0	239233	0	232347008	439406		
47825	2841	4163874	1984-10-21	1984-10-21 00:00:00	38000276	\N		0	0	0	0	188634	0	399211009	4163874		
2327	4027	4102123	1975-02-13	1975-02-13 00:00:00	38000280	\N		0	0	0	0	267867	0	300916003	4102123		
65130	3852	4324181	2008-03-31	2008-03-31 00:00:00	38000276	\N		0	0	0	0	255634	0	429007001	4324181		
76502	4534	4163874	2011-11-30	2011-11-30 00:00:00	38000276	\N		0	0	0	0	302079	0	399211009	4163874		
1626	2537	4304110	1951-09-10	1951-09-10 00:00:00	38000280	\N		0	0	0	0	167614	0	419474003	4304110		
1718	2649	4219399	1958-09-12	1958-09-12 00:00:00	38000280	\N		0	0	0	0	175296	0	417532002	4219399		
88009	5234	4323208	1977-08-24	1977-08-24 00:00:00	38000276	\N		0	0	0	0	348231	0	428251008	4323208		
2687	4505	4302207	1941-08-15	1941-08-15 00:00:00	38000280	\N		0	0	0	0	300040	0	418689008	4302207		
2774	4724	438614	1942-02-13	1942-02-13 00:00:00	38000280	\N		0	0	0	0	314731	0	91934008	438614		
2855	4878	439406	1963-08-21	1963-08-21 00:00:00	38000280	\N		0	0	0	0	324328	0	232347008	439406		
50133	2961	4323208	1972-09-26	1972-09-26 00:00:00	38000276	\N		0	0	0	0	197702	0	428251008	4323208		
42678	2543	45766064	1964-10-18	1964-10-18 00:00:00	38000276	\N		0	0	0	0	168264	0	703151001	45766064		
724	1211	439406	1967-11-16	1967-11-16 00:00:00	38000280	\N		0	0	0	0	79593	0	232347008	439406		
857	1397	439406	1977-11-27	1977-11-27 00:00:00	38000280	\N		0	0	0	0	92780	0	232347008	439406		
42272	2518	4324181	1986-08-08	1986-08-08 00:00:00	38000276	\N		0	0	0	0	166542	0	429007001	4324181		
1795	2732	4169137	1970-12-12	1970-12-12 00:00:00	38000280	\N		0	0	0	0	180890	0	420174000	4169137		
1888	2942	4306014	1954-12-06	1954-12-06 00:00:00	38000280	\N		0	0	0	0	196168	0	419263009	4306014		
29432	1743	4323208	2011-01-25	2011-01-25 00:00:00	38000276	\N		0	0	0	0	116475	0	428251008	4323208		
1269	1967	4102123	1956-11-18	1956-11-18 00:00:00	38000280	\N		0	0	0	0	130849	0	300916003	4102123		
1353	2149	4048169	1959-10-30	1959-10-30 00:00:00	38000280	\N		0	0	0	0	143121	0	232350006	4048169		
1519	2369	4306014	1982-01-16	1982-01-16 00:00:00	38000280	\N		0	0	0	0	157671	0	419263009	4306014		
2599	4366	4169137	1982-04-19	1982-04-19 00:00:00	38000280	\N		0	0	0	0	289663	0	420174000	4169137		
70947	4208	4324181	1981-04-07	1981-04-07 00:00:00	38000276	\N		0	0	0	0	279428	0	429007001	4324181		
929	1478	4304110	1961-12-29	1961-12-29 00:00:00	38000280	\N		0	0	0	0	98571	0	419474003	4304110		
1003	1567	4174876	1975-10-07	1975-10-07 00:00:00	38000280	\N		0	0	0	0	105078	0	424213003	4174876		
196	399	4304110	1958-04-30	1958-04-30 00:00:00	38000280	\N		0	0	0	0	26160	0	419474003	4304110		
299	576	439406	1967-12-07	1967-12-07 00:00:00	38000280	\N		0	0	0	0	38090	0	232347008	439406		
608	1051	4302207	1966-03-19	1966-03-19 00:00:00	38000280	\N		0	0	0	0	68871	0	418689008	4302207		
654	1091	4240902	1957-08-10	1957-08-10 00:00:00	38000280	\N		0	0	0	0	71738	0	91935009	4240902		
86204	5128	4324181	1955-07-27	1955-07-27 00:00:00	38000276	\N		0	0	0	0	340918	0	429007001	4324181		
1096	1753	4219399	1965-10-09	1965-10-09 00:00:00	38000280	\N		0	0	0	0	117170	0	417532002	4219399		
1201	1845	4306014	1962-07-29	1962-07-29 00:00:00	38000280	\N		0	0	0	0	123271	0	419263009	4306014		
2916	4970	4304110	1946-05-04	1946-05-04 00:00:00	38000280	\N		0	0	0	0	330475	0	419474003	4304110		
3063	5165	433644	1964-06-22	1964-06-22 00:00:00	38000280	\N		0	0	0	0	343246	0	300913006	433644		
3150	5322	4219399	1947-03-14	1947-03-14 00:00:00	38000280	\N		0	0	0	0	354216	0	417532002	4219399		
786	42	4323208	1933-10-29	1933-10-29 00:00:00	38000276	\N		0	0	0	0	3109	0	428251008	4323208		
1981	3128	433644	1973-08-18	1973-08-18 00:00:00	38000280	\N		0	0	0	0	208193	0	300913006	433644		
2061	3376	4219399	1953-11-03	1953-11-03 00:00:00	38000280	\N		0	0	0	0	224006	0	417532002	4219399		
30432	1794	4323208	1972-02-06	1972-02-06 00:00:00	38000276	\N		0	0	0	0	120296	0	428251008	4323208		
529	911	439406	1977-06-15	1977-06-15 00:00:00	38000280	\N		0	0	0	0	60471	0	232347008	439406		
24968	1491	4163874	2011-07-12	2011-07-12 00:00:00	38000276	\N		0	0	0	0	99456	0	399211009	4163874		
22317	1332	4163874	2019-01-02	2019-01-02 00:00:00	38000276	\N		0	0	0	0	88384	0	399211009	4163874		
46555	2771	45766064	1972-09-01	1972-09-01 00:00:00	38000276	\N		0	0	0	0	183473	0	703151001	45766064		
2150	3601	4304110	1960-08-23	1960-08-23 00:00:00	38000280	\N		0	0	0	0	239233	0	419474003	4304110		
74505	4423	4324181	1989-04-21	1989-04-21 00:00:00	38000276	\N		0	0	0	0	294121	0	429007001	4324181		
69002	4084	4324181	2010-10-03	2010-10-03 00:00:00	38000276	\N		0	0	0	0	271438	0	429007001	4324181		
76446	4532	4323208	1946-04-10	1946-04-10 00:00:00	38000276	\N		0	0	0	0	301940	0	428251008	4323208		
70177	4156	4163874	2006-02-27	2006-02-27 00:00:00	38000276	\N		0	0	0	0	276159	0	399211009	4163874		
1642	2559	442116	1959-06-26	1959-06-26 00:00:00	38000280	\N		0	0	0	0	169543	0	91930004	442116		
1719	2649	4306014	1958-09-12	1958-09-12 00:00:00	38000280	\N		0	0	0	0	175296	0	419263009	4306014		
88042	5235	4163874	1982-01-23	1982-01-23 00:00:00	38000276	\N		0	0	0	0	348320	0	399211009	4163874		
2688	4514	433644	1976-06-28	1976-06-28 00:00:00	38000280	\N		0	0	0	0	300670	0	300913006	433644		
2775	4724	4240902	1942-02-13	1942-02-13 00:00:00	38000280	\N		0	0	0	0	314731	0	91935009	4240902		
2856	4878	4302207	1963-08-21	1963-08-21 00:00:00	38000280	\N		0	0	0	0	324328	0	418689008	4302207		
20601	1237	4323208	1950-09-30	1950-09-30 00:00:00	38000276	\N		0	0	0	0	81491	0	428251008	4323208		
745	1228	439406	1979-07-31	1979-07-31 00:00:00	38000280	\N		0	0	0	0	80917	0	232347008	439406		
858	1397	4169137	1977-11-27	1977-11-27 00:00:00	38000280	\N		0	0	0	0	92780	0	420174000	4169137		
65594	3879	45766064	2015-11-25	2015-11-25 00:00:00	38000276	\N		0	0	0	0	257729	0	703151001	45766064		
1803	2770	433644	1932-02-12	1932-02-12 00:00:00	38000280	\N		0	0	0	0	183330	0	300913006	433644		
1889	2942	442116	1954-12-06	1954-12-06 00:00:00	38000280	\N		0	0	0	0	196168	0	91930004	442116		
67106	3967	4323208	1993-04-25	1993-04-25 00:00:00	38000276	\N		0	0	0	0	263743	0	428251008	4323208		
1270	1967	4219399	1956-11-18	1956-11-18 00:00:00	38000280	\N		0	0	0	0	130849	0	417532002	4219399		
1368	2168	4048169	1958-10-11	1958-10-11 00:00:00	38000280	\N		0	0	0	0	144456	0	232350006	4048169		
1520	2369	4304110	1982-01-16	1982-01-16 00:00:00	38000280	\N		0	0	0	0	157671	0	419474003	4304110		
2600	4366	433644	1982-04-19	1982-04-19 00:00:00	38000280	\N		0	0	0	0	289663	0	300913006	433644		
4783	280	4163874	2019-05-31	2019-05-31 00:00:00	38000276	\N		0	0	0	0	18709	0	399211009	4163874		
930	1478	4102123	1961-12-29	1961-12-29 00:00:00	38000280	\N		0	0	0	0	98571	0	300916003	4102123		
1004	1567	4048169	1975-10-07	1975-10-07 00:00:00	38000280	\N		0	0	0	0	105078	0	232350006	4048169		
197	399	439406	1958-04-30	1958-04-30 00:00:00	38000280	\N		0	0	0	0	26160	0	232347008	439406		
300	576	4048169	1967-12-07	1967-12-07 00:00:00	38000280	\N		0	0	0	0	38090	0	232350006	4048169		
609	1051	4304110	1966-03-19	1966-03-19 00:00:00	38000280	\N		0	0	0	0	68871	0	419474003	4304110		
656	1099	4169137	1952-12-26	1952-12-26 00:00:00	38000280	\N		0	0	0	0	72139	0	420174000	4169137		
38532	2289	45766064	1958-10-30	1958-10-30 00:00:00	38000276	\N		0	0	0	0	152263	0	703151001	45766064		
1097	1753	4240902	1965-10-09	1965-10-09 00:00:00	38000280	\N		0	0	0	0	117170	0	91935009	4240902		
1202	1845	4304110	1962-07-29	1962-07-29 00:00:00	38000280	\N		0	0	0	0	123271	0	419474003	4304110		
2917	4976	439406	1913-06-18	1913-06-18 00:00:00	38000280	\N		0	0	0	0	331030	0	232347008	439406		
3064	5166	442116	1953-06-13	1953-06-13 00:00:00	38000280	\N		0	0	0	0	343405	0	91930004	442116		
3151	5322	4306014	1947-03-14	1947-03-14 00:00:00	38000280	\N		0	0	0	0	354216	0	419263009	4306014		
47113	2802	4163874	1997-12-13	1997-12-13 00:00:00	38000276	\N		0	0	0	0	185715	0	399211009	4163874		
1982	3128	439406	1973-08-18	1973-08-18 00:00:00	38000280	\N		0	0	0	0	208193	0	232347008	439406		
2076	3399	433644	1983-12-17	1983-12-17 00:00:00	38000280	\N		0	0	0	0	225486	0	300913006	433644		
12321	728	4323208	1960-01-22	1960-01-22 00:00:00	38000276	\N		0	0	0	0	48274	0	428251008	4323208		
530	911	4306014	1977-06-15	1977-06-15 00:00:00	38000280	\N		0	0	0	0	60471	0	419263009	4306014		
85896	5111	4163874	1984-12-03	1984-12-03 00:00:00	38000276	\N		0	0	0	0	339626	0	399211009	4163874		
81521	4835	4323208	1985-04-26	1985-04-26 00:00:00	38000276	\N		0	0	0	0	321666	0	428251008	4323208		
46563	2771	4324181	1955-11-11	1955-11-11 00:00:00	38000276	\N		0	0	0	0	183470	0	429007001	4324181		
2151	3601	4240902	1960-08-23	1960-08-23 00:00:00	38000280	\N		0	0	0	0	239233	0	91935009	4240902		
2244	3832	433644	1984-11-17	1984-11-17 00:00:00	38000280	\N		0	0	0	0	254407	0	300913006	433644		
44973	2675	4323208	1996-01-23	1996-01-23 00:00:00	38000276	\N		0	0	0	0	177275	0	428251008	4323208		
84672	5035	4324181	2003-03-03	2003-03-03 00:00:00	38000276	\N		0	0	0	0	334577	0	429007001	4324181		
70250	4160	4324181	1965-11-25	1965-11-25 00:00:00	38000276	\N		0	0	0	0	276447	0	429007001	4324181		
1643	2577	4302207	1973-10-04	1973-10-04 00:00:00	38000280	\N		0	0	0	0	170648	0	418689008	4302207		
1720	2649	439406	1958-09-12	1958-09-12 00:00:00	38000280	\N		0	0	0	0	175296	0	232347008	439406		
88283	5251	45766064	1922-02-27	1922-02-27 00:00:00	38000276	\N		0	0	0	0	349386	0	703151001	45766064		
2699	4550	4169137	1963-12-19	1963-12-19 00:00:00	38000280	\N		0	0	0	0	303176	0	420174000	4169137		
2776	4724	4219399	1942-02-13	1942-02-13 00:00:00	38000280	\N		0	0	0	0	314731	0	417532002	4219399		
2857	4878	4048169	1963-08-21	1963-08-21 00:00:00	38000280	\N		0	0	0	0	324328	0	232350006	4048169		
31315	1851	45766064	1988-12-05	1988-12-05 00:00:00	38000276	\N		0	0	0	0	123828	0	703151001	45766064		
746	1246	439406	1939-02-25	1939-02-25 00:00:00	38000280	\N		0	0	0	0	82137	0	232347008	439406		
859	1397	4048169	1977-11-27	1977-11-27 00:00:00	38000280	\N		0	0	0	0	92780	0	232350006	4048169		
1806	2778	442116	1978-02-02	1978-02-02 00:00:00	38000280	\N		0	0	0	0	183994	0	91930004	442116		
1890	2942	4302207	1954-12-06	1954-12-06 00:00:00	38000280	\N		0	0	0	0	196168	0	418689008	4302207		
67125	3968	4324181	1928-02-03	1928-02-03 00:00:00	38000276	\N		0	0	0	0	263901	0	429007001	4324181		
1271	1967	439406	1956-11-18	1956-11-18 00:00:00	38000280	\N		0	0	0	0	130849	0	232347008	439406		
1369	2168	4302207	1958-10-11	1958-10-11 00:00:00	38000280	\N		0	0	0	0	144456	0	418689008	4302207		
1521	2369	4219399	1982-01-16	1982-01-16 00:00:00	38000280	\N		0	0	0	0	157671	0	417532002	4219399		
2607	4372	438614	1981-01-19	1981-01-19 00:00:00	38000280	\N		0	0	0	0	290260	0	91934008	438614		
75252	4470	4323208	2010-12-31	2010-12-31 00:00:00	38000276	\N		0	0	0	0	297389	0	428251008	4323208		
931	1478	438614	1961-12-29	1961-12-29 00:00:00	38000280	\N		0	0	0	0	98571	0	91934008	438614		
1005	1567	4302207	1975-10-07	1975-10-07 00:00:00	38000280	\N		0	0	0	0	105078	0	418689008	4302207		
198	399	4174876	1958-04-30	1958-04-30 00:00:00	38000280	\N		0	0	0	0	26160	0	424213003	4174876		
301	576	4302207	1967-12-07	1967-12-07 00:00:00	38000280	\N		0	0	0	0	38090	0	418689008	4302207		
610	1051	438614	1966-03-19	1966-03-19 00:00:00	38000280	\N		0	0	0	0	68871	0	91934008	438614		
663	1110	442116	1983-04-24	1983-04-24 00:00:00	38000280	\N		0	0	0	0	73088	0	91930004	442116		
38612	2291	4323208	1966-10-14	1966-10-14 00:00:00	38000276	\N		0	0	0	0	152494	0	428251008	4323208		
1098	1753	4102123	1965-10-09	1965-10-09 00:00:00	38000280	\N		0	0	0	0	117170	0	300916003	4102123		
1203	1845	4102123	1962-07-29	1962-07-29 00:00:00	38000280	\N		0	0	0	0	123271	0	300916003	4102123		
2918	4976	4304110	1913-06-18	1913-06-18 00:00:00	38000280	\N		0	0	0	0	331030	0	419474003	4304110		
3074	5194	4306014	1946-07-03	1946-07-03 00:00:00	38000280	\N		0	0	0	0	345296	0	419263009	4306014		
3152	5322	4048169	1947-03-14	1947-03-14 00:00:00	38000280	\N		0	0	0	0	354216	0	232350006	4048169		
1983	3128	4174876	1973-08-18	1973-08-18 00:00:00	38000280	\N		0	0	0	0	208193	0	424213003	4174876		
2086	3428	4240902	1967-08-31	1967-08-31 00:00:00	38000280	\N		0	0	0	0	227247	0	91935009	4240902		
58688	3481	4324181	2001-05-12	2001-05-12 00:00:00	38000276	\N		0	0	0	0	230885	0	429007001	4324181		
531	911	4304110	1977-06-15	1977-06-15 00:00:00	38000280	\N		0	0	0	0	60471	0	419474003	4304110		
85914	5113	45766064	1974-03-14	1974-03-14 00:00:00	38000276	\N		0	0	0	0	339723	0	703151001	45766064		
81541	4837	4324181	2004-03-23	2004-03-23 00:00:00	38000276	\N		0	0	0	0	321870	0	429007001	4324181		
79069	4680	45766064	1946-04-08	1946-04-08 00:00:00	38000276	\N		0	0	0	0	311942	0	703151001	45766064		
2152	3601	4306014	1960-08-23	1960-08-23 00:00:00	38000280	\N		0	0	0	0	239233	0	419263009	4306014		
2245	3852	4304110	1970-10-24	1970-10-24 00:00:00	38000280	\N		0	0	0	0	255708	0	419474003	4304110		
80186	4753	4324181	1987-11-18	1987-11-18 00:00:00	38000276	\N		0	0	0	0	316575	0	429007001	4324181		
59297	3516	4323208	1950-07-26	1950-07-26 00:00:00	38000276	\N		0	0	0	0	233390	0	428251008	4323208		
1644	2577	4048169	1973-10-04	1973-10-04 00:00:00	38000280	\N		0	0	0	0	170648	0	232350006	4048169		
1721	2649	4169137	1958-09-12	1958-09-12 00:00:00	38000280	\N		0	0	0	0	175296	0	420174000	4169137		
36210	2147	4324181	2005-03-25	2005-03-25 00:00:00	38000276	\N		0	0	0	0	142966	0	429007001	4324181		
2700	4562	4304110	1961-08-14	1961-08-14 00:00:00	38000280	\N		0	0	0	0	304056	0	419474003	4304110		
2777	4724	4304110	1942-02-13	1942-02-13 00:00:00	38000280	\N		0	0	0	0	314731	0	419474003	4304110		
2858	4878	433644	1963-08-21	1963-08-21 00:00:00	38000280	\N		0	0	0	0	324328	0	300913006	433644		
747	1246	4302207	1939-02-25	1939-02-25 00:00:00	38000280	\N		0	0	0	0	82137	0	418689008	4302207		
860	1397	4302207	1977-11-27	1977-11-27 00:00:00	38000280	\N		0	0	0	0	92780	0	418689008	4302207		
1836	2830	4306014	1975-06-22	1975-06-22 00:00:00	38000280	\N		0	0	0	0	187706	0	419263009	4306014		
1891	2942	4048169	1954-12-06	1954-12-06 00:00:00	38000280	\N		0	0	0	0	196168	0	232350006	4048169		
1274	1971	433644	1970-03-23	1970-03-23 00:00:00	38000280	\N		0	0	0	0	131065	0	300913006	433644		
1370	2168	439406	1958-10-11	1958-10-11 00:00:00	38000280	\N		0	0	0	0	144456	0	232347008	439406		
1531	2402	4302207	1977-11-19	1977-11-19 00:00:00	38000280	\N		0	0	0	0	159572	0	418689008	4302207		
2608	4373	4139681	1976-07-18	1976-07-18 00:00:00	38000280	\N		0	0	0	0	290341	0	425525006	4139681		
932	1478	4306014	1961-12-29	1961-12-29 00:00:00	38000280	\N		0	0	0	0	98571	0	419263009	4306014		
1006	1567	4306014	1975-10-07	1975-10-07 00:00:00	38000280	\N		0	0	0	0	105078	0	419263009	4306014		
199	404	4304110	1965-07-09	1965-07-09 00:00:00	38000280	\N		0	0	0	0	26674	0	419474003	4304110		
302	578	439406	1968-01-16	1968-01-16 00:00:00	38000280	\N		0	0	0	0	38264	0	232347008	439406		
611	1051	4240902	1966-03-19	1966-03-19 00:00:00	38000280	\N		0	0	0	0	68871	0	91935009	4240902		
664	1110	4306014	1983-04-24	1983-04-24 00:00:00	38000280	\N		0	0	0	0	73088	0	419263009	4306014		
67840	4009	45766064	2005-07-26	2005-07-26 00:00:00	38000276	\N		0	0	0	0	266396	0	703151001	45766064		
1099	1753	4048169	1965-10-09	1965-10-09 00:00:00	38000280	\N		0	0	0	0	117170	0	232350006	4048169		
1204	1852	439406	1974-04-16	1974-04-16 00:00:00	38000280	\N		0	0	0	0	123886	0	232347008	439406		
2919	4976	438614	1913-06-18	1913-06-18 00:00:00	38000280	\N		0	0	0	0	331030	0	91934008	438614		
3075	5194	433644	1946-07-03	1946-07-03 00:00:00	38000280	\N		0	0	0	0	345296	0	300913006	433644		
3153	5322	4302207	1947-03-14	1947-03-14 00:00:00	38000280	\N		0	0	0	0	354216	0	418689008	4302207		
1984	3128	4169137	1973-08-18	1973-08-18 00:00:00	38000280	\N		0	0	0	0	208193	0	420174000	4169137		
2087	3436	438614	1964-03-21	1964-03-21 00:00:00	38000280	\N		0	0	0	0	227892	0	91934008	438614		
58696	3481	4163874	2015-04-04	2015-04-04 00:00:00	38000276	\N		0	0	0	0	230888	0	399211009	4163874		
532	911	4139681	1977-06-15	1977-06-15 00:00:00	38000280	\N		0	0	0	0	60471	0	425525006	4139681		
80889	4799	4324181	2010-05-01	2010-05-01 00:00:00	38000276	\N		0	0	0	0	319291	0	429007001	4324181		
22105	1321	4323208	1995-06-24	1995-06-24 00:00:00	38000276	\N		0	0	0	0	87609	0	428251008	4323208		
2153	3601	4302207	1960-08-23	1960-08-23 00:00:00	38000280	\N		0	0	0	0	239233	0	418689008	4302207		
2246	3865	439406	1960-07-24	1960-07-24 00:00:00	38000280	\N		0	0	0	0	256577	0	232347008	439406		
59334	3518	4323208	2016-03-17	2016-03-17 00:00:00	38000276	\N		0	0	0	0	233586	0	428251008	4323208		
1645	2577	4102123	1973-10-04	1973-10-04 00:00:00	38000280	\N		0	0	0	0	170648	0	300916003	4102123		
1728	2661	4048169	1965-11-17	1965-11-17 00:00:00	38000280	\N		0	0	0	0	176238	0	232350006	4048169		
2701	4562	4306014	1961-08-14	1961-08-14 00:00:00	38000280	\N		0	0	0	0	304056	0	419263009	4306014		
2778	4724	4048169	1942-02-13	1942-02-13 00:00:00	38000280	\N		0	0	0	0	314731	0	232350006	4048169		
47785	2837	4323208	1996-07-28	1996-07-28 00:00:00	38000276	\N		0	0	0	0	188474	0	428251008	4323208		
748	1246	4139681	1939-02-25	1939-02-25 00:00:00	38000280	\N		0	0	0	0	82137	0	425525006	4139681		
862	1399	433644	1961-05-07	1961-05-07 00:00:00	38000280	\N		0	0	0	0	93041	0	300913006	433644		
1837	2830	4304110	1975-06-22	1975-06-22 00:00:00	38000280	\N		0	0	0	0	187706	0	419474003	4304110		
1899	2959	433644	1972-05-26	1972-05-26 00:00:00	38000280	\N		0	0	0	0	197581	0	300913006	433644		
1284	1977	442116	1910-12-20	1910-12-20 00:00:00	38000280	\N		0	0	0	0	131503	0	91930004	442116		
1371	2168	4304110	1958-10-11	1958-10-11 00:00:00	38000280	\N		0	0	0	0	144456	0	419474003	4304110		
1532	2402	4139681	1977-11-19	1977-11-19 00:00:00	38000280	\N		0	0	0	0	159572	0	425525006	4139681		
2609	4373	4048169	1976-07-18	1976-07-18 00:00:00	38000280	\N		0	0	0	0	290341	0	232350006	4048169		
933	1478	439406	1961-12-29	1961-12-29 00:00:00	38000280	\N		0	0	0	0	98571	0	232347008	439406		
1007	1567	4304110	1975-10-07	1975-10-07 00:00:00	38000280	\N		0	0	0	0	105078	0	419474003	4304110		
200	406	4304110	1974-03-08	1974-03-08 00:00:00	38000280	\N		0	0	0	0	26757	0	419474003	4304110		
303	578	4304110	1968-01-16	1968-01-16 00:00:00	38000280	\N		0	0	0	0	38264	0	419474003	4304110		
612	1051	439406	1966-03-19	1966-03-19 00:00:00	38000280	\N		0	0	0	0	68871	0	232347008	439406		
665	1115	4304110	1950-08-05	1950-08-05 00:00:00	38000280	\N		0	0	0	0	73449	0	419474003	4304110		
1100	1753	4302207	1965-10-09	1965-10-09 00:00:00	38000280	\N		0	0	0	0	117170	0	418689008	4302207		
1205	1852	433644	1974-04-16	1974-04-16 00:00:00	38000280	\N		0	0	0	0	123886	0	300913006	433644		
2946	4998	4048169	1965-06-02	1965-06-02 00:00:00	38000280	\N		0	0	0	0	332367	0	232350006	4048169		
3090	5245	4304110	1974-09-12	1974-09-12 00:00:00	38000280	\N		0	0	0	0	348960	0	419474003	4304110		
3154	5322	4139681	1947-03-14	1947-03-14 00:00:00	38000280	\N		0	0	0	0	354216	0	425525006	4139681		
1985	3128	4304110	1973-08-18	1973-08-18 00:00:00	38000280	\N		0	0	0	0	208193	0	419474003	4304110		
2091	3464	439406	2009-05-29	2009-05-29 00:00:00	38000280	\N		0	0	0	0	229905	0	232347008	439406		
45691	2715	4323208	1989-01-08	1989-01-08 00:00:00	38000276	\N		0	0	0	0	180098	0	428251008	4323208		
533	911	4048169	1977-06-15	1977-06-15 00:00:00	38000280	\N		0	0	0	0	60471	0	232350006	4048169		
68714	4067	45766064	1971-03-27	1971-03-27 00:00:00	38000276	\N		0	0	0	0	270199	0	703151001	45766064		
2154	3603	4048169	1967-03-18	1967-03-18 00:00:00	38000280	\N		0	0	0	0	239372	0	232350006	4048169		
2252	3874	4304110	1984-01-20	1984-01-20 00:00:00	38000280	\N		0	0	0	0	257211	0	419474003	4304110		
65433	3869	4324181	1926-10-09	1926-10-09 00:00:00	38000276	\N		0	0	0	0	256936	0	429007001	4324181		
1646	2577	4306014	1973-10-04	1973-10-04 00:00:00	38000280	\N		0	0	0	0	170648	0	419263009	4306014		
1729	2661	4139681	1965-11-17	1965-11-17 00:00:00	38000280	\N		0	0	0	0	176238	0	425525006	4139681		
2702	4562	439406	1961-08-14	1961-08-14 00:00:00	38000280	\N		0	0	0	0	304056	0	232347008	439406		
2779	4724	4302207	1942-02-13	1942-02-13 00:00:00	38000280	\N		0	0	0	0	314731	0	418689008	4302207		
760	1261	4304110	1971-07-22	1971-07-22 00:00:00	38000280	\N		0	0	0	0	83220	0	419474003	4304110		
863	1399	4048169	1961-05-07	1961-05-07 00:00:00	38000280	\N		0	0	0	0	93041	0	232350006	4048169		
1838	2830	439406	1975-06-22	1975-06-22 00:00:00	38000280	\N		0	0	0	0	187706	0	232347008	439406		
1900	2959	439406	1972-05-26	1972-05-26 00:00:00	38000280	\N		0	0	0	0	197581	0	232347008	439406		
1285	1980	4304110	1975-10-10	1975-10-10 00:00:00	38000280	\N		0	0	0	0	131877	0	419474003	4304110		
1372	2168	4306014	1958-10-11	1958-10-11 00:00:00	38000280	\N		0	0	0	0	144456	0	419263009	4306014		
1533	2402	4304110	1977-11-19	1977-11-19 00:00:00	38000280	\N		0	0	0	0	159572	0	419474003	4304110		
2610	4373	442116	1976-07-18	1976-07-18 00:00:00	38000280	\N		0	0	0	0	290341	0	91930004	442116		
934	1482	37017711	1975-07-28	1975-07-28 00:00:00	38000280	\N		0	0	0	0	98904	0	714035009	37017711		
1008	1567	438614	1975-10-07	1975-10-07 00:00:00	38000280	\N		0	0	0	0	105078	0	91934008	438614		
201	408	433644	1962-02-17	1962-02-17 00:00:00	38000280	\N		0	0	0	0	26962	0	300913006	433644		
304	578	438614	1968-01-16	1968-01-16 00:00:00	38000280	\N		0	0	0	0	38264	0	91934008	438614		
613	1051	4169137	1966-03-19	1966-03-19 00:00:00	38000280	\N		0	0	0	0	68871	0	420174000	4169137		
666	1118	433644	1974-12-18	1974-12-18 00:00:00	38000280	\N		0	0	0	0	73669	0	300913006	433644		
1101	1753	442116	1965-10-09	1965-10-09 00:00:00	38000280	\N		0	0	0	0	117170	0	91930004	442116		
18596	1118	45766064	1983-08-10	1983-08-10 00:00:00	38000276	\N		0	0	0	0	73703	0	703151001	45766064		
2947	4998	4174876	1965-06-02	1965-06-02 00:00:00	38000280	\N		0	0	0	0	332367	0	424213003	4174876		
3091	5245	438614	1974-09-12	1974-09-12 00:00:00	38000280	\N		0	0	0	0	348960	0	91934008	438614		
3162	5337	439406	1974-03-18	1974-03-18 00:00:00	38000280	\N		0	0	0	0	355447	0	232347008	439406		
1986	3128	438614	1973-08-18	1973-08-18 00:00:00	38000280	\N		0	0	0	0	208193	0	91934008	438614		
2116	3527	4219399	1962-03-24	1962-03-24 00:00:00	38000280	\N		0	0	0	0	234016	0	417532002	4219399		
45693	2715	4163874	2017-11-23	2017-11-23 00:00:00	38000276	\N		0	0	0	0	179971	0	399211009	4163874		
534	911	442116	1977-06-15	1977-06-15 00:00:00	38000280	\N		0	0	0	0	60471	0	91930004	442116		
2155	3603	4302207	1967-03-18	1967-03-18 00:00:00	38000280	\N		0	0	0	0	239372	0	418689008	4302207		
2253	3876	4048169	1971-06-17	1971-06-17 00:00:00	38000280	\N		0	0	0	0	257501	0	232350006	4048169		
50838	3007	4323208	1998-05-18	1998-05-18 00:00:00	38000276	\N		0	0	0	0	200604	0	428251008	4323208		
1647	2577	4304110	1973-10-04	1973-10-04 00:00:00	38000280	\N		0	0	0	0	170648	0	419474003	4304110		
1730	2661	442116	1965-11-17	1965-11-17 00:00:00	38000280	\N		0	0	0	0	176238	0	91930004	442116		
2703	4562	4302207	1961-08-14	1961-08-14 00:00:00	38000280	\N		0	0	0	0	304056	0	418689008	4302207		
2780	4739	442116	1910-07-04	1910-07-04 00:00:00	38000280	\N		0	0	0	0	315697	0	91930004	442116		
761	1261	433644	1971-07-22	1971-07-22 00:00:00	38000280	\N		0	0	0	0	83220	0	300913006	433644		
864	1399	4302207	1961-05-07	1961-05-07 00:00:00	38000280	\N		0	0	0	0	93041	0	418689008	4302207		
1839	2830	4169137	1975-06-22	1975-06-22 00:00:00	38000280	\N		0	0	0	0	187706	0	420174000	4169137		
1901	2959	4306014	1972-05-26	1972-05-26 00:00:00	38000280	\N		0	0	0	0	197581	0	419263009	4306014		
1286	1992	4304110	1978-04-17	1978-04-17 00:00:00	38000280	\N		0	0	0	0	132718	0	419474003	4304110		
1373	2173	433644	1931-07-19	1931-07-19 00:00:00	38000280	\N		0	0	0	0	144840	0	300913006	433644		
1534	2402	4306014	1977-11-19	1977-11-19 00:00:00	38000280	\N		0	0	0	0	159572	0	419263009	4306014		
2611	4373	4302207	1976-07-18	1976-07-18 00:00:00	38000280	\N		0	0	0	0	290341	0	418689008	4302207		
935	1486	439406	1956-01-16	1956-01-16 00:00:00	38000280	\N		0	0	0	0	99040	0	232347008	439406		
1009	1567	4240902	1975-10-07	1975-10-07 00:00:00	38000280	\N		0	0	0	0	105078	0	91935009	4240902		
202	408	4304110	1962-02-17	1962-02-17 00:00:00	38000280	\N		0	0	0	0	26962	0	419474003	4304110		
305	578	4306014	1968-01-16	1968-01-16 00:00:00	38000280	\N		0	0	0	0	38264	0	419263009	4306014		
616	1058	4306014	1956-02-15	1956-02-15 00:00:00	38000280	\N		0	0	0	0	69479	0	419263009	4306014		
667	1118	442116	1974-12-18	1974-12-18 00:00:00	38000280	\N		0	0	0	0	73669	0	91930004	442116		
1108	1773	439406	1952-08-07	1952-08-07 00:00:00	38000280	\N		0	0	0	0	118501	0	232347008	439406		
87423	5203	4163874	1999-02-17	1999-02-17 00:00:00	38000276	\N		0	0	0	0	346136	0	399211009	4163874		
25361	1511	4323208	2010-04-15	2010-04-15 00:00:00	38000276	\N		0	0	0	0	100876	0	428251008	4323208		
3092	5255	4304110	1961-05-27	1961-05-27 00:00:00	38000280	\N		0	0	0	0	349619	0	419474003	4304110		
3163	5337	4102123	1974-03-18	1974-03-18 00:00:00	38000280	\N		0	0	0	0	355447	0	300916003	4102123		
1987	3128	4219399	1973-08-18	1973-08-18 00:00:00	38000280	\N		0	0	0	0	208193	0	417532002	4219399		
2117	3528	4240902	1959-10-16	1959-10-16 00:00:00	38000280	\N		0	0	0	0	234260	0	91935009	4240902		
27539	1626	4324181	2010-10-10	2010-10-10 00:00:00	38000276	\N		0	0	0	0	109220	0	429007001	4324181		
535	911	4302207	1977-06-15	1977-06-15 00:00:00	38000280	\N		0	0	0	0	60471	0	418689008	4302207		
2156	3603	4306014	1967-03-18	1967-03-18 00:00:00	38000280	\N		0	0	0	0	239372	0	419263009	4306014		
2254	3876	4302207	1971-06-17	1971-06-17 00:00:00	38000280	\N		0	0	0	0	257501	0	418689008	4302207		
14206	841	4323208	1961-01-14	1961-01-14 00:00:00	38000276	\N		0	0	0	0	55546	0	428251008	4323208		
1648	2577	4240902	1973-10-04	1973-10-04 00:00:00	38000280	\N		0	0	0	0	170648	0	91935009	4240902		
1731	2661	4174876	1965-11-17	1965-11-17 00:00:00	38000280	\N		0	0	0	0	176238	0	424213003	4174876		
2704	4562	4048169	1961-08-14	1961-08-14 00:00:00	38000280	\N		0	0	0	0	304056	0	232350006	4048169		
2781	4745	4048169	1978-05-01	1978-05-01 00:00:00	38000280	\N		0	0	0	0	315993	0	232350006	4048169		
764	1272	4219399	1980-05-24	1980-05-24 00:00:00	38000280	\N		0	0	0	0	83864	0	417532002	4219399		
865	1399	439406	1961-05-07	1961-05-07 00:00:00	38000280	\N		0	0	0	0	93041	0	232347008	439406		
1840	2830	4302207	1975-06-22	1975-06-22 00:00:00	38000280	\N		0	0	0	0	187706	0	418689008	4302207		
1902	2959	4304110	1972-05-26	1972-05-26 00:00:00	38000280	\N		0	0	0	0	197581	0	419474003	4304110		
1309	2030	433644	1962-10-29	1962-10-29 00:00:00	38000280	\N		0	0	0	0	135115	0	300913006	433644		
1374	2173	439406	1931-07-19	1931-07-19 00:00:00	38000280	\N		0	0	0	0	144840	0	232347008	439406		
1535	2402	439406	1977-11-19	1977-11-19 00:00:00	38000280	\N		0	0	0	0	159572	0	232347008	439406		
2612	4373	439406	1976-07-18	1976-07-18 00:00:00	38000280	\N		0	0	0	0	290341	0	232347008	439406		
936	1486	4240902	1956-01-16	1956-01-16 00:00:00	38000280	\N		0	0	0	0	99040	0	91935009	4240902		
1010	1571	433644	1955-07-10	1955-07-10 00:00:00	38000280	\N		0	0	0	0	105478	0	300913006	433644		
203	409	37017711	1952-01-12	1952-01-12 00:00:00	38000280	\N		0	0	0	0	27086	0	714035009	37017711		
306	578	4219399	1968-01-16	1968-01-16 00:00:00	38000280	\N		0	0	0	0	38264	0	417532002	4219399		
17086	1022	4324181	2010-02-09	2010-02-09 00:00:00	38000276	\N		0	0	0	0	67211	0	429007001	4324181		
668	1118	4048169	1974-12-18	1974-12-18 00:00:00	38000280	\N		0	0	0	0	73669	0	232350006	4048169		
1109	1773	4169137	1952-08-07	1952-08-07 00:00:00	38000280	\N		0	0	0	0	118501	0	420174000	4169137		
50025	2955	4324181	2017-07-25	2017-07-25 00:00:00	38000276	\N		0	0	0	0	197252	0	429007001	4324181		
57701	3422	45766064	1978-12-16	1978-12-16 00:00:00	38000276	\N		0	0	0	0	226981	0	703151001	45766064		
3093	5255	433644	1961-05-27	1961-05-27 00:00:00	38000280	\N		0	0	0	0	349619	0	300913006	433644		
3164	5337	4304110	1974-03-18	1974-03-18 00:00:00	38000280	\N		0	0	0	0	355447	0	419474003	4304110		
1988	3128	4306014	1973-08-18	1973-08-18 00:00:00	38000280	\N		0	0	0	0	208193	0	419263009	4306014		
2118	3529	4304110	1949-05-23	1949-05-23 00:00:00	38000280	\N		0	0	0	0	234301	0	419474003	4304110		
62180	3672	4323208	1986-03-13	1986-03-13 00:00:00	38000276	\N		0	0	0	0	244325	0	428251008	4323208		
537	917	433644	1964-02-25	1964-02-25 00:00:00	38000280	\N		0	0	0	0	61041	0	300913006	433644		
2157	3603	4304110	1967-03-18	1967-03-18 00:00:00	38000280	\N		0	0	0	0	239372	0	419474003	4304110		
2255	3876	439406	1971-06-17	1971-06-17 00:00:00	38000280	\N		0	0	0	0	257501	0	232347008	439406		
1649	2577	4174876	1973-10-04	1973-10-04 00:00:00	38000280	\N		0	0	0	0	170648	0	424213003	4174876		
1732	2661	439406	1965-11-17	1965-11-17 00:00:00	38000280	\N		0	0	0	0	176238	0	232347008	439406		
2705	4562	433644	1961-08-14	1961-08-14 00:00:00	38000280	\N		0	0	0	0	304056	0	300913006	433644		
2782	4745	4302207	1978-05-01	1978-05-01 00:00:00	38000280	\N		0	0	0	0	315993	0	418689008	4302207		
765	1276	4169137	1958-05-18	1958-05-18 00:00:00	38000280	\N		0	0	0	0	84271	0	420174000	4169137		
866	1399	4102123	1961-05-07	1961-05-07 00:00:00	38000280	\N		0	0	0	0	93041	0	300916003	4102123		
1846	2858	4169137	1911-03-02	1911-03-02 00:00:00	38000280	\N		0	0	0	0	189820	0	420174000	4169137		
1903	2959	438614	1972-05-26	1972-05-26 00:00:00	38000280	\N		0	0	0	0	197581	0	91934008	438614		
1310	2058	438614	1967-09-01	1967-09-01 00:00:00	38000280	\N		0	0	0	0	136840	0	91934008	438614		
1375	2175	4304110	2009-02-17	2009-02-17 00:00:00	38000280	\N		0	0	0	0	145012	0	419474003	4304110		
1536	2402	4174876	1977-11-19	1977-11-19 00:00:00	38000280	\N		0	0	0	0	159572	0	424213003	4174876		
2613	4373	4174876	1976-07-18	1976-07-18 00:00:00	38000280	\N		0	0	0	0	290341	0	424213003	4174876		
937	1486	4304110	1956-01-16	1956-01-16 00:00:00	38000280	\N		0	0	0	0	99040	0	419474003	4304110		
1011	1597	433644	1945-05-09	1945-05-09 00:00:00	38000280	\N		0	0	0	0	107123	0	300913006	433644		
204	409	439406	1952-01-12	1952-01-12 00:00:00	38000280	\N		0	0	0	0	27086	0	232347008	439406		
307	578	4302207	1968-01-16	1968-01-16 00:00:00	38000280	\N		0	0	0	0	38264	0	418689008	4302207		
31705	1878	4323208	2004-03-09	2004-03-09 00:00:00	38000276	\N		0	0	0	0	125350	0	428251008	4323208		
669	1118	4302207	1974-12-18	1974-12-18 00:00:00	38000280	\N		0	0	0	0	73669	0	418689008	4302207		
1110	1773	4240902	1952-08-07	1952-08-07 00:00:00	38000280	\N		0	0	0	0	118501	0	91935009	4240902		
13943	823	4323208	1977-11-14	1977-11-14 00:00:00	38000276	\N		0	0	0	0	54560	0	428251008	4323208		
57706	3422	4324181	1973-11-12	1973-11-12 00:00:00	38000276	\N		0	0	0	0	226979	0	429007001	4324181		
3121	5290	4302207	1955-02-12	1955-02-12 00:00:00	38000280	\N		0	0	0	0	351966	0	418689008	4302207		
3165	5337	4048169	1974-03-18	1974-03-18 00:00:00	38000280	\N		0	0	0	0	355447	0	232350006	4048169		
1989	3128	4302207	1973-08-18	1973-08-18 00:00:00	38000280	\N		0	0	0	0	208193	0	418689008	4302207		
2119	3536	4219399	1964-05-17	1964-05-17 00:00:00	38000280	\N		0	0	0	0	234847	0	417532002	4219399		
444	829	442116	1974-06-29	1974-06-29 00:00:00	38000280	\N		0	0	0	0	54904	0	91930004	442116		
51146	3028	4323208	1978-04-19	1978-04-19 00:00:00	38000276	\N		0	0	0	0	201862	0	428251008	4323208		
2158	3603	4240902	1967-03-18	1967-03-18 00:00:00	38000280	\N		0	0	0	0	239372	0	91935009	4240902		
2256	3876	4174876	1971-06-17	1971-06-17 00:00:00	38000280	\N		0	0	0	0	257501	0	424213003	4174876		
1650	2577	439406	1973-10-04	1973-10-04 00:00:00	38000280	\N		0	0	0	0	170648	0	232347008	439406		
1733	2661	4169137	1965-11-17	1965-11-17 00:00:00	38000280	\N		0	0	0	0	176238	0	420174000	4169137		
2724	4608	442116	1956-05-18	1956-05-18 00:00:00	38000280	\N		0	0	0	0	306933	0	91930004	442116		
2783	4745	439406	1978-05-01	1978-05-01 00:00:00	38000280	\N		0	0	0	0	315993	0	232347008	439406		
767	1282	4302207	1977-08-12	1977-08-12 00:00:00	38000280	\N		0	0	0	0	84719	0	418689008	4302207		
867	1399	4304110	1961-05-07	1961-05-07 00:00:00	38000280	\N		0	0	0	0	93041	0	419474003	4304110		
1847	2863	439406	1966-10-08	1966-10-08 00:00:00	38000280	\N		0	0	0	0	190425	0	232347008	439406		
1904	2959	4240902	1972-05-26	1972-05-26 00:00:00	38000280	\N		0	0	0	0	197581	0	91935009	4240902		
1311	2058	433644	1967-09-01	1967-09-01 00:00:00	38000280	\N		0	0	0	0	136840	0	300913006	433644		
1388	2189	4304110	2010-02-17	2010-02-17 00:00:00	38000280	\N		0	0	0	0	145893	0	419474003	4304110		
1537	2402	433644	1977-11-19	1977-11-19 00:00:00	38000280	\N		0	0	0	0	159572	0	300913006	433644		
2614	4373	4306014	1976-07-18	1976-07-18 00:00:00	38000280	\N		0	0	0	0	290341	0	419263009	4306014		
938	1486	4219399	1956-01-16	1956-01-16 00:00:00	38000280	\N		0	0	0	0	99040	0	417532002	4219399		
1012	1609	433644	1944-07-30	1944-07-30 00:00:00	38000280	\N		0	0	0	0	108177	0	300913006	433644		
205	409	4304110	1952-01-12	1952-01-12 00:00:00	38000280	\N		0	0	0	0	27086	0	419474003	4304110		
308	578	4048169	1968-01-16	1968-01-16 00:00:00	38000280	\N		0	0	0	0	38264	0	232350006	4048169		
12126	718	4324181	1974-10-19	1974-10-19 00:00:00	38000276	\N		0	0	0	0	47525	0	429007001	4324181		
670	1118	439406	1974-12-18	1974-12-18 00:00:00	38000280	\N		0	0	0	0	73669	0	232347008	439406		
1111	1773	4304110	1952-08-07	1952-08-07 00:00:00	38000280	\N		0	0	0	0	118501	0	419474003	4304110		
34987	2077	4324181	2005-08-21	2005-08-21 00:00:00	38000276	\N		0	0	0	0	138380	0	429007001	4324181		
57738	3423	4323208	2007-03-14	2007-03-14 00:00:00	38000276	\N		0	0	0	0	227090	0	428251008	4323208		
3122	5290	4048169	1955-02-12	1955-02-12 00:00:00	38000280	\N		0	0	0	0	351966	0	232350006	4048169		
3166	5337	4302207	1974-03-18	1974-03-18 00:00:00	38000280	\N		0	0	0	0	355447	0	418689008	4302207		
1990	3128	4048169	1973-08-18	1973-08-18 00:00:00	38000280	\N		0	0	0	0	208193	0	232350006	4048169		
2120	3537	4306014	1962-01-12	1962-01-12 00:00:00	38000280	\N		0	0	0	0	234962	0	419263009	4306014		
445	841	433644	1952-10-25	1952-10-25 00:00:00	38000280	\N		0	0	0	0	55518	0	300913006	433644		
6708	395	45766064	1972-02-13	1972-02-13 00:00:00	38000276	\N		0	0	0	0	25938	0	703151001	45766064		
2159	3603	439406	1967-03-18	1967-03-18 00:00:00	38000280	\N		0	0	0	0	239372	0	232347008	439406		
2257	3876	4306014	1971-06-17	1971-06-17 00:00:00	38000280	\N		0	0	0	0	257501	0	419263009	4306014		
1660	2586	4174876	1969-10-10	1969-10-10 00:00:00	38000280	\N		0	0	0	0	171125	0	424213003	4174876		
1734	2661	4304110	1965-11-17	1965-11-17 00:00:00	38000280	\N		0	0	0	0	176238	0	419474003	4304110		
2733	4623	439406	1955-06-06	1955-06-06 00:00:00	38000280	\N		0	0	0	0	307861	0	232347008	439406		
2784	4745	4304110	1978-05-01	1978-05-01 00:00:00	38000280	\N		0	0	0	0	315993	0	419474003	4304110		
768	1282	4048169	1977-08-12	1977-08-12 00:00:00	38000280	\N		0	0	0	0	84719	0	232350006	4048169		
868	1399	4306014	1961-05-07	1961-05-07 00:00:00	38000280	\N		0	0	0	0	93041	0	419263009	4306014		
1858	2882	433644	1973-07-16	1973-07-16 00:00:00	38000280	\N		0	0	0	0	191697	0	300913006	433644		
1905	2959	4302207	1972-05-26	1972-05-26 00:00:00	38000280	\N		0	0	0	0	197581	0	418689008	4302207		
1312	2070	439406	1969-11-20	1969-11-20 00:00:00	38000280	\N		0	0	0	0	137742	0	232347008	439406		
1403	2213	439406	1991-08-01	1991-08-01 00:00:00	38000280	\N		0	0	0	0	147361	0	232347008	439406		
1546	2419	442116	1945-10-02	1945-10-02 00:00:00	38000280	\N		0	0	0	0	160627	0	91930004	442116		
2615	4373	4304110	1976-07-18	1976-07-18 00:00:00	38000280	\N		0	0	0	0	290341	0	419474003	4304110		
939	1486	4306014	1956-01-16	1956-01-16 00:00:00	38000280	\N		0	0	0	0	99040	0	419263009	4306014		
1020	1612	433644	1964-04-08	1964-04-08 00:00:00	38000280	\N		0	0	0	0	108374	0	300913006	433644		
206	409	4306014	1952-01-12	1952-01-12 00:00:00	38000280	\N		0	0	0	0	27086	0	419263009	4306014		
309	578	433644	1968-01-16	1968-01-16 00:00:00	38000280	\N		0	0	0	0	38264	0	300913006	433644		
12584	744	4323208	2004-03-17	2004-03-17 00:00:00	38000276	\N		0	0	0	0	49371	0	428251008	4323208		
671	1118	4304110	1974-12-18	1974-12-18 00:00:00	38000280	\N		0	0	0	0	73669	0	419474003	4304110		
1112	1773	4302207	1952-08-07	1952-08-07 00:00:00	38000280	\N		0	0	0	0	118501	0	418689008	4302207		
40005	2372	4323208	1967-04-02	1967-04-02 00:00:00	38000276	\N		0	0	0	0	157859	0	428251008	4323208		
35041	2079	4323208	1956-12-17	1956-12-17 00:00:00	38000276	\N		0	0	0	0	138476	0	428251008	4323208		
3123	5290	4139681	1955-02-12	1955-02-12 00:00:00	38000280	\N		0	0	0	0	351966	0	425525006	4139681		
3178	5343	4174876	1984-05-11	1984-05-11 00:00:00	38000280	\N		0	0	0	0	355857	0	424213003	4174876		
1992	3181	4048169	1952-05-27	1952-05-27 00:00:00	38000280	\N		0	0	0	0	211693	0	232350006	4048169		
2121	3537	4240902	1962-01-12	1962-01-12 00:00:00	38000280	\N		0	0	0	0	234962	0	91935009	4240902		
446	841	4048169	1952-10-25	1952-10-25 00:00:00	38000280	\N		0	0	0	0	55518	0	232350006	4048169		
6736	398	4163874	1967-02-11	1967-02-11 00:00:00	38000276	\N		0	0	0	0	26071	0	399211009	4163874		
2160	3604	4302207	1984-12-12	1984-12-12 00:00:00	38000280	\N		0	0	0	0	239520	0	418689008	4302207		
2258	3876	4304110	1971-06-17	1971-06-17 00:00:00	38000280	\N		0	0	0	0	257501	0	419474003	4304110		
1661	2586	439406	1969-10-10	1969-10-10 00:00:00	38000280	\N		0	0	0	0	171125	0	232347008	439406		
1735	2661	438614	1965-11-17	1965-11-17 00:00:00	38000280	\N		0	0	0	0	176238	0	91934008	438614		
2734	4626	4304110	1997-11-21	1997-11-21 00:00:00	38000280	\N		0	0	0	0	308259	0	419474003	4304110		
2785	4745	4306014	1978-05-01	1978-05-01 00:00:00	38000280	\N		0	0	0	0	315993	0	419263009	4306014		
769	1282	4240902	1977-08-12	1977-08-12 00:00:00	38000280	\N		0	0	0	0	84719	0	91935009	4240902		
870	1407	4219399	1969-02-19	1969-02-19 00:00:00	38000280	\N		0	0	0	0	93534	0	417532002	4219399		
1859	2882	4102123	1973-07-16	1973-07-16 00:00:00	38000280	\N		0	0	0	0	191697	0	300916003	4102123		
1906	2965	4048169	1972-03-23	1972-03-23 00:00:00	38000280	\N		0	0	0	0	198002	0	232350006	4048169		
1313	2075	4048169	1967-05-03	1967-05-03 00:00:00	38000280	\N		0	0	0	0	138116	0	232350006	4048169		
1406	2218	433644	1979-03-30	1979-03-30 00:00:00	38000280	\N		0	0	0	0	147700	0	300913006	433644		
1572	2462	4139681	1962-11-12	1962-11-12 00:00:00	38000280	\N		0	0	0	0	163230	0	425525006	4139681		
2616	4373	4219399	1976-07-18	1976-07-18 00:00:00	38000280	\N		0	0	0	0	290341	0	417532002	4219399		
940	1486	4302207	1956-01-16	1956-01-16 00:00:00	38000280	\N		0	0	0	0	99040	0	418689008	4302207		
33444	1982	4163874	2006-10-19	2006-10-19 00:00:00	38000276	\N		0	0	0	0	131963	0	399211009	4163874		
207	409	4102123	1952-01-12	1952-01-12 00:00:00	38000280	\N		0	0	0	0	27086	0	300916003	4102123		
318	601	4219399	1971-03-26	1971-03-26 00:00:00	38000280	\N		0	0	0	0	39732	0	417532002	4219399		
1396	81	4323208	1984-03-15	1984-03-15 00:00:00	38000276	\N		0	0	0	0	5509	0	428251008	4323208		
672	1118	4219399	1974-12-18	1974-12-18 00:00:00	38000280	\N		0	0	0	0	73669	0	417532002	4219399		
1121	1779	4048169	1944-01-28	1944-01-28 00:00:00	38000280	\N		0	0	0	0	119011	0	232350006	4048169		
35559	2108	4323208	1978-08-31	1978-08-31 00:00:00	38000276	\N		0	0	0	0	140300	0	428251008	4323208		
3124	5290	4304110	1955-02-12	1955-02-12 00:00:00	38000280	\N		0	0	0	0	351966	0	419474003	4304110		
3179	5343	439406	1984-05-11	1984-05-11 00:00:00	38000280	\N		0	0	0	0	355857	0	232347008	439406		
1993	3181	4302207	1952-05-27	1952-05-27 00:00:00	38000280	\N		0	0	0	0	211693	0	418689008	4302207		
2122	3537	4304110	1962-01-12	1962-01-12 00:00:00	38000280	\N		0	0	0	0	234962	0	419474003	4304110		
447	841	4304110	1952-10-25	1952-10-25 00:00:00	38000280	\N		0	0	0	0	55518	0	419474003	4304110		
2161	3604	4048169	1984-12-12	1984-12-12 00:00:00	38000280	\N		0	0	0	0	239520	0	232350006	4048169		
2259	3879	4304110	1965-12-29	1965-12-29 00:00:00	38000280	\N		0	0	0	0	257731	0	419474003	4304110		
1662	2586	4240902	1969-10-10	1969-10-10 00:00:00	38000280	\N		0	0	0	0	171125	0	91935009	4240902		
1736	2661	4102123	1965-11-17	1965-11-17 00:00:00	38000280	\N		0	0	0	0	176238	0	300916003	4102123		
2735	4628	439406	1986-10-24	1986-10-24 00:00:00	38000280	\N		0	0	0	0	308311	0	232347008	439406		
2786	4745	4102123	1978-05-01	1978-05-01 00:00:00	38000280	\N		0	0	0	0	315993	0	300916003	4102123		
770	1282	4304110	1977-08-12	1977-08-12 00:00:00	38000280	\N		0	0	0	0	84719	0	419474003	4304110		
21203	1272	4324181	1991-08-30	1991-08-30 00:00:00	38000276	\N		0	0	0	0	83860	0	429007001	4324181		
1860	2882	4306014	1973-07-16	1973-07-16 00:00:00	38000280	\N		0	0	0	0	191697	0	419263009	4306014		
1907	2966	433644	1963-01-17	1963-01-17 00:00:00	38000280	\N		0	0	0	0	198129	0	300913006	433644		
1314	2075	4139681	1967-05-03	1967-05-03 00:00:00	38000280	\N		0	0	0	0	138116	0	425525006	4139681		
1407	2218	4302207	1979-03-30	1979-03-30 00:00:00	38000280	\N		0	0	0	0	147700	0	418689008	4302207		
1588	2477	4306014	1956-01-07	1956-01-07 00:00:00	38000280	\N		0	0	0	0	164150	0	419263009	4306014		
2617	4373	438614	1976-07-18	1976-07-18 00:00:00	38000280	\N		0	0	0	0	290341	0	91934008	438614		
941	1486	4139681	1956-01-16	1956-01-16 00:00:00	38000280	\N		0	0	0	0	99040	0	425525006	4139681		
83208	4943	45766064	1962-02-01	1962-02-01 00:00:00	38000276	\N		0	0	0	0	328618	0	703151001	45766064		
208	409	4048169	1952-01-12	1952-01-12 00:00:00	38000280	\N		0	0	0	0	27086	0	232350006	4048169		
324	603	433644	1957-05-16	1957-05-16 00:00:00	38000280	\N		0	0	0	0	39906	0	300913006	433644		
1419	82	45766064	1973-03-18	1973-03-18 00:00:00	38000276	\N		0	0	0	0	5570	0	703151001	45766064		
673	1118	4306014	1974-12-18	1974-12-18 00:00:00	38000280	\N		0	0	0	0	73669	0	419263009	4306014		
1122	1779	4302207	1944-01-28	1944-01-28 00:00:00	38000280	\N		0	0	0	0	119011	0	418689008	4302207		
4530	264	4163874	2011-11-11	2011-11-11 00:00:00	38000276	\N		0	0	0	0	17590	0	399211009	4163874		
3125	5290	4306014	1955-02-12	1955-02-12 00:00:00	38000280	\N		0	0	0	0	351966	0	419263009	4306014		
3180	5343	4048169	1984-05-11	1984-05-11 00:00:00	38000280	\N		0	0	0	0	355857	0	232350006	4048169		
1994	3181	439406	1952-05-27	1952-05-27 00:00:00	38000280	\N		0	0	0	0	211693	0	232347008	439406		
2123	3537	439406	1962-01-12	1962-01-12 00:00:00	38000280	\N		0	0	0	0	234962	0	232347008	439406		
448	841	4240902	1952-10-25	1952-10-25 00:00:00	38000280	\N		0	0	0	0	55518	0	91935009	4240902		
2162	3604	4219399	1984-12-12	1984-12-12 00:00:00	38000280	\N		0	0	0	0	239520	0	417532002	4219399		
2260	3879	4174876	1965-12-29	1965-12-29 00:00:00	38000280	\N		0	0	0	0	257731	0	424213003	4174876		
1663	2586	4304110	1969-10-10	1969-10-10 00:00:00	38000280	\N		0	0	0	0	171125	0	419474003	4304110		
1737	2661	4306014	1965-11-17	1965-11-17 00:00:00	38000280	\N		0	0	0	0	176238	0	419263009	4306014		
2736	4628	4306014	1986-10-24	1986-10-24 00:00:00	38000280	\N		0	0	0	0	308311	0	419263009	4306014		
2787	4761	4302207	1984-05-29	1984-05-29 00:00:00	38000280	\N		0	0	0	0	317259	0	418689008	4302207		
771	1282	4306014	1977-08-12	1977-08-12 00:00:00	38000280	\N		0	0	0	0	84719	0	419263009	4306014		
21272	1276	45766064	1968-03-05	1968-03-05 00:00:00	38000276	\N		0	0	0	0	84132	0	703151001	45766064		
1861	2882	4304110	1973-07-16	1973-07-16 00:00:00	38000280	\N		0	0	0	0	191697	0	419474003	4304110		
1916	2970	4304110	1999-05-06	1999-05-06 00:00:00	38000280	\N		0	0	0	0	198331	0	419474003	4304110		
1315	2075	4302207	1967-05-03	1967-05-03 00:00:00	38000280	\N		0	0	0	0	138116	0	418689008	4302207		
1408	2218	4048169	1979-03-30	1979-03-30 00:00:00	38000280	\N		0	0	0	0	147700	0	232350006	4048169		
1589	2477	4304110	1956-01-07	1956-01-07 00:00:00	38000280	\N		0	0	0	0	164150	0	419474003	4304110		
2618	4384	433644	1968-09-21	1968-09-21 00:00:00	38000280	\N		0	0	0	0	291369	0	300913006	433644		
948	1497	433644	1941-05-28	1941-05-28 00:00:00	38000280	\N		0	0	0	0	99763	0	300913006	433644		
84069	4992	4323208	2007-05-12	2007-05-12 00:00:00	38000276	\N		0	0	0	0	332122	0	428251008	4323208		
209	409	4302207	1952-01-12	1952-01-12 00:00:00	38000280	\N		0	0	0	0	27086	0	418689008	4302207		
325	605	4304110	1959-07-16	1959-07-16 00:00:00	38000280	\N		0	0	0	0	40152	0	419474003	4304110		
27166	1605	4324181	2019-05-12	2019-05-12 00:00:00	38000276	\N		0	0	0	0	107753	0	429007001	4324181		
681	1138	4302207	1985-02-26	1985-02-26 00:00:00	38000280	\N		0	0	0	0	75060	0	418689008	4302207		
1123	1779	439406	1944-01-28	1944-01-28 00:00:00	38000280	\N		0	0	0	0	119011	0	232347008	439406		
27872	1646	4323208	1982-11-22	1982-11-22 00:00:00	38000276	\N		0	0	0	0	110393	0	428251008	4323208		
3126	5290	4240902	1955-02-12	1955-02-12 00:00:00	38000280	\N		0	0	0	0	351966	0	91935009	4240902		
3181	5343	4302207	1984-05-11	1984-05-11 00:00:00	38000280	\N		0	0	0	0	355857	0	418689008	4302207		
1995	3181	4304110	1952-05-27	1952-05-27 00:00:00	38000280	\N		0	0	0	0	211693	0	419474003	4304110		
2124	3537	37017711	1962-01-12	1962-01-12 00:00:00	38000280	\N		0	0	0	0	234962	0	714035009	37017711		
449	841	4306014	1952-10-25	1952-10-25 00:00:00	38000280	\N		0	0	0	0	55518	0	419263009	4306014		
2163	3604	438614	1984-12-12	1984-12-12 00:00:00	38000280	\N		0	0	0	0	239520	0	91934008	438614		
2269	3891	4048169	1983-11-05	1983-11-05 00:00:00	38000280	\N		0	0	0	0	258719	0	232350006	4048169		
1664	2586	4306014	1969-10-10	1969-10-10 00:00:00	38000280	\N		0	0	0	0	171125	0	419263009	4306014		
1738	2663	433644	1964-09-07	1964-09-07 00:00:00	38000280	\N		0	0	0	0	176441	0	300913006	433644		
2737	4633	433644	1959-12-30	1959-12-30 00:00:00	38000280	\N		0	0	0	0	308745	0	300913006	433644		
2788	4761	439406	1984-05-29	1984-05-29 00:00:00	38000280	\N		0	0	0	0	317259	0	232347008	439406		
772	1282	439406	1977-08-12	1977-08-12 00:00:00	38000280	\N		0	0	0	0	84719	0	232347008	439406		
1862	2882	439406	1973-07-16	1973-07-16 00:00:00	38000280	\N		0	0	0	0	191697	0	232347008	439406		
1923	2975	433644	1962-12-22	1962-12-22 00:00:00	38000280	\N		0	0	0	0	198605	0	300913006	433644		
1316	2075	442116	1967-05-03	1967-05-03 00:00:00	38000280	\N		0	0	0	0	138116	0	91930004	442116		
1409	2218	4139681	1979-03-30	1979-03-30 00:00:00	38000280	\N		0	0	0	0	147700	0	425525006	4139681		
1590	2477	4102123	1956-01-07	1956-01-07 00:00:00	38000280	\N		0	0	0	0	164150	0	300916003	4102123		
2620	4390	438614	1960-06-15	1960-06-15 00:00:00	38000280	\N		0	0	0	0	291811	0	91934008	438614		
961	1513	433644	1968-12-04	1968-12-04 00:00:00	38000280	\N		0	0	0	0	101063	0	300913006	433644		
51876	3076	4324181	1952-11-26	1952-11-26 00:00:00	38000276	\N		0	0	0	0	204704	0	429007001	4324181		
210	411	4174876	1961-03-22	1961-03-22 00:00:00	38000280	\N		0	0	0	0	27252	0	424213003	4174876		
326	615	439406	1911-03-27	1911-03-27 00:00:00	38000280	\N		0	0	0	0	40932	0	232347008	439406		
2494	4217	4139681	1959-08-20	1959-08-20 00:00:00	38000280	\N		0	0	0	0	279962	0	425525006	4139681		
693	1154	4240902	1971-03-15	1971-03-15 00:00:00	38000280	\N		0	0	0	0	76254	0	91935009	4240902		
1124	1779	4174876	1944-01-28	1944-01-28 00:00:00	38000280	\N		0	0	0	0	119011	0	424213003	4174876		
46438	2765	4323208	1994-05-08	1994-05-08 00:00:00	38000276	\N		0	0	0	0	182873	0	428251008	4323208		
3182	5343	442116	1984-05-11	1984-05-11 00:00:00	38000280	\N		0	0	0	0	355857	0	91930004	442116		
1996	3181	4306014	1952-05-27	1952-05-27 00:00:00	38000280	\N		0	0	0	0	211693	0	419263009	4306014		
2125	3537	4048169	1962-01-12	1962-01-12 00:00:00	38000280	\N		0	0	0	0	234962	0	232350006	4048169		
450	841	439406	1952-10-25	1952-10-25 00:00:00	38000280	\N		0	0	0	0	55518	0	232347008	439406		
2164	3604	4304110	1984-12-12	1984-12-12 00:00:00	38000280	\N		0	0	0	0	239520	0	419474003	4304110		
2270	3891	4302207	1983-11-05	1983-11-05 00:00:00	38000280	\N		0	0	0	0	258719	0	418689008	4302207		
1665	2586	438614	1969-10-10	1969-10-10 00:00:00	38000280	\N		0	0	0	0	171125	0	91934008	438614		
1739	2672	4219399	1951-08-06	1951-08-06 00:00:00	38000280	\N		0	0	0	0	177013	0	417532002	4219399		
2738	4633	4048169	1959-12-30	1959-12-30 00:00:00	38000280	\N		0	0	0	0	308745	0	232350006	4048169		
2789	4761	4174876	1984-05-29	1984-05-29 00:00:00	38000280	\N		0	0	0	0	317259	0	424213003	4174876		
773	1285	433644	1954-09-29	1954-09-29 00:00:00	38000280	\N		0	0	0	0	84973	0	300913006	433644		
1863	2882	4302207	1973-07-16	1973-07-16 00:00:00	38000280	\N		0	0	0	0	191697	0	418689008	4302207		
1924	2976	4306014	1956-07-29	1956-07-29 00:00:00	38000280	\N		0	0	0	0	198743	0	419263009	4306014		
1317	2075	439406	1967-05-03	1967-05-03 00:00:00	38000280	\N		0	0	0	0	138116	0	232347008	439406		
1410	2218	442116	1979-03-30	1979-03-30 00:00:00	38000280	\N		0	0	0	0	147700	0	91930004	442116		
1591	2477	4174876	1956-01-07	1956-01-07 00:00:00	38000280	\N		0	0	0	0	164150	0	424213003	4174876		
2621	4412	4240902	1964-10-05	1964-10-05 00:00:00	38000280	\N		0	0	0	0	293274	0	91935009	4240902		
976	1536	4139681	1912-11-06	1912-11-06 00:00:00	38000280	\N		0	0	0	0	102813	0	425525006	4139681		
211	411	4304110	1961-03-22	1961-03-22 00:00:00	38000280	\N		0	0	0	0	27252	0	419474003	4304110		
327	615	438614	1911-03-27	1911-03-27 00:00:00	38000280	\N		0	0	0	0	40932	0	91934008	438614		
2495	4217	442116	1959-08-20	1959-08-20 00:00:00	38000280	\N		0	0	0	0	279962	0	91930004	442116		
703	1176	4302207	1963-10-28	1963-10-28 00:00:00	38000280	\N		0	0	0	0	77625	0	418689008	4302207		
1125	1779	4240902	1944-01-28	1944-01-28 00:00:00	38000280	\N		0	0	0	0	119011	0	91935009	4240902		
21826	1310	45766064	2013-02-11	2013-02-11 00:00:00	38000276	\N		0	0	0	0	86679	0	703151001	45766064		
3183	5343	4306014	1984-05-11	1984-05-11 00:00:00	38000280	\N		0	0	0	0	355857	0	419263009	4306014		
1997	3181	438614	1952-05-27	1952-05-27 00:00:00	38000280	\N		0	0	0	0	211693	0	91934008	438614		
2126	3537	4302207	1962-01-12	1962-01-12 00:00:00	38000280	\N		0	0	0	0	234962	0	418689008	4302207		
451	843	439406	1983-05-08	1983-05-08 00:00:00	38000280	\N		0	0	0	0	55804	0	232347008	439406		
2165	3604	439406	1984-12-12	1984-12-12 00:00:00	38000280	\N		0	0	0	0	239520	0	232347008	439406		
2271	3891	4139681	1983-11-05	1983-11-05 00:00:00	38000280	\N		0	0	0	0	258719	0	425525006	4139681		
1666	2586	4302207	1969-10-10	1969-10-10 00:00:00	38000280	\N		0	0	0	0	171125	0	418689008	4302207		
1771	2711	4048169	1951-01-10	1951-01-10 00:00:00	38000280	\N		0	0	0	0	179635	0	232350006	4048169		
2741	4642	4139681	1953-09-03	1953-09-03 00:00:00	38000280	\N		0	0	0	0	309354	0	425525006	4139681		
2790	4761	4304110	1984-05-29	1984-05-29 00:00:00	38000280	\N		0	0	0	0	317259	0	419474003	4304110		
776	1292	4306014	1951-02-24	1951-02-24 00:00:00	38000280	\N		0	0	0	0	85380	0	419263009	4306014		
1864	2882	442116	1973-07-16	1973-07-16 00:00:00	38000280	\N		0	0	0	0	191697	0	91930004	442116		
1925	2976	4302207	1956-07-29	1956-07-29 00:00:00	38000280	\N		0	0	0	0	198743	0	418689008	4302207		
1318	2075	4174876	1967-05-03	1967-05-03 00:00:00	38000280	\N		0	0	0	0	138116	0	424213003	4174876		
1411	2218	4306014	1979-03-30	1979-03-30 00:00:00	38000280	\N		0	0	0	0	147700	0	419263009	4306014		
1592	2477	37017711	1956-01-07	1956-01-07 00:00:00	38000280	\N		0	0	0	0	164150	0	714035009	37017711		
2660	4452	433644	1955-12-15	1955-12-15 00:00:00	38000280	\N		0	0	0	0	296243	0	300913006	433644		
977	1538	4304110	1932-07-02	1932-07-02 00:00:00	38000280	\N		0	0	0	0	102949	0	419474003	4304110		
214	442	439406	1980-09-11	1980-09-11 00:00:00	38000280	\N		0	0	0	0	29313	0	232347008	439406		
342	655	433644	1961-01-19	1961-01-19 00:00:00	38000280	\N		0	0	0	0	43411	0	300913006	433644		
2496	4217	4302207	1959-08-20	1959-08-20 00:00:00	38000280	\N		0	0	0	0	279962	0	418689008	4302207		
12683	752	4324181	1979-02-04	1979-02-04 00:00:00	38000276	\N		0	0	0	0	49640	0	429007001	4324181		
1126	1779	4304110	1944-01-28	1944-01-28 00:00:00	38000280	\N		0	0	0	0	119011	0	419474003	4304110		
4584	268	4323208	1989-02-16	1989-02-16 00:00:00	38000276	\N		0	0	0	0	17779	0	428251008	4323208		
3184	5343	4304110	1984-05-11	1984-05-11 00:00:00	38000280	\N		0	0	0	0	355857	0	419474003	4304110		
1998	3183	433644	1981-08-20	1981-08-20 00:00:00	38000280	\N		0	0	0	0	211895	0	300913006	433644		
2127	3566	439406	1953-08-21	1953-08-21 00:00:00	38000280	\N		0	0	0	0	236806	0	232347008	439406		
452	843	4169137	1983-05-08	1983-05-08 00:00:00	38000280	\N		0	0	0	0	55804	0	420174000	4169137		
2166	3604	4174876	1984-12-12	1984-12-12 00:00:00	38000280	\N		0	0	0	0	239520	0	424213003	4174876		
2272	3891	4304110	1983-11-05	1983-11-05 00:00:00	38000280	\N		0	0	0	0	258719	0	419474003	4304110		
1667	2586	4048169	1969-10-10	1969-10-10 00:00:00	38000280	\N		0	0	0	0	171125	0	232350006	4048169		
1772	2711	4302207	1951-01-10	1951-01-10 00:00:00	38000280	\N		0	0	0	0	179635	0	418689008	4302207		
2742	4642	4302207	1953-09-03	1953-09-03 00:00:00	38000280	\N		0	0	0	0	309354	0	418689008	4302207		
2791	4761	4306014	1984-05-29	1984-05-29 00:00:00	38000280	\N		0	0	0	0	317259	0	419263009	4306014		
777	1292	4304110	1951-02-24	1951-02-24 00:00:00	38000280	\N		0	0	0	0	85380	0	419474003	4304110		
1865	2882	4048169	1973-07-16	1973-07-16 00:00:00	38000280	\N		0	0	0	0	191697	0	232350006	4048169		
1926	2976	442116	1956-07-29	1956-07-29 00:00:00	38000280	\N		0	0	0	0	198743	0	91930004	442116		
1319	2075	4306014	1967-05-03	1967-05-03 00:00:00	38000280	\N		0	0	0	0	138116	0	419263009	4306014		
1412	2218	4304110	1979-03-30	1979-03-30 00:00:00	38000280	\N		0	0	0	0	147700	0	419474003	4304110		
1593	2477	439406	1956-01-07	1956-01-07 00:00:00	38000280	\N		0	0	0	0	164150	0	232347008	439406		
2661	4452	439406	1955-12-15	1955-12-15 00:00:00	38000280	\N		0	0	0	0	296243	0	232347008	439406		
51829	3072	4324181	1964-02-01	1964-02-01 00:00:00	38000276	\N		0	0	0	0	204459	0	429007001	4324181		
215	442	4304110	1980-09-11	1980-09-11 00:00:00	38000280	\N		0	0	0	0	29313	0	419474003	4304110		
17039	1017	45766064	1970-06-12	1970-06-12 00:00:00	38000276	\N		0	0	0	0	67002	0	703151001	45766064		
2497	4217	4219399	1959-08-20	1959-08-20 00:00:00	38000280	\N		0	0	0	0	279962	0	417532002	4219399		
38511	2287	4163874	2001-01-26	2001-01-26 00:00:00	38000276	\N		0	0	0	0	152152	0	399211009	4163874		
1127	1779	4306014	1944-01-28	1944-01-28 00:00:00	38000280	\N		0	0	0	0	119011	0	419263009	4306014		
4605	270	4324181	2012-06-05	2012-06-05 00:00:00	38000276	\N		0	0	0	0	18027	0	429007001	4324181		
305	16	45766064	1983-10-10	1983-10-10 00:00:00	38000276	\N		0	0	0	0	1163	0	703151001	45766064		
2003	3194	4102123	1968-07-04	1968-07-04 00:00:00	38000280	\N		0	0	0	0	212463	0	300916003	4102123		
2128	3571	439406	1972-12-29	1972-12-29 00:00:00	38000280	\N		0	0	0	0	237380	0	232347008	439406		
453	844	4048169	1967-02-03	1967-02-03 00:00:00	38000280	\N		0	0	0	0	55924	0	232350006	4048169		
2167	3622	433644	1923-10-29	1923-10-29 00:00:00	38000280	\N		0	0	0	0	240687	0	300913006	433644		
2273	3891	439406	1983-11-05	1983-11-05 00:00:00	38000280	\N		0	0	0	0	258719	0	232347008	439406		
69623	4119	4323208	1976-07-15	1976-07-15 00:00:00	38000276	\N		0	0	0	0	273877	0	428251008	4323208		
1773	2711	4174876	1951-01-10	1951-01-10 00:00:00	38000280	\N		0	0	0	0	179635	0	424213003	4174876		
2743	4642	439406	1953-09-03	1953-09-03 00:00:00	38000280	\N		0	0	0	0	309354	0	232347008	439406		
2808	4804	4048169	1978-01-28	1978-01-28 00:00:00	38000280	\N		0	0	0	0	319658	0	232350006	4048169		
778	1292	4174876	1951-02-24	1951-02-24 00:00:00	38000280	\N		0	0	0	0	85380	0	424213003	4174876		
1866	2891	442116	1975-04-27	1975-04-27 00:00:00	38000280	\N		0	0	0	0	192353	0	91930004	442116		
1934	3041	4169137	1978-08-06	1978-08-06 00:00:00	38000280	\N		0	0	0	0	202463	0	420174000	4169137		
1320	2075	4219399	1967-05-03	1967-05-03 00:00:00	38000280	\N		0	0	0	0	138116	0	417532002	4219399		
1413	2218	4240902	1979-03-30	1979-03-30 00:00:00	38000280	\N		0	0	0	0	147700	0	91935009	4240902		
1594	2477	4302207	1956-01-07	1956-01-07 00:00:00	38000280	\N		0	0	0	0	164150	0	418689008	4302207		
2662	4459	433644	1965-01-28	1965-01-28 00:00:00	38000280	\N		0	0	0	0	296719	0	300913006	433644		
40616	2414	4163874	1994-05-26	1994-05-26 00:00:00	38000276	\N		0	0	0	0	160252	0	399211009	4163874		
234	480	4302207	1971-05-28	1971-05-28 00:00:00	38000280	\N		0	0	0	0	32129	0	418689008	4302207		
11998	709	4163874	2005-08-28	2005-08-28 00:00:00	38000276	\N		0	0	0	0	46975	0	399211009	4163874		
2498	4217	4304110	1959-08-20	1959-08-20 00:00:00	38000280	\N		0	0	0	0	279962	0	419474003	4304110		
38519	2287	4324181	2014-01-24	2014-01-24 00:00:00	38000276	\N		0	0	0	0	152154	0	429007001	4324181		
1128	1783	4048169	1960-03-01	1960-03-01 00:00:00	38000280	\N		0	0	0	0	119488	0	232350006	4048169		
35667	2114	4324181	1988-06-15	1988-06-15 00:00:00	38000276	\N		0	0	0	0	140683	0	429007001	4324181		
320	17	45766064	1962-12-08	1962-12-08 00:00:00	38000276	\N		0	0	0	0	1378	0	703151001	45766064		
2004	3241	4169137	1961-11-03	1961-11-03 00:00:00	38000280	\N		0	0	0	0	215575	0	420174000	4169137		
2129	3571	4048169	1972-12-29	1972-12-29 00:00:00	38000280	\N		0	0	0	0	237380	0	232350006	4048169		
454	844	4139681	1967-02-03	1967-02-03 00:00:00	38000280	\N		0	0	0	0	55924	0	425525006	4139681		
2186	3680	4304110	1979-12-15	1979-12-15 00:00:00	38000280	\N		0	0	0	0	244725	0	419474003	4304110		
2274	3891	4174876	1983-11-05	1983-11-05 00:00:00	38000280	\N		0	0	0	0	258719	0	424213003	4174876		
18398	1107	4163874	2007-06-15	2007-06-15 00:00:00	38000276	\N		0	0	0	0	72859	0	399211009	4163874		
1774	2711	4169137	1951-01-10	1951-01-10 00:00:00	38000280	\N		0	0	0	0	179635	0	420174000	4169137		
2744	4642	4304110	1953-09-03	1953-09-03 00:00:00	38000280	\N		0	0	0	0	309354	0	419474003	4304110		
2809	4804	4302207	1978-01-28	1978-01-28 00:00:00	38000280	\N		0	0	0	0	319658	0	418689008	4302207		
779	1292	4169137	1951-02-24	1951-02-24 00:00:00	38000280	\N		0	0	0	0	85380	0	420174000	4169137		
1867	2895	439406	1986-01-09	1986-01-09 00:00:00	38000280	\N		0	0	0	0	192693	0	232347008	439406		
1935	3041	439406	1978-08-06	1978-08-06 00:00:00	38000280	\N		0	0	0	0	202463	0	232347008	439406		
1321	2075	4240902	1967-05-03	1967-05-03 00:00:00	38000280	\N		0	0	0	0	138116	0	91935009	4240902		
1414	2218	439406	1979-03-30	1979-03-30 00:00:00	38000280	\N		0	0	0	0	147700	0	232347008	439406		
1595	2477	4048169	1956-01-07	1956-01-07 00:00:00	38000280	\N		0	0	0	0	164150	0	232350006	4048169		
2663	4471	439406	1961-07-20	1961-07-20 00:00:00	38000280	\N		0	0	0	0	297428	0	232347008	439406		
235	489	433644	1976-11-03	1976-11-03 00:00:00	38000280	\N		0	0	0	0	32754	0	300913006	433644		
12059	712	4324181	2011-04-14	2011-04-14 00:00:00	38000276	\N		0	0	0	0	47268	0	429007001	4324181		
2499	4217	438614	1959-08-20	1959-08-20 00:00:00	38000280	\N		0	0	0	0	279962	0	91934008	438614		
67687	3998	4324181	1982-08-26	1982-08-26 00:00:00	38000276	\N		0	0	0	0	265792	0	429007001	4324181		
1129	1783	442116	1960-03-01	1960-03-01 00:00:00	38000280	\N		0	0	0	0	119488	0	91930004	442116		
51395	3049	4324181	1991-07-12	1991-07-12 00:00:00	38000276	\N		0	0	0	0	202875	0	429007001	4324181		
69114	4090	4324181	2015-03-23	2015-03-23 00:00:00	38000276	\N		0	0	0	0	271940	0	429007001	4324181		
2018	3253	4302207	1972-06-02	1972-06-02 00:00:00	38000280	\N		0	0	0	0	216320	0	418689008	4302207		
2130	3571	4139681	1972-12-29	1972-12-29 00:00:00	38000280	\N		0	0	0	0	237380	0	425525006	4139681		
455	844	439406	1967-02-03	1967-02-03 00:00:00	38000280	\N		0	0	0	0	55924	0	232347008	439406		
2187	3680	4306014	1979-12-15	1979-12-15 00:00:00	38000280	\N		0	0	0	0	244725	0	419263009	4306014		
2296	3913	439406	1981-11-09	1981-11-09 00:00:00	38000280	\N		0	0	0	0	260154	0	232347008	439406		
49381	2919	4323208	1965-08-17	1965-08-17 00:00:00	38000276	\N		0	0	0	0	194614	0	428251008	4323208		
1775	2711	439406	1951-01-10	1951-01-10 00:00:00	38000280	\N		0	0	0	0	179635	0	232347008	439406		
2745	4642	4306014	1953-09-03	1953-09-03 00:00:00	38000280	\N		0	0	0	0	309354	0	419263009	4306014		
2810	4804	4304110	1978-01-28	1978-01-28 00:00:00	38000280	\N		0	0	0	0	319658	0	419474003	4304110		
780	1292	439406	1951-02-24	1951-02-24 00:00:00	38000280	\N		0	0	0	0	85380	0	232347008	439406		
1868	2898	4240902	1980-03-29	1980-03-29 00:00:00	38000280	\N		0	0	0	0	193004	0	91935009	4240902		
1936	3041	4306014	1978-08-06	1978-08-06 00:00:00	38000280	\N		0	0	0	0	202463	0	419263009	4306014		
1322	2075	4304110	1967-05-03	1967-05-03 00:00:00	38000280	\N		0	0	0	0	138116	0	419474003	4304110		
1448	2280	439406	1970-08-08	1970-08-08 00:00:00	38000280	\N		0	0	0	0	151553	0	232347008	439406		
1596	2477	4139681	1956-01-07	1956-01-07 00:00:00	38000280	\N		0	0	0	0	164150	0	425525006	4139681		
2664	4471	4240902	1961-07-20	1961-07-20 00:00:00	38000280	\N		0	0	0	0	297428	0	91935009	4240902		
236	499	4048169	1959-10-31	1959-10-31 00:00:00	38000280	\N		0	0	0	0	33343	0	232350006	4048169		
74699	4436	4324181	2003-06-13	2003-06-13 00:00:00	38000276	\N		0	0	0	0	294881	0	429007001	4324181		
2500	4217	439406	1959-08-20	1959-08-20 00:00:00	38000280	\N		0	0	0	0	279962	0	232347008	439406		
1130	1783	4302207	1960-03-01	1960-03-01 00:00:00	38000280	\N		0	0	0	0	119488	0	418689008	4302207		
51399	3049	4163874	1986-12-05	1986-12-05 00:00:00	38000276	\N		0	0	0	0	202874	0	399211009	4163874		
69136	4091	4324181	2017-09-10	2017-09-10 00:00:00	38000276	\N		0	0	0	0	271945	0	429007001	4324181		
2019	3253	4306014	1972-06-02	1972-06-02 00:00:00	38000280	\N		0	0	0	0	216320	0	419263009	4306014		
2131	3571	4304110	1972-12-29	1972-12-29 00:00:00	38000280	\N		0	0	0	0	237380	0	419474003	4304110		
456	844	4102123	1967-02-03	1967-02-03 00:00:00	38000280	\N		0	0	0	0	55924	0	300916003	4102123		
2188	3680	4219399	1979-12-15	1979-12-15 00:00:00	38000280	\N		0	0	0	0	244725	0	417532002	4219399		
2297	3916	433644	1979-04-17	1979-04-17 00:00:00	38000280	\N		0	0	0	0	260278	0	300913006	433644		
76416	4531	4163874	2017-04-29	2017-04-29 00:00:00	38000276	\N		0	0	0	0	301711	0	399211009	4163874		
1776	2711	4304110	1951-01-10	1951-01-10 00:00:00	38000280	\N		0	0	0	0	179635	0	419474003	4304110		
2746	4642	4102123	1953-09-03	1953-09-03 00:00:00	38000280	\N		0	0	0	0	309354	0	300916003	4102123		
2811	4804	4240902	1978-01-28	1978-01-28 00:00:00	38000280	\N		0	0	0	0	319658	0	91935009	4240902		
781	1292	4302207	1951-02-24	1951-02-24 00:00:00	38000280	\N		0	0	0	0	85380	0	418689008	4302207		
1870	2915	439406	1967-05-27	1967-05-27 00:00:00	38000280	\N		0	0	0	0	194342	0	232347008	439406		
1937	3041	4304110	1978-08-06	1978-08-06 00:00:00	38000280	\N		0	0	0	0	202463	0	419474003	4304110		
33895	2012	4323208	1996-01-25	1996-01-25 00:00:00	38000276	\N		0	0	0	0	133915	0	428251008	4323208		
1449	2280	4174876	1970-08-08	1970-08-08 00:00:00	38000280	\N		0	0	0	0	151553	0	424213003	4174876		
2507	4226	439406	1964-12-19	1964-12-19 00:00:00	38000280	\N		0	0	0	0	280763	0	232347008	439406		
2665	4476	4169137	1962-06-12	1962-06-12 00:00:00	38000280	\N		0	0	0	0	297889	0	420174000	4169137		
237	499	439406	1959-10-31	1959-10-31 00:00:00	38000280	\N		0	0	0	0	33343	0	232347008	439406		
2428	4130	4306014	1966-12-16	1966-12-16 00:00:00	38000280	\N		0	0	0	0	274579	0	419263009	4306014		
2502	4224	439406	1951-02-03	1951-02-03 00:00:00	38000280	\N		0	0	0	0	280443	0	232347008	439406		
1131	1783	439406	1960-03-01	1960-03-01 00:00:00	38000280	\N		0	0	0	0	119488	0	232347008	439406		
46534	2770	45766064	1945-03-31	1945-03-31 00:00:00	38000276	\N		0	0	0	0	183302	0	703151001	45766064		
2020	3253	4304110	1972-06-02	1972-06-02 00:00:00	38000280	\N		0	0	0	0	216320	0	419474003	4304110		
2132	3571	4306014	1972-12-29	1972-12-29 00:00:00	38000280	\N		0	0	0	0	237380	0	419263009	4306014		
457	844	4240902	1967-02-03	1967-02-03 00:00:00	38000280	\N		0	0	0	0	55924	0	91935009	4240902		
2189	3680	439406	1979-12-15	1979-12-15 00:00:00	38000280	\N		0	0	0	0	244725	0	232347008	439406		
2298	3916	4048169	1979-04-17	1979-04-17 00:00:00	38000280	\N		0	0	0	0	260278	0	232350006	4048169		
72464	4304	45766064	1977-09-08	1977-09-08 00:00:00	38000276	\N		0	0	0	0	285471	0	703151001	45766064		
1777	2711	4240902	1951-01-10	1951-01-10 00:00:00	38000280	\N		0	0	0	0	179635	0	91935009	4240902		
2747	4642	4219399	1953-09-03	1953-09-03 00:00:00	38000280	\N		0	0	0	0	309354	0	417532002	4219399		
2812	4804	4306014	1978-01-28	1978-01-28 00:00:00	38000280	\N		0	0	0	0	319658	0	419263009	4306014		
782	1292	4048169	1951-02-24	1951-02-24 00:00:00	38000280	\N		0	0	0	0	85380	0	232350006	4048169		
1871	2925	4302207	1963-05-26	1963-05-26 00:00:00	38000280	\N		0	0	0	0	195090	0	418689008	4302207		
1938	3041	4219399	1978-08-06	1978-08-06 00:00:00	38000280	\N		0	0	0	0	202463	0	417532002	4219399		
15513	918	4324181	2016-05-20	2016-05-20 00:00:00	38000276	\N		0	0	0	0	61206	0	429007001	4324181		
1450	2280	4139681	1970-08-08	1970-08-08 00:00:00	38000280	\N		0	0	0	0	151553	0	425525006	4139681		
2526	4279	433644	1951-01-14	1951-01-14 00:00:00	38000280	\N		0	0	0	0	283958	0	300913006	433644		
2666	4476	439406	1962-06-12	1962-06-12 00:00:00	38000280	\N		0	0	0	0	297889	0	232347008	439406		
238	499	4169137	1959-10-31	1959-10-31 00:00:00	38000280	\N		0	0	0	0	33343	0	420174000	4169137		
2429	4130	4304110	1966-12-16	1966-12-16 00:00:00	38000280	\N		0	0	0	0	274579	0	419474003	4304110		
2503	4226	4302207	1964-12-19	1964-12-19 00:00:00	38000280	\N		0	0	0	0	280763	0	418689008	4302207		
1132	1783	4304110	1960-03-01	1960-03-01 00:00:00	38000280	\N		0	0	0	0	119488	0	419474003	4304110		
15971	946	4323208	1976-04-04	1976-04-04 00:00:00	38000276	\N		0	0	0	0	62811	0	428251008	4323208		
2021	3253	439406	1972-06-02	1972-06-02 00:00:00	38000280	\N		0	0	0	0	216320	0	232347008	439406		
2133	3583	4048169	1970-01-11	1970-01-11 00:00:00	38000280	\N		0	0	0	0	238243	0	232350006	4048169		
458	844	4306014	1967-02-03	1967-02-03 00:00:00	38000280	\N		0	0	0	0	55924	0	419263009	4306014		
2190	3680	4169137	1979-12-15	1979-12-15 00:00:00	38000280	\N		0	0	0	0	244725	0	420174000	4169137		
2299	3916	4302207	1979-04-17	1979-04-17 00:00:00	38000280	\N		0	0	0	0	260278	0	418689008	4302207		
54350	3219	4323208	2015-01-11	2015-01-11 00:00:00	38000276	\N		0	0	0	0	213928	0	428251008	4323208		
64033	3783	45766064	1952-04-02	1952-04-02 00:00:00	38000276	\N		0	0	0	0	251451	0	703151001	45766064		
2748	4642	433644	1953-09-03	1953-09-03 00:00:00	38000280	\N		0	0	0	0	309354	0	300913006	433644		
2813	4804	439406	1978-01-28	1978-01-28 00:00:00	38000280	\N		0	0	0	0	319658	0	232347008	439406		
88905	5285	4163874	2008-07-06	2008-07-06 00:00:00	38000276	\N		0	0	0	0	351690	0	399211009	4163874		
1872	2925	4304110	1963-05-26	1963-05-26 00:00:00	38000280	\N		0	0	0	0	195090	0	419474003	4304110		
1939	3041	4048169	1978-08-06	1978-08-06 00:00:00	38000280	\N		0	0	0	0	202463	0	232350006	4048169		
1451	2280	4048169	1970-08-08	1970-08-08 00:00:00	38000280	\N		0	0	0	0	151553	0	232350006	4048169		
2527	4279	4302207	1951-01-14	1951-01-14 00:00:00	38000280	\N		0	0	0	0	283958	0	418689008	4302207		
2667	4476	4304110	1962-06-12	1962-06-12 00:00:00	38000280	\N		0	0	0	0	297889	0	419474003	4304110		
239	499	4304110	1959-10-31	1959-10-31 00:00:00	38000280	\N		0	0	0	0	33343	0	419474003	4304110		
2430	4130	439406	1966-12-16	1966-12-16 00:00:00	38000280	\N		0	0	0	0	274579	0	232347008	439406		
2504	4226	4048169	1964-12-19	1964-12-19 00:00:00	38000280	\N		0	0	0	0	280763	0	232350006	4048169		
1133	1783	433644	1960-03-01	1960-03-01 00:00:00	38000280	\N		0	0	0	0	119488	0	300913006	433644		
51538	3059	4323208	1990-04-15	1990-04-15 00:00:00	38000276	\N		0	0	0	0	203510	0	428251008	4323208		
2030	3279	4139681	1956-01-05	1956-01-05 00:00:00	38000280	\N		0	0	0	0	217900	0	425525006	4139681		
2134	3583	4302207	1970-01-11	1970-01-11 00:00:00	38000280	\N		0	0	0	0	238243	0	418689008	4302207		
459	844	4304110	1967-02-03	1967-02-03 00:00:00	38000280	\N		0	0	0	0	55924	0	419474003	4304110		
2191	3680	4302207	1979-12-15	1979-12-15 00:00:00	38000280	\N		0	0	0	0	244725	0	418689008	4302207		
2300	3916	439406	1979-04-17	1979-04-17 00:00:00	38000280	\N		0	0	0	0	260278	0	232347008	439406		
70326	4165	4324181	1991-01-27	1991-01-27 00:00:00	38000276	\N		0	0	0	0	276828	0	429007001	4324181		
60771	3598	4163874	2014-12-14	2014-12-14 00:00:00	38000276	\N		0	0	0	0	238946	0	399211009	4163874		
2749	4646	4219399	1944-11-13	1944-11-13 00:00:00	38000280	\N		0	0	0	0	309782	0	417532002	4219399		
2814	4826	433644	1952-10-15	1952-10-15 00:00:00	38000280	\N		0	0	0	0	321066	0	300913006	433644		
54146	3207	4324181	1994-12-01	1994-12-01 00:00:00	38000276	\N		0	0	0	0	213206	0	429007001	4324181		
1729	99	4323208	1996-10-17	1996-10-17 00:00:00	38000276	\N		0	0	0	0	6779	0	428251008	4323208		
1940	3041	4302207	1978-08-06	1978-08-06 00:00:00	38000280	\N		0	0	0	0	202463	0	418689008	4302207		
1452	2280	442116	1970-08-08	1970-08-08 00:00:00	38000280	\N		0	0	0	0	151553	0	91930004	442116		
2528	4279	4169137	1951-01-14	1951-01-14 00:00:00	38000280	\N		0	0	0	0	283958	0	420174000	4169137		
2668	4476	4240902	1962-06-12	1962-06-12 00:00:00	38000280	\N		0	0	0	0	297889	0	91935009	4240902		
240	499	4306014	1959-10-31	1959-10-31 00:00:00	38000280	\N		0	0	0	0	33343	0	419263009	4306014		
2431	4130	4048169	1966-12-16	1966-12-16 00:00:00	38000280	\N		0	0	0	0	274579	0	232350006	4048169		
2505	4226	4304110	1964-12-19	1964-12-19 00:00:00	38000280	\N		0	0	0	0	280763	0	419474003	4304110		
1142	1789	4048169	1976-03-06	1976-03-06 00:00:00	38000280	\N		0	0	0	0	119926	0	232350006	4048169		
2031	3279	4240902	1956-01-05	1956-01-05 00:00:00	38000280	\N		0	0	0	0	217900	0	91935009	4240902		
2135	3583	439406	1970-01-11	1970-01-11 00:00:00	38000280	\N		0	0	0	0	238243	0	232347008	439406		
473	859	4302207	1958-02-16	1958-02-16 00:00:00	38000280	\N		0	0	0	0	56728	0	418689008	4302207		
2192	3680	4048169	1979-12-15	1979-12-15 00:00:00	38000280	\N		0	0	0	0	244725	0	232350006	4048169		
2301	3916	4304110	1979-04-17	1979-04-17 00:00:00	38000280	\N		0	0	0	0	260278	0	419474003	4304110		
24822	1480	4163874	2006-08-04	2006-08-04 00:00:00	38000276	\N		0	0	0	0	98765	0	399211009	4163874		
76882	4557	4324181	1978-12-31	1978-12-31 00:00:00	38000276	\N		0	0	0	0	303643	0	429007001	4324181		
2750	4655	4240902	1960-04-19	1960-04-19 00:00:00	38000280	\N		0	0	0	0	310402	0	91935009	4240902		
2823	4837	4102123	1952-01-17	1952-01-17 00:00:00	38000280	\N		0	0	0	0	321860	0	300916003	4102123		
1753	101	4324181	2001-01-12	2001-01-12 00:00:00	38000276	\N		0	0	0	0	6902	0	429007001	4324181		
16841	1000	45766064	2017-01-29	2017-01-29 00:00:00	38000276	\N		0	0	0	0	66142	0	703151001	45766064		
1453	2280	4302207	1970-08-08	1970-08-08 00:00:00	38000280	\N		0	0	0	0	151553	0	418689008	4302207		
2529	4279	439406	1951-01-14	1951-01-14 00:00:00	38000280	\N		0	0	0	0	283958	0	232347008	439406		
2669	4476	4048169	1962-06-12	1962-06-12 00:00:00	38000280	\N		0	0	0	0	297889	0	232350006	4048169		
241	499	4102123	1959-10-31	1959-10-31 00:00:00	38000280	\N		0	0	0	0	33343	0	300916003	4102123		
2432	4130	4302207	1966-12-16	1966-12-16 00:00:00	38000280	\N		0	0	0	0	274579	0	418689008	4302207		
2506	4226	4306014	1964-12-19	1964-12-19 00:00:00	38000280	\N		0	0	0	0	280763	0	419263009	4306014		
1143	1789	4139681	1976-03-06	1976-03-06 00:00:00	38000280	\N		0	0	0	0	119926	0	425525006	4139681		
2032	3311	439406	1990-03-30	1990-03-30 00:00:00	38000280	\N		0	0	0	0	219805	0	232347008	439406		
84332	5013	4163874	2013-05-31	2013-05-31 00:00:00	38000276	\N		0	0	0	0	333201	0	399211009	4163874		
474	859	4169137	1958-02-16	1958-02-16 00:00:00	38000280	\N		0	0	0	0	56728	0	420174000	4169137		
2193	3680	433644	1979-12-15	1979-12-15 00:00:00	38000280	\N		0	0	0	0	244725	0	300913006	433644		
2302	3916	4306014	1979-04-17	1979-04-17 00:00:00	38000280	\N		0	0	0	0	260278	0	419263009	4306014		
25631	1524	4323208	1969-01-12	1969-01-12 00:00:00	38000276	\N		0	0	0	0	101909	0	428251008	4323208		
76957	4560	4323208	1977-10-30	1977-10-30 00:00:00	38000276	\N		0	0	0	0	303812	0	428251008	4323208		
2759	4694	4169137	1982-07-22	1982-07-22 00:00:00	38000280	\N		0	0	0	0	312703	0	420174000	4169137		
2824	4844	4048169	1959-10-10	1959-10-10 00:00:00	38000280	\N		0	0	0	0	322199	0	232350006	4048169		
1757	101	45766064	1986-11-04	1986-11-04 00:00:00	38000276	\N		0	0	0	0	6899	0	703151001	45766064		
1454	2280	4306014	1970-08-08	1970-08-08 00:00:00	38000280	\N		0	0	0	0	151553	0	419263009	4306014		
2530	4279	4304110	1951-01-14	1951-01-14 00:00:00	38000280	\N		0	0	0	0	283958	0	419474003	4304110		
1607	2497	433644	1962-10-07	1962-10-07 00:00:00	38000280	\N		0	0	0	0	165328	0	300913006	433644		
247	505	433644	1969-05-19	1969-05-19 00:00:00	38000280	\N		0	0	0	0	33825	0	300913006	433644		
2451	4167	4302207	1979-06-28	1979-06-28 00:00:00	38000280	\N		0	0	0	0	276979	0	418689008	4302207		
6988	410	4323208	1951-09-02	1951-09-02 00:00:00	38000276	\N		0	0	0	0	27160	0	428251008	4323208		
1144	1789	4302207	1976-03-06	1976-03-06 00:00:00	38000280	\N		0	0	0	0	119926	0	418689008	4302207		
2033	3315	442116	1958-02-03	1958-02-03 00:00:00	38000280	\N		0	0	0	0	220164	0	91930004	442116		
20424	1228	4323208	2016-06-26	2016-06-26 00:00:00	38000276	\N		0	0	0	0	80893	0	428251008	4323208		
475	859	439406	1958-02-16	1958-02-16 00:00:00	38000280	\N		0	0	0	0	56728	0	232347008	439406		
2194	3695	4306014	1981-06-13	1981-06-13 00:00:00	38000280	\N		0	0	0	0	245609	0	419263009	4306014		
33571	1991	4163874	2011-02-21	2011-02-21 00:00:00	38000276	\N		0	0	0	0	132611	0	399211009	4163874		
54375	3221	4323208	1967-06-02	1967-06-02 00:00:00	38000276	\N		0	0	0	0	214129	0	428251008	4323208		
36316	2151	4163874	1999-12-08	1999-12-08 00:00:00	38000276	\N		0	0	0	0	143282	0	399211009	4163874		
2825	4844	4302207	1959-10-10	1959-10-10 00:00:00	38000280	\N		0	0	0	0	322199	0	418689008	4302207		
65650	3881	4324181	1997-01-03	1997-01-03 00:00:00	38000276	\N		0	0	0	0	257921	0	429007001	4324181		
1455	2280	4304110	1970-08-08	1970-08-08 00:00:00	38000280	\N		0	0	0	0	151553	0	419474003	4304110		
2531	4279	4306014	1951-01-14	1951-01-14 00:00:00	38000280	\N		0	0	0	0	283958	0	419263009	4306014		
1608	2497	4304110	1962-10-07	1962-10-07 00:00:00	38000280	\N		0	0	0	0	165328	0	419474003	4304110		
248	505	439406	1969-05-19	1969-05-19 00:00:00	38000280	\N		0	0	0	0	33825	0	232347008	439406		
2452	4167	4048169	1979-06-28	1979-06-28 00:00:00	38000280	\N		0	0	0	0	276979	0	232350006	4048169		
1145	1789	4304110	1976-03-06	1976-03-06 00:00:00	38000280	\N		0	0	0	0	119926	0	419474003	4304110		
2034	3315	4240902	1958-02-03	1958-02-03 00:00:00	38000280	\N		0	0	0	0	220164	0	91935009	4240902		
2133	123	4324181	2013-07-10	2013-07-10 00:00:00	38000276	\N		0	0	0	0	8146	0	429007001	4324181		
476	859	433644	1958-02-16	1958-02-16 00:00:00	38000280	\N		0	0	0	0	56728	0	300913006	433644		
2195	3695	433644	1981-06-13	1981-06-13 00:00:00	38000280	\N		0	0	0	0	245609	0	300913006	433644		
33801	2006	4324181	2014-01-17	2014-01-17 00:00:00	38000276	\N		0	0	0	0	133607	0	429007001	4324181		
54415	3223	4323208	1949-07-12	1949-07-12 00:00:00	38000276	\N		0	0	0	0	214304	0	428251008	4323208		
82258	4878	4323208	2011-12-25	2011-12-25 00:00:00	38000276	\N		0	0	0	0	324461	0	428251008	4323208		
2826	4844	4306014	1959-10-10	1959-10-10 00:00:00	38000280	\N		0	0	0	0	322199	0	419263009	4306014		
1472	2291	439406	1963-11-09	1963-11-09 00:00:00	38000280	\N		0	0	0	0	152399	0	232347008	439406		
2552	4305	4240902	1958-07-03	1958-07-03 00:00:00	38000280	\N		0	0	0	0	285573	0	91935009	4240902		
1609	2503	4048169	1973-10-31	1973-10-31 00:00:00	38000280	\N		0	0	0	0	165730	0	232350006	4048169		
249	505	4306014	1969-05-19	1969-05-19 00:00:00	38000280	\N		0	0	0	0	33825	0	419263009	4306014		
2453	4167	4139681	1979-06-28	1979-06-28 00:00:00	38000280	\N		0	0	0	0	276979	0	425525006	4139681		
1146	1789	4306014	1976-03-06	1976-03-06 00:00:00	38000280	\N		0	0	0	0	119926	0	419263009	4306014		
2035	3343	4048169	1977-07-13	1977-07-13 00:00:00	38000280	\N		0	0	0	0	221770	0	232350006	4048169		
23105	1379	4324181	1987-09-05	1987-09-05 00:00:00	38000276	\N		0	0	0	0	91516	0	429007001	4324181		
477	859	4306014	1958-02-16	1958-02-16 00:00:00	38000280	\N		0	0	0	0	56728	0	419263009	4306014		
2196	3703	4139681	1969-07-02	1969-07-02 00:00:00	38000280	\N		0	0	0	0	246258	0	425525006	4139681		
45112	2684	4324181	1967-05-21	1967-05-21 00:00:00	38000276	\N		0	0	0	0	177845	0	429007001	4324181		
37141	2199	4323208	1995-07-19	1995-07-19 00:00:00	38000276	\N		0	0	0	0	146580	0	428251008	4323208		
2827	4844	4304110	1959-10-10	1959-10-10 00:00:00	38000280	\N		0	0	0	0	322199	0	419474003	4304110		
1473	2291	4304110	1963-11-09	1963-11-09 00:00:00	38000280	\N		0	0	0	0	152399	0	419474003	4304110		
2554	4312	439406	1961-02-20	1961-02-20 00:00:00	38000280	\N		0	0	0	0	286108	0	232347008	439406		
1610	2503	442116	1973-10-31	1973-10-31 00:00:00	38000280	\N		0	0	0	0	165730	0	91930004	442116		
250	505	4304110	1969-05-19	1969-05-19 00:00:00	38000280	\N		0	0	0	0	33825	0	419474003	4304110		
2454	4167	4102123	1979-06-28	1979-06-28 00:00:00	38000280	\N		0	0	0	0	276979	0	300916003	4102123		
1147	1789	433644	1976-03-06	1976-03-06 00:00:00	38000280	\N		0	0	0	0	119926	0	300913006	433644		
2036	3343	4139681	1977-07-13	1977-07-13 00:00:00	38000280	\N		0	0	0	0	221770	0	425525006	4139681		
80644	4781	4323208	2002-09-29	2002-09-29 00:00:00	38000276	\N		0	0	0	0	318306	0	428251008	4323208		
478	859	4304110	1958-02-16	1958-02-16 00:00:00	38000280	\N		0	0	0	0	56728	0	419474003	4304110		
2197	3708	4306014	1978-01-26	1978-01-26 00:00:00	38000280	\N		0	0	0	0	246551	0	419263009	4306014		
2828	4844	439406	1959-10-10	1959-10-10 00:00:00	38000280	\N		0	0	0	0	322199	0	232347008	439406		
1474	2291	4306014	1963-11-09	1963-11-09 00:00:00	38000280	\N		0	0	0	0	152399	0	419263009	4306014		
2555	4312	4304110	1961-02-20	1961-02-20 00:00:00	38000280	\N		0	0	0	0	286108	0	419474003	4304110		
1611	2503	4304110	1973-10-31	1973-10-31 00:00:00	38000280	\N		0	0	0	0	165730	0	419474003	4304110		
251	505	438614	1969-05-19	1969-05-19 00:00:00	38000280	\N		0	0	0	0	33825	0	91934008	438614		
2455	4167	4306014	1979-06-28	1979-06-28 00:00:00	38000280	\N		0	0	0	0	276979	0	419263009	4306014		
1148	1789	439406	1976-03-06	1976-03-06 00:00:00	38000280	\N		0	0	0	0	119926	0	232347008	439406		
2037	3343	4302207	1977-07-13	1977-07-13 00:00:00	38000280	\N		0	0	0	0	221770	0	418689008	4302207		
69297	4101	45766064	1960-02-27	1960-02-27 00:00:00	38000276	\N		0	0	0	0	272468	0	703151001	45766064		
502	877	433644	1978-06-07	1978-06-07 00:00:00	38000280	\N		0	0	0	0	58348	0	300913006	433644		
2198	3708	4304110	1978-01-26	1978-01-26 00:00:00	38000280	\N		0	0	0	0	246551	0	419474003	4304110		
2829	4844	433644	1959-10-10	1959-10-10 00:00:00	38000280	\N		0	0	0	0	322199	0	300913006	433644		
1475	2291	4302207	1963-11-09	1963-11-09 00:00:00	38000280	\N		0	0	0	0	152399	0	418689008	4302207		
2556	4312	438614	1961-02-20	1961-02-20 00:00:00	38000280	\N		0	0	0	0	286108	0	91934008	438614		
22616	1352	4324181	1984-11-25	1984-11-25 00:00:00	38000276	\N		0	0	0	0	89607	0	429007001	4324181		
252	505	4048169	1969-05-19	1969-05-19 00:00:00	38000280	\N		0	0	0	0	33825	0	232350006	4048169		
2456	4167	4304110	1979-06-28	1979-06-28 00:00:00	38000280	\N		0	0	0	0	276979	0	419474003	4304110		
10300	608	4163874	2005-07-13	2005-07-13 00:00:00	38000276	\N		0	0	0	0	40409	0	399211009	4163874		
2038	3343	439406	1977-07-13	1977-07-13 00:00:00	38000280	\N		0	0	0	0	221770	0	232347008	439406		
359	680	439406	1971-10-24	1971-10-24 00:00:00	38000280	\N		0	0	0	0	45000	0	232347008	439406		
504	884	4302207	1978-11-13	1978-11-13 00:00:00	38000280	\N		0	0	0	0	58857	0	418689008	4302207		
2199	3708	4219399	1978-01-26	1978-01-26 00:00:00	38000280	\N		0	0	0	0	246551	0	417532002	4219399		
2851	4878	4304110	1963-08-21	1963-08-21 00:00:00	38000280	\N		0	0	0	0	324328	0	419474003	4304110		
1476	2291	4048169	1963-11-09	1963-11-09 00:00:00	38000280	\N		0	0	0	0	152399	0	232350006	4048169		
2557	4312	4102123	1961-02-20	1961-02-20 00:00:00	38000280	\N		0	0	0	0	286108	0	300916003	4102123		
167	332	4302207	1964-07-23	1964-07-23 00:00:00	38000280	\N		0	0	0	0	22048	0	418689008	4302207		
63292	3736	4324181	2006-06-28	2006-06-28 00:00:00	38000276	\N		0	0	0	0	248300	0	429007001	4324181		
2457	4167	439406	1979-06-28	1979-06-28 00:00:00	38000280	\N		0	0	0	0	276979	0	232347008	439406		
10314	609	4324181	2014-12-02	2014-12-02 00:00:00	38000276	\N		0	0	0	0	40413	0	429007001	4324181		
2039	3343	4306014	1977-07-13	1977-07-13 00:00:00	38000280	\N		0	0	0	0	221770	0	419263009	4306014		
360	687	4174876	1967-12-11	1967-12-11 00:00:00	38000280	\N		0	0	0	0	45458	0	424213003	4174876		
505	884	4048169	1978-11-13	1978-11-13 00:00:00	38000280	\N		0	0	0	0	58857	0	232350006	4048169		
2200	3708	433644	1978-01-26	1978-01-26 00:00:00	38000280	\N		0	0	0	0	246551	0	300913006	433644		
47686	2834	4163874	1999-12-04	1999-12-04 00:00:00	38000276	\N		0	0	0	0	188165	0	399211009	4163874		
1482	2319	4302207	1947-08-28	1947-08-28 00:00:00	38000280	\N		0	0	0	0	154153	0	418689008	4302207		
2558	4312	4048169	1961-02-20	1961-02-20 00:00:00	38000280	\N		0	0	0	0	286108	0	232350006	4048169		
168	332	439406	1964-07-23	1964-07-23 00:00:00	38000280	\N		0	0	0	0	22048	0	232347008	439406		
63413	3745	4323208	1935-03-13	1935-03-13 00:00:00	38000276	\N		0	0	0	0	248971	0	428251008	4323208		
2465	4190	4304110	1973-04-12	1973-04-12 00:00:00	38000280	\N		0	0	0	0	278068	0	419474003	4304110		
86380	5142	4163874	2012-04-03	2012-04-03 00:00:00	38000276	\N		0	0	0	0	341697	0	399211009	4163874		
2040	3343	4102123	1977-07-13	1977-07-13 00:00:00	38000280	\N		0	0	0	0	221770	0	300916003	4102123		
361	687	439406	1967-12-11	1967-12-11 00:00:00	38000280	\N		0	0	0	0	45458	0	232347008	439406		
506	884	442116	1978-11-13	1978-11-13 00:00:00	38000280	\N		0	0	0	0	58857	0	91930004	442116		
2201	3708	4048169	1978-01-26	1978-01-26 00:00:00	38000280	\N		0	0	0	0	246551	0	232350006	4048169		
48515	2872	4323208	1979-03-07	1979-03-07 00:00:00	38000276	\N		0	0	0	0	191208	0	428251008	4323208		
1483	2319	4048169	1947-08-28	1947-08-28 00:00:00	38000280	\N		0	0	0	0	154153	0	232350006	4048169		
2559	4313	439406	1948-01-25	1948-01-25 00:00:00	38000280	\N		0	0	0	0	286274	0	232347008	439406		
169	332	4174876	1964-07-23	1964-07-23 00:00:00	38000280	\N		0	0	0	0	22048	0	424213003	4174876		
2328	4027	4306014	1975-02-13	1975-02-13 00:00:00	38000280	\N		0	0	0	0	267867	0	419263009	4306014		
2466	4190	4306014	1973-04-12	1973-04-12 00:00:00	38000280	\N		0	0	0	0	278068	0	419263009	4306014		
2041	3343	4304110	1977-07-13	1977-07-13 00:00:00	38000280	\N		0	0	0	0	221770	0	419474003	4304110		
362	687	4306014	1967-12-11	1967-12-11 00:00:00	38000280	\N		0	0	0	0	45458	0	419263009	4306014		
507	884	439406	1978-11-13	1978-11-13 00:00:00	38000280	\N		0	0	0	0	58857	0	232347008	439406		
2202	3708	4302207	1978-01-26	1978-01-26 00:00:00	38000280	\N		0	0	0	0	246551	0	418689008	4302207		
48517	2872	4163874	1999-08-17	1999-08-17 00:00:00	38000276	\N		0	0	0	0	191227	0	399211009	4163874		
1484	2319	439406	1947-08-28	1947-08-28 00:00:00	38000280	\N		0	0	0	0	154153	0	232347008	439406		
2560	4313	433644	1948-01-25	1948-01-25 00:00:00	38000280	\N		0	0	0	0	286274	0	300913006	433644		
170	332	4169137	1964-07-23	1964-07-23 00:00:00	38000280	\N		0	0	0	0	22048	0	420174000	4169137		
2329	4027	4304110	1975-02-13	1975-02-13 00:00:00	38000280	\N		0	0	0	0	267867	0	419474003	4304110		
2467	4190	4102123	1973-04-12	1973-04-12 00:00:00	38000280	\N		0	0	0	0	278068	0	300916003	4102123		
2052	3364	433644	1977-10-02	1977-10-02 00:00:00	38000280	\N		0	0	0	0	223078	0	300913006	433644		
363	687	4219399	1967-12-11	1967-12-11 00:00:00	38000280	\N		0	0	0	0	45458	0	417532002	4219399		
508	884	4304110	1978-11-13	1978-11-13 00:00:00	38000280	\N		0	0	0	0	58857	0	419474003	4304110		
2203	3708	439406	1978-01-26	1978-01-26 00:00:00	38000280	\N		0	0	0	0	246551	0	232347008	439406		
48529	2872	4324181	1971-09-07	1971-09-07 00:00:00	38000276	\N		0	0	0	0	191205	0	429007001	4324181		
1485	2319	4174876	1947-08-28	1947-08-28 00:00:00	38000280	\N		0	0	0	0	154153	0	424213003	4174876		
2568	4342	438614	1958-11-09	1958-11-09 00:00:00	38000280	\N		0	0	0	0	287940	0	91934008	438614		
171	332	4304110	1964-07-23	1964-07-23 00:00:00	38000280	\N		0	0	0	0	22048	0	419474003	4304110		
2330	4027	4169137	1975-02-13	1975-02-13 00:00:00	38000280	\N		0	0	0	0	267867	0	420174000	4169137		
2468	4190	439406	1973-04-12	1973-04-12 00:00:00	38000280	\N		0	0	0	0	278068	0	232347008	439406		
52883	3132	4323208	1976-07-05	1976-07-05 00:00:00	38000276	\N		0	0	0	0	208378	0	428251008	4323208		
364	687	4304110	1967-12-11	1967-12-11 00:00:00	38000280	\N		0	0	0	0	45458	0	419474003	4304110		
509	884	4102123	1978-11-13	1978-11-13 00:00:00	38000280	\N		0	0	0	0	58857	0	300916003	4102123		
2204	3717	4240902	1977-02-15	1977-02-15 00:00:00	38000280	\N		0	0	0	0	247065	0	91935009	4240902		
1486	2319	4306014	1947-08-28	1947-08-28 00:00:00	38000280	\N		0	0	0	0	154153	0	419263009	4306014		
45356	2697	4324181	2005-09-08	2005-09-08 00:00:00	38000276	\N		0	0	0	0	178582	0	429007001	4324181		
172	332	4306014	1964-07-23	1964-07-23 00:00:00	38000280	\N		0	0	0	0	22048	0	419263009	4306014		
2331	4027	439406	1975-02-13	1975-02-13 00:00:00	38000280	\N		0	0	0	0	267867	0	232347008	439406		
2469	4190	4174876	1973-04-12	1973-04-12 00:00:00	38000280	\N		0	0	0	0	278068	0	424213003	4174876		
3693	211	45766064	1967-10-12	1967-10-12 00:00:00	38000276	\N		0	0	0	0	14405	0	703151001	45766064		
365	687	438614	1967-12-11	1967-12-11 00:00:00	38000280	\N		0	0	0	0	45458	0	91934008	438614		
510	884	4306014	1978-11-13	1978-11-13 00:00:00	38000280	\N		0	0	0	0	58857	0	419263009	4306014		
2215	3745	433644	1931-03-19	1931-03-19 00:00:00	38000280	\N		0	0	0	0	248917	0	300913006	433644		
1487	2319	4304110	1947-08-28	1947-08-28 00:00:00	38000280	\N		0	0	0	0	154153	0	419474003	4304110		
11206	662	4163874	2012-06-06	2012-06-06 00:00:00	38000276	\N		0	0	0	0	43754	0	399211009	4163874		
173	332	4102123	1964-07-23	1964-07-23 00:00:00	38000280	\N		0	0	0	0	22048	0	300916003	4102123		
2332	4027	4139681	1975-02-13	1975-02-13 00:00:00	38000280	\N		0	0	0	0	267867	0	425525006	4139681		
2470	4190	4169137	1973-04-12	1973-04-12 00:00:00	38000280	\N		0	0	0	0	278068	0	420174000	4169137		
3695	212	45766064	2012-03-10	2012-03-10 00:00:00	38000276	\N		0	0	0	0	14440	0	703151001	45766064		
366	687	4302207	1967-12-11	1967-12-11 00:00:00	38000280	\N		0	0	0	0	45458	0	418689008	4302207		
51071	3025	4163874	2002-10-14	2002-10-14 00:00:00	38000276	\N		0	0	0	0	201587	0	399211009	4163874		
2217	3754	4219399	1959-07-16	1959-07-16 00:00:00	38000280	\N		0	0	0	0	249439	0	417532002	4219399		
1488	2319	438614	1947-08-28	1947-08-28 00:00:00	38000280	\N		0	0	0	0	154153	0	91934008	438614		
89	135	433644	1972-09-24	1972-09-24 00:00:00	38000280	\N		0	0	0	0	9079	0	300913006	433644		
174	332	438614	1964-07-23	1964-07-23 00:00:00	38000280	\N		0	0	0	0	22048	0	91934008	438614		
2333	4027	4302207	1975-02-13	1975-02-13 00:00:00	38000280	\N		0	0	0	0	267867	0	418689008	4302207		
2471	4190	442116	1973-04-12	1973-04-12 00:00:00	38000280	\N		0	0	0	0	278068	0	91930004	442116		
3720	213	4323208	1977-04-29	1977-04-29 00:00:00	38000276	\N		0	0	0	0	14547	0	428251008	4323208		
367	687	4048169	1967-12-11	1967-12-11 00:00:00	38000280	\N		0	0	0	0	45458	0	232350006	4048169		
74429	4418	4323208	1954-07-27	1954-07-27 00:00:00	38000276	\N		0	0	0	0	293743	0	428251008	4323208		
2218	3759	439406	1983-08-31	1983-08-31 00:00:00	38000280	\N		0	0	0	0	249968	0	232347008	439406		
1497	2339	439406	1973-02-28	1973-02-28 00:00:00	38000280	\N		0	0	0	0	155587	0	232347008	439406		
90	137	433644	1972-11-02	1972-11-02 00:00:00	38000280	\N		0	0	0	0	9195	0	300913006	433644		
176	338	442116	1968-06-25	1968-06-25 00:00:00	38000280	\N		0	0	0	0	22601	0	91930004	442116		
2334	4027	4048169	1975-02-13	1975-02-13 00:00:00	38000280	\N		0	0	0	0	267867	0	232350006	4048169		
2472	4190	4302207	1973-04-12	1973-04-12 00:00:00	38000280	\N		0	0	0	0	278068	0	418689008	4302207		
19164	1148	4323208	2010-06-10	2010-06-10 00:00:00	38000276	\N		0	0	0	0	75935	0	428251008	4323208		
376	711	433644	1952-04-30	1952-04-30 00:00:00	38000280	\N		0	0	0	0	47161	0	300913006	433644		
2228	3772	4219399	1970-02-22	1970-02-22 00:00:00	38000280	\N		0	0	0	0	250694	0	417532002	4219399		
1498	2339	4304110	1973-02-28	1973-02-28 00:00:00	38000280	\N		0	0	0	0	155587	0	419474003	4304110		
91	137	439406	1972-11-02	1972-11-02 00:00:00	38000280	\N		0	0	0	0	9195	0	232347008	439406		
177	343	4174876	1971-03-10	1971-03-10 00:00:00	38000280	\N		0	0	0	0	22851	0	424213003	4174876		
2335	4027	433644	1975-02-13	1975-02-13 00:00:00	38000280	\N		0	0	0	0	267867	0	300913006	433644		
2476	4199	4304110	1962-05-14	1962-05-14 00:00:00	38000280	\N		0	0	0	0	278623	0	419474003	4304110		
44674	2657	4324181	1970-09-05	1970-09-05 00:00:00	38000276	\N		0	0	0	0	175949	0	429007001	4324181		
377	711	439406	1952-04-30	1952-04-30 00:00:00	38000280	\N		0	0	0	0	47161	0	232347008	439406		
2229	3772	4304110	1970-02-22	1970-02-22 00:00:00	38000280	\N		0	0	0	0	250694	0	419474003	4304110		
1499	2339	438614	1973-02-28	1973-02-28 00:00:00	38000280	\N		0	0	0	0	155587	0	91934008	438614		
114	186	439406	1972-07-11	1972-07-11 00:00:00	38000280	\N		0	0	0	0	12619	0	232347008	439406		
178	343	4169137	1971-03-10	1971-03-10 00:00:00	38000280	\N		0	0	0	0	22851	0	420174000	4169137		
2357	4064	4302207	1960-11-26	1960-11-26 00:00:00	38000280	\N		0	0	0	0	270091	0	418689008	4302207		
2485	4202	433644	1971-09-06	1971-09-06 00:00:00	38000280	\N		0	0	0	0	278933	0	300913006	433644		
16105	951	4323208	2011-12-20	2011-12-20 00:00:00	38000276	\N		0	0	0	0	63217	0	428251008	4323208		
378	718	433644	1966-12-08	1966-12-08 00:00:00	38000280	\N		0	0	0	0	47439	0	300913006	433644		
2230	3783	433644	1940-12-17	1940-12-17 00:00:00	38000280	\N		0	0	0	0	251425	0	300913006	433644		
1500	2339	4102123	1973-02-28	1973-02-28 00:00:00	38000280	\N		0	0	0	0	155587	0	300916003	4102123		
115	186	4174876	1972-07-11	1972-07-11 00:00:00	38000280	\N		0	0	0	0	12619	0	424213003	4174876		
179	343	439406	1971-03-10	1971-03-10 00:00:00	38000280	\N		0	0	0	0	22851	0	232347008	439406		
2358	4064	4139681	1960-11-26	1960-11-26 00:00:00	38000280	\N		0	0	0	0	270091	0	425525006	4139681		
2486	4202	4306014	1971-09-06	1971-09-06 00:00:00	38000280	\N		0	0	0	0	278933	0	419263009	4306014		
27429	1618	4163874	2006-04-12	2006-04-12 00:00:00	38000276	\N		0	0	0	0	108786	0	399211009	4163874		
379	718	4304110	1966-12-08	1966-12-08 00:00:00	38000280	\N		0	0	0	0	47439	0	419474003	4304110		
87327	5197	443279	1993-04-11	1993-04-11 00:00:00	38000276	\N		0	0	0	0	345575	0	287185009	443279		
1501	2339	4306014	1973-02-28	1973-02-28 00:00:00	38000280	\N		0	0	0	0	155587	0	419263009	4306014		
116	186	4306014	1972-07-11	1972-07-11 00:00:00	38000280	\N		0	0	0	0	12619	0	419263009	4306014		
37300	2210	4323208	1969-10-19	1969-10-19 00:00:00	38000276	\N		0	0	0	0	147270	0	428251008	4323208		
2359	4064	4240902	1960-11-26	1960-11-26 00:00:00	38000280	\N		0	0	0	0	270091	0	91935009	4240902		
2487	4202	4304110	1971-09-06	1971-09-06 00:00:00	38000280	\N		0	0	0	0	278933	0	419474003	4304110		
396	754	4048169	1942-09-18	1942-09-18 00:00:00	38000280	\N		0	0	0	0	49948	0	232350006	4048169		
87350	5199	45766064	1976-01-13	1976-01-13 00:00:00	38000276	\N		0	0	0	0	345722	0	703151001	45766064		
1502	2339	4302207	1973-02-28	1973-02-28 00:00:00	38000280	\N		0	0	0	0	155587	0	418689008	4302207		
117	186	4304110	1972-07-11	1972-07-11 00:00:00	38000280	\N		0	0	0	0	12619	0	419474003	4304110		
2360	4064	4304110	1960-11-26	1960-11-26 00:00:00	38000280	\N		0	0	0	0	270091	0	419474003	4304110		
2488	4202	4240902	1971-09-06	1971-09-06 00:00:00	38000280	\N		0	0	0	0	278933	0	91935009	4240902		
397	761	4304110	1979-09-26	1979-09-26 00:00:00	38000280	\N		0	0	0	0	50589	0	419474003	4304110		
1503	2339	4048169	1973-02-28	1973-02-28 00:00:00	38000280	\N		0	0	0	0	155587	0	232350006	4048169		
118	186	438614	1972-07-11	1972-07-11 00:00:00	38000280	\N		0	0	0	0	12619	0	91934008	438614		
2361	4064	4306014	1960-11-26	1960-11-26 00:00:00	38000280	\N		0	0	0	0	270091	0	419263009	4306014		
2489	4202	439406	1971-09-06	1971-09-06 00:00:00	38000280	\N		0	0	0	0	278933	0	232347008	439406		
398	761	4306014	1979-09-26	1979-09-26 00:00:00	38000280	\N		0	0	0	0	50589	0	419263009	4306014		
1504	2349	439406	1972-11-14	1972-11-14 00:00:00	38000280	\N		0	0	0	0	156414	0	232347008	439406		
119	186	4240902	1972-07-11	1972-07-11 00:00:00	38000280	\N		0	0	0	0	12619	0	91935009	4240902		
2362	4064	37017711	1960-11-26	1960-11-26 00:00:00	38000280	\N		0	0	0	0	270091	0	714035009	37017711		
2490	4202	4302207	1971-09-06	1971-09-06 00:00:00	38000280	\N		0	0	0	0	278933	0	418689008	4302207		
399	761	439406	1979-09-26	1979-09-26 00:00:00	38000280	\N		0	0	0	0	50589	0	232347008	439406		
1505	2349	433644	1972-11-14	1972-11-14 00:00:00	38000280	\N		0	0	0	0	156414	0	300913006	433644		
120	186	4048169	1972-07-11	1972-07-11 00:00:00	38000280	\N		0	0	0	0	12619	0	232350006	4048169		
2363	4064	439406	1960-11-26	1960-11-26 00:00:00	38000280	\N		0	0	0	0	270091	0	232347008	439406		
2491	4202	4048169	1971-09-06	1971-09-06 00:00:00	38000280	\N		0	0	0	0	278933	0	232350006	4048169		
400	761	4169137	1979-09-26	1979-09-26 00:00:00	38000280	\N		0	0	0	0	50589	0	420174000	4169137		
1506	2352	4302207	1974-11-20	1974-11-20 00:00:00	38000280	\N		0	0	0	0	156646	0	418689008	4302207		
121	186	442116	1972-07-11	1972-07-11 00:00:00	38000280	\N		0	0	0	0	12619	0	91930004	442116		
2378	4078	439406	1953-03-24	1953-03-24 00:00:00	38000280	\N		0	0	0	0	271015	0	232347008	439406		
2492	4205	4240902	1972-12-19	1972-12-19 00:00:00	38000280	\N		0	0	0	0	279158	0	91935009	4240902		
401	761	4048169	1979-09-26	1979-09-26 00:00:00	38000280	\N		0	0	0	0	50589	0	232350006	4048169		
1507	2352	4048169	1974-11-20	1974-11-20 00:00:00	38000280	\N		0	0	0	0	156646	0	232350006	4048169		
122	186	4302207	1972-07-11	1972-07-11 00:00:00	38000280	\N		0	0	0	0	12619	0	418689008	4302207		
2379	4078	4304110	1953-03-24	1953-03-24 00:00:00	38000280	\N		0	0	0	0	271015	0	419474003	4304110		
2493	4217	4048169	1959-08-20	1959-08-20 00:00:00	38000280	\N		0	0	0	0	279962	0	232350006	4048169		
402	761	4302207	1979-09-26	1979-09-26 00:00:00	38000280	\N		0	0	0	0	50589	0	418689008	4302207		
1508	2352	439406	1974-11-20	1974-11-20 00:00:00	38000280	\N		0	0	0	0	156646	0	232347008	439406		
137	236	4240902	1951-10-01	1951-10-01 00:00:00	38000280	\N		0	0	0	0	15920	0	91935009	4240902		
2380	4078	4102123	1953-03-24	1953-03-24 00:00:00	38000280	\N		0	0	0	0	271015	0	300916003	4102123		
56299	3337	4324181	1983-12-05	1983-12-05 00:00:00	38000276	\N		0	0	0	0	221351	0	429007001	4324181		
74335	4412	4323208	2010-07-22	2010-07-22 00:00:00	38000276	\N		0	0	0	0	293415	0	428251008	4323208		
1509	2352	4174876	1974-11-20	1974-11-20 00:00:00	38000280	\N		0	0	0	0	156646	0	424213003	4174876		
138	266	433644	1967-01-14	1967-01-14 00:00:00	38000280	\N		0	0	0	0	17695	0	300913006	433644		
2381	4078	4306014	1953-03-24	1953-03-24 00:00:00	38000280	\N		0	0	0	0	271015	0	419263009	4306014		
79973	4739	4163874	1993-06-26	1993-06-26 00:00:00	38000276	\N		0	0	0	0	315731	0	399211009	4163874		
74344	4413	45766064	1996-11-29	1996-11-29 00:00:00	38000276	\N		0	0	0	0	293419	0	703151001	45766064		
1510	2352	4306014	1974-11-20	1974-11-20 00:00:00	38000280	\N		0	0	0	0	156646	0	419263009	4306014		
148	273	4302207	1976-09-25	1976-09-25 00:00:00	38000280	\N		0	0	0	0	18193	0	418689008	4302207		
2382	4078	4048169	1953-03-24	1953-03-24 00:00:00	38000280	\N		0	0	0	0	271015	0	232350006	4048169		
1511	2352	4304110	1974-11-20	1974-11-20 00:00:00	38000280	\N		0	0	0	0	156646	0	419474003	4304110		
149	273	4048169	1976-09-25	1976-09-25 00:00:00	38000280	\N		0	0	0	0	18193	0	232350006	4048169		
2383	4078	4302207	1953-03-24	1953-03-24 00:00:00	38000280	\N		0	0	0	0	271015	0	418689008	4302207		
1512	2357	433644	1939-12-24	1939-12-24 00:00:00	38000280	\N		0	0	0	0	156932	0	300913006	433644		
150	273	4139681	1976-09-25	1976-09-25 00:00:00	38000280	\N		0	0	0	0	18193	0	425525006	4139681		
2402	4109	4102123	1965-05-19	1965-05-19 00:00:00	38000280	\N		0	0	0	0	273053	0	300916003	4102123		
1513	2357	4102123	1939-12-24	1939-12-24 00:00:00	38000280	\N		0	0	0	0	156932	0	300916003	4102123		
151	273	4102123	1976-09-25	1976-09-25 00:00:00	38000280	\N		0	0	0	0	18193	0	300916003	4102123		
2403	4109	4304110	1965-05-19	1965-05-19 00:00:00	38000280	\N		0	0	0	0	273053	0	419474003	4304110		
1514	2369	4302207	1982-01-16	1982-01-16 00:00:00	38000280	\N		0	0	0	0	157671	0	418689008	4302207		
152	273	4306014	1976-09-25	1976-09-25 00:00:00	38000280	\N		0	0	0	0	18193	0	419263009	4306014		
2404	4109	439406	1965-05-19	1965-05-19 00:00:00	38000280	\N		0	0	0	0	273053	0	232347008	439406		
1515	2369	4048169	1982-01-16	1982-01-16 00:00:00	38000280	\N		0	0	0	0	157671	0	232350006	4048169		
153	273	4219399	1976-09-25	1976-09-25 00:00:00	38000280	\N		0	0	0	0	18193	0	417532002	4219399		
2405	4109	4174876	1965-05-19	1965-05-19 00:00:00	38000280	\N		0	0	0	0	273053	0	424213003	4174876		
1	9	439406	1979-01-30	1979-01-30 00:00:00	38000280	\N		0	0	0	0	707	0	232347008	439406		
154	273	4304110	1976-09-25	1976-09-25 00:00:00	38000280	\N		0	0	0	0	18193	0	419474003	4304110		
2406	4109	4048169	1965-05-19	1965-05-19 00:00:00	38000280	\N		0	0	0	0	273053	0	232350006	4048169		
2	9	4306014	1979-01-30	1979-01-30 00:00:00	38000280	\N		0	0	0	0	707	0	419263009	4306014		
155	273	439406	1976-09-25	1976-09-25 00:00:00	38000280	\N		0	0	0	0	18193	0	232347008	439406		
2407	4109	4302207	1965-05-19	1965-05-19 00:00:00	38000280	\N		0	0	0	0	273053	0	418689008	4302207		
3	9	4102123	1979-01-30	1979-01-30 00:00:00	38000280	\N		0	0	0	0	707	0	300916003	4102123		
156	273	4169137	1976-09-25	1976-09-25 00:00:00	38000280	\N		0	0	0	0	18193	0	420174000	4169137		
79865	4732	4323208	1970-07-21	1970-07-21 00:00:00	38000276	\N		0	0	0	0	315275	0	428251008	4323208		
4	9	4240902	1979-01-30	1979-01-30 00:00:00	38000280	\N		0	0	0	0	707	0	91935009	4240902		
157	285	4240902	1971-10-03	1971-10-03 00:00:00	38000280	\N		0	0	0	0	18962	0	91935009	4240902		
79906	4735	4324181	1983-06-16	1983-06-16 00:00:00	38000276	\N		0	0	0	0	315452	0	429007001	4324181		
5	9	4304110	1979-01-30	1979-01-30 00:00:00	38000280	\N		0	0	0	0	707	0	419474003	4304110		
158	285	439406	1971-10-03	1971-10-03 00:00:00	38000280	\N		0	0	0	0	18962	0	232347008	439406		
15686	929	4163874	2005-10-10	2005-10-10 00:00:00	38000276	\N		0	0	0	0	61759	0	399211009	4163874		
6	9	4048169	1979-01-30	1979-01-30 00:00:00	38000280	\N		0	0	0	0	707	0	232350006	4048169		
165	332	4048169	1964-07-23	1964-07-23 00:00:00	38000280	\N		0	0	0	0	22048	0	232350006	4048169		
7	9	4302207	1979-01-30	1979-01-30 00:00:00	38000280	\N		0	0	0	0	707	0	418689008	4302207		
166	332	4139681	1964-07-23	1964-07-23 00:00:00	38000280	\N		0	0	0	0	22048	0	425525006	4139681		
9	16	37017711	1972-09-22	1972-09-22 00:00:00	38000280	\N		0	0	0	0	1259	0	714035009	37017711		
74255	4409	4324181	1999-10-28	1999-10-28 00:00:00	38000276	\N		0	0	0	0	293129	0	429007001	4324181		
15	30	4302207	1971-02-09	1971-02-09 00:00:00	38000280	\N		0	0	0	0	2061	0	418689008	4302207		
71939	4269	4323208	1976-05-01	1976-05-01 00:00:00	38000276	\N		0	0	0	0	283316	0	428251008	4323208		
16	30	4306014	1971-02-09	1971-02-09 00:00:00	38000280	\N		0	0	0	0	2061	0	419263009	4306014		
26836	1588	4323208	1981-12-01	1981-12-01 00:00:00	38000276	\N		0	0	0	0	106624	0	428251008	4323208		
17	30	438614	1971-02-09	1971-02-09 00:00:00	38000280	\N		0	0	0	0	2061	0	91934008	438614		
18	30	4304110	1971-02-09	1971-02-09 00:00:00	38000280	\N		0	0	0	0	2061	0	419474003	4304110		
19	30	4174876	1971-02-09	1971-02-09 00:00:00	38000280	\N		0	0	0	0	2061	0	424213003	4174876		
20	30	439406	1971-02-09	1971-02-09 00:00:00	38000280	\N		0	0	0	0	2061	0	232347008	439406		
21	30	4169137	1971-02-09	1971-02-09 00:00:00	38000280	\N		0	0	0	0	2061	0	420174000	4169137		
22	30	433644	1971-02-09	1971-02-09 00:00:00	38000280	\N		0	0	0	0	2061	0	300913006	433644		
23	36	4302207	1960-07-02	1960-07-02 00:00:00	38000280	\N		0	0	0	0	2485	0	418689008	4302207		
24	36	4306014	1960-07-02	1960-07-02 00:00:00	38000280	\N		0	0	0	0	2485	0	419263009	4306014		
25	36	4304110	1960-07-02	1960-07-02 00:00:00	38000280	\N		0	0	0	0	2485	0	419474003	4304110		
26	36	439406	1960-07-02	1960-07-02 00:00:00	38000280	\N		0	0	0	0	2485	0	232347008	439406		
27	36	4174876	1960-07-02	1960-07-02 00:00:00	38000280	\N		0	0	0	0	2485	0	424213003	4174876		
28	41	4048169	1974-04-03	1974-04-03 00:00:00	38000280	\N		0	0	0	0	2900	0	232350006	4048169		
29	41	4302207	1974-04-03	1974-04-03 00:00:00	38000280	\N		0	0	0	0	2900	0	418689008	4302207		
30	41	4304110	1974-04-03	1974-04-03 00:00:00	38000280	\N		0	0	0	0	2900	0	419474003	4304110		
31	41	4102123	1974-04-03	1974-04-03 00:00:00	38000280	\N		0	0	0	0	2900	0	300916003	4102123		
32	41	37017711	1974-04-03	1974-04-03 00:00:00	38000280	\N		0	0	0	0	2900	0	714035009	37017711		
33	41	439406	1974-04-03	1974-04-03 00:00:00	38000280	\N		0	0	0	0	2900	0	232347008	439406		
35	61	4174876	1969-06-28	1969-06-28 00:00:00	38000280	\N		0	0	0	0	4149	0	424213003	4174876		
36	61	37017711	1969-06-28	1969-06-28 00:00:00	38000280	\N		0	0	0	0	4149	0	714035009	37017711		
37	61	439406	1969-06-28	1969-06-28 00:00:00	38000280	\N		0	0	0	0	4149	0	232347008	439406		
38	61	4304110	1969-06-28	1969-06-28 00:00:00	38000280	\N		0	0	0	0	4149	0	419474003	4304110		
39	61	4102123	1969-06-28	1969-06-28 00:00:00	38000280	\N		0	0	0	0	4149	0	300916003	4102123		
40	61	4219399	1969-06-28	1969-06-28 00:00:00	38000280	\N		0	0	0	0	4149	0	417532002	4219399		
41	61	4302207	1969-06-28	1969-06-28 00:00:00	38000280	\N		0	0	0	0	4149	0	418689008	4302207		
42	61	4139681	1969-06-28	1969-06-28 00:00:00	38000280	\N		0	0	0	0	4149	0	425525006	4139681		
43	61	4048169	1969-06-28	1969-06-28 00:00:00	38000280	\N		0	0	0	0	4149	0	232350006	4048169		
51	84	439406	1979-04-08	1979-04-08 00:00:00	38000280	\N		0	0	0	0	5665	0	232347008	439406		
52	84	4302207	1979-04-08	1979-04-08 00:00:00	38000280	\N		0	0	0	0	5665	0	418689008	4302207		
53	84	4048169	1979-04-08	1979-04-08 00:00:00	38000280	\N		0	0	0	0	5665	0	232350006	4048169		
54	84	4306014	1979-04-08	1979-04-08 00:00:00	38000280	\N		0	0	0	0	5665	0	419263009	4306014		
55	84	4304110	1979-04-08	1979-04-08 00:00:00	38000280	\N		0	0	0	0	5665	0	419474003	4304110		
56	84	4102123	1979-04-08	1979-04-08 00:00:00	38000280	\N		0	0	0	0	5665	0	300916003	4102123		
68	124	4048169	1987-04-02	1987-04-02 00:00:00	38000280	\N		0	0	0	0	8296	0	232350006	4048169		
69	124	4302207	1987-04-02	1987-04-02 00:00:00	38000280	\N		0	0	0	0	8296	0	418689008	4302207		
70	124	439406	1987-04-02	1987-04-02 00:00:00	38000280	\N		0	0	0	0	8296	0	232347008	439406		
71	124	4174876	1987-04-02	1987-04-02 00:00:00	38000280	\N		0	0	0	0	8296	0	424213003	4174876		
72	124	4304110	1987-04-02	1987-04-02 00:00:00	38000280	\N		0	0	0	0	8296	0	419474003	4304110		
73	124	4306014	1987-04-02	1987-04-02 00:00:00	38000280	\N		0	0	0	0	8296	0	419263009	4306014		
11130	656	4323208	1996-12-28	1996-12-28 00:00:00	38000276	\N		0	0	0	0	43505	0	428251008	4323208		
\.


--
-- TOC entry 3907 (class 0 OID 3185574)
-- Dependencies: 229
-- Data for Name: observation_period; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".observation_period (observation_period_id, person_id, observation_period_start_date, observation_period_end_date, period_type_concept_id) FROM stdin;
6	6	1963-12-31	2007-02-06	44814724
13	13	2009-04-26	2019-04-14	44814724
27	27	2002-01-30	2018-11-21	44814724
16	16	1971-10-14	2017-11-02	44814724
55	55	2009-05-30	2019-03-23	44814724
60	60	1990-11-21	2019-01-23	44814724
42	42	1909-11-03	2019-03-13	44814724
33	33	1986-05-12	2018-09-10	44814724
18	18	1965-11-17	2018-11-07	44814724
25	25	2007-03-18	2019-04-07	44814724
15	15	2003-07-18	2019-04-30	44814724
4	4	2006-08-19	2019-03-20	44814724
35	35	1960-03-22	2018-12-25	44814724
40	40	1951-12-05	2018-07-14	44814724
62	62	1980-12-11	2017-03-02	44814724
53	53	1962-08-15	2019-04-10	44814724
37	37	2005-02-18	2019-03-22	44814724
46	46	1950-09-22	1981-03-13	44814724
56	56	2007-01-06	2019-01-19	44814724
51	51	2018-06-24	2019-06-09	44814724
20	20	2016-06-05	2019-05-12	44814724
31	31	1990-04-22	2018-11-04	44814724
9	9	1978-07-20	2018-10-25	44814724
2	2	1920-06-01	2008-03-25	44814724
49	49	1972-11-05	2018-07-08	44814724
58	58	1990-06-28	2018-09-06	44814724
44	44	1989-02-22	2017-10-04	44814724
39	39	1989-10-31	2019-02-26	44814724
118	118	1987-12-22	2019-03-05	44814724
11	11	1953-02-03	2019-05-07	44814724
29	29	1980-06-27	2014-12-26	44814724
22	22	1994-12-10	2019-02-23	44814724
61	61	1968-01-21	2019-01-06	44814724
54	54	1995-08-09	2018-09-29	44814724
32	32	1943-10-27	2014-12-24	44814724
43	43	1956-12-17	2018-11-30	44814724
12	12	1963-01-30	2019-03-06	44814724
7	7	1968-11-06	2018-11-07	44814724
17	17	1950-12-11	2019-01-07	44814724
26	26	2003-07-03	2019-06-27	44814724
41	41	1973-05-27	2018-12-23	44814724
34	34	1978-06-05	2018-06-11	44814724
52	52	2008-09-04	2018-07-26	44814724
63	63	1955-12-15	2019-02-28	44814724
24	24	1964-10-13	1982-11-23	44814724
19	19	1949-01-30	2018-08-19	44814724
5	5	1968-07-24	2018-08-29	44814724
14	14	2011-11-18	2018-11-09	44814724
30	30	1970-08-15	2018-05-05	44814724
21	21	2005-08-31	2019-06-26	44814724
3	3	1916-01-03	2018-10-29	44814724
8	8	1989-09-21	2017-10-26	44814724
47	47	1994-09-08	2019-02-21	44814724
36	36	1958-10-21	2019-01-15	44814724
50	50	2015-03-19	2019-02-21	44814724
57	57	1961-06-19	2019-05-13	44814724
10	10	1997-12-11	2016-12-22	44814724
1	1	1949-01-28	2019-05-24	44814724
23	23	1978-09-07	2018-09-13	44814724
28	28	1979-11-01	2017-01-19	44814724
59	59	1994-03-08	2019-06-25	44814724
48	48	1997-06-21	2018-03-08	44814724
38	38	1965-02-10	2019-01-30	44814724
45	45	1984-12-24	2019-04-28	44814724
112	112	1979-03-29	2019-04-04	44814724
123	123	1950-04-12	2013-07-17	44814724
109	109	2010-05-10	2019-06-12	44814724
102	102	1972-06-26	2018-07-16	44814724
65	65	1967-03-31	2019-04-12	44814724
74	74	1972-01-05	2018-07-25	44814724
92	92	1989-01-03	2019-02-19	44814724
87	87	1986-12-20	2018-06-30	44814724
100	100	1991-04-14	2018-07-29	44814724
111	111	1975-05-02	2019-05-17	44814724
121	121	1995-06-21	2018-07-20	44814724
114	114	1972-03-13	2018-09-10	44814724
85	85	1987-06-22	2018-11-19	44814724
94	94	1952-03-28	2018-12-28	44814724
72	72	1947-07-14	2018-11-12	44814724
67	67	1970-10-18	2018-06-10	44814724
83	83	1999-11-09	2019-01-08	44814724
88	88	2010-05-04	2019-05-07	44814724
78	78	1967-01-05	2018-12-13	44814724
69	69	1943-10-27	2019-02-06	44814724
98	98	2009-05-13	2019-05-22	44814724
105	105	1965-06-11	2005-11-18	44814724
127	127	1998-09-10	2018-06-27	44814724
116	116	1926-11-07	2006-07-16	44814724
71	71	2010-04-10	2019-04-13	44814724
76	76	2010-03-27	2019-03-30	44814724
90	90	1961-02-22	2019-04-10	44814724
81	81	1956-03-21	2019-06-19	44814724
154	154	1974-11-21	2017-07-20	44814724
125	125	1984-07-11	2018-08-29	44814724
107	107	2003-04-01	2019-02-05	44814724
96	96	1924-12-27	1997-02-01	44814724
75	75	2004-09-17	2019-01-25	44814724
64	64	1974-10-24	2018-11-08	44814724
86	86	1947-10-28	2019-06-04	44814724
93	93	1975-12-15	2018-12-30	44814724
122	122	1979-07-15	2018-11-11	44814724
113	113	2010-06-23	2019-06-26	44814724
103	103	1967-05-28	2019-01-06	44814724
108	108	2000-03-12	2019-01-13	44814724
95	95	1957-08-29	2019-06-27	44814724
84	84	1974-03-14	2018-03-29	44814724
66	66	1958-06-27	2018-07-13	44814724
73	73	1985-12-17	2017-08-22	44814724
110	110	1976-02-15	2019-02-24	44814724
101	101	1926-11-19	2018-08-10	44814724
115	115	1959-11-01	2019-05-05	44814724
120	120	1978-01-07	2019-06-08	44814724
104	104	2015-03-17	2019-02-19	44814724
99	99	1958-10-25	2019-04-27	44814724
117	117	1968-10-05	2018-10-06	44814724
126	126	1947-07-22	2019-02-19	44814724
89	89	2012-01-01	2018-12-23	44814724
82	82	1961-03-21	2019-06-25	44814724
68	68	2003-02-25	2019-04-09	44814724
79	79	1946-04-26	2019-01-19	44814724
124	124	1984-03-06	2017-06-12	44814724
119	119	1955-12-28	2019-03-13	44814724
97	97	1943-07-19	2018-08-27	44814724
106	106	2008-05-04	2019-05-19	44814724
77	77	1990-02-07	2019-05-22	44814724
70	70	1948-04-11	2019-04-24	44814724
80	80	1936-11-09	2019-04-15	44814724
91	91	1985-07-24	2018-09-29	44814724
156	156	1978-10-22	2018-11-04	44814724
151	151	2001-12-28	2019-03-15	44814724
129	129	1974-10-07	2018-07-02	44814724
138	138	1999-02-01	2018-05-21	44814724
173	173	1968-03-24	2018-08-05	44814724
166	166	2011-11-24	2018-11-15	44814724
176	176	1964-11-25	2018-12-20	44814724
187	187	1945-07-23	2018-11-19	44814724
136	136	1998-06-12	2019-06-22	44814724
131	131	1982-05-19	2019-05-13	44814724
149	149	1941-08-20	2018-10-31	44814724
158	158	1947-01-04	2019-05-04	44814724
185	185	1946-05-12	2019-06-09	44814724
178	178	2005-10-02	2019-05-26	44814724
164	164	1966-01-04	2019-06-04	44814724
175	175	1989-03-01	2017-05-10	44814724
191	191	1920-06-01	2003-07-22	44814724
180	180	1977-04-21	2019-05-02	44814724
162	162	1938-11-22	2018-10-16	44814724
169	169	1988-03-28	2019-06-10	44814724
142	142	1975-10-28	2019-05-14	44814724
133	133	1980-12-15	2019-04-06	44814724
147	147	1999-01-12	2018-08-28	44814724
152	152	1966-10-31	2018-10-29	44814724
171	171	1968-03-11	2019-03-18	44814724
160	160	1961-07-27	2019-04-11	44814724
182	182	1950-09-10	2019-02-17	44814724
189	189	1958-05-12	2018-10-08	44814724
236	236	1951-03-22	2018-06-28	44814724
145	145	1948-11-30	2019-03-26	44814724
135	135	1971-06-16	2018-11-14	44814724
140	140	1969-06-05	2019-06-06	44814724
167	167	2006-05-29	2019-06-03	44814724
172	172	2000-02-22	2018-08-07	44814724
186	186	1971-11-22	2019-03-25	44814724
177	177	1966-04-25	2019-05-13	44814724
150	150	1998-05-14	2019-04-25	44814724
157	157	1982-02-23	2018-05-08	44814724
139	139	2004-05-14	2019-06-21	44814724
128	128	1988-06-12	2019-06-27	44814724
179	179	1990-10-10	2019-02-13	44814724
184	184	1946-01-28	2019-04-10	44814724
174	174	1997-05-07	2019-06-26	44814724
165	165	1968-06-12	2018-09-01	44814724
130	130	1993-07-10	2018-11-24	44814724
137	137	1971-07-01	2019-01-31	44814724
159	159	1954-01-19	2018-06-26	44814724
148	148	1978-10-15	2018-10-21	44814724
132	132	2000-01-22	2019-05-11	44814724
143	143	1964-11-01	2018-11-25	44814724
153	153	1943-06-10	2018-11-01	44814724
146	146	1984-06-19	2019-02-12	44814724
181	181	1973-09-16	2017-10-01	44814724
190	190	1930-07-08	2016-04-12	44814724
168	168	1997-03-26	2019-04-25	44814724
163	163	1966-06-28	2018-07-10	44814724
144	144	1974-12-20	2019-01-04	44814724
155	155	1954-05-07	2018-12-14	44814724
141	141	1984-02-29	2019-01-02	44814724
134	134	2014-07-26	2019-06-28	44814724
161	161	1977-12-25	2018-07-03	44814724
170	170	1971-02-05	2018-02-09	44814724
188	188	1962-11-18	2019-05-26	44814724
183	183	1974-10-24	2019-03-16	44814724
234	234	1999-06-05	2019-05-09	44814724
225	225	1965-01-04	2018-11-04	44814724
247	247	1993-11-17	2019-04-22	44814724
252	252	2002-12-25	2019-02-06	44814724
219	219	1968-03-30	2019-06-22	44814724
208	208	1998-07-05	2017-09-03	44814724
198	198	2010-07-23	2018-07-20	44814724
205	205	1993-05-12	2018-10-01	44814724
254	254	1950-09-22	2006-05-12	44814724
245	245	1916-06-18	2018-09-23	44814724
227	227	1971-09-17	2019-05-06	44814724
232	232	1944-11-01	2019-01-23	44814724
207	207	1940-10-21	2019-05-27	44814724
196	196	1954-10-16	2018-11-03	44814724
210	210	1993-03-03	2018-12-19	44814724
217	217	1975-04-08	2018-03-13	44814724
201	201	2013-09-29	2018-10-03	44814724
194	194	1980-03-20	2018-01-25	44814724
212	212	1970-03-21	2019-05-11	44814724
223	223	1995-11-30	2019-06-27	44814724
248	248	1972-08-01	2019-05-28	44814724
243	243	2016-09-27	2019-03-16	44814724
229	229	2017-09-11	2019-03-08	44814724
238	238	2010-04-20	2019-05-28	44814724
221	221	2012-05-19	2019-05-11	44814724
214	214	2000-12-06	2019-04-17	44814724
192	192	1939-10-18	2018-09-26	44814724
203	203	2009-12-14	2019-05-13	44814724
319	319	1990-09-08	2016-10-12	44814724
231	231	2008-02-13	2019-02-27	44814724
241	241	1951-09-25	1980-01-15	44814724
250	250	1974-02-13	2018-06-13	44814724
209	209	1951-02-23	2019-06-07	44814724
218	218	2018-01-15	2019-06-24	44814724
204	204	1984-12-31	2016-09-12	44814724
199	199	1941-04-02	2019-04-03	44814724
224	224	1942-10-13	2019-06-25	44814724
235	235	1981-05-11	2017-06-19	44814724
253	253	2018-08-16	2019-06-12	44814724
246	246	1959-11-26	2019-06-20	44814724
197	197	1960-09-18	2018-12-02	44814724
206	206	1996-08-09	2019-05-03	44814724
216	216	2016-11-19	2019-03-02	44814724
211	211	1967-10-13	2019-01-11	44814724
244	244	1922-02-27	1997-02-24	44814724
255	255	1995-10-18	2017-12-20	44814724
233	233	1989-01-05	2018-12-27	44814724
226	226	1995-07-03	2018-09-12	44814724
242	242	1982-03-21	2016-08-28	44814724
249	249	1981-08-23	2019-04-26	44814724
239	239	1945-10-25	2012-07-12	44814724
228	228	1990-01-15	2016-10-10	44814724
195	195	1958-03-17	2018-11-12	44814724
200	200	1991-06-11	2017-03-21	44814724
222	222	1951-09-14	2018-12-21	44814724
213	213	1967-05-01	2018-07-02	44814724
230	230	1998-05-12	2017-08-22	44814724
237	237	1999-03-28	2015-10-25	44814724
251	251	2002-12-16	2018-12-10	44814724
240	240	2003-12-04	2019-03-28	44814724
215	215	2002-08-21	2019-05-22	44814724
220	220	1982-09-01	2019-01-23	44814724
202	202	1938-09-10	2019-01-19	44814724
193	193	1986-03-20	2019-02-07	44814724
313	313	1961-09-25	1969-01-27	44814724
306	306	2010-04-09	2019-04-12	44814724
292	292	1975-12-13	2017-11-04	44814724
303	303	1996-12-23	2016-12-05	44814724
264	264	1951-07-27	2011-11-18	44814724
259	259	2005-08-30	2019-06-26	44814724
277	277	1963-12-31	2019-01-29	44814724
286	286	1928-05-05	2019-05-23	44814724
301	301	1993-07-04	2019-06-16	44814724
294	294	2012-06-17	2019-05-26	44814724
304	304	1956-05-07	2019-06-17	44814724
315	315	2013-01-27	2019-01-13	44814724
284	284	2013-01-07	2018-12-17	44814724
279	279	1951-11-30	2018-11-23	44814724
257	257	1983-12-13	2018-11-20	44814724
266	266	1966-05-02	2019-05-20	44814724
282	282	1963-07-13	1978-11-04	44814724
273	273	1975-09-14	2019-02-25	44814724
263	263	1954-06-20	2018-09-10	44814724
268	268	1967-02-21	2019-05-23	44814724
299	299	1961-12-09	2019-01-19	44814724
288	288	2001-08-25	2019-06-08	44814724
310	310	1949-06-18	2019-03-09	44814724
317	317	1992-02-22	2018-06-02	44814724
270	270	1958-02-04	2019-03-12	44814724
261	261	1980-09-18	2017-12-07	44814724
275	275	1987-07-10	2018-09-21	44814724
280	280	1938-10-28	2019-06-04	44814724
329	329	1987-03-17	2019-01-29	44814724
308	308	1959-07-21	2018-12-18	44814724
290	290	1993-06-03	2018-08-09	44814724
297	297	1951-06-18	2018-11-27	44814724
258	258	2015-02-12	2019-01-17	44814724
265	265	2005-05-25	2019-06-26	44814724
287	287	1976-03-15	2018-09-17	44814724
276	276	1977-06-10	2018-10-26	44814724
307	307	1969-06-21	2019-03-09	44814724
312	312	1972-01-24	2018-03-12	44814724
302	302	2010-03-10	2019-03-13	44814724
293	293	1964-10-13	2018-10-09	44814724
278	278	2000-02-09	2018-12-12	44814724
285	285	1970-05-25	2018-06-18	44814724
267	267	2014-06-24	2019-06-04	44814724
256	256	1998-11-11	2018-10-17	44814724
295	295	1949-06-16	2018-10-04	44814724
300	300	1972-03-24	2017-07-21	44814724
314	314	1993-01-20	2017-08-23	44814724
305	305	2005-10-26	2018-11-21	44814724
289	289	1959-03-17	2018-09-18	44814724
298	298	1952-04-08	2019-02-12	44814724
316	316	1927-08-02	2019-04-23	44814724
311	311	1977-07-27	2019-01-30	44814724
272	272	1991-10-25	2017-02-10	44814724
283	283	1980-09-01	2019-04-10	44814724
269	269	1990-05-15	2019-05-14	44814724
262	262	1964-08-03	2018-08-27	44814724
309	309	2013-05-10	2019-04-26	44814724
318	318	1953-05-05	2018-10-02	44814724
296	296	1978-09-13	2017-07-19	44814724
291	291	1991-06-24	2016-07-25	44814724
260	260	1969-07-12	2017-08-05	44814724
271	271	1983-10-16	2018-10-07	44814724
281	281	2013-08-12	2018-07-23	44814724
274	274	2012-02-06	2019-01-28	44814724
335	335	1963-06-18	2018-07-03	44814724
324	324	1997-12-17	2017-09-27	44814724
338	338	1967-04-19	2019-05-01	44814724
345	345	2015-08-21	2019-01-25	44814724
382	382	1989-04-01	2017-04-01	44814724
373	373	2018-07-20	2019-06-28	44814724
355	355	2018-10-17	2019-06-26	44814724
360	360	2000-12-30	2019-06-22	44814724
347	347	1969-10-19	2018-12-09	44814724
336	336	1998-01-16	2017-12-01	44814724
326	326	1970-06-01	2018-06-25	44814724
333	333	1984-04-26	2018-07-19	44814724
362	362	1981-04-21	2019-02-05	44814724
353	353	2011-03-12	2019-03-09	44814724
375	375	2013-06-20	2019-06-20	44814724
380	380	1971-11-13	2017-12-02	44814724
364	364	1945-09-30	2018-09-30	44814724
359	359	1977-10-22	2017-10-28	44814724
369	369	1980-12-27	2018-07-18	44814724
378	378	2010-04-25	2019-05-28	44814724
349	349	1957-08-31	2019-05-04	44814724
342	342	2001-10-30	2019-01-31	44814724
320	320	1956-02-19	2019-03-31	44814724
331	331	1935-05-02	2018-11-30	44814724
376	376	1961-04-27	2019-06-13	44814724
371	371	1968-02-02	2019-02-15	44814724
357	357	1954-10-13	2019-01-02	44814724
366	366	1911-02-19	2019-05-19	44814724
421	421	1965-06-16	2018-07-04	44814724
322	322	1992-12-30	2018-09-19	44814724
340	340	1958-05-14	2018-07-11	44814724
351	351	1977-11-29	2018-06-29	44814724
372	372	1961-05-13	2019-06-29	44814724
383	383	2014-06-15	2019-06-08	44814724
361	361	2005-03-18	2019-04-19	44814724
354	354	1956-01-06	2019-03-22	44814724
325	325	1982-12-05	2017-04-23	44814724
334	334	1935-06-06	2017-11-16	44814724
344	344	1999-09-25	2018-11-24	44814724
339	339	1982-08-14	2017-12-02	44814724
352	352	1977-07-18	2017-07-24	44814724
363	363	1964-07-07	2018-07-31	44814724
381	381	1994-10-03	2017-06-26	44814724
374	374	1979-11-08	2017-05-25	44814724
337	337	1959-09-23	2018-11-14	44814724
346	346	2006-07-19	2019-03-29	44814724
332	332	1963-06-14	2019-04-12	44814724
327	327	1971-02-01	2018-02-09	44814724
343	343	1970-01-31	2018-02-24	44814724
348	348	1975-07-28	2017-08-07	44814724
330	330	2001-08-16	2019-04-11	44814724
321	321	1961-11-12	2019-03-24	44814724
358	358	1939-12-26	2012-08-07	44814724
365	365	1991-09-08	2018-02-19	44814724
379	379	1975-03-29	2019-03-06	44814724
368	368	1971-10-06	2017-10-25	44814724
323	323	1992-04-30	2017-07-06	44814724
328	328	1978-10-29	2019-04-14	44814724
350	350	1959-09-18	2019-04-15	44814724
341	341	1960-07-11	2018-12-03	44814724
370	370	1963-05-02	2019-06-06	44814724
377	377	1967-02-02	2018-10-25	44814724
367	367	1997-11-03	2018-01-29	44814724
356	356	2013-03-05	2018-10-16	44814724
419	419	1911-07-31	1995-12-18	44814724
424	424	1994-04-01	2018-06-22	44814724
446	446	1989-07-12	2016-10-25	44814724
437	437	1946-02-12	2019-06-25	44814724
402	402	1993-03-20	2019-06-22	44814724
409	409	1950-10-06	2019-01-18	44814724
399	399	1955-04-03	2018-12-23	44814724
388	388	1954-09-14	2018-09-18	44814724
439	439	1977-09-29	2018-08-30	44814724
444	444	1981-09-20	2018-09-09	44814724
426	426	1966-01-13	2018-09-27	44814724
417	417	1919-08-04	1925-09-07	44814724
390	390	1975-02-05	2019-06-05	44814724
397	397	2002-01-29	2019-03-19	44814724
411	411	1959-02-21	2019-04-20	44814724
400	400	1999-11-19	2018-09-14	44814724
384	384	1960-05-30	2019-05-27	44814724
395	395	1960-02-16	2019-04-09	44814724
413	413	2018-08-28	2019-05-07	44814724
406	406	1952-02-20	2019-04-10	44814724
433	433	1997-11-21	2017-11-10	44814724
442	442	1947-08-23	2019-01-18	44814724
428	428	1983-02-06	2017-11-12	44814724
423	423	1997-02-11	2019-04-01	44814724
404	404	1960-06-14	2019-03-26	44814724
415	415	2011-08-01	2018-07-23	44814724
393	393	1957-01-09	2019-01-09	44814724
386	386	1984-10-17	2019-05-17	44814724
467	467	2001-02-10	2018-09-22	44814724
430	430	1931-06-20	2012-10-20	44814724
440	440	1972-12-13	2018-04-18	44814724
435	435	2008-03-16	2018-11-04	44814724
408	408	1961-06-08	2018-09-06	44814724
403	403	1922-02-27	2019-05-27	44814724
389	389	1996-03-28	1996-11-07	44814724
398	398	1924-12-27	1967-02-18	44814724
425	425	1980-06-27	2018-02-24	44814724
418	418	1957-09-23	2019-04-29	44814724
436	436	2017-01-22	2019-06-30	44814724
447	447	1998-04-02	2017-06-01	44814724
396	396	2017-03-17	2019-02-22	44814724
391	391	1994-08-22	2018-03-25	44814724
401	401	1985-12-27	2017-03-10	44814724
410	410	1949-09-01	2019-03-08	44814724
445	445	1911-09-22	1996-06-07	44814724
438	438	1998-05-09	2019-04-02	44814724
416	416	2012-06-09	2019-06-01	44814724
427	427	2015-04-30	2019-04-04	44814724
443	443	1968-12-17	2018-12-18	44814724
432	432	1930-06-02	2018-07-16	44814724
422	422	1959-01-11	2019-04-28	44814724
429	429	1998-05-20	2018-06-25	44814724
394	394	1919-08-04	1998-01-05	44814724
385	385	2000-07-07	2018-11-23	44814724
407	407	1990-02-25	2019-02-24	44814724
412	412	1953-05-15	2004-06-25	44814724
431	431	1948-01-02	2018-09-28	44814724
420	420	2009-06-03	2019-02-06	44814724
434	434	1986-03-22	2018-12-17	44814724
441	441	2006-01-27	2019-02-22	44814724
414	414	2002-10-10	2019-02-07	44814724
405	405	2014-08-22	2018-07-27	44814724
387	387	1973-08-31	2017-09-15	44814724
392	392	1975-07-04	2019-02-08	44814724
469	469	1935-11-30	2018-10-27	44814724
478	478	2010-09-04	2018-09-01	44814724
456	456	1988-11-03	2018-06-20	44814724
451	451	2008-07-27	2018-08-05	44814724
484	484	1938-01-03	2019-07-01	44814724
495	495	1968-05-18	2019-05-25	44814724
505	505	1968-06-04	2019-03-05	44814724
498	498	1970-03-26	2018-04-19	44814724
449	449	1959-10-29	2018-09-13	44814724
458	458	1972-08-13	2017-07-23	44814724
476	476	1967-09-16	2018-12-27	44814724
471	471	1985-05-04	2017-09-11	44814724
496	496	1986-08-29	2016-07-22	44814724
507	507	1938-08-20	2016-04-30	44814724
493	493	1997-11-07	2017-04-21	44814724
486	486	1960-11-03	2019-02-14	44814724
502	502	1947-01-11	2018-11-03	44814724
509	509	2000-01-23	2019-03-24	44814724
491	491	1992-12-06	2017-12-24	44814724
480	480	1937-05-20	2018-10-18	44814724
455	455	1950-01-31	2019-06-13	44814724
460	460	1984-10-28	2019-03-24	44814724
474	474	1969-12-14	2017-09-17	44814724
465	465	1984-01-12	2008-07-03	44814724
482	482	1969-10-23	2019-05-16	44814724
489	489	1975-06-01	2017-07-17	44814724
511	511	2015-08-16	2019-01-20	44814724
500	500	1961-09-19	2019-02-19	44814724
515	515	1941-03-22	2019-04-20	44814724
472	472	1976-01-26	2018-10-29	44814724
462	462	1976-09-16	2017-12-21	44814724
453	453	1970-05-16	2018-05-05	44814724
494	494	2018-08-26	2019-05-05	44814724
485	485	1989-05-23	2018-03-06	44814724
499	499	1959-04-25	2018-07-14	44814724
504	504	2013-06-30	2019-06-16	44814724
479	479	1939-10-23	2018-09-22	44814724
468	468	2013-04-04	2019-03-21	44814724
450	450	1967-04-10	2019-05-06	44814724
457	457	1951-08-14	2019-05-28	44814724
506	506	2007-05-11	2019-03-01	44814724
497	497	2008-05-26	2019-06-10	44814724
487	487	1965-05-20	2019-01-31	44814724
492	492	1946-12-13	2018-11-16	44814724
459	459	1970-09-01	2018-09-25	44814724
448	448	1998-12-23	2018-02-28	44814724
470	470	1955-01-11	2019-03-12	44814724
477	477	1987-05-03	2017-07-10	44814724
461	461	1948-07-27	2018-12-19	44814724
454	454	1935-03-02	2019-03-23	44814724
464	464	1972-05-16	2018-12-01	44814724
475	475	2006-04-15	2019-06-15	44814724
508	508	2004-09-04	2018-10-26	44814724
503	503	1980-07-26	2017-10-14	44814724
481	481	1986-08-13	2017-09-06	44814724
490	490	2004-05-30	2019-05-22	44814724
473	473	1990-06-12	2019-06-11	44814724
466	466	1984-12-21	2019-06-07	44814724
452	452	1962-09-08	2019-04-18	44814724
463	463	1997-08-27	2017-07-26	44814724
488	488	1954-10-02	2018-09-15	44814724
483	483	1993-06-26	2018-07-21	44814724
501	501	2012-11-10	2018-09-29	44814724
510	510	1965-10-03	2018-10-21	44814724
517	517	1986-04-15	2019-05-07	44814724
526	526	1971-02-25	2019-03-21	44814724
536	536	2012-04-20	2019-06-24	44814724
531	531	2017-03-01	2019-05-25	44814724
564	564	1955-10-20	2018-09-27	44814724
575	575	2004-09-04	2019-06-18	44814724
553	553	1993-08-01	2019-03-10	44814724
546	546	1943-11-14	2019-04-07	44814724
529	529	2005-01-14	2019-02-15	44814724
538	538	2013-01-13	2018-12-30	44814724
524	524	1989-08-14	2019-05-13	44814724
519	519	2014-11-05	2018-10-10	44814724
544	544	1997-07-18	2018-06-02	44814724
555	555	1987-06-06	2017-11-04	44814724
573	573	1959-11-01	2018-09-09	44814724
566	566	2006-05-08	2019-05-31	44814724
550	550	1919-11-19	2002-06-26	44814724
557	557	1985-10-27	2018-02-25	44814724
571	571	1954-08-30	2019-07-01	44814724
560	560	1999-11-30	2008-01-15	44814724
535	535	1987-05-12	2018-07-24	44814724
540	540	2018-05-14	2019-04-22	44814724
522	522	1986-07-09	2018-10-03	44814724
513	513	2008-10-26	2019-05-07	44814724
562	562	1999-03-28	2018-05-27	44814724
569	569	1912-04-28	2018-12-09	44814724
559	559	1968-10-21	2018-10-22	44814724
548	548	1989-05-24	2018-09-27	44814724
629	629	2000-10-15	2018-12-09	44814724
520	520	1950-11-09	2019-02-21	44814724
542	542	2011-02-23	2019-02-20	44814724
533	533	1962-08-02	2018-08-16	44814724
574	574	2013-03-31	2019-03-11	44814724
565	565	1957-07-25	2018-09-27	44814724
547	547	1995-04-16	2019-01-20	44814724
552	552	1951-09-18	2019-01-01	44814724
527	527	1992-09-23	2019-06-05	44814724
516	516	1999-04-08	2019-06-15	44814724
530	530	1997-09-23	2019-06-04	44814724
537	537	1980-04-02	2018-01-24	44814724
554	554	1995-08-31	2018-06-07	44814724
545	545	1971-10-09	2018-09-30	44814724
567	567	1996-11-25	2019-04-22	44814724
572	572	1953-10-23	2018-11-30	44814724
539	539	1933-03-27	1999-08-02	44814724
528	528	1959-05-29	2018-07-20	44814724
518	518	1970-06-30	2019-03-26	44814724
525	525	1949-04-04	2018-07-23	44814724
541	541	2005-01-25	2019-02-26	44814724
534	534	1978-06-20	2018-06-26	44814724
512	512	1954-02-20	2018-07-14	44814724
523	523	1988-05-26	2017-05-01	44814724
556	556	2014-05-16	2019-04-26	44814724
551	551	2014-01-28	2019-01-08	44814724
561	561	2015-02-05	2019-01-03	44814724
570	570	1995-09-26	2017-11-28	44814724
521	521	1972-09-22	1987-06-05	44814724
514	514	1993-05-04	2019-03-19	44814724
532	532	2007-02-24	2019-03-16	44814724
543	543	1979-08-26	2016-11-25	44814724
568	568	1999-06-03	2019-04-30	44814724
563	563	1964-04-12	2005-03-20	44814724
549	549	1952-07-31	2018-10-04	44814724
558	558	1960-11-03	2018-12-20	44814724
627	627	1980-03-09	2017-09-10	44814724
632	632	1954-06-02	1959-04-22	44814724
622	622	1987-08-31	2018-03-23	44814724
613	613	1935-11-15	2019-06-14	44814724
578	578	1967-05-31	2019-05-29	44814724
585	585	1987-01-14	2019-02-20	44814724
607	607	1950-12-15	2019-02-08	44814724
596	596	1948-02-17	2005-06-28	44814724
615	615	1910-01-22	2019-06-27	44814724
620	620	1995-05-13	2018-07-25	44814724
634	634	2006-07-15	2019-01-12	44814724
625	625	1972-12-05	2018-12-25	44814724
598	598	1974-09-20	2018-11-09	44814724
605	605	1956-06-15	2019-03-08	44814724
587	587	1978-03-22	2018-05-30	44814724
576	576	1966-09-01	2018-11-01	44814724
592	592	1969-11-28	2018-10-12	44814724
603	603	1956-03-09	2019-04-19	44814724
589	589	2012-06-19	2019-05-07	44814724
582	582	1959-03-04	2019-05-08	44814724
609	609	1967-12-12	2018-12-18	44814724
618	618	2008-09-28	2019-05-19	44814724
636	636	1948-03-12	2019-04-12	44814724
631	631	2011-08-06	2018-07-28	44814724
580	580	1926-11-07	2019-05-19	44814724
591	591	2003-03-12	2018-10-24	44814724
601	601	1969-11-16	2019-03-24	44814724
594	594	1984-05-04	2019-02-15	44814724
665	665	1955-07-01	2018-10-12	44814724
638	638	2012-06-24	2019-06-16	44814724
616	616	1959-01-03	2019-04-21	44814724
611	611	2002-06-11	2019-05-14	44814724
584	584	2014-04-06	2019-06-11	44814724
579	579	1961-03-22	2018-10-10	44814724
597	597	1952-05-05	2018-12-10	44814724
606	606	1975-02-12	2018-05-23	44814724
633	633	2009-09-18	2019-05-10	44814724
626	626	1985-06-15	2016-09-17	44814724
612	612	2016-04-06	2019-03-13	44814724
623	623	1990-07-08	2018-11-25	44814724
604	604	1986-04-27	2018-07-16	44814724
599	599	1989-05-25	2018-06-14	44814724
577	577	1987-05-04	2018-10-15	44814724
586	586	1983-01-04	2019-06-03	44814724
621	621	1912-08-21	2019-04-10	44814724
614	614	1963-09-01	2019-02-24	44814724
624	624	1940-10-26	2019-05-28	44814724
635	635	2007-11-20	2019-06-06	44814724
619	619	2007-10-02	2018-10-16	44814724
608	608	1973-12-19	2018-01-03	44814724
630	630	2019-01-21	2019-05-13	44814724
637	637	2001-04-02	2019-05-27	44814724
602	602	2001-04-06	2019-05-24	44814724
593	593	1992-09-09	2018-12-25	44814724
583	583	2006-11-26	2018-12-16	44814724
588	588	1981-01-29	2018-06-28	44814724
639	639	1953-01-03	2019-05-18	44814724
628	628	1985-05-23	2016-07-21	44814724
610	610	1962-08-30	2018-10-04	44814724
617	617	1987-11-05	2017-07-13	44814724
590	590	1985-06-11	2018-06-27	44814724
581	581	1994-01-23	2019-03-31	44814724
595	595	1988-12-28	2019-01-22	44814724
600	600	1954-01-07	2018-08-09	44814724
671	671	1997-05-07	2019-04-24	44814724
660	660	1993-03-10	2018-12-19	44814724
642	642	1934-12-30	2018-07-15	44814724
649	649	1968-02-14	2019-02-20	44814724
686	686	1945-10-13	2018-09-29	44814724
677	677	1961-06-02	2018-07-13	44814724
691	691	1957-09-10	2019-06-20	44814724
696	696	1969-01-09	1991-07-18	44814724
651	651	1977-05-05	2018-12-06	44814724
640	640	1946-11-04	2018-09-17	44814724
662	662	1960-09-21	2018-11-07	44814724
669	669	1969-10-01	2018-11-21	44814724
698	698	2004-10-04	2019-01-01	44814724
689	689	1982-02-21	2019-04-21	44814724
679	679	1972-04-07	2017-06-30	44814724
684	684	2006-03-20	2019-03-18	44814724
700	700	1978-06-14	2018-05-30	44814724
695	695	1968-10-21	2018-11-26	44814724
673	673	1961-09-22	2018-10-19	44814724
682	682	1970-11-18	2018-03-28	44814724
653	653	1953-01-31	2019-03-16	44814724
646	646	1980-06-10	2019-04-30	44814724
656	656	1964-01-04	2018-07-07	44814724
667	667	1986-06-15	2017-06-11	44814724
680	680	1967-09-26	2019-01-22	44814724
675	675	1948-02-17	2019-06-07	44814724
693	693	1951-01-02	2019-01-29	44814724
702	702	1956-06-07	1972-01-20	44814724
751	751	1986-01-13	2017-08-28	44814724
658	658	2016-03-31	2019-03-23	44814724
644	644	1975-10-23	2019-06-13	44814724
655	655	1959-12-12	2019-04-27	44814724
676	676	1980-03-25	2017-09-26	44814724
687	687	1967-01-21	2019-03-23	44814724
697	697	1965-04-14	2019-05-01	44814724
690	690	1997-08-28	2017-03-09	44814724
661	661	2005-01-06	2019-02-07	44814724
670	670	1973-11-03	2018-09-13	44814724
648	648	1932-12-16	2019-03-29	44814724
643	643	2001-08-29	2018-10-17	44814724
688	688	2007-08-30	2018-07-05	44814724
699	699	2004-07-22	2018-08-24	44814724
685	685	1966-02-07	2019-02-25	44814724
678	678	1977-09-18	2017-09-30	44814724
641	641	2005-11-12	2018-12-29	44814724
650	650	2004-02-21	2019-04-06	44814724
668	668	2009-10-11	2019-01-24	44814724
663	663	1993-09-05	2018-11-11	44814724
647	647	2014-08-29	2018-08-03	44814724
652	652	1968-02-13	2019-01-15	44814724
666	666	1986-07-20	2018-09-21	44814724
657	657	2017-05-25	2019-03-28	44814724
694	694	2016-10-07	2019-03-15	44814724
701	701	1957-08-31	2019-03-02	44814724
683	683	2014-08-31	2019-05-13	44814724
672	672	1955-05-02	2019-02-11	44814724
659	659	1980-06-18	2018-06-20	44814724
664	664	1981-07-10	2018-09-28	44814724
654	654	1962-02-16	2018-09-07	44814724
645	645	1980-07-27	2018-10-07	44814724
674	674	1991-05-13	2018-04-15	44814724
681	681	1990-07-13	2018-09-29	44814724
703	703	1949-12-23	2019-02-01	44814724
692	692	1993-06-05	2018-10-13	44814724
745	745	2001-10-24	2019-06-16	44814724
738	738	1978-07-05	2018-10-17	44814724
756	756	1965-08-04	2019-02-27	44814724
767	767	1986-05-01	2018-12-29	44814724
728	728	1955-01-22	2019-04-13	44814724
723	723	1960-11-10	2018-08-30	44814724
709	709	1949-07-04	2005-09-05	44814724
718	718	1966-02-26	2019-03-16	44814724
765	765	1987-02-18	2019-05-06	44814724
758	758	1973-03-25	2018-06-03	44814724
736	736	1972-01-06	2017-09-21	44814724
747	747	1963-09-21	2018-10-20	44814724
716	716	1988-01-28	2008-05-15	44814724
711	711	1950-12-22	2018-11-23	44814724
721	721	1983-07-25	2019-06-17	44814724
730	730	1957-04-14	2018-12-16	44814724
714	714	2019-02-15	2019-05-24	44814724
705	705	1994-10-17	2017-07-17	44814724
727	727	1912-11-02	2019-05-18	44814724
732	732	1972-04-13	2018-05-03	44814724
763	763	1965-03-18	2019-04-11	44814724
752	752	1946-11-10	2018-12-16	44814724
742	742	1925-03-17	2014-10-28	44814724
749	749	2010-01-02	2018-11-17	44814724
734	734	2001-03-11	2018-09-02	44814724
725	725	1993-08-06	2019-04-26	44814724
707	707	2012-07-01	2019-06-29	44814724
712	712	1974-11-07	2018-12-25	44814724
828	828	1952-07-22	2005-06-21	44814724
740	740	2014-06-02	2019-05-13	44814724
754	754	1937-08-24	2019-06-20	44814724
761	761	1978-12-15	2018-04-13	44814724
722	722	1969-02-12	2019-02-13	44814724
729	729	1961-07-01	2019-03-30	44814724
719	719	1980-11-15	2019-05-04	44814724
708	708	1989-07-16	2018-04-22	44814724
739	739	1909-07-07	1993-08-25	44814724
744	744	1952-03-28	2019-03-22	44814724
766	766	2001-09-10	2019-03-18	44814724
757	757	1914-11-08	1998-10-25	44814724
710	710	1961-04-18	2019-06-04	44814724
717	717	2005-01-09	2019-04-21	44814724
731	731	2012-02-25	2019-02-16	44814724
720	720	1964-08-29	2019-05-21	44814724
759	759	1945-01-04	2018-09-20	44814724
764	764	1969-07-15	2018-05-29	44814724
746	746	2005-12-02	2018-08-04	44814724
737	737	2019-05-27	2019-07-01	44814724
753	753	1967-09-24	2019-04-21	44814724
762	762	1954-07-14	2019-02-13	44814724
748	748	1990-07-31	2018-07-14	44814724
743	743	1975-11-02	2017-10-08	44814724
704	704	1965-12-08	2019-05-30	44814724
715	715	1983-02-15	2018-02-20	44814724
733	733	1941-09-04	2018-08-30	44814724
726	726	1953-08-30	2018-07-13	44814724
741	741	1974-11-29	2019-05-17	44814724
750	750	2017-03-23	2019-02-28	44814724
760	760	1964-11-25	2018-12-19	44814724
755	755	1947-07-05	2019-05-25	44814724
724	724	2002-11-04	2019-05-13	44814724
735	735	1990-07-05	2019-01-31	44814724
713	713	2014-09-19	2019-03-09	44814724
706	706	1985-12-10	2017-01-24	44814724
826	826	1958-07-17	2019-06-20	44814724
817	817	1957-05-17	2019-02-08	44814724
807	807	1951-01-16	2019-03-19	44814724
812	812	1963-07-13	2018-11-03	44814724
779	779	2001-12-16	2019-06-09	44814724
768	768	1996-04-03	2019-05-03	44814724
790	790	2008-11-24	2018-12-03	44814724
797	797	2000-07-03	2019-06-24	44814724
814	814	1980-07-13	2018-05-13	44814724
805	805	1998-10-19	2018-05-28	44814724
819	819	1992-07-11	2017-12-23	44814724
824	824	2014-10-04	2018-09-08	44814724
799	799	1993-01-29	2018-04-06	44814724
788	788	1969-09-10	2017-12-27	44814724
770	770	2011-04-01	2019-05-27	44814724
777	777	1994-05-08	2017-11-21	44814724
793	793	1973-06-07	2017-12-01	44814724
786	786	2005-08-05	2019-05-17	44814724
772	772	2002-10-28	2019-05-01	44814724
783	783	1981-03-22	2018-09-16	44814724
808	808	2005-01-19	2019-02-20	44814724
803	803	1986-02-26	2018-02-14	44814724
821	821	1948-06-12	2019-01-26	44814724
830	830	1958-11-26	2018-10-10	44814724
781	781	2002-02-08	2019-05-31	44814724
774	774	1966-07-25	2019-06-10	44814724
784	784	1959-05-02	2018-12-15	44814724
795	795	1936-08-19	2018-12-17	44814724
842	842	1909-11-27	2018-11-10	44814724
823	823	1944-11-20	2019-02-04	44814724
801	801	1980-05-15	2019-06-06	44814724
810	810	1985-12-22	2017-09-17	44814724
769	769	1981-12-19	2018-04-17	44814724
778	778	1978-01-19	2017-08-17	44814724
796	796	2001-01-18	2019-06-27	44814724
791	791	1989-06-05	2017-08-14	44814724
816	816	1979-03-31	2017-12-30	44814724
827	827	1994-10-31	2017-03-06	44814724
813	813	2008-09-26	2019-05-24	44814724
806	806	1956-12-30	2019-03-10	44814724
789	789	1972-06-26	2018-07-16	44814724
798	798	1985-09-05	2018-04-26	44814724
776	776	1958-07-31	2018-09-27	44814724
771	771	1958-12-11	2019-02-07	44814724
804	804	1996-10-20	2019-02-10	44814724
815	815	2002-11-26	2019-01-08	44814724
825	825	1970-09-12	2018-09-14	44814724
818	818	2003-03-10	2018-07-02	44814724
802	802	1994-03-12	2019-06-22	44814724
809	809	1937-11-01	1961-04-10	44814724
831	831	2015-04-11	2019-03-23	44814724
820	820	1964-05-21	2019-06-20	44814724
787	787	1975-09-30	2019-05-28	44814724
792	792	2013-05-20	2019-05-06	44814724
782	782	1911-06-18	2001-07-15	44814724
773	773	1940-04-28	1967-06-18	44814724
822	822	1970-05-15	2018-06-08	44814724
829	829	1973-06-18	2018-10-08	44814724
811	811	2006-04-28	2019-06-12	44814724
800	800	1954-05-30	2018-08-19	44814724
775	775	1938-11-16	2017-03-22	44814724
780	780	1987-09-25	2016-09-30	44814724
794	794	2002-11-11	2019-03-04	44814724
785	785	1963-12-09	2019-01-07	44814724
844	844	1966-04-23	2019-05-11	44814724
839	839	2009-08-19	2018-07-11	44814724
849	849	2017-09-23	2019-03-02	44814724
858	858	1974-02-14	2018-03-01	44814724
893	893	1953-09-21	2019-05-06	44814724
886	886	1983-04-05	2019-06-15	44814724
864	864	1922-02-27	2011-03-28	44814724
875	875	1999-11-30	2019-01-21	44814724
856	856	1969-06-13	2019-06-14	44814724
851	851	1981-06-01	2018-08-20	44814724
837	837	2000-01-03	2018-12-10	44814724
846	846	1974-04-17	2019-05-28	44814724
873	873	2001-06-26	2019-03-13	44814724
866	866	1958-09-14	2019-05-12	44814724
884	884	1977-09-06	2017-09-12	44814724
895	895	1960-02-05	2018-11-30	44814724
879	879	1952-02-11	2019-05-20	44814724
868	868	1981-11-19	2019-04-18	44814724
882	882	1944-12-23	2018-09-15	44814724
889	889	1991-02-13	2018-09-27	44814724
862	862	1970-06-02	2018-06-26	44814724
853	853	1996-02-25	2019-02-17	44814724
835	835	2012-09-13	2019-03-02	44814724
840	840	1997-08-12	2017-04-04	44814724
891	891	1995-01-18	2017-03-22	44814724
880	880	2018-06-25	2019-06-03	44814724
870	870	1959-12-08	2018-07-31	44814724
877	877	1977-05-03	2019-05-14	44814724
934	934	1995-02-19	2019-04-01	44814724
833	833	1995-03-20	2019-05-23	44814724
855	855	1956-11-23	2001-04-27	44814724
860	860	1996-07-21	2019-05-29	44814724
887	887	1958-01-12	2019-06-25	44814724
892	892	1998-12-22	2018-03-28	44814724
874	874	1982-08-17	2018-05-13	44814724
865	865	1941-04-23	2018-12-26	44814724
838	838	1988-02-16	2019-04-30	44814724
845	845	2010-11-03	2019-06-26	44814724
859	859	1957-03-04	2019-05-27	44814724
848	848	2015-04-07	2019-03-12	44814724
867	867	1929-01-29	2018-09-04	44814724
872	872	1993-04-22	2018-07-19	44814724
894	894	1987-05-31	2019-03-03	44814724
885	885	1975-04-13	2019-04-28	44814724
850	850	1947-02-18	2019-05-21	44814724
857	857	1952-03-03	2016-05-30	44814724
847	847	1966-04-09	2019-01-12	44814724
836	836	1978-09-03	2018-09-09	44814724
852	852	2009-04-02	2019-02-28	44814724
863	863	1921-08-18	2019-02-21	44814724
841	841	1952-01-16	2019-04-24	44814724
834	834	1956-07-09	2019-06-24	44814724
869	869	1913-12-12	2018-12-14	44814724
878	878	1993-11-19	2019-06-11	44814724
888	888	1998-02-13	2019-01-29	44814724
883	883	1961-06-15	2018-08-23	44814724
832	832	2005-06-06	2019-03-18	44814724
843	843	1982-05-01	2016-07-16	44814724
861	861	2011-07-26	2018-07-17	44814724
854	854	1984-01-01	2018-09-23	44814724
881	881	1978-10-22	2018-10-28	44814724
890	890	1959-05-29	2018-10-19	44814724
876	876	1980-11-07	2018-07-19	44814724
871	871	1966-01-19	2019-02-06	44814724
928	928	1986-07-14	2019-03-25	44814724
939	939	1964-07-14	2018-10-16	44814724
957	957	2001-02-12	2019-04-15	44814724
950	950	1970-05-24	2018-09-09	44814724
913	913	2002-11-26	2019-05-21	44814724
922	922	2005-01-31	2019-03-04	44814724
908	908	1997-09-05	2017-08-01	44814724
903	903	1984-12-28	2018-06-15	44814724
948	948	1958-09-19	2018-11-16	44814724
959	959	1958-03-26	2019-01-09	44814724
937	937	2015-04-25	2019-03-30	44814724
930	930	1980-03-11	2018-08-24	44814724
901	901	2018-11-09	2019-04-19	44814724
910	910	1985-12-23	2019-06-12	44814724
920	920	2006-09-18	2019-02-09	44814724
915	915	1959-12-26	2019-03-30	44814724
899	899	2007-05-16	2019-06-05	44814724
904	904	2009-05-29	2018-12-28	44814724
926	926	1985-08-09	2018-01-18	44814724
917	917	1963-05-16	2019-06-20	44814724
946	946	1960-04-06	2019-06-12	44814724
953	953	1996-11-29	2019-05-17	44814724
943	943	1995-03-22	2018-11-05	44814724
932	932	1969-02-24	2019-02-25	44814724
919	919	1972-07-24	2019-06-24	44814724
924	924	1963-06-30	2019-03-03	44814724
906	906	1972-02-29	2018-03-20	44814724
897	897	1992-03-16	2017-05-22	44814724
976	976	2006-09-03	2018-12-17	44814724
941	941	1996-04-03	2005-05-04	44814724
955	955	2014-01-22	2019-03-01	44814724
944	944	2001-01-18	2019-03-14	44814724
923	923	1958-11-13	2019-01-10	44814724
912	912	1994-07-07	2017-06-22	44814724
902	902	1950-08-26	2018-06-30	44814724
909	909	1952-09-06	1985-06-22	44814724
938	938	1945-07-19	2019-06-13	44814724
929	929	1919-08-04	2005-10-17	44814724
951	951	1952-01-02	2019-01-22	44814724
956	956	1935-06-06	2018-11-01	44814724
911	911	1976-03-07	2018-09-02	44814724
900	900	1986-12-16	2018-08-28	44814724
914	914	1945-05-28	2018-10-08	44814724
921	921	1966-06-21	2018-07-03	44814724
958	958	1957-01-07	2019-01-21	44814724
949	949	1958-03-17	2019-05-20	44814724
931	931	1960-09-16	2018-11-02	44814724
936	936	1960-10-28	2018-11-16	44814724
952	952	1990-04-01	2019-02-03	44814724
947	947	1966-09-30	2018-07-20	44814724
933	933	1972-09-26	2018-10-16	44814724
942	942	1994-03-17	2019-04-25	44814724
905	905	1968-09-21	2019-04-26	44814724
898	898	2012-05-20	2019-06-23	44814724
916	916	1988-02-13	2018-10-20	44814724
927	927	2019-05-03	2019-06-07	44814724
940	940	1942-11-26	2001-12-06	44814724
935	935	1930-03-12	1994-06-01	44814724
945	945	1997-06-22	2017-04-16	44814724
954	954	1974-04-14	2019-02-24	44814724
925	925	1968-11-30	2018-10-13	44814724
918	918	1913-08-09	2016-05-28	44814724
896	896	2006-11-09	2018-12-20	44814724
907	907	2008-02-16	2019-05-27	44814724
982	982	1984-10-30	2017-09-02	44814724
989	989	2014-10-20	2018-09-24	44814724
971	971	1944-05-12	2019-03-29	44814724
960	960	1992-01-02	2019-06-27	44814724
999	999	1974-02-16	2017-10-28	44814724
1004	1004	1962-10-11	2019-01-03	44814724
1018	1018	1971-01-11	2018-06-20	44814724
1009	1009	2016-03-10	2019-02-14	44814724
962	962	1950-11-10	2019-06-14	44814724
969	969	1978-05-07	2019-02-07	44814724
991	991	1985-11-17	2017-01-29	44814724
980	980	2007-10-12	2018-11-23	44814724
1011	1011	1980-04-30	2018-06-15	44814724
1016	1016	1967-06-14	2019-06-26	44814724
1006	1006	2010-09-29	2018-08-22	44814724
997	997	1993-09-03	2018-11-16	44814724
1013	1013	1993-03-05	2018-05-18	44814724
1022	1022	1964-03-31	2019-04-30	44814724
1000	1000	1963-02-12	2019-03-19	44814724
995	995	1999-01-07	2018-03-08	44814724
964	964	1974-11-04	2018-11-19	44814724
975	975	1964-11-15	2019-04-07	44814724
985	985	1984-04-18	2018-07-18	44814724
978	978	1975-08-15	2018-11-09	44814724
993	993	1988-06-13	2019-06-24	44814724
1002	1002	1987-07-08	2018-08-15	44814724
1020	1020	1991-05-22	2018-02-21	44814724
1015	1015	1953-10-26	2019-05-28	44814724
1030	1030	2011-09-27	2018-09-18	44814724
987	987	1953-08-30	2019-06-02	44814724
973	973	1914-08-17	2018-12-25	44814724
966	966	2009-08-11	2019-01-22	44814724
1005	1005	1967-02-21	2018-11-20	44814724
998	998	1997-10-10	2017-05-26	44814724
1008	1008	2010-12-14	2018-12-11	44814724
1019	1019	2001-01-31	2019-03-27	44814724
988	988	2003-10-20	2018-11-26	44814724
983	983	1996-07-11	2018-09-13	44814724
961	961	1991-11-24	2018-07-17	44814724
970	970	1952-06-08	2019-03-15	44814724
1017	1017	1958-06-16	2018-09-03	44814724
1010	1010	1999-06-22	2018-11-06	44814724
996	996	2017-10-08	2019-03-17	44814724
1007	1007	2005-01-06	2019-04-20	44814724
968	968	2012-04-12	2018-09-27	44814724
963	963	2002-03-29	2019-05-17	44814724
981	981	2019-04-04	2019-05-09	44814724
990	990	2014-07-26	2018-11-16	44814724
974	974	1956-06-24	2018-09-02	44814724
965	965	1986-10-23	2017-10-21	44814724
979	979	2008-04-03	2019-04-18	44814724
984	984	2008-03-24	2018-10-01	44814724
1023	1023	1996-07-07	2019-02-02	44814724
1012	1012	2015-06-02	2019-05-29	44814724
994	994	1959-07-22	2018-09-12	44814724
1001	1001	2014-02-05	2019-01-16	44814724
986	986	1916-10-28	1996-08-31	44814724
977	977	2016-05-11	2019-04-17	44814724
967	967	1932-10-15	2019-02-07	44814724
972	972	1966-06-01	2019-02-06	44814724
1003	1003	1979-09-23	2017-06-04	44814724
992	992	1953-08-23	2018-11-04	44814724
1014	1014	2016-07-10	2019-06-16	44814724
1021	1021	1952-12-11	2019-06-01	44814724
1024	1024	1941-06-29	2019-06-16	44814724
1035	1035	2015-08-09	2019-01-13	44814724
1053	1053	1976-01-30	2018-05-09	44814724
1046	1046	1971-05-09	2019-06-02	44814724
1073	1073	1936-06-25	2019-04-18	44814724
1082	1082	1955-08-20	2019-03-16	44814724
1068	1068	1973-09-14	2018-11-02	44814724
1063	1063	1978-06-03	1991-02-16	44814724
1044	1044	1986-08-19	2018-05-01	44814724
1055	1055	1984-02-05	2019-05-30	44814724
1033	1033	1971-08-05	2017-08-24	44814724
1026	1026	1994-08-28	2017-07-19	44814724
1061	1061	2014-01-06	2019-06-24	44814724
1070	1070	1972-11-02	2018-12-30	44814724
1080	1080	2003-01-13	2018-12-24	44814724
1075	1075	1939-10-24	1966-10-11	44814724
1059	1059	1978-10-07	2018-10-13	44814724
1064	1064	2008-01-06	2018-12-16	44814724
1086	1086	1965-06-11	2019-04-12	44814724
1077	1077	1946-08-16	2018-12-07	44814724
1042	1042	1996-07-28	2018-09-23	44814724
1049	1049	1992-03-25	2017-10-04	44814724
1039	1039	1960-03-20	2019-05-12	44814724
1028	1028	2005-05-28	2019-06-29	44814724
1079	1079	1961-03-19	2018-10-28	44814724
1084	1084	1978-01-06	2019-03-08	44814724
1066	1066	1985-01-29	2019-03-02	44814724
1057	1057	1961-07-21	2019-06-21	44814724
1136	1136	1971-05-15	2017-07-01	44814724
1037	1037	1988-07-13	2017-10-08	44814724
1051	1051	1965-02-09	2019-05-05	44814724
1040	1040	2013-02-28	2019-05-02	44814724
1083	1083	1966-05-19	2019-06-06	44814724
1072	1072	1960-08-17	2019-04-20	44814724
1062	1062	1966-06-20	2018-07-02	44814724
1069	1069	1998-03-22	2017-10-29	44814724
1034	1034	1991-07-25	2018-01-10	44814724
1025	1025	1940-06-23	2019-04-07	44814724
1047	1047	1959-04-25	1963-03-16	44814724
1052	1052	2009-09-04	2019-06-18	44814724
1071	1071	1988-02-24	2017-03-29	44814724
1060	1060	1980-09-28	2017-07-02	44814724
1074	1074	1996-01-15	2018-11-25	44814724
1081	1081	1961-08-16	2018-09-26	44814724
1054	1054	1932-12-16	2013-01-25	44814724
1045	1045	1999-10-27	2018-12-26	44814724
1027	1027	1997-11-15	2017-04-01	44814724
1032	1032	1951-10-14	2018-12-23	44814724
1048	1048	2010-12-06	2018-12-03	44814724
1043	1043	1986-07-03	2018-03-22	44814724
1029	1029	2002-08-15	2019-02-21	44814724
1038	1038	2003-07-30	2018-07-18	44814724
1065	1065	2013-01-20	2018-12-03	44814724
1058	1058	1955-09-24	2019-05-11	44814724
1076	1076	1973-05-11	2019-05-31	44814724
1087	1087	2011-04-11	2019-04-08	44814724
1036	1036	1969-09-05	2017-12-22	44814724
1031	1031	1996-09-27	2018-10-19	44814724
1041	1041	1957-06-04	1958-02-11	44814724
1050	1050	1982-05-29	2018-09-09	44814724
1085	1085	1965-01-02	2019-06-22	44814724
1078	1078	1991-12-17	2019-06-25	44814724
1056	1056	2005-10-13	2019-06-27	44814724
1067	1067	2011-08-29	2018-12-01	44814724
1142	1142	1990-06-24	2019-05-22	44814724
1149	1149	1979-01-30	2019-02-05	44814724
1131	1131	1965-08-11	2019-05-01	44814724
1120	1120	1957-12-02	2019-02-04	44814724
1095	1095	2017-08-22	2019-01-29	44814724
1100	1100	1982-09-29	2016-12-07	44814724
1114	1114	1995-12-16	2018-02-24	44814724
1105	1105	1989-01-10	2016-09-27	44814724
1122	1122	1969-11-17	2018-11-15	44814724
1129	1129	1992-10-30	2018-03-23	44814724
1151	1151	1984-11-21	2019-04-10	44814724
1140	1140	1994-08-30	2018-06-14	44814724
1107	1107	1926-11-19	2007-06-22	44814724
1112	1112	1963-10-27	2019-01-20	44814724
1102	1102	1967-01-24	2019-02-05	44814724
1093	1093	1988-02-27	2019-05-04	44814724
1109	1109	2002-10-15	2018-11-27	44814724
1118	1118	1973-08-12	2019-06-23	44814724
1096	1096	1984-03-17	2017-05-13	44814724
1091	1091	1956-06-07	2019-01-31	44814724
1124	1124	1935-10-06	2018-07-29	44814724
1135	1135	1958-12-27	2019-02-23	44814724
1145	1145	1938-08-24	2018-10-12	44814724
1138	1138	1980-01-31	2019-03-12	44814724
1089	1089	1988-12-02	2016-12-16	44814724
1098	1098	1955-12-10	2019-02-23	44814724
1116	1116	1965-12-11	2018-08-11	44814724
1111	1111	2011-07-27	2018-07-18	44814724
1180	1180	1956-04-11	2018-08-15	44814724
1147	1147	1988-05-02	2017-02-13	44814724
1133	1133	1965-07-09	2018-09-23	44814724
1126	1126	1988-08-03	2018-03-17	44814724
1101	1101	1974-08-18	2016-09-04	44814724
1094	1094	2012-01-17	2019-04-18	44814724
1104	1104	1986-04-04	2018-02-09	44814724
1115	1115	1948-07-05	2018-12-10	44814724
1148	1148	1957-06-22	2018-11-03	44814724
1143	1143	1971-05-29	2018-12-22	44814724
1121	1121	2016-07-03	2019-06-09	44814724
1130	1130	2018-07-10	2019-06-18	44814724
1113	1113	1971-11-16	2017-12-05	44814724
1106	1106	2005-09-28	2018-10-24	44814724
1092	1092	1954-10-15	2019-05-17	44814724
1103	1103	1994-02-08	2019-05-28	44814724
1128	1128	1968-07-26	2018-07-27	44814724
1123	1123	1965-05-27	2019-06-20	44814724
1141	1141	1992-08-20	2018-05-20	44814724
1150	1150	1950-04-12	2018-07-25	44814724
1134	1134	1939-04-02	2019-02-10	44814724
1125	1125	1950-09-22	2019-05-17	44814724
1139	1139	1999-01-18	2019-01-07	44814724
1144	1144	1970-06-07	2018-06-24	44814724
1119	1119	2005-10-07	2018-11-02	44814724
1108	1108	1969-07-30	2019-06-26	44814724
1090	1090	1984-02-29	1986-01-22	44814724
1097	1097	1969-03-28	2019-03-29	44814724
1146	1146	1959-01-15	2018-11-22	44814724
1137	1137	1951-09-15	2013-10-26	44814724
1127	1127	1997-10-19	2016-12-18	44814724
1132	1132	1953-05-04	2018-07-30	44814724
1099	1099	1952-04-13	2018-10-25	44814724
1088	1088	1972-07-30	2018-08-19	44814724
1110	1110	1982-03-15	2019-01-14	44814724
1117	1117	1935-11-23	2019-06-29	44814724
1178	1178	2002-01-16	2019-06-04	44814724
1169	1169	1935-10-14	2018-08-27	44814724
1159	1159	1980-07-27	2018-05-27	44814724
1164	1164	2014-04-27	2019-04-07	44814724
1195	1195	1991-01-10	2019-03-21	44814724
1184	1184	1989-04-26	2018-09-26	44814724
1206	1206	1964-02-11	2019-03-12	44814724
1213	1213	1986-06-25	2018-10-10	44814724
1166	1166	1994-05-03	2017-02-14	44814724
1157	1157	1988-12-27	2017-04-25	44814724
1171	1171	1981-10-29	2018-10-30	44814724
1176	1176	1962-10-19	2018-09-28	44814724
1215	1215	1972-04-08	2018-04-28	44814724
1204	1204	1935-04-13	1952-03-01	44814724
1186	1186	2014-08-25	2018-07-30	44814724
1193	1193	1948-10-01	2018-10-12	44814724
1209	1209	1977-09-08	2017-09-14	44814724
1202	1202	1980-07-06	2019-06-09	44814724
1188	1188	1975-02-01	2019-02-16	44814724
1199	1199	2011-02-11	2019-01-11	44814724
1160	1160	1980-06-20	2017-12-03	44814724
1155	1155	1966-02-21	2019-03-25	44814724
1173	1173	1944-09-11	2019-01-28	44814724
1182	1182	2012-03-03	2019-02-23	44814724
1197	1197	1978-06-04	2018-06-10	44814724
1190	1190	2013-04-17	2019-01-30	44814724
1200	1200	1994-04-22	2018-08-04	44814724
1211	1211	1963-10-23	2019-01-02	44814724
1258	1258	1967-03-13	2019-03-25	44814724
1175	1175	1940-07-29	2019-06-24	44814724
1153	1153	2005-11-25	2018-08-03	44814724
1162	1162	1919-11-01	2007-01-13	44814724
1185	1185	1936-11-29	2019-05-12	44814724
1194	1194	1960-09-19	2018-11-05	44814724
1212	1212	1993-08-06	2018-11-30	44814724
1207	1207	1997-08-15	2017-04-28	44814724
1168	1168	2018-11-13	2019-04-23	44814724
1179	1179	2000-03-14	2019-05-18	44814724
1165	1165	1994-08-28	2017-01-29	44814724
1158	1158	1979-08-06	2017-02-15	44814724
1205	1205	1959-10-22	2018-10-18	44814724
1214	1214	1939-12-29	2019-04-19	44814724
1192	1192	1989-01-19	2017-08-10	44814724
1187	1187	1986-04-23	2017-08-09	44814724
1156	1156	1999-06-02	2019-04-28	44814724
1167	1167	1992-12-22	2018-12-11	44814724
1177	1177	1963-04-29	2019-06-03	44814724
1170	1170	1987-08-03	2019-01-28	44814724
1154	1154	1970-09-06	2019-02-02	44814724
1161	1161	2018-06-30	2019-05-11	44814724
1183	1183	2001-03-08	2019-05-02	44814724
1172	1172	2015-12-06	2019-06-18	44814724
1203	1203	2014-01-20	2018-12-31	44814724
1208	1208	1939-12-26	2009-03-24	44814724
1198	1198	2013-01-24	2019-06-19	44814724
1189	1189	1963-12-02	2018-09-24	44814724
1174	1174	1940-01-14	2019-06-30	44814724
1181	1181	2006-12-31	2019-06-02	44814724
1163	1163	2010-05-30	2019-03-10	44814724
1152	1152	1982-08-31	2018-08-08	44814724
1191	1191	1998-06-27	2019-06-08	44814724
1196	1196	2000-11-19	2018-07-01	44814724
1210	1210	2011-03-14	2019-03-11	44814724
1201	1201	1972-10-11	2018-10-31	44814724
1260	1260	2000-05-10	2018-08-08	44814724
1255	1255	1982-09-25	2019-04-23	44814724
1265	1265	1980-05-11	2018-02-21	44814724
1274	1274	1996-08-20	2018-01-02	44814724
1245	1245	1934-09-07	2018-07-13	44814724
1238	1238	1955-11-08	2019-01-22	44814724
1216	1216	1969-07-29	2019-01-22	44814724
1227	1227	1937-08-25	2019-05-08	44814724
1272	1272	1979-09-14	2018-12-21	44814724
1267	1267	1952-05-08	2019-02-14	44814724
1253	1253	1955-03-10	2018-08-16	44814724
1262	1262	2017-03-31	2019-03-08	44814724
1225	1225	2000-07-05	2019-06-06	44814724
1218	1218	2017-08-20	2019-01-27	44814724
1236	1236	1920-07-30	2018-09-14	44814724
1247	1247	2009-07-03	2019-03-08	44814724
1231	1231	1939-01-12	2018-09-23	44814724
1220	1220	1988-01-30	2019-04-13	44814724
1234	1234	2010-07-09	2019-03-15	44814724
1241	1241	1986-08-30	2017-11-11	44814724
1278	1278	1994-03-05	2019-05-11	44814724
1269	1269	1967-02-21	1995-04-18	44814724
1251	1251	1998-04-09	2017-09-28	44814724
1256	1256	1985-09-13	2018-03-17	44814724
1243	1243	2012-05-05	2019-05-11	44814724
1232	1232	1964-12-14	2019-01-08	44814724
1222	1222	1953-08-26	2018-11-28	44814724
1229	1229	1954-05-15	2019-06-24	44814724
1337	1337	1987-02-26	2018-08-09	44814724
1249	1249	1968-01-25	2019-05-02	44814724
1271	1271	1967-01-08	2018-09-16	44814724
1276	1276	1957-03-08	2019-05-03	44814724
1239	1239	1970-06-25	2018-10-03	44814724
1244	1244	2013-06-16	2019-06-02	44814724
1226	1226	1980-04-06	2017-11-05	44814724
1217	1217	1971-11-19	2019-04-15	44814724
1254	1254	2001-07-17	2019-03-19	44814724
1261	1261	1970-05-17	2017-12-03	44814724
1275	1275	2008-07-16	2018-07-25	44814724
1264	1264	1947-01-03	2019-06-07	44814724
1219	1219	1942-09-14	2019-02-11	44814724
1224	1224	2013-01-30	2019-06-05	44814724
1246	1246	1938-08-20	2018-12-08	44814724
1237	1237	1945-09-30	1995-05-14	44814724
1266	1266	1967-01-09	2018-12-24	44814724
1273	1273	1935-10-14	2017-01-02	44814724
1263	1263	2017-05-13	2019-04-20	44814724
1252	1252	1989-11-30	2019-03-29	44814724
1268	1268	1982-10-03	2017-08-06	44814724
1279	1279	1989-12-07	2018-09-16	44814724
1257	1257	1972-10-28	2018-11-17	44814724
1250	1250	1953-03-23	2019-06-24	44814724
1221	1221	2016-06-20	2019-05-27	44814724
1230	1230	2000-03-10	2019-05-03	44814724
1240	1240	2006-07-19	2018-08-08	44814724
1235	1235	1975-05-26	2019-06-10	44814724
1248	1248	1981-04-02	2019-06-13	44814724
1259	1259	1948-03-29	2019-01-03	44814724
1277	1277	1996-10-09	2016-08-31	44814724
1270	1270	2012-09-21	2018-11-16	44814724
1233	1233	1985-08-23	2018-10-15	44814724
1242	1242	1959-03-11	2019-05-08	44814724
1228	1228	1974-07-06	2019-01-05	44814724
1223	1223	1951-03-09	2019-06-21	44814724
1343	1343	2013-01-07	2018-12-24	44814724
1332	1332	1943-06-02	2019-01-09	44814724
1314	1314	1930-02-15	2018-07-21	44814724
1321	1321	1959-07-02	2019-05-22	44814724
1294	1294	1972-11-18	2018-08-04	44814724
1285	1285	1954-03-22	2018-10-22	44814724
1299	1299	2008-08-01	2018-08-10	44814724
1304	1304	1968-10-21	1986-09-29	44814724
1323	1323	1961-05-06	2018-10-13	44814724
1312	1312	1995-08-17	2019-06-22	44814724
1334	1334	1969-02-23	2019-02-24	44814724
1341	1341	2013-07-23	2018-07-03	44814724
1306	1306	1956-08-09	2019-05-12	44814724
1297	1297	1978-08-13	2018-11-11	44814724
1287	1287	1987-08-18	2016-12-13	44814724
1292	1292	1950-08-15	2018-11-20	44814724
1308	1308	1984-06-09	2019-01-12	44814724
1303	1303	1976-05-23	2018-06-03	44814724
1281	1281	1970-01-04	2018-01-30	44814724
1290	1290	1991-01-25	2018-02-02	44814724
1325	1325	1964-04-12	2018-12-16	44814724
1318	1318	1938-03-09	2019-01-02	44814724
1328	1328	1945-07-26	2019-05-02	44814724
1339	1339	1966-04-15	2018-09-07	44814724
1288	1288	2001-02-02	2019-03-29	44814724
1283	1283	1959-03-17	2018-09-04	44814724
1301	1301	2001-05-16	2018-11-14	44814724
1310	1310	1940-03-01	2014-03-21	44814724
1359	1359	1930-07-08	2008-09-16	44814724
1330	1330	2011-08-21	2019-02-03	44814724
1316	1316	1948-10-26	2019-06-18	44814724
1327	1327	1990-09-27	2018-12-06	44814724
1284	1284	1979-01-19	2017-11-24	44814724
1295	1295	2005-02-14	2019-02-11	44814724
1305	1305	1964-07-10	2018-08-03	44814724
1298	1298	2013-05-19	2019-05-05	44814724
1333	1333	1954-10-03	2019-05-05	44814724
1342	1342	1995-01-25	2018-09-21	44814724
1320	1320	1934-08-30	2019-05-26	44814724
1315	1315	1959-06-09	2018-07-31	44814724
1296	1296	2017-04-01	2019-03-09	44814724
1307	1307	1994-05-22	2019-06-02	44814724
1293	1293	1939-12-26	2019-01-15	44814724
1286	1286	2005-10-05	2018-10-31	44814724
1313	1313	1969-11-26	2018-04-25	44814724
1322	1322	1923-04-18	2018-08-29	44814724
1340	1340	1911-07-31	2019-03-18	44814724
1335	1335	1978-11-20	2018-11-26	44814724
1319	1319	1998-02-27	2017-04-28	44814724
1324	1324	1992-01-05	2019-04-28	44814724
1338	1338	1943-10-07	2019-06-21	44814724
1329	1329	2003-09-25	2019-04-07	44814724
1302	1302	1984-04-09	2018-06-25	44814724
1309	1309	1955-03-30	2018-07-25	44814724
1291	1291	2000-03-04	2019-04-20	44814724
1280	1280	1951-07-04	2019-01-30	44814724
1331	1331	2017-02-10	2019-01-18	44814724
1336	1336	2012-01-29	2019-05-07	44814724
1326	1326	2015-07-09	2019-06-13	44814724
1317	1317	1951-11-10	2015-01-31	44814724
1282	1282	1976-04-03	2018-03-03	44814724
1289	1289	1962-03-14	2019-04-24	44814724
1311	1311	1963-12-22	2001-08-26	44814724
1300	1300	1988-04-15	2019-06-28	44814724
1353	1353	1955-02-28	2019-05-06	44814724
1346	1346	2005-11-21	2018-12-17	44814724
1364	1364	2019-06-28	2019-06-28	44814724
1375	1375	1990-05-16	2018-11-21	44814724
1400	1400	2019-03-28	2019-05-02	44814724
1395	1395	2018-03-19	2019-05-27	44814724
1381	1381	1978-06-03	2019-05-11	44814724
1390	1390	1965-12-30	2019-01-17	44814724
1373	1373	1991-01-30	2016-12-28	44814724
1366	1366	1989-07-27	2017-10-26	44814724
1344	1344	2008-11-20	2019-05-23	44814724
1355	1355	1963-08-09	2018-09-07	44814724
1388	1388	1976-12-14	2018-12-25	44814724
1383	1383	1992-04-05	2019-04-21	44814724
1393	1393	2000-07-02	2019-03-04	44814724
1402	1402	1986-04-19	2018-03-24	44814724
1386	1386	1976-11-25	2018-12-06	44814724
1377	1377	1979-12-05	2017-12-20	44814724
1399	1399	1960-06-29	2018-12-19	44814724
1404	1404	2008-03-11	2019-03-26	44814724
1371	1371	1971-04-14	2019-04-24	44814724
1360	1360	1975-10-05	2017-10-08	44814724
1350	1350	1992-04-27	2019-03-11	44814724
1357	1357	1974-12-28	2019-05-11	44814724
1406	1406	1996-12-04	2018-12-26	44814724
1397	1397	1976-11-19	2019-02-15	44814724
1379	1379	1960-02-14	2019-04-28	44814724
1384	1384	1982-03-17	2016-10-19	44814724
1443	1443	1977-03-26	2019-03-30	44814724
1348	1348	1911-05-01	2002-04-22	44814724
1362	1362	1973-01-04	1976-10-28	44814724
1369	1369	2012-08-09	2019-05-08	44814724
1394	1394	1991-12-27	2017-11-15	44814724
1401	1401	1973-01-28	2019-02-17	44814724
1391	1391	1924-01-01	1999-07-27	44814724
1380	1380	2003-07-29	2018-07-03	44814724
1347	1347	1991-10-25	2017-12-15	44814724
1352	1352	1946-08-04	2019-02-03	44814724
1374	1374	1980-06-27	2015-02-20	44814724
1365	1365	1963-08-22	2019-05-16	44814724
1382	1382	1977-04-27	2019-06-26	44814724
1389	1389	1955-03-06	2018-11-25	44814724
1403	1403	1993-02-26	2018-11-09	44814724
1392	1392	1989-06-30	2019-06-23	44814724
1367	1367	1965-04-30	2018-11-02	44814724
1372	1372	2008-08-18	2019-03-11	44814724
1354	1354	1978-04-07	2018-04-13	44814724
1345	1345	1966-03-15	2019-04-16	44814724
1361	1361	1939-09-04	2018-11-05	44814724
1370	1370	2001-05-07	2019-04-15	44814724
1356	1356	1971-02-05	2018-10-19	44814724
1351	1351	1997-11-27	2018-10-18	44814724
1376	1376	1977-11-11	2019-02-15	44814724
1387	1387	1969-04-01	2019-04-02	44814724
1405	1405	1998-06-02	2018-04-28	44814724
1398	1398	1999-01-31	2019-04-21	44814724
1349	1349	2001-06-05	2019-05-17	44814724
1358	1358	1953-07-23	2018-07-05	44814724
1368	1368	1956-03-21	2019-07-03	44814724
1363	1363	2017-09-05	2019-02-12	44814724
1396	1396	1992-08-26	2018-03-07	44814724
1407	1407	1967-11-11	2018-11-17	44814724
1385	1385	1960-05-13	2018-06-29	44814724
1378	1378	1944-06-21	2018-08-01	44814724
1445	1445	1983-03-06	2016-09-11	44814724
1454	1454	1971-09-11	2018-09-15	44814724
1464	1464	1959-12-03	2018-11-22	44814724
1459	1459	1942-12-10	2018-08-09	44814724
1428	1428	1944-08-23	2019-01-23	44814724
1439	1439	1977-08-13	2019-05-18	44814724
1417	1417	1988-03-01	2019-03-24	44814724
1410	1410	1967-03-16	2019-01-10	44814724
1457	1457	1987-06-12	2019-01-04	44814724
1466	1466	1968-03-05	2019-03-12	44814724
1452	1452	1996-02-25	2019-04-21	44814724
1447	1447	1957-08-01	2019-05-18	44814724
1408	1408	1943-08-02	2019-04-15	44814724
1419	1419	1996-07-21	2004-05-09	44814724
1437	1437	1996-01-30	2018-10-23	44814724
1430	1430	1943-11-23	2019-01-01	44814724
1414	1414	1983-08-16	2018-10-16	44814724
1421	1421	2009-01-27	2019-05-28	44814724
1435	1435	1961-02-18	2018-10-16	44814724
1424	1424	2001-05-10	2019-04-13	44814724
1463	1463	1992-09-13	2017-08-30	44814724
1468	1468	1949-06-15	2019-06-26	44814724
1450	1450	1963-05-12	2019-01-20	44814724
1441	1441	1967-06-26	2018-11-05	44814724
1426	1426	1952-03-11	2019-06-18	44814724
1433	1433	1960-01-04	2019-04-08	44814724
1423	1423	2017-07-29	2019-01-05	44814724
1412	1412	1961-05-13	2019-04-27	44814724
1493	1493	1956-09-25	2018-06-26	44814724
1448	1448	1973-03-28	2019-04-24	44814724
1470	1470	2005-05-10	2019-05-07	44814724
1461	1461	1966-10-27	2018-11-08	44814724
1438	1438	1952-01-18	2019-05-17	44814724
1429	1429	1989-03-17	2017-06-02	44814724
1411	1411	1965-11-30	2018-12-18	44814724
1416	1416	1993-10-14	2019-02-14	44814724
1455	1455	2013-11-30	2018-11-24	44814724
1444	1444	2005-10-26	2019-01-23	44814724
1458	1458	2007-09-18	2018-10-02	44814724
1465	1465	2011-04-14	2018-08-16	44814724
1418	1418	1972-08-28	2019-01-07	44814724
1409	1409	1917-01-29	2019-01-07	44814724
1431	1431	1949-10-02	2019-03-31	44814724
1436	1436	1983-03-31	2017-11-05	44814724
1467	1467	1933-03-27	2018-08-20	44814724
1456	1456	1988-11-24	2017-02-02	44814724
1446	1446	1983-11-01	2016-09-27	44814724
1453	1453	1980-05-07	2018-06-20	44814724
1469	1469	1992-09-04	2019-06-25	44814724
1462	1462	2004-04-17	2019-06-29	44814724
1440	1440	2014-07-27	2019-03-24	44814724
1451	1451	1991-04-22	2016-12-12	44814724
1420	1420	2015-01-08	2018-12-18	44814724
1415	1415	1969-01-26	2019-01-27	44814724
1425	1425	1935-11-27	2019-06-05	44814724
1434	1434	1935-04-13	1950-08-26	44814724
1449	1449	1995-02-11	2017-04-08	44814724
1442	1442	1946-02-05	2019-06-18	44814724
1460	1460	1981-05-30	2019-04-27	44814724
1471	1471	1990-11-19	2019-01-28	44814724
1432	1432	1961-08-29	2018-09-25	44814724
1427	1427	1955-11-09	2019-01-23	44814724
1413	1413	2017-07-18	2019-06-25	44814724
1422	1422	2003-01-11	2019-02-23	44814724
1491	1491	1968-11-05	2011-07-19	44814724
1496	1496	1920-04-18	1998-05-17	44814724
1486	1486	1955-07-10	2018-12-02	44814724
1477	1477	2011-10-07	2018-09-28	44814724
1506	1506	1946-02-02	2012-10-20	44814724
1513	1513	1968-05-26	2018-08-12	44814724
1535	1535	1978-04-03	2018-04-09	44814724
1524	1524	1967-01-12	2019-05-02	44814724
1479	1479	2004-10-03	2019-01-29	44814724
1484	1484	2018-11-21	2019-05-01	44814724
1498	1498	1964-03-17	2019-05-21	44814724
1489	1489	2017-07-10	2019-04-15	44814724
1526	1526	1971-12-30	2018-12-03	44814724
1533	1533	1970-12-30	2018-10-10	44814724
1515	1515	2011-04-27	2019-04-24	44814724
1504	1504	1941-06-10	2018-10-16	44814724
1520	1520	1936-06-28	2018-12-30	44814724
1531	1531	1985-01-29	2017-12-14	44814724
1517	1517	1937-11-01	2019-04-29	44814724
1510	1510	1958-11-02	2019-02-26	44814724
1473	1473	1989-01-12	2017-04-20	44814724
1482	1482	1974-10-19	2018-11-03	44814724
1500	1500	1962-02-12	2019-06-17	44814724
1495	1495	1992-08-27	2017-11-16	44814724
1508	1508	1924-01-01	2019-05-14	44814724
1519	1519	1994-12-27	2018-10-02	44814724
1529	1529	1962-07-02	2019-06-10	44814724
1522	1522	1985-09-26	2016-12-08	44814724
1541	1541	1963-04-29	2019-06-03	44814724
1502	1502	2009-05-05	2019-05-14	44814724
1480	1480	1966-01-21	2006-08-11	44814724
1475	1475	1934-08-23	2019-01-17	44814724
1512	1512	1974-06-12	2017-11-29	44814724
1507	1507	1996-02-08	2019-01-09	44814724
1525	1525	1963-08-02	2018-08-31	44814724
1534	1534	2019-01-30	2019-05-08	44814724
1497	1497	1940-03-16	2018-09-15	44814724
1490	1490	1937-12-09	2019-03-28	44814724
1476	1476	1944-09-15	2011-06-03	44814724
1487	1487	2001-08-17	2018-10-05	44814724
1532	1532	1977-09-28	2019-05-22	44814724
1527	1527	2002-11-02	2019-05-11	44814724
1505	1505	1953-09-05	2019-04-13	44814724
1514	1514	1982-04-06	2018-11-06	44814724
1485	1485	2008-05-27	2019-04-16	44814724
1478	1478	1961-03-21	2019-06-04	44814724
1488	1488	1988-11-03	2018-11-09	44814724
1499	1499	1983-05-04	2017-08-30	44814724
1483	1483	1985-01-19	2017-09-23	44814724
1472	1472	2000-05-22	2019-02-25	44814724
1494	1494	2018-10-23	2019-04-02	44814724
1501	1501	2012-11-17	2018-11-03	44814724
1530	1530	1988-11-14	2017-03-13	44814724
1521	1521	1985-04-23	2017-12-12	44814724
1511	1511	1965-04-25	2019-05-19	44814724
1516	1516	1938-01-03	2015-06-22	44814724
1503	1503	2008-07-25	2019-03-15	44814724
1492	1492	2004-12-03	2018-11-02	44814724
1474	1474	1992-03-24	2018-10-23	44814724
1481	1481	2004-11-16	2018-12-21	44814724
1518	1518	1953-07-11	2019-06-29	44814724
1509	1509	1999-07-30	2019-06-25	44814724
1523	1523	1956-04-10	2019-06-25	44814724
1528	1528	1959-01-10	2019-03-09	44814724
1539	1539	1993-12-14	2019-02-05	44814724
1544	1544	1999-12-13	2018-11-13	44814724
1566	1566	1967-11-04	2019-02-07	44814724
1557	1557	2008-12-24	2019-06-12	44814724
1586	1586	1939-03-12	2018-10-28	44814724
1593	1593	1934-10-11	2019-03-14	44814724
1583	1583	2016-04-20	2019-03-27	44814724
1572	1572	1962-06-22	2019-02-13	44814724
1559	1559	1993-12-26	2019-02-17	44814724
1564	1564	1999-06-14	2019-01-05	44814724
1546	1546	2017-07-12	2019-06-19	44814724
1537	1537	1956-06-13	2019-04-24	44814724
1574	1574	1958-10-03	2018-11-30	44814724
1581	1581	2005-09-27	2018-10-23	44814724
1595	1595	1959-12-23	1965-09-01	44814724
1584	1584	1983-09-05	2019-06-14	44814724
1568	1568	1952-08-31	2018-12-02	44814724
1579	1579	1954-12-30	2019-03-07	44814724
1597	1597	1944-07-29	2018-12-15	44814724
1590	1590	1960-04-03	2018-11-04	44814724
1553	1553	1967-03-11	2019-03-23	44814724
1562	1562	1995-10-04	2019-05-22	44814724
1548	1548	1986-06-25	2017-09-06	44814724
1543	1543	1940-10-21	1994-10-31	44814724
1588	1588	1960-12-04	2018-12-30	44814724
1599	1599	1960-05-09	2019-07-01	44814724
1577	1577	1922-02-17	2018-08-17	44814724
1570	1570	1990-05-06	2017-03-19	44814724
1651	1651	1973-06-18	2004-11-08	44814724
1550	1550	1969-01-12	2019-01-13	44814724
1560	1560	1935-01-14	2019-02-11	44814724
1555	1555	1981-12-13	2018-11-04	44814724
1592	1592	1985-04-07	2017-06-16	44814724
1587	1587	1982-05-28	2018-03-16	44814724
1573	1573	2017-06-29	2019-06-06	44814724
1582	1582	1992-12-18	2018-06-30	44814724
1545	1545	1968-12-06	2018-07-06	44814724
1538	1538	1930-06-02	2016-09-26	44814724
1556	1556	1973-03-29	2017-11-30	44814724
1567	1567	1974-12-27	2018-06-01	44814724
1580	1580	2018-12-16	2019-05-26	44814724
1575	1575	1995-06-17	2018-08-26	44814724
1585	1585	1929-07-28	2018-10-21	44814724
1594	1594	1987-08-14	2018-10-05	44814724
1565	1565	1964-09-13	2018-09-02	44814724
1558	1558	1954-04-29	2019-05-16	44814724
1536	1536	1911-07-02	1971-12-05	44814724
1547	1547	1982-06-12	2017-05-20	44814724
1563	1563	1956-06-23	2019-04-20	44814724
1552	1552	1987-03-30	2019-06-10	44814724
1542	1542	1965-11-24	2018-11-07	44814724
1549	1549	1979-02-12	2019-02-18	44814724
1578	1578	1947-04-07	2019-01-31	44814724
1569	1569	1936-09-04	2018-07-20	44814724
1591	1591	2012-03-26	2019-06-16	44814724
1596	1596	1999-10-17	2019-03-17	44814724
1551	1551	1956-12-17	2019-03-18	44814724
1540	1540	1958-07-28	2018-09-24	44814724
1554	1554	2015-06-10	2019-05-15	44814724
1561	1561	2010-01-20	2019-06-23	44814724
1598	1598	1958-01-20	2018-08-06	44814724
1589	1589	2007-05-17	2019-06-06	44814724
1571	1571	1954-07-02	2018-08-10	44814724
1576	1576	1967-10-07	2018-10-13	44814724
1653	1653	2016-08-16	2019-01-22	44814724
1662	1662	1964-03-14	2018-12-08	44814724
1640	1640	1935-08-14	2019-06-05	44814724
1635	1635	1972-10-18	2019-05-01	44814724
1604	1604	1953-10-29	2019-01-26	44814724
1615	1615	1993-08-24	2018-06-14	44814724
1625	1625	2013-04-02	2019-03-19	44814724
1618	1618	1973-05-16	2019-06-05	44814724
1633	1633	1993-06-15	2018-11-13	44814724
1642	1642	1951-05-22	2018-10-23	44814724
1660	1660	1987-10-31	2019-01-12	44814724
1655	1655	1971-10-01	2019-05-24	44814724
1616	1616	1991-10-07	2018-07-27	44814724
1627	1627	1952-05-31	2019-02-02	44814724
1613	1613	1954-05-15	2006-11-04	44814724
1606	1606	1950-01-02	2019-02-25	44814724
1622	1622	1974-05-28	2019-04-23	44814724
1629	1629	1979-01-08	2018-10-02	44814724
1611	1611	1952-06-08	2017-04-16	44814724
1600	1600	1945-11-26	2018-10-15	44814724
1639	1639	2015-12-24	2019-06-06	44814724
1644	1644	1988-02-07	2019-03-10	44814724
1658	1658	1911-05-01	2019-07-01	44814724
1649	1649	1956-03-07	2017-08-30	44814724
1602	1602	1963-04-17	2019-05-22	44814724
1609	1609	1943-03-25	2019-05-02	44814724
1631	1631	1982-07-30	2018-08-21	44814724
1620	1620	1985-08-10	2017-01-14	44814724
1695	1695	1965-12-30	2018-11-22	44814724
1656	1656	1977-11-26	2018-01-27	44814724
1646	1646	1940-11-30	2019-04-06	44814724
1637	1637	2010-05-29	2019-03-23	44814724
1614	1614	2010-03-09	2019-06-20	44814724
1605	1605	1936-06-28	2019-05-19	44814724
1619	1619	2014-08-12	2018-07-03	44814724
1624	1624	2005-06-03	2019-06-11	44814724
1663	1663	2014-03-10	2019-03-11	44814724
1652	1652	2012-04-20	2018-05-25	44814724
1634	1634	1938-09-09	2018-09-21	44814724
1641	1641	1954-09-22	2019-03-27	44814724
1626	1626	1934-12-30	2010-10-17	44814724
1617	1617	2004-09-28	2019-06-26	44814724
1607	1607	1998-06-12	2018-02-09	44814724
1612	1612	1963-07-31	2018-08-29	44814724
1643	1643	2016-12-10	2019-05-18	44814724
1632	1632	1951-07-23	2019-04-15	44814724
1654	1654	1981-11-19	2019-03-31	44814724
1661	1661	1955-06-30	2019-04-18	44814724
1645	1645	2018-07-24	2019-04-02	44814724
1638	1638	2013-02-01	2018-12-14	44814724
1648	1648	1999-06-06	2019-06-25	44814724
1659	1659	1969-03-17	2019-03-18	44814724
1628	1628	1983-08-04	2017-07-13	44814724
1623	1623	1950-01-06	2019-01-25	44814724
1601	1601	2002-05-08	2019-06-27	44814724
1610	1610	2005-08-08	2019-06-24	44814724
1657	1657	1943-12-29	2019-05-22	44814724
1650	1650	2007-02-17	2019-03-09	44814724
1636	1636	1956-02-10	2019-02-22	44814724
1647	1647	1993-08-21	2018-10-27	44814724
1608	1608	1941-06-15	2018-12-23	44814724
1603	1603	2014-06-21	2019-06-01	44814724
1621	1621	1987-02-10	2018-04-24	44814724
1630	1630	2017-02-25	2019-02-02	44814724
1689	1689	1940-11-28	2019-03-29	44814724
1682	1682	2013-11-14	2018-11-13	44814724
1668	1668	1988-04-29	2017-09-22	44814724
1679	1679	1969-09-30	2019-02-26	44814724
1704	1704	1969-06-09	1994-07-25	44814724
1699	1699	1966-04-03	2019-04-21	44814724
1717	1717	1986-12-18	2018-11-08	44814724
1726	1726	2011-10-30	2019-02-03	44814724
1677	1677	1969-07-12	2018-08-09	44814724
1670	1670	1964-01-05	2018-10-28	44814724
1680	1680	1995-04-13	2017-10-19	44814724
1691	1691	1944-07-13	2018-08-23	44814724
1724	1724	1949-09-12	2019-02-01	44814724
1719	1719	1957-04-09	2019-06-25	44814724
1697	1697	2014-09-27	2019-04-27	44814724
1706	1706	1995-03-05	2017-12-17	44814724
1722	1722	2005-12-16	2018-08-24	44814724
1713	1713	1971-10-06	2018-05-16	44814724
1703	1703	1949-02-09	2019-06-05	44814724
1708	1708	1987-12-07	2019-02-18	44814724
1675	1675	2002-07-14	2019-04-07	44814724
1664	1664	2008-08-21	2019-04-25	44814724
1686	1686	1961-03-19	2018-10-13	44814724
1693	1693	2019-04-14	2019-05-19	44814724
1710	1710	1987-08-26	2018-11-07	44814724
1701	1701	1994-03-28	2017-09-19	44814724
1715	1715	1955-11-26	2019-06-27	44814724
1720	1720	1979-03-31	2018-05-26	44814724
1769	1769	1974-09-25	2018-10-10	44814724
1684	1684	2006-07-05	2018-10-24	44814724
1666	1666	1934-10-06	2019-05-25	44814724
1673	1673	1987-05-22	2018-08-04	44814724
1698	1698	2006-03-10	2019-06-28	44814724
1705	1705	2004-08-02	2019-07-01	44814724
1727	1727	1949-03-31	2018-12-06	44814724
1716	1716	1944-10-20	2019-03-08	44814724
1683	1683	1971-07-22	2017-08-10	44814724
1688	1688	1991-07-17	2018-11-07	44814724
1678	1678	2007-07-24	2018-09-11	44814724
1669	1669	1959-02-02	2019-05-13	44814724
1718	1718	1966-09-18	2019-01-28	44814724
1725	1725	1988-12-03	2017-02-11	44814724
1707	1707	1970-08-10	2018-09-03	44814724
1696	1696	2009-02-02	2019-07-01	44814724
1671	1671	2016-08-04	2019-01-17	44814724
1676	1676	1979-12-14	2017-11-24	44814724
1690	1690	1973-10-03	2015-12-30	44814724
1681	1681	2015-02-28	2019-03-26	44814724
1665	1665	2002-10-08	2019-01-29	44814724
1674	1674	1976-10-11	2019-06-10	44814724
1692	1692	1976-08-16	2018-08-27	44814724
1687	1687	2018-09-08	2019-05-18	44814724
1712	1712	2010-11-20	2019-02-09	44814724
1723	1723	1995-02-12	2018-11-08	44814724
1709	1709	1936-09-19	2019-05-04	44814724
1702	1702	1964-11-02	2018-11-26	44814724
1685	1685	1980-02-10	2019-01-20	44814724
1694	1694	1984-10-11	2019-01-17	44814724
1672	1672	1953-04-29	2019-02-06	44814724
1667	1667	1994-12-16	2019-01-31	44814724
1700	1700	1987-08-30	2018-11-11	44814724
1711	1711	2012-10-04	2018-09-20	44814724
1721	1721	1986-02-26	2018-04-16	44814724
1714	1714	2015-10-16	2019-03-22	44814724
1775	1775	1997-06-27	2018-09-14	44814724
1764	1764	1959-09-03	2018-10-25	44814724
1778	1778	1980-05-17	2017-10-21	44814724
1785	1785	1954-10-05	2019-01-24	44814724
1758	1758	1960-08-19	2019-03-08	44814724
1749	1749	1989-07-10	2018-06-11	44814724
1731	1731	1996-07-21	2018-09-23	44814724
1736	1736	1969-05-09	2019-05-10	44814724
1787	1787	2015-11-21	2019-04-27	44814724
1776	1776	1916-10-28	2019-05-17	44814724
1766	1766	1952-06-25	2019-04-03	44814724
1773	1773	1951-08-26	2018-09-30	44814724
1738	1738	1968-05-20	2019-05-27	44814724
1729	1729	1977-09-07	2018-03-04	44814724
1751	1751	1977-09-28	2017-11-22	44814724
1756	1756	1972-08-06	2018-08-26	44814724
1740	1740	1952-09-06	2018-12-08	44814724
1735	1735	2011-06-29	2019-06-26	44814724
1745	1745	1979-01-15	2018-03-26	44814724
1754	1754	2014-02-26	2019-02-06	44814724
1789	1789	1975-02-27	2019-06-13	44814724
1782	1782	1952-11-25	2018-12-18	44814724
1760	1760	1977-06-19	2018-06-19	44814724
1771	1771	1993-09-09	2019-06-13	44814724
1752	1752	1977-12-26	2018-01-01	44814724
1747	1747	2011-09-10	2019-02-27	44814724
1733	1733	1981-02-19	2019-04-04	44814724
1742	1742	1990-06-08	2018-07-20	44814724
1850	1850	1956-12-14	2019-02-15	44814724
1762	1762	1940-10-31	2019-05-09	44814724
1780	1780	1965-06-16	2019-02-21	44814724
1791	1791	1954-11-25	2019-04-11	44814724
1748	1748	1946-10-05	2018-11-10	44814724
1759	1759	1984-12-31	2019-04-04	44814724
1737	1737	1911-09-22	2019-05-24	44814724
1730	1730	1983-04-02	2017-05-13	44814724
1765	1765	2001-07-12	2019-06-22	44814724
1774	1774	2017-08-26	2019-02-02	44814724
1784	1784	2012-01-31	2019-01-22	44814724
1779	1779	1942-11-26	2019-01-24	44814724
1728	1728	2001-01-17	2019-04-10	44814724
1739	1739	1968-04-11	2019-02-07	44814724
1757	1757	2001-05-12	2018-12-01	44814724
1750	1750	1968-02-15	2018-11-15	44814724
1777	1777	2008-10-10	2018-11-16	44814724
1786	1786	1943-02-27	2019-01-12	44814724
1772	1772	1994-02-05	2019-04-13	44814724
1767	1767	2012-08-03	2019-04-26	44814724
1783	1783	1959-07-27	2019-06-03	44814724
1788	1788	1961-08-17	2018-11-29	44814724
1770	1770	1978-06-11	2017-12-31	44814724
1761	1761	1952-08-25	2019-04-16	44814724
1734	1734	2018-07-07	2019-06-15	44814724
1741	1741	1994-06-25	2018-08-29	44814724
1755	1755	1959-06-17	2018-10-16	44814724
1744	1744	1975-05-02	2018-09-14	44814724
1763	1763	2002-04-23	2019-06-04	44814724
1768	1768	1992-04-15	2018-06-18	44814724
1790	1790	1982-08-10	2019-05-13	44814724
1781	1781	1941-06-10	2019-01-15	44814724
1746	1746	1952-11-13	2019-05-02	44814724
1753	1753	1964-05-07	2019-06-06	44814724
1743	1743	1965-02-04	2019-02-28	44814724
1732	1732	1987-02-20	2018-03-09	44814724
1852	1852	1973-03-07	2019-02-27	44814724
1847	1847	1914-11-08	1995-07-02	44814724
1825	1825	1988-12-21	2017-05-03	44814724
1834	1834	1946-02-03	2019-06-16	44814724
1805	1805	2005-04-13	2019-05-22	44814724
1798	1798	2001-02-25	2019-03-23	44814724
1808	1808	1962-02-07	2019-06-05	44814724
1819	1819	1977-05-24	2019-06-04	44814724
1832	1832	2006-01-02	2018-11-05	44814724
1827	1827	1988-06-16	2019-06-12	44814724
1845	1845	1961-04-19	2019-02-13	44814724
1854	1854	1970-11-03	2018-11-27	44814724
1817	1817	1981-09-23	2018-02-21	44814724
1810	1810	1985-07-31	2017-03-15	44814724
1796	1796	1979-04-04	2018-12-05	44814724
1807	1807	1980-03-31	2018-09-19	44814724
1823	1823	2018-03-08	2019-05-16	44814724
1812	1812	1960-03-28	2018-11-12	44814724
1794	1794	1959-02-07	2019-04-06	44814724
1801	1801	1954-07-22	2018-10-11	44814724
1838	1838	2008-11-19	2018-11-28	44814724
1829	1829	1967-07-04	2018-08-28	44814724
1843	1843	1981-08-19	2018-06-20	44814724
1848	1848	1944-09-15	2019-05-24	44814724
1803	1803	2011-11-21	2019-01-18	44814724
1792	1792	1999-11-15	2012-10-01	44814724
1814	1814	1940-04-20	2019-03-23	44814724
1821	1821	1937-07-05	2019-03-11	44814724
1868	1868	1986-01-20	2018-12-31	44814724
1841	1841	1955-06-30	1992-02-27	44814724
1831	1831	2014-07-06	2019-06-16	44814724
1836	1836	1995-08-19	2018-06-16	44814724
1799	1799	1986-09-27	2017-07-24	44814724
1804	1804	1935-10-14	1999-06-21	44814724
1818	1818	1992-02-02	2019-03-11	44814724
1809	1809	1962-12-12	2019-01-16	44814724
1846	1846	1950-12-28	2019-03-14	44814724
1853	1853	1987-01-13	2018-09-25	44814724
1835	1835	2003-12-22	2019-05-06	44814724
1824	1824	2015-08-07	2019-01-11	44814724
1811	1811	2006-11-04	2019-04-27	44814724
1816	1816	2018-11-05	2019-04-15	44814724
1806	1806	2010-10-15	2018-10-19	44814724
1797	1797	1982-09-21	2019-02-18	44814724
1826	1826	1938-03-09	2019-03-20	44814724
1833	1833	1997-08-01	2017-09-19	44814724
1855	1855	1975-03-21	2018-11-23	44814724
1844	1844	1959-04-07	2018-11-21	44814724
1828	1828	1991-08-08	2018-11-12	44814724
1839	1839	2011-01-17	2019-01-14	44814724
1849	1849	1948-09-29	1962-11-14	44814724
1842	1842	1965-08-20	2018-07-27	44814724
1813	1813	1981-06-20	2019-05-11	44814724
1822	1822	2004-08-22	2019-04-07	44814724
1800	1800	1989-06-24	2018-11-03	44814724
1795	1795	2000-12-08	2019-02-01	44814724
1840	1840	1975-04-19	2018-03-03	44814724
1851	1851	1977-12-09	2017-12-15	44814724
1837	1837	1960-05-13	2018-07-27	44814724
1830	1830	2009-03-29	2019-06-30	44814724
1793	1793	1918-06-12	2006-09-06	44814724
1802	1802	2018-11-07	2019-04-17	44814724
1820	1820	1978-02-07	2019-02-21	44814724
1815	1815	1993-12-11	2019-06-03	44814724
1866	1866	1983-09-30	2018-02-23	44814724
1857	1857	2015-06-15	2019-05-20	44814724
1879	1879	1958-10-05	2019-05-05	44814724
1884	1884	2009-01-02	2018-10-26	44814724
1915	1915	1974-03-05	2018-09-13	44814724
1904	1904	1987-02-15	2018-05-28	44814724
1894	1894	1958-08-07	1998-08-13	44814724
1901	1901	1989-09-08	2018-10-09	44814724
1886	1886	2013-04-22	2019-04-08	44814724
1877	1877	2014-04-17	2019-05-07	44814724
1859	1859	2010-05-28	2019-05-31	44814724
1864	1864	1965-12-03	2018-12-21	44814724
1903	1903	1962-06-19	2019-01-01	44814724
1892	1892	1960-07-14	2018-09-11	44814724
1906	1906	1960-11-13	2019-05-19	44814724
1913	1913	1988-10-17	2018-11-24	44814724
1897	1897	1991-06-07	2018-07-21	44814724
1890	1890	2014-12-30	2018-09-11	44814724
1908	1908	1970-06-07	2018-07-01	44814724
1919	1919	1985-04-25	2019-06-13	44814724
1880	1880	2017-12-24	2019-06-17	44814724
1875	1875	1988-07-21	2018-09-06	44814724
1861	1861	1981-11-28	2019-02-16	44814724
1870	1870	1920-04-18	1961-02-26	44814724
1917	1917	1949-07-04	2006-06-12	44814724
1910	1910	1980-11-07	2018-05-18	44814724
1888	1888	1987-12-18	2019-01-04	44814724
1899	1899	2001-02-01	2019-03-28	44814724
1952	1952	1954-08-02	2019-03-25	44814724
1863	1863	2017-09-12	2019-02-19	44814724
1873	1873	2002-02-26	2019-04-16	44814724
1882	1882	1968-08-10	2018-10-20	44814724
1905	1905	1966-02-18	2019-02-08	44814724
1914	1914	1986-10-17	2016-07-15	44814724
1900	1900	1963-10-08	2018-09-11	44814724
1895	1895	2011-02-04	2019-02-01	44814724
1856	1856	1992-03-09	2019-01-14	44814724
1867	1867	1972-05-23	2018-06-21	44814724
1885	1885	1973-02-27	2019-04-09	44814724
1878	1878	1975-03-16	2019-05-05	44814724
1893	1893	2005-07-15	2018-08-10	44814724
1902	1902	1943-11-28	2019-03-17	44814724
1912	1912	1987-11-02	2016-11-08	44814724
1907	1907	2012-01-11	2019-05-10	44814724
1876	1876	1990-04-28	2019-06-22	44814724
1887	1887	2009-05-07	2019-05-16	44814724
1865	1865	2013-06-19	2019-06-05	44814724
1858	1858	2003-03-31	2019-05-13	44814724
1874	1874	1973-11-10	2019-01-05	44814724
1881	1881	2006-10-19	2018-11-22	44814724
1871	1871	1997-07-09	2018-12-30	44814724
1860	1860	1958-10-28	1997-07-15	44814724
1891	1891	2018-03-23	2019-06-17	44814724
1896	1896	1983-12-05	2018-11-13	44814724
1918	1918	1968-08-10	2018-08-21	44814724
1909	1909	2019-01-26	2019-05-04	44814724
1862	1862	2000-05-11	2019-06-20	44814724
1869	1869	1994-05-27	2019-02-22	44814724
1883	1883	1991-12-05	2018-05-03	44814724
1872	1872	1996-02-11	2018-04-01	44814724
1911	1911	1945-11-26	2009-11-16	44814724
1916	1916	1971-10-04	2019-06-24	44814724
1898	1898	1970-12-07	2019-06-17	44814724
1889	1889	1982-11-18	2018-03-06	44814724
1958	1958	1971-07-27	2019-04-09	44814724
1965	1965	1973-01-28	2019-02-17	44814724
1979	1979	1991-11-14	2018-07-12	44814724
1968	1968	2011-10-12	2018-06-27	44814724
1943	1943	2007-07-17	2018-07-31	44814724
1948	1948	1993-04-01	2018-06-15	44814724
1930	1930	2014-10-16	2019-02-23	44814724
1921	1921	1951-09-25	2019-01-29	44814724
1970	1970	2015-08-08	2019-04-19	44814724
1977	1977	1910-02-10	2018-07-05	44814724
1967	1967	1955-10-13	2019-04-26	44814724
1956	1956	1963-06-25	2018-07-24	44814724
1923	1923	1932-12-16	2018-04-20	44814724
1928	1928	1971-08-05	2019-06-27	44814724
1950	1950	1940-09-13	2019-03-01	44814724
1941	1941	1973-02-15	2018-03-15	44814724
1925	1925	1945-01-20	2019-04-20	44814724
1934	1934	1960-01-30	2019-03-09	44814724
1944	1944	2010-11-29	2018-09-24	44814724
1939	1939	2016-01-13	2019-06-19	44814724
1972	1972	2011-09-01	2018-11-22	44814724
1983	1983	1987-12-06	2019-04-28	44814724
1961	1961	2003-03-29	2018-12-15	44814724
1954	1954	1936-01-30	2006-04-27	44814724
1937	1937	1963-05-14	2019-05-07	44814724
1946	1946	1925-12-27	2018-11-04	44814724
1932	1932	2009-09-04	2019-02-08	44814724
1927	1927	1990-09-19	2016-07-27	44814724
2006	2006	1946-01-18	2019-05-31	44814724
1963	1963	1914-08-29	1922-01-14	44814724
1981	1981	1990-02-20	2018-05-01	44814724
1974	1974	1986-01-20	2018-04-16	44814724
1949	1949	1980-05-15	2017-08-24	44814724
1942	1942	1994-04-21	2019-06-27	44814724
1920	1920	2017-08-27	2019-02-03	44814724
1931	1931	2005-06-04	2019-06-01	44814724
1964	1964	1961-02-01	2018-12-08	44814724
1959	1959	2017-01-22	2019-06-09	44814724
1969	1969	1996-06-18	2018-12-09	44814724
1978	1978	1990-11-04	2019-03-10	44814724
1929	1929	1954-08-19	2019-01-17	44814724
1922	1922	1994-03-12	2019-05-18	44814724
1940	1940	1993-10-01	2018-12-28	44814724
1951	1951	1981-05-13	2019-05-18	44814724
1976	1976	1982-12-20	2017-03-06	44814724
1971	1971	1969-03-14	2019-03-15	44814724
1957	1957	2012-04-29	2019-04-21	44814724
1966	1966	1961-04-25	2019-05-04	44814724
1982	1982	1921-08-25	2006-10-26	44814724
1973	1973	1971-06-07	2018-12-10	44814724
1955	1955	1999-02-02	2018-04-10	44814724
1960	1960	1930-07-08	2010-04-13	44814724
1935	1935	1964-02-04	2019-03-05	44814724
1924	1924	1971-06-04	2019-06-28	44814724
1938	1938	1982-07-18	2017-11-05	44814724
1945	1945	1970-11-29	2018-11-18	44814724
1962	1962	1964-04-09	2019-01-31	44814724
1953	1953	1954-08-09	2018-11-19	44814724
1975	1975	1922-02-11	1973-11-24	44814724
1980	1980	1972-09-10	2018-02-18	44814724
1947	1947	1948-10-17	2019-03-15	44814724
1936	1936	1947-02-21	2019-06-28	44814724
1926	1926	1970-04-11	2018-01-27	44814724
1933	1933	1958-05-30	2018-07-27	44814724
2000	2000	2007-09-19	2019-06-12	44814724
2011	2011	1986-07-29	2018-04-24	44814724
1997	1997	1977-03-01	2019-03-12	44814724
1990	1990	1966-05-27	2019-06-14	44814724
2017	2017	1969-07-29	2018-04-28	44814724
2026	2026	1952-01-12	2019-06-19	44814724
2044	2044	1961-10-14	2018-11-03	44814724
2039	2039	1990-08-31	2018-09-14	44814724
1988	1988	2010-08-14	2019-01-28	44814724
1999	1999	1977-09-24	2019-02-09	44814724
2009	2009	1997-10-26	2016-12-25	44814724
2002	2002	1975-03-14	2019-05-17	44814724
2037	2037	1960-04-15	2019-06-07	44814724
2046	2046	1939-12-26	2014-04-08	44814724
2024	2024	1999-01-27	2018-12-23	44814724
2019	2019	2013-03-22	2019-03-29	44814724
2035	2035	1989-08-14	2018-06-18	44814724
2040	2040	2014-04-02	2019-03-13	44814724
2030	2030	1962-04-23	2019-06-17	44814724
2021	2021	1997-07-28	2019-06-21	44814724
1986	1986	1979-11-20	2017-02-07	44814724
1993	1993	1986-07-24	2017-09-14	44814724
2015	2015	2002-03-26	2019-01-08	44814724
2004	2004	1971-06-01	2019-06-25	44814724
2023	2023	1988-06-11	2017-08-09	44814724
2028	2028	1945-12-06	2018-11-18	44814724
2042	2042	2018-11-11	2019-04-21	44814724
2033	2033	1951-05-22	2019-05-07	44814724
2060	2060	1963-12-04	2019-01-02	44814724
2013	2013	1956-03-17	2019-06-01	44814724
1995	1995	1992-09-03	2018-08-30	44814724
1984	1984	2001-01-31	2019-03-27	44814724
2027	2027	1961-03-17	2019-01-11	44814724
2016	2016	1980-12-09	2017-06-14	44814724
2038	2038	2007-05-13	2019-06-02	44814724
2045	2045	1985-07-18	2018-04-24	44814724
2010	2010	2018-04-17	2019-06-18	44814724
2001	2001	1996-06-11	2017-11-15	44814724
1991	1991	1943-10-11	2011-02-28	44814724
1996	1996	1994-10-02	2018-08-09	44814724
2047	2047	1981-01-01	2018-08-23	44814724
2036	2036	1989-08-15	2017-10-24	44814724
2018	2018	2018-05-10	2019-04-18	44814724
2025	2025	1909-02-21	2019-06-23	44814724
1998	1998	1981-09-19	2019-03-02	44814724
1989	1989	1952-02-15	2019-05-24	44814724
2003	2003	2006-03-15	2019-04-10	44814724
2008	2008	1991-12-27	2019-05-21	44814724
1992	1992	1975-03-23	2017-12-31	44814724
1987	1987	1943-08-14	2019-01-05	44814724
2005	2005	1973-08-11	2019-05-25	44814724
2014	2014	1984-09-24	2019-04-12	44814724
2041	2041	1964-02-25	2019-03-26	44814724
2034	2034	1923-04-18	2018-01-24	44814724
2020	2020	1970-10-31	2019-02-09	44814724
2031	2031	1999-11-18	2019-05-23	44814724
2012	2012	1957-02-01	2019-01-25	44814724
2007	2007	1986-11-03	2018-02-26	44814724
1985	1985	1983-11-25	2018-03-24	44814724
1994	1994	2014-06-06	2019-02-01	44814724
2029	2029	1992-05-01	2017-11-21	44814724
2022	2022	1986-03-06	2019-01-10	44814724
2032	2032	1984-03-25	2018-06-17	44814724
2043	2043	1955-09-11	2018-11-25	44814724
2058	2058	1966-10-26	2018-11-07	44814724
2049	2049	1989-02-13	2018-12-24	44814724
2071	2071	1965-06-16	2018-06-27	44814724
2076	2076	1966-12-29	2019-01-10	44814724
2107	2107	2015-06-03	2019-05-08	44814724
2096	2096	1987-12-03	2019-02-14	44814724
2086	2086	1985-07-29	2019-05-12	44814724
2093	2093	1987-07-03	2018-09-21	44814724
2078	2078	1982-06-09	2019-03-25	44814724
2069	2069	1951-07-23	2019-05-27	44814724
2051	2051	1962-11-18	2018-12-23	44814724
2056	2056	1976-02-12	2019-02-22	44814724
2095	2095	1998-02-20	2017-04-21	44814724
2084	2084	1962-10-10	2018-12-26	44814724
2098	2098	1962-07-04	2018-08-09	44814724
2105	2105	1974-08-18	2019-03-24	44814724
2089	2089	2003-04-15	2019-04-01	44814724
2082	2082	1942-02-05	2019-05-16	44814724
2100	2100	1943-09-07	2019-05-07	44814724
2111	2111	2008-12-13	2018-12-22	44814724
2072	2072	1997-04-22	2019-06-25	44814724
2067	2067	1983-10-12	2018-09-05	44814724
2053	2053	1953-07-02	2018-09-27	44814724
2062	2062	1946-08-17	2019-06-19	44814724
2109	2109	1969-11-23	2019-03-10	44814724
2102	2102	2005-03-24	2019-04-25	44814724
2080	2080	1979-10-12	2019-01-25	44814724
2091	2091	1964-11-15	2018-12-09	44814724
2170	2170	2017-08-28	2019-02-04	44814724
2055	2055	2013-09-12	2018-08-23	44814724
2065	2065	2008-06-27	2019-03-15	44814724
2074	2074	1988-04-18	2016-11-28	44814724
2097	2097	1977-03-05	2019-03-16	44814724
2106	2106	2017-11-03	2019-04-12	44814724
2092	2092	2015-04-02	2019-06-27	44814724
2087	2087	1918-06-12	2018-12-19	44814724
2048	2048	2002-12-22	2018-12-23	44814724
2059	2059	1983-07-01	2017-12-16	44814724
2077	2077	1933-03-27	2012-03-26	44814724
2070	2070	1964-10-26	2018-11-19	44814724
2085	2085	1988-07-26	2017-12-26	44814724
2094	2094	1944-01-09	2018-12-23	44814724
2104	2104	2009-03-20	2019-03-29	44814724
2099	2099	2012-10-19	2019-05-18	44814724
2068	2068	2004-06-28	2019-06-20	44814724
2079	2079	1955-12-16	2018-11-28	44814724
2057	2057	1990-11-25	2016-07-03	44814724
2050	2050	2011-10-08	2018-09-29	44814724
2066	2066	1997-04-13	2018-10-20	44814724
2073	2073	1963-02-15	2018-08-03	44814724
2063	2063	1972-11-11	2019-06-01	44814724
2052	2052	1962-03-05	2019-04-15	44814724
2083	2083	1987-11-18	2019-06-12	44814724
2088	2088	1908-09-22	2018-08-07	44814724
2110	2110	2005-06-23	2018-07-19	44814724
2101	2101	1987-08-28	2017-09-15	44814724
2054	2054	1971-06-24	2019-06-26	44814724
2061	2061	2003-01-07	2018-12-27	44814724
2075	2075	1965-11-30	2019-04-15	44814724
2064	2064	1976-04-07	2019-06-25	44814724
2103	2103	1972-05-13	2017-09-23	44814724
2108	2108	1939-09-08	2018-12-28	44814724
2090	2090	1966-06-01	2018-07-18	44814724
2081	2081	2002-03-11	2019-06-10	44814724
2172	2172	1978-10-07	2018-10-13	44814724
2167	2167	1978-03-15	2018-04-03	44814724
2145	2145	1963-12-21	2019-01-19	44814724
2154	2154	1995-02-07	2018-05-28	44814724
2125	2125	1982-04-29	2019-06-23	44814724
2118	2118	1984-06-06	2019-03-19	44814724
2128	2128	2000-02-17	2019-05-23	44814724
2139	2139	2005-08-21	2018-08-26	44814724
2152	2152	1922-02-11	2018-11-10	44814724
2147	2147	1952-09-27	2019-01-06	44814724
2165	2165	1954-06-02	2018-08-01	44814724
2174	2174	1974-07-01	2018-09-10	44814724
2137	2137	1986-11-03	2019-06-23	44814724
2130	2130	1957-06-06	2018-10-04	44814724
2116	2116	1949-03-28	2019-06-17	44814724
2127	2127	1960-09-03	2018-11-17	44814724
2143	2143	2013-12-11	2018-12-15	44814724
2132	2132	1992-10-27	2018-07-31	44814724
2114	2114	1965-01-27	2019-02-20	44814724
2121	2121	1991-10-18	2018-05-26	44814724
2158	2158	2011-11-29	2018-10-16	44814724
2149	2149	1959-04-18	2019-05-11	44814724
2163	2163	1999-10-18	2018-12-17	44814724
2168	2168	1956-09-13	2018-11-22	44814724
2123	2123	1949-04-22	2018-09-07	44814724
2112	2112	1966-10-29	2000-10-14	44814724
2134	2134	1949-09-11	2018-10-28	44814724
2141	2141	1946-07-09	2019-03-12	44814724
2198	2198	2017-01-16	2019-06-24	44814724
2161	2161	2009-05-10	2019-03-19	44814724
2151	2151	1918-06-12	1999-12-15	44814724
2156	2156	1964-07-23	2019-03-21	44814724
2119	2119	1961-06-12	2018-12-24	44814724
2124	2124	2002-05-12	2019-06-30	44814724
2138	2138	1954-10-10	2018-08-05	44814724
2129	2129	1990-02-14	2019-02-13	44814724
2166	2166	1969-05-11	2019-06-09	44814724
2173	2173	1930-07-08	2018-10-16	44814724
2155	2155	1926-08-11	2009-05-06	44814724
2144	2144	2000-12-07	2019-05-23	44814724
2131	2131	1951-07-26	2018-10-11	44814724
2136	2136	1968-06-01	2019-06-08	44814724
2126	2126	2005-08-04	2018-09-06	44814724
2117	2117	1969-01-09	1993-09-02	44814724
2146	2146	2002-05-09	2019-04-20	44814724
2153	2153	1965-11-20	2018-12-09	44814724
2175	2175	1976-01-29	2019-02-21	44814724
2164	2164	1972-09-29	2019-01-04	44814724
2148	2148	1995-04-29	2018-03-10	44814724
2159	2159	1981-05-03	1999-12-05	44814724
2169	2169	2002-09-17	2018-07-24	44814724
2162	2162	1996-07-13	2018-10-13	44814724
2133	2133	1965-06-07	2018-06-25	44814724
2142	2142	1987-05-08	2019-05-17	44814724
2120	2120	2004-12-09	2019-03-30	44814724
2115	2115	1961-09-25	2018-11-05	44814724
2160	2160	1960-07-12	2019-03-05	44814724
2171	2171	2008-07-30	2018-11-28	44814724
2157	2157	1987-04-28	2019-01-22	44814724
2150	2150	1950-01-20	2019-05-10	44814724
2113	2113	1996-01-03	2018-08-01	44814724
2122	2122	1973-10-20	2017-11-04	44814724
2140	2140	1951-06-07	2018-09-13	44814724
2135	2135	1948-02-02	2018-12-24	44814724
2192	2192	1954-12-23	2018-11-22	44814724
2203	2203	1993-05-03	2018-06-04	44814724
2189	2189	1980-02-03	2019-05-05	44814724
2182	2182	2008-11-08	2019-04-08	44814724
2209	2209	1993-06-21	2018-11-19	44814724
2218	2218	1978-05-23	2017-06-28	44814724
2236	2236	1989-04-19	2017-07-04	44814724
2231	2231	1970-05-09	2018-06-02	44814724
2180	2180	1978-09-30	2018-10-06	44814724
2191	2191	1970-04-19	2018-05-13	44814724
2201	2201	2001-04-20	2019-06-14	44814724
2194	2194	1992-11-25	2019-06-26	44814724
2229	2229	1981-10-10	2019-05-25	44814724
2238	2238	1968-08-05	2019-06-04	44814724
2216	2216	1999-06-10	2019-05-06	44814724
2211	2211	1971-06-20	2017-07-09	44814724
2227	2227	1991-12-03	2006-09-19	44814724
2232	2232	1963-05-10	2019-06-18	44814724
2222	2222	1962-12-25	2018-08-28	44814724
2213	2213	1961-07-19	2019-02-06	44814724
2178	2178	1997-05-13	2017-02-14	44814724
2185	2185	1940-02-08	2019-01-10	44814724
2207	2207	1980-04-24	2018-10-11	44814724
2196	2196	2013-08-03	2018-07-14	44814724
2215	2215	1994-04-30	2019-04-28	44814724
2220	2220	1942-04-15	2019-04-17	44814724
2234	2234	2011-06-18	2019-05-12	44814724
2225	2225	1987-07-26	2018-10-07	44814724
2272	2272	1979-12-01	2017-11-11	44814724
2205	2205	2004-10-24	2018-10-21	44814724
2187	2187	2016-10-07	2019-03-15	44814724
2176	2176	1956-08-20	2018-10-29	44814724
2219	2219	2018-07-14	2019-06-22	44814724
2208	2208	2017-06-22	2019-05-30	44814724
2230	2230	1973-05-17	2018-01-11	44814724
2237	2237	1928-11-11	2019-01-13	44814724
2202	2202	1973-10-12	2018-06-01	44814724
2193	2193	2000-06-28	2019-04-10	44814724
2183	2183	1986-05-15	2019-06-05	44814724
2188	2188	2003-08-01	2019-05-12	44814724
2239	2239	1977-04-14	2018-12-13	44814724
2228	2228	1947-01-19	2018-12-16	44814724
2210	2210	1936-10-25	2018-08-12	44814724
2217	2217	1979-06-30	2019-02-09	44814724
2190	2190	1950-05-08	2019-06-24	44814724
2181	2181	2018-06-05	2019-05-14	44814724
2195	2195	1993-01-30	2019-04-27	44814724
2200	2200	1973-06-10	2019-06-30	44814724
2184	2184	1967-02-15	2019-05-30	44814724
2179	2179	2004-03-09	2019-06-14	44814724
2197	2197	1957-06-04	1986-01-07	44814724
2206	2206	1971-12-03	2018-03-06	44814724
2233	2233	1972-02-01	2019-03-26	44814724
2226	2226	1942-01-23	2018-06-29	44814724
2212	2212	2019-02-18	2019-05-27	44814724
2223	2223	2015-02-06	2019-01-11	44814724
2204	2204	1945-09-13	2018-07-26	44814724
2199	2199	1979-07-22	2018-05-08	44814724
2177	2177	1966-10-26	2018-11-14	44814724
2186	2186	1973-02-08	2019-06-20	44814724
2221	2221	2011-12-24	2018-12-15	44814724
2214	2214	1990-01-28	2018-10-14	44814724
2224	2224	1985-10-09	2018-07-25	44814724
2235	2235	1951-12-05	2012-12-19	44814724
2278	2278	1999-10-20	2018-11-21	44814724
2285	2285	2012-10-25	2018-10-11	44814724
2299	2299	1985-10-28	2017-12-25	44814724
2288	2288	2016-10-20	2019-03-28	44814724
2263	2263	2003-06-16	2019-06-02	44814724
2268	2268	1975-04-29	2019-05-14	44814724
2250	2250	1956-03-07	2019-01-02	44814724
2241	2241	2006-10-06	2019-02-08	44814724
2290	2290	1956-09-29	2018-12-08	44814724
2297	2297	1973-09-06	2017-09-21	44814724
2287	2287	1940-03-01	2014-01-31	44814724
2276	2276	1988-05-27	2016-08-05	44814724
2243	2243	1966-01-21	2019-02-08	44814724
2248	2248	1995-09-30	2019-05-11	44814724
2270	2270	1978-05-31	2018-06-06	44814724
2261	2261	1963-11-06	2019-05-01	44814724
2245	2245	1991-02-04	2019-04-01	44814724
2254	2254	1955-04-03	1966-02-27	44814724
2264	2264	1969-05-11	2018-09-09	44814724
2259	2259	1979-12-04	2018-01-09	44814724
2292	2292	1963-11-15	2019-03-29	44814724
2303	2303	2006-01-22	2019-01-06	44814724
2281	2281	2014-07-17	2019-06-27	44814724
2274	2274	1946-11-04	2018-10-28	44814724
2257	2257	1982-04-10	2019-06-16	44814724
2266	2266	1968-12-14	2018-12-16	44814724
2252	2252	2019-05-16	2019-06-20	44814724
2247	2247	2019-01-02	2019-06-12	44814724
2355	2355	1954-09-28	1976-08-31	44814724
2283	2283	1937-10-18	2019-05-07	44814724
2301	2301	1977-03-04	1978-10-13	44814724
2294	2294	1960-11-25	2019-01-11	44814724
2269	2269	1994-10-10	2018-05-12	44814724
2262	2262	1994-08-06	2016-11-12	44814724
2240	2240	1957-03-27	2019-03-06	44814724
2251	2251	2014-02-12	2019-01-23	44814724
2284	2284	1998-10-27	2018-09-22	44814724
2279	2279	1997-11-05	2019-04-24	44814724
2289	2289	1949-11-01	2019-06-11	44814724
2298	2298	1970-10-30	2018-02-16	44814724
2249	2249	1998-04-19	2018-02-04	44814724
2242	2242	1927-04-10	2018-12-02	44814724
2260	2260	1942-06-08	2018-11-05	44814724
2271	2271	2019-04-18	2019-05-23	44814724
2296	2296	1988-06-06	2018-12-03	44814724
2291	2291	1960-10-14	2019-03-22	44814724
2277	2277	1965-09-05	2018-09-30	44814724
2286	2286	1957-09-02	2018-11-05	44814724
2302	2302	2003-02-24	2018-09-17	44814724
2293	2293	2013-10-27	2018-10-07	44814724
2275	2275	1998-09-27	2019-01-20	44814724
2280	2280	1969-06-05	2019-06-06	44814724
2255	2255	1997-01-31	2019-05-17	44814724
2244	2244	1953-07-24	2018-10-19	44814724
2258	2258	1956-04-19	2019-02-07	44814724
2265	2265	1963-02-17	2018-09-23	44814724
2282	2282	1992-04-10	2018-07-17	44814724
2273	2273	1983-10-19	2018-09-12	44814724
2295	2295	1973-02-06	2019-02-26	44814724
2300	2300	1950-01-26	2019-04-11	44814724
2267	2267	1965-12-13	2018-12-31	44814724
2256	2256	1978-08-09	2018-08-15	44814724
2246	2246	2012-12-09	2019-03-09	44814724
2253	2253	1993-06-18	2019-01-25	44814724
2357	2357	1938-11-16	2019-04-24	44814724
2366	2366	1965-09-13	2018-10-01	44814724
2344	2344	1966-03-14	2019-04-01	44814724
2339	2339	1972-08-22	2017-10-03	44814724
2308	2308	1988-03-12	2017-07-18	44814724
2319	2319	1947-02-15	2019-03-16	44814724
2329	2329	1971-01-12	2018-01-23	44814724
2322	2322	1993-01-11	2019-03-18	44814724
2337	2337	1963-07-17	2018-09-12	44814724
2346	2346	1946-02-06	2019-06-19	44814724
2364	2364	2000-06-23	2018-11-02	44814724
2359	2359	1925-03-17	2019-06-11	44814724
2320	2320	1941-08-02	2018-07-14	44814724
2331	2331	1997-03-21	2018-02-02	44814724
2317	2317	1997-05-21	2003-05-01	44814724
2310	2310	2012-11-01	2018-10-18	44814724
2326	2326	1951-02-08	2019-05-23	44814724
2333	2333	1920-06-01	2010-04-20	44814724
2315	2315	1977-04-30	2018-11-10	44814724
2304	2304	1991-06-23	2018-02-07	44814724
2343	2343	1956-01-14	2018-07-07	44814724
2348	2348	1993-04-13	2019-06-04	44814724
2362	2362	1980-12-23	2018-11-06	44814724
2353	2353	1998-10-05	2018-12-08	44814724
2306	2306	1991-01-05	2019-06-08	44814724
2313	2313	1969-02-12	1970-12-02	44814724
2335	2335	1987-10-14	2018-06-20	44814724
2324	2324	1990-03-21	2019-06-09	44814724
2373	2373	1956-01-19	2018-08-02	44814724
2360	2360	1997-11-05	2018-07-13	44814724
2350	2350	1994-10-12	2016-12-14	44814724
2341	2341	1952-03-27	2019-06-06	44814724
2318	2318	1963-01-26	2018-11-24	44814724
2309	2309	1973-03-30	2019-04-26	44814724
2323	2323	2009-04-21	2019-04-09	44814724
2328	2328	1954-09-27	2019-01-21	44814724
2367	2367	1974-10-29	2018-06-26	44814724
2356	2356	1977-11-02	2017-12-27	44814724
2338	2338	2005-07-12	2018-12-03	44814724
2345	2345	2000-03-02	2019-03-07	44814724
2330	2330	1975-07-21	2017-07-31	44814724
2321	2321	1979-03-07	2019-05-22	44814724
2311	2311	1960-01-31	2019-03-24	44814724
2316	2316	1987-09-08	2018-09-25	44814724
2347	2347	1968-12-02	2019-03-11	44814724
2336	2336	1980-01-30	2018-10-10	44814724
2358	2358	1971-06-08	2018-10-16	44814724
2365	2365	2008-02-11	2019-04-29	44814724
2349	2349	1972-04-09	2019-01-06	44814724
2342	2342	1975-01-17	2019-02-01	44814724
2352	2352	1970-10-26	2019-06-12	44814724
2363	2363	1999-11-15	2018-11-26	44814724
2332	2332	1957-04-21	2019-06-30	44814724
2327	2327	1957-10-16	2019-04-20	44814724
2305	2305	1984-05-22	2017-08-08	44814724
2314	2314	1951-07-07	2018-10-13	44814724
2361	2361	2016-08-18	2019-03-21	44814724
2354	2354	2013-05-17	2019-05-03	44814724
2340	2340	1959-03-05	2019-05-02	44814724
2351	2351	1948-07-17	2019-06-08	44814724
2312	2312	1993-03-21	2017-12-24	44814724
2307	2307	1961-10-03	2018-11-13	44814724
2325	2325	1970-10-29	2019-06-19	44814724
2334	2334	1936-01-30	2018-08-02	44814724
2371	2371	2003-04-28	2019-06-10	44814724
2376	2376	2019-03-03	2019-06-09	44814724
2398	2398	2004-06-06	2019-06-16	44814724
2389	2389	1969-04-01	2019-02-19	44814724
2418	2418	1973-09-04	2018-06-02	44814724
2425	2425	1960-02-18	2019-04-11	44814724
2415	2415	1977-04-01	2019-04-12	44814724
2404	2404	1965-12-05	2018-12-23	44814724
2391	2391	1996-09-19	2019-05-20	44814724
2396	2396	1919-11-19	2001-02-28	44814724
2378	2378	2015-03-20	2019-03-01	44814724
2369	2369	1981-05-03	2016-07-31	44814724
2406	2406	1942-12-10	1993-09-30	44814724
2413	2413	1996-09-16	2017-12-08	44814724
2427	2427	1942-01-13	2018-11-20	44814724
2416	2416	1998-01-02	2017-12-01	44814724
2400	2400	2013-11-18	2019-06-07	44814724
2411	2411	1964-07-02	2019-02-08	44814724
2429	2429	2018-05-16	2019-06-10	44814724
2422	2422	1996-04-26	2018-06-29	44814724
2385	2385	1988-08-07	2016-08-14	44814724
2394	2394	1911-05-01	1992-02-17	44814724
2380	2380	1950-05-27	2019-02-16	44814724
2375	2375	2003-04-08	2018-10-23	44814724
2420	2420	2017-04-19	2019-04-07	44814724
2431	2431	1971-07-21	2018-11-14	44814724
2409	2409	1978-10-02	2019-06-15	44814724
2402	2402	1976-09-13	2018-04-16	44814724
2473	2473	2009-08-13	2019-06-22	44814724
2382	2382	1987-04-21	2018-07-03	44814724
2392	2392	1916-02-04	2019-03-13	44814724
2387	2387	1969-02-23	2018-09-23	44814724
2424	2424	1962-06-14	2018-09-06	44814724
2419	2419	1944-10-20	2019-05-31	44814724
2405	2405	2012-06-08	2019-05-31	44814724
2414	2414	1918-04-04	2000-05-04	44814724
2377	2377	2015-06-14	2019-05-19	44814724
2370	2370	1943-10-11	1977-06-27	44814724
2388	2388	2005-04-15	2019-04-12	44814724
2399	2399	2017-05-15	2019-04-22	44814724
2412	2412	1950-05-26	2018-10-15	44814724
2407	2407	2018-11-08	2019-04-18	44814724
2417	2417	2013-08-29	2018-11-01	44814724
2426	2426	2017-07-22	2019-06-29	44814724
2397	2397	2011-11-05	2019-03-15	44814724
2390	2390	2006-07-29	2018-08-18	44814724
2368	2368	2017-11-06	2019-04-15	44814724
2379	2379	1997-03-18	2019-05-21	44814724
2395	2395	1959-02-14	2019-05-01	44814724
2384	2384	1984-02-22	2018-11-07	44814724
2374	2374	1979-02-15	2019-06-13	44814724
2381	2381	1936-03-18	2013-02-06	44814724
2410	2410	2017-01-19	2019-06-27	44814724
2401	2401	1998-02-20	2019-01-11	44814724
2423	2423	1956-10-22	2019-06-03	44814724
2428	2428	1974-06-25	2018-03-27	44814724
2383	2383	1979-06-10	2019-04-07	44814724
2372	2372	1959-04-03	2019-05-31	44814724
2386	2386	1999-10-10	2019-02-10	44814724
2393	2393	2015-03-13	2019-02-15	44814724
2430	2430	1985-01-19	2019-03-12	44814724
2421	2421	2010-01-10	2019-05-12	44814724
2403	2403	2019-06-23	2019-06-23	44814724
2408	2408	2010-02-06	2019-02-09	44814724
2479	2479	1998-12-07	2018-06-30	44814724
2468	2468	1938-04-10	2018-10-28	44814724
2482	2482	1974-09-12	2018-07-20	44814724
2489	2489	2009-04-21	2019-04-30	44814724
2462	2462	1961-10-08	2018-11-18	44814724
2453	2453	2007-08-01	2018-08-15	44814724
2435	2435	1972-11-11	2018-03-24	44814724
2440	2440	1989-01-11	2018-01-03	44814724
2491	2491	1967-08-29	1982-01-12	44814724
2480	2480	1955-11-02	2018-11-14	44814724
2470	2470	1958-12-15	2019-05-07	44814724
2477	2477	1955-02-27	2019-01-06	44814724
2442	2442	1971-06-21	2018-07-23	44814724
2433	2433	1953-01-11	2019-04-14	44814724
2455	2455	2004-02-13	2019-03-15	44814724
2460	2460	1984-08-08	2018-12-25	44814724
2444	2444	1955-08-07	2018-10-21	44814724
2439	2439	1972-05-17	2019-01-23	44814724
2449	2449	1978-06-10	2018-06-16	44814724
2458	2458	1970-05-24	2018-06-17	44814724
2493	2493	1984-06-09	2018-12-15	44814724
2486	2486	1974-03-22	2018-04-06	44814724
2464	2464	2008-02-27	2018-11-07	44814724
2475	2475	1987-03-18	2019-01-10	44814724
2456	2456	1955-04-24	2019-02-24	44814724
2451	2451	1991-11-26	2019-03-13	44814724
2437	2437	1961-08-08	2018-07-31	44814724
2446	2446	2015-08-04	2019-05-28	44814724
2527	2527	1991-07-24	2017-01-08	44814724
2466	2466	1979-09-16	2019-05-19	44814724
2484	2484	2003-04-30	2019-04-16	44814724
2495	2495	1980-09-30	2017-01-03	44814724
2452	2452	2013-01-09	2019-05-01	44814724
2463	2463	1969-04-10	2019-04-11	44814724
2441	2441	1998-01-24	2017-08-12	44814724
2434	2434	2008-01-23	2019-06-05	44814724
2469	2469	1971-08-01	2017-08-20	44814724
2478	2478	2009-02-08	2019-02-17	44814724
2488	2488	2007-06-29	2019-06-26	44814724
2483	2483	1944-03-04	1987-06-13	44814724
2432	2432	2005-03-21	2019-06-17	44814724
2443	2443	1961-12-29	2019-02-03	44814724
2461	2461	1966-11-01	2019-01-08	44814724
2454	2454	2002-03-04	2018-12-27	44814724
2481	2481	1969-07-20	2019-03-31	44814724
2490	2490	1982-12-25	2019-01-26	44814724
2476	2476	1956-10-03	2018-08-22	44814724
2471	2471	1996-11-27	2016-11-09	44814724
2487	2487	1952-03-03	2019-02-25	44814724
2492	2492	2006-09-05	2018-07-24	44814724
2474	2474	2013-03-07	2019-02-21	44814724
2465	2465	2008-04-16	2019-05-01	44814724
2438	2438	1980-06-22	2018-04-15	44814724
2445	2445	1927-10-03	1999-02-01	44814724
2459	2459	1976-06-21	2019-04-21	44814724
2448	2448	1964-07-15	2018-08-08	44814724
2467	2467	1988-09-17	2019-04-25	44814724
2472	2472	1985-10-21	2017-09-19	44814724
2494	2494	1988-11-21	2017-04-24	44814724
2485	2485	1913-07-02	2019-02-06	44814724
2450	2450	1951-01-04	2018-10-29	44814724
2457	2457	1991-09-06	2019-01-20	44814724
2447	2447	1980-08-20	2017-10-11	44814724
2436	2436	1912-03-16	2019-06-22	44814724
2521	2521	1948-01-19	2018-10-22	44814724
2514	2514	1987-12-16	2016-09-14	44814724
2500	2500	1991-10-30	2018-07-11	44814724
2511	2511	1993-06-22	2017-11-28	44814724
2536	2536	2005-02-12	2018-12-08	44814724
2531	2531	1986-09-28	2017-12-10	44814724
2549	2549	1982-01-17	2017-11-19	44814724
2558	2558	1990-08-30	2019-01-03	44814724
2509	2509	1969-06-08	2019-06-09	44814724
2502	2502	1983-08-12	2016-08-19	44814724
2512	2512	2007-02-11	2019-05-05	44814724
2523	2523	2017-01-26	2019-01-03	44814724
2556	2556	1967-12-25	2018-12-31	44814724
2551	2551	1958-08-21	2019-03-21	44814724
2529	2529	2002-04-19	2019-03-31	44814724
2538	2538	1989-09-16	2017-09-23	44814724
2554	2554	1933-07-28	2019-03-22	44814724
2545	2545	1945-07-26	2008-01-17	44814724
2535	2535	1961-01-01	2019-02-17	44814724
2540	2540	1936-12-22	2019-04-16	44814724
2507	2507	1967-05-03	2019-04-17	44814724
2496	2496	1998-03-14	2019-05-11	44814724
2518	2518	1953-08-21	2019-02-08	44814724
2525	2525	1974-01-04	2019-01-25	44814724
2542	2542	1963-05-31	2019-01-11	44814724
2533	2533	2016-04-06	2019-03-20	44814724
2547	2547	1986-05-13	2019-06-18	44814724
2552	2552	1963-08-25	1982-11-14	44814724
2575	2575	2017-04-03	2019-03-11	44814724
2516	2516	1989-02-09	2019-02-25	44814724
2498	2498	1971-07-10	2018-10-18	44814724
2505	2505	2014-10-22	2018-11-11	44814724
2530	2530	1964-04-26	2019-05-12	44814724
2537	2537	1947-08-17	2019-02-17	44814724
2559	2559	1958-02-15	2018-07-21	44814724
2548	2548	1965-10-04	2019-02-11	44814724
2515	2515	1999-02-12	2019-01-08	44814724
2520	2520	1991-09-11	2017-08-09	44814724
2510	2510	1997-09-19	2018-11-28	44814724
2501	2501	1961-11-27	2019-06-04	44814724
2550	2550	1983-01-16	2018-04-10	44814724
2557	2557	1988-05-14	2019-05-11	44814724
2539	2539	2000-06-24	2019-03-02	44814724
2528	2528	1968-03-20	2019-03-27	44814724
2503	2503	1973-02-20	2019-03-12	44814724
2508	2508	1994-12-27	2017-07-04	44814724
2522	2522	1958-07-11	2019-02-22	44814724
2513	2513	1983-03-13	2018-07-08	44814724
2497	2497	1961-08-31	2018-08-23	44814724
2506	2506	1981-01-30	2017-02-03	44814724
2524	2524	1949-06-18	2002-07-13	44814724
2519	2519	1993-07-15	2019-03-07	44814724
2544	2544	1987-01-20	2017-03-07	44814724
2555	2555	1950-03-09	2018-09-20	44814724
2541	2541	1975-09-29	2019-05-27	44814724
2534	2534	1972-07-25	2017-08-08	44814724
2517	2517	1984-06-13	2017-09-13	44814724
2526	2526	1974-12-23	2019-01-07	44814724
2504	2504	1953-10-26	2018-11-19	44814724
2499	2499	1982-06-15	2017-01-10	44814724
2532	2532	2015-11-19	2019-04-25	44814724
2543	2543	1964-10-18	2019-03-17	44814724
2553	2553	1985-04-06	2017-11-18	44814724
2546	2546	1975-03-28	2019-01-25	44814724
2569	2569	2009-05-02	2019-05-11	44814724
2562	2562	2006-09-25	2018-10-15	44814724
2580	2580	1958-06-09	2018-09-17	44814724
2591	2591	1931-06-18	2018-12-06	44814724
2616	2616	1951-11-27	2019-02-19	44814724
2611	2611	1951-07-19	2018-12-04	44814724
2597	2597	1970-11-24	2018-12-18	44814724
2606	2606	1909-02-21	1948-10-03	44814724
2589	2589	1983-03-22	2017-11-14	44814724
2582	2582	2012-08-29	2018-08-15	44814724
2560	2560	2018-01-25	2019-06-20	44814724
2571	2571	1978-02-12	2018-02-18	44814724
2604	2604	1956-03-11	2018-12-09	44814724
2599	2599	1978-01-28	2019-06-12	44814724
2609	2609	1958-05-02	2018-12-21	44814724
2618	2618	2009-06-10	2019-06-19	44814724
2602	2602	1948-09-29	2019-06-11	44814724
2593	2593	2015-06-27	2019-03-30	44814724
2615	2615	1947-11-17	2019-06-24	44814724
2620	2620	1963-11-12	2018-12-11	44814724
2587	2587	2015-02-28	2019-02-02	44814724
2576	2576	1979-11-09	2018-09-14	44814724
2566	2566	1939-10-24	2019-04-09	44814724
2573	2573	1981-01-22	2019-06-04	44814724
2622	2622	1930-11-09	2019-01-13	44814724
2613	2613	1955-05-13	2018-09-21	44814724
2595	2595	2019-06-17	2019-06-17	44814724
2600	2600	2002-08-10	2018-09-22	44814724
2681	2681	1996-12-13	2019-02-22	44814724
2564	2564	1976-08-21	2017-11-11	44814724
2578	2578	1970-08-27	2018-09-20	44814724
2585	2585	2005-02-23	2019-03-27	44814724
2610	2610	1957-07-06	2019-01-12	44814724
2617	2617	1952-02-10	2018-09-30	44814724
2607	2607	2018-05-28	2019-05-06	44814724
2596	2596	1966-10-29	2018-11-17	44814724
2563	2563	1970-06-21	2019-03-31	44814724
2568	2568	2010-06-02	2019-06-05	44814724
2590	2590	1962-10-16	2018-11-20	44814724
2581	2581	1994-07-16	2019-05-20	44814724
2598	2598	1974-01-08	2019-05-21	44814724
2605	2605	1978-07-07	2018-05-11	44814724
2619	2619	1938-11-12	2018-09-15	44814724
2608	2608	2011-10-25	2018-11-26	44814724
2583	2583	1970-06-15	2018-11-05	44814724
2588	2588	1964-08-30	2018-09-23	44814724
2570	2570	1935-08-22	2018-12-21	44814724
2561	2561	1976-10-27	2018-12-26	44814724
2577	2577	1973-05-12	2019-06-01	44814724
2586	2586	1968-06-30	2018-08-19	44814724
2572	2572	1969-06-24	2019-06-12	44814724
2567	2567	1975-07-26	2018-08-30	44814724
2592	2592	2000-12-09	2019-02-02	44814724
2603	2603	1960-05-25	2019-05-15	44814724
2621	2621	1956-08-25	2019-05-25	44814724
2614	2614	2008-08-24	2019-05-05	44814724
2565	2565	2013-10-18	2019-05-24	44814724
2574	2574	1961-01-04	2019-02-20	44814724
2584	2584	2016-07-01	2019-06-07	44814724
2579	2579	1952-04-21	2019-06-17	44814724
2612	2612	2009-03-07	2019-03-16	44814724
2623	2623	2009-01-27	2019-02-05	44814724
2601	2601	2008-07-09	2019-04-17	44814724
2594	2594	1975-02-26	2019-06-12	44814724
2687	2687	2015-11-12	2019-04-18	44814724
2676	2676	2012-01-05	2018-10-11	44814724
2658	2658	1994-05-21	2018-09-05	44814724
2665	2665	1984-11-18	2017-03-12	44814724
2638	2638	2001-06-13	2018-07-18	44814724
2629	2629	2000-07-30	2018-12-23	44814724
2643	2643	2003-06-13	2018-12-15	44814724
2648	2648	2004-09-04	2018-10-06	44814724
2667	2667	1987-12-22	2017-09-12	44814724
2656	2656	1990-05-19	2018-07-14	44814724
2678	2678	2007-07-05	2018-07-19	44814724
2685	2685	1942-11-26	2017-06-08	44814724
2650	2650	1999-12-04	2019-03-09	44814724
2641	2641	1990-09-21	2019-03-08	44814724
2631	2631	1951-05-14	2017-05-15	44814724
2636	2636	1960-04-15	2019-03-15	44814724
2652	2652	1986-03-22	2019-05-11	44814724
2647	2647	1970-12-13	2019-01-07	44814724
2625	2625	1983-07-19	2019-04-21	44814724
2634	2634	2001-06-27	2018-07-04	44814724
2669	2669	1976-12-08	2018-04-11	44814724
2662	2662	1978-04-28	2018-04-27	44814724
2672	2672	1950-11-26	2018-11-04	44814724
2683	2683	1980-04-28	2019-01-07	44814724
2632	2632	1987-11-10	2019-01-22	44814724
2627	2627	1981-05-25	2019-01-28	44814724
2645	2645	2001-02-03	2019-03-30	44814724
2654	2654	1943-11-04	2019-04-11	44814724
2709	2709	1939-01-10	2019-03-26	44814724
2674	2674	1971-04-24	2019-05-18	44814724
2660	2660	2005-10-13	2018-11-01	44814724
2671	2671	2006-12-14	2018-10-25	44814724
2628	2628	2006-06-29	2018-07-19	44814724
2639	2639	2011-05-21	2019-03-09	44814724
2649	2649	1957-06-03	2018-07-02	44814724
2642	2642	1981-01-08	2018-11-08	44814724
2677	2677	1972-04-15	2018-05-19	44814724
2686	2686	1952-09-21	2018-09-30	44814724
2664	2664	1996-01-27	2019-03-18	44814724
2659	2659	1974-06-26	2018-08-16	44814724
2640	2640	1986-01-04	2017-10-28	44814724
2651	2651	1946-09-18	2019-06-26	44814724
2637	2637	1984-07-25	2017-05-31	44814724
2630	2630	1959-12-20	2018-09-30	44814724
2657	2657	1966-01-09	2019-01-27	44814724
2666	2666	1950-12-17	2018-08-26	44814724
2684	2684	1961-02-12	2018-08-26	44814724
2679	2679	1972-03-31	2018-04-20	44814724
2663	2663	1963-09-01	2018-09-30	44814724
2668	2668	1991-04-12	1995-03-24	44814724
2682	2682	1973-06-15	2017-12-15	44814724
2673	2673	1977-02-07	2018-12-03	44814724
2646	2646	1974-07-12	2018-07-27	44814724
2653	2653	1993-02-19	2018-04-27	44814724
2635	2635	1999-11-29	2019-01-28	44814724
2624	2624	1968-01-04	2019-01-10	44814724
2675	2675	1961-01-29	2019-03-17	44814724
2680	2680	1972-03-09	2017-11-23	44814724
2670	2670	2011-08-09	2018-07-31	44814724
2661	2661	1964-09-12	2018-08-25	44814724
2626	2626	1963-07-02	2018-08-21	44814724
2633	2633	1947-10-16	2019-03-07	44814724
2655	2655	1994-04-09	2018-05-11	44814724
2644	2644	1980-02-11	2018-11-05	44814724
2707	2707	2011-11-19	2019-01-26	44814724
2712	2712	1963-12-31	2019-01-29	44814724
2702	2702	1940-10-14	2019-02-25	44814724
2693	2693	1958-10-14	2019-02-23	44814724
2722	2722	1986-01-03	2018-10-27	44814724
2729	2729	1981-02-02	2018-12-25	44814724
2751	2751	1979-06-06	2019-06-12	44814724
2740	2740	1968-12-10	2018-10-02	44814724
2695	2695	2007-05-07	2019-04-01	44814724
2700	2700	2001-07-26	2018-09-27	44814724
2714	2714	1989-12-08	2018-10-05	44814724
2705	2705	1942-01-31	2018-09-01	44814724
2742	2742	2003-04-23	2019-04-29	44814724
2749	2749	1959-12-23	2019-05-08	44814724
2731	2731	1960-07-12	2019-01-01	44814724
2720	2720	2019-04-07	2019-05-12	44814724
2736	2736	1969-08-07	2019-06-13	44814724
2747	2747	1972-06-11	2019-05-01	44814724
2733	2733	1995-07-12	2017-03-08	44814724
2726	2726	2013-03-13	2019-02-27	44814724
2689	2689	2009-09-13	2018-07-29	44814724
2698	2698	1983-04-06	2017-05-17	44814724
2716	2716	1988-09-12	2017-05-30	44814724
2711	2711	1950-06-26	2019-06-11	44814724
2724	2724	1954-05-24	2019-05-13	44814724
2735	2735	2001-04-23	2019-03-30	44814724
2745	2745	1971-03-21	2018-08-05	44814724
2738	2738	2007-01-28	2018-12-09	44814724
2787	2787	2002-11-11	2018-07-03	44814724
2718	2718	1985-10-15	2017-09-05	44814724
2696	2696	1993-11-13	2019-06-29	44814724
2691	2691	1987-01-06	2018-03-20	44814724
2728	2728	2010-03-29	2019-04-01	44814724
2723	2723	2015-12-11	2019-05-17	44814724
2741	2741	1990-06-14	2018-09-20	44814724
2750	2750	1923-04-18	2011-06-01	44814724
2713	2713	1971-06-01	1972-09-12	44814724
2706	2706	1963-04-10	2019-05-01	44814724
2692	2692	1947-11-17	1998-07-06	44814724
2703	2703	1974-03-03	2018-03-18	44814724
2748	2748	1979-02-20	2019-02-26	44814724
2743	2743	1960-04-06	2019-05-29	44814724
2721	2721	1967-11-11	2019-05-04	44814724
2730	2730	2001-09-15	2019-05-04	44814724
2701	2701	1984-11-27	2019-01-22	44814724
2694	2694	2014-03-19	2019-04-08	44814724
2704	2704	1971-08-15	2018-12-20	44814724
2715	2715	1966-01-13	2017-11-30	44814724
2699	2699	1970-11-18	2019-02-05	44814724
2688	2688	1962-11-18	2018-12-23	44814724
2710	2710	1990-07-31	2019-05-16	44814724
2717	2717	1986-01-21	2018-01-30	44814724
2746	2746	1985-02-09	2019-06-01	44814724
2737	2737	2018-07-25	2019-04-03	44814724
2727	2727	1992-07-23	2017-12-28	44814724
2732	2732	1969-08-08	2017-09-01	44814724
2719	2719	1987-05-09	2017-07-22	44814724
2708	2708	1954-06-07	2019-01-14	44814724
2690	2690	1948-10-01	2001-08-10	44814724
2697	2697	1933-04-20	2005-09-15	44814724
2734	2734	1978-05-11	2018-03-01	44814724
2725	2725	2013-04-24	2019-04-10	44814724
2739	2739	1953-03-18	2015-12-02	44814724
2744	2744	1980-12-05	2018-02-23	44814724
2789	2789	1987-05-29	2018-08-10	44814724
2798	2798	1953-10-11	2018-10-07	44814724
2808	2808	1983-09-27	2019-04-30	44814724
2803	2803	2005-11-10	2019-04-25	44814724
2772	2772	1990-07-22	2018-09-23	44814724
2783	2783	2015-06-12	2019-03-22	44814724
2761	2761	1980-05-19	2017-07-17	44814724
2754	2754	1982-12-22	2017-08-02	44814724
2801	2801	1922-02-17	2002-04-12	44814724
2810	2810	1991-10-03	2017-05-25	44814724
2796	2796	1995-09-10	2018-07-15	44814724
2791	2791	1993-07-02	2019-02-15	44814724
2752	2752	1951-03-18	2018-10-07	44814724
2763	2763	2005-07-21	2019-06-27	44814724
2781	2781	1980-03-28	2017-02-03	44814724
2774	2774	1940-03-22	2019-04-26	44814724
2758	2758	1940-03-01	2019-02-01	44814724
2765	2765	1934-05-22	2019-01-16	44814724
2779	2779	1970-11-15	2019-05-20	44814724
2768	2768	1969-06-10	2018-10-02	44814724
2807	2807	1991-08-03	2019-01-10	44814724
2812	2812	1938-06-06	2019-05-20	44814724
2794	2794	1999-03-31	2019-03-20	44814724
2785	2785	2012-11-20	2018-11-06	44814724
2770	2770	1931-04-04	2018-12-19	44814724
2777	2777	1960-04-01	2019-05-24	44814724
2767	2767	1936-04-09	2019-04-11	44814724
2756	2756	1989-06-19	2017-11-20	44814724
2864	2864	1939-04-27	2019-05-09	44814724
2792	2792	1957-10-07	2018-12-10	44814724
2814	2814	2016-05-05	2019-06-22	44814724
2805	2805	2012-09-13	2018-08-30	44814724
2782	2782	1919-11-19	2002-03-13	44814724
2773	2773	1996-03-24	2018-05-27	44814724
2755	2755	2015-06-30	2019-06-04	44814724
2760	2760	1957-03-28	2018-10-11	44814724
2799	2799	1980-04-03	2017-06-22	44814724
2788	2788	1978-03-20	2018-03-26	44814724
2802	2802	1938-09-10	1997-12-20	44814724
2809	2809	2010-10-01	2018-09-28	44814724
2762	2762	2012-08-29	2018-08-01	44814724
2753	2753	2009-09-30	2018-07-25	44814724
2775	2775	2011-10-07	2019-04-26	44814724
2780	2780	1956-01-18	2019-04-24	44814724
2811	2811	2015-06-20	2019-05-26	44814724
2800	2800	1980-01-29	2018-03-13	44814724
2790	2790	1952-07-24	2019-05-16	44814724
2797	2797	2000-04-20	2019-01-24	44814724
2813	2813	1934-07-28	2019-03-16	44814724
2806	2806	1953-04-16	2018-07-12	44814724
2784	2784	1995-03-12	2017-08-06	44814724
2795	2795	1979-01-16	2019-01-22	44814724
2764	2764	1973-08-24	2017-09-08	44814724
2759	2759	2001-01-05	2019-03-01	44814724
2769	2769	1986-12-17	2017-12-27	44814724
2778	2778	1976-10-23	2017-09-16	44814724
2793	2793	1992-01-22	2017-03-29	44814724
2786	2786	1923-04-28	2015-12-19	44814724
2804	2804	1951-10-11	2018-09-06	44814724
2815	2815	1962-09-14	2019-05-31	44814724
2776	2776	1975-07-14	2017-07-24	44814724
2771	2771	1909-09-17	2018-09-07	44814724
2757	2757	1973-02-03	2018-08-04	44814724
2766	2766	1949-09-11	1952-06-08	44814724
2870	2870	1992-02-18	2019-05-24	44814724
2877	2877	2013-01-30	2019-01-16	44814724
2859	2859	1942-06-16	2018-11-13	44814724
2848	2848	2005-05-31	2019-06-18	44814724
2823	2823	2001-09-24	2019-05-20	44814724
2828	2828	1992-06-09	2018-01-02	44814724
2842	2842	1958-09-26	2019-03-08	44814724
2833	2833	1935-10-14	2013-10-28	44814724
2850	2850	1986-04-09	2016-08-03	44814724
2857	2857	1964-03-12	2018-09-27	44814724
2879	2879	1998-04-15	2018-01-06	44814724
2868	2868	1962-10-10	2016-02-17	44814724
2835	2835	1912-11-12	2018-10-09	44814724
2840	2840	2016-12-22	2019-05-30	44814724
2830	2830	1974-08-12	2019-01-14	44814724
2821	2821	1920-06-01	2010-07-13	44814724
2837	2837	1966-08-03	2018-10-25	44814724
2846	2846	1972-06-26	2018-07-16	44814724
2824	2824	1984-02-13	2019-04-17	44814724
2819	2819	2015-03-05	2019-02-07	44814724
2852	2852	2015-04-10	2019-03-15	44814724
2863	2863	1961-09-14	2019-06-13	44814724
2873	2873	2000-01-01	2019-03-22	44814724
2866	2866	1966-08-07	2018-10-03	44814724
2817	2817	1982-11-03	2017-01-25	44814724
2826	2826	1989-09-27	2018-05-10	44814724
2844	2844	1948-03-08	2019-05-25	44814724
2839	2839	1972-02-21	2018-11-26	44814724
2886	2886	1950-12-11	2019-04-29	44814724
2875	2875	1980-05-08	2001-11-29	44814724
2861	2861	1963-07-08	2019-06-19	44814724
2854	2854	2009-06-17	2019-06-26	44814724
2829	2829	1950-09-04	2018-10-01	44814724
2822	2822	1975-12-24	2018-01-03	44814724
2832	2832	1965-02-14	2018-09-09	44814724
2843	2843	1958-08-07	2018-12-20	44814724
2876	2876	1963-10-11	2018-11-09	44814724
2871	2871	1950-12-11	2019-03-25	44814724
2849	2849	1919-08-04	2018-09-10	44814724
2858	2858	1910-03-23	2019-05-29	44814724
2841	2841	1949-06-26	1994-08-28	44814724
2834	2834	1937-04-24	1999-12-11	44814724
2820	2820	2008-01-10	2019-01-31	44814724
2831	2831	2000-12-07	2018-08-30	44814724
2856	2856	1990-11-25	1999-01-17	44814724
2851	2851	1985-08-21	2018-08-01	44814724
2869	2869	1950-10-24	2019-02-05	44814724
2878	2878	1980-08-25	2019-04-12	44814724
2862	2862	1967-08-26	2018-11-17	44814724
2853	2853	1961-08-02	2019-06-19	44814724
2867	2867	1978-08-15	2018-08-21	44814724
2872	2872	1952-03-11	1999-08-24	44814724
2847	2847	1962-02-11	2019-03-17	44814724
2836	2836	1980-09-01	2019-03-22	44814724
2818	2818	1967-12-04	2018-12-10	44814724
2825	2825	1925-02-24	2019-03-12	44814724
2874	2874	2014-12-29	2018-12-03	44814724
2865	2865	1968-01-30	2019-02-05	44814724
2855	2855	1982-11-22	2017-07-19	44814724
2860	2860	1941-10-17	2018-08-03	44814724
2827	2827	1920-06-01	2001-10-16	44814724
2816	2816	1995-07-09	2018-06-24	44814724
2838	2838	1996-03-16	2018-05-19	44814724
2845	2845	1952-10-02	2019-03-28	44814724
2880	2880	1989-05-14	2019-03-10	44814724
2891	2891	1973-11-22	2019-05-11	44814724
2909	2909	1945-02-26	2007-07-23	44814724
2902	2902	1946-07-05	2019-05-17	44814724
2929	2929	1974-08-17	2017-11-04	44814724
2938	2938	2002-07-08	2018-09-13	44814724
2924	2924	2014-04-06	2019-03-17	44814724
2919	2919	1949-08-20	2018-12-22	44814724
2900	2900	1991-04-05	2019-06-14	44814724
2911	2911	1979-08-23	2018-08-16	44814724
2889	2889	1960-03-20	2018-11-25	44814724
2882	2882	1972-05-12	2017-09-01	44814724
2917	2917	1936-09-02	2019-03-07	44814724
2926	2926	1981-09-18	2019-01-04	44814724
2936	2936	1962-06-02	2019-06-17	44814724
2931	2931	2018-10-03	2019-06-12	44814724
2915	2915	1944-05-07	2019-04-16	44814724
2920	2920	1991-04-16	2017-03-07	44814724
2942	2942	1953-07-29	2019-04-17	44814724
2933	2933	1953-11-23	2018-11-19	44814724
2898	2898	1979-01-17	2019-01-23	44814724
2905	2905	1966-11-28	2019-06-24	44814724
2895	2895	1957-12-22	2019-05-26	44814724
2884	2884	2011-06-09	2019-06-06	44814724
2935	2935	1976-04-07	2018-06-08	44814724
2940	2940	2014-02-08	2018-12-22	44814724
2922	2922	1986-05-30	2019-05-03	44814724
2913	2913	1946-02-23	2018-07-21	44814724
2986	2986	1944-10-10	2019-06-18	44814724
2893	2893	1943-06-02	2019-05-29	44814724
2907	2907	1988-09-06	2016-10-25	44814724
2896	2896	1969-03-23	2019-03-24	44814724
2939	2939	1953-01-20	2018-09-04	44814724
2928	2928	1989-05-24	2018-11-21	44814724
2918	2918	2010-09-13	2019-06-17	44814724
2925	2925	1960-01-11	2019-04-08	44814724
2890	2890	1961-12-09	2019-01-19	44814724
2881	2881	1980-02-21	2018-05-24	44814724
2903	2903	1963-09-15	2019-04-28	44814724
2908	2908	1986-11-25	2018-02-06	44814724
2927	2927	1942-04-24	2018-10-05	44814724
2916	2916	2008-01-14	2019-06-15	44814724
2930	2930	1993-10-14	2019-06-18	44814724
2937	2937	2000-09-24	2018-11-18	44814724
2910	2910	1979-06-21	2018-09-13	44814724
2901	2901	2016-05-23	2019-04-29	44814724
2883	2883	1964-02-26	2019-06-05	44814724
2888	2888	1989-03-03	2018-02-16	44814724
2904	2904	1970-05-20	2018-06-13	44814724
2899	2899	1949-08-25	2019-04-11	44814724
2885	2885	1985-08-18	2018-07-26	44814724
2894	2894	1922-02-11	2007-03-17	44814724
2921	2921	1940-06-18	2018-11-27	44814724
2914	2914	1955-10-01	2019-04-27	44814724
2932	2932	2001-12-30	2018-10-28	44814724
2943	2943	1914-06-01	2018-06-25	44814724
2892	2892	1972-09-29	2017-07-28	44814724
2887	2887	1983-08-20	2017-11-19	44814724
2897	2897	1960-06-04	2018-09-29	44814724
2906	2906	1924-04-13	2019-04-28	44814724
2941	2941	2007-03-11	2019-03-31	44814724
2934	2934	2008-11-22	2019-06-08	44814724
2912	2912	2002-05-16	2019-02-05	44814724
2923	2923	1991-04-18	2019-06-27	44814724
2988	2988	1962-06-10	2018-11-25	44814724
2983	2983	1994-10-22	2017-08-05	44814724
2993	2993	1970-06-14	2019-06-02	44814724
3002	3002	1973-07-03	2018-12-18	44814724
2973	2973	2014-02-28	2019-04-26	44814724
2966	2966	1961-11-11	2018-11-03	44814724
2944	2944	1960-01-31	2019-06-30	44814724
2955	2955	1969-07-29	2019-05-14	44814724
3000	3000	1948-04-16	2018-06-29	44814724
2995	2995	1982-10-12	2016-12-27	44814724
2981	2981	1997-08-04	2017-02-06	44814724
2990	2990	2007-04-18	2019-05-08	44814724
2953	2953	1982-11-12	2019-03-28	44814724
2946	2946	1983-03-22	2018-01-30	44814724
2964	2964	1987-03-30	2019-01-28	44814724
2975	2975	1962-04-08	2019-05-19	44814724
2959	2959	1970-12-22	2018-11-16	44814724
2948	2948	1979-02-16	2019-02-22	44814724
2962	2962	2000-10-10	2019-02-26	44814724
2969	2969	1965-01-21	2019-02-14	44814724
3006	3006	2014-11-21	2019-03-30	44814724
2997	2997	1981-10-04	2018-12-16	44814724
2979	2979	2007-04-28	2019-05-18	44814724
2984	2984	1978-03-06	2018-07-28	44814724
2971	2971	2014-11-10	2018-10-15	44814724
2960	2960	1955-02-04	2019-04-26	44814724
2950	2950	1935-10-14	2018-04-09	44814724
2957	2957	1947-05-04	2019-04-07	44814724
3036	3036	1986-02-17	2018-01-29	44814724
2977	2977	1987-04-28	2018-02-20	44814724
2999	2999	1987-08-24	2018-05-14	44814724
3004	3004	1950-10-03	2019-03-19	44814724
2967	2967	2017-04-04	2019-03-12	44814724
2972	2972	2002-05-24	2019-05-10	44814724
2954	2954	1995-11-17	2018-08-31	44814724
2945	2945	1945-07-18	2012-02-08	44814724
2982	2982	2009-12-29	2019-01-01	44814724
2989	2989	1954-06-23	2018-09-12	44814724
3003	3003	1994-04-29	2019-04-27	44814724
2992	2992	1956-07-20	2018-07-20	44814724
2947	2947	1974-05-22	2018-06-06	44814724
2952	2952	1990-07-30	2018-11-26	44814724
2974	2974	2000-07-19	2018-09-12	44814724
2965	2965	1970-02-23	2017-09-18	44814724
2994	2994	2005-05-07	2019-06-08	44814724
3001	3001	1947-02-18	2019-02-21	44814724
2991	2991	1960-03-04	2018-10-01	44814724
2980	2980	1971-12-19	2018-04-01	44814724
2996	2996	2016-04-30	2019-04-06	44814724
3007	3007	1966-05-25	2019-06-12	44814724
2985	2985	1963-10-20	2019-05-02	44814724
2978	2978	1957-12-13	1974-05-31	44814724
2949	2949	1950-07-25	2019-04-11	44814724
2958	2958	1996-12-01	2018-01-28	44814724
2968	2968	2014-11-24	2018-10-29	44814724
2963	2963	1993-05-13	2018-09-14	44814724
2976	2976	1955-06-24	2018-08-10	44814724
2987	2987	1972-06-26	2018-08-27	44814724
3005	3005	1991-01-10	2017-05-25	44814724
2998	2998	1996-10-08	2018-11-20	44814724
2961	2961	1971-09-26	2019-03-09	44814724
2970	2970	1965-04-16	2018-10-05	44814724
2956	2956	2013-07-21	2019-01-21	44814724
2951	2951	1958-11-16	2019-01-13	44814724
3034	3034	2002-07-13	2019-06-29	44814724
3025	3025	1945-11-26	2002-10-21	44814724
3015	3015	2002-06-07	2018-07-20	44814724
3020	3020	1957-01-02	2019-03-13	44814724
3051	3051	1999-06-22	2018-08-21	44814724
3040	3040	1972-02-24	2019-03-16	44814724
3062	3062	1979-10-30	2017-10-17	44814724
3069	3069	1961-08-16	2018-09-26	44814724
3022	3022	1972-05-06	2018-03-10	44814724
3013	3013	1950-08-30	2018-07-11	44814724
3027	3027	1985-12-21	2016-07-23	44814724
3032	3032	1988-06-25	2016-09-03	44814724
3071	3071	2002-02-15	2019-04-05	44814724
3060	3060	1924-03-29	2018-12-15	44814724
3042	3042	2018-10-28	2019-04-07	44814724
3049	3049	1976-04-23	2018-05-04	44814724
3065	3065	1972-05-11	2018-05-31	44814724
3058	3058	1989-10-09	2018-09-24	44814724
3044	3044	1969-01-21	2019-01-22	44814724
3055	3055	1999-01-01	2018-09-08	44814724
3016	3016	1991-07-09	2019-02-05	44814724
3011	3011	1974-07-09	2018-05-29	44814724
3029	3029	1994-06-05	2018-05-07	44814724
3038	3038	2016-11-16	2019-04-24	44814724
3053	3053	1982-01-09	2019-03-30	44814724
3046	3046	1997-10-30	2018-10-25	44814724
3056	3056	1956-12-28	2019-01-18	44814724
3067	3067	1939-12-19	2019-04-22	44814724
3082	3082	1965-08-04	2018-08-22	44814724
3031	3031	2007-06-30	2019-03-30	44814724
3009	3009	2002-08-05	2018-11-05	44814724
3018	3018	2014-08-08	2018-08-03	44814724
3041	3041	1977-03-04	2019-05-11	44814724
3050	3050	1994-03-29	2018-12-21	44814724
3068	3068	2008-11-19	2018-07-11	44814724
3063	3063	2012-04-15	2019-04-07	44814724
3024	3024	2018-05-28	2019-06-22	44814724
3035	3035	1963-12-20	2019-01-18	44814724
3021	3021	2017-01-21	2019-06-29	44814724
3014	3014	1973-06-30	2018-04-28	44814724
3061	3061	1976-04-26	2015-05-18	44814724
3070	3070	1966-09-25	2018-12-28	44814724
3048	3048	1974-05-15	2018-05-30	44814724
3043	3043	1999-10-31	2018-10-07	44814724
3012	3012	1996-08-23	2018-10-26	44814724
3023	3023	1981-10-24	2017-07-08	44814724
3033	3033	2014-03-26	2019-03-31	44814724
3026	3026	1955-01-23	2019-06-08	44814724
3010	3010	1964-01-15	2019-03-20	44814724
3017	3017	1957-08-16	2018-07-20	44814724
3039	3039	2009-03-07	2019-03-16	44814724
3028	3028	1959-04-24	2018-07-20	44814724
3059	3059	1970-04-19	2019-04-07	44814724
3064	3064	1935-10-04	2018-10-19	44814724
3054	3054	2009-05-17	2019-05-26	44814724
3045	3045	2015-04-16	2019-01-03	44814724
3030	3030	1981-08-18	2016-06-28	44814724
3037	3037	1995-12-17	2019-02-05	44814724
3019	3019	1977-05-04	2019-05-15	44814724
3008	3008	1999-04-12	2019-06-01	44814724
3047	3047	1972-07-26	2017-10-04	44814724
3052	3052	1990-07-31	2018-10-09	44814724
3066	3066	2013-10-16	2018-10-10	44814724
3057	3057	1937-01-04	2018-07-02	44814724
3084	3084	1977-11-23	2019-06-14	44814724
3079	3079	1933-04-20	2019-01-24	44814724
3089	3089	2015-03-06	2019-03-29	44814724
3098	3098	1958-09-23	2019-06-24	44814724
3133	3133	1956-02-22	2019-05-08	44814724
3126	3126	1979-11-14	2019-02-13	44814724
3104	3104	2013-03-04	2019-02-18	44814724
3115	3115	1967-01-20	2019-02-01	44814724
3096	3096	1963-12-22	2019-02-07	44814724
3091	3091	1978-01-23	2018-01-29	44814724
3077	3077	1952-05-28	2018-09-13	44814724
3086	3086	1968-09-26	2018-09-27	44814724
3113	3113	1984-11-02	2019-06-07	44814724
3106	3106	1950-07-10	2019-02-11	44814724
3124	3124	1981-11-28	2019-03-02	44814724
3135	3135	1963-06-06	2018-07-05	44814724
3119	3119	1974-06-17	2018-07-02	44814724
3108	3108	1959-12-24	1974-06-06	44814724
3122	3122	1984-03-13	2018-05-29	44814724
3129	3129	1971-05-19	2019-06-12	44814724
3102	3102	1995-07-11	2018-07-08	44814724
3093	3093	1971-06-27	2019-04-07	44814724
3075	3075	2016-04-10	2019-03-17	44814724
3080	3080	1940-12-13	2019-03-25	44814724
3131	3131	2007-06-14	2019-01-07	44814724
3120	3120	1997-05-26	2019-07-01	44814724
3110	3110	2005-02-15	2019-03-19	44814724
3117	3117	1973-08-02	2018-09-19	44814724
3196	3196	1970-04-07	2018-08-01	44814724
3073	3073	2010-05-30	2018-08-26	44814724
3095	3095	1964-10-26	1978-05-08	44814724
3100	3100	1950-12-07	2019-05-02	44814724
3127	3127	2014-01-02	2018-12-13	44814724
3132	3132	1963-07-07	2018-08-05	44814724
3114	3114	1946-09-19	2019-01-24	44814724
3105	3105	1970-01-27	2018-06-07	44814724
3078	3078	1975-07-02	2017-09-27	44814724
3085	3085	2015-07-27	2018-12-31	44814724
3099	3099	2019-04-22	2019-05-27	44814724
3088	3088	1939-04-15	2019-02-23	44814724
3107	3107	1989-02-25	2018-01-27	44814724
3112	3112	1978-02-09	2017-11-10	44814724
3134	3134	1921-08-25	2019-04-25	44814724
3125	3125	1951-06-28	2019-04-15	44814724
3090	3090	1961-01-23	2019-03-11	44814724
3097	3097	2005-12-29	2019-01-10	44814724
3087	3087	1938-06-30	2019-03-07	44814724
3076	3076	1949-06-01	2018-09-19	44814724
3092	3092	1955-07-28	2018-10-11	44814724
3103	3103	1977-06-15	2018-10-07	44814724
3081	3081	1946-01-23	2019-06-05	44814724
3074	3074	1950-12-07	2018-08-02	44814724
3109	3109	1918-06-12	1990-08-01	44814724
3118	3118	1948-12-06	2006-01-02	44814724
3128	3128	1973-07-24	2017-08-08	44814724
3123	3123	1977-07-07	2018-10-25	44814724
3072	3072	1959-07-18	2019-04-12	44814724
3083	3083	1951-04-29	2018-08-05	44814724
3101	3101	1987-12-14	2019-03-18	44814724
3094	3094	2002-11-03	2018-12-16	44814724
3121	3121	1988-11-13	2017-01-22	44814724
3130	3130	1986-12-05	2019-02-08	44814724
3116	3116	1984-04-29	2018-10-24	44814724
3111	3111	1982-08-18	2016-08-17	44814724
3194	3194	1942-06-16	1983-04-05	44814724
3185	3185	1987-07-07	2018-11-20	44814724
3175	3175	1953-11-24	2018-09-04	44814724
3180	3180	1985-07-02	2017-10-03	44814724
3147	3147	1947-02-10	2019-06-17	44814724
3136	3136	1993-04-30	2019-04-05	44814724
3158	3158	1949-08-25	2002-01-17	44814724
3165	3165	1999-02-18	2018-10-06	44814724
3182	3182	1981-11-15	2018-11-01	44814724
3173	3173	1999-03-07	2018-05-27	44814724
3187	3187	1996-12-10	2018-12-25	44814724
3192	3192	1952-07-24	1954-03-11	44814724
3167	3167	1960-06-05	2018-09-09	44814724
3156	3156	2001-05-18	2018-12-21	44814724
3138	3138	2017-07-31	2019-01-07	44814724
3145	3145	1970-08-30	2018-09-23	44814724
3161	3161	1951-05-16	2018-09-05	44814724
3154	3154	2012-09-15	2018-09-01	44814724
3140	3140	1993-07-12	2019-06-26	44814724
3151	3151	2008-02-18	2018-12-10	44814724
3176	3176	1971-12-04	2018-10-07	44814724
3171	3171	1992-06-03	2018-09-05	44814724
3189	3189	1965-06-16	2018-09-26	44814724
3198	3198	1984-06-11	2019-02-11	44814724
3149	3149	1950-11-20	2019-06-03	44814724
3142	3142	1997-05-22	2019-02-07	44814724
3152	3152	1987-04-16	2019-04-11	44814724
3163	3163	1997-07-25	2017-09-13	44814724
3216	3216	1954-06-22	2018-10-05	44814724
3191	3191	1957-09-27	2018-11-16	44814724
3169	3169	1942-01-31	1967-08-26	44814724
3178	3178	1954-03-28	2018-09-16	44814724
3137	3137	1909-04-17	1987-11-21	44814724
3146	3146	2006-09-29	2018-10-19	44814724
3164	3164	1982-04-09	2018-04-06	44814724
3159	3159	1959-06-25	2018-10-18	44814724
3184	3184	1961-03-03	2018-08-24	44814724
3195	3195	1948-11-22	2019-01-07	44814724
3181	3181	1951-09-15	2019-02-14	44814724
3174	3174	1980-12-12	2018-02-16	44814724
3157	3157	1952-07-04	2019-03-08	44814724
3166	3166	2011-01-26	2019-04-30	44814724
3144	3144	1963-05-29	2019-04-07	44814724
3139	3139	2000-07-07	2019-01-18	44814724
3172	3172	1977-01-21	2018-09-28	44814724
3183	3183	1981-02-08	2018-01-07	44814724
3193	3193	2006-02-10	2019-05-17	44814724
3186	3186	2017-05-18	2019-06-12	44814724
3170	3170	1950-12-22	1990-04-27	44814724
3177	3177	1916-07-19	2012-06-06	44814724
3199	3199	1973-01-31	2017-10-18	44814724
3188	3188	1993-11-23	2016-09-20	44814724
3155	3155	1956-11-28	1982-12-08	44814724
3160	3160	1982-02-22	2019-05-13	44814724
3150	3150	1939-04-27	1983-05-19	44814724
3141	3141	1971-02-07	2019-03-03	44814724
3190	3190	2011-07-09	2018-06-30	44814724
3197	3197	2013-10-05	2018-09-15	44814724
3179	3179	1919-11-01	2002-02-23	44814724
3168	3168	1980-01-19	2018-11-10	44814724
3143	3143	1989-11-14	2019-03-12	44814724
3148	3148	1987-06-23	2018-11-12	44814724
3162	3162	2015-04-29	2019-04-03	44814724
3153	3153	2015-03-19	2019-02-25	44814724
3222	3222	1951-01-02	2018-07-03	44814724
3229	3229	1979-06-08	2019-06-28	44814724
3211	3211	1956-11-23	2019-02-01	44814724
3200	3200	1946-08-22	2018-11-08	44814724
3239	3239	2015-04-29	2019-04-03	44814724
3244	3244	1973-04-19	2019-05-09	44814724
3258	3258	1981-06-03	2018-09-05	44814724
3249	3249	1957-07-14	2018-09-16	44814724
3202	3202	1996-05-11	2018-08-18	44814724
3209	3209	2010-05-12	2019-05-15	44814724
3231	3231	1947-10-16	2018-09-13	44814724
3220	3220	1996-04-07	2019-03-17	44814724
3251	3251	2005-06-21	2019-01-25	44814724
3256	3256	2007-11-02	2018-07-13	44814724
3246	3246	1979-10-22	2017-03-06	44814724
3237	3237	1926-08-11	2013-06-26	44814724
3253	3253	1970-05-19	2018-08-19	44814724
3262	3262	1978-06-03	2018-11-27	44814724
3240	3240	1946-01-23	2018-10-31	44814724
3235	3235	2010-12-06	2018-12-03	44814724
3204	3204	2015-11-02	2019-04-08	44814724
3215	3215	1977-10-03	2017-10-09	44814724
3225	3225	2003-04-23	2019-04-09	44814724
3218	3218	1956-10-28	2019-01-06	44814724
3233	3233	1985-06-18	2017-03-07	44814724
3242	3242	1980-05-17	2017-10-28	44814724
3260	3260	1960-04-02	2019-05-25	44814724
3255	3255	2006-06-16	2018-11-30	44814724
3302	3302	2017-05-16	2019-04-23	44814724
3227	3227	1969-09-23	2018-06-12	44814724
3213	3213	2001-07-07	2019-01-26	44814724
3206	3206	1993-01-21	2019-04-18	44814724
3245	3245	2008-10-12	2018-09-23	44814724
3238	3238	1967-02-27	2019-03-18	44814724
3248	3248	1945-07-13	2019-06-07	44814724
3259	3259	1965-10-29	2018-11-16	44814724
3228	3228	2010-03-26	2019-03-29	44814724
3223	3223	1916-07-19	1998-07-15	44814724
3201	3201	1936-08-19	1985-01-02	44814724
3210	3210	2016-09-02	2019-02-08	44814724
3257	3257	2004-07-09	2018-09-03	44814724
3250	3250	1963-01-08	2019-02-12	44814724
3236	3236	1923-11-02	2018-09-28	44814724
3247	3247	2015-08-02	2019-01-06	44814724
3208	3208	1968-01-12	2019-01-18	44814724
3203	3203	1996-10-17	2017-10-26	44814724
3221	3221	1963-06-01	2018-06-30	44814724
3230	3230	1955-08-24	2018-11-07	44814724
3214	3214	1972-02-15	2019-05-28	44814724
3205	3205	2010-09-01	2018-08-15	44814724
3219	3219	1980-01-19	2018-12-22	44814724
3224	3224	1960-01-15	2019-06-07	44814724
3263	3263	1944-10-24	2019-04-09	44814724
3252	3252	1997-07-09	2017-10-25	44814724
3234	3234	1947-10-28	2010-01-26	44814724
3241	3241	1961-03-30	2019-06-10	44814724
3226	3226	1968-10-06	2018-07-29	44814724
3217	3217	1983-07-05	2017-09-05	44814724
3207	3207	1958-12-11	2019-02-07	44814724
3212	3212	1981-07-28	2018-08-10	44814724
3243	3243	1991-12-06	2017-04-05	44814724
3232	3232	1963-09-16	2018-10-15	44814724
3254	3254	1963-12-01	2018-12-30	44814724
3261	3261	1999-07-22	2019-06-21	44814724
3296	3296	1936-09-26	2019-04-10	44814724
3307	3307	1965-10-22	2018-11-09	44814724
3325	3325	1963-07-17	2019-02-02	44814724
3318	3318	1984-03-07	2018-03-21	44814724
3281	3281	2014-08-14	2018-07-19	44814724
3290	3290	1969-04-03	2019-04-04	44814724
3276	3276	2011-02-20	2018-11-11	44814724
3271	3271	1941-04-23	1960-08-31	44814724
3316	3316	2002-04-12	2019-05-31	44814724
3327	3327	1988-01-28	2018-09-27	44814724
3305	3305	2012-10-19	2018-10-05	44814724
3298	3298	1971-08-15	2018-06-28	44814724
3269	3269	2013-05-18	2019-05-04	44814724
3278	3278	1960-04-18	2019-06-10	44814724
3288	3288	1998-10-07	2018-09-05	44814724
3283	3283	1978-07-14	2018-11-11	44814724
3267	3267	2003-09-02	2018-10-09	44814724
3272	3272	1970-06-09	2018-01-23	44814724
3294	3294	1949-10-18	2018-12-27	44814724
3285	3285	1958-11-15	2019-06-22	44814724
3314	3314	1962-09-08	2019-01-26	44814724
3321	3321	1977-01-24	2019-02-04	44814724
3311	3311	1956-03-21	2019-02-27	44814724
3300	3300	1982-08-05	2018-09-19	44814724
3287	3287	1944-07-10	2018-10-01	44814724
3292	3292	2005-02-23	2019-04-10	44814724
3274	3274	1997-06-18	2016-08-17	44814724
3265	3265	1980-05-23	2018-06-29	44814724
3381	3381	1971-12-07	2018-06-19	44814724
3309	3309	1990-05-05	2019-02-02	44814724
3323	3323	2014-07-25	2018-06-29	44814724
3312	3312	1985-02-12	2019-04-30	44814724
3291	3291	2018-08-26	2019-06-22	44814724
3280	3280	1951-09-13	2018-12-27	44814724
3270	3270	1970-03-27	2019-05-10	44814724
3277	3277	1962-12-07	2019-05-31	44814724
3306	3306	1984-05-22	2009-06-30	44814724
3297	3297	2014-06-28	2019-06-08	44814724
3319	3319	1995-05-12	2019-02-24	44814724
3324	3324	1982-12-23	2017-05-03	44814724
3279	3279	1954-09-28	2018-12-18	44814724
3268	3268	1969-07-11	2018-05-21	44814724
3282	3282	1972-03-24	1975-03-07	44814724
3289	3289	1955-12-24	2019-06-22	44814724
3326	3326	1995-09-10	2018-01-14	44814724
3317	3317	2008-06-12	2019-05-24	44814724
3299	3299	2015-06-18	2019-05-23	44814724
3304	3304	1963-01-10	2018-07-05	44814724
3320	3320	1963-08-25	2018-07-29	44814724
3315	3315	1957-04-28	2018-07-01	44814724
3301	3301	1938-04-05	2018-09-25	44814724
3310	3310	2003-06-04	2018-07-11	44814724
3273	3273	1962-01-31	1993-12-22	44814724
3266	3266	1995-08-09	2018-01-12	44814724
3284	3284	2011-09-08	2019-05-23	44814724
3295	3295	1942-05-11	2019-06-03	44814724
3308	3308	1947-02-10	1996-11-25	44814724
3303	3303	2003-04-25	2019-06-21	44814724
3313	3313	1955-01-21	2018-11-26	44814724
3322	3322	1987-07-18	2019-03-30	44814724
3293	3293	1912-03-16	2006-12-02	44814724
3286	3286	1996-03-23	2018-05-26	44814724
3264	3264	2018-01-03	2019-06-12	44814724
3275	3275	1960-04-09	2019-03-16	44814724
3379	3379	1985-10-13	2019-05-19	44814724
3384	3384	2007-02-28	2019-03-20	44814724
3374	3374	2005-07-26	2018-08-21	44814724
3365	3365	1964-07-17	2018-08-10	44814724
3330	3330	1973-10-07	2017-10-22	44814724
3337	3337	1969-06-09	2019-06-17	44814724
3359	3359	1989-06-10	2018-10-13	44814724
3348	3348	2017-06-23	2019-05-31	44814724
3367	3367	1963-03-05	2018-11-06	44814724
3372	3372	1986-11-25	2018-05-29	44814724
3386	3386	1968-12-01	2019-02-04	44814724
3377	3377	1998-10-24	2018-05-05	44814724
3350	3350	1985-10-26	2018-02-02	44814724
3357	3357	1979-06-22	2019-03-08	44814724
3339	3339	1959-10-13	2018-10-30	44814724
3328	3328	2018-02-19	2019-04-29	44814724
3344	3344	1990-03-14	2019-02-13	44814724
3355	3355	1962-10-05	2018-11-09	44814724
3341	3341	2019-04-15	2019-05-20	44814724
3334	3334	1945-10-25	2019-04-27	44814724
3361	3361	2009-03-08	2018-12-16	44814724
3370	3370	1972-09-24	2019-04-20	44814724
3388	3388	1990-10-05	2019-03-15	44814724
3383	3383	1986-04-17	2018-08-31	44814724
3332	3332	1960-12-06	2019-01-22	44814724
3343	3343	1976-06-06	2018-09-29	44814724
3353	3353	1924-12-27	2019-04-06	44814724
3346	3346	2003-03-22	2018-11-03	44814724
3395	3395	1989-01-13	2018-01-19	44814724
3390	3390	1991-09-12	2017-01-05	44814724
3368	3368	2016-04-06	2019-03-13	44814724
3363	3363	1951-03-02	2019-06-14	44814724
3336	3336	1989-07-30	2019-01-08	44814724
3331	3331	1994-12-10	2018-04-29	44814724
3349	3349	2012-02-23	2019-03-18	44814724
3358	3358	1997-03-16	2018-02-25	44814724
3385	3385	2005-10-08	2019-06-10	44814724
3378	3378	1957-07-20	2019-02-09	44814724
3364	3364	1976-06-24	2018-10-11	44814724
3375	3375	1954-03-05	2018-12-21	44814724
3356	3356	2011-02-07	2019-06-29	44814724
3351	3351	2014-08-04	2018-07-09	44814724
3329	3329	1996-12-22	2019-01-06	44814724
3338	3338	1981-12-25	2016-09-30	44814724
3373	3373	1998-02-25	2019-01-23	44814724
3366	3366	1988-02-14	2019-06-15	44814724
3376	3376	1953-03-27	2019-06-28	44814724
3387	3387	2014-05-26	2019-05-06	44814724
3371	3371	1975-08-15	2018-09-14	44814724
3360	3360	1998-09-12	2017-09-16	44814724
3382	3382	1962-02-15	2018-12-20	44814724
3389	3389	1958-09-01	2018-10-29	44814724
3354	3354	2018-10-20	2019-06-29	44814724
3345	3345	2001-07-13	2019-06-28	44814724
3335	3335	1972-03-26	2018-04-15	44814724
3340	3340	2018-12-22	2019-06-01	44814724
3391	3391	1982-06-22	2018-08-14	44814724
3380	3380	1988-04-12	2016-07-12	44814724
3362	3362	1957-02-20	2019-01-30	44814724
3369	3369	2007-10-18	2019-05-02	44814724
3342	3342	1909-07-07	2019-06-19	44814724
3333	3333	2017-11-04	2019-04-13	44814724
3347	3347	1954-05-16	2018-11-25	44814724
3352	3352	1964-10-23	2018-11-16	44814724
3397	3397	1944-06-18	2019-03-10	44814724
3406	3406	1982-12-29	2016-08-10	44814724
3416	3416	2014-10-17	2018-09-21	44814724
3411	3411	1984-06-15	2019-05-10	44814724
3444	3444	1938-10-31	2019-03-18	44814724
3455	3455	1969-05-26	2019-05-06	44814724
3433	3433	1988-07-25	2016-09-12	44814724
3426	3426	2017-10-20	2019-03-29	44814724
3409	3409	1955-06-16	2018-09-28	44814724
3418	3418	1943-10-17	2019-03-03	44814724
3404	3404	1990-04-10	2019-04-02	44814724
3399	3399	1983-02-08	2019-01-30	44814724
3424	3424	1980-10-13	2018-06-04	44814724
3435	3435	1975-04-26	2019-05-23	44814724
3453	3453	1994-06-30	2018-05-05	44814724
3446	3446	1943-12-13	2018-12-17	44814724
3430	3430	1961-07-15	2019-05-25	44814724
3437	3437	1912-04-28	1988-11-13	44814724
3451	3451	2016-05-02	2019-04-08	44814724
3440	3440	1942-03-10	2018-09-11	44814724
3415	3415	1965-08-07	2018-08-25	44814724
3420	3420	1964-09-29	2018-10-23	44814724
3402	3402	1992-03-11	2017-10-25	44814724
3393	3393	1989-02-14	2017-07-07	44814724
3442	3442	1960-06-12	2018-07-29	44814724
3449	3449	1986-12-09	2018-10-30	44814724
3439	3439	1951-08-30	2018-12-27	44814724
3428	3428	1966-05-25	2019-03-20	44814724
3503	3503	1984-03-21	2017-12-13	44814724
3400	3400	1993-10-13	2019-01-23	44814724
3422	3422	1966-12-19	2018-12-31	44814724
3413	3413	1966-04-27	2019-05-15	44814724
3454	3454	1983-03-07	2019-04-16	44814724
3445	3445	1985-09-17	2018-10-16	44814724
3427	3427	1966-04-07	2019-04-25	44814724
3432	3432	1951-11-10	2019-02-16	44814724
3407	3407	1963-01-26	2019-05-04	44814724
3396	3396	1992-11-29	2018-05-06	44814724
3410	3410	1964-04-15	2019-03-27	44814724
3417	3417	1909-04-17	2019-06-01	44814724
3434	3434	1948-04-22	2018-07-26	44814724
3425	3425	2007-09-20	2018-10-04	44814724
3447	3447	2004-09-12	2019-04-14	44814724
3452	3452	2009-04-05	2019-03-31	44814724
3419	3419	2005-05-14	2019-06-15	44814724
3408	3408	1969-07-07	2017-07-31	44814724
3398	3398	1982-04-13	2019-06-04	44814724
3405	3405	1996-08-30	2019-06-16	44814724
3421	3421	2005-05-08	2019-06-09	44814724
3414	3414	1967-03-30	2019-04-11	44814724
3392	3392	1967-01-01	2018-07-15	44814724
3403	3403	1969-04-01	2019-04-02	44814724
3436	3436	1962-11-12	2019-06-17	44814724
3431	3431	1962-10-10	2001-10-24	44814724
3441	3441	1994-10-28	2017-01-20	44814724
3450	3450	1985-04-01	2017-03-06	44814724
3401	3401	1958-09-21	2018-11-18	44814724
3394	3394	1965-10-03	2019-01-06	44814724
3412	3412	2003-12-29	2019-03-25	44814724
3423	3423	1974-03-21	2018-04-05	44814724
3448	3448	1986-09-07	2017-11-19	44814724
3443	3443	1977-03-09	2019-04-24	44814724
3429	3429	2017-06-28	2019-06-05	44814724
3438	3438	1909-04-17	1992-01-11	44814724
3497	3497	2010-11-23	2019-01-27	44814724
3490	3490	1945-09-14	2018-08-03	44814724
3508	3508	1956-11-28	2019-05-02	44814724
3519	3519	2009-08-12	2018-08-15	44814724
3480	3480	2015-07-27	2018-12-31	44814724
3475	3475	1981-01-13	2019-02-26	44814724
3461	3461	1949-01-30	1955-07-10	44814724
3470	3470	1954-03-01	2019-06-03	44814724
3517	3517	1988-08-16	2018-12-19	44814724
3510	3510	1935-03-08	2019-05-15	44814724
3488	3488	1954-02-20	2019-05-11	44814724
3499	3499	2012-09-04	2018-10-16	44814724
3468	3468	1983-07-11	2019-06-03	44814724
3463	3463	1990-08-14	2019-05-14	44814724
3473	3473	1994-02-16	2018-12-01	44814724
3482	3482	2000-11-14	2019-04-09	44814724
3466	3466	2016-10-01	2019-05-19	44814724
3457	3457	1916-09-01	2018-10-26	44814724
3479	3479	2005-04-14	2019-05-16	44814724
3484	3484	2006-03-06	2019-01-28	44814724
3515	3515	1985-02-19	2017-10-09	44814724
3504	3504	1922-02-17	2008-11-28	44814724
3494	3494	1959-08-06	2018-11-29	44814724
3501	3501	1947-12-05	2019-04-05	44814724
3486	3486	1959-12-26	2019-03-30	44814724
3477	3477	1961-03-29	2018-11-24	44814724
3459	3459	1993-07-12	2019-02-11	44814724
3464	3464	1980-05-14	2017-12-27	44814724
3545	3545	1971-03-03	2019-03-27	44814724
3492	3492	2000-08-11	2019-02-15	44814724
3506	3506	2003-10-06	2018-10-15	44814724
3513	3513	1972-03-19	2019-02-12	44814724
3474	3474	2011-07-29	2018-07-20	44814724
3481	3481	1977-04-30	2015-04-11	44814724
3471	3471	2007-02-07	2019-06-02	44814724
3460	3460	1989-08-30	2017-11-08	44814724
3491	3491	2003-01-11	2019-02-23	44814724
3496	3496	1979-05-21	2019-05-27	44814724
3518	3518	1958-03-31	2018-09-03	44814724
3509	3509	1942-01-16	2019-06-21	44814724
3462	3462	1960-09-23	2019-06-16	44814724
3469	3469	1952-10-01	2018-10-17	44814724
3483	3483	1953-01-24	2018-09-22	44814724
3472	3472	1992-12-25	2018-07-06	44814724
3511	3511	1993-09-09	2004-01-29	44814724
3516	3516	1945-07-26	2018-01-11	44814724
3498	3498	1990-09-18	2017-12-05	44814724
3489	3489	1972-10-28	2018-11-17	44814724
3505	3505	1937-02-05	2019-02-08	44814724
3514	3514	1974-08-20	2018-09-04	44814724
3500	3500	2002-10-22	2019-05-06	44814724
3495	3495	1965-06-16	2018-11-22	44814724
3456	3456	1942-12-10	1991-12-19	44814724
3467	3467	2002-07-02	2018-08-14	44814724
3485	3485	2001-08-31	2019-03-18	44814724
3478	3478	1999-04-19	2018-08-06	44814724
3493	3493	2014-11-17	2018-10-22	44814724
3502	3502	1987-12-01	2017-10-08	44814724
3512	3512	1990-09-05	2019-04-20	44814724
3507	3507	1989-03-07	2018-06-17	44814724
3476	3476	1988-09-17	2002-04-06	44814724
3487	3487	2001-06-21	2018-10-25	44814724
3465	3465	2005-12-12	2018-10-01	44814724
3458	3458	1979-10-19	2017-04-07	44814724
3551	3551	2013-05-26	2019-05-12	44814724
3540	3540	1974-01-28	2019-06-13	44814724
3522	3522	1981-03-02	2018-06-11	44814724
3529	3529	1944-04-26	2018-10-24	44814724
3566	3566	1951-07-23	2018-09-10	44814724
3557	3557	2011-06-01	2019-05-29	44814724
3571	3571	1971-08-25	2017-08-02	44814724
3576	3576	1966-01-16	2018-12-30	44814724
3531	3531	1967-03-29	2019-04-10	44814724
3520	3520	1993-12-25	2018-07-07	44814724
3542	3542	1937-04-03	2018-09-29	44814724
3549	3549	1957-06-04	2018-08-07	44814724
3578	3578	1972-08-02	2019-06-05	44814724
3569	3569	1958-11-04	2018-12-11	44814724
3559	3559	1949-08-26	2018-10-26	44814724
3564	3564	1989-06-20	2019-02-19	44814724
3580	3580	1972-03-24	2018-03-30	44814724
3575	3575	2017-04-28	2019-04-05	44814724
3553	3553	1930-11-09	2012-10-07	44814724
3562	3562	1968-08-22	2018-08-23	44814724
3533	3533	1961-11-30	2019-01-10	44814724
3526	3526	1949-12-27	2019-02-05	44814724
3536	3536	1963-11-07	2019-05-23	44814724
3547	3547	1970-07-13	2018-08-06	44814724
3560	3560	1960-05-05	2018-06-28	44814724
3555	3555	1993-09-09	2019-05-09	44814724
3573	3573	1923-04-28	2018-08-04	44814724
3582	3582	1956-05-27	2019-03-03	44814724
3593	3593	1952-03-19	2019-06-26	44814724
3538	3538	1986-11-06	2018-05-20	44814724
3524	3524	2000-07-30	2019-03-17	44814724
3535	3535	1981-03-13	2019-06-13	44814724
3556	3556	1978-07-17	2018-07-23	44814724
3567	3567	1967-06-30	2018-07-06	44814724
3577	3577	1961-02-27	2019-04-08	44814724
3570	3570	1948-12-06	2018-07-02	44814724
3541	3541	1967-08-07	2018-10-08	44814724
3550	3550	1984-07-21	2019-05-20	44814724
3528	3528	1958-11-03	2018-12-24	44814724
3523	3523	1993-04-04	2018-06-10	44814724
3568	3568	1969-05-29	2019-05-30	44814724
3579	3579	1964-10-31	2018-11-24	44814724
3565	3565	1944-03-04	2019-03-16	44814724
3558	3558	1959-03-28	2019-05-26	44814724
3521	3521	1985-05-26	2017-09-17	44814724
3530	3530	1959-04-25	2003-01-11	44814724
3548	3548	2009-07-30	2019-04-22	44814724
3543	3543	1958-07-15	2019-02-26	44814724
3527	3527	1961-07-13	2018-08-23	44814724
3532	3532	1970-07-12	2018-08-05	44814724
3546	3546	1997-07-05	2019-05-21	44814724
3537	3537	1961-06-25	2019-05-19	44814724
3574	3574	2002-06-29	2019-04-13	44814724
3581	3581	1980-10-25	2017-12-02	44814724
3563	3563	2007-08-06	2018-10-22	44814724
3552	3552	1956-11-15	2019-01-31	44814724
3539	3539	1980-12-12	2018-09-14	44814724
3544	3544	2006-02-03	2018-07-13	44814724
3534	3534	1991-04-12	2016-11-04	44814724
3525	3525	1956-01-06	1978-01-13	44814724
3554	3554	1992-01-01	2019-03-02	44814724
3561	3561	1910-01-31	2018-11-05	44814724
3583	3583	1968-11-05	2019-04-30	44814724
3572	3572	1956-03-21	2014-04-16	44814724
3599	3599	1966-05-06	2019-05-24	44814724
3588	3588	1997-10-29	2018-01-10	44814724
3602	3602	1992-09-14	2018-08-29	44814724
3609	3609	1974-11-29	2018-12-14	44814724
3646	3646	1988-01-31	2019-05-09	44814724
3637	3637	1959-07-21	2019-01-21	44814724
3619	3619	1995-04-17	2018-02-10	44814724
3624	3624	1946-07-04	2018-07-05	44814724
3611	3611	2003-10-15	2019-01-09	44814724
3600	3600	1991-06-15	2017-05-05	44814724
3590	3590	2008-12-10	2018-12-19	44814724
3597	3597	2000-10-27	2019-03-14	44814724
3626	3626	1974-03-23	2018-05-05	44814724
3617	3617	2012-05-22	2019-05-14	44814724
3639	3639	1922-02-11	2010-04-10	44814724
3644	3644	1947-01-22	1982-03-03	44814724
3628	3628	1914-08-29	2006-08-26	44814724
3623	3623	1949-06-20	2019-04-08	44814724
3633	3633	1972-05-28	2018-03-11	44814724
3642	3642	1994-02-08	2019-03-05	44814724
3613	3613	1976-01-25	2018-02-04	44814724
3606	3606	1982-07-21	2018-02-09	44814724
3584	3584	2011-10-24	2018-10-15	44814724
3595	3595	1949-04-14	2019-02-28	44814724
3640	3640	1989-07-01	2018-04-21	44814724
3635	3635	2006-12-21	2018-09-13	44814724
3621	3621	1922-02-11	1996-11-23	44814724
3630	3630	1955-04-13	2018-10-10	44814724
3711	3711	2009-05-05	2019-05-14	44814724
3586	3586	2018-08-14	2019-04-23	44814724
3604	3604	1984-05-04	2017-07-07	44814724
3615	3615	1949-08-31	2019-02-27	44814724
3636	3636	1972-07-14	2018-08-03	44814724
3647	3647	1936-10-22	2018-07-05	44814724
3625	3625	1953-07-14	2018-10-09	44814724
3618	3618	1910-01-22	1994-08-13	44814724
3589	3589	1980-12-30	2019-02-27	44814724
3598	3598	1944-03-26	2019-06-23	44814724
3608	3608	2016-02-05	2019-05-25	44814724
3603	3603	1966-02-06	2019-02-24	44814724
3616	3616	1958-02-25	2019-06-01	44814724
3627	3627	2002-03-16	2019-05-04	44814724
3645	3645	2008-01-17	2018-11-06	44814724
3638	3638	1963-05-02	2019-06-06	44814724
3601	3601	1959-06-19	2019-06-14	44814724
3610	3610	1944-05-06	2019-03-09	44814724
3596	3596	2017-07-16	2019-06-23	44814724
3591	3591	1999-03-14	2018-05-13	44814724
3607	3607	1993-07-08	2017-11-23	44814724
3612	3612	1959-12-21	2018-11-26	44814724
3594	3594	1999-06-29	2018-10-30	44814724
3585	3585	2016-11-03	2019-06-22	44814724
3622	3622	1922-05-25	2019-04-04	44814724
3629	3629	1955-11-21	2019-04-29	44814724
3643	3643	2013-08-17	2019-04-20	44814724
3632	3632	2017-03-29	2019-03-19	44814724
3587	3587	2018-01-06	2019-06-15	44814724
3592	3592	1965-01-27	2018-07-14	44814724
3614	3614	1949-06-26	2011-04-03	44814724
3605	3605	1988-05-11	2018-08-15	44814724
3634	3634	1970-02-23	2018-05-07	44814724
3641	3641	1912-11-02	2019-04-20	44814724
3631	3631	1974-11-28	2018-12-13	44814724
3620	3620	1977-04-17	2019-05-02	44814724
3705	3705	2008-04-10	2019-01-31	44814724
3698	3698	1951-03-06	2018-09-18	44814724
3684	3684	1986-02-21	2016-07-15	44814724
3695	3695	1980-02-04	2017-12-18	44814724
3656	3656	1970-05-19	1998-01-27	44814724
3651	3651	1959-08-27	2018-08-16	44814724
3669	3669	1979-08-28	2018-05-01	44814724
3678	3678	1976-11-22	2018-06-15	44814724
3693	3693	1998-08-22	2019-06-15	44814724
3686	3686	1967-11-20	2019-03-18	44814724
3696	3696	1999-05-04	2018-10-02	44814724
3707	3707	1969-07-01	2018-10-02	44814724
3676	3676	1970-11-12	2018-12-06	44814724
3671	3671	1995-01-07	2019-06-22	44814724
3649	3649	1998-06-23	2019-03-01	44814724
3658	3658	1960-12-04	2019-01-20	44814724
3674	3674	1952-03-19	1963-01-09	44814724
3665	3665	2007-04-21	2019-05-11	44814724
3655	3655	1935-05-02	2010-12-23	44814724
3660	3660	1972-07-22	2018-07-28	44814724
3691	3691	1954-08-13	2018-12-07	44814724
3680	3680	1979-04-03	2018-12-25	44814724
3702	3702	1992-03-14	2018-04-21	44814724
3709	3709	1989-02-06	2017-08-14	44814724
3662	3662	1985-08-29	2018-04-29	44814724
3653	3653	2000-01-03	2019-04-29	44814724
3667	3667	1967-07-12	2019-01-02	44814724
3672	3672	1963-03-18	2019-04-22	44814724
3731	3731	1973-12-23	2018-01-07	44814724
3700	3700	1966-09-01	2018-09-13	44814724
3682	3682	1998-06-18	2019-06-13	44814724
3689	3689	1950-01-30	2018-10-22	44814724
3650	3650	1926-07-30	2019-03-29	44814724
3657	3657	1983-05-03	2017-06-20	44814724
3679	3679	1979-01-23	2019-01-29	44814724
3668	3668	1975-08-31	2018-01-16	44814724
3699	3699	1971-07-16	2018-02-23	44814724
3704	3704	1987-12-18	2019-03-01	44814724
3694	3694	1957-04-10	2019-02-06	44814724
3685	3685	1983-12-10	2018-11-24	44814724
3670	3670	1991-08-26	2017-03-20	44814724
3677	3677	2015-05-03	2019-04-23	44814724
3659	3659	1991-07-27	2016-10-01	44814724
3648	3648	1998-09-22	2017-11-28	44814724
3687	3687	1999-01-29	2018-08-03	44814724
3692	3692	1982-12-17	2019-06-14	44814724
3706	3706	2011-07-11	2019-06-03	44814724
3697	3697	1951-03-24	2018-07-01	44814724
3681	3681	2006-10-04	2018-10-24	44814724
3690	3690	1996-05-29	2018-09-26	44814724
3708	3708	1977-05-14	2019-05-25	44814724
3703	3703	1968-11-23	2018-11-24	44814724
3664	3664	2002-07-02	2013-11-19	44814724
3675	3675	1967-04-17	2019-03-18	44814724
3661	3661	1978-02-12	2018-08-26	44814724
3654	3654	1971-07-03	2017-07-22	44814724
3701	3701	1952-05-05	2019-04-01	44814724
3710	3710	1977-04-30	2019-05-11	44814724
3688	3688	2007-11-06	2019-01-01	44814724
3683	3683	1991-02-16	2019-05-18	44814724
3652	3652	1973-09-09	2019-03-24	44814724
3663	3663	2000-05-18	2019-01-03	44814724
3673	3673	1992-07-16	2018-05-13	44814724
3666	3666	1959-12-31	2019-02-21	44814724
3733	3733	1975-11-11	2017-11-21	44814724
3742	3742	1970-08-14	2019-05-10	44814724
3720	3720	1954-04-07	2018-11-28	44814724
3715	3715	2009-12-14	2018-09-17	44814724
3748	3748	1979-03-13	2017-08-29	44814724
3759	3759	1964-08-09	2018-08-12	44814724
3769	3769	1949-06-26	2019-03-31	44814724
3762	3762	1998-10-22	2019-01-05	44814724
3713	3713	1947-01-28	1961-01-10	44814724
3722	3722	2004-10-04	2019-02-01	44814724
3740	3740	1983-05-19	2019-01-27	44814724
3735	3735	2005-03-30	2019-06-19	44814724
3760	3760	1984-01-08	2019-03-01	44814724
3771	3771	1964-01-28	2019-02-26	44814724
3757	3757	1945-02-21	2018-10-18	44814724
3750	3750	1960-01-23	2019-02-02	44814724
3766	3766	2009-01-01	2019-02-08	44814724
3773	3773	1958-05-02	2019-01-27	44814724
3755	3755	1977-02-05	2019-02-16	44814724
3744	3744	1969-12-29	2019-01-18	44814724
3719	3719	1963-01-08	2019-02-12	44814724
3724	3724	2010-03-27	2019-05-12	44814724
3738	3738	2010-03-09	2019-03-12	44814724
3729	3729	1983-12-17	2019-01-12	44814724
3746	3746	1943-12-09	2018-10-26	44814724
3753	3753	2009-09-05	2018-09-08	44814724
3775	3775	1991-12-18	2018-10-06	44814724
3764	3764	1981-02-23	2016-08-15	44814724
3813	3813	1971-10-09	2018-10-27	44814724
3736	3736	1950-12-06	2018-10-31	44814724
3726	3726	1989-07-28	2017-10-06	44814724
3717	3717	1976-05-08	2018-05-19	44814724
3758	3758	1986-06-06	2017-07-07	44814724
3749	3749	2000-01-19	2019-03-20	44814724
3763	3763	2002-06-15	2018-12-08	44814724
3768	3768	1990-05-04	2018-11-23	44814724
3743	3743	1977-08-14	2018-10-07	44814724
3732	3732	1955-07-17	2016-09-25	44814724
3714	3714	1922-08-16	2019-06-06	44814724
3721	3721	1963-11-15	2019-06-14	44814724
3770	3770	2019-06-29	2019-06-29	44814724
3761	3761	1956-04-21	2018-06-30	44814724
3751	3751	2012-11-13	2018-10-30	44814724
3756	3756	1940-12-21	2018-07-21	44814724
3723	3723	1990-08-06	2018-12-13	44814724
3712	3712	2018-04-10	2019-06-18	44814724
3734	3734	1948-07-18	2019-05-21	44814724
3741	3741	2014-04-05	2019-03-02	44814724
3725	3725	1968-03-07	2019-03-14	44814724
3718	3718	1965-10-25	2018-12-20	44814724
3728	3728	1972-01-16	2018-05-27	44814724
3739	3739	1967-08-15	2019-03-12	44814724
3772	3772	1969-02-15	2018-07-14	44814724
3767	3767	1985-02-16	2019-06-29	44814724
3745	3745	1930-03-12	2018-10-17	44814724
3754	3754	1959-01-07	2019-05-16	44814724
3737	3737	2009-01-20	2019-01-29	44814724
3730	3730	1954-04-01	2019-04-18	44814724
3716	3716	1994-06-23	2018-07-28	44814724
3727	3727	1988-03-25	2019-06-07	44814724
3752	3752	1957-12-13	2019-02-15	44814724
3747	3747	2014-07-26	2019-06-29	44814724
3765	3765	1987-02-04	2019-01-16	44814724
3774	3774	1991-06-19	2017-05-24	44814724
3811	3811	1920-07-30	2017-01-06	44814724
3816	3816	2011-04-23	2019-02-16	44814724
3838	3838	2006-07-01	2018-07-21	44814724
3829	3829	2019-06-21	2019-06-21	44814724
3794	3794	2017-10-08	2019-03-17	44814724
3801	3801	2008-01-29	2019-04-23	44814724
3791	3791	1914-08-29	2018-08-04	44814724
3780	3780	2014-05-01	2019-04-11	44814724
3831	3831	1954-05-30	2019-05-05	44814724
3836	3836	1977-03-04	2019-02-25	44814724
3818	3818	1992-02-17	2019-02-08	44814724
3809	3809	2015-03-12	2019-02-14	44814724
3782	3782	1996-03-28	2019-03-07	44814724
3789	3789	1944-05-18	2018-08-30	44814724
3803	3803	1960-04-13	2018-09-19	44814724
3792	3792	2015-04-27	2019-04-01	44814724
3776	3776	1973-06-02	2019-06-22	44814724
3787	3787	1961-11-11	2016-09-03	44814724
3805	3805	1993-04-05	2017-05-01	44814724
3798	3798	1998-08-29	2017-09-30	44814724
3825	3825	1954-06-11	2018-08-31	44814724
3834	3834	1955-07-17	2019-06-30	44814724
3820	3820	1964-11-20	2018-12-14	44814724
3815	3815	1987-07-30	2018-10-11	44814724
3796	3796	1967-11-14	2019-03-19	44814724
3807	3807	1946-09-21	2019-01-19	44814724
3785	3785	2000-12-13	2019-05-20	44814724
3778	3778	1964-10-04	2018-10-28	44814724
3894	3894	1994-09-09	2017-05-05	44814724
3822	3822	1944-09-25	2019-05-20	44814724
3832	3832	1984-01-12	2019-06-07	44814724
3827	3827	1956-11-23	2019-02-01	44814724
3800	3800	2015-09-07	2019-02-11	44814724
3795	3795	1973-02-13	2018-10-30	44814724
3781	3781	1994-06-03	2019-03-26	44814724
3790	3790	1963-07-01	2019-07-01	44814724
3817	3817	1964-08-21	2019-02-18	44814724
3810	3810	2003-04-04	2019-05-17	44814724
3828	3828	1992-07-30	2018-07-25	44814724
3839	3839	1950-10-23	2018-12-03	44814724
3788	3788	1964-08-11	2018-09-04	44814724
3783	3783	1940-04-05	2019-06-21	44814724
3793	3793	1939-05-02	2018-09-18	44814724
3802	3802	1983-11-08	2018-11-13	44814724
3837	3837	1984-11-05	2017-07-10	44814724
3830	3830	1981-08-17	2016-07-04	44814724
3808	3808	2014-09-27	2018-10-03	44814724
3819	3819	2004-02-02	2019-01-21	44814724
3835	3835	1965-09-18	2018-10-06	44814724
3824	3824	1988-01-06	2019-02-20	44814724
3814	3814	1974-12-02	2018-09-24	44814724
3821	3821	2000-01-02	2019-04-09	44814724
3786	3786	1958-12-10	2018-10-24	44814724
3777	3777	1984-04-26	2019-04-25	44814724
3799	3799	1971-11-23	2018-08-07	44814724
3804	3804	1959-12-03	2018-08-23	44814724
3823	3823	1954-10-13	2016-11-23	44814724
3812	3812	2013-12-01	2018-11-04	44814724
3826	3826	2004-09-18	2018-09-29	44814724
3833	3833	1965-10-27	2019-04-24	44814724
3806	3806	2014-06-05	2019-05-16	44814724
3797	3797	2005-11-02	2018-09-26	44814724
3779	3779	1970-04-04	2018-04-28	44814724
3784	3784	1930-07-08	1993-08-31	44814724
3888	3888	2003-05-30	2019-05-16	44814724
3899	3899	1979-12-29	2018-12-29	44814724
3885	3885	1962-11-16	2018-10-12	44814724
3878	3878	1979-01-30	2019-02-05	44814724
3841	3841	1971-09-30	2018-09-26	44814724
3850	3850	1995-08-31	2018-03-08	44814724
3868	3868	1991-11-13	2018-02-07	44814724
3863	3863	2015-06-16	2019-05-21	44814724
3876	3876	1967-05-22	2019-06-03	44814724
3887	3887	1956-06-25	2019-06-17	44814724
3897	3897	2017-08-29	2019-02-05	44814724
3890	3890	1952-07-22	2019-01-15	44814724
3861	3861	2004-04-10	2018-09-29	44814724
3870	3870	1995-06-04	2018-07-15	44814724
3848	3848	2002-08-23	2019-05-17	44814724
3843	3843	1968-12-08	2018-12-09	44814724
3859	3859	1922-09-16	2019-05-04	44814724
3864	3864	1965-04-10	2019-05-04	44814724
3854	3854	1979-10-22	2018-06-25	44814724
3845	3845	1981-06-27	2017-10-21	44814724
3874	3874	1981-12-23	2019-04-28	44814724
3881	3881	1955-08-26	2019-05-25	44814724
3903	3903	1999-04-06	2019-01-27	44814724
3892	3892	1962-06-30	2019-02-02	44814724
3847	3847	2007-03-17	2019-04-06	44814724
3852	3852	1951-10-08	2019-06-18	44814724
3866	3866	1949-10-11	2019-02-05	44814724
3857	3857	1944-01-05	2018-08-01	44814724
3904	3904	1979-02-22	2019-02-28	44814724
3901	3901	1936-03-18	2018-08-01	44814724
3883	3883	2001-08-27	2018-11-05	44814724
3872	3872	1979-11-26	2018-05-31	44814724
3851	3851	1911-05-01	2000-09-25	44814724
3840	3840	2005-04-14	2019-05-16	44814724
3862	3862	1956-02-01	2019-04-17	44814724
3869	3869	1909-04-17	1994-10-29	44814724
3898	3898	1996-04-04	2018-05-29	44814724
3889	3889	1937-09-12	2019-04-07	44814724
3879	3879	1939-12-14	2019-05-30	44814724
3884	3884	1972-03-27	2018-02-19	44814724
3871	3871	1962-09-12	2018-10-17	44814724
3860	3860	1972-07-09	2018-11-17	44814724
3842	3842	2018-10-15	2019-06-24	44814724
3849	3849	1963-11-21	2019-01-17	44814724
3886	3886	1994-11-14	2018-03-02	44814724
3877	3877	2005-02-22	2019-03-26	44814724
3891	3891	1982-11-24	2018-12-05	44814724
3896	3896	1977-10-07	2017-12-01	44814724
3880	3880	1993-11-01	2016-08-22	44814724
3875	3875	1957-11-23	2019-01-05	44814724
3893	3893	1971-10-15	2018-07-07	44814724
3902	3902	2013-09-03	2018-08-14	44814724
3865	3865	1956-06-28	2018-10-11	44814724
3858	3858	2004-01-04	2019-06-09	44814724
3844	3844	1952-08-29	2018-11-30	44814724
3855	3855	2009-12-24	2018-12-27	44814724
3900	3900	1967-07-04	2004-09-28	44814724
3895	3895	1923-06-08	2019-03-13	44814724
3873	3873	2015-02-22	2019-01-27	44814724
3882	3882	2009-01-12	2019-02-04	44814724
3853	3853	1989-01-06	2017-11-17	44814724
3846	3846	1985-01-11	2019-05-24	44814724
3856	3856	1973-10-03	2017-10-18	44814724
3867	3867	2018-09-13	2019-05-23	44814724
3910	3910	1991-02-10	2019-04-21	44814724
3917	3917	1967-09-08	2018-09-14	44814724
3931	3931	1995-03-12	2017-07-16	44814724
3920	3920	1972-08-27	2018-09-16	44814724
3959	3959	1993-10-20	2018-11-10	44814724
3964	3964	2019-05-12	2019-06-16	44814724
3946	3946	1960-03-23	2018-10-24	44814724
3937	3937	1992-07-20	2017-09-25	44814724
3922	3922	1994-01-25	2018-02-17	44814724
3929	3929	1952-05-05	2006-01-23	44814724
3919	3919	1986-06-23	2018-05-21	44814724
3908	3908	2002-10-31	2018-07-19	44814724
3939	3939	1974-01-21	2019-04-22	44814724
3944	3944	1988-07-05	2017-05-23	44814724
3966	3966	1966-12-10	2019-01-05	44814724
3957	3957	1955-09-22	2019-04-01	44814724
3941	3941	1963-01-22	2019-02-26	44814724
3950	3950	1970-10-01	2018-10-25	44814724
3960	3960	1958-02-15	2019-04-20	44814724
3955	3955	1956-02-04	2019-05-18	44814724
3924	3924	1980-07-19	2018-07-14	44814724
3935	3935	1945-01-03	1990-10-31	44814724
3913	3913	1962-10-18	2018-08-30	44814724
3906	3906	1942-10-21	2018-07-04	44814724
3953	3953	1986-02-28	2019-05-31	44814724
3962	3962	1951-05-18	2018-11-23	44814724
3948	3948	1994-10-11	2018-12-17	44814724
3943	3943	1952-02-14	2018-10-21	44814724
4012	4012	1981-07-30	2019-01-03	44814724
3915	3915	2017-06-15	2019-05-23	44814724
3933	3933	2019-01-05	2019-06-15	44814724
3926	3926	1947-09-29	2018-07-30	44814724
3965	3965	1997-09-04	2019-03-21	44814724
3958	3958	1960-08-14	2018-07-08	44814724
3936	3936	1958-03-10	2019-05-13	44814724
3947	3947	2006-06-04	2019-06-30	44814724
3916	3916	1978-10-04	2019-04-17	44814724
3911	3911	2017-10-10	2019-03-19	44814724
3921	3921	1981-11-11	2017-10-10	44814724
3930	3930	1914-08-29	1980-01-05	44814724
3945	3945	2006-10-02	2018-11-19	44814724
3938	3938	1910-03-23	2000-06-07	44814724
3956	3956	1914-11-08	2018-11-11	44814724
3967	3967	1960-05-01	2019-06-30	44814724
3928	3928	1979-12-10	2017-02-27	44814724
3923	3923	1999-05-17	2019-05-05	44814724
3909	3909	1961-08-18	2019-02-01	44814724
3918	3918	1980-01-29	2017-04-18	44814724
3934	3934	1938-11-16	2019-05-08	44814724
3925	3925	2011-04-19	2018-12-18	44814724
3907	3907	1989-04-07	2019-01-26	44814724
3912	3912	2004-11-29	2019-06-24	44814724
3951	3951	1943-09-25	2019-04-13	44814724
3940	3940	1989-03-20	2016-11-20	44814724
3954	3954	1987-10-03	2017-03-11	44814724
3961	3961	1973-02-06	2019-02-26	44814724
3914	3914	2008-11-01	2018-11-10	44814724
3905	3905	2017-05-04	2019-04-11	44814724
3927	3927	1947-01-28	2019-06-04	44814724
3932	3932	1973-05-28	2018-10-29	44814724
3963	3963	2001-02-23	2019-02-28	44814724
3952	3952	2013-06-07	2019-05-24	44814724
3942	3942	1978-04-20	2019-03-21	44814724
3949	3949	1969-03-18	2019-03-05	44814724
4010	4010	1977-05-05	2019-05-25	44814724
4001	4001	2010-01-23	2019-01-26	44814724
4023	4023	2007-11-15	2019-06-07	44814724
4028	4028	2008-04-02	2019-04-17	44814724
3995	3995	1971-02-13	2018-08-18	44814724
3984	3984	1953-12-23	2018-12-19	44814724
3974	3974	1994-06-14	2018-12-03	44814724
3981	3981	2007-01-06	2019-05-03	44814724
4030	4030	1999-04-16	2018-06-15	44814724
4021	4021	1955-01-12	2019-05-01	44814724
4003	4003	2001-02-24	2019-06-22	44814724
4008	4008	1984-01-12	2018-06-14	44814724
3983	3983	1934-12-02	1963-10-06	44814724
3972	3972	1959-01-12	2019-02-18	44814724
3986	3986	1961-08-25	2018-09-07	44814724
3993	3993	1936-12-29	2019-02-05	44814724
3977	3977	1991-07-04	2018-10-05	44814724
3970	3970	2000-07-22	2019-04-27	44814724
3988	3988	1998-02-23	2019-01-14	44814724
3999	3999	1983-07-07	2016-09-01	44814724
4024	4024	1979-01-28	2018-05-20	44814724
4019	4019	1962-11-27	2019-03-12	44814724
4005	4005	1969-06-21	2019-06-29	44814724
4014	4014	1967-11-27	2018-12-29	44814724
3997	3997	1966-11-22	2018-11-09	44814724
3990	3990	2011-01-30	2019-01-27	44814724
3968	3968	1913-08-02	2019-02-02	44814724
3979	3979	1985-04-08	2019-04-10	44814724
4058	4058	2009-08-27	2019-05-08	44814724
4007	4007	2001-03-01	2019-05-02	44814724
4017	4017	1920-07-30	2014-08-15	44814724
4026	4026	1958-01-26	2019-06-20	44814724
3985	3985	1992-11-20	2019-06-22	44814724
3994	3994	2004-10-26	2018-11-27	44814724
3980	3980	1974-10-27	2018-09-09	44814724
3975	3975	1999-02-15	2019-01-11	44814724
4000	4000	2005-06-13	2018-09-18	44814724
4011	4011	1919-11-01	1944-03-25	44814724
4029	4029	1980-07-25	2017-10-13	44814724
4022	4022	1959-07-18	2019-06-22	44814724
3973	3973	1968-07-26	2019-02-16	44814724
3982	3982	1938-11-12	2019-06-15	44814724
3992	3992	2007-09-16	2019-01-20	44814724
3987	3987	1953-12-27	2019-03-24	44814724
4020	4020	1956-03-01	2019-05-16	44814724
4031	4031	1992-09-12	2017-09-23	44814724
4009	4009	1950-08-09	2007-12-26	44814724
4002	4002	2007-02-08	2018-12-27	44814724
4018	4018	1963-11-27	2018-09-05	44814724
4025	4025	2011-05-13	2019-05-10	44814724
4015	4015	2007-04-27	2019-06-28	44814724
4004	4004	2001-05-07	2019-02-04	44814724
3971	3971	1992-03-25	2019-05-15	44814724
3976	3976	1963-04-18	2019-05-02	44814724
3998	3998	1947-06-12	2018-12-13	44814724
3989	3989	1927-10-03	2019-02-04	44814724
4006	4006	1948-12-21	2016-08-09	44814724
4013	4013	1974-11-17	2018-12-02	44814724
4027	4027	1974-01-05	2017-07-01	44814724
4016	4016	1983-02-09	2018-09-28	44814724
3991	3991	1945-09-30	2019-02-10	44814724
3996	3996	1968-11-13	2018-11-14	44814724
3978	3978	1998-09-06	2019-05-19	44814724
3969	3969	2000-06-27	2019-05-29	44814724
4060	4060	1993-09-14	2019-06-08	44814724
4055	4055	1968-11-06	2019-01-16	44814724
4033	4033	1969-10-14	2018-04-24	44814724
4042	4042	1984-04-16	2019-05-27	44814724
4077	4077	1971-02-01	2017-08-07	44814724
4070	4070	1979-11-20	2018-03-27	44814724
4080	4080	1965-06-01	2019-06-25	44814724
4091	4091	1967-11-26	2018-12-02	44814724
4040	4040	1976-02-09	2019-03-18	44814724
4035	4035	1972-03-21	2019-03-19	44814724
4053	4053	1961-11-26	2019-01-06	44814724
4062	4062	1987-01-17	2019-03-09	44814724
4089	4089	1995-04-13	2018-08-16	44814724
4082	4082	1997-01-18	2019-03-23	44814724
4068	4068	1980-09-27	2017-05-06	44814724
4079	4079	1984-12-08	2018-12-29	44814724
4095	4095	1989-01-02	2017-08-21	44814724
4084	4084	1961-08-20	2019-05-05	44814724
4066	4066	2004-01-22	2019-02-28	44814724
4073	4073	2003-07-25	2018-10-12	44814724
4046	4046	2014-03-19	2019-02-21	44814724
4037	4037	1993-05-28	2019-06-21	44814724
4051	4051	1974-01-16	2018-12-24	44814724
4056	4056	1986-04-09	2018-10-07	44814724
4075	4075	2010-09-06	2019-04-01	44814724
4064	4064	1960-05-09	2018-07-16	44814724
4086	4086	1972-11-30	2019-02-21	44814724
4093	4093	2001-10-11	2019-03-28	44814724
4120	4120	2004-09-30	2019-03-21	44814724
4049	4049	1961-04-04	2018-07-03	44814724
4039	4039	2003-04-17	2019-03-28	44814724
4044	4044	1959-09-06	2018-10-28	44814724
4071	4071	1952-10-02	2018-12-27	44814724
4076	4076	1989-09-04	2018-08-05	44814724
4090	4090	1942-03-23	2018-08-20	44814724
4081	4081	1955-07-12	2018-11-13	44814724
4054	4054	2008-06-20	2018-06-29	44814724
4061	4061	1989-01-14	2018-08-18	44814724
4043	4043	2003-04-01	2019-06-06	44814724
4032	4032	1947-06-17	2018-09-04	44814724
4083	4083	2004-01-13	2019-02-19	44814724
4088	4088	1997-08-01	2019-06-21	44814724
4078	4078	1951-08-07	2019-05-07	44814724
4069	4069	1999-04-25	2018-04-22	44814724
4034	4034	1986-03-10	2017-11-06	44814724
4041	4041	1982-05-17	2019-05-20	44814724
4063	4063	1974-10-03	2017-09-07	44814724
4052	4052	1976-04-15	2018-06-10	44814724
4036	4036	2015-12-04	2019-06-27	44814724
4047	4047	2016-01-20	2019-06-26	44814724
4057	4057	2015-05-16	2019-03-23	44814724
4050	4050	2006-12-04	2018-08-13	44814724
4085	4085	1958-10-04	2019-06-29	44814724
4094	4094	1957-09-12	2018-10-25	44814724
4072	4072	1974-09-07	2017-11-18	44814724
4067	4067	1971-03-27	2018-08-18	44814724
4048	4048	1990-02-24	2018-06-16	44814724
4059	4059	1994-02-22	2016-10-11	44814724
4045	4045	1974-02-16	2018-03-04	44814724
4038	4038	1977-03-15	2019-04-23	44814724
4065	4065	1994-10-23	2018-09-23	44814724
4074	4074	1981-12-28	2019-03-15	44814724
4092	4092	1973-06-07	2019-05-02	44814724
4087	4087	1977-10-19	2018-07-09	44814724
4126	4126	2006-02-10	2019-03-08	44814724
4117	4117	1962-12-14	2018-08-10	44814724
4099	4099	2008-08-22	2019-01-11	44814724
4104	4104	2008-09-15	2018-09-24	44814724
4143	4143	1961-09-29	2018-11-09	44814724
4132	4132	2011-08-18	2019-01-10	44814724
4146	4146	1986-10-12	2018-04-07	44814724
4153	4153	1965-02-12	2019-04-19	44814724
4106	4106	1944-03-03	2018-11-09	44814724
4097	4097	2011-04-09	2019-04-06	44814724
4119	4119	1944-07-22	2018-12-01	44814724
4124	4124	1972-06-24	2017-07-01	44814724
4155	4155	2010-05-28	2019-05-31	44814724
4144	4144	1996-07-15	2019-05-20	44814724
4134	4134	1949-07-04	2019-05-14	44814724
4141	4141	2003-03-25	2018-12-25	44814724
4157	4157	1995-04-16	2016-12-18	44814724
4150	4150	1991-06-02	2017-06-04	44814724
4128	4128	1994-08-09	2018-07-17	44814724
4139	4139	1970-11-06	2019-05-17	44814724
4108	4108	2001-03-10	2019-06-01	44814724
4103	4103	1998-09-24	2018-02-08	44814724
4113	4113	1958-04-07	2019-06-10	44814724
4122	4122	1969-01-16	2018-10-18	44814724
4137	4137	1961-01-25	2019-03-13	44814724
4130	4130	1964-11-20	2019-05-31	44814724
4148	4148	1990-02-05	2018-12-17	44814724
4159	4159	1956-01-28	2019-01-26	44814724
4206	4206	1943-09-07	1996-10-01	44814724
4115	4115	1996-05-24	2017-07-21	44814724
4101	4101	1960-02-27	2019-04-20	44814724
4110	4110	2011-10-15	2018-10-06	44814724
4133	4133	1976-07-31	2019-02-14	44814724
4142	4142	1981-06-14	2018-12-09	44814724
4152	4152	1978-12-28	2019-05-09	44814724
4147	4147	1995-11-03	2018-08-10	44814724
4116	4116	1968-10-17	2018-10-18	44814724
4127	4127	1947-06-29	2019-03-23	44814724
4105	4105	1947-07-05	2019-04-27	44814724
4098	4098	1992-08-12	2018-05-16	44814724
4145	4145	1974-07-07	2018-07-22	44814724
4154	4154	2005-08-29	2018-10-08	44814724
4140	4140	1984-08-31	2019-02-01	44814724
4135	4135	2001-03-31	2019-05-25	44814724
4096	4096	1987-08-22	2019-04-13	44814724
4107	4107	1971-02-08	2018-12-21	44814724
4125	4125	1967-09-19	2018-09-25	44814724
4118	4118	1985-07-23	2017-04-18	44814724
4102	4102	1965-03-23	2019-04-16	44814724
4109	4109	1964-12-01	2019-04-23	44814724
4123	4123	1961-06-25	2019-04-21	44814724
4112	4112	1988-09-19	2017-10-30	44814724
4151	4151	2004-05-26	2018-09-12	44814724
4156	4156	1956-06-26	2019-01-08	44814724
4138	4138	1994-04-15	2019-06-21	44814724
4129	4129	1948-04-26	2018-11-26	44814724
4114	4114	2003-05-11	2019-06-23	44814724
4121	4121	1920-04-18	1987-11-15	44814724
4111	4111	2007-11-20	2018-08-28	44814724
4100	4100	1941-12-10	2019-05-15	44814724
4131	4131	1976-06-11	2018-10-12	44814724
4136	4136	2003-08-25	2018-12-24	44814724
4158	4158	1995-08-08	2018-06-18	44814724
4149	4149	1966-02-25	2018-07-27	44814724
4200	4200	1968-06-20	2019-06-27	44814724
4195	4195	1994-01-31	2019-04-22	44814724
4213	4213	1996-06-23	2019-06-02	44814724
4222	4222	1949-06-16	2019-06-13	44814724
4185	4185	1981-04-24	2017-08-18	44814724
4178	4178	2009-04-20	2018-10-15	44814724
4164	4164	2012-02-23	2019-04-20	44814724
4175	4175	2003-06-02	2019-05-27	44814724
4220	4220	1941-12-31	2018-09-12	44814724
4215	4215	1963-12-13	1992-01-03	44814724
4193	4193	1964-05-07	1995-09-07	44814724
4202	4202	1971-05-15	2018-04-21	44814724
4173	4173	1963-08-14	2018-09-12	44814724
4166	4166	1984-12-31	2018-01-22	44814724
4176	4176	1918-04-04	2019-04-04	44814724
4187	4187	2017-03-11	2019-02-16	44814724
4171	4171	1984-10-19	2019-06-21	44814724
4160	4160	1962-07-06	2018-07-13	44814724
4182	4182	1996-12-23	2019-02-25	44814724
4189	4189	2012-12-10	2018-11-26	44814724
4218	4218	1983-02-03	2016-09-22	44814724
4209	4209	1992-05-24	2017-10-22	44814724
4199	4199	1938-04-28	2018-10-04	44814724
4204	4204	1950-08-14	2019-02-04	44814724
4191	4191	1957-08-16	2013-08-02	44814724
4180	4180	2018-07-28	2019-04-06	44814724
4162	4162	2016-04-15	2019-03-22	44814724
4169	4169	1998-06-19	2018-12-29	44814724
4226	4226	1962-11-18	2018-11-25	44814724
4197	4197	1985-09-15	2016-11-27	44814724
4211	4211	1992-02-08	2017-09-09	44814724
4216	4216	2001-05-16	2018-04-25	44814724
4179	4179	1984-01-12	2018-03-29	44814724
4184	4184	1993-10-03	2019-06-24	44814724
4174	4174	2013-09-14	2019-04-24	44814724
4165	4165	1911-06-18	2018-07-15	44814724
4194	4194	1976-04-26	2017-07-10	44814724
4201	4201	1983-06-28	2019-04-23	44814724
4223	4223	1957-01-25	2019-04-26	44814724
4212	4212	1969-10-31	2019-05-23	44814724
4167	4167	1978-09-20	2018-06-13	44814724
4172	4172	2016-09-12	2019-02-18	44814724
4186	4186	2010-07-08	2018-12-20	44814724
4177	4177	1989-12-01	2019-05-01	44814724
4214	4214	1972-11-29	2018-12-19	44814724
4221	4221	2008-09-08	2018-09-10	44814724
4203	4203	1987-03-07	2018-08-18	44814724
4192	4192	1993-02-27	2019-03-16	44814724
4208	4208	1938-11-22	2013-11-19	44814724
4219	4219	1985-10-06	2018-08-05	44814724
4205	4205	1972-01-08	2018-02-08	44814724
4198	4198	1983-07-07	2016-09-01	44814724
4161	4161	2006-09-13	2019-04-10	44814724
4170	4170	1984-04-24	2018-07-10	44814724
4188	4188	2018-03-19	2019-05-27	44814724
4183	4183	1989-09-13	2018-03-28	44814724
4196	4196	2010-05-10	2019-05-13	44814724
4207	4207	2018-07-07	2019-05-11	44814724
4217	4217	1958-08-13	2019-06-05	44814724
4210	4210	1975-04-06	2019-04-21	44814724
4181	4181	2003-02-03	2019-03-18	44814724
4190	4190	1972-07-30	2019-04-28	44814724
4168	4168	1971-04-03	2019-04-27	44814724
4163	4163	1986-02-24	2018-08-06	44814724
4228	4228	2002-07-27	2018-07-28	44814724
4239	4239	1948-09-26	2019-04-21	44814724
4249	4249	1987-09-09	2019-05-08	44814724
4242	4242	2000-05-17	2018-07-11	44814724
4277	4277	2006-02-01	2018-12-26	44814724
4286	4286	2001-03-28	2019-04-07	44814724
4264	4264	2015-09-19	2019-02-23	44814724
4259	4259	2008-07-14	2019-06-17	44814724
4240	4240	1941-07-22	2018-12-25	44814724
4251	4251	2014-07-12	2019-06-22	44814724
4237	4237	2014-02-06	2019-01-10	44814724
4230	4230	1981-10-08	2019-05-09	44814724
4257	4257	1983-09-02	2019-01-17	44814724
4266	4266	2001-03-24	2019-03-16	44814724
4284	4284	1942-12-03	2019-05-02	44814724
4279	4279	1950-04-07	2018-07-20	44814724
4263	4263	2014-11-15	2019-01-23	44814724
4268	4268	1955-09-13	2019-01-29	44814724
4282	4282	1966-04-06	2019-04-24	44814724
4273	4273	2016-11-18	2019-04-19	44814724
4246	4246	1966-12-28	2019-01-09	44814724
4253	4253	1980-12-23	2018-10-26	44814724
4235	4235	1979-03-01	2019-05-30	44814724
4224	4224	1946-01-09	2019-04-10	44814724
4275	4275	1980-01-14	2017-08-14	44814724
4280	4280	1994-02-10	2018-07-07	44814724
4270	4270	1967-01-17	2019-01-29	44814724
4261	4261	1922-03-12	2019-03-17	44814724
4340	4340	1972-09-22	2019-04-26	44814724
4233	4233	1996-05-02	2018-11-01	44814724
4255	4255	1973-04-29	2019-06-30	44814724
4244	4244	2009-12-22	2019-06-25	44814724
4287	4287	1993-11-22	2019-01-24	44814724
4276	4276	1952-12-26	2019-03-29	44814724
4258	4258	2012-09-25	2018-08-28	44814724
4265	4265	1997-08-14	2019-05-12	44814724
4238	4238	1961-08-31	2018-10-11	44814724
4229	4229	1952-06-22	2018-10-21	44814724
4243	4243	1968-01-19	2019-03-29	44814724
4248	4248	1960-02-27	1989-12-16	44814724
4267	4267	2000-07-21	2018-07-22	44814724
4256	4256	1952-10-05	2019-01-06	44814724
4278	4278	1950-10-20	2019-03-26	44814724
4285	4285	1998-06-20	2018-05-19	44814724
4250	4250	1945-03-03	2019-04-06	44814724
4241	4241	1964-10-27	2018-10-23	44814724
4231	4231	2002-05-08	2019-06-26	44814724
4236	4236	1984-08-21	2016-11-29	44814724
4252	4252	2000-02-14	2018-12-24	44814724
4247	4247	1983-03-19	2019-03-28	44814724
4225	4225	1979-04-06	2019-04-12	44814724
4234	4234	2018-01-24	2019-06-05	44814724
4269	4269	1968-05-01	2019-05-08	44814724
4262	4262	2014-12-19	2018-07-13	44814724
4272	4272	1998-11-06	2018-12-07	44814724
4283	4283	1951-04-14	2019-01-26	44814724
4232	4232	2001-07-04	2018-07-25	44814724
4227	4227	1955-02-13	2019-05-05	44814724
4245	4245	2007-12-21	2019-01-04	44814724
4254	4254	2016-12-09	2019-05-17	44814724
4281	4281	2012-03-08	2019-02-28	44814724
4274	4274	1920-11-27	2018-11-24	44814724
4260	4260	1937-01-05	2018-10-30	44814724
4271	4271	1987-07-20	2018-10-01	44814724
4338	4338	1965-07-10	2018-07-28	44814724
4345	4345	1991-06-23	2017-02-12	44814724
4335	4335	1989-09-01	2016-10-21	44814724
4324	4324	1961-06-11	2019-06-11	44814724
4291	4291	1973-11-23	2019-06-09	44814724
4296	4296	1997-11-11	2017-10-31	44814724
4318	4318	2010-05-25	2019-05-28	44814724
4309	4309	1954-08-04	2019-01-02	44814724
4326	4326	1992-01-19	2019-04-14	44814724
4333	4333	1953-08-27	2018-11-25	44814724
4347	4347	1966-04-11	2019-06-10	44814724
4336	4336	1976-07-28	2018-08-08	44814724
4311	4311	2003-12-09	2019-06-25	44814724
4316	4316	1996-01-11	2018-11-08	44814724
4298	4298	2012-11-28	2019-05-26	44814724
4289	4289	1942-07-19	2019-02-03	44814724
4305	4305	1957-11-23	2019-06-13	44814724
4314	4314	2016-01-09	2019-06-15	44814724
4300	4300	2006-11-14	2019-01-18	44814724
4295	4295	1971-09-22	2019-03-13	44814724
4320	4320	1970-03-29	2019-03-03	44814724
4331	4331	1974-11-15	2018-11-30	44814724
4349	4349	1982-12-03	2017-02-17	44814724
4342	4342	1957-07-05	2018-11-09	44814724
4293	4293	1974-11-25	2018-12-10	44814724
4302	4302	1990-07-10	2018-09-18	44814724
4312	4312	1959-09-17	2019-05-17	44814724
4307	4307	2010-12-20	2018-10-08	44814724
4391	4391	1941-02-07	2018-07-13	44814724
4351	4351	1990-08-05	2019-02-09	44814724
4329	4329	1978-04-03	2018-12-31	44814724
4322	4322	2016-05-25	2019-05-08	44814724
4297	4297	1973-01-06	2019-03-02	44814724
4290	4290	1991-03-16	2018-06-10	44814724
4308	4308	1912-08-21	1992-11-25	44814724
4319	4319	1977-12-07	2019-06-02	44814724
4344	4344	2006-04-17	2019-06-24	44814724
4339	4339	1996-03-23	2018-04-14	44814724
4325	4325	1965-03-23	2018-09-18	44814724
4334	4334	2006-07-09	2019-01-13	44814724
4317	4317	1947-02-07	2018-11-02	44814724
4310	4310	2012-11-26	2019-03-30	44814724
4288	4288	1951-02-11	2019-04-07	44814724
4299	4299	1973-02-11	2018-06-10	44814724
4332	4332	2013-04-25	2019-04-11	44814724
4327	4327	2015-01-08	2019-05-17	44814724
4337	4337	1961-06-09	2018-07-27	44814724
4346	4346	2009-10-03	2018-07-07	44814724
4330	4330	1945-12-23	2018-10-21	44814724
4321	4321	1962-12-30	2018-12-09	44814724
4343	4343	1954-10-18	2019-06-24	44814724
4348	4348	1981-10-21	2019-01-07	44814724
4315	4315	1995-04-05	2017-09-27	44814724
4304	4304	1966-09-11	2018-12-30	44814724
4294	4294	2018-06-11	2019-05-20	44814724
4301	4301	2012-09-11	2018-08-28	44814724
4350	4350	1992-05-17	2018-11-29	44814724
4341	4341	2009-02-03	2019-02-12	44814724
4323	4323	2014-07-16	2019-06-26	44814724
4328	4328	1970-06-03	2018-03-21	44814724
4303	4303	2017-06-20	2019-05-28	44814724
4292	4292	2011-01-12	2018-11-07	44814724
4306	4306	1995-06-26	2017-01-30	44814724
4313	4313	1947-07-19	2018-06-30	44814724
4385	4385	1990-08-09	2018-10-18	44814724
4394	4394	1970-03-02	2018-05-28	44814724
4412	4412	1963-08-02	2019-04-05	44814724
4407	4407	1990-03-02	2018-09-09	44814724
4368	4368	1985-06-09	2019-04-14	44814724
4379	4379	1969-06-17	2019-06-18	44814724
4365	4365	1951-07-23	2016-01-18	44814724
4358	4358	1988-02-21	2018-07-16	44814724
4405	4405	1964-02-17	2019-03-18	44814724
4414	4414	1972-10-22	2007-12-02	44814724
4392	4392	1979-08-03	2017-03-03	44814724
4387	4387	1964-08-21	2018-09-14	44814724
4356	4356	1985-03-23	2019-06-08	44814724
4367	4367	1983-10-31	2017-11-20	44814724
4377	4377	1983-08-26	2018-03-30	44814724
4370	4370	1958-11-19	2019-03-30	44814724
4354	4354	1997-07-28	2017-01-02	44814724
4361	4361	2009-02-10	2018-10-02	44814724
4383	4383	1968-11-16	2018-11-17	44814724
4372	4372	1980-05-08	2019-06-04	44814724
4403	4403	1935-03-02	2000-07-22	44814724
4408	4408	1981-01-23	2019-02-24	44814724
4398	4398	1959-04-19	2019-04-23	44814724
4389	4389	2002-10-11	2018-08-17	44814724
4374	4374	1976-05-20	2017-08-24	44814724
4381	4381	1964-06-02	2018-08-14	44814724
4363	4363	2004-12-08	2019-05-01	44814724
4352	4352	1948-07-29	2018-08-23	44814724
4433	4433	1939-03-19	2019-06-25	44814724
4396	4396	1976-03-07	2019-04-10	44814724
4410	4410	2009-09-09	2018-10-22	44814724
4401	4401	1969-01-04	2019-01-05	44814724
4378	4378	1980-10-08	2018-01-14	44814724
4369	4369	1994-11-19	2019-03-17	44814724
4359	4359	1943-02-10	2019-03-07	44814724
4364	4364	1951-01-01	2019-01-21	44814724
4395	4395	1947-01-10	2019-05-17	44814724
4384	4384	1967-04-17	2019-01-07	44814724
4406	4406	1941-11-22	2019-04-27	44814724
4413	4413	1960-12-08	2018-07-26	44814724
4366	4366	1981-05-05	2019-04-23	44814724
4357	4357	2003-08-11	2019-03-25	44814724
4371	4371	1987-07-25	2019-05-01	44814724
4376	4376	1920-06-01	2019-02-12	44814724
4415	4415	1998-02-13	2017-08-10	44814724
4404	4404	1981-12-27	2017-10-29	44814724
4386	4386	1996-12-10	2016-10-18	44814724
4393	4393	1984-05-18	2018-05-04	44814724
4409	4409	1967-01-19	2018-10-18	44814724
4402	4402	2008-07-20	2018-07-29	44814724
4388	4388	1966-08-20	2019-04-22	44814724
4399	4399	2010-01-05	2019-02-17	44814724
4360	4360	1987-01-07	2018-03-21	44814724
4355	4355	1981-04-18	2019-04-20	44814724
4373	4373	1976-01-06	2018-02-05	44814724
4382	4382	1952-12-29	2019-06-16	44814724
4397	4397	2000-11-23	2019-01-17	44814724
4390	4390	1959-02-06	2019-04-26	44814724
4400	4400	1983-07-19	2018-06-19	44814724
4411	4411	1945-04-16	2018-07-02	44814724
4380	4380	1964-04-20	2019-05-20	44814724
4375	4375	1927-07-11	2019-03-11	44814724
4353	4353	1966-08-07	2018-09-23	44814724
4362	4362	2005-09-06	2019-01-01	44814724
4439	4439	1954-12-09	2019-02-28	44814724
4444	4444	1996-03-27	2019-03-11	44814724
4426	4426	1982-03-26	2019-06-21	44814724
4417	4417	1995-07-07	2019-01-05	44814724
4454	4454	1919-11-01	2019-01-12	44814724
4461	4461	2004-12-04	2019-01-05	44814724
4475	4475	1978-05-22	2018-09-29	44814724
4464	4464	1996-05-18	2018-12-29	44814724
4419	4419	1955-08-22	2018-08-13	44814724
4424	4424	1982-01-03	2019-06-11	44814724
4446	4446	1960-06-28	2018-08-14	44814724
4437	4437	1969-01-09	2018-07-19	44814724
4466	4466	1971-10-01	2017-08-25	44814724
4473	4473	1971-07-26	2019-05-27	44814724
4463	4463	2001-10-06	2019-03-09	44814724
4452	4452	1955-06-03	2018-08-17	44814724
4468	4468	1984-04-15	2018-10-28	44814724
4479	4479	2002-03-04	2018-10-22	44814724
4457	4457	1983-05-10	2017-07-25	44814724
4450	4450	1967-08-12	2018-10-18	44814724
4421	4421	1993-04-25	2019-05-09	44814724
4430	4430	1994-11-23	2017-05-08	44814724
4440	4440	1997-11-10	2019-06-14	44814724
4435	4435	1961-01-02	2018-11-19	44814724
4448	4448	1954-04-15	2018-07-05	44814724
4459	4459	1963-10-22	2018-11-20	44814724
4477	4477	1963-11-21	2018-12-20	44814724
4470	4470	1972-01-09	2018-05-20	44814724
4541	4541	1988-11-10	2017-10-19	44814724
4442	4442	1981-06-15	2018-09-03	44814724
4428	4428	1949-11-25	2019-03-15	44814724
4423	4423	1975-08-22	2017-11-17	44814724
4460	4460	1940-04-08	2018-10-29	44814724
4455	4455	1946-01-18	1976-07-02	44814724
4465	4465	1973-01-26	2019-02-15	44814724
4474	4474	1963-06-07	2018-10-02	44814724
4445	4445	2000-01-14	2018-12-15	44814724
4438	4438	1991-10-09	2017-01-25	44814724
4416	4416	1994-06-25	2009-03-07	44814724
4427	4427	2009-12-25	2018-12-28	44814724
4472	4472	1935-04-13	2015-10-10	44814724
4467	4467	1951-06-28	2019-02-21	44814724
4453	4453	2012-08-08	2018-07-25	44814724
4462	4462	1955-02-04	2018-04-27	44814724
4425	4425	2007-03-30	2019-02-15	44814724
4418	4418	1951-07-27	2019-04-05	44814724
4436	4436	1965-05-28	2019-06-21	44814724
4447	4447	1951-08-22	2019-03-10	44814724
4431	4431	1988-01-27	2016-10-26	44814724
4420	4420	1983-08-13	2018-12-22	44814724
4434	4434	2016-06-21	2019-06-24	44814724
4441	4441	2016-04-02	2019-04-09	44814724
4478	4478	2008-01-04	2018-08-03	44814724
4469	4469	2007-02-03	2019-02-23	44814724
4451	4451	1951-05-14	2019-06-03	44814724
4456	4456	1964-05-24	2019-05-19	44814724
4443	4443	1985-11-27	2018-04-13	44814724
4432	4432	1957-06-26	2019-05-14	44814724
4422	4422	1996-11-03	2019-01-06	44814724
4429	4429	2002-02-24	2019-04-14	44814724
4458	4458	2019-06-14	2019-06-14	44814724
4449	4449	1990-10-28	2019-05-26	44814724
4471	4471	1960-07-12	2001-01-16	44814724
4476	4476	1962-02-18	2019-05-19	44814724
4539	4539	2004-01-16	2019-01-04	44814724
4528	4528	1981-02-08	2018-08-12	44814724
4518	4518	1996-09-09	2019-03-30	44814724
4525	4525	1968-01-31	2019-02-06	44814724
4490	4490	1924-12-27	1988-04-30	44814724
4481	4481	1982-05-15	2017-12-30	44814724
4503	4503	1935-12-25	2019-05-01	44814724
4508	4508	1985-03-28	2018-05-09	44814724
4527	4527	1960-06-10	2019-05-10	44814724
4516	4516	1990-04-16	2019-02-04	44814724
4530	4530	1968-05-18	2019-05-26	44814724
4537	4537	1996-10-01	2019-04-21	44814724
4510	4510	1978-12-12	2017-10-24	44814724
4501	4501	1972-11-30	2018-12-20	44814724
4483	4483	2010-02-10	2019-05-15	44814724
4488	4488	1976-01-02	2018-12-14	44814724
4504	4504	1966-11-19	2019-06-22	44814724
4499	4499	2007-01-27	2018-10-10	44814724
4485	4485	1950-10-12	2019-04-28	44814724
4494	4494	2009-11-16	2018-10-15	44814724
4521	4521	1918-04-04	2009-05-07	44814724
4514	4514	1975-05-23	2018-07-13	44814724
4532	4532	1909-04-17	1998-10-24	44814724
4543	4543	1979-09-08	2018-05-06	44814724
4492	4492	1946-08-06	2019-01-08	44814724
4487	4487	1948-03-12	2010-02-19	44814724
4497	4497	1956-09-25	2018-12-11	44814724
4506	4506	1953-12-25	2019-03-22	44814724
4555	4555	2001-04-05	2019-01-03	44814724
4534	4534	1943-10-27	2011-12-07	44814724
4512	4512	2016-05-29	2019-05-05	44814724
4523	4523	1976-01-25	2018-02-04	44814724
4480	4480	1961-01-31	2018-10-09	44814724
4491	4491	1946-01-13	2019-06-23	44814724
4509	4509	1967-08-29	2018-09-04	44814724
4502	4502	1998-03-23	2018-09-25	44814724
4529	4529	1963-11-17	2018-12-17	44814724
4538	4538	1953-05-15	2018-08-10	44814724
4524	4524	1982-07-22	2019-04-11	44814724
4519	4519	2014-06-04	2019-05-15	44814724
4500	4500	1961-09-13	2018-10-31	44814724
4511	4511	1986-05-21	2019-05-13	44814724
4489	4489	2008-11-23	2018-09-02	44814724
4482	4482	1950-07-22	2019-01-26	44814724
4517	4517	2013-01-23	2019-01-09	44814724
4526	4526	1953-10-09	2019-01-05	44814724
4536	4536	1989-02-04	2018-02-10	44814724
4531	4531	1914-08-29	2017-05-06	44814724
4515	4515	1995-07-26	2019-03-25	44814724
4520	4520	1927-04-10	1996-10-06	44814724
4542	4542	1994-05-05	2019-05-22	44814724
4533	4533	2001-09-24	2019-06-17	44814724
4498	4498	1977-05-25	2019-06-05	44814724
4505	4505	1936-07-21	2019-05-28	44814724
4495	4495	1995-09-05	2017-11-07	44814724
4484	4484	1951-09-13	2019-06-20	44814724
4535	4535	1987-10-31	2019-01-12	44814724
4540	4540	1996-02-09	2018-04-13	44814724
4522	4522	1976-01-09	2018-01-20	44814724
4513	4513	1961-12-20	2019-01-30	44814724
4486	4486	1980-01-13	2018-06-03	44814724
4493	4493	1982-06-22	2016-08-02	44814724
4507	4507	1985-07-30	2017-03-07	44814724
4496	4496	1947-03-13	2019-06-20	44814724
4557	4557	1920-04-18	2019-01-20	44814724
4550	4550	1962-09-09	2018-10-14	44814724
4560	4560	1967-11-01	2019-06-19	44814724
4571	4571	1954-06-27	2019-03-24	44814724
4604	4604	1964-03-01	2019-05-12	44814724
4599	4599	2016-08-15	2019-01-21	44814724
4577	4577	1983-07-09	2018-03-31	44814724
4586	4586	1956-10-28	2019-01-06	44814724
4569	4569	1962-01-23	2019-03-05	44814724
4562	4562	1961-01-28	2019-06-01	44814724
4548	4548	1983-10-18	2019-06-05	44814724
4559	4559	1944-12-20	2018-08-15	44814724
4584	4584	2015-06-17	2019-05-22	44814724
4579	4579	1967-07-14	2019-01-11	44814724
4597	4597	1991-03-24	2018-02-16	44814724
4606	4606	1982-02-04	2019-06-20	44814724
4590	4590	1955-11-14	2019-01-28	44814724
4581	4581	2016-03-20	2019-03-17	44814724
4595	4595	1962-07-13	2018-07-06	44814724
4600	4600	1993-03-17	2018-12-26	44814724
4575	4575	2018-01-13	2019-06-22	44814724
4564	4564	2008-11-08	2018-11-17	44814724
4546	4546	1968-06-28	2018-09-16	44814724
4553	4553	1981-02-18	2018-05-09	44814724
4602	4602	1977-05-09	2017-07-31	44814724
4593	4593	1963-09-12	2018-12-13	44814724
4583	4583	1997-04-22	2019-06-25	44814724
4588	4588	1993-10-24	2019-03-24	44814724
4635	4635	1995-07-16	2017-09-17	44814724
4544	4544	1939-10-24	1994-02-08	44814724
4566	4566	2008-12-21	2019-05-12	44814724
4573	4573	2011-01-13	2019-01-10	44814724
4598	4598	1981-11-06	2018-08-03	44814724
4605	4605	1998-01-29	2018-12-13	44814724
4587	4587	1935-04-13	2019-02-23	44814724
4576	4576	1954-10-27	2018-09-26	44814724
4551	4551	1977-01-26	2019-02-06	44814724
4556	4556	1984-08-19	2018-11-25	44814724
4570	4570	1937-01-23	2019-06-01	44814724
4561	4561	1950-04-13	2018-07-26	44814724
4578	4578	1964-05-24	2019-02-24	44814724
4585	4585	1996-08-07	2018-11-28	44814724
4607	4607	1972-01-20	2019-05-16	44814724
4596	4596	1938-06-26	2019-01-20	44814724
4563	4563	1963-12-13	2019-04-28	44814724
4568	4568	2002-02-19	2019-01-29	44814724
4558	4558	2005-02-03	2019-01-17	44814724
4549	4549	1985-06-22	2017-02-25	44814724
4565	4565	1945-08-07	2019-05-26	44814724
4574	4574	1956-03-16	2019-04-21	44814724
4552	4552	2006-07-31	2019-07-01	44814724
4547	4547	1908-10-19	2019-04-08	44814724
4580	4580	1966-03-01	2019-03-19	44814724
4591	4591	1952-09-18	2019-06-27	44814724
4601	4601	2008-12-18	2019-05-16	44814724
4594	4594	1984-11-02	2019-04-27	44814724
4545	4545	1987-03-22	2018-11-25	44814724
4554	4554	1997-07-21	2017-02-15	44814724
4572	4572	1976-01-13	2018-07-16	44814724
4567	4567	2013-03-09	2019-06-08	44814724
4592	4592	1997-09-13	2019-06-17	44814724
4603	4603	1930-10-17	2018-12-14	44814724
4589	4589	1991-03-08	2016-12-02	44814724
4582	4582	1993-01-20	2018-10-09	44814724
4637	4637	1974-01-21	2018-06-25	44814724
4630	4630	1955-01-27	2019-02-14	44814724
4608	4608	1954-12-16	2019-03-07	44814724
4619	4619	2005-01-19	2019-06-07	44814724
4652	4652	2017-10-26	2019-03-28	44814724
4647	4647	1989-10-05	2019-05-30	44814724
4657	4657	1960-10-07	2018-10-19	44814724
4666	4666	1972-07-04	2017-08-08	44814724
4617	4617	1980-09-30	1990-08-07	44814724
4610	4610	1992-01-20	2017-10-23	44814724
4628	4628	1968-09-29	2018-09-30	44814724
4639	4639	1970-02-20	2018-03-16	44814724
4664	4664	1996-11-29	2015-02-27	44814724
4659	4659	2017-08-19	2019-06-10	44814724
4645	4645	2009-09-13	2018-09-16	44814724
4654	4654	1990-08-10	2019-06-14	44814724
4670	4670	1954-03-31	2019-03-28	44814724
4661	4661	1976-10-14	2018-04-28	44814724
4643	4643	1909-04-17	1998-04-04	44814724
4648	4648	2000-01-11	2019-03-12	44814724
4623	4623	1929-05-14	2018-07-03	44814724
4612	4612	2000-05-27	2019-06-24	44814724
4626	4626	1975-11-03	2017-11-27	44814724
4633	4633	1958-11-26	2019-01-23	44814724
4650	4650	1994-06-23	2000-12-28	44814724
4641	4641	1967-07-13	2018-07-19	44814724
4663	4663	2009-11-16	2018-07-16	44814724
4668	4668	1955-01-12	2019-04-03	44814724
4717	4717	2003-10-07	2019-06-25	44814724
4624	4624	1993-07-04	2018-09-02	44814724
4614	4614	2004-05-12	2019-06-19	44814724
4621	4621	1976-07-26	2018-08-06	44814724
4646	4646	1943-08-03	2019-06-18	44814724
4653	4653	1959-02-22	2019-04-21	44814724
4667	4667	1981-11-15	2019-02-10	44814724
4656	4656	1949-09-11	2014-05-18	44814724
4631	4631	1913-08-09	2019-06-28	44814724
4636	4636	1946-06-18	2018-10-23	44814724
4618	4618	1988-10-19	2016-12-28	44814724
4609	4609	2018-11-19	2019-04-29	44814724
4658	4658	2016-05-04	2019-04-10	44814724
4665	4665	1981-08-15	2019-04-20	44814724
4655	4655	1958-12-14	2019-01-13	44814724
4644	4644	1962-07-05	2018-09-27	44814724
4611	4611	1999-10-29	2019-03-29	44814724
4616	4616	1969-02-12	1999-09-22	44814724
4638	4638	1993-05-27	2018-07-05	44814724
4629	4629	1965-10-03	1993-12-26	44814724
4613	4613	1966-05-22	2019-06-02	44814724
4622	4622	1956-01-26	2019-04-11	44814724
4632	4632	1984-11-26	2019-04-29	44814724
4627	4627	1986-05-05	2017-07-17	44814724
4660	4660	1960-12-04	2019-04-07	44814724
4671	4671	2001-12-29	2018-09-22	44814724
4649	4649	1969-02-10	2019-06-03	44814724
4642	4642	1952-11-26	2019-02-27	44814724
4625	4625	1960-05-18	2019-01-23	44814724
4634	4634	1962-11-08	2018-08-23	44814724
4620	4620	2001-04-24	2019-06-18	44814724
4615	4615	1955-04-20	2019-02-13	44814724
4640	4640	1993-12-05	2019-05-19	44814724
4651	4651	1987-05-22	2019-05-03	44814724
4669	4669	2013-10-03	2018-07-12	44814724
4662	4662	1950-08-05	2018-11-17	44814724
4715	4715	1950-08-09	2018-12-26	44814724
4704	4704	1965-12-19	2018-12-09	44814724
4726	4726	1989-08-18	2019-01-11	44814724
4733	4733	1981-02-24	2018-07-24	44814724
4698	4698	1988-05-17	2018-05-16	44814724
4689	4689	1967-05-10	2019-06-26	44814724
4679	4679	1995-04-30	2018-11-20	44814724
4684	4684	2013-01-07	2019-01-14	44814724
4735	4735	1973-01-04	2019-01-24	44814724
4724	4724	1941-05-07	2019-03-06	44814724
4706	4706	1998-05-24	2019-05-03	44814724
4713	4713	1966-01-07	2019-01-25	44814724
4686	4686	2001-08-27	2019-02-04	44814724
4677	4677	1957-12-13	2019-06-01	44814724
4691	4691	1960-05-07	2019-06-29	44814724
4696	4696	1951-03-14	2019-01-02	44814724
4680	4680	1909-04-17	2000-01-08	44814724
4675	4675	1911-07-02	2019-03-24	44814724
4693	4693	2011-07-26	2018-07-17	44814724
4702	4702	1997-04-22	2017-02-07	44814724
4729	4729	1963-02-01	2018-07-13	44814724
4722	4722	1909-02-14	2018-08-26	44814724
4708	4708	2008-08-13	2019-04-24	44814724
4719	4719	1934-12-02	2019-04-22	44814724
4700	4700	1951-05-23	2019-03-20	44814724
4695	4695	1990-09-13	2018-11-22	44814724
4673	4673	2001-01-08	2019-01-07	44814724
4682	4682	1979-09-16	2016-12-04	44814724
4737	4737	1984-03-23	2019-06-28	44814724
4710	4710	2019-03-27	2019-05-26	44814724
4720	4720	1976-06-15	2018-05-15	44814724
4731	4731	1971-11-02	2018-07-03	44814724
4688	4688	1999-09-16	2019-03-28	44814724
4699	4699	2002-11-26	2018-10-02	44814724
4685	4685	1939-09-04	1992-06-01	44814724
4678	4678	1954-09-28	2018-07-24	44814724
4705	4705	1972-06-16	2019-06-22	44814724
4714	4714	2014-06-10	2019-05-21	44814724
4732	4732	1955-07-24	2018-10-07	44814724
4727	4727	2019-04-22	2019-05-27	44814724
4676	4676	1979-08-02	2017-11-09	44814724
4687	4687	1986-02-24	2018-04-16	44814724
4697	4697	2005-12-05	2019-01-21	44814724
4690	4690	1956-06-10	2018-10-14	44814724
4725	4725	1974-09-23	2018-10-08	44814724
4734	4734	1987-05-04	2018-06-11	44814724
4712	4712	1968-01-19	2019-03-31	44814724
4707	4707	1973-09-06	2018-09-11	44814724
4723	4723	1994-09-30	2017-04-14	44814724
4728	4728	2015-10-09	2019-03-15	44814724
4718	4718	1990-05-30	2019-02-27	44814724
4709	4709	1956-05-07	2018-12-15	44814724
4674	4674	1968-08-20	2018-10-16	44814724
4681	4681	2008-02-16	2018-08-11	44814724
4703	4703	2003-12-25	2019-01-31	44814724
4692	4692	2011-07-24	2018-07-15	44814724
4711	4711	2003-10-14	2018-11-20	44814724
4716	4716	1998-12-31	2019-03-21	44814724
4730	4730	1989-02-09	2019-05-30	44814724
4721	4721	1987-01-10	2018-03-24	44814724
4694	4694	1981-08-09	2019-03-24	44814724
4701	4701	1970-11-28	2018-12-22	44814724
4683	4683	1990-09-13	2017-02-16	44814724
4672	4672	1986-09-27	2017-12-09	44814724
4743	4743	2018-02-19	2019-04-29	44814724
4748	4748	1944-10-06	2019-05-17	44814724
4762	4762	2004-03-27	2019-05-04	44814724
4753	4753	1961-06-08	2018-08-28	44814724
4790	4790	2000-05-12	2019-01-05	44814724
4797	4797	1978-03-13	2018-03-19	44814724
4779	4779	2001-08-18	2018-10-06	44814724
4768	4768	1986-12-02	2017-03-07	44814724
4755	4755	1924-11-07	2019-02-01	44814724
4760	4760	1954-10-27	2018-10-03	44814724
4750	4750	1963-04-10	2019-05-15	44814724
4741	4741	2007-02-20	2019-03-12	44814724
4770	4770	1972-02-21	1980-05-19	44814724
4777	4777	1958-05-13	2018-07-10	44814724
4799	4799	1957-11-16	2019-01-19	44814724
4788	4788	1975-11-23	2017-12-03	44814724
4772	4772	1988-03-15	2019-05-28	44814724
4783	4783	2000-03-15	2018-10-17	44814724
4793	4793	2010-07-20	2019-01-13	44814724
4786	4786	1997-11-14	2018-09-09	44814724
4757	4757	1956-03-28	2018-10-24	44814724
4766	4766	2005-05-29	2019-06-16	44814724
4744	4744	2017-11-20	2019-06-13	44814724
4739	4739	1909-11-27	1993-07-03	44814724
4784	4784	1949-01-01	2018-09-08	44814724
4795	4795	1965-11-03	2018-11-21	44814724
4781	4781	1981-10-02	2017-10-20	44814724
4774	4774	2013-06-23	2018-12-21	44814724
4855	4855	1977-09-10	2019-04-06	44814724
4746	4746	1983-06-03	2019-04-28	44814724
4764	4764	1968-08-21	2018-08-29	44814724
4759	4759	1976-11-16	2017-09-12	44814724
4796	4796	1997-11-30	2019-01-04	44814724
4791	4791	1967-05-25	2018-09-13	44814724
4769	4769	1999-11-14	2018-12-30	44814724
4778	4778	1984-03-18	2018-12-30	44814724
4749	4749	1972-10-22	2018-11-11	44814724
4742	4742	2006-01-12	2019-05-23	44814724
4752	4752	2015-05-30	2019-05-04	44814724
4763	4763	1950-08-22	2018-06-26	44814724
4776	4776	1960-04-17	2018-09-16	44814724
4771	4771	1953-02-21	2018-10-06	44814724
4789	4789	2015-01-24	2018-12-29	44814724
4798	4798	1985-03-09	2018-09-22	44814724
4761	4761	1980-05-05	2018-04-02	44814724
4754	4754	1964-10-20	2018-07-17	44814724
4740	4740	2015-09-03	2019-02-07	44814724
4751	4751	1995-02-01	2019-03-19	44814724
4767	4767	2012-01-03	2018-12-25	44814724
4756	4756	1943-10-09	2018-12-01	44814724
4738	4738	1909-09-17	1945-07-20	44814724
4745	4745	1975-04-02	2018-03-28	44814724
4782	4782	1980-04-29	2018-03-17	44814724
4773	4773	1958-12-25	2018-06-28	44814724
4787	4787	1987-06-28	2019-03-03	44814724
4792	4792	1950-03-21	2018-12-18	44814724
4747	4747	1981-06-15	2019-01-07	44814724
4736	4736	1972-09-15	2019-06-14	44814724
4758	4758	1958-03-10	2018-07-16	44814724
4765	4765	2015-12-14	2019-06-20	44814724
4794	4794	1997-12-13	2017-05-06	44814724
4785	4785	1954-04-07	1981-06-24	44814724
4775	4775	1998-10-15	2018-08-23	44814724
4780	4780	1990-05-04	2018-07-13	44814724
4849	4849	1997-08-26	2016-10-25	44814724
4858	4858	1977-12-30	2018-01-06	44814724
4844	4844	1959-02-26	2019-04-25	44814724
4839	4839	1997-01-27	2016-07-18	44814724
4800	4800	1970-10-30	2018-11-16	44814724
4811	4811	1962-04-17	2018-08-07	44814724
4829	4829	1971-12-10	2019-04-07	44814724
4822	4822	1947-09-24	2019-06-26	44814724
4837	4837	1948-12-21	2019-01-15	44814724
4846	4846	2004-11-22	2019-05-14	44814724
4856	4856	2006-09-06	2018-12-17	44814724
4851	4851	1994-01-03	2019-03-11	44814724
4820	4820	1955-10-27	2018-06-28	44814724
4831	4831	1961-04-27	2019-02-16	44814724
4809	4809	2015-08-08	2019-01-12	44814724
4802	4802	1964-09-13	2018-09-16	44814724
4818	4818	1984-10-30	2019-06-04	44814724
4825	4825	2013-07-16	2018-06-26	44814724
4815	4815	1970-03-05	2018-06-28	44814724
4804	4804	1977-03-21	2018-10-29	44814724
4835	4835	1970-04-30	2018-05-24	44814724
4840	4840	1983-08-03	2018-05-16	44814724
4862	4862	2019-03-13	2019-06-19	44814724
4853	4853	1962-05-09	2019-05-08	44814724
4806	4806	1964-01-28	1996-05-21	44814724
4813	4813	2007-07-03	2019-05-14	44814724
4827	4827	1949-12-08	2019-04-04	44814724
4816	4816	1981-11-09	2019-03-29	44814724
4900	4900	2004-10-08	2018-11-09	44814724
4860	4860	1978-09-30	2018-10-06	44814724
4842	4842	1990-01-19	2018-08-10	44814724
4833	4833	2003-10-10	2018-12-07	44814724
4810	4810	1985-10-12	2017-01-25	44814724
4801	4801	1971-07-24	2019-03-30	44814724
4823	4823	2004-07-05	2019-06-27	44814724
4828	4828	1967-05-10	2019-05-22	44814724
4859	4859	1954-04-26	2018-08-31	44814724
4848	4848	1952-09-14	2018-10-21	44814724
4838	4838	2007-02-24	2019-03-16	44814724
4845	4845	2000-09-17	2018-09-15	44814724
4830	4830	1983-12-17	2018-06-02	44814724
4821	4821	2014-12-01	2018-11-05	44814724
4803	4803	1986-06-09	2019-02-13	44814724
4808	4808	1978-10-20	2018-10-26	44814724
4847	4847	1943-06-02	2015-04-15	44814724
4836	4836	1997-09-18	2017-10-04	44814724
4850	4850	2012-09-14	2018-09-13	44814724
4857	4857	1985-02-08	2018-05-19	44814724
4841	4841	1989-05-11	2017-05-25	44814724
4834	4834	1960-05-16	2019-02-01	44814724
4852	4852	1947-11-07	2018-10-26	44814724
4863	4863	2018-08-22	2019-05-01	44814724
4824	4824	1987-09-04	2018-11-02	44814724
4819	4819	1959-09-22	2018-11-27	44814724
4805	4805	1962-04-28	2019-02-23	44814724
4814	4814	1935-10-14	2018-08-27	44814724
4861	4861	1946-06-04	2019-05-23	44814724
4854	4854	1985-08-15	2019-04-05	44814724
4832	4832	1998-03-16	2017-05-15	44814724
4843	4843	1962-02-20	2019-02-27	44814724
4812	4812	1954-10-13	2018-09-05	44814724
4807	4807	1945-03-29	2019-05-23	44814724
4817	4817	1985-12-22	1987-08-23	44814724
4826	4826	1951-06-09	2019-06-22	44814724
4898	4898	1953-03-18	2019-06-19	44814724
4905	4905	1972-08-31	2018-09-20	44814724
4927	4927	1977-07-22	2018-06-15	44814724
4916	4916	1977-07-29	2019-06-28	44814724
4883	4883	1945-12-22	2019-06-01	44814724
4888	4888	1993-10-05	2018-12-04	44814724
4878	4878	1963-01-05	2018-07-21	44814724
4869	4869	2003-08-25	2018-10-01	44814724
4918	4918	1994-10-14	2016-12-16	44814724
4925	4925	2000-03-02	2018-12-12	44814724
4907	4907	1946-02-02	2019-06-01	44814724
4896	4896	2008-01-22	2019-02-05	44814724
4871	4871	1986-06-04	2017-08-02	44814724
4876	4876	1972-05-20	2018-07-14	44814724
4890	4890	1919-11-19	2019-01-30	44814724
4881	4881	1948-07-11	2018-11-04	44814724
4865	4865	1974-01-30	2017-08-16	44814724
4874	4874	1968-08-03	2018-08-04	44814724
4892	4892	1986-11-06	2019-05-09	44814724
4887	4887	1989-10-27	2018-07-06	44814724
4912	4912	1992-07-06	2018-04-16	44814724
4923	4923	1968-10-08	2018-10-09	44814724
4909	4909	1975-06-16	2019-02-18	44814724
4902	4902	1992-03-07	2018-12-26	44814724
4885	4885	1983-01-15	2017-10-14	44814724
4894	4894	1995-04-24	2018-03-19	44814724
4872	4872	1914-08-04	2018-12-04	44814724
4867	4867	1913-09-10	2018-10-31	44814724
4946	4946	1983-02-05	2017-08-19	44814724
4911	4911	1994-02-26	2018-06-02	44814724
4921	4921	1990-05-17	2018-10-10	44814724
4914	4914	1999-03-09	2019-02-02	44814724
4889	4889	2013-01-05	2019-05-04	44814724
4882	4882	1979-08-02	2017-04-20	44814724
4868	4868	2007-06-01	2019-06-21	44814724
4879	4879	2014-09-24	2018-06-27	44814724
4904	4904	2004-09-30	2018-11-30	44814724
4899	4899	1920-06-01	1998-11-17	44814724
4917	4917	1982-02-23	2018-10-02	44814724
4926	4926	2004-03-12	2018-12-14	44814724
4877	4877	2017-11-26	2019-05-05	44814724
4870	4870	2014-10-08	2019-06-26	44814724
4880	4880	2009-05-30	2019-05-04	44814724
4891	4891	1995-10-22	2018-06-03	44814724
4924	4924	1977-12-14	2018-06-27	44814724
4919	4919	1978-02-20	2018-02-26	44814724
4897	4897	1988-09-29	2017-09-28	44814724
4906	4906	2013-12-30	2018-12-10	44814724
4922	4922	1976-08-03	2019-04-12	44814724
4913	4913	1969-05-14	2019-05-15	44814724
4903	4903	1989-09-24	2019-05-19	44814724
4908	4908	2012-06-08	2019-05-31	44814724
4875	4875	2004-11-17	2018-11-16	44814724
4864	4864	2011-05-03	2019-04-30	44814724
4886	4886	1965-09-06	2018-12-25	44814724
4893	4893	1987-07-26	2019-03-17	44814724
4910	4910	1994-01-28	2019-04-07	44814724
4901	4901	2018-01-28	2019-04-07	44814724
4915	4915	1982-06-18	2018-07-27	44814724
4920	4920	1996-10-07	2019-03-16	44814724
4895	4895	2013-03-13	2018-10-17	44814724
4884	4884	1972-10-22	2018-11-11	44814724
4866	4866	1997-12-16	2017-11-01	44814724
4873	4873	1976-07-16	2017-12-01	44814724
4948	4948	2000-12-18	2018-10-01	44814724
4959	4959	1984-02-05	2018-03-25	44814724
4937	4937	1995-04-05	2017-07-29	44814724
4930	4930	2017-04-18	2019-03-26	44814724
4965	4965	2008-02-27	2019-03-13	44814724
4974	4974	1990-11-24	2018-08-25	44814724
4984	4984	1983-12-06	2019-04-02	44814724
4979	4979	1976-07-24	2018-08-04	44814724
4928	4928	1986-02-17	2017-07-17	44814724
4939	4939	1999-10-23	2018-12-22	44814724
4957	4957	1971-10-02	2019-06-20	44814724
4950	4950	2007-02-27	2019-03-26	44814724
4977	4977	1959-12-19	2019-05-11	44814724
4986	4986	1950-04-23	2018-08-26	44814724
4972	4972	1951-01-13	2018-12-01	44814724
4967	4967	1961-05-29	2018-12-17	44814724
4983	4983	2007-06-05	2018-11-06	44814724
4988	4988	1953-04-22	2018-07-18	44814724
4970	4970	1923-04-18	2001-09-05	44814724
4961	4961	1991-12-03	2017-09-04	44814724
4934	4934	2000-11-07	2019-04-02	44814724
4941	4941	1970-06-07	1974-03-17	44814724
4955	4955	1994-12-01	2018-09-11	44814724
4944	4944	2013-02-05	2019-01-22	44814724
4963	4963	1973-05-14	2019-06-03	44814724
4968	4968	1983-09-11	2017-11-26	44814724
4990	4990	1962-01-24	2019-03-06	44814724
4981	4981	1974-11-25	2018-12-10	44814724
5054	5054	2011-08-20	2018-08-11	44814724
4953	4953	2010-04-19	2019-03-25	44814724
4943	4943	1961-02-02	2019-05-23	44814724
4932	4932	1957-11-14	2019-04-24	44814724
4975	4975	1959-07-09	2018-09-06	44814724
4964	4964	1960-02-13	2018-12-01	44814724
4978	4978	1981-04-04	2018-06-23	44814724
4985	4985	1980-01-13	1990-09-30	44814724
4958	4958	1964-05-24	1975-03-09	44814724
4949	4949	1972-09-22	2018-10-12	44814724
4931	4931	2001-10-22	2018-10-15	44814724
4936	4936	1998-08-28	2017-10-06	44814724
4987	4987	1959-09-22	2019-06-10	44814724
4976	4976	1912-11-12	1996-04-02	44814724
4966	4966	1981-01-19	2019-02-25	44814724
4973	4973	1998-02-05	2017-06-22	44814724
4938	4938	1994-03-09	2019-05-15	44814724
4929	4929	1961-12-16	2019-01-26	44814724
4951	4951	2002-03-16	2018-08-04	44814724
4956	4956	1986-05-18	2017-10-01	44814724
4940	4940	2000-11-03	2018-09-14	44814724
4935	4935	1964-09-24	2018-12-27	44814724
4945	4945	1954-04-29	2018-07-19	44814724
4954	4954	1993-05-18	2019-02-15	44814724
4989	4989	1989-12-03	2017-12-10	44814724
4982	4982	1999-04-23	2019-05-31	44814724
4960	4960	1909-04-17	1991-10-12	44814724
4971	4971	1934-09-04	2019-04-09	44814724
4952	4952	1970-03-21	2018-04-14	44814724
4947	4947	1995-05-26	2018-10-12	44814724
4933	4933	1970-03-05	2018-03-29	44814724
4942	4942	1954-04-29	2006-08-10	44814724
4969	4969	1982-07-26	2019-03-11	44814724
4962	4962	1999-05-29	2019-05-04	44814724
4980	4980	2000-01-21	2019-05-02	44814724
4991	4991	1971-07-10	2017-07-29	44814724
5048	5048	1958-10-24	2019-05-31	44814724
5043	5043	1973-12-14	2017-10-06	44814724
5029	5029	1990-02-03	2018-05-19	44814724
5038	5038	2013-06-21	2019-06-08	44814724
5001	5001	1959-10-25	2019-01-11	44814724
4994	4994	1997-05-05	2016-08-08	44814724
5012	5012	1997-10-11	2018-10-09	44814724
5023	5023	1972-08-06	2018-03-11	44814724
5036	5036	1989-09-02	2019-06-27	44814724
5031	5031	1920-02-07	2019-05-25	44814724
5041	5041	1970-11-24	2018-06-20	44814724
5050	5050	1988-04-28	2019-06-13	44814724
5021	5021	2012-05-10	2019-02-07	44814724
5014	5014	1912-11-12	1996-06-04	44814724
4992	4992	1985-05-16	2019-05-30	44814724
5003	5003	1988-08-06	2017-02-11	44814724
5019	5019	1978-12-27	2019-01-02	44814724
5008	5008	2008-04-19	2019-06-05	44814724
4998	4998	1964-10-09	2019-04-19	44814724
5005	5005	1973-07-01	2017-12-24	44814724
5034	5034	1922-02-11	1994-03-05	44814724
5025	5025	1986-02-04	2018-11-13	44814724
5047	5047	2009-11-28	2018-10-06	44814724
5052	5052	2011-06-08	2019-01-02	44814724
5007	5007	1983-03-28	2016-07-18	44814724
4996	4996	2003-02-12	2019-05-08	44814724
5010	5010	2017-11-20	2019-04-29	44814724
5017	5017	1980-01-12	2017-09-02	44814724
5064	5064	2008-03-11	2018-10-09	44814724
5045	5045	1960-04-03	2019-05-26	44814724
5027	5027	1983-06-17	2017-10-27	44814724
5032	5032	2019-03-14	2019-06-20	44814724
4995	4995	2017-01-24	2019-01-01	44814724
5000	5000	1938-08-23	2018-08-28	44814724
5022	5022	1968-01-02	2019-01-08	44814724
5013	5013	1964-08-21	2013-06-07	44814724
5042	5042	1984-10-11	2018-11-01	44814724
5049	5049	1962-01-31	2019-02-06	44814724
5039	5039	1974-07-23	2019-02-19	44814724
5028	5028	2010-06-16	2019-05-15	44814724
5015	5015	1968-02-05	2019-02-11	44814724
5020	5020	2017-11-17	2019-04-26	44814724
5002	5002	1976-04-09	2019-05-26	44814724
4993	4993	1996-03-18	2018-11-05	44814724
5030	5030	1978-09-02	2019-06-15	44814724
5037	5037	1977-02-16	2019-02-27	44814724
5051	5051	1977-11-25	2017-12-01	44814724
5040	5040	2019-01-03	2019-06-13	44814724
5024	5024	1986-02-14	2017-11-08	44814724
5035	5035	1930-06-02	2014-10-20	44814724
5053	5053	1945-02-26	2019-01-14	44814724
5046	5046	1958-01-14	2018-07-17	44814724
5009	5009	2003-12-29	2019-02-04	44814724
5018	5018	1939-11-16	2018-12-18	44814724
5004	5004	1977-03-08	2019-03-19	44814724
4999	4999	1956-11-19	2019-01-28	44814724
5044	5044	1972-11-15	2018-12-05	44814724
5055	5055	1998-05-20	2019-06-19	44814724
5033	5033	2019-03-09	2019-06-15	44814724
5026	5026	2009-04-11	2019-04-20	44814724
4997	4997	2008-04-03	2019-04-18	44814724
5006	5006	2005-08-12	2018-09-07	44814724
5016	5016	2012-11-18	2018-07-29	44814724
5011	5011	2016-05-30	2019-05-06	44814724
5070	5070	1992-03-29	2017-05-07	44814724
5061	5061	1982-02-25	2018-09-06	44814724
5075	5075	2009-02-11	2019-02-20	44814724
5080	5080	1999-10-14	2019-01-24	44814724
5119	5119	1962-05-08	2019-06-18	44814724
5108	5108	1961-01-23	2019-02-04	44814724
5090	5090	1997-10-03	2017-11-19	44814724
5097	5097	1967-06-26	2019-05-23	44814724
5082	5082	1994-08-09	2017-03-28	44814724
5073	5073	1935-04-13	2012-06-30	44814724
5063	5063	1941-04-05	2019-03-11	44814724
5068	5068	1931-06-20	2019-01-19	44814724
5099	5099	1943-03-06	2019-03-09	44814724
5088	5088	2005-05-11	2019-02-06	44814724
5110	5110	1992-08-10	2017-11-27	44814724
5117	5117	1958-03-10	2019-05-13	44814724
5101	5101	1956-12-29	2019-01-12	44814724
5094	5094	1978-05-01	2018-05-07	44814724
5104	5104	1979-12-02	2017-10-29	44814724
5115	5115	1996-05-20	2018-10-15	44814724
5084	5084	2014-12-05	2019-05-13	44814724
5079	5079	1966-12-11	2018-12-30	44814724
5057	5057	2004-03-12	2019-04-19	44814724
5066	5066	1967-04-08	2018-10-20	44814724
5113	5113	1969-03-16	2019-05-14	44814724
5106	5106	1981-04-18	2019-06-28	44814724
5092	5092	1985-08-05	2016-09-19	44814724
5103	5103	1943-10-11	2019-03-31	44814724
5150	5150	1939-03-16	2018-07-19	44814724
5059	5059	1998-11-21	2018-10-17	44814724
5077	5077	1965-03-18	2019-06-27	44814724
5086	5086	1969-09-25	2019-06-06	44814724
5109	5109	1983-06-15	2017-11-22	44814724
5118	5118	1967-07-19	2018-12-02	44814724
5096	5096	1967-04-13	2019-04-25	44814724
5091	5091	1999-01-03	2018-04-29	44814724
5060	5060	1972-03-28	2018-06-23	44814724
5071	5071	2018-02-16	2019-04-26	44814724
5081	5081	1913-08-09	2006-11-18	44814724
5074	5074	2002-02-13	2019-04-03	44814724
5089	5089	2009-02-17	2019-05-07	44814724
5098	5098	1988-10-31	2019-04-15	44814724
5116	5116	1964-05-29	2019-06-28	44814724
5111	5111	1945-05-28	1984-12-10	44814724
5072	5072	1993-08-29	2018-11-04	44814724
5083	5083	1947-11-17	2018-08-06	44814724
5069	5069	1985-05-28	2017-08-13	44814724
5062	5062	2010-01-13	2019-04-24	44814724
5078	5078	1911-05-01	2001-10-01	44814724
5085	5085	1976-09-09	2018-09-20	44814724
5067	5067	1974-06-02	2019-05-19	44814724
5056	5056	1938-02-24	2018-09-27	44814724
5095	5095	1965-01-04	2019-05-27	44814724
5100	5100	2002-01-19	2019-04-27	44814724
5114	5114	1990-02-08	2018-11-08	44814724
5105	5105	2004-02-12	2018-11-29	44814724
5058	5058	1937-02-07	2019-03-17	44814724
5065	5065	1969-02-12	2005-03-23	44814724
5087	5087	2015-08-13	2019-01-17	44814724
5076	5076	1938-03-08	2019-06-04	44814724
5107	5107	1975-06-08	2019-05-19	44814724
5112	5112	2010-09-24	2019-02-15	44814724
5102	5102	2007-02-05	2019-02-25	44814724
5093	5093	2011-09-17	2018-12-01	44814724
5144	5144	1937-04-24	2019-04-13	44814724
5139	5139	1986-04-04	1994-09-02	44814724
5125	5125	1990-02-11	2018-05-13	44814724
5134	5134	1982-11-18	2019-03-28	44814724
5161	5161	1994-03-27	2019-06-02	44814724
5154	5154	1994-10-16	2017-09-02	44814724
5172	5172	1945-04-03	2019-05-28	44814724
5183	5183	2004-10-20	2019-01-05	44814724
5132	5132	1966-08-08	2019-06-06	44814724
5127	5127	1965-09-11	2019-03-23	44814724
5137	5137	1967-06-21	2019-04-03	44814724
5146	5146	1946-08-06	2018-11-15	44814724
5181	5181	1995-08-19	2018-06-09	44814724
5174	5174	1937-01-28	2018-10-11	44814724
5152	5152	1970-01-04	2017-07-09	44814724
5163	5163	1997-05-02	2019-06-21	44814724
5179	5179	2009-03-21	2019-03-30	44814724
5168	5168	1971-02-26	2019-03-24	44814724
5158	5158	2006-01-02	2019-01-28	44814724
5165	5165	1963-12-13	2019-01-11	44814724
5130	5130	2013-03-12	2019-01-17	44814724
5121	5121	1964-06-19	2019-01-25	44814724
5143	5143	1958-12-10	2019-03-27	44814724
5148	5148	1960-02-16	2019-02-26	44814724
5167	5167	1997-10-26	2017-09-21	44814724
5156	5156	1997-05-21	2017-08-08	44814724
5170	5170	1968-12-28	2019-01-12	44814724
5177	5177	1995-02-12	2017-11-26	44814724
5224	5224	1981-01-29	2018-09-13	44814724
5141	5141	1993-12-26	2019-06-14	44814724
5123	5123	1979-05-29	2019-06-04	44814724
5128	5128	1926-08-11	2019-06-07	44814724
5155	5155	1978-05-03	2018-10-24	44814724
5160	5160	1989-09-24	2018-11-19	44814724
5182	5182	2015-06-17	2019-05-22	44814724
5173	5173	1993-05-04	2018-09-11	44814724
5138	5138	1977-12-02	2017-12-08	44814724
5145	5145	1955-09-11	2018-09-02	44814724
5135	5135	2006-08-07	2018-08-27	44814724
5124	5124	1985-02-10	2016-10-09	44814724
5175	5175	2000-01-21	2019-06-24	44814724
5180	5180	1998-12-22	2019-03-19	44814724
5162	5162	2008-12-23	2018-07-31	44814724
5153	5153	1944-12-27	2019-05-15	44814724
5126	5126	1977-05-28	2019-01-26	44814724
5133	5133	2007-12-18	2018-10-30	44814724
5147	5147	1986-05-21	2018-12-12	44814724
5136	5136	1975-11-08	2018-07-28	44814724
5120	5120	2005-06-05	2019-06-23	44814724
5131	5131	1980-12-26	2018-01-12	44814724
5149	5149	2002-12-19	2019-01-31	44814724
5142	5142	1945-07-18	2019-06-19	44814724
5169	5169	1953-06-01	2019-01-07	44814724
5178	5178	2000-05-05	2019-05-25	44814724
5164	5164	2014-10-20	2018-09-24	44814724
5159	5159	1983-08-19	2018-03-16	44814724
5140	5140	2003-11-25	2019-01-22	44814724
5151	5151	1956-11-02	2019-02-08	44814724
5129	5129	2017-12-23	2019-06-01	44814724
5122	5122	1987-10-29	2019-03-28	44814724
5157	5157	1963-04-11	2019-05-16	44814724
5166	5166	1952-04-08	2019-06-11	44814724
5176	5176	1993-04-15	2019-06-19	44814724
5171	5171	2013-04-22	2018-12-31	44814724
5230	5230	1945-01-03	2019-01-23	44814724
5221	5221	2003-04-26	2019-06-22	44814724
5235	5235	1922-09-16	1982-01-30	44814724
5240	5240	1939-06-27	2019-03-12	44814724
5215	5215	1940-05-13	2018-10-08	44814724
5204	5204	1982-05-24	2017-01-09	44814724
5186	5186	2000-02-04	2018-10-26	44814724
5193	5193	1960-08-25	2018-10-11	44814724
5242	5242	1962-07-27	2018-08-31	44814724
5233	5233	1956-09-19	2019-04-03	44814724
5223	5223	1968-01-20	2019-01-26	44814724
5228	5228	1935-06-21	2019-06-07	44814724
5195	5195	1960-02-17	2019-05-01	44814724
5184	5184	1964-06-19	2019-04-05	44814724
5206	5206	1976-10-16	2018-10-27	44814724
5213	5213	1938-06-16	2018-11-01	44814724
5197	5197	1953-04-22	2012-05-16	44814724
5190	5190	1956-11-30	2018-10-05	44814724
5200	5200	1955-08-17	2019-04-20	44814724
5211	5211	1991-11-09	2018-10-11	44814724
5244	5244	1989-04-26	2018-01-10	44814724
5239	5239	1965-11-24	2018-12-12	44814724
5217	5217	2003-09-27	2018-09-18	44814724
5226	5226	1998-03-08	2017-03-12	44814724
5209	5209	1991-12-23	2017-02-27	44814724
5202	5202	1974-11-07	2018-11-22	44814724
5188	5188	1995-02-16	2017-04-20	44814724
5199	5199	1962-01-16	2018-08-14	44814724
5252	5252	1957-12-03	2019-06-11	44814724
5219	5219	1983-05-26	2019-04-04	44814724
5237	5237	1988-08-20	2017-12-05	44814724
5246	5246	1998-08-08	2019-05-12	44814724
5205	5205	1987-12-10	2018-09-13	44814724
5214	5214	1987-11-17	2018-11-13	44814724
5192	5192	1983-05-11	2019-06-04	44814724
5187	5187	2000-02-06	2019-04-07	44814724
5220	5220	1999-12-16	2019-04-04	44814724
5231	5231	2003-05-31	2018-07-07	44814724
5241	5241	1962-03-27	2019-05-07	44814724
5234	5234	1936-09-02	2006-07-26	44814724
5185	5185	1935-10-14	2019-02-25	44814724
5194	5194	1945-06-21	2019-04-04	44814724
5212	5212	1990-01-04	2018-11-08	44814724
5207	5207	1956-01-11	2018-10-24	44814724
5232	5232	1967-10-08	2018-10-14	44814724
5243	5243	2008-09-30	2019-05-11	44814724
5229	5229	1961-12-06	2019-01-16	44814724
5222	5222	1917-07-19	2018-08-24	44814724
5238	5238	1996-01-18	2019-02-28	44814724
5245	5245	1973-12-31	2018-01-29	44814724
5227	5227	2013-03-23	2019-03-09	44814724
5216	5216	1976-03-09	2018-04-17	44814724
5191	5191	1970-08-20	2018-09-20	44814724
5196	5196	1951-08-03	2018-11-30	44814724
5210	5210	1971-12-07	2017-12-26	44814724
5201	5201	1978-04-05	2018-04-12	44814724
5218	5218	1981-11-30	2019-01-07	44814724
5225	5225	1986-08-17	2017-07-21	44814724
5247	5247	2010-11-22	2019-04-09	44814724
5236	5236	1971-03-10	2018-08-27	44814724
5203	5203	1935-08-14	2003-03-26	44814724
5208	5208	2018-04-12	2019-06-20	44814724
5198	5198	1994-07-24	2017-08-07	44814724
5189	5189	1955-05-22	2018-08-05	44814724
5250	5250	1978-04-26	2018-09-07	44814724
5257	5257	1978-03-15	2018-03-21	44814724
5279	5279	1946-01-27	2019-06-09	44814724
5268	5268	1965-06-27	2019-06-14	44814724
5299	5299	1971-06-13	2018-12-17	44814724
5304	5304	1985-03-14	2019-05-30	44814724
5294	5294	1999-08-10	2018-12-04	44814724
5285	5285	1942-12-06	2019-06-16	44814724
5270	5270	2001-04-05	2001-11-29	44814724
5277	5277	1955-01-06	2018-07-19	44814724
5259	5259	1958-10-28	2018-12-25	44814724
5248	5248	2000-12-04	2019-01-28	44814724
5287	5287	2010-03-27	2019-03-30	44814724
5292	5292	1988-03-02	2018-01-31	44814724
5306	5306	1969-01-19	2019-01-20	44814724
5297	5297	2016-12-18	2019-05-26	44814724
5281	5281	1994-04-01	2019-02-06	44814724
5290	5290	1953-11-06	2018-08-17	44814724
5308	5308	2003-10-27	2018-12-24	44814724
5303	5303	2017-02-19	2019-01-27	44814724
5264	5264	1967-11-01	2019-01-26	44814724
5275	5275	2010-10-20	2018-10-17	44814724
5261	5261	2005-10-22	2018-11-24	44814724
5254	5254	1987-05-21	2018-08-02	44814724
5301	5301	1920-07-30	2003-05-09	44814724
5310	5310	2017-09-07	2019-02-14	44814724
5288	5288	1997-09-11	2019-03-20	44814724
5283	5283	1972-09-05	2018-05-01	44814724
5263	5263	2005-07-30	2019-06-15	44814724
5273	5273	2000-10-06	2019-05-03	44814724
5266	5266	2010-03-08	2019-05-13	44814724
5305	5305	1999-02-28	2018-11-06	44814724
5298	5298	1940-04-28	2018-09-02	44814724
5284	5284	1966-08-24	2018-09-05	44814724
5295	5295	1909-09-29	2002-05-15	44814724
5256	5256	1959-11-13	2018-10-26	44814724
5251	5251	1922-02-27	1980-03-17	44814724
5269	5269	2011-09-17	2018-09-08	44814724
5278	5278	1969-05-09	2019-06-14	44814724
5293	5293	2013-05-27	2019-05-13	44814724
5286	5286	2004-01-31	2019-06-15	44814724
5296	5296	1993-10-23	2019-02-23	44814724
5307	5307	2003-06-13	2018-07-20	44814724
5276	5276	1958-01-19	2018-09-30	44814724
5271	5271	2015-01-17	2018-12-22	44814724
5249	5249	1948-09-06	2018-07-30	44814724
5258	5258	1958-07-30	2019-03-27	44814724
5274	5274	1952-04-06	2019-01-13	44814724
5265	5265	1968-02-22	2019-01-03	44814724
5255	5255	1959-12-24	2018-06-28	44814724
5260	5260	2011-04-01	2019-03-22	44814724
5291	5291	1975-10-19	2018-02-04	44814724
5280	5280	2001-12-30	2018-10-21	44814724
5302	5302	1971-09-04	2018-09-08	44814724
5309	5309	1951-01-30	2019-05-14	44814724
5262	5262	1971-01-04	2018-09-17	44814724
5253	5253	1955-12-11	2019-05-26	44814724
5267	5267	1966-12-04	2018-12-16	44814724
5272	5272	1916-07-19	2018-12-05	44814724
5311	5311	1988-12-23	2017-10-27	44814724
5300	5300	1940-12-27	2018-08-24	44814724
5282	5282	2011-06-13	2019-06-10	44814724
5289	5289	2018-10-15	2019-06-24	44814724
5317	5317	1972-12-06	2018-09-26	44814724
5326	5326	2018-01-30	2019-04-09	44814724
5336	5336	1994-08-30	2018-05-22	44814724
5331	5331	1963-07-31	2018-09-05	44814724
5329	5329	1942-12-23	2018-06-27	44814724
5338	5338	1995-02-10	2017-06-09	44814724
5324	5324	1979-03-13	2018-08-21	44814724
5319	5319	2001-06-19	2018-08-07	44814724
5335	5335	1958-08-22	2019-03-18	44814724
5340	5340	1980-05-15	2018-11-01	44814724
5322	5322	1947-01-22	2018-07-25	44814724
5313	5313	1999-03-08	2018-04-16	44814724
5315	5315	1916-06-18	1979-04-22	44814724
5320	5320	2007-09-27	2018-10-11	44814724
5342	5342	1984-09-22	2016-08-27	44814724
5333	5333	1949-07-04	2002-11-18	44814724
5327	5327	1979-03-10	2019-03-16	44814724
5316	5316	1956-08-20	2018-09-24	44814724
5330	5330	1987-03-22	2018-06-10	44814724
5337	5337	1970-02-23	2018-03-19	44814724
5339	5339	2006-08-06	2018-08-26	44814724
5328	5328	1909-09-29	2019-06-27	44814724
5318	5318	1994-11-22	2018-12-07	44814724
5325	5325	1946-01-06	2019-03-17	44814724
5341	5341	2012-11-20	2018-12-16	44814724
5334	5334	1964-02-19	2018-12-19	44814724
5312	5312	1938-10-31	2007-02-05	44814724
5323	5323	1987-04-14	2019-02-19	44814724
5321	5321	1990-11-19	2019-04-21	44814724
5314	5314	1950-11-24	2019-04-05	44814724
5332	5332	1956-12-17	1993-09-13	44814724
5343	5343	1983-01-02	2018-03-11	44814724
\.


--
-- TOC entry 3908 (class 0 OID 3185577)
-- Dependencies: 230
-- Data for Name: payer_plan_period; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".payer_plan_period (payer_plan_period_id, person_id, payer_plan_period_start_date, payer_plan_period_end_date, payer_concept_id, payer_source_value, payer_source_concept_id, plan_concept_id, plan_source_value, plan_source_concept_id, sponsor_concept_id, sponsor_source_value, sponsor_source_concept_id, family_source_value, stop_reason_concept_id, stop_reason_source_value, stop_reason_source_concept_id) FROM stdin;
\.


--
-- TOC entry 3909 (class 0 OID 3185580)
-- Dependencies: 231
-- Data for Name: person; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".person (person_id, gender_concept_id, year_of_birth, month_of_birth, day_of_birth, birth_datetime, race_concept_id, ethnicity_concept_id, location_id, provider_id, care_site_id, person_source_value, gender_source_value, gender_source_concept_id, race_source_value, race_source_concept_id, ethnicity_source_value, ethnicity_source_concept_id) FROM stdin;
6	8532	1963	12	31	1963-12-31 00:00:00	8516	0	\N	\N	\N	001f4a87-70d0-435c-a4b9-1425f6928d33	F	0	black	0	west_indian	0
123	8507	1950	4	12	1950-04-12 00:00:00	8527	0	\N	\N	\N	052d9254-80e8-428f-b8b6-69518b0ef3f3	M	0	white	0	italian	0
129	8507	1974	10	7	1974-10-07 00:00:00	8527	0	\N	\N	\N	054d32d5-904f-4df4-846b-8c08d165b4e9	M	0	white	0	polish	0
16	8532	1971	10	13	1971-10-13 00:00:00	8527	0	\N	\N	\N	00444703-f2c9-45c9-a247-f6317a43a929	F	0	white	0	american	0
65	8532	1967	3	31	1967-03-31 00:00:00	8516	0	\N	\N	\N	02a3dad9-f9d5-42fb-8074-c16d45b4f5c8	F	0	black	0	dominican	0
74	8532	1972	1	5	1972-01-05 00:00:00	8527	0	\N	\N	\N	02fbf1be-29b7-4da8-8bbd-14c7433f843f	F	0	white	0	english	0
42	8532	1909	11	2	1909-11-02 00:00:00	8527	0	\N	\N	\N	0177d2e0-98f5-4f3d-bcfd-497b7a07b3f8	F	0	white	0	irish	0
187	8507	1945	7	23	1945-07-23 00:00:00	8527	0	\N	\N	\N	07a1e14d-73ed-4d3a-9a39-d729745773fa	M	0	white	0	irish	0
18	8532	1965	11	17	1965-11-17 00:00:00	8527	0	\N	\N	\N	0084b0fe-e30f-4930-b6d1-5e1eff4b7dea	F	0	white	0	english	0
111	8532	1975	5	2	1975-05-02 00:00:00	8527	0	\N	\N	\N	0478d6b3-bdb3-4574-9b93-cf448d725b84	F	0	white	0	english	0
149	8532	1941	8	19	1941-08-19 00:00:00	8515	0	\N	\N	\N	06134cd3-dd33-4d2a-ab93-098302b252dc	F	0	asian	0	chinese	0
114	8532	1972	3	13	1972-03-13 00:00:00	8527	0	\N	\N	\N	0495df04-eb88-4f85-82b3-6ecae39bad2f	F	0	white	0	german	0
35	8532	1960	3	22	1960-03-22 00:00:00	8527	0	\N	\N	\N	01304e75-3214-4ca9-8694-8884e85b2455	F	0	white	0	irish	0
40	8507	1951	12	5	1951-12-05 00:00:00	8527	0	\N	\N	\N	0164dcad-518f-4181-bf64-5d8e7b47a90c	M	0	white	0	french_canadian	0
72	8532	1947	7	14	1947-07-14 00:00:00	8527	0	\N	\N	\N	02d4e2db-1544-455a-9b13-6751f8e65883	F	0	white	0	irish	0
53	8507	1962	8	15	1962-08-15 00:00:00	8527	0	\N	\N	\N	02101f8b-9338-487e-a24f-0a5d9298c089	M	0	white	0	italian	0
191	8532	1920	6	1	1920-06-01 00:00:00	8527	0	\N	\N	\N	07c1a30a-11be-4cec-b965-bfcd97054d15	F	0	white	0	irish	0
180	8532	1977	4	21	1977-04-21 00:00:00	8527	0	\N	\N	\N	0745e4d2-10e6-44a6-9f3c-debf4addc208	F	0	white	0	irish	0
78	8507	1967	1	5	1967-01-05 00:00:00	8527	0	\N	\N	\N	0316bdaa-b4e1-40c4-9b7f-37791f787de0	M	0	white	0	italian	0
69	8507	1943	10	27	1943-10-27 00:00:00	8515	0	\N	\N	\N	02b89823-8be1-4d2e-8233-95aca701c45d	M	0	asian	0	chinese	0
248	8507	1972	8	1	1972-08-01 00:00:00	8527	0	\N	\N	\N	0b25e7c4-c964-415c-a0ff-8665136240cd	M	0	white	0	english	0
105	8507	1965	6	11	1965-06-11 00:00:00	8527	0	\N	\N	\N	0457212b-9952-4432-ab04-0b4e2fb24361	M	0	white	0	polish	0
9	8532	1978	7	20	1978-07-20 00:00:00	8516	0	\N	\N	\N	002805e7-7624-4cb7-b68d-e8ac92f61ff9	F	0	black	0	dominican	0
2	8532	1920	6	1	1920-06-01 00:00:00	8527	0	\N	\N	\N	00093765-abef-4a56-9280-8f92422afae7	F	0	white	0	irish	0
49	8507	1972	11	4	1972-11-04 00:00:00	8527	0	\N	\N	\N	01c99d51-f490-4fad-af2c-3f57025cbc29	M	0	white	0	italian	0
160	8532	1961	7	27	1961-07-27 00:00:00	0	38003563	\N	\N	\N	0681bc75-74de-4010-9d5e-060871641c2d	F	0	hispanic	0	puerto_rican	0
90	8532	1961	2	21	1961-02-21 00:00:00	8527	0	\N	\N	\N	0382e92d-6ba7-444b-b076-4ba5f8caabb6	F	0	white	0	italian	0
81	8507	1956	3	21	1956-03-21 00:00:00	8516	0	\N	\N	\N	03324a7e-e25d-4a11-9b1c-7df069daed9c	M	0	black	0	dominican	0
154	8532	1974	11	21	1974-11-21 00:00:00	8527	0	\N	\N	\N	064d241f-0fcc-4065-81c6-c68e8cff5b70	F	0	white	0	english	0
11	8507	1953	2	3	1953-02-03 00:00:00	8527	0	\N	\N	\N	0029df47-1263-4576-8ca3-4615adb7dd7a	M	0	white	0	english	0
135	8532	1971	6	15	1971-06-15 00:00:00	8527	0	\N	\N	\N	057a89a4-9a10-4ac9-99d7-b4aa9cd47f81	F	0	white	0	english	0
96	8507	1924	12	27	1924-12-27 00:00:00	8527	0	\N	\N	\N	03d98b42-14ac-40b8-ad04-4c527a350667	M	0	white	0	italian	0
61	8532	1968	1	21	1968-01-21 00:00:00	8527	0	\N	\N	\N	026f7567-c1bc-4f54-995f-10b30dc211f4	F	0	white	0	french	0
64	8532	1974	10	23	1974-10-23 00:00:00	8527	0	\N	\N	\N	028b1481-fd5b-4010-8b16-d0f57171950a	F	0	white	0	french	0
32	8507	1943	10	27	1943-10-27 00:00:00	8515	0	\N	\N	\N	011ad234-9df9-40e9-91c1-80211b4a7bc8	M	0	asian	0	chinese	0
43	8532	1956	12	17	1956-12-17 00:00:00	0	38003563	\N	\N	\N	017b16a2-a179-42be-9380-4d5594015b5c	F	0	hispanic	0	mexican	0
12	8532	1963	1	30	1963-01-30 00:00:00	8527	0	\N	\N	\N	0030eb48-316c-4250-907f-a272909ff8b9	F	0	white	0	irish	0
7	8532	1968	11	6	1968-11-06 00:00:00	0	38003563	\N	\N	\N	00211cd2-f171-45d9-a7c6-ea8ac6d28d09	F	0	hispanic	0	central_american	0
17	8532	1950	12	11	1950-12-11 00:00:00	8527	0	\N	\N	\N	005823a2-895f-4af4-afc8-81ab84059889	F	0	white	0	irish	0
246	8507	1959	11	26	1959-11-26 00:00:00	8527	0	\N	\N	\N	0af8ac13-73e2-4d27-a519-ca54a5e604d8	M	0	white	0	french	0
41	8507	1973	5	26	1973-05-26 00:00:00	8516	0	\N	\N	\N	01747c2b-c70e-4ce8-bf0c-fee20d3ba4a8	M	0	black	0	west_indian	0
84	8532	1974	3	14	1974-03-14 00:00:00	8527	0	\N	\N	\N	03509121-9c40-4245-b13f-181d5fdaafcc	F	0	white	0	italian	0
66	8532	1958	6	27	1958-06-27 00:00:00	8527	0	\N	\N	\N	02aa6ff1-b19f-4794-9ece-a3e93129029c	F	0	white	0	german	0
63	8532	1955	12	14	1955-12-14 00:00:00	8527	0	\N	\N	\N	028aadd2-a214-4c7c-88a3-6aafefcd93f6	F	0	white	0	greek	0
110	8532	1976	2	15	1976-02-15 00:00:00	8527	0	\N	\N	\N	04759b7e-82e8-428a-9fbe-87346ff4e4c0	F	0	white	0	english	0
19	8532	1949	1	30	1949-01-30 00:00:00	0	38003563	\N	\N	\N	0088faee-d229-448d-adbb-e84ff92aba1c	F	0	hispanic	0	mexican	0
5	8507	1968	7	24	1968-07-24 00:00:00	8515	0	\N	\N	\N	00196a95-1567-41f8-b608-18e6295b4c1e	M	0	asian	0	chinese	0
120	8507	1978	1	7	1978-01-07 00:00:00	8527	0	\N	\N	\N	04e91b17-3e46-4db5-8c8f-0f3a6e4162f8	M	0	white	0	italian	0
30	8532	1970	8	15	1970-08-15 00:00:00	8527	0	\N	\N	\N	00fdac01-f3ab-4a6c-ac65-8cdc2db83814	F	0	white	0	italian	0
99	8532	1958	10	25	1958-10-25 00:00:00	8516	0	\N	\N	\N	03f88864-c070-43d1-8aed-8219cf34e280	F	0	black	0	west_indian	0
3	8507	1916	1	3	1916-01-03 00:00:00	8527	0	\N	\N	\N	000cb58f-523d-49a2-a05e-de1e93f35c01	M	0	white	0	french_canadian	0
126	8507	1947	7	21	1947-07-21 00:00:00	8527	0	\N	\N	\N	053f7c53-ec1e-4497-af24-984b2871bb9d	M	0	white	0	polish	0
181	8532	1973	9	16	1973-09-16 00:00:00	8527	0	\N	\N	\N	075cbb91-fb3b-45ba-be65-23f227afbe38	F	0	white	0	irish	0
36	8532	1958	10	21	1958-10-21 00:00:00	8527	0	\N	\N	\N	013ffde8-ac7d-4607-959c-66715d574c7c	F	0	white	0	german	0
222	8532	1951	9	14	1951-09-14 00:00:00	8527	0	\N	\N	\N	091332e3-b618-4511-a536-4570526437f1	F	0	white	0	irish	0
57	8507	1961	6	19	1961-06-19 00:00:00	8527	0	\N	\N	\N	022bfb02-912a-44a4-a857-bc52290fbd94	M	0	white	0	french	0
124	8532	1984	3	5	1984-03-05 00:00:00	8527	0	\N	\N	\N	05393fff-3697-4a1c-aa4a-45abd9bf54ae	F	0	white	0	polish	0
1	8507	1949	1	27	1949-01-27 00:00:00	8527	0	\N	\N	\N	000728a7-80de-420a-9286-2c20e81cb7b8	M	0	white	0	italian	0
23	8507	1978	9	7	1978-09-07 00:00:00	8515	0	\N	\N	\N	00badc72-67b3-41b8-82c3-781e775c026e	M	0	asian	0	chinese	0
28	8507	1979	10	31	1979-10-31 00:00:00	0	38003563	\N	\N	\N	00fb4ef9-47c6-4e09-a095-effacf18d0bf	M	0	hispanic	0	mexican	0
161	8507	1977	12	25	1977-12-25 00:00:00	8515	0	\N	\N	\N	0695b20b-6258-4a5f-9493-c8a1ee495b5a	M	0	asian	0	chinese	0
70	8507	1948	4	11	1948-04-11 00:00:00	8527	0	\N	\N	\N	02c9e004-15eb-41f0-95c3-38e82af0b079	M	0	white	0	german	0
38	8532	1965	2	9	1965-02-09 00:00:00	8527	0	\N	\N	\N	015659e6-78b7-4afc-ba24-a537958bf2fb	F	0	white	0	french_canadian	0
183	8507	1974	10	24	1974-10-24 00:00:00	0	0	\N	\N	\N	076bbf0d-ab79-4ddd-84da-ab874307314d	M	0	native	0	american_indian	0
156	8532	1978	10	22	1978-10-22 00:00:00	8515	0	\N	\N	\N	0655078f-59d7-4431-ae08-a1d01301f49f	F	0	asian	0	chinese	0
225	8532	1965	1	4	1965-01-04 00:00:00	8527	0	\N	\N	\N	095dcc6d-781d-4eab-8712-50ec922e19d9	F	0	white	0	italian	0
292	8507	1975	12	13	1975-12-13 00:00:00	8527	0	\N	\N	\N	0d1fbda9-c84e-4609-9297-08244edf6259	M	0	white	0	irish	0
102	8532	1972	6	25	1972-06-25 00:00:00	8515	0	\N	\N	\N	0447f79b-c553-44be-a4f1-2f5e547c4b54	F	0	asian	0	chinese	0
173	8507	1968	3	24	1968-03-24 00:00:00	8527	0	\N	\N	\N	0703051a-4b41-458d-a1c1-7d284c958356	M	0	white	0	irish	0
409	8532	1950	10	6	1950-10-06 00:00:00	8527	0	\N	\N	\N	125b7c8f-b8fe-4dc7-b7bd-6be83db010c1	F	0	white	0	irish	0
176	8507	1964	11	25	1964-11-25 00:00:00	8527	0	\N	\N	\N	071dae97-e378-4ac0-ba3b-1fb6aae3a012	M	0	white	0	polish	0
286	8532	1928	5	5	1928-05-05 00:00:00	8527	0	\N	\N	\N	0cd030e6-702a-49b3-9c6b-026dccfad5b0	F	0	white	0	american	0
254	8507	1950	9	22	1950-09-22 00:00:00	8527	0	\N	\N	\N	0b94ecfd-f4df-47a7-81a3-d6883c299644	M	0	white	0	italian	0
245	8507	1916	6	18	1916-06-18 00:00:00	8527	0	\N	\N	\N	0ae559f4-1fc5-407f-a38c-95098db17bc4	M	0	white	0	scottish	0
227	8532	1971	9	17	1971-09-17 00:00:00	8516	0	\N	\N	\N	096dad58-446a-491d-b6d3-31c1b54ad7c5	F	0	black	0	dominican	0
158	8507	1947	1	4	1947-01-04 00:00:00	8527	0	\N	\N	\N	066ed130-1abf-4b2b-b9aa-c5a6d2cdb858	M	0	white	0	english	0
185	8507	1946	5	12	1946-05-12 00:00:00	8527	0	\N	\N	\N	078d48f8-e9f3-467a-82f3-409c909ead14	M	0	white	0	german	0
94	8507	1952	3	28	1952-03-28 00:00:00	8527	0	\N	\N	\N	03c03048-9469-407f-9f08-9b009979cba4	M	0	white	0	scottish	0
164	8532	1966	1	3	1966-01-03 00:00:00	8516	0	\N	\N	\N	06b54ac0-fb44-41fa-b8ce-6144ee676b00	F	0	black	0	dominican	0
67	8507	1970	10	18	1970-10-18 00:00:00	0	38003563	\N	\N	\N	02ac2ac1-d4d6-4260-bda9-3b386a9d4163	M	0	hispanic	0	central_american	0
364	8507	1945	9	30	1945-09-30 00:00:00	8527	0	\N	\N	\N	10061eb2-3b86-4856-8f73-48964910675d	M	0	white	0	irish	0
194	8507	1980	3	20	1980-03-20 00:00:00	8527	0	\N	\N	\N	07d2ff84-7a25-412d-a282-67b4acf58bdc	M	0	white	0	italian	0
162	8532	1938	11	22	1938-11-22 00:00:00	8527	0	\N	\N	\N	06ae6dc0-d5d6-46ea-bc77-58111d998aa9	F	0	white	0	polish	0
268	8507	1967	2	21	1967-02-21 00:00:00	8527	0	\N	\N	\N	0c15ddbf-f8bc-4a27-9935-6fd13dde5c37	M	0	white	0	german	0
299	8532	1961	12	9	1961-12-09 00:00:00	8527	0	\N	\N	\N	0d74b50a-a0e6-4ef1-be9c-e646519b3066	F	0	white	0	german	0
133	8507	1980	12	15	1980-12-15 00:00:00	8527	0	\N	\N	\N	055e9e89-29fe-431b-9e52-d166897cbcc6	M	0	white	0	polish	0
310	8507	1949	6	18	1949-06-18 00:00:00	0	38003563	\N	\N	\N	0de96179-386d-4cd2-a3c5-6ce5a74ca035	M	0	hispanic	0	south_american	0
116	8532	1926	11	7	1926-11-07 00:00:00	0	38003563	\N	\N	\N	04aa195a-044f-41a2-b226-51f6cc41077c	F	0	hispanic	0	puerto_rican	0
171	8507	1968	3	10	1968-03-10 00:00:00	8527	0	\N	\N	\N	06ed108a-05d4-472f-bd1b-122d6bcc3045	M	0	white	0	american	0
371	8532	1968	2	1	1968-02-01 00:00:00	8527	0	\N	\N	\N	10281498-62e7-4ee5-a6af-35a41b4956b0	F	0	white	0	scottish	0
182	8507	1950	9	10	1950-09-10 00:00:00	8527	0	\N	\N	\N	0768ad1e-1969-4b40-a5ab-724760134faa	M	0	white	0	english	0
189	8507	1958	5	11	1958-05-11 00:00:00	0	38003563	\N	\N	\N	07b3c77f-8c60-4c7d-aa3d-cfed7e88e401	M	0	hispanic	0	puerto_rican	0
236	8532	1951	3	22	1951-03-22 00:00:00	8527	0	\N	\N	\N	0a22b5e7-5834-496a-a387-251f20dc9ea1	F	0	white	0	italian	0
145	8532	1948	11	30	1948-11-30 00:00:00	8527	0	\N	\N	\N	05e81ed0-d662-48b7-b7d8-ea9b72255310	F	0	white	0	french	0
340	8507	1958	5	14	1958-05-14 00:00:00	0	38003563	\N	\N	\N	0f0b92fa-f7ef-4396-b5fe-007b24e42422	M	0	hispanic	0	puerto_rican	0
140	8532	1969	6	5	1969-06-05 00:00:00	8515	0	\N	\N	\N	05ab8c5a-d21e-415a-89aa-8bf926957be4	F	0	asian	0	chinese	0
209	8532	1951	2	23	1951-02-23 00:00:00	8527	0	\N	\N	\N	0887468f-d5c2-4601-9195-579190e33149	F	0	white	0	italian	0
403	8507	1922	2	27	1922-02-27 00:00:00	8527	0	\N	\N	\N	1204032b-20a0-4f84-bbdd-19144f1c8065	M	0	white	0	polish	0
86	8507	1947	10	27	1947-10-27 00:00:00	0	38003563	\N	\N	\N	0357baaa-c90b-419d-91b9-50ea45b2551f	M	0	hispanic	0	south_american	0
177	8532	1966	4	25	1966-04-25 00:00:00	0	38003563	\N	\N	\N	0729671d-4b9e-4d3b-957a-7c4024fa29e7	F	0	hispanic	0	puerto_rican	0
224	8532	1942	10	13	1942-10-13 00:00:00	8527	0	\N	\N	\N	09405fbf-1d25-4244-9347-2608076090f0	F	0	white	0	swedish	0
235	8507	1981	5	11	1981-05-11 00:00:00	0	38003563	\N	\N	\N	0a1f77c2-b916-4ddb-963c-e0674376dbf5	M	0	hispanic	0	puerto_rican	0
103	8532	1967	5	28	1967-05-28 00:00:00	8516	0	\N	\N	\N	044daa93-012a-4b00-9e65-2ba9d8b78e26	F	0	black	0	dominican	0
293	8507	1964	10	13	1964-10-13 00:00:00	8527	0	\N	\N	\N	0d253900-d31a-45ab-912b-0c12cf869248	M	0	white	0	german	0
95	8507	1957	8	29	1957-08-29 00:00:00	8527	0	\N	\N	\N	03c21fcc-24e7-45bf-a8fd-a1ba4560e896	M	0	white	0	french_canadian	0
184	8532	1946	1	28	1946-01-28 00:00:00	8527	0	\N	\N	\N	077edadc-4a80-4a43-b6d1-e7539dd6f1d9	F	0	white	0	irish	0
487	8532	1965	5	19	1965-05-19 00:00:00	0	38003563	\N	\N	\N	16267b23-069c-4747-8d49-e907d445a3f2	F	0	hispanic	0	puerto_rican	0
165	8532	1968	6	12	1968-06-12 00:00:00	0	38003563	\N	\N	\N	06b5d964-08e7-46c7-91ee-838d5256d904	F	0	hispanic	0	mexican	0
244	8507	1922	2	27	1922-02-27 00:00:00	8527	0	\N	\N	\N	0ab5499d-9bf5-4114-b93d-e7e60e0f5e4e	M	0	white	0	polish	0
101	8507	1926	11	19	1926-11-19 00:00:00	8527	0	\N	\N	\N	0405f94b-17c8-4746-9469-57b13854d58c	M	0	white	0	german	0
115	8532	1959	11	1	1959-11-01 00:00:00	0	38003563	\N	\N	\N	04999e9d-fa37-4050-970c-971ccfb6eacd	F	0	hispanic	0	puerto_rican	0
148	8532	1978	10	15	1978-10-15 00:00:00	8516	0	\N	\N	\N	060cda84-df43-4b5b-8b5a-ed772b7ff199	F	0	black	0	african	0
289	8532	1959	3	16	1959-03-16 00:00:00	8527	0	\N	\N	\N	0ceabc2c-47d7-4e2b-8a2f-e2a2c11c644b	F	0	white	0	italian	0
143	8507	1964	11	1	1964-11-01 00:00:00	8527	0	\N	\N	\N	05c46a0c-482d-4612-85ae-3abf66dba4bd	M	0	white	0	polish	0
117	8507	1968	10	5	1968-10-05 00:00:00	0	38003563	\N	\N	\N	04ab9630-85fa-4f3e-bc8f-7a0b97631c43	M	0	hispanic	0	puerto_rican	0
311	8507	1977	7	26	1977-07-26 00:00:00	8527	0	\N	\N	\N	0df243a8-c3ce-4628-8fd8-956bd318c11c	M	0	white	0	irish	0
195	8507	1958	3	17	1958-03-17 00:00:00	8527	0	\N	\N	\N	07e72c4d-c65f-4f47-871e-e3dd78943e94	M	0	white	0	american	0
82	8532	1961	3	21	1961-03-21 00:00:00	8527	0	\N	\N	\N	0345d67f-6620-4cae-9c55-dfe6f3f38664	F	0	white	0	italian	0
379	8532	1975	3	29	1975-03-29 00:00:00	8527	0	\N	\N	\N	109f862e-47bd-43cb-9a1b-44d4ddfe3330	F	0	white	0	irish	0
79	8532	1946	4	25	1946-04-25 00:00:00	8527	0	\N	\N	\N	0317eeb0-791c-49aa-9e6f-8c2cacc5bd49	F	0	white	0	french_canadian	0
144	8532	1974	12	20	1974-12-20 00:00:00	8527	0	\N	\N	\N	05d55ec5-6a42-4fdd-92fa-83419881dd4e	F	0	white	0	irish	0
119	8532	1955	12	27	1955-12-27 00:00:00	0	38003563	\N	\N	\N	04d91a07-9648-4afb-a21f-93beb06035d8	F	0	hispanic	0	puerto_rican	0
97	8532	1943	7	19	1943-07-19 00:00:00	8527	0	\N	\N	\N	03e71f42-db33-40c1-8c73-e4095fd94f5e	F	0	white	0	scottish	0
341	8532	1960	7	11	1960-07-11 00:00:00	8527	0	\N	\N	\N	0f133dd7-4012-4aa3-b488-17c0ae83ba40	F	0	white	0	portuguese	0
260	8507	1969	7	12	1969-07-12 00:00:00	8527	0	\N	\N	\N	0bc075b1-9aea-4324-bc84-a6ce2172e808	M	0	white	0	irish	0
170	8532	1971	2	4	1971-02-04 00:00:00	8527	0	\N	\N	\N	06ec724a-de27-4cb7-bd12-1bd1489c7d05	F	0	white	0	german	0
80	8507	1936	11	9	1936-11-09 00:00:00	8527	0	\N	\N	\N	031a9119-07af-4379-bb20-1b083372f664	M	0	white	0	russian	0
392	8507	1975	7	4	1975-07-04 00:00:00	8527	0	\N	\N	\N	118be12f-7f59-493f-8986-9066e696b92d	M	0	white	0	american	0
335	8507	1963	6	18	1963-06-18 00:00:00	8527	0	\N	\N	\N	0edfa083-b3ce-4f1e-9aec-256c316cb002	M	0	white	0	english	0
526	8532	1971	2	24	1971-02-24 00:00:00	0	38003563	\N	\N	\N	181ae005-b1d8-41ea-a7ba-1f35e0a886de	F	0	hispanic	0	central_american	0
338	8532	1967	4	19	1967-04-19 00:00:00	8527	0	\N	\N	\N	0ef2e01f-4ad7-4dde-9733-3ed9f97b10b5	F	0	white	0	irish	0
437	8532	1946	2	12	1946-02-12 00:00:00	8527	0	\N	\N	\N	13befa8b-bbc1-4229-8b5e-1ecbfb65cb21	F	0	white	0	english	0
219	8507	1968	3	30	1968-03-30 00:00:00	8527	0	\N	\N	\N	08f27631-173b-47e1-bdef-4a7b9cd1665f	M	0	white	0	italian	0
495	8507	1968	5	18	1968-05-18 00:00:00	8527	0	\N	\N	\N	16b29998-d142-4528-beb1-800cf39a2bac	M	0	white	0	portuguese	0
277	8507	1963	12	31	1963-12-31 00:00:00	8527	0	\N	\N	\N	0c6c0bad-dab9-4689-ab9a-469664840b28	M	0	white	0	polish	0
388	8507	1954	9	14	1954-09-14 00:00:00	8527	0	\N	\N	\N	11380a4f-cf56-4b0a-a254-c977477a1d65	M	0	white	0	irish	0
347	8507	1969	10	19	1969-10-19 00:00:00	8527	0	\N	\N	\N	0f512c79-37e9-4af7-bf12-6538aedbaba7	M	0	white	0	irish	0
458	8532	1972	8	13	1972-08-13 00:00:00	0	38003563	\N	\N	\N	14bbbe6a-6dd0-4df7-aa8b-29b96e529311	F	0	hispanic	0	puerto_rican	0
304	8507	1956	5	7	1956-05-07 00:00:00	8527	0	\N	\N	\N	0da7cc42-5716-470b-b4a0-c5e854fd5254	M	0	white	0	italian	0
232	8507	1944	11	1	1944-11-01 00:00:00	8527	0	\N	\N	\N	09d0ca1f-44e1-49be-84de-30be0b8cb58a	M	0	white	0	english	0
207	8507	1940	10	20	1940-10-20 00:00:00	8527	0	\N	\N	\N	087339f4-536e-488d-8f2d-da9f975a0ecf	M	0	white	0	irish	0
196	8532	1954	10	16	1954-10-16 00:00:00	8516	0	\N	\N	\N	07f7bdf6-0ed7-43b0-98cd-f62c176ec5e9	F	0	black	0	dominican	0
411	8507	1959	2	21	1959-02-21 00:00:00	8527	0	\N	\N	\N	1269ba45-ed99-497e-ab5d-834a878c2ed1	M	0	white	0	french	0
217	8507	1975	4	8	1975-04-08 00:00:00	8527	0	\N	\N	\N	08d25c4f-ceeb-48e9-8119-fe70667f09ab	M	0	white	0	italian	0
384	8532	1960	5	30	1960-05-30 00:00:00	8527	0	\N	\N	\N	10ea6b6e-08ff-4a3c-bfaf-8f0fd4350220	F	0	white	0	french_canadian	0
273	8507	1975	9	14	1975-09-14 00:00:00	8515	0	\N	\N	\N	0c3de049-7b7f-4ddd-8a60-54991e8e8ee9	M	0	asian	0	chinese	0
212	8532	1970	3	21	1970-03-21 00:00:00	8516	0	\N	\N	\N	089f1a43-d8da-4007-b93a-d8833d9d52c1	F	0	black	0	african	0
406	8507	1952	2	19	1952-02-19 00:00:00	8527	0	\N	\N	\N	12322c9d-3696-44ff-be12-14d7dba422f4	M	0	white	0	italian	0
349	8532	1957	8	31	1957-08-31 00:00:00	8516	0	\N	\N	\N	0f59613a-6cdb-4432-bea2-7b8daaef420f	F	0	black	0	african	0
442	8532	1947	8	23	1947-08-23 00:00:00	8527	0	\N	\N	\N	13ec441f-b909-4d43-a3b9-534bdb8e047f	F	0	white	0	scottish	0
320	8532	1956	2	19	1956-02-19 00:00:00	8527	0	\N	\N	\N	0e8e7fee-aeb7-43cb-beb6-90398ca49be3	F	0	white	0	italian	0
152	8532	1966	10	31	1966-10-31 00:00:00	8527	0	\N	\N	\N	0631f7f9-2de5-49c0-bcd2-b6f56c5373e9	F	0	white	0	polish	0
270	8507	1958	2	4	1958-02-04 00:00:00	8515	0	\N	\N	\N	0c2488eb-26b5-4acb-8187-dd6cb60ded76	M	0	asian	0	chinese	0
489	8532	1975	6	1	1975-06-01 00:00:00	8527	0	\N	\N	\N	16572455-b282-4fc9-af41-60624d20d920	F	0	white	0	italian	0
192	8507	1939	10	18	1939-10-18 00:00:00	8527	0	\N	\N	\N	07cf5eb5-2f47-4401-a841-fbbe943ccba2	M	0	white	0	italian	0
280	8532	1938	10	28	1938-10-28 00:00:00	0	38003563	\N	\N	\N	0c80c584-bc17-4635-a047-9c3a16a9154d	F	0	hispanic	0	central_american	0
421	8532	1965	6	16	1965-06-16 00:00:00	0	38003563	\N	\N	\N	12afac62-6f3d-4034-a141-74671885bfee	F	0	hispanic	0	south_american	0
308	8507	1959	7	21	1959-07-21 00:00:00	0	38003563	\N	\N	\N	0ddfb2ee-e406-4d85-b401-9f1d22d8ffc9	M	0	hispanic	0	central_american	0
440	8532	1972	12	13	1972-12-13 00:00:00	8527	0	\N	\N	\N	13db7130-93ba-4283-b22c-f036e41f5767	F	0	white	0	irish	0
250	8532	1974	2	13	1974-02-13 00:00:00	8527	0	\N	\N	\N	0b433810-92d8-4207-a493-b72c4e78777b	F	0	white	0	irish	0
372	8532	1961	5	13	1961-05-13 00:00:00	8527	0	\N	\N	\N	1035f22c-56f1-4224-b5e3-78fc4a3aed21	F	0	white	0	french_canadian	0
565	8507	1957	7	24	1957-07-24 00:00:00	8527	0	\N	\N	\N	1a0baa37-a47c-4b08-b5b6-c6b29e580004	M	0	white	0	russian	0
186	8532	1971	11	21	1971-11-21 00:00:00	8527	0	\N	\N	\N	0795340f-7a1f-4ea0-b7a9-e9e531108d4b	F	0	white	0	irish	0
199	8507	1941	4	2	1941-04-02 00:00:00	8515	0	\N	\N	\N	080fcf8c-c8ff-4062-96b9-b921683a5393	M	0	asian	0	chinese	0
307	8507	1969	6	21	1969-06-21 00:00:00	8527	0	\N	\N	\N	0dcd7b12-092a-4763-adb8-190df59d3ccd	M	0	white	0	russian	0
312	8507	1972	1	24	1972-01-24 00:00:00	8515	0	\N	\N	\N	0e0a22cb-4cb9-430f-b98a-1ae57ae5a443	M	0	asian	0	chinese	0
450	8507	1967	4	9	1967-04-09 00:00:00	0	38003563	\N	\N	\N	144f672f-0d64-4268-bc25-3990a82cbece	M	0	hispanic	0	puerto_rican	0
339	8507	1982	8	14	1982-08-14 00:00:00	0	38003563	\N	\N	\N	0efb23e5-d7e5-4d57-b25f-019f10e63f20	M	0	hispanic	0	central_american	0
197	8507	1960	9	18	1960-09-18 00:00:00	0	38003563	\N	\N	\N	080aae70-5538-480a-b216-eca7ba4da2d1	M	0	hispanic	0	puerto_rican	0
285	8507	1970	5	25	1970-05-25 00:00:00	8515	0	\N	\N	\N	0caccf85-1cac-4aa2-81dd-d6e474503a9e	M	0	asian	0	asian_indian	0
685	8507	1966	2	7	1966-02-07 00:00:00	8527	0	\N	\N	\N	1f988ecd-b67f-443c-9c71-b486a5c139c8	M	0	white	0	irish	0
211	8532	1967	10	12	1967-10-12 00:00:00	8527	0	\N	\N	\N	0897dbc6-b368-4cc6-8696-e961176fc984	F	0	white	0	irish	0
295	8532	1949	6	15	1949-06-15 00:00:00	0	38003563	\N	\N	\N	0d2ccf81-91d4-44a3-81f0-68303df7d6cc	F	0	hispanic	0	mexican	0
137	8532	1971	6	30	1971-06-30 00:00:00	8527	0	\N	\N	\N	05891559-eeea-4d5c-a7a6-9b3e725914aa	F	0	white	0	irish	0
159	8507	1954	1	19	1954-01-19 00:00:00	8527	0	\N	\N	\N	06796dd1-ac7c-492c-a985-dc87115d0fdf	M	0	white	0	french_canadian	0
327	8507	1971	2	1	1971-02-01 00:00:00	8527	0	\N	\N	\N	0eb73050-f9fc-4450-bdba-4805d0be5473	M	0	white	0	french	0
343	8532	1970	1	31	1970-01-31 00:00:00	8527	0	\N	\N	\N	0f26da42-a1f3-49bb-9000-a9f41bcf9d3a	F	0	white	0	german	0
249	8532	1981	8	22	1981-08-22 00:00:00	8527	0	\N	\N	\N	0b32370e-a483-458e-be45-613bf8dc4166	F	0	white	0	russian	0
153	8532	1943	6	10	1943-06-10 00:00:00	8527	0	\N	\N	\N	06329a7f-59ca-4b96-80ff-0083ff513835	F	0	white	0	irish	0
321	8532	1961	11	12	1961-11-12 00:00:00	8516	0	\N	\N	\N	0ea52765-ebb5-4ae7-9107-08fd0b921d49	F	0	black	0	west_indian	0
358	8507	1939	12	26	1939-12-26 00:00:00	8527	0	\N	\N	\N	0faa7fa6-ff6f-4b96-b97e-546b8296e93a	M	0	white	0	irish	0
190	8532	1930	7	8	1930-07-08 00:00:00	8516	0	\N	\N	\N	07b714b1-c546-4481-ba56-de6f77bb3413	F	0	black	0	dominican	0
733	8532	1941	9	4	1941-09-04 00:00:00	8527	0	\N	\N	\N	21eac2a7-1d84-49fb-a53d-cd48f9733d56	F	0	white	0	irish	0
163	8532	1966	6	28	1966-06-28 00:00:00	8527	0	\N	\N	\N	06b3681d-fbd0-48e7-a06c-e32f128f48cc	F	0	white	0	irish	0
431	8532	1948	1	1	1948-01-01 00:00:00	8515	0	\N	\N	\N	135da4cf-976e-426b-a870-0953920bb041	F	0	asian	0	chinese	0
155	8532	1954	5	7	1954-05-07 00:00:00	8527	0	\N	\N	\N	0652937d-ccc1-48c7-80bc-2f6f89e6a62b	F	0	white	0	swedish	0
141	8532	1984	2	28	1984-02-28 00:00:00	8527	0	\N	\N	\N	05ad592c-fb6f-427b-bac1-fb5fd303290d	F	0	white	0	russian	0
755	8532	1947	7	5	1947-07-05 00:00:00	8527	0	\N	\N	\N	230773ea-eaa3-437e-8a35-a13a2a396e90	F	0	white	0	german	0
370	8507	1963	5	2	1963-05-02 00:00:00	8515	0	\N	\N	\N	1025dd64-1ef1-45fb-b1da-febae9052dc2	M	0	asian	0	asian_indian	0
220	8532	1982	9	1	1982-09-01 00:00:00	8516	0	\N	\N	\N	08f4245f-36e3-4d00-8bd6-8569197c8dd6	F	0	black	0	west_indian	0
188	8507	1962	11	18	1962-11-18 00:00:00	8527	0	\N	\N	\N	07b3778d-d67f-47fd-9cd7-b4ca0de263b1	M	0	white	0	italian	0
510	8507	1965	10	2	1965-10-02 00:00:00	8527	0	\N	\N	\N	1791c627-b48d-43b9-8573-4e655ae1b065	M	0	white	0	french_canadian	0
419	8532	1911	7	30	1911-07-30 00:00:00	8527	0	\N	\N	\N	128d5a71-4ca8-47c4-a70f-c8d4ec728973	F	0	white	0	french	0
738	8507	1978	7	4	1978-07-04 00:00:00	8527	0	\N	\N	\N	222384a1-7d86-44c8-a851-ceacdfcc4019	M	0	white	0	irish	0
642	8507	1934	12	30	1934-12-30 00:00:00	8527	0	\N	\N	\N	1dcf6eef-1fe3-4bf0-84e6-481d93da9c3f	M	0	white	0	irish	0
613	8532	1935	11	15	1935-11-15 00:00:00	8516	0	\N	\N	\N	1ca03ac7-0489-428a-83f9-809423a13584	F	0	black	0	dominican	0
264	8507	1951	7	27	1951-07-27 00:00:00	8527	0	\N	\N	\N	0bef13c5-4535-412b-95e2-dd19127bbc78	M	0	white	0	irish	0
677	8507	1961	6	2	1961-06-02 00:00:00	0	38003563	\N	\N	\N	1f52a3cd-93a7-4db3-8280-90f480b012da	M	0	hispanic	0	puerto_rican	0
399	8507	1955	4	3	1955-04-03 00:00:00	8527	0	\N	\N	\N	11f5ee3a-8a2e-4ac9-8d91-5580d4f28525	M	0	white	0	italian	0
498	8507	1970	3	26	1970-03-26 00:00:00	8527	0	\N	\N	\N	16c99b4f-738c-458d-96e9-282b1750e9f5	M	0	white	0	irish	0
439	8532	1977	9	29	1977-09-29 00:00:00	8527	0	\N	\N	\N	13d232be-c304-420c-88c0-a190a9271d6c	F	0	white	0	irish	0
640	8507	1946	11	4	1946-11-04 00:00:00	8516	0	\N	\N	\N	1db4c8ee-8cf2-457b-a163-a414b83f2db1	M	0	black	0	african	0
326	8507	1970	6	1	1970-06-01 00:00:00	8516	0	\N	\N	\N	0eb71b8a-cc5f-4ec3-967f-34fab704a86b	M	0	black	0	african	0
471	8507	1985	5	3	1985-05-03 00:00:00	8527	0	\N	\N	\N	15709cba-2455-4b98-826e-dade042a7fce	M	0	white	0	irish	0
362	8507	1981	4	21	1981-04-21 00:00:00	0	38003563	\N	\N	\N	0fd97158-b196-4cb1-837d-64c54c923877	M	0	hispanic	0	puerto_rican	0
279	8507	1951	11	30	1951-11-30 00:00:00	8527	0	\N	\N	\N	0c7a5583-e337-4e42-82d7-6d6e57b204c7	M	0	white	0	irish	0
573	8507	1959	10	31	1959-10-31 00:00:00	8515	0	\N	\N	\N	1a5eeabd-c300-443e-b156-9a413d779bbe	M	0	asian	0	asian_indian	0
266	8507	1966	5	2	1966-05-02 00:00:00	8527	0	\N	\N	\N	0c0ac865-a0ef-423b-a911-b61438aed4ae	M	0	white	0	irish	0
502	8532	1947	1	11	1947-01-11 00:00:00	8516	0	\N	\N	\N	16f577c5-6898-4a8a-9435-88ab39b414f6	F	0	black	0	dominican	0
359	8507	1977	10	22	1977-10-22 00:00:00	0	38003563	\N	\N	\N	0fadc0ca-a7e0-4aeb-a217-ee726d124b4d	M	0	hispanic	0	puerto_rican	0
263	8507	1954	6	20	1954-06-20 00:00:00	8527	0	\N	\N	\N	0beb03f1-8596-4ffb-b4b3-acc5faede0d4	M	0	white	0	english	0
480	8507	1937	5	19	1937-05-19 00:00:00	8527	0	\N	\N	\N	15bd63fe-5e35-4be3-b671-e4b43f9d9f57	M	0	white	0	american	0
455	8507	1950	1	31	1950-01-31 00:00:00	8527	0	\N	\N	\N	14890a2d-adc5-48d9-98ff-b28bd08938a0	M	0	white	0	irish	0
752	8507	1946	11	10	1946-11-10 00:00:00	8516	0	\N	\N	\N	22f618a6-2b61-413b-83a3-46128847d25d	M	0	black	0	west_indian	0
474	8507	1969	12	14	1969-12-14 00:00:00	8516	0	\N	\N	\N	15824efa-e09d-49bb-8065-e7281dd2f847	M	0	black	0	west_indian	0
331	8507	1935	5	2	1935-05-02 00:00:00	0	38003563	\N	\N	\N	0ec4603d-d712-4353-bdee-8b80d715ad52	M	0	hispanic	0	south_american	0
376	8532	1961	4	27	1961-04-27 00:00:00	8527	0	\N	\N	\N	108f4591-3d7e-49bc-b038-1c20c3618739	F	0	white	0	german	0
569	8532	1912	4	27	1912-04-27 00:00:00	8527	0	\N	\N	\N	1a49da89-17b4-426a-9f83-13f850bae2fc	F	0	white	0	american	0
357	8532	1954	10	13	1954-10-13 00:00:00	8527	0	\N	\N	\N	0f88d603-a557-4f4f-b890-88d0e7ff5c60	F	0	white	0	irish	0
366	8532	1911	2	19	1911-02-19 00:00:00	8527	0	\N	\N	\N	1019c92b-165c-4b12-8138-c19bc05ad125	F	0	white	0	italian	0
515	8507	1941	3	22	1941-03-22 00:00:00	8527	0	\N	\N	\N	17da4da0-8855-4a8d-b4bd-2f5a72f0ab15	M	0	white	0	french	0
430	8532	1931	6	20	1931-06-20 00:00:00	8515	0	\N	\N	\N	134f273e-c504-434f-9ef1-36e06aa05565	F	0	asian	0	chinese	0
462	8532	1976	9	16	1976-09-16 00:00:00	8527	0	\N	\N	\N	14eeb137-85c9-4b9f-9ec7-66d7f62bbb37	F	0	white	0	italian	0
297	8532	1951	6	17	1951-06-17 00:00:00	8527	0	\N	\N	\N	0d5e6a4e-500b-4350-ac73-7f57c0bc3e56	F	0	white	0	german	0
408	8532	1961	6	7	1961-06-07 00:00:00	8515	0	\N	\N	\N	1252ee97-a472-4620-a0a2-a53a00e030c8	F	0	asian	0	chinese	0
579	8507	1961	3	22	1961-03-22 00:00:00	8527	0	\N	\N	\N	1ab128f1-345e-4c96-9158-4aee8d572b1f	M	0	white	0	irish	0
287	8507	1976	3	14	1976-03-14 00:00:00	8527	0	\N	\N	\N	0cd297a5-4167-4bf2-bcc1-b15210dbe6cd	M	0	white	0	irish	0
276	8532	1977	6	9	1977-06-09 00:00:00	8527	0	\N	\N	\N	0c5e58e2-c080-49c2-96f9-a2f754158d1d	F	0	white	0	irish	0
479	8507	1939	10	22	1939-10-22 00:00:00	8527	0	\N	\N	\N	15b9f736-ec8f-415a-a0be-2ffffe74f6b1	M	0	white	0	italian	0
334	8532	1935	6	5	1935-06-05 00:00:00	8527	0	\N	\N	\N	0ed5bec9-06ee-488d-8b88-a22d34289913	F	0	white	0	portuguese	0
648	8507	1932	12	16	1932-12-16 00:00:00	8527	0	\N	\N	\N	1e0e209d-0c2e-41f8-a0f8-c76a7847e7ce	M	0	white	0	irish	0
457	8507	1951	8	14	1951-08-14 00:00:00	8516	0	\N	\N	\N	14a7b3cb-8c63-4e4b-8df3-b11d07656fbe	M	0	black	0	dominican	0
352	8507	1977	7	18	1977-07-18 00:00:00	8516	0	\N	\N	\N	0f6717a8-7765-4752-82be-8c3b460821f7	M	0	black	0	west_indian	0
363	8507	1964	7	7	1964-07-07 00:00:00	8527	0	\N	\N	\N	0fd9bb48-e614-4925-8cde-fb3f73737ae1	M	0	white	0	italian	0
776	8532	1958	7	31	1958-07-31 00:00:00	8527	0	\N	\N	\N	23ff411a-cb5e-4a0d-87da-cd2f838ee76a	F	0	white	0	english	0
374	8532	1979	11	8	1979-11-08 00:00:00	8527	0	\N	\N	\N	106c9f13-b56c-4540-a99b-bb5aca28e65a	F	0	white	0	polish	0
337	8507	1959	9	23	1959-09-23 00:00:00	8515	0	\N	\N	\N	0ef0f540-9d19-49f7-b89f-3432496e641d	M	0	asian	0	chinese	0
300	8532	1972	3	24	1972-03-24 00:00:00	8527	0	\N	\N	\N	0d777fd7-5ba0-422c-aeb2-0ef23653498e	F	0	white	0	english	0
332	8532	1963	6	14	1963-06-14 00:00:00	0	38003563	\N	\N	\N	0ec8234d-c9e1-485e-a1ac-93d1c6c662c8	F	0	hispanic	0	puerto_rican	0
525	8532	1949	4	4	1949-04-04 00:00:00	8527	0	\N	\N	\N	18156e1c-d770-4825-8fc9-98de759d97d1	F	0	white	0	american	0
443	8507	1968	12	16	1968-12-16 00:00:00	8527	0	\N	\N	\N	13fcd296-e140-4687-8fb3-ea1d378bdd21	M	0	white	0	irish	0
298	8507	1952	4	8	1952-04-08 00:00:00	8515	0	\N	\N	\N	0d6722ea-20c8-49cd-8eab-c5503ea36491	M	0	asian	0	chinese	0
239	8507	1945	10	25	1945-10-25 00:00:00	8527	0	\N	\N	\N	0a2f6b63-2c4a-495e-a932-5dfb91d86ad9	M	0	white	0	english	0
743	8532	1975	11	2	1975-11-02 00:00:00	8516	0	\N	\N	\N	2266b65b-b869-4226-a5f3-91fbfcb05b75	F	0	black	0	dominican	0
394	8507	1919	8	4	1919-08-04 00:00:00	8527	0	\N	\N	\N	119194d7-73a8-4ce8-b5c6-49c33425da2b	M	0	white	0	irish	0
283	8532	1980	9	1	1980-09-01 00:00:00	8527	0	\N	\N	\N	0c9a5225-482e-44cb-9b6c-02ef1f77391f	F	0	white	0	scottish	0
782	8532	1911	6	18	1911-06-18 00:00:00	8527	0	\N	\N	\N	24687490-cc47-4994-bc6b-3f5e9c60123c	F	0	white	0	english	0
213	8532	1967	5	1	1967-05-01 00:00:00	8527	0	\N	\N	\N	089f4e32-7f0a-4601-8ccd-598847123048	F	0	white	0	english	0
639	8532	1953	1	3	1953-01-03 00:00:00	0	38003563	\N	\N	\N	1d96fe6c-1ccf-4973-9015-a2b9e4bc042e	F	0	hispanic	0	puerto_rican	0
318	8532	1953	5	4	1953-05-04 00:00:00	8515	0	\N	\N	\N	0e758229-4ad2-487f-b67d-1f49134ccc31	F	0	asian	0	asian_indian	0
350	8532	1959	9	18	1959-09-18 00:00:00	0	38003563	\N	\N	\N	0f5b1029-2469-42c2-aa28-b1bb3cdae2bf	F	0	hispanic	0	puerto_rican	0
800	8532	1954	5	30	1954-05-30 00:00:00	8527	0	\N	\N	\N	255d0db6-2169-4640-a086-7b9bff8b15b8	F	0	white	0	irish	0
488	8507	1954	10	1	1954-10-01 00:00:00	8516	0	\N	\N	\N	163b1ee5-2ba9-4ca8-8f69-fa2398621f8e	M	0	black	0	african	0
377	8532	1967	2	2	1967-02-02 00:00:00	8527	0	\N	\N	\N	10996006-da8d-4ea2-b5fa-ea646e129232	F	0	white	0	french	0
202	8507	1938	9	10	1938-09-10 00:00:00	8527	0	\N	\N	\N	0843a08c-3554-4634-b383-4f6267cac9d8	M	0	white	0	english	0
558	8507	1960	11	3	1960-11-03 00:00:00	8527	0	\N	\N	\N	19a566b5-b02f-438b-b2c9-10f0b3f1f4bd	M	0	white	0	german	0
469	8532	1935	11	30	1935-11-30 00:00:00	0	38003563	\N	\N	\N	153a7963-0985-4753-9698-0876411541d2	F	0	hispanic	0	south_american	0
817	8532	1957	5	16	1957-05-16 00:00:00	8516	0	\N	\N	\N	25ef6826-e64c-479c-bff3-da458893d33a	F	0	black	0	west_indian	0
756	8532	1965	8	4	1965-08-04 00:00:00	8527	0	\N	\N	\N	23213c9e-9098-4f61-bc47-b9cc4a7a5656	F	0	white	0	italian	0
649	8507	1968	2	13	1968-02-13 00:00:00	8527	0	\N	\N	\N	1e1323cc-9baa-47fd-a963-b6585d98b061	M	0	white	0	american	0
484	8532	1938	1	3	1938-01-03 00:00:00	8527	0	\N	\N	\N	16190a6e-8635-4fd8-8b4d-89df3a9ce559	F	0	white	0	italian	0
723	8532	1960	11	10	1960-11-10 00:00:00	8527	0	\N	\N	\N	217e58e1-2232-42e0-aa21-8b77b9ebd122	F	0	white	0	english	0
505	8532	1968	6	4	1968-06-04 00:00:00	8527	0	\N	\N	\N	17055282-27d6-4d02-88a9-a49c5a86c4f8	F	0	white	0	irish	0
546	8532	1943	11	14	1943-11-14 00:00:00	8527	0	\N	\N	\N	19329d53-4579-4282-8570-99deeda6c603	F	0	white	0	irish	0
449	8532	1959	10	29	1959-10-29 00:00:00	8527	0	\N	\N	\N	144ba2bf-22c3-4486-a6fc-5d97fed30f7c	F	0	white	0	scottish	0
758	8532	1973	3	25	1973-03-25 00:00:00	8516	0	\N	\N	\N	2334ca4b-bb15-4877-96f7-bc7ccfe9752b	F	0	black	0	west_indian	0
426	8507	1966	1	13	1966-01-13 00:00:00	8527	0	\N	\N	\N	1314ca72-f8f6-4504-94ef-98510d7a3ee5	M	0	white	0	french	0
625	8507	1972	12	5	1972-12-05 00:00:00	0	38003563	\N	\N	\N	1d1641b5-fcdb-4dec-bf20-0d1257db8cf7	M	0	hispanic	0	puerto_rican	0
390	8532	1975	2	5	1975-02-05 00:00:00	8516	0	\N	\N	\N	117fc907-e282-4ca2-ba74-cc1b8712eddb	F	0	black	0	west_indian	0
507	8507	1938	8	19	1938-08-19 00:00:00	8516	0	\N	\N	\N	175b288a-c0a4-4fcc-a763-1138392df383	M	0	black	0	african	0
587	8532	1978	3	22	1978-03-22 00:00:00	0	38003563	\N	\N	\N	1b08d55f-03bf-4435-ade6-12352d51b6e9	F	0	hispanic	0	puerto_rican	0
380	8507	1971	11	12	1971-11-12 00:00:00	8527	0	\N	\N	\N	10b45b8d-8b48-4400-a3d1-6e2d932f9d92	M	0	white	0	italian	0
550	8532	1919	11	19	1919-11-19 00:00:00	8527	0	\N	\N	\N	1952a900-af0f-4725-ad30-6201b440ca76	F	0	white	0	irish	0
395	8507	1960	2	16	1960-02-16 00:00:00	8527	0	\N	\N	\N	11930d6e-1e53-4e1a-b2b5-36af792feaee	M	0	white	0	irish	0
369	8532	1980	12	27	1980-12-27 00:00:00	8527	0	\N	\N	\N	1025b09e-a2cd-4f3c-b703-34a6de00836d	F	0	white	0	italian	0
582	8507	1959	3	4	1959-03-04 00:00:00	8527	0	\N	\N	\N	1acec638-4abd-4002-99ef-1fb27a6493ea	M	0	white	0	italian	0
609	8507	1967	12	12	1967-12-12 00:00:00	8527	0	\N	\N	\N	1c597ec8-864d-497b-8cb9-5a758a2b0450	M	0	white	0	italian	0
975	8507	1964	11	15	1964-11-15 00:00:00	8527	0	\N	\N	\N	2e545f42-f265-4838-944b-041b69137bd2	M	0	white	0	english	0
636	8507	1948	3	12	1948-03-12 00:00:00	8527	0	\N	\N	\N	1d89d396-cd94-49ad-94a7-b2b481e50692	M	0	white	0	irish	0
830	8507	1958	11	26	1958-11-26 00:00:00	0	38003563	\N	\N	\N	266b0637-5e8c-48d4-ba95-5ad7084ee4c2	M	0	hispanic	0	puerto_rican	0
404	8532	1960	6	14	1960-06-14 00:00:00	8515	0	\N	\N	\N	122f3d22-b37d-4ee9-9fe0-ff38edc2e407	F	0	asian	0	chinese	0
675	8532	1948	2	17	1948-02-17 00:00:00	8516	0	\N	\N	\N	1f4b2c55-5b83-4c3f-a086-8005ca692b6d	F	0	black	0	african	0
393	8532	1957	1	9	1957-01-09 00:00:00	8527	0	\N	\N	\N	118ca429-6528-436b-95e1-c86f9b24bc36	F	0	white	0	irish	0
500	8507	1961	9	19	1961-09-19 00:00:00	8527	0	\N	\N	\N	16d47d3c-a7bd-41bf-a04e-a6621fdf46aa	M	0	white	0	italian	0
665	8507	1955	7	1	1955-07-01 00:00:00	8527	0	\N	\N	\N	1e8b018f-6636-4524-83fd-0ed979af74f2	M	0	white	0	irish	0
472	8507	1976	1	25	1976-01-25 00:00:00	8527	0	\N	\N	\N	15792f45-3fe2-445c-ae12-a8418b033f7f	M	0	white	0	american	0
616	8507	1959	1	3	1959-01-03 00:00:00	8527	0	\N	\N	\N	1cbef711-3112-49d8-9e82-9c441743bfae	M	0	white	0	english	0
351	8532	1977	11	29	1977-11-29 00:00:00	8516	0	\N	\N	\N	0f5c6f41-98ac-4abc-9ab9-9481ce363f9b	F	0	black	0	dominican	0
722	8507	1969	2	11	1969-02-11 00:00:00	8527	0	\N	\N	\N	21784d8c-e35f-4c21-8431-a79c788db48e	M	0	white	0	irish	0
687	8532	1967	1	21	1967-01-21 00:00:00	8527	0	\N	\N	\N	1fa8e377-fe2c-4a3b-a510-ed7f0b422a08	F	0	white	0	french	0
499	8507	1959	4	24	1959-04-24 00:00:00	0	38003563	\N	\N	\N	16ce0277-4b35-44c7-92f6-74cfaa5fdd56	M	0	hispanic	0	central_american	0
354	8532	1956	1	5	1956-01-05 00:00:00	8527	0	\N	\N	\N	0f6aeef9-8e41-4664-b7e0-ec26693eceb8	F	0	white	0	irish	0
739	8532	1909	7	7	1909-07-07 00:00:00	8527	0	\N	\N	\N	2225deb1-c8c6-47ed-8112-c6dcb02fd52d	F	0	white	0	polish	0
418	8507	1957	9	23	1957-09-23 00:00:00	8527	0	\N	\N	\N	128237a4-ed9c-4772-8040-2de5127d9114	M	0	white	0	portuguese	0
859	8507	1957	3	4	1957-03-04 00:00:00	8527	0	\N	\N	\N	27cfe51a-41f5-4b9c-bcb3-33cdf0aae39b	M	0	white	0	italian	0
757	8532	1914	11	8	1914-11-08 00:00:00	8527	0	\N	\N	\N	232df117-2845-454c-8580-07b81a194bba	F	0	white	0	polish	0
710	8507	1961	4	18	1961-04-18 00:00:00	8527	0	\N	\N	\N	20eec1bf-c5bf-4e44-804f-5332799194e3	M	0	white	0	french_canadian	0
545	8532	1971	10	9	1971-10-09 00:00:00	0	38003563	\N	\N	\N	19328d59-bcbf-447a-941f-617717147f22	F	0	hispanic	0	south_american	0
914	8507	1945	5	28	1945-05-28 00:00:00	8516	0	\N	\N	\N	2ada9998-1cec-4c0f-879e-e796c5217a98	M	0	black	0	dominican	0
410	8532	1949	9	1	1949-09-01 00:00:00	8527	0	\N	\N	\N	12603194-c1f9-484f-a90a-32106693cad2	F	0	white	0	italian	0
445	8507	1911	9	22	1911-09-22 00:00:00	0	38003563	\N	\N	\N	1423047e-0d5d-4f46-a17f-69eb34a69c91	M	0	hispanic	0	puerto_rican	0
528	8532	1959	5	29	1959-05-29 00:00:00	0	38003563	\N	\N	\N	182cb238-25be-4fe4-8564-8240547c5b83	F	0	hispanic	0	puerto_rican	0
470	8507	1955	1	11	1955-01-11 00:00:00	0	38003563	\N	\N	\N	154b4dcf-5c3b-4fdc-b249-5cca31a6ba1a	M	0	hispanic	0	mexican	0
836	8532	1978	9	3	1978-09-03 00:00:00	8527	0	\N	\N	\N	269c4da4-e056-45f5-b2f5-879ecd4cf31d	F	0	white	0	portuguese	0
461	8507	1948	7	27	1948-07-27 00:00:00	8515	0	\N	\N	\N	14e8fd19-f264-4deb-9efb-56d845fb75f8	M	0	asian	0	chinese	0
348	8507	1975	7	28	1975-07-28 00:00:00	8516	0	\N	\N	\N	0f556027-0ec9-4611-9677-66e43a25ca61	M	0	black	0	african	0
316	8532	1927	8	2	1927-08-02 00:00:00	0	38003563	\N	\N	\N	0e60a86c-48d8-483d-aa92-b7b9cc2c0a57	F	0	hispanic	0	puerto_rican	0
820	8507	1964	5	21	1964-05-21 00:00:00	8527	0	\N	\N	\N	260ada24-c254-4d58-a582-2c37937cb0aa	M	0	white	0	portuguese	0
704	8507	1965	12	8	1965-12-08 00:00:00	8527	0	\N	\N	\N	20b53ae0-fda3-4922-8608-817666b13eaa	M	0	white	0	french	0
701	8532	1957	8	31	1957-08-31 00:00:00	8527	0	\N	\N	\N	20928a65-a3b2-4385-baab-ae6e968e6fd7	F	0	white	0	russian	0
994	8507	1959	7	22	1959-07-22 00:00:00	8527	0	\N	\N	\N	2f53242a-37ee-48cf-809b-06b665bc93af	M	0	white	0	irish	0
262	8507	1964	8	3	1964-08-03 00:00:00	8516	0	\N	\N	\N	0bea24f1-7b1b-4903-9271-593f76ddbb7f	M	0	black	0	african	0
741	8532	1974	11	29	1974-11-29 00:00:00	8516	0	\N	\N	\N	2263e0c8-868e-4b93-9d3a-f83f3514c5f3	F	0	black	0	dominican	0
328	8532	1978	10	29	1978-10-29 00:00:00	8516	0	\N	\N	\N	0eb8261d-80af-4755-a8f9-c7c3f9db2041	F	0	black	0	african	0
452	8507	1962	9	7	1962-09-07 00:00:00	8527	0	\N	\N	\N	1469d19b-c7d5-412b-a065-86e5deff74b0	M	0	white	0	irish	0
954	8532	1974	4	14	1974-04-14 00:00:00	8527	0	\N	\N	\N	2d0d9a2b-a38c-4a81-aec2-f27751f005cf	F	0	white	0	irish	0
775	8532	1938	11	16	1938-11-16 00:00:00	8515	0	\N	\N	\N	23fd8907-8c03-4873-9387-0fe3060a8019	F	0	asian	0	chinese	0
563	8507	1964	4	12	1964-04-12 00:00:00	0	38003563	\N	\N	\N	19f2b181-4c28-4175-b413-2cfcf1fb4dd4	M	0	hispanic	0	puerto_rican	0
387	8532	1973	8	31	1973-08-31 00:00:00	8527	0	\N	\N	\N	112e9c2c-48c5-4124-b747-dc1e7ef890f7	F	0	white	0	russian	0
600	8532	1954	1	6	1954-01-06 00:00:00	8527	0	\N	\N	\N	1baf9ba7-d3dc-4be4-b5d5-38b299a5595f	F	0	white	0	irish	0
826	8532	1958	7	17	1958-07-17 00:00:00	8527	0	\N	\N	\N	26311a76-2e4c-47ab-832a-e380e5eb83e4	F	0	white	0	french	0
939	8507	1964	7	14	1964-07-14 00:00:00	8527	0	\N	\N	\N	2c585be6-66fd-4a95-a959-9c5920c9a4aa	M	0	white	0	english	0
807	8507	1951	1	16	1951-01-16 00:00:00	8527	0	\N	\N	\N	25a381e6-56fb-4937-a329-0a961574f668	M	0	white	0	scottish	0
812	8507	1963	7	13	1963-07-13 00:00:00	8527	0	\N	\N	\N	25d16a91-b019-4794-ab34-e276f95cc97d	M	0	white	0	irish	0
564	8532	1955	10	20	1955-10-20 00:00:00	8527	0	\N	\N	\N	1a05403e-4aa9-410a-be67-9da9ad78a435	F	0	white	0	italian	0
886	8507	1983	4	5	1983-04-05 00:00:00	8527	0	\N	\N	\N	2912b272-4c5c-4fb2-b745-972d5c68a6bd	M	0	white	0	american	0
607	8507	1950	12	15	1950-12-15 00:00:00	0	38003563	\N	\N	\N	1c4468d0-9a4f-409e-bfa9-d8531f040675	M	0	hispanic	0	mexican	0
596	8532	1948	2	17	1948-02-17 00:00:00	8516	0	\N	\N	\N	1b8859e8-dbb0-4bb8-a2c9-578bf47b9834	F	0	black	0	african	0
615	8532	1910	1	22	1910-01-22 00:00:00	0	38003563	\N	\N	\N	1cb986ea-7d2c-4d32-a94c-f36e874f7343	F	0	hispanic	0	puerto_rican	0
851	8507	1981	6	1	1981-06-01 00:00:00	8527	0	\N	\N	\N	2766435a-81af-4964-b301-ac1c8b18b4d2	M	0	white	0	irish	0
476	8507	1967	9	16	1967-09-16 00:00:00	8527	0	\N	\N	\N	158c669a-494c-440e-9e87-bb10e547e926	M	0	white	0	french_canadian	0
669	8532	1969	10	1	1969-10-01 00:00:00	8527	0	\N	\N	\N	1eb1e07d-2ec9-4ec8-9d01-9d9a3eb6ef35	F	0	white	0	german	0
598	8532	1974	9	20	1974-09-20 00:00:00	8527	0	\N	\N	\N	1b9106d5-16a7-41e8-bd52-1e8e468666e6	F	0	white	0	scottish	0
605	8532	1956	6	15	1956-06-15 00:00:00	8527	0	\N	\N	\N	1c033960-5e2b-4e45-8bb0-ff48f1cdd1b9	F	0	white	0	french	0
679	8507	1972	4	7	1972-04-07 00:00:00	8515	0	\N	\N	\N	1f5996d8-a986-4bf5-8eb6-ebbfd3741c1c	M	0	asian	0	asian_indian	0
486	8532	1960	11	3	1960-11-03 00:00:00	8516	0	\N	\N	\N	161dd879-b9c7-4f55-8056-744f21f83bc4	F	0	black	0	west_indian	0
592	8532	1969	11	28	1969-11-28 00:00:00	8527	0	\N	\N	\N	1b472895-1d4a-4642-842b-69df7cb1b726	F	0	white	0	french_canadian	0
603	8507	1956	3	9	1956-03-09 00:00:00	8527	0	\N	\N	\N	1be79281-1f27-4425-a4ee-6028b12671c9	M	0	white	0	english	0
571	8507	1954	8	30	1954-08-30 00:00:00	8516	0	\N	\N	\N	1a4fcdca-bf0b-4cdf-8cf1-65f704799818	M	0	black	0	dominican	0
682	8507	1970	11	18	1970-11-18 00:00:00	0	38003563	\N	\N	\N	1f86ec58-61c5-4b62-beeb-3728a7be02b8	M	0	hispanic	0	central_american	0
653	8507	1953	1	30	1953-01-30 00:00:00	8527	0	\N	\N	\N	1e2998e5-b730-4b1f-b48a-435d37ffd9bc	M	0	white	0	irish	0
1135	8507	1958	12	27	1958-12-27 00:00:00	0	38003563	\N	\N	\N	35e75458-b659-4802-b7b5-2583b115f633	M	0	hispanic	0	puerto_rican	0
656	8507	1964	1	4	1964-01-04 00:00:00	8527	0	\N	\N	\N	1e344d88-b80a-4c86-b07a-079846cf3cfb	M	0	white	0	french	0
932	8507	1969	2	24	1969-02-24 00:00:00	8527	0	\N	\N	\N	2beea68e-8c64-4c50-87e1-8abb1b3a3095	M	0	white	0	irish	0
482	8532	1969	10	23	1969-10-23 00:00:00	0	38003563	\N	\N	\N	15ffac92-2184-4fb3-9d18-efc15e3c4622	F	0	hispanic	0	puerto_rican	0
774	8532	1966	7	25	1966-07-25 00:00:00	0	38003563	\N	\N	\N	23f344ce-07fa-4b5b-ba22-18250931cf69	F	0	hispanic	0	puerto_rican	0
559	8507	1968	10	21	1968-10-21 00:00:00	8527	0	\N	\N	\N	19c0ed5c-a102-4337-9a6f-f47707275b20	M	0	white	0	german	0
712	8507	1974	11	7	1974-11-07 00:00:00	8527	0	\N	\N	\N	21153e79-c189-471f-852f-3f3c314ee704	M	0	white	0	american	0
828	8532	1952	7	22	1952-07-22 00:00:00	8515	0	\N	\N	\N	263bdfe6-d46a-4fd8-b4c3-bc59ffc16826	F	0	asian	0	asian_indian	0
520	8532	1950	11	9	1950-11-09 00:00:00	8515	0	\N	\N	\N	18054874-d179-41a8-aa01-3a1c7866a0cd	F	0	asian	0	chinese	0
644	8532	1975	10	22	1975-10-22 00:00:00	8527	0	\N	\N	\N	1ddaf003-1b40-48d6-ad55-e143d0be5d44	F	0	white	0	english	0
453	8507	1970	5	15	1970-05-15 00:00:00	8516	0	\N	\N	\N	146a73eb-327b-4ada-9174-310277fbe89a	M	0	black	0	west_indian	0
887	8507	1958	1	11	1958-01-11 00:00:00	0	38003563	\N	\N	\N	29158297-64be-4bcc-873c-83b5347d9da7	M	0	hispanic	0	puerto_rican	0
729	8532	1961	7	1	1961-07-01 00:00:00	8527	0	\N	\N	\N	21bf221a-7f92-4c1c-a5d9-d2f6e491c4fd	F	0	white	0	polish	0
597	8532	1952	5	5	1952-05-05 00:00:00	8527	0	\N	\N	\N	1b8a770b-3724-4d08-b2a8-9cd0ab43f46f	F	0	white	0	scottish	0
398	8507	1924	12	27	1924-12-27 00:00:00	8527	0	\N	\N	\N	11e9278e-8e20-41a0-9a8d-3b01e734335b	M	0	white	0	italian	0
938	8532	1945	7	19	1945-07-19 00:00:00	8527	0	\N	\N	\N	2c5389b4-53d2-4c2b-9cc6-1bd26524a2c3	F	0	white	0	irish	0
670	8532	1973	11	2	1973-11-02 00:00:00	8527	0	\N	\N	\N	1f0fee1c-93f4-4665-9334-1ebb36b35422	F	0	white	0	french_canadian	0
951	8507	1952	1	2	1952-01-02 00:00:00	8527	0	\N	\N	\N	2cffdd72-2245-471e-a752-580729fd8947	M	0	white	0	italian	0
806	8507	1956	12	30	1956-12-30 00:00:00	8516	0	\N	\N	\N	25a18398-a2ee-4cdc-b2ef-fc473ced187e	M	0	black	0	dominican	0
789	8507	1972	6	26	1972-06-26 00:00:00	8527	0	\N	\N	\N	24dd225f-d3ba-4e3b-80dc-2199b20e4e11	M	0	white	0	portuguese	0
1214	8532	1939	12	28	1939-12-28 00:00:00	8527	0	\N	\N	\N	39860bdb-9c6d-4c6a-b520-fac3e2b3b021	F	0	white	0	russian	0
1092	8507	1954	10	15	1954-10-15 00:00:00	0	38003563	\N	\N	\N	340d473b-a70d-4e89-9f10-6c922d1b5217	M	0	hispanic	0	puerto_rican	0
492	8532	1946	12	13	1946-12-13 00:00:00	0	38003563	\N	\N	\N	1670de5b-1821-4c47-8ff9-01df4dc115eb	F	0	hispanic	0	puerto_rican	0
459	8507	1970	8	31	1970-08-31 00:00:00	8527	0	\N	\N	\N	14c5e8e4-fcb9-4672-9df6-b7e93b377468	M	0	white	0	german	0
614	8507	1963	9	1	1963-09-01 00:00:00	8516	0	\N	\N	\N	1cab35e0-d510-43b1-920a-dd07c3de1e09	M	0	black	0	african	0
518	8532	1970	6	30	1970-06-30 00:00:00	8516	0	\N	\N	\N	17edb4a4-6ad5-4c2c-b3e6-e04e7fe8b5d6	F	0	black	0	west_indian	0
936	8507	1960	10	28	1960-10-28 00:00:00	8527	0	\N	\N	\N	2c2abb99-d020-4620-b22f-828b06d4f21d	M	0	white	0	irish	0
753	8532	1967	9	24	1967-09-24 00:00:00	8527	0	\N	\N	\N	22f74be9-9db2-4c42-8080-1edfb341395c	F	0	white	0	portuguese	0
432	8507	1930	6	2	1930-06-02 00:00:00	8516	0	\N	\N	\N	136af4b4-afe7-4f4a-bdba-ace511761b86	M	0	black	0	west_indian	0
422	8532	1959	1	10	1959-01-10 00:00:00	0	38003563	\N	\N	\N	12be1c1e-c8f4-49aa-8750-a5fb7724c424	F	0	hispanic	0	puerto_rican	0
834	8532	1956	7	9	1956-07-09 00:00:00	8527	0	\N	\N	\N	269227ae-8189-48a5-9655-5db3564f188a	F	0	white	0	portuguese	0
787	8507	1975	9	30	1975-09-30 00:00:00	8516	0	\N	\N	\N	24965ee1-359b-4c27-8e5c-08b6e2f3adcd	M	0	black	0	african	0
715	8532	1983	2	15	1983-02-15 00:00:00	8516	0	\N	\N	\N	2138899f-4497-47e9-bc86-f7b98cd5c634	F	0	black	0	dominican	0
1076	8532	1973	5	11	1973-05-11 00:00:00	8527	0	\N	\N	\N	333bea8d-6380-4ffe-a5ac-2ba4d0838234	F	0	white	0	french	0
368	8507	1971	10	6	1971-10-06 00:00:00	8516	0	\N	\N	\N	101f0e4b-0a62-4e85-9a0e-cc57ee9e9762	M	0	black	0	dominican	0
822	8507	1970	5	15	1970-05-15 00:00:00	8527	0	\N	\N	\N	2614969e-9cd3-4c4c-a34d-dc615c33db2d	M	0	white	0	american	0
664	8532	1981	7	9	1981-07-09 00:00:00	8516	0	\N	\N	\N	1e87820e-19fb-4329-af60-fbe4a7118002	F	0	black	0	dominican	0
610	8532	1962	8	30	1962-08-30 00:00:00	8527	0	\N	\N	\N	1c684151-c073-4ae4-b643-0e656850adb3	F	0	white	0	irish	0
972	8532	1966	6	1	1966-06-01 00:00:00	8527	0	\N	\N	\N	2e2d2d5c-6273-4329-8d1f-1ef1beca7efd	F	0	white	0	english	0
925	8507	1968	11	29	1968-11-29 00:00:00	8527	0	\N	\N	\N	2b8da21a-f814-4d27-974e-ff2cf44cff68	M	0	white	0	french	0
890	8507	1959	5	29	1959-05-29 00:00:00	8527	0	\N	\N	\N	292b0c33-d4c8-4e6d-aa4f-743928c1a7d2	M	0	white	0	german	0
549	8532	1952	7	30	1952-07-30 00:00:00	8527	0	\N	\N	\N	1945b9c4-e410-4397-b6ed-a9e4e2fcaf1f	F	0	white	0	irish	0
785	8532	1963	12	8	1963-12-08 00:00:00	8515	0	\N	\N	\N	24852f29-2a10-4031-b954-4b9779cee0b7	F	0	asian	0	asian_indian	0
844	8532	1966	4	23	1966-04-23 00:00:00	0	38003563	\N	\N	\N	26d7881d-2c54-4522-b2a8-069db79d97d0	F	0	hispanic	0	puerto_rican	0
1149	8507	1979	1	30	1979-01-30 00:00:00	8527	0	\N	\N	\N	36a160a0-8b79-49f8-a29a-a92cf7d503eb	M	0	white	0	irish	0
971	8507	1944	5	12	1944-05-12 00:00:00	8515	0	\N	\N	\N	2e2c10f5-1fc9-4667-ab62-002214c54e03	M	0	asian	0	chinese	0
858	8507	1974	2	14	1974-02-14 00:00:00	8527	0	\N	\N	\N	27c12af3-0100-4647-a83e-20f582771040	M	0	white	0	english	0
578	8532	1967	5	31	1967-05-31 00:00:00	0	38003563	\N	\N	\N	1aa64cd4-cb3d-4d25-9ade-8d3160b4d3f9	F	0	hispanic	0	puerto_rican	0
1004	8532	1962	10	11	1962-10-11 00:00:00	8527	0	\N	\N	\N	2fd8edfa-ef6b-4024-85ff-fc1a0294a407	F	0	white	0	italian	0
691	8507	1957	9	10	1957-09-10 00:00:00	8516	0	\N	\N	\N	1fc1b708-4b2f-4cb6-af1a-2ee74e327631	M	0	black	0	dominican	0
718	8507	1966	2	26	1966-02-26 00:00:00	8527	0	\N	\N	\N	21501765-0b29-48fe-b38f-46decf8ae1b0	M	0	white	0	german	0
651	8532	1977	5	5	1977-05-05 00:00:00	8527	0	\N	\N	\N	1e1d2d3e-5186-4355-b350-0c9489e131d6	F	0	white	0	portuguese	0
959	8507	1958	3	26	1958-03-26 00:00:00	8527	0	\N	\N	\N	2d6e1b2d-2d45-4a07-907f-5d903d6c9427	M	0	white	0	irish	0
662	8507	1960	9	21	1960-09-21 00:00:00	8527	0	\N	\N	\N	1e695c5b-6b31-4373-910a-6dc5af4d02b1	M	0	white	0	english	0
747	8507	1963	9	21	1963-09-21 00:00:00	0	38003563	\N	\N	\N	22e2020d-5051-4092-8645-64a46c341367	M	0	hispanic	0	puerto_rican	0
1107	8507	1926	11	19	1926-11-19 00:00:00	8527	0	\N	\N	\N	34a52ca4-ccc0-4ed1-bdc0-32cadc59f617	M	0	white	0	german	0
689	8532	1982	2	21	1982-02-21 00:00:00	8527	0	\N	\N	\N	1fb60e2f-cc57-453a-9ea8-99ecf28a9722	F	0	white	0	american	0
884	8532	1977	9	6	1977-09-06 00:00:00	8527	0	\N	\N	\N	290b2400-de65-4364-97a2-f365ed55bd15	F	0	white	0	portuguese	0
576	8507	1966	8	31	1966-08-31 00:00:00	8527	0	\N	\N	\N	1a9c0d65-b898-4ea2-a045-12e9971bb7af	M	0	white	0	german	0
700	8532	1978	6	14	1978-06-14 00:00:00	8515	0	\N	\N	\N	208c31ac-8819-4b82-a1a0-dded9a2329bb	F	0	asian	0	chinese	0
695	8507	1968	10	21	1968-10-21 00:00:00	8527	0	\N	\N	\N	1ff68e13-60cb-40df-853a-bf67fa908459	M	0	white	0	italian	0
673	8532	1961	9	22	1961-09-22 00:00:00	8515	0	\N	\N	\N	1f37261b-4473-4d6f-8957-687f663713a1	F	0	asian	0	chinese	0
732	8532	1972	4	13	1972-04-13 00:00:00	8527	0	\N	\N	\N	21e762aa-bccc-45ee-9cb0-ca40afcb496b	F	0	white	0	english	0
763	8532	1965	3	18	1965-03-18 00:00:00	0	38003563	\N	\N	\N	23753164-a10d-4bce-afe4-603c6cfd5c90	F	0	hispanic	0	south_american	0
1155	8507	1966	2	21	1966-02-21 00:00:00	0	38003563	\N	\N	\N	36d4e6ab-c65c-40a8-b510-2b4ac0fa1bfc	M	0	hispanic	0	south_american	0
742	8507	1925	3	16	1925-03-16 00:00:00	8527	0	\N	\N	\N	2265e8d9-7f28-4ec5-9584-502a28466089	M	0	white	0	irish	0
978	8532	1975	8	15	1975-08-15 00:00:00	8516	0	\N	\N	\N	2e911d6f-0efd-4ff7-b004-7d4a81d66d04	F	0	black	0	african	0
580	8532	1926	11	7	1926-11-07 00:00:00	0	38003563	\N	\N	\N	1acae704-c3e0-4718-872c-358b45131c57	F	0	hispanic	0	puerto_rican	0
924	8532	1963	6	30	1963-06-30 00:00:00	8527	0	\N	\N	\N	2b7f63db-b5a6-46db-8a11-ba0377f3e8a2	F	0	white	0	irish	0
601	8507	1969	11	16	1969-11-16 00:00:00	8527	0	\N	\N	\N	1bc52b17-5983-40d5-95ae-f33d08d36f72	M	0	white	0	italian	0
795	8532	1936	8	19	1936-08-19 00:00:00	8527	0	\N	\N	\N	253a7849-ae22-423c-a191-ca2b1df14d92	F	0	white	0	italian	0
842	8507	1909	11	27	1909-11-27 00:00:00	8527	0	\N	\N	\N	26d50728-9ac0-4c56-9e4b-b707627d9caa	M	0	white	0	polish	0
823	8532	1944	11	20	1944-11-20 00:00:00	8527	0	\N	\N	\N	261a1b2c-95f2-4d80-bb49-c9b0a90941f4	F	0	white	0	irish	0
754	8532	1937	8	24	1937-08-24 00:00:00	8527	0	\N	\N	\N	22fd8e47-b8d0-4574-94dc-0ad6852b8fd6	F	0	white	0	french_canadian	0
533	8532	1962	8	1	1962-08-01 00:00:00	8527	0	\N	\N	\N	1877fc70-4f03-46b2-a7ae-8dd3e0dc7fec	F	0	white	0	english	0
923	8507	1958	11	12	1958-11-12 00:00:00	8527	0	\N	\N	\N	2b7a585b-7504-4a0f-ade7-8f4ea02ec668	M	0	white	0	irish	0
778	8532	1978	1	19	1978-01-19 00:00:00	8527	0	\N	\N	\N	24209bf7-36ca-47b0-9eec-9c73fce1bf33	F	0	white	0	irish	0
697	8507	1965	4	14	1965-04-14 00:00:00	8527	0	\N	\N	\N	203e4a42-d748-4e25-8728-2aa6f9cd3040	M	0	white	0	italian	0
552	8532	1951	9	18	1951-09-18 00:00:00	8527	0	\N	\N	\N	197da49a-f840-46f9-8274-4e7211dada5c	F	0	white	0	german	0
1148	8507	1957	6	22	1957-06-22 00:00:00	8527	0	\N	\N	\N	36a007af-e5aa-4d36-ac7f-150b4bf0333d	M	0	white	0	american	0
744	8507	1952	3	28	1952-03-28 00:00:00	8527	0	\N	\N	\N	2276d4b6-80e1-4f02-bf0c-f80d1d864562	M	0	white	0	irish	0
1320	8532	1934	8	30	1934-08-30 00:00:00	8527	0	\N	\N	\N	3e6a1f2f-a34b-4f1b-a14c-84fe2d094f8e	F	0	white	0	german	0
956	8532	1935	6	5	1935-06-05 00:00:00	8527	0	\N	\N	\N	2d472b08-8425-44de-8bc0-737f901a935f	F	0	white	0	portuguese	0
867	8532	1929	1	29	1929-01-29 00:00:00	0	38003563	\N	\N	\N	283374e5-25c9-4056-8514-fb6dabea753d	F	0	hispanic	0	puerto_rican	0
1389	8532	1955	3	5	1955-03-05 00:00:00	8516	0	\N	\N	\N	41c2832d-1a49-4895-b2e4-513928652cba	F	0	black	0	west_indian	0
1246	8507	1938	8	19	1938-08-19 00:00:00	8516	0	\N	\N	\N	3b09679d-692e-49a3-8981-14aa503777e5	M	0	black	0	african	0
572	8532	1953	10	23	1953-10-23 00:00:00	0	38003563	\N	\N	\N	1a5006bd-02ec-4fd3-9912-8f2c45bb4821	F	0	hispanic	0	puerto_rican	0
539	8532	1933	3	26	1933-03-26 00:00:00	8527	0	\N	\N	\N	18f99ce0-eba4-49bd-85e2-863f77e2c19e	F	0	white	0	english	0
764	8532	1969	7	15	1969-07-15 00:00:00	0	38003563	\N	\N	\N	237bb35c-b785-48f0-aeb6-4b7ea29401b2	F	0	hispanic	0	puerto_rican	0
624	8507	1940	10	26	1940-10-26 00:00:00	8516	0	\N	\N	\N	1d0e6384-8b91-4e29-a779-db18d879bd94	M	0	black	0	african	0
1032	8507	1951	10	14	1951-10-14 00:00:00	8527	0	\N	\N	\N	3149bbed-7cc6-4de2-b19e-bc487aeb3c0e	M	0	white	0	english	0
974	8532	1956	6	24	1956-06-24 00:00:00	8516	0	\N	\N	\N	2e4e9313-a9c1-48aa-95ae-b4ebd9a5c934	F	0	black	0	west_indian	0
454	8532	1935	3	2	1935-03-02 00:00:00	8516	0	\N	\N	\N	1471a55a-b3b0-4585-9360-eff2a1643cf2	F	0	black	0	african	0
464	8507	1972	5	16	1972-05-16 00:00:00	8527	0	\N	\N	\N	1505e031-8c88-4f0f-a371-45940fd35994	M	0	white	0	irish	0
1144	8532	1970	6	7	1970-06-07 00:00:00	8527	0	\N	\N	\N	36540f8c-05d1-460b-8ffd-0facb1116d3c	F	0	white	0	italian	0
869	8507	1913	12	12	1913-12-12 00:00:00	8527	0	\N	\N	\N	28795f50-6c6a-44e5-b8c6-47ad679280c9	M	0	white	0	irish	0
1058	8507	1955	9	24	1955-09-24 00:00:00	8527	0	\N	\N	\N	324c8081-79a6-4179-90da-d80deb6703d9	M	0	white	0	russian	0
1425	8532	1935	11	26	1935-11-26 00:00:00	8527	0	\N	\N	\N	43c961ea-5225-4473-b559-cd4219eac5c1	F	0	white	0	american	0
412	8532	1953	5	15	1953-05-15 00:00:00	8527	0	\N	\N	\N	126b6c49-0b9e-4cbe-ba4d-7072b5aa082a	F	0	white	0	portuguese	0
940	8507	1942	11	26	1942-11-26 00:00:00	8527	0	\N	\N	\N	2c59ef10-ab57-44c8-a6f0-e3252697327f	M	0	white	0	portuguese	0
829	8532	1973	6	17	1973-06-17 00:00:00	8516	0	\N	\N	\N	26630981-b61a-4145-8bd3-c5f97222e150	F	0	black	0	dominican	0
654	8532	1962	2	16	1962-02-16 00:00:00	8527	0	\N	\N	\N	1e30b463-8733-4a67-ad68-e57769ea6905	F	0	white	0	italian	0
1132	8532	1953	5	4	1953-05-04 00:00:00	8527	0	\N	\N	\N	35d0885b-32ea-40de-8d75-ca4db08d57dc	F	0	white	0	german	0
1085	8507	1965	1	2	1965-01-02 00:00:00	8527	0	\N	\N	\N	3399977e-0c09-49dd-844a-6c8c50ad5826	M	0	white	0	italian	0
918	8507	1913	8	8	1913-08-08 00:00:00	0	38003563	\N	\N	\N	2aee3c63-8295-421b-8700-507a3408c388	M	0	hispanic	0	puerto_rican	0
703	8507	1949	12	23	1949-12-23 00:00:00	8527	0	\N	\N	\N	20b33bfb-cd76-4028-ad33-22d8db52e8ab	M	0	white	0	american	0
871	8532	1966	1	18	1966-01-18 00:00:00	0	38003563	\N	\N	\N	28a8f516-6c8f-4400-ab62-1a78bbcfce09	F	0	hispanic	0	puerto_rican	0
1024	8507	1941	6	29	1941-06-29 00:00:00	8527	0	\N	\N	\N	30e70722-24aa-4ae8-a12a-e2e2c2c35a8d	M	0	white	0	polish	0
1169	8532	1935	10	14	1935-10-14 00:00:00	8527	0	\N	\N	\N	37835ebc-0b18-4269-981a-71a38134540e	F	0	white	0	english	0
1053	8532	1976	1	30	1976-01-30 00:00:00	8527	0	\N	\N	\N	3220e8e8-2a5e-4520-9db3-b0876c0805aa	F	0	white	0	italian	0
950	8532	1970	5	24	1970-05-24 00:00:00	8515	0	\N	\N	\N	2cfe7d80-4f6e-4658-9604-36d43d3f6ad1	F	0	asian	0	asian_indian	0
686	8507	1945	10	12	1945-10-12 00:00:00	8516	0	\N	\N	\N	1f9a0606-33b8-447a-9740-af9462a55632	M	0	black	0	african	0
1082	8532	1955	8	20	1955-08-20 00:00:00	8527	0	\N	\N	\N	3372f71b-7acd-427f-9e95-31724f75de7b	F	0	white	0	portuguese	0
709	8507	1949	7	3	1949-07-03 00:00:00	8516	0	\N	\N	\N	20df349f-b565-4af1-9966-ebe041b765bc	M	0	black	0	dominican	0
1227	8507	1937	8	25	1937-08-25 00:00:00	0	38003563	\N	\N	\N	3a59f8a4-972d-4745-9de1-bbebfd992944	M	0	hispanic	0	puerto_rican	0
814	8532	1980	7	12	1980-07-12 00:00:00	8527	0	\N	\N	\N	25dfbf6b-bd2a-4342-a023-6e3f88fb63c1	F	0	white	0	italian	0
969	8532	1978	5	7	1978-05-07 00:00:00	8527	0	\N	\N	\N	2e067db6-b300-4166-8390-5a83d889b108	F	0	white	0	german	0
736	8507	1972	1	6	1972-01-06 00:00:00	8527	0	\N	\N	\N	220b15d1-3bc2-4684-9e19-4e436ee8764b	M	0	white	0	italian	0
1176	8507	1962	10	19	1962-10-19 00:00:00	0	38003563	\N	\N	\N	37d17726-f09c-42cf-b502-347cd910fa36	M	0	hispanic	0	mexican	0
1215	8507	1972	4	8	1972-04-08 00:00:00	8516	0	\N	\N	\N	398b1adc-925d-43f2-b1b9-e21dd182ff7f	M	0	black	0	west_indian	0
711	8532	1950	12	22	1950-12-22 00:00:00	8527	0	\N	\N	\N	21099753-4a26-4536-a976-6f8e27cef54f	F	0	white	0	english	0
1102	8532	1967	1	24	1967-01-24 00:00:00	8527	0	\N	\N	\N	34728bea-46e0-44e6-98cc-09d85144c47d	F	0	white	0	portuguese	0
730	8532	1957	4	13	1957-04-13 00:00:00	0	38003563	\N	\N	\N	21bfd615-ca0e-4f90-9bf8-044b87f15899	F	0	hispanic	0	mexican	0
793	8507	1973	6	7	1973-06-07 00:00:00	8527	0	\N	\N	\N	250799ab-01a2-4fa6-9654-c6d41fb6b464	M	0	white	0	irish	0
1022	8532	1964	3	31	1964-03-31 00:00:00	0	38003563	\N	\N	\N	30d9662f-c8f0-4689-a4e0-660b99f70a55	F	0	hispanic	0	puerto_rican	0
727	8507	1912	11	1	1912-11-01 00:00:00	8527	0	\N	\N	\N	21a9d3a1-bab0-477c-b16b-2ce64788e35e	M	0	white	0	irish	0
917	8532	1963	5	16	1963-05-16 00:00:00	8527	0	\N	\N	\N	2aeaaac6-a5b7-4291-ba62-165f841255dd	F	0	white	0	french	0
862	8507	1970	6	2	1970-06-02 00:00:00	0	38003563	\N	\N	\N	27fc26a0-25ef-41b9-8a59-78a33dcae8b2	M	0	hispanic	0	mexican	0
1318	8507	1938	3	8	1938-03-08 00:00:00	8527	0	\N	\N	\N	3e5d6e6c-8432-476a-acb1-be4fe959ce63	M	0	white	0	french	0
821	8507	1948	6	12	1948-06-12 00:00:00	0	38003563	\N	\N	\N	260ed8b6-9cd6-4e47-ac07-998ff9a7ef90	M	0	hispanic	0	puerto_rican	0
1138	8507	1980	1	31	1980-01-31 00:00:00	8527	0	\N	\N	\N	3619e795-999e-49e6-a5df-72f191029102	M	0	white	0	english	0
680	8507	1967	9	25	1967-09-25 00:00:00	8527	0	\N	\N	\N	1f63b5a3-f93e-4341-8fcf-6f406e0eaece	M	0	white	0	irish	0
1084	8532	1978	1	6	1978-01-06 00:00:00	8527	0	\N	\N	\N	3392310e-3e95-48f6-ba5b-1afcefafb8b6	F	0	white	0	english	0
693	8507	1951	1	2	1951-01-02 00:00:00	8516	0	\N	\N	\N	1fd89fc0-1ceb-4134-b505-e8960328ff67	M	0	black	0	west_indian	0
877	8532	1977	5	3	1977-05-03 00:00:00	8515	0	\N	\N	\N	28cecc15-767b-4fae-8f6c-dd4814015e6a	F	0	asian	0	chinese	0
1136	8507	1971	5	15	1971-05-15 00:00:00	8527	0	\N	\N	\N	35fa9c83-b61d-4de1-8408-c565f3c77c6a	M	0	white	0	german	0
987	8532	1953	8	30	1953-08-30 00:00:00	8527	0	\N	\N	\N	2f0c4433-c377-41f3-949d-e21f96969110	F	0	white	0	italian	0
855	8532	1956	11	23	1956-11-23 00:00:00	0	38003563	\N	\N	\N	2787d054-619e-42e3-8f0b-eb7a181ba72c	F	0	hispanic	0	central_american	0
655	8532	1959	12	12	1959-12-12 00:00:00	8527	0	\N	\N	\N	1e32725f-4fa4-4e11-b91e-aa5c235497f7	F	0	white	0	american	0
1005	8532	1967	2	21	1967-02-21 00:00:00	8515	0	\N	\N	\N	2ff258dd-465d-4d1a-bf3f-50b53d999186	F	0	asian	0	asian_indian	0
1072	8507	1960	8	17	1960-08-17 00:00:00	0	38003563	\N	\N	\N	330d91be-92fa-4017-ad74-3e54428043b3	M	0	hispanic	0	puerto_rican	0
719	8532	1980	11	14	1980-11-14 00:00:00	8527	0	\N	\N	\N	215414fe-6af3-4cd7-84b7-8204c7ab8c45	F	0	white	0	italian	0
606	8532	1975	2	12	1975-02-12 00:00:00	8527	0	\N	\N	\N	1c2bde6e-af8c-4d36-ba33-a8e73cb3c1b1	F	0	white	0	russian	0
1333	8532	1954	10	3	1954-10-03 00:00:00	8527	0	\N	\N	\N	3f403cf7-258a-4742-ad4e-6b347e6ed1a6	F	0	white	0	irish	0
929	8507	1919	8	4	1919-08-04 00:00:00	8527	0	\N	\N	\N	2bd20c4d-9919-421d-acb4-c31ae0ae534b	M	0	white	0	irish	0
1476	8532	1944	9	14	1944-09-14 00:00:00	0	38003563	\N	\N	\N	45e53294-7a55-4301-8d74-ec3dd68ba6dd	F	0	hispanic	0	south_american	0
970	8507	1952	6	8	1952-06-08 00:00:00	8527	0	\N	\N	\N	2e1943a5-e386-4d12-adfe-55da87116948	M	0	white	0	french	0
911	8507	1976	3	7	1976-03-07 00:00:00	8527	0	\N	\N	\N	2aa77616-a85a-415c-bf72-1046bc9cb8d1	M	0	white	0	irish	0
1409	8532	1917	1	29	1917-01-29 00:00:00	0	38003563	\N	\N	\N	42b7d4c9-9170-4ad6-9d49-7e0cf9078596	F	0	hispanic	0	puerto_rican	0
1293	8507	1939	12	26	1939-12-26 00:00:00	8527	0	\N	\N	\N	3d4ad2bf-78c0-4968-afbd-2e1c3e7aa716	M	0	white	0	irish	0
720	8532	1964	8	29	1964-08-29 00:00:00	0	38003563	\N	\N	\N	21546e4e-9398-439c-b730-eaa989b39efd	F	0	hispanic	0	central_american	0
621	8532	1912	8	21	1912-08-21 00:00:00	8527	0	\N	\N	\N	1cf76057-ee89-4045-804a-9b125b9eb62e	F	0	white	0	irish	0
857	8532	1952	3	2	1952-03-02 00:00:00	8527	0	\N	\N	\N	27b1b0e0-fbef-480d-91e5-cd0220209489	F	0	white	0	english	0
825	8507	1970	9	12	1970-09-12 00:00:00	8527	0	\N	\N	\N	262e2023-e7cb-4182-836e-0d129f03ee99	M	0	white	0	italian	0
1150	8507	1950	4	12	1950-04-12 00:00:00	8527	0	\N	\N	\N	36a97d7a-c58f-4276-a1f8-a3e3477a84f1	M	0	white	0	italian	0
1134	8507	1939	4	2	1939-04-02 00:00:00	8527	0	\N	\N	\N	35e6dffe-ea1a-46cf-a74d-ac44af90458e	M	0	white	0	irish	0
534	8532	1978	6	20	1978-06-20 00:00:00	8515	0	\N	\N	\N	187f51e5-aa8c-4980-80de-f4789e534b3f	F	0	asian	0	chinese	0
512	8507	1954	2	19	1954-02-19 00:00:00	8527	0	\N	\N	\N	17a177f5-c9f7-47b5-b124-d1437bcbd686	M	0	white	0	irish	0
1250	8532	1953	3	23	1953-03-23 00:00:00	8527	0	\N	\N	\N	3b23df69-8d99-4d25-a48c-b1f1487f459b	F	0	white	0	irish	0
905	8532	1968	9	21	1968-09-21 00:00:00	8527	0	\N	\N	\N	2a439b65-b9e9-4feb-9204-de9fe7eab46e	F	0	white	0	french_canadian	0
1108	8532	1969	7	30	1969-07-30 00:00:00	8527	0	\N	\N	\N	34a6e48f-6217-44ba-b6b2-fa53ef21f285	F	0	white	0	italian	0
1511	8532	1965	4	25	1965-04-25 00:00:00	8516	0	\N	\N	\N	4745799f-58e3-4ad2-905b-446c719bd8b9	F	0	black	0	african	0
588	8507	1981	1	28	1981-01-28 00:00:00	0	38003563	\N	\N	\N	1b0a9534-cde8-4f41-a22b-97e678f426f2	M	0	hispanic	0	puerto_rican	0
986	8532	1916	10	28	1916-10-28 00:00:00	8527	0	\N	\N	\N	2f0728d7-07c9-4e4e-b39c-4652ac9da55e	F	0	white	0	french	0
843	8532	1982	5	1	1982-05-01 00:00:00	8515	0	\N	\N	\N	26d61c61-77ab-4334-8080-5ae8e9deaad5	F	0	asian	0	asian_indian	0
760	8532	1964	11	25	1964-11-25 00:00:00	0	38003563	\N	\N	\N	23426705-ba0f-4f93-88e3-c7be09827c2c	F	0	hispanic	0	mexican	0
1317	8507	1951	11	9	1951-11-09 00:00:00	8527	0	\N	\N	\N	3e3f8c3e-b4e6-41ad-a294-d0d3649bb918	M	0	white	0	irish	0
1099	8507	1952	4	12	1952-04-12 00:00:00	8527	0	\N	\N	\N	3438b35c-0326-447c-b820-dd5cb5be26b7	M	0	white	0	italian	0
992	8532	1953	8	23	1953-08-23 00:00:00	8516	0	\N	\N	\N	2f3f7d5b-6435-4fa7-863f-c80e34c39972	F	0	black	0	dominican	0
1110	8532	1982	3	15	1982-03-15 00:00:00	8515	0	\N	\N	\N	34b72a25-311a-43c0-ba4f-75b77572ff00	F	0	asian	0	asian_indian	0
1021	8507	1952	12	11	1952-12-11 00:00:00	8527	0	\N	\N	\N	30c11d50-9994-4ad7-887c-16c9558a80af	M	0	white	0	polish	0
1353	8532	1955	2	28	1955-02-28 00:00:00	8527	0	\N	\N	\N	4050d72c-15c9-4b9f-bf2e-d63efbbd39e0	F	0	white	0	german	0
1332	8507	1943	6	2	1943-06-02 00:00:00	0	38003563	\N	\N	\N	3f2a562f-b760-4a70-a569-7f8be8a3d871	M	0	hispanic	0	puerto_rican	0
1131	8507	1965	8	11	1965-08-11 00:00:00	8527	0	\N	\N	\N	35cfaa76-4b1b-4053-9f34-a1298c5cd3f1	M	0	white	0	irish	0
1046	8532	1971	5	9	1971-05-09 00:00:00	0	38003563	\N	\N	\N	31c9446c-5382-4c8f-b93c-e04373d26d2a	F	0	hispanic	0	puerto_rican	0
728	8507	1955	1	22	1955-01-22 00:00:00	8516	0	\N	\N	\N	21b5b232-7c8c-4ad5-962b-00d882240819	M	0	black	0	west_indian	0
1100	8507	1982	9	29	1982-09-29 00:00:00	8527	0	\N	\N	\N	3462fed0-2c9c-4025-ac69-cfd92971668d	M	0	white	0	portuguese	0
864	8507	1922	2	27	1922-02-27 00:00:00	8527	0	\N	\N	\N	281b5568-f6ea-4b20-af78-8fc47825c693	M	0	white	0	polish	0
1390	8507	1965	12	30	1965-12-30 00:00:00	8527	0	\N	\N	\N	41d2a075-41d7-43ca-83ec-d259210dd95f	M	0	white	0	portuguese	0
856	8507	1969	6	13	1969-06-13 00:00:00	8516	0	\N	\N	\N	279fe5f1-b49d-4179-8b6e-b579b8b4873c	M	0	black	0	dominican	0
1267	8532	1952	5	8	1952-05-08 00:00:00	8516	0	\N	\N	\N	3c033468-de0c-478b-8021-c4e76fc5ffe8	F	0	black	0	west_indian	0
1033	8532	1971	8	5	1971-08-05 00:00:00	8515	0	\N	\N	\N	314def2e-f5f0-4414-8778-ef6161688253	F	0	asian	0	asian_indian	0
1355	8532	1963	8	9	1963-08-09 00:00:00	8527	0	\N	\N	\N	4054d3c2-e632-41e6-961c-4e6ef5dcd3e8	F	0	white	0	irish	0
1306	8532	1956	8	8	1956-08-08 00:00:00	0	38003563	\N	\N	\N	3dd678c3-a939-4256-87c3-884603c2163f	F	0	hispanic	0	central_american	0
788	8507	1969	9	10	1969-09-10 00:00:00	8527	0	\N	\N	\N	24b2a227-c4ac-47a4-b24d-3ea7c2c8e788	M	0	white	0	scottish	0
1236	8532	1920	7	29	1920-07-29 00:00:00	8527	0	\N	\N	\N	3ab242c0-1768-49cd-a10f-3bc33e8b69e4	F	0	white	0	irish	0
895	8507	1960	2	5	1960-02-05 00:00:00	8515	0	\N	\N	\N	295244d3-e3bc-4e51-b984-d9c73cebbd3a	M	0	asian	0	chinese	0
879	8507	1952	2	11	1952-02-11 00:00:00	8527	0	\N	\N	\N	28d92435-d025-4bfe-a6bc-a2af8290a597	M	0	white	0	irish	0
1118	8532	1973	8	12	1973-08-12 00:00:00	8527	0	\N	\N	\N	3552ff66-4a84-499d-bb91-3aea034904ab	F	0	white	0	english	0
882	8507	1944	12	23	1944-12-23 00:00:00	8527	0	\N	\N	\N	28ece444-ef84-4cd1-a4ca-103f079ee2f5	M	0	white	0	irish	0
1077	8507	1946	8	16	1946-08-16 00:00:00	8527	0	\N	\N	\N	334aaf9d-f03f-4fb8-b50c-a5b5811996a3	M	0	white	0	english	0
946	8532	1960	4	6	1960-04-06 00:00:00	8527	0	\N	\N	\N	2cbc66ab-5132-475e-90e4-5130d479e992	F	0	white	0	italian	0
1360	8532	1975	10	5	1975-10-05 00:00:00	8527	0	\N	\N	\N	40700948-02e2-41ed-b43a-8f391c628277	F	0	white	0	irish	0
1039	8507	1960	3	19	1960-03-19 00:00:00	8527	0	\N	\N	\N	317897c6-7f70-4ef9-97f8-0b15f4986c1b	M	0	white	0	italian	0
1339	8532	1966	4	14	1966-04-14 00:00:00	8527	0	\N	\N	\N	3f85fc42-343d-4217-8944-da5682fe3668	F	0	white	0	italian	0
919	8532	1972	7	24	1972-07-24 00:00:00	8527	0	\N	\N	\N	2af15d65-b06b-4cfd-8472-951fc5e064fe	F	0	white	0	italian	0
1098	8532	1955	12	10	1955-12-10 00:00:00	8527	0	\N	\N	\N	3432b412-e859-4de5-8947-711755d1d0ea	F	0	white	0	english	0
784	8507	1959	5	2	1959-05-02 00:00:00	8515	0	\N	\N	\N	248050b7-8e1d-4a41-8371-4630070c513b	M	0	asian	0	asian_indian	0
1015	8507	1953	10	26	1953-10-26 00:00:00	8516	0	\N	\N	\N	309f4e97-c11f-4340-be04-7b51d738d01d	M	0	black	0	west_indian	0
1180	8507	1956	4	11	1956-04-11 00:00:00	8527	0	\N	\N	\N	37ff95fe-6432-47d5-aeb8-ce88b4a812a3	M	0	white	0	polish	0
1175	8507	1940	7	28	1940-07-28 00:00:00	8516	0	\N	\N	\N	37cb9dfa-b367-48c1-b32a-0c371c588c65	M	0	black	0	dominican	0
973	8507	1914	8	17	1914-08-17 00:00:00	8527	0	\N	\N	\N	2e3ee2b5-2499-485b-9467-b8622d47f4e5	M	0	white	0	irish	0
761	8507	1978	12	15	1978-12-15 00:00:00	0	38003563	\N	\N	\N	2342e9d6-6137-4d4d-8e0d-35849899834f	M	0	hispanic	0	puerto_rican	0
1083	8532	1966	5	19	1966-05-19 00:00:00	8527	0	\N	\N	\N	337d75be-2fdb-4eca-ae7d-8b9d6eaffc69	F	0	white	0	english	0
1194	8532	1960	9	19	1960-09-19 00:00:00	8527	0	\N	\N	\N	3871bf8e-d998-4e96-b5e0-619ed61ff61c	F	0	white	0	irish	0
902	8507	1950	8	26	1950-08-26 00:00:00	8527	0	\N	\N	\N	29ee9553-a98f-4b47-8c35-ce96b7ea5848	M	0	white	0	portuguese	0
865	8507	1941	4	23	1941-04-23 00:00:00	8515	0	\N	\N	\N	281f142e-02a5-40f0-8d7e-349498829e95	M	0	asian	0	chinese	0
1497	8532	1940	3	15	1940-03-15 00:00:00	0	38003563	\N	\N	\N	46971339-c2fc-413d-8e3e-07c5aa48ca1c	F	0	hispanic	0	puerto_rican	0
1025	8532	1940	6	22	1940-06-22 00:00:00	0	38003563	\N	\N	\N	30fc94dd-4abf-4b15-b999-ef0caa787bb7	F	0	hispanic	0	puerto_rican	0
1556	8532	1973	3	29	1973-03-29 00:00:00	0	0	\N	\N	\N	492e9dbe-49df-42cf-999c-f34fef45b08b	F	0	other	0	arab	0
1158	8532	1979	8	5	1979-08-05 00:00:00	8527	0	\N	\N	\N	36f0562b-3877-4ae8-9d53-faa81beb7a47	F	0	white	0	italian	0
1017	8507	1958	6	15	1958-06-15 00:00:00	8516	0	\N	\N	\N	30a08e17-3661-473c-be1d-ce87da5340ea	M	0	black	0	dominican	0
1739	8507	1968	4	11	1968-04-11 00:00:00	8527	0	\N	\N	\N	51a474b8-1a6e-450d-98f1-d80d68342e74	M	0	white	0	italian	0
1431	8532	1949	10	1	1949-10-01 00:00:00	8527	0	\N	\N	\N	43e6fe68-af49-45ff-bcb9-29a486944d52	F	0	white	0	swedish	0
771	8532	1958	12	10	1958-12-10 00:00:00	8527	0	\N	\N	\N	23da107f-d7b6-4e84-8629-0a6aecb1b132	F	0	white	0	german	0
759	8507	1945	1	3	1945-01-03 00:00:00	8527	0	\N	\N	\N	233bdd54-0e54-48a6-bc34-97a01f5ea892	M	0	white	0	polish	0
949	8507	1958	3	17	1958-03-17 00:00:00	8527	0	\N	\N	\N	2ce51c51-b084-4ce1-812e-409fef6baa29	M	0	white	0	american	0
847	8532	1966	4	8	1966-04-08 00:00:00	8527	0	\N	\N	\N	27258044-8469-49eb-9b09-e3acf517a0fc	F	0	white	0	english	0
1335	8532	1978	11	20	1978-11-20 00:00:00	8527	0	\N	\N	\N	3f6ce124-79af-494f-9e69-6e21e9005a31	F	0	white	0	polish	0
1154	8532	1970	9	6	1970-09-06 00:00:00	8515	0	\N	\N	\N	36d24c7d-96b3-4b0c-ae5f-c233479738d9	F	0	asian	0	chinese	0
608	8507	1973	12	19	1973-12-19 00:00:00	8527	0	\N	\N	\N	1c4a2ee1-ae5d-4d7c-ac09-f1c729cf0175	M	0	white	0	italian	0
841	8507	1952	1	16	1952-01-16 00:00:00	8527	0	\N	\N	\N	26d0bf02-7f3c-47e3-8e69-ccc4918292a6	M	0	white	0	irish	0
1659	8507	1969	3	17	1969-03-17 00:00:00	0	38003563	\N	\N	\N	4df4cc45-9bca-4c13-9573-d0b6a0796514	M	0	hispanic	0	mexican	0
1376	8507	1977	11	11	1977-11-11 00:00:00	8516	0	\N	\N	\N	41390516-54e0-4660-91ea-b5aa1edede07	M	0	black	0	african	0
1208	8507	1939	12	26	1939-12-26 00:00:00	8527	0	\N	\N	\N	393f1b75-4e72-4225-a88e-6f632d0d4e30	M	0	white	0	irish	0
1709	8532	1936	9	19	1936-09-19 00:00:00	8527	0	\N	\N	\N	50407671-3d59-46d8-94a8-4267c8ec9757	F	0	white	0	italian	0
672	8532	1955	5	2	1955-05-02 00:00:00	8527	0	\N	\N	\N	1f2d07ae-a22b-4466-8543-fc0468f06182	F	0	white	0	scottish	0
1036	8532	1969	9	5	1969-09-05 00:00:00	0	38003563	\N	\N	\N	315e9925-1df1-4b3e-aab3-bc0d33abb25d	F	0	hispanic	0	puerto_rican	0
935	8507	1930	3	12	1930-03-12 00:00:00	8527	0	\N	\N	\N	2c290374-5b73-4f9f-aae2-66e3382283cc	M	0	white	0	italian	0
967	8532	1932	10	15	1932-10-15 00:00:00	8527	0	\N	\N	\N	2dff8845-00cb-482c-99c8-bb92b812b708	F	0	white	0	american	0
1781	8507	1941	6	10	1941-06-10 00:00:00	8515	0	\N	\N	\N	537d0ca7-07fa-4fe8-9910-78ef20c49db2	M	0	asian	0	asian_indian	0
1282	8532	1976	4	3	1976-04-03 00:00:00	8527	0	\N	\N	\N	3cca78b8-d3be-4442-ab59-bbd18628e038	F	0	white	0	italian	0
1088	8532	1972	7	30	1972-07-30 00:00:00	8527	0	\N	\N	\N	33cde2d1-43e7-4d72-95fc-3aad3731055c	F	0	white	0	french	0
1228	8532	1974	7	6	1974-07-06 00:00:00	8516	0	\N	\N	\N	3a77ab30-b22e-408d-858f-f37725d393f7	F	0	black	0	african	0
1117	8507	1935	11	23	1935-11-23 00:00:00	8527	0	\N	\N	\N	354e720a-c36f-4788-ba97-ac3ab02bb4dc	M	0	white	0	irish	0
1491	8507	1968	11	5	1968-11-05 00:00:00	8527	0	\N	\N	\N	4671dddb-aee0-41df-8ddc-b77c8548eba4	M	0	white	0	scottish	0
1454	8532	1971	9	10	1971-09-10 00:00:00	0	38003563	\N	\N	\N	44c3bc6c-7ef7-45a1-826c-656270d7f7aa	F	0	hispanic	0	puerto_rican	0
1159	8532	1980	7	26	1980-07-26 00:00:00	8516	0	\N	\N	\N	36f69d36-a2aa-48ba-ae6f-27b69d37cba9	F	0	black	0	west_indian	0
1120	8532	1957	12	2	1957-12-02 00:00:00	8527	0	\N	\N	\N	356ce8c7-db5e-4322-9f10-f77c8f9c3f14	F	0	white	0	irish	0
893	8532	1953	9	21	1953-09-21 00:00:00	8515	0	\N	\N	\N	293656f7-496b-4b04-ae27-239fd1463f5f	F	0	asian	0	chinese	0
1238	8532	1955	11	8	1955-11-08 00:00:00	8527	0	\N	\N	\N	3ac2575b-e818-4e45-9236-b0f36853e549	F	0	white	0	italian	0
1018	8507	1971	1	11	1971-01-11 00:00:00	8527	0	\N	\N	\N	30af8477-4db7-41be-9b16-88b09da171cf	M	0	white	0	italian	0
1410	8532	1967	3	15	1967-03-15 00:00:00	8527	0	\N	\N	\N	42d73ed6-ca57-4798-9fe0-95f51ad0ea42	F	0	white	0	greek	0
948	8507	1958	9	19	1958-09-19 00:00:00	8527	0	\N	\N	\N	2ce2aef3-d0d8-42f2-ae8b-7aed00c64ec3	M	0	white	0	portuguese	0
1466	8532	1968	3	5	1968-03-05 00:00:00	8527	0	\N	\N	\N	4556794e-f611-428d-a972-7d40780432d0	F	0	white	0	german	0
1151	8532	1984	11	20	1984-11-20 00:00:00	8515	0	\N	\N	\N	36b70d5d-1518-49f3-ba8c-5659b22c69e3	F	0	asian	0	asian_indian	0
1447	8532	1957	8	1	1957-08-01 00:00:00	0	38003563	\N	\N	\N	448fc69d-82fe-48dd-91e4-4bd32a4b4ec2	F	0	hispanic	0	puerto_rican	0
1408	8507	1943	8	2	1943-08-02 00:00:00	8527	0	\N	\N	\N	42a5a887-de93-4d18-a863-f90c005ea15b	M	0	white	0	irish	0
866	8507	1958	9	14	1958-09-14 00:00:00	8515	0	\N	\N	\N	282bdf78-336d-4251-8636-144321185c0f	M	0	asian	0	chinese	0
1613	8532	1954	5	15	1954-05-15 00:00:00	8527	0	\N	\N	\N	4c208176-9340-456a-8c7b-43f8d3dd88e3	F	0	white	0	italian	0
915	8532	1959	12	26	1959-12-26 00:00:00	8527	0	\N	\N	\N	2ae19789-9c99-4726-842f-3f7f11ebe21a	F	0	white	0	english	0
1209	8507	1977	9	8	1977-09-08 00:00:00	8527	0	\N	\N	\N	394bb9ec-d940-4552-b657-8151ec4b4f7d	M	0	white	0	english	0
1202	8532	1980	7	6	1980-07-06 00:00:00	8527	0	\N	\N	\N	38d9c57b-e3a8-4ce1-9a09-e712ef1cc466	F	0	white	0	italian	0
1000	8532	1963	2	12	1963-02-12 00:00:00	8527	0	\N	\N	\N	2f959862-719e-43d4-922b-dfec17f6b967	F	0	white	0	irish	0
1091	8532	1956	6	7	1956-06-07 00:00:00	8527	0	\N	\N	\N	33ed1a06-96c3-4b46-a4fe-5d8a47941752	F	0	white	0	italian	0
964	8532	1974	11	3	1974-11-03 00:00:00	0	38003563	\N	\N	\N	2da66332-11d1-4502-8f85-e7357d33f7ac	F	0	hispanic	0	puerto_rican	0
1468	8532	1949	6	15	1949-06-15 00:00:00	8527	0	\N	\N	\N	4577f2bb-bb8f-4a4d-9aca-c42bdf24ce75	F	0	white	0	italian	0
1145	8532	1938	8	24	1938-08-24 00:00:00	8527	0	\N	\N	\N	365b5490-e9ca-4abe-823d-50f764fc4b60	F	0	white	0	english	0
1357	8507	1974	12	27	1974-12-27 00:00:00	8527	0	\N	\N	\N	40682357-88c3-4080-9eb6-c349d4588b82	M	0	white	0	irish	0
1079	8532	1961	3	19	1961-03-19 00:00:00	8527	0	\N	\N	\N	335a647a-4bc9-46cf-bfba-e450b2ed1c1c	F	0	white	0	american	0
1232	8507	1964	12	14	1964-12-14 00:00:00	8527	0	\N	\N	\N	3a956017-0cec-41db-ba4f-f28f7c45fc13	M	0	white	0	german	0
870	8532	1959	12	8	1959-12-08 00:00:00	8516	0	\N	\N	\N	288a1337-2eeb-42a9-a180-0abfa13f95dc	F	0	black	0	african	0
1057	8507	1961	7	20	1961-07-20 00:00:00	8527	0	\N	\N	\N	323b476c-2c70-41a3-8af8-cb18dde6dc39	M	0	white	0	irish	0
1258	8532	1967	3	13	1967-03-13 00:00:00	8527	0	\N	\N	\N	3b6af001-a084-49e1-90ca-af9e6f6b5625	F	0	white	0	american	0
1249	8507	1968	1	25	1968-01-25 00:00:00	8516	0	\N	\N	\N	3b1782b7-15aa-4444-b1bb-7de7a93e24df	M	0	black	0	dominican	0
1051	8532	1965	2	9	1965-02-09 00:00:00	8527	0	\N	\N	\N	320dec82-f58a-4f51-9789-83dcf9e16b85	F	0	white	0	irish	0
1162	8507	1919	11	1	1919-11-01 00:00:00	8516	0	\N	\N	\N	3723747a-5137-43c5-97f5-f7fbcdd869c6	M	0	black	0	dominican	0
1101	8507	1974	8	18	1974-08-18 00:00:00	8527	0	\N	\N	\N	34630664-234b-4fc0-822a-9a40d391aeab	M	0	white	0	italian	0
1401	8532	1973	1	28	1973-01-28 00:00:00	8527	0	\N	\N	\N	425bdb7c-cef6-4107-ad92-8296d880c8d4	F	0	white	0	german	0
1062	8507	1966	6	19	1966-06-19 00:00:00	0	38003563	\N	\N	\N	32791e7d-7fad-4fde-be65-aeceac59ab2d	M	0	hispanic	0	south_american	0
1115	8532	1948	7	5	1948-07-05 00:00:00	8527	0	\N	\N	\N	3546be0e-3da5-4e0f-bef3-6b358eb854f9	F	0	white	0	scottish	0
1545	8507	1968	12	6	1968-12-06 00:00:00	8527	0	\N	\N	\N	48adafdc-17bf-485d-80a5-4ed7873f9f47	M	0	white	0	italian	0
1143	8507	1971	5	28	1971-05-28 00:00:00	8516	0	\N	\N	\N	364d9ff4-0c57-4e64-a59c-f5246c92659a	M	0	black	0	west_indian	0
1634	8532	1938	9	9	1938-09-09 00:00:00	8527	0	\N	\N	\N	4cebee23-0af5-4c10-b9a0-54eb1f091459	F	0	white	0	polish	0
1264	8507	1947	1	3	1947-01-03 00:00:00	8527	0	\N	\N	\N	3be36fd4-2411-42a5-a5a8-06235bb9246d	M	0	white	0	irish	0
1113	8532	1971	11	16	1971-11-16 00:00:00	8527	0	\N	\N	\N	3528f8c1-55ad-4540-ad63-fb7cadc58b1b	F	0	white	0	english	0
1902	8507	1943	11	28	1943-11-28 00:00:00	8527	0	\N	\N	\N	58e1f88b-6bc1-49aa-b17a-65379e4c2f66	M	0	white	0	english	0
1505	8507	1953	9	5	1953-09-05 00:00:00	8516	0	\N	\N	\N	46e26108-d600-4974-9235-fa2a1216c3db	M	0	black	0	west_indian	0
885	8507	1975	4	13	1975-04-13 00:00:00	8527	0	\N	\N	\N	290c0d3a-b99c-4f6b-9523-7809ed138c82	M	0	white	0	english	0
850	8507	1947	2	18	1947-02-18 00:00:00	8527	0	\N	\N	\N	275f2050-5d53-4de8-b4c5-c639e2edcf36	M	0	white	0	irish	0
1123	8532	1965	5	27	1965-05-27 00:00:00	8516	0	\N	\N	\N	3594a046-cb88-48c5-be7f-9703d301d7db	F	0	black	0	african	0
931	8507	1960	9	16	1960-09-16 00:00:00	0	38003563	\N	\N	\N	2bdab547-a0e4-4f77-8ac1-84e45e53fa0d	M	0	hispanic	0	puerto_rican	0
1345	8507	1966	3	15	1966-03-15 00:00:00	8527	0	\N	\N	\N	3fe46ed2-5862-4b64-a0cc-0474a3a62fe6	M	0	white	0	english	0
1361	8532	1939	9	4	1939-09-04 00:00:00	8527	0	\N	\N	\N	40797cd0-00b2-452f-81db-3a1fbe5cf549	F	0	white	0	italian	0
652	8532	1968	2	13	1968-02-13 00:00:00	8527	0	\N	\N	\N	1e1ed1a7-723c-45c8-a648-4e76188fa585	F	0	white	0	irish	0
933	8507	1972	9	26	1972-09-26 00:00:00	8527	0	\N	\N	\N	2bf2fe82-a519-4512-b833-130c6214d641	M	0	white	0	swedish	0
1761	8532	1952	8	25	1952-08-25 00:00:00	8527	0	\N	\N	\N	52be3179-d094-4ebf-8155-d458bd1892a0	F	0	white	0	german	0
1578	8532	1947	4	6	1947-04-06 00:00:00	8527	0	\N	\N	\N	4a447e8c-9660-41d0-9890-50844cf3c8d1	F	0	white	0	irish	0
1309	8532	1955	3	29	1955-03-29 00:00:00	8527	0	\N	\N	\N	3dfa309f-55f0-44a4-bbeb-b67870dc871f	F	0	white	0	italian	0
1755	8532	1959	6	17	1959-06-17 00:00:00	8527	0	\N	\N	\N	529a6e2a-d85b-49c6-b030-1a59624bc52e	F	0	white	0	italian	0
726	8532	1953	8	30	1953-08-30 00:00:00	8515	0	\N	\N	\N	219c02ed-0b6b-4987-8cd8-4d468744bce0	F	0	asian	0	chinese	0
1146	8532	1959	1	15	1959-01-15 00:00:00	8516	0	\N	\N	\N	366c4662-0699-430e-8e46-1804a022a489	F	0	black	0	african	0
1137	8532	1951	9	14	1951-09-14 00:00:00	8527	0	\N	\N	\N	35fed4aa-cbde-4007-85a5-b04d6b92e4e6	F	0	white	0	irish	0
1368	8507	1956	3	21	1956-03-21 00:00:00	8527	0	\N	\N	\N	40a58f7b-af30-404d-9b65-150046e56562	M	0	white	0	polish	0
1980	8532	1972	9	10	1972-09-10 00:00:00	0	38003563	\N	\N	\N	5c2af792-63ff-4de0-8518-787f0b50986b	F	0	hispanic	0	mexican	0
1432	8507	1961	8	29	1961-08-29 00:00:00	8527	0	\N	\N	\N	43ee0314-fc1a-4655-9304-e1c02392611f	M	0	white	0	scottish	0
1242	8532	1959	3	11	1959-03-11 00:00:00	8516	0	\N	\N	\N	3adae4b5-39aa-4e7f-8884-357800e8e309	F	0	black	0	african	0
1385	8532	1960	5	13	1960-05-13 00:00:00	8527	0	\N	\N	\N	417c1a25-9c02-41d2-9762-55b0dff7bd7a	F	0	white	0	english	0
1201	8507	1972	10	11	1972-10-11 00:00:00	8527	0	\N	\N	\N	38d2976d-3bc3-4bef-8be5-219bc8266233	M	0	white	0	scottish	0
1689	8507	1940	11	28	1940-11-28 00:00:00	8527	0	\N	\N	\N	4f59e815-e9c4-4a72-ac7e-bbc69d1e4188	M	0	white	0	american	0
1496	8532	1920	4	18	1920-04-18 00:00:00	8527	0	\N	\N	\N	46916315-b03c-403c-9a0c-af538b76d851	F	0	white	0	irish	0
1265	8532	1980	5	11	1980-05-11 00:00:00	8527	0	\N	\N	\N	3bf53caf-391e-4f14-8ec4-1fe2d15702c0	F	0	white	0	italian	0
1321	8532	1959	7	2	1959-07-02 00:00:00	8527	0	\N	\N	\N	3e97b640-2d60-4af4-a408-b9db0337785e	F	0	white	0	italian	0
1073	8532	1936	6	25	1936-06-25 00:00:00	8527	0	\N	\N	\N	33339d45-940e-490e-bff8-b0c1a6d5cef9	F	0	white	0	german	0
1285	8507	1954	3	22	1954-03-22 00:00:00	8515	0	\N	\N	\N	3cd0c233-e8b4-4f15-8a12-01cb687b5978	M	0	asian	0	chinese	0
1068	8507	1973	9	14	1973-09-14 00:00:00	0	38003563	\N	\N	\N	32ba1d84-3ec4-4118-afd9-c4d2f6d7a889	M	0	hispanic	0	puerto_rican	0
1524	8532	1967	1	12	1967-01-12 00:00:00	8527	0	\N	\N	\N	48104b16-42da-4769-a659-f1e2f9e6b5d8	F	0	white	0	english	0
962	8507	1950	11	10	1950-11-10 00:00:00	8527	0	\N	\N	\N	2d9c2056-0b92-4cae-9a6d-1b2d0b2a8ea0	M	0	white	0	french	0
1642	8532	1951	5	22	1951-05-22 00:00:00	8516	0	\N	\N	\N	4d31f3f2-ee7a-4c99-b9cb-54d31f6743fc	F	0	black	0	dominican	0
1253	8532	1955	3	9	1955-03-09 00:00:00	8527	0	\N	\N	\N	3b5b2df6-2007-41bf-957c-41947508dc74	F	0	white	0	french_canadian	0
1537	8532	1956	6	13	1956-06-13 00:00:00	8527	0	\N	\N	\N	4856726d-764b-4d9d-9bf6-081df68c5793	F	0	white	0	polish	0
1526	8532	1971	12	30	1971-12-30 00:00:00	8527	0	\N	\N	\N	4815c6a6-3f18-431f-98e6-37f3600a1164	F	0	white	0	irish	0
1016	8532	1967	6	14	1967-06-14 00:00:00	8527	0	\N	\N	\N	309fbc9c-929e-42e0-b224-927846bc3643	F	0	white	0	italian	0
1751	8507	1977	9	28	1977-09-28 00:00:00	8527	0	\N	\N	\N	524f0016-0c5b-49a5-85cb-173aa971e0f6	M	0	white	0	scottish	0
1193	8507	1948	9	30	1948-09-30 00:00:00	8515	0	\N	\N	\N	386c8408-6e02-46d8-869b-6e66a72223ee	M	0	asian	0	asian_indian	0
1231	8532	1939	1	11	1939-01-11 00:00:00	8527	0	\N	\N	\N	3a8ad7f9-ad84-44e6-8129-b8ffb49e1eb5	F	0	white	0	italian	0
1303	8507	1976	5	23	1976-05-23 00:00:00	8527	0	\N	\N	\N	3dbb4a9f-bdbd-42fd-8be8-ba5640ba9c8b	M	0	white	0	italian	0
1086	8507	1965	6	11	1965-06-11 00:00:00	8527	0	\N	\N	\N	33a766ba-bf85-4cd4-85a2-88d00ece71b1	M	0	white	0	polish	0
1510	8532	1958	11	2	1958-11-02 00:00:00	8527	0	\N	\N	\N	474260ba-fd6f-4d76-9f89-5c1bf02f7078	F	0	white	0	french	0
1124	8507	1935	10	6	1935-10-06 00:00:00	8527	0	\N	\N	\N	35b15afd-a609-449d-ae83-3a086447dc49	M	0	white	0	italian	0
1482	8507	1974	10	19	1974-10-19 00:00:00	8527	0	\N	\N	\N	4628f13f-d5df-4900-9042-1830ff301ebd	M	0	white	0	french_canadian	0
1173	8532	1944	9	11	1944-09-11 00:00:00	8527	0	\N	\N	\N	37a9afe7-2e8d-4616-a002-c2959c18e708	F	0	white	0	irish	0
1441	8532	1967	6	26	1967-06-26 00:00:00	8527	0	\N	\N	\N	4462d0bd-65d0-44a4-aad3-5b6c557802a3	F	0	white	0	german	0
1197	8507	1978	6	4	1978-06-04 00:00:00	8527	0	\N	\N	\N	388c7b41-6305-4c52-9741-08296c100861	M	0	white	0	irish	0
1283	8532	1959	3	16	1959-03-16 00:00:00	0	38003563	\N	\N	\N	3cca7a90-5c92-4203-a5b3-3305073e0029	F	0	hispanic	0	central_american	0
906	8532	1972	2	29	1972-02-29 00:00:00	8515	0	\N	\N	\N	2a56f2f8-950b-4747-8745-09d7c1e1c4d6	F	0	asian	0	chinese	0
1211	8532	1963	10	23	1963-10-23 00:00:00	8527	0	\N	\N	\N	395fba6d-c613-4ddd-9f20-3da524941802	F	0	white	0	swedish	0
1359	8532	1930	7	8	1930-07-08 00:00:00	8516	0	\N	\N	\N	406de1dd-75cf-451d-8cf5-a3ca8d897e06	F	0	black	0	dominican	0
1348	8532	1911	5	1	1911-05-01 00:00:00	8516	0	\N	\N	\N	400fedff-5cb1-41ea-ad87-133ea18278c6	F	0	black	0	west_indian	0
1133	8532	1965	7	9	1965-07-09 00:00:00	8527	0	\N	\N	\N	35dc58f3-65c0-4ef8-a804-8a92b9755608	F	0	white	0	italian	0
1276	8507	1957	3	8	1957-03-08 00:00:00	8515	0	\N	\N	\N	3c9e0a5d-d161-4d33-b1fa-67c38dbc0b31	M	0	asian	0	asian_indian	0
1185	8507	1936	11	29	1936-11-29 00:00:00	8527	0	\N	\N	\N	383d8286-6d79-47cf-b32d-67783827195e	M	0	white	0	italian	0
1605	8507	1936	6	28	1936-06-28 00:00:00	8527	0	\N	\N	\N	4bb1069b-8ef4-4989-906c-59d678a434f4	M	0	white	0	portuguese	0
1226	8507	1980	4	6	1980-04-06 00:00:00	8515	0	\N	\N	\N	3a361a37-631d-4119-8960-81357712a830	M	0	asian	0	chinese	0
1217	8507	1971	11	19	1971-11-19 00:00:00	0	38003563	\N	\N	\N	39980fd9-d1d3-40fc-ad0f-22e5ff2b8bc9	M	0	hispanic	0	puerto_rican	0
1683	8532	1971	7	22	1971-07-22 00:00:00	8516	0	\N	\N	\N	4f1e766a-a121-4c22-9308-7612b684777f	F	0	black	0	dominican	0
1261	8532	1970	5	16	1970-05-16 00:00:00	8527	0	\N	\N	\N	3b9a85fa-4350-4413-959e-dedfd649440d	F	0	white	0	polish	0
1885	8532	1973	2	27	1973-02-27 00:00:00	8527	0	\N	\N	\N	57ebb1fe-53f1-4635-9037-9921247a0b75	F	0	white	0	italian	0
1315	8532	1959	6	9	1959-06-09 00:00:00	8527	0	\N	\N	\N	3e361689-b30e-4039-ba58-746f3a170dae	F	0	white	0	french_canadian	0
1205	8532	1959	10	22	1959-10-22 00:00:00	8527	0	\N	\N	\N	38fc4403-824d-4b6c-aa14-202b445bfaff	F	0	white	0	american	0
2094	8507	1944	1	9	1944-01-09 00:00:00	8527	0	\N	\N	\N	61a1fd90-3229-4694-a46d-3a36f9fe5574	M	0	white	0	italian	0
1585	8507	1929	7	28	1929-07-28 00:00:00	0	38003563	\N	\N	\N	4a9f057c-4a3b-41e3-b79b-7c34be3d76b4	M	0	hispanic	0	puerto_rican	0
921	8532	1966	6	21	1966-06-21 00:00:00	0	38003563	\N	\N	\N	2b5284f4-c518-4608-8ffa-09032a4792a2	F	0	hispanic	0	puerto_rican	0
958	8507	1957	1	6	1957-01-06 00:00:00	8527	0	\N	\N	\N	2d6915e8-3a20-431f-a02e-80fedc809724	M	0	white	0	italian	0
1273	8532	1935	10	14	1935-10-14 00:00:00	8527	0	\N	\N	\N	3c614ab9-926f-4dfe-8059-1aa63f381a56	F	0	white	0	english	0
1177	8532	1963	4	29	1963-04-29 00:00:00	0	38003563	\N	\N	\N	37d5b490-b3d6-45e1-b64e-2518fb873679	F	0	hispanic	0	puerto_rican	0
1661	8507	1955	6	30	1955-06-30 00:00:00	8527	0	\N	\N	\N	4e11c07f-538c-42f6-8575-71b84fcd0e65	M	0	white	0	english	0
1563	8507	1956	6	23	1956-06-23 00:00:00	8516	0	\N	\N	\N	4985e7a1-c9cb-4ede-9b66-4362b815d675	M	0	black	0	west_indian	0
762	8507	1954	7	14	1954-07-14 00:00:00	8527	0	\N	\N	\N	23734d67-3ef2-4041-a013-7023acd7de56	M	0	white	0	english	0
1257	8507	1972	10	28	1972-10-28 00:00:00	8527	0	\N	\N	\N	3b675d58-3cf0-47e0-8484-47e5e11d3689	M	0	white	0	italian	0
1842	8507	1965	8	20	1965-08-20 00:00:00	8527	0	\N	\N	\N	56469975-460b-4706-a4ac-87309fe821b2	M	0	white	0	french	0
1813	8507	1981	6	20	1981-06-20 00:00:00	8527	0	\N	\N	\N	54eea0af-5578-4f9a-abfe-7269356305fe	M	0	white	0	french_canadian	0
1387	8532	1969	4	1	1969-04-01 00:00:00	8527	0	\N	\N	\N	41ac412e-420b-452f-8cce-d94f7ed9619b	F	0	white	0	greek	0
1918	8507	1968	8	10	1968-08-10 00:00:00	0	38003563	\N	\N	\N	598f384c-bdc2-4bc8-9772-9f9c0de09324	M	0	hispanic	0	mexican	0
883	8532	1961	6	15	1961-06-15 00:00:00	8527	0	\N	\N	\N	290826ff-8965-4eae-98cf-12e46021b803	F	0	white	0	irish	0
1174	8532	1940	1	13	1940-01-13 00:00:00	8527	0	\N	\N	\N	37b6ffe5-56f9-4936-bb2a-237c00c5018d	F	0	white	0	french_canadian	0
1259	8507	1948	3	29	1948-03-29 00:00:00	8527	0	\N	\N	\N	3b76d06c-531c-4fbb-adbe-bd8632b6aed4	M	0	white	0	scottish	0
1460	8532	1981	5	30	1981-05-30 00:00:00	8527	0	\N	\N	\N	44ecdd8f-f167-4f36-ac14-aa60ed6a3af5	F	0	white	0	scottish	0
2064	8532	1976	4	7	1976-04-07 00:00:00	8527	0	\N	\N	\N	5fd9d6ca-58ae-4d57-aa20-fe492ae2b512	F	0	white	0	french_canadian	0
1518	8532	1953	7	10	1953-07-10 00:00:00	8516	0	\N	\N	\N	47b1ea39-af82-4f75-80ed-360959e07de1	F	0	black	0	west_indian	0
1289	8507	1962	3	13	1962-03-13 00:00:00	8527	0	\N	\N	\N	3d027411-364e-4127-802e-4b67a273ad3c	M	0	white	0	german	0
1523	8507	1956	4	10	1956-04-10 00:00:00	8527	0	\N	\N	\N	480e5547-5594-4f4d-ad4b-07dfe20a91ea	M	0	white	0	italian	0
1223	8507	1951	3	9	1951-03-09 00:00:00	8527	0	\N	\N	\N	3a1eb1e3-a8b3-4c1b-bb08-b92bac2dfeb8	M	0	white	0	french	0
1852	8532	1973	3	7	1973-03-07 00:00:00	0	38003563	\N	\N	\N	56a9e76b-0a7a-4973-8fba-be8e96224034	F	0	hispanic	0	south_american	0
1662	8507	1964	3	13	1964-03-13 00:00:00	0	38003563	\N	\N	\N	4e13e791-feb5-42fe-ab7d-a4cc7cbec426	M	0	hispanic	0	puerto_rican	0
1314	8507	1930	2	15	1930-02-15 00:00:00	0	38003563	\N	\N	\N	3e33ec54-4d3d-4040-b834-39b0aa9e73f4	M	0	hispanic	0	south_american	0
1459	8507	1942	12	10	1942-12-10 00:00:00	8527	0	\N	\N	\N	44e92433-6665-49a4-b80a-ae788bdee717	M	0	white	0	german	0
1245	8532	1934	9	7	1934-09-07 00:00:00	8527	0	\N	\N	\N	3af77263-c8b7-45f1-a5cb-a345cfde7526	F	0	white	0	polish	0
1439	8532	1977	8	13	1977-08-13 00:00:00	8516	0	\N	\N	\N	44556d91-922e-4f63-a75b-c89b53aefce6	F	0	black	0	african	0
1206	8507	1964	2	10	1964-02-10 00:00:00	8527	0	\N	\N	\N	392d055c-8885-4c94-a0d4-dd1645f8cdde	M	0	white	0	italian	0
1572	8532	1962	6	22	1962-06-22 00:00:00	8527	0	\N	\N	\N	4a05ac87-7d33-4a7e-98ce-b7ee5b848345	F	0	white	0	italian	0
1122	8507	1969	11	17	1969-11-17 00:00:00	0	38003563	\N	\N	\N	35857975-db67-4217-9b0f-86e7d215187f	M	0	hispanic	0	puerto_rican	0
1670	8507	1964	1	5	1964-01-05 00:00:00	8515	0	\N	\N	\N	4e6318f4-2f8b-4fb9-a793-14568b008356	M	0	asian	0	asian_indian	0
1334	8507	1969	2	23	1969-02-23 00:00:00	8516	0	\N	\N	\N	3f5274b4-dfa7-4465-995a-0189f0007f15	M	0	black	0	african	0
1655	8507	1971	10	1	1971-10-01 00:00:00	0	38003563	\N	\N	\N	4dc95e84-5593-4e55-8fdc-3e69855d3b79	M	0	hispanic	0	central_american	0
1574	8507	1958	10	3	1958-10-03 00:00:00	8527	0	\N	\N	\N	4a0dbaff-1a51-4f66-ab59-a3c47ca8780e	M	0	white	0	polish	0
1070	8507	1972	11	2	1972-11-02 00:00:00	8527	0	\N	\N	\N	3306013b-f749-48f1-a0dd-dc2c384f7cdb	M	0	white	0	american	0
1796	8532	1979	4	4	1979-04-04 00:00:00	8527	0	\N	\N	\N	543b2c05-76ec-44d6-ba6a-1ce214383425	F	0	white	0	irish	0
1292	8507	1950	8	15	1950-08-15 00:00:00	8515	0	\N	\N	\N	3d250d95-a3b1-4a01-ad8e-d6e5e591dc9f	M	0	asian	0	chinese	0
1520	8507	1936	6	28	1936-06-28 00:00:00	8527	0	\N	\N	\N	47cbe3e0-6fea-413d-9322-e7fd565fd265	M	0	white	0	portuguese	0
1377	8532	1979	12	4	1979-12-04 00:00:00	8527	0	\N	\N	\N	414008b2-d6ee-4fc3-a1b6-12bc6dafe46e	F	0	white	0	italian	0
1188	8507	1975	2	1	1975-02-01 00:00:00	8527	0	\N	\N	\N	384e99c4-3b21-46e1-9238-acc33d7e792a	M	0	white	0	german	0
1590	8507	1960	4	2	1960-04-02 00:00:00	8527	0	\N	\N	\N	4ad5d32a-1d07-46c5-850b-27604dce7e74	M	0	white	0	german	0
1325	8507	1964	4	12	1964-04-12 00:00:00	0	38003563	\N	\N	\N	3ed86762-68e0-4992-adce-c5bafd9cab2f	M	0	hispanic	0	puerto_rican	0
1782	8532	1952	11	25	1952-11-25 00:00:00	8527	0	\N	\N	\N	539942ef-05b9-4f85-b6fa-66aff2b0c1e0	F	0	white	0	german	0
1328	8532	1945	7	26	1945-07-26 00:00:00	0	38003563	\N	\N	\N	3eee1b0d-ed23-47d1-8a3f-41299175fbe9	F	0	hispanic	0	central_american	0
1543	8507	1940	10	20	1940-10-20 00:00:00	8527	0	\N	\N	\N	48960cc5-d6cc-4625-aa73-cb04fd243cd7	M	0	white	0	irish	0
1426	8507	1952	3	11	1952-03-11 00:00:00	8527	0	\N	\N	\N	43ccf6d1-b89c-44d1-b4f2-45e74d0006ce	M	0	white	0	irish	0
1397	8532	1976	11	19	1976-11-19 00:00:00	8515	0	\N	\N	\N	4238ec15-42e4-419b-be63-f000ecc2ebbd	F	0	asian	0	asian_indian	0
1116	8507	1965	12	10	1965-12-10 00:00:00	8527	0	\N	\N	\N	3547049c-a18d-4c35-9591-085cc5b177df	M	0	white	0	portuguese	0
1229	8532	1954	5	15	1954-05-15 00:00:00	8527	0	\N	\N	\N	3a838dd3-87ee-4a09-93ae-7bf8e3f96115	F	0	white	0	italian	0
1443	8532	1977	3	25	1977-03-25 00:00:00	8527	0	\N	\N	\N	4468b590-f408-4d74-9190-eaccee59c3cc	F	0	white	0	english	0
1448	8532	1973	3	28	1973-03-28 00:00:00	8516	0	\N	\N	\N	44953b66-1f41-46f0-902f-4f1481aa3aeb	F	0	black	0	african	0
1271	8532	1967	1	8	1967-01-08 00:00:00	0	38003563	\N	\N	\N	3c4ab6af-97f7-4081-b081-c8cd027dafec	F	0	hispanic	0	puerto_rican	0
1461	8532	1966	10	27	1966-10-27 00:00:00	8527	0	\N	\N	\N	45242da1-e77d-4431-ba13-ae24dc74dadc	F	0	white	0	irish	0
1239	8532	1970	6	25	1970-06-25 00:00:00	8516	0	\N	\N	\N	3ac71a7c-1255-4a6a-9317-78405394bbdc	F	0	black	0	african	0
1759	8532	1984	12	31	1984-12-31 00:00:00	0	38003563	\N	\N	\N	52ae19b4-eff9-4bba-a616-56cb64e04ebe	F	0	hispanic	0	central_american	0
1305	8507	1964	7	9	1964-07-09 00:00:00	8527	0	\N	\N	\N	3dcf3b96-658e-415a-95a6-3741d17299d7	M	0	white	0	irish	0
1716	8507	1944	10	20	1944-10-20 00:00:00	8527	0	\N	\N	\N	50c6dd53-9e2b-443a-b632-07deaec0723a	M	0	white	0	italian	0
1846	8507	1950	12	28	1950-12-28 00:00:00	0	38003563	\N	\N	\N	56648bc4-c409-45ae-89dc-dea4a5beb5bb	M	0	hispanic	0	central_american	0
1352	8532	1946	8	4	1946-08-04 00:00:00	8516	0	\N	\N	\N	40400ca7-adeb-451b-b394-74863d22d161	F	0	black	0	dominican	0
1991	8507	1943	10	11	1943-10-11 00:00:00	8527	0	\N	\N	\N	5ca36704-9822-4168-a15d-1dafded69539	M	0	white	0	italian	0
1365	8532	1963	8	22	1963-08-22 00:00:00	0	38003563	\N	\N	\N	409ea53d-0e0d-4672-928f-432d3cb18f74	F	0	hispanic	0	central_american	0
1219	8507	1942	9	14	1942-09-14 00:00:00	8527	0	\N	\N	\N	39dc8428-84e0-4ce9-915e-ade62066e463	M	0	white	0	french	0
2136	8532	1968	6	1	1968-06-01 00:00:00	8527	0	\N	\N	\N	64585683-f0bb-4c77-9689-64a82ae884e1	F	0	white	0	italian	0
1707	8507	1970	8	10	1970-08-10 00:00:00	8516	0	\N	\N	\N	5039d588-e503-4296-8504-5782699b4359	M	0	black	0	west_indian	0
1081	8532	1961	8	16	1961-08-16 00:00:00	8515	0	\N	\N	\N	33694c6f-7bcd-46a9-bb2e-cb69b48a7385	F	0	asian	0	chinese	0
1054	8507	1932	12	16	1932-12-16 00:00:00	8527	0	\N	\N	\N	32296d7d-5a23-4998-95c4-81150665e2b2	M	0	white	0	irish	0
1322	8507	1923	4	18	1923-04-18 00:00:00	8516	0	\N	\N	\N	3eb1600e-0960-409a-8093-d9c112dcc574	M	0	black	0	dominican	0
1340	8532	1911	7	30	1911-07-30 00:00:00	8527	0	\N	\N	\N	3f990cf3-aa19-4946-8f07-eed97ffca3dd	F	0	white	0	french	0
1844	8532	1959	4	7	1959-04-07 00:00:00	8527	0	\N	\N	\N	564cfdf5-b029-4454-b0f6-b9460b44f491	F	0	white	0	irish	0
1783	8507	1959	7	27	1959-07-27 00:00:00	0	38003563	\N	\N	\N	539b2364-f83a-4466-bad3-8c1757db3e17	M	0	hispanic	0	puerto_rican	0
863	8532	1921	8	18	1921-08-18 00:00:00	8515	0	\N	\N	\N	281a1a1e-1144-4dc1-a1be-2d7e3d3dbac3	F	0	asian	0	chinese	0
1338	8532	1943	10	7	1943-10-07 00:00:00	0	38003563	\N	\N	\N	3f81b64c-2c2e-4367-8b18-cf621344b90c	F	0	hispanic	0	puerto_rican	0
1860	8507	1958	10	27	1958-10-27 00:00:00	8527	0	\N	\N	\N	56dca900-f70c-4363-a8e8-0af8447c4b5d	M	0	white	0	german	0
1935	8532	1964	2	4	1964-02-04 00:00:00	8527	0	\N	\N	\N	5a41c30e-6d22-4102-8854-302c74c5bc68	F	0	white	0	irish	0
1415	8507	1969	1	26	1969-01-26 00:00:00	0	38003563	\N	\N	\N	4334457f-f6cb-4f13-bd60-470bd76c57fb	M	0	hispanic	0	puerto_rican	0
2020	8532	1970	10	31	1970-10-31 00:00:00	8527	0	\N	\N	\N	5e64f9c6-cf2f-41e9-a85b-be9e426a0b17	F	0	white	0	french	0
1097	8532	1969	3	27	1969-03-27 00:00:00	8516	0	\N	\N	\N	342e65d7-b37e-43ca-a1b9-375f1ad1d659	F	0	black	0	african	0
1551	8507	1956	12	17	1956-12-17 00:00:00	8527	0	\N	\N	\N	48cb8f41-3f23-4375-9e78-0973988c01f9	M	0	white	0	portuguese	0
1358	8532	1953	7	23	1953-07-23 00:00:00	8527	0	\N	\N	\N	406a8ccf-1620-47ee-ab6f-48ddff38a7f5	F	0	white	0	italian	0
1636	8507	1956	2	10	1956-02-10 00:00:00	8515	0	\N	\N	\N	4cfe9591-fa95-475e-a416-6cc9cedc24e4	M	0	asian	0	chinese	0
2150	8507	1950	1	20	1950-01-20 00:00:00	8527	0	\N	\N	\N	64ef96e1-cef6-4bdc-966b-2d385caf9e4f	M	0	white	0	swedish	0
1598	8532	1958	1	20	1958-01-20 00:00:00	8515	0	\N	\N	\N	4b25cca2-61b3-41ff-b783-477b740dd907	F	0	asian	0	asian_indian	0
1407	8532	1967	11	11	1967-11-11 00:00:00	0	38003563	\N	\N	\N	42a42956-4d9c-4e14-9633-5c8c9287e2a7	F	0	hispanic	0	puerto_rican	0
1571	8507	1954	7	2	1954-07-02 00:00:00	8527	0	\N	\N	\N	4a008706-4a16-426e-bed4-aa8cbe0c86b6	M	0	white	0	american	0
1378	8507	1944	6	20	1944-06-20 00:00:00	8527	0	\N	\N	\N	41460afa-e7cc-4796-8aa8-7093135cfbbc	M	0	white	0	irish	0
1958	8507	1971	7	27	1971-07-27 00:00:00	8515	0	\N	\N	\N	5b68538c-8503-41d5-86e4-54125376625f	M	0	asian	0	chinese	0
1764	8507	1959	9	3	1959-09-03 00:00:00	8527	0	\N	\N	\N	52c38994-7df2-4339-be87-837c42b74115	M	0	white	0	french	0
1464	8507	1959	12	2	1959-12-02 00:00:00	8527	0	\N	\N	\N	45255375-1911-4627-9be7-06dddcd739af	M	0	white	0	french_canadian	0
1635	8507	1972	10	18	1972-10-18 00:00:00	8527	0	\N	\N	\N	4cfbe24f-a84c-4011-8645-3c69688f16f1	M	0	white	0	irish	0
1294	8507	1972	11	18	1972-11-18 00:00:00	8527	0	\N	\N	\N	3d59015f-a6c0-4923-a780-1cbcf2b7f14d	M	0	white	0	german	0
1513	8532	1968	5	26	1968-05-26 00:00:00	8527	0	\N	\N	\N	4769a8f1-17af-4134-9905-337e05d335f3	F	0	white	0	english	0
1216	8532	1969	7	29	1969-07-29 00:00:00	0	38003563	\N	\N	\N	398de68f-bf91-4d92-ae16-65747377d82e	F	0	hispanic	0	mexican	0
1618	8532	1973	5	16	1973-05-16 00:00:00	8527	0	\N	\N	\N	4c680691-4969-4868-b089-7d3ad16792d5	F	0	white	0	french_canadian	0
1272	8507	1979	9	14	1979-09-14 00:00:00	8527	0	\N	\N	\N	3c5a4731-221c-4338-9034-3516747a7807	M	0	white	0	german	0
1776	8532	1916	10	28	1916-10-28 00:00:00	8527	0	\N	\N	\N	531eae5b-845e-46d0-8849-b56f018b9568	F	0	white	0	french	0
1498	8507	1964	3	16	1964-03-16 00:00:00	0	38003563	\N	\N	\N	46ad196c-4e61-446d-8566-5d9e4fda6743	M	0	hispanic	0	puerto_rican	0
1691	8532	1944	7	13	1944-07-13 00:00:00	8527	0	\N	\N	\N	4f6928e8-6f03-4ca9-ad58-6edfc233b817	F	0	white	0	english	0
1724	8532	1949	9	12	1949-09-12 00:00:00	8527	0	\N	\N	\N	5106b65e-28bd-4528-86cb-1413d765b9b9	F	0	white	0	english	0
1112	8507	1963	10	27	1963-10-27 00:00:00	8527	0	\N	\N	\N	351dbc7d-d677-448a-8dfa-58e8b2b8e996	M	0	white	0	irish	0
1906	8507	1960	11	12	1960-11-12 00:00:00	8527	0	\N	\N	\N	59039923-4d6b-4dbf-9952-2ebee5e9abe5	M	0	white	0	scottish	0
1430	8532	1943	11	23	1943-11-23 00:00:00	8527	0	\N	\N	\N	43db2085-38f8-42a7-a28b-508340508ca8	F	0	white	0	portuguese	0
1568	8507	1952	8	31	1952-08-31 00:00:00	0	38003563	\N	\N	\N	49c12e38-78a9-43bb-ac30-cdc441e4ca49	M	0	hispanic	0	puerto_rican	0
1579	8507	1954	12	30	1954-12-30 00:00:00	8527	0	\N	\N	\N	4a636f23-1d81-4784-beae-a2492071ba72	M	0	white	0	german	0
1281	8507	1970	1	3	1970-01-03 00:00:00	8515	0	\N	\N	\N	3cc5237a-9114-4fae-81e0-0b4b069382ba	M	0	asian	0	chinese	0
1600	8532	1945	11	26	1945-11-26 00:00:00	8527	0	\N	\N	\N	4b58e150-3e41-41c1-8bc7-28801d50ae47	F	0	white	0	irish	0
1371	8532	1971	4	13	1971-04-13 00:00:00	8527	0	\N	\N	\N	40f0f42d-ebda-4de4-8a56-e911d8aca8fc	F	0	white	0	english	0
1829	8532	1967	7	4	1967-07-04 00:00:00	0	38003563	\N	\N	\N	55b09339-b7b5-4b0d-8d9e-3086d5814341	F	0	hispanic	0	south_american	0
1450	8507	1963	5	12	1963-05-12 00:00:00	8527	0	\N	\N	\N	449e8426-a8e1-49a5-b3b3-caffda490a2e	M	0	white	0	irish	0
1649	8507	1956	3	7	1956-03-07 00:00:00	8527	0	\N	\N	\N	4d9719b7-aedb-4c00-9416-69e9c5f5cd17	M	0	white	0	portuguese	0
1508	8532	1924	1	1	1924-01-01 00:00:00	8527	0	\N	\N	\N	472d6019-24da-4dac-aaf8-2e3fc5a4a327	F	0	white	0	german	0
1433	8507	1960	1	4	1960-01-04 00:00:00	8527	0	\N	\N	\N	43f8414f-8b41-44bb-9a74-1694af47c30f	M	0	white	0	irish	0
1222	8507	1953	8	26	1953-08-26 00:00:00	8527	0	\N	\N	\N	39fe01c9-f0f5-4a7b-85c4-18c4d39b2343	M	0	white	0	german	0
1310	8507	1940	3	1	1940-03-01 00:00:00	8527	0	\N	\N	\N	3e0920a0-b433-45df-a5b0-4fc1419fee42	M	0	white	0	polish	0
1493	8507	1956	9	25	1956-09-25 00:00:00	0	38003563	\N	\N	\N	467ed6cf-e370-40ae-8fa6-211fc93e2d36	M	0	hispanic	0	puerto_rican	0
1550	8532	1969	1	11	1969-01-11 00:00:00	8527	0	\N	\N	\N	48caaa52-4c8b-402b-8b71-3dcd1167079a	F	0	white	0	french	0
1316	8532	1948	10	26	1948-10-26 00:00:00	8516	0	\N	\N	\N	3e3b5bc3-3789-4b7e-989f-ebdedde5e997	F	0	black	0	dominican	0
1475	8532	1934	8	23	1934-08-23 00:00:00	8527	0	\N	\N	\N	45e00d20-29ac-44a3-9278-07daca83c04e	F	0	white	0	portuguese	0
1438	8532	1952	1	18	1952-01-18 00:00:00	0	0	\N	\N	\N	4440a2a2-5af1-4d3b-8932-8e3c7227f42b	F	0	native	0	american_indian	0
1804	8532	1935	10	14	1935-10-14 00:00:00	8527	0	\N	\N	\N	54b34792-196a-4cc1-8ee1-78836d683494	F	0	white	0	english	0
1391	8532	1924	1	1	1924-01-01 00:00:00	8527	0	\N	\N	\N	41f71539-9561-4acd-b796-11545eeed807	F	0	white	0	german	0
1809	8532	1962	12	12	1962-12-12 00:00:00	8527	0	\N	\N	\N	54d58ebf-757e-4462-b107-7906e85f0e1f	F	0	white	0	irish	0
1964	8507	1961	1	31	1961-01-31 00:00:00	8527	0	\N	\N	\N	5b8aa32a-d541-43b2-b092-e31aa257e43c	M	0	white	0	irish	0
1490	8507	1937	12	9	1937-12-09 00:00:00	8527	0	\N	\N	\N	466cff31-663f-437c-a8f2-6a434af23607	M	0	white	0	russian	0
2077	8532	1933	3	26	1933-03-26 00:00:00	8527	0	\N	\N	\N	6086f439-18b9-4018-b0a5-e5b873e1cafb	F	0	white	0	english	0
1567	8507	1974	12	26	1974-12-26 00:00:00	8527	0	\N	\N	\N	49aa89c3-b66d-42b6-8971-cf17995fedfd	M	0	white	0	polish	0
1382	8507	1977	4	27	1977-04-27 00:00:00	8527	0	\N	\N	\N	41545844-b3f3-4e07-96c5-cc625c61fc0b	M	0	white	0	portuguese	0
2228	8507	1947	1	18	1947-01-18 00:00:00	8527	0	\N	\N	\N	6884013e-9c0d-4c74-a523-30d5442af60b	M	0	white	0	american	0
2210	8507	1936	10	25	1936-10-25 00:00:00	8515	0	\N	\N	\N	67c0893f-d5bd-4d60-8cf0-2252d15215ab	M	0	asian	0	chinese	0
1237	8507	1945	9	30	1945-09-30 00:00:00	8527	0	\N	\N	\N	3abf98e7-58a4-4e73-818d-8ea55d9e4c69	M	0	white	0	irish	0
1128	8532	1968	7	26	1968-07-26 00:00:00	8527	0	\N	\N	\N	35bc9658-b547-4f2b-b3c1-cf239308dd5f	F	0	white	0	scottish	0
1478	8532	1961	3	21	1961-03-21 00:00:00	0	38003563	\N	\N	\N	45f8b755-3619-40ae-8bda-f1a66e595641	F	0	hispanic	0	central_american	0
1354	8507	1978	4	7	1978-04-07 00:00:00	8516	0	\N	\N	\N	4050f0ae-d669-49d8-98b8-b0bd46d68fe7	M	0	black	0	dominican	0
1966	8532	1961	4	25	1961-04-25 00:00:00	8527	0	\N	\N	\N	5b9bd146-af9e-4af3-9272-efd204414675	F	0	white	0	irish	0
1874	8532	1973	11	10	1973-11-10 00:00:00	0	38003563	\N	\N	\N	5778d874-282b-4efd-b80f-be9f57f4f83c	F	0	hispanic	0	puerto_rican	0
947	8507	1966	9	30	1966-09-30 00:00:00	8527	0	\N	\N	\N	2cd99c0f-bed9-4cad-98d7-ba21ad0a39a6	M	0	white	0	irish	0
1356	8507	1971	2	5	1971-02-05 00:00:00	8515	0	\N	\N	\N	4056f6ef-f8f4-42e3-9511-2ea8c5532950	M	0	asian	0	chinese	0
1960	8532	1930	7	8	1930-07-08 00:00:00	8516	0	\N	\N	\N	5b7e4a94-3cbb-45e1-8073-6dd582058c29	F	0	black	0	dominican	0
2041	8507	1964	2	25	1964-02-25 00:00:00	8527	0	\N	\N	\N	5ef136b6-aa9d-42a5-89e3-fd62c57e71dd	M	0	white	0	italian	0
1569	8532	1936	9	4	1936-09-04 00:00:00	8527	0	\N	\N	\N	49de9ff5-2b38-47f6-ba8c-eeeaaa750d03	F	0	white	0	french	0
2258	8507	1956	4	19	1956-04-19 00:00:00	0	38003563	\N	\N	\N	699c60eb-867f-4a14-bba5-e7de106a0560	M	0	hispanic	0	puerto_rican	0
1189	8532	1963	12	2	1963-12-02 00:00:00	8527	0	\N	\N	\N	3855cc13-d4c0-49bf-9131-8dba97a213b5	F	0	white	0	french_canadian	0
1657	8532	1943	12	29	1943-12-29 00:00:00	8516	0	\N	\N	\N	4def858d-5a19-4c4e-91cf-4a08f82f4e87	F	0	black	0	west_indian	0
1442	8532	1946	2	5	1946-02-05 00:00:00	8527	0	\N	\N	\N	4464bad1-5524-4df3-8b0f-0703a435939e	F	0	white	0	english	0
1672	8532	1953	4	29	1953-04-29 00:00:00	8527	0	\N	\N	\N	4eadd476-2c0b-424c-89f3-6736826e6d0d	F	0	white	0	greek	0
2186	8507	1973	2	8	1973-02-08 00:00:00	8527	0	\N	\N	\N	66687fcf-349d-4a6b-8574-6ebd1ef3a90c	M	0	white	0	irish	0
1608	8507	1941	6	14	1941-06-14 00:00:00	8527	0	\N	\N	\N	4bbe92cd-868d-45d3-9e11-29d8aaabd869	M	0	white	0	american	0
1427	8532	1955	11	9	1955-11-09 00:00:00	8515	0	\N	\N	\N	43d0cac0-cc78-4b76-baa8-0dcca2325ccf	F	0	asian	0	chinese	0
1743	8532	1965	2	3	1965-02-03 00:00:00	8527	0	\N	\N	\N	51c63b0f-1388-441d-95a0-ea5b18783add	F	0	white	0	irish	0
1528	8532	1959	1	9	1959-01-09 00:00:00	8527	0	\N	\N	\N	4822a6f6-20e8-457f-bdd2-bc8fc13e4319	F	0	white	0	english	0
2058	8532	1966	10	26	1966-10-26 00:00:00	8527	0	\N	\N	\N	5faf48bf-4ced-4235-8a4a-e1ac546b0f3c	F	0	white	0	irish	0
1847	8532	1914	11	8	1914-11-08 00:00:00	8527	0	\N	\N	\N	568312ae-52f2-4cb5-9f81-2862fd907859	F	0	white	0	polish	0
1486	8532	1955	7	10	1955-07-10 00:00:00	8527	0	\N	\N	\N	464439d8-11e2-4c41-993f-a19eea861102	F	0	white	0	portuguese	0
1679	8507	1969	9	30	1969-09-30 00:00:00	8527	0	\N	\N	\N	4ee87054-8daa-476a-b40f-0ab16ae397aa	M	0	white	0	irish	0
1428	8507	1944	8	23	1944-08-23 00:00:00	8516	0	\N	\N	\N	43d39f35-9381-468a-a93d-ff3c567ec1ab	M	0	black	0	dominican	0
1593	8532	1934	10	11	1934-10-11 00:00:00	0	38003563	\N	\N	\N	4aee3d6e-0c39-4ccb-bbce-348cc1188acc	F	0	hispanic	0	south_american	0
1381	8507	1978	6	3	1978-06-03 00:00:00	8527	0	\N	\N	\N	414e238e-5e47-4842-8811-2f5f43a4bcb2	M	0	white	0	american	0
1736	8532	1969	5	8	1969-05-08 00:00:00	8516	0	\N	\N	\N	518a6a72-42d4-47b7-b538-10cd37b91ce2	F	0	black	0	west_indian	0
1323	8507	1961	5	6	1961-05-06 00:00:00	8527	0	\N	\N	\N	3ec4c4be-5f28-4903-ba30-f7522185a192	M	0	white	0	italian	0
1977	8507	1910	2	10	1910-02-10 00:00:00	0	38003563	\N	\N	\N	5c1b3378-1345-44e2-a8a8-7634be0ade6c	M	0	hispanic	0	puerto_rican	0
1766	8507	1952	6	24	1952-06-24 00:00:00	8527	0	\N	\N	\N	52d3b950-3e0e-4f63-b786-8c949ac939ee	M	0	white	0	english	0
1773	8532	1951	8	26	1951-08-26 00:00:00	8527	0	\N	\N	\N	5307dadc-bd91-4631-87f3-496f47608101	F	0	white	0	irish	0
1738	8532	1968	5	19	1968-05-19 00:00:00	8527	0	\N	\N	\N	51a27725-43d2-4233-990e-dcfc5e1a584a	F	0	white	0	irish	0
1297	8532	1978	8	13	1978-08-13 00:00:00	8527	0	\N	\N	\N	3d769f55-88da-4ade-9bc6-1e0adb231715	F	0	white	0	irish	0
1950	8532	1940	9	12	1940-09-12 00:00:00	8527	0	\N	\N	\N	5b24d722-89d9-4a6d-a630-324453ae2262	F	0	white	0	french	0
1504	8507	1941	6	10	1941-06-10 00:00:00	8527	0	\N	\N	\N	46e13fdb-e4a4-424b-95b9-e9c08bc70ef1	M	0	white	0	french	0
1622	8532	1974	5	27	1974-05-27 00:00:00	8527	0	\N	\N	\N	4c987069-25ac-4d2a-9d16-5c21ddfd83f7	F	0	white	0	german	0
1713	8532	1971	10	6	1971-10-06 00:00:00	8527	0	\N	\N	\N	50851425-0d0e-4be5-b7ac-895d3d142d8c	F	0	white	0	italian	0
1399	8507	1960	6	29	1960-06-29 00:00:00	8516	0	\N	\N	\N	4240e5b2-3de4-4ca6-902e-96656a4d2a5b	M	0	black	0	african	0
1801	8507	1954	7	21	1954-07-21 00:00:00	0	38003563	\N	\N	\N	546adaf2-81a9-4c95-8ea5-faf04b82e78c	M	0	hispanic	0	puerto_rican	0
1553	8507	1967	3	10	1967-03-10 00:00:00	8527	0	\N	\N	\N	48f2c701-d1d5-4ec8-9342-0e05e8d22307	M	0	white	0	irish	0
2149	8507	1959	4	18	1959-04-18 00:00:00	8516	0	\N	\N	\N	64ede050-311f-4b73-8db4-eb4cf7ffa18b	M	0	black	0	dominican	0
1500	8507	1962	2	12	1962-02-12 00:00:00	8527	0	\N	\N	\N	46c59e12-4589-48eb-b754-405a80733e25	M	0	white	0	french	0
1848	8532	1944	9	14	1944-09-14 00:00:00	0	38003563	\N	\N	\N	568521de-ecfd-4713-af4f-ea4d50c2d772	F	0	hispanic	0	south_american	0
1588	8532	1960	12	4	1960-12-04 00:00:00	0	38003563	\N	\N	\N	4ac36cef-4912-4d68-86c4-427bfc498b72	F	0	hispanic	0	south_american	0
1599	8532	1960	5	9	1960-05-09 00:00:00	8527	0	\N	\N	\N	4b27c492-95e4-41eb-8a27-0749c17c0f8f	F	0	white	0	irish	0
1379	8532	1960	2	13	1960-02-13 00:00:00	8527	0	\N	\N	\N	414afa68-168a-4637-a902-2e67ab5b633a	F	0	white	0	english	0
1384	8532	1982	3	16	1982-03-16 00:00:00	8516	0	\N	\N	\N	4168eadd-e468-4345-bcb1-f50acaf9e725	F	0	black	0	african	0
1541	8532	1963	4	29	1963-04-29 00:00:00	8527	0	\N	\N	\N	4876c3e7-c533-466b-bbd4-0adafd59f38c	F	0	white	0	portuguese	0
1656	8532	1977	11	26	1977-11-26 00:00:00	8527	0	\N	\N	\N	4dcf1f88-45f2-4734-b35d-de091b036a11	F	0	white	0	irish	0
1480	8507	1966	1	21	1966-01-21 00:00:00	0	38003563	\N	\N	\N	46049e15-9c60-46d6-aeee-1c1138b3b416	M	0	hispanic	0	puerto_rican	0
1791	8532	1954	11	25	1954-11-25 00:00:00	8515	0	\N	\N	\N	53e730f4-27f9-4cb2-a763-240cedbb984b	F	0	asian	0	chinese	0
1512	8532	1974	6	12	1974-06-12 00:00:00	0	38003563	\N	\N	\N	474844d5-8e73-4c82-ba77-e3f918ca0dae	F	0	hispanic	0	puerto_rican	0
2016	8532	1980	12	9	1980-12-09 00:00:00	8515	0	\N	\N	\N	5e0a0553-95eb-42f3-9ee1-0bf5efdd7c73	F	0	asian	0	chinese	0
1411	8532	1965	11	30	1965-11-30 00:00:00	8527	0	\N	\N	\N	43147e5b-c981-488d-bc39-330c4f321fe4	F	0	white	0	italian	0
2087	8507	1918	6	12	1918-06-12 00:00:00	0	0	\N	\N	\N	614cf010-c54a-4545-9e27-4ed673ac7086	M	0	native	0	american_indian	0
2166	8532	1969	5	11	1969-05-11 00:00:00	8527	0	\N	\N	\N	65cde13c-739f-417f-ae2a-9925983b1727	F	0	white	0	irish	0
1538	8507	1930	6	2	1930-06-02 00:00:00	8516	0	\N	\N	\N	485ff666-017c-4ae5-bc18-d4291bf96334	M	0	black	0	west_indian	0
2155	8532	1926	8	11	1926-08-11 00:00:00	8515	0	\N	\N	\N	65723bfd-7f2d-4e7d-954e-891b29e82592	F	0	asian	0	chinese	0
1641	8532	1954	9	22	1954-09-22 00:00:00	8527	0	\N	\N	\N	4d268e0b-020a-498d-9ee4-7bc05048afac	F	0	white	0	german	0
1418	8532	1972	8	28	1972-08-28 00:00:00	8516	0	\N	\N	\N	437904dc-d02d-4982-902c-8e0dd534dca7	F	0	black	0	dominican	0
2242	8507	1927	4	9	1927-04-09 00:00:00	8527	0	\N	\N	\N	68dc082e-72d0-492f-a7d2-80c2abea2d77	M	0	white	0	italian	0
2260	8507	1942	6	7	1942-06-07 00:00:00	8515	0	\N	\N	\N	69be022e-b4af-4354-accc-3ed22ff36097	M	0	asian	0	chinese	0
1612	8532	1963	7	31	1963-07-31 00:00:00	8527	0	\N	\N	\N	4c11df74-8b42-4e12-82d1-40bcc54f8a9c	F	0	white	0	irish	0
1266	8532	1967	1	9	1967-01-09 00:00:00	8527	0	\N	\N	\N	3c01d1d9-bfe6-4c2e-8a72-e915db3984d0	F	0	white	0	irish	0
1558	8532	1954	4	29	1954-04-29 00:00:00	0	38003563	\N	\N	\N	495b7e2f-199d-4d4d-b50d-14e5a54d7fe1	F	0	hispanic	0	puerto_rican	0
1446	8532	1983	11	1	1983-11-01 00:00:00	8527	0	\N	\N	\N	448dfc92-7026-4782-a2d4-5a87052da593	F	0	white	0	italian	0
2164	8507	1972	9	29	1972-09-29 00:00:00	8527	0	\N	\N	\N	65a3d8c8-9102-4da7-9366-52b5ffeb3710	M	0	white	0	irish	0
1982	8507	1921	8	25	1921-08-25 00:00:00	8527	0	\N	\N	\N	5c418ec3-d09a-4770-bebd-7a219991d335	M	0	white	0	english	0
1125	8507	1950	9	22	1950-09-22 00:00:00	8527	0	\N	\N	\N	35b572aa-6248-4e96-9591-0b9c5659f388	M	0	white	0	italian	0
1542	8507	1965	11	24	1965-11-24 00:00:00	8527	0	\N	\N	\N	4879287f-7701-4546-920d-ccb3b6a6a315	M	0	white	0	english	0
2052	8507	1962	3	5	1962-03-05 00:00:00	8516	0	\N	\N	\N	5f77fa16-70ef-4376-98ea-192a48796434	M	0	black	0	dominican	0
2133	8507	1965	6	7	1965-06-07 00:00:00	8516	0	\N	\N	\N	642aae67-d583-45b4-805e-89adf16cfe15	M	0	black	0	african	0
1623	8507	1950	1	6	1950-01-06 00:00:00	8527	0	\N	\N	\N	4ca017f4-6ada-470c-a22d-4983eb697288	M	0	white	0	irish	0
2423	8532	1956	10	22	1956-10-22 00:00:00	0	38003563	\N	\N	\N	721324a3-99a2-403a-8013-2420810da9ed	F	0	hispanic	0	puerto_rican	0
1235	8532	1975	5	26	1975-05-26 00:00:00	8527	0	\N	\N	\N	3aad8a0c-8346-4a16-b5e0-98fc4fbc3fec	F	0	white	0	italian	0
1685	8507	1980	2	10	1980-02-10 00:00:00	8527	0	\N	\N	\N	4f306106-f9b1-4a10-a38c-581ca78d8e07	M	0	white	0	french_canadian	0
1540	8507	1958	7	28	1958-07-28 00:00:00	8527	0	\N	\N	\N	4872b2ee-77de-40d9-b098-11683c662d8c	M	0	white	0	italian	0
1837	8532	1960	5	13	1960-05-13 00:00:00	8527	0	\N	\N	\N	562581ab-ca11-4edc-a1cd-4faa3b72bdfd	F	0	white	0	russian	0
2300	8507	1950	1	26	1950-01-26 00:00:00	8527	0	\N	\N	\N	6bb46fc6-f925-4b62-9b6f-b62ec2d2d0dd	M	0	white	0	french	0
1746	8532	1952	11	13	1952-11-13 00:00:00	8527	0	\N	\N	\N	51f4744b-80f0-4925-8d74-2ecac8a554b9	F	0	white	0	american	0
1753	8532	1964	5	7	1964-05-07 00:00:00	8527	0	\N	\N	\N	525b6c1e-4ceb-4935-be23-02f12d6b8921	F	0	white	0	german	0
1820	8532	1978	2	7	1978-02-07 00:00:00	8527	0	\N	\N	\N	55312979-6a6e-44e8-bcbe-312acf577a4d	F	0	white	0	french_canadian	0
1576	8532	1967	10	7	1967-10-07 00:00:00	0	38003563	\N	\N	\N	4a3e512c-c186-4b3b-984f-326a8a4ea0ee	F	0	hispanic	0	puerto_rican	0
2172	8507	1978	10	7	1978-10-07 00:00:00	0	38003563	\N	\N	\N	65e608d5-9ba5-416a-9547-4e9526c8042c	M	0	hispanic	0	puerto_rican	0
1965	8507	1973	1	28	1973-01-28 00:00:00	8527	0	\N	\N	\N	5b93f66f-23c2-48d5-92e5-7f6288d8fe20	M	0	white	0	french	0
1566	8507	1967	11	4	1967-11-04 00:00:00	8515	0	\N	\N	\N	499d24d0-50fe-4a18-98e9-c2235f0faa49	M	0	asian	0	chinese	0
1785	8507	1954	10	4	1954-10-04 00:00:00	8527	0	\N	\N	\N	53b72341-f02a-404e-aa53-b33a5263100c	M	0	white	0	irish	0
1506	8532	1946	2	2	1946-02-02 00:00:00	8527	0	\N	\N	\N	46e2e026-4195-4991-bfca-933b7e40d7c7	F	0	white	0	portuguese	0
1699	8532	1966	4	3	1966-04-03 00:00:00	8527	0	\N	\N	\N	4fb857ba-dfb1-4126-9fa2-3a5a015bd3b7	F	0	white	0	italian	0
1535	8507	1978	4	3	1978-04-03 00:00:00	8515	0	\N	\N	\N	484c6d01-ceee-42a9-8210-a1edc4493dc6	M	0	asian	0	asian_indian	0
1819	8532	1977	5	24	1977-05-24 00:00:00	8527	0	\N	\N	\N	55213c5c-80eb-45d1-aa61-92a5ff676ff8	F	0	white	0	greek	0
1677	8507	1969	7	12	1969-07-12 00:00:00	8527	0	\N	\N	\N	4ecce30e-d5a8-4565-8b51-6efb535f5949	M	0	white	0	italian	0
1999	8507	1977	9	23	1977-09-23 00:00:00	8515	0	\N	\N	\N	5d38a458-2e2e-4b48-a874-c8663e1108ba	M	0	asian	0	asian_indian	0
1845	8507	1961	4	19	1961-04-19 00:00:00	8527	0	\N	\N	\N	56617a8d-8799-45b8-9b7b-e7fe93bb1bce	M	0	white	0	polish	0
1854	8532	1970	11	3	1970-11-03 00:00:00	0	0	\N	\N	\N	56bd8b2c-43a6-4023-8288-0b95814f0c80	F	0	native	0	american_indian	0
1903	8507	1962	6	19	1962-06-19 00:00:00	8516	0	\N	\N	\N	58fbe4f0-3f8c-4367-82de-5fcbc70c7af9	M	0	black	0	dominican	0
1533	8532	1970	12	29	1970-12-29 00:00:00	0	38003563	\N	\N	\N	48479fc7-4c4e-43da-8c1c-f9e660220509	F	0	hispanic	0	puerto_rican	0
2098	8532	1962	7	4	1962-07-04 00:00:00	8527	0	\N	\N	\N	61c05167-5ee6-41db-a292-4710e0769f7e	F	0	white	0	english	0
1606	8507	1950	1	2	1950-01-02 00:00:00	8527	0	\N	\N	\N	4bb1b770-9f2d-4f5f-b08a-faed5914b511	M	0	white	0	english	0
1740	8507	1952	9	6	1952-09-06 00:00:00	8527	0	\N	\N	\N	51b72be9-98d8-4c25-9244-32c3128e36db	M	0	white	0	american	0
1812	8507	1960	3	28	1960-03-28 00:00:00	8527	0	\N	\N	\N	54ed4674-d43b-4bc4-8887-f373a7c6f159	M	0	white	0	irish	0
1435	8532	1961	2	18	1961-02-18 00:00:00	8527	0	\N	\N	\N	442cda12-cee0-46e3-a118-b99f4d1ba59a	F	0	white	0	german	0
2213	8507	1961	7	19	1961-07-19 00:00:00	0	38003563	\N	\N	\N	67d1347a-3091-4117-84ef-e6b6ddca1c19	M	0	hispanic	0	puerto_rican	0
1789	8507	1975	2	27	1975-02-27 00:00:00	0	38003563	\N	\N	\N	53c6bfe5-1b46-448c-8e9c-c73977a5bbae	M	0	hispanic	0	central_american	0
2185	8532	1940	2	7	1940-02-07 00:00:00	8527	0	\N	\N	\N	66630538-7e36-4e5e-84e8-31360f3e3222	F	0	white	0	american	0
1658	8532	1911	5	1	1911-05-01 00:00:00	8516	0	\N	\N	\N	4df3b13b-ac41-491e-b34e-17b4d52417c9	F	0	black	0	west_indian	0
1870	8532	1920	4	18	1920-04-18 00:00:00	8527	0	\N	\N	\N	5738e2a3-b1bb-42bc-bcb1-34f85189cfad	F	0	white	0	irish	0
1602	8507	1963	4	17	1963-04-17 00:00:00	0	38003563	\N	\N	\N	4b790513-a574-4d49-aa43-7bfcc98f8598	M	0	hispanic	0	puerto_rican	0
1609	8507	1943	3	25	1943-03-25 00:00:00	8527	0	\N	\N	\N	4be0cf9e-f4dc-4d30-9a83-3c797bbc61d5	M	0	white	0	french	0
1529	8507	1962	7	2	1962-07-02 00:00:00	8527	0	\N	\N	\N	48250068-0613-4932-a56b-538d642b07bb	M	0	white	0	polish	0
1412	8532	1961	5	13	1961-05-13 00:00:00	8527	0	\N	\N	\N	43180448-b49e-4c91-8fa3-10f54793759e	F	0	white	0	french_canadian	0
1695	8532	1965	12	30	1965-12-30 00:00:00	8527	0	\N	\N	\N	4f8ddb5b-c7dc-4bea-8172-d3705ea6ae02	F	0	white	0	irish	0
1762	8507	1940	10	31	1940-10-31 00:00:00	8516	0	\N	\N	\N	52be68a0-87b4-4c56-ae5f-07aa8bd38f74	M	0	black	0	african	0
1560	8532	1935	1	14	1935-01-14 00:00:00	8527	0	\N	\N	\N	4960615f-ca2a-4d08-b084-17bde0a9b248	F	0	white	0	italian	0
1882	8532	1968	8	10	1968-08-10 00:00:00	8527	0	\N	\N	\N	57e507d4-6110-48b5-a2ff-4203fa331b58	F	0	white	0	irish	0
1748	8507	1946	10	5	1946-10-05 00:00:00	8527	0	\N	\N	\N	5223d6ac-9a26-4233-94c0-cd772a49c1f5	M	0	white	0	english	0
2309	8507	1973	3	30	1973-03-30 00:00:00	8527	0	\N	\N	\N	6c0b613c-c6e6-4c08-9300-3a912cbcc5de	M	0	white	0	swedish	0
1525	8532	1963	8	1	1963-08-01 00:00:00	8527	0	\N	\N	\N	4814386b-a9d8-4cd1-85e5-acd34d0b5c51	F	0	white	0	swedish	0
2237	8532	1928	11	11	1928-11-11 00:00:00	8516	0	\N	\N	\N	68bb6118-2ecc-43d1-a1a5-9ab94c5893cd	F	0	black	0	african	0
2202	8507	1973	10	11	1973-10-11 00:00:00	8516	0	\N	\N	\N	674153a5-68bc-412d-9f57-7b6662b6dfbc	M	0	black	0	dominican	0
1867	8507	1972	5	23	1972-05-23 00:00:00	8527	0	\N	\N	\N	57119094-20b9-4995-96cc-4bccbea2af8e	M	0	white	0	french_canadian	0
2289	8507	1949	11	1	1949-11-01 00:00:00	8527	0	\N	\N	\N	6b50b62b-a458-4ce0-b4a6-54a246776587	M	0	white	0	russian	0
1669	8507	1959	2	2	1959-02-02 00:00:00	8527	0	\N	\N	\N	4e514782-a7fe-44ef-ba4d-ca699a15ed2c	M	0	white	0	irish	0
1532	8532	1977	9	28	1977-09-28 00:00:00	8527	0	\N	\N	\N	48440003-957e-4a43-8024-2640b44d5386	F	0	white	0	german	0
2443	8507	1961	12	28	1961-12-28 00:00:00	0	38003563	\N	\N	\N	730a6a6b-da9e-458b-9b3e-bef5d6d89265	M	0	hispanic	0	puerto_rican	0
2311	8507	1960	1	30	1960-01-30 00:00:00	0	38003563	\N	\N	\N	6c3056d9-b5f7-40ae-981f-94757a1e9fe9	M	0	hispanic	0	central_american	0
1750	8507	1968	2	14	1968-02-14 00:00:00	0	38003563	\N	\N	\N	52426c5c-cce0-4a40-8a9b-afcf61a7740a	M	0	hispanic	0	puerto_rican	0
1313	8507	1969	11	26	1969-11-26 00:00:00	8527	0	\N	\N	\N	3e3271e1-74e0-4a23-ac49-cbcf4082e5c1	M	0	white	0	irish	0
1632	8507	1951	7	23	1951-07-23 00:00:00	8527	0	\N	\N	\N	4ce38023-2057-4939-b418-addbdd1aefbb	M	0	white	0	polish	0
1536	8507	1911	7	2	1911-07-02 00:00:00	8527	0	\N	\N	\N	484f3d58-49c9-4472-9363-7b376f539d56	M	0	white	0	english	0
2200	8507	1973	6	10	1973-06-10 00:00:00	8515	0	\N	\N	\N	6722a640-5569-4639-83db-72bd00c3a7ff	M	0	asian	0	asian_indian	0
1992	8532	1975	3	23	1975-03-23 00:00:00	8527	0	\N	\N	\N	5ca372c6-fe79-49df-a7c4-9729159afa45	F	0	white	0	polish	0
1674	8507	1976	10	11	1976-10-11 00:00:00	0	38003563	\N	\N	\N	4ec02f61-0249-4113-abc6-59cb915c08af	M	0	hispanic	0	puerto_rican	0
1692	8532	1976	8	16	1976-08-16 00:00:00	8527	0	\N	\N	\N	4f6a6187-ef3b-4dec-8a50-a352866cd1bf	F	0	white	0	scottish	0
2206	8532	1971	12	3	1971-12-03 00:00:00	8527	0	\N	\N	\N	6783184c-8a25-46b7-acfb-d45a5658a29a	F	0	white	0	irish	0
2233	8532	1972	2	1	1972-02-01 00:00:00	8527	0	\N	\N	\N	68ac03e8-f9b6-451d-9faf-2b28f685ea40	F	0	white	0	irish	0
1924	8532	1971	6	4	1971-06-04 00:00:00	8527	0	\N	\N	\N	59b58229-00a0-4927-8d04-71226b70b736	F	0	white	0	italian	0
2459	8532	1976	6	21	1976-06-21 00:00:00	8527	0	\N	\N	\N	73e62148-4a73-4d4a-811a-eb3f576eb0b2	F	0	white	0	italian	0
1280	8507	1951	7	4	1951-07-04 00:00:00	8516	0	\N	\N	\N	3cbaadbd-46dd-4680-824e-256bfa290ff3	M	0	black	0	dominican	0
1840	8507	1975	4	19	1975-04-19 00:00:00	8527	0	\N	\N	\N	563d9704-0982-40f4-ad16-e07ce6146c5b	M	0	white	0	irish	0
1851	8507	1977	12	8	1977-12-08 00:00:00	8516	0	\N	\N	\N	56a2cda1-559c-4cd7-aac0-489c36744e39	M	0	black	0	dominican	0
1975	8507	1922	2	11	1922-02-11 00:00:00	8527	0	\N	\N	\N	5c125f45-1b91-4c23-acfb-041dcfc1a09f	M	0	white	0	italian	0
2351	8507	1948	7	17	1948-07-17 00:00:00	8516	0	\N	\N	\N	6e6ec9e4-4c4f-45fd-8e67-e7d746dec8a1	M	0	black	0	african	0
1793	8507	1918	6	12	1918-06-12 00:00:00	0	0	\N	\N	\N	541edd98-0824-44ba-8d2d-44a2ee682e48	M	0	native	0	american_indian	0
1916	8507	1971	10	4	1971-10-04 00:00:00	8527	0	\N	\N	\N	5985cc32-92a6-4dce-871d-454491aa42b3	M	0	white	0	irish	0
1898	8532	1970	12	7	1970-12-07 00:00:00	8516	0	\N	\N	\N	58a40949-ff9c-4b93-accc-50a15531ea06	F	0	black	0	african	0
1889	8507	1982	11	18	1982-11-18 00:00:00	0	38003563	\N	\N	\N	582dc17e-cfac-488a-8a37-075f68698801	M	0	hispanic	0	puerto_rican	0
2192	8532	1954	12	23	1954-12-23 00:00:00	0	38003563	\N	\N	\N	66d5fadd-39e1-45fc-9721-027b69e41b78	F	0	hispanic	0	south_american	0
2167	8507	1978	3	15	1978-03-15 00:00:00	8527	0	\N	\N	\N	65d970b5-5e8b-489e-a5e5-fc70cd116d88	M	0	white	0	italian	0
1640	8507	1935	8	14	1935-08-14 00:00:00	8515	0	\N	\N	\N	4d219d7e-db50-486f-98c8-dee00615ebd1	M	0	asian	0	asian_indian	0
1834	8507	1946	2	3	1946-02-03 00:00:00	8516	0	\N	\N	\N	55fd836a-d78c-4ae5-b3c7-1fc2f8b103c8	M	0	black	0	west_indian	0
1586	8532	1939	3	12	1939-03-12 00:00:00	8527	0	\N	\N	\N	4aa416ce-0c18-4191-84d8-1ced8aec5055	F	0	white	0	greek	0
2026	8532	1952	1	11	1952-01-11 00:00:00	8527	0	\N	\N	\N	5e992e03-f2f6-496c-b484-aa1e0ec87808	F	0	white	0	english	0
1808	8532	1962	2	6	1962-02-06 00:00:00	8527	0	\N	\N	\N	54cd03e7-0144-44db-9bf7-964a75b3797e	F	0	white	0	german	0
1921	8532	1951	9	24	1951-09-24 00:00:00	0	38003563	\N	\N	\N	59a0d0fe-6cc9-4e7d-a755-9c6539a7b63c	F	0	hispanic	0	central_american	0
2078	8507	1982	6	9	1982-06-09 00:00:00	0	38003563	\N	\N	\N	60a27e39-9817-4fd1-9223-1879ae168c0f	M	0	hispanic	0	puerto_rican	0
2069	8507	1951	7	23	1951-07-23 00:00:00	8527	0	\N	\N	\N	6024aec4-7976-4c4c-a7e9-6bd533e16b59	M	0	white	0	german	0
1967	8532	1955	10	13	1955-10-13 00:00:00	8527	0	\N	\N	\N	5b9c555c-d3c6-432c-b7ea-41c8e50366b0	F	0	white	0	portuguese	0
1864	8532	1965	12	3	1965-12-03 00:00:00	8516	0	\N	\N	\N	56f4bd29-4da2-4e3c-98ed-969e7d3dd41a	F	0	black	0	dominican	0
1923	8507	1932	12	16	1932-12-16 00:00:00	8527	0	\N	\N	\N	59aa9093-c7ee-4476-90e6-6b2d43f9abfa	M	0	white	0	irish	0
1627	8532	1952	5	31	1952-05-31 00:00:00	8527	0	\N	\N	\N	4cb99710-5620-461e-96f2-934bc2768624	F	0	white	0	english	0
2116	8507	1949	3	28	1949-03-28 00:00:00	8527	0	\N	\N	\N	6304ad16-299e-4870-952d-a497268288ef	M	0	white	0	polish	0
1756	8507	1972	8	6	1972-08-06 00:00:00	8527	0	\N	\N	\N	52a214d1-6d7a-4f78-a465-1dc5d4870fa0	M	0	white	0	italian	0
1925	8532	1945	1	20	1945-01-20 00:00:00	8527	0	\N	\N	\N	59c608bd-b8dc-400f-a697-fe3dbdf1a4ab	F	0	white	0	irish	0
1934	8507	1960	1	30	1960-01-30 00:00:00	8527	0	\N	\N	\N	5a380760-9394-4af4-8127-c14dc91bd758	M	0	white	0	american	0
1517	8532	1937	11	1	1937-11-01 00:00:00	8527	0	\N	\N	\N	47a74a7d-5804-48a1-b9c5-a6b72ebd426b	F	0	white	0	italian	0
2458	8532	1970	5	24	1970-05-24 00:00:00	0	38003563	\N	\N	\N	73d45a64-d48f-4e7a-9407-98bfb1572ffd	F	0	hispanic	0	puerto_rican	0
1986	8507	1979	11	20	1979-11-20 00:00:00	8527	0	\N	\N	\N	5c6f7c0a-24eb-4b68-9a1e-190f8244baa2	M	0	white	0	german	0
2394	8532	1911	5	1	1911-05-01 00:00:00	8516	0	\N	\N	\N	708ee2fe-0799-4b78-a1e8-4c5b8e5c5289	F	0	black	0	west_indian	0
1686	8507	1961	3	19	1961-03-19 00:00:00	8527	0	\N	\N	\N	4f33fd5f-0466-45dc-9114-5dea8c6f2b6e	M	0	white	0	french_canadian	0
1954	8532	1936	1	30	1936-01-30 00:00:00	0	38003563	\N	\N	\N	5b553ef6-09f1-4fb0-9655-b0edea374635	F	0	hispanic	0	puerto_rican	0
1752	8507	1977	12	25	1977-12-25 00:00:00	8527	0	\N	\N	\N	5258725c-fbad-4776-880e-1f86a409b10c	M	0	white	0	irish	0
1946	8507	1925	12	26	1925-12-26 00:00:00	8516	0	\N	\N	\N	5aedffa5-d0b6-4683-871e-eb16c4608b42	M	0	black	0	west_indian	0
1577	8532	1922	2	17	1922-02-17 00:00:00	8527	0	\N	\N	\N	4a415b1d-9b8e-4171-9ffe-09c8a8e6dda5	F	0	white	0	italian	0
1720	8507	1979	3	31	1979-03-31 00:00:00	8527	0	\N	\N	\N	50f20e86-cce2-4a00-a927-acf03695c78d	M	0	white	0	irish	0
1769	8532	1974	9	25	1974-09-25 00:00:00	0	38003563	\N	\N	\N	52d8e6b3-caba-4f60-bb20-18bc419142b2	F	0	hispanic	0	puerto_rican	0
2013	8532	1956	3	17	1956-03-17 00:00:00	8516	0	\N	\N	\N	5dd42e05-e123-479a-9968-1ca917fc82d0	F	0	black	0	african	0
1646	8532	1940	11	30	1940-11-30 00:00:00	8527	0	\N	\N	\N	4d7a8057-0d75-4f99-87d0-4f792fe4ee40	F	0	white	0	american	0
2156	8532	1964	7	23	1964-07-23 00:00:00	8516	0	\N	\N	\N	657652b6-d1d0-4f7e-a99e-22df03b6b171	F	0	black	0	west_indian	0
1905	8532	1966	2	18	1966-02-18 00:00:00	0	38003563	\N	\N	\N	59001122-d4f8-43f6-848b-9a8a251a125f	F	0	hispanic	0	puerto_rican	0
2419	8507	1944	10	20	1944-10-20 00:00:00	8527	0	\N	\N	\N	71f17642-e658-45b1-b91e-204bf6ef5731	M	0	white	0	irish	0
1727	8532	1949	3	30	1949-03-30 00:00:00	0	38003563	\N	\N	\N	5114a22e-841b-44ae-b005-a19d64e6fa67	F	0	hispanic	0	central_american	0
2328	8507	1954	9	27	1954-09-27 00:00:00	8527	0	\N	\N	\N	6d1ead52-fe80-473a-9206-fbb38c262806	M	0	white	0	irish	0
2367	8507	1974	10	29	1974-10-29 00:00:00	8527	0	\N	\N	\N	6f112ae9-e9ad-464d-b66f-00f02272d17b	M	0	white	0	italian	0
2173	8532	1930	7	8	1930-07-08 00:00:00	8516	0	\N	\N	\N	65ee907a-842e-44f8-82bf-21d2c07cb1cf	F	0	black	0	dominican	0
2590	8507	1962	10	16	1962-10-16 00:00:00	8527	0	\N	\N	\N	7b349270-34bc-4a3d-bbb7-ab2959ba2499	M	0	white	0	italian	0
1779	8507	1942	11	26	1942-11-26 00:00:00	8527	0	\N	\N	\N	53437025-5b22-4c49-8291-a942138ea248	M	0	white	0	portuguese	0
1626	8507	1934	12	30	1934-12-30 00:00:00	8527	0	\N	\N	\N	4cb64d8c-900f-4b0e-a863-6af63d004cf0	M	0	white	0	irish	0
2651	8532	1946	9	18	1946-09-18 00:00:00	8527	0	\N	\N	\N	7dcd823b-d429-4a3f-84e7-b924e5d4312b	F	0	white	0	english	0
2461	8507	1966	11	1	1966-11-01 00:00:00	8516	0	\N	\N	\N	740d61b8-e399-4317-a6e6-3fa5d9e97a48	M	0	black	0	african	0
1951	8507	1981	5	13	1981-05-13 00:00:00	8527	0	\N	\N	\N	5b2671e9-7d23-4b30-bf09-32c18d9dec06	M	0	white	0	english	0
1367	8532	1965	4	30	1965-04-30 00:00:00	8515	0	\N	\N	\N	40a4c3bd-fd2d-4ce5-93af-3d749dfa4e0e	F	0	asian	0	asian_indian	0
1676	8507	1979	12	14	1979-12-14 00:00:00	8527	0	\N	\N	\N	4ec5dc8f-a544-4ec5-aa73-4c539029d18f	M	0	white	0	irish	0
1690	8532	1973	10	3	1973-10-03 00:00:00	8516	0	\N	\N	\N	4f60b35f-5854-4c81-b13b-aa0f83e7d6b8	F	0	black	0	african	0
2286	8507	1957	9	2	1957-09-02 00:00:00	8527	0	\N	\N	\N	6b36cfc9-626b-47be-89e8-26725c263cca	M	0	white	0	irish	0
2184	8507	1967	2	15	1967-02-15 00:00:00	0	38003563	\N	\N	\N	6658b6bd-5dd3-4bfc-aa64-3d7158af883a	M	0	hispanic	0	puerto_rican	0
1788	8507	1961	8	17	1961-08-17 00:00:00	0	38003563	\N	\N	\N	53b8ef1c-fd93-46e6-8b3b-3ebb6e5c6717	M	0	hispanic	0	puerto_rican	0
1770	8532	1978	6	11	1978-06-11 00:00:00	8516	0	\N	\N	\N	52eb7f09-0eac-4aa6-95a5-677b3a0a1910	F	0	black	0	african	0
2280	8507	1969	6	4	1969-06-04 00:00:00	8527	0	\N	\N	\N	6ad3af94-296f-42e6-b46d-659b1518fc27	M	0	white	0	portuguese	0
2332	8532	1957	4	20	1957-04-20 00:00:00	8527	0	\N	\N	\N	6d5ceeeb-47c5-4055-b381-43e71f4191c3	F	0	white	0	irish	0
2034	8507	1923	4	18	1923-04-18 00:00:00	8516	0	\N	\N	\N	5ec17b9e-df50-4f00-bae9-4a6010e48dd4	M	0	black	0	dominican	0
2541	8532	1975	9	29	1975-09-29 00:00:00	8527	0	\N	\N	\N	786c2886-0edf-4615-8972-998dd05eae97	F	0	white	0	french	0
1516	8532	1938	1	3	1938-01-03 00:00:00	8527	0	\N	\N	\N	478569b6-f3a9-43ff-9774-ecc533060798	F	0	white	0	italian	0
1962	8532	1964	4	8	1964-04-08 00:00:00	8527	0	\N	\N	\N	5b826eef-82d1-4483-ba0f-91c517cd5680	F	0	white	0	irish	0
1953	8532	1954	8	9	1954-08-09 00:00:00	8527	0	\N	\N	\N	5b52d4e2-a551-4289-b6b7-dd6a411e9ac6	F	0	white	0	english	0
2075	8507	1965	11	30	1965-11-30 00:00:00	0	38003563	\N	\N	\N	605a495c-8627-4742-9649-87170be66149	M	0	hispanic	0	central_american	0
2485	8532	1913	7	2	1913-07-02 00:00:00	8527	0	\N	\N	\N	756a6909-0c86-4cc6-8444-00f5327e3e83	F	0	white	0	german	0
1911	8532	1945	11	26	1945-11-26 00:00:00	8527	0	\N	\N	\N	5952fdd9-ee31-42cd-9b7e-e145106f13bf	F	0	white	0	irish	0
1936	8532	1947	2	21	1947-02-21 00:00:00	8516	0	\N	\N	\N	5a5ef161-f096-4c61-98d1-651e13f5b564	F	0	black	0	west_indian	0
1926	8532	1970	4	11	1970-04-11 00:00:00	8527	0	\N	\N	\N	59c7244a-208e-4353-9428-9ddb4a9b1740	F	0	white	0	portuguese	0
1933	8532	1958	5	30	1958-05-30 00:00:00	8527	0	\N	\N	\N	5a333d68-cc41-482c-b543-c27c4c791c83	F	0	white	0	german	0
2357	8507	1938	11	15	1938-11-15 00:00:00	8527	0	\N	\N	\N	6e8d4142-5564-4112-b6f7-69889e917f0b	M	0	white	0	french_canadian	0
2366	8532	1965	9	13	1965-09-13 00:00:00	8527	0	\N	\N	\N	6ef01d33-6b8b-4d44-b8ba-6141abab7208	F	0	white	0	german	0
1778	8507	1980	5	17	1980-05-17 00:00:00	8527	0	\N	\N	\N	53423077-22df-4955-9f8a-7bca52c9be2a	M	0	white	0	english	0
1990	8532	1966	5	27	1966-05-27 00:00:00	8527	0	\N	\N	\N	5c8e9b15-3d67-457e-972e-2b78c7718867	F	0	white	0	english	0
1604	8507	1953	10	29	1953-10-29 00:00:00	8527	0	\N	\N	\N	4b8b470d-4541-44de-95b9-7a4a52b1d668	M	0	white	0	portuguese	0
2218	8532	1978	5	23	1978-05-23 00:00:00	8527	0	\N	\N	\N	680ecbda-219e-4af5-a4a1-5ba7e72782d3	F	0	white	0	german	0
2044	8507	1961	10	14	1961-10-14 00:00:00	8527	0	\N	\N	\N	5f13e2fe-4578-4776-9d07-697047064e05	M	0	white	0	irish	0
2231	8507	1970	5	9	1970-05-09 00:00:00	8515	0	\N	\N	\N	6899ad10-6092-4c08-98ce-6f098958e14c	M	0	asian	0	chinese	0
2152	8507	1922	2	11	1922-02-11 00:00:00	8527	0	\N	\N	\N	651badab-02d0-4752-b022-d0aacbff810d	M	0	white	0	italian	0
2147	8532	1952	9	27	1952-09-27 00:00:00	8516	0	\N	\N	\N	64e764b2-cd73-45e5-82a6-ce6d43ffb532	F	0	black	0	west_indian	0
2051	8532	1962	11	18	1962-11-18 00:00:00	8527	0	\N	\N	\N	5f75681b-8c0f-4d20-aacf-12b08a3f4fc5	F	0	white	0	german	0
1956	8507	1963	6	25	1963-06-25 00:00:00	8527	0	\N	\N	\N	5b58f623-55ed-4e9e-9253-0eb4ebd1ea91	M	0	white	0	irish	0
2037	8507	1960	4	15	1960-04-15 00:00:00	8527	0	\N	\N	\N	5ee6e9d2-7c96-46b5-a964-08a701601754	M	0	white	0	greek	0
1719	8507	1957	4	9	1957-04-09 00:00:00	0	38003563	\N	\N	\N	50e61616-ed41-4599-9a0d-4bfc5bfb8beb	M	0	hispanic	0	south_american	0
2270	8532	1978	5	31	1978-05-31 00:00:00	8527	0	\N	\N	\N	6a2527e4-0040-4f39-9186-98ac909881ab	F	0	white	0	english	0
1941	8507	1973	2	15	1973-02-15 00:00:00	8527	0	\N	\N	\N	5a980429-51bc-47b9-83fc-75e56b27c014	M	0	white	0	italian	0
2326	8532	1951	2	8	1951-02-08 00:00:00	0	38003563	\N	\N	\N	6cffb222-eeb7-4559-8ea7-fa2139e66f5a	F	0	hispanic	0	central_american	0
2082	8532	1942	2	5	1942-02-05 00:00:00	8527	0	\N	\N	\N	60f99afc-40e9-4068-92ee-0c44c3f5e8f9	F	0	white	0	french	0
1597	8532	1944	7	29	1944-07-29 00:00:00	8527	0	\N	\N	\N	4b24606f-0d27-48ad-8039-7dbd0c1470ae	F	0	white	0	english	0
2540	8507	1936	12	22	1936-12-22 00:00:00	8516	0	\N	\N	\N	7857e581-ff72-4c15-9bfc-8922dcffa92f	M	0	black	0	african	0
2292	8507	1963	11	15	1963-11-15 00:00:00	8516	0	\N	\N	\N	6b6776e1-d62c-4608-bbc1-e875d06f8503	M	0	black	0	dominican	0
2486	8532	1974	3	22	1974-03-22 00:00:00	8527	0	\N	\N	\N	757135de-0386-4d70-9533-52f4fe6ba512	F	0	white	0	irish	0
1760	8532	1977	6	19	1977-06-19 00:00:00	0	38003563	\N	\N	\N	52b832b4-efe8-4c67-92be-24175eea36e8	F	0	hispanic	0	central_american	0
2004	8532	1971	6	1	1971-06-01 00:00:00	0	38003563	\N	\N	\N	5d91cd3d-a34a-417a-aaf6-b76c5157337d	F	0	hispanic	0	south_american	0
1917	8507	1949	7	3	1949-07-03 00:00:00	8516	0	\N	\N	\N	59880a4d-3579-4c3d-ad50-7658d5ddcc74	M	0	black	0	dominican	0
2028	8532	1945	12	5	1945-12-05 00:00:00	0	38003563	\N	\N	\N	5eb53549-169e-4402-9517-ba503431a24b	F	0	hispanic	0	south_american	0
1715	8532	1955	11	26	1955-11-26 00:00:00	8516	0	\N	\N	\N	50962347-d426-4854-8120-543d96b0a103	F	0	black	0	west_indian	0
1821	8507	1937	7	4	1937-07-04 00:00:00	8527	0	\N	\N	\N	55326b1c-89d4-461d-b660-9d33a2dceee6	M	0	white	0	irish	0
1850	8532	1956	12	14	1956-12-14 00:00:00	8515	0	\N	\N	\N	569e6793-81f4-40b6-bdaf-9f10f9a09b2b	F	0	asian	0	asian_indian	0
2283	8507	1937	10	18	1937-10-18 00:00:00	8527	0	\N	\N	\N	6b07a4de-2bf3-4ab9-9ca5-f2f351dcff79	M	0	white	0	italian	0
1666	8507	1934	10	6	1934-10-06 00:00:00	8527	0	\N	\N	\N	4e29802e-cec8-4e56-adb5-6e626f1c949c	M	0	white	0	italian	0
2176	8532	1956	8	20	1956-08-20 00:00:00	8527	0	\N	\N	\N	660bd1de-54b0-4283-a801-d6c952d19c54	F	0	white	0	irish	0
2027	8507	1961	3	17	1961-03-17 00:00:00	8516	0	\N	\N	\N	5eb293c4-0e47-4741-ba8c-e02dc544c1e5	M	0	black	0	dominican	0
2463	8532	1969	4	10	1969-04-10 00:00:00	0	38003563	\N	\N	\N	744cb795-4a77-4552-8e73-e00e678ce30a	F	0	hispanic	0	puerto_rican	0
1737	8507	1911	9	22	1911-09-22 00:00:00	0	38003563	\N	\N	\N	51949373-1df9-4eb7-acc1-45764989c963	M	0	hispanic	0	puerto_rican	0
2414	8507	1918	4	4	1918-04-04 00:00:00	0	38003563	\N	\N	\N	71c38602-0c35-43ed-b715-b63ad326eff0	M	0	hispanic	0	puerto_rican	0
2469	8532	1971	8	1	1971-08-01 00:00:00	8527	0	\N	\N	\N	74894c6d-076b-48c6-b115-1b307f0c573e	F	0	white	0	english	0
2356	8507	1977	11	2	1977-11-02 00:00:00	8527	0	\N	\N	\N	6e8ccf0a-1c45-40e0-b13b-8fe35fc34772	M	0	white	0	polish	0
2692	8507	1947	11	17	1947-11-17 00:00:00	0	38003563	\N	\N	\N	7f89b9b0-0f76-498a-bf2b-bc61fd7b304a	M	0	hispanic	0	central_american	0
1878	8507	1975	3	16	1975-03-16 00:00:00	0	38003563	\N	\N	\N	579b4a64-e37a-4e57-a30a-88d989bf54dd	M	0	hispanic	0	central_american	0
1718	8507	1966	9	17	1966-09-17 00:00:00	8527	0	\N	\N	\N	50ce71f9-7c6a-4252-b36f-c08ca164f72b	M	0	white	0	american	0
2743	8532	1960	4	6	1960-04-06 00:00:00	0	38003563	\N	\N	\N	826f8a29-544b-42d4-a70c-ec7b53c809b1	F	0	hispanic	0	puerto_rican	0
2619	8532	1938	11	11	1938-11-11 00:00:00	8527	0	\N	\N	\N	7c627255-80cd-4f40-8968-843b3164fd22	F	0	white	0	italian	0
2025	8532	1909	2	20	1909-02-20 00:00:00	8527	0	\N	\N	\N	5e86b5e2-5397-4170-b70b-b83db94882b2	F	0	white	0	greek	0
1467	8532	1933	3	26	1933-03-26 00:00:00	8527	0	\N	\N	\N	45712c5c-2172-4438-a9dc-c06d957946d8	F	0	white	0	english	0
1786	8532	1943	2	27	1943-02-27 00:00:00	8527	0	\N	\N	\N	53b7b770-27c5-48ed-9438-cba284a685df	F	0	white	0	russian	0
1855	8532	1975	3	21	1975-03-21 00:00:00	0	38003563	\N	\N	\N	56c1cfb3-e0ab-4701-99e4-600fb5958017	F	0	hispanic	0	south_american	0
2561	8532	1976	10	27	1976-10-27 00:00:00	8515	0	\N	\N	\N	79ef2973-59e4-4e6f-8ede-533f67cdb1dd	F	0	asian	0	asian_indian	0
2349	8507	1972	4	9	1972-04-09 00:00:00	8527	0	\N	\N	\N	6e5beffe-1474-4fcb-b501-8c656f146187	M	0	white	0	italian	0
1973	8532	1971	6	7	1971-06-07 00:00:00	8515	0	\N	\N	\N	5be0bcac-ad0e-485e-8cb0-2d2521bfe818	F	0	asian	0	asian_indian	0
2005	8507	1973	8	11	1973-08-11 00:00:00	0	38003563	\N	\N	\N	5d955698-be28-4e53-bf65-25fee12d7b15	M	0	hispanic	0	puerto_rican	0
2381	8507	1936	3	18	1936-03-18 00:00:00	8515	0	\N	\N	\N	6fd2508b-9ad9-42ed-ac4d-a932fd797af7	M	0	asian	0	asian_indian	0
2438	8532	1980	6	22	1980-06-22 00:00:00	8527	0	\N	\N	\N	72dba285-d5a7-4c6a-a3bb-5a7cca996853	F	0	white	0	french	0
2088	8532	1908	9	22	1908-09-22 00:00:00	8527	0	\N	\N	\N	61512e3c-e532-46db-8546-cf5756f207fd	F	0	white	0	irish	0
2621	8507	1956	8	25	1956-08-25 00:00:00	0	38003563	\N	\N	\N	7c7d88cd-cfd8-4a00-a1f5-b8914464dcc4	M	0	hispanic	0	central_american	0
1702	8507	1964	11	1	1964-11-01 00:00:00	8527	0	\N	\N	\N	4fe4766d-7a38-4ac8-82d2-7f1b63dd0cba	M	0	white	0	italian	0
2012	8507	1957	2	1	1957-02-01 00:00:00	8527	0	\N	\N	\N	5dd1114e-2481-40d5-a021-c2c57458e08b	M	0	white	0	english	0
2007	8507	1986	11	2	1986-11-02 00:00:00	0	38003563	\N	\N	\N	5da3a5e7-64f5-41d7-bf4f-30534766386f	M	0	hispanic	0	south_american	0
2177	8507	1966	10	26	1966-10-26 00:00:00	8527	0	\N	\N	\N	662857ec-96fa-4ac5-9adb-0d84b81baf04	M	0	white	0	russian	0
2579	8532	1952	4	20	1952-04-20 00:00:00	8527	0	\N	\N	\N	7ad552fd-a98c-4b66-8a7a-fb1fe7b0b65e	F	0	white	0	french	0
1947	8532	1948	10	17	1948-10-17 00:00:00	8516	0	\N	\N	\N	5b09e45b-09ce-4292-bda6-8a773539c3b4	F	0	black	0	west_indian	0
2108	8507	1939	9	8	1939-09-08 00:00:00	8527	0	\N	\N	\N	6270d099-2f85-46a2-b126-4d42d400d04b	M	0	white	0	irish	0
2090	8532	1966	6	1	1966-06-01 00:00:00	8527	0	\N	\N	\N	61611b8c-8a2d-4dd5-8b1d-a0e45591e2d7	F	0	white	0	english	0
2043	8507	1955	9	11	1955-09-11 00:00:00	8527	0	\N	\N	\N	5f02b063-5f9f-4552-891c-7c787ae2ca2f	M	0	white	0	irish	0
2521	8532	1948	1	19	1948-01-19 00:00:00	8527	0	\N	\N	\N	77763d60-9952-42ae-8bb6-d9baeb45442a	F	0	white	0	irish	0
2468	8507	1938	4	10	1938-04-10 00:00:00	8527	0	\N	\N	\N	7488e94c-c9ec-4134-ba5d-ab1cd1e01cc2	M	0	white	0	french_canadian	0
1879	8507	1958	10	4	1958-10-04 00:00:00	8527	0	\N	\N	\N	57a23d9f-c9c5-4fff-98a7-55044aeadb0e	M	0	white	0	italian	0
2076	8507	1966	12	29	1966-12-29 00:00:00	8516	0	\N	\N	\N	6070d911-781b-49c0-8b81-e8a7df5210c8	M	0	black	0	west_indian	0
1758	8532	1960	8	19	1960-08-19 00:00:00	8527	0	\N	\N	\N	52a5a3ad-63cb-411a-b676-9668f202632d	F	0	white	0	english	0
2319	8532	1947	2	15	1947-02-15 00:00:00	8527	0	\N	\N	\N	6c72b775-215c-48f5-a086-83e2a25232d5	F	0	white	0	italian	0
2250	8507	1956	3	7	1956-03-07 00:00:00	8527	0	\N	\N	\N	6955a557-b7e8-45a8-9266-69dc59fdaff8	M	0	white	0	portuguese	0
2404	8507	1965	12	5	1965-12-05 00:00:00	8516	0	\N	\N	\N	7153505f-079c-40ca-83f7-9f261f51ea22	M	0	black	0	west_indian	0
2180	8507	1978	9	30	1978-09-30 00:00:00	8515	0	\N	\N	\N	663f5122-d60e-4653-b59e-d18488ba99d1	M	0	asian	0	chinese	0
2191	8507	1970	4	19	1970-04-19 00:00:00	8516	0	\N	\N	\N	66cbb9c4-1e70-4ea4-93fb-739a5e1db3f6	M	0	black	0	dominican	0
2165	8507	1954	6	1	1954-06-01 00:00:00	0	38003563	\N	\N	\N	65a6e679-7f0a-446b-af65-c48bae7287d1	M	0	hispanic	0	mexican	0
2002	8507	1975	3	13	1975-03-13 00:00:00	8516	0	\N	\N	\N	5d68ec51-3841-4b63-86b7-b84db79ebdd3	M	0	black	0	african	0
2243	8507	1966	1	21	1966-01-21 00:00:00	0	38003563	\N	\N	\N	68e34b93-4e4b-43ab-8730-b5136939c93d	M	0	hispanic	0	puerto_rican	0
1729	8507	1977	9	7	1977-09-07 00:00:00	8516	0	\N	\N	\N	5145c524-aa5c-4b10-bf3f-61f65385048e	M	0	black	0	west_indian	0
2427	8532	1942	1	13	1942-01-13 00:00:00	0	38003563	\N	\N	\N	7267b0f1-ff95-4bb8-8416-32eeb279a79d	F	0	hispanic	0	puerto_rican	0
2105	8507	1974	8	18	1974-08-18 00:00:00	8527	0	\N	\N	\N	620f4de6-a9ec-448c-811b-c29004867826	M	0	white	0	italian	0
2444	8532	1955	8	7	1955-08-07 00:00:00	0	38003563	\N	\N	\N	731bbc40-cb78-480a-a9cf-17c551c2ba6c	F	0	hispanic	0	central_american	0
2232	8532	1963	5	10	1963-05-10 00:00:00	8527	0	\N	\N	\N	68a6ada0-9b02-42ca-ae4f-88aca2acaa78	F	0	white	0	english	0
1611	8507	1952	6	8	1952-06-08 00:00:00	8527	0	\N	\N	\N	4c0d6552-e127-4243-8b58-c6249197918a	M	0	white	0	french	0
2620	8532	1963	11	12	1963-11-12 00:00:00	8527	0	\N	\N	\N	7c7087f5-558a-4181-ae72-17a58395c126	F	0	white	0	french_canadian	0
2343	8507	1956	1	14	1956-01-14 00:00:00	8516	0	\N	\N	\N	6dfa2f43-b037-4b91-8a2c-49776f2e68c1	M	0	black	0	african	0
2576	8532	1979	11	8	1979-11-08 00:00:00	8527	0	\N	\N	\N	7ab1b9b3-d222-40a2-a9ab-84796e40b0ca	F	0	white	0	polish	0
1843	8532	1981	8	19	1981-08-19 00:00:00	8515	0	\N	\N	\N	56488f9b-a0c8-4251-9297-d569b94e6074	F	0	asian	0	chinese	0
2062	8507	1946	8	17	1946-08-17 00:00:00	8516	0	\N	\N	\N	5fd5fbb5-bfbf-444e-97d5-eac7aa412f77	M	0	black	0	african	0
1937	8532	1963	5	14	1963-05-14 00:00:00	8527	0	\N	\N	\N	5a746f0e-8121-4360-b60d-9d982be26290	F	0	white	0	american	0
2220	8507	1942	4	15	1942-04-15 00:00:00	8527	0	\N	\N	\N	682a0a31-71e7-452a-a629-24cbc22ffaf8	M	0	white	0	swedish	0
1733	8532	1981	2	18	1981-02-18 00:00:00	0	38003563	\N	\N	\N	5170b2c8-32b0-4566-b408-70f5bb58d595	F	0	hispanic	0	puerto_rican	0
2033	8507	1951	5	22	1951-05-22 00:00:00	0	38003563	\N	\N	\N	5ebf0333-1b0a-44cf-b764-3a6b415e4c39	M	0	hispanic	0	central_american	0
1952	8532	1954	8	2	1954-08-02 00:00:00	8527	0	\N	\N	\N	5b276e04-05c8-4f85-8aae-33ab51d4696f	F	0	white	0	italian	0
2466	8507	1979	9	16	1979-09-16 00:00:00	8516	0	\N	\N	\N	747bffd0-5f88-4613-b352-52098029f2ba	M	0	black	0	african	0
1780	8507	1965	6	15	1965-06-15 00:00:00	8516	0	\N	\N	\N	53577fb8-cc1a-4e34-9967-1e66a62622bc	M	0	black	0	west_indian	0
2294	8507	1960	11	25	1960-11-25 00:00:00	8516	0	\N	\N	\N	6b8079b7-e910-4f2e-9eb9-e93c67100737	M	0	black	0	african	0
2097	8532	1977	3	5	1977-03-05 00:00:00	8527	0	\N	\N	\N	61bda4b8-b4ce-4646-b8fe-999f91f498d4	F	0	white	0	polish	0
2537	8507	1947	8	17	1947-08-17 00:00:00	8527	0	\N	\N	\N	78206c69-2781-43f4-98a7-63acadfd878c	M	0	white	0	german	0
1900	8532	1963	10	7	1963-10-07 00:00:00	0	38003563	\N	\N	\N	58dc5556-8c70-47b5-958e-3f1dbe8d033c	F	0	hispanic	0	puerto_rican	0
2548	8507	1965	10	3	1965-10-03 00:00:00	8527	0	\N	\N	\N	78de7bbb-1ab0-4a15-bd58-041dc96b3cae	M	0	white	0	irish	0
2563	8507	1970	6	21	1970-06-21 00:00:00	0	38003563	\N	\N	\N	7a069610-bf25-4f99-8e48-7fda23effcdd	M	0	hispanic	0	mexican	0
2686	8507	1952	9	21	1952-09-21 00:00:00	8527	0	\N	\N	\N	7f6675d1-63c5-4943-9f98-30f45f551350	M	0	white	0	irish	0
2802	8507	1938	9	10	1938-09-10 00:00:00	8527	0	\N	\N	\N	84dfd9bd-7e04-4ffc-a577-ee7243e43429	M	0	white	0	english	0
2070	8532	1964	10	26	1964-10-26 00:00:00	0	38003563	\N	\N	\N	603039c9-4393-4458-aae1-0cbbd8aca057	F	0	hispanic	0	south_american	0
1929	8532	1954	8	19	1954-08-19 00:00:00	8527	0	\N	\N	\N	5a009d9f-ab4f-4d33-bbaa-4f21ff12fcdd	F	0	white	0	irish	0
2834	8532	1937	4	24	1937-04-24 00:00:00	8516	0	\N	\N	\N	861d44ec-6fa0-4ccf-aa24-a8c9140534f1	F	0	black	0	african	0
2721	8507	1967	11	11	1967-11-11 00:00:00	8527	0	\N	\N	\N	81641823-57f6-4178-a6fc-bf33762ab8c2	M	0	white	0	english	0
2217	8532	1979	6	29	1979-06-29 00:00:00	0	38003563	\N	\N	\N	680ae5c2-b1f8-435d-85a5-10276afd90ba	F	0	hispanic	0	puerto_rican	0
1565	8507	1964	9	13	1964-09-13 00:00:00	8516	0	\N	\N	\N	498ce087-2d28-44d0-a698-e17e37b930a6	M	0	black	0	african	0
1971	8532	1969	3	14	1969-03-14 00:00:00	8527	0	\N	\N	\N	5bcd660b-12e2-4c41-92a4-d86fa707b6bd	F	0	white	0	american	0
2175	8532	1976	1	29	1976-01-29 00:00:00	8527	0	\N	\N	\N	6609025a-e346-4778-92c5-d65cb734095e	F	0	white	0	polish	0
2679	8507	1972	3	31	1972-03-31 00:00:00	8515	0	\N	\N	\N	7f0b28e2-a8c1-44f4-8c93-6ba6770b627f	M	0	asian	0	chinese	0
2395	8507	1959	2	13	1959-02-13 00:00:00	0	38003563	\N	\N	\N	7091cf21-0588-4e63-8489-f9dd85d8eec9	M	0	hispanic	0	central_american	0
1987	8507	1943	8	13	1943-08-13 00:00:00	8527	0	\N	\N	\N	5c72163b-11ec-48ec-bd4b-5572eb1c2357	M	0	white	0	english	0
2063	8507	1972	11	10	1972-11-10 00:00:00	8527	0	\N	\N	\N	5fd876e1-13d8-4120-9707-620a071e32e5	M	0	white	0	polish	0
2567	8532	1975	7	26	1975-07-26 00:00:00	8515	0	\N	\N	\N	7a30b3b0-cf8b-4b02-bcc5-c0ed60348d9d	F	0	asian	0	chinese	0
2646	8507	1974	7	12	1974-07-12 00:00:00	0	38003563	\N	\N	\N	7d998e37-ca19-4766-884f-79f281249245	M	0	hispanic	0	puerto_rican	0
2226	8507	1942	1	23	1942-01-23 00:00:00	0	38003563	\N	\N	\N	68580d85-1304-4be2-b728-ee63e6fb10f7	M	0	hispanic	0	puerto_rican	0
2818	8507	1967	12	4	1967-12-04 00:00:00	8516	0	\N	\N	\N	8571b9d6-d844-4029-8a49-4957a7689463	M	0	black	0	african	0
1744	8507	1975	5	2	1975-05-02 00:00:00	8527	0	\N	\N	\N	51cb99f3-982a-47fd-a667-73afedb3fe37	M	0	white	0	american	0
2054	8532	1971	6	24	1971-06-24 00:00:00	0	38003563	\N	\N	\N	5f859657-a1c7-460d-ab85-4c288f08c324	F	0	hispanic	0	central_american	0
2199	8507	1979	7	22	1979-07-22 00:00:00	8515	0	\N	\N	\N	670e63ce-222b-4897-b2fa-2574c9e2cf0d	M	0	asian	0	asian_indian	0
2295	8507	1973	2	6	1973-02-06 00:00:00	8527	0	\N	\N	\N	6b8b6c7d-188d-4a37-9331-6b6357495177	M	0	white	0	irish	0
2661	8532	1964	9	11	1964-09-11 00:00:00	8527	0	\N	\N	\N	7e5bd677-851b-4307-8759-2b4fbd9e5924	F	0	white	0	english	0
2103	8532	1972	5	13	1972-05-13 00:00:00	8516	0	\N	\N	\N	61f668ab-fe49-4885-ba91-b293c87ba387	F	0	black	0	west_indian	0
2122	8507	1973	10	20	1973-10-20 00:00:00	8527	0	\N	\N	\N	634e0d40-3263-4053-a9f7-869bbc64c9cb	M	0	white	0	irish	0
2140	8507	1951	6	6	1951-06-06 00:00:00	8527	0	\N	\N	\N	64a8d5ed-9b3d-400b-876d-fe13e04dd8bd	M	0	white	0	italian	0
2135	8532	1948	2	2	1948-02-02 00:00:00	8527	0	\N	\N	\N	6441f7f3-a15c-418b-95fa-f78758934a32	F	0	white	0	italian	0
2988	8507	1962	6	10	1962-06-10 00:00:00	8527	0	\N	\N	\N	8d6572c4-e99d-4f36-a25c-f639ff3ab910	M	0	white	0	italian	0
2712	8532	1963	12	31	1963-12-31 00:00:00	8516	0	\N	\N	\N	80d54133-6db1-40cc-9ede-94c01c4b1599	F	0	black	0	west_indian	0
2071	8532	1965	6	16	1965-06-16 00:00:00	8515	0	\N	\N	\N	6031b1d8-cd76-4db3-8827-1c1fd447e4da	F	0	asian	0	asian_indian	0
2339	8507	1972	8	22	1972-08-22 00:00:00	8527	0	\N	\N	\N	6dc0f76e-4981-42d1-93d9-ebef7e28376f	M	0	white	0	irish	0
1915	8507	1974	3	5	1974-03-05 00:00:00	8527	0	\N	\N	\N	597a26a3-83eb-44c5-98f4-ea63de12876a	M	0	white	0	scottish	0
2425	8532	1960	2	18	1960-02-18 00:00:00	0	0	\N	\N	\N	7241131b-f210-48c7-9c1c-aebe4c32f4f9	F	0	native	0	american_indian	0
2329	8532	1971	1	12	1971-01-12 00:00:00	8527	0	\N	\N	\N	6d2bb477-821a-4e9f-b32b-50290f2f4be3	F	0	white	0	french_canadian	0
2740	8532	1968	12	10	1968-12-10 00:00:00	8527	0	\N	\N	\N	8263f879-bda7-490a-a0d4-7e64a14a5f3e	F	0	white	0	english	0
2290	8507	1956	9	29	1956-09-29 00:00:00	8527	0	\N	\N	\N	6b61105a-1beb-4296-bde5-bdaef933f561	M	0	white	0	german	0
2297	8532	1973	9	6	1973-09-06 00:00:00	8516	0	\N	\N	\N	6b9fe9ff-c959-44da-92b0-200835adb76d	F	0	black	0	african	0
2287	8507	1940	3	1	1940-03-01 00:00:00	8527	0	\N	\N	\N	6b44cdac-f1f7-4aaa-a202-61efb2e8e076	M	0	white	0	polish	0
2056	8507	1976	2	11	1976-02-11 00:00:00	8527	0	\N	\N	\N	5f8ca591-9879-4305-8157-244f185ce57a	M	0	white	0	irish	0
2320	8507	1941	8	2	1941-08-02 00:00:00	8527	0	\N	\N	\N	6c7647e1-62ab-48f7-b10c-01e2a9f103d2	M	0	white	0	irish	0
1892	8532	1960	7	14	1960-07-14 00:00:00	8527	0	\N	\N	\N	5858eba5-7482-4499-a947-b5733595c906	F	0	white	0	irish	0
2609	8507	1958	5	2	1958-05-02 00:00:00	8515	0	\N	\N	\N	7c034a48-4a0b-4660-94b1-9022b8479570	M	0	asian	0	chinese	0
2127	8532	1960	9	3	1960-09-03 00:00:00	8527	0	\N	\N	\N	63ba1e29-03a9-4df7-86b4-b668ea14e091	F	0	white	0	french	0
2554	8532	1933	7	27	1933-07-27 00:00:00	8516	0	\N	\N	\N	79ac60a7-75a8-428b-99f9-a3e66a799008	F	0	black	0	african	0
2333	8532	1920	6	1	1920-06-01 00:00:00	8527	0	\N	\N	\N	6d6b179e-35d3-4e73-984c-1245b32e7c9c	F	0	white	0	irish	0
1703	8507	1949	2	9	1949-02-09 00:00:00	8527	0	\N	\N	\N	4fea9ee0-1487-47c5-ad24-e586dfcfa842	M	0	white	0	german	0
2768	8532	1969	6	10	1969-06-10 00:00:00	8527	0	\N	\N	\N	836abb7d-2ca9-4a30-8a77-1df8559a56d6	F	0	white	0	scottish	0
2507	8532	1967	5	2	1967-05-02 00:00:00	8515	0	\N	\N	\N	7678fcbf-9c0b-4e64-adbb-030bd2fa7513	F	0	asian	0	asian_indian	0
2662	8507	1978	4	27	1978-04-27 00:00:00	0	38003563	\N	\N	\N	7e635e32-b7df-45d7-aa5f-214110610482	M	0	hispanic	0	central_american	0
1861	8507	1981	11	28	1981-11-28 00:00:00	8527	0	\N	\N	\N	56e21e09-f12f-4411-81c5-4ca9aa9f60ce	M	0	white	0	french	0
2168	8507	1956	9	13	1956-09-13 00:00:00	8516	0	\N	\N	\N	65e0108c-10bf-479e-9db7-e1040373054e	M	0	black	0	west_indian	0
2109	8507	1969	11	23	1969-11-23 00:00:00	0	38003563	\N	\N	\N	62793270-f627-4d09-bd36-8e5759f1bce8	M	0	hispanic	0	puerto_rican	0
2266	8507	1968	12	14	1968-12-14 00:00:00	0	38003563	\N	\N	\N	6a061235-843f-40d6-bdbc-6dec1ce96368	M	0	hispanic	0	south_american	0
1814	8507	1940	4	20	1940-04-20 00:00:00	8527	0	\N	\N	\N	54fa3e32-c519-441c-9d93-cbd60f81bee4	M	0	white	0	english	0
2091	8507	1964	11	14	1964-11-14 00:00:00	0	38003563	\N	\N	\N	6164c257-a14b-41f8-961d-d2b44ccc01fb	M	0	hispanic	0	mexican	0
2006	8532	1946	1	18	1946-01-18 00:00:00	8527	0	\N	\N	\N	5d9d4492-d7d2-4998-aadd-d5417bbaeda5	F	0	white	0	italian	0
2564	8532	1976	8	21	1976-08-21 00:00:00	8527	0	\N	\N	\N	7a1b91b5-f15b-4ad7-8f15-b74c284736ad	F	0	white	0	polish	0
2151	8507	1918	6	12	1918-06-12 00:00:00	0	0	\N	\N	\N	651896a5-3ee5-44be-a0d5-0e242fbdfc91	M	0	native	0	american_indian	0
2341	8532	1952	3	27	1952-03-27 00:00:00	8527	0	\N	\N	\N	6ddbff89-a8dc-4398-bbdd-f5c95509df83	F	0	white	0	irish	0
2119	8532	1961	6	12	1961-06-12 00:00:00	8527	0	\N	\N	\N	632d8dac-a05f-48e2-bb30-c5ffd69a8aaa	F	0	white	0	italian	0
2617	8507	1952	2	9	1952-02-09 00:00:00	0	38003563	\N	\N	\N	7c614114-0151-44be-b66b-b09c57f01436	M	0	hispanic	0	puerto_rican	0
2138	8507	1954	10	10	1954-10-10 00:00:00	8527	0	\N	\N	\N	64748776-3dc5-46e4-ba63-ae6a058b126c	M	0	white	0	italian	0
2596	8507	1966	10	29	1966-10-29 00:00:00	8515	0	\N	\N	\N	7bb1d47d-6b94-489d-8974-2f433f7912a5	M	0	asian	0	asian_indian	0
2677	8507	1972	4	14	1972-04-14 00:00:00	8527	0	\N	\N	\N	7eff695c-76f4-4a1d-a7f0-1f879ba8f4ed	M	0	white	0	irish	0
2706	8507	1963	4	9	1963-04-09 00:00:00	8516	0	\N	\N	\N	803ead31-c15d-4e66-92eb-4db0475c1e98	M	0	black	0	african	0
2849	8507	1919	8	4	1919-08-04 00:00:00	8527	0	\N	\N	\N	86acd3c4-7c8f-4deb-8072-9be54e2eb64b	M	0	white	0	irish	0
2298	8507	1970	10	29	1970-10-29 00:00:00	8527	0	\N	\N	\N	6ba09993-137a-492e-b100-78a6665a8113	M	0	white	0	german	0
2131	8507	1951	7	26	1951-07-26 00:00:00	8515	0	\N	\N	\N	641613ec-46f7-4af5-ad03-fc2c2c46718f	M	0	asian	0	chinese	0
3070	8532	1966	9	25	1966-09-25 00:00:00	0	38003563	\N	\N	\N	911f2032-4799-4a8b-b650-c635b39840dd	F	0	hispanic	0	south_american	0
3048	8532	1974	5	15	1974-05-15 00:00:00	8527	0	\N	\N	\N	90043c9e-59f9-4706-98d8-7ccaceb39364	F	0	white	0	portuguese	0
2528	8507	1968	3	20	1968-03-20 00:00:00	8516	0	\N	\N	\N	77c5c995-1333-4980-8777-ae3c59ca296d	M	0	black	0	african	0
1826	8507	1938	3	8	1938-03-08 00:00:00	8527	0	\N	\N	\N	559ad22d-e8b3-482e-a086-964d8c1d7f19	M	0	white	0	french	0
1989	8532	1952	2	15	1952-02-15 00:00:00	0	38003563	\N	\N	\N	5c8d977b-a6ec-4f54-9f67-1457045cb642	F	0	hispanic	0	puerto_rican	0
2277	8532	1965	9	5	1965-09-05 00:00:00	0	38003563	\N	\N	\N	6ac676f4-9b9a-4d15-97bd-c2d58c9938de	F	0	hispanic	0	puerto_rican	0
2715	8507	1966	1	13	1966-01-13 00:00:00	8527	0	\N	\N	\N	810f480a-9849-4624-98c9-6ee2eb8b5c2c	M	0	white	0	french	0
2487	8532	1952	3	2	1952-03-02 00:00:00	8527	0	\N	\N	\N	7572d622-e6a2-4c19-bafe-6b936b3d3937	F	0	white	0	english	0
2073	8507	1963	2	15	1963-02-15 00:00:00	8527	0	\N	\N	\N	603dcb64-78a6-4bd4-96e2-6da59059107a	M	0	white	0	english	0
2352	8507	1970	10	26	1970-10-26 00:00:00	8515	0	\N	\N	\N	6e746a36-2783-4a1b-b853-e8cc05c92001	M	0	asian	0	chinese	0
2673	8532	1977	2	7	1977-02-07 00:00:00	8527	0	\N	\N	\N	7ecc9690-6d25-4b0f-b3b9-983da251d405	F	0	white	0	irish	0
2764	8532	1973	8	24	1973-08-24 00:00:00	8516	0	\N	\N	\N	83461dfe-cc40-434d-815d-92463a5988b9	F	0	black	0	west_indian	0
2244	8507	1953	7	24	1953-07-24 00:00:00	8516	0	\N	\N	\N	68fdecfa-dd1d-4e42-bd59-55006d7b7bd9	M	0	black	0	dominican	0
3128	8532	1973	7	24	1973-07-24 00:00:00	0	38003563	\N	\N	\N	946a61d6-05fc-4b5d-a645-8e7758f59c6c	F	0	hispanic	0	central_american	0
1945	8507	1970	11	28	1970-11-28 00:00:00	0	38003563	\N	\N	\N	5ac0c31c-cded-4dbe-a235-71d007039340	M	0	hispanic	0	central_american	0
2160	8532	1960	7	11	1960-07-11 00:00:00	8527	0	\N	\N	\N	65879898-5b44-490a-9a94-590da3ce700f	F	0	white	0	portuguese	0
2273	8507	1983	10	19	1983-10-19 00:00:00	8527	0	\N	\N	\N	6a44ce2a-47a8-4756-9021-7ed1e7c7921a	M	0	white	0	swedish	0
2340	8507	1959	3	4	1959-03-04 00:00:00	8527	0	\N	\N	\N	6dd4d780-2269-4be0-8e8c-90ce37a8b331	M	0	white	0	scottish	0
2697	8507	1933	4	20	1933-04-20 00:00:00	8516	0	\N	\N	\N	7fea4a1b-32eb-457e-b0f0-7fc621235058	M	0	black	0	west_indian	0
2267	8532	1965	12	13	1965-12-13 00:00:00	8527	0	\N	\N	\N	6a0a5d55-3287-4d98-a44d-718835f57380	F	0	white	0	greek	0
2256	8532	1978	8	9	1978-08-09 00:00:00	0	38003563	\N	\N	\N	697c3f88-185c-4e4e-813c-5456f40e5450	F	0	hispanic	0	south_american	0
2325	8532	1970	10	29	1970-10-29 00:00:00	8527	0	\N	\N	\N	6cf90b7a-1e40-444e-a608-cd9958a7cc60	F	0	white	0	french	0
2235	8507	1951	12	5	1951-12-05 00:00:00	8527	0	\N	\N	\N	68b8243b-143f-4b5c-9cfb-dfb3ef9cbec5	M	0	white	0	french_canadian	0
3084	8532	1977	11	23	1977-11-23 00:00:00	8527	0	\N	\N	\N	921b9fd5-9638-45b8-a77d-b14c31df8fa2	F	0	white	0	english	0
2798	8532	1953	10	11	1953-10-11 00:00:00	8527	0	\N	\N	\N	84a15ecc-8721-41df-981f-399b00951543	F	0	white	0	irish	0
2145	8507	1963	12	21	1963-12-21 00:00:00	8516	0	\N	\N	\N	64e1c73a-0a5f-47cb-9277-c8836034a3fc	M	0	black	0	african	0
2389	8532	1969	4	1	1969-04-01 00:00:00	8527	0	\N	\N	\N	7078ea5a-f73d-4859-8c27-06204d4a1a8e	F	0	white	0	english	0
2017	8507	1969	7	29	1969-07-29 00:00:00	8527	0	\N	\N	\N	5e3be288-19ff-45fc-b434-483b14038ddb	M	0	white	0	irish	0
2611	8507	1951	7	19	1951-07-19 00:00:00	8527	0	\N	\N	\N	7c1d134c-a9d1-4aad-bd62-0c6641b7a029	M	0	white	0	portuguese	0
2435	8532	1972	11	10	1972-11-10 00:00:00	8527	0	\N	\N	\N	72b47a7b-60aa-47cb-999d-b922c0193494	F	0	white	0	german	0
2833	8532	1935	10	14	1935-10-14 00:00:00	8527	0	\N	\N	\N	8610f93a-0841-4e48-8baa-9cbbec3ff8a2	F	0	white	0	english	0
2337	8532	1963	7	16	1963-07-16 00:00:00	8516	0	\N	\N	\N	6dba4325-1e49-41c1-819c-ffd362287b70	F	0	black	0	dominican	0
2346	8507	1946	2	6	1946-02-06 00:00:00	8527	0	\N	\N	\N	6e25d8d7-93b7-4581-b8c5-79c77bdd1524	M	0	white	0	english	0
2470	8532	1958	12	15	1958-12-15 00:00:00	8527	0	\N	\N	\N	749ab756-dc3c-4f5b-bbff-ea50e4fe80e4	F	0	white	0	polish	0
2174	8532	1974	6	30	1974-06-30 00:00:00	8527	0	\N	\N	\N	65f694a9-0d68-456e-8037-89b5f1a8851a	F	0	white	0	english	0
2406	8507	1942	12	10	1942-12-10 00:00:00	8527	0	\N	\N	\N	715edf57-3e5e-4284-a246-56336fdc53ae	M	0	white	0	german	0
1928	8532	1971	8	4	1971-08-04 00:00:00	8527	0	\N	\N	\N	59cd6a0f-aaec-4ed4-9e3a-39d0c574b264	F	0	white	0	polish	0
2631	8507	1951	5	13	1951-05-13 00:00:00	8516	0	\N	\N	\N	7cf9db86-d1c7-4abb-8f89-66300f32e4c7	M	0	black	0	african	0
2211	8507	1971	6	20	1971-06-20 00:00:00	8527	0	\N	\N	\N	67c961bc-8739-454c-bb81-a155c669a847	M	0	white	0	irish	0
2602	8532	1948	9	29	1948-09-29 00:00:00	8527	0	\N	\N	\N	7bdc45a5-5d5a-4d55-9a08-ddaf4b35cd8d	F	0	white	0	russian	0
2411	8532	1964	7	2	1964-07-02 00:00:00	8527	0	\N	\N	\N	71a0f4f4-ac7f-4813-ba75-a7bb64a0622c	F	0	white	0	polish	0
1745	8532	1979	1	15	1979-01-15 00:00:00	8527	0	\N	\N	\N	51d78f5e-eb9a-480f-8334-59bed330cee8	F	0	white	0	french	0
2933	8532	1953	11	23	1953-11-23 00:00:00	8515	0	\N	\N	\N	8af6e4dc-bf3b-4468-bf0a-6a37e7fbc015	F	0	asian	0	asian_indian	0
2669	8507	1976	12	8	1976-12-08 00:00:00	0	38003563	\N	\N	\N	7eb9882d-732f-4d40-b29b-87de6992a522	M	0	hispanic	0	central_american	0
2698	8507	1983	4	6	1983-04-06 00:00:00	0	38003563	\N	\N	\N	800457ca-2f84-4622-8ce7-cf7f4929d2ba	M	0	hispanic	0	puerto_rican	0
2053	8507	1953	7	2	1953-07-02 00:00:00	8516	0	\N	\N	\N	5f81f7ee-28ed-4626-baad-b33d055ab801	M	0	black	0	african	0
2274	8507	1946	11	3	1946-11-03 00:00:00	8527	0	\N	\N	\N	6a52b01c-5829-45fb-aeeb-9282fdb4d7f4	M	0	white	0	italian	0
2123	8507	1949	4	22	1949-04-22 00:00:00	8527	0	\N	\N	\N	63582983-b525-47a7-8d02-320a0d2a849f	M	0	white	0	irish	0
2431	8532	1971	7	21	1971-07-21 00:00:00	8527	0	\N	\N	\N	72a2f03b-211b-49a4-8c2a-47e5db63f864	F	0	white	0	italian	0
2080	8507	1979	10	12	1979-10-12 00:00:00	8527	0	\N	\N	\N	60b5512e-ca37-44ca-91ee-3ed418d6bbd0	M	0	white	0	italian	0
2141	8507	1946	7	8	1946-07-08 00:00:00	8516	0	\N	\N	\N	64aacda3-27eb-45a2-a7f3-bac29f7265be	M	0	black	0	dominican	0
2060	8532	1963	12	4	1963-12-04 00:00:00	8516	0	\N	\N	\N	5fc18c22-b68c-4607-8c75-a0394da2035f	F	0	black	0	african	0
2674	8507	1971	4	23	1971-04-23 00:00:00	8527	0	\N	\N	\N	7edfa7c8-786e-4a63-8312-7b61d7112410	M	0	white	0	english	0
2392	8532	1916	2	4	1916-02-04 00:00:00	8516	0	\N	\N	\N	70804b2e-657e-42df-a9f8-4453f83cf5e1	F	0	black	0	dominican	0
2387	8532	1969	2	22	1969-02-22 00:00:00	8527	0	\N	\N	\N	706f20a8-0815-489f-8026-74874ae85348	F	0	white	0	italian	0
2318	8532	1963	1	26	1963-01-26 00:00:00	8527	0	\N	\N	\N	6c6cd08b-525a-45f1-bc0a-6717cdac9869	F	0	white	0	italian	0
2822	8507	1975	12	24	1975-12-24 00:00:00	8515	0	\N	\N	\N	85a79597-e48e-4f86-a7b2-25c654d82e7c	M	0	asian	0	chinese	0
2230	8507	1973	5	17	1973-05-17 00:00:00	8527	0	\N	\N	\N	689349b2-7060-4870-9f21-c697d709b89a	M	0	white	0	italian	0
2750	8507	1923	4	18	1923-04-18 00:00:00	8516	0	\N	\N	\N	82b80b57-3deb-4f6f-9db0-c5d4ad9b2fd7	M	0	black	0	dominican	0
2799	8507	1980	4	2	1980-04-02 00:00:00	8527	0	\N	\N	\N	84a48843-a6c7-44b4-9ec6-6c938bfe3306	M	0	white	0	italian	0
2788	8507	1978	3	19	1978-03-19 00:00:00	8516	0	\N	\N	\N	843c3cf5-571a-42a5-b864-803d6e1410f6	M	0	black	0	west_indian	0
2903	8532	1963	9	15	1963-09-15 00:00:00	8527	0	\N	\N	\N	89fda6e3-5e14-4821-aad9-d5e2585b3401	F	0	white	0	english	0
2483	8532	1944	3	4	1944-03-04 00:00:00	8516	0	\N	\N	\N	755bb9bb-1988-4efc-a831-2fc892907d1a	F	0	black	0	dominican	0
2330	8507	1975	7	21	1975-07-21 00:00:00	8527	0	\N	\N	\N	6d3cd373-74f3-42fc-ac09-11679c107e53	M	0	white	0	american	0
3250	8507	1963	1	8	1963-01-08 00:00:00	0	38003563	\N	\N	\N	9a90eace-0612-4166-9001-7117fdc421ae	M	0	hispanic	0	south_american	0
3134	8507	1921	8	25	1921-08-25 00:00:00	8527	0	\N	\N	\N	94f04d09-ea21-43d4-86d6-c42c0d7a4d55	M	0	white	0	english	0
2630	8507	1959	12	20	1959-12-20 00:00:00	8527	0	\N	\N	\N	7cf5c986-a813-4c58-9f03-f3e4383fb85e	M	0	white	0	english	0
1976	8532	1982	12	20	1982-12-20 00:00:00	8527	0	\N	\N	\N	5c130740-3b3b-4820-b0bd-a9222645b6a0	F	0	white	0	polish	0
2079	8507	1955	12	16	1955-12-16 00:00:00	8527	0	\N	\N	\N	60a69eb8-5bb4-4d41-925e-75b66d236fb3	M	0	white	0	french_canadian	0
2358	8507	1971	6	8	1971-06-08 00:00:00	8527	0	\N	\N	\N	6e910148-1128-497c-8136-83d5bd9803eb	M	0	white	0	swedish	0
2878	8532	1980	8	24	1980-08-24 00:00:00	8527	0	\N	\N	\N	88a7cfe8-796a-477c-8d88-58cdac67a84b	F	0	white	0	greek	0
2497	8507	1961	8	31	1961-08-31 00:00:00	8527	0	\N	\N	\N	76092c92-cba6-44d2-9279-f9bebf08e611	M	0	white	0	scottish	0
2342	8532	1975	1	17	1975-01-17 00:00:00	8527	0	\N	\N	\N	6df68467-698c-455a-a7e8-2ead12e65456	F	0	white	0	irish	0
2524	8507	1949	6	18	1949-06-18 00:00:00	0	38003563	\N	\N	\N	778e8d07-46d7-47fe-b6b0-f2b93c1d637f	M	0	hispanic	0	south_american	0
2872	8507	1952	3	11	1952-03-11 00:00:00	8527	0	\N	\N	\N	88509f08-b76f-4428-8840-06c196dfe6ac	M	0	white	0	irish	0
2847	8532	1962	2	11	1962-02-11 00:00:00	8527	0	\N	\N	\N	8696b594-770a-4a4b-9c66-6c8c32de62b6	F	0	white	0	portuguese	0
2327	8532	1957	10	16	1957-10-16 00:00:00	8527	0	\N	\N	\N	6d1e241c-5cbb-4f1d-acc4-54f97c9cf654	F	0	white	0	russian	0
3150	8532	1939	4	27	1939-04-27 00:00:00	0	38003563	\N	\N	\N	95b5d072-1468-43e7-b5f0-eac1bcee90ed	F	0	hispanic	0	puerto_rican	0
2115	8532	1961	9	25	1961-09-25 00:00:00	8527	0	\N	\N	\N	62f482e9-2077-4f32-9a41-c2aaf6664c44	F	0	white	0	french	0
2204	8507	1945	9	13	1945-09-13 00:00:00	8527	0	\N	\N	\N	6778e2c2-fa7f-407b-a774-820e7cbd8524	M	0	white	0	portuguese	0
2372	8507	1959	4	3	1959-04-03 00:00:00	8515	0	\N	\N	\N	6f7e1c2f-e238-403e-a842-d2e63044f9b9	M	0	asian	0	asian_indian	0
2504	8532	1953	10	26	1953-10-26 00:00:00	8527	0	\N	\N	\N	7637195b-2584-43a0-8837-53bf0784fe66	F	0	white	0	italian	0
2815	8532	1962	9	14	1962-09-14 00:00:00	8527	0	\N	\N	\N	853e4f3c-2253-42d2-bf42-5a9929df23f6	F	0	white	0	english	0
2450	8532	1951	1	4	1951-01-04 00:00:00	0	38003563	\N	\N	\N	73642491-bf42-40f2-a955-d97e13e8b222	F	0	hispanic	0	south_american	0
2307	8532	1961	10	3	1961-10-03 00:00:00	0	38003563	\N	\N	\N	6c04ce15-a496-4da0-a3ed-3bd2fc604834	F	0	hispanic	0	puerto_rican	0
2447	8507	1980	8	20	1980-08-20 00:00:00	8527	0	\N	\N	\N	7341a324-7d85-4d6d-b842-fae3dbbcff6c	M	0	white	0	english	0
2334	8532	1936	1	30	1936-01-30 00:00:00	0	38003563	\N	\N	\N	6d6bdd33-db0a-49c1-b98d-07cf1f744a88	F	0	hispanic	0	puerto_rican	0
3194	8532	1942	6	15	1942-06-15 00:00:00	8527	0	\N	\N	\N	97d30443-03b3-45b3-a570-ab80783f8247	F	0	white	0	scottish	0
2891	8532	1973	11	22	1973-11-22 00:00:00	8527	0	\N	\N	\N	89647abe-a2a1-4236-9473-f4493285cfbf	F	0	white	0	polish	0
2189	8507	1980	2	3	1980-02-03 00:00:00	8527	0	\N	\N	\N	66994692-e18c-41c7-ab14-2a9c4adedaf1	M	0	white	0	german	0
2591	8532	1931	6	17	1931-06-17 00:00:00	8527	0	\N	\N	\N	7b3ec790-2999-4e30-9339-6680f55e1088	F	0	white	0	french	0
2418	8532	1973	9	4	1973-09-04 00:00:00	8527	0	\N	\N	\N	71eef81a-cf54-44e5-9fdd-fe4794559633	F	0	white	0	english	0
2966	8507	1961	11	11	1961-11-11 00:00:00	8527	0	\N	\N	\N	8c5f0ba5-2be2-4026-867b-80eba620541f	M	0	white	0	irish	0
2597	8507	1970	11	24	1970-11-24 00:00:00	8527	0	\N	\N	\N	7bb5565a-af81-4710-9d69-f921601e47f9	M	0	white	0	irish	0
2919	8507	1949	8	20	1949-08-20 00:00:00	8527	0	\N	\N	\N	8aa09c73-ca41-41a9-a141-d24c4054de45	M	0	white	0	irish	0
2509	8532	1969	6	8	1969-06-08 00:00:00	0	38003563	\N	\N	\N	768d1db9-af1a-427d-b972-ed516faeae81	F	0	hispanic	0	central_american	0
2396	8532	1919	11	19	1919-11-19 00:00:00	8527	0	\N	\N	\N	70a2cb57-ff97-45c5-b6db-9cdd6acbf9ad	F	0	white	0	irish	0
2889	8507	1960	3	20	1960-03-20 00:00:00	0	38003563	\N	\N	\N	893d8fc5-6697-4cf4-8066-035880cf82fd	M	0	hispanic	0	puerto_rican	0
2359	8507	1925	3	16	1925-03-16 00:00:00	8527	0	\N	\N	\N	6ea320d3-5678-4477-b3cf-0e487450c11a	M	0	white	0	irish	0
2442	8507	1971	6	21	1971-06-21 00:00:00	8527	0	\N	\N	\N	73081367-fe87-4e56-aabb-023f04be3c0d	M	0	white	0	irish	0
2046	8507	1939	12	26	1939-12-26 00:00:00	8527	0	\N	\N	\N	5f2602e5-6592-4ac6-81bb-926ada1f03ae	M	0	white	0	irish	0
2731	8532	1960	7	11	1960-07-11 00:00:00	8527	0	\N	\N	\N	81d32c23-2152-481c-b161-bbd3866dd8a8	F	0	white	0	irish	0
2261	8507	1963	11	5	1963-11-05 00:00:00	8515	0	\N	\N	\N	69eef614-2353-44a8-abc9-475361085c41	M	0	asian	0	asian_indian	0
2736	8532	1969	8	6	1969-08-06 00:00:00	8527	0	\N	\N	\N	82237186-a126-4e02-b372-e21184e5b442	F	0	white	0	irish	0
2439	8532	1972	5	17	1972-05-17 00:00:00	8527	0	\N	\N	\N	72f6d187-c65e-437f-adb8-8b5ec7b6b12e	F	0	white	0	italian	0
1794	8507	1959	2	7	1959-02-07 00:00:00	8516	0	\N	\N	\N	54388e14-686a-438b-afde-19b00277f1b2	M	0	black	0	african	0
2969	8507	1965	1	21	1965-01-21 00:00:00	8527	0	\N	\N	\N	8c865b35-0dea-432e-9ce5-c1995da2513c	M	0	white	0	german	0
2898	8532	1979	1	16	1979-01-16 00:00:00	0	38003563	\N	\N	\N	89bf1318-ee68-49d4-8bcc-fd55bb258880	F	0	hispanic	0	puerto_rican	0
2812	8507	1938	6	6	1938-06-06 00:00:00	8527	0	\N	\N	\N	8521ddb0-ae13-4ca6-ab1b-664e5bd42d92	M	0	white	0	french	0
2207	8532	1980	4	24	1980-04-24 00:00:00	8516	0	\N	\N	\N	678c5f53-6ae6-4477-b211-198ffe8b1ded	F	0	black	0	west_indian	0
2525	8532	1974	1	4	1974-01-04 00:00:00	8515	0	\N	\N	\N	7797a9bf-aadf-431b-88ce-f6b6619ad89a	F	0	asian	0	chinese	0
2456	8507	1955	4	24	1955-04-24 00:00:00	8527	0	\N	\N	\N	73a25674-6603-4746-853e-353bd69b3487	M	0	white	0	english	0
2613	8507	1955	5	13	1955-05-13 00:00:00	8527	0	\N	\N	\N	7c311d0b-5494-4853-813a-d0873374acff	M	0	white	0	english	0
2134	8507	1949	9	11	1949-09-11 00:00:00	0	38003563	\N	\N	\N	6436ba2c-fd9b-477f-ab92-6c2fb7fb9659	M	0	hispanic	0	mexican	0
2402	8507	1976	9	13	1976-09-13 00:00:00	8515	0	\N	\N	\N	7104f124-cd78-4a8f-92df-d2e3976a7c58	M	0	asian	0	asian_indian	0
2272	8532	1979	12	1	1979-12-01 00:00:00	8527	0	\N	\N	\N	6a35a076-74eb-4b00-a234-2f42c8f58b3c	F	0	white	0	english	0
2792	8507	1957	10	7	1957-10-07 00:00:00	8527	0	\N	\N	\N	846e393f-9077-4a0c-be19-37f883f84101	M	0	white	0	irish	0
2498	8507	1971	7	10	1971-07-10 00:00:00	8527	0	\N	\N	\N	76116485-e66b-45c8-a384-1946f913dacd	M	0	white	0	irish	0
2495	8532	1980	9	30	1980-09-30 00:00:00	8527	0	\N	\N	\N	75e9c062-cf8e-4b1d-8abf-611802b57cca	F	0	white	0	french_canadian	0
2424	8507	1962	6	14	1962-06-14 00:00:00	0	38003563	\N	\N	\N	721980b1-b1b6-4eae-a76e-e6c9ed6bed46	M	0	hispanic	0	mexican	0
3132	8507	1963	7	7	1963-07-07 00:00:00	8515	0	\N	\N	\N	94b3586d-53f6-4347-95e8-6ea24ced6574	M	0	asian	0	chinese	0
2240	8507	1957	3	26	1957-03-26 00:00:00	8527	0	\N	\N	\N	68cfa204-7932-47f0-823b-8b3a0d5dd162	M	0	white	0	irish	0
2760	8532	1957	3	28	1957-03-28 00:00:00	8527	0	\N	\N	\N	83293f28-750d-46b2-8558-bff66d5fb8ca	F	0	white	0	french	0
2876	8532	1963	10	10	1963-10-10 00:00:00	8527	0	\N	\N	\N	88a23ab3-c20c-4b97-a837-c2ca531e1ba4	F	0	white	0	english	0
2871	8507	1950	12	11	1950-12-11 00:00:00	8527	0	\N	\N	\N	884f2b0c-2227-4d20-a3a5-bfd13fe31dd1	M	0	white	0	french	0
3181	8532	1951	9	14	1951-09-14 00:00:00	8527	0	\N	\N	\N	9730745c-6b66-457a-9840-1bc981b36407	F	0	white	0	irish	0
2501	8507	1961	11	27	1961-11-27 00:00:00	8527	0	\N	\N	\N	761caa75-a534-4acf-8242-18395b64103b	M	0	white	0	polish	0
2412	8532	1950	5	26	1950-05-26 00:00:00	8516	0	\N	\N	\N	71a5db7b-0cc9-4150-a9a6-fccb8fa5ab21	F	0	black	0	dominican	0
3268	8507	1969	7	11	1969-07-11 00:00:00	8527	0	\N	\N	\N	9bc69fc3-b41e-4a40-8274-e417b52610d5	M	0	white	0	irish	0
3144	8532	1963	5	29	1963-05-29 00:00:00	8516	0	\N	\N	\N	956d6674-92a1-429e-b0bf-0ad247ae1155	F	0	black	0	dominican	0
2780	8507	1956	1	18	1956-01-18 00:00:00	8516	0	\N	\N	\N	83e27786-bb00-4688-a3e5-f57e6872e904	M	0	black	0	african	0
1998	8507	1981	9	19	1981-09-19 00:00:00	0	38003563	\N	\N	\N	5cffb5b0-2af6-446c-832a-187204f16690	M	0	hispanic	0	puerto_rican	0
2153	8532	1965	11	20	1965-11-20 00:00:00	8516	0	\N	\N	\N	652771f4-1d6a-4dde-95cc-4665024631f8	F	0	black	0	african	0
2476	8507	1956	10	3	1956-10-03 00:00:00	8527	0	\N	\N	\N	74dea1d6-b4a5-49de-8f32-f2fa50dd3b79	M	0	white	0	irish	0
2980	8507	1971	12	19	1971-12-19 00:00:00	8527	0	\N	\N	\N	8d1ad6c3-125a-45c4-92d1-73f35e80fd9d	M	0	white	0	portuguese	0
2577	8507	1973	5	12	1973-05-12 00:00:00	8527	0	\N	\N	\N	7abcf290-c4aa-43f5-bbe3-49a150e083da	M	0	white	0	french	0
2384	8532	1984	2	21	1984-02-21 00:00:00	8527	0	\N	\N	\N	702c9b54-4a97-419d-a7dc-aa2558dc7e64	F	0	white	0	french	0
2572	8532	1969	6	24	1969-06-24 00:00:00	8527	0	\N	\N	\N	7a776d8b-b2b1-4458-95cd-dab00be496a9	F	0	white	0	irish	0
2894	8507	1922	2	11	1922-02-11 00:00:00	8527	0	\N	\N	\N	89810fb2-b26c-46a0-bac1-b9d8fc7d1bad	M	0	white	0	italian	0
2921	8507	1940	6	18	1940-06-18 00:00:00	8527	0	\N	\N	\N	8aa9e088-bfb6-4bbe-ae5f-6b099d71a1d7	M	0	white	0	german	0
2445	8532	1927	10	3	1927-10-03 00:00:00	8527	0	\N	\N	\N	732151d7-5716-4e39-8159-cfc1253f5bcf	F	0	white	0	american	0
3234	8507	1947	10	27	1947-10-27 00:00:00	0	38003563	\N	\N	\N	99d7be71-8093-4cc1-9133-c3a167c6f9b8	M	0	hispanic	0	south_american	0
2265	8507	1963	2	17	1963-02-17 00:00:00	8527	0	\N	\N	\N	69fccda9-ef18-4519-9ba3-7e6f679d3e7e	M	0	white	0	french	0
2675	8507	1961	1	29	1961-01-29 00:00:00	8516	0	\N	\N	\N	7ef5daea-21a2-4945-98f3-3a44d3419e4d	M	0	black	0	west_indian	0
2526	8507	1974	12	23	1974-12-23 00:00:00	8527	0	\N	\N	\N	77bbdfe8-5859-499f-8a23-a14d3f9234d9	M	0	white	0	italian	0
2690	8507	1948	9	30	1948-09-30 00:00:00	8515	0	\N	\N	\N	7f86b268-f4dd-4e9f-a775-937b432cce23	M	0	asian	0	asian_indian	0
2860	8532	1941	10	17	1941-10-17 00:00:00	8516	0	\N	\N	\N	878f4635-bc7f-454a-bb31-d2523c6d1ae3	F	0	black	0	african	0
2626	8532	1963	7	2	1963-07-02 00:00:00	0	38003563	\N	\N	\N	7c9f402b-1401-46bd-a3f5-a3ccc4ac0f33	F	0	hispanic	0	puerto_rican	0
2543	8507	1964	10	18	1964-10-18 00:00:00	8527	0	\N	\N	\N	787a5c19-4050-4718-ae6e-607273a91ae7	M	0	white	0	english	0
2739	8532	1953	3	18	1953-03-18 00:00:00	8527	0	\N	\N	\N	8261f03f-3636-4641-959a-47c390764788	F	0	white	0	english	0
2436	8507	1912	3	16	1912-03-16 00:00:00	8516	0	\N	\N	\N	72c3c64c-2388-4f8b-9baa-bc54a924c94f	M	0	black	0	dominican	0
3222	8507	1951	1	2	1951-01-02 00:00:00	8527	0	\N	\N	\N	9936b411-030a-4e7a-b5db-5937ba135130	M	0	white	0	english	0
3025	8532	1945	11	26	1945-11-26 00:00:00	8527	0	\N	\N	\N	8eff4935-0ecf-40f7-8415-127c1cab72bc	F	0	white	0	irish	0
2344	8532	1966	3	14	1966-03-14 00:00:00	8527	0	\N	\N	\N	6dfdfe86-e6b4-4c88-ace0-e86f0650d944	F	0	white	0	polish	0
2693	8532	1958	10	14	1958-10-14 00:00:00	8527	0	\N	\N	\N	7f8eb552-9b1d-4593-b1ce-20b9bf28c3c4	F	0	white	0	irish	0
2462	8507	1961	10	8	1961-10-08 00:00:00	8516	0	\N	\N	\N	74209e3b-4247-421e-a7d8-79e66165a00f	M	0	black	0	dominican	0
3040	8507	1972	2	24	1972-02-24 00:00:00	8527	0	\N	\N	\N	8fa02f27-d12d-4032-9ba1-644697002c87	M	0	white	0	italian	0
2761	8507	1980	5	19	1980-05-19 00:00:00	8527	0	\N	\N	\N	832a3c79-5319-4fa0-b327-cc390f312a2d	M	0	white	0	english	0
2955	8507	1969	7	29	1969-07-29 00:00:00	8527	0	\N	\N	\N	8c1c64c3-8eb1-4346-ad99-93e972b4ec49	M	0	white	0	swedish	0
2589	8532	1983	3	22	1983-03-22 00:00:00	8527	0	\N	\N	\N	7b300458-5f75-4a2a-a3a7-d83757e86cca	F	0	white	0	swedish	0
2480	8507	1955	11	2	1955-11-02 00:00:00	0	38003563	\N	\N	\N	75210b86-9791-449e-9236-51e1369d32e5	M	0	hispanic	0	puerto_rican	0
3077	8507	1952	5	28	1952-05-28 00:00:00	8527	0	\N	\N	\N	917274b4-fdff-4916-a9a0-fc5b03e89439	M	0	white	0	french	0
2369	8507	1981	5	3	1981-05-03 00:00:00	8527	0	\N	\N	\N	6f1f3a80-0ee2-4e03-b5b9-850b0616922e	M	0	white	0	french	0
2556	8507	1967	12	25	1967-12-25 00:00:00	8527	0	\N	\N	\N	79d3a35f-5682-48dd-b430-613346c52dfe	M	0	white	0	italian	0
2084	8532	1962	10	10	1962-10-10 00:00:00	8527	0	\N	\N	\N	6118109c-4699-4016-8369-ced0b63d204e	F	0	white	0	french	0
2781	8532	1980	3	28	1980-03-28 00:00:00	8527	0	\N	\N	\N	83f4bf5f-6116-404a-8afd-1616fa635447	F	0	white	0	french	0
2460	8532	1984	8	8	1984-08-08 00:00:00	8527	0	\N	\N	\N	740b7c19-a232-4591-9a54-028d869d4af2	F	0	white	0	french	0
2758	8507	1940	3	1	1940-03-01 00:00:00	8527	0	\N	\N	\N	83104586-155b-4e57-8a24-0cc0dd487f32	M	0	white	0	polish	0
2545	8532	1945	7	26	1945-07-26 00:00:00	0	38003563	\N	\N	\N	78a0cb97-1a8a-45b2-8695-f41f6a8262a7	F	0	hispanic	0	central_american	0
1908	8507	1970	6	7	1970-06-07 00:00:00	8527	0	\N	\N	\N	590c3a4d-2d92-4c98-b98d-007828440c01	M	0	white	0	french_canadian	0
3129	8532	1971	5	18	1971-05-18 00:00:00	8527	0	\N	\N	\N	947fdcb9-1529-42f8-9f3d-544e1148f90e	F	0	white	0	greek	0
3176	8532	1971	12	4	1971-12-04 00:00:00	8527	0	\N	\N	\N	96d6e320-8eda-4fa5-a246-b0a9d228cb33	F	0	white	0	french	0
2863	8507	1961	9	14	1961-09-14 00:00:00	8527	0	\N	\N	\N	87d75dfa-9a99-41a7-a2ce-4b1e20782c2c	M	0	white	0	french	0
2380	8532	1950	5	27	1950-05-27 00:00:00	8527	0	\N	\N	\N	6fcb2330-0767-46b8-bb38-e8f531d0cf0f	F	0	white	0	italian	0
2711	8507	1950	6	26	1950-06-26 00:00:00	8527	0	\N	\N	\N	80d4f104-1ef3-4511-96a6-4b2e3723324f	M	0	white	0	german	0
2542	8532	1963	5	31	1963-05-31 00:00:00	8516	0	\N	\N	\N	78753559-eefe-47fb-bd86-37c30f705c6f	F	0	black	0	west_indian	0
2777	8532	1960	3	31	1960-03-31 00:00:00	8516	0	\N	\N	\N	83c4d5e3-70b1-42d1-bb49-3e636a74ba75	F	0	black	0	dominican	0
2409	8532	1978	10	1	1978-10-01 00:00:00	8516	0	\N	\N	\N	71912297-7de2-47b5-bcd4-07c0ccca6db6	F	0	black	0	african	0
2654	8507	1943	11	4	1943-11-04 00:00:00	8515	0	\N	\N	\N	7de7142d-4613-4aa9-8145-9813a38219c5	M	0	asian	0	asian_indian	0
2373	8507	1956	1	19	1956-01-19 00:00:00	0	38003563	\N	\N	\N	6f802584-0b16-45de-8e0a-a83688c84e55	M	0	hispanic	0	puerto_rican	0
2893	8507	1943	6	2	1943-06-02 00:00:00	0	38003563	\N	\N	\N	8973304c-3994-47da-b8d8-7130a00f570e	M	0	hispanic	0	puerto_rican	0
2578	8532	1970	8	27	1970-08-27 00:00:00	0	38003563	\N	\N	\N	7ac09e47-d6f2-4abc-8116-6c797fa511e1	F	0	hispanic	0	puerto_rican	0
2896	8507	1969	3	23	1969-03-23 00:00:00	8516	0	\N	\N	\N	89a161a3-692a-493a-bc6e-a80b9d6ee2ce	M	0	black	0	west_indian	0
2530	8507	1964	4	26	1964-04-26 00:00:00	0	38003563	\N	\N	\N	77d302bd-944a-4bc5-8564-fe60bcef12a4	M	0	hispanic	0	puerto_rican	0
3238	8507	1967	2	27	1967-02-27 00:00:00	0	38003563	\N	\N	\N	9a17e53f-3626-48ed-a113-22738e4c6c7f	M	0	hispanic	0	puerto_rican	0
2559	8507	1958	2	15	1958-02-15 00:00:00	8527	0	\N	\N	\N	79e539a4-f08f-4f12-a1b7-ceb9a96b3037	M	0	white	0	italian	0
2843	8532	1958	8	7	1958-08-07 00:00:00	8516	0	\N	\N	\N	86625473-011d-447f-9f01-c0effce3463c	F	0	black	0	west_indian	0
2890	8532	1961	12	8	1961-12-08 00:00:00	8516	0	\N	\N	\N	895713d5-d7b1-4500-bdf7-fa9695bd38b1	F	0	black	0	west_indian	0
2989	8532	1954	6	23	1954-06-23 00:00:00	8516	0	\N	\N	\N	8d6bf786-2694-402e-a589-72f10dfe8a02	F	0	black	0	west_indian	0
3201	8532	1936	8	19	1936-08-19 00:00:00	8527	0	\N	\N	\N	9861ff56-f71a-4b52-8279-aaad239a61eb	F	0	white	0	italian	0
2659	8507	1974	6	26	1974-06-26 00:00:00	8527	0	\N	\N	\N	7e2fd5c8-a71d-4473-833d-55c3ecb393a6	M	0	white	0	polish	0
2550	8532	1983	1	16	1983-01-16 00:00:00	8515	0	\N	\N	\N	792ccde1-d952-4421-abf9-1640e3883cf1	F	0	asian	0	chinese	0
3469	8532	1952	10	1	1952-10-01 00:00:00	8516	0	\N	\N	\N	a4ea30cd-c9bb-4059-b1a7-4e5dd054dd62	F	0	black	0	west_indian	0
3236	8507	1923	11	2	1923-11-02 00:00:00	8527	0	\N	\N	\N	9a04be79-518f-42ee-8466-3376f620f2e0	M	0	white	0	english	0
2965	8532	1970	2	23	1970-02-23 00:00:00	8527	0	\N	\N	\N	8c5a05aa-d646-46de-9f05-2f3024ebc670	F	0	white	0	polish	0
2190	8532	1950	5	8	1950-05-08 00:00:00	8527	0	\N	\N	\N	66a61b15-4b10-40f1-ad69-04c35bb5b560	F	0	white	0	portuguese	0
2291	8532	1960	10	13	1960-10-13 00:00:00	0	38003563	\N	\N	\N	6b6712fa-3b9d-45d3-907a-ef1fb06af0d4	F	0	hispanic	0	central_american	0
2522	8532	1958	7	11	1958-07-11 00:00:00	8527	0	\N	\N	\N	77820d92-9263-4705-9774-85b5d7763bd6	F	0	white	0	irish	0
3026	8507	1955	1	23	1955-01-23 00:00:00	8527	0	\N	\N	\N	8f048459-64e9-44ab-9a1e-cc7bd6622dd1	M	0	white	0	portuguese	0
2663	8507	1963	9	1	1963-09-01 00:00:00	8527	0	\N	\N	\N	7e681f93-f115-4194-b434-930f99a30073	M	0	white	0	polish	0
2586	8507	1968	6	30	1968-06-30 00:00:00	0	38003563	\N	\N	\N	7afec849-26c5-4fc7-83ca-ea08562949f1	M	0	hispanic	0	puerto_rican	0
2682	8507	1973	6	15	1973-06-15 00:00:00	8527	0	\N	\N	\N	7f1da4fb-700d-4fee-b2e7-629991f21aaf	M	0	white	0	english	0
3028	8507	1959	4	23	1959-04-23 00:00:00	8516	0	\N	\N	\N	8f119d3a-0f50-4fe0-b70a-5762c509bf9d	M	0	black	0	west_indian	0
2949	8507	1950	7	25	1950-07-25 00:00:00	8527	0	\N	\N	\N	8bc92a32-c46a-432d-ae03-1deeda3d0d14	M	0	white	0	english	0
2555	8532	1950	3	8	1950-03-08 00:00:00	8527	0	\N	\N	\N	79b02871-ada0-4f5e-8425-4015848a7f37	F	0	white	0	irish	0
3335	8507	1972	3	26	1972-03-26 00:00:00	8527	0	\N	\N	\N	9e9c4f54-9e0c-4533-b7e0-df42e0947c94	M	0	white	0	german	0
2314	8507	1951	7	7	1951-07-07 00:00:00	8527	0	\N	\N	\N	6c4d8e14-67e8-489b-9b40-f93450e410b0	M	0	white	0	french	0
2892	8507	1972	9	29	1972-09-29 00:00:00	0	38003563	\N	\N	\N	8972a91a-53c3-4f74-a36a-3cda9342ed90	M	0	hispanic	0	south_american	0
2574	8507	1961	1	3	1961-01-03 00:00:00	0	38003563	\N	\N	\N	7aa710fd-646e-4dbd-95de-446923b80860	M	0	hispanic	0	puerto_rican	0
2804	8507	1951	10	10	1951-10-10 00:00:00	8527	0	\N	\N	\N	84f3264e-da19-45a0-aecc-d8f809b8f96b	M	0	white	0	english	0
2906	8532	1924	4	12	1924-04-12 00:00:00	8527	0	\N	\N	\N	8a1271e5-dc17-4190-bf59-058da8694cce	F	0	white	0	irish	0
2776	8507	1975	7	13	1975-07-13 00:00:00	8527	0	\N	\N	\N	83c406f7-860c-4242-b343-87b125847258	M	0	white	0	irish	0
2633	8507	1947	10	16	1947-10-16 00:00:00	0	38003563	\N	\N	\N	7cfe7726-c583-430c-9d08-c8a84784476b	M	0	hispanic	0	puerto_rican	0
2757	8507	1973	2	2	1973-02-02 00:00:00	8527	0	\N	\N	\N	83060387-bcd8-4ebd-9561-4bf6abc020d2	M	0	white	0	french	0
2546	8532	1975	3	28	1975-03-28 00:00:00	8527	0	\N	\N	\N	78b235e6-b455-4570-af7b-b1ec309e6a93	F	0	white	0	english	0
3296	8507	1936	9	25	1936-09-25 00:00:00	0	0	\N	\N	\N	9ccfd76b-8a86-457f-8a00-c70d2a3b61a1	M	0	native	0	american_indian	0
3079	8507	1933	4	20	1933-04-20 00:00:00	8516	0	\N	\N	\N	91b6f987-5133-48fa-a3a6-f704d90606a5	M	0	black	0	west_indian	0
2482	8532	1974	9	12	1974-09-12 00:00:00	0	38003563	\N	\N	\N	753a078a-cd57-4bec-8e7d-69f6469059c3	F	0	hispanic	0	central_american	0
2902	8507	1946	7	5	1946-07-05 00:00:00	8527	0	\N	\N	\N	89f2ff53-1999-4102-98da-a642bec721a4	M	0	white	0	polish	0
2616	8507	1951	11	27	1951-11-27 00:00:00	8515	0	\N	\N	\N	7c55ccb5-b67e-43f2-80b0-470a5c3f0610	M	0	asian	0	chinese	0
3244	8532	1973	4	18	1973-04-18 00:00:00	8527	0	\N	\N	\N	9a54335c-8e0f-43f4-b6a3-423d0a5675bc	F	0	white	0	irish	0
2842	8507	1958	9	25	1958-09-25 00:00:00	8527	0	\N	\N	\N	865710d6-7e2c-4e39-a8dc-6364315b8f95	M	0	white	0	russian	0
3069	8532	1961	8	16	1961-08-16 00:00:00	8527	0	\N	\N	\N	9113bcc7-9d34-46b2-8585-b72339ec2616	F	0	white	0	irish	0
2801	8532	1922	2	17	1922-02-17 00:00:00	8527	0	\N	\N	\N	84dab351-aaa6-4613-bd96-5d7047bf77d7	F	0	white	0	italian	0
2857	8507	1964	3	11	1964-03-11 00:00:00	0	38003563	\N	\N	\N	87541305-664c-4747-9eea-95299dfdcd31	M	0	hispanic	0	mexican	0
3231	8507	1947	10	16	1947-10-16 00:00:00	8527	0	\N	\N	\N	99af30f2-04ee-4403-b071-68444a11c1c9	M	0	white	0	french_canadian	0
2477	8532	1955	2	27	1955-02-27 00:00:00	8516	0	\N	\N	\N	74e0baf8-fcba-4b24-bbf0-0d5f1a477fd9	F	0	black	0	dominican	0
2604	8507	1956	3	10	1956-03-10 00:00:00	0	38003563	\N	\N	\N	7be47dd5-8f68-4207-8698-305aa2cb666e	M	0	hispanic	0	puerto_rican	0
2130	8507	1957	6	6	1957-06-06 00:00:00	8527	0	\N	\N	\N	640f90e1-c736-4cf0-b5e7-0a1e047db1b9	M	0	white	0	english	0
2830	8532	1974	8	12	1974-08-12 00:00:00	8527	0	\N	\N	\N	85f9cdb5-da33-4a57-833d-e63842e79a05	F	0	white	0	english	0
2636	8507	1960	4	15	1960-04-15 00:00:00	8527	0	\N	\N	\N	7d259ca3-a72d-4e32-a1fc-f9f7ce77edc2	M	0	white	0	greek	0
2837	8507	1966	8	3	1966-08-03 00:00:00	8527	0	\N	\N	\N	863e9ca4-0760-4240-a4eb-1cd8eab9ef4b	M	0	white	0	polish	0
2647	8532	1970	12	13	1970-12-13 00:00:00	0	38003563	\N	\N	\N	7da0c1f3-dc2e-403f-8272-c8b0bae0a8f7	F	0	hispanic	0	puerto_rican	0
2030	8532	1962	4	22	1962-04-22 00:00:00	8527	0	\N	\N	\N	5ebad9c8-fbed-4997-90f0-71a9ca6a3756	F	0	white	0	irish	0
3285	8507	1958	11	15	1958-11-15 00:00:00	8527	0	\N	\N	\N	9c77330a-e6e9-4662-ad29-12b235ff90d1	M	0	white	0	irish	0
3314	8532	1962	9	8	1962-09-08 00:00:00	0	38003563	\N	\N	\N	9d87da81-147e-4407-a49c-ca312bc0f8c7	F	0	hispanic	0	puerto_rican	0
2905	8532	1966	11	28	1966-11-28 00:00:00	8527	0	\N	\N	\N	8a0fc3ad-8512-41db-861b-55babf0c7c63	F	0	white	0	irish	0
2518	8532	1953	8	21	1953-08-21 00:00:00	8515	0	\N	\N	\N	77292672-6ca2-46cc-ad63-e151aebc886f	F	0	asian	0	chinese	0
2866	8532	1966	8	7	1966-08-07 00:00:00	8527	0	\N	\N	\N	88113030-3129-4a36-869f-629ec7492798	F	0	white	0	italian	0
2622	8532	1930	11	8	1930-11-08 00:00:00	8527	0	\N	\N	\N	7c7e13bb-5dff-4ee5-8588-610c95da32d8	F	0	white	0	italian	0
2960	8532	1955	2	3	1955-02-03 00:00:00	8527	0	\N	\N	\N	8c4199bf-4d54-43d4-b79d-c300cdceeb83	F	0	white	0	polish	0
2437	8507	1961	8	7	1961-08-07 00:00:00	8527	0	\N	\N	\N	72caed80-86fc-414e-ab60-3433251d1ce9	M	0	white	0	english	0
2839	8532	1972	2	21	1972-02-21 00:00:00	8515	0	\N	\N	\N	86490e1a-2911-49f6-a7fd-acb8b82bdca0	F	0	asian	0	chinese	0
2709	8507	1939	1	10	1939-01-10 00:00:00	8527	0	\N	\N	\N	8083e6f0-4432-4023-881e-563bae817f44	M	0	white	0	american	0
3191	8507	1957	9	26	1957-09-26 00:00:00	0	38003563	\N	\N	\N	97b28957-7261-42b3-99d2-e24e7d15d4e7	M	0	hispanic	0	south_american	0
2861	8532	1963	7	8	1963-07-08 00:00:00	0	38003563	\N	\N	\N	879ec641-e766-4788-b50b-b45c3afbf841	F	0	hispanic	0	puerto_rican	0
3004	8507	1950	10	3	1950-10-03 00:00:00	8527	0	\N	\N	\N	8e0ca641-a8a3-4b57-ba2b-2ac94dc21714	M	0	white	0	german	0
2610	8532	1957	7	6	1957-07-06 00:00:00	8515	0	\N	\N	\N	7c0b5272-6d2f-4e8f-a80b-8fece80fbd9f	F	0	asian	0	chinese	0
3280	8507	1951	9	13	1951-09-13 00:00:00	8527	0	\N	\N	\N	9c3d1e88-6f48-4ac9-a00b-301f3cb54e3b	M	0	white	0	irish	0
2649	8507	1957	6	3	1957-06-03 00:00:00	8515	0	\N	\N	\N	7db37ad8-2446-484f-bc4e-911499deaa3e	M	0	asian	0	asian_indian	0
2925	8532	1960	1	10	1960-01-10 00:00:00	8527	0	\N	\N	\N	8ac437bb-434a-41dc-8692-b7bb1df89966	F	0	white	0	french_canadian	0
3184	8507	1961	3	2	1961-03-02 00:00:00	8527	0	\N	\N	\N	976ada72-c1e8-4346-bef9-6fe2712d21ff	M	0	white	0	german	0
3035	8507	1963	12	20	1963-12-20 00:00:00	8527	0	\N	\N	\N	8f6ed5af-600d-423f-8fc0-d68e33cd4482	M	0	white	0	swedish	0
3364	8532	1976	6	24	1976-06-24 00:00:00	0	38003563	\N	\N	\N	9fd0c58c-561b-4d05-8ece-53f1ebdf02ae	F	0	hispanic	0	central_american	0
2703	8507	1974	3	3	1974-03-03 00:00:00	8527	0	\N	\N	\N	802bd443-1349-4fc3-89b8-223adce8c869	M	0	white	0	french	0
2598	8507	1974	1	8	1974-01-08 00:00:00	8515	0	\N	\N	\N	7bb58899-6d12-4ceb-90a2-9576c9bcf234	M	0	asian	0	chinese	0
3579	8532	1964	10	31	1964-10-31 00:00:00	8516	0	\N	\N	\N	aa40e53a-1666-4ad5-aa87-2b2edfef8256	F	0	black	0	dominican	0
3483	8507	1953	1	24	1953-01-24 00:00:00	8527	0	\N	\N	\N	a5a3b75b-8320-4b10-a320-e93875c7bf89	M	0	white	0	irish	0
3125	8507	1951	6	28	1951-06-28 00:00:00	8527	0	\N	\N	\N	943d73a3-a320-450c-a08d-593f11761059	M	0	white	0	russian	0
2347	8532	1968	12	2	1968-12-02 00:00:00	8527	0	\N	\N	\N	6e352ab3-9373-49bc-a65a-0240e227635e	F	0	white	0	irish	0
2588	8532	1964	8	30	1964-08-30 00:00:00	8527	0	\N	\N	\N	7b1195bb-ae59-4468-9c1f-0bd87fb4ea84	F	0	white	0	irish	0
2570	8507	1935	8	22	1935-08-22 00:00:00	8527	0	\N	\N	\N	7a6516e0-c5af-4881-ba8c-c981dcf94235	M	0	white	0	american	0
3076	8507	1949	6	1	1949-06-01 00:00:00	0	38003563	\N	\N	\N	91689688-23ec-4947-a192-642740188be2	M	0	hispanic	0	mexican	0
2699	8532	1970	11	17	1970-11-17 00:00:00	8527	0	\N	\N	\N	8007daf8-2586-49ff-b339-8bca89a1329e	F	0	white	0	greek	0
2688	8507	1962	11	18	1962-11-18 00:00:00	8527	0	\N	\N	\N	7f6c741e-2977-4df3-a92c-e6b2d9163b04	M	0	white	0	italian	0
2867	8532	1978	8	15	1978-08-15 00:00:00	8527	0	\N	\N	\N	882ece72-5124-4e6d-ac77-3f6bc7e1aceb	F	0	white	0	irish	0
3074	8532	1950	12	6	1950-12-06 00:00:00	8516	0	\N	\N	\N	916293f8-beea-45a8-842e-85920590c24b	F	0	black	0	west_indian	0
3059	8507	1970	4	19	1970-04-19 00:00:00	8527	0	\N	\N	\N	9096d4a2-73cc-43d2-91ff-1990f595d62a	M	0	white	0	russian	0
2603	8532	1960	5	25	1960-05-25 00:00:00	0	38003563	\N	\N	\N	7be19ecf-e343-45c2-b11c-05d2f3a7a1fd	F	0	hispanic	0	central_american	0
3661	8532	1978	2	12	1978-02-12 00:00:00	8527	0	\N	\N	\N	ae2013a9-d864-4694-975a-a15807bf5220	F	0	white	0	english	0
2428	8532	1974	6	25	1974-06-25 00:00:00	8527	0	\N	\N	\N	72735683-33c5-466a-b9c3-5f472f3565f8	F	0	white	0	irish	0
2976	8507	1955	6	23	1955-06-23 00:00:00	8515	0	\N	\N	\N	8cd1f97e-2fc7-4487-8bdb-897421796fa8	M	0	asian	0	chinese	0
2680	8532	1972	3	9	1972-03-09 00:00:00	8527	0	\N	\N	\N	7f12dee5-0120-4073-8320-8c2bf136b1f4	F	0	white	0	italian	0
2897	8507	1960	6	4	1960-06-04 00:00:00	8516	0	\N	\N	\N	89a4d4c6-c557-4cd1-9cdc-41d3b42bd6c2	M	0	black	0	african	0
3168	8507	1980	1	19	1980-01-19 00:00:00	8527	0	\N	\N	\N	9654e4b3-a597-4afe-934a-6e11488c9340	M	0	white	0	irish	0
2827	8532	1920	6	1	1920-06-01 00:00:00	8527	0	\N	\N	\N	85e5bd99-e67e-4b42-8447-7d7f1ccdc8fd	F	0	white	0	irish	0
2771	8532	1909	9	17	1909-09-17 00:00:00	8527	0	\N	\N	\N	8385b78a-0665-4a1f-ad6f-1a7501360845	F	0	white	0	french_canadian	0
3254	8532	1963	12	1	1963-12-01 00:00:00	8527	0	\N	\N	\N	9ab75e9b-d745-4ae4-9a14-66ced4b7273a	F	0	white	0	irish	0
2594	8507	1975	2	26	1975-02-26 00:00:00	8527	0	\N	\N	\N	7b5b8128-bb0e-4d87-bc89-23df0f180bb6	M	0	white	0	portuguese	0
3397	8532	1944	6	17	1944-06-17 00:00:00	8527	0	\N	\N	\N	a17244fa-03c1-4d82-9da2-903c7c76d063	F	0	white	0	irish	0
3229	8507	1979	6	8	1979-06-08 00:00:00	0	38003563	\N	\N	\N	998049ec-804a-4b7b-ab8d-1224a375b296	M	0	hispanic	0	south_american	0
2580	8532	1958	6	9	1958-06-09 00:00:00	8527	0	\N	\N	\N	7adfcfce-b406-4e23-95c7-ddf4b01f153b	F	0	white	0	portuguese	0
3002	8507	1973	7	3	1973-07-03 00:00:00	8527	0	\N	\N	\N	8dff7d6d-1fc5-4abb-b6b2-a68c6f7f8cae	M	0	white	0	italian	0
2929	8507	1974	8	17	1974-08-17 00:00:00	0	38003563	\N	\N	\N	8acf17c2-0161-45d8-ae0b-c7149d02677f	M	0	hispanic	0	puerto_rican	0
3290	8507	1969	4	2	1969-04-02 00:00:00	8527	0	\N	\N	\N	9c97d71c-b8b8-4209-b7df-f9abc907ab20	M	0	white	0	french	0
2944	8532	1960	1	31	1960-01-31 00:00:00	8516	0	\N	\N	\N	8ba787ba-384b-4ff5-a682-9e762d6d0d96	F	0	black	0	west_indian	0
3115	8532	1967	1	20	1967-01-20 00:00:00	8527	0	\N	\N	\N	93b6ac34-c836-4eae-830d-53a1dd396054	F	0	white	0	german	0
3000	8532	1948	4	16	1948-04-16 00:00:00	8527	0	\N	\N	\N	8df28571-2b3e-4a73-b4c1-76d03552a950	F	0	white	0	english	0
3013	8532	1950	8	29	1950-08-29 00:00:00	8527	0	\N	\N	\N	8e943c7d-da60-43c0-bd5d-48fe70362750	F	0	white	0	irish	0
3386	8532	1968	12	1	1968-12-01 00:00:00	8527	0	\N	\N	\N	a0d53ffe-30d8-48e8-8129-727e18522cca	F	0	white	0	italian	0
2685	8507	1942	11	26	1942-11-26 00:00:00	8527	0	\N	\N	\N	7f4a7978-0f6f-45c3-a029-60c50addacf2	M	0	white	0	portuguese	0
2752	8532	1951	3	18	1951-03-18 00:00:00	8527	0	\N	\N	\N	82c460a7-fd0f-483c-9249-77ae948da725	F	0	white	0	scottish	0
2238	8507	1968	8	4	1968-08-04 00:00:00	0	38003563	\N	\N	\N	68c060d4-d448-4b78-8168-52eabfc73cc4	M	0	hispanic	0	central_american	0
2936	8507	1962	6	2	1962-06-02 00:00:00	8527	0	\N	\N	\N	8b28f022-a424-46fe-a18d-7472ed17078e	M	0	white	0	french	0
2774	8507	1940	3	22	1940-03-22 00:00:00	8527	0	\N	\N	\N	83a79f1a-b888-40d6-952b-8a25d6a889bb	M	0	white	0	irish	0
2915	8532	1944	5	7	1944-05-07 00:00:00	8527	0	\N	\N	\N	8a78315d-5e51-42d5-8ea1-8477ed96ee72	F	0	white	0	russian	0
2747	8507	1972	6	11	1972-06-11 00:00:00	8527	0	\N	\N	\N	829d6284-4f10-4c71-8d64-30d2c0f854a5	M	0	white	0	scottish	0
2100	8507	1943	9	6	1943-09-06 00:00:00	8516	0	\N	\N	\N	61d6aa81-dfb2-4897-b00a-52cde3460a9c	M	0	black	0	african	0
3334	8507	1945	10	25	1945-10-25 00:00:00	8527	0	\N	\N	\N	9e7e93fd-3aa8-4a64-8959-4451ec43b52b	M	0	white	0	english	0
3415	8507	1965	8	7	1965-08-07 00:00:00	8527	0	\N	\N	\N	a248241a-5ff0-4628-861a-e210955ee7bb	M	0	white	0	italian	0
2997	8532	1981	10	4	1981-10-04 00:00:00	8527	0	\N	\N	\N	8dadd7fd-0d19-4190-8415-8740c0aee456	F	0	white	0	english	0
2566	8532	1939	10	24	1939-10-24 00:00:00	8515	0	\N	\N	\N	7a2984a9-1b47-4f78-9545-a49345d22463	F	0	asian	0	chinese	0
3080	8532	1940	12	12	1940-12-12 00:00:00	8516	0	\N	\N	\N	91e54cf9-5206-4997-bb1e-72df227715ec	F	0	black	0	west_indian	0
2724	8532	1954	5	23	1954-05-23 00:00:00	8515	0	\N	\N	\N	81770ffc-e988-49d0-b85d-292d7d1baac9	F	0	asian	0	chinese	0
3242	8507	1980	5	17	1980-05-17 00:00:00	0	38003563	\N	\N	\N	9a28fc78-8e31-4a18-9a93-1b2f8d79ca9c	M	0	hispanic	0	puerto_rican	0
2745	8507	1971	3	21	1971-03-21 00:00:00	8527	0	\N	\N	\N	8281b4b6-35ca-4c36-9024-30010222570e	M	0	white	0	english	0
2913	8507	1946	2	23	1946-02-23 00:00:00	8527	0	\N	\N	\N	8a5ce29a-f0a3-4a87-be8d-bf42c2e3b89c	M	0	white	0	irish	0
2864	8532	1939	4	27	1939-04-27 00:00:00	0	38003563	\N	\N	\N	87fbb2b5-d3ff-4f09-a522-4e7d38aac017	F	0	hispanic	0	puerto_rican	0
3227	8507	1969	9	23	1969-09-23 00:00:00	8527	0	\N	\N	\N	99723be8-b0d2-47ff-ad8d-a73e31cdaff1	M	0	white	0	french	0
3422	8507	1966	12	19	1966-12-19 00:00:00	8516	0	\N	\N	\N	a27c1517-ff61-484c-b009-76c3524623af	M	0	black	0	west_indian	0
3100	8507	1950	12	7	1950-12-07 00:00:00	8516	0	\N	\N	\N	92ade12b-10b7-463f-8e09-f7539486b5c0	M	0	black	0	african	0
2782	8532	1919	11	19	1919-11-19 00:00:00	8527	0	\N	\N	\N	8405c701-52a0-4c97-a28e-d093f9798619	F	0	white	0	irish	0
3481	8507	1977	4	30	1977-04-30 00:00:00	8527	0	\N	\N	\N	a581da92-9622-4831-b471-1bc84ac391d9	M	0	white	0	english	0
2832	8532	1965	2	14	1965-02-14 00:00:00	8527	0	\N	\N	\N	8601649c-9cbc-4317-9bb9-c6a914252600	F	0	white	0	german	0
2945	8507	1945	7	17	1945-07-17 00:00:00	8527	0	\N	\N	\N	8bab3c3c-cf74-46ad-bcc2-6e4fdc5ee997	M	0	white	0	italian	0
3407	8532	1963	1	25	1963-01-25 00:00:00	8527	0	\N	\N	\N	a1ea7d12-a9ed-487c-bdf0-d35450e94ec7	F	0	white	0	irish	0
3195	8507	1948	11	22	1948-11-22 00:00:00	8527	0	\N	\N	\N	97f20309-3337-4616-b5c9-5d8870cfee65	M	0	white	0	italian	0
3410	8532	1964	4	15	1964-04-15 00:00:00	8527	0	\N	\N	\N	a211270f-7383-46ba-9050-31a1acb3ff72	F	0	white	0	irish	0
2858	8532	1910	3	22	1910-03-22 00:00:00	8527	0	\N	\N	\N	8767ab7e-4839-4872-a76b-72bc76391480	F	0	white	0	german	0
2841	8507	1949	6	26	1949-06-26 00:00:00	8527	0	\N	\N	\N	865465c1-c5b0-45c2-b107-3a03aa79f37b	M	0	white	0	irish	0
3761	8532	1956	4	21	1956-04-21 00:00:00	8527	0	\N	\N	\N	b2cfe5b7-d6cd-4ced-b4d2-798bfd4cd526	F	0	white	0	german	0
3565	8532	1944	3	4	1944-03-04 00:00:00	8516	0	\N	\N	\N	a9810a9f-29cf-469d-b499-f07213d68d1e	F	0	black	0	dominican	0
3289	8532	1955	12	23	1955-12-23 00:00:00	8527	0	\N	\N	\N	9c92554b-e702-48db-9601-482c55d711b3	F	0	white	0	irish	0
2481	8507	1969	7	20	1969-07-20 00:00:00	8515	0	\N	\N	\N	7528941c-fa3d-4ebb-8695-056f03ddc70c	M	0	asian	0	chinese	0
2666	8532	1950	12	17	1950-12-17 00:00:00	8516	0	\N	\N	\N	7ea69162-845b-47c3-a8a7-9c6434e60e15	F	0	black	0	dominican	0
2684	8532	1961	2	12	1961-02-12 00:00:00	8527	0	\N	\N	\N	7f2e9822-bbe4-4dfc-ab31-39885b79e03f	F	0	white	0	portuguese	0
3230	8507	1955	8	24	1955-08-24 00:00:00	8527	0	\N	\N	\N	9985b915-6d96-4822-8d0c-ce1a5b011abc	M	0	white	0	french	0
2813	8507	1934	7	27	1934-07-27 00:00:00	8527	0	\N	\N	\N	85324789-2634-4cdd-9149-433f560d3f34	M	0	white	0	irish	0
2806	8532	1953	4	16	1953-04-16 00:00:00	8515	0	\N	\N	\N	84fb3078-084a-4754-882a-dbf24bdf06c6	F	0	asian	0	chinese	0
2985	8532	1963	10	19	1963-10-19 00:00:00	8527	0	\N	\N	\N	8d36a687-7b63-4956-bcf8-005b2635b6e3	F	0	white	0	french	0
3224	8532	1960	1	15	1960-01-15 00:00:00	8527	0	\N	\N	\N	9947cb91-859f-4dd5-8ade-68bc47768d25	F	0	white	0	irish	0
3109	8507	1918	6	12	1918-06-12 00:00:00	0	0	\N	\N	\N	934e302a-8aa1-47a7-af94-6bf93473698c	M	0	native	0	american_indian	0
2836	8532	1980	9	1	1980-09-01 00:00:00	8527	0	\N	\N	\N	8637407c-dd0d-41f4-a5ac-c07b094be791	F	0	white	0	scottish	0
3745	8507	1930	3	12	1930-03-12 00:00:00	8527	0	\N	\N	\N	b2456960-f203-41a3-a297-787e2d7e88f0	M	0	white	0	italian	0
2448	8532	1964	7	15	1964-07-15 00:00:00	0	0	\N	\N	\N	73445c01-c927-4577-b622-0f77d671f46c	F	0	native	0	american_indian	0
3030	8532	1981	8	18	1981-08-18 00:00:00	0	38003563	\N	\N	\N	8f36271f-dcc1-4349-8223-b0e72f17386c	F	0	hispanic	0	puerto_rican	0
2708	8507	1954	6	7	1954-06-07 00:00:00	8527	0	\N	\N	\N	8076ac4c-9c1e-438a-83b1-29150aac649b	M	0	white	0	irish	0
3019	8507	1977	5	4	1977-05-04 00:00:00	8527	0	\N	\N	\N	8ed3d1c7-bcf5-4fdb-b59b-f40bee0b5ee8	M	0	white	0	italian	0
3212	8532	1981	7	28	1981-07-28 00:00:00	8527	0	\N	\N	\N	98a96887-9edf-41ca-bf8f-9b8ef3e5232a	F	0	white	0	french	0
2961	8532	1971	9	26	1971-09-26 00:00:00	0	38003563	\N	\N	\N	8c4533be-fccf-4a47-9efe-23f76fa50059	F	0	hispanic	0	puerto_rican	0
2970	8507	1965	4	16	1965-04-16 00:00:00	0	38003563	\N	\N	\N	8c8acdf7-4546-48ea-841b-b39bcaec0740	M	0	hispanic	0	mexican	0
3347	8532	1954	5	15	1954-05-15 00:00:00	8527	0	\N	\N	\N	9f080eaa-d05d-429b-9511-3ca585acd985	F	0	white	0	italian	0
2644	8507	1980	2	11	1980-02-11 00:00:00	8527	0	\N	\N	\N	7d7eb28a-39d9-4ec8-b470-45ac6ee72def	M	0	white	0	french_canadian	0
3599	8507	1966	5	6	1966-05-06 00:00:00	8527	0	\N	\N	\N	aafcc95c-d909-4e24-9dc4-5d0aaddef426	M	0	white	0	portuguese	0
3307	8532	1965	10	22	1965-10-22 00:00:00	8527	0	\N	\N	\N	9d4c4ee4-5ae3-412c-9936-01a71f8bff49	F	0	white	0	italian	0
2702	8532	1940	10	13	1940-10-13 00:00:00	8527	0	\N	\N	\N	80276311-73a3-49fb-8a24-b0c773795537	F	0	white	0	irish	0
3020	8532	1957	1	2	1957-01-02 00:00:00	8527	0	\N	\N	\N	8ee36da7-4cd8-4949-b9b9-55bb4698825d	F	0	white	0	italian	0
3133	8507	1956	2	22	1956-02-22 00:00:00	0	38003563	\N	\N	\N	94e4725f-33d1-4ef2-92a4-e8b273c2aeab	M	0	hispanic	0	south_american	0
3337	8507	1969	6	9	1969-06-09 00:00:00	8527	0	\N	\N	\N	9ec56ba9-52da-4470-9ce6-3269a0203db9	M	0	white	0	irish	0
3158	8507	1949	8	25	1949-08-25 00:00:00	8527	0	\N	\N	\N	95f44915-21b5-42a1-a14c-ea21fd0e0636	M	0	white	0	english	0
3249	8507	1957	7	14	1957-07-14 00:00:00	8516	0	\N	\N	\N	9a86a409-28d9-4083-b7b8-78a608d2fcd0	M	0	black	0	dominican	0
3022	8507	1972	5	5	1972-05-05 00:00:00	8527	0	\N	\N	\N	8ee5e167-a0d8-438d-a020-9a97e5bc2883	M	0	white	0	german	0
3418	8532	1943	10	17	1943-10-17 00:00:00	0	38003563	\N	\N	\N	a2647cac-e3a6-4c7a-8c36-49bf275edac2	F	0	hispanic	0	puerto_rican	0
3488	8507	1954	2	19	1954-02-19 00:00:00	8527	0	\N	\N	\N	a613cb71-b017-4ffd-9f48-9b0a45e9815c	M	0	white	0	irish	0
2705	8507	1942	1	31	1942-01-31 00:00:00	8527	0	\N	\N	\N	803d16ca-bf9f-40e4-aeae-61018e021a6c	M	0	white	0	german	0
2835	8532	1912	11	12	1912-11-12 00:00:00	8527	0	\N	\N	\N	862af0f6-83c2-4c82-92da-e0eead391933	F	0	white	0	irish	0
2433	8507	1953	1	11	1953-01-11 00:00:00	8527	0	\N	\N	\N	72aadcc2-9fee-406e-bfd4-f01c26017df5	M	0	white	0	american	0
3246	8507	1979	10	22	1979-10-22 00:00:00	0	38003563	\N	\N	\N	9a5b8554-d3d0-4ff3-8bff-9ca57983d35e	M	0	hispanic	0	central_american	0
2821	8532	1920	6	1	1920-06-01 00:00:00	8527	0	\N	\N	\N	85977f93-24d0-42e6-bb69-2eeb7ede5a5c	F	0	white	0	irish	0
2959	8532	1970	12	22	1970-12-22 00:00:00	0	38003563	\N	\N	\N	8c40842e-eccd-4015-8cf6-74162a14646c	F	0	hispanic	0	puerto_rican	0
2765	8532	1934	5	22	1934-05-22 00:00:00	0	38003563	\N	\N	\N	8346727b-e22d-4128-ab09-4e23f674a164	F	0	hispanic	0	central_american	0
2114	8507	1965	1	27	1965-01-27 00:00:00	8527	0	\N	\N	\N	62d6e3a8-af21-4da0-9e7d-6a3f96d2ce0b	M	0	white	0	german	0
3440	8507	1942	3	10	1942-03-10 00:00:00	8516	0	\N	\N	\N	a3a1c401-9602-433b-8481-0a56ab31fc20	M	0	black	0	african	0
3533	8532	1961	11	29	1961-11-29 00:00:00	0	38003563	\N	\N	\N	a815b6d0-ac73-4a53-b48e-d8696ef413f8	F	0	hispanic	0	mexican	0
3011	8532	1974	7	9	1974-07-09 00:00:00	8527	0	\N	\N	\N	8e830839-2bc2-42e0-b9ec-67d4455fd245	F	0	white	0	irish	0
2672	8532	1950	11	26	1950-11-26 00:00:00	8527	0	\N	\N	\N	7ec1f6ec-a6e4-4225-aacb-2033c8c2a673	F	0	white	0	german	0
3218	8507	1956	10	28	1956-10-28 00:00:00	0	38003563	\N	\N	\N	9915f657-184f-4d44-805c-724d11339260	M	0	hispanic	0	puerto_rican	0
2770	8507	1931	4	4	1931-04-04 00:00:00	0	38003563	\N	\N	\N	83835575-175d-4c1e-a95a-fd3a05749ac1	M	0	hispanic	0	central_american	0
3343	8507	1976	6	6	1976-06-06 00:00:00	8516	0	\N	\N	\N	9ee800a5-378c-4894-9f71-835c424e8e35	M	0	black	0	west_indian	0
2767	8532	1936	4	8	1936-04-08 00:00:00	8527	0	\N	\N	\N	83595bae-b715-4ab2-999d-47d2a0c2e3e0	F	0	white	0	german	0
2957	8532	1947	5	4	1947-05-04 00:00:00	8527	0	\N	\N	\N	8c2ac32a-37b6-40db-9c8a-f5902c820906	F	0	white	0	french_canadian	0
2886	8507	1950	12	11	1950-12-11 00:00:00	0	38003563	\N	\N	\N	88f4aec6-e595-4f64-b67b-a57353daaad3	M	0	hispanic	0	puerto_rican	0
3700	8507	1966	8	31	1966-08-31 00:00:00	8516	0	\N	\N	\N	b016eca3-9243-4aac-9b73-55dbbcbd745b	M	0	black	0	west_indian	0
3604	8507	1984	5	4	1984-05-04 00:00:00	0	38003563	\N	\N	\N	ab2b6471-af06-4372-b8a2-5472a4ae7cb8	M	0	hispanic	0	central_american	0
3178	8507	1954	3	27	1954-03-27 00:00:00	8527	0	\N	\N	\N	9706813a-258d-41f7-9bfe-3cfb7c3f1b40	M	0	white	0	scottish	0
2829	8507	1950	9	4	1950-09-04 00:00:00	8527	0	\N	\N	\N	85f41cdf-6138-47bb-b2bd-545ed9d4e0f1	M	0	white	0	italian	0
3567	8532	1967	6	29	1967-06-29 00:00:00	8527	0	\N	\N	\N	a9b634a8-fd78-4209-8f9a-47dcfbcb6273	F	0	white	0	italian	0
3114	8532	1946	9	18	1946-09-18 00:00:00	8527	0	\N	\N	\N	93b2da21-5e65-4ed8-b3f2-e93273480418	F	0	white	0	irish	0
3105	8507	1970	1	26	1970-01-26 00:00:00	8527	0	\N	\N	\N	93143f04-793a-4b92-888c-9afc44e5758d	M	0	white	0	portuguese	0
3541	8507	1967	8	7	1967-08-07 00:00:00	0	38003563	\N	\N	\N	a85b0c0a-c212-480b-bc8e-dc446c22a5f2	M	0	hispanic	0	puerto_rican	0
3223	8532	1916	7	19	1916-07-19 00:00:00	8515	0	\N	\N	\N	993e24cc-eba2-4ca5-a874-09958e0773f6	F	0	asian	0	chinese	0
3518	8507	1958	3	31	1958-03-31 00:00:00	0	38003563	\N	\N	\N	a7703b0e-bcba-47c2-8138-21a46c7b2a18	M	0	hispanic	0	mexican	0
2992	8507	1956	7	20	1956-07-20 00:00:00	0	38003563	\N	\N	\N	8d9497f8-0271-47a2-a8bf-762b249d94a5	M	0	hispanic	0	puerto_rican	0
2927	8507	1942	4	24	1942-04-24 00:00:00	8516	0	\N	\N	\N	8aca5d2a-dd04-4797-bfc0-81874368e996	M	0	black	0	west_indian	0
3783	8507	1940	4	5	1940-04-05 00:00:00	8515	0	\N	\N	\N	b3d0a346-0215-48bc-a141-8191a6fd9d34	M	0	asian	0	asian_indian	0
3793	8507	1939	5	2	1939-05-02 00:00:00	8527	0	\N	\N	\N	b42ef9c9-1396-49eb-a5aa-2d4e9fbdf8b1	M	0	white	0	english	0
3558	8532	1959	3	28	1959-03-28 00:00:00	8527	0	\N	\N	\N	a933c453-6195-425d-a72e-d5a07cdf723f	F	0	white	0	italian	0
2503	8532	1973	2	20	1973-02-20 00:00:00	0	38003563	\N	\N	\N	762aedad-3aff-4ebd-b800-2329d4c62467	F	0	hispanic	0	puerto_rican	0
3001	8507	1947	2	18	1947-02-18 00:00:00	8527	0	\N	\N	\N	8df9e44e-f607-4333-8b83-538b7ffb408d	M	0	white	0	irish	0
2704	8532	1971	8	14	1971-08-14 00:00:00	0	38003563	\N	\N	\N	803a7699-2945-4998-a549-916390541c02	F	0	hispanic	0	south_american	0
3304	8532	1963	1	9	1963-01-09 00:00:00	8527	0	\N	\N	\N	9d256259-eb4e-4d30-b4ba-1c3d3602b1c7	F	0	white	0	english	0
2862	8507	1967	8	26	1967-08-26 00:00:00	8516	0	\N	\N	\N	87c00a30-d893-4649-ad1b-a9aa7a886d79	M	0	black	0	west_indian	0
2853	8507	1961	8	1	1961-08-01 00:00:00	0	38003563	\N	\N	\N	871c27e9-fb04-4019-8a27-2e3c4d8b0e14	M	0	hispanic	0	puerto_rican	0
3081	8507	1946	1	23	1946-01-23 00:00:00	8527	0	\N	\N	\N	91e8e1a4-0910-41fb-a53f-1df1212fa9e4	M	0	white	0	english	0
3389	8507	1958	9	1	1958-09-01 00:00:00	0	38003563	\N	\N	\N	a0f10d08-f68b-4e32-8416-8a99d03988ef	M	0	hispanic	0	central_american	0
3263	8507	1944	10	24	1944-10-24 00:00:00	8516	0	\N	\N	\N	9b32ccf7-5cb4-4970-9b23-0f8c9df698ee	M	0	black	0	dominican	0
2914	8532	1955	10	1	1955-10-01 00:00:00	8516	0	\N	\N	\N	8a6c1f49-7af4-48ad-bb9d-a232e885f6c4	F	0	black	0	west_indian	0
3799	8507	1971	11	23	1971-11-23 00:00:00	0	38003563	\N	\N	\N	b45251b5-35ec-4c07-ae18-d7f6fcfd1009	M	0	hispanic	0	puerto_rican	0
2534	8532	1972	7	25	1972-07-25 00:00:00	8527	0	\N	\N	\N	78179485-bf3a-4064-8462-09747b23414b	F	0	white	0	irish	0
3072	8507	1959	7	18	1959-07-18 00:00:00	0	38003563	\N	\N	\N	9124727f-c5e8-482a-8075-096d7516ff94	M	0	hispanic	0	puerto_rican	0
2786	8532	1923	4	28	1923-04-28 00:00:00	0	38003563	\N	\N	\N	841fb69d-488c-4ce6-9970-6a0b5054603f	F	0	hispanic	0	central_american	0
3179	8507	1919	11	1	1919-11-01 00:00:00	8516	0	\N	\N	\N	971bb20b-eab5-41cd-9074-a6c2d73209aa	M	0	black	0	dominican	0
3423	8507	1974	3	21	1974-03-21 00:00:00	0	38003563	\N	\N	\N	a27ff39d-d222-4dd9-adb7-20dd5f9643fd	M	0	hispanic	0	central_american	0
3047	8532	1972	7	26	1972-07-26 00:00:00	8527	0	\N	\N	\N	8fed4054-420a-4b7e-9434-6a62dc1875a2	F	0	white	0	french_canadian	0
3232	8507	1963	9	16	1963-09-16 00:00:00	8515	0	\N	\N	\N	99af3aa4-6126-44ca-b1d5-3976f645fe95	M	0	asian	0	chinese	0
3583	8507	1968	11	5	1968-11-05 00:00:00	8527	0	\N	\N	\N	aa62e76e-55da-4a28-b110-fe50e6a5ef49	M	0	white	0	scottish	0
2845	8532	1952	10	2	1952-10-02 00:00:00	8527	0	\N	\N	\N	866d300c-4360-4edb-bff8-39c0485a03cf	F	0	white	0	portuguese	0
3733	8532	1975	11	11	1975-11-11 00:00:00	8527	0	\N	\N	\N	b19bcf6b-9aa4-4555-8b4f-7e3376100515	F	0	white	0	irish	0
3490	8507	1945	9	14	1945-09-14 00:00:00	8527	0	\N	\N	\N	a6200e99-bcd6-4012-a72c-53f2df195ff7	M	0	white	0	irish	0
2859	8532	1942	6	15	1942-06-15 00:00:00	8527	0	\N	\N	\N	876defa8-1c3d-4d7b-ae11-54882883371d	F	0	white	0	scottish	0
3098	8532	1958	9	22	1958-09-22 00:00:00	0	38003563	\N	\N	\N	929bd46a-d81b-488f-9e81-9f3af37182d3	F	0	hispanic	0	puerto_rican	0
3147	8507	1947	2	10	1947-02-10 00:00:00	8527	0	\N	\N	\N	9577ab8f-af7e-4215-9631-a0778631e8e3	M	0	white	0	english	0
3455	8532	1969	5	26	1969-05-26 00:00:00	8515	0	\N	\N	\N	a429c227-6ee7-4a3c-ac60-2168aacce6c9	F	0	asian	0	chinese	0
3258	8532	1981	6	3	1981-06-03 00:00:00	8527	0	\N	\N	\N	9b0b8cea-5e63-44c4-86dc-dbb7c9c8a928	F	0	white	0	french	0
3470	8532	1954	3	1	1954-03-01 00:00:00	8527	0	\N	\N	\N	a50ed1ca-0d8d-456a-95e8-1e82e2e5ee8f	F	0	white	0	polish	0
3096	8532	1963	12	22	1963-12-22 00:00:00	8527	0	\N	\N	\N	9289c675-980f-4cbc-9a11-1a3d0d00ef5a	F	0	white	0	scottish	0
3510	8507	1935	3	8	1935-03-08 00:00:00	8527	0	\N	\N	\N	a71cacd2-8ece-4dd2-b2a1-faab14d3c621	M	0	white	0	portuguese	0
3542	8532	1937	4	3	1937-04-03 00:00:00	8527	0	\N	\N	\N	a8715785-f03b-409b-94c7-33cad71160a8	F	0	white	0	german	0
2868	8532	1962	10	10	1962-10-10 00:00:00	8527	0	\N	\N	\N	882f4de0-9652-44d3-a491-7ef3707b2a2b	F	0	white	0	french	0
2917	8532	1936	9	2	1936-09-02 00:00:00	8527	0	\N	\N	\N	8a8fac15-dfee-466b-93e0-c5dd6984ab6a	F	0	white	0	german	0
2551	8532	1958	8	21	1958-08-21 00:00:00	8527	0	\N	\N	\N	79566c60-b169-48de-a931-49a91a15bbf7	F	0	white	0	irish	0
3339	8507	1959	10	13	1959-10-13 00:00:00	8527	0	\N	\N	\N	9ece72b6-cb7f-4163-8a7a-b36ccc4d0030	M	0	white	0	irish	0
2975	8507	1962	4	8	1962-04-08 00:00:00	8527	0	\N	\N	\N	8ccf4a59-d1ac-416a-ba7b-e54b1dc49d4a	M	0	white	0	polish	0
3065	8532	1972	5	11	1972-05-11 00:00:00	8527	0	\N	\N	\N	90dc279d-bd8e-4ff4-bb9b-a0e187c33549	F	0	white	0	irish	0
2846	8532	1972	6	25	1972-06-25 00:00:00	0	38003563	\N	\N	\N	86750274-29b7-4764-b42b-b5b2e7293828	F	0	hispanic	0	central_american	0
2222	8507	1962	12	25	1962-12-25 00:00:00	8515	0	\N	\N	\N	68399b16-e872-4175-9ea9-5376e29f468d	M	0	asian	0	chinese	0
3562	8507	1968	8	21	1968-08-21 00:00:00	8527	0	\N	\N	\N	a95d9795-a71f-4d00-9bea-f6c79362a0e7	M	0	white	0	english	0
3613	8507	1976	1	25	1976-01-25 00:00:00	8527	0	\N	\N	\N	aba22521-395c-4f70-ac42-4dea58f73c1d	M	0	white	0	english	0
3093	8532	1971	6	26	1971-06-26 00:00:00	8527	0	\N	\N	\N	92737ec2-1300-4e6f-b0b0-d85178dd4961	F	0	white	0	italian	0
2895	8507	1957	12	22	1957-12-22 00:00:00	8515	0	\N	\N	\N	89910209-a6ac-43b4-9c45-f58bf699e7ea	M	0	asian	0	chinese	0
3300	8532	1982	8	5	1982-08-05 00:00:00	8527	0	\N	\N	\N	9d04aace-65a6-467a-9695-3eba5ff76cf3	F	0	white	0	portuguese	0
2935	8532	1976	4	7	1976-04-07 00:00:00	8527	0	\N	\N	\N	8b01a9e9-ce8d-4ab3-9eff-4f14b093d3e3	F	0	white	0	swedish	0
3477	8507	1961	3	28	1961-03-28 00:00:00	8515	0	\N	\N	\N	a55ba9a7-79fd-43ce-9689-3aec0194f4e3	M	0	asian	0	chinese	0
2844	8532	1948	3	8	1948-03-08 00:00:00	8527	0	\N	\N	\N	866a6d4d-09e8-49db-8dba-3f5a6683c1da	F	0	white	0	portuguese	0
3067	8532	1939	12	19	1939-12-19 00:00:00	8515	0	\N	\N	\N	91097503-aaec-4a35-bd23-9dd2d7a4ccfd	F	0	asian	0	asian_indian	0
2986	8532	1944	10	10	1944-10-10 00:00:00	0	38003563	\N	\N	\N	8d482465-3241-42fd-bc42-728f15d5f2d2	F	0	hispanic	0	puerto_rican	0
3736	8507	1950	12	6	1950-12-06 00:00:00	8527	0	\N	\N	\N	b1ef35f2-9b74-4994-9035-e7836e0a70ca	M	0	white	0	italian	0
3832	8507	1984	1	12	1984-01-12 00:00:00	0	38003563	\N	\N	\N	b6140939-4fa7-439d-84c5-d3e7c0486703	M	0	hispanic	0	puerto_rican	0
3363	8507	1951	3	2	1951-03-02 00:00:00	0	38003563	\N	\N	\N	9fcfe289-1f62-434d-9ecd-a2fa613864fb	M	0	hispanic	0	puerto_rican	0
2939	8532	1953	1	20	1953-01-20 00:00:00	8516	0	\N	\N	\N	8b5fb9e4-44b3-47f3-900a-2b908e39ced1	F	0	black	0	african	0
3647	8507	1936	10	21	1936-10-21 00:00:00	0	38003563	\N	\N	\N	ad991c42-8a8c-4a1a-b465-b0d0d0202648	M	0	hispanic	0	puerto_rican	0
3248	8532	1945	7	13	1945-07-13 00:00:00	8515	0	\N	\N	\N	9a67c8d7-9243-4af2-a5d8-c9ab4a730473	F	0	asian	0	chinese	0
3159	8532	1959	6	25	1959-06-25 00:00:00	8527	0	\N	\N	\N	95fd3d9d-ce25-4c49-83b0-32bacaca62d1	F	0	white	0	german	0
3589	8507	1980	12	29	1980-12-29 00:00:00	8516	0	\N	\N	\N	aa8cc190-285d-4f11-95f6-6725bc7f8af8	M	0	black	0	dominican	0
3378	8507	1957	7	20	1957-07-20 00:00:00	8527	0	\N	\N	\N	a0627bd9-7fc2-4806-8061-4277bf8560db	M	0	white	0	irish	0
3528	8507	1958	11	3	1958-11-03 00:00:00	8527	0	\N	\N	\N	a7e77728-41cc-4f2e-9974-d48026183142	M	0	white	0	italian	0
3014	8532	1973	6	30	1973-06-30 00:00:00	8527	0	\N	\N	\N	8e963945-bf7b-4524-8f57-12d2ead84e5c	F	0	white	0	portuguese	0
2947	8532	1974	5	22	1974-05-22 00:00:00	8527	0	\N	\N	\N	8bb5c87d-9297-44d0-821d-891035ab8911	F	0	white	0	english	0
3860	8507	1972	7	8	1972-07-08 00:00:00	8527	0	\N	\N	\N	b74e540a-f110-4547-a8da-6ad5f6d716a2	M	0	white	0	polish	0
3956	8532	1914	11	8	1914-11-08 00:00:00	8527	0	\N	\N	\N	bc7c9c1a-b2b9-49a5-a846-35e42ec6389e	F	0	white	0	polish	0
3638	8532	1963	5	2	1963-05-02 00:00:00	8527	0	\N	\N	\N	ad1a7392-012f-4eba-8b6f-b6a883fafcb5	F	0	white	0	french	0
2583	8532	1970	6	15	1970-06-15 00:00:00	8527	0	\N	\N	\N	7aebf814-efbf-4cb6-bca4-00439aa61842	F	0	white	0	italian	0
3023	8532	1981	10	24	1981-10-24 00:00:00	8527	0	\N	\N	\N	8eea24e2-4568-4c89-8162-870ac343b774	F	0	white	0	irish	0
2790	8532	1952	7	24	1952-07-24 00:00:00	8527	0	\N	\N	\N	845b1ec9-f7a6-4250-808c-b03759f13b91	F	0	white	0	irish	0
3489	8532	1972	10	28	1972-10-28 00:00:00	8527	0	\N	\N	\N	a61c1f8a-bfee-476d-84b2-4ec25ab81867	F	0	white	0	american	0
2904	8532	1970	5	20	1970-05-20 00:00:00	8527	0	\N	\N	\N	8a076282-64f5-42e2-bad3-27c3c5f1d94d	F	0	white	0	irish	0
2899	8507	1949	8	25	1949-08-25 00:00:00	8527	0	\N	\N	\N	89e4d2c3-9ec1-427f-bb81-81e65f1935fd	M	0	white	0	english	0
3199	8507	1973	1	31	1973-01-31 00:00:00	0	38003563	\N	\N	\N	9858f7cb-862b-43f9-9e3d-9bba986d36f4	M	0	hispanic	0	central_american	0
3403	8532	1969	3	31	1969-03-31 00:00:00	8516	0	\N	\N	\N	a1adea1c-74bf-4e26-a9b3-fc477581a117	F	0	black	0	african	0
3436	8532	1962	11	12	1962-11-12 00:00:00	8527	0	\N	\N	\N	a337ee87-c051-4474-888f-2eb0251f82be	F	0	white	0	italian	0
3064	8507	1935	10	3	1935-10-03 00:00:00	8527	0	\N	\N	\N	90d28c5f-4deb-448b-888e-3b7861383fdd	M	0	white	0	italian	0
3844	8507	1952	8	29	1952-08-29 00:00:00	0	38003563	\N	\N	\N	b69b1f34-be42-4f1b-add3-d1491e813afd	M	0	hispanic	0	puerto_rican	0
2624	8532	1968	1	4	1968-01-04 00:00:00	8516	0	\N	\N	\N	7c9ac780-999a-4868-9b75-6212cb77c5e8	F	0	black	0	african	0
3226	8507	1968	10	6	1968-10-06 00:00:00	0	38003563	\N	\N	\N	994b2e80-dd2f-490f-ab74-cda3bdd4f60c	M	0	hispanic	0	puerto_rican	0
2865	8507	1968	1	29	1968-01-29 00:00:00	8527	0	\N	\N	\N	88099165-2c7e-42c0-93ba-905ef72bbbdb	M	0	white	0	french_canadian	0
3207	8507	1958	12	11	1958-12-11 00:00:00	8527	0	\N	\N	\N	988f5219-4f70-4362-b03e-c4c906f1e866	M	0	white	0	portuguese	0
3833	8507	1965	10	27	1965-10-27 00:00:00	8527	0	\N	\N	\N	b619a88a-71ec-4d52-affc-dea99a7c809b	M	0	white	0	irish	0
3293	8507	1912	3	16	1912-03-16 00:00:00	8516	0	\N	\N	\N	9cb58b01-3169-4031-853a-600bf551a055	M	0	black	0	dominican	0
3443	8532	1977	3	8	1977-03-08 00:00:00	8516	0	\N	\N	\N	a3b87333-663d-4277-b581-0735596349b0	F	0	black	0	african	0
3631	8507	1974	11	28	1974-11-28 00:00:00	8516	0	\N	\N	\N	acb8551f-5243-47b4-bc57-3775cb70c295	M	0	black	0	african	0
2951	8532	1958	11	16	1958-11-16 00:00:00	8527	0	\N	\N	\N	8be0f3b4-c0d6-4763-9d8b-1eaa588696cb	F	0	white	0	italian	0
3811	8532	1920	7	29	1920-07-29 00:00:00	8527	0	\N	\N	\N	b5280a01-6388-4803-a886-9af6bc66fcca	F	0	white	0	irish	0
3540	8507	1974	1	28	1974-01-28 00:00:00	8527	0	\N	\N	\N	a859cdcc-fd8a-44d1-8662-e01a0b21eb42	M	0	white	0	polish	0
2909	8532	1945	2	25	1945-02-25 00:00:00	8527	0	\N	\N	\N	8a2f8ced-f5fd-42ca-905f-5eebd04589ea	F	0	white	0	french_canadian	0
3200	8532	1946	8	22	1946-08-22 00:00:00	8515	0	\N	\N	\N	985f2ef6-135a-46b5-a19c-7edc5aa47d41	F	0	asian	0	chinese	0
3330	8532	1973	10	7	1973-10-07 00:00:00	8527	0	\N	\N	\N	9e518e2a-93ee-46c6-a495-546b14a5688e	F	0	white	0	german	0
3637	8507	1959	7	21	1959-07-21 00:00:00	8515	0	\N	\N	\N	ad09e19d-7c19-4241-9cd3-7cc5ecfac1db	M	0	asian	0	chinese	0
3571	8507	1971	8	24	1971-08-24 00:00:00	8527	0	\N	\N	\N	aa008359-ddd8-4e2c-874b-a5eda552d6f1	M	0	white	0	german	0
3576	8532	1966	1	15	1966-01-15 00:00:00	8516	0	\N	\N	\N	aa2b0034-9a9d-49f4-be00-ed9398f2fb87	F	0	black	0	west_indian	0
3367	8507	1963	3	4	1963-03-04 00:00:00	0	38003563	\N	\N	\N	9fe640aa-ece0-420a-9610-ac3b17fdd657	M	0	hispanic	0	south_american	0
3686	8507	1967	11	20	1967-11-20 00:00:00	8527	0	\N	\N	\N	af76dc69-c5a7-49a7-91c8-dddc6e2c9cd5	M	0	white	0	irish	0
4053	8507	1961	11	26	1961-11-26 00:00:00	8527	0	\N	\N	\N	c0c91032-4443-4527-bfa8-5f2d9062bb8d	M	0	white	0	irish	0
2882	8532	1972	5	12	1972-05-12 00:00:00	8516	0	\N	\N	\N	88d048b3-d7a4-402d-a5ca-28e278c516b7	F	0	black	0	west_indian	0
2953	8507	1982	11	12	1982-11-12 00:00:00	0	38003563	\N	\N	\N	8c0c0656-5ebc-4ed4-8735-5941e2446968	M	0	hispanic	0	puerto_rican	0
2599	8532	1978	1	28	1978-01-28 00:00:00	8515	0	\N	\N	\N	7bb9dd44-dc81-47c3-809a-c3eb34e2a5de	F	0	asian	0	chinese	0
3559	8507	1949	8	26	1949-08-26 00:00:00	8527	0	\N	\N	\N	a94735cd-8a9a-41bd-86d9-a3e5682ad0e6	M	0	white	0	italian	0
3049	8507	1976	4	23	1976-04-23 00:00:00	0	38003563	\N	\N	\N	900a149c-e616-4bce-82b4-7681317593d8	M	0	hispanic	0	puerto_rican	0
3119	8507	1974	6	17	1974-06-17 00:00:00	8527	0	\N	\N	\N	93eb0d69-4c62-40b6-a81f-552a528e376d	M	0	white	0	italian	0
3272	8532	1970	6	9	1970-06-09 00:00:00	8527	0	\N	\N	\N	9bfcb67a-f2ba-4687-bf2a-8083c61c2732	F	0	white	0	italian	0
2264	8532	1969	5	11	1969-05-11 00:00:00	0	38003563	\N	\N	\N	69fbeb58-b441-403d-9186-cf077f9062ce	F	0	hispanic	0	puerto_rican	0
3660	8532	1972	7	22	1972-07-22 00:00:00	8515	0	\N	\N	\N	ae1fc7bc-0e99-4323-a72b-e21165303f9f	F	0	asian	0	chinese	0
3691	8532	1954	8	13	1954-08-13 00:00:00	8527	0	\N	\N	\N	af9924e5-6684-4119-a8bc-f196513c81ef	F	0	white	0	irish	0
3215	8507	1977	10	3	1977-10-03 00:00:00	8527	0	\N	\N	\N	98b563fa-7ab5-4317-82b0-a49980a84762	M	0	white	0	polish	0
3189	8532	1965	6	16	1965-06-16 00:00:00	8527	0	\N	\N	\N	979e1ed7-af6e-4069-bb13-86f9a63b0238	F	0	white	0	irish	0
3383	8532	1986	4	17	1986-04-17 00:00:00	8527	0	\N	\N	\N	a09aac55-e13f-4fbf-b94b-d9e50c452630	F	0	white	0	french_canadian	0
3053	8532	1982	1	9	1982-01-09 00:00:00	8516	0	\N	\N	\N	9056718f-2d46-4706-983a-0af3bde80c2d	F	0	black	0	dominican	0
3807	8532	1946	9	21	1946-09-21 00:00:00	8527	0	\N	\N	\N	b4f43d05-d450-4817-ba34-2df2763c3324	F	0	white	0	irish	0
2950	8532	1935	10	14	1935-10-14 00:00:00	8527	0	\N	\N	\N	8bde6604-87ff-4abc-8ee9-cf51f2df81d2	F	0	white	0	english	0
3117	8532	1973	8	1	1973-08-01 00:00:00	0	0	\N	\N	\N	93d1f63a-3b2d-4182-b050-debd43058d9c	F	0	native	0	american_indian	0
3082	8532	1965	8	4	1965-08-04 00:00:00	8515	0	\N	\N	\N	920c1e51-9efa-430f-9740-3d396afa8836	F	0	asian	0	chinese	0
3822	8507	1944	9	25	1944-09-25 00:00:00	8527	0	\N	\N	\N	b5a7e503-e35b-4adb-baf6-d4ba8d4ae7f5	M	0	white	0	english	0
4017	8532	1920	7	29	1920-07-29 00:00:00	8527	0	\N	\N	\N	bf2613ec-592e-4cae-9604-761b0ccef6f6	F	0	white	0	irish	0
3413	8532	1966	4	27	1966-04-27 00:00:00	8527	0	\N	\N	\N	a2305981-5309-4d44-8468-de6b184ee7c0	F	0	white	0	russian	0
3041	8507	1977	3	3	1977-03-03 00:00:00	8527	0	\N	\N	\N	8fa1f359-b975-4920-92d0-8fb38288199f	M	0	white	0	scottish	0
3795	8507	1973	2	13	1973-02-13 00:00:00	0	38003563	\N	\N	\N	b4415c17-de36-4349-bb0a-9bed76150599	M	0	hispanic	0	mexican	0
3270	8507	1970	3	26	1970-03-26 00:00:00	8527	0	\N	\N	\N	9bd44b14-161f-4e40-9af4-3c1653842e18	M	0	white	0	portuguese	0
3259	8507	1965	10	29	1965-10-29 00:00:00	8527	0	\N	\N	\N	9b19703a-c794-402d-bf17-ab5c0dde7056	M	0	white	0	portuguese	0
3699	8532	1971	7	15	1971-07-15 00:00:00	0	38003563	\N	\N	\N	b0116300-1939-4caf-bc47-984ac46660c2	F	0	hispanic	0	puerto_rican	0
3550	8507	1984	7	21	1984-07-21 00:00:00	8527	0	\N	\N	\N	a8caa0ee-6f7a-44ad-84c9-0eda3ae6f5a4	M	0	white	0	italian	0
3694	8507	1957	4	9	1957-04-09 00:00:00	8527	0	\N	\N	\N	afcf738b-cc93-4730-bffc-fc3641bc4bee	M	0	white	0	polish	0
3088	8507	1939	4	14	1939-04-14 00:00:00	8516	0	\N	\N	\N	92421575-bd87-4687-b5ad-832dbb374159	M	0	black	0	african	0
3157	8532	1952	7	4	1952-07-04 00:00:00	0	38003563	\N	\N	\N	95eadd6f-3ef6-4a4a-8bac-db1734ad9755	F	0	hispanic	0	puerto_rican	0
3938	8532	1910	3	22	1910-03-22 00:00:00	8527	0	\N	\N	\N	bba2444b-aa04-4ce0-b76b-237cd5cdfefb	F	0	white	0	german	0
4078	8532	1951	8	6	1951-08-06 00:00:00	8527	0	\N	\N	\N	c1c7bb26-2991-4fc2-a2e4-75c174336e4e	F	0	white	0	irish	0
3756	8532	1940	12	21	1940-12-21 00:00:00	8527	0	\N	\N	\N	b2aec6d1-a5ff-4d7c-9a08-57c6ea3e0812	F	0	white	0	english	0
2657	8507	1966	1	8	1966-01-08 00:00:00	8516	0	\N	\N	\N	7e0f3b4a-73d5-4d07-94e2-e8f5c2fe88b4	M	0	black	0	african	0
3183	8507	1981	2	8	1981-02-08 00:00:00	8527	0	\N	\N	\N	976a8031-4f94-4eac-a0f3-4f8f04e2dbd3	M	0	white	0	irish	0
2869	8507	1950	10	24	1950-10-24 00:00:00	8527	0	\N	\N	\N	8830dd96-877e-428e-8a9c-79f5c2eae4c9	M	0	white	0	irish	0
3543	8532	1958	7	15	1958-07-15 00:00:00	8527	0	\N	\N	\N	a8858264-a235-43d7-8fee-66ebca5b4640	F	0	white	0	italian	0
3010	8507	1964	1	15	1964-01-15 00:00:00	8527	0	\N	\N	\N	8e8102e3-27a4-4a1d-ba9b-71c2f97f8918	M	0	white	0	irish	0
3007	8507	1966	5	25	1966-05-25 00:00:00	8527	0	\N	\N	\N	8e38d55c-d802-47b8-adbc-5ada5632d6c9	M	0	white	0	english	0
3219	8507	1980	1	19	1980-01-19 00:00:00	8516	0	\N	\N	\N	99209435-42f8-4153-b97f-14b75d15c738	M	0	black	0	dominican	0
3495	8532	1965	6	16	1965-06-16 00:00:00	8527	0	\N	\N	\N	a6531a2a-d887-4913-8523-9c3f459956c7	F	0	white	0	american	0
3456	8507	1942	12	10	1942-12-10 00:00:00	8527	0	\N	\N	\N	a44ab586-7df6-46f9-ac85-fb5da658c7dc	M	0	white	0	german	0
3118	8532	1948	12	5	1948-12-05 00:00:00	8527	0	\N	\N	\N	93dfa272-35f0-492f-b873-d01f5b3c23dc	F	0	white	0	english	0
3998	8507	1947	6	12	1947-06-12 00:00:00	8527	0	\N	\N	\N	be30309f-83f1-4a5d-99c5-b54285a9a908	M	0	white	0	english	0
2732	8532	1969	8	7	1969-08-07 00:00:00	8527	0	\N	\N	\N	81e40472-c9ae-4bee-b9e0-51134fa98e4b	F	0	white	0	german	0
3308	8507	1947	2	10	1947-02-10 00:00:00	8527	0	\N	\N	\N	9d5c4c15-cf7f-47ff-aa0d-2f9a6cf591f0	M	0	white	0	english	0
2987	8507	1972	6	26	1972-06-26 00:00:00	8516	0	\N	\N	\N	8d53ded0-2716-41e5-a370-c4c612d81461	M	0	black	0	african	0
3313	8532	1955	1	21	1955-01-21 00:00:00	8527	0	\N	\N	\N	9d7db35d-2e37-4579-94d6-7ee6e920378d	F	0	white	0	german	0
3932	8507	1973	5	28	1973-05-28 00:00:00	8527	0	\N	\N	\N	bb2dc151-dbbd-42e0-89b8-83bc51926d96	M	0	white	0	english	0
3342	8532	1909	7	7	1909-07-07 00:00:00	8527	0	\N	\N	\N	9ee2d09d-452f-42d8-b1e1-2ced2b01e569	F	0	white	0	polish	0
3561	8507	1910	1	31	1910-01-31 00:00:00	0	38003563	\N	\N	\N	a955a168-6c0a-4a07-bc83-41e8d8484c06	M	0	hispanic	0	central_american	0
3779	8532	1970	4	4	1970-04-04 00:00:00	0	38003563	\N	\N	\N	b3b034f2-8a63-4e61-9eb0-1c0935a8ad6f	F	0	hispanic	0	puerto_rican	0
3057	8507	1937	1	4	1937-01-04 00:00:00	8527	0	\N	\N	\N	9061a3f7-43f6-4ff8-93fa-7e0754d928a9	M	0	white	0	polish	0
4010	8532	1977	5	5	1977-05-05 00:00:00	8527	0	\N	\N	\N	bed11c94-1dd4-42c2-827c-a423e6e48761	F	0	white	0	italian	0
3698	8532	1951	3	6	1951-03-06 00:00:00	8527	0	\N	\N	\N	b00d1444-ca14-4a3b-8a7a-12624ff41351	F	0	white	0	american	0
2993	8532	1970	6	13	1970-06-13 00:00:00	8527	0	\N	\N	\N	8d965abd-75dc-4a29-aed0-741af8027585	F	0	white	0	polish	0
3365	8507	1964	7	17	1964-07-17 00:00:00	8527	0	\N	\N	\N	9fdbeb08-5447-4aaf-bf85-ef0045bb2fa3	M	0	white	0	french	0
3444	8532	1938	10	31	1938-10-31 00:00:00	8515	0	\N	\N	\N	a3c01e5c-dfab-4ab7-ba20-a973f0fa87dc	F	0	asian	0	asian_indian	0
3651	8507	1959	8	27	1959-08-27 00:00:00	8527	0	\N	\N	\N	adc159d8-0ac2-40ff-9ee9-12855777aa98	M	0	white	0	english	0
3769	8507	1949	6	26	1949-06-26 00:00:00	8527	0	\N	\N	\N	b32af214-d063-4bbe-bf85-d7872689c2d3	M	0	white	0	irish	0
3624	8507	1946	7	4	1946-07-04 00:00:00	8516	0	\N	\N	\N	ac559c12-1d54-41db-bb86-08563d7516e3	M	0	black	0	west_indian	0
3409	8532	1955	6	16	1955-06-16 00:00:00	8527	0	\N	\N	\N	a2029e34-160c-453f-a63b-43e99ae84969	F	0	white	0	swedish	0
3836	8507	1977	3	4	1977-03-04 00:00:00	8527	0	\N	\N	\N	b6380a69-3931-43d5-a7a9-b72953d6a086	M	0	white	0	polish	0
4119	8532	1944	7	22	1944-07-22 00:00:00	8515	0	\N	\N	\N	c4651aac-c488-45a6-ba6c-d18c77f38d79	F	0	asian	0	asian_indian	0
3086	8507	1968	9	25	1968-09-25 00:00:00	8527	0	\N	\N	\N	922bca21-3e80-477c-a457-a5222ae8b668	M	0	white	0	english	0
3167	8507	1960	6	5	1960-06-05 00:00:00	8527	0	\N	\N	\N	964df2fe-7534-4daa-a7c4-73dd7635df37	M	0	white	0	english	0
2749	8507	1959	12	23	1959-12-23 00:00:00	8527	0	\N	\N	\N	82af6021-cad0-4f96-97d5-c6f5f441162c	M	0	white	0	irish	0
3639	8507	1922	2	11	1922-02-11 00:00:00	8527	0	\N	\N	\N	ad1d7aaa-e82e-4110-a791-30df84706572	M	0	white	0	italian	0
3135	8507	1963	6	6	1963-06-06 00:00:00	8527	0	\N	\N	\N	95149518-ab42-4ef1-bcd9-84490031c6a4	M	0	white	0	french_canadian	0
3161	8507	1951	5	16	1951-05-16 00:00:00	8527	0	\N	\N	\N	9603f75e-c10b-457a-9895-cbca8d4eccfd	M	0	white	0	french	0
3355	8532	1962	10	5	1962-10-05 00:00:00	8527	0	\N	\N	\N	9f9df1db-b730-4221-95d0-29a9881bb88a	F	0	white	0	english	0
2315	8507	1977	4	30	1977-04-30 00:00:00	8527	0	\N	\N	\N	6c4e2660-9ca4-47fd-9a13-3997fda01a4a	M	0	white	0	english	0
3744	8532	1969	12	28	1969-12-28 00:00:00	8527	0	\N	\N	\N	b237cea9-8aa7-43ee-8d72-eb96709f5e6c	F	0	white	0	portuguese	0
3719	8532	1963	1	8	1963-01-08 00:00:00	0	38003563	\N	\N	\N	b10b38fd-766e-46ba-ad4a-a1d8fe258bee	F	0	hispanic	0	south_american	0
3321	8507	1977	1	24	1977-01-24 00:00:00	8527	0	\N	\N	\N	9df8406b-885d-4329-8c7f-438393311435	M	0	white	0	irish	0
3311	8507	1956	3	21	1956-03-21 00:00:00	8527	0	\N	\N	\N	9d61b9c6-a5e0-45e9-bae4-1a84c45c3e0d	M	0	white	0	polish	0
3501	8507	1947	12	4	1947-12-04 00:00:00	0	38003563	\N	\N	\N	a6ce68a8-7658-493b-a8b9-d719f40ab215	M	0	hispanic	0	central_american	0
3149	8507	1950	11	20	1950-11-20 00:00:00	8527	0	\N	\N	\N	959bb617-57e3-40d7-9e33-9947d02e29f8	M	0	white	0	english	0
3852	8532	1951	10	8	1951-10-08 00:00:00	8527	0	\N	\N	\N	b6fbc3f5-dda5-4435-a618-60aa4640bc77	F	0	white	0	american	0
3056	8507	1956	12	28	1956-12-28 00:00:00	8527	0	\N	\N	\N	905cf4d1-847d-4a59-b442-8878effd3b09	M	0	white	0	french	0
3428	8507	1966	5	25	1966-05-25 00:00:00	8516	0	\N	\N	\N	a29e2989-daae-4a17-8b7f-d4d11884d9bb	M	0	black	0	african	0
3196	8507	1970	4	7	1970-04-07 00:00:00	8527	0	\N	\N	\N	97f5b08f-6240-4f6e-9ea1-1f00a5055fd4	M	0	white	0	english	0
3901	8507	1936	3	18	1936-03-18 00:00:00	8515	0	\N	\N	\N	b950f338-4fc4-40ea-b323-ec0348855f2a	M	0	asian	0	asian_indian	0
4101	8532	1960	2	27	1960-02-27 00:00:00	8516	0	\N	\N	\N	c352a2d4-5def-44c2-bb52-54ca7af6b09b	F	0	black	0	west_indian	0
3513	8532	1972	3	19	1972-03-19 00:00:00	8527	0	\N	\N	\N	a747d054-955a-4de8-ad19-94577cb3b032	F	0	white	0	portuguese	0
3137	8532	1909	4	17	1909-04-17 00:00:00	8527	0	\N	\N	\N	95283c3a-f722-4058-bb9f-6b80bb60aace	F	0	white	0	irish	0
3958	8507	1960	8	14	1960-08-14 00:00:00	8515	0	\N	\N	\N	bc90bae4-84fe-4f8b-8058-88666829958a	M	0	asian	0	chinese	0
3427	8507	1966	4	6	1966-04-06 00:00:00	8527	0	\N	\N	\N	a2989ed1-18ce-41db-89c9-2424206bc7dd	M	0	white	0	american	0
3277	8507	1962	12	7	1962-12-07 00:00:00	0	38003563	\N	\N	\N	9c3578fc-6f6f-4d2b-8316-a8a9fb9ec9cc	M	0	hispanic	0	puerto_rican	0
3743	8532	1977	8	14	1977-08-14 00:00:00	8527	0	\N	\N	\N	b237b6fc-92a7-4b78-b79b-7fba6f756625	F	0	white	0	french	0
3598	8532	1944	3	26	1944-03-26 00:00:00	8527	0	\N	\N	\N	aafaee28-ef29-45c5-a855-463c17e65b3e	F	0	white	0	polish	0
3714	8532	1922	8	16	1922-08-16 00:00:00	8527	0	\N	\N	\N	b0eccea3-29f8-4152-ae63-52e5caa82d02	F	0	white	0	english	0
3174	8532	1980	12	12	1980-12-12 00:00:00	8527	0	\N	\N	\N	96b7935b-28e8-407f-b3e5-c245f28221ee	F	0	white	0	irish	0
3279	8507	1954	9	28	1954-09-28 00:00:00	8527	0	\N	\N	\N	9c38c8a4-9389-47e6-ac96-678ad1ce73e3	M	0	white	0	american	0
3982	8532	1938	11	11	1938-11-11 00:00:00	8527	0	\N	\N	\N	bd6e4fe5-d06c-4307-a55e-b2b9d9d716b9	F	0	white	0	italian	0
4278	8532	1950	10	20	1950-10-20 00:00:00	8527	0	\N	\N	\N	cb733b7f-1c55-476e-9149-b0cf2d761b0d	F	0	white	0	german	0
3849	8532	1963	11	21	1963-11-21 00:00:00	8527	0	\N	\N	\N	b6ef6acb-19a6-4d79-90c2-10caf4dbc8f1	F	0	white	0	irish	0
3090	8507	1961	1	23	1961-01-23 00:00:00	0	38003563	\N	\N	\N	926b2152-bb7c-4fce-a0ae-4f7a900165c4	M	0	hispanic	0	central_american	0
3408	8507	1969	7	7	1969-07-07 00:00:00	0	38003563	\N	\N	\N	a1eadf51-5ea7-432e-8ab2-dd750fbb7ea9	M	0	hispanic	0	puerto_rican	0
2883	8532	1964	2	26	1964-02-26 00:00:00	8527	0	\N	\N	\N	88d9a1ae-63d0-42d0-a406-d1c244a80feb	F	0	white	0	irish	0
3697	8532	1951	3	24	1951-03-24 00:00:00	8527	0	\N	\N	\N	affec033-75ab-4f03-8a29-0ce9d1845a94	F	0	white	0	french	0
3092	8532	1955	7	27	1955-07-27 00:00:00	8527	0	\N	\N	\N	92724c86-9c7a-485d-84d6-9e761117f58a	F	0	white	0	italian	0
3017	8532	1957	8	16	1957-08-16 00:00:00	8527	0	\N	\N	\N	8ea5108f-4f91-43ae-9039-fad096b983ec	F	0	white	0	irish	0
3301	8507	1938	4	5	1938-04-05 00:00:00	8527	0	\N	\N	\N	9d08fb21-7630-4e39-a2bf-8b77b766531b	M	0	white	0	italian	0
3537	8507	1961	6	25	1961-06-25 00:00:00	8527	0	\N	\N	\N	a83f40b6-4886-4fe4-8b11-5a9b36856f3c	M	0	white	0	english	0
3622	8532	1922	5	24	1922-05-24 00:00:00	8527	0	\N	\N	\N	ac216b96-0a24-4b31-8b7c-ecabeec71262	F	0	white	0	german	0
3431	8532	1962	10	10	1962-10-10 00:00:00	8527	0	\N	\N	\N	a2c95d0f-ee4d-44c0-b534-ff4127cc5a6c	F	0	white	0	french	0
4072	8507	1974	9	7	1974-09-07 00:00:00	8527	0	\N	\N	\N	c171f26b-ed0a-40c3-9cd1-94b5625da952	M	0	white	0	english	0
2778	8507	1976	10	23	1976-10-23 00:00:00	8527	0	\N	\N	\N	83db94b6-85ef-4f25-9c9f-1dbf4d6218b2	M	0	white	0	french	0
3391	8507	1982	6	22	1982-06-22 00:00:00	0	38003563	\N	\N	\N	a11510a9-317c-4aef-9834-0ea6cc997c4a	M	0	hispanic	0	puerto_rican	0
3083	8532	1951	4	29	1951-04-29 00:00:00	8527	0	\N	\N	\N	92111908-78d5-40ff-bda9-f8d944790ccd	F	0	white	0	russian	0
3362	8507	1957	2	20	1957-02-20 00:00:00	8527	0	\N	\N	\N	9fce3308-41ce-4cbe-a081-687dd5eabfa5	M	0	white	0	italian	0
4100	8507	1941	12	10	1941-12-10 00:00:00	8516	0	\N	\N	\N	c343351b-1e4f-42ad-9199-46feee791e05	M	0	black	0	african	0
3634	8532	1970	2	23	1970-02-23 00:00:00	8527	0	\N	\N	\N	acca0f8b-876e-4940-914c-991c5ef559b8	F	0	white	0	italian	0
3641	8507	1912	11	1	1912-11-01 00:00:00	8527	0	\N	\N	\N	ad47ee2d-e961-4668-90f3-2d880ff641a1	M	0	white	0	irish	0
3856	8532	1973	10	3	1973-10-03 00:00:00	8516	0	\N	\N	\N	b71a4779-1322-4559-93f2-0f7ee220e0fb	F	0	black	0	african	0
3275	8532	1960	4	9	1960-04-09 00:00:00	8515	0	\N	\N	\N	9c167d0c-94cd-487b-9506-bbf3a63cc3b0	F	0	asian	0	asian_indian	0
4200	8532	1968	6	19	1968-06-19 00:00:00	0	38003563	\N	\N	\N	c83d8af4-c1dc-48f2-9160-eea0f13347f5	F	0	hispanic	0	puerto_rican	0
3742	8507	1970	8	14	1970-08-14 00:00:00	8527	0	\N	\N	\N	b23443e5-91fc-4b46-b13e-782934e9c367	M	0	white	0	italian	0
3175	8532	1953	11	24	1953-11-24 00:00:00	8527	0	\N	\N	\N	96b81efa-dad3-48e9-bdec-c34d94770217	F	0	white	0	irish	0
3529	8532	1944	4	26	1944-04-26 00:00:00	8527	0	\N	\N	\N	a7ebb877-3b97-4b21-9f4f-4eff564d9842	F	0	white	0	italian	0
3566	8507	1951	7	23	1951-07-23 00:00:00	8516	0	\N	\N	\N	a992a439-3360-4741-b433-94c37fb074f7	M	0	black	0	dominican	0
3759	8532	1964	8	9	1964-08-09 00:00:00	8527	0	\N	\N	\N	b2c98430-9bca-4126-b603-5bc44931b2aa	F	0	white	0	american	0
3791	8507	1914	8	29	1914-08-29 00:00:00	0	38003563	\N	\N	\N	b41179fa-e06e-4b71-b71d-e813630e3068	M	0	hispanic	0	south_american	0
3678	8507	1976	11	22	1976-11-22 00:00:00	8527	0	\N	\N	\N	af10bfaa-3682-4aaf-9cb4-9af49cbe3277	M	0	white	0	italian	0
3531	8532	1967	3	29	1967-03-29 00:00:00	0	38003563	\N	\N	\N	a7f69df3-a341-42cd-8414-3ab73f70d950	F	0	hispanic	0	puerto_rican	0
3887	8532	1956	6	25	1956-06-25 00:00:00	8515	0	\N	\N	\N	b8a8c7f4-9469-4bf1-9e45-7c0efe06cd65	F	0	asian	0	chinese	0
4347	8532	1966	4	10	1966-04-10 00:00:00	8527	0	\N	\N	\N	ce461aa6-9bfa-474a-98ed-130bd3a637c5	F	0	white	0	french_canadian	0
3298	8507	1971	8	15	1971-08-15 00:00:00	8527	0	\N	\N	\N	9cfcda3b-e101-40cc-8bc3-030418b62153	M	0	white	0	english	0
3578	8532	1972	8	2	1972-08-02 00:00:00	8527	0	\N	\N	\N	aa2bf6b2-1911-4a04-88d1-03b8e49f8b76	F	0	white	0	polish	0
2926	8532	1981	9	18	1981-09-18 00:00:00	8516	0	\N	\N	\N	8ac65c75-7c0e-46d9-acce-d4b1f344ee05	F	0	black	0	dominican	0
3757	8507	1945	2	21	1945-02-21 00:00:00	0	0	\N	\N	\N	b2b7d559-a1af-4736-a8b4-9a77ad42b31f	M	0	native	0	american_indian	0
3145	8507	1970	8	30	1970-08-30 00:00:00	8527	0	\N	\N	\N	957467e8-3a35-4918-8f23-1580285b63b2	M	0	white	0	german	0
3253	8532	1970	5	19	1970-05-19 00:00:00	8515	0	\N	\N	\N	9ab22f9e-2fb1-4ab1-9b1e-4b9ede453e6b	F	0	asian	0	chinese	0
3437	8532	1912	4	27	1912-04-27 00:00:00	8527	0	\N	\N	\N	a33ea2cc-37a2-4ba3-809e-d496a79000b7	F	0	white	0	american	0
2535	8507	1961	1	1	1961-01-01 00:00:00	8527	0	\N	\N	\N	7819b8df-c9a2-4911-9ff1-00987a089983	M	0	white	0	american	0
3955	8507	1956	2	4	1956-02-04 00:00:00	8516	0	\N	\N	\N	bc7644ad-a699-4d5d-b46f-58516b3cd544	M	0	black	0	african	0
3825	8532	1954	6	11	1954-06-11 00:00:00	8515	0	\N	\N	\N	b5c90815-7ce6-4ac3-9076-6f79a22ff4e9	F	0	asian	0	asian_indian	0
3370	8532	1972	9	24	1972-09-24 00:00:00	8527	0	\N	\N	\N	a00f5db1-8f56-475c-a9f0-239b25918f55	F	0	white	0	italian	0
3494	8532	1959	8	6	1959-08-06 00:00:00	8527	0	\N	\N	\N	a645d739-1c93-4b29-98cb-c37baf8653d3	F	0	white	0	french	0
3547	8507	1970	7	13	1970-07-13 00:00:00	0	38003563	\N	\N	\N	a898921a-4017-41f3-b1fa-6dd128076495	M	0	hispanic	0	puerto_rican	0
3287	8532	1944	7	10	1944-07-10 00:00:00	0	38003563	\N	\N	\N	9c85457e-cf6e-4d94-a99f-c699c99453e2	F	0	hispanic	0	puerto_rican	0
3962	8532	1951	5	18	1951-05-18 00:00:00	8527	0	\N	\N	\N	bcba3dbe-3f9e-4b21-8950-c6376168f6c5	F	0	white	0	portuguese	0
3260	8532	1960	4	2	1960-04-02 00:00:00	8527	0	\N	\N	\N	9b1f0da2-d5c9-4aa5-b44e-1c446dee9d85	F	0	white	0	russian	0
3464	8532	1980	5	14	1980-05-14 00:00:00	0	38003563	\N	\N	\N	a49ab331-478e-4979-b6bd-01cfda973426	F	0	hispanic	0	puerto_rican	0
3216	8507	1954	6	22	1954-06-22 00:00:00	8527	0	\N	\N	\N	98c8b875-9b87-4ce1-a620-963373a52e7a	M	0	white	0	french	0
4049	8507	1961	4	4	1961-04-04 00:00:00	8527	0	\N	\N	\N	c06f39b4-8b29-45ee-8aff-5bdaf600eadf	M	0	white	0	irish	0
4255	8507	1973	4	28	1973-04-28 00:00:00	0	38003563	\N	\N	\N	cabc71f4-4103-414a-b5e7-98b657770d55	M	0	hispanic	0	puerto_rican	0
3615	8532	1949	8	31	1949-08-31 00:00:00	8527	0	\N	\N	\N	abbd3337-d608-4db1-b5bb-cbaf71b2b3d9	F	0	white	0	russian	0
3454	8507	1983	3	7	1983-03-07 00:00:00	8527	0	\N	\N	\N	a428b224-f421-41f3-86a2-8dddc456ea62	M	0	white	0	irish	0
4142	8507	1981	6	14	1981-06-14 00:00:00	0	38003563	\N	\N	\N	c5cbac70-7b0e-4748-9c72-23b5508ffd57	M	0	hispanic	0	puerto_rican	0
3577	8532	1961	2	27	1961-02-27 00:00:00	8527	0	\N	\N	\N	aa2b77dd-97c8-44fa-8d93-5f78c7cce227	F	0	white	0	italian	0
3432	8507	1951	11	9	1951-11-09 00:00:00	8527	0	\N	\N	\N	a2d8d91f-ab1c-403b-8ece-d93becbac9ea	M	0	white	0	irish	0
3817	8507	1964	8	21	1964-08-21 00:00:00	8527	0	\N	\N	\N	b548763f-e274-40af-bb90-bbdb32a60573	M	0	white	0	italian	0
3732	8507	1955	7	17	1955-07-17 00:00:00	8527	0	\N	\N	\N	b197d94e-6a3c-4160-b6f4-670a30f862d6	M	0	white	0	french_canadian	0
3879	8532	1939	12	14	1939-12-14 00:00:00	8527	0	\N	\N	\N	b8325769-cfbd-4782-80a7-dd858ef36088	F	0	white	0	english	0
3375	8532	1954	3	5	1954-03-05 00:00:00	0	38003563	\N	\N	\N	a033abff-ff74-4114-a0de-7eabdb3fbe29	F	0	hispanic	0	puerto_rican	0
3434	8532	1948	4	22	1948-04-22 00:00:00	8527	0	\N	\N	\N	a2ff5e4f-16bd-4950-92a9-23244f39c88f	F	0	white	0	polish	0
4256	8507	1952	10	5	1952-10-05 00:00:00	8527	0	\N	\N	\N	cabe3faa-18fa-4c71-b024-9ec820e0b678	M	0	white	0	polish	0
4288	8532	1951	2	10	1951-02-10 00:00:00	8516	0	\N	\N	\N	cbf76b4a-3796-4b3f-8c65-39cf1ed93319	F	0	black	0	west_indian	0
3967	8532	1960	5	1	1960-05-01 00:00:00	8527	0	\N	\N	\N	bcc97562-cce8-4fd2-98ae-f013a3e637ec	F	0	white	0	italian	0
3172	8532	1977	1	20	1977-01-20 00:00:00	8527	0	\N	\N	\N	96a9e699-d5e5-4b9f-9f8a-5735e06dc41b	F	0	white	0	portuguese	0
3516	8532	1945	7	26	1945-07-26 00:00:00	0	38003563	\N	\N	\N	a7675b24-b687-4c55-867e-8b9925034644	F	0	hispanic	0	central_american	0
2991	8507	1960	3	4	1960-03-04 00:00:00	8527	0	\N	\N	\N	8d798935-dbda-4208-a90a-ea6273ef6183	M	0	white	0	english	0
3896	8532	1977	10	7	1977-10-07 00:00:00	8527	0	\N	\N	\N	b9180b84-2555-491b-afb9-21581106f564	F	0	white	0	portuguese	0
3170	8532	1950	12	22	1950-12-22 00:00:00	8527	0	\N	\N	\N	968b9980-8e3d-4bce-a7df-433df6ff3d07	F	0	white	0	english	0
3103	8532	1977	6	15	1977-06-15 00:00:00	8527	0	\N	\N	\N	92fb54bb-5092-4bea-a697-90837c942ece	F	0	white	0	american	0
3382	8532	1962	2	15	1962-02-15 00:00:00	0	38003563	\N	\N	\N	a094d0ea-a27e-4f65-ad92-1de44c7a9e7e	F	0	hispanic	0	puerto_rican	0
3703	8507	1968	11	23	1968-11-23 00:00:00	8527	0	\N	\N	\N	b05cd35d-6d80-4040-b2b5-aef2709e3982	M	0	white	0	french	0
3772	8532	1969	2	15	1969-02-15 00:00:00	8527	0	\N	\N	\N	b35064ba-4068-4937-a03b-5a4fa46245cb	F	0	white	0	irish	0
3629	8507	1955	11	21	1955-11-21 00:00:00	8527	0	\N	\N	\N	ac912ba4-ffcc-4a34-97a7-b0695e4d971f	M	0	white	0	german	0
4373	8507	1976	1	6	1976-01-06 00:00:00	0	38003563	\N	\N	\N	cfad8edd-9c6d-4b9d-a1ff-7c032dbaf741	M	0	hispanic	0	puerto_rican	0
2825	8507	1925	2	24	1925-02-24 00:00:00	8527	0	\N	\N	\N	85caa5d3-028e-48fa-b841-458255b758f8	M	0	white	0	irish	0
3401	8507	1958	9	21	1958-09-21 00:00:00	0	38003563	\N	\N	\N	a19542d8-d3e1-4e62-b14f-96b99744bc70	M	0	hispanic	0	puerto_rican	0
3217	8507	1983	7	5	1983-07-05 00:00:00	8527	0	\N	\N	\N	98fd111c-d4a1-4907-a9e0-98ded9a38152	M	0	white	0	american	0
3614	8507	1949	6	26	1949-06-26 00:00:00	8527	0	\N	\N	\N	abba5eef-9978-4f23-aa7a-e263c8fef854	M	0	white	0	irish	0
4210	8507	1975	4	5	1975-04-05 00:00:00	8515	0	\N	\N	\N	c8ee1bf6-7957-4aec-b504-749836b50068	M	0	asian	0	chinese	0
3652	8532	1973	9	9	1973-09-09 00:00:00	8527	0	\N	\N	\N	add5516e-8fa6-4bf3-81f3-0eda7a451fd4	F	0	white	0	irish	0
3996	8507	1968	11	12	1968-11-12 00:00:00	8527	0	\N	\N	\N	be1b245d-182e-444a-8402-1d95b38a9a04	M	0	white	0	english	0
3942	8532	1978	4	20	1978-04-20 00:00:00	8527	0	\N	\N	\N	bbd7e658-3fa1-4dad-b688-dca51c2706ad	F	0	white	0	italian	0
3352	8532	1964	10	23	1964-10-23 00:00:00	8527	0	\N	\N	\N	9f6f711c-7959-40ff-824a-ab782f768660	F	0	white	0	irish	0
4338	8507	1965	7	10	1965-07-10 00:00:00	8515	0	\N	\N	\N	ce091f81-80a2-49cb-b4ae-6114e94f7c48	M	0	asian	0	chinese	0
3899	8507	1979	12	29	1979-12-29 00:00:00	8527	0	\N	\N	\N	b9385e39-8116-4a12-ae5e-d455401cac8e	M	0	white	0	german	0
3211	8532	1956	11	23	1956-11-23 00:00:00	8515	0	\N	\N	\N	989c2e16-4f1f-4bf1-9221-6a34ec5cd8fd	F	0	asian	0	asian_indian	0
3609	8507	1974	11	29	1974-11-29 00:00:00	0	38003563	\N	\N	\N	ab85f1be-19d3-43c5-86be-a0725dc6ea93	M	0	hispanic	0	mexican	0
3748	8507	1979	3	13	1979-03-13 00:00:00	8527	0	\N	\N	\N	b257f6c4-5d9a-4894-9fd4-ea420ad749e8	M	0	white	0	irish	0
3984	8507	1953	12	23	1953-12-23 00:00:00	0	38003563	\N	\N	\N	bd82b775-6b67-457f-829f-746b642d75d1	M	0	hispanic	0	mexican	0
3946	8507	1960	3	22	1960-03-22 00:00:00	8515	0	\N	\N	\N	bc12fffe-0c0d-461b-9902-dcd96e15b279	M	0	asian	0	chinese	0
4091	8532	1967	11	26	1967-11-26 00:00:00	8527	0	\N	\N	\N	c2ace511-8a72-4bb2-a40c-b0b74b5c0a3f	F	0	white	0	irish	0
3831	8507	1954	5	30	1954-05-30 00:00:00	8527	0	\N	\N	\N	b5fef238-8475-4835-bcd7-21b3935c8373	M	0	white	0	irish	0
3929	8532	1952	5	5	1952-05-05 00:00:00	8516	0	\N	\N	\N	baffcc56-33c6-4d4a-9989-39b74b59fbb4	F	0	black	0	west_indian	0
4392	8532	1979	8	3	1979-08-03 00:00:00	8516	0	\N	\N	\N	d0a67256-4d78-4038-b03f-b088755210ff	F	0	black	0	west_indian	0
3399	8532	1983	2	7	1983-02-07 00:00:00	8516	0	\N	\N	\N	a18f2e4c-195c-4ecc-9dad-a7a2361fd6d3	F	0	black	0	dominican	0
3626	8532	1974	3	23	1974-03-23 00:00:00	8527	0	\N	\N	\N	ac6a3b6f-e00c-44d2-b22d-a9882ed7040b	F	0	white	0	italian	0
3060	8507	1924	3	29	1924-03-29 00:00:00	8515	0	\N	\N	\N	90ac787d-f88b-49dc-9c98-a35cc6d530df	M	0	asian	0	asian_indian	0
3803	8532	1960	4	13	1960-04-13 00:00:00	0	38003563	\N	\N	\N	b496f309-0dc3-4d50-ac0d-589d5f06fb25	F	0	hispanic	0	puerto_rican	0
3237	8532	1926	8	11	1926-08-11 00:00:00	8515	0	\N	\N	\N	9a0d4c28-48a4-44bb-809b-95c708befac5	F	0	asian	0	chinese	0
3430	8532	1961	7	15	1961-07-15 00:00:00	8527	0	\N	\N	\N	a2a88ff6-cf06-4276-b0fd-be7a979137f6	F	0	white	0	polish	0
3457	8532	1916	9	1	1916-09-01 00:00:00	8527	0	\N	\N	\N	a44b5a2c-e426-4769-9eed-1940feb89e62	F	0	white	0	english	0
2615	8507	1947	11	16	1947-11-16 00:00:00	8527	0	\N	\N	\N	7c43ca40-d9f7-4db5-a4ff-5913d3f7a325	M	0	white	0	irish	0
4139	8532	1970	11	6	1970-11-06 00:00:00	8527	0	\N	\N	\N	c5b10f9e-4bed-490c-93f4-300ef7e545ef	F	0	white	0	english	0
3874	8532	1981	12	23	1981-12-23 00:00:00	8527	0	\N	\N	\N	b80fc345-4dde-41ce-b1b0-901c9dfaa2e1	F	0	white	0	italian	0
3420	8532	1964	9	29	1964-09-29 00:00:00	8527	0	\N	\N	\N	a26b099e-13a6-48d8-b33a-d05365bf6226	F	0	white	0	portuguese	0
3536	8532	1963	11	7	1963-11-07 00:00:00	0	0	\N	\N	\N	a83cd26a-eec8-4ace-8239-a9126e8ebfc4	F	0	native	0	american_indian	0
3595	8507	1949	4	14	1949-04-14 00:00:00	8515	0	\N	\N	\N	aad0005d-1364-4b6a-a9d7-9e117c4ae084	M	0	asian	0	chinese	0
3332	8532	1960	12	6	1960-12-06 00:00:00	8516	0	\N	\N	\N	9e751c6c-bb72-4413-9b32-198a701f2c25	F	0	black	0	dominican	0
4064	8532	1960	5	9	1960-05-09 00:00:00	8527	0	\N	\N	\N	c1342915-84d0-4e47-8bff-87dd13dccd34	F	0	white	0	english	0
3353	8507	1924	12	27	1924-12-27 00:00:00	8527	0	\N	\N	\N	9f7908d3-a254-4377-87b4-fad4baf91051	M	0	white	0	italian	0
3582	8532	1956	5	27	1956-05-27 00:00:00	8527	0	\N	\N	\N	aa5bbd2c-c268-4eff-8c04-b2203a8cc240	F	0	white	0	polish	0
3381	8532	1971	12	6	1971-12-06 00:00:00	8527	0	\N	\N	\N	a07fd45c-0f3f-4aa1-97e5-1e5682efb4a8	F	0	white	0	german	0
4197	8532	1985	9	15	1985-09-15 00:00:00	8516	0	\N	\N	\N	c7f52a47-8233-409c-9c06-16cdfbf78287	F	0	black	0	dominican	0
4329	8532	1978	4	2	1978-04-02 00:00:00	8527	0	\N	\N	\N	cdb5cd24-81f1-45c4-8a50-2b8776fb1e95	F	0	white	0	irish	0
3689	8532	1950	1	29	1950-01-29 00:00:00	8527	0	\N	\N	\N	af9274a2-8a40-4b62-9a93-30fbf04a0199	F	0	white	0	portuguese	0
3556	8507	1978	7	17	1978-07-17 00:00:00	8527	0	\N	\N	\N	a8e97224-3ef9-4be2-83c1-e64eee65c369	M	0	white	0	polish	0
4276	8507	1952	12	25	1952-12-25 00:00:00	0	38003563	\N	\N	\N	cb590ed2-d0f0-4f90-a482-b197ede36d92	M	0	hispanic	0	south_american	0
3625	8532	1953	7	14	1953-07-14 00:00:00	8516	0	\N	\N	\N	ac5a5347-f4d7-40c3-8595-559ef5949393	F	0	black	0	african	0
3570	8532	1948	12	5	1948-12-05 00:00:00	8527	0	\N	\N	\N	a9f6a81b-c77f-4807-b2d1-847668f9aeb3	F	0	white	0	english	0
3916	8532	1978	10	4	1978-10-04 00:00:00	8527	0	\N	\N	\N	ba27ba98-0f14-46e1-acca-4eec5ac6bacf	F	0	white	0	english	0
3889	8507	1937	9	12	1937-09-12 00:00:00	8527	0	\N	\N	\N	b8b7c0a1-c1d7-4dcf-9ef4-2cfcf7cebae5	M	0	white	0	italian	0
3921	8532	1981	11	11	1981-11-11 00:00:00	8527	0	\N	\N	\N	babbc364-342e-4883-81d4-d3b4d5f156db	F	0	white	0	english	0
3417	8532	1909	4	17	1909-04-17 00:00:00	8527	0	\N	\N	\N	a259b03f-4d5c-4514-9926-2e0270aa96a7	F	0	white	0	irish	0
3462	8532	1960	9	23	1960-09-23 00:00:00	8515	0	\N	\N	\N	a49003cf-6028-494b-ba9f-850f33469c0a	F	0	asian	0	asian_indian	0
4467	8532	1951	6	28	1951-06-28 00:00:00	8527	0	\N	\N	\N	d493b261-957a-481f-a6e3-0c15c0dabffd	F	0	white	0	italian	0
4607	8507	1972	1	20	1972-01-20 00:00:00	0	38003563	\N	\N	\N	dc1dc1a9-f844-4bc5-b111-5717359d64ff	M	0	hispanic	0	puerto_rican	0
3987	8532	1953	12	26	1953-12-26 00:00:00	8527	0	\N	\N	\N	bdac2101-088b-445f-a7b9-afbe06762449	F	0	white	0	italian	0
3208	8532	1968	1	12	1968-01-12 00:00:00	8527	0	\N	\N	\N	9891e818-36a3-456b-a209-6f25701e9b0c	F	0	white	0	polish	0
3530	8507	1959	4	24	1959-04-24 00:00:00	0	38003563	\N	\N	\N	a7eccb18-7752-49d0-8d08-c58934d1221c	M	0	hispanic	0	central_american	0
3087	8532	1938	6	29	1938-06-29 00:00:00	8527	0	\N	\N	\N	923c1383-22b5-47b9-9893-03241b4a6fae	F	0	white	0	american	0
4052	8532	1976	4	15	1976-04-15 00:00:00	8516	0	\N	\N	\N	c0c3f7a7-ff2f-496f-8420-cad54621fd4b	F	0	black	0	african	0
3214	8532	1972	2	15	1972-02-15 00:00:00	8527	0	\N	\N	\N	98b2734b-a2ac-42fd-9a2f-92d8e1b77d91	F	0	white	0	irish	0
3177	8532	1916	7	19	1916-07-19 00:00:00	8515	0	\N	\N	\N	96d733b6-1a58-4853-8df2-28104cfb0768	F	0	asian	0	chinese	0
3392	8532	1966	12	31	1966-12-31 00:00:00	8515	0	\N	\N	\N	a125b09b-314c-45e3-a61a-8a96cb8250be	F	0	asian	0	chinese	0
3739	8532	1967	8	14	1967-08-14 00:00:00	8527	0	\N	\N	\N	b2176219-12a2-4643-baf4-bb667380477e	F	0	white	0	irish	0
3786	8532	1958	12	9	1958-12-09 00:00:00	8527	0	\N	\N	\N	b3f3e8ed-b2b7-4762-84a2-c2fcac770961	F	0	white	0	english	0
3675	8507	1967	4	17	1967-04-17 00:00:00	8516	0	\N	\N	\N	aefd95d0-eb27-404d-b000-919ea7141799	M	0	black	0	african	0
4451	8507	1951	5	13	1951-05-13 00:00:00	8516	0	\N	\N	\N	d36f1dc7-b6bc-4d83-bcf9-4ff8c98868a7	M	0	black	0	african	0
2943	8532	1914	6	1	1914-06-01 00:00:00	8527	0	\N	\N	\N	8ba0239b-3d1c-46f3-a9f8-b05f57c9a1a4	F	0	white	0	swedish	0
3539	8532	1980	12	12	1980-12-12 00:00:00	0	38003563	\N	\N	\N	a85661eb-1330-4191-add6-6babb0856c49	F	0	hispanic	0	puerto_rican	0
3394	8532	1965	10	2	1965-10-02 00:00:00	8527	0	\N	\N	\N	a137a6b3-ba1c-4196-9666-aa66103a4d64	F	0	white	0	russian	0
3927	8507	1947	1	28	1947-01-28 00:00:00	8527	0	\N	\N	\N	baed679e-c770-42b5-b655-66d7974085e5	M	0	white	0	italian	0
4328	8532	1970	6	3	1970-06-03 00:00:00	8527	0	\N	\N	\N	cdac279e-5fb0-49a4-9701-f9a73fda48dc	F	0	white	0	french	0
3752	8532	1957	12	12	1957-12-12 00:00:00	8527	0	\N	\N	\N	b2983c64-70c4-4562-a2f0-26b07355d15b	F	0	white	0	french_canadian	0
4190	8507	1972	7	30	1972-07-30 00:00:00	8527	0	\N	\N	\N	c7afd074-8f44-49f4-94d9-2f6650c50a59	M	0	white	0	polish	0
4092	8532	1973	6	7	1973-06-07 00:00:00	8516	0	\N	\N	\N	c2c28788-6e92-4057-990f-9c9d879604f1	F	0	black	0	west_indian	0
3438	8532	1909	4	17	1909-04-17 00:00:00	8527	0	\N	\N	\N	a340966f-0ff5-415f-ba3e-8e5fc52d32cf	F	0	white	0	irish	0
4439	8507	1954	12	8	1954-12-08 00:00:00	0	38003563	\N	\N	\N	d2e0d627-2f34-4a4f-9af2-3f15e0ae35ac	M	0	hispanic	0	puerto_rican	0
3917	8507	1967	9	7	1967-09-07 00:00:00	0	38003563	\N	\N	\N	ba671a68-2bcd-4303-b7b5-1dcd30da9355	M	0	hispanic	0	puerto_rican	0
3325	8507	1963	7	17	1963-07-17 00:00:00	8516	0	\N	\N	\N	9e1641ee-77a2-40fb-b67d-ddfee1549731	M	0	black	0	west_indian	0
3695	8532	1980	2	4	1980-02-04 00:00:00	8516	0	\N	\N	\N	afd442d5-7ee1-40de-ae8a-c36bf3a248a3	F	0	black	0	african	0
3841	8532	1971	9	29	1971-09-29 00:00:00	8527	0	\N	\N	\N	b6846f9a-06c3-4948-a863-65acabe53961	F	0	white	0	irish	0
4379	8507	1969	6	17	1969-06-17 00:00:00	8515	0	\N	\N	\N	d011d4e8-1272-41f0-8cc9-62e08d8f40a9	M	0	asian	0	chinese	0
4080	8532	1965	6	1	1965-06-01 00:00:00	8515	0	\N	\N	\N	c1e2f662-6344-4e41-8945-83a855fb243d	F	0	asian	0	asian_indian	0
4153	8507	1965	2	11	1965-02-11 00:00:00	8527	0	\N	\N	\N	c671232b-e59f-42e3-b675-5d3c2dc3443d	M	0	white	0	german	0
3876	8507	1967	5	22	1967-05-22 00:00:00	8527	0	\N	\N	\N	b821df37-9247-46b0-a613-0546acff6136	M	0	white	0	english	0
4021	8532	1955	1	12	1955-01-12 00:00:00	8515	0	\N	\N	\N	bf4fb4d0-8779-4563-8f1b-e147057ec3b8	F	0	asian	0	asian_indian	0
4446	8507	1960	6	28	1960-06-28 00:00:00	0	38003563	\N	\N	\N	d33a8cd0-42da-4e0c-82a5-f8afd6025c2b	M	0	hispanic	0	puerto_rican	0
3549	8507	1957	6	4	1957-06-04 00:00:00	8527	0	\N	\N	\N	a8b84923-3ac4-43d7-a79a-3e65723ce32e	M	0	white	0	irish	0
3676	8532	1970	11	12	1970-11-12 00:00:00	8527	0	\N	\N	\N	af03d599-26ad-4e29-9c5d-3ff90f86337f	F	0	white	0	irish	0
3106	8507	1950	7	10	1950-07-10 00:00:00	8527	0	\N	\N	\N	931b225c-c173-499b-9791-a333816c631f	M	0	white	0	english	0
3966	8532	1966	12	10	1966-12-10 00:00:00	0	38003563	\N	\N	\N	bcc86213-448c-4e9d-a699-2ab722b3b563	F	0	hispanic	0	puerto_rican	0
3283	8532	1978	7	14	1978-07-14 00:00:00	8527	0	\N	\N	\N	9c5856a4-a0bd-4d1f-96db-2983101bcb01	F	0	white	0	italian	0
3580	8532	1972	3	24	1972-03-24 00:00:00	8527	0	\N	\N	\N	aa493cf7-4777-4b65-a89d-915e4cdfa253	F	0	white	0	italian	0
3623	8507	1949	6	19	1949-06-19 00:00:00	8527	0	\N	\N	\N	ac2eac53-37e9-430c-81ba-fe846dbac0db	M	0	white	0	french	0
2779	8507	1970	11	15	1970-11-15 00:00:00	8515	0	\N	\N	\N	83de89a4-2246-4fc2-bdaf-67a0246efc81	M	0	asian	0	asian_indian	0
4295	8507	1971	9	22	1971-09-22 00:00:00	8527	0	\N	\N	\N	cc3c3e5d-554c-4efb-a2a6-c45d1bc10de5	M	0	white	0	irish	0
4024	8532	1979	1	28	1979-01-28 00:00:00	8527	0	\N	\N	\N	bf677629-beb1-406f-b498-9e2791c18717	F	0	white	0	italian	0
3504	8532	1922	2	17	1922-02-17 00:00:00	8527	0	\N	\N	\N	a6ff23c4-3e05-4d39-8abd-b1fb4dddbe8e	F	0	white	0	italian	0
3820	8532	1964	11	20	1964-11-20 00:00:00	8527	0	\N	\N	\N	b57f6ff8-6db7-4507-ae53-63fb5558334b	F	0	white	0	italian	0
3892	8507	1962	6	30	1962-06-30 00:00:00	8527	0	\N	\N	\N	b8e0b167-e309-4918-8e27-37f026243f00	M	0	white	0	irish	0
3442	8532	1960	6	12	1960-06-12 00:00:00	8515	0	\N	\N	\N	a3b7e3b7-3668-4c1e-ab2e-b2fe45bbc7d0	F	0	asian	0	asian_indian	0
4130	8507	1964	11	19	1964-11-19 00:00:00	8527	0	\N	\N	\N	c526a837-c4d0-4ec1-90a2-dd6ee5892a25	M	0	white	0	russian	0
3439	8507	1951	8	30	1951-08-30 00:00:00	8516	0	\N	\N	\N	a387364e-66e9-4240-836f-fecebd6c840f	M	0	black	0	african	0
3630	8532	1955	4	13	1955-04-13 00:00:00	8527	0	\N	\N	\N	aca581ce-0690-4ec1-94b9-0a9992acf73d	F	0	white	0	irish	0
3545	8507	1971	3	3	1971-03-03 00:00:00	0	38003563	\N	\N	\N	a891c4ab-844c-47b2-9a8e-4d77dee9b5df	M	0	hispanic	0	puerto_rican	0
4442	8532	1981	6	15	1981-06-15 00:00:00	0	38003563	\N	\N	\N	d308fd8b-dd31-4d3c-a82c-9bcc55ea9746	F	0	hispanic	0	mexican	0
4428	8532	1949	11	24	1949-11-24 00:00:00	8527	0	\N	\N	\N	d209d0af-4998-4703-99da-aaf04e82fb6d	F	0	white	0	italian	0
3717	8507	1976	5	8	1976-05-08 00:00:00	8516	0	\N	\N	\N	b109c78d-1282-46ba-9b1d-403936cd84df	M	0	black	0	west_indian	0
3636	8532	1972	7	14	1972-07-14 00:00:00	8527	0	\N	\N	\N	ace3b6d6-64ef-4e58-bfd7-9d487958908f	F	0	white	0	russian	0
4491	8532	1946	1	13	1946-01-13 00:00:00	0	38003563	\N	\N	\N	d63d21b0-8357-4805-93f7-2c5867e5f4ec	F	0	hispanic	0	south_american	0
3862	8507	1956	2	1	1956-02-01 00:00:00	8527	0	\N	\N	\N	b7923f4b-daec-4f63-a6c7-197529373872	M	0	white	0	french	0
3618	8532	1910	1	22	1910-01-22 00:00:00	0	38003563	\N	\N	\N	abf6a9b2-4eab-4e68-af44-9ca857be6295	F	0	hispanic	0	puerto_rican	0
4116	8532	1968	10	17	1968-10-17 00:00:00	8515	0	\N	\N	\N	c42494ff-77eb-437e-99c1-21d2f4d08143	F	0	asian	0	asian_indian	0
4127	8532	1947	6	29	1947-06-29 00:00:00	0	38003563	\N	\N	\N	c4c8a07a-a4de-469b-bf02-8ca84e0525c7	F	0	hispanic	0	south_american	0
4105	8507	1947	7	5	1947-07-05 00:00:00	8527	0	\N	\N	\N	c39d8007-9e93-4dd2-aaa9-d7669059363b	M	0	white	0	american	0
3509	8532	1942	1	16	1942-01-16 00:00:00	8527	0	\N	\N	\N	a71b1509-7b79-455f-b980-32d915d5534d	F	0	white	0	irish	0
3568	8507	1969	5	29	1969-05-29 00:00:00	8515	0	\N	\N	\N	a9dc0bc4-ddbe-4b70-8033-b8936915c85b	M	0	asian	0	asian_indian	0
4665	8532	1981	8	15	1981-08-15 00:00:00	0	0	\N	\N	\N	deda4e05-9cd6-4f42-81d1-fe2fa94651f6	F	0	other	0	arab	0
4655	8507	1958	12	14	1958-12-14 00:00:00	0	38003563	\N	\N	\N	de3e8e66-4df7-4c0e-964d-628faa0d47dd	M	0	hispanic	0	south_american	0
4299	8507	1973	2	11	1973-02-11 00:00:00	0	38003563	\N	\N	\N	cc56ca78-e147-4e4e-8a90-a1ef545e699e	M	0	hispanic	0	puerto_rican	0
3601	8532	1959	6	19	1959-06-19 00:00:00	8515	0	\N	\N	\N	ab0f07b6-76ab-4153-929a-3ae994cc27fe	F	0	asian	0	chinese	0
3610	8532	1944	5	6	1944-05-06 00:00:00	8516	0	\N	\N	\N	ab88ef81-3110-4828-897d-bf0c425bbd96	F	0	black	0	west_indian	0
3221	8507	1963	6	1	1963-06-01 00:00:00	8527	0	\N	\N	\N	9932aa97-ebaf-4b48-8e60-2829e0550d05	M	0	white	0	french	0
4393	8532	1984	5	18	1984-05-18 00:00:00	8527	0	\N	\N	\N	d0b9a580-200c-47d2-813b-ef5eae996c1c	F	0	white	0	portuguese	0
3320	8507	1963	8	25	1963-08-25 00:00:00	0	38003563	\N	\N	\N	9df184ea-c394-4332-8933-ba781ce17675	M	0	hispanic	0	central_american	0
3315	8532	1957	4	27	1957-04-27 00:00:00	8527	0	\N	\N	\N	9d94d338-e326-48fe-9e3e-3079334b8293	F	0	white	0	irish	0
3708	8532	1977	5	13	1977-05-13 00:00:00	8527	0	\N	\N	\N	b0b235f2-e23d-4e91-8933-232d5e0a9aab	F	0	white	0	portuguese	0
4348	8507	1981	10	21	1981-10-21 00:00:00	0	38003563	\N	\N	\N	ce616188-2342-4c1a-9da9-b100d670b863	M	0	hispanic	0	puerto_rican	0
3865	8507	1956	6	28	1956-06-28 00:00:00	0	38003563	\N	\N	\N	b7b5b295-78fd-4a08-bcf4-40d6e2a4ade8	M	0	hispanic	0	south_american	0
3767	8507	1985	2	15	1985-02-15 00:00:00	8527	0	\N	\N	\N	b31d0c3c-50a2-4c33-8156-44cbe19c3c9d	M	0	white	0	irish	0
4649	8532	1969	2	10	1969-02-10 00:00:00	8527	0	\N	\N	\N	de0f990c-d207-42c6-baa0-f52c712ee909	F	0	white	0	irish	0
3123	8532	1977	7	6	1977-07-06 00:00:00	8516	0	\N	\N	\N	942ffff9-2a65-4fbe-a6b6-b26e738fb508	F	0	black	0	dominican	0
3701	8532	1952	5	5	1952-05-05 00:00:00	8516	0	\N	\N	\N	b037605d-7a06-4e5d-9fb4-7fa41d5eca9d	F	0	black	0	west_indian	0
3592	8532	1965	1	27	1965-01-27 00:00:00	0	38003563	\N	\N	\N	aab18134-3a75-4a22-954c-67e3dac75fdf	F	0	hispanic	0	puerto_rican	0
4027	8532	1974	1	5	1974-01-05 00:00:00	8527	0	\N	\N	\N	bf94e8c1-8c0e-47c0-935b-3270417c04af	F	0	white	0	french_canadian	0
4411	8532	1945	4	16	1945-04-16 00:00:00	8515	0	\N	\N	\N	d1617f77-257c-4117-a239-39b38b3d84a5	F	0	asian	0	chinese	0
3991	8507	1945	9	29	1945-09-29 00:00:00	8527	0	\N	\N	\N	bdeeed1d-525b-40f0-88ff-47a681d3d182	M	0	white	0	irish	0
4274	8532	1920	11	26	1920-11-26 00:00:00	8527	0	\N	\N	\N	cb55ab59-3617-4cbb-943e-de48b928619f	F	0	white	0	irish	0
4168	8507	1971	4	3	1971-04-03 00:00:00	8527	0	\N	\N	\N	c6b3b206-70de-44b4-b21b-39d5d309b35e	M	0	white	0	russian	0
3458	8507	1979	10	19	1979-10-19 00:00:00	8527	0	\N	\N	\N	a45a63c1-fb91-4ac4-8773-e38e336f813f	M	0	white	0	german	0
4557	8532	1920	4	18	1920-04-18 00:00:00	8527	0	\N	\N	\N	d9c7e92e-8a69-48c9-8842-b3040598e5c4	F	0	white	0	irish	0
4055	8532	1968	11	6	1968-11-06 00:00:00	0	38003563	\N	\N	\N	c0dc3d85-822e-4130-92ae-d8769a7515fd	F	0	hispanic	0	mexican	0
3508	8507	1956	11	28	1956-11-28 00:00:00	8527	0	\N	\N	\N	a7187a71-be76-43c8-b13e-0d558e900977	M	0	white	0	french_canadian	0
3920	8532	1972	8	26	1972-08-26 00:00:00	8515	0	\N	\N	\N	ba8ac233-75cc-4aa3-bb29-dd9a1252fb58	F	0	asian	0	chinese	0
3995	8532	1971	2	13	1971-02-13 00:00:00	8516	0	\N	\N	\N	be19adb3-d9d6-4ffb-8ebe-f2e17eb7ca24	F	0	black	0	african	0
4689	8532	1967	5	10	1967-05-10 00:00:00	0	38003563	\N	\N	\N	dfe2c8b5-a818-487e-8078-14ba44076372	F	0	hispanic	0	puerto_rican	0
4365	8507	1951	7	23	1951-07-23 00:00:00	8527	0	\N	\N	\N	cf4bd165-1fc4-4de2-9251-9080a60c982c	M	0	white	0	german	0
4309	8507	1954	8	4	1954-08-04 00:00:00	8527	0	\N	\N	\N	cd0ea724-5300-4161-8668-eeacf0a40553	M	0	white	0	polish	0
4040	8507	1976	2	9	1976-02-09 00:00:00	0	38003563	\N	\N	\N	bfe8aa41-50a6-4f18-aef0-2d3224c486b2	M	0	hispanic	0	puerto_rican	0
4035	8532	1972	3	21	1972-03-21 00:00:00	8527	0	\N	\N	\N	bfcd4b9a-6353-47d2-97be-43fdf15825e6	F	0	white	0	german	0
4530	8532	1968	5	18	1968-05-18 00:00:00	8527	0	\N	\N	\N	d84a13b1-a6d0-48c3-8145-d3924e19eeb5	F	0	white	0	swedish	0
3707	8532	1969	6	30	1969-06-30 00:00:00	8527	0	\N	\N	\N	b0b1a994-1569-4c48-906f-3f0f9c4ada9f	F	0	white	0	italian	0
3939	8507	1974	1	20	1974-01-20 00:00:00	0	38003563	\N	\N	\N	bbafa93d-158d-4aa8-b15e-42e3c44986ee	M	0	hispanic	0	puerto_rican	0
3278	8507	1960	4	18	1960-04-18 00:00:00	8527	0	\N	\N	\N	9c35b892-6795-4660-90a3-cd791f35a7b0	M	0	white	0	french_canadian	0
3986	8532	1961	8	25	1961-08-25 00:00:00	8527	0	\N	\N	\N	bd969ff3-5c8f-4154-8697-a1cb417ac79e	F	0	white	0	swedish	0
3446	8507	1943	12	13	1943-12-13 00:00:00	8527	0	\N	\N	\N	a3d98a92-a96a-472a-8c52-87ee7edd5b1d	M	0	white	0	french	0
3628	8507	1914	8	29	1914-08-29 00:00:00	0	38003563	\N	\N	\N	ac83ed6d-8038-4d82-8c42-8cb499458f44	M	0	hispanic	0	south_american	0
3773	8507	1958	5	2	1958-05-02 00:00:00	8515	0	\N	\N	\N	b383fef3-b428-4fd5-a6df-dfa8e39cb444	M	0	asian	0	chinese	0
2942	8507	1953	7	29	1953-07-29 00:00:00	8527	0	\N	\N	\N	8b95a12a-19bf-4cf6-b59f-6bc147e12e87	M	0	white	0	swedish	0
4372	8532	1980	5	8	1980-05-08 00:00:00	8527	0	\N	\N	\N	cf9a68f9-8494-4627-a02b-7867ab43e00e	F	0	white	0	irish	0
4246	8507	1966	12	28	1966-12-28 00:00:00	8527	0	\N	\N	\N	ca492c88-15d0-40ff-b8a3-957469a7e029	M	0	white	0	irish	0
3526	8507	1949	12	27	1949-12-27 00:00:00	8527	0	\N	\N	\N	a7ce8cdb-f8dd-43c2-b0fa-d80e7a2026e1	M	0	white	0	american	0
3913	8507	1962	10	18	1962-10-18 00:00:00	0	38003563	\N	\N	\N	b9f5aa82-95d2-4d20-a236-1b5f4edef6f6	M	0	hispanic	0	south_american	0
3906	8507	1942	10	21	1942-10-21 00:00:00	8527	0	\N	\N	\N	b9920b9e-f263-443a-ae5b-c77d9cc33d34	M	0	white	0	german	0
3486	8532	1959	12	25	1959-12-25 00:00:00	0	38003563	\N	\N	\N	a5f0e7f8-d24a-4954-a70e-8d87453cc8df	F	0	hispanic	0	mexican	0
4381	8507	1964	6	2	1964-06-02 00:00:00	8516	0	\N	\N	\N	d028edf5-e7dd-400b-bb7a-97125efbfc30	M	0	black	0	west_indian	0
3573	8532	1923	4	28	1923-04-28 00:00:00	0	38003563	\N	\N	\N	aa1e1ed6-bf7b-496b-b274-06b9da2e3b5a	F	0	hispanic	0	central_american	0
3672	8507	1963	3	18	1963-03-18 00:00:00	0	38003563	\N	\N	\N	aed04281-fcf0-46e7-9c18-70d8d82f33ba	M	0	hispanic	0	mexican	0
3593	8532	1952	3	19	1952-03-19 00:00:00	8527	0	\N	\N	\N	aacd132f-b06c-4dc4-8cf9-24857e2b2f06	F	0	white	0	italian	0
4534	8507	1943	10	27	1943-10-27 00:00:00	8515	0	\N	\N	\N	d87b5a00-e864-42ab-9f09-d3fb3b636103	M	0	asian	0	chinese	0
4720	8532	1976	6	15	1976-06-15 00:00:00	8527	0	\N	\N	\N	e126af30-eb10-4a52-8ec1-48ca8009d869	F	0	white	0	polish	0
3827	8532	1956	11	23	1956-11-23 00:00:00	0	38003563	\N	\N	\N	b5d66ea7-5ea1-4763-9a47-6f0b36d3a7c5	F	0	hispanic	0	central_american	0
3650	8532	1926	7	30	1926-07-30 00:00:00	8527	0	\N	\N	\N	adb950e4-3a5c-48e6-965e-60dac53da41f	F	0	white	0	english	0
4653	8507	1959	2	22	1959-02-22 00:00:00	8527	0	\N	\N	\N	de2a3a01-e103-4ebe-ab91-ce6c773a2a9d	M	0	white	0	irish	0
3936	8532	1958	3	10	1958-03-10 00:00:00	8527	0	\N	\N	\N	bb6ae5f4-4e32-40dd-b067-0816d8b722bf	F	0	white	0	american	0
3668	8532	1975	8	31	1975-08-31 00:00:00	8515	0	\N	\N	\N	ae98070c-46f2-4be9-be6c-3f4983ecb117	F	0	asian	0	chinese	0
4194	8507	1976	4	26	1976-04-26 00:00:00	8527	0	\N	\N	\N	c7e0bc04-49cd-4ed6-9496-6136b423f32b	M	0	white	0	english	0
4229	8507	1952	6	21	1952-06-21 00:00:00	8527	0	\N	\N	\N	c9b54163-942c-4525-8a02-4082a3cea640	M	0	white	0	irish	0
4223	8507	1957	1	25	1957-01-25 00:00:00	8527	0	\N	\N	\N	c9784abc-e29d-4247-aaed-9beb59695cb2	M	0	white	0	polish	0
3603	8507	1966	2	6	1966-02-06 00:00:00	8527	0	\N	\N	\N	ab1c53df-de29-40ca-bc5f-edbe4332ffd2	M	0	white	0	irish	0
3616	8532	1958	2	25	1958-02-25 00:00:00	8527	0	\N	\N	\N	abcf944e-a562-4351-9d9d-95234617fc8c	F	0	white	0	italian	0
4771	8532	1953	2	21	1953-02-21 00:00:00	8527	0	\N	\N	\N	e48a2a74-9f22-46a4-9132-7f19466e1309	F	0	white	0	english	0
5002	8507	1976	4	9	1976-04-09 00:00:00	8516	0	\N	\N	\N	ef04ee7b-c01c-49a1-8179-d51639fcf052	M	0	black	0	west_indian	0
4376	8532	1920	6	1	1920-06-01 00:00:00	8527	0	\N	\N	\N	cfc48b84-d01c-4596-8947-197603dbd199	F	0	white	0	irish	0
3928	8507	1979	12	9	1979-12-09 00:00:00	8527	0	\N	\N	\N	baf509db-3df7-437f-ba12-4783dc0ff334	M	0	white	0	polish	0
3830	8507	1981	8	17	1981-08-17 00:00:00	8527	0	\N	\N	\N	b5f3e6e0-f472-48c2-9931-5e1655a1b283	M	0	white	0	irish	0
3376	8532	1953	3	27	1953-03-27 00:00:00	8527	0	\N	\N	\N	a0568ea2-2cc4-4801-ada7-deccc24684eb	F	0	white	0	english	0
4447	8532	1951	8	21	1951-08-21 00:00:00	8515	0	\N	\N	\N	d3488157-070c-4676-ad9f-65d1f591f94e	F	0	asian	0	asian_indian	0
3371	8532	1975	8	15	1975-08-15 00:00:00	8527	0	\N	\N	\N	a013ed4f-dfd6-45c6-b00e-94ba07e53ab5	F	0	white	0	irish	0
3414	8507	1967	3	30	1967-03-30 00:00:00	8516	0	\N	\N	\N	a243858b-d6d9-4ef4-b32e-72367ee61a97	M	0	black	0	dominican	0
3728	8532	1972	1	16	1972-01-16 00:00:00	8527	0	\N	\N	\N	b1809e9a-1e69-4645-a80b-6d34d08c1e30	F	0	white	0	italian	0
4547	8532	1908	10	18	1908-10-18 00:00:00	8527	0	\N	\N	\N	d92ae5ae-e2d9-4b63-b03b-c06c332d29a6	F	0	white	0	portuguese	0
3951	8532	1943	9	25	1943-09-25 00:00:00	8527	0	\N	\N	\N	bc43c275-b043-40da-bb26-ccfb70aa40d2	F	0	white	0	irish	0
3777	8507	1984	4	26	1984-04-26 00:00:00	8516	0	\N	\N	\N	b3a85aa9-4d54-4d8f-8fcf-dbb6afe3371e	M	0	black	0	west_indian	0
4805	8507	1962	4	27	1962-04-27 00:00:00	8527	0	\N	\N	\N	e60d6b28-31a8-491e-b5ac-98b43c95c7ea	M	0	white	0	italian	0
3141	8507	1971	2	7	1971-02-07 00:00:00	8527	0	\N	\N	\N	95561d09-6dce-454a-af8b-c25453d18326	M	0	white	0	italian	0
3823	8532	1954	10	13	1954-10-13 00:00:00	8516	0	\N	\N	\N	b5a920a2-801f-4b41-b2e5-39d3f716b7a4	F	0	black	0	african	0
3730	8532	1954	4	1	1954-04-01 00:00:00	8527	0	\N	\N	\N	b18ddd92-88e2-45b3-ba38-01c5688b0948	F	0	white	0	irish	0
4045	8532	1974	2	16	1974-02-16 00:00:00	8527	0	\N	\N	\N	c01fb1ad-715d-4036-bc4f-b35e41923292	F	0	white	0	portuguese	0
4513	8507	1961	12	20	1961-12-20 00:00:00	8527	0	\N	\N	\N	d774ab39-104e-4010-a299-a06ec99628c8	M	0	white	0	italian	0
4131	8532	1976	6	11	1976-06-11 00:00:00	8527	0	\N	\N	\N	c558d108-0de0-4272-a2b6-362e14eb859b	F	0	white	0	french	0
4375	8532	1927	7	10	1927-07-10 00:00:00	8515	0	\N	\N	\N	cfba1e00-41ac-4a8c-ac13-839879342ec6	F	0	asian	0	chinese	0
4260	8532	1937	1	5	1937-01-05 00:00:00	8527	0	\N	\N	\N	cadfaca5-e5e3-483a-b406-c9153c9d5c5c	F	0	white	0	irish	0
3572	8507	1956	3	21	1956-03-21 00:00:00	8527	0	\N	\N	\N	aa00f14f-6fda-4608-93b1-dcdbd1bbb579	M	0	white	0	polish	0
4637	8507	1974	1	21	1974-01-21 00:00:00	8527	0	\N	\N	\N	dd22bcc6-02c1-474e-b897-9f418a2e62bd	M	0	white	0	irish	0
4117	8532	1962	12	14	1962-12-14 00:00:00	8516	0	\N	\N	\N	c43cf255-61e2-4563-bfb3-14b7b572d9ff	F	0	black	0	west_indian	0
3720	8507	1954	4	6	1954-04-06 00:00:00	8527	0	\N	\N	\N	b131f847-c76b-4db5-82f7-4300d2f53f1e	M	0	white	0	scottish	0
4222	8532	1949	6	16	1949-06-16 00:00:00	8527	0	\N	\N	\N	c978152b-0864-4050-81ab-2b69266dc3d3	F	0	white	0	english	0
4077	8507	1971	2	1	1971-02-01 00:00:00	0	38003563	\N	\N	\N	c1a03e3b-d610-4968-9e8d-a644dfbcde99	M	0	hispanic	0	south_american	0
4811	8507	1962	4	16	1962-04-16 00:00:00	8527	0	\N	\N	\N	e635fc09-3d7c-42ee-a8c2-0e1af2297a8f	M	0	white	0	american	0
4475	8507	1978	5	22	1978-05-22 00:00:00	8527	0	\N	\N	\N	d4f17fed-6423-433a-9e02-0c67efae3875	M	0	white	0	irish	0
4586	8532	1956	10	28	1956-10-28 00:00:00	0	38003563	\N	\N	\N	db06ec3a-8a1b-44ab-b435-52ef87a7f79c	F	0	hispanic	0	puerto_rican	0
4106	8532	1944	3	3	1944-03-03 00:00:00	8515	0	\N	\N	\N	c39f7914-9e34-4cf3-b9e6-91b3a83b3d6f	F	0	asian	0	asian_indian	0
4333	8532	1953	8	27	1953-08-27 00:00:00	8527	0	\N	\N	\N	cde239bd-9aef-4305-b930-86ff626a4131	F	0	white	0	italian	0
4548	8507	1983	10	18	1983-10-18 00:00:00	8527	0	\N	\N	\N	d9352701-0749-40a9-a029-ecb8a3bb4200	M	0	white	0	irish	0
3890	8532	1952	7	22	1952-07-22 00:00:00	8515	0	\N	\N	\N	b8c54295-8bfe-4dd3-8942-221d611e031f	F	0	asian	0	asian_indian	0
4173	8507	1963	8	14	1963-08-14 00:00:00	8527	0	\N	\N	\N	c6efd93a-bf2d-4d32-bd18-21f5cd4c480e	M	0	white	0	french_canadian	0
3435	8532	1975	4	26	1975-04-26 00:00:00	8527	0	\N	\N	\N	a32d05fb-a27d-48ba-81dc-497927480d60	F	0	white	0	french	0
4134	8507	1949	7	3	1949-07-03 00:00:00	8516	0	\N	\N	\N	c577e5fb-5870-4ec6-9e5f-e30a9e10333b	M	0	black	0	dominican	0
3644	8507	1947	1	22	1947-01-22 00:00:00	8527	0	\N	\N	\N	ad6909a6-1a49-46af-8044-9e4dfe631eec	M	0	white	0	english	0
3776	8532	1973	6	2	1973-06-02 00:00:00	8527	0	\N	\N	\N	b399ce94-7120-4fc3-9e3d-dad6d580b99a	F	0	white	0	irish	0
3787	8507	1961	11	11	1961-11-11 00:00:00	8527	0	\N	\N	\N	b3fdba19-61fd-4f27-b578-a926c45720ba	M	0	white	0	irish	0
3044	8507	1969	1	21	1969-01-21 00:00:00	8527	0	\N	\N	\N	8fce6deb-2cd1-4b1d-ae69-16195039099a	M	0	white	0	american	0
4450	8507	1967	8	12	1967-08-12 00:00:00	8527	0	\N	\N	\N	d36b3cf4-6da4-4099-8807-e1f9474911db	M	0	white	0	irish	0
4320	8532	1970	3	29	1970-03-29 00:00:00	8527	0	\N	\N	\N	cd82bdc3-f576-459e-82a2-d704d60db187	F	0	white	0	italian	0
3680	8507	1979	4	3	1979-04-03 00:00:00	0	38003563	\N	\N	\N	af17e592-fb79-4c72-a2aa-3311b3bebb4d	M	0	hispanic	0	puerto_rican	0
4005	8507	1969	6	21	1969-06-21 00:00:00	8527	0	\N	\N	\N	beb38bee-fa6f-4393-bfb3-9ad92de98ac2	M	0	white	0	irish	0
4014	8507	1967	11	26	1967-11-26 00:00:00	8515	0	\N	\N	\N	bef54904-fd0a-416a-841b-cf099e231613	M	0	asian	0	chinese	0
3560	8507	1960	5	4	1960-05-04 00:00:00	8515	0	\N	\N	\N	a9506c56-1b53-43db-84c5-7fdbc5ed9c03	M	0	asian	0	asian_indian	0
4459	8507	1963	10	22	1963-10-22 00:00:00	8527	0	\N	\N	\N	d4362745-d85f-40ce-86ae-f6ea45d53c60	M	0	white	0	american	0
3621	8507	1922	2	11	1922-02-11 00:00:00	8527	0	\N	\N	\N	ac149866-e0c5-4701-93f6-70d519c866ad	M	0	white	0	italian	0
3778	8507	1964	10	4	1964-10-04 00:00:00	8527	0	\N	\N	\N	b3afafe6-91fa-4752-a539-7e49e5267490	M	0	white	0	irish	0
3731	8507	1973	12	22	1973-12-22 00:00:00	8527	0	\N	\N	\N	b195810c-7dbd-4f7b-ac8a-06912c7cb0f9	M	0	white	0	german	0
4544	8532	1939	10	24	1939-10-24 00:00:00	8515	0	\N	\N	\N	d9003828-e4a6-4707-890c-9421507cc600	F	0	asian	0	chinese	0
4764	8507	1968	8	21	1968-08-21 00:00:00	8527	0	\N	\N	\N	e3f29988-4888-4834-9276-834ac2ca1262	M	0	white	0	irish	0
3926	8532	1947	9	29	1947-09-29 00:00:00	8515	0	\N	\N	\N	baddcc37-ecc6-4aa4-b3c7-e63970d9b0e8	F	0	asian	0	chinese	0
3851	8532	1911	5	1	1911-05-01 00:00:00	8516	0	\N	\N	\N	b6f307fe-44a1-4b85-ae17-135e1b0e78a0	F	0	black	0	west_indian	0
4791	8507	1967	5	25	1967-05-25 00:00:00	8515	0	\N	\N	\N	e5864a3c-2afb-4032-aa8f-3c64181e1387	M	0	asian	0	asian_indian	0
3980	8532	1974	10	27	1974-10-27 00:00:00	0	38003563	\N	\N	\N	bd55f9c1-bdcd-462f-83a3-e1985974f866	F	0	hispanic	0	puerto_rican	0
3790	8507	1963	7	1	1963-07-01 00:00:00	8516	0	\N	\N	\N	b400a8c6-cc77-4614-9757-3ff1cf0309f9	M	0	black	0	african	0
4238	8532	1961	8	31	1961-08-31 00:00:00	0	38003563	\N	\N	\N	c9f33138-1ea1-46af-be69-f511d4ac8fa2	F	0	hispanic	0	south_american	0
4384	8507	1967	4	17	1967-04-17 00:00:00	8515	0	\N	\N	\N	d04b0b94-668a-49a7-aa26-0a10b3158f2b	M	0	asian	0	chinese	0
4243	8507	1968	1	19	1968-01-19 00:00:00	8527	0	\N	\N	\N	ca26ee8f-4bbe-4552-84db-13fd9c4c5136	M	0	white	0	italian	0
3721	8532	1963	11	15	1963-11-15 00:00:00	0	38003563	\N	\N	\N	b13904ff-9de6-43c1-a026-a28477ac977f	F	0	hispanic	0	puerto_rican	0
3788	8507	1964	8	11	1964-08-11 00:00:00	8515	0	\N	\N	\N	b3feb1a3-ebcb-4b25-a947-b472bd93946f	M	0	asian	0	asian_indian	0
4976	8532	1912	11	12	1912-11-12 00:00:00	8527	0	\N	\N	\N	edf52287-e0d2-4c36-9654-17b954237a0a	F	0	white	0	irish	0
5116	8507	1964	5	29	1964-05-29 00:00:00	0	38003563	\N	\N	\N	f4d94a8f-77c1-4f56-85f1-2f6d809e5f64	M	0	hispanic	0	puerto_rican	0
4462	8532	1955	2	3	1955-02-03 00:00:00	8527	0	\N	\N	\N	d4512aae-f999-4183-b554-c5ab5f45e3dd	F	0	white	0	polish	0
4020	8507	1956	3	1	1956-03-01 00:00:00	8527	0	\N	\N	\N	bf41be4c-5a03-473a-b447-afdcaeba5e30	M	0	white	0	german	0
4107	8507	1971	2	8	1971-02-08 00:00:00	8527	0	\N	\N	\N	c3a8bfa9-0950-4fa2-83be-8eb640f57515	M	0	white	0	french	0
3734	8532	1948	7	17	1948-07-17 00:00:00	8527	0	\N	\N	\N	b19ff8e2-36fd-44ff-b46a-fbd2f075ddf9	F	0	white	0	italian	0
4531	8507	1914	8	29	1914-08-29 00:00:00	0	38003563	\N	\N	\N	d86a04a8-cb13-4409-945f-c8f4ba14a89d	M	0	hispanic	0	south_american	0
3505	8507	1937	2	5	1937-02-05 00:00:00	8515	0	\N	\N	\N	a7001230-1f19-4c03-83a4-a45176353169	M	0	asian	0	chinese	0
3514	8532	1974	8	19	1974-08-19 00:00:00	8516	0	\N	\N	\N	a7517364-4cec-4fdc-b838-0a8fe902a770	F	0	black	0	african	0
3814	8532	1974	12	1	1974-12-01 00:00:00	8527	0	\N	\N	\N	b52e94ef-aa98-4a4d-b301-11845cdc607b	F	0	white	0	irish	0
4709	8507	1956	5	7	1956-05-07 00:00:00	8527	0	\N	\N	\N	e0c7db5c-8295-4f5a-89f6-ecc4a5a19bfd	M	0	white	0	scottish	0
4085	8507	1958	10	4	1958-10-04 00:00:00	8527	0	\N	\N	\N	c269d711-0949-4d84-9909-1e683c7d5dec	M	0	white	0	american	0
3976	8507	1963	4	18	1963-04-18 00:00:00	8527	0	\N	\N	\N	bd174358-f63a-4db7-938d-4d96dd5d64c2	M	0	white	0	irish	0
4886	8532	1965	9	6	1965-09-06 00:00:00	8515	0	\N	\N	\N	ea2a59b1-bd93-4dd4-93f9-d8c088fef710	F	0	asian	0	chinese	0
3241	8532	1961	3	30	1961-03-30 00:00:00	8527	0	\N	\N	\N	9a21eaba-3ff0-4fcc-a2eb-ebe769295c88	F	0	white	0	english	0
3900	8532	1967	7	4	1967-07-04 00:00:00	0	38003563	\N	\N	\N	b9394b2b-37e6-4d9b-bc5c-b1945e5d2ad0	F	0	hispanic	0	south_american	0
3895	8532	1923	6	8	1923-06-08 00:00:00	8527	0	\N	\N	\N	b900e62b-178c-4057-a06f-6acfa30d76f3	F	0	white	0	irish	0
4217	8532	1958	8	13	1958-08-13 00:00:00	8515	0	\N	\N	\N	c93b2065-055b-4041-bb66-cd563504b091	F	0	asian	0	chinese	0
4615	8532	1955	4	20	1955-04-20 00:00:00	8516	0	\N	\N	\N	dc5c6dda-5968-469d-bf90-a96985ef6151	F	0	black	0	west_indian	0
4380	8507	1964	4	20	1964-04-20 00:00:00	8516	0	\N	\N	\N	d01bd1e0-4cf9-44f7-b46e-8e9ceef79f65	M	0	black	0	west_indian	0
4493	8507	1982	6	22	1982-06-22 00:00:00	8516	0	\N	\N	\N	d66439d9-9edd-4c7f-a065-a83b911c39f5	M	0	black	0	dominican	0
4353	8532	1966	8	7	1966-08-07 00:00:00	8516	0	\N	\N	\N	cec6d06e-df3c-4a41-bcaa-82f9865cb44a	F	0	black	0	west_indian	0
3666	8507	1959	12	31	1959-12-31 00:00:00	8515	0	\N	\N	\N	ae892d1a-4db1-49d9-9284-1de9cd3eb4d9	M	0	asian	0	asian_indian	0
4715	8532	1950	8	9	1950-08-09 00:00:00	0	38003563	\N	\N	\N	e0fbbe87-9c63-46e6-a3fb-b25f85d45558	F	0	hispanic	0	south_american	0
4239	8532	1948	9	25	1948-09-25 00:00:00	8527	0	\N	\N	\N	ca007fed-49da-4bcc-96c0-377deee5cbd8	F	0	white	0	greek	0
3885	8532	1962	11	16	1962-11-16 00:00:00	8527	0	\N	\N	\N	b887a5f2-0ffd-43ee-b707-7ab22df3f900	F	0	white	0	american	0
4324	8507	1961	6	11	1961-06-11 00:00:00	8516	0	\N	\N	\N	cd8bcd4f-5e02-4e26-9ebb-746cbb21c23e	M	0	black	0	african	0
4143	8532	1961	9	29	1961-09-29 00:00:00	0	38003563	\N	\N	\N	c5d71157-e1d0-4c64-9f9b-f75d5c30c239	F	0	hispanic	0	puerto_rican	0
5108	8507	1961	1	22	1961-01-22 00:00:00	8515	0	\N	\N	\N	f45c004b-cbcc-4c50-8aa1-5559e4485845	M	0	asian	0	chinese	0
4503	8507	1935	12	24	1935-12-24 00:00:00	8527	0	\N	\N	\N	d6f86517-1f02-427f-a678-e2c963993fa6	M	0	white	0	portuguese	0
4666	8532	1972	7	3	1972-07-03 00:00:00	8527	0	\N	\N	\N	dee05f0d-9c2b-45ef-8389-b049a4f9eccb	F	0	white	0	american	0
4220	8507	1941	12	30	1941-12-30 00:00:00	8527	0	\N	\N	\N	c95e574d-6fd4-4457-9ccd-c39d3755570b	M	0	white	0	portuguese	0
4562	8507	1961	1	28	1961-01-28 00:00:00	8527	0	\N	\N	\N	da1a89a1-4c80-4735-b3ed-d81166930e7b	M	0	white	0	irish	0
4628	8507	1968	9	29	1968-09-29 00:00:00	8527	0	\N	\N	\N	dce8fc85-12e7-487b-b13a-bebe2e1722e4	M	0	white	0	greek	0
4124	8507	1972	6	24	1972-06-24 00:00:00	8527	0	\N	\N	\N	c498dd8d-701d-4e6b-94f2-d51e0dfe08dc	M	0	white	0	italian	0
4466	8507	1971	10	1	1971-10-01 00:00:00	8516	0	\N	\N	\N	d482e7b4-28c5-475b-8576-1fe48c3bb977	M	0	black	0	african	0
3569	8532	1958	11	4	1958-11-04 00:00:00	0	38003563	\N	\N	\N	a9e1bfc2-fdc1-4e22-bfc6-c2e859cdc506	F	0	hispanic	0	mexican	0
4176	8507	1918	4	4	1918-04-04 00:00:00	0	38003563	\N	\N	\N	c6fe0eba-fad0-4867-bd39-42e6d7e97234	M	0	hispanic	0	puerto_rican	0
3658	8507	1960	12	4	1960-12-04 00:00:00	8516	0	\N	\N	\N	adfae529-dfa0-431b-9647-d990f7b4dad5	M	0	black	0	west_indian	0
3859	8532	1922	9	16	1922-09-16 00:00:00	8527	0	\N	\N	\N	b73de705-f341-4e4f-8556-2fd12448aba4	F	0	white	0	irish	0
3864	8507	1965	4	10	1965-04-10 00:00:00	8527	0	\N	\N	\N	b7a909a0-3b76-4c6d-9e35-8acb3b761fec	M	0	white	0	polish	0
3240	8507	1946	1	23	1946-01-23 00:00:00	0	38003563	\N	\N	\N	9a1acff2-34d2-4a2f-aa0c-1ddb1ae88b1c	M	0	hispanic	0	south_american	0
4804	8532	1977	3	21	1977-03-21 00:00:00	8527	0	\N	\N	\N	e5f5f9ed-55b5-4edf-90b2-d0917f9160b1	F	0	white	0	irish	0
4403	8532	1935	3	2	1935-03-02 00:00:00	8516	0	\N	\N	\N	d0fac4ad-8cb3-4765-b1b0-8e5e4f774468	F	0	black	0	african	0
3834	8507	1955	7	17	1955-07-17 00:00:00	8527	0	\N	\N	\N	b61fbd0e-cdb3-4a12-b9f9-549fe8687620	M	0	white	0	french_canadian	0
4051	8507	1974	1	16	1974-01-16 00:00:00	8527	0	\N	\N	\N	c0b9e319-5ce0-475c-acd2-709c4b3be8ab	M	0	white	0	polish	0
4122	8532	1969	1	15	1969-01-15 00:00:00	0	38003563	\N	\N	\N	c488b0f5-e49c-45e2-b315-c389de3d7fd1	F	0	hispanic	0	puerto_rican	0
3746	8532	1943	12	9	1943-12-09 00:00:00	8527	0	\N	\N	\N	b2518c9c-78b1-45da-9208-347b1faa98a2	F	0	white	0	french_canadian	0
4487	8507	1948	3	12	1948-03-12 00:00:00	8527	0	\N	\N	\N	d5cd05f2-98b3-4bfc-97c4-303c74f57e7e	M	0	white	0	irish	0
3667	8532	1967	7	11	1967-07-11 00:00:00	8527	0	\N	\N	\N	ae97ec7f-360b-46c6-81d8-e3362b22c2ed	F	0	white	0	irish	0
3857	8532	1944	1	4	1944-01-04 00:00:00	8516	0	\N	\N	\N	b7201757-68bd-4513-8128-735991c16824	F	0	black	0	african	0
3813	8532	1971	10	9	1971-10-09 00:00:00	0	38003563	\N	\N	\N	b52b91cf-9fc1-4fe0-9968-5aaafd150563	F	0	hispanic	0	puerto_rican	0
4860	8532	1978	9	29	1978-09-29 00:00:00	8527	0	\N	\N	\N	e8d48b7c-12a3-459a-bf09-a05c9ede5043	F	0	white	0	english	0
4943	8532	1961	2	1	1961-02-01 00:00:00	8527	0	\N	\N	\N	ec5c5bdb-d2f2-4397-b347-44ce6a3f68f2	F	0	white	0	italian	0
4026	8507	1958	1	26	1958-01-26 00:00:00	0	38003563	\N	\N	\N	bf8e0581-ddf0-4231-8a8d-f7a8d647e000	M	0	hispanic	0	puerto_rican	0
4071	8532	1952	10	2	1952-10-02 00:00:00	8527	0	\N	\N	\N	c1707f4b-ebe4-4185-ba52-abca8d388f8a	F	0	white	0	english	0
4801	8532	1971	7	24	1971-07-24 00:00:00	8515	0	\N	\N	\N	e5d7d6ce-cca1-4019-a515-d56bd3ec7303	F	0	asian	0	chinese	0
4090	8507	1942	3	23	1942-03-23 00:00:00	8527	0	\N	\N	\N	c2a69eaa-1629-4683-b006-36ac2c736e05	M	0	white	0	english	0
3869	8532	1909	4	17	1909-04-17 00:00:00	8527	0	\N	\N	\N	b7d5235c-cb72-4cd0-9f3a-b69e4716ae05	F	0	white	0	irish	0
4395	8532	1947	1	10	1947-01-10 00:00:00	8527	0	\N	\N	\N	d0c5de1a-e1d0-46af-b387-ca78afe5fe3f	F	0	white	0	english	0
4538	8532	1953	5	15	1953-05-15 00:00:00	8527	0	\N	\N	\N	d8a3b961-fa01-429e-a721-cc7a6bbc12b9	F	0	white	0	portuguese	0
4325	8532	1965	3	23	1965-03-23 00:00:00	0	38003563	\N	\N	\N	cd922409-b401-4383-9926-d7b95c4eb477	F	0	hispanic	0	central_american	0
3839	8532	1950	10	23	1950-10-23 00:00:00	8527	0	\N	\N	\N	b6608a23-e1b0-4e9e-8c40-a757c90b3e86	F	0	white	0	english	0
3871	8507	1962	9	12	1962-09-12 00:00:00	8527	0	\N	\N	\N	b7e9798b-fc06-45a2-b982-412e6c4a9dbb	M	0	white	0	german	0
5194	8532	1945	6	21	1945-06-21 00:00:00	8527	0	\N	\N	\N	f90d2f14-30fc-4017-beed-3a2e7f9be846	F	0	white	0	irish	0
4482	8507	1950	7	22	1950-07-22 00:00:00	8527	0	\N	\N	\N	d58a2221-0e8e-42ce-8f37-16429dd00e7f	M	0	white	0	german	0
4214	8507	1972	11	28	1972-11-28 00:00:00	8516	0	\N	\N	\N	c90ff3d6-5547-419b-b1ad-6b91ef53b509	M	0	black	0	west_indian	0
4241	8532	1964	10	27	1964-10-27 00:00:00	8516	0	\N	\N	\N	ca21971e-2ddf-4aa0-8987-8d9561f27a92	F	0	black	0	african	0
3891	8507	1982	11	24	1982-11-24 00:00:00	8527	0	\N	\N	\N	b8de40fb-ce87-4b42-adba-86f5ee3510a8	M	0	white	0	french	0
4707	8507	1973	9	6	1973-09-06 00:00:00	8527	0	\N	\N	\N	e09cad55-17fb-41d0-8675-4f69de2d4c12	M	0	white	0	french_canadian	0
3527	8507	1961	7	13	1961-07-13 00:00:00	8527	0	\N	\N	\N	a7e5614d-ce18-423f-a271-dc671ae9477f	M	0	white	0	irish	0
3532	8507	1970	7	12	1970-07-12 00:00:00	8527	0	\N	\N	\N	a8019edd-bf6c-49c2-9900-ecda11e155d0	M	0	white	0	american	0
3893	8507	1971	10	15	1971-10-15 00:00:00	8527	0	\N	\N	\N	b8eb7c7b-2f8e-4a68-90c9-3b9fb33e4e8b	M	0	white	0	polish	0
4745	8532	1975	4	2	1975-04-02 00:00:00	8516	0	\N	\N	\N	e2f2113d-4e5d-40e8-b6c0-e75306266212	F	0	black	0	dominican	0
4269	8532	1968	5	1	1968-05-01 00:00:00	8516	0	\N	\N	\N	cb41b3e1-bbd9-4e05-9fad-08fef0a9d7b7	F	0	black	0	african	0
4094	8507	1957	9	12	1957-09-12 00:00:00	8527	0	\N	\N	\N	c2dde754-30d2-4425-beb6-87e2329287d7	M	0	white	0	french	0
4960	8532	1909	4	17	1909-04-17 00:00:00	8527	0	\N	\N	\N	ed3e91c3-6e54-432a-9093-1e4d41069d6f	F	0	white	0	irish	0
3295	8532	1942	5	11	1942-05-11 00:00:00	8527	0	\N	\N	\N	9cc7dd11-ef3f-4c93-bbff-e660d60b0e0f	F	0	white	0	irish	0
4006	8507	1948	12	21	1948-12-21 00:00:00	8527	0	\N	\N	\N	beb3fd55-bf81-4608-894b-d5fdc9d505ba	M	0	white	0	italian	0
4013	8532	1974	11	17	1974-11-17 00:00:00	8527	0	\N	\N	\N	bef15f6d-4f97-4b93-8994-2ece5bb920d7	F	0	white	0	irish	0
4522	8532	1976	1	9	1976-01-09 00:00:00	8515	0	\N	\N	\N	d7f9340c-80db-41d5-9af3-bf59bad84f20	F	0	asian	0	chinese	0
4843	8507	1962	2	20	1962-02-20 00:00:00	8527	0	\N	\N	\N	e7f8ea92-b909-4c89-8e29-2a8fe497660b	M	0	white	0	portuguese	0
4694	8532	1981	8	9	1981-08-09 00:00:00	0	38003563	\N	\N	\N	e00556eb-229a-4121-8ff9-d61edf836e52	F	0	hispanic	0	mexican	0
4603	8507	1930	10	16	1930-10-16 00:00:00	8527	0	\N	\N	\N	dbcced98-e853-4958-85ec-bd9a8f2985ce	M	0	white	0	portuguese	0
4471	8532	1960	7	11	1960-07-11 00:00:00	8527	0	\N	\N	\N	d4c28efa-1608-4be4-9f6b-0d2c0f7a501b	F	0	white	0	portuguese	0
3784	8532	1930	7	8	1930-07-08 00:00:00	8516	0	\N	\N	\N	b3dc7447-651d-47cf-b3df-c325ef587b9a	F	0	black	0	dominican	0
4898	8532	1953	3	18	1953-03-18 00:00:00	8527	0	\N	\N	\N	eaa51a75-f501-49ad-a350-224807d54d15	F	0	white	0	english	0
4394	8532	1970	3	2	1970-03-02 00:00:00	0	38003563	\N	\N	\N	d0ba2d30-7bf3-486d-950c-cf83bfb071e3	F	0	hispanic	0	puerto_rican	0
4033	8507	1969	10	14	1969-10-14 00:00:00	8527	0	\N	\N	\N	bfc2c0f8-c6ec-4e97-8fd6-c3ea59d26192	M	0	white	0	french	0
4525	8507	1968	1	31	1968-01-31 00:00:00	8527	0	\N	\N	\N	d81ad069-d567-4969-9846-c231441eefca	M	0	white	0	english	0
4291	8507	1973	11	23	1973-11-23 00:00:00	8527	0	\N	\N	\N	cc12c2c7-9769-4781-b605-711ab9083a77	M	0	white	0	french	0
4577	8507	1983	7	9	1983-07-09 00:00:00	8527	0	\N	\N	\N	dabbc458-36e7-4be4-8469-c7c7e30de5ec	M	0	white	0	english	0
4822	8532	1947	9	24	1947-09-24 00:00:00	8516	0	\N	\N	\N	e69b114b-bbc8-4453-bf61-7d01f6731da3	F	0	black	0	west_indian	0
4240	8507	1941	7	21	1941-07-21 00:00:00	8516	0	\N	\N	\N	ca1488e3-c076-4160-b759-f287e8b8a11a	M	0	black	0	dominican	0
4724	8532	1941	5	7	1941-05-07 00:00:00	8516	0	\N	\N	\N	e167ce9e-76f6-475f-8e4e-2ab5481e1a64	F	0	black	0	african	0
4750	8532	1963	4	10	1963-04-10 00:00:00	0	38003563	\N	\N	\N	e33e83bc-5096-4f46-9470-e879573f6c2d	F	0	hispanic	0	puerto_rican	0
4202	8507	1971	5	15	1971-05-15 00:00:00	8527	0	\N	\N	\N	c84d99bc-d145-4ea0-b4df-8f212e0b8cd0	M	0	white	0	scottish	0
4820	8532	1955	10	27	1955-10-27 00:00:00	8527	0	\N	\N	\N	e6822267-b471-4e00-a466-18e04f02a634	F	0	white	0	american	0
3771	8532	1964	1	28	1964-01-28 00:00:00	8527	0	\N	\N	\N	b3478ed2-f89a-42ae-8795-26c3b73c0876	F	0	white	0	polish	0
4284	8532	1942	12	3	1942-12-03 00:00:00	8527	0	\N	\N	\N	cbc4b818-73db-46c3-8a04-73994689addd	F	0	white	0	irish	0
3750	8532	1960	1	23	1960-01-23 00:00:00	8527	0	\N	\N	\N	b2838fd2-a6a1-4038-80b8-7364d50c4915	F	0	white	0	italian	0
3941	8532	1963	1	22	1963-01-22 00:00:00	0	38003563	\N	\N	\N	bbd44579-ccec-485e-a89b-f0d4a85379fb	F	0	hispanic	0	puerto_rican	0
3950	8507	1970	10	1	1970-10-01 00:00:00	8527	0	\N	\N	\N	bc3cc27f-cf84-415e-8fe4-24feb1b233d5	M	0	white	0	english	0
3294	8507	1949	10	18	1949-10-18 00:00:00	8527	0	\N	\N	\N	9cbb5e61-ec40-44d9-8a11-d74d7f127d4d	M	0	white	0	american	0
5005	8532	1973	7	1	1973-07-01 00:00:00	8527	0	\N	\N	\N	ef55fb02-9d2d-43af-8ead-7529aa63c19d	F	0	white	0	french_canadian	0
4521	8507	1918	4	4	1918-04-04 00:00:00	0	38003563	\N	\N	\N	d7f2d9ca-1d0e-40bd-8ba5-b22d76ba1548	M	0	hispanic	0	puerto_rican	0
3881	8507	1955	8	26	1955-08-26 00:00:00	0	38003563	\N	\N	\N	b8525f7a-636e-43c5-8ab6-33ecf05be29f	M	0	hispanic	0	puerto_rican	0
4113	8532	1958	4	7	1958-04-07 00:00:00	8516	0	\N	\N	\N	c4105858-dd42-4cac-86e1-78870297a9b6	F	0	black	0	west_indian	0
4204	8507	1950	8	14	1950-08-14 00:00:00	8527	0	\N	\N	\N	c866f15b-bec5-4af9-9623-cadf6f995829	M	0	white	0	french_canadian	0
3796	8507	1967	11	14	1967-11-14 00:00:00	8527	0	\N	\N	\N	b4434cce-897b-4ec6-9e93-78843b460a27	M	0	white	0	american	0
4593	8532	1963	9	12	1963-09-12 00:00:00	8527	0	\N	\N	\N	db599c70-aeed-4a64-9d5f-c2e3acfd96f5	F	0	white	0	french	0
3866	8532	1949	10	11	1949-10-11 00:00:00	8527	0	\N	\N	\N	b7c17701-9611-4370-a1b6-1be6db1469e0	F	0	white	0	french	0
3943	8532	1952	2	14	1952-02-14 00:00:00	8515	0	\N	\N	\N	bbdde718-ecbc-4959-a3f4-1f0e2e4130c7	F	0	asian	0	chinese	0
3904	8532	1979	2	22	1979-02-22 00:00:00	8527	0	\N	\N	\N	b9673d9c-8210-4820-a30c-dd6da3001743	F	0	white	0	italian	0
5045	8532	1960	4	2	1960-04-02 00:00:00	8527	0	\N	\N	\N	f13b8638-e3a6-4fc8-9d20-ab9825a956f9	F	0	white	0	irish	0
5077	8507	1965	3	17	1965-03-17 00:00:00	8527	0	\N	\N	\N	f2891cbb-e849-491b-8f88-1dfe2013a401	M	0	white	0	italian	0
4044	8507	1959	9	6	1959-09-06 00:00:00	8527	0	\N	\N	\N	c0139c73-8fcb-4652-91de-8500440f12b5	M	0	white	0	english	0
4133	8532	1976	7	30	1976-07-30 00:00:00	8516	0	\N	\N	\N	c574eaf9-ed46-47dc-af3b-4ff048320313	F	0	black	0	west_indian	0
4964	8532	1960	2	13	1960-02-13 00:00:00	8516	0	\N	\N	\N	ed64acc7-0cd3-429c-b6b7-dd0902079b57	F	0	black	0	west_indian	0
4308	8532	1912	8	21	1912-08-21 00:00:00	8527	0	\N	\N	\N	cd071bef-c939-4654-b89e-46a6bc5b2f64	F	0	white	0	irish	0
4081	8507	1955	7	11	1955-07-11 00:00:00	8516	0	\N	\N	\N	c1f5d28a-401a-4b29-bd6d-0adee4af6085	M	0	black	0	african	0
4529	8532	1963	11	17	1963-11-17 00:00:00	8527	0	\N	\N	\N	d8449299-f3b1-433d-8dda-b6868b117d9f	F	0	white	0	swedish	0
4636	8532	1946	6	18	1946-06-18 00:00:00	8527	0	\N	\N	\N	dd051e52-3be2-4cc0-978a-21503fd7c663	F	0	white	0	portuguese	0
4406	8532	1941	11	22	1941-11-22 00:00:00	8527	0	\N	\N	\N	d11a01f9-67f6-4ee6-aeef-44eda36d7ec9	F	0	white	0	italian	0
3884	8507	1972	3	27	1972-03-27 00:00:00	8527	0	\N	\N	\N	b88041d2-f718-4c64-8eac-dfd1c0be992d	M	0	white	0	american	0
3973	8507	1968	7	25	1968-07-25 00:00:00	8527	0	\N	\N	\N	bd04f0d1-8349-414e-96cf-1fa7c64fcc9e	M	0	white	0	irish	0
5328	8532	1909	9	29	1909-09-29 00:00:00	0	38003563	\N	\N	\N	ff4ebaea-8d68-4238-ac2c-ceecafb4a62f	F	0	hispanic	0	central_american	0
4596	8507	1938	6	26	1938-06-26 00:00:00	8516	0	\N	\N	\N	db7e0e8e-9cbb-40d3-a78b-76b30e0eb86f	M	0	black	0	dominican	0
4250	8532	1945	3	3	1945-03-03 00:00:00	8527	0	\N	\N	\N	ca902572-3c9e-4ab4-a56f-b1b643aa04d0	F	0	white	0	french	0
4418	8507	1951	7	27	1951-07-27 00:00:00	8527	0	\N	\N	\N	d1902f29-6666-41e8-99b7-7ad9f0b18b1b	M	0	white	0	irish	0
3909	8532	1961	8	18	1961-08-18 00:00:00	8527	0	\N	\N	\N	b9d88549-38b8-447c-9c53-3ffee219b170	F	0	white	0	polish	0
5222	8507	1917	7	19	1917-07-19 00:00:00	8527	0	\N	\N	\N	fac21316-61c3-4698-81fe-d1ef7550a589	M	0	white	0	swedish	0
3725	8507	1968	3	7	1968-03-07 00:00:00	8527	0	\N	\N	\N	b173f7a5-7abf-4906-8999-83a66f774cf0	M	0	white	0	russian	0
3612	8532	1959	12	20	1959-12-20 00:00:00	0	38003563	\N	\N	\N	aba15d09-2343-4ce0-9ca7-f970beb996e0	F	0	hispanic	0	puerto_rican	0
4123	8507	1961	6	25	1961-06-25 00:00:00	8516	0	\N	\N	\N	c494acb1-c240-4ae5-a4cb-9130478f4b07	M	0	black	0	west_indian	0
5046	8507	1958	1	13	1958-01-13 00:00:00	8516	0	\N	\N	\N	f13de570-361a-49e6-96f7-bf75da593977	M	0	black	0	african	0
4498	8532	1977	5	24	1977-05-24 00:00:00	8527	0	\N	\N	\N	d682d673-18f8-45de-80bb-607b1d0f5018	F	0	white	0	italian	0
4156	8507	1956	6	25	1956-06-25 00:00:00	8527	0	\N	\N	\N	c68ae867-d3c5-4428-a74e-f0f4b1781da3	M	0	white	0	polish	0
5004	8507	1977	3	8	1977-03-08 00:00:00	8527	0	\N	\N	\N	ef493ed1-6286-4a3b-9b2a-496e82e830e9	M	0	white	0	irish	0
3552	8507	1956	11	15	1956-11-15 00:00:00	8527	0	\N	\N	\N	a8d2462c-e04e-4546-a9cd-dbc841032b12	M	0	white	0	french	0
4625	8532	1960	5	18	1960-05-18 00:00:00	8527	0	\N	\N	\N	dcd4547f-5613-4eeb-ad5d-68273c5fb816	F	0	white	0	italian	0
4121	8532	1920	4	18	1920-04-18 00:00:00	8527	0	\N	\N	\N	c47aeb9d-2847-4ee7-9cee-a1d201e1b6b5	F	0	white	0	irish	0
4572	8507	1976	1	13	1976-01-13 00:00:00	8515	0	\N	\N	\N	da8b8ebf-cf7c-480e-b3bf-8c848fcc17ae	M	0	asian	0	chinese	0
4942	8532	1954	4	29	1954-04-29 00:00:00	8527	0	\N	\N	\N	ec5b9df1-5ffc-4165-b15b-28f1b5bacf19	F	0	white	0	irish	0
4812	8532	1954	10	13	1954-10-13 00:00:00	8516	0	\N	\N	\N	e6378849-56b8-459c-a715-da79b7f74114	F	0	black	0	african	0
4701	8532	1970	11	27	1970-11-27 00:00:00	8516	0	\N	\N	\N	e056d526-5d9a-44bf-9ee9-ce1fe065341d	F	0	black	0	dominican	0
3949	8507	1969	3	17	1969-03-17 00:00:00	0	38003563	\N	\N	\N	bc39e18f-229c-4a89-8abe-940dfe2ce3f9	M	0	hispanic	0	central_american	0
5048	8532	1958	10	24	1958-10-24 00:00:00	0	38003563	\N	\N	\N	f15d7597-974b-4cc3-9cc8-9d0f5158d64d	F	0	hispanic	0	puerto_rican	0
4550	8507	1962	9	9	1962-09-09 00:00:00	8527	0	\N	\N	\N	d96a02bf-a7ca-4460-bb3b-2ec1287e1cdb	M	0	white	0	irish	0
4412	8507	1963	8	2	1963-08-02 00:00:00	8527	0	\N	\N	\N	d16b6633-7783-411c-8e91-c36d92f89a53	M	0	white	0	irish	0
4571	8532	1954	6	26	1954-06-26 00:00:00	8516	0	\N	\N	\N	da899bca-9bb9-45d2-b3ab-1e94cec7ede6	F	0	black	0	west_indian	0
4454	8507	1919	11	1	1919-11-01 00:00:00	8516	0	\N	\N	\N	d3ae6f8a-25b5-436a-b212-8b20853c139b	M	0	black	0	dominican	0
4657	8532	1960	10	7	1960-10-07 00:00:00	8527	0	\N	\N	\N	de5bff81-c00f-427d-b31a-e3b2ae95c082	F	0	white	0	italian	0
4979	8532	1976	7	23	1976-07-23 00:00:00	8516	0	\N	\N	\N	edff7d93-967b-4db2-b181-43a84a09d0ad	F	0	black	0	west_indian	0
4405	8507	1964	2	17	1964-02-17 00:00:00	0	38003563	\N	\N	\N	d1155992-02c6-40c1-bf21-89e59b514516	M	0	hispanic	0	puerto_rican	0
4760	8507	1954	10	27	1954-10-27 00:00:00	0	38003563	\N	\N	\N	e3a7f832-3823-4d28-a88e-f6ff108811e1	M	0	hispanic	0	puerto_rican	0
4907	8532	1946	2	2	1946-02-02 00:00:00	8527	0	\N	\N	\N	eb0284c2-6fea-427b-8642-3f66ba0c6f1e	F	0	white	0	portuguese	0
4387	8507	1964	8	21	1964-08-21 00:00:00	0	38003563	\N	\N	\N	d06b0a96-d8b5-4a10-bdcd-f1ec76892d77	M	0	hispanic	0	central_american	0
4977	8532	1959	12	18	1959-12-18 00:00:00	0	38003563	\N	\N	\N	edf55fe5-5228-47fa-b8db-8576e65d428c	F	0	hispanic	0	puerto_rican	0
3789	8532	1944	5	18	1944-05-18 00:00:00	8527	0	\N	\N	\N	b400a35b-ebad-4af1-8ba3-eb5bae0de6df	F	0	white	0	irish	0
4691	8532	1960	5	7	1960-05-07 00:00:00	8527	0	\N	\N	\N	dff97de2-d01d-4f00-8f7b-07798571a9c7	F	0	white	0	french	0
3843	8532	1968	12	8	1968-12-08 00:00:00	8516	0	\N	\N	\N	b68f7ee7-00a2-4802-aa83-c6342bb41182	F	0	black	0	dominican	0
4305	8532	1957	11	22	1957-11-22 00:00:00	8515	0	\N	\N	\N	cceb0916-9be1-49d8-afd5-6b7148e8473a	F	0	asian	0	chinese	0
4084	8532	1961	8	20	1961-08-20 00:00:00	8515	0	\N	\N	\N	c24dbbb5-b6c6-4a45-be5b-c0aca1c45c3c	F	0	asian	0	chinese	0
3553	8532	1930	11	8	1930-11-08 00:00:00	8527	0	\N	\N	\N	a8deb824-677e-4aae-befe-8708f6e4a704	F	0	white	0	italian	0
5165	8532	1963	12	13	1963-12-13 00:00:00	8527	0	\N	\N	\N	f7c38a2a-6055-4b3c-824b-6052954cf430	F	0	white	0	irish	0
4623	8532	1929	5	14	1929-05-14 00:00:00	8527	0	\N	\N	\N	dcb4e06c-313a-443b-88d2-12e9bb0be8f1	F	0	white	0	italian	0
3935	8507	1945	1	3	1945-01-03 00:00:00	0	38003563	\N	\N	\N	bb682f97-153c-4ba8-8b13-c19453122ab5	M	0	hispanic	0	puerto_rican	0
4199	8532	1938	4	28	1938-04-28 00:00:00	8527	0	\N	\N	\N	c8197401-5e31-4e3c-8b07-936134fdb19d	F	0	white	0	french_canadian	0
4224	8507	1946	1	9	1946-01-09 00:00:00	8527	0	\N	\N	\N	c97edd8e-094d-420b-9be9-f6eb38193b9f	M	0	white	0	english	0
3997	8532	1966	11	21	1966-11-21 00:00:00	8527	0	\N	\N	\N	be1d1895-e3f7-45f2-a2e9-d5f9aa5dff9a	F	0	white	0	polish	0
4641	8532	1967	7	13	1967-07-13 00:00:00	8527	0	\N	\N	\N	dd457076-883f-480c-bf7c-591a3dd5b009	F	0	white	0	italian	0
3968	8507	1913	8	1	1913-08-01 00:00:00	8527	0	\N	\N	\N	bcdc048c-ea89-44c2-86f9-127f0f7f5137	M	0	white	0	irish	0
4159	8532	1956	1	28	1956-01-28 00:00:00	0	38003563	\N	\N	\N	c690dd04-8d39-4587-8a97-93da48c3efff	F	0	hispanic	0	central_american	0
4206	8507	1943	9	6	1943-09-06 00:00:00	8516	0	\N	\N	\N	c88ce49b-fb97-4656-8ddb-a5f8f17c11be	M	0	black	0	african	0
5123	8532	1979	5	28	1979-05-28 00:00:00	8516	0	\N	\N	\N	f59cf20a-2d06-49ce-9ab2-f39045835df8	F	0	black	0	african	0
4401	8532	1969	1	4	1969-01-04 00:00:00	8527	0	\N	\N	\N	d0e91e9e-4909-4e0d-912f-2ff0cd554b91	F	0	white	0	german	0
4297	8532	1973	1	6	1973-01-06 00:00:00	8515	0	\N	\N	\N	cc45406d-05b1-4bfb-8f53-657f79f5ca9c	F	0	asian	0	asian_indian	0
5000	8507	1938	8	23	1938-08-23 00:00:00	0	38003563	\N	\N	\N	eee4f5a1-4d05-41a7-bf1b-1dcfbb975841	M	0	hispanic	0	central_american	0
4359	8532	1943	2	10	1943-02-10 00:00:00	8527	0	\N	\N	\N	cf02eb9b-f8a3-4315-bb5e-c5e1653c3128	F	0	white	0	italian	0
4165	8532	1911	6	18	1911-06-18 00:00:00	8527	0	\N	\N	\N	c6aeaae7-fb89-4f75-81a8-f36858f93e5c	F	0	white	0	english	0
4551	8507	1977	1	26	1977-01-26 00:00:00	8527	0	\N	\N	\N	d98b5bf3-894f-4b81-beb4-59d65a361265	M	0	white	0	swedish	0
4848	8532	1952	9	14	1952-09-14 00:00:00	0	38003563	\N	\N	\N	e8438fd4-44c6-48db-abbc-8739a1603678	F	0	hispanic	0	puerto_rican	0
4570	8507	1937	1	23	1937-01-23 00:00:00	8527	0	\N	\N	\N	da6a60fd-7aa3-428e-b101-86eee90c5e7a	M	0	white	0	english	0
3930	8507	1914	8	29	1914-08-29 00:00:00	0	38003563	\N	\N	\N	bb2208e3-af1d-48ab-b5d7-27d861265f82	M	0	hispanic	0	south_american	0
4145	8507	1974	7	7	1974-07-07 00:00:00	8527	0	\N	\N	\N	c61fdadf-d51a-409e-aab6-5f76d76d1e2a	M	0	white	0	english	0
4644	8507	1962	7	5	1962-07-05 00:00:00	8527	0	\N	\N	\N	dd710e42-0442-47a6-8e81-68af144bbeda	M	0	white	0	irish	0
4563	8532	1963	12	13	1963-12-13 00:00:00	8527	0	\N	\N	\N	da1d8920-7fc6-4a48-931e-a1fafbe88c12	F	0	white	0	german	0
4526	8507	1953	10	9	1953-10-09 00:00:00	8527	0	\N	\N	\N	d81ed8af-8c82-4b37-83b1-51fec029bbae	M	0	white	0	english	0
4009	8532	1950	8	9	1950-08-09 00:00:00	0	38003563	\N	\N	\N	bebede3e-b9c0-4c89-8077-c789b2d32e4a	F	0	hispanic	0	south_american	0
5258	8532	1958	7	30	1958-07-30 00:00:00	8527	0	\N	\N	\N	fbb5d25d-2aaa-48c5-b040-c33e0bfa7e46	F	0	white	0	italian	0
3835	8532	1965	9	18	1965-09-18 00:00:00	8527	0	\N	\N	\N	b635ad73-b70c-4cb7-850d-797918992d7c	F	0	white	0	english	0
3718	8532	1965	10	25	1965-10-25 00:00:00	0	38003563	\N	\N	\N	b10b36cb-c70f-4e96-b814-7ed233b78442	F	0	hispanic	0	central_american	0
4205	8532	1972	1	8	1972-01-08 00:00:00	8527	0	\N	\N	\N	c87817bb-70e9-46fe-825d-7faca09b725b	F	0	white	0	american	0
5056	8532	1938	2	24	1938-02-24 00:00:00	8515	0	\N	\N	\N	f1c2b561-4a0b-4d1b-a3af-a883a7c6b636	F	0	asian	0	asian_indian	0
4580	8532	1966	3	1	1966-03-01 00:00:00	8515	0	\N	\N	\N	dad5f947-18cd-4a3e-b699-a60ebd93cd09	F	0	asian	0	asian_indian	0
4304	8507	1966	9	11	1966-09-11 00:00:00	8515	0	\N	\N	\N	cce1e494-2a65-49d6-af68-82b93fdb8f42	M	0	asian	0	chinese	0
5210	8507	1971	12	7	1971-12-07 00:00:00	0	38003563	\N	\N	\N	fa088069-f077-4224-bbc2-a32682a1f4da	M	0	hispanic	0	central_american	0
3654	8507	1971	7	3	1971-07-03 00:00:00	8527	0	\N	\N	\N	addd4b33-fe0c-42e7-b323-1efd2b15c8e9	M	0	white	0	irish	0
4861	8507	1946	6	4	1946-06-04 00:00:00	8527	0	\N	\N	\N	e8de2be1-6118-4c92-a431-052137d7a3bc	M	0	white	0	italian	0
4227	8532	1955	2	13	1955-02-13 00:00:00	8527	0	\N	\N	\N	c9963453-f945-431a-87a6-4a2a1c191712	F	0	white	0	italian	0
4758	8507	1958	3	9	1958-03-09 00:00:00	8527	0	\N	\N	\N	e3a1d7e3-f588-4adf-a6d4-2f7111206b71	M	0	white	0	french	0
5076	8507	1938	3	8	1938-03-08 00:00:00	8527	0	\N	\N	\N	f27644bf-2052-45d2-b2b3-4c771614d343	M	0	white	0	irish	0
5107	8507	1975	6	7	1975-06-07 00:00:00	8527	0	\N	\N	\N	f44fd146-d0ed-43c9-aa95-c314111c9b29	M	0	white	0	italian	0
4807	8532	1945	3	29	1945-03-29 00:00:00	8527	0	\N	\N	\N	e61a5498-e44a-4d6d-b0db-39bf35c954aa	F	0	white	0	italian	0
4087	8507	1977	10	19	1977-10-19 00:00:00	8527	0	\N	\N	\N	c2792829-2a99-46db-a36b-17435185e2ff	M	0	white	0	russian	0
5144	8532	1937	4	24	1937-04-24 00:00:00	8516	0	\N	\N	\N	f694aaa5-9a55-4b7c-a99d-ca709ac9d338	F	0	black	0	african	0
4630	8532	1955	1	27	1955-01-27 00:00:00	8515	0	\N	\N	\N	dcecbc75-64af-426b-858c-830540d426b3	F	0	asian	0	chinese	0
4560	8507	1967	11	1	1967-11-01 00:00:00	0	38003563	\N	\N	\N	d9d82dc4-1a6a-4cf0-825f-ff8747d4a786	M	0	hispanic	0	central_american	0
4753	8532	1961	6	7	1961-06-07 00:00:00	0	38003563	\N	\N	\N	e35216cd-b223-4159-9eda-30f7725093bd	F	0	hispanic	0	puerto_rican	0
4490	8507	1924	12	27	1924-12-27 00:00:00	8527	0	\N	\N	\N	d624428e-4125-499b-af5f-0be7296c431b	M	0	white	0	italian	0
4829	8532	1971	12	10	1971-12-10 00:00:00	0	38003563	\N	\N	\N	e73712c0-7865-4120-84dd-b27ac02cd7ef	F	0	hispanic	0	puerto_rican	0
5023	8507	1972	8	6	1972-08-06 00:00:00	8527	0	\N	\N	\N	f05d8f1a-d7f2-43d4-b157-124095d52fc7	M	0	white	0	swedish	0
4419	8507	1955	8	22	1955-08-22 00:00:00	8527	0	\N	\N	\N	d1956bab-c4ec-4be5-8721-41c09596b43c	M	0	white	0	portuguese	0
5031	8532	1920	2	7	1920-02-07 00:00:00	8527	0	\N	\N	\N	f098073a-d3f6-43b0-b5af-b2da2cf4eff0	F	0	white	0	french	0
4957	8532	1971	10	2	1971-10-02 00:00:00	8527	0	\N	\N	\N	ed0618b7-9f4f-480b-a5ef-7a045708236b	F	0	white	0	italian	0
4437	8507	1969	1	8	1969-01-08 00:00:00	8527	0	\N	\N	\N	d2d5dfe2-b119-4269-8fbd-4ef544a99289	M	0	white	0	german	0
5099	8532	1943	3	6	1943-03-06 00:00:00	8527	0	\N	\N	\N	f4027816-9251-4790-800f-1f379462852f	F	0	white	0	scottish	0
3972	8507	1959	1	11	1959-01-11 00:00:00	8527	0	\N	\N	\N	bcfe0f0a-bd56-4a1b-afec-de7cdc24fe93	M	0	white	0	scottish	0
4799	8532	1957	11	16	1957-11-16 00:00:00	0	38003563	\N	\N	\N	e5c0513b-e3a9-42d5-89f2-fca07a31e623	F	0	hispanic	0	puerto_rican	0
3957	8532	1955	9	22	1955-09-22 00:00:00	8527	0	\N	\N	\N	bc8bd2c8-0b9f-416f-85ec-7de56db042eb	F	0	white	0	french_canadian	0
4504	8507	1966	11	19	1966-11-19 00:00:00	8527	0	\N	\N	\N	d6f9b7dd-cda2-42dd-9f84-e95cc3d76029	M	0	white	0	french	0
4160	8532	1962	7	5	1962-07-05 00:00:00	8516	0	\N	\N	\N	c690f77e-3c59-41cf-bbe1-fea8e22d3cc2	F	0	black	0	dominican	0
3633	8507	1972	5	28	1972-05-28 00:00:00	8527	0	\N	\N	\N	acbdcd20-c94a-4d0e-b00e-b8b30e9f6ee6	M	0	white	0	german	0
4729	8532	1963	2	1	1963-02-01 00:00:00	0	38003563	\N	\N	\N	e1e6e131-a094-4506-a04a-dae4c4ab97a0	F	0	hispanic	0	mexican	0
4019	8507	1962	11	27	1962-11-27 00:00:00	8515	0	\N	\N	\N	bf3e6fb8-0210-43e2-ad9c-ee1beccc334a	M	0	asian	0	asian_indian	0
4235	8507	1979	3	1	1979-03-01 00:00:00	8515	0	\N	\N	\N	c9e22b5a-001a-47f7-8554-10e0f9f04bfc	M	0	asian	0	asian_indian	0
4342	8532	1957	7	5	1957-07-05 00:00:00	8527	0	\N	\N	\N	ce1cdc76-3591-4562-ac46-a261d0a7c51a	F	0	white	0	irish	0
4137	8507	1961	1	25	1961-01-25 00:00:00	0	38003563	\N	\N	\N	c59809e7-f002-4b9f-998a-4679a4875c53	M	0	hispanic	0	puerto_rican	0
4795	8532	1965	11	3	1965-11-03 00:00:00	8527	0	\N	\N	\N	e5a3a760-d516-4eee-8e65-29cdc4548c1e	F	0	white	0	french	0
4086	8532	1972	11	29	1972-11-29 00:00:00	8527	0	\N	\N	\N	c26bf749-f50f-470b-a70e-a7da0719adf4	F	0	white	0	portuguese	0
4261	8532	1922	3	12	1922-03-12 00:00:00	0	38003563	\N	\N	\N	cae60398-f221-4dcf-b810-88243f903466	F	0	hispanic	0	puerto_rican	0
4226	8532	1962	11	18	1962-11-18 00:00:00	8527	0	\N	\N	\N	c98abea1-fb9f-42cd-a420-6f91313dd775	F	0	white	0	french	0
4423	8507	1975	8	22	1975-08-22 00:00:00	8527	0	\N	\N	\N	d1cc98fe-d26e-4944-a01f-3a6221573e7f	M	0	white	0	russian	0
4460	8532	1940	4	8	1940-04-08 00:00:00	8527	0	\N	\N	\N	d4459c66-3393-4b8c-9114-ff525dd1ac8c	F	0	white	0	irish	0
5118	8507	1967	7	19	1967-07-19 00:00:00	8516	0	\N	\N	\N	f5388f83-da83-4236-9efb-6da36bdcfef3	M	0	black	0	african	0
4465	8507	1973	1	26	1973-01-26 00:00:00	8527	0	\N	\N	\N	d46a25b0-df00-4464-9bfc-512f5a59c732	M	0	white	0	portuguese	0
4319	8507	1977	12	7	1977-12-07 00:00:00	8527	0	\N	\N	\N	cd62c69d-7f33-4615-9a6d-3c4785679a28	M	0	white	0	irish	0
4631	8507	1913	8	8	1913-08-08 00:00:00	0	38003563	\N	\N	\N	dcf0a918-fb26-4da7-9aa0-3875d5f0d4b5	M	0	hispanic	0	puerto_rican	0
4899	8532	1920	6	1	1920-06-01 00:00:00	8527	0	\N	\N	\N	eaada151-53a6-46ea-bc93-78a9a3a189e1	F	0	white	0	irish	0
4732	8507	1955	7	24	1955-07-24 00:00:00	8516	0	\N	\N	\N	e25d57ec-0b16-4347-addf-e2a15f1b595d	M	0	black	0	west_indian	0
4022	8532	1959	7	18	1959-07-18 00:00:00	8527	0	\N	\N	\N	bf539838-fe97-400f-b6dc-f93eff635aa6	F	0	white	0	polish	0
4167	8532	1978	9	20	1978-09-20 00:00:00	0	38003563	\N	\N	\N	c6b1fa7d-7a7b-4c62-901c-4337c397ff65	F	0	hispanic	0	mexican	0
4690	8532	1956	6	9	1956-06-09 00:00:00	8527	0	\N	\N	\N	dff13ff5-fb17-4ea7-b879-ef9aeb7b009a	F	0	white	0	american	0
4725	8532	1974	9	23	1974-09-23 00:00:00	8516	0	\N	\N	\N	e1890048-0470-4618-b1b6-305103c709ef	F	0	black	0	african	0
4754	8507	1964	10	20	1964-10-20 00:00:00	0	38003563	\N	\N	\N	e3780262-70ee-4c0a-8b4d-169fb66e1600	M	0	hispanic	0	central_american	0
4125	8507	1967	9	19	1967-09-19 00:00:00	8527	0	\N	\N	\N	c4994c37-dc20-4d4d-9d54-a480571ed476	M	0	white	0	irish	0
3934	8532	1938	11	16	1938-11-16 00:00:00	8515	0	\N	\N	\N	bb4d0d3b-2d9a-4a67-8835-b7a33a7cc1a1	F	0	asian	0	chinese	0
3875	8532	1957	11	23	1957-11-23 00:00:00	8527	0	\N	\N	\N	b81158bc-f074-4956-acbe-b1ce44d9c78b	F	0	white	0	german	0
4225	8507	1979	4	5	1979-04-05 00:00:00	8516	0	\N	\N	\N	c988cd68-05d9-42a4-b47a-36b9b87dd1b1	M	0	black	0	african	0
5142	8507	1945	7	17	1945-07-17 00:00:00	8527	0	\N	\N	\N	f681e198-8c73-4a15-8122-c923eb0baeb8	M	0	white	0	italian	0
4660	8507	1960	12	4	1960-12-04 00:00:00	8515	0	\N	\N	\N	de85e292-7a18-4391-8c98-cce0d3128664	M	0	asian	0	asian_indian	0
4355	8507	1981	4	18	1981-04-18 00:00:00	8527	0	\N	\N	\N	cef4400e-8125-44cd-8cb2-e5b10fc67cfa	M	0	white	0	italian	0
5302	8532	1971	9	3	1971-09-03 00:00:00	8527	0	\N	\N	\N	fd684ddf-894a-4dd4-be56-a2bbdf9f1a14	F	0	white	0	irish	0
3754	8532	1959	1	6	1959-01-06 00:00:00	8527	0	\N	\N	\N	b2a5008d-9977-43be-b25a-2be7db9f404a	F	0	white	0	irish	0
4952	8532	1970	3	21	1970-03-21 00:00:00	8516	0	\N	\N	\N	ecc896c1-a825-4c1a-b034-4a6aada55dcc	F	0	black	0	african	0
4390	8532	1959	2	6	1959-02-06 00:00:00	8515	0	\N	\N	\N	d0898333-866d-4ae5-b71b-b16052fc8d27	F	0	asian	0	chinese	0
4933	8507	1970	3	5	1970-03-05 00:00:00	8527	0	\N	\N	\N	ebfdbc0e-1149-43f1-8469-c30d3e74cf3d	M	0	white	0	american	0
5236	8532	1971	3	10	1971-03-10 00:00:00	8527	0	\N	\N	\N	fb392cf7-683a-4d29-ad1f-c1bd944fd133	F	0	white	0	portuguese	0
5157	8532	1963	4	11	1963-04-11 00:00:00	8527	0	\N	\N	\N	f75cc811-9459-431e-aabf-8f7b38682ceb	F	0	white	0	french	0
4884	8507	1972	10	21	1972-10-21 00:00:00	8527	0	\N	\N	\N	ea154a2b-04cf-4f55-938c-cda6d790d8bd	M	0	white	0	irish	0
4149	8507	1966	2	25	1966-02-25 00:00:00	8527	0	\N	\N	\N	c6493f45-1ea1-4b08-a9ff-3189b396745a	M	0	white	0	french	0
5230	8507	1945	1	3	1945-01-03 00:00:00	0	38003563	\N	\N	\N	fafd107d-e582-45c9-8ec0-dac082542663	M	0	hispanic	0	puerto_rican	0
4704	8532	1965	12	18	1965-12-18 00:00:00	8527	0	\N	\N	\N	e08a21ed-2b4c-49fa-b11c-66d7f4e12ac8	F	0	white	0	russian	0
4608	8532	1954	12	16	1954-12-16 00:00:00	8527	0	\N	\N	\N	dc23e9e8-c788-4451-9725-e7cdffe6fcf4	F	0	white	0	irish	0
4916	8532	1977	7	29	1977-07-29 00:00:00	8515	0	\N	\N	\N	eb4b5d07-4d00-4168-b564-71eb38bcde72	F	0	asian	0	chinese	0
4604	8507	1964	3	1	1964-03-01 00:00:00	8516	0	\N	\N	\N	dbe29d14-a0a0-467b-bdef-85c17a7647fb	M	0	black	0	west_indian	0
4878	8507	1963	1	5	1963-01-05 00:00:00	8527	0	\N	\N	\N	e9c2b297-a33d-471c-b500-4336783320ca	M	0	white	0	italian	0
5097	8507	1967	6	26	1967-06-26 00:00:00	8527	0	\N	\N	\N	f3f9c8ef-ed2c-4cc8-b213-683873f48b20	M	0	white	0	scottish	0
4527	8532	1960	6	10	1960-06-10 00:00:00	8527	0	\N	\N	\N	d8238983-a56a-4c15-ada0-3fdf6a6666e8	F	0	white	0	polish	0
5073	8507	1935	4	13	1935-04-13 00:00:00	0	38003563	\N	\N	\N	f24e6398-16cc-4260-9420-acfbc7ad0e83	M	0	hispanic	0	mexican	0
5041	8532	1970	11	24	1970-11-24 00:00:00	8527	0	\N	\N	\N	f0fbe4f4-4c83-4243-81fc-364c1930cc78	F	0	white	0	italian	0
4559	8532	1944	12	19	1944-12-19 00:00:00	8516	0	\N	\N	\N	d9d0a950-66b9-418a-8cef-2c75f583ea40	F	0	black	0	dominican	0
5195	8507	1960	2	17	1960-02-17 00:00:00	8527	0	\N	\N	\N	f90da16b-1bba-4f79-992a-ccae3b5998ae	M	0	white	0	italian	0
4473	8532	1971	7	25	1971-07-25 00:00:00	8527	0	\N	\N	\N	d4d1843f-dbab-4974-bac9-13c3019a5d76	F	0	white	0	italian	0
4890	8532	1919	11	19	1919-11-19 00:00:00	8527	0	\N	\N	\N	ea380258-2fe9-4536-965f-ff760dec0361	F	0	white	0	irish	0
3993	8532	1936	12	28	1936-12-28 00:00:00	8527	0	\N	\N	\N	bdff733e-8162-412f-8927-7745a6dda9f2	F	0	white	0	english	0
4590	8532	1955	11	14	1955-11-14 00:00:00	8515	0	\N	\N	\N	db49c2d1-7fb2-4a89-915f-91def7884dd9	F	0	asian	0	asian_indian	0
4268	8532	1955	9	12	1955-09-12 00:00:00	0	38003563	\N	\N	\N	cb3e5925-cc46-47aa-9895-f65455ea201c	F	0	hispanic	0	puerto_rican	0
3655	8507	1935	5	2	1935-05-02 00:00:00	0	38003563	\N	\N	\N	adde8c29-ea79-4e58-ac1c-aa819834df80	M	0	hispanic	0	south_american	0
4757	8532	1956	3	28	1956-03-28 00:00:00	8527	0	\N	\N	\N	e3977758-4ac6-4067-87e6-0b3778450adb	F	0	white	0	english	0
4253	8532	1980	12	22	1980-12-22 00:00:00	8516	0	\N	\N	\N	cab2c1ff-94ec-4674-9672-c19a08f7ad7b	F	0	black	0	dominican	0
4349	8507	1982	12	2	1982-12-02 00:00:00	0	38003563	\N	\N	\N	ce72d61b-2008-4a24-b9bf-8ebeeb551be7	M	0	hispanic	0	puerto_rican	0
4435	8507	1961	1	2	1961-01-02 00:00:00	8527	0	\N	\N	\N	d29037e6-0607-4f95-a41a-fb90655b81ab	M	0	white	0	german	0
4191	8532	1957	8	16	1957-08-16 00:00:00	8527	0	\N	\N	\N	c7bea4a6-1008-4313-bffb-013edbef2993	F	0	white	0	irish	0
4270	8507	1967	1	17	1967-01-17 00:00:00	8527	0	\N	\N	\N	cb4be6c7-7e9c-41f6-9250-6bcc73a7f71a	M	0	white	0	irish	0
4352	8532	1948	7	29	1948-07-29 00:00:00	8516	0	\N	\N	\N	cec5c58a-f71e-443b-9039-06a3e7fd0b5e	F	0	black	0	african	0
4340	8507	1972	9	22	1972-09-22 00:00:00	8527	0	\N	\N	\N	ce12821b-44a8-49d1-ae90-a9cabfcfec0f	M	0	white	0	irish	0
4523	8532	1976	1	25	1976-01-25 00:00:00	8527	0	\N	\N	\N	d7fe35b5-6340-4b41-8b54-edabf754ea09	F	0	white	0	irish	0
4480	8532	1961	1	31	1961-01-31 00:00:00	8527	0	\N	\N	\N	d5570e99-c69a-48d8-b879-0aebd1524cf9	F	0	white	0	italian	0
5298	8507	1940	4	28	1940-04-28 00:00:00	8527	0	\N	\N	\N	fd50f9fb-0b2f-4f20-8716-930afc788d82	M	0	white	0	irish	0
4509	8507	1967	8	29	1967-08-29 00:00:00	0	38003563	\N	\N	\N	d721f387-ab23-4eaa-8f61-2ffd15131a12	M	0	hispanic	0	mexican	0
4364	8507	1950	12	31	1950-12-31 00:00:00	8527	0	\N	\N	\N	cf325a2b-e037-47e6-95d1-4a8f4d94136b	M	0	white	0	irish	0
4705	8532	1972	6	15	1972-06-15 00:00:00	0	38003563	\N	\N	\N	e08bbd5d-a65e-4fbc-85c0-a01164b54d4e	F	0	hispanic	0	puerto_rican	0
4949	8532	1972	9	21	1972-09-21 00:00:00	8516	0	\N	\N	\N	eca4de36-4b09-4a02-96ae-27c35f8b33c3	F	0	black	0	african	0
4917	8507	1982	2	22	1982-02-22 00:00:00	8527	0	\N	\N	\N	eb53ce10-8c60-45bc-b429-cde65db804b4	M	0	white	0	italian	0
4032	8507	1947	6	17	1947-06-17 00:00:00	8527	0	\N	\N	\N	bfbc5e9e-d727-4a7a-bcf9-2ad5a51a9db7	M	0	white	0	polish	0
4317	8507	1947	2	6	1947-02-06 00:00:00	8527	0	\N	\N	\N	cd55f157-bf5f-41ce-8768-795347308561	M	0	white	0	irish	0
5111	8507	1945	5	28	1945-05-28 00:00:00	8516	0	\N	\N	\N	f47e358c-8410-4860-9f4f-e87a63d3b95f	M	0	black	0	dominican	0
4761	8532	1980	5	5	1980-05-05 00:00:00	0	38003563	\N	\N	\N	e3a8dacf-5667-4480-b7d2-ad942492325e	F	0	hispanic	0	puerto_rican	0
4929	8532	1961	12	16	1961-12-16 00:00:00	8527	0	\N	\N	\N	ebe0b841-cab9-40e4-a5bc-0a81dfdc3094	F	0	white	0	irish	0
4337	8532	1961	6	9	1961-06-09 00:00:00	8515	0	\N	\N	\N	cdf65510-abcb-49c1-b2a6-db82de319aa1	F	0	asian	0	asian_indian	0
4018	8532	1963	11	26	1963-11-26 00:00:00	8527	0	\N	\N	\N	bf3adc1f-54a0-4a87-9d45-e97b4d16d4f4	F	0	white	0	french	0
4109	8532	1964	12	1	1964-12-01 00:00:00	8527	0	\N	\N	\N	c3c04eb2-af73-45ab-91f9-3d5ce90b4059	F	0	white	0	american	0
4343	8532	1954	10	18	1954-10-18 00:00:00	8527	0	\N	\N	\N	ce1d954a-3f9e-4243-b1cd-06dee4b53f38	F	0	white	0	irish	0
4674	8532	1968	8	20	1968-08-20 00:00:00	8527	0	\N	\N	\N	df42574f-3576-4439-8073-7c0313ef0913	F	0	white	0	french_canadian	0
4505	8507	1936	7	21	1936-07-21 00:00:00	0	38003563	\N	\N	\N	d6fb01ff-3bcf-42fa-9c9d-77f4947902a2	M	0	hispanic	0	puerto_rican	0
5312	8532	1938	10	31	1938-10-31 00:00:00	8515	0	\N	\N	\N	fe0c310f-75ca-4ad7-ad22-92707d5deb34	F	0	asian	0	asian_indian	0
3804	8507	1959	12	3	1959-12-03 00:00:00	8527	0	\N	\N	\N	b4b26f9a-cd96-4a86-8cd9-4a8edcc5bdc5	M	0	white	0	russian	0
5044	8507	1972	11	15	1972-11-15 00:00:00	8527	0	\N	\N	\N	f132b84c-0b9e-4d1b-8c3b-4c4ed894dc4e	M	0	white	0	english	0
4432	8507	1957	6	25	1957-06-25 00:00:00	8527	0	\N	\N	\N	d226df08-7dc1-4083-b8c8-ac8edc53bc14	M	0	white	0	irish	0
5267	8532	1966	12	4	1966-12-04 00:00:00	8527	0	\N	\N	\N	fc493992-9588-42ea-9049-7dbf5ff21eab	F	0	white	0	swedish	0
5272	8532	1916	7	19	1916-07-19 00:00:00	8515	0	\N	\N	\N	fc7d99df-db59-413d-b8bc-72a5a6d3cada	F	0	asian	0	chinese	0
5203	8507	1935	8	14	1935-08-14 00:00:00	8515	0	\N	\N	\N	f98db258-9d45-47ea-92f5-cc9f77e203e4	M	0	asian	0	asian_indian	0
5166	8507	1952	4	8	1952-04-08 00:00:00	8516	0	\N	\N	\N	f7c3f9f0-ec34-412c-a030-3f67dd776a18	M	0	black	0	dominican	0
4313	8507	1947	7	19	1947-07-19 00:00:00	8515	0	\N	\N	\N	cd2fdc65-7de4-43a2-a8fa-32383b99ad89	M	0	asian	0	chinese	0
4748	8532	1944	10	6	1944-10-06 00:00:00	8527	0	\N	\N	\N	e33415bf-3849-46df-965f-7bb400a4ff8f	F	0	white	0	german	0
4844	8507	1959	2	26	1959-02-26 00:00:00	8527	0	\N	\N	\N	e81c2e21-dcab-4e31-b5a6-5544deb9f9c2	M	0	white	0	american	0
5240	8532	1939	6	27	1939-06-27 00:00:00	8527	0	\N	\N	\N	fb4c9dd6-7977-4ba1-aa91-f935b235bd82	F	0	white	0	italian	0
4800	8507	1970	10	29	1970-10-29 00:00:00	0	38003563	\N	\N	\N	e5c9b805-9e59-49f8-90ce-a79f98d8a548	M	0	hispanic	0	puerto_rican	0
5172	8507	1945	4	3	1945-04-03 00:00:00	8527	0	\N	\N	\N	f83889c3-e197-4b94-9000-b1e8ba0d179c	M	0	white	0	english	0
5193	8507	1960	8	25	1960-08-25 00:00:00	0	38003563	\N	\N	\N	f901f878-00e5-4de6-a6a0-7c2b82961562	M	0	hispanic	0	puerto_rican	0
4569	8507	1962	1	23	1962-01-23 00:00:00	8527	0	\N	\N	\N	da3a8ad8-4976-4974-9da7-3d2e65f6117d	M	0	white	0	polish	0
5127	8507	1965	9	10	1965-09-10 00:00:00	8527	0	\N	\N	\N	f5e25fa7-a83d-4875-9620-d75af2a94542	M	0	white	0	french_canadian	0
5063	8532	1941	4	4	1941-04-04 00:00:00	0	38003563	\N	\N	\N	f1fb1c7f-7e12-47b6-87bc-26c59667fd96	F	0	hispanic	0	puerto_rican	0
4639	8532	1970	2	20	1970-02-20 00:00:00	8527	0	\N	\N	\N	dd309c4c-3a9d-4be7-8c14-7e7616e85789	F	0	white	0	italian	0
5329	8532	1942	12	23	1942-12-23 00:00:00	8527	0	\N	\N	\N	ff59ce67-bd4b-4908-9ccd-e9683a154aad	F	0	white	0	french	0
4501	8532	1972	11	30	1972-11-30 00:00:00	8527	0	\N	\N	\N	d6c44cbf-9a05-461c-8344-ebbf22b5d920	F	0	white	0	irish	0
4972	8507	1951	1	13	1951-01-13 00:00:00	8527	0	\N	\N	\N	edc753a1-2802-4406-865d-33a79fa0cf44	M	0	white	0	italian	0
4279	8507	1950	4	7	1950-04-07 00:00:00	8527	0	\N	\N	\N	cba6b0f7-c722-430f-906f-82950211f63b	M	0	white	0	scottish	0
4670	8532	1954	3	31	1954-03-31 00:00:00	8516	0	\N	\N	\N	df1331fc-e7f4-4fab-9f59-308c0756b8e5	F	0	black	0	african	0
4661	8507	1976	10	14	1976-10-14 00:00:00	8515	0	\N	\N	\N	dec76fd5-14a5-45b8-9956-53c33983a21d	M	0	asian	0	chinese	0
3960	8532	1958	2	15	1958-02-15 00:00:00	0	38003563	\N	\N	\N	bcab1d44-b82e-4cfa-b034-7c4a738368c2	F	0	hispanic	0	puerto_rican	0
4835	8507	1970	4	30	1970-04-30 00:00:00	8527	0	\N	\N	\N	e78b7cb9-c811-4495-8c4a-37f2b50626a3	M	0	white	0	irish	0
4331	8507	1974	11	15	1974-11-15 00:00:00	8527	0	\N	\N	\N	cdc632e6-a696-46cd-ac41-9f5cfb0cfa4e	M	0	white	0	italian	0
4398	8507	1959	4	18	1959-04-18 00:00:00	0	38003563	\N	\N	\N	d0d7cf27-88fc-4205-a8c0-79e76a9d2c9a	M	0	hispanic	0	central_american	0
4543	8532	1979	9	8	1979-09-08 00:00:00	8527	0	\N	\N	\N	d8f188a2-4ac3-443c-a097-d6d55f0435c8	F	0	white	0	irish	0
4275	8507	1980	1	13	1980-01-13 00:00:00	8516	0	\N	\N	\N	cb576c5f-e9da-4f41-a21a-56bbaab8ab18	M	0	black	0	west_indian	0
4312	8532	1959	9	16	1959-09-16 00:00:00	8527	0	\N	\N	\N	cd26c921-1464-484e-b8e9-10d5c254f74c	F	0	white	0	french_canadian	0
4470	8507	1972	1	9	1972-01-09 00:00:00	8515	0	\N	\N	\N	d4b5f1e8-3e3b-40e9-86e2-807334fbba9d	M	0	asian	0	chinese	0
4391	8507	1941	2	7	1941-02-07 00:00:00	8527	0	\N	\N	\N	d08e64cc-be29-4b9c-8ac6-6037d968d8ff	M	0	white	0	irish	0
4621	8507	1976	7	26	1976-07-26 00:00:00	8527	0	\N	\N	\N	dca1ce78-9513-4796-9740-78bcf1d13306	M	0	white	0	portuguese	0
4646	8507	1943	8	3	1943-08-03 00:00:00	8515	0	\N	\N	\N	ddb9c299-9de8-4d71-b9c5-bf565482fa08	M	0	asian	0	asian_indian	0
5316	8507	1956	8	20	1956-08-20 00:00:00	0	38003563	\N	\N	\N	fe717bb6-32e3-4e91-976b-4974f8362a19	M	0	hispanic	0	south_american	0
4587	8507	1935	4	13	1935-04-13 00:00:00	0	38003563	\N	\N	\N	db13a3e9-212b-43a7-b20b-c49574036785	M	0	hispanic	0	mexican	0
4474	8507	1963	6	7	1963-06-07 00:00:00	8527	0	\N	\N	\N	d4e15c1c-4bfc-4dee-bbdd-935d9162aebc	M	0	white	0	irish	0
4749	8507	1972	10	21	1972-10-21 00:00:00	8527	0	\N	\N	\N	e3345648-10fa-446e-803f-7fbb40d55be9	M	0	white	0	english	0
5049	8507	1962	1	31	1962-01-31 00:00:00	8516	0	\N	\N	\N	f162a3e1-7c05-479d-af03-76b06e4969ef	M	0	black	0	african	0
5039	8507	1974	7	23	1974-07-23 00:00:00	0	38003563	\N	\N	\N	f0df8699-65e1-4b7c-9d67-a18e71003aea	M	0	hispanic	0	south_american	0
4212	8507	1969	10	31	1969-10-31 00:00:00	8527	0	\N	\N	\N	c8fb4323-53e8-4685-8668-af702efb9d65	M	0	white	0	german	0
4366	8532	1981	5	5	1981-05-05 00:00:00	8527	0	\N	\N	\N	cf5478c8-46a7-4c49-a3fc-67edff8a670a	F	0	white	0	swedish	0
5153	8532	1944	12	27	1944-12-27 00:00:00	8527	0	\N	\N	\N	f70d9665-496d-4131-a160-e328f8a4b1ca	F	0	white	0	german	0
4847	8507	1943	6	2	1943-06-02 00:00:00	0	38003563	\N	\N	\N	e8342453-10ef-40de-b545-9dae57236166	M	0	hispanic	0	puerto_rican	0
5037	8532	1977	2	16	1977-02-16 00:00:00	8527	0	\N	\N	\N	f0cec4ee-75cc-42bb-819c-bea4954bbde1	F	0	white	0	french	0
4436	8507	1965	5	28	1965-05-28 00:00:00	8527	0	\N	\N	\N	d2aceb24-7139-4168-aab5-e7e7875a1b11	M	0	white	0	portuguese	0
4102	8532	1965	3	22	1965-03-22 00:00:00	0	38003563	\N	\N	\N	c35379a5-9ac0-4567-9f9c-bd16ba3cd574	F	0	hispanic	0	puerto_rican	0
4247	8507	1983	3	19	1983-03-19 00:00:00	8527	0	\N	\N	\N	ca4f2c4c-0ca1-4c0b-a50e-39357c6fccd3	M	0	white	0	portuguese	0
4388	8507	1966	8	20	1966-08-20 00:00:00	8527	0	\N	\N	\N	d08389ea-078f-4663-86d8-2ab16b13b9ea	M	0	white	0	italian	0
4782	8532	1980	4	29	1980-04-29 00:00:00	8516	0	\N	\N	\N	e52bb896-721a-4954-a691-2b1fca6a5825	F	0	black	0	dominican	0
4591	8507	1952	9	18	1952-09-18 00:00:00	8516	0	\N	\N	\N	db509285-19c1-48ba-bd75-904e882720c9	M	0	black	0	west_indian	0
3961	8532	1973	2	6	1973-02-06 00:00:00	0	38003563	\N	\N	\N	bcb4c58c-8c5b-4811-af2b-8314f87439df	F	0	hispanic	0	puerto_rican	0
5058	8507	1937	2	7	1937-02-07 00:00:00	0	38003563	\N	\N	\N	f1d8e388-8210-4e37-978b-0591955f5b9c	M	0	hispanic	0	puerto_rican	0
4634	8532	1962	11	8	1962-11-08 00:00:00	8527	0	\N	\N	\N	dcfb6a2d-6ba2-43ee-976a-be5d653122a0	F	0	white	0	english	0
5300	8532	1940	12	27	1940-12-27 00:00:00	8527	0	\N	\N	\N	fd604c88-8276-46aa-b04f-a3d93609d81a	F	0	white	0	irish	0
4476	8532	1962	2	18	1962-02-18 00:00:00	8527	0	\N	\N	\N	d50a4b2a-4d7d-44ba-a4bd-da81f91e9a4c	F	0	white	0	italian	0
4905	8532	1972	8	31	1972-08-31 00:00:00	8527	0	\N	\N	\N	eafe4a78-b40f-4542-a533-6da8c4a60457	F	0	white	0	french	0
4927	8532	1977	7	22	1977-07-22 00:00:00	8527	0	\N	\N	\N	ebd69242-ec31-41fb-a93d-132ab80a0bd6	F	0	white	0	italian	0
5268	8532	1965	6	27	1965-06-27 00:00:00	0	38003563	\N	\N	\N	fc4d4a24-a854-4894-a060-7814a4a0cae8	F	0	hispanic	0	puerto_rican	0
4883	8532	1945	12	21	1945-12-21 00:00:00	8527	0	\N	\N	\N	ea0f30e2-275a-4f7c-bc29-bfad3ba8fbcb	F	0	white	0	german	0
5285	8532	1942	12	6	1942-12-06 00:00:00	8515	0	\N	\N	\N	fcbcea23-b321-4601-b9ff-b167a58fe363	F	0	asian	0	asian_indian	0
4735	8532	1973	1	4	1973-01-04 00:00:00	8515	0	\N	\N	\N	e28a7905-685c-48ce-84fe-c6caaeda5a7c	F	0	asian	0	asian_indian	0
5233	8507	1956	9	18	1956-09-18 00:00:00	8527	0	\N	\N	\N	fb09ae9a-42b7-46b8-ace9-299f363bd235	M	0	white	0	italian	0
5137	8532	1967	6	21	1967-06-21 00:00:00	0	38003563	\N	\N	\N	f6428a2c-ae60-48bc-8758-2845b52bf22f	F	0	hispanic	0	south_american	0
4713	8507	1966	1	7	1966-01-07 00:00:00	8527	0	\N	\N	\N	e0eb9009-fd1d-4216-8a89-3016c0b4450e	M	0	white	0	irish	0
4579	8532	1967	7	14	1967-07-14 00:00:00	0	38003563	\N	\N	\N	dace8e88-8b5c-4fb6-af52-ba2d49812e59	F	0	hispanic	0	puerto_rican	0
4992	8532	1985	5	16	1985-05-16 00:00:00	0	38003563	\N	\N	\N	ee86d728-10d7-4c5c-9fa3-e67330389fbd	F	0	hispanic	0	puerto_rican	0
4289	8532	1942	7	19	1942-07-19 00:00:00	8527	0	\N	\N	\N	cc0304d1-1920-464b-aba6-ac938a4bbf61	F	0	white	0	italian	0
4680	8532	1909	4	17	1909-04-17 00:00:00	8527	0	\N	\N	\N	df7adada-495e-47b9-8b6b-c4659eba436c	F	0	white	0	irish	0
4675	8507	1911	7	2	1911-07-02 00:00:00	8527	0	\N	\N	\N	df4f1825-ba34-49a7-9e66-439fde085d6f	M	0	white	0	english	0
4282	8532	1966	4	6	1966-04-06 00:00:00	8527	0	\N	\N	\N	cbb54f34-4fe4-47fb-8077-e70af01d6b4d	F	0	white	0	english	0
5034	8507	1922	2	11	1922-02-11 00:00:00	8527	0	\N	\N	\N	f0a26023-5c86-4571-982e-8710ec7c97bd	M	0	white	0	italian	0
4408	8532	1981	1	22	1981-01-22 00:00:00	8527	0	\N	\N	\N	d139d1de-1b59-4034-a77c-da4c9205b794	F	0	white	0	irish	0
4532	8532	1909	4	17	1909-04-17 00:00:00	8527	0	\N	\N	\N	d87a0a67-a1fc-4b0b-9f9c-1a0bb0542e03	F	0	white	0	irish	0
4633	8507	1958	11	25	1958-11-25 00:00:00	8527	0	\N	\N	\N	dcfb463c-d311-4da7-8ddf-3fbc7f2c3d29	M	0	white	0	italian	0
4374	8532	1976	5	20	1976-05-20 00:00:00	0	38003563	\N	\N	\N	cfb254d9-f8d9-410c-bd26-1930187733b3	F	0	hispanic	0	central_american	0
4477	8532	1963	11	21	1963-11-21 00:00:00	8527	0	\N	\N	\N	d50ca5a2-5080-4212-b0b0-e651143a2527	F	0	white	0	english	0
4506	8507	1953	12	24	1953-12-24 00:00:00	0	0	\N	\N	\N	d7139079-22dd-4327-984e-d953bbf00419	M	0	native	0	american_indian	0
4433	8507	1939	3	18	1939-03-18 00:00:00	0	38003563	\N	\N	\N	d255c43f-6721-4164-89f2-fedc5ae619a5	M	0	hispanic	0	central_american	0
4731	8507	1971	11	2	1971-11-02 00:00:00	8527	0	\N	\N	\N	e20c1a37-a400-4729-9f4a-5e9b2200fb81	M	0	white	0	portuguese	0
4975	8507	1959	7	9	1959-07-09 00:00:00	0	38003563	\N	\N	\N	edea3138-9bb1-4eff-9098-06e0b79b218c	M	0	hispanic	0	puerto_rican	0
4685	8532	1939	9	4	1939-09-04 00:00:00	8527	0	\N	\N	\N	dfae8cff-92c0-49b3-b35b-649d59131848	F	0	white	0	italian	0
4576	8532	1954	10	27	1954-10-27 00:00:00	8527	0	\N	\N	\N	daa5237e-31e7-422c-bfe1-75ce54ee7141	F	0	white	0	swedish	0
4859	8532	1954	4	25	1954-04-25 00:00:00	8527	0	\N	\N	\N	e8c143d0-362f-4309-a240-a067d03a5cf6	F	0	white	0	german	0
5145	8532	1955	9	10	1955-09-10 00:00:00	8527	0	\N	\N	\N	f6a25222-1f35-4661-9c9d-7078c602bae4	F	0	white	0	italian	0
5081	8507	1913	8	8	1913-08-08 00:00:00	0	38003563	\N	\N	\N	f2f8586a-2d06-421f-9dd0-dea6b5b46fcd	M	0	hispanic	0	puerto_rican	0
4413	8532	1960	12	8	1960-12-08 00:00:00	8516	0	\N	\N	\N	d17041f6-c963-4d72-a18d-5605dc316113	F	0	black	0	west_indian	0
4472	8507	1935	4	13	1935-04-13 00:00:00	0	38003563	\N	\N	\N	d4cb64b2-7c28-4eb3-b08d-fb0b80e10523	M	0	hispanic	0	mexican	0
5207	8532	1956	1	11	1956-01-11 00:00:00	8527	0	\N	\N	\N	f9ce6ee8-8b95-4766-aa0e-52e21191d573	F	0	white	0	irish	0
4924	8532	1977	12	14	1977-12-14 00:00:00	8527	0	\N	\N	\N	ebaca7ef-7f16-45a3-a771-235a0d478798	F	0	white	0	greek	0
5083	8507	1947	11	17	1947-11-17 00:00:00	0	38003563	\N	\N	\N	f30ed1b9-7fa4-49de-908d-2dd1816f3d73	M	0	hispanic	0	central_american	0
4712	8507	1968	1	19	1968-01-19 00:00:00	8527	0	\N	\N	\N	e0e5bfb8-857a-4857-8ee5-dead92988a7f	M	0	white	0	irish	0
4208	8532	1938	11	22	1938-11-22 00:00:00	8527	0	\N	\N	\N	c8c1c95e-201d-4985-846e-2652a2eb6f31	F	0	white	0	polish	0
4321	8532	1962	12	30	1962-12-30 00:00:00	0	38003563	\N	\N	\N	cd83dfed-2f05-4453-acca-a929abbf952f	F	0	hispanic	0	puerto_rican	0
4738	8532	1909	9	17	1909-09-17 00:00:00	8527	0	\N	\N	\N	e2a90d95-bd16-486a-9b50-32c6ee430dd6	F	0	white	0	french_canadian	0
5095	8507	1965	1	4	1965-01-04 00:00:00	8515	0	\N	\N	\N	f3ee5912-12c4-42f1-b31c-f98759663973	M	0	asian	0	asian_indian	0
4773	8507	1958	12	25	1958-12-25 00:00:00	8527	0	\N	\N	\N	e49c37ff-ee38-48e6-83ea-1698aea8d665	M	0	white	0	irish	0
3989	8532	1927	10	3	1927-10-03 00:00:00	8527	0	\N	\N	\N	bdbc163f-d5cc-4a82-a5dd-01ca5453912c	F	0	white	0	american	0
5262	8532	1971	1	3	1971-01-03 00:00:00	0	38003563	\N	\N	\N	fbec9e07-5091-492e-bfaa-f41bb6cd4e1f	F	0	hispanic	0	puerto_rican	0
4736	8507	1972	9	15	1972-09-15 00:00:00	8515	0	\N	\N	\N	e28cb1f2-e56d-4ef1-8b5e-7b9c9cd86948	M	0	asian	0	asian_indian	0
5314	8532	1950	11	24	1950-11-24 00:00:00	8527	0	\N	\N	\N	fe3ec7db-fdec-4995-b8a0-bc410c71ee6e	F	0	white	0	american	0
4496	8532	1947	3	13	1947-03-13 00:00:00	8527	0	\N	\N	\N	d679a22a-1186-410f-8aa6-f353c4dd6f99	F	0	white	0	portuguese	0
5043	8532	1973	12	14	1973-12-14 00:00:00	0	38003563	\N	\N	\N	f1022143-f73c-4d84-bd1d-28c00dbc0217	F	0	hispanic	0	puerto_rican	0
5235	8532	1922	9	16	1922-09-16 00:00:00	8527	0	\N	\N	\N	fb2abbb1-7b53-413c-ad15-7172919263e2	F	0	white	0	irish	0
5001	8507	1959	10	25	1959-10-25 00:00:00	8527	0	\N	\N	\N	eef6e9de-fb35-42f9-97ad-64829787c40f	M	0	white	0	polish	0
5331	8532	1963	7	31	1963-07-31 00:00:00	0	38003563	\N	\N	\N	ff6cce80-dc25-4c6a-8a2c-9ddbace327d7	F	0	hispanic	0	puerto_rican	0
4755	8532	1924	11	7	1924-11-07 00:00:00	8527	0	\N	\N	\N	e3862705-480e-4a3e-944d-bd8d3c7654c7	F	0	white	0	irish	0
5277	8532	1955	1	5	1955-01-05 00:00:00	8527	0	\N	\N	\N	fc91108f-e0b5-4f75-85dd-a0a0ecb3ff8f	F	0	white	0	french_canadian	0
5223	8532	1968	1	20	1968-01-20 00:00:00	8527	0	\N	\N	\N	faca81c5-02ae-417b-b1fc-ccfe1fc1c296	F	0	white	0	irish	0
5068	8532	1931	6	20	1931-06-20 00:00:00	8515	0	\N	\N	\N	f2176082-e960-4c2d-b076-0d45a6e08cdc	F	0	asian	0	chinese	0
4677	8507	1957	12	13	1957-12-13 00:00:00	8527	0	\N	\N	\N	df5882da-14d9-49a3-abd7-d93ab58a3eef	M	0	white	0	italian	0
5152	8507	1970	1	4	1970-01-04 00:00:00	8527	0	\N	\N	\N	f70aff6b-f880-4cbe-a6d6-1918f2bd4f29	M	0	white	0	polish	0
4370	8507	1958	11	19	1958-11-19 00:00:00	8516	0	\N	\N	\N	cf7f6ad8-924a-4fb1-99a7-625deaba0411	M	0	black	0	african	0
4865	8507	1974	1	30	1974-01-30 00:00:00	8527	0	\N	\N	\N	e9104571-7cac-4fe5-90b3-60eb7f1d5233	M	0	white	0	german	0
4874	8532	1968	8	3	1968-08-03 00:00:00	0	38003563	\N	\N	\N	e9970ae8-93fe-4840-8806-2e0e99a99ca6	F	0	hispanic	0	puerto_rican	0
4383	8507	1968	11	16	1968-11-16 00:00:00	8527	0	\N	\N	\N	d0456c11-cd05-4ed0-bbcb-1884b30c179b	M	0	white	0	scottish	0
5264	8507	1967	10	31	1967-10-31 00:00:00	8527	0	\N	\N	\N	fc15ad0e-07ee-4717-8045-25a753cf00cf	M	0	white	0	italian	0
4514	8532	1975	5	23	1975-05-23 00:00:00	8527	0	\N	\N	\N	d77d6c4a-3e48-4721-acaf-634e91b2c583	F	0	white	0	irish	0
4546	8532	1968	6	28	1968-06-28 00:00:00	8527	0	\N	\N	\N	d903e01c-4590-4b63-8642-a1b6a45f11d9	F	0	white	0	irish	0
4719	8507	1934	12	2	1934-12-02 00:00:00	8527	0	\N	\N	\N	e122f3e4-9242-4539-9d6b-73c0e51afae0	M	0	white	0	irish	0
4448	8507	1954	4	15	1954-04-15 00:00:00	8527	0	\N	\N	\N	d34be962-452c-479a-a43f-d5e0fcedc2cf	M	0	white	0	german	0
4497	8532	1956	9	25	1956-09-25 00:00:00	8527	0	\N	\N	\N	d67a4813-f765-42b2-9319-64a27c1b97f3	F	0	white	0	greek	0
4668	8532	1955	1	11	1955-01-11 00:00:00	8527	0	\N	\N	\N	def9d426-5112-4a03-9cea-5f4c4cbe06c7	F	0	white	0	german	0
4855	8532	1977	9	10	1977-09-10 00:00:00	0	38003563	\N	\N	\N	e879a8a9-417b-434a-a002-cecdc10bffa4	F	0	hispanic	0	puerto_rican	0
4759	8507	1976	11	16	1976-11-16 00:00:00	8527	0	\N	\N	\N	e3a70a15-7d32-478f-b5d8-b9d3339c74b0	M	0	white	0	irish	0
5022	8532	1968	1	1	1968-01-01 00:00:00	8516	0	\N	\N	\N	f05cea14-3928-4bf5-bccd-d2558af9662b	F	0	black	0	dominican	0
4656	8507	1949	9	11	1949-09-11 00:00:00	0	38003563	\N	\N	\N	de42ec52-90de-4b55-b9e4-5066a6c6c7e1	M	0	hispanic	0	mexican	0
5060	8507	1972	3	27	1972-03-27 00:00:00	8516	0	\N	\N	\N	f1eba8ce-7e0e-4f14-87e1-acab70e64f9c	M	0	black	0	dominican	0
5251	8507	1922	2	27	1922-02-27 00:00:00	8527	0	\N	\N	\N	fb943a58-8a89-4989-b53b-fc261ca20d2a	M	0	white	0	polish	0
5241	8532	1962	3	27	1962-03-27 00:00:00	8527	0	\N	\N	\N	fb553601-c562-4a60-99c1-b30d726b6e55	F	0	white	0	polish	0
4561	8507	1950	4	12	1950-04-12 00:00:00	8527	0	\N	\N	\N	da0394ae-343b-4930-a668-3640bd0147c3	M	0	white	0	portuguese	0
4500	8507	1961	9	13	1961-09-13 00:00:00	8527	0	\N	\N	\N	d6b8776c-a532-437d-b5f1-6e23db7fcb39	M	0	white	0	american	0
5325	8507	1946	1	6	1946-01-06 00:00:00	8516	0	\N	\N	\N	ff375e51-48dd-4536-9e4e-d2329f5109a9	M	0	black	0	west_indian	0
5232	8507	1967	10	7	1967-10-07 00:00:00	8527	0	\N	\N	\N	fb092046-5277-40a5-b8ef-c724a08ea945	M	0	white	0	irish	0
5051	8507	1977	11	24	1977-11-24 00:00:00	8527	0	\N	\N	\N	f1982e13-e407-4245-bf22-dc94af8f103d	M	0	white	0	french	0
4330	8532	1945	12	22	1945-12-22 00:00:00	8527	0	\N	\N	\N	cdc3f4fb-116c-4a47-af2a-74c75b555ea1	F	0	white	0	german	0
4520	8507	1927	4	9	1927-04-09 00:00:00	8527	0	\N	\N	\N	d7dacd7a-dc21-4e39-9fba-d45cfa286f8c	M	0	white	0	italian	0
4852	8532	1947	11	6	1947-11-06 00:00:00	8527	0	\N	\N	\N	e8656c69-9533-4ace-8507-c0a4b952addd	F	0	white	0	italian	0
5169	8507	1953	6	1	1953-06-01 00:00:00	8527	0	\N	\N	\N	f8277c21-c2a4-4556-a0e7-6c145bea8da5	M	0	white	0	irish	0
4819	8507	1959	9	22	1959-09-22 00:00:00	0	38003563	\N	\N	\N	e670f32a-039a-4156-aaba-6ceafe662adf	M	0	hispanic	0	puerto_rican	0
4067	8507	1971	3	27	1971-03-27 00:00:00	8516	0	\N	\N	\N	c15532a5-f80c-4cd1-a64c-0b5804d6b07c	M	0	black	0	african	0
5065	8507	1969	2	11	1969-02-11 00:00:00	8527	0	\N	\N	\N	f206a74b-6eb3-4d88-8d82-59fab0333c43	M	0	white	0	irish	0
4662	8532	1950	8	5	1950-08-05 00:00:00	8516	0	\N	\N	\N	ded094df-bc92-4f85-8b51-8ced38e1151d	F	0	black	0	west_indian	0
5257	8532	1978	3	15	1978-03-15 00:00:00	8516	0	\N	\N	\N	fbb5ca50-5275-49e4-8e7b-3e440c12584c	F	0	black	0	african	0
5279	8532	1946	1	27	1946-01-27 00:00:00	8527	0	\N	\N	\N	fc9d1b1a-4f92-49ae-a6d0-24301d4fdb5a	F	0	white	0	english	0
5119	8507	1962	5	8	1962-05-08 00:00:00	8516	0	\N	\N	\N	f54b1f1c-e735-440a-97d1-c7e94966d630	M	0	black	0	dominican	0
4837	8507	1948	12	21	1948-12-21 00:00:00	8527	0	\N	\N	\N	e793052e-845b-4014-8cbe-1448b94c1b9c	M	0	white	0	italian	0
5259	8507	1958	10	27	1958-10-27 00:00:00	8527	0	\N	\N	\N	fbc33d98-655c-4fdf-8429-7d7fc6a3bc50	M	0	white	0	german	0
5146	8532	1946	8	5	1946-08-05 00:00:00	8515	0	\N	\N	\N	f6c8fdbe-0315-48bc-9004-cc0a0431c9ec	F	0	asian	0	chinese	0
4777	8532	1958	5	13	1958-05-13 00:00:00	8527	0	\N	\N	\N	e4d5fcc9-32fa-49b7-b187-bcb54f435282	F	0	white	0	italian	0
5206	8507	1976	10	16	1976-10-16 00:00:00	8527	0	\N	\N	\N	f9cd35ca-fbf7-485f-b3f3-43d1f6fca745	M	0	white	0	polish	0
4452	8532	1955	6	3	1955-06-03 00:00:00	8527	0	\N	\N	\N	d37421b2-0d6a-45d0-8772-1bc585516da3	F	0	white	0	english	0
5101	8532	1956	12	29	1956-12-29 00:00:00	8527	0	\N	\N	\N	f408bd33-c37c-4c7d-8576-fba7fd881998	F	0	white	0	irish	0
4988	8532	1953	4	21	1953-04-21 00:00:00	8527	0	\N	\N	\N	ee4e4cf5-8c38-4999-a22e-5a9c75862e3c	F	0	white	0	irish	0
4457	8507	1983	5	10	1983-05-10 00:00:00	8527	0	\N	\N	\N	d4176200-5b59-4a8e-8bd2-6076d6d014e9	M	0	white	0	irish	0
4722	8507	1909	2	14	1909-02-14 00:00:00	8516	0	\N	\N	\N	e1431961-438c-4f65-965d-9f931c8efda4	M	0	black	0	west_indian	0
4626	8532	1975	11	3	1975-11-03 00:00:00	8527	0	\N	\N	\N	dcdc8202-3472-42ed-96ec-c9c4f29cf606	F	0	white	0	italian	0
4739	8507	1909	11	27	1909-11-27 00:00:00	8527	0	\N	\N	\N	e2aafc90-1cc9-4ed6-917d-20e0b6fc4807	M	0	white	0	polish	0
4492	8532	1946	8	6	1946-08-06 00:00:00	8527	0	\N	\N	\N	d6584cf1-e338-47a6-8fbf-153cf1768fd7	F	0	white	0	american	0
4781	8507	1981	10	2	1981-10-02 00:00:00	8527	0	\N	\N	\N	e523f07c-0bdc-429c-90ae-7787227ba9c4	M	0	white	0	irish	0
4682	8532	1979	9	16	1979-09-16 00:00:00	0	38003563	\N	\N	\N	df82e0ca-afe5-4e2b-8ac7-781d8ce0c990	F	0	hispanic	0	puerto_rican	0
5150	8532	1939	3	16	1939-03-16 00:00:00	8527	0	\N	\N	\N	f6f4835e-e195-43b8-a297-b3aaaee4e92b	F	0	white	0	french	0
4932	8507	1957	11	14	1957-11-14 00:00:00	8516	0	\N	\N	\N	ebf413de-c75b-4bd0-bd22-4a3ebe832a2c	M	0	black	0	african	0
5096	8532	1967	4	13	1967-04-13 00:00:00	8516	0	\N	\N	\N	f3f94e4c-27f4-4e43-aa72-2f4de227e750	F	0	black	0	dominican	0
4678	8507	1954	9	28	1954-09-28 00:00:00	8527	0	\N	\N	\N	df59f62a-bb85-40b4-b6d3-90a72af4a814	M	0	white	0	italian	0
5138	8507	1977	12	2	1977-12-02 00:00:00	8527	0	\N	\N	\N	f64d8c52-406d-4d95-a793-8d19672081f9	M	0	white	0	irish	0
4763	8532	1950	8	22	1950-08-22 00:00:00	0	38003563	\N	\N	\N	e3ba5333-8780-4a57-b176-2dec24fa283b	F	0	hispanic	0	puerto_rican	0
4578	8532	1964	5	24	1964-05-24 00:00:00	8515	0	\N	\N	\N	dac1e322-c9a7-486a-a1c8-28202a3aa9b0	F	0	asian	0	asian_indian	0
5276	8532	1958	1	19	1958-01-19 00:00:00	8527	0	\N	\N	\N	fc8b6553-4e00-44cb-b131-5b3244183ebb	F	0	white	0	french	0
5229	8507	1961	12	6	1961-12-06 00:00:00	8527	0	\N	\N	\N	fafbf95b-0cd0-48cf-80c9-f229aa0e4f45	M	0	white	0	german	0
4409	8532	1967	1	19	1967-01-19 00:00:00	8527	0	\N	\N	\N	d1486b62-6395-4896-9bf8-e002c7aa3d5e	F	0	white	0	french	0
4574	8532	1956	3	16	1956-03-16 00:00:00	8527	0	\N	\N	\N	da8fa489-3c97-41f6-98bf-7f9669eefc76	F	0	white	0	english	0
4945	8532	1954	4	29	1954-04-29 00:00:00	8527	0	\N	\N	\N	ec734940-e632-4192-b7d9-c9557c62ec84	F	0	white	0	irish	0
5191	8532	1970	8	20	1970-08-20 00:00:00	8527	0	\N	\N	\N	f8f47036-1379-40d4-b499-c254862f517e	F	0	white	0	irish	0
5018	8532	1939	11	16	1939-11-16 00:00:00	8527	0	\N	\N	\N	f020231e-0cd0-4cf9-a944-1398d02b5096	F	0	white	0	italian	0
4129	8532	1948	4	26	1948-04-26 00:00:00	8515	0	\N	\N	\N	c524d9a6-27e5-4e29-8e58-e25f39b3f893	F	0	asian	0	asian_indian	0
5151	8507	1956	11	2	1956-11-02 00:00:00	8527	0	\N	\N	\N	f703ad19-1e41-450b-8558-a3187ead8013	M	0	white	0	french_canadian	0
4826	8507	1951	6	9	1951-06-09 00:00:00	8527	0	\N	\N	\N	e6c78682-fb6e-46a5-8b7c-fd03c712e237	M	0	white	0	french_canadian	0
5215	8507	1940	5	13	1940-05-13 00:00:00	8527	0	\N	\N	\N	fa3f04c4-5d5b-451e-a21b-333fe14993ff	M	0	white	0	french_canadian	0
5132	8532	1966	8	8	1966-08-08 00:00:00	8527	0	\N	\N	\N	f5fc0f72-28ab-4102-81dc-cd91e032736f	F	0	white	0	french	0
5228	8532	1935	6	20	1935-06-20 00:00:00	8527	0	\N	\N	\N	faf828bb-7375-4490-a3a9-545a7aa4258e	F	0	white	0	polish	0
4831	8507	1961	4	27	1961-04-27 00:00:00	8527	0	\N	\N	\N	e7505dba-8e30-433b-a5c3-5306b94bdb87	M	0	white	0	irish	0
5306	8532	1969	1	19	1969-01-19 00:00:00	0	38003563	\N	\N	\N	fdc6db0f-d2b6-4373-9b93-6a333c4bfda5	F	0	hispanic	0	puerto_rican	0
4488	8507	1976	1	2	1976-01-02 00:00:00	8527	0	\N	\N	\N	d5f95a24-86ce-4fb6-886a-a2fadd751840	M	0	white	0	english	0
5197	8532	1953	4	21	1953-04-21 00:00:00	8527	0	\N	\N	\N	f91fb263-5e32-45de-b127-c1fe2e636efd	F	0	white	0	irish	0
5094	8532	1978	5	1	1978-05-01 00:00:00	8516	0	\N	\N	\N	f3d37976-bf12-4282-925a-4aed3e87a50f	F	0	black	0	dominican	0
4485	8507	1950	10	12	1950-10-12 00:00:00	8527	0	\N	\N	\N	d5c599cc-6304-423f-a076-32b34bfd21bd	M	0	white	0	german	0
4923	8532	1968	10	8	1968-10-08 00:00:00	8527	0	\N	\N	\N	ebab862b-c441-4069-af58-3eae383d5a53	F	0	white	0	portuguese	0
4909	8532	1975	6	16	1975-06-16 00:00:00	8516	0	\N	\N	\N	eb240988-2e0d-4aaf-a6b5-b494d6d6fa08	F	0	black	0	african	0
4853	8507	1962	5	9	1962-05-09 00:00:00	8527	0	\N	\N	\N	e8659964-ff13-4e92-9be3-4c37d6744283	M	0	white	0	italian	0
4602	8507	1977	5	9	1977-05-09 00:00:00	8527	0	\N	\N	\N	dbcb7a50-dd29-44b8-8e98-0cb152ce4e91	M	0	white	0	polish	0
4827	8532	1949	12	8	1949-12-08 00:00:00	8527	0	\N	\N	\N	e6f4c10b-d26e-4020-a0db-7f9a1bea7cf8	F	0	white	0	swedish	0
4816	8532	1981	11	9	1981-11-09 00:00:00	8527	0	\N	\N	\N	e660a632-6e94-4884-8c88-d83466e01ff4	F	0	white	0	scottish	0
5252	8507	1957	12	3	1957-12-03 00:00:00	8527	0	\N	\N	\N	fb991091-acbf-4386-ba63-42521f991715	M	0	white	0	italian	0
5086	8532	1969	9	25	1969-09-25 00:00:00	0	38003563	\N	\N	\N	f33b52f8-dc12-4c6f-ae26-9fe2ba533741	F	0	hispanic	0	puerto_rican	0
5284	8532	1966	8	24	1966-08-24 00:00:00	8527	0	\N	\N	\N	fcbb724e-46b1-4994-a9de-60ed6777cd06	F	0	white	0	portuguese	0
4828	8507	1967	5	10	1967-05-10 00:00:00	8516	0	\N	\N	\N	e718b39a-a1d3-4b8e-90bc-e97ae0fc826e	M	0	black	0	west_indian	0
5256	8532	1959	11	13	1959-11-13 00:00:00	0	38003563	\N	\N	\N	fbb38055-c4c9-464a-93c7-40c401f1b4ab	F	0	hispanic	0	mexican	0
5234	8532	1936	9	2	1936-09-02 00:00:00	8527	0	\N	\N	\N	fb1ae525-0772-45a1-a221-dc144d8684b5	F	0	white	0	german	0
4676	8532	1979	8	2	1979-08-02 00:00:00	8516	0	\N	\N	\N	df55f73a-9a91-4b12-abc3-035d449670fb	F	0	black	0	dominican	0
5249	8507	1948	9	5	1948-09-05 00:00:00	8527	0	\N	\N	\N	fb81fb4e-a93a-4ec1-93ce-d4c730ce2b1b	M	0	white	0	english	0
4565	8532	1945	8	7	1945-08-07 00:00:00	8527	0	\N	\N	\N	da251142-e5b0-4f83-9808-21814540479b	F	0	white	0	english	0
4622	8507	1956	1	26	1956-01-26 00:00:00	8527	0	\N	\N	\N	dcb0f86b-d75d-4601-920c-d8a5f46966b2	M	0	white	0	italian	0
5053	8532	1945	2	25	1945-02-25 00:00:00	8527	0	\N	\N	\N	f1adcffd-24ff-4455-85f0-f045ed71fa5b	F	0	white	0	french_canadian	0
5291	8532	1975	10	19	1975-10-19 00:00:00	8527	0	\N	\N	\N	fd07e8f5-ece4-4772-a7f7-ede636369643	F	0	white	0	german	0
5196	8532	1951	8	3	1951-08-03 00:00:00	8515	0	\N	\N	\N	f910767e-a1ba-436f-bc00-ecc475eeb0d9	F	0	asian	0	asian_indian	0
4283	8532	1951	4	14	1951-04-14 00:00:00	8527	0	\N	\N	\N	cbc34767-6b8f-4801-ab82-486a7389c3c0	F	0	white	0	german	0
5253	8532	1955	12	10	1955-12-10 00:00:00	0	38003563	\N	\N	\N	fb9a6b01-e3e5-4e8f-badd-161196e29ec5	F	0	hispanic	0	puerto_rican	0
4873	8532	1976	7	16	1976-07-16 00:00:00	8527	0	\N	\N	\N	e9730bd4-ba2f-469c-83e5-624f6dab72b0	F	0	white	0	french	0
5299	8532	1971	6	13	1971-06-13 00:00:00	0	38003563	\N	\N	\N	fd51ab06-3089-4f21-8f97-ff657f5d529a	F	0	hispanic	0	puerto_rican	0
5242	8507	1962	7	27	1962-07-27 00:00:00	8527	0	\N	\N	\N	fb5c1925-c21b-446d-b1c8-d6cdc518e329	M	0	white	0	american	0
4876	8532	1972	5	20	1972-05-20 00:00:00	8527	0	\N	\N	\N	e9ab42bd-cefa-4a9a-93bf-67cb285e4a14	F	0	white	0	english	0
4606	8507	1982	2	4	1982-02-04 00:00:00	8515	0	\N	\N	\N	dc02b9f6-3856-435a-8ff6-e2895e4a3d63	M	0	asian	0	chinese	0
5335	8532	1958	8	21	1958-08-21 00:00:00	8527	0	\N	\N	\N	ffab3860-df75-4708-8df5-589fc303fa7c	F	0	white	0	swedish	0
5168	8507	1971	2	26	1971-02-26 00:00:00	8527	0	\N	\N	\N	f7ff1564-a081-4bda-bc18-cadc97432f62	M	0	white	0	irish	0
4595	8507	1962	7	13	1962-07-13 00:00:00	8527	0	\N	\N	\N	db78b03a-0403-45fc-9566-3acb7b6d2686	M	0	white	0	scottish	0
5079	8507	1966	12	11	1966-12-11 00:00:00	8527	0	\N	\N	\N	f2cacfb0-361a-40bf-81c8-e2731496c227	M	0	white	0	italian	0
5143	8507	1958	12	10	1958-12-10 00:00:00	8527	0	\N	\N	\N	f6878a1e-2aa2-417c-8cb1-f854616b2163	M	0	white	0	french	0
5066	8532	1967	4	8	1967-04-08 00:00:00	8527	0	\N	\N	\N	f20bc6f3-a1a7-4d0b-83a0-50bba682a2ae	F	0	white	0	portuguese	0
4700	8532	1951	5	22	1951-05-22 00:00:00	8527	0	\N	\N	\N	e040a8c2-ded8-46fe-a398-c47221a82a99	F	0	white	0	french	0
4872	8532	1914	8	4	1914-08-04 00:00:00	8527	0	\N	\N	\N	e957f191-5830-43ee-9c66-b6c74bfd85ec	F	0	white	0	italian	0
4867	8507	1913	9	10	1913-09-10 00:00:00	0	38003563	\N	\N	\N	e91c7903-6b0d-4b25-86af-cf8337209117	M	0	hispanic	0	south_american	0
5128	8532	1926	8	11	1926-08-11 00:00:00	8515	0	\N	\N	\N	f5e33fc0-48ef-4b0a-b001-070b24e2cca8	F	0	asian	0	chinese	0
5013	8507	1964	8	21	1964-08-21 00:00:00	8527	0	\N	\N	\N	efa3ded6-4e0d-4299-b8e9-e24846af0956	M	0	white	0	italian	0
5278	8507	1969	5	9	1969-05-09 00:00:00	8527	0	\N	\N	\N	fc95e86a-008a-47cd-990a-a61b93c022ff	M	0	white	0	polish	0
4776	8507	1960	4	17	1960-04-17 00:00:00	8527	0	\N	\N	\N	e4d1d892-3a46-4478-bb14-4027a5c5b26a	M	0	white	0	irish	0
4613	8532	1966	5	22	1966-05-22 00:00:00	0	38003563	\N	\N	\N	dc4cfdcf-bc8e-4c8b-8f61-2702afc3aecc	F	0	hispanic	0	south_american	0
4756	8507	1943	10	9	1943-10-09 00:00:00	8527	0	\N	\N	\N	e38a7a9b-ff9a-4d6a-a641-f73158accb33	M	0	white	0	italian	0
5067	8532	1974	6	2	1974-06-02 00:00:00	8527	0	\N	\N	\N	f20d2c3b-aab5-4357-b77d-c7cafc08af9b	F	0	white	0	english	0
5334	8532	1964	2	19	1964-02-19 00:00:00	8515	0	\N	\N	\N	ffa8d9c2-dc43-48e4-9bee-44ffe6be4b7b	F	0	asian	0	chinese	0
4382	8532	1952	12	29	1952-12-29 00:00:00	8527	0	\N	\N	\N	d0382382-70a4-4a32-a223-ee86130d52b6	F	0	white	0	french	0
4991	8532	1971	7	10	1971-07-10 00:00:00	8527	0	\N	\N	\N	ee7d86e8-d439-418b-a941-eb508431d08d	F	0	white	0	portuguese	0
5317	8532	1972	12	6	1972-12-06 00:00:00	8527	0	\N	\N	\N	fe7472d2-cb11-4d6c-bdf7-dd7d6f1ec034	F	0	white	0	english	0
4986	8532	1950	4	23	1950-04-23 00:00:00	8527	0	\N	\N	\N	ee38f803-6834-43bb-87bd-bce77daa76e8	F	0	white	0	scottish	0
4696	8532	1951	3	14	1951-03-14 00:00:00	8516	0	\N	\N	\N	e013e4ef-fc95-4ffd-8e16-dd10fb774068	F	0	black	0	west_indian	0
5190	8532	1956	11	30	1956-11-30 00:00:00	8527	0	\N	\N	\N	f8e05461-5c18-40d6-8d11-ece5aa99b7a6	F	0	white	0	french_canadian	0
4643	8532	1909	4	17	1909-04-17 00:00:00	8527	0	\N	\N	\N	dd5d9c58-29c5-4fc1-808b-577406ac1aff	F	0	white	0	irish	0
5121	8507	1964	6	19	1964-06-19 00:00:00	8527	0	\N	\N	\N	f55cca44-6dbc-47e4-8328-9678d46dd0b9	M	0	white	0	english	0
5148	8532	1960	2	15	1960-02-15 00:00:00	8527	0	\N	\N	\N	f6db0be6-3f3e-4dae-be89-9c8c9443c866	F	0	white	0	french	0
4784	8507	1949	1	1	1949-01-01 00:00:00	8527	0	\N	\N	\N	e53bcf08-4f2d-4379-9bce-3c843c680cc4	M	0	white	0	italian	0
4990	8532	1962	1	24	1962-01-24 00:00:00	8527	0	\N	\N	\N	ee75e3e0-6424-4d6a-94e6-132038cac460	F	0	white	0	french	0
5017	8507	1980	1	12	1980-01-12 00:00:00	0	38003563	\N	\N	\N	f00980d5-0765-4be3-839b-62f03781b27b	M	0	hispanic	0	puerto_rican	0
5295	8532	1909	9	29	1909-09-29 00:00:00	0	38003563	\N	\N	\N	fd1d0486-e857-457b-9d35-96a43836fa3e	F	0	hispanic	0	central_american	0
4987	8532	1959	9	22	1959-09-22 00:00:00	8516	0	\N	\N	\N	ee3d0ed7-25c3-45e5-82db-2580af239afa	F	0	black	0	african	0
4922	8532	1976	8	3	1976-08-03 00:00:00	0	38003563	\N	\N	\N	eb9c3870-2abb-4467-b250-8675545f8771	F	0	hispanic	0	puerto_rican	0
4834	8532	1960	5	15	1960-05-15 00:00:00	0	38003563	\N	\N	\N	e76da4c6-af58-437d-80b2-465b9ece9314	F	0	hispanic	0	puerto_rican	0
5255	8532	1959	12	24	1959-12-24 00:00:00	8527	0	\N	\N	\N	fbb04c87-5d0e-4b96-96a2-4563d31611c6	F	0	white	0	italian	0
4456	8532	1964	5	24	1964-05-24 00:00:00	8527	0	\N	\N	\N	d3ddecad-c60c-4829-9c5e-1f7c462261a6	F	0	white	0	greek	0
5189	8532	1955	5	22	1955-05-22 00:00:00	8516	0	\N	\N	\N	f8db5ed6-34b9-4d21-ac6f-7e27ebcc15d4	F	0	black	0	african	0
5014	8532	1912	11	12	1912-11-12 00:00:00	8527	0	\N	\N	\N	efc202ae-fde4-409c-8248-6dbb360d4351	F	0	white	0	irish	0
4788	8507	1975	11	23	1975-11-23 00:00:00	8527	0	\N	\N	\N	e54dafb5-c6d4-46a5-bce9-edc73541dbe3	M	0	white	0	italian	0
5290	8507	1953	11	6	1953-11-06 00:00:00	8527	0	\N	\N	\N	fd020d77-f54c-4248-b12c-ac872a8452c6	M	0	white	0	italian	0
4815	8507	1970	3	5	1970-03-05 00:00:00	8527	0	\N	\N	\N	e652b253-43a7-4f44-8b19-2c549def9863	M	0	white	0	irish	0
5239	8507	1965	11	24	1965-11-24 00:00:00	8527	0	\N	\N	\N	fb4bc5b4-1838-49bb-8f90-e57a615332b0	M	0	white	0	italian	0
4963	8507	1973	5	14	1973-05-14 00:00:00	8527	0	\N	\N	\N	ed57ca7e-1b2e-4fd5-b350-8943dfad0993	M	0	white	0	french_canadian	0
5170	8532	1968	12	27	1968-12-27 00:00:00	8516	0	\N	\N	\N	f82c39bf-2dc9-4fcf-917e-7cc6b34bd3ac	F	0	black	0	west_indian	0
5103	8507	1943	10	11	1943-10-11 00:00:00	8527	0	\N	\N	\N	f42b2d05-9f6e-4a56-ae9b-831e76fbd1ec	M	0	white	0	italian	0
5337	8507	1970	2	22	1970-02-22 00:00:00	8527	0	\N	\N	\N	ffb7208c-db54-47f1-b5fa-b14c6b169a99	M	0	white	0	french	0
5015	8507	1968	2	5	1968-02-05 00:00:00	8527	0	\N	\N	\N	efe70f45-6e3b-4e6b-99ac-1159195371ce	M	0	white	0	english	0
5078	8532	1911	5	1	1911-05-01 00:00:00	8516	0	\N	\N	\N	f2bda782-f41d-4b3f-bff1-d9bf86771629	F	0	black	0	west_indian	0
4913	8532	1969	5	14	1969-05-14 00:00:00	8527	0	\N	\N	\N	eb42bc4d-c29e-4410-9c05-072792bfc2da	F	0	white	0	english	0
4484	8507	1951	9	13	1951-09-13 00:00:00	8527	0	\N	\N	\N	d591ec3b-2a0b-416c-a631-9278010f7a02	M	0	white	0	irish	0
5343	8532	1983	1	2	1983-01-02 00:00:00	8527	0	\N	\N	\N	fffc6f0d-452b-4a5b-bfd3-1656ab3da340	F	0	white	0	german	0
5174	8532	1937	1	28	1937-01-28 00:00:00	8527	0	\N	\N	\N	f856c7f7-9a08-4c8a-9656-fa145db8e148	F	0	white	0	italian	0
4802	8507	1964	9	13	1964-09-13 00:00:00	8527	0	\N	\N	\N	e5df5ed8-5a25-4bde-b190-11d82191ded0	M	0	white	0	italian	0
4970	8507	1923	4	18	1923-04-18 00:00:00	8516	0	\N	\N	\N	edbac830-669c-4cae-b940-6a03efd5d4ac	M	0	black	0	dominican	0
5007	8507	1983	3	27	1983-03-27 00:00:00	8527	0	\N	\N	\N	ef716494-9563-485f-beb7-cec62c08f2a1	M	0	white	0	irish	0
5199	8532	1962	1	16	1962-01-16 00:00:00	8527	0	\N	\N	\N	f93d3bc6-d57c-4be2-a685-e55927b5fdb3	F	0	white	0	german	0
5185	8532	1935	10	14	1935-10-14 00:00:00	8527	0	\N	\N	\N	f8be868b-784b-4613-8133-1e36c4b409c2	F	0	white	0	english	0
5274	8532	1952	4	6	1952-04-06 00:00:00	8527	0	\N	\N	\N	fc87be3e-9006-414a-9386-461a25ae5e53	F	0	white	0	french	0
4935	8532	1964	9	24	1964-09-24 00:00:00	8516	0	\N	\N	\N	ec2057c9-ee86-4dbc-abfa-9e8e8af2f5ca	F	0	black	0	west_indian	0
4642	8532	1952	11	25	1952-11-25 00:00:00	8527	0	\N	\N	\N	dd4ae0ba-237d-4117-8698-b5fc8806b9ac	F	0	white	0	italian	0
5184	8532	1964	6	19	1964-06-19 00:00:00	8527	0	\N	\N	\N	f8bdd79e-1ce5-44b8-8d2e-1886e3bad40e	F	0	white	0	english	0
4881	8507	1948	7	11	1948-07-11 00:00:00	8527	0	\N	\N	\N	e9fa3d74-16f1-4f3a-af2c-2b6518dffd99	M	0	white	0	french_canadian	0
4998	8507	1964	10	9	1964-10-09 00:00:00	8516	0	\N	\N	\N	eed40602-af0a-496a-aa69-f260ef2affdc	M	0	black	0	west_indian	0
5113	8507	1969	3	15	1969-03-15 00:00:00	0	38003563	\N	\N	\N	f49e79e2-652a-42ac-a9f4-9140657f0fae	M	0	hispanic	0	puerto_rican	0
5283	8532	1972	9	5	1972-09-05 00:00:00	8516	0	\N	\N	\N	fcb29ade-193d-4888-9202-d3a3e318dcb4	F	0	black	0	dominican	0
5035	8507	1930	6	2	1930-06-02 00:00:00	8516	0	\N	\N	\N	f0b2a787-1dc1-4e35-8072-fcf92df8ff76	M	0	black	0	west_indian	0
4792	8532	1950	3	21	1950-03-21 00:00:00	0	38003563	\N	\N	\N	e586f6f0-db16-4f78-aa36-76c419957f22	F	0	hispanic	0	south_american	0
4967	8532	1961	5	29	1961-05-29 00:00:00	8527	0	\N	\N	\N	eda355c7-81c4-456e-800a-636d840d535a	F	0	white	0	german	0
5104	8507	1979	12	1	1979-12-01 00:00:00	8527	0	\N	\N	\N	f42df83e-d3ca-41b0-829b-d31b7a0e66de	M	0	white	0	scottish	0
5301	8532	1920	7	29	1920-07-29 00:00:00	8527	0	\N	\N	\N	fd6605d7-7e0b-4abf-898c-a10d17f4f188	F	0	white	0	irish	0
5333	8507	1949	7	3	1949-07-03 00:00:00	8516	0	\N	\N	\N	ff8d86ab-6480-4065-8eb2-62e7a3240743	M	0	black	0	dominican	0
5085	8507	1976	9	9	1976-09-09 00:00:00	8516	0	\N	\N	\N	f336962b-9e2f-4e5c-82a6-3a992b5310d8	M	0	black	0	african	0
4814	8532	1935	10	14	1935-10-14 00:00:00	8527	0	\N	\N	\N	e63fbf6f-f675-4bae-82cf-84ee97af09a9	F	0	white	0	english	0
5117	8532	1958	3	10	1958-03-10 00:00:00	0	38003563	\N	\N	\N	f4fce63c-2698-4640-833c-57fd47c87aca	F	0	hispanic	0	puerto_rican	0
5200	8507	1955	8	17	1955-08-17 00:00:00	8515	0	\N	\N	\N	f95bea52-f05a-4302-829d-7bc5db92b549	M	0	asian	0	chinese	0
5315	8507	1916	6	18	1916-06-18 00:00:00	8527	0	\N	\N	\N	fe545655-59bc-4337-a0bc-0a7c8e3dfa14	M	0	white	0	scottish	0
5245	8507	1973	12	30	1973-12-30 00:00:00	8527	0	\N	\N	\N	fb71555a-4589-4c72-8096-1e8cc6a8973a	M	0	white	0	italian	0
4971	8532	1934	9	4	1934-09-04 00:00:00	8527	0	\N	\N	\N	edbd07d0-f689-4e4c-a004-f02d2612b311	F	0	white	0	greek	0
5213	8507	1938	6	16	1938-06-16 00:00:00	8527	0	\N	\N	\N	fa212267-c513-4757-a5ff-902625081927	M	0	white	0	french_canadian	0
5322	8507	1947	1	22	1947-01-22 00:00:00	8527	0	\N	\N	\N	fec063f0-ef29-49e4-b7b6-c46d8f153393	M	0	white	0	english	0
5265	8507	1968	2	22	1968-02-22 00:00:00	8527	0	\N	\N	\N	fc180a73-ad0e-4b76-9b0c-20bf1848b9c6	M	0	white	0	portuguese	0
4999	8532	1956	11	18	1956-11-18 00:00:00	8527	0	\N	\N	\N	eedee7e1-59de-4a14-b123-5bf3a9ed6082	F	0	white	0	irish	0
5201	8532	1978	4	5	1978-04-05 00:00:00	8527	0	\N	\N	\N	f965b46d-fc51-48c9-ad2f-62f6b16ad55d	F	0	white	0	italian	0
5309	8532	1951	1	29	1951-01-29 00:00:00	8527	0	\N	\N	\N	fdf64ca7-54c9-48b4-bd26-7f226d17ab7f	F	0	white	0	irish	0
\.


--
-- TOC entry 3910 (class 0 OID 3185583)
-- Dependencies: 232
-- Data for Name: procedure_occurrence; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".procedure_occurrence (procedure_occurrence_id, person_id, procedure_concept_id, procedure_date, procedure_datetime, procedure_type_concept_id, modifier_concept_id, quantity, provider_id, visit_occurrence_id, visit_detail_id, procedure_source_value, procedure_source_concept_id, modifier_source_value) FROM stdin;
3554	343	4107731	1992-02-01	1992-02-01 00:00:00	38000275	0	\N	\N	22951	0	180256009	4107731	
3741	357	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	23670	0	180256009	4107731	
3928	399	4107731	1991-09-08	1991-09-08 00:00:00	38000275	0	\N	\N	26205	0	180256009	4107731	
4115	406	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	26759	0	180256009	4107731	
4302	411	4107731	1992-01-11	1992-01-11 00:00:00	38000275	0	\N	\N	27401	0	180256009	4107731	
4489	430	4058899	1938-10-11	1938-10-11 00:00:00	38000275	0	\N	\N	28537	0	168594001	4058899	
4676	442	4107731	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	29330	0	180256009	4107731	
4863	453	4043071	1984-03-20	1984-03-20 00:00:00	38000275	0	\N	\N	30237	0	228557008	4043071	
5050	469	4043071	1948-04-26	1948-04-26 00:00:00	38000275	0	\N	\N	31282	0	228557008	4043071	
5237	488	4151422	1962-09-21	1962-09-21 00:00:00	38000275	0	\N	\N	32616	0	269911007	4151422	
5424	499	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	33362	0	180256009	4107731	
5674	518	4170947	1977-04-24	1977-04-24 00:00:00	38000275	0	\N	\N	34592	0	274474001	4170947	
5798	533	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	35478	0	180256009	4107731	
5985	546	4243062	1961-10-10	1961-10-10 00:00:00	38000275	0	\N	\N	36151	0	60027007	4243062	
6172	563	4107731	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	37280	0	180256009	4107731	
6360	592	4295880	1994-07-08	1994-07-08 00:00:00	38000275	0	\N	\N	39116	0	76601001	4295880	
6546	603	4151422	2002-06-04	2002-06-04 00:00:00	38000275	0	\N	\N	40005	0	269911007	4151422	
6733	613	4125906	2002-04-18	2002-04-18 00:00:00	38000275	0	\N	\N	40695	0	288086009	4125906	
6920	625	4010253	2001-08-13	2001-08-13 00:00:00	38000275	0	\N	\N	41735	0	112790001	4010253	
7120	662	4216130	2012-06-06	2012-06-06 00:00:00	38000275	0	\N	\N	43754	0	415070008	4216130	
7294	680	4107731	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	45006	0	180256009	4107731	
7481	693	44783196	1999-09-11	1999-09-11 00:00:00	38000275	0	\N	\N	45884	0	699253003	44783196	
7720	709	4151422	1961-03-12	1961-03-12 00:00:00	38000275	0	\N	\N	46954	0	269911007	4151422	
7855	718	4107731	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	47542	0	180256009	4107731	
8042	733	4058899	1959-08-29	1959-08-29 00:00:00	38000275	0	\N	\N	48597	0	168594001	4058899	
8229	754	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	49992	0	180256009	4107731	
8416	764	4151422	2010-01-08	2010-01-08 00:00:00	38000275	0	\N	\N	50824	0	269911007	4151422	
8603	782	4293740	1977-11-15	1977-11-15 00:00:00	38000275	0	\N	\N	52019	0	384700001	4293740	
8800	800	4151422	1973-06-21	1973-06-21 00:00:00	38000275	0	\N	\N	53152	0	269911007	4151422	
8983	820	4151422	2009-10-14	2009-10-14 00:00:00	38000275	0	\N	\N	54329	0	269911007	4151422	
9164	843	4191853	1995-05-06	1995-05-06 00:00:00	38000275	0	\N	\N	55807	0	395142003	4191853	
9351	859	4107731	1991-04-29	1991-04-29 00:00:00	38000275	0	\N	\N	56831	0	180256009	4107731	
9543	869	4078793	2013-11-15	2013-11-15 00:00:00	38000275	0	\N	\N	57689	0	180325003	4078793	
9733	877	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	58372	0	180256009	4107731	
9912	885	4043071	1988-04-29	1988-04-29 00:00:00	38000275	0	\N	\N	59015	0	228557008	4043071	
10127	902	4145310	1968-01-15	1968-01-15 00:00:00	38000275	0	\N	\N	60067	0	268425006	4145310	
10286	917	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	60963	0	180256009	4107731	
10484	946	4170947	1975-04-23	1975-04-23 00:00:00	38000275	0	\N	\N	62809	0	274474001	4170947	
10786	962	4170947	1964-03-27	1964-03-27 00:00:00	38000275	0	\N	\N	64026	0	274474001	4170947	
10847	978	4243062	1985-01-24	1985-01-24 00:00:00	38000275	0	\N	\N	65152	0	60027007	4243062	
11066	1024	4170947	2012-08-16	2012-08-16 00:00:00	38000275	0	\N	\N	67441	0	274474001	4170947	
11221	1036	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	68162	0	180256009	4107731	
11408	1058	4107731	1993-01-23	1993-01-23 00:00:00	38000275	0	\N	\N	69340	0	180256009	4107731	
11596	1072	4024289	1979-05-29	1979-05-29 00:00:00	38000275	0	\N	\N	70286	0	19490002	4024289	
11782	1083	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	71072	0	180256009	4107731	
1	1	44783196	1981-08-17	1981-08-17 00:00:00	38000275	0	\N	\N	85	0	699253003	44783196	
188	9	4107731	1994-12-15	1994-12-15 00:00:00	38000275	0	\N	\N	743	0	180256009	4107731	
437	23	4125906	1986-04-28	1986-04-28 00:00:00	38000275	0	\N	\N	1774	0	288086009	4125906	
565	40	4195803	2018-06-14	2018-06-14 00:00:00	38000275	0	\N	\N	2866	0	312681000	4195803	
773	61	4197460	1977-03-04	1977-03-04 00:00:00	38000275	0	\N	\N	4182	0	313191000	4197460	
978	94	4202451	2005-01-28	2005-01-28 00:00:00	38000275	0	\N	\N	6358	0	433112001	4202451	
1123	114	4187458	2006-03-05	2006-03-05 00:00:00	38000275	0	\N	\N	7511	0	415300000	4187458	
1399	135	4151422	2010-10-21	2010-10-21 00:00:00	38000275	0	\N	\N	9083	0	269911007	4151422	
1497	141	4295880	2000-05-16	2000-05-16 00:00:00	38000275	0	\N	\N	9452	0	76601001	4295880	
1684	154	4295880	1995-07-20	1995-07-20 00:00:00	38000275	0	\N	\N	10497	0	76601001	4295880	
1877	173	4151422	1985-07-03	1985-07-03 00:00:00	38000275	0	\N	\N	11740	0	269911007	4151422	
2058	197	4125906	1982-07-12	1982-07-12 00:00:00	38000275	0	\N	\N	13531	0	288086009	4125906	
2245	225	4047491	1966-10-24	1966-10-24 00:00:00	38000275	0	\N	\N	15148	0	1225002	4047491	
2440	245	4151422	2012-11-23	2012-11-23 00:00:00	38000275	0	\N	\N	16456	0	269911007	4151422	
2619	266	4107731	1992-10-26	1992-10-26 00:00:00	38000275	0	\N	\N	17646	0	180256009	4107731	
2806	273	4107731	1990-12-30	1990-12-30 00:00:00	38000275	0	\N	\N	18310	0	180256009	4107731	
2993	286	4170947	2017-06-02	2017-06-02 00:00:00	38000275	0	\N	\N	19047	0	274474001	4170947	
3226	316	4252419	1975-12-14	1975-12-14 00:00:00	38000275	0	\N	\N	20889	0	74016001	4252419	
3367	332	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	22016	0	180256009	4107731	
3555	343	4107731	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	22934	0	180256009	4107731	
3742	357	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	23686	0	180256009	4107731	
3929	399	4151422	2016-12-01	2016-12-01 00:00:00	38000275	0	\N	\N	26156	0	269911007	4151422	
4116	406	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	26723	0	180256009	4107731	
4303	411	4107731	1991-09-07	1991-09-07 00:00:00	38000275	0	\N	\N	27372	0	180256009	4107731	
4490	430	4058899	1941-10-25	1941-10-25 00:00:00	38000275	0	\N	\N	28538	0	168594001	4058899	
4677	442	4293740	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	29287	0	384700001	4293740	
4864	453	4043071	1981-11-03	1981-11-03 00:00:00	38000275	0	\N	\N	30231	0	228557008	4043071	
5051	469	4043071	1944-12-25	1944-12-25 00:00:00	38000275	0	\N	\N	31338	0	228557008	4043071	
5238	489	4107731	1993-04-18	1993-04-18 00:00:00	38000275	0	\N	\N	32738	0	180256009	4107731	
5425	499	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	33380	0	180256009	4107731	
5675	518	4243062	1977-04-24	1977-04-24 00:00:00	38000275	0	\N	\N	34592	0	60027007	4243062	
5799	533	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	35403	0	180256009	4107731	
5990	549	4125906	2011-04-18	2011-04-18 00:00:00	38000275	0	\N	\N	36424	0	288086009	4125906	
6173	563	4107731	1991-01-20	1991-01-20 00:00:00	38000275	0	\N	\N	37214	0	180256009	4107731	
6361	592	4295880	1993-04-09	1993-04-09 00:00:00	38000275	0	\N	\N	39086	0	76601001	4295880	
6547	603	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	39962	0	180256009	4107731	
6734	614	4125906	1986-12-18	1986-12-18 00:00:00	38000275	0	\N	\N	40850	0	288086009	4125906	
6934	636	4078793	2003-06-20	2003-06-20 00:00:00	38000275	0	\N	\N	42134	0	180325003	4078793	
7121	662	4336464	2012-06-06	2012-06-06 00:00:00	38000275	0	\N	\N	43754	0	232717009	4336464	
7295	680	4107731	1991-04-08	1991-04-08 00:00:00	38000275	0	\N	\N	44986	0	180256009	4107731	
7482	693	4163872	1968-09-16	1968-09-16 00:00:00	38000275	0	\N	\N	45891	0	399208008	4163872	
7721	709	4125906	1972-03-04	1972-03-04 00:00:00	38000275	0	\N	\N	46974	0	288086009	4125906	
7856	718	4252419	1970-03-28	1970-03-28 00:00:00	38000275	0	\N	\N	47524	0	74016001	4252419	
8043	733	4252419	2003-09-05	2003-09-05 00:00:00	38000275	0	\N	\N	48643	0	74016001	4252419	
8230	754	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	49954	0	180256009	4107731	
8473	771	4170947	1975-12-13	1975-12-13 00:00:00	38000275	0	\N	\N	51180	0	274474001	4170947	
8604	782	4170947	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	52021	0	274474001	4170947	
8801	800	4252419	1994-06-04	1994-06-04 00:00:00	38000275	0	\N	\N	53093	0	74016001	4252419	
8984	820	4151422	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	54327	0	269911007	4151422	
9165	843	4107731	1996-01-13	1996-01-13 00:00:00	38000275	0	\N	\N	55791	0	180256009	4107731	
9352	859	4107731	1992-01-27	1992-01-27 00:00:00	38000275	0	\N	\N	56834	0	180256009	4107731	
9544	869	4078793	2003-09-19	2003-09-19 00:00:00	38000275	0	\N	\N	57718	0	180325003	4078793	
9734	877	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	58374	0	180256009	4107731	
9913	885	4043071	1988-10-07	1988-10-07 00:00:00	38000275	0	\N	\N	58989	0	228557008	4043071	
10128	902	4293740	1965-03-10	1965-03-10 00:00:00	38000275	0	\N	\N	60066	0	384700001	4293740	
10287	917	4043071	1976-04-11	1976-04-11 00:00:00	38000275	0	\N	\N	60939	0	228557008	4043071	
10485	946	4198190	1976-04-04	1976-04-04 00:00:00	38000275	0	\N	\N	62811	0	80146002	4198190	
10787	962	4243062	1964-03-27	1964-03-27 00:00:00	38000275	0	\N	\N	64026	0	60027007	4243062	
10848	978	4024289	1995-09-29	1995-09-29 00:00:00	38000275	0	\N	\N	65153	0	19490002	4024289	
11067	1024	4024289	2012-08-16	2012-08-16 00:00:00	38000275	0	\N	\N	67441	0	19490002	4024289	
11222	1036	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	68103	0	395142003	4191853	
11409	1058	4107731	1990-10-06	1990-10-06 00:00:00	38000275	0	\N	\N	69465	0	180256009	4107731	
11597	1072	4170947	1979-05-29	1979-05-29 00:00:00	38000275	0	\N	\N	70286	0	274474001	4170947	
11783	1083	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	71161	0	180256009	4107731	
2	1	4125906	1982-09-11	1982-09-11 00:00:00	38000275	0	\N	\N	83	0	288086009	4125906	
189	9	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	749	0	180256009	4107731	
438	23	4125906	1988-05-08	1988-05-08 00:00:00	38000275	0	\N	\N	1775	0	288086009	4125906	
566	40	4058899	2018-06-14	2018-06-14 00:00:00	38000275	0	\N	\N	2866	0	168594001	4058899	
774	61	4062501	1971-01-27	1971-01-27 00:00:00	38000275	0	\N	\N	4151	0	171231001	4062501	
979	94	4151422	1982-07-03	1982-07-03 00:00:00	38000275	0	\N	\N	6340	0	269911007	4151422	
1124	114	4037675	2006-03-05	2006-03-05 00:00:00	38000275	0	\N	\N	7511	0	162676008	4037675	
1400	135	4058899	1988-12-10	1988-12-10 00:00:00	38000275	0	\N	\N	9020	0	168594001	4058899	
1498	141	4295880	2000-08-15	2000-08-15 00:00:00	38000275	0	\N	\N	9446	0	76601001	4295880	
1685	154	4295880	1995-04-20	1995-04-20 00:00:00	38000275	0	\N	\N	10456	0	76601001	4295880	
1878	173	4151422	1983-11-03	1983-11-03 00:00:00	38000275	0	\N	\N	11767	0	269911007	4151422	
2059	197	4151422	1968-09-08	1968-09-08 00:00:00	38000275	0	\N	\N	13534	0	269911007	4151422	
2246	225	4170947	1966-10-24	1966-10-24 00:00:00	38000275	0	\N	\N	15148	0	274474001	4170947	
2441	245	4145310	2015-09-20	2015-09-20 00:00:00	38000275	0	\N	\N	16407	0	268425006	4145310	
2620	266	4107731	1991-09-23	1991-09-23 00:00:00	38000275	0	\N	\N	17751	0	180256009	4107731	
2807	273	4107731	1992-06-07	1992-06-07 00:00:00	38000275	0	\N	\N	18256	0	180256009	4107731	
2994	286	4243062	2017-06-02	2017-06-02 00:00:00	38000275	0	\N	\N	19047	0	60027007	4243062	
3227	316	4125906	1932-05-12	1932-05-12 00:00:00	38000275	0	\N	\N	20888	0	288086009	4125906	
3368	332	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	21984	0	180256009	4107731	
3556	343	4107731	1993-02-13	1993-02-13 00:00:00	38000275	0	\N	\N	22859	0	180256009	4107731	
3743	357	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	23708	0	180256009	4107731	
3930	399	4107731	1992-02-23	1992-02-23 00:00:00	38000275	0	\N	\N	26243	0	180256009	4107731	
4117	406	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	26768	0	180256009	4107731	
4304	411	4107731	1992-02-01	1992-02-01 00:00:00	38000275	0	\N	\N	27350	0	180256009	4107731	
4491	430	4252419	1997-12-05	1997-12-05 00:00:00	38000275	0	\N	\N	28540	0	74016001	4252419	
4678	442	4125906	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	29287	0	288086009	4125906	
4865	453	4043071	1981-06-16	1981-06-16 00:00:00	38000275	0	\N	\N	30182	0	228557008	4043071	
5052	469	4043071	1946-09-16	1946-09-16 00:00:00	38000275	0	\N	\N	31343	0	228557008	4043071	
5239	489	4107731	1991-06-16	1991-06-16 00:00:00	38000275	0	\N	\N	32749	0	180256009	4107731	
5426	499	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	33438	0	180256009	4107731	
5676	518	4058899	2013-07-28	2013-07-28 00:00:00	38000275	0	\N	\N	34595	0	168594001	4058899	
5800	533	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	35422	0	180256009	4107731	
5991	549	4151422	1989-05-19	1989-05-19 00:00:00	38000275	0	\N	\N	36372	0	269911007	4151422	
6174	563	4107731	1990-07-15	1990-07-15 00:00:00	38000275	0	\N	\N	37199	0	180256009	4107731	
6362	592	4295880	1993-10-08	1993-10-08 00:00:00	38000275	0	\N	\N	39115	0	76601001	4295880	
6548	603	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	39920	0	180256009	4107731	
6735	614	4170947	1970-04-27	1970-04-27 00:00:00	38000275	0	\N	\N	40847	0	274474001	4170947	
6935	636	4078793	2012-08-10	2012-08-10 00:00:00	38000275	0	\N	\N	42136	0	180325003	4078793	
7122	662	4293740	1993-10-01	1993-10-01 00:00:00	38000275	0	\N	\N	43752	0	384700001	4293740	
7296	680	4107731	1992-08-24	1992-08-24 00:00:00	38000275	0	\N	\N	45034	0	180256009	4107731	
7483	693	4170947	1968-09-16	1968-09-16 00:00:00	38000275	0	\N	\N	45891	0	274474001	4170947	
7722	709	4330583	1984-07-01	1984-07-01 00:00:00	38000275	0	\N	\N	46978	0	22523008	4330583	
7857	718	4107731	1991-04-13	1991-04-13 00:00:00	38000275	0	\N	\N	47495	0	180256009	4107731	
8044	733	44783196	2003-09-12	2003-09-12 00:00:00	38000275	0	\N	\N	48620	0	699253003	44783196	
8231	754	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	49953	0	180256009	4107731	
8474	771	4024289	1975-12-13	1975-12-13 00:00:00	38000275	0	\N	\N	51180	0	19490002	4024289	
8605	782	4243062	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	52021	0	60027007	4243062	
8802	800	4125906	1996-07-30	1996-07-30 00:00:00	38000275	0	\N	\N	53094	0	288086009	4125906	
8985	821	4151422	2008-11-15	2008-11-15 00:00:00	38000275	0	\N	\N	54382	0	269911007	4151422	
9166	843	4107731	1996-05-18	1996-05-18 00:00:00	38000275	0	\N	\N	55871	0	180256009	4107731	
9353	859	4107731	1992-06-01	1992-06-01 00:00:00	38000275	0	\N	\N	56850	0	180256009	4107731	
9545	869	4125906	1975-09-05	1975-09-05 00:00:00	38000275	0	\N	\N	57726	0	288086009	4125906	
9735	877	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	58397	0	180256009	4107731	
9914	885	4043071	1987-10-30	1987-10-30 00:00:00	38000275	0	\N	\N	59002	0	228557008	4043071	
10129	902	4125906	1965-03-10	1965-03-10 00:00:00	38000275	0	\N	\N	60066	0	288086009	4125906	
10288	917	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	61075	0	180256009	4107731	
10486	946	4151422	1985-08-09	1985-08-09 00:00:00	38000275	0	\N	\N	62812	0	269911007	4151422	
10793	967	4125906	1977-04-06	1977-04-06 00:00:00	38000275	0	\N	\N	64315	0	288086009	4125906	
10849	978	4170947	1995-09-29	1995-09-29 00:00:00	38000275	0	\N	\N	65153	0	274474001	4170947	
11068	1024	4195803	2012-08-16	2012-08-16 00:00:00	38000275	0	\N	\N	67441	0	312681000	4195803	
11223	1036	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	68221	0	180256009	4107731	
11420	1062	4252419	2005-09-04	2005-09-04 00:00:00	38000275	0	\N	\N	69664	0	74016001	4252419	
11598	1072	4151422	2009-04-14	2009-04-14 00:00:00	38000275	0	\N	\N	70264	0	269911007	4151422	
11784	1083	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	71163	0	180256009	4107731	
3	1	4252419	1981-08-10	1981-08-10 00:00:00	38000275	0	\N	\N	82	0	74016001	4252419	
190	9	4107731	1993-07-29	1993-07-29 00:00:00	38000275	0	\N	\N	738	0	180256009	4107731	
453	28	4125906	1991-06-30	1991-06-30 00:00:00	38000275	0	\N	\N	1992	0	288086009	4125906	
567	40	4170947	1961-03-17	1961-03-17 00:00:00	38000275	0	\N	\N	2862	0	274474001	4170947	
775	61	4197460	1978-07-29	1978-07-29 00:00:00	38000275	0	\N	\N	4159	0	313191000	4197460	
980	94	4151422	1972-04-27	1972-04-27 00:00:00	38000275	0	\N	\N	6354	0	269911007	4151422	
1125	114	4326177	2006-03-05	2006-03-05 00:00:00	38000275	0	\N	\N	7511	0	430193006	4326177	
1401	137	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	9158	0	180256009	4107731	
1499	141	4295880	2001-02-13	2001-02-13 00:00:00	38000275	0	\N	\N	9453	0	76601001	4295880	
1686	154	4295880	1999-01-14	1999-01-14 00:00:00	38000275	0	\N	\N	10504	0	76601001	4295880	
1879	173	4163872	1977-11-02	1977-11-02 00:00:00	38000275	0	\N	\N	11763	0	399208008	4163872	
2060	197	4125906	1975-10-26	1975-10-26 00:00:00	38000275	0	\N	\N	13530	0	288086009	4125906	
2247	225	4107731	1990-05-07	1990-05-07 00:00:00	38000275	0	\N	\N	15139	0	180256009	4107731	
2442	245	4010253	1922-07-14	1922-07-14 00:00:00	38000275	0	\N	\N	16444	0	112790001	4010253	
2621	266	4107731	1992-06-01	1992-06-01 00:00:00	38000275	0	\N	\N	17713	0	180256009	4107731	
2808	273	4107731	1991-07-07	1991-07-07 00:00:00	38000275	0	\N	\N	18202	0	180256009	4107731	
2995	286	4195803	2017-06-02	2017-06-02 00:00:00	38000275	0	\N	\N	19047	0	312681000	4195803	
3228	316	4151422	1963-06-01	1963-06-01 00:00:00	38000275	0	\N	\N	20956	0	269911007	4151422	
3370	334	4170947	2009-09-12	2009-09-12 00:00:00	38000275	0	\N	\N	22117	0	274474001	4170947	
3557	343	4107731	1991-09-28	1991-09-28 00:00:00	38000275	0	\N	\N	22978	0	180256009	4107731	
3744	357	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	23657	0	180256009	4107731	
3931	399	4107731	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	26204	0	180256009	4107731	
4118	406	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	26817	0	180256009	4107731	
4305	411	4107731	1991-11-09	1991-11-09 00:00:00	38000275	0	\N	\N	27348	0	180256009	4107731	
4492	430	4195803	2011-11-19	2011-11-19 00:00:00	38000275	0	\N	\N	28547	0	312681000	4195803	
4679	442	4107731	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	29329	0	180256009	4107731	
4866	453	4043071	1982-01-05	1982-01-05 00:00:00	38000275	0	\N	\N	30155	0	228557008	4043071	
5053	469	4043071	1947-01-27	1947-01-27 00:00:00	38000275	0	\N	\N	31213	0	228557008	4043071	
5240	489	4107731	1990-09-16	1990-09-16 00:00:00	38000275	0	\N	\N	32746	0	180256009	4107731	
5427	499	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	33425	0	180256009	4107731	
5677	520	4125906	1969-04-29	1969-04-29 00:00:00	38000275	0	\N	\N	34742	0	288086009	4125906	
5801	533	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	35491	0	180256009	4107731	
5992	550	4195803	1980-03-26	1980-03-26 00:00:00	38000275	0	\N	\N	36459	0	312681000	4195803	
6175	563	4107731	1990-11-18	1990-11-18 00:00:00	38000275	0	\N	\N	37302	0	180256009	4107731	
6363	592	4295880	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	39132	0	76601001	4295880	
6549	603	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	39960	0	180256009	4107731	
6736	614	4163872	1970-04-27	1970-04-27 00:00:00	38000275	0	\N	\N	40847	0	399208008	4163872	
6936	636	4078793	2019-04-12	2019-04-12 00:00:00	38000275	0	\N	\N	42105	0	180325003	4078793	
7123	662	4125906	1993-10-01	1993-10-01 00:00:00	38000275	0	\N	\N	43752	0	288086009	4125906	
7297	680	4107731	1991-04-29	1991-04-29 00:00:00	38000275	0	\N	\N	45022	0	180256009	4107731	
7484	693	4151422	2018-01-11	2018-01-11 00:00:00	38000275	0	\N	\N	45948	0	269911007	4151422	
7723	709	4336464	2005-08-28	2005-08-28 00:00:00	38000275	0	\N	\N	46975	0	232717009	4336464	
7858	718	4107731	1990-12-08	1990-12-08 00:00:00	38000275	0	\N	\N	47430	0	180256009	4107731	
8049	736	4043071	1986-03-26	1986-03-26 00:00:00	38000275	0	\N	\N	48860	0	228557008	4043071	
8232	754	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	49928	0	180256009	4107731	
8475	771	4024289	1980-10-17	1980-10-17 00:00:00	38000275	0	\N	\N	51181	0	19490002	4024289	
8606	782	44783196	1954-06-19	1954-06-19 00:00:00	38000275	0	\N	\N	52010	0	699253003	44783196	
8803	800	44783196	1994-06-11	1994-06-11 00:00:00	38000275	0	\N	\N	53141	0	699253003	44783196	
8986	821	4125906	1960-06-09	1960-06-09 00:00:00	38000275	0	\N	\N	54394	0	288086009	4125906	
9167	843	4191853	1983-05-08	1983-05-08 00:00:00	38000275	0	\N	\N	55804	0	395142003	4191853	
9354	859	4107731	1991-07-22	1991-07-22 00:00:00	38000275	0	\N	\N	56833	0	180256009	4107731	
9546	869	4125906	1947-02-06	1947-02-06 00:00:00	38000275	0	\N	\N	57724	0	288086009	4125906	
9736	877	4125906	2005-10-22	2005-10-22 00:00:00	38000275	0	\N	\N	58442	0	288086009	4125906	
9915	885	4043071	1988-09-02	1988-09-02 00:00:00	38000275	0	\N	\N	58975	0	228557008	4043071	
10136	905	4047491	1974-03-24	1974-03-24 00:00:00	38000275	0	\N	\N	60190	0	1225002	4047491	
10289	917	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	61086	0	180256009	4107731	
10487	946	4047491	1975-04-23	1975-04-23 00:00:00	38000275	0	\N	\N	62809	0	1225002	4047491	
10794	967	4195803	2003-03-12	2003-03-12 00:00:00	38000275	0	\N	\N	64318	0	312681000	4195803	
10850	978	4151422	1985-10-23	1985-10-23 00:00:00	38000275	0	\N	\N	65142	0	269911007	4151422	
11069	1024	4163872	1981-12-17	1981-12-17 00:00:00	38000275	0	\N	\N	67469	0	399208008	4163872	
11224	1036	4170947	2006-10-12	2006-10-12 00:00:00	38000275	0	\N	\N	68138	0	274474001	4170947	
11421	1062	4058899	1979-05-24	1979-05-24 00:00:00	38000275	0	\N	\N	69663	0	168594001	4058899	
11599	1072	4151422	1990-10-20	1990-10-20 00:00:00	38000275	0	\N	\N	70258	0	269911007	4151422	
11785	1083	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	71093	0	180256009	4107731	
4	1	4170947	1958-03-11	1958-03-11 00:00:00	38000275	0	\N	\N	79	0	274474001	4170947	
191	9	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	794	0	180256009	4107731	
456	30	4058899	1977-08-29	1977-08-29 00:00:00	38000275	0	\N	\N	2125	0	168594001	4058899	
568	40	4047491	1961-03-17	1961-03-17 00:00:00	38000275	0	\N	\N	2862	0	1225002	4047491	
778	63	4024289	2008-02-19	2008-02-19 00:00:00	38000275	0	\N	\N	4299	0	19490002	4024289	
981	95	4125906	1990-09-19	1990-09-19 00:00:00	38000275	0	\N	\N	6465	0	288086009	4125906	
1126	114	4202451	2004-11-22	2004-11-22 00:00:00	38000275	0	\N	\N	7548	0	433112001	4202451	
1402	137	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	9212	0	180256009	4107731	
1502	143	4170947	1981-04-27	1981-04-27 00:00:00	38000275	0	\N	\N	9610	0	274474001	4170947	
1687	154	4295880	1999-04-15	1999-04-15 00:00:00	38000275	0	\N	\N	10493	0	76601001	4295880	
1880	173	4170947	1977-11-02	1977-11-02 00:00:00	38000275	0	\N	\N	11763	0	274474001	4170947	
2061	197	4293740	1975-10-26	1975-10-26 00:00:00	38000275	0	\N	\N	13530	0	384700001	4293740	
2248	225	4107731	1990-02-12	1990-02-12 00:00:00	38000275	0	\N	\N	15178	0	180256009	4107731	
2443	245	4195803	1984-02-25	1984-02-25 00:00:00	38000275	0	\N	\N	16402	0	312681000	4195803	
2622	266	4107731	1991-02-04	1991-02-04 00:00:00	38000275	0	\N	\N	17749	0	180256009	4107731	
2809	273	4107731	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	18267	0	180256009	4107731	
2996	286	4195803	2016-05-08	2016-05-08 00:00:00	38000275	0	\N	\N	19046	0	312681000	4195803	
3229	316	4170947	2006-08-31	2006-08-31 00:00:00	38000275	0	\N	\N	20891	0	274474001	4170947	
3371	334	4047491	2009-09-12	2009-09-12 00:00:00	38000275	0	\N	\N	22117	0	1225002	4047491	
3558	343	4107731	1991-02-09	1991-02-09 00:00:00	38000275	0	\N	\N	22946	0	180256009	4107731	
3745	357	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	23690	0	180256009	4107731	
3932	399	4107731	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	26112	0	180256009	4107731	
4119	406	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	26760	0	180256009	4107731	
4306	411	4107731	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	27302	0	180256009	4107731	
4493	430	4151422	1940-11-30	1940-11-30 00:00:00	38000275	0	\N	\N	28515	0	269911007	4151422	
4680	442	4107731	1993-03-27	1993-03-27 00:00:00	38000275	0	\N	\N	29343	0	180256009	4107731	
4867	453	4043071	1984-08-14	1984-08-14 00:00:00	38000275	0	\N	\N	30184	0	228557008	4043071	
5054	469	4043071	1945-12-31	1945-12-31 00:00:00	38000275	0	\N	\N	31210	0	228557008	4043071	
5241	489	4107731	1992-01-12	1992-01-12 00:00:00	38000275	0	\N	\N	32811	0	180256009	4107731	
5428	499	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	33299	0	180256009	4107731	
5678	520	4125906	1980-12-30	1980-12-30 00:00:00	38000275	0	\N	\N	34745	0	288086009	4125906	
5802	533	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	35457	0	180256009	4107731	
5993	550	4243062	1920-12-13	1920-12-13 00:00:00	38000275	0	\N	\N	36445	0	60027007	4243062	
6176	563	4107731	1990-08-05	1990-08-05 00:00:00	38000275	0	\N	\N	37278	0	180256009	4107731	
6364	592	4295880	1993-01-08	1993-01-08 00:00:00	38000275	0	\N	\N	39114	0	76601001	4295880	
6550	603	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	39916	0	180256009	4107731	
6737	614	4170947	1968-05-07	1968-05-07 00:00:00	38000275	0	\N	\N	40846	0	274474001	4170947	
6937	636	4078793	2009-07-24	2009-07-24 00:00:00	38000275	0	\N	\N	42166	0	180325003	4078793	
7124	662	4125906	2018-02-05	2018-02-05 00:00:00	38000275	0	\N	\N	43755	0	288086009	4125906	
7298	680	4107731	1992-06-01	1992-06-01 00:00:00	38000275	0	\N	\N	45071	0	180256009	4107731	
7485	693	4125906	1966-09-13	1966-09-13 00:00:00	38000275	0	\N	\N	45890	0	288086009	4125906	
7724	709	4216130	2005-08-28	2005-08-28 00:00:00	38000275	0	\N	\N	46975	0	415070008	4216130	
7859	718	4107731	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	47452	0	180256009	4107731	
8050	736	4043071	1985-05-29	1985-05-29 00:00:00	38000275	0	\N	\N	48794	0	228557008	4043071	
8233	754	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	49967	0	180256009	4107731	
8476	771	4170947	1980-10-17	1980-10-17 00:00:00	38000275	0	\N	\N	51181	0	274474001	4170947	
8607	782	4195803	1982-03-07	1982-03-07 00:00:00	38000275	0	\N	\N	52050	0	312681000	4195803	
8804	800	4170947	1980-03-14	1980-03-14 00:00:00	38000275	0	\N	\N	53091	0	274474001	4170947	
8987	821	4151422	1967-02-22	1967-02-22 00:00:00	38000275	0	\N	\N	54397	0	269911007	4151422	
9168	843	4107731	1996-09-21	1996-09-21 00:00:00	38000275	0	\N	\N	55812	0	180256009	4107731	
9355	859	4107731	1991-09-23	1991-09-23 00:00:00	38000275	0	\N	\N	56863	0	180256009	4107731	
9547	869	4078793	1994-04-29	1994-04-29 00:00:00	38000275	0	\N	\N	57684	0	180325003	4078793	
9737	877	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	58358	0	180256009	4107731	
9916	885	4125906	2002-07-11	2002-07-11 00:00:00	38000275	0	\N	\N	58982	0	288086009	4125906	
10137	905	4170947	1974-03-24	1974-03-24 00:00:00	38000275	0	\N	\N	60190	0	274474001	4170947	
10290	917	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	61028	0	180256009	4107731	
10488	947	4125906	2009-09-28	2009-09-28 00:00:00	38000275	0	\N	\N	62864	0	288086009	4125906	
10795	967	4058899	2003-03-12	2003-03-12 00:00:00	38000275	0	\N	\N	64318	0	168594001	4058899	
10851	978	4275113	1991-08-04	1991-08-04 00:00:00	38000275	0	\N	\N	65125	0	65200003	4275113	
11070	1024	4125906	1979-04-11	1979-04-11 00:00:00	38000275	0	\N	\N	67437	0	288086009	4125906	
11225	1036	4243062	2006-10-12	2006-10-12 00:00:00	38000275	0	\N	\N	68138	0	60027007	4243062	
11422	1062	4252419	1969-02-03	1969-02-03 00:00:00	38000275	0	\N	\N	69661	0	74016001	4252419	
11600	1072	4293740	2019-04-20	2019-04-20 00:00:00	38000275	0	\N	\N	70289	0	384700001	4293740	
11786	1084	4151422	2019-02-20	2019-02-20 00:00:00	38000275	0	\N	\N	71239	0	269911007	4151422	
5	1	4047491	1958-03-11	1958-03-11 00:00:00	38000275	0	\N	\N	79	0	1225002	4047491	
192	9	4107731	1994-10-13	1994-10-13 00:00:00	38000275	0	\N	\N	755	0	180256009	4107731	
457	30	4197460	1971-02-11	1971-02-11 00:00:00	38000275	0	\N	\N	2122	0	313191000	4197460	
569	40	4151422	1964-12-28	1964-12-28 00:00:00	38000275	0	\N	\N	2799	0	269911007	4151422	
779	63	4195803	2008-02-19	2008-02-19 00:00:00	38000275	0	\N	\N	4299	0	312681000	4195803	
982	95	4151422	1979-02-24	1979-02-24 00:00:00	38000275	0	\N	\N	6419	0	269911007	4151422	
1127	114	4125906	1988-08-14	1988-08-14 00:00:00	38000275	0	\N	\N	7505	0	288086009	4125906	
1403	137	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	9167	0	180256009	4107731	
1503	143	4047491	1981-04-27	1981-04-27 00:00:00	38000275	0	\N	\N	9610	0	1225002	4047491	
1688	154	4295880	1998-04-16	1998-04-16 00:00:00	38000275	0	\N	\N	10460	0	76601001	4295880	
1886	176	44783196	1975-05-23	1975-05-23 00:00:00	38000275	0	\N	\N	11904	0	699253003	44783196	
2066	199	4163872	1954-01-27	1954-01-27 00:00:00	38000275	0	\N	\N	13678	0	399208008	4163872	
2249	227	4047491	1980-07-01	1980-07-01 00:00:00	38000275	0	\N	\N	15306	0	1225002	4047491	
2444	245	4145310	1984-02-25	1984-02-25 00:00:00	38000275	0	\N	\N	16402	0	268425006	4145310	
2623	266	4107731	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	17754	0	180256009	4107731	
2810	273	4107731	1990-04-01	1990-04-01 00:00:00	38000275	0	\N	\N	18292	0	180256009	4107731	
2997	286	4170947	2016-05-08	2016-05-08 00:00:00	38000275	0	\N	\N	19046	0	274474001	4170947	
3230	316	4195803	2006-08-31	2006-08-31 00:00:00	38000275	0	\N	\N	20891	0	312681000	4195803	
3372	334	4151422	1970-04-21	1970-04-21 00:00:00	38000275	0	\N	\N	22123	0	269911007	4151422	
3559	343	4107731	1990-04-21	1990-04-21 00:00:00	38000275	0	\N	\N	22939	0	180256009	4107731	
3746	357	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	23706	0	180256009	4107731	
3933	399	4107731	1990-08-26	1990-08-26 00:00:00	38000275	0	\N	\N	26257	0	180256009	4107731	
4120	406	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	26767	0	180256009	4107731	
4307	411	4107731	1991-07-06	1991-07-06 00:00:00	38000275	0	\N	\N	27287	0	180256009	4107731	
4494	431	4024289	1999-01-22	1999-01-22 00:00:00	38000275	0	\N	\N	28596	0	19490002	4024289	
4681	442	4107731	1991-06-15	1991-06-15 00:00:00	38000275	0	\N	\N	29405	0	180256009	4107731	
4868	453	4043071	1984-01-10	1984-01-10 00:00:00	38000275	0	\N	\N	30175	0	228557008	4043071	
5055	469	4043071	1945-04-02	1945-04-02 00:00:00	38000275	0	\N	\N	31207	0	228557008	4043071	
5242	489	4107731	1991-12-22	1991-12-22 00:00:00	38000275	0	\N	\N	32726	0	180256009	4107731	
5429	499	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	33383	0	180256009	4107731	
5679	520	4125906	1972-03-05	1972-03-05 00:00:00	38000275	0	\N	\N	34743	0	288086009	4125906	
5803	533	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	35486	0	180256009	4107731	
5994	550	4170947	1920-12-13	1920-12-13 00:00:00	38000275	0	\N	\N	36445	0	274474001	4170947	
6177	563	4107731	1990-04-22	1990-04-22 00:00:00	38000275	0	\N	\N	37298	0	180256009	4107731	
6365	592	4295880	1994-04-08	1994-04-08 00:00:00	38000275	0	\N	\N	39133	0	76601001	4295880	
6551	603	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	39928	0	180256009	4107731	
6738	614	4243062	1968-05-07	1968-05-07 00:00:00	38000275	0	\N	\N	40846	0	60027007	4243062	
6938	636	4078793	2004-06-25	2004-06-25 00:00:00	38000275	0	\N	\N	42117	0	180325003	4078793	
7125	664	4107731	2012-07-31	2012-07-31 00:00:00	38000275	0	\N	\N	43846	0	180256009	4107731	
7299	680	4107731	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	45070	0	180256009	4107731	
7486	693	4010253	1962-12-10	1962-12-10 00:00:00	38000275	0	\N	\N	45919	0	112790001	4010253	
7725	709	4151422	1973-11-24	1973-11-24 00:00:00	38000275	0	\N	\N	46964	0	269911007	4151422	
7860	718	4107731	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	47482	0	180256009	4107731	
8051	736	4125906	2010-07-15	2010-07-15 00:00:00	38000275	0	\N	\N	48814	0	288086009	4125906	
8234	754	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	49971	0	180256009	4107731	
8483	774	4125906	1985-08-14	1985-08-14 00:00:00	38000275	0	\N	\N	51390	0	288086009	4125906	
8608	782	4252419	1954-06-12	1954-06-12 00:00:00	38000275	0	\N	\N	52018	0	74016001	4252419	
8805	800	4243062	1980-03-14	1980-03-14 00:00:00	38000275	0	\N	\N	53091	0	60027007	4243062	
8988	821	4243062	1978-04-18	1978-04-18 00:00:00	38000275	0	\N	\N	54396	0	60027007	4243062	
9169	843	4107731	1996-06-29	1996-06-29 00:00:00	38000275	0	\N	\N	55760	0	180256009	4107731	
9356	859	4107731	1992-01-06	1992-01-06 00:00:00	38000275	0	\N	\N	56839	0	180256009	4107731	
9548	869	4078793	1995-05-05	1995-05-05 00:00:00	38000275	0	\N	\N	57715	0	180325003	4078793	
9738	877	4125906	1984-01-27	1984-01-27 00:00:00	38000275	0	\N	\N	58438	0	288086009	4125906	
9917	885	4198190	2012-04-05	2012-04-05 00:00:00	38000275	0	\N	\N	58983	0	80146002	4198190	
10138	905	4125906	1988-02-23	1988-02-23 00:00:00	38000275	0	\N	\N	60194	0	288086009	4125906	
10291	917	4043071	1975-03-30	1975-03-30 00:00:00	38000275	0	\N	\N	60919	0	228557008	4043071	
10489	948	4170947	2000-11-05	2000-11-05 00:00:00	38000275	0	\N	\N	62964	0	274474001	4170947	
10796	967	4202451	1953-04-25	1953-04-25 00:00:00	38000275	0	\N	\N	64346	0	433112001	4202451	
10866	986	4151422	1968-03-23	1968-03-23 00:00:00	38000275	0	\N	\N	65509	0	269911007	4151422	
11071	1024	4243062	1952-02-02	1952-02-02 00:00:00	38000275	0	\N	\N	67436	0	60027007	4243062	
11226	1036	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	68154	0	180256009	4107731	
11423	1062	44783196	1969-02-10	1969-02-10 00:00:00	38000275	0	\N	\N	69704	0	699253003	44783196	
11601	1072	4125906	2019-04-20	2019-04-20 00:00:00	38000275	0	\N	\N	70289	0	288086009	4125906	
11787	1084	4058899	1982-12-11	1982-12-11 00:00:00	38000275	0	\N	\N	71208	0	168594001	4058899	
6	2	4163872	1955-10-22	1955-10-22 00:00:00	38000275	0	\N	\N	103	0	399208008	4163872	
193	9	4191853	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	837	0	395142003	4191853	
458	30	4243062	1975-06-11	1975-06-11 00:00:00	38000275	0	\N	\N	2124	0	60027007	4243062	
570	40	4151422	1972-02-28	1972-02-28 00:00:00	38000275	0	\N	\N	2868	0	269911007	4151422	
780	63	4170947	2008-02-19	2008-02-19 00:00:00	38000275	0	\N	\N	4299	0	274474001	4170947	
983	95	4170947	1969-12-08	1969-12-08 00:00:00	38000275	0	\N	\N	6464	0	274474001	4170947	
1128	115	4151422	2001-06-30	2001-06-30 00:00:00	38000275	0	\N	\N	7576	0	269911007	4151422	
1404	137	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	9199	0	180256009	4107731	
1504	143	4151422	1982-10-29	1982-10-29 00:00:00	38000275	0	\N	\N	9549	0	269911007	4151422	
1689	154	4295880	1996-07-18	1996-07-18 00:00:00	38000275	0	\N	\N	10503	0	76601001	4295880	
1887	176	4252419	1975-05-16	1975-05-16 00:00:00	38000275	0	\N	\N	11929	0	74016001	4252419	
2067	199	4195803	2007-07-06	2007-07-06 00:00:00	38000275	0	\N	\N	13646	0	312681000	4195803	
2250	227	4170947	1980-07-01	1980-07-01 00:00:00	38000275	0	\N	\N	15306	0	274474001	4170947	
2445	245	4195803	2006-07-16	2006-07-16 00:00:00	38000275	0	\N	\N	16382	0	312681000	4195803	
2624	266	4107731	1991-02-25	1991-02-25 00:00:00	38000275	0	\N	\N	17709	0	180256009	4107731	
2811	273	4107731	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	18205	0	180256009	4107731	
2998	286	4243062	2016-05-08	2016-05-08 00:00:00	38000275	0	\N	\N	19046	0	60027007	4243062	
3231	316	4047491	2006-08-31	2006-08-31 00:00:00	38000275	0	\N	\N	20891	0	1225002	4047491	
3373	334	4170947	2005-09-03	2005-09-03 00:00:00	38000275	0	\N	\N	22115	0	274474001	4170947	
3560	343	4107731	1990-08-04	1990-08-04 00:00:00	38000275	0	\N	\N	22945	0	180256009	4107731	
3747	358	4202451	2012-07-31	2012-07-31 00:00:00	38000275	0	\N	\N	23860	0	433112001	4202451	
3934	399	4107731	1991-09-29	1991-09-29 00:00:00	38000275	0	\N	\N	26210	0	180256009	4107731	
4121	406	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	26721	0	180256009	4107731	
4308	411	4107731	1990-03-31	1990-03-31 00:00:00	38000275	0	\N	\N	27312	0	180256009	4107731	
4495	431	4170947	1999-01-22	1999-01-22 00:00:00	38000275	0	\N	\N	28596	0	274474001	4170947	
4682	442	4107731	1991-02-09	1991-02-09 00:00:00	38000275	0	\N	\N	29341	0	180256009	4107731	
4869	453	4043071	1982-04-06	1982-04-06 00:00:00	38000275	0	\N	\N	30232	0	228557008	4043071	
5056	469	4043071	1950-09-04	1950-09-04 00:00:00	38000275	0	\N	\N	31290	0	228557008	4043071	
5243	489	4107731	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	32814	0	180256009	4107731	
5430	499	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	33430	0	180256009	4107731	
5680	520	4125906	1953-12-07	1953-12-07 00:00:00	38000275	0	\N	\N	34749	0	288086009	4125906	
5804	533	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	35482	0	180256009	4107731	
5995	550	4047491	1977-07-29	1977-07-29 00:00:00	38000275	0	\N	\N	36449	0	1225002	4047491	
6178	563	4191853	1990-01-07	1990-01-07 00:00:00	38000275	0	\N	\N	37291	0	395142003	4191853	
6366	592	4295880	1994-10-07	1994-10-07 00:00:00	38000275	0	\N	\N	39088	0	76601001	4295880	
6552	603	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	39890	0	180256009	4107731	
6739	615	4107731	1990-11-17	1990-11-17 00:00:00	38000275	0	\N	\N	40934	0	180256009	4107731	
6939	636	4078793	2002-06-14	2002-06-14 00:00:00	38000275	0	\N	\N	42116	0	180325003	4078793	
7126	664	4107731	2011-02-22	2011-02-22 00:00:00	38000275	0	\N	\N	43920	0	180256009	4107731	
7300	680	4107731	1990-08-20	1990-08-20 00:00:00	38000275	0	\N	\N	44998	0	180256009	4107731	
7487	693	4047491	1984-05-25	1984-05-25 00:00:00	38000275	0	\N	\N	45892	0	1225002	4047491	
7726	710	4326177	1964-04-17	1964-04-17 00:00:00	38000275	0	\N	\N	47041	0	430193006	4326177	
7861	718	4107731	1991-09-28	1991-09-28 00:00:00	38000275	0	\N	\N	47468	0	180256009	4107731	
8052	736	4043071	1985-05-01	1985-05-01 00:00:00	38000275	0	\N	\N	48787	0	228557008	4043071	
8235	754	4058899	1972-09-15	1972-09-15 00:00:00	38000275	0	\N	\N	49824	0	168594001	4058899	
8484	774	4275113	1983-07-09	1983-07-09 00:00:00	38000275	0	\N	\N	51353	0	65200003	4275113	
8609	782	4151422	1921-11-16	1921-11-16 00:00:00	38000275	0	\N	\N	52052	0	269911007	4151422	
8866	806	4151422	1971-02-17	1971-02-17 00:00:00	38000275	0	\N	\N	53507	0	269911007	4151422	
8989	821	4170947	1978-04-18	1978-04-18 00:00:00	38000275	0	\N	\N	54396	0	274474001	4170947	
9170	843	4107731	1997-01-04	1997-01-04 00:00:00	38000275	0	\N	\N	55828	0	180256009	4107731	
9357	859	4107731	1991-02-04	1991-02-04 00:00:00	38000275	0	\N	\N	56823	0	180256009	4107731	
9549	869	4078793	2017-12-08	2017-12-08 00:00:00	38000275	0	\N	\N	57691	0	180325003	4078793	
9739	877	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	58418	0	180256009	4107731	
9918	885	4043071	1987-07-24	1987-07-24 00:00:00	38000275	0	\N	\N	59032	0	228557008	4043071	
10139	905	4181917	1974-09-20	1974-09-20 00:00:00	38000275	0	\N	\N	60191	0	54550000	4181917	
10292	917	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	60957	0	180256009	4107731	
10490	948	4163872	2000-11-05	2000-11-05 00:00:00	38000275	0	\N	\N	62964	0	399208008	4163872	
10797	967	4125906	2019-02-07	2019-02-07 00:00:00	38000275	0	\N	\N	64321	0	288086009	4125906	
10867	986	4151422	1934-05-27	1934-05-27 00:00:00	38000275	0	\N	\N	65447	0	269911007	4151422	
11072	1024	4170947	1952-02-02	1952-02-02 00:00:00	38000275	0	\N	\N	67436	0	274474001	4170947	
11227	1036	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	68180	0	180256009	4107731	
11506	1068	4125906	2004-10-01	2004-10-01 00:00:00	38000275	0	\N	\N	69961	0	288086009	4125906	
11602	1073	4195803	1996-08-29	1996-08-29 00:00:00	38000275	0	\N	\N	70353	0	312681000	4195803	
11788	1085	4058899	2000-07-02	2000-07-02 00:00:00	38000275	0	\N	\N	71267	0	168594001	4058899	
7	2	4125906	1977-04-08	1977-04-08 00:00:00	38000275	0	\N	\N	115	0	288086009	4125906	
194	9	4107731	1994-01-13	1994-01-13 00:00:00	38000275	0	\N	\N	752	0	180256009	4107731	
459	30	4170947	1975-06-11	1975-06-11 00:00:00	38000275	0	\N	\N	2124	0	274474001	4170947	
571	40	4243062	1967-08-13	1967-08-13 00:00:00	38000275	0	\N	\N	2863	0	60027007	4243062	
781	63	4151422	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	4244	0	269911007	4151422	
984	95	4047491	1969-12-08	1969-12-08 00:00:00	38000275	0	\N	\N	6464	0	1225002	4047491	
1129	115	4058899	2006-06-09	2006-06-09 00:00:00	38000275	0	\N	\N	7637	0	168594001	4058899	
1405	137	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	9246	0	180256009	4107731	
1505	144	4151422	1984-01-21	1984-01-21 00:00:00	38000275	0	\N	\N	9630	0	269911007	4151422	
1690	154	4295880	1995-01-19	1995-01-19 00:00:00	38000275	0	\N	\N	10501	0	76601001	4295880	
1888	176	4125906	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	11931	0	288086009	4125906	
2068	199	4047491	2007-07-06	2007-07-06 00:00:00	38000275	0	\N	\N	13646	0	1225002	4047491	
2302	232	4024289	1983-05-07	1983-05-07 00:00:00	38000275	0	\N	\N	15617	0	19490002	4024289	
2446	245	4151422	2014-07-23	2014-07-23 00:00:00	38000275	0	\N	\N	16495	0	269911007	4151422	
2625	266	4107731	1990-06-18	1990-06-18 00:00:00	38000275	0	\N	\N	17744	0	180256009	4107731	
2812	273	4107731	1990-07-15	1990-07-15 00:00:00	38000275	0	\N	\N	18217	0	180256009	4107731	
2999	286	44783196	1979-01-06	1979-01-06 00:00:00	38000275	0	\N	\N	19049	0	699253003	44783196	
3232	316	4125906	2014-02-20	2014-02-20 00:00:00	38000275	0	\N	\N	20985	0	288086009	4125906	
3374	334	4047491	2005-09-03	2005-09-03 00:00:00	38000275	0	\N	\N	22115	0	1225002	4047491	
3561	343	4107731	1992-08-29	1992-08-29 00:00:00	38000275	0	\N	\N	22896	0	180256009	4107731	
3748	359	4151422	1988-01-08	1988-01-08 00:00:00	38000275	0	\N	\N	23889	0	269911007	4151422	
3935	399	4107731	1993-03-28	1993-03-28 00:00:00	38000275	0	\N	\N	26150	0	180256009	4107731	
4122	406	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	26844	0	180256009	4107731	
4309	411	4107731	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	27331	0	180256009	4107731	
4496	431	4195803	1999-01-22	1999-01-22 00:00:00	38000275	0	\N	\N	28596	0	312681000	4195803	
4683	442	4107731	1992-01-11	1992-01-11 00:00:00	38000275	0	\N	\N	29357	0	180256009	4107731	
4870	453	4043071	1985-06-04	1985-06-04 00:00:00	38000275	0	\N	\N	30178	0	228557008	4043071	
5057	469	4043071	1945-12-03	1945-12-03 00:00:00	38000275	0	\N	\N	31337	0	228557008	4043071	
5244	489	4107731	1990-08-05	1990-08-05 00:00:00	38000275	0	\N	\N	32745	0	180256009	4107731	
5431	499	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	33390	0	180256009	4107731	
5681	520	4010253	1983-10-25	1983-10-25 00:00:00	38000275	0	\N	\N	34670	0	112790001	4010253	
5805	533	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	35480	0	180256009	4107731	
5996	550	4195803	1977-07-29	1977-07-29 00:00:00	38000275	0	\N	\N	36449	0	312681000	4195803	
6179	563	4107731	1993-05-09	1993-05-09 00:00:00	38000275	0	\N	\N	37206	0	180256009	4107731	
6367	592	4295880	1994-01-07	1994-01-07 00:00:00	38000275	0	\N	\N	39087	0	76601001	4295880	
6553	603	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	40031	0	180256009	4107731	
6740	615	4107731	1993-05-29	1993-05-29 00:00:00	38000275	0	\N	\N	40959	0	180256009	4107731	
6940	636	4078793	2011-08-05	2011-08-05 00:00:00	38000275	0	\N	\N	42167	0	180325003	4078793	
7127	664	4107731	2011-03-15	2011-03-15 00:00:00	38000275	0	\N	\N	43880	0	180256009	4107731	
7301	680	4107731	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	44987	0	180256009	4107731	
7488	693	4170947	1984-05-25	1984-05-25 00:00:00	38000275	0	\N	\N	45892	0	274474001	4170947	
7727	710	4187458	1964-04-17	1964-04-17 00:00:00	38000275	0	\N	\N	47041	0	415300000	4187458	
7862	718	4107731	1991-11-30	1991-11-30 00:00:00	38000275	0	\N	\N	47480	0	180256009	4107731	
8053	736	4043071	1985-01-30	1985-01-30 00:00:00	38000275	0	\N	\N	48793	0	228557008	4043071	
8236	754	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	49941	0	180256009	4107731	
8485	774	4238715	1985-03-31	1985-03-31 00:00:00	38000275	0	\N	\N	51379	0	68254000	4238715	
8610	782	4293740	1978-12-24	1978-12-24 00:00:00	38000275	0	\N	\N	52020	0	384700001	4293740	
8867	806	4010253	2002-11-26	2002-11-26 00:00:00	38000275	0	\N	\N	53515	0	112790001	4010253	
8990	823	4163872	2017-10-19	2017-10-19 00:00:00	38000275	0	\N	\N	54559	0	399208008	4163872	
9171	843	4107731	1995-08-19	1995-08-19 00:00:00	38000275	0	\N	\N	55867	0	180256009	4107731	
9358	859	4330583	1994-03-02	1994-03-02 00:00:00	38000275	0	\N	\N	56799	0	22523008	4330583	
9550	869	4125906	1952-06-23	1952-06-23 00:00:00	38000275	0	\N	\N	57725	0	288086009	4125906	
9740	877	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	58351	0	180256009	4107731	
9919	885	4043071	1988-01-01	1988-01-01 00:00:00	38000275	0	\N	\N	59033	0	228557008	4043071	
10140	905	4151422	2018-09-22	2018-09-22 00:00:00	38000275	0	\N	\N	60157	0	269911007	4151422	
10293	917	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	61019	0	180256009	4107731	
10491	948	4125906	2007-12-29	2007-12-29 00:00:00	38000275	0	\N	\N	62965	0	288086009	4125906	
10798	967	4047491	2002-02-15	2002-02-15 00:00:00	38000275	0	\N	\N	64317	0	1225002	4047491	
10868	987	4243062	2002-10-27	2002-10-27 00:00:00	38000275	0	\N	\N	65523	0	60027007	4243062	
11073	1025	4151422	1956-09-28	1956-09-28 00:00:00	38000275	0	\N	\N	67570	0	269911007	4151422	
11228	1036	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	68203	0	180256009	4107731	
11507	1068	4125906	2013-07-28	2013-07-28 00:00:00	38000275	0	\N	\N	69963	0	288086009	4125906	
11603	1073	4043071	1945-11-23	1945-11-23 00:00:00	38000275	0	\N	\N	70387	0	228557008	4043071	
11789	1085	4252419	1968-11-12	1968-11-12 00:00:00	38000275	0	\N	\N	71265	0	74016001	4252419	
8	2	4151422	1931-09-03	1931-09-03 00:00:00	38000275	0	\N	\N	123	0	269911007	4151422	
195	9	4107731	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	786	0	180256009	4107731	
460	30	4125906	1980-06-14	1980-06-14 00:00:00	38000275	0	\N	\N	2075	0	288086009	4125906	
572	40	4170947	1967-08-13	1967-08-13 00:00:00	38000275	0	\N	\N	2863	0	274474001	4170947	
782	63	4170947	1973-12-05	1973-12-05 00:00:00	38000275	0	\N	\N	4297	0	274474001	4170947	
985	95	4125906	1968-12-29	1968-12-29 00:00:00	38000275	0	\N	\N	6463	0	288086009	4125906	
1130	116	4125906	2002-04-19	2002-04-19 00:00:00	38000275	0	\N	\N	7692	0	288086009	4125906	
1406	137	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	9215	0	180256009	4107731	
1506	145	4125906	1982-06-01	1982-06-01 00:00:00	38000275	0	\N	\N	9801	0	288086009	4125906	
1691	154	4295880	1998-01-15	1998-01-15 00:00:00	38000275	0	\N	\N	10478	0	76601001	4295880	
1889	177	4202451	2009-11-08	2009-11-08 00:00:00	38000275	0	\N	\N	11982	0	433112001	4202451	
2069	199	4170947	2007-07-06	2007-07-06 00:00:00	38000275	0	\N	\N	13646	0	274474001	4170947	
2303	232	4170947	1983-05-07	1983-05-07 00:00:00	38000275	0	\N	\N	15617	0	274474001	4170947	
2447	245	4163872	1917-05-16	1917-05-16 00:00:00	38000275	0	\N	\N	16420	0	399208008	4163872	
2626	266	4107731	1992-06-22	1992-06-22 00:00:00	38000275	0	\N	\N	17724	0	180256009	4107731	
2813	273	4107731	1991-06-16	1991-06-16 00:00:00	38000275	0	\N	\N	18272	0	180256009	4107731	
3000	286	44783196	1976-10-11	1976-10-11 00:00:00	38000275	0	\N	\N	19088	0	699253003	44783196	
3233	316	4163872	2007-10-25	2007-10-25 00:00:00	38000275	0	\N	\N	20983	0	399208008	4163872	
3375	334	4195803	2005-06-15	2005-06-15 00:00:00	38000275	0	\N	\N	22137	0	312681000	4195803	
3562	343	4107731	1993-03-27	1993-03-27 00:00:00	38000275	0	\N	\N	22860	0	180256009	4107731	
3773	362	4125906	1998-07-03	1998-07-03 00:00:00	38000275	0	\N	\N	24055	0	288086009	4125906	
3936	399	4125906	1972-03-09	1972-03-09 00:00:00	38000275	0	\N	\N	26236	0	288086009	4125906	
4123	406	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	26742	0	180256009	4107731	
4310	411	4107731	1992-04-04	1992-04-04 00:00:00	38000275	0	\N	\N	27291	0	180256009	4107731	
4497	431	4163872	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	28622	0	399208008	4163872	
4684	442	4107731	1991-01-19	1991-01-19 00:00:00	38000275	0	\N	\N	29352	0	180256009	4107731	
4871	453	4043071	1982-08-10	1982-08-10 00:00:00	38000275	0	\N	\N	30233	0	228557008	4043071	
5058	469	4043071	1949-12-12	1949-12-12 00:00:00	38000275	0	\N	\N	31304	0	228557008	4043071	
5245	489	4197460	1976-10-23	1976-10-23 00:00:00	38000275	0	\N	\N	32702	0	313191000	4197460	
5432	499	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	33366	0	180256009	4107731	
5682	520	4125906	2001-12-15	2001-12-15 00:00:00	38000275	0	\N	\N	34747	0	288086009	4125906	
5806	533	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	35475	0	180256009	4107731	
5997	550	4170947	1977-07-29	1977-07-29 00:00:00	38000275	0	\N	\N	36449	0	274474001	4170947	
6180	563	4107731	1991-09-29	1991-09-29 00:00:00	38000275	0	\N	\N	37306	0	180256009	4107731	
6368	592	4295880	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	39085	0	76601001	4295880	
6554	603	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	39897	0	180256009	4107731	
6741	615	4107731	1991-01-19	1991-01-19 00:00:00	38000275	0	\N	\N	41065	0	180256009	4107731	
6941	636	4078793	2008-07-18	2008-07-18 00:00:00	38000275	0	\N	\N	42127	0	180325003	4078793	
7128	664	4107731	2011-02-01	2011-02-01 00:00:00	38000275	0	\N	\N	43822	0	180256009	4107731	
7302	680	4107731	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	44963	0	180256009	4107731	
7490	695	4125906	1969-11-15	1969-11-15 00:00:00	38000275	0	\N	\N	46005	0	288086009	4125906	
7728	710	4037675	1964-04-17	1964-04-17 00:00:00	38000275	0	\N	\N	47041	0	162676008	4037675	
7863	718	4107731	1993-03-06	1993-03-06 00:00:00	38000275	0	\N	\N	47515	0	180256009	4107731	
8054	736	4151422	1982-10-06	1982-10-06 00:00:00	38000275	0	\N	\N	48785	0	269911007	4151422	
8237	754	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	49833	0	180256009	4107731	
8486	774	4047491	2006-11-05	2006-11-05 00:00:00	38000275	0	\N	\N	51391	0	1225002	4047491	
8611	782	4125906	1978-12-24	1978-12-24 00:00:00	38000275	0	\N	\N	52020	0	288086009	4125906	
8868	806	4125906	1967-03-06	1967-03-06 00:00:00	38000275	0	\N	\N	53469	0	288086009	4125906	
8991	823	4170947	2017-10-19	2017-10-19 00:00:00	38000275	0	\N	\N	54559	0	274474001	4170947	
9172	843	4107731	1995-06-17	1995-06-17 00:00:00	38000275	0	\N	\N	55808	0	180256009	4107731	
9359	859	4062501	1961-03-10	1961-03-10 00:00:00	38000275	0	\N	\N	56729	0	171231001	4062501	
9551	869	4078793	2016-12-02	2016-12-02 00:00:00	38000275	0	\N	\N	57721	0	180325003	4078793	
9741	877	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	58422	0	180256009	4107731	
9920	885	4043071	1988-07-29	1988-07-29 00:00:00	38000275	0	\N	\N	59005	0	228557008	4043071	
10141	905	4181917	1977-04-30	1977-04-30 00:00:00	38000275	0	\N	\N	60192	0	54550000	4181917	
10294	917	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	60955	0	180256009	4107731	
10492	948	4058899	1972-05-15	1972-05-15 00:00:00	38000275	0	\N	\N	62962	0	168594001	4058899	
10799	967	4170947	2002-02-15	2002-02-15 00:00:00	38000275	0	\N	\N	64317	0	274474001	4170947	
10869	987	4170947	2002-10-27	2002-10-27 00:00:00	38000275	0	\N	\N	65523	0	274474001	4170947	
11156	1032	4125906	1979-03-21	1979-03-21 00:00:00	38000275	0	\N	\N	67950	0	288086009	4125906	
11229	1036	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	68222	0	180256009	4107731	
11524	1070	4151422	1979-11-27	1979-11-27 00:00:00	38000275	0	\N	\N	70061	0	269911007	4151422	
11604	1073	4043071	1945-08-24	1945-08-24 00:00:00	38000275	0	\N	\N	70419	0	228557008	4043071	
11790	1085	44783196	1968-11-19	1968-11-19 00:00:00	38000275	0	\N	\N	71268	0	699253003	44783196	
9	2	4078793	2007-09-04	2007-09-04 00:00:00	38000275	0	\N	\N	137	0	180325003	4078793	
196	9	4107731	1993-09-30	1993-09-30 00:00:00	38000275	0	\N	\N	774	0	180256009	4107731	
461	30	4010253	2014-04-28	2014-04-28 00:00:00	38000275	0	\N	\N	2132	0	112790001	4010253	
573	40	4202451	2006-11-29	2006-11-29 00:00:00	38000275	0	\N	\N	2834	0	433112001	4202451	
783	63	4243062	1973-12-05	1973-12-05 00:00:00	38000275	0	\N	\N	4297	0	60027007	4243062	
986	95	4125906	2013-06-02	2013-06-02 00:00:00	38000275	0	\N	\N	6468	0	288086009	4125906	
1131	116	4293740	2002-04-19	2002-04-19 00:00:00	38000275	0	\N	\N	7692	0	384700001	4293740	
1407	137	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	9159	0	180256009	4107731	
1507	145	4125906	1979-10-24	1979-10-24 00:00:00	38000275	0	\N	\N	9799	0	288086009	4125906	
1692	155	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	10604	0	180256009	4107731	
1890	177	4293740	2007-09-15	2007-09-15 00:00:00	38000275	0	\N	\N	11969	0	384700001	4293740	
2070	199	4125906	1965-01-26	1965-01-26 00:00:00	38000275	0	\N	\N	13644	0	288086009	4125906	
2304	232	4252419	1959-02-05	1959-02-05 00:00:00	38000275	0	\N	\N	15614	0	74016001	4252419	
2448	246	4151422	2011-08-12	2011-08-12 00:00:00	38000275	0	\N	\N	16582	0	269911007	4151422	
2627	266	4107731	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	17701	0	180256009	4107731	
2814	273	4107731	1991-10-20	1991-10-20 00:00:00	38000275	0	\N	\N	18221	0	180256009	4107731	
3001	286	4252419	1976-10-04	1976-10-04 00:00:00	38000275	0	\N	\N	19038	0	74016001	4252419	
3234	316	4170947	2007-10-25	2007-10-25 00:00:00	38000275	0	\N	\N	20983	0	274474001	4170947	
3376	334	4145310	2006-08-29	2006-08-29 00:00:00	38000275	0	\N	\N	22116	0	268425006	4145310	
3563	343	4107731	1992-06-27	1992-06-27 00:00:00	38000275	0	\N	\N	22981	0	180256009	4107731	
3774	362	4125906	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	24053	0	288086009	4125906	
3937	399	4293740	1986-06-15	1986-06-15 00:00:00	38000275	0	\N	\N	26238	0	384700001	4293740	
4124	406	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	26846	0	180256009	4107731	
4311	411	4191853	1993-07-10	1993-07-10 00:00:00	38000275	0	\N	\N	27261	0	395142003	4191853	
4498	431	4125906	1985-09-18	1985-09-18 00:00:00	38000275	0	\N	\N	28595	0	288086009	4125906	
4685	442	4107731	1990-11-17	1990-11-17 00:00:00	38000275	0	\N	\N	29261	0	180256009	4107731	
4872	453	4043071	1983-02-15	1983-02-15 00:00:00	38000275	0	\N	\N	30235	0	228557008	4043071	
5059	469	4043071	1946-03-04	1946-03-04 00:00:00	38000275	0	\N	\N	31341	0	228557008	4043071	
5246	489	4107731	1990-07-15	1990-07-15 00:00:00	38000275	0	\N	\N	32818	0	180256009	4107731	
5433	499	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	33369	0	180256009	4107731	
5683	520	4195803	2011-01-06	2011-01-06 00:00:00	38000275	0	\N	\N	34741	0	312681000	4195803	
5807	533	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	35474	0	180256009	4107731	
5998	550	4163872	1966-08-23	1966-08-23 00:00:00	38000275	0	\N	\N	36439	0	399208008	4163872	
6181	563	4107731	1990-10-28	1990-10-28 00:00:00	38000275	0	\N	\N	37212	0	180256009	4107731	
6384	596	4170947	1953-09-18	1953-09-18 00:00:00	38000275	0	\N	\N	39390	0	274474001	4170947	
6555	603	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	39921	0	180256009	4107731	
6742	615	4107731	1990-03-10	1990-03-10 00:00:00	38000275	0	\N	\N	41061	0	180256009	4107731	
6942	636	4078793	2015-08-07	2015-08-07 00:00:00	38000275	0	\N	\N	42138	0	180325003	4078793	
7129	664	4107731	2012-10-02	2012-10-02 00:00:00	38000275	0	\N	\N	43894	0	180256009	4107731	
7303	680	4107731	1990-10-01	1990-10-01 00:00:00	38000275	0	\N	\N	44985	0	180256009	4107731	
7491	695	4293740	1969-11-15	1969-11-15 00:00:00	38000275	0	\N	\N	46005	0	384700001	4293740	
7729	710	4058899	1973-02-14	1973-02-14 00:00:00	38000275	0	\N	\N	46996	0	168594001	4058899	
7864	718	4107731	1990-09-15	1990-09-15 00:00:00	38000275	0	\N	\N	47502	0	180256009	4107731	
8055	736	4043071	1986-08-06	1986-08-06 00:00:00	38000275	0	\N	\N	48838	0	228557008	4043071	
8238	754	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	49918	0	180256009	4107731	
8487	774	4170947	2006-11-05	2006-11-05 00:00:00	38000275	0	\N	\N	51391	0	274474001	4170947	
8678	784	4252419	1982-04-01	1982-04-01 00:00:00	38000275	0	\N	\N	52250	0	74016001	4252419	
8869	806	4243062	2010-01-03	2010-01-03 00:00:00	38000275	0	\N	\N	53470	0	60027007	4243062	
8992	823	4035793	2017-01-23	2017-01-23 00:00:00	38000275	0	\N	\N	54584	0	15081005	4035793	
9173	843	4107731	1998-02-28	1998-02-28 00:00:00	38000275	0	\N	\N	55849	0	180256009	4107731	
9360	859	4107731	1990-08-20	1990-08-20 00:00:00	38000275	0	\N	\N	56886	0	180256009	4107731	
9552	869	4078793	2004-09-24	2004-09-24 00:00:00	38000275	0	\N	\N	57688	0	180325003	4078793	
9742	877	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	58423	0	180256009	4107731	
9921	885	4043071	1987-12-04	1987-12-04 00:00:00	38000275	0	\N	\N	58974	0	228557008	4043071	
10142	906	4151422	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	60264	0	269911007	4151422	
10295	917	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	61085	0	180256009	4107731	
10493	948	4252419	1964-05-20	1964-05-20 00:00:00	38000275	0	\N	\N	62960	0	74016001	4252419	
10800	967	4195803	2002-02-15	2002-02-15 00:00:00	38000275	0	\N	\N	64317	0	312681000	4195803	
10870	987	4195803	2013-10-27	2013-10-27 00:00:00	38000275	0	\N	\N	65571	0	312681000	4195803	
11157	1032	4125906	1986-09-01	1986-09-01 00:00:00	38000275	0	\N	\N	67951	0	288086009	4125906	
11230	1036	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	68111	0	180256009	4107731	
11525	1070	4151422	2007-02-11	2007-02-11 00:00:00	38000275	0	\N	\N	70048	0	269911007	4151422	
11605	1073	4047491	1950-09-10	1950-09-10 00:00:00	38000275	0	\N	\N	70300	0	1225002	4047491	
11791	1086	4243062	2015-04-23	2015-04-23 00:00:00	38000275	0	\N	\N	71352	0	60027007	4243062	
10	2	4047491	1924-01-12	1924-01-12 00:00:00	38000275	0	\N	\N	111	0	1225002	4047491	
197	9	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	736	0	180256009	4107731	
468	32	4125906	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	2281	0	288086009	4125906	
574	41	4125906	1979-12-21	1979-12-21 00:00:00	38000275	0	\N	\N	2899	0	288086009	4125906	
784	64	4125906	2000-08-07	2000-08-07 00:00:00	38000275	0	\N	\N	4329	0	288086009	4125906	
987	95	4293740	2013-06-02	2013-06-02 00:00:00	38000275	0	\N	\N	6468	0	384700001	4293740	
1132	116	4058899	1964-06-16	1964-06-16 00:00:00	38000275	0	\N	\N	7653	0	168594001	4058899	
1408	137	4197460	1981-11-07	1981-11-07 00:00:00	38000275	0	\N	\N	9120	0	313191000	4197460	
1508	145	4252419	1973-01-28	1973-01-28 00:00:00	38000275	0	\N	\N	9798	0	74016001	4252419	
1693	155	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	10534	0	395142003	4191853	
1891	177	4125906	2007-09-15	2007-09-15 00:00:00	38000275	0	\N	\N	11969	0	288086009	4125906	
2078	202	4010253	1963-01-03	1963-01-03 00:00:00	38000275	0	\N	\N	13847	0	112790001	4010253	
2305	232	4330583	1998-11-02	1998-11-02 00:00:00	38000275	0	\N	\N	15568	0	22523008	4330583	
2449	246	4062501	1963-12-02	1963-12-02 00:00:00	38000275	0	\N	\N	16519	0	171231001	4062501	
2628	266	4107731	1990-07-09	1990-07-09 00:00:00	38000275	0	\N	\N	17698	0	180256009	4107731	
2815	273	4107731	1993-01-24	1993-01-24 00:00:00	38000275	0	\N	\N	18258	0	180256009	4107731	
3002	286	4151422	1973-07-19	1973-07-19 00:00:00	38000275	0	\N	\N	19119	0	269911007	4151422	
3235	316	4195803	2007-10-25	2007-10-25 00:00:00	38000275	0	\N	\N	20983	0	312681000	4195803	
3377	335	4151422	1986-10-25	1986-10-25 00:00:00	38000275	0	\N	\N	22279	0	269911007	4151422	
3564	343	4107731	1992-06-06	1992-06-06 00:00:00	38000275	0	\N	\N	22881	0	180256009	4107731	
3775	362	4058899	1995-09-17	1995-09-17 00:00:00	38000275	0	\N	\N	24054	0	168594001	4058899	
3938	399	4125906	1986-06-15	1986-06-15 00:00:00	38000275	0	\N	\N	26238	0	288086009	4125906	
4125	406	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	26843	0	180256009	4107731	
4312	411	4107731	1990-06-02	1990-06-02 00:00:00	38000275	0	\N	\N	27394	0	180256009	4107731	
4499	432	4078793	2016-07-04	2016-07-04 00:00:00	38000275	0	\N	\N	28656	0	180325003	4078793	
4686	442	4107731	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	29328	0	180256009	4107731	
4873	453	4043071	1984-06-19	1984-06-19 00:00:00	38000275	0	\N	\N	30193	0	228557008	4043071	
5060	469	4043071	1946-06-24	1946-06-24 00:00:00	38000275	0	\N	\N	31342	0	228557008	4043071	
5247	489	4107731	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	32744	0	180256009	4107731	
5434	499	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	33384	0	180256009	4107731	
5693	525	4125906	2013-03-04	2013-03-04 00:00:00	38000275	0	\N	\N	34963	0	288086009	4125906	
5808	534	4043071	1989-05-26	1989-05-26 00:00:00	38000275	0	\N	\N	35559	0	228557008	4043071	
5999	550	4125906	1962-07-27	1962-07-27 00:00:00	38000275	0	\N	\N	36448	0	288086009	4125906	
6182	563	4107731	1992-08-30	1992-08-30 00:00:00	38000275	0	\N	\N	37221	0	180256009	4107731	
6385	596	4047491	1953-09-18	1953-09-18 00:00:00	38000275	0	\N	\N	39390	0	1225002	4047491	
6556	603	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	39977	0	180256009	4107731	
6743	615	4191853	1993-07-10	1993-07-10 00:00:00	38000275	0	\N	\N	40960	0	395142003	4191853	
6943	636	4078793	2018-04-06	2018-04-06 00:00:00	38000275	0	\N	\N	42168	0	180325003	4078793	
7130	664	4107731	2013-02-05	2013-02-05 00:00:00	38000275	0	\N	\N	43847	0	180256009	4107731	
7304	680	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	45007	0	180256009	4107731	
7492	695	4151422	1990-08-18	1990-08-18 00:00:00	38000275	0	\N	\N	46014	0	269911007	4151422	
7730	710	4125906	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	46997	0	288086009	4125906	
7865	718	4107731	1991-05-25	1991-05-25 00:00:00	38000275	0	\N	\N	47497	0	180256009	4107731	
8056	736	4043071	1985-11-27	1985-11-27 00:00:00	38000275	0	\N	\N	48782	0	228557008	4043071	
8239	754	4047491	1952-07-11	1952-07-11 00:00:00	38000275	0	\N	\N	49821	0	1225002	4047491	
8488	774	4151422	1991-04-16	1991-04-16 00:00:00	38000275	0	\N	\N	51376	0	269911007	4151422	
8679	784	4125906	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	52251	0	288086009	4125906	
8870	806	4195803	2010-01-03	2010-01-03 00:00:00	38000275	0	\N	\N	53470	0	312681000	4195803	
8993	823	4058899	2011-07-23	2011-07-23 00:00:00	38000275	0	\N	\N	54557	0	168594001	4058899	
9174	843	4107731	1998-07-25	1998-07-25 00:00:00	38000275	0	\N	\N	55784	0	180256009	4107731	
9361	859	4107731	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	56828	0	180256009	4107731	
9553	869	4078793	2012-11-09	2012-11-09 00:00:00	38000275	0	\N	\N	57719	0	180325003	4078793	
9743	877	4107731	1993-08-17	1993-08-17 00:00:00	38000275	0	\N	\N	58435	0	180256009	4107731	
9922	887	4024289	1989-11-29	1989-11-29 00:00:00	38000275	0	\N	\N	59104	0	19490002	4024289	
10143	906	4024289	2011-10-07	2011-10-07 00:00:00	38000275	0	\N	\N	60236	0	19490002	4024289	
10296	917	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	60923	0	180256009	4107731	
10494	948	44783196	1964-05-27	1964-05-27 00:00:00	38000275	0	\N	\N	62902	0	699253003	44783196	
10801	967	4125906	1973-01-13	1973-01-13 00:00:00	38000275	0	\N	\N	64314	0	288086009	4125906	
10871	987	4163872	1970-09-29	1970-09-29 00:00:00	38000275	0	\N	\N	65597	0	399208008	4163872	
11158	1032	4010253	1997-12-09	1997-12-09 00:00:00	38000275	0	\N	\N	67910	0	112790001	4010253	
11231	1036	4151422	1981-12-03	1981-12-03 00:00:00	38000275	0	\N	\N	68150	0	269911007	4151422	
11526	1070	4163872	1982-06-05	1982-06-05 00:00:00	38000275	0	\N	\N	70074	0	399208008	4163872	
11606	1073	4170947	1950-09-10	1950-09-10 00:00:00	38000275	0	\N	\N	70300	0	274474001	4170947	
11792	1086	4170947	2015-04-23	2015-04-23 00:00:00	38000275	0	\N	\N	71352	0	274474001	4170947	
11	2	4151422	1994-06-05	1994-06-05 00:00:00	38000275	0	\N	\N	106	0	269911007	4151422	
198	9	4107731	1994-03-17	1994-03-17 00:00:00	38000275	0	\N	\N	740	0	180256009	4107731	
469	32	4151422	1986-07-05	1986-07-05 00:00:00	38000275	0	\N	\N	2270	0	269911007	4151422	
575	41	4293740	1979-12-21	1979-12-21 00:00:00	38000275	0	\N	\N	2899	0	384700001	4293740	
785	64	4293740	2000-08-07	2000-08-07 00:00:00	38000275	0	\N	\N	4329	0	384700001	4293740	
988	96	4035793	1992-04-04	1992-04-04 00:00:00	38000275	0	\N	\N	6495	0	15081005	4035793	
1133	116	4163872	1994-11-27	1994-11-27 00:00:00	38000275	0	\N	\N	7657	0	399208008	4163872	
1409	137	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	9245	0	180256009	4107731	
1509	145	4163872	1977-12-17	1977-12-17 00:00:00	38000275	0	\N	\N	9784	0	399208008	4163872	
1694	155	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	10631	0	180256009	4107731	
1892	177	44783196	2002-05-14	2002-05-14 00:00:00	38000275	0	\N	\N	11981	0	699253003	44783196	
2079	202	4293740	1971-07-29	1971-07-29 00:00:00	38000275	0	\N	\N	13907	0	384700001	4293740	
2306	232	4170947	2016-03-05	2016-03-05 00:00:00	38000275	0	\N	\N	15620	0	274474001	4170947	
2450	246	4170947	1961-11-15	1961-11-15 00:00:00	38000275	0	\N	\N	16583	0	274474001	4170947	
2629	266	4107731	1992-01-27	1992-01-27 00:00:00	38000275	0	\N	\N	17643	0	180256009	4107731	
2816	273	4107731	1990-12-09	1990-12-09 00:00:00	38000275	0	\N	\N	18271	0	180256009	4107731	
3003	286	4125906	1975-10-26	1975-10-26 00:00:00	38000275	0	\N	\N	19037	0	288086009	4125906	
3236	316	44783196	1975-12-21	1975-12-21 00:00:00	38000275	0	\N	\N	20892	0	699253003	44783196	
3378	335	4125906	1982-03-24	1982-03-24 00:00:00	38000275	0	\N	\N	22294	0	288086009	4125906	
3565	343	4107731	1993-05-29	1993-05-29 00:00:00	38000275	0	\N	\N	22886	0	180256009	4107731	
3776	363	4125906	2000-03-08	2000-03-08 00:00:00	38000275	0	\N	\N	24071	0	288086009	4125906	
3939	399	4107731	1990-04-22	1990-04-22 00:00:00	38000275	0	\N	\N	26200	0	180256009	4107731	
4126	406	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	26826	0	180256009	4107731	
4313	411	4107731	1990-12-08	1990-12-08 00:00:00	38000275	0	\N	\N	27369	0	180256009	4107731	
4500	432	4043071	1940-06-04	1940-06-04 00:00:00	38000275	0	\N	\N	28721	0	228557008	4043071	
4687	442	4107731	1990-06-23	1990-06-23 00:00:00	38000275	0	\N	\N	29339	0	180256009	4107731	
4874	453	4043071	1984-05-22	1984-05-22 00:00:00	38000275	0	\N	\N	30183	0	228557008	4043071	
5061	469	4043071	1946-04-29	1946-04-29 00:00:00	38000275	0	\N	\N	31211	0	228557008	4043071	
5248	489	4107731	1991-09-08	1991-09-08 00:00:00	38000275	0	\N	\N	32751	0	180256009	4107731	
5435	499	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	33381	0	180256009	4107731	
5694	525	4293740	2013-03-04	2013-03-04 00:00:00	38000275	0	\N	\N	34963	0	384700001	4293740	
5809	534	4043071	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	35519	0	228557008	4043071	
6001	552	4243062	1962-01-23	1962-01-23 00:00:00	38000275	0	\N	\N	36594	0	60027007	4243062	
6183	563	4107731	1991-05-26	1991-05-26 00:00:00	38000275	0	\N	\N	37260	0	180256009	4107731	
6386	596	4238715	1972-07-25	1972-07-25 00:00:00	38000275	0	\N	\N	39367	0	68254000	4238715	
6557	603	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	39929	0	180256009	4107731	
6744	615	4107731	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	41066	0	180256009	4107731	
6944	636	4058899	2018-01-04	2018-01-04 00:00:00	38000275	0	\N	\N	42161	0	168594001	4058899	
7131	664	4107731	2012-03-06	2012-03-06 00:00:00	38000275	0	\N	\N	43885	0	180256009	4107731	
7305	680	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	45039	0	180256009	4107731	
7496	697	4125906	1973-08-30	1973-08-30 00:00:00	38000275	0	\N	\N	46161	0	288086009	4125906	
7731	711	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	47081	0	180256009	4107731	
7866	718	4107731	1991-07-27	1991-07-27 00:00:00	38000275	0	\N	\N	47506	0	180256009	4107731	
8057	736	4043071	1986-01-22	1986-01-22 00:00:00	38000275	0	\N	\N	48795	0	228557008	4043071	
8240	754	4170947	1952-07-11	1952-07-11 00:00:00	38000275	0	\N	\N	49821	0	274474001	4170947	
8489	775	44783196	2016-05-31	2016-05-31 00:00:00	38000275	0	\N	\N	51436	0	699253003	44783196	
8680	784	4293740	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	52251	0	384700001	4293740	
8871	806	4170947	2010-01-03	2010-01-03 00:00:00	38000275	0	\N	\N	53470	0	274474001	4170947	
8994	823	4035793	2019-02-04	2019-02-04 00:00:00	38000275	0	\N	\N	54601	0	15081005	4035793	
9175	843	4107731	1996-03-16	1996-03-16 00:00:00	38000275	0	\N	\N	55811	0	180256009	4107731	
9362	859	4170947	1996-05-09	1996-05-09 00:00:00	38000275	0	\N	\N	56874	0	274474001	4170947	
9554	869	4057420	2008-10-17	2008-10-17 00:00:00	38000275	0	\N	\N	57763	0	18286008	4057420	
9744	877	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	58427	0	180256009	4107731	
9923	887	4170947	1989-11-29	1989-11-29 00:00:00	38000275	0	\N	\N	59104	0	274474001	4170947	
10144	906	4170947	2011-10-07	2011-10-07 00:00:00	38000275	0	\N	\N	60236	0	274474001	4170947	
10297	917	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	60940	0	180256009	4107731	
10495	948	4170947	1967-05-12	1967-05-12 00:00:00	38000275	0	\N	\N	62961	0	274474001	4170947	
10802	967	4151422	2011-07-09	2011-07-09 00:00:00	38000275	0	\N	\N	64305	0	269911007	4151422	
10872	987	4058899	1965-10-26	1965-10-26 00:00:00	38000275	0	\N	\N	65519	0	168594001	4058899	
11159	1032	4125906	2010-10-03	2010-10-03 00:00:00	38000275	0	\N	\N	67956	0	288086009	4125906	
11232	1036	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	68151	0	180256009	4107731	
23376	2037	4170947	1974-01-30	1974-01-30 00:00:00	38000275	0	\N	\N	135659	0	274474001	4170947	
11607	1073	4043071	1945-10-26	1945-10-26 00:00:00	38000275	0	\N	\N	70405	0	228557008	4043071	
11793	1086	4151422	1993-12-01	1993-12-01 00:00:00	38000275	0	\N	\N	71356	0	269911007	4151422	
12	2	4125906	1952-07-13	1952-07-13 00:00:00	38000275	0	\N	\N	113	0	288086009	4125906	
199	9	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	773	0	180256009	4107731	
470	32	4125906	1956-03-20	1956-03-20 00:00:00	38000275	0	\N	\N	2236	0	288086009	4125906	
576	41	4163872	1989-09-24	1989-09-24 00:00:00	38000275	0	\N	\N	2940	0	399208008	4163872	
786	64	4125906	2003-10-05	2003-10-05 00:00:00	38000275	0	\N	\N	4330	0	288086009	4125906	
989	96	4058899	1931-07-24	1931-07-24 00:00:00	38000275	0	\N	\N	6502	0	168594001	4058899	
1134	116	4151422	1938-03-10	1938-03-10 00:00:00	38000275	0	\N	\N	7703	0	269911007	4151422	
1410	137	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	9214	0	180256009	4107731	
1510	145	4252419	1981-07-06	1981-07-06 00:00:00	38000275	0	\N	\N	9800	0	74016001	4252419	
1695	155	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	10623	0	180256009	4107731	
1893	177	4252419	2002-05-07	2002-05-07 00:00:00	38000275	0	\N	\N	11955	0	74016001	4252419	
2080	202	4125906	1971-07-29	1971-07-29 00:00:00	38000275	0	\N	\N	13907	0	288086009	4125906	
2307	232	4047491	2016-03-05	2016-03-05 00:00:00	38000275	0	\N	\N	15620	0	1225002	4047491	
2451	246	4163872	1961-11-15	1961-11-15 00:00:00	38000275	0	\N	\N	16583	0	399208008	4163872	
2630	266	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	17655	0	180256009	4107731	
2817	273	4107731	1992-01-12	1992-01-12 00:00:00	38000275	0	\N	\N	18235	0	180256009	4107731	
3004	286	4151422	1995-12-27	1995-12-27 00:00:00	38000275	0	\N	\N	19054	0	269911007	4151422	
3237	316	4163872	2012-02-01	2012-02-01 00:00:00	38000275	0	\N	\N	20984	0	399208008	4163872	
3379	335	4293740	1990-07-01	1990-07-01 00:00:00	38000275	0	\N	\N	22295	0	384700001	4293740	
3566	343	4107731	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	22908	0	180256009	4107731	
3777	363	4058899	2005-07-01	2005-07-01 00:00:00	38000275	0	\N	\N	24072	0	168594001	4058899	
3940	399	4107731	1991-02-10	1991-02-10 00:00:00	38000275	0	\N	\N	26137	0	180256009	4107731	
4127	406	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	26734	0	180256009	4107731	
4314	411	4191853	1990-01-06	1990-01-06 00:00:00	38000275	0	\N	\N	27256	0	395142003	4191853	
4501	432	4043071	1939-11-21	1939-11-21 00:00:00	38000275	0	\N	\N	28719	0	228557008	4043071	
4688	442	4107731	1990-08-04	1990-08-04 00:00:00	38000275	0	\N	\N	29315	0	180256009	4107731	
4875	453	4043071	1983-12-06	1983-12-06 00:00:00	38000275	0	\N	\N	30163	0	228557008	4043071	
5062	469	4043071	1945-06-25	1945-06-25 00:00:00	38000275	0	\N	\N	31208	0	228557008	4043071	
5249	489	4107731	1992-11-22	1992-11-22 00:00:00	38000275	0	\N	\N	32815	0	180256009	4107731	
5436	499	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	33437	0	180256009	4107731	
5695	525	4170947	1965-03-25	1965-03-25 00:00:00	38000275	0	\N	\N	34960	0	274474001	4170947	
5810	534	4043071	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	35542	0	228557008	4043071	
6002	552	4170947	1962-01-23	1962-01-23 00:00:00	38000275	0	\N	\N	36594	0	274474001	4170947	
6184	563	4107731	1990-04-01	1990-04-01 00:00:00	38000275	0	\N	\N	37300	0	180256009	4107731	
6387	596	4275113	1968-01-16	1968-01-16 00:00:00	38000275	0	\N	\N	39366	0	65200003	4275113	
6558	603	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	39911	0	180256009	4107731	
6745	615	4107731	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	40975	0	180256009	4107731	
6945	636	4195803	2018-01-04	2018-01-04 00:00:00	38000275	0	\N	\N	42161	0	312681000	4195803	
7132	664	4107731	2013-12-17	2013-12-17 00:00:00	38000275	0	\N	\N	43830	0	180256009	4107731	
7306	680	4107731	1992-02-17	1992-02-17 00:00:00	38000275	0	\N	\N	44990	0	180256009	4107731	
7497	697	4170947	2001-08-17	2001-08-17 00:00:00	38000275	0	\N	\N	46162	0	274474001	4170947	
7732	711	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	47088	0	180256009	4107731	
7867	718	4107731	1992-11-21	1992-11-21 00:00:00	38000275	0	\N	\N	47456	0	180256009	4107731	
8058	736	4043071	1985-10-30	1985-10-30 00:00:00	38000275	0	\N	\N	48850	0	228557008	4043071	
8241	754	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	49955	0	180256009	4107731	
8490	775	4202451	2017-03-15	2017-03-15 00:00:00	38000275	0	\N	\N	51455	0	433112001	4202451	
8681	784	4151422	1979-01-17	1979-01-17 00:00:00	38000275	0	\N	\N	52200	0	269911007	4151422	
8872	807	4145310	1991-10-25	1991-10-25 00:00:00	38000275	0	\N	\N	53545	0	268425006	4145310	
8995	823	4202451	2019-04-15	2019-04-15 00:00:00	38000275	0	\N	\N	54601	0	433112001	4202451	
9176	843	4107731	1996-06-08	1996-06-08 00:00:00	38000275	0	\N	\N	55775	0	180256009	4107731	
9363	859	4047491	1996-05-09	1996-05-09 00:00:00	38000275	0	\N	\N	56874	0	1225002	4047491	
9555	869	4078793	2005-09-30	2005-09-30 00:00:00	38000275	0	\N	\N	57814	0	180325003	4078793	
9745	877	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	58424	0	180256009	4107731	
9924	887	4195803	2018-02-24	2018-02-24 00:00:00	38000275	0	\N	\N	59163	0	312681000	4195803	
10145	906	4293740	1986-12-12	1986-12-12 00:00:00	38000275	0	\N	\N	60234	0	384700001	4293740	
10298	917	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	61059	0	395142003	4191853	
10496	948	4024289	1967-05-12	1967-05-12 00:00:00	38000275	0	\N	\N	62961	0	19490002	4024289	
10803	967	4151422	1994-02-18	1994-02-18 00:00:00	38000275	0	\N	\N	64357	0	269911007	4151422	
10873	987	4125906	2004-02-19	2004-02-19 00:00:00	38000275	0	\N	\N	65579	0	288086009	4125906	
11160	1032	4170947	1969-08-10	1969-08-10 00:00:00	38000275	0	\N	\N	67949	0	274474001	4170947	
11233	1036	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	68199	0	180256009	4107731	
23377	2037	4024289	1974-01-30	1974-01-30 00:00:00	38000275	0	\N	\N	135659	0	19490002	4024289	
11608	1073	4043071	1945-06-29	1945-06-29 00:00:00	38000275	0	\N	\N	70403	0	228557008	4043071	
11794	1086	4125906	1975-09-17	1975-09-17 00:00:00	38000275	0	\N	\N	71349	0	288086009	4125906	
13	2	4058899	1934-01-19	1934-01-19 00:00:00	38000275	0	\N	\N	112	0	168594001	4058899	
200	9	4125906	2012-12-21	2012-12-21 00:00:00	38000275	0	\N	\N	866	0	288086009	4125906	
471	32	4293740	1956-03-20	1956-03-20 00:00:00	38000275	0	\N	\N	2236	0	384700001	4293740	
577	41	4197460	1976-02-10	1976-02-10 00:00:00	38000275	0	\N	\N	2898	0	313191000	4197460	
787	64	4151422	1985-02-28	1985-02-28 00:00:00	38000275	0	\N	\N	4319	0	269911007	4151422	
990	96	4035793	1991-03-30	1991-03-30 00:00:00	38000275	0	\N	\N	6483	0	15081005	4035793	
1135	116	4170947	1944-10-08	1944-10-08 00:00:00	38000275	0	\N	\N	7651	0	274474001	4170947	
1411	137	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	9147	0	180256009	4107731	
1511	145	4195803	2003-05-17	2003-05-17 00:00:00	38000275	0	\N	\N	9805	0	312681000	4195803	
1696	155	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	10518	0	180256009	4107731	
1895	180	4107731	1991-05-30	1991-05-30 00:00:00	38000275	0	\N	\N	12192	0	180256009	4107731	
2081	202	4202451	1997-10-25	1997-10-25 00:00:00	38000275	0	\N	\N	13877	0	433112001	4202451	
2308	232	4195803	2016-03-05	2016-03-05 00:00:00	38000275	0	\N	\N	15620	0	312681000	4195803	
2452	246	4125906	1975-02-03	1975-02-03 00:00:00	38000275	0	\N	\N	16545	0	288086009	4125906	
2631	266	4107731	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	17711	0	180256009	4107731	
2818	273	4107731	1991-12-01	1991-12-01 00:00:00	38000275	0	\N	\N	18234	0	180256009	4107731	
3005	286	4252419	1978-12-30	1978-12-30 00:00:00	38000275	0	\N	\N	19040	0	74016001	4252419	
3238	316	4170947	2012-02-01	2012-02-01 00:00:00	38000275	0	\N	\N	20984	0	274474001	4170947	
3380	335	4125906	1990-07-01	1990-07-01 00:00:00	38000275	0	\N	\N	22295	0	288086009	4125906	
3567	343	4197460	1972-10-19	1972-10-19 00:00:00	38000275	0	\N	\N	22849	0	313191000	4197460	
3778	364	4163872	1988-05-05	1988-05-05 00:00:00	38000275	0	\N	\N	24201	0	399208008	4163872	
3941	399	4107731	1992-01-12	1992-01-12 00:00:00	38000275	0	\N	\N	26242	0	180256009	4107731	
4128	406	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	26819	0	180256009	4107731	
4315	411	4107731	1993-05-08	1993-05-08 00:00:00	38000275	0	\N	\N	27321	0	180256009	4107731	
4502	432	4043071	1939-04-25	1939-04-25 00:00:00	38000275	0	\N	\N	28730	0	228557008	4043071	
4689	443	4170947	2013-05-26	2013-05-26 00:00:00	38000275	0	\N	\N	29432	0	274474001	4170947	
4876	453	4043071	1983-08-02	1983-08-02 00:00:00	38000275	0	\N	\N	30174	0	228557008	4043071	
5063	469	4043071	1947-12-08	1947-12-08 00:00:00	38000275	0	\N	\N	31316	0	228557008	4043071	
5250	489	4107731	1990-06-24	1990-06-24 00:00:00	38000275	0	\N	\N	32721	0	180256009	4107731	
5437	499	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	33376	0	180256009	4107731	
5696	525	4243062	1965-03-25	1965-03-25 00:00:00	38000275	0	\N	\N	34960	0	60027007	4243062	
5811	534	4043071	1992-08-14	1992-08-14 00:00:00	38000275	0	\N	\N	35545	0	228557008	4043071	
6003	552	4195803	2015-06-05	2015-06-05 00:00:00	38000275	0	\N	\N	36614	0	312681000	4195803	
6185	563	4107731	1990-12-30	1990-12-30 00:00:00	38000275	0	\N	\N	37303	0	180256009	4107731	
6388	596	4125906	1962-10-01	1962-10-01 00:00:00	38000275	0	\N	\N	39324	0	288086009	4125906	
6559	603	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	40018	0	180256009	4107731	
6746	615	4107731	1991-10-19	1991-10-19 00:00:00	38000275	0	\N	\N	41068	0	180256009	4107731	
6946	636	4078793	2017-03-31	2017-03-31 00:00:00	38000275	0	\N	\N	42129	0	180325003	4078793	
7133	664	4191853	2010-07-27	2010-07-27 00:00:00	38000275	0	\N	\N	43821	0	395142003	4191853	
7307	680	4107731	1991-02-25	1991-02-25 00:00:00	38000275	0	\N	\N	45028	0	180256009	4107731	
7498	697	4243062	2001-08-17	2001-08-17 00:00:00	38000275	0	\N	\N	46162	0	60027007	4243062	
7733	711	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	47149	0	180256009	4107731	
7868	718	4107731	1990-12-29	1990-12-29 00:00:00	38000275	0	\N	\N	47465	0	180256009	4107731	
8059	736	4043071	1985-07-03	1985-07-03 00:00:00	38000275	0	\N	\N	48848	0	228557008	4043071	
8242	754	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	49852	0	180256009	4107731	
8491	775	4252419	2016-05-24	2016-05-24 00:00:00	38000275	0	\N	\N	51435	0	74016001	4252419	
8682	785	4125906	1984-12-17	1984-12-17 00:00:00	38000275	0	\N	\N	52252	0	288086009	4125906	
8873	807	4198190	1971-01-13	1971-01-13 00:00:00	38000275	0	\N	\N	53555	0	80146002	4198190	
8996	823	4145310	2013-07-12	2013-07-12 00:00:00	38000275	0	\N	\N	54558	0	268425006	4145310	
9177	843	4107731	1995-12-23	1995-12-23 00:00:00	38000275	0	\N	\N	55809	0	180256009	4107731	
9364	859	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	56872	0	180256009	4107731	
9556	869	4202451	2006-09-29	2006-09-29 00:00:00	38000275	0	\N	\N	57814	0	433112001	4202451	
9746	877	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	58380	0	180256009	4107731	
9925	887	4125906	1974-10-05	1974-10-05 00:00:00	38000275	0	\N	\N	59102	0	288086009	4125906	
10146	906	4125906	1986-12-12	1986-12-12 00:00:00	38000275	0	\N	\N	60234	0	288086009	4125906	
10299	917	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	60969	0	180256009	4107731	
10497	949	4151422	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	62987	0	269911007	4151422	
10805	969	4202451	2014-12-07	2014-12-07 00:00:00	38000275	0	\N	\N	64419	0	433112001	4202451	
10877	992	4163872	2009-12-25	2009-12-25 00:00:00	38000275	0	\N	\N	65751	0	399208008	4163872	
11161	1032	4047491	1969-08-10	1969-08-10 00:00:00	38000275	0	\N	\N	67949	0	1225002	4047491	
11234	1036	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	68197	0	180256009	4107731	
23390	2041	4125906	1966-01-15	1966-01-15 00:00:00	38000275	0	\N	\N	135852	0	288086009	4125906	
11609	1073	4043071	1945-05-25	1945-05-25 00:00:00	38000275	0	\N	\N	70416	0	228557008	4043071	
11797	1088	4125906	1976-04-10	1976-04-10 00:00:00	38000275	0	\N	\N	71422	0	288086009	4125906	
14	2	4170947	1990-04-14	1990-04-14 00:00:00	38000275	0	\N	\N	116	0	274474001	4170947	
201	9	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	840	0	180256009	4107731	
472	32	4125906	1959-04-25	1959-04-25 00:00:00	38000275	0	\N	\N	2237	0	288086009	4125906	
578	41	4062501	1975-06-02	1975-06-02 00:00:00	38000275	0	\N	\N	2934	0	171231001	4062501	
788	65	4151422	1996-10-25	1996-10-25 00:00:00	38000275	0	\N	\N	4419	0	269911007	4151422	
991	96	4035793	1995-04-22	1995-04-22 00:00:00	38000275	0	\N	\N	6529	0	15081005	4035793	
1136	116	4163872	1944-10-08	1944-10-08 00:00:00	38000275	0	\N	\N	7651	0	399208008	4163872	
1412	137	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	9155	0	180256009	4107731	
1512	145	4058899	2003-05-17	2003-05-17 00:00:00	38000275	0	\N	\N	9805	0	168594001	4058899	
1697	155	4293740	1985-09-21	1985-09-21 00:00:00	38000275	0	\N	\N	10528	0	384700001	4293740	
1896	180	4059978	2003-02-14	2003-02-14 00:00:00	38000275	0	\N	\N	12078	0	169553002	4059978	
2087	207	4024289	2009-07-25	2009-07-25 00:00:00	38000275	0	\N	\N	14132	0	19490002	4024289	
2309	232	4198190	1963-10-30	1963-10-30 00:00:00	38000275	0	\N	\N	15612	0	80146002	4198190	
2464	248	4058899	1990-04-29	1990-04-29 00:00:00	38000275	0	\N	\N	16666	0	168594001	4058899	
2632	266	4107731	1990-05-07	1990-05-07 00:00:00	38000275	0	\N	\N	17752	0	180256009	4107731	
2819	273	4107731	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	18261	0	180256009	4107731	
3006	286	4125906	2013-07-09	2013-07-09 00:00:00	38000275	0	\N	\N	19045	0	288086009	4125906	
3239	316	4125906	1987-03-23	1987-03-23 00:00:00	38000275	0	\N	\N	20890	0	288086009	4125906	
3447	337	4125906	1965-09-21	1965-09-21 00:00:00	38000275	0	\N	\N	22414	0	288086009	4125906	
3568	343	4107731	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	22910	0	180256009	4107731	
3779	364	4195803	2018-07-05	2018-07-05 00:00:00	38000275	0	\N	\N	24213	0	312681000	4195803	
3942	399	4107731	1991-12-22	1991-12-22 00:00:00	38000275	0	\N	\N	26182	0	180256009	4107731	
4129	406	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	26842	0	180256009	4107731	
4316	411	4107731	1992-04-25	1992-04-25 00:00:00	38000275	0	\N	\N	27374	0	180256009	4107731	
4503	432	4043071	1939-06-27	1939-06-27 00:00:00	38000275	0	\N	\N	28648	0	228557008	4043071	
4690	443	4047491	2013-05-26	2013-05-26 00:00:00	38000275	0	\N	\N	29432	0	1225002	4047491	
4877	453	4043071	1981-09-08	1981-09-08 00:00:00	38000275	0	\N	\N	30154	0	228557008	4043071	
5064	469	4078793	2015-10-10	2015-10-10 00:00:00	38000275	0	\N	\N	31313	0	180325003	4078793	
5251	489	4107731	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	32758	0	180256009	4107731	
5438	499	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	33379	0	180256009	4107731	
5697	525	4010253	1964-06-03	1964-06-03 00:00:00	38000275	0	\N	\N	35011	0	112790001	4010253	
5812	534	4043071	1991-01-03	1991-01-03 00:00:00	38000275	0	\N	\N	35562	0	228557008	4043071	
6004	552	4058899	2015-06-05	2015-06-05 00:00:00	38000275	0	\N	\N	36614	0	168594001	4058899	
6186	563	4107731	1991-07-07	1991-07-07 00:00:00	38000275	0	\N	\N	37261	0	180256009	4107731	
6389	596	4125906	2000-05-03	2000-05-03 00:00:00	38000275	0	\N	\N	39327	0	288086009	4125906	
6560	603	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	39937	0	180256009	4107731	
6747	615	4107731	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	40918	0	180256009	4107731	
6947	636	4078793	2016-08-12	2016-08-12 00:00:00	38000275	0	\N	\N	42107	0	180325003	4078793	
7134	664	4107731	2012-12-25	2012-12-25 00:00:00	38000275	0	\N	\N	43896	0	180256009	4107731	
7308	680	4107731	1991-03-18	1991-03-18 00:00:00	38000275	0	\N	\N	44969	0	180256009	4107731	
7501	700	4326177	2011-06-06	2011-06-06 00:00:00	38000275	0	\N	\N	46242	0	430193006	4326177	
7734	711	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	47170	0	180256009	4107731	
7869	718	4107731	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	47541	0	180256009	4107731	
8060	736	4043071	1985-04-03	1985-04-03 00:00:00	38000275	0	\N	\N	48780	0	228557008	4043071	
8243	754	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	49853	0	180256009	4107731	
8492	775	4170947	1947-05-03	1947-05-03 00:00:00	38000275	0	\N	\N	51447	0	274474001	4170947	
8684	788	4151422	1998-11-08	1998-11-08 00:00:00	38000275	0	\N	\N	52395	0	269911007	4151422	
8874	807	4125906	1965-10-27	1965-10-27 00:00:00	38000275	0	\N	\N	53634	0	288086009	4125906	
8997	823	4035793	2018-01-29	2018-01-29 00:00:00	38000275	0	\N	\N	54517	0	15081005	4035793	
9178	843	4107731	1998-08-15	1998-08-15 00:00:00	38000275	0	\N	\N	55854	0	180256009	4107731	
9365	859	4191853	1990-01-01	1990-01-01 00:00:00	38000275	0	\N	\N	56883	0	395142003	4191853	
9557	869	4078793	2011-11-04	2011-11-04 00:00:00	38000275	0	\N	\N	57817	0	180325003	4078793	
9747	877	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	58375	0	180256009	4107731	
9926	887	4293740	1974-10-05	1974-10-05 00:00:00	38000275	0	\N	\N	59102	0	384700001	4293740	
10153	911	4330583	2009-03-06	2009-03-06 00:00:00	38000275	0	\N	\N	60483	0	22523008	4330583	
10300	917	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	61002	0	180256009	4107731	
10498	949	4151422	1959-11-09	1959-11-09 00:00:00	38000275	0	\N	\N	62985	0	269911007	4151422	
10806	969	4125906	1997-09-24	1997-09-24 00:00:00	38000275	0	\N	\N	64470	0	288086009	4125906	
10878	992	4170947	2009-12-25	2009-12-25 00:00:00	38000275	0	\N	\N	65751	0	274474001	4170947	
11162	1032	4151422	1985-08-09	1985-08-09 00:00:00	38000275	0	\N	\N	67907	0	269911007	4151422	
11235	1036	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	68226	0	180256009	4107731	
23391	2041	4293740	1966-01-15	1966-01-15 00:00:00	38000275	0	\N	\N	135852	0	384700001	4293740	
11610	1073	4043071	1945-04-27	1945-04-27 00:00:00	38000275	0	\N	\N	70309	0	228557008	4043071	
11798	1088	4301346	1995-12-14	1995-12-14 00:00:00	38000275	0	\N	\N	71435	0	387685009	4301346	
15	2	4024289	1990-04-14	1990-04-14 00:00:00	38000275	0	\N	\N	116	0	19490002	4024289	
205	11	4170947	1987-10-03	1987-10-03 00:00:00	38000275	0	\N	\N	989	0	274474001	4170947	
473	32	4151422	1998-10-02	1998-10-02 00:00:00	38000275	0	\N	\N	2200	0	269911007	4151422	
579	42	4151422	1937-09-07	1937-09-07 00:00:00	38000275	0	\N	\N	3062	0	269911007	4151422	
789	65	4151422	2005-09-21	2005-09-21 00:00:00	38000275	0	\N	\N	4397	0	269911007	4151422	
992	96	4035793	1990-03-24	1990-03-24 00:00:00	38000275	0	\N	\N	6494	0	15081005	4035793	
1137	116	4125906	2001-03-04	2001-03-04 00:00:00	38000275	0	\N	\N	7654	0	288086009	4125906	
1413	137	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	9198	0	180256009	4107731	
1513	145	4062501	1952-12-06	1952-12-06 00:00:00	38000275	0	\N	\N	9764	0	171231001	4062501	
1698	155	4125906	1985-09-21	1985-09-21 00:00:00	38000275	0	\N	\N	10528	0	288086009	4125906	
1897	180	4107731	1992-04-09	1992-04-09 00:00:00	38000275	0	\N	\N	12181	0	180256009	4107731	
2088	207	4195803	2009-07-25	2009-07-25 00:00:00	38000275	0	\N	\N	14132	0	312681000	4195803	
2310	232	4151422	2007-08-31	2007-08-31 00:00:00	38000275	0	\N	\N	15637	0	269911007	4151422	
2465	248	4170947	2009-05-19	2009-05-19 00:00:00	38000275	0	\N	\N	16667	0	274474001	4170947	
2633	266	4107731	1991-08-12	1991-08-12 00:00:00	38000275	0	\N	\N	17750	0	180256009	4107731	
2820	273	4107731	1991-05-05	1991-05-05 00:00:00	38000275	0	\N	\N	18313	0	180256009	4107731	
3007	287	4151422	2002-05-07	2002-05-07 00:00:00	38000275	0	\N	\N	19207	0	269911007	4151422	
3240	316	4195803	2012-02-01	2012-02-01 00:00:00	38000275	0	\N	\N	20984	0	312681000	4195803	
3448	337	4125906	2018-11-01	2018-11-01 00:00:00	38000275	0	\N	\N	22416	0	288086009	4125906	
3569	343	4107731	1991-11-09	1991-11-09 00:00:00	38000275	0	\N	\N	22949	0	180256009	4107731	
3780	364	4243062	2018-07-05	2018-07-05 00:00:00	38000275	0	\N	\N	24213	0	60027007	4243062	
3943	399	4191853	1990-01-07	1990-01-07 00:00:00	38000275	0	\N	\N	26131	0	395142003	4191853	
4130	406	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	26780	0	180256009	4107731	
4317	412	4058899	1963-03-13	1963-03-13 00:00:00	38000275	0	\N	\N	27409	0	168594001	4058899	
4504	432	4202451	1974-12-02	1974-12-02 00:00:00	38000275	0	\N	\N	28689	0	433112001	4202451	
4691	443	4125906	2006-03-19	2006-03-19 00:00:00	38000275	0	\N	\N	29430	0	288086009	4125906	
4878	453	4043071	1982-12-14	1982-12-14 00:00:00	38000275	0	\N	\N	30172	0	228557008	4043071	
5065	469	4057420	2013-09-28	2013-09-28 00:00:00	38000275	0	\N	\N	31312	0	18286008	4057420	
5252	489	4107731	1991-07-07	1991-07-07 00:00:00	38000275	0	\N	\N	32823	0	180256009	4107731	
5439	499	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	33443	0	180256009	4107731	
5698	525	4163951	1952-05-22	1952-05-22 00:00:00	38000275	0	\N	\N	34958	0	29303009	4163951	
5813	534	4043071	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	35596	0	228557008	4043071	
6073	558	4202451	2003-09-04	2003-09-04 00:00:00	38000275	0	\N	\N	36972	0	433112001	4202451	
6187	563	4107731	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	37251	0	180256009	4107731	
6390	596	4125906	1982-09-21	1982-09-21 00:00:00	38000275	0	\N	\N	39326	0	288086009	4125906	
6561	603	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	39925	0	180256009	4107731	
6748	615	4107731	1991-09-28	1991-09-28 00:00:00	38000275	0	\N	\N	40937	0	180256009	4107731	
6948	636	4078793	2006-07-07	2006-07-07 00:00:00	38000275	0	\N	\N	42126	0	180325003	4078793	
7135	664	4107731	2013-06-11	2013-06-11 00:00:00	38000275	0	\N	\N	43889	0	180256009	4107731	
7309	680	4107731	1990-02-12	1990-02-12 00:00:00	38000275	0	\N	\N	45005	0	180256009	4107731	
7502	700	4037675	2011-06-06	2011-06-06 00:00:00	38000275	0	\N	\N	46242	0	162676008	4037675	
7735	711	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	47101	0	180256009	4107731	
7870	718	4107731	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	47540	0	180256009	4107731	
8061	736	4043071	1986-02-19	1986-02-19 00:00:00	38000275	0	\N	\N	48851	0	228557008	4043071	
8244	754	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	49832	0	180256009	4107731	
8493	775	4163872	1947-05-03	1947-05-03 00:00:00	38000275	0	\N	\N	51447	0	399208008	4163872	
8685	788	4125906	2015-08-01	2015-08-01 00:00:00	38000275	0	\N	\N	52454	0	288086009	4125906	
8915	812	4125906	1970-01-07	1970-01-07 00:00:00	38000275	0	\N	\N	53887	0	288086009	4125906	
8998	823	4035793	2016-01-18	2016-01-18 00:00:00	38000275	0	\N	\N	54527	0	15081005	4035793	
9179	843	4107731	1997-12-27	1997-12-27 00:00:00	38000275	0	\N	\N	55766	0	180256009	4107731	
9366	859	4107731	1990-05-07	1990-05-07 00:00:00	38000275	0	\N	\N	56820	0	180256009	4107731	
9558	869	4057420	1999-08-27	1999-08-27 00:00:00	38000275	0	\N	\N	57716	0	18286008	4057420	
9748	877	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	58356	0	180256009	4107731	
9935	890	4043071	1970-06-23	1970-06-23 00:00:00	38000275	0	\N	\N	59330	0	228557008	4043071	
10154	911	4191853	1977-06-15	1977-06-15 00:00:00	38000275	0	\N	\N	60471	0	395142003	4191853	
10301	917	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	60984	0	180256009	4107731	
10499	949	4125906	1961-01-30	1961-01-30 00:00:00	38000275	0	\N	\N	63021	0	288086009	4125906	
10807	969	4301346	2004-08-07	2004-08-07 00:00:00	38000275	0	\N	\N	64469	0	387685009	4301346	
10879	992	4195803	2009-12-25	2009-12-25 00:00:00	38000275	0	\N	\N	65751	0	312681000	4195803	
11163	1033	4326177	1999-07-29	1999-07-29 00:00:00	38000275	0	\N	\N	67973	0	430193006	4326177	
11236	1036	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	68115	0	180256009	4107731	
23392	2041	4151422	1974-06-13	1974-06-13 00:00:00	38000275	0	\N	\N	135790	0	269911007	4151422	
11611	1073	4043071	1945-01-26	1945-01-26 00:00:00	38000275	0	\N	\N	70414	0	228557008	4043071	
11799	1088	4151422	1996-10-10	1996-10-10 00:00:00	38000275	0	\N	\N	71462	0	269911007	4151422	
16	2	4195803	1990-04-14	1990-04-14 00:00:00	38000275	0	\N	\N	116	0	312681000	4195803	
206	11	4047491	1987-10-03	1987-10-03 00:00:00	38000275	0	\N	\N	989	0	1225002	4047491	
474	32	4047491	1951-07-17	1951-07-17 00:00:00	38000275	0	\N	\N	2234	0	1225002	4047491	
580	42	4198190	1933-10-29	1933-10-29 00:00:00	38000275	0	\N	\N	3109	0	80146002	4198190	
790	65	4151422	2001-09-15	2001-09-15 00:00:00	38000275	0	\N	\N	4421	0	269911007	4151422	
993	96	4243062	1942-02-26	1942-02-26 00:00:00	38000275	0	\N	\N	6504	0	60027007	4243062	
1138	117	4163872	1984-11-29	1984-11-29 00:00:00	38000275	0	\N	\N	7779	0	399208008	4163872	
1414	137	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	9213	0	180256009	4107731	
1514	145	4125906	1984-04-12	1984-04-12 00:00:00	38000275	0	\N	\N	9802	0	288086009	4125906	
1699	155	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	10562	0	180256009	4107731	
1898	180	4107731	1991-08-01	1991-08-01 00:00:00	38000275	0	\N	\N	12126	0	180256009	4107731	
2089	207	4170947	2009-07-25	2009-07-25 00:00:00	38000275	0	\N	\N	14132	0	274474001	4170947	
2311	232	4125906	1958-02-26	1958-02-26 00:00:00	38000275	0	\N	\N	15613	0	288086009	4125906	
2466	248	4024289	2009-05-19	2009-05-19 00:00:00	38000275	0	\N	\N	16667	0	19490002	4024289	
2634	266	4107731	1991-11-25	1991-11-25 00:00:00	38000275	0	\N	\N	17712	0	180256009	4107731	
2821	273	4107731	1991-02-10	1991-02-10 00:00:00	38000275	0	\N	\N	18311	0	180256009	4107731	
3008	289	4243062	1970-09-15	1970-09-15 00:00:00	38000275	0	\N	\N	19328	0	60027007	4243062	
3241	316	4151422	1996-05-08	1996-05-08 00:00:00	38000275	0	\N	\N	20862	0	269911007	4151422	
3449	337	4170947	1962-06-09	1962-06-09 00:00:00	38000275	0	\N	\N	22471	0	274474001	4170947	
3570	343	4107731	1990-02-17	1990-02-17 00:00:00	38000275	0	\N	\N	22857	0	180256009	4107731	
3781	364	4170947	2018-07-05	2018-07-05 00:00:00	38000275	0	\N	\N	24213	0	274474001	4170947	
3944	399	4107731	1990-08-05	1990-08-05 00:00:00	38000275	0	\N	\N	26177	0	180256009	4107731	
4131	406	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	26762	0	180256009	4107731	
4318	412	4125906	1965-06-30	1965-06-30 00:00:00	38000275	0	\N	\N	27410	0	288086009	4125906	
4505	432	4195803	2001-04-09	2001-04-09 00:00:00	38000275	0	\N	\N	28696	0	312681000	4195803	
4692	443	4125906	1991-06-23	1991-06-23 00:00:00	38000275	0	\N	\N	29428	0	288086009	4125906	
4879	453	4043071	1983-05-31	1983-05-31 00:00:00	38000275	0	\N	\N	30160	0	228557008	4043071	
5066	469	4078793	2018-10-27	2018-10-27 00:00:00	38000275	0	\N	\N	31374	0	180325003	4078793	
5253	489	4191853	1976-11-03	1976-11-03 00:00:00	38000275	0	\N	\N	32754	0	395142003	4191853	
5440	499	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	33368	0	180256009	4107731	
5699	525	4202832	1952-05-22	1952-05-22 00:00:00	38000275	0	\N	\N	34958	0	52765003	4202832	
5814	534	4238715	2001-10-02	2001-10-02 00:00:00	38000275	0	\N	\N	35574	0	68254000	4238715	
6074	558	4043071	1970-08-28	1970-08-28 00:00:00	38000275	0	\N	\N	37025	0	228557008	4043071	
6188	563	4107731	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	37267	0	180256009	4107731	
6391	596	4125906	1979-12-15	1979-12-15 00:00:00	38000275	0	\N	\N	39325	0	288086009	4125906	
6562	603	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	39948	0	180256009	4107731	
6749	615	4107731	1990-08-04	1990-08-04 00:00:00	38000275	0	\N	\N	40916	0	180256009	4107731	
6949	636	4078793	2010-07-30	2010-07-30 00:00:00	38000275	0	\N	\N	42128	0	180325003	4078793	
7136	664	4107731	2010-08-17	2010-08-17 00:00:00	38000275	0	\N	\N	43867	0	180256009	4107731	
7310	680	4107731	1992-07-13	1992-07-13 00:00:00	38000275	0	\N	\N	45033	0	180256009	4107731	
7503	700	4187458	2011-06-06	2011-06-06 00:00:00	38000275	0	\N	\N	46242	0	415300000	4187458	
7736	711	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	47079	0	180256009	4107731	
7871	718	4107731	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	47508	0	180256009	4107731	
8062	736	4043071	1985-12-25	1985-12-25 00:00:00	38000275	0	\N	\N	48789	0	228557008	4043071	
8245	754	4191853	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	49994	0	395142003	4191853	
8494	775	4151422	1962-07-23	1962-07-23 00:00:00	38000275	0	\N	\N	51453	0	269911007	4151422	
8686	789	4125906	2000-06-25	2000-06-25 00:00:00	38000275	0	\N	\N	52460	0	288086009	4125906	
8916	812	4170947	1979-09-01	1979-09-01 00:00:00	38000275	0	\N	\N	53888	0	274474001	4170947	
8999	823	4195803	2005-01-17	2005-01-17 00:00:00	38000275	0	\N	\N	54579	0	312681000	4195803	
9180	843	4107731	1997-03-08	1997-03-08 00:00:00	38000275	0	\N	\N	55844	0	180256009	4107731	
9367	859	4107731	1991-09-02	1991-09-02 00:00:00	38000275	0	\N	\N	56836	0	180256009	4107731	
9559	869	4078793	2018-12-14	2018-12-14 00:00:00	38000275	0	\N	\N	57818	0	180325003	4078793	
9749	877	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	58373	0	180256009	4107731	
9936	890	4043071	1970-09-15	1970-09-15 00:00:00	38000275	0	\N	\N	59331	0	228557008	4043071	
10155	911	4151422	1986-01-16	1986-01-16 00:00:00	38000275	0	\N	\N	60490	0	269911007	4151422	
10302	917	4043071	1975-12-28	1975-12-28 00:00:00	38000275	0	\N	\N	61070	0	228557008	4043071	
10500	949	4058899	1974-07-05	1974-07-05 00:00:00	38000275	0	\N	\N	63022	0	168594001	4058899	
10808	970	4125906	1996-07-29	1996-07-29 00:00:00	38000275	0	\N	\N	64476	0	288086009	4125906	
10880	992	4170947	1997-02-01	1997-02-01 00:00:00	38000275	0	\N	\N	65750	0	274474001	4170947	
11164	1033	4187458	1999-07-29	1999-07-29 00:00:00	38000275	0	\N	\N	67973	0	415300000	4187458	
11237	1036	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	68098	0	180256009	4107731	
23393	2043	4170947	1973-01-09	1973-01-09 00:00:00	38000275	0	\N	\N	135903	0	274474001	4170947	
11612	1073	4170947	2017-02-14	2017-02-14 00:00:00	38000275	0	\N	\N	70305	0	274474001	4170947	
11800	1088	4293740	1988-01-29	1988-01-29 00:00:00	38000275	0	\N	\N	71423	0	384700001	4293740	
17	2	4170947	1924-01-12	1924-01-12 00:00:00	38000275	0	\N	\N	111	0	274474001	4170947	
207	11	4170947	1998-04-02	1998-04-02 00:00:00	38000275	0	\N	\N	993	0	274474001	4170947	
475	32	4170947	1951-07-17	1951-07-17 00:00:00	38000275	0	\N	\N	2234	0	274474001	4170947	
581	42	4170947	1970-06-04	1970-06-04 00:00:00	38000275	0	\N	\N	3106	0	274474001	4170947	
791	65	4058899	2018-07-31	2018-07-31 00:00:00	38000275	0	\N	\N	4446	0	168594001	4058899	
994	96	4170947	1942-02-26	1942-02-26 00:00:00	38000275	0	\N	\N	6504	0	274474001	4170947	
1139	117	4058899	1982-09-22	1982-09-22 00:00:00	38000275	0	\N	\N	7803	0	168594001	4058899	
1415	137	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	9174	0	180256009	4107731	
1593	148	4125906	1980-09-04	1980-09-04 00:00:00	38000275	0	\N	\N	9980	0	288086009	4125906	
1700	155	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	10625	0	180256009	4107731	
1899	180	4107731	1991-01-03	1991-01-03 00:00:00	38000275	0	\N	\N	12167	0	180256009	4107731	
2090	207	4195803	2011-04-10	2011-04-10 00:00:00	38000275	0	\N	\N	14096	0	312681000	4195803	
2312	232	44783196	1959-02-12	1959-02-12 00:00:00	38000275	0	\N	\N	15596	0	699253003	44783196	
2467	248	4243062	1982-11-07	1982-11-07 00:00:00	38000275	0	\N	\N	16664	0	60027007	4243062	
2635	266	4107731	1992-12-28	1992-12-28 00:00:00	38000275	0	\N	\N	17761	0	180256009	4107731	
2822	273	4107731	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	18220	0	180256009	4107731	
3009	289	4170947	1970-09-15	1970-09-15 00:00:00	38000275	0	\N	\N	19328	0	274474001	4170947	
3249	318	4043071	1966-08-07	1966-08-07 00:00:00	38000275	0	\N	\N	21048	0	228557008	4043071	
3450	337	4024289	1962-06-09	1962-06-09 00:00:00	38000275	0	\N	\N	22471	0	19490002	4024289	
3571	343	4107731	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	22977	0	180256009	4107731	
3782	364	4125906	1991-08-21	1991-08-21 00:00:00	38000275	0	\N	\N	24211	0	288086009	4125906	
3945	399	4107731	1991-03-03	1991-03-03 00:00:00	38000275	0	\N	\N	26258	0	180256009	4107731	
4132	406	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	26724	0	180256009	4107731	
4319	412	4202451	2004-06-18	2004-06-18 00:00:00	38000275	0	\N	\N	27423	0	433112001	4202451	
4506	432	4043071	1938-11-01	1938-11-01 00:00:00	38000275	0	\N	\N	28740	0	228557008	4043071	
4693	443	4145310	2012-05-01	2012-05-01 00:00:00	38000275	0	\N	\N	29431	0	268425006	4145310	
4880	453	4043071	1985-01-22	1985-01-22 00:00:00	38000275	0	\N	\N	30247	0	228557008	4043071	
5067	469	4043071	1949-06-27	1949-06-27 00:00:00	38000275	0	\N	\N	31287	0	228557008	4043071	
5254	489	4107731	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	32720	0	180256009	4107731	
5441	499	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	33389	0	180256009	4107731	
5700	525	42535580	1952-05-22	1952-05-22 00:00:00	38000275	0	\N	\N	34958	0	426701000119108	42535580	
5815	534	4043071	1988-11-24	1988-11-24 00:00:00	38000275	0	\N	\N	35593	0	228557008	4043071	
6075	558	4043071	1970-03-20	1970-03-20 00:00:00	38000275	0	\N	\N	37024	0	228557008	4043071	
6189	564	4125906	2007-09-04	2007-09-04 00:00:00	38000275	0	\N	\N	37343	0	288086009	4125906	
6392	597	4125906	1984-06-30	1984-06-30 00:00:00	38000275	0	\N	\N	39457	0	288086009	4125906	
6563	603	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	39972	0	180256009	4107731	
6750	615	4107731	1990-06-02	1990-06-02 00:00:00	38000275	0	\N	\N	40929	0	180256009	4107731	
6950	636	4078793	2001-06-08	2001-06-08 00:00:00	38000275	0	\N	\N	42133	0	180325003	4078793	
7137	664	4170947	2005-04-09	2005-04-09 00:00:00	38000275	0	\N	\N	43904	0	274474001	4170947	
7311	680	4107731	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	45021	0	180256009	4107731	
7504	700	4125906	2017-06-11	2017-06-11 00:00:00	38000275	0	\N	\N	46233	0	288086009	4125906	
7737	711	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	47179	0	180256009	4107731	
7872	718	4107731	1990-01-27	1990-01-27 00:00:00	38000275	0	\N	\N	47426	0	180256009	4107731	
8063	736	4043071	1985-02-27	1985-02-27 00:00:00	38000275	0	\N	\N	48779	0	228557008	4043071	
8246	754	4107731	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	49956	0	180256009	4107731	
8495	775	4151422	2012-09-06	2012-09-06 00:00:00	38000275	0	\N	\N	51411	0	269911007	4151422	
8687	789	4047491	1991-02-22	1991-02-22 00:00:00	38000275	0	\N	\N	52458	0	1225002	4047491	
8917	812	4163872	1979-09-01	1979-09-01 00:00:00	38000275	0	\N	\N	53888	0	399208008	4163872	
9000	823	4198190	1977-11-14	1977-11-14 00:00:00	38000275	0	\N	\N	54560	0	80146002	4198190	
9181	843	4107731	1997-05-31	1997-05-31 00:00:00	38000275	0	\N	\N	55846	0	180256009	4107731	
9368	859	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	56843	0	180256009	4107731	
9560	869	4078793	2010-10-29	2010-10-29 00:00:00	38000275	0	\N	\N	57764	0	180325003	4078793	
9750	877	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	58452	0	180256009	4107731	
9937	890	4058899	1961-06-17	1961-06-17 00:00:00	38000275	0	\N	\N	59325	0	168594001	4058899	
10156	911	4197460	1984-05-24	1984-05-24 00:00:00	38000275	0	\N	\N	60479	0	313191000	4197460	
10303	917	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	60958	0	180256009	4107731	
10501	950	4043071	1981-09-24	1981-09-24 00:00:00	38000275	0	\N	\N	63083	0	228557008	4043071	
10809	970	4163872	1967-11-28	1967-11-28 00:00:00	38000275	0	\N	\N	64519	0	399208008	4163872	
10881	992	4024289	1997-02-01	1997-02-01 00:00:00	38000275	0	\N	\N	65750	0	19490002	4024289	
11165	1033	4170947	1980-12-20	1980-12-20 00:00:00	38000275	0	\N	\N	67968	0	274474001	4170947	
11238	1036	4062501	1971-09-12	1971-09-12 00:00:00	38000275	0	\N	\N	68092	0	171231001	4062501	
23394	2043	4024289	1973-01-09	1973-01-09 00:00:00	38000275	0	\N	\N	135903	0	19490002	4024289	
11613	1073	4047491	2017-02-14	2017-02-14 00:00:00	38000275	0	\N	\N	70305	0	1225002	4047491	
11801	1088	4125906	1988-01-29	1988-01-29 00:00:00	38000275	0	\N	\N	71423	0	288086009	4125906	
18	2	4151422	1996-04-10	1996-04-10 00:00:00	38000275	0	\N	\N	107	0	269911007	4151422	
208	11	4243062	1998-04-02	1998-04-02 00:00:00	38000275	0	\N	\N	993	0	60027007	4243062	
485	35	4238715	1981-05-26	1981-05-26 00:00:00	38000275	0	\N	\N	2438	0	68254000	4238715	
582	42	4024289	1970-06-04	1970-06-04 00:00:00	38000275	0	\N	\N	3106	0	19490002	4024289	
792	65	4195803	2018-07-31	2018-07-31 00:00:00	38000275	0	\N	\N	4446	0	312681000	4195803	
995	96	4035793	1989-03-18	1989-03-18 00:00:00	38000275	0	\N	\N	6493	0	15081005	4035793	
1142	119	4186930	1978-12-05	1978-12-05 00:00:00	38000275	0	\N	\N	7871	0	46706006	4186930	
1416	137	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	9170	0	180256009	4107731	
1594	148	4145310	1993-06-12	1993-06-12 00:00:00	38000275	0	\N	\N	9981	0	268425006	4145310	
1701	155	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	10603	0	180256009	4107731	
1900	180	4107731	1992-04-30	1992-04-30 00:00:00	38000275	0	\N	\N	12129	0	180256009	4107731	
2091	207	4163872	1996-10-25	1996-10-25 00:00:00	38000275	0	\N	\N	14104	0	399208008	4163872	
2318	235	4181917	1992-09-25	1992-09-25 00:00:00	38000275	0	\N	\N	15758	0	54550000	4181917	
2468	248	4170947	1982-11-07	1982-11-07 00:00:00	38000275	0	\N	\N	16664	0	274474001	4170947	
2636	266	4107731	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	17645	0	180256009	4107731	
2823	273	4107731	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	18277	0	180256009	4107731	
3023	292	4151422	1985-01-26	1985-01-26 00:00:00	38000275	0	\N	\N	19469	0	269911007	4151422	
3250	318	4043071	1966-07-03	1966-07-03 00:00:00	38000275	0	\N	\N	21110	0	228557008	4043071	
3451	338	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	22575	0	180256009	4107731	
3572	343	4107731	1992-04-04	1992-04-04 00:00:00	38000275	0	\N	\N	22979	0	180256009	4107731	
3783	364	4293740	1961-03-10	1961-03-10 00:00:00	38000275	0	\N	\N	24210	0	384700001	4293740	
3946	399	4107731	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	26117	0	180256009	4107731	
4133	406	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	26775	0	180256009	4107731	
4322	418	4163872	2004-06-26	2004-06-26 00:00:00	38000275	0	\N	\N	27666	0	399208008	4163872	
4507	432	4043071	1939-05-23	1939-05-23 00:00:00	38000275	0	\N	\N	28647	0	228557008	4043071	
4694	443	4170947	1984-03-02	1984-03-02 00:00:00	38000275	0	\N	\N	29426	0	274474001	4170947	
4881	453	4043071	1983-10-04	1983-10-04 00:00:00	38000275	0	\N	\N	30207	0	228557008	4043071	
5068	469	4043071	1950-04-17	1950-04-17 00:00:00	38000275	0	\N	\N	31321	0	228557008	4043071	
5255	489	4107731	1992-08-09	1992-08-09 00:00:00	38000275	0	\N	\N	32728	0	180256009	4107731	
5442	499	4125906	1987-02-26	1987-02-26 00:00:00	38000275	0	\N	\N	33418	0	288086009	4125906	
5701	525	4163971	1952-05-22	1952-05-22 00:00:00	38000275	0	\N	\N	34958	0	45595009	4163971	
5816	534	4043071	1991-08-09	1991-08-09 00:00:00	38000275	0	\N	\N	35613	0	228557008	4043071	
6076	558	4125906	2003-11-05	2003-11-05 00:00:00	38000275	0	\N	\N	36978	0	288086009	4125906	
6190	564	4125906	1996-06-21	1996-06-21 00:00:00	38000275	0	\N	\N	37341	0	288086009	4125906	
6393	597	4151422	1966-10-06	1966-10-06 00:00:00	38000275	0	\N	\N	39423	0	269911007	4151422	
6564	603	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	40016	0	180256009	4107731	
6751	615	4107731	1991-12-21	1991-12-21 00:00:00	38000275	0	\N	\N	40939	0	180256009	4107731	
6951	636	4078793	2007-07-13	2007-07-13 00:00:00	38000275	0	\N	\N	42165	0	180325003	4078793	
7138	664	4047491	2005-04-09	2005-04-09 00:00:00	38000275	0	\N	\N	43904	0	1225002	4047491	
7312	680	4107731	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	44992	0	180256009	4107731	
7505	700	4151422	2003-05-06	2003-05-06 00:00:00	38000275	0	\N	\N	46241	0	269911007	4151422	
7738	711	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	47113	0	180256009	4107731	
7873	718	4107731	1991-10-19	1991-10-19 00:00:00	38000275	0	\N	\N	47479	0	180256009	4107731	
8064	736	4010253	2008-06-10	2008-06-10 00:00:00	38000275	0	\N	\N	48813	0	112790001	4010253	
8247	754	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	49898	0	180256009	4107731	
8496	776	4252419	2011-08-16	2011-08-16 00:00:00	38000275	0	\N	\N	51573	0	74016001	4252419	
8688	789	4170947	1991-02-22	1991-02-22 00:00:00	38000275	0	\N	\N	52458	0	274474001	4170947	
8941	814	4163872	2003-04-15	2003-04-15 00:00:00	38000275	0	\N	\N	53973	0	399208008	4163872	
9001	825	4151422	2010-04-13	2010-04-13 00:00:00	38000275	0	\N	\N	54643	0	269911007	4151422	
9182	843	4107731	1997-08-02	1997-08-02 00:00:00	38000275	0	\N	\N	55779	0	180256009	4107731	
9369	859	4107731	1992-03-09	1992-03-09 00:00:00	38000275	0	\N	\N	56848	0	180256009	4107731	
9561	869	4057420	2002-09-13	2002-09-13 00:00:00	38000275	0	\N	\N	57687	0	18286008	4057420	
9751	877	4107731	1993-09-07	1993-09-07 00:00:00	38000275	0	\N	\N	58365	0	180256009	4107731	
9938	890	4163872	1982-06-25	1982-06-25 00:00:00	38000275	0	\N	\N	59328	0	399208008	4163872	
10233	914	4170947	2015-06-09	2015-06-09 00:00:00	38000275	0	\N	\N	60733	0	274474001	4170947	
10304	917	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	61088	0	180256009	4107731	
10502	950	4043071	1982-01-07	1982-01-07 00:00:00	38000275	0	\N	\N	63110	0	228557008	4043071	
10810	970	4163872	1966-12-24	1966-12-24 00:00:00	38000275	0	\N	\N	64488	0	399208008	4163872	
10882	992	4187458	1969-08-19	1969-08-19 00:00:00	38000275	0	\N	\N	65770	0	415300000	4187458	
11166	1033	4047491	1980-12-20	1980-12-20 00:00:00	38000275	0	\N	\N	67968	0	1225002	4047491	
11239	1036	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	68179	0	180256009	4107731	
23395	2043	4151422	1973-12-30	1973-12-30 00:00:00	38000275	0	\N	\N	135915	0	269911007	4151422	
11614	1073	4145310	2010-08-20	2010-08-20 00:00:00	38000275	0	\N	\N	70304	0	268425006	4145310	
11802	1088	4163872	1987-10-20	1987-10-20 00:00:00	38000275	0	\N	\N	71406	0	399208008	4163872	
19	2	4195803	1993-03-29	1993-03-29 00:00:00	38000275	0	\N	\N	117	0	312681000	4195803	
209	11	4170947	1966-08-24	1966-08-24 00:00:00	38000275	0	\N	\N	988	0	274474001	4170947	
486	35	4243062	1993-04-28	1993-04-28 00:00:00	38000275	0	\N	\N	2393	0	60027007	4243062	
583	42	4195803	1970-06-04	1970-06-04 00:00:00	38000275	0	\N	\N	3106	0	312681000	4195803	
793	66	4163872	1998-04-18	1998-04-18 00:00:00	38000275	0	\N	\N	4505	0	399208008	4163872	
996	96	4202451	1989-09-16	1989-09-16 00:00:00	38000275	0	\N	\N	6493	0	433112001	4202451	
1143	119	4238715	1983-02-01	1983-02-01 00:00:00	38000275	0	\N	\N	7941	0	68254000	4238715	
1417	137	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	9145	0	180256009	4107731	
1595	149	4151422	1947-01-21	1947-01-21 00:00:00	38000275	0	\N	\N	10070	0	269911007	4151422	
1702	155	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	10514	0	180256009	4107731	
1901	180	4107731	1991-06-20	1991-06-20 00:00:00	38000275	0	\N	\N	12125	0	180256009	4107731	
2096	209	4043071	1962-06-19	1962-06-19 00:00:00	38000275	0	\N	\N	14261	0	228557008	4043071	
2319	235	4181917	1992-05-08	1992-05-08 00:00:00	38000275	0	\N	\N	15757	0	54550000	4181917	
2469	249	4275113	2003-07-12	2003-07-12 00:00:00	38000275	0	\N	\N	16775	0	65200003	4275113	
2637	266	4107731	1993-01-18	1993-01-18 00:00:00	38000275	0	\N	\N	17680	0	180256009	4107731	
2824	273	4151422	2014-03-27	2014-03-27 00:00:00	38000275	0	\N	\N	18224	0	269911007	4151422	
3024	293	4058899	1978-04-03	1978-04-03 00:00:00	38000275	0	\N	\N	19513	0	168594001	4058899	
3251	318	4195803	2013-09-02	2013-09-02 00:00:00	38000275	0	\N	\N	21064	0	312681000	4195803	
3452	338	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	22606	0	180256009	4107731	
3573	343	4107731	1993-01-23	1993-01-23 00:00:00	38000275	0	\N	\N	22883	0	180256009	4107731	
3784	364	4125906	1961-03-10	1961-03-10 00:00:00	38000275	0	\N	\N	24210	0	288086009	4125906	
3947	399	4107731	1992-06-07	1992-06-07 00:00:00	38000275	0	\N	\N	26110	0	180256009	4107731	
4134	406	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	26739	0	180256009	4107731	
4323	418	4170947	2004-06-26	2004-06-26 00:00:00	38000275	0	\N	\N	27666	0	274474001	4170947	
4508	432	4043071	1939-12-26	1939-12-26 00:00:00	38000275	0	\N	\N	28749	0	228557008	4043071	
4695	443	4047491	1984-03-02	1984-03-02 00:00:00	38000275	0	\N	\N	29426	0	1225002	4047491	
4882	453	4043071	1984-10-16	1984-10-16 00:00:00	38000275	0	\N	\N	30195	0	228557008	4043071	
5069	469	4043071	1948-09-20	1948-09-20 00:00:00	38000275	0	\N	\N	31280	0	228557008	4043071	
5256	489	4107731	1992-11-01	1992-11-01 00:00:00	38000275	0	\N	\N	32730	0	180256009	4107731	
5443	499	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	33385	0	180256009	4107731	
5702	525	4125906	1955-01-03	1955-01-03 00:00:00	38000275	0	\N	\N	34959	0	288086009	4125906	
5817	534	4043071	1990-07-20	1990-07-20 00:00:00	38000275	0	\N	\N	35598	0	228557008	4043071	
6077	558	4043071	1970-05-22	1970-05-22 00:00:00	38000275	0	\N	\N	36993	0	228557008	4043071	
6191	565	4151422	1960-12-07	1960-12-07 00:00:00	38000275	0	\N	\N	37459	0	269911007	4151422	
6394	600	4151422	1960-06-04	1960-06-04 00:00:00	38000275	0	\N	\N	39625	0	269911007	4151422	
6565	603	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	40028	0	180256009	4107731	
6752	615	4107731	1992-10-10	1992-10-10 00:00:00	38000275	0	\N	\N	40957	0	180256009	4107731	
6952	636	4057420	2005-07-01	2005-07-01 00:00:00	38000275	0	\N	\N	42135	0	18286008	4057420	
7139	664	4107731	2011-04-26	2011-04-26 00:00:00	38000275	0	\N	\N	43881	0	180256009	4107731	
7313	680	4107731	1992-03-09	1992-03-09 00:00:00	38000275	0	\N	\N	45069	0	180256009	4107731	
7506	700	4010253	1983-06-30	1983-06-30 00:00:00	38000275	0	\N	\N	46285	0	112790001	4010253	
7739	711	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	47131	0	180256009	4107731	
7874	718	4107731	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	47493	0	180256009	4107731	
8065	736	4043071	1986-07-02	1986-07-02 00:00:00	38000275	0	\N	\N	48837	0	228557008	4043071	
8248	754	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	49834	0	180256009	4107731	
8497	776	4125906	2003-02-01	2003-02-01 00:00:00	38000275	0	\N	\N	51571	0	288086009	4125906	
8692	793	4151422	1988-01-30	1988-01-30 00:00:00	38000275	0	\N	\N	52624	0	269911007	4151422	
8942	814	4170947	1995-12-21	1995-12-21 00:00:00	38000275	0	\N	\N	53979	0	274474001	4170947	
9002	825	4163872	1972-04-15	1972-04-15 00:00:00	38000275	0	\N	\N	54625	0	399208008	4163872	
9183	843	4107731	1997-10-04	1997-10-04 00:00:00	38000275	0	\N	\N	55831	0	180256009	4107731	
9370	859	4107731	1993-01-18	1993-01-18 00:00:00	38000275	0	\N	\N	56852	0	180256009	4107731	
9562	869	4202451	2012-04-20	2012-04-20 00:00:00	38000275	0	\N	\N	57727	0	433112001	4202451	
9752	877	4107731	1993-07-27	1993-07-27 00:00:00	38000275	0	\N	\N	58364	0	180256009	4107731	
9939	890	4170947	1982-06-25	1982-06-25 00:00:00	38000275	0	\N	\N	59328	0	274474001	4170947	
10234	914	4243062	2015-06-09	2015-06-09 00:00:00	38000275	0	\N	\N	60733	0	60027007	4243062	
10305	917	4043071	1976-08-15	1976-08-15 00:00:00	38000275	0	\N	\N	61000	0	228557008	4043071	
10503	950	4043071	1981-12-03	1981-12-03 00:00:00	38000275	0	\N	\N	63109	0	228557008	4043071	
10811	970	4170947	1953-04-04	1953-04-04 00:00:00	38000275	0	\N	\N	64473	0	274474001	4170947	
10883	992	4037675	1969-08-19	1969-08-19 00:00:00	38000275	0	\N	\N	65770	0	162676008	4037675	
11167	1033	4037675	1999-07-29	1999-07-29 00:00:00	38000275	0	\N	\N	67973	0	162676008	4037675	
11240	1036	4125906	2000-06-24	2000-06-24 00:00:00	38000275	0	\N	\N	68137	0	288086009	4125906	
23396	2044	4151422	2016-10-14	2016-10-14 00:00:00	38000275	0	\N	\N	135971	0	269911007	4151422	
11615	1073	4043071	1945-07-27	1945-07-27 00:00:00	38000275	0	\N	\N	70386	0	228557008	4043071	
11871	1091	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	71731	0	180256009	4107731	
20	2	4163872	1993-03-29	1993-03-29 00:00:00	38000275	0	\N	\N	117	0	399208008	4163872	
210	11	4243062	1966-08-24	1966-08-24 00:00:00	38000275	0	\N	\N	988	0	60027007	4243062	
487	35	4170947	1993-04-28	1993-04-28 00:00:00	38000275	0	\N	\N	2393	0	274474001	4170947	
584	42	4202451	1994-10-04	1994-10-04 00:00:00	38000275	0	\N	\N	3108	0	433112001	4202451	
794	66	4252419	2016-02-26	2016-02-26 00:00:00	38000275	0	\N	\N	4450	0	74016001	4252419	
997	96	4035793	1988-03-12	1988-03-12 00:00:00	38000275	0	\N	\N	6482	0	15081005	4035793	
1144	119	4024289	1967-05-28	1967-05-28 00:00:00	38000275	0	\N	\N	7923	0	19490002	4024289	
1418	137	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	9204	0	180256009	4107731	
1596	149	4293740	1958-07-21	1958-07-21 00:00:00	38000275	0	\N	\N	10103	0	384700001	4293740	
1703	155	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	10509	0	180256009	4107731	
1902	180	4107731	1992-03-19	1992-03-19 00:00:00	38000275	0	\N	\N	12140	0	180256009	4107731	
2097	209	4043071	1962-04-17	1962-04-17 00:00:00	38000275	0	\N	\N	14280	0	228557008	4043071	
2320	235	4170947	2000-10-03	2000-10-03 00:00:00	38000275	0	\N	\N	15759	0	274474001	4170947	
2470	249	4125906	2005-11-05	2005-11-05 00:00:00	38000275	0	\N	\N	16781	0	288086009	4125906	
2638	266	4107731	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	17654	0	180256009	4107731	
2825	273	4107731	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	18318	0	180256009	4107731	
3025	293	4198190	2005-10-04	2005-10-04 00:00:00	38000275	0	\N	\N	19503	0	80146002	4198190	
3252	318	4043071	1966-09-04	1966-09-04 00:00:00	38000275	0	\N	\N	21056	0	228557008	4043071	
3453	338	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	22512	0	180256009	4107731	
3574	343	4107731	1990-06-23	1990-06-23 00:00:00	38000275	0	\N	\N	22944	0	180256009	4107731	
3787	366	4195803	1998-11-03	1998-11-03 00:00:00	38000275	0	\N	\N	24356	0	312681000	4195803	
3948	399	4107731	1991-07-07	1991-07-07 00:00:00	38000275	0	\N	\N	26241	0	180256009	4107731	
4135	406	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	26764	0	180256009	4107731	
4324	418	4170947	1961-05-17	1961-05-17 00:00:00	38000275	0	\N	\N	27669	0	274474001	4170947	
4509	432	4125906	1989-12-24	1989-12-24 00:00:00	38000275	0	\N	\N	28715	0	288086009	4125906	
4700	445	4181917	1925-09-18	1925-09-18 00:00:00	38000275	0	\N	\N	29635	0	54550000	4181917	
4883	453	4043071	1984-02-14	1984-02-14 00:00:00	38000275	0	\N	\N	30176	0	228557008	4043071	
5070	469	4043071	1945-08-27	1945-08-27 00:00:00	38000275	0	\N	\N	31247	0	228557008	4043071	
5257	489	4107731	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	32737	0	180256009	4107731	
5444	499	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	33386	0	180256009	4107731	
5703	526	4198190	2008-02-16	2008-02-16 00:00:00	38000275	0	\N	\N	35103	0	80146002	4198190	
5818	534	4275113	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	35509	0	65200003	4275113	
6078	558	4125906	2000-11-01	2000-11-01 00:00:00	38000275	0	\N	\N	36976	0	288086009	4125906	
6200	569	4170947	1976-04-08	1976-04-08 00:00:00	38000275	0	\N	\N	37663	0	274474001	4170947	
6395	600	4057420	1997-02-19	1997-02-19 00:00:00	38000275	0	\N	\N	39649	0	18286008	4057420	
6566	603	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	39965	0	180256009	4107731	
6753	615	4107731	1993-03-27	1993-03-27 00:00:00	38000275	0	\N	\N	40985	0	180256009	4107731	
6953	636	4078793	2014-08-01	2014-08-01 00:00:00	38000275	0	\N	\N	42106	0	180325003	4078793	
7140	664	4191853	2010-07-27	2010-07-27 00:00:00	38000275	0	\N	\N	43821	0	395142003	4191853	
7314	680	4107731	1993-03-01	1993-03-01 00:00:00	38000275	0	\N	\N	45074	0	180256009	4107731	
7507	700	4199276	1997-12-17	1997-12-17 00:00:00	38000275	0	\N	\N	46264	0	301807007	4199276	
7740	711	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	47189	0	180256009	4107731	
7875	718	44783196	1970-04-04	1970-04-04 00:00:00	38000275	0	\N	\N	47519	0	699253003	44783196	
8066	736	4043071	1986-11-05	1986-11-05 00:00:00	38000275	0	\N	\N	48810	0	228557008	4043071	
8249	754	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	49919	0	180256009	4107731	
8498	776	4243062	1969-06-29	1969-06-29 00:00:00	38000275	0	\N	\N	51570	0	60027007	4243062	
8693	793	4151422	1993-08-10	1993-08-10 00:00:00	38000275	0	\N	\N	52603	0	269911007	4151422	
8943	814	4047491	1995-12-21	1995-12-21 00:00:00	38000275	0	\N	\N	53979	0	1225002	4047491	
9003	825	4037675	1970-09-12	1970-09-12 00:00:00	38000275	0	\N	\N	54664	0	162676008	4037675	
9184	843	4107731	1996-08-10	1996-08-10 00:00:00	38000275	0	\N	\N	55761	0	180256009	4107731	
9371	859	4107731	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	56821	0	180256009	4107731	
9563	869	4078793	2009-10-23	2009-10-23 00:00:00	38000275	0	\N	\N	57816	0	180325003	4078793	
9753	877	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	58458	0	180256009	4107731	
9940	890	4043071	1970-07-21	1970-07-21 00:00:00	38000275	0	\N	\N	59301	0	228557008	4043071	
10235	914	4195803	2015-06-09	2015-06-09 00:00:00	38000275	0	\N	\N	60733	0	312681000	4195803	
10306	917	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	60956	0	180256009	4107731	
10504	950	4024289	1983-04-16	1983-04-16 00:00:00	38000275	0	\N	\N	63096	0	19490002	4024289	
10812	970	4163872	1953-04-04	1953-04-04 00:00:00	38000275	0	\N	\N	64473	0	399208008	4163872	
10884	992	4326177	1969-08-19	1969-08-19 00:00:00	38000275	0	\N	\N	65770	0	430193006	4326177	
11171	1036	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	68170	0	180256009	4107731	
11241	1036	4293740	2000-06-24	2000-06-24 00:00:00	38000275	0	\N	\N	68137	0	384700001	4293740	
23398	2046	4151422	2001-01-31	2001-01-31 00:00:00	38000275	0	\N	\N	136176	0	269911007	4151422	
11616	1073	4043071	1944-08-18	1944-08-18 00:00:00	38000275	0	\N	\N	70413	0	228557008	4043071	
11872	1091	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	71662	0	180256009	4107731	
21	2	4170947	1993-03-29	1993-03-29 00:00:00	38000275	0	\N	\N	117	0	274474001	4170947	
211	11	4202451	2002-05-28	2002-05-28 00:00:00	38000275	0	\N	\N	973	0	433112001	4202451	
488	35	4275113	1977-03-07	1977-03-07 00:00:00	38000275	0	\N	\N	2464	0	65200003	4275113	
585	42	4151422	1985-02-03	1985-02-03 00:00:00	38000275	0	\N	\N	3066	0	269911007	4151422	
795	66	4125906	1981-03-10	1981-03-10 00:00:00	38000275	0	\N	\N	4449	0	288086009	4125906	
998	96	4330583	1971-12-30	1971-12-30 00:00:00	38000275	0	\N	\N	6472	0	22523008	4330583	
1145	119	4170947	1967-05-28	1967-05-28 00:00:00	38000275	0	\N	\N	7923	0	274474001	4170947	
1419	137	4058899	1984-08-11	1984-08-11 00:00:00	38000275	0	\N	\N	9121	0	168594001	4058899	
1597	149	4125906	1958-07-21	1958-07-21 00:00:00	38000275	0	\N	\N	10103	0	288086009	4125906	
1704	155	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	10570	0	180256009	4107731	
1903	180	4107731	1991-03-07	1991-03-07 00:00:00	38000275	0	\N	\N	12112	0	180256009	4107731	
2098	209	40492359	1976-12-31	1976-12-31 00:00:00	38000275	0	\N	\N	14267	0	447365002	40492359	
2321	235	4047491	2000-10-03	2000-10-03 00:00:00	38000275	0	\N	\N	15759	0	1225002	4047491	
2471	249	4238715	2006-05-27	2006-05-27 00:00:00	38000275	0	\N	\N	16771	0	68254000	4238715	
2639	266	4107731	1992-03-09	1992-03-09 00:00:00	38000275	0	\N	\N	17644	0	180256009	4107731	
2826	273	4107731	1992-11-01	1992-11-01 00:00:00	38000275	0	\N	\N	18276	0	180256009	4107731	
3026	295	4151422	1973-12-07	1973-12-07 00:00:00	38000275	0	\N	\N	19623	0	269911007	4151422	
3253	318	4043071	1966-05-29	1966-05-29 00:00:00	38000275	0	\N	\N	21109	0	228557008	4043071	
3454	338	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	22496	0	180256009	4107731	
3575	343	4191853	1993-07-10	1993-07-10 00:00:00	38000275	0	\N	\N	22870	0	395142003	4191853	
3788	366	4243062	1998-11-03	1998-11-03 00:00:00	38000275	0	\N	\N	24356	0	60027007	4243062	
3949	399	4107731	1991-11-10	1991-11-10 00:00:00	38000275	0	\N	\N	26211	0	180256009	4107731	
4136	406	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	26820	0	180256009	4107731	
4325	418	4024289	1961-05-17	1961-05-17 00:00:00	38000275	0	\N	\N	27669	0	19490002	4024289	
4510	432	4293740	1989-12-24	1989-12-24 00:00:00	38000275	0	\N	\N	28715	0	384700001	4293740	
4701	445	4181917	1925-12-18	1925-12-18 00:00:00	38000275	0	\N	\N	29636	0	54550000	4181917	
4884	453	4043071	1983-01-18	1983-01-18 00:00:00	38000275	0	\N	\N	30173	0	228557008	4043071	
5071	469	4043071	1948-06-28	1948-06-28 00:00:00	38000275	0	\N	\N	31279	0	228557008	4043071	
5258	489	4191853	1993-07-11	1993-07-11 00:00:00	38000275	0	\N	\N	32787	0	395142003	4191853	
5445	499	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	33388	0	180256009	4107731	
5704	526	4151422	1973-07-15	1973-07-15 00:00:00	38000275	0	\N	\N	35046	0	269911007	4151422	
5819	534	4043071	1993-07-02	1993-07-02 00:00:00	38000275	0	\N	\N	35532	0	228557008	4043071	
6079	558	4043071	1970-06-26	1970-06-26 00:00:00	38000275	0	\N	\N	36994	0	228557008	4043071	
6201	569	4163872	1976-04-08	1976-04-08 00:00:00	38000275	0	\N	\N	37663	0	399208008	4163872	
6396	600	40492359	1997-02-19	1997-02-19 00:00:00	38000275	0	\N	\N	39649	0	447365002	40492359	
6567	603	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	39988	0	180256009	4107731	
6754	615	4107731	1992-06-27	1992-06-27 00:00:00	38000275	0	\N	\N	40940	0	180256009	4107731	
6954	636	4057420	1999-05-28	1999-05-28 00:00:00	38000275	0	\N	\N	42125	0	18286008	4057420	
7141	664	4107731	2014-01-07	2014-01-07 00:00:00	38000275	0	\N	\N	43914	0	180256009	4107731	
7315	680	4107731	1993-01-18	1993-01-18 00:00:00	38000275	0	\N	\N	45073	0	180256009	4107731	
7508	700	4059978	1994-05-31	1994-05-31 00:00:00	38000275	0	\N	\N	46269	0	169553002	4059978	
7741	711	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	47136	0	180256009	4107731	
7876	718	4107731	1992-12-12	1992-12-12 00:00:00	38000275	0	\N	\N	47513	0	180256009	4107731	
8067	736	4151422	2002-08-21	2002-08-21 00:00:00	38000275	0	\N	\N	48842	0	269911007	4151422	
8250	754	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	49935	0	180256009	4107731	
8499	776	4170947	1969-06-29	1969-06-29 00:00:00	38000275	0	\N	\N	51570	0	274474001	4170947	
8694	793	44783196	2012-02-20	2012-02-20 00:00:00	38000275	0	\N	\N	52650	0	699253003	44783196	
8947	817	4037675	1976-05-11	1976-05-11 00:00:00	38000275	0	\N	\N	54162	0	162676008	4037675	
9004	825	4326177	1970-09-12	1970-09-12 00:00:00	38000275	0	\N	\N	54664	0	430193006	4326177	
9185	843	4107731	1996-10-12	1996-10-12 00:00:00	38000275	0	\N	\N	55826	0	180256009	4107731	
9372	859	4107731	1992-09-14	1992-09-14 00:00:00	38000275	0	\N	\N	56868	0	180256009	4107731	
9564	869	4078793	2006-10-06	2006-10-06 00:00:00	38000275	0	\N	\N	57762	0	180325003	4078793	
9754	877	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	58463	0	180256009	4107731	
9941	890	4043071	1970-08-18	1970-08-18 00:00:00	38000275	0	\N	\N	59307	0	228557008	4043071	
10236	914	4125906	1967-04-17	1967-04-17 00:00:00	38000275	0	\N	\N	60730	0	288086009	4125906	
10307	917	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	61082	0	180256009	4107731	
10505	950	4170947	1983-04-16	1983-04-16 00:00:00	38000275	0	\N	\N	63096	0	274474001	4170947	
10813	971	4125906	1985-12-01	1985-12-01 00:00:00	38000275	0	\N	\N	64581	0	288086009	4125906	
10885	992	4151422	1960-07-03	1960-07-03 00:00:00	38000275	0	\N	\N	65764	0	269911007	4151422	
11172	1036	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	68202	0	180256009	4107731	
11248	1039	4058899	1978-10-02	1978-10-02 00:00:00	38000275	0	\N	\N	68331	0	168594001	4058899	
23399	2046	4151422	1991-11-12	1991-11-12 00:00:00	38000275	0	\N	\N	136183	0	269911007	4151422	
11617	1073	4043071	1945-03-02	1945-03-02 00:00:00	38000275	0	\N	\N	70415	0	228557008	4043071	
11873	1091	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	71623	0	180256009	4107731	
22	3	4078793	2007-08-27	2007-08-27 00:00:00	38000275	0	\N	\N	310	0	180325003	4078793	
212	12	4170947	1970-09-20	1970-09-20 00:00:00	38000275	0	\N	\N	995	0	274474001	4170947	
489	35	4058899	1984-05-15	1984-05-15 00:00:00	38000275	0	\N	\N	2392	0	168594001	4058899	
586	42	4024289	1930-10-04	1930-10-04 00:00:00	38000275	0	\N	\N	3111	0	19490002	4024289	
796	66	4125906	1959-04-23	1959-04-23 00:00:00	38000275	0	\N	\N	4447	0	288086009	4125906	
999	96	4035793	1994-04-16	1994-04-16 00:00:00	38000275	0	\N	\N	6516	0	15081005	4035793	
1146	119	4275113	1973-12-06	1973-12-06 00:00:00	38000275	0	\N	\N	7870	0	65200003	4275113	
1420	137	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	9218	0	180256009	4107731	
1598	149	4181917	1948-08-17	1948-08-17 00:00:00	38000275	0	\N	\N	10102	0	54550000	4181917	
1705	155	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	10575	0	180256009	4107731	
1904	180	4107731	1990-11-22	1990-11-22 00:00:00	38000275	0	\N	\N	12166	0	180256009	4107731	
2099	209	4057420	1976-12-31	1976-12-31 00:00:00	38000275	0	\N	\N	14267	0	18286008	4057420	
2322	236	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	15855	0	180256009	4107731	
2472	249	4293740	2004-11-19	2004-11-19 00:00:00	38000275	0	\N	\N	16780	0	384700001	4293740	
2640	266	4107731	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	17748	0	180256009	4107731	
2827	273	4107731	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	18278	0	180256009	4107731	
3027	295	4195803	2017-02-16	2017-02-16 00:00:00	38000275	0	\N	\N	19646	0	312681000	4195803	
3257	320	4058899	1959-11-30	1959-11-30 00:00:00	38000275	0	\N	\N	21231	0	168594001	4058899	
3455	338	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	22521	0	180256009	4107731	
3576	343	4107731	1992-10-10	1992-10-10 00:00:00	38000275	0	\N	\N	22897	0	180256009	4107731	
3789	366	4170947	1998-11-03	1998-11-03 00:00:00	38000275	0	\N	\N	24356	0	274474001	4170947	
3950	399	4107731	1990-11-18	1990-11-18 00:00:00	38000275	0	\N	\N	26135	0	180256009	4107731	
4137	406	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	26736	0	180256009	4107731	
4326	418	4125906	1981-10-20	1981-10-20 00:00:00	38000275	0	\N	\N	27663	0	288086009	4125906	
4511	432	4043071	1938-12-27	1938-12-27 00:00:00	38000275	0	\N	\N	28729	0	228557008	4043071	
4777	449	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	29948	0	180256009	4107731	
4885	453	4043071	1982-05-04	1982-05-04 00:00:00	38000275	0	\N	\N	30156	0	228557008	4043071	
5072	469	4043071	1946-02-04	1946-02-04 00:00:00	38000275	0	\N	\N	31233	0	228557008	4043071	
5259	489	4107731	1991-05-05	1991-05-05 00:00:00	38000275	0	\N	\N	32748	0	180256009	4107731	
5446	499	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	33394	0	180256009	4107731	
5705	526	4151422	2018-04-14	2018-04-14 00:00:00	38000275	0	\N	\N	35099	0	269911007	4151422	
5820	534	4043071	1989-12-07	1989-12-07 00:00:00	38000275	0	\N	\N	35560	0	228557008	4043071	
6080	558	4043071	1970-04-17	1970-04-17 00:00:00	38000275	0	\N	\N	36969	0	228557008	4043071	
6202	569	4195803	1976-04-08	1976-04-08 00:00:00	38000275	0	\N	\N	37663	0	312681000	4195803	
6397	600	4125906	1984-09-09	1984-09-09 00:00:00	38000275	0	\N	\N	39647	0	288086009	4125906	
6568	603	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	40023	0	180256009	4107731	
6755	615	4107731	1990-01-27	1990-01-27 00:00:00	38000275	0	\N	\N	41060	0	180256009	4107731	
6955	636	4057420	2013-07-26	2013-07-26 00:00:00	38000275	0	\N	\N	42137	0	18286008	4057420	
7142	664	4107731	2011-05-17	2011-05-17 00:00:00	38000275	0	\N	\N	43922	0	180256009	4107731	
7316	680	4107731	1990-05-07	1990-05-07 00:00:00	38000275	0	\N	\N	44965	0	180256009	4107731	
7509	700	4293740	2008-09-05	2008-09-05 00:00:00	38000275	0	\N	\N	46232	0	384700001	4293740	
7742	711	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	47094	0	180256009	4107731	
7877	718	4107731	1990-10-27	1990-10-27 00:00:00	38000275	0	\N	\N	47503	0	180256009	4107731	
8068	736	4043071	1986-05-28	1986-05-28 00:00:00	38000275	0	\N	\N	48809	0	228557008	4043071	
8251	754	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	49957	0	180256009	4107731	
8500	776	4010253	2004-09-03	2004-09-03 00:00:00	38000275	0	\N	\N	51588	0	112790001	4010253	
8695	793	4252419	2012-02-13	2012-02-13 00:00:00	38000275	0	\N	\N	52612	0	74016001	4252419	
8948	817	4187458	1976-05-11	1976-05-11 00:00:00	38000275	0	\N	\N	54162	0	415300000	4187458	
9005	825	4125906	2013-08-02	2013-08-02 00:00:00	38000275	0	\N	\N	54655	0	288086009	4125906	
9186	843	4107731	1996-04-27	1996-04-27 00:00:00	38000275	0	\N	\N	55774	0	180256009	4107731	
9373	859	4107731	1992-12-07	1992-12-07 00:00:00	38000275	0	\N	\N	56851	0	180256009	4107731	
9565	869	4293740	1936-10-10	1936-10-10 00:00:00	38000275	0	\N	\N	57722	0	384700001	4293740	
9755	877	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	58398	0	180256009	4107731	
9942	890	4151422	2012-09-04	2012-09-04 00:00:00	38000275	0	\N	\N	59304	0	269911007	4151422	
10237	914	4330583	1994-05-30	1994-05-30 00:00:00	38000275	0	\N	\N	60718	0	22523008	4330583	
10308	917	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	60959	0	180256009	4107731	
10506	950	4043071	1981-08-27	1981-08-27 00:00:00	38000275	0	\N	\N	63101	0	228557008	4043071	
10814	971	4125906	1994-03-03	1994-03-03 00:00:00	38000275	0	\N	\N	64582	0	288086009	4125906	
10897	1000	4058899	1966-10-24	1966-10-24 00:00:00	38000275	0	\N	\N	66136	0	168594001	4058899	
11173	1036	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	68145	0	180256009	4107731	
11249	1039	4252419	1996-09-27	1996-09-27 00:00:00	38000275	0	\N	\N	68332	0	74016001	4252419	
23400	2046	4216130	2014-04-01	2014-04-01 00:00:00	38000275	0	\N	\N	136154	0	415070008	4216130	
11618	1073	4043071	1945-03-30	1945-03-30 00:00:00	38000275	0	\N	\N	70385	0	228557008	4043071	
11874	1091	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	71732	0	180256009	4107731	
23	3	4078793	2016-10-17	2016-10-17 00:00:00	38000275	0	\N	\N	279	0	180325003	4078793	
213	12	4125906	1980-01-31	1980-01-31 00:00:00	38000275	0	\N	\N	996	0	288086009	4125906	
490	36	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	2553	0	180256009	4107731	
587	42	4170947	1930-10-04	1930-10-04 00:00:00	38000275	0	\N	\N	3111	0	274474001	4170947	
797	66	4293740	1979-03-30	1979-03-30 00:00:00	38000275	0	\N	\N	4448	0	384700001	4293740	
1000	96	4035793	1993-04-10	1993-04-10 00:00:00	38000275	0	\N	\N	6528	0	15081005	4035793	
1147	120	4058899	1992-11-10	1992-11-10 00:00:00	38000275	0	\N	\N	7970	0	168594001	4058899	
1421	137	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	9172	0	180256009	4107731	
1625	152	4010253	1987-01-11	1987-01-11 00:00:00	38000275	0	\N	\N	10229	0	112790001	4010253	
1706	155	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	10620	0	180256009	4107731	
1905	180	4107731	1993-10-07	1993-10-07 00:00:00	38000275	0	\N	\N	12159	0	180256009	4107731	
2100	209	4043071	1962-03-20	1962-03-20 00:00:00	38000275	0	\N	\N	14230	0	228557008	4043071	
2323	236	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	15863	0	180256009	4107731	
2473	249	4125906	2004-11-19	2004-11-19 00:00:00	38000275	0	\N	\N	16780	0	288086009	4125906	
2641	266	4107731	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	17745	0	180256009	4107731	
2828	273	4107731	1991-03-03	1991-03-03 00:00:00	38000275	0	\N	\N	18219	0	180256009	4107731	
3028	295	4163872	2017-02-16	2017-02-16 00:00:00	38000275	0	\N	\N	19646	0	399208008	4163872	
3258	320	4293740	1995-08-08	1995-08-08 00:00:00	38000275	0	\N	\N	21237	0	384700001	4293740	
3456	338	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	22540	0	180256009	4107731	
3577	343	4163872	1987-06-01	1987-06-01 00:00:00	38000275	0	\N	\N	22850	0	399208008	4163872	
3790	366	4202451	1974-03-03	1974-03-03 00:00:00	38000275	0	\N	\N	24322	0	433112001	4202451	
3951	399	4107731	1991-05-05	1991-05-05 00:00:00	38000275	0	\N	\N	26180	0	180256009	4107731	
4138	406	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	26845	0	180256009	4107731	
4327	418	4170947	1967-09-13	1967-09-13 00:00:00	38000275	0	\N	\N	27671	0	274474001	4170947	
4512	432	4043071	1939-10-24	1939-10-24 00:00:00	38000275	0	\N	\N	28649	0	228557008	4043071	
4778	449	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	29979	0	180256009	4107731	
4886	453	4043071	1984-09-11	1984-09-11 00:00:00	38000275	0	\N	\N	30194	0	228557008	4043071	
5073	469	4043071	1947-03-31	1947-03-31 00:00:00	38000275	0	\N	\N	31345	0	228557008	4043071	
5260	489	4107731	1991-08-18	1991-08-18 00:00:00	38000275	0	\N	\N	32824	0	180256009	4107731	
5447	499	4197460	1972-03-18	1972-03-18 00:00:00	38000275	0	\N	\N	33417	0	313191000	4197460	
5706	526	4125906	2008-09-05	2008-09-05 00:00:00	38000275	0	\N	\N	35104	0	288086009	4125906	
5821	534	4043071	1989-08-04	1989-08-04 00:00:00	38000275	0	\N	\N	35618	0	228557008	4043071	
6081	558	4043071	1970-01-23	1970-01-23 00:00:00	38000275	0	\N	\N	36992	0	228557008	4043071	
6203	569	4195803	1993-03-20	1993-03-20 00:00:00	38000275	0	\N	\N	37682	0	312681000	4195803	
6398	600	44783196	2018-07-23	2018-07-23 00:00:00	38000275	0	\N	\N	39643	0	699253003	44783196	
6569	603	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	39917	0	180256009	4107731	
6756	615	4107731	1991-11-30	1991-11-30 00:00:00	38000275	0	\N	\N	41069	0	180256009	4107731	
6956	636	4078793	2000-06-02	2000-06-02 00:00:00	38000275	0	\N	\N	42115	0	180325003	4078793	
7143	664	4107731	2012-02-14	2012-02-14 00:00:00	38000275	0	\N	\N	43892	0	180256009	4107731	
7317	680	4107731	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	45023	0	180256009	4107731	
7510	700	4125906	2008-09-05	2008-09-05 00:00:00	38000275	0	\N	\N	46232	0	288086009	4125906	
7743	711	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	47080	0	180256009	4107731	
7878	718	4107731	1991-09-07	1991-09-07 00:00:00	38000275	0	\N	\N	47433	0	180256009	4107731	
8069	736	4043071	1986-10-08	1986-10-08 00:00:00	38000275	0	\N	\N	48861	0	228557008	4043071	
8252	754	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	49899	0	180256009	4107731	
8501	776	4125906	2009-10-11	2009-10-11 00:00:00	38000275	0	\N	\N	51572	0	288086009	4125906	
8700	795	4195803	2006-11-01	2006-11-01 00:00:00	38000275	0	\N	\N	52769	0	312681000	4195803	
8949	817	4326177	1976-05-11	1976-05-11 00:00:00	38000275	0	\N	\N	54162	0	430193006	4326177	
9006	825	4163872	1982-01-31	1982-01-31 00:00:00	38000275	0	\N	\N	54691	0	399208008	4163872	
9187	843	4191853	1998-11-07	1998-11-07 00:00:00	38000275	0	\N	\N	55792	0	395142003	4191853	
9374	859	4107731	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	56837	0	180256009	4107731	
9566	869	4125906	1936-10-10	1936-10-10 00:00:00	38000275	0	\N	\N	57722	0	288086009	4125906	
9756	877	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	58465	0	180256009	4107731	
9943	890	4330583	2000-05-25	2000-05-25 00:00:00	38000275	0	\N	\N	59347	0	22523008	4330583	
10238	914	4024289	2013-05-20	2013-05-20 00:00:00	38000275	0	\N	\N	60732	0	19490002	4024289	
10309	917	4043071	1974-06-30	1974-06-30 00:00:00	38000275	0	\N	\N	60917	0	228557008	4043071	
10507	950	4125906	1984-07-09	1984-07-09 00:00:00	38000275	0	\N	\N	63097	0	288086009	4125906	
10815	971	4293740	1994-03-03	1994-03-03 00:00:00	38000275	0	\N	\N	64582	0	384700001	4293740	
10898	1000	4058899	1964-11-03	1964-11-03 00:00:00	38000275	0	\N	\N	66135	0	168594001	4058899	
11174	1036	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	68104	0	180256009	4107731	
11250	1039	4163872	1995-06-15	1995-06-15 00:00:00	38000275	0	\N	\N	68340	0	399208008	4163872	
23401	2046	4336464	2014-04-01	2014-04-01 00:00:00	38000275	0	\N	\N	136154	0	232717009	4336464	
11619	1073	4043071	1944-09-22	1944-09-22 00:00:00	38000275	0	\N	\N	70322	0	228557008	4043071	
11875	1091	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	71626	0	395142003	4191853	
24	3	4024289	1950-01-25	1950-01-25 00:00:00	38000275	0	\N	\N	344	0	19490002	4024289	
214	12	4047491	1970-09-20	1970-09-20 00:00:00	38000275	0	\N	\N	995	0	1225002	4047491	
491	36	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	2536	0	180256009	4107731	
588	42	4202451	1993-10-19	1993-10-19 00:00:00	38000275	0	\N	\N	3104	0	433112001	4202451	
798	66	4125906	1979-03-30	1979-03-30 00:00:00	38000275	0	\N	\N	4448	0	288086009	4125906	
1001	96	4035793	1985-02-23	1985-02-23 00:00:00	38000275	0	\N	\N	6526	0	15081005	4035793	
1148	120	4125906	2016-03-30	2016-03-30 00:00:00	38000275	0	\N	\N	7972	0	288086009	4125906	
1422	137	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	9146	0	180256009	4107731	
1626	152	4058899	1992-02-17	1992-02-17 00:00:00	38000275	0	\N	\N	10292	0	168594001	4058899	
1707	155	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	10561	0	180256009	4107731	
1906	180	4107731	1990-11-01	1990-11-01 00:00:00	38000275	0	\N	\N	12123	0	180256009	4107731	
2101	209	4043071	1962-05-22	1962-05-22 00:00:00	38000275	0	\N	\N	14247	0	228557008	4043071	
2324	236	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	15844	0	180256009	4107731	
2474	250	4125906	1975-01-09	1975-01-09 00:00:00	38000275	0	\N	\N	16792	0	288086009	4125906	
2642	266	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	17728	0	180256009	4107731	
2829	273	4107731	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	18317	0	180256009	4107731	
3029	295	4170947	2017-02-16	2017-02-16 00:00:00	38000275	0	\N	\N	19646	0	274474001	4170947	
3259	320	4125906	1995-08-08	1995-08-08 00:00:00	38000275	0	\N	\N	21237	0	288086009	4125906	
3457	338	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	22570	0	180256009	4107731	
3578	343	4170947	1987-06-01	1987-06-01 00:00:00	38000275	0	\N	\N	22850	0	274474001	4170947	
3791	366	4151422	1983-02-22	1983-02-22 00:00:00	38000275	0	\N	\N	24342	0	269911007	4151422	
3952	399	4107731	1992-06-28	1992-06-28 00:00:00	38000275	0	\N	\N	26213	0	180256009	4107731	
4139	406	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	26823	0	180256009	4107731	
4328	418	4047491	1967-09-13	1967-09-13 00:00:00	38000275	0	\N	\N	27671	0	1225002	4047491	
4513	432	4043071	1940-02-27	1940-02-27 00:00:00	38000275	0	\N	\N	28733	0	228557008	4043071	
4779	449	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	29928	0	180256009	4107731	
4887	453	4043071	1984-07-17	1984-07-17 00:00:00	38000275	0	\N	\N	30239	0	228557008	4043071	
5074	469	4043071	1945-10-01	1945-10-01 00:00:00	38000275	0	\N	\N	31340	0	228557008	4043071	
5261	489	4107731	1993-01-24	1993-01-24 00:00:00	38000275	0	\N	\N	32736	0	180256009	4107731	
5448	499	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	33432	0	180256009	4107731	
5708	528	4170947	2002-04-13	2002-04-13 00:00:00	38000275	0	\N	\N	35211	0	274474001	4170947	
5822	534	4043071	1991-01-31	1991-01-31 00:00:00	38000275	0	\N	\N	35599	0	228557008	4043071	
6082	558	4043071	1970-07-31	1970-07-31 00:00:00	38000275	0	\N	\N	36983	0	228557008	4043071	
6204	569	4125906	1949-02-08	1949-02-08 00:00:00	38000275	0	\N	\N	37661	0	288086009	4125906	
6399	600	4252419	2018-07-16	2018-07-16 00:00:00	38000275	0	\N	\N	39652	0	74016001	4252419	
6570	603	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	39895	0	180256009	4107731	
6757	615	4107731	1992-11-21	1992-11-21 00:00:00	38000275	0	\N	\N	40982	0	180256009	4107731	
6958	639	44783196	2007-04-27	2007-04-27 00:00:00	38000275	0	\N	\N	42242	0	699253003	44783196	
7144	664	4107731	2013-08-13	2013-08-13 00:00:00	38000275	0	\N	\N	43898	0	180256009	4107731	
7318	680	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	45040	0	180256009	4107731	
7511	701	4125906	2015-05-04	2015-05-04 00:00:00	38000275	0	\N	\N	46365	0	288086009	4125906	
7744	711	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	47137	0	180256009	4107731	
7879	718	4107731	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	47432	0	180256009	4107731	
8070	736	4043071	1986-09-10	1986-09-10 00:00:00	38000275	0	\N	\N	48839	0	228557008	4043071	
8253	755	4047491	1981-07-02	1981-07-02 00:00:00	38000275	0	\N	\N	50009	0	1225002	4047491	
8502	776	4010253	1979-08-31	1979-08-31 00:00:00	38000275	0	\N	\N	51586	0	112790001	4010253	
8701	795	4151422	1978-02-20	1978-02-20 00:00:00	38000275	0	\N	\N	52751	0	269911007	4151422	
8950	817	4252419	2012-12-26	2012-12-26 00:00:00	38000275	0	\N	\N	54111	0	74016001	4252419	
9007	825	4187458	1970-09-12	1970-09-12 00:00:00	38000275	0	\N	\N	54664	0	415300000	4187458	
9188	843	4107731	1995-09-09	1995-09-09 00:00:00	38000275	0	\N	\N	55772	0	180256009	4107731	
9375	859	4107731	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	56849	0	180256009	4107731	
9567	869	4078793	1997-05-16	1997-05-16 00:00:00	38000275	0	\N	\N	57737	0	180325003	4078793	
9757	877	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	58466	0	180256009	4107731	
9944	890	4043071	1970-12-08	1970-12-08 00:00:00	38000275	0	\N	\N	59322	0	228557008	4043071	
10239	914	4125906	2004-01-24	2004-01-24 00:00:00	38000275	0	\N	\N	60731	0	288086009	4125906	
10310	917	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	61027	0	180256009	4107731	
10508	950	4043071	1981-10-29	1981-10-29 00:00:00	38000275	0	\N	\N	63084	0	228557008	4043071	
10816	971	4151422	1979-07-02	1979-07-02 00:00:00	38000275	0	\N	\N	64609	0	269911007	4151422	
10899	1000	4047491	1976-02-18	1976-02-18 00:00:00	38000275	0	\N	\N	66139	0	1225002	4047491	
11175	1036	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	68114	0	180256009	4107731	
11251	1039	44783196	1996-10-04	1996-10-04 00:00:00	38000275	0	\N	\N	68381	0	699253003	44783196	
23402	2046	4301346	1969-12-30	1969-12-30 00:00:00	38000275	0	\N	\N	136098	0	387685009	4301346	
11620	1073	4043071	1945-12-21	1945-12-21 00:00:00	38000275	0	\N	\N	70420	0	228557008	4043071	
11876	1091	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	71614	0	180256009	4107731	
25	3	4170947	1950-01-25	1950-01-25 00:00:00	38000275	0	\N	\N	344	0	274474001	4170947	
215	12	4151422	1974-10-08	1974-10-08 00:00:00	38000275	0	\N	\N	1041	0	269911007	4151422	
492	36	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	2531	0	180256009	4107731	
589	42	4125906	1974-06-13	1974-06-13 00:00:00	38000275	0	\N	\N	3107	0	288086009	4125906	
801	69	4125906	1949-05-28	1949-05-28 00:00:00	38000275	0	\N	\N	4708	0	288086009	4125906	
1002	96	4337138	1985-04-13	1985-04-13 00:00:00	38000275	0	\N	\N	6484	0	88039007	4337138	
1157	123	4057420	2013-07-10	2013-07-10 00:00:00	38000275	0	\N	\N	8146	0	18286008	4057420	
1423	137	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	9169	0	180256009	4107731	
1627	152	4202832	1973-12-15	1973-12-15 00:00:00	38000275	0	\N	\N	10291	0	52765003	4202832	
1708	155	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	10572	0	180256009	4107731	
1907	180	4107731	1990-06-07	1990-06-07 00:00:00	38000275	0	\N	\N	12109	0	180256009	4107731	
2102	209	4202451	1992-07-31	1992-07-31 00:00:00	38000275	0	\N	\N	14215	0	433112001	4202451	
2325	236	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	15885	0	180256009	4107731	
2477	254	4125906	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	16919	0	288086009	4125906	
2643	266	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	17729	0	180256009	4107731	
2830	273	4107731	1992-04-26	1992-04-26 00:00:00	38000275	0	\N	\N	18275	0	180256009	4107731	
3030	295	4170947	1951-04-06	1951-04-06 00:00:00	38000275	0	\N	\N	19643	0	274474001	4170947	
3260	320	4125906	2004-08-09	2004-08-09 00:00:00	38000275	0	\N	\N	21179	0	288086009	4125906	
3458	338	4275113	1985-03-27	1985-03-27 00:00:00	38000275	0	\N	\N	22529	0	65200003	4275113	
3579	343	4107731	1990-10-06	1990-10-06 00:00:00	38000275	0	\N	\N	22973	0	180256009	4107731	
3792	366	4252419	1954-11-21	1954-11-21 00:00:00	38000275	0	\N	\N	24353	0	74016001	4252419	
3953	399	4107731	1993-02-14	1993-02-14 00:00:00	38000275	0	\N	\N	26249	0	180256009	4107731	
4140	406	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	26738	0	180256009	4107731	
4329	419	4195803	1979-12-26	1979-12-26 00:00:00	38000275	0	\N	\N	27712	0	312681000	4195803	
4514	432	4043071	1939-09-26	1939-09-26 00:00:00	38000275	0	\N	\N	28731	0	228557008	4043071	
4780	449	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	29944	0	180256009	4107731	
4888	453	4043071	1985-04-02	1985-04-02 00:00:00	38000275	0	\N	\N	30186	0	228557008	4043071	
5075	469	4043071	1946-04-01	1946-04-01 00:00:00	38000275	0	\N	\N	31272	0	228557008	4043071	
5262	489	4107731	1990-04-22	1990-04-22 00:00:00	38000275	0	\N	\N	32759	0	180256009	4107731	
5449	499	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	33382	0	180256009	4107731	
5709	528	4047491	2002-04-13	2002-04-13 00:00:00	38000275	0	\N	\N	35211	0	1225002	4047491	
5823	534	4043071	1991-07-12	1991-07-12 00:00:00	38000275	0	\N	\N	35501	0	228557008	4043071	
6083	558	4043071	1970-09-25	1970-09-25 00:00:00	38000275	0	\N	\N	36970	0	228557008	4043071	
6205	569	4047491	1999-10-05	1999-10-05 00:00:00	38000275	0	\N	\N	37722	0	1225002	4047491	
6400	600	4145310	2002-01-20	2002-01-20 00:00:00	38000275	0	\N	\N	39650	0	268425006	4145310	
6571	603	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	39924	0	180256009	4107731	
6758	615	4107731	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	40943	0	180256009	4107731	
6959	639	4252419	2007-04-20	2007-04-20 00:00:00	38000275	0	\N	\N	42244	0	74016001	4252419	
7145	664	4107731	2010-10-19	2010-10-19 00:00:00	38000275	0	\N	\N	43806	0	180256009	4107731	
7319	680	4107731	1992-11-16	1992-11-16 00:00:00	38000275	0	\N	\N	44993	0	180256009	4107731	
7515	703	4078793	2016-01-15	2016-01-15 00:00:00	38000275	0	\N	\N	46490	0	180325003	4078793	
7745	711	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	47151	0	180256009	4107731	
7880	718	4107731	1993-05-08	1993-05-08 00:00:00	38000275	0	\N	\N	47543	0	180256009	4107731	
8071	736	4043071	1986-04-23	1986-04-23 00:00:00	38000275	0	\N	\N	48791	0	228557008	4043071	
8254	755	4170947	1981-07-02	1981-07-02 00:00:00	38000275	0	\N	\N	50009	0	274474001	4170947	
8505	778	4295880	1995-04-06	1995-04-06 00:00:00	38000275	0	\N	\N	51668	0	76601001	4295880	
8702	795	4163872	1988-06-08	1988-06-08 00:00:00	38000275	0	\N	\N	52710	0	399208008	4163872	
8951	817	44783196	2013-01-02	2013-01-02 00:00:00	38000275	0	\N	\N	54130	0	699253003	44783196	
9008	825	4163872	1971-03-12	1971-03-12 00:00:00	38000275	0	\N	\N	54689	0	399208008	4163872	
9189	843	4107731	1997-02-15	1997-02-15 00:00:00	38000275	0	\N	\N	55762	0	180256009	4107731	
9376	859	4107731	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	56829	0	180256009	4107731	
9568	869	4078793	2007-10-12	2007-10-12 00:00:00	38000275	0	\N	\N	57815	0	180325003	4078793	
9758	877	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	58429	0	180256009	4107731	
9945	890	4043071	1970-10-13	1970-10-13 00:00:00	38000275	0	\N	\N	59302	0	228557008	4043071	
10240	914	4170947	2013-05-20	2013-05-20 00:00:00	38000275	0	\N	\N	60732	0	274474001	4170947	
10311	917	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	60966	0	180256009	4107731	
10509	950	4043071	1982-04-08	1982-04-08 00:00:00	38000275	0	\N	\N	63086	0	228557008	4043071	
10817	972	4151422	2008-09-20	2008-09-20 00:00:00	38000275	0	\N	\N	64723	0	269911007	4151422	
10900	1000	4170947	1976-02-18	1976-02-18 00:00:00	38000275	0	\N	\N	66139	0	274474001	4170947	
11176	1036	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	68105	0	180256009	4107731	
11289	1046	4125906	1992-02-28	1992-02-28 00:00:00	38000275	0	\N	\N	68699	0	288086009	4125906	
23403	2046	4293740	1995-01-18	1995-01-18 00:00:00	38000275	0	\N	\N	136153	0	384700001	4293740	
11621	1073	4043071	1944-12-29	1944-12-29 00:00:00	38000275	0	\N	\N	70308	0	228557008	4043071	
11877	1091	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	71644	0	180256009	4107731	
26	3	4078793	2011-09-19	2011-09-19 00:00:00	38000275	0	\N	\N	323	0	180325003	4078793	
216	12	4170947	1986-11-16	1986-11-16 00:00:00	38000275	0	\N	\N	997	0	274474001	4170947	
493	36	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	2552	0	180256009	4107731	
590	43	4125906	1994-11-12	1994-11-12 00:00:00	38000275	0	\N	\N	3156	0	288086009	4125906	
802	69	4125906	1997-12-24	1997-12-24 00:00:00	38000275	0	\N	\N	4710	0	288086009	4125906	
1003	96	4035793	1996-04-27	1996-04-27 00:00:00	38000275	0	\N	\N	6496	0	15081005	4035793	
1158	123	40492359	2013-07-10	2013-07-10 00:00:00	38000275	0	\N	\N	8146	0	447365002	40492359	
1424	137	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	9249	0	180256009	4107731	
1628	152	4163971	1973-12-15	1973-12-15 00:00:00	38000275	0	\N	\N	10291	0	45595009	4163971	
1709	155	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	10607	0	180256009	4107731	
1908	180	4107731	1992-09-03	1992-09-03 00:00:00	38000275	0	\N	\N	12153	0	180256009	4107731	
2114	211	4181917	1967-10-12	1967-10-12 00:00:00	38000275	0	\N	\N	14405	0	54550000	4181917	
2326	236	4238715	1986-12-18	1986-12-18 00:00:00	38000275	0	\N	\N	15836	0	68254000	4238715	
2478	254	4151422	2000-10-07	2000-10-07 00:00:00	38000275	0	\N	\N	16968	0	269911007	4151422	
2644	266	4107731	1990-12-03	1990-12-03 00:00:00	38000275	0	\N	\N	17707	0	180256009	4107731	
2831	273	4197460	1981-04-15	1981-04-15 00:00:00	38000275	0	\N	\N	18286	0	313191000	4197460	
3031	295	4243062	1951-04-06	1951-04-06 00:00:00	38000275	0	\N	\N	19643	0	60027007	4243062	
3261	320	44783196	1974-03-01	1974-03-01 00:00:00	38000275	0	\N	\N	21205	0	699253003	44783196	
3459	338	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	22574	0	180256009	4107731	
3580	343	4107731	1990-12-08	1990-12-08 00:00:00	38000275	0	\N	\N	22905	0	180256009	4107731	
3793	366	44783196	1954-11-28	1954-11-28 00:00:00	38000275	0	\N	\N	24416	0	699253003	44783196	
3954	399	4107731	1992-08-30	1992-08-30 00:00:00	38000275	0	\N	\N	26113	0	180256009	4107731	
4141	406	4107731	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	26720	0	180256009	4107731	
4330	419	4163872	1979-12-26	1979-12-26 00:00:00	38000275	0	\N	\N	27712	0	399208008	4163872	
4515	432	4078793	2018-07-16	2018-07-16 00:00:00	38000275	0	\N	\N	28657	0	180325003	4078793	
4781	449	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	29859	0	180256009	4107731	
4889	453	4043071	1982-10-12	1982-10-12 00:00:00	38000275	0	\N	\N	30204	0	228557008	4043071	
5076	469	4043071	1949-11-07	1949-11-07 00:00:00	38000275	0	\N	\N	31303	0	228557008	4043071	
5263	489	4107731	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	32799	0	180256009	4107731	
5450	499	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	33323	0	180256009	4107731	
5737	533	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	35487	0	180256009	4107731	
5824	534	4043071	1992-09-11	1992-09-11 00:00:00	38000275	0	\N	\N	35503	0	228557008	4043071	
6084	558	4043071	1969-07-11	1969-07-11 00:00:00	38000275	0	\N	\N	36990	0	228557008	4043071	
6206	569	4170947	1999-10-05	1999-10-05 00:00:00	38000275	0	\N	\N	37722	0	274474001	4170947	
6401	600	4125906	2012-08-25	2012-08-25 00:00:00	38000275	0	\N	\N	39651	0	288086009	4125906	
6572	603	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	40014	0	180256009	4107731	
6759	615	4107731	1991-02-09	1991-02-09 00:00:00	38000275	0	\N	\N	40936	0	180256009	4107731	
6960	640	4047491	1957-04-10	1957-04-10 00:00:00	38000275	0	\N	\N	42328	0	1225002	4047491	
7146	664	4107731	2013-04-30	2013-04-30 00:00:00	38000275	0	\N	\N	43829	0	180256009	4107731	
7320	680	4107731	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	45020	0	180256009	4107731	
7516	703	4078793	2008-02-08	2008-02-08 00:00:00	38000275	0	\N	\N	46431	0	180325003	4078793	
7746	711	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	47187	0	180256009	4107731	
7881	718	40492359	1974-10-19	1974-10-19 00:00:00	38000275	0	\N	\N	47525	0	447365002	40492359	
8072	736	4043071	1985-09-04	1985-09-04 00:00:00	38000275	0	\N	\N	48781	0	228557008	4043071	
8255	755	4145310	2018-10-14	2018-10-14 00:00:00	38000275	0	\N	\N	50013	0	268425006	4145310	
8506	778	4295880	1998-07-02	1998-07-02 00:00:00	38000275	0	\N	\N	51699	0	76601001	4295880	
8703	795	4151422	1980-06-21	1980-06-21 00:00:00	38000275	0	\N	\N	52752	0	269911007	4151422	
8952	817	4058899	2007-01-27	2007-01-27 00:00:00	38000275	0	\N	\N	54110	0	168594001	4058899	
9009	825	4125906	1984-07-30	1984-07-30 00:00:00	38000275	0	\N	\N	54653	0	288086009	4125906	
9190	843	4107731	1997-05-10	1997-05-10 00:00:00	38000275	0	\N	\N	55764	0	180256009	4107731	
9377	859	4107731	1992-02-17	1992-02-17 00:00:00	38000275	0	\N	\N	56807	0	180256009	4107731	
9569	869	4170947	1937-11-25	1937-11-25 00:00:00	38000275	0	\N	\N	57723	0	274474001	4170947	
9759	877	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	58357	0	180256009	4107731	
9946	890	4151422	1966-03-25	1966-03-25 00:00:00	38000275	0	\N	\N	59318	0	269911007	4151422	
10241	914	4195803	2013-05-20	2013-05-20 00:00:00	38000275	0	\N	\N	60732	0	312681000	4195803	
10312	917	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	60924	0	180256009	4107731	
10510	950	4243062	1988-03-02	1988-03-02 00:00:00	38000275	0	\N	\N	63099	0	60027007	4243062	
10818	972	4170947	1974-01-20	1974-01-20 00:00:00	38000275	0	\N	\N	64718	0	274474001	4170947	
10901	1000	4024289	1972-08-23	1972-08-23 00:00:00	38000275	0	\N	\N	66137	0	19490002	4024289	
11177	1036	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	68168	0	180256009	4107731	
11290	1046	4163872	1975-03-19	1975-03-19 00:00:00	38000275	0	\N	\N	68696	0	399208008	4163872	
23404	2046	4125906	1995-01-18	1995-01-18 00:00:00	38000275	0	\N	\N	136153	0	288086009	4125906	
11622	1073	4043071	1944-10-27	1944-10-27 00:00:00	38000275	0	\N	\N	70383	0	228557008	4043071	
11878	1091	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	71631	0	180256009	4107731	
27	3	4078793	2018-10-29	2018-10-29 00:00:00	38000275	0	\N	\N	280	0	180325003	4078793	
217	12	4243062	1986-11-16	1986-11-16 00:00:00	38000275	0	\N	\N	997	0	60027007	4243062	
494	36	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	2525	0	180256009	4107731	
591	43	4125906	1990-03-24	1990-03-24 00:00:00	38000275	0	\N	\N	3155	0	288086009	4125906	
805	72	4010253	2000-10-09	2000-10-09 00:00:00	38000275	0	\N	\N	4886	0	112790001	4010253	
1004	96	4035793	1986-03-01	1986-03-01 00:00:00	38000275	0	\N	\N	6515	0	15081005	4035793	
1159	123	4151422	2006-08-17	2006-08-17 00:00:00	38000275	0	\N	\N	8144	0	269911007	4151422	
1425	137	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	9209	0	180256009	4107731	
1629	152	42535580	1973-12-15	1973-12-15 00:00:00	38000275	0	\N	\N	10291	0	426701000119108	42535580	
1710	155	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	10614	0	180256009	4107731	
1909	180	4107731	1992-05-21	1992-05-21 00:00:00	38000275	0	\N	\N	12182	0	180256009	4107731	
2115	211	4151422	1969-08-03	1969-08-03 00:00:00	38000275	0	\N	\N	14388	0	269911007	4151422	
2327	236	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	15882	0	395142003	4191853	
2479	254	4202451	2006-05-05	2006-05-05 00:00:00	38000275	0	\N	\N	16975	0	433112001	4202451	
2645	266	4107731	1991-07-22	1991-07-22 00:00:00	38000275	0	\N	\N	17679	0	180256009	4107731	
2832	273	4107731	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	18293	0	180256009	4107731	
3032	295	4170947	2015-11-24	2015-11-24 00:00:00	38000275	0	\N	\N	19645	0	274474001	4170947	
3262	320	4252419	1974-02-22	1974-02-22 00:00:00	38000275	0	\N	\N	21236	0	74016001	4252419	
3460	338	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	22489	0	180256009	4107731	
3581	343	4107731	1991-05-25	1991-05-25 00:00:00	38000275	0	\N	\N	22892	0	180256009	4107731	
3820	369	4125906	2013-03-07	2013-03-07 00:00:00	38000275	0	\N	\N	24580	0	288086009	4125906	
3955	399	4107731	1990-07-15	1990-07-15 00:00:00	38000275	0	\N	\N	26256	0	180256009	4107731	
4142	406	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	26745	0	180256009	4107731	
4331	419	4170947	1979-12-26	1979-12-26 00:00:00	38000275	0	\N	\N	27712	0	274474001	4170947	
4516	432	4043071	1938-11-29	1938-11-29 00:00:00	38000275	0	\N	\N	28746	0	228557008	4043071	
4782	449	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	29898	0	180256009	4107731	
4890	453	4043071	1984-12-18	1984-12-18 00:00:00	38000275	0	\N	\N	30246	0	228557008	4043071	
5077	469	4043071	1947-09-01	1947-09-01 00:00:00	38000275	0	\N	\N	31347	0	228557008	4043071	
5264	489	4107731	1992-08-30	1992-08-30 00:00:00	38000275	0	\N	\N	32813	0	180256009	4107731	
5451	499	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	33364	0	180256009	4107731	
5738	533	4125906	1971-04-16	1971-04-16 00:00:00	38000275	0	\N	\N	35368	0	288086009	4125906	
5825	534	4043071	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	35541	0	228557008	4043071	
6085	558	4043071	1969-05-02	1969-05-02 00:00:00	38000275	0	\N	\N	36966	0	228557008	4043071	
6207	569	4202451	1998-02-21	1998-02-21 00:00:00	38000275	0	\N	\N	37710	0	433112001	4202451	
6402	600	4293740	2012-08-25	2012-08-25 00:00:00	38000275	0	\N	\N	39651	0	384700001	4293740	
6573	603	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	39912	0	180256009	4107731	
6760	615	4125906	1999-03-30	1999-03-30 00:00:00	38000275	0	\N	\N	41046	0	288086009	4125906	
6961	640	4170947	1957-04-10	1957-04-10 00:00:00	38000275	0	\N	\N	42328	0	274474001	4170947	
7147	664	4107731	2011-07-19	2011-07-19 00:00:00	38000275	0	\N	\N	43809	0	180256009	4107731	
7321	680	4107731	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	45030	0	180256009	4107731	
7517	703	4078793	2007-02-02	2007-02-02 00:00:00	38000275	0	\N	\N	46495	0	180325003	4078793	
7747	711	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	47150	0	180256009	4107731	
7882	718	4057420	1974-10-19	1974-10-19 00:00:00	38000275	0	\N	\N	47525	0	18286008	4057420	
8073	736	4043071	1985-08-07	1985-08-07 00:00:00	38000275	0	\N	\N	48849	0	228557008	4043071	
8256	755	4195803	2018-10-14	2018-10-14 00:00:00	38000275	0	\N	\N	50013	0	312681000	4195803	
8507	778	4295880	1997-10-02	1997-10-02 00:00:00	38000275	0	\N	\N	51697	0	76601001	4295880	
8704	795	4125906	2000-11-02	2000-11-02 00:00:00	38000275	0	\N	\N	52734	0	288086009	4125906	
20758	1783	4107731	1992-07-13	1992-07-13 00:00:00	38000275	0	\N	\N	119558	0	180256009	4107731	
9010	826	4125906	2014-10-21	2014-10-21 00:00:00	38000275	0	\N	\N	54740	0	288086009	4125906	
9191	843	4107731	1997-10-25	1997-10-25 00:00:00	38000275	0	\N	\N	55781	0	180256009	4107731	
9378	859	4107731	1991-03-18	1991-03-18 00:00:00	38000275	0	\N	\N	56824	0	180256009	4107731	
9570	869	4024289	1937-11-25	1937-11-25 00:00:00	38000275	0	\N	\N	57723	0	19490002	4024289	
9760	877	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	58433	0	180256009	4107731	
9947	890	4043071	1971-01-12	1971-01-12 00:00:00	38000275	0	\N	\N	59323	0	228557008	4043071	
10242	914	4010253	1972-03-14	1972-03-14 00:00:00	38000275	0	\N	\N	60715	0	112790001	4010253	
10313	917	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	60964	0	180256009	4107731	
10511	950	4170947	1988-03-02	1988-03-02 00:00:00	38000275	0	\N	\N	63099	0	274474001	4170947	
10819	972	4163872	1974-01-20	1974-01-20 00:00:00	38000275	0	\N	\N	64718	0	399208008	4163872	
10902	1000	4170947	1972-08-23	1972-08-23 00:00:00	38000275	0	\N	\N	66137	0	274474001	4170947	
11178	1036	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	68169	0	180256009	4107731	
11291	1046	4170947	1975-03-19	1975-03-19 00:00:00	38000275	0	\N	\N	68696	0	274474001	4170947	
23405	2046	4151422	1946-11-21	1946-11-21 00:00:00	38000275	0	\N	\N	136170	0	269911007	4151422	
11623	1073	4043071	1944-11-24	1944-11-24 00:00:00	38000275	0	\N	\N	70418	0	228557008	4043071	
11879	1091	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	71741	0	180256009	4107731	
28	3	4078793	2013-09-30	2013-09-30 00:00:00	38000275	0	\N	\N	324	0	180325003	4078793	
222	16	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	1243	0	180256009	4107731	
495	36	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	2498	0	180256009	4107731	
592	43	4151422	1978-12-23	1978-12-23 00:00:00	38000275	0	\N	\N	3159	0	269911007	4151422	
806	72	4125906	1964-11-11	1964-11-11 00:00:00	38000275	0	\N	\N	4855	0	288086009	4125906	
1005	96	4336464	1997-01-25	1997-01-25 00:00:00	38000275	0	\N	\N	6509	0	232717009	4336464	
1160	123	44783196	1962-07-15	1962-07-15 00:00:00	38000275	0	\N	\N	8166	0	699253003	44783196	
1426	137	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	9141	0	180256009	4107731	
1630	152	4163951	1973-12-15	1973-12-15 00:00:00	38000275	0	\N	\N	10291	0	29303009	4163951	
1711	155	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	10591	0	180256009	4107731	
1910	180	4107731	1991-09-12	1991-09-12 00:00:00	38000275	0	\N	\N	12127	0	180256009	4107731	
2116	211	4125906	2003-03-07	2003-03-07 00:00:00	38000275	0	\N	\N	14406	0	288086009	4125906	
2328	236	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	15958	0	180256009	4107731	
2489	260	4107731	1992-06-06	1992-06-06 00:00:00	38000275	0	\N	\N	17256	0	180256009	4107731	
2646	266	4107731	1991-03-18	1991-03-18 00:00:00	38000275	0	\N	\N	17676	0	180256009	4107731	
2833	273	4107731	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	18240	0	180256009	4107731	
3033	295	4024289	2015-11-24	2015-11-24 00:00:00	38000275	0	\N	\N	19645	0	19490002	4024289	
3263	320	4125906	1960-12-24	1960-12-24 00:00:00	38000275	0	\N	\N	21232	0	288086009	4125906	
3461	338	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	22568	0	180256009	4107731	
3582	343	4107731	1990-10-27	1990-10-27 00:00:00	38000275	0	\N	\N	22904	0	180256009	4107731	
3821	369	4170947	1982-01-21	1982-01-21 00:00:00	38000275	0	\N	\N	24554	0	274474001	4170947	
3956	399	4107731	1990-06-03	1990-06-03 00:00:00	38000275	0	\N	\N	26255	0	180256009	4107731	
4143	406	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	26741	0	180256009	4107731	
4332	419	4202451	1994-07-31	1994-07-31 00:00:00	38000275	0	\N	\N	27775	0	433112001	4202451	
4517	432	4043071	1938-06-28	1938-06-28 00:00:00	38000275	0	\N	\N	28739	0	228557008	4043071	
4783	449	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	29945	0	180256009	4107731	
4891	453	4043071	1981-07-14	1981-07-14 00:00:00	38000275	0	\N	\N	30230	0	228557008	4043071	
5078	469	4043071	1951-02-05	1951-02-05 00:00:00	38000275	0	\N	\N	31248	0	228557008	4043071	
5265	489	4107731	1991-01-20	1991-01-20 00:00:00	38000275	0	\N	\N	32806	0	180256009	4107731	
5452	499	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	33441	0	180256009	4107731	
5739	533	4293740	1971-04-16	1971-04-16 00:00:00	38000275	0	\N	\N	35368	0	384700001	4293740	
5826	534	4043071	1992-12-17	1992-12-17 00:00:00	38000275	0	\N	\N	35525	0	228557008	4043071	
6086	558	4043071	1970-02-20	1970-02-20 00:00:00	38000275	0	\N	\N	36982	0	228557008	4043071	
6208	569	4202451	1998-05-30	1998-05-30 00:00:00	38000275	0	\N	\N	37721	0	433112001	4202451	
6403	600	4058899	1956-02-25	1956-02-25 00:00:00	38000275	0	\N	\N	39644	0	168594001	4058899	
6574	603	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	39926	0	180256009	4107731	
6761	615	4107731	1992-01-11	1992-01-11 00:00:00	38000275	0	\N	\N	40954	0	180256009	4107731	
6962	640	4163872	1967-07-04	1967-07-04 00:00:00	38000275	0	\N	\N	42375	0	399208008	4163872	
7148	664	4238715	2003-09-11	2003-09-11 00:00:00	38000275	0	\N	\N	43876	0	68254000	4238715	
7322	680	4107731	1992-12-28	1992-12-28 00:00:00	38000275	0	\N	\N	44994	0	180256009	4107731	
7518	703	4078793	2011-06-03	2011-06-03 00:00:00	38000275	0	\N	\N	46488	0	180325003	4078793	
7748	711	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	47184	0	180256009	4107731	
7883	718	4107731	1993-02-13	1993-02-13 00:00:00	38000275	0	\N	\N	47458	0	180256009	4107731	
8074	736	4043071	1985-10-02	1985-10-02 00:00:00	38000275	0	\N	\N	48788	0	228557008	4043071	
8257	755	4058899	1970-08-08	1970-08-08 00:00:00	38000275	0	\N	\N	50007	0	168594001	4058899	
8508	778	4170947	1988-03-16	1988-03-16 00:00:00	38000275	0	\N	\N	51673	0	274474001	4170947	
8705	795	4151422	1984-02-16	1984-02-16 00:00:00	38000275	0	\N	\N	52743	0	269911007	4151422	
20759	1783	4107731	1992-03-30	1992-03-30 00:00:00	38000275	0	\N	\N	119382	0	180256009	4107731	
9011	826	4202451	1988-06-09	1988-06-09 00:00:00	38000275	0	\N	\N	54769	0	433112001	4202451	
9192	843	4107731	1997-09-13	1997-09-13 00:00:00	38000275	0	\N	\N	55780	0	180256009	4107731	
9379	859	4107731	1992-10-26	1992-10-26 00:00:00	38000275	0	\N	\N	56869	0	180256009	4107731	
9571	869	4078793	1996-05-10	1996-05-10 00:00:00	38000275	0	\N	\N	57685	0	180325003	4078793	
9761	877	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	58426	0	180256009	4107731	
9948	890	4043071	1970-11-10	1970-11-10 00:00:00	38000275	0	\N	\N	59308	0	228557008	4043071	
10243	915	4243062	1961-01-19	1961-01-19 00:00:00	38000275	0	\N	\N	60784	0	60027007	4243062	
10314	917	4043071	1976-02-01	1976-02-01 00:00:00	38000275	0	\N	\N	60997	0	228557008	4043071	
10512	950	4043071	1981-07-23	1981-07-23 00:00:00	38000275	0	\N	\N	63064	0	228557008	4043071	
10820	972	4202451	2019-01-30	2019-01-30 00:00:00	38000275	0	\N	\N	64683	0	433112001	4202451	
10903	1000	4125906	2011-06-12	2011-06-12 00:00:00	38000275	0	\N	\N	66141	0	288086009	4125906	
11179	1036	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	68225	0	180256009	4107731	
11298	1051	4197460	1966-03-06	1966-03-06 00:00:00	38000275	0	\N	\N	68869	0	313191000	4197460	
23408	2051	4293740	1974-05-10	1974-05-10 00:00:00	38000275	0	\N	\N	136397	0	384700001	4293740	
11624	1073	4163872	1983-05-07	1983-05-07 00:00:00	38000275	0	\N	\N	70409	0	399208008	4163872	
11880	1091	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	71730	0	180256009	4107731	
29	3	4078793	2015-10-12	2015-10-12 00:00:00	38000275	0	\N	\N	325	0	180325003	4078793	
223	16	4125906	1975-05-25	1975-05-25 00:00:00	38000275	0	\N	\N	1162	0	288086009	4125906	
496	36	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	2557	0	180256009	4107731	
593	43	4024289	1987-03-10	1987-03-10 00:00:00	38000275	0	\N	\N	3154	0	19490002	4024289	
807	72	4145310	1969-09-30	1969-09-30 00:00:00	38000275	0	\N	\N	4856	0	268425006	4145310	
1006	96	4216130	1997-01-25	1997-01-25 00:00:00	38000275	0	\N	\N	6509	0	415070008	4216130	
1161	123	4252419	1962-07-08	1962-07-08 00:00:00	38000275	0	\N	\N	8165	0	74016001	4252419	
1427	137	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	9138	0	180256009	4107731	
1631	152	4047491	2000-10-23	2000-10-23 00:00:00	38000275	0	\N	\N	10294	0	1225002	4047491	
1712	155	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	10516	0	180256009	4107731	
1911	180	4107731	1993-01-07	1993-01-07 00:00:00	38000275	0	\N	\N	12156	0	180256009	4107731	
2117	211	4151422	2006-11-25	2006-11-25 00:00:00	38000275	0	\N	\N	14354	0	269911007	4151422	
2329	236	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	15866	0	180256009	4107731	
2490	260	4107731	1990-06-02	1990-06-02 00:00:00	38000275	0	\N	\N	17160	0	180256009	4107731	
2647	266	4197460	1984-12-25	1984-12-25 00:00:00	38000275	0	\N	\N	17691	0	313191000	4197460	
2834	273	4107731	1990-08-26	1990-08-26 00:00:00	38000275	0	\N	\N	18198	0	180256009	4107731	
3034	295	4195803	2015-11-24	2015-11-24 00:00:00	38000275	0	\N	\N	19645	0	312681000	4195803	
3264	321	4125906	1967-11-11	1967-11-11 00:00:00	38000275	0	\N	\N	21319	0	288086009	4125906	
3462	338	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	22523	0	180256009	4107731	
3583	343	4107731	1991-09-07	1991-09-07 00:00:00	38000275	0	\N	\N	22878	0	180256009	4107731	
3822	369	4243062	1982-01-21	1982-01-21 00:00:00	38000275	0	\N	\N	24554	0	60027007	4243062	
3957	399	4107731	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	26149	0	180256009	4107731	
4144	406	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	26850	0	180256009	4107731	
4333	419	4047491	1969-07-21	1969-07-21 00:00:00	38000275	0	\N	\N	27711	0	1225002	4047491	
4518	432	4043071	1938-07-26	1938-07-26 00:00:00	38000275	0	\N	\N	28738	0	228557008	4043071	
4784	449	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	29951	0	180256009	4107731	
4892	453	4043071	1985-02-26	1985-02-26 00:00:00	38000275	0	\N	\N	30185	0	228557008	4043071	
5079	469	4078793	2017-10-21	2017-10-21 00:00:00	38000275	0	\N	\N	31314	0	180325003	4078793	
5266	489	4107731	1991-10-20	1991-10-20 00:00:00	38000275	0	\N	\N	32809	0	180256009	4107731	
5453	499	4151422	1976-06-19	1976-06-19 00:00:00	38000275	0	\N	\N	33456	0	269911007	4151422	
5740	533	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	35473	0	180256009	4107731	
5827	534	4043071	1993-02-25	1993-02-25 00:00:00	38000275	0	\N	\N	35511	0	228557008	4043071	
6087	558	4043071	1969-12-26	1969-12-26 00:00:00	38000275	0	\N	\N	36968	0	228557008	4043071	
6209	569	4125906	2006-04-01	2006-04-01 00:00:00	38000275	0	\N	\N	37723	0	288086009	4125906	
6404	601	4107731	1993-05-09	1993-05-09 00:00:00	38000275	0	\N	\N	39754	0	180256009	4107731	
6575	603	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	39938	0	180256009	4107731	
6762	615	4058899	2003-02-21	2003-02-21 00:00:00	38000275	0	\N	\N	41047	0	168594001	4058899	
6963	642	4058899	1935-10-26	1935-10-26 00:00:00	38000275	0	\N	\N	42461	0	168594001	4058899	
7149	664	4107731	2012-01-24	2012-01-24 00:00:00	38000275	0	\N	\N	43884	0	180256009	4107731	
7323	680	4107731	1991-02-04	1991-02-04 00:00:00	38000275	0	\N	\N	44968	0	180256009	4107731	
7519	703	4058899	1966-07-27	1966-07-27 00:00:00	38000275	0	\N	\N	46508	0	168594001	4058899	
7749	711	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	47168	0	180256009	4107731	
7884	719	4170947	2009-09-11	2009-09-11 00:00:00	38000275	0	\N	\N	47564	0	274474001	4170947	
8075	736	4151422	2000-10-22	2000-10-22 00:00:00	38000275	0	\N	\N	48841	0	269911007	4151422	
8258	755	4195803	2016-01-28	2016-01-28 00:00:00	38000275	0	\N	\N	50012	0	312681000	4195803	
8509	778	4047491	1988-03-16	1988-03-16 00:00:00	38000275	0	\N	\N	51673	0	1225002	4047491	
20571	1773	4107731	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	118529	0	180256009	4107731	
20760	1783	4107731	1990-05-07	1990-05-07 00:00:00	38000275	0	\N	\N	119546	0	180256009	4107731	
9012	826	4243062	2013-09-26	2013-09-26 00:00:00	38000275	0	\N	\N	54739	0	60027007	4243062	
9193	843	4107731	1998-01-17	1998-01-17 00:00:00	38000275	0	\N	\N	55848	0	180256009	4107731	
9380	859	4107731	1993-03-01	1993-03-01 00:00:00	38000275	0	\N	\N	56780	0	180256009	4107731	
9572	869	4078793	2000-09-01	2000-09-01 00:00:00	38000275	0	\N	\N	57686	0	180325003	4078793	
9762	877	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	58360	0	180256009	4107731	
10016	895	4043071	1970-02-27	1970-02-27 00:00:00	38000275	0	\N	\N	59717	0	228557008	4043071	
10244	915	4170947	1961-01-19	1961-01-19 00:00:00	38000275	0	\N	\N	60784	0	274474001	4170947	
10315	917	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	60960	0	180256009	4107731	
10513	950	4043071	1982-03-11	1982-03-11 00:00:00	38000275	0	\N	\N	63102	0	228557008	4043071	
10821	973	4151422	1993-12-03	1993-12-03 00:00:00	38000275	0	\N	\N	64744	0	269911007	4151422	
10904	1000	4181917	2017-01-29	2017-01-29 00:00:00	38000275	0	\N	\N	66142	0	54550000	4181917	
11180	1036	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	68107	0	180256009	4107731	
11299	1051	4125906	1988-08-07	1988-08-07 00:00:00	38000275	0	\N	\N	68936	0	288086009	4125906	
23409	2051	4125906	1974-05-10	1974-05-10 00:00:00	38000275	0	\N	\N	136397	0	288086009	4125906	
11625	1073	4125906	1953-10-24	1953-10-24 00:00:00	38000275	0	\N	\N	70301	0	288086009	4125906	
11881	1091	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	71621	0	180256009	4107731	
30	3	4125906	1967-05-26	1967-05-26 00:00:00	38000275	0	\N	\N	346	0	288086009	4125906	
224	16	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	1265	0	180256009	4107731	
497	36	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	2648	0	180256009	4107731	
594	43	4170947	1987-03-10	1987-03-10 00:00:00	38000275	0	\N	\N	3154	0	274474001	4170947	
808	72	4151422	1985-05-26	1985-05-26 00:00:00	38000275	0	\N	\N	4835	0	269911007	4151422	
1007	96	4035793	1987-03-07	1987-03-07 00:00:00	38000275	0	\N	\N	6527	0	15081005	4035793	
1162	124	4107731	1998-03-23	1998-03-23 00:00:00	38000275	0	\N	\N	8248	0	180256009	4107731	
1428	137	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	9228	0	180256009	4107731	
1632	152	4170947	2000-10-23	2000-10-23 00:00:00	38000275	0	\N	\N	10294	0	274474001	4170947	
1713	155	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	10563	0	180256009	4107731	
1912	180	4191853	1980-05-17	1980-05-17 00:00:00	38000275	0	\N	\N	12198	0	395142003	4191853	
2118	212	4151422	1996-06-13	1996-06-13 00:00:00	38000275	0	\N	\N	14412	0	269911007	4151422	
2330	236	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	15959	0	180256009	4107731	
2491	260	4107731	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	17178	0	180256009	4107731	
2648	266	4107731	1993-03-01	1993-03-01 00:00:00	38000275	0	\N	\N	17681	0	180256009	4107731	
2835	273	4107731	1993-04-18	1993-04-18 00:00:00	38000275	0	\N	\N	18260	0	180256009	4107731	
3102	297	4238715	1977-04-17	1977-04-17 00:00:00	38000275	0	\N	\N	19785	0	68254000	4238715	
3265	321	4163872	1968-08-08	1968-08-08 00:00:00	38000275	0	\N	\N	21290	0	399208008	4163872	
3463	338	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	22525	0	395142003	4191853	
3584	343	4107731	1991-10-19	1991-10-19 00:00:00	38000275	0	\N	\N	22879	0	180256009	4107731	
3823	369	4151422	2014-09-18	2014-09-18 00:00:00	38000275	0	\N	\N	24525	0	269911007	4151422	
3958	399	4107731	1993-04-18	1993-04-18 00:00:00	38000275	0	\N	\N	26116	0	180256009	4107731	
4145	406	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	26766	0	180256009	4107731	
4334	419	4195803	1969-07-21	1969-07-21 00:00:00	38000275	0	\N	\N	27711	0	312681000	4195803	
4519	432	4078793	2015-06-29	2015-06-29 00:00:00	38000275	0	\N	\N	28710	0	180325003	4078793	
4785	449	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	29878	0	180256009	4107731	
4893	453	4043071	1983-03-22	1983-03-22 00:00:00	38000275	0	\N	\N	30205	0	228557008	4043071	
5080	469	4043071	1949-04-25	1949-04-25 00:00:00	38000275	0	\N	\N	31302	0	228557008	4043071	
5267	489	4107731	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	32750	0	180256009	4107731	
5454	500	4125906	1962-09-14	1962-09-14 00:00:00	38000275	0	\N	\N	33503	0	288086009	4125906	
5741	533	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	35415	0	180256009	4107731	
5828	534	4043071	1989-03-23	1989-03-23 00:00:00	38000275	0	\N	\N	35594	0	228557008	4043071	
6088	558	4043071	1969-10-24	1969-10-24 00:00:00	38000275	0	\N	\N	36981	0	228557008	4043071	
6210	569	4151422	2012-03-31	2012-03-31 00:00:00	38000275	0	\N	\N	37586	0	269911007	4151422	
6405	601	4107731	1990-12-30	1990-12-30 00:00:00	38000275	0	\N	\N	39764	0	180256009	4107731	
6576	603	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	39898	0	180256009	4107731	
6763	615	4107731	1990-02-17	1990-02-17 00:00:00	38000275	0	\N	\N	40868	0	180256009	4107731	
6964	642	4078793	2014-01-05	2014-01-05 00:00:00	38000275	0	\N	\N	42515	0	180325003	4078793	
7150	664	4107731	2011-04-05	2011-04-05 00:00:00	38000275	0	\N	\N	43921	0	180256009	4107731	
7324	680	4107731	1990-03-05	1990-03-05 00:00:00	38000275	0	\N	\N	44961	0	180256009	4107731	
7520	703	4078793	2013-06-14	2013-06-14 00:00:00	38000275	0	\N	\N	46489	0	180325003	4078793	
7750	711	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	47185	0	180256009	4107731	
7885	719	4024289	2009-09-11	2009-09-11 00:00:00	38000275	0	\N	\N	47564	0	19490002	4024289	
8076	738	4151422	1990-07-04	1990-07-04 00:00:00	38000275	0	\N	\N	48867	0	269911007	4151422	
8259	755	4047491	2016-01-28	2016-01-28 00:00:00	38000275	0	\N	\N	50012	0	1225002	4047491	
8510	778	4163872	1990-03-18	1990-03-18 00:00:00	38000275	0	\N	\N	51642	0	399208008	4163872	
20572	1773	4107731	1990-12-30	1990-12-30 00:00:00	38000275	0	\N	\N	118497	0	180256009	4107731	
20761	1783	4107731	1992-10-26	1992-10-26 00:00:00	38000275	0	\N	\N	119453	0	180256009	4107731	
9013	826	4195803	2013-09-26	2013-09-26 00:00:00	38000275	0	\N	\N	54739	0	312681000	4195803	
9194	843	4107731	1995-07-29	1995-07-29 00:00:00	38000275	0	\N	\N	55771	0	180256009	4107731	
9381	859	4107731	1991-12-16	1991-12-16 00:00:00	38000275	0	\N	\N	56865	0	180256009	4107731	
9573	869	4151422	1992-04-11	1992-04-11 00:00:00	38000275	0	\N	\N	57793	0	269911007	4151422	
9763	877	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	58395	0	180256009	4107731	
10017	895	4043071	1969-03-07	1969-03-07 00:00:00	38000275	0	\N	\N	59734	0	228557008	4043071	
10245	915	4125906	2018-03-19	2018-03-19 00:00:00	38000275	0	\N	\N	60788	0	288086009	4125906	
10316	917	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	61080	0	180256009	4107731	
10514	950	4043071	1982-02-04	1982-02-04 00:00:00	38000275	0	\N	\N	63065	0	228557008	4043071	
10822	973	4125906	1997-04-08	1997-04-08 00:00:00	38000275	0	\N	\N	64806	0	288086009	4125906	
10918	1004	4163872	1997-05-27	1997-05-27 00:00:00	38000275	0	\N	\N	66377	0	399208008	4163872	
11181	1036	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	68201	0	180256009	4107731	
11300	1051	4024289	1975-06-17	1975-06-17 00:00:00	38000275	0	\N	\N	68870	0	19490002	4024289	
23410	2051	4243062	2012-12-28	2012-12-28 00:00:00	38000275	0	\N	\N	136399	0	60027007	4243062	
11626	1073	4043071	1944-07-21	1944-07-21 00:00:00	38000275	0	\N	\N	70307	0	228557008	4043071	
11882	1091	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	71663	0	180256009	4107731	
31	3	4151422	1948-06-14	1948-06-14 00:00:00	38000275	0	\N	\N	359	0	269911007	4151422	
225	16	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	1177	0	180256009	4107731	
498	36	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	2495	0	180256009	4107731	
670	49	4057420	2003-07-12	2003-07-12 00:00:00	38000275	0	\N	\N	3529	0	18286008	4057420	
813	74	4125906	2013-08-27	2013-08-27 00:00:00	38000275	0	\N	\N	4981	0	288086009	4125906	
1008	97	4035793	2014-08-04	2014-08-04 00:00:00	38000275	0	\N	\N	6632	0	15081005	4035793	
1163	124	4107731	1998-08-18	1998-08-18 00:00:00	38000275	0	\N	\N	8217	0	180256009	4107731	
1429	137	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	9127	0	395142003	4191853	
1633	152	4125906	1995-03-03	1995-03-03 00:00:00	38000275	0	\N	\N	10293	0	288086009	4125906	
1714	155	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	10632	0	180256009	4107731	
1913	180	4107731	1990-08-30	1990-08-30 00:00:00	38000275	0	\N	\N	12164	0	180256009	4107731	
2119	212	4125906	1978-11-04	1978-11-04 00:00:00	38000275	0	\N	\N	14437	0	288086009	4125906	
2331	236	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	15896	0	180256009	4107731	
2492	260	4107731	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	17280	0	180256009	4107731	
2649	266	4107731	1992-07-13	1992-07-13 00:00:00	38000275	0	\N	\N	17714	0	180256009	4107731	
2836	273	4107731	1991-11-10	1991-11-10 00:00:00	38000275	0	\N	\N	18314	0	180256009	4107731	
3103	297	4151422	2010-02-12	2010-02-12 00:00:00	38000275	0	\N	\N	19789	0	269911007	4151422	
3266	321	4170947	1966-08-18	1966-08-18 00:00:00	38000275	0	\N	\N	21318	0	274474001	4170947	
3464	338	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	22488	0	180256009	4107731	
3585	343	4107731	1990-11-17	1990-11-17 00:00:00	38000275	0	\N	\N	22974	0	180256009	4107731	
3824	369	4293740	1997-02-15	1997-02-15 00:00:00	38000275	0	\N	\N	24579	0	384700001	4293740	
3959	399	4107731	1992-04-26	1992-04-26 00:00:00	38000275	0	\N	\N	26185	0	180256009	4107731	
4146	406	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	26737	0	180256009	4107731	
4335	419	4170947	1969-07-21	1969-07-21 00:00:00	38000275	0	\N	\N	27711	0	274474001	4170947	
4520	432	4043071	1939-03-21	1939-03-21 00:00:00	38000275	0	\N	\N	28747	0	228557008	4043071	
4786	449	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	29950	0	180256009	4107731	
4894	454	4151422	1959-06-04	1959-06-04 00:00:00	38000275	0	\N	\N	30320	0	269911007	4151422	
5081	469	4043071	1949-08-01	1949-08-01 00:00:00	38000275	0	\N	\N	31238	0	228557008	4043071	
5268	489	4107731	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	32786	0	180256009	4107731	
5455	500	4125906	1974-06-23	1974-06-23 00:00:00	38000275	0	\N	\N	33548	0	288086009	4125906	
5742	533	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	35414	0	180256009	4107731	
5829	534	4043071	1989-06-30	1989-06-30 00:00:00	38000275	0	\N	\N	35617	0	228557008	4043071	
6089	558	4043071	1969-09-19	1969-09-19 00:00:00	38000275	0	\N	\N	36980	0	228557008	4043071	
6215	571	4125906	1958-06-10	1958-06-10 00:00:00	38000275	0	\N	\N	37832	0	288086009	4125906	
6406	601	4107731	1991-12-01	1991-12-01 00:00:00	38000275	0	\N	\N	39778	0	180256009	4107731	
6577	603	4047491	1983-09-12	1983-09-12 00:00:00	38000275	0	\N	\N	39931	0	1225002	4047491	
6764	615	4107731	1993-05-08	1993-05-08 00:00:00	38000275	0	\N	\N	40917	0	180256009	4107731	
6965	642	4125906	1967-07-31	1967-07-31 00:00:00	38000275	0	\N	\N	42463	0	288086009	4125906	
7151	664	4107731	2011-11-01	2011-11-01 00:00:00	38000275	0	\N	\N	43882	0	180256009	4107731	
7325	680	4107731	1991-11-04	1991-11-04 00:00:00	38000275	0	\N	\N	44971	0	180256009	4107731	
7521	703	4078793	2014-01-03	2014-01-03 00:00:00	38000275	0	\N	\N	46432	0	180325003	4078793	
7751	711	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	47186	0	180256009	4107731	
7886	719	4125906	2010-09-06	2010-09-06 00:00:00	38000275	0	\N	\N	47565	0	288086009	4125906	
8077	738	4163872	1988-04-22	1988-04-22 00:00:00	38000275	0	\N	\N	48887	0	399208008	4163872	
8260	755	4170947	2016-01-28	2016-01-28 00:00:00	38000275	0	\N	\N	50012	0	274474001	4170947	
8511	778	4295880	1997-01-02	1997-01-02 00:00:00	38000275	0	\N	\N	51696	0	76601001	4295880	
20638	1776	4125906	1997-12-07	1997-12-07 00:00:00	38000275	0	\N	\N	118884	0	288086009	4125906	
20762	1783	4197460	1962-03-13	1962-03-13 00:00:00	38000275	0	\N	\N	119436	0	313191000	4197460	
9014	826	4170947	2013-09-26	2013-09-26 00:00:00	38000275	0	\N	\N	54739	0	274474001	4170947	
9195	843	4107731	1998-09-05	1998-09-05 00:00:00	38000275	0	\N	\N	55785	0	180256009	4107731	
9382	859	4107731	1990-01-22	1990-01-22 00:00:00	38000275	0	\N	\N	56755	0	180256009	4107731	
9574	869	4151422	1998-08-10	1998-08-10 00:00:00	38000275	0	\N	\N	57812	0	269911007	4151422	
9764	877	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	58359	0	180256009	4107731	
10018	895	4043071	1968-08-09	1968-08-09 00:00:00	38000275	0	\N	\N	59647	0	228557008	4043071	
10247	917	4043071	1976-03-07	1976-03-07 00:00:00	38000275	0	\N	\N	60998	0	228557008	4043071	
10317	917	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	61058	0	180256009	4107731	
10515	950	4043071	1981-06-18	1981-06-18 00:00:00	38000275	0	\N	\N	63063	0	228557008	4043071	
10823	973	4125906	1998-02-16	1998-02-16 00:00:00	38000275	0	\N	\N	64807	0	288086009	4125906	
10919	1004	4125906	2016-09-27	2016-09-27 00:00:00	38000275	0	\N	\N	66339	0	288086009	4125906	
11182	1036	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	68224	0	180256009	4107731	
11301	1051	4170947	1975-06-17	1975-06-17 00:00:00	38000275	0	\N	\N	68870	0	274474001	4170947	
23411	2051	4170947	2012-12-28	2012-12-28 00:00:00	38000275	0	\N	\N	136399	0	274474001	4170947	
11627	1073	4043071	1945-09-21	1945-09-21 00:00:00	38000275	0	\N	\N	70404	0	228557008	4043071	
11883	1091	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	71735	0	180256009	4107731	
32	3	4078793	2012-09-24	2012-09-24 00:00:00	38000275	0	\N	\N	277	0	180325003	4078793	
226	16	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	1268	0	180256009	4107731	
499	36	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	2501	0	180256009	4107731	
671	49	40492359	2003-07-12	2003-07-12 00:00:00	38000275	0	\N	\N	3529	0	447365002	40492359	
821	78	4058899	1978-09-25	1978-09-25 00:00:00	38000275	0	\N	\N	5163	0	168594001	4058899	
1009	97	4035793	2013-07-29	2013-07-29 00:00:00	38000275	0	\N	\N	6612	0	15081005	4035793	
1164	124	4107731	2000-03-27	2000-03-27 00:00:00	38000275	0	\N	\N	8204	0	180256009	4107731	
1430	137	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	9140	0	180256009	4107731	
1634	152	4293740	1995-03-03	1995-03-03 00:00:00	38000275	0	\N	\N	10293	0	384700001	4293740	
1715	155	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	10511	0	180256009	4107731	
1914	180	4107731	1993-06-03	1993-06-03 00:00:00	38000275	0	\N	\N	12090	0	180256009	4107731	
2120	212	4293740	1978-11-04	1978-11-04 00:00:00	38000275	0	\N	\N	14437	0	384700001	4293740	
2332	236	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	15953	0	180256009	4107731	
2493	260	4107731	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	17218	0	180256009	4107731	
2650	266	4107731	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	17755	0	180256009	4107731	
2837	273	4107731	1992-02-23	1992-02-23 00:00:00	38000275	0	\N	\N	18236	0	180256009	4107731	
3104	297	4275113	1976-04-18	1976-04-18 00:00:00	38000275	0	\N	\N	19792	0	65200003	4275113	
3267	321	4243062	1966-08-18	1966-08-18 00:00:00	38000275	0	\N	\N	21318	0	60027007	4243062	
3465	338	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	22571	0	180256009	4107731	
3586	343	4107731	1991-12-21	1991-12-21 00:00:00	38000275	0	\N	\N	22950	0	180256009	4107731	
3825	369	4125906	1997-02-15	1997-02-15 00:00:00	38000275	0	\N	\N	24579	0	288086009	4125906	
3960	399	4107731	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	26259	0	180256009	4107731	
4147	406	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	26848	0	180256009	4107731	
4336	419	4195803	1992-04-12	1992-04-12 00:00:00	38000275	0	\N	\N	27774	0	312681000	4195803	
4521	432	4043071	1940-01-30	1940-01-30 00:00:00	38000275	0	\N	\N	28668	0	228557008	4043071	
4787	449	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	29857	0	180256009	4107731	
4895	454	4078793	2014-02-22	2014-02-22 00:00:00	38000275	0	\N	\N	30302	0	180325003	4078793	
5082	469	4043071	1950-11-06	1950-11-06 00:00:00	38000275	0	\N	\N	31322	0	228557008	4043071	
5269	489	4107731	1990-06-03	1990-06-03 00:00:00	38000275	0	\N	\N	32760	0	180256009	4107731	
5456	500	4293740	1974-06-23	1974-06-23 00:00:00	38000275	0	\N	\N	33548	0	384700001	4293740	
5743	533	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	35476	0	180256009	4107731	
5830	534	4043071	1992-05-22	1992-05-22 00:00:00	38000275	0	\N	\N	35544	0	228557008	4043071	
6090	558	4043071	1969-01-31	1969-01-31 00:00:00	38000275	0	\N	\N	36989	0	228557008	4043071	
6216	571	4151422	1980-05-17	1980-05-17 00:00:00	38000275	0	\N	\N	37773	0	269911007	4151422	
6407	601	4107731	1992-06-28	1992-06-28 00:00:00	38000275	0	\N	\N	39750	0	180256009	4107731	
6578	603	4170947	1983-09-12	1983-09-12 00:00:00	38000275	0	\N	\N	39931	0	274474001	4170947	
6765	615	4107731	1992-06-06	1992-06-06 00:00:00	38000275	0	\N	\N	40977	0	180256009	4107731	
6966	642	4195803	2017-11-18	2017-11-18 00:00:00	38000275	0	\N	\N	42576	0	312681000	4195803	
7152	664	4107731	2012-09-11	2012-09-11 00:00:00	38000275	0	\N	\N	43886	0	180256009	4107731	
7326	680	4107731	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	45019	0	180256009	4107731	
7522	703	4078793	2009-05-22	2009-05-22 00:00:00	38000275	0	\N	\N	46487	0	180325003	4078793	
7752	711	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	47133	0	180256009	4107731	
7887	719	4024289	2016-08-19	2016-08-19 00:00:00	38000275	0	\N	\N	47566	0	19490002	4024289	
8078	738	4125906	1983-03-10	1983-03-10 00:00:00	38000275	0	\N	\N	48889	0	288086009	4125906	
8261	756	4058899	1974-02-18	1974-02-18 00:00:00	38000275	0	\N	\N	50172	0	168594001	4058899	
8512	778	4295880	1996-10-03	1996-10-03 00:00:00	38000275	0	\N	\N	51670	0	76601001	4295880	
20639	1776	4057420	2008-11-08	2008-11-08 00:00:00	38000275	0	\N	\N	118871	0	18286008	4057420	
20763	1783	4107731	1993-03-01	1993-03-01 00:00:00	38000275	0	\N	\N	119560	0	180256009	4107731	
9018	828	4252419	1971-04-14	1971-04-14 00:00:00	38000275	0	\N	\N	54863	0	74016001	4252419	
9196	843	4107731	1997-03-29	1997-03-29 00:00:00	38000275	0	\N	\N	55763	0	180256009	4107731	
9383	859	4107731	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	56890	0	180256009	4107731	
9575	869	4078793	1998-05-22	1998-05-22 00:00:00	38000275	0	\N	\N	57761	0	180325003	4078793	
9765	877	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	58428	0	180256009	4107731	
10019	895	4043071	1969-06-27	1969-06-27 00:00:00	38000275	0	\N	\N	59670	0	228557008	4043071	
10248	917	4043071	1973-09-23	1973-09-23 00:00:00	38000275	0	\N	\N	60992	0	228557008	4043071	
10318	917	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	60972	0	180256009	4107731	
10516	951	4125906	1967-12-30	1967-12-30 00:00:00	38000275	0	\N	\N	63219	0	288086009	4125906	
10824	973	4293740	1998-02-16	1998-02-16 00:00:00	38000275	0	\N	\N	64807	0	384700001	4293740	
10920	1005	4252419	1989-02-25	1989-02-25 00:00:00	38000275	0	\N	\N	66473	0	74016001	4252419	
11183	1036	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	68144	0	180256009	4107731	
11302	1051	4062501	1969-02-15	1969-02-15 00:00:00	38000275	0	\N	\N	68872	0	171231001	4062501	
23412	2051	4125906	1963-11-13	1963-11-13 00:00:00	38000275	0	\N	\N	136353	0	288086009	4125906	
11632	1076	4170947	1981-12-25	1981-12-25 00:00:00	38000275	0	\N	\N	70553	0	274474001	4170947	
11884	1091	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	71658	0	180256009	4107731	
33	3	4078793	2001-07-23	2001-07-23 00:00:00	38000275	0	\N	\N	258	0	180325003	4078793	
227	16	4293740	1989-06-24	1989-06-24 00:00:00	38000275	0	\N	\N	1164	0	384700001	4293740	
500	36	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	2523	0	395142003	4191853	
672	49	4058899	1980-02-26	1980-02-26 00:00:00	38000275	0	\N	\N	3525	0	168594001	4058899	
822	78	4125906	1968-11-25	1968-11-25 00:00:00	38000275	0	\N	\N	5162	0	288086009	4125906	
1010	97	4035793	2017-08-21	2017-08-21 00:00:00	38000275	0	\N	\N	6605	0	15081005	4035793	
1165	124	4107731	1997-07-15	1997-07-15 00:00:00	38000275	0	\N	\N	8302	0	180256009	4107731	
1431	137	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	9244	0	180256009	4107731	
1635	153	4043071	1960-01-14	1960-01-14 00:00:00	38000275	0	\N	\N	10384	0	228557008	4043071	
1716	155	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	10531	0	180256009	4107731	
1915	180	4107731	1991-02-14	1991-02-14 00:00:00	38000275	0	\N	\N	12134	0	180256009	4107731	
2121	212	4181917	2012-03-10	2012-03-10 00:00:00	38000275	0	\N	\N	14440	0	54550000	4181917	
2333	236	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	15867	0	180256009	4107731	
2494	260	4107731	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	17162	0	180256009	4107731	
2651	266	4107731	1990-02-12	1990-02-12 00:00:00	38000275	0	\N	\N	17653	0	180256009	4107731	
2838	273	4107731	1990-04-22	1990-04-22 00:00:00	38000275	0	\N	\N	18215	0	180256009	4107731	
3105	298	4293740	2010-06-18	2010-06-18 00:00:00	38000275	0	\N	\N	19885	0	384700001	4293740	
3268	321	4125906	1978-03-02	1978-03-02 00:00:00	38000275	0	\N	\N	21320	0	288086009	4125906	
3466	338	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	22567	0	180256009	4107731	
3587	343	4107731	1990-12-29	1990-12-29 00:00:00	38000275	0	\N	\N	22975	0	180256009	4107731	
3826	370	4125906	1970-10-20	1970-10-20 00:00:00	38000275	0	\N	\N	24582	0	288086009	4125906	
3961	399	4107731	1990-10-07	1990-10-07 00:00:00	38000275	0	\N	\N	26134	0	180256009	4107731	
4148	406	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	26758	0	395142003	4191853	
4337	419	4195803	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	27761	0	312681000	4195803	
4522	432	4043071	1939-08-29	1939-08-29 00:00:00	38000275	0	\N	\N	28748	0	228557008	4043071	
4788	449	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	29947	0	395142003	4191853	
4896	454	4057420	2013-02-16	2013-02-16 00:00:00	38000275	0	\N	\N	30331	0	18286008	4057420	
5083	469	4043071	1950-03-13	1950-03-13 00:00:00	38000275	0	\N	\N	31320	0	228557008	4043071	
5270	489	4107731	1992-02-23	1992-02-23 00:00:00	38000275	0	\N	\N	32763	0	180256009	4107731	
5457	500	4163872	2013-03-19	2013-03-19 00:00:00	38000275	0	\N	\N	33550	0	399208008	4163872	
5744	533	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	35400	0	180256009	4107731	
5831	534	4043071	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	35614	0	228557008	4043071	
6091	558	4043071	1969-06-06	1969-06-06 00:00:00	38000275	0	\N	\N	36967	0	228557008	4043071	
6217	571	4326177	1956-08-29	1956-08-29 00:00:00	38000275	0	\N	\N	37797	0	430193006	4326177	
6408	601	4107731	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	39710	0	180256009	4107731	
6579	603	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	39894	0	180256009	4107731	
6766	615	4107731	1990-09-15	1990-09-15 00:00:00	38000275	0	\N	\N	40969	0	180256009	4107731	
6967	642	4047491	2017-11-18	2017-11-18 00:00:00	38000275	0	\N	\N	42576	0	1225002	4047491	
7153	664	4107731	2011-06-07	2011-06-07 00:00:00	38000275	0	\N	\N	43808	0	180256009	4107731	
7327	680	4107731	1991-09-23	1991-09-23 00:00:00	38000275	0	\N	\N	44970	0	180256009	4107731	
7523	703	4078793	2009-05-15	2009-05-15 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
7753	711	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	47143	0	180256009	4107731	
7888	719	4170947	2016-08-19	2016-08-19 00:00:00	38000275	0	\N	\N	47566	0	274474001	4170947	
8079	738	4125906	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	48890	0	288086009	4125906	
8262	756	4151422	2005-01-04	2005-01-04 00:00:00	38000275	0	\N	\N	50156	0	269911007	4151422	
8513	778	4295880	1998-01-01	1998-01-01 00:00:00	38000275	0	\N	\N	51652	0	76601001	4295880	
20640	1776	4195803	1992-12-03	1992-12-03 00:00:00	38000275	0	\N	\N	118805	0	312681000	4195803	
20764	1783	4107731	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	119487	0	180256009	4107731	
9019	828	4125906	1999-10-21	1999-10-21 00:00:00	38000275	0	\N	\N	54865	0	288086009	4125906	
9197	843	4107731	1997-12-06	1997-12-06 00:00:00	38000275	0	\N	\N	55847	0	180256009	4107731	
9384	859	4107731	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	56822	0	180256009	4107731	
9576	869	4057420	2001-09-07	2001-09-07 00:00:00	38000275	0	\N	\N	57717	0	18286008	4057420	
9766	877	4191853	1993-11-09	1993-11-09 00:00:00	38000275	0	\N	\N	58381	0	395142003	4191853	
10020	895	4043071	1968-03-08	1968-03-08 00:00:00	38000275	0	\N	\N	59645	0	228557008	4043071	
10249	917	4043071	1973-08-19	1973-08-19 00:00:00	38000275	0	\N	\N	60916	0	228557008	4043071	
10319	917	4043071	1975-01-26	1975-01-26 00:00:00	38000275	0	\N	\N	60975	0	228557008	4043071	
10517	951	4151422	1990-12-09	1990-12-09 00:00:00	38000275	0	\N	\N	63166	0	269911007	4151422	
10825	973	4125906	2016-06-02	2016-06-02 00:00:00	38000275	0	\N	\N	64829	0	288086009	4125906	
10921	1005	44783196	1989-03-04	1989-03-04 00:00:00	38000275	0	\N	\N	66407	0	699253003	44783196	
11184	1036	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	68220	0	180256009	4107731	
11303	1051	4125906	1991-08-06	1991-08-06 00:00:00	38000275	0	\N	\N	68937	0	288086009	4125906	
23413	2052	40492359	2015-10-19	2015-10-19 00:00:00	38000275	0	\N	\N	136411	0	447365002	40492359	
11633	1076	4243062	1981-12-25	1981-12-25 00:00:00	38000275	0	\N	\N	70553	0	60027007	4243062	
11885	1091	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	71616	0	180256009	4107731	
34	3	4057420	2004-08-09	2004-08-09 00:00:00	38000275	0	\N	\N	274	0	18286008	4057420	
228	16	4125906	1989-06-24	1989-06-24 00:00:00	38000275	0	\N	\N	1164	0	288086009	4125906	
501	36	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	2554	0	180256009	4107731	
673	49	4195803	1980-02-26	1980-02-26 00:00:00	38000275	0	\N	\N	3525	0	312681000	4195803	
823	79	4010253	1996-07-03	1996-07-03 00:00:00	38000275	0	\N	\N	5309	0	112790001	4010253	
1011	97	4035793	2018-08-27	2018-08-27 00:00:00	38000275	0	\N	\N	6641	0	15081005	4035793	
1166	124	4058899	1993-11-13	1993-11-13 00:00:00	38000275	0	\N	\N	8288	0	168594001	4058899	
1432	137	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	9168	0	180256009	4107731	
1636	153	4043071	1958-09-18	1958-09-18 00:00:00	38000275	0	\N	\N	10371	0	228557008	4043071	
1717	155	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	10533	0	180256009	4107731	
1916	180	4107731	1991-03-28	1991-03-28 00:00:00	38000275	0	\N	\N	12135	0	180256009	4107731	
2122	212	4181917	2014-11-01	2014-11-01 00:00:00	38000275	0	\N	\N	14441	0	54550000	4181917	
2334	236	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	15955	0	180256009	4107731	
2495	260	4107731	1991-11-09	1991-11-09 00:00:00	38000275	0	\N	\N	17282	0	180256009	4107731	
2652	266	4107731	1991-11-04	1991-11-04 00:00:00	38000275	0	\N	\N	17722	0	180256009	4107731	
2839	273	4107731	1992-06-28	1992-06-28 00:00:00	38000275	0	\N	\N	18207	0	180256009	4107731	
3106	298	4125906	2010-06-18	2010-06-18 00:00:00	38000275	0	\N	\N	19885	0	288086009	4125906	
3277	326	4243062	1980-01-10	1980-01-10 00:00:00	38000275	0	\N	\N	21528	0	60027007	4243062	
3467	338	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	22493	0	180256009	4107731	
3592	347	4035793	2018-12-09	2018-12-09 00:00:00	38000275	0	\N	\N	23081	0	15081005	4035793	
3827	370	4170947	1994-01-27	1994-01-27 00:00:00	38000275	0	\N	\N	24585	0	274474001	4170947	
3962	399	4107731	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	26244	0	180256009	4107731	
4149	406	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	26722	0	180256009	4107731	
4338	419	4058899	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	27761	0	168594001	4058899	
4523	432	4043071	1940-04-02	1940-04-02 00:00:00	38000275	0	\N	\N	28750	0	228557008	4043071	
4789	449	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	29943	0	180256009	4107731	
4897	454	4125906	1991-12-15	1991-12-15 00:00:00	38000275	0	\N	\N	30275	0	288086009	4125906	
5084	469	4043071	1950-06-26	1950-06-26 00:00:00	38000275	0	\N	\N	31306	0	228557008	4043071	
5271	489	4107731	1991-02-10	1991-02-10 00:00:00	38000275	0	\N	\N	32723	0	180256009	4107731	
5458	500	4170947	2013-03-19	2013-03-19 00:00:00	38000275	0	\N	\N	33550	0	274474001	4170947	
5745	533	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	35433	0	180256009	4107731	
5832	534	4043071	1990-02-08	1990-02-08 00:00:00	38000275	0	\N	\N	35597	0	228557008	4043071	
6092	558	4043071	1969-11-28	1969-11-28 00:00:00	38000275	0	\N	\N	37023	0	228557008	4043071	
6218	571	4037675	1956-08-29	1956-08-29 00:00:00	38000275	0	\N	\N	37797	0	162676008	4037675	
6409	601	4107731	1991-08-18	1991-08-18 00:00:00	38000275	0	\N	\N	39766	0	180256009	4107731	
6580	603	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	39915	0	180256009	4107731	
6767	615	4107731	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	40931	0	180256009	4107731	
6968	642	4170947	2017-11-18	2017-11-18 00:00:00	38000275	0	\N	\N	42576	0	274474001	4170947	
7154	664	4151422	1987-09-07	1987-09-07 00:00:00	38000275	0	\N	\N	43802	0	269911007	4151422	
7328	680	44783196	2012-07-24	2012-07-24 00:00:00	38000275	0	\N	\N	45079	0	699253003	44783196	
7524	703	4078793	2012-06-08	2012-06-08 00:00:00	38000275	0	\N	\N	46469	0	180325003	4078793	
7754	711	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	47180	0	180256009	4107731	
7889	720	4125906	1975-05-04	1975-05-04 00:00:00	38000275	0	\N	\N	47658	0	288086009	4125906	
8080	739	4151422	1923-06-26	1923-06-26 00:00:00	38000275	0	\N	\N	48971	0	269911007	4151422	
8263	756	4252419	1995-08-25	1995-08-25 00:00:00	38000275	0	\N	\N	50104	0	74016001	4252419	
8514	778	4295880	1998-10-01	1998-10-01 00:00:00	38000275	0	\N	\N	51705	0	76601001	4295880	
20641	1776	4163872	1992-12-03	1992-12-03 00:00:00	38000275	0	\N	\N	118805	0	399208008	4163872	
20765	1783	4107731	1991-09-02	1991-09-02 00:00:00	38000275	0	\N	\N	119476	0	180256009	4107731	
9020	828	4202451	2005-06-14	2005-06-14 00:00:00	38000275	0	\N	\N	54823	0	433112001	4202451	
9198	843	4107731	1996-07-20	1996-07-20 00:00:00	38000275	0	\N	\N	55776	0	180256009	4107731	
9385	859	4107731	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	56758	0	180256009	4107731	
9577	869	4078793	1993-04-23	1993-04-23 00:00:00	38000275	0	\N	\N	57714	0	180325003	4078793	
9767	877	4107731	1993-09-28	1993-09-28 00:00:00	38000275	0	\N	\N	58436	0	180256009	4107731	
10021	895	4043071	1968-10-04	1968-10-04 00:00:00	38000275	0	\N	\N	59731	0	228557008	4043071	
10250	917	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	60971	0	180256009	4107731	
10320	917	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	60927	0	180256009	4107731	
10518	951	4198190	2011-12-20	2011-12-20 00:00:00	38000275	0	\N	\N	63217	0	80146002	4198190	
10826	973	4062501	1917-08-23	1917-08-23 00:00:00	38000275	0	\N	\N	64732	0	171231001	4062501	
10922	1005	4062501	1970-02-27	1970-02-27 00:00:00	38000275	0	\N	\N	66404	0	171231001	4062501	
11185	1036	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	68152	0	180256009	4107731	
11305	1053	4151422	1978-08-19	1978-08-19 00:00:00	38000275	0	\N	\N	69044	0	269911007	4151422	
23414	2052	4057420	2015-10-19	2015-10-19 00:00:00	38000275	0	\N	\N	136411	0	18286008	4057420	
11634	1076	4170947	1980-10-01	1980-10-01 00:00:00	38000275	0	\N	\N	70552	0	274474001	4170947	
11886	1091	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	71734	0	180256009	4107731	
35	3	4078793	2002-07-29	2002-07-29 00:00:00	38000275	0	\N	\N	273	0	180325003	4078793	
229	16	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	1167	0	180256009	4107731	
502	36	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	2508	0	180256009	4107731	
674	53	4170947	1974-05-05	1974-05-05 00:00:00	38000275	0	\N	\N	3633	0	274474001	4170947	
824	79	4125906	1967-07-05	1967-07-05 00:00:00	38000275	0	\N	\N	5263	0	288086009	4125906	
1012	97	4125906	1996-09-16	1996-09-16 00:00:00	38000275	0	\N	\N	6647	0	288086009	4125906	
1167	124	4107731	1999-09-21	1999-09-21 00:00:00	38000275	0	\N	\N	8223	0	180256009	4107731	
1433	137	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	9197	0	180256009	4107731	
1637	153	4043071	1959-08-20	1959-08-20 00:00:00	38000275	0	\N	\N	10362	0	228557008	4043071	
1718	155	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	10613	0	180256009	4107731	
1917	180	4107731	1992-11-05	1992-11-05 00:00:00	38000275	0	\N	\N	12142	0	180256009	4107731	
2123	212	4125906	2007-04-20	2007-04-20 00:00:00	38000275	0	\N	\N	14438	0	288086009	4125906	
2335	236	4275113	1979-01-07	1979-01-07 00:00:00	38000275	0	\N	\N	15833	0	65200003	4275113	
2496	260	4107731	1990-10-06	1990-10-06 00:00:00	38000275	0	\N	\N	17276	0	180256009	4107731	
2653	266	4107731	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	17697	0	180256009	4107731	
2840	273	4107731	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	18312	0	180256009	4107731	
3107	298	4151422	1967-02-24	1967-02-24 00:00:00	38000275	0	\N	\N	19894	0	269911007	4151422	
3278	326	4170947	1980-01-10	1980-01-10 00:00:00	38000275	0	\N	\N	21528	0	274474001	4170947	
3468	338	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	22495	0	180256009	4107731	
3593	347	4035793	2010-11-21	2010-11-21 00:00:00	38000275	0	\N	\N	23111	0	15081005	4035793	
3828	370	4047491	1994-01-27	1994-01-27 00:00:00	38000275	0	\N	\N	24585	0	1225002	4047491	
3963	399	4107731	1993-01-24	1993-01-24 00:00:00	38000275	0	\N	\N	26123	0	180256009	4107731	
4150	406	4107731	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	26830	0	180256009	4107731	
4339	419	4125906	1915-06-09	1915-06-09 00:00:00	38000275	0	\N	\N	27707	0	288086009	4125906	
4524	432	4078793	2014-06-23	2014-06-23 00:00:00	38000275	0	\N	\N	28655	0	180325003	4078793	
4790	449	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	29930	0	180256009	4107731	
4898	454	4293740	1991-12-15	1991-12-15 00:00:00	38000275	0	\N	\N	30275	0	384700001	4293740	
5085	469	4043071	1950-07-31	1950-07-31 00:00:00	38000275	0	\N	\N	31289	0	228557008	4043071	
5272	489	4107731	1991-03-03	1991-03-03 00:00:00	38000275	0	\N	\N	32807	0	180256009	4107731	
5459	500	4195803	2013-03-19	2013-03-19 00:00:00	38000275	0	\N	\N	33550	0	312681000	4195803	
5746	533	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	35402	0	180256009	4107731	
5833	534	4043071	1991-05-10	1991-05-10 00:00:00	38000275	0	\N	\N	35522	0	228557008	4043071	
6093	558	4043071	1968-12-06	1968-12-06 00:00:00	38000275	0	\N	\N	37010	0	228557008	4043071	
6219	571	4187458	1956-08-29	1956-08-29 00:00:00	38000275	0	\N	\N	37797	0	415300000	4187458	
6410	601	4107731	1990-04-22	1990-04-22 00:00:00	38000275	0	\N	\N	39657	0	180256009	4107731	
6581	603	4125906	2015-09-29	2015-09-29 00:00:00	38000275	0	\N	\N	39933	0	288086009	4125906	
6768	615	4107731	1990-12-08	1990-12-08 00:00:00	38000275	0	\N	\N	41064	0	180256009	4107731	
6969	642	4125906	2017-01-08	2017-01-08 00:00:00	38000275	0	\N	\N	42575	0	288086009	4125906	
7155	664	4107731	2011-12-13	2011-12-13 00:00:00	38000275	0	\N	\N	43883	0	180256009	4107731	
7329	680	4107731	1990-04-16	1990-04-16 00:00:00	38000275	0	\N	\N	44962	0	180256009	4107731	
7525	703	4078793	2015-01-09	2015-01-09 00:00:00	38000275	0	\N	\N	46470	0	180325003	4078793	
7755	711	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	47135	0	180256009	4107731	
7890	720	4047491	1968-08-08	1968-08-08 00:00:00	38000275	0	\N	\N	47657	0	1225002	4047491	
8081	739	4047491	1935-06-21	1935-06-21 00:00:00	38000275	0	\N	\N	48969	0	1225002	4047491	
8264	756	4047491	1972-12-25	1972-12-25 00:00:00	38000275	0	\N	\N	50171	0	1225002	4047491	
8515	778	4295880	1996-07-04	1996-07-04 00:00:00	38000275	0	\N	\N	51650	0	76601001	4295880	
20642	1776	4170947	1992-12-03	1992-12-03 00:00:00	38000275	0	\N	\N	118805	0	274474001	4170947	
20766	1783	4191853	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	119524	0	395142003	4191853	
9021	828	44783196	1971-04-21	1971-04-21 00:00:00	38000275	0	\N	\N	54874	0	699253003	44783196	
9199	843	4107731	1997-06-21	1997-06-21 00:00:00	38000275	0	\N	\N	55765	0	180256009	4107731	
9386	859	4107731	1991-08-12	1991-08-12 00:00:00	38000275	0	\N	\N	56806	0	180256009	4107731	
9578	869	4078793	1998-08-21	1998-08-21 00:00:00	38000275	0	\N	\N	57738	0	180325003	4078793	
9768	877	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	58417	0	180256009	4107731	
10022	895	4043071	1967-09-01	1967-09-01 00:00:00	38000275	0	\N	\N	59680	0	228557008	4043071	
10251	917	4043071	1974-03-24	1974-03-24 00:00:00	38000275	0	\N	\N	60932	0	228557008	4043071	
10321	917	4043071	1975-08-24	1975-08-24 00:00:00	38000275	0	\N	\N	60996	0	228557008	4043071	
10519	951	4330583	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	63170	0	22523008	4330583	
10827	973	4195803	1994-09-12	1994-09-12 00:00:00	38000275	0	\N	\N	64851	0	312681000	4195803	
10970	1015	4057420	1973-07-23	1973-07-23 00:00:00	38000275	0	\N	\N	66813	0	18286008	4057420	
11186	1036	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	68142	0	180256009	4107731	
11306	1053	4181917	1982-12-03	1982-12-03 00:00:00	38000275	0	\N	\N	69039	0	54550000	4181917	
23415	2052	4151422	1978-05-04	1978-05-04 00:00:00	38000275	0	\N	\N	136439	0	269911007	4151422	
11635	1076	4047491	1980-10-01	1980-10-01 00:00:00	38000275	0	\N	\N	70552	0	1225002	4047491	
11887	1091	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	71742	0	180256009	4107731	
36	3	4078793	2010-09-13	2010-09-13 00:00:00	38000275	0	\N	\N	331	0	180325003	4078793	
230	16	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	1224	0	180256009	4107731	
503	36	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	2529	0	180256009	4107731	
675	53	4047491	1974-05-05	1974-05-05 00:00:00	38000275	0	\N	\N	3633	0	1225002	4047491	
825	79	4062501	1949-05-02	1949-05-02 00:00:00	38000275	0	\N	\N	5251	0	171231001	4062501	
1013	97	4035793	2012-07-23	2012-07-23 00:00:00	38000275	0	\N	\N	6631	0	15081005	4035793	
1168	124	4107731	2000-01-24	2000-01-24 00:00:00	38000275	0	\N	\N	8275	0	180256009	4107731	
1434	137	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	9144	0	180256009	4107731	
1638	153	4043071	1959-03-19	1959-03-19 00:00:00	38000275	0	\N	\N	10379	0	228557008	4043071	
1719	155	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	10552	0	180256009	4107731	
1918	180	4107731	1991-04-18	1991-04-18 00:00:00	38000275	0	\N	\N	12191	0	180256009	4107731	
2124	213	4198190	1977-04-29	1977-04-29 00:00:00	38000275	0	\N	\N	14547	0	80146002	4198190	
2336	236	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	15956	0	180256009	4107731	
2497	260	4107731	1991-04-13	1991-04-13 00:00:00	38000275	0	\N	\N	17244	0	180256009	4107731	
2654	266	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	17656	0	180256009	4107731	
2841	273	4107731	1992-08-09	1992-08-09 00:00:00	38000275	0	\N	\N	18208	0	180256009	4107731	
3108	298	4151422	1989-11-18	1989-11-18 00:00:00	38000275	0	\N	\N	19918	0	269911007	4151422	
3279	327	4243062	1974-10-13	1974-10-13 00:00:00	38000275	0	\N	\N	21617	0	60027007	4243062	
3469	338	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	22531	0	180256009	4107731	
3594	347	4035793	2016-12-04	2016-12-04 00:00:00	38000275	0	\N	\N	23112	0	15081005	4035793	
3829	372	4151422	1994-11-27	1994-11-27 00:00:00	38000275	0	\N	\N	24715	0	269911007	4151422	
3964	399	4107731	1990-02-18	1990-02-18 00:00:00	38000275	0	\N	\N	26132	0	180256009	4107731	
4151	406	4191853	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	26726	0	395142003	4191853	
4340	419	4163872	1943-02-22	1943-02-22 00:00:00	38000275	0	\N	\N	27752	0	399208008	4163872	
4525	432	4043071	1939-08-01	1939-08-01 00:00:00	38000275	0	\N	\N	28718	0	228557008	4043071	
4791	449	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	29910	0	180256009	4107731	
4899	454	4078793	2007-03-17	2007-03-17 00:00:00	38000275	0	\N	\N	30330	0	180325003	4078793	
5086	469	4043071	1948-11-29	1948-11-29 00:00:00	38000275	0	\N	\N	31317	0	228557008	4043071	
5273	489	4107731	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	32731	0	180256009	4107731	
5461	502	4057420	2016-03-05	2016-03-05 00:00:00	38000275	0	\N	\N	33579	0	18286008	4057420	
5747	533	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	35463	0	180256009	4107731	
5834	534	4043071	1991-10-04	1991-10-04 00:00:00	38000275	0	\N	\N	35564	0	228557008	4043071	
6094	558	4170947	1977-11-04	1977-11-04 00:00:00	38000275	0	\N	\N	37007	0	274474001	4170947	
6220	571	4170947	1968-02-09	1968-02-09 00:00:00	38000275	0	\N	\N	37833	0	274474001	4170947	
6411	601	4107731	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	39672	0	180256009	4107731	
6582	603	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	39922	0	180256009	4107731	
6769	615	4107731	1990-03-31	1990-03-31 00:00:00	38000275	0	\N	\N	40869	0	180256009	4107731	
6970	642	4078793	2009-09-20	2009-09-20 00:00:00	38000275	0	\N	\N	42482	0	180325003	4078793	
7156	664	4107731	2012-05-08	2012-05-08 00:00:00	38000275	0	\N	\N	43844	0	180256009	4107731	
7330	680	4252419	2012-07-17	2012-07-17 00:00:00	38000275	0	\N	\N	45095	0	74016001	4252419	
7526	703	4078793	2009-02-13	2009-02-13 00:00:00	38000275	0	\N	\N	46467	0	180325003	4078793	
7756	711	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	47099	0	180256009	4107731	
7891	720	4170947	1968-08-08	1968-08-08 00:00:00	38000275	0	\N	\N	47657	0	274474001	4170947	
8082	739	4170947	1935-06-21	1935-06-21 00:00:00	38000275	0	\N	\N	48969	0	274474001	4170947	
8265	756	4170947	1972-12-25	1972-12-25 00:00:00	38000275	0	\N	\N	50171	0	274474001	4170947	
8516	778	4295880	1997-04-03	1997-04-03 00:00:00	38000275	0	\N	\N	51651	0	76601001	4295880	
20643	1776	4057420	2012-12-01	2012-12-01 00:00:00	38000275	0	\N	\N	118873	0	18286008	4057420	
20767	1783	4107731	1992-01-27	1992-01-27 00:00:00	38000275	0	\N	\N	119554	0	180256009	4107731	
9022	828	4058899	1965-06-14	1965-06-14 00:00:00	38000275	0	\N	\N	54862	0	168594001	4058899	
9200	843	4107731	1997-11-15	1997-11-15 00:00:00	38000275	0	\N	\N	55832	0	180256009	4107731	
9387	859	4107731	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	56805	0	180256009	4107731	
9579	869	4078793	2015-11-27	2015-11-27 00:00:00	38000275	0	\N	\N	57690	0	180325003	4078793	
9769	877	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	58420	0	180256009	4107731	
10023	895	4043071	1967-06-02	1967-06-02 00:00:00	38000275	0	\N	\N	59643	0	228557008	4043071	
10252	917	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	60970	0	180256009	4107731	
10322	917	4043071	1974-09-01	1974-09-01 00:00:00	38000275	0	\N	\N	60933	0	228557008	4043071	
10520	951	4151422	1984-01-20	1984-01-20 00:00:00	38000275	0	\N	\N	63138	0	269911007	4151422	
10828	974	4293740	1976-06-14	1976-06-14 00:00:00	38000275	0	\N	\N	64965	0	384700001	4293740	
10971	1015	40492359	1973-07-23	1973-07-23 00:00:00	38000275	0	\N	\N	66813	0	447365002	40492359	
11187	1036	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	68158	0	180256009	4107731	
11307	1053	4151422	2004-09-23	2004-09-23 00:00:00	38000275	0	\N	\N	69007	0	269911007	4151422	
23416	2053	4195803	2010-03-24	2010-03-24 00:00:00	38000275	0	\N	\N	136571	0	312681000	4195803	
11636	1077	4047491	1963-10-16	1963-10-16 00:00:00	38000275	0	\N	\N	70602	0	1225002	4047491	
11888	1091	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	71643	0	180256009	4107731	
37	3	4078793	2006-08-21	2006-08-21 00:00:00	38000275	0	\N	\N	329	0	180325003	4078793	
231	16	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	1226	0	180256009	4107731	
504	36	4125906	1964-10-19	1964-10-19 00:00:00	38000275	0	\N	\N	2613	0	288086009	4125906	
676	53	4145310	1988-02-26	1988-02-26 00:00:00	38000275	0	\N	\N	3684	0	268425006	4145310	
826	79	4125906	1979-02-15	1979-02-15 00:00:00	38000275	0	\N	\N	5265	0	288086009	4125906	
1014	97	4035793	2016-08-15	2016-08-15 00:00:00	38000275	0	\N	\N	6633	0	15081005	4035793	
1169	124	4107731	2000-01-03	2000-01-03 00:00:00	38000275	0	\N	\N	8332	0	180256009	4107731	
1435	137	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	9166	0	180256009	4107731	
1639	153	4043071	1959-05-28	1959-05-28 00:00:00	38000275	0	\N	\N	10361	0	228557008	4043071	
1720	155	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	10601	0	180256009	4107731	
1919	180	4107731	1993-05-13	1993-05-13 00:00:00	38000275	0	\N	\N	12187	0	180256009	4107731	
2125	213	4125906	1988-05-10	1988-05-10 00:00:00	38000275	0	\N	\N	14535	0	288086009	4125906	
2337	236	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	15845	0	180256009	4107731	
2498	260	4107731	1991-10-19	1991-10-19 00:00:00	38000275	0	\N	\N	17173	0	180256009	4107731	
2655	266	4107731	1991-09-02	1991-09-02 00:00:00	38000275	0	\N	\N	17710	0	180256009	4107731	
2842	273	4107731	1990-08-05	1990-08-05 00:00:00	38000275	0	\N	\N	18268	0	180256009	4107731	
3109	298	4125906	2000-12-16	2000-12-16 00:00:00	38000275	0	\N	\N	19884	0	288086009	4125906	
3280	327	4170947	1974-10-13	1974-10-13 00:00:00	38000275	0	\N	\N	21617	0	274474001	4170947	
3470	338	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	22494	0	180256009	4107731	
3595	347	4035793	2014-11-30	2014-11-30 00:00:00	38000275	0	\N	\N	23089	0	15081005	4035793	
3830	372	4163872	1980-02-05	1980-02-05 00:00:00	38000275	0	\N	\N	24756	0	399208008	4163872	
3965	399	4107731	1991-08-18	1991-08-18 00:00:00	38000275	0	\N	\N	26138	0	180256009	4107731	
4152	406	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	26849	0	180256009	4107731	
4341	419	4151422	1987-03-08	1987-03-08 00:00:00	38000275	0	\N	\N	27759	0	269911007	4151422	
4526	432	4078793	2017-07-10	2017-07-10 00:00:00	38000275	0	\N	\N	28711	0	180325003	4078793	
4792	449	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	29908	0	180256009	4107731	
4900	454	4078793	2018-03-17	2018-03-17 00:00:00	38000275	0	\N	\N	30375	0	180325003	4078793	
5087	470	4151422	2009-04-29	2009-04-29 00:00:00	38000275	0	\N	\N	31413	0	269911007	4151422	
5274	489	4107731	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	32735	0	180256009	4107731	
5462	502	40492359	2016-03-05	2016-03-05 00:00:00	38000275	0	\N	\N	33579	0	447365002	40492359	
5748	533	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	35399	0	180256009	4107731	
5835	534	4043071	1992-04-17	1992-04-17 00:00:00	38000275	0	\N	\N	35543	0	228557008	4043071	
6095	558	4047491	1977-11-04	1977-11-04 00:00:00	38000275	0	\N	\N	37007	0	1225002	4047491	
6221	571	4163872	1968-02-09	1968-02-09 00:00:00	38000275	0	\N	\N	37833	0	399208008	4163872	
6412	601	4107731	1990-02-18	1990-02-18 00:00:00	38000275	0	\N	\N	39760	0	180256009	4107731	
6583	603	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	39893	0	180256009	4107731	
6770	615	4107731	1990-04-21	1990-04-21 00:00:00	38000275	0	\N	\N	41062	0	180256009	4107731	
6971	642	4202451	2017-10-08	2017-10-08 00:00:00	38000275	0	\N	\N	42521	0	433112001	4202451	
7157	664	4107731	2012-08-21	2012-08-21 00:00:00	38000275	0	\N	\N	43893	0	180256009	4107731	
7331	680	4107731	1992-10-05	1992-10-05 00:00:00	38000275	0	\N	\N	45035	0	180256009	4107731	
7527	703	4078793	2019-02-01	2019-02-01 00:00:00	38000275	0	\N	\N	46496	0	180325003	4078793	
7757	711	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	47089	0	180256009	4107731	
7896	722	4125906	2011-11-28	2011-11-28 00:00:00	38000275	0	\N	\N	47802	0	288086009	4125906	
8083	739	4058899	1978-05-06	1978-05-06 00:00:00	38000275	0	\N	\N	48931	0	168594001	4058899	
8266	756	4125906	1992-10-25	1992-10-25 00:00:00	38000275	0	\N	\N	50103	0	288086009	4125906	
8517	778	4151422	2008-01-22	2008-01-22 00:00:00	38000275	0	\N	\N	51647	0	269911007	4151422	
20644	1776	4195803	2006-10-28	2006-10-28 00:00:00	38000275	0	\N	\N	118881	0	312681000	4195803	
20768	1783	4107731	1991-01-14	1991-01-14 00:00:00	38000275	0	\N	\N	119484	0	180256009	4107731	
9023	829	4275113	1988-06-12	1988-06-12 00:00:00	38000275	0	\N	\N	54932	0	65200003	4275113	
9201	843	4107731	1997-01-25	1997-01-25 00:00:00	38000275	0	\N	\N	55778	0	180256009	4107731	
9388	859	4107731	1992-12-28	1992-12-28 00:00:00	38000275	0	\N	\N	56811	0	180256009	4107731	
9580	869	4125906	1915-12-02	1915-12-02 00:00:00	38000275	0	\N	\N	57768	0	288086009	4125906	
9770	877	4170947	1984-12-06	1984-12-06 00:00:00	38000275	0	\N	\N	58439	0	274474001	4170947	
10024	895	4043071	1969-08-22	1969-08-22 00:00:00	38000275	0	\N	\N	59656	0	228557008	4043071	
10253	917	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	61018	0	180256009	4107731	
10323	917	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	61017	0	180256009	4107731	
10521	951	4058899	1995-09-25	1995-09-25 00:00:00	38000275	0	\N	\N	63220	0	168594001	4058899	
10829	974	4125906	1976-06-14	1976-06-14 00:00:00	38000275	0	\N	\N	64965	0	288086009	4125906	
10972	1015	4151422	2010-06-30	2010-06-30 00:00:00	38000275	0	\N	\N	66838	0	269911007	4151422	
11188	1036	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	68184	0	180256009	4107731	
11308	1053	4181917	1982-01-28	1982-01-28 00:00:00	38000275	0	\N	\N	69038	0	54550000	4181917	
23417	2053	4058899	2010-03-24	2010-03-24 00:00:00	38000275	0	\N	\N	136571	0	168594001	4058899	
11637	1077	4170947	1963-10-16	1963-10-16 00:00:00	38000275	0	\N	\N	70602	0	274474001	4170947	
11889	1091	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	71736	0	180256009	4107731	
38	3	4078793	2005-08-15	2005-08-15 00:00:00	38000275	0	\N	\N	276	0	180325003	4078793	
232	16	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	1184	0	180256009	4107731	
505	36	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	2492	0	180256009	4107731	
699	57	4125906	2007-01-15	2007-01-15 00:00:00	38000275	0	\N	\N	3890	0	288086009	4125906	
827	80	4151422	2008-06-03	2008-06-03 00:00:00	38000275	0	\N	\N	5413	0	269911007	4151422	
1015	97	4170947	1959-09-23	1959-09-23 00:00:00	38000275	0	\N	\N	6642	0	274474001	4170947	
1170	124	4107731	1998-07-28	1998-07-28 00:00:00	38000275	0	\N	\N	8307	0	180256009	4107731	
1436	137	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	9139	0	180256009	4107731	
1640	153	4043071	1959-07-23	1959-07-23 00:00:00	38000275	0	\N	\N	10380	0	228557008	4043071	
1721	155	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	10513	0	180256009	4107731	
1920	180	4107731	1993-06-24	1993-06-24 00:00:00	38000275	0	\N	\N	12144	0	180256009	4107731	
2126	213	4125906	2015-11-04	2015-11-04 00:00:00	38000275	0	\N	\N	14497	0	288086009	4125906	
2338	236	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	15854	0	180256009	4107731	
2499	260	4107731	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	17283	0	180256009	4107731	
2656	266	4107731	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	17759	0	180256009	4107731	
2843	273	4107731	1990-06-03	1990-06-03 00:00:00	38000275	0	\N	\N	18216	0	180256009	4107731	
3110	299	4057420	2019-01-19	2019-01-19 00:00:00	38000275	0	\N	\N	19983	0	18286008	4057420	
3281	327	4293740	2010-09-30	2010-09-30 00:00:00	38000275	0	\N	\N	21621	0	384700001	4293740	
3471	338	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	22487	0	180256009	4107731	
3596	347	4058899	1982-10-11	1982-10-11 00:00:00	38000275	0	\N	\N	23113	0	168594001	4058899	
3831	372	4191853	1985-05-29	1985-05-29 00:00:00	38000275	0	\N	\N	24765	0	395142003	4191853	
3966	399	4107731	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	26152	0	180256009	4107731	
4153	406	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	26781	0	180256009	4107731	
4342	419	4195803	1964-09-15	1964-09-15 00:00:00	38000275	0	\N	\N	27710	0	312681000	4195803	
4527	432	4043071	1938-08-30	1938-08-30 00:00:00	38000275	0	\N	\N	28728	0	228557008	4043071	
4793	449	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	29880	0	180256009	4107731	
4901	454	4195803	2006-02-13	2006-02-13 00:00:00	38000275	0	\N	\N	30276	0	312681000	4195803	
5088	470	4163872	2013-01-27	2013-01-27 00:00:00	38000275	0	\N	\N	31409	0	399208008	4163872	
5275	489	4107731	1990-11-18	1990-11-18 00:00:00	38000275	0	\N	\N	32821	0	180256009	4107731	
5463	502	4078793	2017-10-28	2017-10-28 00:00:00	38000275	0	\N	\N	33623	0	180325003	4078793	
5749	533	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	35424	0	180256009	4107731	
5836	534	4043071	1989-09-01	1989-09-01 00:00:00	38000275	0	\N	\N	35609	0	228557008	4043071	
6096	558	4043071	1969-01-03	1969-01-03 00:00:00	38000275	0	\N	\N	36965	0	228557008	4043071	
6222	572	4047491	1976-11-21	1976-11-21 00:00:00	38000275	0	\N	\N	37860	0	1225002	4047491	
6413	601	4107731	1992-01-12	1992-01-12 00:00:00	38000275	0	\N	\N	39779	0	180256009	4107731	
6584	603	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	39927	0	180256009	4107731	
6771	615	4107731	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	40955	0	180256009	4107731	
6972	642	4078793	2017-07-09	2017-07-09 00:00:00	38000275	0	\N	\N	42521	0	180325003	4078793	
7158	664	4107731	2012-05-29	2012-05-29 00:00:00	38000275	0	\N	\N	43907	0	180256009	4107731	
7332	680	4107731	1990-01-22	1990-01-22 00:00:00	38000275	0	\N	\N	44960	0	180256009	4107731	
7528	703	4078793	2006-01-27	2006-01-27 00:00:00	38000275	0	\N	\N	46430	0	180325003	4078793	
7758	711	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	47083	0	180256009	4107731	
7897	722	4058899	1989-07-26	1989-07-26 00:00:00	38000275	0	\N	\N	47801	0	168594001	4058899	
8084	739	4195803	1978-05-06	1978-05-06 00:00:00	38000275	0	\N	\N	48931	0	312681000	4195803	
8267	756	44783196	1995-09-01	1995-09-01 00:00:00	38000275	0	\N	\N	50106	0	699253003	44783196	
8518	778	4295880	1998-04-02	1998-04-02 00:00:00	38000275	0	\N	\N	51657	0	76601001	4295880	
20645	1776	4078793	2006-10-28	2006-10-28 00:00:00	38000275	0	\N	\N	118881	0	180325003	4078793	
20769	1783	4107731	1992-09-14	1992-09-14 00:00:00	38000275	0	\N	\N	119452	0	180256009	4107731	
9024	829	4170947	2012-03-29	2012-03-29 00:00:00	38000275	0	\N	\N	54896	0	274474001	4170947	
9202	843	4107731	1998-05-02	1998-05-02 00:00:00	38000275	0	\N	\N	55782	0	180256009	4107731	
9389	859	4107731	1990-10-01	1990-10-01 00:00:00	38000275	0	\N	\N	56887	0	180256009	4107731	
9581	869	4078793	2014-11-21	2014-11-21 00:00:00	38000275	0	\N	\N	57720	0	180325003	4078793	
9771	877	4047491	1984-12-06	1984-12-06 00:00:00	38000275	0	\N	\N	58439	0	1225002	4047491	
10025	895	4043071	1967-03-03	1967-03-03 00:00:00	38000275	0	\N	\N	59650	0	228557008	4043071	
10254	917	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	61077	0	180256009	4107731	
10324	917	4043071	1975-06-01	1975-06-01 00:00:00	38000275	0	\N	\N	60936	0	228557008	4043071	
10569	954	4125906	1983-01-25	1983-01-25 00:00:00	38000275	0	\N	\N	63396	0	288086009	4125906	
10830	974	4181917	1956-06-24	1956-06-24 00:00:00	38000275	0	\N	\N	64962	0	54550000	4181917	
10973	1015	4198190	1984-10-19	1984-10-19 00:00:00	38000275	0	\N	\N	66860	0	80146002	4198190	
11189	1036	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	68156	0	180256009	4107731	
11309	1053	4170947	2001-11-12	2001-11-12 00:00:00	38000275	0	\N	\N	69042	0	274474001	4170947	
23418	2053	4202451	2007-09-20	2007-09-20 00:00:00	38000275	0	\N	\N	136496	0	433112001	4202451	
11638	1077	4151422	1958-11-18	1958-11-18 00:00:00	38000275	0	\N	\N	70585	0	269911007	4151422	
11890	1091	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	71617	0	180256009	4107731	
39	3	4078793	2009-09-07	2009-09-07 00:00:00	38000275	0	\N	\N	322	0	180325003	4078793	
233	16	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	1284	0	180256009	4107731	
506	36	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	2526	0	180256009	4107731	
700	57	4151422	1982-07-09	1982-07-09 00:00:00	38000275	0	\N	\N	3849	0	269911007	4151422	
828	81	4163872	1963-09-11	1963-09-11 00:00:00	38000275	0	\N	\N	5507	0	399208008	4163872	
1016	97	4024289	1959-09-23	1959-09-23 00:00:00	38000275	0	\N	\N	6642	0	19490002	4024289	
1171	124	4107731	1999-07-20	1999-07-20 00:00:00	38000275	0	\N	\N	8313	0	180256009	4107731	
1437	137	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	9208	0	180256009	4107731	
1641	153	4043071	1958-12-18	1958-12-18 00:00:00	38000275	0	\N	\N	10352	0	228557008	4043071	
1722	155	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	10565	0	180256009	4107731	
1921	180	4107731	1991-11-14	1991-11-14 00:00:00	38000275	0	\N	\N	12137	0	180256009	4107731	
2133	217	4163872	2010-09-16	2010-09-16 00:00:00	38000275	0	\N	\N	14685	0	399208008	4163872	
2339	236	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	15906	0	180256009	4107731	
2500	260	4107731	1991-09-28	1991-09-28 00:00:00	38000275	0	\N	\N	17281	0	180256009	4107731	
2657	268	4198190	1989-02-16	1989-02-16 00:00:00	38000275	0	\N	\N	17779	0	80146002	4198190	
2844	273	4170947	2002-11-21	2002-11-21 00:00:00	38000275	0	\N	\N	18289	0	274474001	4170947	
3111	299	4057420	2018-06-30	2018-06-30 00:00:00	38000275	0	\N	\N	19986	0	18286008	4057420	
3282	327	4125906	2010-09-30	2010-09-30 00:00:00	38000275	0	\N	\N	21621	0	288086009	4125906	
3472	338	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	22516	0	180256009	4107731	
3597	347	4035793	2012-11-25	2012-11-25 00:00:00	38000275	0	\N	\N	23098	0	15081005	4035793	
3832	372	4151422	1996-03-30	1996-03-30 00:00:00	38000275	0	\N	\N	24716	0	269911007	4151422	
3967	399	4107731	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	26175	0	180256009	4107731	
4154	406	4125906	1987-06-15	1987-06-15 00:00:00	38000275	0	\N	\N	26814	0	288086009	4125906	
4343	419	4058899	1964-09-15	1964-09-15 00:00:00	38000275	0	\N	\N	27710	0	168594001	4058899	
4528	432	4043071	1940-04-30	1940-04-30 00:00:00	38000275	0	\N	\N	28720	0	228557008	4043071	
4794	449	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	29861	0	180256009	4107731	
4902	454	4243062	2006-02-13	2006-02-13 00:00:00	38000275	0	\N	\N	30276	0	60027007	4243062	
5089	470	4293740	1961-08-07	1961-08-07 00:00:00	38000275	0	\N	\N	31390	0	384700001	4293740	
5276	489	4107731	1993-02-14	1993-02-14 00:00:00	38000275	0	\N	\N	32800	0	180256009	4107731	
5464	502	4195803	2000-10-13	2000-10-13 00:00:00	38000275	0	\N	\N	33650	0	312681000	4195803	
5750	533	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	35458	0	180256009	4107731	
5837	534	4043071	1990-11-29	1990-11-29 00:00:00	38000275	0	\N	\N	35520	0	228557008	4043071	
6097	558	4043071	1969-04-04	1969-04-04 00:00:00	38000275	0	\N	\N	37011	0	228557008	4043071	
6223	572	4170947	1976-11-21	1976-11-21 00:00:00	38000275	0	\N	\N	37860	0	274474001	4170947	
6414	601	4107731	1991-11-10	1991-11-10 00:00:00	38000275	0	\N	\N	39666	0	180256009	4107731	
6585	603	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	40017	0	180256009	4107731	
6772	615	4107731	1991-07-06	1991-07-06 00:00:00	38000275	0	\N	\N	41007	0	180256009	4107731	
6973	642	4057420	2012-10-07	2012-10-07 00:00:00	38000275	0	\N	\N	42512	0	18286008	4057420	
7159	664	4107731	2012-12-04	2012-12-04 00:00:00	38000275	0	\N	\N	43888	0	180256009	4107731	
7333	680	4107731	1992-09-14	1992-09-14 00:00:00	38000275	0	\N	\N	45037	0	180256009	4107731	
7529	703	4078793	2017-01-20	2017-01-20 00:00:00	38000275	0	\N	\N	46471	0	180325003	4078793	
7759	711	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	47115	0	180256009	4107731	
7898	723	4125906	1984-10-19	1984-10-19 00:00:00	38000275	0	\N	\N	47805	0	288086009	4125906	
8085	739	4243062	1975-08-20	1975-08-20 00:00:00	38000275	0	\N	\N	48930	0	60027007	4243062	
8268	757	4078793	1988-05-01	1988-05-01 00:00:00	38000275	0	\N	\N	50246	0	180325003	4078793	
8519	778	4295880	1997-07-03	1997-07-03 00:00:00	38000275	0	\N	\N	51656	0	76601001	4295880	
20646	1776	4047491	1922-09-09	1922-09-09 00:00:00	38000275	0	\N	\N	118800	0	1225002	4047491	
20770	1785	4170947	1961-05-26	1961-05-26 00:00:00	38000275	0	\N	\N	119607	0	274474001	4170947	
9025	829	4024289	2012-03-29	2012-03-29 00:00:00	38000275	0	\N	\N	54896	0	19490002	4024289	
9203	843	4107731	1995-09-30	1995-09-30 00:00:00	38000275	0	\N	\N	55868	0	180256009	4107731	
9390	859	4107731	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	56809	0	180256009	4107731	
9582	870	4145310	1993-04-02	1993-04-02 00:00:00	38000275	0	\N	\N	57849	0	268425006	4145310	
9772	877	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	58354	0	180256009	4107731	
10026	895	4043071	1967-11-24	1967-11-24 00:00:00	38000275	0	\N	\N	59729	0	228557008	4043071	
10255	917	4043071	1974-12-01	1974-12-01 00:00:00	38000275	0	\N	\N	60918	0	228557008	4043071	
10325	917	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	60982	0	180256009	4107731	
10570	954	4125906	2007-04-08	2007-04-08 00:00:00	38000275	0	\N	\N	63419	0	288086009	4125906	
10831	974	4163872	2014-04-08	2014-04-08 00:00:00	38000275	0	\N	\N	64968	0	399208008	4163872	
10974	1015	4151422	1976-07-29	1976-07-29 00:00:00	38000275	0	\N	\N	66823	0	269911007	4151422	
11190	1036	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	68110	0	180256009	4107731	
11310	1053	4024289	2001-11-12	2001-11-12 00:00:00	38000275	0	\N	\N	69042	0	19490002	4024289	
23419	2054	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	136587	0	180256009	4107731	
11639	1077	4151422	1950-08-27	1950-08-27 00:00:00	38000275	0	\N	\N	70641	0	269911007	4151422	
11891	1091	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	71639	0	180256009	4107731	
40	3	4198190	1972-12-20	1972-12-20 00:00:00	38000275	0	\N	\N	312	0	80146002	4198190	
234	16	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	1171	0	180256009	4107731	
507	36	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	2548	0	180256009	4107731	
701	57	4293740	1971-02-27	1971-02-27 00:00:00	38000275	0	\N	\N	3819	0	384700001	4293740	
829	81	4170947	1963-09-11	1963-09-11 00:00:00	38000275	0	\N	\N	5507	0	274474001	4170947	
1017	97	4035793	2015-08-10	2015-08-10 00:00:00	38000275	0	\N	\N	6613	0	15081005	4035793	
1172	124	4107731	1999-04-27	1999-04-27 00:00:00	38000275	0	\N	\N	8254	0	180256009	4107731	
1438	137	4197460	1972-10-22	1972-10-22 00:00:00	38000275	0	\N	\N	9118	0	313191000	4197460	
1642	153	4043071	1958-01-09	1958-01-09 00:00:00	38000275	0	\N	\N	10407	0	228557008	4043071	
1723	155	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	10510	0	180256009	4107731	
1922	180	4107731	1992-02-27	1992-02-27 00:00:00	38000275	0	\N	\N	12195	0	180256009	4107731	
2134	219	4181917	1975-05-24	1975-05-24 00:00:00	38000275	0	\N	\N	14751	0	54550000	4181917	
2340	236	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	15891	0	180256009	4107731	
2501	260	4107731	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	17163	0	180256009	4107731	
2658	268	4163872	1990-03-23	1990-03-23 00:00:00	38000275	0	\N	\N	17795	0	399208008	4163872	
2845	273	4024289	2002-11-21	2002-11-21 00:00:00	38000275	0	\N	\N	18289	0	19490002	4024289	
3112	299	4151422	2017-06-06	2017-06-06 00:00:00	38000275	0	\N	\N	19994	0	269911007	4151422	
3283	327	4151422	2000-07-17	2000-07-17 00:00:00	38000275	0	\N	\N	21574	0	269911007	4151422	
3473	338	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	22511	0	180256009	4107731	
3598	347	4323902	2009-02-01	2009-02-01 00:00:00	38000275	0	\N	\N	23063	0	429609002	4323902	
3833	372	4125906	1968-02-06	1968-02-06 00:00:00	38000275	0	\N	\N	24786	0	288086009	4125906	
3968	399	4107731	1992-08-09	1992-08-09 00:00:00	38000275	0	\N	\N	26214	0	180256009	4107731	
4155	406	4151422	2011-05-23	2011-05-23 00:00:00	38000275	0	\N	\N	26856	0	269911007	4151422	
4344	419	4125906	1923-11-15	1923-11-15 00:00:00	38000275	0	\N	\N	27708	0	288086009	4125906	
4529	432	4043071	1939-02-21	1939-02-21 00:00:00	38000275	0	\N	\N	28742	0	228557008	4043071	
4795	449	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	29974	0	180256009	4107731	
4903	454	4170947	2006-02-13	2006-02-13 00:00:00	38000275	0	\N	\N	30276	0	274474001	4170947	
5090	470	4125906	1961-08-07	1961-08-07 00:00:00	38000275	0	\N	\N	31390	0	288086009	4125906	
5277	489	4107731	1991-05-26	1991-05-26 00:00:00	38000275	0	\N	\N	32822	0	180256009	4107731	
5465	502	4170947	2000-10-13	2000-10-13 00:00:00	38000275	0	\N	\N	33650	0	274474001	4170947	
5751	533	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	35413	0	180256009	4107731	
5838	534	4043071	1990-04-13	1990-04-13 00:00:00	38000275	0	\N	\N	35516	0	228557008	4043071	
6098	558	4043071	1969-08-15	1969-08-15 00:00:00	38000275	0	\N	\N	36991	0	228557008	4043071	
6224	573	4125906	1988-08-13	1988-08-13 00:00:00	38000275	0	\N	\N	37986	0	288086009	4125906	
6415	601	4107731	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	39708	0	180256009	4107731	
6586	603	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	40015	0	180256009	4107731	
6773	615	4107731	1991-09-07	1991-09-07 00:00:00	38000275	0	\N	\N	41067	0	180256009	4107731	
6974	642	4057420	2017-07-02	2017-07-02 00:00:00	38000275	0	\N	\N	\N	0	18286008	4057420	
7160	664	4107731	2011-11-22	2011-11-22 00:00:00	38000275	0	\N	\N	43923	0	180256009	4107731	
7334	680	4107731	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	44966	0	180256009	4107731	
7530	703	4170947	1952-02-11	1952-02-11 00:00:00	38000275	0	\N	\N	46507	0	274474001	4170947	
7760	711	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	47102	0	180256009	4107731	
7899	723	4195803	2013-12-21	2013-12-21 00:00:00	38000275	0	\N	\N	47822	0	312681000	4195803	
8086	739	4170947	1975-08-20	1975-08-20 00:00:00	38000275	0	\N	\N	48930	0	274474001	4170947	
8269	757	4078793	1995-06-11	1995-06-11 00:00:00	38000275	0	\N	\N	50269	0	180325003	4078793	
8520	778	4295880	1995-07-06	1995-07-06 00:00:00	38000275	0	\N	\N	51703	0	76601001	4295880	
20647	1776	4170947	1922-09-09	1922-09-09 00:00:00	38000275	0	\N	\N	118800	0	274474001	4170947	
20771	1785	4243062	1961-05-26	1961-05-26 00:00:00	38000275	0	\N	\N	119607	0	60027007	4243062	
9026	829	4238715	1992-08-16	1992-08-16 00:00:00	38000275	0	\N	\N	54882	0	68254000	4238715	
9204	843	4107731	1997-07-12	1997-07-12 00:00:00	38000275	0	\N	\N	55829	0	180256009	4107731	
9391	859	4107731	1991-11-25	1991-11-25 00:00:00	38000275	0	\N	\N	56838	0	180256009	4107731	
9583	870	4195803	1993-04-02	1993-04-02 00:00:00	38000275	0	\N	\N	57849	0	312681000	4195803	
9773	877	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	58457	0	180256009	4107731	
10027	895	4043071	1968-12-27	1968-12-27 00:00:00	38000275	0	\N	\N	59732	0	228557008	4043071	
10256	917	4043071	1975-06-29	1975-06-29 00:00:00	38000275	0	\N	\N	60977	0	228557008	4043071	
10326	917	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	60920	0	180256009	4107731	
10573	956	4145310	1950-04-08	1950-04-08 00:00:00	38000275	0	\N	\N	63551	0	268425006	4145310	
10832	974	4170947	2014-04-08	2014-04-08 00:00:00	38000275	0	\N	\N	64968	0	274474001	4170947	
10975	1015	4125906	1957-11-04	1957-11-04 00:00:00	38000275	0	\N	\N	66812	0	288086009	4125906	
11191	1036	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	68108	0	180256009	4107731	
11311	1054	4125906	2012-03-01	2012-03-01 00:00:00	38000275	0	\N	\N	69137	0	288086009	4125906	
23420	2054	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	136599	0	180256009	4107731	
11640	1079	4125906	1988-01-25	1988-01-25 00:00:00	38000275	0	\N	\N	70770	0	288086009	4125906	
11892	1091	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	71613	0	180256009	4107731	
41	3	4057420	2014-10-06	2014-10-06 00:00:00	38000275	0	\N	\N	278	0	18286008	4057420	
235	16	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	1273	0	180256009	4107731	
508	36	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	2534	0	180256009	4107731	
702	57	4125906	1971-02-27	1971-02-27 00:00:00	38000275	0	\N	\N	3819	0	288086009	4125906	
830	81	4198190	1984-03-15	1984-03-15 00:00:00	38000275	0	\N	\N	5509	0	80146002	4198190	
1018	99	4035793	2018-04-21	2018-04-21 00:00:00	38000275	0	\N	\N	6770	0	15081005	4035793	
1173	124	4107731	1999-06-08	1999-06-08 00:00:00	38000275	0	\N	\N	8312	0	180256009	4107731	
1439	137	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	9206	0	180256009	4107731	
1643	153	4043071	1958-02-06	1958-02-06 00:00:00	38000275	0	\N	\N	10348	0	228557008	4043071	
1724	155	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	10605	0	180256009	4107731	
1923	180	4191853	1990-04-26	1990-04-26 00:00:00	38000275	0	\N	\N	12108	0	395142003	4191853	
2135	219	4170947	1985-06-18	1985-06-18 00:00:00	38000275	0	\N	\N	14756	0	274474001	4170947	
2341	236	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	15858	0	180256009	4107731	
2502	260	4107731	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	17257	0	180256009	4107731	
2723	270	4151422	1990-06-27	1990-06-27 00:00:00	38000275	0	\N	\N	17959	0	269911007	4151422	
2846	273	4107731	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	18257	0	180256009	4107731	
3115	304	4170947	1957-04-02	1957-04-02 00:00:00	38000275	0	\N	\N	20210	0	274474001	4170947	
3284	328	4187458	2004-10-22	2004-10-22 00:00:00	38000275	0	\N	\N	21677	0	415300000	4187458	
3474	338	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	22577	0	180256009	4107731	
3599	348	4125906	2015-11-21	2015-11-21 00:00:00	38000275	0	\N	\N	23119	0	288086009	4125906	
3834	372	4293740	1968-02-06	1968-02-06 00:00:00	38000275	0	\N	\N	24786	0	384700001	4293740	
3969	399	4107731	1991-06-16	1991-06-16 00:00:00	38000275	0	\N	\N	26181	0	180256009	4107731	
4156	406	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	26854	0	180256009	4107731	
4345	421	4170947	1977-09-02	1977-09-02 00:00:00	38000275	0	\N	\N	27878	0	274474001	4170947	
4530	432	4043071	1938-09-27	1938-09-27 00:00:00	38000275	0	\N	\N	28645	0	228557008	4043071	
4796	449	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	29905	0	180256009	4107731	
4904	454	4078793	2009-03-28	2009-03-28 00:00:00	38000275	0	\N	\N	30363	0	180325003	4078793	
5091	471	40492359	1990-04-06	1990-04-06 00:00:00	38000275	0	\N	\N	31462	0	447365002	40492359	
5278	489	4107731	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	32707	0	180256009	4107731	
5466	502	4163872	2000-10-13	2000-10-13 00:00:00	38000275	0	\N	\N	33650	0	399208008	4163872	
5752	533	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	35430	0	180256009	4107731	
5839	534	4043071	1989-10-06	1989-10-06 00:00:00	38000275	0	\N	\N	35610	0	228557008	4043071	
6099	558	4151422	1974-09-22	1974-09-22 00:00:00	38000275	0	\N	\N	36995	0	269911007	4151422	
6225	573	4293740	1988-08-13	1988-08-13 00:00:00	38000275	0	\N	\N	37986	0	384700001	4293740	
6416	601	4107731	1992-11-22	1992-11-22 00:00:00	38000275	0	\N	\N	39738	0	180256009	4107731	
6587	603	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	39939	0	180256009	4107731	
6774	615	4125906	1996-04-23	1996-04-23 00:00:00	38000275	0	\N	\N	41045	0	288086009	4125906	
6975	642	4151422	1950-06-06	1950-06-06 00:00:00	38000275	0	\N	\N	42518	0	269911007	4151422	
7161	664	4186930	2001-07-05	2001-07-05 00:00:00	38000275	0	\N	\N	43836	0	46706006	4186930	
7335	680	4107731	1992-01-06	1992-01-06 00:00:00	38000275	0	\N	\N	45032	0	180256009	4107731	
7531	703	4243062	1952-02-11	1952-02-11 00:00:00	38000275	0	\N	\N	46507	0	60027007	4243062	
7761	711	4145310	1990-01-01	1990-01-01 00:00:00	38000275	0	\N	\N	47199	0	268425006	4145310	
7900	723	4145310	2013-12-21	2013-12-21 00:00:00	38000275	0	\N	\N	47822	0	268425006	4145310	
8087	739	4195803	1975-08-20	1975-08-20 00:00:00	38000275	0	\N	\N	48930	0	312681000	4195803	
8270	757	4078793	1990-06-03	1990-06-03 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
8521	778	4295880	1996-04-04	1996-04-04 00:00:00	38000275	0	\N	\N	51704	0	76601001	4295880	
20648	1776	4163951	1984-10-13	1984-10-13 00:00:00	38000275	0	\N	\N	118804	0	29303009	4163951	
20772	1785	4293740	2001-10-28	2001-10-28 00:00:00	38000275	0	\N	\N	119609	0	384700001	4293740	
9027	830	4125906	1981-09-22	1981-09-22 00:00:00	38000275	0	\N	\N	55008	0	288086009	4125906	
9205	843	4107731	1996-02-24	1996-02-24 00:00:00	38000275	0	\N	\N	55824	0	180256009	4107731	
9392	859	4107731	1992-07-13	1992-07-13 00:00:00	38000275	0	\N	\N	56840	0	180256009	4107731	
9584	870	4163872	1975-10-08	1975-10-08 00:00:00	38000275	0	\N	\N	57908	0	399208008	4163872	
9774	877	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	58396	0	180256009	4107731	
10028	895	4043071	1967-07-28	1967-07-28 00:00:00	38000275	0	\N	\N	59728	0	228557008	4043071	
10257	917	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	60973	0	180256009	4107731	
10327	917	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	60922	0	180256009	4107731	
10574	956	4125906	1969-10-12	1969-10-12 00:00:00	38000275	0	\N	\N	63457	0	288086009	4125906	
10833	974	4195803	2014-04-08	2014-04-08 00:00:00	38000275	0	\N	\N	64968	0	312681000	4195803	
10976	1015	4293740	1957-11-04	1957-11-04 00:00:00	38000275	0	\N	\N	66812	0	384700001	4293740	
11192	1036	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	68153	0	180256009	4107731	
11312	1054	4163872	1957-05-05	1957-05-05 00:00:00	38000275	0	\N	\N	69121	0	399208008	4163872	
23421	2054	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	136600	0	180256009	4107731	
11641	1079	4125906	2002-04-02	2002-04-02 00:00:00	38000275	0	\N	\N	70771	0	288086009	4125906	
11893	1091	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	71740	0	180256009	4107731	
42	3	4170947	2010-08-27	2010-08-27 00:00:00	38000275	0	\N	\N	314	0	274474001	4170947	
236	16	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	1194	0	180256009	4107731	
509	36	44783196	2001-03-30	2001-03-30 00:00:00	38000275	0	\N	\N	2615	0	699253003	44783196	
703	57	4125906	1976-08-13	1976-08-13 00:00:00	38000275	0	\N	\N	3820	0	288086009	4125906	
831	82	4181917	1973-08-19	1973-08-19 00:00:00	38000275	0	\N	\N	5571	0	54550000	4181917	
1019	99	4252419	1968-10-21	1968-10-21 00:00:00	38000275	0	\N	\N	6728	0	74016001	4252419	
1174	124	4107731	1998-04-14	1998-04-14 00:00:00	38000275	0	\N	\N	8190	0	180256009	4107731	
1440	137	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	9247	0	180256009	4107731	
1644	153	4043071	1957-12-05	1957-12-05 00:00:00	38000275	0	\N	\N	10376	0	228557008	4043071	
1725	155	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	10567	0	180256009	4107731	
1924	180	4107731	1993-08-26	1993-08-26 00:00:00	38000275	0	\N	\N	12158	0	180256009	4107731	
2136	219	4047491	1985-06-18	1985-06-18 00:00:00	38000275	0	\N	\N	14756	0	1225002	4047491	
2342	236	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	15824	0	180256009	4107731	
2503	260	4107731	1990-12-29	1990-12-29 00:00:00	38000275	0	\N	\N	17278	0	180256009	4107731	
2724	270	4125906	1965-07-27	1965-07-27 00:00:00	38000275	0	\N	\N	18022	0	288086009	4125906	
2847	273	4107731	1991-05-26	1991-05-26 00:00:00	38000275	0	\N	\N	18201	0	180256009	4107731	
3116	304	4163872	1957-04-02	1957-04-02 00:00:00	38000275	0	\N	\N	20210	0	399208008	4163872	
3285	328	4326177	2004-10-22	2004-10-22 00:00:00	38000275	0	\N	\N	21677	0	430193006	4326177	
3475	338	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	22582	0	180256009	4107731	
3600	348	4151422	1994-12-16	1994-12-16 00:00:00	38000275	0	\N	\N	23142	0	269911007	4151422	
3835	372	4151422	2004-04-14	2004-04-14 00:00:00	38000275	0	\N	\N	24717	0	269911007	4151422	
3970	399	4107731	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	26199	0	180256009	4107731	
4157	406	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	26812	0	180256009	4107731	
4346	421	4024289	1977-09-02	1977-09-02 00:00:00	38000275	0	\N	\N	27878	0	19490002	4024289	
4531	432	4043071	1939-01-24	1939-01-24 00:00:00	38000275	0	\N	\N	28646	0	228557008	4043071	
4797	449	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	29936	0	180256009	4107731	
4905	454	4078793	2017-09-16	2017-09-16 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
5092	471	4057420	1990-04-06	1990-04-06 00:00:00	38000275	0	\N	\N	31462	0	18286008	4057420	
5279	489	4107731	1992-06-28	1992-06-28 00:00:00	38000275	0	\N	\N	32798	0	180256009	4107731	
5467	502	4078793	2016-04-30	2016-04-30 00:00:00	38000275	0	\N	\N	33661	0	180325003	4078793	
5753	533	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	35404	0	180256009	4107731	
5840	534	4043071	1988-12-22	1988-12-22 00:00:00	38000275	0	\N	\N	35557	0	228557008	4043071	
6100	558	4043071	1969-03-07	1969-03-07 00:00:00	38000275	0	\N	\N	36979	0	228557008	4043071	
6226	573	4330583	2007-11-02	2007-11-02 00:00:00	38000275	0	\N	\N	37987	0	22523008	4330583	
6417	601	4107731	1991-09-08	1991-09-08 00:00:00	38000275	0	\N	\N	39704	0	180256009	4107731	
6588	603	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	39961	0	180256009	4107731	
6775	615	4107731	1991-07-27	1991-07-27 00:00:00	38000275	0	\N	\N	40973	0	180256009	4107731	
6976	642	4078793	2012-10-28	2012-10-28 00:00:00	38000275	0	\N	\N	42484	0	180325003	4078793	
7162	664	4107731	2012-11-13	2012-11-13 00:00:00	38000275	0	\N	\N	43895	0	180256009	4107731	
7336	680	4191853	1990-01-01	1990-01-01 00:00:00	38000275	0	\N	\N	44996	0	395142003	4191853	
7532	703	4151422	2013-12-25	2013-12-25 00:00:00	38000275	0	\N	\N	46447	0	269911007	4151422	
7762	711	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	47082	0	180256009	4107731	
7901	723	4151422	1969-07-28	1969-07-28 00:00:00	38000275	0	\N	\N	47823	0	269911007	4151422	
8088	739	4195803	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	48934	0	312681000	4195803	
8271	757	4078793	1986-03-09	1986-03-09 00:00:00	38000275	0	\N	\N	50244	0	180325003	4078793	
8522	778	4295880	1995-10-05	1995-10-05 00:00:00	38000275	0	\N	\N	51649	0	76601001	4295880	
20649	1776	42535580	1984-10-13	1984-10-13 00:00:00	38000275	0	\N	\N	118804	0	426701000119108	42535580	
20773	1785	4125906	2001-10-28	2001-10-28 00:00:00	38000275	0	\N	\N	119609	0	288086009	4125906	
9028	830	4198190	1973-11-24	1973-11-24 00:00:00	38000275	0	\N	\N	55003	0	80146002	4198190	
9206	843	4107731	1998-02-07	1998-02-07 00:00:00	38000275	0	\N	\N	55767	0	180256009	4107731	
9461	862	4010253	1990-11-18	1990-11-18 00:00:00	38000275	0	\N	\N	57103	0	112790001	4010253	
9585	870	4243062	1971-10-06	1971-10-06 00:00:00	38000275	0	\N	\N	57891	0	60027007	4243062	
9775	877	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	58355	0	180256009	4107731	
10029	895	4043071	1969-10-24	1969-10-24 00:00:00	38000275	0	\N	\N	59671	0	228557008	4043071	
10258	917	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	60961	0	180256009	4107731	
10328	917	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	60967	0	180256009	4107731	
10575	956	4058899	1948-01-19	1948-01-19 00:00:00	38000275	0	\N	\N	63550	0	168594001	4058899	
10834	974	4163872	1960-03-05	1960-03-05 00:00:00	38000275	0	\N	\N	64963	0	399208008	4163872	
10977	1015	4125906	2003-07-25	2003-07-25 00:00:00	38000275	0	\N	\N	66816	0	288086009	4125906	
11193	1036	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	68141	0	180256009	4107731	
11313	1054	4170947	2000-02-03	2000-02-03 00:00:00	38000275	0	\N	\N	69136	0	274474001	4170947	
23422	2054	4170947	2014-07-22	2014-07-22 00:00:00	38000275	0	\N	\N	136590	0	274474001	4170947	
11642	1079	4151422	1988-07-26	1988-07-26 00:00:00	38000275	0	\N	\N	70736	0	269911007	4151422	
11894	1091	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	71624	0	180256009	4107731	
43	3	4047491	2010-08-27	2010-08-27 00:00:00	38000275	0	\N	\N	314	0	1225002	4047491	
237	16	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	1281	0	180256009	4107731	
510	36	4107731	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	2528	0	180256009	4107731	
704	57	4125906	1982-12-31	1982-12-31 00:00:00	38000275	0	\N	\N	3821	0	288086009	4125906	
832	82	4181917	1973-03-18	1973-03-18 00:00:00	38000275	0	\N	\N	5570	0	54550000	4181917	
1020	99	4198190	1996-10-17	1996-10-17 00:00:00	38000275	0	\N	\N	6779	0	80146002	4198190	
1175	124	4107731	1999-03-15	1999-03-15 00:00:00	38000275	0	\N	\N	8253	0	180256009	4107731	
1441	137	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	9248	0	180256009	4107731	
1645	153	4043071	1957-10-03	1957-10-03 00:00:00	38000275	0	\N	\N	10368	0	228557008	4043071	
1726	155	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	10517	0	180256009	4107731	
1925	180	4107731	1992-07-23	1992-07-23 00:00:00	38000275	0	\N	\N	12086	0	180256009	4107731	
2137	219	4181917	1977-07-09	1977-07-09 00:00:00	38000275	0	\N	\N	14754	0	54550000	4181917	
2343	236	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	15847	0	180256009	4107731	
2504	260	4107731	1990-03-10	1990-03-10 00:00:00	38000275	0	\N	\N	17166	0	180256009	4107731	
2725	270	4125906	1982-04-13	1982-04-13 00:00:00	38000275	0	\N	\N	18023	0	288086009	4125906	
2848	273	4107731	1990-10-28	1990-10-28 00:00:00	38000275	0	\N	\N	18270	0	180256009	4107731	
3117	304	4252419	2017-12-07	2017-12-07 00:00:00	38000275	0	\N	\N	20257	0	74016001	4252419	
3286	328	4037675	2004-10-22	2004-10-22 00:00:00	38000275	0	\N	\N	21677	0	162676008	4037675	
3476	338	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	22474	0	395142003	4191853	
3601	348	4058899	1990-01-10	1990-01-10 00:00:00	38000275	0	\N	\N	23116	0	168594001	4058899	
3836	372	4170947	1962-05-08	1962-05-08 00:00:00	38000275	0	\N	\N	24785	0	274474001	4170947	
3971	399	4107731	1991-05-26	1991-05-26 00:00:00	38000275	0	\N	\N	26240	0	180256009	4107731	
4158	406	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	26778	0	180256009	4107731	
4347	422	4195803	2019-04-27	2019-04-27 00:00:00	38000275	0	\N	\N	27964	0	312681000	4195803	
4600	437	4170947	2017-11-06	2017-11-06 00:00:00	38000275	0	\N	\N	29054	0	274474001	4170947	
4798	449	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	29973	0	180256009	4107731	
4906	454	4078793	2017-09-09	2017-09-09 00:00:00	38000275	0	\N	\N	30277	0	180325003	4078793	
5093	471	4125906	2017-09-10	2017-09-10 00:00:00	38000275	0	\N	\N	31464	0	288086009	4125906	
5280	489	4058899	1999-09-07	1999-09-07 00:00:00	38000275	0	\N	\N	32705	0	168594001	4058899	
5468	502	4078793	2015-04-25	2015-04-25 00:00:00	38000275	0	\N	\N	33630	0	180325003	4078793	
5754	533	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	35454	0	180256009	4107731	
5841	534	4043071	1988-10-21	1988-10-21 00:00:00	38000275	0	\N	\N	35608	0	228557008	4043071	
6101	559	4043071	1977-03-22	1977-03-22 00:00:00	38000275	0	\N	\N	37077	0	228557008	4043071	
6227	573	4125906	1974-04-15	1974-04-15 00:00:00	38000275	0	\N	\N	37985	0	288086009	4125906	
6418	601	4107731	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	39748	0	180256009	4107731	
6589	603	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	39891	0	180256009	4107731	
6776	615	4107731	1991-05-25	1991-05-25 00:00:00	38000275	0	\N	\N	41006	0	180256009	4107731	
6977	642	4057420	2015-01-11	2015-01-11 00:00:00	38000275	0	\N	\N	42514	0	18286008	4057420	
7163	664	4107731	2011-06-28	2011-06-28 00:00:00	38000275	0	\N	\N	43840	0	180256009	4107731	
7337	680	4107731	1993-02-08	1993-02-08 00:00:00	38000275	0	\N	\N	45080	0	180256009	4107731	
7533	703	4125906	1992-09-13	1992-09-13 00:00:00	38000275	0	\N	\N	46510	0	288086009	4125906	
7763	711	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	47188	0	180256009	4107731	
7902	723	4170947	1966-12-23	1966-12-23 00:00:00	38000275	0	\N	\N	47804	0	274474001	4170947	
8089	739	4058899	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	48934	0	168594001	4058899	
8272	757	4078793	1979-01-28	1979-01-28 00:00:00	38000275	0	\N	\N	50243	0	180325003	4078793	
8523	778	4295880	1994-12-31	1994-12-31 00:00:00	38000275	0	\N	\N	51694	0	76601001	4295880	
20650	1776	4202832	1984-10-13	1984-10-13 00:00:00	38000275	0	\N	\N	118804	0	52765003	4202832	
20774	1786	4024289	1959-03-05	1959-03-05 00:00:00	38000275	0	\N	\N	119704	0	19490002	4024289	
9072	834	4275113	1973-06-23	1973-06-23 00:00:00	38000275	0	\N	\N	55225	0	65200003	4275113	
9207	843	4107731	1995-11-11	1995-11-11 00:00:00	38000275	0	\N	\N	55869	0	180256009	4107731	
9462	862	4252419	1994-02-24	1994-02-24 00:00:00	38000275	0	\N	\N	57053	0	74016001	4252419	
9586	870	4170947	1971-10-06	1971-10-06 00:00:00	38000275	0	\N	\N	57891	0	274474001	4170947	
9776	877	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	58377	0	180256009	4107731	
10030	895	4043071	1968-11-29	1968-11-29 00:00:00	38000275	0	\N	\N	59648	0	228557008	4043071	
10259	917	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	61073	0	395142003	4191853	
10329	917	4043071	1976-07-18	1976-07-18 00:00:00	38000275	0	\N	\N	61071	0	228557008	4043071	
10576	956	4151422	1945-04-15	1945-04-15 00:00:00	38000275	0	\N	\N	63489	0	269911007	4151422	
10835	974	4170947	1960-03-05	1960-03-05 00:00:00	38000275	0	\N	\N	64963	0	274474001	4170947	
10978	1017	4058899	2009-09-27	2009-09-27 00:00:00	38000275	0	\N	\N	67004	0	168594001	4058899	
11194	1036	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	68109	0	180256009	4107731	
11314	1054	4024289	2000-02-03	2000-02-03 00:00:00	38000275	0	\N	\N	69136	0	19490002	4024289	
23423	2054	4047491	2014-07-22	2014-07-22 00:00:00	38000275	0	\N	\N	136590	0	1225002	4047491	
11643	1079	4275113	1976-03-14	1976-03-14 00:00:00	38000275	0	\N	\N	70718	0	65200003	4275113	
11895	1091	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	71622	0	180256009	4107731	
44	3	4057420	2008-09-01	2008-09-01 00:00:00	38000275	0	\N	\N	330	0	18286008	4057420	
238	16	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	1179	0	180256009	4107731	
511	36	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	2535	0	180256009	4107731	
12530	1137	4243062	1957-01-06	1957-01-06 00:00:00	38000275	0	\N	\N	74974	0	60027007	4243062	
833	82	4163872	2004-04-05	2004-04-05 00:00:00	38000275	0	\N	\N	5539	0	399208008	4163872	
1021	99	4187458	2016-10-10	2016-10-10 00:00:00	38000275	0	\N	\N	6774	0	415300000	4187458	
1176	124	4107731	1997-10-27	1997-10-27 00:00:00	38000275	0	\N	\N	8327	0	180256009	4107731	
1442	137	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	9217	0	180256009	4107731	
1646	153	4125906	2011-02-02	2011-02-02 00:00:00	38000275	0	\N	\N	10333	0	288086009	4125906	
1727	155	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	10630	0	180256009	4107731	
1926	180	4107731	1992-09-24	1992-09-24 00:00:00	38000275	0	\N	\N	12141	0	180256009	4107731	
2138	219	4181917	1976-03-13	1976-03-13 00:00:00	38000275	0	\N	\N	14752	0	54550000	4181917	
2344	236	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	15865	0	180256009	4107731	
2505	260	4107731	1991-09-07	1991-09-07 00:00:00	38000275	0	\N	\N	17172	0	180256009	4107731	
2726	270	4057420	2012-06-05	2012-06-05 00:00:00	38000275	0	\N	\N	18027	0	18286008	4057420	
2849	273	4107731	1990-10-07	1990-10-07 00:00:00	38000275	0	\N	\N	18199	0	180256009	4107731	
3118	304	4151422	2018-05-26	2018-05-26 00:00:00	38000275	0	\N	\N	20255	0	269911007	4151422	
3293	331	4252419	1942-09-22	1942-09-22 00:00:00	38000275	0	\N	\N	21807	0	74016001	4252419	
3477	338	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	22475	0	180256009	4107731	
3602	348	4170947	1984-10-08	1984-10-08 00:00:00	38000275	0	\N	\N	23115	0	274474001	4170947	
3837	372	4243062	1962-05-08	1962-05-08 00:00:00	38000275	0	\N	\N	24785	0	60027007	4243062	
3972	399	4107731	1991-12-01	1991-12-01 00:00:00	38000275	0	\N	\N	26108	0	180256009	4107731	
4159	406	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	26735	0	180256009	4107731	
4348	422	4058899	1967-01-28	1967-01-28 00:00:00	38000275	0	\N	\N	27940	0	168594001	4058899	
4601	437	4195803	2017-11-06	2017-11-06 00:00:00	38000275	0	\N	\N	29054	0	312681000	4195803	
4799	449	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	29940	0	180256009	4107731	
4907	454	4057420	2005-03-05	2005-03-05 00:00:00	38000275	0	\N	\N	30329	0	18286008	4057420	
5094	472	4243062	2003-06-16	2003-06-16 00:00:00	38000275	0	\N	\N	31547	0	60027007	4243062	
5281	489	4107731	1990-10-07	1990-10-07 00:00:00	38000275	0	\N	\N	32820	0	180256009	4107731	
5469	502	4078793	2012-04-07	2012-04-07 00:00:00	38000275	0	\N	\N	33608	0	180325003	4078793	
5755	533	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	35429	0	180256009	4107731	
5842	534	4043071	1990-08-17	1990-08-17 00:00:00	38000275	0	\N	\N	35611	0	228557008	4043071	
6102	559	4043071	1977-04-26	1977-04-26 00:00:00	38000275	0	\N	\N	37078	0	228557008	4043071	
6230	576	4043071	1974-02-27	1974-02-27 00:00:00	38000275	0	\N	\N	38069	0	228557008	4043071	
6419	601	4191853	1990-01-07	1990-01-07 00:00:00	38000275	0	\N	\N	39759	0	395142003	4191853	
6590	603	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	39914	0	180256009	4107731	
6777	615	4107731	1991-06-15	1991-06-15 00:00:00	38000275	0	\N	\N	40972	0	180256009	4107731	
6978	642	4057420	2013-11-03	2013-11-03 00:00:00	38000275	0	\N	\N	42513	0	18286008	4057420	
7164	664	4107731	2011-09-20	2011-09-20 00:00:00	38000275	0	\N	\N	43842	0	180256009	4107731	
7338	680	4107731	1992-10-26	1992-10-26 00:00:00	38000275	0	\N	\N	45038	0	180256009	4107731	
7534	703	4293740	1992-09-13	1992-09-13 00:00:00	38000275	0	\N	\N	46510	0	384700001	4293740	
7764	711	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	47182	0	180256009	4107731	
7903	723	4163872	1966-12-23	1966-12-23 00:00:00	38000275	0	\N	\N	47804	0	399208008	4163872	
8090	741	4057420	2000-05-26	2000-05-26 00:00:00	38000275	0	\N	\N	49043	0	18286008	4057420	
8273	757	4078793	1997-06-22	1997-06-22 00:00:00	38000275	0	\N	\N	50275	0	180325003	4078793	
8524	778	4295880	1996-01-04	1996-01-04 00:00:00	38000275	0	\N	\N	51669	0	76601001	4295880	
20651	1776	4163971	1984-10-13	1984-10-13 00:00:00	38000275	0	\N	\N	118804	0	45595009	4163971	
20775	1786	4170947	1959-03-05	1959-03-05 00:00:00	38000275	0	\N	\N	119704	0	274474001	4170947	
9073	834	4170947	1963-05-04	1963-05-04 00:00:00	38000275	0	\N	\N	55205	0	274474001	4170947	
9208	843	4107731	1998-05-23	1998-05-23 00:00:00	38000275	0	\N	\N	55833	0	180256009	4107731	
9463	862	4145310	1979-09-11	1979-09-11 00:00:00	38000275	0	\N	\N	57051	0	268425006	4145310	
9587	871	4125906	1975-10-28	1975-10-28 00:00:00	38000275	0	\N	\N	57956	0	288086009	4125906	
9777	877	4125906	1992-05-28	1992-05-28 00:00:00	38000275	0	\N	\N	58440	0	288086009	4125906	
10031	895	4043071	1969-11-21	1969-11-21 00:00:00	38000275	0	\N	\N	59694	0	228557008	4043071	
10260	917	4043071	1975-03-02	1975-03-02 00:00:00	38000275	0	\N	\N	60976	0	228557008	4043071	
10330	917	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	61003	0	180256009	4107731	
10577	956	4195803	2006-05-03	2006-05-03 00:00:00	38000275	0	\N	\N	63525	0	312681000	4195803	
10836	974	4198190	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	64969	0	80146002	4198190	
10979	1017	4195803	2009-09-27	2009-09-27 00:00:00	38000275	0	\N	\N	67004	0	312681000	4195803	
11195	1036	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	68182	0	180256009	4107731	
11315	1054	4195803	2000-02-03	2000-02-03 00:00:00	38000275	0	\N	\N	69136	0	312681000	4195803	
23424	2054	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	136648	0	180256009	4107731	
11644	1079	4238715	1980-07-06	1980-07-06 00:00:00	38000275	0	\N	\N	70721	0	68254000	4238715	
11896	1091	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	71661	0	180256009	4107731	
45	3	4078793	2003-08-04	2003-08-04 00:00:00	38000275	0	\N	\N	275	0	180325003	4078793	
239	16	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	1173	0	395142003	4191853	
512	36	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	2556	0	180256009	4107731	
12531	1137	4170947	1957-01-06	1957-01-06 00:00:00	38000275	0	\N	\N	74974	0	274474001	4170947	
834	82	4047491	1973-09-14	1973-09-14 00:00:00	38000275	0	\N	\N	5568	0	1225002	4047491	
1022	99	4326177	2016-10-10	2016-10-10 00:00:00	38000275	0	\N	\N	6774	0	430193006	4326177	
1177	124	4191853	1997-03-10	1997-03-10 00:00:00	38000275	0	\N	\N	8325	0	395142003	4191853	
1443	137	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	9203	0	180256009	4107731	
1647	153	4043071	1958-05-01	1958-05-01 00:00:00	38000275	0	\N	\N	10408	0	228557008	4043071	
1728	155	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	10592	0	180256009	4107731	
1927	180	4107731	1993-04-22	1993-04-22 00:00:00	38000275	0	\N	\N	12089	0	180256009	4107731	
2139	219	4181917	1977-03-26	1977-03-26 00:00:00	38000275	0	\N	\N	14753	0	54550000	4181917	
2345	236	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	15954	0	180256009	4107731	
2506	260	4107731	1992-08-29	1992-08-29 00:00:00	38000275	0	\N	\N	17258	0	180256009	4107731	
2727	270	40492359	2012-06-05	2012-06-05 00:00:00	38000275	0	\N	\N	18027	0	447365002	40492359	
2850	273	4107731	1990-11-18	1990-11-18 00:00:00	38000275	0	\N	\N	18200	0	180256009	4107731	
3119	304	44783196	2017-12-14	2017-12-14 00:00:00	38000275	0	\N	\N	20209	0	699253003	44783196	
3294	331	4163951	1997-04-18	1997-04-18 00:00:00	38000275	0	\N	\N	21811	0	29303009	4163951	
3478	338	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	22520	0	180256009	4107731	
3603	348	4024289	1984-10-08	1984-10-08 00:00:00	38000275	0	\N	\N	23115	0	19490002	4024289	
3838	372	4195803	2017-11-27	2017-11-27 00:00:00	38000275	0	\N	\N	24790	0	312681000	4195803	
3973	399	4107731	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	26184	0	180256009	4107731	
4160	406	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	26761	0	180256009	4107731	
4483	426	4198190	2007-01-04	2007-01-04 00:00:00	38000275	0	\N	\N	28295	0	80146002	4198190	
4602	437	4047491	2017-11-06	2017-11-06 00:00:00	38000275	0	\N	\N	29054	0	1225002	4047491	
4800	449	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	29938	0	180256009	4107731	
4908	454	4078793	2006-03-11	2006-03-11 00:00:00	38000275	0	\N	\N	30300	0	180325003	4078793	
5095	472	4170947	2003-06-16	2003-06-16 00:00:00	38000275	0	\N	\N	31547	0	274474001	4170947	
5282	489	4107731	1993-05-09	1993-05-09 00:00:00	38000275	0	\N	\N	32802	0	180256009	4107731	
5470	502	4057420	2013-04-13	2013-04-13 00:00:00	38000275	0	\N	\N	33580	0	18286008	4057420	
5756	533	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	35444	0	395142003	4191853	
5843	534	4043071	1991-04-04	1991-04-04 00:00:00	38000275	0	\N	\N	35521	0	228557008	4043071	
6103	559	4043071	1977-05-31	1977-05-31 00:00:00	38000275	0	\N	\N	37079	0	228557008	4043071	
6231	576	4043071	1974-04-03	1974-04-03 00:00:00	38000275	0	\N	\N	38070	0	228557008	4043071	
6420	601	4107731	1993-03-28	1993-03-28 00:00:00	38000275	0	\N	\N	39753	0	180256009	4107731	
6591	603	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	39975	0	180256009	4107731	
6778	615	4197460	1926-12-24	1926-12-24 00:00:00	38000275	0	\N	\N	41040	0	313191000	4197460	
6979	642	4078793	2017-01-22	2017-01-22 00:00:00	38000275	0	\N	\N	42544	0	180325003	4078793	
7165	664	4107731	2010-09-28	2010-09-28 00:00:00	38000275	0	\N	\N	43868	0	180256009	4107731	
7339	680	4107731	1990-06-18	1990-06-18 00:00:00	38000275	0	\N	\N	45018	0	180256009	4107731	
7535	703	4078793	2018-01-26	2018-01-26 00:00:00	38000275	0	\N	\N	46491	0	180325003	4078793	
7765	711	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	47145	0	180256009	4107731	
7994	726	4151422	1984-08-18	1984-08-18 00:00:00	38000275	0	\N	\N	48112	0	269911007	4151422	
8091	741	40492359	2000-05-26	2000-05-26 00:00:00	38000275	0	\N	\N	49043	0	447365002	40492359	
8274	757	4078793	1983-02-20	1983-02-20 00:00:00	38000275	0	\N	\N	50271	0	180325003	4078793	
8602	782	4125906	1977-11-15	1977-11-15 00:00:00	38000275	0	\N	\N	52019	0	288086009	4125906	
20652	1776	4057420	2013-12-07	2013-12-07 00:00:00	38000275	0	\N	\N	118894	0	18286008	4057420	
20776	1786	4058899	1986-07-11	1986-07-11 00:00:00	38000275	0	\N	\N	119706	0	168594001	4058899	
9074	834	4047491	1963-05-04	1963-05-04 00:00:00	38000275	0	\N	\N	55205	0	1225002	4047491	
9209	843	4107731	1995-12-02	1995-12-02 00:00:00	38000275	0	\N	\N	55790	0	180256009	4107731	
9464	862	4058899	1986-06-06	1986-06-06 00:00:00	38000275	0	\N	\N	57052	0	168594001	4058899	
9588	871	4058899	1967-11-09	1967-11-09 00:00:00	38000275	0	\N	\N	57955	0	168594001	4058899	
9778	877	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	58431	0	180256009	4107731	
10032	895	4043071	1967-06-30	1967-06-30 00:00:00	38000275	0	\N	\N	59651	0	228557008	4043071	
10261	917	4043071	1973-07-22	1973-07-22 00:00:00	38000275	0	\N	\N	61043	0	228557008	4043071	
10331	917	4043071	1974-11-03	1974-11-03 00:00:00	38000275	0	\N	\N	61047	0	228557008	4043071	
10578	956	4151422	1949-08-29	1949-08-29 00:00:00	38000275	0	\N	\N	63491	0	269911007	4151422	
10837	975	4125906	1975-10-19	1975-10-19 00:00:00	38000275	0	\N	\N	65031	0	288086009	4125906	
10980	1017	4125906	1984-10-17	1984-10-17 00:00:00	38000275	0	\N	\N	67003	0	288086009	4125906	
11196	1036	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	68159	0	180256009	4107731	
11316	1054	4125906	1985-11-27	1985-11-27 00:00:00	38000275	0	\N	\N	69134	0	288086009	4125906	
23425	2054	4238715	1990-03-22	1990-03-22 00:00:00	38000275	0	\N	\N	136601	0	68254000	4238715	
11649	1081	4151422	2001-06-26	2001-06-26 00:00:00	38000275	0	\N	\N	70845	0	269911007	4151422	
11897	1091	4125906	1998-07-27	1998-07-27 00:00:00	38000275	0	\N	\N	71726	0	288086009	4125906	
46	3	4170947	1986-10-04	1986-10-04 00:00:00	38000275	0	\N	\N	348	0	274474001	4170947	
240	16	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	1222	0	180256009	4107731	
513	36	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	2644	0	180256009	4107731	
12532	1138	4043071	1994-02-24	1994-02-24 00:00:00	38000275	0	\N	\N	75043	0	228557008	4043071	
835	82	4170947	1973-09-14	1973-09-14 00:00:00	38000275	0	\N	\N	5568	0	274474001	4170947	
1023	99	4037675	2016-10-10	2016-10-10 00:00:00	38000275	0	\N	\N	6774	0	162676008	4037675	
1178	124	4107731	1999-01-11	1999-01-11 00:00:00	38000275	0	\N	\N	8193	0	180256009	4107731	
1444	137	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	9156	0	180256009	4107731	
1648	153	4043071	1959-02-19	1959-02-19 00:00:00	38000275	0	\N	\N	10373	0	228557008	4043071	
1729	155	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	10573	0	180256009	4107731	
1928	180	4107731	1990-08-09	1990-08-09 00:00:00	38000275	0	\N	\N	12132	0	180256009	4107731	
2140	219	4151422	1968-08-28	1968-08-28 00:00:00	38000275	0	\N	\N	14766	0	269911007	4151422	
2346	236	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	15892	0	180256009	4107731	
2507	260	4107731	1991-11-30	1991-11-30 00:00:00	38000275	0	\N	\N	17254	0	180256009	4107731	
2801	273	4191853	1990-01-07	1990-01-07 00:00:00	38000275	0	\N	\N	18196	0	395142003	4191853	
2851	273	4107731	1990-06-24	1990-06-24 00:00:00	38000275	0	\N	\N	18309	0	180256009	4107731	
3120	304	4010253	1974-11-05	1974-11-05 00:00:00	38000275	0	\N	\N	20275	0	112790001	4010253	
3295	331	4163971	1997-04-18	1997-04-18 00:00:00	38000275	0	\N	\N	21811	0	45595009	4163971	
3479	338	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	22539	0	180256009	4107731	
3604	349	4117038	1983-07-10	1983-07-10 00:00:00	38000275	0	\N	\N	23243	0	287664005	4117038	
3839	372	4170947	2017-11-27	2017-11-27 00:00:00	38000275	0	\N	\N	24790	0	274474001	4170947	
3977	403	4078793	1997-01-20	1997-01-20 00:00:00	38000275	0	\N	\N	26469	0	180325003	4078793	
4161	406	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	26824	0	180256009	4107731	
4487	430	4293740	2009-09-03	2009-09-03 00:00:00	38000275	0	\N	\N	28543	0	384700001	4293740	
4603	437	4163872	1950-01-23	1950-01-23 00:00:00	38000275	0	\N	\N	28965	0	399208008	4163872	
4801	449	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	29909	0	180256009	4107731	
4909	454	4078793	2010-04-03	2010-04-03 00:00:00	38000275	0	\N	\N	30316	0	180325003	4078793	
5096	472	4191853	1998-02-10	1998-02-10 00:00:00	38000275	0	\N	\N	31515	0	395142003	4191853	
5283	489	4107731	1992-05-17	1992-05-17 00:00:00	38000275	0	\N	\N	32797	0	180256009	4107731	
5471	502	4078793	2011-04-02	2011-04-02 00:00:00	38000275	0	\N	\N	33622	0	180325003	4078793	
5757	533	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	35420	0	180256009	4107731	
5844	534	4043071	1993-06-04	1993-06-04 00:00:00	38000275	0	\N	\N	35567	0	228557008	4043071	
6104	559	4043071	1977-06-28	1977-06-28 00:00:00	38000275	0	\N	\N	37053	0	228557008	4043071	
6232	576	4125906	1997-04-18	1997-04-18 00:00:00	38000275	0	\N	\N	38065	0	288086009	4125906	
6421	601	4107731	1990-08-05	1990-08-05 00:00:00	38000275	0	\N	\N	39736	0	180256009	4107731	
6592	603	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	40004	0	395142003	4191853	
6779	615	4107731	1993-01-02	1993-01-02 00:00:00	38000275	0	\N	\N	40983	0	180256009	4107731	
6980	642	4163872	1985-06-08	1985-06-08 00:00:00	38000275	0	\N	\N	42539	0	399208008	4163872	
7166	664	4107731	2012-10-23	2012-10-23 00:00:00	38000275	0	\N	\N	43887	0	180256009	4107731	
7340	680	4107731	1992-06-22	1992-06-22 00:00:00	38000275	0	\N	\N	44973	0	180256009	4107731	
7536	703	4078793	2010-05-28	2010-05-28 00:00:00	38000275	0	\N	\N	46468	0	180325003	4078793	
7766	711	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	47078	0	180256009	4107731	
7995	726	4170947	1969-02-07	1969-02-07 00:00:00	38000275	0	\N	\N	48092	0	274474001	4170947	
8092	741	4151422	2004-05-05	2004-05-05 00:00:00	38000275	0	\N	\N	49096	0	269911007	4151422	
8275	757	4057420	1985-03-03	1985-03-03 00:00:00	38000275	0	\N	\N	50272	0	18286008	4057420	
20384	1762	4035793	2016-04-21	2016-04-21 00:00:00	38000275	0	\N	\N	117832	0	15081005	4035793	
20653	1776	4293740	1921-09-30	1921-09-30 00:00:00	38000275	0	\N	\N	118799	0	384700001	4293740	
20777	1786	4151422	2007-11-05	2007-11-05 00:00:00	38000275	0	\N	\N	119695	0	269911007	4151422	
9075	834	4238715	1976-10-18	1976-10-18 00:00:00	38000275	0	\N	\N	55195	0	68254000	4238715	
9210	843	4107731	1997-08-23	1997-08-23 00:00:00	38000275	0	\N	\N	55830	0	180256009	4107731	
9465	862	4047491	2017-08-22	2017-08-22 00:00:00	38000275	0	\N	\N	57054	0	1225002	4047491	
9589	871	4252419	2001-10-25	2001-10-25 00:00:00	38000275	0	\N	\N	57958	0	74016001	4252419	
9779	877	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	58352	0	180256009	4107731	
10033	895	4043071	1969-05-30	1969-05-30 00:00:00	38000275	0	\N	\N	59735	0	228557008	4043071	
10262	917	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	61005	0	180256009	4107731	
10332	917	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	60965	0	180256009	4107731	
10579	956	4125906	1952-05-27	1952-05-27 00:00:00	38000275	0	\N	\N	63552	0	288086009	4125906	
10838	975	4252419	1979-12-11	1979-12-11 00:00:00	38000275	0	\N	\N	65022	0	74016001	4252419	
10981	1017	4187458	1964-06-13	1964-06-13 00:00:00	38000275	0	\N	\N	67005	0	415300000	4187458	
11197	1036	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	68167	0	180256009	4107731	
11317	1054	4125906	1956-02-14	1956-02-14 00:00:00	38000275	0	\N	\N	69131	0	288086009	4125906	
23426	2054	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	136594	0	180256009	4107731	
11650	1082	4107731	1993-03-06	1993-03-06 00:00:00	38000275	0	\N	\N	70959	0	180256009	4107731	
11898	1091	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	71597	0	180256009	4107731	
47	3	4047491	1986-10-04	1986-10-04 00:00:00	38000275	0	\N	\N	348	0	1225002	4047491	
241	16	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	1185	0	180256009	4107731	
514	36	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	2550	0	180256009	4107731	
12533	1138	4043071	1995-07-13	1995-07-13 00:00:00	38000275	0	\N	\N	75101	0	228557008	4043071	
837	84	4191853	1979-04-08	1979-04-08 00:00:00	38000275	0	\N	\N	5665	0	395142003	4191853	
1024	99	4035793	2019-04-27	2019-04-27 00:00:00	38000275	0	\N	\N	6754	0	15081005	4035793	
1179	124	4107731	2000-04-18	2000-04-18 00:00:00	38000275	0	\N	\N	8269	0	180256009	4107731	
1445	137	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	9171	0	180256009	4107731	
1649	153	4043071	1959-06-25	1959-06-25 00:00:00	38000275	0	\N	\N	10354	0	228557008	4043071	
1730	155	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	10611	0	180256009	4107731	
1929	180	4107731	1990-09-20	1990-09-20 00:00:00	38000275	0	\N	\N	12122	0	180256009	4107731	
2141	219	4181917	1974-03-29	1974-03-29 00:00:00	38000275	0	\N	\N	14749	0	54550000	4181917	
2347	236	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	15825	0	180256009	4107731	
2508	260	4107731	1990-01-27	1990-01-27 00:00:00	38000275	0	\N	\N	17165	0	180256009	4107731	
2802	273	4107731	1991-12-22	1991-12-22 00:00:00	38000275	0	\N	\N	18315	0	180256009	4107731	
2852	273	4107731	1993-02-14	1993-02-14 00:00:00	38000275	0	\N	\N	18209	0	180256009	4107731	
3121	304	4125906	1978-01-17	1978-01-17 00:00:00	38000275	0	\N	\N	20212	0	288086009	4125906	
3296	331	4202832	1997-04-18	1997-04-18 00:00:00	38000275	0	\N	\N	21811	0	52765003	4202832	
3480	338	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	22492	0	180256009	4107731	
3605	349	4195803	2018-04-28	2018-04-28 00:00:00	38000275	0	\N	\N	23211	0	312681000	4195803	
3840	372	4243062	2017-11-27	2017-11-27 00:00:00	38000275	0	\N	\N	24790	0	60027007	4243062	
3978	403	4078793	2004-03-01	2004-03-01 00:00:00	38000275	0	\N	\N	26528	0	180325003	4078793	
4162	406	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	26733	0	180256009	4107731	
4488	430	4125906	2009-09-03	2009-09-03 00:00:00	38000275	0	\N	\N	28543	0	288086009	4125906	
4608	439	4170947	1983-05-31	1983-05-31 00:00:00	38000275	0	\N	\N	29151	0	274474001	4170947	
4802	449	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	29926	0	180256009	4107731	
4910	454	4078793	2016-03-05	2016-03-05 00:00:00	38000275	0	\N	\N	30303	0	180325003	4078793	
5097	474	4125906	1976-05-11	1976-05-11 00:00:00	38000275	0	\N	\N	31640	0	288086009	4125906	
5284	489	4107731	1990-10-28	1990-10-28 00:00:00	38000275	0	\N	\N	32747	0	180256009	4107731	
5472	502	4125906	1953-10-06	1953-10-06 00:00:00	38000275	0	\N	\N	33649	0	288086009	4125906	
5758	533	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	35432	0	180256009	4107731	
5845	534	4043071	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	35531	0	228557008	4043071	
6105	559	4043071	1977-02-22	1977-02-22 00:00:00	38000275	0	\N	\N	37052	0	228557008	4043071	
6233	576	4043071	1973-11-28	1973-11-28 00:00:00	38000275	0	\N	\N	38097	0	228557008	4043071	
6422	601	4107731	1993-02-14	1993-02-14 00:00:00	38000275	0	\N	\N	39752	0	180256009	4107731	
6593	603	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	39896	0	180256009	4107731	
6780	615	4107731	1992-12-12	1992-12-12 00:00:00	38000275	0	\N	\N	40978	0	180256009	4107731	
6981	642	4078793	2018-07-15	2018-07-15 00:00:00	38000275	0	\N	\N	42556	0	180325003	4078793	
7167	664	4275113	1996-07-03	1996-07-03 00:00:00	38000275	0	\N	\N	43835	0	65200003	4275113	
7341	680	4107731	1992-03-30	1992-03-30 00:00:00	38000275	0	\N	\N	44991	0	180256009	4107731	
7537	704	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	46575	0	180256009	4107731	
7767	711	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	47092	0	180256009	4107731	
7996	726	4243062	1969-02-07	1969-02-07 00:00:00	38000275	0	\N	\N	48092	0	60027007	4243062	
8093	741	4243062	1977-12-13	1977-12-13 00:00:00	38000275	0	\N	\N	49040	0	60027007	4243062	
8276	757	4078793	1982-02-14	1982-02-14 00:00:00	38000275	0	\N	\N	50228	0	180325003	4078793	
20385	1762	4078793	2016-04-21	2016-04-21 00:00:00	38000275	0	\N	\N	117832	0	180325003	4078793	
20654	1776	4125906	1921-09-30	1921-09-30 00:00:00	38000275	0	\N	\N	118799	0	288086009	4125906	
20778	1786	4047491	1970-11-02	1970-11-02 00:00:00	38000275	0	\N	\N	119705	0	1225002	4047491	
9076	834	4125906	2012-11-18	2012-11-18 00:00:00	38000275	0	\N	\N	55252	0	288086009	4125906	
9211	843	4107731	1998-09-26	1998-09-26 00:00:00	38000275	0	\N	\N	55769	0	180256009	4107731	
9466	862	4170947	2017-08-22	2017-08-22 00:00:00	38000275	0	\N	\N	57054	0	274474001	4170947	
21529	1867	4330583	2006-05-22	2006-05-22 00:00:00	38000275	0	\N	\N	124679	0	22523008	4330583	
9780	877	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	58350	0	180256009	4107731	
10034	895	4043071	1967-04-07	1967-04-07 00:00:00	38000275	0	\N	\N	59727	0	228557008	4043071	
10263	917	4043071	1973-12-23	1973-12-23 00:00:00	38000275	0	\N	\N	61044	0	228557008	4043071	
10333	917	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	60921	0	180256009	4107731	
10580	958	4125906	2012-10-04	2012-10-04 00:00:00	38000275	0	\N	\N	63599	0	288086009	4125906	
10839	975	4047491	1972-01-08	1972-01-08 00:00:00	38000275	0	\N	\N	65030	0	1225002	4047491	
10982	1017	4326177	1964-06-13	1964-06-13 00:00:00	38000275	0	\N	\N	67005	0	430193006	4326177	
11198	1036	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	68113	0	180256009	4107731	
11318	1054	4125906	1984-02-15	1984-02-15 00:00:00	38000275	0	\N	\N	69133	0	288086009	4125906	
23427	2054	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	136687	0	180256009	4107731	
11651	1082	4107731	1991-01-19	1991-01-19 00:00:00	38000275	0	\N	\N	70915	0	180256009	4107731	
11899	1091	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	71656	0	180256009	4107731	
48	3	4195803	1986-04-28	1986-04-28 00:00:00	38000275	0	\N	\N	253	0	312681000	4195803	
242	16	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	1270	0	180256009	4107731	
515	36	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	2555	0	180256009	4107731	
12534	1138	4043071	1997-11-20	1997-11-20 00:00:00	38000275	0	\N	\N	74998	0	228557008	4043071	
841	86	4163872	1952-07-05	1952-07-05 00:00:00	38000275	0	\N	\N	5768	0	399208008	4163872	
1025	99	4035793	2015-04-04	2015-04-04 00:00:00	38000275	0	\N	\N	6752	0	15081005	4035793	
1180	124	4107731	1998-12-21	1998-12-21 00:00:00	38000275	0	\N	\N	8251	0	180256009	4107731	
1446	137	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	9210	0	180256009	4107731	
1650	153	4043071	1958-07-10	1958-07-10 00:00:00	38000275	0	\N	\N	10350	0	228557008	4043071	
1731	155	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	10621	0	180256009	4107731	
1930	180	4107731	1993-03-11	1993-03-11 00:00:00	38000275	0	\N	\N	12088	0	180256009	4107731	
2142	219	4125906	1974-11-24	1974-11-24 00:00:00	38000275	0	\N	\N	14750	0	288086009	4125906	
2348	236	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	15868	0	180256009	4107731	
2509	260	4191853	1990-01-06	1990-01-06 00:00:00	38000275	0	\N	\N	17212	0	395142003	4191853	
2803	273	4107731	1992-11-22	1992-11-22 00:00:00	38000275	0	\N	\N	18239	0	180256009	4107731	
2853	273	4145310	2001-09-27	2001-09-27 00:00:00	38000275	0	\N	\N	18287	0	268425006	4145310	
3124	307	4151422	2019-03-03	2019-03-03 00:00:00	38000275	0	\N	\N	20387	0	269911007	4151422	
3297	331	42535580	1997-04-18	1997-04-18 00:00:00	38000275	0	\N	\N	21811	0	426701000119108	42535580	
3481	338	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	22514	0	180256009	4107731	
3606	349	4058899	1969-08-28	1969-08-28 00:00:00	38000275	0	\N	\N	23241	0	168594001	4058899	
3841	372	4252419	2018-12-22	2018-12-22 00:00:00	38000275	0	\N	\N	24791	0	74016001	4252419	
3979	403	4078793	2019-05-27	2019-05-27 00:00:00	38000275	0	\N	\N	26473	0	180325003	4078793	
4163	406	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	26740	0	180256009	4107731	
16305	1418	4151422	1988-03-09	1988-03-09 00:00:00	38000275	0	\N	\N	94446	0	269911007	4151422	
4609	439	4163872	1983-05-31	1983-05-31 00:00:00	38000275	0	\N	\N	29151	0	399208008	4163872	
4803	449	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	29976	0	180256009	4107731	
4911	454	4057420	2011-04-09	2011-04-09 00:00:00	38000275	0	\N	\N	30374	0	18286008	4057420	
5098	474	4125906	1990-09-05	1990-09-05 00:00:00	38000275	0	\N	\N	31643	0	288086009	4125906	
5285	489	4107731	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	32796	0	180256009	4107731	
5473	502	4293740	1953-10-06	1953-10-06 00:00:00	38000275	0	\N	\N	33649	0	384700001	4293740	
5759	533	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	35411	0	180256009	4107731	
5846	534	4043071	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	35523	0	228557008	4043071	
6106	559	4151422	1969-06-19	1969-06-19 00:00:00	38000275	0	\N	\N	37050	0	269911007	4151422	
6234	576	4058899	2001-07-01	2001-07-01 00:00:00	38000275	0	\N	\N	38066	0	168594001	4058899	
6423	601	4107731	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	39726	0	180256009	4107731	
6594	603	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	39923	0	180256009	4107731	
6781	615	4107731	1992-02-01	1992-02-01 00:00:00	38000275	0	\N	\N	40974	0	180256009	4107731	
6982	642	4078793	2013-02-03	2013-02-03 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
7168	664	4107731	2010-12-21	2010-12-21 00:00:00	38000275	0	\N	\N	43839	0	180256009	4107731	
7342	680	4107731	1991-01-14	1991-01-14 00:00:00	38000275	0	\N	\N	45027	0	180256009	4107731	
7538	704	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	46560	0	180256009	4107731	
7768	711	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	47134	0	180256009	4107731	
7997	726	4151422	2013-05-23	2013-05-23 00:00:00	38000275	0	\N	\N	48088	0	269911007	4151422	
8094	741	4170947	1977-12-13	1977-12-13 00:00:00	38000275	0	\N	\N	49040	0	274474001	4170947	
8277	757	4057420	1994-06-05	1994-06-05 00:00:00	38000275	0	\N	\N	50249	0	18286008	4057420	
20386	1762	4035793	1981-02-05	1981-02-05 00:00:00	38000275	0	\N	\N	117817	0	15081005	4035793	
20655	1776	4078793	2016-12-24	2016-12-24 00:00:00	38000275	0	\N	\N	118841	0	180325003	4078793	
20779	1786	4170947	1970-11-02	1970-11-02 00:00:00	38000275	0	\N	\N	119705	0	274474001	4170947	
9078	836	4199276	2005-04-03	2005-04-03 00:00:00	38000275	0	\N	\N	55286	0	301807007	4199276	
9212	843	4107731	1996-08-31	1996-08-31 00:00:00	38000275	0	\N	\N	55843	0	180256009	4107731	
9467	863	4057420	1999-05-13	1999-05-13 00:00:00	38000275	0	\N	\N	57116	0	18286008	4057420	
21530	1867	4024289	1990-08-17	1990-08-17 00:00:00	38000275	0	\N	\N	124729	0	19490002	4024289	
9781	877	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	58361	0	180256009	4107731	
10035	895	4043071	1968-06-07	1968-06-07 00:00:00	38000275	0	\N	\N	59730	0	228557008	4043071	
10264	917	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	61030	0	180256009	4107731	
10334	917	4043071	1973-06-17	1973-06-17 00:00:00	38000275	0	\N	\N	61042	0	228557008	4043071	
10581	958	4293740	2012-10-04	2012-10-04 00:00:00	38000275	0	\N	\N	63599	0	384700001	4293740	
10840	975	4170947	1972-01-08	1972-01-08 00:00:00	38000275	0	\N	\N	65030	0	274474001	4170947	
10983	1017	4037675	1964-06-13	1964-06-13 00:00:00	38000275	0	\N	\N	67005	0	162676008	4037675	
11199	1036	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	68185	0	180256009	4107731	
11319	1054	4293740	1984-02-15	1984-02-15 00:00:00	38000275	0	\N	\N	69133	0	384700001	4293740	
23428	2054	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	136685	0	180256009	4107731	
11652	1082	4107731	1991-11-09	1991-11-09 00:00:00	38000275	0	\N	\N	71004	0	180256009	4107731	
11900	1091	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	71620	0	180256009	4107731	
49	3	4078793	2017-10-23	2017-10-23 00:00:00	38000275	0	\N	\N	326	0	180325003	4078793	
243	16	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	1244	0	180256009	4107731	
516	36	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	2524	0	180256009	4107731	
12535	1138	4043071	1994-03-24	1994-03-24 00:00:00	38000275	0	\N	\N	75026	0	228557008	4043071	
842	86	4125906	1961-03-15	1961-03-15 00:00:00	38000275	0	\N	\N	5791	0	288086009	4125906	
1026	99	4195803	2015-09-20	2015-09-20 00:00:00	38000275	0	\N	\N	6733	0	312681000	4195803	
1181	124	4107731	1998-06-16	1998-06-16 00:00:00	38000275	0	\N	\N	8250	0	180256009	4107731	
1447	137	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	9136	0	180256009	4107731	
1651	153	4125906	1970-02-09	1970-02-09 00:00:00	38000275	0	\N	\N	10318	0	288086009	4125906	
1732	155	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	10619	0	180256009	4107731	
1931	180	4107731	1990-06-28	1990-06-28 00:00:00	38000275	0	\N	\N	12131	0	180256009	4107731	
2143	219	4062501	1971-04-06	1971-04-06 00:00:00	38000275	0	\N	\N	14767	0	171231001	4062501	
2349	236	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	15900	0	180256009	4107731	
2510	260	44783196	1990-08-17	1990-08-17 00:00:00	38000275	0	\N	\N	17174	0	699253003	44783196	
2804	273	4107731	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	18273	0	180256009	4107731	
2854	273	4107731	1991-09-08	1991-09-08 00:00:00	38000275	0	\N	\N	18274	0	180256009	4107731	
3125	307	4125906	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	20382	0	288086009	4125906	
3298	331	4163872	1999-12-31	1999-12-31 00:00:00	38000275	0	\N	\N	21783	0	399208008	4163872	
3482	338	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	22581	0	180256009	4107731	
3607	349	4125906	2014-05-18	2014-05-18 00:00:00	38000275	0	\N	\N	23240	0	288086009	4125906	
3843	376	4163872	1973-05-26	1973-05-26 00:00:00	38000275	0	\N	\N	24902	0	399208008	4163872	
3980	403	4078793	2016-05-09	2016-05-09 00:00:00	38000275	0	\N	\N	26478	0	180325003	4078793	
4164	406	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	26821	0	180256009	4107731	
16306	1418	4238715	1993-03-08	1993-03-08 00:00:00	38000275	0	\N	\N	94401	0	68254000	4238715	
4610	439	4243062	1993-04-08	1993-04-08 00:00:00	38000275	0	\N	\N	29153	0	60027007	4243062	
4804	449	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	29929	0	180256009	4107731	
4912	454	4078793	2013-02-02	2013-02-02 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
5112	476	4151422	2002-02-11	2002-02-11 00:00:00	38000275	0	\N	\N	31740	0	269911007	4151422	
5286	489	4107731	1992-06-07	1992-06-07 00:00:00	38000275	0	\N	\N	32734	0	180256009	4107731	
5474	502	4078793	2014-04-19	2014-04-19 00:00:00	38000275	0	\N	\N	33609	0	180325003	4078793	
5760	533	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	35495	0	180256009	4107731	
5847	534	4043071	1992-06-19	1992-06-19 00:00:00	38000275	0	\N	\N	35565	0	228557008	4043071	
6107	559	4043071	1977-01-18	1977-01-18 00:00:00	38000275	0	\N	\N	37051	0	228557008	4043071	
6235	576	4043071	1973-12-26	1973-12-26 00:00:00	38000275	0	\N	\N	38112	0	228557008	4043071	
6424	601	4107731	1990-07-15	1990-07-15 00:00:00	38000275	0	\N	\N	39659	0	180256009	4107731	
6595	603	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	40021	0	180256009	4107731	
6782	615	4107731	1990-07-14	1990-07-14 00:00:00	38000275	0	\N	\N	40966	0	180256009	4107731	
6983	642	4057420	2007-09-09	2007-09-09 00:00:00	38000275	0	\N	\N	42481	0	18286008	4057420	
7169	664	4107731	2012-01-03	2012-01-03 00:00:00	38000275	0	\N	\N	43924	0	180256009	4107731	
7343	680	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	45036	0	180256009	4107731	
7539	704	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	46629	0	180256009	4107731	
7769	711	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	47132	0	180256009	4107731	
7998	726	4125906	2004-09-01	2004-09-01 00:00:00	38000275	0	\N	\N	48093	0	288086009	4125906	
8095	742	4035793	1984-10-15	1984-10-15 00:00:00	38000275	0	\N	\N	49114	0	15081005	4035793	
8278	757	4078793	1989-05-07	1989-05-07 00:00:00	38000275	0	\N	\N	50266	0	180325003	4078793	
20387	1762	4035793	1993-03-11	1993-03-11 00:00:00	38000275	0	\N	\N	117843	0	15081005	4035793	
20656	1776	44783196	2018-04-24	2018-04-24 00:00:00	38000275	0	\N	\N	118775	0	699253003	44783196	
20780	1786	4125906	2001-02-22	2001-02-22 00:00:00	38000275	0	\N	\N	119707	0	288086009	4125906	
9079	836	4243062	1992-03-28	1992-03-28 00:00:00	38000275	0	\N	\N	55325	0	60027007	4243062	
9213	843	4107731	1997-04-19	1997-04-19 00:00:00	38000275	0	\N	\N	55845	0	180256009	4107731	
9468	863	4078793	1988-03-10	1988-03-10 00:00:00	38000275	0	\N	\N	57136	0	180325003	4078793	
21531	1867	4170947	1990-08-17	1990-08-17 00:00:00	38000275	0	\N	\N	124729	0	274474001	4170947	
9782	877	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	58362	0	180256009	4107731	
10036	895	4043071	1970-01-30	1970-01-30 00:00:00	38000275	0	\N	\N	59657	0	228557008	4043071	
10265	917	4043071	1976-06-13	1976-06-13 00:00:00	38000275	0	\N	\N	60979	0	228557008	4043071	
10335	917	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	60983	0	180256009	4107731	
10582	958	4151422	2013-12-06	2013-12-06 00:00:00	38000275	0	\N	\N	63611	0	269911007	4151422	
10841	975	44783196	1979-12-18	1979-12-18 00:00:00	38000275	0	\N	\N	65021	0	699253003	44783196	
10984	1017	4181917	1970-06-12	1970-06-12 00:00:00	38000275	0	\N	\N	67002	0	54550000	4181917	
11200	1036	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	68178	0	180256009	4107731	
11340	1057	4170947	1989-01-08	1989-01-08 00:00:00	38000275	0	\N	\N	69302	0	274474001	4170947	
23429	2054	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	136668	0	395142003	4191853	
11653	1082	4037675	2006-08-07	2006-08-07 00:00:00	38000275	0	\N	\N	70962	0	162676008	4037675	
11901	1091	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	71645	0	180256009	4107731	
50	3	4151422	1956-12-15	1956-12-15 00:00:00	38000275	0	\N	\N	262	0	269911007	4151422	
244	16	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	1278	0	180256009	4107731	
517	36	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	2511	0	180256009	4107731	
12536	1138	4107731	1996-02-01	1996-02-01 00:00:00	38000275	0	\N	\N	75085	0	180256009	4107731	
843	86	4151422	1957-02-23	1957-02-23 00:00:00	38000275	0	\N	\N	5804	0	269911007	4151422	
1027	99	4058899	2015-09-20	2015-09-20 00:00:00	38000275	0	\N	\N	6733	0	168594001	4058899	
1182	124	4107731	1999-04-06	1999-04-06 00:00:00	38000275	0	\N	\N	8329	0	180256009	4107731	
1448	137	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	9137	0	180256009	4107731	
1652	153	4125906	1972-10-10	1972-10-10 00:00:00	38000275	0	\N	\N	10319	0	288086009	4125906	
1733	155	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	10512	0	180256009	4107731	
1932	180	4107731	1991-10-03	1991-10-03 00:00:00	38000275	0	\N	\N	12170	0	180256009	4107731	
2144	220	4295880	1999-08-18	1999-08-18 00:00:00	38000275	0	\N	\N	14844	0	76601001	4295880	
2350	236	4275113	1980-01-10	1980-01-10 00:00:00	38000275	0	\N	\N	15872	0	65200003	4275113	
2511	260	4107731	1990-09-15	1990-09-15 00:00:00	38000275	0	\N	\N	17227	0	180256009	4107731	
2805	273	4107731	1991-08-18	1991-08-18 00:00:00	38000275	0	\N	\N	18203	0	180256009	4107731	
2855	273	4107731	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	18214	0	180256009	4107731	
3126	307	4047491	2004-12-13	2004-12-13 00:00:00	38000275	0	\N	\N	20398	0	1225002	4047491	
3299	331	44783196	1942-09-29	1942-09-29 00:00:00	38000275	0	\N	\N	21813	0	699253003	44783196	
3483	338	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	22605	0	180256009	4107731	
3608	350	4125906	1999-05-10	1999-05-10 00:00:00	38000275	0	\N	\N	23294	0	288086009	4125906	
3844	376	4151422	1986-12-31	1986-12-31 00:00:00	38000275	0	\N	\N	24922	0	269911007	4151422	
3981	403	4145310	1968-08-29	1968-08-29 00:00:00	38000275	0	\N	\N	26463	0	268425006	4145310	
4165	406	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	26825	0	180256009	4107731	
16307	1418	4275113	1989-08-12	1989-08-12 00:00:00	38000275	0	\N	\N	94416	0	65200003	4275113	
4611	439	4170947	1993-04-08	1993-04-08 00:00:00	38000275	0	\N	\N	29153	0	274474001	4170947	
4805	449	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	29858	0	180256009	4107731	
4913	454	4078793	2008-03-22	2008-03-22 00:00:00	38000275	0	\N	\N	30301	0	180325003	4078793	
5113	476	4125906	1983-05-25	1983-05-25 00:00:00	38000275	0	\N	\N	31752	0	288086009	4125906	
5287	489	4107731	1990-12-09	1990-12-09 00:00:00	38000275	0	\N	\N	32761	0	180256009	4107731	
5475	502	4078793	2018-11-03	2018-11-03 00:00:00	38000275	0	\N	\N	33632	0	180325003	4078793	
5761	533	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	35460	0	180256009	4107731	
5848	534	4043071	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	35612	0	228557008	4043071	
6108	559	4043071	1976-12-21	1976-12-21 00:00:00	38000275	0	\N	\N	37047	0	228557008	4043071	
6236	576	4043071	1973-10-31	1973-10-31 00:00:00	38000275	0	\N	\N	38068	0	228557008	4043071	
6425	601	4107731	1992-08-30	1992-08-30 00:00:00	38000275	0	\N	\N	39781	0	180256009	4107731	
6596	603	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	39899	0	180256009	4107731	
6783	615	4191853	1990-01-06	1990-01-06 00:00:00	38000275	0	\N	\N	40867	0	395142003	4191853	
6984	642	4078793	2013-01-27	2013-01-27 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
7170	664	4107731	2013-03-19	2013-03-19 00:00:00	38000275	0	\N	\N	43848	0	180256009	4107731	
7344	680	4107731	1991-09-02	1991-09-02 00:00:00	38000275	0	\N	\N	45029	0	180256009	4107731	
7540	704	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	46568	0	180256009	4107731	
7770	711	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	47090	0	180256009	4107731	
7999	726	4293740	2004-09-01	2004-09-01 00:00:00	38000275	0	\N	\N	48093	0	384700001	4293740	
8096	742	4125906	1952-10-20	1952-10-20 00:00:00	38000275	0	\N	\N	49187	0	288086009	4125906	
8279	757	4078793	1986-03-30	1986-03-30 00:00:00	38000275	0	\N	\N	50273	0	180325003	4078793	
20388	1762	4035793	1996-03-28	1996-03-28 00:00:00	38000275	0	\N	\N	117825	0	15081005	4035793	
20657	1776	4078793	2007-11-03	2007-11-03 00:00:00	38000275	0	\N	\N	118840	0	180325003	4078793	
20783	1788	4125906	1990-07-21	1990-07-21 00:00:00	38000275	0	\N	\N	119834	0	288086009	4125906	
9080	836	4170947	1992-03-28	1992-03-28 00:00:00	38000275	0	\N	\N	55325	0	274474001	4170947	
9214	843	4107731	1996-11-02	1996-11-02 00:00:00	38000275	0	\N	\N	55813	0	180256009	4107731	
9469	863	4057420	1984-02-16	1984-02-16 00:00:00	38000275	0	\N	\N	57112	0	18286008	4057420	
21627	1870	4151422	1947-10-21	1947-10-21 00:00:00	38000275	0	\N	\N	124948	0	269911007	4151422	
9783	877	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	58376	0	180256009	4107731	
10037	895	4043071	1969-12-26	1969-12-26 00:00:00	38000275	0	\N	\N	59695	0	228557008	4043071	
10266	917	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	61078	0	180256009	4107731	
10336	917	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	61079	0	180256009	4107731	
10583	959	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	63764	0	180256009	4107731	
10845	978	4238715	1993-06-11	1993-06-11 00:00:00	38000275	0	\N	\N	65168	0	68254000	4238715	
10985	1018	4330583	2011-01-15	2011-01-15 00:00:00	38000275	0	\N	\N	67014	0	22523008	4330583	
11201	1036	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	68183	0	180256009	4107731	
11341	1057	4024289	1989-01-08	1989-01-08 00:00:00	38000275	0	\N	\N	69302	0	19490002	4024289	
23430	2054	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	136653	0	180256009	4107731	
11654	1082	4187458	2006-08-07	2006-08-07 00:00:00	38000275	0	\N	\N	70962	0	415300000	4187458	
11902	1091	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	71630	0	180256009	4107731	
53	5	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	432	0	180256009	4107731	
245	16	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	1182	0	180256009	4107731	
518	36	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	2518	0	180256009	4107731	
12537	1138	4107731	1994-12-08	1994-12-08 00:00:00	38000275	0	\N	\N	75013	0	180256009	4107731	
844	86	4125906	2001-04-20	2001-04-20 00:00:00	38000275	0	\N	\N	5793	0	288086009	4125906	
1028	99	4035793	2017-04-15	2017-04-15 00:00:00	38000275	0	\N	\N	6753	0	15081005	4035793	
1183	124	4107731	2000-06-20	2000-06-20 00:00:00	38000275	0	\N	\N	8206	0	180256009	4107731	
1449	137	4145310	1996-10-07	1996-10-07 00:00:00	38000275	0	\N	\N	9122	0	268425006	4145310	
1653	153	4043071	1959-01-22	1959-01-22 00:00:00	38000275	0	\N	\N	10353	0	228557008	4043071	
1734	155	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	10612	0	180256009	4107731	
1933	180	4199276	2004-05-06	2004-05-06 00:00:00	38000275	0	\N	\N	12162	0	301807007	4199276	
2145	220	4295880	2000-02-16	2000-02-16 00:00:00	38000275	0	\N	\N	14825	0	76601001	4295880	
2351	236	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	15856	0	180256009	4107731	
2512	260	4107731	1992-01-11	1992-01-11 00:00:00	38000275	0	\N	\N	17248	0	180256009	4107731	
14587	1306	4170947	1966-01-09	1966-01-09 00:00:00	38000275	0	\N	\N	86247	0	274474001	4170947	
2856	273	4107731	1992-08-30	1992-08-30 00:00:00	38000275	0	\N	\N	18237	0	180256009	4107731	
3127	307	4170947	2004-12-13	2004-12-13 00:00:00	38000275	0	\N	\N	20398	0	274474001	4170947	
3300	331	4151422	1968-01-10	1968-01-10 00:00:00	38000275	0	\N	\N	21782	0	269911007	4151422	
3484	338	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	22579	0	180256009	4107731	
3609	350	4058899	1970-11-03	1970-11-03 00:00:00	38000275	0	\N	\N	23290	0	168594001	4058899	
3845	376	4163872	1969-02-14	1969-02-14 00:00:00	38000275	0	\N	\N	24939	0	399208008	4163872	
3982	403	4195803	1991-08-29	1991-08-29 00:00:00	38000275	0	\N	\N	26465	0	312681000	4195803	
4172	408	4197460	1962-02-02	1962-02-02 00:00:00	38000275	0	\N	\N	26972	0	313191000	4197460	
16381	1425	4252419	1954-06-17	1954-06-17 00:00:00	38000275	0	\N	\N	94731	0	74016001	4252419	
4612	439	4125906	2002-10-18	2002-10-18 00:00:00	38000275	0	\N	\N	29154	0	288086009	4125906	
4806	449	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	29877	0	180256009	4107731	
4914	454	4078793	2017-03-11	2017-03-11 00:00:00	38000275	0	\N	\N	30333	0	180325003	4078793	
5114	476	4293740	1983-05-25	1983-05-25 00:00:00	38000275	0	\N	\N	31752	0	384700001	4293740	
5288	489	4197460	1977-10-19	1977-10-19 00:00:00	38000275	0	\N	\N	32703	0	313191000	4197460	
5482	505	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	33786	0	180256009	4107731	
5762	533	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	35431	0	180256009	4107731	
5849	534	4043071	1991-06-07	1991-06-07 00:00:00	38000275	0	\N	\N	35563	0	228557008	4043071	
6109	559	4043071	1976-11-23	1976-11-23 00:00:00	38000275	0	\N	\N	37076	0	228557008	4043071	
6237	576	4125906	1982-06-22	1982-06-22 00:00:00	38000275	0	\N	\N	38064	0	288086009	4125906	
6426	601	4107731	1992-06-07	1992-06-07 00:00:00	38000275	0	\N	\N	39707	0	180256009	4107731	
6597	603	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	40030	0	180256009	4107731	
6784	615	4125906	1991-05-06	1991-05-06 00:00:00	38000275	0	\N	\N	41043	0	288086009	4125906	
6985	642	4078793	2008-09-14	2008-09-14 00:00:00	38000275	0	\N	\N	42510	0	180325003	4078793	
7171	664	4107731	2010-09-07	2010-09-07 00:00:00	38000275	0	\N	\N	43805	0	180256009	4107731	
7345	680	4107731	1991-07-22	1991-07-22 00:00:00	38000275	0	\N	\N	45025	0	180256009	4107731	
7541	704	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	46518	0	180256009	4107731	
7771	711	4252419	1978-07-28	1978-07-28 00:00:00	38000275	0	\N	\N	47197	0	74016001	4252419	
8000	727	4125906	1969-08-25	1969-08-25 00:00:00	38000275	0	\N	\N	48206	0	288086009	4125906	
8097	742	4035793	1998-05-25	1998-05-25 00:00:00	38000275	0	\N	\N	49111	0	15081005	4035793	
8280	757	4151422	1990-05-21	1990-05-21 00:00:00	38000275	0	\N	\N	50183	0	269911007	4151422	
20389	1762	4035793	1990-02-22	1990-02-22 00:00:00	38000275	0	\N	\N	117874	0	15081005	4035793	
20658	1776	4078793	2015-12-19	2015-12-19 00:00:00	38000275	0	\N	\N	118882	0	180325003	4078793	
20784	1788	4202451	2018-05-24	2018-05-24 00:00:00	38000275	0	\N	\N	119803	0	433112001	4202451	
9081	836	4293740	1987-06-02	1987-06-02 00:00:00	38000275	0	\N	\N	55324	0	384700001	4293740	
9215	843	4107731	1998-04-11	1998-04-11 00:00:00	38000275	0	\N	\N	55850	0	180256009	4107731	
9470	863	4078793	2012-07-26	2012-07-26 00:00:00	38000275	0	\N	\N	57119	0	180325003	4078793	
21628	1870	4202451	1961-02-19	1961-02-19 00:00:00	38000275	0	\N	\N	124934	0	433112001	4202451	
9784	877	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	58400	0	180256009	4107731	
10038	895	4043071	1968-04-12	1968-04-12 00:00:00	38000275	0	\N	\N	59646	0	228557008	4043071	
10267	917	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	60925	0	180256009	4107731	
10337	917	4043071	1975-04-27	1975-04-27 00:00:00	38000275	0	\N	\N	60995	0	228557008	4043071	
10584	959	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	63743	0	180256009	4107731	
10846	978	4170947	1985-01-24	1985-01-24 00:00:00	38000275	0	\N	\N	65152	0	274474001	4170947	
10986	1018	4047491	1982-11-09	1982-11-09 00:00:00	38000275	0	\N	\N	67010	0	1225002	4047491	
11202	1036	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	68166	0	180256009	4107731	
11342	1057	4151422	2007-03-13	2007-03-13 00:00:00	38000275	0	\N	\N	69324	0	269911007	4151422	
23431	2054	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	136684	0	180256009	4107731	
11655	1082	4326177	2006-08-07	2006-08-07 00:00:00	38000275	0	\N	\N	70962	0	430193006	4326177	
11903	1091	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	71619	0	180256009	4107731	
54	5	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	423	0	180256009	4107731	
246	16	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	1231	0	180256009	4107731	
519	36	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	2496	0	180256009	4107731	
12538	1138	4107731	1994-12-29	1994-12-29 00:00:00	38000275	0	\N	\N	75097	0	180256009	4107731	
893	90	4151422	1987-06-06	1987-06-06 00:00:00	38000275	0	\N	\N	6049	0	269911007	4151422	
1029	99	4035793	2016-04-09	2016-04-09 00:00:00	38000275	0	\N	\N	6769	0	15081005	4035793	
1184	124	4107731	1997-06-24	1997-06-24 00:00:00	38000275	0	\N	\N	8320	0	180256009	4107731	
1450	137	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	9173	0	180256009	4107731	
1654	153	4145310	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	10332	0	268425006	4145310	
1735	155	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	10564	0	180256009	4107731	
1934	180	4107731	1992-07-02	1992-07-02 00:00:00	38000275	0	\N	\N	12183	0	180256009	4107731	
2146	220	4295880	2001-11-14	2001-11-14 00:00:00	38000275	0	\N	\N	14858	0	76601001	4295880	
2352	236	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	15864	0	180256009	4107731	
2513	260	4107731	1992-02-22	1992-02-22 00:00:00	38000275	0	\N	\N	17249	0	180256009	4107731	
14588	1306	4125906	2001-12-20	2001-12-20 00:00:00	38000275	0	\N	\N	86203	0	288086009	4125906	
2857	273	4191853	1976-09-25	1976-09-25 00:00:00	38000275	0	\N	\N	18193	0	395142003	4191853	
3128	307	4163872	1994-08-08	1994-08-08 00:00:00	38000275	0	\N	\N	20397	0	399208008	4163872	
3301	331	4151422	1998-05-31	1998-05-31 00:00:00	38000275	0	\N	\N	21823	0	269911007	4151422	
3485	338	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	22509	0	180256009	4107731	
3610	350	4293740	1965-05-19	1965-05-19 00:00:00	38000275	0	\N	\N	23289	0	384700001	4293740	
3846	376	4170947	1969-02-14	1969-02-14 00:00:00	38000275	0	\N	\N	24939	0	274474001	4170947	
3983	403	4047491	1991-08-29	1991-08-29 00:00:00	38000275	0	\N	\N	26465	0	1225002	4047491	
4173	408	4163872	2003-04-27	2003-04-27 00:00:00	38000275	0	\N	\N	26990	0	399208008	4163872	
16382	1425	4125906	1947-08-09	1947-08-09 00:00:00	38000275	0	\N	\N	94723	0	288086009	4125906	
4613	440	4295880	1995-05-03	1995-05-03 00:00:00	38000275	0	\N	\N	29174	0	76601001	4295880	
4807	449	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	29911	0	395142003	4191853	
4915	454	4151422	1961-08-01	1961-08-01 00:00:00	38000275	0	\N	\N	30348	0	269911007	4151422	
5122	479	4125906	2011-11-15	2011-11-15 00:00:00	38000275	0	\N	\N	31962	0	288086009	4125906	
5289	489	4107731	1990-04-01	1990-04-01 00:00:00	38000275	0	\N	\N	32719	0	180256009	4107731	
5483	505	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	33866	0	180256009	4107731	
5763	533	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	35459	0	180256009	4107731	
5850	534	4043071	1988-08-12	1988-08-12 00:00:00	38000275	0	\N	\N	35600	0	228557008	4043071	
6110	559	4125906	1974-02-22	1974-02-22 00:00:00	38000275	0	\N	\N	37096	0	288086009	4125906	
6238	576	4293740	1982-06-22	1982-06-22 00:00:00	38000275	0	\N	\N	38064	0	384700001	4293740	
6427	601	4107731	1990-10-07	1990-10-07 00:00:00	38000275	0	\N	\N	39762	0	180256009	4107731	
6598	603	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	39892	0	180256009	4107731	
6785	615	4107731	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	40942	0	180256009	4107731	
6986	642	4057420	2016-01-17	2016-01-17 00:00:00	38000275	0	\N	\N	42516	0	18286008	4057420	
7172	664	4107731	2013-02-26	2013-02-26 00:00:00	38000275	0	\N	\N	43910	0	180256009	4107731	
7346	680	4107731	1991-11-25	1991-11-25 00:00:00	38000275	0	\N	\N	45031	0	180256009	4107731	
7542	704	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	46578	0	180256009	4107731	
7772	711	4163951	1967-01-29	1967-01-29 00:00:00	38000275	0	\N	\N	47196	0	29303009	4163951	
8001	727	4243062	1998-01-16	1998-01-16 00:00:00	38000275	0	\N	\N	48220	0	60027007	4243062	
8098	742	4035793	2013-12-23	2013-12-23 00:00:00	38000275	0	\N	\N	49186	0	15081005	4035793	
8281	757	4078793	1991-05-19	1991-05-19 00:00:00	38000275	0	\N	\N	50267	0	180325003	4078793	
20390	1762	4035793	2002-01-31	2002-01-31 00:00:00	38000275	0	\N	\N	117821	0	15081005	4035793	
20659	1776	4078793	2014-12-13	2014-12-13 00:00:00	38000275	0	\N	\N	118874	0	180325003	4078793	
20785	1788	4125906	1999-05-26	1999-05-26 00:00:00	38000275	0	\N	\N	119835	0	288086009	4125906	
9082	836	4125906	1987-06-02	1987-06-02 00:00:00	38000275	0	\N	\N	55324	0	288086009	4125906	
9216	843	4107731	1998-06-13	1998-06-13 00:00:00	38000275	0	\N	\N	55783	0	180256009	4107731	
9471	863	4078793	2018-02-15	2018-02-15 00:00:00	38000275	0	\N	\N	57204	0	180325003	4078793	
21629	1870	4125906	1953-01-25	1953-01-25 00:00:00	38000275	0	\N	\N	124946	0	288086009	4125906	
9785	877	4107731	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	58434	0	180256009	4107731	
10039	895	4043071	1968-07-05	1968-07-05 00:00:00	38000275	0	\N	\N	59668	0	228557008	4043071	
10268	917	4043071	1974-02-17	1974-02-17 00:00:00	38000275	0	\N	\N	60931	0	228557008	4043071	
10338	917	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	61081	0	180256009	4107731	
10585	959	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	63785	0	180256009	4107731	
22628	1976	4107731	1996-12-16	1996-12-16 00:00:00	38000275	0	\N	\N	131442	0	180256009	4107731	
10987	1018	4170947	1982-11-09	1982-11-09 00:00:00	38000275	0	\N	\N	67010	0	274474001	4170947	
11203	1036	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	68223	0	180256009	4107731	
11343	1058	4107731	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	69492	0	180256009	4107731	
23432	2054	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	136649	0	180256009	4107731	
11656	1082	4107731	1992-11-21	1992-11-21 00:00:00	38000275	0	\N	\N	71050	0	180256009	4107731	
11904	1091	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	71610	0	180256009	4107731	
55	5	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	503	0	180256009	4107731	
247	16	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	1192	0	180256009	4107731	
520	36	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	2497	0	180256009	4107731	
12539	1138	4107731	1994-06-02	1994-06-02 00:00:00	38000275	0	\N	\N	75108	0	180256009	4107731	
894	90	4010253	1970-08-09	1970-08-09 00:00:00	38000275	0	\N	\N	5989	0	112790001	4010253	
1030	99	4323902	2014-10-25	2014-10-25 00:00:00	38000275	0	\N	\N	6780	0	429609002	4323902	
1185	124	4107731	1999-02-01	1999-02-01 00:00:00	38000275	0	\N	\N	8252	0	180256009	4107731	
1451	137	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	9162	0	395142003	4191853	
1655	153	4043071	1959-11-19	1959-11-19 00:00:00	38000275	0	\N	\N	10394	0	228557008	4043071	
1736	155	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	10508	0	180256009	4107731	
1935	180	4107731	1991-12-05	1991-12-05 00:00:00	38000275	0	\N	\N	12193	0	180256009	4107731	
2147	220	4295880	2001-02-14	2001-02-14 00:00:00	38000275	0	\N	\N	14846	0	76601001	4295880	
2353	236	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	15904	0	180256009	4107731	
2514	260	4107731	1990-11-17	1990-11-17 00:00:00	38000275	0	\N	\N	17277	0	180256009	4107731	
14589	1306	4125906	1980-06-29	1980-06-29 00:00:00	38000275	0	\N	\N	86201	0	288086009	4125906	
2858	273	4107731	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	18238	0	180256009	4107731	
3129	307	4170947	1994-08-08	1994-08-08 00:00:00	38000275	0	\N	\N	20397	0	274474001	4170947	
3302	332	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	21989	0	180256009	4107731	
3486	338	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	22533	0	180256009	4107731	
3611	350	4125906	1965-05-19	1965-05-19 00:00:00	38000275	0	\N	\N	23289	0	288086009	4125906	
3847	376	4047491	1965-04-06	1965-04-06 00:00:00	38000275	0	\N	\N	24938	0	1225002	4047491	
3984	403	4170947	1991-08-29	1991-08-29 00:00:00	38000275	0	\N	\N	26465	0	274474001	4170947	
4174	409	4058899	1965-05-20	1965-05-20 00:00:00	38000275	0	\N	\N	27150	0	168594001	4058899	
16383	1425	44783196	1954-06-24	1954-06-24 00:00:00	38000275	0	\N	\N	94795	0	699253003	44783196	
4614	440	4295880	1996-01-31	1996-01-31 00:00:00	38000275	0	\N	\N	29175	0	76601001	4295880	
4808	449	4198190	1968-10-27	1968-10-27 00:00:00	38000275	0	\N	\N	29952	0	80146002	4198190	
4916	454	4057420	2019-03-23	2019-03-23 00:00:00	38000275	0	\N	\N	30318	0	18286008	4057420	
5123	479	4195803	2016-09-03	2016-09-03 00:00:00	38000275	0	\N	\N	31963	0	312681000	4195803	
5290	489	4107731	1991-09-29	1991-09-29 00:00:00	38000275	0	\N	\N	32825	0	180256009	4107731	
5484	505	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	33775	0	180256009	4107731	
5764	533	4170947	1963-06-27	1963-06-27 00:00:00	38000275	0	\N	\N	35367	0	274474001	4170947	
5851	534	4043071	1989-01-26	1989-01-26 00:00:00	38000275	0	\N	\N	35558	0	228557008	4043071	
6111	559	4170947	1981-01-07	1981-01-07 00:00:00	38000275	0	\N	\N	37097	0	274474001	4170947	
6239	576	4197460	2000-10-31	2000-10-31 00:00:00	38000275	0	\N	\N	38088	0	313191000	4197460	
6428	601	4107731	1991-06-16	1991-06-16 00:00:00	38000275	0	\N	\N	39702	0	180256009	4107731	
6624	605	4151422	1987-03-09	1987-03-09 00:00:00	38000275	0	\N	\N	40184	0	269911007	4151422	
6786	615	4107731	1990-12-29	1990-12-29 00:00:00	38000275	0	\N	\N	40935	0	180256009	4107731	
6987	642	4125906	1949-12-11	1949-12-11 00:00:00	38000275	0	\N	\N	42462	0	288086009	4125906	
7173	664	4107731	2013-11-26	2013-11-26 00:00:00	38000275	0	\N	\N	43913	0	180256009	4107731	
7347	680	4107731	1990-07-09	1990-07-09 00:00:00	38000275	0	\N	\N	44997	0	180256009	4107731	
7543	704	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	46585	0	180256009	4107731	
7773	711	42535580	1967-01-29	1967-01-29 00:00:00	38000275	0	\N	\N	47196	0	426701000119108	42535580	
8002	727	4170947	1998-01-16	1998-01-16 00:00:00	38000275	0	\N	\N	48220	0	274474001	4170947	
8099	742	4078793	2013-12-23	2013-12-23 00:00:00	38000275	0	\N	\N	49186	0	180325003	4078793	
8282	757	4078793	1976-01-11	1976-01-11 00:00:00	38000275	0	\N	\N	50264	0	180325003	4078793	
20391	1762	4057420	2002-01-31	2002-01-31 00:00:00	38000275	0	\N	\N	117821	0	18286008	4057420	
20660	1776	4057420	2003-10-11	2003-10-11 00:00:00	38000275	0	\N	\N	118838	0	18286008	4057420	
20786	1789	4191853	1976-03-06	1976-03-06 00:00:00	38000275	0	\N	\N	119926	0	395142003	4191853	
9083	836	4275113	2004-07-02	2004-07-02 00:00:00	38000275	0	\N	\N	55315	0	65200003	4275113	
9217	843	4107731	1996-12-14	1996-12-14 00:00:00	38000275	0	\N	\N	55777	0	180256009	4107731	
9472	863	4078793	1991-03-28	1991-03-28 00:00:00	38000275	0	\N	\N	57137	0	180325003	4078793	
21637	1874	4125906	1978-05-18	1978-05-18 00:00:00	38000275	0	\N	\N	125103	0	288086009	4125906	
9786	877	4191853	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	58446	0	395142003	4191853	
10040	895	4043071	1967-05-05	1967-05-05 00:00:00	38000275	0	\N	\N	59679	0	228557008	4043071	
10269	917	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	61026	0	180256009	4107731	
10339	917	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	61087	0	180256009	4107731	
10586	959	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	63790	0	180256009	4107731	
22629	1976	4107731	1998-08-17	1998-08-17 00:00:00	38000275	0	\N	\N	131456	0	180256009	4107731	
10988	1018	4170947	1972-11-01	1972-11-01 00:00:00	38000275	0	\N	\N	67009	0	274474001	4170947	
11204	1036	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	68116	0	180256009	4107731	
11344	1058	4107731	1990-12-29	1990-12-29 00:00:00	38000275	0	\N	\N	69467	0	180256009	4107731	
23433	2054	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	136573	0	180256009	4107731	
11657	1082	4107731	1993-05-08	1993-05-08 00:00:00	38000275	0	\N	\N	70990	0	180256009	4107731	
11905	1091	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	71737	0	180256009	4107731	
56	5	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	415	0	180256009	4107731	
248	16	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	1221	0	180256009	4107731	
521	36	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	2547	0	180256009	4107731	
12540	1138	4107731	1995-07-27	1995-07-27 00:00:00	38000275	0	\N	\N	75081	0	180256009	4107731	
895	90	4170947	1975-11-10	1975-11-10 00:00:00	38000275	0	\N	\N	5997	0	274474001	4170947	
1031	99	4125906	2004-07-28	2004-07-28 00:00:00	38000275	0	\N	\N	6731	0	288086009	4125906	
1186	124	4107731	1998-11-09	1998-11-09 00:00:00	38000275	0	\N	\N	8219	0	180256009	4107731	
1452	137	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	9157	0	180256009	4107731	
1656	153	4043071	1959-09-24	1959-09-24 00:00:00	38000275	0	\N	\N	10363	0	228557008	4043071	
1737	155	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	10515	0	180256009	4107731	
1936	180	4107731	1991-12-26	1991-12-26 00:00:00	38000275	0	\N	\N	12138	0	180256009	4107731	
2148	220	4295880	2000-08-16	2000-08-16 00:00:00	38000275	0	\N	\N	14799	0	76601001	4295880	
2354	236	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	15928	0	180256009	4107731	
2515	260	4107731	1990-03-31	1990-03-31 00:00:00	38000275	0	\N	\N	17275	0	180256009	4107731	
14665	1309	4125906	1989-12-09	1989-12-09 00:00:00	38000275	0	\N	\N	86449	0	288086009	4125906	
2859	273	4191853	1993-07-11	1993-07-11 00:00:00	38000275	0	\N	\N	18241	0	395142003	4191853	
3130	308	4330583	1999-07-18	1999-07-18 00:00:00	38000275	0	\N	\N	20415	0	22523008	4330583	
3303	332	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	21966	0	180256009	4107731	
3487	338	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	22535	0	180256009	4107731	
3612	350	42535580	1995-09-11	1995-09-11 00:00:00	38000275	0	\N	\N	23293	0	426701000119108	42535580	
3848	376	4170947	1965-04-06	1965-04-06 00:00:00	38000275	0	\N	\N	24938	0	274474001	4170947	
3985	403	4078793	2000-02-07	2000-02-07 00:00:00	38000275	0	\N	\N	26526	0	180325003	4078793	
4175	409	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	27017	0	180256009	4107731	
16384	1425	4125906	1938-06-13	1938-06-13 00:00:00	38000275	0	\N	\N	94722	0	288086009	4125906	
4615	440	4295880	1994-10-29	1994-10-29 00:00:00	38000275	0	\N	\N	29194	0	76601001	4295880	
4809	449	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	29876	0	180256009	4107731	
4917	454	4078793	2013-02-09	2013-02-09 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
5124	479	4243062	2016-09-03	2016-09-03 00:00:00	38000275	0	\N	\N	31963	0	60027007	4243062	
5291	489	4107731	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	32729	0	180256009	4107731	
5485	505	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	33772	0	180256009	4107731	
5765	533	4047491	1963-06-27	1963-06-27 00:00:00	38000275	0	\N	\N	35367	0	1225002	4047491	
5852	534	4043071	1990-05-18	1990-05-18 00:00:00	38000275	0	\N	\N	35517	0	228557008	4043071	
6112	559	4024289	1981-01-07	1981-01-07 00:00:00	38000275	0	\N	\N	37097	0	19490002	4024289	
6240	576	4043071	1973-09-26	1973-09-26 00:00:00	38000275	0	\N	\N	38067	0	228557008	4043071	
6429	601	4107731	1992-02-23	1992-02-23 00:00:00	38000275	0	\N	\N	39780	0	180256009	4107731	
6625	605	4125906	1982-11-26	1982-11-26 00:00:00	38000275	0	\N	\N	40162	0	288086009	4125906	
6787	615	4107731	1993-04-17	1993-04-17 00:00:00	38000275	0	\N	\N	40958	0	180256009	4107731	
6988	642	4125906	2010-12-20	2010-12-20 00:00:00	38000275	0	\N	\N	42574	0	288086009	4125906	
7174	664	4107731	2013-11-05	2013-11-05 00:00:00	38000275	0	\N	\N	43900	0	180256009	4107731	
7348	680	4107731	1991-08-12	1991-08-12 00:00:00	38000275	0	\N	\N	44989	0	180256009	4107731	
7544	704	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	46630	0	180256009	4107731	
7774	711	4163971	1967-01-29	1967-01-29 00:00:00	38000275	0	\N	\N	47196	0	45595009	4163971	
8003	727	4195803	1991-04-23	1991-04-23 00:00:00	38000275	0	\N	\N	48209	0	312681000	4195803	
8100	742	4035793	1988-11-07	1988-11-07 00:00:00	38000275	0	\N	\N	49121	0	15081005	4035793	
8283	757	4078793	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	50247	0	180325003	4078793	
20392	1762	4078793	2015-04-16	2015-04-16 00:00:00	38000275	0	\N	\N	117834	0	180325003	4078793	
20661	1776	4252419	2018-04-17	2018-04-17 00:00:00	38000275	0	\N	\N	118776	0	74016001	4252419	
20787	1789	4151422	1988-04-21	1988-04-21 00:00:00	38000275	0	\N	\N	119862	0	269911007	4151422	
9084	836	4125906	1985-03-30	1985-03-30 00:00:00	38000275	0	\N	\N	55323	0	288086009	4125906	
9218	844	4107731	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	55896	0	180256009	4107731	
9473	863	4151422	2018-02-10	2018-02-10 00:00:00	38000275	0	\N	\N	57144	0	269911007	4151422	
21638	1874	4151422	1982-04-29	1982-04-29 00:00:00	38000275	0	\N	\N	125129	0	269911007	4151422	
9787	877	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	58419	0	180256009	4107731	
10041	895	4043071	1967-09-29	1967-09-29 00:00:00	38000275	0	\N	\N	59644	0	228557008	4043071	
10270	917	4043071	1974-12-29	1974-12-29 00:00:00	38000275	0	\N	\N	60935	0	228557008	4043071	
10340	917	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	61034	0	180256009	4107731	
10587	959	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	63677	0	180256009	4107731	
22630	1976	4107731	1996-07-22	1996-07-22 00:00:00	38000275	0	\N	\N	131433	0	180256009	4107731	
10989	1018	4163872	1972-11-01	1972-11-01 00:00:00	38000275	0	\N	\N	67009	0	399208008	4163872	
11205	1036	4058899	1983-10-22	1983-10-22 00:00:00	38000275	0	\N	\N	68136	0	168594001	4058899	
11345	1058	4107731	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	69427	0	180256009	4107731	
23434	2054	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	136638	0	180256009	4107731	
11658	1082	4107731	1992-02-01	1992-02-01 00:00:00	38000275	0	\N	\N	70953	0	180256009	4107731	
11906	1091	4151422	1989-02-04	1989-02-04 00:00:00	38000275	0	\N	\N	71681	0	269911007	4151422	
57	5	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	418	0	180256009	4107731	
249	16	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	1195	0	180256009	4107731	
522	36	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	2618	0	180256009	4107731	
12541	1138	4043071	1994-04-28	1994-04-28 00:00:00	38000275	0	\N	\N	75027	0	228557008	4043071	
896	90	4047491	1975-11-10	1975-11-10 00:00:00	38000275	0	\N	\N	5997	0	1225002	4047491	
1032	99	4195803	2011-09-11	2011-09-11 00:00:00	38000275	0	\N	\N	6732	0	312681000	4195803	
1187	124	4107731	1997-12-29	1997-12-29 00:00:00	38000275	0	\N	\N	8215	0	180256009	4107731	
1453	137	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	9165	0	180256009	4107731	
1657	153	4043071	1958-06-05	1958-06-05 00:00:00	38000275	0	\N	\N	10349	0	228557008	4043071	
1738	155	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	10610	0	180256009	4107731	
1937	180	4107731	1992-11-26	1992-11-26 00:00:00	38000275	0	\N	\N	12155	0	180256009	4107731	
2149	220	4295880	1999-05-19	1999-05-19 00:00:00	38000275	0	\N	\N	14857	0	76601001	4295880	
2355	236	4195803	1983-12-29	1983-12-29 00:00:00	38000275	0	\N	\N	15915	0	312681000	4195803	
2516	260	4170947	2015-04-08	2015-04-08 00:00:00	38000275	0	\N	\N	17175	0	274474001	4170947	
14666	1309	4163951	1994-03-21	1994-03-21 00:00:00	38000275	0	\N	\N	86444	0	29303009	4163951	
2860	273	4107731	1990-02-18	1990-02-18 00:00:00	38000275	0	\N	\N	18197	0	180256009	4107731	
3131	310	4151422	1972-09-08	1972-09-08 00:00:00	38000275	0	\N	\N	20504	0	269911007	4151422	
3304	332	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	21943	0	180256009	4107731	
3488	338	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	22499	0	180256009	4107731	
3613	350	4202832	1995-09-11	1995-09-11 00:00:00	38000275	0	\N	\N	23293	0	52765003	4202832	
3849	376	4125906	1977-12-29	1977-12-29 00:00:00	38000275	0	\N	\N	24940	0	288086009	4125906	
3986	403	4078793	2006-03-13	2006-03-13 00:00:00	38000275	0	\N	\N	26470	0	180325003	4078793	
4176	409	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	27077	0	180256009	4107731	
16385	1426	4125906	2009-09-27	2009-09-27 00:00:00	38000275	0	\N	\N	94877	0	288086009	4125906	
4616	440	4295880	1995-11-01	1995-11-01 00:00:00	38000275	0	\N	\N	29188	0	76601001	4295880	
4810	449	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	29860	0	180256009	4107731	
4918	454	4057420	2017-09-23	2017-09-23 00:00:00	38000275	0	\N	\N	\N	0	18286008	4057420	
5125	479	4170947	2016-09-03	2016-09-03 00:00:00	38000275	0	\N	\N	31963	0	274474001	4170947	
5292	489	4107731	1992-02-02	1992-02-02 00:00:00	38000275	0	\N	\N	32727	0	180256009	4107731	
5486	505	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	33822	0	180256009	4107731	
5766	533	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	35408	0	180256009	4107731	
5853	534	4043071	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	35566	0	228557008	4043071	
6122	563	4107731	1993-03-28	1993-03-28 00:00:00	38000275	0	\N	\N	37205	0	180256009	4107731	
6241	576	4043071	1974-01-30	1974-01-30 00:00:00	38000275	0	\N	\N	38119	0	228557008	4043071	
6430	601	4107731	1993-01-24	1993-01-24 00:00:00	38000275	0	\N	\N	39709	0	180256009	4107731	
6626	605	4151422	1961-03-22	1961-03-22 00:00:00	38000275	0	\N	\N	40115	0	269911007	4151422	
6788	615	4151422	1914-01-03	1914-01-03 00:00:00	38000275	0	\N	\N	41002	0	269911007	4151422	
6989	642	4078793	2011-10-02	2011-10-02 00:00:00	38000275	0	\N	\N	42483	0	180325003	4078793	
7175	664	4293740	2007-05-20	2007-05-20 00:00:00	38000275	0	\N	\N	43891	0	384700001	4293740	
7349	680	4107731	1990-12-03	1990-12-03 00:00:00	38000275	0	\N	\N	44964	0	180256009	4107731	
7545	704	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	46620	0	180256009	4107731	
7775	711	4202832	1967-01-29	1967-01-29 00:00:00	38000275	0	\N	\N	47196	0	52765003	4202832	
8004	727	4170947	1991-04-23	1991-04-23 00:00:00	38000275	0	\N	\N	48209	0	274474001	4170947	
8101	742	4035793	1994-05-02	1994-05-02 00:00:00	38000275	0	\N	\N	49179	0	15081005	4035793	
8284	757	4078793	1998-06-28	1998-06-28 00:00:00	38000275	0	\N	\N	50231	0	180325003	4078793	
20393	1762	4035793	2015-04-16	2015-04-16 00:00:00	38000275	0	\N	\N	117834	0	15081005	4035793	
20662	1776	4078793	2010-11-20	2010-11-20 00:00:00	38000275	0	\N	\N	118872	0	180325003	4078793	
20788	1789	4125906	1978-11-08	1978-11-08 00:00:00	38000275	0	\N	\N	119897	0	288086009	4125906	
9085	836	44805732	2003-07-27	2003-07-27 00:00:00	38000275	0	\N	\N	55330	0	755621000000101	44805732	
9219	844	4107731	1990-11-17	1990-11-17 00:00:00	38000275	0	\N	\N	55957	0	180256009	4107731	
9474	863	4202451	2014-07-03	2014-07-03 00:00:00	38000275	0	\N	\N	57181	0	433112001	4202451	
21639	1874	4125906	1987-04-15	1987-04-15 00:00:00	38000275	0	\N	\N	125104	0	288086009	4125906	
9788	877	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	58379	0	180256009	4107731	
10042	895	4043071	1969-01-31	1969-01-31 00:00:00	38000275	0	\N	\N	59733	0	228557008	4043071	
10271	917	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	61074	0	180256009	4107731	
10341	917	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	61020	0	180256009	4107731	
10588	959	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	63768	0	180256009	4107731	
22631	1976	4107731	1996-10-14	1996-10-14 00:00:00	38000275	0	\N	\N	131437	0	180256009	4107731	
10993	1022	4057420	2010-02-09	2010-02-09 00:00:00	38000275	0	\N	\N	67211	0	18286008	4057420	
11206	1036	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	68140	0	180256009	4107731	
11346	1058	4107731	1990-03-10	1990-03-10 00:00:00	38000275	0	\N	\N	69385	0	180256009	4107731	
23435	2054	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	136647	0	180256009	4107731	
11659	1082	4107731	1991-02-09	1991-02-09 00:00:00	38000275	0	\N	\N	71001	0	180256009	4107731	
11907	1091	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	71659	0	180256009	4107731	
58	5	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	524	0	180256009	4107731	
250	16	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	1282	0	180256009	4107731	
523	36	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	2620	0	180256009	4107731	
12542	1138	4043071	1994-09-01	1994-09-01 00:00:00	38000275	0	\N	\N	75095	0	228557008	4043071	
897	90	4010253	1985-08-25	1985-08-25 00:00:00	38000275	0	\N	\N	6018	0	112790001	4010253	
1033	99	4047491	2011-09-11	2011-09-11 00:00:00	38000275	0	\N	\N	6732	0	1225002	4047491	
1188	124	4107731	1998-02-09	1998-02-09 00:00:00	38000275	0	\N	\N	8216	0	180256009	4107731	
1454	137	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	9220	0	180256009	4107731	
1658	153	4043071	1959-04-23	1959-04-23 00:00:00	38000275	0	\N	\N	10360	0	228557008	4043071	
1739	155	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	10569	0	180256009	4107731	
1938	180	4107731	1990-05-17	1990-05-17 00:00:00	38000275	0	\N	\N	12152	0	180256009	4107731	
2150	220	4295880	2001-05-16	2001-05-16 00:00:00	38000275	0	\N	\N	14800	0	76601001	4295880	
2356	236	4243062	1983-12-29	1983-12-29 00:00:00	38000275	0	\N	\N	15915	0	60027007	4243062	
2517	260	4024289	2015-04-08	2015-04-08 00:00:00	38000275	0	\N	\N	17175	0	19490002	4024289	
14667	1309	4163971	1994-03-22	1994-03-22 00:00:00	38000275	0	\N	\N	86444	0	45595009	4163971	
2861	273	4107731	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	18259	0	180256009	4107731	
3132	310	4125906	2002-07-15	2002-07-15 00:00:00	38000275	0	\N	\N	20498	0	288086009	4125906	
3305	332	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	22045	0	180256009	4107731	
3489	338	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	22603	0	180256009	4107731	
3614	350	4163951	1995-09-11	1995-09-11 00:00:00	38000275	0	\N	\N	23293	0	29303009	4163951	
3850	377	4125906	1977-08-04	1977-08-04 00:00:00	38000275	0	\N	\N	24966	0	288086009	4125906	
3987	403	4078793	1994-01-03	1994-01-03 00:00:00	38000275	0	\N	\N	26429	0	180325003	4078793	
4177	409	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	27074	0	180256009	4107731	
16386	1426	4125906	1984-07-19	1984-07-19 00:00:00	38000275	0	\N	\N	94874	0	288086009	4125906	
4617	440	4295880	1995-08-02	1995-08-02 00:00:00	38000275	0	\N	\N	29201	0	76601001	4295880	
4811	449	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	29977	0	180256009	4107731	
4919	454	4057420	2012-04-14	2012-04-14 00:00:00	38000275	0	\N	\N	30317	0	18286008	4057420	
5126	479	4125906	1967-12-15	1967-12-15 00:00:00	38000275	0	\N	\N	31854	0	288086009	4125906	
5293	489	4107731	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	32808	0	180256009	4107731	
5487	505	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	33755	0	180256009	4107731	
5767	533	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	35479	0	180256009	4107731	
5854	534	4043071	1988-07-15	1988-07-15 00:00:00	38000275	0	\N	\N	35556	0	228557008	4043071	
6123	563	4107731	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	37207	0	180256009	4107731	
6242	576	4043071	1974-05-01	1974-05-01 00:00:00	38000275	0	\N	\N	38113	0	228557008	4043071	
6431	601	4107731	1992-05-17	1992-05-17 00:00:00	38000275	0	\N	\N	39749	0	180256009	4107731	
6627	605	4125906	1997-05-02	1997-05-02 00:00:00	38000275	0	\N	\N	40163	0	288086009	4125906	
6789	615	4107731	1990-05-12	1990-05-12 00:00:00	38000275	0	\N	\N	40870	0	180256009	4107731	
6990	642	4057420	2010-09-26	2010-09-26 00:00:00	38000275	0	\N	\N	42511	0	18286008	4057420	
7176	664	4125906	2007-05-20	2007-05-20 00:00:00	38000275	0	\N	\N	43891	0	288086009	4125906	
7350	680	4107731	1992-01-27	1992-01-27 00:00:00	38000275	0	\N	\N	45026	0	180256009	4107731	
7546	704	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	46615	0	180256009	4107731	
7776	711	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	47111	0	395142003	4191853	
8005	727	4024289	1991-04-23	1991-04-23 00:00:00	38000275	0	\N	\N	48209	0	19490002	4024289	
8102	742	4151422	1926-06-10	1926-06-10 00:00:00	38000275	0	\N	\N	49104	0	269911007	4151422	
8285	757	4078793	1977-01-16	1977-01-16 00:00:00	38000275	0	\N	\N	50242	0	180325003	4078793	
20394	1762	4035793	2013-04-04	2013-04-04 00:00:00	38000275	0	\N	\N	117833	0	15081005	4035793	
20663	1776	4078793	2009-11-14	2009-11-14 00:00:00	38000275	0	\N	\N	118892	0	180325003	4078793	
20789	1789	4058899	1991-11-21	1991-11-21 00:00:00	38000275	0	\N	\N	119906	0	168594001	4058899	
9086	836	4059978	1999-07-25	1999-07-25 00:00:00	38000275	0	\N	\N	55283	0	169553002	4059978	
9220	844	4107731	1992-08-29	1992-08-29 00:00:00	38000275	0	\N	\N	55915	0	180256009	4107731	
9475	863	4151422	1932-07-23	1932-07-23 00:00:00	38000275	0	\N	\N	57199	0	269911007	4151422	
21650	1878	4125906	1980-12-04	1980-12-04 00:00:00	38000275	0	\N	\N	125348	0	288086009	4125906	
9789	877	4191853	1978-06-07	1978-06-07 00:00:00	38000275	0	\N	\N	58348	0	395142003	4191853	
10043	895	4043071	1967-10-27	1967-10-27 00:00:00	38000275	0	\N	\N	59652	0	228557008	4043071	
10272	917	4043071	1974-04-28	1974-04-28 00:00:00	38000275	0	\N	\N	61045	0	228557008	4043071	
10342	917	4043071	1976-09-12	1976-09-12 00:00:00	38000275	0	\N	\N	61013	0	228557008	4043071	
10589	959	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	63685	0	180256009	4107731	
22632	1976	4107731	1998-11-09	1998-11-09 00:00:00	38000275	0	\N	\N	131404	0	180256009	4107731	
10994	1022	40492359	2010-02-09	2010-02-09 00:00:00	38000275	0	\N	\N	67211	0	447365002	40492359	
11207	1036	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	68181	0	180256009	4107731	
11347	1058	4107731	1991-07-06	1991-07-06 00:00:00	38000275	0	\N	\N	69437	0	180256009	4107731	
23436	2054	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	136645	0	180256009	4107731	
11660	1082	4107731	1990-03-31	1990-03-31 00:00:00	38000275	0	\N	\N	70997	0	180256009	4107731	
11908	1091	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	71625	0	180256009	4107731	
59	5	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	457	0	180256009	4107731	
251	16	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	1169	0	180256009	4107731	
524	36	4191853	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	2539	0	395142003	4191853	
12543	1138	4107731	1995-09-28	1995-09-28 00:00:00	38000275	0	\N	\N	75102	0	180256009	4107731	
898	90	4125906	1980-09-19	1980-09-19 00:00:00	38000275	0	\N	\N	5999	0	288086009	4125906	
1034	99	4170947	2011-09-11	2011-09-11 00:00:00	38000275	0	\N	\N	6732	0	274474001	4170947	
1189	124	4107731	1999-11-01	1999-11-01 00:00:00	38000275	0	\N	\N	8255	0	180256009	4107731	
1455	137	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	9142	0	180256009	4107731	
1659	153	4043071	1957-08-08	1957-08-08 00:00:00	38000275	0	\N	\N	10375	0	228557008	4043071	
1740	155	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	10609	0	180256009	4107731	
1939	180	4107731	1992-12-17	1992-12-17 00:00:00	38000275	0	\N	\N	12143	0	180256009	4107731	
2151	220	4151422	1990-01-12	1990-01-12 00:00:00	38000275	0	\N	\N	14864	0	269911007	4151422	
2357	236	4170947	1983-12-29	1983-12-29 00:00:00	38000275	0	\N	\N	15915	0	274474001	4170947	
2518	260	4107731	1992-10-10	1992-10-10 00:00:00	38000275	0	\N	\N	17251	0	180256009	4107731	
14668	1309	4202832	1994-03-22	1994-03-22 00:00:00	38000275	0	\N	\N	86444	0	52765003	4202832	
2862	273	4107731	1991-01-20	1991-01-20 00:00:00	38000275	0	\N	\N	18218	0	180256009	4107731	
3133	310	4293740	1981-06-14	1981-06-14 00:00:00	38000275	0	\N	\N	20497	0	384700001	4293740	
3306	332	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	21972	0	180256009	4107731	
3490	338	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	22497	0	180256009	4107731	
3615	350	4163971	1995-09-11	1995-09-11 00:00:00	38000275	0	\N	\N	23293	0	45595009	4163971	
3851	377	4057420	1996-11-07	1996-11-07 00:00:00	38000275	0	\N	\N	24997	0	18286008	4057420	
3988	403	4078793	1999-02-01	1999-02-01 00:00:00	38000275	0	\N	\N	26461	0	180325003	4078793	
4178	409	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	27142	0	180256009	4107731	
16387	1426	4047491	2007-10-08	2007-10-08 00:00:00	38000275	0	\N	\N	94876	0	1225002	4047491	
4618	440	4295880	1995-02-01	1995-02-01 00:00:00	38000275	0	\N	\N	29187	0	76601001	4295880	
4812	449	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	29939	0	180256009	4107731	
4920	454	4151422	1961-09-08	1961-09-08 00:00:00	38000275	0	\N	\N	30349	0	269911007	4151422	
5127	479	4151422	1964-03-23	1964-03-23 00:00:00	38000275	0	\N	\N	31877	0	269911007	4151422	
5294	489	4107731	1992-04-26	1992-04-26 00:00:00	38000275	0	\N	\N	32733	0	180256009	4107731	
5488	505	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	33766	0	180256009	4107731	
5768	533	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	35409	0	180256009	4107731	
5855	534	4043071	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	35561	0	228557008	4043071	
6124	563	4107731	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	37297	0	180256009	4107731	
6243	576	4043071	1974-07-03	1974-07-03 00:00:00	38000275	0	\N	\N	38120	0	228557008	4043071	
6432	601	4107731	1990-06-03	1990-06-03 00:00:00	38000275	0	\N	\N	39658	0	180256009	4107731	
6628	605	4293740	1997-05-02	1997-05-02 00:00:00	38000275	0	\N	\N	40163	0	384700001	4293740	
6790	615	4107731	1992-04-04	1992-04-04 00:00:00	38000275	0	\N	\N	40980	0	180256009	4107731	
6992	644	4151422	1984-09-22	1984-09-22 00:00:00	38000275	0	\N	\N	42656	0	269911007	4151422	
7177	664	4107731	2013-05-21	2013-05-21 00:00:00	38000275	0	\N	\N	43912	0	180256009	4107731	
7351	680	4107731	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	44967	0	180256009	4107731	
7547	704	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	46627	0	180256009	4107731	
7777	711	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	47174	0	180256009	4107731	
8006	727	4195803	1993-04-23	1993-04-23 00:00:00	38000275	0	\N	\N	48159	0	312681000	4195803	
8103	742	4035793	2009-07-27	2009-07-27 00:00:00	38000275	0	\N	\N	49184	0	15081005	4035793	
8286	757	4057420	1992-05-24	1992-05-24 00:00:00	38000275	0	\N	\N	50248	0	18286008	4057420	
20395	1762	4057420	2013-04-04	2013-04-04 00:00:00	38000275	0	\N	\N	117833	0	18286008	4057420	
20664	1776	4078793	2004-10-16	2004-10-16 00:00:00	38000275	0	\N	\N	118880	0	180325003	4078793	
20790	1789	4062501	1979-03-05	1979-03-05 00:00:00	38000275	0	\N	\N	119860	0	171231001	4062501	
9099	841	4198190	1961-01-14	1961-01-14 00:00:00	38000275	0	\N	\N	55546	0	80146002	4198190	
9221	844	4107731	1990-10-06	1990-10-06 00:00:00	38000275	0	\N	\N	55994	0	180256009	4107731	
9476	863	4078793	2017-08-24	2017-08-24 00:00:00	38000275	0	\N	\N	57230	0	180325003	4078793	
21651	1878	4293740	1980-12-04	1980-12-04 00:00:00	38000275	0	\N	\N	125348	0	384700001	4293740	
9790	877	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	58421	0	180256009	4107731	
10044	895	4043071	1968-11-01	1968-11-01 00:00:00	38000275	0	\N	\N	59669	0	228557008	4043071	
10273	917	4043071	1976-10-17	1976-10-17 00:00:00	38000275	0	\N	\N	61014	0	228557008	4043071	
10343	917	4043071	1975-09-21	1975-09-21 00:00:00	38000275	0	\N	\N	60937	0	228557008	4043071	
10590	959	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	63714	0	180256009	4107731	
22633	1976	4295880	1998-06-15	1998-06-15 00:00:00	38000275	0	\N	\N	131392	0	76601001	4295880	
22815	1982	4163872	2004-05-01	2004-05-01 00:00:00	38000275	0	\N	\N	131962	0	399208008	4163872	
11208	1036	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	68198	0	180256009	4107731	
11348	1058	4107731	1990-06-02	1990-06-02 00:00:00	38000275	0	\N	\N	69446	0	180256009	4107731	
23437	2054	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	136672	0	180256009	4107731	
11661	1082	4107731	1990-04-21	1990-04-21 00:00:00	38000275	0	\N	\N	70912	0	180256009	4107731	
11909	1091	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	71611	0	180256009	4107731	
60	5	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	514	0	180256009	4107731	
252	16	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	1283	0	180256009	4107731	
525	36	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	2650	0	180256009	4107731	
12544	1138	4107731	1993-11-04	1993-11-04 00:00:00	38000275	0	\N	\N	74985	0	180256009	4107731	
12731	1143	4047491	1983-11-26	1983-11-26 00:00:00	38000275	0	\N	\N	75457	0	1225002	4047491	
1040	101	4170947	2011-05-08	2011-05-08 00:00:00	38000275	0	\N	\N	6943	0	274474001	4170947	
1190	124	4191853	1987-04-02	1987-04-02 00:00:00	38000275	0	\N	\N	8296	0	395142003	4191853	
1456	137	4125906	2007-04-13	2007-04-13 00:00:00	38000275	0	\N	\N	9123	0	288086009	4125906	
1660	153	4043071	1957-09-05	1957-09-05 00:00:00	38000275	0	\N	\N	10406	0	228557008	4043071	
1741	155	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	10568	0	180256009	4107731	
1940	180	4107731	1992-02-06	1992-02-06 00:00:00	38000275	0	\N	\N	12139	0	180256009	4107731	
2152	220	4295880	1998-11-18	1998-11-18 00:00:00	38000275	0	\N	\N	14843	0	76601001	4295880	
2358	236	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	15932	0	180256009	4107731	
2519	260	4107731	1992-02-01	1992-02-01 00:00:00	38000275	0	\N	\N	17233	0	180256009	4107731	
14669	1309	42535580	1994-03-21	1994-03-21 00:00:00	38000275	0	\N	\N	86444	0	426701000119108	42535580	
2863	273	4107731	1993-05-09	1993-05-09 00:00:00	38000275	0	\N	\N	18211	0	180256009	4107731	
3134	310	4125906	1981-06-14	1981-06-14 00:00:00	38000275	0	\N	\N	20497	0	288086009	4125906	
3307	332	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	21920	0	180256009	4107731	
3491	338	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	22578	0	180256009	4107731	
3616	351	4295880	2001-01-23	2001-01-23 00:00:00	38000275	0	\N	\N	23363	0	76601001	4295880	
3852	377	40492359	1996-11-07	1996-11-07 00:00:00	38000275	0	\N	\N	24997	0	447365002	40492359	
3989	403	4125906	1939-10-10	1939-10-10 00:00:00	38000275	0	\N	\N	26536	0	288086009	4125906	
4179	409	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	27140	0	180256009	4107731	
16388	1426	4195803	2007-10-08	2007-10-08 00:00:00	38000275	0	\N	\N	94876	0	312681000	4195803	
4622	442	4191853	1993-07-10	1993-07-10 00:00:00	38000275	0	\N	\N	29416	0	395142003	4191853	
4813	449	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	29980	0	180256009	4107731	
4921	454	4078793	2015-02-28	2015-02-28 00:00:00	38000275	0	\N	\N	30332	0	180325003	4078793	
5128	479	4125906	1955-12-27	1955-12-27 00:00:00	38000275	0	\N	\N	31853	0	288086009	4125906	
5295	489	4107731	1993-03-28	1993-03-28 00:00:00	38000275	0	\N	\N	32801	0	180256009	4107731	
5489	505	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	33768	0	180256009	4107731	
5769	533	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	35401	0	180256009	4107731	
5856	534	4043071	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	35620	0	228557008	4043071	
6125	563	4107731	1991-12-01	1991-12-01 00:00:00	38000275	0	\N	\N	37218	0	180256009	4107731	
6244	576	4043071	1974-06-05	1974-06-05 00:00:00	38000275	0	\N	\N	38114	0	228557008	4043071	
6433	601	4107731	1991-05-05	1991-05-05 00:00:00	38000275	0	\N	\N	39665	0	180256009	4107731	
6629	606	4151422	2004-02-20	2004-02-20 00:00:00	38000275	0	\N	\N	40243	0	269911007	4151422	
6791	615	4107731	1990-10-27	1990-10-27 00:00:00	38000275	0	\N	\N	41063	0	180256009	4107731	
6993	644	4151422	1980-09-26	1980-09-26 00:00:00	38000275	0	\N	\N	42643	0	269911007	4151422	
7178	664	4107731	2013-01-15	2013-01-15 00:00:00	38000275	0	\N	\N	43909	0	180256009	4107731	
7352	680	4107731	1992-12-07	1992-12-07 00:00:00	38000275	0	\N	\N	45072	0	180256009	4107731	
7548	704	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	46566	0	180256009	4107731	
7778	711	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	47183	0	180256009	4107731	
8007	727	4170947	1974-03-23	1974-03-23 00:00:00	38000275	0	\N	\N	48207	0	274474001	4170947	
8104	742	4078793	2009-07-27	2009-07-27 00:00:00	38000275	0	\N	\N	49184	0	180325003	4078793	
8287	757	4125906	1978-09-22	1978-09-22 00:00:00	38000275	0	\N	\N	50288	0	288086009	4125906	
20396	1762	4057420	2014-04-10	2014-04-10 00:00:00	38000275	0	\N	\N	117812	0	18286008	4057420	
20665	1776	4078793	2005-10-22	2005-10-22 00:00:00	38000275	0	\N	\N	118839	0	180325003	4078793	
20791	1789	4197460	1976-02-22	1976-02-22 00:00:00	38000275	0	\N	\N	119896	0	313191000	4197460	
9100	841	4197460	1966-01-02	1966-01-02 00:00:00	38000275	0	\N	\N	55509	0	313191000	4197460	
9222	844	4107731	1991-07-27	1991-07-27 00:00:00	38000275	0	\N	\N	55982	0	180256009	4107731	
9477	863	4078793	2006-06-22	2006-06-22 00:00:00	38000275	0	\N	\N	57228	0	180325003	4078793	
21652	1878	4010253	1998-04-15	1998-04-15 00:00:00	38000275	0	\N	\N	125329	0	112790001	4010253	
9791	877	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	58462	0	180256009	4107731	
10045	895	4043071	1969-07-25	1969-07-25 00:00:00	38000275	0	\N	\N	59693	0	228557008	4043071	
10274	917	4043071	1975-07-27	1975-07-27 00:00:00	38000275	0	\N	\N	61068	0	228557008	4043071	
10344	917	4043071	1975-11-23	1975-11-23 00:00:00	38000275	0	\N	\N	61069	0	228557008	4043071	
10591	959	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	63725	0	180256009	4107731	
22634	1976	4107731	1998-05-25	1998-05-25 00:00:00	38000275	0	\N	\N	131454	0	180256009	4107731	
22816	1982	4170947	2004-05-01	2004-05-01 00:00:00	38000275	0	\N	\N	131962	0	274474001	4170947	
11209	1036	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	68157	0	180256009	4107731	
11349	1058	4107731	1992-02-01	1992-02-01 00:00:00	38000275	0	\N	\N	69491	0	180256009	4107731	
23438	2054	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	136686	0	180256009	4107731	
11662	1082	4107731	1990-03-10	1990-03-10 00:00:00	38000275	0	\N	\N	70911	0	180256009	4107731	
11910	1091	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	71632	0	180256009	4107731	
61	5	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	403	0	180256009	4107731	
253	16	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	1247	0	180256009	4107731	
526	36	4078793	2018-01-09	2018-01-09 00:00:00	38000275	0	\N	\N	2600	0	180325003	4078793	
12545	1138	4043071	1997-07-10	1997-07-10 00:00:00	38000275	0	\N	\N	74997	0	228557008	4043071	
12732	1143	4170947	1983-11-26	1983-11-26 00:00:00	38000275	0	\N	\N	75457	0	274474001	4170947	
1041	101	4195803	2011-05-08	2011-05-08 00:00:00	38000275	0	\N	\N	6943	0	312681000	4195803	
1191	124	4107731	2000-08-01	2000-08-01 00:00:00	38000275	0	\N	\N	8276	0	180256009	4107731	
1457	137	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	9143	0	180256009	4107731	
1661	153	4043071	1958-10-23	1958-10-23 00:00:00	38000275	0	\N	\N	10372	0	228557008	4043071	
1742	155	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	10576	0	180256009	4107731	
1941	180	4107731	1991-10-24	1991-10-24 00:00:00	38000275	0	\N	\N	12128	0	180256009	4107731	
2153	220	4295880	2000-11-15	2000-11-15 00:00:00	38000275	0	\N	\N	14827	0	76601001	4295880	
2359	236	4186930	1984-01-05	1984-01-05 00:00:00	38000275	0	\N	\N	15814	0	46706006	4186930	
2520	260	4107731	1993-03-27	1993-03-27 00:00:00	38000275	0	\N	\N	17216	0	180256009	4107731	
14670	1309	4047491	1958-04-12	1958-04-12 00:00:00	38000275	0	\N	\N	86447	0	1225002	4047491	
2864	273	4107731	1992-02-02	1992-02-02 00:00:00	38000275	0	\N	\N	18316	0	180256009	4107731	
3135	310	4243062	1961-11-26	1961-11-26 00:00:00	38000275	0	\N	\N	20496	0	60027007	4243062	
3308	332	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	22039	0	180256009	4107731	
3492	338	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	22538	0	180256009	4107731	
3617	351	4295880	1998-10-27	1998-10-27 00:00:00	38000275	0	\N	\N	23359	0	76601001	4295880	
3854	379	4145310	1977-02-16	1977-02-16 00:00:00	38000275	0	\N	\N	25065	0	268425006	4145310	
3990	403	4078793	2013-04-22	2013-04-22 00:00:00	38000275	0	\N	\N	26506	0	180325003	4078793	
4180	409	4151422	2011-11-17	2011-11-17 00:00:00	38000275	0	\N	\N	27012	0	269911007	4151422	
16389	1426	4170947	2007-10-08	2007-10-08 00:00:00	38000275	0	\N	\N	94876	0	274474001	4170947	
4623	442	4107731	1990-09-15	1990-09-15 00:00:00	38000275	0	\N	\N	29402	0	180256009	4107731	
4814	449	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	29975	0	180256009	4107731	
4922	454	4125906	1943-03-20	1943-03-20 00:00:00	38000275	0	\N	\N	30271	0	288086009	4125906	
5129	479	4293740	1955-12-27	1955-12-27 00:00:00	38000275	0	\N	\N	31853	0	384700001	4293740	
5296	489	4107731	1990-12-30	1990-12-30 00:00:00	38000275	0	\N	\N	32722	0	180256009	4107731	
5490	505	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	33788	0	180256009	4107731	
5770	533	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	35405	0	180256009	4107731	
5857	534	4043071	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	35524	0	228557008	4043071	
6126	563	4107731	1992-08-09	1992-08-09 00:00:00	38000275	0	\N	\N	37203	0	180256009	4107731	
6246	578	4197460	1967-12-27	1967-12-27 00:00:00	38000275	0	\N	\N	38192	0	313191000	4197460	
6434	601	4107731	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	39662	0	180256009	4107731	
6630	606	4151422	1978-07-27	1978-07-27 00:00:00	38000275	0	\N	\N	40260	0	269911007	4151422	
6792	615	4107731	1991-04-13	1991-04-13 00:00:00	38000275	0	\N	\N	41005	0	180256009	4107731	
6994	644	4125906	1976-10-16	1976-10-16 00:00:00	38000275	0	\N	\N	42665	0	288086009	4125906	
7179	664	4107731	2011-01-11	2011-01-11 00:00:00	38000275	0	\N	\N	43919	0	180256009	4107731	
7353	680	4107731	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	44988	0	180256009	4107731	
7549	704	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	46621	0	180256009	4107731	
7779	711	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	47117	0	180256009	4107731	
8008	727	4047491	1974-03-23	1974-03-23 00:00:00	38000275	0	\N	\N	48207	0	1225002	4047491	
8105	742	4035793	2002-06-17	2002-06-17 00:00:00	38000275	0	\N	\N	49103	0	15081005	4035793	
8288	757	4078793	1981-02-08	1981-02-08 00:00:00	38000275	0	\N	\N	50270	0	180325003	4078793	
20397	1762	4035793	2014-04-10	2014-04-10 00:00:00	38000275	0	\N	\N	117812	0	15081005	4035793	
20666	1776	4125906	1945-04-23	1945-04-23 00:00:00	38000275	0	\N	\N	118803	0	288086009	4125906	
20807	1791	4151422	1975-04-25	1975-04-25 00:00:00	38000275	0	\N	\N	120101	0	269911007	4151422	
9101	842	4035793	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	55679	0	15081005	4035793	
9223	844	4107731	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	55889	0	180256009	4107731	
9478	863	4078793	1993-04-08	1993-04-08 00:00:00	38000275	0	\N	\N	57138	0	180325003	4078793	
21653	1878	4198190	2004-03-09	2004-03-09 00:00:00	38000275	0	\N	\N	125350	0	80146002	4198190	
9792	877	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	58432	0	180256009	4107731	
10046	895	4151422	1989-12-28	1989-12-28 00:00:00	38000275	0	\N	\N	59698	0	269911007	4151422	
10275	917	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	61004	0	180256009	4107731	
10345	917	4043071	1974-01-20	1974-01-20 00:00:00	38000275	0	\N	\N	60993	0	228557008	4043071	
10592	959	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	63722	0	180256009	4107731	
22635	1976	4295880	1999-12-13	1999-12-13 00:00:00	38000275	0	\N	\N	131394	0	76601001	4295880	
22817	1982	4170947	1997-02-07	1997-02-07 00:00:00	38000275	0	\N	\N	131961	0	274474001	4170947	
11210	1036	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	68117	0	395142003	4191853	
11350	1058	4107731	1993-05-29	1993-05-29 00:00:00	38000275	0	\N	\N	69426	0	180256009	4107731	
23439	2054	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	136606	0	180256009	4107731	
11663	1082	4107731	1991-09-07	1991-09-07 00:00:00	38000275	0	\N	\N	70917	0	180256009	4107731	
11911	1091	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	71654	0	180256009	4107731	
62	5	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	443	0	180256009	4107731	
254	16	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	1266	0	180256009	4107731	
527	36	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	2645	0	180256009	4107731	
12546	1138	4107731	1996-03-14	1996-03-14 00:00:00	38000275	0	\N	\N	75110	0	180256009	4107731	
12733	1143	4125906	1979-11-12	1979-11-12 00:00:00	38000275	0	\N	\N	75455	0	288086009	4125906	
1042	101	4047491	2011-05-08	2011-05-08 00:00:00	38000275	0	\N	\N	6943	0	1225002	4047491	
1192	124	4107731	1999-10-12	1999-10-12 00:00:00	38000275	0	\N	\N	8330	0	180256009	4107731	
1458	137	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	9191	0	180256009	4107731	
1662	153	4043071	1957-11-07	1957-11-07 00:00:00	38000275	0	\N	\N	10369	0	228557008	4043071	
1743	155	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	10608	0	180256009	4107731	
1942	180	4107731	1992-08-13	1992-08-13 00:00:00	38000275	0	\N	\N	12184	0	180256009	4107731	
2154	220	4295880	1999-02-17	1999-02-17 00:00:00	38000275	0	\N	\N	14811	0	76601001	4295880	
2360	236	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	15828	0	395142003	4191853	
2521	260	4107731	1991-05-25	1991-05-25 00:00:00	38000275	0	\N	\N	17245	0	180256009	4107731	
14671	1309	4170947	1958-04-12	1958-04-12 00:00:00	38000275	0	\N	\N	86447	0	274474001	4170947	
2865	273	4107731	1992-05-17	1992-05-17 00:00:00	38000275	0	\N	\N	18206	0	180256009	4107731	
3136	310	4170947	1961-11-26	1961-11-26 00:00:00	38000275	0	\N	\N	20496	0	274474001	4170947	
3309	332	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	21971	0	180256009	4107731	
3493	338	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	22536	0	180256009	4107731	
3618	351	4295880	1998-04-28	1998-04-28 00:00:00	38000275	0	\N	\N	23417	0	76601001	4295880	
3855	379	4151422	2014-06-12	2014-06-12 00:00:00	38000275	0	\N	\N	25059	0	269911007	4151422	
3991	403	4078793	1998-01-26	1998-01-26 00:00:00	38000275	0	\N	\N	26441	0	180325003	4078793	
4181	409	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	27042	0	180256009	4107731	
16390	1426	4047491	2005-10-18	2005-10-18 00:00:00	38000275	0	\N	\N	94875	0	1225002	4047491	
4624	442	4107731	1990-03-31	1990-03-31 00:00:00	38000275	0	\N	\N	29337	0	180256009	4107731	
4815	449	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	29895	0	180256009	4107731	
4923	455	4170947	1960-02-11	1960-02-11 00:00:00	38000275	0	\N	\N	30467	0	274474001	4170947	
5130	479	4330583	1981-10-25	1981-10-25 00:00:00	38000275	0	\N	\N	31938	0	22523008	4330583	
5297	489	4107731	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	32732	0	180256009	4107731	
5491	505	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	33753	0	180256009	4107731	
5771	533	4163872	1979-07-24	1979-07-24 00:00:00	38000275	0	\N	\N	35369	0	399208008	4163872	
5858	534	4043071	1988-09-16	1988-09-16 00:00:00	38000275	0	\N	\N	35607	0	228557008	4043071	
6127	563	4107731	1992-06-28	1992-06-28 00:00:00	38000275	0	\N	\N	37202	0	180256009	4107731	
6247	578	4125906	2005-10-27	2005-10-27 00:00:00	38000275	0	\N	\N	38260	0	288086009	4125906	
6435	601	4107731	1991-02-10	1991-02-10 00:00:00	38000275	0	\N	\N	39663	0	180256009	4107731	
6631	606	4163872	1992-01-19	1992-01-19 00:00:00	38000275	0	\N	\N	40238	0	399208008	4163872	
6793	615	4107731	1993-02-13	1993-02-13 00:00:00	38000275	0	\N	\N	40984	0	180256009	4107731	
6995	644	4151422	1989-06-02	1989-06-02 00:00:00	38000275	0	\N	\N	42612	0	269911007	4151422	
7180	664	4107731	2012-07-10	2012-07-10 00:00:00	38000275	0	\N	\N	43908	0	180256009	4107731	
7354	680	4107731	1992-08-03	1992-08-03 00:00:00	38000275	0	\N	\N	44974	0	180256009	4107731	
7550	704	4191853	1986-12-25	1986-12-25 00:00:00	38000275	0	\N	\N	46535	0	395142003	4191853	
7780	711	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	47095	0	180256009	4107731	
8009	727	4195803	1974-03-23	1974-03-23 00:00:00	38000275	0	\N	\N	48207	0	312681000	4195803	
8106	742	4035793	1982-10-04	1982-10-04 00:00:00	38000275	0	\N	\N	49113	0	15081005	4035793	
8289	757	4057420	1987-04-05	1987-04-05 00:00:00	38000275	0	\N	\N	50245	0	18286008	4057420	
20403	1764	44783196	2008-12-08	2008-12-08 00:00:00	38000275	0	\N	\N	117994	0	699253003	44783196	
20667	1776	4078793	2019-01-05	2019-01-05 00:00:00	38000275	0	\N	\N	118842	0	180325003	4078793	
20808	1791	4151422	1988-06-07	1988-06-07 00:00:00	38000275	0	\N	\N	120023	0	269911007	4151422	
9102	842	4035793	1985-04-06	1985-04-06 00:00:00	38000275	0	\N	\N	55667	0	15081005	4035793	
9224	844	4107731	1993-03-27	1993-03-27 00:00:00	38000275	0	\N	\N	55897	0	180256009	4107731	
9479	863	4078793	1990-03-22	1990-03-22 00:00:00	38000275	0	\N	\N	57184	0	180325003	4078793	
21654	1879	4151422	1980-05-12	1980-05-12 00:00:00	38000275	0	\N	\N	125371	0	269911007	4151422	
9793	877	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	58353	0	180256009	4107731	
10047	895	4043071	1968-05-10	1968-05-10 00:00:00	38000275	0	\N	\N	59653	0	228557008	4043071	
10276	917	4043071	1974-08-04	1974-08-04 00:00:00	38000275	0	\N	\N	60994	0	228557008	4043071	
10346	917	4043071	1976-05-16	1976-05-16 00:00:00	38000275	0	\N	\N	61012	0	228557008	4043071	
10593	959	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	63772	0	180256009	4107731	
22636	1976	4107731	1997-10-06	1997-10-06 00:00:00	38000275	0	\N	\N	131452	0	180256009	4107731	
22818	1982	4163872	1997-02-07	1997-02-07 00:00:00	38000275	0	\N	\N	131961	0	399208008	4163872	
11211	1036	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	68219	0	180256009	4107731	
11351	1058	4107731	1992-04-25	1992-04-25 00:00:00	38000275	0	\N	\N	69493	0	180256009	4107731	
23440	2054	4151422	1987-01-11	1987-01-11 00:00:00	38000275	0	\N	\N	136640	0	269911007	4151422	
11664	1082	4107731	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	71041	0	180256009	4107731	
11912	1091	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	71634	0	180256009	4107731	
63	5	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	417	0	180256009	4107731	
255	16	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	1183	0	180256009	4107731	
528	36	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	2510	0	180256009	4107731	
12547	1138	4107731	1993-09-23	1993-09-23 00:00:00	38000275	0	\N	\N	75064	0	180256009	4107731	
12734	1143	4058899	1976-01-02	1976-01-02 00:00:00	38000275	0	\N	\N	75454	0	168594001	4058899	
1043	101	4181917	1986-11-04	1986-11-04 00:00:00	38000275	0	\N	\N	6899	0	54550000	4181917	
1193	124	4107731	1998-05-26	1998-05-26 00:00:00	38000275	0	\N	\N	8191	0	180256009	4107731	
1459	137	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	9201	0	180256009	4107731	
1663	153	4043071	1958-08-14	1958-08-14 00:00:00	38000275	0	\N	\N	10351	0	228557008	4043071	
1744	155	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	10622	0	180256009	4107731	
1943	180	4107731	1993-09-16	1993-09-16 00:00:00	38000275	0	\N	\N	12146	0	180256009	4107731	
2155	220	4293740	1985-03-19	1985-03-19 00:00:00	38000275	0	\N	\N	14836	0	384700001	4293740	
2361	236	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	15884	0	180256009	4107731	
2522	260	4107731	1992-04-04	1992-04-04 00:00:00	38000275	0	\N	\N	17250	0	180256009	4107731	
14672	1309	4125906	2018-07-25	2018-07-25 00:00:00	38000275	0	\N	\N	86445	0	288086009	4125906	
2866	273	4107731	1993-03-28	1993-03-28 00:00:00	38000275	0	\N	\N	18210	0	180256009	4107731	
3137	310	4125906	2014-03-05	2014-03-05 00:00:00	38000275	0	\N	\N	20499	0	288086009	4125906	
3310	332	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	22038	0	180256009	4107731	
3494	338	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	22515	0	180256009	4107731	
3619	351	4295880	2003-04-22	2003-04-22 00:00:00	38000275	0	\N	\N	23403	0	76601001	4295880	
3856	380	4043071	1984-01-11	1984-01-11 00:00:00	38000275	0	\N	\N	25135	0	228557008	4043071	
3992	403	4078793	1995-01-09	1995-01-09 00:00:00	38000275	0	\N	\N	26488	0	180325003	4078793	
4182	409	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	27076	0	180256009	4107731	
16391	1426	4195803	2005-10-18	2005-10-18 00:00:00	38000275	0	\N	\N	94875	0	312681000	4195803	
4625	442	4107731	1990-07-14	1990-07-14 00:00:00	38000275	0	\N	\N	29284	0	180256009	4107731	
4816	449	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	29881	0	180256009	4107731	
4924	455	4047491	1960-02-11	1960-02-11 00:00:00	38000275	0	\N	\N	30467	0	1225002	4047491	
5131	480	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	31998	0	180256009	4107731	
5298	489	4191853	1990-01-07	1990-01-07 00:00:00	38000275	0	\N	\N	32817	0	395142003	4191853	
5492	505	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	33820	0	180256009	4107731	
5772	533	4170947	1979-07-24	1979-07-24 00:00:00	38000275	0	\N	\N	35369	0	274474001	4170947	
5859	534	4043071	1989-04-28	1989-04-28 00:00:00	38000275	0	\N	\N	35595	0	228557008	4043071	
6128	563	4107731	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	37259	0	180256009	4107731	
6248	578	4151422	1969-02-21	1969-02-21 00:00:00	38000275	0	\N	\N	38265	0	269911007	4151422	
6436	601	4107731	1990-06-24	1990-06-24 00:00:00	38000275	0	\N	\N	39735	0	180256009	4107731	
6632	606	4170947	1992-01-19	1992-01-19 00:00:00	38000275	0	\N	\N	40238	0	274474001	4170947	
6794	615	4107731	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	40941	0	180256009	4107731	
6996	644	4047491	1982-09-29	1982-09-29 00:00:00	38000275	0	\N	\N	42666	0	1225002	4047491	
7181	664	4107731	2013-07-23	2013-07-23 00:00:00	38000275	0	\N	\N	43856	0	180256009	4107731	
7355	680	4107731	1991-12-16	1991-12-16 00:00:00	38000275	0	\N	\N	44972	0	180256009	4107731	
7551	704	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	46613	0	180256009	4107731	
7781	711	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	47091	0	180256009	4107731	
8010	727	4125906	2013-10-24	2013-10-24 00:00:00	38000275	0	\N	\N	48221	0	288086009	4125906	
8107	742	4035793	1991-04-15	1991-04-15 00:00:00	38000275	0	\N	\N	49209	0	15081005	4035793	
8290	757	4078793	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	50268	0	180325003	4078793	
20404	1764	4252419	2008-12-01	2008-12-01 00:00:00	38000275	0	\N	\N	117992	0	74016001	4252419	
20668	1776	4057420	2017-12-30	2017-12-30 00:00:00	38000275	0	\N	\N	118883	0	18286008	4057420	
20809	1791	4163872	1995-07-08	1995-07-08 00:00:00	38000275	0	\N	\N	120057	0	399208008	4163872	
9103	842	4035793	1994-06-25	1994-06-25 00:00:00	38000275	0	\N	\N	55750	0	15081005	4035793	
9225	844	4107731	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	55976	0	180256009	4107731	
9480	863	4078793	2001-05-24	2001-05-24 00:00:00	38000275	0	\N	\N	57187	0	180325003	4078793	
21655	1879	4058899	1994-11-25	1994-11-25 00:00:00	38000275	0	\N	\N	125382	0	168594001	4058899	
9794	877	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	58459	0	180256009	4107731	
10048	895	4043071	1969-04-04	1969-04-04 00:00:00	38000275	0	\N	\N	59649	0	228557008	4043071	
10277	917	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	61021	0	180256009	4107731	
10347	917	4043071	1973-10-21	1973-10-21 00:00:00	38000275	0	\N	\N	60954	0	228557008	4043071	
10594	959	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	63773	0	180256009	4107731	
22637	1976	4107731	1997-04-21	1997-04-21 00:00:00	38000275	0	\N	\N	131350	0	180256009	4107731	
22819	1982	4195803	1997-02-07	1997-02-07 00:00:00	38000275	0	\N	\N	131961	0	312681000	4195803	
11212	1036	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	68200	0	180256009	4107731	
11352	1058	4107731	1990-03-31	1990-03-31 00:00:00	38000275	0	\N	\N	69464	0	180256009	4107731	
23441	2054	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	136681	0	180256009	4107731	
11665	1082	4151422	1959-09-29	1959-09-29 00:00:00	38000275	0	\N	\N	71008	0	269911007	4151422	
11913	1091	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	71655	0	180256009	4107731	
64	5	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	513	0	180256009	4107731	
256	16	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	1186	0	180256009	4107731	
529	36	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	2649	0	180256009	4107731	
12548	1138	4107731	1993-03-18	1993-03-18 00:00:00	38000275	0	\N	\N	75063	0	180256009	4107731	
12735	1143	4151422	1999-07-18	1999-07-18 00:00:00	38000275	0	\N	\N	75419	0	269911007	4151422	
1044	101	4058899	2014-07-21	2014-07-21 00:00:00	38000275	0	\N	\N	6944	0	168594001	4058899	
1194	124	4107731	2000-07-11	2000-07-11 00:00:00	38000275	0	\N	\N	8199	0	180256009	4107731	
1460	137	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	9148	0	180256009	4107731	
1664	153	4043071	1958-04-03	1958-04-03 00:00:00	38000275	0	\N	\N	10377	0	228557008	4043071	
1745	155	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	10551	0	180256009	4107731	
1944	180	4107731	1993-04-01	1993-04-01 00:00:00	38000275	0	\N	\N	12186	0	180256009	4107731	
2156	220	4125906	1985-03-19	1985-03-19 00:00:00	38000275	0	\N	\N	14836	0	288086009	4125906	
2362	236	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	15827	0	180256009	4107731	
2523	260	4107731	1990-07-14	1990-07-14 00:00:00	38000275	0	\N	\N	17161	0	180256009	4107731	
14673	1309	4125906	1964-01-11	1964-01-11 00:00:00	38000275	0	\N	\N	86448	0	288086009	4125906	
2867	273	4107731	1991-09-29	1991-09-29 00:00:00	38000275	0	\N	\N	18204	0	180256009	4107731	
3138	310	4125906	1955-02-17	1955-02-17 00:00:00	38000275	0	\N	\N	20495	0	288086009	4125906	
3311	332	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	22018	0	180256009	4107731	
3495	338	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	22537	0	180256009	4107731	
3620	351	4295880	2005-01-18	2005-01-18 00:00:00	38000275	0	\N	\N	23422	0	76601001	4295880	
3857	380	4043071	1983-12-14	1983-12-14 00:00:00	38000275	0	\N	\N	25127	0	228557008	4043071	
3993	403	4037675	1999-02-08	1999-02-08 00:00:00	38000275	0	\N	\N	26500	0	162676008	4037675	
4183	409	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	27028	0	180256009	4107731	
16392	1426	4170947	2005-10-18	2005-10-18 00:00:00	38000275	0	\N	\N	94875	0	274474001	4170947	
4626	442	4107731	1992-10-10	1992-10-10 00:00:00	38000275	0	\N	\N	29380	0	180256009	4107731	
4817	449	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	29896	0	180256009	4107731	
4925	455	4198190	1977-01-25	1977-01-25 00:00:00	38000275	0	\N	\N	30394	0	80146002	4198190	
5132	480	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	32107	0	180256009	4107731	
5299	489	4107731	1990-02-18	1990-02-18 00:00:00	38000275	0	\N	\N	32718	0	180256009	4107731	
5493	505	4197460	1983-09-14	1983-09-14 00:00:00	38000275	0	\N	\N	33828	0	313191000	4197460	
5773	533	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	35461	0	180256009	4107731	
5860	534	4043071	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	35505	0	228557008	4043071	
6129	563	4107731	1991-10-20	1991-10-20 00:00:00	38000275	0	\N	\N	37217	0	180256009	4107731	
6249	578	4058899	1970-01-15	1970-01-15 00:00:00	38000275	0	\N	\N	38193	0	168594001	4058899	
6437	601	4107731	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	39669	0	180256009	4107731	
6633	607	4163872	1954-07-27	1954-07-27 00:00:00	38000275	0	\N	\N	40297	0	399208008	4163872	
6795	615	4107731	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	40981	0	180256009	4107731	
6997	644	4170947	1982-09-29	1982-09-29 00:00:00	38000275	0	\N	\N	42666	0	274474001	4170947	
7182	664	4107731	2011-08-30	2011-08-30 00:00:00	38000275	0	\N	\N	43810	0	180256009	4107731	
7359	682	4293740	1983-04-12	1983-04-12 00:00:00	38000275	0	\N	\N	45199	0	384700001	4293740	
7552	704	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	46523	0	180256009	4107731	
7782	711	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	47112	0	180256009	4107731	
8011	727	4195803	1988-08-06	1988-08-06 00:00:00	38000275	0	\N	\N	48208	0	312681000	4195803	
8108	742	4078793	2011-12-12	2011-12-12 00:00:00	38000275	0	\N	\N	49185	0	180325003	4078793	
8291	757	4057420	1998-09-13	1998-09-13 00:00:00	38000275	0	\N	\N	50232	0	18286008	4057420	
20405	1764	4163872	1968-11-16	1968-11-16 00:00:00	38000275	0	\N	\N	117936	0	399208008	4163872	
20669	1776	4078793	2011-11-26	2011-11-26 00:00:00	38000275	0	\N	\N	118893	0	180325003	4078793	
20810	1791	4170947	1995-07-08	1995-07-08 00:00:00	38000275	0	\N	\N	120057	0	274474001	4170947	
9104	842	4037675	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	55625	0	162676008	4037675	
9226	844	4107731	1990-12-29	1990-12-29 00:00:00	38000275	0	\N	\N	55958	0	180256009	4107731	
9481	863	4078793	2005-06-16	2005-06-16 00:00:00	38000275	0	\N	\N	57189	0	180325003	4078793	
21656	1879	4125906	1988-04-16	1988-04-16 00:00:00	38000275	0	\N	\N	125381	0	288086009	4125906	
9795	877	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	58425	0	180256009	4107731	
10049	895	4043071	1969-09-26	1969-09-26 00:00:00	38000275	0	\N	\N	59736	0	228557008	4043071	
10278	917	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	60968	0	180256009	4107731	
10348	917	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	60974	0	180256009	4107731	
10595	959	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	63792	0	180256009	4107731	
22638	1976	4107731	1996-08-12	1996-08-12 00:00:00	38000275	0	\N	\N	131344	0	180256009	4107731	
22824	1986	4043071	1989-02-23	1989-02-23 00:00:00	38000275	0	\N	\N	132243	0	228557008	4043071	
11213	1036	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	68112	0	180256009	4107731	
11353	1058	4107731	1990-04-21	1990-04-21 00:00:00	38000275	0	\N	\N	69360	0	180256009	4107731	
23442	2054	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	136595	0	180256009	4107731	
11666	1082	4107731	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	71002	0	180256009	4107731	
11914	1091	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	71612	0	180256009	4107731	
65	5	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	519	0	180256009	4107731	
257	16	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	1234	0	180256009	4107731	
530	36	4151422	1996-04-29	1996-04-29 00:00:00	38000275	0	\N	\N	2540	0	269911007	4151422	
12549	1138	4043071	1997-09-18	1997-09-18 00:00:00	38000275	0	\N	\N	75116	0	228557008	4043071	
12736	1144	4170947	2003-01-04	2003-01-04 00:00:00	38000275	0	\N	\N	75497	0	274474001	4170947	
1045	101	4195803	2014-07-21	2014-07-21 00:00:00	38000275	0	\N	\N	6944	0	312681000	4195803	
1195	124	4062501	1986-03-12	1986-03-12 00:00:00	38000275	0	\N	\N	8294	0	171231001	4062501	
1461	137	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	9207	0	180256009	4107731	
1665	153	4043071	1959-10-22	1959-10-22 00:00:00	38000275	0	\N	\N	10335	0	228557008	4043071	
1746	155	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	10629	0	395142003	4191853	
1945	180	4107731	1993-02-18	1993-02-18 00:00:00	38000275	0	\N	\N	12185	0	180256009	4107731	
2157	220	4295880	2002-02-13	2002-02-13 00:00:00	38000275	0	\N	\N	14801	0	76601001	4295880	
2363	236	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	15894	0	180256009	4107731	
2524	260	4107731	1991-06-15	1991-06-15 00:00:00	38000275	0	\N	\N	17231	0	180256009	4107731	
14674	1309	4151422	2017-06-23	2017-06-23 00:00:00	38000275	0	\N	\N	86525	0	269911007	4151422	
2868	273	4107731	1990-09-16	1990-09-16 00:00:00	38000275	0	\N	\N	18269	0	180256009	4107731	
3139	311	4043071	1985-06-04	1985-06-04 00:00:00	38000275	0	\N	\N	20634	0	228557008	4043071	
3312	332	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	21886	0	180256009	4107731	
3496	338	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	22532	0	180256009	4107731	
3621	351	4295880	2005-04-19	2005-04-19 00:00:00	38000275	0	\N	\N	23384	0	76601001	4295880	
3858	380	4058899	1986-08-25	1986-08-25 00:00:00	38000275	0	\N	\N	25137	0	168594001	4058899	
3994	403	4187458	1999-02-08	1999-02-08 00:00:00	38000275	0	\N	\N	26500	0	415300000	4187458	
4184	409	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	27016	0	180256009	4107731	
16393	1427	4024289	1968-06-03	1968-06-03 00:00:00	38000275	0	\N	\N	94958	0	19490002	4024289	
4627	442	4107731	1992-06-06	1992-06-06 00:00:00	38000275	0	\N	\N	29411	0	180256009	4107731	
4818	449	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	29941	0	180256009	4107731	
4941	457	4047491	2009-05-14	2009-05-14 00:00:00	38000275	0	\N	\N	30594	0	1225002	4047491	
5133	480	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	31976	0	180256009	4107731	
5300	489	4107731	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	32724	0	180256009	4107731	
5494	505	4125906	1971-03-21	1971-03-21 00:00:00	38000275	0	\N	\N	33826	0	288086009	4125906	
5774	533	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	35406	0	180256009	4107731	
5861	534	4043071	1989-02-23	1989-02-23 00:00:00	38000275	0	\N	\N	35616	0	228557008	4043071	
6130	563	4191853	1985-05-03	1985-05-03 00:00:00	38000275	0	\N	\N	37276	0	395142003	4191853	
6250	579	4151422	1994-03-30	1994-03-30 00:00:00	38000275	0	\N	\N	38293	0	269911007	4151422	
6438	601	4125906	1979-01-03	1979-01-03 00:00:00	38000275	0	\N	\N	39682	0	288086009	4125906	
6634	607	4170947	1954-07-27	1954-07-27 00:00:00	38000275	0	\N	\N	40297	0	274474001	4170947	
6796	615	4107731	1993-01-23	1993-01-23 00:00:00	38000275	0	\N	\N	40900	0	180256009	4107731	
7034	648	4151422	1938-08-25	1938-08-25 00:00:00	38000275	0	\N	\N	42840	0	269911007	4151422	
7183	664	4107731	2013-09-24	2013-09-24 00:00:00	38000275	0	\N	\N	43899	0	180256009	4107731	
7360	682	4125906	1983-04-12	1983-04-12 00:00:00	38000275	0	\N	\N	45199	0	288086009	4125906	
7553	704	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	46596	0	395142003	4191853	
7783	711	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	47100	0	180256009	4107731	
8012	727	4058899	1988-08-06	1988-08-06 00:00:00	38000275	0	\N	\N	48208	0	168594001	4058899	
8109	742	4035793	2011-12-12	2011-12-12 00:00:00	38000275	0	\N	\N	49185	0	15081005	4035793	
8292	757	4078793	1984-02-26	1984-02-26 00:00:00	38000275	0	\N	\N	50229	0	180325003	4078793	
20471	1766	4035793	2013-11-05	2013-11-05 00:00:00	38000275	0	\N	\N	118185	0	15081005	4035793	
20670	1778	4163872	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	118931	0	399208008	4163872	
20813	1793	4170947	1919-07-07	1919-07-07 00:00:00	38000275	0	\N	\N	120220	0	274474001	4170947	
9105	842	4326177	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	55625	0	430193006	4326177	
9227	844	4107731	1991-03-23	1991-03-23 00:00:00	38000275	0	\N	\N	56015	0	180256009	4107731	
9482	863	4057420	2013-08-01	2013-08-01 00:00:00	38000275	0	\N	\N	57198	0	18286008	4057420	
21657	1879	4195803	2019-05-04	2019-05-04 00:00:00	38000275	0	\N	\N	125427	0	312681000	4195803	
9796	877	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	58363	0	180256009	4107731	
10050	895	4043071	1969-05-02	1969-05-02 00:00:00	38000275	0	\N	\N	59655	0	228557008	4043071	
10279	917	4043071	1974-10-06	1974-10-06 00:00:00	38000275	0	\N	\N	60934	0	228557008	4043071	
10349	918	4125906	1966-02-22	1966-02-22 00:00:00	38000275	0	\N	\N	61199	0	288086009	4125906	
10596	959	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	63717	0	180256009	4107731	
22639	1976	4107731	1996-11-25	1996-11-25 00:00:00	38000275	0	\N	\N	131438	0	180256009	4107731	
22825	1986	4043071	1989-10-19	1989-10-19 00:00:00	38000275	0	\N	\N	132246	0	228557008	4043071	
11214	1036	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	68143	0	180256009	4107731	
11354	1058	4107731	1992-11-21	1992-11-21 00:00:00	38000275	0	\N	\N	69417	0	180256009	4107731	
23443	2054	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	136625	0	180256009	4107731	
11667	1082	4107731	1990-11-17	1990-11-17 00:00:00	38000275	0	\N	\N	70999	0	180256009	4107731	
11915	1091	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	71618	0	180256009	4107731	
66	5	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	416	0	180256009	4107731	
258	16	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	1178	0	180256009	4107731	
531	36	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	2559	0	180256009	4107731	
12550	1138	4043071	1994-08-04	1994-08-04 00:00:00	38000275	0	\N	\N	75075	0	228557008	4043071	
12737	1144	4024289	2003-01-04	2003-01-04 00:00:00	38000275	0	\N	\N	75497	0	19490002	4024289	
1046	101	4078793	2012-07-06	2012-07-06 00:00:00	38000275	0	\N	\N	6892	0	180325003	4078793	
1196	124	4107731	1997-06-03	1997-06-03 00:00:00	38000275	0	\N	\N	8301	0	180256009	4107731	
1462	137	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	9202	0	180256009	4107731	
1666	153	4043071	1959-12-17	1959-12-17 00:00:00	38000275	0	\N	\N	10364	0	228557008	4043071	
1747	155	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	10584	0	180256009	4107731	
1946	180	4107731	1992-10-15	1992-10-15 00:00:00	38000275	0	\N	\N	12154	0	180256009	4107731	
2158	220	4295880	1999-11-17	1999-11-17 00:00:00	38000275	0	\N	\N	14798	0	76601001	4295880	
2364	236	4125906	1987-03-13	1987-03-13 00:00:00	38000275	0	\N	\N	15916	0	288086009	4125906	
2525	260	4107731	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	17176	0	180256009	4107731	
14675	1309	4163872	1993-09-11	1993-09-11 00:00:00	38000275	0	\N	\N	86465	0	399208008	4163872	
2873	276	4170947	1978-06-04	1978-06-04 00:00:00	38000275	0	\N	\N	18389	0	274474001	4170947	
3140	311	4058899	1987-09-23	1987-09-23 00:00:00	38000275	0	\N	\N	20651	0	168594001	4058899	
3313	332	4062501	1965-06-20	1965-06-20 00:00:00	38000275	0	\N	\N	22030	0	171231001	4062501	
3497	338	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	22583	0	180256009	4107731	
3622	351	4295880	2002-09-29	2002-09-29 00:00:00	38000275	0	\N	\N	23365	0	76601001	4295880	
3859	380	4043071	1984-02-15	1984-02-15 00:00:00	38000275	0	\N	\N	25136	0	228557008	4043071	
3995	403	4326177	1999-02-08	1999-02-08 00:00:00	38000275	0	\N	\N	26500	0	430193006	4326177	
4185	409	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	27141	0	180256009	4107731	
16394	1427	4170947	1968-06-03	1968-06-03 00:00:00	38000275	0	\N	\N	94958	0	274474001	4170947	
4628	442	4151422	1974-12-18	1974-12-18 00:00:00	38000275	0	\N	\N	29293	0	269911007	4151422	
4819	449	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	29875	0	180256009	4107731	
4942	457	4170947	2009-05-14	2009-05-14 00:00:00	38000275	0	\N	\N	30594	0	274474001	4170947	
5134	480	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	32075	0	180256009	4107731	
5301	489	4107731	1991-11-10	1991-11-10 00:00:00	38000275	0	\N	\N	32725	0	180256009	4107731	
5495	505	4107731	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	33863	0	180256009	4107731	
5775	533	4010253	1999-07-28	1999-07-28 00:00:00	38000275	0	\N	\N	35393	0	112790001	4010253	
5862	534	4043071	1992-10-16	1992-10-16 00:00:00	38000275	0	\N	\N	35504	0	228557008	4043071	
6131	563	4107731	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	37204	0	180256009	4107731	
6251	579	4330583	2005-03-25	2005-03-25 00:00:00	38000275	0	\N	\N	38309	0	22523008	4330583	
6439	601	4293740	1979-01-03	1979-01-03 00:00:00	38000275	0	\N	\N	39682	0	384700001	4293740	
6635	607	4243062	2001-07-20	2001-07-20 00:00:00	38000275	0	\N	\N	40299	0	60027007	4243062	
6797	615	4107731	1993-03-06	1993-03-06 00:00:00	38000275	0	\N	\N	40901	0	180256009	4107731	
7035	648	4195803	2001-02-27	2001-02-27 00:00:00	38000275	0	\N	\N	42966	0	312681000	4195803	
7184	664	4107731	2013-04-09	2013-04-09 00:00:00	38000275	0	\N	\N	43911	0	180256009	4107731	
7363	685	4043071	1976-11-30	1976-11-30 00:00:00	38000275	0	\N	\N	45295	0	228557008	4043071	
7554	704	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	46564	0	180256009	4107731	
7784	711	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	47148	0	180256009	4107731	
8013	727	4151422	1927-04-03	1927-04-03 00:00:00	38000275	0	\N	\N	48239	0	269911007	4151422	
8110	742	4035793	2000-06-05	2000-06-05 00:00:00	38000275	0	\N	\N	49112	0	15081005	4035793	
8293	757	4078793	1980-02-03	1980-02-03 00:00:00	38000275	0	\N	\N	50227	0	180325003	4078793	
20472	1766	4035793	2010-10-19	2010-10-19 00:00:00	38000275	0	\N	\N	118144	0	15081005	4035793	
20671	1778	4170947	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	118931	0	274474001	4170947	
20814	1793	4047491	1919-07-07	1919-07-07 00:00:00	38000275	0	\N	\N	120220	0	1225002	4047491	
9106	842	4187458	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	55625	0	415300000	4187458	
9228	844	4107731	1991-05-04	1991-05-04 00:00:00	38000275	0	\N	\N	55980	0	180256009	4107731	
9483	863	4078793	1998-05-07	1998-05-07 00:00:00	38000275	0	\N	\N	57194	0	180325003	4078793	
21662	1882	4107731	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	125513	0	180256009	4107731	
9797	877	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	58464	0	180256009	4107731	
10051	895	4043071	1968-02-02	1968-02-02 00:00:00	38000275	0	\N	\N	59661	0	228557008	4043071	
10280	917	4043071	1973-11-25	1973-11-25 00:00:00	38000275	0	\N	\N	60930	0	228557008	4043071	
10350	918	4170947	1969-01-21	1969-01-21 00:00:00	38000275	0	\N	\N	61200	0	274474001	4170947	
10597	959	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	63684	0	180256009	4107731	
22640	1976	4107731	1997-05-12	1997-05-12 00:00:00	38000275	0	\N	\N	131347	0	180256009	4107731	
22826	1986	4043071	1989-07-27	1989-07-27 00:00:00	38000275	0	\N	\N	132252	0	228557008	4043071	
11215	1036	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	68106	0	180256009	4107731	
11355	1058	4107731	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	69469	0	180256009	4107731	
23444	2054	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	136608	0	180256009	4107731	
11668	1082	4107731	1993-02-13	1993-02-13 00:00:00	38000275	0	\N	\N	71020	0	180256009	4107731	
11916	1091	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	71739	0	180256009	4107731	
67	5	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	424	0	180256009	4107731	
259	16	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	1229	0	180256009	4107731	
532	36	4107731	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	2519	0	180256009	4107731	
12551	1138	4107731	1995-12-21	1995-12-21 00:00:00	38000275	0	\N	\N	75104	0	180256009	4107731	
12738	1144	4151422	2006-03-31	2006-03-31 00:00:00	38000275	0	\N	\N	75476	0	269911007	4151422	
1047	101	44783196	1978-11-03	1978-11-03 00:00:00	38000275	0	\N	\N	6947	0	699253003	44783196	
1197	124	4107731	1997-09-16	1997-09-16 00:00:00	38000275	0	\N	\N	8247	0	180256009	4107731	
1463	137	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	9135	0	180256009	4107731	
1667	153	4043071	1958-03-06	1958-03-06 00:00:00	38000275	0	\N	\N	10370	0	228557008	4043071	
1748	155	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	10571	0	180256009	4107731	
1947	180	4107731	1990-10-11	1990-10-11 00:00:00	38000275	0	\N	\N	12165	0	180256009	4107731	
2159	220	4295880	2000-05-17	2000-05-17 00:00:00	38000275	0	\N	\N	14845	0	76601001	4295880	
2365	236	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	15857	0	180256009	4107731	
2526	260	4107731	1993-01-02	1993-01-02 00:00:00	38000275	0	\N	\N	17253	0	180256009	4107731	
14676	1310	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	86643	0	180256009	4107731	
2874	276	4047491	1978-06-04	1978-06-04 00:00:00	38000275	0	\N	\N	18389	0	1225002	4047491	
3141	311	4043071	1985-04-02	1985-04-02 00:00:00	38000275	0	\N	\N	20602	0	228557008	4043071	
3314	332	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	22044	0	180256009	4107731	
3498	338	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	22510	0	180256009	4107731	
3623	351	4295880	2003-10-21	2003-10-21 00:00:00	38000275	0	\N	\N	23392	0	76601001	4295880	
3860	380	4043071	1984-03-21	1984-03-21 00:00:00	38000275	0	\N	\N	25116	0	228557008	4043071	
3996	403	4078793	2011-04-11	2011-04-11 00:00:00	38000275	0	\N	\N	26445	0	180325003	4078793	
4186	409	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	27075	0	180256009	4107731	
16395	1427	4125906	1983-01-28	1983-01-28 00:00:00	38000275	0	\N	\N	94961	0	288086009	4125906	
4629	442	4107731	1990-12-29	1990-12-29 00:00:00	38000275	0	\N	\N	29340	0	180256009	4107731	
4820	449	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	29932	0	180256009	4107731	
4943	457	4195803	2009-05-14	2009-05-14 00:00:00	38000275	0	\N	\N	30594	0	312681000	4195803	
5135	480	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	32098	0	180256009	4107731	
5302	489	4107731	1990-08-26	1990-08-26 00:00:00	38000275	0	\N	\N	32819	0	180256009	4107731	
5496	505	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	33818	0	180256009	4107731	
5776	533	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	35412	0	180256009	4107731	
5863	534	4043071	1992-02-13	1992-02-13 00:00:00	38000275	0	\N	\N	35615	0	228557008	4043071	
6132	563	4107731	1991-11-10	1991-11-10 00:00:00	38000275	0	\N	\N	37307	0	180256009	4107731	
6252	580	4010253	1953-10-27	1953-10-27 00:00:00	38000275	0	\N	\N	38405	0	112790001	4010253	
6440	601	4107731	1990-12-09	1990-12-09 00:00:00	38000275	0	\N	\N	39730	0	180256009	4107731	
6636	607	4170947	2001-07-20	2001-07-20 00:00:00	38000275	0	\N	\N	40299	0	274474001	4170947	
6798	615	4195803	2000-09-09	2000-09-09 00:00:00	38000275	0	\N	\N	40882	0	312681000	4195803	
7036	648	4047491	2001-02-27	2001-02-27 00:00:00	38000275	0	\N	\N	42966	0	1225002	4047491	
7185	664	4107731	2013-10-15	2013-10-15 00:00:00	38000275	0	\N	\N	43858	0	180256009	4107731	
7364	685	4043071	1976-08-31	1976-08-31 00:00:00	38000275	0	\N	\N	45355	0	228557008	4043071	
7555	704	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	46570	0	180256009	4107731	
7785	711	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	47181	0	180256009	4107731	
8014	727	4151422	1949-09-20	1949-09-20 00:00:00	38000275	0	\N	\N	48242	0	269911007	4151422	
8111	742	4035793	2007-07-16	2007-07-16 00:00:00	38000275	0	\N	\N	49183	0	15081005	4035793	
8294	757	4078793	1987-04-26	1987-04-26 00:00:00	38000275	0	\N	\N	50274	0	180325003	4078793	
20473	1766	4035793	2003-09-09	2003-09-09 00:00:00	38000275	0	\N	\N	118179	0	15081005	4035793	
20672	1779	4170947	1976-07-14	1976-07-14 00:00:00	38000275	0	\N	\N	119068	0	274474001	4170947	
20815	1793	4202451	2006-08-30	2006-08-30 00:00:00	38000275	0	\N	\N	120247	0	433112001	4202451	
9107	842	4035793	1990-06-02	1990-06-02 00:00:00	38000275	0	\N	\N	55669	0	15081005	4035793	
9229	844	4107731	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	55895	0	180256009	4107731	
9484	863	4078793	2003-06-05	2003-06-05 00:00:00	38000275	0	\N	\N	57188	0	180325003	4078793	
21663	1882	4107731	1990-06-23	1990-06-23 00:00:00	38000275	0	\N	\N	125557	0	180256009	4107731	
9798	877	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	58378	0	180256009	4107731	
10052	895	4043071	1967-12-29	1967-12-29 00:00:00	38000275	0	\N	\N	59681	0	228557008	4043071	
10281	917	4043071	1974-06-02	1974-06-02 00:00:00	38000275	0	\N	\N	61046	0	228557008	4043071	
10351	918	4243062	1969-01-21	1969-01-21 00:00:00	38000275	0	\N	\N	61200	0	60027007	4243062	
10598	959	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	63719	0	180256009	4107731	
22641	1976	4107731	1998-07-27	1998-07-27 00:00:00	38000275	0	\N	\N	131399	0	180256009	4107731	
22827	1986	4043071	1989-08-24	1989-08-24 00:00:00	38000275	0	\N	\N	132265	0	228557008	4043071	
11216	1036	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	68176	0	180256009	4107731	
11356	1058	4107731	1993-03-06	1993-03-06 00:00:00	38000275	0	\N	\N	69423	0	180256009	4107731	
23445	2054	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	136671	0	180256009	4107731	
11669	1082	4191853	1990-01-06	1990-01-06 00:00:00	38000275	0	\N	\N	70975	0	395142003	4191853	
11917	1091	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	71609	0	180256009	4107731	
68	5	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	482	0	180256009	4107731	
260	16	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	1220	0	180256009	4107731	
533	36	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	2647	0	180256009	4107731	
12552	1138	4043071	1994-06-02	1994-06-02 00:00:00	38000275	0	\N	\N	75108	0	228557008	4043071	
12739	1144	4252419	2009-05-02	2009-05-02 00:00:00	38000275	0	\N	\N	75498	0	74016001	4252419	
1048	101	4078793	2016-07-29	2016-07-29 00:00:00	38000275	0	\N	\N	6894	0	180325003	4078793	
1198	124	4107731	1999-08-10	1999-08-10 00:00:00	38000275	0	\N	\N	8222	0	180256009	4107731	
1464	137	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	9160	0	180256009	4107731	
1668	153	4043071	1958-11-20	1958-11-20 00:00:00	38000275	0	\N	\N	10378	0	228557008	4043071	
1749	155	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	10574	0	180256009	4107731	
1948	180	4107731	1993-01-28	1993-01-28 00:00:00	38000275	0	\N	\N	12087	0	180256009	4107731	
2160	220	4295880	1998-08-18	1998-08-18 00:00:00	38000275	0	\N	\N	14797	0	76601001	4295880	
2366	236	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	15907	0	180256009	4107731	
2527	260	4107731	1993-04-17	1993-04-17 00:00:00	38000275	0	\N	\N	17260	0	180256009	4107731	
14677	1310	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	86611	0	180256009	4107731	
2875	276	4275113	2005-04-08	2005-04-08 00:00:00	38000275	0	\N	\N	18448	0	65200003	4275113	
3142	311	4043071	1985-02-26	1985-02-26 00:00:00	38000275	0	\N	\N	20601	0	228557008	4043071	
3315	332	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	21987	0	180256009	4107731	
3499	338	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	22522	0	180256009	4107731	
3624	351	4295880	2004-07-20	2004-07-20 00:00:00	38000275	0	\N	\N	23383	0	76601001	4295880	
3864	384	4293740	1967-12-25	1967-12-25 00:00:00	38000275	0	\N	\N	25353	0	384700001	4293740	
3997	403	4057420	2012-04-16	2012-04-16 00:00:00	38000275	0	\N	\N	26476	0	18286008	4057420	
4187	409	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	27083	0	180256009	4107731	
16396	1427	4170947	1958-09-24	1958-09-24 00:00:00	38000275	0	\N	\N	94957	0	274474001	4170947	
4630	442	4107731	1992-02-01	1992-02-01 00:00:00	38000275	0	\N	\N	29327	0	180256009	4107731	
4821	449	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	29892	0	180256009	4107731	
4944	457	4252419	1998-07-04	1998-07-04 00:00:00	38000275	0	\N	\N	30593	0	74016001	4252419	
5136	480	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	32096	0	180256009	4107731	
5303	489	4107731	1991-12-01	1991-12-01 00:00:00	38000275	0	\N	\N	32810	0	180256009	4107731	
5497	505	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	33839	0	180256009	4107731	
5777	533	4151422	1981-05-29	1981-05-29 00:00:00	38000275	0	\N	\N	35398	0	269911007	4151422	
5864	534	4043071	1993-04-01	1993-04-01 00:00:00	38000275	0	\N	\N	35512	0	228557008	4043071	
6133	563	4191853	1993-07-11	1993-07-11 00:00:00	38000275	0	\N	\N	37252	0	395142003	4191853	
6253	580	4125906	2005-10-14	2005-10-14 00:00:00	38000275	0	\N	\N	38454	0	288086009	4125906	
6441	601	4107731	1990-10-28	1990-10-28 00:00:00	38000275	0	\N	\N	39729	0	180256009	4107731	
6637	607	4151422	2018-01-26	2018-01-26 00:00:00	38000275	0	\N	\N	40271	0	269911007	4151422	
6799	615	4107731	1991-05-04	1991-05-04 00:00:00	38000275	0	\N	\N	40971	0	180256009	4107731	
7037	648	4170947	2001-02-27	2001-02-27 00:00:00	38000275	0	\N	\N	42966	0	274474001	4170947	
7186	664	4107731	2011-08-09	2011-08-09 00:00:00	38000275	0	\N	\N	43841	0	180256009	4107731	
7365	685	4043071	1974-10-08	1974-10-08 00:00:00	38000275	0	\N	\N	45290	0	228557008	4043071	
7556	704	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	46628	0	180256009	4107731	
7786	711	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	47129	0	180256009	4107731	
8015	728	4043071	1964-07-27	1964-07-27 00:00:00	38000275	0	\N	\N	48338	0	228557008	4043071	
8112	742	4035793	1979-09-17	1979-09-17 00:00:00	38000275	0	\N	\N	49120	0	15081005	4035793	
8295	757	4078793	1990-05-27	1990-05-27 00:00:00	38000275	0	\N	\N	50290	0	180325003	4078793	
20474	1766	4035793	2008-10-07	2008-10-07 00:00:00	38000275	0	\N	\N	118169	0	15081005	4035793	
20673	1779	4047491	1976-07-14	1976-07-14 00:00:00	38000275	0	\N	\N	119068	0	1225002	4047491	
20816	1793	4151422	1934-04-14	1934-04-14 00:00:00	38000275	0	\N	\N	120212	0	269911007	4151422	
9108	842	4035793	1983-03-26	1983-03-26 00:00:00	38000275	0	\N	\N	55666	0	15081005	4035793	
9230	844	4107731	1990-05-12	1990-05-12 00:00:00	38000275	0	\N	\N	55956	0	180256009	4107731	
9485	863	4078793	2000-05-18	2000-05-18 00:00:00	38000275	0	\N	\N	57195	0	180325003	4078793	
21664	1882	4107731	1993-05-08	1993-05-08 00:00:00	38000275	0	\N	\N	125516	0	180256009	4107731	
9799	877	4163872	2009-07-15	2009-07-15 00:00:00	38000275	0	\N	\N	58367	0	399208008	4163872	
10053	895	4043071	1968-09-06	1968-09-06 00:00:00	38000275	0	\N	\N	59654	0	228557008	4043071	
10282	917	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	60926	0	180256009	4107731	
10352	918	4195803	1969-01-21	1969-01-21 00:00:00	38000275	0	\N	\N	61200	0	312681000	4195803	
10599	959	4151422	1978-07-01	1978-07-01 00:00:00	38000275	0	\N	\N	63697	0	269911007	4151422	
22642	1976	4151422	2003-12-02	2003-12-02 00:00:00	38000275	0	\N	\N	131390	0	269911007	4151422	
22828	1986	4043071	1989-03-23	1989-03-23 00:00:00	38000275	0	\N	\N	132251	0	228557008	4043071	
11217	1036	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	68155	0	180256009	4107731	
11357	1058	4151422	2009-03-09	2009-03-09 00:00:00	38000275	0	\N	\N	69430	0	269911007	4151422	
23446	2054	4151422	1973-04-16	1973-04-16 00:00:00	38000275	0	\N	\N	136583	0	269911007	4151422	
11670	1082	4107731	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	70916	0	180256009	4107731	
11918	1091	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	71598	0	180256009	4107731	
69	5	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	511	0	180256009	4107731	
261	16	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	1241	0	180256009	4107731	
534	36	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	2616	0	180256009	4107731	
12553	1138	4043071	1998-01-22	1998-01-22 00:00:00	38000275	0	\N	\N	75133	0	228557008	4043071	
12740	1144	4125906	1980-01-16	1980-01-16 00:00:00	38000275	0	\N	\N	75495	0	288086009	4125906	
1049	101	4170947	2017-07-10	2017-07-10 00:00:00	38000275	0	\N	\N	6946	0	274474001	4170947	
1199	124	4191853	2000-09-12	2000-09-12 00:00:00	38000275	0	\N	\N	8277	0	395142003	4191853	
1465	137	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	9219	0	180256009	4107731	
1669	153	4043071	1957-07-11	1957-07-11 00:00:00	38000275	0	\N	\N	10367	0	228557008	4043071	
1750	155	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	10566	0	180256009	4107731	
1949	180	4107731	1993-08-05	1993-08-05 00:00:00	38000275	0	\N	\N	12145	0	180256009	4107731	
2161	220	4295880	2001-08-15	2001-08-15 00:00:00	38000275	0	\N	\N	14828	0	76601001	4295880	
2367	236	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	15850	0	180256009	4107731	
2528	260	4107731	1990-04-21	1990-04-21 00:00:00	38000275	0	\N	\N	17167	0	180256009	4107731	
14678	1310	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	86595	0	180256009	4107731	
2876	276	4186930	2001-05-17	2001-05-17 00:00:00	38000275	0	\N	\N	18419	0	46706006	4186930	
3143	311	4043071	1985-07-09	1985-07-09 00:00:00	38000275	0	\N	\N	20635	0	228557008	4043071	
3316	332	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	21944	0	180256009	4107731	
3500	338	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	22576	0	180256009	4107731	
3625	351	4295880	2000-04-25	2000-04-25 00:00:00	38000275	0	\N	\N	23361	0	76601001	4295880	
3865	384	4125906	1967-12-25	1967-12-25 00:00:00	38000275	0	\N	\N	25353	0	288086009	4125906	
3998	403	4010253	1928-05-24	1928-05-24 00:00:00	38000275	0	\N	\N	26509	0	112790001	4010253	
4188	409	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	27007	0	180256009	4107731	
16397	1427	4163872	1958-09-24	1958-09-24 00:00:00	38000275	0	\N	\N	94957	0	399208008	4163872	
4631	442	4107731	1991-04-13	1991-04-13 00:00:00	38000275	0	\N	\N	29354	0	180256009	4107731	
4822	449	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	29893	0	180256009	4107731	
4945	457	4151422	1954-04-01	1954-04-01 00:00:00	38000275	0	\N	\N	30528	0	269911007	4151422	
5137	480	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	31973	0	180256009	4107731	
5309	492	4326177	1979-12-05	1979-12-05 00:00:00	38000275	0	\N	\N	32984	0	430193006	4326177	
5498	505	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	33853	0	180256009	4107731	
5778	533	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	35416	0	180256009	4107731	
5865	534	4186930	1998-06-16	1998-06-16 00:00:00	38000275	0	\N	\N	35583	0	46706006	4186930	
6134	563	4107731	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	37264	0	180256009	4107731	
6254	580	4125906	1994-07-30	1994-07-30 00:00:00	38000275	0	\N	\N	38453	0	288086009	4125906	
6442	601	4107731	1992-02-02	1992-02-02 00:00:00	38000275	0	\N	\N	39668	0	180256009	4107731	
6638	607	4170947	1957-06-11	1957-06-11 00:00:00	38000275	0	\N	\N	40298	0	274474001	4170947	
6800	615	4170947	1995-01-29	1995-01-29 00:00:00	38000275	0	\N	\N	41044	0	274474001	4170947	
7038	648	4151422	2005-08-27	2005-08-27 00:00:00	38000275	0	\N	\N	42905	0	269911007	4151422	
7187	664	4107731	2013-07-02	2013-07-02 00:00:00	38000275	0	\N	\N	43897	0	180256009	4107731	
7366	685	4043071	1975-10-21	1975-10-21 00:00:00	38000275	0	\N	\N	45352	0	228557008	4043071	
7557	704	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	46607	0	180256009	4107731	
7787	711	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	47096	0	180256009	4107731	
8016	728	4043071	1964-12-21	1964-12-21 00:00:00	38000275	0	\N	\N	48330	0	228557008	4043071	
8113	742	4078793	2010-12-06	2010-12-06 00:00:00	38000275	0	\N	\N	49196	0	180325003	4078793	
8296	757	4057420	1996-06-16	1996-06-16 00:00:00	38000275	0	\N	\N	50230	0	18286008	4057420	
20475	1766	4035793	2012-10-30	2012-10-30 00:00:00	38000275	0	\N	\N	118145	0	15081005	4035793	
20674	1779	4197460	1945-02-13	1945-02-13 00:00:00	38000275	0	\N	\N	119062	0	313191000	4197460	
20817	1793	4252419	1991-01-05	1991-01-05 00:00:00	38000275	0	\N	\N	120226	0	74016001	4252419	
9109	842	4035793	2007-09-08	2007-09-08 00:00:00	38000275	0	\N	\N	55689	0	15081005	4035793	
9231	844	4107731	1990-04-21	1990-04-21 00:00:00	38000275	0	\N	\N	55972	0	180256009	4107731	
9486	863	4078793	2011-07-21	2011-07-21 00:00:00	38000275	0	\N	\N	57197	0	180325003	4078793	
21665	1882	4107731	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	125537	0	180256009	4107731	
9800	877	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	58399	0	180256009	4107731	
21899	1898	4125906	2011-08-25	2011-08-25 00:00:00	38000275	0	\N	\N	126340	0	288086009	4125906	
10283	917	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	61029	0	180256009	4107731	
10353	918	4058899	1928-01-22	1928-01-22 00:00:00	38000275	0	\N	\N	61197	0	168594001	4058899	
10600	959	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	63788	0	180256009	4107731	
22643	1976	4107731	1997-06-23	1997-06-23 00:00:00	38000275	0	\N	\N	131367	0	180256009	4107731	
22829	1986	4043071	1989-06-22	1989-06-22 00:00:00	38000275	0	\N	\N	132245	0	228557008	4043071	
11218	1036	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	68177	0	180256009	4107731	
11358	1058	4107731	1990-07-14	1990-07-14 00:00:00	38000275	0	\N	\N	69432	0	180256009	4107731	
23447	2054	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	136597	0	180256009	4107731	
11671	1082	4191853	1988-09-06	1988-09-06 00:00:00	38000275	0	\N	\N	70905	0	395142003	4191853	
11919	1091	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	71615	0	180256009	4107731	
70	5	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	483	0	180256009	4107731	
262	16	4181917	1983-10-10	1983-10-10 00:00:00	38000275	0	\N	\N	1163	0	54550000	4181917	
535	36	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	2499	0	180256009	4107731	
12554	1138	4043071	1996-10-17	1996-10-17 00:00:00	38000275	0	\N	\N	75034	0	228557008	4043071	
12741	1145	4145310	1977-02-05	1977-02-05 00:00:00	38000275	0	\N	\N	75556	0	268425006	4145310	
1050	101	4024289	2017-07-10	2017-07-10 00:00:00	38000275	0	\N	\N	6946	0	19490002	4024289	
1200	124	4107731	1998-01-19	1998-01-19 00:00:00	38000275	0	\N	\N	8305	0	180256009	4107731	
1466	137	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	9200	0	180256009	4107731	
1670	154	4295880	1996-04-18	1996-04-18 00:00:00	38000275	0	\N	\N	10489	0	76601001	4295880	
1751	155	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	10577	0	180256009	4107731	
1950	180	4107731	1991-01-24	1991-01-24 00:00:00	38000275	0	\N	\N	12111	0	180256009	4107731	
2162	222	44783196	2003-09-14	2003-09-14 00:00:00	38000275	0	\N	\N	14888	0	699253003	44783196	
2368	236	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	15861	0	180256009	4107731	
2529	260	4151422	1979-02-22	1979-02-22 00:00:00	38000275	0	\N	\N	17155	0	269911007	4151422	
14679	1310	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	86608	0	180256009	4107731	
2877	276	4275113	2003-04-14	2003-04-14 00:00:00	38000275	0	\N	\N	18433	0	65200003	4275113	
3144	311	4043071	1984-09-18	1984-09-18 00:00:00	38000275	0	\N	\N	20600	0	228557008	4043071	
3317	332	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	21918	0	180256009	4107731	
3501	338	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	22580	0	180256009	4107731	
3626	351	4295880	2000-01-25	2000-01-25 00:00:00	38000275	0	\N	\N	23413	0	76601001	4295880	
3866	384	4151422	2008-02-10	2008-02-10 00:00:00	38000275	0	\N	\N	25348	0	269911007	4151422	
3999	403	4078793	2018-05-21	2018-05-21 00:00:00	38000275	0	\N	\N	26456	0	180325003	4078793	
4189	409	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	27130	0	395142003	4191853	
16398	1428	4170947	1998-06-05	1998-06-05 00:00:00	38000275	0	\N	\N	95043	0	274474001	4170947	
4632	442	4107731	1992-11-21	1992-11-21 00:00:00	38000275	0	\N	\N	29381	0	180256009	4107731	
4823	449	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	29942	0	180256009	4107731	
4946	457	4024289	1958-08-07	1958-08-07 00:00:00	38000275	0	\N	\N	30590	0	19490002	4024289	
5138	480	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	32086	0	180256009	4107731	
5310	492	4037675	1979-12-05	1979-12-05 00:00:00	38000275	0	\N	\N	32984	0	162676008	4037675	
5499	505	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	33851	0	180256009	4107731	
5779	533	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	35488	0	180256009	4107731	
5866	534	4043071	1990-09-21	1990-09-21 00:00:00	38000275	0	\N	\N	35518	0	228557008	4043071	
6135	563	4202451	2005-03-13	2005-03-13 00:00:00	38000275	0	\N	\N	37311	0	433112001	4202451	
6255	580	4293740	1994-07-30	1994-07-30 00:00:00	38000275	0	\N	\N	38453	0	384700001	4293740	
6443	601	4107731	1990-11-18	1990-11-18 00:00:00	38000275	0	\N	\N	39763	0	180256009	4107731	
6639	607	4047491	1957-06-11	1957-06-11 00:00:00	38000275	0	\N	\N	40298	0	1225002	4047491	
6801	615	4195803	1995-01-29	1995-01-29 00:00:00	38000275	0	\N	\N	41044	0	312681000	4195803	
7039	648	4047491	1954-10-22	1954-10-22 00:00:00	38000275	0	\N	\N	42961	0	1225002	4047491	
7188	664	4191853	2014-01-28	2014-01-28 00:00:00	38000275	0	\N	\N	43831	0	395142003	4191853	
7367	685	4043071	1975-02-11	1975-02-11 00:00:00	38000275	0	\N	\N	45252	0	228557008	4043071	
7558	704	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	46521	0	180256009	4107731	
7788	711	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	47201	0	395142003	4191853	
8017	728	4043071	1964-06-29	1964-06-29 00:00:00	38000275	0	\N	\N	48308	0	228557008	4043071	
8114	742	4035793	1985-10-21	1985-10-21 00:00:00	38000275	0	\N	\N	49206	0	15081005	4035793	
8297	757	4078793	1978-01-22	1978-01-22 00:00:00	38000275	0	\N	\N	50265	0	180325003	4078793	
20476	1766	4035793	2017-11-28	2017-11-28 00:00:00	38000275	0	\N	\N	118170	0	15081005	4035793	
20675	1779	4197460	1969-04-15	1969-04-15 00:00:00	38000275	0	\N	\N	119067	0	313191000	4197460	
20818	1793	4151422	2002-10-14	2002-10-14 00:00:00	38000275	0	\N	\N	120251	0	269911007	4151422	
9110	842	4043071	1917-12-30	1917-12-30 00:00:00	38000275	0	\N	\N	55674	0	228557008	4043071	
9232	844	4107731	1992-02-01	1992-02-01 00:00:00	38000275	0	\N	\N	55983	0	180256009	4107731	
9487	863	4078793	1997-05-01	1997-05-01 00:00:00	38000275	0	\N	\N	57115	0	180325003	4078793	
21666	1882	4107731	1991-06-15	1991-06-15 00:00:00	38000275	0	\N	\N	125570	0	180256009	4107731	
9801	877	4107731	1993-10-19	1993-10-19 00:00:00	38000275	0	\N	\N	58366	0	180256009	4107731	
21900	1898	4170947	1996-05-15	1996-05-15 00:00:00	38000275	0	\N	\N	126339	0	274474001	4170947	
10284	917	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	60962	0	180256009	4107731	
10354	918	4195803	1985-04-27	1985-04-27 00:00:00	38000275	0	\N	\N	61201	0	312681000	4195803	
10601	959	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	63740	0	180256009	4107731	
22644	1976	4107731	1997-03-31	1997-03-31 00:00:00	38000275	0	\N	\N	131346	0	180256009	4107731	
22830	1986	4043071	1989-01-26	1989-01-26 00:00:00	38000275	0	\N	\N	132239	0	228557008	4043071	
11219	1036	4163872	1978-12-17	1978-12-17 00:00:00	38000275	0	\N	\N	68135	0	399208008	4163872	
11359	1058	4107731	1990-11-17	1990-11-17 00:00:00	38000275	0	\N	\N	69466	0	180256009	4107731	
23448	2054	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	136652	0	180256009	4107731	
11672	1082	4107731	1993-01-02	1993-01-02 00:00:00	38000275	0	\N	\N	71019	0	180256009	4107731	
11920	1091	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	71629	0	180256009	4107731	
71	5	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	517	0	180256009	4107731	
263	16	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	1248	0	180256009	4107731	
536	36	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	2500	0	180256009	4107731	
12555	1138	4043071	1996-11-14	1996-11-14 00:00:00	38000275	0	\N	\N	74995	0	228557008	4043071	
12742	1145	4047491	2018-08-13	2018-08-13 00:00:00	38000275	0	\N	\N	75559	0	1225002	4047491	
1051	101	4195803	2017-07-10	2017-07-10 00:00:00	38000275	0	\N	\N	6946	0	312681000	4195803	
1201	124	4107731	1999-05-18	1999-05-18 00:00:00	38000275	0	\N	\N	8220	0	180256009	4107731	
1467	137	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	9161	0	180256009	4107731	
1671	154	4295880	1997-10-16	1997-10-16 00:00:00	38000275	0	\N	\N	10491	0	76601001	4295880	
1752	155	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	10624	0	180256009	4107731	
1951	180	4107731	1993-07-15	1993-07-15 00:00:00	38000275	0	\N	\N	12157	0	180256009	4107731	
2163	222	4151422	1965-10-31	1965-10-31 00:00:00	38000275	0	\N	\N	14936	0	269911007	4151422	
2369	236	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	15826	0	180256009	4107731	
2530	260	4107731	1993-05-29	1993-05-29 00:00:00	38000275	0	\N	\N	17261	0	180256009	4107731	
14680	1310	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	86686	0	180256009	4107731	
2878	276	4186930	2006-05-18	2006-05-18 00:00:00	38000275	0	\N	\N	18449	0	46706006	4186930	
3145	311	4151422	2008-01-04	2008-01-04 00:00:00	38000275	0	\N	\N	20588	0	269911007	4151422	
3318	332	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	21881	0	180256009	4107731	
3502	338	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	22513	0	180256009	4107731	
3627	351	4295880	2002-10-22	2002-10-22 00:00:00	38000275	0	\N	\N	23382	0	76601001	4295880	
3867	384	4125906	2003-07-03	2003-07-03 00:00:00	38000275	0	\N	\N	25354	0	288086009	4125906	
4000	403	4195803	1988-08-14	1988-08-14 00:00:00	38000275	0	\N	\N	26464	0	312681000	4195803	
4190	409	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	27093	0	180256009	4107731	
16399	1428	4047491	1998-06-05	1998-06-05 00:00:00	38000275	0	\N	\N	95043	0	1225002	4047491	
4633	442	4107731	1992-04-04	1992-04-04 00:00:00	38000275	0	\N	\N	29266	0	180256009	4107731	
4824	449	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	29934	0	180256009	4107731	
4947	457	4170947	1958-08-07	1958-08-07 00:00:00	38000275	0	\N	\N	30590	0	274474001	4170947	
5139	480	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	31981	0	180256009	4107731	
5311	492	4187458	1979-12-05	1979-12-05 00:00:00	38000275	0	\N	\N	32984	0	415300000	4187458	
5500	505	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	33857	0	180256009	4107731	
5780	533	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	35423	0	180256009	4107731	
5867	534	4043071	1991-12-12	1991-12-12 00:00:00	38000275	0	\N	\N	35502	0	228557008	4043071	
6136	563	4107731	1991-09-08	1991-09-08 00:00:00	38000275	0	\N	\N	37216	0	180256009	4107731	
6256	580	4195803	1997-10-05	1997-10-05 00:00:00	38000275	0	\N	\N	38467	0	312681000	4195803	
6444	601	4107731	1991-09-29	1991-09-29 00:00:00	38000275	0	\N	\N	39747	0	180256009	4107731	
6640	608	4151422	1975-03-16	1975-03-16 00:00:00	38000275	0	\N	\N	40411	0	269911007	4151422	
6802	615	4243062	1995-01-29	1995-01-29 00:00:00	38000275	0	\N	\N	41044	0	60027007	4243062	
7040	648	4170947	1954-10-22	1954-10-22 00:00:00	38000275	0	\N	\N	42961	0	274474001	4170947	
7189	664	4107731	2012-06-19	2012-06-19 00:00:00	38000275	0	\N	\N	43845	0	180256009	4107731	
7368	685	4043071	1977-10-11	1977-10-11 00:00:00	38000275	0	\N	\N	45259	0	228557008	4043071	
7559	704	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	46622	0	180256009	4107731	
7789	711	44783196	1978-08-04	1978-08-04 00:00:00	38000275	0	\N	\N	47128	0	699253003	44783196	
8018	728	4043071	1964-09-28	1964-09-28 00:00:00	38000275	0	\N	\N	48329	0	228557008	4043071	
8115	742	4035793	2004-06-28	2004-06-28 00:00:00	38000275	0	\N	\N	49212	0	15081005	4035793	
8298	757	4057420	1998-09-06	1998-09-06 00:00:00	38000275	0	\N	\N	\N	0	18286008	4057420	
20477	1766	4035793	2003-06-17	2003-06-17 00:00:00	38000275	0	\N	\N	118162	0	15081005	4035793	
20676	1779	4145310	1953-02-01	1953-02-01 00:00:00	38000275	0	\N	\N	119065	0	268425006	4145310	
20819	1793	4125906	1996-12-04	1996-12-04 00:00:00	38000275	0	\N	\N	120227	0	288086009	4125906	
9111	842	4035793	2003-08-16	2003-08-16 00:00:00	38000275	0	\N	\N	55672	0	15081005	4035793	
9233	844	4107731	1991-02-09	1991-02-09 00:00:00	38000275	0	\N	\N	55959	0	180256009	4107731	
9488	863	4078793	1987-03-05	1987-03-05 00:00:00	38000275	0	\N	\N	57182	0	180325003	4078793	
21667	1882	4191853	1993-07-10	1993-07-10 00:00:00	38000275	0	\N	\N	125508	0	395142003	4191853	
9803	879	4047491	1986-02-17	1986-02-17 00:00:00	38000275	0	\N	\N	58580	0	1225002	4047491	
21901	1898	4024289	1996-05-15	1996-05-15 00:00:00	38000275	0	\N	\N	126339	0	19490002	4024289	
10285	917	4043071	1975-10-26	1975-10-26 00:00:00	38000275	0	\N	\N	60978	0	228557008	4043071	
10355	918	4170947	1985-04-27	1985-04-27 00:00:00	38000275	0	\N	\N	61201	0	274474001	4170947	
10602	959	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	63746	0	180256009	4107731	
22645	1976	4107731	1998-05-04	1998-05-04 00:00:00	38000275	0	\N	\N	131371	0	180256009	4107731	
22831	1986	4043071	1989-11-23	1989-11-23 00:00:00	38000275	0	\N	\N	132247	0	228557008	4043071	
11220	1036	4170947	1978-12-17	1978-12-17 00:00:00	38000275	0	\N	\N	68135	0	274474001	4170947	
11360	1058	4107731	1991-06-15	1991-06-15 00:00:00	38000275	0	\N	\N	69489	0	180256009	4107731	
23449	2054	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	136689	0	180256009	4107731	
11673	1082	4107731	1990-07-14	1990-07-14 00:00:00	38000275	0	\N	\N	70907	0	180256009	4107731	
11921	1091	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	71641	0	180256009	4107731	
72	5	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	425	0	180256009	4107731	
264	16	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	1246	0	180256009	4107731	
537	36	4252419	2001-03-23	2001-03-23 00:00:00	38000275	0	\N	\N	2611	0	74016001	4252419	
12556	1138	4107731	1995-06-15	1995-06-15 00:00:00	38000275	0	\N	\N	75080	0	180256009	4107731	
12743	1145	4195803	2018-08-13	2018-08-13 00:00:00	38000275	0	\N	\N	75559	0	312681000	4195803	
1052	101	40492359	2001-01-12	2001-01-12 00:00:00	38000275	0	\N	\N	6902	0	447365002	40492359	
1202	124	4107731	1998-11-30	1998-11-30 00:00:00	38000275	0	\N	\N	8310	0	180256009	4107731	
1470	140	4295880	1999-12-23	1999-12-23 00:00:00	38000275	0	\N	\N	9372	0	76601001	4295880	
1672	154	4059978	1995-10-12	1995-10-12 00:00:00	38000275	0	\N	\N	10476	0	169553002	4059978	
1753	155	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	10606	0	180256009	4107731	
1952	180	4107731	1991-08-22	1991-08-22 00:00:00	38000275	0	\N	\N	12169	0	180256009	4107731	
2164	222	4125906	2014-07-18	2014-07-18 00:00:00	38000275	0	\N	\N	14935	0	288086009	4125906	
2370	236	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	15848	0	180256009	4107731	
2531	260	4107731	1992-04-25	1992-04-25 00:00:00	38000275	0	\N	\N	17177	0	180256009	4107731	
14681	1310	4151422	1945-04-11	1945-04-11 00:00:00	38000275	0	\N	\N	86566	0	269911007	4151422	
2879	276	4275113	1996-05-13	1996-05-13 00:00:00	38000275	0	\N	\N	18396	0	65200003	4275113	
3146	311	4125906	2004-08-24	2004-08-24 00:00:00	38000275	0	\N	\N	20654	0	288086009	4125906	
3319	332	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	22041	0	180256009	4107731	
3503	338	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	22604	0	180256009	4107731	
3628	351	4295880	2001-04-24	2001-04-24 00:00:00	38000275	0	\N	\N	23380	0	76601001	4295880	
3870	387	4024289	1974-08-26	1974-08-26 00:00:00	38000275	0	\N	\N	25455	0	19490002	4024289	
4001	403	4170947	1988-08-14	1988-08-14 00:00:00	38000275	0	\N	\N	26464	0	274474001	4170947	
4191	409	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	27104	0	180256009	4107731	
16400	1428	4195803	1998-06-05	1998-06-05 00:00:00	38000275	0	\N	\N	95043	0	312681000	4195803	
4634	442	4107731	1992-02-22	1992-02-22 00:00:00	38000275	0	\N	\N	29358	0	180256009	4107731	
4825	449	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	29937	0	180256009	4107731	
4948	457	44783196	1998-07-11	1998-07-11 00:00:00	38000275	0	\N	\N	30580	0	699253003	44783196	
5140	480	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	32023	0	180256009	4107731	
5312	492	4163872	1954-10-03	1954-10-03 00:00:00	38000275	0	\N	\N	32949	0	399208008	4163872	
5501	505	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	33834	0	180256009	4107731	
5781	533	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	35481	0	180256009	4107731	
5868	534	4043071	1989-11-09	1989-11-09 00:00:00	38000275	0	\N	\N	35619	0	228557008	4043071	
6137	563	4107731	1992-04-26	1992-04-26 00:00:00	38000275	0	\N	\N	37281	0	180256009	4107731	
6257	580	4151422	1964-05-17	1964-05-17 00:00:00	38000275	0	\N	\N	38458	0	269911007	4151422	
6445	601	4107731	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	39755	0	180256009	4107731	
6641	608	4216130	2005-07-13	2005-07-13 00:00:00	38000275	0	\N	\N	40409	0	415070008	4216130	
6803	615	4107731	1990-06-23	1990-06-23 00:00:00	38000275	0	\N	\N	40915	0	180256009	4107731	
7041	648	4195803	2007-07-26	2007-07-26 00:00:00	38000275	0	\N	\N	42967	0	312681000	4195803	
7190	664	4107731	2012-04-17	2012-04-17 00:00:00	38000275	0	\N	\N	43906	0	180256009	4107731	
7369	685	4043071	1977-01-25	1977-01-25 00:00:00	38000275	0	\N	\N	45271	0	228557008	4043071	
7560	704	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	46608	0	180256009	4107731	
7790	711	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	47195	0	180256009	4107731	
8019	728	4043071	1964-08-31	1964-08-31 00:00:00	38000275	0	\N	\N	48339	0	228557008	4043071	
8116	742	4078793	2014-10-20	2014-10-20 00:00:00	38000275	0	\N	\N	49198	0	180325003	4078793	
8299	758	4058899	1974-03-20	1974-03-20 00:00:00	38000275	0	\N	\N	50297	0	168594001	4058899	
20478	1766	4323902	2014-01-21	2014-01-21 00:00:00	38000275	0	\N	\N	118160	0	429609002	4323902	
20677	1779	4151422	1950-01-13	1950-01-13 00:00:00	38000275	0	\N	\N	119041	0	269911007	4151422	
20820	1793	4293740	1996-12-04	1996-12-04 00:00:00	38000275	0	\N	\N	120227	0	384700001	4293740	
9112	842	4035793	1996-07-06	1996-07-06 00:00:00	38000275	0	\N	\N	55687	0	15081005	4035793	
9234	844	4107731	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	55986	0	180256009	4107731	
9489	863	4078793	2010-07-15	2010-07-15 00:00:00	38000275	0	\N	\N	57118	0	180325003	4078793	
21668	1882	4107731	1990-11-17	1990-11-17 00:00:00	38000275	0	\N	\N	125539	0	180256009	4107731	
9804	879	4170947	1986-02-17	1986-02-17 00:00:00	38000275	0	\N	\N	58580	0	274474001	4170947	
21902	1898	4125906	1994-06-04	1994-06-04 00:00:00	38000275	0	\N	\N	126338	0	288086009	4125906	
22067	1923	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	127880	0	180256009	4107731	
10356	918	4243062	1985-04-27	1985-04-27 00:00:00	38000275	0	\N	\N	61201	0	60027007	4243062	
10603	959	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	63716	0	180256009	4107731	
22646	1976	4107731	1997-12-29	1997-12-29 00:00:00	38000275	0	\N	\N	131354	0	180256009	4107731	
22832	1986	4043071	1989-04-20	1989-04-20 00:00:00	38000275	0	\N	\N	132240	0	228557008	4043071	
23002	1999	4107731	2014-07-30	2014-07-30 00:00:00	38000275	0	\N	\N	133103	0	180256009	4107731	
11361	1058	4107731	1990-10-27	1990-10-27 00:00:00	38000275	0	\N	\N	69361	0	180256009	4107731	
23450	2054	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	136586	0	180256009	4107731	
11674	1082	4107731	1992-04-25	1992-04-25 00:00:00	38000275	0	\N	\N	70955	0	180256009	4107731	
11922	1091	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	71640	0	180256009	4107731	
73	5	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	479	0	180256009	4107731	
265	16	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	1233	0	180256009	4107731	
538	36	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	2509	0	180256009	4107731	
12557	1138	4107731	1994-08-25	1994-08-25 00:00:00	38000275	0	\N	\N	75050	0	180256009	4107731	
12744	1145	4170947	2018-08-13	2018-08-13 00:00:00	38000275	0	\N	\N	75559	0	274474001	4170947	
1053	101	4057420	2001-01-12	2001-01-12 00:00:00	38000275	0	\N	\N	6902	0	18286008	4057420	
1203	124	4107731	1997-12-08	1997-12-08 00:00:00	38000275	0	\N	\N	8304	0	180256009	4107731	
1471	140	4295880	1998-09-24	1998-09-24 00:00:00	38000275	0	\N	\N	9385	0	76601001	4295880	
1673	154	4295880	1999-10-14	1999-10-14 00:00:00	38000275	0	\N	\N	10505	0	76601001	4295880	
1754	155	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	10618	0	180256009	4107731	
1953	180	4107731	1991-07-11	1991-07-11 00:00:00	38000275	0	\N	\N	12168	0	180256009	4107731	
2165	222	4252419	2003-09-07	2003-09-07 00:00:00	38000275	0	\N	\N	14934	0	74016001	4252419	
2371	236	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	15924	0	180256009	4107731	
2532	260	4107731	1991-12-21	1991-12-21 00:00:00	38000275	0	\N	\N	17232	0	180256009	4107731	
14682	1310	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	86596	0	180256009	4107731	
2880	276	4238715	2009-07-16	2009-07-16 00:00:00	38000275	0	\N	\N	18420	0	68254000	4238715	
3147	311	4043071	1984-11-20	1984-11-20 00:00:00	38000275	0	\N	\N	20632	0	228557008	4043071	
3320	332	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	22021	0	180256009	4107731	
3504	338	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	22530	0	180256009	4107731	
3629	351	4295880	1998-01-27	1998-01-27 00:00:00	38000275	0	\N	\N	23358	0	76601001	4295880	
3871	387	4170947	1974-08-26	1974-08-26 00:00:00	38000275	0	\N	\N	25455	0	274474001	4170947	
4002	403	4243062	1988-08-14	1988-08-14 00:00:00	38000275	0	\N	\N	26464	0	60027007	4243062	
4192	409	4125906	2007-01-31	2007-01-31 00:00:00	38000275	0	\N	\N	27153	0	288086009	4125906	
16402	1430	4243062	1955-05-24	1955-05-24 00:00:00	38000275	0	\N	\N	95179	0	60027007	4243062	
4635	442	4107731	1991-07-27	1991-07-27 00:00:00	38000275	0	\N	\N	29406	0	180256009	4107731	
4826	449	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	29879	0	180256009	4107731	
4949	458	4326177	2012-08-03	2012-08-03 00:00:00	38000275	0	\N	\N	30640	0	430193006	4326177	
5141	480	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	32054	0	180256009	4107731	
5313	492	4108705	1979-12-05	1979-12-05 00:00:00	38000275	0	\N	\N	32984	0	180207008	4108705	
5502	505	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	33774	0	180256009	4107731	
5782	533	4125906	1988-08-05	1988-08-05 00:00:00	38000275	0	\N	\N	35370	0	288086009	4125906	
5883	539	4336464	1999-07-25	1999-07-25 00:00:00	38000275	0	\N	\N	35858	0	232717009	4336464	
6138	563	4107731	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	37283	0	180256009	4107731	
6258	580	4125906	1929-06-24	1929-06-24 00:00:00	38000275	0	\N	\N	38399	0	288086009	4125906	
6446	601	4107731	1990-04-01	1990-04-01 00:00:00	38000275	0	\N	\N	39733	0	180256009	4107731	
6642	608	4336464	2005-07-13	2005-07-13 00:00:00	38000275	0	\N	\N	40409	0	232717009	4336464	
6804	615	4107731	1992-08-29	1992-08-29 00:00:00	38000275	0	\N	\N	40956	0	180256009	4107731	
7042	648	4024289	2007-07-26	2007-07-26 00:00:00	38000275	0	\N	\N	42967	0	19490002	4024289	
7191	664	4107731	2010-11-30	2010-11-30 00:00:00	38000275	0	\N	\N	43807	0	180256009	4107731	
7370	685	4043071	1978-04-25	1978-04-25 00:00:00	38000275	0	\N	\N	45262	0	228557008	4043071	
7561	704	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	46623	0	180256009	4107731	
7791	711	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	47147	0	180256009	4107731	
8020	728	4125906	1970-10-14	1970-10-14 00:00:00	38000275	0	\N	\N	48312	0	288086009	4125906	
8117	742	4035793	2014-10-20	2014-10-20 00:00:00	38000275	0	\N	\N	49198	0	15081005	4035793	
8300	758	4125906	2000-07-15	2000-07-15 00:00:00	38000275	0	\N	\N	50357	0	288086009	4125906	
20479	1766	4035793	2016-11-22	2016-11-22 00:00:00	38000275	0	\N	\N	118198	0	15081005	4035793	
20678	1779	4151422	2011-01-30	2011-01-30 00:00:00	38000275	0	\N	\N	118990	0	269911007	4151422	
20821	1793	4252419	1962-05-25	1962-05-25 00:00:00	38000275	0	\N	\N	120223	0	74016001	4252419	
9113	842	4035793	2011-10-01	2011-10-01 00:00:00	38000275	0	\N	\N	55691	0	15081005	4035793	
9235	844	4107731	1992-01-11	1992-01-11 00:00:00	38000275	0	\N	\N	55998	0	180256009	4107731	
9490	863	4078793	2002-05-30	2002-05-30 00:00:00	38000275	0	\N	\N	57139	0	180325003	4078793	
21669	1882	4107731	1993-02-13	1993-02-13 00:00:00	38000275	0	\N	\N	125552	0	180256009	4107731	
9805	879	4043071	1963-06-21	1963-06-21 00:00:00	38000275	0	\N	\N	58523	0	228557008	4043071	
21903	1898	4151422	1986-10-24	1986-10-24 00:00:00	38000275	0	\N	\N	126341	0	269911007	4151422	
22068	1923	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	127944	0	180256009	4107731	
10357	918	4125906	1995-03-04	1995-03-04 00:00:00	38000275	0	\N	\N	61203	0	288086009	4125906	
10604	959	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	63747	0	180256009	4107731	
22647	1976	4107731	1998-03-02	1998-03-02 00:00:00	38000275	0	\N	\N	131359	0	180256009	4107731	
22833	1986	4043071	1989-09-21	1989-09-21 00:00:00	38000275	0	\N	\N	132253	0	228557008	4043071	
23003	1999	4107731	2014-04-16	2014-04-16 00:00:00	38000275	0	\N	\N	133123	0	180256009	4107731	
11362	1058	4107731	1993-02-13	1993-02-13 00:00:00	38000275	0	\N	\N	69419	0	180256009	4107731	
23451	2054	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	136673	0	180256009	4107731	
11675	1082	4107731	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	70987	0	180256009	4107731	
11923	1091	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	71633	0	180256009	4107731	
74	5	44783196	1990-04-07	1990-04-07 00:00:00	38000275	0	\N	\N	468	0	699253003	44783196	
266	16	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	1225	0	180256009	4107731	
539	36	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	2493	0	180256009	4107731	
12558	1138	4107731	1995-10-19	1995-10-19 00:00:00	38000275	0	\N	\N	74989	0	180256009	4107731	
12745	1145	4010253	1961-10-24	1961-10-24 00:00:00	38000275	0	\N	\N	75586	0	112790001	4010253	
1054	101	4252419	1978-10-27	1978-10-27 00:00:00	38000275	0	\N	\N	6898	0	74016001	4252419	
1204	124	4107731	1997-08-05	1997-08-05 00:00:00	38000275	0	\N	\N	8321	0	180256009	4107731	
1472	140	4295880	1996-09-26	1996-09-26 00:00:00	38000275	0	\N	\N	9370	0	76601001	4295880	
1674	154	4295880	1994-10-17	1994-10-17 00:00:00	38000275	0	\N	\N	10475	0	76601001	4295880	
1755	155	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	10532	0	180256009	4107731	
1954	180	4107731	1992-06-11	1992-06-11 00:00:00	38000275	0	\N	\N	12130	0	180256009	4107731	
2166	222	4243062	1958-05-10	1958-05-10 00:00:00	38000275	0	\N	\N	14931	0	60027007	4243062	
2372	236	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	15862	0	180256009	4107731	
2533	260	4191853	1993-07-10	1993-07-10 00:00:00	38000275	0	\N	\N	17262	0	395142003	4191853	
14683	1310	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	86658	0	180256009	4107731	
2881	277	4151422	1986-11-20	1986-11-20 00:00:00	38000275	0	\N	\N	18458	0	269911007	4151422	
3148	311	4043071	1984-10-16	1984-10-16 00:00:00	38000275	0	\N	\N	20584	0	228557008	4043071	
3321	332	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	21887	0	395142003	4191853	
3505	338	4197460	1975-09-04	1975-09-04 00:00:00	38000275	0	\N	\N	22598	0	313191000	4197460	
3630	351	4295880	2001-10-04	2001-10-04 00:00:00	38000275	0	\N	\N	23364	0	76601001	4295880	
3872	387	4275113	1993-07-29	1993-07-29 00:00:00	38000275	0	\N	\N	25450	0	65200003	4275113	
4003	403	4078793	2009-03-30	2009-03-30 00:00:00	38000275	0	\N	\N	26444	0	180325003	4078793	
4193	409	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	27009	0	180256009	4107731	
16403	1430	4170947	1955-05-24	1955-05-24 00:00:00	38000275	0	\N	\N	95179	0	274474001	4170947	
4636	442	4107731	1990-03-10	1990-03-10 00:00:00	38000275	0	\N	\N	29281	0	180256009	4107731	
4827	449	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	29864	0	180256009	4107731	
4950	458	4037675	2012-08-03	2012-08-03 00:00:00	38000275	0	\N	\N	30640	0	162676008	4037675	
5142	480	4125906	1961-06-17	1961-06-17 00:00:00	38000275	0	\N	\N	31967	0	288086009	4125906	
5314	492	4024289	2014-08-07	2014-08-07 00:00:00	38000275	0	\N	\N	32906	0	19490002	4024289	
5503	505	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	33833	0	180256009	4107731	
5783	533	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	35471	0	180256009	4107731	
5884	539	4216130	1999-07-25	1999-07-25 00:00:00	38000275	0	\N	\N	35858	0	415070008	4216130	
6139	563	4107731	1992-05-17	1992-05-17 00:00:00	38000275	0	\N	\N	37265	0	180256009	4107731	
6259	580	4125906	1958-04-26	1958-04-26 00:00:00	38000275	0	\N	\N	38402	0	288086009	4125906	
6447	601	4107731	1992-11-01	1992-11-01 00:00:00	38000275	0	\N	\N	39671	0	180256009	4107731	
6643	608	4043071	1982-05-20	1982-05-20 00:00:00	38000275	0	\N	\N	40381	0	228557008	4043071	
6805	615	4107731	1991-03-23	1991-03-23 00:00:00	38000275	0	\N	\N	40970	0	180256009	4107731	
7043	648	4170947	2007-07-26	2007-07-26 00:00:00	38000275	0	\N	\N	42967	0	274474001	4170947	
7192	664	4107731	2013-09-03	2013-09-03 00:00:00	38000275	0	\N	\N	43857	0	180256009	4107731	
7371	685	4043071	1974-12-10	1974-12-10 00:00:00	38000275	0	\N	\N	45313	0	228557008	4043071	
7562	704	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	46520	0	180256009	4107731	
7792	711	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	47146	0	180256009	4107731	
8021	728	4043071	1964-10-26	1964-10-26 00:00:00	38000275	0	\N	\N	48309	0	228557008	4043071	
8118	742	4035793	2001-06-11	2001-06-11 00:00:00	38000275	0	\N	\N	49124	0	15081005	4035793	
8301	758	4151422	2000-05-04	2000-05-04 00:00:00	38000275	0	\N	\N	50316	0	269911007	4151422	
20480	1766	4035793	2019-04-02	2019-04-02 00:00:00	38000275	0	\N	\N	118199	0	15081005	4035793	
20679	1779	4197460	1946-12-07	1946-12-07 00:00:00	38000275	0	\N	\N	119063	0	313191000	4197460	
20822	1793	4195803	1988-06-01	1988-06-01 00:00:00	38000275	0	\N	\N	120170	0	312681000	4195803	
9114	842	4043071	1918-03-10	1918-03-10 00:00:00	38000275	0	\N	\N	55678	0	228557008	4043071	
9236	844	4107731	1991-07-06	1991-07-06 00:00:00	38000275	0	\N	\N	55997	0	180256009	4107731	
9491	863	4125906	1967-08-11	1967-08-11 00:00:00	38000275	0	\N	\N	57178	0	288086009	4125906	
21670	1882	4107731	1993-05-29	1993-05-29 00:00:00	38000275	0	\N	\N	125507	0	180256009	4107731	
9806	879	4043071	1963-03-15	1963-03-15 00:00:00	38000275	0	\N	\N	58557	0	228557008	4043071	
21904	1898	4151422	2007-09-12	2007-09-12 00:00:00	38000275	0	\N	\N	126344	0	269911007	4151422	
22069	1923	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	127920	0	180256009	4107731	
10358	918	4057420	2016-05-20	2016-05-20 00:00:00	38000275	0	\N	\N	61206	0	18286008	4057420	
10605	959	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	63720	0	180256009	4107731	
22648	1976	4295880	1998-12-14	1998-12-14 00:00:00	38000275	0	\N	\N	131424	0	76601001	4295880	
22834	1986	4043071	1989-05-18	1989-05-18 00:00:00	38000275	0	\N	\N	132244	0	228557008	4043071	
23004	1999	4107731	2014-12-03	2014-12-03 00:00:00	38000275	0	\N	\N	133154	0	180256009	4107731	
11363	1058	4107731	1991-03-23	1991-03-23 00:00:00	38000275	0	\N	\N	69487	0	180256009	4107731	
23452	2054	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	136598	0	180256009	4107731	
11676	1082	4107731	1991-06-15	1991-06-15 00:00:00	38000275	0	\N	\N	70937	0	180256009	4107731	
11924	1091	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	71635	0	180256009	4107731	
75	5	4024289	2012-10-08	2012-10-08 00:00:00	38000275	0	\N	\N	493	0	19490002	4024289	
267	16	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	1236	0	180256009	4107731	
540	36	4151422	2008-06-08	2008-06-08 00:00:00	38000275	0	\N	\N	2632	0	269911007	4151422	
12559	1138	4043071	1996-12-19	1996-12-19 00:00:00	38000275	0	\N	\N	75113	0	228557008	4043071	
12746	1145	4151422	1948-12-30	1948-12-30 00:00:00	38000275	0	\N	\N	75540	0	269911007	4151422	
1055	101	4078793	2017-08-04	2017-08-04 00:00:00	38000275	0	\N	\N	6960	0	180325003	4078793	
1205	124	4107731	2000-08-22	2000-08-22 00:00:00	38000275	0	\N	\N	8258	0	180256009	4107731	
1473	140	4295880	1997-09-25	1997-09-25 00:00:00	38000275	0	\N	\N	9359	0	76601001	4295880	
1675	154	4295880	1995-10-19	1995-10-19 00:00:00	38000275	0	\N	\N	10502	0	76601001	4295880	
1756	156	4151422	1982-07-05	1982-07-05 00:00:00	38000275	0	\N	\N	10653	0	269911007	4151422	
1955	180	4107731	1991-05-09	1991-05-09 00:00:00	38000275	0	\N	\N	12136	0	180256009	4107731	
2167	222	4170947	1958-05-10	1958-05-10 00:00:00	38000275	0	\N	\N	14931	0	274474001	4170947	
2373	236	4125906	2009-01-21	2009-01-21 00:00:00	38000275	0	\N	\N	15918	0	288086009	4125906	
2534	260	4107731	1993-03-06	1993-03-06 00:00:00	38000275	0	\N	\N	17259	0	180256009	4107731	
14684	1310	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	86638	0	180256009	4107731	
2882	277	4151422	2010-12-09	2010-12-09 00:00:00	38000275	0	\N	\N	18505	0	269911007	4151422	
3149	311	4043071	1985-01-22	1985-01-22 00:00:00	38000275	0	\N	\N	20626	0	228557008	4043071	
3322	332	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	21934	0	180256009	4107731	
3506	338	4238715	1987-01-21	1987-01-21 00:00:00	38000275	0	\N	\N	22550	0	68254000	4238715	
3631	351	4295880	1999-10-26	1999-10-26 00:00:00	38000275	0	\N	\N	23419	0	76601001	4295880	
3873	387	4238715	1994-10-21	1994-10-21 00:00:00	38000275	0	\N	\N	25506	0	68254000	4238715	
4004	403	4125906	1929-07-20	1929-07-20 00:00:00	38000275	0	\N	\N	26535	0	288086009	4125906	
4194	409	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	27044	0	180256009	4107731	
16404	1430	4125906	1972-02-24	1972-02-24 00:00:00	38000275	0	\N	\N	95181	0	288086009	4125906	
4637	442	4107731	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	29408	0	180256009	4107731	
4828	449	4191853	1984-11-21	1984-11-21 00:00:00	38000275	0	\N	\N	29904	0	395142003	4191853	
4951	458	4187458	2012-08-03	2012-08-03 00:00:00	38000275	0	\N	\N	30640	0	415300000	4187458	
5143	480	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	32050	0	180256009	4107731	
5315	492	4170947	2014-08-07	2014-08-07 00:00:00	38000275	0	\N	\N	32906	0	274474001	4170947	
5504	505	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	33778	0	180256009	4107731	
5784	533	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	35493	0	180256009	4107731	
5885	539	4057420	1972-01-02	1972-01-02 00:00:00	38000275	0	\N	\N	35857	0	18286008	4057420	
6140	563	4107731	1992-11-01	1992-11-01 00:00:00	38000275	0	\N	\N	37282	0	180256009	4107731	
6263	582	4151422	1996-10-02	1996-10-02 00:00:00	38000275	0	\N	\N	38579	0	269911007	4151422	
6448	601	4191853	1993-07-11	1993-07-11 00:00:00	38000275	0	\N	\N	39740	0	395142003	4191853	
6644	608	4043071	1982-01-21	1982-01-21 00:00:00	38000275	0	\N	\N	40379	0	228557008	4043071	
6806	615	4107731	1990-10-06	1990-10-06 00:00:00	38000275	0	\N	\N	41004	0	180256009	4107731	
7044	648	4170947	2000-02-03	2000-02-03 00:00:00	38000275	0	\N	\N	42965	0	274474001	4170947	
7193	664	4107731	2010-11-09	2010-11-09 00:00:00	38000275	0	\N	\N	43869	0	180256009	4107731	
7372	685	4043071	1976-06-01	1976-06-01 00:00:00	38000275	0	\N	\N	45320	0	228557008	4043071	
7563	704	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	46574	0	180256009	4107731	
7793	711	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	47144	0	180256009	4107731	
8022	728	4043071	1964-05-25	1964-05-25 00:00:00	38000275	0	\N	\N	48307	0	228557008	4043071	
8119	742	4035793	1983-10-10	1983-10-10 00:00:00	38000275	0	\N	\N	49205	0	15081005	4035793	
8302	759	4078793	2012-04-11	2012-04-11 00:00:00	38000275	0	\N	\N	50409	0	180325003	4078793	
20481	1766	4035793	2002-06-11	2002-06-11 00:00:00	38000275	0	\N	\N	118166	0	15081005	4035793	
20680	1779	4125906	2002-12-07	2002-12-07 00:00:00	38000275	0	\N	\N	119009	0	288086009	4125906	
20823	1794	4198190	1972-02-06	1972-02-06 00:00:00	38000275	0	\N	\N	120296	0	80146002	4198190	
9115	842	4035793	1984-03-31	1984-03-31 00:00:00	38000275	0	\N	\N	55738	0	15081005	4035793	
9237	844	4107731	1993-01-02	1993-01-02 00:00:00	38000275	0	\N	\N	55964	0	180256009	4107731	
9492	863	4057420	1996-04-25	1996-04-25 00:00:00	38000275	0	\N	\N	57193	0	18286008	4057420	
21671	1882	4107731	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	125574	0	180256009	4107731	
9807	879	4043071	1963-04-12	1963-04-12 00:00:00	38000275	0	\N	\N	58521	0	228557008	4043071	
21911	1902	4024289	1958-01-13	1958-01-13 00:00:00	38000275	0	\N	\N	126623	0	19490002	4024289	
22070	1923	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	128008	0	180256009	4107731	
10359	918	40492359	2016-05-20	2016-05-20 00:00:00	38000275	0	\N	\N	61206	0	447365002	40492359	
10606	959	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	63766	0	180256009	4107731	
22649	1976	4107731	1998-09-07	1998-09-07 00:00:00	38000275	0	\N	\N	131360	0	180256009	4107731	
22835	1986	4043071	1988-12-22	1988-12-22 00:00:00	38000275	0	\N	\N	132238	0	228557008	4043071	
23005	1999	4107731	2014-05-07	2014-05-07 00:00:00	38000275	0	\N	\N	133101	0	180256009	4107731	
11364	1058	4107731	1990-12-08	1990-12-08 00:00:00	38000275	0	\N	\N	69362	0	180256009	4107731	
23453	2054	4275113	1987-06-12	1987-06-12 00:00:00	38000275	0	\N	\N	136674	0	65200003	4275113	
11677	1082	4107731	1991-09-28	1991-09-28 00:00:00	38000275	0	\N	\N	71003	0	180256009	4107731	
11925	1091	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	71638	0	180256009	4107731	
76	5	4170947	2012-10-08	2012-10-08 00:00:00	38000275	0	\N	\N	493	0	274474001	4170947	
268	16	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	1274	0	180256009	4107731	
541	36	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	2642	0	180256009	4107731	
12560	1138	4043071	1997-03-13	1997-03-13 00:00:00	38000275	0	\N	\N	74996	0	228557008	4043071	
12747	1145	4125906	2006-08-02	2006-08-02 00:00:00	38000275	0	\N	\N	75557	0	288086009	4125906	
1056	101	4078793	2015-07-24	2015-07-24 00:00:00	38000275	0	\N	\N	6959	0	180325003	4078793	
1206	124	4107731	2000-05-09	2000-05-09 00:00:00	38000275	0	\N	\N	8205	0	180256009	4107731	
1474	140	4295880	2000-06-22	2000-06-22 00:00:00	38000275	0	\N	\N	9402	0	76601001	4295880	
1676	154	4295880	1997-07-17	1997-07-17 00:00:00	38000275	0	\N	\N	10459	0	76601001	4295880	
1761	158	4047491	1948-10-25	1948-10-25 00:00:00	38000275	0	\N	\N	10847	0	1225002	4047491	
1956	180	4107731	1990-07-19	1990-07-19 00:00:00	38000275	0	\N	\N	12110	0	180256009	4107731	
2169	224	4125906	1996-02-19	1996-02-19 00:00:00	38000275	0	\N	\N	15109	0	288086009	4125906	
2374	236	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	15889	0	180256009	4107731	
2535	260	4151422	1979-09-06	1979-09-06 00:00:00	38000275	0	\N	\N	17156	0	269911007	4151422	
14685	1310	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	86594	0	180256009	4107731	
2883	277	4202451	2005-11-29	2005-11-29 00:00:00	38000275	0	\N	\N	18469	0	433112001	4202451	
3150	311	4125906	1978-05-22	1978-05-22 00:00:00	38000275	0	\N	\N	20650	0	288086009	4125906	
3323	332	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	21973	0	180256009	4107731	
3507	338	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	22498	0	180256009	4107731	
3632	351	4295880	2004-04-20	2004-04-20 00:00:00	38000275	0	\N	\N	23367	0	76601001	4295880	
3874	387	4151422	1975-08-22	1975-08-22 00:00:00	38000275	0	\N	\N	25447	0	269911007	4151422	
4005	403	4078793	2005-03-07	2005-03-07 00:00:00	38000275	0	\N	\N	26442	0	180325003	4078793	
4195	409	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	27144	0	180256009	4107731	
16405	1430	4198190	1965-11-18	1965-11-18 00:00:00	38000275	0	\N	\N	95124	0	80146002	4198190	
4638	442	4107731	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	29298	0	180256009	4107731	
4829	449	4163872	2001-02-19	2001-02-19 00:00:00	38000275	0	\N	\N	29918	0	399208008	4163872	
4952	458	4252419	2010-06-25	2010-06-25 00:00:00	38000275	0	\N	\N	30615	0	74016001	4252419	
5144	480	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	32076	0	180256009	4107731	
5316	492	4195803	2014-08-07	2014-08-07 00:00:00	38000275	0	\N	\N	32906	0	312681000	4195803	
5505	505	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	33777	0	180256009	4107731	
5785	533	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	35477	0	180256009	4107731	
5886	539	40492359	1972-01-02	1972-01-02 00:00:00	38000275	0	\N	\N	35857	0	447365002	40492359	
6141	563	4107731	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	37286	0	180256009	4107731	
6264	582	4170947	1961-01-22	1961-01-22 00:00:00	38000275	0	\N	\N	38553	0	274474001	4170947	
6449	601	4107731	1991-05-26	1991-05-26 00:00:00	38000275	0	\N	\N	39777	0	180256009	4107731	
6645	608	4330583	2016-12-22	2016-12-22 00:00:00	38000275	0	\N	\N	40396	0	22523008	4330583	
6807	615	4107731	1992-02-22	1992-02-22 00:00:00	38000275	0	\N	\N	40979	0	180256009	4107731	
7045	648	4047491	2000-02-03	2000-02-03 00:00:00	38000275	0	\N	\N	42965	0	1225002	4047491	
7194	664	4107731	2011-10-11	2011-10-11 00:00:00	38000275	0	\N	\N	43811	0	180256009	4107731	
7373	685	4043071	1976-03-23	1976-03-23 00:00:00	38000275	0	\N	\N	45354	0	228557008	4043071	
7564	704	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	46522	0	180256009	4107731	
7794	711	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	47093	0	180256009	4107731	
8023	728	4125906	1993-06-29	1993-06-29 00:00:00	38000275	0	\N	\N	48313	0	288086009	4125906	
8120	742	4078793	2011-03-21	2011-03-21 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
8303	759	4078793	2016-05-04	2016-05-04 00:00:00	38000275	0	\N	\N	50371	0	180325003	4078793	
20482	1766	4035793	2014-11-11	2014-11-11 00:00:00	38000275	0	\N	\N	118146	0	15081005	4035793	
20681	1779	40492359	1949-09-15	1949-09-15 00:00:00	38000275	0	\N	\N	119064	0	447365002	40492359	
20824	1794	4125906	1990-04-25	1990-04-25 00:00:00	38000275	0	\N	\N	120328	0	288086009	4125906	
9116	842	4035793	2013-10-12	2013-10-12 00:00:00	38000275	0	\N	\N	55684	0	15081005	4035793	
9238	844	4107731	1990-08-04	1990-08-04 00:00:00	38000275	0	\N	\N	56013	0	180256009	4107731	
9493	863	4078793	1986-02-27	1986-02-27 00:00:00	38000275	0	\N	\N	57113	0	180325003	4078793	
21672	1882	4107731	1990-03-31	1990-03-31 00:00:00	38000275	0	\N	\N	125555	0	180256009	4107731	
9808	879	4043071	1963-05-17	1963-05-17 00:00:00	38000275	0	\N	\N	58522	0	228557008	4043071	
21912	1902	4170947	1958-01-13	1958-01-13 00:00:00	38000275	0	\N	\N	126623	0	274474001	4170947	
22071	1923	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	127883	0	180256009	4107731	
10360	919	4151422	2002-01-30	2002-01-30 00:00:00	38000275	0	\N	\N	61256	0	269911007	4151422	
10607	959	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	63680	0	180256009	4107731	
22650	1977	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	131592	0	180256009	4107731	
22836	1987	4058899	1948-04-18	1948-04-18 00:00:00	38000275	0	\N	\N	132360	0	168594001	4058899	
23006	1999	4107731	2012-04-11	2012-04-11 00:00:00	38000275	0	\N	\N	133115	0	180256009	4107731	
11365	1058	4107731	1993-01-02	1993-01-02 00:00:00	38000275	0	\N	\N	69418	0	180256009	4107731	
23454	2054	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	136644	0	180256009	4107731	
11678	1082	4107731	1992-10-10	1992-10-10 00:00:00	38000275	0	\N	\N	70963	0	180256009	4107731	
11926	1091	4125906	2016-04-07	2016-04-07 00:00:00	38000275	0	\N	\N	71727	0	288086009	4125906	
77	5	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	451	0	180256009	4107731	
269	16	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	1277	0	395142003	4191853	
542	36	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	2538	0	180256009	4107731	
12561	1138	4043071	1996-08-15	1996-08-15 00:00:00	38000275	0	\N	\N	75089	0	228557008	4043071	
12748	1145	4243062	2011-12-18	2011-12-18 00:00:00	38000275	0	\N	\N	75558	0	60027007	4243062	
1057	101	4078793	2018-08-10	2018-08-10 00:00:00	38000275	0	\N	\N	6879	0	180325003	4078793	
1207	124	4107731	2000-05-30	2000-05-30 00:00:00	38000275	0	\N	\N	8198	0	180256009	4107731	
1475	140	4295880	1997-06-26	1997-06-26 00:00:00	38000275	0	\N	\N	9398	0	76601001	4295880	
1677	154	4295880	1997-04-17	1997-04-17 00:00:00	38000275	0	\N	\N	10477	0	76601001	4295880	
1762	158	4170947	1948-10-25	1948-10-25 00:00:00	38000275	0	\N	\N	10847	0	274474001	4170947	
1957	180	4107731	1992-01-16	1992-01-16 00:00:00	38000275	0	\N	\N	12194	0	180256009	4107731	
2170	224	4181917	1954-10-10	1954-10-10 00:00:00	38000275	0	\N	\N	15088	0	54550000	4181917	
2375	236	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	15897	0	180256009	4107731	
2536	260	4107731	1990-12-08	1990-12-08 00:00:00	38000275	0	\N	\N	17169	0	180256009	4107731	
14686	1310	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	86593	0	180256009	4107731	
2904	279	4293740	2012-02-27	2012-02-27 00:00:00	38000275	0	\N	\N	18613	0	384700001	4293740	
3151	311	4043071	1985-05-07	1985-05-07 00:00:00	38000275	0	\N	\N	20585	0	228557008	4043071	
3324	332	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	22040	0	180256009	4107731	
3508	338	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	22507	0	180256009	4107731	
3633	351	4295880	2004-10-19	2004-10-19 00:00:00	38000275	0	\N	\N	23371	0	76601001	4295880	
3875	387	4243062	1998-04-04	1998-04-04 00:00:00	38000275	0	\N	\N	25458	0	60027007	4243062	
4006	403	4078793	2002-02-18	2002-02-18 00:00:00	38000275	0	\N	\N	26527	0	180325003	4078793	
4196	409	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	27121	0	180256009	4107731	
16406	1430	4195803	2004-10-12	2004-10-12 00:00:00	38000275	0	\N	\N	95168	0	312681000	4195803	
4639	442	4107731	1993-01-02	1993-01-02 00:00:00	38000275	0	\N	\N	29269	0	180256009	4107731	
4830	449	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	29931	0	180256009	4107731	
4953	458	4151422	1991-12-12	1991-12-12 00:00:00	38000275	0	\N	\N	30648	0	269911007	4151422	
5145	480	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	32103	0	180256009	4107731	
5317	492	4293740	1968-07-25	1968-07-25 00:00:00	38000275	0	\N	\N	32905	0	384700001	4293740	
5506	505	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	33770	0	180256009	4107731	
5786	533	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	35462	0	180256009	4107731	
5887	539	44783196	1956-01-02	1956-01-02 00:00:00	38000275	0	\N	\N	35859	0	699253003	44783196	
6142	563	4107731	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	37220	0	180256009	4107731	
6265	582	4024289	1961-01-22	1961-01-22 00:00:00	38000275	0	\N	\N	38553	0	19490002	4024289	
6450	601	4107731	1991-12-22	1991-12-22 00:00:00	38000275	0	\N	\N	39667	0	180256009	4107731	
6646	608	4151422	2004-03-27	2004-03-27 00:00:00	38000275	0	\N	\N	40383	0	269911007	4151422	
6808	615	4107731	1992-04-25	1992-04-25 00:00:00	38000275	0	\N	\N	40976	0	180256009	4107731	
7046	648	4195803	2000-02-03	2000-02-03 00:00:00	38000275	0	\N	\N	42965	0	312681000	4195803	
7195	664	4107731	2012-03-27	2012-03-27 00:00:00	38000275	0	\N	\N	43843	0	180256009	4107731	
7374	685	4043071	1974-05-07	1974-05-07 00:00:00	38000275	0	\N	\N	45251	0	228557008	4043071	
7565	704	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	46561	0	180256009	4107731	
7795	711	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	47098	0	180256009	4107731	
8024	728	4043071	1964-11-23	1964-11-23 00:00:00	38000275	0	\N	\N	48349	0	228557008	4043071	
8121	742	4035793	2006-07-10	2006-07-10 00:00:00	38000275	0	\N	\N	49213	0	15081005	4035793	
8304	759	4078793	2010-03-31	2010-03-31 00:00:00	38000275	0	\N	\N	50408	0	180325003	4078793	
20483	1766	4035793	2009-10-13	2009-10-13 00:00:00	38000275	0	\N	\N	118197	0	15081005	4035793	
20682	1779	4057420	1949-09-15	1949-09-15 00:00:00	38000275	0	\N	\N	119064	0	18286008	4057420	
20825	1794	4293740	1990-04-25	1990-04-25 00:00:00	38000275	0	\N	\N	120328	0	384700001	4293740	
9117	842	4035793	2009-09-19	2009-09-19 00:00:00	38000275	0	\N	\N	55690	0	15081005	4035793	
9239	844	4107731	1991-11-09	1991-11-09 00:00:00	38000275	0	\N	\N	55891	0	180256009	4107731	
9494	863	4078793	1982-02-04	1982-02-04 00:00:00	38000275	0	\N	\N	57135	0	180325003	4078793	
21673	1882	4107731	1990-01-27	1990-01-27 00:00:00	38000275	0	\N	\N	125604	0	180256009	4107731	
9814	882	4151422	2018-09-03	2018-09-03 00:00:00	38000275	0	\N	\N	58761	0	269911007	4151422	
21913	1903	4181917	1976-05-18	1976-05-18 00:00:00	38000275	0	\N	\N	126665	0	54550000	4181917	
22072	1923	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	127908	0	180256009	4107731	
10361	919	4151422	1975-09-09	1975-09-09 00:00:00	38000275	0	\N	\N	61252	0	269911007	4151422	
10608	959	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	63723	0	180256009	4107731	
22651	1977	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	131610	0	180256009	4107731	
22837	1987	4058899	1967-10-06	1967-10-06 00:00:00	38000275	0	\N	\N	132288	0	168594001	4058899	
23007	1999	4107731	2012-09-26	2012-09-26 00:00:00	38000275	0	\N	\N	133088	0	180256009	4107731	
11366	1058	44783196	2004-06-06	2004-06-06 00:00:00	38000275	0	\N	\N	69405	0	699253003	44783196	
23455	2054	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	136643	0	180256009	4107731	
11679	1082	4107731	1992-02-22	1992-02-22 00:00:00	38000275	0	\N	\N	71047	0	180256009	4107731	
11927	1091	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	71646	0	180256009	4107731	
78	5	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	502	0	180256009	4107731	
270	16	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	1180	0	180256009	4107731	
543	36	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	2641	0	180256009	4107731	
12562	1138	4107731	1994-01-27	1994-01-27 00:00:00	38000275	0	\N	\N	75067	0	180256009	4107731	
12749	1145	4195803	2011-12-18	2011-12-18 00:00:00	38000275	0	\N	\N	75558	0	312681000	4195803	
1058	101	4151422	1973-02-28	1973-02-28 00:00:00	38000275	0	\N	\N	6836	0	269911007	4151422	
1208	124	4107731	1997-05-13	1997-05-13 00:00:00	38000275	0	\N	\N	8319	0	180256009	4107731	
1476	140	4295880	1996-03-25	1996-03-25 00:00:00	38000275	0	\N	\N	9411	0	76601001	4295880	
1678	154	4295880	1996-01-18	1996-01-18 00:00:00	38000275	0	\N	\N	10457	0	76601001	4295880	
1763	158	4163872	1953-08-31	1953-08-31 00:00:00	38000275	0	\N	\N	10844	0	399208008	4163872	
1958	180	4107731	1990-12-13	1990-12-13 00:00:00	38000275	0	\N	\N	12124	0	180256009	4107731	
2171	224	4195803	2009-07-24	2009-07-24 00:00:00	38000275	0	\N	\N	15110	0	312681000	4195803	
2376	236	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	15888	0	180256009	4107731	
2537	260	4107731	1993-05-08	1993-05-08 00:00:00	38000275	0	\N	\N	17217	0	180256009	4107731	
14687	1310	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	86637	0	180256009	4107731	
2905	279	4125906	2012-02-27	2012-02-27 00:00:00	38000275	0	\N	\N	18613	0	288086009	4125906	
3152	311	4043071	1984-12-25	1984-12-25 00:00:00	38000275	0	\N	\N	20633	0	228557008	4043071	
3325	332	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	21967	0	180256009	4107731	
3509	338	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	22491	0	180256009	4107731	
3634	351	4295880	1999-07-27	1999-07-27 00:00:00	38000275	0	\N	\N	23360	0	76601001	4295880	
3876	387	4170947	1998-04-04	1998-04-04 00:00:00	38000275	0	\N	\N	25458	0	274474001	4170947	
4007	403	4078793	2008-03-24	2008-03-24 00:00:00	38000275	0	\N	\N	26471	0	180325003	4078793	
4197	409	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	27148	0	180256009	4107731	
16407	1430	4293740	1986-04-25	1986-04-25 00:00:00	38000275	0	\N	\N	95182	0	384700001	4293740	
4640	442	4107731	1991-10-19	1991-10-19 00:00:00	38000275	0	\N	\N	29355	0	180256009	4107731	
4831	449	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	29978	0	180256009	4107731	
4954	459	4170947	2013-12-16	2013-12-16 00:00:00	38000275	0	\N	\N	30714	0	274474001	4170947	
5146	480	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	31993	0	180256009	4107731	
5318	492	4125906	1968-07-25	1968-07-25 00:00:00	38000275	0	\N	\N	32905	0	288086009	4125906	
5507	505	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	33767	0	180256009	4107731	
5787	533	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	35372	0	180256009	4107731	
5888	539	4252419	1955-12-26	1955-12-26 00:00:00	38000275	0	\N	\N	35824	0	74016001	4252419	
6143	563	4107731	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	37249	0	180256009	4107731	
6266	582	4163872	2016-09-10	2016-09-10 00:00:00	38000275	0	\N	\N	38557	0	399208008	4163872	
6451	601	4107731	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	39670	0	180256009	4107731	
6647	608	4043071	1982-07-15	1982-07-15 00:00:00	38000275	0	\N	\N	40362	0	228557008	4043071	
6809	615	4107731	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	41008	0	180256009	4107731	
7047	648	4151422	1951-12-20	1951-12-20 00:00:00	38000275	0	\N	\N	42844	0	269911007	4151422	
7196	665	4170947	1966-12-30	1966-12-30 00:00:00	38000275	0	\N	\N	43937	0	274474001	4170947	
7375	685	4043071	1974-11-05	1974-11-05 00:00:00	38000275	0	\N	\N	45312	0	228557008	4043071	
7566	704	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	46537	0	180256009	4107731	
7796	711	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	47114	0	180256009	4107731	
8025	728	4043071	1964-04-20	1964-04-20 00:00:00	38000275	0	\N	\N	48306	0	228557008	4043071	
8122	742	4035793	2003-06-23	2003-06-23 00:00:00	38000275	0	\N	\N	49181	0	15081005	4035793	
8305	759	4293740	1969-03-28	1969-03-28 00:00:00	38000275	0	\N	\N	50358	0	384700001	4293740	
20484	1766	4035793	2004-09-14	2004-09-14 00:00:00	38000275	0	\N	\N	118167	0	15081005	4035793	
20683	1780	4170947	1989-02-09	1989-02-09 00:00:00	38000275	0	\N	\N	119144	0	274474001	4170947	
20826	1794	4125906	2005-03-21	2005-03-21 00:00:00	38000275	0	\N	\N	120329	0	288086009	4125906	
9118	842	4043071	1918-02-03	1918-02-03 00:00:00	38000275	0	\N	\N	55677	0	228557008	4043071	
9240	844	4107731	1992-02-22	1992-02-22 00:00:00	38000275	0	\N	\N	55960	0	180256009	4107731	
9495	863	4078793	2009-07-09	2009-07-09 00:00:00	38000275	0	\N	\N	57196	0	180325003	4078793	
21674	1882	4107731	1991-05-04	1991-05-04 00:00:00	38000275	0	\N	\N	125591	0	180256009	4107731	
9815	882	4202451	2016-12-10	2016-12-10 00:00:00	38000275	0	\N	\N	58720	0	433112001	4202451	
21914	1903	4125906	2009-05-04	2009-05-04 00:00:00	38000275	0	\N	\N	126667	0	288086009	4125906	
22073	1923	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	127884	0	180256009	4107731	
10365	921	4125906	1999-12-26	1999-12-26 00:00:00	38000275	0	\N	\N	61384	0	288086009	4125906	
10609	959	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	63787	0	180256009	4107731	
22652	1977	4078793	2016-06-23	2016-06-23 00:00:00	38000275	0	\N	\N	131569	0	180325003	4078793	
22838	1987	4125906	1993-10-19	1993-10-19 00:00:00	38000275	0	\N	\N	132289	0	288086009	4125906	
23008	1999	4107731	2013-06-26	2013-06-26 00:00:00	38000275	0	\N	\N	133091	0	180256009	4107731	
11367	1058	4107731	1991-02-09	1991-02-09 00:00:00	38000275	0	\N	\N	69468	0	180256009	4107731	
23456	2054	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	136641	0	180256009	4107731	
11680	1082	4107731	1993-03-27	1993-03-27 00:00:00	38000275	0	\N	\N	70989	0	180256009	4107731	
11928	1091	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	71648	0	180256009	4107731	
79	5	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	437	0	180256009	4107731	
271	16	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	1267	0	180256009	4107731	
544	36	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	2643	0	180256009	4107731	
12563	1138	4043071	1996-02-08	1996-02-08 00:00:00	38000275	0	\N	\N	75084	0	228557008	4043071	
12750	1145	4170947	2011-12-18	2011-12-18 00:00:00	38000275	0	\N	\N	75558	0	274474001	4170947	
1059	101	4125906	1986-12-21	1986-12-21 00:00:00	38000275	0	\N	\N	6900	0	288086009	4125906	
1209	124	4107731	1998-09-08	1998-09-08 00:00:00	38000275	0	\N	\N	8308	0	180256009	4107731	
1477	140	4295880	1997-03-27	1997-03-27 00:00:00	38000275	0	\N	\N	9383	0	76601001	4295880	
1679	154	4295880	1996-10-17	1996-10-17 00:00:00	38000275	0	\N	\N	10458	0	76601001	4295880	
1764	158	4125906	1975-02-09	1975-02-09 00:00:00	38000275	0	\N	\N	10851	0	288086009	4125906	
1959	180	4243062	1979-03-12	1979-03-12 00:00:00	38000275	0	\N	\N	12196	0	60027007	4243062	
2172	224	4170947	2009-07-24	2009-07-24 00:00:00	38000275	0	\N	\N	15110	0	274474001	4170947	
2377	236	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	15899	0	180256009	4107731	
2538	260	4107731	1992-11-21	1992-11-21 00:00:00	38000275	0	\N	\N	17252	0	180256009	4107731	
14688	1310	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	86588	0	180256009	4107731	
2906	280	4336464	2019-05-31	2019-05-31 00:00:00	38000275	0	\N	\N	18709	0	232717009	4336464	
3153	311	4043071	1984-08-21	1984-08-21 00:00:00	38000275	0	\N	\N	20625	0	228557008	4043071	
3326	332	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	21930	0	180256009	4107731	
3510	338	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	22524	0	180256009	4107731	
3635	351	4295880	2005-07-19	2005-07-19 00:00:00	38000275	0	\N	\N	23372	0	76601001	4295880	
3877	388	4125906	2000-04-04	2000-04-04 00:00:00	38000275	0	\N	\N	25585	0	288086009	4125906	
4008	403	4243062	1946-03-28	1946-03-28 00:00:00	38000275	0	\N	\N	26462	0	60027007	4243062	
4198	409	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	27099	0	180256009	4107731	
16408	1430	4125906	1986-04-25	1986-04-25 00:00:00	38000275	0	\N	\N	95182	0	288086009	4125906	
4641	442	4107731	1990-04-21	1990-04-21 00:00:00	38000275	0	\N	\N	29282	0	180256009	4107731	
4832	449	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	29906	0	180256009	4107731	
4955	459	4047491	2013-12-16	2013-12-16 00:00:00	38000275	0	\N	\N	30714	0	1225002	4047491	
5147	480	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	32071	0	395142003	4191853	
5319	495	4151422	2006-01-22	2006-01-22 00:00:00	38000275	0	\N	\N	33042	0	269911007	4151422	
5508	505	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	33754	0	180256009	4107731	
5788	533	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	35421	0	180256009	4107731	
5889	539	4181917	1933-03-26	1933-03-26 00:00:00	38000275	0	\N	\N	35823	0	54550000	4181917	
6144	563	4107731	1990-12-09	1990-12-09 00:00:00	38000275	0	\N	\N	37213	0	180256009	4107731	
6267	582	4170947	2016-09-10	2016-09-10 00:00:00	38000275	0	\N	\N	38557	0	274474001	4170947	
6452	601	4107731	1992-08-09	1992-08-09 00:00:00	38000275	0	\N	\N	39751	0	180256009	4107731	
6648	608	4043071	1982-06-17	1982-06-17 00:00:00	38000275	0	\N	\N	40395	0	228557008	4043071	
6810	615	4107731	1991-11-09	1991-11-09 00:00:00	38000275	0	\N	\N	40938	0	180256009	4107731	
7048	648	4163872	1984-05-21	1984-05-21 00:00:00	38000275	0	\N	\N	42889	0	399208008	4163872	
7197	665	4024289	1966-12-30	1966-12-30 00:00:00	38000275	0	\N	\N	43937	0	19490002	4024289	
7376	685	4043071	1977-06-07	1977-06-07 00:00:00	38000275	0	\N	\N	45297	0	228557008	4043071	
7567	704	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	46567	0	180256009	4107731	
7797	711	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	47169	0	180256009	4107731	
8026	728	4198190	1960-01-22	1960-01-22 00:00:00	38000275	0	\N	\N	48274	0	80146002	4198190	
8123	742	4035793	2010-08-02	2010-08-02 00:00:00	38000275	0	\N	\N	49125	0	15081005	4035793	
8306	759	4125906	1969-03-28	1969-03-28 00:00:00	38000275	0	\N	\N	50358	0	288086009	4125906	
20485	1766	4035793	2006-09-26	2006-09-26 00:00:00	38000275	0	\N	\N	118168	0	15081005	4035793	
20684	1780	4243062	1989-02-09	1989-02-09 00:00:00	38000275	0	\N	\N	119144	0	60027007	4243062	
20828	1796	4125906	1997-06-28	1997-06-28 00:00:00	38000275	0	\N	\N	120433	0	288086009	4125906	
9119	842	4035793	1977-12-24	1977-12-24 00:00:00	38000275	0	\N	\N	55663	0	15081005	4035793	
9241	844	4107731	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	55984	0	180256009	4107731	
9496	863	4078793	2004-06-10	2004-06-10 00:00:00	38000275	0	\N	\N	57227	0	180325003	4078793	
21675	1882	4107731	1991-09-07	1991-09-07 00:00:00	38000275	0	\N	\N	125572	0	180256009	4107731	
9816	882	4252419	2015-05-18	2015-05-18 00:00:00	38000275	0	\N	\N	58724	0	74016001	4252419	
21915	1903	4181917	1975-06-16	1975-06-16 00:00:00	38000275	0	\N	\N	126664	0	54550000	4181917	
22074	1923	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	127881	0	180256009	4107731	
10366	921	4125906	1981-04-13	1981-04-13 00:00:00	38000275	0	\N	\N	61344	0	288086009	4125906	
10610	959	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	63724	0	180256009	4107731	
22653	1977	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	131636	0	180256009	4107731	
22839	1987	4125906	2003-07-25	2003-07-25 00:00:00	38000275	0	\N	\N	132291	0	288086009	4125906	
23009	1999	4107731	2014-02-12	2014-02-12 00:00:00	38000275	0	\N	\N	133134	0	180256009	4107731	
11368	1058	4107731	1991-09-28	1991-09-28 00:00:00	38000275	0	\N	\N	69470	0	180256009	4107731	
23457	2054	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	136654	0	180256009	4107731	
11681	1082	4191853	1993-07-10	1993-07-10 00:00:00	38000275	0	\N	\N	71021	0	395142003	4191853	
11929	1091	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	71642	0	180256009	4107731	
80	5	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	452	0	180256009	4107731	
272	16	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	1271	0	180256009	4107731	
545	36	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	2551	0	180256009	4107731	
12564	1138	4107731	1995-09-07	1995-09-07 00:00:00	38000275	0	\N	\N	75082	0	180256009	4107731	
12751	1146	4195803	2001-09-11	2001-09-11 00:00:00	38000275	0	\N	\N	75753	0	312681000	4195803	
1060	101	4078793	2010-06-25	2010-06-25 00:00:00	38000275	0	\N	\N	6852	0	180325003	4078793	
1210	124	4107731	1999-08-31	1999-08-31 00:00:00	38000275	0	\N	\N	8194	0	180256009	4107731	
1478	140	4295880	2000-03-23	2000-03-23 00:00:00	38000275	0	\N	\N	9344	0	76601001	4295880	
1680	154	4295880	1998-07-16	1998-07-16 00:00:00	38000275	0	\N	\N	10492	0	76601001	4295880	
1765	158	4125906	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	10791	0	288086009	4125906	
1960	180	4170947	1979-03-12	1979-03-12 00:00:00	38000275	0	\N	\N	12196	0	274474001	4170947	
2173	224	4047491	2009-07-24	2009-07-24 00:00:00	38000275	0	\N	\N	15110	0	1225002	4047491	
2378	236	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	15929	0	180256009	4107731	
2539	260	4107731	1991-03-23	1991-03-23 00:00:00	38000275	0	\N	\N	17229	0	180256009	4107731	
14689	1310	4170947	1968-02-03	1968-02-03 00:00:00	38000275	0	\N	\N	86678	0	274474001	4170947	
2907	280	4216130	2019-05-31	2019-05-31 00:00:00	38000275	0	\N	\N	18709	0	415070008	4216130	
3154	312	4145310	1977-04-27	1977-04-27 00:00:00	38000275	0	\N	\N	20657	0	268425006	4145310	
3327	332	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	22057	0	180256009	4107731	
3511	338	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	22490	0	180256009	4107731	
3636	351	4295880	2000-10-24	2000-10-24 00:00:00	38000275	0	\N	\N	23414	0	76601001	4295880	
3878	388	4125906	2006-02-16	2006-02-16 00:00:00	38000275	0	\N	\N	25586	0	288086009	4125906	
4009	403	4170947	1946-03-28	1946-03-28 00:00:00	38000275	0	\N	\N	26462	0	274474001	4170947	
4199	409	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	27129	0	180256009	4107731	
16409	1431	4107731	1991-11-30	1991-11-30 00:00:00	38000275	0	\N	\N	95268	0	180256009	4107731	
4642	442	4107731	1991-05-04	1991-05-04 00:00:00	38000275	0	\N	\N	29324	0	180256009	4107731	
4833	449	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	29935	0	180256009	4107731	
4956	459	4252419	1984-12-20	1984-12-20 00:00:00	38000275	0	\N	\N	30712	0	74016001	4252419	
5148	480	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	32109	0	180256009	4107731	
5320	495	4125906	2001-10-13	2001-10-13 00:00:00	38000275	0	\N	\N	33107	0	288086009	4125906	
5509	505	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	33836	0	180256009	4107731	
5789	533	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	35456	0	180256009	4107731	
5890	539	4293740	1971-04-04	1971-04-04 00:00:00	38000275	0	\N	\N	35826	0	384700001	4293740	
6145	563	4107731	1992-11-22	1992-11-22 00:00:00	38000275	0	\N	\N	37266	0	180256009	4107731	
6268	582	4195803	2016-09-10	2016-09-10 00:00:00	38000275	0	\N	\N	38557	0	312681000	4195803	
6453	601	4107731	1991-10-20	1991-10-20 00:00:00	38000275	0	\N	\N	39705	0	180256009	4107731	
6649	608	4125906	1988-04-04	1988-04-04 00:00:00	38000275	0	\N	\N	40407	0	288086009	4125906	
6811	616	4024289	1959-11-29	1959-11-29 00:00:00	38000275	0	\N	\N	41085	0	19490002	4024289	
7049	648	4202451	2018-01-19	2018-01-19 00:00:00	38000275	0	\N	\N	42968	0	433112001	4202451	
7198	665	4151422	1995-08-02	1995-08-02 00:00:00	38000275	0	\N	\N	43980	0	269911007	4151422	
7377	685	4043071	1977-09-06	1977-09-06 00:00:00	38000275	0	\N	\N	45258	0	228557008	4043071	
7568	704	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	46589	0	180256009	4107731	
7798	711	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	47097	0	180256009	4107731	
8027	728	4125906	1960-11-21	1960-11-21 00:00:00	38000275	0	\N	\N	48311	0	288086009	4125906	
8124	742	4057420	2010-08-02	2010-08-02 00:00:00	38000275	0	\N	\N	49125	0	18286008	4057420	
8307	759	4078793	2008-03-19	2008-03-19 00:00:00	38000275	0	\N	\N	50443	0	180325003	4078793	
20486	1766	4035793	2015-11-17	2015-11-17 00:00:00	38000275	0	\N	\N	118186	0	15081005	4035793	
20685	1780	4062501	1967-06-22	1967-06-22 00:00:00	38000275	0	\N	\N	119105	0	171231001	4062501	
20917	1801	4078793	2015-09-23	2015-09-23 00:00:00	38000275	0	\N	\N	120791	0	180325003	4078793	
9120	842	4035793	1997-07-12	1997-07-12 00:00:00	38000275	0	\N	\N	55697	0	15081005	4035793	
9242	844	4107731	1993-05-29	1993-05-29 00:00:00	38000275	0	\N	\N	55918	0	180256009	4107731	
9497	863	4202451	2004-09-30	2004-09-30 00:00:00	38000275	0	\N	\N	57227	0	433112001	4202451	
21676	1882	4107731	1990-09-15	1990-09-15 00:00:00	38000275	0	\N	\N	125589	0	180256009	4107731	
9817	882	4252419	2013-06-20	2013-06-20 00:00:00	38000275	0	\N	\N	58723	0	74016001	4252419	
21916	1903	4151422	2016-07-20	2016-07-20 00:00:00	38000275	0	\N	\N	126679	0	269911007	4151422	
22075	1923	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	128013	0	180256009	4107731	
10367	921	4078793	2018-07-03	2018-07-03 00:00:00	38000275	0	\N	\N	61367	0	180325003	4078793	
10611	959	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	63679	0	180256009	4107731	
22654	1977	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	131609	0	180256009	4107731	
22844	1989	4125906	1984-01-26	1984-01-26 00:00:00	38000275	0	\N	\N	132478	0	288086009	4125906	
23010	1999	4107731	2013-01-09	2013-01-09 00:00:00	38000275	0	\N	\N	133098	0	180256009	4107731	
11369	1058	4107731	1991-12-21	1991-12-21 00:00:00	38000275	0	\N	\N	69490	0	180256009	4107731	
23458	2054	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	136575	0	180256009	4107731	
11682	1082	4107731	1993-01-23	1993-01-23 00:00:00	38000275	0	\N	\N	70958	0	180256009	4107731	
11930	1091	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	71637	0	180256009	4107731	
81	5	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	441	0	180256009	4107731	
273	16	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	1227	0	180256009	4107731	
546	36	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	2533	0	180256009	4107731	
12565	1138	4043071	1997-05-08	1997-05-08 00:00:00	38000275	0	\N	\N	75036	0	228557008	4043071	
12752	1146	4058899	2001-09-11	2001-09-11 00:00:00	38000275	0	\N	\N	75753	0	168594001	4058899	
1061	101	4151422	1989-05-22	1989-05-22 00:00:00	38000275	0	\N	\N	6908	0	269911007	4151422	
1211	124	4107731	2000-03-06	2000-03-06 00:00:00	38000275	0	\N	\N	8196	0	180256009	4107731	
1479	140	4295880	1998-12-24	1998-12-24 00:00:00	38000275	0	\N	\N	9400	0	76601001	4295880	
1681	154	4295880	1999-07-15	1999-07-15 00:00:00	38000275	0	\N	\N	10446	0	76601001	4295880	
1766	159	4252419	1997-12-23	1997-12-23 00:00:00	38000275	0	\N	\N	10922	0	74016001	4252419	
1961	180	4191853	1993-10-28	1993-10-28 00:00:00	38000275	0	\N	\N	12147	0	395142003	4191853	
2174	224	4151422	1985-12-28	1985-12-28 00:00:00	38000275	0	\N	\N	15037	0	269911007	4151422	
2379	236	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	15895	0	180256009	4107731	
2540	260	4107731	1993-01-23	1993-01-23 00:00:00	38000275	0	\N	\N	17180	0	180256009	4107731	
14690	1310	4243062	1968-02-03	1968-02-03 00:00:00	38000275	0	\N	\N	86678	0	60027007	4243062	
2908	280	4125906	1946-10-16	1946-10-16 00:00:00	38000275	0	\N	\N	18702	0	288086009	4125906	
3155	312	4125906	2012-03-24	2012-03-24 00:00:00	38000275	0	\N	\N	20659	0	288086009	4125906	
3328	332	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	21916	0	180256009	4107731	
3512	338	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	22569	0	180256009	4107731	
3637	351	4295880	1997-10-25	1997-10-25 00:00:00	38000275	0	\N	\N	23397	0	76601001	4295880	
3879	388	4181917	2017-08-29	2017-08-29 00:00:00	38000275	0	\N	\N	25587	0	54550000	4181917	
4010	403	4078793	1996-01-15	1996-01-15 00:00:00	38000275	0	\N	\N	26430	0	180325003	4078793	
4200	409	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	27078	0	180256009	4107731	
16410	1431	4107731	1991-06-15	1991-06-15 00:00:00	38000275	0	\N	\N	95322	0	180256009	4107731	
4643	442	4107731	1991-07-06	1991-07-06 00:00:00	38000275	0	\N	\N	29263	0	180256009	4107731	
4834	449	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	29894	0	180256009	4107731	
4958	461	4202451	1998-01-06	1998-01-06 00:00:00	38000275	0	\N	\N	30785	0	433112001	4202451	
5149	480	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	32102	0	180256009	4107731	
5386	498	4125906	2007-05-16	2007-05-16 00:00:00	38000275	0	\N	\N	33247	0	288086009	4125906	
5510	505	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	33854	0	180256009	4107731	
5790	533	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	35472	0	180256009	4107731	
5891	539	4125906	1971-04-04	1971-04-04 00:00:00	38000275	0	\N	\N	35826	0	288086009	4125906	
6146	563	4107731	1992-02-02	1992-02-02 00:00:00	38000275	0	\N	\N	37225	0	180256009	4107731	
6346	587	4151422	1980-11-07	1980-11-07 00:00:00	38000275	0	\N	\N	38900	0	269911007	4151422	
6454	601	4107731	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	39664	0	180256009	4107731	
6650	608	4043071	1982-04-22	1982-04-22 00:00:00	38000275	0	\N	\N	40404	0	228557008	4043071	
6812	616	4170947	1959-11-29	1959-11-29 00:00:00	38000275	0	\N	\N	41085	0	274474001	4170947	
7050	648	4151422	1980-04-13	1980-04-13 00:00:00	38000275	0	\N	\N	42903	0	269911007	4151422	
7217	669	4151422	2007-05-31	2007-05-31 00:00:00	38000275	0	\N	\N	44193	0	269911007	4151422	
7378	685	4043071	1974-09-10	1974-09-10 00:00:00	38000275	0	\N	\N	45332	0	228557008	4043071	
7569	704	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	46536	0	395142003	4191853	
7799	711	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	47130	0	180256009	4107731	
8028	728	4043071	1964-03-23	1964-03-23 00:00:00	38000275	0	\N	\N	48337	0	228557008	4043071	
8125	742	4035793	1995-05-08	1995-05-08 00:00:00	38000275	0	\N	\N	49211	0	15081005	4035793	
8308	759	4125906	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	50361	0	288086009	4125906	
20487	1766	4035793	2011-10-25	2011-10-25 00:00:00	38000275	0	\N	\N	118184	0	15081005	4035793	
20686	1781	4195803	2011-12-06	2011-12-06 00:00:00	38000275	0	\N	\N	119201	0	312681000	4195803	
20918	1801	4078793	2014-09-17	2014-09-17 00:00:00	38000275	0	\N	\N	120795	0	180325003	4078793	
9121	842	4035793	2015-10-24	2015-10-24 00:00:00	38000275	0	\N	\N	55685	0	15081005	4035793	
9243	844	4107731	1993-02-13	1993-02-13 00:00:00	38000275	0	\N	\N	55965	0	180256009	4107731	
9498	863	4078793	2016-08-18	2016-08-18 00:00:00	38000275	0	\N	\N	57203	0	180325003	4078793	
21677	1882	4107731	1990-03-10	1990-03-10 00:00:00	38000275	0	\N	\N	125605	0	180256009	4107731	
9818	882	44783196	2015-05-25	2015-05-25 00:00:00	38000275	0	\N	\N	58696	0	699253003	44783196	
21917	1903	4125906	2019-01-01	2019-01-01 00:00:00	38000275	0	\N	\N	126735	0	288086009	4125906	
22076	1923	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	127943	0	180256009	4107731	
10368	921	4293740	1968-05-11	1968-05-11 00:00:00	38000275	0	\N	\N	61341	0	384700001	4293740	
10612	959	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	63718	0	180256009	4107731	
22655	1977	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	131631	0	180256009	4107731	
22845	1989	44783196	1988-10-29	1988-10-29 00:00:00	38000275	0	\N	\N	132477	0	699253003	44783196	
23011	1999	4191853	2011-10-05	2011-10-05 00:00:00	38000275	0	\N	\N	133114	0	395142003	4191853	
11370	1058	4107731	1990-01-27	1990-01-27 00:00:00	38000275	0	\N	\N	69384	0	180256009	4107731	
23459	2054	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	136588	0	180256009	4107731	
11683	1082	4107731	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	70956	0	180256009	4107731	
11931	1091	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	71660	0	180256009	4107731	
82	5	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	458	0	180256009	4107731	
274	16	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	1228	0	180256009	4107731	
547	36	4125906	2011-07-06	2011-07-06 00:00:00	38000275	0	\N	\N	2612	0	288086009	4125906	
12566	1138	4107731	1995-08-17	1995-08-17 00:00:00	38000275	0	\N	\N	75058	0	180256009	4107731	
12753	1146	4275113	1979-12-08	1979-12-08 00:00:00	38000275	0	\N	\N	75691	0	65200003	4275113	
1062	102	4010253	1989-10-02	1989-10-02 00:00:00	38000275	0	\N	\N	6961	0	112790001	4010253	
1212	124	4107731	1999-06-29	1999-06-29 00:00:00	38000275	0	\N	\N	8221	0	180256009	4107731	
1480	140	4295880	1996-06-27	1996-06-27 00:00:00	38000275	0	\N	\N	9382	0	76601001	4295880	
1682	154	4295880	1997-01-16	1997-01-16 00:00:00	38000275	0	\N	\N	10490	0	76601001	4295880	
1767	159	44783196	1997-12-30	1997-12-30 00:00:00	38000275	0	\N	\N	10924	0	699253003	44783196	
1962	182	4010253	1999-03-23	1999-03-23 00:00:00	38000275	0	\N	\N	12251	0	112790001	4010253	
2175	224	4170947	2010-06-19	2010-06-19 00:00:00	38000275	0	\N	\N	15111	0	274474001	4170947	
2380	236	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	15890	0	180256009	4107731	
2541	260	4107731	1990-02-17	1990-02-17 00:00:00	38000275	0	\N	\N	17213	0	180256009	4107731	
14691	1310	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	86618	0	180256009	4107731	
2909	280	4125906	1988-05-20	1988-05-20 00:00:00	38000275	0	\N	\N	18706	0	288086009	4125906	
3156	312	4151422	2006-12-03	2006-12-03 00:00:00	38000275	0	\N	\N	20675	0	269911007	4151422	
3329	332	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	22042	0	180256009	4107731	
3513	338	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	22607	0	180256009	4107731	
3638	351	4151422	2017-11-17	2017-11-17 00:00:00	38000275	0	\N	\N	23416	0	269911007	4151422	
3880	388	4181917	2017-09-26	2017-09-26 00:00:00	38000275	0	\N	\N	25588	0	54550000	4181917	
4011	403	4078793	2017-05-15	2017-05-15 00:00:00	38000275	0	\N	\N	26508	0	180325003	4078793	
4201	409	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	27084	0	180256009	4107731	
16411	1431	4107731	1990-05-12	1990-05-12 00:00:00	38000275	0	\N	\N	95289	0	180256009	4107731	
4644	442	4107731	1992-12-12	1992-12-12 00:00:00	38000275	0	\N	\N	29331	0	180256009	4107731	
4835	449	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	29907	0	180256009	4107731	
4959	461	4195803	2018-12-18	2018-12-18 00:00:00	38000275	0	\N	\N	30847	0	312681000	4195803	
5150	480	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	32048	0	180256009	4107731	
5387	499	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	33387	0	180256009	4107731	
5511	505	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	33850	0	180256009	4107731	
5791	533	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	35484	0	180256009	4107731	
5892	539	4151422	1972-12-15	1972-12-15 00:00:00	38000275	0	\N	\N	35772	0	269911007	4151422	
6147	563	4107731	1991-08-18	1991-08-18 00:00:00	38000275	0	\N	\N	37305	0	180256009	4107731	
6347	588	4037675	1984-01-28	1984-01-28 00:00:00	38000275	0	\N	\N	38930	0	162676008	4037675	
6455	601	4107731	1991-07-07	1991-07-07 00:00:00	38000275	0	\N	\N	39765	0	180256009	4107731	
6651	608	4043071	1982-02-25	1982-02-25 00:00:00	38000275	0	\N	\N	40380	0	228557008	4043071	
6813	616	4151422	2012-11-14	2012-11-14 00:00:00	38000275	0	\N	\N	41072	0	269911007	4151422	
7051	648	4170947	1939-02-13	1939-02-13 00:00:00	38000275	0	\N	\N	42960	0	274474001	4170947	
7218	669	4293740	1998-06-15	1998-06-15 00:00:00	38000275	0	\N	\N	44156	0	384700001	4293740	
7379	685	4043071	1978-02-14	1978-02-14 00:00:00	38000275	0	\N	\N	45260	0	228557008	4043071	
7570	704	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	46614	0	180256009	4107731	
7800	712	4043071	1989-01-26	1989-01-26 00:00:00	38000275	0	\N	\N	47223	0	228557008	4043071	
8029	728	4043071	1964-02-17	1964-02-17 00:00:00	38000275	0	\N	\N	48336	0	228557008	4043071	
8126	742	4035793	2010-12-06	2010-12-06 00:00:00	38000275	0	\N	\N	49174	0	15081005	4035793	
8309	759	4125906	1977-01-20	1977-01-20 00:00:00	38000275	0	\N	\N	50360	0	288086009	4125906	
20488	1766	4035793	2018-03-27	2018-03-27 00:00:00	38000275	0	\N	\N	118150	0	15081005	4035793	
20687	1781	4326177	2000-05-26	2000-05-26 00:00:00	38000275	0	\N	\N	119260	0	430193006	4326177	
20919	1801	4078793	2012-09-05	2012-09-05 00:00:00	38000275	0	\N	\N	120794	0	180325003	4078793	
9122	842	4035793	1986-04-12	1986-04-12 00:00:00	38000275	0	\N	\N	55748	0	15081005	4035793	
9244	844	4191853	1990-01-06	1990-01-06 00:00:00	38000275	0	\N	\N	55953	0	395142003	4191853	
9499	863	4078793	2008-07-03	2008-07-03 00:00:00	38000275	0	\N	\N	57117	0	180325003	4078793	
21678	1882	4107731	1992-06-06	1992-06-06 00:00:00	38000275	0	\N	\N	125576	0	180256009	4107731	
9819	882	44783196	2013-06-27	2013-06-27 00:00:00	38000275	0	\N	\N	58762	0	699253003	44783196	
21918	1905	4275113	1983-02-01	1983-02-01 00:00:00	38000275	0	\N	\N	126822	0	65200003	4275113	
22077	1923	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	127966	0	180256009	4107731	
10369	921	4125906	1968-05-11	1968-05-11 00:00:00	38000275	0	\N	\N	61341	0	288086009	4125906	
10613	959	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	63686	0	180256009	4107731	
22656	1977	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	131632	0	180256009	4107731	
22846	1989	4252419	1988-10-22	1988-10-22 00:00:00	38000275	0	\N	\N	132479	0	74016001	4252419	
23012	1999	4043071	1991-10-25	1991-10-25 00:00:00	38000275	0	\N	\N	133071	0	228557008	4043071	
11371	1058	4107731	1991-01-19	1991-01-19 00:00:00	38000275	0	\N	\N	69363	0	180256009	4107731	
23460	2054	4125906	1985-05-11	1985-05-11 00:00:00	38000275	0	\N	\N	136572	0	288086009	4125906	
11684	1082	4107731	1990-12-29	1990-12-29 00:00:00	38000275	0	\N	\N	71000	0	180256009	4107731	
11932	1091	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	71636	0	180256009	4107731	
83	5	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	439	0	180256009	4107731	
275	16	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	1181	0	180256009	4107731	
548	36	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	2527	0	180256009	4107731	
12567	1138	4043071	1995-04-13	1995-04-13 00:00:00	38000275	0	\N	\N	74988	0	228557008	4043071	
12754	1146	4058899	1970-11-25	1970-11-25 00:00:00	38000275	0	\N	\N	75740	0	168594001	4058899	
1063	102	4151422	2010-03-10	2010-03-10 00:00:00	38000275	0	\N	\N	7012	0	269911007	4151422	
1213	124	4107731	1997-03-31	1997-03-31 00:00:00	38000275	0	\N	\N	8245	0	180256009	4107731	
1481	140	4295880	1999-06-24	1999-06-24 00:00:00	38000275	0	\N	\N	9343	0	76601001	4295880	
1683	154	4295880	1998-10-15	1998-10-15 00:00:00	38000275	0	\N	\N	10445	0	76601001	4295880	
1768	159	4163872	1984-04-05	1984-04-05 00:00:00	38000275	0	\N	\N	10921	0	399208008	4163872	
1963	183	4043071	1983-04-22	1983-04-22 00:00:00	38000275	0	\N	\N	12392	0	228557008	4043071	
2176	224	4195803	2010-06-19	2010-06-19 00:00:00	38000275	0	\N	\N	15111	0	312681000	4195803	
2381	236	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	15905	0	180256009	4107731	
2542	260	4107731	1991-02-09	1991-02-09 00:00:00	38000275	0	\N	\N	17279	0	180256009	4107731	
14692	1310	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	86639	0	180256009	4107731	
2910	280	4151422	1992-09-21	1992-09-21 00:00:00	38000275	0	\N	\N	18734	0	269911007	4151422	
3157	312	4243062	1991-05-14	1991-05-14 00:00:00	38000275	0	\N	\N	20658	0	60027007	4243062	
3330	332	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	21982	0	180256009	4107731	
3514	338	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	22534	0	180256009	4107731	
3639	351	4295880	2003-07-22	2003-07-22 00:00:00	38000275	0	\N	\N	23366	0	76601001	4295880	
3882	390	4125906	1980-04-09	1980-04-09 00:00:00	38000275	0	\N	\N	25651	0	288086009	4125906	
4012	403	4078793	1992-12-28	1992-12-28 00:00:00	38000275	0	\N	\N	26487	0	180325003	4078793	
4202	409	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	27114	0	180256009	4107731	
16412	1431	4107731	1992-04-04	1992-04-04 00:00:00	38000275	0	\N	\N	95345	0	180256009	4107731	
4645	442	4107731	1992-06-27	1992-06-27 00:00:00	38000275	0	\N	\N	29268	0	180256009	4107731	
4836	449	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	29900	0	180256009	4107731	
4960	461	4151422	1953-03-27	1953-03-27 00:00:00	38000275	0	\N	\N	30779	0	269911007	4151422	
5151	480	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	32100	0	180256009	4107731	
5388	499	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	33367	0	180256009	4107731	
5512	505	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	33823	0	180256009	4107731	
5792	533	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	35483	0	180256009	4107731	
5904	545	4107731	1991-11-30	1991-11-30 00:00:00	38000275	0	\N	\N	36035	0	180256009	4107731	
6148	563	4107731	1992-06-07	1992-06-07 00:00:00	38000275	0	\N	\N	37219	0	180256009	4107731	
6348	588	4187458	1984-01-28	1984-01-28 00:00:00	38000275	0	\N	\N	38930	0	415300000	4187458	
6456	601	4107731	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	39739	0	180256009	4107731	
6652	608	4125906	2008-11-13	2008-11-13 00:00:00	38000275	0	\N	\N	40410	0	288086009	4125906	
6814	616	4198190	1962-01-03	1962-01-03 00:00:00	38000275	0	\N	\N	41147	0	80146002	4198190	
7052	648	4024289	1939-02-13	1939-02-13 00:00:00	38000275	0	\N	\N	42960	0	19490002	4024289	
7219	669	4125906	1998-06-15	1998-06-15 00:00:00	38000275	0	\N	\N	44156	0	288086009	4125906	
7380	685	4043071	1975-12-16	1975-12-16 00:00:00	38000275	0	\N	\N	45255	0	228557008	4043071	
7571	704	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	46562	0	180256009	4107731	
7801	712	4058899	2003-08-07	2003-08-07 00:00:00	38000275	0	\N	\N	47267	0	168594001	4058899	
8030	729	4024289	2001-11-17	2001-11-17 00:00:00	38000275	0	\N	\N	48366	0	19490002	4024289	
8127	742	4035793	1997-05-19	1997-05-19 00:00:00	38000275	0	\N	\N	49122	0	15081005	4035793	
8310	759	4078793	2007-03-14	2007-03-14 00:00:00	38000275	0	\N	\N	50369	0	180325003	4078793	
20489	1766	4035793	2007-10-02	2007-10-02 00:00:00	38000275	0	\N	\N	118165	0	15081005	4035793	
20688	1781	4037675	2000-05-26	2000-05-26 00:00:00	38000275	0	\N	\N	119260	0	162676008	4037675	
20920	1801	4125906	1963-12-01	1963-12-01 00:00:00	38000275	0	\N	\N	120749	0	288086009	4125906	
9123	842	4035793	2001-08-04	2001-08-04 00:00:00	38000275	0	\N	\N	55671	0	15081005	4035793	
9245	844	4107731	1992-06-06	1992-06-06 00:00:00	38000275	0	\N	\N	55913	0	180256009	4107731	
9500	863	4057420	2015-08-13	2015-08-13 00:00:00	38000275	0	\N	\N	57229	0	18286008	4057420	
21679	1882	4107731	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	125514	0	180256009	4107731	
9820	883	4151422	1968-05-11	1968-05-11 00:00:00	38000275	0	\N	\N	58792	0	269911007	4151422	
21919	1905	4151422	2018-01-20	2018-01-20 00:00:00	38000275	0	\N	\N	126808	0	269911007	4151422	
22078	1923	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	127967	0	180256009	4107731	
10370	921	4078793	2016-06-21	2016-06-21 00:00:00	38000275	0	\N	\N	61366	0	180325003	4078793	
10614	959	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	63751	0	180256009	4107731	
22657	1977	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	131485	0	180256009	4107731	
22847	1989	4125906	1994-05-31	1994-05-31 00:00:00	38000275	0	\N	\N	132480	0	288086009	4125906	
23013	1999	4107731	2014-03-26	2014-03-26 00:00:00	38000275	0	\N	\N	133135	0	180256009	4107731	
11372	1058	4107731	1991-05-04	1991-05-04 00:00:00	38000275	0	\N	\N	69488	0	180256009	4107731	
23461	2054	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	136682	0	180256009	4107731	
11685	1082	4107731	1992-06-27	1992-06-27 00:00:00	38000275	0	\N	\N	70986	0	180256009	4107731	
11933	1091	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	71657	0	180256009	4107731	
84	5	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	431	0	180256009	4107731	
276	16	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	1242	0	180256009	4107731	
549	36	4078793	2019-01-15	2019-01-15 00:00:00	38000275	0	\N	\N	2594	0	180325003	4078793	
12568	1138	4107731	1993-04-08	1993-04-08 00:00:00	38000275	0	\N	\N	75048	0	180256009	4107731	
12755	1146	4186930	1984-12-06	1984-12-06 00:00:00	38000275	0	\N	\N	75692	0	46706006	4186930	
1064	103	4326177	2002-05-19	2002-05-19 00:00:00	38000275	0	\N	\N	7047	0	430193006	4326177	
1214	124	4107731	1999-11-22	1999-11-22 00:00:00	38000275	0	\N	\N	8331	0	180256009	4107731	
1482	140	4295880	1996-12-26	1996-12-26 00:00:00	38000275	0	\N	\N	9412	0	76601001	4295880	
13465	1223	4170947	1983-07-17	1983-07-17 00:00:00	38000275	0	\N	\N	80446	0	274474001	4170947	
1769	159	4170947	1984-04-05	1984-04-05 00:00:00	38000275	0	\N	\N	10921	0	274474001	4170947	
1964	183	4043071	1984-02-17	1984-02-17 00:00:00	38000275	0	\N	\N	12354	0	228557008	4043071	
2177	224	4163872	2010-06-19	2010-06-19 00:00:00	38000275	0	\N	\N	15111	0	399208008	4163872	
2382	236	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	15846	0	180256009	4107731	
2543	260	4107731	1990-10-27	1990-10-27 00:00:00	38000275	0	\N	\N	17168	0	180256009	4107731	
14693	1310	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	86619	0	180256009	4107731	
2911	280	4301346	1991-02-02	1991-02-02 00:00:00	38000275	0	\N	\N	18686	0	387685009	4301346	
3158	312	4170947	1991-05-14	1991-05-14 00:00:00	38000275	0	\N	\N	20658	0	274474001	4170947	
3331	332	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	21974	0	180256009	4107731	
3515	338	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	22508	0	180256009	4107731	
3640	351	4295880	2003-01-21	2003-01-21 00:00:00	38000275	0	\N	\N	23391	0	76601001	4295880	
3883	390	4151422	2015-05-20	2015-05-20 00:00:00	38000275	0	\N	\N	25631	0	269911007	4151422	
4013	403	4078793	2007-03-19	2007-03-19 00:00:00	38000275	0	\N	\N	26443	0	180325003	4078793	
4203	409	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	27085	0	180256009	4107731	
16413	1431	4107731	1990-06-23	1990-06-23 00:00:00	38000275	0	\N	\N	95290	0	180256009	4107731	
4646	442	4107731	1990-01-27	1990-01-27 00:00:00	38000275	0	\N	\N	29314	0	180256009	4107731	
4837	449	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	29867	0	180256009	4107731	
4961	461	4125906	2001-02-19	2001-02-19 00:00:00	38000275	0	\N	\N	30858	0	288086009	4125906	
5152	480	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	32105	0	180256009	4107731	
5389	499	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	33440	0	180256009	4107731	
5513	505	4191853	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	33756	0	395142003	4191853	
5793	533	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	35410	0	180256009	4107731	
5905	545	4107731	1990-03-10	1990-03-10 00:00:00	38000275	0	\N	\N	36053	0	180256009	4107731	
6149	563	4107731	1992-01-12	1992-01-12 00:00:00	38000275	0	\N	\N	37262	0	180256009	4107731	
6349	588	4326177	1984-01-28	1984-01-28 00:00:00	38000275	0	\N	\N	38930	0	430193006	4326177	
6457	601	4107731	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	39734	0	180256009	4107731	
6653	608	4043071	1982-03-25	1982-03-25 00:00:00	38000275	0	\N	\N	40394	0	228557008	4043071	
6815	616	4125906	2004-07-01	2004-07-01 00:00:00	38000275	0	\N	\N	41090	0	288086009	4125906	
7053	648	4202451	2015-09-25	2015-09-25 00:00:00	38000275	0	\N	\N	42861	0	433112001	4202451	
7220	670	4238715	1992-05-23	1992-05-23 00:00:00	38000275	0	\N	\N	44208	0	68254000	4238715	
7381	685	4043071	1977-03-01	1977-03-01 00:00:00	38000275	0	\N	\N	45272	0	228557008	4043071	
7572	704	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	46572	0	180256009	4107731	
7802	712	40492359	2011-04-14	2011-04-14 00:00:00	38000275	0	\N	\N	47268	0	447365002	40492359	
8031	729	4170947	2001-11-17	2001-11-17 00:00:00	38000275	0	\N	\N	48366	0	274474001	4170947	
8128	742	4035793	1999-05-31	1999-05-31 00:00:00	38000275	0	\N	\N	49123	0	15081005	4035793	
8311	759	4078793	2017-09-13	2017-09-13 00:00:00	38000275	0	\N	\N	50437	0	180325003	4078793	
20490	1766	4035793	2005-09-20	2005-09-20 00:00:00	38000275	0	\N	\N	118164	0	15081005	4035793	
20689	1781	4187458	2000-05-26	2000-05-26 00:00:00	38000275	0	\N	\N	119260	0	415300000	4187458	
20921	1801	4078793	2016-09-28	2016-09-28 00:00:00	38000275	0	\N	\N	120796	0	180325003	4078793	
9124	842	4035793	1980-01-05	1980-01-05 00:00:00	38000275	0	\N	\N	55664	0	15081005	4035793	
9246	844	4163872	1989-04-02	1989-04-02 00:00:00	38000275	0	\N	\N	55926	0	399208008	4163872	
9501	863	4078793	1983-02-10	1983-02-10 00:00:00	38000275	0	\N	\N	57226	0	180325003	4078793	
21680	1882	4107731	1990-12-29	1990-12-29 00:00:00	38000275	0	\N	\N	125558	0	180256009	4107731	
9821	883	4170947	1970-01-29	1970-01-29 00:00:00	38000275	0	\N	\N	58778	0	274474001	4170947	
21920	1905	4238715	1986-11-21	1986-11-21 00:00:00	38000275	0	\N	\N	126830	0	68254000	4238715	
22079	1923	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	128011	0	180256009	4107731	
10371	921	4243062	1983-03-25	1983-03-25 00:00:00	38000275	0	\N	\N	61345	0	60027007	4243062	
10615	959	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	63688	0	180256009	4107731	
22658	1977	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	131637	0	180256009	4107731	
22848	1990	4170947	1975-04-10	1975-04-10 00:00:00	38000275	0	\N	\N	132502	0	274474001	4170947	
23014	1999	4107731	2012-07-25	2012-07-25 00:00:00	38000275	0	\N	\N	133143	0	180256009	4107731	
11373	1058	4252419	2004-05-30	2004-05-30 00:00:00	38000275	0	\N	\N	69406	0	74016001	4252419	
23462	2054	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	136609	0	180256009	4107731	
11686	1082	4107731	1991-07-06	1991-07-06 00:00:00	38000275	0	\N	\N	71045	0	180256009	4107731	
11934	1091	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	71647	0	180256009	4107731	
85	5	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	505	0	180256009	4107731	
277	16	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	1272	0	180256009	4107731	
550	36	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	2619	0	180256009	4107731	
12569	1138	4107731	1996-04-04	1996-04-04 00:00:00	38000275	0	\N	\N	75030	0	180256009	4107731	
12756	1146	4238715	1985-07-25	1985-07-25 00:00:00	38000275	0	\N	\N	75723	0	68254000	4238715	
1065	103	4037675	2002-05-19	2002-05-19 00:00:00	38000275	0	\N	\N	7047	0	162676008	4037675	
1215	124	4107731	2000-02-14	2000-02-14 00:00:00	38000275	0	\N	\N	8257	0	180256009	4107731	
1483	140	4295880	1999-03-25	1999-03-25 00:00:00	38000275	0	\N	\N	9371	0	76601001	4295880	
13466	1223	4047491	1983-07-17	1983-07-17 00:00:00	38000275	0	\N	\N	80446	0	1225002	4047491	
1770	160	4151422	2019-04-02	2019-04-02 00:00:00	38000275	0	\N	\N	10966	0	269911007	4151422	
1965	183	4043071	1983-11-18	1983-11-18 00:00:00	38000275	0	\N	\N	12406	0	228557008	4043071	
2178	224	4125906	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	15108	0	288086009	4125906	
2383	236	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	15898	0	180256009	4107731	
2544	260	4107731	1990-05-12	1990-05-12 00:00:00	38000275	0	\N	\N	17224	0	180256009	4107731	
14694	1310	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	86640	0	180256009	4107731	
2912	280	4243062	1949-11-13	1949-11-13 00:00:00	38000275	0	\N	\N	18703	0	60027007	4243062	
14974	1328	4337138	2001-11-15	2001-11-15 00:00:00	38000275	0	\N	\N	88155	0	88039007	4337138	
3332	332	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	21990	0	180256009	4107731	
3516	339	4058899	1994-08-09	1994-08-09 00:00:00	38000275	0	\N	\N	22663	0	168594001	4058899	
3641	351	4295880	1998-07-28	1998-07-28 00:00:00	38000275	0	\N	\N	23398	0	76601001	4295880	
3886	392	4058899	1978-03-20	1978-03-20 00:00:00	38000275	0	\N	\N	25744	0	168594001	4058899	
4014	403	4078793	2015-05-04	2015-05-04 00:00:00	38000275	0	\N	\N	26507	0	180325003	4078793	
4204	409	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	27145	0	180256009	4107731	
16414	1431	4107731	1991-02-09	1991-02-09 00:00:00	38000275	0	\N	\N	95292	0	180256009	4107731	
4647	442	4107731	1990-12-08	1990-12-08 00:00:00	38000275	0	\N	\N	29404	0	180256009	4107731	
4838	449	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	29949	0	180256009	4107731	
4962	462	4163872	2002-02-03	2002-02-03 00:00:00	38000275	0	\N	\N	30884	0	399208008	4163872	
5153	480	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	32104	0	180256009	4107731	
5390	499	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	33392	0	180256009	4107731	
5514	505	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	33840	0	180256009	4107731	
5794	533	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	35485	0	180256009	4107731	
5906	545	4107731	1991-09-28	1991-09-28 00:00:00	38000275	0	\N	\N	36103	0	180256009	4107731	
6150	563	4107731	1990-06-24	1990-06-24 00:00:00	38000275	0	\N	\N	37277	0	180256009	4107731	
18203	1556	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	104187	0	180256009	4107731	
6458	601	4107731	1991-03-03	1991-03-03 00:00:00	38000275	0	\N	\N	39661	0	180256009	4107731	
6654	609	4151422	1991-02-01	1991-02-01 00:00:00	38000275	0	\N	\N	40417	0	269911007	4151422	
6886	621	4057420	2016-03-23	2016-03-23 00:00:00	38000275	0	\N	\N	41411	0	18286008	4057420	
7054	649	4170947	1972-11-18	1972-11-18 00:00:00	38000275	0	\N	\N	42974	0	274474001	4170947	
7221	670	4275113	1988-10-27	1988-10-27 00:00:00	38000275	0	\N	\N	44242	0	65200003	4275113	
7382	685	4043071	1978-03-21	1978-03-21 00:00:00	38000275	0	\N	\N	45261	0	228557008	4043071	
7573	704	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	46606	0	180256009	4107731	
7803	712	4057420	2011-04-14	2011-04-14 00:00:00	38000275	0	\N	\N	47268	0	18286008	4057420	
8032	729	4058899	1962-07-26	1962-07-26 00:00:00	38000275	0	\N	\N	48403	0	168594001	4058899	
8129	742	4323902	1986-12-15	1986-12-15 00:00:00	38000275	0	\N	\N	49194	0	429609002	4323902	
8312	759	4078793	2015-04-29	2015-04-29 00:00:00	38000275	0	\N	\N	50436	0	180325003	4078793	
20494	1769	4295880	1994-11-30	1994-11-30 00:00:00	38000275	0	\N	\N	118308	0	76601001	4295880	
20690	1781	4125906	2009-11-24	2009-11-24 00:00:00	38000275	0	\N	\N	119227	0	288086009	4125906	
20922	1801	4078793	2011-08-31	2011-08-31 00:00:00	38000275	0	\N	\N	120781	0	180325003	4078793	
9125	842	4035793	2006-09-02	2006-09-02 00:00:00	38000275	0	\N	\N	55683	0	15081005	4035793	
9247	844	4107731	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	55872	0	180256009	4107731	
9502	863	4078793	1989-03-16	1989-03-16 00:00:00	38000275	0	\N	\N	57183	0	180325003	4078793	
21681	1882	4107731	1991-09-28	1991-09-28 00:00:00	38000275	0	\N	\N	125561	0	180256009	4107731	
9822	883	4024289	1970-01-29	1970-01-29 00:00:00	38000275	0	\N	\N	58778	0	19490002	4024289	
21921	1906	4163872	1980-01-13	1980-01-13 00:00:00	38000275	0	\N	\N	126872	0	399208008	4163872	
22080	1923	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	127919	0	180256009	4107731	
10372	921	4170947	1983-03-25	1983-03-25 00:00:00	38000275	0	\N	\N	61345	0	274474001	4170947	
10616	959	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	63793	0	180256009	4107731	
22659	1977	4125906	2007-12-09	2007-12-09 00:00:00	38000275	0	\N	\N	131627	0	288086009	4125906	
22849	1990	4047491	1975-04-10	1975-04-10 00:00:00	38000275	0	\N	\N	132502	0	1225002	4047491	
23015	1999	4107731	2014-06-18	2014-06-18 00:00:00	38000275	0	\N	\N	133102	0	180256009	4107731	
11374	1058	4107731	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	69369	0	180256009	4107731	
23463	2054	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	136624	0	180256009	4107731	
11687	1082	4107731	1991-05-25	1991-05-25 00:00:00	38000275	0	\N	\N	71044	0	180256009	4107731	
11935	1091	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	71682	0	395142003	4191853	
86	5	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	455	0	180256009	4107731	
278	16	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	1170	0	180256009	4107731	
551	36	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	2549	0	180256009	4107731	
12570	1138	4107731	1994-10-06	1994-10-06 00:00:00	38000275	0	\N	\N	75051	0	180256009	4107731	
12757	1146	4125906	1965-06-12	1965-06-12 00:00:00	38000275	0	\N	\N	75738	0	288086009	4125906	
1066	103	4187458	2002-05-19	2002-05-19 00:00:00	38000275	0	\N	\N	7047	0	415300000	4187458	
1216	124	4107731	1998-03-02	1998-03-02 00:00:00	38000275	0	\N	\N	8189	0	180256009	4107731	
1484	140	4295880	1999-09-23	1999-09-23 00:00:00	38000275	0	\N	\N	9401	0	76601001	4295880	
13467	1223	4057420	2012-05-11	2012-05-11 00:00:00	38000275	0	\N	\N	80504	0	18286008	4057420	
1771	160	4195803	2016-08-05	2016-08-05 00:00:00	38000275	0	\N	\N	10976	0	312681000	4195803	
1966	183	4043071	1983-05-20	1983-05-20 00:00:00	38000275	0	\N	\N	12352	0	228557008	4043071	
2179	225	4107731	1991-07-22	1991-07-22 00:00:00	38000275	0	\N	\N	15227	0	180256009	4107731	
2384	236	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	15860	0	180256009	4107731	
2545	260	4107731	1991-05-04	1991-05-04 00:00:00	38000275	0	\N	\N	17230	0	180256009	4107731	
14695	1310	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	86553	0	180256009	4107731	
2913	280	4170947	1949-11-13	1949-11-13 00:00:00	38000275	0	\N	\N	18703	0	274474001	4170947	
14975	1328	4035793	2006-09-28	2006-09-28 00:00:00	38000275	0	\N	\N	88195	0	15081005	4035793	
3333	332	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	22019	0	180256009	4107731	
3517	340	4058899	2001-05-03	2001-05-03 00:00:00	38000275	0	\N	\N	22669	0	168594001	4058899	
3642	351	4198190	2016-11-21	2016-11-21 00:00:00	38000275	0	\N	\N	23368	0	80146002	4198190	
3887	393	4151422	1976-08-01	1976-08-01 00:00:00	38000275	0	\N	\N	25762	0	269911007	4151422	
4015	403	4151422	1926-02-07	1926-02-07 00:00:00	38000275	0	\N	\N	26529	0	269911007	4151422	
4205	409	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	27082	0	180256009	4107731	
16415	1431	4107731	1990-12-29	1990-12-29 00:00:00	38000275	0	\N	\N	95291	0	180256009	4107731	
4648	442	4107731	1993-03-06	1993-03-06 00:00:00	38000275	0	\N	\N	29366	0	180256009	4107731	
4839	449	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	29899	0	180256009	4107731	
5004	469	4043071	1945-02-26	1945-02-26 00:00:00	38000275	0	\N	\N	31206	0	228557008	4043071	
5154	480	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	31991	0	180256009	4107731	
5391	499	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	33365	0	180256009	4107731	
5515	505	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	33865	0	180256009	4107731	
5795	533	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	35492	0	180256009	4107731	
5907	545	4107731	1991-10-19	1991-10-19 00:00:00	38000275	0	\N	\N	36070	0	180256009	4107731	
6151	563	4107731	1993-04-18	1993-04-18 00:00:00	38000275	0	\N	\N	37250	0	180256009	4107731	
18204	1556	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	104266	0	180256009	4107731	
6459	601	4107731	1991-01-20	1991-01-20 00:00:00	38000275	0	\N	\N	39660	0	180256009	4107731	
6655	609	4057420	2014-12-02	2014-12-02 00:00:00	38000275	0	\N	\N	40413	0	18286008	4057420	
6887	621	4202451	1995-11-29	1995-11-29 00:00:00	38000275	0	\N	\N	41422	0	433112001	4202451	
7055	649	4047491	1972-11-18	1972-11-18 00:00:00	38000275	0	\N	\N	42974	0	1225002	4047491	
7222	670	4024289	1978-05-11	1978-05-11 00:00:00	38000275	0	\N	\N	44252	0	19490002	4024289	
7383	685	4043071	1975-01-07	1975-01-07 00:00:00	38000275	0	\N	\N	45316	0	228557008	4043071	
7574	704	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	46617	0	180256009	4107731	
7804	712	4043071	1988-12-01	1988-12-01 00:00:00	38000275	0	\N	\N	47244	0	228557008	4043071	
8033	729	4151422	2019-03-20	2019-03-20 00:00:00	38000275	0	\N	\N	48429	0	269911007	4151422	
8130	742	4035793	1981-09-28	1981-09-28 00:00:00	38000275	0	\N	\N	49204	0	15081005	4035793	
8313	759	4078793	2009-03-25	2009-03-25 00:00:00	38000275	0	\N	\N	50370	0	180325003	4078793	
20495	1769	4295880	1994-03-02	1994-03-02 00:00:00	38000275	0	\N	\N	118298	0	76601001	4295880	
20691	1781	4293740	2009-11-24	2009-11-24 00:00:00	38000275	0	\N	\N	119227	0	384700001	4293740	
20923	1801	4078793	2008-08-13	2008-08-13 00:00:00	38000275	0	\N	\N	120777	0	180325003	4078793	
9126	842	4035793	2004-08-21	2004-08-21 00:00:00	38000275	0	\N	\N	55682	0	15081005	4035793	
9248	844	4107731	1992-04-25	1992-04-25 00:00:00	38000275	0	\N	\N	55985	0	180256009	4107731	
9503	863	4057420	1981-01-29	1981-01-29 00:00:00	38000275	0	\N	\N	57216	0	18286008	4057420	
21682	1882	4107731	1990-06-02	1990-06-02 00:00:00	38000275	0	\N	\N	125593	0	180256009	4107731	
9823	883	4293740	2008-03-24	2008-03-24 00:00:00	38000275	0	\N	\N	58780	0	384700001	4293740	
21922	1908	4170947	1998-02-24	1998-02-24 00:00:00	38000275	0	\N	\N	126953	0	274474001	4170947	
22081	1923	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	127939	0	180256009	4107731	
10373	921	4078793	2017-06-27	2017-06-27 00:00:00	38000275	0	\N	\N	61382	0	180325003	4078793	
10617	959	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	63689	0	180256009	4107731	
22660	1977	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	131608	0	180256009	4107731	
22850	1990	4252419	2001-03-15	2001-03-15 00:00:00	38000275	0	\N	\N	132505	0	74016001	4252419	
23083	2002	4047491	1986-05-24	1986-05-24 00:00:00	38000275	0	\N	\N	133381	0	1225002	4047491	
11375	1058	4107731	1992-10-10	1992-10-10 00:00:00	38000275	0	\N	\N	69441	0	180256009	4107731	
23464	2054	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	136662	0	180256009	4107731	
11688	1082	4107731	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	70994	0	180256009	4107731	
11936	1092	44783196	1962-08-11	1962-08-11 00:00:00	38000275	0	\N	\N	71836	0	699253003	44783196	
87	5	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	454	0	180256009	4107731	
279	16	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	1279	0	180256009	4107731	
552	36	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	2530	0	180256009	4107731	
12571	1138	4107731	1994-08-04	1994-08-04 00:00:00	38000275	0	\N	\N	75075	0	180256009	4107731	
12826	1148	4125906	2002-02-15	2002-02-15 00:00:00	38000275	0	\N	\N	75933	0	288086009	4125906	
1067	103	4163872	2002-04-30	2002-04-30 00:00:00	38000275	0	\N	\N	7046	0	399208008	4163872	
1217	124	4107731	1997-10-07	1997-10-07 00:00:00	38000275	0	\N	\N	8246	0	180256009	4107731	
1485	140	4295880	1998-03-26	1998-03-26 00:00:00	38000275	0	\N	\N	9399	0	76601001	4295880	
13468	1223	4078793	2015-05-29	2015-05-29 00:00:00	38000275	0	\N	\N	80495	0	180325003	4078793	
1772	160	4058899	2016-08-05	2016-08-05 00:00:00	38000275	0	\N	\N	10976	0	168594001	4058899	
1967	183	4043071	1983-06-17	1983-06-17 00:00:00	38000275	0	\N	\N	12404	0	228557008	4043071	
2180	225	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	15173	0	180256009	4107731	
2385	236	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	15869	0	180256009	4107731	
2546	260	4107731	1992-12-12	1992-12-12 00:00:00	38000275	0	\N	\N	17179	0	180256009	4107731	
14696	1310	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	86657	0	180256009	4107731	
2914	280	4170947	1962-03-10	1962-03-10 00:00:00	38000275	0	\N	\N	18704	0	274474001	4170947	
14976	1328	4035793	2017-04-20	2017-04-20 00:00:00	38000275	0	\N	\N	88174	0	15081005	4035793	
3334	332	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	21970	0	180256009	4107731	
3518	341	4125906	1989-04-10	1989-04-10 00:00:00	38000275	0	\N	\N	22742	0	288086009	4125906	
3643	351	4295880	2000-07-25	2000-07-25 00:00:00	38000275	0	\N	\N	23420	0	76601001	4295880	
3888	394	4170947	1922-03-21	1922-03-21 00:00:00	38000275	0	\N	\N	25926	0	274474001	4170947	
4016	403	4078793	2014-04-28	2014-04-28 00:00:00	38000275	0	\N	\N	26477	0	180325003	4078793	
4206	409	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	27106	0	180256009	4107731	
16416	1431	4107731	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	95283	0	180256009	4107731	
4649	442	4107731	1992-08-29	1992-08-29 00:00:00	38000275	0	\N	\N	29379	0	180256009	4107731	
4840	449	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	29927	0	180256009	4107731	
5005	469	4043071	1948-07-26	1948-07-26 00:00:00	38000275	0	\N	\N	31361	0	228557008	4043071	
5155	480	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	31975	0	180256009	4107731	
5392	499	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	33363	0	180256009	4107731	
5516	505	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	33789	0	180256009	4107731	
5796	533	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	35428	0	395142003	4191853	
5908	545	4107731	1990-03-31	1990-03-31 00:00:00	38000275	0	\N	\N	36135	0	180256009	4107731	
6152	563	4107731	1991-06-16	1991-06-16 00:00:00	38000275	0	\N	\N	37223	0	180256009	4107731	
18205	1556	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	104174	0	180256009	4107731	
6460	601	4107731	1990-08-26	1990-08-26 00:00:00	38000275	0	\N	\N	39761	0	180256009	4107731	
6656	609	40492359	2014-12-02	2014-12-02 00:00:00	38000275	0	\N	\N	40413	0	447365002	40492359	
6888	621	4078793	2019-04-10	2019-04-10 00:00:00	38000275	0	\N	\N	41409	0	180325003	4078793	
7056	649	4163872	2010-03-23	2010-03-23 00:00:00	38000275	0	\N	\N	42993	0	399208008	4163872	
7223	670	4170947	1978-05-11	1978-05-11 00:00:00	38000275	0	\N	\N	44252	0	274474001	4170947	
7384	685	4043071	1977-05-03	1977-05-03 00:00:00	38000275	0	\N	\N	45296	0	228557008	4043071	
7575	704	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	46558	0	180256009	4107731	
7805	712	4043071	1988-12-29	1988-12-29 00:00:00	38000275	0	\N	\N	47230	0	228557008	4043071	
8034	729	4125906	1972-02-04	1972-02-04 00:00:00	38000275	0	\N	\N	48404	0	288086009	4125906	
8131	742	4035793	1993-04-26	1993-04-26 00:00:00	38000275	0	\N	\N	49210	0	15081005	4035793	
8314	759	4163872	1962-10-03	1962-10-03 00:00:00	38000275	0	\N	\N	50435	0	399208008	4163872	
20496	1769	4295880	1995-08-30	1995-08-30 00:00:00	38000275	0	\N	\N	118309	0	76601001	4295880	
20692	1781	4125906	1957-01-17	1957-01-17 00:00:00	38000275	0	\N	\N	119225	0	288086009	4125906	
20924	1801	4078793	2009-12-02	2009-12-02 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
9127	842	4035793	1982-03-20	1982-03-20 00:00:00	38000275	0	\N	\N	55737	0	15081005	4035793	
9249	844	4125906	1995-04-21	1995-04-21 00:00:00	38000275	0	\N	\N	56004	0	288086009	4125906	
9504	863	4293740	1930-02-16	1930-02-16 00:00:00	38000275	0	\N	\N	57206	0	384700001	4293740	
21683	1882	4107731	1992-10-10	1992-10-10 00:00:00	38000275	0	\N	\N	125505	0	180256009	4107731	
9824	883	4125906	2008-03-24	2008-03-24 00:00:00	38000275	0	\N	\N	58780	0	288086009	4125906	
21923	1908	4163872	1998-02-24	1998-02-24 00:00:00	38000275	0	\N	\N	126953	0	399208008	4163872	
22082	1923	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	127987	0	180256009	4107731	
10374	923	4125906	1989-04-03	1989-04-03 00:00:00	38000275	0	\N	\N	61494	0	288086009	4125906	
10618	959	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	63741	0	180256009	4107731	
22661	1977	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	131630	0	180256009	4107731	
22851	1991	4216130	2011-02-21	2011-02-21 00:00:00	38000275	0	\N	\N	132611	0	415070008	4216130	
23084	2002	4170947	1986-05-24	1986-05-24 00:00:00	38000275	0	\N	\N	133381	0	274474001	4170947	
11376	1058	4107731	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	69451	0	180256009	4107731	
23465	2054	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	136576	0	180256009	4107731	
11689	1082	4107731	1992-01-11	1992-01-11 00:00:00	38000275	0	\N	\N	71046	0	180256009	4107731	
11937	1092	4252419	1997-03-13	1997-03-13 00:00:00	38000275	0	\N	\N	71800	0	74016001	4252419	
88	5	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	420	0	180256009	4107731	
280	16	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	1269	0	180256009	4107731	
553	36	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	2617	0	180256009	4107731	
12572	1138	4252419	2007-03-15	2007-03-15 00:00:00	38000275	0	\N	\N	75131	0	74016001	4252419	
12827	1148	4293740	2002-02-15	2002-02-15 00:00:00	38000275	0	\N	\N	75933	0	384700001	4293740	
1068	105	4125906	1982-02-12	1982-02-12 00:00:00	38000275	0	\N	\N	7145	0	288086009	4125906	
1218	124	4107731	1998-07-07	1998-07-07 00:00:00	38000275	0	\N	\N	8192	0	180256009	4107731	
1486	140	4125906	1995-01-07	1995-01-07 00:00:00	38000275	0	\N	\N	9348	0	288086009	4125906	
13535	1226	4043071	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	80708	0	228557008	4043071	
1773	160	4187458	2000-07-17	2000-07-17 00:00:00	38000275	0	\N	\N	11003	0	415300000	4187458	
1968	183	4043071	1983-01-21	1983-01-21 00:00:00	38000275	0	\N	\N	12351	0	228557008	4043071	
2181	225	4107731	1990-12-03	1990-12-03 00:00:00	38000275	0	\N	\N	15225	0	180256009	4107731	
2386	236	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	15887	0	180256009	4107731	
2547	260	4252419	1990-08-10	1990-08-10 00:00:00	38000275	0	\N	\N	17267	0	74016001	4252419	
14697	1310	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	86689	0	180256009	4107731	
2915	280	4163872	1962-03-10	1962-03-10 00:00:00	38000275	0	\N	\N	18704	0	399208008	4163872	
14977	1328	4125906	2014-03-25	2014-03-25 00:00:00	38000275	0	\N	\N	88160	0	288086009	4125906	
3335	332	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	22053	0	395142003	4191853	
3519	341	4275113	1977-06-25	1977-06-25 00:00:00	38000275	0	\N	\N	22774	0	65200003	4275113	
3644	351	4295880	1999-04-27	1999-04-27 00:00:00	38000275	0	\N	\N	23400	0	76601001	4295880	
3889	394	4243062	1922-03-21	1922-03-21 00:00:00	38000275	0	\N	\N	25926	0	60027007	4243062	
4017	403	4078793	2001-02-12	2001-02-12 00:00:00	38000275	0	\N	\N	26474	0	180325003	4078793	
4207	409	4243062	1955-10-10	1955-10-10 00:00:00	38000275	0	\N	\N	27149	0	60027007	4243062	
16417	1431	4107731	1990-10-27	1990-10-27 00:00:00	38000275	0	\N	\N	95320	0	180256009	4107731	
4650	442	4107731	1991-09-28	1991-09-28 00:00:00	38000275	0	\N	\N	29265	0	180256009	4107731	
4841	449	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	29916	0	180256009	4107731	
5006	469	4043071	1947-04-28	1947-04-28 00:00:00	38000275	0	\N	\N	31276	0	228557008	4043071	
5156	480	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	32025	0	180256009	4107731	
5393	499	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	33439	0	180256009	4107731	
5517	505	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	33771	0	180256009	4107731	
5797	533	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	35494	0	180256009	4107731	
5909	545	4047491	2015-10-16	2015-10-16 00:00:00	38000275	0	\N	\N	36146	0	1225002	4047491	
6153	563	4107731	1990-08-26	1990-08-26 00:00:00	38000275	0	\N	\N	37200	0	180256009	4107731	
18206	1556	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	104201	0	180256009	4107731	
6461	601	4107731	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	39692	0	180256009	4107731	
6657	610	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	40535	0	180256009	4107731	
6889	621	4024289	1919-04-17	1919-04-17 00:00:00	38000275	0	\N	\N	41485	0	19490002	4024289	
7057	649	4163872	1978-04-26	1978-04-26 00:00:00	38000275	0	\N	\N	42979	0	399208008	4163872	
7224	670	4125906	1998-08-24	1998-08-24 00:00:00	38000275	0	\N	\N	44253	0	288086009	4125906	
7385	685	4043071	1977-04-05	1977-04-05 00:00:00	38000275	0	\N	\N	45257	0	228557008	4043071	
7576	704	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	46609	0	180256009	4107731	
7806	712	4043071	1989-02-23	1989-02-23 00:00:00	38000275	0	\N	\N	47245	0	228557008	4043071	
8035	730	4170947	1965-11-02	1965-11-02 00:00:00	38000275	0	\N	\N	48502	0	274474001	4170947	
8132	742	4035793	1990-04-09	1990-04-09 00:00:00	38000275	0	\N	\N	49116	0	15081005	4035793	
8315	759	4151422	1948-12-14	1948-12-14 00:00:00	38000275	0	\N	\N	50372	0	269911007	4151422	
20497	1769	4295880	1995-05-31	1995-05-31 00:00:00	38000275	0	\N	\N	118306	0	76601001	4295880	
20693	1782	4170947	1961-09-09	1961-09-09 00:00:00	38000275	0	\N	\N	119340	0	274474001	4170947	
20925	1801	4197460	1955-05-17	1955-05-17 00:00:00	38000275	0	\N	\N	120748	0	313191000	4197460	
9128	842	4125906	1970-10-20	1970-10-20 00:00:00	38000275	0	\N	\N	55712	0	288086009	4125906	
9250	844	4293740	1995-04-21	1995-04-21 00:00:00	38000275	0	\N	\N	56004	0	384700001	4293740	
9505	863	4125906	1930-02-16	1930-02-16 00:00:00	38000275	0	\N	\N	57206	0	288086009	4125906	
21684	1882	4107731	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	125503	0	180256009	4107731	
9825	883	4151422	1986-03-20	1986-03-20 00:00:00	38000275	0	\N	\N	58814	0	269911007	4151422	
21924	1908	4163872	2018-03-11	2018-03-11 00:00:00	38000275	0	\N	\N	126954	0	399208008	4163872	
22083	1923	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	127968	0	180256009	4107731	
10375	923	4151422	1987-02-02	1987-02-02 00:00:00	38000275	0	\N	\N	61489	0	269911007	4151422	
10619	959	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	63690	0	180256009	4107731	
22662	1977	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	131539	0	180256009	4107731	
22852	1991	4336464	2011-02-21	2011-02-21 00:00:00	38000275	0	\N	\N	132611	0	232717009	4336464	
23085	2002	4252419	1983-08-01	1983-08-01 00:00:00	38000275	0	\N	\N	133380	0	74016001	4252419	
11377	1058	4107731	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	69494	0	180256009	4107731	
23466	2054	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	136602	0	180256009	4107731	
11690	1082	4107731	1991-05-04	1991-05-04 00:00:00	38000275	0	\N	\N	70936	0	180256009	4107731	
11938	1092	4252419	1962-08-04	1962-08-04 00:00:00	38000275	0	\N	\N	71796	0	74016001	4252419	
89	5	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	408	0	395142003	4191853	
281	16	4243062	2004-01-21	2004-01-21 00:00:00	38000275	0	\N	\N	1165	0	60027007	4243062	
554	36	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	2558	0	180256009	4107731	
12573	1138	4043071	1996-07-18	1996-07-18 00:00:00	38000275	0	\N	\N	74994	0	228557008	4043071	
12828	1148	4170947	1967-09-03	1967-09-03 00:00:00	38000275	0	\N	\N	75931	0	274474001	4170947	
1069	105	4293740	1985-10-08	1985-10-08 00:00:00	38000275	0	\N	\N	7146	0	384700001	4293740	
1219	124	4107731	1998-09-29	1998-09-29 00:00:00	38000275	0	\N	\N	8218	0	180256009	4107731	
1487	140	4295880	1998-06-25	1998-06-25 00:00:00	38000275	0	\N	\N	9360	0	76601001	4295880	
13536	1226	4043071	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	80695	0	228557008	4043071	
1774	160	4326177	2000-07-17	2000-07-17 00:00:00	38000275	0	\N	\N	11003	0	430193006	4326177	
1969	183	4043071	1982-12-24	1982-12-24 00:00:00	38000275	0	\N	\N	12359	0	228557008	4043071	
2182	225	4107731	1993-03-01	1993-03-01 00:00:00	38000275	0	\N	\N	15171	0	180256009	4107731	
2387	236	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	15883	0	180256009	4107731	
2548	260	4107731	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	17215	0	180256009	4107731	
14698	1310	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	86556	0	180256009	4107731	
2916	280	4195803	2010-10-11	2010-10-11 00:00:00	38000275	0	\N	\N	18708	0	312681000	4195803	
14978	1328	4035793	2010-03-11	2010-03-11 00:00:00	38000275	0	\N	\N	88213	0	15081005	4035793	
3336	332	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	21942	0	180256009	4107731	
3520	341	4238715	1980-07-21	1980-07-21 00:00:00	38000275	0	\N	\N	22775	0	68254000	4238715	
3645	351	4295880	1999-01-26	1999-01-26 00:00:00	38000275	0	\N	\N	23418	0	76601001	4295880	
3890	394	4336464	1997-12-29	1997-12-29 00:00:00	38000275	0	\N	\N	25915	0	232717009	4336464	
4018	403	4293740	2019-01-09	2019-01-09 00:00:00	38000275	0	\N	\N	26468	0	384700001	4293740	
4208	409	4170947	1955-10-10	1955-10-10 00:00:00	38000275	0	\N	\N	27149	0	274474001	4170947	
16418	1431	4107731	1993-02-13	1993-02-13 00:00:00	38000275	0	\N	\N	95349	0	180256009	4107731	
4651	442	4107731	1992-04-25	1992-04-25 00:00:00	38000275	0	\N	\N	29410	0	180256009	4107731	
4842	450	4047491	1981-07-25	1981-07-25 00:00:00	38000275	0	\N	\N	30053	0	1225002	4047491	
5007	469	4043071	1946-08-19	1946-08-19 00:00:00	38000275	0	\N	\N	31235	0	228557008	4043071	
5157	480	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	32108	0	180256009	4107731	
5394	499	4062501	1962-04-30	1962-04-30 00:00:00	38000275	0	\N	\N	33344	0	171231001	4062501	
5518	505	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	33864	0	180256009	4107731	
17579	1512	4295880	1997-10-29	1997-10-29 00:00:00	38000275	0	\N	\N	100978	0	76601001	4295880	
5910	545	4170947	2015-10-16	2015-10-16 00:00:00	38000275	0	\N	\N	36146	0	274474001	4170947	
6154	563	4107731	1991-03-03	1991-03-03 00:00:00	38000275	0	\N	\N	37215	0	180256009	4107731	
18207	1556	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	104171	0	180256009	4107731	
6462	601	4107731	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	39703	0	180256009	4107731	
6658	610	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	40541	0	180256009	4107731	
6890	621	4170947	1919-04-17	1919-04-17 00:00:00	38000275	0	\N	\N	41485	0	274474001	4170947	
7058	649	4170947	1978-04-26	1978-04-26 00:00:00	38000275	0	\N	\N	42979	0	274474001	4170947	
7256	672	4151422	1967-03-26	1967-03-26 00:00:00	38000275	0	\N	\N	44349	0	269911007	4151422	
7386	685	4043071	1975-04-22	1975-04-22 00:00:00	38000275	0	\N	\N	45291	0	228557008	4043071	
7577	704	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	46587	0	180256009	4107731	
7808	715	4125906	2008-06-17	2008-06-17 00:00:00	38000275	0	\N	\N	47302	0	288086009	4125906	
8036	730	4163872	1965-11-02	1965-11-02 00:00:00	38000275	0	\N	\N	48502	0	399208008	4163872	
8133	742	4035793	2005-07-04	2005-07-04 00:00:00	38000275	0	\N	\N	49182	0	15081005	4035793	
8316	759	4078793	2011-04-06	2011-04-06 00:00:00	38000275	0	\N	\N	50425	0	180325003	4078793	
20498	1769	4295880	1993-08-26	1993-08-26 00:00:00	38000275	0	\N	\N	118304	0	76601001	4295880	
20694	1782	4024289	1961-09-09	1961-09-09 00:00:00	38000275	0	\N	\N	119340	0	19490002	4024289	
20926	1801	4078793	2007-08-08	2007-08-08 00:00:00	38000275	0	\N	\N	120779	0	180325003	4078793	
9129	842	4035793	1995-07-01	1995-07-01 00:00:00	38000275	0	\N	\N	55696	0	15081005	4035793	
9251	844	4107731	1992-12-12	1992-12-12 00:00:00	38000275	0	\N	\N	55987	0	180256009	4107731	
9506	863	4078793	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	57185	0	180325003	4078793	
21685	1882	4107731	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	125596	0	180256009	4107731	
9826	884	4107731	1993-11-09	1993-11-09 00:00:00	38000275	0	\N	\N	58896	0	180256009	4107731	
21925	1908	4170947	2018-03-11	2018-03-11 00:00:00	38000275	0	\N	\N	126954	0	274474001	4170947	
22084	1923	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	127996	0	180256009	4107731	
10376	923	4151422	2001-05-22	2001-05-22 00:00:00	38000275	0	\N	\N	61422	0	269911007	4151422	
10620	959	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	63744	0	180256009	4107731	
22663	1977	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	131598	0	180256009	4107731	
22853	1991	4047491	1958-07-15	1958-07-15 00:00:00	38000275	0	\N	\N	132607	0	1225002	4047491	
23086	2002	44783196	1983-08-08	1983-08-08 00:00:00	38000275	0	\N	\N	133372	0	699253003	44783196	
11378	1058	4107731	1992-06-06	1992-06-06 00:00:00	38000275	0	\N	\N	69368	0	180256009	4107731	
23467	2054	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	136670	0	180256009	4107731	
11691	1082	4107731	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	70988	0	180256009	4107731	
11939	1092	4293740	1982-12-22	1982-12-22 00:00:00	38000275	0	\N	\N	71798	0	384700001	4293740	
90	5	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	429	0	180256009	4107731	
282	16	4170947	2004-01-21	2004-01-21 00:00:00	38000275	0	\N	\N	1165	0	274474001	4170947	
555	36	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	2537	0	180256009	4107731	
12574	1138	4107731	1994-09-15	1994-09-15 00:00:00	38000275	0	\N	\N	75076	0	180256009	4107731	
12829	1148	4198190	2010-06-10	2010-06-10 00:00:00	38000275	0	\N	\N	75935	0	80146002	4198190	
1070	105	4125906	1985-10-08	1985-10-08 00:00:00	38000275	0	\N	\N	7146	0	288086009	4125906	
1220	124	4107731	1998-05-05	1998-05-05 00:00:00	38000275	0	\N	\N	8249	0	180256009	4107731	
1488	140	4295880	1997-12-25	1997-12-25 00:00:00	38000275	0	\N	\N	9384	0	76601001	4295880	
13537	1226	4043071	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	80710	0	228557008	4043071	
1775	160	4037675	2000-07-17	2000-07-17 00:00:00	38000275	0	\N	\N	11003	0	162676008	4037675	
1970	183	4043071	1983-12-16	1983-12-16 00:00:00	38000275	0	\N	\N	12337	0	228557008	4043071	
2183	225	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	15248	0	180256009	4107731	
2388	236	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	15886	0	180256009	4107731	
2549	260	4107731	1990-08-04	1990-08-04 00:00:00	38000275	0	\N	\N	17226	0	180256009	4107731	
14699	1310	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	86560	0	180256009	4107731	
2917	280	4170947	2010-10-11	2010-10-11 00:00:00	38000275	0	\N	\N	18708	0	274474001	4170947	
14979	1328	4202451	2019-06-13	2019-06-13 00:00:00	38000275	0	\N	\N	88175	0	433112001	4202451	
3337	332	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	22054	0	180256009	4107731	
3521	343	4107731	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	22858	0	180256009	4107731	
3646	351	4295880	2002-01-22	2002-01-22 00:00:00	38000275	0	\N	\N	23381	0	76601001	4295880	
3891	394	4216130	1997-12-29	1997-12-29 00:00:00	38000275	0	\N	\N	25915	0	415070008	4216130	
4019	403	4125906	2019-01-09	2019-01-09 00:00:00	38000275	0	\N	\N	26468	0	288086009	4125906	
4209	409	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	27113	0	180256009	4107731	
16419	1431	4107731	1990-07-14	1990-07-14 00:00:00	38000275	0	\N	\N	95303	0	180256009	4107731	
4652	442	4107731	1991-03-23	1991-03-23 00:00:00	38000275	0	\N	\N	29323	0	180256009	4107731	
4843	450	4170947	1981-07-25	1981-07-25 00:00:00	38000275	0	\N	\N	30053	0	274474001	4170947	
5008	469	4043071	1945-04-30	1945-04-30 00:00:00	38000275	0	\N	\N	31246	0	228557008	4043071	
5158	480	4151422	2010-09-15	2010-09-15 00:00:00	38000275	0	\N	\N	32092	0	269911007	4151422	
5395	499	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	33423	0	395142003	4191853	
5519	505	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	33837	0	180256009	4107731	
17580	1512	4295880	1997-07-30	1997-07-30 00:00:00	38000275	0	\N	\N	101011	0	76601001	4295880	
5911	545	4107731	1991-01-19	1991-01-19 00:00:00	38000275	0	\N	\N	36057	0	180256009	4107731	
6155	563	4107731	1993-02-14	1993-02-14 00:00:00	38000275	0	\N	\N	37268	0	180256009	4107731	
18208	1556	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	104176	0	180256009	4107731	
6463	601	4107731	1993-04-18	1993-04-18 00:00:00	38000275	0	\N	\N	39711	0	180256009	4107731	
6659	610	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	40551	0	180256009	4107731	
6891	621	4057420	2018-04-04	2018-04-04 00:00:00	38000275	0	\N	\N	41412	0	18286008	4057420	
7059	649	4057420	2011-01-25	2011-01-25 00:00:00	38000275	0	\N	\N	42970	0	18286008	4057420	
7257	672	4125906	1985-03-16	1985-03-16 00:00:00	38000275	0	\N	\N	44413	0	288086009	4125906	
7387	685	4043071	1977-07-05	1977-07-05 00:00:00	38000275	0	\N	\N	45357	0	228557008	4043071	
7578	704	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	46524	0	180256009	4107731	
7809	715	4125906	2002-09-03	2002-09-03 00:00:00	38000275	0	\N	\N	47301	0	288086009	4125906	
8037	730	4170947	1960-05-02	1960-05-02 00:00:00	38000275	0	\N	\N	48501	0	274474001	4170947	
8134	742	4035793	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	49117	0	15081005	4035793	
8317	759	4151422	1957-10-07	1957-10-07 00:00:00	38000275	0	\N	\N	50433	0	269911007	4151422	
20499	1769	4295880	1995-03-01	1995-03-01 00:00:00	38000275	0	\N	\N	118288	0	76601001	4295880	
20695	1782	4125906	2009-11-17	2009-11-17 00:00:00	38000275	0	\N	\N	119344	0	288086009	4125906	
20927	1801	4078793	2013-09-11	2013-09-11 00:00:00	38000275	0	\N	\N	120790	0	180325003	4078793	
9130	842	4151422	2009-01-17	2009-01-17 00:00:00	38000275	0	\N	\N	55648	0	269911007	4151422	
9252	844	4107731	1990-06-23	1990-06-23 00:00:00	38000275	0	\N	\N	56012	0	180256009	4107731	
9507	863	4078793	2007-06-28	2007-06-28 00:00:00	38000275	0	\N	\N	57190	0	180325003	4078793	
21686	1882	4107731	1993-03-27	1993-03-27 00:00:00	38000275	0	\N	\N	125553	0	180256009	4107731	
9827	884	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	58899	0	180256009	4107731	
21926	1908	4151422	2007-01-14	2007-01-14 00:00:00	38000275	0	\N	\N	126958	0	269911007	4151422	
22085	1923	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	127885	0	180256009	4107731	
10377	923	4163872	2000-10-21	2000-10-21 00:00:00	38000275	0	\N	\N	61433	0	399208008	4163872	
10621	959	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	63675	0	180256009	4107731	
22664	1977	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	131580	0	180256009	4107731	
22854	1991	4170947	1958-07-15	1958-07-15 00:00:00	38000275	0	\N	\N	132607	0	274474001	4170947	
23087	2004	4151422	1984-05-25	1984-05-25 00:00:00	38000275	0	\N	\N	133448	0	269911007	4151422	
11379	1058	4107731	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	69433	0	180256009	4107731	
23468	2054	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	136626	0	395142003	4191853	
11692	1082	4125906	2018-07-20	2018-07-20 00:00:00	38000275	0	\N	\N	71053	0	288086009	4125906	
11940	1092	4125906	1982-12-22	1982-12-22 00:00:00	38000275	0	\N	\N	71798	0	288086009	4125906	
91	5	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	411	0	180256009	4107731	
283	16	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	1193	0	180256009	4107731	
556	36	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	2520	0	180256009	4107731	
12575	1138	4043071	1997-08-14	1997-08-14 00:00:00	38000275	0	\N	\N	75115	0	228557008	4043071	
12830	1148	4024289	1967-09-03	1967-09-03 00:00:00	38000275	0	\N	\N	75931	0	19490002	4024289	
1071	105	4336464	2005-11-11	2005-11-11 00:00:00	38000275	0	\N	\N	7147	0	232717009	4336464	
1221	124	4107731	1997-11-17	1997-11-17 00:00:00	38000275	0	\N	\N	8214	0	180256009	4107731	
1489	141	4295880	2001-05-15	2001-05-15 00:00:00	38000275	0	\N	\N	9447	0	76601001	4295880	
13538	1226	4043071	1991-04-24	1991-04-24 00:00:00	38000275	0	\N	\N	80711	0	228557008	4043071	
1776	161	4125906	2009-06-10	2009-06-10 00:00:00	38000275	0	\N	\N	11057	0	288086009	4125906	
1971	183	4043071	1983-07-22	1983-07-22 00:00:00	38000275	0	\N	\N	12405	0	228557008	4043071	
2184	225	4107731	1992-01-06	1992-01-06 00:00:00	38000275	0	\N	\N	15217	0	180256009	4107731	
2389	236	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	15957	0	180256009	4107731	
2550	260	4107731	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	17214	0	180256009	4107731	
14700	1310	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	86685	0	395142003	4191853	
2918	280	4243062	2010-10-11	2010-10-11 00:00:00	38000275	0	\N	\N	18708	0	60027007	4243062	
14980	1328	4035793	2019-05-02	2019-05-02 00:00:00	38000275	0	\N	\N	88175	0	15081005	4035793	
3338	332	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	22020	0	180256009	4107731	
3522	343	4197460	1971-02-25	1971-02-25 00:00:00	38000275	0	\N	\N	22848	0	313191000	4197460	
3647	351	4295880	2002-04-23	2002-04-23 00:00:00	38000275	0	\N	\N	23390	0	76601001	4295880	
3892	394	4151422	1953-03-10	1953-03-10 00:00:00	38000275	0	\N	\N	25894	0	269911007	4151422	
4020	403	4057420	2010-04-05	2010-04-05 00:00:00	38000275	0	\N	\N	26472	0	18286008	4057420	
4210	409	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	27073	0	395142003	4191853	
16420	1431	4107731	1992-08-29	1992-08-29 00:00:00	38000275	0	\N	\N	95271	0	180256009	4107731	
4653	442	4107731	1993-04-17	1993-04-17 00:00:00	38000275	0	\N	\N	29367	0	180256009	4107731	
4844	452	4252419	2013-06-07	2013-06-07 00:00:00	38000275	0	\N	\N	30150	0	74016001	4252419	
5009	469	4043071	1949-05-23	1949-05-23 00:00:00	38000275	0	\N	\N	31286	0	228557008	4043071	
5159	480	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	31996	0	180256009	4107731	
5396	499	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	33427	0	180256009	4107731	
5520	505	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	33787	0	180256009	4107731	
17581	1512	4295880	1995-08-02	1995-08-02 00:00:00	38000275	0	\N	\N	100957	0	76601001	4295880	
5912	545	4107731	1993-01-23	1993-01-23 00:00:00	38000275	0	\N	\N	36047	0	180256009	4107731	
6156	563	4125906	1969-04-16	1969-04-16 00:00:00	38000275	0	\N	\N	37269	0	288086009	4125906	
18209	1556	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	104244	0	180256009	4107731	
6464	601	4107731	1990-09-16	1990-09-16 00:00:00	38000275	0	\N	\N	39728	0	180256009	4107731	
6660	610	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	40534	0	180256009	4107731	
6892	621	4195803	2003-01-08	2003-01-08 00:00:00	38000275	0	\N	\N	41389	0	312681000	4195803	
7060	649	40492359	2011-01-25	2011-01-25 00:00:00	38000275	0	\N	\N	42970	0	447365002	40492359	
7258	672	44783196	2000-02-24	2000-02-24 00:00:00	38000275	0	\N	\N	44415	0	699253003	44783196	
7388	685	4043071	1976-09-28	1976-09-28 00:00:00	38000275	0	\N	\N	45269	0	228557008	4043071	
7579	704	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	46565	0	180256009	4107731	
7810	715	4238715	2000-06-13	2000-06-13 00:00:00	38000275	0	\N	\N	47311	0	68254000	4238715	
8038	730	4243062	1960-05-02	1960-05-02 00:00:00	38000275	0	\N	\N	48501	0	60027007	4243062	
8135	742	4035793	1987-11-02	1987-11-02 00:00:00	38000275	0	\N	\N	49207	0	15081005	4035793	
8318	759	4078793	2006-03-08	2006-03-08 00:00:00	38000275	0	\N	\N	50442	0	180325003	4078793	
20500	1769	4295880	1994-06-01	1994-06-01 00:00:00	38000275	0	\N	\N	118287	0	76601001	4295880	
20696	1782	4058899	1968-12-01	1968-12-01 00:00:00	38000275	0	\N	\N	119341	0	168594001	4058899	
20928	1801	4151422	1964-01-31	1964-01-31 00:00:00	38000275	0	\N	\N	120729	0	269911007	4151422	
9131	842	4035793	1981-03-14	1981-03-14 00:00:00	38000275	0	\N	\N	55665	0	15081005	4035793	
9253	844	4107731	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	55962	0	180256009	4107731	
9508	863	4078793	1994-04-14	1994-04-14 00:00:00	38000275	0	\N	\N	57186	0	180325003	4078793	
21687	1882	4107731	1993-01-02	1993-01-02 00:00:00	38000275	0	\N	\N	125551	0	180256009	4107731	
9828	884	4107731	1993-09-28	1993-09-28 00:00:00	38000275	0	\N	\N	58854	0	180256009	4107731	
21952	1911	4275113	1968-10-09	1968-10-09 00:00:00	38000275	0	\N	\N	127150	0	65200003	4275113	
22086	1923	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	127931	0	180256009	4107731	
10378	923	4151422	1976-10-30	1976-10-30 00:00:00	38000275	0	\N	\N	61487	0	269911007	4151422	
10622	959	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	63750	0	180256009	4107731	
22665	1977	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	131541	0	180256009	4107731	
22855	1991	4125906	1992-12-02	1992-12-02 00:00:00	38000275	0	\N	\N	132610	0	288086009	4125906	
23088	2004	4125906	1989-12-28	1989-12-28 00:00:00	38000275	0	\N	\N	133464	0	288086009	4125906	
11380	1058	4107731	1993-03-27	1993-03-27 00:00:00	38000275	0	\N	\N	69452	0	180256009	4107731	
23469	2054	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	136650	0	180256009	4107731	
11693	1082	4107731	1990-10-27	1990-10-27 00:00:00	38000275	0	\N	\N	70913	0	180256009	4107731	
11941	1092	4195803	2000-11-29	2000-11-29 00:00:00	38000275	0	\N	\N	71801	0	312681000	4195803	
92	5	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	410	0	180256009	4107731	
284	16	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	1172	0	180256009	4107731	
557	36	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	2494	0	180256009	4107731	
12576	1138	4043071	1995-05-11	1995-05-11 00:00:00	38000275	0	\N	\N	75079	0	228557008	4043071	
12831	1149	44783196	1986-11-26	1986-11-26 00:00:00	38000275	0	\N	\N	75978	0	699253003	44783196	
1072	105	4216130	2005-11-11	2005-11-11 00:00:00	38000275	0	\N	\N	7147	0	415070008	4216130	
1222	124	4107731	1997-04-22	1997-04-22 00:00:00	38000275	0	\N	\N	8326	0	180256009	4107731	
1490	141	4170947	1995-07-30	1995-07-30 00:00:00	38000275	0	\N	\N	9484	0	274474001	4170947	
13539	1226	4043071	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	80690	0	228557008	4043071	
1777	161	4125906	2011-07-21	2011-07-21 00:00:00	38000275	0	\N	\N	11058	0	288086009	4125906	
1972	183	4198190	1986-10-22	1986-10-22 00:00:00	38000275	0	\N	\N	12413	0	80146002	4198190	
2185	225	4107731	1991-04-29	1991-04-29 00:00:00	38000275	0	\N	\N	15239	0	180256009	4107731	
2390	236	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	15849	0	180256009	4107731	
2551	260	4107731	1991-07-06	1991-07-06 00:00:00	38000275	0	\N	\N	17247	0	180256009	4107731	
14701	1310	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	86687	0	180256009	4107731	
2919	280	4163872	2017-08-17	2017-08-17 00:00:00	38000275	0	\N	\N	18768	0	399208008	4163872	
14981	1328	4035793	2011-03-17	2011-03-17 00:00:00	38000275	0	\N	\N	88173	0	15081005	4035793	
3339	332	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	21885	0	180256009	4107731	
3523	343	4107731	1992-01-11	1992-01-11 00:00:00	38000275	0	\N	\N	22894	0	180256009	4107731	
3648	351	4295880	2001-10-23	2001-10-23 00:00:00	38000275	0	\N	\N	23401	0	76601001	4295880	
3893	394	4125906	1938-07-25	1938-07-25 00:00:00	38000275	0	\N	\N	25913	0	288086009	4125906	
4021	403	4078793	2003-02-24	2003-02-24 00:00:00	38000275	0	\N	\N	26475	0	180325003	4078793	
4211	409	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	27008	0	180256009	4107731	
16421	1431	4107731	1992-04-25	1992-04-25 00:00:00	38000275	0	\N	\N	95334	0	180256009	4107731	
4654	442	4125906	1989-12-08	1989-12-08 00:00:00	38000275	0	\N	\N	29286	0	288086009	4125906	
4845	452	4151422	2008-12-14	2008-12-14 00:00:00	38000275	0	\N	\N	30106	0	269911007	4151422	
5010	469	4043071	1945-01-22	1945-01-22 00:00:00	38000275	0	\N	\N	31335	0	228557008	4043071	
5160	480	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	31979	0	180256009	4107731	
5397	499	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	33391	0	180256009	4107731	
5521	505	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	33785	0	180256009	4107731	
17582	1512	4295880	1997-04-30	1997-04-30 00:00:00	38000275	0	\N	\N	100997	0	76601001	4295880	
5913	545	4107731	1990-12-29	1990-12-29 00:00:00	38000275	0	\N	\N	36100	0	180256009	4107731	
6157	563	4107731	1992-02-23	1992-02-23 00:00:00	38000275	0	\N	\N	37263	0	180256009	4107731	
18210	1556	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	104203	0	180256009	4107731	
6465	601	4107731	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	39727	0	180256009	4107731	
6661	610	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	40539	0	180256009	4107731	
6893	621	4057420	2017-03-29	2017-03-29 00:00:00	38000275	0	\N	\N	41408	0	18286008	4057420	
7061	651	4057420	1999-01-28	1999-01-28 00:00:00	38000275	0	\N	\N	43079	0	18286008	4057420	
7259	672	4125906	1983-02-04	1983-02-04 00:00:00	38000275	0	\N	\N	44412	0	288086009	4125906	
7389	685	4043071	1976-08-03	1976-08-03 00:00:00	38000275	0	\N	\N	45294	0	228557008	4043071	
7580	704	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	46588	0	180256009	4107731	
7811	715	4275113	2000-01-30	2000-01-30 00:00:00	38000275	0	\N	\N	47293	0	65200003	4275113	
8039	730	4195803	2017-09-16	2017-09-16 00:00:00	38000275	0	\N	\N	48464	0	312681000	4195803	
8136	742	4035793	2012-12-17	2012-12-17 00:00:00	38000275	0	\N	\N	49197	0	15081005	4035793	
8319	759	4151422	1982-12-30	1982-12-30 00:00:00	38000275	0	\N	\N	50392	0	269911007	4151422	
20501	1769	4295880	1995-11-29	1995-11-29 00:00:00	38000275	0	\N	\N	118289	0	76601001	4295880	
20697	1782	4151422	1960-02-01	1960-02-01 00:00:00	38000275	0	\N	\N	119372	0	269911007	4151422	
20929	1801	4078793	2010-08-25	2010-08-25 00:00:00	38000275	0	\N	\N	120778	0	180325003	4078793	
9132	842	4035793	2010-09-25	2010-09-25 00:00:00	38000275	0	\N	\N	55700	0	15081005	4035793	
9254	844	4107731	1990-01-27	1990-01-27 00:00:00	38000275	0	\N	\N	55970	0	180256009	4107731	
9509	863	4057420	1985-02-21	1985-02-21 00:00:00	38000275	0	\N	\N	57192	0	18286008	4057420	
21688	1882	4107731	1991-11-09	1991-11-09 00:00:00	38000275	0	\N	\N	125562	0	180256009	4107731	
9829	884	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	58893	0	180256009	4107731	
21953	1911	4035793	2007-10-29	2007-10-29 00:00:00	38000275	0	\N	\N	127122	0	15081005	4035793	
22087	1923	4195803	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	127980	0	312681000	4195803	
10379	924	4170947	2013-09-29	2013-09-29 00:00:00	38000275	0	\N	\N	61543	0	274474001	4170947	
10623	959	4243062	1970-05-13	1970-05-13 00:00:00	38000275	0	\N	\N	63783	0	60027007	4243062	
22666	1977	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	131522	0	180256009	4107731	
22856	1991	4151422	1965-12-03	1965-12-03 00:00:00	38000275	0	\N	\N	132603	0	269911007	4151422	
23089	2004	4238715	1989-05-30	1989-05-30 00:00:00	38000275	0	\N	\N	133452	0	68254000	4238715	
11381	1058	4107731	1991-11-09	1991-11-09 00:00:00	38000275	0	\N	\N	69471	0	180256009	4107731	
23470	2054	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	136646	0	180256009	4107731	
11694	1082	4107731	1990-06-02	1990-06-02 00:00:00	38000275	0	\N	\N	70906	0	180256009	4107731	
11942	1092	4047491	2000-11-29	2000-11-29 00:00:00	38000275	0	\N	\N	71801	0	1225002	4047491	
93	5	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	512	0	180256009	4107731	
285	16	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	1232	0	180256009	4107731	
558	36	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	2491	0	180256009	4107731	
12577	1138	4043071	1994-07-07	1994-07-07 00:00:00	38000275	0	\N	\N	75109	0	228557008	4043071	
12832	1149	4170947	2007-10-21	2007-10-21 00:00:00	38000275	0	\N	\N	75947	0	274474001	4170947	
1107	110	4151422	2015-02-10	2015-02-10 00:00:00	38000275	0	\N	\N	7311	0	269911007	4151422	
1223	124	4107731	1998-10-20	1998-10-20 00:00:00	38000275	0	\N	\N	8309	0	180256009	4107731	
1491	141	4163872	1995-07-30	1995-07-30 00:00:00	38000275	0	\N	\N	9484	0	399208008	4163872	
13540	1226	4043071	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	80687	0	228557008	4043071	
1778	161	4125906	2018-07-03	2018-07-03 00:00:00	38000275	0	\N	\N	11061	0	288086009	4125906	
1973	183	4170947	1981-05-04	1981-05-04 00:00:00	38000275	0	\N	\N	12347	0	274474001	4170947	
2186	225	4107731	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	15197	0	180256009	4107731	
2391	236	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	15893	0	180256009	4107731	
2552	260	4107731	1991-07-27	1991-07-27 00:00:00	38000275	0	\N	\N	17171	0	180256009	4107731	
14702	1310	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	86591	0	180256009	4107731	
2924	283	4058899	1998-04-21	1998-04-21 00:00:00	38000275	0	\N	\N	18881	0	168594001	4058899	
14982	1328	4035793	2013-03-28	2013-03-28 00:00:00	38000275	0	\N	\N	88233	0	15081005	4035793	
3340	332	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	22023	0	180256009	4107731	
3524	343	4107731	1990-06-02	1990-06-02 00:00:00	38000275	0	\N	\N	22940	0	180256009	4107731	
3649	351	4295880	2001-07-24	2001-07-24 00:00:00	38000275	0	\N	\N	23415	0	76601001	4295880	
3894	394	4216130	1989-03-27	1989-03-27 00:00:00	38000275	0	\N	\N	25914	0	415070008	4216130	
4022	404	4043071	1971-05-28	1971-05-28 00:00:00	38000275	0	\N	\N	26667	0	228557008	4043071	
4212	409	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	27120	0	180256009	4107731	
16422	1431	4107731	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	95333	0	180256009	4107731	
4655	442	4107731	1991-12-21	1991-12-21 00:00:00	38000275	0	\N	\N	29326	0	180256009	4107731	
4846	453	4043071	1983-04-26	1983-04-26 00:00:00	38000275	0	\N	\N	30206	0	228557008	4043071	
5011	469	4043071	1947-05-26	1947-05-26 00:00:00	38000275	0	\N	\N	31214	0	228557008	4043071	
5161	480	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	32089	0	180256009	4107731	
5398	499	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	33370	0	180256009	4107731	
5522	505	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	33838	0	180256009	4107731	
17583	1512	4295880	1998-01-28	1998-01-28 00:00:00	38000275	0	\N	\N	100998	0	76601001	4295880	
5914	545	4107731	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	36073	0	180256009	4107731	
6158	563	4107731	1991-12-22	1991-12-22 00:00:00	38000275	0	\N	\N	37308	0	180256009	4107731	
18211	1556	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	104178	0	180256009	4107731	
6466	601	4107731	1992-04-26	1992-04-26 00:00:00	38000275	0	\N	\N	39706	0	180256009	4107731	
6662	610	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	40586	0	180256009	4107731	
6894	621	4078793	2015-03-18	2015-03-18 00:00:00	38000275	0	\N	\N	41407	0	180325003	4078793	
7062	651	40492359	1999-01-28	1999-01-28 00:00:00	38000275	0	\N	\N	43079	0	447365002	40492359	
7260	672	4252419	2000-02-17	2000-02-17 00:00:00	38000275	0	\N	\N	44414	0	74016001	4252419	
7390	685	4043071	1976-06-29	1976-06-29 00:00:00	38000275	0	\N	\N	45256	0	228557008	4043071	
7581	704	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	46618	0	180256009	4107731	
7814	718	4107731	1991-01-19	1991-01-19 00:00:00	38000275	0	\N	\N	47431	0	180256009	4107731	
8040	732	4163872	1986-07-18	1986-07-18 00:00:00	38000275	0	\N	\N	48573	0	399208008	4163872	
8137	742	4078793	2012-12-17	2012-12-17 00:00:00	38000275	0	\N	\N	49197	0	180325003	4078793	
8320	759	4195803	2016-11-17	2016-11-17 00:00:00	38000275	0	\N	\N	50364	0	312681000	4195803	
20502	1769	4295880	1993-12-01	1993-12-01 00:00:00	38000275	0	\N	\N	118273	0	76601001	4295880	
20698	1782	4151422	1955-08-13	1955-08-13 00:00:00	38000275	0	\N	\N	119359	0	269911007	4151422	
20930	1801	4151422	2009-11-24	2009-11-24 00:00:00	38000275	0	\N	\N	120736	0	269911007	4151422	
9133	842	4035793	1989-05-27	1989-05-27 00:00:00	38000275	0	\N	\N	55739	0	15081005	4035793	
9255	844	4107731	1992-06-27	1992-06-27 00:00:00	38000275	0	\N	\N	55882	0	180256009	4107731	
9510	863	4078793	1995-04-20	1995-04-20 00:00:00	38000275	0	\N	\N	57114	0	180325003	4078793	
21689	1882	4107731	1991-07-27	1991-07-27 00:00:00	38000275	0	\N	\N	125571	0	180256009	4107731	
9830	884	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	58851	0	180256009	4107731	
21954	1911	4035793	2005-10-17	2005-10-17 00:00:00	38000275	0	\N	\N	127114	0	15081005	4035793	
22088	1923	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	128012	0	180256009	4107731	
10380	924	4024289	2013-09-29	2013-09-29 00:00:00	38000275	0	\N	\N	61543	0	19490002	4024289	
10624	959	4170947	1970-05-13	1970-05-13 00:00:00	38000275	0	\N	\N	63783	0	274474001	4170947	
22667	1977	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	131511	0	180256009	4107731	
22857	1991	4151422	1988-08-19	1988-08-19 00:00:00	38000275	0	\N	\N	132633	0	269911007	4151422	
23090	2004	4275113	1986-05-27	1986-05-27 00:00:00	38000275	0	\N	\N	133451	0	65200003	4275113	
11382	1058	4107731	1990-08-04	1990-08-04 00:00:00	38000275	0	\N	\N	69485	0	180256009	4107731	
23471	2054	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	136593	0	180256009	4107731	
11695	1082	4107731	1992-08-29	1992-08-29 00:00:00	38000275	0	\N	\N	70995	0	180256009	4107731	
11943	1092	4170947	2000-11-29	2000-11-29 00:00:00	38000275	0	\N	\N	71801	0	274474001	4170947	
94	5	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	515	0	180256009	4107731	
286	16	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	1245	0	180256009	4107731	
559	36	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	2532	0	180256009	4107731	
12578	1138	4043071	1995-03-09	1995-03-09 00:00:00	38000275	0	\N	\N	75054	0	228557008	4043071	
12833	1149	4243062	2007-10-21	2007-10-21 00:00:00	38000275	0	\N	\N	75947	0	60027007	4243062	
1108	110	4238715	1995-02-12	1995-02-12 00:00:00	38000275	0	\N	\N	7339	0	68254000	4238715	
1224	124	4107731	1997-08-26	1997-08-26 00:00:00	38000275	0	\N	\N	8303	0	180256009	4107731	
1492	141	4295880	2001-11-13	2001-11-13 00:00:00	38000275	0	\N	\N	9454	0	76601001	4295880	
13541	1226	4043071	1991-03-27	1991-03-27 00:00:00	38000275	0	\N	\N	80689	0	228557008	4043071	
1779	161	4163872	1990-07-20	1990-07-20 00:00:00	38000275	0	\N	\N	11056	0	399208008	4163872	
1974	183	4243062	1981-05-04	1981-05-04 00:00:00	38000275	0	\N	\N	12347	0	60027007	4243062	
2187	225	4107731	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	15188	0	180256009	4107731	
2392	236	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	15859	0	180256009	4107731	
2553	260	4107731	1993-02-13	1993-02-13 00:00:00	38000275	0	\N	\N	17186	0	180256009	4107731	
14703	1310	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	86617	0	180256009	4107731	
2925	283	4062501	1984-09-07	1984-09-07 00:00:00	38000275	0	\N	\N	18834	0	171231001	4062501	
14983	1328	4035793	2002-09-05	2002-09-05 00:00:00	38000275	0	\N	\N	88187	0	15081005	4035793	
3341	332	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	21883	0	180256009	4107731	
3525	343	4163872	1981-10-01	1981-10-01 00:00:00	38000275	0	\N	\N	22917	0	399208008	4163872	
3650	351	4295880	2002-07-23	2002-07-23 00:00:00	38000275	0	\N	\N	23402	0	76601001	4295880	
3895	394	4336464	1989-03-27	1989-03-27 00:00:00	38000275	0	\N	\N	25914	0	232717009	4336464	
4023	404	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	26668	0	180256009	4107731	
4213	409	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	27105	0	180256009	4107731	
16423	1431	4107731	1993-04-17	1993-04-17 00:00:00	38000275	0	\N	\N	95339	0	180256009	4107731	
4656	442	4107731	1991-05-25	1991-05-25 00:00:00	38000275	0	\N	\N	29262	0	180256009	4107731	
4847	453	4043071	1982-02-02	1982-02-02 00:00:00	38000275	0	\N	\N	30169	0	228557008	4043071	
5012	469	4043071	1949-01-24	1949-01-24 00:00:00	38000275	0	\N	\N	31284	0	228557008	4043071	
5162	480	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	31990	0	180256009	4107731	
5399	499	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	33322	0	180256009	4107731	
5523	505	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	33870	0	180256009	4107731	
17584	1512	4295880	1996-01-31	1996-01-31 00:00:00	38000275	0	\N	\N	100964	0	76601001	4295880	
5915	545	4107731	1991-12-21	1991-12-21 00:00:00	38000275	0	\N	\N	36076	0	180256009	4107731	
6159	563	4125906	1986-02-19	1986-02-19 00:00:00	38000275	0	\N	\N	37272	0	288086009	4125906	
18212	1556	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	104188	0	395142003	4191853	
6467	601	4107731	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	39737	0	180256009	4107731	
6663	610	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	40518	0	180256009	4107731	
6908	624	4163872	1957-01-30	1957-01-30 00:00:00	38000275	0	\N	\N	41689	0	399208008	4163872	
7063	651	4252419	1987-08-11	1987-08-11 00:00:00	38000275	0	\N	\N	43078	0	74016001	4252419	
7261	673	4062501	1964-09-28	1964-09-28 00:00:00	38000275	0	\N	\N	44480	0	171231001	4062501	
7391	685	4043071	1974-07-09	1974-07-09 00:00:00	38000275	0	\N	\N	45310	0	228557008	4043071	
7582	704	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	46579	0	180256009	4107731	
7815	718	4107731	1990-04-21	1990-04-21 00:00:00	38000275	0	\N	\N	47428	0	180256009	4107731	
8041	732	4163872	1984-05-11	1984-05-11 00:00:00	38000275	0	\N	\N	48582	0	399208008	4163872	
8138	742	4035793	2008-07-21	2008-07-21 00:00:00	38000275	0	\N	\N	49195	0	15081005	4035793	
8321	759	4170947	2016-11-17	2016-11-17 00:00:00	38000275	0	\N	\N	50364	0	274474001	4170947	
20503	1769	4295880	1996-02-28	1996-02-28 00:00:00	38000275	0	\N	\N	118307	0	76601001	4295880	
20699	1782	4163971	1956-01-11	1956-01-11 00:00:00	38000275	0	\N	\N	119339	0	45595009	4163971	
20931	1801	4125906	1996-12-19	1996-12-19 00:00:00	38000275	0	\N	\N	120753	0	288086009	4125906	
9134	842	4035793	2017-11-04	2017-11-04 00:00:00	38000275	0	\N	\N	55686	0	15081005	4035793	
9256	844	4107731	1991-12-21	1991-12-21 00:00:00	38000275	0	\N	\N	55892	0	180256009	4107731	
9511	863	4078793	2014-08-07	2014-08-07 00:00:00	38000275	0	\N	\N	57191	0	180325003	4078793	
21690	1882	4107731	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	125542	0	180256009	4107731	
9831	884	4058899	2007-02-25	2007-02-25 00:00:00	38000275	0	\N	\N	58953	0	168594001	4058899	
21955	1911	4323902	2002-12-02	2002-12-02 00:00:00	38000275	0	\N	\N	127181	0	429609002	4323902	
22089	1923	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	127936	0	395142003	4191853	
10381	924	4151422	1968-02-04	1968-02-04 00:00:00	38000275	0	\N	\N	61527	0	269911007	4151422	
10625	959	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	63789	0	180256009	4107731	
22668	1977	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	131487	0	395142003	4191853	
22858	1992	4107731	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	132658	0	180256009	4107731	
23091	2005	4163872	2013-05-02	2013-05-02 00:00:00	38000275	0	\N	\N	133511	0	399208008	4163872	
11383	1058	4151422	2003-11-16	2003-11-16 00:00:00	38000275	0	\N	\N	69343	0	269911007	4151422	
23472	2054	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	136596	0	180256009	4107731	
11696	1082	4107731	1990-10-06	1990-10-06 00:00:00	38000275	0	\N	\N	71042	0	180256009	4107731	
11944	1092	4163872	1981-01-10	1981-01-10 00:00:00	38000275	0	\N	\N	71751	0	399208008	4163872	
95	5	4252419	1990-03-31	1990-03-31 00:00:00	38000275	0	\N	\N	492	0	74016001	4252419	
287	16	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	1235	0	180256009	4107731	
561	38	4151422	1999-12-24	1999-12-24 00:00:00	38000275	0	\N	\N	2735	0	269911007	4151422	
12579	1138	4107731	1995-04-13	1995-04-13 00:00:00	38000275	0	\N	\N	74988	0	180256009	4107731	
12834	1149	4252419	1986-11-19	1986-11-19 00:00:00	38000275	0	\N	\N	75945	0	74016001	4252419	
1109	110	4275113	1992-02-03	1992-02-03 00:00:00	38000275	0	\N	\N	7326	0	65200003	4275113	
1225	124	4107731	1999-02-22	1999-02-22 00:00:00	38000275	0	\N	\N	8328	0	180256009	4107731	
1493	141	4295880	2000-11-14	2000-11-14 00:00:00	38000275	0	\N	\N	9429	0	76601001	4295880	
13542	1226	4043071	1991-02-20	1991-02-20 00:00:00	38000275	0	\N	\N	80697	0	228557008	4043071	
1780	161	4170947	1990-07-20	1990-07-20 00:00:00	38000275	0	\N	\N	11056	0	274474001	4170947	
1975	183	4043071	1982-11-26	1982-11-26 00:00:00	38000275	0	\N	\N	12372	0	228557008	4043071	
2188	225	4107731	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	15181	0	180256009	4107731	
2396	239	4058899	2012-03-01	2012-03-01 00:00:00	38000275	0	\N	\N	16053	0	168594001	4058899	
2554	260	4107731	1990-06-23	1990-06-23 00:00:00	38000275	0	\N	\N	17225	0	180256009	4107731	
14704	1310	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	86659	0	180256009	4107731	
2926	285	4107731	1992-08-03	1992-08-03 00:00:00	38000275	0	\N	\N	18951	0	180256009	4107731	
14984	1328	4047491	1948-04-11	1948-04-11 00:00:00	38000275	0	\N	\N	88207	0	1225002	4047491	
3342	332	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	21917	0	180256009	4107731	
3526	343	4107731	1991-06-15	1991-06-15 00:00:00	38000275	0	\N	\N	22906	0	180256009	4107731	
3651	351	4295880	2004-01-20	2004-01-20 00:00:00	38000275	0	\N	\N	23370	0	76601001	4295880	
3896	395	4125906	1964-12-21	1964-12-21 00:00:00	38000275	0	\N	\N	25937	0	288086009	4125906	
4024	404	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	26672	0	180256009	4107731	
4214	409	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	27029	0	180256009	4107731	
16424	1431	4107731	1993-05-08	1993-05-08 00:00:00	38000275	0	\N	\N	95351	0	180256009	4107731	
4657	442	4107731	1990-10-27	1990-10-27 00:00:00	38000275	0	\N	\N	29403	0	180256009	4107731	
4848	453	4043071	1982-09-14	1982-09-14 00:00:00	38000275	0	\N	\N	30234	0	228557008	4043071	
5013	469	4043071	1947-07-28	1947-07-28 00:00:00	38000275	0	\N	\N	31346	0	228557008	4043071	
5163	480	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	32045	0	180256009	4107731	
5400	499	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	33377	0	180256009	4107731	
5524	505	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	33821	0	180256009	4107731	
17585	1512	4295880	1997-01-29	1997-01-29 00:00:00	38000275	0	\N	\N	100977	0	76601001	4295880	
5916	545	4107731	1993-05-29	1993-05-29 00:00:00	38000275	0	\N	\N	36062	0	180256009	4107731	
6160	563	4107731	1990-02-18	1990-02-18 00:00:00	38000275	0	\N	\N	37299	0	180256009	4107731	
18213	1556	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	104184	0	180256009	4107731	
6533	603	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	39913	0	180256009	4107731	
6664	610	4125906	1965-06-29	1965-06-29 00:00:00	38000275	0	\N	\N	40476	0	288086009	4125906	
6909	624	4170947	1957-01-30	1957-01-30 00:00:00	38000275	0	\N	\N	41689	0	274474001	4170947	
7064	651	4125906	2007-08-26	2007-08-26 00:00:00	38000275	0	\N	\N	43080	0	288086009	4125906	
7262	673	4252419	2014-08-05	2014-08-05 00:00:00	38000275	0	\N	\N	44441	0	74016001	4252419	
7392	685	4043071	1976-12-28	1976-12-28 00:00:00	38000275	0	\N	\N	45356	0	228557008	4043071	
7583	704	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	46569	0	180256009	4107731	
7816	718	4107731	1990-03-31	1990-03-31 00:00:00	38000275	0	\N	\N	47462	0	180256009	4107731	
19823	1716	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	114629	0	180256009	4107731	
8139	742	4078793	2008-07-21	2008-07-21 00:00:00	38000275	0	\N	\N	49195	0	180325003	4078793	
8322	759	4024289	2016-11-17	2016-11-17 00:00:00	38000275	0	\N	\N	50364	0	19490002	4024289	
20504	1769	4295880	1994-08-31	1994-08-31 00:00:00	38000275	0	\N	\N	118274	0	76601001	4295880	
20700	1782	4202832	1956-01-11	1956-01-11 00:00:00	38000275	0	\N	\N	119339	0	52765003	4202832	
20932	1801	4057420	2009-08-19	2009-08-19 00:00:00	38000275	0	\N	\N	120780	0	18286008	4057420	
9135	842	4058899	1940-08-16	1940-08-16 00:00:00	38000275	0	\N	\N	55708	0	168594001	4058899	
9257	844	4191853	1993-07-10	1993-07-10 00:00:00	38000275	0	\N	\N	55919	0	395142003	4191853	
9512	863	4078793	2019-02-21	2019-02-21 00:00:00	38000275	0	\N	\N	57231	0	180325003	4078793	
21691	1882	4107731	1992-02-01	1992-02-01 00:00:00	38000275	0	\N	\N	125564	0	180256009	4107731	
9832	884	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	58942	0	180256009	4107731	
21956	1911	4125906	1979-08-30	1979-08-30 00:00:00	38000275	0	\N	\N	127176	0	288086009	4125906	
22090	1923	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	127989	0	180256009	4107731	
10382	924	4125906	1987-06-15	1987-06-15 00:00:00	38000275	0	\N	\N	61540	0	288086009	4125906	
10626	959	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	63691	0	180256009	4107731	
22669	1977	4078793	2012-05-31	2012-05-31 00:00:00	38000275	0	\N	\N	131568	0	180325003	4078793	
22859	1992	4107731	1991-06-16	1991-06-16 00:00:00	38000275	0	\N	\N	132677	0	180256009	4107731	
23092	2005	4163872	1988-07-24	1988-07-24 00:00:00	38000275	0	\N	\N	133521	0	399208008	4163872	
11384	1058	4107731	1991-04-13	1991-04-13 00:00:00	38000275	0	\N	\N	69435	0	180256009	4107731	
23473	2054	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	136642	0	180256009	4107731	
11697	1082	4107731	1993-04-17	1993-04-17 00:00:00	38000275	0	\N	\N	70964	0	180256009	4107731	
11945	1092	44783196	1997-03-20	1997-03-20 00:00:00	38000275	0	\N	\N	71835	0	699253003	44783196	
96	5	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	486	0	395142003	4191853	
288	16	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	1223	0	180256009	4107731	
12343	1110	4107731	1997-07-28	1997-07-28 00:00:00	38000275	0	\N	\N	73045	0	180256009	4107731	
12580	1138	4191853	1993-02-04	1993-02-04 00:00:00	38000275	0	\N	\N	75062	0	395142003	4191853	
12835	1149	4151422	1987-08-18	1987-08-18 00:00:00	38000275	0	\N	\N	75959	0	269911007	4151422	
1110	111	4059978	2004-02-14	2004-02-14 00:00:00	38000275	0	\N	\N	7385	0	169553002	4059978	
1226	124	4107731	1999-12-13	1999-12-13 00:00:00	38000275	0	\N	\N	8256	0	180256009	4107731	
1494	141	4295880	2000-02-14	2000-02-14 00:00:00	38000275	0	\N	\N	9445	0	76601001	4295880	
13543	1226	4043071	1991-06-26	1991-06-26 00:00:00	38000275	0	\N	\N	80665	0	228557008	4043071	
1781	161	4252419	2016-07-13	2016-07-13 00:00:00	38000275	0	\N	\N	11060	0	74016001	4252419	
1976	183	4043071	1984-01-20	1984-01-20 00:00:00	38000275	0	\N	\N	12375	0	228557008	4043071	
2189	225	4107731	1990-03-05	1990-03-05 00:00:00	38000275	0	\N	\N	15166	0	180256009	4107731	
2397	239	4195803	2012-03-01	2012-03-01 00:00:00	38000275	0	\N	\N	16053	0	312681000	4195803	
2555	260	4107731	1991-01-19	1991-01-19 00:00:00	38000275	0	\N	\N	17170	0	180256009	4107731	
14705	1310	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	86644	0	180256009	4107731	
2927	285	4107731	1992-02-17	1992-02-17 00:00:00	38000275	0	\N	\N	18993	0	180256009	4107731	
14985	1328	4170947	1948-04-11	1948-04-11 00:00:00	38000275	0	\N	\N	88207	0	274474001	4170947	
3343	332	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	21882	0	180256009	4107731	
3527	343	4107731	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	22909	0	180256009	4107731	
3652	352	4151422	1996-10-03	1996-10-03 00:00:00	38000275	0	\N	\N	23479	0	269911007	4151422	
3897	395	4181917	1972-02-13	1972-02-13 00:00:00	38000275	0	\N	\N	25938	0	54550000	4181917	
4025	404	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	26606	0	180256009	4107731	
4215	409	4197460	1951-12-30	1951-12-30 00:00:00	38000275	0	\N	\N	27031	0	313191000	4197460	
16425	1431	4107731	1990-03-10	1990-03-10 00:00:00	38000275	0	\N	\N	95300	0	180256009	4107731	
4658	442	4107731	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	29353	0	180256009	4107731	
4849	453	4043071	1984-04-24	1984-04-24 00:00:00	38000275	0	\N	\N	30238	0	228557008	4043071	
5014	469	4043071	1950-10-09	1950-10-09 00:00:00	38000275	0	\N	\N	31291	0	228557008	4043071	
5164	480	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	32088	0	180256009	4107731	
5401	499	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	33442	0	180256009	4107731	
5525	505	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	33752	0	180256009	4107731	
17586	1512	4295880	1995-11-01	1995-11-01 00:00:00	38000275	0	\N	\N	100995	0	76601001	4295880	
5917	545	4107731	1992-11-21	1992-11-21 00:00:00	38000275	0	\N	\N	36020	0	180256009	4107731	
6161	563	4125906	1978-01-11	1978-01-11 00:00:00	38000275	0	\N	\N	37271	0	288086009	4125906	
18214	1556	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	104196	0	180256009	4107731	
6534	603	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	39940	0	180256009	4107731	
6665	610	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	40604	0	180256009	4107731	
6910	624	4195803	2019-05-27	2019-05-27 00:00:00	38000275	0	\N	\N	41697	0	312681000	4195803	
7065	652	4125906	1997-04-07	1997-04-07 00:00:00	38000275	0	\N	\N	43186	0	288086009	4125906	
7263	673	44783196	2005-11-29	2005-11-29 00:00:00	38000275	0	\N	\N	44416	0	699253003	44783196	
7393	685	4043071	1974-06-04	1974-06-04 00:00:00	38000275	0	\N	\N	45289	0	228557008	4043071	
7584	704	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	46576	0	180256009	4107731	
7817	718	4107731	1992-10-10	1992-10-10 00:00:00	38000275	0	\N	\N	47484	0	180256009	4107731	
19824	1716	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	114736	0	180256009	4107731	
8140	742	4078793	2014-10-13	2014-10-13 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
8323	759	4078793	2005-03-02	2005-03-02 00:00:00	38000275	0	\N	\N	50368	0	180325003	4078793	
20505	1770	4151422	2006-04-30	2006-04-30 00:00:00	38000275	0	\N	\N	118342	0	269911007	4151422	
20701	1782	42535580	1956-01-11	1956-01-11 00:00:00	38000275	0	\N	\N	119339	0	426701000119108	42535580	
20933	1801	4078793	2017-10-04	2017-10-04 00:00:00	38000275	0	\N	\N	120737	0	180325003	4078793	
9136	842	4035793	2008-09-13	2008-09-13 00:00:00	38000275	0	\N	\N	55699	0	15081005	4035793	
9258	844	4107731	1991-05-25	1991-05-25 00:00:00	38000275	0	\N	\N	55996	0	180256009	4107731	
9513	864	4047491	2001-07-11	2001-07-11 00:00:00	38000275	0	\N	\N	57326	0	1225002	4047491	
21692	1882	4107731	1991-11-30	1991-11-30 00:00:00	38000275	0	\N	\N	125600	0	180256009	4107731	
9833	884	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	58897	0	180256009	4107731	
21957	1911	4035793	2006-10-23	2006-10-23 00:00:00	38000275	0	\N	\N	127172	0	15081005	4035793	
22091	1923	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	127988	0	180256009	4107731	
10383	924	4293740	1987-06-15	1987-06-15 00:00:00	38000275	0	\N	\N	61540	0	384700001	4293740	
10627	959	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	63762	0	180256009	4107731	
22670	1977	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	131615	0	180256009	4107731	
22860	1992	4107731	1990-04-01	1990-04-01 00:00:00	38000275	0	\N	\N	132709	0	180256009	4107731	
23093	2005	4125906	2018-03-18	2018-03-18 00:00:00	38000275	0	\N	\N	133497	0	288086009	4125906	
11385	1058	4107731	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	69450	0	180256009	4107731	
23474	2054	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	136574	0	180256009	4107731	
11698	1082	4107731	1990-06-23	1990-06-23 00:00:00	38000275	0	\N	\N	70932	0	180256009	4107731	
11946	1092	4163872	1960-03-11	1960-03-11 00:00:00	38000275	0	\N	\N	71783	0	399208008	4163872	
97	5	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	419	0	180256009	4107731	
289	16	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	1168	0	180256009	4107731	
12344	1110	4107731	1997-05-26	1997-05-26 00:00:00	38000275	0	\N	\N	73064	0	180256009	4107731	
12581	1138	4043071	1996-05-09	1996-05-09 00:00:00	38000275	0	\N	\N	74992	0	228557008	4043071	
12836	1150	4058899	1953-12-22	1953-12-22 00:00:00	38000275	0	\N	\N	76061	0	168594001	4058899	
1111	111	4238715	2005-11-11	2005-11-11 00:00:00	38000275	0	\N	\N	7386	0	68254000	4238715	
1233	126	4125906	2010-05-26	2010-05-26 00:00:00	38000275	0	\N	\N	8449	0	288086009	4125906	
1495	141	4295880	2002-02-12	2002-02-12 00:00:00	38000275	0	\N	\N	9463	0	76601001	4295880	
13544	1226	4043071	1990-08-15	1990-08-15 00:00:00	38000275	0	\N	\N	80693	0	228557008	4043071	
1782	162	4195803	2009-10-20	2009-10-20 00:00:00	38000275	0	\N	\N	11146	0	312681000	4195803	
1977	183	4043071	1983-09-23	1983-09-23 00:00:00	38000275	0	\N	\N	12374	0	228557008	4043071	
2190	225	4107731	1991-04-08	1991-04-08 00:00:00	38000275	0	\N	\N	15214	0	180256009	4107731	
2398	239	4058899	1956-12-31	1956-12-31 00:00:00	38000275	0	\N	\N	16049	0	168594001	4058899	
2556	260	4107731	1992-06-27	1992-06-27 00:00:00	38000275	0	\N	\N	17284	0	180256009	4107731	
14706	1310	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	86552	0	180256009	4107731	
2928	285	4107731	1992-08-24	1992-08-24 00:00:00	38000275	0	\N	\N	18979	0	180256009	4107731	
14986	1328	4035793	2008-02-28	2008-02-28 00:00:00	38000275	0	\N	\N	88212	0	15081005	4035793	
3344	332	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	21975	0	180256009	4107731	
3528	343	4107731	1993-01-02	1993-01-02 00:00:00	38000275	0	\N	\N	22869	0	180256009	4107731	
3653	352	4151422	1991-09-11	1991-09-11 00:00:00	38000275	0	\N	\N	23437	0	269911007	4151422	
3901	398	4125906	1955-07-09	1955-07-09 00:00:00	38000275	0	\N	\N	26106	0	288086009	4125906	
4026	404	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	26622	0	180256009	4107731	
4216	409	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	27143	0	180256009	4107731	
16426	1431	4107731	1991-09-28	1991-09-28 00:00:00	38000275	0	\N	\N	95344	0	180256009	4107731	
4659	442	4107731	1993-02-13	1993-02-13 00:00:00	38000275	0	\N	\N	29342	0	180256009	4107731	
4850	453	4043071	1983-11-01	1983-11-01 00:00:00	38000275	0	\N	\N	30162	0	228557008	4043071	
5015	469	4043071	1948-01-12	1948-01-12 00:00:00	38000275	0	\N	\N	31358	0	228557008	4043071	
5165	480	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	32026	0	180256009	4107731	
5402	499	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	33393	0	180256009	4107731	
5526	505	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	33869	0	180256009	4107731	
17587	1512	4295880	1996-10-30	1996-10-30 00:00:00	38000275	0	\N	\N	101010	0	76601001	4295880	
5918	545	4107731	1991-07-06	1991-07-06 00:00:00	38000275	0	\N	\N	36101	0	180256009	4107731	
6162	563	4107731	1990-09-16	1990-09-16 00:00:00	38000275	0	\N	\N	37279	0	180256009	4107731	
18215	1556	4125906	1990-02-19	1990-02-19 00:00:00	38000275	0	\N	\N	104149	0	288086009	4125906	
6535	603	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	39963	0	180256009	4107731	
6666	610	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	40553	0	180256009	4107731	
6911	624	4170947	2019-05-27	2019-05-27 00:00:00	38000275	0	\N	\N	41697	0	274474001	4170947	
7066	652	4293740	2003-01-27	2003-01-27 00:00:00	38000275	0	\N	\N	43128	0	384700001	4293740	
7264	673	4252419	2005-11-22	2005-11-22 00:00:00	38000275	0	\N	\N	44439	0	74016001	4252419	
7394	685	4043071	1977-11-15	1977-11-15 00:00:00	38000275	0	\N	\N	45298	0	228557008	4043071	
7585	704	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	46611	0	180256009	4107731	
7818	718	4107731	1992-02-01	1992-02-01 00:00:00	38000275	0	\N	\N	47507	0	180256009	4107731	
19825	1716	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	114685	0	180256009	4107731	
8141	742	4035793	1989-04-03	1989-04-03 00:00:00	38000275	0	\N	\N	49208	0	15081005	4035793	
8324	759	4078793	2018-09-19	2018-09-19 00:00:00	38000275	0	\N	\N	50365	0	180325003	4078793	
20506	1770	4151422	1995-01-04	1995-01-04 00:00:00	38000275	0	\N	\N	118401	0	269911007	4151422	
20702	1782	4163951	1956-01-11	1956-01-11 00:00:00	38000275	0	\N	\N	119339	0	29303009	4163951	
20934	1801	4078793	2018-10-10	2018-10-10 00:00:00	38000275	0	\N	\N	120797	0	180325003	4078793	
9137	842	4035793	1980-03-08	1980-03-08 00:00:00	38000275	0	\N	\N	55736	0	15081005	4035793	
9259	844	4107731	1990-09-15	1990-09-15 00:00:00	38000275	0	\N	\N	56014	0	180256009	4107731	
9514	864	4170947	2001-07-11	2001-07-11 00:00:00	38000275	0	\N	\N	57326	0	274474001	4170947	
33532	2925	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	195098	0	180256009	4107731	
9834	884	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	58844	0	180256009	4107731	
21958	1911	4035793	2009-11-09	2009-11-09 00:00:00	38000275	0	\N	\N	127123	0	15081005	4035793	
22092	1923	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	127942	0	180256009	4107731	
10384	925	4170947	1999-04-21	1999-04-21 00:00:00	38000275	0	\N	\N	61600	0	274474001	4170947	
10628	959	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	63748	0	180256009	4107731	
22671	1977	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	131629	0	180256009	4107731	
22861	1992	4107731	1992-05-17	1992-05-17 00:00:00	38000275	0	\N	\N	132669	0	180256009	4107731	
23094	2005	4047491	2013-08-11	2013-08-11 00:00:00	38000275	0	\N	\N	133496	0	1225002	4047491	
11386	1058	4107731	1992-01-11	1992-01-11 00:00:00	38000275	0	\N	\N	69438	0	180256009	4107731	
23475	2054	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	136610	0	180256009	4107731	
11699	1082	4107731	1990-09-15	1990-09-15 00:00:00	38000275	0	\N	\N	70934	0	180256009	4107731	
11947	1092	4151422	1958-04-29	1958-04-29 00:00:00	38000275	0	\N	\N	71754	0	269911007	4151422	
98	5	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	450	0	180256009	4107731	
290	17	4145310	1958-11-29	1958-11-29 00:00:00	38000275	0	\N	\N	1377	0	268425006	4145310	
12345	1110	4107731	1998-08-31	1998-08-31 00:00:00	38000275	0	\N	\N	73042	0	180256009	4107731	
12582	1138	4107731	1995-11-09	1995-11-09 00:00:00	38000275	0	\N	\N	75103	0	180256009	4107731	
12837	1151	4238715	2000-12-19	2000-12-19 00:00:00	38000275	0	\N	\N	76130	0	68254000	4238715	
1112	111	4125906	2018-08-28	2018-08-28 00:00:00	38000275	0	\N	\N	7418	0	288086009	4125906	
1305	129	4125906	1983-04-23	1983-04-23 00:00:00	38000275	0	\N	\N	8704	0	288086009	4125906	
1496	141	4295880	2001-08-14	2001-08-14 00:00:00	38000275	0	\N	\N	9430	0	76601001	4295880	
13545	1226	4043071	1990-06-13	1990-06-13 00:00:00	38000275	0	\N	\N	80709	0	228557008	4043071	
1783	162	4151422	1979-07-29	1979-07-29 00:00:00	38000275	0	\N	\N	11162	0	269911007	4151422	
1978	183	4125906	1975-10-19	1975-10-19 00:00:00	38000275	0	\N	\N	12346	0	288086009	4125906	
2191	225	4107731	1991-03-18	1991-03-18 00:00:00	38000275	0	\N	\N	15238	0	180256009	4107731	
2399	239	4216130	2012-07-05	2012-07-05 00:00:00	38000275	0	\N	\N	16054	0	415070008	4216130	
2565	262	4024289	1967-03-21	1967-03-21 00:00:00	38000275	0	\N	\N	17354	0	19490002	4024289	
14707	1310	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	86586	0	180256009	4107731	
2929	285	4107731	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	18975	0	180256009	4107731	
14987	1328	4035793	2003-09-11	2003-09-11 00:00:00	38000275	0	\N	\N	88170	0	15081005	4035793	
3345	332	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	21983	0	180256009	4107731	
3529	343	4107731	1991-07-27	1991-07-27 00:00:00	38000275	0	\N	\N	22907	0	180256009	4107731	
3654	352	4125906	2002-01-27	2002-01-27 00:00:00	38000275	0	\N	\N	23435	0	288086009	4125906	
3902	398	4336464	1967-02-11	1967-02-11 00:00:00	38000275	0	\N	\N	26071	0	232717009	4336464	
4027	404	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	26604	0	180256009	4107731	
4217	409	4024289	1980-10-28	1980-10-28 00:00:00	38000275	0	\N	\N	27151	0	19490002	4024289	
16427	1431	4107731	1990-10-06	1990-10-06 00:00:00	38000275	0	\N	\N	95215	0	180256009	4107731	
4660	442	4107731	1990-10-06	1990-10-06 00:00:00	38000275	0	\N	\N	29260	0	180256009	4107731	
4851	453	4043071	1983-09-06	1983-09-06 00:00:00	38000275	0	\N	\N	30236	0	228557008	4043071	
5016	469	4043071	1949-03-28	1949-03-28 00:00:00	38000275	0	\N	\N	31318	0	228557008	4043071	
5166	480	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	31978	0	180256009	4107731	
5403	499	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	33301	0	180256009	4107731	
5527	505	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	33859	0	180256009	4107731	
17588	1513	4107731	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	101139	0	180256009	4107731	
5919	545	4107731	1991-07-27	1991-07-27 00:00:00	38000275	0	\N	\N	36058	0	180256009	4107731	
6163	563	4107731	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	37296	0	180256009	4107731	
18216	1556	4199276	1992-04-16	1992-04-16 00:00:00	38000275	0	\N	\N	104253	0	301807007	4199276	
6536	603	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	40019	0	180256009	4107731	
6667	610	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	40591	0	395142003	4191853	
6912	624	4243062	2019-05-27	2019-05-27 00:00:00	38000275	0	\N	\N	41697	0	60027007	4243062	
7067	652	4125906	2003-01-27	2003-01-27 00:00:00	38000275	0	\N	\N	43128	0	288086009	4125906	
7266	675	4326177	1981-02-08	1981-02-08 00:00:00	38000275	0	\N	\N	44708	0	430193006	4326177	
7395	685	4043071	1974-03-12	1974-03-12 00:00:00	38000275	0	\N	\N	45309	0	228557008	4043071	
7586	704	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	46559	0	180256009	4107731	
7819	718	4107731	1992-06-27	1992-06-27 00:00:00	38000275	0	\N	\N	47471	0	180256009	4107731	
19826	1716	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	114742	0	180256009	4107731	
8142	742	4035793	1986-10-27	1986-10-27 00:00:00	38000275	0	\N	\N	49115	0	15081005	4035793	
8325	759	4057420	2013-04-17	2013-04-17 00:00:00	38000275	0	\N	\N	50426	0	18286008	4057420	
20509	1773	4107731	1991-03-03	1991-03-03 00:00:00	38000275	0	\N	\N	118542	0	180256009	4107731	
20703	1783	4107731	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	119477	0	180256009	4107731	
20935	1801	4181917	1966-07-18	1966-07-18 00:00:00	38000275	0	\N	\N	120750	0	54550000	4181917	
9138	842	4035793	2005-08-27	2005-08-27 00:00:00	38000275	0	\N	\N	55702	0	15081005	4035793	
9260	844	4107731	1992-11-21	1992-11-21 00:00:00	38000275	0	\N	\N	55963	0	180256009	4107731	
9515	864	4195803	2001-07-11	2001-07-11 00:00:00	38000275	0	\N	\N	57326	0	312681000	4195803	
33533	2925	4107731	1991-11-03	1991-11-03 00:00:00	38000275	0	\N	\N	195106	0	180256009	4107731	
9835	884	44783196	1981-08-23	1981-08-23 00:00:00	38000275	0	\N	\N	58948	0	699253003	44783196	
21959	1911	4035793	2004-10-11	2004-10-11 00:00:00	38000275	0	\N	\N	127196	0	15081005	4035793	
22093	1923	4125906	1938-10-16	1938-10-16 00:00:00	38000275	0	\N	\N	127997	0	288086009	4125906	
10385	925	4163872	1999-04-21	1999-04-21 00:00:00	38000275	0	\N	\N	61600	0	399208008	4163872	
10629	959	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	63765	0	180256009	4107731	
22672	1977	4078793	2015-06-18	2015-06-18 00:00:00	38000275	0	\N	\N	131501	0	180325003	4078793	
22862	1992	4107731	1990-02-18	1990-02-18 00:00:00	38000275	0	\N	\N	132714	0	180256009	4107731	
23095	2005	4170947	2013-08-11	2013-08-11 00:00:00	38000275	0	\N	\N	133496	0	274474001	4170947	
11387	1058	4191853	1993-07-10	1993-07-10 00:00:00	38000275	0	\N	\N	69393	0	395142003	4191853	
23476	2054	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	136661	0	180256009	4107731	
11700	1082	4107731	1992-06-06	1992-06-06 00:00:00	38000275	0	\N	\N	70993	0	180256009	4107731	
11960	1097	4202451	2016-09-15	2016-09-15 00:00:00	38000275	0	\N	\N	71970	0	433112001	4202451	
99	5	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	501	0	180256009	4107731	
291	17	4125906	1989-09-27	1989-09-27 00:00:00	38000275	0	\N	\N	1374	0	288086009	4125906	
12346	1110	4151422	2010-09-10	2010-09-10 00:00:00	38000275	0	\N	\N	73120	0	269911007	4151422	
12583	1138	4043071	1996-03-07	1996-03-07 00:00:00	38000275	0	\N	\N	75086	0	228557008	4043071	
12838	1151	4275113	1999-11-15	1999-11-15 00:00:00	38000275	0	\N	\N	76102	0	65200003	4275113	
1113	111	4186930	2002-04-19	2002-04-19 00:00:00	38000275	0	\N	\N	7356	0	46706006	4186930	
1306	129	4163872	1994-08-25	1994-08-25 00:00:00	38000275	0	\N	\N	8707	0	399208008	4163872	
13278	1211	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	79619	0	180256009	4107731	
13546	1226	4043071	1990-12-12	1990-12-12 00:00:00	38000275	0	\N	\N	80663	0	228557008	4043071	
1784	162	4293740	2005-10-31	2005-10-31 00:00:00	38000275	0	\N	\N	11092	0	384700001	4293740	
1979	183	4043071	1983-02-18	1983-02-18 00:00:00	38000275	0	\N	\N	12403	0	228557008	4043071	
2192	225	4107731	1992-02-17	1992-02-17 00:00:00	38000275	0	\N	\N	15218	0	180256009	4107731	
2400	239	4336464	2012-07-05	2012-07-05 00:00:00	38000275	0	\N	\N	16054	0	232717009	4336464	
2566	262	4330583	2004-07-31	2004-07-31 00:00:00	38000275	0	\N	\N	17365	0	22523008	4330583	
14708	1310	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	86629	0	180256009	4107731	
2930	285	4107731	1991-03-18	1991-03-18 00:00:00	38000275	0	\N	\N	18946	0	180256009	4107731	
14988	1328	4035793	2018-04-26	2018-04-26 00:00:00	38000275	0	\N	\N	88216	0	15081005	4035793	
3346	332	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	21988	0	180256009	4107731	
3530	343	4107731	1993-05-08	1993-05-08 00:00:00	38000275	0	\N	\N	22861	0	180256009	4107731	
3655	354	4337138	2011-04-21	2011-04-21 00:00:00	38000275	0	\N	\N	23549	0	88039007	4337138	
3903	398	4216130	1967-02-11	1967-02-11 00:00:00	38000275	0	\N	\N	26071	0	415070008	4216130	
4028	404	4043071	1970-09-11	1970-09-11 00:00:00	38000275	0	\N	\N	26656	0	228557008	4043071	
4218	409	4170947	1980-10-28	1980-10-28 00:00:00	38000275	0	\N	\N	27151	0	274474001	4170947	
16428	1431	4107731	1991-07-06	1991-07-06 00:00:00	38000275	0	\N	\N	95218	0	180256009	4107731	
4661	442	4107731	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	29332	0	180256009	4107731	
4852	453	4043071	1982-06-08	1982-06-08 00:00:00	38000275	0	\N	\N	30157	0	228557008	4043071	
5017	469	4043071	1947-10-06	1947-10-06 00:00:00	38000275	0	\N	\N	31277	0	228557008	4043071	
5167	480	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	31989	0	180256009	4107731	
5404	499	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	33335	0	180256009	4107731	
5528	505	4037675	1995-05-29	1995-05-29 00:00:00	38000275	0	\N	\N	33760	0	162676008	4037675	
17589	1513	4107731	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	101014	0	180256009	4107731	
5920	545	4107731	1993-01-02	1993-01-02 00:00:00	38000275	0	\N	\N	36021	0	180256009	4107731	
6164	563	4107731	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	37226	0	180256009	4107731	
18217	1556	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	104202	0	180256009	4107731	
6537	603	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	40020	0	180256009	4107731	
6668	610	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	40490	0	180256009	4107731	
6913	624	4058899	2011-07-17	2011-07-17 00:00:00	38000275	0	\N	\N	41695	0	168594001	4058899	
7068	652	4275113	1990-01-07	1990-01-07 00:00:00	38000275	0	\N	\N	43145	0	65200003	4275113	
7267	675	4187458	1981-02-08	1981-02-08 00:00:00	38000275	0	\N	\N	44708	0	415300000	4187458	
7396	685	4043071	1975-08-19	1975-08-19 00:00:00	38000275	0	\N	\N	45254	0	228557008	4043071	
7587	704	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	46612	0	180256009	4107731	
7820	718	4107731	1992-04-04	1992-04-04 00:00:00	38000275	0	\N	\N	47454	0	180256009	4107731	
19827	1716	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	114688	0	180256009	4107731	
8143	742	4035793	1996-05-13	1996-05-13 00:00:00	38000275	0	\N	\N	49180	0	15081005	4035793	
8326	759	4078793	2005-08-03	2005-08-03 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
20510	1773	4107731	1990-09-16	1990-09-16 00:00:00	38000275	0	\N	\N	118576	0	180256009	4107731	
20704	1783	4107731	1992-08-03	1992-08-03 00:00:00	38000275	0	\N	\N	119385	0	180256009	4107731	
20938	1804	4125906	1955-10-29	1955-10-29 00:00:00	38000275	0	\N	\N	120875	0	288086009	4125906	
9139	842	4035793	2018-11-10	2018-11-10 00:00:00	38000275	0	\N	\N	55705	0	15081005	4035793	
9261	844	4170947	1982-01-29	1982-01-29 00:00:00	38000275	0	\N	\N	56003	0	274474001	4170947	
9516	864	4125906	1939-10-06	1939-10-06 00:00:00	38000275	0	\N	\N	57279	0	288086009	4125906	
33534	2925	4107731	1991-12-15	1991-12-15 00:00:00	38000275	0	\N	\N	195072	0	180256009	4107731	
9836	884	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	58885	0	180256009	4107731	
21960	1911	4035793	2003-10-06	2003-10-06 00:00:00	38000275	0	\N	\N	127113	0	15081005	4035793	
22094	1923	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	128006	0	180256009	4107731	
10386	925	4058899	2018-02-01	2018-02-01 00:00:00	38000275	0	\N	\N	61642	0	168594001	4058899	
10630	959	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	63742	0	180256009	4107731	
22673	1977	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	131486	0	180256009	4107731	
22863	1992	4107731	1990-09-16	1990-09-16 00:00:00	38000275	0	\N	\N	132703	0	180256009	4107731	
23096	2006	4151422	1967-03-29	1967-03-29 00:00:00	38000275	0	\N	\N	133568	0	269911007	4151422	
11388	1058	4191853	1990-01-06	1990-01-06 00:00:00	38000275	0	\N	\N	69483	0	395142003	4191853	
23477	2054	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	136605	0	180256009	4107731	
11701	1082	4047491	1962-11-11	1962-11-11 00:00:00	38000275	0	\N	\N	71052	0	1225002	4047491	
11961	1098	4125906	1982-02-26	1982-02-26 00:00:00	38000275	0	\N	\N	72030	0	288086009	4125906	
100	5	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	412	0	180256009	4107731	
292	17	4181917	1962-12-08	1962-12-08 00:00:00	38000275	0	\N	\N	1378	0	54550000	4181917	
12347	1110	4107731	1997-12-01	1997-12-01 00:00:00	38000275	0	\N	\N	73038	0	180256009	4107731	
12584	1138	4107731	1995-02-09	1995-02-09 00:00:00	38000275	0	\N	\N	75098	0	180256009	4107731	
12839	1151	4151422	2014-01-26	2014-01-26 00:00:00	38000275	0	\N	\N	76129	0	269911007	4151422	
1114	111	4186930	1997-04-18	1997-04-18 00:00:00	38000275	0	\N	\N	7372	0	46706006	4186930	
1307	129	4125906	1989-02-11	1989-02-11 00:00:00	38000275	0	\N	\N	8705	0	288086009	4125906	
13279	1211	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	79615	0	180256009	4107731	
13547	1226	4043071	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	80664	0	228557008	4043071	
1785	162	4125906	2005-10-31	2005-10-31 00:00:00	38000275	0	\N	\N	11092	0	288086009	4125906	
1980	183	4043071	1983-03-18	1983-03-18 00:00:00	38000275	0	\N	\N	12391	0	228557008	4043071	
2193	225	4107731	1992-11-16	1992-11-16 00:00:00	38000275	0	\N	\N	15221	0	180256009	4107731	
2401	239	4151422	1964-01-20	1964-01-20 00:00:00	38000275	0	\N	\N	16057	0	269911007	4151422	
2567	262	4293740	2005-05-30	2005-05-30 00:00:00	38000275	0	\N	\N	17412	0	384700001	4293740	
14709	1310	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	86587	0	180256009	4107731	
2931	285	4107731	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	18941	0	180256009	4107731	
14989	1328	4035793	2014-04-03	2014-04-03 00:00:00	38000275	0	\N	\N	88196	0	15081005	4035793	
3347	332	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	21985	0	180256009	4107731	
3531	343	4107731	1992-02-22	1992-02-22 00:00:00	38000275	0	\N	\N	22895	0	180256009	4107731	
3656	354	4035793	2013-02-14	2013-02-14 00:00:00	38000275	0	\N	\N	23592	0	15081005	4035793	
3904	399	4107731	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	26248	0	180256009	4107731	
4029	404	4043071	1970-07-10	1970-07-10 00:00:00	38000275	0	\N	\N	26628	0	228557008	4043071	
4219	409	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	27111	0	180256009	4107731	
16429	1431	4107731	1992-02-01	1992-02-01 00:00:00	38000275	0	\N	\N	95282	0	180256009	4107731	
4662	442	4107731	1990-06-02	1990-06-02 00:00:00	38000275	0	\N	\N	29283	0	180256009	4107731	
4853	453	4043071	1981-12-01	1981-12-01 00:00:00	38000275	0	\N	\N	30203	0	228557008	4043071	
5018	469	4043071	1945-07-30	1945-07-30 00:00:00	38000275	0	\N	\N	31209	0	228557008	4043071	
5168	480	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	31972	0	180256009	4107731	
5405	499	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	33446	0	180256009	4107731	
5529	505	4187458	1995-05-29	1995-05-29 00:00:00	38000275	0	\N	\N	33760	0	415300000	4187458	
17590	1513	4107731	1993-01-24	1993-01-24 00:00:00	38000275	0	\N	\N	101015	0	180256009	4107731	
5921	545	4107731	1990-01-27	1990-01-27 00:00:00	38000275	0	\N	\N	36052	0	180256009	4107731	
6165	563	4107731	1990-10-07	1990-10-07 00:00:00	38000275	0	\N	\N	37201	0	180256009	4107731	
18218	1556	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	104228	0	180256009	4107731	
6538	603	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	39973	0	180256009	4107731	
6669	610	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	40495	0	180256009	4107731	
6914	624	4195803	2011-07-17	2011-07-17 00:00:00	38000275	0	\N	\N	41695	0	312681000	4195803	
7069	652	4125906	2017-10-31	2017-10-31 00:00:00	38000275	0	\N	\N	43130	0	288086009	4125906	
7268	675	4037675	1981-02-08	1981-02-08 00:00:00	38000275	0	\N	\N	44708	0	162676008	4037675	
7397	685	4043071	1977-08-09	1977-08-09 00:00:00	38000275	0	\N	\N	45273	0	228557008	4043071	
7588	704	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	46577	0	180256009	4107731	
7821	718	4107731	1993-01-23	1993-01-23 00:00:00	38000275	0	\N	\N	47514	0	180256009	4107731	
19828	1716	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	114738	0	180256009	4107731	
8144	742	4058899	1991-11-12	1991-11-12 00:00:00	38000275	0	\N	\N	49190	0	168594001	4058899	
8327	759	4125906	2015-11-02	2015-11-02 00:00:00	38000275	0	\N	\N	50363	0	288086009	4125906	
20511	1773	4197460	1965-01-14	1965-01-14 00:00:00	38000275	0	\N	\N	118549	0	313191000	4197460	
20705	1783	4107731	1992-03-09	1992-03-09 00:00:00	38000275	0	\N	\N	119555	0	180256009	4107731	
20939	1804	4202451	1999-06-14	1999-06-14 00:00:00	38000275	0	\N	\N	120884	0	433112001	4202451	
9140	842	4035793	2016-10-29	2016-10-29 00:00:00	38000275	0	\N	\N	55704	0	15081005	4035793	
9262	844	4243062	1982-01-29	1982-01-29 00:00:00	38000275	0	\N	\N	56003	0	60027007	4243062	
9517	864	4293740	1939-10-06	1939-10-06 00:00:00	38000275	0	\N	\N	57279	0	384700001	4293740	
33535	2925	4107731	1993-03-21	1993-03-21 00:00:00	38000275	0	\N	\N	195111	0	180256009	4107731	
9837	884	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	58845	0	180256009	4107731	
21961	1911	4035793	2008-11-03	2008-11-03 00:00:00	38000275	0	\N	\N	127174	0	15081005	4035793	
22095	1923	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	127933	0	180256009	4107731	
10387	925	4170947	2005-06-18	2005-06-18 00:00:00	38000275	0	\N	\N	61601	0	274474001	4170947	
10631	959	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	63791	0	180256009	4107731	
22674	1977	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	131563	0	180256009	4107731	
22864	1992	4107731	1990-08-26	1990-08-26 00:00:00	38000275	0	\N	\N	132715	0	180256009	4107731	
23097	2006	4125906	2008-06-22	2008-06-22 00:00:00	38000275	0	\N	\N	133605	0	288086009	4125906	
11389	1058	4107731	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	69472	0	180256009	4107731	
23478	2054	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	136611	0	180256009	4107731	
11702	1082	4170947	1962-11-11	1962-11-11 00:00:00	38000275	0	\N	\N	71052	0	274474001	4170947	
11962	1098	4163872	1980-06-11	1980-06-11 00:00:00	38000275	0	\N	\N	72026	0	399208008	4163872	
101	5	4151422	2012-10-16	2012-10-16 00:00:00	38000275	0	\N	\N	525	0	269911007	4151422	
293	17	4293740	1989-09-27	1989-09-27 00:00:00	38000275	0	\N	\N	1374	0	384700001	4293740	
12348	1110	4107731	1997-07-07	1997-07-07 00:00:00	38000275	0	\N	\N	73065	0	180256009	4107731	
12585	1138	4043071	1994-11-24	1994-11-24 00:00:00	38000275	0	\N	\N	75096	0	228557008	4043071	
12850	1154	4197460	1971-03-05	1971-03-05 00:00:00	38000275	0	\N	\N	76271	0	313191000	4197460	
1115	111	4125906	1981-01-30	1981-01-30 00:00:00	38000275	0	\N	\N	7417	0	288086009	4125906	
1308	129	4293740	1989-02-11	1989-02-11 00:00:00	38000275	0	\N	\N	8705	0	384700001	4293740	
13280	1211	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	79497	0	180256009	4107731	
13548	1226	4043071	1990-10-17	1990-10-17 00:00:00	38000275	0	\N	\N	80688	0	228557008	4043071	
1786	163	4125906	1984-04-29	1984-04-29 00:00:00	38000275	0	\N	\N	11236	0	288086009	4125906	
1981	183	4043071	1983-08-26	1983-08-26 00:00:00	38000275	0	\N	\N	12336	0	228557008	4043071	
2194	225	4107731	1992-08-03	1992-08-03 00:00:00	38000275	0	\N	\N	15194	0	180256009	4107731	
2402	239	4151422	1984-10-23	1984-10-23 00:00:00	38000275	0	\N	\N	16028	0	269911007	4151422	
2568	262	4125906	2005-05-30	2005-05-30 00:00:00	38000275	0	\N	\N	17412	0	288086009	4125906	
14710	1310	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	86559	0	180256009	4107731	
2932	285	4107731	1992-07-13	1992-07-13 00:00:00	38000275	0	\N	\N	18978	0	180256009	4107731	
14990	1328	4035793	2004-09-16	2004-09-16 00:00:00	38000275	0	\N	\N	88211	0	15081005	4035793	
3348	332	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	21969	0	180256009	4107731	
3532	343	4107731	1991-01-19	1991-01-19 00:00:00	38000275	0	\N	\N	22889	0	180256009	4107731	
3657	354	4035793	2002-01-24	2002-01-24 00:00:00	38000275	0	\N	\N	23591	0	15081005	4035793	
3905	399	4191853	1993-07-11	1993-07-11 00:00:00	38000275	0	\N	\N	26139	0	395142003	4191853	
4030	404	4043071	1971-07-30	1971-07-30 00:00:00	38000275	0	\N	\N	26617	0	228557008	4043071	
4220	409	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	27110	0	180256009	4107731	
16430	1431	4107731	1992-06-06	1992-06-06 00:00:00	38000275	0	\N	\N	95335	0	180256009	4107731	
4663	442	4107731	1993-05-08	1993-05-08 00:00:00	38000275	0	\N	\N	29344	0	180256009	4107731	
4854	453	4043071	1981-10-06	1981-10-06 00:00:00	38000275	0	\N	\N	30209	0	228557008	4043071	
5019	469	4043071	1950-05-22	1950-05-22 00:00:00	38000275	0	\N	\N	31305	0	228557008	4043071	
5169	480	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	32052	0	180256009	4107731	
5406	499	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	33428	0	180256009	4107731	
5530	505	4326177	1995-05-29	1995-05-29 00:00:00	38000275	0	\N	\N	33760	0	430193006	4326177	
17591	1513	4107731	1992-02-02	1992-02-02 00:00:00	38000275	0	\N	\N	101076	0	180256009	4107731	
5922	545	4107731	1990-12-08	1990-12-08 00:00:00	38000275	0	\N	\N	36056	0	180256009	4107731	
6166	563	4107731	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	37224	0	180256009	4107731	
18219	1556	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	104154	0	180256009	4107731	
6539	603	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	39976	0	180256009	4107731	
6670	610	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	40552	0	180256009	4107731	
6915	624	4047491	1947-01-23	1947-01-23 00:00:00	38000275	0	\N	\N	41688	0	1225002	4047491	
7070	652	4275113	1989-01-05	1989-01-05 00:00:00	38000275	0	\N	\N	43164	0	65200003	4275113	
7269	675	4163872	1975-12-16	1975-12-16 00:00:00	38000275	0	\N	\N	44577	0	399208008	4163872	
7398	685	4043071	1978-01-17	1978-01-17 00:00:00	38000275	0	\N	\N	45358	0	228557008	4043071	
7589	704	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	46584	0	180256009	4107731	
7822	718	4293740	1967-03-23	1967-03-23 00:00:00	38000275	0	\N	\N	47523	0	384700001	4293740	
19829	1716	4058899	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	114707	0	168594001	4058899	
8145	742	4195803	1991-11-12	1991-11-12 00:00:00	38000275	0	\N	\N	49190	0	312681000	4195803	
8328	759	4078793	2003-02-19	2003-02-19 00:00:00	38000275	0	\N	\N	50367	0	180325003	4078793	
20512	1773	4107731	1990-08-26	1990-08-26 00:00:00	38000275	0	\N	\N	118541	0	180256009	4107731	
20706	1783	4107731	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	119541	0	180256009	4107731	
20944	1808	4275113	1977-01-30	1977-01-30 00:00:00	38000275	0	\N	\N	121025	0	65200003	4275113	
9141	842	4035793	2002-08-10	2002-08-10 00:00:00	38000275	0	\N	\N	55681	0	15081005	4035793	
9263	844	4107731	1993-01-23	1993-01-23 00:00:00	38000275	0	\N	\N	55988	0	180256009	4107731	
9518	865	4151422	1972-07-28	1972-07-28 00:00:00	38000275	0	\N	\N	57400	0	269911007	4151422	
33536	2925	4107731	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	195033	0	180256009	4107731	
9838	884	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	58878	0	180256009	4107731	
21962	1911	4238715	1970-01-19	1970-01-19 00:00:00	38000275	0	\N	\N	127103	0	68254000	4238715	
22096	1923	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	127940	0	180256009	4107731	
10388	925	4047491	2005-06-18	2005-06-18 00:00:00	38000275	0	\N	\N	61601	0	1225002	4047491	
10632	959	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	63713	0	180256009	4107731	
22675	1977	4078793	2017-06-29	2017-06-29 00:00:00	38000275	0	\N	\N	131652	0	180325003	4078793	
22865	1992	4170947	2015-10-24	2015-10-24 00:00:00	38000275	0	\N	\N	132689	0	274474001	4170947	
23098	2006	4057420	2014-01-17	2014-01-17 00:00:00	38000275	0	\N	\N	133607	0	18286008	4057420	
11390	1058	4107731	1991-09-07	1991-09-07 00:00:00	38000275	0	\N	\N	69365	0	180256009	4107731	
23479	2054	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	136607	0	180256009	4107731	
11703	1082	4107731	1991-12-21	1991-12-21 00:00:00	38000275	0	\N	\N	71005	0	180256009	4107731	
11963	1098	4293740	2011-10-13	2011-10-13 00:00:00	38000275	0	\N	\N	72031	0	384700001	4293740	
102	5	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	433	0	180256009	4107731	
294	18	4047491	1998-10-07	1998-10-07 00:00:00	38000275	0	\N	\N	1379	0	1225002	4047491	
12349	1110	4107731	1997-06-16	1997-06-16 00:00:00	38000275	0	\N	\N	73061	0	180256009	4107731	
12586	1138	4043071	1995-09-07	1995-09-07 00:00:00	38000275	0	\N	\N	75082	0	228557008	4043071	
12851	1154	4058899	2016-08-17	2016-08-17 00:00:00	38000275	0	\N	\N	76276	0	168594001	4058899	
1116	111	4275113	1992-04-15	1992-04-15 00:00:00	38000275	0	\N	\N	7354	0	65200003	4275113	
13095	1180	4170947	1963-12-31	1963-12-31 00:00:00	38000275	0	\N	\N	77959	0	274474001	4170947	
13281	1211	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	79560	0	180256009	4107731	
13549	1227	4078793	2019-05-01	2019-05-01 00:00:00	38000275	0	\N	\N	80825	0	180325003	4078793	
1787	163	4293740	1984-04-29	1984-04-29 00:00:00	38000275	0	\N	\N	11236	0	384700001	4293740	
1982	183	4043071	1983-10-21	1983-10-21 00:00:00	38000275	0	\N	\N	12353	0	228557008	4043071	
2195	225	4107731	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	15226	0	180256009	4107731	
2403	239	4125906	1970-07-26	1970-07-26 00:00:00	38000275	0	\N	\N	16052	0	288086009	4125906	
2569	262	4170947	1967-03-21	1967-03-21 00:00:00	38000275	0	\N	\N	17354	0	274474001	4170947	
14711	1310	4163872	1944-01-10	1944-01-10 00:00:00	38000275	0	\N	\N	86677	0	399208008	4163872	
2933	285	4107731	1990-07-09	1990-07-09 00:00:00	38000275	0	\N	\N	18966	0	180256009	4107731	
14991	1328	4035793	2016-04-14	2016-04-14 00:00:00	38000275	0	\N	\N	88215	0	15081005	4035793	
3349	332	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	22022	0	180256009	4107731	
3533	343	4107731	1993-03-06	1993-03-06 00:00:00	38000275	0	\N	\N	22884	0	180256009	4107731	
3658	354	4035793	2007-01-11	2007-01-11 00:00:00	38000275	0	\N	\N	23576	0	15081005	4035793	
3906	399	4107731	1990-10-28	1990-10-28 00:00:00	38000275	0	\N	\N	26201	0	180256009	4107731	
4031	404	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	26577	0	180256009	4107731	
4221	409	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	27080	0	180256009	4107731	
16431	1431	4107731	1991-10-19	1991-10-19 00:00:00	38000275	0	\N	\N	95267	0	180256009	4107731	
4664	442	4107731	1991-11-30	1991-11-30 00:00:00	38000275	0	\N	\N	29356	0	180256009	4107731	
4855	453	4043071	1982-11-16	1982-11-16 00:00:00	38000275	0	\N	\N	30159	0	228557008	4043071	
5020	469	4043071	1949-10-10	1949-10-10 00:00:00	38000275	0	\N	\N	31319	0	228557008	4043071	
5170	480	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	32099	0	180256009	4107731	
5407	499	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	33324	0	180256009	4107731	
5531	505	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	33773	0	180256009	4107731	
17592	1513	4107731	1991-07-07	1991-07-07 00:00:00	38000275	0	\N	\N	101144	0	180256009	4107731	
5923	545	4107731	1990-04-21	1990-04-21 00:00:00	38000275	0	\N	\N	36028	0	180256009	4107731	
6167	563	4107731	1990-06-03	1990-06-03 00:00:00	38000275	0	\N	\N	37198	0	180256009	4107731	
18220	1556	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	104258	0	180256009	4107731	
6540	603	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	40029	0	180256009	4107731	
6671	610	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	40537	0	180256009	4107731	
6916	624	4170947	1947-01-23	1947-01-23 00:00:00	38000275	0	\N	\N	41688	0	274474001	4170947	
7071	652	4238715	1992-05-05	1992-05-05 00:00:00	38000275	0	\N	\N	43149	0	68254000	4238715	
7270	675	4125906	1972-04-23	1972-04-23 00:00:00	38000275	0	\N	\N	44600	0	288086009	4125906	
7399	685	4043071	1975-03-18	1975-03-18 00:00:00	38000275	0	\N	\N	45253	0	228557008	4043071	
7590	704	4058899	1968-01-27	1968-01-27 00:00:00	38000275	0	\N	\N	46511	0	168594001	4058899	
7823	718	4125906	1967-03-23	1967-03-23 00:00:00	38000275	0	\N	\N	47523	0	288086009	4125906	
19830	1716	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	114648	0	180256009	4107731	
8146	742	4035793	1980-09-22	1980-09-22 00:00:00	38000275	0	\N	\N	49110	0	15081005	4035793	
8329	759	4078793	2017-05-10	2017-05-10 00:00:00	38000275	0	\N	\N	50444	0	180325003	4078793	
20513	1773	4107731	1990-11-18	1990-11-18 00:00:00	38000275	0	\N	\N	118496	0	180256009	4107731	
20707	1783	4107731	1990-08-20	1990-08-20 00:00:00	38000275	0	\N	\N	119539	0	180256009	4107731	
32743	2871	4043071	1961-02-09	1961-02-09 00:00:00	38000275	0	\N	\N	191112	0	228557008	4043071	
9142	842	4035793	1978-12-30	1978-12-30 00:00:00	38000275	0	\N	\N	55735	0	15081005	4035793	
9264	844	4107731	1991-09-28	1991-09-28 00:00:00	38000275	0	\N	\N	55890	0	180256009	4107731	
9519	866	4125906	2007-03-22	2007-03-22 00:00:00	38000275	0	\N	\N	57488	0	288086009	4125906	
33537	2925	44783196	2015-03-19	2015-03-19 00:00:00	38000275	0	\N	\N	195027	0	699253003	44783196	
9839	884	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	58902	0	180256009	4107731	
21963	1911	4243062	1960-03-12	1960-03-12 00:00:00	38000275	0	\N	\N	127175	0	60027007	4243062	
22097	1923	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	127878	0	180256009	4107731	
10395	929	4151422	1942-06-13	1942-06-13 00:00:00	38000275	0	\N	\N	61784	0	269911007	4151422	
10633	959	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	63767	0	180256009	4107731	
22676	1977	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	131586	0	180256009	4107731	
22866	1992	4243062	2015-10-24	2015-10-24 00:00:00	38000275	0	\N	\N	132689	0	60027007	4243062	
23099	2006	40492359	2014-01-17	2014-01-17 00:00:00	38000275	0	\N	\N	133607	0	447365002	40492359	
11391	1058	4107731	1991-11-30	1991-11-30 00:00:00	38000275	0	\N	\N	69367	0	180256009	4107731	
23480	2054	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	136603	0	180256009	4107731	
11704	1082	4107731	1991-04-13	1991-04-13 00:00:00	38000275	0	\N	\N	71043	0	180256009	4107731	
11964	1098	4125906	2011-10-13	2011-10-13 00:00:00	38000275	0	\N	\N	72031	0	288086009	4125906	
103	5	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	421	0	180256009	4107731	
295	18	4170947	1998-10-07	1998-10-07 00:00:00	38000275	0	\N	\N	1379	0	274474001	4170947	
12350	1110	4107731	1995-05-01	1995-05-01 00:00:00	38000275	0	\N	\N	73101	0	180256009	4107731	
12587	1138	4107731	1995-07-06	1995-07-06 00:00:00	38000275	0	\N	\N	75056	0	180256009	4107731	
12852	1154	4293740	2009-11-01	2009-11-01 00:00:00	38000275	0	\N	\N	76275	0	384700001	4293740	
1122	114	4151422	2009-11-30	2009-11-30 00:00:00	38000275	0	\N	\N	7513	0	269911007	4151422	
13096	1180	4047491	1963-12-31	1963-12-31 00:00:00	38000275	0	\N	\N	77959	0	1225002	4047491	
13282	1211	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	79624	0	180256009	4107731	
13550	1227	4078793	2019-04-24	2019-04-24 00:00:00	38000275	0	\N	\N	80851	0	180325003	4078793	
1788	163	4151422	2001-04-28	2001-04-28 00:00:00	38000275	0	\N	\N	11197	0	269911007	4151422	
1983	183	4043071	1984-03-16	1984-03-16 00:00:00	38000275	0	\N	\N	12407	0	228557008	4043071	
2196	225	4107731	1992-06-22	1992-06-22 00:00:00	38000275	0	\N	\N	15193	0	180256009	4107731	
2404	239	4125906	1966-08-25	1966-08-25 00:00:00	38000275	0	\N	\N	16051	0	288086009	4125906	
2570	263	4078793	2018-09-09	2018-09-09 00:00:00	38000275	0	\N	\N	17500	0	180325003	4078793	
14712	1310	4170947	1944-01-10	1944-01-10 00:00:00	38000275	0	\N	\N	86677	0	274474001	4170947	
2934	285	4107731	1990-06-18	1990-06-18 00:00:00	38000275	0	\N	\N	18943	0	180256009	4107731	
14992	1328	4035793	2007-10-04	2007-10-04 00:00:00	38000275	0	\N	\N	88232	0	15081005	4035793	
3350	332	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	22046	0	180256009	4107731	
3534	343	4107731	1992-12-12	1992-12-12 00:00:00	38000275	0	\N	\N	22911	0	180256009	4107731	
3659	354	4035793	2012-02-09	2012-02-09 00:00:00	38000275	0	\N	\N	23567	0	15081005	4035793	
3907	399	4107731	1991-01-20	1991-01-20 00:00:00	38000275	0	\N	\N	26203	0	180256009	4107731	
4032	404	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	26589	0	180256009	4107731	
4222	409	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	27118	0	180256009	4107731	
16432	1431	4107731	1991-04-13	1991-04-13 00:00:00	38000275	0	\N	\N	95266	0	180256009	4107731	
4665	442	4107731	1990-02-17	1990-02-17 00:00:00	38000275	0	\N	\N	29297	0	180256009	4107731	
4856	453	4043071	1983-07-05	1983-07-05 00:00:00	38000275	0	\N	\N	30161	0	228557008	4043071	
5021	469	4043071	1948-05-24	1948-05-24 00:00:00	38000275	0	\N	\N	31278	0	228557008	4043071	
5171	480	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	32078	0	180256009	4107731	
5408	499	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	33298	0	180256009	4107731	
5532	505	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	33817	0	180256009	4107731	
17593	1513	4043071	1979-11-29	1979-11-29 00:00:00	38000275	0	\N	\N	101132	0	228557008	4043071	
5924	545	4107731	1992-06-06	1992-06-06 00:00:00	38000275	0	\N	\N	36072	0	180256009	4107731	
6168	563	4107731	1991-05-05	1991-05-05 00:00:00	38000275	0	\N	\N	37222	0	180256009	4107731	
18221	1556	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	104217	0	180256009	4107731	
6541	603	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	39910	0	395142003	4191853	
6672	610	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	40486	0	180256009	4107731	
6917	624	4125906	1973-04-23	1973-04-23 00:00:00	38000275	0	\N	\N	41693	0	288086009	4125906	
7072	653	4125906	1971-09-14	1971-09-14 00:00:00	38000275	0	\N	\N	43262	0	288086009	4125906	
7271	675	4058899	2013-11-05	2013-11-05 00:00:00	38000275	0	\N	\N	44646	0	168594001	4058899	
7400	685	4043071	1974-08-13	1974-08-13 00:00:00	38000275	0	\N	\N	45311	0	228557008	4043071	
7591	704	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	46571	0	180256009	4107731	
7824	718	4107731	1990-06-23	1990-06-23 00:00:00	38000275	0	\N	\N	47500	0	180256009	4107731	
19831	1716	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	114686	0	180256009	4107731	
8147	744	4125906	2012-01-14	2012-01-14 00:00:00	38000275	0	\N	\N	49357	0	288086009	4125906	
8330	759	4078793	2004-02-25	2004-02-25 00:00:00	38000275	0	\N	\N	50441	0	180325003	4078793	
20514	1773	4107731	1991-01-20	1991-01-20 00:00:00	38000275	0	\N	\N	118579	0	180256009	4107731	
20708	1783	4107731	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	119387	0	180256009	4107731	
32744	2871	4043071	1963-09-05	1963-09-05 00:00:00	38000275	0	\N	\N	191164	0	228557008	4043071	
9143	842	4125906	1968-11-15	1968-11-15 00:00:00	38000275	0	\N	\N	55711	0	288086009	4125906	
9265	844	4107731	1993-03-06	1993-03-06 00:00:00	38000275	0	\N	\N	55989	0	180256009	4107731	
9520	867	4293740	1931-02-18	1931-02-18 00:00:00	38000275	0	\N	\N	57579	0	384700001	4293740	
33538	2925	4107731	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	195065	0	180256009	4107731	
9840	884	4145310	1989-06-08	1989-06-08 00:00:00	38000275	0	\N	\N	58950	0	268425006	4145310	
21964	1911	4170947	1960-03-12	1960-03-12 00:00:00	38000275	0	\N	\N	127175	0	274474001	4170947	
22098	1923	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	127935	0	180256009	4107731	
10396	929	4151422	1934-08-16	1934-08-16 00:00:00	38000275	0	\N	\N	61820	0	269911007	4151422	
10634	959	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	63721	0	180256009	4107731	
22677	1977	4125906	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	131624	0	288086009	4125906	
22867	1992	4107731	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	132686	0	180256009	4107731	
23100	2006	4010253	1979-11-26	1979-11-26 00:00:00	38000275	0	\N	\N	133620	0	112790001	4010253	
11392	1058	4107731	1992-06-27	1992-06-27 00:00:00	38000275	0	\N	\N	69449	0	180256009	4107731	
23481	2054	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	136688	0	180256009	4107731	
11705	1082	4107731	1991-03-23	1991-03-23 00:00:00	38000275	0	\N	\N	70935	0	180256009	4107731	
11965	1098	4151422	1956-11-05	1956-11-05 00:00:00	38000275	0	\N	\N	72041	0	269911007	4151422	
104	5	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	504	0	180256009	4107731	
296	18	4024289	1995-06-25	1995-06-25 00:00:00	38000275	0	\N	\N	1383	0	19490002	4024289	
12351	1110	4107731	1997-03-24	1997-03-24 00:00:00	38000275	0	\N	\N	73099	0	180256009	4107731	
12588	1138	4107731	1994-07-14	1994-07-14 00:00:00	38000275	0	\N	\N	75049	0	180256009	4107731	
12853	1154	4125906	2009-11-01	2009-11-01 00:00:00	38000275	0	\N	\N	76275	0	288086009	4125906	
12941	1173	4058899	1949-03-19	1949-03-19 00:00:00	38000275	0	\N	\N	77274	0	168594001	4058899	
13097	1180	4151422	1961-03-18	1961-03-18 00:00:00	38000275	0	\N	\N	77894	0	269911007	4151422	
13283	1211	4062501	1966-10-29	1966-10-29 00:00:00	38000275	0	\N	\N	79536	0	171231001	4062501	
13551	1227	4078793	2018-02-14	2018-02-14 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
1789	163	4293740	1979-06-04	1979-06-04 00:00:00	38000275	0	\N	\N	11235	0	384700001	4293740	
1984	184	4125906	1984-07-07	1984-07-07 00:00:00	38000275	0	\N	\N	12503	0	288086009	4125906	
2197	225	4107731	1990-04-16	1990-04-16 00:00:00	38000275	0	\N	\N	15209	0	180256009	4107731	
14213	1276	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	84251	0	180256009	4107731	
2571	263	4078793	2017-09-03	2017-09-03 00:00:00	38000275	0	\N	\N	17494	0	180325003	4078793	
14713	1310	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	86635	0	180256009	4107731	
2935	285	4107731	1990-10-01	1990-10-01 00:00:00	38000275	0	\N	\N	18968	0	180256009	4107731	
14993	1328	4035793	2012-03-22	2012-03-22 00:00:00	38000275	0	\N	\N	88214	0	15081005	4035793	
3351	332	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	21929	0	180256009	4107731	
3535	343	4107731	1991-03-23	1991-03-23 00:00:00	38000275	0	\N	\N	22947	0	180256009	4107731	
3660	354	4035793	2000-01-20	2000-01-20 00:00:00	38000275	0	\N	\N	23575	0	15081005	4035793	
3908	399	4107731	1992-05-17	1992-05-17 00:00:00	38000275	0	\N	\N	26212	0	180256009	4107731	
4033	404	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	26688	0	180256009	4107731	
4223	409	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	27097	0	180256009	4107731	
16433	1431	4107731	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	95284	0	180256009	4107731	
4666	442	4191853	1990-01-06	1990-01-06 00:00:00	38000275	0	\N	\N	29296	0	395142003	4191853	
4857	453	4043071	1981-08-11	1981-08-11 00:00:00	38000275	0	\N	\N	30153	0	228557008	4043071	
5022	469	4043071	1948-02-16	1948-02-16 00:00:00	38000275	0	\N	\N	31359	0	228557008	4043071	
5172	480	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	31992	0	180256009	4107731	
5409	499	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	33445	0	180256009	4107731	
5533	505	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	33855	0	180256009	4107731	
17594	1513	4181917	1983-06-19	1983-06-19 00:00:00	38000275	0	\N	\N	101151	0	54550000	4181917	
5925	545	4107731	1990-05-12	1990-05-12 00:00:00	38000275	0	\N	\N	36136	0	180256009	4107731	
6169	563	4107731	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	37301	0	180256009	4107731	
18222	1556	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	104163	0	180256009	4107731	
6542	603	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	39966	0	180256009	4107731	
6673	610	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	40531	0	180256009	4107731	
6918	625	4243062	1974-12-25	1974-12-25 00:00:00	38000275	0	\N	\N	41733	0	60027007	4243062	
7073	654	4163872	2010-03-03	2010-03-03 00:00:00	38000275	0	\N	\N	43295	0	399208008	4163872	
7272	675	4195803	2013-11-05	2013-11-05 00:00:00	38000275	0	\N	\N	44646	0	312681000	4195803	
7401	685	4043071	1977-12-20	1977-12-20 00:00:00	38000275	0	\N	\N	45299	0	228557008	4043071	
7592	704	4151422	1978-07-04	1978-07-04 00:00:00	38000275	0	\N	\N	46581	0	269911007	4151422	
7825	718	4107731	1991-03-23	1991-03-23 00:00:00	38000275	0	\N	\N	47467	0	180256009	4107731	
19832	1716	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	114612	0	180256009	4107731	
8148	744	4125906	2017-08-29	2017-08-29 00:00:00	38000275	0	\N	\N	49358	0	288086009	4125906	
8331	759	4078793	2014-04-23	2014-04-23 00:00:00	38000275	0	\N	\N	50410	0	180325003	4078793	
20515	1773	4107731	1990-06-03	1990-06-03 00:00:00	38000275	0	\N	\N	118539	0	180256009	4107731	
20709	1783	4107731	1991-02-25	1991-02-25 00:00:00	38000275	0	\N	\N	119485	0	180256009	4107731	
32745	2871	4043071	1961-07-27	1961-07-27 00:00:00	38000275	0	\N	\N	191075	0	228557008	4043071	
9144	842	4035793	1988-04-23	1988-04-23 00:00:00	38000275	0	\N	\N	55749	0	15081005	4035793	
9266	844	4107731	1990-03-31	1990-03-31 00:00:00	38000275	0	\N	\N	55955	0	180256009	4107731	
9521	867	4125906	1931-02-18	1931-02-18 00:00:00	38000275	0	\N	\N	57579	0	288086009	4125906	
33539	2925	4107731	1990-03-25	1990-03-25 00:00:00	38000275	0	\N	\N	195095	0	180256009	4107731	
9841	884	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	58877	0	180256009	4107731	
21978	1915	4043071	1983-08-11	1983-08-11 00:00:00	38000275	0	\N	\N	127377	0	228557008	4043071	
22099	1923	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	127934	0	180256009	4107731	
10397	929	4125906	1932-07-26	1932-07-26 00:00:00	38000275	0	\N	\N	61754	0	288086009	4125906	
10635	959	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	63693	0	180256009	4107731	
22678	1977	4293740	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	131624	0	384700001	4293740	
22868	1992	4107731	1991-07-07	1991-07-07 00:00:00	38000275	0	\N	\N	132674	0	180256009	4107731	
23101	2007	40492359	1994-07-17	1994-07-17 00:00:00	38000275	0	\N	\N	133660	0	447365002	40492359	
11393	1058	4107731	1990-09-15	1990-09-15 00:00:00	38000275	0	\N	\N	69486	0	180256009	4107731	
23482	2054	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	136683	0	180256009	4107731	
11706	1082	4107731	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	71049	0	180256009	4107731	
11966	1098	4125906	1975-02-19	1975-02-19 00:00:00	38000275	0	\N	\N	72029	0	288086009	4125906	
105	5	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	409	0	180256009	4107731	
297	18	4170947	1995-06-25	1995-06-25 00:00:00	38000275	0	\N	\N	1383	0	274474001	4170947	
12352	1110	4107731	1996-08-26	1996-08-26 00:00:00	38000275	0	\N	\N	73034	0	180256009	4107731	
12589	1138	4107731	1993-05-20	1993-05-20 00:00:00	38000275	0	\N	\N	75039	0	180256009	4107731	
12854	1154	4195803	2002-05-21	2002-05-21 00:00:00	38000275	0	\N	\N	76272	0	312681000	4195803	
12942	1174	4010253	1976-12-01	1976-12-01 00:00:00	38000275	0	\N	\N	77362	0	112790001	4010253	
13098	1180	4151422	1983-04-09	1983-04-09 00:00:00	38000275	0	\N	\N	77904	0	269911007	4151422	
13284	1211	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	79603	0	180256009	4107731	
13552	1227	4145310	2004-05-22	2004-05-22 00:00:00	38000275	0	\N	\N	80823	0	268425006	4145310	
1790	163	4125906	1979-06-04	1979-06-04 00:00:00	38000275	0	\N	\N	11235	0	288086009	4125906	
1985	184	4151422	1964-01-25	1964-01-25 00:00:00	38000275	0	\N	\N	12472	0	269911007	4151422	
2198	225	4107731	1990-07-09	1990-07-09 00:00:00	38000275	0	\N	\N	15211	0	180256009	4107731	
14214	1276	4125906	2015-09-14	2015-09-14 00:00:00	38000275	0	\N	\N	84136	0	288086009	4125906	
2572	263	4125906	2013-08-21	2013-08-21 00:00:00	38000275	0	\N	\N	17424	0	288086009	4125906	
14714	1310	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	86631	0	180256009	4107731	
2936	285	4107731	1993-01-18	1993-01-18 00:00:00	38000275	0	\N	\N	18924	0	180256009	4107731	
14994	1328	4035793	2001-08-30	2001-08-30 00:00:00	38000275	0	\N	\N	88169	0	15081005	4035793	
3352	332	4197460	1979-09-18	1979-09-18 00:00:00	38000275	0	\N	\N	21908	0	313191000	4197460	
3536	343	4107731	1990-07-14	1990-07-14 00:00:00	38000275	0	\N	\N	22888	0	180256009	4107731	
3661	354	4035793	2004-01-29	2004-01-29 00:00:00	38000275	0	\N	\N	23587	0	15081005	4035793	
3909	399	4107731	1990-06-24	1990-06-24 00:00:00	38000275	0	\N	\N	26176	0	180256009	4107731	
4034	404	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	26570	0	180256009	4107731	
4224	409	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	27079	0	180256009	4107731	
16434	1431	4125906	1956-01-28	1956-01-28 00:00:00	38000275	0	\N	\N	95249	0	288086009	4125906	
4667	442	4107731	1993-01-23	1993-01-23 00:00:00	38000275	0	\N	\N	29365	0	180256009	4107731	
4858	453	4043071	1985-07-09	1985-07-09 00:00:00	38000275	0	\N	\N	30164	0	228557008	4043071	
5023	469	4043071	1950-12-04	1950-12-04 00:00:00	38000275	0	\N	\N	31307	0	228557008	4043071	
5173	480	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	32077	0	180256009	4107731	
5410	499	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	33300	0	180256009	4107731	
5534	505	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	33751	0	180256009	4107731	
17595	1513	4043071	1980-08-14	1980-08-14 00:00:00	38000275	0	\N	\N	101157	0	228557008	4043071	
5926	545	4107731	1991-05-04	1991-05-04 00:00:00	38000275	0	\N	\N	36141	0	180256009	4107731	
6170	563	4107731	1991-02-10	1991-02-10 00:00:00	38000275	0	\N	\N	37304	0	180256009	4107731	
18223	1556	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	104243	0	180256009	4107731	
6543	603	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	39974	0	180256009	4107731	
6674	610	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	40585	0	180256009	4107731	
6919	625	4170947	1974-12-25	1974-12-25 00:00:00	38000275	0	\N	\N	41733	0	274474001	4170947	
7074	654	4151422	2007-05-22	2007-05-22 00:00:00	38000275	0	\N	\N	43311	0	269911007	4151422	
7273	675	4062501	1952-02-23	1952-02-23 00:00:00	38000275	0	\N	\N	44712	0	171231001	4062501	
7402	685	4043071	1976-01-13	1976-01-13 00:00:00	38000275	0	\N	\N	45293	0	228557008	4043071	
7593	704	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	46616	0	180256009	4107731	
7826	718	4107731	1990-03-10	1990-03-10 00:00:00	38000275	0	\N	\N	47427	0	180256009	4107731	
19833	1716	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	114740	0	180256009	4107731	
8149	744	4198190	2004-03-17	2004-03-17 00:00:00	38000275	0	\N	\N	49371	0	80146002	4198190	
8332	760	4275113	1978-11-24	1978-11-24 00:00:00	38000275	0	\N	\N	50502	0	65200003	4275113	
20516	1773	4107731	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	118635	0	180256009	4107731	
20710	1783	4191853	1990-01-01	1990-01-01 00:00:00	38000275	0	\N	\N	119537	0	395142003	4191853	
32746	2871	4043071	1962-03-29	1962-03-29 00:00:00	38000275	0	\N	\N	191068	0	228557008	4043071	
9145	842	4035793	1998-07-18	1998-07-18 00:00:00	38000275	0	\N	\N	55688	0	15081005	4035793	
9267	844	4107731	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	55914	0	180256009	4107731	
9522	867	4151422	1984-02-02	1984-02-02 00:00:00	38000275	0	\N	\N	57522	0	269911007	4151422	
33540	2925	4107731	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	195115	0	180256009	4107731	
9842	884	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	58879	0	180256009	4107731	
21979	1915	4043071	1983-07-14	1983-07-14 00:00:00	38000275	0	\N	\N	127352	0	228557008	4043071	
22100	1923	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	127945	0	180256009	4107731	
10398	929	4125906	1977-05-20	1977-05-20 00:00:00	38000275	0	\N	\N	61756	0	288086009	4125906	
10636	959	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	63674	0	180256009	4107731	
22679	1977	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	131599	0	180256009	4107731	
22869	1992	4107731	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	132662	0	180256009	4107731	
23102	2007	4057420	1994-07-17	1994-07-17 00:00:00	38000275	0	\N	\N	133660	0	18286008	4057420	
11394	1058	4107731	1990-05-12	1990-05-12 00:00:00	38000275	0	\N	\N	69477	0	180256009	4107731	
23483	2054	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	136589	0	180256009	4107731	
11707	1082	4107731	1993-05-29	1993-05-29 00:00:00	38000275	0	\N	\N	70965	0	180256009	4107731	
11967	1099	4191853	1993-07-10	1993-07-10 00:00:00	38000275	0	\N	\N	72208	0	395142003	4191853	
106	5	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	480	0	180256009	4107731	
298	18	4125906	1970-09-22	1970-09-22 00:00:00	38000275	0	\N	\N	1381	0	288086009	4125906	
12353	1110	4107731	1996-01-29	1996-01-29 00:00:00	38000275	0	\N	\N	73056	0	180256009	4107731	
12590	1138	4107731	1996-06-27	1996-06-27 00:00:00	38000275	0	\N	\N	75032	0	180256009	4107731	
12855	1154	4243062	2002-05-21	2002-05-21 00:00:00	38000275	0	\N	\N	76272	0	60027007	4243062	
12943	1174	4125906	2003-01-31	2003-01-31 00:00:00	38000275	0	\N	\N	77374	0	288086009	4125906	
13099	1180	4058899	2010-09-28	2010-09-28 00:00:00	38000275	0	\N	\N	77962	0	168594001	4058899	
13285	1211	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	79648	0	180256009	4107731	
13553	1227	4195803	2004-05-22	2004-05-22 00:00:00	38000275	0	\N	\N	80823	0	312681000	4195803	
1791	163	4125906	1999-08-30	1999-08-30 00:00:00	38000275	0	\N	\N	11237	0	288086009	4125906	
1986	184	4058899	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	12504	0	168594001	4058899	
2199	225	4107731	1992-03-09	1992-03-09 00:00:00	38000275	0	\N	\N	15244	0	180256009	4107731	
14215	1276	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	84176	0	180256009	4107731	
2573	263	4170947	2010-11-05	2010-11-05 00:00:00	38000275	0	\N	\N	17423	0	274474001	4170947	
14715	1310	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	86597	0	180256009	4107731	
2937	285	4107731	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	18991	0	180256009	4107731	
14995	1328	4117038	1971-05-28	1971-05-28 00:00:00	38000275	0	\N	\N	88166	0	287664005	4117038	
3353	332	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	22017	0	180256009	4107731	
3537	343	4107731	1991-07-06	1991-07-06 00:00:00	38000275	0	\N	\N	22976	0	180256009	4107731	
3662	354	4035793	2010-01-28	2010-01-28 00:00:00	38000275	0	\N	\N	23523	0	15081005	4035793	
3910	399	4107731	1990-12-30	1990-12-30 00:00:00	38000275	0	\N	\N	26136	0	180256009	4107731	
4035	404	4043071	1971-06-25	1971-06-25 00:00:00	38000275	0	\N	\N	26631	0	228557008	4043071	
4225	409	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	27139	0	180256009	4107731	
16435	1431	4107731	1991-01-19	1991-01-19 00:00:00	38000275	0	\N	\N	95304	0	180256009	4107731	
4668	442	4107731	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	29264	0	180256009	4107731	
4859	453	4043071	1985-04-30	1985-04-30 00:00:00	38000275	0	\N	\N	30196	0	228557008	4043071	
5024	469	4043071	1946-10-21	1946-10-21 00:00:00	38000275	0	\N	\N	31344	0	228557008	4043071	
5174	480	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	31988	0	180256009	4107731	
5411	499	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	33431	0	180256009	4107731	
5535	505	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	33831	0	180256009	4107731	
17596	1513	4043071	1979-12-27	1979-12-27 00:00:00	38000275	0	\N	\N	101118	0	228557008	4043071	
5927	545	4107731	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	36045	0	180256009	4107731	
6171	563	4107731	1993-01-24	1993-01-24 00:00:00	38000275	0	\N	\N	37284	0	180256009	4107731	
18224	1556	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	104239	0	180256009	4107731	
6544	603	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	39959	0	180256009	4107731	
6675	610	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	40483	0	180256009	4107731	
18703	1602	4170947	2006-05-25	2006-05-25 00:00:00	38000275	0	\N	\N	107525	0	274474001	4170947	
7075	654	4163872	2018-08-26	2018-08-26 00:00:00	38000275	0	\N	\N	43298	0	399208008	4163872	
7274	675	4163872	1958-08-21	1958-08-21 00:00:00	38000275	0	\N	\N	44594	0	399208008	4163872	
7403	685	4043071	1975-09-16	1975-09-16 00:00:00	38000275	0	\N	\N	45315	0	228557008	4043071	
7594	704	4125906	1994-10-26	1994-10-26 00:00:00	38000275	0	\N	\N	46642	0	288086009	4125906	
7827	718	4151422	2016-01-27	2016-01-27 00:00:00	38000275	0	\N	\N	47461	0	269911007	4151422	
19834	1716	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	114743	0	180256009	4107731	
8150	744	4125906	1983-12-07	1983-12-07 00:00:00	38000275	0	\N	\N	49354	0	288086009	4125906	
8333	760	4151422	2007-06-21	2007-06-21 00:00:00	38000275	0	\N	\N	50497	0	269911007	4151422	
20517	1773	4107731	1992-01-12	1992-01-12 00:00:00	38000275	0	\N	\N	118608	0	180256009	4107731	
20711	1783	4107731	1992-02-17	1992-02-17 00:00:00	38000275	0	\N	\N	119518	0	180256009	4107731	
32747	2871	4043071	1962-08-02	1962-08-02 00:00:00	38000275	0	\N	\N	191069	0	228557008	4043071	
9146	842	4035793	1991-06-08	1991-06-08 00:00:00	38000275	0	\N	\N	55740	0	15081005	4035793	
9268	844	4107731	1990-12-08	1990-12-08 00:00:00	38000275	0	\N	\N	55974	0	180256009	4107731	
9523	867	4170947	1998-09-29	1998-09-29 00:00:00	38000275	0	\N	\N	57582	0	274474001	4170947	
33541	2925	4107731	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	195061	0	180256009	4107731	
9843	884	4252419	2011-12-29	2011-12-29 00:00:00	38000275	0	\N	\N	58955	0	74016001	4252419	
21980	1915	4125906	2001-12-13	2001-12-13 00:00:00	38000275	0	\N	\N	127405	0	288086009	4125906	
22101	1923	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	127990	0	180256009	4107731	
10399	929	4062501	1922-08-10	1922-08-10 00:00:00	38000275	0	\N	\N	61818	0	171231001	4062501	
10637	959	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	63687	0	180256009	4107731	
22680	1977	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	131584	0	180256009	4107731	
22870	1992	4107731	1992-06-07	1992-06-07 00:00:00	38000275	0	\N	\N	132696	0	180256009	4107731	
23106	2012	4198190	1996-01-25	1996-01-25 00:00:00	38000275	0	\N	\N	133915	0	80146002	4198190	
11395	1058	4107731	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	69434	0	180256009	4107731	
23484	2054	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	136604	0	180256009	4107731	
11708	1082	4151422	2005-12-20	2005-12-20 00:00:00	38000275	0	\N	\N	70966	0	269911007	4151422	
11968	1099	4107731	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	72241	0	180256009	4107731	
107	5	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	523	0	180256009	4107731	
299	19	4078793	2015-09-27	2015-09-27 00:00:00	38000275	0	\N	\N	1536	0	180325003	4078793	
12354	1110	4107731	1995-11-27	1995-11-27 00:00:00	38000275	0	\N	\N	73031	0	180256009	4107731	
12591	1138	4107731	1995-03-23	1995-03-23 00:00:00	38000275	0	\N	\N	75099	0	180256009	4107731	
12856	1154	4170947	2002-05-21	2002-05-21 00:00:00	38000275	0	\N	\N	76272	0	274474001	4170947	
12944	1174	4125906	1941-11-03	1941-11-03 00:00:00	38000275	0	\N	\N	77371	0	288086009	4125906	
13100	1180	4195803	2010-09-28	2010-09-28 00:00:00	38000275	0	\N	\N	77962	0	312681000	4195803	
13286	1211	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	79590	0	180256009	4107731	
13554	1227	4043071	1947-07-18	1947-07-18 00:00:00	38000275	0	\N	\N	80778	0	228557008	4043071	
1792	163	4058899	1975-04-26	1975-04-26 00:00:00	38000275	0	\N	\N	11234	0	168594001	4058899	
1987	184	4195803	2016-08-01	2016-08-01 00:00:00	38000275	0	\N	\N	12437	0	312681000	4195803	
2200	225	4107731	1991-09-02	1991-09-02 00:00:00	38000275	0	\N	\N	15228	0	180256009	4107731	
14216	1276	4047491	2010-08-11	2010-08-11 00:00:00	38000275	0	\N	\N	84135	0	1225002	4047491	
2574	263	4024289	2010-11-05	2010-11-05 00:00:00	38000275	0	\N	\N	17423	0	19490002	4024289	
14716	1310	4163872	1959-07-17	1959-07-17 00:00:00	38000275	0	\N	\N	86682	0	399208008	4163872	
2938	285	4107731	1990-04-16	1990-04-16 00:00:00	38000275	0	\N	\N	18920	0	180256009	4107731	
14996	1328	4035793	2015-04-09	2015-04-09 00:00:00	38000275	0	\N	\N	88234	0	15081005	4035793	
3354	332	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	21884	0	180256009	4107731	
3538	343	4107731	1991-04-13	1991-04-13 00:00:00	38000275	0	\N	\N	22891	0	180256009	4107731	
3663	354	4035793	2016-03-03	2016-03-03 00:00:00	38000275	0	\N	\N	23569	0	15081005	4035793	
3911	399	4107731	1992-02-02	1992-02-02 00:00:00	38000275	0	\N	\N	26183	0	180256009	4107731	
4036	404	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	26590	0	180256009	4107731	
4226	409	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	27030	0	180256009	4107731	
16436	1431	4107731	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	95262	0	180256009	4107731	
4669	442	4107731	1990-05-12	1990-05-12 00:00:00	38000275	0	\N	\N	29338	0	180256009	4107731	
4860	453	4043071	1982-07-06	1982-07-06 00:00:00	38000275	0	\N	\N	30171	0	228557008	4043071	
5025	469	4043071	1950-02-13	1950-02-13 00:00:00	38000275	0	\N	\N	31240	0	228557008	4043071	
5175	480	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	32049	0	180256009	4107731	
5412	499	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	33371	0	395142003	4191853	
5536	505	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	33832	0	180256009	4107731	
17597	1513	4043071	1980-07-17	1980-07-17 00:00:00	38000275	0	\N	\N	101134	0	228557008	4043071	
5928	545	4107731	1992-02-22	1992-02-22 00:00:00	38000275	0	\N	\N	36017	0	180256009	4107731	
17953	1538	4191853	1990-01-01	1990-01-01 00:00:00	38000275	0	\N	\N	102975	0	395142003	4191853	
18225	1556	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	104247	0	180256009	4107731	
6545	603	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	39964	0	180256009	4107731	
6676	610	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	40548	0	180256009	4107731	
18704	1602	4047491	2006-05-25	2006-05-25 00:00:00	38000275	0	\N	\N	107525	0	1225002	4047491	
7076	655	4238715	1979-02-24	1979-02-24 00:00:00	38000275	0	\N	\N	43402	0	68254000	4238715	
7275	675	4170947	1958-08-21	1958-08-21 00:00:00	38000275	0	\N	\N	44594	0	274474001	4170947	
7404	685	4043071	1974-04-09	1974-04-09 00:00:00	38000275	0	\N	\N	45331	0	228557008	4043071	
7595	704	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	46610	0	180256009	4107731	
7828	718	4107731	1993-03-27	1993-03-27 00:00:00	38000275	0	\N	\N	47459	0	180256009	4107731	
19835	1716	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	114762	0	180256009	4107731	
8151	744	4125906	1996-07-22	1996-07-22 00:00:00	38000275	0	\N	\N	49355	0	288086009	4125906	
8334	760	4238715	1984-02-22	1984-02-22 00:00:00	38000275	0	\N	\N	50463	0	68254000	4238715	
20518	1773	4107731	1991-08-18	1991-08-18 00:00:00	38000275	0	\N	\N	118499	0	180256009	4107731	
20712	1783	4197460	1974-06-14	1974-06-14 00:00:00	38000275	0	\N	\N	119439	0	313191000	4197460	
32748	2871	4043071	1962-05-31	1962-05-31 00:00:00	38000275	0	\N	\N	191053	0	228557008	4043071	
9147	842	4035793	1987-04-18	1987-04-18 00:00:00	38000275	0	\N	\N	55695	0	15081005	4035793	
9269	844	4107731	1991-11-30	1991-11-30 00:00:00	38000275	0	\N	\N	55979	0	180256009	4107731	
9524	867	4047491	1998-09-29	1998-09-29 00:00:00	38000275	0	\N	\N	57582	0	1225002	4047491	
33542	2925	4107731	1991-09-23	1991-09-23 00:00:00	38000275	0	\N	\N	195105	0	180256009	4107731	
9844	884	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	58906	0	180256009	4107731	
21981	1915	4043071	1983-06-09	1983-06-09 00:00:00	38000275	0	\N	\N	127351	0	228557008	4043071	
22102	1923	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	127992	0	180256009	4107731	
10400	929	4216130	2005-10-10	2005-10-10 00:00:00	38000275	0	\N	\N	61759	0	415070008	4216130	
10638	959	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	63715	0	180256009	4107731	
22681	1977	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	131482	0	180256009	4107731	
22871	1992	4107731	1990-08-05	1990-08-05 00:00:00	38000275	0	\N	\N	132702	0	180256009	4107731	
23107	2012	4058899	1970-07-23	1970-07-23 00:00:00	38000275	0	\N	\N	133863	0	168594001	4058899	
11396	1058	4107731	1991-10-19	1991-10-19 00:00:00	38000275	0	\N	\N	69366	0	180256009	4107731	
23485	2054	4170947	2019-06-26	2019-06-26 00:00:00	38000275	0	\N	\N	136591	0	274474001	4170947	
11709	1082	4107731	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	70954	0	180256009	4107731	
23750	2070	4107731	1992-08-24	1992-08-24 00:00:00	38000275	0	\N	\N	137695	0	180256009	4107731	
108	5	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	440	0	180256009	4107731	
300	19	4078793	2014-04-27	2014-04-27 00:00:00	38000275	0	\N	\N	1480	0	180325003	4078793	
12355	1110	4107731	1998-01-12	1998-01-12 00:00:00	38000275	0	\N	\N	73039	0	180256009	4107731	
12592	1138	4243062	2018-03-17	2018-03-17 00:00:00	38000275	0	\N	\N	75132	0	60027007	4243062	
12857	1155	4151422	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	76329	0	269911007	4151422	
12945	1174	4252419	1963-02-23	1963-02-23 00:00:00	38000275	0	\N	\N	77373	0	74016001	4252419	
13106	1185	4151422	1962-07-16	1962-07-16 00:00:00	38000275	0	\N	\N	78089	0	269911007	4151422	
13287	1211	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	79657	0	180256009	4107731	
13555	1227	4252419	1961-08-29	1961-08-29 00:00:00	38000275	0	\N	\N	80821	0	74016001	4252419	
1793	164	4125906	2018-09-25	2018-09-25 00:00:00	38000275	0	\N	\N	11281	0	288086009	4125906	
1988	184	4125906	2017-10-03	2017-10-03 00:00:00	38000275	0	\N	\N	12505	0	288086009	4125906	
2201	225	4107731	1991-12-16	1991-12-16 00:00:00	38000275	0	\N	\N	15242	0	180256009	4107731	
14217	1276	4195803	2010-08-11	2010-08-11 00:00:00	38000275	0	\N	\N	84135	0	312681000	4195803	
2575	263	4195803	2010-11-05	2010-11-05 00:00:00	38000275	0	\N	\N	17423	0	312681000	4195803	
14717	1310	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	86645	0	180256009	4107731	
2939	285	4107731	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	18934	0	180256009	4107731	
14997	1328	4035793	2005-09-22	2005-09-22 00:00:00	38000275	0	\N	\N	88171	0	15081005	4035793	
3355	332	4151422	1969-02-14	1969-02-14 00:00:00	38000275	0	\N	\N	21936	0	269911007	4151422	
3539	343	4107731	1990-09-15	1990-09-15 00:00:00	38000275	0	\N	\N	22903	0	180256009	4107731	
3664	354	4125906	1968-12-27	1968-12-27 00:00:00	38000275	0	\N	\N	23545	0	288086009	4125906	
3912	399	4107731	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	26198	0	180256009	4107731	
4037	404	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	26636	0	180256009	4107731	
4227	409	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	27119	0	180256009	4107731	
16437	1431	4107731	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	95219	0	180256009	4107731	
4670	442	4107731	1991-11-09	1991-11-09 00:00:00	38000275	0	\N	\N	29325	0	180256009	4107731	
4861	453	4043071	1984-11-13	1984-11-13 00:00:00	38000275	0	\N	\N	30177	0	228557008	4043071	
5026	469	4078793	2016-10-15	2016-10-15 00:00:00	38000275	0	\N	\N	31373	0	180325003	4078793	
5176	480	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	32097	0	180256009	4107731	
5413	499	4197460	1959-10-21	1959-10-21 00:00:00	38000275	0	\N	\N	33413	0	313191000	4197460	
5537	505	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	33776	0	180256009	4107731	
17598	1513	4043071	1980-02-21	1980-02-21 00:00:00	38000275	0	\N	\N	101163	0	228557008	4043071	
5929	545	4197460	1974-06-25	1974-06-25 00:00:00	38000275	0	\N	\N	36142	0	313191000	4197460	
17954	1538	4107731	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	103064	0	180256009	4107731	
18226	1556	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	104200	0	180256009	4107731	
18429	1565	4043071	1974-09-02	1974-09-02 00:00:00	38000275	0	\N	\N	104936	0	228557008	4043071	
6677	610	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	40582	0	180256009	4107731	
18705	1602	4125906	1971-04-10	1971-04-10 00:00:00	38000275	0	\N	\N	107520	0	288086009	4125906	
7077	655	4275113	1977-11-20	1977-11-20 00:00:00	38000275	0	\N	\N	43418	0	65200003	4275113	
7276	675	4125906	1959-10-15	1959-10-15 00:00:00	38000275	0	\N	\N	44596	0	288086009	4125906	
7405	685	4043071	1975-06-24	1975-06-24 00:00:00	38000275	0	\N	\N	45314	0	228557008	4043071	
7596	704	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	46619	0	180256009	4107731	
7829	718	4107731	1991-05-04	1991-05-04 00:00:00	38000275	0	\N	\N	47504	0	180256009	4107731	
19836	1716	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	114608	0	180256009	4107731	
8160	747	4125906	2003-07-14	2003-07-14 00:00:00	38000275	0	\N	\N	49477	0	288086009	4125906	
8335	760	4170947	1977-06-20	1977-06-20 00:00:00	38000275	0	\N	\N	50508	0	274474001	4170947	
20519	1773	4107731	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	118634	0	180256009	4107731	
20713	1783	4107731	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	119556	0	180256009	4107731	
32749	2871	4043071	1961-12-14	1961-12-14 00:00:00	38000275	0	\N	\N	191116	0	228557008	4043071	
9148	842	4035793	1992-06-13	1992-06-13 00:00:00	38000275	0	\N	\N	55670	0	15081005	4035793	
9270	844	4151422	1966-11-20	1966-11-20 00:00:00	38000275	0	\N	\N	55935	0	269911007	4151422	
9525	867	4195803	1998-09-29	1998-09-29 00:00:00	38000275	0	\N	\N	57582	0	312681000	4195803	
33543	2925	4107731	1991-04-08	1991-04-08 00:00:00	38000275	0	\N	\N	195032	0	180256009	4107731	
9845	884	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	58900	0	180256009	4107731	
21982	1915	4058899	1991-07-09	1991-07-09 00:00:00	38000275	0	\N	\N	127404	0	168594001	4058899	
22103	1923	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	127941	0	180256009	4107731	
10401	929	4336464	2005-10-10	2005-10-10 00:00:00	38000275	0	\N	\N	61759	0	232717009	4336464	
10639	959	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	63712	0	395142003	4191853	
22682	1977	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	131595	0	180256009	4107731	
22872	1992	4107731	1991-12-01	1991-12-01 00:00:00	38000275	0	\N	\N	132652	0	180256009	4107731	
23108	2012	4252419	1978-02-25	1978-02-25 00:00:00	38000275	0	\N	\N	133865	0	74016001	4252419	
11397	1058	4107731	1991-07-27	1991-07-27 00:00:00	38000275	0	\N	\N	69364	0	180256009	4107731	
23486	2054	4047491	2019-06-26	2019-06-26 00:00:00	38000275	0	\N	\N	136591	0	1225002	4047491	
11710	1082	4107731	1990-01-27	1990-01-27 00:00:00	38000275	0	\N	\N	70910	0	180256009	4107731	
23751	2070	4107731	1990-12-03	1990-12-03 00:00:00	38000275	0	\N	\N	137687	0	180256009	4107731	
109	5	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	449	0	180256009	4107731	
301	19	4078793	2016-10-02	2016-10-02 00:00:00	38000275	0	\N	\N	1520	0	180325003	4078793	
12356	1110	4107731	1996-01-08	1996-01-08 00:00:00	38000275	0	\N	\N	73032	0	180256009	4107731	
12593	1138	4170947	2018-03-17	2018-03-17 00:00:00	38000275	0	\N	\N	75132	0	274474001	4170947	
12858	1155	4010253	2011-04-01	2011-04-01 00:00:00	38000275	0	\N	\N	76390	0	112790001	4010253	
12946	1174	44783196	1963-03-02	1963-03-02 00:00:00	38000275	0	\N	\N	77329	0	699253003	44783196	
13107	1185	4151422	1946-04-13	1946-04-13 00:00:00	38000275	0	\N	\N	78087	0	269911007	4151422	
13288	1211	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	79618	0	180256009	4107731	
13556	1227	4043071	1947-01-03	1947-01-03 00:00:00	38000275	0	\N	\N	80776	0	228557008	4043071	
1794	164	4151422	1986-07-27	1986-07-27 00:00:00	38000275	0	\N	\N	11287	0	269911007	4151422	
1989	184	4293740	2017-10-03	2017-10-03 00:00:00	38000275	0	\N	\N	12505	0	384700001	4293740	
2202	225	4151422	2010-08-28	2010-08-28 00:00:00	38000275	0	\N	\N	15184	0	269911007	4151422	
14218	1276	4170947	2010-08-11	2010-08-11 00:00:00	38000275	0	\N	\N	84135	0	274474001	4170947	
2576	263	4078793	2016-08-28	2016-08-28 00:00:00	38000275	0	\N	\N	17499	0	180325003	4078793	
14718	1310	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	86612	0	180256009	4107731	
2940	285	4107731	1992-12-28	1992-12-28 00:00:00	38000275	0	\N	\N	18997	0	180256009	4107731	
14998	1328	4035793	1999-08-19	1999-08-19 00:00:00	38000275	0	\N	\N	88168	0	15081005	4035793	
3356	332	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	21986	0	180256009	4107731	
3540	343	4107731	1990-01-27	1990-01-27 00:00:00	38000275	0	\N	\N	22901	0	180256009	4107731	
3665	354	4035793	2009-01-22	2009-01-22 00:00:00	38000275	0	\N	\N	23577	0	15081005	4035793	
3913	399	4107731	1992-11-22	1992-11-22 00:00:00	38000275	0	\N	\N	26246	0	180256009	4107731	
4038	404	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	26597	0	180256009	4107731	
4228	409	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	27100	0	180256009	4107731	
16438	1431	4107731	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	95265	0	180256009	4107731	
4671	442	4191853	1980-09-11	1980-09-11 00:00:00	38000275	0	\N	\N	29313	0	395142003	4191853	
4862	453	4043071	1982-03-09	1982-03-09 00:00:00	38000275	0	\N	\N	30170	0	228557008	4043071	
5027	469	4043071	1947-06-23	1947-06-23 00:00:00	38000275	0	\N	\N	31237	0	228557008	4043071	
5177	480	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	32074	0	180256009	4107731	
5414	499	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	33297	0	180256009	4107731	
5538	505	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	33858	0	180256009	4107731	
17599	1513	4107731	1992-04-26	1992-04-26 00:00:00	38000275	0	\N	\N	101042	0	180256009	4107731	
5930	545	4107731	1990-09-15	1990-09-15 00:00:00	38000275	0	\N	\N	36054	0	180256009	4107731	
17955	1538	4107731	1993-03-01	1993-03-01 00:00:00	38000275	0	\N	\N	103031	0	180256009	4107731	
18227	1556	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	104179	0	180256009	4107731	
18430	1565	4043071	1974-06-10	1974-06-10 00:00:00	38000275	0	\N	\N	104939	0	228557008	4043071	
6678	610	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	40519	0	180256009	4107731	
18706	1602	4024289	2001-06-20	2001-06-20 00:00:00	38000275	0	\N	\N	107524	0	19490002	4024289	
7078	655	4202451	2013-03-30	2013-03-30 00:00:00	38000275	0	\N	\N	43409	0	433112001	4202451	
7288	677	4125906	2016-11-11	2016-11-11 00:00:00	38000275	0	\N	\N	44813	0	288086009	4125906	
7406	685	4043071	1976-02-17	1976-02-17 00:00:00	38000275	0	\N	\N	45353	0	228557008	4043071	
7597	704	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	46590	0	180256009	4107731	
7830	718	4107731	1992-01-11	1992-01-11 00:00:00	38000275	0	\N	\N	47481	0	180256009	4107731	
19837	1716	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	114632	0	395142003	4191853	
8169	752	4057420	1979-02-04	1979-02-04 00:00:00	38000275	0	\N	\N	49640	0	18286008	4057420	
8336	760	4024289	1977-06-20	1977-06-20 00:00:00	38000275	0	\N	\N	50508	0	19490002	4024289	
20520	1773	4107731	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	118637	0	180256009	4107731	
20714	1783	4107731	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	119474	0	180256009	4107731	
32750	2871	4043071	1961-09-21	1961-09-21 00:00:00	38000275	0	\N	\N	191065	0	228557008	4043071	
9149	842	4035793	2014-10-18	2014-10-18 00:00:00	38000275	0	\N	\N	55703	0	15081005	4035793	
9271	844	4107731	1990-02-17	1990-02-17 00:00:00	38000275	0	\N	\N	55954	0	180256009	4107731	
9526	867	4170947	2002-06-10	2002-06-10 00:00:00	38000275	0	\N	\N	57583	0	274474001	4170947	
33544	2925	4107731	1991-02-03	1991-02-03 00:00:00	38000275	0	\N	\N	195062	0	180256009	4107731	
9846	884	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	58946	0	180256009	4107731	
21983	1915	4330583	2012-03-02	2012-03-02 00:00:00	38000275	0	\N	\N	127358	0	22523008	4330583	
22104	1923	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	128016	0	180256009	4107731	
10407	931	4151422	1965-12-20	1965-12-20 00:00:00	38000275	0	\N	\N	61926	0	269911007	4151422	
10640	959	4125906	1969-05-27	1969-05-27 00:00:00	38000275	0	\N	\N	63782	0	288086009	4125906	
22683	1977	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	131542	0	180256009	4107731	
22873	1992	4107731	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	132719	0	180256009	4107731	
23109	2012	4151422	1957-08-31	1957-08-31 00:00:00	38000275	0	\N	\N	133896	0	269911007	4151422	
11398	1058	4151422	1986-10-07	1986-10-07 00:00:00	38000275	0	\N	\N	69383	0	269911007	4151422	
23487	2054	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	136592	0	180256009	4107731	
11711	1082	4107731	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	70924	0	180256009	4107731	
23752	2070	4107731	1991-04-08	1991-04-08 00:00:00	38000275	0	\N	\N	137709	0	180256009	4107731	
110	5	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	518	0	180256009	4107731	
302	19	4078793	2014-09-21	2014-09-21 00:00:00	38000275	0	\N	\N	1519	0	180325003	4078793	
12357	1110	4197460	1983-04-09	1983-04-09 00:00:00	38000275	0	\N	\N	73118	0	313191000	4197460	
12594	1138	4043071	1998-02-26	1998-02-26 00:00:00	38000275	0	\N	\N	75117	0	228557008	4043071	
12859	1155	4195803	1981-03-04	1981-03-04 00:00:00	38000275	0	\N	\N	76312	0	312681000	4195803	
12947	1175	4107731	1992-09-13	1992-09-13 00:00:00	38000275	0	\N	\N	77507	0	180256009	4107731	
13108	1185	4195803	1997-01-05	1997-01-05 00:00:00	38000275	0	\N	\N	78100	0	312681000	4195803	
13289	1211	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	79601	0	180256009	4107731	
13557	1227	4125906	1949-05-24	1949-05-24 00:00:00	38000275	0	\N	\N	80817	0	288086009	4125906	
1795	165	4252419	2013-04-15	2013-04-15 00:00:00	38000275	0	\N	\N	11329	0	74016001	4252419	
1990	185	4125906	1982-05-03	1982-05-03 00:00:00	38000275	0	\N	\N	12520	0	288086009	4125906	
2203	225	4125906	2016-12-01	2016-12-01 00:00:00	38000275	0	\N	\N	15146	0	288086009	4125906	
14219	1276	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	84261	0	180256009	4107731	
2577	264	4216130	2011-11-11	2011-11-11 00:00:00	38000275	0	\N	\N	17590	0	415070008	4216130	
14719	1310	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	86620	0	180256009	4107731	
2941	285	4107731	1991-02-04	1991-02-04 00:00:00	38000275	0	\N	\N	18945	0	180256009	4107731	
14999	1328	4125906	1969-04-19	1969-04-19 00:00:00	38000275	0	\N	\N	88209	0	288086009	4125906	
3357	332	4163872	1972-08-25	1972-08-25 00:00:00	38000275	0	\N	\N	21905	0	399208008	4163872	
3541	343	4107731	1993-04-17	1993-04-17 00:00:00	38000275	0	\N	\N	22885	0	180256009	4107731	
3666	354	4035793	2011-02-03	2011-02-03 00:00:00	38000275	0	\N	\N	23578	0	15081005	4035793	
3914	399	4107731	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	26245	0	180256009	4107731	
4039	404	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	26579	0	180256009	4107731	
4229	409	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	27043	0	180256009	4107731	
16439	1431	4107731	1991-03-23	1991-03-23 00:00:00	38000275	0	\N	\N	95293	0	180256009	4107731	
4672	442	4107731	1991-09-07	1991-09-07 00:00:00	38000275	0	\N	\N	29407	0	180256009	4107731	
16644	1442	4195803	2012-09-07	2012-09-07 00:00:00	38000275	0	\N	\N	96188	0	312681000	4195803	
5028	469	4043071	1949-02-28	1949-02-28 00:00:00	38000275	0	\N	\N	31285	0	228557008	4043071	
5178	480	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	31977	0	180256009	4107731	
5415	499	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	33433	0	180256009	4107731	
5539	505	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	33868	0	180256009	4107731	
17600	1513	4043071	1979-06-21	1979-06-21 00:00:00	38000275	0	\N	\N	101130	0	228557008	4043071	
5931	545	4107731	1990-06-23	1990-06-23 00:00:00	38000275	0	\N	\N	36137	0	180256009	4107731	
17956	1538	4107731	1990-08-20	1990-08-20 00:00:00	38000275	0	\N	\N	102932	0	180256009	4107731	
18228	1556	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	104260	0	180256009	4107731	
18431	1565	4043071	1974-02-25	1974-02-25 00:00:00	38000275	0	\N	\N	104933	0	228557008	4043071	
6679	610	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	40603	0	180256009	4107731	
18707	1602	4170947	2001-06-20	2001-06-20 00:00:00	38000275	0	\N	\N	107524	0	274474001	4170947	
7079	656	4043071	1971-04-17	1971-04-17 00:00:00	38000275	0	\N	\N	43460	0	228557008	4043071	
7289	677	4125906	1982-01-23	1982-01-23 00:00:00	38000275	0	\N	\N	44812	0	288086009	4125906	
7407	685	4043071	1975-07-22	1975-07-22 00:00:00	38000275	0	\N	\N	45317	0	228557008	4043071	
7598	704	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	46519	0	180256009	4107731	
7831	718	4107731	1990-10-06	1990-10-06 00:00:00	38000275	0	\N	\N	47494	0	180256009	4107731	
19838	1716	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	114771	0	180256009	4107731	
8170	752	40492359	1979-02-04	1979-02-04 00:00:00	38000275	0	\N	\N	49640	0	447365002	40492359	
8337	760	4151422	1966-11-16	1966-11-16 00:00:00	38000275	0	\N	\N	50495	0	269911007	4151422	
20521	1773	4107731	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	118580	0	180256009	4107731	
20715	1783	4107731	1990-06-18	1990-06-18 00:00:00	38000275	0	\N	\N	119547	0	180256009	4107731	
32751	2871	4043071	1962-05-03	1962-05-03 00:00:00	38000275	0	\N	\N	191077	0	228557008	4043071	
9150	842	4035793	1988-05-21	1988-05-21 00:00:00	38000275	0	\N	\N	55668	0	15081005	4035793	
9272	844	4107731	1990-07-14	1990-07-14 00:00:00	38000275	0	\N	\N	55992	0	180256009	4107731	
9527	867	4243062	2002-06-10	2002-06-10 00:00:00	38000275	0	\N	\N	57583	0	60027007	4243062	
33545	2925	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	195099	0	180256009	4107731	
9847	884	4107731	1993-07-27	1993-07-27 00:00:00	38000275	0	\N	\N	58861	0	180256009	4107731	
21984	1915	4043071	1983-09-15	1983-09-15 00:00:00	38000275	0	\N	\N	127374	0	228557008	4043071	
22105	1923	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	127889	0	180256009	4107731	
10408	931	4125906	1978-10-13	1978-10-13 00:00:00	38000275	0	\N	\N	61961	0	288086009	4125906	
10641	959	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	63763	0	180256009	4107731	
22684	1977	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	131616	0	180256009	4107731	
22874	1992	4107731	1991-10-20	1991-10-20 00:00:00	38000275	0	\N	\N	132693	0	180256009	4107731	
23110	2012	4125906	2006-06-05	2006-06-05 00:00:00	38000275	0	\N	\N	133869	0	288086009	4125906	
11399	1058	4107731	1992-08-29	1992-08-29 00:00:00	38000275	0	\N	\N	69422	0	180256009	4107731	
23488	2054	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	136690	0	180256009	4107731	
11712	1082	4107731	1992-12-12	1992-12-12 00:00:00	38000275	0	\N	\N	70957	0	180256009	4107731	
23753	2070	4107731	1991-11-25	1991-11-25 00:00:00	38000275	0	\N	\N	137692	0	180256009	4107731	
111	5	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	414	0	180256009	4107731	
303	19	4057420	2018-05-27	2018-05-27 00:00:00	38000275	0	\N	\N	1481	0	18286008	4057420	
12358	1110	4107731	1995-07-24	1995-07-24 00:00:00	38000275	0	\N	\N	73103	0	180256009	4107731	
12595	1138	4043071	1995-08-10	1995-08-10 00:00:00	38000275	0	\N	\N	75057	0	228557008	4043071	
12860	1155	4243062	1981-03-04	1981-03-04 00:00:00	38000275	0	\N	\N	76312	0	60027007	4243062	
12948	1175	4107731	1992-12-27	1992-12-27 00:00:00	38000275	0	\N	\N	77526	0	180256009	4107731	
13109	1185	4170947	2008-02-11	2008-02-11 00:00:00	38000275	0	\N	\N	78150	0	274474001	4170947	
13290	1211	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	79599	0	180256009	4107731	
13558	1227	4078793	2018-04-18	2018-04-18 00:00:00	38000275	0	\N	\N	80767	0	180325003	4078793	
1796	165	4151422	1992-09-23	1992-09-23 00:00:00	38000275	0	\N	\N	11313	0	269911007	4151422	
1991	185	4170947	1958-08-07	1958-08-07 00:00:00	38000275	0	\N	\N	12506	0	274474001	4170947	
2204	225	4107731	1993-01-18	1993-01-18 00:00:00	38000275	0	\N	\N	15170	0	180256009	4107731	
14220	1276	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	84257	0	180256009	4107731	
2578	264	4336464	2011-11-11	2011-11-11 00:00:00	38000275	0	\N	\N	17590	0	232717009	4336464	
14720	1310	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	86636	0	180256009	4107731	
2942	285	4107731	1993-03-01	1993-03-01 00:00:00	38000275	0	\N	\N	18925	0	180256009	4107731	
15000	1328	4293740	1969-04-19	1969-04-19 00:00:00	38000275	0	\N	\N	88209	0	384700001	4293740	
3358	332	4170947	1972-08-25	1972-08-25 00:00:00	38000275	0	\N	\N	21905	0	274474001	4170947	
3542	343	4107731	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	22882	0	180256009	4107731	
3667	354	4035793	2008-01-17	2008-01-17 00:00:00	38000275	0	\N	\N	23589	0	15081005	4035793	
3915	399	4107731	1990-09-16	1990-09-16 00:00:00	38000275	0	\N	\N	26178	0	180256009	4107731	
4040	404	4043071	1971-01-15	1971-01-15 00:00:00	38000275	0	\N	\N	26630	0	228557008	4043071	
4230	409	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	27006	0	180256009	4107731	
16440	1431	4107731	1991-12-21	1991-12-21 00:00:00	38000275	0	\N	\N	95281	0	180256009	4107731	
4673	442	4107731	1993-05-29	1993-05-29 00:00:00	38000275	0	\N	\N	29415	0	180256009	4107731	
16645	1442	4170947	2004-12-18	2004-12-18 00:00:00	38000275	0	\N	\N	96187	0	274474001	4170947	
5029	469	4043071	1945-10-29	1945-10-29 00:00:00	38000275	0	\N	\N	31336	0	228557008	4043071	
5179	480	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	32073	0	180256009	4107731	
5416	499	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	33457	0	180256009	4107731	
5540	505	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	33739	0	395142003	4191853	
17601	1513	4107731	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	101041	0	180256009	4107731	
5932	545	4107731	1990-08-04	1990-08-04 00:00:00	38000275	0	\N	\N	36138	0	180256009	4107731	
17957	1538	4107731	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	102957	0	180256009	4107731	
18229	1556	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	104265	0	180256009	4107731	
18432	1565	4043071	1973-04-16	1973-04-16 00:00:00	38000275	0	\N	\N	104930	0	228557008	4043071	
6680	610	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	40487	0	180256009	4107731	
18708	1602	4125906	1995-09-15	1995-09-15 00:00:00	38000275	0	\N	\N	107522	0	288086009	4125906	
7080	656	4043071	1971-05-22	1971-05-22 00:00:00	38000275	0	\N	\N	43471	0	228557008	4043071	
7291	679	4151422	2007-11-01	2007-11-01 00:00:00	38000275	0	\N	\N	44956	0	269911007	4151422	
7408	685	4043071	1976-11-02	1976-11-02 00:00:00	38000275	0	\N	\N	45270	0	228557008	4043071	
7599	704	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	46625	0	180256009	4107731	
7832	718	4107731	1990-07-14	1990-07-14 00:00:00	38000275	0	\N	\N	47492	0	180256009	4107731	
19839	1716	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	114748	0	180256009	4107731	
8171	752	4125906	2000-01-22	2000-01-22 00:00:00	38000275	0	\N	\N	49642	0	288086009	4125906	
8338	760	4186930	1983-11-23	1983-11-23 00:00:00	38000275	0	\N	\N	50503	0	46706006	4186930	
20522	1773	4107731	1993-04-18	1993-04-18 00:00:00	38000275	0	\N	\N	118603	0	180256009	4107731	
20716	1783	4107731	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	119383	0	180256009	4107731	
32752	2871	4043071	1961-06-22	1961-06-22 00:00:00	38000275	0	\N	\N	191074	0	228557008	4043071	
9151	842	4035793	2000-07-29	2000-07-29 00:00:00	38000275	0	\N	\N	55680	0	15081005	4035793	
9273	844	4107731	1991-09-07	1991-09-07 00:00:00	38000275	0	\N	\N	55977	0	180256009	4107731	
9528	867	4195803	2002-06-10	2002-06-10 00:00:00	38000275	0	\N	\N	57583	0	312681000	4195803	
33546	2925	4252419	2015-03-12	2015-03-12 00:00:00	38000275	0	\N	\N	195026	0	74016001	4252419	
9848	884	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	58859	0	180256009	4107731	
21985	1915	4125906	2018-09-13	2018-09-13 00:00:00	38000275	0	\N	\N	127407	0	288086009	4125906	
22106	1924	4078793	2019-06-28	2019-06-28 00:00:00	38000275	0	\N	\N	128060	0	180325003	4078793	
10409	931	4125906	1964-05-28	1964-05-28 00:00:00	38000275	0	\N	\N	61957	0	288086009	4125906	
10642	959	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	63786	0	180256009	4107731	
22685	1977	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	131597	0	180256009	4107731	
22875	1992	4107731	1991-08-18	1991-08-18 00:00:00	38000275	0	\N	\N	132675	0	180256009	4107731	
23111	2012	4293740	2006-06-05	2006-06-05 00:00:00	38000275	0	\N	\N	133869	0	384700001	4293740	
11400	1058	4107731	1991-05-25	1991-05-25 00:00:00	38000275	0	\N	\N	69436	0	180256009	4107731	
23489	2054	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	136651	0	180256009	4107731	
11713	1082	4107731	1990-12-08	1990-12-08 00:00:00	38000275	0	\N	\N	70914	0	180256009	4107731	
23754	2070	4107731	1992-07-13	1992-07-13 00:00:00	38000275	0	\N	\N	137694	0	180256009	4107731	
112	5	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	436	0	180256009	4107731	
304	19	4078793	2018-08-19	2018-08-19 00:00:00	38000275	0	\N	\N	1537	0	180325003	4078793	
12359	1110	4107731	1995-10-16	1995-10-16 00:00:00	38000275	0	\N	\N	73030	0	180256009	4107731	
12596	1138	4043071	1996-01-11	1996-01-11 00:00:00	38000275	0	\N	\N	74991	0	228557008	4043071	
12861	1155	4170947	1981-03-04	1981-03-04 00:00:00	38000275	0	\N	\N	76312	0	274474001	4170947	
12949	1175	4107731	1992-08-23	1992-08-23 00:00:00	38000275	0	\N	\N	77534	0	180256009	4107731	
13110	1185	4047491	2008-02-11	2008-02-11 00:00:00	38000275	0	\N	\N	78150	0	1225002	4047491	
13291	1211	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	79621	0	180256009	4107731	
13559	1227	4043071	1946-09-20	1946-09-20 00:00:00	38000275	0	\N	\N	80799	0	228557008	4043071	
1797	165	4125906	1974-02-11	1974-02-11 00:00:00	38000275	0	\N	\N	11327	0	288086009	4125906	
1992	185	4243062	1958-08-07	1958-08-07 00:00:00	38000275	0	\N	\N	12506	0	60027007	4243062	
2205	225	4191853	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	15183	0	395142003	4191853	
14221	1276	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	84147	0	180256009	4107731	
2579	264	4252419	1969-10-18	1969-10-18 00:00:00	38000275	0	\N	\N	17534	0	74016001	4252419	
14721	1310	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	86641	0	180256009	4107731	
2943	285	4107731	1991-11-25	1991-11-25 00:00:00	38000275	0	\N	\N	18976	0	180256009	4107731	
15001	1328	4035793	2009-03-05	2009-03-05 00:00:00	38000275	0	\N	\N	88172	0	15081005	4035793	
3359	332	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	21932	0	180256009	4107731	
3543	343	4107731	1990-03-31	1990-03-31 00:00:00	38000275	0	\N	\N	22942	0	180256009	4107731	
3668	354	4035793	2018-03-15	2018-03-15 00:00:00	38000275	0	\N	\N	23579	0	15081005	4035793	
3916	399	4107731	1991-10-20	1991-10-20 00:00:00	38000275	0	\N	\N	26206	0	180256009	4107731	
4041	404	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	26601	0	180256009	4107731	
4231	409	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	27147	0	180256009	4107731	
16441	1431	4107731	1991-09-07	1991-09-07 00:00:00	38000275	0	\N	\N	95332	0	180256009	4107731	
4674	442	4107731	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	29364	0	180256009	4107731	
16646	1442	4047491	2004-12-18	2004-12-18 00:00:00	38000275	0	\N	\N	96187	0	1225002	4047491	
5030	469	4043071	1948-12-27	1948-12-27 00:00:00	38000275	0	\N	\N	31362	0	228557008	4043071	
5180	480	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	31980	0	180256009	4107731	
5417	499	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	33426	0	180256009	4107731	
5541	505	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	33867	0	180256009	4107731	
17602	1513	4107731	1991-03-03	1991-03-03 00:00:00	38000275	0	\N	\N	101036	0	180256009	4107731	
5933	545	4107731	1990-02-17	1990-02-17 00:00:00	38000275	0	\N	\N	36042	0	180256009	4107731	
17958	1538	4107731	1990-12-03	1990-12-03 00:00:00	38000275	0	\N	\N	103059	0	180256009	4107731	
18230	1556	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	104246	0	180256009	4107731	
18433	1565	4043071	1973-07-23	1973-07-23 00:00:00	38000275	0	\N	\N	104967	0	228557008	4043071	
6681	610	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	40529	0	180256009	4107731	
18709	1602	4170947	1972-03-19	1972-03-19 00:00:00	38000275	0	\N	\N	107521	0	274474001	4170947	
7081	656	4043071	1971-06-26	1971-06-26 00:00:00	38000275	0	\N	\N	43472	0	228557008	4043071	
7292	680	4191853	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	45008	0	395142003	4191853	
7409	685	4043071	1975-11-18	1975-11-18 00:00:00	38000275	0	\N	\N	45318	0	228557008	4043071	
7600	704	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	46563	0	180256009	4107731	
7833	718	4107731	1991-12-21	1991-12-21 00:00:00	38000275	0	\N	\N	47470	0	180256009	4107731	
19840	1716	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	114681	0	180256009	4107731	
8172	752	4058899	1951-10-15	1951-10-15 00:00:00	38000275	0	\N	\N	49639	0	168594001	4058899	
8339	761	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	50631	0	180256009	4107731	
20523	1773	4107731	1992-11-01	1992-11-01 00:00:00	38000275	0	\N	\N	118636	0	180256009	4107731	
20717	1783	4107731	1990-12-03	1990-12-03 00:00:00	38000275	0	\N	\N	119473	0	180256009	4107731	
32753	2871	4043071	1962-08-30	1962-08-30 00:00:00	38000275	0	\N	\N	191078	0	228557008	4043071	
9152	842	4035793	2012-10-06	2012-10-06 00:00:00	38000275	0	\N	\N	55701	0	15081005	4035793	
9274	844	4107731	1992-04-04	1992-04-04 00:00:00	38000275	0	\N	\N	55961	0	180256009	4107731	
9529	867	4058899	2005-04-25	2005-04-25 00:00:00	38000275	0	\N	\N	57584	0	168594001	4058899	
33547	2925	4107731	1992-12-27	1992-12-27 00:00:00	38000275	0	\N	\N	195129	0	180256009	4107731	
9849	884	4252419	1981-08-16	1981-08-16 00:00:00	38000275	0	\N	\N	58927	0	74016001	4252419	
21986	1915	4293740	1989-06-28	1989-06-28 00:00:00	38000275	0	\N	\N	127403	0	384700001	4293740	
22107	1924	4170947	1978-08-26	1978-08-26 00:00:00	38000275	0	\N	\N	128069	0	274474001	4170947	
10410	931	4125906	1965-05-07	1965-05-07 00:00:00	38000275	0	\N	\N	61958	0	288086009	4125906	
10643	959	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	63678	0	180256009	4107731	
22686	1977	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	131634	0	180256009	4107731	
22876	1992	4191853	1978-04-17	1978-04-17 00:00:00	38000275	0	\N	\N	132718	0	395142003	4191853	
23112	2012	44783196	1978-03-04	1978-03-04 00:00:00	38000275	0	\N	\N	133925	0	699253003	44783196	
11401	1058	4107731	1993-05-08	1993-05-08 00:00:00	38000275	0	\N	\N	69453	0	180256009	4107731	
23490	2056	4024289	1982-01-10	1982-01-10 00:00:00	38000275	0	\N	\N	136715	0	19490002	4024289	
11714	1082	4107731	1990-05-12	1990-05-12 00:00:00	38000275	0	\N	\N	70998	0	180256009	4107731	
23755	2070	4107731	1991-04-29	1991-04-29 00:00:00	38000275	0	\N	\N	137749	0	180256009	4107731	
113	5	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	520	0	180256009	4107731	
305	19	4238715	1980-01-27	1980-01-27 00:00:00	38000275	0	\N	\N	1533	0	68254000	4238715	
12360	1110	4107731	1996-06-03	1996-06-03 00:00:00	38000275	0	\N	\N	73107	0	180256009	4107731	
12597	1138	4107731	1995-01-19	1995-01-19 00:00:00	38000275	0	\N	\N	75015	0	180256009	4107731	
12862	1155	4151422	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	76387	0	269911007	4151422	
12950	1175	4107731	1990-01-21	1990-01-21 00:00:00	38000275	0	\N	\N	77550	0	180256009	4107731	
13111	1185	4202451	1981-02-22	1981-02-22 00:00:00	38000275	0	\N	\N	78104	0	433112001	4202451	
13292	1211	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	79503	0	180256009	4107731	
13560	1227	4043071	1947-09-19	1947-09-19 00:00:00	38000275	0	\N	\N	80842	0	228557008	4043071	
1798	165	4125906	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	11328	0	288086009	4125906	
1993	185	4151422	1977-04-30	1977-04-30 00:00:00	38000275	0	\N	\N	12525	0	269911007	4151422	
2206	225	4107731	1990-08-20	1990-08-20 00:00:00	38000275	0	\N	\N	15179	0	180256009	4107731	
14222	1276	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	84190	0	180256009	4107731	
2580	264	4151422	1978-06-15	1978-06-15 00:00:00	38000275	0	\N	\N	17514	0	269911007	4151422	
14722	1310	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	86589	0	180256009	4107731	
2944	285	4107731	1993-02-08	1993-02-08 00:00:00	38000275	0	\N	\N	18998	0	180256009	4107731	
15002	1328	4252419	1976-02-26	1976-02-26 00:00:00	38000275	0	\N	\N	88210	0	74016001	4252419	
3360	332	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	22043	0	180256009	4107731	
3544	343	4107731	1992-04-25	1992-04-25 00:00:00	38000275	0	\N	\N	22880	0	180256009	4107731	
3669	354	4035793	2014-02-20	2014-02-20 00:00:00	38000275	0	\N	\N	23568	0	15081005	4035793	
3917	399	4107731	1992-11-01	1992-11-01 00:00:00	38000275	0	\N	\N	26120	0	180256009	4107731	
4042	404	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	26681	0	180256009	4107731	
4232	409	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	27103	0	180256009	4107731	
16442	1431	4107731	1990-03-31	1990-03-31 00:00:00	38000275	0	\N	\N	95288	0	180256009	4107731	
4675	442	4107731	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	29267	0	180256009	4107731	
16647	1442	4195803	2004-12-18	2004-12-18 00:00:00	38000275	0	\N	\N	96187	0	312681000	4195803	
5031	469	4043071	1949-09-05	1949-09-05 00:00:00	38000275	0	\N	\N	31239	0	228557008	4043071	
5181	480	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	32053	0	180256009	4107731	
5418	499	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	33424	0	180256009	4107731	
5542	505	4107731	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	33819	0	180256009	4107731	
17603	1513	4107731	1993-03-28	1993-03-28 00:00:00	38000275	0	\N	\N	101105	0	180256009	4107731	
5934	545	4107731	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	36031	0	180256009	4107731	
17959	1538	4078793	2010-05-10	2010-05-10 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
18231	1556	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	104198	0	180256009	4107731	
18434	1565	4043071	1973-10-15	1973-10-15 00:00:00	38000275	0	\N	\N	104915	0	228557008	4043071	
6682	610	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	40530	0	180256009	4107731	
18710	1602	4243062	1972-03-19	1972-03-19 00:00:00	38000275	0	\N	\N	107521	0	60027007	4243062	
7082	656	4125906	2012-05-24	2012-05-24 00:00:00	38000275	0	\N	\N	43427	0	288086009	4125906	
7293	680	4107731	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	45081	0	180256009	4107731	
7410	685	4043071	1975-05-27	1975-05-27 00:00:00	38000275	0	\N	\N	45292	0	228557008	4043071	
7601	704	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	46580	0	180256009	4107731	
7834	718	4107731	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	47455	0	180256009	4107731	
19841	1716	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	114647	0	180256009	4107731	
8173	752	4151422	2014-02-27	2014-02-27 00:00:00	38000275	0	\N	\N	49643	0	269911007	4151422	
8340	761	4191853	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	50594	0	395142003	4191853	
20524	1773	4107731	1991-11-10	1991-11-10 00:00:00	38000275	0	\N	\N	118505	0	180256009	4107731	
20718	1783	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	119388	0	180256009	4107731	
32754	2871	4043071	1963-08-01	1963-08-01 00:00:00	38000275	0	\N	\N	191099	0	228557008	4043071	
9153	842	4035793	1999-07-24	1999-07-24 00:00:00	38000275	0	\N	\N	55698	0	15081005	4035793	
9275	844	4107731	1993-04-17	1993-04-17 00:00:00	38000275	0	\N	\N	55917	0	180256009	4107731	
9530	867	4195803	2005-04-25	2005-04-25 00:00:00	38000275	0	\N	\N	57584	0	312681000	4195803	
33548	2925	4107731	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	195116	0	180256009	4107731	
9850	884	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	58843	0	180256009	4107731	
21987	1915	4125906	1989-06-28	1989-06-28 00:00:00	38000275	0	\N	\N	127403	0	288086009	4125906	
22108	1924	4243062	1978-08-26	1978-08-26 00:00:00	38000275	0	\N	\N	128069	0	60027007	4243062	
10411	931	4151422	2009-07-26	2009-07-26 00:00:00	38000275	0	\N	\N	61947	0	269911007	4151422	
10644	959	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	63676	0	180256009	4107731	
22687	1977	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	131579	0	180256009	4107731	
22877	1992	4107731	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	132671	0	180256009	4107731	
23113	2013	4125906	1971-12-22	1971-12-22 00:00:00	38000275	0	\N	\N	134002	0	288086009	4125906	
11402	1058	4107731	1992-04-04	1992-04-04 00:00:00	38000275	0	\N	\N	69440	0	180256009	4107731	
23491	2056	4170947	1982-01-10	1982-01-10 00:00:00	38000275	0	\N	\N	136715	0	274474001	4170947	
11715	1082	4107731	1991-10-19	1991-10-19 00:00:00	38000275	0	\N	\N	70991	0	180256009	4107731	
23756	2070	4107731	1991-07-22	1991-07-22 00:00:00	38000275	0	\N	\N	137756	0	180256009	4107731	
114	5	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	453	0	180256009	4107731	
306	19	4078793	2012-04-15	2012-04-15 00:00:00	38000275	0	\N	\N	1479	0	180325003	4078793	
12361	1110	4107731	1998-05-18	1998-05-18 00:00:00	38000275	0	\N	\N	73069	0	180256009	4107731	
12598	1138	4107731	1994-10-27	1994-10-27 00:00:00	38000275	0	\N	\N	75077	0	180256009	4107731	
12863	1155	4151422	1974-02-19	1974-02-19 00:00:00	38000275	0	\N	\N	76325	0	269911007	4151422	
12951	1175	4043071	1953-08-22	1953-08-22 00:00:00	38000275	0	\N	\N	77414	0	228557008	4043071	
13112	1185	4202451	2018-09-23	2018-09-23 00:00:00	38000275	0	\N	\N	78151	0	433112001	4202451	
13293	1211	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	79499	0	180256009	4107731	
13561	1227	4043071	1946-10-25	1946-10-25 00:00:00	38000275	0	\N	\N	80800	0	228557008	4043071	
1806	170	4125906	1994-06-03	1994-06-03 00:00:00	38000275	0	\N	\N	11580	0	288086009	4125906	
1994	186	4163872	1991-01-11	1991-01-11 00:00:00	38000275	0	\N	\N	12637	0	399208008	4163872	
2207	225	4107731	1991-08-12	1991-08-12 00:00:00	38000275	0	\N	\N	15189	0	180256009	4107731	
14223	1276	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	84164	0	180256009	4107731	
2581	264	44783196	1969-10-25	1969-10-25 00:00:00	38000275	0	\N	\N	17537	0	699253003	44783196	
14723	1310	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	86688	0	180256009	4107731	
2945	285	4107731	1992-12-07	1992-12-07 00:00:00	38000275	0	\N	\N	18923	0	180256009	4107731	
15003	1328	4035793	2000-08-24	2000-08-24 00:00:00	38000275	0	\N	\N	88186	0	15081005	4035793	
3361	332	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	21931	0	180256009	4107731	
3545	343	4107731	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	22890	0	180256009	4107731	
3670	354	4035793	2019-03-21	2019-03-21 00:00:00	38000275	0	\N	\N	23524	0	15081005	4035793	
3918	399	4107731	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	26179	0	180256009	4107731	
4043	404	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	26638	0	180256009	4107731	
4233	409	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	27098	0	180256009	4107731	
16443	1431	4107731	1993-01-23	1993-01-23 00:00:00	38000275	0	\N	\N	95337	0	180256009	4107731	
16457	1431	4107731	1993-01-02	1993-01-02 00:00:00	38000275	0	\N	\N	95348	0	180256009	4107731	
16648	1442	4151422	1955-01-21	1955-01-21 00:00:00	38000275	0	\N	\N	96142	0	269911007	4151422	
5032	469	4043071	1948-08-23	1948-08-23 00:00:00	38000275	0	\N	\N	31283	0	228557008	4043071	
5182	480	4195803	1998-03-18	1998-03-18 00:00:00	38000275	0	\N	\N	32119	0	312681000	4195803	
5419	499	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	33321	0	180256009	4107731	
5543	505	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	33856	0	180256009	4107731	
17604	1513	4107731	1993-02-14	1993-02-14 00:00:00	38000275	0	\N	\N	101104	0	180256009	4107731	
5935	545	4107731	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	36081	0	180256009	4107731	
17960	1538	4057420	2009-10-12	2009-10-12 00:00:00	38000275	0	\N	\N	\N	0	18286008	4057420	
18232	1556	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	104177	0	180256009	4107731	
18435	1565	4043071	1974-04-01	1974-04-01 00:00:00	38000275	0	\N	\N	104934	0	228557008	4043071	
6683	610	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	40547	0	180256009	4107731	
18711	1602	4293740	2000-08-10	2000-08-10 00:00:00	38000275	0	\N	\N	107523	0	384700001	4293740	
7083	656	4043071	1971-11-06	1971-11-06 00:00:00	38000275	0	\N	\N	43492	0	228557008	4043071	
19075	1636	4243062	2002-04-07	2002-04-07 00:00:00	38000275	0	\N	\N	109883	0	60027007	4243062	
7411	685	4043071	1976-04-27	1976-04-27 00:00:00	38000275	0	\N	\N	45319	0	228557008	4043071	
7602	704	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	46624	0	180256009	4107731	
7835	718	4107731	1993-05-29	1993-05-29 00:00:00	38000275	0	\N	\N	47486	0	180256009	4107731	
19842	1716	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	114741	0	180256009	4107731	
8174	752	4125906	1979-10-18	1979-10-18 00:00:00	38000275	0	\N	\N	49641	0	288086009	4125906	
8341	761	4107731	1995-05-12	1995-05-12 00:00:00	38000275	0	\N	\N	50625	0	180256009	4107731	
20525	1773	4107731	1990-04-22	1990-04-22 00:00:00	38000275	0	\N	\N	118538	0	180256009	4107731	
20719	1783	4107731	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	119542	0	180256009	4107731	
32755	2871	4043071	1963-06-27	1963-06-27 00:00:00	38000275	0	\N	\N	191098	0	228557008	4043071	
9154	842	4151422	1938-03-25	1938-03-25 00:00:00	38000275	0	\N	\N	55655	0	269911007	4151422	
9276	844	4107731	1990-03-10	1990-03-10 00:00:00	38000275	0	\N	\N	55971	0	180256009	4107731	
9531	867	4202451	2016-07-05	2016-07-05 00:00:00	38000275	0	\N	\N	57590	0	433112001	4202451	
33549	2925	4107731	1992-09-14	1992-09-14 00:00:00	38000275	0	\N	\N	195110	0	180256009	4107731	
9851	884	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	58905	0	180256009	4107731	
21988	1915	4043071	1983-05-05	1983-05-05 00:00:00	38000275	0	\N	\N	127389	0	228557008	4043071	
22109	1925	4058899	1959-06-06	1959-06-06 00:00:00	38000275	0	\N	\N	128084	0	168594001	4058899	
10412	932	4058899	1971-01-15	1971-01-15 00:00:00	38000275	0	\N	\N	62026	0	168594001	4058899	
10645	959	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	63774	0	180256009	4107731	
22688	1977	4078793	2018-07-05	2018-07-05 00:00:00	38000275	0	\N	\N	131570	0	180325003	4078793	
22878	1992	4107731	1991-09-08	1991-09-08 00:00:00	38000275	0	\N	\N	132679	0	180256009	4107731	
23114	2013	4151422	1975-11-24	1975-11-24 00:00:00	38000275	0	\N	\N	133959	0	269911007	4151422	
11403	1058	4107731	1993-04-17	1993-04-17 00:00:00	38000275	0	\N	\N	69425	0	180256009	4107731	
23492	2056	4252419	1990-09-25	1990-09-25 00:00:00	38000275	0	\N	\N	136716	0	74016001	4252419	
11716	1082	4107731	1990-02-17	1990-02-17 00:00:00	38000275	0	\N	\N	70996	0	180256009	4107731	
23757	2070	4107731	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	137759	0	180256009	4107731	
115	5	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	413	0	180256009	4107731	
307	19	4170947	1981-11-08	1981-11-08 00:00:00	38000275	0	\N	\N	1544	0	274474001	4170947	
12362	1110	4107731	1998-03-16	1998-03-16 00:00:00	38000275	0	\N	\N	73047	0	180256009	4107731	
12599	1138	4191853	1996-08-08	1996-08-08 00:00:00	38000275	0	\N	\N	75088	0	395142003	4191853	
12868	1159	4295880	2001-06-23	2001-06-23 00:00:00	38000275	0	\N	\N	76576	0	76601001	4295880	
12952	1175	4107731	1991-02-24	1991-02-24 00:00:00	38000275	0	\N	\N	77498	0	180256009	4107731	
13117	1188	4163872	1983-09-17	1983-09-17 00:00:00	38000275	0	\N	\N	78276	0	399208008	4163872	
13294	1211	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	79617	0	180256009	4107731	
13562	1227	4170947	1950-04-03	1950-04-03 00:00:00	38000275	0	\N	\N	80818	0	274474001	4170947	
1807	170	4163872	2014-01-21	2014-01-21 00:00:00	38000275	0	\N	\N	11524	0	399208008	4163872	
1995	186	4197460	1972-11-15	1972-11-15 00:00:00	38000275	0	\N	\N	12647	0	313191000	4197460	
2208	225	4170947	1975-06-21	1975-06-21 00:00:00	38000275	0	\N	\N	15151	0	274474001	4170947	
14224	1276	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	84184	0	180256009	4107731	
2582	264	4125906	1975-10-15	1975-10-15 00:00:00	38000275	0	\N	\N	17536	0	288086009	4125906	
14724	1310	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	86642	0	180256009	4107731	
2946	285	4107731	1992-01-06	1992-01-06 00:00:00	38000275	0	\N	\N	18977	0	180256009	4107731	
15005	1332	4125906	1975-05-09	1975-05-09 00:00:00	38000275	0	\N	\N	88380	0	288086009	4125906	
3362	332	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	21915	0	180256009	4107731	
3546	343	4191853	1990-01-06	1990-01-06 00:00:00	38000275	0	\N	\N	22856	0	395142003	4191853	
3671	354	4035793	2015-02-26	2015-02-26 00:00:00	38000275	0	\N	\N	23593	0	15081005	4035793	
3919	399	4107731	1993-05-09	1993-05-09 00:00:00	38000275	0	\N	\N	26151	0	180256009	4107731	
4044	404	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	26696	0	180256009	4107731	
4234	409	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	27091	0	180256009	4107731	
16444	1431	4107731	1993-03-27	1993-03-27 00:00:00	38000275	0	\N	\N	95350	0	180256009	4107731	
16458	1431	4107731	1990-02-17	1990-02-17 00:00:00	38000275	0	\N	\N	95213	0	180256009	4107731	
16649	1443	4125906	2001-05-13	2001-05-13 00:00:00	38000275	0	\N	\N	96193	0	288086009	4125906	
5033	469	4043071	1946-05-27	1946-05-27 00:00:00	38000275	0	\N	\N	31234	0	228557008	4043071	
5183	480	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	32087	0	180256009	4107731	
5420	499	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	33429	0	180256009	4107731	
5544	505	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	33765	0	180256009	4107731	
17605	1513	4107731	1991-05-26	1991-05-26 00:00:00	38000275	0	\N	\N	101044	0	180256009	4107731	
5936	545	4107731	1991-09-07	1991-09-07 00:00:00	38000275	0	\N	\N	36069	0	180256009	4107731	
17961	1538	4107731	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	103090	0	180256009	4107731	
18233	1556	4197460	1973-09-25	1973-09-25 00:00:00	38000275	0	\N	\N	104147	0	313191000	4197460	
18436	1565	4043071	1973-02-19	1973-02-19 00:00:00	38000275	0	\N	\N	104913	0	228557008	4043071	
6684	610	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	40580	0	180256009	4107731	
18712	1602	4125906	2000-08-10	2000-08-10 00:00:00	38000275	0	\N	\N	107523	0	288086009	4125906	
7084	656	4043071	1971-02-06	1971-02-06 00:00:00	38000275	0	\N	\N	43490	0	228557008	4043071	
19076	1636	4170947	2002-04-07	2002-04-07 00:00:00	38000275	0	\N	\N	109883	0	274474001	4170947	
7412	686	4163872	1966-06-18	1966-06-18 00:00:00	38000275	0	\N	\N	45438	0	399208008	4163872	
19449	1659	4043071	1982-03-22	1982-03-22 00:00:00	38000275	0	\N	\N	111563	0	228557008	4043071	
7836	718	4107731	1992-02-22	1992-02-22 00:00:00	38000275	0	\N	\N	47453	0	180256009	4107731	
19843	1716	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	114687	0	180256009	4107731	
8175	753	4238715	1989-12-17	1989-12-17 00:00:00	38000275	0	\N	\N	49802	0	68254000	4238715	
8342	761	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	50547	0	180256009	4107731	
20526	1773	4191853	1990-01-07	1990-01-07 00:00:00	38000275	0	\N	\N	118557	0	395142003	4191853	
20720	1783	4107731	1991-04-29	1991-04-29 00:00:00	38000275	0	\N	\N	119551	0	180256009	4107731	
32756	2871	4058899	2017-03-15	2017-03-15 00:00:00	38000275	0	\N	\N	191095	0	168594001	4058899	
9155	843	4107731	1998-03-21	1998-03-21 00:00:00	38000275	0	\N	\N	55768	0	180256009	4107731	
9277	844	4107731	1990-06-02	1990-06-02 00:00:00	38000275	0	\N	\N	55991	0	180256009	4107731	
21319	1845	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	123374	0	180256009	4107731	
33550	2925	4107731	1992-12-06	1992-12-06 00:00:00	38000275	0	\N	\N	195077	0	180256009	4107731	
9852	884	4191853	1994-03-15	1994-03-15 00:00:00	38000275	0	\N	\N	58863	0	395142003	4191853	
21989	1915	4043071	1983-03-31	1983-03-31 00:00:00	38000275	0	\N	\N	127388	0	228557008	4043071	
22110	1925	4151422	1954-02-04	1954-02-04 00:00:00	38000275	0	\N	\N	128171	0	269911007	4151422	
10413	932	4024289	2017-05-25	2017-05-25 00:00:00	38000275	0	\N	\N	62055	0	19490002	4024289	
10646	959	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	63775	0	395142003	4191853	
22689	1977	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	131581	0	180256009	4107731	
22879	1992	4107731	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	132684	0	180256009	4107731	
23115	2013	4058899	1975-10-16	1975-10-16 00:00:00	38000275	0	\N	\N	134003	0	168594001	4058899	
11404	1058	4107731	1990-02-17	1990-02-17 00:00:00	38000275	0	\N	\N	69484	0	180256009	4107731	
23493	2056	4125906	2001-04-30	2001-04-30 00:00:00	38000275	0	\N	\N	136717	0	288086009	4125906	
11717	1082	4107731	1991-07-27	1991-07-27 00:00:00	38000275	0	\N	\N	70938	0	180256009	4107731	
23758	2070	4107731	1991-08-12	1991-08-12 00:00:00	38000275	0	\N	\N	137712	0	180256009	4107731	
116	5	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	435	0	180256009	4107731	
308	19	4024289	1981-11-08	1981-11-08 00:00:00	38000275	0	\N	\N	1544	0	19490002	4024289	
12363	1110	4107731	1997-08-18	1997-08-18 00:00:00	38000275	0	\N	\N	73066	0	180256009	4107731	
12600	1138	4107731	1996-01-11	1996-01-11 00:00:00	38000275	0	\N	\N	74991	0	180256009	4107731	
12869	1159	4238715	2002-08-24	2002-08-24 00:00:00	38000275	0	\N	\N	76577	0	68254000	4238715	
12953	1175	4107731	1991-04-07	1991-04-07 00:00:00	38000275	0	\N	\N	77455	0	180256009	4107731	
13118	1188	4170947	1983-09-17	1983-09-17 00:00:00	38000275	0	\N	\N	78276	0	274474001	4170947	
13295	1211	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	79604	0	180256009	4107731	
13563	1227	4047491	1950-04-03	1950-04-03 00:00:00	38000275	0	\N	\N	80818	0	1225002	4047491	
1808	171	4125906	1983-06-21	1983-06-21 00:00:00	38000275	0	\N	\N	11609	0	288086009	4125906	
1996	186	4125906	2005-02-25	2005-02-25 00:00:00	38000275	0	\N	\N	12652	0	288086009	4125906	
2209	225	4243062	1975-06-21	1975-06-21 00:00:00	38000275	0	\N	\N	15151	0	60027007	4243062	
14225	1276	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	84182	0	180256009	4107731	
2583	264	4125906	2007-06-16	2007-06-16 00:00:00	38000275	0	\N	\N	17588	0	288086009	4125906	
14725	1310	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	86609	0	180256009	4107731	
2947	285	4107731	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	18995	0	180256009	4107731	
15006	1332	4216130	2019-01-02	2019-01-02 00:00:00	38000275	0	\N	\N	88384	0	415070008	4216130	
3363	332	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	22055	0	180256009	4107731	
3547	343	4107731	1991-11-30	1991-11-30 00:00:00	38000275	0	\N	\N	22893	0	180256009	4107731	
3672	354	4035793	2017-03-09	2017-03-09 00:00:00	38000275	0	\N	\N	23594	0	15081005	4035793	
3920	399	4145310	1969-02-23	1969-02-23 00:00:00	38000275	0	\N	\N	26235	0	268425006	4145310	
4045	404	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	26682	0	180256009	4107731	
4235	409	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	27109	0	180256009	4107731	
16445	1431	4170947	2018-11-08	2018-11-08 00:00:00	38000275	0	\N	\N	95254	0	274474001	4170947	
16459	1431	4125906	2000-05-18	2000-05-18 00:00:00	38000275	0	\N	\N	95252	0	288086009	4125906	
16677	1446	4125906	2008-09-25	2008-09-25 00:00:00	38000275	0	\N	\N	96378	0	288086009	4125906	
5034	469	4043071	1951-01-08	1951-01-08 00:00:00	38000275	0	\N	\N	31308	0	228557008	4043071	
5184	480	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	31971	0	180256009	4107731	
5421	499	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	33444	0	180256009	4107731	
5545	505	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	33852	0	180256009	4107731	
17606	1513	4107731	1990-08-05	1990-08-05 00:00:00	38000275	0	\N	\N	101136	0	180256009	4107731	
5937	545	4107731	1991-03-23	1991-03-23 00:00:00	38000275	0	\N	\N	36140	0	180256009	4107731	
17962	1538	4107731	1991-02-04	1991-02-04 00:00:00	38000275	0	\N	\N	102981	0	180256009	4107731	
18234	1556	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	104194	0	180256009	4107731	
18437	1565	4043071	1973-03-19	1973-03-19 00:00:00	38000275	0	\N	\N	104951	0	228557008	4043071	
6685	610	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	40550	0	180256009	4107731	
18714	1604	4252419	1973-04-15	1973-04-15 00:00:00	38000275	0	\N	\N	107605	0	74016001	4252419	
7085	656	4043071	1971-09-04	1971-09-04 00:00:00	38000275	0	\N	\N	43435	0	228557008	4043071	
19081	1640	4195803	1996-05-08	1996-05-08 00:00:00	38000275	0	\N	\N	110023	0	312681000	4195803	
7413	686	4125906	1976-01-08	1976-01-08 00:00:00	38000275	0	\N	\N	45425	0	288086009	4125906	
19450	1659	4043071	1978-12-04	1978-12-04 00:00:00	38000275	0	\N	\N	111483	0	228557008	4043071	
7837	718	4107731	1991-02-09	1991-02-09 00:00:00	38000275	0	\N	\N	47466	0	180256009	4107731	
19844	1716	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	114625	0	180256009	4107731	
8176	753	4275113	1984-09-08	1984-09-08 00:00:00	38000275	0	\N	\N	49800	0	65200003	4275113	
8343	761	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	50629	0	180256009	4107731	
20527	1773	4107731	1991-09-29	1991-09-29 00:00:00	38000275	0	\N	\N	118500	0	180256009	4107731	
20721	1783	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	119462	0	180256009	4107731	
32757	2871	4195803	2017-03-15	2017-03-15 00:00:00	38000275	0	\N	\N	191095	0	312681000	4195803	
9156	843	4107731	1995-10-21	1995-10-21 00:00:00	38000275	0	\N	\N	55773	0	180256009	4107731	
9278	844	4107731	1991-01-19	1991-01-19 00:00:00	38000275	0	\N	\N	55975	0	180256009	4107731	
21320	1845	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	123314	0	180256009	4107731	
33551	2925	4107731	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	195121	0	180256009	4107731	
9853	884	4191853	1978-11-13	1978-11-13 00:00:00	38000275	0	\N	\N	58857	0	395142003	4191853	
21990	1916	44783196	1982-05-30	1982-05-30 00:00:00	38000275	0	\N	\N	127460	0	699253003	44783196	
22111	1925	4243062	1960-05-01	1960-05-01 00:00:00	38000275	0	\N	\N	128085	0	60027007	4243062	
10414	932	4170947	2017-05-25	2017-05-25 00:00:00	38000275	0	\N	\N	62055	0	274474001	4170947	
10647	959	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	63745	0	180256009	4107731	
22690	1977	4078793	2014-06-12	2014-06-12 00:00:00	38000275	0	\N	\N	131528	0	180325003	4078793	
22880	1992	4107731	1992-04-26	1992-04-26 00:00:00	38000275	0	\N	\N	132695	0	180256009	4107731	
23118	2016	4125906	1989-05-26	1989-05-26 00:00:00	38000275	0	\N	\N	134106	0	288086009	4125906	
11405	1058	4107731	1992-02-22	1992-02-22 00:00:00	38000275	0	\N	\N	69439	0	180256009	4107731	
23495	2058	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	136879	0	180256009	4107731	
11718	1082	4107731	1992-04-04	1992-04-04 00:00:00	38000275	0	\N	\N	71048	0	180256009	4107731	
23759	2070	4107731	1991-02-04	1991-02-04 00:00:00	38000275	0	\N	\N	137686	0	180256009	4107731	
117	5	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	485	0	180256009	4107731	
309	19	4057420	2011-04-10	2011-04-10 00:00:00	38000275	0	\N	\N	1471	0	18286008	4057420	
12364	1110	4107731	1998-02-02	1998-02-02 00:00:00	38000275	0	\N	\N	73075	0	180256009	4107731	
12601	1138	4043071	1997-04-10	1997-04-10 00:00:00	38000275	0	\N	\N	75114	0	228557008	4043071	
12870	1159	4275113	1994-07-27	1994-07-27 00:00:00	38000275	0	\N	\N	76587	0	65200003	4275113	
12954	1175	4107731	1992-08-02	1992-08-02 00:00:00	38000275	0	\N	\N	77506	0	180256009	4107731	
13119	1189	4058899	1964-09-27	1964-09-27 00:00:00	38000275	0	\N	\N	78324	0	168594001	4058899	
13296	1211	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	79508	0	180256009	4107731	
13564	1227	4170947	1946-04-10	1946-04-10 00:00:00	38000275	0	\N	\N	80816	0	274474001	4170947	
1809	171	4125906	2000-03-04	2000-03-04 00:00:00	38000275	0	\N	\N	11611	0	288086009	4125906	
1997	186	4243062	1981-09-30	1981-09-30 00:00:00	38000275	0	\N	\N	12649	0	60027007	4243062	
2210	225	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	15152	0	180256009	4107731	
14226	1276	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	84179	0	180256009	4107731	
2584	264	4125906	1995-06-05	1995-06-05 00:00:00	38000275	0	\N	\N	17587	0	288086009	4125906	
14726	1310	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	86555	0	180256009	4107731	
2948	285	4107731	1990-02-12	1990-02-12 00:00:00	38000275	0	\N	\N	19006	0	180256009	4107731	
15007	1332	4336464	2019-01-02	2019-01-02 00:00:00	38000275	0	\N	\N	88384	0	232717009	4336464	
3364	332	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	21981	0	180256009	4107731	
3548	343	4107731	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	22972	0	180256009	4107731	
3673	354	4035793	2006-01-05	2006-01-05 00:00:00	38000275	0	\N	\N	23588	0	15081005	4035793	
3921	399	4107731	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	26121	0	180256009	4107731	
4046	404	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	26571	0	180256009	4107731	
4236	409	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	27102	0	180256009	4107731	
16446	1431	4024289	2018-11-08	2018-11-08 00:00:00	38000275	0	\N	\N	95254	0	19490002	4024289	
16460	1431	4107731	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	95336	0	180256009	4107731	
16678	1446	4191853	1984-09-08	1984-09-08 00:00:00	38000275	0	\N	\N	96389	0	395142003	4191853	
5035	469	4043071	1951-03-12	1951-03-12 00:00:00	38000275	0	\N	\N	31241	0	228557008	4043071	
5185	480	4170947	1954-02-10	1954-02-10 00:00:00	38000275	0	\N	\N	31965	0	274474001	4170947	
5422	499	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	33378	0	180256009	4107731	
5546	505	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	33835	0	180256009	4107731	
17607	1513	4191853	1990-01-07	1990-01-07 00:00:00	38000275	0	\N	\N	101125	0	395142003	4191853	
5938	545	4107731	1991-05-25	1991-05-25 00:00:00	38000275	0	\N	\N	36034	0	180256009	4107731	
17963	1538	4191853	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	103037	0	395142003	4191853	
18235	1556	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	104261	0	180256009	4107731	
18438	1565	4043071	1973-12-17	1973-12-17 00:00:00	38000275	0	\N	\N	104953	0	228557008	4043071	
6686	610	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	40549	0	180256009	4107731	
18715	1604	44783196	1973-04-22	1973-04-22 00:00:00	38000275	0	\N	\N	107603	0	699253003	44783196	
7086	656	4301346	2011-03-31	2011-03-31 00:00:00	38000275	0	\N	\N	43504	0	387685009	4301346	
19082	1640	4202451	2015-06-10	2015-06-10 00:00:00	38000275	0	\N	\N	110067	0	433112001	4202451	
7414	686	4024289	1954-02-27	1954-02-27 00:00:00	38000275	0	\N	\N	45423	0	19490002	4024289	
19451	1659	4043071	1978-03-27	1978-03-27 00:00:00	38000275	0	\N	\N	111439	0	228557008	4043071	
7838	718	4107731	1991-06-15	1991-06-15 00:00:00	38000275	0	\N	\N	47505	0	180256009	4107731	
19845	1716	44783196	2009-07-01	2009-07-01 00:00:00	38000275	0	\N	\N	114706	0	699253003	44783196	
8177	753	4151422	1978-10-14	1978-10-14 00:00:00	38000275	0	\N	\N	49806	0	269911007	4151422	
8344	761	4107731	1994-02-04	1994-02-04 00:00:00	38000275	0	\N	\N	50621	0	180256009	4107731	
20528	1773	4107731	1990-08-05	1990-08-05 00:00:00	38000275	0	\N	\N	118527	0	180256009	4107731	
20722	1783	4107731	1991-02-04	1991-02-04 00:00:00	38000275	0	\N	\N	119549	0	180256009	4107731	
32758	2871	4043071	1962-12-06	1962-12-06 00:00:00	38000275	0	\N	\N	191117	0	228557008	4043071	
9157	843	4107731	1998-07-04	1998-07-04 00:00:00	38000275	0	\N	\N	55853	0	180256009	4107731	
9279	844	4107731	1992-10-10	1992-10-10 00:00:00	38000275	0	\N	\N	55916	0	180256009	4107731	
21321	1845	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	123293	0	180256009	4107731	
33552	2925	4107731	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	195075	0	180256009	4107731	
9854	884	4107731	1993-09-07	1993-09-07 00:00:00	38000275	0	\N	\N	58862	0	180256009	4107731	
21991	1916	4163872	1972-01-04	1972-01-04 00:00:00	38000275	0	\N	\N	127461	0	399208008	4163872	
22112	1925	4170947	1960-05-01	1960-05-01 00:00:00	38000275	0	\N	\N	128085	0	274474001	4170947	
10415	933	4125906	1983-10-11	1983-10-11 00:00:00	38000275	0	\N	\N	62058	0	288086009	4125906	
10648	959	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	63692	0	180256009	4107731	
22691	1977	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	131613	0	180256009	4107731	
22881	1992	4107731	1990-12-30	1990-12-30 00:00:00	38000275	0	\N	\N	132664	0	180256009	4107731	
23119	2016	4145310	2011-09-06	2011-09-06 00:00:00	38000275	0	\N	\N	134136	0	268425006	4145310	
11406	1058	4107731	1992-12-12	1992-12-12 00:00:00	38000275	0	\N	\N	69339	0	180256009	4107731	
23496	2058	4151422	1972-09-26	1972-09-26 00:00:00	38000275	0	\N	\N	136870	0	269911007	4151422	
11719	1082	4107731	1991-11-30	1991-11-30 00:00:00	38000275	0	\N	\N	70992	0	180256009	4107731	
23760	2070	4107731	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	137682	0	180256009	4107731	
118	5	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	404	0	180256009	4107731	
310	19	4057420	2017-05-14	2017-05-14 00:00:00	38000275	0	\N	\N	\N	0	18286008	4057420	
12367	1112	4125906	1968-07-02	1968-07-02 00:00:00	38000275	0	\N	\N	73184	0	288086009	4125906	
12602	1138	4043071	1995-11-09	1995-11-09 00:00:00	38000275	0	\N	\N	75103	0	228557008	4043071	
12871	1159	4058899	1982-03-18	1982-03-18 00:00:00	38000275	0	\N	\N	76596	0	168594001	4058899	
12955	1175	4107731	1990-02-11	1990-02-11 00:00:00	38000275	0	\N	\N	77432	0	180256009	4107731	
13120	1189	4163872	1975-07-02	1975-07-02 00:00:00	38000275	0	\N	\N	78325	0	399208008	4163872	
13297	1211	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	79496	0	180256009	4107731	
13565	1227	4047491	1946-04-10	1946-04-10 00:00:00	38000275	0	\N	\N	80816	0	1225002	4047491	
1810	171	4125906	1994-05-15	1994-05-15 00:00:00	38000275	0	\N	\N	11610	0	288086009	4125906	
1998	186	4170947	1981-09-30	1981-09-30 00:00:00	38000275	0	\N	\N	12649	0	274474001	4170947	
2211	225	4107731	1991-11-25	1991-11-25 00:00:00	38000275	0	\N	\N	15216	0	180256009	4107731	
14227	1276	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	84259	0	180256009	4107731	
2590	266	4107731	1991-12-16	1991-12-16 00:00:00	38000275	0	\N	\N	17723	0	180256009	4107731	
14727	1310	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	86634	0	180256009	4107731	
2949	285	4107731	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	18921	0	180256009	4107731	
15008	1332	4170947	1979-12-05	1979-12-05 00:00:00	38000275	0	\N	\N	88381	0	274474001	4170947	
3365	332	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	21968	0	180256009	4107731	
3549	343	4107731	1991-05-04	1991-05-04 00:00:00	38000275	0	\N	\N	22948	0	180256009	4107731	
3674	357	4170947	1959-12-16	1959-12-16 00:00:00	38000275	0	\N	\N	23634	0	274474001	4170947	
3922	399	4107731	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	26115	0	180256009	4107731	
4047	404	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	26639	0	180256009	4107731	
4237	409	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	27101	0	180256009	4107731	
16447	1431	4195803	2018-11-08	2018-11-08 00:00:00	38000275	0	\N	\N	95254	0	312681000	4195803	
16461	1431	4107731	1993-05-29	1993-05-29 00:00:00	38000275	0	\N	\N	95340	0	180256009	4107731	
16679	1447	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	96478	0	180256009	4107731	
5036	469	4125906	1969-07-04	1969-07-04 00:00:00	38000275	0	\N	\N	31364	0	288086009	4125906	
5186	480	4024289	1954-02-10	1954-02-10 00:00:00	38000275	0	\N	\N	31965	0	19490002	4024289	
5423	499	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	33434	0	180256009	4107731	
5547	505	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	33750	0	180256009	4107731	
17608	1513	4043071	1979-09-20	1979-09-20 00:00:00	38000275	0	\N	\N	101162	0	228557008	4043071	
5939	545	4107731	1990-06-02	1990-06-02 00:00:00	38000275	0	\N	\N	36029	0	180256009	4107731	
17964	1538	4107731	1993-01-18	1993-01-18 00:00:00	38000275	0	\N	\N	103030	0	180256009	4107731	
18236	1556	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	104168	0	180256009	4107731	
18439	1565	4043071	1973-05-21	1973-05-21 00:00:00	38000275	0	\N	\N	104931	0	228557008	4043071	
6687	610	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	40488	0	180256009	4107731	
18716	1604	4058899	2018-12-27	2018-12-27 00:00:00	38000275	0	\N	\N	107607	0	168594001	4058899	
7087	656	4043071	1971-07-31	1971-07-31 00:00:00	38000275	0	\N	\N	43434	0	228557008	4043071	
19083	1640	4125906	1992-03-17	1992-03-17 00:00:00	38000275	0	\N	\N	110030	0	288086009	4125906	
7415	686	4170947	1954-02-27	1954-02-27 00:00:00	38000275	0	\N	\N	45423	0	274474001	4170947	
19452	1659	4043071	1980-12-08	1980-12-08 00:00:00	38000275	0	\N	\N	111560	0	228557008	4043071	
7839	718	4107731	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	47544	0	180256009	4107731	
19846	1716	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	114684	0	180256009	4107731	
8178	753	4186930	1989-09-10	1989-09-10 00:00:00	38000275	0	\N	\N	49801	0	46706006	4186930	
8345	761	4107731	1993-12-24	1993-12-24 00:00:00	38000275	0	\N	\N	50620	0	180256009	4107731	
20529	1773	4107731	1990-06-24	1990-06-24 00:00:00	38000275	0	\N	\N	118526	0	180256009	4107731	
20723	1783	4107731	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	119543	0	180256009	4107731	
32759	2871	4043071	1961-04-20	1961-04-20 00:00:00	38000275	0	\N	\N	191114	0	228557008	4043071	
9158	843	4107731	1998-10-17	1998-10-17 00:00:00	38000275	0	\N	\N	55851	0	180256009	4107731	
9280	844	4107731	1991-06-15	1991-06-15 00:00:00	38000275	0	\N	\N	55981	0	180256009	4107731	
21322	1845	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	123281	0	180256009	4107731	
33553	2925	4107731	1991-08-12	1991-08-12 00:00:00	38000275	0	\N	\N	195104	0	180256009	4107731	
9855	884	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	58947	0	180256009	4107731	
21992	1916	4024289	1977-07-18	1977-07-18 00:00:00	38000275	0	\N	\N	127440	0	19490002	4024289	
22113	1925	4058899	1957-06-16	1957-06-16 00:00:00	38000275	0	\N	\N	128083	0	168594001	4058899	
10428	935	4057420	1991-05-15	1991-05-15 00:00:00	38000275	0	\N	\N	62180	0	18286008	4057420	
22441	1967	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	130845	0	180256009	4107731	
22692	1977	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	131601	0	180256009	4107731	
22882	1992	4107731	1991-05-26	1991-05-26 00:00:00	38000275	0	\N	\N	132673	0	180256009	4107731	
23120	2017	4151422	1985-04-26	1985-04-26 00:00:00	38000275	0	\N	\N	134167	0	269911007	4151422	
11407	1058	4107731	1990-06-23	1990-06-23 00:00:00	38000275	0	\N	\N	69478	0	180256009	4107731	
23497	2058	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	136841	0	395142003	4191853	
11720	1082	4107731	1990-08-04	1990-08-04 00:00:00	38000275	0	\N	\N	70933	0	180256009	4107731	
23761	2070	4107731	1990-04-16	1990-04-16 00:00:00	38000275	0	\N	\N	137769	0	180256009	4107731	
119	5	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	438	0	180256009	4107731	
311	19	4275113	1976-11-16	1976-11-16 00:00:00	38000275	0	\N	\N	1532	0	65200003	4275113	
12368	1112	4151422	1990-11-05	1990-11-05 00:00:00	38000275	0	\N	\N	73168	0	269911007	4151422	
12603	1138	4107731	1995-05-04	1995-05-04 00:00:00	38000275	0	\N	\N	75078	0	180256009	4107731	
12872	1159	4293740	2007-09-03	2007-09-03 00:00:00	38000275	0	\N	\N	76597	0	384700001	4293740	
12956	1175	4107731	1992-05-31	1992-05-31 00:00:00	38000275	0	\N	\N	77450	0	180256009	4107731	
13121	1189	4170947	1975-07-02	1975-07-02 00:00:00	38000275	0	\N	\N	78325	0	274474001	4170947	
13298	1211	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	79646	0	180256009	4107731	
13566	1227	4057420	2018-02-21	2018-02-21 00:00:00	38000275	0	\N	\N	\N	0	18286008	4057420	
1811	171	4243062	1979-09-10	1979-09-10 00:00:00	38000275	0	\N	\N	11608	0	60027007	4243062	
1999	186	4197460	1991-07-18	1991-07-18 00:00:00	38000275	0	\N	\N	12650	0	313191000	4197460	
2212	225	4125906	1978-04-06	1978-04-06 00:00:00	38000275	0	\N	\N	15143	0	288086009	4125906	
14228	1276	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	84169	0	180256009	4107731	
2591	266	4107731	1992-09-14	1992-09-14 00:00:00	38000275	0	\N	\N	17726	0	180256009	4107731	
14728	1310	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	86630	0	180256009	4107731	
2950	285	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	18954	0	180256009	4107731	
15009	1332	4243062	1979-12-05	1979-12-05 00:00:00	38000275	0	\N	\N	88381	0	60027007	4243062	
3366	332	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	21919	0	180256009	4107731	
3550	343	4107731	1990-03-10	1990-03-10 00:00:00	38000275	0	\N	\N	22902	0	180256009	4107731	
3675	357	4163872	1959-12-16	1959-12-16 00:00:00	38000275	0	\N	\N	23634	0	399208008	4163872	
3923	399	4024289	1968-03-30	1968-03-30 00:00:00	38000275	0	\N	\N	26234	0	19490002	4024289	
4048	404	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	26626	0	180256009	4107731	
4238	409	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	27146	0	180256009	4107731	
16448	1431	4107731	1992-01-11	1992-01-11 00:00:00	38000275	0	\N	\N	95269	0	180256009	4107731	
16462	1431	4047491	1965-05-31	1965-05-31 00:00:00	38000275	0	\N	\N	95250	0	1225002	4047491	
16680	1447	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	96521	0	180256009	4107731	
5037	469	4043071	1946-07-22	1946-07-22 00:00:00	38000275	0	\N	\N	31212	0	228557008	4043071	
5187	480	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	32090	0	395142003	4191853	
17205	1486	4107731	1990-04-01	1990-04-01 00:00:00	38000275	0	\N	\N	99128	0	180256009	4107731	
5548	505	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	33862	0	180256009	4107731	
17609	1513	4107731	1990-10-28	1990-10-28 00:00:00	38000275	0	\N	\N	101138	0	180256009	4107731	
5940	545	4191853	1993-07-10	1993-07-10 00:00:00	38000275	0	\N	\N	36022	0	395142003	4191853	
17965	1538	4107731	1990-02-12	1990-02-12 00:00:00	38000275	0	\N	\N	102976	0	180256009	4107731	
18237	1556	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	104173	0	180256009	4107731	
18440	1565	4043071	1974-07-08	1974-07-08 00:00:00	38000275	0	\N	\N	104969	0	228557008	4043071	
6688	610	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	40522	0	180256009	4107731	
18717	1604	4195803	2018-12-27	2018-12-27 00:00:00	38000275	0	\N	\N	107607	0	312681000	4195803	
7088	656	4043071	1971-10-09	1971-10-09 00:00:00	38000275	0	\N	\N	43444	0	228557008	4043071	
19084	1640	4145310	2006-09-14	2006-09-14 00:00:00	38000275	0	\N	\N	110031	0	268425006	4145310	
7416	687	4062501	1970-01-27	1970-01-27 00:00:00	38000275	0	\N	\N	45459	0	171231001	4062501	
19453	1659	4043071	1982-07-12	1982-07-12 00:00:00	38000275	0	\N	\N	111432	0	228557008	4043071	
7840	718	4107731	1990-06-02	1990-06-02 00:00:00	38000275	0	\N	\N	47429	0	180256009	4107731	
19847	1716	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	114614	0	180256009	4107731	
8179	753	4151422	2007-01-17	2007-01-17 00:00:00	38000275	0	\N	\N	49746	0	269911007	4151422	
8346	761	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	50643	0	180256009	4107731	
20530	1773	4107731	1990-10-28	1990-10-28 00:00:00	38000275	0	\N	\N	118577	0	180256009	4107731	
20724	1783	4107731	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	119482	0	180256009	4107731	
32760	2871	4043071	1962-01-18	1962-01-18 00:00:00	38000275	0	\N	\N	191066	0	228557008	4043071	
9159	843	4107731	1996-11-23	1996-11-23 00:00:00	38000275	0	\N	\N	55827	0	180256009	4107731	
9281	844	4107731	1990-10-27	1990-10-27 00:00:00	38000275	0	\N	\N	55973	0	180256009	4107731	
21323	1845	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	123367	0	180256009	4107731	
33554	2925	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	195008	0	180256009	4107731	
9856	884	4107731	1994-02-22	1994-02-22 00:00:00	38000275	0	\N	\N	58911	0	180256009	4107731	
21993	1916	4170947	1977-07-18	1977-07-18 00:00:00	38000275	0	\N	\N	127440	0	274474001	4170947	
22114	1925	4125906	2002-12-17	2002-12-17 00:00:00	38000275	0	\N	\N	128086	0	288086009	4125906	
10429	935	4078793	1991-10-23	1991-10-23 00:00:00	38000275	0	\N	\N	62161	0	180325003	4078793	
22442	1967	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	130747	0	395142003	4191853	
22693	1977	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	131484	0	180256009	4107731	
22883	1992	4107731	1990-04-22	1990-04-22 00:00:00	38000275	0	\N	\N	132734	0	180256009	4107731	
23122	2020	4295880	1994-12-10	1994-12-10 00:00:00	38000275	0	\N	\N	134269	0	76601001	4295880	
23265	2025	4078793	1973-11-10	1973-11-10 00:00:00	38000275	0	\N	\N	134672	0	180325003	4078793	
23498	2058	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	136806	0	180256009	4107731	
11721	1083	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	71131	0	180256009	4107731	
23762	2070	4107731	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	137691	0	180256009	4107731	
120	6	4181917	2004-02-08	2004-02-08 00:00:00	38000275	0	\N	\N	560	0	54550000	4181917	
312	19	4057420	2013-04-21	2013-04-21 00:00:00	38000275	0	\N	\N	1472	0	18286008	4057420	
12369	1113	4275113	1987-11-06	1987-11-06 00:00:00	38000275	0	\N	\N	73230	0	65200003	4275113	
12604	1138	4043071	1994-12-29	1994-12-29 00:00:00	38000275	0	\N	\N	75097	0	228557008	4043071	
12873	1159	4125906	2007-09-03	2007-09-03 00:00:00	38000275	0	\N	\N	76597	0	288086009	4125906	
12957	1175	4107731	1991-01-13	1991-01-13 00:00:00	38000275	0	\N	\N	77497	0	180256009	4107731	
13211	1193	4170947	1976-01-29	1976-01-29 00:00:00	38000275	0	\N	\N	78624	0	274474001	4170947	
13299	1211	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	79589	0	180256009	4107731	
13567	1227	4043071	1947-02-07	1947-02-07 00:00:00	38000275	0	\N	\N	80777	0	228557008	4043071	
1812	171	4170947	1979-09-10	1979-09-10 00:00:00	38000275	0	\N	\N	11608	0	274474001	4170947	
2000	186	4197460	1975-01-08	1975-01-08 00:00:00	38000275	0	\N	\N	12648	0	313191000	4197460	
2213	225	4107731	1992-07-13	1992-07-13 00:00:00	38000275	0	\N	\N	15232	0	180256009	4107731	
14337	1280	4043071	1964-09-01	1964-09-01 00:00:00	38000275	0	\N	\N	84597	0	228557008	4043071	
2592	266	4107731	1992-01-06	1992-01-06 00:00:00	38000275	0	\N	\N	17756	0	180256009	4107731	
14729	1310	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	86598	0	180256009	4107731	
2951	285	4107731	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	18933	0	180256009	4107731	
15010	1332	4125906	1966-11-12	1966-11-12 00:00:00	38000275	0	\N	\N	88317	0	288086009	4125906	
15148	1356	4107731	1998-04-23	1998-04-23 00:00:00	38000275	0	\N	\N	89865	0	180256009	4107731	
3551	343	4107731	1990-05-12	1990-05-12 00:00:00	38000275	0	\N	\N	22943	0	180256009	4107731	
3676	357	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	23692	0	180256009	4107731	
3924	399	4170947	1968-03-30	1968-03-30 00:00:00	38000275	0	\N	\N	26234	0	274474001	4170947	
4049	404	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	26697	0	180256009	4107731	
4239	409	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	27092	0	180256009	4107731	
16449	1431	4107731	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	95346	0	180256009	4107731	
16463	1431	4170947	1965-05-31	1965-05-31 00:00:00	38000275	0	\N	\N	95250	0	274474001	4170947	
16681	1447	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	96419	0	180256009	4107731	
5038	469	4043071	1946-11-25	1946-11-25 00:00:00	38000275	0	\N	\N	31274	0	228557008	4043071	
5188	480	4151422	1944-07-20	1944-07-20 00:00:00	38000275	0	\N	\N	32019	0	269911007	4151422	
17206	1486	4107731	1991-08-18	1991-08-18 00:00:00	38000275	0	\N	\N	99094	0	180256009	4107731	
5549	507	4078793	2007-09-14	2007-09-14 00:00:00	38000275	0	\N	\N	33935	0	180325003	4078793	
17610	1513	4107731	1990-12-30	1990-12-30 00:00:00	38000275	0	\N	\N	101141	0	180256009	4107731	
5941	545	4107731	1990-10-27	1990-10-27 00:00:00	38000275	0	\N	\N	36055	0	180256009	4107731	
17966	1538	4107731	1990-01-22	1990-01-22 00:00:00	38000275	0	\N	\N	102954	0	180256009	4107731	
18238	1556	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	104167	0	180256009	4107731	
18441	1565	4043071	1973-11-12	1973-11-12 00:00:00	38000275	0	\N	\N	104968	0	228557008	4043071	
6689	610	4125906	1995-08-24	1995-08-24 00:00:00	38000275	0	\N	\N	40481	0	288086009	4125906	
18718	1605	4151422	1964-10-31	1964-10-31 00:00:00	38000275	0	\N	\N	107677	0	269911007	4151422	
7089	656	4125906	2004-10-05	2004-10-05 00:00:00	38000275	0	\N	\N	43426	0	288086009	4125906	
19085	1641	4252419	1962-06-17	1962-06-17 00:00:00	38000275	0	\N	\N	110173	0	74016001	4252419	
7417	687	4198190	1992-01-17	1992-01-17 00:00:00	38000275	0	\N	\N	45498	0	80146002	4198190	
19454	1659	4043071	1981-01-05	1981-01-05 00:00:00	38000275	0	\N	\N	111427	0	228557008	4043071	
7841	718	4107731	1991-11-09	1991-11-09 00:00:00	38000275	0	\N	\N	47469	0	180256009	4107731	
19849	1718	4125906	2006-02-19	2006-02-19 00:00:00	38000275	0	\N	\N	114854	0	288086009	4125906	
8180	753	4125906	1997-08-31	1997-08-31 00:00:00	38000275	0	\N	\N	49817	0	288086009	4125906	
8347	761	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	50569	0	180256009	4107731	
20531	1773	4107731	1992-06-28	1992-06-28 00:00:00	38000275	0	\N	\N	118507	0	180256009	4107731	
20725	1783	4107731	1990-02-12	1990-02-12 00:00:00	38000275	0	\N	\N	119538	0	180256009	4107731	
32761	2871	4043071	1963-01-03	1963-01-03 00:00:00	38000275	0	\N	\N	191070	0	228557008	4043071	
9160	843	4107731	1995-05-27	1995-05-27 00:00:00	38000275	0	\N	\N	55789	0	180256009	4107731	
9282	844	4107731	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	55993	0	180256009	4107731	
21324	1845	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	123335	0	180256009	4107731	
33555	2925	4107731	1992-02-16	1992-02-16 00:00:00	38000275	0	\N	\N	195036	0	180256009	4107731	
9857	884	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	58883	0	180256009	4107731	
21994	1916	4125906	1973-09-23	1973-09-23 00:00:00	38000275	0	\N	\N	127439	0	288086009	4125906	
22115	1925	4047491	1949-07-28	1949-07-28 00:00:00	38000275	0	\N	\N	128081	0	1225002	4047491	
10430	935	4078793	1992-09-23	1992-09-23 00:00:00	38000275	0	\N	\N	62228	0	180325003	4078793	
22443	1967	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	130759	0	180256009	4107731	
22694	1977	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	131583	0	180256009	4107731	
22884	1992	4107731	1990-07-15	1990-07-15 00:00:00	38000275	0	\N	\N	132736	0	180256009	4107731	
23123	2020	4295880	1995-03-11	1995-03-11 00:00:00	38000275	0	\N	\N	134293	0	76601001	4295880	
23266	2025	4057420	1985-01-12	1985-01-12 00:00:00	38000275	0	\N	\N	134760	0	18286008	4057420	
23499	2058	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	136880	0	180256009	4107731	
11722	1083	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	71143	0	180256009	4107731	
23763	2070	4107731	1991-03-18	1991-03-18 00:00:00	38000275	0	\N	\N	137668	0	180256009	4107731	
121	6	4125906	1967-12-10	1967-12-10 00:00:00	38000275	0	\N	\N	554	0	288086009	4125906	
313	19	4145310	2003-07-16	2003-07-16 00:00:00	38000275	0	\N	\N	1545	0	268425006	4145310	
12370	1113	4238715	1996-01-02	1996-01-02 00:00:00	38000275	0	\N	\N	73231	0	68254000	4238715	
12605	1138	4043071	1997-01-16	1997-01-16 00:00:00	38000275	0	\N	\N	75090	0	228557008	4043071	
12874	1159	4186930	1999-07-24	1999-07-24 00:00:00	38000275	0	\N	\N	76560	0	46706006	4186930	
12958	1175	4107731	1992-07-12	1992-07-12 00:00:00	38000275	0	\N	\N	77503	0	180256009	4107731	
13212	1193	4163872	1976-01-29	1976-01-29 00:00:00	38000275	0	\N	\N	78624	0	399208008	4163872	
13300	1211	4198190	1971-10-23	1971-10-23 00:00:00	38000275	0	\N	\N	79555	0	80146002	4198190	
13568	1227	4043071	1946-11-29	1946-11-29 00:00:00	38000275	0	\N	\N	80775	0	228557008	4043071	
13652	1245	4198190	1985-08-27	1985-08-27 00:00:00	38000275	0	\N	\N	81898	0	80146002	4198190	
2001	187	4024289	1948-04-07	1948-04-07 00:00:00	38000275	0	\N	\N	12732	0	19490002	4024289	
2214	225	4107731	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	15215	0	180256009	4107731	
14338	1280	4043071	1965-02-16	1965-02-16 00:00:00	38000275	0	\N	\N	84602	0	228557008	4043071	
2593	266	4058899	1967-05-27	1967-05-27 00:00:00	38000275	0	\N	\N	17638	0	168594001	4058899	
14730	1310	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	86627	0	180256009	4107731	
2952	285	4107731	1992-10-26	1992-10-26 00:00:00	38000275	0	\N	\N	18953	0	180256009	4107731	
15011	1332	4125906	2002-12-25	2002-12-25 00:00:00	38000275	0	\N	\N	88383	0	288086009	4125906	
15149	1356	4107731	1997-07-24	1997-07-24 00:00:00	38000275	0	\N	\N	89918	0	180256009	4107731	
3552	343	4107731	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	22912	0	180256009	4107731	
3677	357	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	23685	0	180256009	4107731	
3925	399	4107731	1990-04-01	1990-04-01 00:00:00	38000275	0	\N	\N	26133	0	180256009	4107731	
4050	404	4107731	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	26669	0	180256009	4107731	
4240	409	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	27026	0	180256009	4107731	
16450	1431	4107731	1992-06-27	1992-06-27 00:00:00	38000275	0	\N	\N	95347	0	180256009	4107731	
16464	1431	4107731	1990-04-21	1990-04-21 00:00:00	38000275	0	\N	\N	95301	0	180256009	4107731	
16682	1447	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	96466	0	180256009	4107731	
5039	469	4043071	1948-10-25	1948-10-25 00:00:00	38000275	0	\N	\N	31281	0	228557008	4043071	
5189	480	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	32101	0	180256009	4107731	
17207	1486	4107731	1991-05-26	1991-05-26 00:00:00	38000275	0	\N	\N	99111	0	180256009	4107731	
5550	507	4057420	1998-09-11	1998-09-11 00:00:00	38000275	0	\N	\N	33933	0	18286008	4057420	
17611	1513	4107731	1992-11-22	1992-11-22 00:00:00	38000275	0	\N	\N	101051	0	180256009	4107731	
5942	545	4107731	1992-04-04	1992-04-04 00:00:00	38000275	0	\N	\N	36018	0	180256009	4107731	
17967	1538	4107731	1991-02-25	1991-02-25 00:00:00	38000275	0	\N	\N	102933	0	180256009	4107731	
18239	1556	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	104195	0	180256009	4107731	
18442	1565	4043071	1974-08-05	1974-08-05 00:00:00	38000275	0	\N	\N	104955	0	228557008	4043071	
6690	610	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	40606	0	180256009	4107731	
18719	1605	4195803	2011-06-01	2011-06-01 00:00:00	38000275	0	\N	\N	107751	0	312681000	4195803	
7090	656	4043071	1971-03-13	1971-03-13 00:00:00	38000275	0	\N	\N	43491	0	228557008	4043071	
19086	1641	44783196	1962-06-24	1962-06-24 00:00:00	38000275	0	\N	\N	110178	0	699253003	44783196	
7418	687	4197460	1977-05-03	1977-05-03 00:00:00	38000275	0	\N	\N	45487	0	313191000	4197460	
19455	1659	4043071	1978-04-24	1978-04-24 00:00:00	38000275	0	\N	\N	111516	0	228557008	4043071	
7842	718	4107731	1992-06-06	1992-06-06 00:00:00	38000275	0	\N	\N	47510	0	180256009	4107731	
19850	1718	4151422	2011-10-14	2011-10-14 00:00:00	38000275	0	\N	\N	114860	0	269911007	4151422	
8181	754	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	49927	0	180256009	4107731	
8348	761	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	50548	0	180256009	4107731	
20532	1773	4107731	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	118611	0	180256009	4107731	
20726	1783	4107731	1991-09-23	1991-09-23 00:00:00	38000275	0	\N	\N	119545	0	180256009	4107731	
32762	2871	4058899	1960-11-18	1960-11-18 00:00:00	38000275	0	\N	\N	191093	0	168594001	4058899	
9161	843	4107731	1996-04-06	1996-04-06 00:00:00	38000275	0	\N	\N	55825	0	180256009	4107731	
9283	844	4107731	1991-04-13	1991-04-13 00:00:00	38000275	0	\N	\N	55995	0	180256009	4107731	
21325	1845	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	123373	0	180256009	4107731	
33556	2925	4107731	1992-10-05	1992-10-05 00:00:00	38000275	0	\N	\N	195127	0	180256009	4107731	
9858	884	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	58898	0	180256009	4107731	
21995	1916	4293740	1973-09-23	1973-09-23 00:00:00	38000275	0	\N	\N	127439	0	384700001	4293740	
22116	1925	4170947	1949-07-28	1949-07-28 00:00:00	38000275	0	\N	\N	128081	0	274474001	4170947	
10431	935	4078793	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	62238	0	180325003	4078793	
22444	1967	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	130754	0	180256009	4107731	
22695	1977	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	131593	0	180256009	4107731	
22885	1992	4107731	1990-10-28	1990-10-28 00:00:00	38000275	0	\N	\N	132704	0	180256009	4107731	
23124	2020	4295880	1995-06-10	1995-06-10 00:00:00	38000275	0	\N	\N	134249	0	76601001	4295880	
23267	2025	4125906	1969-04-05	1969-04-05 00:00:00	38000275	0	\N	\N	134741	0	288086009	4125906	
23500	2058	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	136846	0	180256009	4107731	
11723	1083	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	71116	0	180256009	4107731	
23764	2070	4107731	1990-10-01	1990-10-01 00:00:00	38000275	0	\N	\N	137708	0	180256009	4107731	
122	6	4058899	1976-05-01	1976-05-01 00:00:00	38000275	0	\N	\N	556	0	168594001	4058899	
314	19	4195803	2003-07-16	2003-07-16 00:00:00	38000275	0	\N	\N	1545	0	312681000	4195803	
12371	1113	4186930	1992-11-03	1992-11-03 00:00:00	38000275	0	\N	\N	73245	0	46706006	4186930	
12606	1138	4107731	1994-03-10	1994-03-10 00:00:00	38000275	0	\N	\N	75106	0	180256009	4107731	
12881	1162	4195803	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	76731	0	312681000	4195803	
12959	1175	4107731	1991-09-22	1991-09-22 00:00:00	38000275	0	\N	\N	77439	0	180256009	4107731	
13213	1193	4330583	1983-09-29	1983-09-29 00:00:00	38000275	0	\N	\N	78607	0	22523008	4330583	
13301	1211	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	79616	0	180256009	4107731	
13569	1227	4043071	1947-06-20	1947-06-20 00:00:00	38000275	0	\N	\N	80801	0	228557008	4043071	
13653	1245	4170947	1959-02-17	1959-02-17 00:00:00	38000275	0	\N	\N	81899	0	274474001	4170947	
2002	187	4170947	1948-04-07	1948-04-07 00:00:00	38000275	0	\N	\N	12732	0	274474001	4170947	
2215	225	4107731	1992-12-07	1992-12-07 00:00:00	38000275	0	\N	\N	15247	0	180256009	4107731	
14339	1280	4043071	1965-01-12	1965-01-12 00:00:00	38000275	0	\N	\N	84601	0	228557008	4043071	
2594	266	4107731	1990-03-05	1990-03-05 00:00:00	38000275	0	\N	\N	17674	0	180256009	4107731	
14731	1310	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	86633	0	180256009	4107731	
2953	285	4107731	1990-01-22	1990-01-22 00:00:00	38000275	0	\N	\N	18932	0	180256009	4107731	
15012	1333	4125906	1990-04-07	1990-04-07 00:00:00	38000275	0	\N	\N	88416	0	288086009	4125906	
15150	1356	4107731	1997-02-27	1997-02-27 00:00:00	38000275	0	\N	\N	89968	0	180256009	4107731	
3553	343	4107731	1992-11-21	1992-11-21 00:00:00	38000275	0	\N	\N	22868	0	180256009	4107731	
3678	357	4125906	1961-11-05	1961-11-05 00:00:00	38000275	0	\N	\N	23635	0	288086009	4125906	
3926	399	4107731	1990-12-09	1990-12-09 00:00:00	38000275	0	\N	\N	26202	0	180256009	4107731	
4051	404	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	26573	0	180256009	4107731	
4241	409	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	27081	0	180256009	4107731	
16451	1431	4107731	1990-09-15	1990-09-15 00:00:00	38000275	0	\N	\N	95319	0	180256009	4107731	
16465	1431	4107731	1991-11-09	1991-11-09 00:00:00	38000275	0	\N	\N	95280	0	180256009	4107731	
16683	1447	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	96430	0	180256009	4107731	
5040	469	4043071	1951-04-09	1951-04-09 00:00:00	38000275	0	\N	\N	31323	0	228557008	4043071	
5190	480	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	32047	0	180256009	4107731	
17208	1486	4107731	1991-07-07	1991-07-07 00:00:00	38000275	0	\N	\N	99034	0	180256009	4107731	
5551	507	4078793	2006-09-08	2006-09-08 00:00:00	38000275	0	\N	\N	33968	0	180325003	4078793	
17612	1513	4107731	1992-11-01	1992-11-01 00:00:00	38000275	0	\N	\N	101079	0	180256009	4107731	
5943	545	4293740	2018-09-30	2018-09-30 00:00:00	38000275	0	\N	\N	36147	0	384700001	4293740	
17968	1538	4107731	1991-07-22	1991-07-22 00:00:00	38000275	0	\N	\N	103062	0	180256009	4107731	
18240	1556	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	104199	0	180256009	4107731	
18443	1565	4043071	1972-11-20	1972-11-20 00:00:00	38000275	0	\N	\N	104950	0	228557008	4043071	
6691	610	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	40607	0	180256009	4107731	
18720	1605	4024289	2011-06-01	2011-06-01 00:00:00	38000275	0	\N	\N	107751	0	19490002	4024289	
7091	656	4198190	1996-12-28	1996-12-28 00:00:00	38000275	0	\N	\N	43505	0	80146002	4198190	
19087	1642	4151422	1978-07-15	1978-07-15 00:00:00	38000275	0	\N	\N	110255	0	269911007	4151422	
7419	687	4197460	1969-06-09	1969-06-09 00:00:00	38000275	0	\N	\N	45482	0	313191000	4197460	
19456	1659	4043071	1976-07-26	1976-07-26 00:00:00	38000275	0	\N	\N	111551	0	228557008	4043071	
7843	718	4107731	1990-05-12	1990-05-12 00:00:00	38000275	0	\N	\N	47463	0	180256009	4107731	
19851	1719	4062501	1961-04-15	1961-04-15 00:00:00	38000275	0	\N	\N	114883	0	171231001	4062501	
8182	754	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	49936	0	180256009	4107731	
8349	761	4062501	1980-12-21	1980-12-21 00:00:00	38000275	0	\N	\N	50564	0	171231001	4062501	
20533	1773	4107731	1992-04-26	1992-04-26 00:00:00	38000275	0	\N	\N	118598	0	180256009	4107731	
20727	1783	4062501	1961-08-02	1961-08-02 00:00:00	38000275	0	\N	\N	119420	0	171231001	4062501	
32763	2871	4043071	1961-03-16	1961-03-16 00:00:00	38000275	0	\N	\N	191113	0	228557008	4043071	
9162	843	4107731	1995-07-08	1995-07-08 00:00:00	38000275	0	\N	\N	55803	0	180256009	4107731	
9284	844	4107731	1993-05-08	1993-05-08 00:00:00	38000275	0	\N	\N	55898	0	180256009	4107731	
21326	1845	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	123334	0	180256009	4107731	
33557	2925	4107731	1993-01-17	1993-01-17 00:00:00	38000275	0	\N	\N	195078	0	180256009	4107731	
9859	884	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	58901	0	180256009	4107731	
21996	1916	4125906	2004-10-31	2004-10-31 00:00:00	38000275	0	\N	\N	127446	0	288086009	4125906	
22117	1925	4058899	1952-07-12	1952-07-12 00:00:00	38000275	0	\N	\N	128082	0	168594001	4058899	
10432	935	4058899	1961-08-26	1961-08-26 00:00:00	38000275	0	\N	\N	62226	0	168594001	4058899	
22445	1967	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	130750	0	180256009	4107731	
22696	1977	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	131540	0	180256009	4107731	
22886	1992	4107731	1992-06-28	1992-06-28 00:00:00	38000275	0	\N	\N	132670	0	180256009	4107731	
23125	2020	4295880	1995-09-09	1995-09-09 00:00:00	38000275	0	\N	\N	134270	0	76601001	4295880	
23268	2025	4078793	1979-12-15	1979-12-15 00:00:00	38000275	0	\N	\N	134674	0	180325003	4078793	
23501	2058	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	136829	0	180256009	4107731	
11724	1083	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	71114	0	180256009	4107731	
23765	2070	4024289	1988-02-07	1988-02-07 00:00:00	38000275	0	\N	\N	137727	0	19490002	4024289	
123	6	4125906	2004-05-09	2004-05-09 00:00:00	38000275	0	\N	\N	561	0	288086009	4125906	
315	19	4078793	2017-05-21	2017-05-21 00:00:00	38000275	0	\N	\N	1473	0	180325003	4078793	
12375	1115	4107731	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	73353	0	180256009	4107731	
12607	1138	4107731	1994-03-31	1994-03-31 00:00:00	38000275	0	\N	\N	75044	0	180256009	4107731	
12882	1162	4243062	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	76731	0	60027007	4243062	
12960	1175	4107731	1991-08-11	1991-08-11 00:00:00	38000275	0	\N	\N	77458	0	180256009	4107731	
13214	1193	4163872	1951-11-14	1951-11-14 00:00:00	38000275	0	\N	\N	78617	0	399208008	4163872	
13302	1211	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	79524	0	180256009	4107731	
13570	1227	4043071	1947-08-15	1947-08-15 00:00:00	38000275	0	\N	\N	80747	0	228557008	4043071	
13654	1245	4024289	1959-02-17	1959-02-17 00:00:00	38000275	0	\N	\N	81899	0	19490002	4024289	
2003	187	4195803	2012-04-15	2012-04-15 00:00:00	38000275	0	\N	\N	12739	0	312681000	4195803	
2216	225	4107731	1991-02-25	1991-02-25 00:00:00	38000275	0	\N	\N	15213	0	180256009	4107731	
14340	1280	4043071	1965-06-29	1965-06-29 00:00:00	38000275	0	\N	\N	84553	0	228557008	4043071	
2595	266	4191853	1990-01-01	1990-01-01 00:00:00	38000275	0	\N	\N	17652	0	395142003	4191853	
14732	1310	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	86571	0	180256009	4107731	
2954	285	4107731	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	18990	0	180256009	4107731	
15013	1333	4252419	2002-05-18	2002-05-18 00:00:00	38000275	0	\N	\N	88417	0	74016001	4252419	
15151	1356	4107731	1998-07-16	1998-07-16 00:00:00	38000275	0	\N	\N	89867	0	180256009	4107731	
15367	1371	4024289	1991-08-01	1991-08-01 00:00:00	38000275	0	\N	\N	90895	0	19490002	4024289	
3679	357	4293740	1961-11-05	1961-11-05 00:00:00	38000275	0	\N	\N	23635	0	384700001	4293740	
3927	399	4058899	1980-07-16	1980-07-16 00:00:00	38000275	0	\N	\N	26237	0	168594001	4058899	
4052	404	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	26568	0	180256009	4107731	
4242	409	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	27112	0	180256009	4107731	
16452	1431	4107731	1990-11-17	1990-11-17 00:00:00	38000275	0	\N	\N	95216	0	180256009	4107731	
16466	1431	4107731	1990-01-27	1990-01-27 00:00:00	38000275	0	\N	\N	95317	0	180256009	4107731	
16684	1447	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	96539	0	180256009	4107731	
5041	469	4043071	1947-03-03	1947-03-03 00:00:00	38000275	0	\N	\N	31236	0	228557008	4043071	
5191	480	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	32024	0	180256009	4107731	
17209	1486	4107731	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	99020	0	180256009	4107731	
5552	507	4078793	2011-09-23	2011-09-23 00:00:00	38000275	0	\N	\N	33971	0	180325003	4078793	
17613	1513	4107731	1990-09-16	1990-09-16 00:00:00	38000275	0	\N	\N	101137	0	180256009	4107731	
5944	545	4125906	2018-09-30	2018-09-30 00:00:00	38000275	0	\N	\N	36147	0	288086009	4125906	
17969	1538	4125906	1960-08-23	1960-08-23 00:00:00	38000275	0	\N	\N	102945	0	288086009	4125906	
18241	1556	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	104197	0	180256009	4107731	
18444	1565	4043071	1974-01-21	1974-01-21 00:00:00	38000275	0	\N	\N	104954	0	228557008	4043071	
6692	610	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	40520	0	180256009	4107731	
18721	1605	4170947	2011-06-01	2011-06-01 00:00:00	38000275	0	\N	\N	107751	0	274474001	4170947	
18952	1618	4336464	2006-04-12	2006-04-12 00:00:00	38000275	0	\N	\N	108786	0	232717009	4336464	
19088	1642	4163872	2018-07-05	2018-07-05 00:00:00	38000275	0	\N	\N	110212	0	399208008	4163872	
7420	687	4058899	1984-07-20	1984-07-20 00:00:00	38000275	0	\N	\N	45490	0	168594001	4058899	
19457	1659	4043071	1982-11-08	1982-11-08 00:00:00	38000275	0	\N	\N	111434	0	228557008	4043071	
7844	718	4107731	1990-08-04	1990-08-04 00:00:00	38000275	0	\N	\N	47501	0	180256009	4107731	
19852	1719	4151422	1973-03-18	1973-03-18 00:00:00	38000275	0	\N	\N	114921	0	269911007	4151422	
8183	754	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	49968	0	180256009	4107731	
8350	761	4107731	1994-12-16	1994-12-16 00:00:00	38000275	0	\N	\N	50579	0	180256009	4107731	
20534	1773	4107731	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	118574	0	180256009	4107731	
20728	1783	4107731	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	119429	0	180256009	4107731	
32764	2871	4043071	1963-05-30	1963-05-30 00:00:00	38000275	0	\N	\N	191082	0	228557008	4043071	
9163	843	4107731	1996-02-03	1996-02-03 00:00:00	38000275	0	\N	\N	55810	0	180256009	4107731	
9285	844	4170947	1979-01-15	1979-01-15 00:00:00	38000275	0	\N	\N	56001	0	274474001	4170947	
21327	1845	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	123352	0	180256009	4107731	
33558	2925	4107731	1992-11-15	1992-11-15 00:00:00	38000275	0	\N	\N	195128	0	180256009	4107731	
9860	884	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	58945	0	180256009	4107731	
21997	1916	4252419	1982-05-23	1982-05-23 00:00:00	38000275	0	\N	\N	127442	0	74016001	4252419	
22118	1925	4293740	2019-02-03	2019-02-03 00:00:00	38000275	0	\N	\N	128178	0	384700001	4293740	
10433	935	4243062	1931-04-06	1931-04-06 00:00:00	38000275	0	\N	\N	62223	0	60027007	4243062	
22446	1967	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	130785	0	180256009	4107731	
22697	1977	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	131614	0	180256009	4107731	
22887	1992	4107731	1993-05-09	1993-05-09 00:00:00	38000275	0	\N	\N	132644	0	180256009	4107731	
23126	2020	4295880	1995-12-09	1995-12-09 00:00:00	38000275	0	\N	\N	134294	0	76601001	4295880	
23269	2025	4078793	1994-03-05	1994-03-05 00:00:00	38000275	0	\N	\N	134645	0	180325003	4078793	
23502	2058	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	136836	0	180256009	4107731	
11725	1083	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	71117	0	180256009	4107731	
23766	2070	4170947	1988-02-07	1988-02-07 00:00:00	38000275	0	\N	\N	137727	0	274474001	4170947	
124	6	4125906	1971-08-12	1971-08-12 00:00:00	38000275	0	\N	\N	555	0	288086009	4125906	
12286	1107	4125906	1929-01-07	1929-01-07 00:00:00	38000275	0	\N	\N	72862	0	288086009	4125906	
12376	1115	4107731	1991-04-29	1991-04-29 00:00:00	38000275	0	\N	\N	73361	0	180256009	4107731	
12608	1138	4107731	1993-07-01	1993-07-01 00:00:00	38000275	0	\N	\N	75040	0	180256009	4107731	
12883	1162	4170947	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	76731	0	274474001	4170947	
12961	1175	4107731	1991-06-30	1991-06-30 00:00:00	38000275	0	\N	\N	77457	0	180256009	4107731	
13215	1193	4170947	1951-11-14	1951-11-14 00:00:00	38000275	0	\N	\N	78617	0	274474001	4170947	
13303	1211	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	79504	0	180256009	4107731	
13571	1227	4057420	2016-04-06	2016-04-06 00:00:00	38000275	0	\N	\N	80766	0	18286008	4057420	
13655	1245	4078793	2018-07-13	2018-07-13 00:00:00	38000275	0	\N	\N	81924	0	180325003	4078793	
2004	187	4058899	2012-04-15	2012-04-15 00:00:00	38000275	0	\N	\N	12739	0	168594001	4058899	
2217	225	4107731	1992-10-05	1992-10-05 00:00:00	38000275	0	\N	\N	15220	0	180256009	4107731	
14341	1280	4043071	1965-04-27	1965-04-27 00:00:00	38000275	0	\N	\N	84614	0	228557008	4043071	
2596	266	4145310	2018-09-26	2018-09-26 00:00:00	38000275	0	\N	\N	17694	0	268425006	4145310	
14733	1310	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	86628	0	180256009	4107731	
2955	285	4191853	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	18983	0	395142003	4191853	
15014	1333	44783196	2002-05-25	2002-05-25 00:00:00	38000275	0	\N	\N	88486	0	699253003	44783196	
15152	1356	4107731	1995-06-08	1995-06-08 00:00:00	38000275	0	\N	\N	89877	0	180256009	4107731	
15368	1371	4170947	1991-08-01	1991-08-01 00:00:00	38000275	0	\N	\N	90895	0	274474001	4170947	
3680	357	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	23666	0	395142003	4191853	
15709	1391	4293740	1999-04-14	1999-04-14 00:00:00	38000275	0	\N	\N	92410	0	384700001	4293740	
4053	404	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	26641	0	180256009	4107731	
4243	409	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	27122	0	180256009	4107731	
16453	1431	4107731	1991-05-04	1991-05-04 00:00:00	38000275	0	\N	\N	95294	0	180256009	4107731	
16467	1431	4191853	1993-07-10	1993-07-10 00:00:00	38000275	0	\N	\N	95274	0	395142003	4191853	
16685	1447	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	96477	0	180256009	4107731	
5042	469	4043071	1947-11-03	1947-11-03 00:00:00	38000275	0	\N	\N	31315	0	228557008	4043071	
5192	480	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	31997	0	180256009	4107731	
17210	1486	4107731	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	99098	0	180256009	4107731	
5553	507	4078793	1993-09-17	1993-09-17 00:00:00	38000275	0	\N	\N	33944	0	180325003	4078793	
17614	1513	4107731	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	101078	0	180256009	4107731	
5945	545	4107731	1993-04-17	1993-04-17 00:00:00	38000275	0	\N	\N	36061	0	180256009	4107731	
17970	1538	4107731	1992-12-28	1992-12-28 00:00:00	38000275	0	\N	\N	102964	0	180256009	4107731	
18242	1556	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	104175	0	180256009	4107731	
18445	1565	4043071	1973-08-20	1973-08-20 00:00:00	38000275	0	\N	\N	104952	0	228557008	4043071	
6693	610	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	40521	0	180256009	4107731	
18722	1605	4202451	2006-09-17	2006-09-17 00:00:00	38000275	0	\N	\N	107770	0	433112001	4202451	
18953	1618	4216130	2006-04-12	2006-04-12 00:00:00	38000275	0	\N	\N	108786	0	415070008	4216130	
19089	1642	4037675	1979-05-15	1979-05-15 00:00:00	38000275	0	\N	\N	110279	0	162676008	4037675	
7421	687	4058899	1981-07-06	1981-07-06 00:00:00	38000275	0	\N	\N	45488	0	168594001	4058899	
19458	1659	4043071	1976-10-18	1976-10-18 00:00:00	38000275	0	\N	\N	111511	0	228557008	4043071	
7845	718	4107731	1993-04-17	1993-04-17 00:00:00	38000275	0	\N	\N	47485	0	180256009	4107731	
19853	1719	4170947	2004-12-27	2004-12-27 00:00:00	38000275	0	\N	\N	114996	0	274474001	4170947	
8184	754	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	49827	0	180256009	4107731	
8351	761	4107731	1995-04-21	1995-04-21 00:00:00	38000275	0	\N	\N	50582	0	180256009	4107731	
20535	1773	4107731	1990-02-18	1990-02-18 00:00:00	38000275	0	\N	\N	118558	0	180256009	4107731	
20729	1783	4107731	1992-12-28	1992-12-28 00:00:00	38000275	0	\N	\N	119523	0	180256009	4107731	
32765	2871	4043071	1963-04-04	1963-04-04 00:00:00	38000275	0	\N	\N	191118	0	228557008	4043071	
20945	1808	4238715	1979-02-27	1979-02-27 00:00:00	38000275	0	\N	\N	121052	0	68254000	4238715	
9286	844	4024289	1979-01-15	1979-01-15 00:00:00	38000275	0	\N	\N	56001	0	19490002	4024289	
21328	1845	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	123368	0	180256009	4107731	
33559	2925	4191853	1989-12-31	1989-12-31 00:00:00	38000275	0	\N	\N	195093	0	395142003	4191853	
9861	884	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	58847	0	180256009	4107731	
21998	1916	4062501	1974-10-10	1974-10-10 00:00:00	38000275	0	\N	\N	127450	0	171231001	4062501	
22119	1925	4125906	2019-02-03	2019-02-03 00:00:00	38000275	0	\N	\N	128178	0	288086009	4125906	
10434	935	4170947	1931-04-06	1931-04-06 00:00:00	38000275	0	\N	\N	62223	0	274474001	4170947	
22447	1967	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	130793	0	180256009	4107731	
22698	1977	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	131633	0	180256009	4107731	
22888	1992	4107731	1990-06-03	1990-06-03 00:00:00	38000275	0	\N	\N	132735	0	180256009	4107731	
23127	2020	4295880	1994-09-05	1994-09-05 00:00:00	38000275	0	\N	\N	134285	0	76601001	4295880	
23270	2025	4078793	1990-02-10	1990-02-10 00:00:00	38000275	0	\N	\N	134763	0	180325003	4078793	
23503	2058	4238715	1983-12-07	1983-12-07 00:00:00	38000275	0	\N	\N	136864	0	68254000	4238715	
11726	1083	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	71166	0	180256009	4107731	
23767	2070	4107731	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	137747	0	180256009	4107731	
125	6	4181917	2003-12-21	2003-12-21 00:00:00	38000275	0	\N	\N	559	0	54550000	4181917	
12287	1107	4145310	1927-12-14	1927-12-14 00:00:00	38000275	0	\N	\N	72861	0	268425006	4145310	
12377	1115	4107731	1990-12-03	1990-12-03 00:00:00	38000275	0	\N	\N	73409	0	180256009	4107731	
12609	1138	4107731	1993-04-29	1993-04-29 00:00:00	38000275	0	\N	\N	75071	0	180256009	4107731	
12884	1162	4170947	1952-10-08	1952-10-08 00:00:00	38000275	0	\N	\N	76729	0	274474001	4170947	
12962	1175	4107731	1993-06-13	1993-06-13 00:00:00	38000275	0	\N	\N	77510	0	180256009	4107731	
13216	1193	4163872	1979-12-05	1979-12-05 00:00:00	38000275	0	\N	\N	78667	0	399208008	4163872	
13304	1211	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	79600	0	180256009	4107731	
13572	1227	4043071	1947-04-18	1947-04-18 00:00:00	38000275	0	\N	\N	80726	0	228557008	4043071	
13656	1245	4170947	2008-08-08	2008-08-08 00:00:00	38000275	0	\N	\N	81905	0	274474001	4170947	
2005	187	4125906	1980-01-09	1980-01-09 00:00:00	38000275	0	\N	\N	12736	0	288086009	4125906	
2218	225	4107731	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	15210	0	180256009	4107731	
14342	1280	4043071	1965-03-23	1965-03-23 00:00:00	38000275	0	\N	\N	84598	0	228557008	4043071	
2597	266	4195803	2018-09-26	2018-09-26 00:00:00	38000275	0	\N	\N	17694	0	312681000	4195803	
14734	1310	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	86558	0	180256009	4107731	
2956	285	4107731	1992-01-27	1992-01-27 00:00:00	38000275	0	\N	\N	18950	0	180256009	4107731	
15015	1333	4238715	1976-03-14	1976-03-14 00:00:00	38000275	0	\N	\N	88477	0	68254000	4238715	
15153	1356	4107731	1997-01-16	1997-01-16 00:00:00	38000275	0	\N	\N	89967	0	180256009	4107731	
15369	1371	4125906	1999-06-20	1999-06-20 00:00:00	38000275	0	\N	\N	90939	0	288086009	4125906	
3681	357	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	23661	0	180256009	4107731	
15710	1391	4125906	1999-04-14	1999-04-14 00:00:00	38000275	0	\N	\N	92410	0	288086009	4125906	
4054	404	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	26694	0	180256009	4107731	
4244	410	4151422	1975-02-18	1975-02-18 00:00:00	38000275	0	\N	\N	27197	0	269911007	4151422	
16454	1431	4107731	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	95214	0	180256009	4107731	
16468	1431	4107731	1992-12-12	1992-12-12 00:00:00	38000275	0	\N	\N	95261	0	180256009	4107731	
16686	1447	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	96547	0	180256009	4107731	
5043	469	4043071	1946-12-30	1946-12-30 00:00:00	38000275	0	\N	\N	31275	0	228557008	4043071	
5193	480	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	32072	0	180256009	4107731	
17211	1486	4107731	1990-08-26	1990-08-26 00:00:00	38000275	0	\N	\N	99030	0	180256009	4107731	
5554	507	4125906	1946-11-05	1946-11-05 00:00:00	38000275	0	\N	\N	33956	0	288086009	4125906	
17615	1513	4107731	1991-11-10	1991-11-10 00:00:00	38000275	0	\N	\N	101074	0	180256009	4107731	
5946	545	4107731	1993-05-08	1993-05-08 00:00:00	38000275	0	\N	\N	36080	0	180256009	4107731	
17971	1538	4107731	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	102979	0	180256009	4107731	
18243	1556	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	104170	0	180256009	4107731	
18446	1565	4151422	1998-11-25	1998-11-25 00:00:00	38000275	0	\N	\N	104940	0	269911007	4151422	
6694	610	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	40533	0	180256009	4107731	
18723	1605	4125906	1948-12-13	1948-12-13 00:00:00	38000275	0	\N	\N	107746	0	288086009	4125906	
18954	1618	4151422	1992-12-21	1992-12-21 00:00:00	38000275	0	\N	\N	108827	0	269911007	4151422	
19090	1642	4326177	1979-05-15	1979-05-15 00:00:00	38000275	0	\N	\N	110279	0	430193006	4326177	
7422	689	4295880	2000-08-13	2000-08-13 00:00:00	38000275	0	\N	\N	45650	0	76601001	4295880	
19459	1659	4043071	1981-03-09	1981-03-09 00:00:00	38000275	0	\N	\N	111573	0	228557008	4043071	
7846	718	4107731	1991-07-06	1991-07-06 00:00:00	38000275	0	\N	\N	47498	0	180256009	4107731	
19854	1719	4024289	2004-12-27	2004-12-27 00:00:00	38000275	0	\N	\N	114996	0	19490002	4024289	
8185	754	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	49973	0	180256009	4107731	
8352	761	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	50535	0	180256009	4107731	
20536	1773	4107731	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	118575	0	180256009	4107731	
20730	1783	4107731	1991-03-18	1991-03-18 00:00:00	38000275	0	\N	\N	119550	0	180256009	4107731	
32766	2871	4043071	1963-05-02	1963-05-02 00:00:00	38000275	0	\N	\N	191071	0	228557008	4043071	
20946	1809	4047491	1978-08-20	1978-08-20 00:00:00	38000275	0	\N	\N	121088	0	1225002	4047491	
9287	844	4107731	1991-10-19	1991-10-19 00:00:00	38000275	0	\N	\N	55978	0	180256009	4107731	
21329	1845	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	123328	0	180256009	4107731	
33560	2925	4107731	1992-01-26	1992-01-26 00:00:00	38000275	0	\N	\N	195073	0	180256009	4107731	
9862	884	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	58903	0	180256009	4107731	
21999	1917	4202451	2006-06-04	2006-06-04 00:00:00	38000275	0	\N	\N	127552	0	433112001	4202451	
22120	1926	4058899	1984-06-26	1984-06-26 00:00:00	38000275	0	\N	\N	128199	0	168594001	4058899	
10435	935	4243062	1936-04-09	1936-04-09 00:00:00	38000275	0	\N	\N	62225	0	60027007	4243062	
22448	1967	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	130862	0	180256009	4107731	
22699	1977	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	131612	0	180256009	4107731	
22889	1992	4107731	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	132694	0	180256009	4107731	
34970	3049	4057420	1991-07-12	1991-07-12 00:00:00	38000275	0	\N	\N	202875	0	18286008	4057420	
23271	2025	4125906	1965-01-12	1965-01-12 00:00:00	38000275	0	\N	\N	134739	0	288086009	4125906	
23504	2058	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	136807	0	180256009	4107731	
11727	1083	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	71096	0	180256009	4107731	
23768	2070	4107731	1993-03-01	1993-03-01 00:00:00	38000275	0	\N	\N	137763	0	180256009	4107731	
126	7	4058899	1974-08-12	1974-08-12 00:00:00	38000275	0	\N	\N	631	0	168594001	4058899	
12288	1107	4336464	2007-06-15	2007-06-15 00:00:00	38000275	0	\N	\N	72859	0	232717009	4336464	
12378	1115	4107731	1990-05-07	1990-05-07 00:00:00	38000275	0	\N	\N	73456	0	180256009	4107731	
12610	1138	4107731	1996-06-06	1996-06-06 00:00:00	38000275	0	\N	\N	75112	0	180256009	4107731	
12885	1162	4024289	1952-10-08	1952-10-08 00:00:00	38000275	0	\N	\N	76729	0	19490002	4024289	
12963	1175	4107731	1991-04-28	1991-04-28 00:00:00	38000275	0	\N	\N	77445	0	180256009	4107731	
13217	1193	4151422	2008-07-08	2008-07-08 00:00:00	38000275	0	\N	\N	78606	0	269911007	4151422	
13305	1211	4293740	1980-10-07	1980-10-07 00:00:00	38000275	0	\N	\N	79570	0	384700001	4293740	
13573	1227	4058899	1981-02-22	1981-02-22 00:00:00	38000275	0	\N	\N	80822	0	168594001	4058899	
13657	1245	4163872	2008-08-08	2008-08-08 00:00:00	38000275	0	\N	\N	81905	0	399208008	4163872	
2006	187	4125906	1957-04-20	1957-04-20 00:00:00	38000275	0	\N	\N	12733	0	288086009	4125906	
2219	225	4107731	1991-02-04	1991-02-04 00:00:00	38000275	0	\N	\N	15142	0	180256009	4107731	
14343	1280	4301346	1976-03-04	1976-03-04 00:00:00	38000275	0	\N	\N	84571	0	387685009	4301346	
2598	266	4107731	1993-02-08	1993-02-08 00:00:00	38000275	0	\N	\N	17732	0	180256009	4107731	
14735	1310	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	86590	0	180256009	4107731	
2957	285	4107731	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	18944	0	180256009	4107731	
15016	1333	4125906	2013-05-27	2013-05-27 00:00:00	38000275	0	\N	\N	88418	0	288086009	4125906	
15154	1356	4107731	1996-02-15	1996-02-15 00:00:00	38000275	0	\N	\N	89893	0	180256009	4107731	
15370	1371	4243062	1998-04-26	1998-04-26 00:00:00	38000275	0	\N	\N	90896	0	60027007	4243062	
3682	357	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	23768	0	180256009	4107731	
15840	1397	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	92811	0	180256009	4107731	
4055	404	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	26587	0	180256009	4107731	
4245	410	4125906	1990-04-04	1990-04-04 00:00:00	38000275	0	\N	\N	27157	0	288086009	4125906	
16455	1431	4107731	1990-06-02	1990-06-02 00:00:00	38000275	0	\N	\N	95302	0	180256009	4107731	
16469	1431	4107731	1992-11-21	1992-11-21 00:00:00	38000275	0	\N	\N	95273	0	180256009	4107731	
16687	1447	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	96549	0	180256009	4107731	
5044	469	4195803	2014-12-19	2014-12-19 00:00:00	38000275	0	\N	\N	31366	0	312681000	4195803	
5194	480	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	32106	0	180256009	4107731	
17212	1486	4107731	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	99115	0	180256009	4107731	
5555	507	4078793	1996-08-30	1996-08-30 00:00:00	38000275	0	\N	\N	33929	0	180325003	4078793	
17616	1513	4107731	1991-09-29	1991-09-29 00:00:00	38000275	0	\N	\N	101073	0	180256009	4107731	
5947	545	4107731	1991-11-09	1991-11-09 00:00:00	38000275	0	\N	\N	36104	0	180256009	4107731	
17972	1538	4078793	2008-05-05	2008-05-05 00:00:00	38000275	0	\N	\N	103050	0	180325003	4078793	
18244	1556	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	104215	0	180256009	4107731	
18447	1565	4043071	1974-05-06	1974-05-06 00:00:00	38000275	0	\N	\N	104935	0	228557008	4043071	
6695	610	4125906	1963-08-25	1963-08-25 00:00:00	38000275	0	\N	\N	40587	0	288086009	4125906	
18724	1605	40492359	2019-05-12	2019-05-12 00:00:00	38000275	0	\N	\N	107753	0	447365002	40492359	
18959	1622	4295880	1995-01-30	1995-01-30 00:00:00	38000275	0	\N	\N	108960	0	76601001	4295880	
19091	1642	4187458	1979-05-15	1979-05-15 00:00:00	38000275	0	\N	\N	110279	0	415300000	4187458	
7423	689	4295880	2005-08-07	2005-08-07 00:00:00	38000275	0	\N	\N	45679	0	76601001	4295880	
19460	1659	4043071	1982-04-19	1982-04-19 00:00:00	38000275	0	\N	\N	111431	0	228557008	4043071	
7847	718	4191853	1990-01-06	1990-01-06 00:00:00	38000275	0	\N	\N	47491	0	395142003	4191853	
19855	1719	4195803	2017-06-13	2017-06-13 00:00:00	38000275	0	\N	\N	114975	0	312681000	4195803	
8186	754	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	49902	0	180256009	4107731	
8353	761	4107731	1994-10-14	1994-10-14 00:00:00	38000275	0	\N	\N	50609	0	180256009	4107731	
20537	1773	4107731	1990-10-07	1990-10-07 00:00:00	38000275	0	\N	\N	118560	0	180256009	4107731	
20731	1783	4107731	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	119505	0	180256009	4107731	
32767	2871	4043071	1962-07-05	1962-07-05 00:00:00	38000275	0	\N	\N	191096	0	228557008	4043071	
20947	1809	4170947	1978-08-20	1978-08-20 00:00:00	38000275	0	\N	\N	121088	0	274474001	4170947	
9288	844	4197460	1980-05-09	1980-05-09 00:00:00	38000275	0	\N	\N	56002	0	313191000	4197460	
21330	1845	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	123320	0	180256009	4107731	
33561	2925	4107731	1992-03-08	1992-03-08 00:00:00	38000275	0	\N	\N	195074	0	180256009	4107731	
9863	884	4107731	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	58852	0	180256009	4107731	
22000	1918	4043071	1978-09-04	1978-09-04 00:00:00	38000275	0	\N	\N	127631	0	228557008	4043071	
22121	1926	4243062	2005-07-27	2005-07-27 00:00:00	38000275	0	\N	\N	128201	0	60027007	4243062	
10436	935	4170947	1936-04-09	1936-04-09 00:00:00	38000275	0	\N	\N	62225	0	274474001	4170947	
22449	1967	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	130797	0	180256009	4107731	
22700	1977	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	131596	0	180256009	4107731	
22890	1992	4107731	1992-08-30	1992-08-30 00:00:00	38000275	0	\N	\N	132655	0	180256009	4107731	
34971	3049	40492359	1991-07-12	1991-07-12 00:00:00	38000275	0	\N	\N	202875	0	447365002	40492359	
23272	2025	4024289	1979-09-01	1979-09-01 00:00:00	38000275	0	\N	\N	134742	0	19490002	4024289	
23505	2058	44783196	2013-08-16	2013-08-16 00:00:00	38000275	0	\N	\N	136811	0	699253003	44783196	
11728	1083	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	71110	0	180256009	4107731	
23769	2070	4107731	1993-01-18	1993-01-18 00:00:00	38000275	0	\N	\N	137762	0	180256009	4107731	
127	7	4163872	2001-07-18	2001-07-18 00:00:00	38000275	0	\N	\N	625	0	399208008	4163872	
12289	1107	4216130	2007-06-15	2007-06-15 00:00:00	38000275	0	\N	\N	72859	0	415070008	4216130	
12379	1115	4107731	1990-03-05	1990-03-05 00:00:00	38000275	0	\N	\N	73406	0	180256009	4107731	
12611	1138	4043071	1996-09-12	1996-09-12 00:00:00	38000275	0	\N	\N	75033	0	228557008	4043071	
12886	1162	4151422	2002-07-15	2002-07-15 00:00:00	38000275	0	\N	\N	76754	0	269911007	4151422	
12964	1175	4107731	1993-05-23	1993-05-23 00:00:00	38000275	0	\N	\N	77537	0	180256009	4107731	
13218	1194	4125906	1978-09-15	1978-09-15 00:00:00	38000275	0	\N	\N	78687	0	288086009	4125906	
13306	1211	4125906	1980-10-07	1980-10-07 00:00:00	38000275	0	\N	\N	79570	0	288086009	4125906	
13574	1227	44783196	1961-09-05	1961-09-05 00:00:00	38000275	0	\N	\N	80757	0	699253003	44783196	
13658	1245	4195803	2008-08-08	2008-08-08 00:00:00	38000275	0	\N	\N	81905	0	312681000	4195803	
2007	188	4125906	1975-09-11	1975-09-11 00:00:00	38000275	0	\N	\N	12783	0	288086009	4125906	
2220	225	4107731	1991-09-23	1991-09-23 00:00:00	38000275	0	\N	\N	15190	0	180256009	4107731	
14344	1280	4125906	2017-04-28	2017-04-28 00:00:00	38000275	0	\N	\N	84527	0	288086009	4125906	
2599	266	4107731	1991-01-14	1991-01-14 00:00:00	38000275	0	\N	\N	17708	0	180256009	4107731	
14736	1310	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	86613	0	395142003	4191853	
2958	285	4107731	1990-03-05	1990-03-05 00:00:00	38000275	0	\N	\N	18919	0	180256009	4107731	
15017	1333	4275113	1970-09-23	1970-09-23 00:00:00	38000275	0	\N	\N	88476	0	65200003	4275113	
15155	1356	4107731	1997-07-03	1997-07-03 00:00:00	38000275	0	\N	\N	89898	0	180256009	4107731	
15371	1371	4170947	1998-04-26	1998-04-26 00:00:00	38000275	0	\N	\N	90896	0	274474001	4170947	
3683	357	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	23693	0	180256009	4107731	
15841	1397	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	92803	0	180256009	4107731	
4056	404	4043071	1971-04-30	1971-04-30 00:00:00	38000275	0	\N	\N	26677	0	228557008	4043071	
4246	410	4198190	1951-09-02	1951-09-02 00:00:00	38000275	0	\N	\N	27160	0	80146002	4198190	
16456	1431	4107731	1992-02-22	1992-02-22 00:00:00	38000275	0	\N	\N	95270	0	180256009	4107731	
16470	1431	4107731	1991-05-25	1991-05-25 00:00:00	38000275	0	\N	\N	95217	0	180256009	4107731	
16688	1447	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	96472	0	180256009	4107731	
5045	469	4058899	2014-12-19	2014-12-19 00:00:00	38000275	0	\N	\N	31366	0	168594001	4058899	
5195	480	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	31974	0	180256009	4107731	
17213	1486	4107731	1991-05-05	1991-05-05 00:00:00	38000275	0	\N	\N	99120	0	180256009	4107731	
5556	507	4057420	2001-08-10	2001-08-10 00:00:00	38000275	0	\N	\N	33962	0	18286008	4057420	
17617	1513	4107731	1990-04-22	1990-04-22 00:00:00	38000275	0	\N	\N	101122	0	180256009	4107731	
5948	545	4107731	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	36107	0	180256009	4107731	
17973	1538	4057420	2010-05-17	2010-05-17 00:00:00	38000275	0	\N	\N	103084	0	18286008	4057420	
18245	1556	4151422	1996-10-26	1996-10-26 00:00:00	38000275	0	\N	\N	104156	0	269911007	4151422	
18448	1565	4330583	2007-09-17	2007-09-17 00:00:00	38000275	0	\N	\N	104898	0	22523008	4330583	
6696	610	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	40498	0	180256009	4107731	
18725	1605	4057420	2019-05-12	2019-05-12 00:00:00	38000275	0	\N	\N	107753	0	18286008	4057420	
18960	1622	4295880	2002-04-22	2002-04-22 00:00:00	38000275	0	\N	\N	109047	0	76601001	4295880	
19092	1642	4202451	2008-06-17	2008-06-17 00:00:00	38000275	0	\N	\N	110265	0	433112001	4202451	
7424	689	4295880	2001-05-13	2001-05-13 00:00:00	38000275	0	\N	\N	45651	0	76601001	4295880	
19461	1659	4043071	1976-06-21	1976-06-21 00:00:00	38000275	0	\N	\N	111510	0	228557008	4043071	
7848	718	4107731	1990-02-17	1990-02-17 00:00:00	38000275	0	\N	\N	47442	0	180256009	4107731	
19856	1719	4170947	1967-03-09	1967-03-09 00:00:00	38000275	0	\N	\N	114916	0	274474001	4170947	
8187	754	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	49959	0	180256009	4107731	
8354	761	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	50537	0	180256009	4107731	
20538	1773	4107731	1993-03-28	1993-03-28 00:00:00	38000275	0	\N	\N	118510	0	180256009	4107731	
20732	1783	4107731	1990-04-16	1990-04-16 00:00:00	38000275	0	\N	\N	119481	0	180256009	4107731	
32768	2871	4043071	1961-01-05	1961-01-05 00:00:00	38000275	0	\N	\N	191051	0	228557008	4043071	
20948	1809	4125906	2004-12-01	2004-12-01 00:00:00	38000275	0	\N	\N	121089	0	288086009	4125906	
9292	847	4058899	1967-02-02	1967-02-02 00:00:00	38000275	0	\N	\N	56136	0	168594001	4058899	
21331	1845	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	123300	0	180256009	4107731	
33562	2925	4107731	1990-12-23	1990-12-23 00:00:00	38000275	0	\N	\N	195103	0	180256009	4107731	
9864	884	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	58881	0	180256009	4107731	
22001	1918	4125906	2018-08-21	2018-08-21 00:00:00	38000275	0	\N	\N	127587	0	288086009	4125906	
22122	1926	4170947	2005-07-27	2005-07-27 00:00:00	38000275	0	\N	\N	128201	0	274474001	4170947	
10437	935	4202451	1994-05-25	1994-05-25 00:00:00	38000275	0	\N	\N	62162	0	433112001	4202451	
22450	1967	4197460	1960-07-18	1960-07-18 00:00:00	38000275	0	\N	\N	130888	0	313191000	4197460	
22701	1977	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	131578	0	180256009	4107731	
22891	1992	4107731	1991-01-20	1991-01-20 00:00:00	38000275	0	\N	\N	132737	0	180256009	4107731	
34972	3049	4125906	2017-06-20	2017-06-20 00:00:00	38000275	0	\N	\N	202878	0	288086009	4125906	
23273	2025	4170947	1979-09-01	1979-09-01 00:00:00	38000275	0	\N	\N	134742	0	274474001	4170947	
23506	2058	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	136900	0	180256009	4107731	
11729	1083	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	71091	0	180256009	4107731	
23770	2071	4163872	1970-02-20	1970-02-20 00:00:00	38000275	0	\N	\N	137800	0	399208008	4163872	
128	7	4293740	1972-07-09	1972-07-09 00:00:00	38000275	0	\N	\N	630	0	384700001	4293740	
12290	1107	4195803	2004-12-09	2004-12-09 00:00:00	38000275	0	\N	\N	72858	0	312681000	4195803	
12380	1115	4107731	1991-03-18	1991-03-18 00:00:00	38000275	0	\N	\N	73360	0	180256009	4107731	
12612	1138	4043071	1994-10-27	1994-10-27 00:00:00	38000275	0	\N	\N	75077	0	228557008	4043071	
12887	1162	4151422	1942-02-15	1942-02-15 00:00:00	38000275	0	\N	\N	76674	0	269911007	4151422	
12965	1175	4107731	1992-06-21	1992-06-21 00:00:00	38000275	0	\N	\N	77525	0	180256009	4107731	
13219	1194	4058899	1995-07-09	1995-07-09 00:00:00	38000275	0	\N	\N	78688	0	168594001	4058899	
13307	1211	4125906	2004-04-02	2004-04-02 00:00:00	38000275	0	\N	\N	79575	0	288086009	4125906	
13575	1227	4043071	1947-03-14	1947-03-14 00:00:00	38000275	0	\N	\N	80725	0	228557008	4043071	
13659	1246	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	82005	0	180256009	4107731	
2008	189	4125906	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	12890	0	288086009	4125906	
2221	225	4107731	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	15230	0	180256009	4107731	
14345	1280	4043071	1964-11-03	1964-11-03 00:00:00	38000275	0	\N	\N	84551	0	228557008	4043071	
2600	266	4107731	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	17746	0	180256009	4107731	
14737	1310	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	86592	0	180256009	4107731	
2959	285	4107731	1991-01-14	1991-01-14 00:00:00	38000275	0	\N	\N	18972	0	180256009	4107731	
15018	1333	4151422	2006-02-08	2006-02-08 00:00:00	38000275	0	\N	\N	88447	0	269911007	4151422	
15156	1356	4107731	1996-01-04	1996-01-04 00:00:00	38000275	0	\N	\N	89892	0	180256009	4107731	
15443	1376	4151422	1986-11-25	1986-11-25 00:00:00	38000275	0	\N	\N	91200	0	269911007	4151422	
3684	357	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	23672	0	180256009	4107731	
15842	1397	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	92774	0	180256009	4107731	
4057	404	4125906	2007-12-24	2007-12-24 00:00:00	38000275	0	\N	\N	26663	0	288086009	4125906	
4247	410	4125906	2004-08-09	2004-08-09 00:00:00	38000275	0	\N	\N	27158	0	288086009	4125906	
28238	2497	4125906	1969-07-20	1969-07-20 00:00:00	38000275	0	\N	\N	165313	0	288086009	4125906	
16471	1431	4107731	1990-12-08	1990-12-08 00:00:00	38000275	0	\N	\N	95321	0	180256009	4107731	
16689	1447	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	96553	0	180256009	4107731	
5046	469	4043071	1945-05-28	1945-05-28 00:00:00	38000275	0	\N	\N	31339	0	228557008	4043071	
5196	480	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	32079	0	180256009	4107731	
17214	1486	4107731	1991-10-20	1991-10-20 00:00:00	38000275	0	\N	\N	99015	0	180256009	4107731	
5557	507	4057420	2009-09-11	2009-09-11 00:00:00	38000275	0	\N	\N	33970	0	18286008	4057420	
17618	1513	4043071	1980-05-22	1980-05-22 00:00:00	38000275	0	\N	\N	101156	0	228557008	4043071	
5949	545	4107731	1990-11-17	1990-11-17 00:00:00	38000275	0	\N	\N	36044	0	180256009	4107731	
17974	1538	4107731	1991-01-14	1991-01-14 00:00:00	38000275	0	\N	\N	103060	0	180256009	4107731	
18246	1556	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	104227	0	180256009	4107731	
18449	1565	4151422	2017-08-18	2017-08-18 00:00:00	38000275	0	\N	\N	104941	0	269911007	4151422	
6697	610	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	40485	0	180256009	4107731	
18726	1605	4047491	1958-06-08	1958-06-08 00:00:00	38000275	0	\N	\N	107747	0	1225002	4047491	
18961	1622	4295880	2001-07-23	2001-07-23 00:00:00	38000275	0	\N	\N	109015	0	76601001	4295880	
19093	1646	4125906	1943-09-16	1943-09-16 00:00:00	38000275	0	\N	\N	110447	0	288086009	4125906	
7425	689	4295880	1997-02-12	1997-02-12 00:00:00	38000275	0	\N	\N	45696	0	76601001	4295880	
19462	1659	4043071	1981-10-19	1981-10-19 00:00:00	38000275	0	\N	\N	111562	0	228557008	4043071	
7849	718	4107731	1992-04-25	1992-04-25 00:00:00	38000275	0	\N	\N	47509	0	180256009	4107731	
19857	1719	4243062	1967-03-09	1967-03-09 00:00:00	38000275	0	\N	\N	114916	0	60027007	4243062	
8188	754	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	49829	0	180256009	4107731	
8355	761	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	50549	0	180256009	4107731	
20539	1773	4107731	1992-02-23	1992-02-23 00:00:00	38000275	0	\N	\N	118609	0	180256009	4107731	
20733	1783	4107731	1992-12-07	1992-12-07 00:00:00	38000275	0	\N	\N	119454	0	180256009	4107731	
32769	2871	4043071	1961-11-16	1961-11-16 00:00:00	38000275	0	\N	\N	191052	0	228557008	4043071	
20955	1812	4170947	2005-09-28	2005-09-28 00:00:00	38000275	0	\N	\N	121298	0	274474001	4170947	
9293	847	40492359	1970-07-24	1970-07-24 00:00:00	38000275	0	\N	\N	56137	0	447365002	40492359	
21332	1845	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	123262	0	180256009	4107731	
33563	2925	4107731	1990-12-02	1990-12-02 00:00:00	38000275	0	\N	\N	195117	0	180256009	4107731	
9865	884	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	58850	0	180256009	4107731	
22002	1918	4043071	1979-05-14	1979-05-14 00:00:00	38000275	0	\N	\N	127649	0	228557008	4043071	
22123	1926	4125906	1986-05-17	1986-05-17 00:00:00	38000275	0	\N	\N	128200	0	288086009	4125906	
10438	935	4078793	1993-09-29	1993-09-29 00:00:00	38000275	0	\N	\N	62162	0	180325003	4078793	
22451	1967	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	130762	0	180256009	4107731	
22702	1977	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	131617	0	180256009	4107731	
22892	1992	4107731	1990-12-09	1990-12-09 00:00:00	38000275	0	\N	\N	132705	0	180256009	4107731	
34973	3049	4336464	1986-12-05	1986-12-05 00:00:00	38000275	0	\N	\N	202874	0	232717009	4336464	
23274	2025	4195803	1979-09-01	1979-09-01 00:00:00	38000275	0	\N	\N	134742	0	312681000	4195803	
23507	2058	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	136834	0	180256009	4107731	
11730	1083	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	71112	0	180256009	4107731	
23771	2071	4170947	1970-02-20	1970-02-20 00:00:00	38000275	0	\N	\N	137800	0	274474001	4170947	
129	7	4125906	1972-07-09	1972-07-09 00:00:00	38000275	0	\N	\N	630	0	288086009	4125906	
12291	1107	4163872	2004-12-09	2004-12-09 00:00:00	38000275	0	\N	\N	72858	0	399208008	4163872	
12381	1115	4107731	1991-02-04	1991-02-04 00:00:00	38000275	0	\N	\N	73359	0	180256009	4107731	
12613	1138	4107731	1994-04-21	1994-04-21 00:00:00	38000275	0	\N	\N	75107	0	180256009	4107731	
12897	1169	4336464	2018-08-20	2018-08-20 00:00:00	38000275	0	\N	\N	76991	0	232717009	4336464	
12966	1175	4107731	1992-11-15	1992-11-15 00:00:00	38000275	0	\N	\N	77536	0	180256009	4107731	
13220	1194	4151422	2003-06-30	2003-06-30 00:00:00	38000275	0	\N	\N	78712	0	269911007	4151422	
13308	1211	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	79558	0	180256009	4107731	
13576	1227	4057420	2019-05-08	2019-05-08 00:00:00	38000275	0	\N	\N	\N	0	18286008	4057420	
13660	1246	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	82118	0	180256009	4107731	
2009	189	4125906	1984-11-20	1984-11-20 00:00:00	38000275	0	\N	\N	12889	0	288086009	4125906	
2222	225	4151422	1973-10-21	1973-10-21 00:00:00	38000275	0	\N	\N	15176	0	269911007	4151422	
14346	1280	4043071	1965-08-31	1965-08-31 00:00:00	38000275	0	\N	\N	84603	0	228557008	4043071	
2601	266	4107731	1990-04-16	1990-04-16 00:00:00	38000275	0	\N	\N	17675	0	180256009	4107731	
14738	1310	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	86610	0	180256009	4107731	
2960	285	4107731	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	18937	0	180256009	4107731	
15019	1333	4186930	1975-09-21	1975-09-21 00:00:00	38000275	0	\N	\N	88468	0	46706006	4186930	
15157	1356	4107731	1997-11-27	1997-11-27 00:00:00	38000275	0	\N	\N	89971	0	180256009	4107731	
15444	1376	4170947	1983-06-13	1983-06-13 00:00:00	38000275	0	\N	\N	91177	0	274474001	4170947	
3685	357	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	23694	0	180256009	4107731	
15843	1397	4197460	1977-11-14	1977-11-14 00:00:00	38000275	0	\N	\N	92836	0	313191000	4197460	
4058	404	4043071	1971-03-26	1971-03-26 00:00:00	38000275	0	\N	\N	26658	0	228557008	4043071	
4248	410	4195803	2019-02-06	2019-02-06 00:00:00	38000275	0	\N	\N	27159	0	312681000	4195803	
28239	2497	40492359	2008-02-28	2008-02-28 00:00:00	38000275	0	\N	\N	165316	0	447365002	40492359	
16472	1431	4107731	1993-03-06	1993-03-06 00:00:00	38000275	0	\N	\N	95338	0	180256009	4107731	
16690	1447	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	96520	0	180256009	4107731	
5047	469	4043071	1950-01-16	1950-01-16 00:00:00	38000275	0	\N	\N	31288	0	228557008	4043071	
5197	480	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	32051	0	180256009	4107731	
17215	1486	4107731	1990-12-30	1990-12-30 00:00:00	38000275	0	\N	\N	99033	0	180256009	4107731	
5558	507	4078793	2003-08-22	2003-08-22 00:00:00	38000275	0	\N	\N	33963	0	180325003	4078793	
17619	1513	4107731	1991-01-20	1991-01-20 00:00:00	38000275	0	\N	\N	101035	0	180256009	4107731	
5950	545	4107731	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	36078	0	180256009	4107731	
17975	1538	4107731	1992-01-27	1992-01-27 00:00:00	38000275	0	\N	\N	103024	0	180256009	4107731	
18247	1556	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	104263	0	180256009	4107731	
18450	1565	4043071	1972-12-18	1972-12-18 00:00:00	38000275	0	\N	\N	104917	0	228557008	4043071	
6698	610	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	40489	0	180256009	4107731	
18727	1605	4170947	1958-06-08	1958-06-08 00:00:00	38000275	0	\N	\N	107747	0	274474001	4170947	
18962	1622	4295880	1995-07-31	1995-07-31 00:00:00	38000275	0	\N	\N	109003	0	76601001	4295880	
19094	1646	4047491	2012-03-22	2012-03-22 00:00:00	38000275	0	\N	\N	110450	0	1225002	4047491	
7426	689	4295880	1999-08-15	1999-08-15 00:00:00	38000275	0	\N	\N	45640	0	76601001	4295880	
19463	1659	4043071	1977-10-24	1977-10-24 00:00:00	38000275	0	\N	\N	111544	0	228557008	4043071	
7850	718	4107731	1993-01-02	1993-01-02 00:00:00	38000275	0	\N	\N	47457	0	180256009	4107731	
19858	1719	4151422	1959-08-28	1959-08-28 00:00:00	38000275	0	\N	\N	114887	0	269911007	4151422	
8189	754	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	49942	0	180256009	4107731	
8356	761	4151422	2015-03-29	2015-03-29 00:00:00	38000275	0	\N	\N	50532	0	269911007	4151422	
20540	1773	4107731	1992-02-02	1992-02-02 00:00:00	38000275	0	\N	\N	118633	0	180256009	4107731	
20734	1783	4107731	1990-01-22	1990-01-22 00:00:00	38000275	0	\N	\N	119427	0	180256009	4107731	
32770	2871	4043071	1963-01-31	1963-01-31 00:00:00	38000275	0	\N	\N	191080	0	228557008	4043071	
20956	1812	4047491	2005-09-28	2005-09-28 00:00:00	38000275	0	\N	\N	121298	0	1225002	4047491	
9294	847	4057420	1970-07-24	1970-07-24 00:00:00	38000275	0	\N	\N	56137	0	18286008	4057420	
21333	1845	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	123354	0	180256009	4107731	
33564	2925	4107731	1990-06-18	1990-06-18 00:00:00	38000275	0	\N	\N	195060	0	180256009	4107731	
9866	884	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	58944	0	180256009	4107731	
22003	1918	4043071	1977-11-14	1977-11-14 00:00:00	38000275	0	\N	\N	127662	0	228557008	4043071	
22124	1928	4293740	1996-02-24	1996-02-24 00:00:00	38000275	0	\N	\N	128378	0	384700001	4293740	
10439	936	4125906	1988-03-03	1988-03-03 00:00:00	38000275	0	\N	\N	62263	0	288086009	4125906	
22452	1967	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	130844	0	180256009	4107731	
22703	1977	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	131585	0	180256009	4107731	
22893	1992	4107731	1993-03-28	1993-03-28 00:00:00	38000275	0	\N	\N	132643	0	180256009	4107731	
34974	3049	4216130	1986-12-05	1986-12-05 00:00:00	38000275	0	\N	\N	202874	0	415070008	4216130	
23275	2025	4078793	2012-04-28	2012-04-28 00:00:00	38000275	0	\N	\N	134651	0	180325003	4078793	
23508	2058	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	136837	0	180256009	4107731	
11731	1083	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	71100	0	180256009	4107731	
23772	2071	4243062	1973-03-06	1973-03-06 00:00:00	38000275	0	\N	\N	137801	0	60027007	4243062	
134	9	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	725	0	180256009	4107731	
12292	1107	4170947	2004-12-09	2004-12-09 00:00:00	38000275	0	\N	\N	72858	0	274474001	4170947	
12382	1115	4107731	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	73369	0	180256009	4107731	
12614	1138	4107731	1994-02-17	1994-02-17 00:00:00	38000275	0	\N	\N	75042	0	180256009	4107731	
12898	1169	4216130	2018-08-20	2018-08-20 00:00:00	38000275	0	\N	\N	76991	0	415070008	4216130	
12967	1175	4107731	1990-05-27	1990-05-27 00:00:00	38000275	0	\N	\N	77495	0	180256009	4107731	
13222	1197	4151422	1997-11-04	1997-11-04 00:00:00	38000275	0	\N	\N	78843	0	269911007	4151422	
13309	1211	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	79559	0	180256009	4107731	
13577	1227	4163872	2000-06-03	2000-06-03 00:00:00	38000275	0	\N	\N	80735	0	399208008	4163872	
13661	1246	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	82165	0	180256009	4107731	
2010	189	4058899	1970-01-08	1970-01-08 00:00:00	38000275	0	\N	\N	12888	0	168594001	4058899	
2223	225	4107731	1990-10-01	1990-10-01 00:00:00	38000275	0	\N	\N	15180	0	180256009	4107731	
14347	1280	4043071	1964-08-04	1964-08-04 00:00:00	38000275	0	\N	\N	84599	0	228557008	4043071	
2602	266	4107731	1991-04-08	1991-04-08 00:00:00	38000275	0	\N	\N	17753	0	180256009	4107731	
14739	1310	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	86554	0	180256009	4107731	
2961	285	4107731	1991-02-25	1991-02-25 00:00:00	38000275	0	\N	\N	18973	0	180256009	4107731	
15020	1334	4125906	1973-09-05	1973-09-05 00:00:00	38000275	0	\N	\N	88530	0	288086009	4125906	
15158	1356	4107731	1997-03-20	1997-03-20 00:00:00	38000275	0	\N	\N	89948	0	180256009	4107731	
15445	1376	4243062	1983-06-13	1983-06-13 00:00:00	38000275	0	\N	\N	91177	0	60027007	4243062	
3686	357	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	23688	0	180256009	4107731	
15844	1397	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	92751	0	395142003	4191853	
4059	404	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	26618	0	395142003	4191853	
4249	410	4243062	2019-02-06	2019-02-06 00:00:00	38000275	0	\N	\N	27159	0	60027007	4243062	
28240	2498	4058899	2018-08-26	2018-08-26 00:00:00	38000275	0	\N	\N	165405	0	168594001	4058899	
16473	1431	4107731	1991-07-27	1991-07-27 00:00:00	38000275	0	\N	\N	95323	0	180256009	4107731	
16691	1447	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	96432	0	180256009	4107731	
5048	469	4043071	1948-03-22	1948-03-22 00:00:00	38000275	0	\N	\N	31360	0	228557008	4043071	
5198	480	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	32046	0	180256009	4107731	
17216	1486	4107731	1992-01-12	1992-01-12 00:00:00	38000275	0	\N	\N	99113	0	180256009	4107731	
5559	507	4078793	1994-08-12	1994-08-12 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
17620	1513	4107731	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	101037	0	180256009	4107731	
5951	545	4107731	1992-06-27	1992-06-27 00:00:00	38000275	0	\N	\N	36106	0	180256009	4107731	
17976	1538	4107731	1991-12-16	1991-12-16 00:00:00	38000275	0	\N	\N	103023	0	180256009	4107731	
18248	1556	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	104256	0	180256009	4107731	
18451	1565	4043071	1972-10-16	1972-10-16 00:00:00	38000275	0	\N	\N	104966	0	228557008	4043071	
6699	610	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	40583	0	180256009	4107731	
18728	1605	4125906	1948-01-27	1948-01-27 00:00:00	38000275	0	\N	\N	107745	0	288086009	4125906	
18963	1622	4295880	1994-08-01	1994-08-01 00:00:00	38000275	0	\N	\N	109033	0	76601001	4295880	
19095	1646	4170947	2012-03-22	2012-03-22 00:00:00	38000275	0	\N	\N	110450	0	274474001	4170947	
7427	689	4295880	2000-02-13	2000-02-13 00:00:00	38000275	0	\N	\N	45641	0	76601001	4295880	
19464	1659	4043071	1981-12-21	1981-12-21 00:00:00	38000275	0	\N	\N	111430	0	228557008	4043071	
7851	718	4043071	1978-03-30	1978-03-30 00:00:00	38000275	0	\N	\N	47490	0	228557008	4043071	
19859	1719	4125906	2007-01-07	2007-01-07 00:00:00	38000275	0	\N	\N	114998	0	288086009	4125906	
8190	754	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	49931	0	180256009	4107731	
8357	761	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	50540	0	180256009	4107731	
20541	1773	4107731	1991-12-01	1991-12-01 00:00:00	38000275	0	\N	\N	118607	0	180256009	4107731	
20735	1783	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	119455	0	180256009	4107731	
32771	2871	4043071	1961-05-25	1961-05-25 00:00:00	38000275	0	\N	\N	191064	0	228557008	4043071	
20957	1812	4151422	1992-05-09	1992-05-09 00:00:00	38000275	0	\N	\N	121256	0	269911007	4151422	
9295	847	4293740	1985-03-20	1985-03-20 00:00:00	38000275	0	\N	\N	56139	0	384700001	4293740	
21334	1845	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	123317	0	180256009	4107731	
33565	2925	4191853	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	195100	0	395142003	4191853	
9867	884	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	58860	0	180256009	4107731	
22004	1918	4043071	1978-08-07	1978-08-07 00:00:00	38000275	0	\N	\N	127589	0	228557008	4043071	
22125	1928	4125906	1996-02-24	1996-02-24 00:00:00	38000275	0	\N	\N	128378	0	288086009	4125906	
10440	938	4145310	1952-05-13	1952-05-13 00:00:00	38000275	0	\N	\N	62327	0	268425006	4145310	
22453	1967	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	130800	0	180256009	4107731	
22704	1977	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	131483	0	180256009	4107731	
22894	1992	4107731	1993-04-18	1993-04-18 00:00:00	38000275	0	\N	\N	132700	0	180256009	4107731	
35052	3053	4125906	1982-11-05	1982-11-05 00:00:00	38000275	0	\N	\N	203124	0	288086009	4125906	
23276	2025	4078793	1976-11-27	1976-11-27 00:00:00	38000275	0	\N	\N	134775	0	180325003	4078793	
23509	2058	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	136878	0	180256009	4107731	
11732	1083	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	71155	0	180256009	4107731	
23773	2071	4170947	1973-03-06	1973-03-06 00:00:00	38000275	0	\N	\N	137801	0	274474001	4170947	
135	9	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	737	0	180256009	4107731	
12293	1108	4151422	1981-02-19	1981-02-19 00:00:00	38000275	0	\N	\N	72938	0	269911007	4151422	
12383	1115	4107731	1992-10-05	1992-10-05 00:00:00	38000275	0	\N	\N	73494	0	180256009	4107731	
12615	1138	4107731	1994-05-12	1994-05-12 00:00:00	38000275	0	\N	\N	75045	0	180256009	4107731	
12899	1169	4057420	2012-02-20	2012-02-20 00:00:00	38000275	0	\N	\N	76990	0	18286008	4057420	
12968	1175	4024289	1967-02-28	1967-02-28 00:00:00	38000275	0	\N	\N	77419	0	19490002	4024289	
13226	1201	4151422	2005-12-13	2005-12-13 00:00:00	38000275	0	\N	\N	79020	0	269911007	4151422	
13310	1211	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	79579	0	395142003	4191853	
13578	1227	4043071	1947-05-23	1947-05-23 00:00:00	38000275	0	\N	\N	80841	0	228557008	4043071	
13662	1246	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	82047	0	180256009	4107731	
2011	190	4293740	1971-07-17	1971-07-17 00:00:00	38000275	0	\N	\N	12912	0	384700001	4293740	
2224	225	4107731	1992-06-01	1992-06-01 00:00:00	38000275	0	\N	\N	15231	0	180256009	4107731	
14348	1280	4043071	1965-08-03	1965-08-03 00:00:00	38000275	0	\N	\N	84554	0	228557008	4043071	
2603	266	4107731	1992-10-05	1992-10-05 00:00:00	38000275	0	\N	\N	17716	0	180256009	4107731	
14740	1310	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	86607	0	180256009	4107731	
2962	285	4107731	1991-09-23	1991-09-23 00:00:00	38000275	0	\N	\N	18947	0	180256009	4107731	
15021	1334	44783196	1972-08-11	1972-08-11 00:00:00	38000275	0	\N	\N	88495	0	699253003	44783196	
15159	1356	4107731	1996-10-24	1996-10-24 00:00:00	38000275	0	\N	\N	89915	0	180256009	4107731	
15446	1376	4187458	1979-11-11	1979-11-11 00:00:00	38000275	0	\N	\N	91181	0	415300000	4187458	
3687	357	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	23744	0	180256009	4107731	
15845	1397	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	92853	0	180256009	4107731	
4060	404	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	26633	0	180256009	4107731	
4250	410	4170947	2019-02-06	2019-02-06 00:00:00	38000275	0	\N	\N	27159	0	274474001	4170947	
28241	2498	4047491	1997-10-15	1997-10-15 00:00:00	38000275	0	\N	\N	165404	0	1225002	4047491	
16474	1431	4107731	1990-08-04	1990-08-04 00:00:00	38000275	0	\N	\N	95318	0	180256009	4107731	
16692	1447	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	96418	0	180256009	4107731	
5049	469	4078793	2014-10-04	2014-10-04 00:00:00	38000275	0	\N	\N	31372	0	180325003	4078793	
5204	482	4047491	1971-11-12	1971-11-12 00:00:00	38000275	0	\N	\N	32227	0	1225002	4047491	
17217	1486	4107731	1991-01-20	1991-01-20 00:00:00	38000275	0	\N	\N	99108	0	180256009	4107731	
5560	507	4078793	1990-08-31	1990-08-31 00:00:00	38000275	0	\N	\N	33931	0	180325003	4078793	
17621	1513	4043071	1979-10-25	1979-10-25 00:00:00	38000275	0	\N	\N	101131	0	228557008	4043071	
5952	545	4107731	1991-02-09	1991-02-09 00:00:00	38000275	0	\N	\N	36139	0	180256009	4107731	
17977	1538	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	103096	0	180256009	4107731	
18249	1556	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	104155	0	180256009	4107731	
18452	1565	4043071	1973-09-17	1973-09-17 00:00:00	38000275	0	\N	\N	104932	0	228557008	4043071	
6700	610	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	40492	0	180256009	4107731	
18729	1605	4293740	1948-01-27	1948-01-27 00:00:00	38000275	0	\N	\N	107745	0	384700001	4293740	
18964	1622	4295880	1995-05-01	1995-05-01 00:00:00	38000275	0	\N	\N	108973	0	76601001	4295880	
19096	1646	4195803	2012-03-22	2012-03-22 00:00:00	38000275	0	\N	\N	110450	0	312681000	4195803	
7428	689	4295880	2002-02-10	2002-02-10 00:00:00	38000275	0	\N	\N	45652	0	76601001	4295880	
19465	1659	4043071	1980-02-18	1980-02-18 00:00:00	38000275	0	\N	\N	111533	0	228557008	4043071	
7852	718	4107731	1992-08-29	1992-08-29 00:00:00	38000275	0	\N	\N	47483	0	180256009	4107731	
19860	1720	4125906	2009-12-23	2009-12-23 00:00:00	38000275	0	\N	\N	115003	0	288086009	4125906	
8191	754	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	49940	0	180256009	4107731	
8358	761	4107731	1993-07-30	1993-07-30 00:00:00	38000275	0	\N	\N	50644	0	180256009	4107731	
20542	1773	4107731	1991-12-22	1991-12-22 00:00:00	38000275	0	\N	\N	118532	0	180256009	4107731	
20736	1783	4125906	1986-08-04	1986-08-04 00:00:00	38000275	0	\N	\N	119441	0	288086009	4125906	
32772	2871	4043071	1963-03-07	1963-03-07 00:00:00	38000275	0	\N	\N	191081	0	228557008	4043071	
20958	1813	4170947	2016-03-18	2016-03-18 00:00:00	38000275	0	\N	\N	121310	0	274474001	4170947	
9296	847	4125906	1985-03-20	1985-03-20 00:00:00	38000275	0	\N	\N	56139	0	288086009	4125906	
21335	1845	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	123276	0	180256009	4107731	
33566	2925	4107731	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	195028	0	180256009	4107731	
9868	884	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	58887	0	180256009	4107731	
22005	1918	4043071	1978-01-16	1978-01-16 00:00:00	38000275	0	\N	\N	127588	0	228557008	4043071	
22126	1928	44783196	2018-02-26	2018-02-26 00:00:00	38000275	0	\N	\N	128324	0	699253003	44783196	
10441	938	4151422	1990-08-10	1990-08-10 00:00:00	38000275	0	\N	\N	62351	0	269911007	4151422	
22454	1967	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	130853	0	180256009	4107731	
22705	1977	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	131611	0	180256009	4107731	
22895	1992	4107731	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	132701	0	180256009	4107731	
35053	3053	4125906	2009-03-02	2009-03-02 00:00:00	38000275	0	\N	\N	203108	0	288086009	4125906	
23277	2025	4057420	2009-05-30	2009-05-30 00:00:00	38000275	0	\N	\N	134649	0	18286008	4057420	
23510	2058	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	136848	0	180256009	4107731	
11733	1083	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	71164	0	180256009	4107731	
23774	2071	4243062	1977-02-13	1977-02-13 00:00:00	38000275	0	\N	\N	137802	0	60027007	4243062	
136	9	4107731	1994-02-03	1994-02-03 00:00:00	38000275	0	\N	\N	777	0	180256009	4107731	
12294	1108	4151422	2014-09-05	2014-09-05 00:00:00	38000275	0	\N	\N	72944	0	269911007	4151422	
12384	1115	4107731	1992-08-24	1992-08-24 00:00:00	38000275	0	\N	\N	73493	0	180256009	4107731	
12616	1138	4043071	1997-02-13	1997-02-13 00:00:00	38000275	0	\N	\N	75035	0	228557008	4043071	
12900	1169	40492359	2012-02-20	2012-02-20 00:00:00	38000275	0	\N	\N	76990	0	447365002	40492359	
12969	1175	4170947	1967-02-28	1967-02-28 00:00:00	38000275	0	\N	\N	77419	0	274474001	4170947	
13227	1201	4125906	1995-11-01	1995-11-01 00:00:00	38000275	0	\N	\N	78981	0	288086009	4125906	
13311	1211	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	79500	0	180256009	4107731	
13579	1227	4078793	2017-04-12	2017-04-12 00:00:00	38000275	0	\N	\N	80771	0	180325003	4078793	
13663	1246	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	82108	0	180256009	4107731	
2012	190	4125906	1971-07-17	1971-07-17 00:00:00	38000275	0	\N	\N	12912	0	288086009	4125906	
2225	225	4107731	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	15182	0	180256009	4107731	
14349	1280	4043071	1965-05-25	1965-05-25 00:00:00	38000275	0	\N	\N	84542	0	228557008	4043071	
2604	266	4107731	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	17747	0	180256009	4107731	
14741	1310	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	86632	0	180256009	4107731	
2963	285	4107731	1992-11-16	1992-11-16 00:00:00	38000275	0	\N	\N	18981	0	180256009	4107731	
15022	1334	4252419	1972-08-04	1972-08-04 00:00:00	38000275	0	\N	\N	88529	0	74016001	4252419	
15160	1356	4107731	1996-12-26	1996-12-26 00:00:00	38000275	0	\N	\N	89897	0	180256009	4107731	
15447	1376	4037675	1979-11-11	1979-11-11 00:00:00	38000275	0	\N	\N	91181	0	162676008	4037675	
3688	357	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	23729	0	180256009	4107731	
15846	1397	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	92787	0	180256009	4107731	
4061	404	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	26602	0	180256009	4107731	
4251	411	4107731	1990-02-17	1990-02-17 00:00:00	38000275	0	\N	\N	27282	0	180256009	4107731	
28242	2498	4170947	1997-10-15	1997-10-15 00:00:00	38000275	0	\N	\N	165404	0	274474001	4170947	
16475	1431	4191853	1990-01-06	1990-01-06 00:00:00	38000275	0	\N	\N	95212	0	395142003	4191853	
16693	1447	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	96551	0	180256009	4107731	
16831	1459	4195803	1997-07-15	1997-07-15 00:00:00	38000275	0	\N	\N	97248	0	312681000	4195803	
5205	482	4170947	1971-11-12	1971-11-12 00:00:00	38000275	0	\N	\N	32227	0	274474001	4170947	
17218	1486	4107731	1992-11-22	1992-11-22 00:00:00	38000275	0	\N	\N	99097	0	180256009	4107731	
5561	507	4163872	1994-08-04	1994-08-04 00:00:00	38000275	0	\N	\N	33978	0	399208008	4163872	
17622	1513	4125906	2010-03-31	2010-03-31 00:00:00	38000275	0	\N	\N	101153	0	288086009	4125906	
5953	545	4107731	1990-07-14	1990-07-14 00:00:00	38000275	0	\N	\N	36030	0	180256009	4107731	
17978	1538	4057420	2015-06-15	2015-06-15 00:00:00	38000275	0	\N	\N	103017	0	18286008	4057420	
18250	1556	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	104183	0	180256009	4107731	
18453	1565	4043071	1973-01-22	1973-01-22 00:00:00	38000275	0	\N	\N	104929	0	228557008	4043071	
6701	610	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	40589	0	180256009	4107731	
18730	1606	4151422	1990-04-09	1990-04-09 00:00:00	38000275	0	\N	\N	107801	0	269911007	4151422	
18965	1622	4295880	1997-04-06	1997-04-06 00:00:00	38000275	0	\N	\N	108976	0	76601001	4295880	
19097	1646	4198190	1982-11-22	1982-11-22 00:00:00	38000275	0	\N	\N	110393	0	80146002	4198190	
7429	689	4295880	1999-11-14	1999-11-14 00:00:00	38000275	0	\N	\N	45618	0	76601001	4295880	
19466	1659	4043071	1979-04-09	1979-04-09 00:00:00	38000275	0	\N	\N	111528	0	228557008	4043071	
7853	718	4191853	1993-07-10	1993-07-10 00:00:00	38000275	0	\N	\N	47487	0	395142003	4191853	
19861	1720	4170947	1998-03-21	1998-03-21 00:00:00	38000275	0	\N	\N	115001	0	274474001	4170947	
8192	754	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	49938	0	180256009	4107731	
8359	761	4151422	1988-07-26	1988-07-26 00:00:00	38000275	0	\N	\N	50592	0	269911007	4151422	
20543	1773	4107731	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	118543	0	180256009	4107731	
20737	1783	4293740	1986-08-04	1986-08-04 00:00:00	38000275	0	\N	\N	119441	0	384700001	4293740	
32773	2871	4043071	1961-10-19	1961-10-19 00:00:00	38000275	0	\N	\N	191076	0	228557008	4043071	
20959	1813	4243062	2016-03-18	2016-03-18 00:00:00	38000275	0	\N	\N	121310	0	60027007	4243062	
9297	847	4125906	1973-08-29	1973-08-29 00:00:00	38000275	0	\N	\N	56138	0	288086009	4125906	
21336	1845	4151422	2019-02-06	2019-02-06 00:00:00	38000275	0	\N	\N	123284	0	269911007	4151422	
33567	2925	4107731	1993-02-07	1993-02-07 00:00:00	38000275	0	\N	\N	195130	0	180256009	4107731	
9869	884	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	58882	0	180256009	4107731	
22006	1918	4043071	1977-12-19	1977-12-19 00:00:00	38000275	0	\N	\N	127663	0	228557008	4043071	
22127	1928	4058899	2019-04-22	2019-04-22 00:00:00	38000275	0	\N	\N	128380	0	168594001	4058899	
10442	938	4047491	2015-10-22	2015-10-22 00:00:00	38000275	0	\N	\N	62331	0	1225002	4047491	
22455	1967	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	130765	0	180256009	4107731	
22706	1977	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	131600	0	180256009	4107731	
22896	1992	4107731	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	132699	0	180256009	4107731	
35054	3053	4170947	1997-10-31	1997-10-31 00:00:00	38000275	0	\N	\N	203107	0	274474001	4170947	
23278	2025	4078793	1996-03-16	1996-03-16 00:00:00	38000275	0	\N	\N	134646	0	180325003	4078793	
23511	2058	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	136858	0	180256009	4107731	
11734	1083	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	71120	0	180256009	4107731	
23775	2071	4170947	1977-02-13	1977-02-13 00:00:00	38000275	0	\N	\N	137802	0	274474001	4170947	
137	9	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	820	0	180256009	4107731	
12295	1108	4293740	2008-07-24	2008-07-24 00:00:00	38000275	0	\N	\N	72947	0	384700001	4293740	
12385	1115	4107731	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	73458	0	180256009	4107731	
12617	1138	4043071	1995-06-08	1995-06-08 00:00:00	38000275	0	\N	\N	75100	0	228557008	4043071	
12901	1169	4125906	1982-01-30	1982-01-30 00:00:00	38000275	0	\N	\N	76988	0	288086009	4125906	
12970	1175	4043071	1953-12-26	1953-12-26 00:00:00	38000275	0	\N	\N	77549	0	228557008	4043071	
13228	1201	4125906	2013-06-13	2013-06-13 00:00:00	38000275	0	\N	\N	78982	0	288086009	4125906	
13312	1211	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	79645	0	180256009	4107731	
13580	1227	4195803	2017-09-11	2017-09-11 00:00:00	38000275	0	\N	\N	80824	0	312681000	4195803	
13664	1246	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	82064	0	180256009	4107731	
2013	190	4243062	1936-02-07	1936-02-07 00:00:00	38000275	0	\N	\N	12909	0	60027007	4243062	
2226	225	4191853	1990-01-01	1990-01-01 00:00:00	38000275	0	\N	\N	15177	0	395142003	4191853	
14350	1280	4163872	1955-07-15	1955-07-15 00:00:00	38000275	0	\N	\N	84550	0	399208008	4163872	
2605	266	4197460	1973-02-24	1973-02-24 00:00:00	38000275	0	\N	\N	17690	0	313191000	4197460	
14742	1310	4181917	2013-02-11	2013-02-11 00:00:00	38000275	0	\N	\N	86679	0	54550000	4181917	
2964	285	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	18982	0	180256009	4107731	
15023	1335	4151422	2017-06-24	2017-06-24 00:00:00	38000275	0	\N	\N	88544	0	269911007	4151422	
15161	1356	4107731	1995-03-16	1995-03-16 00:00:00	38000275	0	\N	\N	89941	0	180256009	4107731	
15448	1376	4326177	1979-11-11	1979-11-11 00:00:00	38000275	0	\N	\N	91181	0	430193006	4326177	
3689	357	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	23767	0	180256009	4107731	
15847	1397	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	92796	0	180256009	4107731	
4062	404	4151422	1965-03-22	1965-03-22 00:00:00	38000275	0	\N	\N	26576	0	269911007	4151422	
4252	411	4107731	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	27283	0	180256009	4107731	
28247	2501	4293740	1962-10-23	1962-10-23 00:00:00	38000275	0	\N	\N	165573	0	384700001	4293740	
16476	1431	4107731	1992-10-10	1992-10-10 00:00:00	38000275	0	\N	\N	95272	0	180256009	4107731	
16694	1447	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	96548	0	180256009	4107731	
16832	1460	4125906	2017-10-21	2017-10-21 00:00:00	38000275	0	\N	\N	97306	0	288086009	4125906	
5206	482	4163872	1991-05-09	1991-05-09 00:00:00	38000275	0	\N	\N	32200	0	399208008	4163872	
17219	1486	4107731	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	99022	0	180256009	4107731	
5562	507	4078793	1992-09-11	1992-09-11 00:00:00	38000275	0	\N	\N	33932	0	180325003	4078793	
17623	1513	4107731	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	101135	0	180256009	4107731	
5954	545	4107731	1992-04-25	1992-04-25 00:00:00	38000275	0	\N	\N	36071	0	180256009	4107731	
17979	1538	4107731	1992-03-09	1992-03-09 00:00:00	38000275	0	\N	\N	103025	0	180256009	4107731	
18251	1556	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	104245	0	180256009	4107731	
18454	1565	4043071	1973-06-25	1973-06-25 00:00:00	38000275	0	\N	\N	104914	0	228557008	4043071	
6702	610	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	40517	0	180256009	4107731	
18731	1606	4151422	1985-01-29	1985-01-29 00:00:00	38000275	0	\N	\N	107846	0	269911007	4151422	
18966	1622	4295880	1993-08-02	1993-08-02 00:00:00	38000275	0	\N	\N	108957	0	76601001	4295880	
19168	1649	4125906	1972-10-09	1972-10-09 00:00:00	38000275	0	\N	\N	110678	0	288086009	4125906	
7430	689	4295880	2005-02-06	2005-02-06 00:00:00	38000275	0	\N	\N	45629	0	76601001	4295880	
19467	1659	4043071	1980-10-06	1980-10-06 00:00:00	38000275	0	\N	\N	111536	0	228557008	4043071	
7854	718	4107731	1990-11-17	1990-11-17 00:00:00	38000275	0	\N	\N	47464	0	180256009	4107731	
19862	1720	4047491	1998-03-21	1998-03-21 00:00:00	38000275	0	\N	\N	115001	0	1225002	4047491	
8193	754	4170947	1950-09-20	1950-09-20 00:00:00	38000275	0	\N	\N	49820	0	274474001	4170947	
8360	761	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	50538	0	180256009	4107731	
20544	1773	4107731	1991-07-07	1991-07-07 00:00:00	38000275	0	\N	\N	118498	0	180256009	4107731	
20738	1783	4107731	1993-01-18	1993-01-18 00:00:00	38000275	0	\N	\N	119559	0	180256009	4107731	
32774	2871	4043071	1962-10-04	1962-10-04 00:00:00	38000275	0	\N	\N	191079	0	228557008	4043071	
20960	1813	4047491	1986-07-24	1986-07-24 00:00:00	38000275	0	\N	\N	121309	0	1225002	4047491	
9299	850	4151422	1971-03-15	1971-03-15 00:00:00	38000275	0	\N	\N	56216	0	269911007	4151422	
21337	1845	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	123280	0	180256009	4107731	
33568	2925	4107731	1990-07-09	1990-07-09 00:00:00	38000275	0	\N	\N	195029	0	180256009	4107731	
9870	884	40492359	2005-05-24	2005-05-24 00:00:00	38000275	0	\N	\N	58952	0	447365002	40492359	
22007	1918	4043071	1979-03-05	1979-03-05 00:00:00	38000275	0	\N	\N	127616	0	228557008	4043071	
22128	1928	4252419	2018-02-19	2018-02-19 00:00:00	38000275	0	\N	\N	128379	0	74016001	4252419	
10443	938	4170947	2015-10-22	2015-10-22 00:00:00	38000275	0	\N	\N	62331	0	274474001	4170947	
22456	1967	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	130784	0	180256009	4107731	
22707	1977	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	131591	0	180256009	4107731	
22897	1992	4107731	1992-08-09	1992-08-09 00:00:00	38000275	0	\N	\N	132683	0	180256009	4107731	
35055	3053	4243062	1997-10-31	1997-10-31 00:00:00	38000275	0	\N	\N	203107	0	60027007	4243062	
23279	2025	4078793	1977-12-03	1977-12-03 00:00:00	38000275	0	\N	\N	134673	0	180325003	4078793	
23512	2058	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	136802	0	180256009	4107731	
11735	1083	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	71090	0	180256009	4107731	
23776	2073	4202451	2012-04-13	2012-04-13 00:00:00	38000275	0	\N	\N	137922	0	433112001	4202451	
138	9	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	806	0	180256009	4107731	
12296	1108	4125906	2008-07-24	2008-07-24 00:00:00	38000275	0	\N	\N	72947	0	288086009	4125906	
12386	1115	4107731	1993-03-01	1993-03-01 00:00:00	38000275	0	\N	\N	73484	0	180256009	4107731	
12618	1138	4107731	1993-10-14	1993-10-14 00:00:00	38000275	0	\N	\N	75023	0	180256009	4107731	
12902	1169	4293740	1982-01-30	1982-01-30 00:00:00	38000275	0	\N	\N	76988	0	384700001	4293740	
12971	1175	4107731	1992-03-29	1992-03-29 00:00:00	38000275	0	\N	\N	77460	0	180256009	4107731	
13233	1205	4275113	1984-08-24	1984-08-24 00:00:00	38000275	0	\N	\N	79217	0	65200003	4275113	
13313	1211	4293740	2012-06-17	2012-06-17 00:00:00	38000275	0	\N	\N	79578	0	384700001	4293740	
13581	1227	4058899	2017-09-11	2017-09-11 00:00:00	38000275	0	\N	\N	80824	0	168594001	4058899	
13665	1246	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	82107	0	180256009	4107731	
2014	190	4170947	1936-02-07	1936-02-07 00:00:00	38000275	0	\N	\N	12909	0	274474001	4170947	
2227	225	4107731	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	15229	0	180256009	4107731	
14351	1280	4043071	1964-12-08	1964-12-08 00:00:00	38000275	0	\N	\N	84552	0	228557008	4043071	
2606	266	4107731	1992-08-24	1992-08-24 00:00:00	38000275	0	\N	\N	17715	0	180256009	4107731	
14743	1310	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	86646	0	180256009	4107731	
2965	285	4107731	1991-08-12	1991-08-12 00:00:00	38000275	0	\N	\N	18992	0	180256009	4107731	
15024	1335	4151422	2008-03-27	2008-03-27 00:00:00	38000275	0	\N	\N	88559	0	269911007	4151422	
15162	1356	4107731	1996-10-03	1996-10-03 00:00:00	38000275	0	\N	\N	89895	0	180256009	4107731	
15449	1377	4295880	1996-08-20	1996-08-20 00:00:00	38000275	0	\N	\N	91234	0	76601001	4295880	
3690	357	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	23658	0	180256009	4107731	
15848	1397	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	92770	0	180256009	4107731	
4063	404	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	26605	0	180256009	4107731	
4253	411	4107731	1990-10-06	1990-10-06 00:00:00	38000275	0	\N	\N	27284	0	180256009	4107731	
28248	2501	4125906	1962-10-23	1962-10-23 00:00:00	38000275	0	\N	\N	165573	0	288086009	4125906	
16477	1431	4197460	1950-05-29	1950-05-29 00:00:00	38000275	0	\N	\N	95248	0	313191000	4197460	
16695	1447	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	96451	0	180256009	4107731	
16833	1460	4125906	1984-03-15	1984-03-15 00:00:00	38000275	0	\N	\N	97303	0	288086009	4125906	
5207	482	4125906	2013-12-18	2013-12-18 00:00:00	38000275	0	\N	\N	32258	0	288086009	4125906	
17220	1486	4107731	1991-09-29	1991-09-29 00:00:00	38000275	0	\N	\N	99036	0	180256009	4107731	
5563	507	4151422	1999-07-24	1999-07-24 00:00:00	38000275	0	\N	\N	33900	0	269911007	4151422	
17624	1513	4107731	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	101052	0	180256009	4107731	
5955	545	4107731	1992-10-10	1992-10-10 00:00:00	38000275	0	\N	\N	36019	0	180256009	4107731	
17980	1538	4107731	1992-10-05	1992-10-05 00:00:00	38000275	0	\N	\N	102962	0	180256009	4107731	
18252	1556	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	104218	0	180256009	4107731	
18455	1566	4125906	1985-05-01	1985-05-01 00:00:00	38000275	0	\N	\N	105011	0	288086009	4125906	
6703	610	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	40502	0	180256009	4107731	
18732	1606	4170947	1964-05-14	1964-05-14 00:00:00	38000275	0	\N	\N	107855	0	274474001	4170947	
18967	1622	4295880	2001-10-22	2001-10-22 00:00:00	38000275	0	\N	\N	108964	0	76601001	4295880	
19169	1649	4125906	1978-05-02	1978-05-02 00:00:00	38000275	0	\N	\N	110679	0	288086009	4125906	
7431	689	4170947	1997-05-31	1997-05-31 00:00:00	38000275	0	\N	\N	45624	0	274474001	4170947	
19468	1659	4043071	1980-06-30	1980-06-30 00:00:00	38000275	0	\N	\N	111559	0	228557008	4043071	
19636	1683	4058899	2012-10-01	2012-10-01 00:00:00	38000275	0	\N	\N	112772	0	168594001	4058899	
19929	1724	4163872	1950-05-12	1950-05-12 00:00:00	38000275	0	\N	\N	115239	0	399208008	4163872	
8194	754	4163872	1950-09-20	1950-09-20 00:00:00	38000275	0	\N	\N	49820	0	399208008	4163872	
8361	761	4107731	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	50541	0	180256009	4107731	
20545	1773	4107731	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	118600	0	180256009	4107731	
20739	1783	4107731	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	119548	0	180256009	4107731	
32775	2871	4043071	1961-08-24	1961-08-24 00:00:00	38000275	0	\N	\N	191115	0	228557008	4043071	
20961	1813	4170947	1986-07-24	1986-07-24 00:00:00	38000275	0	\N	\N	121309	0	274474001	4170947	
9300	850	4125906	1978-04-06	1978-04-06 00:00:00	38000275	0	\N	\N	56237	0	288086009	4125906	
21338	1845	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	123351	0	180256009	4107731	
33569	2925	4107731	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	195034	0	180256009	4107731	
9871	884	4057420	2005-05-24	2005-05-24 00:00:00	38000275	0	\N	\N	58952	0	18286008	4057420	
22008	1918	4151422	1985-04-29	1985-04-29 00:00:00	38000275	0	\N	\N	127593	0	269911007	4151422	
22129	1928	4151422	1974-03-22	1974-03-22 00:00:00	38000275	0	\N	\N	128321	0	269911007	4151422	
10444	938	4195803	2015-10-22	2015-10-22 00:00:00	38000275	0	\N	\N	62331	0	312681000	4195803	
22457	1967	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	130753	0	180256009	4107731	
22708	1977	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	131587	0	180256009	4107731	
22898	1992	4107731	1990-06-24	1990-06-24 00:00:00	38000275	0	\N	\N	132663	0	180256009	4107731	
35056	3053	4187458	1987-01-08	1987-01-08 00:00:00	38000275	0	\N	\N	203142	0	415300000	4187458	
23280	2025	4057420	2013-10-12	2013-10-12 00:00:00	38000275	0	\N	\N	\N	0	18286008	4057420	
23513	2058	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	136902	0	180256009	4107731	
11736	1083	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	71077	0	180256009	4107731	
23777	2073	4330583	1999-02-20	1999-02-20 00:00:00	38000275	0	\N	\N	137890	0	22523008	4330583	
139	9	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	784	0	180256009	4107731	
12297	1110	4107731	1996-12-09	1996-12-09 00:00:00	38000275	0	\N	\N	73108	0	180256009	4107731	
12387	1115	4107731	1992-08-03	1992-08-03 00:00:00	38000275	0	\N	\N	73467	0	180256009	4107731	
12619	1138	4043071	1995-10-12	1995-10-12 00:00:00	38000275	0	\N	\N	75083	0	228557008	4043071	
12903	1169	4151422	1944-09-09	1944-09-09 00:00:00	38000275	0	\N	\N	76958	0	269911007	4151422	
12972	1175	4107731	1990-03-25	1990-03-25 00:00:00	38000275	0	\N	\N	77433	0	180256009	4107731	
13234	1205	4170947	1976-07-22	1976-07-22 00:00:00	38000275	0	\N	\N	79174	0	274474001	4170947	
13314	1211	4125906	2012-06-17	2012-06-17 00:00:00	38000275	0	\N	\N	79578	0	288086009	4125906	
13582	1227	4170947	1943-03-27	1943-03-27 00:00:00	38000275	0	\N	\N	80815	0	274474001	4170947	
13666	1246	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	82048	0	180256009	4107731	
2015	190	4252419	1954-11-29	1954-11-29 00:00:00	38000275	0	\N	\N	12910	0	74016001	4252419	
2228	225	4107731	1991-11-04	1991-11-04 00:00:00	38000275	0	\N	\N	15241	0	180256009	4107731	
14352	1280	4043071	1964-09-29	1964-09-29 00:00:00	38000275	0	\N	\N	84541	0	228557008	4043071	
2607	266	4107731	1992-08-03	1992-08-03 00:00:00	38000275	0	\N	\N	17725	0	180256009	4107731	
14744	1310	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	86557	0	180256009	4107731	
2966	285	4107731	1991-04-08	1991-04-08 00:00:00	38000275	0	\N	\N	18974	0	180256009	4107731	
15030	1338	4058899	2019-03-23	2019-03-23 00:00:00	38000275	0	\N	\N	88765	0	168594001	4058899	
15163	1356	4107731	1995-11-23	1995-11-23 00:00:00	38000275	0	\N	\N	89891	0	180256009	4107731	
15450	1377	4295880	1998-02-17	1998-02-17 00:00:00	38000275	0	\N	\N	91236	0	76601001	4295880	
3691	357	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	23695	0	180256009	4107731	
15849	1397	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	92841	0	180256009	4107731	
4064	404	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	26640	0	180256009	4107731	
4254	411	4107731	1990-01-27	1990-01-27 00:00:00	38000275	0	\N	\N	27271	0	180256009	4107731	
28249	2501	4125906	1995-09-03	1995-09-03 00:00:00	38000275	0	\N	\N	165576	0	288086009	4125906	
16478	1431	4107731	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	95260	0	180256009	4107731	
16696	1447	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	96433	0	180256009	4107731	
16834	1460	4163872	1989-07-19	1989-07-19 00:00:00	38000275	0	\N	\N	97271	0	399208008	4163872	
5208	482	4125906	1980-09-25	1980-09-25 00:00:00	38000275	0	\N	\N	32228	0	288086009	4125906	
17221	1486	4107731	1993-01-24	1993-01-24 00:00:00	38000275	0	\N	\N	99151	0	180256009	4107731	
5564	507	4078793	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	33943	0	180325003	4078793	
17625	1513	4043071	1980-04-24	1980-04-24 00:00:00	38000275	0	\N	\N	101119	0	228557008	4043071	
5956	545	4107731	1993-02-13	1993-02-13 00:00:00	38000275	0	\N	\N	36108	0	180256009	4107731	
17981	1538	4107731	1992-08-24	1992-08-24 00:00:00	38000275	0	\N	\N	103034	0	180256009	4107731	
18253	1556	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	104180	0	180256009	4107731	
18456	1566	4010253	2010-03-14	2010-03-14 00:00:00	38000275	0	\N	\N	105037	0	112790001	4010253	
6704	610	4170947	1976-10-11	1976-10-11 00:00:00	38000275	0	\N	\N	40479	0	274474001	4170947	
18733	1606	4024289	1964-05-14	1964-05-14 00:00:00	38000275	0	\N	\N	107855	0	19490002	4024289	
18968	1622	4295880	1998-07-27	1998-07-27 00:00:00	38000275	0	\N	\N	109036	0	76601001	4295880	
19170	1649	4125906	1988-03-31	1988-03-31 00:00:00	38000275	0	\N	\N	110617	0	288086009	4125906	
7432	689	4024289	1997-05-31	1997-05-31 00:00:00	38000275	0	\N	\N	45624	0	19490002	4024289	
19469	1659	4125906	1983-05-03	1983-05-03 00:00:00	38000275	0	\N	\N	111457	0	288086009	4125906	
19637	1683	4170947	1985-11-03	1985-11-03 00:00:00	38000275	0	\N	\N	112768	0	274474001	4170947	
19930	1724	4187458	2016-08-26	2016-08-26 00:00:00	38000275	0	\N	\N	115252	0	415300000	4187458	
8195	754	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	49897	0	180256009	4107731	
8362	761	4107731	1994-06-10	1994-06-10 00:00:00	38000275	0	\N	\N	50648	0	180256009	4107731	
20546	1773	4107731	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	118602	0	180256009	4107731	
20740	1783	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	119463	0	180256009	4107731	
32776	2871	4043071	1962-11-08	1962-11-08 00:00:00	38000275	0	\N	\N	191097	0	228557008	4043071	
20962	1813	4151422	1990-02-02	1990-02-02 00:00:00	38000275	0	\N	\N	121308	0	269911007	4151422	
9301	851	4125906	1992-10-01	1992-10-01 00:00:00	38000275	0	\N	\N	56291	0	288086009	4125906	
21339	1846	4170947	2018-01-26	2018-01-26 00:00:00	38000275	0	\N	\N	123470	0	274474001	4170947	
33570	2925	4107731	1990-03-04	1990-03-04 00:00:00	38000275	0	\N	\N	195114	0	180256009	4107731	
9872	884	4107731	1994-01-11	1994-01-11 00:00:00	38000275	0	\N	\N	58910	0	180256009	4107731	
22009	1918	4043071	1978-07-10	1978-07-10 00:00:00	38000275	0	\N	\N	127647	0	228557008	4043071	
22130	1928	4024289	1974-03-21	1974-03-21 00:00:00	38000275	0	\N	\N	128307	0	19490002	4024289	
10445	938	4163872	1975-05-22	1975-05-22 00:00:00	38000275	0	\N	\N	62348	0	399208008	4163872	
22458	1967	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	130831	0	180256009	4107731	
22709	1977	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	131561	0	395142003	4191853	
22899	1992	4107731	1991-09-29	1991-09-29 00:00:00	38000275	0	\N	\N	132676	0	180256009	4107731	
35057	3053	4326177	1987-01-08	1987-01-08 00:00:00	38000275	0	\N	\N	203142	0	430193006	4326177	
23281	2025	4078793	2017-06-10	2017-06-10 00:00:00	38000275	0	\N	\N	134756	0	180325003	4078793	
23514	2058	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	136899	0	180256009	4107731	
11737	1083	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	71129	0	180256009	4107731	
23778	2073	4163872	1979-05-13	1979-05-13 00:00:00	38000275	0	\N	\N	137884	0	399208008	4163872	
140	9	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	843	0	180256009	4107731	
12298	1110	4107731	1995-11-06	1995-11-06 00:00:00	38000275	0	\N	\N	73054	0	180256009	4107731	
12388	1115	4107731	1992-12-07	1992-12-07 00:00:00	38000275	0	\N	\N	73368	0	180256009	4107731	
12620	1138	4191853	1985-02-26	1985-02-26 00:00:00	38000275	0	\N	\N	75060	0	395142003	4191853	
24700	2160	44783196	2012-07-02	2012-07-02 00:00:00	38000275	0	\N	\N	143996	0	699253003	44783196	
12973	1175	4107731	1991-05-19	1991-05-19 00:00:00	38000275	0	\N	\N	77456	0	180256009	4107731	
13235	1205	4163872	1976-07-22	1976-07-22 00:00:00	38000275	0	\N	\N	79174	0	399208008	4163872	
13315	1211	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	79561	0	180256009	4107731	
13583	1227	4047491	1943-03-27	1943-03-27 00:00:00	38000275	0	\N	\N	80815	0	1225002	4047491	
13667	1246	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	82045	0	180256009	4107731	
2016	190	4125906	2011-01-07	2011-01-07 00:00:00	38000275	0	\N	\N	13000	0	288086009	4125906	
2229	225	4107731	1991-01-14	1991-01-14 00:00:00	38000275	0	\N	\N	15212	0	180256009	4107731	
14353	1281	4125906	2002-10-12	2002-10-12 00:00:00	38000275	0	\N	\N	84704	0	288086009	4125906	
2608	266	4107731	1992-03-30	1992-03-30 00:00:00	38000275	0	\N	\N	17758	0	180256009	4107731	
26557	2318	4163951	1969-03-09	1969-03-09 00:00:00	38000275	0	\N	\N	154115	0	29303009	4163951	
2967	285	4107731	1990-05-07	1990-05-07 00:00:00	38000275	0	\N	\N	18942	0	180256009	4107731	
15031	1338	4195803	2019-03-23	2019-03-23 00:00:00	38000275	0	\N	\N	88765	0	312681000	4195803	
15164	1356	4107731	1998-01-08	1998-01-08 00:00:00	38000275	0	\N	\N	89972	0	180256009	4107731	
15451	1377	4295880	1995-11-20	1995-11-20 00:00:00	38000275	0	\N	\N	91257	0	76601001	4295880	
3692	357	4125906	2016-08-23	2016-08-23 00:00:00	38000275	0	\N	\N	23640	0	288086009	4125906	
15850	1397	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	92797	0	180256009	4107731	
4065	404	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	26695	0	180256009	4107731	
4255	411	4125906	1981-10-23	1981-10-23 00:00:00	38000275	0	\N	\N	27404	0	288086009	4125906	
28250	2501	4125906	2019-06-04	2019-06-04 00:00:00	38000275	0	\N	\N	165578	0	288086009	4125906	
16479	1432	4163872	1979-07-06	1979-07-06 00:00:00	38000275	0	\N	\N	95415	0	399208008	4163872	
16697	1447	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	96552	0	180256009	4107731	
16835	1460	4151422	1991-01-30	1991-01-30 00:00:00	38000275	0	\N	\N	97279	0	269911007	4151422	
5211	484	4047491	1997-03-15	1997-03-15 00:00:00	38000275	0	\N	\N	32401	0	1225002	4047491	
17222	1486	4107731	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	99110	0	180256009	4107731	
5565	507	4125906	1994-05-11	1994-05-11 00:00:00	38000275	0	\N	\N	33958	0	288086009	4125906	
17626	1513	4107731	1993-04-18	1993-04-18 00:00:00	38000275	0	\N	\N	101017	0	180256009	4107731	
5957	545	4191853	1990-01-06	1990-01-06 00:00:00	38000275	0	\N	\N	36041	0	395142003	4191853	
17982	1538	4202451	2016-09-19	2016-09-19 00:00:00	38000275	0	\N	\N	103052	0	433112001	4202451	
18254	1556	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	104240	0	180256009	4107731	
18457	1566	4170947	1970-08-20	1970-08-20 00:00:00	38000275	0	\N	\N	104982	0	274474001	4170947	
6705	610	4243062	1976-10-11	1976-10-11 00:00:00	38000275	0	\N	\N	40479	0	60027007	4243062	
18734	1606	4151422	2012-08-14	2012-08-14 00:00:00	38000275	0	\N	\N	107822	0	269911007	4151422	
18969	1622	4295880	2003-04-21	2003-04-21 00:00:00	38000275	0	\N	\N	109016	0	76601001	4295880	
19171	1649	4336464	2017-08-23	2017-08-23 00:00:00	38000275	0	\N	\N	110618	0	232717009	4336464	
7433	689	4295880	2001-02-11	2001-02-11 00:00:00	38000275	0	\N	\N	45626	0	76601001	4295880	
19470	1659	4043071	1981-06-08	1981-06-08 00:00:00	38000275	0	\N	\N	111428	0	228557008	4043071	
19638	1683	4243062	1985-11-03	1985-11-03 00:00:00	38000275	0	\N	\N	112768	0	60027007	4243062	
19931	1724	4326177	2016-08-26	2016-08-26 00:00:00	38000275	0	\N	\N	115252	0	430193006	4326177	
8196	754	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	49963	0	180256009	4107731	
8363	761	4107731	1993-08-20	1993-08-20 00:00:00	38000275	0	\N	\N	50542	0	180256009	4107731	
20547	1773	4107731	1990-12-09	1990-12-09 00:00:00	38000275	0	\N	\N	118578	0	180256009	4107731	
20741	1783	4107731	1991-12-16	1991-12-16 00:00:00	38000275	0	\N	\N	119553	0	180256009	4107731	
32777	2871	4043071	1962-02-22	1962-02-22 00:00:00	38000275	0	\N	\N	191067	0	228557008	4043071	
20963	1814	4058899	1953-07-11	1953-07-11 00:00:00	38000275	0	\N	\N	121429	0	168594001	4058899	
9302	851	4058899	1982-06-26	1982-06-26 00:00:00	38000275	0	\N	\N	56290	0	168594001	4058899	
21340	1846	4024289	2018-01-26	2018-01-26 00:00:00	38000275	0	\N	\N	123470	0	19490002	4024289	
33571	2925	4107731	1990-08-20	1990-08-20 00:00:00	38000275	0	\N	\N	195030	0	180256009	4107731	
9873	884	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	58895	0	180256009	4107731	
22010	1918	4043071	1979-06-11	1979-06-11 00:00:00	38000275	0	\N	\N	127591	0	228557008	4043071	
22131	1928	4170947	1974-03-21	1974-03-21 00:00:00	38000275	0	\N	\N	128307	0	274474001	4170947	
10446	938	4151422	1958-02-12	1958-02-12 00:00:00	38000275	0	\N	\N	62316	0	269911007	4151422	
22459	1967	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	130848	0	180256009	4107731	
22710	1977	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	131582	0	180256009	4107731	
22900	1992	4107731	1991-11-10	1991-11-10 00:00:00	38000275	0	\N	\N	132680	0	180256009	4107731	
35058	3053	4037675	1987-01-08	1987-01-08 00:00:00	38000275	0	\N	\N	203142	0	162676008	4037675	
23282	2025	4125906	1948-01-02	1948-01-02 00:00:00	38000275	0	\N	\N	134665	0	288086009	4125906	
23515	2058	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	136843	0	180256009	4107731	
11738	1083	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	71108	0	180256009	4107731	
23779	2073	4170947	1979-05-13	1979-05-13 00:00:00	38000275	0	\N	\N	137884	0	274474001	4170947	
141	9	4107731	1993-10-21	1993-10-21 00:00:00	38000275	0	\N	\N	750	0	180256009	4107731	
12299	1110	4107731	1996-02-19	1996-02-19 00:00:00	38000275	0	\N	\N	73093	0	180256009	4107731	
12389	1115	4163872	1958-01-14	1958-01-14 00:00:00	38000275	0	\N	\N	73385	0	399208008	4163872	
12621	1138	4043071	1996-06-13	1996-06-13 00:00:00	38000275	0	\N	\N	74993	0	228557008	4043071	
24701	2160	4125906	2002-03-31	2002-03-31 00:00:00	38000275	0	\N	\N	143920	0	288086009	4125906	
12974	1175	4107731	1990-06-17	1990-06-17 00:00:00	38000275	0	\N	\N	77441	0	180256009	4107731	
13236	1205	4151422	1975-07-20	1975-07-20 00:00:00	38000275	0	\N	\N	79199	0	269911007	4151422	
13316	1211	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	79501	0	180256009	4107731	
13584	1228	4293740	2001-09-19	2001-09-19 00:00:00	38000275	0	\N	\N	80895	0	384700001	4293740	
13668	1246	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	82162	0	180256009	4107731	
2017	191	4125906	1983-10-06	1983-10-06 00:00:00	38000275	0	\N	\N	13040	0	288086009	4125906	
2230	225	4107731	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	15141	0	180256009	4107731	
14354	1281	4057420	2012-07-21	2012-07-21 00:00:00	38000275	0	\N	\N	84706	0	18286008	4057420	
2609	266	4107731	1990-08-20	1990-08-20 00:00:00	38000275	0	\N	\N	17699	0	180256009	4107731	
26558	2318	42535580	1969-03-09	1969-03-09 00:00:00	38000275	0	\N	\N	154115	0	426701000119108	42535580	
2968	285	4107731	1992-03-09	1992-03-09 00:00:00	38000275	0	\N	\N	18940	0	180256009	4107731	
15032	1338	4058899	1948-04-13	1948-04-13 00:00:00	38000275	0	\N	\N	88763	0	168594001	4058899	
15165	1356	4107731	1998-03-12	1998-03-12 00:00:00	38000275	0	\N	\N	89953	0	180256009	4107731	
15452	1377	4295880	1998-11-17	1998-11-17 00:00:00	38000275	0	\N	\N	91237	0	76601001	4295880	
3693	357	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	23669	0	180256009	4107731	
15851	1397	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	92733	0	180256009	4107731	
4066	404	4043071	1970-12-18	1970-12-18 00:00:00	38000275	0	\N	\N	26666	0	228557008	4043071	
4256	411	4107731	1992-02-22	1992-02-22 00:00:00	38000275	0	\N	\N	27402	0	180256009	4107731	
28251	2501	4125906	1979-05-09	1979-05-09 00:00:00	38000275	0	\N	\N	165575	0	288086009	4125906	
16480	1432	4125906	2005-04-06	2005-04-06 00:00:00	38000275	0	\N	\N	95408	0	288086009	4125906	
16698	1447	4024289	1972-06-27	1972-06-27 00:00:00	38000275	0	\N	\N	96482	0	19490002	4024289	
16836	1460	4275113	2002-04-22	2002-04-22 00:00:00	38000275	0	\N	\N	97308	0	65200003	4275113	
5212	484	4195803	1997-03-15	1997-03-15 00:00:00	38000275	0	\N	\N	32401	0	312681000	4195803	
17223	1486	4107731	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	99130	0	180256009	4107731	
5566	507	4078793	1999-07-30	1999-07-30 00:00:00	38000275	0	\N	\N	33930	0	180325003	4078793	
17627	1513	4107731	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	101143	0	180256009	4107731	
5958	545	4107731	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	36079	0	180256009	4107731	
17983	1538	4078793	2016-06-20	2016-06-20 00:00:00	38000275	0	\N	\N	103052	0	180325003	4078793	
18255	1556	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	104216	0	180256009	4107731	
18458	1566	4163872	1970-08-20	1970-08-20 00:00:00	38000275	0	\N	\N	104982	0	399208008	4163872	
6706	610	4047491	2008-12-04	2008-12-04 00:00:00	38000275	0	\N	\N	40482	0	1225002	4047491	
18735	1608	4125906	1982-04-06	1982-04-06 00:00:00	38000275	0	\N	\N	107983	0	288086009	4125906	
18970	1622	4295880	1999-10-25	1999-10-25 00:00:00	38000275	0	\N	\N	109044	0	76601001	4295880	
19172	1649	4216130	2017-08-23	2017-08-23 00:00:00	38000275	0	\N	\N	110618	0	415070008	4216130	
7434	689	4295880	2000-05-14	2000-05-14 00:00:00	38000275	0	\N	\N	45625	0	76601001	4295880	
19471	1659	4043071	1981-07-13	1981-07-13 00:00:00	38000275	0	\N	\N	111460	0	228557008	4043071	
19647	1689	4125906	1992-02-04	1992-02-04 00:00:00	38000275	0	\N	\N	113157	0	288086009	4125906	
19932	1724	4037675	2016-08-26	2016-08-26 00:00:00	38000275	0	\N	\N	115252	0	162676008	4037675	
8197	754	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	49939	0	180256009	4107731	
8364	761	4107731	1993-10-01	1993-10-01 00:00:00	38000275	0	\N	\N	50554	0	180256009	4107731	
20548	1773	4197460	1967-10-04	1967-10-04 00:00:00	38000275	0	\N	\N	118551	0	313191000	4197460	
20742	1783	4107731	1992-11-16	1992-11-16 00:00:00	38000275	0	\N	\N	119522	0	180256009	4107731	
32778	2872	40492359	1971-09-07	1971-09-07 00:00:00	38000275	0	\N	\N	191205	0	447365002	40492359	
20964	1814	4058899	1949-09-30	1949-09-30 00:00:00	38000275	0	\N	\N	121428	0	168594001	4058899	
9311	855	4125906	1967-07-29	1967-07-29 00:00:00	38000275	0	\N	\N	56514	0	288086009	4125906	
21341	1846	4195803	2018-01-26	2018-01-26 00:00:00	38000275	0	\N	\N	123470	0	312681000	4195803	
33572	2925	4107731	1991-01-13	1991-01-13 00:00:00	38000275	0	\N	\N	195118	0	180256009	4107731	
9874	884	4107731	1993-12-21	1993-12-21 00:00:00	38000275	0	\N	\N	58917	0	180256009	4107731	
22011	1918	4170947	1987-09-03	1987-09-03 00:00:00	38000275	0	\N	\N	127586	0	274474001	4170947	
22132	1928	4163872	1983-11-29	1983-11-29 00:00:00	38000275	0	\N	\N	128377	0	399208008	4163872	
10447	938	4170947	1963-12-12	1963-12-12 00:00:00	38000275	0	\N	\N	62328	0	274474001	4170947	
22460	1967	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	130764	0	180256009	4107731	
22711	1977	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	131635	0	180256009	4107731	
22901	1992	4107731	1991-05-05	1991-05-05 00:00:00	38000275	0	\N	\N	132667	0	180256009	4107731	
35064	3056	4293740	1981-02-20	1981-02-20 00:00:00	38000275	0	\N	\N	203307	0	384700001	4293740	
23283	2025	4078793	1987-01-24	1987-01-24 00:00:00	38000275	0	\N	\N	134761	0	180325003	4078793	
23516	2058	4275113	1982-10-16	1982-10-16 00:00:00	38000275	0	\N	\N	136893	0	65200003	4275113	
11739	1083	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	71130	0	180256009	4107731	
23780	2073	4151422	1984-12-30	1984-12-30 00:00:00	38000275	0	\N	\N	137899	0	269911007	4151422	
142	9	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	812	0	180256009	4107731	
12300	1110	4107731	1997-12-22	1997-12-22 00:00:00	38000275	0	\N	\N	73074	0	180256009	4107731	
12390	1115	4170947	1958-01-14	1958-01-14 00:00:00	38000275	0	\N	\N	73385	0	274474001	4170947	
12622	1138	4107731	1995-11-30	1995-11-30 00:00:00	38000275	0	\N	\N	74990	0	180256009	4107731	
24702	2160	4252419	2012-06-25	2012-06-25 00:00:00	38000275	0	\N	\N	143922	0	74016001	4252419	
12975	1175	4107731	1992-01-05	1992-01-05 00:00:00	38000275	0	\N	\N	77502	0	180256009	4107731	
13237	1205	4238715	1986-10-23	1986-10-23 00:00:00	38000275	0	\N	\N	79218	0	68254000	4238715	
13317	1211	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	79653	0	180256009	4107731	
13585	1228	4125906	2001-09-19	2001-09-19 00:00:00	38000275	0	\N	\N	80895	0	288086009	4125906	
13669	1246	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	82117	0	395142003	4191853	
2018	191	4243062	1939-03-31	1939-03-31 00:00:00	38000275	0	\N	\N	13039	0	60027007	4243062	
2231	225	4107731	1990-06-18	1990-06-18 00:00:00	38000275	0	\N	\N	15140	0	180256009	4107731	
14355	1281	40492359	2012-07-21	2012-07-21 00:00:00	38000275	0	\N	\N	84706	0	447365002	40492359	
2610	266	4191853	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	17657	0	395142003	4191853	
26559	2318	4163971	1969-03-09	1969-03-09 00:00:00	38000275	0	\N	\N	154115	0	45595009	4163971	
2969	285	4107731	1992-10-05	1992-10-05 00:00:00	38000275	0	\N	\N	18980	0	180256009	4107731	
15033	1339	4170947	1973-05-12	1973-05-12 00:00:00	38000275	0	\N	\N	88819	0	274474001	4170947	
15166	1356	4107731	1997-04-10	1997-04-10 00:00:00	38000275	0	\N	\N	89969	0	180256009	4107731	
15453	1377	4295880	1997-11-18	1997-11-18 00:00:00	38000275	0	\N	\N	91272	0	76601001	4295880	
3694	357	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	23756	0	180256009	4107731	
15852	1397	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	92785	0	180256009	4107731	
4067	404	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	26634	0	180256009	4107731	
4257	411	4107731	1991-07-27	1991-07-27 00:00:00	38000275	0	\N	\N	27371	0	180256009	4107731	
28253	2503	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	165696	0	180256009	4107731	
16481	1433	4163872	1970-01-13	1970-01-13 00:00:00	38000275	0	\N	\N	95491	0	399208008	4163872	
16699	1447	4170947	1972-06-27	1972-06-27 00:00:00	38000275	0	\N	\N	96482	0	274474001	4170947	
16837	1460	4238715	2003-07-05	2003-07-05 00:00:00	38000275	0	\N	\N	97280	0	68254000	4238715	
5213	484	4170947	1997-03-15	1997-03-15 00:00:00	38000275	0	\N	\N	32401	0	274474001	4170947	
17224	1486	4107731	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	99054	0	180256009	4107731	
5567	507	4078793	2012-09-28	2012-09-28 00:00:00	38000275	0	\N	\N	33960	0	180325003	4078793	
17628	1513	4181917	1981-05-23	1981-05-23 00:00:00	38000275	0	\N	\N	101150	0	54550000	4181917	
5959	545	4107731	1992-08-29	1992-08-29 00:00:00	38000275	0	\N	\N	36059	0	180256009	4107731	
17984	1538	4107731	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	103058	0	180256009	4107731	
18256	1556	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	104152	0	180256009	4107731	
18459	1566	4062501	1970-11-10	1970-11-10 00:00:00	38000275	0	\N	\N	105052	0	171231001	4062501	
6707	610	4170947	2008-12-04	2008-12-04 00:00:00	38000275	0	\N	\N	40482	0	274474001	4170947	
18736	1608	4202451	2016-04-16	2016-04-16 00:00:00	38000275	0	\N	\N	107980	0	433112001	4202451	
18971	1622	4295880	2002-07-22	2002-07-22 00:00:00	38000275	0	\N	\N	108965	0	76601001	4295880	
19173	1649	4163872	1969-11-02	1969-11-02 00:00:00	38000275	0	\N	\N	110673	0	399208008	4163872	
7435	689	4295880	1998-05-17	1998-05-17 00:00:00	38000275	0	\N	\N	45699	0	76601001	4295880	
19472	1659	4043071	1980-01-14	1980-01-14 00:00:00	38000275	0	\N	\N	111532	0	228557008	4043071	
19648	1689	4125906	1964-10-23	1964-10-23 00:00:00	38000275	0	\N	\N	113089	0	288086009	4125906	
19933	1724	4125906	1987-06-21	1987-06-21 00:00:00	38000275	0	\N	\N	115265	0	288086009	4125906	
8198	754	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	49991	0	180256009	4107731	
8365	761	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	50632	0	180256009	4107731	
20549	1773	4107731	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	118512	0	180256009	4107731	
20743	1783	4107731	1993-02-08	1993-02-08 00:00:00	38000275	0	\N	\N	119386	0	180256009	4107731	
32779	2872	4057420	1971-09-07	1971-09-07 00:00:00	38000275	0	\N	\N	191205	0	18286008	4057420	
20965	1814	4010253	1958-09-28	1958-09-28 00:00:00	38000275	0	\N	\N	121410	0	112790001	4010253	
9312	856	4024289	2011-09-06	2011-09-06 00:00:00	38000275	0	\N	\N	56576	0	19490002	4024289	
21342	1846	4151422	1963-05-25	1963-05-25 00:00:00	38000275	0	\N	\N	123408	0	269911007	4151422	
33573	2925	4107731	1991-04-29	1991-04-29 00:00:00	38000275	0	\N	\N	195064	0	180256009	4107731	
9875	884	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	58849	0	180256009	4107731	
22012	1918	4163872	1987-09-03	1987-09-03 00:00:00	38000275	0	\N	\N	127586	0	399208008	4163872	
22133	1928	4170947	1983-11-29	1983-11-29 00:00:00	38000275	0	\N	\N	128377	0	274474001	4170947	
10448	938	4243062	1963-12-12	1963-12-12 00:00:00	38000275	0	\N	\N	62328	0	60027007	4243062	
22461	1967	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	130798	0	180256009	4107731	
22712	1977	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	131651	0	180256009	4107731	
22902	1992	4191853	1990-01-07	1990-01-07 00:00:00	38000275	0	\N	\N	132713	0	395142003	4191853	
35065	3056	4125906	1981-02-20	1981-02-20 00:00:00	38000275	0	\N	\N	203307	0	288086009	4125906	
23284	2025	4125906	1918-09-01	1918-09-01 00:00:00	38000275	0	\N	\N	134662	0	288086009	4125906	
23517	2058	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	136851	0	180256009	4107731	
11740	1083	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	71128	0	180256009	4107731	
23782	2075	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	138073	0	180256009	4107731	
143	9	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	793	0	180256009	4107731	
12301	1110	4107731	1995-12-18	1995-12-18 00:00:00	38000275	0	\N	\N	73055	0	180256009	4107731	
12391	1115	4107731	1993-01-18	1993-01-18 00:00:00	38000275	0	\N	\N	73483	0	180256009	4107731	
12623	1138	4107731	1996-07-18	1996-07-18 00:00:00	38000275	0	\N	\N	74994	0	180256009	4107731	
24703	2160	4125906	2014-05-23	2014-05-23 00:00:00	38000275	0	\N	\N	143923	0	288086009	4125906	
12976	1175	4107731	1991-02-03	1991-02-03 00:00:00	38000275	0	\N	\N	77437	0	180256009	4107731	
13238	1206	4151422	1993-11-12	1993-11-12 00:00:00	38000275	0	\N	\N	79248	0	269911007	4151422	
13318	1211	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	79513	0	180256009	4107731	
13586	1228	4238715	1996-10-05	1996-10-05 00:00:00	38000275	0	\N	\N	80898	0	68254000	4238715	
13670	1246	4058899	1947-07-03	1947-07-03 00:00:00	38000275	0	\N	\N	82134	0	168594001	4058899	
2019	191	4170947	1939-03-31	1939-03-31 00:00:00	38000275	0	\N	\N	13039	0	274474001	4170947	
2232	225	4107731	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	15138	0	180256009	4107731	
14356	1281	4170947	1984-06-18	1984-06-18 00:00:00	38000275	0	\N	\N	84703	0	274474001	4170947	
2611	266	4107731	1990-01-22	1990-01-22 00:00:00	38000275	0	\N	\N	17673	0	180256009	4107731	
26560	2318	4202832	1969-03-09	1969-03-09 00:00:00	38000275	0	\N	\N	154115	0	52765003	4202832	
2970	285	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	18926	0	180256009	4107731	
15034	1339	4163872	1973-05-12	1973-05-12 00:00:00	38000275	0	\N	\N	88819	0	399208008	4163872	
15167	1356	4107731	1998-02-19	1998-02-19 00:00:00	38000275	0	\N	\N	89943	0	180256009	4107731	
15454	1377	4295880	1996-02-20	1996-02-20 00:00:00	38000275	0	\N	\N	91242	0	76601001	4295880	
3695	357	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	23763	0	180256009	4107731	
15853	1397	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	92791	0	180256009	4107731	
4068	404	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	26670	0	180256009	4107731	
4258	411	4107731	1993-04-17	1993-04-17 00:00:00	38000275	0	\N	\N	27334	0	180256009	4107731	
28254	2503	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	165755	0	180256009	4107731	
16485	1435	4047491	2009-01-24	2009-01-24 00:00:00	38000275	0	\N	\N	95586	0	1225002	4047491	
16700	1447	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	96462	0	180256009	4107731	
16838	1461	4293740	1994-09-30	1994-09-30 00:00:00	38000275	0	\N	\N	97353	0	384700001	4293740	
5214	484	4170947	1947-10-13	1947-10-13 00:00:00	38000275	0	\N	\N	32399	0	274474001	4170947	
17225	1486	4107731	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	99125	0	180256009	4107731	
5568	507	4078793	2005-09-02	2005-09-02 00:00:00	38000275	0	\N	\N	33934	0	180325003	4078793	
17629	1513	4107731	1991-08-18	1991-08-18 00:00:00	38000275	0	\N	\N	101145	0	180256009	4107731	
5960	545	4107731	1991-06-15	1991-06-15 00:00:00	38000275	0	\N	\N	36075	0	180256009	4107731	
17985	1538	4107731	1992-08-03	1992-08-03 00:00:00	38000275	0	\N	\N	103092	0	180256009	4107731	
18257	1556	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	104185	0	180256009	4107731	
18460	1567	4197460	1991-09-28	1991-09-28 00:00:00	38000275	0	\N	\N	105106	0	313191000	4197460	
6708	610	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	40532	0	180256009	4107731	
18737	1608	4125906	1974-11-23	1974-11-23 00:00:00	38000275	0	\N	\N	108014	0	288086009	4125906	
18972	1622	4295880	2000-04-24	2000-04-24 00:00:00	38000275	0	\N	\N	109027	0	76601001	4295880	
19174	1649	4170947	1960-09-12	1960-09-12 00:00:00	38000275	0	\N	\N	110676	0	274474001	4170947	
7436	689	4295880	2004-05-09	2004-05-09 00:00:00	38000275	0	\N	\N	45628	0	76601001	4295880	
19473	1659	4043071	1981-04-13	1981-04-13 00:00:00	38000275	0	\N	\N	111574	0	228557008	4043071	
19649	1689	4170947	1952-07-28	1952-07-28 00:00:00	38000275	0	\N	\N	113088	0	274474001	4170947	
19934	1724	4125906	2019-02-01	2019-02-01 00:00:00	38000275	0	\N	\N	115303	0	288086009	4125906	
8199	754	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	49930	0	180256009	4107731	
8366	761	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	50642	0	180256009	4107731	
20550	1773	4107731	1991-09-08	1991-09-08 00:00:00	38000275	0	\N	\N	118596	0	180256009	4107731	
20744	1783	4107731	1992-10-05	1992-10-05 00:00:00	38000275	0	\N	\N	119520	0	180256009	4107731	
32780	2872	4125906	1968-04-07	1968-04-07 00:00:00	38000275	0	\N	\N	191204	0	288086009	4125906	
20966	1814	4170947	2009-12-12	2009-12-12 00:00:00	38000275	0	\N	\N	121432	0	274474001	4170947	
9313	856	4170947	2011-09-06	2011-09-06 00:00:00	38000275	0	\N	\N	56576	0	274474001	4170947	
21343	1846	4024289	2007-04-24	2007-04-24 00:00:00	38000275	0	\N	\N	123469	0	19490002	4024289	
33574	2925	4107731	1991-03-17	1991-03-17 00:00:00	38000275	0	\N	\N	195063	0	180256009	4107731	
9876	884	4107731	1993-11-30	1993-11-30 00:00:00	38000275	0	\N	\N	58909	0	180256009	4107731	
22013	1918	4043071	1977-10-17	1977-10-17 00:00:00	38000275	0	\N	\N	127624	0	228557008	4043071	
22134	1929	4125906	1966-08-16	1966-08-16 00:00:00	38000275	0	\N	\N	128391	0	288086009	4125906	
10449	938	4125906	1971-04-04	1971-04-04 00:00:00	38000275	0	\N	\N	62329	0	288086009	4125906	
22462	1967	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	130787	0	180256009	4107731	
22713	1977	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	131628	0	180256009	4107731	
22903	1992	4107731	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	132733	0	180256009	4107731	
35066	3056	4151422	1991-01-26	1991-01-26 00:00:00	38000275	0	\N	\N	203291	0	269911007	4151422	
23285	2025	4078793	2012-02-04	2012-02-04 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
23518	2058	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	136803	0	180256009	4107731	
11741	1083	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	71138	0	180256009	4107731	
23783	2075	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	138085	0	180256009	4107731	
144	9	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	832	0	180256009	4107731	
12302	1110	4107731	1996-07-15	1996-07-15 00:00:00	38000275	0	\N	\N	73033	0	180256009	4107731	
12392	1115	4107731	1990-07-09	1990-07-09 00:00:00	38000275	0	\N	\N	73349	0	180256009	4107731	
12624	1138	4107731	1994-11-17	1994-11-17 00:00:00	38000275	0	\N	\N	75052	0	180256009	4107731	
24704	2160	4125906	1982-09-14	1982-09-14 00:00:00	38000275	0	\N	\N	143918	0	288086009	4125906	
12977	1175	4125906	1979-06-25	1979-06-25 00:00:00	38000275	0	\N	\N	77420	0	288086009	4125906	
13239	1206	4191853	1988-02-28	1988-02-28 00:00:00	38000275	0	\N	\N	79246	0	395142003	4191853	
13319	1211	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	79502	0	180256009	4107731	
13587	1228	4191853	1979-07-31	1979-07-31 00:00:00	38000275	0	\N	\N	80917	0	395142003	4191853	
13671	1246	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	82007	0	180256009	4107731	
2020	191	4202451	1969-11-04	1969-11-04 00:00:00	38000275	0	\N	\N	13121	0	433112001	4202451	
2233	225	4107731	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	15192	0	180256009	4107731	
14357	1281	4243062	1984-06-18	1984-06-18 00:00:00	38000275	0	\N	\N	84703	0	60027007	4243062	
2612	266	4107731	1992-12-07	1992-12-07 00:00:00	38000275	0	\N	\N	17647	0	180256009	4107731	
26561	2318	4238715	1991-05-25	1991-05-25 00:00:00	38000275	0	\N	\N	154053	0	68254000	4238715	
2971	285	4191853	1990-01-01	1990-01-01 00:00:00	38000275	0	\N	\N	18965	0	395142003	4191853	
15035	1339	4243062	1968-12-29	1968-12-29 00:00:00	38000275	0	\N	\N	88788	0	60027007	4243062	
15168	1356	4107731	1996-01-25	1996-01-25 00:00:00	38000275	0	\N	\N	89912	0	180256009	4107731	
15455	1377	4295880	1998-08-18	1998-08-18 00:00:00	38000275	0	\N	\N	91273	0	76601001	4295880	
3696	357	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	23705	0	180256009	4107731	
15854	1397	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	92848	0	180256009	4107731	
4069	404	4107731	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	26598	0	180256009	4107731	
4259	411	4107731	1990-07-14	1990-07-14 00:00:00	38000275	0	\N	\N	27395	0	180256009	4107731	
28255	2503	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	165738	0	180256009	4107731	
16486	1435	4170947	2009-01-24	2009-01-24 00:00:00	38000275	0	\N	\N	95586	0	274474001	4170947	
16701	1447	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	96554	0	180256009	4107731	
16839	1461	4125906	1994-09-30	1994-09-30 00:00:00	38000275	0	\N	\N	97353	0	288086009	4125906	
5215	484	4047491	1947-10-13	1947-10-13 00:00:00	38000275	0	\N	\N	32399	0	1225002	4047491	
17226	1486	4191853	1993-07-11	1993-07-11 00:00:00	38000275	0	\N	\N	99099	0	395142003	4191853	
5569	507	4057420	2013-10-04	2013-10-04 00:00:00	38000275	0	\N	\N	33972	0	18286008	4057420	
17630	1513	4107731	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	101147	0	180256009	4107731	
5961	545	4107731	1992-12-12	1992-12-12 00:00:00	38000275	0	\N	\N	36046	0	180256009	4107731	
17986	1538	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	103036	0	180256009	4107731	
18258	1556	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	104248	0	180256009	4107731	
18461	1567	4125906	1990-07-05	1990-07-05 00:00:00	38000275	0	\N	\N	105105	0	288086009	4125906	
6709	610	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	40499	0	180256009	4107731	
18738	1608	4293740	1974-11-23	1974-11-23 00:00:00	38000275	0	\N	\N	108014	0	384700001	4293740	
18973	1622	4295880	1999-01-25	1999-01-25 00:00:00	38000275	0	\N	\N	109042	0	76601001	4295880	
19175	1649	4024289	1960-09-12	1960-09-12 00:00:00	38000275	0	\N	\N	110676	0	19490002	4024289	
7437	689	4295880	2001-11-11	2001-11-11 00:00:00	38000275	0	\N	\N	45627	0	76601001	4295880	
19474	1659	4043071	1977-07-25	1977-07-25 00:00:00	38000275	0	\N	\N	111513	0	228557008	4043071	
19650	1689	4047491	1952-07-28	1952-07-28 00:00:00	38000275	0	\N	\N	113088	0	1225002	4047491	
19935	1724	4293740	2019-02-01	2019-02-01 00:00:00	38000275	0	\N	\N	115303	0	384700001	4293740	
8200	754	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	49828	0	180256009	4107731	
8367	761	4107731	1994-08-12	1994-08-12 00:00:00	38000275	0	\N	\N	50622	0	180256009	4107731	
20551	1773	4107731	1993-01-24	1993-01-24 00:00:00	38000275	0	\N	\N	118638	0	180256009	4107731	
20745	1783	4107731	1992-08-24	1992-08-24 00:00:00	38000275	0	\N	\N	119519	0	180256009	4107731	
32781	2872	4125906	1954-10-27	1954-10-27 00:00:00	38000275	0	\N	\N	191203	0	288086009	4125906	
20967	1814	4243062	2009-12-12	2009-12-12 00:00:00	38000275	0	\N	\N	121432	0	60027007	4243062	
9314	856	44783196	1971-12-07	1971-12-07 00:00:00	38000275	0	\N	\N	56555	0	699253003	44783196	
21344	1846	4170947	2007-04-24	2007-04-24 00:00:00	38000275	0	\N	\N	123469	0	274474001	4170947	
33575	2925	4107731	1992-10-25	1992-10-25 00:00:00	38000275	0	\N	\N	195076	0	180256009	4107731	
9877	884	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	58880	0	180256009	4107731	
22014	1918	4043071	1978-10-02	1978-10-02 00:00:00	38000275	0	\N	\N	127614	0	228557008	4043071	
22135	1929	4125906	2016-11-03	2016-11-03 00:00:00	38000275	0	\N	\N	128393	0	288086009	4125906	
10450	938	4163872	2000-12-30	2000-12-30 00:00:00	38000275	0	\N	\N	62353	0	399208008	4163872	
22463	1967	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	130758	0	180256009	4107731	
22714	1977	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	131589	0	180256009	4107731	
22904	1992	4107731	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	132668	0	180256009	4107731	
35067	3056	4163872	1960-05-12	1960-05-12 00:00:00	38000275	0	\N	\N	203293	0	399208008	4163872	
23286	2025	4078793	2004-05-01	2004-05-01 00:00:00	38000275	0	\N	\N	134781	0	180325003	4078793	
23519	2058	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	136845	0	180256009	4107731	
11742	1083	4197460	1967-10-11	1967-10-11 00:00:00	38000275	0	\N	\N	71055	0	313191000	4197460	
23784	2075	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	138083	0	180256009	4107731	
145	9	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	839	0	180256009	4107731	
12303	1110	4107731	1996-10-28	1996-10-28 00:00:00	38000275	0	\N	\N	73059	0	180256009	4107731	
12393	1115	4107731	1992-09-14	1992-09-14 00:00:00	38000275	0	\N	\N	73366	0	180256009	4107731	
12625	1138	4107731	1993-07-22	1993-07-22 00:00:00	38000275	0	\N	\N	75073	0	180256009	4107731	
24716	2164	4125906	2006-09-22	2006-09-22 00:00:00	38000275	0	\N	\N	144124	0	288086009	4125906	
12978	1175	4293740	1979-06-25	1979-06-25 00:00:00	38000275	0	\N	\N	77420	0	384700001	4293740	
13240	1206	4125906	1998-08-08	1998-08-08 00:00:00	38000275	0	\N	\N	79262	0	288086009	4125906	
13320	1211	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	79544	0	180256009	4107731	
13588	1228	4198190	2016-06-26	2016-06-26 00:00:00	38000275	0	\N	\N	80893	0	80146002	4198190	
13672	1246	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	82010	0	180256009	4107731	
2021	191	4151422	1946-04-17	1946-04-17 00:00:00	38000275	0	\N	\N	13062	0	269911007	4151422	
2234	225	4107731	1992-08-24	1992-08-24 00:00:00	38000275	0	\N	\N	15219	0	180256009	4107731	
14358	1282	4238715	1994-04-09	1994-04-09 00:00:00	38000275	0	\N	\N	84768	0	68254000	4238715	
2613	266	4107731	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	17727	0	180256009	4107731	
26562	2318	4275113	1986-12-05	1986-12-05 00:00:00	38000275	0	\N	\N	154103	0	65200003	4275113	
2972	285	4107731	1991-12-16	1991-12-16 00:00:00	38000275	0	\N	\N	18949	0	180256009	4107731	
15036	1339	4170947	1968-12-29	1968-12-29 00:00:00	38000275	0	\N	\N	88788	0	274474001	4170947	
15169	1356	4107731	1995-07-20	1995-07-20 00:00:00	38000275	0	\N	\N	89878	0	180256009	4107731	
15456	1377	4295880	1997-05-20	1997-05-20 00:00:00	38000275	0	\N	\N	91235	0	76601001	4295880	
3697	357	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	23671	0	180256009	4107731	
15855	1397	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	92732	0	180256009	4107731	
4070	404	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	26588	0	180256009	4107731	
4260	411	4107731	1991-02-09	1991-02-09 00:00:00	38000275	0	\N	\N	27316	0	180256009	4107731	
28256	2503	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	165687	0	180256009	4107731	
16487	1435	4058899	1968-07-11	1968-07-11 00:00:00	38000275	0	\N	\N	95581	0	168594001	4058899	
16702	1447	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	96416	0	180256009	4107731	
16884	1464	4243062	1965-09-01	1965-09-01 00:00:00	38000275	0	\N	\N	97580	0	60027007	4243062	
5216	484	4151422	1958-03-21	1958-03-21 00:00:00	38000275	0	\N	\N	32307	0	269911007	4151422	
17227	1486	4107731	1990-09-16	1990-09-16 00:00:00	38000275	0	\N	\N	99146	0	180256009	4107731	
5570	507	4078793	1997-09-05	1997-09-05 00:00:00	38000275	0	\N	\N	33917	0	180325003	4078793	
17631	1513	4191853	1993-07-11	1993-07-11 00:00:00	38000275	0	\N	\N	101053	0	395142003	4191853	
5962	545	4107731	1992-02-01	1992-02-01 00:00:00	38000275	0	\N	\N	36077	0	180256009	4107731	
17987	1538	4107731	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	102980	0	180256009	4107731	
18259	1556	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	104181	0	180256009	4107731	
18462	1567	4151422	1989-07-07	1989-07-07 00:00:00	38000275	0	\N	\N	105112	0	269911007	4151422	
6710	610	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	40497	0	180256009	4107731	
18739	1608	4151422	2013-05-07	2013-05-07 00:00:00	38000275	0	\N	\N	108004	0	269911007	4151422	
18974	1622	4295880	1996-10-28	1996-10-28 00:00:00	38000275	0	\N	\N	109039	0	76601001	4295880	
31043	2757	4170947	1976-02-15	1976-02-15 00:00:00	38000275	0	\N	\N	182335	0	274474001	4170947	
7438	689	4295880	1998-11-15	1998-11-15 00:00:00	38000275	0	\N	\N	45639	0	76601001	4295880	
19482	1661	4058899	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	111654	0	168594001	4058899	
19651	1689	4151422	1986-06-08	1986-06-08 00:00:00	38000275	0	\N	\N	113121	0	269911007	4151422	
19936	1724	4293740	1995-07-23	1995-07-23 00:00:00	38000275	0	\N	\N	115266	0	384700001	4293740	
8201	754	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	49917	0	180256009	4107731	
8368	761	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	50630	0	180256009	4107731	
20552	1773	4107731	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	118613	0	180256009	4107731	
20746	1783	4107731	1990-10-01	1990-10-01 00:00:00	38000275	0	\N	\N	119540	0	180256009	4107731	
32782	2872	4198190	1979-03-07	1979-03-07 00:00:00	38000275	0	\N	\N	191208	0	80146002	4198190	
20968	1814	4195803	2009-12-12	2009-12-12 00:00:00	38000275	0	\N	\N	121432	0	312681000	4195803	
9315	856	4145310	2015-05-18	2015-05-18 00:00:00	38000275	0	\N	\N	56577	0	268425006	4145310	
21345	1846	4195803	2007-04-24	2007-04-24 00:00:00	38000275	0	\N	\N	123469	0	312681000	4195803	
33576	2925	4107731	1992-08-24	1992-08-24 00:00:00	38000275	0	\N	\N	195085	0	180256009	4107731	
9878	884	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	58842	0	180256009	4107731	
22015	1918	4043071	1977-09-12	1977-09-12 00:00:00	38000275	0	\N	\N	127628	0	228557008	4043071	
22136	1929	4293740	2016-11-03	2016-11-03 00:00:00	38000275	0	\N	\N	128393	0	384700001	4293740	
10451	939	4125906	1981-03-29	1981-03-29 00:00:00	38000275	0	\N	\N	62480	0	288086009	4125906	
22464	1967	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	130826	0	180256009	4107731	
22715	1977	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	131594	0	180256009	4107731	
22905	1992	4107731	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	132666	0	180256009	4107731	
35068	3056	4062501	1960-01-04	1960-01-04 00:00:00	38000275	0	\N	\N	203235	0	171231001	4062501	
23287	2025	4151422	1926-06-22	1926-06-22 00:00:00	38000275	0	\N	\N	134748	0	269911007	4151422	
23520	2058	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	136849	0	180256009	4107731	
11743	1083	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	71127	0	180256009	4107731	
23785	2075	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	138027	0	180256009	4107731	
146	9	4107731	1994-06-30	1994-06-30 00:00:00	38000275	0	\N	\N	791	0	180256009	4107731	
12304	1110	4107731	1998-02-23	1998-02-23 00:00:00	38000275	0	\N	\N	73067	0	180256009	4107731	
12394	1115	4107731	1990-01-22	1990-01-22 00:00:00	38000275	0	\N	\N	73405	0	180256009	4107731	
12626	1138	4107731	1994-06-23	1994-06-23 00:00:00	38000275	0	\N	\N	75046	0	180256009	4107731	
24717	2164	4125906	2014-05-04	2014-05-04 00:00:00	38000275	0	\N	\N	144125	0	288086009	4125906	
12979	1175	4107731	1990-09-30	1990-09-30 00:00:00	38000275	0	\N	\N	77454	0	180256009	4107731	
13241	1206	4125906	1991-03-04	1991-03-04 00:00:00	38000275	0	\N	\N	79261	0	288086009	4125906	
13321	1211	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	79655	0	180256009	4107731	
13589	1228	44783196	1980-01-13	1980-01-13 00:00:00	38000275	0	\N	\N	80915	0	699253003	44783196	
13673	1246	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	82019	0	180256009	4107731	
2022	191	44783196	1929-09-19	1929-09-19 00:00:00	38000275	0	\N	\N	13043	0	699253003	44783196	
2235	225	4107731	1993-02-08	1993-02-08 00:00:00	38000275	0	\N	\N	15196	0	180256009	4107731	
14359	1282	4197460	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	84709	0	313191000	4197460	
2614	266	4107731	1990-10-01	1990-10-01 00:00:00	38000275	0	\N	\N	17700	0	180256009	4107731	
26563	2319	4125906	1986-10-21	1986-10-21 00:00:00	38000275	0	\N	\N	154137	0	288086009	4125906	
2973	285	4107731	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	18970	0	180256009	4107731	
15037	1340	4170947	2014-04-29	2014-04-29 00:00:00	38000275	0	\N	\N	88841	0	274474001	4170947	
15170	1356	4191853	1998-08-27	1998-08-27 00:00:00	38000275	0	\N	\N	89944	0	395142003	4191853	
15457	1377	4295880	1999-02-16	1999-02-16 00:00:00	38000275	0	\N	\N	91246	0	76601001	4295880	
3698	357	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	23667	0	180256009	4107731	
15856	1397	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	92773	0	180256009	4107731	
4071	404	4191853	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	26607	0	395142003	4191853	
4261	411	4107731	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	27355	0	180256009	4107731	
28257	2503	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	165695	0	395142003	4191853	
16488	1435	4125906	1994-02-09	1994-02-09 00:00:00	38000275	0	\N	\N	95583	0	288086009	4125906	
16703	1447	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	96434	0	180256009	4107731	
16885	1464	4170947	1965-09-01	1965-09-01 00:00:00	38000275	0	\N	\N	97580	0	274474001	4170947	
5217	484	4125906	2012-06-24	2012-06-24 00:00:00	38000275	0	\N	\N	32403	0	288086009	4125906	
17228	1486	4107731	1992-08-30	1992-08-30 00:00:00	38000275	0	\N	\N	99019	0	180256009	4107731	
5571	507	4057420	2015-10-16	2015-10-16 00:00:00	38000275	0	\N	\N	33964	0	18286008	4057420	
17632	1513	4107731	1992-06-28	1992-06-28 00:00:00	38000275	0	\N	\N	101102	0	180256009	4107731	
5963	545	4107731	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	36102	0	180256009	4107731	
17988	1538	4107731	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	103026	0	180256009	4107731	
18260	1556	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	104255	0	180256009	4107731	
18463	1567	4197460	2002-09-05	2002-09-05 00:00:00	38000275	0	\N	\N	105107	0	313191000	4197460	
6711	610	4293740	1989-12-02	1989-12-02 00:00:00	38000275	0	\N	\N	40480	0	384700001	4293740	
18740	1608	4243062	1979-04-22	1979-04-22 00:00:00	38000275	0	\N	\N	108015	0	60027007	4243062	
18975	1622	4295880	2000-07-24	2000-07-24 00:00:00	38000275	0	\N	\N	108979	0	76601001	4295880	
31044	2758	4078793	2005-11-18	2005-11-18 00:00:00	38000275	0	\N	\N	182395	0	180325003	4078793	
7439	689	4295880	1998-08-16	1998-08-16 00:00:00	38000275	0	\N	\N	45648	0	76601001	4295880	
19483	1661	4057420	2008-07-17	2008-07-17 00:00:00	38000275	0	\N	\N	111663	0	18286008	4057420	
19652	1690	4170947	1978-05-10	1978-05-10 00:00:00	38000275	0	\N	\N	113159	0	274474001	4170947	
19937	1724	4125906	1995-07-23	1995-07-23 00:00:00	38000275	0	\N	\N	115266	0	288086009	4125906	
8202	754	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	49831	0	180256009	4107731	
8369	761	4107731	1993-09-10	1993-09-10 00:00:00	38000275	0	\N	\N	50645	0	180256009	4107731	
20553	1773	4107731	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	118604	0	180256009	4107731	
20747	1783	4107731	1992-01-06	1992-01-06 00:00:00	38000275	0	\N	\N	119517	0	180256009	4107731	
32783	2872	4336464	1999-08-17	1999-08-17 00:00:00	38000275	0	\N	\N	191227	0	232717009	4336464	
20969	1814	4163951	2018-04-03	2018-04-03 00:00:00	38000275	0	\N	\N	121406	0	29303009	4163951	
9316	856	4252419	1971-11-30	1971-11-30 00:00:00	38000275	0	\N	\N	56517	0	74016001	4252419	
21346	1847	4151422	1961-09-24	1961-09-24 00:00:00	38000275	0	\N	\N	123515	0	269911007	4151422	
33577	2925	4107731	1992-06-22	1992-06-22 00:00:00	38000275	0	\N	\N	195108	0	180256009	4107731	
9879	884	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	58886	0	180256009	4107731	
22016	1918	4043071	1979-07-16	1979-07-16 00:00:00	38000275	0	\N	\N	127634	0	228557008	4043071	
22137	1929	4238715	1978-10-26	1978-10-26 00:00:00	38000275	0	\N	\N	128466	0	68254000	4238715	
10452	939	4043071	1977-11-07	1977-11-07 00:00:00	38000275	0	\N	\N	62419	0	228557008	4043071	
22465	1967	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	130788	0	180256009	4107731	
22716	1977	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	131562	0	180256009	4107731	
22906	1992	4107731	1991-02-10	1991-02-10 00:00:00	38000275	0	\N	\N	132665	0	180256009	4107731	
35069	3057	4170947	2017-10-04	2017-10-04 00:00:00	38000275	0	\N	\N	203389	0	274474001	4170947	
23288	2025	4078793	2007-05-19	2007-05-19 00:00:00	38000275	0	\N	\N	134648	0	180325003	4078793	
23521	2058	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	136835	0	180256009	4107731	
11744	1083	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	71113	0	180256009	4107731	
23786	2075	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	138028	0	180256009	4107731	
147	9	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	785	0	180256009	4107731	
12305	1110	4107731	1995-09-25	1995-09-25 00:00:00	38000275	0	\N	\N	73053	0	180256009	4107731	
12395	1115	4107731	1992-01-06	1992-01-06 00:00:00	38000275	0	\N	\N	73491	0	180256009	4107731	
12627	1138	4043071	1995-12-14	1995-12-14 00:00:00	38000275	0	\N	\N	75028	0	228557008	4043071	
24718	2165	4170947	1961-03-26	1961-03-26 00:00:00	38000275	0	\N	\N	144274	0	274474001	4170947	
12980	1175	4107731	1993-05-02	1993-05-02 00:00:00	38000275	0	\N	\N	77509	0	180256009	4107731	
13242	1206	4151422	1979-11-19	1979-11-19 00:00:00	38000275	0	\N	\N	79245	0	269911007	4151422	
13322	1211	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	79505	0	180256009	4107731	
13590	1228	4275113	1992-06-13	1992-06-13 00:00:00	38000275	0	\N	\N	80931	0	65200003	4275113	
13674	1246	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	82043	0	180256009	4107731	
2023	191	4151422	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	13100	0	269911007	4151422	
2236	225	4107731	1992-12-28	1992-12-28 00:00:00	38000275	0	\N	\N	15222	0	180256009	4107731	
14360	1282	4125906	1977-03-29	1977-03-29 00:00:00	38000275	0	\N	\N	84707	0	288086009	4125906	
2615	266	4107731	1991-04-29	1991-04-29 00:00:00	38000275	0	\N	\N	17677	0	180256009	4107731	
26564	2319	4195803	2017-10-14	2017-10-14 00:00:00	38000275	0	\N	\N	154146	0	312681000	4195803	
2974	285	4107731	1991-07-22	1991-07-22 00:00:00	38000275	0	\N	\N	18938	0	180256009	4107731	
15038	1340	4047491	2014-04-29	2014-04-29 00:00:00	38000275	0	\N	\N	88841	0	1225002	4047491	
15171	1356	4107731	1995-10-12	1995-10-12 00:00:00	38000275	0	\N	\N	89963	0	180256009	4107731	
15458	1377	4295880	1997-02-18	1997-02-18 00:00:00	38000275	0	\N	\N	91259	0	76601001	4295880	
3699	357	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	23654	0	180256009	4107731	
15857	1397	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	92792	0	180256009	4107731	
4072	404	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	26620	0	180256009	4107731	
4262	411	4107731	1991-01-19	1991-01-19 00:00:00	38000275	0	\N	\N	27396	0	180256009	4107731	
28258	2503	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	165739	0	180256009	4107731	
16489	1435	4125906	1996-02-13	1996-02-13 00:00:00	38000275	0	\N	\N	95584	0	288086009	4125906	
16704	1447	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	96503	0	180256009	4107731	
16886	1464	4330583	1989-12-08	1989-12-08 00:00:00	38000275	0	\N	\N	97553	0	22523008	4330583	
5218	484	4195803	2011-03-02	2011-03-02 00:00:00	38000275	0	\N	\N	32402	0	312681000	4195803	
17229	1486	4191853	1990-01-07	1990-01-07 00:00:00	38000275	0	\N	\N	99139	0	395142003	4191853	
5572	507	4078793	2014-10-10	2014-10-10 00:00:00	38000275	0	\N	\N	33920	0	180325003	4078793	
17633	1513	4107731	1992-05-17	1992-05-17 00:00:00	38000275	0	\N	\N	101148	0	180256009	4107731	
5964	545	4107731	1993-03-06	1993-03-06 00:00:00	38000275	0	\N	\N	36060	0	180256009	4107731	
17989	1538	4107731	1992-03-30	1992-03-30 00:00:00	38000275	0	\N	\N	102961	0	180256009	4107731	
18261	1556	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	104264	0	180256009	4107731	
18464	1567	4191853	1975-10-07	1975-10-07 00:00:00	38000275	0	\N	\N	105078	0	395142003	4191853	
6712	610	4125906	1989-12-02	1989-12-02 00:00:00	38000275	0	\N	\N	40480	0	288086009	4125906	
18741	1608	4170947	1979-04-22	1979-04-22 00:00:00	38000275	0	\N	\N	108015	0	274474001	4170947	
18976	1622	4295880	1994-10-31	1994-10-31 00:00:00	38000275	0	\N	\N	109002	0	76601001	4295880	
31045	2758	4078793	2006-11-24	2006-11-24 00:00:00	38000275	0	\N	\N	182430	0	180325003	4078793	
7440	689	4295880	2003-02-09	2003-02-09 00:00:00	38000275	0	\N	\N	45670	0	76601001	4295880	
19484	1661	4195803	2018-11-16	2018-11-16 00:00:00	38000275	0	\N	\N	111657	0	312681000	4195803	
19653	1690	4047491	1978-05-10	1978-05-10 00:00:00	38000275	0	\N	\N	113159	0	1225002	4047491	
19938	1724	4047491	1986-05-27	1986-05-27 00:00:00	38000275	0	\N	\N	115264	0	1225002	4047491	
8203	754	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	49830	0	180256009	4107731	
8370	761	4107731	1994-02-25	1994-02-25 00:00:00	38000275	0	\N	\N	50543	0	180256009	4107731	
20554	1773	4191853	1993-07-11	1993-07-11 00:00:00	38000275	0	\N	\N	118614	0	395142003	4191853	
20748	1783	4107731	1991-08-12	1991-08-12 00:00:00	38000275	0	\N	\N	119544	0	180256009	4107731	
32784	2872	4216130	1999-08-17	1999-08-17 00:00:00	38000275	0	\N	\N	191227	0	415070008	4216130	
20970	1814	4163971	2018-04-03	2018-04-03 00:00:00	38000275	0	\N	\N	121406	0	45595009	4163971	
9317	857	4035793	2016-05-22	2016-05-22 00:00:00	38000275	0	\N	\N	56590	0	15081005	4035793	
21347	1847	4024289	1928-05-28	1928-05-28 00:00:00	38000275	0	\N	\N	123517	0	19490002	4024289	
33578	2925	4125906	1963-10-22	1963-10-22 00:00:00	38000275	0	\N	\N	195024	0	288086009	4125906	
9880	884	4191853	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	58941	0	395142003	4191853	
22017	1918	4043071	1979-04-09	1979-04-09 00:00:00	38000275	0	\N	\N	127648	0	228557008	4043071	
22138	1929	4275113	1974-07-18	1974-07-18 00:00:00	38000275	0	\N	\N	128465	0	65200003	4275113	
10453	939	4043071	1977-10-03	1977-10-03 00:00:00	38000275	0	\N	\N	62418	0	228557008	4043071	
22466	1967	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	130858	0	180256009	4107731	
22717	1977	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	131543	0	180256009	4107731	
22907	1992	4107731	1990-10-07	1990-10-07 00:00:00	38000275	0	\N	\N	132716	0	180256009	4107731	
35070	3057	4024289	2017-10-04	2017-10-04 00:00:00	38000275	0	\N	\N	203389	0	19490002	4024289	
23289	2025	4202451	2007-07-21	2007-07-21 00:00:00	38000275	0	\N	\N	134648	0	433112001	4202451	
23522	2058	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	136881	0	180256009	4107731	
11745	1083	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	71139	0	180256009	4107731	
23787	2075	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	138071	0	180256009	4107731	
148	9	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	797	0	180256009	4107731	
12306	1110	4107731	1997-04-14	1997-04-14 00:00:00	38000275	0	\N	\N	73036	0	180256009	4107731	
12396	1115	4107731	1991-08-12	1991-08-12 00:00:00	38000275	0	\N	\N	73447	0	180256009	4107731	
12628	1138	4043071	1994-09-29	1994-09-29 00:00:00	38000275	0	\N	\N	75012	0	228557008	4043071	
24719	2165	4047491	1961-03-26	1961-03-26 00:00:00	38000275	0	\N	\N	144274	0	1225002	4047491	
12981	1175	4043071	1953-10-24	1953-10-24 00:00:00	38000275	0	\N	\N	77411	0	228557008	4043071	
13243	1206	4293740	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	79260	0	384700001	4293740	
13323	1211	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	79649	0	180256009	4107731	
13591	1228	4058899	2003-09-30	2003-09-30 00:00:00	38000275	0	\N	\N	80896	0	168594001	4058899	
13675	1246	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	82163	0	180256009	4107731	
2024	191	4170947	1924-02-11	1924-02-11 00:00:00	38000275	0	\N	\N	13036	0	274474001	4170947	
2237	225	4107731	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	15223	0	180256009	4107731	
14361	1282	4125906	2010-10-16	2010-10-16 00:00:00	38000275	0	\N	\N	84737	0	288086009	4125906	
2616	266	4107731	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	17678	0	180256009	4107731	
26565	2319	4170947	1983-09-07	1983-09-07 00:00:00	38000275	0	\N	\N	154136	0	274474001	4170947	
2975	285	4107731	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	18999	0	180256009	4107731	
15039	1340	4195803	1971-07-15	1971-07-15 00:00:00	38000275	0	\N	\N	88865	0	312681000	4195803	
15172	1356	4107731	1996-08-22	1996-08-22 00:00:00	38000275	0	\N	\N	89894	0	180256009	4107731	
15459	1377	4295880	1997-08-19	1997-08-19 00:00:00	38000275	0	\N	\N	91244	0	76601001	4295880	
3700	357	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	23689	0	180256009	4107731	
15858	1397	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	92846	0	180256009	4107731	
4073	404	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	26623	0	180256009	4107731	
4263	411	4058899	1980-08-29	1980-08-29 00:00:00	38000275	0	\N	\N	27403	0	168594001	4058899	
28259	2503	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	165720	0	180256009	4107731	
16490	1435	4125906	1984-05-18	1984-05-18 00:00:00	38000275	0	\N	\N	95582	0	288086009	4125906	
16705	1447	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	96453	0	180256009	4107731	
16887	1464	4163872	1996-03-31	1996-03-31 00:00:00	38000275	0	\N	\N	97548	0	399208008	4163872	
5219	484	4243062	2011-03-02	2011-03-02 00:00:00	38000275	0	\N	\N	32402	0	60027007	4243062	
17230	1486	4107731	1992-05-17	1992-05-17 00:00:00	38000275	0	\N	\N	99037	0	180256009	4107731	
5573	507	4057420	2008-09-19	2008-09-19 00:00:00	38000275	0	\N	\N	33969	0	18286008	4057420	
17634	1513	4107731	1990-08-26	1990-08-26 00:00:00	38000275	0	\N	\N	101127	0	180256009	4107731	
5965	545	4107731	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	36105	0	180256009	4107731	
17990	1538	4107731	1991-11-04	1991-11-04 00:00:00	38000275	0	\N	\N	103089	0	180256009	4107731	
18262	1556	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	104169	0	180256009	4107731	
18465	1568	4170947	1960-03-22	1960-03-22 00:00:00	38000275	0	\N	\N	105163	0	274474001	4170947	
6713	610	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	40508	0	180256009	4107731	
18742	1609	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	108187	0	180256009	4107731	
18977	1622	4275113	2000-03-23	2000-03-23 00:00:00	38000275	0	\N	\N	109026	0	65200003	4275113	
31046	2758	4078793	2019-02-01	2019-02-01 00:00:00	38000275	0	\N	\N	182399	0	180325003	4078793	
7441	689	4295880	1998-02-15	1998-02-15 00:00:00	38000275	0	\N	\N	45638	0	76601001	4295880	
19485	1661	4170947	2018-11-16	2018-11-16 00:00:00	38000275	0	\N	\N	111657	0	274474001	4170947	
19654	1690	4125906	2009-12-27	2009-12-27 00:00:00	38000275	0	\N	\N	113161	0	288086009	4125906	
19939	1724	4170947	1986-05-27	1986-05-27 00:00:00	38000275	0	\N	\N	115264	0	274474001	4170947	
8204	754	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	49958	0	180256009	4107731	
8371	761	4107731	1995-01-06	1995-01-06 00:00:00	38000275	0	\N	\N	50526	0	180256009	4107731	
20555	1773	4107731	1991-05-26	1991-05-26 00:00:00	38000275	0	\N	\N	118606	0	180256009	4107731	
20749	1783	4107731	1991-11-25	1991-11-25 00:00:00	38000275	0	\N	\N	119516	0	180256009	4107731	
32785	2872	4125906	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	191207	0	288086009	4125906	
20971	1814	42535580	2018-04-03	2018-04-03 00:00:00	38000275	0	\N	\N	121406	0	426701000119108	42535580	
9318	857	4275113	1977-12-28	1977-12-28 00:00:00	38000275	0	\N	\N	56648	0	65200003	4275113	
21348	1847	4170947	1928-05-28	1928-05-28 00:00:00	38000275	0	\N	\N	123517	0	274474001	4170947	
33579	2925	4107731	1990-11-11	1990-11-11 00:00:00	38000275	0	\N	\N	195097	0	180256009	4107731	
9881	884	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	58907	0	180256009	4107731	
22018	1918	4043071	1978-12-04	1978-12-04 00:00:00	38000275	0	\N	\N	127590	0	228557008	4043071	
22139	1929	4125906	1975-09-19	1975-09-19 00:00:00	38000275	0	\N	\N	128392	0	288086009	4125906	
10454	939	4043071	1977-08-08	1977-08-08 00:00:00	38000275	0	\N	\N	62438	0	228557008	4043071	
22467	1967	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	130749	0	180256009	4107731	
22718	1977	4057420	2013-06-06	2013-06-06 00:00:00	38000275	0	\N	\N	131471	0	18286008	4057420	
22908	1992	4107731	1992-11-01	1992-11-01 00:00:00	38000275	0	\N	\N	132685	0	180256009	4107731	
35071	3057	4151422	1941-04-15	1941-04-15 00:00:00	38000275	0	\N	\N	203358	0	269911007	4151422	
23290	2025	4078793	2014-05-24	2014-05-24 00:00:00	38000275	0	\N	\N	134713	0	180325003	4078793	
23523	2058	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	136884	0	180256009	4107731	
11746	1083	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	71140	0	180256009	4107731	
23788	2075	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	138069	0	180256009	4107731	
149	9	4062501	1982-07-26	1982-07-26 00:00:00	38000275	0	\N	\N	708	0	171231001	4062501	
12307	1110	4107731	1996-09-16	1996-09-16 00:00:00	38000275	0	\N	\N	73058	0	180256009	4107731	
12397	1115	4107731	1992-07-13	1992-07-13 00:00:00	38000275	0	\N	\N	73482	0	180256009	4107731	
12629	1138	4107731	1995-03-02	1995-03-02 00:00:00	38000275	0	\N	\N	75016	0	180256009	4107731	
24720	2165	4151422	1957-10-14	1957-10-14 00:00:00	38000275	0	\N	\N	144187	0	269911007	4151422	
12982	1175	4107731	1990-04-15	1990-04-15 00:00:00	38000275	0	\N	\N	77494	0	180256009	4107731	
13244	1206	4125906	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	79260	0	288086009	4125906	
13324	1211	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	79498	0	180256009	4107731	
13592	1228	4252419	1980-01-06	1980-01-06 00:00:00	38000275	0	\N	\N	80894	0	74016001	4252419	
13676	1246	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	82012	0	180256009	4107731	
2025	191	4024289	1924-02-11	1924-02-11 00:00:00	38000275	0	\N	\N	13036	0	19490002	4024289	
2238	225	4107731	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	15224	0	180256009	4107731	
14362	1282	4275113	1990-04-03	1990-04-03 00:00:00	38000275	0	\N	\N	84726	0	65200003	4275113	
2617	266	4107731	1992-11-16	1992-11-16 00:00:00	38000275	0	\N	\N	17760	0	180256009	4107731	
26566	2319	4163872	1983-09-07	1983-09-07 00:00:00	38000275	0	\N	\N	154136	0	399208008	4163872	
2976	285	4107731	1990-12-03	1990-12-03 00:00:00	38000275	0	\N	\N	18971	0	180256009	4107731	
15040	1340	4151422	1919-05-01	1919-05-01 00:00:00	38000275	0	\N	\N	88922	0	269911007	4151422	
15173	1356	4107731	1998-01-29	1998-01-29 00:00:00	38000275	0	\N	\N	89952	0	180256009	4107731	
15460	1377	4295880	1996-11-19	1996-11-19 00:00:00	38000275	0	\N	\N	91243	0	76601001	4295880	
3701	357	4195803	2014-12-10	2014-12-10 00:00:00	38000275	0	\N	\N	23753	0	312681000	4195803	
15859	1397	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	92823	0	180256009	4107731	
4074	404	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	26580	0	180256009	4107731	
4264	411	4107731	1991-03-23	1991-03-23 00:00:00	38000275	0	\N	\N	27346	0	180256009	4107731	
28260	2503	4238715	1996-07-30	1996-07-30 00:00:00	38000275	0	\N	\N	165693	0	68254000	4238715	
16569	1438	4125906	1975-04-17	1975-04-17 00:00:00	38000275	0	\N	\N	95849	0	288086009	4125906	
16706	1447	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	96431	0	180256009	4107731	
16888	1464	4125906	1970-11-04	1970-11-04 00:00:00	38000275	0	\N	\N	97581	0	288086009	4125906	
5220	484	4170947	2011-03-02	2011-03-02 00:00:00	38000275	0	\N	\N	32402	0	274474001	4170947	
17231	1486	4107731	1990-04-22	1990-04-22 00:00:00	38000275	0	\N	\N	99010	0	180256009	4107731	
5574	507	4057420	2010-09-17	2010-09-17 00:00:00	38000275	0	\N	\N	33959	0	18286008	4057420	
17635	1513	4107731	1990-06-03	1990-06-03 00:00:00	38000275	0	\N	\N	101123	0	180256009	4107731	
5966	545	4107731	1991-04-13	1991-04-13 00:00:00	38000275	0	\N	\N	36033	0	180256009	4107731	
17991	1538	4057420	2009-05-11	2009-05-11 00:00:00	38000275	0	\N	\N	103014	0	18286008	4057420	
18263	1556	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	104259	0	180256009	4107731	
18466	1568	4024289	1960-03-22	1960-03-22 00:00:00	38000275	0	\N	\N	105163	0	19490002	4024289	
6714	610	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	40584	0	180256009	4107731	
18743	1609	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	108060	0	180256009	4107731	
18978	1622	4295880	2000-01-24	2000-01-24 00:00:00	38000275	0	\N	\N	109038	0	76601001	4295880	
31047	2758	4078793	2014-01-03	2014-01-03 00:00:00	38000275	0	\N	\N	182451	0	180325003	4078793	
7442	689	4295880	2000-11-12	2000-11-12 00:00:00	38000275	0	\N	\N	45667	0	76601001	4295880	
19486	1661	4163872	2018-11-16	2018-11-16 00:00:00	38000275	0	\N	\N	111657	0	399208008	4163872	
19655	1690	4151422	1985-05-05	1985-05-05 00:00:00	38000275	0	\N	\N	113219	0	269911007	4151422	
19945	1727	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	115555	0	180256009	4107731	
8205	754	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	49962	0	180256009	4107731	
8372	761	4107731	1993-11-12	1993-11-12 00:00:00	38000275	0	\N	\N	50619	0	180256009	4107731	
20556	1773	4107731	1990-07-15	1990-07-15 00:00:00	38000275	0	\N	\N	118540	0	180256009	4107731	
20750	1783	4107731	1992-06-01	1992-06-01 00:00:00	38000275	0	\N	\N	119557	0	180256009	4107731	
32793	2876	4170947	2011-03-23	2011-03-23 00:00:00	38000275	0	\N	\N	191393	0	274474001	4170947	
20972	1814	4202832	2018-04-03	2018-04-03 00:00:00	38000275	0	\N	\N	121406	0	52765003	4202832	
9319	857	4238715	1979-03-04	1979-03-04 00:00:00	38000275	0	\N	\N	56649	0	68254000	4238715	
21349	1847	4047491	1926-06-08	1926-06-08 00:00:00	38000275	0	\N	\N	123516	0	1225002	4047491	
33580	2925	4107731	1990-01-21	1990-01-21 00:00:00	38000275	0	\N	\N	195113	0	180256009	4107731	
9882	884	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	58884	0	180256009	4107731	
22019	1918	4043071	1978-05-01	1978-05-01 00:00:00	38000275	0	\N	\N	127625	0	228557008	4043071	
22144	1933	4024289	1960-05-19	1960-05-19 00:00:00	38000275	0	\N	\N	128561	0	19490002	4024289	
10455	939	4043071	1977-12-12	1977-12-12 00:00:00	38000275	0	\N	\N	62463	0	228557008	4043071	
22468	1967	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	130783	0	180256009	4107731	
22719	1977	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	131590	0	180256009	4107731	
22909	1992	4107731	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	132697	0	180256009	4107731	
35072	3057	4125906	1992-02-13	1992-02-13 00:00:00	38000275	0	\N	\N	203387	0	288086009	4125906	
23291	2025	4078793	2008-05-24	2008-05-24 00:00:00	38000275	0	\N	\N	134710	0	180325003	4078793	
23524	2058	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	136833	0	180256009	4107731	
11747	1083	4197460	1980-05-06	1980-05-06 00:00:00	38000275	0	\N	\N	71057	0	313191000	4197460	
23789	2075	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	138061	0	180256009	4107731	
150	9	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	809	0	180256009	4107731	
12308	1110	4107731	1998-04-06	1998-04-06 00:00:00	38000275	0	\N	\N	73068	0	180256009	4107731	
12398	1115	4170947	2014-12-12	2014-12-12 00:00:00	38000275	0	\N	\N	73390	0	274474001	4170947	
12630	1138	4107731	1993-09-02	1993-09-02 00:00:00	38000275	0	\N	\N	75074	0	180256009	4107731	
24721	2165	4301346	2009-12-14	2009-12-14 00:00:00	38000275	0	\N	\N	144219	0	387685009	4301346	
12983	1175	4107731	1990-07-29	1990-07-29 00:00:00	38000275	0	\N	\N	77467	0	180256009	4107731	
13245	1206	4198190	1972-02-10	1972-02-10 00:00:00	38000275	0	\N	\N	79284	0	80146002	4198190	
13325	1211	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	79602	0	180256009	4107731	
13593	1229	4151422	1957-07-29	1957-07-29 00:00:00	38000275	0	\N	\N	81006	0	269911007	4151422	
13677	1246	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	82065	0	180256009	4107731	
2026	191	4252419	1929-09-12	1929-09-12 00:00:00	38000275	0	\N	\N	13038	0	74016001	4252419	
2239	225	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	15172	0	180256009	4107731	
14363	1282	4191853	1977-08-12	1977-08-12 00:00:00	38000275	0	\N	\N	84719	0	395142003	4191853	
2618	266	4107731	1992-02-17	1992-02-17 00:00:00	38000275	0	\N	\N	17757	0	180256009	4107731	
26567	2319	4125906	1967-06-14	1967-06-14 00:00:00	38000275	0	\N	\N	154134	0	288086009	4125906	
2977	285	4107731	1991-04-29	1991-04-29 00:00:00	38000275	0	\N	\N	18936	0	180256009	4107731	
15041	1340	4125906	1975-03-01	1975-03-01 00:00:00	38000275	0	\N	\N	88845	0	288086009	4125906	
15174	1356	4107731	1996-11-14	1996-11-14 00:00:00	38000275	0	\N	\N	89896	0	180256009	4107731	
15461	1377	4295880	1996-05-21	1996-05-21 00:00:00	38000275	0	\N	\N	91258	0	76601001	4295880	
3702	357	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	23659	0	180256009	4107731	
15860	1397	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	92756	0	180256009	4107731	
4075	404	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	26624	0	180256009	4107731	
4265	411	4107731	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	27352	0	180256009	4107731	
28261	2503	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	165672	0	180256009	4107731	
16570	1438	4151422	1965-12-15	1965-12-15 00:00:00	38000275	0	\N	\N	95838	0	269911007	4151422	
16707	1447	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	96476	0	180256009	4107731	
16889	1464	4326177	1965-11-30	1965-11-30 00:00:00	38000275	0	\N	\N	97538	0	430193006	4326177	
5222	487	4275113	1979-05-19	1979-05-19 00:00:00	38000275	0	\N	\N	32536	0	65200003	4275113	
17232	1486	4107731	1991-12-22	1991-12-22 00:00:00	38000275	0	\N	\N	99122	0	180256009	4107731	
5575	507	4078793	1994-08-19	1994-08-19 00:00:00	38000275	0	\N	\N	33928	0	180325003	4078793	
17636	1513	4107731	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	101048	0	180256009	4107731	
5967	545	4107731	1992-01-11	1992-01-11 00:00:00	38000275	0	\N	\N	36036	0	180256009	4107731	
17992	1538	4107731	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	102958	0	180256009	4107731	
18264	1556	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	104153	0	180256009	4107731	
18467	1568	4058899	1967-07-28	1967-07-28 00:00:00	38000275	0	\N	\N	105165	0	168594001	4058899	
6715	610	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	40538	0	180256009	4107731	
18744	1609	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	108185	0	180256009	4107731	
18979	1622	4125906	2015-02-08	2015-02-08 00:00:00	38000275	0	\N	\N	108938	0	288086009	4125906	
31048	2758	4078793	2017-01-20	2017-01-20 00:00:00	38000275	0	\N	\N	182398	0	180325003	4078793	
7443	689	4295880	2003-05-11	2003-05-11 00:00:00	38000275	0	\N	\N	45644	0	76601001	4295880	
19487	1661	4125906	1980-05-24	1980-05-24 00:00:00	38000275	0	\N	\N	111651	0	288086009	4125906	
19656	1691	4125906	2015-12-24	2015-12-24 00:00:00	38000275	0	\N	\N	113271	0	288086009	4125906	
19946	1727	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	115542	0	180256009	4107731	
8206	754	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	49952	0	180256009	4107731	
8373	761	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	50552	0	180256009	4107731	
20557	1773	4107731	1992-11-22	1992-11-22 00:00:00	38000275	0	\N	\N	118612	0	180256009	4107731	
20751	1783	4107731	1990-03-05	1990-03-05 00:00:00	38000275	0	\N	\N	119480	0	180256009	4107731	
32794	2876	4163872	2011-03-23	2011-03-23 00:00:00	38000275	0	\N	\N	191393	0	399208008	4163872	
20973	1814	4151422	1964-08-21	1964-08-21 00:00:00	38000275	0	\N	\N	121425	0	269911007	4151422	
9320	857	4125906	1979-02-09	1979-02-09 00:00:00	38000275	0	\N	\N	56578	0	288086009	4125906	
21350	1847	4170947	1926-06-08	1926-06-08 00:00:00	38000275	0	\N	\N	123516	0	274474001	4170947	
33581	2925	4107731	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	195107	0	180256009	4107731	
9883	884	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	58889	0	180256009	4107731	
22020	1918	4043071	1978-02-20	1978-02-20 00:00:00	38000275	0	\N	\N	127629	0	228557008	4043071	
22145	1933	4170947	1960-05-19	1960-05-19 00:00:00	38000275	0	\N	\N	128561	0	274474001	4170947	
10456	939	4043071	1977-09-05	1977-09-05 00:00:00	38000275	0	\N	\N	62430	0	228557008	4043071	
22469	1967	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	130847	0	180256009	4107731	
22720	1977	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	131510	0	180256009	4107731	
22910	1992	4107731	1990-11-18	1990-11-18 00:00:00	38000275	0	\N	\N	132672	0	180256009	4107731	
35073	3057	4170947	1966-12-28	1966-12-28 00:00:00	38000275	0	\N	\N	203385	0	274474001	4170947	
23292	2025	4078793	1995-03-11	1995-03-11 00:00:00	38000275	0	\N	\N	134678	0	180325003	4078793	
23525	2058	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	136842	0	180256009	4107731	
11748	1083	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	71092	0	180256009	4107731	
23790	2075	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	138029	0	180256009	4107731	
151	9	4125906	2003-02-23	2003-02-23 00:00:00	38000275	0	\N	\N	863	0	288086009	4125906	
12309	1110	4107731	1996-04-22	1996-04-22 00:00:00	38000275	0	\N	\N	73106	0	180256009	4107731	
12399	1115	4195803	2014-12-12	2014-12-12 00:00:00	38000275	0	\N	\N	73390	0	312681000	4195803	
12631	1138	4043071	1995-02-02	1995-02-02 00:00:00	38000275	0	\N	\N	75053	0	228557008	4043071	
24722	2165	44783196	1989-09-23	1989-09-23 00:00:00	38000275	0	\N	\N	144208	0	699253003	44783196	
12984	1175	4107731	1990-11-11	1990-11-11 00:00:00	38000275	0	\N	\N	77435	0	180256009	4107731	
13247	1208	4057420	1993-11-09	1993-11-09 00:00:00	38000275	0	\N	\N	79360	0	18286008	4057420	
13326	1211	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	79654	0	180256009	4107731	
13594	1231	4151422	1968-04-21	1968-04-21 00:00:00	38000275	0	\N	\N	81107	0	269911007	4151422	
13678	1246	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	81999	0	180256009	4107731	
2027	191	4170947	1994-05-07	1994-05-07 00:00:00	38000275	0	\N	\N	13042	0	274474001	4170947	
2240	225	4107731	1992-03-30	1992-03-30 00:00:00	38000275	0	\N	\N	15191	0	180256009	4107731	
14364	1282	4170947	1980-06-25	1980-06-25 00:00:00	38000275	0	\N	\N	84708	0	274474001	4170947	
14400	1285	4107731	1992-09-14	1992-09-14 00:00:00	38000275	0	\N	\N	84950	0	180256009	4107731	
26568	2319	4197460	1947-08-14	1947-08-14 00:00:00	38000275	0	\N	\N	154131	0	313191000	4197460	
2978	285	4107731	1992-09-14	1992-09-14 00:00:00	38000275	0	\N	\N	18952	0	180256009	4107731	
15046	1345	4024289	1977-09-13	1977-09-13 00:00:00	38000275	0	\N	\N	89171	0	19490002	4024289	
15175	1356	4107731	1995-04-06	1995-04-06 00:00:00	38000275	0	\N	\N	89889	0	180256009	4107731	
15462	1377	4295880	1998-05-19	1998-05-19 00:00:00	38000275	0	\N	\N	91245	0	76601001	4295880	
3703	357	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	23760	0	180256009	4107731	
15861	1397	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	92748	0	180256009	4107731	
4076	404	4043071	1971-09-03	1971-09-03 00:00:00	38000275	0	\N	\N	26659	0	228557008	4043071	
4266	411	4151422	1961-02-11	1961-02-11 00:00:00	38000275	0	\N	\N	27317	0	269911007	4151422	
28262	2503	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	165754	0	180256009	4107731	
16571	1439	4024289	1991-10-29	1991-10-29 00:00:00	38000275	0	\N	\N	95876	0	19490002	4024289	
16708	1447	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	96454	0	180256009	4107731	
16890	1464	4187458	1965-11-30	1965-11-30 00:00:00	38000275	0	\N	\N	97538	0	415300000	4187458	
5223	487	4010253	1994-04-06	1994-04-06 00:00:00	38000275	0	\N	\N	32551	0	112790001	4010253	
17233	1486	4057420	2001-12-23	2001-12-23 00:00:00	38000275	0	\N	\N	99029	0	18286008	4057420	
5576	507	4078793	1995-08-25	1995-08-25 00:00:00	38000275	0	\N	\N	33916	0	180325003	4078793	
17637	1513	4043071	1979-07-19	1979-07-19 00:00:00	38000275	0	\N	\N	101154	0	228557008	4043071	
5968	545	4107731	1990-10-06	1990-10-06 00:00:00	38000275	0	\N	\N	36043	0	180256009	4107731	
17993	1538	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	103035	0	180256009	4107731	
18265	1556	4125906	2011-08-12	2011-08-12 00:00:00	38000275	0	\N	\N	104151	0	288086009	4125906	
18468	1568	4151422	1977-09-08	1977-09-08 00:00:00	38000275	0	\N	\N	105184	0	269911007	4151422	
6716	610	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	40588	0	180256009	4107731	
18745	1609	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	108061	0	180256009	4107731	
18980	1622	4295880	1997-04-28	1997-04-28 00:00:00	38000275	0	\N	\N	108977	0	76601001	4295880	
31049	2758	4078793	2007-11-30	2007-11-30 00:00:00	38000275	0	\N	\N	182396	0	180325003	4078793	
7444	689	4295880	2002-05-12	2002-05-12 00:00:00	38000275	0	\N	\N	45669	0	76601001	4295880	
19488	1661	4057420	2011-08-04	2011-08-04 00:00:00	38000275	0	\N	\N	111681	0	18286008	4057420	
19657	1691	4170947	1977-06-25	1977-06-25 00:00:00	38000275	0	\N	\N	113253	0	274474001	4170947	
19947	1727	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	115422	0	180256009	4107731	
8207	754	4010253	2010-02-28	2010-02-28 00:00:00	38000275	0	\N	\N	49923	0	112790001	4010253	
8374	761	4107731	1995-03-10	1995-03-10 00:00:00	38000275	0	\N	\N	50581	0	180256009	4107731	
20558	1773	4107731	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	118610	0	180256009	4107731	
20752	1783	4107731	1992-06-22	1992-06-22 00:00:00	38000275	0	\N	\N	119384	0	180256009	4107731	
32795	2876	4125906	2016-05-25	2016-05-25 00:00:00	38000275	0	\N	\N	191394	0	288086009	4125906	
21012	1820	4198190	2015-01-31	2015-01-31 00:00:00	38000275	0	\N	\N	121708	0	80146002	4198190	
9321	857	40492359	1983-09-18	1983-09-18 00:00:00	38000275	0	\N	\N	56579	0	447365002	40492359	
21351	1847	4151422	1919-12-13	1919-12-13 00:00:00	38000275	0	\N	\N	123549	0	269911007	4151422	
33582	2925	4107731	1990-05-07	1990-05-07 00:00:00	38000275	0	\N	\N	195059	0	180256009	4107731	
9884	884	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	58841	0	180256009	4107731	
22021	1918	4043071	1978-03-27	1978-03-27 00:00:00	38000275	0	\N	\N	127630	0	228557008	4043071	
22146	1933	4125906	2015-05-01	2015-05-01 00:00:00	38000275	0	\N	\N	128598	0	288086009	4125906	
10457	939	4125906	1986-06-22	1986-06-22 00:00:00	38000275	0	\N	\N	62481	0	288086009	4125906	
22470	1967	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	130830	0	180256009	4107731	
22721	1977	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	131513	0	180256009	4107731	
22911	1992	4107731	1992-02-02	1992-02-02 00:00:00	38000275	0	\N	\N	132682	0	180256009	4107731	
35074	3057	4047491	1966-12-28	1966-12-28 00:00:00	38000275	0	\N	\N	203385	0	1225002	4047491	
23293	2025	4078793	1992-02-22	1992-02-22 00:00:00	38000275	0	\N	\N	134764	0	180325003	4078793	
23526	2058	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	136883	0	180256009	4107731	
11749	1083	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	71099	0	395142003	4191853	
23791	2075	4195803	2019-04-15	2019-04-15 00:00:00	38000275	0	\N	\N	138004	0	312681000	4195803	
152	9	4107731	1994-11-03	1994-11-03 00:00:00	38000275	0	\N	\N	781	0	180256009	4107731	
12310	1110	4191853	1995-03-20	1995-03-20 00:00:00	38000275	0	\N	\N	73052	0	395142003	4191853	
12400	1115	4163872	2014-12-12	2014-12-12 00:00:00	38000275	0	\N	\N	73390	0	399208008	4163872	
12632	1138	4107731	1993-11-25	1993-11-25 00:00:00	38000275	0	\N	\N	75024	0	180256009	4107731	
24723	2165	4058899	2003-01-13	2003-01-13 00:00:00	38000275	0	\N	\N	144207	0	168594001	4058899	
12985	1175	4107731	1990-08-19	1990-08-19 00:00:00	38000275	0	\N	\N	77453	0	180256009	4107731	
13248	1208	4078793	2006-01-17	2006-01-17 00:00:00	38000275	0	\N	\N	79386	0	180325003	4078793	
13327	1211	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	79647	0	180256009	4107731	
13595	1231	4125906	1986-10-05	1986-10-05 00:00:00	38000275	0	\N	\N	81117	0	288086009	4125906	
13679	1246	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	82042	0	180256009	4107731	
2028	191	4024289	1994-05-07	1994-05-07 00:00:00	38000275	0	\N	\N	13042	0	19490002	4024289	
2241	225	4107731	1990-01-22	1990-01-22 00:00:00	38000275	0	\N	\N	15165	0	180256009	4107731	
14365	1282	4243062	1980-06-25	1980-06-25 00:00:00	38000275	0	\N	\N	84708	0	60027007	4243062	
14401	1285	4107731	1992-01-06	1992-01-06 00:00:00	38000275	0	\N	\N	85039	0	180256009	4107731	
26569	2319	4125906	1949-03-06	1949-03-06 00:00:00	38000275	0	\N	\N	154132	0	288086009	4125906	
2979	285	4107731	1992-06-22	1992-06-22 00:00:00	38000275	0	\N	\N	18996	0	180256009	4107731	
15047	1345	4170947	1977-09-13	1977-09-13 00:00:00	38000275	0	\N	\N	89171	0	274474001	4170947	
15176	1356	4107731	1996-06-20	1996-06-20 00:00:00	38000275	0	\N	\N	89936	0	180256009	4107731	
15463	1377	4295880	1999-05-18	1999-05-18 00:00:00	38000275	0	\N	\N	91274	0	76601001	4295880	
3704	357	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	23709	0	180256009	4107731	
15862	1397	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	92752	0	180256009	4107731	
4077	404	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	26572	0	180256009	4107731	
4267	411	4107731	1991-12-21	1991-12-21 00:00:00	38000275	0	\N	\N	27349	0	180256009	4107731	
28263	2503	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	165731	0	180256009	4107731	
16572	1439	4170947	1991-10-29	1991-10-29 00:00:00	38000275	0	\N	\N	95876	0	274474001	4170947	
16709	1447	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	96449	0	180256009	4107731	
16891	1464	4037675	1965-11-30	1965-11-30 00:00:00	38000275	0	\N	\N	97538	0	162676008	4037675	
5224	487	4186930	1984-05-16	1984-05-16 00:00:00	38000275	0	\N	\N	32546	0	46706006	4186930	
17234	1486	40492359	2001-12-23	2001-12-23 00:00:00	38000275	0	\N	\N	99029	0	447365002	40492359	
5577	507	4078793	2000-08-04	2000-08-04 00:00:00	38000275	0	\N	\N	33918	0	180325003	4078793	
17638	1513	4107731	1992-01-12	1992-01-12 00:00:00	38000275	0	\N	\N	101047	0	180256009	4107731	
5969	545	4107731	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	36032	0	180256009	4107731	
17994	1538	4107731	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	102985	0	180256009	4107731	
18266	1556	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	104182	0	180256009	4107731	
18469	1568	4125906	1964-09-27	1964-09-27 00:00:00	38000275	0	\N	\N	105164	0	288086009	4125906	
6717	610	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	40579	0	180256009	4107731	
18746	1609	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	108152	0	180256009	4107731	
18981	1622	4295880	2003-01-20	2003-01-20 00:00:00	38000275	0	\N	\N	109048	0	76601001	4295880	
31050	2758	4078793	2018-01-26	2018-01-26 00:00:00	38000275	0	\N	\N	182453	0	180325003	4078793	
7445	689	4295880	1999-02-14	1999-02-14 00:00:00	38000275	0	\N	\N	45617	0	76601001	4295880	
19489	1661	4078793	2007-07-12	2007-07-12 00:00:00	38000275	0	\N	\N	111679	0	180325003	4078793	
19658	1691	4024289	1977-06-25	1977-06-25 00:00:00	38000275	0	\N	\N	113253	0	19490002	4024289	
19948	1727	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	115543	0	180256009	4107731	
8208	754	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	49960	0	180256009	4107731	
8375	761	4107731	1994-09-02	1994-09-02 00:00:00	38000275	0	\N	\N	50638	0	180256009	4107731	
20559	1773	4107731	1991-05-05	1991-05-05 00:00:00	38000275	0	\N	\N	118530	0	180256009	4107731	
20753	1783	4107731	1991-11-04	1991-11-04 00:00:00	38000275	0	\N	\N	119552	0	180256009	4107731	
32796	2876	4125906	1967-05-22	1967-05-22 00:00:00	38000275	0	\N	\N	191392	0	288086009	4125906	
21013	1820	4125906	1992-07-23	1992-07-23 00:00:00	38000275	0	\N	\N	121709	0	288086009	4125906	
9322	857	4057420	1983-09-18	1983-09-18 00:00:00	38000275	0	\N	\N	56579	0	18286008	4057420	
21352	1848	4170947	1985-04-03	1985-04-03 00:00:00	38000275	0	\N	\N	123647	0	274474001	4170947	
33583	2925	4107731	1993-02-28	1993-02-28 00:00:00	38000275	0	\N	\N	195086	0	180256009	4107731	
9885	884	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	58891	0	180256009	4107731	
22022	1918	4043071	1979-02-05	1979-02-05 00:00:00	38000275	0	\N	\N	127633	0	228557008	4043071	
22147	1934	4125906	2001-11-02	2001-11-02 00:00:00	38000275	0	\N	\N	128625	0	288086009	4125906	
10458	939	4293740	1986-06-22	1986-06-22 00:00:00	38000275	0	\N	\N	62481	0	384700001	4293740	
22471	1967	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	130766	0	180256009	4107731	
22726	1980	4107731	1990-12-30	1990-12-30 00:00:00	38000275	0	\N	\N	131816	0	180256009	4107731	
22912	1992	4107731	1992-11-22	1992-11-22 00:00:00	38000275	0	\N	\N	132657	0	180256009	4107731	
35075	3057	4195803	1997-03-03	1997-03-03 00:00:00	38000275	0	\N	\N	203418	0	312681000	4195803	
23294	2025	4078793	1974-11-16	1974-11-16 00:00:00	38000275	0	\N	\N	134774	0	180325003	4078793	
23527	2058	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	136911	0	180256009	4107731	
11750	1083	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	71115	0	180256009	4107731	
23792	2075	4058899	2019-04-15	2019-04-15 00:00:00	38000275	0	\N	\N	138004	0	168594001	4058899	
153	9	4125906	2008-06-10	2008-06-10 00:00:00	38000275	0	\N	\N	864	0	288086009	4125906	
12311	1110	4107731	1995-09-04	1995-09-04 00:00:00	38000275	0	\N	\N	73104	0	180256009	4107731	
12401	1115	4107731	1990-10-01	1990-10-01 00:00:00	38000275	0	\N	\N	73443	0	180256009	4107731	
12633	1138	4107731	1994-01-06	1994-01-06 00:00:00	38000275	0	\N	\N	75025	0	180256009	4107731	
24724	2165	4151422	1968-11-24	1968-11-24 00:00:00	38000275	0	\N	\N	144220	0	269911007	4151422	
12986	1175	4107731	1992-10-25	1992-10-25 00:00:00	38000275	0	\N	\N	77508	0	180256009	4107731	
13249	1208	4078793	1996-11-26	1996-11-26 00:00:00	38000275	0	\N	\N	79389	0	180325003	4078793	
13328	1211	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	79511	0	180256009	4107731	
13596	1231	4163872	2000-11-01	2000-11-01 00:00:00	38000275	0	\N	\N	81119	0	399208008	4163872	
13680	1246	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	82008	0	180256009	4107731	
2029	191	4195803	1994-05-07	1994-05-07 00:00:00	38000275	0	\N	\N	13042	0	312681000	4195803	
2242	225	4107731	1992-10-26	1992-10-26 00:00:00	38000275	0	\N	\N	15246	0	180256009	4107731	
14366	1282	4197460	1994-03-31	1994-03-31 00:00:00	38000275	0	\N	\N	84736	0	313191000	4197460	
14402	1285	4107731	1990-01-22	1990-01-22 00:00:00	38000275	0	\N	\N	84934	0	180256009	4107731	
26570	2320	4125906	1976-08-03	1976-08-03 00:00:00	38000275	0	\N	\N	154303	0	288086009	4125906	
2980	285	4107731	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	18969	0	180256009	4107731	
15048	1345	4170947	1993-07-21	1993-07-21 00:00:00	38000275	0	\N	\N	89172	0	274474001	4170947	
15177	1356	4107731	1997-11-06	1997-11-06 00:00:00	38000275	0	\N	\N	89950	0	180256009	4107731	
15464	1378	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	91306	0	180256009	4107731	
3705	357	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	23660	0	180256009	4107731	
15863	1397	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	92771	0	180256009	4107731	
4078	404	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	26621	0	180256009	4107731	
4268	411	4107731	1991-11-30	1991-11-30 00:00:00	38000275	0	\N	\N	27400	0	180256009	4107731	
28264	2503	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	165734	0	180256009	4107731	
16574	1441	4107731	1993-02-08	1993-02-08 00:00:00	38000275	0	\N	\N	95962	0	180256009	4107731	
16710	1447	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	96420	0	395142003	4191853	
16892	1464	4293740	2017-06-21	2017-06-21 00:00:00	38000275	0	\N	\N	97582	0	384700001	4293740	
5225	487	4125906	1998-10-23	1998-10-23 00:00:00	38000275	0	\N	\N	32528	0	288086009	4125906	
17235	1486	4107731	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	99144	0	180256009	4107731	
5578	507	4078793	2004-08-27	2004-08-27 00:00:00	38000275	0	\N	\N	33945	0	180325003	4078793	
17639	1513	4043071	1979-08-16	1979-08-16 00:00:00	38000275	0	\N	\N	101161	0	228557008	4043071	
5970	545	4107731	1993-03-27	1993-03-27 00:00:00	38000275	0	\N	\N	36109	0	180256009	4107731	
17995	1538	4107731	1990-07-09	1990-07-09 00:00:00	38000275	0	\N	\N	102931	0	180256009	4107731	
18267	1556	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	104226	0	395142003	4191853	
18470	1568	4163872	1986-01-03	1986-01-03 00:00:00	38000275	0	\N	\N	105167	0	399208008	4163872	
6718	610	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	40484	0	180256009	4107731	
18747	1609	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	108208	0	180256009	4107731	
18982	1622	4295880	1995-10-30	1995-10-30 00:00:00	38000275	0	\N	\N	108962	0	76601001	4295880	
31051	2758	4163872	2012-02-07	2012-02-07 00:00:00	38000275	0	\N	\N	182490	0	399208008	4163872	
7446	689	4295880	2004-08-08	2004-08-08 00:00:00	38000275	0	\N	\N	45672	0	76601001	4295880	
19490	1661	4078793	2012-08-09	2012-08-09 00:00:00	38000275	0	\N	\N	111649	0	180325003	4078793	
19659	1691	4117038	1970-05-22	1970-05-22 00:00:00	38000275	0	\N	\N	113250	0	287664005	4117038	
19949	1727	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	115529	0	180256009	4107731	
8209	754	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	49920	0	180256009	4107731	
8376	761	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	50595	0	180256009	4107731	
20560	1773	4107731	1991-06-16	1991-06-16 00:00:00	38000275	0	\N	\N	118531	0	180256009	4107731	
20754	1783	4107731	1991-04-08	1991-04-08 00:00:00	38000275	0	\N	\N	119486	0	180256009	4107731	
32797	2878	4125906	1994-06-01	1994-06-01 00:00:00	38000275	0	\N	\N	191451	0	288086009	4125906	
21014	1820	4275113	1998-01-06	1998-01-06 00:00:00	38000275	0	\N	\N	121725	0	65200003	4275113	
9323	858	4330583	2014-02-11	2014-02-11 00:00:00	38000275	0	\N	\N	56669	0	22523008	4330583	
21353	1848	4047491	1985-04-03	1985-04-03 00:00:00	38000275	0	\N	\N	123647	0	1225002	4047491	
33584	2925	4107731	1991-09-02	1991-09-02 00:00:00	38000275	0	\N	\N	195120	0	180256009	4107731	
9886	884	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	58890	0	180256009	4107731	
22023	1918	4043071	1978-06-05	1978-06-05 00:00:00	38000275	0	\N	\N	127613	0	228557008	4043071	
22148	1935	4170947	1978-03-22	1978-03-22 00:00:00	38000275	0	\N	\N	128739	0	274474001	4170947	
10459	939	4198190	2003-07-07	2003-07-07 00:00:00	38000275	0	\N	\N	62467	0	80146002	4198190	
22472	1967	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	130755	0	180256009	4107731	
22727	1980	4107731	1990-04-01	1990-04-01 00:00:00	38000275	0	\N	\N	131859	0	180256009	4107731	
22913	1992	4107731	1991-03-03	1991-03-03 00:00:00	38000275	0	\N	\N	132691	0	180256009	4107731	
35076	3057	4163872	1979-11-10	1979-11-10 00:00:00	38000275	0	\N	\N	203363	0	399208008	4163872	
23295	2025	4078793	2011-06-11	2011-06-11 00:00:00	38000275	0	\N	\N	134650	0	180325003	4078793	
23528	2058	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	136832	0	180256009	4107731	
11751	1083	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	71121	0	180256009	4107731	
23793	2075	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	138057	0	180256009	4107731	
154	9	4107731	1994-04-07	1994-04-07 00:00:00	38000275	0	\N	\N	789	0	180256009	4107731	
12312	1110	4107731	1996-12-30	1996-12-30 00:00:00	38000275	0	\N	\N	73097	0	180256009	4107731	
12402	1115	4107731	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	73480	0	180256009	4107731	
12634	1138	4107731	1995-05-25	1995-05-25 00:00:00	38000275	0	\N	\N	75055	0	180256009	4107731	
24725	2165	4010253	2000-09-25	2000-09-25 00:00:00	38000275	0	\N	\N	144224	0	112790001	4010253	
12987	1175	4107731	1990-05-06	1990-05-06 00:00:00	38000275	0	\N	\N	77434	0	180256009	4107731	
13250	1208	4125906	1941-09-16	1941-09-16 00:00:00	38000275	0	\N	\N	79375	0	288086009	4125906	
13329	1211	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	79510	0	180256009	4107731	
13597	1231	4170947	2000-11-01	2000-11-01 00:00:00	38000275	0	\N	\N	81119	0	274474001	4170947	
13681	1246	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	82022	0	180256009	4107731	
2030	192	4202451	2014-07-02	2014-07-02 00:00:00	38000275	0	\N	\N	13209	0	433112001	4202451	
2243	225	4107731	1992-09-14	1992-09-14 00:00:00	38000275	0	\N	\N	15245	0	180256009	4107731	
14367	1283	4275113	1985-01-10	1985-01-10 00:00:00	38000275	0	\N	\N	84791	0	65200003	4275113	
14403	1285	4107731	1990-07-09	1990-07-09 00:00:00	38000275	0	\N	\N	85033	0	180256009	4107731	
26571	2320	4163872	2015-06-19	2015-06-19 00:00:00	38000275	0	\N	\N	154288	0	399208008	4163872	
2981	285	4107731	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	18935	0	180256009	4107731	
15049	1345	4047491	1993-07-21	1993-07-21 00:00:00	38000275	0	\N	\N	89172	0	1225002	4047491	
15178	1356	44783196	2007-09-29	2007-09-29 00:00:00	38000275	0	\N	\N	89863	0	699253003	44783196	
15465	1378	4035793	2017-07-25	2017-07-25 00:00:00	38000275	0	\N	\N	91345	0	15081005	4035793	
3706	357	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	23766	0	180256009	4107731	
15864	1397	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	92795	0	180256009	4107731	
4079	404	4043071	1971-10-08	1971-10-08 00:00:00	38000275	0	\N	\N	26660	0	228557008	4043071	
4269	411	4107731	1990-03-10	1990-03-10 00:00:00	38000275	0	\N	\N	27365	0	180256009	4107731	
28265	2503	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	165702	0	180256009	4107731	
16575	1441	4107731	1991-02-25	1991-02-25 00:00:00	38000275	0	\N	\N	95987	0	180256009	4107731	
16711	1447	4125906	1963-06-01	1963-06-01 00:00:00	38000275	0	\N	\N	96480	0	288086009	4125906	
16893	1464	4125906	2017-06-21	2017-06-21 00:00:00	38000275	0	\N	\N	97582	0	288086009	4125906	
5226	487	4151422	1972-09-11	1972-09-11 00:00:00	38000275	0	\N	\N	32567	0	269911007	4151422	
17236	1486	4107731	1991-12-01	1991-12-01 00:00:00	38000275	0	\N	\N	99112	0	180256009	4107731	
5579	507	4078793	2002-08-16	2002-08-16 00:00:00	38000275	0	\N	\N	33919	0	180325003	4078793	
17640	1513	4107731	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	101103	0	180256009	4107731	
5971	546	4024289	1946-11-28	1946-11-28 00:00:00	38000275	0	\N	\N	36149	0	19490002	4024289	
17996	1538	4107731	1991-04-08	1991-04-08 00:00:00	38000275	0	\N	\N	102934	0	180256009	4107731	
18268	1556	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	104172	0	180256009	4107731	
18471	1569	4125906	2018-01-28	2018-01-28 00:00:00	38000275	0	\N	\N	105231	0	288086009	4125906	
6719	610	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	40605	0	180256009	4107731	
18748	1609	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	108180	0	180256009	4107731	
18983	1622	4295880	1999-04-26	1999-04-26 00:00:00	38000275	0	\N	\N	109037	0	76601001	4295880	
31052	2758	4078793	2015-01-09	2015-01-09 00:00:00	38000275	0	\N	\N	182397	0	180325003	4078793	
7447	689	4295880	2002-11-10	2002-11-10 00:00:00	38000275	0	\N	\N	45653	0	76601001	4295880	
19491	1661	4078793	2019-04-18	2019-04-18 00:00:00	38000275	0	\N	\N	111709	0	180325003	4078793	
19660	1691	4125906	2014-12-08	2014-12-08 00:00:00	38000275	0	\N	\N	113254	0	288086009	4125906	
19950	1727	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	115528	0	180256009	4107731	
8210	754	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	49900	0	180256009	4107731	
8377	761	4107731	1995-06-02	1995-06-02 00:00:00	38000275	0	\N	\N	50611	0	180256009	4107731	
20561	1773	4107731	1991-02-10	1991-02-10 00:00:00	38000275	0	\N	\N	118528	0	180256009	4107731	
20755	1783	4107731	1991-07-22	1991-07-22 00:00:00	38000275	0	\N	\N	119475	0	180256009	4107731	
32855	2882	4062501	1975-05-19	1975-05-19 00:00:00	38000275	0	\N	\N	191707	0	171231001	4062501	
21015	1820	4202451	2004-09-14	2004-09-14 00:00:00	38000275	0	\N	\N	121716	0	433112001	4202451	
9324	858	4163872	1979-11-15	1979-11-15 00:00:00	38000275	0	\N	\N	56712	0	399208008	4163872	
21354	1848	4078793	2016-05-05	2016-05-05 00:00:00	38000275	0	\N	\N	123600	0	180325003	4078793	
33585	2925	4107731	1990-10-01	1990-10-01 00:00:00	38000275	0	\N	\N	195096	0	180256009	4107731	
9887	884	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	58888	0	180256009	4107731	
22024	1918	4043071	1978-11-06	1978-11-06 00:00:00	38000275	0	\N	\N	127615	0	228557008	4043071	
22149	1935	4024289	1978-03-22	1978-03-22 00:00:00	38000275	0	\N	\N	128739	0	19490002	4024289	
10460	939	4125906	1966-06-04	1966-06-04 00:00:00	38000275	0	\N	\N	62478	0	288086009	4125906	
22473	1967	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	130846	0	180256009	4107731	
22728	1980	4107731	1992-11-22	1992-11-22 00:00:00	38000275	0	\N	\N	131866	0	180256009	4107731	
22914	1992	4107731	1992-02-23	1992-02-23 00:00:00	38000275	0	\N	\N	132654	0	180256009	4107731	
35077	3057	4202451	2016-10-24	2016-10-24 00:00:00	38000275	0	\N	\N	203431	0	433112001	4202451	
23296	2025	4078793	2012-11-03	2012-11-03 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
23529	2058	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	136901	0	180256009	4107731	
11752	1083	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	71076	0	180256009	4107731	
23794	2075	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	138078	0	180256009	4107731	
155	9	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	796	0	180256009	4107731	
12313	1110	4107731	1998-06-29	1998-06-29 00:00:00	38000275	0	\N	\N	73070	0	180256009	4107731	
12403	1115	4107731	1992-03-09	1992-03-09 00:00:00	38000275	0	\N	\N	73365	0	180256009	4107731	
12635	1138	4043071	1997-06-12	1997-06-12 00:00:00	38000275	0	\N	\N	75037	0	228557008	4043071	
24726	2165	4151422	1975-01-25	1975-01-25 00:00:00	38000275	0	\N	\N	144243	0	269911007	4151422	
12988	1175	4107731	1991-06-09	1991-06-09 00:00:00	38000275	0	\N	\N	77446	0	180256009	4107731	
13251	1208	4047491	1961-12-21	1961-12-21 00:00:00	38000275	0	\N	\N	79376	0	1225002	4047491	
13330	1211	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	79507	0	180256009	4107731	
13598	1231	4195803	2000-11-01	2000-11-01 00:00:00	38000275	0	\N	\N	81119	0	312681000	4195803	
13682	1246	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	82101	0	180256009	4107731	
2031	192	4151422	2018-09-18	2018-09-18 00:00:00	38000275	0	\N	\N	13211	0	269911007	4151422	
2244	225	4107731	1992-01-27	1992-01-27 00:00:00	38000275	0	\N	\N	15243	0	180256009	4107731	
14368	1283	4163951	1972-04-22	1972-04-22 00:00:00	38000275	0	\N	\N	84823	0	29303009	4163951	
14404	1285	4107731	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	84922	0	180256009	4107731	
26572	2320	4181917	1941-08-02	1941-08-02 00:00:00	38000275	0	\N	\N	154315	0	54550000	4181917	
2982	285	4107731	1991-11-04	1991-11-04 00:00:00	38000275	0	\N	\N	18948	0	180256009	4107731	
15050	1345	4125906	1996-06-05	1996-06-05 00:00:00	38000275	0	\N	\N	89173	0	288086009	4125906	
15179	1356	4107731	1997-09-25	1997-09-25 00:00:00	38000275	0	\N	\N	89900	0	180256009	4107731	
15466	1378	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	91415	0	180256009	4107731	
3707	357	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	23704	0	180256009	4107731	
15865	1397	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	92772	0	180256009	4107731	
4080	404	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	26693	0	180256009	4107731	
4270	411	4107731	1990-09-15	1990-09-15 00:00:00	38000275	0	\N	\N	27367	0	180256009	4107731	
28266	2503	4275113	1990-02-04	1990-02-04 00:00:00	38000275	0	\N	\N	165692	0	65200003	4275113	
16576	1441	4107731	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	95963	0	180256009	4107731	
16712	1447	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	96536	0	180256009	4107731	
16895	1466	4125906	1972-02-13	1972-02-13 00:00:00	38000275	0	\N	\N	97663	0	288086009	4125906	
5227	487	4238715	1986-05-28	1986-05-28 00:00:00	38000275	0	\N	\N	32557	0	68254000	4238715	
17237	1486	4107731	1990-12-09	1990-12-09 00:00:00	38000275	0	\N	\N	99148	0	180256009	4107731	
5583	510	4252419	2005-06-04	2005-06-04 00:00:00	38000275	0	\N	\N	34083	0	74016001	4252419	
17641	1513	4107731	1991-12-01	1991-12-01 00:00:00	38000275	0	\N	\N	101046	0	180256009	4107731	
5972	546	4170947	1946-11-28	1946-11-28 00:00:00	38000275	0	\N	\N	36149	0	274474001	4170947	
17997	1538	4107731	1990-05-07	1990-05-07 00:00:00	38000275	0	\N	\N	102983	0	180256009	4107731	
18269	1556	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	104241	0	180256009	4107731	
18472	1569	4252419	1987-04-06	1987-04-06 00:00:00	38000275	0	\N	\N	105228	0	74016001	4252419	
6720	610	4151422	2010-08-22	2010-08-22 00:00:00	38000275	0	\N	\N	40614	0	269911007	4151422	
18749	1609	4293740	1957-03-01	1957-03-01 00:00:00	38000275	0	\N	\N	108159	0	384700001	4293740	
18984	1622	4295880	2002-10-21	2002-10-21 00:00:00	38000275	0	\N	\N	108983	0	76601001	4295880	
31053	2758	4078793	2016-01-15	2016-01-15 00:00:00	38000275	0	\N	\N	182452	0	180325003	4078793	
7448	689	4295880	1997-11-16	1997-11-16 00:00:00	38000275	0	\N	\N	45647	0	76601001	4295880	
19492	1661	4151422	1963-02-19	1963-02-19 00:00:00	38000275	0	\N	\N	111682	0	269911007	4151422	
19661	1692	4181917	1982-08-15	1982-08-15 00:00:00	38000275	0	\N	\N	113360	0	54550000	4181917	
19951	1727	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	115538	0	180256009	4107731	
8211	754	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	49929	0	180256009	4107731	
8378	761	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	50550	0	180256009	4107731	
20562	1773	4107731	1993-02-14	1993-02-14 00:00:00	38000275	0	\N	\N	118509	0	180256009	4107731	
20756	1783	4107731	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	119428	0	180256009	4107731	
32856	2883	4125906	1966-01-16	1966-01-16 00:00:00	38000275	0	\N	\N	191767	0	288086009	4125906	
21016	1820	4238715	2004-04-13	2004-04-13 00:00:00	38000275	0	\N	\N	121716	0	68254000	4238715	
9325	858	4170947	1979-11-15	1979-11-15 00:00:00	38000275	0	\N	\N	56712	0	274474001	4170947	
21355	1848	4078793	2019-05-23	2019-05-23 00:00:00	38000275	0	\N	\N	123644	0	180325003	4078793	
33586	2925	4107731	1990-02-11	1990-02-11 00:00:00	38000275	0	\N	\N	195094	0	180256009	4107731	
9888	884	44783196	2012-01-05	2012-01-05 00:00:00	38000275	0	\N	\N	58929	0	699253003	44783196	
22025	1918	4043071	1979-01-01	1979-01-01 00:00:00	38000275	0	\N	\N	127632	0	228557008	4043071	
22150	1936	4326177	2007-02-06	2007-02-06 00:00:00	38000275	0	\N	\N	128829	0	430193006	4326177	
10461	939	4293740	1966-06-04	1966-06-04 00:00:00	38000275	0	\N	\N	62478	0	384700001	4293740	
22474	1967	4252419	2006-09-18	2006-09-18 00:00:00	38000275	0	\N	\N	130892	0	74016001	4252419	
22729	1980	4107731	1991-12-22	1991-12-22 00:00:00	38000275	0	\N	\N	131821	0	180256009	4107731	
22915	1992	4191853	1993-07-11	1993-07-11 00:00:00	38000275	0	\N	\N	132659	0	395142003	4191853	
35078	3059	4243062	2008-09-17	2008-09-17 00:00:00	38000275	0	\N	\N	203512	0	60027007	4243062	
23297	2025	4078793	2018-06-16	2018-06-16 00:00:00	38000275	0	\N	\N	134736	0	180325003	4078793	
23530	2058	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	136912	0	395142003	4191853	
11753	1083	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	71122	0	180256009	4107731	
23795	2075	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	138091	0	180256009	4107731	
156	9	4107731	1994-11-24	1994-11-24 00:00:00	38000275	0	\N	\N	756	0	180256009	4107731	
12314	1110	4191853	1998-09-21	1998-09-21 00:00:00	38000275	0	\N	\N	73077	0	395142003	4191853	
12404	1115	4107731	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	73407	0	180256009	4107731	
12636	1138	4107731	1996-04-25	1996-04-25 00:00:00	38000275	0	\N	\N	75111	0	180256009	4107731	
24727	2165	4252419	1989-09-16	1989-09-16 00:00:00	38000275	0	\N	\N	144206	0	74016001	4252419	
12989	1175	4107731	1992-01-26	1992-01-26 00:00:00	38000275	0	\N	\N	77505	0	180256009	4107731	
13252	1208	4170947	1961-12-21	1961-12-21 00:00:00	38000275	0	\N	\N	79376	0	274474001	4170947	
13331	1211	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	79651	0	180256009	4107731	
13599	1231	4243062	1949-11-14	1949-11-14 00:00:00	38000275	0	\N	\N	81113	0	60027007	4243062	
13683	1246	4151422	1945-05-23	1945-05-23 00:00:00	38000275	0	\N	\N	82038	0	269911007	4151422	
2033	194	4125906	1988-05-07	1988-05-07 00:00:00	38000275	0	\N	\N	13306	0	288086009	4125906	
14080	1271	4151422	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	83801	0	269911007	4151422	
14369	1283	4202832	1972-04-22	1972-04-22 00:00:00	38000275	0	\N	\N	84823	0	52765003	4202832	
14405	1285	4107731	1991-01-14	1991-01-14 00:00:00	38000275	0	\N	\N	85034	0	180256009	4107731	
26573	2320	4125906	2017-12-10	2017-12-10 00:00:00	38000275	0	\N	\N	154304	0	288086009	4125906	
2983	285	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	18955	0	180256009	4107731	
15051	1345	4293740	1996-06-05	1996-06-05 00:00:00	38000275	0	\N	\N	89173	0	384700001	4293740	
15180	1356	4107731	1997-08-14	1997-08-14 00:00:00	38000275	0	\N	\N	89899	0	180256009	4107731	
15467	1378	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	91392	0	180256009	4107731	
3708	357	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	23668	0	180256009	4107731	
15866	1397	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	92812	0	180256009	4107731	
4081	404	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	26567	0	180256009	4107731	
4271	411	4107731	1991-09-28	1991-09-28 00:00:00	38000275	0	\N	\N	27289	0	180256009	4107731	
28267	2503	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	165673	0	180256009	4107731	
16577	1441	4107731	1990-01-22	1990-01-22 00:00:00	38000275	0	\N	\N	95980	0	180256009	4107731	
16713	1447	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	96446	0	180256009	4107731	
16896	1466	4163872	2016-02-23	2016-02-23 00:00:00	38000275	0	\N	\N	97651	0	399208008	4163872	
5228	487	4151422	1995-11-29	1995-11-29 00:00:00	38000275	0	\N	\N	32532	0	269911007	4151422	
17238	1486	4107731	1992-08-09	1992-08-09 00:00:00	38000275	0	\N	\N	99039	0	180256009	4107731	
5584	510	44783196	2005-06-11	2005-06-11 00:00:00	38000275	0	\N	\N	34139	0	699253003	44783196	
17642	1513	4107731	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	101082	0	180256009	4107731	
5973	546	4037675	1987-11-03	1987-11-03 00:00:00	38000275	0	\N	\N	36155	0	162676008	4037675	
17998	1538	4107731	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	102989	0	180256009	4107731	
18270	1556	4059978	1991-03-05	1991-03-05 00:00:00	38000275	0	\N	\N	104252	0	169553002	4059978	
18473	1569	44783196	1998-12-18	1998-12-18 00:00:00	38000275	0	\N	\N	105232	0	699253003	44783196	
6721	610	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	40501	0	180256009	4107731	
18750	1609	4125906	1957-03-01	1957-03-01 00:00:00	38000275	0	\N	\N	108159	0	288086009	4125906	
18985	1622	4295880	1993-11-01	1993-11-01 00:00:00	38000275	0	\N	\N	109032	0	76601001	4295880	
31054	2758	4125906	1978-06-22	1978-06-22 00:00:00	38000275	0	\N	\N	182456	0	288086009	4125906	
7449	689	4295880	2005-05-08	2005-05-08 00:00:00	38000275	0	\N	\N	45673	0	76601001	4295880	
19493	1661	4078793	2017-04-06	2017-04-06 00:00:00	38000275	0	\N	\N	111708	0	180325003	4078793	
19663	1695	4252419	2003-06-19	2003-06-19 00:00:00	38000275	0	\N	\N	113483	0	74016001	4252419	
19952	1727	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	115537	0	180256009	4107731	
8212	754	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	49989	0	180256009	4107731	
8379	761	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	50551	0	180256009	4107731	
20563	1773	4107731	1992-08-09	1992-08-09 00:00:00	38000275	0	\N	\N	118508	0	180256009	4107731	
20757	1783	4107731	1990-07-09	1990-07-09 00:00:00	38000275	0	\N	\N	119483	0	180256009	4107731	
32864	2886	4043071	1960-06-01	1960-06-01 00:00:00	38000275	0	\N	\N	191961	0	228557008	4043071	
21017	1820	4186930	2003-01-07	2003-01-07 00:00:00	38000275	0	\N	\N	121715	0	46706006	4186930	
9326	859	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	56871	0	180256009	4107731	
21356	1848	4078793	2011-02-17	2011-02-17 00:00:00	38000275	0	\N	\N	123636	0	180325003	4078793	
33587	2925	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	195112	0	180256009	4107731	
9889	884	4125906	1984-09-11	1984-09-11 00:00:00	38000275	0	\N	\N	58949	0	288086009	4125906	
22030	1921	4151422	1987-03-06	1987-03-06 00:00:00	38000275	0	\N	\N	127721	0	269911007	4151422	
22151	1936	4187458	2007-02-06	2007-02-06 00:00:00	38000275	0	\N	\N	128829	0	415300000	4187458	
10462	940	40492359	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	62564	0	447365002	40492359	
22475	1967	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	130752	0	180256009	4107731	
22730	1980	4170947	1982-03-22	1982-03-22 00:00:00	38000275	0	\N	\N	131804	0	274474001	4170947	
22916	1992	4107731	1991-12-22	1991-12-22 00:00:00	38000275	0	\N	\N	132681	0	180256009	4107731	
35079	3059	4170947	2008-09-17	2008-09-17 00:00:00	38000275	0	\N	\N	203512	0	274474001	4170947	
23298	2025	4078793	1980-12-20	1980-12-20 00:00:00	38000275	0	\N	\N	134643	0	180325003	4078793	
23531	2058	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	136888	0	180256009	4107731	
11754	1083	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	71142	0	180256009	4107731	
23796	2075	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	138097	0	180256009	4107731	
157	9	4107731	1993-12-02	1993-12-02 00:00:00	38000275	0	\N	\N	751	0	180256009	4107731	
12315	1110	4107731	1995-05-22	1995-05-22 00:00:00	38000275	0	\N	\N	73090	0	180256009	4107731	
12405	1115	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	73486	0	180256009	4107731	
12637	1138	4107731	1993-12-16	1993-12-16 00:00:00	38000275	0	\N	\N	75066	0	180256009	4107731	
24728	2166	4151422	1970-12-13	1970-12-13 00:00:00	38000275	0	\N	\N	144286	0	269911007	4151422	
12990	1175	4107731	1990-07-08	1990-07-08 00:00:00	38000275	0	\N	\N	77452	0	180256009	4107731	
13253	1208	4078793	2005-01-11	2005-01-11 00:00:00	38000275	0	\N	\N	79362	0	180325003	4078793	
13332	1211	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	79620	0	180256009	4107731	
13600	1231	4170947	1949-11-14	1949-11-14 00:00:00	38000275	0	\N	\N	81113	0	274474001	4170947	
13684	1246	4125906	1961-11-16	1961-11-16 00:00:00	38000275	0	\N	\N	82051	0	288086009	4125906	
2034	194	4293740	1988-05-07	1988-05-07 00:00:00	38000275	0	\N	\N	13306	0	384700001	4293740	
14081	1271	4125906	1978-12-20	1978-12-20 00:00:00	38000275	0	\N	\N	83820	0	288086009	4125906	
14370	1283	42535580	1972-04-22	1972-04-22 00:00:00	38000275	0	\N	\N	84823	0	426701000119108	42535580	
14406	1285	4107731	1992-07-13	1992-07-13 00:00:00	38000275	0	\N	\N	84955	0	180256009	4107731	
26574	2320	4058899	1954-05-01	1954-05-01 00:00:00	38000275	0	\N	\N	154302	0	168594001	4058899	
2984	285	4107731	1992-03-30	1992-03-30 00:00:00	38000275	0	\N	\N	18994	0	180256009	4107731	
15080	1348	4252419	1919-09-16	1919-09-16 00:00:00	38000275	0	\N	\N	89301	0	74016001	4252419	
15181	1356	4107731	1995-09-21	1995-09-21 00:00:00	38000275	0	\N	\N	89933	0	180256009	4107731	
15468	1378	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	91369	0	180256009	4107731	
3709	357	4024289	1968-04-16	1968-04-16 00:00:00	38000275	0	\N	\N	23636	0	19490002	4024289	
15867	1397	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	92735	0	180256009	4107731	
4082	404	4043071	1970-10-09	1970-10-09 00:00:00	38000275	0	\N	\N	26676	0	228557008	4043071	
4272	411	4107731	1992-06-06	1992-06-06 00:00:00	38000275	0	\N	\N	27375	0	180256009	4107731	
28268	2503	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	165761	0	180256009	4107731	
16578	1441	4107731	1991-09-23	1991-09-23 00:00:00	38000275	0	\N	\N	95957	0	180256009	4107731	
16714	1447	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	96507	0	180256009	4107731	
16897	1466	4125906	1998-03-12	1998-03-12 00:00:00	38000275	0	\N	\N	97664	0	288086009	4125906	
5229	488	4170947	1966-06-30	1966-06-30 00:00:00	38000275	0	\N	\N	32697	0	274474001	4170947	
17239	1486	4107731	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	99145	0	180256009	4107731	
5587	512	4047491	1969-01-29	1969-01-29 00:00:00	38000275	0	\N	\N	34169	0	1225002	4047491	
17643	1513	4107731	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	101016	0	180256009	4107731	
5974	546	4326177	1987-11-03	1987-11-03 00:00:00	38000275	0	\N	\N	36155	0	430193006	4326177	
17999	1538	4107731	1990-10-01	1990-10-01 00:00:00	38000275	0	\N	\N	102978	0	180256009	4107731	
18273	1558	4293740	1969-04-10	1969-04-10 00:00:00	38000275	0	\N	\N	104302	0	384700001	4293740	
18474	1569	4252419	1998-12-11	1998-12-11 00:00:00	38000275	0	\N	\N	105229	0	74016001	4252419	
6722	610	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	40540	0	180256009	4107731	
18751	1609	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	108128	0	180256009	4107731	
18986	1622	4295880	2000-10-23	2000-10-23 00:00:00	38000275	0	\N	\N	109014	0	76601001	4295880	
31055	2758	4293740	1978-06-22	1978-06-22 00:00:00	38000275	0	\N	\N	182456	0	384700001	4293740	
7450	689	4295880	2003-08-10	2003-08-10 00:00:00	38000275	0	\N	\N	45654	0	76601001	4295880	
19494	1661	4078793	2014-08-21	2014-08-21 00:00:00	38000275	0	\N	\N	111673	0	180325003	4078793	
19664	1695	4163872	1986-09-12	1986-09-12 00:00:00	38000275	0	\N	\N	113437	0	399208008	4163872	
19953	1727	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	115544	0	180256009	4107731	
8213	754	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	49901	0	180256009	4107731	
8380	761	4107731	1994-09-23	1994-09-23 00:00:00	38000275	0	\N	\N	50623	0	180256009	4107731	
20564	1773	4107731	1992-08-30	1992-08-30 00:00:00	38000275	0	\N	\N	118601	0	180256009	4107731	
32539	2858	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	189877	0	180256009	4107731	
32865	2886	4043071	1960-01-13	1960-01-13 00:00:00	38000275	0	\N	\N	191956	0	228557008	4043071	
21018	1821	4078793	2008-10-19	2008-10-19 00:00:00	38000275	0	\N	\N	121870	0	180325003	4078793	
9327	859	4107731	1990-07-09	1990-07-09 00:00:00	38000275	0	\N	\N	56885	0	180256009	4107731	
21357	1848	4057420	2018-05-17	2018-05-17 00:00:00	38000275	0	\N	\N	123601	0	18286008	4057420	
33588	2925	4107731	1991-02-24	1991-02-24 00:00:00	38000275	0	\N	\N	195031	0	180256009	4107731	
9890	884	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	58894	0	180256009	4107731	
22031	1921	4151422	2012-12-17	2012-12-17 00:00:00	38000275	0	\N	\N	127748	0	269911007	4151422	
22152	1936	4037675	2007-02-06	2007-02-06 00:00:00	38000275	0	\N	\N	128829	0	162676008	4037675	
10463	940	4057420	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	62564	0	18286008	4057420	
22484	1971	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	131042	0	180256009	4107731	
22731	1980	4024289	1982-03-22	1982-03-22 00:00:00	38000275	0	\N	\N	131804	0	19490002	4024289	
22917	1992	4107731	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	132678	0	180256009	4107731	
35080	3059	4293740	2013-05-15	2013-05-15 00:00:00	38000275	0	\N	\N	203514	0	384700001	4293740	
23299	2025	4078793	2006-05-13	2006-05-13 00:00:00	38000275	0	\N	\N	134680	0	180325003	4078793	
23532	2058	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	136805	0	180256009	4107731	
11755	1083	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	71168	0	180256009	4107731	
23797	2075	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	138059	0	180256009	4107731	
158	9	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	822	0	180256009	4107731	
12316	1110	4107731	1995-07-03	1995-07-03 00:00:00	38000275	0	\N	\N	73091	0	180256009	4107731	
12406	1115	4107731	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	73444	0	180256009	4107731	
12638	1138	4107731	1993-06-10	1993-06-10 00:00:00	38000275	0	\N	\N	75072	0	180256009	4107731	
24729	2166	4047491	1986-09-09	1986-09-09 00:00:00	38000275	0	\N	\N	144342	0	1225002	4047491	
12991	1175	4107731	1992-04-19	1992-04-19 00:00:00	38000275	0	\N	\N	77449	0	180256009	4107731	
13254	1208	4078793	2008-01-29	2008-01-29 00:00:00	38000275	0	\N	\N	79387	0	180325003	4078793	
13333	1211	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	79563	0	180256009	4107731	
13601	1232	4243062	1971-10-09	1971-10-09 00:00:00	38000275	0	\N	\N	81184	0	60027007	4243062	
13685	1246	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	82151	0	395142003	4191853	
2035	194	4170947	1990-03-12	1990-03-12 00:00:00	38000275	0	\N	\N	13307	0	274474001	4170947	
14082	1272	4107731	1994-05-20	1994-05-20 00:00:00	38000275	0	\N	\N	83884	0	180256009	4107731	
14371	1283	4163971	1972-04-22	1972-04-22 00:00:00	38000275	0	\N	\N	84823	0	45595009	4163971	
14407	1285	4107731	1990-03-05	1990-03-05 00:00:00	38000275	0	\N	\N	84935	0	180256009	4107731	
26584	2325	4059978	1996-08-23	1996-08-23 00:00:00	38000275	0	\N	\N	154569	0	169553002	4059978	
2985	285	4107731	1991-09-02	1991-09-02 00:00:00	38000275	0	\N	\N	18939	0	180256009	4107731	
15081	1348	4151422	1988-10-04	1988-10-04 00:00:00	38000275	0	\N	\N	89305	0	269911007	4151422	
15182	1356	4252419	2007-09-22	2007-09-22 00:00:00	38000275	0	\N	\N	89862	0	74016001	4252419	
15469	1378	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	91407	0	180256009	4107731	
3710	357	4170947	1968-04-16	1968-04-16 00:00:00	38000275	0	\N	\N	23636	0	274474001	4170947	
15868	1397	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	92805	0	395142003	4191853	
4083	404	4043071	1970-11-13	1970-11-13 00:00:00	38000275	0	\N	\N	26665	0	228557008	4043071	
4273	411	4107731	1992-11-21	1992-11-21 00:00:00	38000275	0	\N	\N	27259	0	180256009	4107731	
28269	2503	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	165715	0	180256009	4107731	
16579	1441	4107731	1990-07-09	1990-07-09 00:00:00	38000275	0	\N	\N	95985	0	180256009	4107731	
16715	1447	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	96452	0	180256009	4107731	
16898	1467	4043071	1943-05-04	1943-05-04 00:00:00	38000275	0	\N	\N	97712	0	228557008	4043071	
5230	488	4047491	1966-06-30	1966-06-30 00:00:00	38000275	0	\N	\N	32697	0	1225002	4047491	
17240	1486	4107731	1992-02-23	1992-02-23 00:00:00	38000275	0	\N	\N	99114	0	180256009	4107731	
5588	512	4170947	1969-01-29	1969-01-29 00:00:00	38000275	0	\N	\N	34169	0	274474001	4170947	
17644	1513	4107731	1991-05-05	1991-05-05 00:00:00	38000275	0	\N	\N	101072	0	180256009	4107731	
5975	546	4187458	1987-11-03	1987-11-03 00:00:00	38000275	0	\N	\N	36155	0	415300000	4187458	
18000	1538	4107731	1990-06-18	1990-06-18 00:00:00	38000275	0	\N	\N	102984	0	180256009	4107731	
18274	1558	4125906	1969-04-10	1969-04-10 00:00:00	38000275	0	\N	\N	104302	0	288086009	4125906	
18475	1569	4163872	2007-06-21	2007-06-21 00:00:00	38000275	0	\N	\N	105298	0	399208008	4163872	
6723	610	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	40496	0	180256009	4107731	
18752	1609	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	108182	0	180256009	4107731	
18987	1622	4295880	1996-01-29	1996-01-29 00:00:00	38000275	0	\N	\N	108974	0	76601001	4295880	
31056	2758	4078793	2011-12-23	2011-12-23 00:00:00	38000275	0	\N	\N	182420	0	180325003	4078793	
7451	689	4295880	1997-08-17	1997-08-17 00:00:00	38000275	0	\N	\N	45697	0	76601001	4295880	
19495	1661	4078793	2015-08-27	2015-08-27 00:00:00	38000275	0	\N	\N	111707	0	180325003	4078793	
19665	1695	4125906	2016-09-15	2016-09-15 00:00:00	38000275	0	\N	\N	113484	0	288086009	4125906	
19954	1727	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	115425	0	395142003	4191853	
8214	754	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	49970	0	180256009	4107731	
8381	761	4107731	1995-01-27	1995-01-27 00:00:00	38000275	0	\N	\N	50580	0	180256009	4107731	
20565	1773	4107731	1991-10-20	1991-10-20 00:00:00	38000275	0	\N	\N	118597	0	180256009	4107731	
32540	2858	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	189851	0	180256009	4107731	
32866	2886	4043071	1960-04-27	1960-04-27 00:00:00	38000275	0	\N	\N	191965	0	228557008	4043071	
21019	1821	4078793	2006-10-08	2006-10-08 00:00:00	38000275	0	\N	\N	121845	0	180325003	4078793	
9328	859	4191853	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	56795	0	395142003	4191853	
21358	1848	4125906	1957-03-10	1957-03-10 00:00:00	38000275	0	\N	\N	123677	0	288086009	4125906	
33589	2925	4107731	1992-07-13	1992-07-13 00:00:00	38000275	0	\N	\N	195084	0	180256009	4107731	
9891	884	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	58846	0	180256009	4107731	
22032	1921	4024289	1968-07-10	1968-07-10 00:00:00	38000275	0	\N	\N	127790	0	19490002	4024289	
22153	1936	4145310	2009-07-31	2009-07-31 00:00:00	38000275	0	\N	\N	128759	0	268425006	4145310	
10464	940	4151422	1982-07-13	1982-07-13 00:00:00	38000275	0	\N	\N	62567	0	269911007	4151422	
22485	1971	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	131073	0	180256009	4107731	
22732	1980	4107731	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	131802	0	180256009	4107731	
22918	1992	4107731	1993-02-14	1993-02-14 00:00:00	38000275	0	\N	\N	132642	0	180256009	4107731	
35081	3059	4125906	2013-05-15	2013-05-15 00:00:00	38000275	0	\N	\N	203514	0	288086009	4125906	
23300	2025	4078793	2010-06-05	2010-06-05 00:00:00	38000275	0	\N	\N	134711	0	180325003	4078793	
23533	2058	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	136847	0	180256009	4107731	
11756	1083	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	71119	0	180256009	4107731	
23798	2075	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	138062	0	180256009	4107731	
159	9	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	821	0	180256009	4107731	
12317	1110	4107731	1996-11-18	1996-11-18 00:00:00	38000275	0	\N	\N	73063	0	180256009	4107731	
12407	1115	4107731	1992-01-27	1992-01-27 00:00:00	38000275	0	\N	\N	73364	0	180256009	4107731	
12639	1138	4107731	1996-05-16	1996-05-16 00:00:00	38000275	0	\N	\N	75031	0	180256009	4107731	
24730	2166	4170947	1986-09-09	1986-09-09 00:00:00	38000275	0	\N	\N	144342	0	274474001	4170947	
12992	1175	4107731	1992-12-06	1992-12-06 00:00:00	38000275	0	\N	\N	77514	0	180256009	4107731	
13255	1208	4078793	1999-12-14	1999-12-14 00:00:00	38000275	0	\N	\N	79353	0	180325003	4078793	
13334	1211	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	79562	0	180256009	4107731	
13602	1232	4170947	1971-10-09	1971-10-09 00:00:00	38000275	0	\N	\N	81184	0	274474001	4170947	
13686	1246	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	82001	0	180256009	4107731	
2036	194	4047491	1990-03-12	1990-03-12 00:00:00	38000275	0	\N	\N	13307	0	1225002	4047491	
14083	1272	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	83906	0	180256009	4107731	
14372	1283	4242997	1972-04-22	1972-04-22 00:00:00	38000275	0	\N	\N	84823	0	38102005	4242997	
14408	1285	4107731	1991-02-25	1991-02-25 00:00:00	38000275	0	\N	\N	85035	0	180256009	4107731	
26585	2325	4151422	1981-01-06	1981-01-06 00:00:00	38000275	0	\N	\N	154617	0	269911007	4151422	
2986	285	4107731	1990-08-20	1990-08-20 00:00:00	38000275	0	\N	\N	18967	0	180256009	4107731	
15082	1348	4125906	1977-12-01	1977-12-01 00:00:00	38000275	0	\N	\N	89373	0	288086009	4125906	
15183	1356	4107731	1995-06-29	1995-06-29 00:00:00	38000275	0	\N	\N	89931	0	180256009	4107731	
15470	1378	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	91435	0	395142003	4191853	
3711	357	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	23759	0	180256009	4107731	
15869	1397	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	92793	0	180256009	4107731	
4084	404	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	26619	0	180256009	4107731	
4274	411	4107731	1990-11-17	1990-11-17 00:00:00	38000275	0	\N	\N	27285	0	180256009	4107731	
28270	2503	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	165666	0	180256009	4107731	
16580	1441	4107731	1991-02-04	1991-02-04 00:00:00	38000275	0	\N	\N	96063	0	180256009	4107731	
16716	1447	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	96461	0	180256009	4107731	
16899	1467	4043071	1942-07-21	1942-07-21 00:00:00	38000275	0	\N	\N	97695	0	228557008	4043071	
5231	488	4125906	2001-10-24	2001-10-24 00:00:00	38000275	0	\N	\N	32701	0	288086009	4125906	
17241	1486	4107731	1990-08-05	1990-08-05 00:00:00	38000275	0	\N	\N	99132	0	180256009	4107731	
5589	512	4125906	2013-07-14	2013-07-14 00:00:00	38000275	0	\N	\N	34171	0	288086009	4125906	
17645	1513	4107731	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	101039	0	180256009	4107731	
5976	546	4125906	2004-11-23	2004-11-23 00:00:00	38000275	0	\N	\N	36153	0	288086009	4125906	
18001	1538	4107731	1992-06-01	1992-06-01 00:00:00	38000275	0	\N	\N	103066	0	180256009	4107731	
18275	1558	4151422	1996-01-21	1996-01-21 00:00:00	38000275	0	\N	\N	104386	0	269911007	4151422	
18476	1569	4195803	2007-03-02	2007-03-02 00:00:00	38000275	0	\N	\N	105336	0	312681000	4195803	
6724	610	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	40500	0	180256009	4107731	
18753	1609	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	108202	0	180256009	4107731	
18988	1622	4295880	1999-07-26	1999-07-26 00:00:00	38000275	0	\N	\N	109025	0	76601001	4295880	
31057	2758	4078793	2012-02-17	2012-02-17 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
7452	689	4295880	2004-11-07	2004-11-07 00:00:00	38000275	0	\N	\N	45678	0	76601001	4295880	
19496	1661	4078793	2016-09-01	2016-09-01 00:00:00	38000275	0	\N	\N	111674	0	180325003	4078793	
19666	1695	4293740	2016-09-15	2016-09-15 00:00:00	38000275	0	\N	\N	113484	0	384700001	4293740	
19955	1727	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	115469	0	180256009	4107731	
8215	754	4195803	2008-04-09	2008-04-09 00:00:00	38000275	0	\N	\N	49825	0	312681000	4195803	
8382	761	4107731	1994-04-29	1994-04-29 00:00:00	38000275	0	\N	\N	50647	0	180256009	4107731	
20566	1773	4107731	1992-05-17	1992-05-17 00:00:00	38000275	0	\N	\N	118506	0	180256009	4107731	
32541	2858	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	189894	0	180256009	4107731	
32867	2886	4043071	1960-06-29	1960-06-29 00:00:00	38000275	0	\N	\N	191894	0	228557008	4043071	
21020	1821	4057420	2015-11-29	2015-11-29 00:00:00	38000275	0	\N	\N	121867	0	18286008	4057420	
9329	859	4107731	1992-10-05	1992-10-05 00:00:00	38000275	0	\N	\N	56842	0	180256009	4107731	
21359	1848	4078793	2011-04-07	2011-04-07 00:00:00	38000275	0	\N	\N	123645	0	180325003	4078793	
33590	2925	4107731	1990-04-16	1990-04-16 00:00:00	38000275	0	\N	\N	195088	0	180256009	4107731	
9892	884	4107731	1994-02-01	1994-02-01 00:00:00	38000275	0	\N	\N	58918	0	180256009	4107731	
22033	1921	4170947	1968-07-10	1968-07-10 00:00:00	38000275	0	\N	\N	127790	0	274474001	4170947	
22154	1936	4195803	2009-07-31	2009-07-31 00:00:00	38000275	0	\N	\N	128759	0	312681000	4195803	
10465	940	4125906	1979-05-30	1979-05-30 00:00:00	38000275	0	\N	\N	62562	0	288086009	4125906	
22486	1971	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	131022	0	180256009	4107731	
22733	1980	4187458	1999-09-04	1999-09-04 00:00:00	38000275	0	\N	\N	131769	0	415300000	4187458	
22919	1992	4107731	1993-01-24	1993-01-24 00:00:00	38000275	0	\N	\N	132698	0	180256009	4107731	
35082	3059	4198190	1990-04-15	1990-04-15 00:00:00	38000275	0	\N	\N	203510	0	80146002	4198190	
23301	2025	4078793	1978-12-09	1978-12-09 00:00:00	38000275	0	\N	\N	134642	0	180325003	4078793	
23534	2058	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	136852	0	180256009	4107731	
11757	1083	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	71071	0	180256009	4107731	
23799	2075	4107731	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	138108	0	180256009	4107731	
160	9	4107731	1994-04-28	1994-04-28 00:00:00	38000275	0	\N	\N	741	0	180256009	4107731	
12318	1110	4107731	1997-01-20	1997-01-20 00:00:00	38000275	0	\N	\N	73109	0	180256009	4107731	
12408	1115	4107731	1991-01-14	1991-01-14 00:00:00	38000275	0	\N	\N	73350	0	180256009	4107731	
12640	1138	4107731	1996-02-22	1996-02-22 00:00:00	38000275	0	\N	\N	75029	0	180256009	4107731	
24731	2166	4125906	2006-01-27	2006-01-27 00:00:00	38000275	0	\N	\N	144343	0	288086009	4125906	
12993	1175	4107731	1992-03-08	1992-03-08 00:00:00	38000275	0	\N	\N	77448	0	180256009	4107731	
13256	1208	4078793	2009-02-03	2009-02-03 00:00:00	38000275	0	\N	\N	79364	0	180325003	4078793	
13335	1211	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	79623	0	180256009	4107731	
13603	1232	4293740	1993-12-12	1993-12-12 00:00:00	38000275	0	\N	\N	81185	0	384700001	4293740	
13687	1246	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	82166	0	180256009	4107731	
2037	195	4151422	1970-01-14	1970-01-14 00:00:00	38000275	0	\N	\N	13417	0	269911007	4151422	
14084	1272	4107731	1995-11-17	1995-11-17 00:00:00	38000275	0	\N	\N	83890	0	180256009	4107731	
14373	1283	4125906	1993-11-08	1993-11-08 00:00:00	38000275	0	\N	\N	84825	0	288086009	4125906	
14409	1285	4191853	1990-01-01	1990-01-01 00:00:00	38000275	0	\N	\N	84986	0	395142003	4191853	
26586	2325	4145310	2007-10-06	2007-10-06 00:00:00	38000275	0	\N	\N	154601	0	268425006	4145310	
2987	285	4107731	1992-06-01	1992-06-01 00:00:00	38000275	0	\N	\N	18922	0	180256009	4107731	
15089	1352	4035793	2005-04-24	2005-04-24 00:00:00	38000275	0	\N	\N	89556	0	15081005	4035793	
15184	1356	4107731	1995-04-27	1995-04-27 00:00:00	38000275	0	\N	\N	89942	0	180256009	4107731	
15471	1378	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	91376	0	180256009	4107731	
3712	357	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	23691	0	180256009	4107731	
15870	1397	4125906	1998-01-12	1998-01-12 00:00:00	38000275	0	\N	\N	92838	0	288086009	4125906	
4085	404	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	26569	0	180256009	4107731	
4275	411	4107731	1992-08-29	1992-08-29 00:00:00	38000275	0	\N	\N	27257	0	180256009	4107731	
28271	2503	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	165700	0	180256009	4107731	
16581	1441	4191853	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	95975	0	395142003	4191853	
16717	1447	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	96502	0	180256009	4107731	
16900	1467	4043071	1942-04-21	1942-04-21 00:00:00	38000275	0	\N	\N	97770	0	228557008	4043071	
5232	488	4047491	1977-02-02	1977-02-02 00:00:00	38000275	0	\N	\N	32699	0	1225002	4047491	
17242	1486	4107731	1991-09-08	1991-09-08 00:00:00	38000275	0	\N	\N	99014	0	180256009	4107731	
5590	512	4170947	1967-03-11	1967-03-11 00:00:00	38000275	0	\N	\N	34168	0	274474001	4170947	
17646	1513	4107731	1991-02-10	1991-02-10 00:00:00	38000275	0	\N	\N	101142	0	180256009	4107731	
5977	546	4243062	2010-05-17	2010-05-17 00:00:00	38000275	0	\N	\N	36154	0	60027007	4243062	
18002	1538	4078793	2009-10-05	2009-10-05 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
18276	1558	42535580	1962-06-14	1962-06-14 00:00:00	38000275	0	\N	\N	104301	0	426701000119108	42535580	
18477	1569	44783196	1987-04-13	1987-04-13 00:00:00	38000275	0	\N	\N	105233	0	699253003	44783196	
6725	610	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	40581	0	180256009	4107731	
18754	1609	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	108065	0	180256009	4107731	
18989	1622	4295880	2001-04-23	2001-04-23 00:00:00	38000275	0	\N	\N	108981	0	76601001	4295880	
31058	2758	4078793	2009-12-11	2009-12-11 00:00:00	38000275	0	\N	\N	182419	0	180325003	4078793	
7453	689	4295880	2004-02-08	2004-02-08 00:00:00	38000275	0	\N	\N	45677	0	76601001	4295880	
19497	1661	4151422	2003-08-16	2003-08-16 00:00:00	38000275	0	\N	\N	111638	0	269911007	4151422	
19667	1695	4151422	2001-01-31	2001-01-31 00:00:00	38000275	0	\N	\N	113477	0	269911007	4151422	
19956	1727	4125906	2012-11-06	2012-11-06 00:00:00	38000275	0	\N	\N	115474	0	288086009	4125906	
8216	754	4024289	2008-04-09	2008-04-09 00:00:00	38000275	0	\N	\N	49825	0	19490002	4024289	
8383	761	4191853	1979-09-26	1979-09-26 00:00:00	38000275	0	\N	\N	50589	0	395142003	4191853	
20567	1773	4107731	1990-04-01	1990-04-01 00:00:00	38000275	0	\N	\N	118559	0	180256009	4107731	
32542	2858	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	189916	0	180256009	4107731	
32868	2886	4043071	1960-02-17	1960-02-17 00:00:00	38000275	0	\N	\N	191963	0	228557008	4043071	
21021	1821	4078793	2019-03-10	2019-03-10 00:00:00	38000275	0	\N	\N	121872	0	180325003	4078793	
9330	859	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	56844	0	180256009	4107731	
21360	1848	4078793	2012-04-12	2012-04-12 00:00:00	38000275	0	\N	\N	123674	0	180325003	4078793	
33591	2925	4107731	1991-11-24	1991-11-24 00:00:00	38000275	0	\N	\N	195122	0	180256009	4107731	
9893	884	4107731	1993-10-19	1993-10-19 00:00:00	38000275	0	\N	\N	58908	0	180256009	4107731	
22034	1921	4151422	2003-03-13	2003-03-13 00:00:00	38000275	0	\N	\N	127747	0	269911007	4151422	
22155	1936	4163872	1962-12-31	1962-12-31 00:00:00	38000275	0	\N	\N	128827	0	399208008	4163872	
10466	940	4058899	1956-05-30	1956-05-30 00:00:00	38000275	0	\N	\N	62560	0	168594001	4058899	
22487	1971	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	131067	0	180256009	4107731	
22734	1980	4037675	1999-09-04	1999-09-04 00:00:00	38000275	0	\N	\N	131769	0	162676008	4037675	
22920	1992	4107731	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	132692	0	180256009	4107731	
35083	3059	4125906	2012-06-28	2012-06-28 00:00:00	38000275	0	\N	\N	203513	0	288086009	4125906	
23302	2025	4078793	1986-01-18	1986-01-18 00:00:00	38000275	0	\N	\N	134776	0	180325003	4078793	
23535	2058	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	136872	0	180256009	4107731	
11758	1083	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	71109	0	180256009	4107731	
23800	2075	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	138098	0	180256009	4107731	
161	9	4107731	1993-11-11	1993-11-11 00:00:00	38000275	0	\N	\N	775	0	180256009	4107731	
12319	1110	4107731	1995-08-14	1995-08-14 00:00:00	38000275	0	\N	\N	73092	0	180256009	4107731	
12409	1115	4107731	1992-02-17	1992-02-17 00:00:00	38000275	0	\N	\N	73492	0	180256009	4107731	
12641	1138	4043071	1997-10-16	1997-10-16 00:00:00	38000275	0	\N	\N	75091	0	228557008	4043071	
24732	2167	4125906	1993-08-23	1993-08-23 00:00:00	38000275	0	\N	\N	144344	0	288086009	4125906	
12994	1175	4107731	1991-11-03	1991-11-03 00:00:00	38000275	0	\N	\N	77440	0	180256009	4107731	
13257	1208	4078793	1995-11-21	1995-11-21 00:00:00	38000275	0	\N	\N	79361	0	180325003	4078793	
13336	1211	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	79591	0	180256009	4107731	
13604	1232	4125906	1993-12-12	1993-12-12 00:00:00	38000275	0	\N	\N	81185	0	288086009	4125906	
13688	1246	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	82011	0	180256009	4107731	
2038	195	4043071	1969-11-14	1969-11-14 00:00:00	38000275	0	\N	\N	13416	0	228557008	4043071	
14085	1272	4107731	1994-06-10	1994-06-10 00:00:00	38000275	0	\N	\N	83892	0	180256009	4107731	
14374	1283	4238715	1986-05-12	1986-05-12 00:00:00	38000275	0	\N	\N	84802	0	68254000	4238715	
14410	1285	4078793	2015-05-25	2015-05-25 00:00:00	38000275	0	\N	\N	84972	0	180325003	4078793	
26587	2325	4163872	1976-07-29	1976-07-29 00:00:00	38000275	0	\N	\N	154599	0	399208008	4163872	
2988	286	4125906	2019-05-23	2019-05-23 00:00:00	38000275	0	\N	\N	19048	0	288086009	4125906	
15090	1352	4323902	2000-05-28	2000-05-28 00:00:00	38000275	0	\N	\N	89558	0	429609002	4323902	
15185	1356	4107731	1995-08-10	1995-08-10 00:00:00	38000275	0	\N	\N	89932	0	180256009	4107731	
15472	1378	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	91303	0	180256009	4107731	
3713	357	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	23696	0	180256009	4107731	
15871	1397	4191853	1977-11-27	1977-11-27 00:00:00	38000275	0	\N	\N	92780	0	395142003	4191853	
4086	404	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	26566	0	180256009	4107731	
4276	411	4107731	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	27353	0	180256009	4107731	
28272	2503	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	165717	0	180256009	4107731	
16582	1441	4058899	2013-11-01	2013-11-01 00:00:00	38000275	0	\N	\N	95954	0	168594001	4058899	
16718	1447	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	96473	0	180256009	4107731	
16901	1467	4326177	2006-03-08	2006-03-08 00:00:00	38000275	0	\N	\N	97751	0	430193006	4326177	
5233	488	4170947	1977-02-02	1977-02-02 00:00:00	38000275	0	\N	\N	32699	0	274474001	4170947	
17243	1486	4107731	1991-03-03	1991-03-03 00:00:00	38000275	0	\N	\N	99109	0	180256009	4107731	
5591	512	4047491	1967-03-11	1967-03-11 00:00:00	38000275	0	\N	\N	34168	0	1225002	4047491	
17647	1513	4107731	1992-08-30	1992-08-30 00:00:00	38000275	0	\N	\N	101049	0	180256009	4107731	
5978	546	4170947	2010-05-17	2010-05-17 00:00:00	38000275	0	\N	\N	36154	0	274474001	4170947	
18003	1538	4078793	2012-05-28	2012-05-28 00:00:00	38000275	0	\N	\N	103085	0	180325003	4078793	
18277	1558	4202832	1962-06-14	1962-06-14 00:00:00	38000275	0	\N	\N	104301	0	52765003	4202832	
18478	1571	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	105522	0	180256009	4107731	
6726	610	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	40494	0	395142003	4191853	
18755	1609	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	108190	0	180256009	4107731	
18990	1622	4295880	1997-10-27	1997-10-27 00:00:00	38000275	0	\N	\N	109035	0	76601001	4295880	
31059	2758	4078793	2012-12-28	2012-12-28 00:00:00	38000275	0	\N	\N	182474	0	180325003	4078793	
7454	689	4295880	2003-11-09	2003-11-09 00:00:00	38000275	0	\N	\N	45671	0	76601001	4295880	
19498	1661	4151422	2016-08-03	2016-08-03 00:00:00	38000275	0	\N	\N	111640	0	269911007	4151422	
19668	1695	4163872	2016-11-02	2016-11-02 00:00:00	38000275	0	\N	\N	113491	0	399208008	4163872	
19957	1727	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	115548	0	180256009	4107731	
8217	754	4170947	2008-04-09	2008-04-09 00:00:00	38000275	0	\N	\N	49825	0	274474001	4170947	
8384	761	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	50640	0	180256009	4107731	
20568	1773	4107731	1993-05-09	1993-05-09 00:00:00	38000275	0	\N	\N	118511	0	180256009	4107731	
32543	2858	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	189825	0	395142003	4191853	
32869	2886	4043071	1960-09-28	1960-09-28 00:00:00	38000275	0	\N	\N	191962	0	228557008	4043071	
21022	1821	4078793	2002-09-15	2002-09-15 00:00:00	38000275	0	\N	\N	121843	0	180325003	4078793	
9331	859	4107731	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	56819	0	180256009	4107731	
21361	1848	4078793	2017-05-11	2017-05-11 00:00:00	38000275	0	\N	\N	123643	0	180325003	4078793	
33592	2925	4107731	1992-06-01	1992-06-01 00:00:00	38000275	0	\N	\N	195082	0	180256009	4107731	
9894	884	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	58848	0	180256009	4107731	
22035	1921	4125906	2016-01-19	2016-01-19 00:00:00	38000275	0	\N	\N	127793	0	288086009	4125906	
22156	1936	4275113	1968-01-16	1968-01-16 00:00:00	38000275	0	\N	\N	128806	0	65200003	4275113	
10467	940	4216130	2001-11-29	2001-11-29 00:00:00	38000275	0	\N	\N	62565	0	415070008	4216130	
22488	1971	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	131090	0	180256009	4107731	
22735	1980	4326177	1999-09-04	1999-09-04 00:00:00	38000275	0	\N	\N	131769	0	430193006	4326177	
22921	1992	4107731	1992-01-12	1992-01-12 00:00:00	38000275	0	\N	\N	132653	0	180256009	4107731	
35084	3060	4047491	1994-08-26	1994-08-26 00:00:00	38000275	0	\N	\N	203627	0	1225002	4047491	
23303	2025	4078793	2015-05-30	2015-05-30 00:00:00	38000275	0	\N	\N	134755	0	180325003	4078793	
23536	2058	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	136889	0	180256009	4107731	
11759	1083	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	71154	0	180256009	4107731	
23801	2075	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	138058	0	180256009	4107731	
162	9	4107731	1993-12-23	1993-12-23 00:00:00	38000275	0	\N	\N	776	0	180256009	4107731	
12320	1110	4191853	1983-04-24	1983-04-24 00:00:00	38000275	0	\N	\N	73088	0	395142003	4191853	
12410	1115	4107731	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	73479	0	180256009	4107731	
12642	1138	4043071	1997-12-25	1997-12-25 00:00:00	38000275	0	\N	\N	74999	0	228557008	4043071	
24733	2167	4151422	1993-07-26	1993-07-26 00:00:00	38000275	0	\N	\N	144346	0	269911007	4151422	
12995	1175	4107731	1990-09-09	1990-09-09 00:00:00	38000275	0	\N	\N	77443	0	180256009	4107731	
13258	1208	4057420	1998-12-08	1998-12-08 00:00:00	38000275	0	\N	\N	79390	0	18286008	4057420	
13337	1211	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	79512	0	180256009	4107731	
13605	1232	4151422	1989-06-30	1989-06-30 00:00:00	38000275	0	\N	\N	81171	0	269911007	4151422	
13689	1246	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	82103	0	180256009	4107731	
2039	195	4043071	1969-04-18	1969-04-18 00:00:00	38000275	0	\N	\N	13397	0	228557008	4043071	
14086	1272	4107731	1994-04-29	1994-04-29 00:00:00	38000275	0	\N	\N	83891	0	180256009	4107731	
14378	1285	4107731	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	84929	0	180256009	4107731	
14411	1285	4107731	1993-01-18	1993-01-18 00:00:00	38000275	0	\N	\N	84956	0	180256009	4107731	
26588	2325	4199276	1997-09-04	1997-09-04 00:00:00	38000275	0	\N	\N	154622	0	301807007	4199276	
2989	286	4170947	2006-10-16	2006-10-16 00:00:00	38000275	0	\N	\N	19043	0	274474001	4170947	
15091	1352	4035793	2017-01-22	2017-01-22 00:00:00	38000275	0	\N	\N	89547	0	15081005	4035793	
15186	1356	4191853	1995-02-23	1995-02-23 00:00:00	38000275	0	\N	\N	89888	0	395142003	4191853	
15473	1378	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	91414	0	180256009	4107731	
3714	357	4125906	1983-04-28	1983-04-28 00:00:00	38000275	0	\N	\N	23638	0	288086009	4125906	
15872	1397	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	92730	0	180256009	4107731	
4087	404	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	26600	0	180256009	4107731	
4277	411	4107731	1990-10-27	1990-10-27 00:00:00	38000275	0	\N	\N	27368	0	180256009	4107731	
28273	2503	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	165743	0	180256009	4107731	
16583	1441	4107731	1992-09-14	1992-09-14 00:00:00	38000275	0	\N	\N	96018	0	180256009	4107731	
16719	1447	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	96519	0	180256009	4107731	
16902	1467	4037675	2006-03-08	2006-03-08 00:00:00	38000275	0	\N	\N	97751	0	162676008	4037675	
5234	488	4151422	1988-01-17	1988-01-17 00:00:00	38000275	0	\N	\N	32624	0	269911007	4151422	
17244	1486	4107731	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	99127	0	180256009	4107731	
5592	512	4252419	1970-01-24	1970-01-24 00:00:00	38000275	0	\N	\N	34170	0	74016001	4252419	
17648	1513	4107731	1990-07-15	1990-07-15 00:00:00	38000275	0	\N	\N	101126	0	180256009	4107731	
5979	546	4195803	2010-05-17	2010-05-17 00:00:00	38000275	0	\N	\N	36154	0	312681000	4195803	
18004	1538	4151422	1938-02-21	1938-02-21 00:00:00	38000275	0	\N	\N	102951	0	269911007	4151422	
18278	1558	4163971	1962-06-14	1962-06-14 00:00:00	38000275	0	\N	\N	104301	0	45595009	4163971	
18479	1571	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	105472	0	180256009	4107731	
6727	610	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	40491	0	180256009	4107731	
18756	1609	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	108203	0	180256009	4107731	
18991	1622	4295880	1993-04-27	1993-04-27 00:00:00	38000275	0	\N	\N	108956	0	76601001	4295880	
31060	2758	4293740	1941-12-21	1941-12-21 00:00:00	38000275	0	\N	\N	182454	0	384700001	4293740	
7455	689	4295880	1997-05-18	1997-05-18 00:00:00	38000275	0	\N	\N	45637	0	76601001	4295880	
19499	1661	4078793	2009-07-23	2009-07-23 00:00:00	38000275	0	\N	\N	111680	0	180325003	4078793	
19669	1695	44783196	2003-06-26	2003-06-26 00:00:00	38000275	0	\N	\N	113481	0	699253003	44783196	
19958	1727	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	115414	0	180256009	4107731	
8218	754	4107731	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	49826	0	180256009	4107731	
8385	761	4107731	1993-12-03	1993-12-03 00:00:00	38000275	0	\N	\N	50635	0	180256009	4107731	
20569	1773	4107731	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	118525	0	180256009	4107731	
32544	2858	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	189928	0	180256009	4107731	
32870	2886	4043071	1960-08-31	1960-08-31 00:00:00	38000275	0	\N	\N	191934	0	228557008	4043071	
21023	1821	4078793	2009-10-25	2009-10-25 00:00:00	38000275	0	\N	\N	121827	0	180325003	4078793	
9332	859	4151422	1992-11-11	1992-11-11 00:00:00	38000275	0	\N	\N	56870	0	269911007	4151422	
21362	1848	4187458	2015-08-28	2015-08-28 00:00:00	38000275	0	\N	\N	123652	0	415300000	4187458	
33593	2925	4107731	1992-01-05	1992-01-05 00:00:00	38000275	0	\N	\N	195035	0	180256009	4107731	
9895	884	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	58892	0	180256009	4107731	
22036	1921	4151422	1955-02-06	1955-02-06 00:00:00	38000275	0	\N	\N	127729	0	269911007	4151422	
22157	1936	4125906	1955-08-04	1955-08-04 00:00:00	38000275	0	\N	\N	128763	0	288086009	4125906	
10468	940	4336464	2001-11-29	2001-11-29 00:00:00	38000275	0	\N	\N	62565	0	232717009	4336464	
22489	1971	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	131077	0	180256009	4107731	
22736	1980	4107731	1991-09-29	1991-09-29 00:00:00	38000275	0	\N	\N	131819	0	180256009	4107731	
22922	1992	4107731	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	132656	0	180256009	4107731	
35085	3060	4170947	1994-08-26	1994-08-26 00:00:00	38000275	0	\N	\N	203627	0	274474001	4170947	
23304	2025	4057420	2003-04-26	2003-04-26 00:00:00	38000275	0	\N	\N	134767	0	18286008	4057420	
23537	2058	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	136873	0	180256009	4107731	
11760	1083	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	71074	0	180256009	4107731	
23802	2075	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	138120	0	180256009	4107731	
163	9	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	783	0	180256009	4107731	
12321	1110	4125906	2009-08-20	2009-08-20 00:00:00	38000275	0	\N	\N	73083	0	288086009	4125906	
12411	1115	4107731	1992-12-28	1992-12-28 00:00:00	38000275	0	\N	\N	73496	0	180256009	4107731	
12643	1138	4107731	1993-02-25	1993-02-25 00:00:00	38000275	0	\N	\N	75047	0	180256009	4107731	
24734	2168	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	144422	0	180256009	4107731	
12996	1175	4107731	1991-10-13	1991-10-13 00:00:00	38000275	0	\N	\N	77500	0	180256009	4107731	
13259	1208	4057420	2004-01-06	2004-01-06 00:00:00	38000275	0	\N	\N	79385	0	18286008	4057420	
13338	1211	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	79659	0	180256009	4107731	
13608	1235	4293740	1992-12-20	1992-12-20 00:00:00	38000275	0	\N	\N	81339	0	384700001	4293740	
13690	1246	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	82164	0	180256009	4107731	
2040	195	4043071	1970-02-13	1970-02-13 00:00:00	38000275	0	\N	\N	13389	0	228557008	4043071	
14087	1272	4107731	1993-08-20	1993-08-20 00:00:00	38000275	0	\N	\N	83881	0	180256009	4107731	
14379	1285	4107731	1992-03-09	1992-03-09 00:00:00	38000275	0	\N	\N	84949	0	180256009	4107731	
14412	1285	4107731	1991-09-02	1991-09-02 00:00:00	38000275	0	\N	\N	84941	0	180256009	4107731	
26589	2325	4151422	2019-06-19	2019-06-19 00:00:00	38000275	0	\N	\N	154565	0	269911007	4151422	
2990	286	4195803	2006-10-16	2006-10-16 00:00:00	38000275	0	\N	\N	19043	0	312681000	4195803	
15092	1352	4035793	2001-04-01	2001-04-01 00:00:00	38000275	0	\N	\N	89554	0	15081005	4035793	
15187	1356	4107731	1997-06-12	1997-06-12 00:00:00	38000275	0	\N	\N	89917	0	180256009	4107731	
15474	1378	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	91329	0	180256009	4107731	
3715	357	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	23757	0	180256009	4107731	
15873	1397	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	92757	0	180256009	4107731	
4088	404	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	26574	0	180256009	4107731	
4278	411	4107731	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	27351	0	180256009	4107731	
28274	2503	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	165758	0	180256009	4107731	
16584	1441	4107731	1992-03-30	1992-03-30 00:00:00	38000275	0	\N	\N	95958	0	180256009	4107731	
16720	1447	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	96415	0	180256009	4107731	
16903	1467	4187458	2006-03-08	2006-03-08 00:00:00	38000275	0	\N	\N	97751	0	415300000	4187458	
5235	488	4170947	1969-08-13	1969-08-13 00:00:00	38000275	0	\N	\N	32698	0	274474001	4170947	
17245	1486	4107731	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	99018	0	180256009	4107731	
5593	512	44783196	1970-01-31	1970-01-31 00:00:00	38000275	0	\N	\N	34218	0	699253003	44783196	
17649	1513	4107731	1993-05-09	1993-05-09 00:00:00	38000275	0	\N	\N	101081	0	180256009	4107731	
5980	546	4047491	1944-12-08	1944-12-08 00:00:00	38000275	0	\N	\N	36148	0	1225002	4047491	
18005	1538	4107731	1992-01-06	1992-01-06 00:00:00	38000275	0	\N	\N	102959	0	180256009	4107731	
18279	1558	4163951	1962-06-14	1962-06-14 00:00:00	38000275	0	\N	\N	104301	0	29303009	4163951	
18480	1571	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	105503	0	180256009	4107731	
6728	610	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	40523	0	180256009	4107731	
18757	1609	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	108099	0	180256009	4107731	
18992	1622	4295880	2001-01-22	2001-01-22 00:00:00	38000275	0	\N	\N	109028	0	76601001	4295880	
31061	2758	4125906	1941-12-21	1941-12-21 00:00:00	38000275	0	\N	\N	182454	0	288086009	4125906	
7456	689	4295880	2001-08-12	2001-08-12 00:00:00	38000275	0	\N	\N	45668	0	76601001	4295880	
19500	1661	4151422	2017-03-31	2017-03-31 00:00:00	38000275	0	\N	\N	111694	0	269911007	4151422	
19681	1699	4151422	1973-02-26	1973-02-26 00:00:00	38000275	0	\N	\N	113605	0	269911007	4151422	
19959	1727	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	115553	0	180256009	4107731	
8219	754	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	49966	0	395142003	4191853	
8386	761	4107731	1994-04-08	1994-04-08 00:00:00	38000275	0	\N	\N	50544	0	180256009	4107731	
20570	1773	4107731	1992-06-07	1992-06-07 00:00:00	38000275	0	\N	\N	118599	0	180256009	4107731	
32545	2858	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	189826	0	180256009	4107731	
32871	2886	4043071	1960-03-23	1960-03-23 00:00:00	38000275	0	\N	\N	191964	0	228557008	4043071	
21024	1821	4078793	2010-10-31	2010-10-31 00:00:00	38000275	0	\N	\N	121846	0	180325003	4078793	
9333	859	4107731	1991-01-14	1991-01-14 00:00:00	38000275	0	\N	\N	56760	0	180256009	4107731	
21363	1848	4326177	2015-08-28	2015-08-28 00:00:00	38000275	0	\N	\N	123652	0	430193006	4326177	
33594	2925	4107731	1992-03-29	1992-03-29 00:00:00	38000275	0	\N	\N	195037	0	180256009	4107731	
9896	884	4107731	1993-08-17	1993-08-17 00:00:00	38000275	0	\N	\N	58853	0	180256009	4107731	
22037	1921	4125906	1988-07-25	1988-07-25 00:00:00	38000275	0	\N	\N	127791	0	288086009	4125906	
22158	1936	4151422	1987-02-07	1987-02-07 00:00:00	38000275	0	\N	\N	128828	0	269911007	4151422	
10469	940	4125906	1987-05-02	1987-05-02 00:00:00	38000275	0	\N	\N	62563	0	288086009	4125906	
22490	1971	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	131070	0	180256009	4107731	
22737	1980	4107731	1992-06-28	1992-06-28 00:00:00	38000275	0	\N	\N	131822	0	180256009	4107731	
22946	1998	4125906	2017-05-13	2017-05-13 00:00:00	38000275	0	\N	\N	133015	0	288086009	4125906	
35086	3060	4195803	1994-08-26	1994-08-26 00:00:00	38000275	0	\N	\N	203627	0	312681000	4195803	
23305	2025	4078793	2005-05-07	2005-05-07 00:00:00	38000275	0	\N	\N	134734	0	180325003	4078793	
23538	2058	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	136831	0	180256009	4107731	
11761	1083	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	71165	0	180256009	4107731	
23803	2075	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	138104	0	180256009	4107731	
164	9	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	819	0	180256009	4107731	
12322	1110	4107731	1996-10-07	1996-10-07 00:00:00	38000275	0	\N	\N	73062	0	180256009	4107731	
12412	1115	4125906	2007-01-09	2007-01-09 00:00:00	38000275	0	\N	\N	73389	0	288086009	4125906	
12644	1138	4107731	1993-08-12	1993-08-12 00:00:00	38000275	0	\N	\N	75041	0	180256009	4107731	
24735	2168	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	144482	0	180256009	4107731	
12997	1175	4107731	1993-03-21	1993-03-21 00:00:00	38000275	0	\N	\N	77528	0	180256009	4107731	
13260	1208	4078793	1994-11-15	1994-11-15 00:00:00	38000275	0	\N	\N	79384	0	180325003	4078793	
13412	1214	4145310	1955-12-23	1955-12-23 00:00:00	38000275	0	\N	\N	80004	0	268425006	4145310	
13609	1235	4125906	1992-12-20	1992-12-20 00:00:00	38000275	0	\N	\N	81339	0	288086009	4125906	
13691	1246	4195803	2005-07-24	2005-07-24 00:00:00	38000275	0	\N	\N	82056	0	312681000	4195803	
2041	195	4043071	1970-01-16	1970-01-16 00:00:00	38000275	0	\N	\N	13354	0	228557008	4043071	
14088	1272	4107731	1995-06-23	1995-06-23 00:00:00	38000275	0	\N	\N	83937	0	180256009	4107731	
14380	1285	4107731	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	85045	0	180256009	4107731	
14413	1285	4107731	1991-04-29	1991-04-29 00:00:00	38000275	0	\N	\N	84945	0	180256009	4107731	
26590	2325	4170947	1976-07-29	1976-07-29 00:00:00	38000275	0	\N	\N	154599	0	274474001	4170947	
2991	286	4163872	2006-10-16	2006-10-16 00:00:00	38000275	0	\N	\N	19043	0	399208008	4163872	
15093	1352	4035793	2019-02-03	2019-02-03 00:00:00	38000275	0	\N	\N	89548	0	15081005	4035793	
15188	1356	4107731	1996-08-01	1996-08-01 00:00:00	38000275	0	\N	\N	89937	0	180256009	4107731	
15475	1378	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	91370	0	180256009	4107731	
3716	357	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	23687	0	180256009	4107731	
15874	1397	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	92850	0	180256009	4107731	
4089	404	4043071	1971-11-05	1971-11-05 00:00:00	38000275	0	\N	\N	26678	0	228557008	4043071	
4279	411	4107731	1991-05-25	1991-05-25 00:00:00	38000275	0	\N	\N	27286	0	180256009	4107731	
28275	2503	4191853	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	165689	0	395142003	4191853	
16585	1441	40492359	1985-11-11	1985-11-11 00:00:00	38000275	0	\N	\N	95949	0	447365002	40492359	
16721	1447	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	96506	0	180256009	4107731	
16904	1467	4043071	1942-10-27	1942-10-27 00:00:00	38000275	0	\N	\N	97711	0	228557008	4043071	
5236	488	4243062	1969-08-13	1969-08-13 00:00:00	38000275	0	\N	\N	32698	0	60027007	4243062	
17246	1486	4107731	1993-05-09	1993-05-09 00:00:00	38000275	0	\N	\N	99053	0	180256009	4107731	
5599	515	4151422	1966-05-11	1966-05-11 00:00:00	38000275	0	\N	\N	34414	0	269911007	4151422	
17650	1513	4043071	1980-06-19	1980-06-19 00:00:00	38000275	0	\N	\N	101164	0	228557008	4043071	
5981	546	4170947	1944-12-08	1944-12-08 00:00:00	38000275	0	\N	\N	36148	0	274474001	4170947	
18006	1538	4293740	1999-07-05	1999-07-05 00:00:00	38000275	0	\N	\N	102947	0	384700001	4293740	
18281	1560	4163872	1963-04-07	1963-04-07 00:00:00	38000275	0	\N	\N	104438	0	399208008	4163872	
18481	1571	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	105504	0	180256009	4107731	
6729	613	4125906	1992-08-17	1992-08-17 00:00:00	38000275	0	\N	\N	40778	0	288086009	4125906	
18758	1609	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	108100	0	180256009	4107731	
18993	1622	4295880	1998-10-26	1998-10-26 00:00:00	38000275	0	\N	\N	109024	0	76601001	4295880	
31062	2758	4057420	2008-12-05	2008-12-05 00:00:00	38000275	0	\N	\N	182472	0	18286008	4057420	
7457	689	4295880	2002-08-11	2002-08-11 00:00:00	38000275	0	\N	\N	45643	0	76601001	4295880	
19501	1661	4078793	2013-08-15	2013-08-15 00:00:00	38000275	0	\N	\N	111706	0	180325003	4078793	
19682	1699	4170947	1979-01-25	1979-01-25 00:00:00	38000275	0	\N	\N	113627	0	274474001	4170947	
19960	1727	4125906	1952-03-14	1952-03-14 00:00:00	38000275	0	\N	\N	115413	0	288086009	4125906	
8220	754	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	49993	0	180256009	4107731	
8387	761	4107731	1994-11-04	1994-11-04 00:00:00	38000275	0	\N	\N	50624	0	180256009	4107731	
32352	2841	4058899	1981-11-01	1981-11-01 00:00:00	38000275	0	\N	\N	188633	0	168594001	4058899	
32546	2858	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	189811	0	180256009	4107731	
32872	2886	4125906	1965-05-26	1965-05-26 00:00:00	38000275	0	\N	\N	191968	0	288086009	4125906	
21025	1821	4078793	2001-09-09	2001-09-09 00:00:00	38000275	0	\N	\N	121823	0	180325003	4078793	
9334	859	4107731	1990-03-05	1990-03-05 00:00:00	38000275	0	\N	\N	56756	0	180256009	4107731	
21364	1848	4037675	2015-08-28	2015-08-28 00:00:00	38000275	0	\N	\N	123652	0	162676008	4037675	
33595	2925	4107731	1992-08-03	1992-08-03 00:00:00	38000275	0	\N	\N	195109	0	180256009	4107731	
9897	884	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	58904	0	180256009	4107731	
22041	1923	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	128018	0	180256009	4107731	
22159	1936	4238715	1972-05-26	1972-05-26 00:00:00	38000275	0	\N	\N	128755	0	68254000	4238715	
10470	940	4151422	1971-08-09	1971-08-09 00:00:00	38000275	0	\N	\N	62500	0	269911007	4151422	
22491	1971	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	131095	0	180256009	4107731	
22738	1980	4107731	1991-05-05	1991-05-05 00:00:00	38000275	0	\N	\N	131863	0	180256009	4107731	
22947	1999	4107731	2014-07-09	2014-07-09 00:00:00	38000275	0	\N	\N	133125	0	180256009	4107731	
35087	3060	4202451	2003-01-25	2003-01-25 00:00:00	38000275	0	\N	\N	203629	0	433112001	4202451	
23306	2025	4057420	1999-04-03	1999-04-03 00:00:00	38000275	0	\N	\N	134765	0	18286008	4057420	
23539	2058	4202451	2017-11-15	2017-11-15 00:00:00	38000275	0	\N	\N	136827	0	433112001	4202451	
11762	1083	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	71118	0	180256009	4107731	
23804	2075	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	138056	0	180256009	4107731	
165	9	4107731	1994-09-22	1994-09-22 00:00:00	38000275	0	\N	\N	780	0	180256009	4107731	
12323	1110	4107731	1997-05-05	1997-05-05 00:00:00	38000275	0	\N	\N	73060	0	180256009	4107731	
12413	1115	4293740	2007-01-09	2007-01-09 00:00:00	38000275	0	\N	\N	73389	0	384700001	4293740	
12645	1138	4043071	1996-04-11	1996-04-11 00:00:00	38000275	0	\N	\N	75087	0	228557008	4043071	
24736	2168	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	144561	0	180256009	4107731	
12998	1175	4191853	1989-12-31	1989-12-31 00:00:00	38000275	0	\N	\N	77451	0	395142003	4191853	
13261	1208	4078793	2000-12-19	2000-12-19 00:00:00	38000275	0	\N	\N	79391	0	180325003	4078793	
13413	1214	4151422	1944-02-07	1944-02-07 00:00:00	38000275	0	\N	\N	79946	0	269911007	4151422	
13610	1235	4198190	2009-05-19	2009-05-19 00:00:00	38000275	0	\N	\N	81342	0	80146002	4198190	
13692	1246	4170947	2005-07-24	2005-07-24 00:00:00	38000275	0	\N	\N	82056	0	274474001	4170947	
2042	195	4043071	1969-07-18	1969-07-18 00:00:00	38000275	0	\N	\N	13414	0	228557008	4043071	
14089	1272	4107731	1996-01-19	1996-01-19 00:00:00	38000275	0	\N	\N	83899	0	180256009	4107731	
14381	1285	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	84995	0	180256009	4107731	
14414	1285	4107731	1990-06-18	1990-06-18 00:00:00	38000275	0	\N	\N	84931	0	180256009	4107731	
26591	2326	4125906	2000-07-21	2000-07-21 00:00:00	38000275	0	\N	\N	154722	0	288086009	4125906	
2992	286	4151422	1943-01-01	1943-01-01 00:00:00	38000275	0	\N	\N	19052	0	269911007	4151422	
15094	1352	4035793	2010-05-23	2010-05-23 00:00:00	38000275	0	\N	\N	89544	0	15081005	4035793	
15189	1356	4107731	1995-11-02	1995-11-02 00:00:00	38000275	0	\N	\N	89910	0	180256009	4107731	
15476	1378	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	91391	0	180256009	4107731	
3717	357	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	23761	0	180256009	4107731	
15875	1397	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	92790	0	180256009	4107731	
4090	404	4043071	1971-02-19	1971-02-19 00:00:00	38000275	0	\N	\N	26657	0	228557008	4043071	
4280	411	4107731	1990-04-21	1990-04-21 00:00:00	38000275	0	\N	\N	27393	0	180256009	4107731	
28276	2503	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	165670	0	180256009	4107731	
16586	1441	4057420	1985-11-11	1985-11-11 00:00:00	38000275	0	\N	\N	95949	0	18286008	4057420	
16722	1447	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	96414	0	180256009	4107731	
16905	1467	4043071	1942-09-22	1942-09-22 00:00:00	38000275	0	\N	\N	97772	0	228557008	4043071	
17018	1476	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	98382	0	180256009	4107731	
17247	1486	4107731	1990-10-28	1990-10-28 00:00:00	38000275	0	\N	\N	99147	0	180256009	4107731	
5600	515	4170947	2012-08-02	2012-08-02 00:00:00	38000275	0	\N	\N	34392	0	274474001	4170947	
17651	1513	4107731	1990-06-24	1990-06-24 00:00:00	38000275	0	\N	\N	101140	0	180256009	4107731	
5982	546	4047491	1953-10-22	1953-10-22 00:00:00	38000275	0	\N	\N	36150	0	1225002	4047491	
18007	1538	4125906	1999-07-05	1999-07-05 00:00:00	38000275	0	\N	\N	102947	0	288086009	4125906	
18282	1560	4057420	2019-02-11	2019-02-11 00:00:00	38000275	0	\N	\N	104535	0	18286008	4057420	
18482	1571	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	105508	0	180256009	4107731	
6730	613	4145310	2007-03-07	2007-03-07 00:00:00	38000275	0	\N	\N	40696	0	268425006	4145310	
18759	1609	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	108066	0	180256009	4107731	
18994	1622	4295880	1997-07-28	1997-07-28 00:00:00	38000275	0	\N	\N	109040	0	76601001	4295880	
31063	2758	4078793	2010-12-17	2010-12-17 00:00:00	38000275	0	\N	\N	182473	0	180325003	4078793	
7458	689	4295880	1999-05-16	1999-05-16 00:00:00	38000275	0	\N	\N	45666	0	76601001	4295880	
19502	1661	4078793	2010-07-29	2010-07-29 00:00:00	38000275	0	\N	\N	111664	0	180325003	4078793	
19683	1699	4024289	1979-01-25	1979-01-25 00:00:00	38000275	0	\N	\N	113627	0	19490002	4024289	
19961	1727	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	115540	0	180256009	4107731	
8221	754	4125906	1970-01-08	1970-01-08 00:00:00	38000275	0	\N	\N	49823	0	288086009	4125906	
8388	761	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	50536	0	180256009	4107731	
32353	2841	4336464	1984-10-21	1984-10-21 00:00:00	38000275	0	\N	\N	188634	0	232717009	4336464	
32547	2858	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	189850	0	180256009	4107731	
32873	2886	4293740	1965-05-26	1965-05-26 00:00:00	38000275	0	\N	\N	191968	0	384700001	4293740	
21026	1821	4078793	2003-09-21	2003-09-21 00:00:00	38000275	0	\N	\N	121824	0	180325003	4078793	
9335	859	4107731	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	56830	0	180256009	4107731	
21365	1848	4078793	2015-04-30	2015-04-30 00:00:00	38000275	0	\N	\N	123642	0	180325003	4078793	
33596	2925	4107731	1991-07-22	1991-07-22 00:00:00	38000275	0	\N	\N	195119	0	180256009	4107731	
9898	885	4043071	1988-01-29	1988-01-29 00:00:00	38000275	0	\N	\N	59034	0	228557008	4043071	
22042	1923	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	127930	0	180256009	4107731	
22160	1937	4252419	1977-07-13	1977-07-13 00:00:00	38000275	0	\N	\N	128905	0	74016001	4252419	
22256	1950	4035793	1997-10-23	1997-10-23 00:00:00	38000275	0	\N	\N	129658	0	15081005	4035793	
22492	1971	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	131103	0	180256009	4107731	
22739	1980	4107731	1992-06-07	1992-06-07 00:00:00	38000275	0	\N	\N	131884	0	180256009	4107731	
22948	1999	4107731	2012-08-15	2012-08-15 00:00:00	38000275	0	\N	\N	133118	0	180256009	4107731	
35088	3060	4170947	1998-06-06	1998-06-06 00:00:00	38000275	0	\N	\N	203628	0	274474001	4170947	
23307	2025	4078793	1997-03-22	1997-03-22 00:00:00	38000275	0	\N	\N	134679	0	180325003	4078793	
23540	2058	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	136853	0	180256009	4107731	
11763	1083	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	71089	0	180256009	4107731	
23805	2075	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	138119	0	180256009	4107731	
166	9	4107731	1994-09-01	1994-09-01 00:00:00	38000275	0	\N	\N	754	0	180256009	4107731	
12324	1110	4107731	1996-06-24	1996-06-24 00:00:00	38000275	0	\N	\N	73096	0	180256009	4107731	
12414	1115	4107731	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	73408	0	180256009	4107731	
24498	2136	4107731	2003-03-14	2003-03-14 00:00:00	38000275	0	\N	\N	142224	0	180256009	4107731	
24737	2168	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	144569	0	180256009	4107731	
12999	1175	4107731	1990-12-23	1990-12-23 00:00:00	38000275	0	\N	\N	77436	0	180256009	4107731	
13262	1208	4078793	2001-12-25	2001-12-25 00:00:00	38000275	0	\N	\N	79354	0	180325003	4078793	
13414	1214	4163872	1985-06-06	1985-06-06 00:00:00	38000275	0	\N	\N	79900	0	399208008	4163872	
13611	1236	44783196	1967-01-04	1967-01-04 00:00:00	38000275	0	\N	\N	81480	0	699253003	44783196	
13693	1246	4243062	2005-07-24	2005-07-24 00:00:00	38000275	0	\N	\N	82056	0	60027007	4243062	
2043	195	4243062	1997-08-15	1997-08-15 00:00:00	38000275	0	\N	\N	13422	0	60027007	4243062	
14090	1272	4107731	1994-08-12	1994-08-12 00:00:00	38000275	0	\N	\N	83886	0	180256009	4107731	
14382	1285	4078793	2016-10-10	2016-10-10 00:00:00	38000275	0	\N	\N	84917	0	180325003	4078793	
14415	1285	4107731	1992-06-01	1992-06-01 00:00:00	38000275	0	\N	\N	84954	0	180256009	4107731	
26592	2326	4181917	2011-01-24	2011-01-24 00:00:00	38000275	0	\N	\N	154723	0	54550000	4181917	
14827	1314	4125906	1980-05-22	1980-05-22 00:00:00	38000275	0	\N	\N	87035	0	288086009	4125906	
15095	1352	40492359	1984-11-25	1984-11-25 00:00:00	38000275	0	\N	\N	89607	0	447365002	40492359	
15190	1356	4107731	1996-05-30	1996-05-30 00:00:00	38000275	0	\N	\N	89965	0	180256009	4107731	
15477	1378	4035793	2018-07-31	2018-07-31 00:00:00	38000275	0	\N	\N	91431	0	15081005	4035793	
3718	357	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	23728	0	180256009	4107731	
15876	1397	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	92789	0	180256009	4107731	
4091	404	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	26565	0	180256009	4107731	
4281	411	4107731	1992-06-27	1992-06-27 00:00:00	38000275	0	\N	\N	27303	0	180256009	4107731	
28277	2503	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	165744	0	180256009	4107731	
16587	1441	4107731	1992-08-24	1992-08-24 00:00:00	38000275	0	\N	\N	95971	0	180256009	4107731	
16723	1447	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	96537	0	180256009	4107731	
16906	1467	4043071	1942-06-16	1942-06-16 00:00:00	38000275	0	\N	\N	97756	0	228557008	4043071	
17019	1476	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	98358	0	180256009	4107731	
17248	1486	4107731	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	99124	0	180256009	4107731	
5601	515	4024289	2012-08-02	2012-08-02 00:00:00	38000275	0	\N	\N	34392	0	19490002	4024289	
17652	1513	4107731	1991-09-08	1991-09-08 00:00:00	38000275	0	\N	\N	101040	0	180256009	4107731	
5983	546	4170947	1953-10-22	1953-10-22 00:00:00	38000275	0	\N	\N	36150	0	274474001	4170947	
18008	1538	4107731	1991-09-02	1991-09-02 00:00:00	38000275	0	\N	\N	103063	0	180256009	4107731	
18283	1560	4078793	2018-02-05	2018-02-05 00:00:00	38000275	0	\N	\N	104471	0	180325003	4078793	
18483	1571	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	105412	0	180256009	4107731	
6731	613	4195803	2007-03-07	2007-03-07 00:00:00	38000275	0	\N	\N	40696	0	312681000	4195803	
18760	1609	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	108062	0	180256009	4107731	
18995	1622	4295880	1998-01-26	1998-01-26 00:00:00	38000275	0	\N	\N	108978	0	76601001	4295880	
31066	2760	4058899	1970-07-16	1970-07-16 00:00:00	38000275	0	\N	\N	182593	0	168594001	4058899	
7459	691	4163872	1997-04-25	1997-04-25 00:00:00	38000275	0	\N	\N	45784	0	399208008	4163872	
19503	1661	4078793	2016-08-11	2016-08-11 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
19684	1699	4125906	2004-06-10	2004-06-10 00:00:00	38000275	0	\N	\N	113615	0	288086009	4125906	
19962	1727	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	115447	0	180256009	4107731	
8222	754	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	49990	0	180256009	4107731	
8389	761	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	50539	0	180256009	4107731	
32354	2841	4216130	1984-10-21	1984-10-21 00:00:00	38000275	0	\N	\N	188634	0	415070008	4216130	
32548	2858	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	189880	0	180256009	4107731	
32874	2886	4170947	1963-06-06	1963-06-06 00:00:00	38000275	0	\N	\N	191967	0	274474001	4170947	
21027	1821	4078793	1993-09-12	1993-09-12 00:00:00	38000275	0	\N	\N	121865	0	180325003	4078793	
9336	859	4107731	1992-11-16	1992-11-16 00:00:00	38000275	0	\N	\N	56810	0	180256009	4107731	
21366	1848	4057420	2014-04-24	2014-04-24 00:00:00	38000275	0	\N	\N	123675	0	18286008	4057420	
33597	2927	4125906	2013-10-27	2013-10-27 00:00:00	38000275	0	\N	\N	195301	0	288086009	4125906	
9899	885	4043071	1988-12-09	1988-12-09 00:00:00	38000275	0	\N	\N	59036	0	228557008	4043071	
22043	1923	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	127932	0	180256009	4107731	
22161	1937	44783196	1977-07-20	1977-07-20 00:00:00	38000275	0	\N	\N	128902	0	699253003	44783196	
22257	1950	4035793	2008-12-25	2008-12-25 00:00:00	38000275	0	\N	\N	129708	0	15081005	4035793	
22493	1971	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	131074	0	180256009	4107731	
22740	1980	4107731	1990-09-16	1990-09-16 00:00:00	38000275	0	\N	\N	131861	0	180256009	4107731	
22949	1999	4107731	2012-10-17	2012-10-17 00:00:00	38000275	0	\N	\N	133096	0	180256009	4107731	
35089	3060	4047491	1998-06-06	1998-06-06 00:00:00	38000275	0	\N	\N	203628	0	1225002	4047491	
23308	2025	4078793	2013-05-04	2013-05-04 00:00:00	38000275	0	\N	\N	134712	0	180325003	4078793	
23541	2058	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	136850	0	180256009	4107731	
11764	1083	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	71095	0	180256009	4107731	
23806	2075	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	138087	0	180256009	4107731	
167	9	4107731	1994-05-19	1994-05-19 00:00:00	38000275	0	\N	\N	790	0	180256009	4107731	
12325	1110	4107731	1997-03-03	1997-03-03 00:00:00	38000275	0	\N	\N	73035	0	180256009	4107731	
12415	1115	4107731	1990-04-16	1990-04-16 00:00:00	38000275	0	\N	\N	73347	0	180256009	4107731	
24499	2138	4243062	1966-09-07	1966-09-07 00:00:00	38000275	0	\N	\N	142412	0	60027007	4243062	
24738	2168	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	144526	0	180256009	4107731	
13000	1175	4043071	1953-09-26	1953-09-26 00:00:00	38000275	0	\N	\N	77416	0	228557008	4043071	
13263	1208	4078793	2007-01-23	2007-01-23 00:00:00	38000275	0	\N	\N	79363	0	180325003	4078793	
13415	1214	4125906	1979-04-03	1979-04-03 00:00:00	38000275	0	\N	\N	80007	0	288086009	4125906	
13612	1236	4047491	2005-12-08	2005-12-08 00:00:00	38000275	0	\N	\N	81489	0	1225002	4047491	
13694	1246	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	82020	0	180256009	4107731	
2044	195	4170947	1997-08-15	1997-08-15 00:00:00	38000275	0	\N	\N	13422	0	274474001	4170947	
14091	1272	4107731	1995-01-06	1995-01-06 00:00:00	38000275	0	\N	\N	83965	0	180256009	4107731	
14383	1285	4191853	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	84976	0	395142003	4191853	
14416	1285	4107731	1991-07-22	1991-07-22 00:00:00	38000275	0	\N	\N	84940	0	180256009	4107731	
26593	2326	4125906	1985-02-23	1985-02-23 00:00:00	38000275	0	\N	\N	154671	0	288086009	4125906	
14828	1314	4151422	1977-07-01	1977-07-01 00:00:00	38000275	0	\N	\N	87008	0	269911007	4151422	
15096	1352	4035793	2012-06-03	2012-06-03 00:00:00	38000275	0	\N	\N	89545	0	15081005	4035793	
15191	1356	4107731	1998-08-06	1998-08-06 00:00:00	38000275	0	\N	\N	89904	0	180256009	4107731	
15478	1378	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	91403	0	180256009	4107731	
3719	357	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	23724	0	180256009	4107731	
15877	1397	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	92794	0	180256009	4107731	
4092	404	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	26603	0	180256009	4107731	
4282	411	4107731	1991-04-13	1991-04-13 00:00:00	38000275	0	\N	\N	27398	0	180256009	4107731	
28278	2503	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	165751	0	180256009	4107731	
16588	1441	4163872	1976-10-08	1976-10-08 00:00:00	38000275	0	\N	\N	96029	0	399208008	4163872	
16724	1447	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	96417	0	180256009	4107731	
16907	1467	4043071	1943-04-06	1943-04-06 00:00:00	38000275	0	\N	\N	97773	0	228557008	4043071	
17020	1476	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	98478	0	180256009	4107731	
17249	1486	4107731	1990-07-15	1990-07-15 00:00:00	38000275	0	\N	\N	99107	0	180256009	4107731	
5602	515	4195803	2012-08-02	2012-08-02 00:00:00	38000275	0	\N	\N	34392	0	312681000	4195803	
17653	1513	4107731	1991-10-20	1991-10-20 00:00:00	38000275	0	\N	\N	101045	0	180256009	4107731	
5984	546	4170947	1961-10-10	1961-10-10 00:00:00	38000275	0	\N	\N	36151	0	274474001	4170947	
18009	1538	4107731	1992-12-07	1992-12-07 00:00:00	38000275	0	\N	\N	103029	0	180256009	4107731	
18284	1560	4047491	2017-01-29	2017-01-29 00:00:00	38000275	0	\N	\N	104435	0	1225002	4047491	
18484	1571	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	105502	0	180256009	4107731	
6732	613	4195803	2016-05-27	2016-05-27 00:00:00	38000275	0	\N	\N	40683	0	312681000	4195803	
18761	1609	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	108209	0	180256009	4107731	
18996	1622	4295880	1996-04-29	1996-04-29 00:00:00	38000275	0	\N	\N	109004	0	76601001	4295880	
31067	2760	4186930	1977-03-24	1977-03-24 00:00:00	38000275	0	\N	\N	182612	0	46706006	4186930	
7460	691	4195803	2019-06-20	2019-06-20 00:00:00	38000275	0	\N	\N	45788	0	312681000	4195803	
19504	1661	4078793	2018-04-12	2018-04-12 00:00:00	38000275	0	\N	\N	111675	0	180325003	4078793	
19685	1699	4293740	2011-03-27	2011-03-27 00:00:00	38000275	0	\N	\N	113617	0	384700001	4293740	
19963	1727	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	115541	0	180256009	4107731	
8223	754	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	49944	0	180256009	4107731	
8390	761	4107731	1994-03-18	1994-03-18 00:00:00	38000275	0	\N	\N	50646	0	180256009	4107731	
32355	2841	4170947	1986-10-06	1986-10-06 00:00:00	38000275	0	\N	\N	188635	0	274474001	4170947	
32549	2858	4125906	2018-04-12	2018-04-12 00:00:00	38000275	0	\N	\N	189896	0	288086009	4125906	
32875	2886	4024289	1963-06-06	1963-06-06 00:00:00	38000275	0	\N	\N	191967	0	19490002	4024289	
21028	1821	4078793	2017-02-26	2017-02-26 00:00:00	38000275	0	\N	\N	121848	0	180325003	4078793	
9337	859	4107731	1990-06-18	1990-06-18 00:00:00	38000275	0	\N	\N	56827	0	180256009	4107731	
21367	1848	4078793	2013-04-18	2013-04-18 00:00:00	38000275	0	\N	\N	123646	0	180325003	4078793	
33598	2927	4170947	2010-09-13	2010-09-13 00:00:00	38000275	0	\N	\N	195300	0	274474001	4170947	
9900	885	4043071	1987-10-02	1987-10-02 00:00:00	38000275	0	\N	\N	58970	0	228557008	4043071	
22044	1923	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	127865	0	180256009	4107731	
22162	1937	4125906	1969-12-08	1969-12-08 00:00:00	38000275	0	\N	\N	128904	0	288086009	4125906	
22258	1950	4035793	2012-01-12	2012-01-12 00:00:00	38000275	0	\N	\N	129663	0	15081005	4035793	
22494	1971	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	131041	0	180256009	4107731	
22741	1980	4107731	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	131867	0	180256009	4107731	
22950	1999	4107731	2011-11-16	2011-11-16 00:00:00	38000275	0	\N	\N	133055	0	180256009	4107731	
35090	3060	4195803	1998-06-06	1998-06-06 00:00:00	38000275	0	\N	\N	203628	0	312681000	4195803	
23309	2025	4078793	2001-04-14	2001-04-14 00:00:00	38000275	0	\N	\N	134766	0	180325003	4078793	
23542	2058	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	136875	0	180256009	4107731	
11765	1083	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	71094	0	180256009	4107731	
23807	2075	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	138082	0	180256009	4107731	
168	9	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	818	0	180256009	4107731	
12326	1110	4107731	1997-02-10	1997-02-10 00:00:00	38000275	0	\N	\N	73098	0	180256009	4107731	
12416	1115	4107731	1992-06-22	1992-06-22 00:00:00	38000275	0	\N	\N	73466	0	180256009	4107731	
24500	2138	4170947	1966-09-07	1966-09-07 00:00:00	38000275	0	\N	\N	142412	0	274474001	4170947	
24739	2168	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	144483	0	180256009	4107731	
13001	1175	4107731	1991-11-24	1991-11-24 00:00:00	38000275	0	\N	\N	77501	0	180256009	4107731	
13264	1208	4078793	2002-12-31	2002-12-31 00:00:00	38000275	0	\N	\N	79392	0	180325003	4078793	
13416	1214	4125906	1969-10-01	1969-10-01 00:00:00	38000275	0	\N	\N	80006	0	288086009	4125906	
13613	1236	4195803	2005-12-08	2005-12-08 00:00:00	38000275	0	\N	\N	81489	0	312681000	4195803	
13695	1246	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	82050	0	180256009	4107731	
2045	195	4043071	1969-08-15	1969-08-15 00:00:00	38000275	0	\N	\N	13398	0	228557008	4043071	
14092	1272	4107731	1995-12-29	1995-12-29 00:00:00	38000275	0	\N	\N	83926	0	180256009	4107731	
14384	1285	4107731	1992-10-05	1992-10-05 00:00:00	38000275	0	\N	\N	85042	0	180256009	4107731	
14417	1285	4107731	1990-02-12	1990-02-12 00:00:00	38000275	0	\N	\N	84987	0	180256009	4107731	
26594	2326	4293740	1985-02-23	1985-02-23 00:00:00	38000275	0	\N	\N	154671	0	384700001	4293740	
14829	1314	4151422	1998-10-04	1998-10-04 00:00:00	38000275	0	\N	\N	87050	0	269911007	4151422	
15097	1352	4035793	2013-06-09	2013-06-09 00:00:00	38000275	0	\N	\N	89579	0	15081005	4035793	
15192	1356	4151422	1988-11-04	1988-11-04 00:00:00	38000275	0	\N	\N	89875	0	269911007	4151422	
15479	1378	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	91296	0	180256009	4107731	
3720	357	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	23754	0	180256009	4107731	
15878	1397	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	92775	0	180256009	4107731	
4093	404	4043071	1970-08-14	1970-08-14 00:00:00	38000275	0	\N	\N	26629	0	228557008	4043071	
4283	411	4107731	1990-06-23	1990-06-23 00:00:00	38000275	0	\N	\N	27314	0	180256009	4107731	
28279	2503	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	165741	0	180256009	4107731	
16589	1441	4107731	1993-01-18	1993-01-18 00:00:00	38000275	0	\N	\N	96008	0	180256009	4107731	
16725	1447	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	96471	0	180256009	4107731	
16908	1467	4043071	1943-03-09	1943-03-09 00:00:00	38000275	0	\N	\N	97698	0	228557008	4043071	
17021	1476	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	98359	0	180256009	4107731	
17250	1486	4107731	1991-06-16	1991-06-16 00:00:00	38000275	0	\N	\N	99149	0	180256009	4107731	
5603	515	4202451	2014-05-24	2014-05-24 00:00:00	38000275	0	\N	\N	34401	0	433112001	4202451	
17654	1513	4043071	1980-01-24	1980-01-24 00:00:00	38000275	0	\N	\N	101155	0	228557008	4043071	
17821	1528	4170947	2007-02-24	2007-02-24 00:00:00	38000275	0	\N	\N	102241	0	274474001	4170947	
18010	1538	4078793	2014-06-09	2014-06-09 00:00:00	38000275	0	\N	\N	103086	0	180325003	4078793	
18285	1560	4170947	2017-01-29	2017-01-29 00:00:00	38000275	0	\N	\N	104435	0	274474001	4170947	
18485	1571	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	105430	0	180256009	4107731	
18514	1571	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	105436	0	180256009	4107731	
18762	1609	4151422	1984-06-19	1984-06-19 00:00:00	38000275	0	\N	\N	108179	0	269911007	4151422	
18997	1622	4295880	1996-07-29	1996-07-29 00:00:00	38000275	0	\N	\N	108975	0	76601001	4295880	
31068	2760	4151422	1972-10-07	1972-10-07 00:00:00	38000275	0	\N	\N	182551	0	269911007	4151422	
7461	691	4058899	2019-06-20	2019-06-20 00:00:00	38000275	0	\N	\N	45788	0	168594001	4058899	
19510	1666	4151422	1971-02-10	1971-02-10 00:00:00	38000275	0	\N	\N	111912	0	269911007	4151422	
19686	1699	4125906	2011-03-27	2011-03-27 00:00:00	38000275	0	\N	\N	113617	0	288086009	4125906	
19964	1727	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	115559	0	180256009	4107731	
8224	754	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	49933	0	180256009	4107731	
8391	761	4191853	1995-06-23	1995-06-23 00:00:00	38000275	0	\N	\N	50626	0	395142003	4191853	
32356	2841	4243062	1986-10-06	1986-10-06 00:00:00	38000275	0	\N	\N	188635	0	60027007	4243062	
32550	2858	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	189890	0	180256009	4107731	
32876	2886	4163872	1956-12-10	1956-12-10 00:00:00	38000275	0	\N	\N	191958	0	399208008	4163872	
21029	1821	4078793	2014-11-23	2014-11-23 00:00:00	38000275	0	\N	\N	121871	0	180325003	4078793	
9338	859	4107731	1991-02-25	1991-02-25 00:00:00	38000275	0	\N	\N	56835	0	180256009	4107731	
21369	1850	4163872	1999-02-20	1999-02-20 00:00:00	38000275	0	\N	\N	123729	0	399208008	4163872	
33599	2927	4024289	2010-09-13	2010-09-13 00:00:00	38000275	0	\N	\N	195300	0	19490002	4024289	
9901	885	4058899	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	58981	0	168594001	4058899	
22045	1923	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	127929	0	180256009	4107731	
22163	1937	4293740	1969-12-08	1969-12-08 00:00:00	38000275	0	\N	\N	128904	0	384700001	4293740	
22259	1950	4035793	1987-01-15	1987-01-15 00:00:00	38000275	0	\N	\N	129680	0	15081005	4035793	
22495	1971	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	130998	0	180256009	4107731	
22742	1980	4107731	1991-07-07	1991-07-07 00:00:00	38000275	0	\N	\N	131850	0	180256009	4107731	
22951	1999	4107731	2013-03-13	2013-03-13 00:00:00	38000275	0	\N	\N	133145	0	180256009	4107731	
35091	3060	44783196	1945-09-12	1945-09-12 00:00:00	38000275	0	\N	\N	203625	0	699253003	44783196	
23310	2025	4078793	1998-03-28	1998-03-28 00:00:00	38000275	0	\N	\N	134647	0	180325003	4078793	
23543	2058	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	136891	0	180256009	4107731	
11766	1083	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	71111	0	180256009	4107731	
23808	2075	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	138100	0	180256009	4107731	
169	9	4107731	1993-08-19	1993-08-19 00:00:00	38000275	0	\N	\N	787	0	180256009	4107731	
12327	1110	4107731	1996-08-05	1996-08-05 00:00:00	38000275	0	\N	\N	73057	0	180256009	4107731	
12417	1115	4107731	1992-06-01	1992-06-01 00:00:00	38000275	0	\N	\N	73481	0	180256009	4107731	
24501	2138	4195803	1966-09-07	1966-09-07 00:00:00	38000275	0	\N	\N	142412	0	312681000	4195803	
24740	2168	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	144552	0	180256009	4107731	
13002	1175	4107731	1990-12-02	1990-12-02 00:00:00	38000275	0	\N	\N	77496	0	180256009	4107731	
13265	1208	4078793	1997-12-02	1997-12-02 00:00:00	38000275	0	\N	\N	79352	0	180325003	4078793	
13417	1214	4293740	1969-10-01	1969-10-01 00:00:00	38000275	0	\N	\N	80006	0	384700001	4293740	
13614	1236	4170947	2005-12-08	2005-12-08 00:00:00	38000275	0	\N	\N	81489	0	274474001	4170947	
13696	1246	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	82119	0	180256009	4107731	
2046	195	4043071	1969-09-12	1969-09-12 00:00:00	38000275	0	\N	\N	13353	0	228557008	4043071	
14093	1272	4107731	1995-10-06	1995-10-06 00:00:00	38000275	0	\N	\N	83968	0	180256009	4107731	
14385	1285	4107731	1991-11-25	1991-11-25 00:00:00	38000275	0	\N	\N	85038	0	180256009	4107731	
14418	1285	4078793	2014-05-19	2014-05-19 00:00:00	38000275	0	\N	\N	84966	0	180325003	4078793	
26595	2326	4125906	1966-11-16	1966-11-16 00:00:00	38000275	0	\N	\N	154670	0	288086009	4125906	
14830	1315	4125906	2010-02-21	2010-02-21 00:00:00	38000275	0	\N	\N	87108	0	288086009	4125906	
15098	1352	4035793	2006-04-30	2006-04-30 00:00:00	38000275	0	\N	\N	89542	0	15081005	4035793	
15193	1356	4107731	1997-05-22	1997-05-22 00:00:00	38000275	0	\N	\N	89970	0	180256009	4107731	
15480	1378	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	91304	0	180256009	4107731	
3721	357	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	23712	0	180256009	4107731	
15879	1397	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	92813	0	180256009	4107731	
4094	404	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	26635	0	180256009	4107731	
4284	411	4107731	1993-05-29	1993-05-29 00:00:00	38000275	0	\N	\N	27260	0	180256009	4107731	
28280	2503	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	165721	0	180256009	4107731	
16590	1441	4107731	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	95992	0	180256009	4107731	
16726	1447	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	96535	0	180256009	4107731	
16909	1467	4043071	1942-05-19	1942-05-19 00:00:00	38000275	0	\N	\N	97710	0	228557008	4043071	
17022	1476	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	98460	0	180256009	4107731	
17251	1486	4107731	1992-11-01	1992-11-01 00:00:00	38000275	0	\N	\N	99126	0	180256009	4107731	
5604	515	44783196	1976-11-20	1976-11-20 00:00:00	38000275	0	\N	\N	34393	0	699253003	44783196	
17655	1513	4107731	1991-12-22	1991-12-22 00:00:00	38000275	0	\N	\N	101075	0	180256009	4107731	
17822	1528	4047491	2007-02-24	2007-02-24 00:00:00	38000275	0	\N	\N	102241	0	1225002	4047491	
18011	1538	4107731	1992-09-14	1992-09-14 00:00:00	38000275	0	\N	\N	103093	0	180256009	4107731	
18286	1560	4195803	2017-01-29	2017-01-29 00:00:00	38000275	0	\N	\N	104435	0	312681000	4195803	
18486	1571	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	105420	0	180256009	4107731	
18515	1571	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	105475	0	180256009	4107731	
18763	1609	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	108184	0	180256009	4107731	
18998	1622	4295880	1997-01-27	1997-01-27 00:00:00	38000275	0	\N	\N	109034	0	76601001	4295880	
31069	2760	4238715	1979-05-24	1979-05-24 00:00:00	38000275	0	\N	\N	182541	0	68254000	4238715	
7480	693	4252419	1999-09-04	1999-09-04 00:00:00	38000275	0	\N	\N	45894	0	74016001	4252419	
19511	1666	4125906	1977-01-28	1977-01-28 00:00:00	38000275	0	\N	\N	111878	0	288086009	4125906	
19687	1699	4151422	1995-02-06	1995-02-06 00:00:00	38000275	0	\N	\N	113649	0	269911007	4151422	
19965	1727	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	115515	0	180256009	4107731	
8225	754	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	49961	0	180256009	4107731	
8392	761	4107731	1994-11-25	1994-11-25 00:00:00	38000275	0	\N	\N	50610	0	180256009	4107731	
32357	2842	4058899	1964-08-24	1964-08-24 00:00:00	38000275	0	\N	\N	188647	0	168594001	4058899	
32551	2858	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	189786	0	180256009	4107731	
32877	2886	4043071	1960-10-26	1960-10-26 00:00:00	38000275	0	\N	\N	191895	0	228557008	4043071	
21030	1821	4078793	1987-08-09	1987-08-09 00:00:00	38000275	0	\N	\N	121862	0	180325003	4078793	
9339	859	4107731	1990-02-12	1990-02-12 00:00:00	38000275	0	\N	\N	56818	0	180256009	4107731	
21370	1850	4010253	1971-03-30	1971-03-30 00:00:00	38000275	0	\N	\N	123751	0	112790001	4010253	
33600	2927	4195803	2010-09-13	2010-09-13 00:00:00	38000275	0	\N	\N	195300	0	312681000	4195803	
9902	885	4043071	1988-11-11	1988-11-11 00:00:00	38000275	0	\N	\N	59017	0	228557008	4043071	
22046	1923	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	127882	0	180256009	4107731	
22164	1937	4293740	1979-07-10	1979-07-10 00:00:00	38000275	0	\N	\N	128906	0	384700001	4293740	
22260	1950	4035793	2018-02-22	2018-02-22 00:00:00	38000275	0	\N	\N	129666	0	15081005	4035793	
22496	1971	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	131045	0	180256009	4107731	
22743	1980	4107731	1990-06-03	1990-06-03 00:00:00	38000275	0	\N	\N	131783	0	180256009	4107731	
22952	1999	4107731	2013-04-03	2013-04-03 00:00:00	38000275	0	\N	\N	133120	0	180256009	4107731	
35092	3060	4047491	2012-03-29	2012-03-29 00:00:00	38000275	0	\N	\N	203631	0	1225002	4047491	
23311	2025	4202451	2009-05-30	2009-05-30 00:00:00	38000275	0	\N	\N	134745	0	433112001	4202451	
23544	2058	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	136910	0	180256009	4107731	
11767	1083	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	71162	0	180256009	4107731	
23809	2075	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	138110	0	180256009	4107731	
170	9	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	808	0	180256009	4107731	
12328	1110	4107731	1997-09-08	1997-09-08 00:00:00	38000275	0	\N	\N	73046	0	180256009	4107731	
12418	1115	4107731	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	73446	0	180256009	4107731	
24502	2138	4125906	2012-08-18	2012-08-18 00:00:00	38000275	0	\N	\N	142416	0	288086009	4125906	
24741	2168	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	144538	0	180256009	4107731	
13003	1175	4107731	1990-03-04	1990-03-04 00:00:00	38000275	0	\N	\N	77551	0	180256009	4107731	
13266	1209	44783196	2004-09-23	2004-09-23 00:00:00	38000275	0	\N	\N	79459	0	699253003	44783196	
13418	1214	4125906	1945-10-27	1945-10-27 00:00:00	38000275	0	\N	\N	80002	0	288086009	4125906	
13615	1236	4195803	2010-07-29	2010-07-29 00:00:00	38000275	0	\N	\N	81448	0	312681000	4195803	
13697	1246	4024289	1969-09-26	1969-09-26 00:00:00	38000275	0	\N	\N	82052	0	19490002	4024289	
2047	195	4043071	1969-05-16	1969-05-16 00:00:00	38000275	0	\N	\N	13388	0	228557008	4043071	
14094	1272	4107731	1993-11-12	1993-11-12 00:00:00	38000275	0	\N	\N	83880	0	180256009	4107731	
14386	1285	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	84959	0	180256009	4107731	
14419	1285	4107731	1992-08-24	1992-08-24 00:00:00	38000275	0	\N	\N	85041	0	180256009	4107731	
26596	2327	4125906	1995-04-19	1995-04-19 00:00:00	38000275	0	\N	\N	154728	0	288086009	4125906	
14831	1315	4125906	1974-10-14	1974-10-14 00:00:00	38000275	0	\N	\N	87107	0	288086009	4125906	
15099	1352	4035793	2018-01-28	2018-01-28 00:00:00	38000275	0	\N	\N	89575	0	15081005	4035793	
15194	1356	4107731	1997-05-01	1997-05-01 00:00:00	38000275	0	\N	\N	89949	0	180256009	4107731	
15481	1378	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	91416	0	180256009	4107731	
3722	357	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	23742	0	180256009	4107731	
15880	1397	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	92814	0	180256009	4107731	
4095	404	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	26578	0	180256009	4107731	
4285	411	4107731	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	27288	0	180256009	4107731	
28281	2503	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	165718	0	180256009	4107731	
16591	1441	4107731	1992-11-16	1992-11-16 00:00:00	38000275	0	\N	\N	95973	0	180256009	4107731	
16727	1447	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	96465	0	180256009	4107731	
16910	1467	4043071	1942-12-29	1942-12-29 00:00:00	38000275	0	\N	\N	97758	0	228557008	4043071	
17023	1476	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	98445	0	180256009	4107731	
17252	1486	4107731	1993-02-14	1993-02-14 00:00:00	38000275	0	\N	\N	99051	0	180256009	4107731	
5605	515	4252419	1976-11-13	1976-11-13 00:00:00	38000275	0	\N	\N	34389	0	74016001	4252419	
17656	1513	4107731	1991-06-16	1991-06-16 00:00:00	38000275	0	\N	\N	101038	0	180256009	4107731	
17823	1528	4293740	2004-05-26	2004-05-26 00:00:00	38000275	0	\N	\N	102240	0	384700001	4293740	
18012	1538	4078793	2008-09-15	2008-09-15 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
18320	1563	4125906	1975-10-12	1975-10-12 00:00:00	38000275	0	\N	\N	104745	0	288086009	4125906	
18487	1571	4197460	1958-04-12	1958-04-12 00:00:00	38000275	0	\N	\N	105389	0	313191000	4197460	
18516	1571	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	105485	0	180256009	4107731	
18764	1609	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	108175	0	180256009	4107731	
18999	1622	4295880	1994-05-02	1994-05-02 00:00:00	38000275	0	\N	\N	108959	0	76601001	4295880	
31070	2760	4275113	1972-03-23	1972-03-23 00:00:00	38000275	0	\N	\N	182564	0	65200003	4275113	
19308	1655	4151422	1989-08-28	1989-08-28 00:00:00	38000275	0	\N	\N	110992	0	269911007	4151422	
19512	1666	4125906	1953-01-20	1953-01-20 00:00:00	38000275	0	\N	\N	111877	0	288086009	4125906	
19688	1699	4058899	1968-12-18	1968-12-18 00:00:00	38000275	0	\N	\N	113626	0	168594001	4058899	
19966	1727	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	115563	0	180256009	4107731	
8226	754	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	49969	0	180256009	4107731	
8393	761	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	50570	0	180256009	4107731	
32358	2842	4163872	1973-01-10	1973-01-10 00:00:00	38000275	0	\N	\N	188644	0	399208008	4163872	
32552	2858	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	189879	0	180256009	4107731	
32878	2886	4043071	1960-07-27	1960-07-27 00:00:00	38000275	0	\N	\N	191957	0	228557008	4043071	
21031	1821	4078793	2000-09-03	2000-09-03 00:00:00	38000275	0	\N	\N	121866	0	180325003	4078793	
9340	859	4107731	1990-12-03	1990-12-03 00:00:00	38000275	0	\N	\N	56759	0	180256009	4107731	
21371	1850	4125906	1976-09-26	1976-09-26 00:00:00	38000275	0	\N	\N	123734	0	288086009	4125906	
33601	2927	4151422	1950-05-06	1950-05-06 00:00:00	38000275	0	\N	\N	195258	0	269911007	4151422	
9903	885	4043071	1988-04-01	1988-04-01 00:00:00	38000275	0	\N	\N	59004	0	228557008	4043071	
22047	1923	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	128010	0	180256009	4107731	
22165	1937	4125906	1979-07-10	1979-07-10 00:00:00	38000275	0	\N	\N	128906	0	288086009	4125906	
22261	1950	4035793	2006-12-14	2006-12-14 00:00:00	38000275	0	\N	\N	129660	0	15081005	4035793	
22497	1971	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	131101	0	180256009	4107731	
22744	1980	4107731	1992-08-30	1992-08-30 00:00:00	38000275	0	\N	\N	131764	0	180256009	4107731	
22953	1999	4107731	2015-02-25	2015-02-25 00:00:00	38000275	0	\N	\N	133127	0	180256009	4107731	
35093	3060	4195803	2012-03-29	2012-03-29 00:00:00	38000275	0	\N	\N	203631	0	312681000	4195803	
23312	2025	4125906	1963-04-02	1963-04-02 00:00:00	38000275	0	\N	\N	134738	0	288086009	4125906	
23545	2058	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	136859	0	180256009	4107731	
11768	1083	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	71160	0	180256009	4107731	
23810	2075	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	138105	0	180256009	4107731	
171	9	4125906	2011-01-10	2011-01-10 00:00:00	38000275	0	\N	\N	865	0	288086009	4125906	
12329	1110	4107731	1996-05-13	1996-05-13 00:00:00	38000275	0	\N	\N	73095	0	180256009	4107731	
12419	1115	4107731	1991-11-25	1991-11-25 00:00:00	38000275	0	\N	\N	73490	0	180256009	4107731	
24503	2138	4163872	1999-12-27	1999-12-27 00:00:00	38000275	0	\N	\N	142378	0	399208008	4163872	
24742	2168	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	144480	0	180256009	4107731	
13004	1175	4107731	1993-04-11	1993-04-11 00:00:00	38000275	0	\N	\N	77517	0	180256009	4107731	
13267	1209	4252419	2004-09-16	2004-09-16 00:00:00	38000275	0	\N	\N	79458	0	74016001	4252419	
13419	1214	4125906	2012-05-14	2012-05-14 00:00:00	38000275	0	\N	\N	79990	0	288086009	4125906	
13616	1236	4058899	2012-01-06	2012-01-06 00:00:00	38000275	0	\N	\N	81490	0	168594001	4058899	
13698	1246	4170947	1969-09-26	1969-09-26 00:00:00	38000275	0	\N	\N	82052	0	274474001	4170947	
2048	195	4043071	1969-12-12	1969-12-12 00:00:00	38000275	0	\N	\N	13399	0	228557008	4043071	
14095	1272	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	83879	0	180256009	4107731	
14387	1285	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	84960	0	180256009	4107731	
14420	1285	4107731	1992-10-26	1992-10-26 00:00:00	38000275	0	\N	\N	84951	0	180256009	4107731	
26597	2327	4293740	1995-04-19	1995-04-19 00:00:00	38000275	0	\N	\N	154728	0	384700001	4293740	
14832	1315	4151422	1973-02-09	1973-02-09 00:00:00	38000275	0	\N	\N	87115	0	269911007	4151422	
15100	1352	4035793	1998-06-28	1998-06-28 00:00:00	38000275	0	\N	\N	89572	0	15081005	4035793	
15195	1356	4107731	1997-02-06	1997-02-06 00:00:00	38000275	0	\N	\N	89938	0	180256009	4107731	
15482	1378	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	91299	0	180256009	4107731	
3723	357	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	23710	0	180256009	4107731	
15881	1397	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	92852	0	180256009	4107731	
4096	404	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	26637	0	180256009	4107731	
4286	411	4107731	1993-02-13	1993-02-13 00:00:00	38000275	0	\N	\N	27305	0	180256009	4107731	
28282	2503	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	165757	0	180256009	4107731	
16592	1441	4107731	1992-10-26	1992-10-26 00:00:00	38000275	0	\N	\N	96019	0	180256009	4107731	
16728	1447	4197460	1970-08-23	1970-08-23 00:00:00	38000275	0	\N	\N	96481	0	313191000	4197460	
16911	1467	4043071	1943-06-01	1943-06-01 00:00:00	38000275	0	\N	\N	97669	0	228557008	4043071	
17024	1476	4202451	2011-05-26	2011-05-26 00:00:00	38000275	0	\N	\N	98421	0	433112001	4202451	
17253	1486	4107731	1992-06-07	1992-06-07 00:00:00	38000275	0	\N	\N	99017	0	180256009	4107731	
17392	1497	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	99854	0	180256009	4107731	
17657	1513	4107731	1992-02-23	1992-02-23 00:00:00	38000275	0	\N	\N	101146	0	180256009	4107731	
17824	1528	4125906	2004-05-26	2004-05-26 00:00:00	38000275	0	\N	\N	102240	0	288086009	4125906	
18013	1538	4107731	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	102986	0	180256009	4107731	
18321	1563	4062501	1977-06-25	1977-06-25 00:00:00	38000275	0	\N	\N	104703	0	171231001	4062501	
18488	1571	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	105459	0	180256009	4107731	
18517	1571	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	105496	0	180256009	4107731	
18765	1609	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	108205	0	180256009	4107731	
19000	1622	4295880	1994-01-31	1994-01-31 00:00:00	38000275	0	\N	\N	109001	0	76601001	4295880	
31071	2761	4151422	1982-09-08	1982-09-08 00:00:00	38000275	0	\N	\N	182646	0	269911007	4151422	
19309	1655	4151422	1990-11-03	1990-11-03 00:00:00	38000275	0	\N	\N	111029	0	269911007	4151422	
19513	1666	4243062	1982-06-22	1982-06-22 00:00:00	38000275	0	\N	\N	111879	0	60027007	4243062	
19690	1702	4125906	2016-08-22	2016-08-22 00:00:00	38000275	0	\N	\N	113805	0	288086009	4125906	
19967	1727	4163971	1982-03-25	1982-03-25 00:00:00	38000275	0	\N	\N	115482	0	45595009	4163971	
8227	754	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	49972	0	180256009	4107731	
8394	761	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	50639	0	180256009	4107731	
32359	2842	4043071	1971-10-20	1971-10-20 00:00:00	38000275	0	\N	\N	188701	0	228557008	4043071	
32553	2858	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	189922	0	180256009	4107731	
32879	2886	4062501	1954-12-17	1954-12-17 00:00:00	38000275	0	\N	\N	191891	0	171231001	4062501	
21032	1821	4078793	1998-10-11	1998-10-11 00:00:00	38000275	0	\N	\N	121822	0	180325003	4078793	
9341	859	4107731	1991-04-08	1991-04-08 00:00:00	38000275	0	\N	\N	56889	0	180256009	4107731	
21372	1850	4151422	1973-10-17	1973-10-17 00:00:00	38000275	0	\N	\N	123752	0	269911007	4151422	
33602	2927	4163872	1983-03-09	1983-03-09 00:00:00	38000275	0	\N	\N	195295	0	399208008	4163872	
9904	885	4043071	1987-08-28	1987-08-28 00:00:00	38000275	0	\N	\N	58969	0	228557008	4043071	
22048	1923	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	128017	0	180256009	4107731	
22166	1937	4170947	1968-10-14	1968-10-14 00:00:00	38000275	0	\N	\N	128903	0	274474001	4170947	
22262	1950	4323902	2002-01-31	2002-01-31 00:00:00	38000275	0	\N	\N	129643	0	429609002	4323902	
22498	1971	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	131082	0	180256009	4107731	
22745	1980	4107731	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	131780	0	180256009	4107731	
22954	1999	4107731	2014-12-24	2014-12-24 00:00:00	38000275	0	\N	\N	133138	0	180256009	4107731	
35094	3060	4170947	2012-03-29	2012-03-29 00:00:00	38000275	0	\N	\N	203631	0	274474001	4170947	
23313	2025	4078793	2019-06-22	2019-06-22 00:00:00	38000275	0	\N	\N	134757	0	180325003	4078793	
23546	2058	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	136855	0	180256009	4107731	
11769	1083	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	71173	0	395142003	4191853	
23811	2075	4197460	1967-04-24	1967-04-24 00:00:00	38000275	0	\N	\N	137999	0	313191000	4197460	
172	9	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	842	0	180256009	4107731	
12330	1110	4107731	1996-03-11	1996-03-11 00:00:00	38000275	0	\N	\N	73105	0	180256009	4107731	
12420	1115	4107731	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	73465	0	180256009	4107731	
24504	2138	4125906	1995-03-09	1995-03-09 00:00:00	38000275	0	\N	\N	142414	0	288086009	4125906	
24743	2168	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	144556	0	180256009	4107731	
13005	1175	4191853	1993-07-04	1993-07-04 00:00:00	38000275	0	\N	\N	77538	0	395142003	4191853	
13268	1209	4170947	1984-04-04	1984-04-04 00:00:00	38000275	0	\N	\N	79456	0	274474001	4170947	
13420	1214	4125906	1987-02-11	1987-02-11 00:00:00	38000275	0	\N	\N	79988	0	288086009	4125906	
13617	1236	4252419	1939-10-16	1939-10-16 00:00:00	38000275	0	\N	\N	81482	0	74016001	4252419	
13699	1246	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	82004	0	180256009	4107731	
2049	195	4043071	1969-10-10	1969-10-10 00:00:00	38000275	0	\N	\N	13415	0	228557008	4043071	
14096	1272	4151422	1986-11-08	1986-11-08 00:00:00	38000275	0	\N	\N	83865	0	269911007	4151422	
14388	1285	4107731	1992-08-03	1992-08-03 00:00:00	38000275	0	\N	\N	85047	0	180256009	4107731	
14421	1285	4107731	1992-01-27	1992-01-27 00:00:00	38000275	0	\N	\N	84948	0	180256009	4107731	
26598	2327	4170947	1958-10-11	1958-10-11 00:00:00	38000275	0	\N	\N	154725	0	274474001	4170947	
14833	1315	4252419	1962-05-29	1962-05-29 00:00:00	38000275	0	\N	\N	87105	0	74016001	4252419	
15101	1352	4035793	1999-03-21	1999-03-21 00:00:00	38000275	0	\N	\N	89541	0	15081005	4035793	
15196	1356	4107731	1996-12-05	1996-12-05 00:00:00	38000275	0	\N	\N	89916	0	180256009	4107731	
15483	1378	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	91367	0	180256009	4107731	
3724	357	4197460	1955-09-08	1955-09-08 00:00:00	38000275	0	\N	\N	23633	0	313191000	4197460	
15882	1397	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	92851	0	180256009	4107731	
4097	404	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	26599	0	180256009	4107731	
4287	411	4163872	2012-03-25	2012-03-25 00:00:00	38000275	0	\N	\N	27338	0	399208008	4163872	
28283	2503	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	165664	0	180256009	4107731	
16593	1441	4107731	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	96062	0	180256009	4107731	
16729	1447	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	96504	0	180256009	4107731	
16912	1467	4043071	1942-11-24	1942-11-24 00:00:00	38000275	0	\N	\N	97757	0	228557008	4043071	
17025	1476	4078793	2009-12-31	2009-12-31 00:00:00	38000275	0	\N	\N	98340	0	180325003	4078793	
17254	1486	4107731	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	99150	0	180256009	4107731	
17393	1497	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	99815	0	180256009	4107731	
17658	1513	4107731	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	101050	0	180256009	4107731	
17825	1529	4170947	1974-10-02	1974-10-02 00:00:00	38000275	0	\N	\N	102354	0	274474001	4170947	
18014	1538	4107731	1991-11-25	1991-11-25 00:00:00	38000275	0	\N	\N	103065	0	180256009	4107731	
18322	1563	4010253	2018-05-31	2018-05-31 00:00:00	38000275	0	\N	\N	104743	0	112790001	4010253	
18489	1571	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	105525	0	180256009	4107731	
18518	1571	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	105532	0	180256009	4107731	
18766	1609	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	108067	0	180256009	4107731	
19001	1622	4295880	2002-01-21	2002-01-21 00:00:00	38000275	0	\N	\N	108982	0	76601001	4295880	
31095	2764	4295880	1996-04-26	1996-04-26 00:00:00	38000275	0	\N	\N	182755	0	76601001	4295880	
19310	1655	4062501	2004-09-29	2004-09-29 00:00:00	38000275	0	\N	\N	110995	0	171231001	4062501	
19514	1666	4170947	1982-06-22	1982-06-22 00:00:00	38000275	0	\N	\N	111879	0	274474001	4170947	
19691	1702	4170947	1979-07-08	1979-07-08 00:00:00	38000275	0	\N	\N	113794	0	274474001	4170947	
19968	1727	42535580	1982-03-24	1982-03-24 00:00:00	38000275	0	\N	\N	115482	0	426701000119108	42535580	
8228	754	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	49943	0	180256009	4107731	
8395	761	4125906	1994-04-25	1994-04-25 00:00:00	38000275	0	\N	\N	50523	0	288086009	4125906	
32360	2842	4151422	1995-04-23	1995-04-23 00:00:00	38000275	0	\N	\N	188697	0	269911007	4151422	
32554	2858	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	189804	0	180256009	4107731	
32883	2889	4198190	2017-03-07	2017-03-07 00:00:00	38000275	0	\N	\N	192188	0	80146002	4198190	
21033	1821	4078793	1997-10-05	1997-10-05 00:00:00	38000275	0	\N	\N	121786	0	180325003	4078793	
9342	859	4107731	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	56832	0	180256009	4107731	
21373	1850	4170947	1961-12-23	1961-12-23 00:00:00	38000275	0	\N	\N	123732	0	274474001	4170947	
33603	2927	4170947	1983-03-09	1983-03-09 00:00:00	38000275	0	\N	\N	195295	0	274474001	4170947	
9905	885	4043071	1988-07-01	1988-07-01 00:00:00	38000275	0	\N	\N	59035	0	228557008	4043071	
22049	1923	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	127991	0	180256009	4107731	
22167	1937	4243062	1968-10-14	1968-10-14 00:00:00	38000275	0	\N	\N	128903	0	60027007	4243062	
22263	1950	4035793	1994-10-06	1994-10-06 00:00:00	38000275	0	\N	\N	129682	0	15081005	4035793	
22499	1971	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	131094	0	180256009	4107731	
22746	1980	4107731	1993-05-09	1993-05-09 00:00:00	38000275	0	\N	\N	131792	0	180256009	4107731	
22955	1999	4107731	2014-01-01	2014-01-01 00:00:00	38000275	0	\N	\N	133133	0	180256009	4107731	
35095	3060	4151422	1928-07-23	1928-07-23 00:00:00	38000275	0	\N	\N	203568	0	269911007	4151422	
23314	2025	4057420	2016-06-04	2016-06-04 00:00:00	38000275	0	\N	\N	134735	0	18286008	4057420	
23547	2058	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	136854	0	180256009	4107731	
11770	1083	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	71141	0	180256009	4107731	
23812	2075	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	138063	0	180256009	4107731	
173	9	4191853	1995-01-26	1995-01-26 00:00:00	38000275	0	\N	\N	845	0	395142003	4191853	
12331	1110	4107731	1998-06-08	1998-06-08 00:00:00	38000275	0	\N	\N	73049	0	180256009	4107731	
12421	1115	4107731	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	73410	0	180256009	4107731	
24505	2138	4198190	1976-10-06	1976-10-06 00:00:00	38000275	0	\N	\N	142417	0	80146002	4198190	
24744	2168	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	144522	0	180256009	4107731	
13006	1175	4107731	1990-10-21	1990-10-21 00:00:00	38000275	0	\N	\N	77444	0	180256009	4107731	
13269	1209	4243062	1984-04-04	1984-04-04 00:00:00	38000275	0	\N	\N	79456	0	60027007	4243062	
13421	1215	4243062	1998-09-19	1998-09-19 00:00:00	38000275	0	\N	\N	80039	0	60027007	4243062	
13618	1236	4151422	1979-01-23	1979-01-23 00:00:00	38000275	0	\N	\N	81464	0	269911007	4151422	
13700	1246	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	82123	0	180256009	4107731	
2050	195	4043071	1969-06-13	1969-06-13 00:00:00	38000275	0	\N	\N	13413	0	228557008	4043071	
14097	1272	4107731	1995-04-21	1995-04-21 00:00:00	38000275	0	\N	\N	83896	0	180256009	4107731	
14389	1285	4107731	1992-03-30	1992-03-30 00:00:00	38000275	0	\N	\N	85044	0	180256009	4107731	
14422	1285	4107731	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	85018	0	180256009	4107731	
26599	2327	4243062	1958-10-11	1958-10-11 00:00:00	38000275	0	\N	\N	154725	0	60027007	4243062	
14834	1315	4125906	1964-05-25	1964-05-25 00:00:00	38000275	0	\N	\N	87106	0	288086009	4125906	
15102	1352	4035793	2015-03-22	2015-03-22 00:00:00	38000275	0	\N	\N	89546	0	15081005	4035793	
15197	1357	4243062	1982-05-24	1982-05-24 00:00:00	38000275	0	\N	\N	90033	0	60027007	4243062	
15484	1378	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	91390	0	180256009	4107731	
3725	357	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	23726	0	180256009	4107731	
15883	1397	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	92786	0	180256009	4107731	
4098	404	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	26591	0	180256009	4107731	
4288	411	4107731	1990-05-12	1990-05-12 00:00:00	38000275	0	\N	\N	27313	0	180256009	4107731	
28284	2503	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	165750	0	180256009	4107731	
16594	1441	4107731	1990-03-05	1990-03-05 00:00:00	38000275	0	\N	\N	95981	0	180256009	4107731	
16730	1447	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	96470	0	180256009	4107731	
16913	1467	4151422	1988-07-19	1988-07-19 00:00:00	38000275	0	\N	\N	97717	0	269911007	4151422	
17026	1476	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	98464	0	180256009	4107731	
17255	1486	4107731	1990-11-18	1990-11-18 00:00:00	38000275	0	\N	\N	99032	0	180256009	4107731	
17394	1497	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	99853	0	180256009	4107731	
17659	1513	4043071	1980-03-27	1980-03-27 00:00:00	38000275	0	\N	\N	101133	0	228557008	4043071	
17826	1529	4243062	1974-10-02	1974-10-02 00:00:00	38000275	0	\N	\N	102354	0	60027007	4243062	
18015	1538	4107731	1993-02-08	1993-02-08 00:00:00	38000275	0	\N	\N	102965	0	180256009	4107731	
18323	1563	4151422	1976-04-06	1976-04-06 00:00:00	38000275	0	\N	\N	104676	0	269911007	4151422	
18490	1571	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	105524	0	180256009	4107731	
18519	1571	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	105414	0	180256009	4107731	
18767	1609	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	108093	0	180256009	4107731	
19002	1622	4295880	1998-04-27	1998-04-27 00:00:00	38000275	0	\N	\N	109041	0	76601001	4295880	
31096	2764	4295880	1994-04-29	1994-04-29 00:00:00	38000275	0	\N	\N	182806	0	76601001	4295880	
19311	1655	4125906	2002-09-18	2002-09-18 00:00:00	38000275	0	\N	\N	110988	0	288086009	4125906	
19515	1666	4170947	1941-11-19	1941-11-19 00:00:00	38000275	0	\N	\N	111876	0	274474001	4170947	
19692	1702	4163872	1979-07-08	1979-07-08 00:00:00	38000275	0	\N	\N	113794	0	399208008	4163872	
19969	1727	4202832	1982-03-25	1982-03-25 00:00:00	38000275	0	\N	\N	115482	0	52765003	4202832	
20010	1727	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	115552	0	180256009	4107731	
8396	761	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	50571	0	180256009	4107731	
32361	2842	4043071	1971-12-22	1971-12-22 00:00:00	38000275	0	\N	\N	188696	0	228557008	4043071	
32555	2859	4047491	1969-08-22	1969-08-22 00:00:00	38000275	0	\N	\N	190014	0	1225002	4047491	
32884	2890	4243062	1970-08-23	1970-08-23 00:00:00	38000275	0	\N	\N	192211	0	60027007	4243062	
21034	1821	4125906	1978-08-02	1978-08-02 00:00:00	38000275	0	\N	\N	121774	0	288086009	4125906	
9343	859	4107731	1992-08-24	1992-08-24 00:00:00	38000275	0	\N	\N	56841	0	180256009	4107731	
21374	1850	4243062	1961-12-23	1961-12-23 00:00:00	38000275	0	\N	\N	123732	0	60027007	4243062	
33604	2927	4151422	1945-04-10	1945-04-10 00:00:00	38000275	0	\N	\N	195275	0	269911007	4151422	
9906	885	4043071	1988-02-26	1988-02-26 00:00:00	38000275	0	\N	\N	59003	0	228557008	4043071	
22050	1923	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	128014	0	180256009	4107731	
22168	1937	4151422	1980-12-12	1980-12-12 00:00:00	38000275	0	\N	\N	128873	0	269911007	4151422	
22264	1950	4035793	1999-11-04	1999-11-04 00:00:00	38000275	0	\N	\N	129618	0	15081005	4035793	
22500	1971	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	131056	0	180256009	4107731	
22747	1980	4163872	1985-03-22	1985-03-22 00:00:00	38000275	0	\N	\N	131880	0	399208008	4163872	
22956	1999	4107731	2011-12-28	2011-12-28 00:00:00	38000275	0	\N	\N	133085	0	180256009	4107731	
35096	3060	4252419	1945-09-05	1945-09-05 00:00:00	38000275	0	\N	\N	203626	0	74016001	4252419	
23315	2025	4078793	1989-02-04	1989-02-04 00:00:00	38000275	0	\N	\N	134762	0	180325003	4078793	
23548	2058	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	136903	0	180256009	4107731	
11771	1083	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	71075	0	180256009	4107731	
23813	2075	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	138086	0	180256009	4107731	
174	9	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	811	0	180256009	4107731	
12332	1110	4107731	1995-06-12	1995-06-12 00:00:00	38000275	0	\N	\N	73102	0	180256009	4107731	
12422	1115	4107731	1992-03-30	1992-03-30 00:00:00	38000275	0	\N	\N	73464	0	180256009	4107731	
24506	2138	4058899	1959-08-15	1959-08-15 00:00:00	38000275	0	\N	\N	142411	0	168594001	4058899	
24745	2168	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	144539	0	180256009	4107731	
13007	1175	4107731	1991-07-21	1991-07-21 00:00:00	38000275	0	\N	\N	77447	0	180256009	4107731	
13270	1211	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	79523	0	180256009	4107731	
13422	1215	4170947	1998-09-19	1998-09-19 00:00:00	38000275	0	\N	\N	80039	0	274474001	4170947	
13619	1236	4125906	1978-11-02	1978-11-02 00:00:00	38000275	0	\N	\N	81485	0	288086009	4125906	
13701	1246	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	82003	0	180256009	4107731	
2051	196	4058899	1966-06-15	1966-06-15 00:00:00	38000275	0	\N	\N	13449	0	168594001	4058899	
14098	1272	4107731	1994-04-08	1994-04-08 00:00:00	38000275	0	\N	\N	83883	0	180256009	4107731	
14390	1285	4107731	1992-12-28	1992-12-28 00:00:00	38000275	0	\N	\N	84975	0	180256009	4107731	
14423	1285	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	85050	0	180256009	4107731	
26600	2327	4125906	1967-12-23	1967-12-23 00:00:00	38000275	0	\N	\N	154726	0	288086009	4125906	
14835	1315	44783196	1962-06-05	1962-06-05 00:00:00	38000275	0	\N	\N	87081	0	699253003	44783196	
15103	1352	4035793	2014-06-15	2014-06-15 00:00:00	38000275	0	\N	\N	89557	0	15081005	4035793	
15198	1357	4170947	1982-05-24	1982-05-24 00:00:00	38000275	0	\N	\N	90033	0	274474001	4170947	
15485	1378	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	91364	0	180256009	4107731	
3726	357	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	23727	0	180256009	4107731	
15884	1397	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	92758	0	180256009	4107731	
4099	404	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	26698	0	180256009	4107731	
4289	411	4107731	1991-06-15	1991-06-15 00:00:00	38000275	0	\N	\N	27370	0	180256009	4107731	
28285	2503	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	165756	0	180256009	4107731	
16595	1441	4107731	1990-10-01	1990-10-01 00:00:00	38000275	0	\N	\N	95989	0	180256009	4107731	
16731	1447	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	96448	0	180256009	4107731	
16914	1467	4043071	1943-02-02	1943-02-02 00:00:00	38000275	0	\N	\N	97697	0	228557008	4043071	
17027	1476	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	98392	0	180256009	4107731	
17256	1486	4107731	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	99119	0	180256009	4107731	
17395	1497	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	99879	0	180256009	4107731	
17660	1513	4107731	1990-02-18	1990-02-18 00:00:00	38000275	0	\N	\N	101167	0	180256009	4107731	
17827	1529	4024289	1967-07-06	1967-07-06 00:00:00	38000275	0	\N	\N	102352	0	19490002	4024289	
18016	1538	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	103095	0	180256009	4107731	
30108	2662	4252419	2002-07-05	2002-07-05 00:00:00	38000275	0	\N	\N	176431	0	74016001	4252419	
18491	1571	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	105499	0	180256009	4107731	
18520	1571	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	105495	0	180256009	4107731	
18768	1609	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	108106	0	180256009	4107731	
19003	1623	4151422	2019-01-19	2019-01-19 00:00:00	38000275	0	\N	\N	109092	0	269911007	4151422	
31097	2764	4295880	1992-07-25	1992-07-25 00:00:00	38000275	0	\N	\N	182786	0	76601001	4295880	
19312	1656	4295880	2013-09-07	2013-09-07 00:00:00	38000275	0	\N	\N	111143	0	76601001	4295880	
19516	1666	4024289	1941-11-19	1941-11-19 00:00:00	38000275	0	\N	\N	111876	0	19490002	4024289	
19693	1702	4151422	2003-09-27	2003-09-27 00:00:00	38000275	0	\N	\N	113804	0	269911007	4151422	
19970	1727	4163951	1982-03-24	1982-03-24 00:00:00	38000275	0	\N	\N	115482	0	29303009	4163951	
20011	1727	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	115468	0	180256009	4107731	
8397	761	4107731	1995-03-31	1995-03-31 00:00:00	38000275	0	\N	\N	50528	0	180256009	4107731	
32362	2842	4125906	1979-11-09	1979-11-09 00:00:00	38000275	0	\N	\N	188708	0	288086009	4125906	
32556	2859	4170947	1969-08-22	1969-08-22 00:00:00	38000275	0	\N	\N	190014	0	274474001	4170947	
32885	2890	4170947	1970-08-23	1970-08-23 00:00:00	38000275	0	\N	\N	192211	0	274474001	4170947	
21035	1821	4125906	1955-09-19	1955-09-19 00:00:00	38000275	0	\N	\N	121771	0	288086009	4125906	
9344	859	4107731	1992-06-22	1992-06-22 00:00:00	38000275	0	\N	\N	56866	0	180256009	4107731	
21375	1850	4293740	1963-01-17	1963-01-17 00:00:00	38000275	0	\N	\N	123733	0	384700001	4293740	
33605	2927	4145310	1987-05-17	1987-05-17 00:00:00	38000275	0	\N	\N	195296	0	268425006	4145310	
9907	885	4043071	1989-02-17	1989-02-17 00:00:00	38000275	0	\N	\N	58985	0	228557008	4043071	
22051	1923	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	127879	0	180256009	4107731	
22181	1941	4170947	1981-11-21	1981-11-21 00:00:00	38000275	0	\N	\N	129099	0	274474001	4170947	
22265	1950	4035793	1989-01-19	1989-01-19 00:00:00	38000275	0	\N	\N	129616	0	15081005	4035793	
22501	1971	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	131068	0	180256009	4107731	
22748	1980	4107731	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	131887	0	180256009	4107731	
22957	1999	4107731	2013-11-20	2013-11-20 00:00:00	38000275	0	\N	\N	133132	0	180256009	4107731	
46975	4116	44783196	1996-11-06	1996-11-06 00:00:00	38000275	0	\N	\N	273679	0	699253003	44783196	
23316	2025	4078793	2000-04-08	2000-04-08 00:00:00	38000275	0	\N	\N	134779	0	180325003	4078793	
23549	2058	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	136801	0	180256009	4107731	
11772	1083	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	71156	0	180256009	4107731	
23814	2075	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	138026	0	180256009	4107731	
175	9	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	841	0	180256009	4107731	
12333	1110	4107731	1997-11-10	1997-11-10 00:00:00	38000275	0	\N	\N	73073	0	180256009	4107731	
12423	1115	4107731	1991-12-16	1991-12-16 00:00:00	38000275	0	\N	\N	73363	0	180256009	4107731	
24509	2140	4043071	1962-07-01	1962-07-01 00:00:00	38000275	0	\N	\N	142559	0	228557008	4043071	
24746	2168	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	144559	0	180256009	4107731	
13008	1175	4043071	1953-11-28	1953-11-28 00:00:00	38000275	0	\N	\N	77407	0	228557008	4043071	
13271	1211	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	79622	0	180256009	4107731	
13423	1215	4202451	1993-05-08	1993-05-08 00:00:00	38000275	0	\N	\N	80045	0	433112001	4202451	
13620	1236	4125906	1999-03-31	1999-03-31 00:00:00	38000275	0	\N	\N	81487	0	288086009	4125906	
13702	1246	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	82100	0	180256009	4107731	
2052	196	4125906	1985-03-10	1985-03-10 00:00:00	38000275	0	\N	\N	13526	0	288086009	4125906	
14099	1272	4107731	1994-09-23	1994-09-23 00:00:00	38000275	0	\N	\N	83934	0	180256009	4107731	
14391	1285	4107731	1991-02-04	1991-02-04 00:00:00	38000275	0	\N	\N	84943	0	180256009	4107731	
14424	1285	4107731	1990-05-07	1990-05-07 00:00:00	38000275	0	\N	\N	84930	0	180256009	4107731	
26601	2327	4125906	2001-05-15	2001-05-15 00:00:00	38000275	0	\N	\N	154730	0	288086009	4125906	
14836	1316	4195803	2018-09-27	2018-09-27 00:00:00	38000275	0	\N	\N	87224	0	312681000	4195803	
15104	1352	4035793	2004-04-18	2004-04-18 00:00:00	38000275	0	\N	\N	89578	0	15081005	4035793	
15199	1357	4151422	1980-03-18	1980-03-18 00:00:00	38000275	0	\N	\N	90022	0	269911007	4151422	
15486	1378	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	91301	0	180256009	4107731	
3727	357	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	23707	0	180256009	4107731	
15885	1397	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	92849	0	180256009	4107731	
4100	404	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	26625	0	180256009	4107731	
4290	411	4107731	1990-12-29	1990-12-29 00:00:00	38000275	0	\N	\N	27315	0	180256009	4107731	
28286	2503	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	165698	0	180256009	4107731	
16596	1441	4151422	1993-10-10	1993-10-10 00:00:00	38000275	0	\N	\N	96050	0	269911007	4151422	
16732	1447	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	96447	0	180256009	4107731	
16915	1467	4043071	1942-08-18	1942-08-18 00:00:00	38000275	0	\N	\N	97771	0	228557008	4043071	
17028	1476	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	98341	0	180256009	4107731	
17257	1486	4107731	1993-03-28	1993-03-28 00:00:00	38000275	0	\N	\N	99052	0	180256009	4107731	
17396	1497	4197460	1941-05-09	1941-05-09 00:00:00	38000275	0	\N	\N	99778	0	313191000	4197460	
17661	1513	4107731	1992-08-09	1992-08-09 00:00:00	38000275	0	\N	\N	101077	0	180256009	4107731	
17828	1529	4170947	1967-07-06	1967-07-06 00:00:00	38000275	0	\N	\N	102352	0	274474001	4170947	
18017	1538	4078793	2011-05-23	2011-05-23 00:00:00	38000275	0	\N	\N	103015	0	180325003	4078793	
30109	2662	4293740	2000-09-29	2000-09-29 00:00:00	38000275	0	\N	\N	176430	0	384700001	4293740	
18492	1571	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	105439	0	180256009	4107731	
18521	1571	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	105417	0	180256009	4107731	
18769	1609	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	108204	0	180256009	4107731	
19004	1623	4151422	2006-08-08	2006-08-08 00:00:00	38000275	0	\N	\N	109087	0	269911007	4151422	
31098	2764	4295880	1993-04-30	1993-04-30 00:00:00	38000275	0	\N	\N	182787	0	76601001	4295880	
19313	1656	4295880	2006-03-18	2006-03-18 00:00:00	38000275	0	\N	\N	111156	0	76601001	4295880	
19522	1669	4035793	2015-04-20	2015-04-20 00:00:00	38000275	0	\N	\N	112107	0	15081005	4035793	
19694	1702	4125906	1976-09-30	1976-09-30 00:00:00	38000275	0	\N	\N	113793	0	288086009	4125906	
19971	1727	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	115498	0	180256009	4107731	
20012	1727	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	115429	0	180256009	4107731	
8398	761	4107731	1993-10-22	1993-10-22 00:00:00	38000275	0	\N	\N	50634	0	180256009	4107731	
32363	2842	4043071	1971-11-17	1971-11-17 00:00:00	38000275	0	\N	\N	188695	0	228557008	4043071	
32557	2859	4010253	1967-06-27	1967-06-27 00:00:00	38000275	0	\N	\N	190024	0	112790001	4010253	
32886	2890	4151422	1985-01-08	1985-01-08 00:00:00	38000275	0	\N	\N	192201	0	269911007	4151422	
21036	1821	4057420	1994-09-18	1994-09-18 00:00:00	38000275	0	\N	\N	121869	0	18286008	4057420	
9345	859	4107731	1991-11-04	1991-11-04 00:00:00	38000275	0	\N	\N	56864	0	180256009	4107731	
21376	1850	4125906	1963-01-17	1963-01-17 00:00:00	38000275	0	\N	\N	123733	0	288086009	4125906	
33617	2929	44783196	1990-10-29	1990-10-29 00:00:00	38000275	0	\N	\N	195382	0	699253003	44783196	
9908	885	4043071	1987-05-15	1987-05-15 00:00:00	38000275	0	\N	\N	58973	0	228557008	4043071	
22052	1923	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	128007	0	180256009	4107731	
22182	1941	4024289	1981-11-21	1981-11-21 00:00:00	38000275	0	\N	\N	129099	0	19490002	4024289	
22266	1950	4035793	2004-12-02	2004-12-02 00:00:00	38000275	0	\N	\N	129659	0	15081005	4035793	
22502	1971	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	130989	0	395142003	4191853	
22749	1980	4107731	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	131765	0	180256009	4107731	
22958	1999	4107731	2012-02-29	2012-02-29 00:00:00	38000275	0	\N	\N	133076	0	180256009	4107731	
46976	4116	4125906	1994-03-01	1994-03-01 00:00:00	38000275	0	\N	\N	273676	0	288086009	4125906	
23317	2025	4057420	1975-11-22	1975-11-22 00:00:00	38000275	0	\N	\N	134759	0	18286008	4057420	
23550	2058	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	136887	0	180256009	4107731	
11773	1083	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	71158	0	180256009	4107731	
23815	2075	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	138094	0	180256009	4107731	
176	9	4107731	1993-09-09	1993-09-09 00:00:00	38000275	0	\N	\N	739	0	180256009	4107731	
12334	1110	4107731	1995-04-10	1995-04-10 00:00:00	38000275	0	\N	\N	73029	0	180256009	4107731	
12424	1115	4191853	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	73497	0	395142003	4191853	
24510	2140	4043071	1963-06-09	1963-06-09 00:00:00	38000275	0	\N	\N	142503	0	228557008	4043071	
24747	2168	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	144543	0	180256009	4107731	
13009	1175	4107731	1991-03-17	1991-03-17 00:00:00	38000275	0	\N	\N	77438	0	180256009	4107731	
13272	1211	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	79522	0	395142003	4191853	
13424	1215	4125906	1999-12-13	1999-12-13 00:00:00	38000275	0	\N	\N	80040	0	288086009	4125906	
13621	1236	4252419	1966-12-28	1966-12-28 00:00:00	38000275	0	\N	\N	81484	0	74016001	4252419	
13703	1246	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	82044	0	180256009	4107731	
2053	196	4163872	1967-07-29	1967-07-29 00:00:00	38000275	0	\N	\N	13441	0	399208008	4163872	
14100	1272	4191853	1980-05-24	1980-05-24 00:00:00	38000275	0	\N	\N	83864	0	395142003	4191853	
14392	1285	4163872	1996-04-27	1996-04-27 00:00:00	38000275	0	\N	\N	84928	0	399208008	4163872	
14425	1285	4107731	1992-11-16	1992-11-16 00:00:00	38000275	0	\N	\N	84974	0	180256009	4107731	
26602	2327	4125906	1996-04-27	1996-04-27 00:00:00	38000275	0	\N	\N	154729	0	288086009	4125906	
14837	1316	4170947	2018-09-27	2018-09-27 00:00:00	38000275	0	\N	\N	87224	0	274474001	4170947	
15105	1352	4035793	2002-04-07	2002-04-07 00:00:00	38000275	0	\N	\N	89577	0	15081005	4035793	
15200	1357	4243062	1984-06-12	1984-06-12 00:00:00	38000275	0	\N	\N	90034	0	60027007	4243062	
15487	1378	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	91375	0	180256009	4107731	
3728	357	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	23656	0	180256009	4107731	
15886	1397	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	92788	0	180256009	4107731	
4101	404	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	26671	0	180256009	4107731	
4291	411	4107731	1992-10-10	1992-10-10 00:00:00	38000275	0	\N	\N	27258	0	180256009	4107731	
28287	2503	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	165716	0	180256009	4107731	
16597	1441	4107731	1993-03-01	1993-03-01 00:00:00	38000275	0	\N	\N	96009	0	180256009	4107731	
16733	1447	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	96445	0	395142003	4191853	
16916	1468	4078793	2016-06-08	2016-06-08 00:00:00	38000275	0	\N	\N	97847	0	180325003	4078793	
17029	1476	4078793	2009-10-15	2009-10-15 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
17258	1486	4107731	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	99116	0	180256009	4107731	
17397	1497	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	99772	0	180256009	4107731	
17662	1513	4107731	1992-06-07	1992-06-07 00:00:00	38000275	0	\N	\N	101043	0	180256009	4107731	
17933	1532	4151422	2014-05-04	2014-05-04 00:00:00	38000275	0	\N	\N	102610	0	269911007	4151422	
18018	1538	4107731	1992-02-17	1992-02-17 00:00:00	38000275	0	\N	\N	102960	0	180256009	4107731	
30110	2662	4125906	2000-09-29	2000-09-29 00:00:00	38000275	0	\N	\N	176430	0	288086009	4125906	
18493	1571	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	105457	0	180256009	4107731	
18522	1571	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	105528	0	180256009	4107731	
18770	1609	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	108181	0	180256009	4107731	
19005	1626	4163951	1989-12-17	1989-12-17 00:00:00	38000275	0	\N	\N	109189	0	29303009	4163951	
31099	2764	4295880	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	182793	0	76601001	4295880	
19314	1656	4295880	2004-09-15	2004-09-15 00:00:00	38000275	0	\N	\N	111057	0	76601001	4295880	
19523	1669	4035793	2008-03-10	2008-03-10 00:00:00	38000275	0	\N	\N	112080	0	15081005	4035793	
19695	1702	4293740	1976-09-30	1976-09-30 00:00:00	38000275	0	\N	\N	113793	0	384700001	4293740	
19972	1727	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	115424	0	180256009	4107731	
20013	1727	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	115546	0	180256009	4107731	
8399	761	4107731	1994-01-14	1994-01-14 00:00:00	38000275	0	\N	\N	50636	0	180256009	4107731	
32364	2842	4151422	1982-06-19	1982-06-19 00:00:00	38000275	0	\N	\N	188649	0	269911007	4151422	
32558	2859	4151422	1944-01-08	1944-01-08 00:00:00	38000275	0	\N	\N	189962	0	269911007	4151422	
32887	2891	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	192382	0	180256009	4107731	
21037	1821	4057420	1990-08-26	1990-08-26 00:00:00	38000275	0	\N	\N	121796	0	18286008	4057420	
9346	859	4107731	1992-08-03	1992-08-03 00:00:00	38000275	0	\N	\N	56867	0	180256009	4107731	
21377	1851	4181917	1988-12-05	1988-12-05 00:00:00	38000275	0	\N	\N	123828	0	54550000	4181917	
33618	2929	4252419	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	195377	0	74016001	4252419	
9909	885	4043071	1988-06-03	1988-06-03 00:00:00	38000275	0	\N	\N	59016	0	228557008	4043071	
22053	1923	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	127995	0	180256009	4107731	
22183	1941	4043071	1986-12-31	1986-12-31 00:00:00	38000275	0	\N	\N	129035	0	228557008	4043071	
22267	1950	4035793	2005-12-08	2005-12-08 00:00:00	38000275	0	\N	\N	129662	0	15081005	4035793	
22503	1971	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	131060	0	180256009	4107731	
22750	1980	4191853	1975-10-10	1975-10-10 00:00:00	38000275	0	\N	\N	131877	0	395142003	4191853	
22959	1999	4107731	2014-11-12	2014-11-12 00:00:00	38000275	0	\N	\N	133137	0	180256009	4107731	
46977	4116	4252419	1996-10-30	1996-10-30 00:00:00	38000275	0	\N	\N	273677	0	74016001	4252419	
23318	2025	4078793	1988-01-30	1988-01-30 00:00:00	38000275	0	\N	\N	134777	0	180325003	4078793	
23551	2058	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	136804	0	180256009	4107731	
11774	1083	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	71167	0	180256009	4107731	
23816	2075	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	138125	0	180256009	4107731	
177	9	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	734	0	180256009	4107731	
12335	1110	4107731	1997-09-29	1997-09-29 00:00:00	38000275	0	\N	\N	73072	0	180256009	4107731	
12425	1115	4107731	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	73445	0	180256009	4107731	
24511	2140	4043071	1963-02-03	1963-02-03 00:00:00	38000275	0	\N	\N	142527	0	228557008	4043071	
24748	2168	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	144413	0	180256009	4107731	
13010	1175	4107731	1991-12-15	1991-12-15 00:00:00	38000275	0	\N	\N	77504	0	180256009	4107731	
13273	1211	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	79656	0	180256009	4107731	
13425	1216	4170947	1973-03-10	1973-03-10 00:00:00	38000275	0	\N	\N	80068	0	274474001	4170947	
13622	1236	4125906	1938-11-06	1938-11-06 00:00:00	38000275	0	\N	\N	81481	0	288086009	4125906	
13704	1246	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	82090	0	180256009	4107731	
2054	196	4151422	2008-08-31	2008-08-31 00:00:00	38000275	0	\N	\N	13520	0	269911007	4151422	
14101	1272	4107731	1993-10-22	1993-10-22 00:00:00	38000275	0	\N	\N	83872	0	180256009	4107731	
14393	1285	4170947	1996-04-27	1996-04-27 00:00:00	38000275	0	\N	\N	84928	0	274474001	4170947	
14426	1285	4107731	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	85049	0	180256009	4107731	
26603	2328	4163872	1972-05-15	1972-05-15 00:00:00	38000275	0	\N	\N	154815	0	399208008	4163872	
14838	1316	4024289	2018-09-27	2018-09-27 00:00:00	38000275	0	\N	\N	87224	0	19490002	4024289	
15106	1352	4057420	1984-11-25	1984-11-25 00:00:00	38000275	0	\N	\N	89607	0	18286008	4057420	
15201	1357	4170947	1984-06-12	1984-06-12 00:00:00	38000275	0	\N	\N	90034	0	274474001	4170947	
15488	1378	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	91411	0	180256009	4107731	
3729	357	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	23743	0	180256009	4107731	
15887	1397	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	92761	0	180256009	4107731	
4102	406	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	26763	0	180256009	4107731	
4292	411	4107731	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	27397	0	180256009	4107731	
28288	2503	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	165703	0	180256009	4107731	
16598	1441	4107731	1991-09-02	1991-09-02 00:00:00	38000275	0	\N	\N	96088	0	180256009	4107731	
16734	1447	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	96463	0	180256009	4107731	
16917	1468	4163872	1989-07-13	1989-07-13 00:00:00	38000275	0	\N	\N	97862	0	399208008	4163872	
17030	1476	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	98399	0	180256009	4107731	
17259	1486	4107731	1990-06-03	1990-06-03 00:00:00	38000275	0	\N	\N	99011	0	180256009	4107731	
17398	1497	4326177	1983-03-05	1983-03-05 00:00:00	38000275	0	\N	\N	99768	0	430193006	4326177	
17663	1513	4107731	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	101121	0	180256009	4107731	
17934	1532	4047491	1986-04-14	1986-04-14 00:00:00	38000275	0	\N	\N	102596	0	1225002	4047491	
18019	1538	4107731	1992-07-13	1992-07-13 00:00:00	38000275	0	\N	\N	103067	0	180256009	4107731	
30111	2662	4151422	1995-10-28	1995-10-28 00:00:00	38000275	0	\N	\N	176394	0	269911007	4151422	
18494	1571	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	105460	0	180256009	4107731	
18523	1571	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	105530	0	180256009	4107731	
18771	1609	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	108134	0	180256009	4107731	
19006	1626	42535580	1989-12-17	1989-12-17 00:00:00	38000275	0	\N	\N	109189	0	426701000119108	42535580	
31100	2764	4295880	1997-07-25	1997-07-25 00:00:00	38000275	0	\N	\N	182811	0	76601001	4295880	
19315	1656	4295880	2010-06-12	2010-06-12 00:00:00	38000275	0	\N	\N	111132	0	76601001	4295880	
19524	1669	4035793	2012-04-02	2012-04-02 00:00:00	38000275	0	\N	\N	112082	0	15081005	4035793	
19696	1703	4170947	1954-11-10	1954-11-10 00:00:00	38000275	0	\N	\N	113925	0	274474001	4170947	
19973	1727	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	115415	0	180256009	4107731	
20014	1727	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	115556	0	180256009	4107731	
8400	761	4107731	1994-07-01	1994-07-01 00:00:00	38000275	0	\N	\N	50525	0	180256009	4107731	
32365	2843	4163872	1961-06-11	1961-06-11 00:00:00	38000275	0	\N	\N	188758	0	399208008	4163872	
32559	2860	4010253	1968-11-27	1968-11-27 00:00:00	38000275	0	\N	\N	190153	0	112790001	4010253	
32888	2891	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	192380	0	180256009	4107731	
21038	1821	4078793	1986-08-03	1986-08-03 00:00:00	38000275	0	\N	\N	121841	0	180325003	4078793	
9347	859	4107731	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	56813	0	180256009	4107731	
21378	1851	4202451	2017-12-28	2017-12-28 00:00:00	38000275	0	\N	\N	123857	0	433112001	4202451	
45442	4014	4107731	2000-03-07	2000-03-07 00:00:00	38000275	0	\N	\N	266701	0	180256009	4107731	
9910	885	4043071	1989-01-13	1989-01-13 00:00:00	38000275	0	\N	\N	59037	0	228557008	4043071	
22054	1923	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	127948	0	180256009	4107731	
22184	1941	4043071	1987-01-28	1987-01-28 00:00:00	38000275	0	\N	\N	129066	0	228557008	4043071	
22268	1950	4035793	1998-10-29	1998-10-29 00:00:00	38000275	0	\N	\N	129692	0	15081005	4035793	
22504	1971	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	131100	0	180256009	4107731	
22751	1980	4107731	1990-12-09	1990-12-09 00:00:00	38000275	0	\N	\N	131784	0	180256009	4107731	
22960	1999	4107731	2012-09-05	2012-09-05 00:00:00	38000275	0	\N	\N	133095	0	180256009	4107731	
46978	4117	4163872	1980-03-16	1980-03-16 00:00:00	38000275	0	\N	\N	273693	0	399208008	4163872	
23319	2025	4078793	1991-02-16	1991-02-16 00:00:00	38000275	0	\N	\N	134778	0	180325003	4078793	
23552	2058	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	136886	0	180256009	4107731	
11775	1083	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	71073	0	180256009	4107731	
23817	2075	4191853	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	138131	0	395142003	4191853	
178	9	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	810	0	180256009	4107731	
12336	1110	4107731	1996-04-01	1996-04-01 00:00:00	38000275	0	\N	\N	73094	0	180256009	4107731	
12426	1115	4191853	1990-01-01	1990-01-01 00:00:00	38000275	0	\N	\N	73440	0	395142003	4191853	
24512	2140	4043071	1963-05-12	1963-05-12 00:00:00	38000275	0	\N	\N	142546	0	228557008	4043071	
24749	2168	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	144468	0	180256009	4107731	
13011	1175	4107731	1991-09-01	1991-09-01 00:00:00	38000275	0	\N	\N	77499	0	180256009	4107731	
13274	1211	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	79509	0	180256009	4107731	
13426	1216	4047491	1973-03-10	1973-03-10 00:00:00	38000275	0	\N	\N	80068	0	1225002	4047491	
13623	1236	4195803	2001-03-04	2001-03-04 00:00:00	38000275	0	\N	\N	81488	0	312681000	4195803	
13705	1246	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	82006	0	180256009	4107731	
2055	196	4170947	1957-06-02	1957-06-02 00:00:00	38000275	0	\N	\N	13448	0	274474001	4170947	
14102	1272	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	83905	0	180256009	4107731	
14394	1285	4078793	2016-05-30	2016-05-30 00:00:00	38000275	0	\N	\N	84967	0	180325003	4078793	
14427	1285	4107731	1990-08-20	1990-08-20 00:00:00	38000275	0	\N	\N	84988	0	180256009	4107731	
26604	2329	4058899	1982-10-25	1982-10-25 00:00:00	38000275	0	\N	\N	154901	0	168594001	4058899	
14839	1316	4151422	1976-09-26	1976-09-26 00:00:00	38000275	0	\N	\N	87179	0	269911007	4151422	
15107	1352	4035793	2011-05-29	2011-05-29 00:00:00	38000275	0	\N	\N	89573	0	15081005	4035793	
15202	1358	4243062	1976-04-07	1976-04-07 00:00:00	38000275	0	\N	\N	90108	0	60027007	4243062	
15489	1378	4293740	2013-08-27	2013-08-27 00:00:00	38000275	0	\N	\N	91320	0	384700001	4293740	
3730	357	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	23711	0	180256009	4107731	
15888	1397	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	92844	0	180256009	4107731	
4103	406	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	26765	0	180256009	4107731	
4293	411	4107731	1993-03-27	1993-03-27 00:00:00	38000275	0	\N	\N	27306	0	180256009	4107731	
28289	2503	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	165737	0	180256009	4107731	
16599	1441	4107731	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	96086	0	180256009	4107731	
16735	1447	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	96550	0	180256009	4107731	
16918	1468	4125906	1958-09-26	1958-09-26 00:00:00	38000275	0	\N	\N	97887	0	288086009	4125906	
17031	1476	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	98477	0	180256009	4107731	
17260	1486	4107731	1991-11-10	1991-11-10 00:00:00	38000275	0	\N	\N	99121	0	180256009	4107731	
17399	1497	4187458	1983-03-05	1983-03-05 00:00:00	38000275	0	\N	\N	99768	0	415300000	4187458	
17664	1513	4107731	1990-10-07	1990-10-07 00:00:00	38000275	0	\N	\N	101128	0	180256009	4107731	
17935	1532	4170947	1986-04-14	1986-04-14 00:00:00	38000275	0	\N	\N	102596	0	274474001	4170947	
18020	1538	4125906	1993-12-19	1993-12-19 00:00:00	38000275	0	\N	\N	102946	0	288086009	4125906	
30112	2662	44783196	2002-07-12	2002-07-12 00:00:00	38000275	0	\N	\N	176391	0	699253003	44783196	
18495	1571	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	105461	0	395142003	4191853	
18524	1571	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	105441	0	180256009	4107731	
18772	1609	4125906	1950-10-13	1950-10-13 00:00:00	38000275	0	\N	\N	108158	0	288086009	4125906	
19007	1626	4163971	1989-12-17	1989-12-17 00:00:00	38000275	0	\N	\N	109189	0	45595009	4163971	
31101	2764	4295880	1995-07-28	1995-07-28 00:00:00	38000275	0	\N	\N	182754	0	76601001	4295880	
19316	1656	4295880	2012-06-09	2012-06-09 00:00:00	38000275	0	\N	\N	111162	0	76601001	4295880	
19525	1669	4337138	2014-06-09	2014-06-09 00:00:00	38000275	0	\N	\N	112072	0	88039007	4337138	
19697	1703	4047491	1954-11-10	1954-11-10 00:00:00	38000275	0	\N	\N	113925	0	1225002	4047491	
19974	1727	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	115517	0	180256009	4107731	
20015	1727	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	115547	0	180256009	4107731	
8401	761	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	50641	0	180256009	4107731	
32366	2843	4047491	1990-12-31	1990-12-31 00:00:00	38000275	0	\N	\N	188741	0	1225002	4047491	
32560	2860	4024289	1945-05-29	1945-05-29 00:00:00	38000275	0	\N	\N	190129	0	19490002	4024289	
32889	2891	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	192338	0	180256009	4107731	
21039	1821	4057420	2016-02-21	2016-02-21 00:00:00	38000275	0	\N	\N	121830	0	18286008	4057420	
9348	859	4107731	1990-04-16	1990-04-16 00:00:00	38000275	0	\N	\N	56757	0	180256009	4107731	
21379	1851	4181917	1994-04-28	1994-04-28 00:00:00	38000275	0	\N	\N	123824	0	54550000	4181917	
45443	4014	4107731	1999-08-10	1999-08-10 00:00:00	38000275	0	\N	\N	266792	0	180256009	4107731	
9911	885	4043071	1987-06-19	1987-06-19 00:00:00	38000275	0	\N	\N	59031	0	228557008	4043071	
22055	1923	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	127994	0	180256009	4107731	
22185	1941	4043071	1986-11-26	1986-11-26 00:00:00	38000275	0	\N	\N	129055	0	228557008	4043071	
22269	1950	4035793	2011-01-06	2011-01-06 00:00:00	38000275	0	\N	\N	129709	0	15081005	4035793	
22505	1971	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	131059	0	180256009	4107731	
22752	1980	4107731	1991-01-20	1991-01-20 00:00:00	38000275	0	\N	\N	131785	0	180256009	4107731	
22961	1999	4170947	1991-07-12	1991-07-12 00:00:00	38000275	0	\N	\N	133057	0	274474001	4170947	
46979	4119	4202451	2001-09-29	2001-09-29 00:00:00	38000275	0	\N	\N	273830	0	433112001	4202451	
23320	2025	4078793	1983-01-01	1983-01-01 00:00:00	38000275	0	\N	\N	134644	0	180325003	4078793	
23553	2058	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	136874	0	180256009	4107731	
11776	1083	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	71069	0	180256009	4107731	
23818	2075	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	138081	0	180256009	4107731	
179	9	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	807	0	180256009	4107731	
12337	1110	4107731	1998-07-20	1998-07-20 00:00:00	38000275	0	\N	\N	73041	0	180256009	4107731	
12427	1115	4107731	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	73348	0	180256009	4107731	
24513	2140	4043071	1963-04-07	1963-04-07 00:00:00	38000275	0	\N	\N	142485	0	228557008	4043071	
24750	2168	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	144542	0	180256009	4107731	
13012	1175	4107731	1992-10-04	1992-10-04 00:00:00	38000275	0	\N	\N	77535	0	180256009	4107731	
13275	1211	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	79650	0	180256009	4107731	
13427	1216	4125906	2006-05-21	2006-05-21 00:00:00	38000275	0	\N	\N	80071	0	288086009	4125906	
13624	1236	4058899	2001-03-04	2001-03-04 00:00:00	38000275	0	\N	\N	81488	0	168594001	4058899	
13706	1246	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	82013	0	180256009	4107731	
2056	196	4047491	1957-06-02	1957-06-02 00:00:00	38000275	0	\N	\N	13448	0	1225002	4047491	
14103	1272	4107731	1994-02-04	1994-02-04 00:00:00	38000275	0	\N	\N	83932	0	180256009	4107731	
14395	1285	4107731	1991-09-23	1991-09-23 00:00:00	38000275	0	\N	\N	85043	0	180256009	4107731	
14428	1285	4107731	1991-12-16	1991-12-16 00:00:00	38000275	0	\N	\N	84947	0	180256009	4107731	
26605	2330	4293740	1980-03-26	1980-03-26 00:00:00	38000275	0	\N	\N	155004	0	384700001	4293740	
14840	1316	4151422	1998-03-22	1998-03-22 00:00:00	38000275	0	\N	\N	87228	0	269911007	4151422	
15108	1352	4035793	2007-05-06	2007-05-06 00:00:00	38000275	0	\N	\N	89588	0	15081005	4035793	
15203	1358	4170947	1976-04-07	1976-04-07 00:00:00	38000275	0	\N	\N	90108	0	274474001	4170947	
15490	1378	4125906	2013-08-27	2013-08-27 00:00:00	38000275	0	\N	\N	91320	0	288086009	4125906	
3731	357	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	23662	0	180256009	4107731	
15889	1397	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	92753	0	180256009	4107731	
4104	406	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	26822	0	180256009	4107731	
4294	411	4107731	1991-10-19	1991-10-19 00:00:00	38000275	0	\N	\N	27399	0	180256009	4107731	
28290	2503	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	165665	0	180256009	4107731	
16600	1441	4191853	1990-01-01	1990-01-01 00:00:00	38000275	0	\N	\N	96030	0	395142003	4191853	
16736	1447	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	96464	0	180256009	4107731	
16919	1468	4078793	2017-06-14	2017-06-14 00:00:00	38000275	0	\N	\N	97795	0	180325003	4078793	
17032	1476	4062501	1946-09-21	1946-09-21 00:00:00	38000275	0	\N	\N	98365	0	171231001	4062501	
17305	1490	4151422	1968-09-29	1968-09-29 00:00:00	38000275	0	\N	\N	99381	0	269911007	4151422	
17400	1497	4037675	1983-03-05	1983-03-05 00:00:00	38000275	0	\N	\N	99768	0	162676008	4037675	
17665	1513	4107731	1990-04-01	1990-04-01 00:00:00	38000275	0	\N	\N	101168	0	180256009	4107731	
17936	1533	4163872	2016-09-29	2016-09-29 00:00:00	38000275	0	\N	\N	102662	0	399208008	4163872	
18021	1538	4107731	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	102977	0	180256009	4107731	
30113	2663	4151422	1973-04-20	1973-04-20 00:00:00	38000275	0	\N	\N	176443	0	269911007	4151422	
18496	1571	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	105448	0	180256009	4107731	
18525	1571	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	105476	0	180256009	4107731	
18773	1609	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	108103	0	180256009	4107731	
19008	1626	4202832	1989-12-17	1989-12-17 00:00:00	38000275	0	\N	\N	109189	0	52765003	4202832	
31102	2764	4295880	1997-10-24	1997-10-24 00:00:00	38000275	0	\N	\N	182757	0	76601001	4295880	
19317	1656	4295880	2011-09-10	2011-09-10 00:00:00	38000275	0	\N	\N	111107	0	76601001	4295880	
19526	1669	4035793	2018-05-07	2018-05-07 00:00:00	38000275	0	\N	\N	112119	0	15081005	4035793	
19698	1703	44783196	2019-05-18	2019-05-18 00:00:00	38000275	0	\N	\N	113888	0	699253003	44783196	
19975	1727	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	115535	0	180256009	4107731	
20016	1727	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	115554	0	180256009	4107731	
8402	761	4107731	1994-07-22	1994-07-22 00:00:00	38000275	0	\N	\N	50637	0	180256009	4107731	
32367	2843	4170947	1990-12-31	1990-12-31 00:00:00	38000275	0	\N	\N	188741	0	274474001	4170947	
32561	2860	4170947	1945-05-29	1945-05-29 00:00:00	38000275	0	\N	\N	190129	0	274474001	4170947	
32890	2891	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	192285	0	180256009	4107731	
21040	1821	4057420	1988-08-14	1988-08-14 00:00:00	38000275	0	\N	\N	121795	0	18286008	4057420	
9349	859	4107731	1992-03-30	1992-03-30 00:00:00	38000275	0	\N	\N	56808	0	180256009	4107731	
21380	1851	4181917	1996-03-14	1996-03-14 00:00:00	38000275	0	\N	\N	123825	0	54550000	4181917	
45444	4014	4107731	2001-05-01	2001-05-01 00:00:00	38000275	0	\N	\N	266709	0	180256009	4107731	
21693	1882	4107731	1992-08-29	1992-08-29 00:00:00	38000275	0	\N	\N	125504	0	180256009	4107731	
22056	1923	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	127980	0	180256009	4107731	
22186	1941	4125906	1974-01-11	1974-01-11 00:00:00	38000275	0	\N	\N	129098	0	288086009	4125906	
22270	1950	4195803	2011-01-06	2011-01-06 00:00:00	38000275	0	\N	\N	129709	0	312681000	4195803	
22506	1971	4151422	1981-05-12	1981-05-12 00:00:00	38000275	0	\N	\N	131066	0	269911007	4151422	
22753	1980	4163872	1988-07-02	1988-07-02 00:00:00	38000275	0	\N	\N	131806	0	399208008	4163872	
22962	1999	4243062	1991-07-12	1991-07-12 00:00:00	38000275	0	\N	\N	133057	0	60027007	4243062	
46980	4119	4125906	1981-04-28	1981-04-28 00:00:00	38000275	0	\N	\N	273812	0	288086009	4125906	
23321	2025	4078793	1981-12-26	1981-12-26 00:00:00	38000275	0	\N	\N	134675	0	180325003	4078793	
23554	2058	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	136909	0	180256009	4107731	
11777	1083	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	71137	0	180256009	4107731	
23819	2075	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	138072	0	180256009	4107731	
180	9	4107731	1994-02-24	1994-02-24 00:00:00	38000275	0	\N	\N	788	0	180256009	4107731	
12338	1110	4107731	1997-10-20	1997-10-20 00:00:00	38000275	0	\N	\N	73037	0	180256009	4107731	
12428	1115	4107731	1992-10-26	1992-10-26 00:00:00	38000275	0	\N	\N	73367	0	180256009	4107731	
24514	2140	4043071	1963-09-08	1963-09-08 00:00:00	38000275	0	\N	\N	142486	0	228557008	4043071	
24751	2168	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	144484	0	180256009	4107731	
13013	1175	4107731	1993-02-28	1993-02-28 00:00:00	38000275	0	\N	\N	77516	0	180256009	4107731	
13276	1211	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	79592	0	180256009	4107731	
13428	1217	4202451	2018-10-19	2018-10-19 00:00:00	38000275	0	\N	\N	80147	0	433112001	4202451	
13625	1236	44783196	1939-10-23	1939-10-23 00:00:00	38000275	0	\N	\N	81442	0	699253003	44783196	
13707	1246	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	82046	0	180256009	4107731	
2057	197	4151422	1984-08-24	1984-08-24 00:00:00	38000275	0	\N	\N	13536	0	269911007	4151422	
14104	1272	4107731	1995-05-12	1995-05-12 00:00:00	38000275	0	\N	\N	83889	0	180256009	4107731	
14396	1285	4107731	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	84953	0	180256009	4107731	
14429	1285	4107731	1991-03-18	1991-03-18 00:00:00	38000275	0	\N	\N	84944	0	180256009	4107731	
26606	2330	4125906	1980-03-26	1980-03-26 00:00:00	38000275	0	\N	\N	155004	0	288086009	4125906	
14841	1316	4151422	2013-04-30	2013-04-30 00:00:00	38000275	0	\N	\N	87183	0	269911007	4151422	
15109	1352	4035793	2009-05-17	2009-05-17 00:00:00	38000275	0	\N	\N	89589	0	15081005	4035793	
15204	1358	4125906	2002-01-05	2002-01-05 00:00:00	38000275	0	\N	\N	90110	0	288086009	4125906	
15491	1378	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	91379	0	180256009	4107731	
3732	357	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	23765	0	180256009	4107731	
15890	1397	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	92815	0	180256009	4107731	
4105	406	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	26818	0	180256009	4107731	
4295	411	4107731	1993-03-06	1993-03-06 00:00:00	38000275	0	\N	\N	27333	0	180256009	4107731	
28291	2503	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	165732	0	180256009	4107731	
16601	1441	4107731	1990-05-07	1990-05-07 00:00:00	38000275	0	\N	\N	96060	0	180256009	4107731	
16737	1447	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	96450	0	180256009	4107731	
16920	1468	4057420	2018-06-20	2018-06-20 00:00:00	38000275	0	\N	\N	97848	0	18286008	4057420	
17033	1476	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	98381	0	180256009	4107731	
17306	1490	4170947	1982-05-08	1982-05-08 00:00:00	38000275	0	\N	\N	99305	0	274474001	4170947	
17401	1497	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	99822	0	180256009	4107731	
17666	1513	4107731	1990-12-09	1990-12-09 00:00:00	38000275	0	\N	\N	101034	0	180256009	4107731	
17937	1533	4151422	2013-07-22	2013-07-22 00:00:00	38000275	0	\N	\N	102649	0	269911007	4151422	
18022	1538	4107731	1990-04-16	1990-04-16 00:00:00	38000275	0	\N	\N	102956	0	180256009	4107731	
30114	2663	4163872	1965-07-23	1965-07-23 00:00:00	38000275	0	\N	\N	176475	0	399208008	4163872	
18497	1571	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	105431	0	180256009	4107731	
18526	1571	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	105432	0	180256009	4107731	
18774	1609	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	108188	0	180256009	4107731	
19009	1626	4057420	2010-10-10	2010-10-10 00:00:00	38000275	0	\N	\N	109220	0	18286008	4057420	
31103	2764	4275113	1993-07-24	1993-07-24 00:00:00	38000275	0	\N	\N	182804	0	65200003	4275113	
19318	1656	4275113	2009-08-26	2009-08-26 00:00:00	38000275	0	\N	\N	111064	0	65200003	4275113	
19527	1669	4035793	2013-04-08	2013-04-08 00:00:00	38000275	0	\N	\N	112090	0	15081005	4035793	
19699	1703	4125906	1962-10-20	1962-10-20 00:00:00	38000275	0	\N	\N	113927	0	288086009	4125906	
19976	1727	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	115562	0	180256009	4107731	
20028	1733	44783196	1989-08-10	1989-08-10 00:00:00	38000275	0	\N	\N	115833	0	699253003	44783196	
8403	761	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	50553	0	180256009	4107731	
32368	2843	4326177	2005-07-26	2005-07-26 00:00:00	38000275	0	\N	\N	188762	0	430193006	4326177	
32562	2860	4243062	2001-11-01	2001-11-01 00:00:00	38000275	0	\N	\N	190130	0	60027007	4243062	
32891	2891	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	192335	0	180256009	4107731	
21041	1821	4078793	1995-09-24	1995-09-24 00:00:00	38000275	0	\N	\N	121785	0	180325003	4078793	
9350	859	4107731	1993-02-08	1993-02-08 00:00:00	38000275	0	\N	\N	56812	0	180256009	4107731	
21381	1852	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	123935	0	180256009	4107731	
45445	4014	4107731	1999-01-12	1999-01-12 00:00:00	38000275	0	\N	\N	266736	0	180256009	4107731	
21694	1882	4107731	1991-12-21	1991-12-21 00:00:00	38000275	0	\N	\N	125563	0	180256009	4107731	
22057	1923	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	127864	0	395142003	4191853	
22187	1941	4043071	1986-07-09	1986-07-09 00:00:00	38000275	0	\N	\N	129088	0	228557008	4043071	
22271	1950	4035793	2013-01-17	2013-01-17 00:00:00	38000275	0	\N	\N	129661	0	15081005	4035793	
22507	1971	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	131081	0	180256009	4107731	
22754	1980	4170947	1988-07-02	1988-07-02 00:00:00	38000275	0	\N	\N	131806	0	274474001	4170947	
22963	1999	4107731	2012-03-21	2012-03-21 00:00:00	38000275	0	\N	\N	133087	0	180256009	4107731	
46981	4119	4125906	1964-09-10	1964-09-10 00:00:00	38000275	0	\N	\N	273809	0	288086009	4125906	
23322	2025	4078793	2002-04-20	2002-04-20 00:00:00	38000275	0	\N	\N	134780	0	180325003	4078793	
23555	2058	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	136885	0	180256009	4107731	
11778	1083	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	71070	0	180256009	4107731	
23820	2075	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	138109	0	180256009	4107731	
181	9	4107731	1994-08-11	1994-08-11 00:00:00	38000275	0	\N	\N	779	0	180256009	4107731	
12339	1110	4107731	1998-04-27	1998-04-27 00:00:00	38000275	0	\N	\N	73117	0	180256009	4107731	
12429	1115	4107731	1993-02-08	1993-02-08 00:00:00	38000275	0	\N	\N	73468	0	180256009	4107731	
24515	2140	4043071	1962-12-02	1962-12-02 00:00:00	38000275	0	\N	\N	142544	0	228557008	4043071	
24752	2168	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	144549	0	180256009	4107731	
13014	1175	4107731	1992-02-16	1992-02-16 00:00:00	38000275	0	\N	\N	77459	0	180256009	4107731	
13277	1211	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	79625	0	180256009	4107731	
13429	1217	4035793	2017-01-13	2017-01-13 00:00:00	38000275	0	\N	\N	80147	0	15081005	4035793	
13626	1236	4058899	1994-08-24	1994-08-24 00:00:00	38000275	0	\N	\N	81486	0	168594001	4058899	
13708	1246	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	82104	0	180256009	4107731	
13839	1258	4293740	2006-02-05	2006-02-05 00:00:00	38000275	0	\N	\N	82899	0	384700001	4293740	
14105	1272	4107731	1993-07-30	1993-07-30 00:00:00	38000275	0	\N	\N	83870	0	180256009	4107731	
14397	1285	4107731	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	84990	0	180256009	4107731	
14430	1285	4078793	2018-10-22	2018-10-22 00:00:00	38000275	0	\N	\N	84918	0	180325003	4078793	
26607	2332	4047491	1967-08-26	1967-08-26 00:00:00	38000275	0	\N	\N	155123	0	1225002	4047491	
14842	1316	4151422	2004-07-26	2004-07-26 00:00:00	38000275	0	\N	\N	87156	0	269911007	4151422	
15110	1352	4035793	2008-05-11	2008-05-11 00:00:00	38000275	0	\N	\N	89543	0	15081005	4035793	
15205	1358	4293740	2002-01-05	2002-01-05 00:00:00	38000275	0	\N	\N	90110	0	384700001	4293740	
15492	1378	4191853	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	91332	0	395142003	4191853	
3733	357	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	23655	0	180256009	4107731	
15891	1397	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	92821	0	180256009	4107731	
4106	406	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	26782	0	180256009	4107731	
4296	411	4107731	1993-01-23	1993-01-23 00:00:00	38000275	0	\N	\N	27332	0	180256009	4107731	
28292	2503	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	165685	0	180256009	4107731	
16602	1441	4107731	1992-10-05	1992-10-05 00:00:00	38000275	0	\N	\N	95972	0	180256009	4107731	
16738	1447	4163872	1975-03-14	1975-03-14 00:00:00	38000275	0	\N	\N	96483	0	399208008	4163872	
16921	1468	4057420	2015-06-03	2015-06-03 00:00:00	38000275	0	\N	\N	97794	0	18286008	4057420	
17034	1476	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	98417	0	180256009	4107731	
17307	1490	4243062	1982-05-08	1982-05-08 00:00:00	38000275	0	\N	\N	99305	0	60027007	4243062	
17402	1497	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	99798	0	180256009	4107731	
17667	1513	4107731	1990-11-18	1990-11-18 00:00:00	38000275	0	\N	\N	101129	0	180256009	4107731	
17938	1533	4125906	2017-08-29	2017-08-29 00:00:00	38000275	0	\N	\N	102692	0	288086009	4125906	
18023	1538	4107731	1991-09-23	1991-09-23 00:00:00	38000275	0	\N	\N	103088	0	180256009	4107731	
30115	2663	4125906	2018-05-15	2018-05-15 00:00:00	38000275	0	\N	\N	176440	0	288086009	4125906	
18498	1571	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	105445	0	395142003	4191853	
18527	1571	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	105446	0	180256009	4107731	
18775	1609	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	108104	0	180256009	4107731	
19010	1626	40492359	2010-10-10	2010-10-10 00:00:00	38000275	0	\N	\N	109220	0	447365002	40492359	
31104	2764	4295880	1995-10-27	1995-10-27 00:00:00	38000275	0	\N	\N	182749	0	76601001	4295880	
19319	1656	4295880	2006-06-17	2006-06-17 00:00:00	38000275	0	\N	\N	111117	0	76601001	4295880	
19528	1669	4035793	2010-03-22	2010-03-22 00:00:00	38000275	0	\N	\N	112081	0	15081005	4035793	
19700	1703	4125906	1997-08-20	1997-08-20 00:00:00	38000275	0	\N	\N	113931	0	288086009	4125906	
19977	1727	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	115565	0	180256009	4107731	
20029	1733	4151422	2001-03-06	2001-03-06 00:00:00	38000275	0	\N	\N	115835	0	269911007	4151422	
8404	761	4107731	1995-02-17	1995-02-17 00:00:00	38000275	0	\N	\N	50527	0	180256009	4107731	
32369	2843	4037675	2005-07-26	2005-07-26 00:00:00	38000275	0	\N	\N	188762	0	162676008	4037675	
32563	2860	4195803	2001-11-01	2001-11-01 00:00:00	38000275	0	\N	\N	190130	0	312681000	4195803	
32892	2891	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	192356	0	395142003	4191853	
21042	1821	4078793	2007-10-14	2007-10-14 00:00:00	38000275	0	\N	\N	121826	0	180325003	4078793	
21158	1829	4293740	1975-07-22	1975-07-22 00:00:00	38000275	0	\N	\N	122270	0	384700001	4293740	
21382	1852	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	123909	0	180256009	4107731	
45446	4014	4107731	1999-04-06	1999-04-06 00:00:00	38000275	0	\N	\N	266738	0	180256009	4107731	
21695	1882	4107731	1991-02-09	1991-02-09 00:00:00	38000275	0	\N	\N	125559	0	180256009	4107731	
22058	1923	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	128015	0	180256009	4107731	
22188	1941	4043071	1986-09-17	1986-09-17 00:00:00	38000275	0	\N	\N	129073	0	228557008	4043071	
22272	1950	4035793	1992-09-24	1992-09-24 00:00:00	38000275	0	\N	\N	129681	0	15081005	4035793	
22508	1971	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	131043	0	180256009	4107731	
22755	1980	4107731	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	131865	0	180256009	4107731	
22964	1999	4107731	2012-05-02	2012-05-02 00:00:00	38000275	0	\N	\N	133141	0	180256009	4107731	
46982	4119	4198190	1976-07-15	1976-07-15 00:00:00	38000275	0	\N	\N	273877	0	80146002	4198190	
23323	2025	4078793	1984-01-07	1984-01-07 00:00:00	38000275	0	\N	\N	134676	0	180325003	4078793	
23556	2058	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	136890	0	180256009	4107731	
11779	1083	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	71157	0	180256009	4107731	
23821	2075	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	138103	0	180256009	4107731	
182	9	4107731	1995-01-05	1995-01-05 00:00:00	38000275	0	\N	\N	792	0	180256009	4107731	
12340	1110	4107731	1998-08-10	1998-08-10 00:00:00	38000275	0	\N	\N	73076	0	180256009	4107731	
12430	1115	4107731	1991-09-23	1991-09-23 00:00:00	38000275	0	\N	\N	73448	0	180256009	4107731	
24516	2140	4043071	1962-11-04	1962-11-04 00:00:00	38000275	0	\N	\N	142484	0	228557008	4043071	
24753	2168	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	144479	0	180256009	4107731	
13015	1175	4107731	1992-05-10	1992-05-10 00:00:00	38000275	0	\N	\N	77524	0	180256009	4107731	
25059	2186	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	145835	0	180256009	4107731	
13430	1217	4151422	2010-11-22	2010-11-22 00:00:00	38000275	0	\N	\N	80138	0	269911007	4151422	
13627	1236	4195803	1994-08-24	1994-08-24 00:00:00	38000275	0	\N	\N	81486	0	312681000	4195803	
13709	1246	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	82028	0	180256009	4107731	
13840	1258	4125906	2006-02-05	2006-02-05 00:00:00	38000275	0	\N	\N	82899	0	288086009	4125906	
14106	1272	4107731	1995-10-27	1995-10-27 00:00:00	38000275	0	\N	\N	83940	0	180256009	4107731	
14398	1285	4107731	1991-04-08	1991-04-08 00:00:00	38000275	0	\N	\N	85036	0	180256009	4107731	
14431	1285	4107731	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	85037	0	180256009	4107731	
26608	2332	4170947	1967-08-26	1967-08-26 00:00:00	38000275	0	\N	\N	155123	0	274474001	4170947	
14843	1317	4035793	2007-12-14	2007-12-14 00:00:00	38000275	0	\N	\N	87330	0	15081005	4035793	
15111	1352	4035793	2003-04-13	2003-04-13 00:00:00	38000275	0	\N	\N	89555	0	15081005	4035793	
15206	1358	4125906	1965-02-20	1965-02-20 00:00:00	38000275	0	\N	\N	90037	0	288086009	4125906	
15493	1378	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	91331	0	180256009	4107731	
3734	357	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	23684	0	180256009	4107731	
15892	1397	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	92854	0	180256009	4107731	
4107	406	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	26847	0	180256009	4107731	
4297	411	4107731	1990-08-04	1990-08-04 00:00:00	38000275	0	\N	\N	27366	0	180256009	4107731	
28293	2503	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	165742	0	180256009	4107731	
16603	1441	4107731	1991-01-14	1991-01-14 00:00:00	38000275	0	\N	\N	95986	0	180256009	4107731	
16739	1447	4170947	1975-03-14	1975-03-14 00:00:00	38000275	0	\N	\N	96483	0	274474001	4170947	
16922	1468	4078793	2019-06-26	2019-06-26 00:00:00	38000275	0	\N	\N	97796	0	180325003	4078793	
17035	1476	4078793	2008-12-25	2008-12-25 00:00:00	38000275	0	\N	\N	98522	0	180325003	4078793	
17308	1490	4145310	1970-09-08	1970-09-08 00:00:00	38000275	0	\N	\N	99304	0	268425006	4145310	
17403	1497	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	99893	0	180256009	4107731	
17670	1516	4151422	1988-11-02	1988-11-02 00:00:00	38000275	0	\N	\N	101262	0	269911007	4151422	
17939	1533	4293740	2017-08-29	2017-08-29 00:00:00	38000275	0	\N	\N	102692	0	384700001	4293740	
18024	1538	4107731	1990-03-05	1990-03-05 00:00:00	38000275	0	\N	\N	102955	0	180256009	4107731	
30116	2663	4170947	1972-03-17	1972-03-17 00:00:00	38000275	0	\N	\N	176439	0	274474001	4170947	
18499	1571	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	105435	0	180256009	4107731	
18528	1571	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	105416	0	180256009	4107731	
18776	1609	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	108151	0	180256009	4107731	
19011	1626	4057420	2003-10-12	2003-10-12 00:00:00	38000275	0	\N	\N	109257	0	18286008	4057420	
31105	2764	4295880	1996-10-25	1996-10-25 00:00:00	38000275	0	\N	\N	182799	0	76601001	4295880	
19320	1656	4170947	1992-06-10	1992-06-10 00:00:00	38000275	0	\N	\N	111151	0	274474001	4170947	
19529	1669	4035793	2014-04-14	2014-04-14 00:00:00	38000275	0	\N	\N	112117	0	15081005	4035793	
19701	1703	4252419	2019-05-11	2019-05-11 00:00:00	38000275	0	\N	\N	113933	0	74016001	4252419	
19978	1727	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	115467	0	395142003	4191853	
20030	1733	4252419	1989-08-03	1989-08-03 00:00:00	38000275	0	\N	\N	115804	0	74016001	4252419	
8405	761	4107731	1994-05-20	1994-05-20 00:00:00	38000275	0	\N	\N	50524	0	180256009	4107731	
32370	2843	4187458	2005-07-26	2005-07-26 00:00:00	38000275	0	\N	\N	188762	0	415300000	4187458	
32564	2860	4170947	2001-11-01	2001-11-01 00:00:00	38000275	0	\N	\N	190130	0	274474001	4170947	
32893	2891	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	192290	0	395142003	4191853	
21043	1821	4078793	2004-09-26	2004-09-26 00:00:00	38000275	0	\N	\N	121844	0	180325003	4078793	
21159	1829	4125906	1975-07-22	1975-07-22 00:00:00	38000275	0	\N	\N	122270	0	288086009	4125906	
21383	1852	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	123912	0	180256009	4107731	
45447	4014	4107731	2000-05-09	2000-05-09 00:00:00	38000275	0	\N	\N	266795	0	180256009	4107731	
21696	1882	4107731	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	125515	0	180256009	4107731	
22059	1923	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	127867	0	180256009	4107731	
22189	1941	4043071	1986-08-13	1986-08-13 00:00:00	38000275	0	\N	\N	129089	0	228557008	4043071	
22273	1950	4035793	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	129617	0	15081005	4035793	
22509	1971	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	131087	0	180256009	4107731	
22756	1980	4107731	1991-06-16	1991-06-16 00:00:00	38000275	0	\N	\N	131864	0	180256009	4107731	
22965	1999	4107731	2011-12-07	2011-12-07 00:00:00	38000275	0	\N	\N	133074	0	180256009	4107731	
46986	4121	4170947	1952-05-24	1952-05-24 00:00:00	38000275	0	\N	\N	273931	0	274474001	4170947	
23324	2025	4057420	1993-02-27	1993-02-27 00:00:00	38000275	0	\N	\N	134677	0	18286008	4057420	
23557	2058	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	136876	0	180256009	4107731	
11780	1083	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	71107	0	180256009	4107731	
23822	2075	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	138102	0	180256009	4107731	
183	9	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	838	0	180256009	4107731	
12341	1110	4047491	1992-10-18	1992-10-18 00:00:00	38000275	0	\N	\N	73082	0	1225002	4047491	
12431	1115	4107731	1991-02-25	1991-02-25 00:00:00	38000275	0	\N	\N	73351	0	180256009	4107731	
24517	2140	4243062	1960-01-20	1960-01-20 00:00:00	38000275	0	\N	\N	142554	0	60027007	4243062	
24754	2168	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	144466	0	180256009	4107731	
13016	1175	4107731	1993-02-07	1993-02-07 00:00:00	38000275	0	\N	\N	77527	0	180256009	4107731	
25060	2186	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	145727	0	180256009	4107731	
13431	1217	4035793	2015-01-09	2015-01-09 00:00:00	38000275	0	\N	\N	80186	0	15081005	4035793	
13628	1237	4293740	1981-09-05	1981-09-05 00:00:00	38000275	0	\N	\N	81520	0	384700001	4293740	
13710	1246	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	82106	0	180256009	4107731	
13841	1258	4195803	1982-03-24	1982-03-24 00:00:00	38000275	0	\N	\N	82847	0	312681000	4195803	
14107	1272	4107731	1994-11-25	1994-11-25 00:00:00	38000275	0	\N	\N	83964	0	180256009	4107731	
14399	1285	4107731	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	84952	0	180256009	4107731	
14432	1285	4107731	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	84936	0	180256009	4107731	
26609	2332	4010253	1958-06-10	1958-06-10 00:00:00	38000275	0	\N	\N	155099	0	112790001	4010253	
14844	1317	4035793	2010-12-31	2010-12-31 00:00:00	38000275	0	\N	\N	87301	0	15081005	4035793	
15112	1352	4035793	2000-03-26	2000-03-26 00:00:00	38000275	0	\N	\N	89576	0	15081005	4035793	
15207	1358	4125906	1986-10-12	1986-10-12 00:00:00	38000275	0	\N	\N	90109	0	288086009	4125906	
15494	1378	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	91305	0	180256009	4107731	
3735	357	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	23697	0	180256009	4107731	
15893	1397	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	92741	0	180256009	4107731	
4108	406	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	26831	0	180256009	4107731	
4298	411	4107731	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	27373	0	180256009	4107731	
28294	2503	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	165697	0	180256009	4107731	
16604	1441	4107731	1992-06-01	1992-06-01 00:00:00	38000275	0	\N	\N	96092	0	180256009	4107731	
16740	1447	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	96505	0	180256009	4107731	
16923	1468	4125906	1964-11-07	1964-11-07 00:00:00	38000275	0	\N	\N	97873	0	288086009	4125906	
17036	1476	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	98391	0	180256009	4107731	
17309	1490	4145310	2018-10-01	2018-10-01 00:00:00	38000275	0	\N	\N	99329	0	268425006	4145310	
17404	1497	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	99807	0	395142003	4191853	
17671	1516	44783196	1960-08-12	1960-08-12 00:00:00	38000275	0	\N	\N	101254	0	699253003	44783196	
17940	1535	4145310	2008-02-16	2008-02-16 00:00:00	38000275	0	\N	\N	102748	0	268425006	4145310	
18025	1538	4107731	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	103094	0	180256009	4107731	
30117	2663	4163872	1972-03-17	1972-03-17 00:00:00	38000275	0	\N	\N	176439	0	399208008	4163872	
18500	1571	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	105523	0	180256009	4107731	
18529	1571	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	105474	0	180256009	4107731	
18777	1609	4170947	2014-02-15	2014-02-15 00:00:00	38000275	0	\N	\N	108165	0	274474001	4170947	
19012	1626	4078793	2000-01-02	2000-01-02 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
31106	2764	4037675	2015-08-14	2015-08-14 00:00:00	38000275	0	\N	\N	182791	0	162676008	4037675	
19321	1656	4243062	1992-06-10	1992-06-10 00:00:00	38000275	0	\N	\N	111151	0	60027007	4243062	
19530	1669	4035793	2019-05-13	2019-05-13 00:00:00	38000275	0	\N	\N	112109	0	15081005	4035793	
19702	1703	4151422	1954-05-28	1954-05-28 00:00:00	38000275	0	\N	\N	113853	0	269911007	4151422	
19979	1727	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	115536	0	180256009	4107731	
20032	1736	4151422	1992-05-02	1992-05-02 00:00:00	38000275	0	\N	\N	115917	0	269911007	4151422	
8406	762	4195803	2014-09-10	2014-09-10 00:00:00	38000275	0	\N	\N	50729	0	312681000	4195803	
32371	2844	4195803	2018-07-02	2018-07-02 00:00:00	38000275	0	\N	\N	188899	0	312681000	4195803	
32565	2860	4151422	2004-09-01	2004-09-01 00:00:00	38000275	0	\N	\N	190127	0	269911007	4151422	
32894	2891	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	192341	0	180256009	4107731	
21044	1821	4125906	2010-02-20	2010-02-20 00:00:00	38000275	0	\N	\N	121776	0	288086009	4125906	
21160	1829	4125906	1989-07-22	1989-07-22 00:00:00	38000275	0	\N	\N	122271	0	288086009	4125906	
21384	1852	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	123917	0	180256009	4107731	
45448	4014	4107731	1999-06-29	1999-06-29 00:00:00	38000275	0	\N	\N	266791	0	180256009	4107731	
21697	1882	4107731	1990-12-08	1990-12-08 00:00:00	38000275	0	\N	\N	125594	0	180256009	4107731	
22060	1923	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	127993	0	180256009	4107731	
22190	1941	4043071	1986-03-12	1986-03-12 00:00:00	38000275	0	\N	\N	129083	0	228557008	4043071	
22274	1950	4035793	2007-12-20	2007-12-20 00:00:00	38000275	0	\N	\N	129621	0	15081005	4035793	
22510	1971	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	131038	0	180256009	4107731	
22757	1980	4107731	1990-11-18	1990-11-18 00:00:00	38000275	0	\N	\N	131815	0	180256009	4107731	
22966	1999	4107731	2013-08-07	2013-08-07 00:00:00	38000275	0	\N	\N	133093	0	180256009	4107731	
46987	4121	4024289	1952-05-24	1952-05-24 00:00:00	38000275	0	\N	\N	273931	0	19490002	4024289	
23325	2025	4078793	2013-10-19	2013-10-19 00:00:00	38000275	0	\N	\N	134782	0	180325003	4078793	
23558	2058	4252419	2013-08-09	2013-08-09 00:00:00	38000275	0	\N	\N	136800	0	74016001	4252419	
11781	1083	4125906	2006-10-21	2006-10-21 00:00:00	38000275	0	\N	\N	71058	0	288086009	4125906	
23823	2075	4151422	2000-09-14	2000-09-14 00:00:00	38000275	0	\N	\N	138005	0	269911007	4151422	
184	9	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	844	0	180256009	4107731	
12342	1110	4170947	1992-10-18	1992-10-18 00:00:00	38000275	0	\N	\N	73082	0	274474001	4170947	
12432	1115	4107731	1990-02-12	1990-02-12 00:00:00	38000275	0	\N	\N	73441	0	180256009	4107731	
24518	2140	4170947	1960-01-20	1960-01-20 00:00:00	38000275	0	\N	\N	142554	0	274474001	4170947	
24755	2168	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	144570	0	180256009	4107731	
13017	1175	4107731	1993-01-17	1993-01-17 00:00:00	38000275	0	\N	\N	77515	0	180256009	4107731	
25061	2186	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	145803	0	180256009	4107731	
13432	1217	4035793	2019-01-18	2019-01-18 00:00:00	38000275	0	\N	\N	80134	0	15081005	4035793	
13629	1237	4125906	1981-09-05	1981-09-05 00:00:00	38000275	0	\N	\N	81520	0	288086009	4125906	
13711	1246	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	82025	0	180256009	4107731	
13842	1258	4047491	1982-03-24	1982-03-24 00:00:00	38000275	0	\N	\N	82847	0	1225002	4047491	
14108	1272	4107731	1994-07-22	1994-07-22 00:00:00	38000275	0	\N	\N	83893	0	180256009	4107731	
26185	2283	4024289	2017-09-07	2017-09-07 00:00:00	38000275	0	\N	\N	151885	0	19490002	4024289	
14433	1285	4107731	1992-06-22	1992-06-22 00:00:00	38000275	0	\N	\N	85046	0	180256009	4107731	
26610	2332	4125906	1978-07-29	1978-07-29 00:00:00	38000275	0	\N	\N	155124	0	288086009	4125906	
14845	1317	4035793	2008-12-19	2008-12-19 00:00:00	38000275	0	\N	\N	87300	0	15081005	4035793	
15113	1352	4035793	2016-01-17	2016-01-17 00:00:00	38000275	0	\N	\N	89574	0	15081005	4035793	
15208	1358	4195803	2010-08-17	2010-08-17 00:00:00	38000275	0	\N	\N	90112	0	312681000	4195803	
15495	1378	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	91366	0	180256009	4107731	
3736	357	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	23698	0	395142003	4191853	
15894	1397	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	92784	0	180256009	4107731	
4109	406	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	26777	0	180256009	4107731	
4299	411	4107731	1992-12-12	1992-12-12 00:00:00	38000275	0	\N	\N	27354	0	180256009	4107731	
28295	2503	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	165714	0	180256009	4107731	
16605	1441	4107731	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	95991	0	180256009	4107731	
16741	1447	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	96460	0	180256009	4107731	
17006	1475	4195803	2005-02-17	2005-02-17 00:00:00	38000275	0	\N	\N	98302	0	312681000	4195803	
17037	1476	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	98403	0	180256009	4107731	
17310	1490	4195803	2018-10-01	2018-10-01 00:00:00	38000275	0	\N	\N	99329	0	312681000	4195803	
17405	1497	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	99811	0	180256009	4107731	
17672	1516	4195803	1998-03-02	1998-03-02 00:00:00	38000275	0	\N	\N	101252	0	312681000	4195803	
17941	1535	4151422	1989-01-03	1989-01-03 00:00:00	38000275	0	\N	\N	102750	0	269911007	4151422	
18026	1538	4107731	1992-06-22	1992-06-22 00:00:00	38000275	0	\N	\N	103091	0	180256009	4107731	
30123	2666	4151422	2007-06-11	2007-06-11 00:00:00	38000275	0	\N	\N	176622	0	269911007	4151422	
18501	1571	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	105418	0	180256009	4107731	
18530	1571	4151422	1995-01-25	1995-01-25 00:00:00	38000275	0	\N	\N	105510	0	269911007	4151422	
18778	1609	4163872	2014-02-15	2014-02-15 00:00:00	38000275	0	\N	\N	108165	0	399208008	4163872	
19013	1626	4078793	1995-08-27	1995-08-27 00:00:00	38000275	0	\N	\N	109233	0	180325003	4078793	
31107	2764	4187458	2015-08-14	2015-08-14 00:00:00	38000275	0	\N	\N	182791	0	415300000	4187458	
19322	1656	4295880	2014-03-08	2014-03-08 00:00:00	38000275	0	\N	\N	111110	0	76601001	4295880	
19531	1669	4243062	1998-03-30	1998-03-30 00:00:00	38000275	0	\N	\N	112070	0	60027007	4243062	
19756	1709	4195803	2017-02-04	2017-02-04 00:00:00	38000275	0	\N	\N	114283	0	312681000	4195803	
19980	1727	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	115534	0	180256009	4107731	
20033	1736	4163872	2011-10-24	2011-10-24 00:00:00	38000275	0	\N	\N	115920	0	399208008	4163872	
8407	762	4151422	1980-04-20	1980-04-20 00:00:00	38000275	0	\N	\N	50673	0	269911007	4151422	
32372	2844	4151422	1967-05-24	1967-05-24 00:00:00	38000275	0	\N	\N	188803	0	269911007	4151422	
32566	2861	4125906	1982-03-30	1982-03-30 00:00:00	38000275	0	\N	\N	190183	0	288086009	4125906	
32895	2891	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	192370	0	180256009	4107731	
21045	1821	4125906	1963-04-01	1963-04-01 00:00:00	38000275	0	\N	\N	121772	0	288086009	4125906	
21167	1834	4010253	1969-05-05	1969-05-05 00:00:00	38000275	0	\N	\N	122481	0	112790001	4010253	
21385	1852	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	123967	0	180256009	4107731	
45449	4014	4107731	1998-05-26	1998-05-26 00:00:00	38000275	0	\N	\N	266734	0	180256009	4107731	
21698	1882	4107731	1991-03-23	1991-03-23 00:00:00	38000275	0	\N	\N	125560	0	180256009	4107731	
22061	1923	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	128005	0	180256009	4107731	
22191	1941	4043071	1986-05-14	1986-05-14 00:00:00	38000275	0	\N	\N	129072	0	228557008	4043071	
22275	1950	4035793	2019-02-28	2019-02-28 00:00:00	38000275	0	\N	\N	129697	0	15081005	4035793	
22511	1971	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	131075	0	180256009	4107731	
22758	1980	4107731	1990-06-24	1990-06-24 00:00:00	38000275	0	\N	\N	131830	0	180256009	4107731	
22967	1999	4107731	2014-10-22	2014-10-22 00:00:00	38000275	0	\N	\N	133153	0	180256009	4107731	
46988	4122	4151422	2010-09-17	2010-09-17 00:00:00	38000275	0	\N	\N	274071	0	269911007	4151422	
23326	2026	4170947	2016-05-04	2016-05-04 00:00:00	38000275	0	\N	\N	134796	0	274474001	4170947	
23559	2058	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	136877	0	180256009	4107731	
23570	2060	4151422	2008-06-29	2008-06-29 00:00:00	38000275	0	\N	\N	136978	0	269911007	4151422	
23824	2075	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	138017	0	180256009	4107731	
185	9	4191853	1979-01-30	1979-01-30 00:00:00	38000275	0	\N	\N	707	0	395142003	4191853	
24124	2103	4243062	1991-06-17	1991-06-17 00:00:00	38000275	0	\N	\N	140123	0	60027007	4243062	
12433	1115	4107731	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	73455	0	180256009	4107731	
24519	2140	4043071	1963-03-10	1963-03-10 00:00:00	38000275	0	\N	\N	142528	0	228557008	4043071	
24756	2168	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	144475	0	180256009	4107731	
13018	1176	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	77633	0	180256009	4107731	
25062	2186	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	145834	0	180256009	4107731	
13435	1219	4078793	2015-01-19	2015-01-19 00:00:00	38000275	0	\N	\N	80278	0	180325003	4078793	
13630	1237	4151422	1971-01-11	1971-01-11 00:00:00	38000275	0	\N	\N	81545	0	269911007	4151422	
13712	1246	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	82014	0	180256009	4107731	
13843	1258	4170947	1982-03-24	1982-03-24 00:00:00	38000275	0	\N	\N	82847	0	274474001	4170947	
14109	1272	4107731	1995-08-25	1995-08-25 00:00:00	38000275	0	\N	\N	83967	0	180256009	4107731	
26186	2283	4170947	2017-09-07	2017-09-07 00:00:00	38000275	0	\N	\N	151885	0	274474001	4170947	
14434	1285	4107731	1993-02-08	1993-02-08 00:00:00	38000275	0	\N	\N	85048	0	180256009	4107731	
26611	2332	4293740	1978-07-29	1978-07-29 00:00:00	38000275	0	\N	\N	155124	0	384700001	4293740	
14846	1317	4035793	2012-01-06	2012-01-06 00:00:00	38000275	0	\N	\N	87332	0	15081005	4035793	
15114	1352	4163951	1976-07-29	1976-07-29 00:00:00	38000275	0	\N	\N	89606	0	29303009	4163951	
15209	1358	4058899	2010-08-17	2010-08-17 00:00:00	38000275	0	\N	\N	90112	0	168594001	4058899	
15496	1378	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	91371	0	180256009	4107731	
3737	357	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	23762	0	180256009	4107731	
15895	1397	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	92783	0	180256009	4107731	
4110	406	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	26774	0	180256009	4107731	
4300	411	4107731	1993-01-02	1993-01-02 00:00:00	38000275	0	\N	\N	27304	0	180256009	4107731	
28296	2503	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	165688	0	180256009	4107731	
16606	1441	4107731	1991-12-16	1991-12-16 00:00:00	38000275	0	\N	\N	96067	0	180256009	4107731	
16742	1447	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	96474	0	180256009	4107731	
17007	1475	4125906	1961-01-03	1961-01-03 00:00:00	38000275	0	\N	\N	98249	0	288086009	4125906	
17038	1476	4078793	2006-12-14	2006-12-14 00:00:00	38000275	0	\N	\N	98459	0	180325003	4078793	
17311	1490	4010253	1996-10-01	1996-10-01 00:00:00	38000275	0	\N	\N	99351	0	112790001	4010253	
17406	1497	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	99802	0	180256009	4107731	
17673	1516	4125906	2000-04-24	2000-04-24 00:00:00	38000275	0	\N	\N	101272	0	288086009	4125906	
17942	1536	4151422	1964-02-03	1964-02-03 00:00:00	38000275	0	\N	\N	102793	0	269911007	4151422	
18027	1538	4107731	1991-04-29	1991-04-29 00:00:00	38000275	0	\N	\N	102988	0	180256009	4107731	
30124	2666	4293740	1955-12-19	1955-12-19 00:00:00	38000275	0	\N	\N	176681	0	384700001	4293740	
18502	1571	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	105497	0	180256009	4107731	
18531	1571	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	105437	0	180256009	4107731	
18779	1609	4195803	2014-02-15	2014-02-15 00:00:00	38000275	0	\N	\N	108165	0	312681000	4195803	
19014	1626	4057420	2005-10-23	2005-10-23 00:00:00	38000275	0	\N	\N	109201	0	18286008	4057420	
31108	2764	4326177	2015-08-14	2015-08-14 00:00:00	38000275	0	\N	\N	182791	0	430193006	4326177	
19323	1656	4295880	2015-06-06	2015-06-06 00:00:00	38000275	0	\N	\N	111076	0	76601001	4295880	
19532	1669	4170947	1998-03-30	1998-03-30 00:00:00	38000275	0	\N	\N	112070	0	274474001	4170947	
19757	1709	4252419	1949-11-06	1949-11-06 00:00:00	38000275	0	\N	\N	114220	0	74016001	4252419	
19981	1727	4047491	1977-02-22	1977-02-22 00:00:00	38000275	0	\N	\N	115481	0	1225002	4047491	
20034	1736	4151422	1999-06-20	1999-06-20 00:00:00	38000275	0	\N	\N	115900	0	269911007	4151422	
8408	762	4293740	2007-04-28	2007-04-28 00:00:00	38000275	0	\N	\N	50731	0	384700001	4293740	
32373	2844	4170947	1960-10-31	1960-10-31 00:00:00	38000275	0	\N	\N	188892	0	274474001	4170947	
32567	2861	4170947	1977-04-25	1977-04-25 00:00:00	38000275	0	\N	\N	190181	0	274474001	4170947	
32896	2891	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	192275	0	180256009	4107731	
21046	1821	4078793	1999-10-17	1999-10-17 00:00:00	38000275	0	\N	\N	121842	0	180325003	4078793	
21168	1834	4151422	1955-05-18	1955-05-18 00:00:00	38000275	0	\N	\N	122534	0	269911007	4151422	
21386	1852	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	123904	0	180256009	4107731	
45450	4014	4107731	1998-02-10	1998-02-10 00:00:00	38000275	0	\N	\N	266785	0	180256009	4107731	
21699	1882	4107731	1992-04-25	1992-04-25 00:00:00	38000275	0	\N	\N	125575	0	180256009	4107731	
22062	1923	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	127886	0	180256009	4107731	
22192	1941	4043071	1986-06-11	1986-06-11 00:00:00	38000275	0	\N	\N	129065	0	228557008	4043071	
22276	1950	4035793	2000-11-09	2000-11-09 00:00:00	38000275	0	\N	\N	129693	0	15081005	4035793	
22512	1971	4197460	1979-11-17	1979-11-17 00:00:00	38000275	0	\N	\N	131062	0	313191000	4197460	
22759	1980	4107731	1991-11-10	1991-11-10 00:00:00	38000275	0	\N	\N	131820	0	180256009	4107731	
22968	1999	4107731	2012-11-07	2012-11-07 00:00:00	38000275	0	\N	\N	133089	0	180256009	4107731	
46989	4122	4170947	1995-11-25	1995-11-25 00:00:00	38000275	0	\N	\N	274067	0	274474001	4170947	
23327	2026	4047491	2016-05-04	2016-05-04 00:00:00	38000275	0	\N	\N	134796	0	1225002	4047491	
23560	2058	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	136882	0	180256009	4107731	
23571	2060	4151422	1964-02-04	1964-02-04 00:00:00	38000275	0	\N	\N	136995	0	269911007	4151422	
23825	2075	4330583	1999-11-29	1999-11-29 00:00:00	38000275	0	\N	\N	138008	0	22523008	4330583	
186	9	4107731	1994-06-09	1994-06-09 00:00:00	38000275	0	\N	\N	742	0	180256009	4107731	
24125	2103	4170947	1991-06-17	1991-06-17 00:00:00	38000275	0	\N	\N	140123	0	274474001	4170947	
12434	1115	4107731	1991-09-02	1991-09-02 00:00:00	38000275	0	\N	\N	73412	0	180256009	4107731	
24520	2140	4043071	1962-07-29	1962-07-29 00:00:00	38000275	0	\N	\N	142501	0	228557008	4043071	
24757	2168	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	144465	0	180256009	4107731	
13019	1176	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	77655	0	180256009	4107731	
25063	2186	4191853	1975-03-07	1975-03-07 00:00:00	38000275	0	\N	\N	145721	0	395142003	4191853	
13436	1219	4078793	2013-10-14	2013-10-14 00:00:00	38000275	0	\N	\N	80257	0	180325003	4078793	
13631	1237	4198190	1950-09-30	1950-09-30 00:00:00	38000275	0	\N	\N	81491	0	80146002	4198190	
13713	1246	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	82049	0	180256009	4107731	
13844	1259	4125906	2007-07-05	2007-07-05 00:00:00	38000275	0	\N	\N	82965	0	288086009	4125906	
14110	1272	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	83875	0	180256009	4107731	
26187	2283	4195803	2017-09-07	2017-09-07 00:00:00	38000275	0	\N	\N	151885	0	312681000	4195803	
14435	1285	4107731	1992-12-07	1992-12-07 00:00:00	38000275	0	\N	\N	84994	0	180256009	4107731	
26612	2332	4163872	1957-05-21	1957-05-21 00:00:00	38000275	0	\N	\N	155046	0	399208008	4163872	
14847	1317	4035793	2014-01-17	2014-01-17 00:00:00	38000275	0	\N	\N	87333	0	15081005	4035793	
15115	1352	4202832	1976-07-29	1976-07-29 00:00:00	38000275	0	\N	\N	89606	0	52765003	4202832	
15210	1359	4078793	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	90149	0	180325003	4078793	
15497	1378	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	91410	0	180256009	4107731	
3738	357	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	23758	0	180256009	4107731	
27677	2419	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	160617	0	395142003	4191853	
4111	406	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	26779	0	180256009	4107731	
4301	411	4107731	1991-05-04	1991-05-04 00:00:00	38000275	0	\N	\N	27347	0	180256009	4107731	
28297	2503	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	165763	0	180256009	4107731	
16607	1441	4107731	1992-03-09	1992-03-09 00:00:00	38000275	0	\N	\N	96069	0	180256009	4107731	
16743	1447	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	96517	0	180256009	4107731	
17008	1475	4293740	1961-01-03	1961-01-03 00:00:00	38000275	0	\N	\N	98249	0	384700001	4293740	
17039	1476	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	98356	0	180256009	4107731	
17312	1490	4170947	1993-01-10	1993-01-10 00:00:00	38000275	0	\N	\N	99306	0	274474001	4170947	
17407	1497	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	99771	0	180256009	4107731	
17674	1516	4198190	1956-01-01	1956-01-01 00:00:00	38000275	0	\N	\N	101347	0	80146002	4198190	
17943	1536	4047491	1926-11-10	1926-11-10 00:00:00	38000275	0	\N	\N	102788	0	1225002	4047491	
18028	1538	4107731	1991-08-12	1991-08-12 00:00:00	38000275	0	\N	\N	103087	0	180256009	4107731	
30125	2666	4125906	1955-12-19	1955-12-19 00:00:00	38000275	0	\N	\N	176681	0	288086009	4125906	
18503	1571	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	105501	0	180256009	4107731	
18532	1571	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	105415	0	180256009	4107731	
18780	1609	4202451	1998-10-28	1998-10-28 00:00:00	38000275	0	\N	\N	108089	0	433112001	4202451	
19015	1626	4078793	2000-09-24	2000-09-24 00:00:00	38000275	0	\N	\N	109226	0	180325003	4078793	
31109	2764	4295880	1994-10-28	1994-10-28 00:00:00	38000275	0	\N	\N	182747	0	76601001	4295880	
19324	1656	4295880	2009-09-12	2009-09-12 00:00:00	38000275	0	\N	\N	111131	0	76601001	4295880	
19533	1669	4035793	2011-03-28	2011-03-28 00:00:00	38000275	0	\N	\N	112089	0	15081005	4035793	
19758	1709	4125906	1959-10-20	1959-10-20 00:00:00	38000275	0	\N	\N	114237	0	288086009	4125906	
19982	1727	4170947	1977-02-22	1977-02-22 00:00:00	38000275	0	\N	\N	115481	0	274474001	4170947	
20035	1736	4151422	1970-09-01	1970-09-01 00:00:00	38000275	0	\N	\N	115941	0	269911007	4151422	
8409	762	4125906	2007-04-28	2007-04-28 00:00:00	38000275	0	\N	\N	50731	0	288086009	4125906	
32374	2844	4024289	1960-10-31	1960-10-31 00:00:00	38000275	0	\N	\N	188892	0	19490002	4024289	
32568	2861	4024289	1977-04-25	1977-04-25 00:00:00	38000275	0	\N	\N	190181	0	19490002	4024289	
32897	2891	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	192279	0	180256009	4107731	
21047	1821	4078793	1989-08-20	1989-08-20 00:00:00	38000275	0	\N	\N	121863	0	180325003	4078793	
21169	1834	4243062	1955-11-18	1955-11-18 00:00:00	38000275	0	\N	\N	122540	0	60027007	4243062	
21387	1852	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	123982	0	180256009	4107731	
45451	4014	4107731	2000-01-25	2000-01-25 00:00:00	38000275	0	\N	\N	266806	0	180256009	4107731	
21700	1882	4107731	1993-03-06	1993-03-06 00:00:00	38000275	0	\N	\N	125579	0	180256009	4107731	
22063	1923	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	127946	0	180256009	4107731	
22193	1941	4043071	1986-04-16	1986-04-16 00:00:00	38000275	0	\N	\N	129084	0	228557008	4043071	
22277	1950	4035793	1991-09-19	1991-09-19 00:00:00	38000275	0	\N	\N	129655	0	15081005	4035793	
22513	1971	4125906	1984-04-08	1984-04-08 00:00:00	38000275	0	\N	\N	131064	0	288086009	4125906	
22760	1980	4107731	1990-04-22	1990-04-22 00:00:00	38000275	0	\N	\N	131781	0	180256009	4107731	
22969	1999	4125906	2013-04-22	2013-04-22 00:00:00	38000275	0	\N	\N	133059	0	288086009	4125906	
46990	4122	4243062	1995-11-25	1995-11-25 00:00:00	38000275	0	\N	\N	274067	0	60027007	4243062	
23328	2026	4195803	2016-05-04	2016-05-04 00:00:00	38000275	0	\N	\N	134796	0	312681000	4195803	
23561	2058	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	136830	0	180256009	4107731	
23595	2062	4078793	2018-08-04	2018-08-04 00:00:00	38000275	0	\N	\N	137150	0	180325003	4078793	
23826	2075	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	138060	0	180256009	4107731	
187	9	4107731	1994-07-21	1994-07-21 00:00:00	38000275	0	\N	\N	753	0	180256009	4107731	
24126	2105	4330583	2004-08-24	2004-08-24 00:00:00	38000275	0	\N	\N	140258	0	22523008	4330583	
12435	1115	4107731	1991-04-08	1991-04-08 00:00:00	38000275	0	\N	\N	73352	0	180256009	4107731	
24521	2140	4043071	1963-07-07	1963-07-07 00:00:00	38000275	0	\N	\N	142530	0	228557008	4043071	
24758	2168	4125906	1962-10-17	1962-10-17 00:00:00	38000275	0	\N	\N	144576	0	288086009	4125906	
13020	1176	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	77623	0	180256009	4107731	
25064	2186	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	145838	0	180256009	4107731	
13437	1219	4078793	2014-01-13	2014-01-13 00:00:00	38000275	0	\N	\N	80233	0	180325003	4078793	
13632	1237	4170947	1950-02-20	1950-02-20 00:00:00	38000275	0	\N	\N	81518	0	274474001	4170947	
13714	1246	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	82150	0	180256009	4107731	
13845	1259	4191853	1981-04-14	1981-04-14 00:00:00	38000275	0	\N	\N	82942	0	395142003	4191853	
14111	1272	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	83904	0	180256009	4107731	
26188	2283	44783196	1987-03-07	1987-03-07 00:00:00	38000275	0	\N	\N	151886	0	699253003	44783196	
14436	1285	4107731	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	84992	0	180256009	4107731	
26613	2332	4047491	1988-11-15	1988-11-15 00:00:00	38000275	0	\N	\N	155126	0	1225002	4047491	
14848	1317	4035793	2001-11-09	2001-11-09 00:00:00	38000275	0	\N	\N	87313	0	15081005	4035793	
15116	1352	4163971	1976-07-29	1976-07-29 00:00:00	38000275	0	\N	\N	89606	0	45595009	4163971	
15211	1359	4125906	1932-05-28	1932-05-28 00:00:00	38000275	0	\N	\N	90154	0	288086009	4125906	
15498	1378	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	91437	0	180256009	4107731	
3739	357	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	23755	0	180256009	4107731	
27678	2419	4243062	1989-12-12	1989-12-12 00:00:00	38000275	0	\N	\N	160507	0	60027007	4243062	
4112	406	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	26851	0	180256009	4107731	
16141	1407	4107731	1991-10-19	1991-10-19 00:00:00	38000275	0	\N	\N	93522	0	180256009	4107731	
28298	2503	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	165684	0	180256009	4107731	
16608	1441	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	95964	0	180256009	4107731	
16744	1447	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	96479	0	180256009	4107731	
17009	1475	4151422	1944-03-05	1944-03-05 00:00:00	38000275	0	\N	\N	98219	0	269911007	4151422	
17040	1476	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	98465	0	180256009	4107731	
17313	1490	4024289	1993-01-10	1993-01-10 00:00:00	38000275	0	\N	\N	99306	0	19490002	4024289	
17408	1497	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	99824	0	180256009	4107731	
17675	1516	4125906	1966-12-23	1966-12-23 00:00:00	38000275	0	\N	\N	101267	0	288086009	4125906	
17944	1536	4170947	1926-11-10	1926-11-10 00:00:00	38000275	0	\N	\N	102788	0	274474001	4170947	
18029	1538	4107731	1992-11-16	1992-11-16 00:00:00	38000275	0	\N	\N	102963	0	180256009	4107731	
30133	2669	4151422	1980-05-22	1980-05-22 00:00:00	38000275	0	\N	\N	176784	0	269911007	4151422	
18504	1571	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	105486	0	180256009	4107731	
18533	1571	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	105447	0	180256009	4107731	
18781	1609	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	108150	0	395142003	4191853	
19016	1626	4078793	2009-11-15	2009-11-15 00:00:00	38000275	0	\N	\N	109227	0	180325003	4078793	
31110	2764	4295880	1998-01-23	1998-01-23 00:00:00	38000275	0	\N	\N	182752	0	76601001	4295880	
19325	1656	4295880	2008-09-13	2008-09-13 00:00:00	38000275	0	\N	\N	111062	0	76601001	4295880	
19534	1669	4035793	2006-03-06	2006-03-06 00:00:00	38000275	0	\N	\N	112106	0	15081005	4035793	
19759	1709	4151422	1970-04-25	1970-04-25 00:00:00	38000275	0	\N	\N	114256	0	269911007	4151422	
19983	1727	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	115530	0	180256009	4107731	
20036	1736	4151422	2006-07-15	2006-07-15 00:00:00	38000275	0	\N	\N	115892	0	269911007	4151422	
8410	763	4125906	1995-04-24	1995-04-24 00:00:00	38000275	0	\N	\N	50734	0	288086009	4125906	
32375	2844	4145310	2019-04-25	2019-04-25 00:00:00	38000275	0	\N	\N	188893	0	268425006	4145310	
32569	2861	4151422	1999-06-29	1999-06-29 00:00:00	38000275	0	\N	\N	190187	0	269911007	4151422	
32898	2891	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	192364	0	180256009	4107731	
21048	1821	4057420	2005-10-02	2005-10-02 00:00:00	38000275	0	\N	\N	121825	0	18286008	4057420	
21170	1834	4170947	1955-11-18	1955-11-18 00:00:00	38000275	0	\N	\N	122540	0	274474001	4170947	
21388	1852	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	123933	0	180256009	4107731	
45452	4014	4151422	1977-02-27	1977-02-27 00:00:00	38000275	0	\N	\N	266787	0	269911007	4151422	
21701	1882	4107731	1990-05-12	1990-05-12 00:00:00	38000275	0	\N	\N	125556	0	180256009	4107731	
22064	1923	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	127947	0	180256009	4107731	
22194	1941	4024289	1988-12-14	1988-12-14 00:00:00	38000275	0	\N	\N	129100	0	19490002	4024289	
22278	1950	4035793	2003-11-27	2003-11-27 00:00:00	38000275	0	\N	\N	129620	0	15081005	4035793	
22514	1971	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	131036	0	180256009	4107731	
22761	1980	4107731	1991-10-20	1991-10-20 00:00:00	38000275	0	\N	\N	131760	0	180256009	4107731	
22970	1999	4107731	2012-12-19	2012-12-19 00:00:00	38000275	0	\N	\N	133090	0	180256009	4107731	
46991	4123	4170947	1977-11-10	1977-11-10 00:00:00	38000275	0	\N	\N	274116	0	274474001	4170947	
23329	2027	4151422	2002-11-03	2002-11-03 00:00:00	38000275	0	\N	\N	134879	0	269911007	4151422	
23562	2058	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	136844	0	180256009	4107731	
23596	2062	4078793	2015-07-18	2015-07-18 00:00:00	38000275	0	\N	\N	137140	0	180325003	4078793	
23827	2075	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	138089	0	180256009	4107731	
11969	1099	4107731	1991-11-09	1991-11-09 00:00:00	38000275	0	\N	\N	72222	0	180256009	4107731	
24127	2105	4125906	2008-06-04	2008-06-04 00:00:00	38000275	0	\N	\N	140262	0	288086009	4125906	
12436	1115	4107731	1990-06-18	1990-06-18 00:00:00	38000275	0	\N	\N	73457	0	180256009	4107731	
24522	2140	4043071	1963-10-13	1963-10-13 00:00:00	38000275	0	\N	\N	142547	0	228557008	4043071	
24759	2168	4125906	1963-12-02	1963-12-02 00:00:00	38000275	0	\N	\N	144577	0	288086009	4125906	
13021	1176	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	77613	0	180256009	4107731	
25065	2186	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	145757	0	180256009	4107731	
13438	1219	4078793	2010-12-27	2010-12-27 00:00:00	38000275	0	\N	\N	80276	0	180325003	4078793	
13633	1237	4047491	1950-02-20	1950-02-20 00:00:00	38000275	0	\N	\N	81518	0	1225002	4047491	
13715	1246	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	82120	0	180256009	4107731	
13912	1261	4107731	1990-02-17	1990-02-17 00:00:00	38000275	0	\N	\N	83249	0	180256009	4107731	
14112	1272	4107731	1993-10-01	1993-10-01 00:00:00	38000275	0	\N	\N	83882	0	180256009	4107731	
26189	2283	4125906	1988-04-30	1988-04-30 00:00:00	38000275	0	\N	\N	151883	0	288086009	4125906	
14437	1285	4107731	1990-04-16	1990-04-16 00:00:00	38000275	0	\N	\N	85017	0	180256009	4107731	
26614	2332	4170947	1988-11-15	1988-11-15 00:00:00	38000275	0	\N	\N	155126	0	274474001	4170947	
14849	1317	4035793	2015-01-23	2015-01-23 00:00:00	38000275	0	\N	\N	87316	0	15081005	4035793	
15117	1352	42535580	1976-07-29	1976-07-29 00:00:00	38000275	0	\N	\N	89606	0	426701000119108	42535580	
15212	1359	4078793	2001-03-06	2001-03-06 00:00:00	38000275	0	\N	\N	90123	0	180325003	4078793	
15499	1378	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	91327	0	180256009	4107731	
3740	357	4198190	1997-10-04	1997-10-04 00:00:00	38000275	0	\N	\N	23632	0	80146002	4198190	
27679	2419	4170947	1989-12-12	1989-12-12 00:00:00	38000275	0	\N	\N	160507	0	274474001	4170947	
4113	406	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	26725	0	180256009	4107731	
16142	1407	4107731	1990-12-08	1990-12-08 00:00:00	38000275	0	\N	\N	93518	0	180256009	4107731	
28299	2503	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	165736	0	180256009	4107731	
16609	1441	4107731	1992-02-17	1992-02-17 00:00:00	38000275	0	\N	\N	95970	0	180256009	4107731	
16745	1447	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	96475	0	180256009	4107731	
17010	1475	4151422	1980-09-11	1980-09-11 00:00:00	38000275	0	\N	\N	98272	0	269911007	4151422	
17041	1476	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	98343	0	180256009	4107731	
17314	1490	4195803	1993-01-10	1993-01-10 00:00:00	38000275	0	\N	\N	99306	0	312681000	4195803	
17409	1497	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	99774	0	180256009	4107731	
17676	1516	4293740	1966-12-23	1966-12-23 00:00:00	38000275	0	\N	\N	101267	0	384700001	4293740	
17945	1536	4195803	1971-11-28	1971-11-28 00:00:00	38000275	0	\N	\N	102837	0	312681000	4195803	
18030	1538	4078793	2013-06-03	2013-06-03 00:00:00	38000275	0	\N	\N	103016	0	180325003	4078793	
30138	2672	4107731	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	177018	0	180256009	4107731	
18505	1571	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	105433	0	180256009	4107731	
18534	1571	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	105531	0	180256009	4107731	
18782	1609	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	108173	0	180256009	4107731	
19017	1626	4078793	2001-09-30	2001-09-30 00:00:00	38000275	0	\N	\N	109236	0	180325003	4078793	
31111	2764	4295880	1994-01-28	1994-01-28 00:00:00	38000275	0	\N	\N	182746	0	76601001	4295880	
19326	1656	4295880	2014-09-06	2014-09-06 00:00:00	38000275	0	\N	\N	111075	0	76601001	4295880	
19535	1669	4035793	2016-04-25	2016-04-25 00:00:00	38000275	0	\N	\N	112118	0	15081005	4035793	
19760	1709	4252419	1951-10-27	1951-10-27 00:00:00	38000275	0	\N	\N	114221	0	74016001	4252419	
19984	1727	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	115561	0	180256009	4107731	
20037	1736	4170947	2010-07-02	2010-07-02 00:00:00	38000275	0	\N	\N	115958	0	274474001	4170947	
8411	763	4170947	1981-08-21	1981-08-21 00:00:00	38000275	0	\N	\N	50732	0	274474001	4170947	
32376	2846	4047491	1981-02-22	1981-02-22 00:00:00	38000275	0	\N	\N	188988	0	1225002	4047491	
32570	2861	4170947	1987-12-20	1987-12-20 00:00:00	38000275	0	\N	\N	190244	0	274474001	4170947	
32899	2891	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	192281	0	180256009	4107731	
21049	1821	4078793	1992-09-06	1992-09-06 00:00:00	38000275	0	\N	\N	121868	0	180325003	4078793	
21171	1834	4058899	1960-04-25	1960-04-25 00:00:00	38000275	0	\N	\N	122541	0	168594001	4058899	
21389	1852	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	123998	0	180256009	4107731	
45453	4014	4107731	2001-02-27	2001-02-27 00:00:00	38000275	0	\N	\N	266706	0	180256009	4107731	
21702	1882	4107731	1991-05-25	1991-05-25 00:00:00	38000275	0	\N	\N	125540	0	180256009	4107731	
22065	1923	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	127866	0	180256009	4107731	
22195	1941	4170947	1988-12-14	1988-12-14 00:00:00	38000275	0	\N	\N	129100	0	274474001	4170947	
22279	1950	4035793	2002-11-21	2002-11-21 00:00:00	38000275	0	\N	\N	129694	0	15081005	4035793	
22515	1971	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	131037	0	180256009	4107731	
22762	1980	4107731	1992-08-09	1992-08-09 00:00:00	38000275	0	\N	\N	131789	0	180256009	4107731	
22971	1999	4107731	2013-02-20	2013-02-20 00:00:00	38000275	0	\N	\N	133119	0	180256009	4107731	
46992	4123	4024289	1977-11-10	1977-11-10 00:00:00	38000275	0	\N	\N	274116	0	19490002	4024289	
23330	2028	4170947	1997-11-16	1997-11-16 00:00:00	38000275	0	\N	\N	134954	0	274474001	4170947	
35344	3087	4170947	1996-07-15	1996-07-15 00:00:00	38000275	0	\N	\N	205556	0	274474001	4170947	
23597	2062	4078793	2017-07-29	2017-07-29 00:00:00	38000275	0	\N	\N	137139	0	180325003	4078793	
23828	2075	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	138093	0	180256009	4107731	
11970	1099	4107731	1992-04-04	1992-04-04 00:00:00	38000275	0	\N	\N	72230	0	180256009	4107731	
24128	2105	4058899	1981-02-12	1981-02-12 00:00:00	38000275	0	\N	\N	140212	0	168594001	4058899	
12437	1115	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	73416	0	180256009	4107731	
24523	2140	4125906	1984-02-13	1984-02-13 00:00:00	38000275	0	\N	\N	142555	0	288086009	4125906	
24760	2168	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	144548	0	180256009	4107731	
13022	1176	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	77598	0	180256009	4107731	
25066	2186	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	145754	0	180256009	4107731	
13439	1219	4057420	2013-01-07	2013-01-07 00:00:00	38000275	0	\N	\N	80277	0	18286008	4057420	
13634	1237	4125906	1948-05-17	1948-05-17 00:00:00	38000275	0	\N	\N	81517	0	288086009	4125906	
13716	1246	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	82021	0	180256009	4107731	
13913	1261	4107731	1992-04-04	1992-04-04 00:00:00	38000275	0	\N	\N	83231	0	180256009	4107731	
14113	1272	4107731	1994-09-02	1994-09-02 00:00:00	38000275	0	\N	\N	83962	0	180256009	4107731	
26190	2283	4163872	1941-01-31	1941-01-31 00:00:00	38000275	0	\N	\N	151905	0	399208008	4163872	
14438	1285	4107731	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	84991	0	180256009	4107731	
26615	2332	4047491	1964-08-11	1964-08-11 00:00:00	38000275	0	\N	\N	155122	0	1225002	4047491	
14850	1317	4163872	1992-05-05	1992-05-05 00:00:00	38000275	0	\N	\N	87297	0	399208008	4163872	
15118	1353	4151422	1968-10-19	1968-10-19 00:00:00	38000275	0	\N	\N	89629	0	269911007	4151422	
15213	1359	4078793	2005-03-29	2005-03-29 00:00:00	38000275	0	\N	\N	90125	0	180325003	4078793	
15500	1378	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	91365	0	180256009	4107731	
15522	1378	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	91297	0	180256009	4107731	
27680	2419	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	160576	0	180256009	4107731	
4114	406	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	26776	0	180256009	4107731	
16143	1407	4107731	1991-04-13	1991-04-13 00:00:00	38000275	0	\N	\N	93586	0	180256009	4107731	
28300	2503	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	165762	0	180256009	4107731	
16610	1441	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	96021	0	180256009	4107731	
16746	1447	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	96518	0	180256009	4107731	
17011	1475	4125906	1966-04-21	1966-04-21 00:00:00	38000275	0	\N	\N	98250	0	288086009	4125906	
17042	1476	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	98398	0	180256009	4107731	
17315	1491	4170947	1982-04-26	1982-04-26 00:00:00	38000275	0	\N	\N	99451	0	274474001	4170947	
17410	1497	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	99894	0	180256009	4107731	
17677	1516	4125906	1967-12-02	1967-12-02 00:00:00	38000275	0	\N	\N	101268	0	288086009	4125906	
17946	1536	4151422	1919-02-08	1919-02-08 00:00:00	38000275	0	\N	\N	102814	0	269911007	4151422	
18031	1538	4107731	1992-10-26	1992-10-26 00:00:00	38000275	0	\N	\N	103027	0	180256009	4107731	
30139	2672	4107731	1991-05-26	1991-05-26 00:00:00	38000275	0	\N	\N	176952	0	180256009	4107731	
18506	1571	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	105434	0	180256009	4107731	
18535	1571	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	105473	0	180256009	4107731	
18783	1609	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	108097	0	180256009	4107731	
19018	1626	4078793	2004-10-17	2004-10-17 00:00:00	38000275	0	\N	\N	109218	0	180325003	4078793	
31112	2764	4295880	1995-01-27	1995-01-27 00:00:00	38000275	0	\N	\N	182808	0	76601001	4295880	
19327	1656	4295880	2010-09-11	2010-09-11 00:00:00	38000275	0	\N	\N	111129	0	76601001	4295880	
19536	1669	4035793	2009-03-16	2009-03-16 00:00:00	38000275	0	\N	\N	112088	0	15081005	4035793	
19776	1713	4125906	2009-06-09	2009-06-09 00:00:00	38000275	0	\N	\N	114455	0	288086009	4125906	
19985	1727	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	115471	0	180256009	4107731	
20038	1736	4163872	2010-07-02	2010-07-02 00:00:00	38000275	0	\N	\N	115958	0	399208008	4163872	
8412	763	4047491	1981-08-21	1981-08-21 00:00:00	38000275	0	\N	\N	50732	0	1225002	4047491	
32377	2846	4170947	1981-02-22	1981-02-22 00:00:00	38000275	0	\N	\N	188988	0	274474001	4170947	
32571	2861	4243062	1987-12-20	1987-12-20 00:00:00	38000275	0	\N	\N	190244	0	60027007	4243062	
32900	2891	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	192347	0	180256009	4107731	
21050	1821	4057420	1991-09-01	1991-09-01 00:00:00	38000275	0	\N	\N	121864	0	18286008	4057420	
21173	1837	4187458	1970-05-11	1970-05-11 00:00:00	38000275	0	\N	\N	122738	0	415300000	4187458	
21390	1852	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	123929	0	180256009	4107731	
45454	4014	4107731	1998-12-22	1998-12-22 00:00:00	38000275	0	\N	\N	266800	0	180256009	4107731	
21703	1882	4151422	2018-10-20	2018-10-20 00:00:00	38000275	0	\N	\N	125519	0	269911007	4151422	
22066	1923	4151422	1962-06-13	1962-06-13 00:00:00	38000275	0	\N	\N	127953	0	269911007	4151422	
22196	1941	4043071	1986-10-22	1986-10-22 00:00:00	38000275	0	\N	\N	129054	0	228557008	4043071	
22280	1950	4035793	2017-02-09	2017-02-09 00:00:00	38000275	0	\N	\N	129695	0	15081005	4035793	
22516	1971	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	131093	0	180256009	4107731	
22763	1980	4107731	1992-01-12	1992-01-12 00:00:00	38000275	0	\N	\N	131762	0	180256009	4107731	
22972	1999	4107731	2012-11-28	2012-11-28 00:00:00	38000275	0	\N	\N	133097	0	180256009	4107731	
46993	4123	4125906	1965-07-04	1965-07-04 00:00:00	38000275	0	\N	\N	274113	0	288086009	4125906	
23331	2028	4243062	1997-11-16	1997-11-16 00:00:00	38000275	0	\N	\N	134954	0	60027007	4243062	
35345	3088	4187458	1999-03-30	1999-03-30 00:00:00	38000275	0	\N	\N	205619	0	415300000	4187458	
23598	2062	4010253	1965-12-31	1965-12-31 00:00:00	38000275	0	\N	\N	137168	0	112790001	4010253	
23829	2075	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	138018	0	180256009	4107731	
11971	1099	4107731	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	72220	0	180256009	4107731	
24129	2105	4163872	1978-11-27	1978-11-27 00:00:00	38000275	0	\N	\N	140254	0	399208008	4163872	
12438	1115	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	73485	0	180256009	4107731	
24524	2140	4043071	1962-09-02	1962-09-02 00:00:00	38000275	0	\N	\N	142502	0	228557008	4043071	
24761	2168	4062501	1960-09-19	1960-09-19 00:00:00	38000275	0	\N	\N	144485	0	171231001	4062501	
13023	1176	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	77594	0	180256009	4107731	
25067	2186	4125906	1996-02-27	1996-02-27 00:00:00	38000275	0	\N	\N	145829	0	288086009	4125906	
13440	1219	4078793	2019-02-11	2019-02-11 00:00:00	38000275	0	\N	\N	80266	0	180325003	4078793	
13635	1237	4163872	1951-08-01	1951-08-01 00:00:00	38000275	0	\N	\N	81497	0	399208008	4163872	
13717	1246	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	82009	0	180256009	4107731	
13914	1261	4191853	1993-07-10	1993-07-10 00:00:00	38000275	0	\N	\N	83187	0	395142003	4191853	
14114	1272	4107731	1995-07-14	1995-07-14 00:00:00	38000275	0	\N	\N	83966	0	180256009	4107731	
26191	2283	4252419	1987-02-28	1987-02-28 00:00:00	38000275	0	\N	\N	151882	0	74016001	4252419	
14439	1285	4078793	2017-10-16	2017-10-16 00:00:00	38000275	0	\N	\N	85022	0	180325003	4078793	
26616	2332	4170947	1964-08-11	1964-08-11 00:00:00	38000275	0	\N	\N	155122	0	274474001	4170947	
14851	1317	4035793	2002-11-15	2002-11-15 00:00:00	38000275	0	\N	\N	87309	0	15081005	4035793	
15119	1353	4125906	1964-09-08	1964-09-08 00:00:00	38000275	0	\N	\N	89639	0	288086009	4125906	
15214	1359	4078793	1994-06-07	1994-06-07 00:00:00	38000275	0	\N	\N	90175	0	180325003	4078793	
15501	1378	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	91436	0	180256009	4107731	
15523	1378	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	91328	0	180256009	4107731	
27681	2419	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	160525	0	180256009	4107731	
15896	1397	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	92843	0	180256009	4107731	
16144	1407	4107731	1990-01-27	1990-01-27 00:00:00	38000275	0	\N	\N	93537	0	180256009	4107731	
28301	2503	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	165671	0	180256009	4107731	
16611	1441	4107731	1992-01-06	1992-01-06 00:00:00	38000275	0	\N	\N	95969	0	180256009	4107731	
16747	1448	4295880	1997-01-31	1997-01-31 00:00:00	38000275	0	\N	\N	96607	0	76601001	4295880	
17012	1475	4170947	1951-02-25	1951-02-25 00:00:00	38000275	0	\N	\N	98248	0	274474001	4170947	
17043	1476	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	98396	0	180256009	4107731	
17316	1491	4024289	1982-04-26	1982-04-26 00:00:00	38000275	0	\N	\N	99451	0	19490002	4024289	
17411	1497	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	99812	0	180256009	4107731	
17678	1516	4252419	1982-09-26	1982-09-26 00:00:00	38000275	0	\N	\N	101270	0	74016001	4252419	
17947	1536	4125906	1944-03-10	1944-03-10 00:00:00	38000275	0	\N	\N	102789	0	288086009	4125906	
18032	1538	4107731	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	102930	0	180256009	4107731	
30140	2672	4107731	1990-08-26	1990-08-26 00:00:00	38000275	0	\N	\N	177042	0	180256009	4107731	
18507	1571	4197460	1966-01-06	1966-01-06 00:00:00	38000275	0	\N	\N	105505	0	313191000	4197460	
18536	1571	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	105526	0	180256009	4107731	
18784	1609	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	108133	0	180256009	4107731	
19019	1626	4078793	2008-11-09	2008-11-09 00:00:00	38000275	0	\N	\N	109237	0	180325003	4078793	
31113	2764	4295880	1993-10-29	1993-10-29 00:00:00	38000275	0	\N	\N	182795	0	76601001	4295880	
19328	1656	4295880	2015-03-07	2015-03-07 00:00:00	38000275	0	\N	\N	111145	0	76601001	4295880	
19537	1669	4170947	1965-01-22	1965-01-22 00:00:00	38000275	0	\N	\N	112069	0	274474001	4170947	
19777	1715	4151422	2015-01-08	2015-01-08 00:00:00	38000275	0	\N	\N	114565	0	269911007	4151422	
19986	1727	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	115539	0	180256009	4107731	
20039	1737	4202451	2013-10-11	2013-10-11 00:00:00	38000275	0	\N	\N	116083	0	433112001	4202451	
8413	764	4058899	1989-01-01	1989-01-01 00:00:00	38000275	0	\N	\N	50858	0	168594001	4058899	
32378	2846	4125906	1984-02-07	1984-02-07 00:00:00	38000275	0	\N	\N	188990	0	288086009	4125906	
32572	2862	4151422	1972-05-03	1972-05-03 00:00:00	38000275	0	\N	\N	190263	0	269911007	4151422	
32901	2891	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	192274	0	180256009	4107731	
21051	1821	4057420	1996-09-29	1996-09-29 00:00:00	38000275	0	\N	\N	121821	0	18286008	4057420	
21174	1837	4326177	1970-05-11	1970-05-11 00:00:00	38000275	0	\N	\N	122738	0	430193006	4326177	
21391	1852	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	123991	0	180256009	4107731	
45455	4014	4107731	1998-07-07	1998-07-07 00:00:00	38000275	0	\N	\N	266735	0	180256009	4107731	
21704	1882	4107731	1992-02-22	1992-02-22 00:00:00	38000275	0	\N	\N	125543	0	180256009	4107731	
33863	2947	4295880	1999-03-26	1999-03-26 00:00:00	38000275	0	\N	\N	196716	0	76601001	4295880	
22202	1945	4170947	1972-11-17	1972-11-17 00:00:00	38000275	0	\N	\N	129241	0	274474001	4170947	
22281	1950	4035793	2016-02-04	2016-02-04 00:00:00	38000275	0	\N	\N	129665	0	15081005	4035793	
22517	1971	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	131040	0	180256009	4107731	
22764	1980	4107731	1993-01-24	1993-01-24 00:00:00	38000275	0	\N	\N	131886	0	180256009	4107731	
22973	1999	4107731	2013-09-18	2013-09-18 00:00:00	38000275	0	\N	\N	133094	0	180256009	4107731	
46994	4123	4195803	2013-02-09	2013-02-09 00:00:00	38000275	0	\N	\N	274118	0	312681000	4195803	
23332	2028	4195803	1997-11-16	1997-11-16 00:00:00	38000275	0	\N	\N	134954	0	312681000	4195803	
35346	3088	4037675	1999-03-30	1999-03-30 00:00:00	38000275	0	\N	\N	205619	0	162676008	4037675	
23599	2062	4125906	1985-04-04	1985-04-04 00:00:00	38000275	0	\N	\N	137197	0	288086009	4125906	
23830	2075	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	138092	0	180256009	4107731	
11972	1099	4107731	1990-10-06	1990-10-06 00:00:00	38000275	0	\N	\N	72202	0	180256009	4107731	
24130	2108	4170947	1986-05-09	1986-05-09 00:00:00	38000275	0	\N	\N	140357	0	274474001	4170947	
12439	1115	4107731	1991-11-04	1991-11-04 00:00:00	38000275	0	\N	\N	73362	0	180256009	4107731	
24525	2140	4043071	1963-01-06	1963-01-06 00:00:00	38000275	0	\N	\N	142545	0	228557008	4043071	
24762	2168	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	144476	0	180256009	4107731	
13024	1176	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	77684	0	180256009	4107731	
25068	2186	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	145739	0	180256009	4107731	
13441	1219	4078793	2017-01-30	2017-01-30 00:00:00	38000275	0	\N	\N	80265	0	180325003	4078793	
13636	1238	4252419	1982-08-18	1982-08-18 00:00:00	38000275	0	\N	\N	81582	0	74016001	4252419	
13718	1246	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	82000	0	180256009	4107731	
13915	1261	4107731	1993-05-08	1993-05-08 00:00:00	38000275	0	\N	\N	83198	0	180256009	4107731	
14115	1272	4107731	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	83876	0	180256009	4107731	
26200	2286	4198190	1971-08-31	1971-08-31 00:00:00	38000275	0	\N	\N	152036	0	80146002	4198190	
14440	1285	4107731	1991-11-04	1991-11-04 00:00:00	38000275	0	\N	\N	84946	0	180256009	4107731	
26617	2333	4078793	2010-03-02	2010-03-02 00:00:00	38000275	0	\N	\N	155254	0	180325003	4078793	
14852	1317	4024289	1982-09-14	1982-09-14 00:00:00	38000275	0	\N	\N	87277	0	19490002	4024289	
15120	1353	4125906	1986-05-05	1986-05-05 00:00:00	38000275	0	\N	\N	89643	0	288086009	4125906	
15215	1359	4078793	2006-04-04	2006-04-04 00:00:00	38000275	0	\N	\N	90191	0	180325003	4078793	
15502	1378	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	91408	0	180256009	4107731	
15524	1378	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	91307	0	180256009	4107731	
27682	2419	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	160607	0	180256009	4107731	
15897	1397	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	92754	0	180256009	4107731	
16145	1407	4107731	1990-12-29	1990-12-29 00:00:00	38000275	0	\N	\N	93531	0	180256009	4107731	
28302	2503	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	165759	0	180256009	4107731	
16612	1441	4107731	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	95959	0	180256009	4107731	
16748	1448	4295880	1998-02-04	1998-02-04 00:00:00	38000275	0	\N	\N	96609	0	76601001	4295880	
17013	1475	4024289	1951-02-25	1951-02-25 00:00:00	38000275	0	\N	\N	98248	0	19490002	4024289	
17044	1476	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	98354	0	180256009	4107731	
17317	1491	4170947	1995-08-07	1995-08-07 00:00:00	38000275	0	\N	\N	99454	0	274474001	4170947	
17445	1500	4293740	1968-03-26	1968-03-26 00:00:00	38000275	0	\N	\N	100079	0	384700001	4293740	
17679	1516	4293740	1961-08-07	1961-08-07 00:00:00	38000275	0	\N	\N	101266	0	384700001	4293740	
17948	1536	4293740	1944-03-10	1944-03-10 00:00:00	38000275	0	\N	\N	102789	0	384700001	4293740	
18033	1538	4107731	1991-03-18	1991-03-18 00:00:00	38000275	0	\N	\N	102987	0	180256009	4107731	
30141	2672	4107731	1993-02-14	1993-02-14 00:00:00	38000275	0	\N	\N	176960	0	180256009	4107731	
18508	1571	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	105470	0	180256009	4107731	
18537	1571	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	105469	0	180256009	4107731	
18785	1609	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	108059	0	180256009	4107731	
19020	1626	4078793	1998-09-13	1998-09-13 00:00:00	38000275	0	\N	\N	109225	0	180325003	4078793	
31114	2764	4295880	1994-07-29	1994-07-29 00:00:00	38000275	0	\N	\N	182796	0	76601001	4295880	
19329	1656	4170947	1981-06-08	1981-06-08 00:00:00	38000275	0	\N	\N	111150	0	274474001	4170947	
19538	1669	4243062	1965-01-22	1965-01-22 00:00:00	38000275	0	\N	\N	112069	0	60027007	4243062	
19778	1715	4151422	1998-09-04	1998-09-04 00:00:00	38000275	0	\N	\N	114564	0	269911007	4151422	
19987	1727	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	115527	0	180256009	4107731	
20040	1737	4151422	1972-05-02	1972-05-02 00:00:00	38000275	0	\N	\N	116097	0	269911007	4151422	
8414	764	4170947	2012-05-30	2012-05-30 00:00:00	38000275	0	\N	\N	50859	0	274474001	4170947	
32379	2846	4125906	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	188991	0	288086009	4125906	
32573	2862	4125906	1999-03-15	1999-03-15 00:00:00	38000275	0	\N	\N	190261	0	288086009	4125906	
32902	2891	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	192375	0	180256009	4107731	
21052	1821	4125906	1998-10-07	1998-10-07 00:00:00	38000275	0	\N	\N	121775	0	288086009	4125906	
21175	1837	4037675	1970-05-11	1970-05-11 00:00:00	38000275	0	\N	\N	122738	0	162676008	4037675	
21392	1852	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	123915	0	180256009	4107731	
45456	4014	4107731	2000-12-05	2000-12-05 00:00:00	38000275	0	\N	\N	266724	0	180256009	4107731	
21705	1882	4107731	1990-02-17	1990-02-17 00:00:00	38000275	0	\N	\N	125535	0	180256009	4107731	
33864	2947	4275113	1998-03-29	1998-03-29 00:00:00	38000275	0	\N	\N	196713	0	65200003	4275113	
22203	1945	4047491	1972-11-17	1972-11-17 00:00:00	38000275	0	\N	\N	129241	0	1225002	4047491	
22282	1950	4035793	1996-10-17	1996-10-17 00:00:00	38000275	0	\N	\N	129683	0	15081005	4035793	
22518	1971	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	131039	0	180256009	4107731	
22765	1980	4107731	1990-07-15	1990-07-15 00:00:00	38000275	0	\N	\N	131799	0	180256009	4107731	
22974	1999	4107731	2013-04-24	2013-04-24 00:00:00	38000275	0	\N	\N	133147	0	180256009	4107731	
46995	4123	4163872	2013-02-09	2013-02-09 00:00:00	38000275	0	\N	\N	274118	0	399208008	4163872	
23333	2028	4151422	2007-01-12	2007-01-12 00:00:00	38000275	0	\N	\N	134975	0	269911007	4151422	
35347	3088	4326177	1999-03-30	1999-03-30 00:00:00	38000275	0	\N	\N	205619	0	430193006	4326177	
23600	2062	4195803	2006-02-16	2006-02-16 00:00:00	38000275	0	\N	\N	137200	0	312681000	4195803	
23831	2075	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	138084	0	180256009	4107731	
11973	1099	4107731	1992-11-21	1992-11-21 00:00:00	38000275	0	\N	\N	72232	0	180256009	4107731	
24131	2108	4243062	1986-05-09	1986-05-09 00:00:00	38000275	0	\N	\N	140357	0	60027007	4243062	
12440	1115	4107731	1990-08-20	1990-08-20 00:00:00	38000275	0	\N	\N	73442	0	180256009	4107731	
24526	2140	4043071	1962-10-07	1962-10-07 00:00:00	38000275	0	\N	\N	142526	0	228557008	4043071	
24763	2168	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	144523	0	180256009	4107731	
13025	1176	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	77678	0	180256009	4107731	
25069	2186	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	145808	0	180256009	4107731	
13442	1219	4078793	2007-12-10	2007-12-10 00:00:00	38000275	0	\N	\N	80264	0	180325003	4078793	
13637	1238	44783196	1982-08-25	1982-08-25 00:00:00	38000275	0	\N	\N	81606	0	699253003	44783196	
13719	1246	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	81989	0	180256009	4107731	
13916	1261	4107731	1991-03-23	1991-03-23 00:00:00	38000275	0	\N	\N	83182	0	180256009	4107731	
14116	1272	4107731	1994-02-25	1994-02-25 00:00:00	38000275	0	\N	\N	83909	0	180256009	4107731	
26201	2286	4125906	2004-02-24	2004-02-24 00:00:00	38000275	0	\N	\N	152093	0	288086009	4125906	
14441	1285	4107731	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	84937	0	180256009	4107731	
26618	2333	4078793	2004-07-06	2004-07-06 00:00:00	38000275	0	\N	\N	155145	0	180325003	4078793	
14853	1317	4170947	1982-09-14	1982-09-14 00:00:00	38000275	0	\N	\N	87277	0	274474001	4170947	
15121	1353	4195803	1968-08-09	1968-08-09 00:00:00	38000275	0	\N	\N	89640	0	312681000	4195803	
15216	1359	4078793	1997-06-24	1997-06-24 00:00:00	38000275	0	\N	\N	90187	0	180325003	4078793	
15503	1378	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	91298	0	180256009	4107731	
15525	1378	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	91368	0	180256009	4107731	
27683	2419	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	160538	0	180256009	4107731	
15898	1397	4059978	1992-11-05	1992-11-05 00:00:00	38000275	0	\N	\N	92749	0	169553002	4059978	
16146	1407	4107731	1990-08-04	1990-08-04 00:00:00	38000275	0	\N	\N	93577	0	180256009	4107731	
28303	2503	4107731	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	165733	0	180256009	4107731	
16613	1441	4107731	1992-08-03	1992-08-03 00:00:00	38000275	0	\N	\N	95961	0	180256009	4107731	
16749	1448	4295880	1997-08-06	1997-08-06 00:00:00	38000275	0	\N	\N	96575	0	76601001	4295880	
17014	1476	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	98416	0	180256009	4107731	
17045	1476	4078793	2011-01-06	2011-01-06 00:00:00	38000275	0	\N	\N	98523	0	180325003	4078793	
17318	1491	4163872	1995-08-07	1995-08-07 00:00:00	38000275	0	\N	\N	99454	0	399208008	4163872	
17446	1500	4125906	1968-03-26	1968-03-26 00:00:00	38000275	0	\N	\N	100079	0	288086009	4125906	
17680	1516	4125906	1961-08-07	1961-08-07 00:00:00	38000275	0	\N	\N	101266	0	288086009	4125906	
17949	1537	4186930	1979-05-23	1979-05-23 00:00:00	38000275	0	\N	\N	102876	0	46706006	4186930	
18035	1540	4163872	1973-04-10	1973-04-10 00:00:00	38000275	0	\N	\N	103154	0	399208008	4163872	
30142	2672	4107731	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	176923	0	180256009	4107731	
18509	1571	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	105419	0	180256009	4107731	
18538	1571	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	105509	0	180256009	4107731	
18786	1609	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	108109	0	180256009	4107731	
19021	1626	4057420	1999-09-19	1999-09-19 00:00:00	38000275	0	\N	\N	109235	0	18286008	4057420	
31115	2764	4295880	1993-01-29	1993-01-29 00:00:00	38000275	0	\N	\N	182794	0	76601001	4295880	
19330	1656	4163872	1981-06-08	1981-06-08 00:00:00	38000275	0	\N	\N	111150	0	399208008	4163872	
19539	1669	4035793	2017-05-01	2017-05-01 00:00:00	38000275	0	\N	\N	112108	0	15081005	4035793	
19779	1716	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	114626	0	180256009	4107731	
19988	1727	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	115470	0	180256009	4107731	
20041	1737	4163872	2000-10-12	2000-10-12 00:00:00	38000275	0	\N	\N	115964	0	399208008	4163872	
8415	764	4024289	2012-05-30	2012-05-30 00:00:00	38000275	0	\N	\N	50859	0	19490002	4024289	
32380	2846	4170947	1979-12-30	1979-12-30 00:00:00	38000275	0	\N	\N	188987	0	274474001	4170947	
32574	2862	4330583	2003-08-31	2003-08-31 00:00:00	38000275	0	\N	\N	190285	0	22523008	4330583	
32903	2891	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	192288	0	180256009	4107731	
21053	1821	4078793	2013-11-17	2013-11-17 00:00:00	38000275	0	\N	\N	121829	0	180325003	4078793	
21176	1837	4043071	1973-10-11	1973-10-11 00:00:00	38000275	0	\N	\N	122667	0	228557008	4043071	
21393	1852	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	123952	0	395142003	4191853	
45457	4014	4107731	1999-04-27	1999-04-27 00:00:00	38000275	0	\N	\N	266803	0	180256009	4107731	
21706	1882	4191853	1990-01-06	1990-01-06 00:00:00	38000275	0	\N	\N	125482	0	395142003	4191853	
33865	2947	4238715	2004-09-15	2004-09-15 00:00:00	38000275	0	\N	\N	196707	0	68254000	4238715	
22204	1945	4125906	1985-01-13	1985-01-13 00:00:00	38000275	0	\N	\N	129242	0	288086009	4125906	
22283	1950	4035793	2009-12-31	2009-12-31 00:00:00	38000275	0	\N	\N	129622	0	15081005	4035793	
22519	1971	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	131088	0	180256009	4107731	
22766	1980	4107731	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	131793	0	180256009	4107731	
22975	1999	4191853	2011-10-05	2011-10-05 00:00:00	38000275	0	\N	\N	133114	0	395142003	4191853	
46996	4123	4170947	2013-02-09	2013-02-09 00:00:00	38000275	0	\N	\N	274118	0	274474001	4170947	
23334	2028	4181917	1977-11-27	1977-11-27 00:00:00	38000275	0	\N	\N	134950	0	54550000	4181917	
35348	3088	4125906	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	205639	0	288086009	4125906	
23601	2062	4058899	2006-02-16	2006-02-16 00:00:00	38000275	0	\N	\N	137200	0	168594001	4058899	
23832	2075	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	138106	0	180256009	4107731	
11974	1099	4107731	1991-06-15	1991-06-15 00:00:00	38000275	0	\N	\N	72179	0	180256009	4107731	
24132	2108	4243062	1945-03-10	1945-03-10 00:00:00	38000275	0	\N	\N	140353	0	60027007	4243062	
12441	1115	4107731	1991-07-22	1991-07-22 00:00:00	38000275	0	\N	\N	73411	0	180256009	4107731	
24527	2140	4043071	1963-08-11	1963-08-11 00:00:00	38000275	0	\N	\N	142531	0	228557008	4043071	
24764	2168	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	144544	0	180256009	4107731	
13026	1176	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	77607	0	180256009	4107731	
25070	2186	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	145821	0	180256009	4107731	
13443	1219	4057420	2009-12-21	2009-12-21 00:00:00	38000275	0	\N	\N	80231	0	18286008	4057420	
13638	1238	4058899	2004-06-05	2004-06-05 00:00:00	38000275	0	\N	\N	81584	0	168594001	4058899	
13720	1246	4197460	1939-02-15	1939-02-15 00:00:00	38000275	0	\N	\N	82133	0	313191000	4197460	
13917	1261	4107731	1990-04-21	1990-04-21 00:00:00	38000275	0	\N	\N	83242	0	180256009	4107731	
14117	1272	4107731	1994-07-01	1994-07-01 00:00:00	38000275	0	\N	\N	83885	0	180256009	4107731	
26202	2287	4078793	2006-06-02	2006-06-02 00:00:00	38000275	0	\N	\N	152147	0	180325003	4078793	
14442	1285	4107731	1991-08-12	1991-08-12 00:00:00	38000275	0	\N	\N	84993	0	180256009	4107731	
26619	2333	4057420	1992-04-28	1992-04-28 00:00:00	38000275	0	\N	\N	155232	0	18286008	4057420	
14854	1317	4125906	1999-01-18	1999-01-18 00:00:00	38000275	0	\N	\N	87279	0	288086009	4125906	
15122	1353	4170947	1968-08-09	1968-08-09 00:00:00	38000275	0	\N	\N	89640	0	274474001	4170947	
15217	1359	4078793	1991-05-07	1991-05-07 00:00:00	38000275	0	\N	\N	90186	0	180325003	4078793	
15504	1378	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	91302	0	180256009	4107731	
15526	1378	4107731	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	91405	0	180256009	4107731	
27684	2419	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	160485	0	180256009	4107731	
15899	1397	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	92759	0	180256009	4107731	
16147	1407	4107731	1992-02-01	1992-02-01 00:00:00	38000275	0	\N	\N	93552	0	180256009	4107731	
28304	2503	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	165705	0	180256009	4107731	
16614	1441	4107731	1991-11-25	1991-11-25 00:00:00	38000275	0	\N	\N	95968	0	180256009	4107731	
16750	1448	4295880	1997-11-05	1997-11-05 00:00:00	38000275	0	\N	\N	96590	0	76601001	4295880	
17015	1476	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	98404	0	180256009	4107731	
17046	1476	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	98394	0	180256009	4107731	
17319	1491	4125906	2001-06-06	2001-06-06 00:00:00	38000275	0	\N	\N	99455	0	288086009	4125906	
17447	1500	4125906	1965-07-26	1965-07-26 00:00:00	38000275	0	\N	\N	100078	0	288086009	4125906	
17681	1516	4252419	1960-08-05	1960-08-05 00:00:00	38000275	0	\N	\N	101265	0	74016001	4252419	
17950	1537	4275113	1974-05-22	1974-05-22 00:00:00	38000275	0	\N	\N	102898	0	65200003	4275113	
18036	1540	4170947	1973-04-10	1973-04-10 00:00:00	38000275	0	\N	\N	103154	0	274474001	4170947	
30143	2672	4107731	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	176951	0	180256009	4107731	
18510	1571	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	105458	0	180256009	4107731	
18539	1571	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	105498	0	180256009	4107731	
18787	1609	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	108191	0	395142003	4191853	
19022	1626	4078793	2006-10-29	2006-10-29 00:00:00	38000275	0	\N	\N	109219	0	180325003	4078793	
31116	2764	4295880	1993-07-30	1993-07-30 00:00:00	38000275	0	\N	\N	182805	0	76601001	4295880	
19331	1656	4295880	2013-06-08	2013-06-08 00:00:00	38000275	0	\N	\N	111136	0	76601001	4295880	
19540	1670	4125906	2017-01-01	2017-01-01 00:00:00	38000275	0	\N	\N	112173	0	288086009	4125906	
19780	1716	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	114749	0	180256009	4107731	
19989	1727	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	115549	0	180256009	4107731	
20042	1737	4170947	2000-10-12	2000-10-12 00:00:00	38000275	0	\N	\N	115964	0	274474001	4170947	
20197	1744	4151422	1980-05-06	1980-05-06 00:00:00	38000275	0	\N	\N	116611	0	269911007	4151422	
32381	2846	4024289	1979-12-30	1979-12-30 00:00:00	38000275	0	\N	\N	188987	0	19490002	4024289	
32575	2863	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	190328	0	180256009	4107731	
32904	2891	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	192340	0	180256009	4107731	
21054	1821	4078793	2011-11-06	2011-11-06 00:00:00	38000275	0	\N	\N	121828	0	180325003	4078793	
21177	1837	4151422	1971-06-07	1971-06-07 00:00:00	38000275	0	\N	\N	122739	0	269911007	4151422	
21394	1852	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	123983	0	180256009	4107731	
45458	4014	4107731	1998-01-20	1998-01-20 00:00:00	38000275	0	\N	\N	266771	0	180256009	4107731	
21707	1882	4047491	2015-04-09	2015-04-09 00:00:00	38000275	0	\N	\N	125569	0	1225002	4047491	
33866	2947	4186930	2003-04-01	2003-04-01 00:00:00	38000275	0	\N	\N	196682	0	46706006	4186930	
22205	1946	4195803	2008-10-23	2008-10-23 00:00:00	38000275	0	\N	\N	129278	0	312681000	4195803	
22284	1950	4035793	1989-07-13	1989-07-13 00:00:00	38000275	0	\N	\N	129691	0	15081005	4035793	
22520	1971	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	131061	0	180256009	4107731	
22767	1980	4107731	1990-10-07	1990-10-07 00:00:00	38000275	0	\N	\N	131801	0	180256009	4107731	
22976	1999	4107731	2012-01-18	2012-01-18 00:00:00	38000275	0	\N	\N	133075	0	180256009	4107731	
46997	4123	4125906	1976-12-24	1976-12-24 00:00:00	38000275	0	\N	\N	274115	0	288086009	4125906	
23335	2028	4181917	1978-01-08	1978-01-08 00:00:00	38000275	0	\N	\N	134951	0	54550000	4181917	
35349	3088	4125906	1970-03-16	1970-03-16 00:00:00	38000275	0	\N	\N	205637	0	288086009	4125906	
23602	2062	4078793	2014-11-29	2014-11-29 00:00:00	38000275	0	\N	\N	137121	0	180325003	4078793	
23833	2075	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	138118	0	395142003	4191853	
11975	1099	4107731	1990-03-31	1990-03-31 00:00:00	38000275	0	\N	\N	72215	0	180256009	4107731	
24133	2108	4170947	1945-03-10	1945-03-10 00:00:00	38000275	0	\N	\N	140353	0	274474001	4170947	
12442	1115	4107731	1992-11-16	1992-11-16 00:00:00	38000275	0	\N	\N	73495	0	180256009	4107731	
24528	2141	4252419	1961-09-01	1961-09-01 00:00:00	38000275	0	\N	\N	142598	0	74016001	4252419	
24765	2168	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	144528	0	180256009	4107731	
13027	1176	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	77673	0	180256009	4107731	
25071	2186	4125906	1987-10-28	1987-10-28 00:00:00	38000275	0	\N	\N	145827	0	288086009	4125906	
13444	1219	4057420	2018-02-05	2018-02-05 00:00:00	38000275	0	\N	\N	80254	0	18286008	4057420	
13639	1239	4037675	1980-06-22	1980-06-22 00:00:00	38000275	0	\N	\N	81638	0	162676008	4037675	
13721	1246	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	82089	0	180256009	4107731	
13918	1261	4107731	1990-06-23	1990-06-23 00:00:00	38000275	0	\N	\N	83253	0	180256009	4107731	
14118	1272	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	83877	0	180256009	4107731	
26203	2287	4078793	2009-06-19	2009-06-19 00:00:00	38000275	0	\N	\N	152190	0	180325003	4078793	
14443	1285	4107731	1990-12-03	1990-12-03 00:00:00	38000275	0	\N	\N	84938	0	180256009	4107731	
26620	2333	4078793	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	155231	0	180325003	4078793	
14855	1317	4035793	2003-11-21	2003-11-21 00:00:00	38000275	0	\N	\N	87314	0	15081005	4035793	
15123	1353	4163872	1968-08-09	1968-08-09 00:00:00	38000275	0	\N	\N	89640	0	399208008	4163872	
15218	1359	4078793	2004-03-23	2004-03-23 00:00:00	38000275	0	\N	\N	90190	0	180325003	4078793	
15505	1378	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	91409	0	180256009	4107731	
15527	1378	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	91372	0	180256009	4107731	
27685	2419	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	160524	0	180256009	4107731	
15900	1397	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	92762	0	180256009	4107731	
16148	1407	4107731	1993-02-13	1993-02-13 00:00:00	38000275	0	\N	\N	93571	0	180256009	4107731	
28305	2503	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	165719	0	180256009	4107731	
16615	1441	4107731	1992-12-07	1992-12-07 00:00:00	38000275	0	\N	\N	96020	0	180256009	4107731	
16751	1448	4295880	1997-05-07	1997-05-07 00:00:00	38000275	0	\N	\N	96608	0	76601001	4295880	
17016	1476	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	98462	0	180256009	4107731	
17047	1476	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	98461	0	180256009	4107731	
17320	1491	4336464	2011-07-12	2011-07-12 00:00:00	38000275	0	\N	\N	99456	0	232717009	4336464	
17452	1504	4198190	1960-06-07	1960-06-07 00:00:00	38000275	0	\N	\N	100221	0	80146002	4198190	
17682	1517	4043071	1945-04-23	1945-04-23 00:00:00	38000275	0	\N	\N	101395	0	228557008	4043071	
17951	1537	4151422	2010-12-29	2010-12-29 00:00:00	38000275	0	\N	\N	102862	0	269911007	4151422	
18037	1540	4202451	2018-12-10	2018-12-10 00:00:00	38000275	0	\N	\N	103181	0	433112001	4202451	
30144	2672	4107731	1991-12-22	1991-12-22 00:00:00	38000275	0	\N	\N	177009	0	180256009	4107731	
18511	1571	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	105471	0	180256009	4107731	
18540	1571	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	105440	0	180256009	4107731	
18788	1609	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	108063	0	180256009	4107731	
19023	1626	4078793	1996-09-01	1996-09-01 00:00:00	38000275	0	\N	\N	109224	0	180325003	4078793	
31117	2764	4295880	1995-04-28	1995-04-28 00:00:00	38000275	0	\N	\N	182797	0	76601001	4295880	
19332	1656	4295880	2011-06-11	2011-06-11 00:00:00	38000275	0	\N	\N	111140	0	76601001	4295880	
19541	1670	4062501	1968-01-11	1968-01-11 00:00:00	38000275	0	\N	\N	112131	0	171231001	4062501	
19781	1716	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	114745	0	180256009	4107731	
19990	1727	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	115472	0	180256009	4107731	
20043	1737	4195803	2000-10-12	2000-10-12 00:00:00	38000275	0	\N	\N	115964	0	312681000	4195803	
20198	1744	4125906	2007-07-04	2007-07-04 00:00:00	38000275	0	\N	\N	116628	0	288086009	4125906	
32382	2846	4145310	1982-04-18	1982-04-18 00:00:00	38000275	0	\N	\N	188989	0	268425006	4145310	
32576	2863	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	190356	0	180256009	4107731	
32905	2891	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	192342	0	180256009	4107731	
21055	1821	4078793	2018-03-04	2018-03-04 00:00:00	38000275	0	\N	\N	121831	0	180325003	4078793	
21178	1837	4197460	1964-01-23	1964-01-23 00:00:00	38000275	0	\N	\N	122691	0	313191000	4197460	
21395	1852	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	123978	0	180256009	4107731	
45459	4014	4107731	2000-05-30	2000-05-30 00:00:00	38000275	0	\N	\N	266703	0	180256009	4107731	
21708	1882	4170947	2015-04-09	2015-04-09 00:00:00	38000275	0	\N	\N	125569	0	274474001	4170947	
33867	2947	4059978	2003-03-05	2003-03-05 00:00:00	38000275	0	\N	\N	196706	0	169553002	4059978	
22206	1946	4058899	2008-10-23	2008-10-23 00:00:00	38000275	0	\N	\N	129278	0	168594001	4058899	
22285	1950	4035793	2001-11-15	2001-11-15 00:00:00	38000275	0	\N	\N	129619	0	15081005	4035793	
22521	1971	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	131023	0	180256009	4107731	
22768	1980	4107731	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	131763	0	180256009	4107731	
22977	1999	4107731	2013-06-05	2013-06-05 00:00:00	38000275	0	\N	\N	133148	0	180256009	4107731	
46998	4124	4151422	2013-03-22	2013-03-22 00:00:00	38000275	0	\N	\N	274194	0	269911007	4151422	
23336	2028	4125906	2003-09-16	2003-09-16 00:00:00	38000275	0	\N	\N	135030	0	288086009	4125906	
35350	3088	4125906	1963-06-07	1963-06-07 00:00:00	38000275	0	\N	\N	205636	0	288086009	4125906	
23603	2062	4057420	2016-07-23	2016-07-23 00:00:00	38000275	0	\N	\N	137129	0	18286008	4057420	
23834	2075	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	138088	0	180256009	4107731	
11976	1099	4107731	1990-04-21	1990-04-21 00:00:00	38000275	0	\N	\N	72111	0	180256009	4107731	
24134	2108	4078793	2018-12-28	2018-12-28 00:00:00	38000275	0	\N	\N	140382	0	180325003	4078793	
12443	1115	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	73370	0	180256009	4107731	
24529	2141	44783196	1961-09-08	1961-09-08 00:00:00	38000275	0	\N	\N	142596	0	699253003	44783196	
24766	2168	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	144525	0	180256009	4107731	
13028	1176	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	77612	0	180256009	4107731	
25072	2186	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	145722	0	180256009	4107731	
13445	1219	4078793	2013-10-21	2013-10-21 00:00:00	38000275	0	\N	\N	80258	0	180325003	4078793	
13640	1239	4326177	1980-06-22	1980-06-22 00:00:00	38000275	0	\N	\N	81638	0	430193006	4326177	
13722	1246	4170947	1955-01-22	1955-01-22 00:00:00	38000275	0	\N	\N	82135	0	274474001	4170947	
13919	1261	4107731	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	83167	0	180256009	4107731	
14119	1272	4107731	1995-08-04	1995-08-04 00:00:00	38000275	0	\N	\N	83938	0	180256009	4107731	
26204	2287	4057420	2014-01-24	2014-01-24 00:00:00	38000275	0	\N	\N	152154	0	18286008	4057420	
14444	1285	4107731	1993-03-01	1993-03-01 00:00:00	38000275	0	\N	\N	84958	0	180256009	4107731	
26621	2333	4078793	2005-07-12	2005-07-12 00:00:00	38000275	0	\N	\N	155235	0	180325003	4078793	
14856	1317	4035793	2004-11-26	2004-11-26 00:00:00	38000275	0	\N	\N	87310	0	15081005	4035793	
15124	1353	4151422	1985-06-12	1985-06-12 00:00:00	38000275	0	\N	\N	89661	0	269911007	4151422	
15219	1359	4078793	1998-02-17	1998-02-17 00:00:00	38000275	0	\N	\N	90152	0	180325003	4078793	
15506	1378	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	91380	0	180256009	4107731	
15528	1378	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	91300	0	180256009	4107731	
27686	2419	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	160623	0	180256009	4107731	
15901	1397	4295880	1994-10-26	1994-10-26 00:00:00	38000275	0	\N	\N	92736	0	76601001	4295880	
16149	1407	4107731	1991-07-06	1991-07-06 00:00:00	38000275	0	\N	\N	93588	0	180256009	4107731	
28306	2503	4151422	1999-01-07	1999-01-07 00:00:00	38000275	0	\N	\N	165651	0	269911007	4151422	
16616	1441	4107731	1990-06-18	1990-06-18 00:00:00	38000275	0	\N	\N	96061	0	180256009	4107731	
16755	1450	4125906	1994-11-21	1994-11-21 00:00:00	38000275	0	\N	\N	96696	0	288086009	4125906	
17017	1476	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	98334	0	180256009	4107731	
17048	1476	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	98395	0	395142003	4191853	
17321	1491	4216130	2011-07-12	2011-07-12 00:00:00	38000275	0	\N	\N	99456	0	415070008	4216130	
17453	1504	4024289	1959-06-20	1959-06-20 00:00:00	38000275	0	\N	\N	100217	0	19490002	4024289	
17683	1517	4043071	1947-11-10	1947-11-10 00:00:00	38000275	0	\N	\N	101454	0	228557008	4043071	
17952	1537	4238715	1983-12-21	1983-12-21 00:00:00	38000275	0	\N	\N	102929	0	68254000	4238715	
18038	1540	4163872	2004-12-08	2004-12-08 00:00:00	38000275	0	\N	\N	103166	0	399208008	4163872	
30145	2672	4107731	1990-07-15	1990-07-15 00:00:00	38000275	0	\N	\N	177041	0	180256009	4107731	
18512	1571	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	105529	0	180256009	4107731	
18541	1571	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	105527	0	180256009	4107731	
18789	1609	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	108171	0	180256009	4107731	
19024	1626	4078793	1997-09-07	1997-09-07 00:00:00	38000275	0	\N	\N	109234	0	180325003	4078793	
31118	2764	4295880	1997-04-25	1997-04-25 00:00:00	38000275	0	\N	\N	182751	0	76601001	4295880	
19333	1656	4295880	2005-06-18	2005-06-18 00:00:00	38000275	0	\N	\N	111058	0	76601001	4295880	
19542	1672	4125906	2007-09-19	2007-09-19 00:00:00	38000275	0	\N	\N	112283	0	288086009	4125906	
19782	1716	4195803	2010-08-25	2010-08-25 00:00:00	38000275	0	\N	\N	114709	0	312681000	4195803	
19991	1727	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	115566	0	180256009	4107731	
20044	1738	4151422	1971-11-02	1971-11-02 00:00:00	38000275	0	\N	\N	116103	0	269911007	4151422	
20199	1744	4058899	1981-09-27	1981-09-27 00:00:00	38000275	0	\N	\N	116626	0	168594001	4058899	
32383	2847	4151422	2009-06-09	2009-06-09 00:00:00	38000275	0	\N	\N	189106	0	269911007	4151422	
32577	2863	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	190346	0	180256009	4107731	
32906	2891	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	192348	0	180256009	4107731	
21056	1821	4078793	2012-11-11	2012-11-11 00:00:00	38000275	0	\N	\N	121847	0	180325003	4078793	
21179	1837	4043071	1973-11-15	1973-11-15 00:00:00	38000275	0	\N	\N	122683	0	228557008	4043071	
21396	1852	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	123974	0	180256009	4107731	
45460	4014	4107731	1998-08-18	1998-08-18 00:00:00	38000275	0	\N	\N	266786	0	180256009	4107731	
21709	1882	4107731	1990-04-21	1990-04-21 00:00:00	38000275	0	\N	\N	125592	0	180256009	4107731	
33868	2947	4293740	1991-03-28	1991-03-28 00:00:00	38000275	0	\N	\N	196699	0	384700001	4293740	
22207	1946	4078793	2017-01-21	2017-01-21 00:00:00	38000275	0	\N	\N	129345	0	180325003	4078793	
22286	1950	4035793	1993-09-30	1993-09-30 00:00:00	38000275	0	\N	\N	129656	0	15081005	4035793	
22522	1971	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	131092	0	180256009	4107731	
22769	1980	4107731	1990-10-28	1990-10-28 00:00:00	38000275	0	\N	\N	131862	0	180256009	4107731	
22978	1999	4043071	1992-01-03	1992-01-03 00:00:00	38000275	0	\N	\N	133073	0	228557008	4043071	
46999	4124	4125906	1977-02-28	1977-02-28 00:00:00	38000275	0	\N	\N	274209	0	288086009	4125906	
23337	2028	4125906	1984-07-13	1984-07-13 00:00:00	38000275	0	\N	\N	134952	0	288086009	4125906	
35355	3090	4330583	1991-01-23	1991-01-23 00:00:00	38000275	0	\N	\N	205759	0	22523008	4330583	
23604	2064	4275113	1994-03-21	1994-03-21 00:00:00	38000275	0	\N	\N	137286	0	65200003	4275113	
23835	2075	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	138099	0	180256009	4107731	
11977	1099	4107731	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	72182	0	180256009	4107731	
24135	2108	4151422	1951-09-26	1951-09-26 00:00:00	38000275	0	\N	\N	140313	0	269911007	4151422	
12444	1115	4125906	1984-11-14	1984-11-14 00:00:00	38000275	0	\N	\N	73388	0	288086009	4125906	
24530	2141	4024289	1956-01-31	1956-01-31 00:00:00	38000275	0	\N	\N	142597	0	19490002	4024289	
24767	2168	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	144571	0	180256009	4107731	
13029	1176	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	77689	0	180256009	4107731	
25073	2186	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	145723	0	180256009	4107731	
13446	1219	4078793	2008-12-15	2008-12-15 00:00:00	38000275	0	\N	\N	80275	0	180325003	4078793	
13641	1239	4187458	1980-06-22	1980-06-22 00:00:00	38000275	0	\N	\N	81638	0	415300000	4187458	
13723	1246	4047491	1955-01-22	1955-01-22 00:00:00	38000275	0	\N	\N	82135	0	1225002	4047491	
13920	1261	4191853	1990-01-06	1990-01-06 00:00:00	38000275	0	\N	\N	83248	0	395142003	4191853	
14120	1272	4191853	1996-03-22	1996-03-22 00:00:00	38000275	0	\N	\N	83928	0	395142003	4191853	
26205	2287	40492359	2014-01-24	2014-01-24 00:00:00	38000275	0	\N	\N	152154	0	447365002	40492359	
14445	1285	4107731	1992-02-17	1992-02-17 00:00:00	38000275	0	\N	\N	85040	0	180256009	4107731	
26622	2333	4125906	1951-03-31	1951-03-31 00:00:00	38000275	0	\N	\N	155161	0	288086009	4125906	
14857	1317	4035793	2013-01-11	2013-01-11 00:00:00	38000275	0	\N	\N	87302	0	15081005	4035793	
15125	1354	4151422	2018-02-22	2018-02-22 00:00:00	38000275	0	\N	\N	89766	0	269911007	4151422	
15220	1359	4078793	1996-06-18	1996-06-18 00:00:00	38000275	0	\N	\N	90176	0	180325003	4078793	
15507	1378	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	91387	0	180256009	4107731	
15529	1378	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	91373	0	180256009	4107731	
27687	2419	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	160523	0	180256009	4107731	
15902	1397	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	92847	0	180256009	4107731	
16150	1407	4107731	1993-05-29	1993-05-29 00:00:00	38000275	0	\N	\N	93471	0	180256009	4107731	
28307	2503	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	165735	0	180256009	4107731	
16617	1441	4107731	1992-12-28	1992-12-28 00:00:00	38000275	0	\N	\N	96083	0	180256009	4107731	
16829	1459	4243062	1997-07-15	1997-07-15 00:00:00	38000275	0	\N	\N	97248	0	60027007	4243062	
28847	2554	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	169120	0	180256009	4107731	
17049	1476	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	98355	0	180256009	4107731	
17323	1493	4151422	2006-08-09	2006-08-09 00:00:00	38000275	0	\N	\N	99570	0	269911007	4151422	
17454	1504	4170947	1959-06-20	1959-06-20 00:00:00	38000275	0	\N	\N	100217	0	274474001	4170947	
17684	1517	4057420	2018-04-23	2018-04-23 00:00:00	38000275	0	\N	\N	101408	0	18286008	4057420	
29734	2644	4151422	2006-05-26	2006-05-26 00:00:00	38000275	0	\N	\N	174973	0	269911007	4151422	
18039	1541	4125906	1983-03-13	1983-03-13 00:00:00	38000275	0	\N	\N	103301	0	288086009	4125906	
30146	2672	4107731	1991-06-16	1991-06-16 00:00:00	38000275	0	\N	\N	177008	0	180256009	4107731	
18513	1571	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	105438	0	180256009	4107731	
18542	1571	4170947	1971-02-03	1971-02-03 00:00:00	38000275	0	\N	\N	105506	0	274474001	4170947	
18790	1609	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	108131	0	180256009	4107731	
19025	1626	4078793	2007-11-04	2007-11-04 00:00:00	38000275	0	\N	\N	109202	0	180325003	4078793	
31119	2764	4295880	1996-07-26	1996-07-26 00:00:00	38000275	0	\N	\N	182750	0	76601001	4295880	
19334	1656	4295880	2006-12-16	2006-12-16 00:00:00	38000275	0	\N	\N	111157	0	76601001	4295880	
19543	1672	4151422	2001-08-17	2001-08-17 00:00:00	38000275	0	\N	\N	112243	0	269911007	4151422	
19783	1716	4058899	2010-08-25	2010-08-25 00:00:00	38000275	0	\N	\N	114709	0	168594001	4058899	
19992	1727	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	115551	0	180256009	4107731	
20045	1738	4151422	2006-03-19	2006-03-19 00:00:00	38000275	0	\N	\N	116107	0	269911007	4151422	
20200	1745	4275113	2008-10-26	2008-10-26 00:00:00	38000275	0	\N	\N	116655	0	65200003	4275113	
32384	2847	4125906	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	189120	0	288086009	4125906	
32578	2863	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	190323	0	180256009	4107731	
32907	2891	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	192267	0	180256009	4107731	
21078	1826	4252419	1964-05-04	1964-05-04 00:00:00	38000275	0	\N	\N	122061	0	74016001	4252419	
21180	1837	4043071	1973-06-07	1973-06-07 00:00:00	38000275	0	\N	\N	122682	0	228557008	4043071	
21397	1852	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	123984	0	180256009	4107731	
45461	4014	4191853	1997-12-09	1997-12-09 00:00:00	38000275	0	\N	\N	266770	0	395142003	4191853	
21710	1882	4107731	1992-04-04	1992-04-04 00:00:00	38000275	0	\N	\N	125544	0	180256009	4107731	
33869	2947	4125906	1991-03-28	1991-03-28 00:00:00	38000275	0	\N	\N	196699	0	288086009	4125906	
22208	1946	4078793	2017-10-28	2017-10-28 00:00:00	38000275	0	\N	\N	129346	0	180325003	4078793	
22287	1950	4035793	1995-10-12	1995-10-12 00:00:00	38000275	0	\N	\N	129657	0	15081005	4035793	
22523	1971	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	131099	0	180256009	4107731	
22770	1980	4107731	1990-08-26	1990-08-26 00:00:00	38000275	0	\N	\N	131800	0	180256009	4107731	
22979	1999	4107731	2013-10-30	2013-10-30 00:00:00	38000275	0	\N	\N	133100	0	180256009	4107731	
47000	4125	4058899	1978-01-08	1978-01-08 00:00:00	38000275	0	\N	\N	274212	0	168594001	4058899	
23338	2030	4151422	1995-01-05	1995-01-05 00:00:00	38000275	0	\N	\N	135159	0	269911007	4151422	
35356	3090	4125906	1980-09-10	1980-09-10 00:00:00	38000275	0	\N	\N	205727	0	288086009	4125906	
23605	2064	4293740	2008-11-06	2008-11-06 00:00:00	38000275	0	\N	\N	137306	0	384700001	4293740	
23836	2075	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	138096	0	180256009	4107731	
11978	1099	4107731	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	72185	0	180256009	4107731	
24136	2108	4198190	1978-08-31	1978-08-31 00:00:00	38000275	0	\N	\N	140300	0	80146002	4198190	
12445	1115	4125906	1964-10-09	1964-10-09 00:00:00	38000275	0	\N	\N	73386	0	288086009	4125906	
24531	2141	4170947	1956-01-31	1956-01-31 00:00:00	38000275	0	\N	\N	142597	0	274474001	4170947	
24768	2168	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	144560	0	180256009	4107731	
13030	1176	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	77681	0	180256009	4107731	
25074	2186	4125906	2003-09-09	2003-09-09 00:00:00	38000275	0	\N	\N	145830	0	288086009	4125906	
13447	1219	4078793	2016-01-25	2016-01-25 00:00:00	38000275	0	\N	\N	80223	0	180325003	4078793	
13642	1242	4125906	1989-12-26	1989-12-26 00:00:00	38000275	0	\N	\N	81769	0	288086009	4125906	
13724	1246	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	82026	0	180256009	4107731	
13921	1261	4107731	1990-12-08	1990-12-08 00:00:00	38000275	0	\N	\N	83160	0	180256009	4107731	
14121	1272	4107731	1994-12-16	1994-12-16 00:00:00	38000275	0	\N	\N	83936	0	180256009	4107731	
26206	2287	4078793	2012-12-28	2012-12-28 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
14446	1285	4107731	1990-10-01	1990-10-01 00:00:00	38000275	0	\N	\N	84989	0	180256009	4107731	
26623	2333	4293740	1951-03-31	1951-03-31 00:00:00	38000275	0	\N	\N	155161	0	384700001	4293740	
14858	1317	4035793	2009-12-25	2009-12-25 00:00:00	38000275	0	\N	\N	87331	0	15081005	4035793	
15126	1354	4293740	1980-01-27	1980-01-27 00:00:00	38000275	0	\N	\N	89760	0	384700001	4293740	
15221	1359	4078793	2003-03-18	2003-03-18 00:00:00	38000275	0	\N	\N	90124	0	180325003	4078793	
15508	1378	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	91406	0	180256009	4107731	
15530	1378	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	91386	0	180256009	4107731	
27688	2419	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	160560	0	180256009	4107731	
15903	1397	4199276	1998-10-23	1998-10-23 00:00:00	38000275	0	\N	\N	92777	0	301807007	4199276	
16151	1407	4107731	1993-03-27	1993-03-27 00:00:00	38000275	0	\N	\N	93482	0	180256009	4107731	
28308	2503	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	165760	0	180256009	4107731	
16618	1441	4058899	1974-01-20	1974-01-20 00:00:00	38000275	0	\N	\N	95947	0	168594001	4058899	
16830	1459	4170947	1997-07-15	1997-07-15 00:00:00	38000275	0	\N	\N	97248	0	274474001	4170947	
28848	2554	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	169236	0	180256009	4107731	
17050	1476	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	98476	0	180256009	4107731	
17324	1493	4163872	1972-07-03	1972-07-03 00:00:00	38000275	0	\N	\N	99575	0	399208008	4163872	
17455	1504	4058899	1957-04-01	1957-04-01 00:00:00	38000275	0	\N	\N	100255	0	168594001	4058899	
17685	1517	4043071	1946-02-04	1946-02-04 00:00:00	38000275	0	\N	\N	101411	0	228557008	4043071	
29737	2646	4151422	1986-11-16	1986-11-16 00:00:00	38000275	0	\N	\N	175064	0	269911007	4151422	
18040	1541	4293740	1983-03-13	1983-03-13 00:00:00	38000275	0	\N	\N	103301	0	384700001	4293740	
30147	2672	4107731	1992-01-12	1992-01-12 00:00:00	38000275	0	\N	\N	176954	0	180256009	4107731	
30295	2677	4043071	1985-11-28	1985-11-28 00:00:00	38000275	0	\N	\N	177422	0	228557008	4043071	
18543	1571	4163872	1971-02-03	1971-02-03 00:00:00	38000275	0	\N	\N	105506	0	399208008	4163872	
18791	1609	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	108172	0	180256009	4107731	
19026	1626	4078793	2002-10-06	2002-10-06 00:00:00	38000275	0	\N	\N	109217	0	180325003	4078793	
31120	2764	4295880	1996-01-26	1996-01-26 00:00:00	38000275	0	\N	\N	182798	0	76601001	4295880	
19335	1656	4295880	2007-12-15	2007-12-15 00:00:00	38000275	0	\N	\N	111061	0	76601001	4295880	
19544	1672	4293740	1973-10-07	1973-10-07 00:00:00	38000275	0	\N	\N	112280	0	384700001	4293740	
19784	1716	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	114765	0	180256009	4107731	
19993	1727	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	115532	0	180256009	4107731	
20046	1739	4170947	1997-03-15	1997-03-15 00:00:00	38000275	0	\N	\N	116171	0	274474001	4170947	
20201	1745	4199276	2010-04-19	2010-04-19 00:00:00	38000275	0	\N	\N	116656	0	301807007	4199276	
32385	2847	4151422	1989-12-20	1989-12-20 00:00:00	38000275	0	\N	\N	189105	0	269911007	4151422	
32579	2863	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	190352	0	180256009	4107731	
32908	2891	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	192289	0	180256009	4107731	
21079	1826	4058899	1956-10-29	1956-10-29 00:00:00	38000275	0	\N	\N	122040	0	168594001	4058899	
21181	1837	4043071	1973-08-09	1973-08-09 00:00:00	38000275	0	\N	\N	122714	0	228557008	4043071	
21398	1852	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	123932	0	180256009	4107731	
45462	4014	4107731	2001-04-10	2001-04-10 00:00:00	38000275	0	\N	\N	266808	0	180256009	4107731	
21711	1882	4107731	1992-11-21	1992-11-21 00:00:00	38000275	0	\N	\N	125506	0	180256009	4107731	
33878	2949	44783196	1974-10-24	1974-10-24 00:00:00	38000275	0	\N	\N	196837	0	699253003	44783196	
22209	1946	4145310	1997-05-24	1997-05-24 00:00:00	38000275	0	\N	\N	129277	0	268425006	4145310	
22288	1950	4035793	2015-01-29	2015-01-29 00:00:00	38000275	0	\N	\N	129684	0	15081005	4035793	
22524	1971	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	131072	0	180256009	4107731	
22771	1980	4107731	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	131818	0	180256009	4107731	
22980	1999	4107731	2013-07-17	2013-07-17 00:00:00	38000275	0	\N	\N	133099	0	180256009	4107731	
47001	4125	4163872	1972-08-25	1972-08-25 00:00:00	38000275	0	\N	\N	274245	0	399208008	4163872	
23339	2030	4243062	1967-01-26	1967-01-26 00:00:00	38000275	0	\N	\N	135103	0	60027007	4243062	
35357	3090	4151422	1961-09-21	1961-09-21 00:00:00	38000275	0	\N	\N	205705	0	269911007	4151422	
23606	2064	4125906	2008-11-06	2008-11-06 00:00:00	38000275	0	\N	\N	137306	0	288086009	4125906	
23837	2075	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	138111	0	180256009	4107731	
11979	1099	4107731	1990-11-17	1990-11-17 00:00:00	38000275	0	\N	\N	72217	0	180256009	4107731	
24137	2108	4195803	2017-07-23	2017-07-23 00:00:00	38000275	0	\N	\N	140360	0	312681000	4195803	
12446	1116	4170947	1996-02-20	1996-02-20 00:00:00	38000275	0	\N	\N	73509	0	274474001	4170947	
24535	2145	4125906	1993-10-14	1993-10-14 00:00:00	38000275	0	\N	\N	142800	0	288086009	4125906	
24769	2168	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	144521	0	180256009	4107731	
13031	1176	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	77608	0	180256009	4107731	
25075	2186	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	145741	0	180256009	4107731	
13448	1219	4078793	2012-01-02	2012-01-02 00:00:00	38000275	0	\N	\N	80232	0	180325003	4078793	
13643	1242	4238715	1981-02-04	1981-02-04 00:00:00	38000275	0	\N	\N	81826	0	68254000	4238715	
13725	1246	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	82027	0	180256009	4107731	
13922	1261	4107731	1991-11-09	1991-11-09 00:00:00	38000275	0	\N	\N	83177	0	180256009	4107731	
14122	1272	4151422	2008-10-04	2008-10-04 00:00:00	38000275	0	\N	\N	83951	0	269911007	4151422	
26207	2287	4057420	2012-07-06	2012-07-06 00:00:00	38000275	0	\N	\N	152156	0	18286008	4057420	
14447	1285	4107731	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	84942	0	180256009	4107731	
26624	2333	4078793	2007-02-13	2007-02-13 00:00:00	38000275	0	\N	\N	155219	0	180325003	4078793	
14859	1317	4035793	2006-12-08	2006-12-08 00:00:00	38000275	0	\N	\N	87311	0	15081005	4035793	
15127	1354	4125906	1980-01-27	1980-01-27 00:00:00	38000275	0	\N	\N	89760	0	288086009	4125906	
15222	1359	4163872	1994-05-06	1994-05-06 00:00:00	38000275	0	\N	\N	90183	0	399208008	4163872	
15509	1378	4293740	1952-06-29	1952-06-29 00:00:00	38000275	0	\N	\N	91317	0	384700001	4293740	
15531	1378	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	91404	0	180256009	4107731	
27689	2419	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	160515	0	180256009	4107731	
15904	1397	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	92734	0	180256009	4107731	
16152	1407	4107731	1992-06-06	1992-06-06 00:00:00	38000275	0	\N	\N	93466	0	180256009	4107731	
28309	2503	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	165753	0	180256009	4107731	
16619	1441	4107731	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	96084	0	180256009	4107731	
28612	2542	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	168079	0	180256009	4107731	
28849	2554	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	169151	0	180256009	4107731	
17051	1476	4078793	2003-11-27	2003-11-27 00:00:00	38000275	0	\N	\N	98473	0	180325003	4078793	
17325	1493	4170947	1972-07-03	1972-07-03 00:00:00	38000275	0	\N	\N	99575	0	274474001	4170947	
17456	1504	4125906	1954-05-03	1954-05-03 00:00:00	38000275	0	\N	\N	100254	0	288086009	4125906	
17686	1517	4043071	1946-05-06	1946-05-06 00:00:00	38000275	0	\N	\N	101393	0	228557008	4043071	
29738	2646	4047491	1988-04-29	1988-04-29 00:00:00	38000275	0	\N	\N	175083	0	1225002	4047491	
18041	1542	4125906	1978-02-19	1978-02-19 00:00:00	38000275	0	\N	\N	103303	0	288086009	4125906	
30148	2672	4107731	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	177011	0	180256009	4107731	
30296	2677	4043071	1986-12-04	1986-12-04 00:00:00	38000275	0	\N	\N	177416	0	228557008	4043071	
18544	1571	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	105413	0	180256009	4107731	
18792	1609	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	108174	0	180256009	4107731	
19027	1627	4275113	1968-05-19	1968-05-19 00:00:00	38000275	0	\N	\N	109343	0	65200003	4275113	
31121	2764	4295880	1997-01-24	1997-01-24 00:00:00	38000275	0	\N	\N	182756	0	76601001	4295880	
19336	1656	4295880	2010-12-11	2010-12-11 00:00:00	38000275	0	\N	\N	111105	0	76601001	4295880	
19545	1672	4125906	1973-10-07	1973-10-07 00:00:00	38000275	0	\N	\N	112280	0	288086009	4125906	
19785	1716	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	114764	0	180256009	4107731	
19994	1727	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	115419	0	180256009	4107731	
20047	1739	4243062	1997-03-15	1997-03-15 00:00:00	38000275	0	\N	\N	116171	0	60027007	4243062	
20202	1745	4059978	2006-10-30	2006-10-30 00:00:00	38000275	0	\N	\N	116698	0	169553002	4059978	
32386	2849	4195803	2017-10-17	2017-10-17 00:00:00	38000275	0	\N	\N	189298	0	312681000	4195803	
32580	2863	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	190334	0	180256009	4107731	
32909	2891	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	192278	0	180256009	4107731	
21080	1826	4151422	1999-04-13	1999-04-13 00:00:00	38000275	0	\N	\N	122016	0	269911007	4151422	
21182	1837	4043071	1973-07-05	1973-07-05 00:00:00	38000275	0	\N	\N	122725	0	228557008	4043071	
21399	1852	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	123975	0	180256009	4107731	
45463	4014	4107731	2000-08-01	2000-08-01 00:00:00	38000275	0	\N	\N	266807	0	180256009	4107731	
21712	1882	4125906	2010-06-20	2010-06-20 00:00:00	38000275	0	\N	\N	125568	0	288086009	4125906	
33879	2949	4243062	1960-03-04	1960-03-04 00:00:00	38000275	0	\N	\N	196878	0	60027007	4243062	
22210	1946	4195803	1997-05-24	1997-05-24 00:00:00	38000275	0	\N	\N	129277	0	312681000	4195803	
22289	1950	4145310	2016-01-26	2016-01-26 00:00:00	38000275	0	\N	\N	129717	0	268425006	4145310	
22525	1971	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	131058	0	180256009	4107731	
22772	1980	4107731	1992-05-17	1992-05-17 00:00:00	38000275	0	\N	\N	131772	0	180256009	4107731	
22981	1999	4107731	2013-10-09	2013-10-09 00:00:00	38000275	0	\N	\N	133122	0	180256009	4107731	
47002	4125	4125906	1987-11-17	1987-11-17 00:00:00	38000275	0	\N	\N	274213	0	288086009	4125906	
23340	2030	4170947	1967-01-26	1967-01-26 00:00:00	38000275	0	\N	\N	135103	0	274474001	4170947	
35358	3090	4125906	2003-05-25	2003-05-25 00:00:00	38000275	0	\N	\N	205773	0	288086009	4125906	
23607	2064	4238715	1995-06-07	1995-06-07 00:00:00	38000275	0	\N	\N	137293	0	68254000	4238715	
23838	2075	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	138095	0	180256009	4107731	
11980	1099	4107731	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	72184	0	180256009	4107731	
24138	2108	4170947	2017-07-23	2017-07-23 00:00:00	38000275	0	\N	\N	140360	0	274474001	4170947	
12447	1116	4047491	1996-02-20	1996-02-20 00:00:00	38000275	0	\N	\N	73509	0	1225002	4047491	
24536	2145	4252419	1982-03-16	1982-03-16 00:00:00	38000275	0	\N	\N	142799	0	74016001	4252419	
24770	2168	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	144412	0	180256009	4107731	
13032	1176	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	77672	0	180256009	4107731	
25076	2186	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	145799	0	180256009	4107731	
13453	1222	4125906	2017-12-09	2017-12-09 00:00:00	38000275	0	\N	\N	80444	0	288086009	4125906	
13644	1242	4275113	1977-02-17	1977-02-17 00:00:00	38000275	0	\N	\N	81762	0	65200003	4275113	
13726	1246	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	82105	0	180256009	4107731	
13923	1261	4107731	1992-06-27	1992-06-27 00:00:00	38000275	0	\N	\N	83179	0	180256009	4107731	
14123	1272	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	83903	0	180256009	4107731	
26208	2287	4078793	2010-06-25	2010-06-25 00:00:00	38000275	0	\N	\N	152166	0	180325003	4078793	
14451	1289	4151422	1996-03-07	1996-03-07 00:00:00	38000275	0	\N	\N	85196	0	269911007	4151422	
26625	2333	4202451	2007-04-03	2007-04-03 00:00:00	38000275	0	\N	\N	155219	0	433112001	4202451	
14860	1317	4323902	2001-12-21	2001-12-21 00:00:00	38000275	0	\N	\N	87253	0	429609002	4323902	
15128	1354	4163872	1998-04-18	1998-04-18 00:00:00	38000275	0	\N	\N	89747	0	399208008	4163872	
15223	1359	4078793	2007-04-10	2007-04-10 00:00:00	38000275	0	\N	\N	90153	0	180325003	4078793	
15510	1378	4125906	1952-06-29	1952-06-29 00:00:00	38000275	0	\N	\N	91317	0	288086009	4125906	
15532	1379	4058899	1970-07-25	1970-07-25 00:00:00	38000275	0	\N	\N	91512	0	168594001	4058899	
27690	2419	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	160496	0	180256009	4107731	
15905	1397	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	92755	0	180256009	4107731	
16153	1407	4107731	1991-03-23	1991-03-23 00:00:00	38000275	0	\N	\N	93579	0	180256009	4107731	
28310	2503	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	165740	0	180256009	4107731	
16620	1441	4107731	1992-07-13	1992-07-13 00:00:00	38000275	0	\N	\N	96093	0	180256009	4107731	
28613	2542	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	168162	0	180256009	4107731	
28850	2554	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	169140	0	180256009	4107731	
17052	1476	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	98344	0	180256009	4107731	
17326	1493	4125906	1994-04-09	1994-04-09 00:00:00	38000275	0	\N	\N	99576	0	288086009	4125906	
17457	1504	4330583	1986-06-13	1986-06-13 00:00:00	38000275	0	\N	\N	100283	0	22523008	4330583	
17687	1517	4043071	1944-11-27	1944-11-27 00:00:00	38000275	0	\N	\N	101433	0	228557008	4043071	
29739	2646	4170947	1988-04-29	1988-04-29 00:00:00	38000275	0	\N	\N	175083	0	274474001	4170947	
18042	1542	4057420	2016-10-26	2016-10-26 00:00:00	38000275	0	\N	\N	103355	0	18286008	4057420	
30149	2672	4107731	1992-08-30	1992-08-30 00:00:00	38000275	0	\N	\N	176920	0	180256009	4107731	
30297	2677	4043071	1985-05-17	1985-05-17 00:00:00	38000275	0	\N	\N	177345	0	228557008	4043071	
18545	1572	4293740	1972-11-26	1972-11-26 00:00:00	38000275	0	\N	\N	105544	0	384700001	4293740	
18793	1609	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	108186	0	180256009	4107731	
19028	1627	4058899	1964-12-24	1964-12-24 00:00:00	38000275	0	\N	\N	109349	0	168594001	4058899	
31122	2765	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	182881	0	180256009	4107731	
19337	1656	4295880	2005-09-17	2005-09-17 00:00:00	38000275	0	\N	\N	111116	0	76601001	4295880	
19549	1674	4145310	2008-09-07	2008-09-07 00:00:00	38000275	0	\N	\N	112387	0	268425006	4145310	
19786	1716	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	114650	0	180256009	4107731	
19995	1727	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	115564	0	180256009	4107731	
20048	1739	4037675	1986-04-07	1986-04-07 00:00:00	38000275	0	\N	\N	116216	0	162676008	4037675	
20203	1745	4047491	1986-06-05	1986-06-05 00:00:00	38000275	0	\N	\N	116681	0	1225002	4047491	
32387	2849	4024289	2017-10-17	2017-10-17 00:00:00	38000275	0	\N	\N	189298	0	19490002	4024289	
32581	2863	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	190449	0	180256009	4107731	
32910	2891	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	192368	0	180256009	4107731	
21081	1826	4151422	2004-02-27	2004-02-27 00:00:00	38000275	0	\N	\N	122057	0	269911007	4151422	
21183	1837	4151422	1964-01-04	1964-01-04 00:00:00	38000275	0	\N	\N	122702	0	269911007	4151422	
21400	1852	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	123980	0	180256009	4107731	
45464	4014	4107731	2000-11-14	2000-11-14 00:00:00	38000275	0	\N	\N	266748	0	180256009	4107731	
21713	1882	4107731	1991-10-19	1991-10-19 00:00:00	38000275	0	\N	\N	125598	0	180256009	4107731	
33880	2949	4170947	1960-03-04	1960-03-04 00:00:00	38000275	0	\N	\N	196878	0	274474001	4170947	
22211	1946	4078793	2018-11-03	2018-11-03 00:00:00	38000275	0	\N	\N	129356	0	180325003	4078793	
22290	1950	4035793	2014-01-23	2014-01-23 00:00:00	38000275	0	\N	\N	129664	0	15081005	4035793	
22526	1971	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	131052	0	180256009	4107731	
22773	1980	4107731	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	131814	0	180256009	4107731	
22982	1999	4107731	2014-01-22	2014-01-22 00:00:00	38000275	0	\N	\N	133150	0	180256009	4107731	
47003	4125	4057420	1988-10-25	1988-10-25 00:00:00	38000275	0	\N	\N	274214	0	18286008	4057420	
23341	2030	4202451	2005-07-24	2005-07-24 00:00:00	38000275	0	\N	\N	135101	0	433112001	4202451	
35359	3090	4293740	2003-05-25	2003-05-25 00:00:00	38000275	0	\N	\N	205773	0	384700001	4293740	
23608	2064	4170947	1982-04-06	1982-04-06 00:00:00	38000275	0	\N	\N	137304	0	274474001	4170947	
23839	2075	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	138080	0	180256009	4107731	
11981	1099	4107731	1992-12-12	1992-12-12 00:00:00	38000275	0	\N	\N	72122	0	180256009	4107731	
24139	2108	4243062	2017-07-23	2017-07-23 00:00:00	38000275	0	\N	\N	140360	0	60027007	4243062	
12448	1117	4125906	1943-10-03	1943-10-03 00:00:00	38000275	0	\N	\N	73616	0	288086009	4125906	
24537	2145	4170947	1965-12-10	1965-12-10 00:00:00	38000275	0	\N	\N	142797	0	274474001	4170947	
24771	2168	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	144562	0	395142003	4191853	
13033	1176	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	77621	0	180256009	4107731	
25077	2186	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	145806	0	180256009	4107731	
13454	1222	4125906	1960-05-21	1960-05-21 00:00:00	38000275	0	\N	\N	80423	0	288086009	4125906	
13645	1245	4151422	1948-11-11	1948-11-11 00:00:00	38000275	0	\N	\N	81937	0	269911007	4151422	
13727	1246	4252419	1974-09-14	1974-09-14 00:00:00	38000275	0	\N	\N	82054	0	74016001	4252419	
13924	1261	4107731	1991-07-06	1991-07-06 00:00:00	38000275	0	\N	\N	83214	0	180256009	4107731	
14124	1272	4107731	1994-03-18	1994-03-18 00:00:00	38000275	0	\N	\N	83933	0	180256009	4107731	
26209	2287	4078793	2012-12-21	2012-12-21 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
14452	1289	4024289	1997-05-25	1997-05-25 00:00:00	38000275	0	\N	\N	85242	0	19490002	4024289	
26626	2333	4125906	1991-04-19	1991-04-19 00:00:00	38000275	0	\N	\N	155164	0	288086009	4125906	
14861	1317	4125906	1971-02-23	1971-02-23 00:00:00	38000275	0	\N	\N	87276	0	288086009	4125906	
15129	1354	4058899	1995-05-29	1995-05-29 00:00:00	38000275	0	\N	\N	89761	0	168594001	4058899	
15224	1359	4078793	1988-04-19	1988-04-19 00:00:00	38000275	0	\N	\N	90216	0	180325003	4078793	
15511	1378	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	91438	0	180256009	4107731	
15533	1379	40492359	1987-09-05	1987-09-05 00:00:00	38000275	0	\N	\N	91516	0	447365002	40492359	
27691	2419	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	160563	0	180256009	4107731	
15906	1397	44805732	1996-11-08	1996-11-08 00:00:00	38000275	0	\N	\N	92807	0	755621000000101	44805732	
16154	1407	4058899	1989-03-05	1989-03-05 00:00:00	38000275	0	\N	\N	93565	0	168594001	4058899	
28311	2503	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	165668	0	180256009	4107731	
16621	1441	4107731	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	96091	0	180256009	4107731	
28614	2542	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	168111	0	180256009	4107731	
28851	2554	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	169125	0	395142003	4191853	
17053	1476	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	98333	0	180256009	4107731	
17327	1493	4293740	1994-04-09	1994-04-09 00:00:00	38000275	0	\N	\N	99576	0	384700001	4293740	
17458	1505	4151422	1978-03-25	1978-03-25 00:00:00	38000275	0	\N	\N	100368	0	269911007	4151422	
17688	1517	4043071	1947-09-01	1947-09-01 00:00:00	38000275	0	\N	\N	101426	0	228557008	4043071	
29740	2646	40492359	2007-12-14	2007-12-14 00:00:00	38000275	0	\N	\N	175085	0	447365002	40492359	
18043	1542	4078793	2018-11-07	2018-11-07 00:00:00	38000275	0	\N	\N	103356	0	180325003	4078793	
30150	2672	4107731	1990-02-18	1990-02-18 00:00:00	38000275	0	\N	\N	177028	0	180256009	4107731	
30298	2677	4043071	1987-06-12	1987-06-12 00:00:00	38000275	0	\N	\N	177370	0	228557008	4043071	
18546	1572	4125906	1972-11-26	1972-11-26 00:00:00	38000275	0	\N	\N	105544	0	288086009	4125906	
18794	1609	4024289	1993-10-13	1993-10-13 00:00:00	38000275	0	\N	\N	108163	0	19490002	4024289	
19029	1627	4238715	1981-04-04	1981-04-04 00:00:00	38000275	0	\N	\N	109374	0	68254000	4238715	
31123	2765	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	182926	0	180256009	4107731	
19338	1656	4295880	2005-09-10	2005-09-10 00:00:00	38000275	0	\N	\N	111059	0	76601001	4295880	
19550	1674	4151422	2004-12-22	2004-12-22 00:00:00	38000275	0	\N	\N	112354	0	269911007	4151422	
19787	1716	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	114607	0	180256009	4107731	
19996	1727	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	115421	0	180256009	4107731	
20049	1739	4187458	1986-04-07	1986-04-07 00:00:00	38000275	0	\N	\N	116216	0	415300000	4187458	
20204	1745	4170947	1986-06-05	1986-06-05 00:00:00	38000275	0	\N	\N	116681	0	274474001	4170947	
32388	2849	4170947	2017-10-17	2017-10-17 00:00:00	38000275	0	\N	\N	189298	0	274474001	4170947	
32582	2863	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	190350	0	180256009	4107731	
32911	2891	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	192369	0	180256009	4107731	
32913	2891	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	192273	0	180256009	4107731	
21184	1837	4047491	1965-02-16	1965-02-16 00:00:00	38000275	0	\N	\N	122692	0	1225002	4047491	
21401	1852	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	123908	0	180256009	4107731	
45465	4014	4107731	1998-07-28	1998-07-28 00:00:00	38000275	0	\N	\N	266772	0	180256009	4107731	
21714	1882	4107731	1992-01-11	1992-01-11 00:00:00	38000275	0	\N	\N	125601	0	180256009	4107731	
33881	2949	4252419	1974-10-17	1974-10-17 00:00:00	38000275	0	\N	\N	196879	0	74016001	4252419	
22212	1946	4057420	2015-01-10	2015-01-10 00:00:00	38000275	0	\N	\N	129298	0	18286008	4057420	
22291	1950	4035793	2017-02-16	2017-02-16 00:00:00	38000275	0	\N	\N	129696	0	15081005	4035793	
22527	1971	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	131080	0	180256009	4107731	
22774	1980	4107731	1991-12-01	1991-12-01 00:00:00	38000275	0	\N	\N	131761	0	180256009	4107731	
22983	1999	4107731	2013-08-28	2013-08-28 00:00:00	38000275	0	\N	\N	133121	0	180256009	4107731	
47004	4125	40492359	1988-10-25	1988-10-25 00:00:00	38000275	0	\N	\N	274214	0	447365002	40492359	
23342	2030	4151422	1971-01-07	1971-01-07 00:00:00	38000275	0	\N	\N	135117	0	269911007	4151422	
35360	3090	4151422	1978-04-11	1978-04-11 00:00:00	38000275	0	\N	\N	205728	0	269911007	4151422	
23609	2064	4047491	1982-04-06	1982-04-06 00:00:00	38000275	0	\N	\N	137304	0	1225002	4047491	
23840	2075	4107731	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	138070	0	180256009	4107731	
11982	1099	4107731	1991-03-23	1991-03-23 00:00:00	38000275	0	\N	\N	72177	0	180256009	4107731	
24140	2108	4151422	2006-10-14	2006-10-14 00:00:00	38000275	0	\N	\N	140385	0	269911007	4151422	
12449	1117	4125906	1980-04-12	1980-04-12 00:00:00	38000275	0	\N	\N	73617	0	288086009	4125906	
24538	2145	4243062	1965-12-10	1965-12-10 00:00:00	38000275	0	\N	\N	142797	0	60027007	4243062	
24772	2168	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	144527	0	180256009	4107731	
13034	1176	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	77675	0	180256009	4107731	
25078	2186	4145310	2019-01-09	2019-01-09 00:00:00	38000275	0	\N	\N	145831	0	268425006	4145310	
13455	1222	4170947	1971-08-13	1971-08-13 00:00:00	38000275	0	\N	\N	80424	0	274474001	4170947	
13646	1245	4078793	2016-07-01	2016-07-01 00:00:00	38000275	0	\N	\N	81923	0	180325003	4078793	
13728	1246	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	82121	0	180256009	4107731	
13925	1261	4107731	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	83195	0	180256009	4107731	
14125	1272	4107731	1995-03-10	1995-03-10 00:00:00	38000275	0	\N	\N	83895	0	180256009	4107731	
26210	2287	4170947	1969-07-19	1969-07-19 00:00:00	38000275	0	\N	\N	152150	0	274474001	4170947	
14453	1289	4170947	1997-05-25	1997-05-25 00:00:00	38000275	0	\N	\N	85242	0	274474001	4170947	
26627	2333	4293740	1991-04-19	1991-04-19 00:00:00	38000275	0	\N	\N	155164	0	384700001	4293740	
14862	1317	4035793	2005-12-02	2005-12-02 00:00:00	38000275	0	\N	\N	87315	0	15081005	4035793	
15130	1355	4125906	2000-01-02	2000-01-02 00:00:00	38000275	0	\N	\N	89793	0	288086009	4125906	
15225	1359	4078793	1999-02-23	1999-02-23 00:00:00	38000275	0	\N	\N	90177	0	180325003	4078793	
15512	1378	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	91377	0	180256009	4107731	
15534	1379	4057420	1987-09-05	1987-09-05 00:00:00	38000275	0	\N	\N	91516	0	18286008	4057420	
27692	2419	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	160603	0	180256009	4107731	
15907	1397	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	92760	0	180256009	4107731	
16155	1407	4107731	1990-02-17	1990-02-17 00:00:00	38000275	0	\N	\N	93527	0	180256009	4107731	
28312	2503	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	165752	0	180256009	4107731	
16622	1441	4107731	1990-08-20	1990-08-20 00:00:00	38000275	0	\N	\N	95988	0	180256009	4107731	
28615	2542	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	168080	0	180256009	4107731	
28852	2554	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	169101	0	180256009	4107731	
17054	1476	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	98347	0	180256009	4107731	
17328	1493	4170947	1962-10-24	1962-10-24 00:00:00	38000275	0	\N	\N	99574	0	274474001	4170947	
17459	1505	4125906	1995-03-04	1995-03-04 00:00:00	38000275	0	\N	\N	100383	0	288086009	4125906	
17689	1517	4043071	1945-05-21	1945-05-21 00:00:00	38000275	0	\N	\N	101373	0	228557008	4043071	
29741	2646	4057420	2007-12-14	2007-12-14 00:00:00	38000275	0	\N	\N	175085	0	18286008	4057420	
18044	1542	4058899	2007-11-03	2007-11-03 00:00:00	38000275	0	\N	\N	103306	0	168594001	4058899	
30151	2672	4107731	1992-08-09	1992-08-09 00:00:00	38000275	0	\N	\N	176930	0	180256009	4107731	
30299	2677	4043071	1986-11-06	1986-11-06 00:00:00	38000275	0	\N	\N	177378	0	228557008	4043071	
18547	1572	4058899	1976-01-24	1976-01-24 00:00:00	38000275	0	\N	\N	105546	0	168594001	4058899	
18795	1609	4170947	1993-10-13	1993-10-13 00:00:00	38000275	0	\N	\N	108163	0	274474001	4170947	
19030	1627	4186930	1973-05-19	1973-05-19 00:00:00	38000275	0	\N	\N	109298	0	46706006	4186930	
31124	2765	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	182924	0	180256009	4107731	
19339	1656	4295880	2012-09-08	2012-09-08 00:00:00	38000275	0	\N	\N	111135	0	76601001	4295880	
19551	1674	4125906	1995-12-01	1995-12-01 00:00:00	38000275	0	\N	\N	112386	0	288086009	4125906	
19788	1716	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	114679	0	180256009	4107731	
19997	1727	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	115420	0	180256009	4107731	
20050	1739	4326177	1986-04-07	1986-04-07 00:00:00	38000275	0	\N	\N	116216	0	430193006	4326177	
20205	1745	4275113	2007-10-27	2007-10-27 00:00:00	38000275	0	\N	\N	116676	0	65200003	4275113	
32389	2849	4024289	2003-05-04	2003-05-04 00:00:00	38000275	0	\N	\N	189296	0	19490002	4024289	
32583	2863	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	190443	0	395142003	4191853	
32912	2891	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	192359	0	180256009	4107731	
32914	2891	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	192307	0	180256009	4107731	
21185	1837	4170947	1965-02-16	1965-02-16 00:00:00	38000275	0	\N	\N	122692	0	274474001	4170947	
21402	1852	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	123899	0	180256009	4107731	
45466	4014	4107731	1998-12-01	1998-12-01 00:00:00	38000275	0	\N	\N	266697	0	180256009	4107731	
21715	1882	4107731	1993-01-23	1993-01-23 00:00:00	38000275	0	\N	\N	125578	0	180256009	4107731	
33882	2949	4151422	1978-12-11	1978-12-11 00:00:00	38000275	0	\N	\N	196857	0	269911007	4151422	
22213	1946	4202451	1973-10-20	1973-10-20 00:00:00	38000275	0	\N	\N	129307	0	433112001	4202451	
22292	1951	4163872	1993-05-31	1993-05-31 00:00:00	38000275	0	\N	\N	129771	0	399208008	4163872	
22528	1971	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	131104	0	180256009	4107731	
22775	1980	4107731	1991-08-18	1991-08-18 00:00:00	38000275	0	\N	\N	131851	0	180256009	4107731	
22984	1999	4107731	2012-06-13	2012-06-13 00:00:00	38000275	0	\N	\N	133142	0	180256009	4107731	
47005	4125	4058899	1992-06-14	1992-06-14 00:00:00	38000275	0	\N	\N	274215	0	168594001	4058899	
23351	2033	4058899	1956-04-25	1956-04-25 00:00:00	38000275	0	\N	\N	135298	0	168594001	4058899	
35364	3092	4238715	1972-01-26	1972-01-26 00:00:00	38000275	0	\N	\N	205844	0	68254000	4238715	
23610	2064	4275113	1991-04-01	1991-04-01 00:00:00	38000275	0	\N	\N	137269	0	65200003	4275113	
23841	2075	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	138016	0	180256009	4107731	
11983	1099	4107731	1992-06-27	1992-06-27 00:00:00	38000275	0	\N	\N	72183	0	180256009	4107731	
24141	2108	4170947	1961-07-19	1961-07-19 00:00:00	38000275	0	\N	\N	140355	0	274474001	4170947	
12450	1117	4293740	1980-04-12	1980-04-12 00:00:00	38000275	0	\N	\N	73617	0	384700001	4293740	
24539	2147	40492359	2005-03-25	2005-03-25 00:00:00	38000275	0	\N	\N	142966	0	447365002	40492359	
24773	2168	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	144519	0	180256009	4107731	
13035	1176	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	77622	0	180256009	4107731	
25079	2186	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	145824	0	180256009	4107731	
13456	1222	4047491	1971-08-13	1971-08-13 00:00:00	38000275	0	\N	\N	80424	0	1225002	4047491	
13647	1245	4151422	1970-06-04	1970-06-04 00:00:00	38000275	0	\N	\N	81982	0	269911007	4151422	
13729	1246	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	82063	0	180256009	4107731	
13926	1261	4107731	1990-08-04	1990-08-04 00:00:00	38000275	0	\N	\N	83180	0	180256009	4107731	
14126	1272	4107731	1993-12-03	1993-12-03 00:00:00	38000275	0	\N	\N	83907	0	180256009	4107731	
26211	2287	4024289	1969-07-19	1969-07-19 00:00:00	38000275	0	\N	\N	152150	0	19490002	4024289	
14454	1289	4125906	2002-12-25	2002-12-25 00:00:00	38000275	0	\N	\N	85243	0	288086009	4125906	
26628	2333	4078793	1995-05-16	1995-05-16 00:00:00	38000275	0	\N	\N	155143	0	180325003	4078793	
14863	1318	4151422	1942-06-16	1942-06-16 00:00:00	38000275	0	\N	\N	87337	0	269911007	4151422	
15131	1356	4107731	1998-04-02	1998-04-02 00:00:00	38000275	0	\N	\N	89901	0	180256009	4107731	
15226	1359	4078793	2000-02-29	2000-02-29 00:00:00	38000275	0	\N	\N	90188	0	180325003	4078793	
15513	1378	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	91326	0	180256009	4107731	
15535	1379	4125906	1969-08-15	1969-08-15 00:00:00	38000275	0	\N	\N	91511	0	288086009	4125906	
27697	2423	4252419	1998-09-22	1998-09-22 00:00:00	38000275	0	\N	\N	160768	0	74016001	4252419	
15908	1397	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	92855	0	180256009	4107731	
16156	1407	4107731	1990-06-23	1990-06-23 00:00:00	38000275	0	\N	\N	93576	0	180256009	4107731	
28313	2503	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	165701	0	180256009	4107731	
16623	1441	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	96012	0	180256009	4107731	
28616	2542	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	168112	0	395142003	4191853	
28853	2554	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	169270	0	180256009	4107731	
17055	1476	4057420	2004-12-02	2004-12-02 00:00:00	38000275	0	\N	\N	98458	0	18286008	4057420	
17329	1493	4024289	1962-10-24	1962-10-24 00:00:00	38000275	0	\N	\N	99574	0	19490002	4024289	
17460	1506	4125906	1964-12-01	1964-12-01 00:00:00	38000275	0	\N	\N	100394	0	288086009	4125906	
17690	1517	4043071	1946-09-02	1946-09-02 00:00:00	38000275	0	\N	\N	101450	0	228557008	4043071	
29742	2646	4125906	1991-05-14	1991-05-14 00:00:00	38000275	0	\N	\N	175084	0	288086009	4125906	
18045	1542	4078793	2015-11-25	2015-11-25 00:00:00	38000275	0	\N	\N	103319	0	180325003	4078793	
30152	2672	4107731	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	177002	0	180256009	4107731	
30300	2677	4043071	1987-02-12	1987-02-12 00:00:00	38000275	0	\N	\N	177368	0	228557008	4043071	
18548	1572	4186930	1983-06-10	1983-06-10 00:00:00	38000275	0	\N	\N	105562	0	46706006	4186930	
18796	1609	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	108189	0	180256009	4107731	
19031	1627	4186930	1978-05-20	1978-05-20 00:00:00	38000275	0	\N	\N	109338	0	46706006	4186930	
31125	2765	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	182932	0	180256009	4107731	
19340	1656	4295880	2010-03-13	2010-03-13 00:00:00	38000275	0	\N	\N	111065	0	76601001	4295880	
19552	1674	4151422	1997-05-07	1997-05-07 00:00:00	38000275	0	\N	\N	112344	0	269911007	4151422	
19789	1716	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	114617	0	180256009	4107731	
19998	1727	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	115560	0	180256009	4107731	
20051	1739	4293740	2011-09-28	2011-09-28 00:00:00	38000275	0	\N	\N	116172	0	384700001	4293740	
20206	1746	4170947	2000-03-25	2000-03-25 00:00:00	38000275	0	\N	\N	116764	0	274474001	4170947	
32390	2849	4170947	2003-05-04	2003-05-04 00:00:00	38000275	0	\N	\N	189296	0	274474001	4170947	
32584	2863	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	190371	0	395142003	4191853	
44694	3916	4295880	1996-09-25	1996-09-25 00:00:00	38000275	0	\N	\N	260394	0	76601001	4295880	
32915	2891	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	192352	0	180256009	4107731	
21186	1837	4170947	1976-05-17	1976-05-17 00:00:00	38000275	0	\N	\N	122694	0	274474001	4170947	
21403	1852	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	123963	0	180256009	4107731	
45467	4014	4107731	1999-12-14	1999-12-14 00:00:00	38000275	0	\N	\N	266805	0	180256009	4107731	
21716	1882	4107731	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	125517	0	180256009	4107731	
33883	2949	4125906	2006-08-05	2006-08-05 00:00:00	38000275	0	\N	\N	196881	0	288086009	4125906	
22214	1946	4078793	2014-01-04	2014-01-04 00:00:00	38000275	0	\N	\N	129354	0	180325003	4078793	
22293	1951	4170947	1993-05-31	1993-05-31 00:00:00	38000275	0	\N	\N	129771	0	274474001	4170947	
22529	1971	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	131025	0	180256009	4107731	
22776	1980	4107731	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	131767	0	180256009	4107731	
22985	1999	4107731	2014-10-01	2014-10-01 00:00:00	38000275	0	\N	\N	133136	0	180256009	4107731	
47016	4127	4125906	1948-07-23	1948-07-23 00:00:00	38000275	0	\N	\N	274310	0	288086009	4125906	
23352	2034	4047491	1940-12-14	1940-12-14 00:00:00	38000275	0	\N	\N	135486	0	1225002	4047491	
35365	3092	40492359	1995-09-20	1995-09-20 00:00:00	38000275	0	\N	\N	205906	0	447365002	40492359	
23701	2069	4151422	1963-06-22	1963-06-22 00:00:00	38000275	0	\N	\N	137614	0	269911007	4151422	
23842	2075	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	138055	0	180256009	4107731	
11984	1099	4107731	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	72224	0	180256009	4107731	
24142	2108	4047491	1961-07-19	1961-07-19 00:00:00	38000275	0	\N	\N	140355	0	1225002	4047491	
12451	1117	4151422	1986-07-06	1986-07-06 00:00:00	38000275	0	\N	\N	73571	0	269911007	4151422	
24540	2147	4057420	2005-03-25	2005-03-25 00:00:00	38000275	0	\N	\N	142966	0	18286008	4057420	
24774	2168	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	144421	0	180256009	4107731	
13036	1176	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	77692	0	180256009	4107731	
25080	2186	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	145800	0	180256009	4107731	
13457	1223	4078793	2013-05-17	2013-05-17 00:00:00	38000275	0	\N	\N	80494	0	180325003	4078793	
13648	1245	4151422	1940-04-10	1940-04-10 00:00:00	38000275	0	\N	\N	81936	0	269911007	4151422	
13730	1246	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	82002	0	180256009	4107731	
13927	1261	4107731	1992-11-21	1992-11-21 00:00:00	38000275	0	\N	\N	83233	0	180256009	4107731	
14127	1272	4107731	1993-12-24	1993-12-24 00:00:00	38000275	0	\N	\N	83947	0	180256009	4107731	
26212	2287	4195803	2014-01-22	2014-01-22 00:00:00	38000275	0	\N	\N	152153	0	312681000	4195803	
14455	1289	4125906	1963-02-06	1963-02-06 00:00:00	38000275	0	\N	\N	85168	0	288086009	4125906	
26629	2333	4078793	1999-06-08	1999-06-08 00:00:00	38000275	0	\N	\N	155251	0	180325003	4078793	
14864	1318	4151422	2014-06-20	2014-06-20 00:00:00	38000275	0	\N	\N	87348	0	269911007	4151422	
15132	1356	4107731	1996-09-12	1996-09-12 00:00:00	38000275	0	\N	\N	89914	0	180256009	4107731	
15227	1359	4078793	2002-03-12	2002-03-12 00:00:00	38000275	0	\N	\N	90189	0	180325003	4078793	
15514	1378	4107731	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	91385	0	180256009	4107731	
15536	1379	4170947	1962-10-30	1962-10-30 00:00:00	38000275	0	\N	\N	91509	0	274474001	4170947	
27698	2423	4151422	2005-10-02	2005-10-02 00:00:00	38000275	0	\N	\N	160793	0	269911007	4151422	
16004	1399	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	93025	0	180256009	4107731	
16157	1407	4107731	1991-07-27	1991-07-27 00:00:00	38000275	0	\N	\N	93520	0	180256009	4107731	
28314	2503	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	165712	0	180256009	4107731	
16624	1441	4107731	1992-06-22	1992-06-22 00:00:00	38000275	0	\N	\N	95960	0	180256009	4107731	
28617	2542	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	168127	0	180256009	4107731	
28854	2554	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	169122	0	180256009	4107731	
17056	1476	4195803	2004-12-02	2004-12-02 00:00:00	38000275	0	\N	\N	98458	0	312681000	4195803	
17330	1493	4202451	2016-03-08	2016-03-08 00:00:00	38000275	0	\N	\N	99518	0	433112001	4202451	
17461	1506	44783196	1952-09-05	1952-09-05 00:00:00	38000275	0	\N	\N	100396	0	699253003	44783196	
17691	1517	4043071	1945-01-29	1945-01-29 00:00:00	38000275	0	\N	\N	101421	0	228557008	4043071	
29743	2647	4107731	1990-04-22	1990-04-22 00:00:00	38000275	0	\N	\N	175101	0	180256009	4107731	
18046	1542	4078793	2017-11-01	2017-11-01 00:00:00	38000275	0	\N	\N	103320	0	180325003	4078793	
30153	2672	4191853	1990-01-07	1990-01-07 00:00:00	38000275	0	\N	\N	177027	0	395142003	4191853	
30301	2677	4043071	1987-08-14	1987-08-14 00:00:00	38000275	0	\N	\N	177379	0	228557008	4043071	
18549	1572	4275113	1978-06-12	1978-06-12 00:00:00	38000275	0	\N	\N	105597	0	65200003	4275113	
18797	1609	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	108101	0	180256009	4107731	
19032	1627	4170947	1981-09-26	1981-09-26 00:00:00	38000275	0	\N	\N	109350	0	274474001	4170947	
31126	2765	4035793	2012-12-04	2012-12-04 00:00:00	38000275	0	\N	\N	182842	0	15081005	4035793	
19341	1656	4295880	2009-12-12	2009-12-12 00:00:00	38000275	0	\N	\N	111161	0	76601001	4295880	
19553	1674	4151422	1993-12-29	1993-12-29 00:00:00	38000275	0	\N	\N	112369	0	269911007	4151422	
19790	1716	4125906	1978-11-13	1978-11-13 00:00:00	38000275	0	\N	\N	114704	0	288086009	4125906	
19999	1727	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	115523	0	180256009	4107731	
20052	1739	4125906	2011-09-28	2011-09-28 00:00:00	38000275	0	\N	\N	116172	0	288086009	4125906	
20207	1746	4047491	2000-03-25	2000-03-25 00:00:00	38000275	0	\N	\N	116764	0	1225002	4047491	
32391	2849	4195803	2003-05-04	2003-05-04 00:00:00	38000275	0	\N	\N	189296	0	312681000	4195803	
32585	2863	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	190411	0	180256009	4107731	
44695	3916	4295880	1994-12-28	1994-12-28 00:00:00	38000275	0	\N	\N	260320	0	76601001	4295880	
32916	2891	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	192334	0	180256009	4107731	
21187	1837	4024289	1976-05-17	1976-05-17 00:00:00	38000275	0	\N	\N	122694	0	19490002	4024289	
21404	1852	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	123910	0	180256009	4107731	
45468	4014	4107731	2001-03-20	2001-03-20 00:00:00	38000275	0	\N	\N	266708	0	180256009	4107731	
21717	1882	4107731	1990-08-04	1990-08-04 00:00:00	38000275	0	\N	\N	125588	0	180256009	4107731	
33884	2949	4024289	1956-05-24	1956-05-24 00:00:00	38000275	0	\N	\N	196877	0	19490002	4024289	
22215	1946	4125906	1975-01-29	1975-01-29 00:00:00	38000275	0	\N	\N	129276	0	288086009	4125906	
22294	1951	4047491	2015-04-11	2015-04-11 00:00:00	38000275	0	\N	\N	129773	0	1225002	4047491	
22530	1971	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	131089	0	180256009	4107731	
22777	1980	4191853	1990-01-07	1990-01-07 00:00:00	38000275	0	\N	\N	131811	0	395142003	4191853	
22986	1999	4107731	2013-01-30	2013-01-30 00:00:00	38000275	0	\N	\N	133144	0	180256009	4107731	
47017	4127	4125906	1985-08-09	1985-08-09 00:00:00	38000275	0	\N	\N	274342	0	288086009	4125906	
23353	2034	4170947	1940-12-14	1940-12-14 00:00:00	38000275	0	\N	\N	135486	0	274474001	4170947	
35366	3092	4057420	1995-09-20	1995-09-20 00:00:00	38000275	0	\N	\N	205906	0	18286008	4057420	
23702	2069	4058899	1955-05-03	1955-05-03 00:00:00	38000275	0	\N	\N	137584	0	168594001	4058899	
23843	2075	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	138112	0	180256009	4107731	
11985	1099	4107731	1990-01-27	1990-01-27 00:00:00	38000275	0	\N	\N	72109	0	180256009	4107731	
24150	2114	4125906	1971-09-23	1971-09-23 00:00:00	38000275	0	\N	\N	140681	0	288086009	4125906	
12452	1118	4062501	1976-08-18	1976-08-18 00:00:00	38000275	0	\N	\N	73680	0	171231001	4062501	
24541	2147	4125906	1987-05-02	1987-05-02 00:00:00	38000275	0	\N	\N	142903	0	288086009	4125906	
24775	2168	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	144547	0	180256009	4107731	
13037	1176	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	77676	0	180256009	4107731	
25081	2186	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	145833	0	180256009	4107731	
13458	1223	4078793	2019-06-21	2019-06-21 00:00:00	38000275	0	\N	\N	80464	0	180325003	4078793	
13649	1245	4078793	2017-07-07	2017-07-07 00:00:00	38000275	0	\N	\N	81948	0	180325003	4078793	
13731	1246	4151422	1983-08-04	1983-08-04 00:00:00	38000275	0	\N	\N	82114	0	269911007	4151422	
13928	1261	4107731	1993-01-02	1993-01-02 00:00:00	38000275	0	\N	\N	83234	0	180256009	4107731	
14128	1272	4107731	1994-11-04	1994-11-04 00:00:00	38000275	0	\N	\N	83935	0	180256009	4107731	
26213	2287	4047491	2014-01-22	2014-01-22 00:00:00	38000275	0	\N	\N	152153	0	1225002	4047491	
14456	1289	4125906	2011-10-30	2011-10-30 00:00:00	38000275	0	\N	\N	85244	0	288086009	4125906	
26630	2333	4078793	1996-05-21	1996-05-21 00:00:00	38000275	0	\N	\N	155175	0	180325003	4078793	
14865	1318	4078793	2017-08-01	2017-08-01 00:00:00	38000275	0	\N	\N	87417	0	180325003	4078793	
15133	1356	4107731	1997-12-18	1997-12-18 00:00:00	38000275	0	\N	\N	89951	0	180256009	4107731	
15228	1359	4078793	1994-05-17	1994-05-17 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
15515	1378	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	91330	0	180256009	4107731	
15537	1379	4243062	1962-10-30	1962-10-30 00:00:00	38000275	0	\N	\N	91509	0	60027007	4243062	
27699	2423	44783196	1998-09-29	1998-09-29 00:00:00	38000275	0	\N	\N	160719	0	699253003	44783196	
16005	1399	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	93058	0	180256009	4107731	
16158	1407	4107731	1991-12-21	1991-12-21 00:00:00	38000275	0	\N	\N	93551	0	180256009	4107731	
28315	2503	4186930	1995-02-07	1995-02-07 00:00:00	38000275	0	\N	\N	165746	0	46706006	4186930	
16625	1441	4107731	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	95984	0	180256009	4107731	
28618	2542	4125906	1998-11-23	1998-11-23 00:00:00	38000275	0	\N	\N	168092	0	288086009	4125906	
28855	2554	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	169102	0	180256009	4107731	
17057	1476	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	98479	0	180256009	4107731	
17335	1496	4195803	1979-08-29	1979-08-29 00:00:00	38000275	0	\N	\N	99741	0	312681000	4195803	
17462	1506	4078793	2011-04-30	2011-04-30 00:00:00	38000275	0	\N	\N	100439	0	180325003	4078793	
17692	1517	4252419	2013-02-09	2013-02-09 00:00:00	38000275	0	\N	\N	101448	0	74016001	4252419	
29744	2647	4107731	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	175186	0	180256009	4107731	
18047	1543	4043071	1951-01-31	1951-01-31 00:00:00	38000275	0	\N	\N	103426	0	228557008	4043071	
30154	2672	4107731	1991-09-08	1991-09-08 00:00:00	38000275	0	\N	\N	177024	0	180256009	4107731	
30302	2677	4125906	2014-02-24	2014-02-24 00:00:00	38000275	0	\N	\N	177361	0	288086009	4125906	
18550	1572	4238715	1984-11-09	1984-11-09 00:00:00	38000275	0	\N	\N	105598	0	68254000	4238715	
18798	1609	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	108130	0	180256009	4107731	
19033	1627	4163872	1981-09-26	1981-09-26 00:00:00	38000275	0	\N	\N	109350	0	399208008	4163872	
31127	2765	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	182872	0	180256009	4107731	
19342	1656	4295880	2005-03-19	2005-03-19 00:00:00	38000275	0	\N	\N	111122	0	76601001	4295880	
19555	1676	4058899	1999-06-02	1999-06-02 00:00:00	38000275	0	\N	\N	112469	0	168594001	4058899	
19791	1716	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	114610	0	180256009	4107731	
20000	1727	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	115533	0	180256009	4107731	
20053	1739	4125906	1976-05-20	1976-05-20 00:00:00	38000275	0	\N	\N	116170	0	288086009	4125906	
20208	1746	4163872	1957-07-07	1957-07-07 00:00:00	38000275	0	\N	\N	116719	0	399208008	4163872	
32392	2849	4058899	2004-04-28	2004-04-28 00:00:00	38000275	0	\N	\N	189297	0	168594001	4058899	
32586	2863	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	190326	0	180256009	4107731	
44696	3916	4107731	1993-02-24	1993-02-24 00:00:00	38000275	0	\N	\N	260412	0	180256009	4107731	
32917	2891	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	192286	0	180256009	4107731	
21188	1837	4043071	1973-12-20	1973-12-20 00:00:00	38000275	0	\N	\N	122684	0	228557008	4043071	
21405	1852	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	123964	0	180256009	4107731	
45469	4014	4107731	2001-05-22	2001-05-22 00:00:00	38000275	0	\N	\N	266749	0	180256009	4107731	
21718	1882	4107731	1990-10-06	1990-10-06 00:00:00	38000275	0	\N	\N	125538	0	180256009	4107731	
33885	2949	4170947	1956-05-24	1956-05-24 00:00:00	38000275	0	\N	\N	196877	0	274474001	4170947	
22216	1946	4078793	2016-01-16	2016-01-16 00:00:00	38000275	0	\N	\N	129355	0	180325003	4078793	
22295	1951	4170947	2015-04-11	2015-04-11 00:00:00	38000275	0	\N	\N	129773	0	274474001	4170947	
22531	1971	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	130999	0	180256009	4107731	
22778	1980	4107731	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	131882	0	180256009	4107731	
22987	1999	4107731	2015-02-04	2015-02-04 00:00:00	38000275	0	\N	\N	133104	0	180256009	4107731	
47018	4127	4293740	1985-08-09	1985-08-09 00:00:00	38000275	0	\N	\N	274342	0	384700001	4293740	
23354	2034	44783196	2011-09-02	2011-09-02 00:00:00	38000275	0	\N	\N	135432	0	699253003	44783196	
35367	3092	4125906	2011-07-31	2011-07-31 00:00:00	38000275	0	\N	\N	205841	0	288086009	4125906	
23703	2069	4151422	1977-12-26	1977-12-26 00:00:00	38000275	0	\N	\N	137616	0	269911007	4151422	
23844	2075	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	138101	0	180256009	4107731	
11986	1099	4107731	1990-07-14	1990-07-14 00:00:00	38000275	0	\N	\N	72245	0	180256009	4107731	
24151	2114	4125906	1974-11-27	1974-11-27 00:00:00	38000275	0	\N	\N	140682	0	288086009	4125906	
12453	1118	4181917	1983-08-10	1983-08-10 00:00:00	38000275	0	\N	\N	73703	0	54550000	4181917	
24542	2147	4125906	2013-08-27	2013-08-27 00:00:00	38000275	0	\N	\N	142967	0	288086009	4125906	
24776	2168	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	144435	0	180256009	4107731	
13038	1176	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	77683	0	180256009	4107731	
25082	2186	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	145820	0	180256009	4107731	
13459	1223	4057420	2014-05-23	2014-05-23 00:00:00	38000275	0	\N	\N	80505	0	18286008	4057420	
13650	1245	40492359	2003-10-10	2003-10-10 00:00:00	38000275	0	\N	\N	81904	0	447365002	40492359	
13732	1246	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	82024	0	180256009	4107731	
13929	1261	4163872	2006-05-01	2006-05-01 00:00:00	38000275	0	\N	\N	83188	0	399208008	4163872	
14129	1272	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	83878	0	180256009	4107731	
26214	2287	4170947	2014-01-22	2014-01-22 00:00:00	38000275	0	\N	\N	152153	0	274474001	4170947	
14457	1289	4293740	2011-10-30	2011-10-30 00:00:00	38000275	0	\N	\N	85244	0	384700001	4293740	
26631	2333	4078793	2002-06-25	2002-06-25 00:00:00	38000275	0	\N	\N	155144	0	180325003	4078793	
14866	1318	4078793	2018-08-07	2018-08-07 00:00:00	38000275	0	\N	\N	87408	0	180325003	4078793	
15134	1356	4107731	1995-12-14	1995-12-14 00:00:00	38000275	0	\N	\N	89911	0	180256009	4107731	
15229	1359	4078793	1987-04-14	1987-04-14 00:00:00	38000275	0	\N	\N	90184	0	180325003	4078793	
15516	1378	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	91374	0	180256009	4107731	
15538	1379	4125906	1998-02-17	1998-02-17 00:00:00	38000275	0	\N	\N	91517	0	288086009	4125906	
27700	2423	4170947	1997-06-29	1997-06-29 00:00:00	38000275	0	\N	\N	160767	0	274474001	4170947	
16006	1399	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	93123	0	180256009	4107731	
16159	1407	4107731	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	93475	0	180256009	4107731	
28316	2503	4107731	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	165713	0	180256009	4107731	
16626	1441	4107731	1992-01-27	1992-01-27 00:00:00	38000275	0	\N	\N	96068	0	180256009	4107731	
28619	2542	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	168154	0	180256009	4107731	
28856	2554	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	169273	0	180256009	4107731	
17058	1476	4024289	1961-08-21	1961-08-21 00:00:00	38000275	0	\N	\N	98494	0	19490002	4024289	
17336	1496	4170947	1979-08-29	1979-08-29 00:00:00	38000275	0	\N	\N	99741	0	274474001	4170947	
17463	1506	4078793	2012-05-05	2012-05-05 00:00:00	38000275	0	\N	\N	100408	0	180325003	4078793	
17693	1517	4043071	1945-08-20	1945-08-20 00:00:00	38000275	0	\N	\N	101396	0	228557008	4043071	
29745	2647	4107731	1992-06-07	1992-06-07 00:00:00	38000275	0	\N	\N	175134	0	180256009	4107731	
18048	1543	4043071	1951-09-19	1951-09-19 00:00:00	38000275	0	\N	\N	103428	0	228557008	4043071	
30155	2672	4107731	1990-12-30	1990-12-30 00:00:00	38000275	0	\N	\N	177032	0	180256009	4107731	
30303	2677	4043071	1987-07-10	1987-07-10 00:00:00	38000275	0	\N	\N	177429	0	228557008	4043071	
18551	1572	4058899	1974-10-31	1974-10-31 00:00:00	38000275	0	\N	\N	105545	0	168594001	4058899	
18799	1609	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	108129	0	180256009	4107731	
19043	1632	4057420	1988-11-13	1988-11-13 00:00:00	38000275	0	\N	\N	109551	0	18286008	4057420	
31128	2765	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	182981	0	180256009	4107731	
19343	1656	4295880	2008-06-14	2008-06-14 00:00:00	38000275	0	\N	\N	111159	0	76601001	4295880	
19556	1676	4195803	1999-06-02	1999-06-02 00:00:00	38000275	0	\N	\N	112469	0	312681000	4195803	
19792	1716	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	114682	0	180256009	4107731	
20001	1727	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	115545	0	180256009	4107731	
20054	1740	4125906	1961-06-21	1961-06-21 00:00:00	38000275	0	\N	\N	116291	0	288086009	4125906	
20209	1746	4151422	1970-11-15	1970-11-15 00:00:00	38000275	0	\N	\N	116721	0	269911007	4151422	
32393	2849	4195803	2004-04-28	2004-04-28 00:00:00	38000275	0	\N	\N	189297	0	312681000	4195803	
32587	2863	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	190357	0	180256009	4107731	
44697	3916	4295880	1993-03-31	1993-03-31 00:00:00	38000275	0	\N	\N	260377	0	76601001	4295880	
32918	2891	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	192336	0	180256009	4107731	
21189	1837	4043071	1973-09-13	1973-09-13 00:00:00	38000275	0	\N	\N	122715	0	228557008	4043071	
21406	1852	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	123999	0	180256009	4107731	
45470	4014	4107731	1999-08-31	1999-08-31 00:00:00	38000275	0	\N	\N	266700	0	180256009	4107731	
21719	1882	4107731	1990-10-27	1990-10-27 00:00:00	38000275	0	\N	\N	125590	0	180256009	4107731	
33886	2950	4170947	1982-04-15	1982-04-15 00:00:00	38000275	0	\N	\N	196937	0	274474001	4170947	
22217	1946	4125906	1935-02-07	1935-02-07 00:00:00	38000275	0	\N	\N	129275	0	288086009	4125906	
22296	1952	4195803	2015-03-02	2015-03-02 00:00:00	38000275	0	\N	\N	129811	0	312681000	4195803	
22532	1971	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	131098	0	180256009	4107731	
22779	1980	4107731	1993-02-14	1993-02-14 00:00:00	38000275	0	\N	\N	131868	0	180256009	4107731	
22988	1999	4107731	2014-05-28	2014-05-28 00:00:00	38000275	0	\N	\N	133124	0	180256009	4107731	
47019	4127	4163872	1965-11-22	1965-11-22 00:00:00	38000275	0	\N	\N	274338	0	399208008	4163872	
23355	2034	4202451	2018-01-17	2018-01-17 00:00:00	38000275	0	\N	\N	135443	0	433112001	4202451	
35368	3092	4163872	1964-05-24	1964-05-24 00:00:00	38000275	0	\N	\N	205905	0	399208008	4163872	
23704	2070	4107731	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	137750	0	180256009	4107731	
23845	2075	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	138090	0	180256009	4107731	
11987	1099	4107731	1993-05-08	1993-05-08 00:00:00	38000275	0	\N	\N	72187	0	180256009	4107731	
24152	2114	4057420	1988-06-15	1988-06-15 00:00:00	38000275	0	\N	\N	140683	0	18286008	4057420	
12454	1118	4125906	1980-06-06	1980-06-06 00:00:00	38000275	0	\N	\N	73702	0	288086009	4125906	
24543	2147	4062501	1956-10-03	1956-10-03 00:00:00	38000275	0	\N	\N	142926	0	171231001	4062501	
24777	2168	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	144530	0	180256009	4107731	
13039	1176	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	77682	0	180256009	4107731	
25083	2186	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	145819	0	180256009	4107731	
13460	1223	4057420	2018-06-15	2018-06-15 00:00:00	38000275	0	\N	\N	80511	0	18286008	4057420	
13651	1245	4057420	2003-10-10	2003-10-10 00:00:00	38000275	0	\N	\N	81904	0	18286008	4057420	
13733	1246	4125906	1994-03-03	1994-03-03 00:00:00	38000275	0	\N	\N	82055	0	288086009	4125906	
13930	1261	4107731	1990-03-10	1990-03-10 00:00:00	38000275	0	\N	\N	83241	0	180256009	4107731	
14130	1272	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	83874	0	180256009	4107731	
26215	2287	4151422	1981-01-06	1981-01-06 00:00:00	38000275	0	\N	\N	152133	0	269911007	4151422	
14478	1292	4151422	1981-06-24	1981-06-24 00:00:00	38000275	0	\N	\N	85384	0	269911007	4151422	
26632	2333	4057420	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	155142	0	18286008	4057420	
14867	1318	4198190	1953-03-05	1953-03-05 00:00:00	38000275	0	\N	\N	87438	0	80146002	4198190	
15135	1356	4107731	1996-07-11	1996-07-11 00:00:00	38000275	0	\N	\N	89966	0	180256009	4107731	
15230	1359	4078793	1992-05-26	1992-05-26 00:00:00	38000275	0	\N	\N	90174	0	180325003	4078793	
15517	1378	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	91413	0	180256009	4107731	
15539	1379	4125906	1987-08-30	1987-08-30 00:00:00	38000275	0	\N	\N	91515	0	288086009	4125906	
27701	2423	4243062	1997-06-29	1997-06-29 00:00:00	38000275	0	\N	\N	160767	0	60027007	4243062	
16007	1399	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	93055	0	180256009	4107731	
16160	1407	4107731	1992-11-21	1992-11-21 00:00:00	38000275	0	\N	\N	93569	0	180256009	4107731	
28317	2503	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	165699	0	180256009	4107731	
16627	1441	4107731	1990-02-12	1990-02-12 00:00:00	38000275	0	\N	\N	96032	0	180256009	4107731	
28620	2542	4151422	1994-10-11	1994-10-11 00:00:00	38000275	0	\N	\N	168198	0	269911007	4151422	
28857	2554	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	169159	0	180256009	4107731	
17059	1476	4170947	1961-08-21	1961-08-21 00:00:00	38000275	0	\N	\N	98494	0	274474001	4170947	
17337	1496	4243062	1979-08-29	1979-08-29 00:00:00	38000275	0	\N	\N	99741	0	60027007	4243062	
17464	1506	4202451	2012-10-13	2012-10-13 00:00:00	38000275	0	\N	\N	100408	0	433112001	4202451	
17694	1517	4043071	1946-10-07	1946-10-07 00:00:00	38000275	0	\N	\N	101451	0	228557008	4043071	
29746	2647	4107731	1992-06-28	1992-06-28 00:00:00	38000275	0	\N	\N	175154	0	180256009	4107731	
18049	1543	4043071	1951-06-20	1951-06-20 00:00:00	38000275	0	\N	\N	103373	0	228557008	4043071	
30156	2672	4125906	1962-01-27	1962-01-27 00:00:00	38000275	0	\N	\N	176980	0	288086009	4125906	
30304	2677	4043071	1985-07-26	1985-07-26 00:00:00	38000275	0	\N	\N	177374	0	228557008	4043071	
18552	1574	4043071	1972-12-29	1972-12-29 00:00:00	38000275	0	\N	\N	105695	0	228557008	4043071	
18800	1609	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	108107	0	180256009	4107731	
19044	1632	40492359	1988-11-13	1988-11-13 00:00:00	38000275	0	\N	\N	109551	0	447365002	40492359	
31129	2765	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	182995	0	180256009	4107731	
19344	1656	4295880	2009-06-13	2009-06-13 00:00:00	38000275	0	\N	\N	111063	0	76601001	4295880	
19557	1677	4125906	1974-01-17	1974-01-17 00:00:00	38000275	0	\N	\N	112489	0	288086009	4125906	
19793	1716	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	114613	0	180256009	4107731	
20002	1727	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	115550	0	180256009	4107731	
20055	1740	4181917	1952-09-06	1952-09-06 00:00:00	38000275	0	\N	\N	116290	0	54550000	4181917	
20213	1748	4252419	1989-07-03	1989-07-03 00:00:00	38000275	0	\N	\N	116870	0	74016001	4252419	
32394	2849	4243062	1964-05-14	1964-05-14 00:00:00	38000275	0	\N	\N	189293	0	60027007	4243062	
32588	2863	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	190348	0	180256009	4107731	
44698	3916	4295880	1997-03-26	1997-03-26 00:00:00	38000275	0	\N	\N	260323	0	76601001	4295880	
32919	2891	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	192268	0	180256009	4107731	
21192	1840	4010253	1994-05-13	1994-05-13 00:00:00	38000275	0	\N	\N	122837	0	112790001	4010253	
21407	1852	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	123973	0	180256009	4107731	
45471	4014	4107731	2001-02-06	2001-02-06 00:00:00	38000275	0	\N	\N	266707	0	180256009	4107731	
21720	1882	4107731	1990-07-14	1990-07-14 00:00:00	38000275	0	\N	\N	125536	0	180256009	4107731	
33887	2950	4243062	1982-04-15	1982-04-15 00:00:00	38000275	0	\N	\N	196937	0	60027007	4243062	
22218	1946	4151422	1974-11-08	1974-11-08 00:00:00	38000275	0	\N	\N	129334	0	269911007	4151422	
22297	1952	4058899	1967-12-25	1967-12-25 00:00:00	38000275	0	\N	\N	129788	0	168594001	4058899	
22533	1971	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	131078	0	180256009	4107731	
22780	1980	4163872	1972-10-12	1972-10-12 00:00:00	38000275	0	\N	\N	131849	0	399208008	4163872	
22989	1999	4107731	2011-10-26	2011-10-26 00:00:00	38000275	0	\N	\N	133042	0	180256009	4107731	
47020	4127	4125906	1994-03-16	1994-03-16 00:00:00	38000275	0	\N	\N	274343	0	288086009	4125906	
23356	2034	4163872	1939-12-22	1939-12-22 00:00:00	38000275	0	\N	\N	135433	0	399208008	4163872	
35369	3092	4170947	1964-05-24	1964-05-24 00:00:00	38000275	0	\N	\N	205905	0	274474001	4170947	
23705	2070	4107731	1990-06-18	1990-06-18 00:00:00	38000275	0	\N	\N	137745	0	180256009	4107731	
23846	2075	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	138019	0	180256009	4107731	
11988	1099	4107731	1993-04-17	1993-04-17 00:00:00	38000275	0	\N	\N	72205	0	180256009	4107731	
24153	2114	40492359	1988-06-15	1988-06-15 00:00:00	38000275	0	\N	\N	140683	0	447365002	40492359	
12455	1120	4275113	1977-11-01	1977-11-01 00:00:00	38000275	0	\N	\N	73802	0	65200003	4275113	
24547	2149	4151422	2004-09-26	2004-09-26 00:00:00	38000275	0	\N	\N	143065	0	269911007	4151422	
24778	2168	4024289	1959-07-30	1959-07-30 00:00:00	38000275	0	\N	\N	144573	0	19490002	4024289	
13040	1176	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	77616	0	180256009	4107731	
25084	2186	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	145777	0	180256009	4107731	
13461	1223	4151422	2015-01-24	2015-01-24 00:00:00	38000275	0	\N	\N	80526	0	269911007	4151422	
25482	2217	4295880	1999-08-27	1999-08-27 00:00:00	38000275	0	\N	\N	147683	0	76601001	4295880	
13734	1246	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	82102	0	180256009	4107731	
13931	1261	4107731	1991-05-25	1991-05-25 00:00:00	38000275	0	\N	\N	83213	0	180256009	4107731	
14131	1272	4107731	1995-06-02	1995-06-02 00:00:00	38000275	0	\N	\N	83897	0	180256009	4107731	
26216	2287	4078793	2007-06-08	2007-06-08 00:00:00	38000275	0	\N	\N	152172	0	180325003	4078793	
14479	1292	4197460	1963-06-14	1963-06-14 00:00:00	38000275	0	\N	\N	85413	0	313191000	4197460	
26633	2333	4125906	1940-09-12	1940-09-12 00:00:00	38000275	0	\N	\N	155159	0	288086009	4125906	
14868	1320	4151422	1971-10-06	1971-10-06 00:00:00	38000275	0	\N	\N	87480	0	269911007	4151422	
15136	1356	4107731	1998-05-14	1998-05-14 00:00:00	38000275	0	\N	\N	89902	0	180256009	4107731	
15231	1359	4078793	1995-06-13	1995-06-13 00:00:00	38000275	0	\N	\N	90151	0	180325003	4078793	
15518	1378	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	91378	0	180256009	4107731	
15540	1379	4125906	1968-08-29	1968-08-29 00:00:00	38000275	0	\N	\N	91510	0	288086009	4125906	
27702	2423	4151422	1970-01-14	1970-01-14 00:00:00	38000275	0	\N	\N	160728	0	269911007	4151422	
16008	1399	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	93027	0	180256009	4107731	
16161	1407	4107731	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	93481	0	180256009	4107731	
28318	2503	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	165686	0	180256009	4107731	
16628	1441	4107731	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	95990	0	180256009	4107731	
28621	2542	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	168100	0	180256009	4107731	
28858	2554	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	169158	0	180256009	4107731	
17060	1476	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	98463	0	180256009	4107731	
17338	1496	4170947	1994-06-16	1994-06-16 00:00:00	38000275	0	\N	\N	99743	0	274474001	4170947	
17465	1506	4252419	1952-08-29	1952-08-29 00:00:00	38000275	0	\N	\N	100393	0	74016001	4252419	
17695	1517	4043071	1946-03-04	1946-03-04 00:00:00	38000275	0	\N	\N	101397	0	228557008	4043071	
29747	2647	4107731	1990-07-15	1990-07-15 00:00:00	38000275	0	\N	\N	175116	0	180256009	4107731	
18050	1543	4058899	1946-06-21	1946-06-21 00:00:00	38000275	0	\N	\N	103421	0	168594001	4058899	
30157	2672	4107731	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	177017	0	180256009	4107731	
30305	2677	4043071	1986-07-25	1986-07-25 00:00:00	38000275	0	\N	\N	177426	0	228557008	4043071	
18553	1574	4151422	1966-07-25	1966-07-25 00:00:00	38000275	0	\N	\N	105694	0	269911007	4151422	
18801	1609	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	108098	0	180256009	4107731	
19045	1632	4181917	1962-07-20	1962-07-20 00:00:00	38000275	0	\N	\N	109549	0	54550000	4181917	
31130	2765	4243062	1946-11-15	1946-11-15 00:00:00	38000275	0	\N	\N	182884	0	60027007	4243062	
19345	1656	4295880	2008-12-13	2008-12-13 00:00:00	38000275	0	\N	\N	111127	0	76601001	4295880	
19558	1677	4125906	2018-08-08	2018-08-08 00:00:00	38000275	0	\N	\N	112490	0	288086009	4125906	
19794	1716	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	114615	0	180256009	4107731	
20003	1727	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	115557	0	180256009	4107731	
20056	1740	4151422	1988-08-09	1988-08-09 00:00:00	38000275	0	\N	\N	116264	0	269911007	4151422	
20214	1748	4151422	1987-09-01	1987-09-01 00:00:00	38000275	0	\N	\N	116912	0	269911007	4151422	
32395	2849	4170947	1964-05-14	1964-05-14 00:00:00	38000275	0	\N	\N	189293	0	274474001	4170947	
32589	2863	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	190345	0	180256009	4107731	
44699	3916	4107731	1993-07-21	1993-07-21 00:00:00	38000275	0	\N	\N	260405	0	180256009	4107731	
32920	2891	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	192381	0	180256009	4107731	
21193	1840	4024289	1986-08-19	1986-08-19 00:00:00	38000275	0	\N	\N	122840	0	19490002	4024289	
21408	1852	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	123914	0	180256009	4107731	
45472	4014	4107731	2000-09-12	2000-09-12 00:00:00	38000275	0	\N	\N	266722	0	180256009	4107731	
21721	1882	4107731	1991-07-06	1991-07-06 00:00:00	38000275	0	\N	\N	125541	0	180256009	4107731	
33888	2950	4058899	2014-02-11	2014-02-11 00:00:00	38000275	0	\N	\N	196943	0	168594001	4058899	
22219	1947	4326177	1961-10-14	1961-10-14 00:00:00	38000275	0	\N	\N	129425	0	430193006	4326177	
22298	1952	4275113	1969-07-26	1969-07-26 00:00:00	38000275	0	\N	\N	129825	0	65200003	4275113	
22534	1971	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	131071	0	180256009	4107731	
22781	1980	4107731	1990-08-05	1990-08-05 00:00:00	38000275	0	\N	\N	131831	0	180256009	4107731	
22990	1999	4107731	2015-01-14	2015-01-14 00:00:00	38000275	0	\N	\N	133155	0	180256009	4107731	
47021	4127	4202451	2012-04-01	2012-04-01 00:00:00	38000275	0	\N	\N	274344	0	433112001	4202451	
23357	2034	4170947	1996-09-10	1996-09-10 00:00:00	38000275	0	\N	\N	135489	0	274474001	4170947	
35370	3092	4275113	1970-07-20	1970-07-20 00:00:00	38000275	0	\N	\N	205865	0	65200003	4275113	
23706	2070	4107731	1992-06-22	1992-06-22 00:00:00	38000275	0	\N	\N	137672	0	180256009	4107731	
23847	2075	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	138068	0	180256009	4107731	
11989	1099	4125906	1969-06-12	1969-06-12 00:00:00	38000275	0	\N	\N	72157	0	288086009	4125906	
24154	2115	4125906	1970-12-12	1970-12-12 00:00:00	38000275	0	\N	\N	140702	0	288086009	4125906	
12456	1120	4047491	1987-10-26	1987-10-26 00:00:00	38000275	0	\N	\N	73812	0	1225002	4047491	
24548	2149	4197460	1959-10-15	1959-10-15 00:00:00	38000275	0	\N	\N	143074	0	313191000	4197460	
24779	2168	4170947	1959-07-30	1959-07-30 00:00:00	38000275	0	\N	\N	144573	0	274474001	4170947	
13041	1176	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	77604	0	180256009	4107731	
25085	2186	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	145740	0	180256009	4107731	
13462	1223	4078793	2017-06-09	2017-06-09 00:00:00	38000275	0	\N	\N	80463	0	180325003	4078793	
25483	2217	4295880	1999-11-26	1999-11-26 00:00:00	38000275	0	\N	\N	147672	0	76601001	4295880	
13750	1249	4151422	2000-06-24	2000-06-24 00:00:00	38000275	0	\N	\N	82310	0	269911007	4151422	
13932	1261	4107731	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	83232	0	180256009	4107731	
14132	1272	4107731	1995-01-27	1995-01-27 00:00:00	38000275	0	\N	\N	83894	0	180256009	4107731	
26217	2287	4057420	2013-07-12	2013-07-12 00:00:00	38000275	0	\N	\N	152192	0	18286008	4057420	
14480	1292	4125906	1972-02-26	1972-02-26 00:00:00	38000275	0	\N	\N	85414	0	288086009	4125906	
26634	2333	4078793	1997-05-27	1997-05-27 00:00:00	38000275	0	\N	\N	155250	0	180325003	4078793	
14869	1320	4125906	2019-05-25	2019-05-25 00:00:00	38000275	0	\N	\N	87479	0	288086009	4125906	
15137	1356	4107731	1996-03-07	1996-03-07 00:00:00	38000275	0	\N	\N	89913	0	180256009	4107731	
15232	1359	4057420	1989-04-25	1989-04-25 00:00:00	38000275	0	\N	\N	90185	0	18286008	4057420	
15519	1378	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	91412	0	180256009	4107731	
15543	1381	4047491	1993-11-11	1993-11-11 00:00:00	38000275	0	\N	\N	91565	0	1225002	4047491	
27703	2423	4195803	2016-12-19	2016-12-19 00:00:00	38000275	0	\N	\N	160790	0	312681000	4195803	
16009	1399	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	93062	0	180256009	4107731	
16162	1407	4107731	1993-05-08	1993-05-08 00:00:00	38000275	0	\N	\N	93483	0	180256009	4107731	
28319	2504	4187458	1981-10-19	1981-10-19 00:00:00	38000275	0	\N	\N	165791	0	415300000	4187458	
16629	1441	4107731	1991-08-12	1991-08-12 00:00:00	38000275	0	\N	\N	95956	0	180256009	4107731	
28622	2542	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	168205	0	180256009	4107731	
28859	2554	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	169137	0	180256009	4107731	
17061	1476	4047491	1978-08-22	1978-08-22 00:00:00	38000275	0	\N	\N	98367	0	1225002	4047491	
17339	1496	4243062	1994-06-16	1994-06-16 00:00:00	38000275	0	\N	\N	99743	0	60027007	4243062	
17466	1506	4125906	1998-03-22	1998-03-22 00:00:00	38000275	0	\N	\N	100395	0	288086009	4125906	
17696	1517	4043071	1945-09-17	1945-09-17 00:00:00	38000275	0	\N	\N	101422	0	228557008	4043071	
29748	2647	4107731	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	175192	0	180256009	4107731	
18051	1543	4043071	1951-11-21	1951-11-21 00:00:00	38000275	0	\N	\N	103369	0	228557008	4043071	
30158	2672	4107731	1993-04-18	1993-04-18 00:00:00	38000275	0	\N	\N	176922	0	180256009	4107731	
30306	2677	4170947	1974-11-30	1974-11-30 00:00:00	38000275	0	\N	\N	177357	0	274474001	4170947	
18554	1574	4043071	1972-12-01	1972-12-01 00:00:00	38000275	0	\N	\N	105714	0	228557008	4043071	
18802	1609	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	108183	0	180256009	4107731	
19046	1632	4151422	1958-05-18	1958-05-18 00:00:00	38000275	0	\N	\N	109586	0	269911007	4151422	
31131	2765	4170947	1946-11-15	1946-11-15 00:00:00	38000275	0	\N	\N	182884	0	274474001	4170947	
19346	1656	4295880	2007-03-17	2007-03-17 00:00:00	38000275	0	\N	\N	111119	0	76601001	4295880	
19559	1679	4125906	1973-09-09	1973-09-09 00:00:00	38000275	0	\N	\N	112585	0	288086009	4125906	
19795	1716	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	114773	0	180256009	4107731	
20004	1727	4125906	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	115473	0	288086009	4125906	
20057	1740	4330583	1997-09-09	1997-09-09 00:00:00	38000275	0	\N	\N	116256	0	22523008	4330583	
20215	1748	4125906	1980-08-05	1980-08-05 00:00:00	38000275	0	\N	\N	116869	0	288086009	4125906	
32396	2849	4195803	1987-09-25	1987-09-25 00:00:00	38000275	0	\N	\N	189295	0	312681000	4195803	
32590	2863	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	190451	0	180256009	4107731	
44700	3916	4107731	1994-01-26	1994-01-26 00:00:00	38000275	0	\N	\N	260373	0	180256009	4107731	
32921	2891	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	192357	0	180256009	4107731	
21194	1840	4170947	1986-08-19	1986-08-19 00:00:00	38000275	0	\N	\N	122840	0	274474001	4170947	
21409	1852	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	123891	0	180256009	4107731	
45473	4014	4107731	1999-07-20	1999-07-20 00:00:00	38000275	0	\N	\N	266699	0	180256009	4107731	
21722	1882	4107731	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	125545	0	180256009	4107731	
33889	2950	4195803	2014-02-11	2014-02-11 00:00:00	38000275	0	\N	\N	196943	0	312681000	4195803	
22220	1947	4187458	1961-10-14	1961-10-14 00:00:00	38000275	0	\N	\N	129425	0	415300000	4187458	
22299	1952	4238715	1975-09-29	1975-09-29 00:00:00	38000275	0	\N	\N	129826	0	68254000	4238715	
22535	1971	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	131096	0	180256009	4107731	
22782	1980	4191853	1993-07-11	1993-07-11 00:00:00	38000275	0	\N	\N	131768	0	395142003	4191853	
22991	1999	4107731	2014-03-05	2014-03-05 00:00:00	38000275	0	\N	\N	133151	0	180256009	4107731	
47024	4129	4047491	1988-08-24	1988-08-24 00:00:00	38000275	0	\N	\N	274462	0	1225002	4047491	
23358	2034	4163872	1996-09-10	1996-09-10 00:00:00	38000275	0	\N	\N	135489	0	399208008	4163872	
35371	3093	4293740	1973-05-16	1973-05-16 00:00:00	38000275	0	\N	\N	205970	0	384700001	4293740	
23707	2070	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	137676	0	180256009	4107731	
23848	2075	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	138079	0	180256009	4107731	
11990	1099	4107731	1990-06-02	1990-06-02 00:00:00	38000275	0	\N	\N	72244	0	180256009	4107731	
24155	2115	4293740	1970-12-12	1970-12-12 00:00:00	38000275	0	\N	\N	140702	0	384700001	4293740	
12457	1120	4170947	1987-10-26	1987-10-26 00:00:00	38000275	0	\N	\N	73812	0	274474001	4170947	
24549	2149	4163872	2010-01-12	2010-01-12 00:00:00	38000275	0	\N	\N	143079	0	399208008	4163872	
24780	2168	4151422	1995-09-12	1995-09-12 00:00:00	38000275	0	\N	\N	144437	0	269911007	4151422	
13042	1176	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	77634	0	395142003	4191853	
25086	2186	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	145810	0	395142003	4191853	
13463	1223	4078793	2016-06-03	2016-06-03 00:00:00	38000275	0	\N	\N	80509	0	180325003	4078793	
25484	2217	4295880	2001-02-23	2001-02-23 00:00:00	38000275	0	\N	\N	147689	0	76601001	4295880	
13751	1249	4187458	1988-01-20	1988-01-20 00:00:00	38000275	0	\N	\N	82277	0	415300000	4187458	
13933	1261	4107731	1990-09-15	1990-09-15 00:00:00	38000275	0	\N	\N	83181	0	180256009	4107731	
14133	1272	4107731	1995-03-31	1995-03-31 00:00:00	38000275	0	\N	\N	83888	0	180256009	4107731	
26218	2287	4024289	1954-09-10	1954-09-10 00:00:00	38000275	0	\N	\N	152155	0	19490002	4024289	
14481	1292	4293740	1972-02-26	1972-02-26 00:00:00	38000275	0	\N	\N	85414	0	384700001	4293740	
26635	2333	4078793	1998-06-02	1998-06-02 00:00:00	38000275	0	\N	\N	155176	0	180325003	4078793	
14870	1320	4293740	2019-05-25	2019-05-25 00:00:00	38000275	0	\N	\N	87479	0	384700001	4293740	
15138	1356	4107731	1995-05-18	1995-05-18 00:00:00	38000275	0	\N	\N	89890	0	180256009	4107731	
15233	1359	4078793	1991-05-14	1991-05-14 00:00:00	38000275	0	\N	\N	90148	0	180325003	4078793	
15520	1378	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	91388	0	180256009	4107731	
15544	1381	4170947	1993-11-11	1993-11-11 00:00:00	38000275	0	\N	\N	91565	0	274474001	4170947	
27704	2424	4058899	1979-08-14	1979-08-14 00:00:00	38000275	0	\N	\N	160818	0	168594001	4058899	
16010	1399	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	93057	0	180256009	4107731	
16163	1407	4107731	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	93553	0	180256009	4107731	
28320	2504	4326177	1981-10-19	1981-10-19 00:00:00	38000275	0	\N	\N	165791	0	430193006	4326177	
16630	1441	4107731	1990-04-16	1990-04-16 00:00:00	38000275	0	\N	\N	95983	0	180256009	4107731	
28623	2542	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	168172	0	180256009	4107731	
28860	2554	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	169114	0	180256009	4107731	
17062	1476	4170947	1978-08-22	1978-08-22 00:00:00	38000275	0	\N	\N	98367	0	274474001	4170947	
17340	1496	4195803	1994-06-16	1994-06-16 00:00:00	38000275	0	\N	\N	99743	0	312681000	4195803	
17467	1506	4195803	2006-04-01	2006-04-01 00:00:00	38000275	0	\N	\N	100480	0	312681000	4195803	
17697	1517	4043071	1946-07-08	1946-07-08 00:00:00	38000275	0	\N	\N	101412	0	228557008	4043071	
29749	2647	4107731	1990-06-24	1990-06-24 00:00:00	38000275	0	\N	\N	175104	0	180256009	4107731	
18052	1543	4043071	1951-07-25	1951-07-25 00:00:00	38000275	0	\N	\N	103368	0	228557008	4043071	
30159	2672	4107731	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	176934	0	180256009	4107731	
30307	2677	4047491	1974-11-30	1974-11-30 00:00:00	38000275	0	\N	\N	177357	0	1225002	4047491	
18555	1574	4151422	2002-08-08	2002-08-08 00:00:00	38000275	0	\N	\N	105666	0	269911007	4151422	
18803	1609	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	108108	0	180256009	4107731	
19047	1632	4163872	2004-01-07	2004-01-07 00:00:00	38000275	0	\N	\N	109560	0	399208008	4163872	
31132	2765	4035793	2018-01-02	2018-01-02 00:00:00	38000275	0	\N	\N	182827	0	15081005	4035793	
19347	1656	4275113	2012-08-16	2012-08-16 00:00:00	38000275	0	\N	\N	111109	0	65200003	4275113	
19560	1679	4293740	1973-09-09	1973-09-09 00:00:00	38000275	0	\N	\N	112585	0	384700001	4293740	
19796	1716	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	114739	0	180256009	4107731	
20005	1727	4293740	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	115473	0	384700001	4293740	
20058	1740	4170947	2010-08-24	2010-08-24 00:00:00	38000275	0	\N	\N	116292	0	274474001	4170947	
20216	1748	4151422	1975-02-28	1975-02-28 00:00:00	38000275	0	\N	\N	116922	0	269911007	4151422	
32397	2849	4243062	1987-09-25	1987-09-25 00:00:00	38000275	0	\N	\N	189295	0	60027007	4243062	
32591	2863	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	190435	0	180256009	4107731	
44701	3916	4107731	1993-05-19	1993-05-19 00:00:00	38000275	0	\N	\N	260419	0	180256009	4107731	
32922	2891	4191853	1975-04-27	1975-04-27 00:00:00	38000275	0	\N	\N	192353	0	395142003	4191853	
21198	1843	4107731	1995-11-08	1995-11-08 00:00:00	38000275	0	\N	\N	123027	0	180256009	4107731	
21410	1852	4125906	2016-10-29	2016-10-29 00:00:00	38000275	0	\N	\N	123948	0	288086009	4125906	
45474	4014	4107731	1999-06-08	1999-06-08 00:00:00	38000275	0	\N	\N	266698	0	180256009	4107731	
21723	1882	4107731	1993-04-17	1993-04-17 00:00:00	38000275	0	\N	\N	125483	0	180256009	4107731	
33890	2950	4125906	1955-04-16	1955-04-16 00:00:00	38000275	0	\N	\N	196936	0	288086009	4125906	
22221	1947	4037675	1961-10-14	1961-10-14 00:00:00	38000275	0	\N	\N	129425	0	162676008	4037675	
22300	1952	4186930	1974-07-29	1974-07-29 00:00:00	38000275	0	\N	\N	129782	0	46706006	4186930	
22536	1971	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	131086	0	180256009	4107731	
22783	1980	4107731	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	131885	0	180256009	4107731	
22992	1999	4107731	2013-05-15	2013-05-15 00:00:00	38000275	0	\N	\N	133131	0	180256009	4107731	
47025	4129	4170947	1988-08-24	1988-08-24 00:00:00	38000275	0	\N	\N	274462	0	274474001	4170947	
23359	2034	4195803	1996-09-10	1996-09-10 00:00:00	38000275	0	\N	\N	135489	0	312681000	4195803	
35372	3093	4125906	1973-05-16	1973-05-16 00:00:00	38000275	0	\N	\N	205970	0	288086009	4125906	
23708	2070	4107731	1992-01-06	1992-01-06 00:00:00	38000275	0	\N	\N	137693	0	180256009	4107731	
23849	2076	4170947	1973-01-17	1973-01-17 00:00:00	38000275	0	\N	\N	138209	0	274474001	4170947	
11991	1099	4107731	1993-02-13	1993-02-13 00:00:00	38000275	0	\N	\N	72142	0	180256009	4107731	
24156	2115	4145310	2011-04-02	2011-04-02 00:00:00	38000275	0	\N	\N	140706	0	268425006	4145310	
12458	1120	4238715	1980-02-04	1980-02-04 00:00:00	38000275	0	\N	\N	73804	0	68254000	4238715	
24550	2149	4202451	2005-11-12	2005-11-12 00:00:00	38000275	0	\N	\N	143066	0	433112001	4202451	
24781	2168	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	144478	0	180256009	4107731	
13043	1176	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	77619	0	180256009	4107731	
25087	2186	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	145763	0	180256009	4107731	
13464	1223	4151422	1966-01-21	1966-01-21 00:00:00	38000275	0	\N	\N	80513	0	269911007	4151422	
25485	2217	4295880	2000-08-25	2000-08-25 00:00:00	38000275	0	\N	\N	147673	0	76601001	4295880	
13752	1249	4326177	1988-01-20	1988-01-20 00:00:00	38000275	0	\N	\N	82277	0	430193006	4326177	
13934	1261	4107731	1992-02-22	1992-02-22 00:00:00	38000275	0	\N	\N	83230	0	180256009	4107731	
14134	1272	4107731	1995-09-15	1995-09-15 00:00:00	38000275	0	\N	\N	83939	0	180256009	4107731	
26219	2287	4170947	1954-09-10	1954-09-10 00:00:00	38000275	0	\N	\N	152155	0	274474001	4170947	
14482	1292	4252419	1999-01-15	1999-01-15 00:00:00	38000275	0	\N	\N	85417	0	74016001	4252419	
26636	2333	4151422	1941-12-17	1941-12-17 00:00:00	38000275	0	\N	\N	155223	0	269911007	4151422	
14871	1320	4145310	2006-03-04	2006-03-04 00:00:00	38000275	0	\N	\N	87478	0	268425006	4145310	
15139	1356	4107731	1997-09-04	1997-09-04 00:00:00	38000275	0	\N	\N	89919	0	180256009	4107731	
15234	1359	4057420	2008-04-15	2008-04-15 00:00:00	38000275	0	\N	\N	90178	0	18286008	4057420	
15521	1378	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	91389	0	180256009	4107731	
15545	1381	4163872	1983-12-04	1983-12-04 00:00:00	38000275	0	\N	\N	91564	0	399208008	4163872	
27705	2424	4163951	1997-06-06	1997-06-06 00:00:00	38000275	0	\N	\N	160819	0	29303009	4163951	
16011	1399	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	93030	0	180256009	4107731	
16164	1407	4058899	1971-08-18	1971-08-18 00:00:00	38000275	0	\N	\N	93562	0	168594001	4058899	
28321	2504	4037675	1981-10-19	1981-10-19 00:00:00	38000275	0	\N	\N	165791	0	162676008	4037675	
16631	1441	4107731	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	95982	0	180256009	4107731	
28624	2542	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	168085	0	180256009	4107731	
28861	2554	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	169121	0	180256009	4107731	
17063	1476	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	98380	0	180256009	4107731	
17341	1497	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	99917	0	180256009	4107731	
17469	1508	4043071	1938-01-24	1938-01-24 00:00:00	38000275	0	\N	\N	100644	0	228557008	4043071	
17698	1517	4043071	1946-04-01	1946-04-01 00:00:00	38000275	0	\N	\N	101423	0	228557008	4043071	
29750	2647	4107731	1993-01-24	1993-01-24 00:00:00	38000275	0	\N	\N	175203	0	180256009	4107731	
18053	1543	4216130	1994-10-23	1994-10-23 00:00:00	38000275	0	\N	\N	103423	0	415070008	4216130	
30160	2672	4107731	1990-04-01	1990-04-01 00:00:00	38000275	0	\N	\N	177029	0	180256009	4107731	
30308	2677	4043071	1986-10-03	1986-10-03 00:00:00	38000275	0	\N	\N	177377	0	228557008	4043071	
18556	1574	4058899	1967-04-19	1967-04-19 00:00:00	38000275	0	\N	\N	105632	0	168594001	4058899	
18804	1609	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	108206	0	180256009	4107731	
19050	1634	4047491	1966-12-11	1966-12-11 00:00:00	38000275	0	\N	\N	109687	0	1225002	4047491	
31133	2765	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	182867	0	180256009	4107731	
19348	1656	4275113	2006-09-09	2006-09-09 00:00:00	38000275	0	\N	\N	111118	0	65200003	4275113	
19561	1679	4047491	1989-07-01	1989-07-01 00:00:00	38000275	0	\N	\N	112586	0	1225002	4047491	
19797	1716	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	114746	0	180256009	4107731	
20006	1727	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	115516	0	180256009	4107731	
20059	1740	4243062	2010-08-24	2010-08-24 00:00:00	38000275	0	\N	\N	116292	0	60027007	4243062	
20217	1748	44783196	1989-07-10	1989-07-10 00:00:00	38000275	0	\N	\N	116868	0	699253003	44783196	
32398	2849	4170947	1987-09-25	1987-09-25 00:00:00	38000275	0	\N	\N	189295	0	274474001	4170947	
32592	2863	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	190445	0	180256009	4107731	
44702	3916	4295880	1995-12-27	1995-12-27 00:00:00	38000275	0	\N	\N	260393	0	76601001	4295880	
32923	2891	4151422	2011-03-13	2011-03-13 00:00:00	38000275	0	\N	\N	192372	0	269911007	4151422	
21199	1843	4107731	1997-10-22	1997-10-22 00:00:00	38000275	0	\N	\N	123121	0	180256009	4107731	
21411	1852	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	123900	0	180256009	4107731	
45475	4014	4107731	2001-01-16	2001-01-16 00:00:00	38000275	0	\N	\N	266705	0	180256009	4107731	
21724	1882	4107731	1992-06-27	1992-06-27 00:00:00	38000275	0	\N	\N	125550	0	180256009	4107731	
33891	2950	4125906	1949-11-29	1949-11-29 00:00:00	38000275	0	\N	\N	196935	0	288086009	4125906	
22222	1947	4170947	1956-05-22	1956-05-22 00:00:00	38000275	0	\N	\N	129465	0	274474001	4170947	
22301	1953	4170947	1964-06-17	1964-06-17 00:00:00	38000275	0	\N	\N	129882	0	274474001	4170947	
22537	1971	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	131044	0	180256009	4107731	
22784	1980	4107731	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	131790	0	180256009	4107731	
22993	1999	4191853	2015-04-08	2015-04-08 00:00:00	38000275	0	\N	\N	133128	0	395142003	4191853	
47026	4129	4125906	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	274463	0	288086009	4125906	
23360	2034	4252419	2016-11-04	2016-11-04 00:00:00	38000275	0	\N	\N	135431	0	74016001	4252419	
35373	3093	4125906	1981-02-24	1981-02-24 00:00:00	38000275	0	\N	\N	205971	0	288086009	4125906	
23709	2070	4107731	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	137746	0	180256009	4107731	
23850	2076	4047491	1973-01-17	1973-01-17 00:00:00	38000275	0	\N	\N	138209	0	1225002	4047491	
11992	1099	4107731	1990-10-27	1990-10-27 00:00:00	38000275	0	\N	\N	72112	0	180256009	4107731	
24157	2115	4010253	1989-07-26	1989-07-26 00:00:00	38000275	0	\N	\N	140709	0	112790001	4010253	
12459	1120	4170947	1971-12-19	1971-12-19 00:00:00	38000275	0	\N	\N	73810	0	274474001	4170947	
24551	2149	4293740	1990-09-19	1990-09-19 00:00:00	38000275	0	\N	\N	143127	0	384700001	4293740	
24782	2168	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	144464	0	180256009	4107731	
13044	1176	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	77590	0	395142003	4191853	
25088	2186	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	145762	0	180256009	4107731	
25280	2199	4198190	1995-07-19	1995-07-19 00:00:00	38000275	0	\N	\N	146580	0	80146002	4198190	
25486	2217	4024289	1995-12-02	1995-12-02 00:00:00	38000275	0	\N	\N	147668	0	19490002	4024289	
13753	1249	4037675	1988-01-20	1988-01-20 00:00:00	38000275	0	\N	\N	82277	0	162676008	4037675	
13935	1261	4107731	1990-10-06	1990-10-06 00:00:00	38000275	0	\N	\N	83211	0	180256009	4107731	
14135	1272	4107731	1995-12-08	1995-12-08 00:00:00	38000275	0	\N	\N	83898	0	180256009	4107731	
26220	2287	4078793	2004-05-21	2004-05-21 00:00:00	38000275	0	\N	\N	152146	0	180325003	4078793	
14483	1292	4197460	1960-09-21	1960-09-21 00:00:00	38000275	0	\N	\N	85412	0	313191000	4197460	
26637	2333	4202832	1978-05-19	1978-05-19 00:00:00	38000275	0	\N	\N	155162	0	52765003	4202832	
14872	1320	4125906	1947-09-21	1947-09-21 00:00:00	38000275	0	\N	\N	87474	0	288086009	4125906	
15140	1356	4107731	1996-03-28	1996-03-28 00:00:00	38000275	0	\N	\N	89934	0	180256009	4107731	
15235	1359	4078793	1993-06-01	1993-06-01 00:00:00	38000275	0	\N	\N	90150	0	180325003	4078793	
27340	2387	4151422	1972-05-08	1972-05-08 00:00:00	38000275	0	\N	\N	158776	0	269911007	4151422	
15546	1381	4170947	1983-12-04	1983-12-04 00:00:00	38000275	0	\N	\N	91564	0	274474001	4170947	
27706	2424	42535580	1997-06-06	1997-06-06 00:00:00	38000275	0	\N	\N	160819	0	426701000119108	42535580	
16012	1399	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	92998	0	180256009	4107731	
16165	1407	4107731	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	93484	0	180256009	4107731	
28322	2504	4151422	2006-04-02	2006-04-02 00:00:00	38000275	0	\N	\N	165804	0	269911007	4151422	
16632	1441	4107731	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	96039	0	180256009	4107731	
28625	2542	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	168109	0	180256009	4107731	
28862	2554	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	169103	0	180256009	4107731	
17064	1476	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	98388	0	180256009	4107731	
17342	1497	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	99775	0	180256009	4107731	
17470	1508	4043071	1938-06-06	1938-06-06 00:00:00	38000275	0	\N	\N	100637	0	228557008	4043071	
17699	1517	4043071	1944-12-25	1944-12-25 00:00:00	38000275	0	\N	\N	101420	0	228557008	4043071	
29751	2647	4107731	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	175137	0	180256009	4107731	
18054	1543	4336464	1994-10-23	1994-10-23 00:00:00	38000275	0	\N	\N	103423	0	232717009	4336464	
30161	2672	4107731	1990-08-05	1990-08-05 00:00:00	38000275	0	\N	\N	177004	0	180256009	4107731	
30309	2677	4043071	1986-06-27	1986-06-27 00:00:00	38000275	0	\N	\N	177366	0	228557008	4043071	
18557	1574	4043071	1972-10-27	1972-10-27 00:00:00	38000275	0	\N	\N	105713	0	228557008	4043071	
18805	1609	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	108064	0	180256009	4107731	
19051	1634	4170947	1966-12-11	1966-12-11 00:00:00	38000275	0	\N	\N	109687	0	274474001	4170947	
31134	2765	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	182996	0	180256009	4107731	
19349	1656	4295880	2004-12-18	2004-12-18 00:00:00	38000275	0	\N	\N	111115	0	76601001	4295880	
19562	1679	4170947	1989-07-01	1989-07-01 00:00:00	38000275	0	\N	\N	112586	0	274474001	4170947	
19798	1716	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	114605	0	180256009	4107731	
20007	1727	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	115439	0	180256009	4107731	
20060	1740	4195803	2010-08-24	2010-08-24 00:00:00	38000275	0	\N	\N	116292	0	312681000	4195803	
20226	1750	4125906	1995-04-23	1995-04-23 00:00:00	38000275	0	\N	\N	117004	0	288086009	4125906	
32467	2853	4170947	1962-08-26	1962-08-26 00:00:00	38000275	0	\N	\N	189542	0	274474001	4170947	
32593	2863	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	190327	0	180256009	4107731	
44703	3916	4107731	1991-10-30	1991-10-30 00:00:00	38000275	0	\N	\N	260343	0	180256009	4107731	
32924	2891	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	192277	0	180256009	4107731	
21200	1843	4107731	1995-12-20	1995-12-20 00:00:00	38000275	0	\N	\N	123112	0	180256009	4107731	
21412	1852	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	123931	0	180256009	4107731	
45476	4014	4107731	1998-05-05	1998-05-05 00:00:00	38000275	0	\N	\N	266798	0	180256009	4107731	
21725	1882	4047491	1971-09-24	1971-09-24 00:00:00	38000275	0	\N	\N	125565	0	1225002	4047491	
33892	2950	4125906	1983-06-09	1983-06-09 00:00:00	38000275	0	\N	\N	196938	0	288086009	4125906	
22223	1947	4047491	1956-05-22	1956-05-22 00:00:00	38000275	0	\N	\N	129465	0	1225002	4047491	
22302	1953	4047491	1964-06-17	1964-06-17 00:00:00	38000275	0	\N	\N	129882	0	1225002	4047491	
22538	1971	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	131053	0	180256009	4107731	
22785	1980	4107731	1992-11-01	1992-11-01 00:00:00	38000275	0	\N	\N	131791	0	180256009	4107731	
22994	1999	4107731	2015-03-18	2015-03-18 00:00:00	38000275	0	\N	\N	133105	0	180256009	4107731	
47027	4130	4078793	2016-05-19	2016-05-19 00:00:00	38000275	0	\N	\N	274605	0	180325003	4078793	
23361	2034	4252419	2011-08-26	2011-08-26 00:00:00	38000275	0	\N	\N	135430	0	74016001	4252419	
35374	3093	4293740	1984-11-19	1984-11-19 00:00:00	38000275	0	\N	\N	205972	0	384700001	4293740	
23710	2070	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	137698	0	180256009	4107731	
23851	2076	4163872	2005-07-10	2005-07-10 00:00:00	38000275	0	\N	\N	138145	0	399208008	4163872	
11993	1099	4107731	1991-09-28	1991-09-28 00:00:00	38000275	0	\N	\N	72221	0	180256009	4107731	
24158	2115	44783196	2004-09-05	2004-09-05 00:00:00	38000275	0	\N	\N	140751	0	699253003	44783196	
12460	1120	4047491	1971-12-19	1971-12-19 00:00:00	38000275	0	\N	\N	73810	0	1225002	4047491	
24552	2149	4125906	1990-09-19	1990-09-19 00:00:00	38000275	0	\N	\N	143127	0	288086009	4125906	
24783	2168	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	144458	0	395142003	4191853	
13045	1176	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	77691	0	180256009	4107731	
25089	2186	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	145836	0	180256009	4107731	
25281	2199	4170947	1984-04-26	1984-04-26 00:00:00	38000275	0	\N	\N	146577	0	274474001	4170947	
25487	2217	4170947	1995-12-02	1995-12-02 00:00:00	38000275	0	\N	\N	147668	0	274474001	4170947	
13754	1249	4058899	2002-08-24	2002-08-24 00:00:00	38000275	0	\N	\N	82292	0	168594001	4058899	
13936	1261	4107731	1993-05-29	1993-05-29 00:00:00	38000275	0	\N	\N	83186	0	180256009	4107731	
14136	1272	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	83869	0	180256009	4107731	
26221	2287	4057420	2005-05-27	2005-05-27 00:00:00	38000275	0	\N	\N	152171	0	18286008	4057420	
14484	1292	44783196	1999-01-22	1999-01-22 00:00:00	38000275	0	\N	\N	85356	0	699253003	44783196	
26638	2333	4163951	1978-05-19	1978-05-19 00:00:00	38000275	0	\N	\N	155162	0	29303009	4163951	
14873	1320	4024289	1998-09-12	1998-09-12 00:00:00	38000275	0	\N	\N	87477	0	19490002	4024289	
15141	1356	4107731	1997-10-16	1997-10-16 00:00:00	38000275	0	\N	\N	89864	0	180256009	4107731	
15236	1359	4078793	1990-05-01	1990-05-01 00:00:00	38000275	0	\N	\N	90122	0	180325003	4078793	
27341	2387	4275113	1986-02-07	1986-02-07 00:00:00	38000275	0	\N	\N	158765	0	65200003	4275113	
15547	1381	4170947	1982-02-12	1982-02-12 00:00:00	38000275	0	\N	\N	91563	0	274474001	4170947	
27707	2424	4163971	1997-06-06	1997-06-06 00:00:00	38000275	0	\N	\N	160819	0	45595009	4163971	
16013	1399	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	93114	0	180256009	4107731	
16166	1407	4107731	1993-01-02	1993-01-02 00:00:00	38000275	0	\N	\N	93570	0	180256009	4107731	
28323	2504	4145310	1963-08-05	1963-08-05 00:00:00	38000275	0	\N	\N	165851	0	268425006	4145310	
16633	1441	4107731	1990-12-03	1990-12-03 00:00:00	38000275	0	\N	\N	96085	0	180256009	4107731	
28626	2542	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	168197	0	180256009	4107731	
28863	2554	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	169243	0	180256009	4107731	
17065	1476	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	98397	0	180256009	4107731	
17343	1497	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	99826	0	180256009	4107731	
17471	1508	4043071	1938-08-29	1938-08-29 00:00:00	38000275	0	\N	\N	100638	0	228557008	4043071	
17700	1517	4043071	1947-01-20	1947-01-20 00:00:00	38000275	0	\N	\N	101415	0	228557008	4043071	
29752	2647	4107731	1991-01-20	1991-01-20 00:00:00	38000275	0	\N	\N	175129	0	180256009	4107731	
18055	1543	4043071	1951-04-11	1951-04-11 00:00:00	38000275	0	\N	\N	103419	0	228557008	4043071	
30162	2672	4107731	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	176919	0	180256009	4107731	
30310	2677	4043071	1985-09-20	1985-09-20 00:00:00	38000275	0	\N	\N	177365	0	228557008	4043071	
18567	1576	4275113	1981-10-06	1981-10-06 00:00:00	38000275	0	\N	\N	105805	0	65200003	4275113	
18806	1609	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	108095	0	180256009	4107731	
19052	1634	4078793	2016-09-09	2016-09-09 00:00:00	38000275	0	\N	\N	109778	0	180325003	4078793	
31135	2765	4107731	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	182882	0	180256009	4107731	
19350	1656	4295880	2011-12-10	2011-12-10 00:00:00	38000275	0	\N	\N	111134	0	76601001	4295880	
19563	1679	4125906	2013-03-27	2013-03-27 00:00:00	38000275	0	\N	\N	112587	0	288086009	4125906	
19799	1716	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	114766	0	180256009	4107731	
20008	1727	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	115531	0	180256009	4107731	
20127	1743	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	116527	0	180256009	4107731	
20227	1750	4058899	1974-01-13	1974-01-13 00:00:00	38000275	0	\N	\N	117003	0	168594001	4058899	
32468	2853	4024289	1962-08-26	1962-08-26 00:00:00	38000275	0	\N	\N	189542	0	19490002	4024289	
32594	2863	4058899	1988-05-16	1988-05-16 00:00:00	38000275	0	\N	\N	190390	0	168594001	4058899	
44704	3916	4043071	1989-12-03	1989-12-03 00:00:00	38000275	0	\N	\N	260260	0	228557008	4043071	
32925	2891	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	192276	0	180256009	4107731	
21201	1843	4107731	1994-12-07	1994-12-07 00:00:00	38000275	0	\N	\N	123061	0	180256009	4107731	
21413	1852	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	123968	0	180256009	4107731	
45477	4014	4107731	1998-09-08	1998-09-08 00:00:00	38000275	0	\N	\N	266773	0	180256009	4107731	
21726	1882	4170947	1971-09-24	1971-09-24 00:00:00	38000275	0	\N	\N	125565	0	274474001	4170947	
33893	2951	4151422	1965-03-06	1965-03-06 00:00:00	38000275	0	\N	\N	197058	0	269911007	4151422	
22224	1947	4243062	1976-04-07	1976-04-07 00:00:00	38000275	0	\N	\N	129466	0	60027007	4243062	
22303	1953	4195803	2014-10-27	2014-10-27 00:00:00	38000275	0	\N	\N	129945	0	312681000	4195803	
22539	1971	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	131097	0	180256009	4107731	
22786	1980	4107731	1992-02-23	1992-02-23 00:00:00	38000275	0	\N	\N	131852	0	180256009	4107731	
22995	1999	4043071	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	133072	0	228557008	4043071	
47028	4130	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	274637	0	180256009	4107731	
23375	2037	4151422	1970-07-23	1970-07-23 00:00:00	38000275	0	\N	\N	135679	0	269911007	4151422	
35375	3093	4125906	1984-11-19	1984-11-19 00:00:00	38000275	0	\N	\N	205972	0	288086009	4125906	
23711	2070	4107731	1991-12-16	1991-12-16 00:00:00	38000275	0	\N	\N	137671	0	180256009	4107731	
23852	2076	4125906	1970-11-08	1970-11-08 00:00:00	38000275	0	\N	\N	138208	0	288086009	4125906	
11994	1099	4107731	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	72121	0	180256009	4107731	
24159	2115	4170947	1989-12-16	1989-12-16 00:00:00	38000275	0	\N	\N	140704	0	274474001	4170947	
12462	1122	4170947	1972-08-03	1972-08-03 00:00:00	38000275	0	\N	\N	73928	0	274474001	4170947	
24553	2150	4195803	2003-10-19	2003-10-19 00:00:00	38000275	0	\N	\N	143152	0	312681000	4195803	
24784	2168	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	144531	0	180256009	4107731	
13046	1176	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	77614	0	180256009	4107731	
25090	2186	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	145724	0	180256009	4107731	
25282	2199	4243062	1984-04-26	1984-04-26 00:00:00	38000275	0	\N	\N	146577	0	60027007	4243062	
25488	2217	4295880	2001-11-23	2001-11-23 00:00:00	38000275	0	\N	\N	147691	0	76601001	4295880	
13755	1249	4024289	1984-09-27	1984-09-27 00:00:00	38000275	0	\N	\N	82291	0	19490002	4024289	
13937	1261	4107731	1990-12-29	1990-12-29 00:00:00	38000275	0	\N	\N	83173	0	180256009	4107731	
14137	1272	4107731	1993-09-10	1993-09-10 00:00:00	38000275	0	\N	\N	83871	0	180256009	4107731	
26222	2287	4078793	2008-06-13	2008-06-13 00:00:00	38000275	0	\N	\N	152165	0	180325003	4078793	
14485	1293	4170947	1945-10-25	1945-10-25 00:00:00	38000275	0	\N	\N	85596	0	274474001	4170947	
26639	2333	4163971	1978-05-19	1978-05-19 00:00:00	38000275	0	\N	\N	155162	0	45595009	4163971	
14874	1320	4170947	1998-09-12	1998-09-12 00:00:00	38000275	0	\N	\N	87477	0	274474001	4170947	
15142	1356	4191853	1995-02-23	1995-02-23 00:00:00	38000275	0	\N	\N	89888	0	395142003	4191853	
15237	1360	4170947	2013-06-17	2013-06-17 00:00:00	38000275	0	\N	\N	90274	0	274474001	4170947	
27342	2387	4151422	2012-08-30	2012-08-30 00:00:00	38000275	0	\N	\N	158781	0	269911007	4151422	
15548	1381	4024289	1982-02-12	1982-02-12 00:00:00	38000275	0	\N	\N	91563	0	19490002	4024289	
27708	2424	4202832	1997-06-06	1997-06-06 00:00:00	38000275	0	\N	\N	160819	0	52765003	4202832	
16014	1399	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	93000	0	180256009	4107731	
16167	1407	4107731	1990-10-06	1990-10-06 00:00:00	38000275	0	\N	\N	93529	0	180256009	4107731	
28329	2507	4024289	1996-11-16	1996-11-16 00:00:00	38000275	0	\N	\N	165954	0	19490002	4024289	
16634	1441	4107731	1991-03-18	1991-03-18 00:00:00	38000275	0	\N	\N	96064	0	180256009	4107731	
28627	2542	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	168204	0	180256009	4107731	
28864	2554	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	169244	0	180256009	4107731	
17066	1476	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	98342	0	180256009	4107731	
17344	1497	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	99876	0	180256009	4107731	
17472	1508	4043071	1937-07-05	1937-07-05 00:00:00	38000275	0	\N	\N	100643	0	228557008	4043071	
17701	1517	4043071	1946-06-10	1946-06-10 00:00:00	38000275	0	\N	\N	101449	0	228557008	4043071	
29753	2647	4107731	1992-11-22	1992-11-22 00:00:00	38000275	0	\N	\N	175193	0	180256009	4107731	
18056	1543	4252419	1957-03-25	1957-03-25 00:00:00	38000275	0	\N	\N	103422	0	74016001	4252419	
30163	2672	4275113	1970-10-24	1970-10-24 00:00:00	38000275	0	\N	\N	176910	0	65200003	4275113	
30311	2677	4043071	1985-08-23	1985-08-23 00:00:00	38000275	0	\N	\N	177413	0	228557008	4043071	
18568	1576	4238715	1989-04-08	1989-04-08 00:00:00	38000275	0	\N	\N	105806	0	68254000	4238715	
18807	1609	4197460	1959-07-29	1959-07-29 00:00:00	38000275	0	\N	\N	108160	0	313191000	4197460	
19053	1634	4125906	1981-07-16	1981-07-16 00:00:00	38000275	0	\N	\N	109689	0	288086009	4125906	
31136	2765	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	182945	0	180256009	4107731	
19351	1656	4295880	2011-03-12	2011-03-12 00:00:00	38000275	0	\N	\N	111133	0	76601001	4295880	
19633	1683	4125906	2006-11-18	2006-11-18 00:00:00	38000275	0	\N	\N	112771	0	288086009	4125906	
19800	1716	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	114772	0	180256009	4107731	
20009	1727	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	115416	0	180256009	4107731	
20128	1743	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	116529	0	180256009	4107731	
20228	1750	4125906	2010-10-29	2010-10-29 00:00:00	38000275	0	\N	\N	117016	0	288086009	4125906	
32469	2853	4125906	1980-05-23	1980-05-23 00:00:00	38000275	0	\N	\N	189580	0	288086009	4125906	
32595	2863	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	190427	0	180256009	4107731	
44705	3916	4107731	1993-09-01	1993-09-01 00:00:00	38000275	0	\N	\N	260406	0	180256009	4107731	
32926	2891	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	192366	0	180256009	4107731	
21202	1843	4107731	1997-05-28	1997-05-28 00:00:00	38000275	0	\N	\N	123038	0	180256009	4107731	
21414	1852	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	123994	0	180256009	4107731	
45478	4014	4107731	2000-07-11	2000-07-11 00:00:00	38000275	0	\N	\N	266704	0	180256009	4107731	
21727	1882	4107731	1991-01-19	1991-01-19 00:00:00	38000275	0	\N	\N	125595	0	180256009	4107731	
33894	2951	4058899	1986-04-07	1986-04-07 00:00:00	38000275	0	\N	\N	197009	0	168594001	4058899	
22225	1947	4170947	1976-04-07	1976-04-07 00:00:00	38000275	0	\N	\N	129466	0	274474001	4170947	
22304	1954	44783196	1960-05-14	1960-05-14 00:00:00	38000275	0	\N	\N	130030	0	699253003	44783196	
22540	1971	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	130990	0	180256009	4107731	
22787	1980	4125906	2005-04-04	2005-04-04 00:00:00	38000275	0	\N	\N	131807	0	288086009	4125906	
22996	1999	4107731	2012-07-04	2012-07-04 00:00:00	38000275	0	\N	\N	133117	0	180256009	4107731	
47029	4130	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	274631	0	180256009	4107731	
35172	3064	4043071	1951-03-22	1951-03-22 00:00:00	38000275	0	\N	\N	203978	0	228557008	4043071	
35378	3096	4125906	2015-02-22	2015-02-22 00:00:00	38000275	0	\N	\N	206079	0	288086009	4125906	
23712	2070	4107731	1991-11-04	1991-11-04 00:00:00	38000275	0	\N	\N	137670	0	180256009	4107731	
23853	2076	4151422	1988-03-17	1988-03-17 00:00:00	38000275	0	\N	\N	138200	0	269911007	4151422	
11995	1099	4107731	1992-08-29	1992-08-29 00:00:00	38000275	0	\N	\N	72203	0	180256009	4107731	
24160	2115	4024289	1989-12-16	1989-12-16 00:00:00	38000275	0	\N	\N	140704	0	19490002	4024289	
12463	1122	4024289	1972-08-03	1972-08-03 00:00:00	38000275	0	\N	\N	73928	0	19490002	4024289	
24554	2150	4170947	2003-10-19	2003-10-19 00:00:00	38000275	0	\N	\N	143152	0	274474001	4170947	
24785	2168	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	144532	0	180256009	4107731	
13047	1176	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	77694	0	180256009	4107731	
25091	2186	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	145778	0	180256009	4107731	
25283	2200	4043071	1983-12-11	1983-12-11 00:00:00	38000275	0	\N	\N	146620	0	228557008	4043071	
25489	2217	4295880	1999-05-25	1999-05-25 00:00:00	38000275	0	\N	\N	147687	0	76601001	4295880	
13756	1249	4170947	1984-09-27	1984-09-27 00:00:00	38000275	0	\N	\N	82291	0	274474001	4170947	
13938	1261	4107731	1990-05-12	1990-05-12 00:00:00	38000275	0	\N	\N	83171	0	180256009	4107731	
14138	1272	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	83873	0	180256009	4107731	
26223	2287	4216130	2001-01-26	2001-01-26 00:00:00	38000275	0	\N	\N	152152	0	415070008	4216130	
14486	1293	4024289	1945-10-25	1945-10-25 00:00:00	38000275	0	\N	\N	85596	0	19490002	4024289	
26640	2333	42535580	1978-05-19	1978-05-19 00:00:00	38000275	0	\N	\N	155162	0	426701000119108	42535580	
14875	1320	4195803	1993-08-09	1993-08-09 00:00:00	38000275	0	\N	\N	87476	0	312681000	4195803	
15143	1356	4107731	1995-08-31	1995-08-31 00:00:00	38000275	0	\N	\N	89879	0	180256009	4107731	
15238	1360	4243062	2013-06-17	2013-06-17 00:00:00	38000275	0	\N	\N	90274	0	60027007	4243062	
27343	2387	4186930	1991-02-09	1991-02-09 00:00:00	38000275	0	\N	\N	158782	0	46706006	4186930	
15549	1381	4151422	2009-08-14	2009-08-14 00:00:00	38000275	0	\N	\N	91586	0	269911007	4151422	
27709	2425	4243062	1968-04-27	1968-04-27 00:00:00	38000275	0	\N	\N	160872	0	60027007	4243062	
16015	1399	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	93086	0	180256009	4107731	
16168	1407	4107731	1993-04-17	1993-04-17 00:00:00	38000275	0	\N	\N	93470	0	180256009	4107731	
28330	2507	4170947	1996-11-16	1996-11-16 00:00:00	38000275	0	\N	\N	165954	0	274474001	4170947	
16635	1441	4107731	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	95967	0	180256009	4107731	
28628	2542	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	168196	0	180256009	4107731	
28865	2554	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	169136	0	180256009	4107731	
17067	1476	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	98377	0	180256009	4107731	
17345	1497	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	99882	0	180256009	4107731	
17473	1508	4125906	1943-01-12	1943-01-12 00:00:00	38000275	0	\N	\N	100545	0	288086009	4125906	
17702	1517	4043071	1947-07-07	1947-07-07 00:00:00	38000275	0	\N	\N	101453	0	228557008	4043071	
29754	2647	4107731	1992-11-01	1992-11-01 00:00:00	38000275	0	\N	\N	175201	0	180256009	4107731	
18057	1543	4043071	1951-05-16	1951-05-16 00:00:00	38000275	0	\N	\N	103372	0	228557008	4043071	
30164	2672	4107731	1990-10-28	1990-10-28 00:00:00	38000275	0	\N	\N	177020	0	180256009	4107731	
30312	2677	4043071	1985-10-25	1985-10-25 00:00:00	38000275	0	\N	\N	177421	0	228557008	4043071	
18569	1576	4058899	1983-12-17	1983-12-17 00:00:00	38000275	0	\N	\N	105775	0	168594001	4058899	
18808	1609	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	108102	0	180256009	4107731	
19054	1634	4151422	1992-01-13	1992-01-13 00:00:00	38000275	0	\N	\N	109741	0	269911007	4151422	
31137	2765	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	182869	0	180256009	4107731	
19352	1656	4295880	2012-12-08	2012-12-08 00:00:00	38000275	0	\N	\N	111142	0	76601001	4295880	
19634	1683	4293740	2006-11-18	2006-11-18 00:00:00	38000275	0	\N	\N	112771	0	384700001	4293740	
19801	1716	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	114763	0	180256009	4107731	
31815	2798	4163872	1973-03-21	1973-03-21 00:00:00	38000275	0	\N	\N	185459	0	399208008	4163872	
20129	1743	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	116492	0	180256009	4107731	
20229	1751	4125906	2004-03-18	2004-03-18 00:00:00	38000275	0	\N	\N	117081	0	288086009	4125906	
32470	2853	4151422	1988-06-02	1988-06-02 00:00:00	38000275	0	\N	\N	189512	0	269911007	4151422	
32596	2863	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	190436	0	180256009	4107731	
44706	3916	4107731	1992-10-21	1992-10-21 00:00:00	38000275	0	\N	\N	260402	0	180256009	4107731	
32927	2891	4151422	1974-10-20	1974-10-20 00:00:00	38000275	0	\N	\N	192343	0	269911007	4151422	
21203	1843	4107731	1996-10-30	1996-10-30 00:00:00	38000275	0	\N	\N	123116	0	180256009	4107731	
21415	1852	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	123966	0	180256009	4107731	
45479	4014	4107731	1998-09-29	1998-09-29 00:00:00	38000275	0	\N	\N	266788	0	180256009	4107731	
21728	1882	4107731	1992-12-12	1992-12-12 00:00:00	38000275	0	\N	\N	125577	0	180256009	4107731	
33895	2951	4024289	1963-10-21	1963-10-21 00:00:00	38000275	0	\N	\N	197007	0	19490002	4024289	
22226	1947	4195803	2009-06-21	2009-06-21 00:00:00	38000275	0	\N	\N	129400	0	312681000	4195803	
22305	1954	4125906	1952-12-01	1952-12-01 00:00:00	38000275	0	\N	\N	130034	0	288086009	4125906	
22541	1971	4163872	1997-09-06	1997-09-06 00:00:00	38000275	0	\N	\N	131112	0	399208008	4163872	
22788	1980	4107731	1991-02-10	1991-02-10 00:00:00	38000275	0	\N	\N	131817	0	180256009	4107731	
22997	1999	4107731	2014-08-20	2014-08-20 00:00:00	38000275	0	\N	\N	133126	0	180256009	4107731	
47030	4130	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	274560	0	180256009	4107731	
35173	3064	4043071	1951-02-15	1951-02-15 00:00:00	38000275	0	\N	\N	203951	0	228557008	4043071	
35379	3096	4078793	2018-07-29	2018-07-29 00:00:00	38000275	0	\N	\N	206076	0	180325003	4078793	
23713	2070	4107731	1992-11-16	1992-11-16 00:00:00	38000275	0	\N	\N	137716	0	180256009	4107731	
23854	2076	4058899	1976-11-27	1976-11-27 00:00:00	38000275	0	\N	\N	138210	0	168594001	4058899	
11996	1099	4107731	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	72246	0	180256009	4107731	
24161	2115	4151422	2016-09-21	2016-09-21 00:00:00	38000275	0	\N	\N	140711	0	269911007	4151422	
12464	1122	4243062	1992-07-24	1992-07-24 00:00:00	38000275	0	\N	\N	73965	0	60027007	4243062	
24555	2150	4163872	2003-10-19	2003-10-19 00:00:00	38000275	0	\N	\N	143152	0	399208008	4163872	
24786	2168	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	144467	0	180256009	4107731	
13048	1176	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	77595	0	180256009	4107731	
25092	2186	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	145776	0	180256009	4107731	
25284	2200	4043071	1982-10-31	1982-10-31 00:00:00	38000275	0	\N	\N	146650	0	228557008	4043071	
25490	2217	4295880	2003-02-21	2003-02-21 00:00:00	38000275	0	\N	\N	147665	0	76601001	4295880	
13757	1249	4163872	1973-05-29	1973-05-29 00:00:00	38000275	0	\N	\N	82253	0	399208008	4163872	
13939	1261	4107731	1990-06-02	1990-06-02 00:00:00	38000275	0	\N	\N	83208	0	180256009	4107731	
14139	1272	4107731	1995-02-17	1995-02-17 00:00:00	38000275	0	\N	\N	83887	0	180256009	4107731	
26224	2287	4336464	2001-01-26	2001-01-26 00:00:00	38000275	0	\N	\N	152152	0	232717009	4336464	
14487	1293	4062501	1942-01-01	1942-01-01 00:00:00	38000275	0	\N	\N	85477	0	171231001	4062501	
26641	2333	4125906	1998-10-30	1998-10-30 00:00:00	38000275	0	\N	\N	155165	0	288086009	4125906	
14876	1320	4243062	1993-08-09	1993-08-09 00:00:00	38000275	0	\N	\N	87476	0	60027007	4243062	
15144	1356	4107731	1996-05-09	1996-05-09 00:00:00	38000275	0	\N	\N	89935	0	180256009	4107731	
15239	1361	4125906	1987-06-22	1987-06-22 00:00:00	38000275	0	\N	\N	90291	0	288086009	4125906	
27344	2387	4238715	1992-05-09	1992-05-09 00:00:00	38000275	0	\N	\N	158766	0	68254000	4238715	
15550	1382	4125906	2019-05-17	2019-05-17 00:00:00	38000275	0	\N	\N	91653	0	288086009	4125906	
27710	2425	4170947	1968-04-27	1968-04-27 00:00:00	38000275	0	\N	\N	160872	0	274474001	4170947	
16016	1399	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	93035	0	180256009	4107731	
16169	1407	4107731	1992-01-11	1992-01-11 00:00:00	38000275	0	\N	\N	93589	0	180256009	4107731	
28331	2507	4125906	2017-07-20	2017-07-20 00:00:00	38000275	0	\N	\N	165956	0	288086009	4125906	
16636	1441	4107731	1991-07-22	1991-07-22 00:00:00	38000275	0	\N	\N	96087	0	180256009	4107731	
28629	2542	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	168176	0	180256009	4107731	
28866	2554	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	169268	0	395142003	4191853	
17068	1476	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	98402	0	180256009	4107731	
17346	1497	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	99799	0	180256009	4107731	
17474	1508	4163872	1949-02-23	1949-02-23 00:00:00	38000275	0	\N	\N	100546	0	399208008	4163872	
17703	1517	4043071	1947-04-28	1947-04-28 00:00:00	38000275	0	\N	\N	101425	0	228557008	4043071	
29755	2647	4107731	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	175191	0	180256009	4107731	
18058	1543	4043071	1951-10-17	1951-10-17 00:00:00	38000275	0	\N	\N	103374	0	228557008	4043071	
30165	2672	4107731	1990-04-22	1990-04-22 00:00:00	38000275	0	\N	\N	177039	0	180256009	4107731	
30313	2677	4043071	1987-03-12	1987-03-12 00:00:00	38000275	0	\N	\N	177428	0	228557008	4043071	
18570	1576	4186930	1986-10-04	1986-10-04 00:00:00	38000275	0	\N	\N	105796	0	46706006	4186930	
18809	1609	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	108096	0	180256009	4107731	
19055	1634	4202451	2009-07-03	2009-07-03 00:00:00	38000275	0	\N	\N	109765	0	433112001	4202451	
31138	2765	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	182984	0	180256009	4107731	
19353	1656	4295880	2012-03-10	2012-03-10 00:00:00	38000275	0	\N	\N	111141	0	76601001	4295880	
19635	1683	4117038	1997-05-23	1997-05-23 00:00:00	38000275	0	\N	\N	112766	0	287664005	4117038	
19802	1716	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	114737	0	180256009	4107731	
31816	2798	4243062	1958-04-18	1958-04-18 00:00:00	38000275	0	\N	\N	185428	0	60027007	4243062	
20130	1743	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	116587	0	180256009	4107731	
20230	1751	4243062	1987-05-28	1987-05-28 00:00:00	38000275	0	\N	\N	117078	0	60027007	4243062	
32472	2857	4125906	1979-12-02	1979-12-02 00:00:00	38000275	0	\N	\N	189670	0	288086009	4125906	
32597	2863	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	190431	0	180256009	4107731	
44707	3916	4107731	1994-08-24	1994-08-24 00:00:00	38000275	0	\N	\N	260330	0	180256009	4107731	
32928	2891	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	192379	0	180256009	4107731	
21204	1843	4191853	1982-09-26	1982-09-26 00:00:00	38000275	0	\N	\N	123101	0	395142003	4191853	
21416	1852	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	123898	0	180256009	4107731	
45480	4014	4107731	2000-10-03	2000-10-03 00:00:00	38000275	0	\N	\N	266747	0	180256009	4107731	
21729	1882	4107731	1991-04-13	1991-04-13 00:00:00	38000275	0	\N	\N	125597	0	180256009	4107731	
33896	2951	4170947	1963-10-21	1963-10-21 00:00:00	38000275	0	\N	\N	197007	0	274474001	4170947	
22227	1947	4293740	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	129468	0	384700001	4293740	
22306	1954	4024289	1949-12-17	1949-12-17 00:00:00	38000275	0	\N	\N	130033	0	19490002	4024289	
22542	1971	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	131102	0	180256009	4107731	
22789	1980	4107731	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	131779	0	180256009	4107731	
22998	1999	4107731	2014-09-10	2014-09-10 00:00:00	38000275	0	\N	\N	133152	0	180256009	4107731	
47031	4130	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	274557	0	180256009	4107731	
35174	3064	4125906	1990-07-01	1990-07-01 00:00:00	38000275	0	\N	\N	204001	0	288086009	4125906	
35380	3096	4170947	1968-09-26	1968-09-26 00:00:00	38000275	0	\N	\N	206036	0	274474001	4170947	
23714	2070	4107731	1992-12-07	1992-12-07 00:00:00	38000275	0	\N	\N	137761	0	180256009	4107731	
23855	2077	4107731	1992-06-21	1992-06-21 00:00:00	38000275	0	\N	\N	138251	0	180256009	4107731	
11997	1099	4107731	1991-07-06	1991-07-06 00:00:00	38000275	0	\N	\N	72227	0	180256009	4107731	
24162	2115	4252419	2004-08-29	2004-08-29 00:00:00	38000275	0	\N	\N	140705	0	74016001	4252419	
12465	1122	4170947	1992-07-24	1992-07-24 00:00:00	38000275	0	\N	\N	73965	0	274474001	4170947	
24556	2150	4195803	2005-11-07	2005-11-07 00:00:00	38000275	0	\N	\N	143153	0	312681000	4195803	
24787	2168	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	144541	0	180256009	4107731	
13049	1176	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	77620	0	180256009	4107731	
25093	2186	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	145805	0	180256009	4107731	
25285	2200	4043071	1981-07-12	1981-07-12 00:00:00	38000275	0	\N	\N	146646	0	228557008	4043071	
25491	2217	4295880	2000-05-26	2000-05-26 00:00:00	38000275	0	\N	\N	147684	0	76601001	4295880	
13758	1250	4058899	1955-03-13	1955-03-13 00:00:00	38000275	0	\N	\N	82333	0	168594001	4058899	
13940	1261	4107731	1990-07-14	1990-07-14 00:00:00	38000275	0	\N	\N	83209	0	180256009	4107731	
14140	1272	4107731	1996-02-09	1996-02-09 00:00:00	38000275	0	\N	\N	83927	0	180256009	4107731	
26225	2287	4057420	2011-07-01	2011-07-01 00:00:00	38000275	0	\N	\N	152191	0	18286008	4057420	
14488	1293	4195803	2016-09-12	2016-09-12 00:00:00	38000275	0	\N	\N	85594	0	312681000	4195803	
26642	2333	4078793	2006-07-18	2006-07-18 00:00:00	38000275	0	\N	\N	155146	0	180325003	4078793	
14877	1320	4170947	1993-08-09	1993-08-09 00:00:00	38000275	0	\N	\N	87476	0	274474001	4170947	
15145	1356	4107731	1998-06-25	1998-06-25 00:00:00	38000275	0	\N	\N	89903	0	180256009	4107731	
15240	1361	4195803	1999-10-31	1999-10-31 00:00:00	38000275	0	\N	\N	90292	0	312681000	4195803	
27345	2387	4125906	2002-10-27	2002-10-27 00:00:00	38000275	0	\N	\N	158759	0	288086009	4125906	
15551	1382	4163872	1994-08-26	1994-08-26 00:00:00	38000275	0	\N	\N	91652	0	399208008	4163872	
27711	2425	4170947	1966-01-08	1966-01-08 00:00:00	38000275	0	\N	\N	160871	0	274474001	4170947	
16017	1399	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	93124	0	180256009	4107731	
16170	1407	4191853	1990-01-06	1990-01-06 00:00:00	38000275	0	\N	\N	93526	0	395142003	4191853	
28332	2507	4163872	2009-03-11	2009-03-11 00:00:00	38000275	0	\N	\N	165966	0	399208008	4163872	
16637	1441	4107731	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	96089	0	180256009	4107731	
28630	2542	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	168174	0	180256009	4107731	
28867	2554	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	169160	0	180256009	4107731	
17069	1476	4057420	2005-12-08	2005-12-08 00:00:00	38000275	0	\N	\N	98474	0	18286008	4057420	
17347	1497	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	99823	0	180256009	4107731	
17475	1508	4170947	1949-02-23	1949-02-23 00:00:00	38000275	0	\N	\N	100546	0	274474001	4170947	
17704	1517	4043071	1946-12-16	1946-12-16 00:00:00	38000275	0	\N	\N	101414	0	228557008	4043071	
29756	2647	4107731	1991-09-29	1991-09-29 00:00:00	38000275	0	\N	\N	175151	0	180256009	4107731	
18059	1543	4043071	1950-11-22	1950-11-22 00:00:00	38000275	0	\N	\N	103415	0	228557008	4043071	
30166	2672	4238715	1971-11-07	1971-11-07 00:00:00	38000275	0	\N	\N	176911	0	68254000	4238715	
30315	2679	4047491	1976-12-05	1976-12-05 00:00:00	38000275	0	\N	\N	177460	0	1225002	4047491	
18571	1577	4145310	2017-01-20	2017-01-20 00:00:00	38000275	0	\N	\N	105934	0	268425006	4145310	
18810	1609	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	108201	0	180256009	4107731	
19056	1634	4125906	2017-09-10	2017-09-10 00:00:00	38000275	0	\N	\N	109692	0	288086009	4125906	
31139	2765	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	182868	0	180256009	4107731	
19354	1656	4295880	2013-12-07	2013-12-07 00:00:00	38000275	0	\N	\N	111073	0	76601001	4295880	
31417	2776	4107731	2008-03-18	2008-03-18 00:00:00	38000275	0	\N	\N	183846	0	180256009	4107731	
19803	1716	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	114683	0	180256009	4107731	
31817	2798	4170947	1958-04-18	1958-04-18 00:00:00	38000275	0	\N	\N	185428	0	274474001	4170947	
20131	1743	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	116490	0	180256009	4107731	
20231	1751	4170947	1987-05-28	1987-05-28 00:00:00	38000275	0	\N	\N	117078	0	274474001	4170947	
32473	2857	4293740	1979-12-02	1979-12-02 00:00:00	38000275	0	\N	\N	189670	0	384700001	4293740	
32598	2863	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	190324	0	180256009	4107731	
44708	3916	4107731	1994-02-16	1994-02-16 00:00:00	38000275	0	\N	\N	260422	0	180256009	4107731	
32929	2891	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	192350	0	180256009	4107731	
21205	1843	4107731	1996-04-24	1996-04-24 00:00:00	38000275	0	\N	\N	123051	0	180256009	4107731	
21417	1852	4010253	2011-12-29	2011-12-29 00:00:00	38000275	0	\N	\N	123906	0	112790001	4010253	
45481	4014	4107731	2000-01-04	2000-01-04 00:00:00	38000275	0	\N	\N	266744	0	180256009	4107731	
21802	1889	4125906	2009-04-14	2009-04-14 00:00:00	38000275	0	\N	\N	125916	0	288086009	4125906	
33897	2951	4125906	1983-08-07	1983-08-07 00:00:00	38000275	0	\N	\N	197008	0	288086009	4125906	
22228	1947	4125906	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	129468	0	288086009	4125906	
22307	1954	4170947	1949-12-17	1949-12-17 00:00:00	38000275	0	\N	\N	130033	0	274474001	4170947	
22543	1971	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	131024	0	180256009	4107731	
22790	1980	4107731	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	131853	0	180256009	4107731	
22999	1999	4107731	2013-12-11	2013-12-11 00:00:00	38000275	0	\N	\N	133149	0	180256009	4107731	
47032	4130	4078793	2019-05-30	2019-05-30 00:00:00	38000275	0	\N	\N	274617	0	180325003	4078793	
35175	3064	4043071	1949-11-24	1949-11-24 00:00:00	38000275	0	\N	\N	203953	0	228557008	4043071	
35381	3096	4047491	1968-09-26	1968-09-26 00:00:00	38000275	0	\N	\N	206036	0	1225002	4047491	
23715	2070	4107731	1990-08-20	1990-08-20 00:00:00	38000275	0	\N	\N	137657	0	180256009	4107731	
23856	2077	4125906	1962-08-21	1962-08-21 00:00:00	38000275	0	\N	\N	138213	0	288086009	4125906	
11998	1099	4107731	1991-12-21	1991-12-21 00:00:00	38000275	0	\N	\N	72180	0	180256009	4107731	
24163	2116	4151422	1972-07-04	1972-07-04 00:00:00	38000275	0	\N	\N	140803	0	269911007	4151422	
12466	1122	4062501	1973-11-23	1973-11-23 00:00:00	38000275	0	\N	\N	73931	0	171231001	4062501	
24557	2150	4170947	2005-11-07	2005-11-07 00:00:00	38000275	0	\N	\N	143153	0	274474001	4170947	
24788	2168	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	144558	0	180256009	4107731	
13050	1176	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	77693	0	180256009	4107731	
25094	2186	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	145761	0	180256009	4107731	
25286	2200	4043071	1982-04-25	1982-04-25 00:00:00	38000275	0	\N	\N	146633	0	228557008	4043071	
25492	2217	4295880	2001-05-25	2001-05-25 00:00:00	38000275	0	\N	\N	147674	0	76601001	4295880	
13764	1253	4170947	1975-08-05	1975-08-05 00:00:00	38000275	0	\N	\N	82550	0	274474001	4170947	
13941	1261	4107731	1992-10-10	1992-10-10 00:00:00	38000275	0	\N	\N	83169	0	180256009	4107731	
14141	1272	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	83867	0	180256009	4107731	
26226	2289	4170947	1964-11-24	1964-11-24 00:00:00	38000275	0	\N	\N	152250	0	274474001	4170947	
14489	1293	4047491	2016-09-12	2016-09-12 00:00:00	38000275	0	\N	\N	85594	0	1225002	4047491	
26643	2333	4078793	1991-04-23	1991-04-23 00:00:00	38000275	0	\N	\N	155141	0	180325003	4078793	
14878	1320	4195803	1995-06-15	1995-06-15 00:00:00	38000275	0	\N	\N	87506	0	312681000	4195803	
15146	1356	4107731	1996-04-18	1996-04-18 00:00:00	38000275	0	\N	\N	89964	0	180256009	4107731	
15241	1361	4058899	1999-10-31	1999-10-31 00:00:00	38000275	0	\N	\N	90292	0	168594001	4058899	
27349	2389	4145310	1975-12-17	1975-12-17 00:00:00	38000275	0	\N	\N	158841	0	268425006	4145310	
15552	1382	4170947	1994-08-26	1994-08-26 00:00:00	38000275	0	\N	\N	91652	0	274474001	4170947	
27712	2425	4024289	1966-01-08	1966-01-08 00:00:00	38000275	0	\N	\N	160871	0	19490002	4024289	
16018	1399	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	93060	0	180256009	4107731	
16171	1407	4107731	1990-03-10	1990-03-10 00:00:00	38000275	0	\N	\N	93538	0	180256009	4107731	
28333	2507	4010253	2006-04-21	2006-04-21 00:00:00	38000275	0	\N	\N	165933	0	112790001	4010253	
16638	1441	4107731	1991-11-04	1991-11-04 00:00:00	38000275	0	\N	\N	96066	0	180256009	4107731	
28631	2542	4170947	1974-12-29	1974-12-29 00:00:00	38000275	0	\N	\N	168089	0	274474001	4170947	
28868	2554	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	169228	0	180256009	4107731	
17070	1476	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	98360	0	180256009	4107731	
17348	1497	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	99825	0	180256009	4107731	
17476	1508	4043071	1937-10-11	1937-10-11 00:00:00	38000275	0	\N	\N	100635	0	228557008	4043071	
17705	1517	4078793	2019-04-29	2019-04-29 00:00:00	38000275	0	\N	\N	101406	0	180325003	4078793	
29757	2647	4107731	1990-09-16	1990-09-16 00:00:00	38000275	0	\N	\N	175106	0	180256009	4107731	
18060	1543	4043071	1951-03-07	1951-03-07 00:00:00	38000275	0	\N	\N	103427	0	228557008	4043071	
30167	2672	4107731	1992-02-23	1992-02-23 00:00:00	38000275	0	\N	\N	176955	0	180256009	4107731	
30316	2679	4170947	1976-12-05	1976-12-05 00:00:00	38000275	0	\N	\N	177460	0	274474001	4170947	
18572	1577	4125906	2013-12-16	2013-12-16 00:00:00	38000275	0	\N	\N	105933	0	288086009	4125906	
18811	1609	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	108094	0	180256009	4107731	
19057	1634	4202451	2016-03-11	2016-03-11 00:00:00	38000275	0	\N	\N	109691	0	433112001	4202451	
31140	2765	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	182843	0	180256009	4107731	
19355	1656	4295880	2009-03-14	2009-03-14 00:00:00	38000275	0	\N	\N	111160	0	76601001	4295880	
31418	2776	4107731	2005-10-18	2005-10-18 00:00:00	38000275	0	\N	\N	183778	0	180256009	4107731	
19804	1716	4252419	2009-06-24	2009-06-24 00:00:00	38000275	0	\N	\N	114708	0	74016001	4252419	
31818	2798	4151422	1988-04-21	1988-04-21 00:00:00	38000275	0	\N	\N	185461	0	269911007	4151422	
20132	1743	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	116574	0	180256009	4107731	
20232	1753	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	117297	0	180256009	4107731	
32474	2857	4243062	1980-10-12	1980-10-12 00:00:00	38000275	0	\N	\N	189671	0	60027007	4243062	
32599	2863	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	190444	0	180256009	4107731	
44709	3916	4191853	1991-10-09	1991-10-09 00:00:00	38000275	0	\N	\N	260266	0	395142003	4191853	
32930	2891	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	192287	0	180256009	4107731	
21206	1843	4107731	1997-07-30	1997-07-30 00:00:00	38000275	0	\N	\N	123119	0	180256009	4107731	
21418	1852	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	123985	0	180256009	4107731	
45482	4014	4107731	1998-03-03	1998-03-03 00:00:00	38000275	0	\N	\N	266732	0	180256009	4107731	
21803	1889	4125906	2015-10-31	2015-10-31 00:00:00	38000275	0	\N	\N	125917	0	288086009	4125906	
33898	2953	4024289	1984-11-01	1984-11-01 00:00:00	38000275	0	\N	\N	197111	0	19490002	4024289	
22229	1947	4151422	1986-12-20	1986-12-20 00:00:00	38000275	0	\N	\N	129435	0	269911007	4151422	
22308	1954	4125906	1981-05-29	1981-05-29 00:00:00	38000275	0	\N	\N	130038	0	288086009	4125906	
22544	1971	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	131069	0	180256009	4107731	
22791	1980	4107731	1991-09-08	1991-09-08 00:00:00	38000275	0	\N	\N	131788	0	180256009	4107731	
23000	1999	4107731	2012-05-23	2012-05-23 00:00:00	38000275	0	\N	\N	133116	0	180256009	4107731	
47033	4130	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	274542	0	180256009	4107731	
35176	3064	4043071	1950-08-10	1950-08-10 00:00:00	38000275	0	\N	\N	203961	0	228557008	4043071	
35382	3096	4057420	2015-10-18	2015-10-18 00:00:00	38000275	0	\N	\N	206074	0	18286008	4057420	
23716	2070	4107731	1992-09-14	1992-09-14 00:00:00	38000275	0	\N	\N	137674	0	180256009	4107731	
23857	2077	4202451	1981-08-23	1981-08-23 00:00:00	38000275	0	\N	\N	138312	0	433112001	4202451	
11999	1099	4107731	1992-02-22	1992-02-22 00:00:00	38000275	0	\N	\N	72229	0	180256009	4107731	
24164	2116	4125906	2006-10-25	2006-10-25 00:00:00	38000275	0	\N	\N	140840	0	288086009	4125906	
12467	1122	4125906	1991-09-07	1991-09-07 00:00:00	38000275	0	\N	\N	73964	0	288086009	4125906	
24558	2150	4243062	2005-11-07	2005-11-07 00:00:00	38000275	0	\N	\N	143153	0	60027007	4243062	
24789	2168	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	144572	0	180256009	4107731	
13051	1176	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	77654	0	180256009	4107731	
25095	2186	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	145823	0	180256009	4107731	
25287	2200	4043071	1983-07-03	1983-07-03 00:00:00	38000275	0	\N	\N	146662	0	228557008	4043071	
25493	2217	4295880	2003-05-23	2003-05-23 00:00:00	38000275	0	\N	\N	147693	0	76601001	4295880	
13765	1253	4024289	1975-08-05	1975-08-05 00:00:00	38000275	0	\N	\N	82550	0	19490002	4024289	
13942	1261	4107731	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	83199	0	180256009	4107731	
14142	1272	4107731	1994-10-14	1994-10-14 00:00:00	38000275	0	\N	\N	83963	0	180256009	4107731	
26227	2289	4024289	1964-11-24	1964-11-24 00:00:00	38000275	0	\N	\N	152250	0	19490002	4024289	
14490	1293	4170947	2016-09-12	2016-09-12 00:00:00	38000275	0	\N	\N	85594	0	274474001	4170947	
26644	2333	4125906	1999-10-16	1999-10-16 00:00:00	38000275	0	\N	\N	155166	0	288086009	4125906	
14879	1321	4275113	1974-06-27	1974-06-27 00:00:00	38000275	0	\N	\N	87606	0	65200003	4275113	
15147	1356	4107731	1998-06-04	1998-06-04 00:00:00	38000275	0	\N	\N	89866	0	180256009	4107731	
15242	1361	4024289	1955-01-13	1955-01-13 00:00:00	38000275	0	\N	\N	90289	0	19490002	4024289	
27350	2389	4125906	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	158842	0	288086009	4125906	
15570	1384	4252419	1994-01-12	1994-01-12 00:00:00	38000275	0	\N	\N	91725	0	74016001	4252419	
27714	2427	4170947	2008-12-20	2008-12-20 00:00:00	38000275	0	\N	\N	160964	0	274474001	4170947	
16019	1399	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	93024	0	180256009	4107731	
16172	1407	4107731	1992-04-04	1992-04-04 00:00:00	38000275	0	\N	\N	93567	0	180256009	4107731	
28336	2509	4058899	1975-11-04	1975-11-04 00:00:00	38000275	0	\N	\N	166089	0	168594001	4058899	
16639	1441	4107731	1991-04-08	1991-04-08 00:00:00	38000275	0	\N	\N	95966	0	180256009	4107731	
28632	2542	4024289	1974-12-29	1974-12-29 00:00:00	38000275	0	\N	\N	168089	0	19490002	4024289	
28869	2554	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	169242	0	180256009	4107731	
17071	1476	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	98401	0	180256009	4107731	
17349	1497	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	99891	0	180256009	4107731	
17477	1508	4202451	1982-11-23	1982-11-23 00:00:00	38000275	0	\N	\N	100651	0	433112001	4202451	
17706	1517	4043071	1947-08-04	1947-08-04 00:00:00	38000275	0	\N	\N	101416	0	228557008	4043071	
29758	2647	4107731	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	175130	0	180256009	4107731	
18061	1543	4043071	1950-12-27	1950-12-27 00:00:00	38000275	0	\N	\N	103416	0	228557008	4043071	
30168	2672	4107731	1992-06-07	1992-06-07 00:00:00	38000275	0	\N	\N	176918	0	180256009	4107731	
30317	2679	4125906	2009-12-13	2009-12-13 00:00:00	38000275	0	\N	\N	177491	0	288086009	4125906	
18573	1577	4195803	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	105930	0	312681000	4195803	
18812	1609	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	108207	0	180256009	4107731	
19058	1634	4078793	2017-09-15	2017-09-15 00:00:00	38000275	0	\N	\N	109698	0	180325003	4078793	
31141	2765	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	182983	0	180256009	4107731	
19356	1656	4295880	2005-12-17	2005-12-17 00:00:00	38000275	0	\N	\N	111123	0	76601001	4295880	
31419	2776	4107731	2007-10-02	2007-10-02 00:00:00	38000275	0	\N	\N	183879	0	180256009	4107731	
19805	1716	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	114616	0	180256009	4107731	
31819	2798	4125906	1977-05-25	1977-05-25 00:00:00	38000275	0	\N	\N	185432	0	288086009	4125906	
20133	1743	4170947	1999-09-08	1999-09-08 00:00:00	38000275	0	\N	\N	116509	0	274474001	4170947	
20233	1753	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	117190	0	180256009	4107731	
32475	2857	4170947	1980-10-12	1980-10-12 00:00:00	38000275	0	\N	\N	189671	0	274474001	4170947	
32600	2863	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	190450	0	180256009	4107731	
44710	3916	4295880	1992-09-30	1992-09-30 00:00:00	38000275	0	\N	\N	260389	0	76601001	4295880	
32931	2891	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	192371	0	180256009	4107731	
21207	1843	4199276	2012-10-24	2012-10-24 00:00:00	38000275	0	\N	\N	122998	0	301807007	4199276	
21419	1852	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	123913	0	180256009	4107731	
45483	4014	4107731	2000-10-24	2000-10-24 00:00:00	38000275	0	\N	\N	266723	0	180256009	4107731	
21804	1889	4125906	1994-06-18	1994-06-18 00:00:00	38000275	0	\N	\N	125915	0	288086009	4125906	
33899	2953	4170947	1984-11-01	1984-11-01 00:00:00	38000275	0	\N	\N	197111	0	274474001	4170947	
34035	2965	4107731	1993-02-08	1993-02-08 00:00:00	38000275	0	\N	\N	197972	0	180256009	4107731	
22309	1954	4252419	1960-05-07	1960-05-07 00:00:00	38000275	0	\N	\N	130035	0	74016001	4252419	
22545	1971	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	131076	0	180256009	4107731	
22792	1980	4107731	1992-02-02	1992-02-02 00:00:00	38000275	0	\N	\N	131881	0	180256009	4107731	
23001	1999	4107731	2012-02-08	2012-02-08 00:00:00	38000275	0	\N	\N	133086	0	180256009	4107731	
47034	4130	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	274588	0	180256009	4107731	
35177	3064	4043071	1950-09-14	1950-09-14 00:00:00	38000275	0	\N	\N	203948	0	228557008	4043071	
35383	3096	4078793	2014-10-12	2014-10-12 00:00:00	38000275	0	\N	\N	206057	0	180325003	4078793	
23717	2070	4107731	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	137711	0	180256009	4107731	
23858	2077	4107731	1992-08-02	1992-08-02 00:00:00	38000275	0	\N	\N	138222	0	180256009	4107731	
12000	1099	4107731	1993-01-23	1993-01-23 00:00:00	38000275	0	\N	\N	72123	0	180256009	4107731	
24165	2116	4195803	2015-09-27	2015-09-27 00:00:00	38000275	0	\N	\N	140842	0	312681000	4195803	
12468	1123	4293740	2015-02-25	2015-02-25 00:00:00	38000275	0	\N	\N	73969	0	384700001	4293740	
24559	2150	4125906	1965-12-18	1965-12-18 00:00:00	38000275	0	\N	\N	143150	0	288086009	4125906	
24790	2168	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	144518	0	180256009	4107731	
13052	1176	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	77674	0	180256009	4107731	
25096	2186	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	145779	0	180256009	4107731	
25288	2200	4043071	1981-10-18	1981-10-18 00:00:00	38000275	0	\N	\N	146706	0	228557008	4043071	
25494	2217	4295880	2002-02-22	2002-02-22 00:00:00	38000275	0	\N	\N	147685	0	76601001	4295880	
13766	1253	4151422	2000-03-22	2000-03-22 00:00:00	38000275	0	\N	\N	82516	0	269911007	4151422	
13943	1261	4107731	1993-01-23	1993-01-23 00:00:00	38000275	0	\N	\N	83140	0	180256009	4107731	
14143	1272	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	83868	0	180256009	4107731	
26228	2289	4181917	1959-03-19	1959-03-19 00:00:00	38000275	0	\N	\N	152248	0	54550000	4181917	
14491	1293	4047491	1970-03-18	1970-03-18 00:00:00	38000275	0	\N	\N	85602	0	1225002	4047491	
26645	2333	4078793	1994-05-10	1994-05-10 00:00:00	38000275	0	\N	\N	155233	0	180325003	4078793	
14880	1321	4238715	1976-06-10	1976-06-10 00:00:00	38000275	0	\N	\N	87676	0	68254000	4238715	
26929	2352	4107731	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	156590	0	180256009	4107731	
15243	1361	4170947	1955-01-13	1955-01-13 00:00:00	38000275	0	\N	\N	90289	0	274474001	4170947	
27358	2392	4035793	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	159060	0	15081005	4035793	
15571	1384	4295880	2001-11-20	2001-11-20 00:00:00	38000275	0	\N	\N	91754	0	76601001	4295880	
27715	2427	4195803	2008-12-20	2008-12-20 00:00:00	38000275	0	\N	\N	160964	0	312681000	4195803	
16020	1399	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	93094	0	180256009	4107731	
16173	1407	4107731	1990-05-12	1990-05-12 00:00:00	38000275	0	\N	\N	93575	0	180256009	4107731	
28337	2509	4195803	1975-11-04	1975-11-04 00:00:00	38000275	0	\N	\N	166089	0	312681000	4195803	
16640	1441	4107731	1991-04-29	1991-04-29 00:00:00	38000275	0	\N	\N	96065	0	180256009	4107731	
28633	2542	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	168207	0	180256009	4107731	
28870	2554	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	169245	0	180256009	4107731	
17072	1476	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	98335	0	180256009	4107731	
17350	1497	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	99877	0	180256009	4107731	
17478	1508	4043071	1937-02-01	1937-02-01 00:00:00	38000275	0	\N	\N	100642	0	228557008	4043071	
17707	1517	4043071	1945-02-26	1945-02-26 00:00:00	38000275	0	\N	\N	101372	0	228557008	4043071	
29759	2647	4107731	1991-07-07	1991-07-07 00:00:00	38000275	0	\N	\N	175188	0	180256009	4107731	
18062	1543	4043071	1951-08-22	1951-08-22 00:00:00	38000275	0	\N	\N	103434	0	228557008	4043071	
30169	2672	4107731	1991-05-05	1991-05-05 00:00:00	38000275	0	\N	\N	177007	0	180256009	4107731	
30318	2679	4151422	2016-09-07	2016-09-07 00:00:00	38000275	0	\N	\N	177469	0	269911007	4151422	
18574	1577	4024289	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	105930	0	19490002	4024289	
18813	1609	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	108105	0	180256009	4107731	
19059	1634	4078793	2015-09-04	2015-09-04 00:00:00	38000275	0	\N	\N	109697	0	180325003	4078793	
31142	2765	4035793	2016-12-27	2016-12-27 00:00:00	38000275	0	\N	\N	182837	0	15081005	4035793	
19357	1656	4059978	2011-08-19	2011-08-19 00:00:00	38000275	0	\N	\N	111106	0	169553002	4059978	
31420	2776	4107731	2008-07-22	2008-07-22 00:00:00	38000275	0	\N	\N	183813	0	180256009	4107731	
19806	1716	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	114768	0	180256009	4107731	
31820	2798	4125906	1976-07-08	1976-07-08 00:00:00	38000275	0	\N	\N	185431	0	288086009	4125906	
20134	1743	4024289	1999-09-08	1999-09-08 00:00:00	38000275	0	\N	\N	116509	0	19490002	4024289	
20234	1753	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	117197	0	180256009	4107731	
32476	2857	4125906	1967-08-24	1967-08-24 00:00:00	38000275	0	\N	\N	189669	0	288086009	4125906	
32601	2863	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	190432	0	180256009	4107731	
44711	3916	4107731	1994-10-05	1994-10-05 00:00:00	38000275	0	\N	\N	260331	0	180256009	4107731	
32932	2891	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	192280	0	180256009	4107731	
21208	1843	4059978	2009-06-03	2009-06-03 00:00:00	38000275	0	\N	\N	123072	0	169553002	4059978	
21420	1852	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	123902	0	180256009	4107731	
45484	4014	4107731	1999-09-21	1999-09-21 00:00:00	38000275	0	\N	\N	266793	0	180256009	4107731	
21805	1892	4024289	1974-07-13	1974-07-13 00:00:00	38000275	0	\N	\N	126046	0	19490002	4024289	
33900	2953	4145310	1988-12-10	1988-12-10 00:00:00	38000275	0	\N	\N	197112	0	268425006	4145310	
34036	2965	4191853	1990-01-01	1990-01-01 00:00:00	38000275	0	\N	\N	197968	0	395142003	4191853	
22312	1956	4191853	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	130141	0	395142003	4191853	
22546	1971	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	131055	0	180256009	4107731	
22793	1980	4125906	1983-04-16	1983-04-16 00:00:00	38000275	0	\N	\N	131805	0	288086009	4125906	
34783	3025	4107731	1992-01-06	1992-01-06 00:00:00	38000275	0	\N	\N	201628	0	180256009	4107731	
47035	4130	4078793	2014-05-08	2014-05-08 00:00:00	38000275	0	\N	\N	274604	0	180325003	4078793	
35178	3064	4043071	1949-10-27	1949-10-27 00:00:00	38000275	0	\N	\N	203946	0	228557008	4043071	
35384	3096	4057420	2011-10-02	2011-10-02 00:00:00	38000275	0	\N	\N	206066	0	18286008	4057420	
23718	2070	4125906	2001-07-19	2001-07-19 00:00:00	38000275	0	\N	\N	137729	0	288086009	4125906	
23859	2077	4107731	1992-05-31	1992-05-31 00:00:00	38000275	0	\N	\N	138347	0	180256009	4107731	
12001	1099	4107731	1992-04-25	1992-04-25 00:00:00	38000275	0	\N	\N	72120	0	180256009	4107731	
24166	2116	4170947	2015-09-27	2015-09-27 00:00:00	38000275	0	\N	\N	140842	0	274474001	4170947	
12469	1123	4125906	2015-02-25	2015-02-25 00:00:00	38000275	0	\N	\N	73969	0	288086009	4125906	
24560	2150	4125906	1961-02-21	1961-02-21 00:00:00	38000275	0	\N	\N	143149	0	288086009	4125906	
24791	2168	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	144554	0	180256009	4107731	
13053	1176	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	77610	0	180256009	4107731	
25097	2186	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	145737	0	180256009	4107731	
25289	2200	4043071	1980-08-17	1980-08-17 00:00:00	38000275	0	\N	\N	146701	0	228557008	4043071	
25495	2217	4295880	2000-11-24	2000-11-24 00:00:00	38000275	0	\N	\N	147662	0	76601001	4295880	
13767	1253	4125906	1969-02-23	1969-02-23 00:00:00	38000275	0	\N	\N	82549	0	288086009	4125906	
13944	1261	4107731	1993-02-13	1993-02-13 00:00:00	38000275	0	\N	\N	83235	0	180256009	4107731	
14144	1272	4107731	1994-01-14	1994-01-14 00:00:00	38000275	0	\N	\N	83908	0	180256009	4107731	
26229	2289	4181917	1958-10-30	1958-10-30 00:00:00	38000275	0	\N	\N	152263	0	54550000	4181917	
14492	1293	4170947	1970-03-18	1970-03-18 00:00:00	38000275	0	\N	\N	85602	0	274474001	4170947	
26646	2333	4195803	2000-06-13	2000-06-13 00:00:00	38000275	0	\N	\N	155177	0	312681000	4195803	
14881	1321	4125906	2016-12-26	2016-12-26 00:00:00	38000275	0	\N	\N	87603	0	288086009	4125906	
26930	2352	4107731	1990-08-20	1990-08-20 00:00:00	38000275	0	\N	\N	156718	0	180256009	4107731	
15244	1361	4151422	1980-09-30	1980-09-30 00:00:00	38000275	0	\N	\N	90371	0	269911007	4151422	
27359	2392	4035793	1986-03-14	1986-03-14 00:00:00	38000275	0	\N	\N	159058	0	15081005	4035793	
15572	1384	4295880	2001-08-21	2001-08-21 00:00:00	38000275	0	\N	\N	91731	0	76601001	4295880	
27716	2427	4047491	2008-12-20	2008-12-20 00:00:00	38000275	0	\N	\N	160964	0	1225002	4047491	
16021	1399	4163872	1988-04-01	1988-04-01 00:00:00	38000275	0	\N	\N	93045	0	399208008	4163872	
16174	1407	4107731	1993-03-06	1993-03-06 00:00:00	38000275	0	\N	\N	93469	0	180256009	4107731	
28358	2518	4293740	1983-08-05	1983-08-05 00:00:00	38000275	0	\N	\N	166541	0	384700001	4293740	
16641	1441	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	96011	0	180256009	4107731	
28634	2542	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	168126	0	180256009	4107731	
28871	2554	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	169277	0	180256009	4107731	
17073	1476	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	98480	0	180256009	4107731	
17351	1497	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	99890	0	180256009	4107731	
17479	1508	4043071	1937-09-13	1937-09-13 00:00:00	38000275	0	\N	\N	100525	0	228557008	4043071	
17708	1517	4043071	1945-12-31	1945-12-31 00:00:00	38000275	0	\N	\N	101410	0	228557008	4043071	
29760	2647	4107731	1990-12-09	1990-12-09 00:00:00	38000275	0	\N	\N	175103	0	180256009	4107731	
18065	1545	4047491	2000-12-16	2000-12-16 00:00:00	38000275	0	\N	\N	103511	0	1225002	4047491	
30170	2672	4107731	1992-06-28	1992-06-28 00:00:00	38000275	0	\N	\N	176929	0	180256009	4107731	
30319	2680	4125906	1976-09-14	1976-09-14 00:00:00	38000275	0	\N	\N	177554	0	288086009	4125906	
18575	1577	4170947	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	105930	0	274474001	4170947	
18814	1609	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	108170	0	180256009	4107731	
19060	1634	4078793	2014-08-29	2014-08-29 00:00:00	38000275	0	\N	\N	109777	0	180325003	4078793	
31143	2765	4202451	2016-09-20	2016-09-20 00:00:00	38000275	0	\N	\N	182896	0	433112001	4202451	
19358	1656	4295880	2014-12-06	2014-12-06 00:00:00	38000275	0	\N	\N	111111	0	76601001	4295880	
31421	2776	4107731	2006-06-06	2006-06-06 00:00:00	38000275	0	\N	\N	183834	0	180256009	4107731	
19807	1716	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	114744	0	180256009	4107731	
31821	2799	4125906	2000-05-17	2000-05-17 00:00:00	38000275	0	\N	\N	185477	0	288086009	4125906	
20135	1743	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	116477	0	180256009	4107731	
20235	1753	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	117215	0	395142003	4191853	
32477	2858	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	189876	0	180256009	4107731	
32602	2863	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	190428	0	180256009	4107731	
44712	3916	4107731	1994-03-09	1994-03-09 00:00:00	38000275	0	\N	\N	260407	0	180256009	4107731	
32933	2891	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	192270	0	180256009	4107731	
21209	1843	4107731	1997-10-01	1997-10-01 00:00:00	38000275	0	\N	\N	123065	0	180256009	4107731	
21421	1852	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	123992	0	180256009	4107731	
45485	4014	4107731	1998-04-14	1998-04-14 00:00:00	38000275	0	\N	\N	266733	0	180256009	4107731	
21806	1892	4170947	1974-07-13	1974-07-13 00:00:00	38000275	0	\N	\N	126046	0	274474001	4170947	
33901	2955	4125906	2002-11-08	2002-11-08 00:00:00	38000275	0	\N	\N	197251	0	288086009	4125906	
34037	2965	4163872	1971-02-18	1971-02-18 00:00:00	38000275	0	\N	\N	197983	0	399208008	4163872	
22313	1956	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	130198	0	180256009	4107731	
22547	1971	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	131057	0	180256009	4107731	
22794	1980	4107731	1990-02-18	1990-02-18 00:00:00	38000275	0	\N	\N	131826	0	180256009	4107731	
34784	3025	4107731	1991-09-02	1991-09-02 00:00:00	38000275	0	\N	\N	201706	0	180256009	4107731	
47036	4130	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	274627	0	180256009	4107731	
35179	3064	4043071	1950-12-21	1950-12-21 00:00:00	38000275	0	\N	\N	203935	0	228557008	4043071	
35385	3096	4078793	2016-07-17	2016-07-17 00:00:00	38000275	0	\N	\N	206075	0	180325003	4078793	
23719	2070	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	137699	0	180256009	4107731	
23860	2077	4107731	1993-06-13	1993-06-13 00:00:00	38000275	0	\N	\N	138272	0	180256009	4107731	
12002	1099	4107731	1993-03-06	1993-03-06 00:00:00	38000275	0	\N	\N	72204	0	180256009	4107731	
24167	2116	4163872	2015-09-27	2015-09-27 00:00:00	38000275	0	\N	\N	140842	0	399208008	4163872	
12470	1124	4125906	1939-09-15	1939-09-15 00:00:00	38000275	0	\N	\N	74109	0	288086009	4125906	
24561	2150	4163872	1969-08-06	1969-08-06 00:00:00	38000275	0	\N	\N	143157	0	399208008	4163872	
24792	2168	4151422	1987-03-19	1987-03-19 00:00:00	38000275	0	\N	\N	144462	0	269911007	4151422	
13054	1176	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	77593	0	180256009	4107731	
25098	2186	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	145736	0	180256009	4107731	
25290	2200	4043071	1984-01-15	1984-01-15 00:00:00	38000275	0	\N	\N	146663	0	228557008	4043071	
25496	2217	4295880	2001-08-24	2001-08-24 00:00:00	38000275	0	\N	\N	147663	0	76601001	4295880	
13836	1257	4151422	1987-06-19	1987-06-19 00:00:00	38000275	0	\N	\N	82845	0	269911007	4151422	
13945	1261	4107731	1991-06-15	1991-06-15 00:00:00	38000275	0	\N	\N	83184	0	180256009	4107731	
14145	1272	4107731	1996-03-01	1996-03-01 00:00:00	38000275	0	\N	\N	83900	0	180256009	4107731	
26230	2289	4293740	2000-07-28	2000-07-28 00:00:00	38000275	0	\N	\N	152254	0	384700001	4293740	
14493	1294	4145310	1978-08-19	1978-08-19 00:00:00	38000275	0	\N	\N	85611	0	268425006	4145310	
26647	2333	4078793	2000-06-13	2000-06-13 00:00:00	38000275	0	\N	\N	155177	0	180325003	4078793	
14882	1321	4151422	2000-10-15	2000-10-15 00:00:00	38000275	0	\N	\N	87674	0	269911007	4151422	
26931	2352	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	156684	0	180256009	4107731	
15245	1361	4151422	2000-06-08	2000-06-08 00:00:00	38000275	0	\N	\N	90335	0	269911007	4151422	
27360	2392	4195803	1986-03-14	1986-03-14 00:00:00	38000275	0	\N	\N	159058	0	312681000	4195803	
15573	1384	4295880	2001-02-14	2001-02-14 00:00:00	38000275	0	\N	\N	91753	0	76601001	4295880	
27717	2427	4151422	1994-11-29	1994-11-29 00:00:00	38000275	0	\N	\N	161037	0	269911007	4151422	
16022	1399	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	93125	0	180256009	4107731	
16175	1407	4107731	1990-03-31	1990-03-31 00:00:00	38000275	0	\N	\N	93528	0	180256009	4107731	
28359	2518	4125906	1983-08-05	1983-08-05 00:00:00	38000275	0	\N	\N	166541	0	288086009	4125906	
16642	1442	4170947	2012-09-07	2012-09-07 00:00:00	38000275	0	\N	\N	96188	0	274474001	4170947	
28635	2542	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	168102	0	180256009	4107731	
28872	2554	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	169226	0	180256009	4107731	
17074	1476	4125906	1955-02-19	1955-02-19 00:00:00	38000275	0	\N	\N	98491	0	288086009	4125906	
17352	1497	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	99809	0	180256009	4107731	
17480	1508	4043071	1937-06-07	1937-06-07 00:00:00	38000275	0	\N	\N	100582	0	228557008	4043071	
17709	1517	4057420	2017-04-17	2017-04-17 00:00:00	38000275	0	\N	\N	101405	0	18286008	4057420	
29761	2647	4107731	1991-06-16	1991-06-16 00:00:00	38000275	0	\N	\N	175196	0	180256009	4107731	
18066	1545	4170947	2000-12-16	2000-12-16 00:00:00	38000275	0	\N	\N	103511	0	274474001	4170947	
30171	2672	4107731	1991-01-20	1991-01-20 00:00:00	38000275	0	\N	\N	177022	0	180256009	4107731	
30320	2680	44783196	1986-02-15	1986-02-15 00:00:00	38000275	0	\N	\N	177515	0	699253003	44783196	
18576	1577	4151422	2003-05-15	2003-05-15 00:00:00	38000275	0	\N	\N	105878	0	269911007	4151422	
18833	1611	4198190	1989-05-31	1989-05-31 00:00:00	38000275	0	\N	\N	108288	0	80146002	4198190	
19061	1634	4151422	1950-11-07	1950-11-07 00:00:00	38000275	0	\N	\N	109728	0	269911007	4151422	
31144	2765	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	182880	0	180256009	4107731	
19359	1656	4295880	2008-03-15	2008-03-15 00:00:00	38000275	0	\N	\N	111126	0	76601001	4295880	
31422	2776	4107731	2007-05-08	2007-05-08 00:00:00	38000275	0	\N	\N	183842	0	180256009	4107731	
19808	1716	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	114624	0	180256009	4107731	
31822	2799	4170947	1995-05-14	1995-05-14 00:00:00	38000275	0	\N	\N	185476	0	274474001	4170947	
20136	1743	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	116486	0	180256009	4107731	
20236	1753	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	117220	0	180256009	4107731	
32478	2858	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	189914	0	180256009	4107731	
32603	2863	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	190437	0	180256009	4107731	
44713	3916	4107731	1995-02-08	1995-02-08 00:00:00	38000275	0	\N	\N	260427	0	180256009	4107731	
32934	2891	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	192271	0	180256009	4107731	
21210	1843	4107731	1996-05-15	1996-05-15 00:00:00	38000275	0	\N	\N	123028	0	180256009	4107731	
21422	1852	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	123916	0	180256009	4107731	
45486	4014	4107731	2000-03-28	2000-03-28 00:00:00	38000275	0	\N	\N	266794	0	180256009	4107731	
21807	1892	4035793	2014-08-07	2014-08-07 00:00:00	38000275	0	\N	\N	125989	0	15081005	4035793	
33902	2955	4057420	2017-07-25	2017-07-25 00:00:00	38000275	0	\N	\N	197252	0	18286008	4057420	
34038	2965	4107731	1991-07-22	1991-07-22 00:00:00	38000275	0	\N	\N	197955	0	180256009	4107731	
22314	1956	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	130167	0	180256009	4107731	
22548	1971	4151422	1993-07-04	1993-07-04 00:00:00	38000275	0	\N	\N	131000	0	269911007	4151422	
22795	1980	4107731	1991-03-03	1991-03-03 00:00:00	38000275	0	\N	\N	131787	0	180256009	4107731	
34785	3025	4107731	1992-03-09	1992-03-09 00:00:00	38000275	0	\N	\N	201635	0	180256009	4107731	
47037	4130	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	274626	0	180256009	4107731	
35180	3064	4125906	1980-05-03	1980-05-03 00:00:00	38000275	0	\N	\N	203999	0	288086009	4125906	
35386	3096	4170947	2011-01-14	2011-01-14 00:00:00	38000275	0	\N	\N	206078	0	274474001	4170947	
23720	2070	4191853	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	137700	0	395142003	4191853	
23861	2077	4107731	1992-08-23	1992-08-23 00:00:00	38000275	0	\N	\N	138300	0	180256009	4107731	
12003	1099	4107731	1993-01-02	1993-01-02 00:00:00	38000275	0	\N	\N	72233	0	180256009	4107731	
24176	2119	4107731	1992-12-28	1992-12-28 00:00:00	38000275	0	\N	\N	141034	0	180256009	4107731	
12471	1124	4125906	1991-10-01	1991-10-01 00:00:00	38000275	0	\N	\N	74113	0	288086009	4125906	
24562	2150	4195803	1958-04-08	1958-04-08 00:00:00	38000275	0	\N	\N	143148	0	312681000	4195803	
24793	2168	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	144546	0	180256009	4107731	
13055	1176	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	77596	0	180256009	4107731	
25099	2186	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	145822	0	180256009	4107731	
25291	2200	4043071	1983-10-02	1983-10-02 00:00:00	38000275	0	\N	\N	146677	0	228557008	4043071	
25497	2217	4295880	2002-05-24	2002-05-24 00:00:00	38000275	0	\N	\N	147664	0	76601001	4295880	
13837	1257	4198190	1976-10-28	1976-10-28 00:00:00	38000275	0	\N	\N	82830	0	80146002	4198190	
13946	1261	4107731	1992-12-12	1992-12-12 00:00:00	38000275	0	\N	\N	83194	0	180256009	4107731	
14146	1272	4057420	1991-08-30	1991-08-30 00:00:00	38000275	0	\N	\N	83860	0	18286008	4057420	
26231	2289	4125906	2000-07-28	2000-07-28 00:00:00	38000275	0	\N	\N	152254	0	288086009	4125906	
14494	1297	4151422	1989-11-04	1989-11-04 00:00:00	38000275	0	\N	\N	85706	0	269911007	4151422	
26648	2333	4078793	2008-02-19	2008-02-19 00:00:00	38000275	0	\N	\N	155253	0	180325003	4078793	
14883	1321	4125906	1960-05-27	1960-05-27 00:00:00	38000275	0	\N	\N	87679	0	288086009	4125906	
26932	2352	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	156602	0	180256009	4107731	
15248	1365	4043071	1977-11-24	1977-11-24 00:00:00	38000275	0	\N	\N	90499	0	228557008	4043071	
27361	2392	4035793	2013-10-04	2013-10-04 00:00:00	38000275	0	\N	\N	159068	0	15081005	4035793	
15574	1384	4301346	1996-04-15	1996-04-15 00:00:00	38000275	0	\N	\N	91728	0	387685009	4301346	
27718	2427	4151422	1968-10-01	1968-10-01 00:00:00	38000275	0	\N	\N	161028	0	269911007	4151422	
16023	1399	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	93113	0	180256009	4107731	
16176	1407	4107731	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	93555	0	180256009	4107731	
28360	2518	4035793	2019-02-08	2019-02-08 00:00:00	38000275	0	\N	\N	166528	0	15081005	4035793	
16643	1442	4024289	2012-09-07	2012-09-07 00:00:00	38000275	0	\N	\N	96188	0	19490002	4024289	
28636	2542	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	168082	0	180256009	4107731	
28873	2554	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	169157	0	180256009	4107731	
17075	1476	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	98350	0	180256009	4107731	
17353	1497	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	99821	0	395142003	4191853	
17481	1508	4195803	1984-12-11	1984-12-11 00:00:00	38000275	0	\N	\N	100596	0	312681000	4195803	
17710	1517	4043071	1946-11-11	1946-11-11 00:00:00	38000275	0	\N	\N	101413	0	228557008	4043071	
29762	2647	4107731	1991-09-08	1991-09-08 00:00:00	38000275	0	\N	\N	175131	0	180256009	4107731	
18067	1545	4151422	2018-06-27	2018-06-27 00:00:00	38000275	0	\N	\N	103523	0	269911007	4151422	
30172	2672	4107731	1993-03-28	1993-03-28 00:00:00	38000275	0	\N	\N	176932	0	180256009	4107731	
30321	2680	4125906	2017-09-19	2017-09-19 00:00:00	38000275	0	\N	\N	177559	0	288086009	4125906	
18577	1577	4151422	1990-06-07	1990-06-07 00:00:00	38000275	0	\N	\N	105838	0	269911007	4151422	
18834	1611	4170947	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	108355	0	274474001	4170947	
19062	1634	4078793	2018-09-21	2018-09-21 00:00:00	38000275	0	\N	\N	109779	0	180325003	4078793	
31145	2765	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	182866	0	180256009	4107731	
19360	1656	4295880	2007-06-16	2007-06-16 00:00:00	38000275	0	\N	\N	111125	0	76601001	4295880	
31423	2776	4107731	2006-04-04	2006-04-04 00:00:00	38000275	0	\N	\N	183772	0	180256009	4107731	
19809	1716	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	114680	0	180256009	4107731	
31823	2799	4047491	1995-05-14	1995-05-14 00:00:00	38000275	0	\N	\N	185476	0	1225002	4047491	
20137	1743	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	116518	0	180256009	4107731	
20237	1753	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	117202	0	180256009	4107731	
32479	2858	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	189930	0	180256009	4107731	
32604	2863	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	190335	0	180256009	4107731	
44714	3916	4107731	1994-08-03	1994-08-03 00:00:00	38000275	0	\N	\N	260294	0	180256009	4107731	
32935	2891	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	192377	0	180256009	4107731	
21211	1843	4107731	1997-06-18	1997-06-18 00:00:00	38000275	0	\N	\N	123082	0	180256009	4107731	
21423	1852	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	123972	0	180256009	4107731	
45487	4014	4107731	2000-08-22	2000-08-22 00:00:00	38000275	0	\N	\N	266746	0	180256009	4107731	
21808	1892	4035793	2016-08-18	2016-08-18 00:00:00	38000275	0	\N	\N	126022	0	15081005	4035793	
33903	2955	40492359	2017-07-25	2017-07-25 00:00:00	38000275	0	\N	\N	197252	0	447365002	40492359	
34039	2965	4107731	1991-09-23	1991-09-23 00:00:00	38000275	0	\N	\N	197990	0	180256009	4107731	
22315	1956	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	130199	0	180256009	4107731	
22549	1971	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	131054	0	180256009	4107731	
22796	1980	4107731	1992-04-26	1992-04-26 00:00:00	38000275	0	\N	\N	131883	0	180256009	4107731	
34786	3025	4107731	1992-01-27	1992-01-27 00:00:00	38000275	0	\N	\N	201634	0	180256009	4107731	
47038	4130	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	274554	0	180256009	4107731	
35181	3064	4043071	1950-07-06	1950-07-06 00:00:00	38000275	0	\N	\N	203960	0	228557008	4043071	
35387	3096	4024289	2011-01-14	2011-01-14 00:00:00	38000275	0	\N	\N	206078	0	19490002	4024289	
23721	2070	4107731	1991-01-14	1991-01-14 00:00:00	38000275	0	\N	\N	137688	0	180256009	4107731	
23862	2077	4107731	1991-09-22	1991-09-22 00:00:00	38000275	0	\N	\N	138218	0	180256009	4107731	
12004	1099	4107731	1991-11-30	1991-11-30 00:00:00	38000275	0	\N	\N	72239	0	180256009	4107731	
24177	2119	4107731	1991-02-25	1991-02-25 00:00:00	38000275	0	\N	\N	140969	0	180256009	4107731	
12472	1124	4151422	1998-11-20	1998-11-20 00:00:00	38000275	0	\N	\N	74077	0	269911007	4151422	
24563	2150	4243062	1958-04-08	1958-04-08 00:00:00	38000275	0	\N	\N	143148	0	60027007	4243062	
24794	2168	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	144529	0	180256009	4107731	
13056	1176	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	77656	0	180256009	4107731	
25100	2186	4151422	2013-05-30	2013-05-30 00:00:00	38000275	0	\N	\N	145769	0	269911007	4151422	
25292	2200	4043071	1983-06-05	1983-06-05 00:00:00	38000275	0	\N	\N	146675	0	228557008	4043071	
25498	2217	4295880	2002-11-22	2002-11-22 00:00:00	38000275	0	\N	\N	147686	0	76601001	4295880	
13838	1258	4151422	2013-10-18	2013-10-18 00:00:00	38000275	0	\N	\N	82891	0	269911007	4151422	
13947	1261	4107731	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	83196	0	180256009	4107731	
14147	1272	40492359	1991-08-30	1991-08-30 00:00:00	38000275	0	\N	\N	83860	0	447365002	40492359	
26232	2289	4195803	2009-12-29	2009-12-29 00:00:00	38000275	0	\N	\N	152245	0	312681000	4195803	
14580	1305	4043071	1976-08-10	1976-08-10 00:00:00	38000275	0	\N	\N	86111	0	228557008	4043071	
26649	2333	4078793	2003-07-01	2003-07-01 00:00:00	38000275	0	\N	\N	155234	0	180325003	4078793	
14884	1321	4293740	1960-05-27	1960-05-27 00:00:00	38000275	0	\N	\N	87679	0	384700001	4293740	
26933	2352	4107731	1992-09-14	1992-09-14 00:00:00	38000275	0	\N	\N	156681	0	180256009	4107731	
15249	1365	4043071	1978-02-23	1978-02-23 00:00:00	38000275	0	\N	\N	90518	0	228557008	4043071	
27362	2392	4078793	2013-10-04	2013-10-04 00:00:00	38000275	0	\N	\N	159068	0	180325003	4078793	
15575	1384	4243062	1991-03-29	1991-03-29 00:00:00	38000275	0	\N	\N	91724	0	60027007	4243062	
27719	2427	4151422	1959-10-01	1959-10-01 00:00:00	38000275	0	\N	\N	160980	0	269911007	4151422	
16024	1399	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	93096	0	180256009	4107731	
16177	1407	4107731	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	93478	0	180256009	4107731	
28361	2518	4151422	1993-08-09	1993-08-09 00:00:00	38000275	0	\N	\N	166530	0	269911007	4151422	
28425	2534	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	167422	0	180256009	4107731	
28637	2542	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	168101	0	180256009	4107731	
28874	2554	4125906	1950-08-27	1950-08-27 00:00:00	38000275	0	\N	\N	169197	0	288086009	4125906	
17076	1476	4078793	2007-12-20	2007-12-20 00:00:00	38000275	0	\N	\N	98475	0	180325003	4078793	
17354	1497	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	99848	0	180256009	4107731	
17482	1508	4043071	1938-07-04	1938-07-04 00:00:00	38000275	0	\N	\N	100585	0	228557008	4043071	
17711	1517	4043071	1945-11-26	1945-11-26 00:00:00	38000275	0	\N	\N	101376	0	228557008	4043071	
29763	2647	4107731	1990-02-18	1990-02-18 00:00:00	38000275	0	\N	\N	175177	0	180256009	4107731	
18068	1545	4125906	2017-04-03	2017-04-03 00:00:00	38000275	0	\N	\N	103514	0	288086009	4125906	
30173	2672	4107731	1990-06-03	1990-06-03 00:00:00	38000275	0	\N	\N	177040	0	180256009	4107731	
30322	2680	4243062	1987-05-11	1987-05-11 00:00:00	38000275	0	\N	\N	177556	0	60027007	4243062	
18578	1577	4163971	1997-01-31	1997-01-31 00:00:00	38000275	0	\N	\N	105932	0	45595009	4163971	
18835	1611	4243062	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	108355	0	60027007	4243062	
19063	1635	40492359	2013-03-27	2013-03-27 00:00:00	38000275	0	\N	\N	109831	0	447365002	40492359	
31146	2765	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	182935	0	180256009	4107731	
19361	1656	4295880	2006-09-16	2006-09-16 00:00:00	38000275	0	\N	\N	111124	0	76601001	4295880	
31424	2776	4107731	2008-08-12	2008-08-12 00:00:00	38000275	0	\N	\N	183883	0	180256009	4107731	
19810	1716	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	114623	0	180256009	4107731	
31824	2799	4170947	1986-08-29	1986-08-29 00:00:00	38000275	0	\N	\N	185475	0	274474001	4170947	
20138	1743	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	116528	0	180256009	4107731	
20238	1753	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	117312	0	180256009	4107731	
32480	2858	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	189848	0	180256009	4107731	
32605	2863	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	190438	0	180256009	4107731	
44715	3916	4295880	1997-06-25	1997-06-25 00:00:00	38000275	0	\N	\N	260357	0	76601001	4295880	
32936	2891	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	192265	0	180256009	4107731	
21212	1843	4107731	1997-12-24	1997-12-24 00:00:00	38000275	0	\N	\N	123084	0	180256009	4107731	
21424	1852	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	123928	0	180256009	4107731	
45488	4014	4170947	2018-10-29	2018-10-29 00:00:00	38000275	0	\N	\N	266741	0	274474001	4170947	
21809	1892	4035793	2013-08-01	2013-08-01 00:00:00	38000275	0	\N	\N	126015	0	15081005	4035793	
33904	2955	4151422	1980-04-21	1980-04-21 00:00:00	38000275	0	\N	\N	197241	0	269911007	4151422	
34040	2965	4191853	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	198013	0	395142003	4191853	
22316	1956	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	130163	0	180256009	4107731	
22550	1971	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	131017	0	395142003	4191853	
22797	1980	4107731	1993-03-28	1993-03-28 00:00:00	38000275	0	\N	\N	131869	0	180256009	4107731	
34787	3025	4107731	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	201708	0	180256009	4107731	
47039	4130	4078793	2015-05-14	2015-05-14 00:00:00	38000275	0	\N	\N	274551	0	180325003	4078793	
35182	3064	4047491	1971-10-18	1971-10-18 00:00:00	38000275	0	\N	\N	203998	0	1225002	4047491	
35388	3096	4170947	1970-12-15	1970-12-15 00:00:00	38000275	0	\N	\N	206037	0	274474001	4170947	
23722	2070	4107731	1992-10-05	1992-10-05 00:00:00	38000275	0	\N	\N	137696	0	180256009	4107731	
23863	2077	4107731	1991-11-24	1991-11-24 00:00:00	38000275	0	\N	\N	138355	0	180256009	4107731	
12005	1099	4107731	1991-04-13	1991-04-13 00:00:00	38000275	0	\N	\N	72225	0	180256009	4107731	
24178	2119	4107731	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	141078	0	180256009	4107731	
12473	1124	4047491	1945-08-19	1945-08-19 00:00:00	38000275	0	\N	\N	74111	0	1225002	4047491	
24564	2150	4170947	1958-04-08	1958-04-08 00:00:00	38000275	0	\N	\N	143148	0	274474001	4170947	
24795	2168	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	144520	0	180256009	4107731	
13057	1176	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	77618	0	180256009	4107731	
25101	2186	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	145768	0	180256009	4107731	
25293	2200	4043071	1984-08-19	1984-08-19 00:00:00	38000275	0	\N	\N	146634	0	228557008	4043071	
25499	2217	4295880	2002-08-23	2002-08-23 00:00:00	38000275	0	\N	\N	147692	0	76601001	4295880	
25620	2238	4107731	1990-01-21	1990-01-21 00:00:00	38000275	0	\N	\N	148978	0	180256009	4107731	
13948	1261	4107731	1992-08-29	1992-08-29 00:00:00	38000275	0	\N	\N	83168	0	180256009	4107731	
14148	1272	4191853	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	83866	0	395142003	4191853	
26233	2289	4125906	1961-11-19	1961-11-19 00:00:00	38000275	0	\N	\N	152249	0	288086009	4125906	
14581	1306	4293740	1962-04-09	1962-04-09 00:00:00	38000275	0	\N	\N	86246	0	384700001	4293740	
26650	2333	4078793	2006-03-21	2006-03-21 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
14885	1321	4198190	1995-06-24	1995-06-24 00:00:00	38000275	0	\N	\N	87609	0	80146002	4198190	
26934	2352	4107731	1992-02-17	1992-02-17 00:00:00	38000275	0	\N	\N	156669	0	180256009	4107731	
15250	1365	4043071	1979-09-06	1979-09-06 00:00:00	38000275	0	\N	\N	90435	0	228557008	4043071	
27363	2392	4035793	1997-05-16	1997-05-16 00:00:00	38000275	0	\N	\N	158971	0	15081005	4035793	
15576	1384	4170947	1991-03-29	1991-03-29 00:00:00	38000275	0	\N	\N	91724	0	274474001	4170947	
27720	2428	4293740	1977-04-10	1977-04-10 00:00:00	38000275	0	\N	\N	161123	0	384700001	4293740	
16025	1399	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	93109	0	180256009	4107731	
16178	1407	4107731	1992-04-25	1992-04-25 00:00:00	38000275	0	\N	\N	93554	0	180256009	4107731	
28362	2518	4035793	2015-01-16	2015-01-16 00:00:00	38000275	0	\N	\N	166576	0	15081005	4035793	
28426	2534	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	167384	0	180256009	4107731	
28638	2542	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	168081	0	180256009	4107731	
28875	2554	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	169117	0	180256009	4107731	
17077	1476	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	98345	0	180256009	4107731	
17355	1497	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	99814	0	180256009	4107731	
17483	1508	4043071	1937-08-09	1937-08-09 00:00:00	38000275	0	\N	\N	100524	0	228557008	4043071	
17712	1517	4043071	1945-07-23	1945-07-23 00:00:00	38000275	0	\N	\N	101409	0	228557008	4043071	
29764	2647	4107731	1990-12-30	1990-12-30 00:00:00	38000275	0	\N	\N	175211	0	180256009	4107731	
18069	1545	4125906	2012-08-15	2012-08-15 00:00:00	38000275	0	\N	\N	103512	0	288086009	4125906	
30174	2672	4107731	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	176959	0	180256009	4107731	
30323	2680	4170947	1987-05-11	1987-05-11 00:00:00	38000275	0	\N	\N	177556	0	274474001	4170947	
18579	1577	4163951	1997-01-31	1997-01-31 00:00:00	38000275	0	\N	\N	105932	0	29303009	4163951	
18836	1611	4151422	1977-06-21	1977-06-21 00:00:00	38000275	0	\N	\N	108317	0	269911007	4151422	
19064	1635	4057420	2013-03-27	2013-03-27 00:00:00	38000275	0	\N	\N	109831	0	18286008	4057420	
31147	2765	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	182923	0	180256009	4107731	
19362	1656	4295880	2007-09-15	2007-09-15 00:00:00	38000275	0	\N	\N	111158	0	76601001	4295880	
31425	2776	4107731	2007-08-21	2007-08-21 00:00:00	38000275	0	\N	\N	183878	0	180256009	4107731	
19811	1716	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	114769	0	180256009	4107731	
31825	2799	4047491	1986-08-29	1986-08-29 00:00:00	38000275	0	\N	\N	185475	0	1225002	4047491	
20139	1743	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	116501	0	180256009	4107731	
20239	1753	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	117195	0	180256009	4107731	
32481	2858	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	189746	0	180256009	4107731	
32606	2863	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	190413	0	180256009	4107731	
44716	3916	4107731	1995-01-18	1995-01-18 00:00:00	38000275	0	\N	\N	260284	0	180256009	4107731	
32937	2891	4125906	1982-08-07	1982-08-07 00:00:00	38000275	0	\N	\N	192314	0	288086009	4125906	
21213	1843	4107731	1996-04-03	1996-04-03 00:00:00	38000275	0	\N	\N	123107	0	180256009	4107731	
21425	1852	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	123977	0	180256009	4107731	
45489	4014	4024289	2018-10-29	2018-10-29 00:00:00	38000275	0	\N	\N	266741	0	19490002	4024289	
21810	1892	4151422	2008-11-08	2008-11-08 00:00:00	38000275	0	\N	\N	125976	0	269911007	4151422	
33905	2955	4151422	2015-05-19	2015-05-19 00:00:00	38000275	0	\N	\N	197226	0	269911007	4151422	
34041	2965	4107731	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	198006	0	180256009	4107731	
22317	1956	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	130194	0	180256009	4107731	
22551	1973	4125906	1974-06-21	1974-06-21 00:00:00	38000275	0	\N	\N	131199	0	288086009	4125906	
22798	1980	4107731	1991-05-26	1991-05-26 00:00:00	38000275	0	\N	\N	131803	0	180256009	4107731	
34788	3025	4107731	1991-03-18	1991-03-18 00:00:00	38000275	0	\N	\N	201610	0	180256009	4107731	
47040	4130	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	274590	0	180256009	4107731	
35183	3064	4170947	1971-10-18	1971-10-18 00:00:00	38000275	0	\N	\N	203998	0	274474001	4170947	
35389	3096	4047491	1970-12-15	1970-12-15 00:00:00	38000275	0	\N	\N	206037	0	1225002	4047491	
23723	2070	4191853	1990-01-01	1990-01-01 00:00:00	38000275	0	\N	\N	137655	0	395142003	4191853	
23864	2077	4107731	1990-12-02	1990-12-02 00:00:00	38000275	0	\N	\N	138350	0	180256009	4107731	
12006	1099	4151422	2007-05-23	2007-05-23 00:00:00	38000275	0	\N	\N	72189	0	269911007	4151422	
24179	2119	4107731	1992-08-03	1992-08-03 00:00:00	38000275	0	\N	\N	141080	0	180256009	4107731	
12474	1124	4170947	1945-08-19	1945-08-19 00:00:00	38000275	0	\N	\N	74111	0	274474001	4170947	
24565	2151	4216130	1999-12-08	1999-12-08 00:00:00	38000275	0	\N	\N	143282	0	415070008	4216130	
24796	2168	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	144423	0	180256009	4107731	
13058	1176	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	77677	0	180256009	4107731	
25102	2186	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	145735	0	180256009	4107731	
25294	2200	4043071	1984-11-18	1984-11-18 00:00:00	38000275	0	\N	\N	146668	0	228557008	4043071	
25500	2217	4295880	2000-02-25	2000-02-25 00:00:00	38000275	0	\N	\N	147661	0	76601001	4295880	
25621	2238	4107731	1991-04-07	1991-04-07 00:00:00	38000275	0	\N	\N	148984	0	180256009	4107731	
13949	1261	4107731	1990-01-27	1990-01-27 00:00:00	38000275	0	\N	\N	83240	0	180256009	4107731	
14149	1273	4151422	1969-04-28	1969-04-28 00:00:00	38000275	0	\N	\N	84016	0	269911007	4151422	
26234	2289	4125906	1971-11-18	1971-11-18 00:00:00	38000275	0	\N	\N	152251	0	288086009	4125906	
14582	1306	4125906	1962-04-09	1962-04-09 00:00:00	38000275	0	\N	\N	86246	0	288086009	4125906	
26651	2333	4078793	2009-02-24	2009-02-24 00:00:00	38000275	0	\N	\N	155220	0	180325003	4078793	
14886	1321	4125906	1987-04-25	1987-04-25 00:00:00	38000275	0	\N	\N	87598	0	288086009	4125906	
26935	2352	4107731	1990-02-12	1990-02-12 00:00:00	38000275	0	\N	\N	156702	0	180256009	4107731	
15251	1365	4043071	1979-01-18	1979-01-18 00:00:00	38000275	0	\N	\N	90433	0	228557008	4043071	
27364	2392	4078793	1997-05-16	1997-05-16 00:00:00	38000275	0	\N	\N	158971	0	180325003	4078793	
15577	1384	4295880	2002-05-21	2002-05-21 00:00:00	38000275	0	\N	\N	91732	0	76601001	4295880	
27721	2428	4125906	1977-04-10	1977-04-10 00:00:00	38000275	0	\N	\N	161123	0	288086009	4125906	
16026	1399	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	93023	0	180256009	4107731	
16179	1407	4125906	1992-12-14	1992-12-14 00:00:00	38000275	0	\N	\N	93566	0	288086009	4125906	
28363	2518	4035793	2010-12-24	2010-12-24 00:00:00	38000275	0	\N	\N	166552	0	15081005	4035793	
28427	2534	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	167440	0	180256009	4107731	
28639	2542	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	168125	0	180256009	4107731	
28876	2554	4125906	1965-12-27	1965-12-27 00:00:00	38000275	0	\N	\N	169198	0	288086009	4125906	
17078	1476	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	98375	0	180256009	4107731	
17356	1497	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	99855	0	180256009	4107731	
17484	1508	4043071	1937-03-08	1937-03-08 00:00:00	38000275	0	\N	\N	100523	0	228557008	4043071	
17713	1517	4043071	1947-02-24	1947-02-24 00:00:00	38000275	0	\N	\N	101398	0	228557008	4043071	
29765	2647	4107731	1992-02-02	1992-02-02 00:00:00	38000275	0	\N	\N	175198	0	180256009	4107731	
18070	1545	4170947	1970-09-27	1970-09-27 00:00:00	38000275	0	\N	\N	103508	0	274474001	4170947	
30175	2672	4107731	1990-10-07	1990-10-07 00:00:00	38000275	0	\N	\N	177030	0	180256009	4107731	
30324	2680	4252419	1986-02-08	1986-02-08 00:00:00	38000275	0	\N	\N	177555	0	74016001	4252419	
18580	1577	4202832	1997-01-31	1997-01-31 00:00:00	38000275	0	\N	\N	105932	0	52765003	4202832	
18837	1611	4151422	2011-10-12	2011-10-12 00:00:00	38000275	0	\N	\N	108327	0	269911007	4151422	
19065	1635	4170947	1973-08-14	1973-08-14 00:00:00	38000275	0	\N	\N	109856	0	274474001	4170947	
31148	2765	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	182989	0	180256009	4107731	
19363	1656	4295880	2013-03-09	2013-03-09 00:00:00	38000275	0	\N	\N	111163	0	76601001	4295880	
31426	2776	4107731	2008-05-20	2008-05-20 00:00:00	38000275	0	\N	\N	183881	0	180256009	4107731	
19812	1716	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	114627	0	180256009	4107731	
31830	2801	4170947	1968-10-16	1968-10-16 00:00:00	38000275	0	\N	\N	185605	0	274474001	4170947	
20140	1743	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	116520	0	180256009	4107731	
20240	1753	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	117245	0	180256009	4107731	
32482	2858	4125906	1979-07-01	1979-07-01 00:00:00	38000275	0	\N	\N	189902	0	288086009	4125906	
32607	2863	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	190446	0	180256009	4107731	
44717	3916	4107731	1992-04-15	1992-04-15 00:00:00	38000275	0	\N	\N	260262	0	180256009	4107731	
32938	2891	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	192333	0	180256009	4107731	
21214	1843	4151422	1989-06-26	1989-06-26 00:00:00	38000275	0	\N	\N	123012	0	269911007	4151422	
21426	1852	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	123930	0	180256009	4107731	
45490	4014	4107731	1999-03-16	1999-03-16 00:00:00	38000275	0	\N	\N	266802	0	180256009	4107731	
21811	1892	4337138	2015-10-29	2015-10-29 00:00:00	38000275	0	\N	\N	126050	0	88039007	4337138	
33907	2957	4145310	2017-08-15	2017-08-15 00:00:00	38000275	0	\N	\N	197395	0	268425006	4145310	
34042	2965	4107731	1991-04-29	1991-04-29 00:00:00	38000275	0	\N	\N	197916	0	180256009	4107731	
22318	1956	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	130184	0	180256009	4107731	
22552	1973	4058899	1996-12-20	1996-12-20 00:00:00	38000275	0	\N	\N	131202	0	168594001	4058899	
22799	1980	4107731	1993-04-18	1993-04-18 00:00:00	38000275	0	\N	\N	131766	0	180256009	4107731	
34789	3025	4107731	1990-06-18	1990-06-18 00:00:00	38000275	0	\N	\N	201607	0	180256009	4107731	
47041	4130	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	274561	0	180256009	4107731	
35184	3064	4043071	1949-12-29	1949-12-29 00:00:00	38000275	0	\N	\N	203954	0	228557008	4043071	
35390	3096	4078793	2013-10-06	2013-10-06 00:00:00	38000275	0	\N	\N	206115	0	180325003	4078793	
23724	2070	4107731	1990-07-09	1990-07-09 00:00:00	38000275	0	\N	\N	137656	0	180256009	4107731	
23865	2077	4107731	1992-07-12	1992-07-12 00:00:00	38000275	0	\N	\N	138357	0	180256009	4107731	
12007	1099	4107731	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	72188	0	180256009	4107731	
24180	2119	4107731	1992-10-05	1992-10-05 00:00:00	38000275	0	\N	\N	141032	0	180256009	4107731	
12475	1124	4125906	1940-08-31	1940-08-31 00:00:00	38000275	0	\N	\N	74110	0	288086009	4125906	
24566	2151	4336464	1999-12-08	1999-12-08 00:00:00	38000275	0	\N	\N	143282	0	232717009	4336464	
24797	2168	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	144550	0	180256009	4107731	
13059	1176	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	77685	0	180256009	4107731	
25103	2186	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	145734	0	180256009	4107731	
25295	2200	4043071	1981-02-15	1981-02-15 00:00:00	38000275	0	\N	\N	146630	0	228557008	4043071	
25501	2218	4197460	1989-03-26	1989-03-26 00:00:00	38000275	0	\N	\N	147708	0	313191000	4197460	
25622	2238	4107731	1993-02-28	1993-02-28 00:00:00	38000275	0	\N	\N	149015	0	180256009	4107731	
13950	1261	4107731	1992-02-01	1992-02-01 00:00:00	38000275	0	\N	\N	83191	0	180256009	4107731	
14155	1276	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	84186	0	180256009	4107731	
26235	2290	4125906	1976-11-13	1976-11-13 00:00:00	38000275	0	\N	\N	152336	0	288086009	4125906	
14583	1306	4058899	2019-04-11	2019-04-11 00:00:00	38000275	0	\N	\N	86205	0	168594001	4058899	
26652	2333	4078793	2001-06-19	2001-06-19 00:00:00	38000275	0	\N	\N	155252	0	180325003	4078793	
14887	1322	4195803	2003-08-13	2003-08-13 00:00:00	38000275	0	\N	\N	87686	0	312681000	4195803	
26936	2352	4151422	2000-01-24	2000-01-24 00:00:00	38000275	0	\N	\N	156619	0	269911007	4151422	
15252	1365	4043071	1979-10-11	1979-10-11 00:00:00	38000275	0	\N	\N	90436	0	228557008	4043071	
27365	2392	4035793	2003-06-20	2003-06-20 00:00:00	38000275	0	\N	\N	158995	0	15081005	4035793	
15578	1384	44783196	1994-01-19	1994-01-19 00:00:00	38000275	0	\N	\N	91727	0	699253003	44783196	
27722	2428	4170947	1984-01-18	1984-01-18 00:00:00	38000275	0	\N	\N	161080	0	274474001	4170947	
16027	1399	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	93110	0	180256009	4107731	
16180	1407	4107731	1990-09-15	1990-09-15 00:00:00	38000275	0	\N	\N	93578	0	180256009	4107731	
28364	2518	4035793	2018-02-02	2018-02-02 00:00:00	38000275	0	\N	\N	166594	0	15081005	4035793	
28428	2534	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	167385	0	180256009	4107731	
28640	2542	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	168096	0	180256009	4107731	
28877	2554	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	169118	0	180256009	4107731	
17079	1476	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	98376	0	180256009	4107731	
17357	1497	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	99878	0	180256009	4107731	
17485	1508	4043071	1937-04-05	1937-04-05 00:00:00	38000275	0	\N	\N	100634	0	228557008	4043071	
17714	1517	4043071	1947-10-06	1947-10-06 00:00:00	38000275	0	\N	\N	101357	0	228557008	4043071	
29766	2647	4107731	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	175135	0	180256009	4107731	
18071	1545	4024289	1970-09-27	1970-09-27 00:00:00	38000275	0	\N	\N	103508	0	19490002	4024289	
30176	2672	4107731	1991-11-10	1991-11-10 00:00:00	38000275	0	\N	\N	176927	0	180256009	4107731	
30391	2682	4151422	2009-12-01	2009-12-01 00:00:00	38000275	0	\N	\N	177712	0	269911007	4151422	
18581	1577	42535580	1997-01-31	1997-01-31 00:00:00	38000275	0	\N	\N	105932	0	426701000119108	42535580	
18838	1611	4202451	2017-04-09	2017-04-09 00:00:00	38000275	0	\N	\N	108330	0	433112001	4202451	
19066	1635	4047491	1973-08-14	1973-08-14 00:00:00	38000275	0	\N	\N	109856	0	1225002	4047491	
31149	2765	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	182864	0	180256009	4107731	
19364	1656	4295880	2014-06-07	2014-06-07 00:00:00	38000275	0	\N	\N	111144	0	76601001	4295880	
31427	2776	4107731	2006-06-27	2006-06-27 00:00:00	38000275	0	\N	\N	183838	0	180256009	4107731	
19813	1716	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	114609	0	180256009	4107731	
31831	2801	4024289	1968-10-16	1968-10-16 00:00:00	38000275	0	\N	\N	185605	0	19490002	4024289	
20141	1743	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	116515	0	180256009	4107731	
20241	1753	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	117217	0	180256009	4107731	
32483	2858	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	189805	0	180256009	4107731	
32608	2863	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	190447	0	180256009	4107731	
44718	3916	4107731	1993-10-13	1993-10-13 00:00:00	38000275	0	\N	\N	260414	0	180256009	4107731	
32939	2891	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	192264	0	180256009	4107731	
21215	1843	4107731	1997-01-01	1997-01-01 00:00:00	38000275	0	\N	\N	123110	0	180256009	4107731	
21427	1852	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	123934	0	180256009	4107731	
45491	4014	4107731	2000-06-20	2000-06-20 00:00:00	38000275	0	\N	\N	266796	0	180256009	4107731	
21812	1892	4125906	1968-02-24	1968-02-24 00:00:00	38000275	0	\N	\N	126045	0	288086009	4125906	
33908	2957	4125906	1956-10-13	1956-10-13 00:00:00	38000275	0	\N	\N	197394	0	288086009	4125906	
34043	2965	4107731	1992-12-07	1992-12-07 00:00:00	38000275	0	\N	\N	197960	0	180256009	4107731	
22319	1956	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	130162	0	180256009	4107731	
22560	1975	4181917	1973-01-29	1973-01-29 00:00:00	38000275	0	\N	\N	131312	0	54550000	4181917	
22805	1982	4047491	1933-11-20	1933-11-20 00:00:00	38000275	0	\N	\N	131971	0	1225002	4047491	
34790	3025	4107731	1991-11-04	1991-11-04 00:00:00	38000275	0	\N	\N	201612	0	180256009	4107731	
47042	4130	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	274534	0	395142003	4191853	
35185	3064	4043071	1951-04-19	1951-04-19 00:00:00	38000275	0	\N	\N	203920	0	228557008	4043071	
35391	3096	4024289	1979-08-30	1979-08-30 00:00:00	38000275	0	\N	\N	206038	0	19490002	4024289	
23725	2070	4163872	2001-05-10	2001-05-10 00:00:00	38000275	0	\N	\N	137701	0	399208008	4163872	
23866	2077	4107731	1992-01-26	1992-01-26 00:00:00	38000275	0	\N	\N	138221	0	180256009	4107731	
12008	1099	4107731	1990-05-12	1990-05-12 00:00:00	38000275	0	\N	\N	72173	0	180256009	4107731	
24181	2119	4107731	1993-03-01	1993-03-01 00:00:00	38000275	0	\N	\N	141070	0	180256009	4107731	
12476	1124	4330583	1970-10-11	1970-10-11 00:00:00	38000275	0	\N	\N	74117	0	22523008	4330583	
24567	2151	4057420	1996-08-28	1996-08-28 00:00:00	38000275	0	\N	\N	143254	0	18286008	4057420	
24798	2168	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	144553	0	180256009	4107731	
13060	1176	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	77628	0	180256009	4107731	
25104	2186	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	145832	0	180256009	4107731	
25296	2200	4043071	1983-04-03	1983-04-03 00:00:00	38000275	0	\N	\N	146651	0	228557008	4043071	
25502	2218	4197460	1994-01-01	1994-01-01 00:00:00	38000275	0	\N	\N	147710	0	313191000	4197460	
25623	2238	4107731	1990-04-15	1990-04-15 00:00:00	38000275	0	\N	\N	149004	0	180256009	4107731	
13951	1261	4107731	1990-10-27	1990-10-27 00:00:00	38000275	0	\N	\N	83244	0	180256009	4107731	
14156	1276	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	84228	0	180256009	4107731	
26236	2290	4293740	1976-11-13	1976-11-13 00:00:00	38000275	0	\N	\N	152336	0	384700001	4293740	
14584	1306	4195803	2019-04-11	2019-04-11 00:00:00	38000275	0	\N	\N	86205	0	312681000	4195803	
26653	2334	4035793	2018-08-02	2018-08-02 00:00:00	38000275	0	\N	\N	155323	0	15081005	4035793	
14888	1322	4151422	1940-07-18	1940-07-18 00:00:00	38000275	0	\N	\N	87785	0	269911007	4151422	
26937	2352	4107731	1991-02-25	1991-02-25 00:00:00	38000275	0	\N	\N	156694	0	180256009	4107731	
15253	1365	4043071	1979-12-06	1979-12-06 00:00:00	38000275	0	\N	\N	90459	0	228557008	4043071	
27366	2392	4078793	2003-06-20	2003-06-20 00:00:00	38000275	0	\N	\N	158995	0	180325003	4078793	
15579	1384	4295880	2002-02-19	2002-02-19 00:00:00	38000275	0	\N	\N	91756	0	76601001	4295880	
27723	2428	4163872	1984-01-18	1984-01-18 00:00:00	38000275	0	\N	\N	161080	0	399208008	4163872	
16028	1399	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	93083	0	180256009	4107731	
16181	1407	4107731	1992-12-12	1992-12-12 00:00:00	38000275	0	\N	\N	93556	0	180256009	4107731	
28365	2518	4035793	2014-01-10	2014-01-10 00:00:00	38000275	0	\N	\N	166592	0	15081005	4035793	
28429	2534	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	167367	0	180256009	4107731	
28641	2542	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	168153	0	180256009	4107731	
28878	2554	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	169124	0	180256009	4107731	
17080	1476	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	98444	0	180256009	4107731	
17358	1497	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	99889	0	180256009	4107731	
17486	1508	4043071	1937-11-15	1937-11-15 00:00:00	38000275	0	\N	\N	100583	0	228557008	4043071	
17715	1517	4043071	1945-06-25	1945-06-25 00:00:00	38000275	0	\N	\N	101374	0	228557008	4043071	
29767	2647	4107731	1991-12-01	1991-12-01 00:00:00	38000275	0	\N	\N	175133	0	180256009	4107731	
18105	1550	4035793	2019-01-12	2019-01-12 00:00:00	38000275	0	\N	\N	103791	0	15081005	4035793	
30177	2672	4107731	1991-10-20	1991-10-20 00:00:00	38000275	0	\N	\N	176916	0	180256009	4107731	
30392	2682	4058899	2017-02-04	2017-02-04 00:00:00	38000275	0	\N	\N	177726	0	168594001	4058899	
18582	1577	4195803	1992-07-03	1992-07-03 00:00:00	38000275	0	\N	\N	105935	0	312681000	4195803	
18839	1611	4125906	1972-11-20	1972-11-20 00:00:00	38000275	0	\N	\N	108353	0	288086009	4125906	
19067	1636	4163872	1983-02-04	1983-02-04 00:00:00	38000275	0	\N	\N	109899	0	399208008	4163872	
31150	2765	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	182999	0	180256009	4107731	
19365	1657	4170947	2008-01-09	2008-01-09 00:00:00	38000275	0	\N	\N	111187	0	274474001	4170947	
31428	2776	4191853	2009-01-27	2009-01-27 00:00:00	38000275	0	\N	\N	183868	0	395142003	4191853	
19814	1716	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	114631	0	180256009	4107731	
31832	2801	4195803	2002-03-25	2002-03-25 00:00:00	38000275	0	\N	\N	185617	0	312681000	4195803	
20142	1743	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	116575	0	180256009	4107731	
20242	1753	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	117290	0	180256009	4107731	
32484	2858	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	189952	0	180256009	4107731	
32609	2863	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	190355	0	180256009	4107731	
44719	3916	4107731	1992-09-09	1992-09-09 00:00:00	38000275	0	\N	\N	260401	0	180256009	4107731	
32940	2891	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	192360	0	180256009	4107731	
21216	1843	4107731	1994-12-28	1994-12-28 00:00:00	38000275	0	\N	\N	123023	0	180256009	4107731	
21428	1852	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	123976	0	180256009	4107731	
45492	4014	4107731	1999-02-02	1999-02-02 00:00:00	38000275	0	\N	\N	266801	0	180256009	4107731	
21813	1892	4035793	2015-08-13	2015-08-13 00:00:00	38000275	0	\N	\N	126016	0	15081005	4035793	
33909	2957	4151422	1991-12-03	1991-12-03 00:00:00	38000275	0	\N	\N	197355	0	269911007	4151422	
34044	2965	4107731	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	197973	0	180256009	4107731	
22320	1956	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	130166	0	180256009	4107731	
22561	1975	4163872	1923-01-07	1923-01-07 00:00:00	38000275	0	\N	\N	131307	0	399208008	4163872	
22806	1982	4170947	1933-11-20	1933-11-20 00:00:00	38000275	0	\N	\N	131971	0	274474001	4170947	
34791	3025	4107731	1991-04-08	1991-04-08 00:00:00	38000275	0	\N	\N	201579	0	180256009	4107731	
47043	4130	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	274628	0	180256009	4107731	
35186	3064	4043071	1950-06-01	1950-06-01 00:00:00	38000275	0	\N	\N	203934	0	228557008	4043071	
35392	3096	4170947	1979-08-30	1979-08-30 00:00:00	38000275	0	\N	\N	206038	0	274474001	4170947	
23726	2070	4107731	1991-09-02	1991-09-02 00:00:00	38000275	0	\N	\N	137690	0	180256009	4107731	
23867	2077	4107731	1993-04-11	1993-04-11 00:00:00	38000275	0	\N	\N	138361	0	180256009	4107731	
12009	1099	4107731	1992-01-11	1992-01-11 00:00:00	38000275	0	\N	\N	72228	0	180256009	4107731	
24182	2119	4107731	1992-06-01	1992-06-01 00:00:00	38000275	0	\N	\N	141067	0	180256009	4107731	
12477	1124	4202451	1999-08-29	1999-08-29 00:00:00	38000275	0	\N	\N	74069	0	433112001	4202451	
24568	2151	4078793	1980-05-28	1980-05-28 00:00:00	38000275	0	\N	\N	143328	0	180325003	4078793	
24799	2168	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	144545	0	180256009	4107731	
13061	1176	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	77688	0	180256009	4107731	
25105	2186	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	145738	0	180256009	4107731	
25297	2200	4043071	1982-03-21	1982-03-21 00:00:00	38000275	0	\N	\N	146613	0	228557008	4043071	
25503	2218	4191853	1979-03-30	1979-03-30 00:00:00	38000275	0	\N	\N	147700	0	395142003	4191853	
25624	2238	4062501	1971-08-11	1971-08-11 00:00:00	38000275	0	\N	\N	148888	0	171231001	4062501	
13952	1261	4107731	1991-01-19	1991-01-19 00:00:00	38000275	0	\N	\N	83161	0	180256009	4107731	
14157	1276	4181917	1968-03-05	1968-03-05 00:00:00	38000275	0	\N	\N	84132	0	54550000	4181917	
26237	2290	4151422	1998-06-19	1998-06-19 00:00:00	38000275	0	\N	\N	152316	0	269911007	4151422	
14585	1306	4151422	1999-11-17	1999-11-17 00:00:00	38000275	0	\N	\N	86193	0	269911007	4151422	
26654	2334	4078793	2018-08-02	2018-08-02 00:00:00	38000275	0	\N	\N	155323	0	180325003	4078793	
14889	1322	4151422	1989-05-17	1989-05-17 00:00:00	38000275	0	\N	\N	87720	0	269911007	4151422	
26938	2352	4107731	1992-01-27	1992-01-27 00:00:00	38000275	0	\N	\N	156679	0	180256009	4107731	
15254	1365	4043071	1980-06-19	1980-06-19 00:00:00	38000275	0	\N	\N	90461	0	228557008	4043071	
27367	2392	4035793	2007-07-13	2007-07-13 00:00:00	38000275	0	\N	\N	159065	0	15081005	4035793	
15580	1384	4295880	2001-05-22	2001-05-22 00:00:00	38000275	0	\N	\N	91755	0	76601001	4295880	
27727	2431	4293740	1995-05-16	1995-05-16 00:00:00	38000275	0	\N	\N	161244	0	384700001	4293740	
16029	1399	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	93069	0	180256009	4107731	
16182	1407	4107731	1991-06-15	1991-06-15 00:00:00	38000275	0	\N	\N	93550	0	180256009	4107731	
28366	2518	4035793	2008-09-05	2008-09-05 00:00:00	38000275	0	\N	\N	166569	0	15081005	4035793	
28430	2534	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	167445	0	180256009	4107731	
28642	2542	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	168194	0	180256009	4107731	
28879	2554	4145310	2015-12-26	2015-12-26 00:00:00	38000275	0	\N	\N	169199	0	268425006	4145310	
17081	1476	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	98466	0	180256009	4107731	
17359	1497	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	99865	0	180256009	4107731	
17487	1508	4170947	2014-10-06	2014-10-06 00:00:00	38000275	0	\N	\N	100550	0	274474001	4170947	
17716	1517	4043071	1947-03-31	1947-03-31 00:00:00	38000275	0	\N	\N	101458	0	228557008	4043071	
29768	2647	4107731	1992-08-09	1992-08-09 00:00:00	38000275	0	\N	\N	175155	0	180256009	4107731	
18106	1550	4170947	1981-02-07	1981-02-07 00:00:00	38000275	0	\N	\N	103802	0	274474001	4170947	
30178	2672	4293740	1972-02-18	1972-02-18 00:00:00	38000275	0	\N	\N	176981	0	384700001	4293740	
30397	2684	4170947	2014-04-08	2014-04-08 00:00:00	38000275	0	\N	\N	177896	0	274474001	4170947	
18583	1578	4170947	2018-11-01	2018-11-01 00:00:00	38000275	0	\N	\N	105972	0	274474001	4170947	
18840	1612	4125906	1971-05-20	1971-05-20 00:00:00	38000275	0	\N	\N	108357	0	288086009	4125906	
19068	1636	4195803	2016-04-23	2016-04-23 00:00:00	38000275	0	\N	\N	109885	0	312681000	4195803	
31151	2765	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	182993	0	180256009	4107731	
19366	1657	4024289	2008-01-09	2008-01-09 00:00:00	38000275	0	\N	\N	111187	0	19490002	4024289	
31429	2776	4107731	2007-01-23	2007-01-23 00:00:00	38000275	0	\N	\N	183827	0	180256009	4107731	
19815	1716	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	114649	0	180256009	4107731	
31833	2801	4170947	2002-03-25	2002-03-25 00:00:00	38000275	0	\N	\N	185617	0	274474001	4170947	
20143	1743	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	116523	0	180256009	4107731	
20243	1753	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	117182	0	180256009	4107731	
32485	2858	4252419	1936-02-04	1936-02-04 00:00:00	38000275	0	\N	\N	189899	0	74016001	4252419	
32610	2863	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	190360	0	180256009	4107731	
44720	3916	4107731	1994-07-13	1994-07-13 00:00:00	38000275	0	\N	\N	260354	0	180256009	4107731	
32941	2891	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	192376	0	180256009	4107731	
21217	1843	4059978	2005-06-24	2005-06-24 00:00:00	38000275	0	\N	\N	123070	0	169553002	4059978	
21429	1852	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	123961	0	180256009	4107731	
45493	4014	4107731	1999-05-18	1999-05-18 00:00:00	38000275	0	\N	\N	266790	0	180256009	4107731	
21814	1892	4125906	1981-04-07	1981-04-07 00:00:00	38000275	0	\N	\N	126047	0	288086009	4125906	
33910	2957	4195803	2008-02-02	2008-02-02 00:00:00	38000275	0	\N	\N	197327	0	312681000	4195803	
34045	2965	4107731	1992-10-26	1992-10-26 00:00:00	38000275	0	\N	\N	197896	0	180256009	4107731	
22321	1956	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	130181	0	180256009	4107731	
22562	1975	4170947	1923-01-07	1923-01-07 00:00:00	38000275	0	\N	\N	131307	0	274474001	4170947	
22807	1982	4336464	2006-10-19	2006-10-19 00:00:00	38000275	0	\N	\N	131963	0	232717009	4336464	
34792	3025	4107731	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	201640	0	180256009	4107731	
47044	4130	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	274639	0	180256009	4107731	
35187	3064	4043071	1950-11-23	1950-11-23 00:00:00	38000275	0	\N	\N	203950	0	228557008	4043071	
35393	3096	4078793	2017-07-23	2017-07-23 00:00:00	38000275	0	\N	\N	206067	0	180325003	4078793	
23727	2070	4107731	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	137748	0	180256009	4107731	
23868	2077	4107731	1992-05-10	1992-05-10 00:00:00	38000275	0	\N	\N	138250	0	180256009	4107731	
12010	1099	4107731	1991-07-27	1991-07-27 00:00:00	38000275	0	\N	\N	72115	0	180256009	4107731	
24183	2119	4191853	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	141083	0	395142003	4191853	
12478	1124	4151422	1958-04-24	1958-04-24 00:00:00	38000275	0	\N	\N	74075	0	269911007	4151422	
24569	2151	4151422	1958-02-09	1958-02-09 00:00:00	38000275	0	\N	\N	143285	0	269911007	4151422	
24800	2168	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	144555	0	180256009	4107731	
13062	1176	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	77603	0	180256009	4107731	
25106	2186	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	145767	0	180256009	4107731	
25298	2200	4043071	1984-03-25	1984-03-25 00:00:00	38000275	0	\N	\N	146665	0	228557008	4043071	
25504	2218	4125906	1986-09-08	1986-09-08 00:00:00	38000275	0	\N	\N	147707	0	288086009	4125906	
25625	2238	4107731	1992-01-26	1992-01-26 00:00:00	38000275	0	\N	\N	148946	0	180256009	4107731	
13953	1261	4107731	1991-11-30	1991-11-30 00:00:00	38000275	0	\N	\N	83165	0	180256009	4107731	
14158	1276	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	84183	0	180256009	4107731	
26238	2290	4170947	1972-10-05	1972-10-05 00:00:00	38000275	0	\N	\N	152341	0	274474001	4170947	
14586	1306	4047491	1966-01-09	1966-01-09 00:00:00	38000275	0	\N	\N	86247	0	1225002	4047491	
26655	2334	4078793	2014-07-10	2014-07-10 00:00:00	38000275	0	\N	\N	155321	0	180325003	4078793	
14890	1322	4170947	1928-02-21	1928-02-21 00:00:00	38000275	0	\N	\N	87781	0	274474001	4170947	
26939	2352	4107731	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	156706	0	180256009	4107731	
15255	1365	4043071	1980-07-17	1980-07-17 00:00:00	38000275	0	\N	\N	90504	0	228557008	4043071	
27368	2392	4078793	2007-07-13	2007-07-13 00:00:00	38000275	0	\N	\N	159065	0	180325003	4078793	
15581	1384	4058899	1989-03-09	1989-03-09 00:00:00	38000275	0	\N	\N	91723	0	168594001	4058899	
27728	2431	4125906	1995-05-16	1995-05-16 00:00:00	38000275	0	\N	\N	161244	0	288086009	4125906	
16030	1399	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	93063	0	180256009	4107731	
16183	1407	4107731	1991-09-28	1991-09-28 00:00:00	38000275	0	\N	\N	93476	0	180256009	4107731	
28367	2518	4035793	2016-01-22	2016-01-22 00:00:00	38000275	0	\N	\N	166593	0	15081005	4035793	
28431	2534	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	167396	0	180256009	4107731	
28643	2542	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	168192	0	180256009	4107731	
28880	2554	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	169239	0	180256009	4107731	
17082	1476	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	98418	0	180256009	4107731	
17360	1497	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	99887	0	180256009	4107731	
17488	1508	4243062	2014-10-06	2014-10-06 00:00:00	38000275	0	\N	\N	100550	0	60027007	4243062	
17717	1517	4043071	1945-03-26	1945-03-26 00:00:00	38000275	0	\N	\N	101434	0	228557008	4043071	
29769	2647	4024289	1996-06-29	1996-06-29 00:00:00	38000275	0	\N	\N	175139	0	19490002	4024289	
18107	1550	4047491	1981-02-07	1981-02-07 00:00:00	38000275	0	\N	\N	103802	0	1225002	4047491	
30179	2672	4125906	1972-02-18	1972-02-18 00:00:00	38000275	0	\N	\N	176981	0	288086009	4125906	
30398	2684	4195803	2014-04-08	2014-04-08 00:00:00	38000275	0	\N	\N	177896	0	312681000	4195803	
18584	1578	4047491	2018-11-01	2018-11-01 00:00:00	38000275	0	\N	\N	105972	0	1225002	4047491	
18841	1612	4151422	1965-09-19	1965-09-19 00:00:00	38000275	0	\N	\N	108380	0	269911007	4151422	
19069	1636	4170947	2016-04-23	2016-04-23 00:00:00	38000275	0	\N	\N	109885	0	274474001	4170947	
31152	2765	4125906	1952-12-11	1952-12-11 00:00:00	38000275	0	\N	\N	182888	0	288086009	4125906	
19367	1657	4195803	2008-01-09	2008-01-09 00:00:00	38000275	0	\N	\N	111187	0	312681000	4195803	
31430	2776	4107731	2006-10-10	2006-10-10 00:00:00	38000275	0	\N	\N	183773	0	180256009	4107731	
19816	1716	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	114611	0	180256009	4107731	
31834	2801	4024289	2002-03-25	2002-03-25 00:00:00	38000275	0	\N	\N	185617	0	19490002	4024289	
20144	1743	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	116526	0	180256009	4107731	
20244	1753	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	117246	0	180256009	4107731	
32486	2858	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	189953	0	180256009	4107731	
32611	2863	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	190430	0	180256009	4107731	
44721	3916	4107731	1994-03-30	1994-03-30 00:00:00	38000275	0	\N	\N	260319	0	180256009	4107731	
32942	2891	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	192378	0	180256009	4107731	
21218	1843	4107731	1996-02-21	1996-02-21 00:00:00	38000275	0	\N	\N	123106	0	180256009	4107731	
21430	1852	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	123890	0	180256009	4107731	
45494	4014	4107731	2000-04-18	2000-04-18 00:00:00	38000275	0	\N	\N	266702	0	180256009	4107731	
21815	1892	4035793	2017-08-24	2017-08-24 00:00:00	38000275	0	\N	\N	126006	0	15081005	4035793	
33919	2959	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	197575	0	395142003	4191853	
34046	2965	4107731	1992-06-22	1992-06-22 00:00:00	38000275	0	\N	\N	197938	0	180256009	4107731	
22322	1956	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	130165	0	180256009	4107731	
22563	1975	4243062	1928-08-22	1928-08-22 00:00:00	38000275	0	\N	\N	131309	0	60027007	4243062	
22808	1982	4216130	2006-10-19	2006-10-19 00:00:00	38000275	0	\N	\N	131963	0	415070008	4216130	
34793	3025	4107731	1992-06-01	1992-06-01 00:00:00	38000275	0	\N	\N	201709	0	180256009	4107731	
47045	4130	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	274634	0	180256009	4107731	
35188	3064	4043071	1950-04-27	1950-04-27 00:00:00	38000275	0	\N	\N	203955	0	228557008	4043071	
35394	3096	4170947	2016-04-08	2016-04-08 00:00:00	38000275	0	\N	\N	206080	0	274474001	4170947	
23728	2070	4107731	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	137684	0	180256009	4107731	
23869	2077	4107731	1990-07-29	1990-07-29 00:00:00	38000275	0	\N	\N	138338	0	180256009	4107731	
12011	1099	4107731	1990-03-10	1990-03-10 00:00:00	38000275	0	\N	\N	72110	0	180256009	4107731	
24184	2119	4191853	1990-01-01	1990-01-01 00:00:00	38000275	0	\N	\N	140966	0	395142003	4191853	
12479	1125	4170947	2014-07-30	2014-07-30 00:00:00	38000275	0	\N	\N	74138	0	274474001	4170947	
24570	2151	4078793	1983-06-15	1983-06-15 00:00:00	38000275	0	\N	\N	143337	0	180325003	4078793	
24801	2168	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	144568	0	180256009	4107731	
13063	1176	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	77605	0	180256009	4107731	
25107	2186	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	145809	0	180256009	4107731	
25299	2200	4043071	1985-03-03	1985-03-03 00:00:00	38000275	0	\N	\N	146637	0	228557008	4043071	
25505	2220	4151422	1980-08-24	1980-08-24 00:00:00	38000275	0	\N	\N	147770	0	269911007	4151422	
25626	2238	4107731	1993-03-21	1993-03-21 00:00:00	38000275	0	\N	\N	148923	0	180256009	4107731	
13954	1261	4107731	1992-04-25	1992-04-25 00:00:00	38000275	0	\N	\N	83193	0	180256009	4107731	
14159	1276	4125906	1992-02-03	1992-02-03 00:00:00	38000275	0	\N	\N	84133	0	288086009	4125906	
26239	2290	4047491	1972-10-05	1972-10-05 00:00:00	38000275	0	\N	\N	152341	0	1225002	4047491	
26412	2297	4170947	1978-06-12	1978-06-12 00:00:00	38000275	0	\N	\N	152928	0	274474001	4170947	
26656	2334	4125906	1977-06-21	1977-06-21 00:00:00	38000275	0	\N	\N	155343	0	288086009	4125906	
14891	1322	4047491	1928-02-21	1928-02-21 00:00:00	38000275	0	\N	\N	87781	0	1225002	4047491	
26940	2352	4107731	1993-01-18	1993-01-18 00:00:00	38000275	0	\N	\N	156633	0	180256009	4107731	
15256	1365	4170947	1974-02-25	1974-02-25 00:00:00	38000275	0	\N	\N	90455	0	274474001	4170947	
27369	2392	4035793	2014-10-10	2014-10-10 00:00:00	38000275	0	\N	\N	158976	0	15081005	4035793	
15582	1385	4037675	2007-05-02	2007-05-02 00:00:00	38000275	0	\N	\N	91820	0	162676008	4037675	
27729	2431	4058899	1975-06-30	1975-06-30 00:00:00	38000275	0	\N	\N	161243	0	168594001	4058899	
16031	1399	4163872	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	93111	0	399208008	4163872	
16184	1407	4107731	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	93467	0	180256009	4107731	
28368	2518	4035793	2011-12-30	2011-12-30 00:00:00	38000275	0	\N	\N	166571	0	15081005	4035793	
28432	2534	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	167436	0	180256009	4107731	
28644	2542	4170947	1978-05-12	1978-05-12 00:00:00	38000275	0	\N	\N	168090	0	274474001	4170947	
28881	2554	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	169246	0	180256009	4107731	
17083	1476	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	98383	0	395142003	4191853	
17361	1497	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	99852	0	180256009	4107731	
17489	1508	4043071	1937-05-03	1937-05-03 00:00:00	38000275	0	\N	\N	100581	0	228557008	4043071	
17718	1517	4252419	1998-04-29	1998-04-29 00:00:00	38000275	0	\N	\N	101447	0	74016001	4252419	
29770	2647	4170947	1996-06-29	1996-06-29 00:00:00	38000275	0	\N	\N	175139	0	274474001	4170947	
18108	1551	4125906	2008-09-20	2008-09-20 00:00:00	38000275	0	\N	\N	103886	0	288086009	4125906	
30180	2672	4107731	1991-02-10	1991-02-10 00:00:00	38000275	0	\N	\N	177005	0	180256009	4107731	
30399	2684	4243062	2014-04-08	2014-04-08 00:00:00	38000275	0	\N	\N	177896	0	60027007	4243062	
18585	1578	4195803	2018-11-01	2018-11-01 00:00:00	38000275	0	\N	\N	105972	0	312681000	4195803	
18842	1612	4202451	2014-04-16	2014-04-16 00:00:00	38000275	0	\N	\N	108401	0	433112001	4202451	
19070	1636	4047491	2016-04-23	2016-04-23 00:00:00	38000275	0	\N	\N	109885	0	1225002	4047491	
31153	2765	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	182921	0	180256009	4107731	
19368	1657	4195803	2013-01-12	2013-01-12 00:00:00	38000275	0	\N	\N	111189	0	312681000	4195803	
31431	2776	4125906	2013-02-23	2013-02-23 00:00:00	38000275	0	\N	\N	183859	0	288086009	4125906	
19817	1716	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	114761	0	395142003	4191853	
31835	2801	4170947	1984-03-01	1984-03-01 00:00:00	38000275	0	\N	\N	185615	0	274474001	4170947	
20145	1743	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	116491	0	180256009	4107731	
20245	1753	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	117235	0	180256009	4107731	
32487	2858	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	189807	0	180256009	4107731	
32612	2863	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	190440	0	180256009	4107731	
44722	3916	4107731	1992-03-04	1992-03-04 00:00:00	38000275	0	\N	\N	260261	0	180256009	4107731	
32943	2891	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	192262	0	180256009	4107731	
21219	1843	4107731	1996-06-05	1996-06-05 00:00:00	38000275	0	\N	\N	123052	0	180256009	4107731	
21431	1852	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	123903	0	180256009	4107731	
45495	4014	4107731	1998-06-16	1998-06-16 00:00:00	38000275	0	\N	\N	266799	0	180256009	4107731	
21816	1892	4035793	2018-08-30	2018-08-30 00:00:00	38000275	0	\N	\N	126023	0	15081005	4035793	
33920	2959	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	197511	0	180256009	4107731	
34047	2965	4107731	1991-11-25	1991-11-25 00:00:00	38000275	0	\N	\N	197950	0	180256009	4107731	
22323	1956	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	130135	0	180256009	4107731	
22564	1975	4170947	1928-08-22	1928-08-22 00:00:00	38000275	0	\N	\N	131309	0	274474001	4170947	
22809	1982	4125906	1983-10-02	1983-10-02 00:00:00	38000275	0	\N	\N	131976	0	288086009	4125906	
34794	3025	4107731	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	201589	0	180256009	4107731	
47046	4130	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	274540	0	180256009	4107731	
35189	3064	4125906	1962-05-24	1962-05-24 00:00:00	38000275	0	\N	\N	203997	0	288086009	4125906	
35395	3096	4195803	2016-04-08	2016-04-08 00:00:00	38000275	0	\N	\N	206080	0	312681000	4195803	
23729	2070	4107731	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	137710	0	180256009	4107731	
23870	2077	4107731	1993-01-17	1993-01-17 00:00:00	38000275	0	\N	\N	138359	0	180256009	4107731	
12012	1099	4107731	1991-10-19	1991-10-19 00:00:00	38000275	0	\N	\N	72238	0	180256009	4107731	
24185	2119	4107731	1992-12-07	1992-12-07 00:00:00	38000275	0	\N	\N	141010	0	180256009	4107731	
12480	1125	4195803	2014-07-30	2014-07-30 00:00:00	38000275	0	\N	\N	74138	0	312681000	4195803	
24571	2151	4078793	1986-07-02	1986-07-02 00:00:00	38000275	0	\N	\N	143293	0	180325003	4078793	
24802	2168	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	144524	0	180256009	4107731	
13064	1176	4197460	1981-09-13	1981-09-13 00:00:00	38000275	0	\N	\N	77645	0	313191000	4197460	
25108	2186	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	145818	0	395142003	4191853	
25300	2200	4043071	1981-12-13	1981-12-13 00:00:00	38000275	0	\N	\N	146648	0	228557008	4043071	
25506	2220	4170947	2005-02-04	2005-02-04 00:00:00	38000275	0	\N	\N	147792	0	274474001	4170947	
25632	2240	4043071	1965-08-04	1965-08-04 00:00:00	38000275	0	\N	\N	149167	0	228557008	4043071	
13955	1261	4107731	1991-07-27	1991-07-27 00:00:00	38000275	0	\N	\N	83190	0	180256009	4107731	
14160	1276	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	84258	0	180256009	4107731	
26240	2290	4125906	1999-08-13	1999-08-13 00:00:00	38000275	0	\N	\N	152339	0	288086009	4125906	
26413	2297	4024289	1978-06-12	1978-06-12 00:00:00	38000275	0	\N	\N	152928	0	19490002	4024289	
26657	2334	4057420	2011-06-23	2011-06-23 00:00:00	38000275	0	\N	\N	155281	0	18286008	4057420	
14892	1322	4151422	2007-06-20	2007-06-20 00:00:00	38000275	0	\N	\N	87744	0	269911007	4151422	
26941	2352	4107731	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	156715	0	180256009	4107731	
15257	1365	4163872	1974-02-25	1974-02-25 00:00:00	38000275	0	\N	\N	90455	0	399208008	4163872	
27370	2392	4078793	2014-10-10	2014-10-10 00:00:00	38000275	0	\N	\N	158976	0	180325003	4078793	
15583	1385	4187458	2007-05-02	2007-05-02 00:00:00	38000275	0	\N	\N	91820	0	415300000	4187458	
27732	2433	4024289	1966-09-21	1966-09-21 00:00:00	38000275	0	\N	\N	161343	0	19490002	4024289	
16032	1399	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	93108	0	180256009	4107731	
16185	1407	4107731	1990-06-02	1990-06-02 00:00:00	38000275	0	\N	\N	93582	0	180256009	4107731	
28369	2518	4035793	2017-01-27	2017-01-27 00:00:00	38000275	0	\N	\N	166527	0	15081005	4035793	
28433	2534	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	167399	0	180256009	4107731	
28645	2542	4047491	1978-05-12	1978-05-12 00:00:00	38000275	0	\N	\N	168090	0	1225002	4047491	
28882	2554	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	169237	0	180256009	4107731	
17084	1476	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	98378	0	180256009	4107731	
17362	1497	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	99864	0	180256009	4107731	
17490	1508	4043071	1938-02-28	1938-02-28 00:00:00	38000275	0	\N	\N	100645	0	228557008	4043071	
17719	1517	4043071	1947-06-02	1947-06-02 00:00:00	38000275	0	\N	\N	101452	0	228557008	4043071	
29771	2647	4107731	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	175099	0	180256009	4107731	
18109	1551	4293740	2008-09-20	2008-09-20 00:00:00	38000275	0	\N	\N	103886	0	384700001	4293740	
30181	2672	4107731	1992-02-02	1992-02-02 00:00:00	38000275	0	\N	\N	177010	0	180256009	4107731	
30400	2684	4057420	1967-05-21	1967-05-21 00:00:00	38000275	0	\N	\N	177845	0	18286008	4057420	
18586	1578	4151422	1948-02-02	1948-02-02 00:00:00	38000275	0	\N	\N	105973	0	269911007	4151422	
18843	1612	4125906	1976-02-06	1976-02-06 00:00:00	38000275	0	\N	\N	108358	0	288086009	4125906	
19071	1636	4170947	2012-01-15	2012-01-15 00:00:00	38000275	0	\N	\N	109884	0	274474001	4170947	
31154	2765	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	182947	0	180256009	4107731	
19369	1657	4058899	2013-01-12	2013-01-12 00:00:00	38000275	0	\N	\N	111189	0	168594001	4058899	
31432	2776	4107731	2008-11-04	2008-11-04 00:00:00	38000275	0	\N	\N	183866	0	180256009	4107731	
19818	1716	4125906	1971-08-31	1971-08-31 00:00:00	38000275	0	\N	\N	114703	0	288086009	4125906	
31836	2801	4195803	1984-03-01	1984-03-01 00:00:00	38000275	0	\N	\N	185615	0	312681000	4195803	
20146	1743	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	116588	0	180256009	4107731	
20246	1753	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	117236	0	180256009	4107731	
32488	2858	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	189806	0	180256009	4107731	
32613	2863	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	190351	0	180256009	4107731	
44723	3916	4295880	1998-12-23	1998-12-23 00:00:00	38000275	0	\N	\N	260398	0	76601001	4295880	
32944	2891	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	192263	0	180256009	4107731	
21220	1843	4107731	1997-11-12	1997-11-12 00:00:00	38000275	0	\N	\N	123066	0	180256009	4107731	
21432	1852	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	123986	0	395142003	4191853	
45496	4014	4107731	1998-11-10	1998-11-10 00:00:00	38000275	0	\N	\N	266789	0	180256009	4107731	
33675	2935	4125906	2018-06-08	2018-06-08 00:00:00	38000275	0	\N	\N	195682	0	288086009	4125906	
33921	2959	4043071	1980-10-08	1980-10-08 00:00:00	38000275	0	\N	\N	197488	0	228557008	4043071	
34048	2965	4107731	1991-01-14	1991-01-14 00:00:00	38000275	0	\N	\N	197946	0	180256009	4107731	
22324	1956	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	130164	0	180256009	4107731	
22565	1976	4295880	2001-03-12	2001-03-12 00:00:00	38000275	0	\N	\N	131387	0	76601001	4295880	
22810	1982	4252419	1957-05-18	1957-05-18 00:00:00	38000275	0	\N	\N	131972	0	74016001	4252419	
34795	3025	4107731	1993-02-08	1993-02-08 00:00:00	38000275	0	\N	\N	201639	0	180256009	4107731	
47047	4130	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	274582	0	180256009	4107731	
35190	3064	4043071	1951-05-17	1951-05-17 00:00:00	38000275	0	\N	\N	203963	0	228557008	4043071	
35396	3096	4047491	2016-04-08	2016-04-08 00:00:00	38000275	0	\N	\N	206080	0	1225002	4047491	
23730	2070	4107731	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	137685	0	180256009	4107731	
23871	2077	4107731	1991-06-09	1991-06-09 00:00:00	38000275	0	\N	\N	138342	0	180256009	4107731	
12013	1099	4107731	1990-09-15	1990-09-15 00:00:00	38000275	0	\N	\N	72176	0	180256009	4107731	
24186	2119	4107731	1990-01-22	1990-01-22 00:00:00	38000275	0	\N	\N	141003	0	180256009	4107731	
12481	1125	4047491	2014-07-30	2014-07-30 00:00:00	38000275	0	\N	\N	74138	0	1225002	4047491	
24572	2151	4057420	1994-08-17	1994-08-17 00:00:00	38000275	0	\N	\N	143294	0	18286008	4057420	
24806	2172	4151422	2016-01-19	2016-01-19 00:00:00	38000275	0	\N	\N	144663	0	269911007	4151422	
13065	1176	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	77631	0	180256009	4107731	
25109	2186	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	145837	0	180256009	4107731	
25301	2200	4043071	1983-07-31	1983-07-31 00:00:00	38000275	0	\N	\N	146653	0	228557008	4043071	
25507	2220	4024289	2005-02-04	2005-02-04 00:00:00	38000275	0	\N	\N	147792	0	19490002	4024289	
25633	2240	4043071	1965-06-30	1965-06-30 00:00:00	38000275	0	\N	\N	149166	0	228557008	4043071	
13956	1261	4107731	1991-12-21	1991-12-21 00:00:00	38000275	0	\N	\N	83178	0	180256009	4107731	
14161	1276	4163872	1976-09-15	1976-09-15 00:00:00	38000275	0	\N	\N	84140	0	399208008	4163872	
26241	2290	4170947	1969-01-24	1969-01-24 00:00:00	38000275	0	\N	\N	152340	0	274474001	4170947	
26414	2298	4151422	1978-02-21	1978-02-21 00:00:00	38000275	0	\N	\N	152984	0	269911007	4151422	
26658	2334	4202451	2016-11-17	2016-11-17 00:00:00	38000275	0	\N	\N	155347	0	433112001	4202451	
14893	1322	4202451	2019-01-30	2019-01-30 00:00:00	38000275	0	\N	\N	87724	0	433112001	4202451	
26942	2352	4107731	1991-04-08	1991-04-08 00:00:00	38000275	0	\N	\N	156695	0	180256009	4107731	
15258	1365	4043071	1980-01-10	1980-01-10 00:00:00	38000275	0	\N	\N	90460	0	228557008	4043071	
27371	2392	4035793	1996-05-10	1996-05-10 00:00:00	38000275	0	\N	\N	159063	0	15081005	4035793	
15584	1385	4326177	2007-05-02	2007-05-02 00:00:00	38000275	0	\N	\N	91820	0	430193006	4326177	
27733	2433	4170947	1966-09-21	1966-09-21 00:00:00	38000275	0	\N	\N	161343	0	274474001	4170947	
16033	1399	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	93082	0	180256009	4107731	
16186	1407	4107731	1991-05-25	1991-05-25 00:00:00	38000275	0	\N	\N	93587	0	180256009	4107731	
28370	2518	4035793	2010-09-17	2010-09-17 00:00:00	38000275	0	\N	\N	166570	0	15081005	4035793	
28434	2534	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	167442	0	180256009	4107731	
28646	2542	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	168130	0	180256009	4107731	
28883	2554	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	169249	0	180256009	4107731	
17085	1476	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	98393	0	180256009	4107731	
17363	1497	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	99816	0	180256009	4107731	
17491	1508	4043071	1938-08-01	1938-08-01 00:00:00	38000275	0	\N	\N	100646	0	228557008	4043071	
17720	1517	4043071	1946-08-05	1946-08-05 00:00:00	38000275	0	\N	\N	101424	0	228557008	4043071	
29772	2647	4107731	1993-05-09	1993-05-09 00:00:00	38000275	0	\N	\N	175158	0	180256009	4107731	
18110	1551	4125906	1982-10-02	1982-10-02 00:00:00	38000275	0	\N	\N	103884	0	288086009	4125906	
30182	2672	4107731	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	176956	0	180256009	4107731	
30401	2684	40492359	1967-05-21	1967-05-21 00:00:00	38000275	0	\N	\N	177845	0	447365002	40492359	
18587	1578	4125906	2017-10-16	2017-10-16 00:00:00	38000275	0	\N	\N	105971	0	288086009	4125906	
18844	1612	4062501	1966-08-06	1966-08-06 00:00:00	38000275	0	\N	\N	108381	0	171231001	4062501	
19072	1636	4024289	2012-01-15	2012-01-15 00:00:00	38000275	0	\N	\N	109884	0	19490002	4024289	
31155	2765	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	182901	0	180256009	4107731	
19370	1657	4125906	2014-02-06	2014-02-06 00:00:00	38000275	0	\N	\N	111190	0	288086009	4125906	
31433	2776	4107731	2007-07-31	2007-07-31 00:00:00	38000275	0	\N	\N	183828	0	180256009	4107731	
19819	1716	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	114767	0	180256009	4107731	
31837	2801	4024289	1984-03-01	1984-03-01 00:00:00	38000275	0	\N	\N	185615	0	19490002	4024289	
20147	1743	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	116571	0	180256009	4107731	
20247	1753	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	117196	0	180256009	4107731	
32489	2858	4243062	1912-03-11	1912-03-11 00:00:00	38000275	0	\N	\N	189897	0	60027007	4243062	
32614	2863	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	190325	0	180256009	4107731	
44724	3916	4295880	1995-09-27	1995-09-27 00:00:00	38000275	0	\N	\N	260321	0	76601001	4295880	
32945	2891	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	192351	0	180256009	4107731	
21221	1843	4107731	1996-01-31	1996-01-31 00:00:00	38000275	0	\N	\N	123113	0	180256009	4107731	
21433	1852	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	123901	0	180256009	4107731	
45497	4014	4107731	1998-10-20	1998-10-20 00:00:00	38000275	0	\N	\N	266774	0	180256009	4107731	
33676	2935	4058899	1984-12-21	1984-12-21 00:00:00	38000275	0	\N	\N	195678	0	168594001	4058899	
33922	2959	4043071	1980-01-09	1980-01-09 00:00:00	38000275	0	\N	\N	197485	0	228557008	4043071	
34049	2965	4107731	1991-08-12	1991-08-12 00:00:00	38000275	0	\N	\N	197908	0	180256009	4107731	
22325	1956	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	130134	0	180256009	4107731	
22566	1976	4295880	1997-06-16	1997-06-16 00:00:00	38000275	0	\N	\N	131422	0	76601001	4295880	
22811	1982	44783196	1957-05-25	1957-05-25 00:00:00	38000275	0	\N	\N	131970	0	699253003	44783196	
34796	3025	4107731	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	201591	0	180256009	4107731	
47048	4130	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	274547	0	180256009	4107731	
35191	3064	4043071	1950-02-23	1950-02-23 00:00:00	38000275	0	\N	\N	203947	0	228557008	4043071	
35398	3098	4195803	2019-06-23	2019-06-23 00:00:00	38000275	0	\N	\N	206195	0	312681000	4195803	
23731	2070	4107731	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	137732	0	180256009	4107731	
23872	2077	4107731	1992-09-13	1992-09-13 00:00:00	38000275	0	\N	\N	138223	0	180256009	4107731	
12014	1099	4125906	2018-10-24	2018-10-24 00:00:00	38000275	0	\N	\N	72161	0	288086009	4125906	
24187	2119	4125906	2018-12-13	2018-12-13 00:00:00	38000275	0	\N	\N	140977	0	288086009	4125906	
12482	1125	4163872	1959-11-20	1959-11-20 00:00:00	38000275	0	\N	\N	74202	0	399208008	4163872	
24573	2151	4078793	1975-04-30	1975-04-30 00:00:00	38000275	0	\N	\N	143273	0	180325003	4078793	
24807	2172	4170947	2007-07-07	2007-07-07 00:00:00	38000275	0	\N	\N	144702	0	274474001	4170947	
13066	1176	4058899	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	77646	0	168594001	4058899	
25110	2186	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	145798	0	180256009	4107731	
25302	2200	4043071	1982-06-27	1982-06-27 00:00:00	38000275	0	\N	\N	146649	0	228557008	4043071	
25508	2220	4195803	2005-02-04	2005-02-04 00:00:00	38000275	0	\N	\N	147792	0	312681000	4195803	
25634	2240	4043071	1965-05-26	1965-05-26 00:00:00	38000275	0	\N	\N	149139	0	228557008	4043071	
13957	1261	4107731	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	83210	0	180256009	4107731	
14162	1276	4197460	1958-05-02	1958-05-02 00:00:00	38000275	0	\N	\N	84131	0	313191000	4197460	
26242	2290	4024289	1969-01-24	1969-01-24 00:00:00	38000275	0	\N	\N	152340	0	19490002	4024289	
26415	2298	4125906	2008-06-30	2008-06-30 00:00:00	38000275	0	\N	\N	153017	0	288086009	4125906	
26659	2334	4078793	2015-07-16	2015-07-16 00:00:00	38000275	0	\N	\N	155365	0	180325003	4078793	
14894	1322	4125906	1963-05-09	1963-05-09 00:00:00	38000275	0	\N	\N	87783	0	288086009	4125906	
26943	2352	4181917	1970-10-26	1970-10-26 00:00:00	38000275	0	\N	\N	156656	0	54550000	4181917	
15259	1365	4043071	1978-12-14	1978-12-14 00:00:00	38000275	0	\N	\N	90420	0	228557008	4043071	
27372	2392	4035793	1995-05-05	1995-05-05 00:00:00	38000275	0	\N	\N	158970	0	15081005	4035793	
15619	1387	4186930	1988-03-29	1988-03-29 00:00:00	38000275	0	\N	\N	92048	0	46706006	4186930	
27734	2433	4125906	1955-01-01	1955-01-01 00:00:00	38000275	0	\N	\N	161342	0	288086009	4125906	
16034	1399	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	92999	0	180256009	4107731	
16187	1407	4107731	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	93585	0	180256009	4107731	
28371	2518	4035793	2013-01-04	2013-01-04 00:00:00	38000275	0	\N	\N	166575	0	15081005	4035793	
28435	2534	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	167397	0	180256009	4107731	
28647	2542	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	168175	0	180256009	4107731	
28884	2554	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	169229	0	180256009	4107731	
17086	1476	4125906	1957-10-27	1957-10-27 00:00:00	38000275	0	\N	\N	98493	0	288086009	4125906	
17364	1497	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	99813	0	180256009	4107731	
17492	1508	4043071	1938-04-04	1938-04-04 00:00:00	38000275	0	\N	\N	100570	0	228557008	4043071	
17721	1517	4181917	1949-10-29	1949-10-29 00:00:00	38000275	0	\N	\N	101446	0	54550000	4181917	
29773	2647	4107731	1990-06-03	1990-06-03 00:00:00	38000275	0	\N	\N	175115	0	180256009	4107731	
18111	1551	4163872	1979-08-19	1979-08-19 00:00:00	38000275	0	\N	\N	103883	0	399208008	4163872	
30183	2672	4107731	1993-01-24	1993-01-24 00:00:00	38000275	0	\N	\N	176888	0	180256009	4107731	
30402	2685	4035793	1999-02-18	1999-02-18 00:00:00	38000275	0	\N	\N	177902	0	15081005	4035793	
18588	1578	4293740	2017-10-16	2017-10-16 00:00:00	38000275	0	\N	\N	105971	0	384700001	4293740	
18845	1613	4238715	1978-08-05	1978-08-05 00:00:00	38000275	0	\N	\N	108450	0	68254000	4238715	
19073	1636	4195803	2012-01-15	2012-01-15 00:00:00	38000275	0	\N	\N	109884	0	312681000	4195803	
31156	2765	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	182933	0	180256009	4107731	
19371	1657	4057420	1998-04-22	1998-04-22 00:00:00	38000275	0	\N	\N	111186	0	18286008	4057420	
31434	2777	4163872	2000-08-30	2000-08-30 00:00:00	38000275	0	\N	\N	183968	0	399208008	4163872	
19820	1716	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	114630	0	180256009	4107731	
31838	2801	4163872	1971-02-17	1971-02-17 00:00:00	38000275	0	\N	\N	185657	0	399208008	4163872	
20148	1743	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	116577	0	180256009	4107731	
20248	1753	4238715	1989-12-14	1989-12-14 00:00:00	38000275	0	\N	\N	117254	0	68254000	4238715	
32490	2858	4170947	1912-03-11	1912-03-11 00:00:00	38000275	0	\N	\N	189897	0	274474001	4170947	
32615	2863	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	190361	0	180256009	4107731	
44725	3916	4107731	1992-07-08	1992-07-08 00:00:00	38000275	0	\N	\N	260269	0	180256009	4107731	
32946	2891	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	192365	0	180256009	4107731	
21222	1843	4107731	1995-09-27	1995-09-27 00:00:00	38000275	0	\N	\N	123026	0	180256009	4107731	
21434	1852	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	123895	0	180256009	4107731	
45498	4014	4107731	1998-03-24	1998-03-24 00:00:00	38000275	0	\N	\N	266696	0	180256009	4107731	
33677	2935	4125906	1987-01-10	1987-01-10 00:00:00	38000275	0	\N	\N	195679	0	288086009	4125906	
33923	2959	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	197513	0	180256009	4107731	
34050	2965	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	198012	0	180256009	4107731	
22326	1956	4163872	2016-01-07	2016-01-07 00:00:00	38000275	0	\N	\N	130127	0	399208008	4163872	
22567	1976	4295880	1997-12-15	1997-12-15 00:00:00	38000275	0	\N	\N	131383	0	76601001	4295880	
22812	1982	4330583	1956-08-23	1956-08-23 00:00:00	38000275	0	\N	\N	132037	0	22523008	4330583	
34797	3025	4107731	1991-11-25	1991-11-25 00:00:00	38000275	0	\N	\N	201581	0	180256009	4107731	
47049	4130	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	274606	0	180256009	4107731	
35192	3064	4043071	1950-10-19	1950-10-19 00:00:00	38000275	0	\N	\N	203949	0	228557008	4043071	
35399	3098	4170947	2019-06-23	2019-06-23 00:00:00	38000275	0	\N	\N	206195	0	274474001	4170947	
23732	2070	4107731	1992-12-28	1992-12-28 00:00:00	38000275	0	\N	\N	137717	0	180256009	4107731	
23873	2077	4107731	1991-04-28	1991-04-28 00:00:00	38000275	0	\N	\N	138341	0	180256009	4107731	
12015	1099	4107731	1991-05-04	1991-05-04 00:00:00	38000275	0	\N	\N	72178	0	180256009	4107731	
24188	2119	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	141082	0	180256009	4107731	
12483	1125	4170947	1967-01-08	1967-01-08 00:00:00	38000275	0	\N	\N	74137	0	274474001	4170947	
24574	2151	4078793	1993-08-11	1993-08-11 00:00:00	38000275	0	\N	\N	143279	0	180325003	4078793	
24808	2172	4047491	2007-07-07	2007-07-07 00:00:00	38000275	0	\N	\N	144702	0	1225002	4047491	
13067	1176	4197460	1999-11-13	1999-11-13 00:00:00	38000275	0	\N	\N	77647	0	313191000	4197460	
25111	2186	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	145732	0	180256009	4107731	
25303	2200	4043071	1980-10-19	1980-10-19 00:00:00	38000275	0	\N	\N	146629	0	228557008	4043071	
25509	2222	4125906	2014-02-16	2014-02-16 00:00:00	38000275	0	\N	\N	147958	0	288086009	4125906	
25635	2240	4170947	1987-07-01	1987-07-01 00:00:00	38000275	0	\N	\N	149136	0	274474001	4170947	
13958	1261	4151422	2006-11-06	2006-11-06 00:00:00	38000275	0	\N	\N	83143	0	269911007	4151422	
14163	1276	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	84280	0	180256009	4107731	
26243	2290	4058899	1988-02-28	1988-02-28 00:00:00	38000275	0	\N	\N	152337	0	168594001	4058899	
26416	2298	4125906	1973-04-16	1973-04-16 00:00:00	38000275	0	\N	\N	153015	0	288086009	4125906	
26660	2334	4202451	2015-08-27	2015-08-27 00:00:00	38000275	0	\N	\N	155365	0	433112001	4202451	
14895	1322	4125906	1996-12-02	1996-12-02 00:00:00	38000275	0	\N	\N	87739	0	288086009	4125906	
26944	2352	4107731	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	156721	0	180256009	4107731	
15260	1365	4043071	1980-09-11	1980-09-11 00:00:00	38000275	0	\N	\N	90481	0	228557008	4043071	
27373	2392	4125906	1926-05-12	1926-05-12 00:00:00	38000275	0	\N	\N	159008	0	288086009	4125906	
15620	1387	4043071	1986-10-26	1986-10-26 00:00:00	38000275	0	\N	\N	91961	0	228557008	4043071	
27735	2433	4058899	1986-02-27	1986-02-27 00:00:00	38000275	0	\N	\N	161346	0	168594001	4058899	
16035	1399	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	93012	0	395142003	4191853	
16188	1407	4107731	1993-01-23	1993-01-23 00:00:00	38000275	0	\N	\N	93557	0	180256009	4107731	
28372	2518	4337138	2010-11-12	2010-11-12 00:00:00	38000275	0	\N	\N	166577	0	88039007	4337138	
28436	2534	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	167438	0	180256009	4107731	
28648	2542	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	168164	0	180256009	4107731	
28885	2554	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	169238	0	180256009	4107731	
17087	1476	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	98387	0	180256009	4107731	
17365	1497	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	99881	0	180256009	4107731	
17493	1508	4043071	1938-05-02	1938-05-02 00:00:00	38000275	0	\N	\N	100636	0	228557008	4043071	
17722	1517	4043071	1945-10-22	1945-10-22 00:00:00	38000275	0	\N	\N	101375	0	228557008	4043071	
29774	2647	4107731	1991-05-26	1991-05-26 00:00:00	38000275	0	\N	\N	175187	0	180256009	4107731	
18112	1551	4170947	1979-08-19	1979-08-19 00:00:00	38000275	0	\N	\N	103883	0	274474001	4170947	
30184	2672	4107731	1990-09-16	1990-09-16 00:00:00	38000275	0	\N	\N	177019	0	180256009	4107731	
30403	2685	4125906	1974-09-30	1974-09-30 00:00:00	38000275	0	\N	\N	177898	0	288086009	4125906	
18589	1578	4195803	1999-08-22	1999-08-22 00:00:00	38000275	0	\N	\N	105970	0	312681000	4195803	
18846	1613	4275113	1977-03-28	1977-03-28 00:00:00	38000275	0	\N	\N	108449	0	65200003	4275113	
19074	1636	4151422	1963-08-03	1963-08-03 00:00:00	38000275	0	\N	\N	109861	0	269911007	4151422	
31157	2765	4035793	2011-11-29	2011-11-29 00:00:00	38000275	0	\N	\N	182825	0	15081005	4035793	
19372	1657	40492359	1998-04-22	1998-04-22 00:00:00	38000275	0	\N	\N	111186	0	447365002	40492359	
31435	2777	4058899	2007-02-03	2007-02-03 00:00:00	38000275	0	\N	\N	183937	0	168594001	4058899	
19821	1716	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	114606	0	180256009	4107731	
31839	2802	4125906	1981-11-17	1981-11-17 00:00:00	38000275	0	\N	\N	185713	0	288086009	4125906	
20149	1743	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	116500	0	180256009	4107731	
20249	1753	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	117300	0	180256009	4107731	
32491	2858	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	189895	0	180256009	4107731	
32616	2863	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	190329	0	180256009	4107731	
44726	3916	4295880	1999-09-22	1999-09-22 00:00:00	38000275	0	\N	\N	260345	0	76601001	4295880	
32947	2891	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	192339	0	180256009	4107731	
21223	1843	4107731	1995-05-24	1995-05-24 00:00:00	38000275	0	\N	\N	123103	0	180256009	4107731	
21435	1852	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	123979	0	180256009	4107731	
45499	4014	4107731	2000-02-15	2000-02-15 00:00:00	38000275	0	\N	\N	266745	0	180256009	4107731	
33678	2935	4170947	1981-01-11	1981-01-11 00:00:00	38000275	0	\N	\N	195677	0	274474001	4170947	
33924	2959	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	197557	0	180256009	4107731	
34051	2965	4107731	1992-08-24	1992-08-24 00:00:00	38000275	0	\N	\N	197953	0	180256009	4107731	
22327	1956	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	130140	0	180256009	4107731	
22568	1976	4107731	1997-10-27	1997-10-27 00:00:00	38000275	0	\N	\N	131370	0	180256009	4107731	
22813	1982	4125906	1960-07-08	1960-07-08 00:00:00	38000275	0	\N	\N	131973	0	288086009	4125906	
34798	3025	4107731	1992-08-03	1992-08-03 00:00:00	38000275	0	\N	\N	201638	0	180256009	4107731	
47050	4130	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	274636	0	180256009	4107731	
35193	3064	4043071	1950-01-26	1950-01-26 00:00:00	38000275	0	\N	\N	203959	0	228557008	4043071	
35400	3098	4024289	2019-06-23	2019-06-23 00:00:00	38000275	0	\N	\N	206195	0	19490002	4024289	
23733	2070	4107731	1990-03-05	1990-03-05 00:00:00	38000275	0	\N	\N	137768	0	180256009	4107731	
23874	2077	4107731	1990-11-11	1990-11-11 00:00:00	38000275	0	\N	\N	138288	0	180256009	4107731	
12016	1099	4107731	1990-02-17	1990-02-17 00:00:00	38000275	0	\N	\N	72214	0	180256009	4107731	
24189	2119	4107731	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	140968	0	180256009	4107731	
12484	1125	4243062	1967-01-08	1967-01-08 00:00:00	38000275	0	\N	\N	74137	0	60027007	4243062	
24575	2151	4078793	1995-08-23	1995-08-23 00:00:00	38000275	0	\N	\N	143340	0	180325003	4078793	
24809	2173	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	144856	0	180256009	4107731	
13068	1176	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	77602	0	180256009	4107731	
25112	2186	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	145726	0	180256009	4107731	
25304	2200	4170947	1991-05-12	1991-05-12 00:00:00	38000275	0	\N	\N	146684	0	274474001	4170947	
25510	2222	4330583	2015-12-19	2015-12-19 00:00:00	38000275	0	\N	\N	147909	0	22523008	4330583	
25636	2240	4243062	1987-07-01	1987-07-01 00:00:00	38000275	0	\N	\N	149136	0	60027007	4243062	
13959	1261	4151422	2016-04-12	2016-04-12 00:00:00	38000275	0	\N	\N	83155	0	269911007	4151422	
14164	1276	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	84221	0	180256009	4107731	
26244	2290	4163872	1992-07-02	1992-07-02 00:00:00	38000275	0	\N	\N	152315	0	399208008	4163872	
26453	2300	4293740	1960-12-29	1960-12-29 00:00:00	38000275	0	\N	\N	153126	0	384700001	4293740	
26661	2334	4078793	2016-07-21	2016-07-21 00:00:00	38000275	0	\N	\N	155322	0	180325003	4078793	
14896	1323	4125906	1997-09-15	1997-09-15 00:00:00	38000275	0	\N	\N	87847	0	288086009	4125906	
26945	2352	4058899	1977-03-23	1977-03-23 00:00:00	38000275	0	\N	\N	156659	0	168594001	4058899	
15261	1365	4043071	1978-01-26	1978-01-26 00:00:00	38000275	0	\N	\N	90430	0	228557008	4043071	
27374	2392	4035793	1977-02-04	1977-02-04 00:00:00	38000275	0	\N	\N	159076	0	15081005	4035793	
15621	1387	4043071	1983-05-29	1983-05-29 00:00:00	38000275	0	\N	\N	92063	0	228557008	4043071	
27742	2435	4238715	1995-09-15	1995-09-15 00:00:00	38000275	0	\N	\N	161436	0	68254000	4238715	
16036	1399	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	93011	0	180256009	4107731	
16189	1407	4107731	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	93480	0	180256009	4107731	
28373	2518	40492359	1986-08-08	1986-08-08 00:00:00	38000275	0	\N	\N	166542	0	447365002	40492359	
28437	2534	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	167368	0	180256009	4107731	
28649	2542	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	168193	0	180256009	4107731	
28886	2554	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	169274	0	180256009	4107731	
17088	1476	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	98389	0	180256009	4107731	
17366	1497	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	99856	0	180256009	4107731	
17494	1508	4125906	1967-05-20	1967-05-20 00:00:00	38000275	0	\N	\N	100547	0	288086009	4125906	
17723	1518	4125906	1968-06-03	1968-06-03 00:00:00	38000275	0	\N	\N	101486	0	288086009	4125906	
29775	2647	4107731	1990-04-01	1990-04-01 00:00:00	38000275	0	\N	\N	175208	0	180256009	4107731	
18113	1551	4151422	2001-12-07	2001-12-07 00:00:00	38000275	0	\N	\N	103834	0	269911007	4151422	
30185	2672	4107731	1990-11-18	1990-11-18 00:00:00	38000275	0	\N	\N	177031	0	180256009	4107731	
30404	2685	4035793	2009-04-16	2009-04-16 00:00:00	38000275	0	\N	\N	177964	0	15081005	4035793	
18590	1578	4170947	1999-08-22	1999-08-22 00:00:00	38000275	0	\N	\N	105970	0	274474001	4170947	
18847	1613	4163872	1961-01-27	1961-01-27 00:00:00	38000275	0	\N	\N	108467	0	399208008	4163872	
30856	2732	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	180841	0	180256009	4107731	
31158	2765	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	182927	0	180256009	4107731	
19373	1657	4252419	1953-04-24	1953-04-24 00:00:00	38000275	0	\N	\N	111183	0	74016001	4252419	
31436	2777	4275113	1974-03-31	1974-03-31 00:00:00	38000275	0	\N	\N	183970	0	65200003	4275113	
19822	1716	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	114747	0	180256009	4107731	
31840	2802	4125906	1993-01-02	1993-01-02 00:00:00	38000275	0	\N	\N	185714	0	288086009	4125906	
20150	1743	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	116465	0	180256009	4107731	
20250	1753	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	117187	0	180256009	4107731	
32492	2858	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	189878	0	180256009	4107731	
32617	2863	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	190433	0	180256009	4107731	
44727	3916	4107731	1992-02-12	1992-02-12 00:00:00	38000275	0	\N	\N	260281	0	180256009	4107731	
32948	2891	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	192266	0	180256009	4107731	
21224	1843	4107731	1995-11-29	1995-11-29 00:00:00	38000275	0	\N	\N	123104	0	180256009	4107731	
21436	1852	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	123936	0	180256009	4107731	
45532	4017	4195803	1980-09-25	1980-09-25 00:00:00	38000275	0	\N	\N	266987	0	312681000	4195803	
33679	2935	4243062	1981-01-11	1981-01-11 00:00:00	38000275	0	\N	\N	195677	0	60027007	4243062	
33925	2959	4062501	1973-12-28	1973-12-28 00:00:00	38000275	0	\N	\N	197474	0	171231001	4062501	
34052	2965	4107731	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	197914	0	180256009	4107731	
22328	1956	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	130182	0	180256009	4107731	
22569	1976	4107731	1998-07-06	1998-07-06 00:00:00	38000275	0	\N	\N	131455	0	180256009	4107731	
22814	1982	4195803	2004-05-01	2004-05-01 00:00:00	38000275	0	\N	\N	131962	0	312681000	4195803	
34799	3025	4107731	1992-07-13	1992-07-13 00:00:00	38000275	0	\N	\N	201710	0	180256009	4107731	
47051	4130	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	274592	0	180256009	4107731	
35194	3064	4043071	1951-01-18	1951-01-18 00:00:00	38000275	0	\N	\N	203962	0	228557008	4043071	
35401	3098	4125906	2009-01-02	2009-01-02 00:00:00	38000275	0	\N	\N	206194	0	288086009	4125906	
23734	2070	4107731	1992-06-01	1992-06-01 00:00:00	38000275	0	\N	\N	137760	0	180256009	4107731	
23875	2077	4107731	1992-03-08	1992-03-08 00:00:00	38000275	0	\N	\N	138345	0	180256009	4107731	
12017	1099	4107731	1991-01-19	1991-01-19 00:00:00	38000275	0	\N	\N	72114	0	180256009	4107731	
24190	2119	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	141081	0	180256009	4107731	
12488	1128	4151422	1979-04-29	1979-04-29 00:00:00	38000275	0	\N	\N	74329	0	269911007	4151422	
24576	2151	4057420	1988-07-13	1988-07-13 00:00:00	38000275	0	\N	\N	143277	0	18286008	4057420	
24810	2173	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	144818	0	180256009	4107731	
13069	1176	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	77611	0	180256009	4107731	
25113	2186	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	145765	0	180256009	4107731	
25305	2200	4047491	1991-05-12	1991-05-12 00:00:00	38000275	0	\N	\N	146684	0	1225002	4047491	
25511	2222	4293740	1992-08-19	1992-08-19 00:00:00	38000275	0	\N	\N	147957	0	384700001	4293740	
25637	2240	4043071	1965-10-06	1965-10-06 00:00:00	38000275	0	\N	\N	149095	0	228557008	4043071	
13960	1261	4107731	1990-11-17	1990-11-17 00:00:00	38000275	0	\N	\N	83172	0	180256009	4107731	
14165	1276	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	84227	0	180256009	4107731	
26245	2291	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	152473	0	180256009	4107731	
26454	2300	4125906	1960-12-29	1960-12-29 00:00:00	38000275	0	\N	\N	153126	0	288086009	4125906	
26662	2334	4125906	2005-06-13	2005-06-13 00:00:00	38000275	0	\N	\N	155346	0	288086009	4125906	
14897	1323	4125906	1977-12-08	1977-12-08 00:00:00	38000275	0	\N	\N	87845	0	288086009	4125906	
26946	2352	4107731	1992-03-09	1992-03-09 00:00:00	38000275	0	\N	\N	156593	0	180256009	4107731	
15262	1365	4043071	1980-04-10	1980-04-10 00:00:00	38000275	0	\N	\N	90479	0	228557008	4043071	
27375	2392	4151422	1942-12-31	1942-12-31 00:00:00	38000275	0	\N	\N	159025	0	269911007	4151422	
15622	1387	4043071	1987-01-25	1987-01-25 00:00:00	38000275	0	\N	\N	92030	0	228557008	4043071	
27743	2435	4275113	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	161413	0	65200003	4275113	
16037	1399	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	93047	0	180256009	4107731	
16190	1407	4107731	1992-10-10	1992-10-10 00:00:00	38000275	0	\N	\N	93568	0	180256009	4107731	
28374	2518	4057420	1986-08-08	1986-08-08 00:00:00	38000275	0	\N	\N	166542	0	18286008	4057420	
28438	2534	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	167443	0	180256009	4107731	
28650	2542	4151422	2018-12-30	2018-12-30 00:00:00	38000275	0	\N	\N	168116	0	269911007	4151422	
28887	2554	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	169099	0	180256009	4107731	
17089	1476	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	98346	0	180256009	4107731	
17367	1497	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	99892	0	180256009	4107731	
17495	1508	4043071	1937-12-20	1937-12-20 00:00:00	38000275	0	\N	\N	100584	0	228557008	4043071	
17724	1518	4125906	1957-03-21	1957-03-21 00:00:00	38000275	0	\N	\N	101483	0	288086009	4125906	
29776	2647	4107731	1992-02-23	1992-02-23 00:00:00	38000275	0	\N	\N	175190	0	180256009	4107731	
18114	1551	4125906	1990-04-07	1990-04-07 00:00:00	38000275	0	\N	\N	103885	0	288086009	4125906	
30186	2672	4107731	1992-05-17	1992-05-17 00:00:00	38000275	0	\N	\N	176928	0	180256009	4107731	
30405	2685	4035793	1998-02-12	1998-02-12 00:00:00	38000275	0	\N	\N	177962	0	15081005	4035793	
18591	1578	4024289	1999-08-22	1999-08-22 00:00:00	38000275	0	\N	\N	105970	0	19490002	4024289	
18848	1613	4125906	2002-03-04	2002-03-04 00:00:00	38000275	0	\N	\N	108497	0	288086009	4125906	
30857	2732	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	180858	0	180256009	4107731	
31159	2765	4035793	2014-12-16	2014-12-16 00:00:00	38000275	0	\N	\N	182836	0	15081005	4035793	
19374	1658	4170947	1989-05-01	1989-05-01 00:00:00	38000275	0	\N	\N	111379	0	274474001	4170947	
31437	2777	4186930	1979-03-29	1979-03-29 00:00:00	38000275	0	\N	\N	183928	0	46706006	4186930	
31604	2782	4078793	1995-04-19	1995-04-19 00:00:00	38000275	0	\N	\N	184432	0	180325003	4078793	
31841	2802	4170947	1965-01-01	1965-01-01 00:00:00	38000275	0	\N	\N	185711	0	274474001	4170947	
20151	1743	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	116578	0	180256009	4107731	
20251	1753	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	117179	0	180256009	4107731	
32493	2858	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	189911	0	180256009	4107731	
32618	2863	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	190359	0	180256009	4107731	
44728	3916	4107731	1995-03-01	1995-03-01 00:00:00	38000275	0	\N	\N	260285	0	180256009	4107731	
32949	2891	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	192349	0	180256009	4107731	
21225	1843	4191853	1994-08-24	1994-08-24 00:00:00	38000275	0	\N	\N	123018	0	395142003	4191853	
21437	1852	4010253	1975-10-26	1975-10-26 00:00:00	38000275	0	\N	\N	123949	0	112790001	4010253	
45533	4017	4078793	2012-05-31	2012-05-31 00:00:00	38000275	0	\N	\N	267005	0	180325003	4078793	
33680	2936	4151422	1963-11-26	1963-11-26 00:00:00	38000275	0	\N	\N	195763	0	269911007	4151422	
33926	2959	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	197514	0	180256009	4107731	
34053	2965	4107731	1990-08-20	1990-08-20 00:00:00	38000275	0	\N	\N	197970	0	180256009	4107731	
22329	1956	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	130171	0	180256009	4107731	
22570	1976	4107731	1998-01-19	1998-01-19 00:00:00	38000275	0	\N	\N	131358	0	180256009	4107731	
34622	3000	4252419	1975-08-28	1975-08-28 00:00:00	38000275	0	\N	\N	200179	0	74016001	4252419	
34800	3025	4191853	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	201695	0	395142003	4191853	
47052	4130	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	274619	0	180256009	4107731	
35195	3064	4043071	1950-03-23	1950-03-23 00:00:00	38000275	0	\N	\N	203919	0	228557008	4043071	
35402	3098	4151422	2016-06-11	2016-06-11 00:00:00	38000275	0	\N	\N	206199	0	269911007	4151422	
23735	2070	4107731	1992-03-30	1992-03-30 00:00:00	38000275	0	\N	\N	137714	0	180256009	4107731	
23876	2077	4107731	1992-10-25	1992-10-25 00:00:00	38000275	0	\N	\N	138224	0	180256009	4107731	
12018	1099	4107731	1990-08-04	1990-08-04 00:00:00	38000275	0	\N	\N	72175	0	180256009	4107731	
24191	2119	4293740	1992-05-05	1992-05-05 00:00:00	38000275	0	\N	\N	140974	0	384700001	4293740	
12491	1131	4151422	1995-10-14	1995-10-14 00:00:00	38000275	0	\N	\N	74424	0	269911007	4151422	
24577	2151	4078793	1999-09-15	1999-09-15 00:00:00	38000275	0	\N	\N	143267	0	180325003	4078793	
24811	2173	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	144782	0	180256009	4107731	
13070	1176	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	77627	0	180256009	4107731	
25118	2189	4107731	2012-01-11	2012-01-11 00:00:00	38000275	0	\N	\N	145928	0	180256009	4107731	
25306	2200	4043071	1981-01-18	1981-01-18 00:00:00	38000275	0	\N	\N	146703	0	228557008	4043071	
25512	2222	4125906	1992-08-19	1992-08-19 00:00:00	38000275	0	\N	\N	147957	0	288086009	4125906	
25638	2240	4043071	1965-09-08	1965-09-08 00:00:00	38000275	0	\N	\N	149099	0	228557008	4043071	
13961	1261	4107731	1993-04-17	1993-04-17 00:00:00	38000275	0	\N	\N	83185	0	180256009	4107731	
14166	1276	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	84274	0	180256009	4107731	
26246	2291	4198190	1966-10-14	1966-10-14 00:00:00	38000275	0	\N	\N	152494	0	80146002	4198190	
26455	2300	4125906	2010-08-01	2010-08-01 00:00:00	38000275	0	\N	\N	153131	0	288086009	4125906	
26663	2334	4170947	1964-08-14	1964-08-14 00:00:00	38000275	0	\N	\N	155341	0	274474001	4170947	
14898	1323	4024289	2016-04-29	2016-04-29 00:00:00	38000275	0	\N	\N	87849	0	19490002	4024289	
26947	2352	4107731	1990-03-05	1990-03-05 00:00:00	38000275	0	\N	\N	156689	0	180256009	4107731	
15263	1365	4043071	1980-03-06	1980-03-06 00:00:00	38000275	0	\N	\N	90526	0	228557008	4043071	
27376	2392	4035793	2011-08-05	2011-08-05 00:00:00	38000275	0	\N	\N	159067	0	15081005	4035793	
15623	1387	4043071	1981-04-26	1981-04-26 00:00:00	38000275	0	\N	\N	91988	0	228557008	4043071	
27744	2436	4107731	1990-12-08	1990-12-08 00:00:00	38000275	0	\N	\N	161543	0	180256009	4107731	
16038	1399	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	93061	0	180256009	4107731	
16191	1407	4107731	1991-11-30	1991-11-30 00:00:00	38000275	0	\N	\N	93465	0	180256009	4107731	
28375	2518	4035793	2009-09-11	2009-09-11 00:00:00	38000275	0	\N	\N	166551	0	15081005	4035793	
28439	2534	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	167423	0	180256009	4107731	
28651	2542	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	168129	0	180256009	4107731	
28888	2554	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	169119	0	180256009	4107731	
17090	1476	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	98357	0	180256009	4107731	
17368	1497	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	99851	0	180256009	4107731	
17559	1510	4243062	1960-11-21	1960-11-21 00:00:00	38000275	0	\N	\N	100819	0	60027007	4243062	
17728	1520	4170947	2002-10-29	2002-10-29 00:00:00	38000275	0	\N	\N	101710	0	274474001	4170947	
29777	2647	4107731	1992-08-30	1992-08-30 00:00:00	38000275	0	\N	\N	175136	0	180256009	4107731	
18123	1553	4125906	1990-06-28	1990-06-28 00:00:00	38000275	0	\N	\N	103939	0	288086009	4125906	
30187	2672	4107731	1992-11-01	1992-11-01 00:00:00	38000275	0	\N	\N	176886	0	180256009	4107731	
30406	2685	4035793	1993-12-02	1993-12-02 00:00:00	38000275	0	\N	\N	177975	0	15081005	4035793	
18592	1579	4293740	1965-06-26	1965-06-26 00:00:00	38000275	0	\N	\N	106103	0	384700001	4293740	
30669	2712	44783196	1998-11-30	1998-11-30 00:00:00	38000275	0	\N	\N	179817	0	699253003	44783196	
30858	2732	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	180946	0	180256009	4107731	
31160	2765	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	182879	0	395142003	4191853	
19375	1658	4243062	1989-05-01	1989-05-01 00:00:00	38000275	0	\N	\N	111379	0	60027007	4243062	
31438	2777	4010253	1978-03-07	1978-03-07 00:00:00	38000275	0	\N	\N	183943	0	112790001	4010253	
31605	2782	4078793	1981-02-18	1981-02-18 00:00:00	38000275	0	\N	\N	184389	0	180325003	4078793	
31842	2802	4243062	1965-01-01	1965-01-01 00:00:00	38000275	0	\N	\N	185711	0	60027007	4243062	
20152	1743	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	116583	0	180256009	4107731	
20252	1753	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	117183	0	180256009	4107731	
32494	2858	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	189909	0	180256009	4107731	
32619	2863	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	190362	0	180256009	4107731	
44729	3916	4295880	1999-03-24	1999-03-24 00:00:00	38000275	0	\N	\N	260316	0	76601001	4295880	
32950	2891	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	192358	0	180256009	4107731	
21226	1843	4107731	1996-08-07	1996-08-07 00:00:00	38000275	0	\N	\N	123030	0	180256009	4107731	
21438	1852	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	123911	0	180256009	4107731	
45534	4017	4078793	2004-05-13	2004-05-13 00:00:00	38000275	0	\N	\N	266931	0	180325003	4078793	
33681	2936	4252419	1989-03-03	1989-03-03 00:00:00	38000275	0	\N	\N	195769	0	74016001	4252419	
33927	2959	4107731	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	197534	0	180256009	4107731	
34054	2965	4107731	1993-01-18	1993-01-18 00:00:00	38000275	0	\N	\N	197961	0	180256009	4107731	
22330	1956	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	130203	0	180256009	4107731	
22571	1976	4107731	1996-06-10	1996-06-10 00:00:00	38000275	0	\N	\N	131432	0	180256009	4107731	
34623	3000	4125906	1996-11-08	1996-11-08 00:00:00	38000275	0	\N	\N	200182	0	288086009	4125906	
34801	3025	4107731	1993-01-18	1993-01-18 00:00:00	38000275	0	\N	\N	201674	0	180256009	4107731	
47053	4130	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	274545	0	180256009	4107731	
35196	3065	4151422	1992-09-29	1992-09-29 00:00:00	38000275	0	\N	\N	204037	0	269911007	4151422	
35403	3098	4187458	1958-09-22	1958-09-22 00:00:00	38000275	0	\N	\N	206146	0	415300000	4187458	
23736	2070	4107731	1992-08-03	1992-08-03 00:00:00	38000275	0	\N	\N	137673	0	180256009	4107731	
23877	2077	4107731	1991-02-24	1991-02-24 00:00:00	38000275	0	\N	\N	138352	0	180256009	4107731	
12019	1099	4107731	1991-09-07	1991-09-07 00:00:00	38000275	0	\N	\N	72237	0	180256009	4107731	
24192	2119	4125906	1992-05-05	1992-05-05 00:00:00	38000275	0	\N	\N	140974	0	288086009	4125906	
12492	1131	4163872	1979-01-30	1979-01-30 00:00:00	38000275	0	\N	\N	74478	0	399208008	4163872	
24578	2151	4078793	1998-09-09	1998-09-09 00:00:00	38000275	0	\N	\N	143255	0	180325003	4078793	
24812	2173	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	144846	0	180256009	4107731	
13071	1176	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	77615	0	180256009	4107731	
25119	2189	4107731	2010-10-27	2010-10-27 00:00:00	38000275	0	\N	\N	145977	0	180256009	4107731	
25307	2200	4043071	1985-06-16	1985-06-16 00:00:00	38000275	0	\N	\N	146689	0	228557008	4043071	
25518	2226	4151422	1945-05-08	1945-05-08 00:00:00	38000275	0	\N	\N	148135	0	269911007	4151422	
25639	2240	4151422	2004-09-16	2004-09-16 00:00:00	38000275	0	\N	\N	149100	0	269911007	4151422	
13962	1261	4107731	1991-09-07	1991-09-07 00:00:00	38000275	0	\N	\N	83163	0	180256009	4107731	
14167	1276	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	84220	0	180256009	4107731	
26247	2291	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	152440	0	180256009	4107731	
26456	2300	4181917	1950-01-26	1950-01-26 00:00:00	38000275	0	\N	\N	153124	0	54550000	4181917	
26664	2334	4024289	1964-08-14	1964-08-14 00:00:00	38000275	0	\N	\N	155341	0	19490002	4024289	
14899	1323	4170947	2016-04-29	2016-04-29 00:00:00	38000275	0	\N	\N	87849	0	274474001	4170947	
26948	2352	4107731	1992-12-28	1992-12-28 00:00:00	38000275	0	\N	\N	156599	0	180256009	4107731	
15264	1365	4043071	1979-05-24	1979-05-24 00:00:00	38000275	0	\N	\N	90421	0	228557008	4043071	
27377	2392	4078793	2011-08-05	2011-08-05 00:00:00	38000275	0	\N	\N	159067	0	180325003	4078793	
15624	1387	4043071	1985-09-29	1985-09-29 00:00:00	38000275	0	\N	\N	92008	0	228557008	4043071	
27745	2436	4107731	1990-02-17	1990-02-17 00:00:00	38000275	0	\N	\N	161592	0	180256009	4107731	
16039	1399	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	93059	0	180256009	4107731	
16192	1407	4107731	1992-02-22	1992-02-22 00:00:00	38000275	0	\N	\N	93590	0	180256009	4107731	
28376	2518	4170947	1961-01-11	1961-01-11 00:00:00	38000275	0	\N	\N	166538	0	274474001	4170947	
28440	2534	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	167441	0	180256009	4107731	
28652	2542	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	168165	0	180256009	4107731	
28889	2554	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	169113	0	180256009	4107731	
17091	1476	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	98348	0	180256009	4107731	
17369	1497	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	99804	0	180256009	4107731	
17560	1510	4170947	1960-11-21	1960-11-21 00:00:00	38000275	0	\N	\N	100819	0	274474001	4170947	
17729	1520	4243062	2002-10-29	2002-10-29 00:00:00	38000275	0	\N	\N	101710	0	60027007	4243062	
29778	2647	4107731	1992-05-17	1992-05-17 00:00:00	38000275	0	\N	\N	175153	0	180256009	4107731	
18124	1553	4125906	1978-01-11	1978-01-11 00:00:00	38000275	0	\N	\N	103938	0	288086009	4125906	
30188	2672	4107731	1991-07-07	1991-07-07 00:00:00	38000275	0	\N	\N	177033	0	180256009	4107731	
30407	2685	4035793	2007-04-05	2007-04-05 00:00:00	38000275	0	\N	\N	177963	0	15081005	4035793	
18593	1579	4125906	1965-06-26	1965-06-26 00:00:00	38000275	0	\N	\N	106103	0	288086009	4125906	
30670	2712	4252419	1998-11-23	1998-11-23 00:00:00	38000275	0	\N	\N	179884	0	74016001	4252419	
30859	2732	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	180930	0	180256009	4107731	
31161	2765	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	182845	0	180256009	4107731	
19376	1658	4195803	1989-05-01	1989-05-01 00:00:00	38000275	0	\N	\N	111379	0	312681000	4195803	
31439	2777	4252419	1985-11-06	1985-11-06 00:00:00	38000275	0	\N	\N	183933	0	74016001	4252419	
31606	2782	4078793	2000-03-22	2000-03-22 00:00:00	38000275	0	\N	\N	184397	0	180325003	4078793	
31843	2802	4216130	1997-12-13	1997-12-13 00:00:00	38000275	0	\N	\N	185715	0	415070008	4216130	
20153	1743	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	116516	0	180256009	4107731	
20253	1753	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	117299	0	180256009	4107731	
32495	2858	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	189913	0	180256009	4107731	
32620	2863	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	190414	0	180256009	4107731	
44730	3916	4295880	1995-03-29	1995-03-29 00:00:00	38000275	0	\N	\N	260391	0	76601001	4295880	
32951	2891	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	192272	0	180256009	4107731	
21227	1843	4107731	1996-10-09	1996-10-09 00:00:00	38000275	0	\N	\N	123108	0	180256009	4107731	
21439	1852	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	123962	0	180256009	4107731	
45535	4017	4078793	2011-05-26	2011-05-26 00:00:00	38000275	0	\N	\N	266927	0	180325003	4078793	
33682	2936	44783196	1989-03-10	1989-03-10 00:00:00	38000275	0	\N	\N	195736	0	699253003	44783196	
33928	2959	4043071	1980-07-16	1980-07-16 00:00:00	38000275	0	\N	\N	197487	0	228557008	4043071	
34055	2965	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	197898	0	180256009	4107731	
22331	1956	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	130173	0	180256009	4107731	
22572	1976	4107731	1997-09-15	1997-09-15 00:00:00	38000275	0	\N	\N	131369	0	180256009	4107731	
34624	3000	4125906	1965-12-13	1965-12-13 00:00:00	38000275	0	\N	\N	200177	0	288086009	4125906	
34802	3025	4107731	1992-12-28	1992-12-28 00:00:00	38000275	0	\N	\N	201694	0	180256009	4107731	
47054	4130	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	274622	0	180256009	4107731	
35197	3065	4058899	1981-02-23	1981-02-23 00:00:00	38000275	0	\N	\N	204042	0	168594001	4058899	
35404	3098	4326177	1958-09-22	1958-09-22 00:00:00	38000275	0	\N	\N	206146	0	430193006	4326177	
23737	2070	4107731	1992-02-17	1992-02-17 00:00:00	38000275	0	\N	\N	137713	0	180256009	4107731	
23878	2077	4107731	1990-09-30	1990-09-30 00:00:00	38000275	0	\N	\N	138287	0	180256009	4107731	
12020	1099	4107731	1991-05-25	1991-05-25 00:00:00	38000275	0	\N	\N	72226	0	180256009	4107731	
24193	2119	4107731	1991-04-08	1991-04-08 00:00:00	38000275	0	\N	\N	140970	0	180256009	4107731	
12493	1131	4170947	1979-01-30	1979-01-30 00:00:00	38000275	0	\N	\N	74478	0	274474001	4170947	
24579	2151	4078793	1990-07-25	1990-07-25 00:00:00	38000275	0	\N	\N	143330	0	180325003	4078793	
24813	2173	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	144745	0	180256009	4107731	
13072	1176	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	77591	0	180256009	4107731	
25120	2189	4107731	2010-08-25	2010-08-25 00:00:00	38000275	0	\N	\N	145908	0	180256009	4107731	
25308	2200	4125906	1978-10-12	1978-10-12 00:00:00	38000275	0	\N	\N	146621	0	288086009	4125906	
25519	2226	4151422	1971-02-23	1971-02-23 00:00:00	38000275	0	\N	\N	148144	0	269911007	4151422	
25640	2240	4125906	1966-10-05	1966-10-05 00:00:00	38000275	0	\N	\N	149135	0	288086009	4125906	
13963	1261	4107731	1991-02-09	1991-02-09 00:00:00	38000275	0	\N	\N	83174	0	180256009	4107731	
14168	1276	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	84146	0	180256009	4107731	
26248	2291	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	152453	0	180256009	4107731	
26457	2300	4058899	1955-12-26	1955-12-26 00:00:00	38000275	0	\N	\N	153125	0	168594001	4058899	
26665	2334	4035793	2017-07-27	2017-07-27 00:00:00	38000275	0	\N	\N	155366	0	15081005	4035793	
14900	1323	4195803	2016-04-29	2016-04-29 00:00:00	38000275	0	\N	\N	87849	0	312681000	4195803	
26949	2352	4107731	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	156594	0	180256009	4107731	
15265	1365	4043071	1978-10-19	1978-10-19 00:00:00	38000275	0	\N	\N	90523	0	228557008	4043071	
27378	2392	4125906	1954-10-08	1954-10-08 00:00:00	38000275	0	\N	\N	159011	0	288086009	4125906	
15625	1387	4238715	1989-08-08	1989-08-08 00:00:00	38000275	0	\N	\N	91964	0	68254000	4238715	
27746	2436	4107731	1993-05-08	1993-05-08 00:00:00	38000275	0	\N	\N	161492	0	180256009	4107731	
16040	1399	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	93085	0	180256009	4107731	
16193	1407	4107731	1990-11-17	1990-11-17 00:00:00	38000275	0	\N	\N	93530	0	180256009	4107731	
28377	2518	4047491	1961-01-11	1961-01-11 00:00:00	38000275	0	\N	\N	166538	0	1225002	4047491	
28441	2534	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	167392	0	180256009	4107731	
28653	2542	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	168094	0	180256009	4107731	
28890	2554	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	169271	0	180256009	4107731	
17092	1476	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	98332	0	180256009	4107731	
17370	1497	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	99850	0	180256009	4107731	
17561	1510	44783196	1978-08-15	1978-08-15 00:00:00	38000275	0	\N	\N	100787	0	699253003	44783196	
17730	1520	4195803	2002-10-29	2002-10-29 00:00:00	38000275	0	\N	\N	101710	0	312681000	4195803	
29779	2647	4107731	1991-08-18	1991-08-18 00:00:00	38000275	0	\N	\N	175213	0	180256009	4107731	
18125	1553	4170947	1968-01-04	1968-01-04 00:00:00	38000275	0	\N	\N	103937	0	274474001	4170947	
30189	2672	4107731	1992-11-22	1992-11-22 00:00:00	38000275	0	\N	\N	176958	0	180256009	4107731	
30408	2685	4035793	2008-04-10	2008-04-10 00:00:00	38000275	0	\N	\N	177904	0	15081005	4035793	
18594	1579	4125906	1959-08-06	1959-08-06 00:00:00	38000275	0	\N	\N	106101	0	288086009	4125906	
30671	2712	4125906	2003-08-06	2003-08-06 00:00:00	38000275	0	\N	\N	179885	0	288086009	4125906	
30860	2732	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	180901	0	180256009	4107731	
31162	2765	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	182980	0	180256009	4107731	
19377	1658	4151422	1974-10-12	1974-10-12 00:00:00	38000275	0	\N	\N	111357	0	269911007	4151422	
31440	2777	4238715	1983-02-10	1983-02-10 00:00:00	38000275	0	\N	\N	183956	0	68254000	4238715	
31607	2782	4195803	2000-03-22	2000-03-22 00:00:00	38000275	0	\N	\N	184397	0	312681000	4195803	
31844	2802	4336464	1997-12-13	1997-12-13 00:00:00	38000275	0	\N	\N	185715	0	232717009	4336464	
20154	1743	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	116478	0	180256009	4107731	
20254	1753	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	117189	0	180256009	4107731	
32496	2858	4170947	1986-02-07	1986-02-07 00:00:00	38000275	0	\N	\N	189903	0	274474001	4170947	
32621	2863	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	190412	0	180256009	4107731	
44731	3916	4107731	1993-12-15	1993-12-15 00:00:00	38000275	0	\N	\N	260372	0	180256009	4107731	
32952	2891	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	192367	0	180256009	4107731	
21228	1843	4107731	1996-07-17	1996-07-17 00:00:00	38000275	0	\N	\N	123033	0	180256009	4107731	
21440	1852	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	124000	0	180256009	4107731	
45536	4017	4078793	2005-05-19	2005-05-19 00:00:00	38000275	0	\N	\N	267044	0	180325003	4078793	
33683	2936	4151422	1971-03-03	1971-03-03 00:00:00	38000275	0	\N	\N	195766	0	269911007	4151422	
33929	2959	4043071	1979-06-27	1979-06-27 00:00:00	38000275	0	\N	\N	197522	0	228557008	4043071	
34056	2965	4107731	1990-05-07	1990-05-07 00:00:00	38000275	0	\N	\N	198007	0	180256009	4107731	
22332	1956	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	130197	0	180256009	4107731	
22573	1976	4107731	1998-12-21	1998-12-21 00:00:00	38000275	0	\N	\N	131405	0	180256009	4107731	
34625	3000	44783196	1975-09-04	1975-09-04 00:00:00	38000275	0	\N	\N	200170	0	699253003	44783196	
34803	3025	4191853	1990-01-01	1990-01-01 00:00:00	38000275	0	\N	\N	201615	0	395142003	4191853	
47055	4130	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	274620	0	180256009	4107731	
35198	3065	44783196	1982-05-26	1982-05-26 00:00:00	38000275	0	\N	\N	204069	0	699253003	44783196	
35405	3098	4037675	1958-09-22	1958-09-22 00:00:00	38000275	0	\N	\N	206146	0	162676008	4037675	
23738	2070	4107731	1991-09-23	1991-09-23 00:00:00	38000275	0	\N	\N	137669	0	180256009	4107731	
23879	2077	4107731	1991-06-30	1991-06-30 00:00:00	38000275	0	\N	\N	138246	0	180256009	4107731	
12021	1099	4191853	1990-01-06	1990-01-06 00:00:00	38000275	0	\N	\N	72213	0	395142003	4191853	
24194	2119	4107731	1990-02-12	1990-02-12 00:00:00	38000275	0	\N	\N	140967	0	180256009	4107731	
12494	1132	4252419	1963-04-12	1963-04-12 00:00:00	38000275	0	\N	\N	74510	0	74016001	4252419	
24580	2151	4151422	1967-06-08	1967-06-08 00:00:00	38000275	0	\N	\N	143286	0	269911007	4151422	
24814	2173	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	144738	0	180256009	4107731	
13073	1176	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	77657	0	180256009	4107731	
25121	2189	4107731	2011-01-19	2011-01-19 00:00:00	38000275	0	\N	\N	145961	0	180256009	4107731	
25309	2200	4043071	1984-02-19	1984-02-19 00:00:00	38000275	0	\N	\N	146664	0	228557008	4043071	
25520	2226	4151422	1988-09-30	1988-09-30 00:00:00	38000275	0	\N	\N	148119	0	269911007	4151422	
25641	2240	4043071	1965-11-03	1965-11-03 00:00:00	38000275	0	\N	\N	149141	0	228557008	4043071	
13964	1261	4107731	1991-09-28	1991-09-28 00:00:00	38000275	0	\N	\N	83176	0	180256009	4107731	
14169	1276	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	84145	0	180256009	4107731	
26249	2291	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	152529	0	180256009	4107731	
26507	2307	4195803	2013-02-07	2013-02-07 00:00:00	38000275	0	\N	\N	153485	0	312681000	4195803	
26666	2334	4078793	2017-07-27	2017-07-27 00:00:00	38000275	0	\N	\N	155366	0	180325003	4078793	
14901	1323	4243062	1987-05-11	1987-05-11 00:00:00	38000275	0	\N	\N	87846	0	60027007	4243062	
26950	2352	4191853	1990-01-01	1990-01-01 00:00:00	38000275	0	\N	\N	156717	0	395142003	4191853	
15266	1365	4043071	1980-05-15	1980-05-15 00:00:00	38000275	0	\N	\N	90480	0	228557008	4043071	
27379	2392	4057420	2001-06-08	2001-06-08 00:00:00	38000275	0	\N	\N	158994	0	18286008	4057420	
15626	1387	4043071	1984-06-17	1984-06-17 00:00:00	38000275	0	\N	\N	92006	0	228557008	4043071	
27747	2436	4107731	1991-01-19	1991-01-19 00:00:00	38000275	0	\N	\N	161544	0	180256009	4107731	
16041	1399	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	93097	0	180256009	4107731	
16194	1407	4107731	1990-10-27	1990-10-27 00:00:00	38000275	0	\N	\N	93540	0	180256009	4107731	
28378	2518	4125906	1973-06-07	1973-06-07 00:00:00	38000275	0	\N	\N	166539	0	288086009	4125906	
28442	2534	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	167453	0	180256009	4107731	
28654	2542	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	168098	0	180256009	4107731	
28891	2554	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	169276	0	180256009	4107731	
17093	1476	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	98400	0	180256009	4107731	
17371	1497	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	99776	0	180256009	4107731	
17562	1510	4170947	1989-06-18	1989-06-18 00:00:00	38000275	0	\N	\N	100790	0	274474001	4170947	
17731	1520	4151422	1952-01-08	1952-01-08 00:00:00	38000275	0	\N	\N	101649	0	269911007	4151422	
29780	2647	4107731	1990-10-07	1990-10-07 00:00:00	38000275	0	\N	\N	175209	0	180256009	4107731	
18126	1553	4024289	1968-01-04	1968-01-04 00:00:00	38000275	0	\N	\N	103937	0	19490002	4024289	
30190	2672	4107731	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	176887	0	180256009	4107731	
30409	2685	4035793	2004-03-18	2004-03-18 00:00:00	38000275	0	\N	\N	177979	0	15081005	4035793	
18595	1579	4058899	1964-04-02	1964-04-02 00:00:00	38000275	0	\N	\N	106102	0	168594001	4058899	
30672	2712	4293740	2003-08-06	2003-08-06 00:00:00	38000275	0	\N	\N	179885	0	384700001	4293740	
30861	2732	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	180936	0	180256009	4107731	
31163	2765	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	182991	0	180256009	4107731	
19378	1658	4037675	1912-04-30	1912-04-30 00:00:00	38000275	0	\N	\N	111353	0	162676008	4037675	
31441	2777	4170947	1993-10-01	1993-10-01 00:00:00	38000275	0	\N	\N	183935	0	274474001	4170947	
31608	2782	4078793	1980-02-13	1980-02-13 00:00:00	38000275	0	\N	\N	184400	0	180325003	4078793	
31845	2802	4151422	1947-01-28	1947-01-28 00:00:00	38000275	0	\N	\N	185763	0	269911007	4151422	
20155	1743	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	116499	0	180256009	4107731	
20255	1753	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	117244	0	180256009	4107731	
32497	2858	4195803	1986-02-07	1986-02-07 00:00:00	38000275	0	\N	\N	189903	0	312681000	4195803	
32622	2863	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	190347	0	180256009	4107731	
44732	3916	4107731	1994-10-26	1994-10-26 00:00:00	38000275	0	\N	\N	260296	0	180256009	4107731	
32953	2892	4151422	1997-07-18	1997-07-18 00:00:00	38000275	0	\N	\N	192397	0	269911007	4151422	
21229	1843	4107731	1995-09-06	1995-09-06 00:00:00	38000275	0	\N	\N	123049	0	180256009	4107731	
21441	1852	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	123997	0	180256009	4107731	
45537	4017	4078793	2014-02-13	2014-02-13 00:00:00	38000275	0	\N	\N	267006	0	180325003	4078793	
33684	2936	4145310	1975-07-24	1975-07-24 00:00:00	38000275	0	\N	\N	195818	0	268425006	4145310	
33930	2959	4170947	1986-09-29	1986-09-29 00:00:00	38000275	0	\N	\N	197604	0	274474001	4170947	
34057	2965	4107731	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	197958	0	180256009	4107731	
22333	1956	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	130132	0	180256009	4107731	
22574	1976	4295880	1998-03-16	1998-03-16 00:00:00	38000275	0	\N	\N	131423	0	76601001	4295880	
34626	3000	4243062	1961-04-08	1961-04-08 00:00:00	38000275	0	\N	\N	200176	0	60027007	4243062	
34804	3025	4151422	1996-05-16	1996-05-16 00:00:00	38000275	0	\N	\N	201675	0	269911007	4151422	
47056	4130	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	274544	0	180256009	4107731	
35199	3065	4252419	1982-05-19	1982-05-19 00:00:00	38000275	0	\N	\N	204043	0	74016001	4252419	
35406	3100	4293740	1951-10-03	1951-10-03 00:00:00	38000275	0	\N	\N	206240	0	384700001	4293740	
23739	2070	4107731	1992-03-09	1992-03-09 00:00:00	38000275	0	\N	\N	137758	0	180256009	4107731	
23880	2077	4107731	1992-12-06	1992-12-06 00:00:00	38000275	0	\N	\N	138358	0	180256009	4107731	
12022	1099	4107731	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	72119	0	180256009	4107731	
24195	2119	4107731	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	141052	0	180256009	4107731	
12495	1132	4024289	1968-09-19	1968-09-19 00:00:00	38000275	0	\N	\N	74563	0	19490002	4024289	
24581	2151	4078793	1979-05-23	1979-05-23 00:00:00	38000275	0	\N	\N	143275	0	180325003	4078793	
24815	2173	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	144778	0	180256009	4107731	
13074	1176	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	77632	0	180256009	4107731	
25122	2189	4107731	2010-06-23	2010-06-23 00:00:00	38000275	0	\N	\N	145905	0	180256009	4107731	
25310	2200	4043071	1981-11-15	1981-11-15 00:00:00	38000275	0	\N	\N	146632	0	228557008	4043071	
25521	2226	4125906	2001-06-12	2001-06-12 00:00:00	38000275	0	\N	\N	148169	0	288086009	4125906	
25642	2240	4043071	1965-04-21	1965-04-21 00:00:00	38000275	0	\N	\N	149138	0	228557008	4043071	
13965	1261	4107731	1992-06-06	1992-06-06 00:00:00	38000275	0	\N	\N	83166	0	180256009	4107731	
14170	1276	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	84165	0	180256009	4107731	
26250	2291	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	152528	0	180256009	4107731	
26508	2307	4047491	2013-02-07	2013-02-07 00:00:00	38000275	0	\N	\N	153485	0	1225002	4047491	
26667	2334	4078793	2013-07-04	2013-07-04 00:00:00	38000275	0	\N	\N	155364	0	180325003	4078793	
14902	1323	4170947	1987-05-11	1987-05-11 00:00:00	38000275	0	\N	\N	87846	0	274474001	4170947	
26951	2352	4181917	1971-03-22	1971-03-22 00:00:00	38000275	0	\N	\N	156657	0	54550000	4181917	
15267	1365	4043071	1977-10-27	1977-10-27 00:00:00	38000275	0	\N	\N	90517	0	228557008	4043071	
27380	2392	4035793	2001-06-08	2001-06-08 00:00:00	38000275	0	\N	\N	158994	0	15081005	4035793	
15627	1387	4043071	1982-11-07	1982-11-07 00:00:00	38000275	0	\N	\N	91999	0	228557008	4043071	
27748	2436	4107731	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	161489	0	180256009	4107731	
16042	1399	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	93090	0	180256009	4107731	
16195	1407	4191853	1993-07-10	1993-07-10 00:00:00	38000275	0	\N	\N	93472	0	395142003	4191853	
28386	2521	4202451	2007-10-15	2007-10-15 00:00:00	38000275	0	\N	\N	166785	0	433112001	4202451	
28443	2534	4170947	1974-06-15	1974-06-15 00:00:00	38000275	0	\N	\N	167431	0	274474001	4170947	
28655	2542	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	168163	0	180256009	4107731	
28892	2554	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	169154	0	180256009	4107731	
17095	1478	4151422	1980-07-26	1980-07-26 00:00:00	38000275	0	\N	\N	98615	0	269911007	4151422	
17372	1497	4170947	2007-02-18	2007-02-18 00:00:00	38000275	0	\N	\N	99782	0	274474001	4170947	
17563	1510	4024289	1989-06-18	1989-06-18 00:00:00	38000275	0	\N	\N	100790	0	19490002	4024289	
17732	1520	4151422	1963-05-04	1963-05-04 00:00:00	38000275	0	\N	\N	101632	0	269911007	4151422	
29781	2647	4107731	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	175156	0	180256009	4107731	
18127	1553	4151422	1977-08-24	1977-08-24 00:00:00	38000275	0	\N	\N	103992	0	269911007	4151422	
30191	2672	4107731	1990-06-24	1990-06-24 00:00:00	38000275	0	\N	\N	177003	0	180256009	4107731	
30410	2685	4035793	2006-03-30	2006-03-30 00:00:00	38000275	0	\N	\N	177903	0	15081005	4035793	
18596	1579	4163872	1974-08-18	1974-08-18 00:00:00	38000275	0	\N	\N	106088	0	399208008	4163872	
30673	2712	4170947	1968-01-09	1968-01-09 00:00:00	38000275	0	\N	\N	179881	0	274474001	4170947	
30862	2732	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	180903	0	180256009	4107731	
31164	2765	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	182994	0	180256009	4107731	
19379	1658	4326177	1912-04-30	1912-04-30 00:00:00	38000275	0	\N	\N	111353	0	430193006	4326177	
31442	2777	4163872	1993-10-01	1993-10-01 00:00:00	38000275	0	\N	\N	183935	0	399208008	4163872	
31609	2782	4078793	1998-03-11	1998-03-11 00:00:00	38000275	0	\N	\N	184396	0	180325003	4078793	
31849	2804	4252419	1983-04-09	1983-04-09 00:00:00	38000275	0	\N	\N	185851	0	74016001	4252419	
20156	1743	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	116591	0	180256009	4107731	
20256	1753	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	117276	0	180256009	4107731	
32498	2858	4024289	1986-02-07	1986-02-07 00:00:00	38000275	0	\N	\N	189903	0	19490002	4024289	
32623	2863	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	190349	0	180256009	4107731	
44733	3916	4107731	1993-04-07	1993-04-07 00:00:00	38000275	0	\N	\N	260413	0	180256009	4107731	
32954	2892	4151422	1975-06-18	1975-06-18 00:00:00	38000275	0	\N	\N	192394	0	269911007	4151422	
21230	1843	4107731	1995-10-18	1995-10-18 00:00:00	38000275	0	\N	\N	123050	0	180256009	4107731	
21442	1852	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	123965	0	180256009	4107731	
45538	4017	4202451	2014-08-07	2014-08-07 00:00:00	38000275	0	\N	\N	267006	0	433112001	4202451	
33698	2942	4057420	2018-04-11	2018-04-11 00:00:00	38000275	0	\N	\N	196167	0	18286008	4057420	
33931	2959	4024289	1986-09-29	1986-09-29 00:00:00	38000275	0	\N	\N	197604	0	19490002	4024289	
34058	2965	4170947	1971-02-18	1971-02-18 00:00:00	38000275	0	\N	\N	197983	0	274474001	4170947	
22334	1956	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	130120	0	180256009	4107731	
22575	1976	4107731	1999-02-22	1999-02-22 00:00:00	38000275	0	\N	\N	131457	0	180256009	4107731	
34627	3000	4170947	1961-04-08	1961-04-08 00:00:00	38000275	0	\N	\N	200176	0	274474001	4170947	
34805	3025	4336464	2002-10-14	2002-10-14 00:00:00	38000275	0	\N	\N	201587	0	232717009	4336464	
47057	4130	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	274528	0	180256009	4107731	
35200	3065	4151422	1989-09-23	1989-09-23 00:00:00	38000275	0	\N	\N	204036	0	269911007	4151422	
35407	3100	4125906	1951-10-03	1951-10-03 00:00:00	38000275	0	\N	\N	206240	0	288086009	4125906	
23740	2070	4107731	1990-01-22	1990-01-22 00:00:00	38000275	0	\N	\N	137767	0	180256009	4107731	
23881	2077	4107731	1991-05-19	1991-05-19 00:00:00	38000275	0	\N	\N	138289	0	180256009	4107731	
12023	1099	4107731	1990-12-08	1990-12-08 00:00:00	38000275	0	\N	\N	72113	0	180256009	4107731	
24196	2119	4107731	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	141059	0	180256009	4107731	
12496	1132	4170947	1968-09-19	1968-09-19 00:00:00	38000275	0	\N	\N	74563	0	274474001	4170947	
24582	2151	4078793	1987-07-08	1987-07-08 00:00:00	38000275	0	\N	\N	143339	0	180325003	4078793	
24816	2173	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	144775	0	180256009	4107731	
13075	1176	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	77617	0	180256009	4107731	
25123	2189	4107731	2010-08-04	2010-08-04 00:00:00	38000275	0	\N	\N	145975	0	180256009	4107731	
25311	2200	4043071	1984-12-23	1984-12-23 00:00:00	38000275	0	\N	\N	146635	0	228557008	4043071	
25526	2228	4195803	2007-04-21	2007-04-21 00:00:00	38000275	0	\N	\N	148242	0	312681000	4195803	
25645	2242	4202451	2013-12-21	2013-12-21 00:00:00	38000275	0	\N	\N	149279	0	433112001	4202451	
13966	1261	4107731	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	83192	0	180256009	4107731	
14171	1276	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	84168	0	180256009	4107731	
26251	2291	4252419	1971-02-18	1971-02-18 00:00:00	38000275	0	\N	\N	152490	0	74016001	4252419	
26509	2307	4170947	2013-02-07	2013-02-07 00:00:00	38000275	0	\N	\N	153485	0	274474001	4170947	
26668	2334	4170947	1942-11-24	1942-11-24 00:00:00	38000275	0	\N	\N	155339	0	274474001	4170947	
14905	1325	4151422	1990-05-03	1990-05-03 00:00:00	38000275	0	\N	\N	87984	0	269911007	4151422	
26952	2352	4107731	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	156703	0	180256009	4107731	
15268	1365	4043071	1978-06-22	1978-06-22 00:00:00	38000275	0	\N	\N	90522	0	228557008	4043071	
27381	2392	4035793	1982-12-10	1982-12-10 00:00:00	38000275	0	\N	\N	159088	0	15081005	4035793	
15628	1387	4043071	1984-07-15	1984-07-15 00:00:00	38000275	0	\N	\N	92071	0	228557008	4043071	
27749	2436	4151422	1980-08-21	1980-08-21 00:00:00	38000275	0	\N	\N	161588	0	269911007	4151422	
16043	1399	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	93034	0	180256009	4107731	
16196	1407	4107731	1990-07-14	1990-07-14 00:00:00	38000275	0	\N	\N	93583	0	180256009	4107731	
28387	2521	4202451	2006-03-20	2006-03-20 00:00:00	38000275	0	\N	\N	166783	0	433112001	4202451	
28444	2534	4047491	1974-06-15	1974-06-15 00:00:00	38000275	0	\N	\N	167431	0	1225002	4047491	
28656	2542	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	168086	0	180256009	4107731	
28893	2554	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	169227	0	180256009	4107731	
17096	1478	4202832	1975-05-03	1975-05-03 00:00:00	38000275	0	\N	\N	98639	0	52765003	4202832	
17373	1497	4047491	2007-02-18	2007-02-18 00:00:00	38000275	0	\N	\N	99782	0	1225002	4047491	
17564	1510	4252419	1978-08-08	1978-08-08 00:00:00	38000275	0	\N	\N	100789	0	74016001	4252419	
17733	1520	4195803	2010-10-17	2010-10-17 00:00:00	38000275	0	\N	\N	101711	0	312681000	4195803	
29782	2647	4107731	1990-11-18	1990-11-18 00:00:00	38000275	0	\N	\N	175210	0	180256009	4107731	
29963	2657	4330583	2017-01-02	2017-01-02 00:00:00	38000275	0	\N	\N	175940	0	22523008	4330583	
30192	2672	4107731	1990-12-09	1990-12-09 00:00:00	38000275	0	\N	\N	177021	0	180256009	4107731	
30411	2685	4035793	2003-03-13	2003-03-13 00:00:00	38000275	0	\N	\N	177932	0	15081005	4035793	
18597	1579	4202451	1999-04-29	1999-04-29 00:00:00	38000275	0	\N	\N	106071	0	433112001	4202451	
30674	2712	4047491	1968-01-09	1968-01-09 00:00:00	38000275	0	\N	\N	179881	0	1225002	4047491	
30863	2732	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	180853	0	180256009	4107731	
31165	2765	4202451	2018-05-22	2018-05-22 00:00:00	38000275	0	\N	\N	182886	0	433112001	4202451	
19380	1658	4125906	1928-01-07	1928-01-07 00:00:00	38000275	0	\N	\N	111375	0	288086009	4125906	
31443	2777	4125906	1999-05-03	1999-05-03 00:00:00	38000275	0	\N	\N	183936	0	288086009	4125906	
31610	2782	4078793	1977-01-26	1977-01-26 00:00:00	38000275	0	\N	\N	184359	0	180325003	4078793	
31850	2804	4151422	1963-02-16	1963-02-16 00:00:00	38000275	0	\N	\N	185845	0	269911007	4151422	
20157	1743	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	116585	0	180256009	4107731	
20257	1753	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	117178	0	180256009	4107731	
32499	2858	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	189912	0	180256009	4107731	
32624	2863	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	190336	0	180256009	4107731	
44734	3916	4295880	1995-06-28	1995-06-28 00:00:00	38000275	0	\N	\N	260380	0	76601001	4295880	
32955	2892	4125906	1990-12-22	1990-12-22 00:00:00	38000275	0	\N	\N	192416	0	288086009	4125906	
21231	1843	4107731	1995-01-18	1995-01-18 00:00:00	38000275	0	\N	\N	123062	0	180256009	4107731	
21443	1852	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	123995	0	180256009	4107731	
45539	4017	4151422	1930-02-08	1930-02-08 00:00:00	38000275	0	\N	\N	267033	0	269911007	4151422	
33699	2942	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	196084	0	180256009	4107731	
33932	2959	4043071	1980-08-13	1980-08-13 00:00:00	38000275	0	\N	\N	197556	0	228557008	4043071	
34059	2965	4107731	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	197925	0	180256009	4107731	
22335	1956	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	130139	0	180256009	4107731	
22576	1976	4107731	1996-04-08	1996-04-08 00:00:00	38000275	0	\N	\N	131341	0	180256009	4107731	
34628	3001	4125906	1980-12-15	1980-12-15 00:00:00	38000275	0	\N	\N	200329	0	288086009	4125906	
34806	3025	4216130	2002-10-14	2002-10-14 00:00:00	38000275	0	\N	\N	201587	0	415070008	4216130	
47058	4130	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	274548	0	180256009	4107731	
35201	3065	4186930	1991-05-09	1991-05-09 00:00:00	38000275	0	\N	\N	204046	0	46706006	4186930	
35408	3100	4330583	1986-12-12	1986-12-12 00:00:00	38000275	0	\N	\N	206226	0	22523008	4330583	
23741	2070	4107731	1993-02-08	1993-02-08 00:00:00	38000275	0	\N	\N	137731	0	180256009	4107731	
23882	2077	4170947	2001-06-11	2001-06-11 00:00:00	38000275	0	\N	\N	138379	0	274474001	4170947	
12024	1099	4107731	1990-12-29	1990-12-29 00:00:00	38000275	0	\N	\N	72218	0	180256009	4107731	
24197	2119	4107731	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	140979	0	180256009	4107731	
12497	1132	4151422	2010-04-24	2010-04-24 00:00:00	38000275	0	\N	\N	74495	0	269911007	4151422	
24583	2151	4078793	1981-06-03	1981-06-03 00:00:00	38000275	0	\N	\N	143276	0	180325003	4078793	
24817	2173	4125906	1960-03-02	1960-03-02 00:00:00	38000275	0	\N	\N	144889	0	288086009	4125906	
13076	1176	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	77592	0	180256009	4107731	
25124	2189	4107731	2012-07-18	2012-07-18 00:00:00	38000275	0	\N	\N	145929	0	180256009	4107731	
25312	2200	4043071	1985-01-27	1985-01-27 00:00:00	38000275	0	\N	\N	146636	0	228557008	4043071	
25527	2228	4151422	2001-02-26	2001-02-26 00:00:00	38000275	0	\N	\N	148275	0	269911007	4151422	
25646	2242	4151422	2001-08-02	2001-08-02 00:00:00	38000275	0	\N	\N	149236	0	269911007	4151422	
13967	1261	4107731	1990-03-31	1990-03-31 00:00:00	38000275	0	\N	\N	83170	0	180256009	4107731	
14172	1276	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	84276	0	180256009	4107731	
26252	2291	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	152454	0	180256009	4107731	
26510	2307	4186930	1985-10-01	1985-10-01 00:00:00	38000275	0	\N	\N	153491	0	46706006	4186930	
26669	2334	4024289	1942-11-24	1942-11-24 00:00:00	38000275	0	\N	\N	155339	0	19490002	4024289	
14906	1325	4163872	1974-04-24	1974-04-24 00:00:00	38000275	0	\N	\N	87950	0	399208008	4163872	
26953	2352	4107731	1990-12-03	1990-12-03 00:00:00	38000275	0	\N	\N	156589	0	180256009	4107731	
15269	1365	4043071	1978-11-16	1978-11-16 00:00:00	38000275	0	\N	\N	90503	0	228557008	4043071	
27382	2392	4035793	1981-12-04	1981-12-04 00:00:00	38000275	0	\N	\N	159078	0	15081005	4035793	
15629	1387	4043071	1982-08-15	1982-08-15 00:00:00	38000275	0	\N	\N	91998	0	228557008	4043071	
27750	2436	4125906	2000-05-18	2000-05-18 00:00:00	38000275	0	\N	\N	161578	0	288086009	4125906	
16044	1399	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	93021	0	180256009	4107731	
16197	1407	4107731	1992-08-29	1992-08-29 00:00:00	38000275	0	\N	\N	93468	0	180256009	4107731	
28388	2521	4125906	1949-02-12	1949-02-12 00:00:00	38000275	0	\N	\N	166736	0	288086009	4125906	
28445	2534	4151422	2017-07-30	2017-07-30 00:00:00	38000275	0	\N	\N	167449	0	269911007	4151422	
28657	2542	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	168093	0	180256009	4107731	
28894	2554	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	169248	0	180256009	4107731	
17097	1478	42535580	1975-05-03	1975-05-03 00:00:00	38000275	0	\N	\N	98639	0	426701000119108	42535580	
17374	1497	4195803	2007-02-18	2007-02-18 00:00:00	38000275	0	\N	\N	99782	0	312681000	4195803	
17565	1511	4163872	1966-01-22	1966-01-22 00:00:00	38000275	0	\N	\N	100899	0	399208008	4163872	
17734	1520	4163872	2010-10-17	2010-10-17 00:00:00	38000275	0	\N	\N	101711	0	399208008	4163872	
29783	2647	4107731	1991-12-22	1991-12-22 00:00:00	38000275	0	\N	\N	175197	0	180256009	4107731	
29964	2657	44783196	2016-01-23	2016-01-23 00:00:00	38000275	0	\N	\N	175934	0	699253003	44783196	
30193	2672	4107731	1992-04-26	1992-04-26 00:00:00	38000275	0	\N	\N	176917	0	180256009	4107731	
30412	2685	4163872	1952-10-13	1952-10-13 00:00:00	38000275	0	\N	\N	177944	0	399208008	4163872	
18603	1585	4125906	1950-10-06	1950-10-06 00:00:00	38000275	0	\N	\N	106346	0	288086009	4125906	
30697	2715	4198190	1989-01-08	1989-01-08 00:00:00	38000275	0	\N	\N	180098	0	80146002	4198190	
30864	2732	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	180934	0	180256009	4107731	
31166	2765	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	182992	0	180256009	4107731	
19381	1658	4195803	1992-01-27	1992-01-27 00:00:00	38000275	0	\N	\N	111287	0	312681000	4195803	
31444	2777	44783196	1985-11-13	1985-11-13 00:00:00	38000275	0	\N	\N	183940	0	699253003	44783196	
31611	2782	4057420	1987-03-25	1987-03-25 00:00:00	38000275	0	\N	\N	184391	0	18286008	4057420	
31851	2804	44783196	1983-04-16	1983-04-16 00:00:00	38000275	0	\N	\N	185857	0	699253003	44783196	
20158	1743	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	116592	0	180256009	4107731	
20258	1753	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	117243	0	180256009	4107731	
32500	2858	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	189846	0	180256009	4107731	
32625	2863	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	190353	0	180256009	4107731	
44735	3916	4107731	1991-12-11	1991-12-11 00:00:00	38000275	0	\N	\N	260344	0	180256009	4107731	
32956	2892	4125906	2014-03-03	2014-03-03 00:00:00	38000275	0	\N	\N	192418	0	288086009	4125906	
21232	1843	4107731	1995-02-08	1995-02-08 00:00:00	38000275	0	\N	\N	123014	0	180256009	4107731	
21444	1852	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	123996	0	180256009	4107731	
45540	4017	4078793	1999-04-15	1999-04-15 00:00:00	38000275	0	\N	\N	267041	0	180325003	4078793	
33700	2942	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	196226	0	180256009	4107731	
33933	2959	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	197533	0	180256009	4107731	
34060	2965	4107731	1991-02-04	1991-02-04 00:00:00	38000275	0	\N	\N	198010	0	180256009	4107731	
22336	1956	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	130124	0	180256009	4107731	
22577	1976	4107731	1997-07-14	1997-07-14 00:00:00	38000275	0	\N	\N	131440	0	180256009	4107731	
34629	3001	4151422	2013-02-02	2013-02-02 00:00:00	38000275	0	\N	\N	200275	0	269911007	4151422	
34807	3025	4107731	1990-02-12	1990-02-12 00:00:00	38000275	0	\N	\N	201616	0	180256009	4107731	
47059	4130	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	274638	0	180256009	4107731	
35202	3065	4238715	1996-04-25	1996-04-25 00:00:00	38000275	0	\N	\N	204025	0	68254000	4238715	
35428	3103	4047491	1987-12-10	1987-12-10 00:00:00	38000275	0	\N	\N	206456	0	1225002	4047491	
23742	2070	4107731	1990-02-12	1990-02-12 00:00:00	38000275	0	\N	\N	137681	0	180256009	4107731	
23883	2077	4047491	2001-06-11	2001-06-11 00:00:00	38000275	0	\N	\N	138379	0	1225002	4047491	
12025	1099	4107731	1991-02-09	1991-02-09 00:00:00	38000275	0	\N	\N	72219	0	180256009	4107731	
24198	2119	4107731	1991-03-18	1991-03-18 00:00:00	38000275	0	\N	\N	141007	0	180256009	4107731	
12498	1132	44783196	1963-04-19	1963-04-19 00:00:00	38000275	0	\N	\N	74511	0	699253003	44783196	
24584	2151	4078793	1984-06-20	1984-06-20 00:00:00	38000275	0	\N	\N	143253	0	180325003	4078793	
24818	2173	4293740	1960-03-02	1960-03-02 00:00:00	38000275	0	\N	\N	144889	0	384700001	4293740	
13077	1176	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	77629	0	180256009	4107731	
25125	2189	4107731	2013-03-27	2013-03-27 00:00:00	38000275	0	\N	\N	145947	0	180256009	4107731	
25313	2200	4043071	1982-05-30	1982-05-30 00:00:00	38000275	0	\N	\N	146660	0	228557008	4043071	
25528	2228	4125906	2016-01-17	2016-01-17 00:00:00	38000275	0	\N	\N	148279	0	288086009	4125906	
25647	2242	4047491	1942-05-25	1942-05-25 00:00:00	38000275	0	\N	\N	149229	0	1225002	4047491	
13968	1261	4107731	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	83162	0	180256009	4107731	
14173	1276	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	84178	0	180256009	4107731	
26253	2291	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	152555	0	180256009	4107731	
26511	2307	4125906	1972-03-09	1972-03-09 00:00:00	38000275	0	\N	\N	153483	0	288086009	4125906	
26670	2334	4078793	2012-06-28	2012-06-28 00:00:00	38000275	0	\N	\N	155284	0	180325003	4078793	
14907	1325	4125906	1989-12-27	1989-12-27 00:00:00	38000275	0	\N	\N	87937	0	288086009	4125906	
26954	2352	4107731	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	156720	0	180256009	4107731	
15270	1365	4043071	1979-02-15	1979-02-15 00:00:00	38000275	0	\N	\N	90524	0	228557008	4043071	
27383	2392	4035793	1994-04-29	1994-04-29 00:00:00	38000275	0	\N	\N	159090	0	15081005	4035793	
15630	1387	4043071	1982-06-13	1982-06-13 00:00:00	38000275	0	\N	\N	92061	0	228557008	4043071	
27751	2436	4107731	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	161493	0	180256009	4107731	
16045	1399	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	93088	0	180256009	4107731	
16198	1407	4107731	1991-02-09	1991-02-09 00:00:00	38000275	0	\N	\N	93532	0	180256009	4107731	
28389	2521	4293740	1949-02-12	1949-02-12 00:00:00	38000275	0	\N	\N	166736	0	384700001	4293740	
28446	2534	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	167369	0	180256009	4107731	
28658	2542	4151422	2005-04-04	2005-04-04 00:00:00	38000275	0	\N	\N	168155	0	269911007	4151422	
28895	2554	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	169272	0	180256009	4107731	
17098	1478	4163971	1975-05-03	1975-05-03 00:00:00	38000275	0	\N	\N	98639	0	45595009	4163971	
17375	1497	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	99810	0	180256009	4107731	
17566	1511	4145310	1974-11-04	1974-11-04 00:00:00	38000275	0	\N	\N	100931	0	268425006	4145310	
17735	1520	4170947	2010-10-17	2010-10-17 00:00:00	38000275	0	\N	\N	101711	0	274474001	4170947	
29784	2647	4107731	1991-05-05	1991-05-05 00:00:00	38000275	0	\N	\N	175108	0	180256009	4107731	
29965	2657	4252419	2016-01-16	2016-01-16 00:00:00	38000275	0	\N	\N	175951	0	74016001	4252419	
30194	2672	4107731	1991-08-18	1991-08-18 00:00:00	38000275	0	\N	\N	177034	0	180256009	4107731	
30413	2685	4035793	1996-12-19	1996-12-19 00:00:00	38000275	0	\N	\N	177930	0	15081005	4035793	
18604	1585	4151422	1959-10-20	1959-10-20 00:00:00	38000275	0	\N	\N	106270	0	269911007	4151422	
30698	2715	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	179992	0	180256009	4107731	
30865	2732	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	180916	0	180256009	4107731	
31167	2765	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	182986	0	180256009	4107731	
19382	1658	4170947	1995-04-14	1995-04-14 00:00:00	38000275	0	\N	\N	111381	0	274474001	4170947	
31445	2778	4107731	1991-11-09	1991-11-09 00:00:00	38000275	0	\N	\N	184036	0	180256009	4107731	
31612	2782	4057420	1992-07-29	1992-07-29 00:00:00	38000275	0	\N	\N	184376	0	18286008	4057420	
31852	2804	4293740	1988-03-20	1988-03-20 00:00:00	38000275	0	\N	\N	185852	0	384700001	4293740	
20159	1743	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	116497	0	180256009	4107731	
20259	1753	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	117181	0	180256009	4107731	
32501	2858	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	189888	0	180256009	4107731	
32626	2863	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	190439	0	180256009	4107731	
44736	3916	4107731	1994-06-22	1994-06-22 00:00:00	38000275	0	\N	\N	260425	0	180256009	4107731	
32957	2893	4170947	1973-09-11	1973-09-11 00:00:00	38000275	0	\N	\N	192463	0	274474001	4170947	
21233	1843	4107731	1996-08-28	1996-08-28 00:00:00	38000275	0	\N	\N	123034	0	180256009	4107731	
21445	1852	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	123981	0	180256009	4107731	
45541	4017	4078793	2008-05-08	2008-05-08 00:00:00	38000275	0	\N	\N	266932	0	180325003	4078793	
33701	2942	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	196231	0	180256009	4107731	
33934	2959	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	197494	0	180256009	4107731	
34061	2965	4107731	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	197937	0	180256009	4107731	
22337	1956	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	130201	0	180256009	4107731	
22578	1976	4107731	1997-12-08	1997-12-08 00:00:00	38000275	0	\N	\N	131352	0	180256009	4107731	
34630	3001	4125906	1956-11-27	1956-11-27 00:00:00	38000275	0	\N	\N	200326	0	288086009	4125906	
34808	3025	4107731	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	201605	0	180256009	4107731	
47060	4130	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	274621	0	180256009	4107731	
35203	3065	4163872	1995-04-27	1995-04-27 00:00:00	38000275	0	\N	\N	204073	0	399208008	4163872	
35429	3103	4170947	1987-12-10	1987-12-10 00:00:00	38000275	0	\N	\N	206456	0	274474001	4170947	
23743	2070	4107731	1992-10-26	1992-10-26 00:00:00	38000275	0	\N	\N	137675	0	180256009	4107731	
23884	2077	4195803	2001-06-11	2001-06-11 00:00:00	38000275	0	\N	\N	138379	0	312681000	4195803	
12026	1099	4107731	1992-02-01	1992-02-01 00:00:00	38000275	0	\N	\N	72181	0	180256009	4107731	
24199	2119	4107731	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	141055	0	180256009	4107731	
12499	1133	4170947	1973-10-25	1973-10-25 00:00:00	38000275	0	\N	\N	74584	0	274474001	4170947	
24585	2151	4078793	1997-09-03	1997-09-03 00:00:00	38000275	0	\N	\N	143266	0	180325003	4078793	
24819	2173	4107731	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	144776	0	180256009	4107731	
13078	1176	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	77609	0	180256009	4107731	
25126	2189	4107731	2010-05-12	2010-05-12 00:00:00	38000275	0	\N	\N	145895	0	180256009	4107731	
25314	2200	4043071	1980-11-16	1980-11-16 00:00:00	38000275	0	\N	\N	146644	0	228557008	4043071	
25540	2230	4058899	1985-06-13	1985-06-13 00:00:00	38000275	0	\N	\N	148400	0	168594001	4058899	
25648	2242	4170947	1942-05-25	1942-05-25 00:00:00	38000275	0	\N	\N	149229	0	274474001	4170947	
13969	1261	4107731	1993-03-27	1993-03-27 00:00:00	38000275	0	\N	\N	83236	0	180256009	4107731	
14174	1276	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	84252	0	180256009	4107731	
26254	2291	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	152444	0	180256009	4107731	
26512	2307	4238715	1989-06-13	1989-06-13 00:00:00	38000275	0	\N	\N	153504	0	68254000	4238715	
26671	2334	4170947	1979-06-25	1979-06-25 00:00:00	38000275	0	\N	\N	155344	0	274474001	4170947	
14908	1325	4024289	2011-10-17	2011-10-17 00:00:00	38000275	0	\N	\N	87939	0	19490002	4024289	
26955	2352	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	156674	0	180256009	4107731	
15271	1365	4043071	1977-12-29	1977-12-29 00:00:00	38000275	0	\N	\N	90417	0	228557008	4043071	
27384	2392	4078793	2004-06-25	2004-06-25 00:00:00	38000275	0	\N	\N	158980	0	180325003	4078793	
15631	1387	4043071	1985-05-26	1985-05-26 00:00:00	38000275	0	\N	\N	92074	0	228557008	4043071	
27752	2436	4107731	1991-04-13	1991-04-13 00:00:00	38000275	0	\N	\N	161645	0	180256009	4107731	
16046	1399	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	93084	0	180256009	4107731	
16199	1407	4107731	1991-01-19	1991-01-19 00:00:00	38000275	0	\N	\N	93519	0	180256009	4107731	
28390	2521	4163872	1985-08-24	1985-08-24 00:00:00	38000275	0	\N	\N	166732	0	399208008	4163872	
28447	2534	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	167460	0	180256009	4107731	
28659	2542	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	168152	0	180256009	4107731	
28896	2554	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	169116	0	180256009	4107731	
17099	1478	4163951	1975-05-03	1975-05-03 00:00:00	38000275	0	\N	\N	98639	0	29303009	4163951	
17376	1497	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	99902	0	180256009	4107731	
17567	1511	4163872	2012-12-15	2012-12-15 00:00:00	38000275	0	\N	\N	100937	0	399208008	4163872	
17747	1523	4163872	1988-11-02	1988-11-02 00:00:00	38000275	0	\N	\N	101881	0	399208008	4163872	
29785	2647	4107731	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	175150	0	180256009	4107731	
29966	2657	4057420	1970-09-05	1970-09-05 00:00:00	38000275	0	\N	\N	175949	0	18286008	4057420	
30195	2672	4107731	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	177006	0	180256009	4107731	
30414	2685	4035793	2001-03-01	2001-03-01 00:00:00	38000275	0	\N	\N	177931	0	15081005	4035793	
18605	1585	4125906	1960-11-17	1960-11-17 00:00:00	38000275	0	\N	\N	106348	0	288086009	4125906	
30699	2715	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	180028	0	180256009	4107731	
30866	2732	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	180915	0	180256009	4107731	
31168	2765	4035793	2010-11-23	2010-11-23 00:00:00	38000275	0	\N	\N	182835	0	15081005	4035793	
19383	1658	4163872	1995-04-14	1995-04-14 00:00:00	38000275	0	\N	\N	111381	0	399208008	4163872	
31446	2778	4191853	1993-07-10	1993-07-10 00:00:00	38000275	0	\N	\N	183976	0	395142003	4191853	
31613	2782	4078793	1998-01-07	1998-01-07 00:00:00	38000275	0	\N	\N	184455	0	180325003	4078793	
31853	2804	4125906	1988-03-20	1988-03-20 00:00:00	38000275	0	\N	\N	185852	0	288086009	4125906	
20160	1743	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	116522	0	180256009	4107731	
20260	1753	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	117298	0	180256009	4107731	
32502	2858	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	189892	0	180256009	4107731	
32627	2863	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	190343	0	180256009	4107731	
44737	3916	4295880	1997-12-24	1997-12-24 00:00:00	38000275	0	\N	\N	260324	0	76601001	4295880	
32958	2893	4024289	1973-09-11	1973-09-11 00:00:00	38000275	0	\N	\N	192463	0	19490002	4024289	
21234	1843	4107731	1997-02-12	1997-02-12 00:00:00	38000275	0	\N	\N	123031	0	180256009	4107731	
21452	1854	4170947	2006-04-26	2006-04-26 00:00:00	38000275	0	\N	\N	124133	0	274474001	4170947	
45542	4017	4078793	2009-05-14	2009-05-14 00:00:00	38000275	0	\N	\N	267046	0	180325003	4078793	
33702	2942	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	196228	0	180256009	4107731	
33935	2959	4191853	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	197540	0	395142003	4191853	
34062	2965	4107731	1992-01-06	1992-01-06 00:00:00	38000275	0	\N	\N	197951	0	180256009	4107731	
22338	1956	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	130202	0	180256009	4107731	
22579	1976	4107731	1997-03-10	1997-03-10 00:00:00	38000275	0	\N	\N	131349	0	180256009	4107731	
34631	3001	4125906	1986-09-06	1986-09-06 00:00:00	38000275	0	\N	\N	200330	0	288086009	4125906	
34809	3025	4107731	1991-02-04	1991-02-04 00:00:00	38000275	0	\N	\N	201609	0	180256009	4107731	
47061	4130	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	274623	0	180256009	4107731	
35204	3065	4275113	1986-05-12	1986-05-12 00:00:00	38000275	0	\N	\N	204005	0	65200003	4275113	
35430	3103	4202451	2018-05-16	2018-05-16 00:00:00	38000275	0	\N	\N	206438	0	433112001	4202451	
23744	2070	4107731	1990-05-07	1990-05-07 00:00:00	38000275	0	\N	\N	137683	0	180256009	4107731	
23885	2077	4107731	1990-10-21	1990-10-21 00:00:00	38000275	0	\N	\N	138340	0	180256009	4107731	
12027	1099	4107731	1992-10-10	1992-10-10 00:00:00	38000275	0	\N	\N	72231	0	180256009	4107731	
24200	2119	4107731	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	141071	0	180256009	4107731	
12500	1133	4163872	1973-10-25	1973-10-25 00:00:00	38000275	0	\N	\N	74584	0	399208008	4163872	
24586	2151	4057420	1977-05-11	1977-05-11 00:00:00	38000275	0	\N	\N	143274	0	18286008	4057420	
24820	2173	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	144857	0	180256009	4107731	
13079	1176	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	77630	0	180256009	4107731	
25127	2189	4107731	2010-03-31	2010-03-31 00:00:00	38000275	0	\N	\N	145894	0	180256009	4107731	
25315	2200	4043071	1980-09-21	1980-09-21 00:00:00	38000275	0	\N	\N	146702	0	228557008	4043071	
25541	2231	4125906	2006-12-26	2006-12-26 00:00:00	38000275	0	\N	\N	148429	0	288086009	4125906	
25649	2242	4125906	1969-02-02	1969-02-02 00:00:00	38000275	0	\N	\N	149230	0	288086009	4125906	
13970	1261	4107731	1992-01-11	1992-01-11 00:00:00	38000275	0	\N	\N	83229	0	180256009	4107731	
14175	1276	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	84193	0	180256009	4107731	
26255	2291	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	152403	0	180256009	4107731	
26513	2307	4186930	1980-09-30	1980-09-30 00:00:00	38000275	0	\N	\N	153498	0	46706006	4186930	
26672	2334	4163872	1979-06-25	1979-06-25 00:00:00	38000275	0	\N	\N	155344	0	399208008	4163872	
14909	1325	4170947	2011-10-17	2011-10-17 00:00:00	38000275	0	\N	\N	87939	0	274474001	4170947	
26956	2352	4107731	1992-12-07	1992-12-07 00:00:00	38000275	0	\N	\N	156683	0	180256009	4107731	
15272	1365	4043071	1978-03-23	1978-03-23 00:00:00	38000275	0	\N	\N	90500	0	228557008	4043071	
27385	2392	4035793	2004-06-25	2004-06-25 00:00:00	38000275	0	\N	\N	158980	0	15081005	4035793	
15632	1387	4043071	1981-05-31	1981-05-31 00:00:00	38000275	0	\N	\N	91989	0	228557008	4043071	
27753	2436	4107731	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	161583	0	180256009	4107731	
16047	1399	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	93092	0	180256009	4107731	
16200	1407	4107731	1991-11-09	1991-11-09 00:00:00	38000275	0	\N	\N	93477	0	180256009	4107731	
28391	2521	4151422	1948-03-20	1948-03-20 00:00:00	38000275	0	\N	\N	166756	0	269911007	4151422	
28448	2534	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	167437	0	180256009	4107731	
28660	2543	4181917	1964-10-18	1964-10-18 00:00:00	38000275	0	\N	\N	168264	0	54550000	4181917	
28897	2554	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	169152	0	180256009	4107731	
17100	1478	4197460	1981-04-12	1981-04-12 00:00:00	38000275	0	\N	\N	98641	0	313191000	4197460	
17377	1497	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	99888	0	180256009	4107731	
17568	1511	4195803	2012-12-15	2012-12-15 00:00:00	38000275	0	\N	\N	100937	0	312681000	4195803	
17748	1523	4170947	1988-11-02	1988-11-02 00:00:00	38000275	0	\N	\N	101881	0	274474001	4170947	
29786	2647	4107731	1993-02-14	1993-02-14 00:00:00	38000275	0	\N	\N	175195	0	180256009	4107731	
29967	2657	40492359	1970-09-05	1970-09-05 00:00:00	38000275	0	\N	\N	175949	0	447365002	40492359	
30196	2672	4107731	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	176921	0	180256009	4107731	
30415	2685	4035793	2005-03-24	2005-03-24 00:00:00	38000275	0	\N	\N	177933	0	15081005	4035793	
18606	1585	4125906	1969-09-15	1969-09-15 00:00:00	38000275	0	\N	\N	106349	0	288086009	4125906	
30700	2715	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	179995	0	180256009	4107731	
30867	2732	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	180827	0	180256009	4107731	
31169	2765	4163872	1989-04-07	1989-04-07 00:00:00	38000275	0	\N	\N	182942	0	399208008	4163872	
19384	1658	4187458	1912-04-30	1912-04-30 00:00:00	38000275	0	\N	\N	111353	0	415300000	4187458	
31447	2778	4107731	1991-07-27	1991-07-27 00:00:00	38000275	0	\N	\N	183986	0	180256009	4107731	
31614	2782	4078793	1986-03-19	1986-03-19 00:00:00	38000275	0	\N	\N	184402	0	180325003	4078793	
31854	2804	4243062	1952-08-05	1952-08-05 00:00:00	38000275	0	\N	\N	185847	0	60027007	4243062	
20161	1743	4198190	2011-01-25	2011-01-25 00:00:00	38000275	0	\N	\N	116475	0	80146002	4198190	
20261	1753	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	117277	0	180256009	4107731	
32503	2858	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	189785	0	180256009	4107731	
32628	2863	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	190452	0	180256009	4107731	
44738	3916	4107731	1991-11-20	1991-11-20 00:00:00	38000275	0	\N	\N	260267	0	180256009	4107731	
32959	2893	4198190	1959-05-30	1959-05-30 00:00:00	38000275	0	\N	\N	192513	0	80146002	4198190	
21235	1843	44805732	2009-07-01	2009-07-01 00:00:00	38000275	0	\N	\N	122997	0	755621000000101	44805732	
21453	1854	4024289	2006-04-26	2006-04-26 00:00:00	38000275	0	\N	\N	124133	0	19490002	4024289	
45543	4017	4078793	2002-05-02	2002-05-02 00:00:00	38000275	0	\N	\N	266930	0	180325003	4078793	
33703	2942	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	196216	0	180256009	4107731	
33936	2959	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	197559	0	180256009	4107731	
34063	2965	4107731	1992-06-01	1992-06-01 00:00:00	38000275	0	\N	\N	197959	0	180256009	4107731	
22339	1956	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	130119	0	180256009	4107731	
22580	1976	4295880	1999-09-13	1999-09-13 00:00:00	38000275	0	\N	\N	131425	0	76601001	4295880	
34632	3001	4293740	1986-09-06	1986-09-06 00:00:00	38000275	0	\N	\N	200330	0	384700001	4293740	
34810	3025	4107731	1990-01-22	1990-01-22 00:00:00	38000275	0	\N	\N	201688	0	180256009	4107731	
47062	4130	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	274633	0	180256009	4107731	
35207	3067	4170947	2015-11-09	2015-11-09 00:00:00	38000275	0	\N	\N	204189	0	274474001	4170947	
35431	3103	4151422	1984-10-08	1984-10-08 00:00:00	38000275	0	\N	\N	206446	0	269911007	4151422	
23745	2070	4107731	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	137770	0	180256009	4107731	
23886	2077	4107731	1993-05-02	1993-05-02 00:00:00	38000275	0	\N	\N	138225	0	180256009	4107731	
12028	1099	4107731	1992-06-06	1992-06-06 00:00:00	38000275	0	\N	\N	72240	0	180256009	4107731	
24201	2119	4107731	1992-03-30	1992-03-30 00:00:00	38000275	0	\N	\N	141031	0	180256009	4107731	
12501	1133	4145310	2011-03-10	2011-03-10 00:00:00	38000275	0	\N	\N	74585	0	268425006	4145310	
24587	2151	4078793	1982-06-09	1982-06-09 00:00:00	38000275	0	\N	\N	143252	0	180325003	4078793	
24821	2173	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	144845	0	180256009	4107731	
13080	1176	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	77671	0	180256009	4107731	
25128	2189	4107731	2011-12-21	2011-12-21 00:00:00	38000275	0	\N	\N	145980	0	180256009	4107731	
25316	2200	4043071	1984-06-17	1984-06-17 00:00:00	38000275	0	\N	\N	146666	0	228557008	4043071	
25542	2231	4047491	1982-09-03	1982-09-03 00:00:00	38000275	0	\N	\N	148428	0	1225002	4047491	
25650	2242	4125906	1996-07-24	1996-07-24 00:00:00	38000275	0	\N	\N	149231	0	288086009	4125906	
13971	1261	4107731	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	83197	0	180256009	4107731	
14176	1276	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	84277	0	180256009	4107731	
26256	2291	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	152539	0	180256009	4107731	
26514	2307	4275113	1981-09-09	1981-09-09 00:00:00	38000275	0	\N	\N	153499	0	65200003	4275113	
26676	2337	4125906	1990-02-22	1990-02-22 00:00:00	38000275	0	\N	\N	155539	0	288086009	4125906	
26742	2339	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	155662	0	180256009	4107731	
26957	2352	4107731	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	156601	0	180256009	4107731	
15273	1365	4043071	1978-09-21	1978-09-21 00:00:00	38000275	0	\N	\N	90432	0	228557008	4043071	
27386	2392	4035793	1985-03-08	1985-03-08 00:00:00	38000275	0	\N	\N	159089	0	15081005	4035793	
15633	1387	4043071	1985-06-30	1985-06-30 00:00:00	38000275	0	\N	\N	92075	0	228557008	4043071	
27754	2436	4107731	1990-05-12	1990-05-12 00:00:00	38000275	0	\N	\N	161502	0	180256009	4107731	
16048	1399	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	93087	0	180256009	4107731	
16201	1407	4107731	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	93584	0	180256009	4107731	
28392	2522	4058899	2000-07-24	2000-07-24 00:00:00	38000275	0	\N	\N	166789	0	168594001	4058899	
28449	2534	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	167421	0	180256009	4107731	
28661	2543	4125906	1978-05-22	1978-05-22 00:00:00	38000275	0	\N	\N	168266	0	288086009	4125906	
28898	2554	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	169156	0	180256009	4107731	
17101	1478	4197460	1990-11-23	1990-11-23 00:00:00	38000275	0	\N	\N	98642	0	313191000	4197460	
17378	1497	4163872	1975-11-05	1975-11-05 00:00:00	38000275	0	\N	\N	99780	0	399208008	4163872	
17569	1511	4170947	2012-12-15	2012-12-15 00:00:00	38000275	0	\N	\N	100937	0	274474001	4170947	
17749	1524	4125906	1973-01-10	1973-01-10 00:00:00	38000275	0	\N	\N	101908	0	288086009	4125906	
29787	2647	4107731	1991-11-10	1991-11-10 00:00:00	38000275	0	\N	\N	175152	0	180256009	4107731	
30034	2659	4058899	1979-06-19	1979-06-19 00:00:00	38000275	0	\N	\N	176147	0	168594001	4058899	
30197	2672	4191853	1993-07-11	1993-07-11 00:00:00	38000275	0	\N	\N	176924	0	395142003	4191853	
30416	2685	4035793	1997-02-06	1997-02-06 00:00:00	38000275	0	\N	\N	177937	0	15081005	4035793	
18607	1585	4151422	1957-03-26	1957-03-26 00:00:00	38000275	0	\N	\N	106257	0	269911007	4151422	
30701	2715	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	179976	0	180256009	4107731	
30868	2732	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	180937	0	180256009	4107731	
31170	2765	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	182925	0	180256009	4107731	
19385	1658	4151422	1971-04-02	1971-04-02 00:00:00	38000275	0	\N	\N	111315	0	269911007	4151422	
31448	2778	4107731	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	184065	0	180256009	4107731	
31615	2782	4078793	1993-08-04	1993-08-04 00:00:00	38000275	0	\N	\N	184417	0	180325003	4078793	
31855	2804	4170947	1952-08-05	1952-08-05 00:00:00	38000275	0	\N	\N	185847	0	274474001	4170947	
20162	1743	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	116496	0	180256009	4107731	
20262	1753	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	117186	0	180256009	4107731	
32504	2858	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	189908	0	180256009	4107731	
32629	2863	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	190358	0	180256009	4107731	
44739	3916	44783196	2007-08-08	2007-08-08 00:00:00	38000275	0	\N	\N	260442	0	699253003	44783196	
32960	2893	4024289	1956-05-15	1956-05-15 00:00:00	38000275	0	\N	\N	192518	0	19490002	4024289	
21236	1843	4107731	1995-05-03	1995-05-03 00:00:00	38000275	0	\N	\N	123016	0	180256009	4107731	
21454	1854	4062501	1972-11-09	1972-11-09 00:00:00	38000275	0	\N	\N	124059	0	171231001	4062501	
45544	4017	4078793	2012-11-22	2012-11-22 00:00:00	38000275	0	\N	\N	267003	0	180325003	4078793	
33704	2942	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	196185	0	180256009	4107731	
33937	2959	4043071	1980-12-17	1980-12-17 00:00:00	38000275	0	\N	\N	197481	0	228557008	4043071	
34064	2965	4107731	1990-12-03	1990-12-03 00:00:00	38000275	0	\N	\N	197945	0	180256009	4107731	
22340	1956	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	130168	0	180256009	4107731	
22581	1976	4107731	1998-02-09	1998-02-09 00:00:00	38000275	0	\N	\N	131355	0	180256009	4107731	
34634	3004	4163872	2001-12-06	2001-12-06 00:00:00	38000275	0	\N	\N	200488	0	399208008	4163872	
34811	3025	4107731	1990-03-05	1990-03-05 00:00:00	38000275	0	\N	\N	201689	0	180256009	4107731	
47063	4130	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	274543	0	180256009	4107731	
35208	3067	4243062	2015-11-09	2015-11-09 00:00:00	38000275	0	\N	\N	204189	0	60027007	4243062	
35432	3103	4125906	1983-03-15	1983-03-15 00:00:00	38000275	0	\N	\N	206455	0	288086009	4125906	
23746	2070	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	137677	0	180256009	4107731	
23887	2077	4107731	1992-12-27	1992-12-27 00:00:00	38000275	0	\N	\N	138252	0	180256009	4107731	
12029	1099	4107731	1993-05-29	1993-05-29 00:00:00	38000275	0	\N	\N	72207	0	180256009	4107731	
24202	2119	4107731	1991-09-23	1991-09-23 00:00:00	38000275	0	\N	\N	141076	0	180256009	4107731	
12502	1134	4170947	2013-07-02	2013-07-02 00:00:00	38000275	0	\N	\N	74731	0	274474001	4170947	
24588	2151	4078793	1976-05-05	1976-05-05 00:00:00	38000275	0	\N	\N	143326	0	180325003	4078793	
24822	2173	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	144824	0	180256009	4107731	
13081	1176	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	77687	0	180256009	4107731	
25129	2189	4107731	2011-09-07	2011-09-07 00:00:00	38000275	0	\N	\N	145963	0	180256009	4107731	
25317	2200	4043071	1982-01-10	1982-01-10 00:00:00	38000275	0	\N	\N	146611	0	228557008	4043071	
25543	2231	4170947	1982-09-03	1982-09-03 00:00:00	38000275	0	\N	\N	148428	0	274474001	4170947	
25651	2243	4163872	1984-12-29	1984-12-29 00:00:00	38000275	0	\N	\N	149336	0	399208008	4163872	
13972	1261	4107731	1993-03-06	1993-03-06 00:00:00	38000275	0	\N	\N	83141	0	180256009	4107731	
14177	1276	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	84143	0	180256009	4107731	
26257	2291	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	152460	0	180256009	4107731	
26515	2307	4275113	1987-08-18	1987-08-18 00:00:00	38000275	0	\N	\N	153503	0	65200003	4275113	
26677	2337	4293740	1990-02-22	1990-02-22 00:00:00	38000275	0	\N	\N	155539	0	384700001	4293740	
26743	2339	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	155685	0	180256009	4107731	
26958	2352	4107731	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	156722	0	180256009	4107731	
15274	1365	4043071	1978-04-20	1978-04-20 00:00:00	38000275	0	\N	\N	90418	0	228557008	4043071	
27387	2392	4057420	2018-11-02	2018-11-02 00:00:00	38000275	0	\N	\N	158978	0	18286008	4057420	
15634	1387	4043071	1982-01-10	1982-01-10 00:00:00	38000275	0	\N	\N	92033	0	228557008	4043071	
27755	2436	4107731	1993-03-27	1993-03-27 00:00:00	38000275	0	\N	\N	161491	0	180256009	4107731	
16049	1399	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	93022	0	180256009	4107731	
16202	1407	4107731	1990-04-21	1990-04-21 00:00:00	38000275	0	\N	\N	93539	0	180256009	4107731	
28393	2522	4010253	2014-08-23	2014-08-23 00:00:00	38000275	0	\N	\N	166796	0	112790001	4010253	
28450	2534	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	167386	0	180256009	4107731	
28662	2543	4125906	1965-11-12	1965-11-12 00:00:00	38000275	0	\N	\N	168265	0	288086009	4125906	
28899	2554	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	169241	0	180256009	4107731	
17102	1478	4125906	2001-09-22	2001-09-22 00:00:00	38000275	0	\N	\N	98643	0	288086009	4125906	
17379	1497	4170947	1975-11-05	1975-11-05 00:00:00	38000275	0	\N	\N	99780	0	274474001	4170947	
17570	1511	4125906	1981-08-29	1981-08-29 00:00:00	38000275	0	\N	\N	100933	0	288086009	4125906	
17750	1524	4198190	1969-01-12	1969-01-12 00:00:00	38000275	0	\N	\N	101909	0	80146002	4198190	
29788	2647	4107731	1991-10-20	1991-10-20 00:00:00	38000275	0	\N	\N	175132	0	180256009	4107731	
30035	2659	4125906	2015-03-12	2015-03-12 00:00:00	38000275	0	\N	\N	176148	0	288086009	4125906	
30198	2672	4107731	1991-09-29	1991-09-29 00:00:00	38000275	0	\N	\N	176926	0	180256009	4107731	
30417	2685	4035793	2010-04-22	2010-04-22 00:00:00	38000275	0	\N	\N	177905	0	15081005	4035793	
18608	1586	4125906	1961-04-13	1961-04-13 00:00:00	38000275	0	\N	\N	106387	0	288086009	4125906	
30702	2715	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	179979	0	180256009	4107731	
30869	2732	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	180935	0	180256009	4107731	
31171	2765	4163872	1984-06-10	1984-06-10 00:00:00	38000275	0	\N	\N	182919	0	399208008	4163872	
19386	1659	4043071	1980-04-28	1980-04-28 00:00:00	38000275	0	\N	\N	111487	0	228557008	4043071	
31449	2778	4107731	1991-12-21	1991-12-21 00:00:00	38000275	0	\N	\N	184014	0	180256009	4107731	
31616	2782	4078793	1985-03-13	1985-03-13 00:00:00	38000275	0	\N	\N	184390	0	180325003	4078793	
31856	2804	4125906	1965-02-28	1965-02-28 00:00:00	38000275	0	\N	\N	185848	0	288086009	4125906	
20163	1743	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	116584	0	180256009	4107731	
20263	1753	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	117293	0	180256009	4107731	
32505	2858	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	189827	0	180256009	4107731	
32630	2863	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	190354	0	180256009	4107731	
44740	3916	4107731	1992-03-25	1992-03-25 00:00:00	38000275	0	\N	\N	260364	0	180256009	4107731	
32961	2893	4170947	1956-05-15	1956-05-15 00:00:00	38000275	0	\N	\N	192518	0	274474001	4170947	
21237	1843	4107731	1998-02-04	1998-02-04 00:00:00	38000275	0	\N	\N	123085	0	180256009	4107731	
21455	1855	4125906	1979-10-10	1979-10-10 00:00:00	38000275	0	\N	\N	124136	0	288086009	4125906	
45545	4017	4078793	2003-05-08	2003-05-08 00:00:00	38000275	0	\N	\N	267043	0	180325003	4078793	
33705	2942	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	196160	0	180256009	4107731	
33938	2959	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	197560	0	180256009	4107731	
34065	2965	4107731	1990-02-12	1990-02-12 00:00:00	38000275	0	\N	\N	198005	0	180256009	4107731	
22341	1956	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	130196	0	180256009	4107731	
22582	1976	4295880	2000-06-12	2000-06-12 00:00:00	38000275	0	\N	\N	131426	0	76601001	4295880	
34635	3004	4151422	2018-04-04	2018-04-04 00:00:00	38000275	0	\N	\N	200470	0	269911007	4151422	
34812	3025	4107731	1992-10-05	1992-10-05 00:00:00	38000275	0	\N	\N	201632	0	180256009	4107731	
47064	4130	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	274583	0	180256009	4107731	
35209	3067	4195803	2015-11-09	2015-11-09 00:00:00	38000275	0	\N	\N	204189	0	312681000	4195803	
35433	3103	4293740	1983-03-15	1983-03-15 00:00:00	38000275	0	\N	\N	206455	0	384700001	4293740	
23747	2070	4107731	1991-02-25	1991-02-25 00:00:00	38000275	0	\N	\N	137689	0	180256009	4107731	
23888	2077	4191853	1993-07-04	1993-07-04 00:00:00	38000275	0	\N	\N	138304	0	395142003	4191853	
12030	1099	4107731	1990-06-23	1990-06-23 00:00:00	38000275	0	\N	\N	72174	0	180256009	4107731	
24203	2119	4107731	1992-07-13	1992-07-13 00:00:00	38000275	0	\N	\N	141068	0	180256009	4107731	
12503	1134	4243062	2013-07-02	2013-07-02 00:00:00	38000275	0	\N	\N	74731	0	60027007	4243062	
24589	2151	4078793	1991-07-31	1991-07-31 00:00:00	38000275	0	\N	\N	143278	0	180325003	4078793	
24823	2173	4151422	2012-08-27	2012-08-27 00:00:00	38000275	0	\N	\N	144750	0	269911007	4151422	
13082	1176	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	77597	0	180256009	4107731	
25130	2189	4107731	2010-09-15	2010-09-15 00:00:00	38000275	0	\N	\N	145976	0	180256009	4107731	
25318	2200	4043071	1983-08-28	1983-08-28 00:00:00	38000275	0	\N	\N	146676	0	228557008	4043071	
25544	2231	4125906	2017-07-06	2017-07-06 00:00:00	38000275	0	\N	\N	148472	0	288086009	4125906	
25652	2243	4151422	1977-08-22	1977-08-22 00:00:00	38000275	0	\N	\N	149327	0	269911007	4151422	
13973	1261	4107731	1991-05-04	1991-05-04 00:00:00	38000275	0	\N	\N	83183	0	180256009	4107731	
14178	1276	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	84177	0	180256009	4107731	
26258	2291	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	152553	0	180256009	4107731	
26516	2307	4275113	1975-10-04	1975-10-04 00:00:00	38000275	0	\N	\N	153487	0	65200003	4275113	
26678	2337	4202451	2002-10-01	2002-10-01 00:00:00	38000275	0	\N	\N	155541	0	433112001	4202451	
26744	2339	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	155593	0	180256009	4107731	
26959	2352	4107731	1990-07-09	1990-07-09 00:00:00	38000275	0	\N	\N	156692	0	180256009	4107731	
15275	1365	4043071	1978-07-20	1978-07-20 00:00:00	38000275	0	\N	\N	90502	0	228557008	4043071	
27388	2392	4035793	2018-11-02	2018-11-02 00:00:00	38000275	0	\N	\N	158978	0	15081005	4035793	
15635	1387	4043071	1983-07-03	1983-07-03 00:00:00	38000275	0	\N	\N	92064	0	228557008	4043071	
27756	2436	4202451	1961-11-25	1961-11-25 00:00:00	38000275	0	\N	\N	161568	0	433112001	4202451	
16050	1399	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	93091	0	180256009	4107731	
16203	1407	4107731	1991-05-04	1991-05-04 00:00:00	38000275	0	\N	\N	93580	0	180256009	4107731	
28394	2522	4125906	1998-06-14	1998-06-14 00:00:00	38000275	0	\N	\N	166788	0	288086009	4125906	
28451	2534	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	167371	0	180256009	4107731	
28688	2545	4125906	1947-09-14	1947-09-14 00:00:00	38000275	0	\N	\N	168453	0	288086009	4125906	
28900	2554	4195803	2003-12-25	2003-12-25 00:00:00	38000275	0	\N	\N	169107	0	312681000	4195803	
17103	1478	4197460	1977-11-22	1977-11-22 00:00:00	38000275	0	\N	\N	98640	0	313191000	4197460	
17380	1497	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	99918	0	180256009	4107731	
17571	1511	4198190	2010-04-15	2010-04-15 00:00:00	38000275	0	\N	\N	100876	0	80146002	4198190	
17751	1525	4058899	1993-08-23	1993-08-23 00:00:00	38000275	0	\N	\N	102031	0	168594001	4058899	
29789	2647	4107731	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	175100	0	180256009	4107731	
30036	2659	4293740	2015-03-12	2015-03-12 00:00:00	38000275	0	\N	\N	176148	0	384700001	4293740	
30199	2672	4107731	1993-05-09	1993-05-09 00:00:00	38000275	0	\N	\N	176933	0	180256009	4107731	
30418	2685	4035793	2012-05-03	2012-05-03 00:00:00	38000275	0	\N	\N	177906	0	15081005	4035793	
18609	1586	4195803	1999-10-17	1999-10-17 00:00:00	38000275	0	\N	\N	106378	0	312681000	4195803	
30703	2715	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	179994	0	180256009	4107731	
30870	2732	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	180898	0	180256009	4107731	
31172	2765	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	182844	0	180256009	4107731	
19387	1659	4043071	1981-09-21	1981-09-21 00:00:00	38000275	0	\N	\N	111575	0	228557008	4043071	
31450	2778	4107731	1990-02-17	1990-02-17 00:00:00	38000275	0	\N	\N	184016	0	180256009	4107731	
31617	2782	4252419	1955-05-03	1955-05-03 00:00:00	38000275	0	\N	\N	184405	0	74016001	4252419	
31857	2804	4293740	1965-02-28	1965-02-28 00:00:00	38000275	0	\N	\N	185848	0	384700001	4293740	
20164	1743	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	116485	0	180256009	4107731	
20264	1753	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	117279	0	180256009	4107731	
32506	2858	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	189845	0	180256009	4107731	
32631	2863	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	190333	0	180256009	4107731	
44741	3916	4107731	1993-11-03	1993-11-03 00:00:00	38000275	0	\N	\N	260371	0	180256009	4107731	
32962	2893	4170947	1948-03-07	1948-03-07 00:00:00	38000275	0	\N	\N	192516	0	274474001	4170947	
21238	1843	4107731	1994-09-14	1994-09-14 00:00:00	38000275	0	\N	\N	123059	0	180256009	4107731	
21456	1855	4062501	1977-03-27	1977-03-27 00:00:00	38000275	0	\N	\N	124163	0	171231001	4062501	
45546	4017	4078793	1998-04-09	1998-04-09 00:00:00	38000275	0	\N	\N	267002	0	180325003	4078793	
33706	2942	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	196233	0	180256009	4107731	
33939	2959	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	197463	0	180256009	4107731	
34066	2965	4107731	1992-09-14	1992-09-14 00:00:00	38000275	0	\N	\N	197895	0	180256009	4107731	
22342	1956	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	130123	0	180256009	4107731	
22583	1976	4107731	1997-11-17	1997-11-17 00:00:00	38000275	0	\N	\N	131353	0	180256009	4107731	
34641	3007	4145310	1979-07-21	1979-07-21 00:00:00	38000275	0	\N	\N	200600	0	268425006	4145310	
34813	3025	4107731	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	201596	0	180256009	4107731	
47065	4130	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	274563	0	180256009	4107731	
35210	3067	4057420	1965-11-23	1965-11-23 00:00:00	38000275	0	\N	\N	204176	0	18286008	4057420	
35434	3105	4043071	1984-04-30	1984-04-30 00:00:00	38000275	0	\N	\N	206499	0	228557008	4043071	
23748	2070	4107731	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	137715	0	180256009	4107731	
23889	2077	4107731	1992-10-04	1992-10-04 00:00:00	38000275	0	\N	\N	138301	0	180256009	4107731	
12031	1099	4107731	1993-03-27	1993-03-27 00:00:00	38000275	0	\N	\N	72186	0	180256009	4107731	
24204	2119	4107731	1991-04-29	1991-04-29 00:00:00	38000275	0	\N	\N	141008	0	180256009	4107731	
12504	1134	4195803	2013-07-02	2013-07-02 00:00:00	38000275	0	\N	\N	74731	0	312681000	4195803	
24590	2151	4078793	1985-06-26	1985-06-26 00:00:00	38000275	0	\N	\N	143338	0	180325003	4078793	
24824	2173	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	144823	0	180256009	4107731	
13083	1176	4197460	1963-10-14	1963-10-14 00:00:00	38000275	0	\N	\N	77642	0	313191000	4197460	
25131	2189	4107731	2012-10-31	2012-10-31 00:00:00	38000275	0	\N	\N	145984	0	180256009	4107731	
25319	2200	4043071	1983-02-27	1983-02-27 00:00:00	38000275	0	\N	\N	146661	0	228557008	4043071	
25545	2231	4293740	2017-07-06	2017-07-06 00:00:00	38000275	0	\N	\N	148472	0	384700001	4293740	
25653	2243	4125906	1968-01-25	1968-01-25 00:00:00	38000275	0	\N	\N	149361	0	288086009	4125906	
13974	1261	4107731	1991-10-19	1991-10-19 00:00:00	38000275	0	\N	\N	83164	0	180256009	4107731	
14179	1276	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	84229	0	180256009	4107731	
26259	2291	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	152533	0	180256009	4107731	
26526	2309	4047491	2013-11-28	2013-11-28 00:00:00	38000275	0	\N	\N	153635	0	1225002	4047491	
26679	2337	4293740	1999-12-23	1999-12-23 00:00:00	38000275	0	\N	\N	155540	0	384700001	4293740	
26745	2339	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	155708	0	180256009	4107731	
26960	2352	4107731	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	156588	0	180256009	4107731	
15276	1365	4043071	1978-05-25	1978-05-25 00:00:00	38000275	0	\N	\N	90431	0	228557008	4043071	
27389	2392	4035793	1989-03-31	1989-03-31 00:00:00	38000275	0	\N	\N	159005	0	15081005	4035793	
15636	1387	4043071	1984-01-08	1984-01-08 00:00:00	38000275	0	\N	\N	92004	0	228557008	4043071	
27757	2436	4107731	1990-11-17	1990-11-17 00:00:00	38000275	0	\N	\N	161607	0	180256009	4107731	
16051	1399	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	93081	0	180256009	4107731	
16204	1407	4107731	1991-09-07	1991-09-07 00:00:00	38000275	0	\N	\N	93521	0	180256009	4107731	
28395	2525	4125906	1976-01-24	1976-01-24 00:00:00	38000275	0	\N	\N	166975	0	288086009	4125906	
28452	2534	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	167381	0	180256009	4107731	
28689	2545	4326177	1968-07-20	1968-07-20 00:00:00	38000275	0	\N	\N	168413	0	430193006	4326177	
28901	2554	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	169115	0	180256009	4107731	
17104	1478	4163872	2012-08-14	2012-08-14 00:00:00	38000275	0	\N	\N	98575	0	399208008	4163872	
17381	1497	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	99916	0	180256009	4107731	
17572	1512	4295880	1998-10-28	1998-10-28 00:00:00	38000275	0	\N	\N	100999	0	76601001	4295880	
17752	1525	4125906	2013-02-09	2013-02-09 00:00:00	38000275	0	\N	\N	102032	0	288086009	4125906	
29790	2647	4107731	1992-04-26	1992-04-26 00:00:00	38000275	0	\N	\N	175200	0	180256009	4107731	
30037	2659	4125906	1978-08-02	1978-08-02 00:00:00	38000275	0	\N	\N	176146	0	288086009	4125906	
30200	2672	4107731	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	177023	0	180256009	4107731	
30419	2685	4323902	1993-01-28	1993-01-28 00:00:00	38000275	0	\N	\N	177922	0	429609002	4323902	
18610	1586	4170947	2008-07-03	2008-07-03 00:00:00	38000275	0	\N	\N	106390	0	274474001	4170947	
30704	2715	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	180095	0	395142003	4191853	
30871	2732	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	180924	0	180256009	4107731	
31173	2765	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	182990	0	180256009	4107731	
19388	1659	4043071	1982-09-13	1982-09-13 00:00:00	38000275	0	\N	\N	111464	0	228557008	4043071	
31451	2778	4107731	1991-07-06	1991-07-06 00:00:00	38000275	0	\N	\N	184024	0	180256009	4107731	
31618	2782	4078793	2001-03-28	2001-03-28 00:00:00	38000275	0	\N	\N	184457	0	180325003	4078793	
31858	2806	4170947	2009-05-25	2009-05-25 00:00:00	38000275	0	\N	\N	185962	0	274474001	4170947	
20165	1743	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	116476	0	180256009	4107731	
20265	1753	4275113	1980-04-27	1980-04-27 00:00:00	38000275	0	\N	\N	117253	0	65200003	4275113	
32507	2858	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	189745	0	180256009	4107731	
32632	2863	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	190442	0	180256009	4107731	
44742	3916	4107731	1992-05-06	1992-05-06 00:00:00	38000275	0	\N	\N	260365	0	180256009	4107731	
32963	2893	4243062	1948-03-07	1948-03-07 00:00:00	38000275	0	\N	\N	192516	0	60027007	4243062	
21239	1843	4058899	1997-03-17	1997-03-17 00:00:00	38000275	0	\N	\N	123011	0	168594001	4058899	
21457	1855	4043071	1989-09-22	1989-09-22 00:00:00	38000275	0	\N	\N	124211	0	228557008	4043071	
45547	4017	4078793	2007-05-03	2007-05-03 00:00:00	38000275	0	\N	\N	267045	0	180325003	4078793	
33707	2942	4024289	1968-04-09	1968-04-09 00:00:00	38000275	0	\N	\N	196057	0	19490002	4024289	
33940	2959	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	197512	0	180256009	4107731	
34067	2965	4107731	1993-03-01	1993-03-01 00:00:00	38000275	0	\N	\N	197962	0	180256009	4107731	
22343	1956	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	130183	0	180256009	4107731	
22584	1976	4107731	1999-04-05	1999-04-05 00:00:00	38000275	0	\N	\N	131458	0	180256009	4107731	
34642	3007	4125906	1989-11-25	1989-11-25 00:00:00	38000275	0	\N	\N	200601	0	288086009	4125906	
34814	3025	4107731	1992-03-30	1992-03-30 00:00:00	38000275	0	\N	\N	201630	0	180256009	4107731	
47066	4130	4125906	1999-12-19	1999-12-19 00:00:00	38000275	0	\N	\N	274666	0	288086009	4125906	
35211	3067	40492359	1965-11-23	1965-11-23 00:00:00	38000275	0	\N	\N	204176	0	447365002	40492359	
35435	3105	4043071	1984-02-27	1984-02-27 00:00:00	38000275	0	\N	\N	206488	0	228557008	4043071	
23749	2070	4107731	1992-01-27	1992-01-27 00:00:00	38000275	0	\N	\N	137757	0	180256009	4107731	
23890	2077	4107731	1990-03-04	1990-03-04 00:00:00	38000275	0	\N	\N	138337	0	180256009	4107731	
12032	1100	4125906	2011-11-17	2011-11-17 00:00:00	38000275	0	\N	\N	72277	0	288086009	4125906	
24205	2119	4107731	1992-09-14	1992-09-14 00:00:00	38000275	0	\N	\N	140978	0	180256009	4107731	
12505	1134	4151422	1955-06-08	1955-06-08 00:00:00	38000275	0	\N	\N	74666	0	269911007	4151422	
24591	2151	4057420	1978-05-17	1978-05-17 00:00:00	38000275	0	\N	\N	143327	0	18286008	4057420	
24825	2173	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	144822	0	180256009	4107731	
13084	1177	4275113	1979-04-18	1979-04-18 00:00:00	38000275	0	\N	\N	77765	0	65200003	4275113	
25132	2189	4191853	2010-02-17	2010-02-17 00:00:00	38000275	0	\N	\N	145893	0	395142003	4191853	
25320	2200	4043071	1984-05-20	1984-05-20 00:00:00	38000275	0	\N	\N	146686	0	228557008	4043071	
25546	2232	4010253	1971-05-31	1971-05-31 00:00:00	38000275	0	\N	\N	148480	0	112790001	4010253	
25654	2244	4058899	1975-03-22	1975-03-22 00:00:00	38000275	0	\N	\N	149383	0	168594001	4058899	
13975	1261	4107731	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	83175	0	180256009	4107731	
14180	1276	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	84181	0	180256009	4107731	
26260	2291	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	152474	0	180256009	4107731	
26527	2309	4170947	2013-11-28	2013-11-28 00:00:00	38000275	0	\N	\N	153635	0	274474001	4170947	
26680	2337	4125906	1999-12-23	1999-12-23 00:00:00	38000275	0	\N	\N	155540	0	288086009	4125906	
26746	2339	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	155600	0	180256009	4107731	
26961	2352	4107731	1992-08-03	1992-08-03 00:00:00	38000275	0	\N	\N	156680	0	180256009	4107731	
15277	1365	4043071	1979-04-19	1979-04-19 00:00:00	38000275	0	\N	\N	90477	0	228557008	4043071	
27390	2392	4035793	2000-06-02	2000-06-02 00:00:00	38000275	0	\N	\N	159062	0	15081005	4035793	
15637	1387	4043071	1986-01-26	1986-01-26 00:00:00	38000275	0	\N	\N	92009	0	228557008	4043071	
27758	2436	4107731	1990-07-14	1990-07-14 00:00:00	38000275	0	\N	\N	161582	0	180256009	4107731	
16052	1399	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	92997	0	395142003	4191853	
16205	1407	4107731	1992-06-27	1992-06-27 00:00:00	38000275	0	\N	\N	93479	0	180256009	4107731	
28396	2525	4293740	1976-01-24	1976-01-24 00:00:00	38000275	0	\N	\N	166975	0	384700001	4293740	
28453	2534	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	167398	0	180256009	4107731	
28690	2545	4037675	1968-07-20	1968-07-20 00:00:00	38000275	0	\N	\N	168413	0	162676008	4037675	
28902	2554	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	169139	0	180256009	4107731	
17106	1480	4125906	1980-03-22	1980-03-22 00:00:00	38000275	0	\N	\N	98761	0	288086009	4125906	
17382	1497	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	99866	0	180256009	4107731	
17573	1512	4295880	1996-07-31	1996-07-31 00:00:00	38000275	0	\N	\N	100996	0	76601001	4295880	
17753	1525	4010253	1969-05-09	1969-05-09 00:00:00	38000275	0	\N	\N	101973	0	112790001	4010253	
29791	2647	4107731	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	175199	0	180256009	4107731	
30038	2659	4151422	2006-07-18	2006-07-18 00:00:00	38000275	0	\N	\N	176121	0	269911007	4151422	
30201	2672	4107731	1991-12-01	1991-12-01 00:00:00	38000275	0	\N	\N	176953	0	180256009	4107731	
30420	2685	4035793	1994-12-08	1994-12-08 00:00:00	38000275	0	\N	\N	177929	0	15081005	4035793	
18611	1586	4024289	2008-07-03	2008-07-03 00:00:00	38000275	0	\N	\N	106390	0	19490002	4024289	
30705	2715	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	179985	0	180256009	4107731	
30872	2732	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	180893	0	180256009	4107731	
31174	2765	4198190	1994-05-08	1994-05-08 00:00:00	38000275	0	\N	\N	182873	0	80146002	4198190	
19389	1659	4043071	1976-09-20	1976-09-20 00:00:00	38000275	0	\N	\N	111436	0	228557008	4043071	
31452	2778	4107731	1991-10-19	1991-10-19 00:00:00	38000275	0	\N	\N	183988	0	180256009	4107731	
31619	2782	4078793	1997-12-03	1997-12-03 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
31859	2806	4195803	2009-05-25	2009-05-25 00:00:00	38000275	0	\N	\N	185962	0	312681000	4195803	
20166	1743	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	116576	0	180256009	4107731	
20266	1753	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	117201	0	180256009	4107731	
32508	2858	4293740	1950-07-19	1950-07-19 00:00:00	38000275	0	\N	\N	189901	0	384700001	4293740	
32633	2863	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	190370	0	180256009	4107731	
44743	3916	4295880	1993-09-29	1993-09-29 00:00:00	38000275	0	\N	\N	260311	0	76601001	4295880	
32964	2893	4125906	2009-02-02	2009-02-02 00:00:00	38000275	0	\N	\N	192515	0	288086009	4125906	
21240	1843	4107731	1995-04-12	1995-04-12 00:00:00	38000275	0	\N	\N	123102	0	180256009	4107731	
21458	1855	4043071	1989-05-19	1989-05-19 00:00:00	38000275	0	\N	\N	124192	0	228557008	4043071	
45548	4017	4078793	2010-05-20	2010-05-20 00:00:00	38000275	0	\N	\N	267004	0	180325003	4078793	
33708	2942	4170947	1968-04-09	1968-04-09 00:00:00	38000275	0	\N	\N	196057	0	274474001	4170947	
33941	2959	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	197492	0	180256009	4107731	
34068	2965	4107731	1990-10-01	1990-10-01 00:00:00	38000275	0	\N	\N	197904	0	180256009	4107731	
22344	1956	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	130192	0	180256009	4107731	
22585	1976	4107731	1999-04-26	1999-04-26 00:00:00	38000275	0	\N	\N	131402	0	180256009	4107731	
34643	3007	4151422	1999-06-20	1999-06-20 00:00:00	38000275	0	\N	\N	200578	0	269911007	4151422	
34815	3025	4107731	1990-12-03	1990-12-03 00:00:00	38000275	0	\N	\N	201703	0	180256009	4107731	
47067	4130	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	274530	0	180256009	4107731	
35212	3067	4125906	2009-12-26	2009-12-26 00:00:00	38000275	0	\N	\N	204187	0	288086009	4125906	
35436	3105	4043071	1984-04-02	1984-04-02 00:00:00	38000275	0	\N	\N	206489	0	228557008	4043071	
35564	3114	4170947	2013-02-19	2013-02-19 00:00:00	38000275	0	\N	\N	207117	0	274474001	4170947	
23891	2077	4107731	1992-01-05	1992-01-05 00:00:00	38000275	0	\N	\N	138356	0	180256009	4107731	
12033	1100	4293740	2011-11-17	2011-11-17 00:00:00	38000275	0	\N	\N	72277	0	384700001	4293740	
24206	2119	4107731	1991-08-12	1991-08-12 00:00:00	38000275	0	\N	\N	141075	0	180256009	4107731	
12506	1134	4195803	1999-06-16	1999-06-16 00:00:00	38000275	0	\N	\N	74730	0	312681000	4195803	
24592	2151	4078793	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	143331	0	180325003	4078793	
24826	2173	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	144843	0	180256009	4107731	
13085	1177	4125906	2016-01-03	2016-01-03 00:00:00	38000275	0	\N	\N	77757	0	288086009	4125906	
25133	2189	4107731	2013-06-19	2013-06-19 00:00:00	38000275	0	\N	\N	145986	0	180256009	4107731	
25321	2200	4043071	1983-05-08	1983-05-08 00:00:00	38000275	0	\N	\N	146652	0	228557008	4043071	
25547	2232	4151422	1981-07-13	1981-07-13 00:00:00	38000275	0	\N	\N	148537	0	269911007	4151422	
25655	2244	4151422	1976-01-16	1976-01-16 00:00:00	38000275	0	\N	\N	149379	0	269911007	4151422	
13976	1261	4151422	1989-03-29	1989-03-29 00:00:00	38000275	0	\N	\N	83252	0	269911007	4151422	
14181	1276	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	84222	0	180256009	4107731	
26261	2291	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	152462	0	180256009	4107731	
26528	2309	4145310	1986-02-04	1986-02-04 00:00:00	38000275	0	\N	\N	153631	0	268425006	4145310	
26681	2337	4293740	2011-02-28	2011-02-28 00:00:00	38000275	0	\N	\N	155542	0	384700001	4293740	
26747	2339	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	155689	0	180256009	4107731	
26962	2352	4107731	1992-03-30	1992-03-30 00:00:00	38000275	0	\N	\N	156725	0	180256009	4107731	
15278	1365	4163872	1967-05-03	1967-05-03 00:00:00	38000275	0	\N	\N	90454	0	399208008	4163872	
27391	2392	4078793	2000-06-02	2000-06-02 00:00:00	38000275	0	\N	\N	159062	0	180325003	4078793	
15638	1387	4043071	1983-01-16	1983-01-16 00:00:00	38000275	0	\N	\N	92001	0	228557008	4043071	
27759	2436	4107731	1992-02-22	1992-02-22 00:00:00	38000275	0	\N	\N	161649	0	180256009	4107731	
16053	1399	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	93095	0	180256009	4107731	
16206	1408	4293740	1972-09-24	1972-09-24 00:00:00	38000275	0	\N	\N	93621	0	384700001	4293740	
28397	2526	4125906	2004-05-17	2004-05-17 00:00:00	38000275	0	\N	\N	167006	0	288086009	4125906	
28454	2534	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	167370	0	180256009	4107731	
28691	2545	4187458	1968-07-20	1968-07-20 00:00:00	38000275	0	\N	\N	168413	0	415300000	4187458	
28903	2554	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	169201	0	180256009	4107731	
17107	1480	4216130	2006-08-04	2006-08-04 00:00:00	38000275	0	\N	\N	98765	0	415070008	4216130	
17383	1497	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	99880	0	180256009	4107731	
17574	1512	4295880	1998-04-29	1998-04-29 00:00:00	38000275	0	\N	\N	101012	0	76601001	4295880	
17754	1525	4151422	1977-07-20	1977-07-20 00:00:00	38000275	0	\N	\N	101964	0	269911007	4151422	
29792	2647	4107731	1993-04-18	1993-04-18 00:00:00	38000275	0	\N	\N	175138	0	180256009	4107731	
30039	2659	4058899	2017-02-20	2017-02-20 00:00:00	38000275	0	\N	\N	176149	0	168594001	4058899	
30202	2672	4107731	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	176931	0	180256009	4107731	
30421	2685	4035793	1995-12-14	1995-12-14 00:00:00	38000275	0	\N	\N	177976	0	15081005	4035793	
18612	1586	4170947	1964-03-12	1964-03-12 00:00:00	38000275	0	\N	\N	106388	0	274474001	4170947	
30706	2715	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	180076	0	180256009	4107731	
30873	2732	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	180902	0	180256009	4107731	
31175	2765	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	182985	0	180256009	4107731	
19390	1659	4043071	1978-05-29	1978-05-29 00:00:00	38000275	0	\N	\N	111517	0	228557008	4043071	
31453	2778	4107731	1990-06-02	1990-06-02 00:00:00	38000275	0	\N	\N	183995	0	180256009	4107731	
31620	2782	4078793	1982-02-24	1982-02-24 00:00:00	38000275	0	\N	\N	184401	0	180325003	4078793	
31860	2806	4047491	2009-05-25	2009-05-25 00:00:00	38000275	0	\N	\N	185962	0	1225002	4047491	
20167	1743	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	116479	0	180256009	4107731	
20267	1753	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	117185	0	180256009	4107731	
32509	2858	4125906	1950-07-19	1950-07-19 00:00:00	38000275	0	\N	\N	189901	0	288086009	4125906	
32634	2863	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	190344	0	180256009	4107731	
44744	3916	4107731	1995-03-22	1995-03-22 00:00:00	38000275	0	\N	\N	260428	0	180256009	4107731	
32965	2894	4151422	1986-05-08	1986-05-08 00:00:00	38000275	0	\N	\N	192637	0	269911007	4151422	
21241	1843	4107731	1995-03-22	1995-03-22 00:00:00	38000275	0	\N	\N	123015	0	180256009	4107731	
21459	1855	4125906	1995-01-24	1995-01-24 00:00:00	38000275	0	\N	\N	124140	0	288086009	4125906	
45549	4017	4078793	2013-11-28	2013-11-28 00:00:00	38000275	0	\N	\N	267028	0	180325003	4078793	
33709	2942	4078793	2018-04-04	2018-04-04 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
33942	2959	4197460	1977-09-17	1977-09-17 00:00:00	38000275	0	\N	\N	197603	0	313191000	4197460	
34069	2965	4107731	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	197905	0	180256009	4107731	
22345	1956	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	130154	0	180256009	4107731	
22586	1976	4107731	1996-07-01	1996-07-01 00:00:00	38000275	0	\N	\N	131343	0	180256009	4107731	
34644	3007	4198190	1998-05-18	1998-05-18 00:00:00	38000275	0	\N	\N	200604	0	80146002	4198190	
34816	3025	4107731	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	201608	0	180256009	4107731	
47068	4130	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	274629	0	180256009	4107731	
35213	3067	4151422	1994-10-18	1994-10-18 00:00:00	38000275	0	\N	\N	204178	0	269911007	4151422	
35437	3105	4043071	1984-06-04	1984-06-04 00:00:00	38000275	0	\N	\N	206506	0	228557008	4043071	
35565	3114	4195803	2013-02-19	2013-02-19 00:00:00	38000275	0	\N	\N	207117	0	312681000	4195803	
23892	2077	4107731	1990-05-06	1990-05-06 00:00:00	38000275	0	\N	\N	138243	0	180256009	4107731	
12034	1100	4163872	1996-03-03	1996-03-03 00:00:00	38000275	0	\N	\N	72274	0	399208008	4163872	
24207	2119	4107731	1992-11-16	1992-11-16 00:00:00	38000275	0	\N	\N	141033	0	180256009	4107731	
12507	1134	4058899	1999-06-16	1999-06-16 00:00:00	38000275	0	\N	\N	74730	0	168594001	4058899	
24593	2151	4202451	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	143331	0	433112001	4202451	
24827	2173	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	144781	0	180256009	4107731	
13086	1177	4125906	1966-04-13	1966-04-13 00:00:00	38000275	0	\N	\N	77755	0	288086009	4125906	
25134	2189	4107731	2011-05-04	2011-05-04 00:00:00	38000275	0	\N	\N	145978	0	180256009	4107731	
25322	2200	4043071	1984-10-21	1984-10-21 00:00:00	38000275	0	\N	\N	146688	0	228557008	4043071	
25548	2232	4125906	2001-09-08	2001-09-08 00:00:00	38000275	0	\N	\N	148474	0	288086009	4125906	
25656	2244	4125906	1993-01-16	1993-01-16 00:00:00	38000275	0	\N	\N	149384	0	288086009	4125906	
13977	1261	4125906	1972-03-06	1972-03-06 00:00:00	38000275	0	\N	\N	83215	0	288086009	4125906	
14182	1276	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	84144	0	180256009	4107731	
26262	2291	4170947	1977-12-20	1977-12-20 00:00:00	38000275	0	\N	\N	152493	0	274474001	4170947	
26529	2309	44783196	2018-01-13	2018-01-13 00:00:00	38000275	0	\N	\N	153618	0	699253003	44783196	
26682	2337	4125906	2011-02-28	2011-02-28 00:00:00	38000275	0	\N	\N	155542	0	288086009	4125906	
26748	2339	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	155686	0	180256009	4107731	
26963	2352	4107731	1992-11-16	1992-11-16 00:00:00	38000275	0	\N	\N	156672	0	180256009	4107731	
15279	1365	4170947	1967-05-03	1967-05-03 00:00:00	38000275	0	\N	\N	90454	0	274474001	4170947	
27392	2392	4035793	2008-07-18	2008-07-18 00:00:00	38000275	0	\N	\N	158973	0	15081005	4035793	
15639	1387	4043071	1986-05-11	1986-05-11 00:00:00	38000275	0	\N	\N	92012	0	228557008	4043071	
27760	2436	4107731	1991-05-04	1991-05-04 00:00:00	38000275	0	\N	\N	161523	0	180256009	4107731	
16054	1399	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	93029	0	180256009	4107731	
16207	1408	4125906	1972-09-24	1972-09-24 00:00:00	38000275	0	\N	\N	93621	0	288086009	4125906	
28398	2526	4293740	2004-05-17	2004-05-17 00:00:00	38000275	0	\N	\N	167006	0	384700001	4293740	
28455	2534	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	167462	0	180256009	4107731	
28692	2546	4024289	1987-07-14	1987-07-14 00:00:00	38000275	0	\N	\N	168460	0	19490002	4024289	
28904	2554	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	169138	0	180256009	4107731	
17108	1480	4336464	2006-08-04	2006-08-04 00:00:00	38000275	0	\N	\N	98765	0	232717009	4336464	
17384	1497	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	99806	0	180256009	4107731	
17575	1512	4125906	2010-10-01	2010-10-01 00:00:00	38000275	0	\N	\N	100938	0	288086009	4125906	
17755	1526	4125906	2005-09-30	2005-09-30 00:00:00	38000275	0	\N	\N	102050	0	288086009	4125906	
29793	2647	4107731	1990-10-28	1990-10-28 00:00:00	38000275	0	\N	\N	175102	0	180256009	4107731	
30042	2661	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	176303	0	180256009	4107731	
30203	2672	4107731	1991-03-03	1991-03-03 00:00:00	38000275	0	\N	\N	177044	0	180256009	4107731	
30422	2685	4035793	2013-05-09	2013-05-09 00:00:00	38000275	0	\N	\N	177980	0	15081005	4035793	
18613	1586	4047491	1964-03-12	1964-03-12 00:00:00	38000275	0	\N	\N	106388	0	1225002	4047491	
30707	2715	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	180036	0	180256009	4107731	
30874	2732	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	180926	0	180256009	4107731	
31176	2765	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	182871	0	180256009	4107731	
19391	1659	4043071	1979-05-07	1979-05-07 00:00:00	38000275	0	\N	\N	111484	0	228557008	4043071	
31454	2778	4107731	1993-03-27	1993-03-27 00:00:00	38000275	0	\N	\N	184041	0	180256009	4107731	
31621	2782	4057420	1983-03-02	1983-03-02 00:00:00	38000275	0	\N	\N	184415	0	18286008	4057420	
31861	2806	4195803	2013-06-13	2013-06-13 00:00:00	38000275	0	\N	\N	185935	0	312681000	4195803	
20168	1743	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	116590	0	180256009	4107731	
20268	1753	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	117176	0	180256009	4107731	
32510	2858	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	189881	0	395142003	4191853	
32635	2863	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	190448	0	180256009	4107731	
44745	3916	4107731	1993-11-24	1993-11-24 00:00:00	38000275	0	\N	\N	260415	0	180256009	4107731	
32966	2894	4252419	1923-01-07	1923-01-07 00:00:00	38000275	0	\N	\N	192620	0	74016001	4252419	
21242	1843	4107731	1994-10-26	1994-10-26 00:00:00	38000275	0	\N	\N	123060	0	180256009	4107731	
21460	1855	4043071	1989-07-21	1989-07-21 00:00:00	38000275	0	\N	\N	124221	0	228557008	4043071	
45550	4017	4078793	2012-11-08	2012-11-08 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
33710	2942	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	196111	0	180256009	4107731	
33943	2959	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	197502	0	180256009	4107731	
34070	2965	4107731	1990-01-22	1990-01-22 00:00:00	38000275	0	\N	\N	198030	0	180256009	4107731	
22346	1956	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	130125	0	180256009	4107731	
22587	1976	4107731	1998-11-30	1998-11-30 00:00:00	38000275	0	\N	\N	131362	0	180256009	4107731	
34648	3010	4047491	1989-05-22	1989-05-22 00:00:00	38000275	0	\N	\N	200799	0	1225002	4047491	
34817	3025	4187458	1988-11-15	1988-11-15 00:00:00	38000275	0	\N	\N	201604	0	415300000	4187458	
47069	4130	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	274624	0	180256009	4107731	
35214	3067	4170947	2010-12-05	2010-12-05 00:00:00	38000275	0	\N	\N	204188	0	274474001	4170947	
35438	3105	4163872	1981-12-26	1981-12-26 00:00:00	38000275	0	\N	\N	206509	0	399208008	4163872	
35566	3114	4243062	2013-02-19	2013-02-19 00:00:00	38000275	0	\N	\N	207117	0	60027007	4243062	
23893	2077	4191853	1989-12-31	1989-12-31 00:00:00	38000275	0	\N	\N	138284	0	395142003	4191853	
12035	1100	4170947	1996-03-03	1996-03-03 00:00:00	38000275	0	\N	\N	72274	0	274474001	4170947	
24208	2119	4107731	1990-04-16	1990-04-16 00:00:00	38000275	0	\N	\N	141005	0	180256009	4107731	
12508	1134	4252419	1947-07-19	1947-07-19 00:00:00	38000275	0	\N	\N	74729	0	74016001	4252419	
24594	2151	4078793	1989-07-19	1989-07-19 00:00:00	38000275	0	\N	\N	143329	0	180325003	4078793	
24828	2173	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	144859	0	180256009	4107731	
13087	1177	4125906	2000-07-04	2000-07-04 00:00:00	38000275	0	\N	\N	77756	0	288086009	4125906	
25135	2189	4125906	1988-09-18	1988-09-18 00:00:00	38000275	0	\N	\N	145890	0	288086009	4125906	
25323	2200	4043071	1985-09-08	1985-09-08 00:00:00	38000275	0	\N	\N	146624	0	228557008	4043071	
25549	2232	4125906	2011-12-29	2011-12-29 00:00:00	38000275	0	\N	\N	148475	0	288086009	4125906	
25657	2244	4078793	2018-10-19	2018-10-19 00:00:00	38000275	0	\N	\N	149432	0	180325003	4078793	
13978	1261	4293740	1972-03-06	1972-03-06 00:00:00	38000275	0	\N	\N	83215	0	384700001	4293740	
14183	1276	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	84191	0	180256009	4107731	
26263	2291	4243062	1977-12-20	1977-12-20 00:00:00	38000275	0	\N	\N	152493	0	60027007	4243062	
26530	2309	4163872	1980-04-06	1980-04-06 00:00:00	38000275	0	\N	\N	153630	0	399208008	4163872	
26683	2337	4151422	2004-07-08	2004-07-08 00:00:00	38000275	0	\N	\N	155473	0	269911007	4151422	
26749	2339	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	155661	0	180256009	4107731	
26964	2352	4107731	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	156597	0	180256009	4107731	
15280	1365	4043071	1979-06-28	1979-06-28 00:00:00	38000275	0	\N	\N	90422	0	228557008	4043071	
27393	2392	4078793	2008-07-18	2008-07-18 00:00:00	38000275	0	\N	\N	158973	0	180325003	4078793	
15640	1387	4043071	1986-09-21	1986-09-21 00:00:00	38000275	0	\N	\N	92029	0	228557008	4043071	
27761	2436	4107731	1992-06-06	1992-06-06 00:00:00	38000275	0	\N	\N	161549	0	180256009	4107731	
16055	1399	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	93048	0	180256009	4107731	
16208	1408	4058899	1978-05-10	1978-05-10 00:00:00	38000275	0	\N	\N	93622	0	168594001	4058899	
28399	2526	4125906	2012-04-19	2012-04-19 00:00:00	38000275	0	\N	\N	167007	0	288086009	4125906	
28456	2534	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	167382	0	180256009	4107731	
28693	2546	4125906	1976-01-22	1976-01-22 00:00:00	38000275	0	\N	\N	168458	0	288086009	4125906	
28905	2554	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	169123	0	180256009	4107731	
17109	1480	4170947	1973-07-13	1973-07-13 00:00:00	38000275	0	\N	\N	98759	0	274474001	4170947	
17385	1497	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	99808	0	180256009	4107731	
17576	1512	4295880	1995-05-03	1995-05-03 00:00:00	38000275	0	\N	\N	100963	0	76601001	4295880	
29590	2636	4216130	2019-03-08	2019-03-08 00:00:00	38000275	0	\N	\N	174490	0	415070008	4216130	
29794	2647	4107731	1991-02-10	1991-02-10 00:00:00	38000275	0	\N	\N	175212	0	180256009	4107731	
30043	2661	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	176278	0	180256009	4107731	
30204	2672	4107731	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	176957	0	180256009	4107731	
30423	2685	4035793	2017-06-01	2017-06-01 00:00:00	38000275	0	\N	\N	177982	0	15081005	4035793	
18616	1588	4151422	2015-07-05	2015-07-05 00:00:00	38000275	0	\N	\N	106618	0	269911007	4151422	
30708	2715	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	179977	0	180256009	4107731	
30875	2732	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	180941	0	180256009	4107731	
31177	2765	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	182937	0	180256009	4107731	
19392	1659	4043071	1976-11-15	1976-11-15 00:00:00	38000275	0	\N	\N	111552	0	228557008	4043071	
31455	2778	4107731	1990-07-14	1990-07-14 00:00:00	38000275	0	\N	\N	183996	0	180256009	4107731	
31622	2782	4078793	1984-03-07	1984-03-07 00:00:00	38000275	0	\N	\N	184374	0	180325003	4078793	
31862	2806	4243062	1982-01-10	1982-01-10 00:00:00	38000275	0	\N	\N	185960	0	60027007	4243062	
20169	1743	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	116534	0	395142003	4191853	
20269	1753	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	117303	0	180256009	4107731	
32511	2858	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	189931	0	180256009	4107731	
32636	2863	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	190434	0	180256009	4107731	
44746	3916	4295880	1994-09-28	1994-09-28 00:00:00	38000275	0	\N	\N	260379	0	76601001	4295880	
32967	2894	4195803	1991-02-24	1991-02-24 00:00:00	38000275	0	\N	\N	192600	0	312681000	4195803	
21243	1843	4107731	1997-09-10	1997-09-10 00:00:00	38000275	0	\N	\N	123120	0	180256009	4107731	
21461	1855	4043071	1989-04-21	1989-04-21 00:00:00	38000275	0	\N	\N	124160	0	228557008	4043071	
45551	4017	4170947	1937-04-08	1937-04-08 00:00:00	38000275	0	\N	\N	267030	0	274474001	4170947	
33711	2942	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	196065	0	180256009	4107731	
33944	2959	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	197565	0	180256009	4107731	
34071	2965	4047491	1987-09-06	1987-09-06 00:00:00	38000275	0	\N	\N	197985	0	1225002	4047491	
22347	1956	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	130137	0	180256009	4107731	
22588	1976	4191853	1986-01-15	1986-01-15 00:00:00	38000275	0	\N	\N	131339	0	395142003	4191853	
34649	3010	4170947	1989-05-22	1989-05-22 00:00:00	38000275	0	\N	\N	200799	0	274474001	4170947	
34818	3025	4326177	1988-11-15	1988-11-15 00:00:00	38000275	0	\N	\N	201604	0	430193006	4326177	
47070	4130	4078793	2019-05-23	2019-05-23 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
35215	3067	4243062	2010-12-05	2010-12-05 00:00:00	38000275	0	\N	\N	204188	0	60027007	4243062	
35439	3105	4293740	2004-07-15	2004-07-15 00:00:00	38000275	0	\N	\N	206482	0	384700001	4293740	
35567	3114	4151422	1953-09-12	1953-09-12 00:00:00	38000275	0	\N	\N	207141	0	269911007	4151422	
23894	2077	4107731	1990-04-15	1990-04-15 00:00:00	38000275	0	\N	\N	138348	0	180256009	4107731	
12036	1100	44783196	2010-11-22	2010-11-22 00:00:00	38000275	0	\N	\N	72272	0	699253003	44783196	
24209	2119	4107731	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	141072	0	180256009	4107731	
12509	1134	4151422	1966-08-01	1966-08-01 00:00:00	38000275	0	\N	\N	74679	0	269911007	4151422	
24595	2152	4202451	1988-01-23	1988-01-23 00:00:00	38000275	0	\N	\N	143347	0	433112001	4202451	
24829	2173	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	144821	0	180256009	4107731	
13088	1177	4238715	1982-07-05	1982-07-05 00:00:00	38000275	0	\N	\N	77790	0	68254000	4238715	
25136	2189	4293740	1988-09-18	1988-09-18 00:00:00	38000275	0	\N	\N	145890	0	384700001	4293740	
25324	2200	4043071	1984-04-22	1984-04-22 00:00:00	38000275	0	\N	\N	146678	0	228557008	4043071	
25550	2233	4125906	2001-09-06	2001-09-06 00:00:00	38000275	0	\N	\N	148605	0	288086009	4125906	
25658	2244	4078793	2017-10-13	2017-10-13 00:00:00	38000275	0	\N	\N	149422	0	180325003	4078793	
13979	1261	4107731	1991-04-13	1991-04-13 00:00:00	38000275	0	\N	\N	83212	0	180256009	4107731	
14184	1276	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	84278	0	180256009	4107731	
26264	2291	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	152437	0	180256009	4107731	
26531	2309	4170947	1980-04-06	1980-04-06 00:00:00	38000275	0	\N	\N	153630	0	274474001	4170947	
26687	2339	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	155694	0	180256009	4107731	
26750	2339	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	155641	0	180256009	4107731	
26965	2352	4107731	1991-03-18	1991-03-18 00:00:00	38000275	0	\N	\N	156708	0	180256009	4107731	
15281	1365	4043071	1979-03-22	1979-03-22 00:00:00	38000275	0	\N	\N	90525	0	228557008	4043071	
27394	2392	4035793	2015-10-16	2015-10-16 00:00:00	38000275	0	\N	\N	159069	0	15081005	4035793	
15641	1387	4043071	1985-02-17	1985-02-17 00:00:00	38000275	0	\N	\N	92022	0	228557008	4043071	
27762	2436	4107731	1993-05-29	1993-05-29 00:00:00	38000275	0	\N	\N	161509	0	180256009	4107731	
16056	1399	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	93026	0	180256009	4107731	
16209	1409	4163872	1937-09-07	1937-09-07 00:00:00	38000275	0	\N	\N	93813	0	399208008	4163872	
28400	2526	44783196	1996-07-07	1996-07-07 00:00:00	38000275	0	\N	\N	167005	0	699253003	44783196	
28457	2534	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	167426	0	180256009	4107731	
28694	2546	4170947	1987-07-14	1987-07-14 00:00:00	38000275	0	\N	\N	168460	0	274474001	4170947	
28906	2554	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	169247	0	180256009	4107731	
17110	1480	4195803	1973-07-13	1973-07-13 00:00:00	38000275	0	\N	\N	98759	0	312681000	4195803	
17386	1497	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	99803	0	180256009	4107731	
17577	1512	4295880	1996-05-01	1996-05-01 00:00:00	38000275	0	\N	\N	100958	0	76601001	4295880	
29591	2636	4336464	2019-03-08	2019-03-08 00:00:00	38000275	0	\N	\N	174490	0	232717009	4336464	
29795	2647	4107731	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	175107	0	180256009	4107731	
30044	2661	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	176386	0	180256009	4107731	
30205	2673	4107731	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	177088	0	180256009	4107731	
30424	2685	4035793	2002-03-07	2002-03-07 00:00:00	38000275	0	\N	\N	177978	0	15081005	4035793	
18617	1588	4163872	1984-10-01	1984-10-01 00:00:00	38000275	0	\N	\N	106633	0	399208008	4163872	
30709	2715	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	180035	0	180256009	4107731	
30876	2732	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	180947	0	180256009	4107731	
31178	2765	4035793	2018-01-09	2018-01-09 00:00:00	38000275	0	\N	\N	182948	0	15081005	4035793	
19393	1659	4043071	1978-01-23	1978-01-23 00:00:00	38000275	0	\N	\N	111480	0	228557008	4043071	
31456	2778	4107731	1990-06-23	1990-06-23 00:00:00	38000275	0	\N	\N	184030	0	180256009	4107731	
31627	2786	4024289	2004-01-08	2004-01-08 00:00:00	38000275	0	\N	\N	184614	0	19490002	4024289	
31863	2806	4170947	1982-01-10	1982-01-10 00:00:00	38000275	0	\N	\N	185960	0	274474001	4170947	
20170	1743	4125906	2012-03-24	2012-03-24 00:00:00	38000275	0	\N	\N	116512	0	288086009	4125906	
20270	1753	4125906	1968-05-16	1968-05-16 00:00:00	38000275	0	\N	\N	117163	0	288086009	4125906	
32512	2858	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	189813	0	180256009	4107731	
32637	2863	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	190441	0	180256009	4107731	
44747	3916	4107731	1992-08-19	1992-08-19 00:00:00	38000275	0	\N	\N	260270	0	180256009	4107731	
32968	2894	4058899	1991-02-24	1991-02-24 00:00:00	38000275	0	\N	\N	192600	0	168594001	4058899	
21244	1843	4107731	1997-04-16	1997-04-16 00:00:00	38000275	0	\N	\N	123037	0	180256009	4107731	
21462	1855	4125906	1991-12-27	1991-12-27 00:00:00	38000275	0	\N	\N	124139	0	288086009	4125906	
45552	4017	4243062	1937-04-08	1937-04-08 00:00:00	38000275	0	\N	\N	267030	0	60027007	4243062	
33712	2942	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	196230	0	180256009	4107731	
33945	2959	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	197561	0	180256009	4107731	
34072	2965	4170947	1987-09-06	1987-09-06 00:00:00	38000275	0	\N	\N	197985	0	274474001	4170947	
22348	1956	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	130158	0	180256009	4107731	
22589	1976	4107731	1996-03-18	1996-03-18 00:00:00	38000275	0	\N	\N	131363	0	180256009	4107731	
34650	3010	4202451	2015-03-18	2015-03-18 00:00:00	38000275	0	\N	\N	200792	0	433112001	4202451	
34819	3025	4037675	1988-11-15	1988-11-15 00:00:00	38000275	0	\N	\N	201604	0	162676008	4037675	
47071	4130	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	274584	0	180256009	4107731	
35216	3067	4195803	2010-12-05	2010-12-05 00:00:00	38000275	0	\N	\N	204188	0	312681000	4195803	
35440	3105	4125906	2004-07-15	2004-07-15 00:00:00	38000275	0	\N	\N	206482	0	288086009	4125906	
35568	3114	4243062	2016-04-04	2016-04-04 00:00:00	38000275	0	\N	\N	207118	0	60027007	4243062	
23895	2077	4107731	1991-03-17	1991-03-17 00:00:00	38000275	0	\N	\N	138217	0	180256009	4107731	
12037	1100	4058899	2004-02-20	2004-02-20 00:00:00	38000275	0	\N	\N	72275	0	168594001	4058899	
24210	2119	4107731	1991-09-02	1991-09-02 00:00:00	38000275	0	\N	\N	141064	0	180256009	4107731	
12510	1135	4151422	2014-07-13	2014-07-13 00:00:00	38000275	0	\N	\N	74773	0	269911007	4151422	
24596	2152	4078793	2016-04-09	2016-04-09 00:00:00	38000275	0	\N	\N	143342	0	180325003	4078793	
24830	2173	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	144780	0	180256009	4107731	
24872	2173	4191853	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	144748	0	395142003	4191853	
25137	2189	4107731	2011-09-28	2011-09-28 00:00:00	38000275	0	\N	\N	145900	0	180256009	4107731	
25325	2200	4043071	1981-09-13	1981-09-13 00:00:00	38000275	0	\N	\N	146705	0	228557008	4043071	
25551	2235	4151422	2002-09-09	2002-09-09 00:00:00	38000275	0	\N	\N	148678	0	269911007	4151422	
25659	2244	4198190	1964-07-23	1964-07-23 00:00:00	38000275	0	\N	\N	149423	0	80146002	4198190	
13981	1264	4035793	2016-05-20	2016-05-20 00:00:00	38000275	0	\N	\N	83282	0	15081005	4035793	
14185	1276	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	84275	0	180256009	4107731	
26265	2291	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	152559	0	180256009	4107731	
26532	2309	4252419	2018-01-06	2018-01-06 00:00:00	38000275	0	\N	\N	153636	0	74016001	4252419	
26688	2339	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	155659	0	180256009	4107731	
26751	2339	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	155667	0	180256009	4107731	
26966	2352	4107731	1991-08-12	1991-08-12 00:00:00	38000275	0	\N	\N	156723	0	180256009	4107731	
15282	1365	4043071	1977-09-22	1977-09-22 00:00:00	38000275	0	\N	\N	90516	0	228557008	4043071	
27395	2392	4057420	2015-10-16	2015-10-16 00:00:00	38000275	0	\N	\N	159069	0	18286008	4057420	
15642	1387	4043071	1981-08-23	1981-08-23 00:00:00	38000275	0	\N	\N	91990	0	228557008	4043071	
27763	2436	4107731	1992-04-25	1992-04-25 00:00:00	38000275	0	\N	\N	161528	0	180256009	4107731	
16057	1399	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	93028	0	180256009	4107731	
16210	1409	4125906	2012-09-03	2012-09-03 00:00:00	38000275	0	\N	\N	93833	0	288086009	4125906	
28401	2526	4252419	1996-06-30	1996-06-30 00:00:00	38000275	0	\N	\N	167003	0	74016001	4252419	
28458	2534	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	167378	0	180256009	4107731	
28695	2546	4145310	1985-05-25	1985-05-25 00:00:00	38000275	0	\N	\N	168459	0	268425006	4145310	
28907	2554	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	169275	0	180256009	4107731	
17111	1480	4047491	1973-07-13	1973-07-13 00:00:00	38000275	0	\N	\N	98759	0	1225002	4047491	
17387	1497	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	99777	0	180256009	4107731	
17578	1512	4295880	1998-07-29	1998-07-29 00:00:00	38000275	0	\N	\N	100966	0	76601001	4295880	
29592	2636	4125906	2018-07-04	2018-07-04 00:00:00	38000275	0	\N	\N	174421	0	288086009	4125906	
29796	2647	4107731	1990-08-26	1990-08-26 00:00:00	38000275	0	\N	\N	175117	0	180256009	4107731	
30045	2661	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	176225	0	180256009	4107731	
30206	2673	4107731	1992-10-05	1992-10-05 00:00:00	38000275	0	\N	\N	177093	0	180256009	4107731	
30425	2685	4035793	2014-05-15	2014-05-15 00:00:00	38000275	0	\N	\N	177934	0	15081005	4035793	
18618	1588	4125906	2018-12-30	2018-12-30 00:00:00	38000275	0	\N	\N	106568	0	288086009	4125906	
30710	2715	4336464	2017-11-23	2017-11-23 00:00:00	38000275	0	\N	\N	179971	0	232717009	4336464	
30877	2732	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	180942	0	180256009	4107731	
31179	2765	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	182929	0	180256009	4107731	
19394	1659	4043071	1979-06-11	1979-06-11 00:00:00	38000275	0	\N	\N	111547	0	228557008	4043071	
31457	2778	4191853	1978-02-02	1978-02-02 00:00:00	38000275	0	\N	\N	183994	0	395142003	4191853	
31628	2786	4170947	2004-01-08	2004-01-08 00:00:00	38000275	0	\N	\N	184614	0	274474001	4170947	
31864	2806	4151422	1985-02-28	1985-02-28 00:00:00	38000275	0	\N	\N	185992	0	269911007	4151422	
20171	1743	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	116525	0	180256009	4107731	
20271	1753	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	117188	0	180256009	4107731	
32513	2858	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	189887	0	180256009	4107731	
32638	2864	4151422	2015-04-07	2015-04-07 00:00:00	38000275	0	\N	\N	190532	0	269911007	4151422	
44748	3916	4295880	1999-06-23	1999-06-23 00:00:00	38000275	0	\N	\N	260383	0	76601001	4295880	
32969	2894	44783196	1998-03-24	1998-03-24 00:00:00	38000275	0	\N	\N	192596	0	699253003	44783196	
21245	1843	4107731	1997-12-03	1997-12-03 00:00:00	38000275	0	\N	\N	123039	0	180256009	4107731	
21463	1855	4293740	1991-12-27	1991-12-27 00:00:00	38000275	0	\N	\N	124139	0	384700001	4293740	
45553	4017	4078793	2000-04-20	2000-04-20 00:00:00	38000275	0	\N	\N	266929	0	180325003	4078793	
33713	2942	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	196186	0	180256009	4107731	
33946	2959	4043071	1979-12-12	1979-12-12 00:00:00	38000275	0	\N	\N	197572	0	228557008	4043071	
34073	2965	4107731	1992-01-27	1992-01-27 00:00:00	38000275	0	\N	\N	197993	0	180256009	4107731	
22349	1956	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	130185	0	180256009	4107731	
22590	1976	4107731	1997-08-04	1997-08-04 00:00:00	38000275	0	\N	\N	131368	0	180256009	4107731	
34651	3010	4058899	1980-10-06	1980-10-06 00:00:00	38000275	0	\N	\N	200798	0	168594001	4058899	
34820	3025	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	201619	0	180256009	4107731	
47072	4130	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	274556	0	180256009	4107731	
35217	3067	4326177	1969-12-11	1969-12-11 00:00:00	38000275	0	\N	\N	204102	0	430193006	4326177	
35445	3109	4043071	1927-08-03	1927-08-03 00:00:00	38000275	0	\N	\N	206809	0	228557008	4043071	
35569	3114	4195803	2016-04-04	2016-04-04 00:00:00	38000275	0	\N	\N	207118	0	312681000	4195803	
23896	2077	4107731	1990-03-25	1990-03-25 00:00:00	38000275	0	\N	\N	138242	0	180256009	4107731	
12038	1100	4252419	2010-11-15	2010-11-15 00:00:00	38000275	0	\N	\N	72276	0	74016001	4252419	
24211	2119	4107731	1992-02-17	1992-02-17 00:00:00	38000275	0	\N	\N	141030	0	180256009	4107731	
12511	1135	4151422	1996-05-09	1996-05-09 00:00:00	38000275	0	\N	\N	74764	0	269911007	4151422	
24597	2152	4078793	2013-03-23	2013-03-23 00:00:00	38000275	0	\N	\N	143402	0	180325003	4078793	
24831	2173	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	144844	0	180256009	4107731	
24873	2173	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	144819	0	180256009	4107731	
25138	2189	4107731	2011-05-25	2011-05-25 00:00:00	38000275	0	\N	\N	145937	0	180256009	4107731	
25326	2200	4043071	1981-06-14	1981-06-14 00:00:00	38000275	0	\N	\N	146631	0	228557008	4043071	
25552	2235	4202451	2012-12-12	2012-12-12 00:00:00	38000275	0	\N	\N	148639	0	433112001	4202451	
25660	2244	4243062	1966-08-15	1966-08-15 00:00:00	38000275	0	\N	\N	149381	0	60027007	4243062	
13982	1264	4035793	2017-05-26	2017-05-26 00:00:00	38000275	0	\N	\N	83294	0	15081005	4035793	
14186	1276	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	84262	0	180256009	4107731	
26266	2291	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	152455	0	180256009	4107731	
26533	2311	4151422	1963-03-25	1963-03-25 00:00:00	38000275	0	\N	\N	153717	0	269911007	4151422	
26689	2339	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	155594	0	180256009	4107731	
26752	2339	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	155684	0	180256009	4107731	
26967	2352	4107731	1991-09-02	1991-09-02 00:00:00	38000275	0	\N	\N	156592	0	180256009	4107731	
15283	1365	4043071	1979-11-08	1979-11-08 00:00:00	38000275	0	\N	\N	90478	0	228557008	4043071	
27396	2392	4163872	1958-07-23	1958-07-23 00:00:00	38000275	0	\N	\N	159027	0	399208008	4163872	
15643	1387	4043071	1985-01-20	1985-01-20 00:00:00	38000275	0	\N	\N	92053	0	228557008	4043071	
27764	2436	4107731	1991-09-28	1991-09-28 00:00:00	38000275	0	\N	\N	161611	0	180256009	4107731	
16058	1399	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	93089	0	180256009	4107731	
16211	1409	4170947	1946-05-23	1946-05-23 00:00:00	38000275	0	\N	\N	93832	0	274474001	4170947	
28402	2528	4293740	2018-11-23	2018-11-23 00:00:00	38000275	0	\N	\N	167134	0	384700001	4293740	
28459	2534	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	167400	0	180256009	4107731	
28766	2548	4151422	1975-11-12	1975-11-12 00:00:00	38000275	0	\N	\N	168695	0	269911007	4151422	
28908	2554	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	169269	0	180256009	4107731	
17112	1480	4293740	1974-09-06	1974-09-06 00:00:00	38000275	0	\N	\N	98760	0	384700001	4293740	
17388	1497	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	99849	0	180256009	4107731	
29362	2619	4024289	1948-06-21	1948-06-21 00:00:00	38000275	0	\N	\N	173199	0	19490002	4024289	
29593	2636	4293740	2018-07-04	2018-07-04 00:00:00	38000275	0	\N	\N	174421	0	384700001	4293740	
29797	2647	4107731	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	175159	0	180256009	4107731	
30046	2661	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	176294	0	180256009	4107731	
30207	2673	4107731	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	177134	0	180256009	4107731	
30426	2685	4035793	2016-05-26	2016-05-26 00:00:00	38000275	0	\N	\N	177935	0	15081005	4035793	
18619	1588	4198190	1981-12-01	1981-12-01 00:00:00	38000275	0	\N	\N	106624	0	80146002	4198190	
30711	2715	4216130	2017-11-23	2017-11-23 00:00:00	38000275	0	\N	\N	179971	0	415070008	4216130	
30878	2732	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	180938	0	180256009	4107731	
31180	2765	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	182997	0	180256009	4107731	
19395	1659	4043071	1977-04-25	1977-04-25 00:00:00	38000275	0	\N	\N	111554	0	228557008	4043071	
31458	2778	4107731	1990-01-27	1990-01-27 00:00:00	38000275	0	\N	\N	184006	0	180256009	4107731	
31629	2786	4170947	2009-07-24	2009-07-24 00:00:00	38000275	0	\N	\N	184616	0	274474001	4170947	
31865	2806	4125906	1957-09-22	1957-09-22 00:00:00	38000275	0	\N	\N	185958	0	288086009	4125906	
20172	1743	4047491	1965-12-30	1965-12-30 00:00:00	38000275	0	\N	\N	116506	0	1225002	4047491	
20272	1753	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	117291	0	180256009	4107731	
32514	2858	4047491	1925-09-29	1925-09-29 00:00:00	38000275	0	\N	\N	189898	0	1225002	4047491	
32639	2864	4170947	1949-08-02	1949-08-02 00:00:00	38000275	0	\N	\N	190549	0	274474001	4170947	
44749	3916	4107731	1993-08-11	1993-08-11 00:00:00	38000275	0	\N	\N	260421	0	180256009	4107731	
32970	2894	44783196	1932-08-06	1932-08-06 00:00:00	38000275	0	\N	\N	192594	0	699253003	44783196	
21246	1843	4107731	1997-01-22	1997-01-22 00:00:00	38000275	0	\N	\N	123118	0	180256009	4107731	
21464	1855	4043071	1989-08-18	1989-08-18 00:00:00	38000275	0	\N	\N	124210	0	228557008	4043071	
45554	4017	4057420	2006-05-25	2006-05-25 00:00:00	38000275	0	\N	\N	267027	0	18286008	4057420	
33714	2942	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	196066	0	180256009	4107731	
33947	2959	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	197493	0	180256009	4107731	
34074	2965	4107731	1991-11-04	1991-11-04 00:00:00	38000275	0	\N	\N	197991	0	180256009	4107731	
22350	1956	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	130156	0	180256009	4107731	
22591	1976	4107731	1998-04-13	1998-04-13 00:00:00	38000275	0	\N	\N	131453	0	180256009	4107731	
34652	3011	4125906	2003-03-14	2003-03-14 00:00:00	38000275	0	\N	\N	200849	0	288086009	4125906	
34821	3025	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	201641	0	180256009	4107731	
47073	4130	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	274562	0	180256009	4107731	
35218	3067	4037675	1969-12-11	1969-12-11 00:00:00	38000275	0	\N	\N	204102	0	162676008	4037675	
35446	3109	4043071	1926-03-31	1926-03-31 00:00:00	38000275	0	\N	\N	206778	0	228557008	4043071	
35570	3114	4170947	2016-04-04	2016-04-04 00:00:00	38000275	0	\N	\N	207118	0	274474001	4170947	
23897	2077	4107731	1990-08-19	1990-08-19 00:00:00	38000275	0	\N	\N	138286	0	180256009	4107731	
12039	1101	4043071	1983-09-13	1983-09-13 00:00:00	38000275	0	\N	\N	72341	0	228557008	4043071	
24212	2119	4191853	1983-06-29	1983-06-29 00:00:00	38000275	0	\N	\N	141050	0	395142003	4191853	
12512	1135	4252419	1981-10-27	1981-10-27 00:00:00	38000275	0	\N	\N	74762	0	74016001	4252419	
24598	2152	4078793	2011-03-12	2011-03-12 00:00:00	38000275	0	\N	\N	143461	0	180325003	4078793	
24832	2173	44783196	2010-07-04	2010-07-04 00:00:00	38000275	0	\N	\N	144893	0	699253003	44783196	
24874	2173	4107731	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	144850	0	180256009	4107731	
25139	2189	4107731	2013-01-23	2013-01-23 00:00:00	38000275	0	\N	\N	145997	0	180256009	4107731	
25327	2200	4043071	1981-05-17	1981-05-17 00:00:00	38000275	0	\N	\N	146704	0	228557008	4043071	
25554	2237	4047491	1991-03-17	1991-03-17 00:00:00	38000275	0	\N	\N	148808	0	1225002	4047491	
25661	2244	4170947	1966-08-15	1966-08-15 00:00:00	38000275	0	\N	\N	149381	0	274474001	4170947	
13983	1264	4035793	2018-06-01	2018-06-01 00:00:00	38000275	0	\N	\N	83283	0	15081005	4035793	
14187	1276	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	84256	0	180256009	4107731	
26267	2291	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	152442	0	180256009	4107731	
26538	2314	4043071	1963-11-21	1963-11-21 00:00:00	38000275	0	\N	\N	153854	0	228557008	4043071	
26690	2339	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	155605	0	180256009	4107731	
26753	2339	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	155683	0	180256009	4107731	
26984	2356	4043071	1989-08-13	1989-08-13 00:00:00	38000275	0	\N	\N	156891	0	228557008	4043071	
15284	1365	4043071	1980-08-14	1980-08-14 00:00:00	38000275	0	\N	\N	90527	0	228557008	4043071	
27397	2392	4078793	1999-05-28	1999-05-28 00:00:00	38000275	0	\N	\N	158972	0	180325003	4078793	
15644	1387	4043071	1986-07-13	1986-07-13 00:00:00	38000275	0	\N	\N	92027	0	228557008	4043071	
27765	2436	4151422	1919-07-09	1919-07-09 00:00:00	38000275	0	\N	\N	161450	0	269911007	4151422	
16059	1399	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	93036	0	180256009	4107731	
16212	1409	4243062	1946-05-23	1946-05-23 00:00:00	38000275	0	\N	\N	93832	0	60027007	4243062	
28403	2528	4125906	2018-11-23	2018-11-23 00:00:00	38000275	0	\N	\N	167134	0	288086009	4125906	
28460	2534	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	167444	0	180256009	4107731	
28769	2550	4024289	1997-01-02	1997-01-02 00:00:00	38000275	0	\N	\N	168803	0	19490002	4024289	
28909	2554	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	169145	0	180256009	4107731	
17113	1480	4125906	1974-09-06	1974-09-06 00:00:00	38000275	0	\N	\N	98760	0	288086009	4125906	
17389	1497	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	99817	0	180256009	4107731	
29363	2619	4170947	1948-06-21	1948-06-21 00:00:00	38000275	0	\N	\N	173199	0	274474001	4170947	
29594	2636	4151422	2017-08-22	2017-08-22 00:00:00	38000275	0	\N	\N	174469	0	269911007	4151422	
29798	2647	4107731	1992-01-12	1992-01-12 00:00:00	38000275	0	\N	\N	175189	0	180256009	4107731	
30047	2661	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	176219	0	180256009	4107731	
30208	2673	4107731	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	177174	0	180256009	4107731	
30427	2685	4035793	2011-04-28	2011-04-28 00:00:00	38000275	0	\N	\N	177965	0	15081005	4035793	
18620	1590	4151422	1985-05-24	1985-05-24 00:00:00	38000275	0	\N	\N	106701	0	269911007	4151422	
30712	2715	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	180078	0	180256009	4107731	
30879	2732	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	180856	0	180256009	4107731	
31181	2765	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	182982	0	180256009	4107731	
19396	1659	4043071	1982-05-17	1982-05-17 00:00:00	38000275	0	\N	\N	111463	0	228557008	4043071	
31459	2778	4107731	1993-02-13	1993-02-13 00:00:00	38000275	0	\N	\N	184078	0	180256009	4107731	
31630	2786	4047491	2009-07-24	2009-07-24 00:00:00	38000275	0	\N	\N	184616	0	1225002	4047491	
31866	2806	4252419	1983-03-06	1983-03-06 00:00:00	38000275	0	\N	\N	185961	0	74016001	4252419	
20173	1743	4170947	1965-12-30	1965-12-30 00:00:00	38000275	0	\N	\N	116506	0	274474001	4170947	
20273	1753	4275113	1987-03-28	1987-03-28 00:00:00	38000275	0	\N	\N	117222	0	65200003	4275113	
32515	2858	4170947	1925-09-29	1925-09-29 00:00:00	38000275	0	\N	\N	189898	0	274474001	4170947	
32640	2864	4024289	1949-08-02	1949-08-02 00:00:00	38000275	0	\N	\N	190549	0	19490002	4024289	
44750	3916	4295880	1996-12-25	1996-12-25 00:00:00	38000275	0	\N	\N	260313	0	76601001	4295880	
32971	2894	4170947	1995-10-22	1995-10-22 00:00:00	38000275	0	\N	\N	192602	0	274474001	4170947	
21247	1843	4107731	1996-01-10	1996-01-10 00:00:00	38000275	0	\N	\N	123105	0	180256009	4107731	
21465	1855	4043071	1989-06-23	1989-06-23 00:00:00	38000275	0	\N	\N	124193	0	228557008	4043071	
45555	4017	4078793	2001-04-26	2001-04-26 00:00:00	38000275	0	\N	\N	267042	0	180325003	4078793	
33715	2942	4197460	1966-03-23	1966-03-23 00:00:00	38000275	0	\N	\N	196056	0	313191000	4197460	
33948	2959	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	197537	0	180256009	4107731	
34075	2965	4107731	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	197907	0	180256009	4107731	
22351	1956	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	130131	0	180256009	4107731	
22592	1976	4107731	1998-09-28	1998-09-28 00:00:00	38000275	0	\N	\N	131357	0	180256009	4107731	
34653	3011	4293740	1983-04-07	1983-04-07 00:00:00	38000275	0	\N	\N	200802	0	384700001	4293740	
34822	3025	4107731	1991-08-12	1991-08-12 00:00:00	38000275	0	\N	\N	201592	0	180256009	4107731	
47074	4130	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	274531	0	180256009	4107731	
35219	3067	4187458	1969-12-11	1969-12-11 00:00:00	38000275	0	\N	\N	204102	0	415300000	4187458	
35447	3109	4043071	1926-04-28	1926-04-28 00:00:00	38000275	0	\N	\N	206720	0	228557008	4043071	
35571	3114	4125906	1980-07-21	1980-07-21 00:00:00	38000275	0	\N	\N	207116	0	288086009	4125906	
23898	2077	4107731	1991-02-03	1991-02-03 00:00:00	38000275	0	\N	\N	138216	0	180256009	4107731	
12040	1101	4125906	2014-10-06	2014-10-06 00:00:00	38000275	0	\N	\N	72330	0	288086009	4125906	
24213	2119	4107731	1991-07-22	1991-07-22 00:00:00	38000275	0	\N	\N	141063	0	180256009	4107731	
12513	1136	4170947	2007-06-05	2007-06-05 00:00:00	38000275	0	\N	\N	74856	0	274474001	4170947	
24599	2152	4078793	2012-03-17	2012-03-17 00:00:00	38000275	0	\N	\N	143353	0	180325003	4078793	
24833	2173	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	144860	0	180256009	4107731	
24875	2173	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	144719	0	180256009	4107731	
25140	2189	4107731	2011-04-13	2011-04-13 00:00:00	38000275	0	\N	\N	145910	0	180256009	4107731	
25328	2200	4043071	1982-08-01	1982-08-01 00:00:00	38000275	0	\N	\N	146673	0	228557008	4043071	
25555	2237	4195803	1991-03-17	1991-03-17 00:00:00	38000275	0	\N	\N	148808	0	312681000	4195803	
25668	2250	4125906	1988-07-17	1988-07-17 00:00:00	38000275	0	\N	\N	149650	0	288086009	4125906	
13984	1264	4035793	2015-05-15	2015-05-15 00:00:00	38000275	0	\N	\N	83293	0	15081005	4035793	
14188	1276	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	84175	0	180256009	4107731	
26268	2291	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	152554	0	180256009	4107731	
26539	2314	4043071	1964-01-16	1964-01-16 00:00:00	38000275	0	\N	\N	153904	0	228557008	4043071	
26691	2339	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	155693	0	180256009	4107731	
26754	2340	4047491	1966-07-26	1966-07-26 00:00:00	38000275	0	\N	\N	155755	0	1225002	4047491	
26985	2356	4043071	1989-07-16	1989-07-16 00:00:00	38000275	0	\N	\N	156867	0	228557008	4043071	
15285	1365	4170947	1996-05-30	1996-05-30 00:00:00	38000275	0	\N	\N	90457	0	274474001	4170947	
27398	2392	4035793	1999-05-28	1999-05-28 00:00:00	38000275	0	\N	\N	158972	0	15081005	4035793	
15645	1387	4043071	1986-03-02	1986-03-02 00:00:00	38000275	0	\N	\N	92010	0	228557008	4043071	
27766	2436	4107731	1990-10-06	1990-10-06 00:00:00	38000275	0	\N	\N	161606	0	180256009	4107731	
16060	1399	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	93122	0	180256009	4107731	
16213	1410	4186930	1995-01-25	1995-01-25 00:00:00	38000275	0	\N	\N	93900	0	46706006	4186930	
28404	2528	4151422	2010-07-30	2010-07-30 00:00:00	38000275	0	\N	\N	167120	0	269911007	4151422	
28461	2534	4107731	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	167459	0	180256009	4107731	
28770	2550	4170947	1997-01-02	1997-01-02 00:00:00	38000275	0	\N	\N	168803	0	274474001	4170947	
28910	2554	4010253	1978-10-31	1978-10-31 00:00:00	38000275	0	\N	\N	169135	0	112790001	4010253	
17114	1480	4043071	1975-02-16	1975-02-16 00:00:00	38000275	0	\N	\N	98731	0	228557008	4043071	
17390	1497	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	99801	0	180256009	4107731	
29364	2619	4170947	1944-10-10	1944-10-10 00:00:00	38000275	0	\N	\N	173224	0	274474001	4170947	
29595	2636	4151422	2014-11-15	2014-11-15 00:00:00	38000275	0	\N	\N	174489	0	269911007	4151422	
29799	2647	4107731	1993-03-28	1993-03-28 00:00:00	38000275	0	\N	\N	175157	0	180256009	4107731	
30048	2661	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	176277	0	180256009	4107731	
30209	2673	4191853	1990-02-12	1990-02-12 00:00:00	38000275	0	\N	\N	177114	0	395142003	4191853	
30428	2685	4151422	1943-02-25	1943-02-25 00:00:00	38000275	0	\N	\N	177923	0	269911007	4151422	
18621	1590	4058899	1965-01-06	1965-01-06 00:00:00	38000275	0	\N	\N	106672	0	168594001	4058899	
30713	2715	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	180081	0	180256009	4107731	
30880	2732	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	180854	0	180256009	4107731	
31182	2765	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	182979	0	180256009	4107731	
19397	1659	4043071	1976-08-23	1976-08-23 00:00:00	38000275	0	\N	\N	111571	0	228557008	4043071	
31460	2778	4107731	1990-12-08	1990-12-08 00:00:00	38000275	0	\N	\N	184010	0	180256009	4107731	
31631	2786	4125906	2006-12-23	2006-12-23 00:00:00	38000275	0	\N	\N	184615	0	288086009	4125906	
31867	2806	44783196	1983-03-13	1983-03-13 00:00:00	38000275	0	\N	\N	185957	0	699253003	44783196	
20174	1743	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	116517	0	180256009	4107731	
20274	1753	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	117301	0	180256009	4107731	
32516	2858	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	189844	0	180256009	4107731	
32641	2864	4151422	2005-01-03	2005-01-03 00:00:00	38000275	0	\N	\N	190514	0	269911007	4151422	
44751	3916	4295880	1994-06-29	1994-06-29 00:00:00	38000275	0	\N	\N	260312	0	76601001	4295880	
32972	2894	4024289	1995-10-22	1995-10-22 00:00:00	38000275	0	\N	\N	192602	0	19490002	4024289	
21248	1843	4107731	1996-06-26	1996-06-26 00:00:00	38000275	0	\N	\N	123029	0	180256009	4107731	
21466	1855	4125906	1996-12-05	1996-12-05 00:00:00	38000275	0	\N	\N	124141	0	288086009	4125906	
45556	4017	4293740	1948-11-06	1948-11-06 00:00:00	38000275	0	\N	\N	267031	0	384700001	4293740	
33716	2942	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	196093	0	180256009	4107731	
33949	2959	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	197495	0	180256009	4107731	
34076	2965	4107731	1991-03-18	1991-03-18 00:00:00	38000275	0	\N	\N	197989	0	180256009	4107731	
22352	1956	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	130103	0	180256009	4107731	
22593	1976	4107731	1996-01-15	1996-01-15 00:00:00	38000275	0	\N	\N	131434	0	180256009	4107731	
34654	3011	4125906	1983-04-07	1983-04-07 00:00:00	38000275	0	\N	\N	200802	0	288086009	4125906	
34823	3025	4107731	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	201575	0	180256009	4107731	
47075	4130	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	274589	0	180256009	4107731	
35220	3067	4243062	1967-03-09	1967-03-09 00:00:00	38000275	0	\N	\N	204177	0	60027007	4243062	
35448	3109	4043071	1928-06-13	1928-06-13 00:00:00	38000275	0	\N	\N	206811	0	228557008	4043071	
35572	3114	4058899	1961-02-01	1961-02-01 00:00:00	38000275	0	\N	\N	207115	0	168594001	4058899	
23899	2077	4107731	1992-04-19	1992-04-19 00:00:00	38000275	0	\N	\N	138346	0	180256009	4107731	
12041	1101	4151422	2009-02-01	2009-02-01 00:00:00	38000275	0	\N	\N	72345	0	269911007	4151422	
24214	2119	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	140980	0	180256009	4107731	
12514	1136	4047491	2007-06-05	2007-06-05 00:00:00	38000275	0	\N	\N	74856	0	1225002	4047491	
24600	2152	4078793	2018-11-10	2018-11-10 00:00:00	38000275	0	\N	\N	143344	0	180325003	4078793	
24834	2173	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	144741	0	180256009	4107731	
24876	2173	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	144820	0	180256009	4107731	
25141	2189	4107731	2011-06-15	2011-06-15 00:00:00	38000275	0	\N	\N	145979	0	180256009	4107731	
25329	2200	4043071	1985-08-11	1985-08-11 00:00:00	38000275	0	\N	\N	146638	0	228557008	4043071	
25556	2237	4170947	1991-03-17	1991-03-17 00:00:00	38000275	0	\N	\N	148808	0	274474001	4170947	
25734	2256	4145310	1985-05-04	1985-05-04 00:00:00	38000275	0	\N	\N	149936	0	268425006	4145310	
13985	1264	4035793	2012-11-16	2012-11-16 00:00:00	38000275	0	\N	\N	83292	0	15081005	4035793	
14189	1276	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	84260	0	395142003	4191853	
26269	2291	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	152459	0	180256009	4107731	
26540	2314	4043071	1963-08-08	1963-08-08 00:00:00	38000275	0	\N	\N	153822	0	228557008	4043071	
26692	2339	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	155592	0	180256009	4107731	
26755	2340	4170947	1966-07-26	1966-07-26 00:00:00	38000275	0	\N	\N	155755	0	274474001	4170947	
26986	2356	4043071	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	156868	0	228557008	4043071	
15286	1365	4047491	1996-05-30	1996-05-30 00:00:00	38000275	0	\N	\N	90457	0	1225002	4047491	
27399	2392	4035793	1984-03-02	1984-03-02 00:00:00	38000275	0	\N	\N	159080	0	15081005	4035793	
15646	1387	4043071	1984-04-15	1984-04-15 00:00:00	38000275	0	\N	\N	92051	0	228557008	4043071	
27767	2436	4107731	1993-03-06	1993-03-06 00:00:00	38000275	0	\N	\N	161552	0	180256009	4107731	
16061	1399	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	93098	0	180256009	4107731	
16214	1410	4163872	2016-12-19	2016-12-19 00:00:00	38000275	0	\N	\N	93898	0	399208008	4163872	
28405	2528	4252419	1974-09-15	1974-09-15 00:00:00	38000275	0	\N	\N	167130	0	74016001	4252419	
28462	2534	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	167380	0	180256009	4107731	
28771	2550	4301346	2018-02-09	2018-02-09 00:00:00	38000275	0	\N	\N	168845	0	387685009	4301346	
28911	2554	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	169250	0	180256009	4107731	
17116	1482	4107731	1991-03-23	1991-03-23 00:00:00	38000275	0	\N	\N	98859	0	180256009	4107731	
17391	1497	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	99773	0	180256009	4107731	
29365	2619	4163872	1944-10-10	1944-10-10 00:00:00	38000275	0	\N	\N	173224	0	399208008	4163872	
29596	2636	4330583	2005-04-11	2005-04-11 00:00:00	38000275	0	\N	\N	174470	0	22523008	4330583	
29800	2647	4107731	1990-08-05	1990-08-05 00:00:00	38000275	0	\N	\N	175105	0	180256009	4107731	
30049	2661	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	176286	0	180256009	4107731	
30210	2673	4107731	1991-08-12	1991-08-12 00:00:00	38000275	0	\N	\N	177145	0	180256009	4107731	
30429	2685	4035793	2000-02-24	2000-02-24 00:00:00	38000275	0	\N	\N	177977	0	15081005	4035793	
18622	1590	4151422	2006-10-23	2006-10-23 00:00:00	38000275	0	\N	\N	106711	0	269911007	4151422	
30714	2715	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	180077	0	180256009	4107731	
30881	2732	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	180879	0	395142003	4191853	
31183	2765	4107731	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	182922	0	180256009	4107731	
19398	1659	4043071	1982-06-14	1982-06-14 00:00:00	38000275	0	\N	\N	111564	0	228557008	4043071	
31461	2778	4107731	1990-10-27	1990-10-27 00:00:00	38000275	0	\N	\N	184009	0	180256009	4107731	
31632	2786	4125906	1966-03-16	1966-03-16 00:00:00	38000275	0	\N	\N	184611	0	288086009	4125906	
31940	2812	4252419	2000-04-23	2000-04-23 00:00:00	38000275	0	\N	\N	186319	0	74016001	4252419	
20175	1743	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	116467	0	180256009	4107731	
20275	1753	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	117294	0	180256009	4107731	
32517	2858	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	189929	0	180256009	4107731	
32642	2866	4035793	2018-08-19	2018-08-19 00:00:00	38000275	0	\N	\N	190651	0	15081005	4035793	
44752	3916	4107731	1993-02-03	1993-02-03 00:00:00	38000275	0	\N	\N	260368	0	180256009	4107731	
32973	2894	4195803	1995-10-22	1995-10-22 00:00:00	38000275	0	\N	\N	192602	0	312681000	4195803	
21249	1843	4125906	1984-08-03	1984-08-03 00:00:00	38000275	0	\N	\N	123008	0	288086009	4125906	
21476	1860	4163872	1984-05-13	1984-05-13 00:00:00	38000275	0	\N	\N	124403	0	399208008	4163872	
45557	4017	4125906	1948-11-06	1948-11-06 00:00:00	38000275	0	\N	\N	267031	0	288086009	4125906	
33717	2942	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	196218	0	180256009	4107731	
33950	2959	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	197458	0	180256009	4107731	
34077	2965	4107731	1991-02-25	1991-02-25 00:00:00	38000275	0	\N	\N	197947	0	180256009	4107731	
22353	1956	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	130157	0	180256009	4107731	
22594	1976	4191853	1995-12-25	1995-12-25 00:00:00	38000275	0	\N	\N	131330	0	395142003	4191853	
34655	3013	4151422	1982-05-15	1982-05-15 00:00:00	38000275	0	\N	\N	200932	0	269911007	4151422	
34824	3025	4107731	1990-08-20	1990-08-20 00:00:00	38000275	0	\N	\N	201617	0	180256009	4107731	
47076	4130	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	274532	0	180256009	4107731	
35221	3067	4170947	1967-03-09	1967-03-09 00:00:00	38000275	0	\N	\N	204177	0	274474001	4170947	
35449	3109	4043071	1928-11-28	1928-11-28 00:00:00	38000275	0	\N	\N	206793	0	228557008	4043071	
35573	3115	4151422	1968-09-12	1968-09-12 00:00:00	38000275	0	\N	\N	207208	0	269911007	4151422	
23900	2077	4107731	1990-09-09	1990-09-09 00:00:00	38000275	0	\N	\N	138339	0	180256009	4107731	
12042	1101	4198190	1985-08-17	1985-08-17 00:00:00	38000275	0	\N	\N	72299	0	80146002	4198190	
24215	2119	4107731	1990-06-18	1990-06-18 00:00:00	38000275	0	\N	\N	141058	0	180256009	4107731	
12515	1136	4195803	2007-06-05	2007-06-05 00:00:00	38000275	0	\N	\N	74856	0	312681000	4195803	
24601	2152	4078793	2010-03-06	2010-03-06 00:00:00	38000275	0	\N	\N	143391	0	180325003	4078793	
24835	2173	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	144744	0	180256009	4107731	
24877	2173	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	144720	0	180256009	4107731	
25142	2189	4107731	2011-07-27	2011-07-27 00:00:00	38000275	0	\N	\N	145990	0	180256009	4107731	
25330	2200	4043071	1981-08-16	1981-08-16 00:00:00	38000275	0	\N	\N	146672	0	228557008	4043071	
25557	2237	4151422	2001-11-01	2001-11-01 00:00:00	38000275	0	\N	\N	148764	0	269911007	4151422	
25735	2256	4163872	1990-06-07	1990-06-07 00:00:00	38000275	0	\N	\N	149937	0	399208008	4163872	
13986	1264	4035793	2013-11-22	2013-11-22 00:00:00	38000275	0	\N	\N	83280	0	15081005	4035793	
14190	1276	4151422	2017-04-13	2017-04-13 00:00:00	38000275	0	\N	\N	84198	0	269911007	4151422	
26270	2291	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	152561	0	180256009	4107731	
26541	2314	4043071	1964-06-11	1964-06-11 00:00:00	38000275	0	\N	\N	153825	0	228557008	4043071	
26693	2339	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	155697	0	180256009	4107731	
26756	2341	4125906	1967-01-08	1967-01-08 00:00:00	38000275	0	\N	\N	155801	0	288086009	4125906	
26987	2356	4043071	1990-06-17	1990-06-17 00:00:00	38000275	0	\N	\N	156875	0	228557008	4043071	
15287	1365	4043071	1980-02-07	1980-02-07 00:00:00	38000275	0	\N	\N	90437	0	228557008	4043071	
27400	2392	4326177	1939-01-29	1939-01-29 00:00:00	38000275	0	\N	\N	159038	0	430193006	4326177	
15647	1387	4043071	1986-08-17	1986-08-17 00:00:00	38000275	0	\N	\N	92028	0	228557008	4043071	
27768	2436	4107731	1992-02-01	1992-02-01 00:00:00	38000275	0	\N	\N	161526	0	180256009	4107731	
16062	1399	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	93056	0	180256009	4107731	
16215	1410	4275113	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	93849	0	65200003	4275113	
28410	2530	4163872	1968-10-03	1968-10-03 00:00:00	38000275	0	\N	\N	167233	0	399208008	4163872	
28463	2534	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	167379	0	180256009	4107731	
28772	2551	4163872	2008-02-08	2008-02-08 00:00:00	38000275	0	\N	\N	168866	0	399208008	4163872	
28912	2554	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	169240	0	180256009	4107731	
17117	1482	4107731	1990-12-08	1990-12-08 00:00:00	38000275	0	\N	\N	98880	0	180256009	4107731	
29173	2586	4043071	1982-04-10	1982-04-10 00:00:00	38000275	0	\N	\N	171154	0	228557008	4043071	
29366	2619	4010253	1948-10-09	1948-10-09 00:00:00	38000275	0	\N	\N	173206	0	112790001	4010253	
29597	2636	4125906	1995-12-13	1995-12-13 00:00:00	38000275	0	\N	\N	174419	0	288086009	4125906	
29801	2647	4107731	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	175216	0	180256009	4107731	
30050	2661	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	176301	0	180256009	4107731	
30211	2673	4107731	1991-09-02	1991-09-02 00:00:00	38000275	0	\N	\N	177173	0	180256009	4107731	
30430	2685	4035793	2015-05-21	2015-05-21 00:00:00	38000275	0	\N	\N	177981	0	15081005	4035793	
18623	1590	4195803	2014-08-23	2014-08-23 00:00:00	38000275	0	\N	\N	106721	0	312681000	4195803	
30715	2715	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	179993	0	180256009	4107731	
30882	2732	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	180895	0	180256009	4107731	
31184	2765	4035793	2013-12-10	2013-12-10 00:00:00	38000275	0	\N	\N	182826	0	15081005	4035793	
19399	1659	4043071	1981-02-02	1981-02-02 00:00:00	38000275	0	\N	\N	111459	0	228557008	4043071	
31462	2778	4107731	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	184063	0	180256009	4107731	
31633	2786	4125906	1936-09-16	1936-09-16 00:00:00	38000275	0	\N	\N	184607	0	288086009	4125906	
31941	2812	4293740	1962-08-29	1962-08-29 00:00:00	38000275	0	\N	\N	186283	0	384700001	4293740	
20176	1743	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	116489	0	180256009	4107731	
20276	1753	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	117247	0	180256009	4107731	
32518	2858	4195803	1998-01-05	1998-01-05 00:00:00	38000275	0	\N	\N	189904	0	312681000	4195803	
32643	2867	4243062	1988-06-07	1988-06-07 00:00:00	38000275	0	\N	\N	190700	0	60027007	4243062	
44753	3916	4295880	1996-03-27	1996-03-27 00:00:00	38000275	0	\N	\N	260381	0	76601001	4295880	
32974	2894	4252419	1932-07-30	1932-07-30 00:00:00	38000275	0	\N	\N	192622	0	74016001	4252419	
21250	1843	4293740	1984-08-03	1984-08-03 00:00:00	38000275	0	\N	\N	123008	0	384700001	4293740	
21477	1860	4170947	1984-05-13	1984-05-13 00:00:00	38000275	0	\N	\N	124403	0	274474001	4170947	
45558	4017	4078793	2009-04-30	2009-04-30 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
33718	2942	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	196083	0	180256009	4107731	
33951	2959	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	197569	0	180256009	4107731	
34078	2965	4107731	1992-08-03	1992-08-03 00:00:00	38000275	0	\N	\N	197894	0	180256009	4107731	
22354	1956	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	130138	0	180256009	4107731	
22595	1976	4107731	1997-01-27	1997-01-27 00:00:00	38000275	0	\N	\N	131348	0	180256009	4107731	
34656	3013	4024289	1963-12-24	1963-12-24 00:00:00	38000275	0	\N	\N	200965	0	19490002	4024289	
34825	3025	4107731	1990-07-09	1990-07-09 00:00:00	38000275	0	\N	\N	201576	0	180256009	4107731	
47077	4130	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	274618	0	180256009	4107731	
35222	3067	40492359	1960-12-20	1960-12-20 00:00:00	38000275	0	\N	\N	204175	0	447365002	40492359	
35450	3109	4043071	1926-10-13	1926-10-13 00:00:00	38000275	0	\N	\N	206780	0	228557008	4043071	
35574	3115	4057420	1991-01-04	1991-01-04 00:00:00	38000275	0	\N	\N	207279	0	18286008	4057420	
23901	2077	4107731	1992-11-15	1992-11-15 00:00:00	38000275	0	\N	\N	138302	0	180256009	4107731	
12043	1101	4043071	1983-11-22	1983-11-22 00:00:00	38000275	0	\N	\N	72362	0	228557008	4043071	
24216	2119	4107731	1990-12-03	1990-12-03 00:00:00	38000275	0	\N	\N	141061	0	180256009	4107731	
12516	1136	4057420	1972-10-07	1972-10-07 00:00:00	38000275	0	\N	\N	74864	0	18286008	4057420	
24602	2152	4125906	1933-07-13	1933-07-13 00:00:00	38000275	0	\N	\N	143415	0	288086009	4125906	
24836	2173	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	144795	0	180256009	4107731	
24878	2173	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	144799	0	180256009	4107731	
25143	2189	4107731	2011-02-09	2011-02-09 00:00:00	38000275	0	\N	\N	145898	0	180256009	4107731	
25331	2200	4043071	1982-10-03	1982-10-03 00:00:00	38000275	0	\N	\N	146616	0	228557008	4043071	
25558	2237	4195803	1999-10-24	1999-10-24 00:00:00	38000275	0	\N	\N	148826	0	312681000	4195803	
25736	2256	4170947	1990-06-07	1990-06-07 00:00:00	38000275	0	\N	\N	149937	0	274474001	4170947	
13987	1264	4035793	2014-05-09	2014-05-09 00:00:00	38000275	0	\N	\N	83287	0	15081005	4035793	
14191	1276	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	84224	0	180256009	4107731	
26271	2291	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	152545	0	180256009	4107731	
26542	2314	44783196	1961-01-22	1961-01-22 00:00:00	38000275	0	\N	\N	153871	0	699253003	44783196	
26694	2339	4191853	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	155630	0	395142003	4191853	
26757	2341	4151422	1953-06-21	1953-06-21 00:00:00	38000275	0	\N	\N	155850	0	269911007	4151422	
26988	2356	4043071	1989-06-11	1989-06-11 00:00:00	38000275	0	\N	\N	156866	0	228557008	4043071	
15288	1365	4043071	1979-08-02	1979-08-02 00:00:00	38000275	0	\N	\N	90434	0	228557008	4043071	
27401	2392	4187458	1939-01-29	1939-01-29 00:00:00	38000275	0	\N	\N	159038	0	415300000	4187458	
15648	1387	4043071	1986-06-15	1986-06-15 00:00:00	38000275	0	\N	\N	92013	0	228557008	4043071	
27769	2436	4107731	1993-01-02	1993-01-02 00:00:00	38000275	0	\N	\N	161653	0	180256009	4107731	
16063	1399	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	93038	0	180256009	4107731	
16216	1410	4238715	1997-06-05	1997-06-05 00:00:00	38000275	0	\N	\N	93851	0	68254000	4238715	
28411	2530	4145310	1972-12-20	1972-12-20 00:00:00	38000275	0	\N	\N	167222	0	268425006	4145310	
28464	2534	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	167439	0	180256009	4107731	
28773	2551	4163872	1991-01-09	1991-01-09 00:00:00	38000275	0	\N	\N	168877	0	399208008	4163872	
28913	2554	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	169100	0	180256009	4107731	
17118	1482	4107731	1993-01-02	1993-01-02 00:00:00	38000275	0	\N	\N	98874	0	180256009	4107731	
29174	2586	4043071	1981-12-12	1981-12-12 00:00:00	38000275	0	\N	\N	171163	0	228557008	4043071	
29367	2620	4024289	1973-03-24	1973-03-24 00:00:00	38000275	0	\N	\N	173270	0	19490002	4024289	
41515	3647	4043071	1945-11-21	1945-11-21 00:00:00	38000275	0	\N	\N	242602	0	228557008	4043071	
29802	2647	4191853	1993-07-11	1993-07-11 00:00:00	38000275	0	\N	\N	175217	0	395142003	4191853	
30051	2661	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	176292	0	180256009	4107731	
30212	2673	4107731	1991-11-25	1991-11-25 00:00:00	38000275	0	\N	\N	177089	0	180256009	4107731	
30431	2686	4125906	1967-12-02	1967-12-02 00:00:00	38000275	0	\N	\N	178070	0	288086009	4125906	
18624	1590	4170947	2014-08-23	2014-08-23 00:00:00	38000275	0	\N	\N	106721	0	274474001	4170947	
30716	2715	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	180067	0	180256009	4107731	
30883	2732	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	180912	0	180256009	4107731	
31185	2765	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	182865	0	180256009	4107731	
19400	1659	4043071	1977-03-21	1977-03-21 00:00:00	38000275	0	\N	\N	111553	0	228557008	4043071	
31463	2778	4107731	1991-04-13	1991-04-13 00:00:00	38000275	0	\N	\N	184022	0	180256009	4107731	
31634	2786	4195803	1993-08-21	1993-08-21 00:00:00	38000275	0	\N	\N	184659	0	312681000	4195803	
31942	2812	4125906	1962-08-29	1962-08-29 00:00:00	38000275	0	\N	\N	186283	0	288086009	4125906	
20177	1743	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	116487	0	180256009	4107731	
20277	1753	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	117275	0	180256009	4107731	
32519	2858	4047491	1998-01-05	1998-01-05 00:00:00	38000275	0	\N	\N	189904	0	1225002	4047491	
32644	2867	4170947	1988-06-07	1988-06-07 00:00:00	38000275	0	\N	\N	190700	0	274474001	4170947	
44754	3916	4252419	1997-06-17	1997-06-17 00:00:00	38000275	0	\N	\N	260435	0	74016001	4252419	
32975	2894	44783196	1997-02-20	1997-02-20 00:00:00	38000275	0	\N	\N	192623	0	699253003	44783196	
21251	1843	4151422	2014-04-03	2014-04-03 00:00:00	38000275	0	\N	\N	123068	0	269911007	4151422	
21478	1860	40492359	1997-07-07	1997-07-07 00:00:00	38000275	0	\N	\N	124408	0	447365002	40492359	
45559	4017	44783196	1934-01-24	1934-01-24 00:00:00	38000275	0	\N	\N	267032	0	699253003	44783196	
33719	2942	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	196098	0	180256009	4107731	
33952	2959	4043071	1979-02-21	1979-02-21 00:00:00	38000275	0	\N	\N	197582	0	228557008	4043071	
34079	2965	4107731	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	197917	0	180256009	4107731	
22355	1956	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	130169	0	180256009	4107731	
22596	1976	4107731	1996-05-20	1996-05-20 00:00:00	38000275	0	\N	\N	131342	0	180256009	4107731	
34657	3013	4170947	1963-12-24	1963-12-24 00:00:00	38000275	0	\N	\N	200965	0	274474001	4170947	
34826	3025	4107731	1992-02-17	1992-02-17 00:00:00	38000275	0	\N	\N	201629	0	180256009	4107731	
47078	4130	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	274641	0	180256009	4107731	
35223	3067	4057420	1960-12-20	1960-12-20 00:00:00	38000275	0	\N	\N	204175	0	18286008	4057420	
35451	3109	4043071	1926-02-24	1926-02-24 00:00:00	38000275	0	\N	\N	206801	0	228557008	4043071	
35575	3115	40492359	1991-01-04	1991-01-04 00:00:00	38000275	0	\N	\N	207279	0	447365002	40492359	
23902	2077	4107731	1993-05-23	1993-05-23 00:00:00	38000275	0	\N	\N	138326	0	180256009	4107731	
12044	1101	4043071	1983-12-27	1983-12-27 00:00:00	38000275	0	\N	\N	72301	0	228557008	4043071	
24217	2119	4107731	1993-01-18	1993-01-18 00:00:00	38000275	0	\N	\N	141011	0	180256009	4107731	
12517	1136	40492359	1972-10-07	1972-10-07 00:00:00	38000275	0	\N	\N	74864	0	447365002	40492359	
24603	2152	4078793	2014-03-29	2014-03-29 00:00:00	38000275	0	\N	\N	143354	0	180325003	4078793	
24837	2173	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	144815	0	180256009	4107731	
24879	2173	4326177	1974-06-27	1974-06-27 00:00:00	38000275	0	\N	\N	144867	0	430193006	4326177	
25144	2189	4107731	2010-12-29	2010-12-29 00:00:00	38000275	0	\N	\N	145897	0	180256009	4107731	
25332	2200	4043071	1984-09-16	1984-09-16 00:00:00	38000275	0	\N	\N	146687	0	228557008	4043071	
25559	2237	4163872	1960-06-15	1960-06-15 00:00:00	38000275	0	\N	\N	148848	0	399208008	4163872	
25737	2256	4151422	1989-11-11	1989-11-11 00:00:00	38000275	0	\N	\N	149965	0	269911007	4151422	
13988	1264	4035793	2019-06-07	2019-06-07 00:00:00	38000275	0	\N	\N	83295	0	15081005	4035793	
14192	1276	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	84225	0	180256009	4107731	
26272	2291	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	152544	0	180256009	4107731	
26543	2314	4043071	1963-12-19	1963-12-19 00:00:00	38000275	0	\N	\N	153872	0	228557008	4043071	
26695	2339	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	155604	0	180256009	4107731	
26758	2341	4078793	2007-03-22	2007-03-22 00:00:00	38000275	0	\N	\N	155796	0	180325003	4078793	
26989	2356	4043071	1988-12-04	1988-12-04 00:00:00	38000275	0	\N	\N	156900	0	228557008	4043071	
15289	1365	4043071	1980-10-16	1980-10-16 00:00:00	38000275	0	\N	\N	90462	0	228557008	4043071	
27402	2392	4037675	1939-01-29	1939-01-29 00:00:00	38000275	0	\N	\N	159038	0	162676008	4037675	
15649	1387	4043071	1984-11-11	1984-11-11 00:00:00	38000275	0	\N	\N	92072	0	228557008	4043071	
27770	2436	4107731	1993-01-23	1993-01-23 00:00:00	38000275	0	\N	\N	161531	0	180256009	4107731	
16064	1399	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	93112	0	180256009	4107731	
16217	1410	4275113	1993-01-17	1993-01-17 00:00:00	38000275	0	\N	\N	93881	0	65200003	4275113	
28412	2530	4151422	1988-08-04	1988-08-04 00:00:00	38000275	0	\N	\N	167252	0	269911007	4151422	
28465	2534	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	167394	0	180256009	4107731	
28774	2551	4151422	2017-03-04	2017-03-04 00:00:00	38000275	0	\N	\N	168899	0	269911007	4151422	
28914	2555	4125906	1969-04-28	1969-04-28 00:00:00	38000275	0	\N	\N	169312	0	288086009	4125906	
17119	1482	4107731	1991-01-19	1991-01-19 00:00:00	38000275	0	\N	\N	98881	0	180256009	4107731	
29175	2586	4043071	1982-01-09	1982-01-09 00:00:00	38000275	0	\N	\N	171209	0	228557008	4043071	
29368	2620	4170947	1973-03-24	1973-03-24 00:00:00	38000275	0	\N	\N	173270	0	274474001	4170947	
41516	3647	4043071	1944-01-26	1944-01-26 00:00:00	38000275	0	\N	\N	242596	0	228557008	4043071	
29803	2647	4107731	1991-03-03	1991-03-03 00:00:00	38000275	0	\N	\N	175118	0	180256009	4107731	
30052	2661	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	176241	0	180256009	4107731	
30213	2673	4107731	1992-10-26	1992-10-26 00:00:00	38000275	0	\N	\N	177068	0	180256009	4107731	
30432	2686	4151422	1962-01-10	1962-01-10 00:00:00	38000275	0	\N	\N	178048	0	269911007	4151422	
18625	1590	4024289	2014-08-23	2014-08-23 00:00:00	38000275	0	\N	\N	106721	0	19490002	4024289	
30717	2715	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	180031	0	395142003	4191853	
30884	2732	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	180920	0	180256009	4107731	
31186	2765	4035793	2008-11-11	2008-11-11 00:00:00	38000275	0	\N	\N	182834	0	15081005	4035793	
19401	1659	4043071	1983-03-21	1983-03-21 00:00:00	38000275	0	\N	\N	111499	0	228557008	4043071	
31464	2778	4107731	1992-04-25	1992-04-25 00:00:00	38000275	0	\N	\N	184064	0	180256009	4107731	
31635	2786	4170947	1926-03-13	1926-03-13 00:00:00	38000275	0	\N	\N	184606	0	274474001	4170947	
31943	2812	4151422	1971-10-13	1971-10-13 00:00:00	38000275	0	\N	\N	186302	0	269911007	4151422	
20178	1743	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	116503	0	395142003	4191853	
20278	1753	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	117292	0	180256009	4107731	
32520	2858	4170947	1998-01-05	1998-01-05 00:00:00	38000275	0	\N	\N	189904	0	274474001	4170947	
32645	2867	4010253	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	190726	0	112790001	4010253	
44755	3916	4107731	1992-11-11	1992-11-11 00:00:00	38000275	0	\N	\N	260272	0	180256009	4107731	
32976	2894	4252419	1998-03-17	1998-03-17 00:00:00	38000275	0	\N	\N	192604	0	74016001	4252419	
21252	1843	4107731	1995-03-01	1995-03-01 00:00:00	38000275	0	\N	\N	123019	0	180256009	4107731	
21479	1860	4057420	1997-07-07	1997-07-07 00:00:00	38000275	0	\N	\N	124408	0	18286008	4057420	
45560	4017	4078793	2009-04-23	2009-04-23 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
33720	2942	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	196170	0	180256009	4107731	
33953	2959	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	197515	0	180256009	4107731	
34080	2965	4107731	1992-02-17	1992-02-17 00:00:00	38000275	0	\N	\N	197935	0	180256009	4107731	
22356	1956	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	130159	0	180256009	4107731	
22597	1976	4107731	1997-02-17	1997-02-17 00:00:00	38000275	0	\N	\N	131345	0	180256009	4107731	
34658	3013	4125906	1952-06-19	1952-06-19 00:00:00	38000275	0	\N	\N	200963	0	288086009	4125906	
34827	3025	4107731	1992-12-07	1992-12-07 00:00:00	38000275	0	\N	\N	201673	0	180256009	4107731	
47079	4130	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	274541	0	180256009	4107731	
35224	3067	4125906	1958-05-11	1958-05-11 00:00:00	38000275	0	\N	\N	204174	0	288086009	4125906	
35452	3109	4043071	1925-10-21	1925-10-21 00:00:00	38000275	0	\N	\N	206800	0	228557008	4043071	
35576	3115	4125906	1973-02-08	1973-02-08 00:00:00	38000275	0	\N	\N	207278	0	288086009	4125906	
23903	2077	4107731	1991-04-07	1991-04-07 00:00:00	38000275	0	\N	\N	138353	0	180256009	4107731	
12045	1101	4043071	1984-02-28	1984-02-28 00:00:00	38000275	0	\N	\N	72358	0	228557008	4043071	
24218	2119	4107731	1992-10-26	1992-10-26 00:00:00	38000275	0	\N	\N	141009	0	180256009	4107731	
12518	1136	4043071	1985-09-07	1985-09-07 00:00:00	38000275	0	\N	\N	74810	0	228557008	4043071	
24604	2152	4198190	1962-02-03	1962-02-03 00:00:00	38000275	0	\N	\N	143420	0	80146002	4198190	
24838	2173	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	144779	0	180256009	4107731	
24880	2173	4037675	1974-06-27	1974-06-27 00:00:00	38000275	0	\N	\N	144867	0	162676008	4037675	
25145	2189	4107731	2012-03-14	2012-03-14 00:00:00	38000275	0	\N	\N	145992	0	180256009	4107731	
25333	2200	4043071	1982-11-28	1982-11-28 00:00:00	38000275	0	\N	\N	146674	0	228557008	4043071	
25560	2237	4145310	2005-10-29	2005-10-29 00:00:00	38000275	0	\N	\N	148809	0	268425006	4145310	
25738	2256	4199276	2006-04-19	2006-04-19 00:00:00	38000275	0	\N	\N	149920	0	301807007	4199276	
13989	1264	4035793	2011-11-11	2011-11-11 00:00:00	38000275	0	\N	\N	83281	0	15081005	4035793	
14193	1276	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	84148	0	180256009	4107731	
26273	2291	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	152404	0	180256009	4107731	
26544	2314	4043071	1964-04-16	1964-04-16 00:00:00	38000275	0	\N	\N	153873	0	228557008	4043071	
26696	2339	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	155608	0	180256009	4107731	
26759	2341	4057420	2012-04-26	2012-04-26 00:00:00	38000275	0	\N	\N	155782	0	18286008	4057420	
26990	2356	4043071	1989-09-17	1989-09-17 00:00:00	38000275	0	\N	\N	156873	0	228557008	4043071	
15290	1365	4043071	1978-08-24	1978-08-24 00:00:00	38000275	0	\N	\N	90419	0	228557008	4043071	
27403	2392	4078793	2016-10-21	2016-10-21 00:00:00	38000275	0	\N	\N	158977	0	180325003	4078793	
15650	1387	4043071	1983-11-13	1983-11-13 00:00:00	38000275	0	\N	\N	92050	0	228557008	4043071	
27771	2436	4107731	1992-01-11	1992-01-11 00:00:00	38000275	0	\N	\N	161648	0	180256009	4107731	
16065	1399	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	93054	0	180256009	4107731	
16218	1410	40492359	2010-03-25	2010-03-25 00:00:00	38000275	0	\N	\N	93838	0	447365002	40492359	
28413	2530	4047491	1980-09-09	1980-09-09 00:00:00	38000275	0	\N	\N	167223	0	1225002	4047491	
28466	2534	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	167451	0	180256009	4107731	
40580	3566	4043071	1959-12-21	1959-12-21 00:00:00	38000275	0	\N	\N	236829	0	228557008	4043071	
28915	2555	4125906	1995-04-08	1995-04-08 00:00:00	38000275	0	\N	\N	169319	0	288086009	4125906	
17120	1482	4107731	1990-08-04	1990-08-04 00:00:00	38000275	0	\N	\N	98857	0	180256009	4107731	
29176	2586	4043071	1983-12-24	1983-12-24 00:00:00	38000275	0	\N	\N	171145	0	228557008	4043071	
29369	2620	4047491	1992-11-05	1992-11-05 00:00:00	38000275	0	\N	\N	173274	0	1225002	4047491	
41517	3647	4043071	1945-02-07	1945-02-07 00:00:00	38000275	0	\N	\N	242672	0	228557008	4043071	
29804	2647	4191853	1990-01-07	1990-01-07 00:00:00	38000275	0	\N	\N	175206	0	395142003	4191853	
30053	2661	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	176295	0	180256009	4107731	
30214	2673	4107731	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	177148	0	180256009	4107731	
30433	2686	4047491	1994-03-20	1994-03-20 00:00:00	38000275	0	\N	\N	178072	0	1225002	4047491	
18632	1593	4202451	2009-10-01	2009-10-01 00:00:00	38000275	0	\N	\N	106939	0	433112001	4202451	
30718	2715	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	180013	0	180256009	4107731	
30885	2732	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	180919	0	180256009	4107731	
31187	2765	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	182928	0	180256009	4107731	
19402	1659	4043071	1977-11-21	1977-11-21 00:00:00	38000275	0	\N	\N	111514	0	228557008	4043071	
31465	2778	4191853	1990-01-06	1990-01-06 00:00:00	38000275	0	\N	\N	184015	0	395142003	4191853	
31636	2786	4024289	1926-03-13	1926-03-13 00:00:00	38000275	0	\N	\N	184606	0	19490002	4024289	
31944	2812	4145310	1947-06-19	1947-06-19 00:00:00	38000275	0	\N	\N	186282	0	268425006	4145310	
20179	1743	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	116483	0	180256009	4107731	
20279	1753	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	117295	0	180256009	4107731	
32521	2858	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	189802	0	180256009	4107731	
32646	2868	4170947	1969-02-05	1969-02-05 00:00:00	38000275	0	\N	\N	190817	0	274474001	4170947	
44756	3916	4295880	1998-09-23	1998-09-23 00:00:00	38000275	0	\N	\N	260382	0	76601001	4295880	
32977	2894	44783196	1923-01-14	1923-01-14 00:00:00	38000275	0	\N	\N	192595	0	699253003	44783196	
21253	1843	4107731	1994-10-05	1994-10-05 00:00:00	38000275	0	\N	\N	123021	0	180256009	4107731	
21480	1860	4216130	1985-11-11	1985-11-11 00:00:00	38000275	0	\N	\N	124404	0	415070008	4216130	
45561	4017	4057420	2012-11-15	2012-11-15 00:00:00	38000275	0	\N	\N	\N	0	18286008	4057420	
33721	2942	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	196173	0	180256009	4107731	
33954	2959	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	197535	0	180256009	4107731	
34081	2965	4107731	1992-03-09	1992-03-09 00:00:00	38000275	0	\N	\N	197957	0	180256009	4107731	
22357	1956	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	130129	0	180256009	4107731	
22598	1976	4107731	1999-01-11	1999-01-11 00:00:00	38000275	0	\N	\N	131389	0	180256009	4107731	
34659	3013	4195803	2014-05-05	2014-05-05 00:00:00	38000275	0	\N	\N	200967	0	312681000	4195803	
34828	3025	4107731	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	201690	0	180256009	4107731	
47080	4130	4010253	2008-06-10	2008-06-10 00:00:00	38000275	0	\N	\N	274646	0	112790001	4010253	
35230	3069	4125906	1977-05-29	1977-05-29 00:00:00	38000275	0	\N	\N	204311	0	288086009	4125906	
35453	3109	4043071	1927-04-27	1927-04-27 00:00:00	38000275	0	\N	\N	206783	0	228557008	4043071	
35577	3115	4125906	2009-09-09	2009-09-09 00:00:00	38000275	0	\N	\N	207281	0	288086009	4125906	
23904	2077	4107731	1990-02-11	1990-02-11 00:00:00	38000275	0	\N	\N	138241	0	180256009	4107731	
12046	1101	4151422	1989-07-01	1989-07-01 00:00:00	38000275	0	\N	\N	72344	0	269911007	4151422	
24219	2119	4107731	1992-01-27	1992-01-27 00:00:00	38000275	0	\N	\N	141021	0	180256009	4107731	
12519	1136	4145310	2013-02-03	2013-02-03 00:00:00	38000275	0	\N	\N	74824	0	268425006	4145310	
24605	2152	4057420	2008-02-23	2008-02-23 00:00:00	38000275	0	\N	\N	143390	0	18286008	4057420	
24839	2173	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	144740	0	180256009	4107731	
24881	2173	4187458	1974-06-27	1974-06-27 00:00:00	38000275	0	\N	\N	144867	0	415300000	4187458	
25146	2189	4107731	2010-12-08	2010-12-08 00:00:00	38000275	0	\N	\N	145960	0	180256009	4107731	
25334	2200	4043071	1985-05-12	1985-05-12 00:00:00	38000275	0	\N	\N	146623	0	228557008	4043071	
25561	2238	4107731	1991-07-21	1991-07-21 00:00:00	38000275	0	\N	\N	148945	0	180256009	4107731	
25739	2256	4151422	1992-09-05	1992-09-05 00:00:00	38000275	0	\N	\N	149951	0	269911007	4151422	
13990	1265	4047491	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	83398	0	1225002	4047491	
14194	1276	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	84253	0	180256009	4107731	
26274	2291	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	152416	0	180256009	4107731	
26545	2314	4043071	1963-09-12	1963-09-12 00:00:00	38000275	0	\N	\N	153823	0	228557008	4043071	
26697	2339	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	155639	0	180256009	4107731	
26760	2341	4078793	2018-05-31	2018-05-31 00:00:00	38000275	0	\N	\N	155834	0	180325003	4078793	
26991	2356	4043071	1989-10-22	1989-10-22 00:00:00	38000275	0	\N	\N	156874	0	228557008	4043071	
15294	1367	4125906	1978-03-28	1978-03-28 00:00:00	38000275	0	\N	\N	90621	0	288086009	4125906	
27404	2392	4035793	2016-10-21	2016-10-21 00:00:00	38000275	0	\N	\N	158977	0	15081005	4035793	
15651	1387	4043071	1984-12-16	1984-12-16 00:00:00	38000275	0	\N	\N	92073	0	228557008	4043071	
27772	2436	4107731	1991-11-30	1991-11-30 00:00:00	38000275	0	\N	\N	161548	0	180256009	4107731	
16066	1399	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	93093	0	180256009	4107731	
16219	1410	4057420	2010-03-25	2010-03-25 00:00:00	38000275	0	\N	\N	93838	0	18286008	4057420	
28414	2530	4170947	1980-09-09	1980-09-09 00:00:00	38000275	0	\N	\N	167223	0	274474001	4170947	
28467	2534	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	167458	0	180256009	4107731	
40581	3566	4043071	1959-02-02	1959-02-02 00:00:00	38000275	0	\N	\N	236924	0	228557008	4043071	
28916	2556	4125906	1991-05-28	1991-05-28 00:00:00	38000275	0	\N	\N	169378	0	288086009	4125906	
17121	1482	4107731	1990-07-14	1990-07-14 00:00:00	38000275	0	\N	\N	98801	0	180256009	4107731	
29177	2586	4043071	1983-05-14	1983-05-14 00:00:00	38000275	0	\N	\N	171157	0	228557008	4043071	
29370	2620	4170947	1992-11-05	1992-11-05 00:00:00	38000275	0	\N	\N	173274	0	274474001	4170947	
41518	3647	4043071	1945-10-24	1945-10-24 00:00:00	38000275	0	\N	\N	242618	0	228557008	4043071	
29805	2647	4107731	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	175202	0	180256009	4107731	
30054	2661	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	176351	0	180256009	4107731	
30215	2673	4107731	1992-03-09	1992-03-09 00:00:00	38000275	0	\N	\N	177066	0	180256009	4107731	
30434	2686	4170947	1994-03-20	1994-03-20 00:00:00	38000275	0	\N	\N	178072	0	274474001	4170947	
18633	1593	4125906	1970-09-03	1970-09-03 00:00:00	38000275	0	\N	\N	106847	0	288086009	4125906	
30719	2715	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	179980	0	180256009	4107731	
30886	2732	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	180922	0	180256009	4107731	
31188	2765	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	182863	0	180256009	4107731	
19403	1659	4043071	1978-02-27	1978-02-27 00:00:00	38000275	0	\N	\N	111545	0	228557008	4043071	
31466	2778	4107731	1990-05-12	1990-05-12 00:00:00	38000275	0	\N	\N	184029	0	180256009	4107731	
31637	2786	4170947	1939-07-17	1939-07-17 00:00:00	38000275	0	\N	\N	184608	0	274474001	4170947	
31945	2813	4078793	2019-03-15	2019-03-15 00:00:00	38000275	0	\N	\N	186405	0	180325003	4078793	
20180	1743	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	116521	0	180256009	4107731	
20280	1753	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	117221	0	180256009	4107731	
32522	2858	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	189809	0	180256009	4107731	
32647	2868	4024289	1969-02-05	1969-02-05 00:00:00	38000275	0	\N	\N	190817	0	19490002	4024289	
44757	3916	4295880	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	260310	0	76601001	4295880	
32978	2894	4252419	1997-02-13	1997-02-13 00:00:00	38000275	0	\N	\N	192603	0	74016001	4252419	
21254	1843	4107731	1998-01-14	1998-01-14 00:00:00	38000275	0	\N	\N	123040	0	180256009	4107731	
21481	1860	4336464	1985-11-11	1985-11-11 00:00:00	38000275	0	\N	\N	124404	0	232717009	4336464	
45562	4017	4252419	1934-01-17	1934-01-17 00:00:00	38000275	0	\N	\N	267029	0	74016001	4252419	
33722	2942	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	196110	0	180256009	4107731	
33955	2959	4043071	1980-03-12	1980-03-12 00:00:00	38000275	0	\N	\N	197478	0	228557008	4043071	
34082	2965	4107731	1992-12-28	1992-12-28 00:00:00	38000275	0	\N	\N	197971	0	180256009	4107731	
22358	1956	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	130122	0	180256009	4107731	
22599	1976	4295880	2000-09-11	2000-09-11 00:00:00	38000275	0	\N	\N	131395	0	76601001	4295880	
34660	3013	4170947	2014-05-05	2014-05-05 00:00:00	38000275	0	\N	\N	200967	0	274474001	4170947	
34829	3025	4107731	1991-02-25	1991-02-25 00:00:00	38000275	0	\N	\N	201568	0	180256009	4107731	
47081	4130	4078793	2017-05-25	2017-05-25 00:00:00	38000275	0	\N	\N	274552	0	180325003	4078793	
35231	3069	4047491	1969-01-27	1969-01-27 00:00:00	38000275	0	\N	\N	204309	0	1225002	4047491	
35454	3109	4043071	1927-02-23	1927-02-23 00:00:00	38000275	0	\N	\N	206807	0	228557008	4043071	
35578	3115	4170947	1972-01-15	1972-01-15 00:00:00	38000275	0	\N	\N	207277	0	274474001	4170947	
23905	2077	4107731	1993-03-21	1993-03-21 00:00:00	38000275	0	\N	\N	138254	0	180256009	4107731	
12047	1101	4043071	1984-04-03	1984-04-03 00:00:00	38000275	0	\N	\N	72342	0	228557008	4043071	
24220	2119	4107731	1990-03-05	1990-03-05 00:00:00	38000275	0	\N	\N	141004	0	180256009	4107731	
12520	1136	4043071	1985-07-13	1985-07-13 00:00:00	38000275	0	\N	\N	74862	0	228557008	4043071	
24606	2152	4078793	2015-04-04	2015-04-04 00:00:00	38000275	0	\N	\N	143403	0	180325003	4078793	
24840	2173	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	144797	0	180256009	4107731	
24882	2173	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	144739	0	180256009	4107731	
25147	2189	4191853	2010-02-17	2010-02-17 00:00:00	38000275	0	\N	\N	145893	0	395142003	4191853	
25335	2200	4043071	1985-04-07	1985-04-07 00:00:00	38000275	0	\N	\N	146679	0	228557008	4043071	
25562	2238	4107731	1992-12-27	1992-12-27 00:00:00	38000275	0	\N	\N	148920	0	180256009	4107731	
25740	2256	4059978	2004-06-03	2004-06-03 00:00:00	38000275	0	\N	\N	149910	0	169553002	4059978	
13991	1265	4170947	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	83398	0	274474001	4170947	
14195	1276	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	84185	0	180256009	4107731	
26275	2291	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	152524	0	180256009	4107731	
26546	2314	4125906	1972-04-08	1972-04-08 00:00:00	38000275	0	\N	\N	153865	0	288086009	4125906	
26698	2339	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	155642	0	180256009	4107731	
26761	2341	4078793	2019-06-06	2019-06-06 00:00:00	38000275	0	\N	\N	155837	0	180325003	4078793	
26992	2356	4043071	1989-04-09	1989-04-09 00:00:00	38000275	0	\N	\N	156890	0	228557008	4043071	
15295	1367	4125906	1992-05-18	1992-05-18 00:00:00	38000275	0	\N	\N	90623	0	288086009	4125906	
27405	2392	4035793	1975-03-21	1975-03-21 00:00:00	38000275	0	\N	\N	159084	0	15081005	4035793	
15652	1387	4043071	1984-05-13	1984-05-13 00:00:00	38000275	0	\N	\N	92066	0	228557008	4043071	
27773	2436	4107731	1991-09-07	1991-09-07 00:00:00	38000275	0	\N	\N	161546	0	180256009	4107731	
16067	1399	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	93037	0	180256009	4107731	
16220	1410	4125906	2008-02-22	2008-02-22 00:00:00	38000275	0	\N	\N	93837	0	288086009	4125906	
28416	2534	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	167377	0	180256009	4107731	
28468	2534	4191853	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	167387	0	395142003	4191853	
40582	3566	4043071	1960-04-25	1960-04-25 00:00:00	38000275	0	\N	\N	236812	0	228557008	4043071	
28919	2559	4107731	1990-06-02	1990-06-02 00:00:00	38000275	0	\N	\N	169597	0	180256009	4107731	
17122	1482	4107731	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	98804	0	180256009	4107731	
29178	2586	4043071	1983-08-20	1983-08-20 00:00:00	38000275	0	\N	\N	171214	0	228557008	4043071	
29371	2620	4047491	1979-09-19	1979-09-19 00:00:00	38000275	0	\N	\N	173271	0	1225002	4047491	
41519	3647	4043071	1945-03-07	1945-03-07 00:00:00	38000275	0	\N	\N	242616	0	228557008	4043071	
29806	2647	4107731	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	175194	0	180256009	4107731	
30055	2661	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	176224	0	180256009	4107731	
30216	2673	4107731	1993-07-26	1993-07-26 00:00:00	38000275	0	\N	\N	177071	0	180256009	4107731	
30435	2686	4293740	1998-06-27	1998-06-27 00:00:00	38000275	0	\N	\N	178073	0	384700001	4293740	
18634	1593	4125906	1968-10-22	1968-10-22 00:00:00	38000275	0	\N	\N	106846	0	288086009	4125906	
30720	2715	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	179978	0	180256009	4107731	
30887	2732	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	180892	0	180256009	4107731	
31189	2765	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	182902	0	180256009	4107731	
19404	1659	4043071	1980-03-24	1980-03-24 00:00:00	38000275	0	\N	\N	111534	0	228557008	4043071	
31467	2778	4107731	1993-05-29	1993-05-29 00:00:00	38000275	0	\N	\N	183975	0	180256009	4107731	
31638	2786	4047491	1939-07-17	1939-07-17 00:00:00	38000275	0	\N	\N	184608	0	1225002	4047491	
31946	2813	4057420	2015-02-20	2015-02-20 00:00:00	38000275	0	\N	\N	186468	0	18286008	4057420	
20181	1743	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	116502	0	180256009	4107731	
20281	1753	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	117203	0	395142003	4191853	
32523	2858	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	189843	0	180256009	4107731	
32648	2868	4163872	2009-05-31	2009-05-31 00:00:00	38000275	0	\N	\N	190808	0	399208008	4163872	
44758	3917	4078793	2016-03-03	2016-03-03 00:00:00	38000275	0	\N	\N	260488	0	180325003	4078793	
32979	2895	4163872	1968-01-31	1968-01-31 00:00:00	38000275	0	\N	\N	192713	0	399208008	4163872	
21255	1843	4107731	1995-06-14	1995-06-14 00:00:00	38000275	0	\N	\N	123017	0	180256009	4107731	
21482	1860	4057420	1991-12-23	1991-12-23 00:00:00	38000275	0	\N	\N	124407	0	18286008	4057420	
45563	4018	4293740	1975-12-14	1975-12-14 00:00:00	38000275	0	\N	\N	267051	0	384700001	4293740	
33723	2942	4151422	2012-10-25	2012-10-25 00:00:00	38000275	0	\N	\N	196223	0	269911007	4151422	
33956	2959	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	197497	0	180256009	4107731	
34083	2965	4107731	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	198009	0	180256009	4107731	
22359	1956	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	130153	0	180256009	4107731	
22600	1976	4295880	1999-03-15	1999-03-15 00:00:00	38000275	0	\N	\N	131393	0	76601001	4295880	
34661	3013	4163872	2014-05-05	2014-05-05 00:00:00	38000275	0	\N	\N	200967	0	399208008	4163872	
34830	3025	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	201642	0	180256009	4107731	
47082	4130	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	274553	0	180256009	4107731	
35232	3069	4170947	1969-01-27	1969-01-27 00:00:00	38000275	0	\N	\N	204309	0	274474001	4170947	
35455	3109	4043071	1928-03-07	1928-03-07 00:00:00	38000275	0	\N	\N	206785	0	228557008	4043071	
35579	3115	4047491	1972-01-15	1972-01-15 00:00:00	38000275	0	\N	\N	207277	0	1225002	4047491	
23906	2077	4107731	1993-02-07	1993-02-07 00:00:00	38000275	0	\N	\N	138253	0	180256009	4107731	
12048	1101	4043071	1984-05-08	1984-05-08 00:00:00	38000275	0	\N	\N	72343	0	228557008	4043071	
24221	2119	4107731	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	141065	0	180256009	4107731	
12521	1136	4043071	1985-10-12	1985-10-12 00:00:00	38000275	0	\N	\N	74858	0	228557008	4043071	
24607	2152	4202451	2007-09-08	2007-09-08 00:00:00	38000275	0	\N	\N	143419	0	433112001	4202451	
24841	2173	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	144742	0	180256009	4107731	
24883	2174	4151422	1991-06-03	1991-06-03 00:00:00	38000275	0	\N	\N	144935	0	269911007	4151422	
25148	2189	4107731	2010-06-02	2010-06-02 00:00:00	38000275	0	\N	\N	145959	0	180256009	4107731	
25336	2200	4043071	1980-12-21	1980-12-21 00:00:00	38000275	0	\N	\N	146670	0	228557008	4043071	
25563	2238	4191853	1993-07-04	1993-07-04 00:00:00	38000275	0	\N	\N	148967	0	395142003	4191853	
25745	2258	4243062	1977-11-25	1977-11-25 00:00:00	38000275	0	\N	\N	150058	0	60027007	4243062	
13992	1265	4275113	1997-04-24	1997-04-24 00:00:00	38000275	0	\N	\N	83372	0	65200003	4275113	
14196	1276	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	84223	0	180256009	4107731	
26276	2291	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	152530	0	180256009	4107731	
26547	2314	4252419	1961-01-15	1961-01-15 00:00:00	38000275	0	\N	\N	153863	0	74016001	4252419	
26699	2339	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	155603	0	180256009	4107731	
26762	2341	4151422	2006-05-28	2006-05-28 00:00:00	38000275	0	\N	\N	155817	0	269911007	4151422	
26993	2356	4043071	1990-05-20	1990-05-20 00:00:00	38000275	0	\N	\N	156885	0	228557008	4043071	
15296	1367	4047491	1969-03-15	1969-03-15 00:00:00	38000275	0	\N	\N	90620	0	1225002	4047491	
27406	2392	4035793	1978-02-10	1978-02-10 00:00:00	38000275	0	\N	\N	159086	0	15081005	4035793	
15653	1387	4275113	1983-03-31	1983-03-31 00:00:00	38000275	0	\N	\N	92047	0	65200003	4275113	
27774	2436	4107731	1992-12-12	1992-12-12 00:00:00	38000275	0	\N	\N	161530	0	180256009	4107731	
16068	1401	4058899	1987-03-14	1987-03-14 00:00:00	38000275	0	\N	\N	93178	0	168594001	4058899	
16221	1410	4275113	1994-01-17	1994-01-17 00:00:00	38000275	0	\N	\N	93850	0	65200003	4275113	
28417	2534	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	167455	0	180256009	4107731	
28469	2534	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	167452	0	180256009	4107731	
40583	3566	4107731	1990-07-09	1990-07-09 00:00:00	38000275	0	\N	\N	236893	0	180256009	4107731	
28920	2559	4151422	1986-03-13	1986-03-13 00:00:00	38000275	0	\N	\N	169594	0	269911007	4151422	
17123	1482	4107731	1992-01-11	1992-01-11 00:00:00	38000275	0	\N	\N	98869	0	180256009	4107731	
29179	2586	4043071	1981-07-25	1981-07-25 00:00:00	38000275	0	\N	\N	171126	0	228557008	4043071	
29372	2620	4170947	1979-09-19	1979-09-19 00:00:00	38000275	0	\N	\N	173271	0	274474001	4170947	
41520	3647	4043071	1945-01-03	1945-01-03 00:00:00	38000275	0	\N	\N	242715	0	228557008	4043071	
29807	2649	4151422	2017-06-15	2017-06-15 00:00:00	38000275	0	\N	\N	175275	0	269911007	4151422	
30056	2661	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	176371	0	180256009	4107731	
30217	2673	4107731	1990-03-05	1990-03-05 00:00:00	38000275	0	\N	\N	177110	0	180256009	4107731	
30436	2686	4125906	1998-06-27	1998-06-27 00:00:00	38000275	0	\N	\N	178073	0	288086009	4125906	
18635	1593	4125906	1953-06-01	1953-06-01 00:00:00	38000275	0	\N	\N	106842	0	288086009	4125906	
30721	2715	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	180084	0	180256009	4107731	
30888	2732	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	180900	0	180256009	4107731	
31190	2765	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	182931	0	180256009	4107731	
19405	1659	4043071	1982-01-25	1982-01-25 00:00:00	38000275	0	\N	\N	111462	0	228557008	4043071	
31468	2778	4107731	1990-03-31	1990-03-31 00:00:00	38000275	0	\N	\N	184017	0	180256009	4107731	
31639	2786	4170947	2002-03-19	2002-03-19 00:00:00	38000275	0	\N	\N	184613	0	274474001	4170947	
31947	2813	4078793	2016-02-26	2016-02-26 00:00:00	38000275	0	\N	\N	186386	0	180325003	4078793	
20182	1743	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	116586	0	180256009	4107731	
20282	1753	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	117234	0	180256009	4107731	
32524	2858	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	189955	0	180256009	4107731	
32649	2868	4125906	1970-03-02	1970-03-02 00:00:00	38000275	0	\N	\N	190818	0	288086009	4125906	
44759	3917	4057420	2014-02-27	2014-02-27 00:00:00	38000275	0	\N	\N	260496	0	18286008	4057420	
32980	2895	4151422	1984-05-20	1984-05-20 00:00:00	38000275	0	\N	\N	192738	0	269911007	4151422	
21256	1843	4107731	1997-07-09	1997-07-09 00:00:00	38000275	0	\N	\N	123063	0	180256009	4107731	
21483	1860	40492359	1991-12-23	1991-12-23 00:00:00	38000275	0	\N	\N	124407	0	447365002	40492359	
45564	4018	4125906	1975-12-14	1975-12-14 00:00:00	38000275	0	\N	\N	267051	0	288086009	4125906	
33724	2942	4078793	2017-10-04	2017-10-04 00:00:00	38000275	0	\N	\N	196156	0	180325003	4078793	
33957	2959	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	197496	0	180256009	4107731	
34084	2965	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	197963	0	180256009	4107731	
22360	1956	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	130133	0	180256009	4107731	
22601	1976	4107731	1998-06-15	1998-06-15 00:00:00	38000275	0	\N	\N	131392	0	180256009	4107731	
34662	3013	4117038	1976-06-30	1976-06-30 00:00:00	38000275	0	\N	\N	200984	0	287664005	4117038	
34831	3025	4107731	1992-11-16	1992-11-16 00:00:00	38000275	0	\N	\N	201693	0	180256009	4107731	
47083	4130	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	274546	0	180256009	4107731	
35233	3069	4125906	1997-04-26	1997-04-26 00:00:00	38000275	0	\N	\N	204314	0	288086009	4125906	
35456	3109	4043071	1929-01-30	1929-01-30 00:00:00	38000275	0	\N	\N	206765	0	228557008	4043071	
35580	3115	4125906	1994-10-07	1994-10-07 00:00:00	38000275	0	\N	\N	207280	0	288086009	4125906	
23907	2077	4107731	1991-07-21	1991-07-21 00:00:00	38000275	0	\N	\N	138343	0	180256009	4107731	
12049	1101	4043071	1983-10-18	1983-10-18 00:00:00	38000275	0	\N	\N	72339	0	228557008	4043071	
24222	2119	4107731	1991-12-16	1991-12-16 00:00:00	38000275	0	\N	\N	141020	0	180256009	4107731	
12522	1136	4043071	1985-08-10	1985-08-10 00:00:00	38000275	0	\N	\N	74827	0	228557008	4043071	
24608	2152	4078793	2009-02-28	2009-02-28 00:00:00	38000275	0	\N	\N	143367	0	180325003	4078793	
24842	2173	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	144718	0	180256009	4107731	
24884	2175	4107731	2010-07-06	2010-07-06 00:00:00	38000275	0	\N	\N	145078	0	180256009	4107731	
25149	2189	4107731	2013-02-13	2013-02-13 00:00:00	38000275	0	\N	\N	145946	0	180256009	4107731	
25337	2200	4043071	1985-07-14	1985-07-14 00:00:00	38000275	0	\N	\N	146669	0	228557008	4043071	
25564	2238	4107731	1990-11-11	1990-11-11 00:00:00	38000275	0	\N	\N	148995	0	180256009	4107731	
25746	2258	4170947	1977-11-25	1977-11-25 00:00:00	38000275	0	\N	\N	150058	0	274474001	4170947	
13993	1265	4238715	2001-04-01	2001-04-01 00:00:00	38000275	0	\N	\N	83417	0	68254000	4238715	
14197	1276	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	84166	0	180256009	4107731	
26277	2291	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	152436	0	180256009	4107731	
26548	2314	4043071	1963-10-17	1963-10-17 00:00:00	38000275	0	\N	\N	153853	0	228557008	4043071	
26700	2339	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	155698	0	180256009	4107731	
26763	2341	4057420	2017-05-25	2017-05-25 00:00:00	38000275	0	\N	\N	155836	0	18286008	4057420	
26994	2356	4043071	1989-05-14	1989-05-14 00:00:00	38000275	0	\N	\N	156884	0	228557008	4043071	
15297	1367	4170947	1969-03-15	1969-03-15 00:00:00	38000275	0	\N	\N	90620	0	274474001	4170947	
27407	2392	4078793	2009-07-24	2009-07-24 00:00:00	38000275	0	\N	\N	159066	0	180325003	4078793	
15654	1387	4043071	1984-08-12	1984-08-12 00:00:00	38000275	0	\N	\N	92052	0	228557008	4043071	
27775	2436	4107731	1992-10-10	1992-10-10 00:00:00	38000275	0	\N	\N	161651	0	180256009	4107731	
16069	1401	4125906	1989-11-28	1989-11-28 00:00:00	38000275	0	\N	\N	93179	0	288086009	4125906	
16222	1411	4058899	1972-04-27	1972-04-27 00:00:00	38000275	0	\N	\N	93976	0	168594001	4058899	
28418	2534	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	167427	0	180256009	4107731	
28470	2534	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	167465	0	180256009	4107731	
40584	3566	4107731	1990-06-18	1990-06-18 00:00:00	38000275	0	\N	\N	236832	0	180256009	4107731	
28921	2559	4107731	1991-09-07	1991-09-07 00:00:00	38000275	0	\N	\N	169591	0	180256009	4107731	
17124	1482	4107731	1991-11-09	1991-11-09 00:00:00	38000275	0	\N	\N	98912	0	180256009	4107731	
29180	2586	4043071	1983-11-26	1983-11-26 00:00:00	38000275	0	\N	\N	171159	0	228557008	4043071	
29373	2621	4125906	1964-10-12	1964-10-12 00:00:00	38000275	0	\N	\N	173397	0	288086009	4125906	
41521	3647	4043071	1946-01-23	1946-01-23 00:00:00	38000275	0	\N	\N	242675	0	228557008	4043071	
29808	2649	4125906	1962-05-08	1962-05-08 00:00:00	38000275	0	\N	\N	175265	0	288086009	4125906	
30057	2661	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	176258	0	180256009	4107731	
30218	2673	4107731	1990-08-20	1990-08-20 00:00:00	38000275	0	\N	\N	177099	0	180256009	4107731	
30437	2686	4125906	1972-10-20	1972-10-20 00:00:00	38000275	0	\N	\N	178071	0	288086009	4125906	
18636	1593	4037675	1973-10-01	1973-10-01 00:00:00	38000275	0	\N	\N	106850	0	162676008	4037675	
30722	2715	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	180012	0	180256009	4107731	
30889	2732	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	180932	0	180256009	4107731	
31191	2765	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	182930	0	180256009	4107731	
19406	1659	4043071	1978-10-30	1978-10-30 00:00:00	38000275	0	\N	\N	111482	0	228557008	4043071	
31469	2778	4107731	1992-10-10	1992-10-10 00:00:00	38000275	0	\N	\N	184075	0	180256009	4107731	
31640	2786	4047491	2002-03-19	2002-03-19 00:00:00	38000275	0	\N	\N	184613	0	1225002	4047491	
31948	2813	4078793	2017-03-03	2017-03-03 00:00:00	38000275	0	\N	\N	186469	0	180325003	4078793	
20183	1743	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	116524	0	180256009	4107731	
20283	1753	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	117233	0	180256009	4107731	
32525	2858	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	189889	0	180256009	4107731	
32650	2868	4336464	2016-02-10	2016-02-10 00:00:00	38000275	0	\N	\N	190820	0	232717009	4336464	
44760	3917	4078793	2018-09-13	2018-09-13 00:00:00	38000275	0	\N	\N	260459	0	180325003	4078793	
32981	2895	4163872	2000-03-21	2000-03-21 00:00:00	38000275	0	\N	\N	192739	0	399208008	4163872	
21257	1843	4107731	1996-12-11	1996-12-11 00:00:00	38000275	0	\N	\N	123117	0	180256009	4107731	
21484	1861	4058899	1995-02-28	1995-02-28 00:00:00	38000275	0	\N	\N	124414	0	168594001	4058899	
45565	4018	4125906	1968-02-03	1968-02-03 00:00:00	38000275	0	\N	\N	267049	0	288086009	4125906	
33725	2942	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	196081	0	180256009	4107731	
33958	2959	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	197500	0	180256009	4107731	
34085	2965	4107731	1991-12-16	1991-12-16 00:00:00	38000275	0	\N	\N	197992	0	180256009	4107731	
22361	1956	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	130161	0	180256009	4107731	
22602	1976	4107731	1997-01-06	1997-01-06 00:00:00	38000275	0	\N	\N	131439	0	180256009	4107731	
34663	3014	44783196	2013-06-12	2013-06-12 00:00:00	38000275	0	\N	\N	201034	0	699253003	44783196	
34832	3025	4107731	1991-04-29	1991-04-29 00:00:00	38000275	0	\N	\N	201611	0	180256009	4107731	
47084	4130	4078793	2018-05-31	2018-05-31 00:00:00	38000275	0	\N	\N	274533	0	180325003	4078793	
35234	3069	4125906	1971-12-13	1971-12-13 00:00:00	38000275	0	\N	\N	204310	0	288086009	4125906	
35457	3109	4043071	1925-09-16	1925-09-16 00:00:00	38000275	0	\N	\N	206799	0	228557008	4043071	
35582	3117	4293740	2015-03-24	2015-03-24 00:00:00	38000275	0	\N	\N	207399	0	384700001	4293740	
23908	2077	4107731	1992-02-16	1992-02-16 00:00:00	38000275	0	\N	\N	138248	0	180256009	4107731	
12050	1101	4043071	1984-01-31	1984-01-31 00:00:00	38000275	0	\N	\N	72302	0	228557008	4043071	
24223	2119	4107731	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	141023	0	180256009	4107731	
12523	1136	4043071	1985-06-15	1985-06-15 00:00:00	38000275	0	\N	\N	74857	0	228557008	4043071	
24609	2152	4057420	2017-11-04	2017-11-04 00:00:00	38000275	0	\N	\N	143404	0	18286008	4057420	
24843	2173	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	144852	0	180256009	4107731	
24885	2175	4107731	2011-07-19	2011-07-19 00:00:00	38000275	0	\N	\N	144962	0	180256009	4107731	
25150	2189	4107731	2011-03-02	2011-03-02 00:00:00	38000275	0	\N	\N	145962	0	180256009	4107731	
25338	2200	4043071	1982-02-14	1982-02-14 00:00:00	38000275	0	\N	\N	146612	0	228557008	4043071	
25565	2238	4107731	1993-05-02	1993-05-02 00:00:00	38000275	0	\N	\N	148955	0	180256009	4107731	
25758	2260	4195803	2012-09-30	2012-09-30 00:00:00	38000275	0	\N	\N	150193	0	312681000	4195803	
13994	1265	4191853	1983-06-08	1983-06-08 00:00:00	38000275	0	\N	\N	83401	0	395142003	4191853	
14198	1276	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	84188	0	180256009	4107731	
26278	2291	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	152558	0	180256009	4107731	
26549	2314	4043071	1964-02-13	1964-02-13 00:00:00	38000275	0	\N	\N	153824	0	228557008	4043071	
26701	2339	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	155696	0	180256009	4107731	
26764	2341	4057420	2008-04-03	2008-04-03 00:00:00	38000275	0	\N	\N	155815	0	18286008	4057420	
26995	2356	4043071	1989-12-31	1989-12-31 00:00:00	38000275	0	\N	\N	156905	0	228557008	4043071	
15298	1368	4125906	1985-01-30	1985-01-30 00:00:00	38000275	0	\N	\N	90747	0	288086009	4125906	
27408	2392	4035793	2009-07-24	2009-07-24 00:00:00	38000275	0	\N	\N	159066	0	15081005	4035793	
15655	1387	4043071	1981-06-28	1981-06-28 00:00:00	38000275	0	\N	\N	92031	0	228557008	4043071	
27776	2436	4107731	1990-03-31	1990-03-31 00:00:00	38000275	0	\N	\N	161605	0	180256009	4107731	
16070	1401	4293740	1989-11-28	1989-11-28 00:00:00	38000275	0	\N	\N	93179	0	384700001	4293740	
16223	1411	44783196	1996-03-29	1996-03-29 00:00:00	38000275	0	\N	\N	93977	0	699253003	44783196	
28419	2534	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	167365	0	180256009	4107731	
28471	2534	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	167395	0	180256009	4107731	
40585	3566	4043071	1960-10-31	1960-10-31 00:00:00	38000275	0	\N	\N	236830	0	228557008	4043071	
28922	2559	4107731	1990-01-27	1990-01-27 00:00:00	38000275	0	\N	\N	169584	0	180256009	4107731	
17125	1482	4107731	1993-05-29	1993-05-29 00:00:00	38000275	0	\N	\N	98835	0	180256009	4107731	
29181	2586	4043071	1983-09-24	1983-09-24 00:00:00	38000275	0	\N	\N	171215	0	228557008	4043071	
29374	2621	4125906	1966-09-16	1966-09-16 00:00:00	38000275	0	\N	\N	173398	0	288086009	4125906	
41522	3647	4125906	1991-09-01	1991-09-01 00:00:00	38000275	0	\N	\N	242665	0	288086009	4125906	
29809	2651	4151422	1952-12-26	1952-12-26 00:00:00	38000275	0	\N	\N	175484	0	269911007	4151422	
30058	2661	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	176272	0	180256009	4107731	
30219	2673	4107731	1991-03-18	1991-03-18 00:00:00	38000275	0	\N	\N	177081	0	180256009	4107731	
30438	2688	4151422	1964-06-12	1964-06-12 00:00:00	38000275	0	\N	\N	178091	0	269911007	4151422	
18637	1593	4187458	1973-10-01	1973-10-01 00:00:00	38000275	0	\N	\N	106850	0	415300000	4187458	
30723	2715	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	180055	0	180256009	4107731	
30890	2732	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	180913	0	180256009	4107731	
31192	2765	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	182943	0	180256009	4107731	
19407	1659	4043071	1980-08-04	1980-08-04 00:00:00	38000275	0	\N	\N	111426	0	228557008	4043071	
31470	2778	4107731	1992-08-29	1992-08-29 00:00:00	38000275	0	\N	\N	183992	0	180256009	4107731	
31641	2788	4043071	1991-04-20	1991-04-20 00:00:00	38000275	0	\N	\N	184705	0	228557008	4043071	
31949	2813	4078793	2014-10-24	2014-10-24 00:00:00	38000275	0	\N	\N	186467	0	180325003	4078793	
20184	1743	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	116498	0	180256009	4107731	
20284	1753	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	117219	0	180256009	4107731	
32526	2858	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	189810	0	180256009	4107731	
32651	2868	4216130	2016-02-10	2016-02-10 00:00:00	38000275	0	\N	\N	190820	0	415070008	4216130	
44761	3917	4078793	2017-09-07	2017-09-07 00:00:00	38000275	0	\N	\N	260497	0	180325003	4078793	
32982	2895	4191853	1986-01-09	1986-01-09 00:00:00	38000275	0	\N	\N	192693	0	395142003	4191853	
21258	1843	4107731	1996-11-20	1996-11-20 00:00:00	38000275	0	\N	\N	123109	0	180256009	4107731	
21485	1861	4125906	2000-02-02	2000-02-02 00:00:00	38000275	0	\N	\N	124415	0	288086009	4125906	
45566	4018	4151422	1967-08-08	1967-08-08 00:00:00	38000275	0	\N	\N	267103	0	269911007	4151422	
33726	2942	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	196232	0	180256009	4107731	
33959	2959	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	197461	0	180256009	4107731	
34086	2965	4107731	1991-04-08	1991-04-08 00:00:00	38000275	0	\N	\N	197948	0	180256009	4107731	
22362	1956	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	130170	0	180256009	4107731	
22603	1976	4295880	1999-06-14	1999-06-14 00:00:00	38000275	0	\N	\N	131385	0	76601001	4295880	
34664	3014	4151422	2000-03-19	2000-03-19 00:00:00	38000275	0	\N	\N	200987	0	269911007	4151422	
34833	3025	4107731	1991-12-16	1991-12-16 00:00:00	38000275	0	\N	\N	201633	0	180256009	4107731	
47085	4130	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	274635	0	180256009	4107731	
35235	3069	4252419	1986-08-01	1986-08-01 00:00:00	38000275	0	\N	\N	204312	0	74016001	4252419	
35458	3109	4043071	1929-05-22	1929-05-22 00:00:00	38000275	0	\N	\N	206731	0	228557008	4043071	
35583	3117	4125906	2015-03-24	2015-03-24 00:00:00	38000275	0	\N	\N	207399	0	288086009	4125906	
23909	2077	4057420	2005-08-21	2005-08-21 00:00:00	38000275	0	\N	\N	138380	0	18286008	4057420	
12051	1101	4057420	1982-08-22	1982-08-22 00:00:00	38000275	0	\N	\N	72326	0	18286008	4057420	
24224	2119	4107731	1991-01-14	1991-01-14 00:00:00	38000275	0	\N	\N	141062	0	180256009	4107731	
12524	1136	4151422	1995-05-26	1995-05-26 00:00:00	38000275	0	\N	\N	74860	0	269911007	4151422	
24610	2152	4057420	2016-10-29	2016-10-29 00:00:00	38000275	0	\N	\N	143343	0	18286008	4057420	
24844	2173	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	144853	0	180256009	4107731	
24886	2175	4107731	2011-12-13	2011-12-13 00:00:00	38000275	0	\N	\N	144953	0	180256009	4107731	
25151	2189	4107731	2013-07-10	2013-07-10 00:00:00	38000275	0	\N	\N	145934	0	180256009	4107731	
25339	2200	4043071	1984-07-22	1984-07-22 00:00:00	38000275	0	\N	\N	146667	0	228557008	4043071	
25566	2238	4107731	1992-12-06	1992-12-06 00:00:00	38000275	0	\N	\N	148950	0	180256009	4107731	
25759	2260	4151422	1969-10-15	1969-10-15 00:00:00	38000275	0	\N	\N	150247	0	269911007	4151422	
13995	1266	4151422	1992-07-21	1992-07-21 00:00:00	38000275	0	\N	\N	83487	0	269911007	4151422	
14199	1276	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	84167	0	180256009	4107731	
26279	2291	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	152526	0	180256009	4107731	
26550	2314	4043071	1964-05-14	1964-05-14 00:00:00	38000275	0	\N	\N	153905	0	228557008	4043071	
26702	2339	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	155644	0	180256009	4107731	
26765	2341	4078793	2014-05-08	2014-05-08 00:00:00	38000275	0	\N	\N	155783	0	180325003	4078793	
26996	2356	4043071	1989-01-01	1989-01-01 00:00:00	38000275	0	\N	\N	156865	0	228557008	4043071	
15299	1368	4202451	2019-06-26	2019-06-26 00:00:00	38000275	0	\N	\N	90677	0	433112001	4202451	
27409	2392	4035793	2013-08-16	2013-08-16 00:00:00	38000275	0	\N	\N	158982	0	15081005	4035793	
15656	1387	4043071	1983-04-24	1983-04-24 00:00:00	38000275	0	\N	\N	92049	0	228557008	4043071	
27777	2436	4107731	1991-02-09	1991-02-09 00:00:00	38000275	0	\N	\N	161609	0	180256009	4107731	
27875	2450	4151422	1984-05-18	1984-05-18 00:00:00	38000275	0	\N	\N	162539	0	269911007	4151422	
16224	1411	4252419	1996-03-22	1996-03-22 00:00:00	38000275	0	\N	\N	93966	0	74016001	4252419	
28420	2534	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	167446	0	180256009	4107731	
28472	2534	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	167461	0	180256009	4107731	
40586	3566	4043071	1960-03-28	1960-03-28 00:00:00	38000275	0	\N	\N	236913	0	228557008	4043071	
28923	2559	4107731	1992-10-10	1992-10-10 00:00:00	38000275	0	\N	\N	169610	0	180256009	4107731	
17126	1482	4107731	1991-05-25	1991-05-25 00:00:00	38000275	0	\N	\N	98867	0	180256009	4107731	
29182	2586	4043071	1982-11-13	1982-11-13 00:00:00	38000275	0	\N	\N	171212	0	228557008	4043071	
29375	2621	4252419	1999-06-10	1999-06-10 00:00:00	38000275	0	\N	\N	173402	0	74016001	4252419	
41523	3647	4043071	1945-12-26	1945-12-26 00:00:00	38000275	0	\N	\N	242716	0	228557008	4043071	
29810	2651	4047491	1956-04-03	1956-04-03 00:00:00	38000275	0	\N	\N	175417	0	1225002	4047491	
30059	2661	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	176276	0	180256009	4107731	
30220	2673	4107731	1992-09-14	1992-09-14 00:00:00	38000275	0	\N	\N	177067	0	180256009	4107731	
30442	2690	4125906	1996-03-22	1996-03-22 00:00:00	38000275	0	\N	\N	178253	0	288086009	4125906	
18638	1593	4326177	1973-10-01	1973-10-01 00:00:00	38000275	0	\N	\N	106850	0	430193006	4326177	
30724	2715	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	180000	0	180256009	4107731	
30891	2732	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	180852	0	180256009	4107731	
31193	2765	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	182934	0	180256009	4107731	
19408	1659	4043071	1977-06-27	1977-06-27 00:00:00	38000275	0	\N	\N	111438	0	228557008	4043071	
31471	2778	4107731	1993-01-02	1993-01-02 00:00:00	38000275	0	\N	\N	184077	0	180256009	4107731	
31642	2788	4252419	2017-11-24	2017-11-24 00:00:00	38000275	0	\N	\N	184724	0	74016001	4252419	
31950	2813	4151422	1940-05-27	1940-05-27 00:00:00	38000275	0	\N	\N	186406	0	269911007	4151422	
20185	1743	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	116519	0	180256009	4107731	
20285	1753	4062501	1967-05-14	1967-05-14 00:00:00	38000275	0	\N	\N	117194	0	171231001	4062501	
32527	2858	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	189915	0	180256009	4107731	
32652	2868	4151422	1966-02-22	1966-02-22 00:00:00	38000275	0	\N	\N	190797	0	269911007	4151422	
44787	3920	4151422	1999-01-16	1999-01-16 00:00:00	38000275	0	\N	\N	260672	0	269911007	4151422	
32983	2895	4151422	2013-06-10	2013-06-10 00:00:00	38000275	0	\N	\N	192740	0	269911007	4151422	
21259	1843	4107731	1995-08-16	1995-08-16 00:00:00	38000275	0	\N	\N	123025	0	180256009	4107731	
21486	1861	4125906	1983-10-19	1983-10-19 00:00:00	38000275	0	\N	\N	124409	0	288086009	4125906	
45567	4018	4024289	1964-12-20	1964-12-20 00:00:00	38000275	0	\N	\N	267048	0	19490002	4024289	
33727	2942	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	196064	0	180256009	4107731	
33960	2959	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	197539	0	180256009	4107731	
34087	2965	4107731	1990-03-05	1990-03-05 00:00:00	38000275	0	\N	\N	197923	0	180256009	4107731	
22363	1956	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	130130	0	180256009	4107731	
22604	1976	4107731	1999-06-07	1999-06-07 00:00:00	38000275	0	\N	\N	131403	0	180256009	4107731	
34665	3014	4252419	2013-06-05	2013-06-05 00:00:00	38000275	0	\N	\N	201001	0	74016001	4252419	
34834	3025	4107731	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	201580	0	180256009	4107731	
47086	4130	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	274529	0	180256009	4107731	
35236	3069	4151422	1991-02-12	1991-02-12 00:00:00	38000275	0	\N	\N	204247	0	269911007	4151422	
35459	3109	4043071	1928-10-24	1928-10-24 00:00:00	38000275	0	\N	\N	206845	0	228557008	4043071	
35584	3118	4107731	1992-08-23	1992-08-23 00:00:00	38000275	0	\N	\N	207521	0	180256009	4107731	
23910	2077	40492359	2005-08-21	2005-08-21 00:00:00	38000275	0	\N	\N	138380	0	447365002	40492359	
12052	1101	40492359	1982-08-22	1982-08-22 00:00:00	38000275	0	\N	\N	72326	0	447365002	40492359	
24225	2119	4107731	1991-11-25	1991-11-25 00:00:00	38000275	0	\N	\N	141066	0	180256009	4107731	
12525	1136	4058899	1984-11-02	1984-11-02 00:00:00	38000275	0	\N	\N	74865	0	168594001	4058899	
24611	2153	4151422	1981-06-30	1981-06-30 00:00:00	38000275	0	\N	\N	143505	0	269911007	4151422	
24845	2173	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	144861	0	180256009	4107731	
24887	2175	4107731	2010-09-07	2010-09-07 00:00:00	38000275	0	\N	\N	144958	0	180256009	4107731	
25152	2189	4107731	2012-08-29	2012-08-29 00:00:00	38000275	0	\N	\N	145930	0	180256009	4107731	
25340	2200	4043071	1982-08-29	1982-08-29 00:00:00	38000275	0	\N	\N	146615	0	228557008	4043071	
25567	2238	4107731	1991-10-13	1991-10-13 00:00:00	38000275	0	\N	\N	149010	0	180256009	4107731	
25760	2260	4058899	1994-09-02	1994-09-02 00:00:00	38000275	0	\N	\N	150220	0	168594001	4058899	
13996	1266	4243062	1971-03-19	1971-03-19 00:00:00	38000275	0	\N	\N	83453	0	60027007	4243062	
14200	1276	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	84226	0	180256009	4107731	
26280	2291	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	152471	0	180256009	4107731	
26551	2314	4163872	1991-12-04	1991-12-04 00:00:00	38000275	0	\N	\N	153890	0	399208008	4163872	
26703	2339	4330583	2005-08-21	2005-08-21 00:00:00	38000275	0	\N	\N	155616	0	22523008	4330583	
26766	2341	4078793	2009-04-09	2009-04-09 00:00:00	38000275	0	\N	\N	155797	0	180325003	4078793	
26997	2356	4043071	1989-11-26	1989-11-26 00:00:00	38000275	0	\N	\N	156904	0	228557008	4043071	
15300	1368	4058899	1959-05-19	1959-05-19 00:00:00	38000275	0	\N	\N	90716	0	168594001	4058899	
27410	2392	4078793	2013-08-16	2013-08-16 00:00:00	38000275	0	\N	\N	158982	0	180325003	4078793	
15657	1387	4043071	1986-04-06	1986-04-06 00:00:00	38000275	0	\N	\N	92011	0	228557008	4043071	
27778	2436	4107731	1990-06-23	1990-06-23 00:00:00	38000275	0	\N	\N	161503	0	180256009	4107731	
27876	2450	4037675	1974-12-29	1974-12-29 00:00:00	38000275	0	\N	\N	162503	0	162676008	4037675	
16225	1411	4202832	1999-11-23	1999-11-23 00:00:00	38000275	0	\N	\N	93967	0	52765003	4202832	
28421	2534	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	167366	0	180256009	4107731	
28473	2534	4107731	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	167363	0	180256009	4107731	
40587	3566	4107731	1993-03-01	1993-03-01 00:00:00	38000275	0	\N	\N	236848	0	180256009	4107731	
28924	2559	4107731	1992-08-29	1992-08-29 00:00:00	38000275	0	\N	\N	169628	0	180256009	4107731	
17127	1482	4107731	1993-04-17	1993-04-17 00:00:00	38000275	0	\N	\N	98834	0	180256009	4107731	
29183	2588	4037675	2016-08-17	2016-08-17 00:00:00	38000275	0	\N	\N	171266	0	162676008	4037675	
29376	2621	4125906	1983-07-08	1983-07-08 00:00:00	38000275	0	\N	\N	173400	0	288086009	4125906	
41524	3647	4043071	1943-11-24	1943-11-24 00:00:00	38000275	0	\N	\N	242712	0	228557008	4043071	
29811	2651	4170947	1956-04-03	1956-04-03 00:00:00	38000275	0	\N	\N	175417	0	274474001	4170947	
30060	2661	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	176260	0	180256009	4107731	
30221	2673	4107731	1990-10-01	1990-10-01 00:00:00	38000275	0	\N	\N	177141	0	180256009	4107731	
30443	2690	4125906	1997-04-30	1997-04-30 00:00:00	38000275	0	\N	\N	178254	0	288086009	4125906	
18639	1593	4163872	1941-08-05	1941-08-05 00:00:00	38000275	0	\N	\N	106919	0	399208008	4163872	
30725	2715	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	180034	0	180256009	4107731	
30892	2732	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	180940	0	180256009	4107731	
31194	2765	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	182946	0	180256009	4107731	
19409	1659	4043071	1981-05-11	1981-05-11 00:00:00	38000275	0	\N	\N	111561	0	228557008	4043071	
31472	2778	4107731	1990-09-15	1990-09-15 00:00:00	38000275	0	\N	\N	184032	0	180256009	4107731	
31643	2788	44783196	2017-12-01	2017-12-01 00:00:00	38000275	0	\N	\N	184722	0	699253003	44783196	
31951	2813	4170947	2015-07-18	2015-07-18 00:00:00	38000275	0	\N	\N	186417	0	274474001	4170947	
20186	1743	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	116573	0	180256009	4107731	
20286	1753	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	117216	0	180256009	4107731	
32528	2858	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	189812	0	180256009	4107731	
32653	2869	4151422	1976-04-27	1976-04-27 00:00:00	38000275	0	\N	\N	190890	0	269911007	4151422	
44788	3920	4252419	1989-01-29	1989-01-29 00:00:00	38000275	0	\N	\N	260684	0	74016001	4252419	
32984	2895	4151422	1959-12-13	1959-12-13 00:00:00	38000275	0	\N	\N	192736	0	269911007	4151422	
21260	1843	4107731	1997-03-26	1997-03-26 00:00:00	38000275	0	\N	\N	123032	0	180256009	4107731	
21487	1861	4125906	1986-10-24	1986-10-24 00:00:00	38000275	0	\N	\N	124410	0	288086009	4125906	
45568	4018	4170947	1964-12-20	1964-12-20 00:00:00	38000275	0	\N	\N	267048	0	274474001	4170947	
33728	2942	4198190	2005-07-17	2005-07-17 00:00:00	38000275	0	\N	\N	196179	0	80146002	4198190	
33961	2959	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	197577	0	180256009	4107731	
34088	2965	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	197897	0	180256009	4107731	
22364	1956	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	130195	0	180256009	4107731	
22605	1976	4107731	1997-08-25	1997-08-25 00:00:00	38000275	0	\N	\N	131441	0	180256009	4107731	
34666	3014	4151422	1998-01-21	1998-01-21 00:00:00	38000275	0	\N	\N	201037	0	269911007	4151422	
34835	3025	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	201618	0	180256009	4107731	
47087	4130	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	274593	0	180256009	4107731	
35237	3069	4125906	1968-02-11	1968-02-11 00:00:00	38000275	0	\N	\N	204308	0	288086009	4125906	
35460	3109	4043071	1926-01-27	1926-01-27 00:00:00	38000275	0	\N	\N	206802	0	228557008	4043071	
35585	3118	4107731	1990-09-09	1990-09-09 00:00:00	38000275	0	\N	\N	207469	0	180256009	4107731	
23911	2077	4107731	1990-06-17	1990-06-17 00:00:00	38000275	0	\N	\N	138244	0	180256009	4107731	
12053	1102	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	72389	0	180256009	4107731	
24226	2119	4107731	1990-10-01	1990-10-01 00:00:00	38000275	0	\N	\N	141060	0	180256009	4107731	
12526	1137	4125906	1993-09-02	1993-09-02 00:00:00	38000275	0	\N	\N	74936	0	288086009	4125906	
24612	2153	4125906	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	143470	0	288086009	4125906	
24846	2173	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	144743	0	180256009	4107731	
24888	2175	4107731	2011-08-30	2011-08-30 00:00:00	38000275	0	\N	\N	144963	0	180256009	4107731	
25153	2189	4107731	2012-05-16	2012-05-16 00:00:00	38000275	0	\N	\N	145943	0	180256009	4107731	
25341	2200	4043071	1981-03-15	1981-03-15 00:00:00	38000275	0	\N	\N	146645	0	228557008	4043071	
25568	2238	4107731	1993-04-11	1993-04-11 00:00:00	38000275	0	\N	\N	148965	0	180256009	4107731	
25761	2260	4195803	1994-09-02	1994-09-02 00:00:00	38000275	0	\N	\N	150220	0	312681000	4195803	
13997	1266	4170947	1971-03-19	1971-03-19 00:00:00	38000275	0	\N	\N	83453	0	274474001	4170947	
14201	1276	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	84265	0	180256009	4107731	
26281	2291	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	152525	0	180256009	4107731	
26552	2314	4043071	1964-03-19	1964-03-19 00:00:00	38000275	0	\N	\N	153856	0	228557008	4043071	
26704	2339	4125906	2016-08-22	2016-08-22 00:00:00	38000275	0	\N	\N	155618	0	288086009	4125906	
26767	2341	4057420	2006-06-08	2006-06-08 00:00:00	38000275	0	\N	\N	155871	0	18286008	4057420	
26998	2356	4043071	1990-02-04	1990-02-04 00:00:00	38000275	0	\N	\N	156906	0	228557008	4043071	
15301	1368	4125906	1958-04-10	1958-04-10 00:00:00	38000275	0	\N	\N	90715	0	288086009	4125906	
27411	2392	4035793	1987-03-20	1987-03-20 00:00:00	38000275	0	\N	\N	159004	0	15081005	4035793	
15658	1387	4043071	1985-12-29	1985-12-29 00:00:00	38000275	0	\N	\N	92025	0	228557008	4043071	
27779	2436	4107731	1990-01-27	1990-01-27 00:00:00	38000275	0	\N	\N	161519	0	180256009	4107731	
27877	2450	4187458	1974-12-29	1974-12-29 00:00:00	38000275	0	\N	\N	162503	0	415300000	4187458	
16226	1411	42535580	1999-11-23	1999-11-23 00:00:00	38000275	0	\N	\N	93967	0	426701000119108	42535580	
28422	2534	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	167424	0	180256009	4107731	
28474	2534	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	167435	0	395142003	4191853	
40588	3566	4043071	1960-12-26	1960-12-26 00:00:00	38000275	0	\N	\N	236916	0	228557008	4043071	
28925	2559	4107731	1990-06-23	1990-06-23 00:00:00	38000275	0	\N	\N	169546	0	180256009	4107731	
17128	1482	4107731	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	98910	0	180256009	4107731	
29184	2588	4187458	2016-08-17	2016-08-17 00:00:00	38000275	0	\N	\N	171266	0	415300000	4187458	
29377	2621	44783196	1999-06-17	1999-06-17 00:00:00	38000275	0	\N	\N	173403	0	699253003	44783196	
41525	3647	4043071	1944-10-04	1944-10-04 00:00:00	38000275	0	\N	\N	242671	0	228557008	4043071	
29812	2651	4058899	1952-05-24	1952-05-24 00:00:00	38000275	0	\N	\N	175416	0	168594001	4058899	
30061	2661	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	176290	0	180256009	4107731	
30222	2673	4107731	1993-02-08	1993-02-08 00:00:00	38000275	0	\N	\N	177056	0	180256009	4107731	
30444	2690	4163872	1956-11-19	1956-11-19 00:00:00	38000275	0	\N	\N	178228	0	399208008	4163872	
18640	1593	4170947	1941-08-05	1941-08-05 00:00:00	38000275	0	\N	\N	106919	0	274474001	4170947	
30726	2715	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	180032	0	180256009	4107731	
30893	2732	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	180939	0	395142003	4191853	
31195	2765	4035793	2019-01-15	2019-01-15 00:00:00	38000275	0	\N	\N	182883	0	15081005	4035793	
19410	1659	4043071	1979-03-05	1979-03-05 00:00:00	38000275	0	\N	\N	111527	0	228557008	4043071	
31473	2778	4107731	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	184043	0	180256009	4107731	
31710	2790	4047491	1973-07-02	1973-07-02 00:00:00	38000275	0	\N	\N	184872	0	1225002	4047491	
31952	2813	4163872	2015-07-18	2015-07-18 00:00:00	38000275	0	\N	\N	186417	0	399208008	4163872	
20187	1743	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	116480	0	180256009	4107731	
20287	1753	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	117184	0	180256009	4107731	
32529	2858	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	189847	0	180256009	4107731	
32654	2869	4078793	2013-01-01	2013-01-01 00:00:00	38000275	0	\N	\N	190903	0	180325003	4078793	
44789	3920	4151422	2004-05-17	2004-05-17 00:00:00	38000275	0	\N	\N	260636	0	269911007	4151422	
32985	2896	4107731	1993-02-14	1993-02-14 00:00:00	38000275	0	\N	\N	192858	0	180256009	4107731	
21261	1843	4107731	1997-08-20	1997-08-20 00:00:00	38000275	0	\N	\N	123064	0	180256009	4107731	
21491	1864	4163872	2008-04-22	2008-04-22 00:00:00	38000275	0	\N	\N	124564	0	399208008	4163872	
45569	4018	4151422	2000-06-18	2000-06-18 00:00:00	38000275	0	\N	\N	267055	0	269911007	4151422	
33729	2942	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	196189	0	180256009	4107731	
33962	2959	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	197570	0	180256009	4107731	
34089	2965	4107731	1990-04-16	1990-04-16 00:00:00	38000275	0	\N	\N	197924	0	180256009	4107731	
22365	1956	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	130155	0	180256009	4107731	
22606	1976	4107731	1996-09-23	1996-09-23 00:00:00	38000275	0	\N	\N	131364	0	180256009	4107731	
34757	3017	4058899	1960-07-01	1960-07-01 00:00:00	38000275	0	\N	\N	201237	0	168594001	4058899	
34836	3026	4151422	2010-03-28	2010-03-28 00:00:00	38000275	0	\N	\N	201771	0	269911007	4151422	
47088	4130	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	274586	0	180256009	4107731	
35238	3069	4125906	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	204313	0	288086009	4125906	
35461	3109	4043071	1929-02-27	1929-02-27 00:00:00	38000275	0	\N	\N	206730	0	228557008	4043071	
35586	3118	4107731	1991-04-07	1991-04-07 00:00:00	38000275	0	\N	\N	207511	0	180256009	4107731	
23912	2077	4107731	1990-12-23	1990-12-23 00:00:00	38000275	0	\N	\N	138245	0	180256009	4107731	
12054	1102	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	72388	0	180256009	4107731	
24227	2119	4107731	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	141027	0	180256009	4107731	
12527	1137	4151422	1974-07-27	1974-07-27 00:00:00	38000275	0	\N	\N	74881	0	269911007	4151422	
24616	2155	4202451	2009-04-29	2009-04-29 00:00:00	38000275	0	\N	\N	143619	0	433112001	4202451	
24847	2173	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	144816	0	180256009	4107731	
24889	2175	4107731	2010-05-04	2010-05-04 00:00:00	38000275	0	\N	\N	145036	0	180256009	4107731	
25154	2189	4107731	2012-10-10	2012-10-10 00:00:00	38000275	0	\N	\N	145931	0	180256009	4107731	
25342	2200	4043071	1982-12-26	1982-12-26 00:00:00	38000275	0	\N	\N	146617	0	228557008	4043071	
25569	2238	4107731	1990-03-04	1990-03-04 00:00:00	38000275	0	\N	\N	148979	0	180256009	4107731	
25762	2260	4125906	2009-04-16	2009-04-16 00:00:00	38000275	0	\N	\N	150222	0	288086009	4125906	
13998	1266	4151422	1972-03-15	1972-03-15 00:00:00	38000275	0	\N	\N	83441	0	269911007	4151422	
14202	1276	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	84192	0	180256009	4107731	
26282	2291	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	152463	0	180256009	4107731	
26553	2314	4058899	1958-03-02	1958-03-02 00:00:00	38000275	0	\N	\N	153862	0	168594001	4058899	
26705	2339	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	155609	0	180256009	4107731	
26768	2341	4078793	2016-05-19	2016-05-19 00:00:00	38000275	0	\N	\N	155833	0	180325003	4078793	
26999	2356	4043071	1989-02-05	1989-02-05 00:00:00	38000275	0	\N	\N	156902	0	228557008	4043071	
15302	1368	4330583	2007-03-16	2007-03-16 00:00:00	38000275	0	\N	\N	90739	0	22523008	4330583	
27412	2392	4035793	1993-04-23	1993-04-23 00:00:00	38000275	0	\N	\N	159061	0	15081005	4035793	
15659	1387	4043071	1982-05-09	1982-05-09 00:00:00	38000275	0	\N	\N	92034	0	228557008	4043071	
27780	2436	4125906	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	161577	0	288086009	4125906	
27878	2450	4326177	1974-12-29	1974-12-29 00:00:00	38000275	0	\N	\N	162503	0	430193006	4326177	
16227	1411	4163971	1999-11-23	1999-11-23 00:00:00	38000275	0	\N	\N	93967	0	45595009	4163971	
28423	2534	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	167464	0	180256009	4107731	
28475	2534	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	167425	0	180256009	4107731	
40589	3566	4107731	1992-12-28	1992-12-28 00:00:00	38000275	0	\N	\N	236966	0	180256009	4107731	
28926	2559	4107731	1990-11-17	1990-11-17 00:00:00	38000275	0	\N	\N	169529	0	180256009	4107731	
17129	1482	4191853	1990-01-06	1990-01-06 00:00:00	38000275	0	\N	\N	98888	0	395142003	4191853	
29185	2588	4326177	2016-08-17	2016-08-17 00:00:00	38000275	0	\N	\N	171266	0	430193006	4326177	
29378	2622	4058899	1998-10-03	1998-10-03 00:00:00	38000275	0	\N	\N	173404	0	168594001	4058899	
41526	3647	4043071	1944-07-05	1944-07-05 00:00:00	38000275	0	\N	\N	242597	0	228557008	4043071	
29813	2651	4062501	1948-09-24	1948-09-24 00:00:00	38000275	0	\N	\N	175435	0	171231001	4062501	
30062	2661	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	176293	0	180256009	4107731	
30223	2673	4107731	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	177047	0	180256009	4107731	
30445	2690	4216130	2001-08-02	2001-08-02 00:00:00	38000275	0	\N	\N	178255	0	415070008	4216130	
18641	1593	4252419	1957-02-24	1957-02-24 00:00:00	38000275	0	\N	\N	106843	0	74016001	4252419	
30727	2715	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	179999	0	180256009	4107731	
30894	2732	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	180945	0	180256009	4107731	
31196	2765	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	182936	0	180256009	4107731	
19411	1659	4043071	1982-08-16	1982-08-16 00:00:00	38000275	0	\N	\N	111433	0	228557008	4043071	
31474	2778	4107731	1991-03-23	1991-03-23 00:00:00	38000275	0	\N	\N	184011	0	180256009	4107731	
31711	2790	4170947	1973-07-02	1973-07-02 00:00:00	38000275	0	\N	\N	184872	0	274474001	4170947	
31953	2813	4195803	2015-07-18	2015-07-18 00:00:00	38000275	0	\N	\N	186417	0	312681000	4195803	
20188	1743	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	116466	0	180256009	4107731	
20288	1753	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	117302	0	180256009	4107731	
32530	2858	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	189803	0	180256009	4107731	
32655	2869	4057420	2018-01-30	2018-01-30 00:00:00	38000275	0	\N	\N	190861	0	18286008	4057420	
44790	3920	4058899	2009-11-10	2009-11-10 00:00:00	38000275	0	\N	\N	260685	0	168594001	4058899	
32986	2896	4107731	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	192796	0	180256009	4107731	
21262	1843	4107731	1997-05-07	1997-05-07 00:00:00	38000275	0	\N	\N	123081	0	180256009	4107731	
21492	1864	4151422	1979-11-04	1979-11-04 00:00:00	38000275	0	\N	\N	124553	0	269911007	4151422	
45570	4019	4151422	1988-04-05	1988-04-05 00:00:00	38000275	0	\N	\N	267137	0	269911007	4151422	
33730	2942	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	196096	0	180256009	4107731	
33963	2959	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	197579	0	180256009	4107731	
34090	2966	4107731	1993-04-17	1993-04-17 00:00:00	38000275	0	\N	\N	198140	0	180256009	4107731	
22366	1956	4293740	2002-07-21	2002-07-21 00:00:00	38000275	0	\N	\N	130150	0	384700001	4293740	
22607	1976	4107731	1999-02-01	1999-02-01 00:00:00	38000275	0	\N	\N	131400	0	180256009	4107731	
34758	3017	4195803	1960-07-01	1960-07-01 00:00:00	38000275	0	\N	\N	201237	0	312681000	4195803	
34837	3026	4252419	2019-05-31	2019-05-31 00:00:00	38000275	0	\N	\N	201730	0	74016001	4252419	
47089	4130	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	274642	0	180256009	4107731	
35239	3069	44783196	1986-08-08	1986-08-08 00:00:00	38000275	0	\N	\N	204284	0	699253003	44783196	
35462	3109	4043071	1928-01-11	1928-01-11 00:00:00	38000275	0	\N	\N	206810	0	228557008	4043071	
35587	3118	4107731	1991-02-03	1991-02-03 00:00:00	38000275	0	\N	\N	207413	0	180256009	4107731	
23913	2077	4107731	1991-08-11	1991-08-11 00:00:00	38000275	0	\N	\N	138247	0	180256009	4107731	
12055	1102	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	72433	0	180256009	4107731	
24228	2119	4107731	1990-08-20	1990-08-20 00:00:00	38000275	0	\N	\N	141054	0	180256009	4107731	
12528	1137	4125906	1975-06-01	1975-06-01 00:00:00	38000275	0	\N	\N	74977	0	288086009	4125906	
24617	2155	4151422	2000-04-17	2000-04-17 00:00:00	38000275	0	\N	\N	143579	0	269911007	4151422	
24848	2173	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	144851	0	180256009	4107731	
24890	2175	4107731	2011-02-01	2011-02-01 00:00:00	38000275	0	\N	\N	145039	0	180256009	4107731	
25155	2189	4107731	2010-04-21	2010-04-21 00:00:00	38000275	0	\N	\N	145958	0	180256009	4107731	
25343	2200	4043071	1983-01-30	1983-01-30 00:00:00	38000275	0	\N	\N	146618	0	228557008	4043071	
25570	2238	4107731	1990-09-09	1990-09-09 00:00:00	38000275	0	\N	\N	148941	0	180256009	4107731	
25763	2260	4293740	2009-04-16	2009-04-16 00:00:00	38000275	0	\N	\N	150222	0	384700001	4293740	
13999	1267	4151422	1959-05-13	1959-05-13 00:00:00	38000275	0	\N	\N	83595	0	269911007	4151422	
14203	1276	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	84263	0	180256009	4107731	
26283	2291	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	152472	0	180256009	4107731	
38374	3375	4198190	1967-03-04	1967-03-04 00:00:00	38000275	0	\N	\N	223887	0	80146002	4198190	
26706	2339	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	155625	0	180256009	4107731	
26769	2341	4078793	2003-04-03	2003-04-03 00:00:00	38000275	0	\N	\N	155794	0	180325003	4078793	
27000	2356	4043071	1989-03-12	1989-03-12 00:00:00	38000275	0	\N	\N	156903	0	228557008	4043071	
27116	2369	4107731	1994-08-21	1994-08-21 00:00:00	38000275	0	\N	\N	157679	0	180256009	4107731	
27413	2392	4035793	1980-11-28	1980-11-28 00:00:00	38000275	0	\N	\N	159087	0	15081005	4035793	
15660	1387	4043071	1981-09-27	1981-09-27 00:00:00	38000275	0	\N	\N	91991	0	228557008	4043071	
27781	2436	4107731	1992-04-04	1992-04-04 00:00:00	38000275	0	\N	\N	161650	0	180256009	4107731	
27894	2456	4170947	1968-02-15	1968-02-15 00:00:00	38000275	0	\N	\N	162816	0	274474001	4170947	
16228	1411	4163951	1999-11-23	1999-11-23 00:00:00	38000275	0	\N	\N	93967	0	29303009	4163951	
28424	2534	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	167364	0	180256009	4107731	
28476	2534	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	167401	0	180256009	4107731	
40590	3566	4043071	1960-01-18	1960-01-18 00:00:00	38000275	0	\N	\N	236906	0	228557008	4043071	
28927	2559	4107731	1991-05-25	1991-05-25 00:00:00	38000275	0	\N	\N	169602	0	180256009	4107731	
17130	1482	4107731	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	98864	0	180256009	4107731	
29186	2588	4125906	1969-06-05	1969-06-05 00:00:00	38000275	0	\N	\N	171307	0	288086009	4125906	
29379	2622	4195803	1998-10-03	1998-10-03 00:00:00	38000275	0	\N	\N	173404	0	312681000	4195803	
41527	3647	4043071	1945-05-16	1945-05-16 00:00:00	38000275	0	\N	\N	242599	0	228557008	4043071	
29883	2654	4151422	1968-05-21	1968-05-21 00:00:00	38000275	0	\N	\N	175713	0	269911007	4151422	
30063	2661	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	176274	0	180256009	4107731	
30224	2673	4107731	1992-08-24	1992-08-24 00:00:00	38000275	0	\N	\N	177153	0	180256009	4107731	
30446	2690	4336464	2001-08-02	2001-08-02 00:00:00	38000275	0	\N	\N	178255	0	232717009	4336464	
18675	1597	4058899	1965-02-28	1965-02-28 00:00:00	38000275	0	\N	\N	107119	0	168594001	4058899	
30728	2715	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	180008	0	180256009	4107731	
30895	2732	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	180923	0	180256009	4107731	
31197	2765	4125906	1998-01-31	1998-01-31 00:00:00	38000275	0	\N	\N	182894	0	288086009	4125906	
19412	1659	4058899	1980-03-19	1980-03-19 00:00:00	38000275	0	\N	\N	111456	0	168594001	4058899	
31475	2778	4107731	1991-05-04	1991-05-04 00:00:00	38000275	0	\N	\N	184012	0	180256009	4107731	
31712	2790	4170947	2009-04-13	2009-04-13 00:00:00	38000275	0	\N	\N	184875	0	274474001	4170947	
31954	2813	4078793	2014-12-19	2014-12-19 00:00:00	38000275	0	\N	\N	186459	0	180325003	4078793	
20189	1743	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	116488	0	180256009	4107731	
20289	1753	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	117251	0	180256009	4107731	
32531	2858	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	189893	0	180256009	4107731	
32656	2869	4078793	2019-02-05	2019-02-05 00:00:00	38000275	0	\N	\N	190912	0	180325003	4078793	
44791	3921	4145310	1999-07-10	1999-07-10 00:00:00	38000275	0	\N	\N	260704	0	268425006	4145310	
32987	2896	4107731	1991-02-10	1991-02-10 00:00:00	38000275	0	\N	\N	192875	0	180256009	4107731	
21263	1843	4107731	1994-11-16	1994-11-16 00:00:00	38000275	0	\N	\N	123022	0	180256009	4107731	
21493	1864	4125906	2014-02-03	2014-02-03 00:00:00	38000275	0	\N	\N	124522	0	288086009	4125906	
45571	4019	4125906	1979-12-28	1979-12-28 00:00:00	38000275	0	\N	\N	267169	0	288086009	4125906	
33731	2942	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	196219	0	395142003	4191853	
33964	2959	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	197567	0	180256009	4107731	
34091	2966	4107731	1993-02-13	1993-02-13 00:00:00	38000275	0	\N	\N	198098	0	180256009	4107731	
22367	1956	4125906	2002-07-21	2002-07-21 00:00:00	38000275	0	\N	\N	130150	0	288086009	4125906	
22608	1976	4107731	1999-05-17	1999-05-17 00:00:00	38000275	0	\N	\N	131459	0	180256009	4107731	
34759	3017	4151422	1966-03-03	1966-03-03 00:00:00	38000275	0	\N	\N	201209	0	269911007	4151422	
34838	3026	44783196	2019-06-07	2019-06-07 00:00:00	38000275	0	\N	\N	201763	0	699253003	44783196	
47090	4130	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	274587	0	180256009	4107731	
35240	3070	4301346	1967-08-28	1967-08-28 00:00:00	38000275	0	\N	\N	204358	0	387685009	4301346	
35463	3109	4151422	1931-02-05	1931-02-05 00:00:00	38000275	0	\N	\N	206769	0	269911007	4151422	
35588	3118	4107731	1990-06-17	1990-06-17 00:00:00	38000275	0	\N	\N	207467	0	180256009	4107731	
23914	2077	4107731	1993-02-28	1993-02-28 00:00:00	38000275	0	\N	\N	138360	0	180256009	4107731	
12056	1102	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	72392	0	180256009	4107731	
24229	2119	4058899	1962-05-08	1962-05-08 00:00:00	38000275	0	\N	\N	140972	0	168594001	4058899	
12529	1137	4151422	1956-11-18	1956-11-18 00:00:00	38000275	0	\N	\N	74903	0	269911007	4151422	
24618	2155	4243062	1996-01-11	1996-01-11 00:00:00	38000275	0	\N	\N	143617	0	60027007	4243062	
24849	2173	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	144717	0	180256009	4107731	
24891	2175	4107731	2009-10-06	2009-10-06 00:00:00	38000275	0	\N	\N	145075	0	180256009	4107731	
25156	2189	4107731	2011-10-19	2011-10-19 00:00:00	38000275	0	\N	\N	145964	0	180256009	4107731	
25344	2200	4043071	1983-11-06	1983-11-06 00:00:00	38000275	0	\N	\N	146619	0	228557008	4043071	
25571	2238	4107731	1990-07-08	1990-07-08 00:00:00	38000275	0	\N	\N	148981	0	180256009	4107731	
25764	2261	4151422	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	150339	0	269911007	4151422	
14000	1267	4125906	2009-05-14	2009-05-14 00:00:00	38000275	0	\N	\N	83535	0	288086009	4125906	
14204	1276	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	84174	0	395142003	4191853	
26284	2291	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	152546	0	395142003	4191853	
38375	3376	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	224070	0	180256009	4107731	
26707	2339	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	155595	0	180256009	4107731	
26770	2341	4078793	2013-05-02	2013-05-02 00:00:00	38000275	0	\N	\N	155799	0	180325003	4078793	
27001	2356	4043071	1990-04-15	1990-04-15 00:00:00	38000275	0	\N	\N	156869	0	228557008	4043071	
27117	2369	4107731	1996-02-18	1996-02-18 00:00:00	38000275	0	\N	\N	157685	0	180256009	4107731	
27414	2392	4337138	1976-04-02	1976-04-02 00:00:00	38000275	0	\N	\N	159014	0	88039007	4337138	
15661	1387	4043071	1985-03-24	1985-03-24 00:00:00	38000275	0	\N	\N	92023	0	228557008	4043071	
27782	2436	4107731	1991-12-21	1991-12-21 00:00:00	38000275	0	\N	\N	161525	0	180256009	4107731	
27895	2456	4047491	1968-02-15	1968-02-15 00:00:00	38000275	0	\N	\N	162816	0	1225002	4047491	
16229	1412	4151422	2006-11-05	2006-11-05 00:00:00	38000275	0	\N	\N	93985	0	269911007	4151422	
40206	3528	4107731	1992-08-24	1992-08-24 00:00:00	38000275	0	\N	\N	234235	0	180256009	4107731	
28477	2534	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	167454	0	180256009	4107731	
40591	3566	4107731	1992-03-09	1992-03-09 00:00:00	38000275	0	\N	\N	236843	0	180256009	4107731	
28928	2559	4107731	1990-12-29	1990-12-29 00:00:00	38000275	0	\N	\N	169530	0	180256009	4107731	
17131	1482	4107731	1991-04-13	1991-04-13 00:00:00	38000275	0	\N	\N	98866	0	180256009	4107731	
29187	2588	4151422	1967-03-06	1967-03-06 00:00:00	38000275	0	\N	\N	171285	0	269911007	4151422	
29380	2622	4125906	1964-07-12	1964-07-12 00:00:00	38000275	0	\N	\N	173408	0	288086009	4125906	
41528	3647	4043071	1944-03-01	1944-03-01 00:00:00	38000275	0	\N	\N	242651	0	228557008	4043071	
29884	2654	4010253	1985-02-22	1985-02-22 00:00:00	38000275	0	\N	\N	175715	0	112790001	4010253	
30064	2661	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	176259	0	180256009	4107731	
30225	2673	4191853	1982-03-04	1982-03-04 00:00:00	38000275	0	\N	\N	177076	0	395142003	4191853	
30449	2692	4336464	1998-06-29	1998-06-29 00:00:00	38000275	0	\N	\N	178364	0	232717009	4336464	
18676	1597	4293740	1994-07-18	1994-07-18 00:00:00	38000275	0	\N	\N	107196	0	384700001	4293740	
30729	2715	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	180080	0	180256009	4107731	
30896	2732	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	180857	0	180256009	4107731	
31198	2765	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	182903	0	180256009	4107731	
19413	1659	4043071	1983-02-21	1983-02-21 00:00:00	38000275	0	\N	\N	111539	0	228557008	4043071	
31476	2778	4107731	1990-10-06	1990-10-06 00:00:00	38000275	0	\N	\N	184018	0	180256009	4107731	
31713	2790	4195803	2009-04-13	2009-04-13 00:00:00	38000275	0	\N	\N	184875	0	312681000	4195803	
31955	2813	4057420	2013-10-18	2013-10-18 00:00:00	38000275	0	\N	\N	186458	0	18286008	4057420	
20190	1743	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	116468	0	180256009	4107731	
20290	1753	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	117200	0	180256009	4107731	
32532	2858	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	189849	0	180256009	4107731	
32657	2869	4151422	1970-03-04	1970-03-04 00:00:00	38000275	0	\N	\N	190889	0	269911007	4151422	
44792	3921	4170947	1986-08-17	1986-08-17 00:00:00	38000275	0	\N	\N	260703	0	274474001	4170947	
32988	2896	4107731	1990-02-18	1990-02-18 00:00:00	38000275	0	\N	\N	192837	0	180256009	4107731	
21264	1843	4107731	1995-07-05	1995-07-05 00:00:00	38000275	0	\N	\N	123024	0	180256009	4107731	
21494	1864	4151422	1971-04-08	1971-04-08 00:00:00	38000275	0	\N	\N	124552	0	269911007	4151422	
45572	4019	4151422	1992-07-22	1992-07-22 00:00:00	38000275	0	\N	\N	267163	0	269911007	4151422	
33732	2942	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	196234	0	180256009	4107731	
33965	2959	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	197484	0	180256009	4107731	
34092	2966	4191853	1993-07-10	1993-07-10 00:00:00	38000275	0	\N	\N	198142	0	395142003	4191853	
22368	1956	4107731	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	130172	0	180256009	4107731	
22609	1976	4107731	1996-04-29	1996-04-29 00:00:00	38000275	0	\N	\N	131431	0	180256009	4107731	
34760	3019	4058899	1992-04-15	1992-04-15 00:00:00	38000275	0	\N	\N	201346	0	168594001	4058899	
34839	3026	4047491	2017-05-11	2017-05-11 00:00:00	38000275	0	\N	\N	201729	0	1225002	4047491	
47091	4130	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	274630	0	180256009	4107731	
35241	3070	4010253	1982-09-07	1982-09-07 00:00:00	38000275	0	\N	\N	204385	0	112790001	4010253	
35464	3109	4043071	1929-03-27	1929-03-27 00:00:00	38000275	0	\N	\N	206794	0	228557008	4043071	
35589	3118	4107731	1993-01-17	1993-01-17 00:00:00	38000275	0	\N	\N	207457	0	180256009	4107731	
23915	2077	4107731	1991-11-03	1991-11-03 00:00:00	38000275	0	\N	\N	138219	0	180256009	4107731	
12057	1102	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	72426	0	180256009	4107731	
24230	2119	4107731	1992-08-24	1992-08-24 00:00:00	38000275	0	\N	\N	141092	0	180256009	4107731	
24350	2130	4163872	1982-02-14	1982-02-14 00:00:00	38000275	0	\N	\N	141744	0	399208008	4163872	
24619	2155	4170947	1996-01-11	1996-01-11 00:00:00	38000275	0	\N	\N	143617	0	274474001	4170947	
24850	2173	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	144796	0	180256009	4107731	
24892	2175	4107731	2011-09-20	2011-09-20 00:00:00	38000275	0	\N	\N	145064	0	180256009	4107731	
25157	2189	4107731	2012-04-25	2012-04-25 00:00:00	38000275	0	\N	\N	145994	0	180256009	4107731	
25345	2200	4043071	1980-07-13	1980-07-13 00:00:00	38000275	0	\N	\N	146600	0	228557008	4043071	
25572	2238	4107731	1991-03-17	1991-03-17 00:00:00	38000275	0	\N	\N	148998	0	180256009	4107731	
25765	2261	4125906	1973-10-13	1973-10-13 00:00:00	38000275	0	\N	\N	150308	0	288086009	4125906	
14001	1267	4151422	1969-10-18	1969-10-18 00:00:00	38000275	0	\N	\N	83515	0	269911007	4151422	
14205	1276	4195803	2009-07-17	2009-07-17 00:00:00	38000275	0	\N	\N	84134	0	312681000	4195803	
26285	2291	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	152426	0	180256009	4107731	
38376	3376	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	223976	0	180256009	4107731	
26708	2339	4107731	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	155660	0	180256009	4107731	
26771	2341	4125906	2005-09-25	2005-09-25 00:00:00	38000275	0	\N	\N	155806	0	288086009	4125906	
27002	2357	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	156961	0	180256009	4107731	
27118	2369	4107731	1997-09-07	1997-09-07 00:00:00	38000275	0	\N	\N	157720	0	180256009	4107731	
27415	2392	4035793	2006-07-07	2006-07-07 00:00:00	38000275	0	\N	\N	158981	0	15081005	4035793	
15662	1387	4043071	1983-07-31	1983-07-31 00:00:00	38000275	0	\N	\N	92003	0	228557008	4043071	
27783	2436	4107731	1992-06-27	1992-06-27 00:00:00	38000275	0	\N	\N	161614	0	180256009	4107731	
27896	2456	4163872	1972-11-06	1972-11-06 00:00:00	38000275	0	\N	\N	162753	0	399208008	4163872	
16230	1412	4062501	1963-05-20	1963-05-20 00:00:00	38000275	0	\N	\N	94078	0	171231001	4062501	
40207	3528	4107731	1992-01-06	1992-01-06 00:00:00	38000275	0	\N	\N	234256	0	180256009	4107731	
28478	2534	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	167393	0	180256009	4107731	
40592	3566	4043071	1959-10-12	1959-10-12 00:00:00	38000275	0	\N	\N	236810	0	228557008	4043071	
28929	2559	4107731	1993-05-08	1993-05-08 00:00:00	38000275	0	\N	\N	169564	0	180256009	4107731	
17132	1482	4107731	1990-06-02	1990-06-02 00:00:00	38000275	0	\N	\N	98800	0	180256009	4107731	
29188	2588	4024289	1978-06-07	1978-06-07 00:00:00	38000275	0	\N	\N	171309	0	19490002	4024289	
29381	2622	4151422	1941-05-16	1941-05-16 00:00:00	38000275	0	\N	\N	173471	0	269911007	4151422	
41529	3647	4043071	1945-09-26	1945-09-26 00:00:00	38000275	0	\N	\N	242674	0	228557008	4043071	
29885	2654	4125906	1989-12-05	1989-12-05 00:00:00	38000275	0	\N	\N	175724	0	288086009	4125906	
30065	2661	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	176223	0	180256009	4107731	
30226	2673	4107731	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	177083	0	180256009	4107731	
30450	2692	4216130	1998-06-29	1998-06-29 00:00:00	38000275	0	\N	\N	178364	0	415070008	4216130	
18677	1597	4125906	1994-07-18	1994-07-18 00:00:00	38000275	0	\N	\N	107196	0	288086009	4125906	
30730	2715	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	180006	0	180256009	4107731	
30905	2736	4125906	2019-05-16	2019-05-16 00:00:00	38000275	0	\N	\N	181079	0	288086009	4125906	
31199	2765	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	182944	0	180256009	4107731	
19414	1659	4043071	1980-05-26	1980-05-26 00:00:00	38000275	0	\N	\N	111558	0	228557008	4043071	
31477	2778	4107731	1992-01-11	1992-01-11 00:00:00	38000275	0	\N	\N	184072	0	180256009	4107731	
31714	2790	4024289	2009-04-13	2009-04-13 00:00:00	38000275	0	\N	\N	184875	0	19490002	4024289	
31956	2813	4057420	2018-03-09	2018-03-09 00:00:00	38000275	0	\N	\N	186387	0	18286008	4057420	
20191	1743	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	116514	0	180256009	4107731	
20291	1753	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	117180	0	180256009	4107731	
32533	2858	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	189954	0	180256009	4107731	
32658	2869	44783196	1954-10-31	1954-10-31 00:00:00	38000275	0	\N	\N	190913	0	699253003	44783196	
44793	3921	4047491	1986-08-17	1986-08-17 00:00:00	38000275	0	\N	\N	260703	0	1225002	4047491	
32989	2896	4107731	1990-06-24	1990-06-24 00:00:00	38000275	0	\N	\N	192873	0	180256009	4107731	
21265	1843	4107731	1996-03-13	1996-03-13 00:00:00	38000275	0	\N	\N	123114	0	180256009	4107731	
33287	2915	4107731	1991-12-01	1991-12-01 00:00:00	38000275	0	\N	\N	194249	0	180256009	4107731	
45573	4020	4151422	1964-07-19	1964-07-19 00:00:00	38000275	0	\N	\N	267217	0	269911007	4151422	
33733	2942	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	196078	0	180256009	4107731	
33966	2959	4043071	1980-04-09	1980-04-09 00:00:00	38000275	0	\N	\N	197555	0	228557008	4043071	
34093	2966	4107731	1991-06-15	1991-06-15 00:00:00	38000275	0	\N	\N	198068	0	180256009	4107731	
22369	1956	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	130200	0	180256009	4107731	
22610	1976	4295880	2000-12-11	2000-12-11 00:00:00	38000275	0	\N	\N	131447	0	76601001	4295880	
34761	3020	4125906	1963-01-01	1963-01-01 00:00:00	38000275	0	\N	\N	201371	0	288086009	4125906	
34840	3026	4195803	2017-05-11	2017-05-11 00:00:00	38000275	0	\N	\N	201729	0	312681000	4195803	
47092	4130	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	274581	0	395142003	4191853	
35242	3070	4243062	2008-04-24	2008-04-24 00:00:00	38000275	0	\N	\N	204326	0	60027007	4243062	
35465	3109	4043071	1925-11-18	1925-11-18 00:00:00	38000275	0	\N	\N	206828	0	228557008	4043071	
35590	3118	4107731	1992-11-15	1992-11-15 00:00:00	38000275	0	\N	\N	207518	0	180256009	4107731	
23916	2077	4107731	1991-10-13	1991-10-13 00:00:00	38000275	0	\N	\N	138354	0	180256009	4107731	
12058	1102	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	72480	0	180256009	4107731	
24231	2119	4107731	1991-11-04	1991-11-04 00:00:00	38000275	0	\N	\N	141077	0	180256009	4107731	
24351	2130	4125906	1980-06-05	1980-06-05 00:00:00	38000275	0	\N	\N	141692	0	288086009	4125906	
24620	2155	4195803	1996-01-11	1996-01-11 00:00:00	38000275	0	\N	\N	143617	0	312681000	4195803	
24851	2173	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	144798	0	180256009	4107731	
24893	2175	4107731	2010-04-13	2010-04-13 00:00:00	38000275	0	\N	\N	145076	0	180256009	4107731	
25158	2189	4107731	2012-06-27	2012-06-27 00:00:00	38000275	0	\N	\N	145981	0	180256009	4107731	
25346	2200	4043071	1981-04-12	1981-04-12 00:00:00	38000275	0	\N	\N	146671	0	228557008	4043071	
25573	2238	4107731	1992-06-21	1992-06-21 00:00:00	38000275	0	\N	\N	149002	0	180256009	4107731	
25766	2261	4058899	1993-02-19	1993-02-19 00:00:00	38000275	0	\N	\N	150334	0	168594001	4058899	
14002	1267	4151422	2004-02-26	2004-02-26 00:00:00	38000275	0	\N	\N	83521	0	269911007	4151422	
14206	1276	4163872	2009-07-17	2009-07-17 00:00:00	38000275	0	\N	\N	84134	0	399208008	4163872	
26286	2291	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	152445	0	180256009	4107731	
38377	3376	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	224029	0	395142003	4191853	
26709	2339	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	155712	0	180256009	4107731	
26772	2341	4047491	1954-05-16	1954-05-16 00:00:00	38000275	0	\N	\N	155800	0	1225002	4047491	
27003	2357	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	157023	0	180256009	4107731	
27119	2369	4107731	1997-03-02	1997-03-02 00:00:00	38000275	0	\N	\N	157643	0	180256009	4107731	
27416	2392	4057420	2006-07-07	2006-07-07 00:00:00	38000275	0	\N	\N	158981	0	18286008	4057420	
15663	1387	4043071	1982-09-12	1982-09-12 00:00:00	38000275	0	\N	\N	91994	0	228557008	4043071	
27784	2436	4107731	1991-11-09	1991-11-09 00:00:00	38000275	0	\N	\N	161612	0	180256009	4107731	
27962	2458	4024289	2015-02-28	2015-02-28 00:00:00	38000275	0	\N	\N	162945	0	19490002	4024289	
16231	1412	4125906	1987-08-14	1987-08-14 00:00:00	38000275	0	\N	\N	94040	0	288086009	4125906	
40208	3528	4107731	1991-03-18	1991-03-18 00:00:00	38000275	0	\N	\N	234266	0	180256009	4107731	
28479	2534	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	167463	0	180256009	4107731	
40593	3566	4043071	1959-11-16	1959-11-16 00:00:00	38000275	0	\N	\N	236811	0	228557008	4043071	
28930	2559	4107731	1991-12-21	1991-12-21 00:00:00	38000275	0	\N	\N	169552	0	180256009	4107731	
17133	1482	4107731	1990-02-17	1990-02-17 00:00:00	38000275	0	\N	\N	98889	0	180256009	4107731	
29189	2588	4170947	1978-06-07	1978-06-07 00:00:00	38000275	0	\N	\N	171309	0	274474001	4170947	
29382	2622	4125906	2018-05-21	2018-05-21 00:00:00	38000275	0	\N	\N	173406	0	288086009	4125906	
41530	3647	4043071	1945-04-11	1945-04-11 00:00:00	38000275	0	\N	\N	242617	0	228557008	4043071	
29886	2654	4252419	1983-04-13	1983-04-13 00:00:00	38000275	0	\N	\N	175722	0	74016001	4252419	
30066	2661	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	176242	0	180256009	4107731	
30227	2673	4107731	1992-08-03	1992-08-03 00:00:00	38000275	0	\N	\N	177160	0	180256009	4107731	
30451	2692	4125906	1996-02-17	1996-02-17 00:00:00	38000275	0	\N	\N	178363	0	288086009	4125906	
18678	1597	4197460	1945-04-25	1945-04-25 00:00:00	38000275	0	\N	\N	107113	0	313191000	4197460	
30731	2715	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	179983	0	180256009	4107731	
30907	2739	4024289	1988-06-26	1988-06-26 00:00:00	38000275	0	\N	\N	181240	0	19490002	4024289	
31200	2765	4035793	2009-11-17	2009-11-17 00:00:00	38000275	0	\N	\N	182916	0	15081005	4035793	
19415	1659	4043071	1980-09-01	1980-09-01 00:00:00	38000275	0	\N	\N	111535	0	228557008	4043071	
31478	2778	4107731	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	184037	0	180256009	4107731	
31715	2790	4195803	2013-04-11	2013-04-11 00:00:00	38000275	0	\N	\N	184866	0	312681000	4195803	
31960	2815	4047491	1996-01-17	1996-01-17 00:00:00	38000275	0	\N	\N	186532	0	1225002	4047491	
20192	1743	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	116572	0	180256009	4107731	
20292	1753	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	117278	0	180256009	4107731	
32534	2858	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	189910	0	180256009	4107731	
32659	2869	4078793	2017-01-24	2017-01-24 00:00:00	38000275	0	\N	\N	190911	0	180325003	4078793	
44799	3926	4163872	1962-09-11	1962-09-11 00:00:00	38000275	0	\N	\N	260925	0	399208008	4163872	
32990	2896	4107731	1990-12-30	1990-12-30 00:00:00	38000275	0	\N	\N	192874	0	180256009	4107731	
21266	1843	4107731	1996-09-18	1996-09-18 00:00:00	38000275	0	\N	\N	123115	0	180256009	4107731	
33288	2915	4107731	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	194397	0	180256009	4107731	
45574	4020	4202451	2014-10-02	2014-10-02 00:00:00	38000275	0	\N	\N	267274	0	433112001	4202451	
33734	2942	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	196188	0	180256009	4107731	
33967	2959	4043071	1979-05-23	1979-05-23 00:00:00	38000275	0	\N	\N	197571	0	228557008	4043071	
34094	2966	4107731	1991-09-28	1991-09-28 00:00:00	38000275	0	\N	\N	198156	0	180256009	4107731	
22370	1956	4107731	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	130193	0	180256009	4107731	
22611	1976	4295880	1998-09-14	1998-09-14 00:00:00	38000275	0	\N	\N	131384	0	76601001	4295880	
34762	3022	4047491	1985-04-09	1985-04-09 00:00:00	38000275	0	\N	\N	201467	0	1225002	4047491	
34841	3026	4170947	2017-05-11	2017-05-11 00:00:00	38000275	0	\N	\N	201729	0	274474001	4170947	
47093	4130	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	274539	0	180256009	4107731	
35243	3070	4170947	2008-04-24	2008-04-24 00:00:00	38000275	0	\N	\N	204326	0	274474001	4170947	
35466	3109	4043071	1926-06-02	1926-06-02 00:00:00	38000275	0	\N	\N	206803	0	228557008	4043071	
35591	3118	4107731	1991-08-11	1991-08-11 00:00:00	38000275	0	\N	\N	207414	0	180256009	4107731	
23917	2077	4107731	1992-03-29	1992-03-29 00:00:00	38000275	0	\N	\N	138249	0	180256009	4107731	
12059	1102	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	72475	0	180256009	4107731	
24232	2119	4107731	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	141006	0	180256009	4107731	
24352	2130	4125906	1987-04-14	1987-04-14 00:00:00	38000275	0	\N	\N	141693	0	288086009	4125906	
24621	2155	4202451	2006-02-08	2006-02-08 00:00:00	38000275	0	\N	\N	143621	0	433112001	4202451	
24852	2173	4024289	1940-10-13	1940-10-13 00:00:00	38000275	0	\N	\N	144757	0	19490002	4024289	
24894	2175	4107731	2012-03-06	2012-03-06 00:00:00	38000275	0	\N	\N	144955	0	180256009	4107731	
25159	2189	4107731	2012-09-19	2012-09-19 00:00:00	38000275	0	\N	\N	145983	0	180256009	4107731	
25347	2202	4125906	1987-06-30	1987-06-30 00:00:00	38000275	0	\N	\N	146808	0	288086009	4125906	
25574	2238	4107731	1991-11-03	1991-11-03 00:00:00	38000275	0	\N	\N	149000	0	180256009	4107731	
25769	2264	4275113	1983-05-11	1983-05-11 00:00:00	38000275	0	\N	\N	150478	0	65200003	4275113	
14003	1267	4125906	1968-03-29	1968-03-29 00:00:00	38000275	0	\N	\N	83566	0	288086009	4125906	
14207	1276	4170947	2009-07-17	2009-07-17 00:00:00	38000275	0	\N	\N	84134	0	274474001	4170947	
26287	2291	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	152438	0	180256009	4107731	
38378	3376	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	223977	0	180256009	4107731	
26710	2339	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	155682	0	180256009	4107731	
26773	2341	4170947	1954-05-16	1954-05-16 00:00:00	38000275	0	\N	\N	155800	0	274474001	4170947	
27004	2357	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	157042	0	180256009	4107731	
27120	2369	4107731	1995-11-26	1995-11-26 00:00:00	38000275	0	\N	\N	157666	0	180256009	4107731	
27417	2392	4035793	1990-04-06	1990-04-06 00:00:00	38000275	0	\N	\N	159006	0	15081005	4035793	
15664	1387	4043071	1981-12-06	1981-12-06 00:00:00	38000275	0	\N	\N	92032	0	228557008	4043071	
27785	2436	4191853	1993-07-10	1993-07-10 00:00:00	38000275	0	\N	\N	161510	0	395142003	4191853	
27963	2458	4170947	2015-02-28	2015-02-28 00:00:00	38000275	0	\N	\N	162945	0	274474001	4170947	
16232	1412	4293740	1987-08-14	1987-08-14 00:00:00	38000275	0	\N	\N	94040	0	384700001	4293740	
40209	3528	4107731	1990-02-12	1990-02-12 00:00:00	38000275	0	\N	\N	234231	0	180256009	4107731	
28480	2534	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	167383	0	180256009	4107731	
40594	3566	4107731	1992-01-27	1992-01-27 00:00:00	38000275	0	\N	\N	236933	0	180256009	4107731	
28931	2559	4107731	1992-06-27	1992-06-27 00:00:00	38000275	0	\N	\N	169560	0	180256009	4107731	
17134	1482	4107731	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	98916	0	180256009	4107731	
29190	2588	4151422	1981-05-01	1981-05-01 00:00:00	38000275	0	\N	\N	171286	0	269911007	4151422	
29383	2624	4043071	1975-02-27	1975-02-27 00:00:00	38000275	0	\N	\N	173536	0	228557008	4043071	
41531	3647	4293740	1941-05-28	1941-05-28 00:00:00	38000275	0	\N	\N	242663	0	384700001	4293740	
29887	2654	44783196	1983-04-20	1983-04-20 00:00:00	38000275	0	\N	\N	175747	0	699253003	44783196	
30067	2661	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	176380	0	180256009	4107731	
30228	2673	4107731	1991-11-04	1991-11-04 00:00:00	38000275	0	\N	\N	177147	0	180256009	4107731	
30452	2692	4151422	1982-10-16	1982-10-16 00:00:00	38000275	0	\N	\N	178337	0	269911007	4151422	
18679	1597	4197460	1948-11-08	1948-11-08 00:00:00	38000275	0	\N	\N	107114	0	313191000	4197460	
30732	2715	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	180007	0	180256009	4107731	
30908	2739	4170947	1988-06-26	1988-06-26 00:00:00	38000275	0	\N	\N	181240	0	274474001	4170947	
31201	2765	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	182870	0	180256009	4107731	
19416	1659	4043071	1979-07-09	1979-07-09 00:00:00	38000275	0	\N	\N	111443	0	228557008	4043071	
31479	2778	4107731	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	184034	0	180256009	4107731	
31716	2790	4163872	1986-01-28	1986-01-28 00:00:00	38000275	0	\N	\N	184876	0	399208008	4163872	
31961	2815	4170947	1996-01-17	1996-01-17 00:00:00	38000275	0	\N	\N	186532	0	274474001	4170947	
20193	1743	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	116589	0	180256009	4107731	
20293	1753	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	117199	0	180256009	4107731	
32535	2858	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	189907	0	180256009	4107731	
32660	2869	4163872	1962-09-19	1962-09-19 00:00:00	38000275	0	\N	\N	190824	0	399208008	4163872	
44800	3926	4035793	2016-07-18	2016-07-18 00:00:00	38000275	0	\N	\N	261005	0	15081005	4035793	
32991	2896	4191853	1990-01-07	1990-01-07 00:00:00	38000275	0	\N	\N	192836	0	395142003	4191853	
21267	1843	4107731	1995-07-26	1995-07-26 00:00:00	38000275	0	\N	\N	123048	0	180256009	4107731	
33289	2915	4107731	1993-02-14	1993-02-14 00:00:00	38000275	0	\N	\N	194398	0	180256009	4107731	
45575	4020	4195803	2016-04-28	2016-04-28 00:00:00	38000275	0	\N	\N	267275	0	312681000	4195803	
33735	2942	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	196215	0	180256009	4107731	
33968	2959	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	197536	0	180256009	4107731	
34095	2966	4107731	1991-04-13	1991-04-13 00:00:00	38000275	0	\N	\N	198127	0	180256009	4107731	
22371	1956	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	130152	0	395142003	4191853	
22612	1976	4295880	1997-09-15	1997-09-15 00:00:00	38000275	0	\N	\N	131369	0	76601001	4295880	
34763	3022	4170947	1985-04-09	1985-04-09 00:00:00	38000275	0	\N	\N	201467	0	274474001	4170947	
34842	3026	4047491	1971-07-28	1971-07-28 00:00:00	38000275	0	\N	\N	201791	0	1225002	4047491	
47094	4130	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	274555	0	180256009	4107731	
35247	3072	4125906	1975-10-22	1975-10-22 00:00:00	38000275	0	\N	\N	204460	0	288086009	4125906	
35467	3109	4043071	1927-12-07	1927-12-07 00:00:00	38000275	0	\N	\N	206790	0	228557008	4043071	
35592	3118	4107731	1991-12-15	1991-12-15 00:00:00	38000275	0	\N	\N	207473	0	180256009	4107731	
23918	2077	4107731	1991-12-15	1991-12-15 00:00:00	38000275	0	\N	\N	138220	0	180256009	4107731	
12060	1102	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	72430	0	180256009	4107731	
24233	2119	4107731	1990-05-07	1990-05-07 00:00:00	38000275	0	\N	\N	141057	0	180256009	4107731	
24353	2130	4058899	1976-02-27	1976-02-27 00:00:00	38000275	0	\N	\N	141691	0	168594001	4058899	
24622	2155	4151422	2003-05-23	2003-05-23 00:00:00	38000275	0	\N	\N	143602	0	269911007	4151422	
24853	2173	4170947	1940-10-13	1940-10-13 00:00:00	38000275	0	\N	\N	144757	0	274474001	4170947	
24895	2175	4107731	2011-11-22	2011-11-22 00:00:00	38000275	0	\N	\N	144969	0	180256009	4107731	
25160	2189	4107731	2013-05-29	2013-05-29 00:00:00	38000275	0	\N	\N	145933	0	180256009	4107731	
25348	2202	4151422	1997-12-24	1997-12-24 00:00:00	38000275	0	\N	\N	146774	0	269911007	4151422	
25575	2238	4107731	1991-06-09	1991-06-09 00:00:00	38000275	0	\N	\N	148944	0	180256009	4107731	
25770	2264	4238715	1986-03-23	1986-03-23 00:00:00	38000275	0	\N	\N	150448	0	68254000	4238715	
14004	1267	4024289	1955-02-06	1955-02-06 00:00:00	38000275	0	\N	\N	83565	0	19490002	4024289	
14208	1276	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	84187	0	180256009	4107731	
26288	2291	4293740	1989-05-21	1989-05-21 00:00:00	38000275	0	\N	\N	152486	0	384700001	4293740	
38379	3376	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	224010	0	180256009	4107731	
26711	2339	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	155711	0	180256009	4107731	
26774	2341	4078793	2004-04-08	2004-04-08 00:00:00	38000275	0	\N	\N	155812	0	180325003	4078793	
27005	2357	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	157035	0	180256009	4107731	
27121	2369	4107731	1995-09-03	1995-09-03 00:00:00	38000275	0	\N	\N	157637	0	180256009	4107731	
27418	2392	4035793	1976-01-30	1976-01-30 00:00:00	38000275	0	\N	\N	159085	0	15081005	4035793	
15665	1387	4043071	1983-10-09	1983-10-09 00:00:00	38000275	0	\N	\N	92069	0	228557008	4043071	
27786	2436	4107731	1993-04-17	1993-04-17 00:00:00	38000275	0	\N	\N	161508	0	180256009	4107731	
27964	2459	4047491	1993-04-23	1993-04-23 00:00:00	38000275	0	\N	\N	163067	0	1225002	4047491	
16233	1412	4163872	1979-08-23	1979-08-23 00:00:00	38000275	0	\N	\N	94053	0	399208008	4163872	
40210	3528	4107731	1992-12-28	1992-12-28 00:00:00	38000275	0	\N	\N	234148	0	180256009	4107731	
28481	2535	4202451	2000-08-27	2000-08-27 00:00:00	38000275	0	\N	\N	167496	0	433112001	4202451	
40595	3566	4043071	1960-08-29	1960-08-29 00:00:00	38000275	0	\N	\N	236915	0	228557008	4043071	
28932	2559	4107731	1991-01-19	1991-01-19 00:00:00	38000275	0	\N	\N	169589	0	180256009	4107731	
17135	1482	4191853	1975-07-28	1975-07-28 00:00:00	38000275	0	\N	\N	98904	0	395142003	4191853	
29191	2589	4125906	1998-01-02	1998-01-02 00:00:00	38000275	0	\N	\N	171329	0	288086009	4125906	
29384	2624	4043071	1977-04-07	1977-04-07 00:00:00	38000275	0	\N	\N	173600	0	228557008	4043071	
41532	3647	4125906	1941-05-28	1941-05-28 00:00:00	38000275	0	\N	\N	242663	0	288086009	4125906	
29888	2654	4243062	2010-03-09	2010-03-09 00:00:00	38000275	0	\N	\N	175727	0	60027007	4243062	
30068	2661	4125906	2006-12-21	2006-12-21 00:00:00	38000275	0	\N	\N	176232	0	288086009	4125906	
30229	2673	4107731	1992-01-27	1992-01-27 00:00:00	38000275	0	\N	\N	177085	0	180256009	4107731	
30453	2692	4125906	1959-07-17	1959-07-17 00:00:00	38000275	0	\N	\N	178361	0	288086009	4125906	
18680	1597	4047491	1985-09-02	1985-09-02 00:00:00	38000275	0	\N	\N	107121	0	1225002	4047491	
30733	2715	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	180033	0	180256009	4107731	
30909	2739	4125906	1986-07-23	1986-07-23 00:00:00	38000275	0	\N	\N	181239	0	288086009	4125906	
31202	2765	4191853	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	182987	0	395142003	4191853	
19417	1659	4043071	1979-01-01	1979-01-01 00:00:00	38000275	0	\N	\N	111546	0	228557008	4043071	
31480	2778	4107731	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	184040	0	180256009	4107731	
31717	2790	4125906	1999-09-19	1999-09-19 00:00:00	38000275	0	\N	\N	184874	0	288086009	4125906	
31962	2815	4163872	2006-01-24	2006-01-24 00:00:00	38000275	0	\N	\N	186495	0	399208008	4163872	
20194	1743	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	116484	0	180256009	4107731	
20294	1753	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	117177	0	180256009	4107731	
32536	2858	4151422	1991-02-19	1991-02-19 00:00:00	38000275	0	\N	\N	189891	0	269911007	4151422	
32661	2869	4170947	1962-09-19	1962-09-19 00:00:00	38000275	0	\N	\N	190824	0	274474001	4170947	
44801	3926	4035793	2013-07-01	2013-07-01 00:00:00	38000275	0	\N	\N	260934	0	15081005	4035793	
32992	2896	4107731	1991-07-07	1991-07-07 00:00:00	38000275	0	\N	\N	192851	0	180256009	4107731	
21268	1843	4191853	1998-02-25	1998-02-25 00:00:00	38000275	0	\N	\N	123041	0	395142003	4191853	
33290	2915	4107731	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	194320	0	180256009	4107731	
45576	4020	4293740	1959-12-11	1959-12-11 00:00:00	38000275	0	\N	\N	267234	0	384700001	4293740	
33736	2942	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	196101	0	180256009	4107731	
33969	2959	4043071	1979-03-28	1979-03-28 00:00:00	38000275	0	\N	\N	197583	0	228557008	4043071	
34096	2966	4107731	1992-12-12	1992-12-12 00:00:00	38000275	0	\N	\N	198149	0	180256009	4107731	
22372	1956	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	130136	0	180256009	4107731	
22613	1976	4107731	1996-11-04	1996-11-04 00:00:00	38000275	0	\N	\N	131365	0	180256009	4107731	
34764	3022	4301346	1978-11-12	1978-11-12 00:00:00	38000275	0	\N	\N	201476	0	387685009	4301346	
34843	3026	4170947	1971-07-28	1971-07-28 00:00:00	38000275	0	\N	\N	201791	0	274474001	4170947	
47095	4130	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	274585	0	180256009	4107731	
35248	3072	4293740	1975-10-22	1975-10-22 00:00:00	38000275	0	\N	\N	204460	0	384700001	4293740	
35468	3109	4043071	1926-08-04	1926-08-04 00:00:00	38000275	0	\N	\N	206726	0	228557008	4043071	
35593	3118	4107731	1990-05-06	1990-05-06 00:00:00	38000275	0	\N	\N	207466	0	180256009	4107731	
23919	2077	4107731	1991-09-01	1991-09-01 00:00:00	38000275	0	\N	\N	138344	0	180256009	4107731	
12061	1102	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	72474	0	180256009	4107731	
24234	2119	4107731	1992-06-22	1992-06-22 00:00:00	38000275	0	\N	\N	141079	0	180256009	4107731	
24354	2131	4197460	1962-03-30	1962-03-30 00:00:00	38000275	0	\N	\N	141824	0	313191000	4197460	
24623	2155	4151422	1979-07-25	1979-07-25 00:00:00	38000275	0	\N	\N	143575	0	269911007	4151422	
24854	2173	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	144783	0	180256009	4107731	
24896	2175	4107731	2012-04-17	2012-04-17 00:00:00	38000275	0	\N	\N	144965	0	180256009	4107731	
25161	2189	4107731	2010-11-17	2010-11-17 00:00:00	38000275	0	\N	\N	145896	0	180256009	4107731	
25352	2204	4125906	2000-06-20	2000-06-20 00:00:00	38000275	0	\N	\N	146881	0	288086009	4125906	
25576	2238	4107731	1991-09-01	1991-09-01 00:00:00	38000275	0	\N	\N	149009	0	180256009	4107731	
25771	2264	4275113	1985-05-08	1985-05-08 00:00:00	38000275	0	\N	\N	150438	0	65200003	4275113	
14005	1267	4170947	1955-02-06	1955-02-06 00:00:00	38000275	0	\N	\N	83565	0	274474001	4170947	
14209	1276	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	84189	0	180256009	4107731	
26289	2291	4125906	1989-05-21	1989-05-21 00:00:00	38000275	0	\N	\N	152486	0	288086009	4125906	
38380	3376	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	224066	0	180256009	4107731	
26712	2339	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	155669	0	395142003	4191853	
26775	2341	4151422	2010-02-23	2010-02-23 00:00:00	38000275	0	\N	\N	155825	0	269911007	4151422	
27006	2357	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	157030	0	180256009	4107731	
27122	2369	4107731	1996-10-27	1996-10-27 00:00:00	38000275	0	\N	\N	157716	0	180256009	4107731	
27419	2392	4125906	1937-09-02	1937-09-02 00:00:00	38000275	0	\N	\N	159009	0	288086009	4125906	
15666	1387	4043071	1985-09-01	1985-09-01 00:00:00	38000275	0	\N	\N	92024	0	228557008	4043071	
27787	2436	4107731	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	161490	0	180256009	4107731	
27965	2459	4170947	1993-04-23	1993-04-23 00:00:00	38000275	0	\N	\N	163067	0	274474001	4170947	
16234	1412	4125906	1983-12-12	1983-12-12 00:00:00	38000275	0	\N	\N	94038	0	288086009	4125906	
40211	3528	4107731	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	234168	0	180256009	4107731	
28482	2535	4151422	2003-11-24	2003-11-24 00:00:00	38000275	0	\N	\N	167555	0	269911007	4151422	
40596	3566	4107731	1992-10-05	1992-10-05 00:00:00	38000275	0	\N	\N	236977	0	180256009	4107731	
28933	2559	4151422	1980-02-19	1980-02-19 00:00:00	38000275	0	\N	\N	169593	0	269911007	4151422	
17136	1482	4107731	1992-10-10	1992-10-10 00:00:00	38000275	0	\N	\N	98872	0	180256009	4107731	
29192	2590	4243062	1967-06-20	1967-06-20 00:00:00	38000275	0	\N	\N	171405	0	60027007	4243062	
29385	2624	4043071	1975-08-28	1975-08-28 00:00:00	38000275	0	\N	\N	173596	0	228557008	4043071	
41533	3647	4043071	1944-11-08	1944-11-08 00:00:00	38000275	0	\N	\N	242615	0	228557008	4043071	
29889	2654	4195803	2010-03-09	2010-03-09 00:00:00	38000275	0	\N	\N	175727	0	312681000	4195803	
30069	2661	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	176220	0	180256009	4107731	
30230	2673	4107731	1992-06-22	1992-06-22 00:00:00	38000275	0	\N	\N	177149	0	180256009	4107731	
30454	2692	4293740	1959-07-17	1959-07-17 00:00:00	38000275	0	\N	\N	178361	0	384700001	4293740	
18681	1597	4170947	1985-09-02	1985-09-02 00:00:00	38000275	0	\N	\N	107121	0	274474001	4170947	
30734	2715	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	180079	0	180256009	4107731	
30910	2739	4151422	1988-07-22	1988-07-22 00:00:00	38000275	0	\N	\N	181217	0	269911007	4151422	
31203	2765	4202451	2005-01-11	2005-01-11 00:00:00	38000275	0	\N	\N	182832	0	433112001	4202451	
19418	1659	4043071	1978-07-24	1978-07-24 00:00:00	38000275	0	\N	\N	111440	0	228557008	4043071	
31481	2778	4107731	1991-09-07	1991-09-07 00:00:00	38000275	0	\N	\N	183987	0	180256009	4107731	
31721	2792	4170947	1958-11-01	1958-11-01 00:00:00	38000275	0	\N	\N	185032	0	274474001	4170947	
31963	2815	4163872	1992-04-10	1992-04-10 00:00:00	38000275	0	\N	\N	186517	0	399208008	4163872	
20195	1744	4058899	2010-06-02	2010-06-02 00:00:00	38000275	0	\N	\N	116629	0	168594001	4058899	
20295	1753	4186930	1985-04-25	1985-04-25 00:00:00	38000275	0	\N	\N	117241	0	46706006	4186930	
32537	2858	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	189852	0	180256009	4107731	
32662	2869	4078793	2016-01-19	2016-01-19 00:00:00	38000275	0	\N	\N	190860	0	180325003	4078793	
44802	3926	4035793	2017-07-24	2017-07-24 00:00:00	38000275	0	\N	\N	260958	0	15081005	4035793	
32993	2896	4107731	1992-06-28	1992-06-28 00:00:00	38000275	0	\N	\N	192856	0	180256009	4107731	
21269	1843	4151422	1983-01-13	1983-01-13 00:00:00	38000275	0	\N	\N	123053	0	269911007	4151422	
33291	2915	4107731	1992-04-26	1992-04-26 00:00:00	38000275	0	\N	\N	194267	0	180256009	4107731	
45577	4020	4125906	1959-12-11	1959-12-11 00:00:00	38000275	0	\N	\N	267234	0	288086009	4125906	
33737	2942	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	196113	0	180256009	4107731	
33970	2959	4043071	1980-09-10	1980-09-10 00:00:00	38000275	0	\N	\N	197574	0	228557008	4043071	
34097	2966	4107731	1993-03-06	1993-03-06 00:00:00	38000275	0	\N	\N	198139	0	180256009	4107731	
22373	1956	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	130160	0	180256009	4107731	
22614	1976	4107731	1999-03-15	1999-03-15 00:00:00	38000275	0	\N	\N	131393	0	180256009	4107731	
34765	3022	4330583	2002-05-12	2002-05-12 00:00:00	38000275	0	\N	\N	201450	0	22523008	4330583	
34844	3026	4125906	1980-05-11	1980-05-11 00:00:00	38000275	0	\N	\N	201792	0	288086009	4125906	
47096	4130	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	274591	0	180256009	4107731	
35249	3072	4043071	1968-09-09	1968-09-09 00:00:00	38000275	0	\N	\N	204445	0	228557008	4043071	
35469	3109	4043071	1929-06-19	1929-06-19 00:00:00	38000275	0	\N	\N	206846	0	228557008	4043071	
35594	3118	4107731	1990-08-19	1990-08-19 00:00:00	38000275	0	\N	\N	207528	0	180256009	4107731	
23920	2077	4107731	1990-05-27	1990-05-27 00:00:00	38000275	0	\N	\N	138349	0	180256009	4107731	
12062	1102	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	72432	0	180256009	4107731	
24235	2119	4107731	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	141028	0	180256009	4107731	
24355	2131	4125906	1988-06-07	1988-06-07 00:00:00	38000275	0	\N	\N	141827	0	288086009	4125906	
24624	2155	4151422	1985-10-10	1985-10-10 00:00:00	38000275	0	\N	\N	143576	0	269911007	4151422	
24855	2173	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	144731	0	395142003	4191853	
24897	2175	4107731	2009-03-10	2009-03-10 00:00:00	38000275	0	\N	\N	145017	0	180256009	4107731	
25162	2189	4107731	2012-06-06	2012-06-06 00:00:00	38000275	0	\N	\N	145995	0	180256009	4107731	
25353	2204	4125906	1980-04-07	1980-04-07 00:00:00	38000275	0	\N	\N	146879	0	288086009	4125906	
25577	2238	4107731	1992-11-15	1992-11-15 00:00:00	38000275	0	\N	\N	148919	0	180256009	4107731	
25772	2265	4107731	1990-04-01	1990-04-01 00:00:00	38000275	0	\N	\N	150560	0	180256009	4107731	
14006	1267	4170947	1995-02-27	1995-02-27 00:00:00	38000275	0	\N	\N	83568	0	274474001	4170947	
14210	1276	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	84279	0	180256009	4107731	
26290	2291	44783196	1971-02-25	1971-02-25 00:00:00	38000275	0	\N	\N	152405	0	699253003	44783196	
38381	3376	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	223972	0	180256009	4107731	
26713	2339	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	155606	0	180256009	4107731	
26776	2341	4078793	2015-05-14	2015-05-14 00:00:00	38000275	0	\N	\N	155835	0	180325003	4078793	
27007	2357	4195803	2009-02-24	2009-02-24 00:00:00	38000275	0	\N	\N	157087	0	312681000	4195803	
27123	2369	4107731	1997-05-25	1997-05-25 00:00:00	38000275	0	\N	\N	157705	0	180256009	4107731	
27420	2392	4035793	1979-11-23	1979-11-23 00:00:00	38000275	0	\N	\N	159077	0	15081005	4035793	
15667	1387	4043071	1985-11-24	1985-11-24 00:00:00	38000275	0	\N	\N	92088	0	228557008	4043071	
27788	2436	4107731	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	161610	0	180256009	4107731	
27966	2459	4151422	2008-09-06	2008-09-06 00:00:00	38000275	0	\N	\N	163039	0	269911007	4151422	
16235	1412	4125906	1999-11-30	1999-11-30 00:00:00	38000275	0	\N	\N	94042	0	288086009	4125906	
40212	3528	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	234190	0	180256009	4107731	
28483	2535	4151422	1998-10-26	1998-10-26 00:00:00	38000275	0	\N	\N	167495	0	269911007	4151422	
40597	3566	4043071	1959-05-04	1959-05-04 00:00:00	38000275	0	\N	\N	236809	0	228557008	4043071	
28934	2559	4107731	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	169561	0	180256009	4107731	
17137	1482	4107731	1991-06-15	1991-06-15 00:00:00	38000275	0	\N	\N	98861	0	180256009	4107731	
29193	2590	4170947	1967-06-20	1967-06-20 00:00:00	38000275	0	\N	\N	171405	0	274474001	4170947	
29386	2624	4043071	1975-07-31	1975-07-31 00:00:00	38000275	0	\N	\N	173537	0	228557008	4043071	
41534	3647	4043071	1943-12-29	1943-12-29 00:00:00	38000275	0	\N	\N	242713	0	228557008	4043071	
29890	2654	4170947	2010-03-09	2010-03-09 00:00:00	38000275	0	\N	\N	175727	0	274474001	4170947	
30070	2661	4062501	1967-09-18	1967-09-18 00:00:00	38000275	0	\N	\N	176267	0	171231001	4062501	
30231	2673	4107731	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	177097	0	180256009	4107731	
30455	2693	4151422	1977-08-27	1977-08-27 00:00:00	38000275	0	\N	\N	178403	0	269911007	4151422	
18682	1597	4125906	1960-06-10	1960-06-10 00:00:00	38000275	0	\N	\N	107118	0	288086009	4125906	
30735	2715	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	180026	0	180256009	4107731	
30911	2739	4163872	1969-07-24	1969-07-24 00:00:00	38000275	0	\N	\N	181187	0	399208008	4163872	
31204	2765	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	182920	0	180256009	4107731	
19419	1659	4043071	1977-12-26	1977-12-26 00:00:00	38000275	0	\N	\N	111515	0	228557008	4043071	
31482	2778	4107731	1993-03-06	1993-03-06 00:00:00	38000275	0	\N	\N	183993	0	180256009	4107731	
31722	2792	4024289	1958-11-01	1958-11-01 00:00:00	38000275	0	\N	\N	185032	0	19490002	4024289	
43759	3869	40492359	1926-10-09	1926-10-09 00:00:00	38000275	0	\N	\N	256936	0	447365002	40492359	
20196	1744	4125906	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	116627	0	288086009	4125906	
20296	1753	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	117296	0	180256009	4107731	
32538	2858	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	189808	0	180256009	4107731	
32663	2869	4195803	2013-01-20	2013-01-20 00:00:00	38000275	0	\N	\N	190829	0	312681000	4195803	
44803	3926	4035793	2018-07-30	2018-07-30 00:00:00	38000275	0	\N	\N	260935	0	15081005	4035793	
32994	2896	4107731	1991-08-18	1991-08-18 00:00:00	38000275	0	\N	\N	192852	0	180256009	4107731	
21270	1843	4107731	1997-03-05	1997-03-05 00:00:00	38000275	0	\N	\N	123035	0	180256009	4107731	
33292	2915	4107731	1990-02-18	1990-02-18 00:00:00	38000275	0	\N	\N	194314	0	180256009	4107731	
45578	4020	4293740	1968-02-18	1968-02-18 00:00:00	38000275	0	\N	\N	267235	0	384700001	4293740	
33738	2942	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	196172	0	180256009	4107731	
33971	2959	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	197532	0	180256009	4107731	
34098	2966	4107731	1990-12-29	1990-12-29 00:00:00	38000275	0	\N	\N	198093	0	180256009	4107731	
22374	1956	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	130186	0	180256009	4107731	
22615	1976	4107731	1996-09-02	1996-09-02 00:00:00	38000275	0	\N	\N	131436	0	180256009	4107731	
34766	3022	4163872	1991-07-18	1991-07-18 00:00:00	38000275	0	\N	\N	201446	0	399208008	4163872	
34846	3028	4057420	2009-04-23	2009-04-23 00:00:00	38000275	0	\N	\N	201876	0	18286008	4057420	
47097	4130	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	274625	0	180256009	4107731	
35250	3072	4125906	2008-01-23	2008-01-23 00:00:00	38000275	0	\N	\N	204462	0	288086009	4125906	
35470	3109	4151422	1964-06-29	1964-06-29 00:00:00	38000275	0	\N	\N	206757	0	269911007	4151422	
35595	3118	4107731	1991-06-30	1991-06-30 00:00:00	38000275	0	\N	\N	207513	0	180256009	4107731	
23921	2077	4107731	1991-01-13	1991-01-13 00:00:00	38000275	0	\N	\N	138351	0	180256009	4107731	
12063	1102	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	72464	0	180256009	4107731	
24236	2119	4107731	1993-02-08	1993-02-08 00:00:00	38000275	0	\N	\N	141035	0	180256009	4107731	
24356	2131	4125906	1978-10-14	1978-10-14 00:00:00	38000275	0	\N	\N	141826	0	288086009	4125906	
24625	2155	4151422	2005-04-06	2005-04-06 00:00:00	38000275	0	\N	\N	143603	0	269911007	4151422	
24856	2173	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	144858	0	180256009	4107731	
24898	2175	4107731	2012-02-14	2012-02-14 00:00:00	38000275	0	\N	\N	144971	0	180256009	4107731	
25163	2189	4107731	2011-08-17	2011-08-17 00:00:00	38000275	0	\N	\N	145939	0	180256009	4107731	
25354	2204	4125906	1959-07-30	1959-07-30 00:00:00	38000275	0	\N	\N	146927	0	288086009	4125906	
25578	2238	4107731	1992-10-25	1992-10-25 00:00:00	38000275	0	\N	\N	148954	0	180256009	4107731	
25773	2265	4107731	1991-05-26	1991-05-26 00:00:00	38000275	0	\N	\N	150570	0	180256009	4107731	
14007	1267	4243062	1995-02-27	1995-02-27 00:00:00	38000275	0	\N	\N	83568	0	60027007	4243062	
14211	1276	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	84264	0	180256009	4107731	
26291	2291	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	152531	0	180256009	4107731	
38382	3376	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	223999	0	180256009	4107731	
26714	2339	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	155643	0	180256009	4107731	
26777	2341	4057420	2011-04-21	2011-04-21 00:00:00	38000275	0	\N	\N	155798	0	18286008	4057420	
27008	2357	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	157028	0	180256009	4107731	
27124	2369	4107731	1995-04-30	1995-04-30 00:00:00	38000275	0	\N	\N	157634	0	180256009	4107731	
27421	2392	4035793	1983-12-16	1983-12-16 00:00:00	38000275	0	\N	\N	159079	0	15081005	4035793	
15668	1387	4043071	1986-11-30	1986-11-30 00:00:00	38000275	0	\N	\N	91962	0	228557008	4043071	
27789	2436	4058899	1963-02-11	1963-02-11 00:00:00	38000275	0	\N	\N	161574	0	168594001	4058899	
27967	2459	4275113	1991-06-17	1991-06-17 00:00:00	38000275	0	\N	\N	163007	0	65200003	4275113	
16236	1412	4125906	1970-06-25	1970-06-25 00:00:00	38000275	0	\N	\N	94034	0	288086009	4125906	
40213	3528	4107731	1992-12-07	1992-12-07 00:00:00	38000275	0	\N	\N	234217	0	180256009	4107731	
28484	2537	4107731	1993-02-14	1993-02-14 00:00:00	38000275	0	\N	\N	167668	0	180256009	4107731	
40598	3566	4010253	1994-07-09	1994-07-09 00:00:00	38000275	0	\N	\N	236852	0	112790001	4010253	
28935	2559	4107731	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	169627	0	180256009	4107731	
17138	1482	4125906	1987-12-10	1987-12-10 00:00:00	38000275	0	\N	\N	98828	0	288086009	4125906	
29194	2591	4195803	2004-02-15	2004-02-15 00:00:00	38000275	0	\N	\N	171448	0	312681000	4195803	
29387	2624	4043071	1975-12-04	1975-12-04 00:00:00	38000275	0	\N	\N	173586	0	228557008	4043071	
41535	3647	4043071	1944-05-03	1944-05-03 00:00:00	38000275	0	\N	\N	242670	0	228557008	4043071	
29891	2654	4151422	1955-01-06	1955-01-06 00:00:00	38000275	0	\N	\N	175710	0	269911007	4151422	
30071	2661	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	176372	0	180256009	4107731	
30232	2673	4107731	1991-04-29	1991-04-29 00:00:00	38000275	0	\N	\N	177082	0	180256009	4107731	
30456	2693	4125906	1972-10-30	1972-10-30 00:00:00	38000275	0	\N	\N	178365	0	288086009	4125906	
18683	1597	4125906	1956-04-11	1956-04-11 00:00:00	38000275	0	\N	\N	107116	0	288086009	4125906	
30736	2715	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	179982	0	180256009	4107731	
30912	2740	4024289	1996-10-14	1996-10-14 00:00:00	38000275	0	\N	\N	181283	0	19490002	4024289	
31205	2765	4035793	2015-12-22	2015-12-22 00:00:00	38000275	0	\N	\N	182917	0	15081005	4035793	
19420	1659	4043071	1979-11-19	1979-11-19 00:00:00	38000275	0	\N	\N	111485	0	228557008	4043071	
31483	2778	4107731	1992-12-12	1992-12-12 00:00:00	38000275	0	\N	\N	184066	0	180256009	4107731	
31723	2792	4043071	1965-11-09	1965-11-09 00:00:00	38000275	0	\N	\N	184995	0	228557008	4043071	
43760	3869	4057420	1926-10-09	1926-10-09 00:00:00	38000275	0	\N	\N	256936	0	18286008	4057420	
32031	2818	4151422	1997-10-01	1997-10-01 00:00:00	38000275	0	\N	\N	186756	0	269911007	4151422	
20297	1753	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	117198	0	180256009	4107731	
44394	3895	4163872	1977-02-01	1977-02-01 00:00:00	38000275	0	\N	\N	259122	0	399208008	4163872	
32664	2869	4170947	2013-01-20	2013-01-20 00:00:00	38000275	0	\N	\N	190829	0	274474001	4170947	
44804	3926	44783196	1957-05-16	1957-05-16 00:00:00	38000275	0	\N	\N	260969	0	699253003	44783196	
32995	2896	4107731	1991-09-29	1991-09-29 00:00:00	38000275	0	\N	\N	192853	0	180256009	4107731	
21271	1844	4163872	1996-02-08	1996-02-08 00:00:00	38000275	0	\N	\N	123248	0	399208008	4163872	
33293	2915	4107731	1990-04-01	1990-04-01 00:00:00	38000275	0	\N	\N	194315	0	180256009	4107731	
45579	4020	4125906	1968-02-18	1968-02-18 00:00:00	38000275	0	\N	\N	267235	0	288086009	4125906	
33739	2942	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	196187	0	180256009	4107731	
33972	2959	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	197518	0	180256009	4107731	
34099	2966	4107731	1991-11-09	1991-11-09 00:00:00	38000275	0	\N	\N	198157	0	180256009	4107731	
22375	1956	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	130121	0	180256009	4107731	
22616	1976	4295880	2000-03-13	2000-03-13 00:00:00	38000275	0	\N	\N	131446	0	76601001	4295880	
34767	3025	4107731	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	201707	0	180256009	4107731	
34847	3028	4057420	2011-06-09	2011-06-09 00:00:00	38000275	0	\N	\N	201928	0	18286008	4057420	
47098	4133	4125906	2012-07-10	2012-07-10 00:00:00	38000275	0	\N	\N	274816	0	288086009	4125906	
35251	3072	4043071	1968-10-14	1968-10-14 00:00:00	38000275	0	\N	\N	204484	0	228557008	4043071	
35471	3109	4043071	1926-11-17	1926-11-17 00:00:00	38000275	0	\N	\N	206781	0	228557008	4043071	
35596	3118	4107731	1993-06-13	1993-06-13 00:00:00	38000275	0	\N	\N	207479	0	180256009	4107731	
23922	2077	4107731	1990-07-08	1990-07-08 00:00:00	38000275	0	\N	\N	138285	0	180256009	4107731	
12064	1102	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	72454	0	180256009	4107731	
24237	2119	4107731	1992-03-09	1992-03-09 00:00:00	38000275	0	\N	\N	141022	0	180256009	4107731	
24360	2133	4252419	1996-11-21	1996-11-21 00:00:00	38000275	0	\N	\N	141933	0	74016001	4252419	
24626	2155	4195803	2007-04-25	2007-04-25 00:00:00	38000275	0	\N	\N	143622	0	312681000	4195803	
24857	2173	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	144862	0	180256009	4107731	
24899	2175	4107731	2009-04-21	2009-04-21 00:00:00	38000275	0	\N	\N	145018	0	180256009	4107731	
25164	2189	4107731	2011-03-23	2011-03-23 00:00:00	38000275	0	\N	\N	145899	0	180256009	4107731	
25355	2204	4252419	1957-04-03	1957-04-03 00:00:00	38000275	0	\N	\N	146926	0	74016001	4252419	
25579	2238	4107731	1990-08-19	1990-08-19 00:00:00	38000275	0	\N	\N	148982	0	180256009	4107731	
25774	2265	4107731	1991-02-10	1991-02-10 00:00:00	38000275	0	\N	\N	150564	0	180256009	4107731	
25807	2265	4107731	1991-11-10	1991-11-10 00:00:00	38000275	0	\N	\N	150587	0	180256009	4107731	
14212	1276	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	84255	0	180256009	4107731	
26292	2291	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	152451	0	180256009	4107731	
38383	3376	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	223995	0	180256009	4107731	
26715	2339	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	155665	0	180256009	4107731	
26778	2341	4078793	2005-04-14	2005-04-14 00:00:00	38000275	0	\N	\N	155795	0	180325003	4078793	
27009	2357	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	157082	0	180256009	4107731	
27125	2369	4107731	1995-04-09	1995-04-09 00:00:00	38000275	0	\N	\N	157664	0	180256009	4107731	
27422	2392	4078793	2010-07-30	2010-07-30 00:00:00	38000275	0	\N	\N	158974	0	180325003	4078793	
15669	1387	4043071	1981-07-26	1981-07-26 00:00:00	38000275	0	\N	\N	92059	0	228557008	4043071	
27790	2436	4107731	1993-02-13	1993-02-13 00:00:00	38000275	0	\N	\N	161634	0	180256009	4107731	
27968	2459	4186930	1996-06-17	1996-06-17 00:00:00	38000275	0	\N	\N	163041	0	46706006	4186930	
16237	1415	4170947	2004-06-05	2004-06-05 00:00:00	38000275	0	\N	\N	94213	0	274474001	4170947	
40214	3528	4107731	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	234255	0	180256009	4107731	
28485	2537	4107731	1990-07-15	1990-07-15 00:00:00	38000275	0	\N	\N	167652	0	180256009	4107731	
40599	3566	4107731	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	236841	0	180256009	4107731	
28936	2559	4107731	1992-04-25	1992-04-25 00:00:00	38000275	0	\N	\N	169625	0	180256009	4107731	
17139	1482	4107731	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	98865	0	180256009	4107731	
29195	2591	4058899	2004-02-15	2004-02-15 00:00:00	38000275	0	\N	\N	171448	0	168594001	4058899	
29388	2624	4043071	1975-10-30	1975-10-30 00:00:00	38000275	0	\N	\N	173583	0	228557008	4043071	
41536	3647	4043071	1945-06-20	1945-06-20 00:00:00	38000275	0	\N	\N	242600	0	228557008	4043071	
29892	2654	4151422	1980-06-16	1980-06-16 00:00:00	38000275	0	\N	\N	175714	0	269911007	4151422	
30072	2661	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	176387	0	180256009	4107731	
30233	2673	4107731	1992-03-30	1992-03-30 00:00:00	38000275	0	\N	\N	177092	0	180256009	4107731	
30457	2693	4151422	1962-01-27	1962-01-27 00:00:00	38000275	0	\N	\N	178421	0	269911007	4151422	
18684	1598	4195803	2018-08-06	2018-08-06 00:00:00	38000275	0	\N	\N	107269	0	312681000	4195803	
30737	2715	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	180068	0	180256009	4107731	
30913	2740	4170947	1996-10-14	1996-10-14 00:00:00	38000275	0	\N	\N	181283	0	274474001	4170947	
31208	2767	4163872	1961-08-01	1961-08-01 00:00:00	38000275	0	\N	\N	183022	0	399208008	4163872	
19421	1659	4043071	1976-12-20	1976-12-20 00:00:00	38000275	0	\N	\N	111572	0	228557008	4043071	
31484	2778	4107731	1991-01-19	1991-01-19 00:00:00	38000275	0	\N	\N	183985	0	180256009	4107731	
31724	2792	4043071	1965-12-07	1965-12-07 00:00:00	38000275	0	\N	\N	185043	0	228557008	4043071	
43761	3869	4170947	1980-12-03	1980-12-03 00:00:00	38000275	0	\N	\N	256844	0	274474001	4170947	
32032	2818	4125906	1989-04-06	1989-04-06 00:00:00	38000275	0	\N	\N	186730	0	288086009	4125906	
20298	1753	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	117250	0	180256009	4107731	
44395	3895	4252419	1953-06-30	1953-06-30 00:00:00	38000275	0	\N	\N	259022	0	74016001	4252419	
32665	2869	4243062	2013-01-20	2013-01-20 00:00:00	38000275	0	\N	\N	190829	0	60027007	4243062	
44805	3926	4035793	2015-07-13	2015-07-13 00:00:00	38000275	0	\N	\N	260957	0	15081005	4035793	
32996	2896	4107731	1991-01-20	1991-01-20 00:00:00	38000275	0	\N	\N	192787	0	180256009	4107731	
21272	1844	4170947	1977-07-15	1977-07-15 00:00:00	38000275	0	\N	\N	123218	0	274474001	4170947	
33294	2915	4107731	1990-12-09	1990-12-09 00:00:00	38000275	0	\N	\N	194331	0	180256009	4107731	
45580	4021	4170947	1961-09-03	1961-09-03 00:00:00	38000275	0	\N	\N	267310	0	274474001	4170947	
33740	2942	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	196225	0	180256009	4107731	
33973	2959	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	197460	0	180256009	4107731	
34100	2966	4107731	1990-05-12	1990-05-12 00:00:00	38000275	0	\N	\N	198062	0	180256009	4107731	
22376	1956	4170947	1972-11-04	1972-11-04 00:00:00	38000275	0	\N	\N	130215	0	274474001	4170947	
22617	1976	4295880	1996-12-16	1996-12-16 00:00:00	38000275	0	\N	\N	131366	0	76601001	4295880	
34768	3025	4107731	1991-07-22	1991-07-22 00:00:00	38000275	0	\N	\N	201705	0	180256009	4107731	
34848	3028	4078793	2014-06-26	2014-06-26 00:00:00	38000275	0	\N	\N	201913	0	180325003	4078793	
47099	4133	4293740	2012-07-10	2012-07-10 00:00:00	38000275	0	\N	\N	274816	0	384700001	4293740	
35252	3072	4010253	1999-07-10	1999-07-10 00:00:00	38000275	0	\N	\N	204480	0	112790001	4010253	
35472	3109	4043071	1928-05-16	1928-05-16 00:00:00	38000275	0	\N	\N	206791	0	228557008	4043071	
35597	3118	44783196	1972-08-29	1972-08-29 00:00:00	38000275	0	\N	\N	207423	0	699253003	44783196	
23923	2077	4107731	1990-01-21	1990-01-21 00:00:00	38000275	0	\N	\N	138271	0	180256009	4107731	
12065	1102	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	72423	0	180256009	4107731	
24238	2119	4107731	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	141019	0	180256009	4107731	
24361	2133	44783196	1996-11-28	1996-11-28 00:00:00	38000275	0	\N	\N	141894	0	699253003	44783196	
24627	2155	4125906	2003-06-03	2003-06-03 00:00:00	38000275	0	\N	\N	143618	0	288086009	4125906	
24858	2173	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	144854	0	180256009	4107731	
24900	2175	4107731	2010-12-21	2010-12-21 00:00:00	38000275	0	\N	\N	145061	0	180256009	4107731	
25165	2189	4107731	2010-10-06	2010-10-06 00:00:00	38000275	0	\N	\N	145909	0	180256009	4107731	
25356	2204	4125906	1950-07-19	1950-07-19 00:00:00	38000275	0	\N	\N	146925	0	288086009	4125906	
25580	2238	4107731	1991-11-24	1991-11-24 00:00:00	38000275	0	\N	\N	149011	0	180256009	4107731	
25775	2265	4107731	1991-10-20	1991-10-20 00:00:00	38000275	0	\N	\N	150557	0	180256009	4107731	
25808	2265	4107731	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	150591	0	180256009	4107731	
26051	2280	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	151683	0	180256009	4107731	
26293	2291	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	152552	0	180256009	4107731	
38384	3376	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	223975	0	180256009	4107731	
26716	2339	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	155602	0	180256009	4107731	
26779	2341	4078793	2010-04-15	2010-04-15 00:00:00	38000275	0	\N	\N	155816	0	180325003	4078793	
27010	2357	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	156938	0	180256009	4107731	
27126	2369	4107731	1996-01-07	1996-01-07 00:00:00	38000275	0	\N	\N	157667	0	180256009	4107731	
27423	2392	4035793	2010-07-30	2010-07-30 00:00:00	38000275	0	\N	\N	158974	0	15081005	4035793	
15670	1387	4043071	1984-02-12	1984-02-12 00:00:00	38000275	0	\N	\N	92005	0	228557008	4043071	
27791	2436	4170947	1990-01-20	1990-01-20 00:00:00	38000275	0	\N	\N	161576	0	274474001	4170947	
27969	2459	4238715	1997-11-17	1997-11-17 00:00:00	38000275	0	\N	\N	163035	0	68254000	4238715	
16238	1415	4047491	2004-06-05	2004-06-05 00:00:00	38000275	0	\N	\N	94213	0	1225002	4047491	
40215	3528	4191853	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	234239	0	395142003	4191853	
28486	2537	4107731	1990-04-01	1990-04-01 00:00:00	38000275	0	\N	\N	167587	0	180256009	4107731	
40600	3566	4107731	1992-08-24	1992-08-24 00:00:00	38000275	0	\N	\N	236976	0	180256009	4107731	
28937	2559	4107731	1992-02-22	1992-02-22 00:00:00	38000275	0	\N	\N	169608	0	180256009	4107731	
17140	1482	4107731	1992-02-22	1992-02-22 00:00:00	38000275	0	\N	\N	98870	0	180256009	4107731	
29196	2591	4293740	1943-06-14	1943-06-14 00:00:00	38000275	0	\N	\N	171449	0	384700001	4293740	
29389	2624	4043071	1976-08-05	1976-08-05 00:00:00	38000275	0	\N	\N	173575	0	228557008	4043071	
41537	3647	4202451	1992-08-19	1992-08-19 00:00:00	38000275	0	\N	\N	242650	0	433112001	4202451	
41739	3672	4198190	1986-03-13	1986-03-13 00:00:00	38000275	0	\N	\N	244325	0	80146002	4198190	
30073	2661	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	176330	0	180256009	4107731	
30234	2673	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	177162	0	180256009	4107731	
30471	2697	4057420	2005-09-08	2005-09-08 00:00:00	38000275	0	\N	\N	178582	0	18286008	4057420	
18685	1598	4151422	1995-08-15	1995-08-15 00:00:00	38000275	0	\N	\N	107245	0	269911007	4151422	
30738	2715	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	179975	0	180256009	4107731	
30914	2740	4125906	2016-02-02	2016-02-02 00:00:00	38000275	0	\N	\N	181284	0	288086009	4125906	
31209	2767	4252419	1975-01-12	1975-01-12 00:00:00	38000275	0	\N	\N	183066	0	74016001	4252419	
19422	1659	4043071	1983-04-25	1983-04-25 00:00:00	38000275	0	\N	\N	111500	0	228557008	4043071	
31485	2778	4107731	1992-04-04	1992-04-04 00:00:00	38000275	0	\N	\N	184074	0	180256009	4107731	
31725	2792	4043071	1966-05-10	1966-05-10 00:00:00	38000275	0	\N	\N	185028	0	228557008	4043071	
43762	3869	4047491	1980-12-03	1980-12-03 00:00:00	38000275	0	\N	\N	256844	0	1225002	4047491	
32033	2818	4125906	1985-07-12	1985-07-12 00:00:00	38000275	0	\N	\N	186729	0	288086009	4125906	
20299	1753	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	117252	0	180256009	4107731	
44396	3895	4202451	1999-02-12	1999-02-12 00:00:00	38000275	0	\N	\N	259125	0	433112001	4202451	
32666	2869	4078793	2014-01-07	2014-01-07 00:00:00	38000275	0	\N	\N	190859	0	180325003	4078793	
44806	3926	4252419	1957-05-09	1957-05-09 00:00:00	38000275	0	\N	\N	261006	0	74016001	4252419	
32997	2896	4107731	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	192876	0	180256009	4107731	
21273	1844	4047491	1977-07-15	1977-07-15 00:00:00	38000275	0	\N	\N	123218	0	1225002	4047491	
33295	2915	4107731	1993-01-24	1993-01-24 00:00:00	38000275	0	\N	\N	194270	0	180256009	4107731	
45581	4021	4243062	1961-09-03	1961-09-03 00:00:00	38000275	0	\N	\N	267310	0	60027007	4243062	
33741	2942	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	196114	0	180256009	4107731	
33974	2959	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	197517	0	180256009	4107731	
34101	2966	4125906	1989-01-07	1989-01-07 00:00:00	38000275	0	\N	\N	198046	0	288086009	4125906	
22377	1956	4047491	1972-11-04	1972-11-04 00:00:00	38000275	0	\N	\N	130215	0	1225002	4047491	
22618	1976	4191853	1999-06-28	1999-06-28 00:00:00	38000275	0	\N	\N	131406	0	395142003	4191853	
34769	3025	4107731	1990-04-16	1990-04-16 00:00:00	38000275	0	\N	\N	201574	0	180256009	4107731	
34849	3028	4198190	1978-04-19	1978-04-19 00:00:00	38000275	0	\N	\N	201862	0	80146002	4198190	
47100	4133	4125906	2004-11-14	2004-11-14 00:00:00	38000275	0	\N	\N	274781	0	288086009	4125906	
35253	3072	4024289	1995-11-27	1995-11-27 00:00:00	38000275	0	\N	\N	204461	0	19490002	4024289	
35473	3109	4043071	1928-04-11	1928-04-11 00:00:00	38000275	0	\N	\N	206786	0	228557008	4043071	
35598	3118	4107731	1993-02-28	1993-02-28 00:00:00	38000275	0	\N	\N	207522	0	180256009	4107731	
23924	2078	4252419	2014-01-13	2014-01-13 00:00:00	38000275	0	\N	\N	138384	0	74016001	4252419	
12066	1102	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	72452	0	180256009	4107731	
24239	2119	4107731	1991-02-04	1991-02-04 00:00:00	38000275	0	\N	\N	141073	0	180256009	4107731	
24362	2134	4151422	1978-08-21	1978-08-21 00:00:00	38000275	0	\N	\N	142002	0	269911007	4151422	
24628	2156	4243062	1988-04-18	1988-04-18 00:00:00	38000275	0	\N	\N	143732	0	60027007	4243062	
24859	2173	4252419	2010-06-27	2010-06-27 00:00:00	38000275	0	\N	\N	144892	0	74016001	4252419	
24901	2175	4107731	2012-01-24	2012-01-24 00:00:00	38000275	0	\N	\N	144954	0	180256009	4107731	
25166	2189	4107731	2011-11-09	2011-11-09 00:00:00	38000275	0	\N	\N	145901	0	180256009	4107731	
25357	2204	44783196	1957-04-10	1957-04-10 00:00:00	38000275	0	\N	\N	146877	0	699253003	44783196	
25581	2238	4107731	1990-03-25	1990-03-25 00:00:00	38000275	0	\N	\N	148906	0	180256009	4107731	
25776	2265	4107731	1993-05-09	1993-05-09 00:00:00	38000275	0	\N	\N	150595	0	180256009	4107731	
25809	2265	4107731	1991-12-22	1991-12-22 00:00:00	38000275	0	\N	\N	150588	0	180256009	4107731	
26052	2280	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	151647	0	180256009	4107731	
26294	2291	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	152475	0	180256009	4107731	
38385	3376	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	224037	0	180256009	4107731	
26717	2339	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	155687	0	180256009	4107731	
26780	2341	4078793	2008-03-27	2008-03-27 00:00:00	38000275	0	\N	\N	155814	0	180325003	4078793	
27011	2357	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	157027	0	180256009	4107731	
27127	2369	4107731	1994-10-02	1994-10-02 00:00:00	38000275	0	\N	\N	157680	0	180256009	4107731	
27424	2392	4078793	2017-10-27	2017-10-27 00:00:00	38000275	0	\N	\N	159070	0	180325003	4078793	
15671	1387	4043071	1982-10-10	1982-10-10 00:00:00	38000275	0	\N	\N	92035	0	228557008	4043071	
27792	2436	4047491	1990-01-20	1990-01-20 00:00:00	38000275	0	\N	\N	161576	0	1225002	4047491	
27970	2460	4062501	1988-08-14	1988-08-14 00:00:00	38000275	0	\N	\N	163084	0	171231001	4062501	
28054	2466	4125906	1996-08-17	1996-08-17 00:00:00	38000275	0	\N	\N	163501	0	288086009	4125906	
40216	3528	4191853	1990-01-01	1990-01-01 00:00:00	38000275	0	\N	\N	234230	0	395142003	4191853	
28487	2537	4107731	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	167771	0	180256009	4107731	
40601	3566	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	236938	0	180256009	4107731	
28938	2559	4107731	1993-05-29	1993-05-29 00:00:00	38000275	0	\N	\N	169631	0	180256009	4107731	
17141	1482	4107731	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	98831	0	180256009	4107731	
29197	2591	4125906	1943-06-14	1943-06-14 00:00:00	38000275	0	\N	\N	171449	0	288086009	4125906	
29390	2624	4043071	1976-07-01	1976-07-01 00:00:00	38000275	0	\N	\N	173574	0	228557008	4043071	
41538	3647	4043071	1944-09-06	1944-09-06 00:00:00	38000275	0	\N	\N	242714	0	228557008	4043071	
41740	3672	4151422	1979-06-23	1979-06-23 00:00:00	38000275	0	\N	\N	244300	0	269911007	4151422	
30074	2661	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	176324	0	180256009	4107731	
30235	2673	4107731	1992-07-13	1992-07-13 00:00:00	38000275	0	\N	\N	177152	0	180256009	4107731	
30472	2697	40492359	2005-09-08	2005-09-08 00:00:00	38000275	0	\N	\N	178582	0	447365002	40492359	
18686	1598	4151422	1997-05-28	1997-05-28 00:00:00	38000275	0	\N	\N	107246	0	269911007	4151422	
30739	2715	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	179996	0	180256009	4107731	
30927	2743	4058899	1977-07-04	1977-07-04 00:00:00	38000275	0	\N	\N	181451	0	168594001	4058899	
31210	2767	4125906	2004-01-17	2004-01-17 00:00:00	38000275	0	\N	\N	183067	0	288086009	4125906	
19423	1659	4043071	1983-05-23	1983-05-23 00:00:00	38000275	0	\N	\N	111471	0	228557008	4043071	
31486	2778	4107731	1992-06-06	1992-06-06 00:00:00	38000275	0	\N	\N	183990	0	180256009	4107731	
31726	2792	4125906	1972-03-22	1972-03-22 00:00:00	38000275	0	\N	\N	185034	0	288086009	4125906	
43763	3869	4195803	1980-12-03	1980-12-03 00:00:00	38000275	0	\N	\N	256844	0	312681000	4195803	
32037	2821	4163872	1946-04-02	1946-04-02 00:00:00	38000275	0	\N	\N	186867	0	399208008	4163872	
20300	1755	4151422	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	117385	0	269911007	4151422	
44397	3895	4195803	1994-05-20	1994-05-20 00:00:00	38000275	0	\N	\N	259028	0	312681000	4195803	
32667	2869	4057420	2015-01-13	2015-01-13 00:00:00	38000275	0	\N	\N	190910	0	18286008	4057420	
44807	3926	4035793	2014-07-07	2014-07-07 00:00:00	38000275	0	\N	\N	260921	0	15081005	4035793	
32998	2896	4293740	1989-02-04	1989-02-04 00:00:00	38000275	0	\N	\N	192866	0	384700001	4293740	
21274	1844	4062501	1963-04-13	1963-04-13 00:00:00	38000275	0	\N	\N	123132	0	171231001	4062501	
33296	2915	4107731	1991-11-10	1991-11-10 00:00:00	38000275	0	\N	\N	194322	0	180256009	4107731	
45582	4022	4125906	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	267386	0	288086009	4125906	
33742	2942	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	196102	0	180256009	4107731	
33975	2959	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	197462	0	180256009	4107731	
34102	2966	4107731	1991-12-21	1991-12-21 00:00:00	38000275	0	\N	\N	198069	0	180256009	4107731	
22378	1956	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	130187	0	180256009	4107731	
22619	1976	4275113	1997-12-14	1997-12-14 00:00:00	38000275	0	\N	\N	131445	0	65200003	4275113	
34770	3025	4151422	2001-01-14	2001-01-14 00:00:00	38000275	0	\N	\N	201620	0	269911007	4151422	
34850	3028	4078793	2007-05-17	2007-05-17 00:00:00	38000275	0	\N	\N	201875	0	180325003	4078793	
47101	4133	4125906	2005-10-31	2005-10-31 00:00:00	38000275	0	\N	\N	274782	0	288086009	4125906	
35254	3072	4170947	1995-11-27	1995-11-27 00:00:00	38000275	0	\N	\N	204461	0	274474001	4170947	
35474	3109	4043071	1928-09-19	1928-09-19 00:00:00	38000275	0	\N	\N	206787	0	228557008	4043071	
35599	3118	4107731	1990-09-30	1990-09-30 00:00:00	38000275	0	\N	\N	207489	0	180256009	4107731	
23925	2078	4010253	2006-07-11	2006-07-11 00:00:00	38000275	0	\N	\N	138422	0	112790001	4010253	
12067	1102	4191853	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	72407	0	395142003	4191853	
24240	2119	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	140981	0	180256009	4107731	
24363	2134	4198190	1997-09-01	1997-09-01 00:00:00	38000275	0	\N	\N	142027	0	80146002	4198190	
24629	2156	4170947	1988-04-18	1988-04-18 00:00:00	38000275	0	\N	\N	143732	0	274474001	4170947	
24860	2173	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	144716	0	180256009	4107731	
24902	2175	4191853	2012-08-21	2012-08-21 00:00:00	38000275	0	\N	\N	144972	0	395142003	4191853	
25167	2189	4107731	2012-04-04	2012-04-04 00:00:00	38000275	0	\N	\N	145941	0	180256009	4107731	
25358	2204	4125906	1965-08-11	1965-08-11 00:00:00	38000275	0	\N	\N	146878	0	288086009	4125906	
25582	2238	4107731	1992-05-31	1992-05-31 00:00:00	38000275	0	\N	\N	148949	0	180256009	4107731	
25777	2265	4107731	1992-06-07	1992-06-07 00:00:00	38000275	0	\N	\N	150503	0	180256009	4107731	
25810	2265	4107731	1991-07-07	1991-07-07 00:00:00	38000275	0	\N	\N	150571	0	180256009	4107731	
26053	2280	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	151648	0	180256009	4107731	
26295	2291	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	152452	0	180256009	4107731	
38386	3376	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	223964	0	180256009	4107731	
26718	2339	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	155679	0	180256009	4107731	
26781	2341	4078793	2006-04-20	2006-04-20 00:00:00	38000275	0	\N	\N	155813	0	180325003	4078793	
27012	2357	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	157041	0	180256009	4107731	
27128	2369	4107731	1995-11-05	1995-11-05 00:00:00	38000275	0	\N	\N	157693	0	180256009	4107731	
27425	2392	4035793	2017-10-27	2017-10-27 00:00:00	38000275	0	\N	\N	159070	0	15081005	4035793	
15672	1387	4043071	1983-02-13	1983-02-13 00:00:00	38000275	0	\N	\N	92036	0	228557008	4043071	
27793	2436	4195803	1990-01-20	1990-01-20 00:00:00	38000275	0	\N	\N	161576	0	312681000	4195803	
27971	2460	4238715	2004-08-18	2004-08-18 00:00:00	38000275	0	\N	\N	163076	0	68254000	4238715	
28055	2466	4243062	1989-06-25	1989-06-25 00:00:00	38000275	0	\N	\N	163499	0	60027007	4243062	
40217	3528	4107731	1992-01-27	1992-01-27 00:00:00	38000275	0	\N	\N	234270	0	180256009	4107731	
28488	2537	4107731	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	167780	0	180256009	4107731	
40602	3566	4107731	1992-06-22	1992-06-22 00:00:00	38000275	0	\N	\N	236965	0	180256009	4107731	
28939	2559	4107731	1992-12-12	1992-12-12 00:00:00	38000275	0	\N	\N	169579	0	180256009	4107731	
17142	1482	4107731	1990-06-23	1990-06-23 00:00:00	38000275	0	\N	\N	98856	0	180256009	4107731	
29198	2591	4010253	1960-05-09	1960-05-09 00:00:00	38000275	0	\N	\N	171490	0	112790001	4010253	
29391	2624	4043071	1976-03-18	1976-03-18 00:00:00	38000275	0	\N	\N	173547	0	228557008	4043071	
41539	3647	4043071	1945-07-25	1945-07-25 00:00:00	38000275	0	\N	\N	242601	0	228557008	4043071	
41741	3672	4151422	1982-08-27	1982-08-27 00:00:00	38000275	0	\N	\N	244305	0	269911007	4151422	
30075	2661	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	176385	0	395142003	4191853	
30236	2673	4107731	1992-12-28	1992-12-28 00:00:00	38000275	0	\N	\N	177095	0	180256009	4107731	
30473	2697	4151422	1941-10-07	1941-10-07 00:00:00	38000275	0	\N	\N	178568	0	269911007	4151422	
18687	1599	4170947	1979-12-31	1979-12-31 00:00:00	38000275	0	\N	\N	107361	0	274474001	4170947	
30740	2715	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	180022	0	180256009	4107731	
30928	2743	4151422	2004-10-24	2004-10-24 00:00:00	38000275	0	\N	\N	181441	0	269911007	4151422	
31211	2767	4151422	2002-12-27	2002-12-27 00:00:00	38000275	0	\N	\N	183076	0	269911007	4151422	
19424	1659	4043071	1977-02-14	1977-02-14 00:00:00	38000275	0	\N	\N	111512	0	228557008	4043071	
31487	2778	4107731	1990-04-21	1990-04-21 00:00:00	38000275	0	\N	\N	184008	0	180256009	4107731	
31727	2792	4170947	1961-09-16	1961-09-16 00:00:00	38000275	0	\N	\N	185033	0	274474001	4170947	
43764	3869	4170947	1961-07-16	1961-07-16 00:00:00	38000275	0	\N	\N	256843	0	274474001	4170947	
32038	2821	4195803	2005-05-07	2005-05-07 00:00:00	38000275	0	\N	\N	186856	0	312681000	4195803	
20301	1755	4125906	1995-12-06	1995-12-06 00:00:00	38000275	0	\N	\N	117377	0	288086009	4125906	
44398	3896	4202451	2010-06-18	2010-06-18 00:00:00	38000275	0	\N	\N	259191	0	433112001	4202451	
32668	2869	4078793	2009-12-15	2009-12-15 00:00:00	38000275	0	\N	\N	190830	0	180325003	4078793	
44808	3926	4125906	1963-07-14	1963-07-14 00:00:00	38000275	0	\N	\N	261007	0	288086009	4125906	
32999	2896	4125906	1989-02-04	1989-02-04 00:00:00	38000275	0	\N	\N	192866	0	288086009	4125906	
21275	1845	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	123370	0	180256009	4107731	
33297	2915	4107731	1990-10-28	1990-10-28 00:00:00	38000275	0	\N	\N	194298	0	180256009	4107731	
45627	4024	4295880	1995-04-16	1995-04-16 00:00:00	38000275	0	\N	\N	267548	0	76601001	4295880	
33743	2942	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	196159	0	180256009	4107731	
33976	2959	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	197578	0	180256009	4107731	
34103	2966	4107731	1991-05-25	1991-05-25 00:00:00	38000275	0	\N	\N	198130	0	180256009	4107731	
22382	1958	4043071	1981-09-25	1981-09-25 00:00:00	38000275	0	\N	\N	130265	0	228557008	4043071	
22620	1976	4295880	1997-03-17	1997-03-17 00:00:00	38000275	0	\N	\N	131382	0	76601001	4295880	
34771	3025	4107731	1990-05-07	1990-05-07 00:00:00	38000275	0	\N	\N	201606	0	180256009	4107731	
34851	3028	4078793	2010-04-29	2010-04-29 00:00:00	38000275	0	\N	\N	201870	0	180325003	4078793	
47102	4134	4151422	1987-05-24	1987-05-24 00:00:00	38000275	0	\N	\N	274863	0	269911007	4151422	
35255	3072	4043071	1968-08-12	1968-08-12 00:00:00	38000275	0	\N	\N	204429	0	228557008	4043071	
35475	3109	4043071	1926-07-07	1926-07-07 00:00:00	38000275	0	\N	\N	206804	0	228557008	4043071	
35600	3118	4252419	1972-08-22	1972-08-22 00:00:00	38000275	0	\N	\N	207534	0	74016001	4252419	
23926	2078	4170947	2019-01-24	2019-01-24 00:00:00	38000275	0	\N	\N	138385	0	274474001	4170947	
12068	1102	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	72482	0	180256009	4107731	
24241	2119	4107731	1990-07-09	1990-07-09 00:00:00	38000275	0	\N	\N	141053	0	180256009	4107731	
24364	2134	4202451	2017-04-02	2017-04-02 00:00:00	38000275	0	\N	\N	141957	0	433112001	4202451	
24630	2156	4010253	1994-07-10	1994-07-10 00:00:00	38000275	0	\N	\N	143698	0	112790001	4010253	
24861	2173	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	144805	0	180256009	4107731	
24903	2175	4191853	2009-02-17	2009-02-17 00:00:00	38000275	0	\N	\N	145012	0	395142003	4191853	
25168	2189	4107731	2011-11-30	2011-11-30 00:00:00	38000275	0	\N	\N	145927	0	180256009	4107731	
25359	2204	4187458	1954-09-11	1954-09-11 00:00:00	38000275	0	\N	\N	146930	0	415300000	4187458	
25583	2238	4107731	1993-06-13	1993-06-13 00:00:00	38000275	0	\N	\N	148956	0	180256009	4107731	
25778	2265	4107731	1990-10-28	1990-10-28 00:00:00	38000275	0	\N	\N	150612	0	180256009	4107731	
25811	2265	4107731	1992-01-12	1992-01-12 00:00:00	38000275	0	\N	\N	150605	0	180256009	4107731	
26054	2280	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	151671	0	180256009	4107731	
26296	2291	4062501	1964-10-19	1964-10-19 00:00:00	38000275	0	\N	\N	152406	0	171231001	4062501	
38387	3376	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	223967	0	180256009	4107731	
26719	2339	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	155658	0	180256009	4107731	
26782	2341	4078793	2002-03-28	2002-03-28 00:00:00	38000275	0	\N	\N	155811	0	180325003	4078793	
27013	2357	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	157015	0	180256009	4107731	
27129	2369	4107731	1996-08-04	1996-08-04 00:00:00	38000275	0	\N	\N	157714	0	180256009	4107731	
27426	2392	4078793	1998-05-22	1998-05-22 00:00:00	38000275	0	\N	\N	159064	0	180325003	4078793	
15673	1387	4170947	1980-08-31	1980-08-31 00:00:00	38000275	0	\N	\N	92092	0	274474001	4170947	
27794	2436	4107731	1991-05-25	1991-05-25 00:00:00	38000275	0	\N	\N	161646	0	180256009	4107731	
27972	2460	4293740	1991-04-04	1991-04-04 00:00:00	38000275	0	\N	\N	163069	0	384700001	4293740	
28056	2466	4195803	1989-06-25	1989-06-25 00:00:00	38000275	0	\N	\N	163499	0	312681000	4195803	
40218	3528	4107731	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	234268	0	180256009	4107731	
28489	2537	4107731	1992-06-07	1992-06-07 00:00:00	38000275	0	\N	\N	167775	0	180256009	4107731	
40603	3566	4107731	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	236835	0	180256009	4107731	
28940	2559	4107731	1990-09-15	1990-09-15 00:00:00	38000275	0	\N	\N	169586	0	180256009	4107731	
17143	1482	4107731	1991-07-27	1991-07-27 00:00:00	38000275	0	\N	\N	98882	0	180256009	4107731	
29199	2591	4163872	1987-12-17	1987-12-17 00:00:00	38000275	0	\N	\N	171497	0	399208008	4163872	
29392	2624	4043071	1976-05-27	1976-05-27 00:00:00	38000275	0	\N	\N	173598	0	228557008	4043071	
41540	3647	4043071	1945-08-22	1945-08-22 00:00:00	38000275	0	\N	\N	242673	0	228557008	4043071	
41742	3672	4151422	2009-03-09	2009-03-09 00:00:00	38000275	0	\N	\N	244309	0	269911007	4151422	
30076	2661	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	176375	0	180256009	4107731	
30237	2673	4107731	1993-01-18	1993-01-18 00:00:00	38000275	0	\N	\N	177070	0	180256009	4107731	
30474	2697	4125906	1941-02-07	1941-02-07 00:00:00	38000275	0	\N	\N	178580	0	288086009	4125906	
18688	1599	4163872	1979-12-31	1979-12-31 00:00:00	38000275	0	\N	\N	107361	0	399208008	4163872	
30741	2715	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	180024	0	180256009	4107731	
30930	2745	4125906	2017-09-09	2017-09-09 00:00:00	38000275	0	\N	\N	181605	0	288086009	4125906	
31212	2767	4243062	1971-04-05	1971-04-05 00:00:00	38000275	0	\N	\N	183064	0	60027007	4243062	
19425	1659	4043071	1977-05-30	1977-05-30 00:00:00	38000275	0	\N	\N	111555	0	228557008	4043071	
31488	2778	4107731	1990-11-17	1990-11-17 00:00:00	38000275	0	\N	\N	184019	0	180256009	4107731	
31728	2792	4047491	1961-09-16	1961-09-16 00:00:00	38000275	0	\N	\N	185033	0	1225002	4047491	
43765	3869	4195803	1961-07-16	1961-07-16 00:00:00	38000275	0	\N	\N	256843	0	312681000	4195803	
32039	2821	4047491	2005-05-07	2005-05-07 00:00:00	38000275	0	\N	\N	186856	0	1225002	4047491	
20302	1755	4057420	2015-08-26	2015-08-26 00:00:00	38000275	0	\N	\N	117380	0	18286008	4057420	
44402	3899	4243062	2018-08-09	2018-08-09 00:00:00	38000275	0	\N	\N	259249	0	60027007	4243062	
32669	2869	4078793	2010-12-21	2010-12-21 00:00:00	38000275	0	\N	\N	190902	0	180325003	4078793	
44809	3927	4151422	2011-04-02	2011-04-02 00:00:00	38000275	0	\N	\N	261045	0	269911007	4151422	
33000	2896	4107731	1992-11-01	1992-11-01 00:00:00	38000275	0	\N	\N	192815	0	180256009	4107731	
21276	1845	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	123294	0	180256009	4107731	
33298	2915	4107731	1991-01-20	1991-01-20 00:00:00	38000275	0	\N	\N	194332	0	180256009	4107731	
45628	4024	4295880	1997-01-12	1997-01-12 00:00:00	38000275	0	\N	\N	267519	0	76601001	4295880	
33744	2942	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	196161	0	180256009	4107731	
33977	2959	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	197564	0	180256009	4107731	
34104	2966	4107731	1992-04-04	1992-04-04 00:00:00	38000275	0	\N	\N	198134	0	180256009	4107731	
22383	1958	4043071	1981-10-23	1981-10-23 00:00:00	38000275	0	\N	\N	130256	0	228557008	4043071	
22621	1976	4107731	1996-02-05	1996-02-05 00:00:00	38000275	0	\N	\N	131331	0	180256009	4107731	
34772	3025	4107731	1993-03-01	1993-03-01 00:00:00	38000275	0	\N	\N	201601	0	180256009	4107731	
34852	3028	4078793	2017-07-13	2017-07-13 00:00:00	38000275	0	\N	\N	201872	0	180325003	4078793	
47103	4134	4058899	1959-08-13	1959-08-13 00:00:00	38000275	0	\N	\N	274820	0	168594001	4058899	
35256	3072	4057420	1964-02-01	1964-02-01 00:00:00	38000275	0	\N	\N	204459	0	18286008	4057420	
35476	3109	4043071	1926-12-15	1926-12-15 00:00:00	38000275	0	\N	\N	206805	0	228557008	4043071	
35601	3118	4107731	1990-12-23	1990-12-23 00:00:00	38000275	0	\N	\N	207412	0	180256009	4107731	
23927	2078	4163872	2019-01-24	2019-01-24 00:00:00	38000275	0	\N	\N	138385	0	399208008	4163872	
12069	1102	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	72481	0	180256009	4107731	
24242	2119	4107731	1992-01-06	1992-01-06 00:00:00	38000275	0	\N	\N	141029	0	180256009	4107731	
24365	2135	4170947	1961-06-28	1961-06-28 00:00:00	38000275	0	\N	\N	142100	0	274474001	4170947	
24631	2156	4151422	1978-10-10	1978-10-10 00:00:00	38000275	0	\N	\N	143696	0	269911007	4151422	
24862	2173	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	144784	0	180256009	4107731	
24904	2175	4107731	2010-06-15	2010-06-15 00:00:00	38000275	0	\N	\N	145037	0	180256009	4107731	
25169	2189	4107731	2012-11-21	2012-11-21 00:00:00	38000275	0	\N	\N	145944	0	180256009	4107731	
25360	2204	4037675	1954-09-11	1954-09-11 00:00:00	38000275	0	\N	\N	146930	0	162676008	4037675	
25584	2238	4107731	1992-07-12	1992-07-12 00:00:00	38000275	0	\N	\N	149013	0	180256009	4107731	
25779	2265	4107731	1991-06-16	1991-06-16 00:00:00	38000275	0	\N	\N	150614	0	180256009	4107731	
25812	2265	4191853	1993-07-11	1993-07-11 00:00:00	38000275	0	\N	\N	150540	0	395142003	4191853	
26055	2280	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	151602	0	180256009	4107731	
26297	2291	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	152443	0	180256009	4107731	
38388	3376	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	223980	0	180256009	4107731	
26720	2339	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	155691	0	180256009	4107731	
26783	2342	4125906	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	155888	0	288086009	4125906	
27014	2357	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	157046	0	180256009	4107731	
27130	2369	4107731	1994-06-19	1994-06-19 00:00:00	38000275	0	\N	\N	157688	0	180256009	4107731	
27427	2392	4035793	1998-05-22	1998-05-22 00:00:00	38000275	0	\N	\N	159064	0	15081005	4035793	
15674	1387	4047491	1980-08-31	1980-08-31 00:00:00	38000275	0	\N	\N	92092	0	1225002	4047491	
27795	2436	4163872	2009-04-13	2009-04-13 00:00:00	38000275	0	\N	\N	161452	0	399208008	4163872	
27973	2460	4125906	1991-04-04	1991-04-04 00:00:00	38000275	0	\N	\N	163069	0	288086009	4125906	
28057	2466	4170947	1989-06-25	1989-06-25 00:00:00	38000275	0	\N	\N	163499	0	274474001	4170947	
40219	3528	4181917	1960-12-12	1960-12-12 00:00:00	38000275	0	\N	\N	234280	0	54550000	4181917	
28490	2537	4107731	1991-03-03	1991-03-03 00:00:00	38000275	0	\N	\N	167654	0	180256009	4107731	
40604	3566	4107731	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	236898	0	180256009	4107731	
28941	2559	4191853	1993-07-10	1993-07-10 00:00:00	38000275	0	\N	\N	169613	0	395142003	4191853	
17144	1482	4107731	1990-09-15	1990-09-15 00:00:00	38000275	0	\N	\N	98878	0	180256009	4107731	
29200	2591	4195803	2012-03-14	2012-03-14 00:00:00	38000275	0	\N	\N	171547	0	312681000	4195803	
29393	2624	4043071	1975-07-03	1975-07-03 00:00:00	38000275	0	\N	\N	173582	0	228557008	4043071	
41608	3650	4151422	1992-02-28	1992-02-28 00:00:00	38000275	0	\N	\N	242944	0	269911007	4151422	
41743	3672	4170947	1976-01-09	1976-01-09 00:00:00	38000275	0	\N	\N	244326	0	274474001	4170947	
30077	2661	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	176388	0	180256009	4107731	
30238	2673	4107731	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	177157	0	180256009	4107731	
30475	2698	4125906	2001-01-15	2001-01-15 00:00:00	38000275	0	\N	\N	178694	0	288086009	4125906	
18689	1599	4047491	1966-11-09	1966-11-09 00:00:00	38000275	0	\N	\N	107360	0	1225002	4047491	
30742	2715	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	180014	0	180256009	4107731	
30931	2745	4125906	2003-12-28	2003-12-28 00:00:00	38000275	0	\N	\N	181576	0	288086009	4125906	
31213	2767	4170947	1971-04-05	1971-04-05 00:00:00	38000275	0	\N	\N	183064	0	274474001	4170947	
19426	1659	4043071	1980-11-10	1980-11-10 00:00:00	38000275	0	\N	\N	111488	0	228557008	4043071	
31489	2778	4107731	1992-06-27	1992-06-27 00:00:00	38000275	0	\N	\N	184038	0	180256009	4107731	
31729	2792	4043071	1966-01-11	1966-01-11 00:00:00	38000275	0	\N	\N	185027	0	228557008	4043071	
43766	3869	4047491	1961-07-16	1961-07-16 00:00:00	38000275	0	\N	\N	256843	0	1225002	4047491	
32040	2821	4170947	2005-05-07	2005-05-07 00:00:00	38000275	0	\N	\N	186856	0	274474001	4170947	
20303	1755	40492359	2015-08-26	2015-08-26 00:00:00	38000275	0	\N	\N	117380	0	447365002	40492359	
44403	3899	4170947	2018-08-09	2018-08-09 00:00:00	38000275	0	\N	\N	259249	0	274474001	4170947	
32670	2869	4252419	1954-10-24	1954-10-24 00:00:00	38000275	0	\N	\N	190822	0	74016001	4252419	
44810	3928	4198190	1995-12-06	1995-12-06 00:00:00	38000275	0	\N	\N	261147	0	80146002	4198190	
33001	2896	4107731	1991-06-16	1991-06-16 00:00:00	38000275	0	\N	\N	192793	0	180256009	4107731	
21277	1845	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	123390	0	180256009	4107731	
33299	2915	4107731	1992-06-07	1992-06-07 00:00:00	38000275	0	\N	\N	194268	0	180256009	4107731	
57410	4972	4024289	2016-09-19	2016-09-19 00:00:00	38000275	0	\N	\N	330665	0	19490002	4024289	
33745	2942	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	196062	0	180256009	4107731	
33978	2959	4043071	1979-01-17	1979-01-17 00:00:00	38000275	0	\N	\N	197521	0	228557008	4043071	
34105	2966	4107731	1993-05-08	1993-05-08 00:00:00	38000275	0	\N	\N	198163	0	180256009	4107731	
22384	1958	4043071	1981-11-20	1981-11-20 00:00:00	38000275	0	\N	\N	130246	0	228557008	4043071	
22622	1976	4107731	1998-03-23	1998-03-23 00:00:00	38000275	0	\N	\N	131356	0	180256009	4107731	
34773	3025	4107731	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	201691	0	180256009	4107731	
34853	3028	4078793	2018-07-19	2018-07-19 00:00:00	38000275	0	\N	\N	201865	0	180325003	4078793	
47104	4134	4125906	1956-07-15	1956-07-15 00:00:00	38000275	0	\N	\N	274819	0	288086009	4125906	
35257	3072	40492359	1964-02-01	1964-02-01 00:00:00	38000275	0	\N	\N	204459	0	447365002	40492359	
35477	3109	4043071	1928-02-08	1928-02-08 00:00:00	38000275	0	\N	\N	206728	0	228557008	4043071	
35602	3118	4107731	1993-03-21	1993-03-21 00:00:00	38000275	0	\N	\N	207477	0	180256009	4107731	
23928	2078	4047491	2005-05-09	2005-05-09 00:00:00	38000275	0	\N	\N	138382	0	1225002	4047491	
12070	1102	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	72478	0	180256009	4107731	
24252	2122	4125906	1998-04-15	1998-04-15 00:00:00	38000275	0	\N	\N	141217	0	288086009	4125906	
24366	2135	4047491	1961-06-28	1961-06-28 00:00:00	38000275	0	\N	\N	142100	0	1225002	4047491	
24632	2156	4151422	2014-02-12	2014-02-12 00:00:00	38000275	0	\N	\N	143704	0	269911007	4151422	
24863	2173	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	144855	0	180256009	4107731	
24905	2175	4107731	2009-07-14	2009-07-14 00:00:00	38000275	0	\N	\N	145073	0	180256009	4107731	
25170	2189	4107731	2010-03-10	2010-03-10 00:00:00	38000275	0	\N	\N	145957	0	180256009	4107731	
25361	2204	4326177	1954-09-11	1954-09-11 00:00:00	38000275	0	\N	\N	146930	0	430193006	4326177	
25585	2238	4107731	1992-03-08	1992-03-08 00:00:00	38000275	0	\N	\N	148947	0	180256009	4107731	
25780	2265	4125906	1978-10-26	1978-10-26 00:00:00	38000275	0	\N	\N	150603	0	288086009	4125906	
25813	2265	4151422	1975-09-26	1975-09-26 00:00:00	38000275	0	\N	\N	150548	0	269911007	4151422	
26056	2280	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	151568	0	180256009	4107731	
26298	2291	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	152402	0	180256009	4107731	
38389	3376	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	224065	0	180256009	4107731	
26721	2339	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	155649	0	180256009	4107731	
26784	2342	4293740	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	155888	0	384700001	4293740	
27015	2357	4107731	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	157020	0	180256009	4107731	
27131	2369	4107731	1995-07-23	1995-07-23 00:00:00	38000275	0	\N	\N	157636	0	180256009	4107731	
27428	2392	4252419	1916-11-30	1916-11-30 00:00:00	38000275	0	\N	\N	159007	0	74016001	4252419	
15675	1387	4043071	1984-09-09	1984-09-09 00:00:00	38000275	0	\N	\N	92067	0	228557008	4043071	
27796	2436	4107731	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	161644	0	180256009	4107731	
27974	2460	4186930	2004-08-04	2004-08-04 00:00:00	38000275	0	\N	\N	163127	0	46706006	4186930	
28058	2466	4170947	1993-07-04	1993-07-04 00:00:00	38000275	0	\N	\N	163500	0	274474001	4170947	
40220	3528	4107731	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	234180	0	180256009	4107731	
28491	2537	4107731	1990-12-09	1990-12-09 00:00:00	38000275	0	\N	\N	167698	0	180256009	4107731	
40605	3566	4151422	2005-07-31	2005-07-31 00:00:00	38000275	0	\N	\N	236970	0	269911007	4151422	
28942	2559	4107731	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	169565	0	180256009	4107731	
17145	1482	4107731	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	98802	0	180256009	4107731	
29201	2591	4243062	1947-09-12	1947-09-12 00:00:00	38000275	0	\N	\N	171447	0	60027007	4243062	
29394	2624	4043071	1975-10-02	1975-10-02 00:00:00	38000275	0	\N	\N	173573	0	228557008	4043071	
41609	3650	4202451	2014-07-04	2014-07-04 00:00:00	38000275	0	\N	\N	242920	0	433112001	4202451	
41744	3672	4047491	1976-01-09	1976-01-09 00:00:00	38000275	0	\N	\N	244326	0	1225002	4047491	
30078	2661	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	176379	0	180256009	4107731	
30239	2673	4107731	1991-12-16	1991-12-16 00:00:00	38000275	0	\N	\N	177084	0	180256009	4107731	
30476	2699	4151422	1980-05-13	1980-05-13 00:00:00	38000275	0	\N	\N	178716	0	269911007	4151422	
18690	1599	4170947	1966-11-09	1966-11-09 00:00:00	38000275	0	\N	\N	107360	0	274474001	4170947	
30743	2715	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	180029	0	180256009	4107731	
30935	2747	4043071	1983-07-14	1983-07-14 00:00:00	38000275	0	\N	\N	181704	0	228557008	4043071	
31214	2767	4163872	1957-11-11	1957-11-11 00:00:00	38000275	0	\N	\N	183049	0	399208008	4163872	
19427	1659	4043071	1978-06-26	1978-06-26 00:00:00	38000275	0	\N	\N	111481	0	228557008	4043071	
31490	2778	4107731	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	184039	0	180256009	4107731	
31730	2792	4024289	1994-01-10	1994-01-10 00:00:00	38000275	0	\N	\N	185040	0	19490002	4024289	
43771	3871	4151422	1969-11-20	1969-11-20 00:00:00	38000275	0	\N	\N	257036	0	269911007	4151422	
32041	2821	4125906	1962-01-04	1962-01-04 00:00:00	38000275	0	\N	\N	186851	0	288086009	4125906	
20304	1755	4293740	2008-07-26	2008-07-26 00:00:00	38000275	0	\N	\N	117379	0	384700001	4293740	
44404	3899	4151422	2010-10-21	2010-10-21 00:00:00	38000275	0	\N	\N	259290	0	269911007	4151422	
32671	2869	4170947	1960-07-31	1960-07-31 00:00:00	38000275	0	\N	\N	190823	0	274474001	4170947	
44811	3929	4125906	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	261150	0	288086009	4125906	
33002	2896	4107731	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	192872	0	180256009	4107731	
21278	1845	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	123297	0	180256009	4107731	
33300	2915	4107731	1992-11-22	1992-11-22 00:00:00	38000275	0	\N	\N	194396	0	180256009	4107731	
57411	4972	4170947	2016-09-19	2016-09-19 00:00:00	38000275	0	\N	\N	330665	0	274474001	4170947	
33746	2942	4062501	1956-08-04	1956-08-04 00:00:00	38000275	0	\N	\N	196086	0	171231001	4062501	
33979	2959	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	197566	0	180256009	4107731	
34106	2966	4107731	1992-04-25	1992-04-25 00:00:00	38000275	0	\N	\N	198147	0	180256009	4107731	
22385	1958	4293740	2004-09-11	2004-09-11 00:00:00	38000275	0	\N	\N	130245	0	384700001	4293740	
22623	1976	4107731	1996-02-26	1996-02-26 00:00:00	38000275	0	\N	\N	131435	0	180256009	4107731	
34774	3025	4107731	1991-09-23	1991-09-23 00:00:00	38000275	0	\N	\N	201593	0	180256009	4107731	
34854	3028	4057420	2012-06-14	2012-06-14 00:00:00	38000275	0	\N	\N	201912	0	18286008	4057420	
47105	4134	4047491	1960-09-06	1960-09-06 00:00:00	38000275	0	\N	\N	274821	0	1225002	4047491	
35258	3074	4202451	1993-11-10	1993-11-10 00:00:00	38000275	0	\N	\N	204591	0	433112001	4202451	
35478	3109	4043071	1925-12-23	1925-12-23 00:00:00	38000275	0	\N	\N	206829	0	228557008	4043071	
35603	3118	4107731	1992-01-05	1992-01-05 00:00:00	38000275	0	\N	\N	207514	0	180256009	4107731	
23929	2078	4170947	2005-05-09	2005-05-09 00:00:00	38000275	0	\N	\N	138382	0	274474001	4170947	
12071	1102	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	72419	0	180256009	4107731	
24253	2122	4125906	1975-09-24	1975-09-24 00:00:00	38000275	0	\N	\N	141214	0	288086009	4125906	
24367	2135	4107731	1993-02-08	1993-02-08 00:00:00	38000275	0	\N	\N	142056	0	180256009	4107731	
24633	2156	4170947	1967-06-08	1967-06-08 00:00:00	38000275	0	\N	\N	143731	0	274474001	4170947	
24864	2173	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	144847	0	180256009	4107731	
24906	2175	4191853	2009-02-17	2009-02-17 00:00:00	38000275	0	\N	\N	145012	0	395142003	4191853	
25171	2189	4107731	2012-12-12	2012-12-12 00:00:00	38000275	0	\N	\N	145996	0	180256009	4107731	
25362	2204	4125906	1986-03-21	1986-03-21 00:00:00	38000275	0	\N	\N	146880	0	288086009	4125906	
25586	2238	4125906	2005-08-16	2005-08-16 00:00:00	38000275	0	\N	\N	148929	0	288086009	4125906	
25781	2265	4107731	1992-02-02	1992-02-02 00:00:00	38000275	0	\N	\N	150589	0	180256009	4107731	
25814	2265	4107731	1991-12-01	1991-12-01 00:00:00	38000275	0	\N	\N	150604	0	180256009	4107731	
26057	2280	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	151592	0	180256009	4107731	
26299	2291	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	152543	0	180256009	4107731	
38390	3376	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	223963	0	180256009	4107731	
26722	2339	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	155596	0	180256009	4107731	
26785	2342	4151422	1985-06-27	1985-06-27 00:00:00	38000275	0	\N	\N	155910	0	269911007	4151422	
27016	2357	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	157011	0	180256009	4107731	
27132	2369	4107731	1995-02-26	1995-02-26 00:00:00	38000275	0	\N	\N	157663	0	180256009	4107731	
27429	2392	4035793	1978-11-17	1978-11-17 00:00:00	38000275	0	\N	\N	159057	0	15081005	4035793	
15676	1387	4043071	1984-10-14	1984-10-14 00:00:00	38000275	0	\N	\N	92021	0	228557008	4043071	
27797	2436	4107731	1991-07-06	1991-07-06 00:00:00	38000275	0	\N	\N	161647	0	180256009	4107731	
27975	2460	4151422	2012-10-11	2012-10-11 00:00:00	38000275	0	\N	\N	163072	0	269911007	4151422	
28059	2466	4024289	1993-07-04	1993-07-04 00:00:00	38000275	0	\N	\N	163500	0	19490002	4024289	
40221	3528	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	234191	0	180256009	4107731	
28492	2537	4107731	1992-08-09	1992-08-09 00:00:00	38000275	0	\N	\N	167667	0	180256009	4107731	
40606	3566	4107731	1992-09-14	1992-09-14 00:00:00	38000275	0	\N	\N	236935	0	180256009	4107731	
28943	2559	4191853	1990-01-06	1990-01-06 00:00:00	38000275	0	\N	\N	169525	0	395142003	4191853	
17146	1482	4107731	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	98915	0	180256009	4107731	
29202	2591	4170947	1947-09-12	1947-09-12 00:00:00	38000275	0	\N	\N	171447	0	274474001	4170947	
29395	2624	4043071	1976-12-23	1976-12-23 00:00:00	38000275	0	\N	\N	173548	0	228557008	4043071	
41610	3650	4252419	1984-12-13	1984-12-13 00:00:00	38000275	0	\N	\N	242936	0	74016001	4252419	
41750	3675	4058899	1968-04-11	1968-04-11 00:00:00	38000275	0	\N	\N	244428	0	168594001	4058899	
30079	2661	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	176390	0	180256009	4107731	
30240	2673	4107731	1991-01-14	1991-01-14 00:00:00	38000275	0	\N	\N	177171	0	180256009	4107731	
30477	2699	4125906	1989-07-20	1989-07-20 00:00:00	38000275	0	\N	\N	178712	0	288086009	4125906	
18691	1599	4151422	1971-10-24	1971-10-24 00:00:00	38000275	0	\N	\N	107290	0	269911007	4151422	
30744	2715	4024289	1990-09-30	1990-09-30 00:00:00	38000275	0	\N	\N	179970	0	19490002	4024289	
30936	2747	4043071	1983-11-10	1983-11-10 00:00:00	38000275	0	\N	\N	181705	0	228557008	4043071	
31215	2767	4195803	1996-06-05	1996-06-05 00:00:00	38000275	0	\N	\N	183042	0	312681000	4195803	
19428	1659	4010253	1975-06-05	1975-06-05 00:00:00	38000275	0	\N	\N	111455	0	112790001	4010253	
31491	2778	4107731	1992-11-21	1992-11-21 00:00:00	38000275	0	\N	\N	184076	0	180256009	4107731	
31731	2792	4170947	1994-01-10	1994-01-10 00:00:00	38000275	0	\N	\N	185040	0	274474001	4170947	
43772	3871	4252419	1994-03-28	1994-03-28 00:00:00	38000275	0	\N	\N	257018	0	74016001	4252419	
32042	2821	4125906	1977-11-25	1977-11-25 00:00:00	38000275	0	\N	\N	186852	0	288086009	4125906	
20305	1755	4125906	2008-07-26	2008-07-26 00:00:00	38000275	0	\N	\N	117379	0	288086009	4125906	
44405	3900	4125906	2002-05-22	2002-05-22 00:00:00	38000275	0	\N	\N	259330	0	288086009	4125906	
32672	2869	4024289	1960-07-31	1960-07-31 00:00:00	38000275	0	\N	\N	190823	0	19490002	4024289	
44812	3929	4035793	2002-12-30	2002-12-30 00:00:00	38000275	0	\N	\N	261164	0	15081005	4035793	
33003	2896	4107731	1992-02-23	1992-02-23 00:00:00	38000275	0	\N	\N	192777	0	180256009	4107731	
21279	1845	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	123277	0	180256009	4107731	
33301	2915	4107731	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	194251	0	180256009	4107731	
57412	4972	4125906	1956-09-13	1956-09-13 00:00:00	38000275	0	\N	\N	330722	0	288086009	4125906	
33747	2942	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	196109	0	180256009	4107731	
33980	2959	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	197516	0	180256009	4107731	
34107	2966	4107731	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	198164	0	180256009	4107731	
22386	1958	4125906	2004-09-11	2004-09-11 00:00:00	38000275	0	\N	\N	130245	0	288086009	4125906	
22624	1976	4107731	1998-10-19	1998-10-19 00:00:00	38000275	0	\N	\N	131361	0	180256009	4107731	
34775	3025	4107731	1992-10-26	1992-10-26 00:00:00	38000275	0	\N	\N	201637	0	180256009	4107731	
34855	3028	4078793	2013-06-20	2013-06-20 00:00:00	38000275	0	\N	\N	201929	0	180325003	4078793	
47106	4134	4170947	1960-09-06	1960-09-06 00:00:00	38000275	0	\N	\N	274821	0	274474001	4170947	
35259	3074	4151422	1968-04-07	1968-04-07 00:00:00	38000275	0	\N	\N	204595	0	269911007	4151422	
35479	3109	4043071	1929-04-24	1929-04-24 00:00:00	38000275	0	\N	\N	206766	0	228557008	4043071	
35604	3118	4107731	1991-03-17	1991-03-17 00:00:00	38000275	0	\N	\N	207470	0	180256009	4107731	
23930	2078	4024289	1995-08-30	1995-08-30 00:00:00	38000275	0	\N	\N	138381	0	19490002	4024289	
12072	1102	4163872	1998-07-26	1998-07-26 00:00:00	38000275	0	\N	\N	72415	0	399208008	4163872	
24254	2122	4125906	1995-03-11	1995-03-11 00:00:00	38000275	0	\N	\N	141216	0	288086009	4125906	
24368	2135	4107731	1991-07-22	1991-07-22 00:00:00	38000275	0	\N	\N	142190	0	180256009	4107731	
24634	2156	4243062	1967-06-08	1967-06-08 00:00:00	38000275	0	\N	\N	143731	0	60027007	4243062	
24865	2173	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	144746	0	180256009	4107731	
24907	2175	4107731	2009-11-17	2009-11-17 00:00:00	38000275	0	\N	\N	145015	0	180256009	4107731	
25172	2189	4107731	2013-07-31	2013-07-31 00:00:00	38000275	0	\N	\N	145987	0	180256009	4107731	
25365	2206	4047491	1986-01-18	1986-01-18 00:00:00	38000275	0	\N	\N	147010	0	1225002	4047491	
25587	2238	4107731	1991-06-30	1991-06-30 00:00:00	38000275	0	\N	\N	148986	0	180256009	4107731	
25782	2265	4107731	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	150539	0	180256009	4107731	
25815	2265	4107731	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	150561	0	180256009	4107731	
26058	2280	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	151673	0	395142003	4191853	
26300	2291	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	152541	0	180256009	4107731	
38391	3376	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	223962	0	180256009	4107731	
26723	2339	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	155650	0	180256009	4107731	
26786	2343	4043071	1966-04-05	1966-04-05 00:00:00	38000275	0	\N	\N	156007	0	228557008	4043071	
27017	2357	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	157043	0	180256009	4107731	
27133	2369	4107731	1994-05-29	1994-05-29 00:00:00	38000275	0	\N	\N	157660	0	180256009	4107731	
27430	2392	4035793	2002-06-14	2002-06-14 00:00:00	38000275	0	\N	\N	158979	0	15081005	4035793	
15677	1387	4043071	1983-09-04	1983-09-04 00:00:00	38000275	0	\N	\N	92068	0	228557008	4043071	
27798	2436	4107731	1990-08-04	1990-08-04 00:00:00	38000275	0	\N	\N	161505	0	180256009	4107731	
27976	2460	4275113	1999-08-03	1999-08-03 00:00:00	38000275	0	\N	\N	163126	0	65200003	4275113	
28066	2468	4151422	1939-12-03	1939-12-03 00:00:00	38000275	0	\N	\N	163609	0	269911007	4151422	
40222	3528	4107731	1990-03-05	1990-03-05 00:00:00	38000275	0	\N	\N	234178	0	180256009	4107731	
28493	2537	4107731	1992-11-22	1992-11-22 00:00:00	38000275	0	\N	\N	167723	0	180256009	4107731	
40607	3566	4107731	1992-11-16	1992-11-16 00:00:00	38000275	0	\N	\N	236978	0	180256009	4107731	
28944	2559	4107731	1992-02-01	1992-02-01 00:00:00	38000275	0	\N	\N	169553	0	180256009	4107731	
17147	1482	4197460	1981-12-11	1981-12-11 00:00:00	38000275	0	\N	\N	98905	0	313191000	4197460	
29271	2594	4195803	1979-09-03	1979-09-03 00:00:00	38000275	0	\N	\N	171726	0	312681000	4195803	
29396	2624	4043071	1975-05-01	1975-05-01 00:00:00	38000275	0	\N	\N	173580	0	228557008	4043071	
41611	3650	4163872	2000-03-21	2000-03-21 00:00:00	38000275	0	\N	\N	242994	0	399208008	4163872	
41751	3675	4125906	1990-08-14	1990-08-14 00:00:00	38000275	0	\N	\N	244484	0	288086009	4125906	
30080	2661	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	176304	0	180256009	4107731	
30241	2673	4107731	1991-02-04	1991-02-04 00:00:00	38000275	0	\N	\N	177053	0	180256009	4107731	
30478	2699	4125906	1976-07-02	1976-07-02 00:00:00	38000275	0	\N	\N	178710	0	288086009	4125906	
18692	1600	4125906	2008-03-10	2008-03-10 00:00:00	38000275	0	\N	\N	107366	0	288086009	4125906	
30745	2715	4170947	1990-09-30	1990-09-30 00:00:00	38000275	0	\N	\N	179970	0	274474001	4170947	
30937	2747	4163872	1974-03-05	1974-03-05 00:00:00	38000275	0	\N	\N	181714	0	399208008	4163872	
31216	2767	4151422	1942-08-06	1942-08-06 00:00:00	38000275	0	\N	\N	183074	0	269911007	4151422	
19429	1659	4043071	1977-01-17	1977-01-17 00:00:00	38000275	0	\N	\N	111437	0	228557008	4043071	
31492	2778	4107731	1990-08-04	1990-08-04 00:00:00	38000275	0	\N	\N	184031	0	180256009	4107731	
31732	2792	4043071	1966-04-12	1966-04-12 00:00:00	38000275	0	\N	\N	185044	0	228557008	4043071	
43773	3871	4024289	1968-06-12	1968-06-12 00:00:00	38000275	0	\N	\N	257017	0	19490002	4024289	
32043	2821	4170947	1990-05-05	1990-05-05 00:00:00	38000275	0	\N	\N	186853	0	274474001	4170947	
20306	1755	4125906	2018-10-16	2018-10-16 00:00:00	38000275	0	\N	\N	117381	0	288086009	4125906	
44406	3901	4151422	1993-11-03	1993-11-03 00:00:00	38000275	0	\N	\N	259447	0	269911007	4151422	
32673	2869	4078793	2011-12-27	2011-12-27 00:00:00	38000275	0	\N	\N	190831	0	180325003	4078793	
44813	3929	4125906	2004-10-09	2004-10-09 00:00:00	38000275	0	\N	\N	261151	0	288086009	4125906	
33004	2896	4107731	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	192857	0	180256009	4107731	
21280	1845	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	123392	0	180256009	4107731	
33302	2915	4107731	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	194264	0	180256009	4107731	
57413	4972	4198190	1991-01-04	1991-01-04 00:00:00	38000275	0	\N	\N	330663	0	80146002	4198190	
33748	2942	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	196095	0	180256009	4107731	
33981	2959	4043071	1979-08-01	1979-08-01 00:00:00	38000275	0	\N	\N	197523	0	228557008	4043071	
34108	2966	4107731	1990-10-27	1990-10-27 00:00:00	38000275	0	\N	\N	198080	0	180256009	4107731	
22387	1958	4043071	1981-08-21	1981-08-21 00:00:00	38000275	0	\N	\N	130264	0	228557008	4043071	
22625	1976	4107731	1997-06-02	1997-06-02 00:00:00	38000275	0	\N	\N	131351	0	180256009	4107731	
34776	3025	4107731	1992-08-24	1992-08-24 00:00:00	38000275	0	\N	\N	201711	0	180256009	4107731	
34856	3028	4078793	2010-06-03	2010-06-03 00:00:00	38000275	0	\N	\N	201911	0	180325003	4078793	
47108	4137	4010253	2002-11-18	2002-11-18 00:00:00	38000275	0	\N	\N	275000	0	112790001	4010253	
35260	3074	4125906	1998-11-15	1998-11-15 00:00:00	38000275	0	\N	\N	204573	0	288086009	4125906	
35480	3109	4043071	1927-05-25	1927-05-25 00:00:00	38000275	0	\N	\N	206788	0	228557008	4043071	
35605	3118	4107731	1992-12-27	1992-12-27 00:00:00	38000275	0	\N	\N	207519	0	180256009	4107731	
23931	2078	4170947	1995-08-30	1995-08-30 00:00:00	38000275	0	\N	\N	138381	0	274474001	4170947	
12073	1102	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	72477	0	180256009	4107731	
24255	2122	4125906	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	141215	0	288086009	4125906	
24369	2135	4191853	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	142038	0	395142003	4191853	
36485	3207	4043071	1973-04-26	1973-04-26 00:00:00	38000275	0	\N	\N	213148	0	228557008	4043071	
24866	2173	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	144777	0	180256009	4107731	
24908	2175	4107731	2010-01-19	2010-01-19 00:00:00	38000275	0	\N	\N	145021	0	180256009	4107731	
25173	2189	4107731	2013-03-06	2013-03-06 00:00:00	38000275	0	\N	\N	145998	0	180256009	4107731	
25366	2206	4170947	1986-01-18	1986-01-18 00:00:00	38000275	0	\N	\N	147010	0	274474001	4170947	
25588	2238	4107731	1990-05-06	1990-05-06 00:00:00	38000275	0	\N	\N	148994	0	180256009	4107731	
25783	2265	4107731	1990-09-16	1990-09-16 00:00:00	38000275	0	\N	\N	150611	0	180256009	4107731	
25816	2265	4107731	1990-12-09	1990-12-09 00:00:00	38000275	0	\N	\N	150613	0	180256009	4107731	
26059	2280	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	151579	0	180256009	4107731	
26301	2291	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	152556	0	180256009	4107731	
38392	3376	4195803	2017-10-08	2017-10-08 00:00:00	38000275	0	\N	\N	224003	0	312681000	4195803	
26724	2339	4107731	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	155710	0	180256009	4107731	
26787	2343	4043071	1966-03-08	1966-03-08 00:00:00	38000275	0	\N	\N	155959	0	228557008	4043071	
27018	2357	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	156980	0	180256009	4107731	
27134	2369	4107731	1994-12-25	1994-12-25 00:00:00	38000275	0	\N	\N	157689	0	180256009	4107731	
27431	2392	4078793	2002-06-14	2002-06-14 00:00:00	38000275	0	\N	\N	158979	0	180325003	4078793	
15678	1387	4043071	1982-07-18	1982-07-18 00:00:00	38000275	0	\N	\N	92062	0	228557008	4043071	
27799	2436	4107731	1992-11-21	1992-11-21 00:00:00	38000275	0	\N	\N	161652	0	180256009	4107731	
27977	2461	4170947	2006-01-19	2006-01-19 00:00:00	38000275	0	\N	\N	163199	0	274474001	4170947	
28067	2468	4252419	1946-05-12	1946-05-12 00:00:00	38000275	0	\N	\N	163673	0	74016001	4252419	
40223	3528	4107731	1993-03-01	1993-03-01 00:00:00	38000275	0	\N	\N	234219	0	180256009	4107731	
28494	2537	4107731	1990-06-24	1990-06-24 00:00:00	38000275	0	\N	\N	167589	0	180256009	4107731	
40608	3566	4043071	1960-11-28	1960-11-28 00:00:00	38000275	0	\N	\N	236909	0	228557008	4043071	
28945	2559	4107731	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	169556	0	180256009	4107731	
17148	1482	4107731	1991-09-28	1991-09-28 00:00:00	38000275	0	\N	\N	98911	0	180256009	4107731	
29272	2594	4058899	1979-09-03	1979-09-03 00:00:00	38000275	0	\N	\N	171726	0	168594001	4058899	
29397	2624	4043071	1977-01-27	1977-01-27 00:00:00	38000275	0	\N	\N	173549	0	228557008	4043071	
41612	3650	4058899	1940-11-04	1940-11-04 00:00:00	38000275	0	\N	\N	242935	0	168594001	4058899	
41752	3676	4058899	1973-07-29	1973-07-29 00:00:00	38000275	0	\N	\N	244485	0	168594001	4058899	
30081	2661	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	176289	0	180256009	4107731	
30242	2673	4107731	1992-02-17	1992-02-17 00:00:00	38000275	0	\N	\N	177091	0	180256009	4107731	
42263	3732	4125906	1985-06-09	1985-06-09 00:00:00	38000275	0	\N	\N	247984	0	288086009	4125906	
18693	1600	4243062	1978-08-26	1978-08-26 00:00:00	38000275	0	\N	\N	107370	0	60027007	4243062	
30746	2715	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	179981	0	180256009	4107731	
30938	2747	4043071	1983-08-11	1983-08-11 00:00:00	38000275	0	\N	\N	181654	0	228557008	4043071	
31217	2767	44783196	1975-01-19	1975-01-19 00:00:00	38000275	0	\N	\N	183028	0	699253003	44783196	
19430	1659	4043071	1983-01-17	1983-01-17 00:00:00	38000275	0	\N	\N	111470	0	228557008	4043071	
31493	2778	4107731	1991-06-15	1991-06-15 00:00:00	38000275	0	\N	\N	184013	0	180256009	4107731	
31733	2792	4043071	1966-02-08	1966-02-08 00:00:00	38000275	0	\N	\N	184988	0	228557008	4043071	
43774	3871	4170947	1968-06-12	1968-06-12 00:00:00	38000275	0	\N	\N	257017	0	274474001	4170947	
32044	2821	4195803	1990-05-05	1990-05-05 00:00:00	38000275	0	\N	\N	186853	0	312681000	4195803	
20307	1755	4275113	1982-04-29	1982-04-29 00:00:00	38000275	0	\N	\N	117365	0	65200003	4275113	
44407	3901	4125906	2002-02-15	2002-02-15 00:00:00	38000275	0	\N	\N	259388	0	288086009	4125906	
44584	3913	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	260129	0	180256009	4107731	
44814	3929	4035793	2004-01-05	2004-01-05 00:00:00	38000275	0	\N	\N	261183	0	15081005	4035793	
33005	2896	4125906	1999-09-24	1999-09-24 00:00:00	38000275	0	\N	\N	192867	0	288086009	4125906	
21281	1845	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	123331	0	180256009	4107731	
33303	2915	4107731	1991-08-18	1991-08-18 00:00:00	38000275	0	\N	\N	194392	0	180256009	4107731	
57420	4975	4163872	1977-08-04	1977-08-04 00:00:00	38000275	0	\N	\N	330880	0	399208008	4163872	
33749	2942	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	196063	0	180256009	4107731	
33982	2959	4057420	1997-10-07	1997-10-07 00:00:00	38000275	0	\N	\N	197605	0	18286008	4057420	
34109	2966	4107731	1991-01-19	1991-01-19 00:00:00	38000275	0	\N	\N	198082	0	180256009	4107731	
22388	1960	4125906	1969-11-15	1969-11-15 00:00:00	38000275	0	\N	\N	130331	0	288086009	4125906	
22626	1976	4170947	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	131375	0	274474001	4170947	
34777	3025	4107731	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	201704	0	180256009	4107731	
34857	3028	4078793	2015-07-02	2015-07-02 00:00:00	38000275	0	\N	\N	201871	0	180325003	4078793	
47109	4137	4125906	2002-12-14	2002-12-14 00:00:00	38000275	0	\N	\N	275052	0	288086009	4125906	
35261	3074	4125906	2018-07-15	2018-07-15 00:00:00	38000275	0	\N	\N	204575	0	288086009	4125906	
35481	3109	4043071	1928-07-18	1928-07-18 00:00:00	38000275	0	\N	\N	206763	0	228557008	4043071	
35606	3118	4107731	1990-02-11	1990-02-11 00:00:00	38000275	0	\N	\N	207487	0	180256009	4107731	
23932	2078	44783196	2014-01-20	2014-01-20 00:00:00	38000275	0	\N	\N	138386	0	699253003	44783196	
12074	1102	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	72394	0	180256009	4107731	
24256	2123	4195803	2002-05-19	2002-05-19 00:00:00	38000275	0	\N	\N	141321	0	312681000	4195803	
24370	2135	4107731	1991-12-16	1991-12-16 00:00:00	38000275	0	\N	\N	142177	0	180256009	4107731	
36486	3207	4043071	1974-03-21	1974-03-21 00:00:00	38000275	0	\N	\N	213181	0	228557008	4043071	
24867	2173	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	144817	0	180256009	4107731	
24909	2175	4107731	2009-08-25	2009-08-25 00:00:00	38000275	0	\N	\N	145074	0	180256009	4107731	
25174	2189	4107731	2013-05-08	2013-05-08 00:00:00	38000275	0	\N	\N	145985	0	180256009	4107731	
25367	2207	4151422	2018-10-03	2018-10-03 00:00:00	38000275	0	\N	\N	147083	0	269911007	4151422	
25589	2238	4107731	1993-01-17	1993-01-17 00:00:00	38000275	0	\N	\N	148951	0	180256009	4107731	
25784	2265	4107731	1991-03-03	1991-03-03 00:00:00	38000275	0	\N	\N	150555	0	180256009	4107731	
25817	2265	4107731	1992-04-26	1992-04-26 00:00:00	38000275	0	\N	\N	150618	0	180256009	4107731	
26060	2280	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	151672	0	180256009	4107731	
26302	2291	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	152456	0	180256009	4107731	
38393	3376	4047491	2017-10-08	2017-10-08 00:00:00	38000275	0	\N	\N	224003	0	1225002	4047491	
26725	2339	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	155688	0	180256009	4107731	
26788	2343	4202451	2016-05-21	2016-05-21 00:00:00	38000275	0	\N	\N	156005	0	433112001	4202451	
27019	2357	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	157053	0	180256009	4107731	
27135	2369	4107731	1994-07-31	1994-07-31 00:00:00	38000275	0	\N	\N	157631	0	180256009	4107731	
27432	2392	4035793	1988-03-25	1988-03-25 00:00:00	38000275	0	\N	\N	159059	0	15081005	4035793	
15679	1387	4043071	1983-03-20	1983-03-20 00:00:00	38000275	0	\N	\N	92037	0	228557008	4043071	
27800	2436	4107731	1991-10-19	1991-10-19 00:00:00	38000275	0	\N	\N	161547	0	180256009	4107731	
27978	2461	4047491	2006-01-19	2006-01-19 00:00:00	38000275	0	\N	\N	163199	0	1225002	4047491	
28068	2468	4151422	1998-07-21	1998-07-21 00:00:00	38000275	0	\N	\N	163653	0	269911007	4151422	
40224	3528	4107731	1991-02-25	1991-02-25 00:00:00	38000275	0	\N	\N	234183	0	180256009	4107731	
28495	2537	4107731	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	167656	0	180256009	4107731	
40609	3566	4107731	1991-11-25	1991-11-25 00:00:00	38000275	0	\N	\N	236891	0	180256009	4107731	
28946	2559	4107731	1990-03-31	1990-03-31 00:00:00	38000275	0	\N	\N	169527	0	180256009	4107731	
17149	1482	4107731	1990-03-10	1990-03-10 00:00:00	38000275	0	\N	\N	98877	0	180256009	4107731	
29273	2596	4125906	2018-03-28	2018-03-28 00:00:00	38000275	0	\N	\N	171766	0	288086009	4125906	
29398	2624	4043071	1976-10-14	1976-10-14 00:00:00	38000275	0	\N	\N	173589	0	228557008	4043071	
41613	3650	4125906	1986-12-10	1986-12-10 00:00:00	38000275	0	\N	\N	242937	0	288086009	4125906	
41753	3676	4151422	1978-05-22	1978-05-22 00:00:00	38000275	0	\N	\N	244507	0	269911007	4151422	
30082	2661	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	176305	0	180256009	4107731	
30243	2673	4107731	1992-12-07	1992-12-07 00:00:00	38000275	0	\N	\N	177069	0	180256009	4107731	
42264	3732	44783196	2015-11-16	2015-11-16 00:00:00	38000275	0	\N	\N	247996	0	699253003	44783196	
18694	1600	4170947	1978-08-26	1978-08-26 00:00:00	38000275	0	\N	\N	107370	0	274474001	4170947	
30747	2715	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	179974	0	180256009	4107731	
30939	2747	4043071	1983-10-13	1983-10-13 00:00:00	38000275	0	\N	\N	181692	0	228557008	4043071	
31218	2767	4163951	1939-05-23	1939-05-23 00:00:00	38000275	0	\N	\N	183063	0	29303009	4163951	
19431	1659	4043071	1982-12-13	1982-12-13 00:00:00	38000275	0	\N	\N	111469	0	228557008	4043071	
31494	2778	4107731	1992-02-22	1992-02-22 00:00:00	38000275	0	\N	\N	184073	0	180256009	4107731	
31734	2792	4043071	1966-03-15	1966-03-15 00:00:00	38000275	0	\N	\N	184989	0	228557008	4043071	
43839	3874	4107731	1997-01-01	1997-01-01 00:00:00	38000275	0	\N	\N	257277	0	180256009	4107731	
32045	2821	4047491	1990-05-05	1990-05-05 00:00:00	38000275	0	\N	\N	186853	0	1225002	4047491	
20308	1755	4238715	1985-09-11	1985-09-11 00:00:00	38000275	0	\N	\N	117368	0	68254000	4238715	
44408	3901	4151422	1962-04-12	1962-04-12 00:00:00	38000275	0	\N	\N	259416	0	269911007	4151422	
44585	3913	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	260149	0	180256009	4107731	
44815	3929	4035793	2005-01-10	2005-01-10 00:00:00	38000275	0	\N	\N	261222	0	15081005	4035793	
33006	2896	4107731	1990-07-15	1990-07-15 00:00:00	38000275	0	\N	\N	192786	0	180256009	4107731	
21282	1845	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	123393	0	180256009	4107731	
33304	2915	4191853	1990-01-07	1990-01-07 00:00:00	38000275	0	\N	\N	194348	0	395142003	4191853	
57421	4975	4125906	2014-01-08	2014-01-08 00:00:00	38000275	0	\N	\N	330920	0	288086009	4125906	
33750	2942	4243062	1954-05-25	1954-05-25 00:00:00	38000275	0	\N	\N	196054	0	60027007	4243062	
33983	2959	40492359	1997-10-07	1997-10-07 00:00:00	38000275	0	\N	\N	197605	0	447365002	40492359	
34110	2966	4107731	1993-01-02	1993-01-02 00:00:00	38000275	0	\N	\N	198097	0	180256009	4107731	
22389	1960	4151422	1955-09-27	1955-09-27 00:00:00	38000275	0	\N	\N	130373	0	269911007	4151422	
22627	1976	4243062	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	131375	0	60027007	4243062	
34778	3025	4107731	1990-10-01	1990-10-01 00:00:00	38000275	0	\N	\N	201588	0	180256009	4107731	
34858	3028	4078793	2016-07-07	2016-07-07 00:00:00	38000275	0	\N	\N	201877	0	180325003	4078793	
47110	4137	4151422	1973-02-23	1973-02-23 00:00:00	38000275	0	\N	\N	275019	0	269911007	4151422	
35262	3074	4151422	1972-09-28	1972-09-28 00:00:00	38000275	0	\N	\N	204538	0	269911007	4151422	
35482	3109	4043071	1928-08-22	1928-08-22 00:00:00	38000275	0	\N	\N	206729	0	228557008	4043071	
35607	3118	4107731	1991-07-21	1991-07-21 00:00:00	38000275	0	\N	\N	207427	0	180256009	4107731	
23933	2079	4125906	2008-01-17	2008-01-17 00:00:00	38000275	0	\N	\N	138490	0	288086009	4125906	
12075	1102	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	72421	0	180256009	4107731	
24257	2123	4170947	2002-05-19	2002-05-19 00:00:00	38000275	0	\N	\N	141321	0	274474001	4170947	
24371	2135	4107731	1991-03-18	1991-03-18 00:00:00	38000275	0	\N	\N	142174	0	180256009	4107731	
36487	3207	4043071	1974-10-24	1974-10-24 00:00:00	38000275	0	\N	\N	213153	0	228557008	4043071	
24868	2173	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	144747	0	180256009	4107731	
24910	2175	4107731	2009-06-23	2009-06-23 00:00:00	38000275	0	\N	\N	145032	0	180256009	4107731	
25175	2189	4107731	2012-08-08	2012-08-08 00:00:00	38000275	0	\N	\N	145982	0	180256009	4107731	
25368	2207	4275113	1995-04-19	1995-04-19 00:00:00	38000275	0	\N	\N	147060	0	65200003	4275113	
25590	2238	4107731	1991-12-15	1991-12-15 00:00:00	38000275	0	\N	\N	149001	0	180256009	4107731	
25785	2265	4107731	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	150521	0	180256009	4107731	
25818	2265	4107731	1990-07-15	1990-07-15 00:00:00	38000275	0	\N	\N	150553	0	180256009	4107731	
26061	2280	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	151659	0	180256009	4107731	
26303	2291	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	152540	0	180256009	4107731	
38394	3376	4170947	2017-10-08	2017-10-08 00:00:00	38000275	0	\N	\N	224003	0	274474001	4170947	
26726	2339	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	155663	0	180256009	4107731	
26789	2343	4151422	1970-06-30	1970-06-30 00:00:00	38000275	0	\N	\N	155949	0	269911007	4151422	
27020	2357	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	157036	0	180256009	4107731	
27136	2369	4107731	1997-06-15	1997-06-15 00:00:00	38000275	0	\N	\N	157718	0	180256009	4107731	
27433	2392	4035793	2012-08-10	2012-08-10 00:00:00	38000275	0	\N	\N	158975	0	15081005	4035793	
15680	1387	4043071	1982-02-14	1982-02-14 00:00:00	38000275	0	\N	\N	92060	0	228557008	4043071	
27801	2436	4107731	1990-12-29	1990-12-29 00:00:00	38000275	0	\N	\N	161608	0	180256009	4107731	
27979	2461	4151422	2010-04-04	2010-04-04 00:00:00	38000275	0	\N	\N	163148	0	269911007	4151422	
28069	2468	4151422	1963-04-29	1963-04-29 00:00:00	38000275	0	\N	\N	163603	0	269911007	4151422	
40225	3528	4107731	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	234263	0	180256009	4107731	
28496	2537	4107731	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	167718	0	180256009	4107731	
40610	3566	4107731	1991-02-25	1991-02-25 00:00:00	38000275	0	\N	\N	236888	0	180256009	4107731	
28947	2559	4107731	1991-02-09	1991-02-09 00:00:00	38000275	0	\N	\N	169548	0	180256009	4107731	
17150	1482	4107731	1991-11-30	1991-11-30 00:00:00	38000275	0	\N	\N	98868	0	180256009	4107731	
29274	2596	4243062	1983-09-21	1983-09-21 00:00:00	38000275	0	\N	\N	171762	0	60027007	4243062	
29399	2624	4043071	1976-09-09	1976-09-09 00:00:00	38000275	0	\N	\N	173588	0	228557008	4043071	
41614	3650	4293740	1986-12-10	1986-12-10 00:00:00	38000275	0	\N	\N	242937	0	384700001	4293740	
41754	3676	40492359	1997-02-13	1997-02-13 00:00:00	38000275	0	\N	\N	244486	0	447365002	40492359	
30083	2661	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	176328	0	180256009	4107731	
30244	2673	4107731	1991-04-08	1991-04-08 00:00:00	38000275	0	\N	\N	177087	0	180256009	4107731	
42265	3732	4202451	2016-09-18	2016-09-18 00:00:00	38000275	0	\N	\N	247982	0	433112001	4202451	
18695	1600	4293740	2002-07-21	2002-07-21 00:00:00	38000275	0	\N	\N	107364	0	384700001	4293740	
30748	2715	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	179984	0	180256009	4107731	
30940	2747	4043071	1983-09-08	1983-09-08 00:00:00	38000275	0	\N	\N	181691	0	228557008	4043071	
31219	2767	42535580	1939-05-23	1939-05-23 00:00:00	38000275	0	\N	\N	183063	0	426701000119108	42535580	
19432	1659	4043071	1982-02-22	1982-02-22 00:00:00	38000275	0	\N	\N	111576	0	228557008	4043071	
31495	2778	4107731	1993-01-23	1993-01-23 00:00:00	38000275	0	\N	\N	184067	0	180256009	4107731	
31735	2792	4293740	2008-07-25	2008-07-25 00:00:00	38000275	0	\N	\N	185041	0	384700001	4293740	
43840	3874	4107731	1997-10-22	1997-10-22 00:00:00	38000275	0	\N	\N	257267	0	180256009	4107731	
32046	2821	4151422	1936-11-05	1936-11-05 00:00:00	38000275	0	\N	\N	186917	0	269911007	4151422	
20309	1756	4163872	2008-02-19	2008-02-19 00:00:00	38000275	0	\N	\N	117462	0	399208008	4163872	
44409	3901	4181917	1936-03-18	1936-03-18 00:00:00	38000275	0	\N	\N	259382	0	54550000	4181917	
44586	3913	4293740	2017-11-12	2017-11-12 00:00:00	38000275	0	\N	\N	260089	0	384700001	4293740	
44816	3929	4323902	2005-03-07	2005-03-07 00:00:00	38000275	0	\N	\N	261165	0	429609002	4323902	
33007	2896	4107731	1992-11-22	1992-11-22 00:00:00	38000275	0	\N	\N	192780	0	180256009	4107731	
21283	1845	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	123275	0	180256009	4107731	
33305	2915	4107731	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	194394	0	180256009	4107731	
57422	4976	4107731	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	330973	0	180256009	4107731	
33751	2942	4170947	1954-05-25	1954-05-25 00:00:00	38000275	0	\N	\N	196054	0	274474001	4170947	
33984	2959	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	197501	0	180256009	4107731	
34111	2966	4107731	1990-03-31	1990-03-31 00:00:00	38000275	0	\N	\N	198090	0	180256009	4107731	
22390	1960	4170947	2007-01-26	2007-01-26 00:00:00	38000275	0	\N	\N	130333	0	274474001	4170947	
34409	2980	4107731	1991-05-05	1991-05-05 00:00:00	38000275	0	\N	\N	198966	0	180256009	4107731	
34779	3025	4107731	1992-06-22	1992-06-22 00:00:00	38000275	0	\N	\N	201597	0	180256009	4107731	
34863	3030	4151422	1984-09-03	1984-09-03 00:00:00	38000275	0	\N	\N	202011	0	269911007	4151422	
47111	4137	4125906	2006-08-09	2006-08-09 00:00:00	38000275	0	\N	\N	275053	0	288086009	4125906	
35263	3076	4125906	2012-11-24	2012-11-24 00:00:00	38000275	0	\N	\N	204648	0	288086009	4125906	
35483	3109	4043071	1929-07-17	1929-07-17 00:00:00	38000275	0	\N	\N	206795	0	228557008	4043071	
35608	3118	4107731	1993-04-11	1993-04-11 00:00:00	38000275	0	\N	\N	207523	0	180256009	4107731	
23934	2079	4125906	1978-06-18	1978-06-18 00:00:00	38000275	0	\N	\N	138488	0	288086009	4125906	
12076	1102	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	72424	0	180256009	4107731	
24258	2123	4047491	2002-05-19	2002-05-19 00:00:00	38000275	0	\N	\N	141321	0	1225002	4047491	
24372	2135	4107731	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	142132	0	180256009	4107731	
36488	3207	4043071	1973-10-11	1973-10-11 00:00:00	38000275	0	\N	\N	213161	0	228557008	4043071	
24869	2173	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	144806	0	180256009	4107731	
24911	2175	4107731	2010-08-17	2010-08-17 00:00:00	38000275	0	\N	\N	145057	0	180256009	4107731	
25176	2189	4191853	2013-08-21	2013-08-21 00:00:00	38000275	0	\N	\N	145935	0	395142003	4191853	
25369	2207	4238715	1999-08-12	1999-08-12 00:00:00	38000275	0	\N	\N	147104	0	68254000	4238715	
25591	2238	4107731	1992-08-02	1992-08-02 00:00:00	38000275	0	\N	\N	149003	0	180256009	4107731	
25786	2265	4107731	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	150504	0	180256009	4107731	
25819	2265	4107731	1993-03-28	1993-03-28 00:00:00	38000275	0	\N	\N	150594	0	180256009	4107731	
26062	2280	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	151649	0	180256009	4107731	
26304	2291	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	152458	0	180256009	4107731	
38395	3376	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	223970	0	180256009	4107731	
26727	2339	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	155607	0	180256009	4107731	
26790	2343	4125906	2010-04-03	2010-04-03 00:00:00	38000275	0	\N	\N	155982	0	288086009	4125906	
27021	2357	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	156978	0	180256009	4107731	
27137	2369	4191853	1994-05-08	1994-05-08 00:00:00	38000275	0	\N	\N	157687	0	395142003	4191853	
27434	2392	4078793	2012-08-10	2012-08-10 00:00:00	38000275	0	\N	\N	158975	0	180325003	4078793	
15681	1387	4043071	1981-11-01	1981-11-01 00:00:00	38000275	0	\N	\N	91992	0	228557008	4043071	
27802	2436	4107731	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	161550	0	180256009	4107731	
27980	2462	4107731	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	163330	0	180256009	4107731	
28070	2468	4151422	2003-01-10	2003-01-10 00:00:00	38000275	0	\N	\N	163607	0	269911007	4151422	
40226	3528	4107731	1990-05-07	1990-05-07 00:00:00	38000275	0	\N	\N	234167	0	180256009	4107731	
28497	2537	4107731	1991-08-18	1991-08-18 00:00:00	38000275	0	\N	\N	167604	0	180256009	4107731	
40611	3566	4107731	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	236954	0	180256009	4107731	
28948	2559	4107731	1991-03-23	1991-03-23 00:00:00	38000275	0	\N	\N	169549	0	180256009	4107731	
17151	1482	4107731	1990-12-29	1990-12-29 00:00:00	38000275	0	\N	\N	98908	0	180256009	4107731	
29275	2596	4170947	1983-09-21	1983-09-21 00:00:00	38000275	0	\N	\N	171762	0	274474001	4170947	
29400	2624	4043071	1976-04-22	1976-04-22 00:00:00	38000275	0	\N	\N	173597	0	228557008	4043071	
41615	3650	44783196	1984-12-20	1984-12-20 00:00:00	38000275	0	\N	\N	242933	0	699253003	44783196	
41755	3676	4057420	1997-02-13	1997-02-13 00:00:00	38000275	0	\N	\N	244486	0	18286008	4057420	
30084	2661	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	176373	0	180256009	4107731	
30245	2673	4107731	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	177143	0	180256009	4107731	
42266	3732	4047491	1958-04-02	1958-04-02 00:00:00	38000275	0	\N	\N	247983	0	1225002	4047491	
18696	1600	4125906	2002-07-21	2002-07-21 00:00:00	38000275	0	\N	\N	107364	0	288086009	4125906	
30749	2715	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	180023	0	180256009	4107731	
30942	2749	4047491	1966-08-18	1966-08-18 00:00:00	38000275	0	\N	\N	181845	0	1225002	4047491	
31220	2767	4202832	1939-05-24	1939-05-24 00:00:00	38000275	0	\N	\N	183063	0	52765003	4202832	
19433	1659	4043071	1978-08-28	1978-08-28 00:00:00	38000275	0	\N	\N	111441	0	228557008	4043071	
31496	2778	4107731	1991-02-09	1991-02-09 00:00:00	38000275	0	\N	\N	184033	0	180256009	4107731	
31736	2792	4125906	2008-07-25	2008-07-25 00:00:00	38000275	0	\N	\N	185041	0	288086009	4125906	
43841	3874	4107731	1998-02-25	1998-02-25 00:00:00	38000275	0	\N	\N	257321	0	180256009	4107731	
32047	2822	4151422	2001-09-04	2001-09-04 00:00:00	38000275	0	\N	\N	186987	0	269911007	4151422	
20310	1758	4125906	1973-02-12	1973-02-12 00:00:00	38000275	0	\N	\N	117556	0	288086009	4125906	
44410	3901	4125906	1958-08-25	1958-08-25 00:00:00	38000275	0	\N	\N	259385	0	288086009	4125906	
44587	3913	4125906	2017-11-12	2017-11-12 00:00:00	38000275	0	\N	\N	260089	0	288086009	4125906	
44817	3929	4035793	2006-01-16	2006-01-16 00:00:00	38000275	0	\N	\N	261206	0	15081005	4035793	
33008	2896	4107731	1992-01-12	1992-01-12 00:00:00	38000275	0	\N	\N	192776	0	180256009	4107731	
21284	1845	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	123295	0	180256009	4107731	
33306	2915	4107731	1990-04-22	1990-04-22 00:00:00	38000275	0	\N	\N	194329	0	180256009	4107731	
57423	4976	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	331001	0	180256009	4107731	
33752	2942	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	196079	0	180256009	4107731	
33985	2959	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	197510	0	180256009	4107731	
34112	2966	4107731	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	198155	0	180256009	4107731	
22391	1960	4195803	2007-01-26	2007-01-26 00:00:00	38000275	0	\N	\N	130333	0	312681000	4195803	
34410	2980	4107731	1993-04-18	1993-04-18 00:00:00	38000275	0	\N	\N	198993	0	180256009	4107731	
34780	3025	4107731	1992-09-14	1992-09-14 00:00:00	38000275	0	\N	\N	201636	0	180256009	4107731	
34864	3030	4125906	1995-12-31	1995-12-31 00:00:00	38000275	0	\N	\N	202023	0	288086009	4125906	
47114	4139	4293740	2007-09-23	2007-09-23 00:00:00	38000275	0	\N	\N	275163	0	384700001	4293740	
35264	3076	40492359	1952-11-26	1952-11-26 00:00:00	38000275	0	\N	\N	204704	0	447365002	40492359	
35484	3109	4202451	1990-02-21	1990-02-21 00:00:00	38000275	0	\N	\N	206724	0	433112001	4202451	
35609	3118	4107731	1992-09-13	1992-09-13 00:00:00	38000275	0	\N	\N	207420	0	180256009	4107731	
23935	2079	4198190	1956-12-17	1956-12-17 00:00:00	38000275	0	\N	\N	138476	0	80146002	4198190	
12077	1102	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	72422	0	180256009	4107731	
24259	2123	44783196	1994-10-28	1994-10-28 00:00:00	38000275	0	\N	\N	141239	0	699253003	44783196	
24373	2135	4107731	1991-04-08	1991-04-08 00:00:00	38000275	0	\N	\N	142134	0	180256009	4107731	
36489	3207	4043071	1974-06-27	1974-06-27 00:00:00	38000275	0	\N	\N	213151	0	228557008	4043071	
24870	2173	4170947	1942-08-04	1942-08-04 00:00:00	38000275	0	\N	\N	144758	0	274474001	4170947	
24912	2175	4170947	1981-01-02	1981-01-02 00:00:00	38000275	0	\N	\N	145067	0	274474001	4170947	
25177	2189	4107731	2013-01-02	2013-01-02 00:00:00	38000275	0	\N	\N	145945	0	180256009	4107731	
25373	2210	4170947	1985-11-24	1985-11-24 00:00:00	38000275	0	\N	\N	147200	0	274474001	4170947	
25592	2238	4107731	1990-02-11	1990-02-11 00:00:00	38000275	0	\N	\N	148905	0	180256009	4107731	
25787	2265	4107731	1991-01-20	1991-01-20 00:00:00	38000275	0	\N	\N	150554	0	180256009	4107731	
25820	2265	4107731	1991-09-29	1991-09-29 00:00:00	38000275	0	\N	\N	150573	0	180256009	4107731	
26063	2280	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	151662	0	180256009	4107731	
26305	2291	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	152439	0	180256009	4107731	
38396	3376	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	223966	0	180256009	4107731	
26728	2339	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	155629	0	180256009	4107731	
26791	2343	4293740	2010-04-03	2010-04-03 00:00:00	38000275	0	\N	\N	155982	0	384700001	4293740	
27022	2357	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	157013	0	180256009	4107731	
27138	2369	4107731	1996-01-28	1996-01-28 00:00:00	38000275	0	\N	\N	157713	0	180256009	4107731	
27435	2392	4057420	2011-04-01	2011-04-01 00:00:00	38000275	0	\N	\N	\N	0	18286008	4057420	
15682	1387	4043071	1985-04-21	1985-04-21 00:00:00	38000275	0	\N	\N	92007	0	228557008	4043071	
27803	2436	4163872	1961-09-18	1961-09-18 00:00:00	38000275	0	\N	\N	161499	0	399208008	4163872	
27981	2462	4107731	1992-06-07	1992-06-07 00:00:00	38000275	0	\N	\N	163285	0	180256009	4107731	
28071	2468	4125906	1939-04-05	1939-04-05 00:00:00	38000275	0	\N	\N	163672	0	288086009	4125906	
40227	3528	4107731	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	234185	0	180256009	4107731	
28498	2537	4107731	1991-10-20	1991-10-20 00:00:00	38000275	0	\N	\N	167773	0	180256009	4107731	
40612	3566	4107731	1993-01-18	1993-01-18 00:00:00	38000275	0	\N	\N	236847	0	180256009	4107731	
28949	2559	4107731	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	169599	0	180256009	4107731	
17152	1482	4107731	1990-04-21	1990-04-21 00:00:00	38000275	0	\N	\N	98799	0	180256009	4107731	
29276	2596	4252419	2017-03-26	2017-03-26 00:00:00	38000275	0	\N	\N	171765	0	74016001	4252419	
29401	2624	4043071	1977-05-12	1977-05-12 00:00:00	38000275	0	\N	\N	173576	0	228557008	4043071	
41616	3650	4195803	1997-05-30	1997-05-30 00:00:00	38000275	0	\N	\N	242923	0	312681000	4195803	
41757	3678	4170947	2009-10-30	2009-10-30 00:00:00	38000275	0	\N	\N	244602	0	274474001	4170947	
30085	2661	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	176221	0	180256009	4107731	
30246	2673	4107731	1993-03-01	1993-03-01 00:00:00	38000275	0	\N	\N	177154	0	180256009	4107731	
42267	3732	4170947	1958-04-02	1958-04-02 00:00:00	38000275	0	\N	\N	247983	0	274474001	4170947	
18697	1600	4058899	1971-10-02	1971-10-02 00:00:00	38000275	0	\N	\N	107369	0	168594001	4058899	
30750	2715	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	180082	0	180256009	4107731	
30943	2749	4170947	1966-08-18	1966-08-18 00:00:00	38000275	0	\N	\N	181845	0	274474001	4170947	
31221	2767	4163971	1939-05-24	1939-05-24 00:00:00	38000275	0	\N	\N	183063	0	45595009	4163971	
19434	1659	4043071	1981-08-17	1981-08-17 00:00:00	38000275	0	\N	\N	111461	0	228557008	4043071	
31497	2778	4107731	1991-05-25	1991-05-25 00:00:00	38000275	0	\N	\N	184023	0	180256009	4107731	
43572	3857	4035793	2002-07-30	2002-07-30 00:00:00	38000275	0	\N	\N	256022	0	15081005	4035793	
43842	3874	4107731	1995-04-12	1995-04-12 00:00:00	38000275	0	\N	\N	257309	0	180256009	4107731	
32048	2822	4163872	2016-02-27	2016-02-27 00:00:00	38000275	0	\N	\N	186988	0	399208008	4163872	
20311	1758	4163872	2013-01-22	2013-01-22 00:00:00	38000275	0	\N	\N	117548	0	399208008	4163872	
44478	3904	4125906	2006-01-01	2006-01-01 00:00:00	38000275	0	\N	\N	259644	0	288086009	4125906	
44588	3913	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	260157	0	180256009	4107731	
44818	3930	4035793	1979-09-01	1979-09-01 00:00:00	38000275	0	\N	\N	261289	0	15081005	4035793	
33009	2896	4107731	1991-05-26	1991-05-26 00:00:00	38000275	0	\N	\N	192850	0	180256009	4107731	
21285	1845	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	123394	0	180256009	4107731	
33307	2915	4107731	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	194316	0	180256009	4107731	
57424	4976	4170947	1917-08-16	1917-08-16 00:00:00	38000275	0	\N	\N	331100	0	274474001	4170947	
33753	2942	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	196171	0	180256009	4107731	
33986	2959	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	197580	0	180256009	4107731	
34113	2966	4107731	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	198146	0	180256009	4107731	
22392	1960	4024289	2007-01-26	2007-01-26 00:00:00	38000275	0	\N	\N	130333	0	19490002	4024289	
34411	2980	4107731	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	199011	0	180256009	4107731	
34781	3025	4107731	1991-01-14	1991-01-14 00:00:00	38000275	0	\N	\N	201577	0	180256009	4107731	
34865	3030	4125906	2013-08-26	2013-08-26 00:00:00	38000275	0	\N	\N	202027	0	288086009	4125906	
47115	4139	4125906	2007-09-23	2007-09-23 00:00:00	38000275	0	\N	\N	275163	0	288086009	4125906	
35265	3076	4057420	1952-11-26	1952-11-26 00:00:00	38000275	0	\N	\N	204704	0	18286008	4057420	
35485	3109	4043071	1927-10-05	1927-10-05 00:00:00	38000275	0	\N	\N	206784	0	228557008	4043071	
35610	3118	4107731	1992-08-02	1992-08-02 00:00:00	38000275	0	\N	\N	207419	0	180256009	4107731	
23936	2079	4151422	2005-11-01	2005-11-01 00:00:00	38000275	0	\N	\N	138448	0	269911007	4151422	
12078	1102	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	72373	0	180256009	4107731	
24260	2123	4163872	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	141279	0	399208008	4163872	
24374	2135	4107731	1992-06-01	1992-06-01 00:00:00	38000275	0	\N	\N	142091	0	180256009	4107731	
36490	3207	4058899	1960-10-01	1960-10-01 00:00:00	38000275	0	\N	\N	213203	0	168594001	4058899	
24871	2173	4024289	1942-08-04	1942-08-04 00:00:00	38000275	0	\N	\N	144758	0	19490002	4024289	
24913	2175	4047491	1981-01-02	1981-01-02 00:00:00	38000275	0	\N	\N	145067	0	1225002	4047491	
25178	2189	4107731	2012-02-22	2012-02-22 00:00:00	38000275	0	\N	\N	145940	0	180256009	4107731	
25374	2210	4024289	1985-11-24	1985-11-24 00:00:00	38000275	0	\N	\N	147200	0	19490002	4024289	
25593	2238	4107731	1990-12-23	1990-12-23 00:00:00	38000275	0	\N	\N	148996	0	180256009	4107731	
25788	2265	4107731	1990-12-30	1990-12-30 00:00:00	38000275	0	\N	\N	150563	0	180256009	4107731	
25821	2265	4107731	1991-05-05	1991-05-05 00:00:00	38000275	0	\N	\N	150566	0	180256009	4107731	
26064	2280	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	151691	0	180256009	4107731	
26306	2291	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	152532	0	180256009	4107731	
38397	3376	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	223961	0	180256009	4107731	
26729	2339	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	155695	0	180256009	4107731	
26792	2343	4043071	1966-05-10	1966-05-10 00:00:00	38000275	0	\N	\N	156008	0	228557008	4043071	
27023	2357	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	157024	0	180256009	4107731	
27139	2369	4107731	1994-07-10	1994-07-10 00:00:00	38000275	0	\N	\N	157678	0	180256009	4107731	
27436	2392	4035793	1992-04-17	1992-04-17 00:00:00	38000275	0	\N	\N	158993	0	15081005	4035793	
15683	1387	4043071	1983-12-11	1983-12-11 00:00:00	38000275	0	\N	\N	92065	0	228557008	4043071	
27804	2436	4107731	1991-06-15	1991-06-15 00:00:00	38000275	0	\N	\N	161524	0	180256009	4107731	
27982	2462	4107731	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	163288	0	180256009	4107731	
28072	2469	4151422	1993-04-08	1993-04-08 00:00:00	38000275	0	\N	\N	163756	0	269911007	4151422	
40228	3528	4107731	1991-08-12	1991-08-12 00:00:00	38000275	0	\N	\N	234171	0	180256009	4107731	
28499	2537	4107731	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	167776	0	180256009	4107731	
40613	3566	4107731	1992-02-17	1992-02-17 00:00:00	38000275	0	\N	\N	236900	0	180256009	4107731	
28950	2559	4107731	1991-05-04	1991-05-04 00:00:00	38000275	0	\N	\N	169550	0	180256009	4107731	
17153	1482	4107731	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	98913	0	180256009	4107731	
29277	2596	4163872	1980-10-21	1980-10-21 00:00:00	38000275	0	\N	\N	171812	0	399208008	4163872	
29402	2624	4326177	1996-12-27	1996-12-27 00:00:00	38000275	0	\N	\N	173602	0	430193006	4326177	
41617	3651	4170947	1973-02-14	1973-02-14 00:00:00	38000275	0	\N	\N	243043	0	274474001	4170947	
41758	3678	4024289	2009-10-30	2009-10-30 00:00:00	38000275	0	\N	\N	244602	0	19490002	4024289	
30086	2661	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	176331	0	395142003	4191853	
30247	2673	4107731	1990-07-09	1990-07-09 00:00:00	38000275	0	\N	\N	177098	0	180256009	4107731	
42268	3733	4295880	1996-04-23	1996-04-23 00:00:00	38000275	0	\N	\N	248062	0	76601001	4295880	
18698	1600	4195803	2013-09-01	2013-09-01 00:00:00	38000275	0	\N	\N	107367	0	312681000	4195803	
30751	2715	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	180025	0	180256009	4107731	
30944	2749	4125906	2007-10-13	2007-10-13 00:00:00	38000275	0	\N	\N	181829	0	288086009	4125906	
31222	2767	4326177	1951-04-05	1951-04-05 00:00:00	38000275	0	\N	\N	183068	0	430193006	4326177	
19435	1659	4043071	1982-10-11	1982-10-11 00:00:00	38000275	0	\N	\N	111577	0	228557008	4043071	
31498	2778	4151422	1978-07-17	1978-07-17 00:00:00	38000275	0	\N	\N	184005	0	269911007	4151422	
43573	3857	4151422	1997-03-22	1997-03-22 00:00:00	38000275	0	\N	\N	256005	0	269911007	4151422	
43843	3874	4107731	1997-04-16	1997-04-16 00:00:00	38000275	0	\N	\N	257317	0	180256009	4107731	
32049	2822	4125906	1983-07-06	1983-07-06 00:00:00	38000275	0	\N	\N	187030	0	288086009	4125906	
20312	1759	4295880	2005-11-21	2005-11-21 00:00:00	38000275	0	\N	\N	117580	0	76601001	4295880	
44480	3906	4195803	2012-10-31	2012-10-31 00:00:00	38000275	0	\N	\N	259712	0	312681000	4195803	
44589	3913	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	260117	0	180256009	4107731	
44819	3930	4125906	1917-05-20	1917-05-20 00:00:00	38000275	0	\N	\N	261307	0	288086009	4125906	
33010	2896	4107731	1990-09-16	1990-09-16 00:00:00	38000275	0	\N	\N	192843	0	180256009	4107731	
21286	1845	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	123313	0	180256009	4107731	
33308	2915	4107731	1991-02-10	1991-02-10 00:00:00	38000275	0	\N	\N	194319	0	180256009	4107731	
57425	4976	4047491	1917-08-16	1917-08-16 00:00:00	38000275	0	\N	\N	331100	0	1225002	4047491	
33754	2942	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	196077	0	180256009	4107731	
33987	2959	4043071	1979-10-03	1979-10-03 00:00:00	38000275	0	\N	\N	197553	0	228557008	4043071	
34114	2966	4107731	1990-01-27	1990-01-27 00:00:00	38000275	0	\N	\N	198077	0	180256009	4107731	
22393	1960	4010253	1979-10-08	1979-10-08 00:00:00	38000275	0	\N	\N	130340	0	112790001	4010253	
34412	2980	4107731	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	198919	0	180256009	4107731	
34782	3025	4107731	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	201590	0	180256009	4107731	
34866	3030	4024289	1986-05-24	1986-05-24 00:00:00	38000275	0	\N	\N	202021	0	19490002	4024289	
47116	4139	4252419	2006-06-30	2006-06-30 00:00:00	38000275	0	\N	\N	275167	0	74016001	4252419	
35266	3076	4293740	1978-04-21	1978-04-21 00:00:00	38000275	0	\N	\N	204643	0	384700001	4293740	
35486	3109	4043071	1927-08-31	1927-08-31 00:00:00	38000275	0	\N	\N	206727	0	228557008	4043071	
35611	3118	4107731	1991-06-09	1991-06-09 00:00:00	38000275	0	\N	\N	207472	0	180256009	4107731	
35718	3128	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	208183	0	180256009	4107731	
12079	1102	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	72446	0	180256009	4107731	
24261	2123	4151422	1967-01-24	1967-01-24 00:00:00	38000275	0	\N	\N	141295	0	269911007	4151422	
24375	2135	4107731	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	142185	0	180256009	4107731	
36491	3207	4043071	1973-03-22	1973-03-22 00:00:00	38000275	0	\N	\N	213159	0	228557008	4043071	
36686	3221	4043071	1971-10-16	1971-10-16 00:00:00	38000275	0	\N	\N	214091	0	228557008	4043071	
24914	2175	4107731	2012-07-31	2012-07-31 00:00:00	38000275	0	\N	\N	145048	0	180256009	4107731	
25179	2189	4107731	2010-07-14	2010-07-14 00:00:00	38000275	0	\N	\N	145907	0	180256009	4107731	
25375	2210	4125906	1966-07-11	1966-07-11 00:00:00	38000275	0	\N	\N	147197	0	288086009	4125906	
25594	2238	4107731	1990-06-17	1990-06-17 00:00:00	38000275	0	\N	\N	148939	0	180256009	4107731	
25789	2265	4107731	1990-06-24	1990-06-24 00:00:00	38000275	0	\N	\N	150562	0	180256009	4107731	
25822	2265	4107731	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	150556	0	180256009	4107731	
26065	2280	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	151666	0	180256009	4107731	
26307	2291	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	152464	0	180256009	4107731	
38398	3376	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	224019	0	180256009	4107731	
26730	2339	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	155690	0	180256009	4107731	
26793	2343	4043071	1966-06-07	1966-06-07 00:00:00	38000275	0	\N	\N	156002	0	228557008	4043071	
27024	2357	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	157047	0	180256009	4107731	
27140	2369	4107731	1996-11-17	1996-11-17 00:00:00	38000275	0	\N	\N	157704	0	180256009	4107731	
27437	2392	4078793	2005-07-01	2005-07-01 00:00:00	38000275	0	\N	\N	158996	0	180325003	4078793	
15684	1387	4043071	1982-04-11	1982-04-11 00:00:00	38000275	0	\N	\N	91993	0	228557008	4043071	
27805	2436	4107731	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	161527	0	180256009	4107731	
27983	2462	4107731	1991-09-29	1991-09-29 00:00:00	38000275	0	\N	\N	163294	0	180256009	4107731	
28073	2469	4243062	1979-09-18	1979-09-18 00:00:00	38000275	0	\N	\N	163710	0	60027007	4243062	
40229	3528	4107731	1992-11-16	1992-11-16 00:00:00	38000275	0	\N	\N	234147	0	180256009	4107731	
28500	2537	4107731	1990-08-05	1990-08-05 00:00:00	38000275	0	\N	\N	167695	0	180256009	4107731	
40614	3566	4107731	1991-04-08	1991-04-08 00:00:00	38000275	0	\N	\N	236896	0	180256009	4107731	
28951	2559	4107731	1992-01-11	1992-01-11 00:00:00	38000275	0	\N	\N	169607	0	180256009	4107731	
17154	1482	4107731	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	98899	0	180256009	4107731	
29278	2596	4243062	1974-04-11	1974-04-11 00:00:00	38000275	0	\N	\N	171817	0	60027007	4243062	
29403	2624	4037675	1996-12-27	1996-12-27 00:00:00	38000275	0	\N	\N	173602	0	162676008	4037675	
41618	3651	4047491	1973-02-14	1973-02-14 00:00:00	38000275	0	\N	\N	243043	0	1225002	4047491	
41759	3678	4163872	2018-03-17	2018-03-17 00:00:00	38000275	0	\N	\N	244603	0	399208008	4163872	
30087	2661	4197460	1976-06-10	1976-06-10 00:00:00	38000275	0	\N	\N	176282	0	313191000	4197460	
30248	2673	4107731	1992-01-06	1992-01-06 00:00:00	38000275	0	\N	\N	177090	0	180256009	4107731	
42269	3733	4295880	1995-04-25	1995-04-25 00:00:00	38000275	0	\N	\N	248049	0	76601001	4295880	
18699	1600	4163872	2013-09-01	2013-09-01 00:00:00	38000275	0	\N	\N	107367	0	399208008	4163872	
30752	2715	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	179973	0	180256009	4107731	
30945	2749	4125906	1983-05-31	1983-05-31 00:00:00	38000275	0	\N	\N	181849	0	288086009	4125906	
31223	2767	4187458	1951-04-05	1951-04-05 00:00:00	38000275	0	\N	\N	183068	0	415300000	4187458	
19436	1659	4043071	1977-08-22	1977-08-22 00:00:00	38000275	0	\N	\N	111556	0	228557008	4043071	
31499	2778	4107731	1991-11-30	1991-11-30 00:00:00	38000275	0	\N	\N	183989	0	180256009	4107731	
43574	3857	4035793	2006-08-22	2006-08-22 00:00:00	38000275	0	\N	\N	255990	0	15081005	4035793	
43844	3874	4107731	1997-07-30	1997-07-30 00:00:00	38000275	0	\N	\N	257262	0	180256009	4107731	
32050	2822	4293740	1983-07-06	1983-07-06 00:00:00	38000275	0	\N	\N	187030	0	384700001	4293740	
20313	1759	4295880	2009-02-16	2009-02-16 00:00:00	38000275	0	\N	\N	117614	0	76601001	4295880	
44481	3906	4024289	2011-04-02	2011-04-02 00:00:00	38000275	0	\N	\N	259730	0	19490002	4024289	
44590	3913	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	260166	0	180256009	4107731	
44820	3930	4035793	1978-08-26	1978-08-26 00:00:00	38000275	0	\N	\N	261295	0	15081005	4035793	
33011	2896	4107731	1990-04-01	1990-04-01 00:00:00	38000275	0	\N	\N	192871	0	180256009	4107731	
21287	1845	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	123299	0	180256009	4107731	
33309	2915	4107731	1992-08-09	1992-08-09 00:00:00	38000275	0	\N	\N	194238	0	180256009	4107731	
57426	4976	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	331012	0	180256009	4107731	
33755	2942	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	196104	0	180256009	4107731	
33988	2959	4043071	1979-11-07	1979-11-07 00:00:00	38000275	0	\N	\N	197554	0	228557008	4043071	
34115	2966	4107731	1993-05-29	1993-05-29 00:00:00	38000275	0	\N	\N	198141	0	180256009	4107731	
22396	1962	4151422	2019-01-22	2019-01-22 00:00:00	38000275	0	\N	\N	130502	0	269911007	4151422	
34413	2980	4107731	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	199016	0	180256009	4107731	
46564	4085	4043071	1967-05-07	1967-05-07 00:00:00	38000275	0	\N	\N	271485	0	228557008	4043071	
34867	3030	4170947	1986-05-24	1986-05-24 00:00:00	38000275	0	\N	\N	202021	0	274474001	4170947	
47117	4139	4024289	1994-11-30	1994-11-30 00:00:00	38000275	0	\N	\N	275166	0	19490002	4024289	
35267	3076	4125906	1978-04-21	1978-04-21 00:00:00	38000275	0	\N	\N	204643	0	288086009	4125906	
35487	3109	4043071	1925-07-08	1925-07-08 00:00:00	38000275	0	\N	\N	206709	0	228557008	4043071	
35612	3118	4125906	1956-07-26	1956-07-26 00:00:00	38000275	0	\N	\N	207401	0	288086009	4125906	
35719	3128	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	208114	0	180256009	4107731	
12080	1102	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	72450	0	180256009	4107731	
24262	2123	4252419	1994-10-21	1994-10-21 00:00:00	38000275	0	\N	\N	141319	0	74016001	4252419	
24376	2135	4107731	1990-08-20	1990-08-20 00:00:00	38000275	0	\N	\N	142130	0	180256009	4107731	
36492	3207	4043071	1974-01-17	1974-01-17 00:00:00	38000275	0	\N	\N	213193	0	228557008	4043071	
36687	3221	4043071	1971-12-11	1971-12-11 00:00:00	38000275	0	\N	\N	214068	0	228557008	4043071	
24915	2175	4107731	2010-11-30	2010-11-30 00:00:00	38000275	0	\N	\N	144960	0	180256009	4107731	
25180	2189	4107731	2013-04-17	2013-04-17 00:00:00	38000275	0	\N	\N	145932	0	180256009	4107731	
25376	2210	4125906	2014-12-22	2014-12-22 00:00:00	38000275	0	\N	\N	147201	0	288086009	4125906	
25595	2238	4107731	1992-08-23	1992-08-23 00:00:00	38000275	0	\N	\N	148963	0	180256009	4107731	
25790	2265	4107731	1992-11-01	1992-11-01 00:00:00	38000275	0	\N	\N	150519	0	180256009	4107731	
25823	2265	4107731	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	150617	0	180256009	4107731	
26066	2280	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	151665	0	180256009	4107731	
26308	2291	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	152457	0	180256009	4107731	
38399	3376	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	223997	0	180256009	4107731	
26731	2339	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	155680	0	180256009	4107731	
26794	2343	4043071	1966-07-12	1966-07-12 00:00:00	38000275	0	\N	\N	156003	0	228557008	4043071	
27025	2357	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	157014	0	180256009	4107731	
27141	2369	4191853	1997-11-09	1997-11-09 00:00:00	38000275	0	\N	\N	157655	0	395142003	4191853	
27438	2392	4035793	2005-07-01	2005-07-01 00:00:00	38000275	0	\N	\N	158996	0	15081005	4035793	
15685	1387	4043071	1982-12-12	1982-12-12 00:00:00	38000275	0	\N	\N	92000	0	228557008	4043071	
27806	2436	4107731	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	161529	0	180256009	4107731	
27984	2462	4107731	1992-08-09	1992-08-09 00:00:00	38000275	0	\N	\N	163218	0	180256009	4107731	
28074	2469	4170947	1979-09-18	1979-09-18 00:00:00	38000275	0	\N	\N	163710	0	274474001	4170947	
40230	3528	4181917	1960-02-29	1960-02-29 00:00:00	38000275	0	\N	\N	234249	0	54550000	4181917	
28501	2537	4107731	1992-04-26	1992-04-26 00:00:00	38000275	0	\N	\N	167774	0	180256009	4107731	
40615	3566	4125906	1957-03-21	1957-03-21 00:00:00	38000275	0	\N	\N	236949	0	288086009	4125906	
28952	2559	4107731	1992-11-21	1992-11-21 00:00:00	38000275	0	\N	\N	169611	0	180256009	4107731	
17155	1482	4107731	1992-04-04	1992-04-04 00:00:00	38000275	0	\N	\N	98871	0	180256009	4107731	
29279	2596	4170947	1974-04-11	1974-04-11 00:00:00	38000275	0	\N	\N	171817	0	274474001	4170947	
29404	2624	4187458	1996-12-27	1996-12-27 00:00:00	38000275	0	\N	\N	173602	0	415300000	4187458	
41619	3652	4151422	2015-03-04	2015-03-04 00:00:00	38000275	0	\N	\N	243129	0	269911007	4151422	
41760	3678	4170947	2018-03-17	2018-03-17 00:00:00	38000275	0	\N	\N	244603	0	274474001	4170947	
30088	2661	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	176325	0	180256009	4107731	
30249	2673	4107731	1991-02-25	1991-02-25 00:00:00	38000275	0	\N	\N	177086	0	180256009	4107731	
42270	3733	4295880	1994-07-26	1994-07-26 00:00:00	38000275	0	\N	\N	248031	0	76601001	4295880	
18700	1600	4170947	2013-09-01	2013-09-01 00:00:00	38000275	0	\N	\N	107367	0	274474001	4170947	
30753	2715	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	180097	0	180256009	4107731	
30946	2750	4024289	1926-10-29	1926-10-29 00:00:00	38000275	0	\N	\N	181870	0	19490002	4024289	
31224	2767	4037675	1951-04-05	1951-04-05 00:00:00	38000275	0	\N	\N	183068	0	162676008	4037675	
19437	1659	4043071	1976-05-17	1976-05-17 00:00:00	38000275	0	\N	\N	111509	0	228557008	4043071	
31500	2778	4107731	1992-02-01	1992-02-01 00:00:00	38000275	0	\N	\N	184062	0	180256009	4107731	
43633	3859	4035793	2006-09-30	2006-09-30 00:00:00	38000275	0	\N	\N	256258	0	15081005	4035793	
43845	3874	4107731	1995-05-24	1995-05-24 00:00:00	38000275	0	\N	\N	257310	0	180256009	4107731	
32123	2825	4151422	1970-04-30	1970-04-30 00:00:00	38000275	0	\N	\N	187229	0	269911007	4151422	
20314	1759	4295880	2006-11-20	2006-11-20 00:00:00	38000275	0	\N	\N	117611	0	76601001	4295880	
44482	3906	4170947	2011-04-02	2011-04-02 00:00:00	38000275	0	\N	\N	259730	0	274474001	4170947	
44591	3913	4191853	1981-11-09	1981-11-09 00:00:00	38000275	0	\N	\N	260154	0	395142003	4191853	
44821	3930	4337138	1972-10-07	1972-10-07 00:00:00	38000275	0	\N	\N	261310	0	88039007	4337138	
33012	2896	4107731	1991-09-08	1991-09-08 00:00:00	38000275	0	\N	\N	192795	0	180256009	4107731	
21288	1845	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	123319	0	180256009	4107731	
33310	2915	4107731	1993-05-09	1993-05-09 00:00:00	38000275	0	\N	\N	194241	0	180256009	4107731	
57427	4976	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	330980	0	180256009	4107731	
33756	2942	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	196080	0	180256009	4107731	
33989	2959	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	197454	0	180256009	4107731	
34116	2966	4107731	1990-11-17	1990-11-17 00:00:00	38000275	0	\N	\N	198092	0	180256009	4107731	
22397	1962	4125906	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	130479	0	288086009	4125906	
34414	2980	4107731	1990-08-05	1990-08-05 00:00:00	38000275	0	\N	\N	198963	0	180256009	4107731	
46565	4085	4043071	1968-02-11	1968-02-11 00:00:00	38000275	0	\N	\N	271487	0	228557008	4043071	
34871	3035	4202451	2014-09-12	2014-09-12 00:00:00	38000275	0	\N	\N	202232	0	433112001	4202451	
47118	4139	4170947	1994-11-30	1994-11-30 00:00:00	38000275	0	\N	\N	275166	0	274474001	4170947	
35268	3076	4293740	2004-09-18	2004-09-18 00:00:00	38000275	0	\N	\N	204646	0	384700001	4293740	
35488	3109	4043071	1925-08-12	1925-08-12 00:00:00	38000275	0	\N	\N	206798	0	228557008	4043071	
35613	3118	4293740	1956-07-26	1956-07-26 00:00:00	38000275	0	\N	\N	207401	0	384700001	4293740	
35720	3128	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	208216	0	180256009	4107731	
12081	1102	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	72425	0	180256009	4107731	
24263	2123	4024289	1959-05-30	1959-05-30 00:00:00	38000275	0	\N	\N	141317	0	19490002	4024289	
24377	2135	4107731	1992-10-05	1992-10-05 00:00:00	38000275	0	\N	\N	142140	0	180256009	4107731	
36493	3207	4043071	1974-02-21	1974-02-21 00:00:00	38000275	0	\N	\N	213194	0	228557008	4043071	
36688	3221	4163872	1967-09-09	1967-09-09 00:00:00	38000275	0	\N	\N	214061	0	399208008	4163872	
24916	2175	4107731	2011-04-05	2011-04-05 00:00:00	38000275	0	\N	\N	144967	0	180256009	4107731	
25181	2189	4107731	2012-02-01	2012-02-01 00:00:00	38000275	0	\N	\N	145991	0	180256009	4107731	
25377	2210	4293740	2014-12-22	2014-12-22 00:00:00	38000275	0	\N	\N	147201	0	384700001	4293740	
25596	2238	4107731	1991-04-28	1991-04-28 00:00:00	38000275	0	\N	\N	148943	0	180256009	4107731	
25791	2265	4107731	1990-04-22	1990-04-22 00:00:00	38000275	0	\N	\N	150551	0	180256009	4107731	
25824	2265	4107731	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	150615	0	180256009	4107731	
26067	2280	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	151668	0	180256009	4107731	
26309	2291	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	152560	0	180256009	4107731	
38400	3376	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	224067	0	180256009	4107731	
26732	2339	4197460	1983-05-27	1983-05-27 00:00:00	38000275	0	\N	\N	155677	0	313191000	4197460	
26795	2343	4043071	1966-09-20	1966-09-20 00:00:00	38000275	0	\N	\N	155970	0	228557008	4043071	
27026	2357	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	157025	0	180256009	4107731	
27142	2369	4107731	1996-04-21	1996-04-21 00:00:00	38000275	0	\N	\N	157639	0	180256009	4107731	
27439	2394	4163872	1956-04-19	1956-04-19 00:00:00	38000275	0	\N	\N	159149	0	399208008	4163872	
15686	1387	4043071	1985-07-28	1985-07-28 00:00:00	38000275	0	\N	\N	92087	0	228557008	4043071	
27807	2436	4107731	1990-03-10	1990-03-10 00:00:00	38000275	0	\N	\N	161520	0	180256009	4107731	
27985	2462	4151422	1989-09-19	1989-09-19 00:00:00	38000275	0	\N	\N	163233	0	269911007	4151422	
28075	2470	4151422	2014-01-20	2014-01-20 00:00:00	38000275	0	\N	\N	163780	0	269911007	4151422	
40231	3528	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	234238	0	180256009	4107731	
28502	2537	4107731	1990-08-26	1990-08-26 00:00:00	38000275	0	\N	\N	167599	0	180256009	4107731	
40616	3566	4107731	1991-04-29	1991-04-29 00:00:00	38000275	0	\N	\N	236836	0	180256009	4107731	
28953	2559	4107731	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	169578	0	180256009	4107731	
17156	1482	4107731	1990-01-27	1990-01-27 00:00:00	38000275	0	\N	\N	98876	0	180256009	4107731	
29280	2596	4195803	1974-04-11	1974-04-11 00:00:00	38000275	0	\N	\N	171817	0	312681000	4195803	
29405	2624	4043071	1976-01-08	1976-01-08 00:00:00	38000275	0	\N	\N	173538	0	228557008	4043071	
41620	3652	4117038	1999-07-12	1999-07-12 00:00:00	38000275	0	\N	\N	243113	0	287664005	4117038	
41764	3680	4107731	1993-01-05	1993-01-05 00:00:00	38000275	0	\N	\N	244683	0	180256009	4107731	
30089	2661	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	176329	0	180256009	4107731	
30250	2673	4107731	1990-05-07	1990-05-07 00:00:00	38000275	0	\N	\N	177077	0	180256009	4107731	
42271	3733	4295880	1993-01-26	1993-01-26 00:00:00	38000275	0	\N	\N	248029	0	76601001	4295880	
30550	2702	4151422	2000-02-20	2000-02-20 00:00:00	38000275	0	\N	\N	178936	0	269911007	4151422	
30754	2715	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	180011	0	180256009	4107731	
30947	2750	4170947	1926-10-29	1926-10-29 00:00:00	38000275	0	\N	\N	181870	0	274474001	4170947	
31225	2768	4293740	1972-07-24	1972-07-24 00:00:00	38000275	0	\N	\N	183162	0	384700001	4293740	
19438	1659	4043071	1979-02-05	1979-02-05 00:00:00	38000275	0	\N	\N	111442	0	228557008	4043071	
31501	2778	4107731	1993-04-17	1993-04-17 00:00:00	38000275	0	\N	\N	183974	0	180256009	4107731	
43634	3859	4035793	2012-11-03	2012-11-03 00:00:00	38000275	0	\N	\N	256279	0	15081005	4035793	
43846	3874	4107731	1997-07-09	1997-07-09 00:00:00	38000275	0	\N	\N	257253	0	180256009	4107731	
32124	2825	4125906	1975-09-08	1975-09-08 00:00:00	38000275	0	\N	\N	187331	0	288086009	4125906	
20315	1759	4295880	2006-05-22	2006-05-22 00:00:00	38000275	0	\N	\N	117583	0	76601001	4295880	
44483	3906	4195803	2011-04-02	2011-04-02 00:00:00	38000275	0	\N	\N	259730	0	312681000	4195803	
44592	3913	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	260177	0	180256009	4107731	
44822	3930	4035793	1977-08-20	1977-08-20 00:00:00	38000275	0	\N	\N	261256	0	15081005	4035793	
33013	2896	4107731	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	192816	0	180256009	4107731	
21289	1845	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	123348	0	180256009	4107731	
33311	2915	4107731	1990-06-24	1990-06-24 00:00:00	38000275	0	\N	\N	194295	0	180256009	4107731	
57428	4976	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	330925	0	180256009	4107731	
33757	2942	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	196158	0	180256009	4107731	
33990	2959	4197460	1972-05-15	1972-05-15 00:00:00	38000275	0	\N	\N	197601	0	313191000	4197460	
34117	2966	4107731	1990-02-17	1990-02-17 00:00:00	38000275	0	\N	\N	198089	0	180256009	4107731	
22398	1962	4170947	2005-03-28	2005-03-28 00:00:00	38000275	0	\N	\N	130481	0	274474001	4170947	
34415	2980	4107731	1990-12-09	1990-12-09 00:00:00	38000275	0	\N	\N	199009	0	180256009	4107731	
46566	4085	4043071	1969-04-13	1969-04-13 00:00:00	38000275	0	\N	\N	271492	0	228557008	4043071	
34872	3035	4151422	1999-09-21	1999-09-21 00:00:00	38000275	0	\N	\N	202212	0	269911007	4151422	
47119	4139	4170947	2010-08-22	2010-08-22 00:00:00	38000275	0	\N	\N	275164	0	274474001	4170947	
35269	3076	4125906	2004-09-18	2004-09-18 00:00:00	38000275	0	\N	\N	204646	0	288086009	4125906	
35489	3109	4043071	1929-08-21	1929-08-21 00:00:00	38000275	0	\N	\N	206767	0	228557008	4043071	
35614	3118	4107731	1992-01-26	1992-01-26 00:00:00	38000275	0	\N	\N	207474	0	180256009	4107731	
35721	3128	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	208113	0	180256009	4107731	
12082	1102	4252419	2003-02-14	2003-02-14 00:00:00	38000275	0	\N	\N	72428	0	74016001	4252419	
24264	2123	4170947	1959-05-30	1959-05-30 00:00:00	38000275	0	\N	\N	141317	0	274474001	4170947	
24378	2135	4243062	1957-08-18	1957-08-18 00:00:00	38000275	0	\N	\N	142099	0	60027007	4243062	
36494	3207	4043071	1975-01-02	1975-01-02 00:00:00	38000275	0	\N	\N	213207	0	228557008	4043071	
36689	3221	4043071	1970-09-05	1970-09-05 00:00:00	38000275	0	\N	\N	214080	0	228557008	4043071	
24917	2175	4107731	2012-07-10	2012-07-10 00:00:00	38000275	0	\N	\N	144985	0	180256009	4107731	
25182	2189	4107731	2011-07-06	2011-07-06 00:00:00	38000275	0	\N	\N	145938	0	180256009	4107731	
25378	2210	4170947	1943-08-20	1943-08-20 00:00:00	38000275	0	\N	\N	147195	0	274474001	4170947	
25597	2238	4107731	1992-03-29	1992-03-29 00:00:00	38000275	0	\N	\N	148917	0	180256009	4107731	
25792	2265	4107731	1992-05-17	1992-05-17 00:00:00	38000275	0	\N	\N	150575	0	180256009	4107731	
25825	2265	4107731	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	150592	0	180256009	4107731	
26068	2280	4252419	1997-04-08	1997-04-08 00:00:00	38000275	0	\N	\N	151558	0	74016001	4252419	
26310	2291	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	152461	0	180256009	4107731	
38401	3376	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	223958	0	180256009	4107731	
26733	2339	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	155664	0	180256009	4107731	
26796	2343	4043071	1966-08-16	1966-08-16 00:00:00	38000275	0	\N	\N	155948	0	228557008	4043071	
27027	2357	4107731	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	156937	0	180256009	4107731	
27143	2369	4107731	1997-07-27	1997-07-27 00:00:00	38000275	0	\N	\N	157719	0	180256009	4107731	
27440	2394	4151422	1914-08-14	1914-08-14 00:00:00	38000275	0	\N	\N	159120	0	269911007	4151422	
15687	1387	4043071	1984-03-18	1984-03-18 00:00:00	38000275	0	\N	\N	92070	0	228557008	4043071	
27808	2436	4107731	1991-03-23	1991-03-23 00:00:00	38000275	0	\N	\N	161507	0	180256009	4107731	
27986	2462	4107731	1991-10-20	1991-10-20 00:00:00	38000275	0	\N	\N	163261	0	180256009	4107731	
28076	2470	4125906	2015-08-07	2015-08-07 00:00:00	38000275	0	\N	\N	163797	0	288086009	4125906	
40232	3528	4107731	1991-01-14	1991-01-14 00:00:00	38000275	0	\N	\N	234182	0	180256009	4107731	
28503	2537	4107731	1990-04-22	1990-04-22 00:00:00	38000275	0	\N	\N	167719	0	180256009	4107731	
40617	3566	4107731	1991-12-16	1991-12-16 00:00:00	38000275	0	\N	\N	236962	0	180256009	4107731	
28954	2559	4107731	1993-01-02	1993-01-02 00:00:00	38000275	0	\N	\N	169612	0	180256009	4107731	
17157	1482	4107731	1992-04-25	1992-04-25 00:00:00	38000275	0	\N	\N	98885	0	180256009	4107731	
29281	2596	4151422	1988-12-07	1988-12-07 00:00:00	38000275	0	\N	\N	171813	0	269911007	4151422	
29406	2624	4043071	1975-03-27	1975-03-27 00:00:00	38000275	0	\N	\N	173579	0	228557008	4043071	
41621	3654	4125906	1973-05-23	1973-05-23 00:00:00	38000275	0	\N	\N	243222	0	288086009	4125906	
41765	3680	4107731	1992-11-03	1992-11-03 00:00:00	38000275	0	\N	\N	244749	0	180256009	4107731	
30090	2661	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	176287	0	180256009	4107731	
30251	2673	4107731	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	177150	0	180256009	4107731	
42272	3733	4295880	1995-07-25	1995-07-25 00:00:00	38000275	0	\N	\N	248081	0	76601001	4295880	
30551	2702	4125906	1947-04-10	1947-04-10 00:00:00	38000275	0	\N	\N	179039	0	288086009	4125906	
30755	2715	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	180001	0	180256009	4107731	
30948	2750	4125906	1949-05-01	1949-05-01 00:00:00	38000275	0	\N	\N	181871	0	288086009	4125906	
31226	2768	4125906	1972-07-24	1972-07-24 00:00:00	38000275	0	\N	\N	183162	0	288086009	4125906	
19439	1659	4043071	1983-06-27	1983-06-27 00:00:00	38000275	0	\N	\N	111472	0	228557008	4043071	
31502	2778	4107731	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	183991	0	180256009	4107731	
43635	3859	4035793	2004-09-18	2004-09-18 00:00:00	38000275	0	\N	\N	256240	0	15081005	4035793	
43847	3874	4107731	1995-09-06	1995-09-06 00:00:00	38000275	0	\N	\N	257241	0	180256009	4107731	
32125	2825	4195803	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	187332	0	312681000	4195803	
20316	1759	4295880	2007-11-19	2007-11-19 00:00:00	38000275	0	\N	\N	117585	0	76601001	4295880	
44484	3909	4151422	2012-12-23	2012-12-23 00:00:00	38000275	0	\N	\N	259855	0	269911007	4151422	
44593	3913	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	260090	0	180256009	4107731	
44823	3930	4035793	1974-08-03	1974-08-03 00:00:00	38000275	0	\N	\N	261272	0	15081005	4035793	
33014	2896	4107731	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	192854	0	180256009	4107731	
21290	1845	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	123292	0	180256009	4107731	
33312	2915	4107731	1991-12-22	1991-12-22 00:00:00	38000275	0	\N	\N	194323	0	180256009	4107731	
57429	4976	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	331005	0	180256009	4107731	
33758	2942	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	196174	0	180256009	4107731	
33991	2959	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	197490	0	180256009	4107731	
34118	2966	4107731	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	198161	0	180256009	4107731	
22399	1962	4047491	2005-03-28	2005-03-28 00:00:00	38000275	0	\N	\N	130481	0	1225002	4047491	
34416	2980	4107731	1992-04-26	1992-04-26 00:00:00	38000275	0	\N	\N	199014	0	180256009	4107731	
46567	4085	4043071	1968-12-01	1968-12-01 00:00:00	38000275	0	\N	\N	271469	0	228557008	4043071	
34873	3035	4125906	1978-02-25	1978-02-25 00:00:00	38000275	0	\N	\N	202172	0	288086009	4125906	
47120	4139	4047491	2010-08-22	2010-08-22 00:00:00	38000275	0	\N	\N	275164	0	1225002	4047491	
35270	3076	4151422	1983-06-05	1983-06-05 00:00:00	38000275	0	\N	\N	204659	0	269911007	4151422	
35490	3109	4043071	1927-01-19	1927-01-19 00:00:00	38000275	0	\N	\N	206806	0	228557008	4043071	
35615	3118	4107731	1992-02-16	1992-02-16 00:00:00	38000275	0	\N	\N	207515	0	180256009	4107731	
35722	3128	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	208220	0	180256009	4107731	
12083	1102	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	72406	0	180256009	4107731	
24265	2123	4151422	1980-03-30	1980-03-30 00:00:00	38000275	0	\N	\N	141307	0	269911007	4151422	
24379	2135	4170947	1957-08-18	1957-08-18 00:00:00	38000275	0	\N	\N	142099	0	274474001	4170947	
36495	3207	4043071	1973-07-19	1973-07-19 00:00:00	38000275	0	\N	\N	213160	0	228557008	4043071	
36690	3221	4163872	1966-03-17	1966-03-17 00:00:00	38000275	0	\N	\N	214130	0	399208008	4163872	
24918	2175	4107731	2010-11-09	2010-11-09 00:00:00	38000275	0	\N	\N	145059	0	180256009	4107731	
25183	2190	4125906	1988-01-08	1988-01-08 00:00:00	38000275	0	\N	\N	146081	0	288086009	4125906	
25379	2210	4024289	1943-08-20	1943-08-20 00:00:00	38000275	0	\N	\N	147195	0	19490002	4024289	
25598	2238	4107731	1990-09-30	1990-09-30 00:00:00	38000275	0	\N	\N	148983	0	180256009	4107731	
25793	2265	4107731	1990-02-18	1990-02-18 00:00:00	38000275	0	\N	\N	150518	0	180256009	4107731	
25826	2265	4107731	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	150506	0	180256009	4107731	
26069	2280	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	151669	0	180256009	4107731	
26311	2291	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	152527	0	180256009	4107731	
38402	3376	4163872	1961-11-11	1961-11-11 00:00:00	38000275	0	\N	\N	224007	0	399208008	4163872	
26734	2339	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	155591	0	180256009	4107731	
26797	2343	4043071	1966-02-08	1966-02-08 00:00:00	38000275	0	\N	\N	156001	0	228557008	4043071	
27028	2357	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	157055	0	180256009	4107731	
27144	2369	4107731	1997-10-19	1997-10-19 00:00:00	38000275	0	\N	\N	157645	0	180256009	4107731	
27441	2394	4163872	1979-10-20	1979-10-20 00:00:00	38000275	0	\N	\N	159214	0	399208008	4163872	
15688	1387	4043071	1982-03-14	1982-03-14 00:00:00	38000275	0	\N	\N	91997	0	228557008	4043071	
27809	2436	4107731	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	161613	0	180256009	4107731	
27987	2462	4107731	1990-12-30	1990-12-30 00:00:00	38000275	0	\N	\N	163225	0	180256009	4107731	
28077	2470	4125906	1962-09-25	1962-09-25 00:00:00	38000275	0	\N	\N	163795	0	288086009	4125906	
40233	3528	4181917	1958-11-03	1958-11-03 00:00:00	38000275	0	\N	\N	234247	0	54550000	4181917	
28504	2537	4181917	1960-08-13	1960-08-13 00:00:00	38000275	0	\N	\N	167646	0	54550000	4181917	
40618	3566	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	236849	0	180256009	4107731	
28955	2559	4107731	1990-08-04	1990-08-04 00:00:00	38000275	0	\N	\N	169547	0	180256009	4107731	
17158	1482	4107731	1991-12-21	1991-12-21 00:00:00	38000275	0	\N	\N	98862	0	180256009	4107731	
29282	2596	4170947	1977-04-25	1977-04-25 00:00:00	38000275	0	\N	\N	171761	0	274474001	4170947	
29407	2624	4125906	1973-08-05	1973-08-05 00:00:00	38000275	0	\N	\N	173623	0	288086009	4125906	
41622	3654	4151422	1977-11-23	1977-11-23 00:00:00	38000275	0	\N	\N	243185	0	269911007	4151422	
41766	3680	4107731	1994-10-18	1994-10-18 00:00:00	38000275	0	\N	\N	244709	0	180256009	4107731	
30091	2661	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	176257	0	180256009	4107731	
30252	2673	4107731	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	177144	0	180256009	4107731	
42273	3733	4295880	1996-01-23	1996-01-23 00:00:00	38000275	0	\N	\N	248032	0	76601001	4295880	
30552	2702	4151422	1978-01-28	1978-01-28 00:00:00	38000275	0	\N	\N	178965	0	269911007	4151422	
30756	2715	4024289	1982-05-15	1982-05-15 00:00:00	38000275	0	\N	\N	179968	0	19490002	4024289	
30949	2750	4151422	2003-01-24	2003-01-24 00:00:00	38000275	0	\N	\N	181958	0	269911007	4151422	
31227	2768	4163872	2002-08-26	2002-08-26 00:00:00	38000275	0	\N	\N	183123	0	399208008	4163872	
19440	1659	4043071	1976-04-19	1976-04-19 00:00:00	38000275	0	\N	\N	111435	0	228557008	4043071	
31503	2778	4107731	1991-09-28	1991-09-28 00:00:00	38000275	0	\N	\N	184035	0	180256009	4107731	
43636	3859	4151422	1926-12-25	1926-12-25 00:00:00	38000275	0	\N	\N	256173	0	269911007	4151422	
43848	3874	4107731	1996-07-17	1996-07-17 00:00:00	38000275	0	\N	\N	257314	0	180256009	4107731	
32126	2825	4163872	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	187332	0	399208008	4163872	
20317	1759	4295880	2007-08-20	2007-08-20 00:00:00	38000275	0	\N	\N	117612	0	76601001	4295880	
44485	3909	4170947	2011-02-27	2011-02-27 00:00:00	38000275	0	\N	\N	259843	0	274474001	4170947	
44594	3913	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	260175	0	180256009	4107731	
44824	3930	4216130	1979-12-29	1979-12-29 00:00:00	38000275	0	\N	\N	261309	0	415070008	4216130	
33015	2896	4107731	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	192817	0	180256009	4107731	
21291	1845	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	123316	0	180256009	4107731	
33313	2915	4107731	1990-10-07	1990-10-07 00:00:00	38000275	0	\N	\N	194259	0	180256009	4107731	
57430	4976	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	331095	0	180256009	4107731	
33759	2942	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	196103	0	180256009	4107731	
33992	2959	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	197457	0	180256009	4107731	
34119	2966	4107731	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	198126	0	180256009	4107731	
22400	1962	4125906	1979-06-03	1979-06-03 00:00:00	38000275	0	\N	\N	130477	0	288086009	4125906	
34417	2980	4107731	1992-08-09	1992-08-09 00:00:00	38000275	0	\N	\N	198955	0	180256009	4107731	
46568	4085	4043071	1967-10-08	1967-10-08 00:00:00	38000275	0	\N	\N	271486	0	228557008	4043071	
34874	3035	4170947	1968-05-27	1968-05-27 00:00:00	38000275	0	\N	\N	202209	0	274474001	4170947	
58967	5116	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	339984	0	180256009	4107731	
35271	3076	4125906	1997-03-08	1997-03-08 00:00:00	38000275	0	\N	\N	204645	0	288086009	4125906	
35491	3109	4043071	1927-06-29	1927-06-29 00:00:00	38000275	0	\N	\N	206808	0	228557008	4043071	
35616	3118	4107731	1990-07-29	1990-07-29 00:00:00	38000275	0	\N	\N	207468	0	180256009	4107731	
35723	3128	4107731	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	208218	0	180256009	4107731	
12084	1102	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	72449	0	180256009	4107731	
24266	2123	4195803	2009-06-19	2009-06-19 00:00:00	38000275	0	\N	\N	141303	0	312681000	4195803	
24380	2135	4107731	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	142135	0	180256009	4107731	
36496	3207	4043071	1974-11-28	1974-11-28 00:00:00	38000275	0	\N	\N	213196	0	228557008	4043071	
36691	3221	4170947	1966-03-17	1966-03-17 00:00:00	38000275	0	\N	\N	214130	0	274474001	4170947	
24919	2175	4198190	1979-01-29	1979-01-29 00:00:00	38000275	0	\N	\N	144977	0	80146002	4198190	
25184	2190	4195803	2014-09-23	2014-09-23 00:00:00	38000275	0	\N	\N	146083	0	312681000	4195803	
25380	2210	4198190	1969-10-19	1969-10-19 00:00:00	38000275	0	\N	\N	147270	0	80146002	4198190	
25599	2238	4107731	1990-10-21	1990-10-21 00:00:00	38000275	0	\N	\N	148942	0	180256009	4107731	
25794	2265	4107731	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	150609	0	180256009	4107731	
25827	2265	4107731	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	150574	0	180256009	4107731	
26070	2280	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	151664	0	180256009	4107731	
26312	2291	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	152470	0	395142003	4191853	
38403	3376	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	223968	0	180256009	4107731	
26735	2339	4170947	1984-12-17	1984-12-17 00:00:00	38000275	0	\N	\N	155678	0	274474001	4170947	
26798	2343	4043071	1966-10-25	1966-10-25 00:00:00	38000275	0	\N	\N	155971	0	228557008	4043071	
27029	2357	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	156969	0	180256009	4107731	
27145	2369	4107731	1995-03-19	1995-03-19 00:00:00	38000275	0	\N	\N	157691	0	180256009	4107731	
27442	2394	4170947	1979-10-20	1979-10-20 00:00:00	38000275	0	\N	\N	159214	0	274474001	4170947	
15689	1387	4043071	1986-12-28	1986-12-28 00:00:00	38000275	0	\N	\N	92014	0	228557008	4043071	
27810	2436	4107731	1991-07-27	1991-07-27 00:00:00	38000275	0	\N	\N	161545	0	180256009	4107731	
27988	2462	4107731	1992-04-26	1992-04-26 00:00:00	38000275	0	\N	\N	163284	0	180256009	4107731	
28078	2470	4151422	2007-02-26	2007-02-26 00:00:00	38000275	0	\N	\N	163820	0	269911007	4151422	
40234	3528	4107731	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	234169	0	180256009	4107731	
28505	2537	4202451	1998-09-06	1998-09-06 00:00:00	38000275	0	\N	\N	167610	0	433112001	4202451	
40619	3566	4043071	1960-06-27	1960-06-27 00:00:00	38000275	0	\N	\N	236908	0	228557008	4043071	
28956	2559	4107731	1991-07-27	1991-07-27 00:00:00	38000275	0	\N	\N	169590	0	180256009	4107731	
17159	1482	4107731	1993-03-06	1993-03-06 00:00:00	38000275	0	\N	\N	98833	0	180256009	4107731	
29283	2596	4163872	1977-04-25	1977-04-25 00:00:00	38000275	0	\N	\N	171761	0	399208008	4163872	
29408	2624	4043071	1976-02-12	1976-02-12 00:00:00	38000275	0	\N	\N	173546	0	228557008	4043071	
41623	3655	4151422	1940-10-04	1940-10-04 00:00:00	38000275	0	\N	\N	243248	0	269911007	4151422	
41767	3680	4107731	1993-02-16	1993-02-16 00:00:00	38000275	0	\N	\N	244789	0	180256009	4107731	
30092	2661	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	176279	0	180256009	4107731	
30253	2673	4107731	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	177135	0	180256009	4107731	
42274	3733	4295880	1994-10-25	1994-10-25 00:00:00	38000275	0	\N	\N	248080	0	76601001	4295880	
30553	2702	4202451	1998-08-09	1998-08-09 00:00:00	38000275	0	\N	\N	179001	0	433112001	4202451	
30757	2715	4170947	1982-05-15	1982-05-15 00:00:00	38000275	0	\N	\N	179968	0	274474001	4170947	
30950	2750	4151422	1983-01-21	1983-01-21 00:00:00	38000275	0	\N	\N	181933	0	269911007	4151422	
31228	2768	4125906	2010-09-08	2010-09-08 00:00:00	38000275	0	\N	\N	183164	0	288086009	4125906	
19441	1659	4043071	1979-12-17	1979-12-17 00:00:00	38000275	0	\N	\N	111548	0	228557008	4043071	
31504	2778	4107731	1990-12-29	1990-12-29 00:00:00	38000275	0	\N	\N	184020	0	180256009	4107731	
43637	3859	4035793	2009-10-17	2009-10-17 00:00:00	38000275	0	\N	\N	256161	0	15081005	4035793	
43849	3874	4107731	1996-10-30	1996-10-30 00:00:00	38000275	0	\N	\N	257259	0	180256009	4107731	
32127	2825	4170947	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	187332	0	274474001	4170947	
20318	1759	4295880	2008-08-18	2008-08-18 00:00:00	38000275	0	\N	\N	117586	0	76601001	4295880	
44486	3909	4047491	2011-02-27	2011-02-27 00:00:00	38000275	0	\N	\N	259843	0	1225002	4047491	
44595	3913	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	260185	0	180256009	4107731	
44825	3930	4336464	1979-12-29	1979-12-29 00:00:00	38000275	0	\N	\N	261309	0	232717009	4336464	
33016	2896	4107731	1990-06-03	1990-06-03 00:00:00	38000275	0	\N	\N	192785	0	180256009	4107731	
21292	1845	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	123279	0	180256009	4107731	
33314	2915	4107731	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	194271	0	180256009	4107731	
57431	4976	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	330975	0	180256009	4107731	
33760	2942	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	196099	0	180256009	4107731	
33993	2959	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	197576	0	180256009	4107731	
34120	2966	4107731	1992-11-21	1992-11-21 00:00:00	38000275	0	\N	\N	198096	0	180256009	4107731	
22401	1962	4125906	1967-01-23	1967-01-23 00:00:00	38000275	0	\N	\N	130476	0	288086009	4125906	
34418	2980	4107731	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	198973	0	180256009	4107731	
46569	4085	4043071	1968-01-14	1968-01-14 00:00:00	38000275	0	\N	\N	271467	0	228557008	4043071	
34875	3035	4047491	1968-05-27	1968-05-27 00:00:00	38000275	0	\N	\N	202209	0	1225002	4047491	
58968	5116	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	340013	0	180256009	4107731	
35272	3076	4047491	1967-07-27	1967-07-27 00:00:00	38000275	0	\N	\N	204641	0	1225002	4047491	
35492	3109	4043071	1928-12-26	1928-12-26 00:00:00	38000275	0	\N	\N	206764	0	228557008	4043071	
35617	3118	4107731	1990-03-04	1990-03-04 00:00:00	38000275	0	\N	\N	207437	0	180256009	4107731	
35724	3128	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	208186	0	180256009	4107731	
12085	1102	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	72457	0	180256009	4107731	
24274	2127	4151422	1970-07-23	1970-07-23 00:00:00	38000275	0	\N	\N	141452	0	269911007	4151422	
24381	2135	4107731	1992-08-03	1992-08-03 00:00:00	38000275	0	\N	\N	142179	0	180256009	4107731	
36497	3207	4043071	1973-08-16	1973-08-16 00:00:00	38000275	0	\N	\N	213149	0	228557008	4043071	
36692	3221	4043071	1970-12-05	1970-12-05 00:00:00	38000275	0	\N	\N	214063	0	228557008	4043071	
24920	2175	4107731	2012-05-08	2012-05-08 00:00:00	38000275	0	\N	\N	145046	0	180256009	4107731	
25185	2190	4170947	2014-09-23	2014-09-23 00:00:00	38000275	0	\N	\N	146083	0	274474001	4170947	
25381	2210	4151422	1951-01-21	1951-01-21 00:00:00	38000275	0	\N	\N	147236	0	269911007	4151422	
25600	2238	4107731	1990-12-02	1990-12-02 00:00:00	38000275	0	\N	\N	149006	0	180256009	4107731	
25795	2265	4107731	1993-04-18	1993-04-18 00:00:00	38000275	0	\N	\N	150507	0	180256009	4107731	
25828	2265	4107731	1993-02-14	1993-02-14 00:00:00	38000275	0	\N	\N	150593	0	180256009	4107731	
26071	2280	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	151593	0	180256009	4107731	
26313	2291	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	152441	0	180256009	4107731	
38404	3376	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	223969	0	180256009	4107731	
26736	2339	4024289	1984-12-17	1984-12-17 00:00:00	38000275	0	\N	\N	155678	0	19490002	4024289	
26799	2344	4125906	1969-05-27	1969-05-27 00:00:00	38000275	0	\N	\N	156034	0	288086009	4125906	
27030	2357	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	157050	0	180256009	4107731	
27146	2369	4107731	1995-02-05	1995-02-05 00:00:00	38000275	0	\N	\N	157690	0	180256009	4107731	
27443	2394	4195803	1979-10-20	1979-10-20 00:00:00	38000275	0	\N	\N	159214	0	312681000	4195803	
15690	1387	4043071	1985-10-27	1985-10-27 00:00:00	38000275	0	\N	\N	92077	0	228557008	4043071	
27811	2436	4107731	1990-04-21	1990-04-21 00:00:00	38000275	0	\N	\N	161521	0	180256009	4107731	
27989	2462	4107731	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	163329	0	180256009	4107731	
28097	2476	4125906	1978-08-05	1978-08-05 00:00:00	38000275	0	\N	\N	164117	0	288086009	4125906	
40235	3528	4107731	1990-12-03	1990-12-03 00:00:00	38000275	0	\N	\N	234181	0	180256009	4107731	
28506	2537	4107731	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	167694	0	180256009	4107731	
40620	3566	4107731	1990-05-07	1990-05-07 00:00:00	38000275	0	\N	\N	236955	0	180256009	4107731	
28957	2559	4107731	1990-04-21	1990-04-21 00:00:00	38000275	0	\N	\N	169596	0	180256009	4107731	
17160	1482	4107731	1990-05-12	1990-05-12 00:00:00	38000275	0	\N	\N	98855	0	180256009	4107731	
29284	2596	44783196	2017-04-02	2017-04-02 00:00:00	38000275	0	\N	\N	171815	0	699253003	44783196	
29409	2624	4043071	1975-05-29	1975-05-29 00:00:00	38000275	0	\N	\N	173572	0	228557008	4043071	
41624	3655	4010253	2003-09-05	2003-09-05 00:00:00	38000275	0	\N	\N	243253	0	112790001	4010253	
41768	3680	4107731	1994-05-03	1994-05-03 00:00:00	38000275	0	\N	\N	244755	0	180256009	4107731	
30093	2661	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	176217	0	180256009	4107731	
30254	2673	4107731	1990-04-16	1990-04-16 00:00:00	38000275	0	\N	\N	177096	0	180256009	4107731	
42275	3733	4295880	1994-04-26	1994-04-26 00:00:00	38000275	0	\N	\N	248060	0	76601001	4295880	
30554	2703	4293740	2004-10-03	2004-10-03 00:00:00	38000275	0	\N	\N	179107	0	384700001	4293740	
30758	2715	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	179998	0	180256009	4107731	
30951	2750	4125906	1980-07-31	1980-07-31 00:00:00	38000275	0	\N	\N	181873	0	288086009	4125906	
31229	2768	4125906	1988-02-15	1988-02-15 00:00:00	38000275	0	\N	\N	183163	0	288086009	4125906	
19442	1659	4043071	1979-10-22	1979-10-22 00:00:00	38000275	0	\N	\N	111530	0	228557008	4043071	
31505	2778	4107731	1990-03-10	1990-03-10 00:00:00	38000275	0	\N	\N	184007	0	180256009	4107731	
43638	3859	4035793	2013-11-09	2013-11-09 00:00:00	38000275	0	\N	\N	256246	0	15081005	4035793	
43850	3874	4107731	1996-12-11	1996-12-11 00:00:00	38000275	0	\N	\N	257220	0	180256009	4107731	
32128	2825	4047491	2007-12-24	2007-12-24 00:00:00	38000275	0	\N	\N	187334	0	1225002	4047491	
20319	1759	4295880	2007-05-21	2007-05-21 00:00:00	38000275	0	\N	\N	117600	0	76601001	4295880	
44487	3909	4252419	1962-08-13	1962-08-13 00:00:00	38000275	0	\N	\N	259841	0	74016001	4252419	
44596	3913	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	260160	0	180256009	4107731	
44826	3930	4035793	1976-08-14	1976-08-14 00:00:00	38000275	0	\N	\N	261294	0	15081005	4035793	
33017	2896	4107731	1991-11-10	1991-11-10 00:00:00	38000275	0	\N	\N	192878	0	180256009	4107731	
21293	1845	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	123283	0	180256009	4107731	
33315	2915	4107731	1990-07-15	1990-07-15 00:00:00	38000275	0	\N	\N	194257	0	180256009	4107731	
57432	4976	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	331010	0	180256009	4107731	
33761	2942	4057420	2019-04-17	2019-04-17 00:00:00	38000275	0	\N	\N	196151	0	18286008	4057420	
33994	2959	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	197456	0	180256009	4107731	
34121	2966	4107731	1991-05-04	1991-05-04 00:00:00	38000275	0	\N	\N	198067	0	180256009	4107731	
22402	1962	4125906	1987-02-05	1987-02-05 00:00:00	38000275	0	\N	\N	130478	0	288086009	4125906	
34419	2980	4191853	1993-07-11	1993-07-11 00:00:00	38000275	0	\N	\N	198939	0	395142003	4191853	
46570	4085	4043071	1966-12-04	1966-12-04 00:00:00	38000275	0	\N	\N	271484	0	228557008	4043071	
34876	3035	4151422	2017-02-26	2017-02-26 00:00:00	38000275	0	\N	\N	202213	0	269911007	4151422	
58969	5116	4151422	1969-01-03	1969-01-03 00:00:00	38000275	0	\N	\N	339910	0	269911007	4151422	
35273	3076	4170947	1967-07-27	1967-07-27 00:00:00	38000275	0	\N	\N	204641	0	274474001	4170947	
35493	3109	4043071	1926-09-08	1926-09-08 00:00:00	38000275	0	\N	\N	206779	0	228557008	4043071	
35618	3118	4107731	1993-05-02	1993-05-02 00:00:00	38000275	0	\N	\N	207478	0	180256009	4107731	
35725	3128	44783196	1984-09-15	1984-09-15 00:00:00	38000275	0	\N	\N	208085	0	699253003	44783196	
12086	1102	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	72456	0	180256009	4107731	
36116	3167	4163872	1990-11-06	1990-11-06 00:00:00	38000275	0	\N	\N	210533	0	399208008	4163872	
24382	2135	4107731	1992-03-09	1992-03-09 00:00:00	38000275	0	\N	\N	142089	0	180256009	4107731	
36498	3207	40492359	1994-12-01	1994-12-01 00:00:00	38000275	0	\N	\N	213206	0	447365002	40492359	
36693	3221	4151422	2001-01-29	2001-01-29 00:00:00	38000275	0	\N	\N	214110	0	269911007	4151422	
24921	2175	4107731	2011-05-17	2011-05-17 00:00:00	38000275	0	\N	\N	144968	0	180256009	4107731	
25186	2190	4047491	2014-09-23	2014-09-23 00:00:00	38000275	0	\N	\N	146083	0	1225002	4047491	
25382	2211	4043071	1985-08-25	1985-08-25 00:00:00	38000275	0	\N	\N	147294	0	228557008	4043071	
25601	2238	4107731	1991-05-19	1991-05-19 00:00:00	38000275	0	\N	\N	148985	0	180256009	4107731	
25796	2265	4107731	1990-06-03	1990-06-03 00:00:00	38000275	0	\N	\N	150552	0	180256009	4107731	
25829	2265	4107731	1992-08-09	1992-08-09 00:00:00	38000275	0	\N	\N	150590	0	180256009	4107731	
26072	2280	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	151663	0	180256009	4107731	
26314	2291	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	152557	0	180256009	4107731	
38405	3376	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	223979	0	180256009	4107731	
26737	2339	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	155681	0	180256009	4107731	
26808	2346	4170947	1982-08-10	1982-08-10 00:00:00	38000275	0	\N	\N	156218	0	274474001	4170947	
27031	2357	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	157007	0	180256009	4107731	
27147	2369	4107731	1997-04-13	1997-04-13 00:00:00	38000275	0	\N	\N	157644	0	180256009	4107731	
27444	2394	4170947	1988-01-06	1988-01-06 00:00:00	38000275	0	\N	\N	159215	0	274474001	4170947	
15693	1389	4024289	1962-04-27	1962-04-27 00:00:00	38000275	0	\N	\N	92203	0	19490002	4024289	
27812	2436	4191853	1990-01-06	1990-01-06 00:00:00	38000275	0	\N	\N	161591	0	395142003	4191853	
27990	2462	4107731	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	163295	0	180256009	4107731	
28098	2477	4163872	1957-06-17	1957-06-17 00:00:00	38000275	0	\N	\N	164151	0	399208008	4163872	
40236	3528	4107731	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	234259	0	180256009	4107731	
28507	2537	4107731	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	167621	0	180256009	4107731	
40621	3566	4043071	1959-04-06	1959-04-06 00:00:00	38000275	0	\N	\N	236927	0	228557008	4043071	
28958	2559	4107731	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	169600	0	180256009	4107731	
17161	1482	4107731	1991-09-07	1991-09-07 00:00:00	38000275	0	\N	\N	98883	0	180256009	4107731	
29285	2596	4151422	1978-04-14	1978-04-14 00:00:00	38000275	0	\N	\N	171768	0	269911007	4151422	
29410	2624	4043071	1976-11-18	1976-11-18 00:00:00	38000275	0	\N	\N	173590	0	228557008	4043071	
41625	3655	4216130	2010-12-16	2010-12-16 00:00:00	38000275	0	\N	\N	243260	0	415070008	4216130	
41769	3680	4107731	1994-09-06	1994-09-06 00:00:00	38000275	0	\N	\N	244767	0	180256009	4107731	
30094	2661	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	176222	0	180256009	4107731	
30255	2673	4107731	1990-12-03	1990-12-03 00:00:00	38000275	0	\N	\N	177170	0	180256009	4107731	
42276	3733	4295880	1993-04-27	1993-04-27 00:00:00	38000275	0	\N	\N	248077	0	76601001	4295880	
30555	2703	4125906	2004-10-03	2004-10-03 00:00:00	38000275	0	\N	\N	179107	0	288086009	4125906	
30759	2715	4197460	1974-01-31	1974-01-31 00:00:00	38000275	0	\N	\N	179967	0	313191000	4197460	
30952	2750	4057420	2011-05-25	2011-05-25 00:00:00	38000275	0	\N	\N	181876	0	18286008	4057420	
43014	3786	4125906	1991-10-01	1991-10-01 00:00:00	38000275	0	\N	\N	251663	0	288086009	4125906	
19443	1659	4125906	2004-08-24	2004-08-24 00:00:00	38000275	0	\N	\N	111458	0	288086009	4125906	
31506	2778	4107731	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	184021	0	180256009	4107731	
43639	3859	4078793	2017-04-22	2017-04-22 00:00:00	38000275	0	\N	\N	256162	0	180325003	4078793	
43851	3874	4107731	1996-11-20	1996-11-20 00:00:00	38000275	0	\N	\N	257225	0	180256009	4107731	
32129	2825	4170947	2007-12-24	2007-12-24 00:00:00	38000275	0	\N	\N	187334	0	274474001	4170947	
20320	1759	4295880	2008-05-19	2008-05-19 00:00:00	38000275	0	\N	\N	117613	0	76601001	4295880	
56300	4913	4125906	1976-12-03	1976-12-03 00:00:00	38000275	0	\N	\N	326570	0	288086009	4125906	
44597	3913	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	260100	0	395142003	4191853	
44827	3930	4035793	1973-07-28	1973-07-28 00:00:00	38000275	0	\N	\N	261278	0	15081005	4035793	
33018	2896	4107731	1991-05-05	1991-05-05 00:00:00	38000275	0	\N	\N	192877	0	180256009	4107731	
21294	1845	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	123282	0	180256009	4107731	
33316	2915	4107731	1990-06-03	1990-06-03 00:00:00	38000275	0	\N	\N	194330	0	180256009	4107731	
57433	4976	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	331004	0	180256009	4107731	
33762	2942	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	196076	0	180256009	4107731	
33995	2959	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	197459	0	180256009	4107731	
34122	2966	4107731	1992-08-29	1992-08-29 00:00:00	38000275	0	\N	\N	198138	0	180256009	4107731	
22404	1964	4151422	2013-08-13	2013-08-13 00:00:00	38000275	0	\N	\N	130566	0	269911007	4151422	
34420	2980	4107731	1992-05-17	1992-05-17 00:00:00	38000275	0	\N	\N	198953	0	180256009	4107731	
46571	4085	4043071	1969-02-02	1969-02-02 00:00:00	38000275	0	\N	\N	271497	0	228557008	4043071	
34887	3040	4024289	1976-08-31	1976-08-31 00:00:00	38000275	0	\N	\N	202412	0	19490002	4024289	
58970	5116	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	339991	0	180256009	4107731	
35274	3076	4163872	2017-10-20	2017-10-20 00:00:00	38000275	0	\N	\N	204649	0	399208008	4163872	
35494	3109	4043071	1927-03-23	1927-03-23 00:00:00	38000275	0	\N	\N	206782	0	228557008	4043071	
35619	3118	4107731	1991-01-13	1991-01-13 00:00:00	38000275	0	\N	\N	207441	0	180256009	4107731	
35726	3128	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	208201	0	180256009	4107731	
12087	1102	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	72371	0	180256009	4107731	
36117	3167	4293740	1996-01-03	1996-01-03 00:00:00	38000275	0	\N	\N	210551	0	384700001	4293740	
24383	2135	4107731	1992-08-24	1992-08-24 00:00:00	38000275	0	\N	\N	142139	0	180256009	4107731	
36499	3207	4057420	1994-12-01	1994-12-01 00:00:00	38000275	0	\N	\N	213206	0	18286008	4057420	
36694	3221	4043071	1971-03-06	1971-03-06 00:00:00	38000275	0	\N	\N	214065	0	228557008	4043071	
24922	2175	4107731	2011-04-26	2011-04-26 00:00:00	38000275	0	\N	\N	145041	0	180256009	4107731	
25187	2191	4151422	1981-04-23	1981-04-23 00:00:00	38000275	0	\N	\N	146088	0	269911007	4151422	
25383	2211	4043071	1986-03-16	1986-03-16 00:00:00	38000275	0	\N	\N	147333	0	228557008	4043071	
25602	2238	4107731	1990-07-29	1990-07-29 00:00:00	38000275	0	\N	\N	148940	0	180256009	4107731	
25797	2265	4107731	1992-11-22	1992-11-22 00:00:00	38000275	0	\N	\N	150538	0	180256009	4107731	
25830	2265	4107731	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	150565	0	180256009	4107731	
26073	2280	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	151572	0	180256009	4107731	
26315	2292	4151422	1965-09-07	1965-09-07 00:00:00	38000275	0	\N	\N	152611	0	269911007	4151422	
38406	3376	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	224054	0	395142003	4191853	
26738	2339	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	155640	0	180256009	4107731	
26809	2346	4243062	1982-08-10	1982-08-10 00:00:00	38000275	0	\N	\N	156218	0	60027007	4243062	
27032	2357	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	156940	0	180256009	4107731	
27148	2369	4107731	1997-07-06	1997-07-06 00:00:00	38000275	0	\N	\N	157706	0	180256009	4107731	
27445	2394	4024289	1988-01-06	1988-01-06 00:00:00	38000275	0	\N	\N	159215	0	19490002	4024289	
15694	1389	4170947	1962-04-27	1962-04-27 00:00:00	38000275	0	\N	\N	92203	0	274474001	4170947	
27813	2436	4107731	1990-10-27	1990-10-27 00:00:00	38000275	0	\N	\N	161477	0	180256009	4107731	
27991	2462	4107731	1993-05-09	1993-05-09 00:00:00	38000275	0	\N	\N	163301	0	180256009	4107731	
28099	2477	4125906	1967-10-22	1967-10-22 00:00:00	38000275	0	\N	\N	164118	0	288086009	4125906	
40237	3528	4107731	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	234272	0	180256009	4107731	
28508	2537	4107731	1993-03-28	1993-03-28 00:00:00	38000275	0	\N	\N	167669	0	180256009	4107731	
40622	3566	4107731	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	236834	0	180256009	4107731	
28959	2559	4107731	1991-11-09	1991-11-09 00:00:00	38000275	0	\N	\N	169558	0	180256009	4107731	
17162	1482	4107731	1990-11-17	1990-11-17 00:00:00	38000275	0	\N	\N	98907	0	180256009	4107731	
29286	2597	4243062	1983-12-30	1983-12-30 00:00:00	38000275	0	\N	\N	171856	0	60027007	4243062	
29411	2624	4043071	1975-01-30	1975-01-30 00:00:00	38000275	0	\N	\N	173581	0	228557008	4043071	
41626	3655	4336464	2010-12-16	2010-12-16 00:00:00	38000275	0	\N	\N	243260	0	232717009	4336464	
41770	3680	4107731	1992-05-19	1992-05-19 00:00:00	38000275	0	\N	\N	244680	0	180256009	4107731	
30095	2661	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	176291	0	180256009	4107731	
30256	2673	4107731	1992-06-01	1992-06-01 00:00:00	38000275	0	\N	\N	177151	0	180256009	4107731	
42277	3733	4295880	1994-01-25	1994-01-25 00:00:00	38000275	0	\N	\N	248078	0	76601001	4295880	
30556	2703	4125906	2015-08-24	2015-08-24 00:00:00	38000275	0	\N	\N	179111	0	288086009	4125906	
30760	2715	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	180010	0	180256009	4107731	
30953	2750	40492359	2011-05-25	2011-05-25 00:00:00	38000275	0	\N	\N	181876	0	447365002	40492359	
43015	3786	4125906	1978-02-27	1978-02-27 00:00:00	38000275	0	\N	\N	251689	0	288086009	4125906	
19444	1659	4043071	1977-09-26	1977-09-26 00:00:00	38000275	0	\N	\N	111479	0	228557008	4043071	
31507	2778	4107731	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	183984	0	180256009	4107731	
43640	3859	4035793	2017-04-22	2017-04-22 00:00:00	38000275	0	\N	\N	256162	0	15081005	4035793	
43852	3874	4107731	1995-01-18	1995-01-18 00:00:00	38000275	0	\N	\N	257239	0	180256009	4107731	
32130	2825	4195803	2007-12-24	2007-12-24 00:00:00	38000275	0	\N	\N	187334	0	312681000	4195803	
20321	1759	4295880	2006-02-20	2006-02-20 00:00:00	38000275	0	\N	\N	117610	0	76601001	4295880	
56301	4913	4024289	1981-04-25	1981-04-25 00:00:00	38000275	0	\N	\N	326571	0	19490002	4024289	
44598	3913	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	260165	0	180256009	4107731	
44828	3930	4035793	1975-08-09	1975-08-09 00:00:00	38000275	0	\N	\N	261255	0	15081005	4035793	
33019	2896	4107731	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	192773	0	180256009	4107731	
21295	1845	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	123366	0	180256009	4107731	
33317	2915	4107731	1991-09-29	1991-09-29 00:00:00	38000275	0	\N	\N	194321	0	180256009	4107731	
57434	4976	4197460	1931-07-06	1931-07-06 00:00:00	38000275	0	\N	\N	331101	0	313191000	4197460	
33763	2942	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	196217	0	180256009	4107731	
33996	2959	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	197499	0	180256009	4107731	
34123	2966	4107731	1990-10-06	1990-10-06 00:00:00	38000275	0	\N	\N	198091	0	180256009	4107731	
22405	1965	4043071	1987-03-29	1987-03-29 00:00:00	38000275	0	\N	\N	130615	0	228557008	4043071	
34421	2980	4107731	1990-04-22	1990-04-22 00:00:00	38000275	0	\N	\N	198968	0	180256009	4107731	
46572	4085	4043071	1966-10-30	1966-10-30 00:00:00	38000275	0	\N	\N	271512	0	228557008	4043071	
34888	3040	4170947	1976-08-31	1976-08-31 00:00:00	38000275	0	\N	\N	202412	0	274474001	4170947	
58971	5116	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	339958	0	180256009	4107731	
35275	3076	4170947	2017-10-20	2017-10-20 00:00:00	38000275	0	\N	\N	204649	0	274474001	4170947	
35495	3109	4043071	1927-11-02	1927-11-02 00:00:00	38000275	0	\N	\N	206789	0	228557008	4043071	
35620	3118	4107731	1991-11-24	1991-11-24 00:00:00	38000275	0	\N	\N	207430	0	180256009	4107731	
35727	3128	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	208215	0	395142003	4191853	
12088	1102	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	72404	0	180256009	4107731	
36118	3167	4125906	1996-01-03	1996-01-03 00:00:00	38000275	0	\N	\N	210551	0	288086009	4125906	
24384	2135	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	142095	0	180256009	4107731	
36500	3207	4043071	1973-06-21	1973-06-21 00:00:00	38000275	0	\N	\N	213215	0	228557008	4043071	
36695	3221	4043071	1971-08-14	1971-08-14 00:00:00	38000275	0	\N	\N	214066	0	228557008	4043071	
24923	2175	4107731	2011-08-09	2011-08-09 00:00:00	38000275	0	\N	\N	145063	0	180256009	4107731	
25188	2192	4238715	1984-10-04	1984-10-04 00:00:00	38000275	0	\N	\N	146157	0	68254000	4238715	
25384	2211	4043071	1985-10-27	1985-10-27 00:00:00	38000275	0	\N	\N	147303	0	228557008	4043071	
25603	2238	4107731	1991-02-03	1991-02-03 00:00:00	38000275	0	\N	\N	148997	0	180256009	4107731	
25798	2265	4107731	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	150608	0	180256009	4107731	
25831	2265	4107731	1991-09-08	1991-09-08 00:00:00	38000275	0	\N	\N	150616	0	180256009	4107731	
26074	2280	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	151604	0	180256009	4107731	
26316	2292	4125906	1997-10-13	1997-10-13 00:00:00	38000275	0	\N	\N	152636	0	288086009	4125906	
38407	3376	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	224009	0	180256009	4107731	
26739	2339	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	155601	0	180256009	4107731	
26810	2346	4170947	2016-09-10	2016-09-10 00:00:00	38000275	0	\N	\N	156220	0	274474001	4170947	
27033	2357	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	157052	0	395142003	4191853	
27149	2369	4107731	1995-01-15	1995-01-15 00:00:00	38000275	0	\N	\N	157662	0	180256009	4107731	
27446	2394	4195803	1988-01-06	1988-01-06 00:00:00	38000275	0	\N	\N	159215	0	312681000	4195803	
15695	1389	4047491	1965-03-12	1965-03-12 00:00:00	38000275	0	\N	\N	92204	0	1225002	4047491	
27814	2436	4107731	1990-06-02	1990-06-02 00:00:00	38000275	0	\N	\N	161581	0	180256009	4107731	
27992	2462	4107731	1990-04-22	1990-04-22 00:00:00	38000275	0	\N	\N	163235	0	180256009	4107731	
28102	2480	4195803	2009-06-05	2009-06-05 00:00:00	38000275	0	\N	\N	164319	0	312681000	4195803	
40238	3528	4107731	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	234265	0	180256009	4107731	
28509	2537	4107731	1992-11-01	1992-11-01 00:00:00	38000275	0	\N	\N	167622	0	180256009	4107731	
40623	3566	4107731	1991-11-04	1991-11-04 00:00:00	38000275	0	\N	\N	236961	0	180256009	4107731	
28960	2559	4107731	1990-02-17	1990-02-17 00:00:00	38000275	0	\N	\N	169526	0	180256009	4107731	
17163	1482	4107731	1993-02-13	1993-02-13 00:00:00	38000275	0	\N	\N	98875	0	180256009	4107731	
29287	2597	4170947	1983-12-30	1983-12-30 00:00:00	38000275	0	\N	\N	171856	0	274474001	4170947	
29412	2624	4043071	1977-06-09	1977-06-09 00:00:00	38000275	0	\N	\N	173591	0	228557008	4043071	
41627	3655	4151422	2002-02-02	2002-02-02 00:00:00	38000275	0	\N	\N	243270	0	269911007	4151422	
41771	3680	4107731	1993-07-13	1993-07-13 00:00:00	38000275	0	\N	\N	244786	0	180256009	4107731	
30096	2661	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	176226	0	180256009	4107731	
30257	2673	4107731	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	177140	0	180256009	4107731	
42278	3733	4295880	1993-07-27	1993-07-27 00:00:00	38000275	0	\N	\N	248059	0	76601001	4295880	
30557	2703	4181917	1974-03-03	1974-03-03 00:00:00	38000275	0	\N	\N	179053	0	54550000	4181917	
30761	2715	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	180096	0	180256009	4107731	
30954	2750	4195803	1993-08-11	1993-08-11 00:00:00	38000275	0	\N	\N	181919	0	312681000	4195803	
43016	3786	4326177	2015-11-25	2015-11-25 00:00:00	38000275	0	\N	\N	251654	0	430193006	4326177	
19445	1659	4043071	1979-08-13	1979-08-13 00:00:00	38000275	0	\N	\N	111444	0	228557008	4043071	
31508	2778	4107731	1993-05-08	1993-05-08 00:00:00	38000275	0	\N	\N	184042	0	180256009	4107731	
43641	3859	4078793	2018-04-28	2018-04-28 00:00:00	38000275	0	\N	\N	256183	0	180325003	4078793	
43853	3874	4107731	1996-04-24	1996-04-24 00:00:00	38000275	0	\N	\N	257218	0	180256009	4107731	
32162	2827	4151422	1945-07-21	1945-07-21 00:00:00	38000275	0	\N	\N	187469	0	269911007	4151422	
20322	1759	4295880	2008-11-17	2008-11-17 00:00:00	38000275	0	\N	\N	117639	0	76601001	4295880	
56302	4913	4170947	1981-04-25	1981-04-25 00:00:00	38000275	0	\N	\N	326571	0	274474001	4170947	
44599	3913	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	260159	0	180256009	4107731	
44829	3930	4035793	1972-07-22	1972-07-22 00:00:00	38000275	0	\N	\N	261271	0	15081005	4035793	
33020	2896	4107731	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	192781	0	180256009	4107731	
21296	1845	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	123330	0	180256009	4107731	
33318	2915	4107731	1990-08-26	1990-08-26 00:00:00	38000275	0	\N	\N	194258	0	180256009	4107731	
57435	4976	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	330926	0	180256009	4107731	
33764	2942	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	196112	0	180256009	4107731	
33997	2959	4043071	1980-11-12	1980-11-12 00:00:00	38000275	0	\N	\N	197489	0	228557008	4043071	
34124	2966	4107731	1990-06-23	1990-06-23 00:00:00	38000275	0	\N	\N	198063	0	180256009	4107731	
22406	1965	4043071	1987-03-01	1987-03-01 00:00:00	38000275	0	\N	\N	130653	0	228557008	4043071	
34422	2980	4107731	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	198961	0	180256009	4107731	
46573	4085	4043071	1969-03-09	1969-03-09 00:00:00	38000275	0	\N	\N	271491	0	228557008	4043071	
34889	3041	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	202456	0	180256009	4107731	
58972	5116	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	339996	0	180256009	4107731	
35276	3076	4195803	2017-10-20	2017-10-20 00:00:00	38000275	0	\N	\N	204649	0	312681000	4195803	
47312	4153	4243062	2005-05-10	2005-05-10 00:00:00	38000275	0	\N	\N	276008	0	60027007	4243062	
35621	3118	4107731	1991-05-19	1991-05-19 00:00:00	38000275	0	\N	\N	207512	0	180256009	4107731	
35728	3128	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	208222	0	180256009	4107731	
12089	1102	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	72476	0	180256009	4107731	
36119	3167	4252419	2011-09-30	2011-09-30 00:00:00	38000275	0	\N	\N	210553	0	74016001	4252419	
24385	2135	4107731	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	142186	0	180256009	4107731	
36501	3207	4043071	1973-02-15	1973-02-15 00:00:00	38000275	0	\N	\N	213158	0	228557008	4043071	
36696	3221	4043071	1970-10-03	1970-10-03 00:00:00	38000275	0	\N	\N	214104	0	228557008	4043071	
24924	2175	4107731	2012-01-03	2012-01-03 00:00:00	38000275	0	\N	\N	144970	0	180256009	4107731	
25189	2192	4151422	1997-01-11	1997-01-11 00:00:00	38000275	0	\N	\N	146174	0	269911007	4151422	
25385	2211	4043071	1986-05-11	1986-05-11 00:00:00	38000275	0	\N	\N	147305	0	228557008	4043071	
25604	2238	4107731	1990-05-27	1990-05-27 00:00:00	38000275	0	\N	\N	149005	0	180256009	4107731	
25799	2265	4107731	1992-02-23	1992-02-23 00:00:00	38000275	0	\N	\N	150606	0	180256009	4107731	
25832	2265	4107731	1992-06-28	1992-06-28 00:00:00	38000275	0	\N	\N	150576	0	180256009	4107731	
26075	2280	44783196	1997-04-15	1997-04-15 00:00:00	38000275	0	\N	\N	151692	0	699253003	44783196	
26317	2292	4035793	2017-03-17	2017-03-17 00:00:00	38000275	0	\N	\N	152592	0	15081005	4035793	
38408	3376	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	224018	0	180256009	4107731	
26740	2339	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	155692	0	180256009	4107731	
26811	2346	4195803	2016-09-10	2016-09-10 00:00:00	38000275	0	\N	\N	156220	0	312681000	4195803	
27034	2357	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	157010	0	180256009	4107731	
27150	2369	4107731	1996-07-14	1996-07-14 00:00:00	38000275	0	\N	\N	157668	0	180256009	4107731	
27447	2395	4125906	1962-03-29	1962-03-29 00:00:00	38000275	0	\N	\N	159236	0	288086009	4125906	
15696	1389	4170947	1965-03-12	1965-03-12 00:00:00	38000275	0	\N	\N	92204	0	274474001	4170947	
27815	2436	4107731	1992-08-29	1992-08-29 00:00:00	38000275	0	\N	\N	161551	0	180256009	4107731	
27993	2462	4107731	1990-04-01	1990-04-01 00:00:00	38000275	0	\N	\N	163222	0	180256009	4107731	
28103	2480	4170947	2009-06-05	2009-06-05 00:00:00	38000275	0	\N	\N	164319	0	274474001	4170947	
40239	3528	4107731	1991-04-29	1991-04-29 00:00:00	38000275	0	\N	\N	234267	0	180256009	4107731	
28510	2537	4107731	1992-01-12	1992-01-12 00:00:00	38000275	0	\N	\N	167659	0	180256009	4107731	
40624	3566	4107731	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	236885	0	180256009	4107731	
28961	2559	4107731	1990-03-10	1990-03-10 00:00:00	38000275	0	\N	\N	169585	0	180256009	4107731	
17164	1482	4107731	1992-06-06	1992-06-06 00:00:00	38000275	0	\N	\N	98830	0	180256009	4107731	
29288	2597	4151422	1981-08-30	1981-08-30 00:00:00	38000275	0	\N	\N	171825	0	269911007	4151422	
29413	2624	4043071	1977-03-03	1977-03-03 00:00:00	38000275	0	\N	\N	173599	0	228557008	4043071	
41628	3655	4202451	2001-12-13	2001-12-13 00:00:00	38000275	0	\N	\N	243245	0	433112001	4202451	
41772	3680	4107731	1992-12-15	1992-12-15 00:00:00	38000275	0	\N	\N	244759	0	180256009	4107731	
30097	2661	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	176218	0	180256009	4107731	
30258	2673	4145310	2009-03-21	2009-03-21 00:00:00	38000275	0	\N	\N	177100	0	268425006	4145310	
42279	3733	4295880	1993-10-26	1993-10-26 00:00:00	38000275	0	\N	\N	248030	0	76601001	4295880	
30558	2703	4181917	1975-01-26	1975-01-26 00:00:00	38000275	0	\N	\N	179054	0	54550000	4181917	
30762	2715	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	180027	0	180256009	4107731	
30957	2752	4125906	1954-04-01	1954-04-01 00:00:00	38000275	0	\N	\N	182113	0	288086009	4125906	
43017	3786	4187458	2015-11-25	2015-11-25 00:00:00	38000275	0	\N	\N	251654	0	415300000	4187458	
19446	1659	4043071	1978-09-25	1978-09-25 00:00:00	38000275	0	\N	\N	111506	0	228557008	4043071	
31509	2779	4107731	1997-07-09	1997-07-09 00:00:00	38000275	0	\N	\N	184107	0	180256009	4107731	
43642	3859	4024289	1936-12-01	1936-12-01 00:00:00	38000275	0	\N	\N	256264	0	19490002	4024289	
43854	3874	4191853	1994-12-28	1994-12-28 00:00:00	38000275	0	\N	\N	257207	0	395142003	4191853	
32163	2827	4078793	2000-12-26	2000-12-26 00:00:00	38000275	0	\N	\N	187456	0	180325003	4078793	
20323	1759	4295880	2006-08-21	2006-08-21 00:00:00	38000275	0	\N	\N	117581	0	76601001	4295880	
56307	4916	4151422	2005-05-27	2005-05-27 00:00:00	38000275	0	\N	\N	326663	0	269911007	4151422	
44600	3913	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	260122	0	180256009	4107731	
44832	3932	4151422	1982-05-12	1982-05-12 00:00:00	38000275	0	\N	\N	261403	0	269911007	4151422	
33021	2896	4107731	1991-12-01	1991-12-01 00:00:00	38000275	0	\N	\N	192775	0	180256009	4107731	
21297	1845	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	123395	0	180256009	4107731	
33319	2915	4107731	1990-12-30	1990-12-30 00:00:00	38000275	0	\N	\N	194318	0	180256009	4107731	
57436	4976	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	331014	0	180256009	4107731	
33765	2942	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	196075	0	180256009	4107731	
33998	2959	4043071	1980-06-11	1980-06-11 00:00:00	38000275	0	\N	\N	197486	0	228557008	4043071	
34125	2966	4107731	1992-01-11	1992-01-11 00:00:00	38000275	0	\N	\N	198132	0	180256009	4107731	
22407	1966	44783196	2010-05-07	2010-05-07 00:00:00	38000275	0	\N	\N	130734	0	699253003	44783196	
34423	2980	4107731	1990-11-18	1990-11-18 00:00:00	38000275	0	\N	\N	198947	0	180256009	4107731	
46574	4085	4043071	1967-08-06	1967-08-06 00:00:00	38000275	0	\N	\N	271515	0	228557008	4043071	
34890	3041	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	202532	0	180256009	4107731	
58973	5116	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	339926	0	180256009	4107731	
35277	3077	4202451	2014-06-11	2014-06-11 00:00:00	38000275	0	\N	\N	204737	0	433112001	4202451	
47313	4153	4252419	1999-11-01	1999-11-01 00:00:00	38000275	0	\N	\N	276007	0	74016001	4252419	
35622	3118	4107731	1992-05-10	1992-05-10 00:00:00	38000275	0	\N	\N	207417	0	180256009	4107731	
35729	3128	4295880	1995-12-12	1995-12-12 00:00:00	38000275	0	\N	\N	208132	0	76601001	4295880	
12090	1102	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	72455	0	180256009	4107731	
36120	3167	4125906	1979-02-17	1979-02-17 00:00:00	38000275	0	\N	\N	210550	0	288086009	4125906	
24386	2135	4107731	1992-01-06	1992-01-06 00:00:00	38000275	0	\N	\N	142137	0	180256009	4107731	
36502	3207	4043071	1973-12-20	1973-12-20 00:00:00	38000275	0	\N	\N	213150	0	228557008	4043071	
36697	3221	4043071	1971-09-18	1971-09-18 00:00:00	38000275	0	\N	\N	214067	0	228557008	4043071	
24925	2175	4107731	2011-06-07	2011-06-07 00:00:00	38000275	0	\N	\N	144961	0	180256009	4107731	
25190	2192	4151422	1986-07-11	1986-07-11 00:00:00	38000275	0	\N	\N	146171	0	269911007	4151422	
25386	2211	4043071	1986-04-13	1986-04-13 00:00:00	38000275	0	\N	\N	147326	0	228557008	4043071	
25605	2238	4107731	1992-04-19	1992-04-19 00:00:00	38000275	0	\N	\N	148948	0	180256009	4107731	
25800	2265	4107731	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	150550	0	180256009	4107731	
25833	2265	4191853	1990-01-07	1990-01-07 00:00:00	38000275	0	\N	\N	150517	0	395142003	4191853	
26076	2280	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	151689	0	180256009	4107731	
26318	2292	4125906	2005-02-24	2005-02-24 00:00:00	38000275	0	\N	\N	152637	0	288086009	4125906	
38409	3376	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	224038	0	180256009	4107731	
26741	2339	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	155666	0	180256009	4107731	
26812	2346	4163872	2016-09-10	2016-09-10 00:00:00	38000275	0	\N	\N	156220	0	399208008	4163872	
27035	2357	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	156979	0	180256009	4107731	
27151	2369	4107731	1997-05-04	1997-05-04 00:00:00	38000275	0	\N	\N	157717	0	180256009	4107731	
27448	2395	4170947	1973-01-21	1973-01-21 00:00:00	38000275	0	\N	\N	159238	0	274474001	4170947	
15697	1389	4037675	1962-03-03	1962-03-03 00:00:00	38000275	0	\N	\N	92180	0	162676008	4037675	
27816	2436	4107731	1990-09-15	1990-09-15 00:00:00	38000275	0	\N	\N	161506	0	180256009	4107731	
27994	2462	4107731	1990-08-26	1990-08-26 00:00:00	38000275	0	\N	\N	163322	0	180256009	4107731	
28104	2480	4243062	2009-06-05	2009-06-05 00:00:00	38000275	0	\N	\N	164319	0	60027007	4243062	
40240	3528	4107731	1992-03-30	1992-03-30 00:00:00	38000275	0	\N	\N	234258	0	180256009	4107731	
28511	2537	4107731	1992-08-30	1992-08-30 00:00:00	38000275	0	\N	\N	167661	0	180256009	4107731	
40625	3566	4043071	1958-09-22	1958-09-22 00:00:00	38000275	0	\N	\N	236926	0	228557008	4043071	
28962	2559	4107731	1993-03-06	1993-03-06 00:00:00	38000275	0	\N	\N	169629	0	180256009	4107731	
17165	1482	4191853	1993-07-10	1993-07-10 00:00:00	38000275	0	\N	\N	98836	0	395142003	4191853	
29289	2598	4151422	2003-07-19	2003-07-19 00:00:00	38000275	0	\N	\N	171895	0	269911007	4151422	
29414	2626	4047491	1968-02-06	1968-02-06 00:00:00	38000275	0	\N	\N	173741	0	1225002	4047491	
41633	3658	4125906	2005-05-17	2005-05-17 00:00:00	38000275	0	\N	\N	243508	0	288086009	4125906	
41773	3680	4107731	1995-09-19	1995-09-19 00:00:00	38000275	0	\N	\N	244772	0	180256009	4107731	
30098	2661	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	176275	0	180256009	4107731	
30259	2673	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	177155	0	180256009	4107731	
42280	3733	4295880	1995-01-24	1995-01-24 00:00:00	38000275	0	\N	\N	248061	0	76601001	4295880	
30559	2704	4125906	1994-12-11	1994-12-11 00:00:00	38000275	0	\N	\N	179113	0	288086009	4125906	
30763	2715	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	179997	0	180256009	4107731	
30958	2752	4151422	1954-04-03	1954-04-03 00:00:00	38000275	0	\N	\N	182101	0	269911007	4151422	
43018	3786	4037675	2015-11-25	2015-11-25 00:00:00	38000275	0	\N	\N	251654	0	162676008	4037675	
19447	1659	4043071	1981-11-16	1981-11-16 00:00:00	38000275	0	\N	\N	111429	0	228557008	4043071	
31510	2779	4107731	1997-10-22	1997-10-22 00:00:00	38000275	0	\N	\N	184169	0	180256009	4107731	
43643	3859	4170947	1936-12-01	1936-12-01 00:00:00	38000275	0	\N	\N	256264	0	274474001	4170947	
43855	3874	4107731	1995-06-14	1995-06-14 00:00:00	38000275	0	\N	\N	257214	0	180256009	4107731	
32164	2827	4145310	1987-05-28	1987-05-28 00:00:00	38000275	0	\N	\N	187513	0	268425006	4145310	
20324	1759	4295880	2008-02-18	2008-02-18 00:00:00	38000275	0	\N	\N	117638	0	76601001	4295880	
56308	4916	4170947	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	326698	0	274474001	4170947	
44601	3913	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	260116	0	180256009	4107731	
44833	3932	4163872	1975-06-17	1975-06-17 00:00:00	38000275	0	\N	\N	261411	0	399208008	4163872	
33022	2896	4107731	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	192779	0	180256009	4107731	
21298	1845	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	123296	0	180256009	4107731	
33320	2915	4107731	1991-07-07	1991-07-07 00:00:00	38000275	0	\N	\N	194262	0	180256009	4107731	
57437	4976	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	331006	0	180256009	4107731	
33766	2942	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	196227	0	180256009	4107731	
33999	2959	4043071	1980-05-14	1980-05-14 00:00:00	38000275	0	\N	\N	197573	0	228557008	4043071	
34126	2966	4107731	1990-12-08	1990-12-08 00:00:00	38000275	0	\N	\N	198081	0	180256009	4107731	
22408	1966	4125906	1984-05-08	1984-05-08 00:00:00	38000275	0	\N	\N	130736	0	288086009	4125906	
34424	2980	4107731	1991-01-20	1991-01-20 00:00:00	38000275	0	\N	\N	199010	0	180256009	4107731	
46575	4085	4043071	1967-01-01	1967-01-01 00:00:00	38000275	0	\N	\N	271534	0	228557008	4043071	
34891	3041	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	202520	0	180256009	4107731	
58974	5116	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	339911	0	180256009	4107731	
35278	3077	4252419	1979-11-18	1979-11-18 00:00:00	38000275	0	\N	\N	204722	0	74016001	4252419	
47314	4153	4151422	1975-12-26	1975-12-26 00:00:00	38000275	0	\N	\N	276063	0	269911007	4151422	
35623	3118	4107731	1990-04-15	1990-04-15 00:00:00	38000275	0	\N	\N	207438	0	180256009	4107731	
35730	3128	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	208158	0	180256009	4107731	
12091	1102	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	72448	0	180256009	4107731	
36121	3167	4151422	2017-08-25	2017-08-25 00:00:00	38000275	0	\N	\N	210579	0	269911007	4151422	
24387	2135	4107731	1993-03-01	1993-03-01 00:00:00	38000275	0	\N	\N	142094	0	180256009	4107731	
36503	3207	4043071	1974-09-19	1974-09-19 00:00:00	38000275	0	\N	\N	213152	0	228557008	4043071	
36698	3221	4043071	1971-11-13	1971-11-13 00:00:00	38000275	0	\N	\N	214085	0	228557008	4043071	
24926	2175	4107731	2009-10-27	2009-10-27 00:00:00	38000275	0	\N	\N	145019	0	180256009	4107731	
25191	2192	4057420	2001-12-06	2001-12-06 00:00:00	38000275	0	\N	\N	146244	0	18286008	4057420	
25387	2211	4043071	1986-08-17	1986-08-17 00:00:00	38000275	0	\N	\N	147296	0	228557008	4043071	
25606	2238	4151422	1986-04-23	1986-04-23 00:00:00	38000275	0	\N	\N	148890	0	269911007	4151422	
25801	2265	4107731	1991-08-18	1991-08-18 00:00:00	38000275	0	\N	\N	150572	0	180256009	4107731	
25834	2265	4107731	1990-08-26	1990-08-26 00:00:00	38000275	0	\N	\N	150567	0	180256009	4107731	
26077	2280	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	151661	0	180256009	4107731	
26319	2292	4035793	2019-03-29	2019-03-29 00:00:00	38000275	0	\N	\N	152593	0	15081005	4035793	
38410	3376	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	224017	0	180256009	4107731	
38523	3386	4125906	2019-02-04	2019-02-04 00:00:00	38000275	0	\N	\N	224633	0	288086009	4125906	
26813	2346	4170947	1974-08-22	1974-08-22 00:00:00	38000275	0	\N	\N	156217	0	274474001	4170947	
27036	2357	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	157034	0	180256009	4107731	
27152	2369	4107731	1995-06-11	1995-06-11 00:00:00	38000275	0	\N	\N	157635	0	180256009	4107731	
27449	2395	4243062	1973-01-21	1973-01-21 00:00:00	38000275	0	\N	\N	159238	0	60027007	4243062	
15698	1389	4326177	1962-03-03	1962-03-03 00:00:00	38000275	0	\N	\N	92180	0	430193006	4326177	
27817	2437	4170947	1963-08-11	1963-08-11 00:00:00	38000275	0	\N	\N	161667	0	274474001	4170947	
27995	2462	4107731	1991-02-10	1991-02-10 00:00:00	38000275	0	\N	\N	163226	0	180256009	4107731	
28105	2480	4125906	1977-12-06	1977-12-06 00:00:00	38000275	0	\N	\N	164317	0	288086009	4125906	
40241	3528	4107731	1991-04-08	1991-04-08 00:00:00	38000275	0	\N	\N	234253	0	180256009	4107731	
28512	2537	4062501	1950-08-23	1950-08-23 00:00:00	38000275	0	\N	\N	167752	0	171231001	4062501	
40626	3566	4107731	1992-12-07	1992-12-07 00:00:00	38000275	0	\N	\N	236846	0	180256009	4107731	
28963	2559	4107731	1990-10-27	1990-10-27 00:00:00	38000275	0	\N	\N	169587	0	180256009	4107731	
17166	1482	4107731	1990-03-31	1990-03-31 00:00:00	38000275	0	\N	\N	98890	0	180256009	4107731	
29290	2598	4125906	2011-11-16	2011-11-16 00:00:00	38000275	0	\N	\N	171937	0	288086009	4125906	
29415	2626	4170947	1968-02-06	1968-02-06 00:00:00	38000275	0	\N	\N	173741	0	274474001	4170947	
41634	3658	4125906	1980-05-14	1980-05-14 00:00:00	38000275	0	\N	\N	243507	0	288086009	4125906	
41774	3680	4107731	1994-04-12	1994-04-12 00:00:00	38000275	0	\N	\N	244689	0	180256009	4107731	
30099	2661	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	176327	0	180256009	4107731	
30260	2673	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	177163	0	180256009	4107731	
42281	3733	4151422	1984-04-28	1984-04-28 00:00:00	38000275	0	\N	\N	248055	0	269911007	4151422	
30560	2704	4293740	1994-12-11	1994-12-11 00:00:00	38000275	0	\N	\N	179113	0	384700001	4293740	
30764	2715	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	180075	0	180256009	4107731	
30959	2752	4170947	1969-03-02	1969-03-02 00:00:00	38000275	0	\N	\N	182116	0	274474001	4170947	
43019	3787	4125906	1980-11-01	1980-11-01 00:00:00	38000275	0	\N	\N	251786	0	288086009	4125906	
19448	1659	4043071	1979-09-17	1979-09-17 00:00:00	38000275	0	\N	\N	111529	0	228557008	4043071	
31511	2779	4107731	1995-09-06	1995-09-06 00:00:00	38000275	0	\N	\N	184160	0	180256009	4107731	
43644	3859	4195803	1993-03-06	1993-03-06 00:00:00	38000275	0	\N	\N	256153	0	312681000	4195803	
43856	3874	4107731	1996-06-05	1996-06-05 00:00:00	38000275	0	\N	\N	257219	0	180256009	4107731	
43946	3876	4107731	1993-02-08	1993-02-08 00:00:00	38000275	0	\N	\N	257438	0	180256009	4107731	
20325	1759	4295880	2007-02-19	2007-02-19 00:00:00	38000275	0	\N	\N	117584	0	76601001	4295880	
56309	4916	4024289	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	326698	0	19490002	4024289	
44602	3913	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	260097	0	180256009	4107731	
44834	3932	4170947	1975-06-17	1975-06-17 00:00:00	38000275	0	\N	\N	261411	0	274474001	4170947	
33023	2896	4107731	1992-05-17	1992-05-17 00:00:00	38000275	0	\N	\N	192855	0	180256009	4107731	
21299	1845	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	123372	0	180256009	4107731	
33321	2915	4107731	1990-09-16	1990-09-16 00:00:00	38000275	0	\N	\N	194297	0	180256009	4107731	
57438	4976	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	331093	0	180256009	4107731	
33767	2942	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	196097	0	180256009	4107731	
34000	2959	4151422	1993-02-24	1993-02-24 00:00:00	38000275	0	\N	\N	197538	0	269911007	4151422	
34127	2966	4107731	1990-04-21	1990-04-21 00:00:00	38000275	0	\N	\N	198079	0	180256009	4107731	
22409	1966	4252419	2010-04-30	2010-04-30 00:00:00	38000275	0	\N	\N	130740	0	74016001	4252419	
34425	2980	4107731	1992-06-07	1992-06-07 00:00:00	38000275	0	\N	\N	199015	0	180256009	4107731	
46576	4085	4043071	1967-09-10	1967-09-10 00:00:00	38000275	0	\N	\N	271516	0	228557008	4043071	
34892	3041	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	202460	0	180256009	4107731	
58975	5116	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	340000	0	180256009	4107731	
35279	3077	4125906	1975-03-16	1975-03-16 00:00:00	38000275	0	\N	\N	204720	0	288086009	4125906	
47315	4153	44783196	1999-11-08	1999-11-08 00:00:00	38000275	0	\N	\N	276038	0	699253003	44783196	
35624	3118	4107731	1992-03-08	1992-03-08 00:00:00	38000275	0	\N	\N	207475	0	180256009	4107731	
35731	3128	4107731	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	208128	0	180256009	4107731	
12092	1102	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	72479	0	180256009	4107731	
36122	3168	4170947	1981-12-09	1981-12-09 00:00:00	38000275	0	\N	\N	210647	0	274474001	4170947	
24388	2135	4107731	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	142189	0	180256009	4107731	
36504	3207	4043071	1974-08-22	1974-08-22 00:00:00	38000275	0	\N	\N	213174	0	228557008	4043071	
36699	3221	4043071	1970-08-01	1970-08-01 00:00:00	38000275	0	\N	\N	214062	0	228557008	4043071	
24927	2175	4107731	2010-09-28	2010-09-28 00:00:00	38000275	0	\N	\N	145058	0	180256009	4107731	
25192	2192	40492359	2001-12-06	2001-12-06 00:00:00	38000275	0	\N	\N	146244	0	447365002	40492359	
25388	2211	4043071	1986-02-16	1986-02-16 00:00:00	38000275	0	\N	\N	147304	0	228557008	4043071	
25607	2238	4107731	1992-09-13	1992-09-13 00:00:00	38000275	0	\N	\N	148953	0	180256009	4107731	
25802	2265	4107731	1990-10-07	1990-10-07 00:00:00	38000275	0	\N	\N	150568	0	180256009	4107731	
25835	2265	4107731	1990-11-18	1990-11-18 00:00:00	38000275	0	\N	\N	150569	0	180256009	4107731	
26078	2280	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	151660	0	180256009	4107731	
26320	2292	4035793	2015-03-06	2015-03-06 00:00:00	38000275	0	\N	\N	152591	0	15081005	4035793	
38411	3376	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	224068	0	180256009	4107731	
38527	3389	4170947	1973-01-15	1973-01-15 00:00:00	38000275	0	\N	\N	224743	0	274474001	4170947	
26814	2346	4163872	1974-08-22	1974-08-22 00:00:00	38000275	0	\N	\N	156217	0	399208008	4163872	
27037	2357	4151422	1955-03-19	1955-03-19 00:00:00	38000275	0	\N	\N	157091	0	269911007	4151422	
27159	2372	4163872	1965-05-02	1965-05-02 00:00:00	38000275	0	\N	\N	157822	0	399208008	4163872	
27450	2395	4125906	1989-07-26	1989-07-26 00:00:00	38000275	0	\N	\N	159240	0	288086009	4125906	
15699	1389	4187458	1962-03-03	1962-03-03 00:00:00	38000275	0	\N	\N	92180	0	415300000	4187458	
27818	2437	4047491	1963-08-11	1963-08-11 00:00:00	38000275	0	\N	\N	161667	0	1225002	4047491	
27996	2462	4107731	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	163223	0	180256009	4107731	
28106	2481	4125906	1997-07-21	1997-07-21 00:00:00	38000275	0	\N	\N	164389	0	288086009	4125906	
40242	3528	4107731	1991-09-23	1991-09-23 00:00:00	38000275	0	\N	\N	234172	0	180256009	4107731	
28513	2537	4107731	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	167606	0	180256009	4107731	
40627	3566	4043071	1959-08-10	1959-08-10 00:00:00	38000275	0	\N	\N	236905	0	228557008	4043071	
28964	2559	4107731	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	169559	0	180256009	4107731	
17167	1482	4107731	1992-12-12	1992-12-12 00:00:00	38000275	0	\N	\N	98841	0	180256009	4107731	
29291	2598	4151422	1994-02-24	1994-02-24 00:00:00	38000275	0	\N	\N	171894	0	269911007	4151422	
29416	2626	4243062	1976-01-25	1976-01-25 00:00:00	38000275	0	\N	\N	173742	0	60027007	4243062	
41635	3658	4293740	1977-05-09	1977-05-09 00:00:00	38000275	0	\N	\N	243506	0	384700001	4293740	
41775	3680	4107731	1995-03-14	1995-03-14 00:00:00	38000275	0	\N	\N	244700	0	180256009	4107731	
30100	2661	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	176288	0	180256009	4107731	
30261	2673	4107731	1992-11-16	1992-11-16 00:00:00	38000275	0	\N	\N	177094	0	180256009	4107731	
42282	3733	4295880	1995-10-24	1995-10-24 00:00:00	38000275	0	\N	\N	248050	0	76601001	4295880	
30561	2705	4078793	2017-01-14	2017-01-14 00:00:00	38000275	0	\N	\N	179250	0	180325003	4078793	
30765	2715	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	180083	0	180256009	4107731	
30960	2752	4024289	1969-03-02	1969-03-02 00:00:00	38000275	0	\N	\N	182116	0	19490002	4024289	
43020	3787	4151422	2010-10-04	2010-10-04 00:00:00	38000275	0	\N	\N	251736	0	269911007	4151422	
31231	2770	4107731	1992-04-25	1992-04-25 00:00:00	38000275	0	\N	\N	183319	0	180256009	4107731	
31512	2779	4107731	1997-07-30	1997-07-30 00:00:00	38000275	0	\N	\N	184181	0	180256009	4107731	
43645	3859	4170947	1995-10-23	1995-10-23 00:00:00	38000275	0	\N	\N	256267	0	274474001	4170947	
43857	3874	4107731	1997-12-03	1997-12-03 00:00:00	38000275	0	\N	\N	257268	0	180256009	4107731	
43947	3876	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	257466	0	180256009	4107731	
20326	1760	4170947	1988-12-18	1988-12-18 00:00:00	38000275	0	\N	\N	117688	0	274474001	4170947	
56310	4916	4151422	1977-08-30	1977-08-30 00:00:00	38000275	0	\N	\N	326687	0	269911007	4151422	
44603	3913	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	260092	0	180256009	4107731	
44835	3932	4163872	1989-01-04	1989-01-04 00:00:00	38000275	0	\N	\N	261399	0	399208008	4163872	
33024	2896	4107731	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	192801	0	180256009	4107731	
21300	1845	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	123375	0	180256009	4107731	
33322	2915	4107731	1993-04-18	1993-04-18 00:00:00	38000275	0	\N	\N	194254	0	180256009	4107731	
57439	4976	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	330943	0	180256009	4107731	
33768	2942	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	196229	0	180256009	4107731	
34001	2959	4043071	1980-02-06	1980-02-06 00:00:00	38000275	0	\N	\N	197477	0	228557008	4043071	
34128	2966	4107731	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	198137	0	180256009	4107731	
22410	1967	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	130860	0	180256009	4107731	
34426	2980	4107731	1990-07-15	1990-07-15 00:00:00	38000275	0	\N	\N	198970	0	180256009	4107731	
46577	4085	4058899	1966-03-26	1966-03-26 00:00:00	38000275	0	\N	\N	271439	0	168594001	4058899	
34893	3041	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	202544	0	180256009	4107731	
58976	5116	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	339908	0	180256009	4107731	
35280	3077	4170947	1968-01-01	1968-01-01 00:00:00	38000275	0	\N	\N	204718	0	274474001	4170947	
47320	4156	4216130	2006-02-27	2006-02-27 00:00:00	38000275	0	\N	\N	276159	0	415070008	4216130	
35625	3118	4107731	1991-02-24	1991-02-24 00:00:00	38000275	0	\N	\N	207510	0	180256009	4107731	
35732	3128	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	208211	0	180256009	4107731	
12093	1102	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	72368	0	180256009	4107731	
36123	3168	4163872	1981-12-09	1981-12-09 00:00:00	38000275	0	\N	\N	210647	0	399208008	4163872	
24389	2135	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	142142	0	180256009	4107731	
36505	3207	4043071	1973-01-11	1973-01-11 00:00:00	38000275	0	\N	\N	213157	0	228557008	4043071	
36700	3221	4198190	1967-06-02	1967-06-02 00:00:00	38000275	0	\N	\N	214129	0	80146002	4198190	
24928	2175	4107731	2010-03-23	2010-03-23 00:00:00	38000275	0	\N	\N	145035	0	180256009	4107731	
25193	2192	4151422	1997-11-15	1997-11-15 00:00:00	38000275	0	\N	\N	146175	0	269911007	4151422	
25389	2211	4170947	1997-02-03	1997-02-03 00:00:00	38000275	0	\N	\N	147320	0	274474001	4170947	
25608	2238	4107731	1993-02-07	1993-02-07 00:00:00	38000275	0	\N	\N	148922	0	180256009	4107731	
25803	2265	4107731	1993-01-24	1993-01-24 00:00:00	38000275	0	\N	\N	150505	0	180256009	4107731	
25836	2265	4107731	1990-08-05	1990-08-05 00:00:00	38000275	0	\N	\N	150610	0	180256009	4107731	
26079	2280	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	151567	0	395142003	4191853	
26321	2292	4252419	1986-08-14	1986-08-14 00:00:00	38000275	0	\N	\N	152634	0	74016001	4252419	
38412	3376	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	224069	0	180256009	4107731	
38528	3389	4047491	1973-01-15	1973-01-15 00:00:00	38000275	0	\N	\N	224743	0	1225002	4047491	
26815	2346	4125906	1966-04-22	1966-04-22 00:00:00	38000275	0	\N	\N	156216	0	288086009	4125906	
27038	2357	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	157012	0	180256009	4107731	
27160	2372	4198190	1967-04-02	1967-04-02 00:00:00	38000275	0	\N	\N	157859	0	80146002	4198190	
27451	2395	4170947	1966-01-28	1966-01-28 00:00:00	38000275	0	\N	\N	159237	0	274474001	4170947	
15700	1390	4125906	1967-10-21	1967-10-21 00:00:00	38000275	0	\N	\N	92247	0	288086009	4125906	
27819	2437	4125906	1962-08-02	1962-08-02 00:00:00	38000275	0	\N	\N	161666	0	288086009	4125906	
27997	2462	4107731	1990-07-15	1990-07-15 00:00:00	38000275	0	\N	\N	163257	0	180256009	4107731	
28107	2481	4024289	2012-08-22	2012-08-22 00:00:00	38000275	0	\N	\N	164390	0	19490002	4024289	
40243	3528	4107731	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	234254	0	180256009	4107731	
28514	2537	4107731	1993-01-24	1993-01-24 00:00:00	38000275	0	\N	\N	167777	0	180256009	4107731	
40628	3566	4107731	1992-07-13	1992-07-13 00:00:00	38000275	0	\N	\N	236975	0	180256009	4107731	
28965	2559	4125906	2012-05-07	2012-05-07 00:00:00	38000275	0	\N	\N	169521	0	288086009	4125906	
17168	1482	4107731	1990-10-06	1990-10-06 00:00:00	38000275	0	\N	\N	98891	0	180256009	4107731	
29292	2598	4151422	2007-04-25	2007-04-25 00:00:00	38000275	0	\N	\N	171929	0	269911007	4151422	
29417	2626	4170947	1976-01-25	1976-01-25 00:00:00	38000275	0	\N	\N	173742	0	274474001	4170947	
41636	3658	4125906	1977-05-09	1977-05-09 00:00:00	38000275	0	\N	\N	243506	0	288086009	4125906	
41776	3680	4107731	1994-05-24	1994-05-24 00:00:00	38000275	0	\N	\N	244690	0	180256009	4107731	
30101	2661	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	176302	0	180256009	4107731	
30262	2673	4107731	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	177079	0	180256009	4107731	
42283	3733	4295880	1992-10-22	1992-10-22 00:00:00	38000275	0	\N	\N	248028	0	76601001	4295880	
30562	2705	4078793	2013-12-28	2013-12-28 00:00:00	38000275	0	\N	\N	179176	0	180325003	4078793	
30766	2715	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	180030	0	180256009	4107731	
30961	2752	4125906	1960-01-14	1960-01-14 00:00:00	38000275	0	\N	\N	182114	0	288086009	4125906	
43021	3787	4216130	2016-08-27	2016-08-27 00:00:00	38000275	0	\N	\N	251789	0	415070008	4216130	
31232	2770	4107731	1990-03-31	1990-03-31 00:00:00	38000275	0	\N	\N	183335	0	180256009	4107731	
31513	2779	4107731	1995-08-16	1995-08-16 00:00:00	38000275	0	\N	\N	184174	0	180256009	4107731	
43646	3859	4024289	1995-10-23	1995-10-23 00:00:00	38000275	0	\N	\N	256267	0	19490002	4024289	
43858	3874	4107731	1995-08-16	1995-08-16 00:00:00	38000275	0	\N	\N	257221	0	180256009	4107731	
43948	3876	4107731	1993-01-18	1993-01-18 00:00:00	38000275	0	\N	\N	257464	0	180256009	4107731	
20327	1760	4047491	1988-12-18	1988-12-18 00:00:00	38000275	0	\N	\N	117688	0	1225002	4047491	
56311	4916	4125906	1978-06-24	1978-06-24 00:00:00	38000275	0	\N	\N	326697	0	288086009	4125906	
44604	3913	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	260158	0	180256009	4107731	
44836	3932	4170947	1989-01-04	1989-01-04 00:00:00	38000275	0	\N	\N	261399	0	274474001	4170947	
33025	2896	4107731	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	192783	0	180256009	4107731	
21301	1845	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	123301	0	395142003	4191853	
33323	2915	4107731	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	194266	0	180256009	4107731	
57440	4976	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	330974	0	180256009	4107731	
33769	2942	4078793	2016-09-28	2016-09-28 00:00:00	38000275	0	\N	\N	196074	0	180325003	4078793	
34002	2959	4043071	1979-08-29	1979-08-29 00:00:00	38000275	0	\N	\N	197475	0	228557008	4043071	
34129	2966	4107731	1992-06-06	1992-06-06 00:00:00	38000275	0	\N	\N	198136	0	180256009	4107731	
22411	1967	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	130786	0	180256009	4107731	
34427	2980	4107731	1991-12-01	1991-12-01 00:00:00	38000275	0	\N	\N	198932	0	180256009	4107731	
46578	4085	4043071	1967-02-05	1967-02-05 00:00:00	38000275	0	\N	\N	271535	0	228557008	4043071	
34894	3041	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	202454	0	180256009	4107731	
58977	5116	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	339898	0	180256009	4107731	
35281	3077	4163872	1968-01-01	1968-01-01 00:00:00	38000275	0	\N	\N	204718	0	399208008	4163872	
47321	4156	4058899	1962-12-12	1962-12-12 00:00:00	38000275	0	\N	\N	276157	0	168594001	4058899	
35626	3118	4107731	1991-04-28	1991-04-28 00:00:00	38000275	0	\N	\N	207471	0	180256009	4107731	
35733	3128	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	208117	0	180256009	4107731	
12094	1102	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	72445	0	180256009	4107731	
36124	3168	4170947	2010-12-03	2010-12-03 00:00:00	38000275	0	\N	\N	210622	0	274474001	4170947	
24390	2135	4107731	1992-10-26	1992-10-26 00:00:00	38000275	0	\N	\N	142181	0	180256009	4107731	
36506	3207	4043071	1974-05-30	1974-05-30 00:00:00	38000275	0	\N	\N	213173	0	228557008	4043071	
36701	3221	4043071	1971-01-09	1971-01-09 00:00:00	38000275	0	\N	\N	214108	0	228557008	4043071	
24929	2175	4107731	2009-12-08	2009-12-08 00:00:00	38000275	0	\N	\N	145020	0	180256009	4107731	
25194	2192	4058899	1962-08-13	1962-08-13 00:00:00	38000275	0	\N	\N	146243	0	168594001	4058899	
25390	2211	4243062	1997-02-03	1997-02-03 00:00:00	38000275	0	\N	\N	147320	0	60027007	4243062	
25609	2238	4107731	1992-10-04	1992-10-04 00:00:00	38000275	0	\N	\N	148964	0	180256009	4107731	
25804	2265	4107731	1992-08-30	1992-08-30 00:00:00	38000275	0	\N	\N	150607	0	180256009	4107731	
25837	2266	4125906	2006-12-07	2006-12-07 00:00:00	38000275	0	\N	\N	150638	0	288086009	4125906	
26080	2280	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	151583	0	180256009	4107731	
26322	2292	4170947	1964-12-09	1964-12-09 00:00:00	38000275	0	\N	\N	152594	0	274474001	4170947	
38413	3376	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	224011	0	180256009	4107731	
38529	3389	4170947	1976-07-28	1976-07-28 00:00:00	38000275	0	\N	\N	224744	0	274474001	4170947	
26816	2347	4238715	1989-01-09	1989-01-09 00:00:00	38000275	0	\N	\N	156227	0	68254000	4238715	
27039	2357	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	156981	0	180256009	4107731	
27161	2372	4125906	1974-04-14	1974-04-14 00:00:00	38000275	0	\N	\N	157840	0	288086009	4125906	
27452	2395	4047491	1966-01-28	1966-01-28 00:00:00	38000275	0	\N	\N	159237	0	1225002	4047491	
15701	1390	4170947	2013-12-21	2013-12-21 00:00:00	38000275	0	\N	\N	92251	0	274474001	4170947	
27820	2438	4151422	2014-01-12	2014-01-12 00:00:00	38000275	0	\N	\N	161753	0	269911007	4151422	
27998	2462	4107731	1993-03-28	1993-03-28 00:00:00	38000275	0	\N	\N	163300	0	180256009	4107731	
28108	2481	4170947	2012-08-22	2012-08-22 00:00:00	38000275	0	\N	\N	164390	0	274474001	4170947	
40244	3528	4107731	1992-09-14	1992-09-14 00:00:00	38000275	0	\N	\N	234188	0	180256009	4107731	
28515	2537	4107731	1991-12-01	1991-12-01 00:00:00	38000275	0	\N	\N	167658	0	180256009	4107731	
40629	3566	4107731	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	236968	0	180256009	4107731	
28966	2559	4107731	1990-12-08	1990-12-08 00:00:00	38000275	0	\N	\N	169588	0	180256009	4107731	
17169	1482	4107731	1991-05-04	1991-05-04 00:00:00	38000275	0	\N	\N	98860	0	180256009	4107731	
29293	2598	4047491	1986-09-02	1986-09-02 00:00:00	38000275	0	\N	\N	171921	0	1225002	4047491	
29418	2626	4151422	2007-12-19	2007-12-19 00:00:00	38000275	0	\N	\N	173682	0	269911007	4151422	
41637	3658	4163872	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	243439	0	399208008	4163872	
41777	3680	4107731	1992-09-01	1992-09-01 00:00:00	38000275	0	\N	\N	244782	0	180256009	4107731	
30102	2661	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	176376	0	180256009	4107731	
30263	2673	4107731	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	177142	0	180256009	4107731	
42284	3734	4195803	2006-07-11	2006-07-11 00:00:00	38000275	0	\N	\N	248174	0	312681000	4195803	
30563	2705	4078793	2010-12-11	2010-12-11 00:00:00	38000275	0	\N	\N	179219	0	180325003	4078793	
30775	2721	4078793	2019-05-04	2019-05-04 00:00:00	38000275	0	\N	\N	180324	0	180325003	4078793	
30962	2752	4293740	1960-01-14	1960-01-14 00:00:00	38000275	0	\N	\N	182114	0	384700001	4293740	
43022	3787	4336464	2016-08-27	2016-08-27 00:00:00	38000275	0	\N	\N	251789	0	232717009	4336464	
31233	2770	4107731	1992-01-11	1992-01-11 00:00:00	38000275	0	\N	\N	183285	0	180256009	4107731	
31514	2779	4107731	1995-07-05	1995-07-05 00:00:00	38000275	0	\N	\N	184173	0	180256009	4107731	
43647	3859	4035793	2003-09-13	2003-09-13 00:00:00	38000275	0	\N	\N	256156	0	15081005	4035793	
43859	3874	4107731	1995-07-05	1995-07-05 00:00:00	38000275	0	\N	\N	257311	0	180256009	4107731	
43949	3876	4107731	1991-04-29	1991-04-29 00:00:00	38000275	0	\N	\N	257500	0	180256009	4107731	
20328	1760	4252419	2006-01-23	2006-01-23 00:00:00	38000275	0	\N	\N	117690	0	74016001	4252419	
56312	4917	4170947	1993-08-23	1993-08-23 00:00:00	38000275	0	\N	\N	326747	0	274474001	4170947	
44605	3913	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	260120	0	180256009	4107731	
44837	3932	4151422	2018-05-06	2018-05-06 00:00:00	38000275	0	\N	\N	261398	0	269911007	4151422	
33026	2896	4107731	1991-10-20	1991-10-20 00:00:00	38000275	0	\N	\N	192774	0	180256009	4107731	
21302	1845	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	123347	0	180256009	4107731	
33324	2915	4107731	1992-02-23	1992-02-23 00:00:00	38000275	0	\N	\N	194393	0	180256009	4107731	
57441	4976	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	330948	0	180256009	4107731	
33770	2942	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	196100	0	180256009	4107731	
34003	2959	4107731	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	197558	0	180256009	4107731	
34130	2966	4107731	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	198160	0	180256009	4107731	
22412	1967	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	130855	0	180256009	4107731	
34428	2980	4107731	1990-08-26	1990-08-26 00:00:00	38000275	0	\N	\N	198971	0	180256009	4107731	
46579	4085	4043071	1968-03-17	1968-03-17 00:00:00	38000275	0	\N	\N	271488	0	228557008	4043071	
34895	3041	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	202533	0	180256009	4107731	
58978	5116	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	340003	0	180256009	4107731	
35282	3077	4243062	1954-06-17	1954-06-17 00:00:00	38000275	0	\N	\N	204779	0	60027007	4243062	
47322	4156	4336464	2007-12-24	2007-12-24 00:00:00	38000275	0	\N	\N	276160	0	232717009	4336464	
35627	3118	4107731	1990-05-27	1990-05-27 00:00:00	38000275	0	\N	\N	207526	0	180256009	4107731	
35734	3128	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	208142	0	180256009	4107731	
12095	1102	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	72420	0	180256009	4107731	
36125	3168	4047491	2010-12-03	2010-12-03 00:00:00	38000275	0	\N	\N	210622	0	1225002	4047491	
24391	2135	4107731	1990-12-03	1990-12-03 00:00:00	38000275	0	\N	\N	142188	0	180256009	4107731	
36507	3207	4043071	1973-05-24	1973-05-24 00:00:00	38000275	0	\N	\N	213192	0	228557008	4043071	
36702	3221	4043071	1971-07-10	1971-07-10 00:00:00	38000275	0	\N	\N	214084	0	228557008	4043071	
24930	2175	4107731	2011-03-15	2011-03-15 00:00:00	38000275	0	\N	\N	145040	0	180256009	4107731	
25195	2192	4275113	1981-10-14	1981-10-14 00:00:00	38000275	0	\N	\N	146156	0	65200003	4275113	
25391	2211	4043071	1986-01-19	1986-01-19 00:00:00	38000275	0	\N	\N	147325	0	228557008	4043071	
25610	2238	4107731	1991-08-11	1991-08-11 00:00:00	38000275	0	\N	\N	148987	0	180256009	4107731	
25805	2265	4151422	1986-05-23	1986-05-23 00:00:00	38000275	0	\N	\N	150559	0	269911007	4151422	
25838	2266	4125906	1978-06-25	1978-06-25 00:00:00	38000275	0	\N	\N	150635	0	288086009	4125906	
26081	2280	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	151580	0	180256009	4107731	
26323	2292	4047491	1964-12-09	1964-12-09 00:00:00	38000275	0	\N	\N	152594	0	1225002	4047491	
38414	3376	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	223960	0	180256009	4107731	
38530	3389	4047491	1976-07-28	1976-07-28 00:00:00	38000275	0	\N	\N	224744	0	1225002	4047491	
26817	2347	4125906	2001-11-23	2001-11-23 00:00:00	38000275	0	\N	\N	156224	0	288086009	4125906	
27040	2357	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	157026	0	180256009	4107731	
27162	2373	4163872	1957-10-10	1957-10-10 00:00:00	38000275	0	\N	\N	157944	0	399208008	4163872	
27453	2396	4195803	2000-09-03	2000-09-03 00:00:00	38000275	0	\N	\N	159324	0	312681000	4195803	
15702	1390	4024289	2013-12-21	2013-12-21 00:00:00	38000275	0	\N	\N	92251	0	19490002	4024289	
27821	2438	4125906	2010-01-21	2010-01-21 00:00:00	38000275	0	\N	\N	161756	0	288086009	4125906	
27999	2462	4107731	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	163260	0	180256009	4107731	
28109	2482	4170947	2002-03-26	2002-03-26 00:00:00	38000275	0	\N	\N	164479	0	274474001	4170947	
40245	3528	4107731	1990-06-18	1990-06-18 00:00:00	38000275	0	\N	\N	234245	0	180256009	4107731	
28516	2537	4107731	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	167620	0	180256009	4107731	
40630	3566	4043071	1960-05-30	1960-05-30 00:00:00	38000275	0	\N	\N	236813	0	228557008	4043071	
28967	2559	4107731	1991-04-13	1991-04-13 00:00:00	38000275	0	\N	\N	169601	0	180256009	4107731	
17170	1482	4107731	1991-02-09	1991-02-09 00:00:00	38000275	0	\N	\N	98858	0	180256009	4107731	
29294	2598	4170947	1986-09-02	1986-09-02 00:00:00	38000275	0	\N	\N	171921	0	274474001	4170947	
29419	2626	4151422	1974-03-08	1974-03-08 00:00:00	38000275	0	\N	\N	173711	0	269911007	4151422	
41638	3658	4047491	1972-09-02	1972-09-02 00:00:00	38000275	0	\N	\N	243505	0	1225002	4047491	
41778	3680	4107731	1994-03-01	1994-03-01 00:00:00	38000275	0	\N	\N	244788	0	180256009	4107731	
30103	2661	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	176273	0	180256009	4107731	
30264	2673	4107731	1991-09-23	1991-09-23 00:00:00	38000275	0	\N	\N	177146	0	180256009	4107731	
42285	3734	4145310	2006-07-11	2006-07-11 00:00:00	38000275	0	\N	\N	248174	0	268425006	4145310	
30564	2705	4057420	2011-12-03	2011-12-03 00:00:00	38000275	0	\N	\N	\N	0	18286008	4057420	
30776	2721	4078793	2018-04-28	2018-04-28 00:00:00	38000275	0	\N	\N	180316	0	180325003	4078793	
30963	2752	4010253	1994-05-21	1994-05-21 00:00:00	38000275	0	\N	\N	182036	0	112790001	4010253	
43023	3787	4198190	1981-11-07	1981-11-07 00:00:00	38000275	0	\N	\N	251767	0	80146002	4198190	
31234	2770	4202451	2018-12-15	2018-12-15 00:00:00	38000275	0	\N	\N	183308	0	433112001	4202451	
31515	2779	4107731	1997-02-12	1997-02-12 00:00:00	38000275	0	\N	\N	184150	0	180256009	4107731	
43648	3859	4151422	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	256210	0	269911007	4151422	
43860	3874	4107731	1997-05-07	1997-05-07 00:00:00	38000275	0	\N	\N	257260	0	180256009	4107731	
43950	3876	4107731	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	257477	0	180256009	4107731	
20329	1760	4010253	2018-06-19	2018-06-19 00:00:00	38000275	0	\N	\N	117674	0	112790001	4010253	
56313	4917	4243062	1993-08-23	1993-08-23 00:00:00	38000275	0	\N	\N	326747	0	60027007	4243062	
44606	3913	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	260167	0	180256009	4107731	
44838	3934	4058899	1945-08-02	1945-08-02 00:00:00	38000275	0	\N	\N	261499	0	168594001	4058899	
33027	2896	4107731	1990-08-26	1990-08-26 00:00:00	38000275	0	\N	\N	192838	0	180256009	4107731	
21303	1845	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	123391	0	180256009	4107731	
33325	2915	4107731	1991-10-20	1991-10-20 00:00:00	38000275	0	\N	\N	194248	0	180256009	4107731	
57442	4976	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	330953	0	180256009	4107731	
33771	2942	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	196082	0	180256009	4107731	
34004	2959	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	197498	0	180256009	4107731	
34131	2966	4107731	1991-09-07	1991-09-07 00:00:00	38000275	0	\N	\N	198084	0	180256009	4107731	
22413	1967	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	130756	0	180256009	4107731	
34429	2980	4107731	1991-03-03	1991-03-03 00:00:00	38000275	0	\N	\N	198972	0	180256009	4107731	
46580	4085	4043071	1967-11-12	1967-11-12 00:00:00	38000275	0	\N	\N	271537	0	228557008	4043071	
34896	3041	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	202458	0	180256009	4107731	
58979	5116	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	339963	0	180256009	4107731	
35283	3077	4170947	1954-06-17	1954-06-17 00:00:00	38000275	0	\N	\N	204779	0	274474001	4170947	
47323	4156	4216130	2007-12-24	2007-12-24 00:00:00	38000275	0	\N	\N	276160	0	415070008	4216130	
35628	3118	4107731	1991-09-01	1991-09-01 00:00:00	38000275	0	\N	\N	207428	0	180256009	4107731	
35735	3128	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	208144	0	180256009	4107731	
12096	1102	4107731	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	72447	0	180256009	4107731	
36126	3168	4145310	2008-10-14	2008-10-14 00:00:00	38000275	0	\N	\N	210651	0	268425006	4145310	
24392	2135	4107731	1991-02-25	1991-02-25 00:00:00	38000275	0	\N	\N	142172	0	180256009	4107731	
36508	3207	4043071	1975-01-30	1975-01-30 00:00:00	38000275	0	\N	\N	213182	0	228557008	4043071	
36703	3221	4043071	1971-02-06	1971-02-06 00:00:00	38000275	0	\N	\N	214081	0	228557008	4043071	
24931	2175	4107731	2012-05-29	2012-05-29 00:00:00	38000275	0	\N	\N	144966	0	180256009	4107731	
37027	3253	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	216250	0	180256009	4107731	
25392	2211	4163872	1973-04-10	1973-04-10 00:00:00	38000275	0	\N	\N	147319	0	399208008	4163872	
25611	2238	4107731	1992-02-16	1992-02-16 00:00:00	38000275	0	\N	\N	148989	0	180256009	4107731	
25806	2265	4107731	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	150520	0	180256009	4107731	
25839	2266	4151422	1991-04-28	1991-04-28 00:00:00	38000275	0	\N	\N	150641	0	269911007	4151422	
26082	2280	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	151584	0	180256009	4107731	
26324	2292	4151422	1984-05-13	1984-05-13 00:00:00	38000275	0	\N	\N	152565	0	269911007	4151422	
38415	3376	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	224040	0	180256009	4107731	
38531	3389	4151422	1976-08-28	1976-08-28 00:00:00	38000275	0	\N	\N	224770	0	269911007	4151422	
26818	2347	4275113	1985-11-16	1985-11-16 00:00:00	38000275	0	\N	\N	156257	0	65200003	4275113	
27041	2357	4191853	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	156941	0	395142003	4191853	
27163	2373	4170947	1957-10-10	1957-10-10 00:00:00	38000275	0	\N	\N	157944	0	274474001	4170947	
27454	2396	4058899	2000-09-03	2000-09-03 00:00:00	38000275	0	\N	\N	159324	0	168594001	4058899	
15703	1391	4170947	1997-12-20	1997-12-20 00:00:00	38000275	0	\N	\N	92409	0	274474001	4170947	
27822	2438	4125906	1997-05-15	1997-05-15 00:00:00	38000275	0	\N	\N	161755	0	288086009	4125906	
28000	2462	4107731	1990-02-18	1990-02-18 00:00:00	38000275	0	\N	\N	163321	0	180256009	4107731	
28110	2482	4243062	2002-03-26	2002-03-26 00:00:00	38000275	0	\N	\N	164479	0	60027007	4243062	
40246	3528	4107731	1992-02-17	1992-02-17 00:00:00	38000275	0	\N	\N	234257	0	180256009	4107731	
28517	2537	4107731	1991-12-22	1991-12-22 00:00:00	38000275	0	\N	\N	167618	0	180256009	4107731	
40631	3566	4043071	1961-04-10	1961-04-10 00:00:00	38000275	0	\N	\N	236868	0	228557008	4043071	
28968	2559	4107731	1992-04-04	1992-04-04 00:00:00	38000275	0	\N	\N	169609	0	180256009	4107731	
17171	1482	4107731	1992-02-01	1992-02-01 00:00:00	38000275	0	\N	\N	98863	0	180256009	4107731	
29295	2598	4125906	1992-07-07	1992-07-07 00:00:00	38000275	0	\N	\N	171923	0	288086009	4125906	
29420	2626	4170947	1991-08-04	1991-08-04 00:00:00	38000275	0	\N	\N	173743	0	274474001	4170947	
41639	3658	4170947	1972-09-02	1972-09-02 00:00:00	38000275	0	\N	\N	243505	0	274474001	4170947	
41779	3680	4191853	1995-10-10	1995-10-10 00:00:00	38000275	0	\N	\N	244695	0	395142003	4191853	
30104	2661	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	176271	0	180256009	4107731	
30265	2673	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	177156	0	180256009	4107731	
42286	3734	4151422	1950-04-10	1950-04-10 00:00:00	38000275	0	\N	\N	248121	0	269911007	4151422	
30565	2705	4125906	2013-03-20	2013-03-20 00:00:00	38000275	0	\N	\N	179246	0	288086009	4125906	
30777	2721	4078793	2017-04-22	2017-04-22 00:00:00	38000275	0	\N	\N	180323	0	180325003	4078793	
31038	2757	4010253	2006-07-19	2006-07-19 00:00:00	38000275	0	\N	\N	182371	0	112790001	4010253	
43024	3787	4170947	1966-06-18	1966-06-18 00:00:00	38000275	0	\N	\N	251785	0	274474001	4170947	
31235	2770	4107731	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	183325	0	180256009	4107731	
31516	2779	4191853	1998-06-10	1998-06-10 00:00:00	38000275	0	\N	\N	184202	0	395142003	4191853	
43649	3859	4035793	2011-10-29	2011-10-29 00:00:00	38000275	0	\N	\N	256245	0	15081005	4035793	
43861	3874	4107731	1996-04-03	1996-04-03 00:00:00	38000275	0	\N	\N	257223	0	180256009	4107731	
43951	3876	4107731	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	257481	0	180256009	4107731	
20330	1761	4010253	2011-10-23	2011-10-23 00:00:00	38000275	0	\N	\N	117745	0	112790001	4010253	
56314	4917	4125906	1994-12-16	1994-12-16 00:00:00	38000275	0	\N	\N	326748	0	288086009	4125906	
44607	3913	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	260123	0	180256009	4107731	
44839	3934	4057420	1984-09-19	1984-09-19 00:00:00	38000275	0	\N	\N	261504	0	18286008	4057420	
33028	2896	4107731	1990-04-22	1990-04-22 00:00:00	38000275	0	\N	\N	192784	0	180256009	4107731	
21304	1845	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	123371	0	180256009	4107731	
33326	2915	4107731	1990-11-18	1990-11-18 00:00:00	38000275	0	\N	\N	194317	0	180256009	4107731	
57443	4976	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	330951	0	180256009	4107731	
33772	2942	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	196157	0	395142003	4191853	
34005	2959	4024289	1975-03-31	1975-03-31 00:00:00	38000275	0	\N	\N	197602	0	19490002	4024289	
34132	2966	4107731	1991-11-30	1991-11-30 00:00:00	38000275	0	\N	\N	198135	0	180256009	4107731	
22414	1967	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	130757	0	180256009	4107731	
34430	2980	4107731	1992-02-23	1992-02-23 00:00:00	38000275	0	\N	\N	198934	0	180256009	4107731	
46581	4085	4043071	1967-04-09	1967-04-09 00:00:00	38000275	0	\N	\N	271514	0	228557008	4043071	
34897	3041	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	202539	0	180256009	4107731	
58980	5116	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	339995	0	395142003	4191853	
35284	3077	4125906	1972-03-10	1972-03-10 00:00:00	38000275	0	\N	\N	204719	0	288086009	4125906	
47324	4156	4293740	1966-09-22	1966-09-22 00:00:00	38000275	0	\N	\N	276158	0	384700001	4293740	
35629	3118	4107731	1991-11-03	1991-11-03 00:00:00	38000275	0	\N	\N	207416	0	180256009	4107731	
35736	3128	4295880	1995-09-12	1995-09-12 00:00:00	38000275	0	\N	\N	208086	0	76601001	4295880	
12097	1102	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	72372	0	180256009	4107731	
36127	3168	4170947	1987-03-13	1987-03-13 00:00:00	38000275	0	\N	\N	210648	0	274474001	4170947	
24393	2135	4107731	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	142164	0	180256009	4107731	
36509	3207	4043071	1973-11-15	1973-11-15 00:00:00	38000275	0	\N	\N	213171	0	228557008	4043071	
36704	3221	4043071	1971-04-03	1971-04-03 00:00:00	38000275	0	\N	\N	214090	0	228557008	4043071	
24932	2175	4107731	2010-02-09	2010-02-09 00:00:00	38000275	0	\N	\N	145056	0	180256009	4107731	
37028	3253	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	216390	0	180256009	4107731	
25393	2211	4170947	1973-04-10	1973-04-10 00:00:00	38000275	0	\N	\N	147319	0	274474001	4170947	
25612	2238	4107731	1991-02-24	1991-02-24 00:00:00	38000275	0	\N	\N	149008	0	180256009	4107731	
37637	3321	4125906	1991-03-17	1991-03-17 00:00:00	38000275	0	\N	\N	220501	0	288086009	4125906	
25840	2267	4151422	1983-10-21	1983-10-21 00:00:00	38000275	0	\N	\N	150708	0	269911007	4151422	
26083	2280	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	151574	0	180256009	4107731	
26325	2292	4293740	2007-02-05	2007-02-05 00:00:00	38000275	0	\N	\N	152638	0	384700001	4293740	
38416	3376	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	224013	0	180256009	4107731	
38532	3389	4293740	2016-12-25	2016-12-25 00:00:00	38000275	0	\N	\N	224745	0	384700001	4293740	
26819	2347	4058899	1974-03-06	1974-03-06 00:00:00	38000275	0	\N	\N	156221	0	168594001	4058899	
27042	2357	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	157049	0	180256009	4107731	
27164	2373	4151422	1961-04-08	1961-04-08 00:00:00	38000275	0	\N	\N	157883	0	269911007	4151422	
27455	2396	4151422	1972-10-23	1972-10-23 00:00:00	38000275	0	\N	\N	159384	0	269911007	4151422	
15704	1391	4047491	1997-12-20	1997-12-20 00:00:00	38000275	0	\N	\N	92409	0	1225002	4047491	
27823	2439	4275113	1989-05-02	1989-05-02 00:00:00	38000275	0	\N	\N	161787	0	65200003	4275113	
28001	2462	4107731	1990-10-07	1990-10-07 00:00:00	38000275	0	\N	\N	163323	0	180256009	4107731	
28111	2482	4145310	1976-07-03	1976-07-03 00:00:00	38000275	0	\N	\N	164477	0	268425006	4145310	
40247	3528	4107731	1992-06-22	1992-06-22 00:00:00	38000275	0	\N	\N	234176	0	180256009	4107731	
28518	2537	4107731	1991-07-07	1991-07-07 00:00:00	38000275	0	\N	\N	167603	0	180256009	4107731	
40632	3566	4107731	1990-10-01	1990-10-01 00:00:00	38000275	0	\N	\N	236895	0	180256009	4107731	
28969	2559	4107731	1990-07-14	1990-07-14 00:00:00	38000275	0	\N	\N	169598	0	180256009	4107731	
17172	1482	4107731	1993-05-08	1993-05-08 00:00:00	38000275	0	\N	\N	98898	0	180256009	4107731	
29296	2599	4186930	1999-01-16	1999-01-16 00:00:00	38000275	0	\N	\N	171994	0	46706006	4186930	
29421	2626	4024289	1991-08-04	1991-08-04 00:00:00	38000275	0	\N	\N	173743	0	19490002	4024289	
41640	3660	4125906	1987-11-29	1987-11-29 00:00:00	38000275	0	\N	\N	243603	0	288086009	4125906	
41780	3680	4107731	1994-03-22	1994-03-22 00:00:00	38000275	0	\N	\N	244754	0	180256009	4107731	
30105	2661	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	176378	0	180256009	4107731	
30266	2673	4107731	1991-07-22	1991-07-22 00:00:00	38000275	0	\N	\N	177172	0	180256009	4107731	
42287	3734	4125906	1949-07-12	1949-07-12 00:00:00	38000275	0	\N	\N	248170	0	288086009	4125906	
30566	2705	4078793	2015-01-03	2015-01-03 00:00:00	38000275	0	\N	\N	179249	0	180325003	4078793	
30782	2724	4043071	1963-07-07	1963-07-07 00:00:00	38000275	0	\N	\N	180495	0	228557008	4043071	
31039	2757	4047491	1978-03-06	1978-03-06 00:00:00	38000275	0	\N	\N	182336	0	1225002	4047491	
43025	3787	4047491	1966-06-18	1966-06-18 00:00:00	38000275	0	\N	\N	251785	0	1225002	4047491	
31236	2770	4107731	1991-09-07	1991-09-07 00:00:00	38000275	0	\N	\N	183317	0	180256009	4107731	
31517	2779	4107731	1996-10-09	1996-10-09 00:00:00	38000275	0	\N	\N	184104	0	180256009	4107731	
43650	3859	4035793	2014-11-15	2014-11-15 00:00:00	38000275	0	\N	\N	256280	0	15081005	4035793	
43862	3874	4107731	1997-06-18	1997-06-18 00:00:00	38000275	0	\N	\N	257261	0	180256009	4107731	
43952	3876	4107731	1990-01-22	1990-01-22 00:00:00	38000275	0	\N	\N	257472	0	180256009	4107731	
20331	1761	4125906	2016-05-10	2016-05-10 00:00:00	38000275	0	\N	\N	117722	0	288086009	4125906	
56345	4922	4043071	1984-11-07	1984-11-07 00:00:00	38000275	0	\N	\N	327039	0	228557008	4043071	
44608	3913	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	260176	0	180256009	4107731	
44840	3934	40492359	1984-09-19	1984-09-19 00:00:00	38000275	0	\N	\N	261504	0	447365002	40492359	
33029	2896	4107731	1990-08-05	1990-08-05 00:00:00	38000275	0	\N	\N	192842	0	180256009	4107731	
21305	1845	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	123349	0	180256009	4107731	
33327	2915	4195803	2005-04-03	2005-04-03 00:00:00	38000275	0	\N	\N	194378	0	312681000	4195803	
57444	4976	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	331070	0	180256009	4107731	
33773	2943	4125906	1917-03-17	1917-03-17 00:00:00	38000275	0	\N	\N	196243	0	288086009	4125906	
34006	2959	4170947	1975-03-31	1975-03-31 00:00:00	38000275	0	\N	\N	197602	0	274474001	4170947	
34133	2966	4107731	1992-10-10	1992-10-10 00:00:00	38000275	0	\N	\N	198095	0	180256009	4107731	
22415	1967	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	130861	0	180256009	4107731	
34431	2980	4107731	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	198992	0	180256009	4107731	
46582	4086	4125906	1979-11-23	1979-11-23 00:00:00	38000275	0	\N	\N	271570	0	288086009	4125906	
34898	3041	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	202537	0	180256009	4107731	
58981	5116	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	339961	0	180256009	4107731	
35285	3079	4170947	1979-05-24	1979-05-24 00:00:00	38000275	0	\N	\N	204964	0	274474001	4170947	
47325	4156	4125906	1966-09-22	1966-09-22 00:00:00	38000275	0	\N	\N	276158	0	288086009	4125906	
35630	3118	4107731	1992-05-31	1992-05-31 00:00:00	38000275	0	\N	\N	207431	0	180256009	4107731	
35737	3128	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	208202	0	180256009	4107731	
12098	1102	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	72367	0	180256009	4107731	
36128	3168	4024289	1987-03-13	1987-03-13 00:00:00	38000275	0	\N	\N	210648	0	19490002	4024289	
24394	2135	4107731	1990-04-16	1990-04-16 00:00:00	38000275	0	\N	\N	142075	0	180256009	4107731	
36510	3207	4043071	1974-04-25	1974-04-25 00:00:00	38000275	0	\N	\N	213172	0	228557008	4043071	
36705	3221	4043071	1970-10-31	1970-10-31 00:00:00	38000275	0	\N	\N	214074	0	228557008	4043071	
24933	2175	4107731	2012-03-27	2012-03-27 00:00:00	38000275	0	\N	\N	145065	0	180256009	4107731	
37029	3253	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	216375	0	180256009	4107731	
25394	2211	4043071	1986-10-19	1986-10-19 00:00:00	38000275	0	\N	\N	147327	0	228557008	4043071	
25613	2238	4107731	1992-01-05	1992-01-05 00:00:00	38000275	0	\N	\N	149012	0	180256009	4107731	
37638	3321	4293740	1991-03-17	1991-03-17 00:00:00	38000275	0	\N	\N	220501	0	384700001	4293740	
25908	2270	4295880	2002-01-09	2002-01-09 00:00:00	38000275	0	\N	\N	150970	0	76601001	4295880	
26084	2280	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	151582	0	180256009	4107731	
26326	2292	4125906	2007-02-05	2007-02-05 00:00:00	38000275	0	\N	\N	152638	0	288086009	4125906	
38417	3376	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	223998	0	180256009	4107731	
38533	3389	4125906	2016-12-25	2016-12-25 00:00:00	38000275	0	\N	\N	224745	0	288086009	4125906	
26820	2347	4151422	2008-01-31	2008-01-31 00:00:00	38000275	0	\N	\N	156226	0	269911007	4151422	
27043	2357	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	157045	0	180256009	4107731	
27165	2373	4010253	1992-12-03	1992-12-03 00:00:00	38000275	0	\N	\N	157952	0	112790001	4010253	
27456	2396	4195803	1971-02-08	1971-02-08 00:00:00	38000275	0	\N	\N	159322	0	312681000	4195803	
15705	1391	4195803	1980-11-19	1980-11-19 00:00:00	38000275	0	\N	\N	92309	0	312681000	4195803	
27824	2439	4238715	1992-09-02	1992-09-02 00:00:00	38000275	0	\N	\N	161788	0	68254000	4238715	
28002	2462	4107731	1993-01-24	1993-01-24 00:00:00	38000275	0	\N	\N	163287	0	180256009	4107731	
28112	2482	4301346	1995-03-03	1995-03-03 00:00:00	38000275	0	\N	\N	164454	0	387685009	4301346	
40248	3528	4107731	1990-07-09	1990-07-09 00:00:00	38000275	0	\N	\N	234250	0	180256009	4107731	
28519	2537	4107731	1990-10-28	1990-10-28 00:00:00	38000275	0	\N	\N	167697	0	180256009	4107731	
40633	3566	4043071	1958-11-24	1958-11-24 00:00:00	38000275	0	\N	\N	236827	0	228557008	4043071	
28970	2559	4107731	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	169554	0	180256009	4107731	
17173	1482	4107731	1992-06-27	1992-06-27 00:00:00	38000275	0	\N	\N	98914	0	180256009	4107731	
29297	2599	4186930	2004-01-17	2004-01-17 00:00:00	38000275	0	\N	\N	171987	0	46706006	4186930	
29466	2630	4043071	1969-01-14	1969-01-14 00:00:00	38000275	0	\N	\N	173924	0	228557008	4043071	
41641	3660	4151422	2006-06-30	2006-06-30 00:00:00	38000275	0	\N	\N	243586	0	269911007	4151422	
41781	3680	4107731	1993-10-05	1993-10-05 00:00:00	38000275	0	\N	\N	244791	0	180256009	4107731	
30106	2661	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	176377	0	180256009	4107731	
30267	2673	4107731	1990-06-18	1990-06-18 00:00:00	38000275	0	\N	\N	177078	0	180256009	4107731	
42288	3734	4170947	1966-02-27	1966-02-27 00:00:00	38000275	0	\N	\N	248171	0	274474001	4170947	
30567	2705	4078793	2018-09-01	2018-09-01 00:00:00	38000275	0	\N	\N	179251	0	180325003	4078793	
30783	2724	4043071	1962-08-05	1962-08-05 00:00:00	38000275	0	\N	\N	180475	0	228557008	4043071	
31040	2757	4170947	1978-03-06	1978-03-06 00:00:00	38000275	0	\N	\N	182336	0	274474001	4170947	
43026	3788	4058899	1967-08-26	1967-08-26 00:00:00	38000275	0	\N	\N	251800	0	168594001	4058899	
31237	2770	4107731	1993-03-06	1993-03-06 00:00:00	38000275	0	\N	\N	183351	0	180256009	4107731	
31518	2779	4107731	1996-05-15	1996-05-15 00:00:00	38000275	0	\N	\N	184177	0	180256009	4107731	
43651	3859	4035793	2008-10-11	2008-10-11 00:00:00	38000275	0	\N	\N	256180	0	15081005	4035793	
43863	3874	4107731	1996-10-09	1996-10-09 00:00:00	38000275	0	\N	\N	257316	0	180256009	4107731	
43953	3876	4107731	1991-01-14	1991-01-14 00:00:00	38000275	0	\N	\N	257510	0	180256009	4107731	
20332	1761	4125906	1972-10-14	1972-10-14 00:00:00	38000275	0	\N	\N	117719	0	288086009	4125906	
56346	4922	4043071	1986-02-05	1986-02-05 00:00:00	38000275	0	\N	\N	326977	0	228557008	4043071	
44609	3913	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	260174	0	180256009	4107731	
44841	3934	4057420	2005-11-16	2005-11-16 00:00:00	38000275	0	\N	\N	261506	0	18286008	4057420	
33030	2896	4107731	1991-03-03	1991-03-03 00:00:00	38000275	0	\N	\N	192772	0	180256009	4107731	
21306	1845	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	123332	0	180256009	4107731	
33328	2915	4107731	1990-08-05	1990-08-05 00:00:00	38000275	0	\N	\N	194296	0	180256009	4107731	
57445	4976	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	330927	0	180256009	4107731	
33774	2943	4125906	1936-08-16	1936-08-16 00:00:00	38000275	0	\N	\N	196247	0	288086009	4125906	
34007	2959	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	197455	0	180256009	4107731	
34134	2966	4107731	1991-03-23	1991-03-23 00:00:00	38000275	0	\N	\N	198066	0	180256009	4107731	
22416	1967	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	130801	0	180256009	4107731	
34432	2980	4107731	1991-09-29	1991-09-29 00:00:00	38000275	0	\N	\N	198951	0	180256009	4107731	
46583	4086	4293740	1979-11-23	1979-11-23 00:00:00	38000275	0	\N	\N	271570	0	384700001	4293740	
34899	3041	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	202535	0	180256009	4107731	
58982	5116	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	340011	0	180256009	4107731	
35286	3079	4243062	1979-05-24	1979-05-24 00:00:00	38000275	0	\N	\N	204964	0	60027007	4243062	
47326	4156	4163872	2017-12-24	2017-12-24 00:00:00	38000275	0	\N	\N	276181	0	399208008	4163872	
35631	3118	4107731	1993-05-23	1993-05-23 00:00:00	38000275	0	\N	\N	207524	0	180256009	4107731	
35738	3128	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	208146	0	180256009	4107731	
12099	1102	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	72418	0	180256009	4107731	
36132	3170	4151422	1979-05-15	1979-05-15 00:00:00	38000275	0	\N	\N	210744	0	269911007	4151422	
24395	2135	4107731	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	142090	0	180256009	4107731	
36511	3207	4043071	1973-09-13	1973-09-13 00:00:00	38000275	0	\N	\N	213216	0	228557008	4043071	
36706	3221	4043071	1971-06-05	1971-06-05 00:00:00	38000275	0	\N	\N	214083	0	228557008	4043071	
24934	2175	4107731	2009-05-12	2009-05-12 00:00:00	38000275	0	\N	\N	145014	0	180256009	4107731	
37030	3253	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	216303	0	180256009	4107731	
25395	2211	4043071	1985-07-21	1985-07-21 00:00:00	38000275	0	\N	\N	147293	0	228557008	4043071	
25614	2238	4107731	1991-09-22	1991-09-22 00:00:00	38000275	0	\N	\N	148999	0	180256009	4107731	
37639	3321	4301346	2013-05-11	2013-05-11 00:00:00	38000275	0	\N	\N	220539	0	387685009	4301346	
25909	2270	4295880	2002-07-10	2002-07-10 00:00:00	38000275	0	\N	\N	150936	0	76601001	4295880	
26085	2280	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	151682	0	180256009	4107731	
26327	2292	4035793	2018-03-23	2018-03-23 00:00:00	38000275	0	\N	\N	152582	0	15081005	4035793	
38418	3376	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	224039	0	180256009	4107731	
38536	3391	4058899	2005-12-25	2005-12-25 00:00:00	38000275	0	\N	\N	224901	0	168594001	4058899	
26824	2349	4107731	1990-12-09	1990-12-09 00:00:00	38000275	0	\N	\N	156341	0	180256009	4107731	
27044	2357	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	157037	0	180256009	4107731	
27166	2373	4024289	1969-08-13	1969-08-13 00:00:00	38000275	0	\N	\N	157946	0	19490002	4024289	
27457	2396	4170947	1971-02-08	1971-02-08 00:00:00	38000275	0	\N	\N	159322	0	274474001	4170947	
15706	1391	4243062	1980-11-19	1980-11-19 00:00:00	38000275	0	\N	\N	92309	0	60027007	4243062	
27825	2439	4151422	1978-03-19	1978-03-19 00:00:00	38000275	0	\N	\N	161799	0	269911007	4151422	
28003	2462	4107731	1992-02-02	1992-02-02 00:00:00	38000275	0	\N	\N	163217	0	180256009	4107731	
28113	2482	4151422	1975-09-08	1975-09-08 00:00:00	38000275	0	\N	\N	164422	0	269911007	4151422	
40249	3528	4107731	1992-03-09	1992-03-09 00:00:00	38000275	0	\N	\N	234271	0	180256009	4107731	
28520	2537	4107731	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	167642	0	180256009	4107731	
40634	3566	4107731	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	236897	0	180256009	4107731	
28971	2559	4107731	1991-07-06	1991-07-06 00:00:00	38000275	0	\N	\N	169531	0	180256009	4107731	
17174	1482	4107731	1990-10-27	1990-10-27 00:00:00	38000275	0	\N	\N	98879	0	180256009	4107731	
29298	2599	4024289	1983-01-07	1983-01-07 00:00:00	38000275	0	\N	\N	171957	0	19490002	4024289	
29467	2630	4043071	1969-12-23	1969-12-23 00:00:00	38000275	0	\N	\N	174002	0	228557008	4043071	
41642	3660	4293740	1999-12-22	1999-12-22 00:00:00	38000275	0	\N	\N	243607	0	384700001	4293740	
41782	3680	4107731	1995-05-16	1995-05-16 00:00:00	38000275	0	\N	\N	244798	0	180256009	4107731	
30107	2662	4252419	2018-02-17	2018-02-17 00:00:00	38000275	0	\N	\N	176432	0	74016001	4252419	
30268	2673	4191853	1993-08-16	1993-08-16 00:00:00	38000275	0	\N	\N	177057	0	395142003	4191853	
42289	3734	4047491	1966-02-27	1966-02-27 00:00:00	38000275	0	\N	\N	248171	0	1225002	4047491	
30568	2705	4078793	2011-12-17	2011-12-17 00:00:00	38000275	0	\N	\N	179175	0	180325003	4078793	
30784	2724	4043071	1963-06-02	1963-06-02 00:00:00	38000275	0	\N	\N	180530	0	228557008	4043071	
31041	2757	4202451	2017-01-20	2017-01-20 00:00:00	38000275	0	\N	\N	182378	0	433112001	4202451	
43027	3788	4163872	1968-12-19	1968-12-19 00:00:00	38000275	0	\N	\N	251837	0	399208008	4163872	
31238	2770	4151422	1973-06-10	1973-06-10 00:00:00	38000275	0	\N	\N	183313	0	269911007	4151422	
31519	2779	4107731	1996-04-24	1996-04-24 00:00:00	38000275	0	\N	\N	184162	0	180256009	4107731	
43652	3859	4035793	2019-05-04	2019-05-04 00:00:00	38000275	0	\N	\N	256248	0	15081005	4035793	
43864	3874	4107731	1995-09-27	1995-09-27 00:00:00	38000275	0	\N	\N	257210	0	180256009	4107731	
43954	3876	4107731	1990-07-09	1990-07-09 00:00:00	38000275	0	\N	\N	257509	0	180256009	4107731	
20333	1761	4151422	1985-12-21	1985-12-21 00:00:00	38000275	0	\N	\N	117770	0	269911007	4151422	
56347	4922	4043071	1985-12-04	1985-12-04 00:00:00	38000275	0	\N	\N	327007	0	228557008	4043071	
44610	3913	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	260128	0	180256009	4107731	
44842	3934	40492359	2005-11-16	2005-11-16 00:00:00	38000275	0	\N	\N	261506	0	447365002	40492359	
33031	2896	4330583	2012-03-26	2012-03-26 00:00:00	38000275	0	\N	\N	192862	0	22523008	4330583	
21307	1845	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	123315	0	180256009	4107731	
33329	2915	4058899	1954-10-03	1954-10-03 00:00:00	38000275	0	\N	\N	194301	0	168594001	4058899	
57446	4976	4326177	1976-10-27	1976-10-27 00:00:00	38000275	0	\N	\N	330970	0	430193006	4326177	
33775	2943	4243062	1997-02-05	1997-02-05 00:00:00	38000275	0	\N	\N	196325	0	60027007	4243062	
34008	2959	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	197568	0	180256009	4107731	
34135	2966	4191853	1990-01-06	1990-01-06 00:00:00	38000275	0	\N	\N	198088	0	395142003	4191853	
22417	1967	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	130851	0	180256009	4107731	
34433	2980	4107731	1990-06-24	1990-06-24 00:00:00	38000275	0	\N	\N	198962	0	180256009	4107731	
46584	4086	4238715	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	271600	0	68254000	4238715	
34900	3041	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	202432	0	180256009	4107731	
58983	5116	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	339925	0	180256009	4107731	
35287	3079	4293740	1975-08-22	1975-08-22 00:00:00	38000275	0	\N	\N	204963	0	384700001	4293740	
47327	4156	4336464	2006-02-27	2006-02-27 00:00:00	38000275	0	\N	\N	276159	0	232717009	4336464	
35632	3118	4191853	1989-12-31	1989-12-31 00:00:00	38000275	0	\N	\N	207486	0	395142003	4191853	
35739	3128	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	208120	0	180256009	4107731	
12100	1102	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	72370	0	180256009	4107731	
36133	3170	4170947	1962-05-07	1962-05-07 00:00:00	38000275	0	\N	\N	210713	0	274474001	4170947	
24396	2135	4125906	1963-06-18	1963-06-18 00:00:00	38000275	0	\N	\N	142101	0	288086009	4125906	
36512	3207	4043071	1974-07-25	1974-07-25 00:00:00	38000275	0	\N	\N	213195	0	228557008	4043071	
36707	3221	4330583	2006-05-28	2006-05-28 00:00:00	38000275	0	\N	\N	214095	0	22523008	4330583	
24935	2175	4125906	1990-07-14	1990-07-14 00:00:00	38000275	0	\N	\N	145068	0	288086009	4125906	
37031	3253	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	216373	0	180256009	4107731	
25396	2211	4043071	1986-09-21	1986-09-21 00:00:00	38000275	0	\N	\N	147297	0	228557008	4043071	
25615	2238	4107731	1991-01-13	1991-01-13 00:00:00	38000275	0	\N	\N	149007	0	180256009	4107731	
37640	3321	4125906	1982-11-15	1982-11-15 00:00:00	38000275	0	\N	\N	220500	0	288086009	4125906	
25910	2270	4295880	2002-04-10	2002-04-10 00:00:00	38000275	0	\N	\N	150929	0	76601001	4295880	
26086	2280	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	151667	0	180256009	4107731	
26328	2292	4035793	2016-03-11	2016-03-11 00:00:00	38000275	0	\N	\N	152581	0	15081005	4035793	
38419	3376	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	223943	0	180256009	4107731	
38537	3391	4170947	2009-12-04	2009-12-04 00:00:00	38000275	0	\N	\N	224902	0	274474001	4170947	
26825	2349	4107731	1991-08-18	1991-08-18 00:00:00	38000275	0	\N	\N	156399	0	180256009	4107731	
27045	2357	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	157054	0	180256009	4107731	
27167	2373	4170947	1969-08-13	1969-08-13 00:00:00	38000275	0	\N	\N	157946	0	274474001	4170947	
27458	2396	4047491	1971-02-08	1971-02-08 00:00:00	38000275	0	\N	\N	159322	0	1225002	4047491	
15707	1391	4170947	1980-11-19	1980-11-19 00:00:00	38000275	0	\N	\N	92309	0	274474001	4170947	
27831	2442	4243062	1979-07-09	1979-07-09 00:00:00	38000275	0	\N	\N	161957	0	60027007	4243062	
28004	2462	4107731	1990-06-03	1990-06-03 00:00:00	38000275	0	\N	\N	163236	0	180256009	4107731	
28114	2482	4252419	1991-05-16	1991-05-16 00:00:00	38000275	0	\N	\N	164478	0	74016001	4252419	
40250	3528	4107731	1992-08-03	1992-08-03 00:00:00	38000275	0	\N	\N	234187	0	180256009	4107731	
28521	2537	4107731	1993-04-18	1993-04-18 00:00:00	38000275	0	\N	\N	167779	0	180256009	4107731	
40635	3566	4107731	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	236956	0	180256009	4107731	
28972	2559	4107731	1993-04-17	1993-04-17 00:00:00	38000275	0	\N	\N	169630	0	180256009	4107731	
17175	1482	4107731	1993-01-23	1993-01-23 00:00:00	38000275	0	\N	\N	98842	0	180256009	4107731	
29299	2599	4170947	1983-01-07	1983-01-07 00:00:00	38000275	0	\N	\N	171957	0	274474001	4170947	
29468	2630	4043071	1969-05-20	1969-05-20 00:00:00	38000275	0	\N	\N	173965	0	228557008	4043071	
41643	3660	4125906	1999-12-22	1999-12-22 00:00:00	38000275	0	\N	\N	243607	0	288086009	4125906	
41783	3680	4107731	1995-08-29	1995-08-29 00:00:00	38000275	0	\N	\N	244713	0	180256009	4107731	
41889	3694	4125906	1961-11-05	1961-11-05 00:00:00	38000275	0	\N	\N	245558	0	288086009	4125906	
30269	2674	4163872	1983-03-01	1983-03-01 00:00:00	38000275	0	\N	\N	177225	0	399208008	4163872	
42290	3734	4170947	1977-01-30	1977-01-30 00:00:00	38000275	0	\N	\N	248172	0	274474001	4170947	
30569	2705	4078793	2017-08-26	2017-08-26 00:00:00	38000275	0	\N	\N	179241	0	180325003	4078793	
30785	2724	4043071	1961-12-03	1961-12-03 00:00:00	38000275	0	\N	\N	180523	0	228557008	4043071	
31042	2757	4047491	1976-02-15	1976-02-15 00:00:00	38000275	0	\N	\N	182335	0	1225002	4047491	
43028	3789	4047491	1963-04-09	1963-04-09 00:00:00	38000275	0	\N	\N	251911	0	1225002	4047491	
31239	2770	4107731	1990-03-10	1990-03-10 00:00:00	38000275	0	\N	\N	183393	0	180256009	4107731	
31520	2779	4107731	1997-08-20	1997-08-20 00:00:00	38000275	0	\N	\N	184108	0	180256009	4107731	
43653	3859	4057420	2019-05-04	2019-05-04 00:00:00	38000275	0	\N	\N	256248	0	18286008	4057420	
43865	3874	4191853	1984-01-20	1984-01-20 00:00:00	38000275	0	\N	\N	257211	0	395142003	4191853	
43955	3876	4107731	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	257439	0	180256009	4107731	
20334	1761	4195803	2014-04-21	2014-04-21 00:00:00	38000275	0	\N	\N	117721	0	312681000	4195803	
56348	4922	4043071	1984-10-10	1984-10-10 00:00:00	38000275	0	\N	\N	327026	0	228557008	4043071	
44611	3913	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	260121	0	180256009	4107731	
44843	3934	4010253	1988-03-07	1988-03-07 00:00:00	38000275	0	\N	\N	261452	0	112790001	4010253	
33032	2896	4107731	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	192799	0	180256009	4107731	
21308	1845	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	123361	0	180256009	4107731	
33330	2915	4107731	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	194328	0	180256009	4107731	
57447	4976	4037675	1976-10-27	1976-10-27 00:00:00	38000275	0	\N	\N	330970	0	162676008	4037675	
33776	2943	4195803	1997-02-05	1997-02-05 00:00:00	38000275	0	\N	\N	196325	0	312681000	4195803	
34009	2959	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	197562	0	180256009	4107731	
34136	2966	4107731	1991-10-19	1991-10-19 00:00:00	38000275	0	\N	\N	198085	0	180256009	4107731	
22418	1967	4170947	1956-09-07	1956-09-07 00:00:00	38000275	0	\N	\N	130742	0	274474001	4170947	
34434	2980	4107731	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	198994	0	180256009	4107731	
46585	4086	4275113	1986-11-28	1986-11-28 00:00:00	38000275	0	\N	\N	271599	0	65200003	4275113	
34901	3041	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	202433	0	180256009	4107731	
58984	5116	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	340002	0	180256009	4107731	
35288	3079	4125906	1975-08-22	1975-08-22 00:00:00	38000275	0	\N	\N	204963	0	288086009	4125906	
47331	4159	4125906	2000-09-01	2000-09-01 00:00:00	38000275	0	\N	\N	276363	0	288086009	4125906	
35633	3118	4107731	1992-04-19	1992-04-19 00:00:00	38000275	0	\N	\N	207476	0	180256009	4107731	
35740	3128	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	208188	0	180256009	4107731	
12101	1102	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	72417	0	180256009	4107731	
36134	3170	4047491	1962-05-07	1962-05-07 00:00:00	38000275	0	\N	\N	210713	0	1225002	4047491	
24397	2135	4107731	1992-01-27	1992-01-27 00:00:00	38000275	0	\N	\N	142178	0	180256009	4107731	
36513	3208	4125906	1992-09-07	1992-09-07 00:00:00	38000275	0	\N	\N	213247	0	288086009	4125906	
36708	3221	4043071	1971-05-01	1971-05-01 00:00:00	38000275	0	\N	\N	214082	0	228557008	4043071	
24936	2175	4107731	2010-05-25	2010-05-25 00:00:00	38000275	0	\N	\N	145077	0	180256009	4107731	
37032	3253	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	216257	0	180256009	4107731	
25397	2211	4043071	1985-09-22	1985-09-22 00:00:00	38000275	0	\N	\N	147324	0	228557008	4043071	
25616	2238	4107731	1992-05-10	1992-05-10 00:00:00	38000275	0	\N	\N	148918	0	180256009	4107731	
37655	3325	4151422	1963-09-16	1963-09-16 00:00:00	38000275	0	\N	\N	220741	0	269911007	4151422	
25911	2270	4295880	2001-10-10	2001-10-10 00:00:00	38000275	0	\N	\N	150935	0	76601001	4295880	
26087	2280	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	151573	0	180256009	4107731	
26329	2294	4125906	2018-11-10	2018-11-10 00:00:00	38000275	0	\N	\N	152752	0	288086009	4125906	
38420	3376	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	224016	0	180256009	4107731	
38538	3391	4024289	2009-12-04	2009-12-04 00:00:00	38000275	0	\N	\N	224902	0	19490002	4024289	
26826	2349	4107731	1992-01-12	1992-01-12 00:00:00	38000275	0	\N	\N	156394	0	180256009	4107731	
27046	2357	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	157029	0	180256009	4107731	
27172	2380	4151422	1969-05-27	1969-05-27 00:00:00	38000275	0	\N	\N	158227	0	269911007	4151422	
27459	2396	4170947	1997-10-19	1997-10-19 00:00:00	38000275	0	\N	\N	159323	0	274474001	4170947	
15708	1391	4195803	1994-10-25	1994-10-25 00:00:00	38000275	0	\N	\N	92308	0	312681000	4195803	
27832	2442	4170947	1979-07-09	1979-07-09 00:00:00	38000275	0	\N	\N	161957	0	274474001	4170947	
28005	2462	4107731	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	163256	0	180256009	4107731	
28115	2483	4187458	1952-03-02	1952-03-02 00:00:00	38000275	0	\N	\N	164522	0	415300000	4187458	
40251	3528	4107731	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	234264	0	180256009	4107731	
28522	2537	4107731	1992-06-28	1992-06-28 00:00:00	38000275	0	\N	\N	167608	0	180256009	4107731	
40636	3566	4107731	1992-03-30	1992-03-30 00:00:00	38000275	0	\N	\N	236901	0	180256009	4107731	
28973	2559	4107731	1993-02-13	1993-02-13 00:00:00	38000275	0	\N	\N	169562	0	180256009	4107731	
17176	1482	4107731	1992-08-29	1992-08-29 00:00:00	38000275	0	\N	\N	98832	0	180256009	4107731	
29300	2599	4125906	1979-12-19	1979-12-19 00:00:00	38000275	0	\N	\N	171955	0	288086009	4125906	
29469	2630	4043071	1970-08-25	1970-08-25 00:00:00	38000275	0	\N	\N	173929	0	228557008	4043071	
41644	3660	4047491	1992-06-17	1992-06-17 00:00:00	38000275	0	\N	\N	243605	0	1225002	4047491	
41784	3680	4107731	1992-08-11	1992-08-11 00:00:00	38000275	0	\N	\N	244729	0	180256009	4107731	
41890	3694	4078793	2017-02-28	2017-02-28 00:00:00	38000275	0	\N	\N	245509	0	180325003	4078793	
30270	2674	4125906	1996-08-09	1996-08-09 00:00:00	38000275	0	\N	\N	177218	0	288086009	4125906	
42291	3734	4024289	1977-01-30	1977-01-30 00:00:00	38000275	0	\N	\N	248172	0	19490002	4024289	
30570	2705	4078793	2016-01-09	2016-01-09 00:00:00	38000275	0	\N	\N	179177	0	180325003	4078793	
30786	2724	4043071	1962-07-01	1962-07-01 00:00:00	38000275	0	\N	\N	180474	0	228557008	4043071	
42846	3776	4252419	2010-11-20	2010-11-20 00:00:00	38000275	0	\N	\N	250981	0	74016001	4252419	
43029	3789	4170947	1963-04-09	1963-04-09 00:00:00	38000275	0	\N	\N	251911	0	274474001	4170947	
31240	2770	4107731	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	183322	0	180256009	4107731	
31521	2779	4107731	1995-09-27	1995-09-27 00:00:00	38000275	0	\N	\N	184113	0	180256009	4107731	
43654	3859	4035793	2015-11-21	2015-11-21 00:00:00	38000275	0	\N	\N	256247	0	15081005	4035793	
43866	3874	4107731	1995-05-03	1995-05-03 00:00:00	38000275	0	\N	\N	257213	0	180256009	4107731	
43956	3876	4107731	1990-02-12	1990-02-12 00:00:00	38000275	0	\N	\N	257504	0	180256009	4107731	
20335	1761	4145310	2014-04-21	2014-04-21 00:00:00	38000275	0	\N	\N	117721	0	268425006	4145310	
56349	4922	4043071	1985-06-19	1985-06-19 00:00:00	38000275	0	\N	\N	326975	0	228557008	4043071	
44612	3913	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	260112	0	180256009	4107731	
44844	3934	4057420	1957-03-06	1957-03-06 00:00:00	38000275	0	\N	\N	261501	0	18286008	4057420	
33033	2896	4107731	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	192794	0	180256009	4107731	
21309	1845	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	123278	0	180256009	4107731	
33331	2915	4107731	1991-05-26	1991-05-26 00:00:00	38000275	0	\N	\N	194261	0	180256009	4107731	
57448	4976	4187458	1976-10-27	1976-10-27 00:00:00	38000275	0	\N	\N	330970	0	415300000	4187458	
33777	2943	4170947	1997-02-05	1997-02-05 00:00:00	38000275	0	\N	\N	196325	0	274474001	4170947	
34010	2959	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	197503	0	180256009	4107731	
34137	2966	4107731	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	198125	0	180256009	4107731	
22419	1967	4163872	1956-09-07	1956-09-07 00:00:00	38000275	0	\N	\N	130742	0	399208008	4163872	
34435	2980	4107731	1991-09-08	1991-09-08 00:00:00	38000275	0	\N	\N	199012	0	180256009	4107731	
46586	4086	4125906	1990-03-19	1990-03-19 00:00:00	38000275	0	\N	\N	271573	0	288086009	4125906	
34902	3041	4107731	1993-08-19	1993-08-19 00:00:00	38000275	0	\N	\N	202524	0	180256009	4107731	
58985	5116	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	340005	0	180256009	4107731	
35289	3080	4037675	1941-12-12	1941-12-12 00:00:00	38000275	0	\N	\N	204983	0	162676008	4037675	
47332	4159	4170947	1972-10-30	1972-10-30 00:00:00	38000275	0	\N	\N	276384	0	274474001	4170947	
35634	3118	4107731	1992-07-12	1992-07-12 00:00:00	38000275	0	\N	\N	207520	0	180256009	4107731	
35741	3128	4252419	1984-09-08	1984-09-08 00:00:00	38000275	0	\N	\N	208164	0	74016001	4252419	
12102	1102	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	72429	0	180256009	4107731	
36151	3172	4252419	1999-01-09	1999-01-09 00:00:00	38000275	0	\N	\N	210821	0	74016001	4252419	
24398	2135	4191853	1990-01-01	1990-01-01 00:00:00	38000275	0	\N	\N	142128	0	395142003	4191853	
36514	3208	4125906	2001-03-08	2001-03-08 00:00:00	38000275	0	\N	\N	213248	0	288086009	4125906	
36709	3221	4043071	1972-01-08	1972-01-08 00:00:00	38000275	0	\N	\N	214092	0	228557008	4043071	
24937	2175	4107731	2009-09-15	2009-09-15 00:00:00	38000275	0	\N	\N	145034	0	180256009	4107731	
37033	3253	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	216366	0	180256009	4107731	
25398	2211	4043071	1986-06-08	1986-06-08 00:00:00	38000275	0	\N	\N	147334	0	228557008	4043071	
25617	2238	4151422	1978-10-13	1978-10-13 00:00:00	38000275	0	\N	\N	148933	0	269911007	4151422	
37724	3330	4151422	2009-06-02	2009-06-02 00:00:00	38000275	0	\N	\N	220956	0	269911007	4151422	
25912	2270	4125906	1988-05-08	1988-05-08 00:00:00	38000275	0	\N	\N	150939	0	288086009	4125906	
26088	2280	4125906	2000-08-27	2000-08-27 00:00:00	38000275	0	\N	\N	151559	0	288086009	4125906	
26330	2294	4043071	1967-12-22	1967-12-22 00:00:00	38000275	0	\N	\N	152674	0	228557008	4043071	
38421	3376	4145310	1964-03-29	1964-03-29 00:00:00	38000275	0	\N	\N	224000	0	268425006	4145310	
38539	3391	4301346	1997-06-10	1997-06-10 00:00:00	38000275	0	\N	\N	224903	0	387685009	4301346	
26827	2349	4107731	1990-12-30	1990-12-30 00:00:00	38000275	0	\N	\N	156420	0	180256009	4107731	
27047	2357	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	156974	0	180256009	4107731	
27173	2381	4043071	1944-05-10	1944-05-10 00:00:00	38000275	0	\N	\N	158290	0	228557008	4043071	
27460	2396	4047491	1997-10-19	1997-10-19 00:00:00	38000275	0	\N	\N	159323	0	1225002	4047491	
27508	2402	4107731	1992-10-05	1992-10-05 00:00:00	38000275	0	\N	\N	159599	0	180256009	4107731	
27833	2442	4062501	1973-06-27	1973-06-27 00:00:00	38000275	0	\N	\N	162005	0	171231001	4062501	
28006	2462	4151422	2011-10-24	2011-10-24 00:00:00	38000275	0	\N	\N	163308	0	269911007	4151422	
28116	2483	4037675	1952-03-02	1952-03-02 00:00:00	38000275	0	\N	\N	164522	0	162676008	4037675	
40252	3528	4107731	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	234232	0	180256009	4107731	
28523	2537	4107731	1991-01-20	1991-01-20 00:00:00	38000275	0	\N	\N	167653	0	180256009	4107731	
40637	3566	4043071	1959-07-06	1959-07-06 00:00:00	38000275	0	\N	\N	236904	0	228557008	4043071	
28974	2559	4107731	1991-11-30	1991-11-30 00:00:00	38000275	0	\N	\N	169606	0	180256009	4107731	
17177	1482	4107731	1993-03-27	1993-03-27 00:00:00	38000275	0	\N	\N	98897	0	180256009	4107731	
29301	2599	4275113	1994-01-17	1994-01-17 00:00:00	38000275	0	\N	\N	171993	0	65200003	4275113	
29470	2630	4043071	1969-09-23	1969-09-23 00:00:00	38000275	0	\N	\N	173976	0	228557008	4043071	
41645	3660	4170947	1992-06-17	1992-06-17 00:00:00	38000275	0	\N	\N	243605	0	274474001	4170947	
41785	3680	4107731	1995-06-06	1995-06-06 00:00:00	38000275	0	\N	\N	244711	0	180256009	4107731	
41891	3694	4078793	2017-09-19	2017-09-19 00:00:00	38000275	0	\N	\N	245551	0	180325003	4078793	
30271	2674	4293740	1996-08-09	1996-08-09 00:00:00	38000275	0	\N	\N	177218	0	384700001	4293740	
42319	3736	4151422	1985-07-31	1985-07-31 00:00:00	38000275	0	\N	\N	248259	0	269911007	4151422	
30571	2705	4078793	2012-12-22	2012-12-22 00:00:00	38000275	0	\N	\N	179248	0	180325003	4078793	
30787	2724	4043071	1961-12-31	1961-12-31 00:00:00	38000275	0	\N	\N	180493	0	228557008	4043071	
42847	3776	4170947	1987-03-21	1987-03-21 00:00:00	38000275	0	\N	\N	250978	0	274474001	4170947	
43030	3789	4195803	2010-07-29	2010-07-29 00:00:00	38000275	0	\N	\N	251914	0	312681000	4195803	
31241	2770	4107731	1993-01-23	1993-01-23 00:00:00	38000275	0	\N	\N	183350	0	180256009	4107731	
31522	2779	4107731	1996-01-10	1996-01-10 00:00:00	38000275	0	\N	\N	184101	0	180256009	4107731	
43655	3859	4035793	2005-09-24	2005-09-24 00:00:00	38000275	0	\N	\N	256159	0	15081005	4035793	
43867	3874	4191853	1998-07-01	1998-07-01 00:00:00	38000275	0	\N	\N	257227	0	395142003	4191853	
43957	3876	4107731	1992-01-27	1992-01-27 00:00:00	38000275	0	\N	\N	257454	0	180256009	4107731	
20336	1762	4035793	1984-02-09	1984-02-09 00:00:00	38000275	0	\N	\N	117842	0	15081005	4035793	
56350	4922	4043071	1988-02-10	1988-02-10 00:00:00	38000275	0	\N	\N	327076	0	228557008	4043071	
44613	3913	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	260150	0	180256009	4107731	
44845	3934	40492359	1957-03-06	1957-03-06 00:00:00	38000275	0	\N	\N	261501	0	447365002	40492359	
33034	2896	4107731	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	192841	0	180256009	4107731	
21310	1845	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	123263	0	180256009	4107731	
33332	2915	4107731	1991-06-16	1991-06-16 00:00:00	38000275	0	\N	\N	194263	0	180256009	4107731	
57449	4976	4125906	1995-01-25	1995-01-25 00:00:00	38000275	0	\N	\N	331108	0	288086009	4125906	
33778	2943	4170947	2008-02-08	2008-02-08 00:00:00	38000275	0	\N	\N	196326	0	274474001	4170947	
34011	2959	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	197563	0	180256009	4107731	
34138	2966	4107731	1992-06-27	1992-06-27 00:00:00	38000275	0	\N	\N	198159	0	180256009	4107731	
22420	1967	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	130751	0	180256009	4107731	
34436	2980	4107731	1991-12-22	1991-12-22 00:00:00	38000275	0	\N	\N	198987	0	180256009	4107731	
46587	4086	4293740	1994-08-31	1994-08-31 00:00:00	38000275	0	\N	\N	271575	0	384700001	4293740	
34903	3041	4191853	1993-09-09	1993-09-09 00:00:00	38000275	0	\N	\N	202546	0	395142003	4191853	
58986	5116	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	339900	0	180256009	4107731	
35290	3080	4326177	1941-12-12	1941-12-12 00:00:00	38000275	0	\N	\N	204983	0	430193006	4326177	
47333	4159	4024289	1972-10-30	1972-10-30 00:00:00	38000275	0	\N	\N	276384	0	19490002	4024289	
35635	3118	4107731	1990-11-11	1990-11-11 00:00:00	38000275	0	\N	\N	207411	0	180256009	4107731	
35742	3128	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	208145	0	180256009	4107731	
12103	1102	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	72466	0	180256009	4107731	
36152	3172	4125906	1982-12-20	1982-12-20 00:00:00	38000275	0	\N	\N	210820	0	288086009	4125906	
24399	2135	4107731	1991-08-12	1991-08-12 00:00:00	38000275	0	\N	\N	142050	0	180256009	4107731	
36515	3208	4170947	1975-10-02	1975-10-02 00:00:00	38000275	0	\N	\N	213245	0	274474001	4170947	
36710	3221	4043071	1970-07-04	1970-07-04 00:00:00	38000275	0	\N	\N	214073	0	228557008	4043071	
24938	2175	4107731	2009-06-02	2009-06-02 00:00:00	38000275	0	\N	\N	145072	0	180256009	4107731	
37034	3253	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	216304	0	180256009	4107731	
25399	2211	4043071	1986-07-13	1986-07-13 00:00:00	38000275	0	\N	\N	147335	0	228557008	4043071	
25618	2238	4191853	1989-12-31	1989-12-31 00:00:00	38000275	0	\N	\N	148980	0	395142003	4191853	
37725	3330	4125906	2007-08-24	2007-08-24 00:00:00	38000275	0	\N	\N	221007	0	288086009	4125906	
25913	2270	4295880	2001-04-10	2001-04-10 00:00:00	38000275	0	\N	\N	150956	0	76601001	4295880	
26089	2280	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	151591	0	180256009	4107731	
26331	2294	4043071	1968-12-06	1968-12-06 00:00:00	38000275	0	\N	\N	152677	0	228557008	4043071	
38422	3376	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	223965	0	180256009	4107731	
38540	3392	4151422	1968-04-25	1968-04-25 00:00:00	38000275	0	\N	\N	224988	0	269911007	4151422	
26828	2349	4107731	1991-05-05	1991-05-05 00:00:00	38000275	0	\N	\N	156423	0	180256009	4107731	
27048	2357	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	156975	0	180256009	4107731	
27174	2381	4043071	1944-06-07	1944-06-07 00:00:00	38000275	0	\N	\N	158313	0	228557008	4043071	
27461	2396	4195803	1997-10-19	1997-10-19 00:00:00	38000275	0	\N	\N	159323	0	312681000	4195803	
27509	2402	4107731	1990-02-12	1990-02-12 00:00:00	38000275	0	\N	\N	159600	0	180256009	4107731	
27834	2442	4125906	1982-06-23	1982-06-23 00:00:00	38000275	0	\N	\N	161958	0	288086009	4125906	
28007	2462	4107731	1992-11-22	1992-11-22 00:00:00	38000275	0	\N	\N	163272	0	180256009	4107731	
28117	2483	4326177	1952-03-02	1952-03-02 00:00:00	38000275	0	\N	\N	164522	0	430193006	4326177	
40253	3528	4107731	1991-11-25	1991-11-25 00:00:00	38000275	0	\N	\N	234186	0	180256009	4107731	
28524	2537	4107731	1993-05-09	1993-05-09 00:00:00	38000275	0	\N	\N	167670	0	180256009	4107731	
40638	3566	4043071	1958-10-20	1958-10-20 00:00:00	38000275	0	\N	\N	236808	0	228557008	4043071	
28975	2559	4107731	1992-06-06	1992-06-06 00:00:00	38000275	0	\N	\N	169626	0	180256009	4107731	
17178	1482	4107731	1991-07-06	1991-07-06 00:00:00	38000275	0	\N	\N	98909	0	180256009	4107731	
29302	2599	4163872	1984-10-28	1984-10-28 00:00:00	38000275	0	\N	\N	171958	0	399208008	4163872	
29471	2630	4043071	1970-05-26	1970-05-26 00:00:00	38000275	0	\N	\N	173985	0	228557008	4043071	
41646	3661	4151422	1988-01-13	1988-01-13 00:00:00	38000275	0	\N	\N	243654	0	269911007	4151422	
41786	3680	4197460	1979-11-29	1979-11-29 00:00:00	38000275	0	\N	\N	244780	0	313191000	4197460	
41892	3694	4058899	1995-02-13	1995-02-13 00:00:00	38000275	0	\N	\N	245565	0	168594001	4058899	
30272	2675	4202451	2012-08-19	2012-08-19 00:00:00	38000275	0	\N	\N	177310	0	433112001	4202451	
42320	3736	4125906	1991-12-31	1991-12-31 00:00:00	38000275	0	\N	\N	248333	0	288086009	4125906	
30572	2706	4125906	2000-08-06	2000-08-06 00:00:00	38000275	0	\N	\N	179260	0	288086009	4125906	
30788	2724	4043071	1961-07-23	1961-07-23 00:00:00	38000275	0	\N	\N	180514	0	228557008	4043071	
42848	3776	4047491	1987-03-21	1987-03-21 00:00:00	38000275	0	\N	\N	250978	0	1225002	4047491	
43031	3789	4243062	2010-07-29	2010-07-29 00:00:00	38000275	0	\N	\N	251914	0	60027007	4243062	
31242	2770	4191853	1993-07-10	1993-07-10 00:00:00	38000275	0	\N	\N	183291	0	395142003	4191853	
31523	2779	4107731	1997-05-28	1997-05-28 00:00:00	38000275	0	\N	\N	184106	0	180256009	4107731	
43656	3859	4035793	2010-10-23	2010-10-23 00:00:00	38000275	0	\N	\N	256181	0	15081005	4035793	
43868	3874	4107731	1995-12-20	1995-12-20 00:00:00	38000275	0	\N	\N	257255	0	180256009	4107731	
43958	3876	4107731	1991-11-04	1991-11-04 00:00:00	38000275	0	\N	\N	257452	0	180256009	4107731	
20337	1762	4035793	1982-02-04	1982-02-04 00:00:00	38000275	0	\N	\N	117873	0	15081005	4035793	
56351	4922	4043071	1987-10-07	1987-10-07 00:00:00	38000275	0	\N	\N	327032	0	228557008	4043071	
44614	3913	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	260091	0	180256009	4107731	
44846	3934	4125906	1941-10-01	1941-10-01 00:00:00	38000275	0	\N	\N	261498	0	288086009	4125906	
33035	2896	4151422	1987-05-23	1987-05-23 00:00:00	38000275	0	\N	\N	192765	0	269911007	4151422	
21311	1845	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	123389	0	395142003	4191853	
33333	2915	4107731	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	194242	0	180256009	4107731	
57450	4976	4293740	1995-01-25	1995-01-25 00:00:00	38000275	0	\N	\N	331108	0	384700001	4293740	
33779	2943	4163872	2008-02-08	2008-02-08 00:00:00	38000275	0	\N	\N	196326	0	399208008	4163872	
34012	2959	4043071	1979-04-25	1979-04-25 00:00:00	38000275	0	\N	\N	197552	0	228557008	4043071	
34139	2966	4107731	1990-03-10	1990-03-10 00:00:00	38000275	0	\N	\N	198078	0	180256009	4107731	
22421	1967	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	130854	0	180256009	4107731	
34437	2980	4107731	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	198990	0	180256009	4107731	
46588	4086	4125906	1994-08-31	1994-08-31 00:00:00	38000275	0	\N	\N	271575	0	288086009	4125906	
34904	3041	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	202473	0	180256009	4107731	
58987	5116	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	339990	0	180256009	4107731	
35291	3080	4187458	1941-12-12	1941-12-12 00:00:00	38000275	0	\N	\N	204983	0	415300000	4187458	
47334	4160	40492359	1965-11-25	1965-11-25 00:00:00	38000275	0	\N	\N	276447	0	447365002	40492359	
35636	3118	4191853	1993-07-04	1993-07-04 00:00:00	38000275	0	\N	\N	207442	0	395142003	4191853	
35743	3128	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	208156	0	180256009	4107731	
12104	1102	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	72405	0	180256009	4107731	
36153	3172	44783196	1999-01-16	1999-01-16 00:00:00	38000275	0	\N	\N	210877	0	699253003	44783196	
24400	2135	4107731	1992-03-30	1992-03-30 00:00:00	38000275	0	\N	\N	142052	0	180256009	4107731	
36516	3208	4163872	1975-10-02	1975-10-02 00:00:00	38000275	0	\N	\N	213245	0	399208008	4163872	
36711	3222	4202451	2012-10-30	2012-10-30 00:00:00	38000275	0	\N	\N	214201	0	433112001	4202451	
24939	2175	4107731	2010-07-27	2010-07-27 00:00:00	38000275	0	\N	\N	145038	0	180256009	4107731	
37035	3253	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	216379	0	180256009	4107731	
25400	2211	4043071	1985-11-24	1985-11-24 00:00:00	38000275	0	\N	\N	147332	0	228557008	4043071	
25619	2238	4107731	1993-05-23	1993-05-23 00:00:00	38000275	0	\N	\N	148966	0	180256009	4107731	
37728	3332	4170947	1969-07-22	1969-07-22 00:00:00	38000275	0	\N	\N	221130	0	274474001	4170947	
25914	2270	4295880	2001-07-11	2001-07-11 00:00:00	38000275	0	\N	\N	150928	0	76601001	4295880	
26090	2280	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	151605	0	180256009	4107731	
26332	2294	4043071	1968-01-26	1968-01-26 00:00:00	38000275	0	\N	\N	152675	0	228557008	4043071	
38423	3376	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	223974	0	180256009	4107731	
38541	3392	4275113	1988-11-17	1988-11-17 00:00:00	38000275	0	\N	\N	224935	0	65200003	4275113	
26829	2349	4107731	1992-04-26	1992-04-26 00:00:00	38000275	0	\N	\N	156345	0	180256009	4107731	
27049	2357	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	156977	0	180256009	4107731	
27175	2381	4043071	1944-07-12	1944-07-12 00:00:00	38000275	0	\N	\N	158332	0	228557008	4043071	
27462	2396	4125906	1941-04-27	1941-04-27 00:00:00	38000275	0	\N	\N	159402	0	288086009	4125906	
27510	2402	4107731	1990-12-03	1990-12-03 00:00:00	38000275	0	\N	\N	159590	0	180256009	4107731	
27835	2442	4163872	1975-07-31	1975-07-31 00:00:00	38000275	0	\N	\N	162001	0	399208008	4163872	
28008	2462	4107731	1993-04-18	1993-04-18 00:00:00	38000275	0	\N	\N	163289	0	180256009	4107731	
28118	2483	4151422	1962-12-15	1962-12-15 00:00:00	38000275	0	\N	\N	164512	0	269911007	4151422	
40254	3528	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	234237	0	180256009	4107731	
28525	2537	4191853	1990-01-07	1990-01-07 00:00:00	38000275	0	\N	\N	167631	0	395142003	4191853	
40639	3566	4107731	1990-02-12	1990-02-12 00:00:00	38000275	0	\N	\N	236871	0	180256009	4107731	
28976	2559	4107731	1991-10-19	1991-10-19 00:00:00	38000275	0	\N	\N	169592	0	180256009	4107731	
17179	1482	4107731	1992-11-21	1992-11-21 00:00:00	38000275	0	\N	\N	98873	0	180256009	4107731	
29303	2599	4170947	1984-10-28	1984-10-28 00:00:00	38000275	0	\N	\N	171958	0	274474001	4170947	
29472	2630	4043071	1969-07-22	1969-07-22 00:00:00	38000275	0	\N	\N	174000	0	228557008	4043071	
41647	3661	4151422	1980-08-02	1980-08-02 00:00:00	38000275	0	\N	\N	243642	0	269911007	4151422	
41787	3680	4107731	1995-01-10	1995-01-10 00:00:00	38000275	0	\N	\N	244692	0	180256009	4107731	
41893	3694	4043071	1965-05-12	1965-05-12 00:00:00	38000275	0	\N	\N	245511	0	228557008	4043071	
30273	2675	4125906	1992-01-01	1992-01-01 00:00:00	38000275	0	\N	\N	177233	0	288086009	4125906	
42321	3736	40492359	2006-06-28	2006-06-28 00:00:00	38000275	0	\N	\N	248300	0	447365002	40492359	
30573	2706	4293740	2000-08-06	2000-08-06 00:00:00	38000275	0	\N	\N	179260	0	384700001	4293740	
30789	2724	4043071	1963-04-28	1963-04-28 00:00:00	38000275	0	\N	\N	180529	0	228557008	4043071	
42849	3776	4125906	1991-12-25	1991-12-25 00:00:00	38000275	0	\N	\N	250979	0	288086009	4125906	
43032	3789	4170947	2010-07-29	2010-07-29 00:00:00	38000275	0	\N	\N	251914	0	274474001	4170947	
31243	2770	4107731	1993-05-29	1993-05-29 00:00:00	38000275	0	\N	\N	183353	0	180256009	4107731	
31524	2779	4107731	1997-10-01	1997-10-01 00:00:00	38000275	0	\N	\N	184152	0	180256009	4107731	
43657	3859	4035793	2018-04-28	2018-04-28 00:00:00	38000275	0	\N	\N	256183	0	15081005	4035793	
43869	3874	4107731	1996-08-28	1996-08-28 00:00:00	38000275	0	\N	\N	257315	0	180256009	4107731	
43959	3876	4107731	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	257445	0	180256009	4107731	
20338	1762	4125906	2012-05-16	2012-05-16 00:00:00	38000275	0	\N	\N	117865	0	288086009	4125906	
56352	4922	4043071	1986-03-12	1986-03-12 00:00:00	38000275	0	\N	\N	327069	0	228557008	4043071	
44615	3913	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	260152	0	180256009	4107731	
44847	3934	4125906	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	261505	0	288086009	4125906	
33036	2896	4107731	1990-10-28	1990-10-28 00:00:00	38000275	0	\N	\N	192844	0	180256009	4107731	
21312	1845	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	123261	0	180256009	4107731	
33334	2915	4107731	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	194255	0	180256009	4107731	
57451	4976	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	330955	0	180256009	4107731	
33780	2943	4195803	2008-02-08	2008-02-08 00:00:00	38000275	0	\N	\N	196326	0	312681000	4195803	
34013	2959	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	197491	0	180256009	4107731	
34140	2966	4107731	1993-01-23	1993-01-23 00:00:00	38000275	0	\N	\N	198117	0	180256009	4107731	
22422	1967	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	130825	0	180256009	4107731	
34438	2980	4191853	1990-01-07	1990-01-07 00:00:00	38000275	0	\N	\N	198943	0	395142003	4191853	
46589	4086	4125906	1986-06-04	1986-06-04 00:00:00	38000275	0	\N	\N	271571	0	288086009	4125906	
34905	3041	4191853	1978-08-06	1978-08-06 00:00:00	38000275	0	\N	\N	202463	0	395142003	4191853	
58988	5116	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	340015	0	180256009	4107731	
35292	3080	4125906	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	204969	0	288086009	4125906	
47335	4160	4057420	1965-11-25	1965-11-25 00:00:00	38000275	0	\N	\N	276447	0	18286008	4057420	
35637	3118	4107731	1991-10-13	1991-10-13 00:00:00	38000275	0	\N	\N	207429	0	180256009	4107731	
35744	3128	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	208189	0	180256009	4107731	
12105	1102	4151422	2005-07-01	2005-07-01 00:00:00	38000275	0	\N	\N	72416	0	269911007	4151422	
36154	3172	4058899	2004-09-16	2004-09-16 00:00:00	38000275	0	\N	\N	210822	0	168594001	4058899	
24401	2135	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	142085	0	180256009	4107731	
36518	3211	4151422	1961-06-02	1961-06-02 00:00:00	38000275	0	\N	\N	213363	0	269911007	4151422	
36712	3222	4058899	1959-04-20	1959-04-20 00:00:00	38000275	0	\N	\N	214154	0	168594001	4058899	
24940	2175	4107731	2009-12-29	2009-12-29 00:00:00	38000275	0	\N	\N	145016	0	180256009	4107731	
37036	3253	4062501	1974-05-25	1974-05-25 00:00:00	38000275	0	\N	\N	216321	0	171231001	4062501	
25401	2211	4043071	1985-12-22	1985-12-22 00:00:00	38000275	0	\N	\N	147295	0	228557008	4043071	
37401	3295	4078793	1994-05-23	1994-05-23 00:00:00	38000275	0	\N	\N	218906	0	180325003	4078793	
37729	3332	4024289	1969-07-22	1969-07-22 00:00:00	38000275	0	\N	\N	221130	0	19490002	4024289	
25915	2272	4295880	1995-05-27	1995-05-27 00:00:00	38000275	0	\N	\N	151015	0	76601001	4295880	
26091	2280	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	151581	0	180256009	4107731	
26333	2294	4125906	1961-11-20	1961-11-20 00:00:00	38000275	0	\N	\N	152747	0	288086009	4125906	
38424	3376	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	224062	0	180256009	4107731	
38542	3392	4238715	1991-06-08	1991-06-08 00:00:00	38000275	0	\N	\N	224956	0	68254000	4238715	
26830	2349	4107731	1990-10-28	1990-10-28 00:00:00	38000275	0	\N	\N	156369	0	180256009	4107731	
27050	2357	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	156959	0	180256009	4107731	
27176	2381	4043071	1944-04-12	1944-04-12 00:00:00	38000275	0	\N	\N	158342	0	228557008	4043071	
27463	2396	4336464	2001-02-21	2001-02-21 00:00:00	38000275	0	\N	\N	159325	0	232717009	4336464	
27511	2402	4107731	1992-10-26	1992-10-26 00:00:00	38000275	0	\N	\N	159659	0	180256009	4107731	
27836	2443	4058899	1979-10-26	1979-10-26 00:00:00	38000275	0	\N	\N	162034	0	168594001	4058899	
28009	2462	4107731	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	163273	0	180256009	4107731	
28119	2483	4293740	1961-02-17	1961-02-17 00:00:00	38000275	0	\N	\N	164511	0	384700001	4293740	
40255	3528	4107731	1990-10-01	1990-10-01 00:00:00	38000275	0	\N	\N	234252	0	180256009	4107731	
28526	2537	4107731	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	167624	0	180256009	4107731	
40640	3566	4043071	1958-08-25	1958-08-25 00:00:00	38000275	0	\N	\N	236923	0	228557008	4043071	
28977	2559	4107731	1991-06-15	1991-06-15 00:00:00	38000275	0	\N	\N	169551	0	180256009	4107731	
17180	1482	4107731	1991-10-19	1991-10-19 00:00:00	38000275	0	\N	\N	98884	0	180256009	4107731	
29304	2599	4151422	1981-09-10	1981-09-10 00:00:00	38000275	0	\N	\N	171946	0	269911007	4151422	
29473	2630	4043071	1969-10-21	1969-10-21 00:00:00	38000275	0	\N	\N	173926	0	228557008	4043071	
41648	3661	4062501	1982-02-18	1982-02-18 00:00:00	38000275	0	\N	\N	243669	0	171231001	4062501	
41788	3680	4107731	1992-11-24	1992-11-24 00:00:00	38000275	0	\N	\N	244784	0	180256009	4107731	
41894	3694	4043071	1965-08-18	1965-08-18 00:00:00	38000275	0	\N	\N	245494	0	228557008	4043071	
30274	2675	4198190	1996-01-23	1996-01-23 00:00:00	38000275	0	\N	\N	177275	0	80146002	4198190	
42322	3736	4057420	2006-06-28	2006-06-28 00:00:00	38000275	0	\N	\N	248300	0	18286008	4057420	
30574	2706	4163872	1973-01-16	1973-01-16 00:00:00	38000275	0	\N	\N	179257	0	399208008	4163872	
30790	2724	4043071	1961-10-01	1961-10-01 00:00:00	38000275	0	\N	\N	180473	0	228557008	4043071	
42850	3776	4125906	1994-12-30	1994-12-30 00:00:00	38000275	0	\N	\N	250980	0	288086009	4125906	
43033	3790	4151422	2005-05-01	2005-05-01 00:00:00	38000275	0	\N	\N	251981	0	269911007	4151422	
31244	2770	4107731	1990-02-17	1990-02-17 00:00:00	38000275	0	\N	\N	183402	0	180256009	4107731	
31525	2779	4107731	1995-10-18	1995-10-18 00:00:00	38000275	0	\N	\N	184128	0	180256009	4107731	
43658	3859	4035793	2016-04-16	2016-04-16 00:00:00	38000275	0	\N	\N	256182	0	15081005	4035793	
43870	3874	4107731	1995-11-08	1995-11-08 00:00:00	38000275	0	\N	\N	257254	0	180256009	4107731	
43960	3876	4107731	1991-11-25	1991-11-25 00:00:00	38000275	0	\N	\N	257514	0	180256009	4107731	
20339	1762	4078793	2006-02-23	2006-02-23 00:00:00	38000275	0	\N	\N	117857	0	180325003	4078793	
56353	4922	4043071	1986-08-20	1986-08-20 00:00:00	38000275	0	\N	\N	326979	0	228557008	4043071	
44616	3913	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	260135	0	180256009	4107731	
44848	3935	4151422	1952-02-28	1952-02-28 00:00:00	38000275	0	\N	\N	261574	0	269911007	4151422	
33037	2896	4107731	1992-04-26	1992-04-26 00:00:00	38000275	0	\N	\N	192797	0	180256009	4107731	
21313	1845	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	123353	0	180256009	4107731	
33335	2915	4107731	1992-02-02	1992-02-02 00:00:00	38000275	0	\N	\N	194265	0	180256009	4107731	
57452	4976	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	331003	0	180256009	4107731	
33781	2943	4151422	1971-01-28	1971-01-28 00:00:00	38000275	0	\N	\N	196320	0	269911007	4151422	
34014	2960	4151422	2011-11-16	2011-11-16 00:00:00	38000275	0	\N	\N	197687	0	269911007	4151422	
34141	2966	4107731	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	198148	0	180256009	4107731	
22423	1967	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	130833	0	180256009	4107731	
34439	2980	4107731	1992-08-30	1992-08-30 00:00:00	38000275	0	\N	\N	198991	0	180256009	4107731	
46590	4086	4243062	2006-06-20	2006-06-20 00:00:00	38000275	0	\N	\N	271576	0	60027007	4243062	
34906	3041	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	202538	0	180256009	4107731	
58989	5116	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	339890	0	180256009	4107731	
35293	3080	4125906	2018-10-09	2018-10-09 00:00:00	38000275	0	\N	\N	205012	0	288086009	4125906	
47336	4160	4275113	1984-05-22	1984-05-22 00:00:00	38000275	0	\N	\N	276437	0	65200003	4275113	
35638	3118	4107731	1990-07-08	1990-07-08 00:00:00	38000275	0	\N	\N	207527	0	180256009	4107731	
35745	3128	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	208130	0	180256009	4107731	
12106	1102	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	72453	0	180256009	4107731	
36158	3174	4295880	1999-08-27	1999-08-27 00:00:00	38000275	0	\N	\N	210986	0	76601001	4295880	
24402	2135	4107731	1990-06-18	1990-06-18 00:00:00	38000275	0	\N	\N	142166	0	180256009	4107731	
36519	3211	4125906	1965-06-09	1965-06-09 00:00:00	38000275	0	\N	\N	213358	0	288086009	4125906	
36713	3222	4125906	2007-08-06	2007-08-06 00:00:00	38000275	0	\N	\N	214157	0	288086009	4125906	
24941	2175	4107731	2010-10-19	2010-10-19 00:00:00	38000275	0	\N	\N	144959	0	180256009	4107731	
37037	3253	4107731	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	216386	0	180256009	4107731	
25402	2213	4163872	2004-09-04	2004-09-04 00:00:00	38000275	0	\N	\N	147391	0	399208008	4163872	
37402	3295	4078793	2017-05-22	2017-05-22 00:00:00	38000275	0	\N	\N	218900	0	180325003	4078793	
37730	3332	44783196	2014-06-15	2014-06-15 00:00:00	38000275	0	\N	\N	221134	0	699253003	44783196	
25916	2272	4295880	1999-05-22	1999-05-22 00:00:00	38000275	0	\N	\N	151067	0	76601001	4295880	
26092	2280	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	151569	0	180256009	4107731	
26334	2294	4293740	1961-11-20	1961-11-20 00:00:00	38000275	0	\N	\N	152747	0	384700001	4293740	
38425	3376	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	224053	0	180256009	4107731	
38609	3394	4275113	1983-09-10	1983-09-10 00:00:00	38000275	0	\N	\N	225123	0	65200003	4275113	
26831	2349	4107731	1993-04-18	1993-04-18 00:00:00	38000275	0	\N	\N	156350	0	180256009	4107731	
27051	2357	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	156939	0	180256009	4107731	
27177	2381	4043071	1943-07-14	1943-07-14 00:00:00	38000275	0	\N	\N	158309	0	228557008	4043071	
27464	2396	4216130	2001-02-21	2001-02-21 00:00:00	38000275	0	\N	\N	159325	0	415070008	4216130	
27512	2402	4107731	1993-01-18	1993-01-18 00:00:00	38000275	0	\N	\N	159697	0	180256009	4107731	
27837	2443	4151422	1989-12-11	1989-12-11 00:00:00	38000275	0	\N	\N	162040	0	269911007	4151422	
28010	2462	4107731	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	163304	0	180256009	4107731	
28120	2483	4125906	1961-02-17	1961-02-17 00:00:00	38000275	0	\N	\N	164511	0	288086009	4125906	
40256	3528	4107731	1990-01-22	1990-01-22 00:00:00	38000275	0	\N	\N	234177	0	180256009	4107731	
28527	2537	4107731	1992-05-17	1992-05-17 00:00:00	38000275	0	\N	\N	167607	0	180256009	4107731	
40641	3566	4107731	1992-08-03	1992-08-03 00:00:00	38000275	0	\N	\N	236934	0	180256009	4107731	
28978	2559	4107731	1993-01-23	1993-01-23 00:00:00	38000275	0	\N	\N	169580	0	180256009	4107731	
17197	1486	4107731	1992-02-02	1992-02-02 00:00:00	38000275	0	\N	\N	99123	0	180256009	4107731	
29305	2599	4238715	2004-01-31	2004-01-31 00:00:00	38000275	0	\N	\N	171995	0	68254000	4238715	
29474	2630	4043071	1969-04-15	1969-04-15 00:00:00	38000275	0	\N	\N	173964	0	228557008	4043071	
41670	3666	4151422	1971-10-30	1971-10-30 00:00:00	38000275	0	\N	\N	243880	0	269911007	4151422	
41789	3680	4107731	1992-09-22	1992-09-22 00:00:00	38000275	0	\N	\N	244748	0	180256009	4107731	
41895	3695	4151422	1987-03-31	1987-03-31 00:00:00	38000275	0	\N	\N	245664	0	269911007	4151422	
30275	2675	4151422	1969-06-18	1969-06-18 00:00:00	38000275	0	\N	\N	177276	0	269911007	4151422	
42330	3739	4275113	1983-08-02	1983-08-02 00:00:00	38000275	0	\N	\N	248452	0	65200003	4275113	
30575	2706	4170947	1973-01-16	1973-01-16 00:00:00	38000275	0	\N	\N	179257	0	274474001	4170947	
30791	2724	4043071	1962-12-09	1962-12-09 00:00:00	38000275	0	\N	\N	180481	0	228557008	4043071	
42851	3776	44783196	2010-11-27	2010-11-27 00:00:00	38000275	0	\N	\N	250955	0	699253003	44783196	
43034	3791	4195803	1982-10-13	1982-10-13 00:00:00	38000275	0	\N	\N	252161	0	312681000	4195803	
31245	2770	4107731	1990-06-02	1990-06-02 00:00:00	38000275	0	\N	\N	183369	0	180256009	4107731	
31526	2779	4107731	1997-05-07	1997-05-07 00:00:00	38000275	0	\N	\N	184120	0	180256009	4107731	
43659	3859	4078793	2016-04-16	2016-04-16 00:00:00	38000275	0	\N	\N	256182	0	180325003	4078793	
43871	3874	4107731	1996-06-26	1996-06-26 00:00:00	38000275	0	\N	\N	257256	0	180256009	4107731	
43961	3876	4107731	1992-02-17	1992-02-17 00:00:00	38000275	0	\N	\N	257516	0	180256009	4107731	
20340	1762	4035793	2006-02-23	2006-02-23 00:00:00	38000275	0	\N	\N	117857	0	15081005	4035793	
56354	4922	4043071	1987-02-25	1987-02-25 00:00:00	38000275	0	\N	\N	327072	0	228557008	4043071	
44617	3913	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	260151	0	180256009	4107731	
44849	3935	4125906	1983-02-07	1983-02-07 00:00:00	38000275	0	\N	\N	261543	0	288086009	4125906	
33038	2896	4107731	1993-05-09	1993-05-09 00:00:00	38000275	0	\N	\N	192822	0	180256009	4107731	
21314	1845	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	123369	0	180256009	4107731	
33336	2915	4107731	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	194327	0	180256009	4107731	
57453	4976	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	331039	0	180256009	4107731	
33782	2943	4170947	1931-08-13	1931-08-13 00:00:00	38000275	0	\N	\N	196246	0	274474001	4170947	
34015	2960	4125906	2009-03-24	2009-03-24 00:00:00	38000275	0	\N	\N	197610	0	288086009	4125906	
34142	2966	4107731	1991-02-09	1991-02-09 00:00:00	38000275	0	\N	\N	198094	0	180256009	4107731	
22424	1967	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	130857	0	180256009	4107731	
34440	2980	4107731	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	198920	0	180256009	4107731	
46591	4086	4170947	2006-06-20	2006-06-20 00:00:00	38000275	0	\N	\N	271576	0	274474001	4170947	
34907	3041	4107731	1993-07-29	1993-07-29 00:00:00	38000275	0	\N	\N	202434	0	180256009	4107731	
58990	5116	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	339940	0	180256009	4107731	
35294	3080	4293740	2018-10-09	2018-10-09 00:00:00	38000275	0	\N	\N	205012	0	384700001	4293740	
47337	4160	4238715	1988-02-18	1988-02-18 00:00:00	38000275	0	\N	\N	276425	0	68254000	4238715	
35639	3118	4107731	1990-10-21	1990-10-21 00:00:00	38000275	0	\N	\N	207439	0	180256009	4107731	
35746	3128	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	208143	0	180256009	4107731	
12107	1102	4107731	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	72390	0	180256009	4107731	
36159	3174	4295880	1998-05-29	1998-05-29 00:00:00	38000275	0	\N	\N	210981	0	76601001	4295880	
24403	2135	4107731	1992-07-13	1992-07-13 00:00:00	38000275	0	\N	\N	142092	0	180256009	4107731	
36520	3211	4151422	2001-11-19	2001-11-19 00:00:00	38000275	0	\N	\N	213317	0	269911007	4151422	
36714	3222	4151422	2011-01-03	2011-01-03 00:00:00	38000275	0	\N	\N	214217	0	269911007	4151422	
24942	2175	4107731	2012-06-19	2012-06-19 00:00:00	38000275	0	\N	\N	145047	0	180256009	4107731	
37038	3253	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	216338	0	180256009	4107731	
25403	2213	4145310	1974-06-26	1974-06-26 00:00:00	38000275	0	\N	\N	147425	0	268425006	4145310	
37403	3295	4057420	2013-04-29	2013-04-29 00:00:00	38000275	0	\N	\N	218983	0	18286008	4057420	
37731	3332	4252419	2014-06-08	2014-06-08 00:00:00	38000275	0	\N	\N	221133	0	74016001	4252419	
25917	2272	4295880	1998-02-21	1998-02-21 00:00:00	38000275	0	\N	\N	151051	0	76601001	4295880	
26093	2280	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	151690	0	180256009	4107731	
26335	2294	4043071	1968-05-10	1968-05-10 00:00:00	38000275	0	\N	\N	152713	0	228557008	4043071	
38426	3376	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	224061	0	180256009	4107731	
38610	3394	4202451	2010-08-21	2010-08-21 00:00:00	38000275	0	\N	\N	225139	0	433112001	4202451	
26832	2349	4107731	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	156428	0	180256009	4107731	
27052	2357	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	157048	0	180256009	4107731	
27178	2381	4043071	1944-08-09	1944-08-09 00:00:00	38000275	0	\N	\N	158343	0	228557008	4043071	
27465	2396	4326177	1995-10-31	1995-10-31 00:00:00	38000275	0	\N	\N	159375	0	430193006	4326177	
27513	2402	4107731	1993-03-01	1993-03-01 00:00:00	38000275	0	\N	\N	159698	0	180256009	4107731	
27838	2443	4125906	2019-02-02	2019-02-02 00:00:00	38000275	0	\N	\N	162036	0	288086009	4125906	
28011	2462	4107731	1991-08-18	1991-08-18 00:00:00	38000275	0	\N	\N	163327	0	180256009	4107731	
28122	2485	4195803	2003-11-12	2003-11-12 00:00:00	38000275	0	\N	\N	164632	0	312681000	4195803	
40257	3528	4107731	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	234189	0	180256009	4107731	
28528	2537	4107731	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	167724	0	180256009	4107731	
40642	3566	4107731	1991-08-12	1991-08-12 00:00:00	38000275	0	\N	\N	236899	0	180256009	4107731	
28979	2559	4107731	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	169555	0	180256009	4107731	
17198	1486	4107731	1990-10-07	1990-10-07 00:00:00	38000275	0	\N	\N	99031	0	180256009	4107731	
29311	2602	4125906	1992-01-03	1992-01-03 00:00:00	38000275	0	\N	\N	172146	0	288086009	4125906	
29475	2630	4043071	1969-03-18	1969-03-18 00:00:00	38000275	0	\N	\N	173983	0	228557008	4043071	
41671	3666	4151422	1991-08-22	1991-08-22 00:00:00	38000275	0	\N	\N	243860	0	269911007	4151422	
41790	3680	4107731	1993-12-28	1993-12-28 00:00:00	38000275	0	\N	\N	244793	0	180256009	4107731	
41896	3695	4107731	1995-10-23	1995-10-23 00:00:00	38000275	0	\N	\N	245636	0	180256009	4107731	
30276	2675	4151422	2005-12-29	2005-12-29 00:00:00	38000275	0	\N	\N	177282	0	269911007	4151422	
42331	3739	4058899	2006-06-11	2006-06-11 00:00:00	38000275	0	\N	\N	248442	0	168594001	4058899	
30576	2706	4125906	2001-08-22	2001-08-22 00:00:00	38000275	0	\N	\N	179261	0	288086009	4125906	
30792	2724	4043071	1963-01-13	1963-01-13 00:00:00	38000275	0	\N	\N	180476	0	228557008	4043071	
42852	3777	4252419	1990-04-25	1990-04-25 00:00:00	38000275	0	\N	\N	251032	0	74016001	4252419	
43035	3791	4024289	1982-10-13	1982-10-13 00:00:00	38000275	0	\N	\N	252161	0	19490002	4024289	
31246	2770	4107731	1991-04-13	1991-04-13 00:00:00	38000275	0	\N	\N	183282	0	180256009	4107731	
31527	2779	4107731	1998-04-29	1998-04-29 00:00:00	38000275	0	\N	\N	184184	0	180256009	4107731	
43660	3859	4035793	2002-09-07	2002-09-07 00:00:00	38000275	0	\N	\N	256239	0	15081005	4035793	
43872	3874	4107731	1998-03-18	1998-03-18 00:00:00	38000275	0	\N	\N	257285	0	180256009	4107731	
43962	3876	4107731	1993-03-01	1993-03-01 00:00:00	38000275	0	\N	\N	257465	0	180256009	4107731	
20341	1762	4035793	2019-05-09	2019-05-09 00:00:00	38000275	0	\N	\N	117860	0	15081005	4035793	
56355	4922	4043071	1985-02-13	1985-02-13 00:00:00	38000275	0	\N	\N	327027	0	228557008	4043071	
44618	3913	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	260162	0	180256009	4107731	
44850	3935	4202451	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	261552	0	433112001	4202451	
33039	2896	4107731	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	192814	0	180256009	4107731	
21315	1845	4125906	1996-04-15	1996-04-15 00:00:00	38000275	0	\N	\N	123325	0	288086009	4125906	
33337	2915	4107731	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	194239	0	180256009	4107731	
57454	4976	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	330952	0	180256009	4107731	
33783	2943	4047491	1931-08-13	1931-08-13 00:00:00	38000275	0	\N	\N	196246	0	1225002	4047491	
34016	2961	4198190	1972-09-26	1972-09-26 00:00:00	38000275	0	\N	\N	197702	0	80146002	4198190	
34143	2966	4107731	1992-02-01	1992-02-01 00:00:00	38000275	0	\N	\N	198145	0	180256009	4107731	
22425	1967	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	130859	0	180256009	4107731	
34441	2980	4107731	1990-02-18	1990-02-18 00:00:00	38000275	0	\N	\N	198944	0	180256009	4107731	
46592	4086	4151422	2016-11-12	2016-11-12 00:00:00	38000275	0	\N	\N	271621	0	269911007	4151422	
34908	3041	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	202506	0	180256009	4107731	
58991	5116	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	340012	0	180256009	4107731	
35295	3080	4125906	2002-07-16	2002-07-16 00:00:00	38000275	0	\N	\N	205009	0	288086009	4125906	
47338	4160	4163872	2017-01-27	2017-01-27 00:00:00	38000275	0	\N	\N	276476	0	399208008	4163872	
35640	3118	4107731	1992-03-29	1992-03-29 00:00:00	38000275	0	\N	\N	207516	0	180256009	4107731	
35747	3128	4058899	1985-08-11	1985-08-11 00:00:00	38000275	0	\N	\N	208166	0	168594001	4058899	
12108	1102	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	72483	0	180256009	4107731	
36160	3174	4295880	2000-08-25	2000-08-25 00:00:00	38000275	0	\N	\N	210967	0	76601001	4295880	
24404	2135	4107731	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	142076	0	180256009	4107731	
36521	3211	4125906	1968-06-07	1968-06-07 00:00:00	38000275	0	\N	\N	213360	0	288086009	4125906	
36715	3223	4047491	1919-08-03	1919-08-03 00:00:00	38000275	0	\N	\N	214307	0	1225002	4047491	
24943	2175	4107731	2009-03-31	2009-03-31 00:00:00	38000275	0	\N	\N	145013	0	180256009	4107731	
37039	3253	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	216365	0	180256009	4107731	
25404	2213	4191853	1991-08-01	1991-08-01 00:00:00	38000275	0	\N	\N	147361	0	395142003	4191853	
37404	3295	4078793	2012-04-23	2012-04-23 00:00:00	38000275	0	\N	\N	218909	0	180325003	4078793	
37732	3332	4151422	1974-11-24	1974-11-24 00:00:00	38000275	0	\N	\N	221125	0	269911007	4151422	
25918	2272	4170947	1987-11-19	1987-11-19 00:00:00	38000275	0	\N	\N	151060	0	274474001	4170947	
26094	2280	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	151655	0	180256009	4107731	
26336	2294	4043071	1968-06-14	1968-06-14 00:00:00	38000275	0	\N	\N	152714	0	228557008	4043071	
38427	3376	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	223971	0	180256009	4107731	
38611	3394	4163872	1972-11-25	1972-11-25 00:00:00	38000275	0	\N	\N	225162	0	399208008	4163872	
26833	2349	4107731	1990-04-01	1990-04-01 00:00:00	38000275	0	\N	\N	156441	0	180256009	4107731	
27053	2357	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	157033	0	180256009	4107731	
27179	2381	4043071	1944-02-09	1944-02-09 00:00:00	38000275	0	\N	\N	158312	0	228557008	4043071	
27466	2396	4037675	1995-10-31	1995-10-31 00:00:00	38000275	0	\N	\N	159375	0	162676008	4037675	
27514	2402	4107731	1991-12-16	1991-12-16 00:00:00	38000275	0	\N	\N	159655	0	180256009	4107731	
27839	2444	4252419	1963-02-26	1963-02-26 00:00:00	38000275	0	\N	\N	162153	0	74016001	4252419	
28012	2462	4107731	1990-08-05	1990-08-05 00:00:00	38000275	0	\N	\N	163305	0	180256009	4107731	
28123	2485	4293740	2015-12-23	2015-12-23 00:00:00	38000275	0	\N	\N	164692	0	384700001	4293740	
40258	3528	4107731	1992-06-01	1992-06-01 00:00:00	38000275	0	\N	\N	234233	0	180256009	4107731	
28529	2537	4107731	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	167778	0	180256009	4107731	
40643	3566	4107731	1990-08-20	1990-08-20 00:00:00	38000275	0	\N	\N	236894	0	180256009	4107731	
28980	2559	4107731	1990-05-12	1990-05-12 00:00:00	38000275	0	\N	\N	169545	0	180256009	4107731	
17199	1486	4107731	1992-04-26	1992-04-26 00:00:00	38000275	0	\N	\N	99016	0	180256009	4107731	
29312	2602	4293740	1992-01-03	1992-01-03 00:00:00	38000275	0	\N	\N	172146	0	384700001	4293740	
29476	2630	4043071	1970-04-28	1970-04-28 00:00:00	38000275	0	\N	\N	173928	0	228557008	4043071	
41672	3666	4151422	1979-12-16	1979-12-16 00:00:00	38000275	0	\N	\N	243881	0	269911007	4151422	
41791	3680	4107731	1993-04-20	1993-04-20 00:00:00	38000275	0	\N	\N	244762	0	180256009	4107731	
41897	3695	4107731	1996-04-29	1996-04-29 00:00:00	38000275	0	\N	\N	245591	0	180256009	4107731	
30277	2675	4170947	1978-02-13	1978-02-13 00:00:00	38000275	0	\N	\N	177232	0	274474001	4170947	
42332	3739	4238715	1987-08-17	1987-08-17 00:00:00	38000275	0	\N	\N	248467	0	68254000	4238715	
30579	2708	4293740	1987-05-17	1987-05-17 00:00:00	38000275	0	\N	\N	179431	0	384700001	4293740	
30793	2724	4043071	1962-09-02	1962-09-02 00:00:00	38000275	0	\N	\N	180527	0	228557008	4043071	
42853	3777	44783196	1990-05-02	1990-05-02 00:00:00	38000275	0	\N	\N	251015	0	699253003	44783196	
43036	3791	4170947	1982-10-13	1982-10-13 00:00:00	38000275	0	\N	\N	252161	0	274474001	4170947	
31247	2770	4202451	2015-08-15	2015-08-15 00:00:00	38000275	0	\N	\N	183245	0	433112001	4202451	
31528	2779	4107731	1998-05-20	1998-05-20 00:00:00	38000275	0	\N	\N	184130	0	180256009	4107731	
43661	3859	4035793	2007-10-06	2007-10-06 00:00:00	38000275	0	\N	\N	256160	0	15081005	4035793	
43873	3874	4107731	1997-02-12	1997-02-12 00:00:00	38000275	0	\N	\N	257278	0	180256009	4107731	
43963	3876	4107731	1991-04-08	1991-04-08 00:00:00	38000275	0	\N	\N	257512	0	180256009	4107731	
20342	1762	4078793	2019-05-09	2019-05-09 00:00:00	38000275	0	\N	\N	117860	0	180325003	4078793	
56356	4922	4043071	1986-09-17	1986-09-17 00:00:00	38000275	0	\N	\N	327071	0	228557008	4043071	
44619	3913	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	260179	0	180256009	4107731	
44851	3936	4252419	2006-11-28	2006-11-28 00:00:00	38000275	0	\N	\N	261632	0	74016001	4252419	
33040	2896	4107731	1992-06-07	1992-06-07 00:00:00	38000275	0	\N	\N	192798	0	180256009	4107731	
21316	1845	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	123329	0	180256009	4107731	
33338	2915	4107731	1991-03-03	1991-03-03 00:00:00	38000275	0	\N	\N	194333	0	180256009	4107731	
57455	4976	4202451	1984-06-12	1984-06-12 00:00:00	38000275	0	\N	\N	330937	0	433112001	4202451	
33784	2943	4125906	1946-10-14	1946-10-14 00:00:00	38000275	0	\N	\N	196248	0	288086009	4125906	
34021	2965	4107731	1992-07-13	1992-07-13 00:00:00	38000275	0	\N	\N	197952	0	180256009	4107731	
34144	2966	4107731	1991-07-27	1991-07-27 00:00:00	38000275	0	\N	\N	198083	0	180256009	4107731	
22426	1967	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	130799	0	180256009	4107731	
34442	2980	4107731	1993-02-14	1993-02-14 00:00:00	38000275	0	\N	\N	198956	0	180256009	4107731	
46593	4086	4151422	1991-10-02	1991-10-02 00:00:00	38000275	0	\N	\N	271619	0	269911007	4151422	
34909	3041	4107731	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	202523	0	180256009	4107731	
58992	5116	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	339903	0	180256009	4107731	
35296	3080	4125906	1966-07-13	1966-07-13 00:00:00	38000275	0	\N	\N	204968	0	288086009	4125906	
47339	4160	4170947	1978-05-17	1978-05-17 00:00:00	38000275	0	\N	\N	276450	0	274474001	4170947	
35641	3118	4107731	1992-10-25	1992-10-25 00:00:00	38000275	0	\N	\N	207455	0	180256009	4107731	
35748	3128	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	208147	0	180256009	4107731	
12109	1102	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	72465	0	180256009	4107731	
36161	3174	4295880	1997-11-23	1997-11-23 00:00:00	38000275	0	\N	\N	210980	0	76601001	4295880	
24405	2135	4107731	1990-03-05	1990-03-05 00:00:00	38000275	0	\N	\N	142074	0	180256009	4107731	
36522	3211	4170947	1966-04-19	1966-04-19 00:00:00	38000275	0	\N	\N	213359	0	274474001	4170947	
36716	3223	4170947	1919-08-03	1919-08-03 00:00:00	38000275	0	\N	\N	214307	0	274474001	4170947	
24944	2175	4107731	2011-01-11	2011-01-11 00:00:00	38000275	0	\N	\N	145079	0	180256009	4107731	
37040	3253	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	216251	0	180256009	4107731	
25405	2213	4151422	2011-12-16	2011-12-16 00:00:00	38000275	0	\N	\N	147378	0	269911007	4151422	
37405	3295	4078793	2016-05-16	2016-05-16 00:00:00	38000275	0	\N	\N	218963	0	180325003	4078793	
37733	3334	4024289	1946-10-20	1946-10-20 00:00:00	38000275	0	\N	\N	221157	0	19490002	4024289	
25919	2272	4047491	1987-11-19	1987-11-19 00:00:00	38000275	0	\N	\N	151060	0	1225002	4047491	
26095	2280	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	151643	0	180256009	4107731	
26337	2294	4043071	1968-11-08	1968-11-08 00:00:00	38000275	0	\N	\N	152659	0	228557008	4043071	
38428	3376	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	224063	0	180256009	4107731	
38612	3394	4238715	1989-02-18	1989-02-18 00:00:00	38000275	0	\N	\N	225146	0	68254000	4238715	
26834	2349	4107731	1990-08-05	1990-08-05 00:00:00	38000275	0	\N	\N	156367	0	180256009	4107731	
27054	2357	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	156972	0	180256009	4107731	
27180	2381	4043071	1944-10-11	1944-10-11 00:00:00	38000275	0	\N	\N	158291	0	228557008	4043071	
27467	2396	4187458	1995-10-31	1995-10-31 00:00:00	38000275	0	\N	\N	159375	0	415300000	4187458	
27515	2402	4107731	1990-08-20	1990-08-20 00:00:00	38000275	0	\N	\N	159577	0	180256009	4107731	
27840	2444	44783196	1963-03-05	1963-03-05 00:00:00	38000275	0	\N	\N	162157	0	699253003	44783196	
28013	2462	4107731	1991-01-20	1991-01-20 00:00:00	38000275	0	\N	\N	163258	0	180256009	4107731	
28124	2485	4125906	2015-12-23	2015-12-23 00:00:00	38000275	0	\N	\N	164692	0	288086009	4125906	
40259	3528	4107731	1992-07-13	1992-07-13 00:00:00	38000275	0	\N	\N	234234	0	180256009	4107731	
28530	2537	4107731	1990-11-18	1990-11-18 00:00:00	38000275	0	\N	\N	167601	0	180256009	4107731	
40644	3566	4043071	1960-02-22	1960-02-22 00:00:00	38000275	0	\N	\N	236907	0	228557008	4043071	
28981	2559	4163872	1960-12-02	1960-12-02 00:00:00	38000275	0	\N	\N	169523	0	399208008	4163872	
17200	1486	4107731	1990-02-18	1990-02-18 00:00:00	38000275	0	\N	\N	99140	0	180256009	4107731	
29313	2602	4170947	2017-01-26	2017-01-26 00:00:00	38000275	0	\N	\N	172148	0	274474001	4170947	
29477	2630	4043071	1970-02-24	1970-02-24 00:00:00	38000275	0	\N	\N	173977	0	228557008	4043071	
41673	3666	4125906	2013-06-02	2013-06-02 00:00:00	38000275	0	\N	\N	243869	0	288086009	4125906	
41792	3680	4107731	1994-07-05	1994-07-05 00:00:00	38000275	0	\N	\N	244691	0	180256009	4107731	
41898	3695	4107731	1995-06-19	1995-06-19 00:00:00	38000275	0	\N	\N	245631	0	180256009	4107731	
30278	2675	4047491	1978-02-13	1978-02-13 00:00:00	38000275	0	\N	\N	177232	0	1225002	4047491	
42333	3739	4047491	2009-08-24	2009-08-24 00:00:00	38000275	0	\N	\N	248443	0	1225002	4047491	
30580	2708	4125906	1987-05-17	1987-05-17 00:00:00	38000275	0	\N	\N	179431	0	288086009	4125906	
30794	2724	4125906	1997-10-30	1997-10-30 00:00:00	38000275	0	\N	\N	180435	0	288086009	4125906	
42854	3777	4151422	2012-04-09	2012-04-09 00:00:00	38000275	0	\N	\N	251026	0	269911007	4151422	
43037	3791	4163872	1976-09-19	1976-09-19 00:00:00	38000275	0	\N	\N	252136	0	399208008	4163872	
31248	2770	4197460	1948-02-04	1948-02-04 00:00:00	38000275	0	\N	\N	183303	0	313191000	4197460	
31529	2779	4107731	1996-08-07	1996-08-07 00:00:00	38000275	0	\N	\N	184117	0	180256009	4107731	
43662	3860	4125906	1994-02-21	1994-02-21 00:00:00	38000275	0	\N	\N	256339	0	288086009	4125906	
43874	3874	4107731	1996-01-10	1996-01-10 00:00:00	38000275	0	\N	\N	257313	0	180256009	4107731	
43964	3876	4107731	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	257446	0	180256009	4107731	
20343	1762	4078793	2012-03-29	2012-03-29 00:00:00	38000275	0	\N	\N	117811	0	180325003	4078793	
56357	4922	4043071	1985-07-24	1985-07-24 00:00:00	38000275	0	\N	\N	326976	0	228557008	4043071	
44620	3913	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	260180	0	180256009	4107731	
44852	3938	4151422	1915-01-26	1915-01-26 00:00:00	38000275	0	\N	\N	261772	0	269911007	4151422	
33041	2896	4191853	1993-07-11	1993-07-11 00:00:00	38000275	0	\N	\N	192802	0	395142003	4191853	
21317	1845	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	123333	0	180256009	4107731	
33339	2915	4107731	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	194253	0	180256009	4107731	
57456	4976	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	331057	0	180256009	4107731	
33785	2943	4170947	1929-09-22	1929-09-22 00:00:00	38000275	0	\N	\N	196245	0	274474001	4170947	
34022	2965	4107731	1990-06-18	1990-06-18 00:00:00	38000275	0	\N	\N	198008	0	180256009	4107731	
34145	2966	4107731	1992-02-22	1992-02-22 00:00:00	38000275	0	\N	\N	198133	0	180256009	4107731	
22427	1967	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	130794	0	180256009	4107731	
34443	2980	4107731	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	198906	0	180256009	4107731	
46594	4086	4151422	2019-02-09	2019-02-09 00:00:00	38000275	0	\N	\N	271614	0	269911007	4151422	
34910	3041	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	202536	0	180256009	4107731	
58993	5116	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	340006	0	180256009	4107731	
35297	3080	4293740	1966-07-13	1966-07-13 00:00:00	38000275	0	\N	\N	204968	0	384700001	4293740	
47340	4160	4243062	1978-05-17	1978-05-17 00:00:00	38000275	0	\N	\N	276450	0	60027007	4243062	
35642	3118	4107731	1990-12-02	1990-12-02 00:00:00	38000275	0	\N	\N	207440	0	180256009	4107731	
35749	3128	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	208173	0	180256009	4107731	
12110	1102	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	72393	0	180256009	4107731	
36162	3174	4295880	2000-11-24	2000-11-24 00:00:00	38000275	0	\N	\N	210946	0	76601001	4295880	
24406	2135	4107731	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	142053	0	180256009	4107731	
36523	3211	4047491	1966-04-19	1966-04-19 00:00:00	38000275	0	\N	\N	213359	0	1225002	4047491	
36717	3223	4058899	1929-02-11	1929-02-11 00:00:00	38000275	0	\N	\N	214308	0	168594001	4058899	
24945	2175	4125906	2019-02-03	2019-02-03 00:00:00	38000275	0	\N	\N	145070	0	288086009	4125906	
37041	3253	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	216261	0	180256009	4107731	
25406	2213	4125906	1972-05-23	1972-05-23 00:00:00	38000275	0	\N	\N	147424	0	288086009	4125906	
37406	3295	4078793	2014-05-05	2014-05-05 00:00:00	38000275	0	\N	\N	218910	0	180325003	4078793	
37734	3334	4170947	1946-10-20	1946-10-20 00:00:00	38000275	0	\N	\N	221157	0	274474001	4170947	
25920	2272	4295880	2003-05-17	2003-05-17 00:00:00	38000275	0	\N	\N	151041	0	76601001	4295880	
26096	2280	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	151603	0	180256009	4107731	
26338	2294	4043071	1968-10-11	1968-10-11 00:00:00	38000275	0	\N	\N	152715	0	228557008	4043071	
38429	3376	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	224031	0	180256009	4107731	
38613	3394	4163872	2003-12-01	2003-12-01 00:00:00	38000275	0	\N	\N	225165	0	399208008	4163872	
26835	2349	4107731	1993-01-24	1993-01-24 00:00:00	38000275	0	\N	\N	156348	0	180256009	4107731	
27055	2357	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	157031	0	180256009	4107731	
27181	2381	4163872	2003-10-29	2003-10-29 00:00:00	38000275	0	\N	\N	158349	0	399208008	4163872	
27468	2396	4202451	2000-11-08	2000-11-08 00:00:00	38000275	0	\N	\N	159376	0	433112001	4202451	
27516	2402	4107731	1990-06-18	1990-06-18 00:00:00	38000275	0	\N	\N	159630	0	180256009	4107731	
27841	2444	4202451	2013-08-11	2013-08-11 00:00:00	38000275	0	\N	\N	162130	0	433112001	4202451	
28014	2462	4107731	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	163283	0	180256009	4107731	
28125	2485	4170947	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	164690	0	274474001	4170947	
40260	3528	4107731	1992-10-26	1992-10-26 00:00:00	38000275	0	\N	\N	234273	0	180256009	4107731	
28531	2537	4107731	1991-09-29	1991-09-29 00:00:00	38000275	0	\N	\N	167605	0	180256009	4107731	
40645	3566	4107731	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	236964	0	180256009	4107731	
28982	2559	4107731	1991-09-28	1991-09-28 00:00:00	38000275	0	\N	\N	169557	0	180256009	4107731	
17201	1486	4107731	1990-06-24	1990-06-24 00:00:00	38000275	0	\N	\N	99131	0	180256009	4107731	
29314	2602	4163872	2017-01-26	2017-01-26 00:00:00	38000275	0	\N	\N	172148	0	399208008	4163872	
29478	2630	4043071	1969-02-18	1969-02-18 00:00:00	38000275	0	\N	\N	173999	0	228557008	4043071	
41674	3666	4010253	1989-12-09	1989-12-09 00:00:00	38000275	0	\N	\N	243883	0	112790001	4010253	
41793	3680	4107731	1995-04-25	1995-04-25 00:00:00	38000275	0	\N	\N	244701	0	180256009	4107731	
41899	3695	4107731	1995-12-25	1995-12-25 00:00:00	38000275	0	\N	\N	245632	0	180256009	4107731	
30279	2675	4125906	2006-06-21	2006-06-21 00:00:00	38000275	0	\N	\N	177236	0	288086009	4125906	
42334	3739	4170947	2009-08-24	2009-08-24 00:00:00	38000275	0	\N	\N	248443	0	274474001	4170947	
30581	2708	4058899	1973-01-28	1973-01-28 00:00:00	38000275	0	\N	\N	179429	0	168594001	4058899	
30795	2724	4043071	1961-08-27	1961-08-27 00:00:00	38000275	0	\N	\N	180515	0	228557008	4043071	
42855	3777	4125906	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	251033	0	288086009	4125906	
43038	3791	4170947	2012-04-08	2012-04-08 00:00:00	38000275	0	\N	\N	252162	0	274474001	4170947	
31249	2770	4107731	1992-12-12	1992-12-12 00:00:00	38000275	0	\N	\N	183298	0	180256009	4107731	
31530	2779	4107731	1995-03-01	1995-03-01 00:00:00	38000275	0	\N	\N	184126	0	180256009	4107731	
43663	3860	4198190	1978-07-08	1978-07-08 00:00:00	38000275	0	\N	\N	256340	0	80146002	4198190	
43875	3874	4107731	1998-06-10	1998-06-10 00:00:00	38000275	0	\N	\N	257287	0	180256009	4107731	
43965	3876	4107731	1990-08-20	1990-08-20 00:00:00	38000275	0	\N	\N	257505	0	180256009	4107731	
20344	1762	4035793	2012-03-29	2012-03-29 00:00:00	38000275	0	\N	\N	117811	0	15081005	4035793	
56358	4922	4043071	1986-12-17	1986-12-17 00:00:00	38000275	0	\N	\N	327013	0	228557008	4043071	
44621	3913	4243062	1969-11-10	1969-11-10 00:00:00	38000275	0	\N	\N	260086	0	60027007	4243062	
44853	3938	4195803	1990-08-15	1990-08-15 00:00:00	38000275	0	\N	\N	261731	0	312681000	4195803	
33042	2896	4107731	1993-04-18	1993-04-18 00:00:00	38000275	0	\N	\N	192860	0	180256009	4107731	
21318	1845	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	123312	0	180256009	4107731	
33340	2915	4107731	1992-06-28	1992-06-28 00:00:00	38000275	0	\N	\N	194237	0	180256009	4107731	
57457	4976	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	330928	0	180256009	4107731	
33786	2943	4163872	1929-09-22	1929-09-22 00:00:00	38000275	0	\N	\N	196245	0	399208008	4163872	
34023	2965	4107731	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	197913	0	180256009	4107731	
34146	2966	4107731	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	198158	0	180256009	4107731	
22428	1967	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	130834	0	395142003	4191853	
34444	2980	4107731	1990-09-16	1990-09-16 00:00:00	38000275	0	\N	\N	199007	0	180256009	4107731	
46595	4087	4151422	2010-10-13	2010-10-13 00:00:00	38000275	0	\N	\N	271648	0	269911007	4151422	
34911	3041	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	202450	0	180256009	4107731	
58994	5116	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	339989	0	180256009	4107731	
35298	3080	4195803	2014-10-02	2014-10-02 00:00:00	38000275	0	\N	\N	205010	0	312681000	4195803	
47341	4160	4125906	2011-11-18	2011-11-18 00:00:00	38000275	0	\N	\N	276452	0	288086009	4125906	
35643	3118	4145310	1964-04-06	1964-04-06 00:00:00	38000275	0	\N	\N	207402	0	268425006	4145310	
35750	3128	4295880	1995-06-09	1995-06-09 00:00:00	38000275	0	\N	\N	208177	0	76601001	4295880	
12111	1102	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	72395	0	180256009	4107731	
36163	3174	4295880	1999-05-28	1999-05-28 00:00:00	38000275	0	\N	\N	210959	0	76601001	4295880	
24407	2135	4107731	1992-06-22	1992-06-22 00:00:00	38000275	0	\N	\N	142054	0	180256009	4107731	
36524	3211	4293740	1970-05-12	1970-05-12 00:00:00	38000275	0	\N	\N	213361	0	384700001	4293740	
36718	3223	4198190	1949-07-12	1949-07-12 00:00:00	38000275	0	\N	\N	214304	0	80146002	4198190	
24946	2175	4107731	2009-08-04	2009-08-04 00:00:00	38000275	0	\N	\N	145033	0	180256009	4107731	
37042	3253	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	216376	0	180256009	4107731	
37214	3270	4043071	1986-03-31	1986-03-31 00:00:00	38000275	0	\N	\N	217258	0	228557008	4043071	
37407	3295	4078793	1990-10-08	1990-10-08 00:00:00	38000275	0	\N	\N	218937	0	180325003	4078793	
37735	3335	4043071	1979-05-27	1979-05-27 00:00:00	38000275	0	\N	\N	221286	0	228557008	4043071	
25921	2272	4024289	1982-09-16	1982-09-16 00:00:00	38000275	0	\N	\N	151059	0	19490002	4024289	
26097	2280	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	151685	0	180256009	4107731	
26339	2294	4043071	1968-03-01	1968-03-01 00:00:00	38000275	0	\N	\N	152727	0	228557008	4043071	
38430	3376	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	223973	0	180256009	4107731	
38614	3394	4186930	1988-09-10	1988-09-10 00:00:00	38000275	0	\N	\N	225145	0	46706006	4186930	
26836	2349	4107731	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	156366	0	180256009	4107731	
27056	2357	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	156976	0	180256009	4107731	
27182	2381	4043071	1944-03-15	1944-03-15 00:00:00	38000275	0	\N	\N	158331	0	228557008	4043071	
39273	3464	4107731	2011-04-01	2011-04-01 00:00:00	38000275	0	\N	\N	229895	0	180256009	4107731	
27517	2402	4107731	1991-03-18	1991-03-18 00:00:00	38000275	0	\N	\N	159652	0	180256009	4107731	
27842	2444	4125906	1965-04-23	1965-04-23 00:00:00	38000275	0	\N	\N	162154	0	288086009	4125906	
28015	2462	4107731	1991-05-05	1991-05-05 00:00:00	38000275	0	\N	\N	163228	0	180256009	4107731	
28126	2485	4024289	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	164690	0	19490002	4024289	
40261	3528	4107731	1991-11-04	1991-11-04 00:00:00	38000275	0	\N	\N	234174	0	180256009	4107731	
28532	2537	4107731	1991-05-26	1991-05-26 00:00:00	38000275	0	\N	\N	167657	0	180256009	4107731	
40646	3566	4107731	1992-06-01	1992-06-01 00:00:00	38000275	0	\N	\N	236845	0	180256009	4107731	
28983	2559	4107731	1990-10-06	1990-10-06 00:00:00	38000275	0	\N	\N	169528	0	180256009	4107731	
17202	1486	4107731	1992-06-28	1992-06-28 00:00:00	38000275	0	\N	\N	99038	0	180256009	4107731	
29315	2602	4195803	2009-03-25	2009-03-25 00:00:00	38000275	0	\N	\N	172092	0	312681000	4195803	
29479	2630	4043071	1969-11-25	1969-11-25 00:00:00	38000275	0	\N	\N	173927	0	228557008	4043071	
41675	3667	4125906	1977-09-28	1977-09-28 00:00:00	38000275	0	\N	\N	243977	0	288086009	4125906	
41794	3680	4107731	1993-03-30	1993-03-30 00:00:00	38000275	0	\N	\N	244790	0	180256009	4107731	
41900	3695	42535580	1996-03-20	1996-03-20 00:00:00	38000275	0	\N	\N	245605	0	426701000119108	42535580	
30282	2677	4043071	1986-04-24	1986-04-24 00:00:00	38000275	0	\N	\N	177376	0	228557008	4043071	
42400	3743	4024289	1979-07-05	1979-07-05 00:00:00	38000275	0	\N	\N	248689	0	19490002	4024289	
30582	2709	4047491	1944-11-07	1944-11-07 00:00:00	38000275	0	\N	\N	179447	0	1225002	4047491	
30796	2724	4043071	1961-06-25	1961-06-25 00:00:00	38000275	0	\N	\N	180492	0	228557008	4043071	
42856	3777	4151422	2000-03-05	2000-03-05 00:00:00	38000275	0	\N	\N	251025	0	269911007	4151422	
43039	3791	4243062	2012-04-08	2012-04-08 00:00:00	38000275	0	\N	\N	252162	0	60027007	4243062	
31250	2770	4107731	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	183297	0	180256009	4107731	
31531	2779	4107731	1996-08-28	1996-08-28 00:00:00	38000275	0	\N	\N	184103	0	180256009	4107731	
43666	3862	4163872	1977-05-12	1977-05-12 00:00:00	38000275	0	\N	\N	256438	0	399208008	4163872	
43876	3874	4107731	1996-02-21	1996-02-21 00:00:00	38000275	0	\N	\N	257222	0	180256009	4107731	
43966	3876	4191853	1990-01-01	1990-01-01 00:00:00	38000275	0	\N	\N	257503	0	395142003	4191853	
20345	1762	4078793	1999-04-15	1999-04-15 00:00:00	38000275	0	\N	\N	117875	0	180325003	4078793	
56359	4922	4043071	1985-04-17	1985-04-17 00:00:00	38000275	0	\N	\N	326986	0	228557008	4043071	
44622	3913	4170947	1969-11-10	1969-11-10 00:00:00	38000275	0	\N	\N	260086	0	274474001	4170947	
44854	3938	4202451	1976-10-20	1976-10-20 00:00:00	38000275	0	\N	\N	261757	0	433112001	4202451	
33043	2896	4107731	1992-02-02	1992-02-02 00:00:00	38000275	0	\N	\N	192812	0	180256009	4107731	
33100	2898	4107731	1993-11-02	1993-11-02 00:00:00	38000275	0	\N	\N	193003	0	180256009	4107731	
33341	2915	4107731	1992-01-12	1992-01-12 00:00:00	38000275	0	\N	\N	194250	0	180256009	4107731	
57458	4976	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	331002	0	180256009	4107731	
33787	2944	44783196	2006-10-23	2006-10-23 00:00:00	38000275	0	\N	\N	196434	0	699253003	44783196	
34024	2965	4107731	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	197906	0	180256009	4107731	
34147	2966	4107731	1990-06-02	1990-06-02 00:00:00	38000275	0	\N	\N	198123	0	180256009	4107731	
22429	1967	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	130763	0	180256009	4107731	
34445	2980	4107731	1991-10-20	1991-10-20 00:00:00	38000275	0	\N	\N	199013	0	180256009	4107731	
46596	4087	4243062	2013-12-03	2013-12-03 00:00:00	38000275	0	\N	\N	271643	0	60027007	4243062	
34912	3041	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	202459	0	180256009	4107731	
58995	5116	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	339897	0	180256009	4107731	
35299	3080	4058899	2014-10-02	2014-10-02 00:00:00	38000275	0	\N	\N	205010	0	168594001	4058899	
47434	4165	4151422	1960-10-22	1960-10-22 00:00:00	38000275	0	\N	\N	276748	0	269911007	4151422	
35644	3118	4107731	1990-03-25	1990-03-25 00:00:00	38000275	0	\N	\N	207488	0	180256009	4107731	
35751	3128	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	208148	0	180256009	4107731	
12112	1102	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	72431	0	180256009	4107731	
36164	3174	4295880	1999-11-26	1999-11-26 00:00:00	38000275	0	\N	\N	210983	0	76601001	4295880	
24408	2135	4107731	1990-02-12	1990-02-12 00:00:00	38000275	0	\N	\N	142063	0	180256009	4107731	
36525	3211	4125906	1970-05-12	1970-05-12 00:00:00	38000275	0	\N	\N	213361	0	288086009	4125906	
36719	3223	4195803	1987-06-17	1987-06-17 00:00:00	38000275	0	\N	\N	214244	0	312681000	4195803	
24947	2175	4107731	2011-06-28	2011-06-28 00:00:00	38000275	0	\N	\N	145062	0	180256009	4107731	
37043	3253	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	216388	0	180256009	4107731	
37215	3270	4043071	1983-08-08	1983-08-08 00:00:00	38000275	0	\N	\N	217363	0	228557008	4043071	
37408	3295	4057420	1998-11-16	1998-11-16 00:00:00	38000275	0	\N	\N	218958	0	18286008	4057420	
37736	3335	4043071	1979-09-02	1979-09-02 00:00:00	38000275	0	\N	\N	221239	0	228557008	4043071	
25922	2272	4170947	1982-09-16	1982-09-16 00:00:00	38000275	0	\N	\N	151059	0	274474001	4170947	
26098	2280	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	151688	0	180256009	4107731	
26340	2294	4043071	1968-08-16	1968-08-16 00:00:00	38000275	0	\N	\N	152676	0	228557008	4043071	
38431	3376	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	224015	0	180256009	4107731	
38615	3394	4047491	1980-02-16	1980-02-16 00:00:00	38000275	0	\N	\N	225156	0	1225002	4047491	
26837	2349	4107731	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	156442	0	180256009	4107731	
27057	2357	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	157022	0	180256009	4107731	
27183	2381	4043071	1943-08-18	1943-08-18 00:00:00	38000275	0	\N	\N	158340	0	228557008	4043071	
39274	3464	4107731	2010-01-15	2010-01-15 00:00:00	38000275	0	\N	\N	229907	0	180256009	4107731	
27518	2402	4107731	1992-08-24	1992-08-24 00:00:00	38000275	0	\N	\N	159598	0	180256009	4107731	
27843	2444	4151422	1985-02-02	1985-02-02 00:00:00	38000275	0	\N	\N	162160	0	269911007	4151422	
28016	2462	4107731	1991-03-03	1991-03-03 00:00:00	38000275	0	\N	\N	163259	0	180256009	4107731	
28127	2485	4195803	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	164690	0	312681000	4195803	
40262	3529	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	234401	0	180256009	4107731	
28533	2537	4107731	1992-02-02	1992-02-02 00:00:00	38000275	0	\N	\N	167619	0	180256009	4107731	
40647	3566	4191853	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	236980	0	395142003	4191853	
28984	2559	4107731	1993-03-27	1993-03-27 00:00:00	38000275	0	\N	\N	169563	0	180256009	4107731	
17203	1486	4107731	1993-04-18	1993-04-18 00:00:00	38000275	0	\N	\N	99021	0	180256009	4107731	
29316	2602	4202451	1985-09-04	1985-09-04 00:00:00	38000275	0	\N	\N	172108	0	433112001	4202451	
29480	2630	4043071	1970-06-23	1970-06-23 00:00:00	38000275	0	\N	\N	173979	0	228557008	4043071	
41676	3667	4125906	1974-10-23	1974-10-23 00:00:00	38000275	0	\N	\N	243976	0	288086009	4125906	
41795	3680	4107731	1992-10-13	1992-10-13 00:00:00	38000275	0	\N	\N	244783	0	180256009	4107731	
41901	3695	4202832	1996-03-20	1996-03-20 00:00:00	38000275	0	\N	\N	245605	0	52765003	4202832	
30283	2677	4043071	1986-08-29	1986-08-29 00:00:00	38000275	0	\N	\N	177427	0	228557008	4043071	
42401	3743	4170947	1979-07-05	1979-07-05 00:00:00	38000275	0	\N	\N	248689	0	274474001	4170947	
30583	2709	4170947	1944-11-07	1944-11-07 00:00:00	38000275	0	\N	\N	179447	0	274474001	4170947	
30797	2724	4043071	1962-04-01	1962-04-01 00:00:00	38000275	0	\N	\N	180525	0	228557008	4043071	
42857	3778	4125906	2003-12-09	2003-12-09 00:00:00	38000275	0	\N	\N	251059	0	288086009	4125906	
43040	3791	4195803	2012-04-08	2012-04-08 00:00:00	38000275	0	\N	\N	252162	0	312681000	4195803	
31251	2770	4107731	1992-06-06	1992-06-06 00:00:00	38000275	0	\N	\N	183348	0	180256009	4107731	
31532	2779	4191853	1994-12-07	1994-12-07 00:00:00	38000275	0	\N	\N	184124	0	395142003	4191853	
43667	3862	4151422	1995-04-20	1995-04-20 00:00:00	38000275	0	\N	\N	256381	0	269911007	4151422	
43877	3874	4107731	1996-03-13	1996-03-13 00:00:00	38000275	0	\N	\N	257217	0	180256009	4107731	
43967	3876	4107731	1992-01-06	1992-01-06 00:00:00	38000275	0	\N	\N	257515	0	180256009	4107731	
20346	1762	4035793	1999-04-15	1999-04-15 00:00:00	38000275	0	\N	\N	117875	0	15081005	4035793	
56360	4922	4010253	2011-01-03	2011-01-03 00:00:00	38000275	0	\N	\N	327059	0	112790001	4010253	
44623	3913	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	260124	0	180256009	4107731	
44855	3939	4151422	2008-09-28	2008-09-28 00:00:00	38000275	0	\N	\N	261866	0	269911007	4151422	
33044	2896	4170947	2014-10-26	2014-10-26 00:00:00	38000275	0	\N	\N	192868	0	274474001	4170947	
33101	2898	4191853	1980-03-29	1980-03-29 00:00:00	38000275	0	\N	\N	193004	0	395142003	4191853	
33342	2915	4107731	1991-09-08	1991-09-08 00:00:00	38000275	0	\N	\N	194247	0	180256009	4107731	
57459	4976	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	330984	0	180256009	4107731	
33788	2944	4151422	2010-10-07	2010-10-07 00:00:00	38000275	0	\N	\N	196412	0	269911007	4151422	
34025	2965	4107731	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	197915	0	180256009	4107731	
34148	2966	4107731	1990-07-14	1990-07-14 00:00:00	38000275	0	\N	\N	198124	0	180256009	4107731	
22430	1967	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	130852	0	180256009	4107731	
34446	2980	4107731	1993-01-24	1993-01-24 00:00:00	38000275	0	\N	\N	198891	0	180256009	4107731	
46597	4087	4170947	2013-12-03	2013-12-03 00:00:00	38000275	0	\N	\N	271643	0	274474001	4170947	
34913	3041	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	202501	0	180256009	4107731	
58996	5116	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	339962	0	180256009	4107731	
35300	3081	4252419	1985-09-21	1985-09-21 00:00:00	38000275	0	\N	\N	205136	0	74016001	4252419	
47435	4165	4151422	1992-02-08	1992-02-08 00:00:00	38000275	0	\N	\N	276722	0	269911007	4151422	
35645	3118	4107731	1992-06-21	1992-06-21 00:00:00	38000275	0	\N	\N	207418	0	180256009	4107731	
35752	3128	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	208160	0	180256009	4107731	
12113	1102	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	72369	0	180256009	4107731	
36165	3174	4295880	1999-02-26	1999-02-26 00:00:00	38000275	0	\N	\N	210982	0	76601001	4295880	
24409	2135	4107731	1992-11-16	1992-11-16 00:00:00	38000275	0	\N	\N	142141	0	180256009	4107731	
36526	3212	4151422	2009-04-30	2009-04-30 00:00:00	38000275	0	\N	\N	213404	0	269911007	4151422	
36720	3223	4125906	1997-11-23	1997-11-23 00:00:00	38000275	0	\N	\N	214312	0	288086009	4125906	
24948	2175	4107731	2011-02-22	2011-02-22 00:00:00	38000275	0	\N	\N	145080	0	180256009	4107731	
37044	3253	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	216300	0	180256009	4107731	
37216	3270	4043071	1984-10-15	1984-10-15 00:00:00	38000275	0	\N	\N	217290	0	228557008	4043071	
37409	3295	4057420	1997-11-10	1997-11-10 00:00:00	38000275	0	\N	\N	218939	0	18286008	4057420	
37737	3335	4043071	1979-07-29	1979-07-29 00:00:00	38000275	0	\N	\N	221238	0	228557008	4043071	
25923	2272	4295880	2000-08-19	2000-08-19 00:00:00	38000275	0	\N	\N	151003	0	76601001	4295880	
26099	2280	4151422	2015-11-01	2015-11-01 00:00:00	38000275	0	\N	\N	151618	0	269911007	4151422	
26341	2294	4058899	1978-06-29	1978-06-29 00:00:00	38000275	0	\N	\N	152750	0	168594001	4058899	
38432	3376	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	223959	0	180256009	4107731	
38616	3394	4170947	1980-02-16	1980-02-16 00:00:00	38000275	0	\N	\N	225156	0	274474001	4170947	
26838	2349	4107731	1992-02-02	1992-02-02 00:00:00	38000275	0	\N	\N	156426	0	180256009	4107731	
27058	2357	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	157009	0	180256009	4107731	
27184	2381	4043071	1943-04-14	1943-04-14 00:00:00	38000275	0	\N	\N	158287	0	228557008	4043071	
39275	3464	4191853	2009-05-29	2009-05-29 00:00:00	38000275	0	\N	\N	229905	0	395142003	4191853	
27519	2402	4107731	1992-01-06	1992-01-06 00:00:00	38000275	0	\N	\N	159596	0	180256009	4107731	
27844	2445	4252419	1979-09-17	1979-09-17 00:00:00	38000275	0	\N	\N	162234	0	74016001	4252419	
28017	2462	4107731	1991-11-10	1991-11-10 00:00:00	38000275	0	\N	\N	163215	0	180256009	4107731	
28128	2486	4058899	1996-12-21	1996-12-21 00:00:00	38000275	0	\N	\N	164712	0	168594001	4058899	
40263	3529	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	234304	0	180256009	4107731	
28534	2537	4107731	1990-02-18	1990-02-18 00:00:00	38000275	0	\N	\N	167632	0	180256009	4107731	
40648	3566	4191853	1990-01-01	1990-01-01 00:00:00	38000275	0	\N	\N	236892	0	395142003	4191853	
40768	3576	4151422	1967-11-08	1967-11-08 00:00:00	38000275	0	\N	\N	237743	0	269911007	4151422	
17204	1486	4107731	1991-02-10	1991-02-10 00:00:00	38000275	0	\N	\N	99118	0	180256009	4107731	
29317	2602	40492359	1964-11-04	1964-11-04 00:00:00	38000275	0	\N	\N	172145	0	447365002	40492359	
29481	2630	4170947	1978-01-14	1978-01-14 00:00:00	38000275	0	\N	\N	174028	0	274474001	4170947	
41677	3667	4024289	2000-02-14	2000-02-14 00:00:00	38000275	0	\N	\N	243978	0	19490002	4024289	
41796	3680	4107731	1992-06-30	1992-06-30 00:00:00	38000275	0	\N	\N	244681	0	180256009	4107731	
41902	3695	4163971	1996-03-20	1996-03-20 00:00:00	38000275	0	\N	\N	245605	0	45595009	4163971	
30284	2677	4043071	1985-12-26	1985-12-26 00:00:00	38000275	0	\N	\N	177375	0	228557008	4043071	
42402	3744	4107731	2005-10-12	2005-10-12 00:00:00	38000275	0	\N	\N	248831	0	180256009	4107731	
30584	2709	4151422	2013-10-12	2013-10-12 00:00:00	38000275	0	\N	\N	179465	0	269911007	4151422	
30798	2724	4043071	1962-01-28	1962-01-28 00:00:00	38000275	0	\N	\N	180516	0	228557008	4043071	
42866	3783	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	251338	0	180256009	4107731	
43041	3791	4078793	2013-07-06	2013-07-06 00:00:00	38000275	0	\N	\N	252037	0	180325003	4078793	
31252	2770	4191853	1990-01-06	1990-01-06 00:00:00	38000275	0	\N	\N	183401	0	395142003	4191853	
31533	2779	4107731	1997-03-26	1997-03-26 00:00:00	38000275	0	\N	\N	184151	0	180256009	4107731	
43668	3862	4125906	2013-11-19	2013-11-19 00:00:00	38000275	0	\N	\N	256461	0	288086009	4125906	
43878	3874	4107731	1997-12-24	1997-12-24 00:00:00	38000275	0	\N	\N	257226	0	180256009	4107731	
43968	3876	4107731	1992-11-16	1992-11-16 00:00:00	38000275	0	\N	\N	257414	0	180256009	4107731	
20347	1762	4078793	2011-03-24	2011-03-24 00:00:00	38000275	0	\N	\N	117822	0	180325003	4078793	
56361	4922	4043071	1985-08-28	1985-08-28 00:00:00	38000275	0	\N	\N	327028	0	228557008	4043071	
44624	3913	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	260134	0	180256009	4107731	
44856	3939	4330583	2010-01-18	2010-01-18 00:00:00	38000275	0	\N	\N	261814	0	22523008	4330583	
33045	2896	4243062	2014-10-26	2014-10-26 00:00:00	38000275	0	\N	\N	192868	0	60027007	4243062	
33102	2898	4107731	1993-07-20	1993-07-20 00:00:00	38000275	0	\N	\N	192986	0	180256009	4107731	
33343	2915	4107731	1991-05-05	1991-05-05 00:00:00	38000275	0	\N	\N	194299	0	180256009	4107731	
57460	4976	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	330930	0	180256009	4107731	
33789	2944	4252419	2006-10-16	2006-10-16 00:00:00	38000275	0	\N	\N	196397	0	74016001	4252419	
34026	2965	4107731	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	197949	0	180256009	4107731	
34149	2966	4107731	1990-08-04	1990-08-04 00:00:00	38000275	0	\N	\N	198064	0	180256009	4107731	
22431	1967	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	130789	0	180256009	4107731	
34447	2980	4107731	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	198936	0	180256009	4107731	
46598	4087	4125906	1995-07-06	1995-07-06 00:00:00	38000275	0	\N	\N	271640	0	288086009	4125906	
34914	3041	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	202472	0	180256009	4107731	
58997	5116	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	339999	0	180256009	4107731	
35301	3081	4125906	2016-07-10	2016-07-10 00:00:00	38000275	0	\N	\N	205113	0	288086009	4125906	
47436	4165	4293740	1917-12-13	1917-12-13 00:00:00	38000275	0	\N	\N	276829	0	384700001	4293740	
35646	3118	4107731	1991-09-22	1991-09-22 00:00:00	38000275	0	\N	\N	207415	0	180256009	4107731	
35753	3128	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	208212	0	180256009	4107731	
12114	1102	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	72414	0	180256009	4107731	
36166	3174	4295880	2000-02-25	2000-02-25 00:00:00	38000275	0	\N	\N	210945	0	76601001	4295880	
24410	2135	4107731	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	142048	0	180256009	4107731	
36527	3212	4151422	2000-12-10	2000-12-10 00:00:00	38000275	0	\N	\N	213432	0	269911007	4151422	
36721	3223	4151422	1925-11-24	1925-11-24 00:00:00	38000275	0	\N	\N	214259	0	269911007	4151422	
24949	2175	4107731	2011-11-01	2011-11-01 00:00:00	38000275	0	\N	\N	144952	0	180256009	4107731	
37045	3253	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	216334	0	180256009	4107731	
37217	3270	4043071	1982-10-18	1982-10-18 00:00:00	38000275	0	\N	\N	217265	0	228557008	4043071	
37410	3295	4078793	2007-03-26	2007-03-26 00:00:00	38000275	0	\N	\N	218962	0	180325003	4078793	
37738	3335	4170947	1987-07-04	1987-07-04 00:00:00	38000275	0	\N	\N	221300	0	274474001	4170947	
25924	2272	4295880	2004-11-13	2004-11-13 00:00:00	38000275	0	\N	\N	151043	0	76601001	4295880	
26100	2280	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	151652	0	180256009	4107731	
26342	2294	4043071	1969-01-10	1969-01-10 00:00:00	38000275	0	\N	\N	152730	0	228557008	4043071	
38433	3376	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	224030	0	180256009	4107731	
38621	3397	4163872	1957-12-06	1957-12-06 00:00:00	38000275	0	\N	\N	225348	0	399208008	4163872	
26839	2349	4107731	1991-05-26	1991-05-26 00:00:00	38000275	0	\N	\N	156397	0	180256009	4107731	
27059	2357	4058899	2012-11-26	2012-11-26 00:00:00	38000275	0	\N	\N	157006	0	168594001	4058899	
27185	2381	4043071	1944-01-05	1944-01-05 00:00:00	38000275	0	\N	\N	158311	0	228557008	4043071	
39276	3464	4107731	2010-06-11	2010-06-11 00:00:00	38000275	0	\N	\N	229962	0	180256009	4107731	
27520	2402	4107731	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	159632	0	180256009	4107731	
27845	2445	4125906	1955-10-27	1955-10-27 00:00:00	38000275	0	\N	\N	162196	0	288086009	4125906	
28018	2462	4107731	1991-12-01	1991-12-01 00:00:00	38000275	0	\N	\N	163262	0	180256009	4107731	
28129	2487	4151422	2013-01-07	2013-01-07 00:00:00	38000275	0	\N	\N	164806	0	269911007	4151422	
40264	3529	4170947	2017-05-15	2017-05-15 00:00:00	38000275	0	\N	\N	234452	0	274474001	4170947	
28535	2537	4107731	1991-06-16	1991-06-16 00:00:00	38000275	0	\N	\N	167699	0	180256009	4107731	
40649	3566	4043071	1959-03-09	1959-03-09 00:00:00	38000275	0	\N	\N	236902	0	228557008	4043071	
40769	3576	4163872	1972-10-10	1972-10-10 00:00:00	38000275	0	\N	\N	237709	0	399208008	4163872	
28986	2561	4125906	1998-03-27	1998-03-27 00:00:00	38000275	0	\N	\N	169702	0	288086009	4125906	
29318	2602	4057420	1964-11-04	1964-11-04 00:00:00	38000275	0	\N	\N	172145	0	18286008	4057420	
29482	2630	4047491	1978-01-14	1978-01-14 00:00:00	38000275	0	\N	\N	174028	0	1225002	4047491	
41678	3667	4170947	2000-02-14	2000-02-14 00:00:00	38000275	0	\N	\N	243978	0	274474001	4170947	
41797	3680	4107731	1993-06-01	1993-06-01 00:00:00	38000275	0	\N	\N	244785	0	180256009	4107731	
41903	3695	4163951	1996-03-20	1996-03-20 00:00:00	38000275	0	\N	\N	245605	0	29303009	4163951	
30285	2677	4043071	1986-02-20	1986-02-20 00:00:00	38000275	0	\N	\N	177423	0	228557008	4043071	
42403	3744	4107731	2004-12-22	2004-12-22 00:00:00	38000275	0	\N	\N	248803	0	180256009	4107731	
30585	2709	4170947	1984-03-03	1984-03-03 00:00:00	38000275	0	\N	\N	179449	0	274474001	4170947	
30799	2724	4043071	1962-05-06	1962-05-06 00:00:00	38000275	0	\N	\N	180526	0	228557008	4043071	
42867	3783	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	251326	0	180256009	4107731	
43042	3791	4125906	1939-05-20	1939-05-20 00:00:00	38000275	0	\N	\N	252050	0	288086009	4125906	
31253	2770	4107731	1990-10-06	1990-10-06 00:00:00	38000275	0	\N	\N	183404	0	180256009	4107731	
31534	2779	4107731	1996-11-20	1996-11-20 00:00:00	38000275	0	\N	\N	184105	0	180256009	4107731	
43669	3862	4293740	2013-11-19	2013-11-19 00:00:00	38000275	0	\N	\N	256461	0	384700001	4293740	
43879	3874	4107731	1996-05-15	1996-05-15 00:00:00	38000275	0	\N	\N	257224	0	180256009	4107731	
43969	3876	4107731	1992-12-07	1992-12-07 00:00:00	38000275	0	\N	\N	257458	0	180256009	4107731	
20348	1762	4035793	2011-03-24	2011-03-24 00:00:00	38000275	0	\N	\N	117822	0	15081005	4035793	
56362	4922	4043071	1987-11-11	1987-11-11 00:00:00	38000275	0	\N	\N	327033	0	228557008	4043071	
44625	3913	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	260118	0	180256009	4107731	
56662	4932	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	327890	0	180256009	4107731	
33046	2896	4107731	1990-12-09	1990-12-09 00:00:00	38000275	0	\N	\N	192792	0	180256009	4107731	
33103	2898	4107731	1993-08-31	1993-08-31 00:00:00	38000275	0	\N	\N	192987	0	180256009	4107731	
33344	2915	4107731	1992-11-01	1992-11-01 00:00:00	38000275	0	\N	\N	194240	0	180256009	4107731	
57461	4976	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	330979	0	180256009	4107731	
33790	2945	4035793	2011-01-25	2011-01-25 00:00:00	38000275	0	\N	\N	196483	0	15081005	4035793	
34027	2965	4163872	1985-02-06	1985-02-06 00:00:00	38000275	0	\N	\N	197909	0	399208008	4163872	
34150	2966	4107731	1991-07-06	1991-07-06 00:00:00	38000275	0	\N	\N	198131	0	180256009	4107731	
22432	1967	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	130748	0	180256009	4107731	
34448	2980	4107731	1992-06-28	1992-06-28 00:00:00	38000275	0	\N	\N	198954	0	180256009	4107731	
46599	4087	4293740	1990-10-16	1990-10-16 00:00:00	38000275	0	\N	\N	271678	0	384700001	4293740	
34915	3041	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	202489	0	180256009	4107731	
58998	5116	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	339905	0	180256009	4107731	
35302	3081	4024289	1955-04-06	1955-04-06 00:00:00	38000275	0	\N	\N	205132	0	19490002	4024289	
47437	4165	4125906	1917-12-13	1917-12-13 00:00:00	38000275	0	\N	\N	276829	0	288086009	4125906	
35647	3118	4107731	1993-02-07	1993-02-07 00:00:00	38000275	0	\N	\N	207529	0	180256009	4107731	
35754	3128	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	208223	0	180256009	4107731	
12115	1102	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	72451	0	180256009	4107731	
36167	3174	4295880	2000-05-26	2000-05-26 00:00:00	38000275	0	\N	\N	210987	0	76601001	4295880	
24411	2135	4107731	1991-11-25	1991-11-25 00:00:00	38000275	0	\N	\N	142136	0	180256009	4107731	
36528	3212	4202832	2018-07-21	2018-07-21 00:00:00	38000275	0	\N	\N	213430	0	52765003	4202832	
36722	3224	4151422	1983-01-18	1983-01-18 00:00:00	38000275	0	\N	\N	214378	0	269911007	4151422	
24950	2175	4107731	2011-10-11	2011-10-11 00:00:00	38000275	0	\N	\N	144964	0	180256009	4107731	
37046	3253	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	216340	0	180256009	4107731	
37218	3270	4043071	1982-02-08	1982-02-08 00:00:00	38000275	0	\N	\N	217358	0	228557008	4043071	
37411	3295	4078793	1993-05-17	1993-05-17 00:00:00	38000275	0	\N	\N	218977	0	180325003	4078793	
37739	3335	4163872	1987-07-04	1987-07-04 00:00:00	38000275	0	\N	\N	221300	0	399208008	4163872	
25925	2272	4295880	1997-08-23	1997-08-23 00:00:00	38000275	0	\N	\N	151023	0	76601001	4295880	
26101	2280	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	151606	0	180256009	4107731	
26343	2294	4043071	1968-09-13	1968-09-13 00:00:00	38000275	0	\N	\N	152729	0	228557008	4043071	
38434	3376	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	223978	0	180256009	4107731	
38622	3397	4170947	1957-12-06	1957-12-06 00:00:00	38000275	0	\N	\N	225348	0	274474001	4170947	
26840	2349	4107731	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	156380	0	180256009	4107731	
27060	2357	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	156973	0	180256009	4107731	
27186	2381	4057420	2013-01-30	2013-01-30 00:00:00	38000275	0	\N	\N	158245	0	18286008	4057420	
39277	3464	4107731	2009-10-23	2009-10-23 00:00:00	38000275	0	\N	\N	229960	0	180256009	4107731	
27521	2402	4107731	1992-08-03	1992-08-03 00:00:00	38000275	0	\N	\N	159657	0	180256009	4107731	
27846	2445	44783196	1979-09-24	1979-09-24 00:00:00	38000275	0	\N	\N	162230	0	699253003	44783196	
28019	2462	4107731	1991-09-08	1991-09-08 00:00:00	38000275	0	\N	\N	163282	0	180256009	4107731	
28130	2487	4151422	2007-12-27	2007-12-27 00:00:00	38000275	0	\N	\N	164804	0	269911007	4151422	
40265	3529	4243062	2017-05-15	2017-05-15 00:00:00	38000275	0	\N	\N	234452	0	60027007	4243062	
28536	2537	4191853	1993-07-11	1993-07-11 00:00:00	38000275	0	\N	\N	167725	0	395142003	4191853	
40650	3566	4043071	1960-07-25	1960-07-25 00:00:00	38000275	0	\N	\N	236988	0	228557008	4043071	
40770	3576	4170947	1972-10-10	1972-10-10 00:00:00	38000275	0	\N	\N	237709	0	274474001	4170947	
28987	2561	4125906	1981-08-02	1981-08-02 00:00:00	38000275	0	\N	\N	169701	0	288086009	4125906	
29319	2602	4125906	2014-02-27	2014-02-27 00:00:00	38000275	0	\N	\N	172147	0	288086009	4125906	
29483	2630	4243062	2013-03-30	2013-03-30 00:00:00	38000275	0	\N	\N	173997	0	60027007	4243062	
41679	3667	4151422	1985-02-02	1985-02-02 00:00:00	38000275	0	\N	\N	243983	0	269911007	4151422	
41798	3680	4107731	1994-01-18	1994-01-18 00:00:00	38000275	0	\N	\N	244765	0	180256009	4107731	
41904	3695	4107731	1994-07-18	1994-07-18 00:00:00	38000275	0	\N	\N	245649	0	180256009	4107731	
30286	2677	4043071	1985-06-21	1985-06-21 00:00:00	38000275	0	\N	\N	177373	0	228557008	4043071	
42404	3744	4191853	2003-01-08	2003-01-08 00:00:00	38000275	0	\N	\N	248741	0	395142003	4191853	
30586	2709	4243062	1984-03-03	1984-03-03 00:00:00	38000275	0	\N	\N	179449	0	60027007	4243062	
30800	2724	4043071	1963-02-17	1963-02-17 00:00:00	38000275	0	\N	\N	180477	0	228557008	4043071	
42868	3783	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	251404	0	180256009	4107731	
43043	3791	4293740	1939-05-20	1939-05-20 00:00:00	38000275	0	\N	\N	252050	0	384700001	4293740	
31254	2770	4107731	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	183299	0	180256009	4107731	
31535	2779	4107731	1995-06-14	1995-06-14 00:00:00	38000275	0	\N	\N	184096	0	180256009	4107731	
43670	3862	4293740	2011-04-13	2011-04-13 00:00:00	38000275	0	\N	\N	256460	0	384700001	4293740	
43880	3874	4107731	1995-11-29	1995-11-29 00:00:00	38000275	0	\N	\N	257312	0	180256009	4107731	
43970	3876	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	257467	0	180256009	4107731	
20349	1762	4035793	2001-01-25	2001-01-25 00:00:00	38000275	0	\N	\N	117876	0	15081005	4035793	
56363	4922	4043071	1984-12-12	1984-12-12 00:00:00	38000275	0	\N	\N	327040	0	228557008	4043071	
44626	3913	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	260156	0	180256009	4107731	
56663	4932	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	327847	0	180256009	4107731	
33047	2896	4107731	1990-11-18	1990-11-18 00:00:00	38000275	0	\N	\N	192840	0	180256009	4107731	
33104	2898	4295880	1997-01-07	1997-01-07 00:00:00	38000275	0	\N	\N	193034	0	76601001	4295880	
33345	2915	4107731	1993-03-28	1993-03-28 00:00:00	38000275	0	\N	\N	194399	0	180256009	4107731	
57462	4976	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	330931	0	180256009	4107731	
33791	2945	4035793	2009-01-13	2009-01-13 00:00:00	38000275	0	\N	\N	196490	0	15081005	4035793	
34028	2965	4107731	1992-11-16	1992-11-16 00:00:00	38000275	0	\N	\N	198011	0	180256009	4107731	
34151	2966	4107731	1990-09-15	1990-09-15 00:00:00	38000275	0	\N	\N	198065	0	180256009	4107731	
22433	1967	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	130760	0	180256009	4107731	
34463	2985	4243062	1990-10-09	1990-10-09 00:00:00	38000275	0	\N	\N	199189	0	60027007	4243062	
46600	4087	4125906	1990-10-16	1990-10-16 00:00:00	38000275	0	\N	\N	271678	0	288086009	4125906	
34916	3041	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	202427	0	180256009	4107731	
58999	5116	4163872	1998-03-25	1998-03-25 00:00:00	38000275	0	\N	\N	340007	0	399208008	4163872	
35303	3081	4170947	1955-04-06	1955-04-06 00:00:00	38000275	0	\N	\N	205132	0	274474001	4170947	
47438	4165	4058899	1990-08-18	1990-08-18 00:00:00	38000275	0	\N	\N	276827	0	168594001	4058899	
35648	3118	4107731	1992-10-04	1992-10-04 00:00:00	38000275	0	\N	\N	207517	0	180256009	4107731	
35755	3128	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	208118	0	180256009	4107731	
12116	1102	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	72441	0	395142003	4191853	
36168	3174	4295880	1998-02-27	1998-02-27 00:00:00	38000275	0	\N	\N	210984	0	76601001	4295880	
24412	2135	4107731	1991-11-04	1991-11-04 00:00:00	38000275	0	\N	\N	142176	0	180256009	4107731	
36529	3212	4163971	2018-07-21	2018-07-21 00:00:00	38000275	0	\N	\N	213430	0	45595009	4163971	
36723	3226	4125906	1984-04-06	1984-04-06 00:00:00	38000275	0	\N	\N	214449	0	288086009	4125906	
24951	2175	4107731	2010-03-02	2010-03-02 00:00:00	38000275	0	\N	\N	144957	0	180256009	4107731	
37047	3253	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	216384	0	180256009	4107731	
37219	3270	4043071	1982-05-10	1982-05-10 00:00:00	38000275	0	\N	\N	217322	0	228557008	4043071	
37412	3295	4078793	2015-05-11	2015-05-11 00:00:00	38000275	0	\N	\N	218899	0	180325003	4078793	
37740	3335	4043071	1979-04-22	1979-04-22 00:00:00	38000275	0	\N	\N	221285	0	228557008	4043071	
25926	2272	4295880	2004-08-14	2004-08-14 00:00:00	38000275	0	\N	\N	151030	0	76601001	4295880	
26102	2280	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	151684	0	180256009	4107731	
26344	2294	4043071	1968-07-12	1968-07-12 00:00:00	38000275	0	\N	\N	152658	0	228557008	4043071	
38435	3376	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	223956	0	180256009	4107731	
38623	3397	4125906	1973-03-17	1973-03-17 00:00:00	38000275	0	\N	\N	225349	0	288086009	4125906	
26841	2349	4107731	1993-05-09	1993-05-09 00:00:00	38000275	0	\N	\N	156355	0	180256009	4107731	
27061	2357	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	157016	0	180256009	4107731	
27187	2381	40492359	2013-01-30	2013-01-30 00:00:00	38000275	0	\N	\N	158245	0	447365002	40492359	
39278	3464	4107731	2012-01-20	2012-01-20 00:00:00	38000275	0	\N	\N	229939	0	180256009	4107731	
27522	2402	4107731	1990-03-05	1990-03-05 00:00:00	38000275	0	\N	\N	159587	0	180256009	4107731	
27847	2447	4163872	1995-07-24	1995-07-24 00:00:00	38000275	0	\N	\N	162311	0	399208008	4163872	
28020	2462	4107731	1993-02-14	1993-02-14 00:00:00	38000275	0	\N	\N	163299	0	180256009	4107731	
28131	2487	4151422	2003-12-22	2003-12-22 00:00:00	38000275	0	\N	\N	164791	0	269911007	4151422	
40266	3529	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	234387	0	180256009	4107731	
28537	2537	4107731	1990-10-07	1990-10-07 00:00:00	38000275	0	\N	\N	167600	0	180256009	4107731	
40651	3566	4043071	1959-06-01	1959-06-01 00:00:00	38000275	0	\N	\N	236903	0	228557008	4043071	
40771	3576	4125906	1991-04-04	1991-04-04 00:00:00	38000275	0	\N	\N	237712	0	288086009	4125906	
28991	2563	4252419	1972-04-11	1972-04-11 00:00:00	38000275	0	\N	\N	169790	0	74016001	4252419	
29320	2602	4151422	1948-11-30	1948-11-30 00:00:00	38000275	0	\N	\N	172071	0	269911007	4151422	
29484	2630	4170947	2013-03-30	2013-03-30 00:00:00	38000275	0	\N	\N	173997	0	274474001	4170947	
41680	3668	4163872	1992-07-02	1992-07-02 00:00:00	38000275	0	\N	\N	244030	0	399208008	4163872	
41799	3680	4107731	1993-06-22	1993-06-22 00:00:00	38000275	0	\N	\N	244751	0	180256009	4107731	
41905	3695	4107731	1995-01-02	1995-01-02 00:00:00	38000275	0	\N	\N	245655	0	180256009	4107731	
30287	2677	4043071	1987-01-08	1987-01-08 00:00:00	38000275	0	\N	\N	177367	0	228557008	4043071	
42405	3744	4107731	2003-04-23	2003-04-23 00:00:00	38000275	0	\N	\N	248830	0	180256009	4107731	
30587	2709	4058899	2017-10-06	2017-10-06 00:00:00	38000275	0	\N	\N	179451	0	168594001	4058899	
30801	2724	4326177	2013-05-08	2013-05-08 00:00:00	38000275	0	\N	\N	180487	0	430193006	4326177	
42869	3783	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	251323	0	180256009	4107731	
43044	3791	4125906	1966-03-27	1966-03-27 00:00:00	38000275	0	\N	\N	252159	0	288086009	4125906	
31255	2770	4107731	1991-07-27	1991-07-27 00:00:00	38000275	0	\N	\N	183316	0	180256009	4107731	
31536	2779	4170947	1976-11-13	1976-11-13 00:00:00	38000275	0	\N	\N	184098	0	274474001	4170947	
43671	3862	4125906	2011-04-13	2011-04-13 00:00:00	38000275	0	\N	\N	256460	0	288086009	4125906	
43881	3874	4243062	1986-09-28	1986-09-28 00:00:00	38000275	0	\N	\N	257236	0	60027007	4243062	
43971	3876	4191853	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	257416	0	395142003	4191853	
20350	1762	4035793	2000-04-20	2000-04-20 00:00:00	38000275	0	\N	\N	117820	0	15081005	4035793	
56364	4922	4043071	1986-04-16	1986-04-16 00:00:00	38000275	0	\N	\N	327070	0	228557008	4043071	
44627	3913	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	260182	0	180256009	4107731	
56664	4932	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	327899	0	180256009	4107731	
33048	2896	4107731	1992-08-30	1992-08-30 00:00:00	38000275	0	\N	\N	192778	0	180256009	4107731	
33105	2898	4295880	1997-04-08	1997-04-08 00:00:00	38000275	0	\N	\N	193087	0	76601001	4295880	
33350	2917	4057420	2016-02-10	2016-02-10 00:00:00	38000275	0	\N	\N	194502	0	18286008	4057420	
57463	4976	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	331000	0	180256009	4107731	
33792	2945	4035793	2010-01-19	2010-01-19 00:00:00	38000275	0	\N	\N	196518	0	15081005	4035793	
34029	2965	4107731	1992-10-05	1992-10-05 00:00:00	38000275	0	\N	\N	197954	0	180256009	4107731	
34152	2966	4107731	1993-03-27	1993-03-27 00:00:00	38000275	0	\N	\N	198162	0	180256009	4107731	
22434	1967	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	130768	0	180256009	4107731	
34464	2985	4170947	1990-10-09	1990-10-09 00:00:00	38000275	0	\N	\N	199189	0	274474001	4170947	
46669	4090	4047491	1957-03-11	1957-03-11 00:00:00	38000275	0	\N	\N	271934	0	1225002	4047491	
34917	3041	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	202504	0	180256009	4107731	
59000	5116	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	340017	0	180256009	4107731	
35304	3081	4202451	2011-09-07	2011-09-07 00:00:00	38000275	0	\N	\N	205094	0	433112001	4202451	
47439	4165	4195803	1990-08-18	1990-08-18 00:00:00	38000275	0	\N	\N	276827	0	312681000	4195803	
35649	3118	4107731	1992-12-06	1992-12-06 00:00:00	38000275	0	\N	\N	207456	0	180256009	4107731	
35756	3128	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	208155	0	180256009	4107731	
12117	1102	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	72391	0	180256009	4107731	
36169	3174	4295880	1998-08-28	1998-08-28 00:00:00	38000275	0	\N	\N	210958	0	76601001	4295880	
24413	2135	4107731	1992-09-14	1992-09-14 00:00:00	38000275	0	\N	\N	142180	0	180256009	4107731	
36530	3212	42535580	2018-07-21	2018-07-21 00:00:00	38000275	0	\N	\N	213430	0	426701000119108	42535580	
36724	3226	4125906	2008-05-26	2008-05-26 00:00:00	38000275	0	\N	\N	214451	0	288086009	4125906	
24952	2176	4151422	1959-01-08	1959-01-08 00:00:00	38000275	0	\N	\N	145122	0	269911007	4151422	
37048	3253	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	216298	0	180256009	4107731	
37220	3270	4043071	1982-08-09	1982-08-09 00:00:00	38000275	0	\N	\N	217263	0	228557008	4043071	
37413	3295	4078793	1996-06-03	1996-06-03 00:00:00	38000275	0	\N	\N	218907	0	180325003	4078793	
37741	3335	4043071	1979-07-01	1979-07-01 00:00:00	38000275	0	\N	\N	221263	0	228557008	4043071	
25927	2272	4295880	1996-05-25	1996-05-25 00:00:00	38000275	0	\N	\N	151036	0	76601001	4295880	
26103	2280	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	151650	0	180256009	4107731	
26345	2294	4043071	1968-04-05	1968-04-05 00:00:00	38000275	0	\N	\N	152728	0	228557008	4043071	
38436	3376	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	224064	0	180256009	4107731	
38624	3397	4243062	1956-01-16	1956-01-16 00:00:00	38000275	0	\N	\N	225347	0	60027007	4243062	
26842	2349	4107731	1992-11-22	1992-11-22 00:00:00	38000275	0	\N	\N	156447	0	180256009	4107731	
27062	2357	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	157032	0	180256009	4107731	
27188	2381	4043071	1943-12-08	1943-12-08 00:00:00	38000275	0	\N	\N	158289	0	228557008	4043071	
39279	3464	4191853	2012-11-30	2012-11-30 00:00:00	38000275	0	\N	\N	229943	0	395142003	4191853	
27523	2402	4107731	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	159604	0	180256009	4107731	
27848	2448	4198190	2003-07-07	2003-07-07 00:00:00	38000275	0	\N	\N	162353	0	80146002	4198190	
28021	2462	4107731	1992-06-28	1992-06-28 00:00:00	38000275	0	\N	\N	163297	0	180256009	4107731	
28153	2495	4117038	2006-08-09	2006-08-09 00:00:00	38000275	0	\N	\N	165130	0	287664005	4117038	
40267	3529	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	234385	0	180256009	4107731	
28538	2537	4107731	1991-09-08	1991-09-08 00:00:00	38000275	0	\N	\N	167772	0	180256009	4107731	
40652	3566	4107731	1992-01-06	1992-01-06 00:00:00	38000275	0	\N	\N	236974	0	180256009	4107731	
40772	3576	4252419	2010-11-11	2010-11-11 00:00:00	38000275	0	\N	\N	237713	0	74016001	4252419	
28992	2563	4125906	1986-06-04	1986-06-04 00:00:00	38000275	0	\N	\N	169792	0	288086009	4125906	
29321	2603	4058899	1983-01-30	1983-01-30 00:00:00	38000275	0	\N	\N	172182	0	168594001	4058899	
29485	2630	4195803	2013-03-30	2013-03-30 00:00:00	38000275	0	\N	\N	173997	0	312681000	4195803	
41681	3668	4170947	1992-07-02	1992-07-02 00:00:00	38000275	0	\N	\N	244030	0	274474001	4170947	
41800	3680	4107731	1994-11-29	1994-11-29 00:00:00	38000275	0	\N	\N	244710	0	180256009	4107731	
41906	3695	40492359	2007-02-12	2007-02-12 00:00:00	38000275	0	\N	\N	245606	0	447365002	40492359	
30288	2677	4243062	1980-09-21	1980-09-21 00:00:00	38000275	0	\N	\N	177359	0	60027007	4243062	
42406	3744	4107731	2005-03-16	2005-03-16 00:00:00	38000275	0	\N	\N	248805	0	180256009	4107731	
30588	2709	4195803	2017-10-06	2017-10-06 00:00:00	38000275	0	\N	\N	179451	0	312681000	4195803	
30802	2724	4187458	2013-05-08	2013-05-08 00:00:00	38000275	0	\N	\N	180487	0	415300000	4187458	
42870	3783	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	251444	0	180256009	4107731	
43045	3791	4293740	1966-03-27	1966-03-27 00:00:00	38000275	0	\N	\N	252159	0	384700001	4293740	
31256	2770	4107731	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	183327	0	180256009	4107731	
31537	2779	4047491	1976-11-13	1976-11-13 00:00:00	38000275	0	\N	\N	184098	0	1225002	4047491	
43674	3865	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	256564	0	180256009	4107731	
43882	3874	4170947	1986-09-28	1986-09-28 00:00:00	38000275	0	\N	\N	257236	0	274474001	4170947	
43972	3876	4151422	2016-12-10	2016-12-10 00:00:00	38000275	0	\N	\N	257417	0	269911007	4151422	
20351	1762	4078793	2000-04-20	2000-04-20 00:00:00	38000275	0	\N	\N	117820	0	180325003	4078793	
56365	4922	4043071	1984-09-05	1984-09-05 00:00:00	38000275	0	\N	\N	327025	0	228557008	4043071	
44628	3913	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	260155	0	180256009	4107731	
56665	4932	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	327878	0	180256009	4107731	
33049	2896	4107731	1992-08-09	1992-08-09 00:00:00	38000275	0	\N	\N	192813	0	180256009	4107731	
33106	2898	4295880	2000-01-04	2000-01-04 00:00:00	38000275	0	\N	\N	193063	0	76601001	4295880	
33351	2917	4078793	1999-11-10	1999-11-10 00:00:00	38000275	0	\N	\N	194476	0	180325003	4078793	
57464	4976	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	331094	0	180256009	4107731	
33793	2945	4125906	1979-12-05	1979-12-05 00:00:00	38000275	0	\N	\N	196485	0	288086009	4125906	
34030	2965	4170947	1988-08-01	1988-08-01 00:00:00	38000275	0	\N	\N	197986	0	274474001	4170947	
34155	2969	4125906	1986-03-03	1986-03-03 00:00:00	38000275	0	\N	\N	198246	0	288086009	4125906	
22435	1967	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	130795	0	180256009	4107731	
34465	2985	4125906	1979-08-26	1979-08-26 00:00:00	38000275	0	\N	\N	199187	0	288086009	4125906	
46670	4090	4170947	1957-03-11	1957-03-11 00:00:00	38000275	0	\N	\N	271934	0	274474001	4170947	
34918	3041	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	202543	0	180256009	4107731	
59001	5116	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	339939	0	180256009	4107731	
35305	3082	4151422	2001-11-03	2001-11-03 00:00:00	38000275	0	\N	\N	205231	0	269911007	4151422	
47440	4165	4202451	1980-04-06	1980-04-06 00:00:00	38000275	0	\N	\N	276754	0	433112001	4202451	
35650	3118	4107731	1990-01-21	1990-01-21 00:00:00	38000275	0	\N	\N	207436	0	180256009	4107731	
35757	3128	4125906	1982-09-05	1982-09-05 00:00:00	38000275	0	\N	\N	208163	0	288086009	4125906	
12118	1102	44783196	2003-02-21	2003-02-21 00:00:00	38000275	0	\N	\N	72384	0	699253003	44783196	
36170	3174	4295880	1998-11-27	1998-11-27 00:00:00	38000275	0	\N	\N	210985	0	76601001	4295880	
24414	2135	4107731	1991-01-14	1991-01-14 00:00:00	38000275	0	\N	\N	142078	0	180256009	4107731	
36531	3212	4163951	2018-07-21	2018-07-21 00:00:00	38000275	0	\N	\N	213430	0	29303009	4163951	
36725	3226	4151422	1995-10-09	1995-10-09 00:00:00	38000275	0	\N	\N	214456	0	269911007	4151422	
24953	2176	4010253	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	145159	0	112790001	4010253	
37049	3253	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	216337	0	180256009	4107731	
37221	3270	4043071	1985-04-22	1985-04-22 00:00:00	38000275	0	\N	\N	217314	0	228557008	4043071	
37414	3295	4125906	1964-11-25	1964-11-25 00:00:00	38000275	0	\N	\N	218896	0	288086009	4125906	
37742	3335	4024289	1986-04-10	1986-04-10 00:00:00	38000275	0	\N	\N	221299	0	19490002	4024289	
25928	2272	4295880	2005-08-13	2005-08-13 00:00:00	38000275	0	\N	\N	151044	0	76601001	4295880	
26104	2280	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	151642	0	180256009	4107731	
26346	2295	4125906	1996-12-23	1996-12-23 00:00:00	38000275	0	\N	\N	152754	0	288086009	4125906	
38437	3376	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	224014	0	180256009	4107731	
38625	3397	4170947	1956-01-16	1956-01-16 00:00:00	38000275	0	\N	\N	225347	0	274474001	4170947	
26843	2349	4107731	1990-02-18	1990-02-18 00:00:00	38000275	0	\N	\N	156378	0	180256009	4107731	
27063	2357	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	157044	0	180256009	4107731	
27189	2381	4125906	1982-11-15	1982-11-15 00:00:00	38000275	0	\N	\N	158242	0	288086009	4125906	
39280	3464	4107731	2009-07-31	2009-07-31 00:00:00	38000275	0	\N	\N	229958	0	180256009	4107731	
27524	2402	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	159618	0	180256009	4107731	
27849	2448	4187458	1991-07-09	1991-07-09 00:00:00	38000275	0	\N	\N	162338	0	415300000	4187458	
28022	2462	4107731	1991-12-22	1991-12-22 00:00:00	38000275	0	\N	\N	163216	0	180256009	4107731	
28154	2495	4243062	1987-06-26	1987-06-26 00:00:00	38000275	0	\N	\N	165161	0	60027007	4243062	
40268	3529	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	234403	0	180256009	4107731	
28539	2537	4107731	1991-02-10	1991-02-10 00:00:00	38000275	0	\N	\N	167590	0	180256009	4107731	
40653	3566	4107731	1990-04-16	1990-04-16 00:00:00	38000275	0	\N	\N	236884	0	180256009	4107731	
40773	3577	4151422	2013-08-28	2013-08-28 00:00:00	38000275	0	\N	\N	237843	0	269911007	4151422	
28993	2563	4125906	2000-03-06	2000-03-06 00:00:00	38000275	0	\N	\N	169793	0	288086009	4125906	
29322	2603	4125906	2012-03-28	2012-03-28 00:00:00	38000275	0	\N	\N	172169	0	288086009	4125906	
29486	2630	4043071	1970-09-29	1970-09-29 00:00:00	38000275	0	\N	\N	174008	0	228557008	4043071	
41682	3668	4047491	1991-05-09	1991-05-09 00:00:00	38000275	0	\N	\N	244029	0	1225002	4047491	
41801	3680	4107731	1993-09-14	1993-09-14 00:00:00	38000275	0	\N	\N	244753	0	180256009	4107731	
41907	3695	4057420	2007-02-12	2007-02-12 00:00:00	38000275	0	\N	\N	245606	0	18286008	4057420	
30289	2677	4170947	1980-09-21	1980-09-21 00:00:00	38000275	0	\N	\N	177359	0	274474001	4170947	
42407	3744	4107731	2005-02-02	2005-02-02 00:00:00	38000275	0	\N	\N	248804	0	180256009	4107731	
30589	2709	4125906	1970-09-22	1970-09-22 00:00:00	38000275	0	\N	\N	179448	0	288086009	4125906	
30803	2724	4037675	2013-05-08	2013-05-08 00:00:00	38000275	0	\N	\N	180487	0	162676008	4037675	
42871	3783	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	251349	0	180256009	4107731	
43046	3791	4125906	1953-09-17	1953-09-17 00:00:00	38000275	0	\N	\N	252051	0	288086009	4125906	
31257	2770	4107731	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	183295	0	180256009	4107731	
31538	2779	4195803	1976-11-13	1976-11-13 00:00:00	38000275	0	\N	\N	184098	0	312681000	4195803	
43675	3865	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	256622	0	180256009	4107731	
43883	3874	4107731	1995-07-26	1995-07-26 00:00:00	38000275	0	\N	\N	257215	0	180256009	4107731	
43973	3876	4107731	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	257494	0	180256009	4107731	
20352	1762	4151422	1967-10-06	1967-10-06 00:00:00	38000275	0	\N	\N	117847	0	269911007	4151422	
56366	4922	4043071	1986-10-15	1986-10-15 00:00:00	38000275	0	\N	\N	326991	0	228557008	4043071	
44629	3913	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	260169	0	180256009	4107731	
56666	4932	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	327814	0	180256009	4107731	
33050	2896	4107731	1993-03-28	1993-03-28 00:00:00	38000275	0	\N	\N	192859	0	180256009	4107731	
33107	2898	4107731	1992-02-11	1992-02-11 00:00:00	38000275	0	\N	\N	193041	0	180256009	4107731	
33352	2917	4078793	2006-12-20	2006-12-20 00:00:00	38000275	0	\N	\N	194442	0	180325003	4078793	
57465	4976	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	330946	0	180256009	4107731	
33794	2945	4035793	2012-01-31	2012-01-31 00:00:00	38000275	0	\N	\N	196519	0	15081005	4035793	
34031	2965	4163872	1988-08-01	1988-08-01 00:00:00	38000275	0	\N	\N	197986	0	399208008	4163872	
34156	2969	4125906	2002-02-28	2002-02-28 00:00:00	38000275	0	\N	\N	198247	0	288086009	4125906	
22436	1967	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	130761	0	180256009	4107731	
34466	2985	40492359	1967-06-17	1967-06-17 00:00:00	38000275	0	\N	\N	199186	0	447365002	40492359	
46671	4090	4047491	1949-09-12	1949-09-12 00:00:00	38000275	0	\N	\N	271904	0	1225002	4047491	
34919	3041	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	202518	0	180256009	4107731	
59002	5116	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	339988	0	180256009	4107731	
35306	3082	4243062	1980-03-02	1980-03-02 00:00:00	38000275	0	\N	\N	205227	0	60027007	4243062	
47441	4165	4057420	1991-01-27	1991-01-27 00:00:00	38000275	0	\N	\N	276828	0	18286008	4057420	
35651	3119	4125906	1997-09-12	1997-09-12 00:00:00	38000275	0	\N	\N	207538	0	288086009	4125906	
35758	3128	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	208116	0	180256009	4107731	
23937	2080	4058899	1989-02-21	1989-02-21 00:00:00	38000275	0	\N	\N	138520	0	168594001	4058899	
36171	3175	4151422	1989-11-17	1989-11-17 00:00:00	38000275	0	\N	\N	211003	0	269911007	4151422	
24415	2135	4107731	1992-12-07	1992-12-07 00:00:00	38000275	0	\N	\N	142084	0	180256009	4107731	
36533	3214	4125906	1988-07-02	1988-07-02 00:00:00	38000275	0	\N	\N	213496	0	288086009	4125906	
36726	3227	4252419	1998-07-23	1998-07-23 00:00:00	38000275	0	\N	\N	214543	0	74016001	4252419	
24954	2177	4243062	1982-10-02	1982-10-02 00:00:00	38000275	0	\N	\N	145184	0	60027007	4243062	
37050	3253	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	216262	0	180256009	4107731	
37222	3270	4043071	1987-02-23	1987-02-23 00:00:00	38000275	0	\N	\N	217297	0	228557008	4043071	
37415	3295	4078793	2008-03-31	2008-03-31 00:00:00	38000275	0	\N	\N	218898	0	180325003	4078793	
37743	3335	4170947	1986-04-10	1986-04-10 00:00:00	38000275	0	\N	\N	221299	0	274474001	4170947	
25929	2272	4295880	2005-02-12	2005-02-12 00:00:00	38000275	0	\N	\N	151081	0	76601001	4295880	
26105	2280	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	151638	0	180256009	4107731	
26347	2295	4058899	2015-07-01	2015-07-01 00:00:00	38000275	0	\N	\N	152755	0	168594001	4058899	
38438	3376	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	223981	0	180256009	4107731	
38627	3399	4107731	1996-10-01	1996-10-01 00:00:00	38000275	0	\N	\N	225469	0	180256009	4107731	
26844	2349	4107731	1991-06-16	1991-06-16 00:00:00	38000275	0	\N	\N	156342	0	180256009	4107731	
27064	2357	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	157008	0	180256009	4107731	
27190	2381	4125906	2003-08-16	2003-08-16 00:00:00	38000275	0	\N	\N	158244	0	288086009	4125906	
39281	3464	4191853	2009-05-29	2009-05-29 00:00:00	38000275	0	\N	\N	229905	0	395142003	4191853	
27525	2402	4062501	1978-09-20	1978-09-20 00:00:00	38000275	0	\N	\N	159573	0	171231001	4062501	
27850	2448	4037675	1991-07-09	1991-07-09 00:00:00	38000275	0	\N	\N	162338	0	162676008	4037675	
28023	2462	4107731	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	163298	0	180256009	4107731	
28155	2495	4170947	1987-06-26	1987-06-26 00:00:00	38000275	0	\N	\N	165161	0	274474001	4170947	
40269	3529	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	234371	0	180256009	4107731	
28540	2537	4107731	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	167722	0	180256009	4107731	
40654	3566	4107731	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	236890	0	180256009	4107731	
40774	3577	4243062	1993-04-10	1993-04-10 00:00:00	38000275	0	\N	\N	237828	0	60027007	4243062	
28994	2563	44783196	1972-04-18	1972-04-18 00:00:00	38000275	0	\N	\N	169794	0	699253003	44783196	
29323	2604	4125906	2017-05-18	2017-05-18 00:00:00	38000275	0	\N	\N	172299	0	288086009	4125906	
29487	2630	4043071	1970-12-08	1970-12-08 00:00:00	38000275	0	\N	\N	173943	0	228557008	4043071	
41683	3668	4170947	1991-05-09	1991-05-09 00:00:00	38000275	0	\N	\N	244029	0	274474001	4170947	
41802	3680	4107731	1994-07-26	1994-07-26 00:00:00	38000275	0	\N	\N	244766	0	180256009	4107731	
41908	3695	4107731	1994-06-06	1994-06-06 00:00:00	38000275	0	\N	\N	245648	0	180256009	4107731	
30290	2677	4043071	1986-05-23	1986-05-23 00:00:00	38000275	0	\N	\N	177415	0	228557008	4043071	
42408	3744	4107731	2005-08-31	2005-08-31 00:00:00	38000275	0	\N	\N	248780	0	180256009	4107731	
30595	2711	4107731	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	179643	0	180256009	4107731	
30804	2724	4043071	1962-06-03	1962-06-03 00:00:00	38000275	0	\N	\N	180517	0	228557008	4043071	
42872	3783	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	251433	0	180256009	4107731	
43047	3791	4078793	2017-07-29	2017-07-29 00:00:00	38000275	0	\N	\N	252122	0	180325003	4078793	
31258	2770	4107731	1992-08-29	1992-08-29 00:00:00	38000275	0	\N	\N	183287	0	180256009	4107731	
31539	2779	4191853	1994-12-07	1994-12-07 00:00:00	38000275	0	\N	\N	184124	0	395142003	4191853	
43676	3865	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	256621	0	180256009	4107731	
43884	3874	4107731	1998-04-29	1998-04-29 00:00:00	38000275	0	\N	\N	257286	0	180256009	4107731	
43974	3876	4107731	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	257507	0	180256009	4107731	
20353	1762	4035793	2003-02-06	2003-02-06 00:00:00	38000275	0	\N	\N	117828	0	15081005	4035793	
56367	4922	4043071	1988-06-15	1988-06-15 00:00:00	38000275	0	\N	\N	327018	0	228557008	4043071	
44630	3913	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	260130	0	180256009	4107731	
56667	4932	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	327813	0	180256009	4107731	
33051	2896	4107731	1991-12-22	1991-12-22 00:00:00	38000275	0	\N	\N	192879	0	180256009	4107731	
33108	2898	4107731	1995-04-11	1995-04-11 00:00:00	38000275	0	\N	\N	193059	0	180256009	4107731	
33353	2917	4078793	2018-02-21	2018-02-21 00:00:00	38000275	0	\N	\N	194444	0	180325003	4078793	
57466	4976	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	330981	0	180256009	4107731	
33795	2945	4035793	2007-09-25	2007-09-25 00:00:00	38000275	0	\N	\N	196489	0	15081005	4035793	
34032	2965	4107731	1992-03-30	1992-03-30 00:00:00	38000275	0	\N	\N	197936	0	180256009	4107731	
34157	2970	4107731	2001-01-25	2001-01-25 00:00:00	38000275	0	\N	\N	198339	0	180256009	4107731	
22437	1967	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	130767	0	180256009	4107731	
34467	2985	4057420	1967-06-17	1967-06-17 00:00:00	38000275	0	\N	\N	199186	0	18286008	4057420	
46672	4090	4170947	1949-09-12	1949-09-12 00:00:00	38000275	0	\N	\N	271904	0	274474001	4170947	
34920	3041	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	202448	0	180256009	4107731	
59003	5116	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	340004	0	180256009	4107731	
35307	3082	4170947	1980-03-02	1980-03-02 00:00:00	38000275	0	\N	\N	205227	0	274474001	4170947	
47442	4165	40492359	1991-01-27	1991-01-27 00:00:00	38000275	0	\N	\N	276828	0	447365002	40492359	
35652	3119	4024289	1985-07-03	1985-07-03 00:00:00	38000275	0	\N	\N	207536	0	19490002	4024289	
35759	3128	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	208187	0	180256009	4107731	
23938	2080	4170947	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	138522	0	274474001	4170947	
36172	3175	4125906	1993-12-24	1993-12-24 00:00:00	38000275	0	\N	\N	211053	0	288086009	4125906	
24416	2135	4107731	1990-10-01	1990-10-01 00:00:00	38000275	0	\N	\N	142131	0	180256009	4107731	
36534	3214	4293740	1982-12-17	1982-12-17 00:00:00	38000275	0	\N	\N	213494	0	384700001	4293740	
36727	3227	4163872	1986-02-26	1986-02-26 00:00:00	38000275	0	\N	\N	214542	0	399208008	4163872	
24955	2177	4170947	1982-10-02	1982-10-02 00:00:00	38000275	0	\N	\N	145184	0	274474001	4170947	
37051	3253	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	216394	0	180256009	4107731	
37223	3270	4043071	1986-06-23	1986-06-23 00:00:00	38000275	0	\N	\N	217317	0	228557008	4043071	
37416	3295	4078793	2003-12-15	2003-12-15 00:00:00	38000275	0	\N	\N	218942	0	180325003	4078793	
37744	3335	4151422	1975-05-12	1975-05-12 00:00:00	38000275	0	\N	\N	221283	0	269911007	4151422	
25930	2272	4295880	2000-11-18	2000-11-18 00:00:00	38000275	0	\N	\N	151039	0	76601001	4295880	
26106	2280	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	151590	0	180256009	4107731	
38149	3365	4125906	2017-02-14	2017-02-14 00:00:00	38000275	0	\N	\N	223179	0	288086009	4125906	
38439	3376	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	224052	0	180256009	4107731	
38628	3399	4107731	1998-09-15	1998-09-15 00:00:00	38000275	0	\N	\N	225434	0	180256009	4107731	
26845	2349	4107731	1990-11-18	1990-11-18 00:00:00	38000275	0	\N	\N	156396	0	180256009	4107731	
27065	2357	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	156970	0	180256009	4107731	
27191	2381	4043071	1943-10-13	1943-10-13 00:00:00	38000275	0	\N	\N	158310	0	228557008	4043071	
39282	3464	4107731	2009-12-25	2009-12-25 00:00:00	38000275	0	\N	\N	230006	0	180256009	4107731	
27526	2402	4107731	1990-07-09	1990-07-09 00:00:00	38000275	0	\N	\N	159576	0	180256009	4107731	
27851	2448	4326177	1991-07-09	1991-07-09 00:00:00	38000275	0	\N	\N	162338	0	430193006	4326177	
28024	2462	4107731	1990-12-09	1990-12-09 00:00:00	38000275	0	\N	\N	163254	0	180256009	4107731	
28156	2495	44805732	2008-08-12	2008-08-12 00:00:00	38000275	0	\N	\N	165159	0	755621000000101	44805732	
40270	3529	4151422	1993-04-11	1993-04-11 00:00:00	38000275	0	\N	\N	234407	0	269911007	4151422	
28541	2537	4107731	1992-02-23	1992-02-23 00:00:00	38000275	0	\N	\N	167660	0	180256009	4107731	
40655	3566	4107731	1990-01-22	1990-01-22 00:00:00	38000275	0	\N	\N	236882	0	180256009	4107731	
40775	3577	4170947	1993-04-10	1993-04-10 00:00:00	38000275	0	\N	\N	237828	0	274474001	4170947	
28995	2563	4024289	1979-01-12	1979-01-12 00:00:00	38000275	0	\N	\N	169791	0	19490002	4024289	
29324	2604	4125906	2000-07-02	2000-07-02 00:00:00	38000275	0	\N	\N	172315	0	288086009	4125906	
29488	2630	4043071	1971-02-16	1971-02-16 00:00:00	38000275	0	\N	\N	173945	0	228557008	4043071	
41684	3668	4125906	1993-06-27	1993-06-27 00:00:00	38000275	0	\N	\N	244031	0	288086009	4125906	
41803	3680	4107731	1994-02-08	1994-02-08 00:00:00	38000275	0	\N	\N	244794	0	180256009	4107731	
41909	3695	4107731	1994-11-21	1994-11-21 00:00:00	38000275	0	\N	\N	245654	0	180256009	4107731	
30291	2677	4043071	1987-04-10	1987-04-10 00:00:00	38000275	0	\N	\N	177417	0	228557008	4043071	
42409	3744	4107731	2004-03-24	2004-03-24 00:00:00	38000275	0	\N	\N	248797	0	180256009	4107731	
30596	2711	4107731	1992-07-13	1992-07-13 00:00:00	38000275	0	\N	\N	179662	0	180256009	4107731	
30805	2724	4043071	1961-10-29	1961-10-29 00:00:00	38000275	0	\N	\N	180522	0	228557008	4043071	
42873	3783	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	251353	0	180256009	4107731	
43048	3791	4078793	2015-07-18	2015-07-18 00:00:00	38000275	0	\N	\N	252121	0	180325003	4078793	
31259	2770	4107731	1990-07-14	1990-07-14 00:00:00	38000275	0	\N	\N	183370	0	180256009	4107731	
31540	2779	4107731	1995-05-03	1995-05-03 00:00:00	38000275	0	\N	\N	184095	0	180256009	4107731	
43677	3865	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	256563	0	180256009	4107731	
43885	3874	4107731	1996-01-31	1996-01-31 00:00:00	38000275	0	\N	\N	257216	0	180256009	4107731	
43982	3879	4195803	2010-04-08	2010-04-08 00:00:00	38000275	0	\N	\N	257704	0	312681000	4195803	
20354	1762	4078793	2003-02-06	2003-02-06 00:00:00	38000275	0	\N	\N	117828	0	180325003	4078793	
56368	4922	4043071	1986-01-08	1986-01-08 00:00:00	38000275	0	\N	\N	327008	0	228557008	4043071	
44631	3913	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	260093	0	180256009	4107731	
56668	4932	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	327852	0	180256009	4107731	
33052	2896	4107731	1993-01-24	1993-01-24 00:00:00	38000275	0	\N	\N	192800	0	180256009	4107731	
33109	2898	4107731	1993-01-12	1993-01-12 00:00:00	38000275	0	\N	\N	193055	0	180256009	4107731	
33354	2917	4078793	2017-02-15	2017-02-15 00:00:00	38000275	0	\N	\N	194482	0	180325003	4078793	
57467	4976	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	331058	0	180256009	4107731	
33796	2945	4035793	2008-01-08	2008-01-08 00:00:00	38000275	0	\N	\N	196517	0	15081005	4035793	
34033	2965	4107731	1991-09-02	1991-09-02 00:00:00	38000275	0	\N	\N	197956	0	180256009	4107731	
34158	2970	4107731	2001-08-23	2001-08-23 00:00:00	38000275	0	\N	\N	198314	0	180256009	4107731	
22438	1967	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	130827	0	180256009	4107731	
34468	2985	4170947	2016-07-13	2016-07-13 00:00:00	38000275	0	\N	\N	199192	0	274474001	4170947	
46673	4090	4078793	2018-08-20	2018-08-20 00:00:00	38000275	0	\N	\N	271872	0	180325003	4078793	
34921	3041	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	202508	0	180256009	4107731	
59004	5116	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	340016	0	180256009	4107731	
35308	3082	4151422	1997-05-19	1997-05-19 00:00:00	38000275	0	\N	\N	205230	0	269911007	4151422	
47443	4165	4125906	1983-09-10	1983-09-10 00:00:00	38000275	0	\N	\N	276826	0	288086009	4125906	
35653	3119	4170947	1985-07-03	1985-07-03 00:00:00	38000275	0	\N	\N	207536	0	274474001	4170947	
35760	3128	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	208207	0	180256009	4107731	
23939	2080	4047491	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	138522	0	1225002	4047491	
36173	3175	4058899	1995-02-01	1995-02-01 00:00:00	38000275	0	\N	\N	211054	0	168594001	4058899	
24417	2135	4107731	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	142049	0	180256009	4107731	
36535	3214	4125906	1982-12-17	1982-12-17 00:00:00	38000275	0	\N	\N	213494	0	288086009	4125906	
36728	3227	4170947	1986-02-26	1986-02-26 00:00:00	38000275	0	\N	\N	214542	0	274474001	4170947	
25032	2184	4062501	1970-02-21	1970-02-21 00:00:00	38000275	0	\N	\N	145531	0	171231001	4062501	
37052	3253	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	216393	0	180256009	4107731	
37224	3270	4043071	1984-06-18	1984-06-18 00:00:00	38000275	0	\N	\N	217365	0	228557008	4043071	
37417	3295	4078793	2009-04-06	2009-04-06 00:00:00	38000275	0	\N	\N	218981	0	180325003	4078793	
37745	3337	40492359	1983-12-05	1983-12-05 00:00:00	38000275	0	\N	\N	221351	0	447365002	40492359	
25931	2272	4295880	2000-02-19	2000-02-19 00:00:00	38000275	0	\N	\N	151038	0	76601001	4295880	
26107	2280	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	151571	0	180256009	4107731	
38150	3365	4043071	1973-01-26	1973-01-26 00:00:00	38000275	0	\N	\N	223194	0	228557008	4043071	
38440	3376	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	224051	0	180256009	4107731	
38629	3399	4107731	1996-07-30	1996-07-30 00:00:00	38000275	0	\N	\N	225490	0	180256009	4107731	
26846	2349	4107731	1990-07-15	1990-07-15 00:00:00	38000275	0	\N	\N	156418	0	180256009	4107731	
27066	2357	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	156971	0	180256009	4107731	
27192	2381	4043071	1943-06-09	1943-06-09 00:00:00	38000275	0	\N	\N	158330	0	228557008	4043071	
39283	3464	4107731	2010-03-19	2010-03-19 00:00:00	38000275	0	\N	\N	229909	0	180256009	4107731	
27527	2402	4107731	1991-07-22	1991-07-22 00:00:00	38000275	0	\N	\N	159691	0	180256009	4107731	
39645	3486	4043071	1975-07-11	1975-07-11 00:00:00	38000275	0	\N	\N	231236	0	228557008	4043071	
28025	2462	4107731	1990-11-18	1990-11-18 00:00:00	38000275	0	\N	\N	163324	0	180256009	4107731	
28157	2495	44805732	2016-08-16	2016-08-16 00:00:00	38000275	0	\N	\N	165125	0	755621000000101	44805732	
40271	3529	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	234360	0	180256009	4107731	
28542	2537	4107731	1990-09-16	1990-09-16 00:00:00	38000275	0	\N	\N	167696	0	180256009	4107731	
40656	3566	4107731	1990-03-05	1990-03-05 00:00:00	38000275	0	\N	\N	236883	0	180256009	4107731	
40776	3577	4024289	1978-05-29	1978-05-29 00:00:00	38000275	0	\N	\N	237826	0	19490002	4024289	
28996	2563	4170947	1979-01-12	1979-01-12 00:00:00	38000275	0	\N	\N	169791	0	274474001	4170947	
29325	2604	4125906	1962-01-08	1962-01-08 00:00:00	38000275	0	\N	\N	172311	0	288086009	4125906	
29489	2630	4043071	1969-06-24	1969-06-24 00:00:00	38000275	0	\N	\N	173925	0	228557008	4043071	
53483	4642	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	309432	0	180256009	4107731	
41804	3680	4107731	1993-11-16	1993-11-16 00:00:00	38000275	0	\N	\N	244792	0	180256009	4107731	
41910	3695	4107731	1993-12-20	1993-12-20 00:00:00	38000275	0	\N	\N	245668	0	180256009	4107731	
30292	2677	4043071	1987-05-08	1987-05-08 00:00:00	38000275	0	\N	\N	177369	0	228557008	4043071	
42410	3744	4107731	2003-02-19	2003-02-19 00:00:00	38000275	0	\N	\N	248742	0	180256009	4107731	
30597	2711	4107731	1991-09-23	1991-09-23 00:00:00	38000275	0	\N	\N	179647	0	180256009	4107731	
30806	2724	4043071	1963-03-24	1963-03-24 00:00:00	38000275	0	\N	\N	180528	0	228557008	4043071	
42874	3783	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	251445	0	180256009	4107731	
43049	3791	4078793	2014-07-12	2014-07-12 00:00:00	38000275	0	\N	\N	252148	0	180325003	4078793	
31260	2770	4195803	2009-10-09	2009-10-09 00:00:00	38000275	0	\N	\N	183307	0	312681000	4195803	
31541	2779	4107731	1996-04-03	1996-04-03 00:00:00	38000275	0	\N	\N	184176	0	180256009	4107731	
43678	3865	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	256544	0	180256009	4107731	
43886	3874	4107731	1995-02-08	1995-02-08 00:00:00	38000275	0	\N	\N	257208	0	180256009	4107731	
43983	3879	4181917	2015-11-25	2015-11-25 00:00:00	38000275	0	\N	\N	257729	0	54550000	4181917	
20355	1762	4035793	2010-03-18	2010-03-18 00:00:00	38000275	0	\N	\N	117810	0	15081005	4035793	
56369	4922	4043071	1988-03-16	1988-03-16 00:00:00	38000275	0	\N	\N	327034	0	228557008	4043071	
44632	3913	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	260119	0	180256009	4107731	
56669	4932	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	327895	0	180256009	4107731	
33053	2896	4107731	1990-10-07	1990-10-07 00:00:00	38000275	0	\N	\N	192839	0	180256009	4107731	
33110	2898	4191853	1995-07-25	1995-07-25 00:00:00	38000275	0	\N	\N	192974	0	395142003	4191853	
33355	2917	4078793	2005-12-14	2005-12-14 00:00:00	38000275	0	\N	\N	194507	0	180325003	4078793	
57468	4976	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	331098	0	180256009	4107731	
33797	2945	4151422	1981-06-25	1981-06-25 00:00:00	38000275	0	\N	\N	196541	0	269911007	4151422	
34034	2965	4107731	1990-07-09	1990-07-09 00:00:00	38000275	0	\N	\N	197969	0	180256009	4107731	
34159	2970	4107731	2001-06-21	2001-06-21 00:00:00	38000275	0	\N	\N	198363	0	180256009	4107731	
22439	1967	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	130856	0	180256009	4107731	
34469	2985	4163872	2016-07-13	2016-07-13 00:00:00	38000275	0	\N	\N	199192	0	399208008	4163872	
46674	4090	44783196	1955-01-21	1955-01-21 00:00:00	38000275	0	\N	\N	271905	0	699253003	44783196	
34922	3041	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	202507	0	180256009	4107731	
59005	5116	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	339959	0	180256009	4107731	
35309	3082	4275113	1993-05-21	1993-05-21 00:00:00	38000275	0	\N	\N	205187	0	65200003	4275113	
47444	4165	4170947	1981-10-20	1981-10-20 00:00:00	38000275	0	\N	\N	276831	0	274474001	4170947	
35654	3119	4293740	1996-11-01	1996-11-01 00:00:00	38000275	0	\N	\N	207537	0	384700001	4293740	
35761	3128	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	208184	0	180256009	4107731	
23940	2080	4062501	1982-10-18	1982-10-18 00:00:00	38000275	0	\N	\N	138532	0	171231001	4062501	
36174	3176	4107731	2002-02-03	2002-02-03 00:00:00	38000275	0	\N	\N	211109	0	180256009	4107731	
24418	2135	4125906	1968-09-03	1968-09-03 00:00:00	38000275	0	\N	\N	142102	0	288086009	4125906	
36536	3214	4151422	2003-12-31	2003-12-31 00:00:00	38000275	0	\N	\N	213550	0	269911007	4151422	
36729	3227	44783196	1998-07-30	1998-07-30 00:00:00	38000275	0	\N	\N	214559	0	699253003	44783196	
25033	2184	4125906	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	145588	0	288086009	4125906	
37053	3253	4191853	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	216281	0	395142003	4191853	
37225	3270	4043071	1981-04-20	1981-04-20 00:00:00	38000275	0	\N	\N	217260	0	228557008	4043071	
37418	3295	4078793	2011-04-18	2011-04-18 00:00:00	38000275	0	\N	\N	218982	0	180325003	4078793	
37746	3337	4057420	1983-12-05	1983-12-05 00:00:00	38000275	0	\N	\N	221351	0	18286008	4057420	
25932	2272	4295880	2002-11-16	2002-11-16 00:00:00	38000275	0	\N	\N	151006	0	76601001	4295880	
26108	2280	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	151657	0	180256009	4107731	
38151	3365	4043071	1972-10-27	1972-10-27 00:00:00	38000275	0	\N	\N	223171	0	228557008	4043071	
38441	3376	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	223996	0	180256009	4107731	
38630	3399	4107731	1999-02-08	1999-02-08 00:00:00	38000275	0	\N	\N	225465	0	180256009	4107731	
26847	2349	4107731	1991-12-01	1991-12-01 00:00:00	38000275	0	\N	\N	156393	0	180256009	4107731	
27067	2358	4151422	2016-10-01	2016-10-01 00:00:00	38000275	0	\N	\N	157143	0	269911007	4151422	
27193	2381	4043071	1943-11-10	1943-11-10 00:00:00	38000275	0	\N	\N	158341	0	228557008	4043071	
39284	3464	4107731	2010-07-02	2010-07-02 00:00:00	38000275	0	\N	\N	230003	0	180256009	4107731	
27528	2402	4107731	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	159601	0	180256009	4107731	
39646	3486	4043071	1975-11-14	1975-11-14 00:00:00	38000275	0	\N	\N	231234	0	228557008	4043071	
28026	2462	4107731	1990-06-24	1990-06-24 00:00:00	38000275	0	\N	\N	163224	0	180256009	4107731	
28158	2495	4059978	2004-08-05	2004-08-05 00:00:00	38000275	0	\N	\N	165156	0	169553002	4059978	
40272	3529	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	234365	0	180256009	4107731	
28543	2537	4107731	1991-05-05	1991-05-05 00:00:00	38000275	0	\N	\N	167592	0	180256009	4107731	
40657	3566	4043071	1958-12-29	1958-12-29 00:00:00	38000275	0	\N	\N	236828	0	228557008	4043071	
40777	3577	4170947	1978-05-29	1978-05-29 00:00:00	38000275	0	\N	\N	237826	0	274474001	4170947	
28997	2564	4043071	1987-05-05	1987-05-05 00:00:00	38000275	0	\N	\N	169826	0	228557008	4043071	
29328	2609	4198190	1967-05-02	1967-05-02 00:00:00	38000275	0	\N	\N	172461	0	80146002	4198190	
29490	2630	4043071	1969-08-26	1969-08-26 00:00:00	38000275	0	\N	\N	174001	0	228557008	4043071	
53484	4642	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	309424	0	180256009	4107731	
41805	3680	4163872	2006-07-29	2006-07-29 00:00:00	38000275	0	\N	\N	244715	0	399208008	4163872	
41911	3695	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	245666	0	180256009	4107731	
30293	2677	4043071	1986-03-27	1986-03-27 00:00:00	38000275	0	\N	\N	177424	0	228557008	4043071	
42411	3744	4107731	2005-05-18	2005-05-18 00:00:00	38000275	0	\N	\N	248772	0	180256009	4107731	
30598	2711	4107731	1991-11-04	1991-11-04 00:00:00	38000275	0	\N	\N	179675	0	180256009	4107731	
30807	2724	4043071	1962-11-04	1962-11-04 00:00:00	38000275	0	\N	\N	180480	0	228557008	4043071	
42875	3783	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	251373	0	180256009	4107731	
43050	3791	4202451	2014-11-01	2014-11-01 00:00:00	38000275	0	\N	\N	252148	0	433112001	4202451	
31261	2770	4170947	2009-10-09	2009-10-09 00:00:00	38000275	0	\N	\N	183307	0	274474001	4170947	
31542	2779	4107731	1996-01-31	1996-01-31 00:00:00	38000275	0	\N	\N	184116	0	180256009	4107731	
43679	3865	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	256589	0	180256009	4107731	
43887	3874	4107731	1997-08-20	1997-08-20 00:00:00	38000275	0	\N	\N	257320	0	180256009	4107731	
43984	3879	4195803	2003-06-03	2003-06-03 00:00:00	38000275	0	\N	\N	257728	0	312681000	4195803	
20356	1762	4078793	2010-03-18	2010-03-18 00:00:00	38000275	0	\N	\N	117810	0	180325003	4078793	
56370	4922	44783196	1983-06-05	1983-06-05 00:00:00	38000275	0	\N	\N	327005	0	699253003	44783196	
44633	3913	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	260183	0	180256009	4107731	
56670	4932	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	327874	0	180256009	4107731	
33054	2897	4195803	2017-11-15	2017-11-15 00:00:00	38000275	0	\N	\N	192945	0	312681000	4195803	
33111	2898	4107731	1992-05-05	1992-05-05 00:00:00	38000275	0	\N	\N	192997	0	180256009	4107731	
33356	2917	4078793	2014-02-26	2014-02-26 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
57469	4976	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	330924	0	180256009	4107731	
33798	2945	4125906	1950-08-20	1950-08-20 00:00:00	38000275	0	\N	\N	196516	0	288086009	4125906	
45899	4032	4125906	2014-01-27	2014-01-27 00:00:00	38000275	0	\N	\N	268214	0	288086009	4125906	
34160	2970	4107731	2002-06-13	2002-06-13 00:00:00	38000275	0	\N	\N	198288	0	180256009	4107731	
22440	1967	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	130796	0	180256009	4107731	
34470	2985	4195803	2016-07-13	2016-07-13 00:00:00	38000275	0	\N	\N	199192	0	312681000	4195803	
46675	4090	4125906	2011-08-14	2011-08-14 00:00:00	38000275	0	\N	\N	271939	0	288086009	4125906	
34923	3041	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	202461	0	180256009	4107731	
59006	5116	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	339913	0	180256009	4107731	
35310	3082	4238715	1995-08-23	1995-08-23 00:00:00	38000275	0	\N	\N	205252	0	68254000	4238715	
47445	4165	4195803	1981-10-20	1981-10-20 00:00:00	38000275	0	\N	\N	276831	0	312681000	4195803	
35655	3119	4125906	1996-11-01	1996-11-01 00:00:00	38000275	0	\N	\N	207537	0	288086009	4125906	
35762	3128	4191853	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	208224	0	395142003	4191853	
23941	2080	4125906	1992-02-06	1992-02-06 00:00:00	38000275	0	\N	\N	138521	0	288086009	4125906	
36175	3176	4107731	2005-02-20	2005-02-20 00:00:00	38000275	0	\N	\N	211218	0	180256009	4107731	
24419	2135	4107731	1991-04-29	1991-04-29 00:00:00	38000275	0	\N	\N	142175	0	180256009	4107731	
36537	3215	4107731	2004-02-21	2004-02-21 00:00:00	38000275	0	\N	\N	213612	0	180256009	4107731	
36730	3229	4293740	2014-11-22	2014-11-22 00:00:00	38000275	0	\N	\N	214641	0	384700001	4293740	
25034	2184	4151422	1987-01-02	1987-01-02 00:00:00	38000275	0	\N	\N	145525	0	269911007	4151422	
37054	3253	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	216301	0	180256009	4107731	
37226	3270	4043071	1985-09-30	1985-09-30 00:00:00	38000275	0	\N	\N	217292	0	228557008	4043071	
37419	3295	4078793	2018-05-28	2018-05-28 00:00:00	38000275	0	\N	\N	218964	0	180325003	4078793	
37747	3337	4330583	2014-06-05	2014-06-05 00:00:00	38000275	0	\N	\N	221393	0	22523008	4330583	
25933	2272	4295880	1995-08-26	1995-08-26 00:00:00	38000275	0	\N	\N	151050	0	76601001	4295880	
26109	2280	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	151570	0	180256009	4107731	
38152	3365	4043071	1972-11-24	1972-11-24 00:00:00	38000275	0	\N	\N	223212	0	228557008	4043071	
38448	3378	4058899	2017-04-20	2017-04-20 00:00:00	38000275	0	\N	\N	224120	0	168594001	4058899	
38631	3399	4107731	1998-12-28	1998-12-28 00:00:00	38000275	0	\N	\N	225464	0	180256009	4107731	
26848	2349	4107731	1992-08-30	1992-08-30 00:00:00	38000275	0	\N	\N	156445	0	180256009	4107731	
27068	2359	4202451	2014-10-06	2014-10-06 00:00:00	38000275	0	\N	\N	157242	0	433112001	4202451	
27194	2381	4043071	1944-09-13	1944-09-13 00:00:00	38000275	0	\N	\N	158344	0	228557008	4043071	
39285	3464	4107731	2009-09-11	2009-09-11 00:00:00	38000275	0	\N	\N	229959	0	180256009	4107731	
27529	2402	4107731	1991-04-29	1991-04-29 00:00:00	38000275	0	\N	\N	159634	0	180256009	4107731	
39647	3486	4043071	1975-08-15	1975-08-15 00:00:00	38000275	0	\N	\N	231237	0	228557008	4043071	
28027	2462	4107731	1992-05-17	1992-05-17 00:00:00	38000275	0	\N	\N	163296	0	180256009	4107731	
28159	2495	44805732	2012-08-14	2012-08-14 00:00:00	38000275	0	\N	\N	165134	0	755621000000101	44805732	
40273	3529	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	234359	0	180256009	4107731	
28544	2537	4107731	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	167623	0	180256009	4107731	
40658	3566	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	236979	0	180256009	4107731	
40778	3577	4151422	2011-03-08	2011-03-08 00:00:00	38000275	0	\N	\N	237801	0	269911007	4151422	
28998	2564	4043071	1989-01-31	1989-01-31 00:00:00	38000275	0	\N	\N	169886	0	228557008	4043071	
29329	2609	4125906	1967-08-04	1967-08-04 00:00:00	38000275	0	\N	\N	172495	0	288086009	4125906	
29491	2630	4043071	1970-07-28	1970-07-28 00:00:00	38000275	0	\N	\N	173980	0	228557008	4043071	
53485	4642	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	309397	0	180256009	4107731	
41806	3680	4107731	1995-08-08	1995-08-08 00:00:00	38000275	0	\N	\N	244771	0	180256009	4107731	
41912	3695	4107731	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	245572	0	180256009	4107731	
30294	2677	4043071	1986-01-23	1986-01-23 00:00:00	38000275	0	\N	\N	177414	0	228557008	4043071	
42412	3744	4107731	2003-04-02	2003-04-02 00:00:00	38000275	0	\N	\N	248743	0	180256009	4107731	
30599	2711	4107731	1992-08-24	1992-08-24 00:00:00	38000275	0	\N	\N	179663	0	180256009	4107731	
30808	2724	4195803	2015-04-19	2015-04-19 00:00:00	38000275	0	\N	\N	180462	0	312681000	4195803	
42876	3783	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	251328	0	180256009	4107731	
43051	3791	4078793	2016-07-23	2016-07-23 00:00:00	38000275	0	\N	\N	252084	0	180325003	4078793	
31262	2770	4024289	2009-10-09	2009-10-09 00:00:00	38000275	0	\N	\N	183307	0	19490002	4024289	
31543	2779	4107731	1995-02-08	1995-02-08 00:00:00	38000275	0	\N	\N	184111	0	180256009	4107731	
43680	3865	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	256568	0	180256009	4107731	
43888	3874	4107731	1998-02-04	1998-02-04 00:00:00	38000275	0	\N	\N	257263	0	180256009	4107731	
43985	3879	4145310	2003-06-03	2003-06-03 00:00:00	38000275	0	\N	\N	257728	0	268425006	4145310	
20357	1762	4035793	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	117819	0	15081005	4035793	
56371	4922	4043071	1988-01-06	1988-01-06 00:00:00	38000275	0	\N	\N	327075	0	228557008	4043071	
44634	3913	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	260115	0	180256009	4107731	
56671	4932	4151422	1967-02-18	1967-02-18 00:00:00	38000275	0	\N	\N	327862	0	269911007	4151422	
33055	2897	4145310	2017-11-15	2017-11-15 00:00:00	38000275	0	\N	\N	192945	0	268425006	4145310	
33112	2898	4107731	1994-06-21	1994-06-21 00:00:00	38000275	0	\N	\N	193093	0	180256009	4107731	
33357	2917	4078793	2000-11-15	2000-11-15 00:00:00	38000275	0	\N	\N	194490	0	180325003	4078793	
57470	4976	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	331090	0	180256009	4107731	
45629	4024	4295880	1999-01-10	1999-01-10 00:00:00	38000275	0	\N	\N	267540	0	76601001	4295880	
45900	4032	4078793	2013-08-06	2013-08-06 00:00:00	38000275	0	\N	\N	268289	0	180325003	4078793	
34161	2970	4107731	2002-05-02	2002-05-02 00:00:00	38000275	0	\N	\N	198258	0	180256009	4107731	
34222	2970	4107731	2000-06-29	2000-06-29 00:00:00	38000275	0	\N	\N	198358	0	180256009	4107731	
34471	2985	4151422	1981-04-16	1981-04-16 00:00:00	38000275	0	\N	\N	199207	0	269911007	4151422	
46676	4090	4078793	2017-08-14	2017-08-14 00:00:00	38000275	0	\N	\N	271870	0	180325003	4078793	
34924	3041	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	202449	0	180256009	4107731	
59007	5116	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	339985	0	180256009	4107731	
35311	3082	40492359	1988-05-04	1988-05-04 00:00:00	38000275	0	\N	\N	205228	0	447365002	40492359	
47446	4165	4047491	1981-10-20	1981-10-20 00:00:00	38000275	0	\N	\N	276831	0	1225002	4047491	
35656	3119	4125906	1982-01-05	1982-01-05 00:00:00	38000275	0	\N	\N	207535	0	288086009	4125906	
35763	3128	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	208209	0	180256009	4107731	
23942	2080	4125906	2009-08-24	2009-08-24 00:00:00	38000275	0	\N	\N	138544	0	288086009	4125906	
36176	3176	4107731	2003-01-05	2003-01-05 00:00:00	38000275	0	\N	\N	211177	0	180256009	4107731	
24420	2135	4238715	1972-01-24	1972-01-24 00:00:00	38000275	0	\N	\N	142086	0	68254000	4238715	
36538	3215	4107731	2005-10-22	2005-10-22 00:00:00	38000275	0	\N	\N	213600	0	180256009	4107731	
36731	3229	4125906	2014-11-22	2014-11-22 00:00:00	38000275	0	\N	\N	214641	0	288086009	4125906	
25035	2185	4058899	1992-09-03	1992-09-03 00:00:00	38000275	0	\N	\N	145626	0	168594001	4058899	
37055	3253	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	216374	0	180256009	4107731	
37227	3270	4043071	1986-03-03	1986-03-03 00:00:00	38000275	0	\N	\N	217316	0	228557008	4043071	
37420	3295	4078793	1997-06-09	1997-06-09 00:00:00	38000275	0	\N	\N	218979	0	180325003	4078793	
37748	3337	4151422	1991-08-29	1991-08-29 00:00:00	38000275	0	\N	\N	221359	0	269911007	4151422	
25934	2272	4295880	2003-08-16	2003-08-16 00:00:00	38000275	0	\N	\N	151007	0	76601001	4295880	
26110	2280	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	151653	0	180256009	4107731	
38153	3365	4043071	1971-10-29	1971-10-29 00:00:00	38000275	0	\N	\N	223209	0	228557008	4043071	
38449	3378	4195803	2017-04-20	2017-04-20 00:00:00	38000275	0	\N	\N	224120	0	312681000	4195803	
38632	3399	4107731	1998-08-25	1998-08-25 00:00:00	38000275	0	\N	\N	225477	0	180256009	4107731	
26849	2349	4107731	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	156349	0	180256009	4107731	
27069	2359	4058899	1998-03-23	1998-03-23 00:00:00	38000275	0	\N	\N	157239	0	168594001	4058899	
27195	2381	4043071	1943-05-12	1943-05-12 00:00:00	38000275	0	\N	\N	158286	0	228557008	4043071	
39286	3464	4107731	2012-02-10	2012-02-10 00:00:00	38000275	0	\N	\N	229899	0	180256009	4107731	
27530	2402	4191853	1990-01-01	1990-01-01 00:00:00	38000275	0	\N	\N	159575	0	395142003	4191853	
39648	3486	4043071	1974-01-25	1974-01-25 00:00:00	38000275	0	\N	\N	231206	0	228557008	4043071	
28028	2462	4107731	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	163286	0	180256009	4107731	
28231	2497	4057420	2008-02-28	2008-02-28 00:00:00	38000275	0	\N	\N	165316	0	18286008	4057420	
40274	3529	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	234409	0	395142003	4191853	
28545	2537	4107731	1991-11-10	1991-11-10 00:00:00	38000275	0	\N	\N	167593	0	180256009	4107731	
40659	3566	4107731	1991-09-02	1991-09-02 00:00:00	38000275	0	\N	\N	236889	0	180256009	4107731	
40779	3578	4125906	2009-02-17	2009-02-17 00:00:00	38000275	0	\N	\N	237861	0	288086009	4125906	
28999	2564	4043071	1988-12-06	1988-12-06 00:00:00	38000275	0	\N	\N	169912	0	228557008	4043071	
29330	2609	4125906	1961-04-16	1961-04-16 00:00:00	38000275	0	\N	\N	172493	0	288086009	4125906	
29492	2630	4043071	1970-03-31	1970-03-31 00:00:00	38000275	0	\N	\N	173978	0	228557008	4043071	
53486	4642	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	309478	0	180256009	4107731	
41807	3680	4107731	1995-02-21	1995-02-21 00:00:00	38000275	0	\N	\N	244693	0	180256009	4107731	
41913	3695	4107731	1995-03-27	1995-03-27 00:00:00	38000275	0	\N	\N	245629	0	180256009	4107731	
42076	3708	4170947	1988-09-12	1988-09-12 00:00:00	38000275	0	\N	\N	246508	0	274474001	4170947	
42413	3744	4107731	2004-09-29	2004-09-29 00:00:00	38000275	0	\N	\N	248770	0	180256009	4107731	
30600	2711	4107731	1992-01-06	1992-01-06 00:00:00	38000275	0	\N	\N	179753	0	180256009	4107731	
30809	2724	4043071	1962-09-30	1962-09-30 00:00:00	38000275	0	\N	\N	180494	0	228557008	4043071	
42877	3783	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	251399	0	180256009	4107731	
43052	3791	4058899	1980-11-22	1980-11-22 00:00:00	38000275	0	\N	\N	252160	0	168594001	4058899	
31263	2770	4107731	1992-11-21	1992-11-21 00:00:00	38000275	0	\N	\N	183289	0	180256009	4107731	
31544	2779	4107731	1995-04-12	1995-04-12 00:00:00	38000275	0	\N	\N	184127	0	180256009	4107731	
43681	3865	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	256647	0	180256009	4107731	
43889	3874	4107731	1995-03-01	1995-03-01 00:00:00	38000275	0	\N	\N	257240	0	180256009	4107731	
44052	3881	4151422	2013-01-03	2013-01-03 00:00:00	38000275	0	\N	\N	257885	0	269911007	4151422	
20358	1762	4078793	2017-04-27	2017-04-27 00:00:00	38000275	0	\N	\N	117859	0	180325003	4078793	
56372	4922	4043071	1986-11-12	1986-11-12 00:00:00	38000275	0	\N	\N	327012	0	228557008	4043071	
44635	3913	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	260178	0	180256009	4107731	
56672	4932	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	327885	0	180256009	4107731	
33056	2897	4125906	1968-12-19	1968-12-19 00:00:00	38000275	0	\N	\N	192940	0	288086009	4125906	
33113	2898	4107731	1994-03-29	1994-03-29 00:00:00	38000275	0	\N	\N	193091	0	180256009	4107731	
33358	2917	4078793	1989-09-13	1989-09-13 00:00:00	38000275	0	\N	\N	194453	0	180325003	4078793	
57471	4976	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	331015	0	180256009	4107731	
45630	4024	4295880	1999-04-11	1999-04-11 00:00:00	38000275	0	\N	\N	267551	0	76601001	4295880	
45901	4032	4163872	1960-02-23	1960-02-23 00:00:00	38000275	0	\N	\N	268266	0	399208008	4163872	
34162	2970	4107731	2001-09-13	2001-09-13 00:00:00	38000275	0	\N	\N	198285	0	180256009	4107731	
34297	2975	4107731	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	198579	0	180256009	4107731	
34472	2986	4035793	2000-01-18	2000-01-18 00:00:00	38000275	0	\N	\N	199321	0	15081005	4035793	
46677	4090	40492359	2015-03-23	2015-03-23 00:00:00	38000275	0	\N	\N	271940	0	447365002	40492359	
34925	3041	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	202540	0	180256009	4107731	
59008	5116	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	339997	0	180256009	4107731	
35312	3082	4057420	1988-05-04	1988-05-04 00:00:00	38000275	0	\N	\N	205228	0	18286008	4057420	
47447	4165	4151422	1912-03-15	1912-03-15 00:00:00	38000275	0	\N	\N	276694	0	269911007	4151422	
35665	3123	4295880	2010-04-21	2010-04-21 00:00:00	38000275	0	\N	\N	207787	0	76601001	4295880	
35764	3128	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	208204	0	180256009	4107731	
23943	2080	4151422	2009-04-09	2009-04-09 00:00:00	38000275	0	\N	\N	138541	0	269911007	4151422	
36177	3176	4107731	2003-10-26	2003-10-26 00:00:00	38000275	0	\N	\N	211183	0	180256009	4107731	
24421	2135	4107731	1991-09-23	1991-09-23 00:00:00	38000275	0	\N	\N	142051	0	180256009	4107731	
36539	3215	4107731	2005-12-03	2005-12-03 00:00:00	38000275	0	\N	\N	213641	0	180256009	4107731	
36732	3229	4125906	2003-12-29	2003-12-29 00:00:00	38000275	0	\N	\N	214638	0	288086009	4125906	
25036	2185	4195803	1992-09-03	1992-09-03 00:00:00	38000275	0	\N	\N	145626	0	312681000	4195803	
37056	3253	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	216249	0	180256009	4107731	
37228	3270	4043071	1984-12-17	1984-12-17 00:00:00	38000275	0	\N	\N	217254	0	228557008	4043071	
37421	3295	4170947	2009-02-23	2009-02-23 00:00:00	38000275	0	\N	\N	218897	0	274474001	4170947	
37749	3337	4058899	1977-08-26	1977-08-26 00:00:00	38000275	0	\N	\N	221350	0	168594001	4058899	
25935	2272	4295880	1994-11-22	1994-11-22 00:00:00	38000275	0	\N	\N	151035	0	76601001	4295880	
26111	2280	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	151658	0	180256009	4107731	
38154	3365	4043071	1971-09-24	1971-09-24 00:00:00	38000275	0	\N	\N	223167	0	228557008	4043071	
38450	3378	4330583	1990-07-19	1990-07-19 00:00:00	38000275	0	\N	\N	224134	0	22523008	4330583	
38633	3399	4107731	1996-08-20	1996-08-20 00:00:00	38000275	0	\N	\N	225455	0	180256009	4107731	
26850	2349	4107731	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	156422	0	180256009	4107731	
27070	2359	4195803	1998-03-23	1998-03-23 00:00:00	38000275	0	\N	\N	157239	0	312681000	4195803	
27196	2381	4330583	1978-03-22	1978-03-22 00:00:00	38000275	0	\N	\N	158354	0	22523008	4330583	
39287	3464	4107731	2011-09-16	2011-09-16 00:00:00	38000275	0	\N	\N	229915	0	180256009	4107731	
27531	2402	4107731	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	159633	0	180256009	4107731	
39649	3486	4043071	1975-02-07	1975-02-07 00:00:00	38000275	0	\N	\N	231232	0	228557008	4043071	
28029	2462	4191853	1993-07-11	1993-07-11 00:00:00	38000275	0	\N	\N	163274	0	395142003	4191853	
28232	2497	4078793	2018-08-23	2018-08-23 00:00:00	38000275	0	\N	\N	165363	0	180325003	4078793	
40275	3529	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	234402	0	180256009	4107731	
28546	2537	4107731	1990-12-30	1990-12-30 00:00:00	38000275	0	\N	\N	167602	0	180256009	4107731	
40660	3566	4107731	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	236957	0	180256009	4107731	
40780	3578	4151422	1998-01-20	1998-01-20 00:00:00	38000275	0	\N	\N	237853	0	269911007	4151422	
29000	2564	4043071	1988-08-23	1988-08-23 00:00:00	38000275	0	\N	\N	169830	0	228557008	4043071	
29331	2609	4047491	1960-03-22	1960-03-22 00:00:00	38000275	0	\N	\N	172492	0	1225002	4047491	
29493	2630	4043071	1971-01-12	1971-01-12 00:00:00	38000275	0	\N	\N	173944	0	228557008	4043071	
53487	4642	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	309389	0	180256009	4107731	
41808	3680	4107731	1994-08-16	1994-08-16 00:00:00	38000275	0	\N	\N	244795	0	180256009	4107731	
41914	3695	4107731	1996-07-01	1996-07-01 00:00:00	38000275	0	\N	\N	245674	0	180256009	4107731	
42077	3708	4024289	1988-09-12	1988-09-12 00:00:00	38000275	0	\N	\N	246508	0	19490002	4024289	
42414	3744	4107731	2003-01-29	2003-01-29 00:00:00	38000275	0	\N	\N	248750	0	180256009	4107731	
30601	2711	4107731	1993-03-01	1993-03-01 00:00:00	38000275	0	\N	\N	179674	0	180256009	4107731	
30810	2724	4043071	1962-02-25	1962-02-25 00:00:00	38000275	0	\N	\N	180524	0	228557008	4043071	
42878	3783	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	251439	0	180256009	4107731	
43053	3791	4195803	1980-11-22	1980-11-22 00:00:00	38000275	0	\N	\N	252160	0	312681000	4195803	
31264	2770	4107731	1991-11-30	1991-11-30 00:00:00	38000275	0	\N	\N	183284	0	180256009	4107731	
31545	2779	4107731	1997-06-18	1997-06-18 00:00:00	38000275	0	\N	\N	184180	0	180256009	4107731	
43682	3865	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	256588	0	180256009	4107731	
43890	3874	4107731	1997-03-26	1997-03-26 00:00:00	38000275	0	\N	\N	257279	0	180256009	4107731	
44053	3881	4195803	1960-11-27	1960-11-27 00:00:00	38000275	0	\N	\N	257918	0	312681000	4195803	
20359	1762	4035793	2017-04-27	2017-04-27 00:00:00	38000275	0	\N	\N	117859	0	15081005	4035793	
56373	4922	4043071	1987-01-21	1987-01-21 00:00:00	38000275	0	\N	\N	327014	0	228557008	4043071	
44636	3913	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	260184	0	180256009	4107731	
56673	4932	4191853	1976-12-03	1976-12-03 00:00:00	38000275	0	\N	\N	327863	0	395142003	4191853	
33057	2898	4107731	1993-06-29	1993-06-29 00:00:00	38000275	0	\N	\N	193046	0	180256009	4107731	
33114	2898	4107731	1992-09-08	1992-09-08 00:00:00	38000275	0	\N	\N	193070	0	180256009	4107731	
33359	2917	4078793	1995-10-18	1995-10-18 00:00:00	38000275	0	\N	\N	194517	0	180325003	4078793	
57472	4976	4191853	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	331016	0	395142003	4191853	
45631	4024	4295880	1996-07-14	1996-07-14 00:00:00	38000275	0	\N	\N	267570	0	76601001	4295880	
45902	4032	4170947	1960-02-23	1960-02-23 00:00:00	38000275	0	\N	\N	268266	0	274474001	4170947	
34163	2970	4107731	2002-03-21	2002-03-21 00:00:00	38000275	0	\N	\N	198366	0	180256009	4107731	
34298	2975	4107731	1991-09-08	1991-09-08 00:00:00	38000275	0	\N	\N	198587	0	180256009	4107731	
34473	2986	4057420	1946-03-12	1946-03-12 00:00:00	38000275	0	\N	\N	199353	0	18286008	4057420	
46678	4090	4057420	2015-03-23	2015-03-23 00:00:00	38000275	0	\N	\N	271940	0	18286008	4057420	
34926	3041	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	202451	0	180256009	4107731	
59009	5116	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	339912	0	180256009	4107731	
35313	3082	4293740	1970-10-07	1970-10-07 00:00:00	38000275	0	\N	\N	205225	0	384700001	4293740	
47450	4167	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	277008	0	180256009	4107731	
35666	3123	4197460	1978-02-01	1978-02-01 00:00:00	38000275	0	\N	\N	207816	0	313191000	4197460	
35765	3128	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	208159	0	180256009	4107731	
23945	2082	4252419	1997-04-06	1997-04-06 00:00:00	38000275	0	\N	\N	138717	0	74016001	4252419	
36178	3176	4107731	2002-09-22	2002-09-22 00:00:00	38000275	0	\N	\N	211111	0	180256009	4107731	
24422	2135	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	142106	0	180256009	4107731	
36540	3215	4107731	2003-11-29	2003-11-29 00:00:00	38000275	0	\N	\N	213646	0	180256009	4107731	
36733	3230	4125906	1961-08-22	1961-08-22 00:00:00	38000275	0	\N	\N	214642	0	288086009	4125906	
25037	2185	4293740	1970-02-16	1970-02-16 00:00:00	38000275	0	\N	\N	145625	0	384700001	4293740	
37057	3253	4058899	1980-04-26	1980-04-26 00:00:00	38000275	0	\N	\N	216242	0	168594001	4058899	
37229	3270	4043071	1987-03-23	1987-03-23 00:00:00	38000275	0	\N	\N	217319	0	228557008	4043071	
37422	3295	4195803	2009-02-23	2009-02-23 00:00:00	38000275	0	\N	\N	218897	0	312681000	4195803	
37753	3339	4125906	1987-06-23	1987-06-23 00:00:00	38000275	0	\N	\N	221540	0	288086009	4125906	
25936	2272	4295880	2001-02-17	2001-02-17 00:00:00	38000275	0	\N	\N	151055	0	76601001	4295880	
26112	2280	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	151687	0	180256009	4107731	
38155	3365	4043071	1972-06-23	1972-06-23 00:00:00	38000275	0	\N	\N	223200	0	228557008	4043071	
38451	3378	4057420	2014-05-10	2014-05-10 00:00:00	38000275	0	\N	\N	224131	0	18286008	4057420	
38634	3399	4107731	1997-05-20	1997-05-20 00:00:00	38000275	0	\N	\N	225457	0	180256009	4107731	
26851	2349	4151422	2016-12-21	2016-12-21 00:00:00	38000275	0	\N	\N	156356	0	269911007	4151422	
27071	2359	4125906	2007-12-01	2007-12-01 00:00:00	38000275	0	\N	\N	157240	0	288086009	4125906	
27197	2381	4043071	1943-09-15	1943-09-15 00:00:00	38000275	0	\N	\N	158288	0	228557008	4043071	
39288	3464	4107731	2011-05-13	2011-05-13 00:00:00	38000275	0	\N	\N	229896	0	180256009	4107731	
27532	2402	4107731	1993-02-08	1993-02-08 00:00:00	38000275	0	\N	\N	159687	0	180256009	4107731	
39650	3486	4043071	1974-03-29	1974-03-29 00:00:00	38000275	0	\N	\N	231202	0	228557008	4043071	
28030	2462	4191853	1990-01-07	1990-01-07 00:00:00	38000275	0	\N	\N	163320	0	395142003	4191853	
28233	2497	4078793	2017-08-17	2017-08-17 00:00:00	38000275	0	\N	\N	165301	0	180325003	4078793	
40276	3529	4195803	2004-08-04	2004-08-04 00:00:00	38000275	0	\N	\N	234354	0	312681000	4195803	
28547	2537	4107731	1990-06-03	1990-06-03 00:00:00	38000275	0	\N	\N	167720	0	180256009	4107731	
40661	3566	4107731	1991-09-23	1991-09-23 00:00:00	38000275	0	\N	\N	236960	0	180256009	4107731	
40781	3578	4198190	1979-08-03	1979-08-03 00:00:00	38000275	0	\N	\N	237906	0	80146002	4198190	
29001	2564	4043071	1987-06-02	1987-06-02 00:00:00	38000275	0	\N	\N	169823	0	228557008	4043071	
29332	2609	4170947	1960-03-22	1960-03-22 00:00:00	38000275	0	\N	\N	172492	0	274474001	4170947	
29494	2630	4043071	1970-11-03	1970-11-03 00:00:00	38000275	0	\N	\N	174009	0	228557008	4043071	
53488	4642	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	309425	0	180256009	4107731	
41809	3680	4107731	1993-01-26	1993-01-26 00:00:00	38000275	0	\N	\N	244760	0	180256009	4107731	
41915	3695	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	245571	0	180256009	4107731	
42078	3708	4199276	2002-05-31	2002-05-31 00:00:00	38000275	0	\N	\N	246488	0	301807007	4199276	
42415	3744	4107731	2004-07-28	2004-07-28 00:00:00	38000275	0	\N	\N	248756	0	180256009	4107731	
30602	2711	4107731	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	179752	0	180256009	4107731	
30824	2731	4151422	1973-05-25	1973-05-25 00:00:00	38000275	0	\N	\N	180740	0	269911007	4151422	
42879	3783	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	251402	0	180256009	4107731	
43054	3791	4078793	2012-06-30	2012-06-30 00:00:00	38000275	0	\N	\N	252110	0	180325003	4078793	
31265	2770	4107731	1992-02-22	1992-02-22 00:00:00	38000275	0	\N	\N	183286	0	180256009	4107731	
31546	2779	4107731	1998-03-18	1998-03-18 00:00:00	38000275	0	\N	\N	184183	0	180256009	4107731	
43683	3865	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	256665	0	180256009	4107731	
43891	3874	4107731	1997-03-05	1997-03-05 00:00:00	38000275	0	\N	\N	257265	0	180256009	4107731	
44054	3881	4243062	1960-11-27	1960-11-27 00:00:00	38000275	0	\N	\N	257918	0	60027007	4243062	
20360	1762	4035793	1992-03-05	1992-03-05 00:00:00	38000275	0	\N	\N	117823	0	15081005	4035793	
56374	4922	4043071	1986-06-11	1986-06-11 00:00:00	38000275	0	\N	\N	327009	0	228557008	4043071	
44637	3913	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	260125	0	180256009	4107731	
56674	4932	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	327892	0	180256009	4107731	
33058	2898	4107731	1992-06-16	1992-06-16 00:00:00	38000275	0	\N	\N	192998	0	180256009	4107731	
33115	2898	4191853	1992-01-21	1992-01-21 00:00:00	38000275	0	\N	\N	193068	0	395142003	4191853	
33360	2917	4078793	2012-01-18	2012-01-18 00:00:00	38000275	0	\N	\N	194492	0	180325003	4078793	
57473	4976	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	330983	0	180256009	4107731	
45632	4024	4295880	1998-07-12	1998-07-12 00:00:00	38000275	0	\N	\N	267550	0	76601001	4295880	
45903	4032	4125906	1953-04-16	1953-04-16 00:00:00	38000275	0	\N	\N	268265	0	288086009	4125906	
34164	2970	4107731	1999-08-19	1999-08-19 00:00:00	38000275	0	\N	\N	198367	0	180256009	4107731	
34299	2975	4107731	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	198576	0	180256009	4107731	
34474	2986	40492359	1946-03-12	1946-03-12 00:00:00	38000275	0	\N	\N	199353	0	447365002	40492359	
46679	4090	4252419	1955-01-14	1955-01-14 00:00:00	38000275	0	\N	\N	271933	0	74016001	4252419	
34927	3041	4191853	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	202452	0	395142003	4191853	
59010	5116	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	340014	0	180256009	4107731	
35314	3082	4125906	1970-10-07	1970-10-07 00:00:00	38000275	0	\N	\N	205225	0	288086009	4125906	
47451	4167	4107731	1994-05-18	1994-05-18 00:00:00	38000275	0	\N	\N	276974	0	180256009	4107731	
35667	3123	4295880	2010-01-20	2010-01-20 00:00:00	38000275	0	\N	\N	207862	0	76601001	4295880	
35766	3128	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	208190	0	180256009	4107731	
23946	2082	4243062	2017-02-20	2017-02-20 00:00:00	38000275	0	\N	\N	138721	0	60027007	4243062	
36179	3176	4107731	2003-04-20	2003-04-20 00:00:00	38000275	0	\N	\N	211133	0	180256009	4107731	
24423	2135	4107731	1993-01-18	1993-01-18 00:00:00	38000275	0	\N	\N	142093	0	180256009	4107731	
36541	3215	4107731	2003-06-14	2003-06-14 00:00:00	38000275	0	\N	\N	213655	0	180256009	4107731	
36734	3230	4170947	1991-10-03	1991-10-03 00:00:00	38000275	0	\N	\N	214645	0	274474001	4170947	
25038	2185	4125906	1970-02-16	1970-02-16 00:00:00	38000275	0	\N	\N	145625	0	288086009	4125906	
37058	3253	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	216362	0	180256009	4107731	
37230	3270	4043071	1983-03-07	1983-03-07 00:00:00	38000275	0	\N	\N	217361	0	228557008	4043071	
37423	3295	4243062	2009-02-23	2009-02-23 00:00:00	38000275	0	\N	\N	218897	0	60027007	4243062	
37754	3339	4024289	1967-08-07	1967-08-07 00:00:00	38000275	0	\N	\N	221539	0	19490002	4024289	
25937	2272	4295880	2004-02-14	2004-02-14 00:00:00	38000275	0	\N	\N	151042	0	76601001	4295880	
26113	2280	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	151686	0	180256009	4107731	
38156	3365	4043071	1972-03-10	1972-03-10 00:00:00	38000275	0	\N	\N	223169	0	228557008	4043071	
38452	3378	40492359	2014-05-10	2014-05-10 00:00:00	38000275	0	\N	\N	224131	0	447365002	40492359	
38635	3399	4107731	1998-11-16	1998-11-16 00:00:00	38000275	0	\N	\N	225463	0	180256009	4107731	
26852	2349	4107731	1990-04-22	1990-04-22 00:00:00	38000275	0	\N	\N	156416	0	180256009	4107731	
27072	2359	4202451	1982-12-27	1982-12-27 00:00:00	38000275	0	\N	\N	157205	0	433112001	4202451	
27205	2384	4047491	1997-05-13	1997-05-13 00:00:00	38000275	0	\N	\N	158495	0	1225002	4047491	
39289	3464	4107731	2010-09-03	2010-09-03 00:00:00	38000275	0	\N	\N	229964	0	180256009	4107731	
27533	2402	4107731	1991-08-12	1991-08-12 00:00:00	38000275	0	\N	\N	159681	0	180256009	4107731	
39651	3486	4043071	1975-01-10	1975-01-10 00:00:00	38000275	0	\N	\N	231209	0	228557008	4043071	
28031	2462	4107731	1992-11-01	1992-11-01 00:00:00	38000275	0	\N	\N	163328	0	180256009	4107731	
28234	2497	4293740	2012-06-16	2012-06-16 00:00:00	38000275	0	\N	\N	165317	0	384700001	4293740	
40277	3529	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	234375	0	180256009	4107731	
28548	2537	4107731	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	167591	0	180256009	4107731	
40662	3566	4043071	1961-01-30	1961-01-30 00:00:00	38000275	0	\N	\N	236917	0	228557008	4043071	
40782	3578	4170947	1992-03-18	1992-03-18 00:00:00	38000275	0	\N	\N	237860	0	274474001	4170947	
29002	2564	4043071	1987-09-29	1987-09-29 00:00:00	38000275	0	\N	\N	169909	0	228557008	4043071	
29333	2609	4057420	2018-12-14	2018-12-14 00:00:00	38000275	0	\N	\N	172469	0	18286008	4057420	
29495	2630	4043071	1970-01-27	1970-01-27 00:00:00	38000275	0	\N	\N	173984	0	228557008	4043071	
53489	4642	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	309405	0	180256009	4107731	
41810	3680	4107731	1992-06-09	1992-06-09 00:00:00	38000275	0	\N	\N	244758	0	180256009	4107731	
41916	3695	4107731	1995-03-06	1995-03-06 00:00:00	38000275	0	\N	\N	245618	0	180256009	4107731	
42079	3708	4125906	2011-01-15	2011-01-15 00:00:00	38000275	0	\N	\N	246498	0	288086009	4125906	
42416	3744	4107731	2003-12-31	2003-12-31 00:00:00	38000275	0	\N	\N	248746	0	180256009	4107731	
30603	2711	4107731	1991-04-08	1991-04-08 00:00:00	38000275	0	\N	\N	179750	0	180256009	4107731	
30825	2731	4125906	1972-09-06	1972-09-06 00:00:00	38000275	0	\N	\N	180817	0	288086009	4125906	
42880	3783	4024289	2008-11-02	2008-11-02 00:00:00	38000275	0	\N	\N	251384	0	19490002	4024289	
43055	3791	4078793	2011-06-25	2011-06-25 00:00:00	38000275	0	\N	\N	252036	0	180325003	4078793	
31266	2770	4107731	1990-09-15	1990-09-15 00:00:00	38000275	0	\N	\N	183394	0	180256009	4107731	
31547	2779	4107731	1997-09-10	1997-09-10 00:00:00	38000275	0	\N	\N	184182	0	180256009	4107731	
43684	3865	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	256674	0	180256009	4107731	
43892	3874	4107731	1997-01-22	1997-01-22 00:00:00	38000275	0	\N	\N	257264	0	180256009	4107731	
44055	3881	4170947	1960-11-27	1960-11-27 00:00:00	38000275	0	\N	\N	257918	0	274474001	4170947	
20361	1762	4035793	1997-04-03	1997-04-03 00:00:00	38000275	0	\N	\N	117845	0	15081005	4035793	
56375	4922	4043071	1986-05-14	1986-05-14 00:00:00	38000275	0	\N	\N	326990	0	228557008	4043071	
44638	3913	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	260131	0	180256009	4107731	
56675	4932	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	327823	0	180256009	4107731	
33059	2898	4295880	1996-04-09	1996-04-09 00:00:00	38000275	0	\N	\N	193033	0	76601001	4295880	
33116	2898	4107731	1994-04-19	1994-04-19 00:00:00	38000275	0	\N	\N	192989	0	180256009	4107731	
33361	2917	4078793	1997-10-29	1997-10-29 00:00:00	38000275	0	\N	\N	194518	0	180325003	4078793	
57474	4976	4151422	1920-11-10	1920-11-10 00:00:00	38000275	0	\N	\N	330986	0	269911007	4151422	
45633	4024	4295880	1995-01-14	1995-01-14 00:00:00	38000275	0	\N	\N	267560	0	76601001	4295880	
45904	4032	4057420	2016-08-23	2016-08-23 00:00:00	38000275	0	\N	\N	268259	0	18286008	4057420	
34165	2970	4107731	1999-09-09	1999-09-09 00:00:00	38000275	0	\N	\N	198325	0	180256009	4107731	
34300	2975	4107731	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	198613	0	180256009	4107731	
34475	2986	4035793	2016-04-19	2016-04-19 00:00:00	38000275	0	\N	\N	199307	0	15081005	4035793	
46680	4091	4125906	2012-09-28	2012-09-28 00:00:00	38000275	0	\N	\N	271943	0	288086009	4125906	
34928	3041	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	202503	0	180256009	4107731	
59011	5116	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	339986	0	180256009	4107731	
35315	3082	4243062	1998-03-28	1998-03-28 00:00:00	38000275	0	\N	\N	205229	0	60027007	4243062	
47452	4167	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	276891	0	180256009	4107731	
35668	3123	4295880	2009-10-21	2009-10-21 00:00:00	38000275	0	\N	\N	207823	0	76601001	4295880	
35767	3128	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	208122	0	180256009	4107731	
23947	2082	4170947	2017-02-20	2017-02-20 00:00:00	38000275	0	\N	\N	138721	0	274474001	4170947	
36180	3176	4163872	1997-06-30	1997-06-30 00:00:00	38000275	0	\N	\N	211150	0	399208008	4163872	
24424	2135	4107731	1990-01-22	1990-01-22 00:00:00	38000275	0	\N	\N	142184	0	180256009	4107731	
36542	3215	4107731	2005-05-28	2005-05-28 00:00:00	38000275	0	\N	\N	213652	0	180256009	4107731	
36735	3230	4163872	1991-10-03	1991-10-03 00:00:00	38000275	0	\N	\N	214645	0	399208008	4163872	
25039	2185	4151422	1982-10-26	1982-10-26 00:00:00	38000275	0	\N	\N	145682	0	269911007	4151422	
37059	3253	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	216279	0	180256009	4107731	
37231	3270	4043071	1987-01-19	1987-01-19 00:00:00	38000275	0	\N	\N	217296	0	228557008	4043071	
37424	3295	4078793	2019-06-03	2019-06-03 00:00:00	38000275	0	\N	\N	218901	0	180325003	4078793	
37755	3339	4170947	1967-08-07	1967-08-07 00:00:00	38000275	0	\N	\N	221539	0	274474001	4170947	
25938	2272	4295880	2002-05-18	2002-05-18 00:00:00	38000275	0	\N	\N	151027	0	76601001	4295880	
26114	2280	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	151656	0	180256009	4107731	
38157	3365	4043071	1972-12-29	1972-12-29 00:00:00	38000275	0	\N	\N	223213	0	228557008	4043071	
38492	3381	4151422	2015-07-24	2015-07-24 00:00:00	38000275	0	\N	\N	224385	0	269911007	4151422	
38636	3399	4107731	1998-12-07	1998-12-07 00:00:00	38000275	0	\N	\N	225535	0	180256009	4107731	
26853	2349	4107731	1990-09-16	1990-09-16 00:00:00	38000275	0	\N	\N	156368	0	180256009	4107731	
27073	2359	4151422	1941-01-31	1941-01-31 00:00:00	38000275	0	\N	\N	157275	0	269911007	4151422	
27206	2384	4170947	1997-05-13	1997-05-13 00:00:00	38000275	0	\N	\N	158495	0	274474001	4170947	
39290	3464	4107731	2011-03-11	2011-03-11 00:00:00	38000275	0	\N	\N	229965	0	180256009	4107731	
27534	2402	4107731	1992-06-22	1992-06-22 00:00:00	38000275	0	\N	\N	159656	0	180256009	4107731	
39652	3486	4043071	1974-11-01	1974-11-01 00:00:00	38000275	0	\N	\N	231279	0	228557008	4043071	
28032	2462	4107731	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	163266	0	180256009	4107731	
28235	2497	4125906	2012-06-16	2012-06-16 00:00:00	38000275	0	\N	\N	165317	0	288086009	4125906	
40278	3529	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	234436	0	395142003	4191853	
28558	2540	4125906	1996-11-04	1996-11-04 00:00:00	38000275	0	\N	\N	167989	0	288086009	4125906	
40663	3567	4275113	1983-06-18	1983-06-18 00:00:00	38000275	0	\N	\N	237044	0	65200003	4275113	
40783	3578	4047491	1992-03-18	1992-03-18 00:00:00	38000275	0	\N	\N	237860	0	1225002	4047491	
29003	2564	4043071	1988-04-19	1988-04-19 00:00:00	38000275	0	\N	\N	169829	0	228557008	4043071	
29334	2609	40492359	2018-12-14	2018-12-14 00:00:00	38000275	0	\N	\N	172469	0	447365002	40492359	
29519	2633	4125906	1991-11-24	1991-11-24 00:00:00	38000275	0	\N	\N	174228	0	288086009	4125906	
53490	4642	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	309420	0	180256009	4107731	
41811	3680	4107731	1993-08-03	1993-08-03 00:00:00	38000275	0	\N	\N	244752	0	180256009	4107731	
41917	3695	4107731	1994-01-10	1994-01-10 00:00:00	38000275	0	\N	\N	245573	0	180256009	4107731	
42080	3708	4191853	1978-01-26	1978-01-26 00:00:00	38000275	0	\N	\N	246551	0	395142003	4191853	
42417	3744	4107731	2005-11-02	2005-11-02 00:00:00	38000275	0	\N	\N	248807	0	180256009	4107731	
30604	2711	4191853	1990-01-01	1990-01-01 00:00:00	38000275	0	\N	\N	179639	0	395142003	4191853	
30826	2731	4047491	1970-12-16	1970-12-16 00:00:00	38000275	0	\N	\N	180816	0	1225002	4047491	
42881	3783	4170947	2008-11-02	2008-11-02 00:00:00	38000275	0	\N	\N	251384	0	274474001	4170947	
43056	3791	4057420	2018-08-04	2018-08-04 00:00:00	38000275	0	\N	\N	252085	0	18286008	4057420	
31267	2770	4151422	1991-01-30	1991-01-30 00:00:00	38000275	0	\N	\N	183320	0	269911007	4151422	
31548	2779	4107731	1996-03-13	1996-03-13 00:00:00	38000275	0	\N	\N	184161	0	180256009	4107731	
43685	3865	44783196	2004-11-20	2004-11-20 00:00:00	38000275	0	\N	\N	256552	0	699253003	44783196	
43893	3874	4107731	1997-11-12	1997-11-12 00:00:00	38000275	0	\N	\N	257281	0	180256009	4107731	
44056	3881	4151422	2015-11-28	2015-11-28 00:00:00	38000275	0	\N	\N	257890	0	269911007	4151422	
20362	1762	4078793	2001-01-25	2001-01-25 00:00:00	38000275	0	\N	\N	117827	0	180325003	4078793	
56376	4922	4043071	1988-10-19	1988-10-19 00:00:00	38000275	0	\N	\N	327011	0	228557008	4043071	
44639	3913	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	260114	0	180256009	4107731	
56676	4932	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	327903	0	180256009	4107731	
33060	2898	4107731	1993-09-21	1993-09-21 00:00:00	38000275	0	\N	\N	193048	0	180256009	4107731	
33117	2898	4107731	1994-02-15	1994-02-15 00:00:00	38000275	0	\N	\N	193104	0	180256009	4107731	
33362	2917	4057420	1998-11-04	1998-11-04 00:00:00	38000275	0	\N	\N	194489	0	18286008	4057420	
57475	4976	4125906	1950-12-05	1950-12-05 00:00:00	38000275	0	\N	\N	331103	0	288086009	4125906	
45634	4024	4295880	1998-01-11	1998-01-11 00:00:00	38000275	0	\N	\N	267573	0	76601001	4295880	
45905	4032	4057420	2017-08-29	2017-08-29 00:00:00	38000275	0	\N	\N	268229	0	18286008	4057420	
34166	2970	4107731	1999-06-17	1999-06-17 00:00:00	38000275	0	\N	\N	198332	0	180256009	4107731	
34301	2975	4107731	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	198670	0	180256009	4107731	
34476	2986	4035793	2013-04-02	2013-04-02 00:00:00	38000275	0	\N	\N	199324	0	15081005	4035793	
46681	4091	4125906	2015-03-31	2015-03-31 00:00:00	38000275	0	\N	\N	271944	0	288086009	4125906	
34929	3041	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	202541	0	180256009	4107731	
59012	5116	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	339960	0	180256009	4107731	
35316	3082	4170947	1998-03-28	1998-03-28 00:00:00	38000275	0	\N	\N	205229	0	274474001	4170947	
47453	4167	4107731	1993-12-22	1993-12-22 00:00:00	38000275	0	\N	\N	276964	0	180256009	4107731	
35669	3123	4295880	2007-01-24	2007-01-24 00:00:00	38000275	0	\N	\N	207785	0	76601001	4295880	
35768	3128	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	208119	0	180256009	4107731	
23948	2082	4195803	2017-02-20	2017-02-20 00:00:00	38000275	0	\N	\N	138721	0	312681000	4195803	
36181	3176	4107731	2004-02-29	2004-02-29 00:00:00	38000275	0	\N	\N	211205	0	180256009	4107731	
24425	2135	4107731	1992-02-17	1992-02-17 00:00:00	38000275	0	\N	\N	142138	0	180256009	4107731	
36543	3215	4191853	2002-10-26	2002-10-26 00:00:00	38000275	0	\N	\N	213667	0	395142003	4191853	
36736	3230	4047491	1967-02-11	1967-02-11 00:00:00	38000275	0	\N	\N	214644	0	1225002	4047491	
25040	2185	4243062	2015-06-05	2015-06-05 00:00:00	38000275	0	\N	\N	145627	0	60027007	4243062	
37060	3253	4107731	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	216392	0	180256009	4107731	
37232	3270	4043071	1984-07-16	1984-07-16 00:00:00	38000275	0	\N	\N	217312	0	228557008	4043071	
37425	3295	4170947	1952-01-19	1952-01-19 00:00:00	38000275	0	\N	\N	218894	0	274474001	4170947	
37756	3339	4170947	1999-04-05	1999-04-05 00:00:00	38000275	0	\N	\N	221541	0	274474001	4170947	
25939	2272	4295880	1999-11-20	1999-11-20 00:00:00	38000275	0	\N	\N	151002	0	76601001	4295880	
26115	2280	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	151564	0	180256009	4107731	
38158	3365	4043071	1972-07-28	1972-07-28 00:00:00	38000275	0	\N	\N	223211	0	228557008	4043071	
38493	3382	4151422	1978-11-01	1978-11-01 00:00:00	38000275	0	\N	\N	224413	0	269911007	4151422	
38637	3399	4191853	1996-02-12	1996-02-12 00:00:00	38000275	0	\N	\N	225512	0	395142003	4191853	
26854	2349	4107731	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	156343	0	180256009	4107731	
27074	2359	4047491	1995-06-07	1995-06-07 00:00:00	38000275	0	\N	\N	157238	0	1225002	4047491	
27207	2384	4151422	2003-10-11	2003-10-11 00:00:00	38000275	0	\N	\N	158483	0	269911007	4151422	
39291	3464	4107731	2011-01-28	2011-01-28 00:00:00	38000275	0	\N	\N	229913	0	180256009	4107731	
27535	2402	4151422	1980-02-26	1980-02-26 00:00:00	38000275	0	\N	\N	159574	0	269911007	4151422	
39653	3486	4043071	1976-01-16	1976-01-16 00:00:00	38000275	0	\N	\N	231238	0	228557008	4043071	
28033	2462	4107731	1992-02-23	1992-02-23 00:00:00	38000275	0	\N	\N	163264	0	180256009	4107731	
28236	2497	4170947	2004-06-28	2004-06-28 00:00:00	38000275	0	\N	\N	165315	0	274474001	4170947	
40279	3529	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	234404	0	180256009	4107731	
28559	2540	4043071	1948-12-18	1948-12-18 00:00:00	38000275	0	\N	\N	167891	0	228557008	4043071	
40664	3567	4151422	2002-06-29	2002-06-29 00:00:00	38000275	0	\N	\N	237050	0	269911007	4151422	
40784	3579	44783196	1996-04-28	1996-04-28 00:00:00	38000275	0	\N	\N	237934	0	699253003	44783196	
29004	2564	4043071	1987-12-01	1987-12-01 00:00:00	38000275	0	\N	\N	169903	0	228557008	4043071	
29335	2610	4252419	1969-05-18	1969-05-18 00:00:00	38000275	0	\N	\N	172594	0	74016001	4252419	
29520	2633	4195803	2018-02-19	2018-02-19 00:00:00	38000275	0	\N	\N	174229	0	312681000	4195803	
53491	4642	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	309431	0	180256009	4107731	
41812	3680	4107731	1992-04-28	1992-04-28 00:00:00	38000275	0	\N	\N	244724	0	180256009	4107731	
41918	3695	4191853	1993-02-08	1993-02-08 00:00:00	38000275	0	\N	\N	245611	0	395142003	4191853	
42088	3714	4057420	2018-01-17	2018-01-17 00:00:00	38000275	0	\N	\N	246854	0	18286008	4057420	
42418	3744	4107731	2003-06-04	2003-06-04 00:00:00	38000275	0	\N	\N	248824	0	180256009	4107731	
30605	2711	4062501	1953-07-02	1953-07-02 00:00:00	38000275	0	\N	\N	179649	0	171231001	4062501	
30827	2731	4170947	1970-12-16	1970-12-16 00:00:00	38000275	0	\N	\N	180816	0	274474001	4170947	
42882	3783	4195803	2008-11-02	2008-11-02 00:00:00	38000275	0	\N	\N	251384	0	312681000	4195803	
43058	3793	4058899	1949-12-10	1949-12-10 00:00:00	38000275	0	\N	\N	252276	0	168594001	4058899	
31268	2770	4107731	1991-05-04	1991-05-04 00:00:00	38000275	0	\N	\N	183385	0	180256009	4107731	
31549	2779	4107731	1997-04-16	1997-04-16 00:00:00	38000275	0	\N	\N	184168	0	180256009	4107731	
43686	3865	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	256667	0	180256009	4107731	
43894	3874	4107731	1998-01-14	1998-01-14 00:00:00	38000275	0	\N	\N	257269	0	180256009	4107731	
44057	3881	40492359	1997-01-03	1997-01-03 00:00:00	38000275	0	\N	\N	257921	0	447365002	40492359	
20363	1762	4035793	1995-03-23	1995-03-23 00:00:00	38000275	0	\N	\N	117844	0	15081005	4035793	
56377	4922	4043071	1987-04-29	1987-04-29 00:00:00	38000275	0	\N	\N	327030	0	228557008	4043071	
44640	3913	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	260113	0	180256009	4107731	
56677	4932	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	327896	0	180256009	4107731	
33061	2898	4107731	1993-02-23	1993-02-23 00:00:00	38000275	0	\N	\N	193011	0	180256009	4107731	
33118	2898	4295880	1994-10-11	1994-10-11 00:00:00	38000275	0	\N	\N	193031	0	76601001	4295880	
33363	2917	4326177	1962-08-27	1962-08-27 00:00:00	38000275	0	\N	\N	194432	0	430193006	4326177	
57476	4976	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	330950	0	180256009	4107731	
45635	4024	4295880	1997-07-13	1997-07-13 00:00:00	38000275	0	\N	\N	267538	0	76601001	4295880	
45906	4032	4151422	2001-05-22	2001-05-22 00:00:00	38000275	0	\N	\N	268281	0	269911007	4151422	
34167	2970	4191853	2002-11-07	2002-11-07 00:00:00	38000275	0	\N	\N	198259	0	395142003	4191853	
34302	2975	4107731	1992-08-09	1992-08-09 00:00:00	38000275	0	\N	\N	198575	0	180256009	4107731	
34477	2986	4035793	2009-03-10	2009-03-10 00:00:00	38000275	0	\N	\N	199305	0	15081005	4035793	
46682	4091	4057420	2017-09-10	2017-09-10 00:00:00	38000275	0	\N	\N	271945	0	18286008	4057420	
34930	3041	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	202545	0	180256009	4107731	
59013	5116	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	339901	0	180256009	4107731	
35317	3083	4047491	1964-02-04	1964-02-04 00:00:00	38000275	0	\N	\N	205269	0	1225002	4047491	
47454	4167	4275113	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	276954	0	65200003	4275113	
35670	3123	4058899	2005-11-02	2005-11-02 00:00:00	38000275	0	\N	\N	207820	0	168594001	4058899	
35769	3128	4197460	1974-02-19	1974-02-19 00:00:00	38000275	0	\N	\N	208162	0	313191000	4197460	
23949	2082	4058899	2007-12-10	2007-12-10 00:00:00	38000275	0	\N	\N	138719	0	168594001	4058899	
36182	3176	4151422	1979-04-28	1979-04-28 00:00:00	38000275	0	\N	\N	211084	0	269911007	4151422	
24426	2135	4107731	1992-12-28	1992-12-28 00:00:00	38000275	0	\N	\N	142055	0	180256009	4107731	
36544	3215	4107731	2006-01-14	2006-01-14 00:00:00	38000275	0	\N	\N	213642	0	180256009	4107731	
36737	3230	4170947	1967-02-11	1967-02-11 00:00:00	38000275	0	\N	\N	214644	0	274474001	4170947	
25041	2185	4170947	2015-06-05	2015-06-05 00:00:00	38000275	0	\N	\N	145627	0	274474001	4170947	
37063	3258	4295880	2003-10-22	2003-10-22 00:00:00	38000275	0	\N	\N	216601	0	76601001	4295880	
37233	3270	4043071	1985-06-24	1985-06-24 00:00:00	38000275	0	\N	\N	217256	0	228557008	4043071	
37426	3295	4047491	1952-01-19	1952-01-19 00:00:00	38000275	0	\N	\N	218894	0	1225002	4047491	
37757	3339	4024289	1999-04-05	1999-04-05 00:00:00	38000275	0	\N	\N	221541	0	19490002	4024289	
25940	2272	4295880	1999-02-20	1999-02-20 00:00:00	38000275	0	\N	\N	151025	0	76601001	4295880	
26116	2280	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	151651	0	180256009	4107731	
38159	3365	4043071	1971-12-03	1971-12-03 00:00:00	38000275	0	\N	\N	223210	0	228557008	4043071	
38494	3382	4275113	1982-01-14	1982-01-14 00:00:00	38000275	0	\N	\N	224450	0	65200003	4275113	
38638	3399	4107731	1999-01-18	1999-01-18 00:00:00	38000275	0	\N	\N	225536	0	180256009	4107731	
26855	2349	4107731	1991-12-22	1991-12-22 00:00:00	38000275	0	\N	\N	156425	0	180256009	4107731	
27075	2359	4195803	1995-06-07	1995-06-07 00:00:00	38000275	0	\N	\N	157238	0	312681000	4195803	
27208	2384	4125906	2008-09-10	2008-09-10 00:00:00	38000275	0	\N	\N	158498	0	288086009	4125906	
39292	3464	4107731	2010-04-09	2010-04-09 00:00:00	38000275	0	\N	\N	229967	0	180256009	4107731	
27536	2402	4107731	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	159589	0	180256009	4107731	
39654	3486	4047491	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	231298	0	1225002	4047491	
28034	2462	4107731	1991-05-26	1991-05-26 00:00:00	38000275	0	\N	\N	163325	0	180256009	4107731	
28237	2497	4243062	2004-06-28	2004-06-28 00:00:00	38000275	0	\N	\N	165315	0	60027007	4243062	
40280	3529	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	234373	0	180256009	4107731	
28560	2540	4043071	1948-10-16	1948-10-16 00:00:00	38000275	0	\N	\N	167964	0	228557008	4043071	
40665	3567	4238715	1989-09-07	1989-09-07 00:00:00	38000275	0	\N	\N	237009	0	68254000	4238715	
40785	3579	4252419	1996-04-21	1996-04-21 00:00:00	38000275	0	\N	\N	237962	0	74016001	4252419	
29005	2564	4043071	1987-09-01	1987-09-01 00:00:00	38000275	0	\N	\N	169827	0	228557008	4043071	
29336	2610	4243062	1964-04-13	1964-04-13 00:00:00	38000275	0	\N	\N	172593	0	60027007	4243062	
29521	2633	4047491	2018-02-19	2018-02-19 00:00:00	38000275	0	\N	\N	174229	0	1225002	4047491	
53492	4642	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	309385	0	180256009	4107731	
41813	3680	4191853	1992-04-07	1992-04-07 00:00:00	38000275	0	\N	\N	244679	0	395142003	4191853	
41919	3695	4107731	1993-09-06	1993-09-06 00:00:00	38000275	0	\N	\N	245645	0	180256009	4107731	
42089	3714	4057420	2006-11-15	2006-11-15 00:00:00	38000275	0	\N	\N	246877	0	18286008	4057420	
42419	3744	4107731	2004-08-18	2004-08-18 00:00:00	38000275	0	\N	\N	248769	0	180256009	4107731	
30606	2711	4107731	1992-09-14	1992-09-14 00:00:00	38000275	0	\N	\N	179679	0	180256009	4107731	
30828	2731	4057420	2007-07-09	2007-07-09 00:00:00	38000275	0	\N	\N	180794	0	18286008	4057420	
42883	3783	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	251358	0	180256009	4107731	
43059	3793	4125906	1959-05-22	1959-05-22 00:00:00	38000275	0	\N	\N	252277	0	288086009	4125906	
31269	2770	4107731	1991-03-23	1991-03-23 00:00:00	38000275	0	\N	\N	183384	0	180256009	4107731	
31550	2779	4107731	1997-03-05	1997-03-05 00:00:00	38000275	0	\N	\N	184167	0	180256009	4107731	
43687	3865	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	256651	0	180256009	4107731	
43895	3874	4107731	1996-08-07	1996-08-07 00:00:00	38000275	0	\N	\N	257257	0	180256009	4107731	
44058	3881	4057420	1997-01-03	1997-01-03 00:00:00	38000275	0	\N	\N	257921	0	18286008	4057420	
20364	1762	4078793	2007-03-01	2007-03-01 00:00:00	38000275	0	\N	\N	117830	0	180325003	4078793	
56378	4922	4043071	1988-04-13	1988-04-13 00:00:00	38000275	0	\N	\N	327010	0	228557008	4043071	
44641	3913	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	260094	0	180256009	4107731	
56678	4932	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	327880	0	180256009	4107731	
33062	2898	4295880	1998-07-07	1998-07-07 00:00:00	38000275	0	\N	\N	193061	0	76601001	4295880	
33119	2898	4107731	1995-03-21	1995-03-21 00:00:00	38000275	0	\N	\N	193096	0	180256009	4107731	
33364	2917	4187458	1962-08-27	1962-08-27 00:00:00	38000275	0	\N	\N	194432	0	415300000	4187458	
57477	4976	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	331096	0	180256009	4107731	
45636	4024	4295880	1995-07-16	1995-07-16 00:00:00	38000275	0	\N	\N	267561	0	76601001	4295880	
45907	4032	4078793	2010-07-20	2010-07-20 00:00:00	38000275	0	\N	\N	268200	0	180325003	4078793	
34168	2970	4107731	2000-02-03	2000-02-03 00:00:00	38000275	0	\N	\N	198334	0	180256009	4107731	
34303	2975	4107731	1991-06-16	1991-06-16 00:00:00	38000275	0	\N	\N	198574	0	180256009	4107731	
34478	2986	4035793	1996-12-31	1996-12-31 00:00:00	38000275	0	\N	\N	199293	0	15081005	4035793	
46683	4091	40492359	2017-09-10	2017-09-10 00:00:00	38000275	0	\N	\N	271945	0	447365002	40492359	
34931	3041	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	202531	0	180256009	4107731	
59014	5116	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	339896	0	180256009	4107731	
35318	3083	4170947	1964-02-04	1964-02-04 00:00:00	38000275	0	\N	\N	205269	0	274474001	4170947	
47455	4167	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	276937	0	180256009	4107731	
35671	3123	4295880	2009-04-22	2009-04-22 00:00:00	38000275	0	\N	\N	207861	0	76601001	4295880	
35770	3128	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	208210	0	180256009	4107731	
23950	2082	4195803	2007-12-10	2007-12-10 00:00:00	38000275	0	\N	\N	138719	0	312681000	4195803	
36183	3176	4107731	2002-10-13	2002-10-13 00:00:00	38000275	0	\N	\N	211175	0	180256009	4107731	
24427	2135	4107731	1990-07-09	1990-07-09 00:00:00	38000275	0	\N	\N	142077	0	180256009	4107731	
36545	3215	4107731	2004-08-28	2004-08-28 00:00:00	38000275	0	\N	\N	213649	0	180256009	4107731	
36738	3230	4125906	2006-02-16	2006-02-16 00:00:00	38000275	0	\N	\N	214646	0	288086009	4125906	
25042	2185	4125906	1954-09-22	1954-09-22 00:00:00	38000275	0	\N	\N	145622	0	288086009	4125906	
37064	3258	4295880	2006-04-19	2006-04-19 00:00:00	38000275	0	\N	\N	216592	0	76601001	4295880	
37234	3270	4043071	1984-11-19	1984-11-19 00:00:00	38000275	0	\N	\N	217313	0	228557008	4043071	
37427	3296	4170947	1949-02-19	1949-02-19 00:00:00	38000275	0	\N	\N	219091	0	274474001	4170947	
37758	3342	4125906	1923-07-24	1923-07-24 00:00:00	38000275	0	\N	\N	221628	0	288086009	4125906	
25941	2272	4295880	1996-11-23	1996-11-23 00:00:00	38000275	0	\N	\N	151017	0	76601001	4295880	
37969	3352	4243062	1981-02-10	1981-02-10 00:00:00	38000275	0	\N	\N	222259	0	60027007	4243062	
38160	3365	4043071	1972-09-29	1972-09-29 00:00:00	38000275	0	\N	\N	223193	0	228557008	4043071	
38495	3382	4047491	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	224401	0	1225002	4047491	
38639	3399	4107731	1996-12-02	1996-12-02 00:00:00	38000275	0	\N	\N	225508	0	180256009	4107731	
26856	2349	4107731	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	156333	0	180256009	4107731	
27076	2359	4170947	1995-06-07	1995-06-07 00:00:00	38000275	0	\N	\N	157238	0	274474001	4170947	
27209	2384	4293740	2008-09-10	2008-09-10 00:00:00	38000275	0	\N	\N	158498	0	384700001	4293740	
39293	3464	4107731	2012-07-06	2012-07-06 00:00:00	38000275	0	\N	\N	229918	0	180256009	4107731	
27537	2402	4107731	1990-01-22	1990-01-22 00:00:00	38000275	0	\N	\N	159586	0	180256009	4107731	
39655	3486	4170947	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	231298	0	274474001	4170947	
28035	2462	4107731	1992-01-12	1992-01-12 00:00:00	38000275	0	\N	\N	163263	0	180256009	4107731	
40087	3518	44783196	1978-09-15	1978-09-15 00:00:00	38000275	0	\N	\N	233585	0	699253003	44783196	
40281	3529	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	234418	0	180256009	4107731	
28561	2540	4043071	1948-08-14	1948-08-14 00:00:00	38000275	0	\N	\N	167874	0	228557008	4043071	
40666	3567	4163872	1991-12-21	1991-12-21 00:00:00	38000275	0	\N	\N	237047	0	399208008	4163872	
40786	3579	40492359	2006-05-20	2006-05-20 00:00:00	38000275	0	\N	\N	237964	0	447365002	40492359	
29006	2564	4043071	1987-03-10	1987-03-10 00:00:00	38000275	0	\N	\N	169883	0	228557008	4043071	
29337	2610	4170947	1964-04-13	1964-04-13 00:00:00	38000275	0	\N	\N	172593	0	274474001	4170947	
29522	2633	4170947	2018-02-19	2018-02-19 00:00:00	38000275	0	\N	\N	174229	0	274474001	4170947	
53493	4642	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	309386	0	180256009	4107731	
41814	3680	4107731	1994-06-14	1994-06-14 00:00:00	38000275	0	\N	\N	244756	0	180256009	4107731	
41920	3695	4107731	1993-08-16	1993-08-16 00:00:00	38000275	0	\N	\N	245612	0	180256009	4107731	
42090	3714	4202451	2005-09-21	2005-09-21 00:00:00	38000275	0	\N	\N	246840	0	433112001	4202451	
42420	3744	4107731	2003-10-08	2003-10-08 00:00:00	38000275	0	\N	\N	248744	0	180256009	4107731	
30607	2711	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	179665	0	180256009	4107731	
30829	2731	40492359	2007-07-09	2007-07-09 00:00:00	38000275	0	\N	\N	180794	0	447365002	40492359	
42884	3783	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	251440	0	180256009	4107731	
43060	3793	4293740	1959-05-22	1959-05-22 00:00:00	38000275	0	\N	\N	252277	0	384700001	4293740	
31270	2770	4107731	1993-05-08	1993-05-08 00:00:00	38000275	0	\N	\N	183343	0	180256009	4107731	
31551	2779	4107731	1996-06-26	1996-06-26 00:00:00	38000275	0	\N	\N	184178	0	180256009	4107731	
43688	3865	44783196	2009-06-04	2009-06-04 00:00:00	38000275	0	\N	\N	256553	0	699253003	44783196	
43896	3874	4107731	1998-04-08	1998-04-08 00:00:00	38000275	0	\N	\N	257244	0	180256009	4107731	
44061	3884	4043071	1985-06-08	1985-06-08 00:00:00	38000275	0	\N	\N	258041	0	228557008	4043071	
20365	1762	4035793	2007-03-01	2007-03-01 00:00:00	38000275	0	\N	\N	117830	0	15081005	4035793	
56379	4922	4043071	1987-03-25	1987-03-25 00:00:00	38000275	0	\N	\N	327029	0	228557008	4043071	
44642	3913	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	260096	0	180256009	4107731	
56679	4932	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	327826	0	395142003	4191853	
33063	2898	4107731	1993-11-23	1993-11-23 00:00:00	38000275	0	\N	\N	193102	0	180256009	4107731	
33120	2898	4107731	1992-05-26	1992-05-26 00:00:00	38000275	0	\N	\N	193008	0	180256009	4107731	
33365	2917	4037675	1962-08-27	1962-08-27 00:00:00	38000275	0	\N	\N	194432	0	162676008	4037675	
57478	4976	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	331009	0	180256009	4107731	
45637	4024	4295880	1995-10-15	1995-10-15 00:00:00	38000275	0	\N	\N	267518	0	76601001	4295880	
45908	4032	4057420	2011-07-26	2011-07-26 00:00:00	38000275	0	\N	\N	268288	0	18286008	4057420	
34169	2970	4107731	2002-04-11	2002-04-11 00:00:00	38000275	0	\N	\N	198301	0	180256009	4107731	
34304	2975	4107731	1990-04-01	1990-04-01 00:00:00	38000275	0	\N	\N	198612	0	180256009	4107731	
34479	2986	4035793	2002-01-29	2002-01-29 00:00:00	38000275	0	\N	\N	199322	0	15081005	4035793	
46684	4092	4047491	1986-12-26	1986-12-26 00:00:00	38000275	0	\N	\N	272072	0	1225002	4047491	
34932	3041	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	202542	0	180256009	4107731	
59015	5116	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	339892	0	180256009	4107731	
35319	3083	4125906	1952-02-23	1952-02-23 00:00:00	38000275	0	\N	\N	205267	0	288086009	4125906	
47456	4167	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	276936	0	180256009	4107731	
35672	3123	4295880	2008-04-23	2008-04-23 00:00:00	38000275	0	\N	\N	207850	0	76601001	4295880	
35771	3128	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	208126	0	180256009	4107731	
23982	2084	4151422	1977-04-25	1977-04-25 00:00:00	38000275	0	\N	\N	138877	0	269911007	4151422	
36184	3176	4107731	2002-06-09	2002-06-09 00:00:00	38000275	0	\N	\N	211129	0	180256009	4107731	
24428	2135	4275113	1970-12-17	1970-12-17 00:00:00	38000275	0	\N	\N	142040	0	65200003	4275113	
36546	3215	4107731	2003-07-05	2003-07-05 00:00:00	38000275	0	\N	\N	213567	0	180256009	4107731	
36739	3230	4151422	2018-04-02	2018-04-02 00:00:00	38000275	0	\N	\N	214657	0	269911007	4151422	
25043	2185	4170947	1942-12-24	1942-12-24 00:00:00	38000275	0	\N	\N	145621	0	274474001	4170947	
37065	3258	4295880	2006-01-18	2006-01-18 00:00:00	38000275	0	\N	\N	216604	0	76601001	4295880	
37235	3270	4043071	1984-03-19	1984-03-19 00:00:00	38000275	0	\N	\N	217253	0	228557008	4043071	
37428	3296	4024289	1949-02-19	1949-02-19 00:00:00	38000275	0	\N	\N	219091	0	19490002	4024289	
37759	3342	4078793	2006-04-05	2006-04-05 00:00:00	38000275	0	\N	\N	221600	0	180325003	4078793	
25942	2272	4295880	2001-05-19	2001-05-19 00:00:00	38000275	0	\N	\N	151004	0	76601001	4295880	
37970	3352	4170947	1981-02-10	1981-02-10 00:00:00	38000275	0	\N	\N	222259	0	274474001	4170947	
38161	3365	4043071	1972-08-25	1972-08-25 00:00:00	38000275	0	\N	\N	223192	0	228557008	4043071	
38496	3382	4170947	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	224401	0	274474001	4170947	
38640	3399	4107731	1997-10-14	1997-10-14 00:00:00	38000275	0	\N	\N	225473	0	180256009	4107731	
26857	2349	4107731	1991-09-29	1991-09-29 00:00:00	38000275	0	\N	\N	156400	0	180256009	4107731	
27077	2359	4151422	1984-11-14	1984-11-14 00:00:00	38000275	0	\N	\N	157179	0	269911007	4151422	
39084	3446	4181917	1957-12-09	1957-12-09 00:00:00	38000275	0	\N	\N	228777	0	54550000	4181917	
39294	3464	4107731	2011-12-30	2011-12-30 00:00:00	38000275	0	\N	\N	229898	0	180256009	4107731	
27538	2402	4191853	1977-11-19	1977-11-19 00:00:00	38000275	0	\N	\N	159572	0	395142003	4191853	
39656	3486	4043071	1974-05-31	1974-05-31 00:00:00	38000275	0	\N	\N	231277	0	228557008	4043071	
28036	2462	4107731	1991-07-07	1991-07-07 00:00:00	38000275	0	\N	\N	163326	0	180256009	4107731	
40088	3518	4151422	2006-11-16	2006-11-16 00:00:00	38000275	0	\N	\N	233596	0	269911007	4151422	
40282	3529	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	234366	0	180256009	4107731	
28562	2540	4043071	1948-04-10	1948-04-10 00:00:00	38000275	0	\N	\N	167932	0	228557008	4043071	
40667	3567	4186930	1988-06-16	1988-06-16 00:00:00	38000275	0	\N	\N	237045	0	46706006	4186930	
40787	3579	4057420	2006-05-20	2006-05-20 00:00:00	38000275	0	\N	\N	237964	0	18286008	4057420	
29007	2564	4163872	1986-06-05	1986-06-05 00:00:00	38000275	0	\N	\N	169906	0	399208008	4163872	
29338	2610	4170947	2000-09-02	2000-09-02 00:00:00	38000275	0	\N	\N	172596	0	274474001	4170947	
41386	3628	4195803	1974-12-28	1974-12-28 00:00:00	38000275	0	\N	\N	241311	0	312681000	4195803	
53494	4642	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	309365	0	180256009	4107731	
41815	3680	4163872	1984-09-04	1984-09-04 00:00:00	38000275	0	\N	\N	244728	0	399208008	4163872	
41921	3695	4107731	1994-03-14	1994-03-14 00:00:00	38000275	0	\N	\N	245670	0	180256009	4107731	
42091	3714	4163872	1963-03-31	1963-03-31 00:00:00	38000275	0	\N	\N	246757	0	399208008	4163872	
42421	3744	4107731	2005-11-23	2005-11-23 00:00:00	38000275	0	\N	\N	248832	0	180256009	4107731	
30608	2711	4107731	1993-02-08	1993-02-08 00:00:00	38000275	0	\N	\N	179725	0	180256009	4107731	
30830	2731	4125906	1977-07-01	1977-07-01 00:00:00	38000275	0	\N	\N	180819	0	288086009	4125906	
42885	3783	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	251360	0	180256009	4107731	
43061	3793	4195803	1999-05-25	1999-05-25 00:00:00	38000275	0	\N	\N	252236	0	312681000	4195803	
31271	2770	4107731	1992-06-27	1992-06-27 00:00:00	38000275	0	\N	\N	183326	0	180256009	4107731	
31552	2779	4107731	1998-04-08	1998-04-08 00:00:00	38000275	0	\N	\N	184110	0	180256009	4107731	
43689	3865	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	256657	0	180256009	4107731	
43897	3874	4107731	1995-10-18	1995-10-18 00:00:00	38000275	0	\N	\N	257242	0	180256009	4107731	
44062	3884	4043071	1984-04-21	1984-04-21 00:00:00	38000275	0	\N	\N	258023	0	228557008	4043071	
20366	1762	4035793	1994-03-17	1994-03-17 00:00:00	38000275	0	\N	\N	117824	0	15081005	4035793	
56380	4922	4125906	2011-12-05	2011-12-05 00:00:00	38000275	0	\N	\N	327003	0	288086009	4125906	
44643	3913	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	260181	0	180256009	4107731	
56680	4932	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	327869	0	180256009	4107731	
33064	2898	4107731	1992-10-20	1992-10-20 00:00:00	38000275	0	\N	\N	192983	0	180256009	4107731	
33121	2898	4107731	1994-12-06	1994-12-06 00:00:00	38000275	0	\N	\N	192972	0	180256009	4107731	
33366	2917	4078793	1994-10-12	1994-10-12 00:00:00	38000275	0	\N	\N	194505	0	180325003	4078793	
57479	4976	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	330982	0	180256009	4107731	
45638	4024	4295880	1996-10-13	1996-10-13 00:00:00	38000275	0	\N	\N	267537	0	76601001	4295880	
45909	4032	4078793	2015-08-18	2015-08-18 00:00:00	38000275	0	\N	\N	268290	0	180325003	4078793	
34170	2970	4107731	2001-01-04	2001-01-04 00:00:00	38000275	0	\N	\N	198312	0	180256009	4107731	
34305	2975	4107731	1991-09-29	1991-09-29 00:00:00	38000275	0	\N	\N	198618	0	180256009	4107731	
34480	2986	4035793	1995-12-26	1995-12-26 00:00:00	38000275	0	\N	\N	199349	0	15081005	4035793	
46685	4092	4170947	1986-12-26	1986-12-26 00:00:00	38000275	0	\N	\N	272072	0	274474001	4170947	
34933	3041	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	202534	0	180256009	4107731	
59016	5116	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	340010	0	180256009	4107731	
35320	3083	4125906	2004-10-20	2004-10-20 00:00:00	38000275	0	\N	\N	205352	0	288086009	4125906	
47457	4167	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	277005	0	180256009	4107731	
35673	3123	4295880	2008-07-23	2008-07-23 00:00:00	38000275	0	\N	\N	207803	0	76601001	4295880	
35772	3128	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	208203	0	180256009	4107731	
23983	2084	4151422	2002-02-18	2002-02-18 00:00:00	38000275	0	\N	\N	138875	0	269911007	4151422	
36185	3176	4107731	2003-09-14	2003-09-14 00:00:00	38000275	0	\N	\N	211182	0	180256009	4107731	
24429	2135	4107731	1991-02-04	1991-02-04 00:00:00	38000275	0	\N	\N	142172	0	180256009	4107731	
36547	3215	4107731	2003-10-18	2003-10-18 00:00:00	38000275	0	\N	\N	213645	0	180256009	4107731	
36740	3230	4151422	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	214679	0	269911007	4151422	
25044	2185	4047491	1942-12-24	1942-12-24 00:00:00	38000275	0	\N	\N	145621	0	1225002	4047491	
37066	3258	4058899	1995-07-09	1995-07-09 00:00:00	38000275	0	\N	\N	216551	0	168594001	4058899	
37241	3272	4275113	1985-06-03	1985-06-03 00:00:00	38000275	0	\N	\N	217476	0	65200003	4275113	
37429	3296	4198190	1938-09-26	1938-09-26 00:00:00	38000275	0	\N	\N	219076	0	80146002	4198190	
37760	3342	4057420	2007-04-11	2007-04-11 00:00:00	38000275	0	\N	\N	221601	0	18286008	4057420	
25943	2272	4295880	2001-08-18	2001-08-18 00:00:00	38000275	0	\N	\N	151026	0	76601001	4295880	
37971	3353	4047491	1998-11-26	1998-11-26 00:00:00	38000275	0	\N	\N	222452	0	1225002	4047491	
38163	3367	4170947	1976-02-24	1976-02-24 00:00:00	38000275	0	\N	\N	223279	0	274474001	4170947	
38497	3382	4125906	2018-06-24	2018-06-24 00:00:00	38000275	0	\N	\N	224461	0	288086009	4125906	
38641	3399	4191853	1999-08-17	1999-08-17 00:00:00	38000275	0	\N	\N	225448	0	395142003	4191853	
26858	2349	4107731	1992-02-23	1992-02-23 00:00:00	38000275	0	\N	\N	156444	0	180256009	4107731	
27083	2366	4243062	1983-06-25	1983-06-25 00:00:00	38000275	0	\N	\N	157517	0	60027007	4243062	
39085	3446	4047491	1965-05-21	1965-05-21 00:00:00	38000275	0	\N	\N	228779	0	1225002	4047491	
39295	3464	4107731	2012-09-28	2012-09-28 00:00:00	38000275	0	\N	\N	229920	0	180256009	4107731	
27539	2402	4191853	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	159619	0	395142003	4191853	
39657	3486	4043071	1974-06-28	1974-06-28 00:00:00	38000275	0	\N	\N	231207	0	228557008	4043071	
28037	2462	4107731	1990-09-16	1990-09-16 00:00:00	38000275	0	\N	\N	163252	0	180256009	4107731	
40089	3518	4125906	1974-11-14	1974-11-14 00:00:00	38000275	0	\N	\N	233581	0	288086009	4125906	
40283	3529	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	234399	0	180256009	4107731	
28563	2540	4043071	1949-02-26	1949-02-26 00:00:00	38000275	0	\N	\N	167876	0	228557008	4043071	
40668	3568	4145310	2002-07-31	2002-07-31 00:00:00	38000275	0	\N	\N	237070	0	268425006	4145310	
40788	3579	4293740	1969-12-25	1969-12-25 00:00:00	38000275	0	\N	\N	237961	0	384700001	4293740	
29008	2564	4170947	1986-06-05	1986-06-05 00:00:00	38000275	0	\N	\N	169906	0	274474001	4170947	
29339	2610	4047491	2000-09-02	2000-09-02 00:00:00	38000275	0	\N	\N	172596	0	1225002	4047491	
41387	3628	4336464	2006-08-19	2006-08-19 00:00:00	38000275	0	\N	\N	241357	0	232717009	4336464	
53495	4642	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	309476	0	180256009	4107731	
41816	3680	4107731	1995-07-18	1995-07-18 00:00:00	38000275	0	\N	\N	244712	0	180256009	4107731	
41922	3695	4107731	1996-06-10	1996-06-10 00:00:00	38000275	0	\N	\N	245639	0	180256009	4107731	
42092	3714	4202451	2009-07-01	2009-07-01 00:00:00	38000275	0	\N	\N	246788	0	433112001	4202451	
42422	3744	4107731	2003-11-19	2003-11-19 00:00:00	38000275	0	\N	\N	248745	0	180256009	4107731	
30609	2711	4107731	1990-07-09	1990-07-09 00:00:00	38000275	0	\N	\N	179747	0	180256009	4107731	
30831	2731	4125906	1984-06-08	1984-06-08 00:00:00	38000275	0	\N	\N	180789	0	288086009	4125906	
42886	3783	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	251363	0	180256009	4107731	
43062	3795	4170947	1993-06-28	1993-06-28 00:00:00	38000275	0	\N	\N	252344	0	274474001	4170947	
31272	2770	4107731	1993-04-17	1993-04-17 00:00:00	38000275	0	\N	\N	183352	0	180256009	4107731	
31553	2779	4107731	1996-06-05	1996-06-05 00:00:00	38000275	0	\N	\N	184163	0	180256009	4107731	
43690	3865	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	256584	0	180256009	4107731	
43898	3874	4107731	1997-05-28	1997-05-28 00:00:00	38000275	0	\N	\N	257318	0	180256009	4107731	
44063	3884	4043071	1988-01-16	1988-01-16 00:00:00	38000275	0	\N	\N	258129	0	228557008	4043071	
20367	1762	4078793	2009-03-12	2009-03-12 00:00:00	38000275	0	\N	\N	117831	0	180325003	4078793	
56381	4922	4043071	1985-01-16	1985-01-16 00:00:00	38000275	0	\N	\N	327041	0	228557008	4043071	
44644	3913	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	260161	0	180256009	4107731	
56681	4932	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	327855	0	180256009	4107731	
33065	2898	4107731	1995-01-17	1995-01-17 00:00:00	38000275	0	\N	\N	192992	0	180256009	4107731	
33122	2898	4107731	1994-05-31	1994-05-31 00:00:00	38000275	0	\N	\N	192990	0	180256009	4107731	
33367	2917	4078793	2011-01-12	2011-01-12 00:00:00	38000275	0	\N	\N	194479	0	180325003	4078793	
57480	4976	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	330942	0	180256009	4107731	
45639	4024	4295880	1996-04-14	1996-04-14 00:00:00	38000275	0	\N	\N	267562	0	76601001	4295880	
45910	4032	4125906	2010-12-23	2010-12-23 00:00:00	38000275	0	\N	\N	268213	0	288086009	4125906	
34171	2970	4107731	1999-12-02	1999-12-02 00:00:00	38000275	0	\N	\N	198327	0	180256009	4107731	
34306	2975	4107731	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	198593	0	180256009	4107731	
34481	2986	4035793	1999-01-12	1999-01-12 00:00:00	38000275	0	\N	\N	199313	0	15081005	4035793	
46690	4094	4293740	2017-10-25	2017-10-25 00:00:00	38000275	0	\N	\N	272152	0	384700001	4293740	
34934	3041	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	202429	0	180256009	4107731	
59017	5116	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	339893	0	180256009	4107731	
35321	3083	4293740	2004-10-20	2004-10-20 00:00:00	38000275	0	\N	\N	205352	0	384700001	4293740	
47458	4167	4191853	1979-06-28	1979-06-28 00:00:00	38000275	0	\N	\N	276979	0	395142003	4191853	
35674	3123	4059978	2009-03-30	2009-03-30 00:00:00	38000275	0	\N	\N	207804	0	169553002	4059978	
35773	3128	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	208161	0	180256009	4107731	
23984	2084	4125906	1979-06-27	1979-06-27 00:00:00	38000275	0	\N	\N	138833	0	288086009	4125906	
36186	3176	4107731	2002-04-07	2002-04-07 00:00:00	38000275	0	\N	\N	211202	0	180256009	4107731	
24430	2135	4107731	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	142057	0	180256009	4107731	
36548	3215	4107731	2005-12-24	2005-12-24 00:00:00	38000275	0	\N	\N	213579	0	180256009	4107731	
36741	3231	4151422	1960-04-27	1960-04-27 00:00:00	38000275	0	\N	\N	214774	0	269911007	4151422	
25045	2185	4195803	2000-09-28	2000-09-28 00:00:00	38000275	0	\N	\N	145629	0	312681000	4195803	
37067	3258	4195803	1995-07-09	1995-07-09 00:00:00	38000275	0	\N	\N	216551	0	312681000	4195803	
37242	3272	4238715	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	217457	0	68254000	4238715	
37430	3296	4151422	1998-04-22	1998-04-22 00:00:00	38000275	0	\N	\N	219024	0	269911007	4151422	
37761	3342	4078793	2017-06-07	2017-06-07 00:00:00	38000275	0	\N	\N	221576	0	180325003	4078793	
25944	2272	4295880	2002-08-17	2002-08-17 00:00:00	38000275	0	\N	\N	151040	0	76601001	4295880	
37972	3353	4170947	1998-11-26	1998-11-26 00:00:00	38000275	0	\N	\N	222452	0	274474001	4170947	
38164	3367	4024289	1976-02-24	1976-02-24 00:00:00	38000275	0	\N	\N	223279	0	19490002	4024289	
38498	3382	4125906	1965-12-17	1965-12-17 00:00:00	38000275	0	\N	\N	224400	0	288086009	4125906	
38642	3399	4107731	1996-09-10	1996-09-10 00:00:00	38000275	0	\N	\N	225491	0	180256009	4107731	
26859	2349	4107731	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	156391	0	180256009	4107731	
27084	2366	4170947	1983-06-25	1983-06-25 00:00:00	38000275	0	\N	\N	157517	0	274474001	4170947	
39086	3446	4170947	1965-05-21	1965-05-21 00:00:00	38000275	0	\N	\N	228779	0	274474001	4170947	
39296	3464	4107731	2009-10-02	2009-10-02 00:00:00	38000275	0	\N	\N	230000	0	180256009	4107731	
27540	2402	4107731	1992-02-17	1992-02-17 00:00:00	38000275	0	\N	\N	159682	0	180256009	4107731	
39658	3486	4043071	1975-12-19	1975-12-19 00:00:00	38000275	0	\N	\N	231290	0	228557008	4043071	
28038	2462	4107731	1990-10-28	1990-10-28 00:00:00	38000275	0	\N	\N	163253	0	180256009	4107731	
40090	3518	4198190	2016-03-17	2016-03-17 00:00:00	38000275	0	\N	\N	233586	0	80146002	4198190	
40284	3529	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	234357	0	180256009	4107731	
28564	2540	4043071	1949-03-26	1949-03-26 00:00:00	38000275	0	\N	\N	167934	0	228557008	4043071	
40669	3569	4151422	2015-08-13	2015-08-13 00:00:00	38000275	0	\N	\N	237184	0	269911007	4151422	
40789	3579	4125906	1969-12-25	1969-12-25 00:00:00	38000275	0	\N	\N	237961	0	288086009	4125906	
29009	2564	4043071	1988-06-21	1988-06-21 00:00:00	38000275	0	\N	\N	169849	0	228557008	4043071	
29340	2610	4047491	1973-04-26	1973-04-26 00:00:00	38000275	0	\N	\N	172595	0	1225002	4047491	
41388	3628	4216130	2006-08-19	2006-08-19 00:00:00	38000275	0	\N	\N	241357	0	415070008	4216130	
53496	4642	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	309382	0	180256009	4107731	
41817	3680	4191853	1979-12-15	1979-12-15 00:00:00	38000275	0	\N	\N	244725	0	395142003	4191853	
41923	3695	4107731	1995-01-23	1995-01-23 00:00:00	38000275	0	\N	\N	245633	0	180256009	4107731	
42093	3714	4078793	2019-01-23	2019-01-23 00:00:00	38000275	0	\N	\N	246858	0	180325003	4078793	
42423	3744	4107731	2006-02-15	2006-02-15 00:00:00	38000275	0	\N	\N	248834	0	180256009	4107731	
30610	2711	4107731	1990-08-20	1990-08-20 00:00:00	38000275	0	\N	\N	179748	0	180256009	4107731	
30832	2731	4163872	1990-07-01	1990-07-01 00:00:00	38000275	0	\N	\N	180823	0	399208008	4163872	
42887	3783	4197460	1948-09-25	1948-09-25 00:00:00	38000275	0	\N	\N	251450	0	313191000	4197460	
43063	3795	4024289	1993-06-28	1993-06-28 00:00:00	38000275	0	\N	\N	252344	0	19490002	4024289	
31273	2770	4107731	1991-02-09	1991-02-09 00:00:00	38000275	0	\N	\N	183383	0	180256009	4107731	
31554	2779	4107731	1995-12-20	1995-12-20 00:00:00	38000275	0	\N	\N	184115	0	180256009	4107731	
43691	3865	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	256658	0	180256009	4107731	
43899	3874	4107731	1995-03-22	1995-03-22 00:00:00	38000275	0	\N	\N	257209	0	180256009	4107731	
44064	3884	4043071	1988-06-25	1988-06-25 00:00:00	38000275	0	\N	\N	258130	0	228557008	4043071	
20368	1762	4035793	2009-03-12	2009-03-12 00:00:00	38000275	0	\N	\N	117831	0	15081005	4035793	
56382	4922	4043071	1988-08-17	1988-08-17 00:00:00	38000275	0	\N	\N	327035	0	228557008	4043071	
44645	3913	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	260095	0	180256009	4107731	
56682	4932	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	327816	0	180256009	4107731	
33066	2898	4107731	1994-08-23	1994-08-23 00:00:00	38000275	0	\N	\N	193105	0	180256009	4107731	
33123	2898	4107731	1992-11-10	1992-11-10 00:00:00	38000275	0	\N	\N	193044	0	180256009	4107731	
33368	2917	4293740	2016-08-31	2016-08-31 00:00:00	38000275	0	\N	\N	194504	0	384700001	4293740	
57481	4976	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	330949	0	180256009	4107731	
45640	4024	4295880	1999-07-11	1999-07-11 00:00:00	38000275	0	\N	\N	267520	0	76601001	4295880	
45911	4032	4078793	2018-09-04	2018-09-04 00:00:00	38000275	0	\N	\N	268286	0	180325003	4078793	
34172	2970	4107731	1999-10-21	1999-10-21 00:00:00	38000275	0	\N	\N	198326	0	180256009	4107731	
34307	2975	4107731	1990-02-18	1990-02-18 00:00:00	38000275	0	\N	\N	198661	0	180256009	4107731	
34482	2986	4035793	2001-01-23	2001-01-23 00:00:00	38000275	0	\N	\N	199314	0	15081005	4035793	
46691	4094	4125906	2017-10-25	2017-10-25 00:00:00	38000275	0	\N	\N	272152	0	288086009	4125906	
34935	3041	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	202455	0	180256009	4107731	
59018	5116	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	340018	0	180256009	4107731	
35322	3083	4047491	1955-04-22	1955-04-22 00:00:00	38000275	0	\N	\N	205268	0	1225002	4047491	
47459	4167	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	276957	0	180256009	4107731	
35675	3123	4191853	1978-02-19	1978-02-19 00:00:00	38000275	0	\N	\N	207805	0	395142003	4191853	
35774	3128	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	208157	0	180256009	4107731	
23995	2087	4151422	2009-08-06	2009-08-06 00:00:00	38000275	0	\N	\N	139011	0	269911007	4151422	
36187	3176	4191853	2001-12-23	2001-12-23 00:00:00	38000275	0	\N	\N	211108	0	395142003	4191853	
24431	2135	4107731	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	142167	0	180256009	4107731	
36549	3215	4107731	2006-02-04	2006-02-04 00:00:00	38000275	0	\N	\N	213595	0	180256009	4107731	
36742	3231	4151422	1996-08-09	1996-08-09 00:00:00	38000275	0	\N	\N	214778	0	269911007	4151422	
25046	2186	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	145725	0	180256009	4107731	
37068	3258	4295880	2002-10-23	2002-10-23 00:00:00	38000275	0	\N	\N	216625	0	76601001	4295880	
37243	3272	4010253	2003-12-28	2003-12-28 00:00:00	38000275	0	\N	\N	217446	0	112790001	4010253	
37431	3296	4181917	1973-07-27	1973-07-27 00:00:00	38000275	0	\N	\N	219095	0	54550000	4181917	
37762	3342	4195803	1981-07-20	1981-07-20 00:00:00	38000275	0	\N	\N	221568	0	312681000	4195803	
25945	2272	4295880	2001-11-17	2001-11-17 00:00:00	38000275	0	\N	\N	151057	0	76601001	4295880	
37973	3353	4195803	1995-11-25	1995-11-25 00:00:00	38000275	0	\N	\N	222384	0	312681000	4195803	
38165	3367	4125906	2010-10-10	2010-10-10 00:00:00	38000275	0	\N	\N	223284	0	288086009	4125906	
38499	3382	4125906	1963-12-07	1963-12-07 00:00:00	38000275	0	\N	\N	224399	0	288086009	4125906	
38643	3399	4107731	1997-07-22	1997-07-22 00:00:00	38000275	0	\N	\N	225483	0	180256009	4107731	
26860	2349	4107731	1991-01-20	1991-01-20 00:00:00	38000275	0	\N	\N	156419	0	180256009	4107731	
27085	2366	4170947	1974-12-09	1974-12-09 00:00:00	38000275	0	\N	\N	157516	0	274474001	4170947	
39087	3446	4125906	2006-09-03	2006-09-03 00:00:00	38000275	0	\N	\N	228801	0	288086009	4125906	
39297	3464	4107731	2012-03-23	2012-03-23 00:00:00	38000275	0	\N	\N	229900	0	180256009	4107731	
27541	2402	4107731	1992-12-07	1992-12-07 00:00:00	38000275	0	\N	\N	159696	0	180256009	4107731	
39659	3486	4043071	1976-03-26	1976-03-26 00:00:00	38000275	0	\N	\N	231283	0	228557008	4043071	
28039	2462	4107731	1992-08-30	1992-08-30 00:00:00	38000275	0	\N	\N	163265	0	180256009	4107731	
40091	3518	4252419	1978-09-08	1978-09-08 00:00:00	38000275	0	\N	\N	233582	0	74016001	4252419	
40285	3529	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	234386	0	180256009	4107731	
28565	2540	4043071	1949-01-22	1949-01-22 00:00:00	38000275	0	\N	\N	167875	0	228557008	4043071	
40670	3569	4202451	1987-07-14	1987-07-14 00:00:00	38000275	0	\N	\N	237140	0	433112001	4202451	
40790	3579	4125906	2004-11-12	2004-11-12 00:00:00	38000275	0	\N	\N	237963	0	288086009	4125906	
29010	2564	4043071	1988-09-27	1988-09-27 00:00:00	38000275	0	\N	\N	169831	0	228557008	4043071	
29341	2610	4170947	1973-04-26	1973-04-26 00:00:00	38000275	0	\N	\N	172595	0	274474001	4170947	
41389	3628	4047491	1985-09-25	1985-09-25 00:00:00	38000275	0	\N	\N	241355	0	1225002	4047491	
53497	4642	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	309474	0	180256009	4107731	
41818	3680	4107731	1995-04-04	1995-04-04 00:00:00	38000275	0	\N	\N	244694	0	180256009	4107731	
41924	3695	4107731	1993-11-08	1993-11-08 00:00:00	38000275	0	\N	\N	245624	0	180256009	4107731	
42094	3714	4078793	2010-12-08	2010-12-08 00:00:00	38000275	0	\N	\N	246879	0	180325003	4078793	
42424	3744	4107731	2004-09-08	2004-09-08 00:00:00	38000275	0	\N	\N	248859	0	180256009	4107731	
30611	2711	4107731	1991-04-29	1991-04-29 00:00:00	38000275	0	\N	\N	179762	0	180256009	4107731	
30833	2731	4151422	1977-09-16	1977-09-16 00:00:00	38000275	0	\N	\N	180822	0	269911007	4151422	
42888	3783	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	251371	0	180256009	4107731	
43064	3796	4293740	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	252357	0	384700001	4293740	
31274	2770	4107731	1990-12-29	1990-12-29 00:00:00	38000275	0	\N	\N	183406	0	180256009	4107731	
31555	2779	4107731	1997-01-01	1997-01-01 00:00:00	38000275	0	\N	\N	184179	0	180256009	4107731	
43692	3865	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	256666	0	180256009	4107731	
43900	3874	4107731	1998-05-20	1998-05-20 00:00:00	38000275	0	\N	\N	257245	0	180256009	4107731	
44065	3884	4107731	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	258152	0	180256009	4107731	
20369	1762	4035793	1986-02-13	1986-02-13 00:00:00	38000275	0	\N	\N	117818	0	15081005	4035793	
56383	4922	4252419	1983-05-29	1983-05-29 00:00:00	38000275	0	\N	\N	327002	0	74016001	4252419	
44646	3913	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	260111	0	395142003	4191853	
56683	4932	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	327850	0	180256009	4107731	
33067	2898	4295880	1997-10-07	1997-10-07 00:00:00	38000275	0	\N	\N	193035	0	76601001	4295880	
33124	2898	4163872	1984-01-21	1984-01-21 00:00:00	38000275	0	\N	\N	192995	0	399208008	4163872	
33369	2917	4125906	2016-08-31	2016-08-31 00:00:00	38000275	0	\N	\N	194504	0	288086009	4125906	
57482	4976	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	331092	0	180256009	4107731	
45641	4024	4295880	1998-04-12	1998-04-12 00:00:00	38000275	0	\N	\N	267539	0	76601001	4295880	
45912	4032	4078793	2012-07-31	2012-07-31 00:00:00	38000275	0	\N	\N	268201	0	180325003	4078793	
34173	2970	4107731	2002-07-25	2002-07-25 00:00:00	38000275	0	\N	\N	198289	0	180256009	4107731	
34308	2975	4107731	1992-06-07	1992-06-07 00:00:00	38000275	0	\N	\N	198686	0	180256009	4107731	
34483	2986	4035793	2004-02-10	2004-02-10 00:00:00	38000275	0	\N	\N	199294	0	15081005	4035793	
46692	4094	4151422	2010-09-02	2010-09-02 00:00:00	38000275	0	\N	\N	272126	0	269911007	4151422	
34936	3041	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	202522	0	180256009	4107731	
59019	5116	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	339895	0	180256009	4107731	
35323	3083	4170947	1955-04-22	1955-04-22 00:00:00	38000275	0	\N	\N	205268	0	274474001	4170947	
47460	4167	4107731	1994-01-12	1994-01-12 00:00:00	38000275	0	\N	\N	276946	0	180256009	4107731	
35676	3123	4295880	2006-07-26	2006-07-26 00:00:00	38000275	0	\N	\N	207783	0	76601001	4295880	
35775	3128	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	208115	0	180256009	4107731	
23996	2087	4170947	2015-01-03	2015-01-03 00:00:00	38000275	0	\N	\N	139105	0	274474001	4170947	
36188	3176	4107731	2004-12-19	2004-12-19 00:00:00	38000275	0	\N	\N	211097	0	180256009	4107731	
24432	2135	4107731	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	142187	0	180256009	4107731	
36550	3215	4107731	2003-08-16	2003-08-16 00:00:00	38000275	0	\N	\N	213611	0	180256009	4107731	
36743	3231	4125906	1957-11-22	1957-11-22 00:00:00	38000275	0	\N	\N	214727	0	288086009	4125906	
25047	2186	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	145728	0	180256009	4107731	
37069	3258	4295880	2004-01-21	2004-01-21 00:00:00	38000275	0	\N	\N	216568	0	76601001	4295880	
37244	3272	4186930	1990-06-05	1990-06-05 00:00:00	38000275	0	\N	\N	217456	0	46706006	4186930	
37432	3296	4181917	1966-09-18	1966-09-18 00:00:00	38000275	0	\N	\N	219093	0	54550000	4181917	
37763	3342	4243062	1981-07-20	1981-07-20 00:00:00	38000275	0	\N	\N	221568	0	60027007	4243062	
25946	2272	4295880	2005-05-14	2005-05-14 00:00:00	38000275	0	\N	\N	151031	0	76601001	4295880	
37974	3353	4170947	1937-11-19	1937-11-19 00:00:00	38000275	0	\N	\N	222424	0	274474001	4170947	
38166	3370	4125906	1984-06-21	1984-06-21 00:00:00	38000275	0	\N	\N	223393	0	288086009	4125906	
38500	3382	4238715	1986-06-12	1986-06-12 00:00:00	38000275	0	\N	\N	224452	0	68254000	4238715	
38644	3399	4107731	1998-10-06	1998-10-06 00:00:00	38000275	0	\N	\N	225478	0	180256009	4107731	
26861	2349	4107731	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	156347	0	180256009	4107731	
27086	2366	4024289	1974-12-09	1974-12-09 00:00:00	38000275	0	\N	\N	157516	0	19490002	4024289	
39088	3446	4043071	1952-11-25	1952-11-25 00:00:00	38000275	0	\N	\N	228869	0	228557008	4043071	
39298	3464	4107731	2011-08-26	2011-08-26 00:00:00	38000275	0	\N	\N	229972	0	180256009	4107731	
27542	2402	4107731	1991-04-08	1991-04-08 00:00:00	38000275	0	\N	\N	159579	0	180256009	4107731	
39660	3486	4043071	1974-07-26	1974-07-26 00:00:00	38000275	0	\N	\N	231230	0	228557008	4043071	
28040	2462	4107731	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	163227	0	180256009	4107731	
40114	3526	4163872	2015-01-05	2015-01-05 00:00:00	38000275	0	\N	\N	233912	0	399208008	4163872	
40286	3529	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	234368	0	180256009	4107731	
28566	2540	4151422	1990-10-27	1990-10-27 00:00:00	38000275	0	\N	\N	167980	0	269911007	4151422	
40671	3569	4195803	2018-12-11	2018-12-11 00:00:00	38000275	0	\N	\N	237138	0	312681000	4195803	
40791	3579	4125906	1965-10-26	1965-10-26 00:00:00	38000275	0	\N	\N	237960	0	288086009	4125906	
29011	2564	4043071	1988-05-24	1988-05-24 00:00:00	38000275	0	\N	\N	169911	0	228557008	4043071	
29342	2611	4151422	1955-06-29	1955-06-29 00:00:00	38000275	0	\N	\N	172700	0	269911007	4151422	
41390	3628	4170947	1985-09-25	1985-09-25 00:00:00	38000275	0	\N	\N	241355	0	274474001	4170947	
53498	4642	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	309480	0	180256009	4107731	
41819	3680	4107731	1993-08-24	1993-08-24 00:00:00	38000275	0	\N	\N	244787	0	180256009	4107731	
41925	3695	4107731	1995-07-31	1995-07-31 00:00:00	38000275	0	\N	\N	245634	0	180256009	4107731	
42095	3714	4078793	2007-11-21	2007-11-21 00:00:00	38000275	0	\N	\N	246863	0	180325003	4078793	
42425	3744	4107731	2005-04-06	2005-04-06 00:00:00	38000275	0	\N	\N	248858	0	180256009	4107731	
30612	2711	4107731	1990-02-12	1990-02-12 00:00:00	38000275	0	\N	\N	179640	0	180256009	4107731	
30834	2731	4125906	2008-04-04	2008-04-04 00:00:00	38000275	0	\N	\N	180795	0	288086009	4125906	
42889	3783	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	251364	0	180256009	4107731	
43065	3796	4125906	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	252357	0	288086009	4125906	
31275	2770	4107731	1991-01-19	1991-01-19 00:00:00	38000275	0	\N	\N	183371	0	180256009	4107731	
31556	2779	4107731	1995-07-26	1995-07-26 00:00:00	38000275	0	\N	\N	184097	0	180256009	4107731	
43693	3865	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	256630	0	180256009	4107731	
43901	3874	4107731	1996-09-18	1996-09-18 00:00:00	38000275	0	\N	\N	257258	0	180256009	4107731	
44066	3884	4043071	1985-09-14	1985-09-14 00:00:00	38000275	0	\N	\N	258026	0	228557008	4043071	
20370	1762	4202451	2002-12-26	2002-12-26 00:00:00	38000275	0	\N	\N	117866	0	433112001	4202451	
56384	4922	4043071	1987-12-09	1987-12-09 00:00:00	38000275	0	\N	\N	327016	0	228557008	4043071	
44647	3913	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	260132	0	180256009	4107731	
56684	4932	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	327849	0	180256009	4107731	
33068	2898	4197460	1980-03-11	1980-03-11 00:00:00	38000275	0	\N	\N	192993	0	313191000	4197460	
33125	2898	4107731	1992-07-28	1992-07-28 00:00:00	38000275	0	\N	\N	193069	0	180256009	4107731	
33370	2917	4078793	2002-11-27	2002-11-27 00:00:00	38000275	0	\N	\N	194491	0	180325003	4078793	
57483	4976	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	331099	0	180256009	4107731	
45642	4024	4295880	1996-01-14	1996-01-14 00:00:00	38000275	0	\N	\N	267536	0	76601001	4295880	
45913	4032	4078793	2014-08-12	2014-08-12 00:00:00	38000275	0	\N	\N	268270	0	180325003	4078793	
34174	2970	4107731	2002-01-17	2002-01-17 00:00:00	38000275	0	\N	\N	198299	0	180256009	4107731	
34309	2975	4107731	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	198596	0	180256009	4107731	
34484	2986	4035793	2008-03-04	2008-03-04 00:00:00	38000275	0	\N	\N	199296	0	15081005	4035793	
46693	4094	4058899	1959-09-02	1959-09-02 00:00:00	38000275	0	\N	\N	272189	0	168594001	4058899	
34937	3041	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	202428	0	180256009	4107731	
59020	5116	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	339904	0	180256009	4107731	
35324	3083	4125906	1997-02-15	1997-02-15 00:00:00	38000275	0	\N	\N	205351	0	288086009	4125906	
47461	4167	4107731	1993-10-20	1993-10-20 00:00:00	38000275	0	\N	\N	276944	0	180256009	4107731	
35677	3123	4295880	2007-07-25	2007-07-25 00:00:00	38000275	0	\N	\N	207848	0	76601001	4295880	
35776	3128	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	208205	0	180256009	4107731	
23997	2087	4047491	2015-01-03	2015-01-03 00:00:00	38000275	0	\N	\N	139105	0	1225002	4047491	
36189	3176	4107731	2004-08-15	2004-08-15 00:00:00	38000275	0	\N	\N	211217	0	180256009	4107731	
24433	2135	4107731	1991-09-02	1991-09-02 00:00:00	38000275	0	\N	\N	142191	0	180256009	4107731	
36551	3215	4107731	2006-03-18	2006-03-18 00:00:00	38000275	0	\N	\N	213596	0	180256009	4107731	
36744	3231	4151422	1966-04-16	1966-04-16 00:00:00	38000275	0	\N	\N	214770	0	269911007	4151422	
25048	2186	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	145801	0	180256009	4107731	
37070	3258	4295880	2004-10-20	2004-10-20 00:00:00	38000275	0	\N	\N	216564	0	76601001	4295880	
37250	3275	4151422	1973-10-30	1973-10-30 00:00:00	38000275	0	\N	\N	217629	0	269911007	4151422	
37433	3296	4195803	2019-02-08	2019-02-08 00:00:00	38000275	0	\N	\N	219097	0	312681000	4195803	
37764	3342	4170947	1981-07-20	1981-07-20 00:00:00	38000275	0	\N	\N	221568	0	274474001	4170947	
25947	2272	4295880	2002-02-16	2002-02-16 00:00:00	38000275	0	\N	\N	151005	0	76601001	4295880	
37975	3353	4024289	1937-11-19	1937-11-19 00:00:00	38000275	0	\N	\N	222424	0	19490002	4024289	
38167	3370	4107731	1990-04-01	1990-04-01 00:00:00	38000275	0	\N	\N	223429	0	180256009	4107731	
38501	3383	4295880	2011-02-24	2011-02-24 00:00:00	38000275	0	\N	\N	224529	0	76601001	4295880	
38645	3399	4107731	1997-09-23	1997-09-23 00:00:00	38000275	0	\N	\N	225519	0	180256009	4107731	
26862	2349	4107731	1990-06-03	1990-06-03 00:00:00	38000275	0	\N	\N	156417	0	180256009	4107731	
27087	2367	4163872	1986-09-20	1986-09-20 00:00:00	38000275	0	\N	\N	157550	0	399208008	4163872	
39089	3446	4043071	1952-05-27	1952-05-27 00:00:00	38000275	0	\N	\N	228803	0	228557008	4043071	
39299	3464	4107731	2010-11-05	2010-11-05 00:00:00	38000275	0	\N	\N	229911	0	180256009	4107731	
27543	2402	4197460	1990-08-31	1990-08-31 00:00:00	38000275	0	\N	\N	159672	0	313191000	4197460	
39661	3486	4043071	1975-10-17	1975-10-17 00:00:00	38000275	0	\N	\N	231211	0	228557008	4043071	
28041	2462	4107731	1991-06-16	1991-06-16 00:00:00	38000275	0	\N	\N	163255	0	180256009	4107731	
40115	3526	4170947	1972-08-17	1972-08-17 00:00:00	38000275	0	\N	\N	234003	0	274474001	4170947	
40287	3529	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	234383	0	180256009	4107731	
28567	2540	4043071	1948-09-11	1948-09-11 00:00:00	38000275	0	\N	\N	167933	0	228557008	4043071	
40672	3569	4125906	1966-01-26	1966-01-26 00:00:00	38000275	0	\N	\N	237186	0	288086009	4125906	
40792	3580	4170947	1989-05-15	1989-05-15 00:00:00	38000275	0	\N	\N	237966	0	274474001	4170947	
29012	2564	4043071	1986-10-21	1986-10-21 00:00:00	38000275	0	\N	\N	169825	0	228557008	4043071	
29343	2611	4125906	2016-08-27	2016-08-27 00:00:00	38000275	0	\N	\N	172655	0	288086009	4125906	
41391	3628	4125906	1987-09-15	1987-09-15 00:00:00	38000275	0	\N	\N	241356	0	288086009	4125906	
53499	4642	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	309395	0	180256009	4107731	
41820	3680	4107731	1993-10-26	1993-10-26 00:00:00	38000275	0	\N	\N	244763	0	180256009	4107731	
41926	3695	4107731	1996-02-26	1996-02-26 00:00:00	38000275	0	\N	\N	245579	0	180256009	4107731	
42096	3714	4057420	2008-11-26	2008-11-26 00:00:00	38000275	0	\N	\N	246878	0	18286008	4057420	
42426	3744	4107731	2005-01-12	2005-01-12 00:00:00	38000275	0	\N	\N	248856	0	180256009	4107731	
30613	2711	4151422	1972-05-18	1972-05-18 00:00:00	38000275	0	\N	\N	179775	0	269911007	4151422	
30835	2732	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	180897	0	180256009	4107731	
42890	3783	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	251403	0	180256009	4107731	
43066	3796	4151422	2010-08-18	2010-08-18 00:00:00	38000275	0	\N	\N	252412	0	269911007	4151422	
31276	2770	4107731	1990-10-27	1990-10-27 00:00:00	38000275	0	\N	\N	183395	0	180256009	4107731	
31557	2779	4107731	1997-12-24	1997-12-24 00:00:00	38000275	0	\N	\N	184154	0	180256009	4107731	
43694	3865	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	256628	0	180256009	4107731	
43902	3874	4107731	1997-09-10	1997-09-10 00:00:00	38000275	0	\N	\N	257266	0	180256009	4107731	
44067	3884	4107731	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	258181	0	180256009	4107731	
20371	1762	4035793	2005-02-17	2005-02-17 00:00:00	38000275	0	\N	\N	117829	0	15081005	4035793	
56385	4922	4043071	1988-07-20	1988-07-20 00:00:00	38000275	0	\N	\N	327077	0	228557008	4043071	
44648	3913	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	260133	0	180256009	4107731	
56685	4932	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	327902	0	180256009	4107731	
33069	2898	4107731	1993-05-18	1993-05-18 00:00:00	38000275	0	\N	\N	193045	0	180256009	4107731	
33126	2898	4107731	1994-05-10	1994-05-10 00:00:00	38000275	0	\N	\N	193092	0	180256009	4107731	
33371	2917	4078793	2014-01-29	2014-01-29 00:00:00	38000275	0	\N	\N	194501	0	180325003	4078793	
57484	4976	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	331097	0	180256009	4107731	
45643	4024	4295880	1997-04-13	1997-04-13 00:00:00	38000275	0	\N	\N	267571	0	76601001	4295880	
45914	4032	4047491	1961-01-18	1961-01-18 00:00:00	38000275	0	\N	\N	268267	0	1225002	4047491	
34175	2970	4107731	2002-05-23	2002-05-23 00:00:00	38000275	0	\N	\N	198382	0	180256009	4107731	
34310	2975	4163872	2004-04-06	2004-04-06 00:00:00	38000275	0	\N	\N	198643	0	399208008	4163872	
34485	2986	4035793	2015-04-14	2015-04-14 00:00:00	38000275	0	\N	\N	199325	0	15081005	4035793	
46700	4100	4202451	2008-08-27	2008-08-27 00:00:00	38000275	0	\N	\N	272433	0	433112001	4202451	
34938	3041	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	202430	0	180256009	4107731	
59021	5116	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	339907	0	180256009	4107731	
35325	3083	4125906	1969-09-05	1969-09-05 00:00:00	38000275	0	\N	\N	205270	0	288086009	4125906	
47462	4167	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	277006	0	180256009	4107731	
35678	3123	4295880	2008-10-22	2008-10-22 00:00:00	38000275	0	\N	\N	207852	0	76601001	4295880	
35777	3128	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	208129	0	180256009	4107731	
23998	2087	4058899	1927-09-23	1927-09-23 00:00:00	38000275	0	\N	\N	139099	0	168594001	4058899	
36190	3176	4107731	2005-01-30	2005-01-30 00:00:00	38000275	0	\N	\N	211187	0	180256009	4107731	
24434	2135	4107731	1990-05-07	1990-05-07 00:00:00	38000275	0	\N	\N	142165	0	180256009	4107731	
36552	3215	4107731	2004-04-03	2004-04-03 00:00:00	38000275	0	\N	\N	213613	0	180256009	4107731	
36745	3231	4198190	1983-10-09	1983-10-09 00:00:00	38000275	0	\N	\N	214795	0	80146002	4198190	
25049	2186	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	145780	0	180256009	4107731	
37071	3258	4295880	2002-07-24	2002-07-24 00:00:00	38000275	0	\N	\N	216566	0	76601001	4295880	
37251	3275	4125906	1985-10-25	1985-10-25 00:00:00	38000275	0	\N	\N	217603	0	288086009	4125906	
37434	3296	4058899	2019-02-08	2019-02-08 00:00:00	38000275	0	\N	\N	219097	0	168594001	4058899	
37765	3342	4151422	1938-11-26	1938-11-26 00:00:00	38000275	0	\N	\N	221561	0	269911007	4151422	
25948	2272	4295880	1998-11-21	1998-11-21 00:00:00	38000275	0	\N	\N	151052	0	76601001	4295880	
37976	3353	4125906	1983-12-19	1983-12-19 00:00:00	38000275	0	\N	\N	222450	0	288086009	4125906	
38168	3370	4107731	1990-12-30	1990-12-30 00:00:00	38000275	0	\N	\N	223432	0	180256009	4107731	
38502	3383	4295880	2011-11-24	2011-11-24 00:00:00	38000275	0	\N	\N	224530	0	76601001	4295880	
38646	3399	4107731	1998-07-14	1998-07-14 00:00:00	38000275	0	\N	\N	225476	0	180256009	4107731	
26863	2349	4107731	1990-10-07	1990-10-07 00:00:00	38000275	0	\N	\N	156395	0	180256009	4107731	
27088	2369	4107731	1996-10-06	1996-10-06 00:00:00	38000275	0	\N	\N	157703	0	180256009	4107731	
39090	3446	4151422	2015-10-04	2015-10-04 00:00:00	38000275	0	\N	\N	228768	0	269911007	4151422	
39300	3464	4107731	2011-10-28	2011-10-28 00:00:00	38000275	0	\N	\N	229916	0	180256009	4107731	
27544	2402	4107731	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	159580	0	180256009	4107731	
39662	3486	4043071	1974-02-22	1974-02-22 00:00:00	38000275	0	\N	\N	231229	0	228557008	4043071	
28042	2462	4107731	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	163234	0	180256009	4107731	
40116	3526	4163872	1972-08-17	1972-08-17 00:00:00	38000275	0	\N	\N	234003	0	399208008	4163872	
40288	3529	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	234374	0	180256009	4107731	
28568	2540	4125906	1953-11-28	1953-11-28 00:00:00	38000275	0	\N	\N	167984	0	288086009	4125906	
40673	3570	4151422	1957-01-16	1957-01-16 00:00:00	38000275	0	\N	\N	237287	0	269911007	4151422	
40793	3580	4163872	1989-05-15	1989-05-15 00:00:00	38000275	0	\N	\N	237966	0	399208008	4163872	
29013	2564	4043071	1986-11-25	1986-11-25 00:00:00	38000275	0	\N	\N	169820	0	228557008	4043071	
29346	2613	4163872	1957-10-01	1957-10-01 00:00:00	38000275	0	\N	\N	172763	0	399208008	4163872	
41392	3628	4151422	1926-09-11	1926-09-11 00:00:00	38000275	0	\N	\N	241404	0	269911007	4151422	
53500	4642	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	309487	0	180256009	4107731	
41821	3680	4107731	1995-01-31	1995-01-31 00:00:00	38000275	0	\N	\N	244699	0	180256009	4107731	
41927	3695	4107731	1993-03-01	1993-03-01 00:00:00	38000275	0	\N	\N	245569	0	180256009	4107731	
42097	3714	4170947	1937-01-20	1937-01-20 00:00:00	38000275	0	\N	\N	246844	0	274474001	4170947	
42427	3744	4107731	2005-06-08	2005-06-08 00:00:00	38000275	0	\N	\N	248778	0	180256009	4107731	
30614	2711	4107731	1991-11-25	1991-11-25 00:00:00	38000275	0	\N	\N	179660	0	180256009	4107731	
30836	2732	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	180855	0	180256009	4107731	
42891	3783	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	251329	0	180256009	4107731	
43067	3796	4125906	1986-05-22	1986-05-22 00:00:00	38000275	0	\N	\N	252356	0	288086009	4125906	
31277	2770	4107731	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	183296	0	180256009	4107731	
31558	2779	4047491	2006-02-07	2006-02-07 00:00:00	38000275	0	\N	\N	184100	0	1225002	4047491	
43695	3865	4058899	1969-06-20	1969-06-20 00:00:00	38000275	0	\N	\N	256555	0	168594001	4058899	
43903	3874	4107731	1997-10-01	1997-10-01 00:00:00	38000275	0	\N	\N	257280	0	180256009	4107731	
44068	3884	4043071	1987-06-13	1987-06-13 00:00:00	38000275	0	\N	\N	258086	0	228557008	4043071	
20372	1762	4057420	2005-02-17	2005-02-17 00:00:00	38000275	0	\N	\N	117829	0	18286008	4057420	
56386	4922	4043071	1986-07-16	1986-07-16 00:00:00	38000275	0	\N	\N	326978	0	228557008	4043071	
44649	3913	4125906	1996-10-19	1996-10-19 00:00:00	38000275	0	\N	\N	260087	0	288086009	4125906	
56686	4932	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	327853	0	180256009	4107731	
33070	2898	4107731	1994-01-25	1994-01-25 00:00:00	38000275	0	\N	\N	192968	0	180256009	4107731	
33127	2898	4295880	1995-07-11	1995-07-11 00:00:00	38000275	0	\N	\N	193032	0	76601001	4295880	
33372	2917	4078793	2013-01-23	2013-01-23 00:00:00	38000275	0	\N	\N	194480	0	180325003	4078793	
57485	4976	4107731	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	330947	0	180256009	4107731	
45644	4024	4295880	1997-10-12	1997-10-12 00:00:00	38000275	0	\N	\N	267549	0	76601001	4295880	
45915	4032	4170947	1961-01-18	1961-01-18 00:00:00	38000275	0	\N	\N	268267	0	274474001	4170947	
34176	2970	4107731	2000-10-12	2000-10-12 00:00:00	38000275	0	\N	\N	198310	0	180256009	4107731	
34311	2975	4107731	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	198640	0	180256009	4107731	
34486	2986	4035793	1995-10-17	1995-10-17 00:00:00	38000275	0	\N	\N	199312	0	15081005	4035793	
46701	4101	4151422	1978-05-24	1978-05-24 00:00:00	38000275	0	\N	\N	272515	0	269911007	4151422	
34939	3041	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	202471	0	180256009	4107731	
59022	5116	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	339899	0	395142003	4191853	
35326	3083	4047491	2013-02-19	2013-02-19 00:00:00	38000275	0	\N	\N	205353	0	1225002	4047491	
47463	4167	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	276910	0	180256009	4107731	
35679	3123	4295880	2005-01-26	2005-01-26 00:00:00	38000275	0	\N	\N	207781	0	76601001	4295880	
35778	3129	4170947	2008-08-31	2008-08-31 00:00:00	38000275	0	\N	\N	208249	0	274474001	4170947	
23999	2087	4151422	1936-09-15	1936-09-15 00:00:00	38000275	0	\N	\N	139026	0	269911007	4151422	
36191	3176	4107731	2005-04-03	2005-04-03 00:00:00	38000275	0	\N	\N	211219	0	180256009	4107731	
24435	2136	4107731	2004-12-03	2004-12-03 00:00:00	38000275	0	\N	\N	142293	0	180256009	4107731	
36553	3215	4107731	2004-10-09	2004-10-09 00:00:00	38000275	0	\N	\N	213650	0	180256009	4107731	
36746	3231	4301346	1989-04-06	1989-04-06 00:00:00	38000275	0	\N	\N	214794	0	387685009	4301346	
25050	2186	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	145733	0	180256009	4107731	
37072	3258	4295880	2005-07-20	2005-07-20 00:00:00	38000275	0	\N	\N	216591	0	76601001	4295880	
37252	3275	4243062	1973-09-28	1973-09-28 00:00:00	38000275	0	\N	\N	217602	0	60027007	4243062	
37435	3296	4195803	2016-02-24	2016-02-24 00:00:00	38000275	0	\N	\N	219096	0	312681000	4195803	
37766	3342	4170947	1979-07-01	1979-07-01 00:00:00	38000275	0	\N	\N	221567	0	274474001	4170947	
25949	2272	4295880	1996-02-24	1996-02-24 00:00:00	38000275	0	\N	\N	151016	0	76601001	4295880	
37977	3353	4058899	1971-06-20	1971-06-20 00:00:00	38000275	0	\N	\N	222448	0	168594001	4058899	
38169	3370	4107731	1990-11-18	1990-11-18 00:00:00	38000275	0	\N	\N	223431	0	180256009	4107731	
38503	3383	4295880	2010-08-26	2010-08-26 00:00:00	38000275	0	\N	\N	224486	0	76601001	4295880	
38647	3399	4107731	1998-03-09	1998-03-09 00:00:00	38000275	0	\N	\N	225532	0	180256009	4107731	
26864	2349	4191853	1990-01-07	1990-01-07 00:00:00	38000275	0	\N	\N	156377	0	395142003	4191853	
27089	2369	4107731	1997-09-28	1997-09-28 00:00:00	38000275	0	\N	\N	157654	0	180256009	4107731	
39091	3446	4043071	1953-03-03	1953-03-03 00:00:00	38000275	0	\N	\N	228846	0	228557008	4043071	
39301	3464	4107731	2011-06-03	2011-06-03 00:00:00	38000275	0	\N	\N	229937	0	180256009	4107731	
27545	2402	4107731	1992-11-16	1992-11-16 00:00:00	38000275	0	\N	\N	159685	0	180256009	4107731	
39667	3488	4035793	2011-03-18	2011-03-18 00:00:00	38000275	0	\N	\N	231371	0	15081005	4035793	
28043	2462	4107731	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	163219	0	180256009	4107731	
40117	3526	4151422	1994-03-07	1994-03-07 00:00:00	38000275	0	\N	\N	233954	0	269911007	4151422	
40289	3529	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	234321	0	180256009	4107731	
28569	2540	4043071	1948-06-05	1948-06-05 00:00:00	38000275	0	\N	\N	167889	0	228557008	4043071	
40674	3570	4293740	1966-12-06	1966-12-06 00:00:00	38000275	0	\N	\N	237225	0	384700001	4293740	
40794	3580	4125906	1986-04-10	1986-04-10 00:00:00	38000275	0	\N	\N	237965	0	288086009	4125906	
29014	2564	4043071	1987-02-03	1987-02-03 00:00:00	38000275	0	\N	\N	169822	0	228557008	4043071	
29347	2613	4125906	1974-10-14	1974-10-14 00:00:00	38000275	0	\N	\N	172817	0	288086009	4125906	
41393	3629	4125906	1992-03-02	1992-03-02 00:00:00	38000275	0	\N	\N	241473	0	288086009	4125906	
53501	4642	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	309477	0	180256009	4107731	
41822	3680	4107731	1992-07-21	1992-07-21 00:00:00	38000275	0	\N	\N	244781	0	180256009	4107731	
41928	3695	4107731	1996-03-18	1996-03-18 00:00:00	38000275	0	\N	\N	245590	0	180256009	4107731	
42098	3714	4024289	1937-01-20	1937-01-20 00:00:00	38000275	0	\N	\N	246844	0	19490002	4024289	
42428	3744	4107731	2006-03-08	2006-03-08 00:00:00	38000275	0	\N	\N	248781	0	180256009	4107731	
30615	2711	4107731	1992-08-03	1992-08-03 00:00:00	38000275	0	\N	\N	179678	0	180256009	4107731	
30837	2732	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	180840	0	180256009	4107731	
42892	3783	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	251437	0	180256009	4107731	
43068	3796	4058899	2003-08-26	2003-08-26 00:00:00	38000275	0	\N	\N	252358	0	168594001	4058899	
31278	2770	4107731	1991-05-25	1991-05-25 00:00:00	38000275	0	\N	\N	183283	0	180256009	4107731	
31559	2779	4170947	2006-02-07	2006-02-07 00:00:00	38000275	0	\N	\N	184100	0	274474001	4170947	
43696	3865	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	256625	0	180256009	4107731	
43904	3875	4195803	2018-07-14	2018-07-14 00:00:00	38000275	0	\N	\N	257341	0	312681000	4195803	
44069	3884	4043071	1985-03-30	1985-03-30 00:00:00	38000275	0	\N	\N	258179	0	228557008	4043071	
20373	1762	4035793	2004-02-12	2004-02-12 00:00:00	38000275	0	\N	\N	117856	0	15081005	4035793	
56387	4922	4043071	1987-07-29	1987-07-29 00:00:00	38000275	0	\N	\N	327074	0	228557008	4043071	
44650	3913	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	260148	0	180256009	4107731	
56687	4932	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	327888	0	180256009	4107731	
33071	2898	4295880	1994-07-12	1994-07-12 00:00:00	38000275	0	\N	\N	193057	0	76601001	4295880	
33128	2898	4107731	1993-04-06	1993-04-06 00:00:00	38000275	0	\N	\N	193012	0	180256009	4107731	
33373	2917	4078793	2008-12-31	2008-12-31 00:00:00	38000275	0	\N	\N	194443	0	180325003	4078793	
57486	4976	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	331055	0	180256009	4107731	
45645	4024	4295880	1998-10-11	1998-10-11 00:00:00	38000275	0	\N	\N	267574	0	76601001	4295880	
45916	4033	4330583	2003-10-20	2003-10-20 00:00:00	38000275	0	\N	\N	268373	0	22523008	4330583	
34177	2970	4107731	1999-07-08	1999-07-08 00:00:00	38000275	0	\N	\N	198351	0	180256009	4107731	
34312	2975	4107731	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	198608	0	180256009	4107731	
34487	2986	4035793	2017-04-25	2017-04-25 00:00:00	38000275	0	\N	\N	199344	0	15081005	4035793	
46702	4101	4181917	1960-02-27	1960-02-27 00:00:00	38000275	0	\N	\N	272468	0	54550000	4181917	
34940	3041	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	202474	0	180256009	4107731	
59023	5116	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	339909	0	180256009	4107731	
35327	3083	4170947	2013-02-19	2013-02-19 00:00:00	38000275	0	\N	\N	205353	0	274474001	4170947	
47464	4167	4107731	1993-12-01	1993-12-01 00:00:00	38000275	0	\N	\N	276945	0	180256009	4107731	
35680	3123	4295880	2006-01-25	2006-01-25 00:00:00	38000275	0	\N	\N	207802	0	76601001	4295880	
35779	3129	4024289	2008-08-31	2008-08-31 00:00:00	38000275	0	\N	\N	208249	0	19490002	4024289	
24000	2087	4151422	1923-08-16	1923-08-16 00:00:00	38000275	0	\N	\N	139038	0	269911007	4151422	
36192	3176	4107731	2004-06-13	2004-06-13 00:00:00	38000275	0	\N	\N	211185	0	180256009	4107731	
24436	2136	4107731	2004-05-28	2004-05-28 00:00:00	38000275	0	\N	\N	142211	0	180256009	4107731	
36554	3215	4107731	2004-04-24	2004-04-24 00:00:00	38000275	0	\N	\N	213659	0	180256009	4107731	
36747	3232	4125906	1983-11-21	1983-11-21 00:00:00	38000275	0	\N	\N	214858	0	288086009	4125906	
25051	2186	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	145802	0	180256009	4107731	
37073	3258	4170947	1994-06-14	1994-06-14 00:00:00	38000275	0	\N	\N	216550	0	274474001	4170947	
37253	3275	4170947	1973-09-28	1973-09-28 00:00:00	38000275	0	\N	\N	217602	0	274474001	4170947	
37436	3296	4058899	2016-02-24	2016-02-24 00:00:00	38000275	0	\N	\N	219096	0	168594001	4058899	
37767	3342	4243062	1979-07-01	1979-07-01 00:00:00	38000275	0	\N	\N	221567	0	60027007	4243062	
25950	2272	4295880	1998-08-22	1998-08-22 00:00:00	38000275	0	\N	\N	151065	0	76601001	4295880	
37978	3353	4151422	2012-06-20	2012-06-20 00:00:00	38000275	0	\N	\N	222359	0	269911007	4151422	
38170	3370	4107731	1992-02-02	1992-02-02 00:00:00	38000275	0	\N	\N	223420	0	180256009	4107731	
38504	3383	4295880	2011-05-26	2011-05-26 00:00:00	38000275	0	\N	\N	224488	0	76601001	4295880	
38648	3399	4107731	1996-11-11	1996-11-11 00:00:00	38000275	0	\N	\N	225515	0	180256009	4107731	
26865	2349	4107731	1992-06-07	1992-06-07 00:00:00	38000275	0	\N	\N	156346	0	180256009	4107731	
27090	2369	4107731	1996-09-15	1996-09-15 00:00:00	38000275	0	\N	\N	157715	0	180256009	4107731	
39092	3446	4198190	1953-12-12	1953-12-12 00:00:00	38000275	0	\N	\N	228775	0	80146002	4198190	
39302	3464	4107731	2009-12-04	2009-12-04 00:00:00	38000275	0	\N	\N	229961	0	180256009	4107731	
27546	2402	4107731	1990-04-16	1990-04-16 00:00:00	38000275	0	\N	\N	159588	0	180256009	4107731	
39668	3488	4035793	2012-03-23	2012-03-23 00:00:00	38000275	0	\N	\N	231425	0	15081005	4035793	
28044	2463	4243062	1970-03-06	1970-03-06 00:00:00	38000275	0	\N	\N	163396	0	60027007	4243062	
40118	3526	4047491	2000-11-09	2000-11-09 00:00:00	38000275	0	\N	\N	234005	0	1225002	4047491	
40290	3529	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	234406	0	180256009	4107731	
28570	2540	4043071	1949-04-23	1949-04-23 00:00:00	38000275	0	\N	\N	167965	0	228557008	4043071	
40675	3570	4125906	1966-12-06	1966-12-06 00:00:00	38000275	0	\N	\N	237225	0	288086009	4125906	
40795	3580	4151422	2003-02-25	2003-02-25 00:00:00	38000275	0	\N	\N	238000	0	269911007	4151422	
29015	2564	4043071	1987-04-07	1987-04-07 00:00:00	38000275	0	\N	\N	169901	0	228557008	4043071	
29348	2613	4125906	1958-11-23	1958-11-23 00:00:00	38000275	0	\N	\N	172816	0	288086009	4125906	
41394	3629	4293740	1992-03-02	1992-03-02 00:00:00	38000275	0	\N	\N	241473	0	384700001	4293740	
53502	4642	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	309368	0	180256009	4107731	
41823	3680	4107731	1993-12-07	1993-12-07 00:00:00	38000275	0	\N	\N	244764	0	180256009	4107731	
41929	3695	4191853	1981-06-13	1981-06-13 00:00:00	38000275	0	\N	\N	245609	0	395142003	4191853	
42099	3714	4057420	2009-12-02	2009-12-02 00:00:00	38000275	0	\N	\N	246864	0	18286008	4057420	
42429	3744	4107731	2004-06-16	2004-06-16 00:00:00	38000275	0	\N	\N	248802	0	180256009	4107731	
30616	2711	4107731	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	179751	0	180256009	4107731	
30838	2732	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	180944	0	180256009	4107731	
42893	3783	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	251348	0	180256009	4107731	
43069	3796	4151422	2019-03-11	2019-03-11 00:00:00	38000275	0	\N	\N	252380	0	269911007	4151422	
31279	2770	4107731	1990-04-21	1990-04-21 00:00:00	38000275	0	\N	\N	183368	0	180256009	4107731	
31560	2779	4107731	1997-01-22	1997-01-22 00:00:00	38000275	0	\N	\N	184166	0	180256009	4107731	
43697	3865	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	256654	0	180256009	4107731	
43905	3875	4151422	1982-02-09	1982-02-09 00:00:00	38000275	0	\N	\N	257395	0	269911007	4151422	
44070	3884	4043071	1988-03-19	1988-03-19 00:00:00	38000275	0	\N	\N	258087	0	228557008	4043071	
20374	1762	4078793	2004-02-12	2004-02-12 00:00:00	38000275	0	\N	\N	117856	0	180325003	4078793	
56388	4922	4043071	1985-10-30	1985-10-30 00:00:00	38000275	0	\N	\N	326989	0	228557008	4043071	
44651	3913	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	260168	0	180256009	4107731	
56688	4932	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	327870	0	180256009	4107731	
33072	2898	4107731	1992-04-14	1992-04-14 00:00:00	38000275	0	\N	\N	193007	0	180256009	4107731	
33129	2898	4295880	1995-10-10	1995-10-10 00:00:00	38000275	0	\N	\N	193085	0	76601001	4295880	
33374	2917	4057420	1996-10-23	1996-10-23 00:00:00	38000275	0	\N	\N	194506	0	18286008	4057420	
57487	4976	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	331069	0	180256009	4107731	
45646	4026	4062501	1960-02-02	1960-02-02 00:00:00	38000275	0	\N	\N	267729	0	171231001	4062501	
45917	4033	4043071	1980-08-07	1980-08-07 00:00:00	38000275	0	\N	\N	268303	0	228557008	4043071	
34178	2970	4107731	2001-05-10	2001-05-10 00:00:00	38000275	0	\N	\N	198362	0	180256009	4107731	
34313	2975	4107731	1990-09-16	1990-09-16 00:00:00	38000275	0	\N	\N	198571	0	180256009	4107731	
34488	2986	4035793	2018-05-01	2018-05-01 00:00:00	38000275	0	\N	\N	199306	0	15081005	4035793	
46703	4101	4125906	1987-12-30	1987-12-30 00:00:00	38000275	0	\N	\N	272524	0	288086009	4125906	
34941	3041	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	202466	0	180256009	4107731	
59024	5116	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	339894	0	180256009	4107731	
35328	3083	4195803	2013-02-19	2013-02-19 00:00:00	38000275	0	\N	\N	205353	0	312681000	4195803	
47465	4167	4191853	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	276909	0	395142003	4191853	
35681	3123	4295880	2011-01-19	2011-01-19 00:00:00	38000275	0	\N	\N	207788	0	76601001	4295880	
35780	3129	4170947	1998-03-27	1998-03-27 00:00:00	38000275	0	\N	\N	208248	0	274474001	4170947	
24001	2087	4151422	2004-01-20	2004-01-20 00:00:00	38000275	0	\N	\N	139049	0	269911007	4151422	
36193	3176	4107731	2004-02-08	2004-02-08 00:00:00	38000275	0	\N	\N	211093	0	180256009	4107731	
24437	2136	4107731	2003-06-27	2003-06-27 00:00:00	38000275	0	\N	\N	142246	0	180256009	4107731	
36555	3215	4107731	2005-03-05	2005-03-05 00:00:00	38000275	0	\N	\N	213663	0	180256009	4107731	
36748	3232	4202451	2019-04-29	2019-04-29 00:00:00	38000275	0	\N	\N	214846	0	433112001	4202451	
25052	2186	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	145760	0	180256009	4107731	
37074	3258	4047491	1994-06-14	1994-06-14 00:00:00	38000275	0	\N	\N	216550	0	1225002	4047491	
37254	3277	4170947	1997-10-25	1997-10-25 00:00:00	38000275	0	\N	\N	217692	0	274474001	4170947	
37437	3296	4151422	1944-05-17	1944-05-17 00:00:00	38000275	0	\N	\N	219062	0	269911007	4151422	
37768	3342	4195803	1979-07-01	1979-07-01 00:00:00	38000275	0	\N	\N	221567	0	312681000	4195803	
25951	2272	4295880	2004-05-15	2004-05-15 00:00:00	38000275	0	\N	\N	151080	0	76601001	4295880	
37979	3353	4151422	1933-03-03	1933-03-03 00:00:00	38000275	0	\N	\N	222389	0	269911007	4151422	
38171	3370	4107731	1991-09-08	1991-09-08 00:00:00	38000275	0	\N	\N	223499	0	180256009	4107731	
38505	3383	4170947	1988-04-06	1988-04-06 00:00:00	38000275	0	\N	\N	224491	0	274474001	4170947	
38649	3399	4191853	1983-12-17	1983-12-17 00:00:00	38000275	0	\N	\N	225486	0	395142003	4191853	
26866	2349	4170947	1987-02-09	1987-02-09 00:00:00	38000275	0	\N	\N	156412	0	274474001	4170947	
27091	2369	4062501	1984-05-09	1984-05-09 00:00:00	38000275	0	\N	\N	157672	0	171231001	4062501	
39093	3446	4043071	1953-05-26	1953-05-26 00:00:00	38000275	0	\N	\N	228834	0	228557008	4043071	
39303	3464	4107731	2009-11-13	2009-11-13 00:00:00	38000275	0	\N	\N	230001	0	180256009	4107731	
27547	2402	4107731	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	159688	0	180256009	4107731	
39669	3488	4035793	2019-05-03	2019-05-03 00:00:00	38000275	0	\N	\N	231402	0	15081005	4035793	
28045	2463	4170947	1970-03-06	1970-03-06 00:00:00	38000275	0	\N	\N	163396	0	274474001	4170947	
40119	3526	4170947	2000-11-09	2000-11-09 00:00:00	38000275	0	\N	\N	234005	0	274474001	4170947	
40291	3529	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	234378	0	180256009	4107731	
28571	2540	4043071	1948-03-13	1948-03-13 00:00:00	38000275	0	\N	\N	167872	0	228557008	4043071	
40676	3570	4125906	1980-09-14	1980-09-14 00:00:00	38000275	0	\N	\N	237226	0	288086009	4125906	
40808	3582	4035793	2015-07-19	2015-07-19 00:00:00	38000275	0	\N	\N	238153	0	15081005	4035793	
29016	2564	4043071	1986-09-16	1986-09-16 00:00:00	38000275	0	\N	\N	169824	0	228557008	4043071	
29349	2613	4198190	2003-05-03	2003-05-03 00:00:00	38000275	0	\N	\N	172819	0	80146002	4198190	
41395	3629	44783196	1973-05-27	1973-05-27 00:00:00	38000275	0	\N	\N	241433	0	699253003	44783196	
53503	4642	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	309366	0	180256009	4107731	
41824	3680	4107731	1993-05-11	1993-05-11 00:00:00	38000275	0	\N	\N	244750	0	180256009	4107731	
41930	3695	4107731	1994-04-25	1994-04-25 00:00:00	38000275	0	\N	\N	245671	0	180256009	4107731	
42100	3714	4195803	2007-02-18	2007-02-18 00:00:00	38000275	0	\N	\N	246787	0	312681000	4195803	
42430	3744	4107731	2006-05-10	2006-05-10 00:00:00	38000275	0	\N	\N	248777	0	180256009	4107731	
30617	2711	4107731	1991-12-16	1991-12-16 00:00:00	38000275	0	\N	\N	179676	0	180256009	4107731	
30839	2732	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	180832	0	180256009	4107731	
42894	3783	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	251370	0	395142003	4191853	
43102	3799	4125906	1982-08-11	1982-08-11 00:00:00	38000275	0	\N	\N	252528	0	288086009	4125906	
31280	2770	4107731	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	183349	0	180256009	4107731	
31561	2779	4107731	1996-09-18	1996-09-18 00:00:00	38000275	0	\N	\N	184118	0	180256009	4107731	
43698	3865	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	256644	0	180256009	4107731	
43906	3875	4125906	1971-06-04	1971-06-04 00:00:00	38000275	0	\N	\N	257379	0	288086009	4125906	
44071	3884	4107731	1991-12-16	1991-12-16 00:00:00	38000275	0	\N	\N	258210	0	180256009	4107731	
20375	1762	4035793	2018-05-03	2018-05-03 00:00:00	38000275	0	\N	\N	117835	0	15081005	4035793	
56389	4922	4043071	1985-09-25	1985-09-25 00:00:00	38000275	0	\N	\N	326988	0	228557008	4043071	
44654	3916	4243062	2003-07-23	2003-07-23 00:00:00	38000275	0	\N	\N	260438	0	60027007	4243062	
56689	4932	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	327822	0	180256009	4107731	
33073	2898	4107731	1994-07-12	1994-07-12 00:00:00	38000275	0	\N	\N	193057	0	180256009	4107731	
33130	2898	4107731	1994-03-08	1994-03-08 00:00:00	38000275	0	\N	\N	192988	0	180256009	4107731	
33375	2917	4078793	1990-09-19	1990-09-19 00:00:00	38000275	0	\N	\N	194475	0	180325003	4078793	
57488	4976	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	331091	0	180256009	4107731	
45647	4026	4191853	1990-01-07	1990-01-07 00:00:00	38000275	0	\N	\N	267614	0	395142003	4191853	
45918	4033	4043071	1978-12-06	1978-12-06 00:00:00	38000275	0	\N	\N	268309	0	228557008	4043071	
34179	2970	4107731	2002-02-07	2002-02-07 00:00:00	38000275	0	\N	\N	198365	0	180256009	4107731	
34314	2975	4107731	1990-07-15	1990-07-15 00:00:00	38000275	0	\N	\N	198662	0	180256009	4107731	
34489	2986	4035793	2014-04-08	2014-04-08 00:00:00	38000275	0	\N	\N	199318	0	15081005	4035793	
46704	4101	4151422	2014-08-08	2014-08-08 00:00:00	38000275	0	\N	\N	272525	0	269911007	4151422	
34942	3041	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	202447	0	180256009	4107731	
59025	5116	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	339941	0	180256009	4107731	
35329	3083	4163872	1955-12-21	1955-12-21 00:00:00	38000275	0	\N	\N	205259	0	399208008	4163872	
47466	4167	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	277002	0	180256009	4107731	
35682	3123	4295880	2007-10-24	2007-10-24 00:00:00	38000275	0	\N	\N	207786	0	76601001	4295880	
35781	3129	4243062	1998-03-27	1998-03-27 00:00:00	38000275	0	\N	\N	208248	0	60027007	4243062	
24002	2087	4202451	2016-08-03	2016-08-03 00:00:00	38000275	0	\N	\N	139131	0	433112001	4202451	
36194	3176	4107731	2004-07-04	2004-07-04 00:00:00	38000275	0	\N	\N	211216	0	180256009	4107731	
24438	2136	4107731	2001-10-26	2001-10-26 00:00:00	38000275	0	\N	\N	142214	0	180256009	4107731	
36556	3215	4191853	2002-10-26	2002-10-26 00:00:00	38000275	0	\N	\N	213667	0	395142003	4191853	
36751	3234	4216130	2010-01-18	2010-01-18 00:00:00	38000275	0	\N	\N	214997	0	415070008	4216130	
25053	2186	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	145758	0	180256009	4107731	
37075	3258	4295880	2005-10-19	2005-10-19 00:00:00	38000275	0	\N	\N	216629	0	76601001	4295880	
37255	3277	4243062	1997-10-25	1997-10-25 00:00:00	38000275	0	\N	\N	217692	0	60027007	4243062	
37439	3298	4125906	1976-01-12	1976-01-12 00:00:00	38000275	0	\N	\N	219144	0	288086009	4125906	
37769	3342	4078793	2005-03-30	2005-03-30 00:00:00	38000275	0	\N	\N	221627	0	180325003	4078793	
25952	2272	4295880	1999-08-21	1999-08-21 00:00:00	38000275	0	\N	\N	151053	0	76601001	4295880	
37980	3353	4163872	1947-12-14	1947-12-14 00:00:00	38000275	0	\N	\N	222415	0	399208008	4163872	
38172	3370	4107731	1991-05-26	1991-05-26 00:00:00	38000275	0	\N	\N	223433	0	180256009	4107731	
38506	3383	4243062	1988-04-06	1988-04-06 00:00:00	38000275	0	\N	\N	224491	0	60027007	4243062	
38650	3399	4107731	1999-07-27	1999-07-27 00:00:00	38000275	0	\N	\N	225438	0	180256009	4107731	
26867	2349	4243062	1987-02-09	1987-02-09 00:00:00	38000275	0	\N	\N	156412	0	60027007	4243062	
27092	2369	4107731	1996-06-23	1996-06-23 00:00:00	38000275	0	\N	\N	157650	0	180256009	4107731	
39094	3446	4125906	2000-09-20	2000-09-20 00:00:00	38000275	0	\N	\N	228785	0	288086009	4125906	
39304	3464	4107731	2012-09-07	2012-09-07 00:00:00	38000275	0	\N	\N	229978	0	180256009	4107731	
27548	2402	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	159636	0	180256009	4107731	
39670	3488	4337138	2008-04-25	2008-04-25 00:00:00	38000275	0	\N	\N	231359	0	88039007	4337138	
28046	2463	4010253	1979-08-05	1979-08-05 00:00:00	38000275	0	\N	\N	163343	0	112790001	4010253	
40120	3526	4243062	1964-09-23	1964-09-23 00:00:00	38000275	0	\N	\N	234001	0	60027007	4243062	
40292	3529	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	234356	0	180256009	4107731	
28572	2540	4043071	1948-05-08	1948-05-08 00:00:00	38000275	0	\N	\N	167963	0	228557008	4043071	
40677	3570	4170947	1961-10-03	1961-10-03 00:00:00	38000275	0	\N	\N	237224	0	274474001	4170947	
40809	3582	4195803	2014-12-17	2014-12-17 00:00:00	38000275	0	\N	\N	238126	0	312681000	4195803	
29017	2564	4043071	1988-07-19	1988-07-19 00:00:00	38000275	0	\N	\N	169905	0	228557008	4043071	
29350	2615	4125906	1956-02-02	1956-02-02 00:00:00	38000275	0	\N	\N	172917	0	288086009	4125906	
41396	3629	4058899	1965-09-29	1965-09-29 00:00:00	38000275	0	\N	\N	241470	0	168594001	4058899	
53504	4642	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	309383	0	180256009	4107731	
41825	3680	4107731	1995-06-27	1995-06-27 00:00:00	38000275	0	\N	\N	244770	0	180256009	4107731	
41931	3695	4107731	1993-09-27	1993-09-27 00:00:00	38000275	0	\N	\N	245623	0	180256009	4107731	
42101	3714	4145310	2007-02-18	2007-02-18 00:00:00	38000275	0	\N	\N	246787	0	268425006	4145310	
42431	3744	4107731	2005-07-20	2005-07-20 00:00:00	38000275	0	\N	\N	248779	0	180256009	4107731	
30618	2711	4107731	1992-02-17	1992-02-17 00:00:00	38000275	0	\N	\N	179754	0	180256009	4107731	
30840	2732	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	180894	0	180256009	4107731	
42895	3783	4151422	1946-03-06	1946-03-06 00:00:00	38000275	0	\N	\N	251426	0	269911007	4151422	
43103	3799	4058899	2000-04-22	2000-04-22 00:00:00	38000275	0	\N	\N	252529	0	168594001	4058899	
31281	2770	4107731	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	183372	0	180256009	4107731	
31562	2779	4107731	1996-07-17	1996-07-17 00:00:00	38000275	0	\N	\N	184102	0	180256009	4107731	
43699	3865	4047491	1978-10-01	1978-10-01 00:00:00	38000275	0	\N	\N	256556	0	1225002	4047491	
43907	3875	4163872	1967-09-23	1967-09-23 00:00:00	38000275	0	\N	\N	257378	0	399208008	4163872	
44072	3884	4107731	1992-08-24	1992-08-24 00:00:00	38000275	0	\N	\N	258188	0	180256009	4107731	
20376	1762	4078793	2018-05-03	2018-05-03 00:00:00	38000275	0	\N	\N	117835	0	180325003	4078793	
56390	4922	4043071	1988-09-21	1988-09-21 00:00:00	38000275	0	\N	\N	327036	0	228557008	4043071	
44655	3916	4170947	2003-07-23	2003-07-23 00:00:00	38000275	0	\N	\N	260438	0	274474001	4170947	
56690	4932	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	327868	0	180256009	4107731	
33074	2898	4295880	1999-04-06	1999-04-06 00:00:00	38000275	0	\N	\N	193062	0	76601001	4295880	
33131	2898	4107731	1994-08-02	1994-08-02 00:00:00	38000275	0	\N	\N	192969	0	180256009	4107731	
33376	2917	4078793	2015-02-04	2015-02-04 00:00:00	38000275	0	\N	\N	194481	0	180325003	4078793	
57489	4976	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	330938	0	395142003	4191853	
45648	4026	4107731	1992-02-02	1992-02-02 00:00:00	38000275	0	\N	\N	267770	0	180256009	4107731	
45919	4033	4043071	1979-05-10	1979-05-10 00:00:00	38000275	0	\N	\N	268312	0	228557008	4043071	
34180	2970	4107731	2001-04-19	2001-04-19 00:00:00	38000275	0	\N	\N	198296	0	180256009	4107731	
34315	2975	4024289	2011-01-19	2011-01-19 00:00:00	38000275	0	\N	\N	198693	0	19490002	4024289	
34490	2986	4035793	2019-06-18	2019-06-18 00:00:00	38000275	0	\N	\N	199345	0	15081005	4035793	
46705	4102	44783196	1997-09-26	1997-09-26 00:00:00	38000275	0	\N	\N	272621	0	699253003	44783196	
34943	3041	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	202457	0	180256009	4107731	
59026	5116	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	339902	0	180256009	4107731	
35330	3084	4125906	1980-08-09	1980-08-09 00:00:00	38000275	0	\N	\N	205354	0	288086009	4125906	
47467	4167	4107731	1994-08-31	1994-08-31 00:00:00	38000275	0	\N	\N	276948	0	180256009	4107731	
35683	3123	4295880	2004-10-27	2004-10-27 00:00:00	38000275	0	\N	\N	207774	0	76601001	4295880	
35782	3129	4163872	1998-11-07	1998-11-07 00:00:00	38000275	0	\N	\N	208276	0	399208008	4163872	
24003	2087	4151422	1941-06-07	1941-06-07 00:00:00	38000275	0	\N	\N	139133	0	269911007	4151422	
36195	3176	4170947	1992-04-29	1992-04-29 00:00:00	38000275	0	\N	\N	211125	0	274474001	4170947	
24439	2136	4107731	2002-09-06	2002-09-06 00:00:00	38000275	0	\N	\N	142203	0	180256009	4107731	
36557	3215	4107731	2003-01-18	2003-01-18 00:00:00	38000275	0	\N	\N	213632	0	180256009	4107731	
36752	3234	4336464	2010-01-18	2010-01-18 00:00:00	38000275	0	\N	\N	214997	0	232717009	4336464	
25054	2186	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	145764	0	180256009	4107731	
37076	3258	4295880	2004-04-21	2004-04-21 00:00:00	38000275	0	\N	\N	216627	0	76601001	4295880	
37256	3277	4125906	2013-12-21	2013-12-21 00:00:00	38000275	0	\N	\N	217694	0	288086009	4125906	
37440	3298	4125906	1972-08-09	1972-08-09 00:00:00	38000275	0	\N	\N	219143	0	288086009	4125906	
37770	3342	4078793	2014-05-21	2014-05-21 00:00:00	38000275	0	\N	\N	221617	0	180325003	4078793	
25953	2272	4295880	1995-02-25	1995-02-25 00:00:00	38000275	0	\N	\N	150989	0	76601001	4295880	
37981	3353	4170947	1948-05-16	1948-05-16 00:00:00	38000275	0	\N	\N	222426	0	274474001	4170947	
38173	3370	4107731	1992-08-09	1992-08-09 00:00:00	38000275	0	\N	\N	223524	0	180256009	4107731	
38507	3383	4295880	2011-08-25	2011-08-25 00:00:00	38000275	0	\N	\N	224496	0	76601001	4295880	
38651	3399	4107731	1999-03-01	1999-03-01 00:00:00	38000275	0	\N	\N	225537	0	180256009	4107731	
26868	2349	4107731	1992-05-17	1992-05-17 00:00:00	38000275	0	\N	\N	156402	0	180256009	4107731	
27093	2369	4197460	1981-12-29	1981-12-29 00:00:00	38000275	0	\N	\N	157732	0	313191000	4197460	
39095	3446	4163872	1972-08-01	1972-08-01 00:00:00	38000275	0	\N	\N	228809	0	399208008	4163872	
39305	3464	4107731	2011-07-15	2011-07-15 00:00:00	38000275	0	\N	\N	229938	0	180256009	4107731	
27549	2402	4107731	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	159684	0	180256009	4107731	
39671	3488	4035793	2018-04-27	2018-04-27 00:00:00	38000275	0	\N	\N	231378	0	15081005	4035793	
28047	2463	4326177	2008-03-31	2008-03-31 00:00:00	38000275	0	\N	\N	163392	0	430193006	4326177	
40121	3526	4170947	1964-09-23	1964-09-23 00:00:00	38000275	0	\N	\N	234001	0	274474001	4170947	
40293	3529	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	234322	0	180256009	4107731	
28573	2540	4043071	1948-01-17	1948-01-17 00:00:00	38000275	0	\N	\N	167962	0	228557008	4043071	
40678	3570	4243062	1961-10-03	1961-10-03 00:00:00	38000275	0	\N	\N	237224	0	60027007	4243062	
40810	3582	4058899	2014-12-17	2014-12-17 00:00:00	38000275	0	\N	\N	238126	0	168594001	4058899	
29018	2564	4043071	1987-08-04	1987-08-04 00:00:00	38000275	0	\N	\N	169902	0	228557008	4043071	
29351	2615	4252419	1987-05-04	1987-05-04 00:00:00	38000275	0	\N	\N	172919	0	74016001	4252419	
41397	3629	4252419	1973-05-20	1973-05-20 00:00:00	38000275	0	\N	\N	241471	0	74016001	4252419	
53505	4642	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	309483	0	180256009	4107731	
41826	3680	4107731	1994-12-20	1994-12-20 00:00:00	38000275	0	\N	\N	244757	0	180256009	4107731	
41932	3695	4107731	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	245665	0	180256009	4107731	
42102	3714	4057420	2017-01-11	2017-01-11 00:00:00	38000275	0	\N	\N	246857	0	18286008	4057420	
42432	3744	4107731	2004-10-20	2004-10-20 00:00:00	38000275	0	\N	\N	248860	0	180256009	4107731	
30619	2711	4107731	1991-02-25	1991-02-25 00:00:00	38000275	0	\N	\N	179692	0	180256009	4107731	
30841	2732	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	180829	0	180256009	4107731	
42896	3783	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	251333	0	180256009	4107731	
43172	3803	4125906	2011-04-21	2011-04-21 00:00:00	38000275	0	\N	\N	252802	0	288086009	4125906	
31282	2770	4107731	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	183403	0	180256009	4107731	
31563	2779	4107731	1995-03-22	1995-03-22 00:00:00	38000275	0	\N	\N	184112	0	180256009	4107731	
43700	3865	4170947	1978-10-01	1978-10-01 00:00:00	38000275	0	\N	\N	256556	0	274474001	4170947	
43908	3875	4170947	1967-09-23	1967-09-23 00:00:00	38000275	0	\N	\N	257378	0	274474001	4170947	
44073	3884	4107731	1992-01-06	1992-01-06 00:00:00	38000275	0	\N	\N	258184	0	180256009	4107731	
20377	1762	4151422	1982-01-25	1982-01-25 00:00:00	38000275	0	\N	\N	117802	0	269911007	4151422	
56391	4922	4043071	1987-05-27	1987-05-27 00:00:00	38000275	0	\N	\N	327015	0	228557008	4043071	
44656	3916	44783196	1997-06-24	1997-06-24 00:00:00	38000275	0	\N	\N	260357	0	699253003	44783196	
56691	4932	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	327877	0	180256009	4107731	
33075	2898	4107731	1992-03-03	1992-03-03 00:00:00	38000275	0	\N	\N	193006	0	180256009	4107731	
33132	2898	4295880	1996-10-08	1996-10-08 00:00:00	38000275	0	\N	\N	193075	0	76601001	4295880	
33377	2917	4078793	2010-01-06	2010-01-06 00:00:00	38000275	0	\N	\N	194509	0	180325003	4078793	
57490	4976	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	330941	0	180256009	4107731	
45649	4026	4107731	1991-09-29	1991-09-29 00:00:00	38000275	0	\N	\N	267767	0	180256009	4107731	
45920	4033	4043071	1979-07-12	1979-07-12 00:00:00	38000275	0	\N	\N	268298	0	228557008	4043071	
34181	2970	4107731	1999-11-11	1999-11-11 00:00:00	38000275	0	\N	\N	198369	0	180256009	4107731	
34316	2975	4170947	2011-01-19	2011-01-19 00:00:00	38000275	0	\N	\N	198693	0	274474001	4170947	
34491	2986	4035793	2010-03-16	2010-03-16 00:00:00	38000275	0	\N	\N	199316	0	15081005	4035793	
46706	4102	4151422	1974-08-11	1974-08-11 00:00:00	38000275	0	\N	\N	272582	0	269911007	4151422	
34944	3041	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	202519	0	180256009	4107731	
59027	5116	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	340009	0	180256009	4107731	
35331	3084	4057420	2015-10-21	2015-10-21 00:00:00	38000275	0	\N	\N	205356	0	18286008	4057420	
47468	4167	4107731	1995-01-25	1995-01-25 00:00:00	38000275	0	\N	\N	276886	0	180256009	4107731	
35684	3123	4295880	2006-10-25	2006-10-25 00:00:00	38000275	0	\N	\N	207846	0	76601001	4295880	
35791	3132	4047491	1995-07-01	1995-07-01 00:00:00	38000275	0	\N	\N	208386	0	1225002	4047491	
24004	2087	4170947	1989-04-19	1989-04-19 00:00:00	38000275	0	\N	\N	139103	0	274474001	4170947	
36196	3176	4243062	1992-04-29	1992-04-29 00:00:00	38000275	0	\N	\N	211125	0	60027007	4243062	
24440	2136	4107731	2003-12-12	2003-12-12 00:00:00	38000275	0	\N	\N	142227	0	180256009	4107731	
36558	3215	4107731	2005-09-10	2005-09-10 00:00:00	38000275	0	\N	\N	213599	0	180256009	4107731	
36757	3236	4078793	1987-04-03	1987-04-03 00:00:00	38000275	0	\N	\N	215053	0	180325003	4078793	
25055	2186	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	145742	0	180256009	4107731	
37077	3258	4295880	2004-07-21	2004-07-21 00:00:00	38000275	0	\N	\N	216602	0	76601001	4295880	
37257	3277	4195803	2017-06-24	2017-06-24 00:00:00	38000275	0	\N	\N	217742	0	312681000	4195803	
37441	3298	4151422	1985-05-04	1985-05-04 00:00:00	38000275	0	\N	\N	219147	0	269911007	4151422	
37771	3342	4195803	1989-11-01	1989-11-01 00:00:00	38000275	0	\N	\N	221595	0	312681000	4195803	
25954	2272	4295880	1995-11-25	1995-11-25 00:00:00	38000275	0	\N	\N	150990	0	76601001	4295880	
37982	3353	4243062	1948-05-16	1948-05-16 00:00:00	38000275	0	\N	\N	222426	0	60027007	4243062	
38174	3370	4107731	1993-04-18	1993-04-18 00:00:00	38000275	0	\N	\N	223506	0	180256009	4107731	
38508	3383	4295880	2010-05-27	2010-05-27 00:00:00	38000275	0	\N	\N	224528	0	76601001	4295880	
38652	3399	4107731	1998-08-04	1998-08-04 00:00:00	38000275	0	\N	\N	225433	0	180256009	4107731	
26869	2349	4107731	1992-06-28	1992-06-28 00:00:00	38000275	0	\N	\N	156403	0	180256009	4107731	
27094	2369	4107731	1995-10-15	1995-10-15 00:00:00	38000275	0	\N	\N	157665	0	180256009	4107731	
39096	3446	4043071	1953-06-30	1953-06-30 00:00:00	38000275	0	\N	\N	228847	0	228557008	4043071	
39306	3464	4107731	2012-03-02	2012-03-02 00:00:00	38000275	0	\N	\N	229940	0	180256009	4107731	
27550	2402	4107731	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	159650	0	180256009	4107731	
39672	3488	4035793	2014-04-04	2014-04-04 00:00:00	38000275	0	\N	\N	231426	0	15081005	4035793	
28048	2463	4187458	2008-03-31	2008-03-31 00:00:00	38000275	0	\N	\N	163392	0	415300000	4187458	
40122	3527	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	234117	0	180256009	4107731	
40294	3529	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	234305	0	180256009	4107731	
28574	2540	4293740	1972-12-21	1972-12-21 00:00:00	38000275	0	\N	\N	167987	0	384700001	4293740	
40679	3570	4151422	1963-11-19	1963-11-19 00:00:00	38000275	0	\N	\N	237266	0	269911007	4151422	
40811	3582	4035793	2019-03-03	2019-03-03 00:00:00	38000275	0	\N	\N	238121	0	15081005	4035793	
29019	2564	4043071	1989-01-03	1989-01-03 00:00:00	38000275	0	\N	\N	169850	0	228557008	4043071	
29352	2615	4170947	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	172939	0	274474001	4170947	
41398	3630	4125906	1986-06-29	1986-06-29 00:00:00	38000275	0	\N	\N	241556	0	288086009	4125906	
53506	4642	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	309393	0	180256009	4107731	
41827	3680	4107731	1994-09-27	1994-09-27 00:00:00	38000275	0	\N	\N	244796	0	180256009	4107731	
41933	3695	4107731	1994-10-10	1994-10-10 00:00:00	38000275	0	\N	\N	245653	0	180256009	4107731	
42103	3714	4078793	2013-12-25	2013-12-25 00:00:00	38000275	0	\N	\N	246841	0	180325003	4078793	
42433	3744	4191853	2003-01-08	2003-01-08 00:00:00	38000275	0	\N	\N	248741	0	395142003	4191853	
30620	2711	4107731	1992-11-16	1992-11-16 00:00:00	38000275	0	\N	\N	179723	0	180256009	4107731	
30842	2732	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	180931	0	180256009	4107731	
42897	3783	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	251432	0	180256009	4107731	
43173	3804	4058899	2000-01-28	2000-01-28 00:00:00	38000275	0	\N	\N	252860	0	168594001	4058899	
31283	2770	4107731	1990-06-23	1990-06-23 00:00:00	38000275	0	\N	\N	183337	0	180256009	4107731	
31564	2779	4107731	1995-01-18	1995-01-18 00:00:00	38000275	0	\N	\N	184125	0	180256009	4107731	
43701	3865	4252419	2009-05-28	2009-05-28 00:00:00	38000275	0	\N	\N	256558	0	74016001	4252419	
43909	3875	4163872	1997-08-20	1997-08-20 00:00:00	38000275	0	\N	\N	257333	0	399208008	4163872	
44074	3884	4107731	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	258168	0	180256009	4107731	
20378	1762	4035793	1998-04-09	1998-04-09 00:00:00	38000275	0	\N	\N	117826	0	15081005	4035793	
56392	4922	4043071	1988-05-11	1988-05-11 00:00:00	38000275	0	\N	\N	327017	0	228557008	4043071	
44657	3916	4107731	1993-04-28	1993-04-28 00:00:00	38000275	0	\N	\N	260403	0	180256009	4107731	
56692	4932	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	327812	0	180256009	4107731	
33076	2898	4107731	1993-03-16	1993-03-16 00:00:00	38000275	0	\N	\N	193001	0	180256009	4107731	
33133	2898	4295880	1997-07-08	1997-07-08 00:00:00	38000275	0	\N	\N	193076	0	76601001	4295880	
33378	2917	4078793	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	194515	0	180325003	4078793	
57491	4976	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	331007	0	180256009	4107731	
45650	4026	4107731	1990-11-18	1990-11-18 00:00:00	38000275	0	\N	\N	267618	0	180256009	4107731	
45921	4033	4043071	1980-01-16	1980-01-16 00:00:00	38000275	0	\N	\N	268293	0	228557008	4043071	
34182	2970	4107731	2000-07-20	2000-07-20 00:00:00	38000275	0	\N	\N	198329	0	180256009	4107731	
34317	2975	4107731	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	198665	0	180256009	4107731	
34492	2986	4035793	2003-02-04	2003-02-04 00:00:00	38000275	0	\N	\N	199315	0	15081005	4035793	
46707	4102	4125906	1977-11-12	1977-11-12 00:00:00	38000275	0	\N	\N	272579	0	288086009	4125906	
34945	3041	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	202530	0	180256009	4107731	
59028	5116	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	339891	0	180256009	4107731	
35332	3084	40492359	2015-10-21	2015-10-21 00:00:00	38000275	0	\N	\N	205356	0	447365002	40492359	
47469	4167	4107731	1994-11-02	1994-11-02 00:00:00	38000275	0	\N	\N	276986	0	180256009	4107731	
35685	3123	4295880	2005-10-26	2005-10-26 00:00:00	38000275	0	\N	\N	207782	0	76601001	4295880	
35792	3132	4170947	1995-07-01	1995-07-01 00:00:00	38000275	0	\N	\N	208386	0	274474001	4170947	
24005	2087	4163872	1989-04-19	1989-04-19 00:00:00	38000275	0	\N	\N	139103	0	399208008	4163872	
36197	3176	4107731	2002-07-21	2002-07-21 00:00:00	38000275	0	\N	\N	211130	0	180256009	4107731	
24441	2136	4107731	2003-05-16	2003-05-16 00:00:00	38000275	0	\N	\N	142245	0	180256009	4107731	
36559	3215	4107731	2004-01-10	2004-01-10 00:00:00	38000275	0	\N	\N	213647	0	180256009	4107731	
36758	3236	4078793	2003-03-14	2003-03-14 00:00:00	38000275	0	\N	\N	215100	0	180325003	4078793	
25056	2186	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	145807	0	180256009	4107731	
37078	3258	4295880	2003-01-22	2003-01-22 00:00:00	38000275	0	\N	\N	216600	0	76601001	4295880	
37258	3277	4047491	2017-06-24	2017-06-24 00:00:00	38000275	0	\N	\N	217742	0	1225002	4047491	
37442	3300	4059978	1999-07-17	1999-07-17 00:00:00	38000275	0	\N	\N	219223	0	169553002	4059978	
37772	3342	4057420	2010-04-28	2010-04-28 00:00:00	38000275	0	\N	\N	221615	0	18286008	4057420	
25955	2272	4295880	2003-02-15	2003-02-15 00:00:00	38000275	0	\N	\N	151028	0	76601001	4295880	
37983	3353	4151422	1930-03-03	1930-03-03 00:00:00	38000275	0	\N	\N	222368	0	269911007	4151422	
38175	3370	4107731	1991-10-20	1991-10-20 00:00:00	38000275	0	\N	\N	223500	0	180256009	4107731	
38509	3383	4295880	2010-11-25	2010-11-25 00:00:00	38000275	0	\N	\N	224495	0	76601001	4295880	
38653	3399	4107731	1998-05-12	1998-05-12 00:00:00	38000275	0	\N	\N	225462	0	180256009	4107731	
26870	2349	4107731	1991-09-08	1991-09-08 00:00:00	38000275	0	\N	\N	156344	0	180256009	4107731	
27095	2369	4107731	1995-07-02	1995-07-02 00:00:00	38000275	0	\N	\N	157683	0	180256009	4107731	
39097	3446	4043071	1953-04-28	1953-04-28 00:00:00	38000275	0	\N	\N	228871	0	228557008	4043071	
39307	3464	4107731	2010-10-15	2010-10-15 00:00:00	38000275	0	\N	\N	229968	0	180256009	4107731	
27551	2402	4107731	1990-10-01	1990-10-01 00:00:00	38000275	0	\N	\N	159578	0	180256009	4107731	
39673	3488	4035793	2016-04-15	2016-04-15 00:00:00	38000275	0	\N	\N	231379	0	15081005	4035793	
28049	2463	4037675	2008-03-31	2008-03-31 00:00:00	38000275	0	\N	\N	163392	0	162676008	4037675	
40123	3527	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	234071	0	395142003	4191853	
40295	3529	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	234405	0	180256009	4107731	
28575	2540	4125906	1972-12-21	1972-12-21 00:00:00	38000275	0	\N	\N	167987	0	288086009	4125906	
40680	3571	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	237370	0	180256009	4107731	
40812	3582	4035793	2016-07-24	2016-07-24 00:00:00	38000275	0	\N	\N	238107	0	15081005	4035793	
29020	2564	4043071	1988-03-22	1988-03-22 00:00:00	38000275	0	\N	\N	169904	0	228557008	4043071	
29353	2615	4243062	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	172939	0	60027007	4243062	
41399	3630	4170947	2009-02-12	2009-02-12 00:00:00	38000275	0	\N	\N	241557	0	274474001	4170947	
53507	4642	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	309363	0	180256009	4107731	
41828	3680	4107731	1994-11-08	1994-11-08 00:00:00	38000275	0	\N	\N	244797	0	180256009	4107731	
41934	3695	4107731	1993-10-18	1993-10-18 00:00:00	38000275	0	\N	\N	245646	0	180256009	4107731	
42104	3714	4057420	2011-12-14	2011-12-14 00:00:00	38000275	0	\N	\N	246865	0	18286008	4057420	
42434	3744	4107731	2004-03-03	2004-03-03 00:00:00	38000275	0	\N	\N	248827	0	180256009	4107731	
30621	2711	4107731	1990-12-03	1990-12-03 00:00:00	38000275	0	\N	\N	179690	0	180256009	4107731	
30843	2732	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	180921	0	180256009	4107731	
42898	3783	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	251446	0	180256009	4107731	
43174	3804	4170947	1962-09-18	1962-09-18 00:00:00	38000275	0	\N	\N	252857	0	274474001	4170947	
31284	2770	4107731	1993-02-13	1993-02-13 00:00:00	38000275	0	\N	\N	183328	0	180256009	4107731	
31565	2779	4107731	1995-05-24	1995-05-24 00:00:00	38000275	0	\N	\N	184172	0	180256009	4107731	
43702	3865	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	256569	0	180256009	4107731	
43910	3876	4107731	1991-08-12	1991-08-12 00:00:00	38000275	0	\N	\N	257447	0	180256009	4107731	
44075	3884	4107731	1992-03-09	1992-03-09 00:00:00	38000275	0	\N	\N	258076	0	180256009	4107731	
20379	1762	4078793	1998-04-09	1998-04-09 00:00:00	38000275	0	\N	\N	117826	0	180325003	4078793	
56393	4922	4043071	1987-09-02	1987-09-02 00:00:00	38000275	0	\N	\N	327031	0	228557008	4043071	
44658	3916	4107731	1992-12-23	1992-12-23 00:00:00	38000275	0	\N	\N	260367	0	180256009	4107731	
56693	4932	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	327916	0	180256009	4107731	
33077	2898	4107731	1993-08-10	1993-08-10 00:00:00	38000275	0	\N	\N	193047	0	180256009	4107731	
33134	2898	4295880	1994-04-12	1994-04-12 00:00:00	38000275	0	\N	\N	193074	0	76601001	4295880	
33379	2917	4057420	2001-11-21	2001-11-21 00:00:00	38000275	0	\N	\N	194477	0	18286008	4057420	
57492	4976	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	331011	0	180256009	4107731	
45651	4026	4107731	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	267620	0	180256009	4107731	
45922	4033	4043071	1980-10-09	1980-10-09 00:00:00	38000275	0	\N	\N	268344	0	228557008	4043071	
34183	2970	4107731	1999-12-23	1999-12-23 00:00:00	38000275	0	\N	\N	198333	0	180256009	4107731	
34318	2975	4107731	1992-05-17	1992-05-17 00:00:00	38000275	0	\N	\N	198671	0	180256009	4107731	
34493	2986	4010253	2018-04-24	2018-04-24 00:00:00	38000275	0	\N	\N	199335	0	112790001	4010253	
46708	4102	4125906	1972-02-14	1972-02-14 00:00:00	38000275	0	\N	\N	272578	0	288086009	4125906	
34946	3041	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	202453	0	180256009	4107731	
59029	5116	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	339924	0	180256009	4107731	
35333	3084	4252419	2017-04-18	2017-04-18 00:00:00	38000275	0	\N	\N	205357	0	74016001	4252419	
47470	4167	4107731	1994-06-08	1994-06-08 00:00:00	38000275	0	\N	\N	276884	0	180256009	4107731	
35686	3123	4295880	2009-01-21	2009-01-21 00:00:00	38000275	0	\N	\N	207822	0	76601001	4295880	
35793	3132	4330583	2004-07-10	2004-07-10 00:00:00	38000275	0	\N	\N	208431	0	22523008	4330583	
24006	2087	4195803	1989-04-19	1989-04-19 00:00:00	38000275	0	\N	\N	139103	0	312681000	4195803	
36198	3176	4107731	2004-09-05	2004-09-05 00:00:00	38000275	0	\N	\N	211206	0	180256009	4107731	
24442	2136	4107731	2001-07-13	2001-07-13 00:00:00	38000275	0	\N	\N	142195	0	180256009	4107731	
36560	3215	4107731	2003-12-20	2003-12-20 00:00:00	38000275	0	\N	\N	213677	0	180256009	4107731	
36759	3236	4078793	1989-12-29	1989-12-29 00:00:00	38000275	0	\N	\N	215076	0	180325003	4078793	
25057	2186	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	145825	0	180256009	4107731	
37079	3258	4295880	2002-04-24	2002-04-24 00:00:00	38000275	0	\N	\N	216562	0	76601001	4295880	
37259	3277	4170947	2017-06-24	2017-06-24 00:00:00	38000275	0	\N	\N	217742	0	274474001	4170947	
37443	3300	4326177	2016-07-27	2016-07-27 00:00:00	38000275	0	\N	\N	219248	0	430193006	4326177	
37773	3342	4078793	2015-05-27	2015-05-27 00:00:00	38000275	0	\N	\N	221575	0	180325003	4078793	
25956	2272	4295880	1997-11-22	1997-11-22 00:00:00	38000275	0	\N	\N	151064	0	76601001	4295880	
37984	3355	4170947	2017-05-10	2017-05-10 00:00:00	38000275	0	\N	\N	222509	0	274474001	4170947	
38176	3370	4107731	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	223458	0	180256009	4107731	
38510	3383	4125906	1995-09-27	1995-09-27 00:00:00	38000275	0	\N	\N	224492	0	288086009	4125906	
38654	3399	4107731	1996-10-22	1996-10-22 00:00:00	38000275	0	\N	\N	225507	0	180256009	4107731	
26871	2349	4107731	1991-07-07	1991-07-07 00:00:00	38000275	0	\N	\N	156398	0	180256009	4107731	
27096	2369	4107731	1994-12-04	1994-12-04 00:00:00	38000275	0	\N	\N	157661	0	180256009	4107731	
39113	3454	4163872	1997-02-21	1997-02-21 00:00:00	38000275	0	\N	\N	229142	0	399208008	4163872	
39308	3464	4107731	2010-02-26	2010-02-26 00:00:00	38000275	0	\N	\N	229966	0	180256009	4107731	
27552	2402	4107731	1991-02-25	1991-02-25 00:00:00	38000275	0	\N	\N	159592	0	180256009	4107731	
39674	3488	4035793	2010-03-12	2010-03-12 00:00:00	38000275	0	\N	\N	231412	0	15081005	4035793	
39832	3508	4145310	1966-08-08	1966-08-08 00:00:00	38000275	0	\N	\N	232692	0	268425006	4145310	
40124	3527	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	234122	0	180256009	4107731	
40296	3529	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	234437	0	180256009	4107731	
28576	2540	4043071	1948-07-10	1948-07-10 00:00:00	38000275	0	\N	\N	167873	0	228557008	4043071	
40681	3571	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	237337	0	180256009	4107731	
40813	3582	4035793	2014-07-13	2014-07-13 00:00:00	38000275	0	\N	\N	238106	0	15081005	4035793	
29021	2564	4043071	1989-02-28	1989-02-28 00:00:00	38000275	0	\N	\N	169833	0	228557008	4043071	
29354	2615	44783196	1987-05-11	1987-05-11 00:00:00	38000275	0	\N	\N	172938	0	699253003	44783196	
41400	3630	4195803	2009-02-12	2009-02-12 00:00:00	38000275	0	\N	\N	241557	0	312681000	4195803	
53508	4642	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	309417	0	180256009	4107731	
41829	3680	4107731	1993-03-09	1993-03-09 00:00:00	38000275	0	\N	\N	244761	0	180256009	4107731	
41935	3695	4107731	1994-09-19	1994-09-19 00:00:00	38000275	0	\N	\N	245628	0	180256009	4107731	
42105	3714	4195803	2012-12-19	2012-12-19 00:00:00	38000275	0	\N	\N	246855	0	312681000	4195803	
42435	3744	4107731	2003-05-14	2003-05-14 00:00:00	38000275	0	\N	\N	248794	0	180256009	4107731	
30622	2711	4107731	1990-04-16	1990-04-16 00:00:00	38000275	0	\N	\N	179687	0	180256009	4107731	
30844	2732	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	180943	0	180256009	4107731	
42899	3783	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	251442	0	180256009	4107731	
43175	3804	4047491	1962-09-18	1962-09-18 00:00:00	38000275	0	\N	\N	252857	0	1225002	4047491	
31285	2770	4107731	1992-04-04	1992-04-04 00:00:00	38000275	0	\N	\N	183324	0	180256009	4107731	
31566	2779	4107731	1996-02-21	1996-02-21 00:00:00	38000275	0	\N	\N	184175	0	180256009	4107731	
43703	3865	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	256617	0	180256009	4107731	
43911	3876	4107731	1990-04-16	1990-04-16 00:00:00	38000275	0	\N	\N	257434	0	180256009	4107731	
44076	3884	4043071	1989-05-06	1989-05-06 00:00:00	38000275	0	\N	\N	258058	0	228557008	4043071	
20380	1762	4078793	2008-03-06	2008-03-06 00:00:00	38000275	0	\N	\N	117858	0	180325003	4078793	
56394	4922	4043071	1987-06-24	1987-06-24 00:00:00	38000275	0	\N	\N	327073	0	228557008	4043071	
44659	3916	4107731	1994-11-16	1994-11-16 00:00:00	38000275	0	\N	\N	260332	0	180256009	4107731	
56694	4932	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	327817	0	180256009	4107731	
33078	2898	4295880	1998-10-06	1998-10-06 00:00:00	38000275	0	\N	\N	193089	0	76601001	4295880	
33135	2898	4107731	1993-04-27	1993-04-27 00:00:00	38000275	0	\N	\N	193002	0	180256009	4107731	
33380	2917	4078793	2003-12-03	2003-12-03 00:00:00	38000275	0	\N	\N	194478	0	180325003	4078793	
57493	4976	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	330940	0	180256009	4107731	
45652	4026	4010253	2019-06-20	2019-06-20 00:00:00	38000275	0	\N	\N	267644	0	112790001	4010253	
45923	4033	4043071	1980-04-23	1980-04-23 00:00:00	38000275	0	\N	\N	268355	0	228557008	4043071	
34184	2970	4107731	2000-08-10	2000-08-10 00:00:00	38000275	0	\N	\N	198359	0	180256009	4107731	
34319	2975	4107731	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	198682	0	180256009	4107731	
34494	2986	4035793	1998-01-06	1998-01-06 00:00:00	38000275	0	\N	\N	199320	0	15081005	4035793	
46709	4102	4058899	1981-08-14	1981-08-14 00:00:00	38000275	0	\N	\N	272580	0	168594001	4058899	
34947	3041	4197460	2005-08-03	2005-08-03 00:00:00	38000275	0	\N	\N	202491	0	313191000	4197460	
59030	5116	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	339987	0	180256009	4107731	
35334	3084	4243062	2006-10-13	2006-10-13 00:00:00	38000275	0	\N	\N	205355	0	60027007	4243062	
47471	4167	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	276960	0	180256009	4107731	
35687	3123	4295880	2006-04-26	2006-04-26 00:00:00	38000275	0	\N	\N	207776	0	76601001	4295880	
35794	3132	4198190	1976-07-05	1976-07-05 00:00:00	38000275	0	\N	\N	208378	0	80146002	4198190	
24007	2087	4010253	1957-10-13	1957-10-13 00:00:00	38000275	0	\N	\N	139043	0	112790001	4010253	
36199	3176	4107731	2004-05-23	2004-05-23 00:00:00	38000275	0	\N	\N	211215	0	180256009	4107731	
24443	2136	4107731	2003-11-21	2003-11-21 00:00:00	38000275	0	\N	\N	142265	0	180256009	4107731	
36561	3215	4107731	2006-04-08	2006-04-08 00:00:00	38000275	0	\N	\N	213603	0	180256009	4107731	
36760	3236	4078793	1995-01-27	1995-01-27 00:00:00	38000275	0	\N	\N	215096	0	180325003	4078793	
25058	2186	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	145759	0	180256009	4107731	
37080	3258	4295880	2005-01-19	2005-01-19 00:00:00	38000275	0	\N	\N	216628	0	76601001	4295880	
37260	3278	4170947	1969-05-01	1969-05-01 00:00:00	38000275	0	\N	\N	217743	0	274474001	4170947	
37444	3300	4187458	2016-07-27	2016-07-27 00:00:00	38000275	0	\N	\N	219248	0	415300000	4187458	
37774	3342	4057420	2008-04-16	2008-04-16 00:00:00	38000275	0	\N	\N	221574	0	18286008	4057420	
25957	2272	4295880	1997-02-22	1997-02-22 00:00:00	38000275	0	\N	\N	151037	0	76601001	4295880	
37985	3355	4024289	2017-05-10	2017-05-10 00:00:00	38000275	0	\N	\N	222509	0	19490002	4024289	
38177	3370	4191853	1990-01-07	1990-01-07 00:00:00	38000275	0	\N	\N	223479	0	395142003	4191853	
38511	3383	4125906	2014-11-07	2014-11-07 00:00:00	38000275	0	\N	\N	224493	0	288086009	4125906	
38655	3399	4107731	1996-06-18	1996-06-18 00:00:00	38000275	0	\N	\N	225489	0	180256009	4107731	
26872	2349	4107731	1993-03-28	1993-03-28 00:00:00	38000275	0	\N	\N	156354	0	180256009	4107731	
27097	2369	4107731	1996-12-08	1996-12-08 00:00:00	38000275	0	\N	\N	157641	0	180256009	4107731	
39114	3454	4170947	1997-02-21	1997-02-21 00:00:00	38000275	0	\N	\N	229142	0	274474001	4170947	
39309	3464	4107731	2011-02-18	2011-02-18 00:00:00	38000275	0	\N	\N	229971	0	180256009	4107731	
27553	2402	4107731	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	159694	0	180256009	4107731	
39675	3488	4047491	1991-06-29	1991-06-29 00:00:00	38000275	0	\N	\N	231358	0	1225002	4047491	
39833	3508	4151422	1961-11-04	1961-11-04 00:00:00	38000275	0	\N	\N	232632	0	269911007	4151422	
40125	3527	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	234054	0	180256009	4107731	
40297	3529	4058899	1951-03-05	1951-03-05 00:00:00	38000275	0	\N	\N	234287	0	168594001	4058899	
28577	2540	4043071	1948-02-14	1948-02-14 00:00:00	38000275	0	\N	\N	167888	0	228557008	4043071	
40682	3571	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	237349	0	180256009	4107731	
40814	3582	4035793	2018-02-25	2018-02-25 00:00:00	38000275	0	\N	\N	238135	0	15081005	4035793	
29022	2564	4043071	1988-01-26	1988-01-26 00:00:00	38000275	0	\N	\N	169910	0	228557008	4043071	
29355	2615	4125906	2010-05-10	2010-05-10 00:00:00	38000275	0	\N	\N	172940	0	288086009	4125906	
41401	3630	4047491	2009-02-12	2009-02-12 00:00:00	38000275	0	\N	\N	241557	0	1225002	4047491	
53509	4642	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	309388	0	180256009	4107731	
41842	3686	4243062	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	245052	0	60027007	4243062	
41936	3695	4107731	1996-04-08	1996-04-08 00:00:00	38000275	0	\N	\N	245580	0	180256009	4107731	
42106	3714	4078793	2012-12-19	2012-12-19 00:00:00	38000275	0	\N	\N	246855	0	180325003	4078793	
42436	3744	4252419	1994-12-17	1994-12-17 00:00:00	38000275	0	\N	\N	248852	0	74016001	4252419	
30623	2711	4151422	1980-02-05	1980-02-05 00:00:00	38000275	0	\N	\N	179621	0	269911007	4151422	
30845	2732	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	180830	0	180256009	4107731	
42900	3783	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	251334	0	180256009	4107731	
43177	3807	4252419	1974-08-25	1974-08-25 00:00:00	38000275	0	\N	\N	253024	0	74016001	4252419	
31286	2770	4107731	1991-09-28	1991-09-28 00:00:00	38000275	0	\N	\N	183323	0	180256009	4107731	
31567	2779	4107731	1994-12-28	1994-12-28 00:00:00	38000275	0	\N	\N	184093	0	180256009	4107731	
43704	3865	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	256645	0	180256009	4107731	
43912	3876	4107731	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	257474	0	180256009	4107731	
44077	3884	4107731	1990-07-09	1990-07-09 00:00:00	38000275	0	\N	\N	258165	0	180256009	4107731	
20381	1762	4035793	2008-03-06	2008-03-06 00:00:00	38000275	0	\N	\N	117858	0	15081005	4035793	
56395	4922	4043071	1985-05-15	1985-05-15 00:00:00	38000275	0	\N	\N	327042	0	228557008	4043071	
44660	3916	4252419	2007-08-01	2007-08-01 00:00:00	38000275	0	\N	\N	260440	0	74016001	4252419	
56695	4932	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	327900	0	180256009	4107731	
33079	2898	4295880	1999-10-05	1999-10-05 00:00:00	38000275	0	\N	\N	193079	0	76601001	4295880	
33136	2898	4295880	1998-01-06	1998-01-06 00:00:00	38000275	0	\N	\N	193088	0	76601001	4295880	
33381	2917	4078793	1992-09-30	1992-09-30 00:00:00	38000275	0	\N	\N	194454	0	180325003	4078793	
57494	4976	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	331008	0	180256009	4107731	
45653	4026	4107731	1991-07-07	1991-07-07 00:00:00	38000275	0	\N	\N	267738	0	180256009	4107731	
45924	4033	4043071	1981-02-04	1981-02-04 00:00:00	38000275	0	\N	\N	268346	0	228557008	4043071	
34185	2970	4107731	2000-02-24	2000-02-24 00:00:00	38000275	0	\N	\N	198308	0	180256009	4107731	
34320	2975	4107731	1991-07-07	1991-07-07 00:00:00	38000275	0	\N	\N	198667	0	180256009	4107731	
34495	2986	4323902	1997-03-18	1997-03-18 00:00:00	38000275	0	\N	\N	199326	0	429609002	4323902	
46710	4102	4301346	1973-11-03	1973-11-03 00:00:00	38000275	0	\N	\N	272577	0	387685009	4301346	
34948	3041	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	202502	0	180256009	4107731	
59031	5117	4107731	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	340097	0	180256009	4107731	
35335	3084	4170947	2006-10-13	2006-10-13 00:00:00	38000275	0	\N	\N	205355	0	274474001	4170947	
47472	4167	4107731	1994-10-12	1994-10-12 00:00:00	38000275	0	\N	\N	276949	0	180256009	4107731	
35688	3123	4295880	2004-07-28	2004-07-28 00:00:00	38000275	0	\N	\N	207800	0	76601001	4295880	
35795	3133	4024289	1961-01-26	1961-01-26 00:00:00	38000275	0	\N	\N	208507	0	19490002	4024289	
24008	2087	4195803	1997-02-06	1997-02-06 00:00:00	38000275	0	\N	\N	139104	0	312681000	4195803	
36200	3176	4107731	2003-08-03	2003-08-03 00:00:00	38000275	0	\N	\N	211115	0	180256009	4107731	
24444	2136	4107731	2003-09-19	2003-09-19 00:00:00	38000275	0	\N	\N	142248	0	180256009	4107731	
36562	3215	4107731	2006-02-25	2006-02-25 00:00:00	38000275	0	\N	\N	213602	0	180256009	4107731	
36761	3236	4078793	2015-09-11	2015-09-11 00:00:00	38000275	0	\N	\N	215086	0	180325003	4078793	
36840	3241	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	215490	0	180256009	4107731	
37081	3258	4295880	2003-07-23	2003-07-23 00:00:00	38000275	0	\N	\N	216626	0	76601001	4295880	
37261	3278	4243062	1969-05-01	1969-05-01 00:00:00	38000275	0	\N	\N	217743	0	60027007	4243062	
37445	3300	4037675	2016-07-27	2016-07-27 00:00:00	38000275	0	\N	\N	219248	0	162676008	4037675	
49556	4353	4043071	1977-08-10	1977-08-10 00:00:00	38000275	0	\N	\N	288732	0	228557008	4043071	
25958	2272	4295880	1996-08-24	1996-08-24 00:00:00	38000275	0	\N	\N	150991	0	76601001	4295880	
37986	3355	4195803	2017-05-10	2017-05-10 00:00:00	38000275	0	\N	\N	222509	0	312681000	4195803	
38178	3370	4107731	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	223498	0	180256009	4107731	
38512	3383	4295880	2010-02-20	2010-02-20 00:00:00	38000275	0	\N	\N	224485	0	76601001	4295880	
38656	3399	4107731	1996-05-28	1996-05-28 00:00:00	38000275	0	\N	\N	225466	0	180256009	4107731	
26873	2349	4107731	1993-02-14	1993-02-14 00:00:00	38000275	0	\N	\N	156353	0	180256009	4107731	
27098	2369	4107731	1997-01-19	1997-01-19 00:00:00	38000275	0	\N	\N	157642	0	180256009	4107731	
39115	3454	4151422	2014-08-24	2014-08-24 00:00:00	38000275	0	\N	\N	229148	0	269911007	4151422	
39310	3464	4107731	2012-05-25	2012-05-25 00:00:00	38000275	0	\N	\N	229975	0	180256009	4107731	
27554	2402	4107731	1991-02-04	1991-02-04 00:00:00	38000275	0	\N	\N	159651	0	180256009	4107731	
39676	3488	4170947	1991-06-29	1991-06-29 00:00:00	38000275	0	\N	\N	231358	0	274474001	4170947	
39834	3508	4195803	2019-05-02	2019-05-02 00:00:00	38000275	0	\N	\N	232693	0	312681000	4195803	
40126	3527	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	234007	0	180256009	4107731	
40298	3529	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	234324	0	180256009	4107731	
28578	2540	4043071	1948-11-13	1948-11-13 00:00:00	38000275	0	\N	\N	167890	0	228557008	4043071	
40683	3571	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	237416	0	180256009	4107731	
40815	3582	4035793	2017-02-19	2017-02-19 00:00:00	38000275	0	\N	\N	238120	0	15081005	4035793	
29023	2564	4043071	1987-10-27	1987-10-27 00:00:00	38000275	0	\N	\N	169885	0	228557008	4043071	
29356	2616	4195803	2012-01-10	2012-01-10 00:00:00	38000275	0	\N	\N	173007	0	312681000	4195803	
41402	3630	4163872	1979-05-07	1979-05-07 00:00:00	38000275	0	\N	\N	241555	0	399208008	4163872	
53510	4642	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	309404	0	180256009	4107731	
41843	3686	4170947	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	245052	0	274474001	4170947	
41937	3695	4107731	1994-05-16	1994-05-16 00:00:00	38000275	0	\N	\N	245625	0	180256009	4107731	
42107	3714	4078793	2005-11-09	2005-11-09 00:00:00	38000275	0	\N	\N	246875	0	180325003	4078793	
42437	3744	4107731	2005-04-27	2005-04-27 00:00:00	38000275	0	\N	\N	248806	0	180256009	4107731	
30624	2711	4107731	1993-01-18	1993-01-18 00:00:00	38000275	0	\N	\N	179673	0	180256009	4107731	
30846	2732	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	180850	0	180256009	4107731	
42901	3783	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	251375	0	180256009	4107731	
43178	3807	4024289	1956-01-02	1956-01-02 00:00:00	38000275	0	\N	\N	253023	0	19490002	4024289	
31287	2770	4163872	2004-11-04	2004-11-04 00:00:00	38000275	0	\N	\N	183305	0	399208008	4163872	
31568	2779	4107731	1995-11-29	1995-11-29 00:00:00	38000275	0	\N	\N	184129	0	180256009	4107731	
43705	3865	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	256668	0	180256009	4107731	
43913	3876	4107731	1992-09-14	1992-09-14 00:00:00	38000275	0	\N	\N	257456	0	180256009	4107731	
44078	3884	4107731	1992-12-07	1992-12-07 00:00:00	38000275	0	\N	\N	258079	0	180256009	4107731	
20382	1762	4337138	1982-04-22	1982-04-22 00:00:00	38000275	0	\N	\N	117863	0	88039007	4337138	
56396	4922	4043071	1985-03-13	1985-03-13 00:00:00	38000275	0	\N	\N	326985	0	228557008	4043071	
44661	3916	4107731	1993-01-13	1993-01-13 00:00:00	38000275	0	\N	\N	260411	0	180256009	4107731	
56696	4932	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	327873	0	180256009	4107731	
33080	2898	4295880	1995-01-10	1995-01-10 00:00:00	38000275	0	\N	\N	193084	0	76601001	4295880	
33137	2898	4107731	1992-08-18	1992-08-18 00:00:00	38000275	0	\N	\N	193042	0	180256009	4107731	
33382	2917	4078793	2007-12-26	2007-12-26 00:00:00	38000275	0	\N	\N	194508	0	180325003	4078793	
57495	4977	42535580	2010-12-07	2010-12-07 00:00:00	38000275	0	\N	\N	331120	0	426701000119108	42535580	
45654	4026	4107731	1992-08-30	1992-08-30 00:00:00	38000275	0	\N	\N	267688	0	180256009	4107731	
45925	4033	4043071	1978-11-08	1978-11-08 00:00:00	38000275	0	\N	\N	268291	0	228557008	4043071	
34186	2970	4107731	2001-08-02	2001-08-02 00:00:00	38000275	0	\N	\N	198340	0	180256009	4107731	
34321	2975	4107731	1991-12-22	1991-12-22 00:00:00	38000275	0	\N	\N	198620	0	180256009	4107731	
34496	2986	4125906	1974-12-02	1974-12-02 00:00:00	38000275	0	\N	\N	199354	0	288086009	4125906	
46711	4102	4252419	1997-09-19	1997-09-19 00:00:00	38000275	0	\N	\N	272581	0	74016001	4252419	
34949	3041	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	202505	0	180256009	4107731	
59032	5117	4107731	1992-08-03	1992-08-03 00:00:00	38000275	0	\N	\N	340079	0	180256009	4107731	
35336	3086	4151422	1987-01-30	1987-01-30 00:00:00	38000275	0	\N	\N	205468	0	269911007	4151422	
47473	4167	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	276938	0	180256009	4107731	
35689	3123	4295880	2008-01-23	2008-01-23 00:00:00	38000275	0	\N	\N	207851	0	76601001	4295880	
35796	3133	4170947	1961-01-26	1961-01-26 00:00:00	38000275	0	\N	\N	208507	0	274474001	4170947	
24009	2087	4024289	1997-02-06	1997-02-06 00:00:00	38000275	0	\N	\N	139104	0	19490002	4024289	
36201	3176	4107731	2003-08-24	2003-08-24 00:00:00	38000275	0	\N	\N	211179	0	180256009	4107731	
24445	2136	4107731	2004-03-26	2004-03-26 00:00:00	38000275	0	\N	\N	142249	0	180256009	4107731	
36563	3215	4107731	2004-06-05	2004-06-05 00:00:00	38000275	0	\N	\N	213660	0	180256009	4107731	
36762	3236	4057420	2008-02-29	2008-02-29 00:00:00	38000275	0	\N	\N	215084	0	18286008	4057420	
36841	3241	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	215501	0	395142003	4191853	
37082	3258	4295880	2005-04-20	2005-04-20 00:00:00	38000275	0	\N	\N	216603	0	76601001	4295880	
37262	3278	4125906	2015-10-07	2015-10-07 00:00:00	38000275	0	\N	\N	217748	0	288086009	4125906	
37446	3300	4199276	2000-07-13	2000-07-13 00:00:00	38000275	0	\N	\N	219241	0	301807007	4199276	
49557	4353	4043071	1980-12-03	1980-12-03 00:00:00	38000275	0	\N	\N	288755	0	228557008	4043071	
25959	2272	4295880	1997-05-24	1997-05-24 00:00:00	38000275	0	\N	\N	150992	0	76601001	4295880	
37987	3355	4243062	1977-11-15	1977-11-15 00:00:00	38000275	0	\N	\N	222506	0	60027007	4243062	
38179	3370	4107731	1992-06-07	1992-06-07 00:00:00	38000275	0	\N	\N	223502	0	180256009	4107731	
38518	3386	4125906	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	224632	0	288086009	4125906	
38657	3399	4107731	1998-01-26	1998-01-26 00:00:00	38000275	0	\N	\N	225484	0	180256009	4107731	
26874	2349	4191853	1993-07-11	1993-07-11 00:00:00	38000275	0	\N	\N	156449	0	395142003	4191853	
27099	2369	4107731	1995-05-21	1995-05-21 00:00:00	38000275	0	\N	\N	157682	0	180256009	4107731	
39116	3454	4151422	1995-10-02	1995-10-02 00:00:00	38000275	0	\N	\N	229196	0	269911007	4151422	
39311	3464	4107731	2010-05-21	2010-05-21 00:00:00	38000275	0	\N	\N	230002	0	180256009	4107731	
27555	2402	4107731	1991-09-23	1991-09-23 00:00:00	38000275	0	\N	\N	159653	0	180256009	4107731	
39677	3488	4035793	2009-03-06	2009-03-06 00:00:00	38000275	0	\N	\N	231377	0	15081005	4035793	
39835	3508	4145310	2019-05-02	2019-05-02 00:00:00	38000275	0	\N	\N	232693	0	268425006	4145310	
40127	3527	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	234081	0	180256009	4107731	
40299	3529	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	234419	0	180256009	4107731	
28579	2541	4151422	1999-02-23	1999-02-23 00:00:00	38000275	0	\N	\N	168033	0	269911007	4151422	
40684	3571	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	237434	0	180256009	4107731	
40816	3582	4170947	1989-09-01	1989-09-01 00:00:00	38000275	0	\N	\N	238122	0	274474001	4170947	
29024	2564	4043071	1987-06-30	1987-06-30 00:00:00	38000275	0	\N	\N	169884	0	228557008	4043071	
29357	2617	4125906	2016-06-05	2016-06-05 00:00:00	38000275	0	\N	\N	173099	0	288086009	4125906	
41403	3630	4170947	1979-05-07	1979-05-07 00:00:00	38000275	0	\N	\N	241555	0	274474001	4170947	
53511	4642	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	309422	0	180256009	4107731	
41844	3686	4151422	2013-02-15	2013-02-15 00:00:00	38000275	0	\N	\N	245086	0	269911007	4151422	
41938	3695	4107731	1996-05-20	1996-05-20 00:00:00	38000275	0	\N	\N	245660	0	180256009	4107731	
42108	3714	4125906	1964-01-09	1964-01-09 00:00:00	38000275	0	\N	\N	246848	0	288086009	4125906	
42438	3744	4107731	2003-10-29	2003-10-29 00:00:00	38000275	0	\N	\N	248753	0	180256009	4107731	
30625	2711	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	179681	0	180256009	4107731	
30847	2732	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	180831	0	180256009	4107731	
42902	3783	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	251365	0	395142003	4191853	
43179	3807	4170947	1956-01-02	1956-01-02 00:00:00	38000275	0	\N	\N	253023	0	274474001	4170947	
31288	2770	4170947	2004-11-04	2004-11-04 00:00:00	38000275	0	\N	\N	183305	0	274474001	4170947	
31569	2779	4107731	1997-12-03	1997-12-03 00:00:00	38000275	0	\N	\N	184140	0	180256009	4107731	
43706	3865	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	256593	0	180256009	4107731	
43914	3876	4107731	1991-12-16	1991-12-16 00:00:00	38000275	0	\N	\N	257453	0	180256009	4107731	
44079	3884	4107731	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	258099	0	180256009	4107731	
20383	1762	4035793	1988-02-18	1988-02-18 00:00:00	38000275	0	\N	\N	117890	0	15081005	4035793	
56397	4923	4238715	1987-10-27	1987-10-27 00:00:00	38000275	0	\N	\N	327141	0	68254000	4238715	
44662	3916	4107731	1994-05-11	1994-05-11 00:00:00	38000275	0	\N	\N	260424	0	180256009	4107731	
56697	4932	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	327894	0	180256009	4107731	
33081	2898	4107731	1992-09-29	1992-09-29 00:00:00	38000275	0	\N	\N	193043	0	180256009	4107731	
33138	2898	4107731	1995-05-02	1995-05-02 00:00:00	38000275	0	\N	\N	193097	0	180256009	4107731	
33383	2917	4151422	1941-02-10	1941-02-10 00:00:00	38000275	0	\N	\N	194465	0	269911007	4151422	
57496	4977	4163971	2010-12-08	2010-12-08 00:00:00	38000275	0	\N	\N	331120	0	45595009	4163971	
45655	4026	4107731	1991-08-18	1991-08-18 00:00:00	38000275	0	\N	\N	267739	0	180256009	4107731	
45926	4033	4043071	1979-03-14	1979-03-14 00:00:00	38000275	0	\N	\N	268292	0	228557008	4043071	
34187	2970	4107731	2001-03-08	2001-03-08 00:00:00	38000275	0	\N	\N	198295	0	180256009	4107731	
34322	2975	4107731	1991-03-03	1991-03-03 00:00:00	38000275	0	\N	\N	198586	0	180256009	4107731	
34497	2986	4035793	2006-02-21	2006-02-21 00:00:00	38000275	0	\N	\N	199295	0	15081005	4035793	
46718	4105	4151422	1947-12-03	1947-12-03 00:00:00	38000275	0	\N	\N	272756	0	269911007	4151422	
34950	3041	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	202470	0	180256009	4107731	
59033	5117	4107731	1991-08-12	1991-08-12 00:00:00	38000275	0	\N	\N	340126	0	180256009	4107731	
35337	3086	4125906	1982-11-11	1982-11-11 00:00:00	38000275	0	\N	\N	205441	0	288086009	4125906	
47474	4167	4107731	1995-03-08	1995-03-08 00:00:00	38000275	0	\N	\N	276887	0	180256009	4107731	
35690	3123	4295880	2010-07-21	2010-07-21 00:00:00	38000275	0	\N	\N	207824	0	76601001	4295880	
35797	3133	4170947	1972-09-25	1972-09-25 00:00:00	38000275	0	\N	\N	208509	0	274474001	4170947	
24010	2087	4170947	1997-02-06	1997-02-06 00:00:00	38000275	0	\N	\N	139104	0	274474001	4170947	
36202	3176	4107731	2003-05-11	2003-05-11 00:00:00	38000275	0	\N	\N	211090	0	180256009	4107731	
24446	2136	4191853	2001-06-22	2001-06-22 00:00:00	38000275	0	\N	\N	142306	0	395142003	4191853	
36564	3215	4107731	2005-02-12	2005-02-12 00:00:00	38000275	0	\N	\N	213617	0	180256009	4107731	
36763	3236	4078793	2007-04-06	2007-04-06 00:00:00	38000275	0	\N	\N	215105	0	180325003	4078793	
36842	3241	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	215511	0	180256009	4107731	
37083	3258	4295880	2003-04-23	2003-04-23 00:00:00	38000275	0	\N	\N	216567	0	76601001	4295880	
37263	3278	4058899	1977-02-02	1977-02-02 00:00:00	38000275	0	\N	\N	217745	0	168594001	4058899	
37447	3300	4062501	1985-08-11	1985-08-11 00:00:00	38000275	0	\N	\N	219236	0	171231001	4062501	
49558	4353	4043071	1978-02-01	1978-02-01 00:00:00	38000275	0	\N	\N	288798	0	228557008	4043071	
25960	2272	4295880	2000-05-20	2000-05-20 00:00:00	38000275	0	\N	\N	151054	0	76601001	4295880	
37988	3355	4170947	1977-11-15	1977-11-15 00:00:00	38000275	0	\N	\N	222506	0	274474001	4170947	
38180	3370	4107731	1990-10-28	1990-10-28 00:00:00	38000275	0	\N	\N	223400	0	180256009	4107731	
38519	3386	4125906	1986-02-24	1986-02-24 00:00:00	38000275	0	\N	\N	224630	0	288086009	4125906	
38658	3399	4107731	1998-10-26	1998-10-26 00:00:00	38000275	0	\N	\N	225534	0	180256009	4107731	
26875	2349	4125906	1974-02-03	1974-02-03 00:00:00	38000275	0	\N	\N	156411	0	288086009	4125906	
27100	2369	4107731	1995-09-24	1995-09-24 00:00:00	38000275	0	\N	\N	157692	0	180256009	4107731	
39117	3454	4125906	2005-09-07	2005-09-07 00:00:00	38000275	0	\N	\N	229143	0	288086009	4125906	
39312	3464	4107731	2011-12-09	2011-12-09 00:00:00	38000275	0	\N	\N	229917	0	180256009	4107731	
27556	2402	4107731	1992-12-28	1992-12-28 00:00:00	38000275	0	\N	\N	159686	0	180256009	4107731	
39678	3488	4035793	2008-02-29	2008-02-29 00:00:00	38000275	0	\N	\N	231411	0	15081005	4035793	
39836	3509	4125906	1973-06-10	1973-06-10 00:00:00	38000275	0	\N	\N	232791	0	288086009	4125906	
40128	3527	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	234080	0	180256009	4107731	
40300	3529	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	234369	0	180256009	4107731	
28580	2541	4202451	1998-08-10	1998-08-10 00:00:00	38000275	0	\N	\N	168027	0	433112001	4202451	
40685	3571	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	237358	0	180256009	4107731	
40817	3582	4047491	1989-09-01	1989-09-01 00:00:00	38000275	0	\N	\N	238122	0	1225002	4047491	
29025	2564	4043071	1988-11-01	1988-11-01 00:00:00	38000275	0	\N	\N	169832	0	228557008	4043071	
29358	2617	4151422	1956-09-16	1956-09-16 00:00:00	38000275	0	\N	\N	173042	0	269911007	4151422	
41404	3631	4058899	1981-03-31	1981-03-31 00:00:00	38000275	0	\N	\N	241581	0	168594001	4058899	
53512	4642	4197460	1957-06-05	1957-06-05 00:00:00	38000275	0	\N	\N	309391	0	313191000	4197460	
41846	3689	4078793	2015-04-27	2015-04-27 00:00:00	38000275	0	\N	\N	245198	0	180325003	4078793	
41939	3695	4107731	1994-10-31	1994-10-31 00:00:00	38000275	0	\N	\N	245672	0	180256009	4107731	
42109	3714	4078793	2016-01-06	2016-01-06 00:00:00	38000275	0	\N	\N	246842	0	180325003	4078793	
42439	3744	4107731	2006-04-19	2006-04-19 00:00:00	38000275	0	\N	\N	248782	0	180256009	4107731	
30626	2711	4107731	1992-12-28	1992-12-28 00:00:00	38000275	0	\N	\N	179724	0	180256009	4107731	
30848	2732	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	180918	0	180256009	4107731	
42903	3783	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	251327	0	180256009	4107731	
43183	3811	4195803	2000-08-24	2000-08-24 00:00:00	38000275	0	\N	\N	253235	0	312681000	4195803	
31289	2770	4195803	2004-11-04	2004-11-04 00:00:00	38000275	0	\N	\N	183305	0	312681000	4195803	
31570	2779	4107731	1996-10-30	1996-10-30 00:00:00	38000275	0	\N	\N	184119	0	180256009	4107731	
43707	3865	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	256655	0	180256009	4107731	
43915	3876	4107731	1992-03-09	1992-03-09 00:00:00	38000275	0	\N	\N	257455	0	180256009	4107731	
44080	3884	4043071	1988-08-20	1988-08-20 00:00:00	38000275	0	\N	\N	258089	0	228557008	4043071	
32165	2827	4195803	1987-05-28	1987-05-28 00:00:00	38000275	0	\N	\N	187513	0	312681000	4195803	
56398	4923	4125906	2014-09-05	2014-09-05 00:00:00	38000275	0	\N	\N	327127	0	288086009	4125906	
44663	3916	4295880	1993-06-30	1993-06-30 00:00:00	38000275	0	\N	\N	260303	0	76601001	4295880	
56698	4932	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	327917	0	180256009	4107731	
33082	2898	4107731	1992-12-22	1992-12-22 00:00:00	38000275	0	\N	\N	192999	0	180256009	4107731	
33139	2898	4107731	1993-02-02	1993-02-02 00:00:00	38000275	0	\N	\N	193000	0	180256009	4107731	
33384	2917	4078793	2019-02-27	2019-02-27 00:00:00	38000275	0	\N	\N	194473	0	180325003	4078793	
57497	4977	4163951	2010-12-07	2010-12-07 00:00:00	38000275	0	\N	\N	331120	0	29303009	4163951	
45656	4026	4107731	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	267724	0	180256009	4107731	
45927	4033	4043071	1981-07-02	1981-07-02 00:00:00	38000275	0	\N	\N	268357	0	228557008	4043071	
34188	2970	4107731	2000-04-27	2000-04-27 00:00:00	38000275	0	\N	\N	198336	0	180256009	4107731	
34323	2975	4107731	1992-11-22	1992-11-22 00:00:00	38000275	0	\N	\N	198595	0	180256009	4107731	
34498	2986	4035793	2018-06-12	2018-06-12 00:00:00	38000275	0	\N	\N	199308	0	15081005	4035793	
46719	4105	4125906	2000-11-14	2000-11-14 00:00:00	38000275	0	\N	\N	272707	0	288086009	4125906	
34951	3041	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	202488	0	180256009	4107731	
59034	5117	4107731	1991-02-04	1991-02-04 00:00:00	38000275	0	\N	\N	340073	0	180256009	4107731	
35338	3087	40492359	2001-02-28	2001-02-28 00:00:00	38000275	0	\N	\N	205557	0	447365002	40492359	
47475	4167	4107731	1993-09-08	1993-09-08 00:00:00	38000275	0	\N	\N	276896	0	180256009	4107731	
35691	3123	4295880	2007-04-25	2007-04-25 00:00:00	38000275	0	\N	\N	207784	0	76601001	4295880	
35798	3133	4047491	1972-09-25	1972-09-25 00:00:00	38000275	0	\N	\N	208509	0	1225002	4047491	
24011	2087	4125906	1950-11-21	1950-11-21 00:00:00	38000275	0	\N	\N	139100	0	288086009	4125906	
36203	3176	4107731	2005-06-05	2005-06-05 00:00:00	38000275	0	\N	\N	211190	0	180256009	4107731	
24447	2136	4107731	2002-07-05	2002-07-05 00:00:00	38000275	0	\N	\N	142200	0	180256009	4107731	
36565	3215	4107731	2003-05-03	2003-05-03 00:00:00	38000275	0	\N	\N	213654	0	180256009	4107731	
36764	3236	4078793	1997-02-07	1997-02-07 00:00:00	38000275	0	\N	\N	215097	0	180325003	4078793	
36843	3241	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	215532	0	180256009	4107731	
37084	3259	4163872	1969-12-08	1969-12-08 00:00:00	38000275	0	\N	\N	216670	0	399208008	4163872	
37264	3279	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	217851	0	180256009	4107731	
37448	3300	4198190	1986-08-06	1986-08-06 00:00:00	38000275	0	\N	\N	219244	0	80146002	4198190	
49559	4353	44783196	1972-11-10	1972-11-10 00:00:00	38000275	0	\N	\N	288789	0	699253003	44783196	
25961	2272	4295880	1998-05-23	1998-05-23 00:00:00	38000275	0	\N	\N	151024	0	76601001	4295880	
37989	3355	4047491	1986-07-31	1986-07-31 00:00:00	38000275	0	\N	\N	222507	0	1225002	4047491	
38181	3370	4107731	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	223438	0	180256009	4107731	
38520	3386	4125906	1988-12-31	1988-12-31 00:00:00	38000275	0	\N	\N	224631	0	288086009	4125906	
38659	3399	4107731	1998-01-05	1998-01-05 00:00:00	38000275	0	\N	\N	225459	0	180256009	4107731	
26876	2349	4107731	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	156381	0	180256009	4107731	
27101	2369	4107731	1997-02-09	1997-02-09 00:00:00	38000275	0	\N	\N	157652	0	180256009	4107731	
39118	3454	4293740	2005-09-07	2005-09-07 00:00:00	38000275	0	\N	\N	229143	0	384700001	4293740	
39313	3464	4107731	2012-10-19	2012-10-19 00:00:00	38000275	0	\N	\N	229942	0	180256009	4107731	
27557	2402	4107731	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	159594	0	180256009	4107731	
39679	3488	4035793	2013-03-29	2013-03-29 00:00:00	38000275	0	\N	\N	231372	0	15081005	4035793	
39837	3509	4195803	2011-03-26	2011-03-26 00:00:00	38000275	0	\N	\N	232794	0	312681000	4195803	
40129	3527	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	234082	0	180256009	4107731	
40301	3529	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	234361	0	180256009	4107731	
28581	2541	4058899	2003-11-06	2003-11-06 00:00:00	38000275	0	\N	\N	168022	0	168594001	4058899	
40686	3571	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	237350	0	180256009	4107731	
40818	3582	4195803	2011-12-03	2011-12-03 00:00:00	38000275	0	\N	\N	238125	0	312681000	4195803	
29026	2564	4043071	1987-12-29	1987-12-29 00:00:00	38000275	0	\N	\N	169828	0	228557008	4043071	
29359	2617	4151422	1969-08-28	1969-08-28 00:00:00	38000275	0	\N	\N	173059	0	269911007	4151422	
41405	3631	4151422	1994-03-03	1994-03-03 00:00:00	38000275	0	\N	\N	241604	0	269911007	4151422	
53513	4642	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	309384	0	180256009	4107731	
41847	3689	4078793	2017-10-16	2017-10-16 00:00:00	38000275	0	\N	\N	245245	0	180325003	4078793	
41940	3695	4107731	1995-09-11	1995-09-11 00:00:00	38000275	0	\N	\N	245635	0	180256009	4107731	
42110	3714	4057420	2014-12-31	2014-12-31 00:00:00	38000275	0	\N	\N	246856	0	18286008	4057420	
42440	3744	4107731	2004-01-21	2004-01-21 00:00:00	38000275	0	\N	\N	248755	0	180256009	4107731	
30627	2711	4107731	1992-10-26	1992-10-26 00:00:00	38000275	0	\N	\N	179671	0	180256009	4107731	
30849	2732	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	180896	0	180256009	4107731	
42904	3783	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	251350	0	180256009	4107731	
43184	3811	4151422	1929-06-13	1929-06-13 00:00:00	38000275	0	\N	\N	253211	0	269911007	4151422	
31290	2770	4107731	1991-12-21	1991-12-21 00:00:00	38000275	0	\N	\N	183292	0	180256009	4107731	
31571	2779	4107731	1996-12-11	1996-12-11 00:00:00	38000275	0	\N	\N	184165	0	180256009	4107731	
43708	3865	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	256591	0	180256009	4107731	
43916	3876	4107731	1990-06-18	1990-06-18 00:00:00	38000275	0	\N	\N	257496	0	180256009	4107731	
44081	3884	4107731	1990-08-20	1990-08-20 00:00:00	38000275	0	\N	\N	258166	0	180256009	4107731	
32166	2827	4293740	1968-03-19	1968-03-19 00:00:00	38000275	0	\N	\N	187511	0	384700001	4293740	
56399	4923	4058899	1977-01-24	1977-01-24 00:00:00	38000275	0	\N	\N	327124	0	168594001	4058899	
44664	3916	4295880	1994-03-30	1994-03-30 00:00:00	38000275	0	\N	\N	260319	0	76601001	4295880	
56699	4932	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	327901	0	180256009	4107731	
33083	2898	4107731	1994-09-13	1994-09-13 00:00:00	38000275	0	\N	\N	192970	0	180256009	4107731	
33140	2898	4107731	1992-07-07	1992-07-07 00:00:00	38000275	0	\N	\N	193009	0	180256009	4107731	
33385	2917	4078793	1993-10-06	1993-10-06 00:00:00	38000275	0	\N	\N	194516	0	180325003	4078793	
57498	4977	4202832	2010-12-08	2010-12-08 00:00:00	38000275	0	\N	\N	331120	0	52765003	4202832	
45657	4026	4191853	1977-02-07	1977-02-07 00:00:00	38000275	0	\N	\N	267662	0	395142003	4191853	
45928	4033	4043071	1979-04-11	1979-04-11 00:00:00	38000275	0	\N	\N	268341	0	228557008	4043071	
34189	2970	4107731	2000-11-23	2000-11-23 00:00:00	38000275	0	\N	\N	198311	0	180256009	4107731	
34324	2975	4191853	1993-07-11	1993-07-11 00:00:00	38000275	0	\N	\N	198641	0	395142003	4191853	
34499	2986	4035793	2007-02-27	2007-02-27 00:00:00	38000275	0	\N	\N	199304	0	15081005	4035793	
46720	4105	4125906	1960-09-24	1960-09-24 00:00:00	38000275	0	\N	\N	272706	0	288086009	4125906	
34952	3041	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	202521	0	180256009	4107731	
59035	5117	4107731	1992-02-17	1992-02-17 00:00:00	38000275	0	\N	\N	340065	0	180256009	4107731	
35339	3087	4057420	2001-02-28	2001-02-28 00:00:00	38000275	0	\N	\N	205557	0	18286008	4057420	
47476	4167	4107731	1994-12-14	1994-12-14 00:00:00	38000275	0	\N	\N	276885	0	180256009	4107731	
35692	3123	4059978	2008-04-04	2008-04-04 00:00:00	38000275	0	\N	\N	207849	0	169553002	4059978	
35799	3134	4078793	2013-03-21	2013-03-21 00:00:00	38000275	0	\N	\N	208593	0	180325003	4078793	
24012	2087	4202451	2011-06-15	2011-06-15 00:00:00	38000275	0	\N	\N	139063	0	433112001	4202451	
36204	3176	4107731	2003-03-09	2003-03-09 00:00:00	38000275	0	\N	\N	211132	0	180256009	4107731	
24448	2136	4107731	2004-10-22	2004-10-22 00:00:00	38000275	0	\N	\N	142292	0	180256009	4107731	
36566	3215	4107731	2004-06-26	2004-06-26 00:00:00	38000275	0	\N	\N	213678	0	180256009	4107731	
36765	3236	4057420	2011-08-19	2011-08-19 00:00:00	38000275	0	\N	\N	215093	0	18286008	4057420	
36844	3241	4170947	1987-03-19	1987-03-19 00:00:00	38000275	0	\N	\N	215442	0	274474001	4170947	
37085	3260	4125906	1983-09-09	1983-09-09 00:00:00	38000275	0	\N	\N	216750	0	288086009	4125906	
37265	3279	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	217848	0	180256009	4107731	
37449	3301	4170947	1948-06-11	1948-06-11 00:00:00	38000275	0	\N	\N	219261	0	274474001	4170947	
49560	4353	4043071	1980-03-26	1980-03-26 00:00:00	38000275	0	\N	\N	288809	0	228557008	4043071	
25962	2272	4295880	2003-11-15	2003-11-15 00:00:00	38000275	0	\N	\N	151029	0	76601001	4295880	
37990	3355	4170947	1986-07-31	1986-07-31 00:00:00	38000275	0	\N	\N	222507	0	274474001	4170947	
38182	3370	4107731	1991-08-18	1991-08-18 00:00:00	38000275	0	\N	\N	223519	0	180256009	4107731	
38521	3386	4170947	1984-12-31	1984-12-31 00:00:00	38000275	0	\N	\N	224629	0	274474001	4170947	
38660	3399	4107731	1997-02-03	1997-02-03 00:00:00	38000275	0	\N	\N	225517	0	180256009	4107731	
26877	2349	4107731	1992-11-01	1992-11-01 00:00:00	38000275	0	\N	\N	156429	0	180256009	4107731	
27102	2369	4107731	1996-06-02	1996-06-02 00:00:00	38000275	0	\N	\N	157640	0	180256009	4107731	
39119	3455	4181917	1991-07-16	1991-07-16 00:00:00	38000275	0	\N	\N	229258	0	54550000	4181917	
39314	3464	4107731	2010-11-26	2010-11-26 00:00:00	38000275	0	\N	\N	229969	0	180256009	4107731	
27558	2402	4107731	1991-01-14	1991-01-14 00:00:00	38000275	0	\N	\N	159591	0	180256009	4107731	
39680	3488	4043071	1965-03-16	1965-03-16 00:00:00	38000275	0	\N	\N	231370	0	228557008	4043071	
39838	3509	4047491	2011-03-26	2011-03-26 00:00:00	38000275	0	\N	\N	232794	0	1225002	4047491	
40130	3527	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	234133	0	180256009	4107731	
40302	3529	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	234363	0	180256009	4107731	
28582	2541	4275113	1991-09-17	1991-09-17 00:00:00	38000275	0	\N	\N	168035	0	65200003	4275113	
40687	3571	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	237406	0	180256009	4107731	
40819	3582	4024289	2011-12-03	2011-12-03 00:00:00	38000275	0	\N	\N	238125	0	19490002	4024289	
29027	2564	4043071	1988-02-23	1988-02-23 00:00:00	38000275	0	\N	\N	169848	0	228557008	4043071	
41141	3604	4107731	1999-10-08	1999-10-08 00:00:00	38000275	0	\N	\N	239549	0	180256009	4107731	
41406	3631	4293740	2006-04-19	2006-04-19 00:00:00	38000275	0	\N	\N	241582	0	384700001	4293740	
53514	4642	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	309423	0	180256009	4107731	
41848	3689	4078793	2011-04-04	2011-04-04 00:00:00	38000275	0	\N	\N	245243	0	180325003	4078793	
41941	3695	4107731	1995-10-02	1995-10-02 00:00:00	38000275	0	\N	\N	245658	0	180256009	4107731	
42116	3717	4107731	1993-01-23	1993-01-23 00:00:00	38000275	0	\N	\N	247044	0	180256009	4107731	
42441	3744	4107731	2006-03-29	2006-03-29 00:00:00	38000275	0	\N	\N	248776	0	180256009	4107731	
30628	2711	4107731	1990-01-22	1990-01-22 00:00:00	38000275	0	\N	\N	179685	0	180256009	4107731	
30850	2732	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	180925	0	180256009	4107731	
42905	3783	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	251324	0	180256009	4107731	
43185	3811	4151422	1932-05-17	1932-05-17 00:00:00	38000275	0	\N	\N	253143	0	269911007	4151422	
31291	2770	4107731	1993-03-27	1993-03-27 00:00:00	38000275	0	\N	\N	183329	0	180256009	4107731	
31572	2779	4107731	1995-11-08	1995-11-08 00:00:00	38000275	0	\N	\N	184114	0	180256009	4107731	
43709	3865	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	256652	0	180256009	4107731	
43917	3876	4107731	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	257497	0	180256009	4107731	
44082	3884	4043071	1989-02-04	1989-02-04 00:00:00	38000275	0	\N	\N	258137	0	228557008	4043071	
32167	2827	4125906	1968-03-19	1968-03-19 00:00:00	38000275	0	\N	\N	187511	0	288086009	4125906	
56400	4923	4186930	1987-10-06	1987-10-06 00:00:00	38000275	0	\N	\N	327099	0	46706006	4186930	
44665	3916	4107731	1994-01-05	1994-01-05 00:00:00	38000275	0	\N	\N	260416	0	180256009	4107731	
56700	4932	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	327881	0	180256009	4107731	
33084	2898	4295880	1996-01-09	1996-01-09 00:00:00	38000275	0	\N	\N	193060	0	76601001	4295880	
33141	2898	4295880	1994-01-07	1994-01-07 00:00:00	38000275	0	\N	\N	193056	0	76601001	4295880	
33386	2917	4078793	2004-12-08	2004-12-08 00:00:00	38000275	0	\N	\N	194519	0	180325003	4078793	
57499	4977	4242997	2010-12-08	2010-12-08 00:00:00	38000275	0	\N	\N	331120	0	38102005	4242997	
45658	4026	4107731	1990-10-28	1990-10-28 00:00:00	38000275	0	\N	\N	267773	0	180256009	4107731	
45929	4033	4043071	1981-10-08	1981-10-08 00:00:00	38000275	0	\N	\N	268381	0	228557008	4043071	
34190	2970	4107731	2002-09-05	2002-09-05 00:00:00	38000275	0	\N	\N	198290	0	180256009	4107731	
34325	2975	4107731	1991-11-10	1991-11-10 00:00:00	38000275	0	\N	\N	198619	0	180256009	4107731	
34500	2986	4035793	2011-03-22	2011-03-22 00:00:00	38000275	0	\N	\N	199323	0	15081005	4035793	
46721	4105	4202451	2019-02-16	2019-02-16 00:00:00	38000275	0	\N	\N	272705	0	433112001	4202451	
34953	3044	4125906	1998-02-09	1998-02-09 00:00:00	38000275	0	\N	\N	202622	0	288086009	4125906	
59036	5117	4107731	1993-02-08	1993-02-08 00:00:00	38000275	0	\N	\N	340150	0	180256009	4107731	
35340	3087	4151422	1993-10-08	1993-10-08 00:00:00	38000275	0	\N	\N	205505	0	269911007	4151422	
47477	4167	4107731	1995-01-04	1995-01-04 00:00:00	38000275	0	\N	\N	276976	0	180256009	4107731	
35693	3123	4295880	2009-07-22	2009-07-22 00:00:00	38000275	0	\N	\N	207853	0	76601001	4295880	
35800	3134	4078793	2010-03-04	2010-03-04 00:00:00	38000275	0	\N	\N	208617	0	180325003	4078793	
24013	2087	4195803	1998-07-01	1998-07-01 00:00:00	38000275	0	\N	\N	139057	0	312681000	4195803	
36205	3176	4107731	2003-02-16	2003-02-16 00:00:00	38000275	0	\N	\N	211088	0	180256009	4107731	
24449	2136	4107731	2002-07-26	2002-07-26 00:00:00	38000275	0	\N	\N	142202	0	180256009	4107731	
36567	3215	4107731	2003-09-06	2003-09-06 00:00:00	38000275	0	\N	\N	213644	0	180256009	4107731	
36766	3236	4057420	2017-09-22	2017-09-22 00:00:00	38000275	0	\N	\N	215109	0	18286008	4057420	
36845	3241	4243062	1987-03-19	1987-03-19 00:00:00	38000275	0	\N	\N	215442	0	60027007	4243062	
37086	3260	4125906	1968-11-05	1968-11-05 00:00:00	38000275	0	\N	\N	216749	0	288086009	4125906	
37266	3279	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	217941	0	180256009	4107731	
37450	3301	4024289	1948-06-11	1948-06-11 00:00:00	38000275	0	\N	\N	219261	0	19490002	4024289	
49561	4353	4043071	1980-08-27	1980-08-27 00:00:00	38000275	0	\N	\N	288780	0	228557008	4043071	
25963	2274	4151422	1958-06-29	1958-06-29 00:00:00	38000275	0	\N	\N	151190	0	269911007	4151422	
37991	3355	4151422	2002-02-08	2002-02-08 00:00:00	38000275	0	\N	\N	222464	0	269911007	4151422	
38183	3370	4191853	1993-07-11	1993-07-11 00:00:00	38000275	0	\N	\N	223481	0	395142003	4191853	
38522	3386	4163872	1984-12-31	1984-12-31 00:00:00	38000275	0	\N	\N	224629	0	399208008	4163872	
38661	3399	4107731	1997-12-15	1997-12-15 00:00:00	38000275	0	\N	\N	225431	0	180256009	4107731	
26878	2349	4107731	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	156427	0	180256009	4107731	
27103	2369	4107731	1996-08-25	1996-08-25 00:00:00	38000275	0	\N	\N	157702	0	180256009	4107731	
39120	3455	4181917	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	229257	0	54550000	4181917	
39315	3464	4170947	2004-01-09	2004-01-09 00:00:00	38000275	0	\N	\N	229948	0	274474001	4170947	
27559	2402	4107731	1992-06-01	1992-06-01 00:00:00	38000275	0	\N	\N	159695	0	180256009	4107731	
39681	3488	4035793	2006-02-17	2006-02-17 00:00:00	38000275	0	\N	\N	231410	0	15081005	4035793	
39839	3509	4170947	2011-03-26	2011-03-26 00:00:00	38000275	0	\N	\N	232794	0	274474001	4170947	
40131	3527	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	234079	0	180256009	4107731	
40303	3529	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	234380	0	180256009	4107731	
28583	2541	4151422	1989-04-28	1989-04-28 00:00:00	38000275	0	\N	\N	168052	0	269911007	4151422	
40688	3571	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	237361	0	180256009	4107731	
40820	3582	4170947	2011-12-03	2011-12-03 00:00:00	38000275	0	\N	\N	238125	0	274474001	4170947	
29028	2564	4043071	1986-12-30	1986-12-30 00:00:00	38000275	0	\N	\N	169821	0	228557008	4043071	
41142	3604	4191853	1984-12-12	1984-12-12 00:00:00	38000275	0	\N	\N	239520	0	395142003	4191853	
41407	3631	4125906	2006-04-19	2006-04-19 00:00:00	38000275	0	\N	\N	241582	0	288086009	4125906	
53515	4642	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	309403	0	180256009	4107731	
41849	3689	4078793	2018-10-22	2018-10-22 00:00:00	38000275	0	\N	\N	245165	0	180325003	4078793	
41942	3695	4107731	1995-12-04	1995-12-04 00:00:00	38000275	0	\N	\N	245637	0	180256009	4107731	
42117	3717	4107731	1990-12-29	1990-12-29 00:00:00	38000275	0	\N	\N	247022	0	180256009	4107731	
42442	3744	4107731	2004-05-05	2004-05-05 00:00:00	38000275	0	\N	\N	248801	0	180256009	4107731	
30629	2711	4107731	1991-01-14	1991-01-14 00:00:00	38000275	0	\N	\N	179691	0	180256009	4107731	
30851	2732	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	180851	0	180256009	4107731	
42906	3783	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	251340	0	180256009	4107731	
43186	3811	4151422	1932-08-24	1932-08-24 00:00:00	38000275	0	\N	\N	253144	0	269911007	4151422	
31292	2770	4107731	1992-02-01	1992-02-01 00:00:00	38000275	0	\N	\N	183294	0	180256009	4107731	
31573	2779	4107731	1998-01-14	1998-01-14 00:00:00	38000275	0	\N	\N	184141	0	180256009	4107731	
43710	3865	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	256587	0	180256009	4107731	
43918	3876	4107731	1992-12-28	1992-12-28 00:00:00	38000275	0	\N	\N	257415	0	180256009	4107731	
44083	3884	4107731	1990-01-22	1990-01-22 00:00:00	38000275	0	\N	\N	258095	0	180256009	4107731	
32183	2829	4047491	1978-02-09	1978-02-09 00:00:00	38000275	0	\N	\N	187670	0	1225002	4047491	
56401	4923	4202451	2018-06-19	2018-06-19 00:00:00	38000275	0	\N	\N	327147	0	433112001	4202451	
44666	3916	4107731	1992-07-29	1992-07-29 00:00:00	38000275	0	\N	\N	260400	0	180256009	4107731	
56701	4932	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	327889	0	180256009	4107731	
33085	2898	4107731	1995-02-28	1995-02-28 00:00:00	38000275	0	\N	\N	193071	0	180256009	4107731	
33142	2898	4295880	1995-04-11	1995-04-11 00:00:00	38000275	0	\N	\N	193059	0	76601001	4295880	
33388	2919	4198190	1965-08-17	1965-08-17 00:00:00	38000275	0	\N	\N	194614	0	80146002	4198190	
57500	4977	4163872	1990-08-13	1990-08-13 00:00:00	38000275	0	\N	\N	331163	0	399208008	4163872	
45659	4026	4107731	1992-04-26	1992-04-26 00:00:00	38000275	0	\N	\N	267779	0	180256009	4107731	
45930	4033	4043071	1981-12-09	1981-12-09 00:00:00	38000275	0	\N	\N	268350	0	228557008	4043071	
34191	2970	4151422	2003-10-05	2003-10-05 00:00:00	38000275	0	\N	\N	198291	0	269911007	4151422	
34326	2975	4107731	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	198687	0	180256009	4107731	
34501	2986	4035793	2012-03-27	2012-03-27 00:00:00	38000275	0	\N	\N	199317	0	15081005	4035793	
46722	4105	4151422	2009-02-16	2009-02-16 00:00:00	38000275	0	\N	\N	272730	0	269911007	4151422	
34957	3047	4295880	1996-12-11	1996-12-11 00:00:00	38000275	0	\N	\N	202780	0	76601001	4295880	
59037	5117	4107731	1992-03-30	1992-03-30 00:00:00	38000275	0	\N	\N	340146	0	180256009	4107731	
35341	3087	4163872	1966-11-25	1966-11-25 00:00:00	38000275	0	\N	\N	205531	0	399208008	4163872	
47478	4167	4107731	1994-02-02	1994-02-02 00:00:00	38000275	0	\N	\N	276983	0	180256009	4107731	
35694	3123	4295880	2004-04-25	2004-04-25 00:00:00	38000275	0	\N	\N	207840	0	76601001	4295880	
35801	3134	4151422	1974-03-22	1974-03-22 00:00:00	38000275	0	\N	\N	208559	0	269911007	4151422	
24014	2088	4125906	1955-09-21	1955-09-21 00:00:00	38000275	0	\N	\N	139179	0	288086009	4125906	
36206	3176	4107731	2005-04-24	2005-04-24 00:00:00	38000275	0	\N	\N	211189	0	180256009	4107731	
24450	2136	4107731	2002-10-18	2002-10-18 00:00:00	38000275	0	\N	\N	142204	0	180256009	4107731	
36568	3215	4107731	2005-06-18	2005-06-18 00:00:00	38000275	0	\N	\N	213593	0	180256009	4107731	
36767	3236	4057420	1983-12-30	1983-12-30 00:00:00	38000275	0	\N	\N	215079	0	18286008	4057420	
36846	3241	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	215505	0	180256009	4107731	
37087	3260	4125906	2013-06-08	2013-06-08 00:00:00	38000275	0	\N	\N	216753	0	288086009	4125906	
37267	3279	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	217915	0	180256009	4107731	
37451	3301	4125906	2016-12-30	2016-12-30 00:00:00	38000275	0	\N	\N	219288	0	288086009	4125906	
49562	4353	4043071	1979-08-15	1979-08-15 00:00:00	38000275	0	\N	\N	288754	0	228557008	4043071	
25964	2274	4151422	2003-11-05	2003-11-05 00:00:00	38000275	0	\N	\N	151193	0	269911007	4151422	
38073	3362	4125906	2013-11-22	2013-11-22 00:00:00	38000275	0	\N	\N	222896	0	288086009	4125906	
38184	3370	4107731	1992-02-23	1992-02-23 00:00:00	38000275	0	\N	\N	223436	0	180256009	4107731	
50304	4376	4035793	1993-09-21	1993-09-21 00:00:00	38000275	0	\N	\N	290806	0	15081005	4035793	
38662	3399	4107731	1998-06-02	1998-06-02 00:00:00	38000275	0	\N	\N	225475	0	180256009	4107731	
26879	2349	4107731	1991-02-10	1991-02-10 00:00:00	38000275	0	\N	\N	156421	0	180256009	4107731	
27104	2369	4107731	1997-03-23	1997-03-23 00:00:00	38000275	0	\N	\N	157653	0	180256009	4107731	
39121	3455	4181917	1994-05-23	1994-05-23 00:00:00	38000275	0	\N	\N	229259	0	54550000	4181917	
39316	3464	4243062	2004-01-09	2004-01-09 00:00:00	38000275	0	\N	\N	229948	0	60027007	4243062	
27560	2402	4107731	1992-03-30	1992-03-30 00:00:00	38000275	0	\N	\N	159683	0	180256009	4107731	
39682	3488	4035793	2007-02-23	2007-02-23 00:00:00	38000275	0	\N	\N	231376	0	15081005	4035793	
39840	3509	4243062	2015-12-30	2015-12-30 00:00:00	38000275	0	\N	\N	232795	0	60027007	4243062	
40132	3527	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	234120	0	180256009	4107731	
40304	3529	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	234408	0	180256009	4107731	
28584	2541	4151422	1994-04-11	1994-04-11 00:00:00	38000275	0	\N	\N	168053	0	269911007	4151422	
40689	3571	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	237351	0	180256009	4107731	
40821	3582	4323902	2015-09-13	2015-09-13 00:00:00	38000275	0	\N	\N	238164	0	429609002	4323902	
29030	2566	4195803	2015-11-22	2015-11-22 00:00:00	38000275	0	\N	\N	169984	0	312681000	4195803	
41143	3604	4107731	2000-02-11	2000-02-11 00:00:00	38000275	0	\N	\N	239493	0	180256009	4107731	
41408	3633	4145310	1979-10-03	1979-10-03 00:00:00	38000275	0	\N	\N	241652	0	268425006	4145310	
53516	4642	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	309475	0	180256009	4107731	
41850	3689	4078793	2016-10-10	2016-10-10 00:00:00	38000275	0	\N	\N	245175	0	180325003	4078793	
41943	3695	4107731	1994-01-31	1994-01-31 00:00:00	38000275	0	\N	\N	245669	0	180256009	4107731	
42118	3717	4043071	1983-08-06	1983-08-06 00:00:00	38000275	0	\N	\N	246955	0	228557008	4043071	
42443	3744	4107731	2005-09-21	2005-09-21 00:00:00	38000275	0	\N	\N	248775	0	180256009	4107731	
30630	2711	4107731	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	179680	0	180256009	4107731	
30852	2732	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	180914	0	180256009	4107731	
42907	3783	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	251325	0	180256009	4107731	
43187	3811	4170947	1927-05-22	1927-05-22 00:00:00	38000275	0	\N	\N	253140	0	274474001	4170947	
31293	2770	4107731	1991-10-19	1991-10-19 00:00:00	38000275	0	\N	\N	183318	0	180256009	4107731	
31574	2779	4107731	1998-02-25	1998-02-25 00:00:00	38000275	0	\N	\N	184109	0	180256009	4107731	
43711	3865	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	256662	0	180256009	4107731	
43919	3876	4107731	1992-06-01	1992-06-01 00:00:00	38000275	0	\N	\N	257462	0	180256009	4107731	
44084	3884	4043071	1987-11-14	1987-11-14 00:00:00	38000275	0	\N	\N	258030	0	228557008	4043071	
32184	2829	4170947	1978-02-09	1978-02-09 00:00:00	38000275	0	\N	\N	187670	0	274474001	4170947	
56402	4923	4275113	1982-10-09	1982-10-09 00:00:00	38000275	0	\N	\N	327087	0	65200003	4275113	
44667	3916	4043071	1989-10-29	1989-10-29 00:00:00	38000275	0	\N	\N	260265	0	228557008	4043071	
56702	4932	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	327854	0	180256009	4107731	
33086	2898	4107731	1995-07-04	1995-07-04 00:00:00	38000275	0	\N	\N	193109	0	180256009	4107731	
33143	2898	4107731	1994-01-04	1994-01-04 00:00:00	38000275	0	\N	\N	193103	0	180256009	4107731	
33389	2919	4202451	1996-06-15	1996-06-15 00:00:00	38000275	0	\N	\N	194646	0	433112001	4202451	
57501	4979	4163872	1978-03-15	1978-03-15 00:00:00	38000275	0	\N	\N	331243	0	399208008	4163872	
45660	4026	4107731	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	267781	0	180256009	4107731	
45931	4033	4043071	1979-06-14	1979-06-14 00:00:00	38000275	0	\N	\N	268313	0	228557008	4043071	
34192	2970	4107731	2000-09-21	2000-09-21 00:00:00	38000275	0	\N	\N	198360	0	180256009	4107731	
34327	2975	4107731	1990-11-18	1990-11-18 00:00:00	38000275	0	\N	\N	198698	0	180256009	4107731	
34502	2986	4035793	2005-02-15	2005-02-15 00:00:00	38000275	0	\N	\N	199303	0	15081005	4035793	
46723	4106	4125906	1963-01-21	1963-01-21 00:00:00	38000275	0	\N	\N	272860	0	288086009	4125906	
34958	3047	4295880	1996-09-11	1996-09-11 00:00:00	38000275	0	\N	\N	202743	0	76601001	4295880	
59038	5117	4107731	1991-04-08	1991-04-08 00:00:00	38000275	0	\N	\N	340027	0	180256009	4107731	
35342	3087	4047491	1996-07-15	1996-07-15 00:00:00	38000275	0	\N	\N	205556	0	1225002	4047491	
47479	4167	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	276893	0	180256009	4107731	
35695	3123	4295880	2005-04-27	2005-04-27 00:00:00	38000275	0	\N	\N	207801	0	76601001	4295880	
35802	3134	4078793	2014-03-27	2014-03-27 00:00:00	38000275	0	\N	\N	208601	0	180325003	4078793	
24015	2088	4145310	1992-06-18	1992-06-18 00:00:00	38000275	0	\N	\N	139183	0	268425006	4145310	
36207	3176	4107731	2002-01-13	2002-01-13 00:00:00	38000275	0	\N	\N	211172	0	180256009	4107731	
24451	2136	4107731	2002-04-12	2002-04-12 00:00:00	38000275	0	\N	\N	142198	0	180256009	4107731	
36569	3215	4107731	2005-07-09	2005-07-09 00:00:00	38000275	0	\N	\N	213653	0	180256009	4107731	
36768	3236	4078793	2018-09-28	2018-09-28 00:00:00	38000275	0	\N	\N	215108	0	180325003	4078793	
36847	3241	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	215522	0	180256009	4107731	
37088	3260	4293740	2013-06-08	2013-06-08 00:00:00	38000275	0	\N	\N	216753	0	384700001	4293740	
37268	3279	4170947	1995-03-27	1995-03-27 00:00:00	38000275	0	\N	\N	217921	0	274474001	4170947	
37452	3301	4170947	2011-05-31	2011-05-31 00:00:00	38000275	0	\N	\N	219287	0	274474001	4170947	
49563	4353	4243062	1980-08-30	1980-08-30 00:00:00	38000275	0	\N	\N	288787	0	60027007	4243062	
25965	2274	4125906	1966-07-26	1966-07-26 00:00:00	38000275	0	\N	\N	151207	0	288086009	4125906	
38074	3362	4125906	1986-12-11	1986-12-11 00:00:00	38000275	0	\N	\N	222892	0	288086009	4125906	
38185	3370	4107731	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	223440	0	180256009	4107731	
50305	4376	4078793	1993-09-21	1993-09-21 00:00:00	38000275	0	\N	\N	290806	0	180325003	4078793	
38663	3399	4107731	1997-03-17	1997-03-17 00:00:00	38000275	0	\N	\N	225480	0	180256009	4107731	
26880	2349	4107731	1991-03-03	1991-03-03 00:00:00	38000275	0	\N	\N	156390	0	180256009	4107731	
27105	2369	4107731	1994-11-13	1994-11-13 00:00:00	38000275	0	\N	\N	157681	0	180256009	4107731	
39122	3455	4151422	2000-05-15	2000-05-15 00:00:00	38000275	0	\N	\N	229250	0	269911007	4151422	
39317	3464	4107731	2012-05-04	2012-05-04 00:00:00	38000275	0	\N	\N	229901	0	180256009	4107731	
27561	2402	4107731	1991-09-02	1991-09-02 00:00:00	38000275	0	\N	\N	159593	0	180256009	4107731	
39683	3488	4125906	1990-06-13	1990-06-13 00:00:00	38000275	0	\N	\N	231357	0	288086009	4125906	
39841	3509	4170947	2015-12-30	2015-12-30 00:00:00	38000275	0	\N	\N	232795	0	274474001	4170947	
40133	3527	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	234118	0	180256009	4107731	
40305	3529	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	234421	0	180256009	4107731	
28585	2541	4238715	1994-10-10	1994-10-10 00:00:00	38000275	0	\N	\N	168056	0	68254000	4238715	
40690	3571	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	237428	0	180256009	4107731	
40822	3583	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	238280	0	180256009	4107731	
29031	2566	4058899	2015-11-22	2015-11-22 00:00:00	38000275	0	\N	\N	169984	0	168594001	4058899	
41144	3604	4107731	1999-01-29	1999-01-29 00:00:00	38000275	0	\N	\N	239452	0	180256009	4107731	
41409	3633	4293740	1975-02-12	1975-02-12 00:00:00	38000275	0	\N	\N	241651	0	384700001	4293740	
53517	4642	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	309369	0	180256009	4107731	
41851	3689	4163872	1963-11-17	1963-11-17 00:00:00	38000275	0	\N	\N	245225	0	399208008	4163872	
41944	3695	4107731	1995-11-13	1995-11-13 00:00:00	38000275	0	\N	\N	245659	0	180256009	4107731	
42119	3717	4191853	1977-02-15	1977-02-15 00:00:00	38000275	0	\N	\N	247065	0	395142003	4191853	
42444	3744	4107731	2006-06-21	2006-06-21 00:00:00	38000275	0	\N	\N	248814	0	180256009	4107731	
30631	2711	4151422	1968-05-27	1968-05-27 00:00:00	38000275	0	\N	\N	179631	0	269911007	4151422	
30853	2732	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	180917	0	180256009	4107731	
42908	3783	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	251372	0	180256009	4107731	
43188	3811	4243062	1927-05-22	1927-05-22 00:00:00	38000275	0	\N	\N	253140	0	60027007	4243062	
31294	2770	4107731	1990-05-12	1990-05-12 00:00:00	38000275	0	\N	\N	183336	0	180256009	4107731	
31575	2779	4107731	1997-11-12	1997-11-12 00:00:00	38000275	0	\N	\N	184153	0	180256009	4107731	
43712	3865	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	256595	0	180256009	4107731	
43920	3876	4107731	1991-09-23	1991-09-23 00:00:00	38000275	0	\N	\N	257448	0	180256009	4107731	
44085	3884	4043071	1986-12-06	1986-12-06 00:00:00	38000275	0	\N	\N	258083	0	228557008	4043071	
32185	2829	4125906	1990-09-04	1990-09-04 00:00:00	38000275	0	\N	\N	187671	0	288086009	4125906	
56403	4923	4170947	1997-03-08	1997-03-08 00:00:00	38000275	0	\N	\N	327126	0	274474001	4170947	
44668	3916	4107731	1993-03-17	1993-03-17 00:00:00	38000275	0	\N	\N	260369	0	180256009	4107731	
56703	4932	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	327805	0	395142003	4191853	
33087	2898	4295880	1999-01-05	1999-01-05 00:00:00	38000275	0	\N	\N	193078	0	76601001	4295880	
33144	2898	4107731	1993-10-12	1993-10-12 00:00:00	38000275	0	\N	\N	193013	0	180256009	4107731	
33390	2919	4195803	2018-03-21	2018-03-21 00:00:00	38000275	0	\N	\N	194613	0	312681000	4195803	
57502	4979	4170947	1978-03-15	1978-03-15 00:00:00	38000275	0	\N	\N	331243	0	274474001	4170947	
45661	4026	4107731	1990-10-07	1990-10-07 00:00:00	38000275	0	\N	\N	267617	0	180256009	4107731	
45932	4033	4043071	1981-09-03	1981-09-03 00:00:00	38000275	0	\N	\N	268371	0	228557008	4043071	
34193	2970	4107731	2000-01-13	2000-01-13 00:00:00	38000275	0	\N	\N	198307	0	180256009	4107731	
34328	2975	4107731	1991-12-01	1991-12-01 00:00:00	38000275	0	\N	\N	198589	0	180256009	4107731	
34503	2987	4010253	1977-09-18	1977-09-18 00:00:00	38000275	0	\N	\N	199410	0	112790001	4010253	
46724	4107	4125906	1992-01-19	1992-01-19 00:00:00	38000275	0	\N	\N	272889	0	288086009	4125906	
34959	3047	4151422	1993-09-28	1993-09-28 00:00:00	38000275	0	\N	\N	202753	0	269911007	4151422	
59039	5117	4107731	1991-07-22	1991-07-22 00:00:00	38000275	0	\N	\N	340035	0	180256009	4107731	
35343	3087	4195803	1996-07-15	1996-07-15 00:00:00	38000275	0	\N	\N	205556	0	312681000	4195803	
47480	4167	4107731	1994-04-06	1994-04-06 00:00:00	38000275	0	\N	\N	276973	0	180256009	4107731	
35696	3123	4295880	2010-10-20	2010-10-20 00:00:00	38000275	0	\N	\N	207863	0	76601001	4295880	
35803	3134	4057420	2008-02-21	2008-02-21 00:00:00	38000275	0	\N	\N	208616	0	18286008	4057420	
24016	2088	4035793	2004-06-29	2004-06-29 00:00:00	38000275	0	\N	\N	139174	0	15081005	4035793	
36208	3176	4151422	2000-08-17	2000-08-17 00:00:00	38000275	0	\N	\N	211151	0	269911007	4151422	
24452	2136	4107731	2004-08-20	2004-08-20 00:00:00	38000275	0	\N	\N	142268	0	180256009	4107731	
36570	3215	4107731	2003-03-22	2003-03-22 00:00:00	38000275	0	\N	\N	213674	0	180256009	4107731	
36769	3236	4078793	1985-01-04	1985-01-04 00:00:00	38000275	0	\N	\N	215074	0	180325003	4078793	
36848	3241	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	215568	0	180256009	4107731	
37096	3263	4057420	2007-09-11	2007-09-11 00:00:00	38000275	0	\N	\N	216903	0	18286008	4057420	
37269	3279	4047491	1995-03-27	1995-03-27 00:00:00	38000275	0	\N	\N	217921	0	1225002	4047491	
37453	3301	4047491	2011-05-31	2011-05-31 00:00:00	38000275	0	\N	\N	219287	0	1225002	4047491	
49564	4353	4170947	1980-08-30	1980-08-30 00:00:00	38000275	0	\N	\N	288787	0	274474001	4170947	
25966	2274	4125906	1975-03-25	1975-03-25 00:00:00	38000275	0	\N	\N	151208	0	288086009	4125906	
38075	3362	4125906	1994-04-17	1994-04-17 00:00:00	38000275	0	\N	\N	222893	0	288086009	4125906	
38186	3370	4107731	1990-06-24	1990-06-24 00:00:00	38000275	0	\N	\N	223414	0	180256009	4107731	
50306	4376	4078793	2000-10-31	2000-10-31 00:00:00	38000275	0	\N	\N	290819	0	180325003	4078793	
38664	3399	4107731	1996-04-16	1996-04-16 00:00:00	38000275	0	\N	\N	225506	0	180256009	4107731	
26881	2349	4107731	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	156448	0	180256009	4107731	
27106	2369	4191853	1982-01-16	1982-01-16 00:00:00	38000275	0	\N	\N	157671	0	395142003	4191853	
39123	3455	4170947	2014-08-19	2014-08-19 00:00:00	38000275	0	\N	\N	229261	0	274474001	4170947	
39318	3464	4107731	2011-08-05	2011-08-05 00:00:00	38000275	0	\N	\N	229914	0	180256009	4107731	
27562	2402	4107731	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	159631	0	180256009	4107731	
39684	3488	4035793	2015-04-10	2015-04-10 00:00:00	38000275	0	\N	\N	231373	0	15081005	4035793	
39842	3509	4195803	2015-12-30	2015-12-30 00:00:00	38000275	0	\N	\N	232795	0	312681000	4195803	
40134	3527	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	234014	0	180256009	4107731	
40306	3529	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	234381	0	180256009	4107731	
28586	2542	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	168087	0	180256009	4107731	
40691	3571	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	237432	0	180256009	4107731	
40823	3583	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	238246	0	180256009	4107731	
29032	2566	4024289	2014-01-01	2014-01-01 00:00:00	38000275	0	\N	\N	170038	0	19490002	4024289	
41145	3604	4107731	1999-06-25	1999-06-25 00:00:00	38000275	0	\N	\N	239533	0	180256009	4107731	
41410	3633	4125906	1975-02-12	1975-02-12 00:00:00	38000275	0	\N	\N	241651	0	288086009	4125906	
53518	4642	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	309387	0	180256009	4107731	
41852	3689	4170947	1963-11-17	1963-11-17 00:00:00	38000275	0	\N	\N	245225	0	274474001	4170947	
41945	3695	4107731	1994-12-12	1994-12-12 00:00:00	38000275	0	\N	\N	245673	0	180256009	4107731	
42120	3717	4107731	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	246973	0	180256009	4107731	
42445	3744	4107731	2004-12-01	2004-12-01 00:00:00	38000275	0	\N	\N	248861	0	180256009	4107731	
30632	2711	4107731	1992-10-05	1992-10-05 00:00:00	38000275	0	\N	\N	179664	0	180256009	4107731	
30854	2732	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	180933	0	180256009	4107731	
42909	3783	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	251330	0	180256009	4107731	
43189	3813	4125906	1994-11-07	1994-11-07 00:00:00	38000275	0	\N	\N	253261	0	288086009	4125906	
31295	2770	4107731	1993-01-02	1993-01-02 00:00:00	38000275	0	\N	\N	183290	0	180256009	4107731	
31576	2779	4107731	1998-02-04	1998-02-04 00:00:00	38000275	0	\N	\N	184155	0	180256009	4107731	
43713	3865	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	256585	0	180256009	4107731	
43921	3876	4107731	1992-03-30	1992-03-30 00:00:00	38000275	0	\N	\N	257449	0	180256009	4107731	
44086	3884	4107731	1992-10-05	1992-10-05 00:00:00	38000275	0	\N	\N	258189	0	180256009	4107731	
32186	2830	4191853	1975-06-22	1975-06-22 00:00:00	38000275	0	\N	\N	187706	0	395142003	4191853	
56404	4923	4047491	1997-03-08	1997-03-08 00:00:00	38000275	0	\N	\N	327126	0	1225002	4047491	
44669	3916	4293740	1987-10-17	1987-10-17 00:00:00	38000275	0	\N	\N	260434	0	384700001	4293740	
56704	4932	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	327872	0	180256009	4107731	
33088	2898	4107731	1993-12-14	1993-12-14 00:00:00	38000275	0	\N	\N	192967	0	180256009	4107731	
33145	2898	4107731	1994-10-04	1994-10-04 00:00:00	38000275	0	\N	\N	193106	0	180256009	4107731	
33391	2919	4145310	2018-03-21	2018-03-21 00:00:00	38000275	0	\N	\N	194613	0	268425006	4145310	
57503	4979	4125906	1996-01-10	1996-01-10 00:00:00	38000275	0	\N	\N	331244	0	288086009	4125906	
45662	4026	4107731	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	267638	0	180256009	4107731	
45933	4033	4043071	1981-06-04	1981-06-04 00:00:00	38000275	0	\N	\N	268348	0	228557008	4043071	
34194	2970	4107731	2002-10-17	2002-10-17 00:00:00	38000275	0	\N	\N	198302	0	180256009	4107731	
34329	2975	4107731	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	198591	0	180256009	4107731	
34504	2987	4243062	1989-01-28	1989-01-28 00:00:00	38000275	0	\N	\N	199423	0	60027007	4243062	
58532	5066	4243062	2015-02-28	2015-02-28 00:00:00	38000275	0	\N	\N	336814	0	60027007	4243062	
34960	3047	4295880	1995-06-14	1995-06-14 00:00:00	38000275	0	\N	\N	202778	0	76601001	4295880	
59040	5117	4107731	1992-01-27	1992-01-27 00:00:00	38000275	0	\N	\N	340078	0	180256009	4107731	
47128	4142	4125906	2013-12-14	2013-12-14 00:00:00	38000275	0	\N	\N	275292	0	288086009	4125906	
47481	4167	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	276959	0	180256009	4107731	
35697	3123	4295880	2005-07-27	2005-07-27 00:00:00	38000275	0	\N	\N	207775	0	76601001	4295880	
35804	3134	4078793	2012-03-15	2012-03-15 00:00:00	38000275	0	\N	\N	208618	0	180325003	4078793	
24017	2088	4035793	2011-03-01	2011-03-01 00:00:00	38000275	0	\N	\N	139243	0	15081005	4035793	
36209	3176	4107731	2002-02-24	2002-02-24 00:00:00	38000275	0	\N	\N	211173	0	180256009	4107731	
24453	2136	4107731	2003-01-10	2003-01-10 00:00:00	38000275	0	\N	\N	142201	0	180256009	4107731	
36571	3215	4107731	2004-03-13	2004-03-13 00:00:00	38000275	0	\N	\N	213658	0	180256009	4107731	
36770	3236	4078793	1993-01-15	1993-01-15 00:00:00	38000275	0	\N	\N	215095	0	180325003	4078793	
36849	3241	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	215489	0	180256009	4107731	
37097	3263	40492359	2007-09-11	2007-09-11 00:00:00	38000275	0	\N	\N	216903	0	447365002	40492359	
37270	3279	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	217914	0	180256009	4107731	
37454	3301	4195803	2011-05-31	2011-05-31 00:00:00	38000275	0	\N	\N	219287	0	312681000	4195803	
49565	4353	4043071	1977-11-02	1977-11-02 00:00:00	38000275	0	\N	\N	288733	0	228557008	4043071	
25967	2274	4293740	1975-03-25	1975-03-25 00:00:00	38000275	0	\N	\N	151208	0	384700001	4293740	
38076	3362	4293740	1994-04-17	1994-04-17 00:00:00	38000275	0	\N	\N	222893	0	384700001	4293740	
38187	3370	4151422	2005-05-04	2005-05-04 00:00:00	38000275	0	\N	\N	223486	0	269911007	4151422	
50307	4376	4035793	2000-10-31	2000-10-31 00:00:00	38000275	0	\N	\N	290819	0	15081005	4035793	
38665	3399	4107731	1998-04-21	1998-04-21 00:00:00	38000275	0	\N	\N	225533	0	180256009	4107731	
26882	2349	4107731	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	156446	0	180256009	4107731	
27107	2369	4107731	1994-09-11	1994-09-11 00:00:00	38000275	0	\N	\N	157632	0	180256009	4107731	
39124	3455	4047491	2014-08-19	2014-08-19 00:00:00	38000275	0	\N	\N	229261	0	1225002	4047491	
39319	3464	4107731	2009-06-19	2009-06-19 00:00:00	38000275	0	\N	\N	230005	0	180256009	4107731	
27563	2402	4107731	1990-05-07	1990-05-07 00:00:00	38000275	0	\N	\N	159602	0	180256009	4107731	
39685	3488	4035793	2017-04-21	2017-04-21 00:00:00	38000275	0	\N	\N	231401	0	15081005	4035793	
39843	3509	4125906	1954-12-12	1954-12-12 00:00:00	38000275	0	\N	\N	232697	0	288086009	4125906	
40135	3527	4125906	1971-04-22	1971-04-22 00:00:00	38000275	0	\N	\N	234048	0	288086009	4125906	
40307	3529	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	234420	0	180256009	4107731	
28587	2542	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	168131	0	180256009	4107731	
40692	3571	4107731	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	237348	0	180256009	4107731	
40824	3583	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	238249	0	180256009	4107731	
29033	2566	4170947	2014-01-01	2014-01-01 00:00:00	38000275	0	\N	\N	170038	0	274474001	4170947	
41146	3604	4107731	2000-08-18	2000-08-18 00:00:00	38000275	0	\N	\N	239563	0	180256009	4107731	
41411	3634	4058899	2002-10-17	2002-10-17 00:00:00	38000275	0	\N	\N	241745	0	168594001	4058899	
53519	4642	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	309427	0	180256009	4107731	
41853	3689	4078793	2014-04-21	2014-04-21 00:00:00	38000275	0	\N	\N	245174	0	180325003	4078793	
41946	3695	4107731	1996-07-22	1996-07-22 00:00:00	38000275	0	\N	\N	245640	0	180256009	4107731	
42121	3717	4107731	1991-03-23	1991-03-23 00:00:00	38000275	0	\N	\N	247024	0	180256009	4107731	
42446	3744	4107731	2005-08-10	2005-08-10 00:00:00	38000275	0	\N	\N	248774	0	180256009	4107731	
30633	2711	4107731	1992-01-27	1992-01-27 00:00:00	38000275	0	\N	\N	179765	0	180256009	4107731	
30855	2732	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	180899	0	180256009	4107731	
42910	3783	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	251359	0	180256009	4107731	
43190	3813	4058899	1982-09-11	1982-09-11 00:00:00	38000275	0	\N	\N	253260	0	168594001	4058899	
31296	2770	4107731	1990-08-04	1990-08-04 00:00:00	38000275	0	\N	\N	183382	0	180256009	4107731	
31577	2780	4151422	2008-02-07	2008-02-07 00:00:00	38000275	0	\N	\N	184237	0	269911007	4151422	
43714	3865	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	256616	0	180256009	4107731	
43922	3876	4107731	1991-09-02	1991-09-02 00:00:00	38000275	0	\N	\N	257479	0	180256009	4107731	
44087	3884	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	258113	0	180256009	4107731	
32187	2830	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	187742	0	180256009	4107731	
56405	4924	4107731	1992-09-09	1992-09-09 00:00:00	38000275	0	\N	\N	327228	0	180256009	4107731	
44670	3916	4125906	1987-10-17	1987-10-17 00:00:00	38000275	0	\N	\N	260434	0	288086009	4125906	
56705	4932	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	327886	0	180256009	4107731	
33089	2898	4295880	1998-04-07	1998-04-07 00:00:00	38000275	0	\N	\N	193077	0	76601001	4295880	
33146	2898	4295880	1996-07-09	1996-07-09 00:00:00	38000275	0	\N	\N	193086	0	76601001	4295880	
33392	2919	4163872	2007-11-03	2007-11-03 00:00:00	38000275	0	\N	\N	194590	0	399208008	4163872	
57575	4986	4078793	2015-07-19	2015-07-19 00:00:00	38000275	0	\N	\N	331674	0	180325003	4078793	
45663	4026	4107731	1992-11-22	1992-11-22 00:00:00	38000275	0	\N	\N	267709	0	180256009	4107731	
45934	4033	4043071	1980-02-13	1980-02-13 00:00:00	38000275	0	\N	\N	268343	0	228557008	4043071	
34195	2970	4107731	1999-07-29	1999-07-29 00:00:00	38000275	0	\N	\N	198324	0	180256009	4107731	
34330	2975	4107731	1990-06-24	1990-06-24 00:00:00	38000275	0	\N	\N	198569	0	180256009	4107731	
34505	2987	4170947	1989-01-28	1989-01-28 00:00:00	38000275	0	\N	\N	199423	0	274474001	4170947	
58533	5067	4295880	1997-04-20	1997-04-20 00:00:00	38000275	0	\N	\N	336843	0	76601001	4295880	
34961	3047	4295880	1994-06-11	1994-06-11 00:00:00	38000275	0	\N	\N	202724	0	76601001	4295880	
59041	5117	4107731	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	340072	0	180256009	4107731	
47129	4142	4151422	2000-07-05	2000-07-05 00:00:00	38000275	0	\N	\N	275337	0	269911007	4151422	
47482	4167	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	276924	0	180256009	4107731	
35700	3125	4125906	1975-09-30	1975-09-30 00:00:00	38000275	0	\N	\N	208006	0	288086009	4125906	
35805	3134	4078793	2017-04-13	2017-04-13 00:00:00	38000275	0	\N	\N	208595	0	180325003	4078793	
24018	2088	4151422	1938-12-28	1938-12-28 00:00:00	38000275	0	\N	\N	139259	0	269911007	4151422	
36210	3176	4107731	2004-11-07	2004-11-07 00:00:00	38000275	0	\N	\N	211096	0	180256009	4107731	
24454	2136	4107731	2002-09-27	2002-09-27 00:00:00	38000275	0	\N	\N	142243	0	180256009	4107731	
36572	3215	4107731	2003-11-08	2003-11-08 00:00:00	38000275	0	\N	\N	213676	0	180256009	4107731	
36771	3236	4078793	1987-12-18	1987-12-18 00:00:00	38000275	0	\N	\N	215081	0	180325003	4078793	
36850	3241	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	215492	0	180256009	4107731	
37098	3263	4125906	2002-11-03	2002-11-03 00:00:00	38000275	0	\N	\N	216902	0	288086009	4125906	
37271	3279	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	217909	0	180256009	4107731	
37459	3304	4125906	1986-05-29	1986-05-29 00:00:00	38000275	0	\N	\N	219486	0	288086009	4125906	
49566	4353	4170947	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	288788	0	274474001	4170947	
25968	2274	4293740	1976-02-02	1976-02-02 00:00:00	38000275	0	\N	\N	151209	0	384700001	4293740	
38077	3362	4151422	2004-11-08	2004-11-08 00:00:00	38000275	0	\N	\N	222885	0	269911007	4151422	
38188	3370	4107731	1991-11-10	1991-11-10 00:00:00	38000275	0	\N	\N	223521	0	180256009	4107731	
50308	4376	4035793	2006-12-05	2006-12-05 00:00:00	38000275	0	\N	\N	290707	0	15081005	4035793	
38666	3399	4107731	1999-05-25	1999-05-25 00:00:00	38000275	0	\N	\N	225522	0	180256009	4107731	
26883	2349	4107731	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	156415	0	180256009	4107731	
27108	2369	4107731	1995-12-17	1995-12-17 00:00:00	38000275	0	\N	\N	157694	0	180256009	4107731	
39125	3456	4151422	1978-11-11	1978-11-11 00:00:00	38000275	0	\N	\N	229308	0	269911007	4151422	
39320	3464	4107731	2012-07-27	2012-07-27 00:00:00	38000275	0	\N	\N	229977	0	180256009	4107731	
27564	2402	4107731	1992-01-27	1992-01-27 00:00:00	38000275	0	\N	\N	159692	0	180256009	4107731	
39686	3489	4151422	1985-01-25	1985-01-25 00:00:00	38000275	0	\N	\N	231447	0	269911007	4151422	
39844	3509	4151422	1961-09-20	1961-09-20 00:00:00	38000275	0	\N	\N	232783	0	269911007	4151422	
40136	3527	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	234023	0	180256009	4107731	
40308	3529	4170947	1949-02-13	1949-02-13 00:00:00	38000275	0	\N	\N	234286	0	274474001	4170947	
28588	2542	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	168095	0	180256009	4107731	
40693	3571	4170947	2005-05-27	2005-05-27 00:00:00	38000275	0	\N	\N	237439	0	274474001	4170947	
40825	3583	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	238276	0	180256009	4107731	
29034	2566	4195803	2014-01-01	2014-01-01 00:00:00	38000275	0	\N	\N	170038	0	312681000	4195803	
41147	3604	4107731	1998-08-14	1998-08-14 00:00:00	38000275	0	\N	\N	239519	0	180256009	4107731	
41412	3634	4293740	2000-11-12	2000-11-12 00:00:00	38000275	0	\N	\N	241744	0	384700001	4293740	
53520	4642	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	309399	0	180256009	4107731	
41854	3689	4057420	2016-05-02	2016-05-02 00:00:00	38000275	0	\N	\N	245164	0	18286008	4057420	
41947	3695	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	245570	0	180256009	4107731	
42122	3717	4107731	1990-05-12	1990-05-12 00:00:00	38000275	0	\N	\N	247020	0	180256009	4107731	
42447	3744	4107731	2004-02-11	2004-02-11 00:00:00	38000275	0	\N	\N	248768	0	180256009	4107731	
30634	2711	4107731	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	179644	0	180256009	4107731	
42637	3759	4107731	1993-05-09	1993-05-09 00:00:00	38000275	0	\N	\N	249925	0	180256009	4107731	
42911	3783	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	251376	0	180256009	4107731	
43191	3814	4295880	1994-11-06	1994-11-06 00:00:00	38000275	0	\N	\N	253359	0	76601001	4295880	
31297	2770	4107731	1990-01-27	1990-01-27 00:00:00	38000275	0	\N	\N	183392	0	180256009	4107731	
31578	2780	4326177	2001-01-06	2001-01-06 00:00:00	38000275	0	\N	\N	184222	0	430193006	4326177	
43715	3865	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	256656	0	180256009	4107731	
43923	3876	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	257440	0	180256009	4107731	
44088	3884	4107731	1992-03-30	1992-03-30 00:00:00	38000275	0	\N	\N	258147	0	180256009	4107731	
32188	2830	4107731	1992-03-30	1992-03-30 00:00:00	38000275	0	\N	\N	187736	0	180256009	4107731	
56406	4924	4107731	1993-07-21	1993-07-21 00:00:00	38000275	0	\N	\N	327195	0	180256009	4107731	
44671	3916	4107731	1994-04-20	1994-04-20 00:00:00	38000275	0	\N	\N	260408	0	180256009	4107731	
56706	4932	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	327824	0	180256009	4107731	
33090	2898	4295880	1999-07-06	1999-07-06 00:00:00	38000275	0	\N	\N	193090	0	76601001	4295880	
33147	2899	4125906	2004-03-14	2004-03-14 00:00:00	38000275	0	\N	\N	193181	0	288086009	4125906	
33394	2921	4035793	2018-11-27	2018-11-27 00:00:00	38000275	0	\N	\N	194720	0	15081005	4035793	
57576	4986	4078793	2001-04-29	2001-04-29 00:00:00	38000275	0	\N	\N	331638	0	180325003	4078793	
45664	4026	4107731	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	267736	0	180256009	4107731	
45935	4033	4043071	1979-02-14	1979-02-14 00:00:00	38000275	0	\N	\N	268311	0	228557008	4043071	
34196	2970	4107731	2001-02-15	2001-02-15 00:00:00	38000275	0	\N	\N	198313	0	180256009	4107731	
34331	2975	4107731	1990-04-22	1990-04-22 00:00:00	38000275	0	\N	\N	198609	0	180256009	4107731	
34506	2987	4024289	1979-05-21	1979-05-21 00:00:00	38000275	0	\N	\N	199368	0	19490002	4024289	
58534	5067	4295880	1996-07-21	1996-07-21 00:00:00	38000275	0	\N	\N	336842	0	76601001	4295880	
34962	3047	4295880	1995-09-13	1995-09-13 00:00:00	38000275	0	\N	\N	202730	0	76601001	4295880	
59042	5117	4107731	1992-09-14	1992-09-14 00:00:00	38000275	0	\N	\N	340080	0	180256009	4107731	
47130	4142	4125906	2015-10-19	2015-10-19 00:00:00	38000275	0	\N	\N	275293	0	288086009	4125906	
47483	4167	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	276955	0	180256009	4107731	
35701	3125	4125906	2011-09-29	2011-09-29 00:00:00	38000275	0	\N	\N	207930	0	288086009	4125906	
35806	3134	4078793	2019-04-25	2019-04-25 00:00:00	38000275	0	\N	\N	208596	0	180325003	4078793	
24019	2088	4035793	1986-07-08	1986-07-08 00:00:00	38000275	0	\N	\N	139286	0	15081005	4035793	
36211	3176	4117038	1997-10-12	1997-10-12 00:00:00	38000275	0	\N	\N	211126	0	287664005	4117038	
24455	2136	4107731	2002-12-20	2002-12-20 00:00:00	38000275	0	\N	\N	142222	0	180256009	4107731	
36573	3215	4107731	2004-01-31	2004-01-31 00:00:00	38000275	0	\N	\N	213657	0	180256009	4107731	
36772	3236	4078793	2006-03-31	2006-03-31 00:00:00	38000275	0	\N	\N	215083	0	180325003	4078793	
36851	3241	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	215480	0	180256009	4107731	
37099	3263	4125906	1962-04-23	1962-04-23 00:00:00	38000275	0	\N	\N	216907	0	288086009	4125906	
37272	3279	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	217911	0	180256009	4107731	
37460	3304	4058899	1975-06-26	1975-06-26 00:00:00	38000275	0	\N	\N	219484	0	168594001	4058899	
49567	4353	4163872	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	288788	0	399208008	4163872	
25969	2274	4125906	1976-02-02	1976-02-02 00:00:00	38000275	0	\N	\N	151209	0	288086009	4125906	
38078	3363	4058899	1958-06-28	1958-06-28 00:00:00	38000275	0	\N	\N	222950	0	168594001	4058899	
38189	3370	4107731	1991-09-29	1991-09-29 00:00:00	38000275	0	\N	\N	223520	0	180256009	4107731	
50309	4376	4078793	2006-12-05	2006-12-05 00:00:00	38000275	0	\N	\N	290707	0	180325003	4078793	
38667	3399	4107731	1999-04-13	1999-04-13 00:00:00	38000275	0	\N	\N	225479	0	180256009	4107731	
26884	2349	4125906	1994-05-03	1994-05-03 00:00:00	38000275	0	\N	\N	156413	0	288086009	4125906	
27109	2369	4107731	1997-08-17	1997-08-17 00:00:00	38000275	0	\N	\N	157620	0	180256009	4107731	
39126	3456	40492359	1991-12-12	1991-12-12 00:00:00	38000275	0	\N	\N	229296	0	447365002	40492359	
39321	3464	4107731	2011-10-07	2011-10-07 00:00:00	38000275	0	\N	\N	229973	0	180256009	4107731	
27565	2402	4107731	1992-03-09	1992-03-09 00:00:00	38000275	0	\N	\N	159693	0	180256009	4107731	
39687	3489	4117038	1998-09-06	1998-09-06 00:00:00	38000275	0	\N	\N	231480	0	287664005	4117038	
39845	3509	4125906	1953-11-03	1953-11-03 00:00:00	38000275	0	\N	\N	232696	0	288086009	4125906	
40137	3527	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	234134	0	180256009	4107731	
40309	3529	4047491	1949-02-13	1949-02-13 00:00:00	38000275	0	\N	\N	234286	0	1225002	4047491	
28589	2542	4151422	2001-06-15	2001-06-15 00:00:00	38000275	0	\N	\N	168113	0	269911007	4151422	
40694	3571	4243062	2005-05-27	2005-05-27 00:00:00	38000275	0	\N	\N	237439	0	60027007	4243062	
40826	3583	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	238247	0	180256009	4107731	
29035	2566	4163872	1946-09-18	1946-09-18 00:00:00	38000275	0	\N	\N	169995	0	399208008	4163872	
41148	3604	4107731	1998-11-27	1998-11-27 00:00:00	38000275	0	\N	\N	239545	0	180256009	4107731	
41413	3634	4125906	2000-11-12	2000-11-12 00:00:00	38000275	0	\N	\N	241744	0	288086009	4125906	
53521	4642	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	309421	0	180256009	4107731	
41855	3689	4163872	1963-07-23	1963-07-23 00:00:00	38000275	0	\N	\N	245228	0	399208008	4163872	
41948	3695	4107731	1993-07-26	1993-07-26 00:00:00	38000275	0	\N	\N	245644	0	180256009	4107731	
42123	3717	4107731	1991-12-21	1991-12-21 00:00:00	38000275	0	\N	\N	247027	0	180256009	4107731	
42448	3744	4107731	2003-03-12	2003-03-12 00:00:00	38000275	0	\N	\N	248751	0	180256009	4107731	
30635	2711	4107731	1992-12-07	1992-12-07 00:00:00	38000275	0	\N	\N	179672	0	180256009	4107731	
42638	3759	4107731	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	249919	0	180256009	4107731	
42912	3783	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	251357	0	180256009	4107731	
43192	3814	4295880	1999-01-31	1999-01-31 00:00:00	38000275	0	\N	\N	253391	0	76601001	4295880	
31298	2770	4107731	1991-06-15	1991-06-15 00:00:00	38000275	0	\N	\N	183315	0	180256009	4107731	
31579	2780	4187458	2001-01-06	2001-01-06 00:00:00	38000275	0	\N	\N	184222	0	415300000	4187458	
43716	3865	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	256542	0	180256009	4107731	
43924	3876	4107731	1992-08-24	1992-08-24 00:00:00	38000275	0	\N	\N	257517	0	180256009	4107731	
44089	3884	4107731	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	258102	0	180256009	4107731	
32189	2830	4107731	1990-10-01	1990-10-01 00:00:00	38000275	0	\N	\N	187791	0	180256009	4107731	
56407	4924	4107731	1992-06-17	1992-06-17 00:00:00	38000275	0	\N	\N	327267	0	180256009	4107731	
44672	3916	4107731	1994-09-14	1994-09-14 00:00:00	38000275	0	\N	\N	260295	0	180256009	4107731	
56707	4932	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	327897	0	180256009	4107731	
33091	2898	4107731	1994-12-27	1994-12-27 00:00:00	38000275	0	\N	\N	193094	0	180256009	4107731	
33148	2899	4195803	2009-10-22	2009-10-22 00:00:00	38000275	0	\N	\N	193167	0	312681000	4195803	
33395	2921	4035793	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	194767	0	15081005	4035793	
57577	4986	4057420	2002-05-05	2002-05-05 00:00:00	38000275	0	\N	\N	331706	0	18286008	4057420	
45665	4026	4107731	1990-08-26	1990-08-26 00:00:00	38000275	0	\N	\N	267616	0	180256009	4107731	
45936	4033	4043071	1980-05-29	1980-05-29 00:00:00	38000275	0	\N	\N	268301	0	228557008	4043071	
34197	2970	4107731	2001-07-12	2001-07-12 00:00:00	38000275	0	\N	\N	198298	0	180256009	4107731	
34332	2975	4107731	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	198684	0	180256009	4107731	
34507	2987	4170947	1979-05-21	1979-05-21 00:00:00	38000275	0	\N	\N	199368	0	274474001	4170947	
58535	5067	4163872	1988-12-06	1988-12-06 00:00:00	38000275	0	\N	\N	336817	0	399208008	4163872	
34963	3047	4295880	1995-03-15	1995-03-15 00:00:00	38000275	0	\N	\N	202760	0	76601001	4295880	
59043	5117	4107731	1990-02-12	1990-02-12 00:00:00	38000275	0	\N	\N	340119	0	180256009	4107731	
47133	4145	4107731	2007-06-09	2007-06-09 00:00:00	38000275	0	\N	\N	275537	0	180256009	4107731	
47484	4167	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	276943	0	180256009	4107731	
35702	3125	4125906	1988-11-09	1988-11-09 00:00:00	38000275	0	\N	\N	208008	0	288086009	4125906	
35807	3134	4078793	2007-02-15	2007-02-15 00:00:00	38000275	0	\N	\N	208597	0	180325003	4078793	
24020	2088	4035793	1998-05-26	1998-05-26 00:00:00	38000275	0	\N	\N	139234	0	15081005	4035793	
36212	3176	4107731	2004-03-21	2004-03-21 00:00:00	38000275	0	\N	\N	211094	0	180256009	4107731	
24456	2136	4191853	2001-06-22	2001-06-22 00:00:00	38000275	0	\N	\N	142306	0	395142003	4191853	
36574	3215	4125906	2003-10-17	2003-10-17 00:00:00	38000275	0	\N	\N	213685	0	288086009	4125906	
36773	3236	4078793	2008-08-01	2008-08-01 00:00:00	38000275	0	\N	\N	215101	0	180325003	4078793	
36852	3241	4170947	1970-02-11	1970-02-11 00:00:00	38000275	0	\N	\N	215440	0	274474001	4170947	
37100	3263	4024289	2018-01-18	2018-01-18 00:00:00	38000275	0	\N	\N	216905	0	19490002	4024289	
37273	3279	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	217814	0	180256009	4107731	
37461	3304	4024289	1977-07-15	1977-07-15 00:00:00	38000275	0	\N	\N	219485	0	19490002	4024289	
49568	4353	4043071	1980-10-01	1980-10-01 00:00:00	38000275	0	\N	\N	288781	0	228557008	4043071	
25970	2274	4125906	1997-11-22	1997-11-22 00:00:00	38000275	0	\N	\N	151210	0	288086009	4125906	
38079	3363	4151422	1972-06-10	1972-06-10 00:00:00	38000275	0	\N	\N	222987	0	269911007	4151422	
38190	3370	4107731	1990-10-07	1990-10-07 00:00:00	38000275	0	\N	\N	223430	0	180256009	4107731	
50310	4376	4078793	1988-08-23	1988-08-23 00:00:00	38000275	0	\N	\N	290799	0	180325003	4078793	
38668	3399	4107731	1997-04-08	1997-04-08 00:00:00	38000275	0	\N	\N	225456	0	180256009	4107731	
26885	2349	4107731	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	156401	0	180256009	4107731	
27110	2369	4107731	1996-03-10	1996-03-10 00:00:00	38000275	0	\N	\N	157638	0	180256009	4107731	
39127	3456	4057420	1991-12-12	1991-12-12 00:00:00	38000275	0	\N	\N	229296	0	18286008	4057420	
39322	3464	4107731	2009-07-10	2009-07-10 00:00:00	38000275	0	\N	\N	229906	0	180256009	4107731	
27566	2402	4107731	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	159680	0	180256009	4107731	
39688	3489	4293740	2012-10-28	2012-10-28 00:00:00	38000275	0	\N	\N	231481	0	384700001	4293740	
39846	3509	4293740	1953-11-03	1953-11-03 00:00:00	38000275	0	\N	\N	232696	0	384700001	4293740	
40138	3527	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	234085	0	180256009	4107731	
40310	3529	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	234367	0	180256009	4107731	
28590	2542	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	168088	0	180256009	4107731	
40695	3571	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	237405	0	180256009	4107731	
40827	3583	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	238261	0	180256009	4107731	
29036	2567	4151422	1978-05-01	1978-05-01 00:00:00	38000275	0	\N	\N	170096	0	269911007	4151422	
41156	3609	4151422	1992-03-01	1992-03-01 00:00:00	38000275	0	\N	\N	239746	0	269911007	4151422	
41414	3634	4170947	1982-04-21	1982-04-21 00:00:00	38000275	0	\N	\N	241743	0	274474001	4170947	
53522	4642	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	309394	0	180256009	4107731	
41856	3689	4057420	2012-04-09	2012-04-09 00:00:00	38000275	0	\N	\N	245173	0	18286008	4057420	
41949	3695	4107731	1995-05-29	1995-05-29 00:00:00	38000275	0	\N	\N	245587	0	180256009	4107731	
42124	3717	4107731	1992-06-06	1992-06-06 00:00:00	38000275	0	\N	\N	247042	0	180256009	4107731	
42449	3744	4107731	2003-12-10	2003-12-10 00:00:00	38000275	0	\N	\N	248754	0	180256009	4107731	
30636	2711	4107731	1991-07-22	1991-07-22 00:00:00	38000275	0	\N	\N	179764	0	180256009	4107731	
42639	3759	4107731	1990-09-16	1990-09-16 00:00:00	38000275	0	\N	\N	249886	0	180256009	4107731	
42913	3783	4197460	1940-12-01	1940-12-01 00:00:00	38000275	0	\N	\N	251449	0	313191000	4197460	
43193	3814	4295880	1996-05-05	1996-05-05 00:00:00	38000275	0	\N	\N	253337	0	76601001	4295880	
31299	2770	4107731	1992-10-10	1992-10-10 00:00:00	38000275	0	\N	\N	183288	0	180256009	4107731	
31580	2780	4037675	2001-01-06	2001-01-06 00:00:00	38000275	0	\N	\N	184222	0	162676008	4037675	
43717	3865	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	256566	0	180256009	4107731	
43925	3876	4107731	1992-07-13	1992-07-13 00:00:00	38000275	0	\N	\N	257463	0	180256009	4107731	
44090	3884	4107731	1991-09-02	1991-09-02 00:00:00	38000275	0	\N	\N	258074	0	180256009	4107731	
32190	2830	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	187688	0	180256009	4107731	
56408	4924	4107731	1991-06-26	1991-06-26 00:00:00	38000275	0	\N	\N	327262	0	180256009	4107731	
44673	3916	4295880	1996-06-26	1996-06-26 00:00:00	38000275	0	\N	\N	260322	0	76601001	4295880	
56708	4932	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	327848	0	180256009	4107731	
33092	2898	4107731	1992-12-01	1992-12-01 00:00:00	38000275	0	\N	\N	192984	0	180256009	4107731	
33149	2899	4151422	1967-07-17	1967-07-17 00:00:00	38000275	0	\N	\N	193172	0	269911007	4151422	
33396	2921	4035793	1992-06-30	1992-06-30 00:00:00	38000275	0	\N	\N	194758	0	15081005	4035793	
57578	4986	4078793	2017-08-20	2017-08-20 00:00:00	38000275	0	\N	\N	331639	0	180325003	4078793	
45666	4026	4107731	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	267765	0	180256009	4107731	
45937	4033	4043071	1979-09-06	1979-09-06 00:00:00	38000275	0	\N	\N	268314	0	228557008	4043071	
34198	2970	4107731	2002-07-04	2002-07-04 00:00:00	38000275	0	\N	\N	198383	0	180256009	4107731	
34333	2975	4107731	1993-01-24	1993-01-24 00:00:00	38000275	0	\N	\N	198688	0	180256009	4107731	
34508	2987	4151422	1995-07-16	1995-07-16 00:00:00	38000275	0	\N	\N	199394	0	269911007	4151422	
58536	5067	4170947	1988-12-06	1988-12-06 00:00:00	38000275	0	\N	\N	336817	0	274474001	4170947	
34964	3047	4295880	1995-12-13	1995-12-13 00:00:00	38000275	0	\N	\N	202761	0	76601001	4295880	
59044	5117	4107731	1990-05-07	1990-05-07 00:00:00	38000275	0	\N	\N	340098	0	180256009	4107731	
47134	4145	4107731	2008-03-29	2008-03-29 00:00:00	38000275	0	\N	\N	275456	0	180256009	4107731	
47485	4167	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	276941	0	180256009	4107731	
35705	3128	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	208221	0	180256009	4107731	
35808	3134	4195803	1988-12-07	1988-12-07 00:00:00	38000275	0	\N	\N	208557	0	312681000	4195803	
24021	2088	4035793	2012-03-06	2012-03-06 00:00:00	38000275	0	\N	\N	139284	0	15081005	4035793	
36213	3176	4107731	2004-07-25	2004-07-25 00:00:00	38000275	0	\N	\N	211186	0	180256009	4107731	
24457	2136	4107731	2004-03-05	2004-03-05 00:00:00	38000275	0	\N	\N	142209	0	180256009	4107731	
36575	3215	4293740	2003-10-17	2003-10-17 00:00:00	38000275	0	\N	\N	213685	0	384700001	4293740	
36774	3236	4078793	2005-03-25	2005-03-25 00:00:00	38000275	0	\N	\N	215104	0	180325003	4078793	
36853	3241	4243062	1970-02-11	1970-02-11 00:00:00	38000275	0	\N	\N	215440	0	60027007	4243062	
37101	3263	4170947	2018-01-18	2018-01-18 00:00:00	38000275	0	\N	\N	216905	0	274474001	4170947	
37274	3279	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	217957	0	180256009	4107731	
37462	3304	4170947	1977-07-15	1977-07-15 00:00:00	38000275	0	\N	\N	219485	0	274474001	4170947	
49569	4353	4043071	1978-07-05	1978-07-05 00:00:00	38000275	0	\N	\N	288764	0	228557008	4043071	
25973	2277	4151422	1977-10-04	1977-10-04 00:00:00	38000275	0	\N	\N	151352	0	269911007	4151422	
38080	3364	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	223046	0	180256009	4107731	
38191	3370	4107731	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	223480	0	180256009	4107731	
50311	4376	4035793	1988-08-23	1988-08-23 00:00:00	38000275	0	\N	\N	290799	0	15081005	4035793	
38669	3399	4107731	1999-05-04	1999-05-04 00:00:00	38000275	0	\N	\N	225436	0	180256009	4107731	
26886	2349	4107731	1991-11-10	1991-11-10 00:00:00	38000275	0	\N	\N	156424	0	180256009	4107731	
27111	2369	4107731	1996-12-29	1996-12-29 00:00:00	38000275	0	\N	\N	157651	0	180256009	4107731	
39128	3457	4125906	1938-07-06	1938-07-06 00:00:00	38000275	0	\N	\N	229383	0	288086009	4125906	
39323	3464	4107731	2012-06-15	2012-06-15 00:00:00	38000275	0	\N	\N	229976	0	180256009	4107731	
27567	2402	4107731	1991-11-25	1991-11-25 00:00:00	38000275	0	\N	\N	159595	0	180256009	4107731	
39689	3489	4125906	2012-10-28	2012-10-28 00:00:00	38000275	0	\N	\N	231481	0	288086009	4125906	
39847	3509	4125906	1984-04-27	1984-04-27 00:00:00	38000275	0	\N	\N	232792	0	288086009	4125906	
40139	3527	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	234103	0	180256009	4107731	
40311	3529	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	234323	0	180256009	4107731	
28591	2542	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	168083	0	180256009	4107731	
40696	3571	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	237324	0	180256009	4107731	
40828	3583	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	238285	0	180256009	4107731	
29037	2567	4151422	2018-01-10	2018-01-10 00:00:00	38000275	0	\N	\N	170078	0	269911007	4151422	
41157	3609	4125906	2017-06-24	2017-06-24 00:00:00	38000275	0	\N	\N	239789	0	288086009	4125906	
41415	3634	4047491	1982-04-21	1982-04-21 00:00:00	38000275	0	\N	\N	241743	0	1225002	4047491	
53523	4642	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	309396	0	180256009	4107731	
41857	3689	4078793	2013-04-15	2013-04-15 00:00:00	38000275	0	\N	\N	245244	0	180325003	4078793	
41950	3695	4107731	1994-02-21	1994-02-21 00:00:00	38000275	0	\N	\N	245651	0	180256009	4107731	
42125	3717	4107731	1991-11-30	1991-11-30 00:00:00	38000275	0	\N	\N	246963	0	180256009	4107731	
54268	4719	4107731	1992-08-09	1992-08-09 00:00:00	38000275	0	\N	\N	314174	0	180256009	4107731	
30637	2711	4107731	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	179641	0	180256009	4107731	
42640	3759	4107731	1993-03-28	1993-03-28 00:00:00	38000275	0	\N	\N	249924	0	180256009	4107731	
42914	3783	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	251347	0	180256009	4107731	
43194	3814	4295880	1995-02-05	1995-02-05 00:00:00	38000275	0	\N	\N	253350	0	76601001	4295880	
31300	2770	4107731	1990-11-17	1990-11-17 00:00:00	38000275	0	\N	\N	183405	0	180256009	4107731	
31581	2780	4198190	1957-01-18	1957-01-18 00:00:00	38000275	0	\N	\N	184230	0	80146002	4198190	
43718	3865	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	256586	0	180256009	4107731	
43926	3876	4107731	1992-08-03	1992-08-03 00:00:00	38000275	0	\N	\N	257437	0	180256009	4107731	
44091	3884	4107731	1992-08-03	1992-08-03 00:00:00	38000275	0	\N	\N	258049	0	180256009	4107731	
32191	2830	4107731	1992-03-09	1992-03-09 00:00:00	38000275	0	\N	\N	187821	0	180256009	4107731	
56409	4924	4107731	1994-01-05	1994-01-05 00:00:00	38000275	0	\N	\N	327188	0	180256009	4107731	
44674	3916	4043071	1989-12-31	1989-12-31 00:00:00	38000275	0	\N	\N	260342	0	228557008	4043071	
56709	4932	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	327898	0	180256009	4107731	
33093	2898	4107731	1995-06-13	1995-06-13 00:00:00	38000275	0	\N	\N	192973	0	180256009	4107731	
33150	2899	4058899	1979-01-25	1979-01-25 00:00:00	38000275	0	\N	\N	193180	0	168594001	4058899	
33397	2921	4035793	1995-07-18	1995-07-18 00:00:00	38000275	0	\N	\N	194740	0	15081005	4035793	
57579	4986	4078793	2009-06-14	2009-06-14 00:00:00	38000275	0	\N	\N	331671	0	180325003	4078793	
45667	4026	4107731	1993-03-28	1993-03-28 00:00:00	38000275	0	\N	\N	267746	0	180256009	4107731	
45938	4033	4043071	1979-12-19	1979-12-19 00:00:00	38000275	0	\N	\N	268300	0	228557008	4043071	
34199	2970	4107731	2000-06-08	2000-06-08 00:00:00	38000275	0	\N	\N	198328	0	180256009	4107731	
34334	2975	4107731	1992-06-28	1992-06-28 00:00:00	38000275	0	\N	\N	198621	0	180256009	4107731	
34509	2987	4163872	1989-05-30	1989-05-30 00:00:00	38000275	0	\N	\N	199371	0	399208008	4163872	
58537	5067	4295880	1996-04-17	1996-04-17 00:00:00	38000275	0	\N	\N	336892	0	76601001	4295880	
34965	3047	4010253	2002-11-16	2002-11-16 00:00:00	38000275	0	\N	\N	202716	0	112790001	4010253	
59045	5117	4107731	1990-12-03	1990-12-03 00:00:00	38000275	0	\N	\N	340033	0	180256009	4107731	
47135	4145	4107731	2007-04-07	2007-04-07 00:00:00	38000275	0	\N	\N	275472	0	180256009	4107731	
47486	4167	4107731	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	277009	0	180256009	4107731	
35706	3128	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	208208	0	180256009	4107731	
35809	3134	4058899	1988-12-07	1988-12-07 00:00:00	38000275	0	\N	\N	208557	0	168594001	4058899	
24022	2088	4035793	2007-02-06	2007-02-06 00:00:00	38000275	0	\N	\N	139267	0	15081005	4035793	
36214	3176	4107731	2004-11-28	2004-11-28 00:00:00	38000275	0	\N	\N	211208	0	180256009	4107731	
24458	2136	4107731	2003-04-25	2003-04-25 00:00:00	38000275	0	\N	\N	142225	0	180256009	4107731	
36576	3215	4107731	2003-07-26	2003-07-26 00:00:00	38000275	0	\N	\N	213656	0	180256009	4107731	
36775	3236	4057420	2001-03-02	2001-03-02 00:00:00	38000275	0	\N	\N	215099	0	18286008	4057420	
36854	3241	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	215467	0	180256009	4107731	
37102	3263	4195803	2018-01-18	2018-01-18 00:00:00	38000275	0	\N	\N	216905	0	312681000	4195803	
37275	3279	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	217933	0	180256009	4107731	
37463	3304	4125906	1964-11-29	1964-11-29 00:00:00	38000275	0	\N	\N	219483	0	288086009	4125906	
49570	4353	4043071	1980-06-04	1980-06-04 00:00:00	38000275	0	\N	\N	288779	0	228557008	4043071	
25974	2277	4047491	1971-04-07	1971-04-07 00:00:00	38000275	0	\N	\N	151383	0	1225002	4047491	
38081	3364	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	223029	0	180256009	4107731	
38192	3370	4107731	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	223413	0	180256009	4107731	
50312	4376	4057420	1980-07-08	1980-07-08 00:00:00	38000275	0	\N	\N	290701	0	18286008	4057420	
38670	3399	4107731	1997-02-24	1997-02-24 00:00:00	38000275	0	\N	\N	225470	0	180256009	4107731	
26887	2349	4107731	1991-10-20	1991-10-20 00:00:00	38000275	0	\N	\N	156392	0	180256009	4107731	
27112	2369	4107731	1995-08-13	1995-08-13 00:00:00	38000275	0	\N	\N	157684	0	180256009	4107731	
39129	3457	4195803	1976-10-29	1976-10-29 00:00:00	38000275	0	\N	\N	229388	0	312681000	4195803	
39324	3464	4107731	2009-08-21	2009-08-21 00:00:00	38000275	0	\N	\N	229999	0	180256009	4107731	
27568	2402	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	159635	0	180256009	4107731	
39690	3490	4151422	1990-04-23	1990-04-23 00:00:00	38000275	0	\N	\N	231626	0	269911007	4151422	
39848	3510	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	232963	0	180256009	4107731	
40140	3527	4197460	1963-04-09	1963-04-09 00:00:00	38000275	0	\N	\N	234047	0	313191000	4197460	
40312	3529	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	234416	0	180256009	4107731	
28592	2542	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	168097	0	180256009	4107731	
40697	3571	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	237429	0	180256009	4107731	
40829	3583	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	238265	0	180256009	4107731	
29039	2570	4202451	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	170241	0	433112001	4202451	
41158	3609	4125906	1982-10-18	1982-10-18 00:00:00	38000275	0	\N	\N	239784	0	288086009	4125906	
41416	3634	4151422	2008-04-06	2008-04-06 00:00:00	38000275	0	\N	\N	241698	0	269911007	4151422	
53524	4642	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	309481	0	180256009	4107731	
41860	3691	4125906	2012-07-17	2012-07-17 00:00:00	38000275	0	\N	\N	245332	0	288086009	4125906	
41951	3695	4107731	1996-01-15	1996-01-15 00:00:00	38000275	0	\N	\N	245622	0	180256009	4107731	
42126	3717	4043071	1983-06-04	1983-06-04 00:00:00	38000275	0	\N	\N	246996	0	228557008	4043071	
54269	4719	4107731	1992-04-26	1992-04-26 00:00:00	38000275	0	\N	\N	314272	0	180256009	4107731	
30638	2711	4107731	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	179670	0	180256009	4107731	
42641	3759	4107731	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	249984	0	180256009	4107731	
42915	3783	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	251401	0	180256009	4107731	
43195	3814	4295880	1995-08-06	1995-08-06 00:00:00	38000275	0	\N	\N	253336	0	76601001	4295880	
31301	2770	4107731	1990-12-08	1990-12-08 00:00:00	38000275	0	\N	\N	183396	0	180256009	4107731	
31582	2781	4125906	1996-01-18	1996-01-18 00:00:00	38000275	0	\N	\N	184330	0	288086009	4125906	
43719	3865	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	256567	0	180256009	4107731	
43927	3876	4107731	1990-10-01	1990-10-01 00:00:00	38000275	0	\N	\N	257506	0	180256009	4107731	
44092	3884	4043071	1984-12-15	1984-12-15 00:00:00	38000275	0	\N	\N	258025	0	228557008	4043071	
32192	2830	4107731	1991-04-08	1991-04-08 00:00:00	38000275	0	\N	\N	187699	0	180256009	4107731	
56410	4924	4107731	1992-01-22	1992-01-22 00:00:00	38000275	0	\N	\N	327226	0	180256009	4107731	
44675	3916	4107731	1994-12-28	1994-12-28 00:00:00	38000275	0	\N	\N	260320	0	180256009	4107731	
56710	4932	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	327904	0	180256009	4107731	
33094	2898	4107731	1994-10-25	1994-10-25 00:00:00	38000275	0	\N	\N	192971	0	180256009	4107731	
33152	2902	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	193336	0	180256009	4107731	
33398	2921	4035793	1991-06-25	1991-06-25 00:00:00	38000275	0	\N	\N	194766	0	15081005	4035793	
57580	4986	4078793	2015-08-09	2015-08-09 00:00:00	38000275	0	\N	\N	331666	0	180325003	4078793	
45668	4026	4107731	1991-10-20	1991-10-20 00:00:00	38000275	0	\N	\N	267684	0	180256009	4107731	
45939	4033	4043071	1981-05-07	1981-05-07 00:00:00	38000275	0	\N	\N	268296	0	228557008	4043071	
34200	2970	4107731	2000-11-02	2000-11-02 00:00:00	38000275	0	\N	\N	198337	0	180256009	4107731	
34335	2975	4107731	1990-12-30	1990-12-30 00:00:00	38000275	0	\N	\N	198615	0	180256009	4107731	
34510	2988	44783196	1993-01-10	1993-01-10 00:00:00	38000275	0	\N	\N	199488	0	699253003	44783196	
58538	5067	4295880	1997-10-19	1997-10-19 00:00:00	38000275	0	\N	\N	336894	0	76601001	4295880	
34966	3047	4295880	1996-03-13	1996-03-13 00:00:00	38000275	0	\N	\N	202779	0	76601001	4295880	
59046	5117	4107731	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	340124	0	180256009	4107731	
47136	4145	4107731	2007-04-28	2007-04-28 00:00:00	38000275	0	\N	\N	275536	0	180256009	4107731	
47487	4167	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	277003	0	180256009	4107731	
35707	3128	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	208121	0	180256009	4107731	
35810	3134	4078793	2015-04-02	2015-04-02 00:00:00	38000275	0	\N	\N	208594	0	180325003	4078793	
24023	2088	4035793	2010-02-23	2010-02-23 00:00:00	38000275	0	\N	\N	139283	0	15081005	4035793	
36215	3176	4107731	2002-08-11	2002-08-11 00:00:00	38000275	0	\N	\N	211087	0	180256009	4107731	
24459	2136	4107731	2003-02-21	2003-02-21 00:00:00	38000275	0	\N	\N	142262	0	180256009	4107731	
36577	3215	4107731	2003-05-24	2003-05-24 00:00:00	38000275	0	\N	\N	213566	0	180256009	4107731	
36776	3236	4125906	1993-06-28	1993-06-28 00:00:00	38000275	0	\N	\N	215031	0	288086009	4125906	
36855	3241	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	215497	0	180256009	4107731	
37103	3263	4151422	2011-02-15	2011-02-15 00:00:00	38000275	0	\N	\N	216943	0	269911007	4151422	
37276	3279	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	217913	0	180256009	4107731	
37465	3307	4238715	1985-01-10	1985-01-10 00:00:00	38000275	0	\N	\N	219583	0	68254000	4238715	
49571	4353	4043071	1980-07-30	1980-07-30 00:00:00	38000275	0	\N	\N	288810	0	228557008	4043071	
25975	2277	4170947	1971-04-07	1971-04-07 00:00:00	38000275	0	\N	\N	151383	0	274474001	4170947	
38082	3364	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	223054	0	180256009	4107731	
38193	3370	4107731	1992-06-28	1992-06-28 00:00:00	38000275	0	\N	\N	223523	0	180256009	4107731	
50313	4376	4078793	1998-10-20	1998-10-20 00:00:00	38000275	0	\N	\N	290803	0	180325003	4078793	
38671	3399	4107731	1999-03-22	1999-03-22 00:00:00	38000275	0	\N	\N	225435	0	180256009	4107731	
26888	2349	4107731	1990-08-26	1990-08-26 00:00:00	38000275	0	\N	\N	156379	0	180256009	4107731	
27113	2369	4107731	1996-05-12	1996-05-12 00:00:00	38000275	0	\N	\N	157649	0	180256009	4107731	
39130	3457	4243062	1986-03-31	1986-03-31 00:00:00	38000275	0	\N	\N	229385	0	60027007	4243062	
39325	3464	4107731	2012-11-09	2012-11-09 00:00:00	38000275	0	\N	\N	229902	0	180256009	4107731	
27569	2402	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	159617	0	180256009	4107731	
39691	3490	4170947	1951-02-13	1951-02-13 00:00:00	38000275	0	\N	\N	231513	0	274474001	4170947	
39849	3510	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	232838	0	180256009	4107731	
40141	3527	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	234121	0	180256009	4107731	
40313	3529	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	234358	0	180256009	4107731	
28593	2542	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	168084	0	180256009	4107731	
40698	3571	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	237413	0	180256009	4107731	
40830	3583	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	238287	0	180256009	4107731	
29040	2570	4170947	2015-05-22	2015-05-22 00:00:00	38000275	0	\N	\N	170200	0	274474001	4170947	
41159	3610	4151422	2001-01-01	2001-01-01 00:00:00	38000275	0	\N	\N	239843	0	269911007	4151422	
41417	3636	4043071	1985-12-19	1985-12-19 00:00:00	38000275	0	\N	\N	241805	0	228557008	4043071	
53525	4642	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	309407	0	180256009	4107731	
41861	3691	4243062	2011-06-23	2011-06-23 00:00:00	38000275	0	\N	\N	245331	0	60027007	4243062	
41952	3695	4293740	1992-09-28	1992-09-28 00:00:00	38000275	0	\N	\N	245604	0	384700001	4293740	
42127	3717	4043071	1983-07-02	1983-07-02 00:00:00	38000275	0	\N	\N	246954	0	228557008	4043071	
54270	4719	4163872	1966-07-05	1966-07-05 00:00:00	38000275	0	\N	\N	314189	0	399208008	4163872	
30639	2711	4107731	1992-06-22	1992-06-22 00:00:00	38000275	0	\N	\N	179677	0	180256009	4107731	
42642	3759	4107731	1992-05-17	1992-05-17 00:00:00	38000275	0	\N	\N	249962	0	180256009	4107731	
42916	3783	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	251436	0	180256009	4107731	
43196	3814	4170947	1975-09-27	1975-09-27 00:00:00	38000275	0	\N	\N	253312	0	274474001	4170947	
31302	2770	4107731	1991-07-06	1991-07-06 00:00:00	38000275	0	\N	\N	183321	0	180256009	4107731	
31583	2782	4125906	1956-06-03	1956-06-03 00:00:00	38000275	0	\N	\N	184406	0	288086009	4125906	
43720	3865	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	256590	0	180256009	4107731	
43928	3876	4107731	1990-12-03	1990-12-03 00:00:00	38000275	0	\N	\N	257476	0	180256009	4107731	
44093	3884	4043071	1984-07-14	1984-07-14 00:00:00	38000275	0	\N	\N	258024	0	228557008	4043071	
32193	2830	4107731	1991-07-22	1991-07-22 00:00:00	38000275	0	\N	\N	187813	0	180256009	4107731	
56411	4924	4107731	1993-06-30	1993-06-30 00:00:00	38000275	0	\N	\N	327169	0	180256009	4107731	
44676	3916	4295880	1993-12-29	1993-12-29 00:00:00	38000275	0	\N	\N	260378	0	76601001	4295880	
56711	4932	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	327806	0	180256009	4107731	
33095	2898	4107731	1995-05-23	1995-05-23 00:00:00	38000275	0	\N	\N	193108	0	180256009	4107731	
33153	2902	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	193342	0	180256009	4107731	
33399	2921	4035793	2016-11-15	2016-11-15 00:00:00	38000275	0	\N	\N	194719	0	15081005	4035793	
57581	4986	4078793	2016-08-14	2016-08-14 00:00:00	38000275	0	\N	\N	331675	0	180325003	4078793	
45669	4026	4107731	1992-06-07	1992-06-07 00:00:00	38000275	0	\N	\N	267780	0	180256009	4107731	
45940	4033	4043071	1981-01-07	1981-01-07 00:00:00	38000275	0	\N	\N	268295	0	228557008	4043071	
34201	2970	4107731	1999-05-27	1999-05-27 00:00:00	38000275	0	\N	\N	198350	0	180256009	4107731	
34336	2975	4170947	1965-11-18	1965-11-18 00:00:00	38000275	0	\N	\N	198626	0	274474001	4170947	
34511	2988	4202451	2012-06-24	2012-06-24 00:00:00	38000275	0	\N	\N	199457	0	433112001	4202451	
58539	5067	4295880	1997-01-19	1997-01-19 00:00:00	38000275	0	\N	\N	336893	0	76601001	4295880	
34967	3047	4295880	1996-06-12	1996-06-12 00:00:00	38000275	0	\N	\N	202731	0	76601001	4295880	
59047	5117	4191853	1990-01-01	1990-01-01 00:00:00	38000275	0	\N	\N	340118	0	395142003	4191853	
47137	4145	4107731	2008-05-31	2008-05-31 00:00:00	38000275	0	\N	\N	275542	0	180256009	4107731	
47488	4167	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	276894	0	180256009	4107731	
35708	3128	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	208185	0	180256009	4107731	
35811	3134	4125906	1981-10-24	1981-10-24 00:00:00	38000275	0	\N	\N	208556	0	288086009	4125906	
24024	2088	4035793	1985-07-02	1985-07-02 00:00:00	38000275	0	\N	\N	139171	0	15081005	4035793	
36216	3176	4107731	2005-01-09	2005-01-09 00:00:00	38000275	0	\N	\N	211209	0	180256009	4107731	
24460	2136	4107731	2002-03-01	2002-03-01 00:00:00	38000275	0	\N	\N	142197	0	180256009	4107731	
36578	3215	4107731	2004-12-11	2004-12-11 00:00:00	38000275	0	\N	\N	213661	0	180256009	4107731	
36777	3236	4078793	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	215038	0	180325003	4078793	
36856	3241	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	215529	0	180256009	4107731	
37156	3268	4151422	1988-11-23	1988-11-23 00:00:00	38000275	0	\N	\N	217165	0	269911007	4151422	
37277	3279	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	217905	0	180256009	4107731	
37466	3307	4058899	1975-08-31	1975-08-31 00:00:00	38000275	0	\N	\N	219554	0	168594001	4058899	
49572	4353	4252419	1972-11-03	1972-11-03 00:00:00	38000275	0	\N	\N	288786	0	74016001	4252419	
25976	2277	4047491	1977-04-05	1977-04-05 00:00:00	38000275	0	\N	\N	151384	0	1225002	4047491	
38083	3364	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	223068	0	180256009	4107731	
38194	3370	4107731	1992-11-01	1992-11-01 00:00:00	38000275	0	\N	\N	223469	0	180256009	4107731	
50314	4376	4035793	1998-10-20	1998-10-20 00:00:00	38000275	0	\N	\N	290803	0	15081005	4035793	
38672	3399	4107731	1998-02-16	1998-02-16 00:00:00	38000275	0	\N	\N	225460	0	180256009	4107731	
26889	2349	4107731	1992-08-09	1992-08-09 00:00:00	38000275	0	\N	\N	156404	0	180256009	4107731	
27114	2369	4107731	1994-10-23	1994-10-23 00:00:00	38000275	0	\N	\N	157633	0	180256009	4107731	
39131	3457	4170947	1986-03-31	1986-03-31 00:00:00	38000275	0	\N	\N	229385	0	274474001	4170947	
39326	3464	4107731	2010-07-23	2010-07-23 00:00:00	38000275	0	\N	\N	229963	0	180256009	4107731	
27570	2402	4107731	1991-11-04	1991-11-04 00:00:00	38000275	0	\N	\N	159654	0	180256009	4107731	
39692	3490	4047491	1951-02-13	1951-02-13 00:00:00	38000275	0	\N	\N	231513	0	1225002	4047491	
39850	3510	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	232935	0	180256009	4107731	
40142	3527	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	234021	0	395142003	4191853	
40314	3529	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	234441	0	180256009	4107731	
28594	2542	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	168142	0	180256009	4107731	
40699	3571	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	237437	0	180256009	4107731	
40831	3583	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	238225	0	180256009	4107731	
29041	2570	4047491	2015-05-22	2015-05-22 00:00:00	38000275	0	\N	\N	170200	0	1225002	4047491	
41160	3610	4125906	1987-06-20	1987-06-20 00:00:00	38000275	0	\N	\N	239884	0	288086009	4125906	
41418	3636	4238715	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	241861	0	68254000	4238715	
53526	4642	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	309429	0	180256009	4107731	
41862	3691	4195803	2011-06-23	2011-06-23 00:00:00	38000275	0	\N	\N	245331	0	312681000	4195803	
41953	3695	4125906	1992-09-28	1992-09-28 00:00:00	38000275	0	\N	\N	245604	0	288086009	4125906	
42128	3717	4107731	1990-09-15	1990-09-15 00:00:00	38000275	0	\N	\N	247034	0	180256009	4107731	
54271	4719	4107731	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	314198	0	180256009	4107731	
30640	2711	4125906	1988-05-07	1988-05-07 00:00:00	38000275	0	\N	\N	179612	0	288086009	4125906	
42643	3759	4125906	1987-03-26	1987-03-26 00:00:00	38000275	0	\N	\N	249879	0	288086009	4125906	
42917	3783	4181917	1952-04-02	1952-04-02 00:00:00	38000275	0	\N	\N	251451	0	54550000	4181917	
43197	3814	4047491	1975-09-27	1975-09-27 00:00:00	38000275	0	\N	\N	253312	0	1225002	4047491	
31303	2770	4181917	1945-03-31	1945-03-31 00:00:00	38000275	0	\N	\N	183302	0	54550000	4181917	
31584	2782	4078793	1995-04-12	1995-04-12 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
43721	3865	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	256583	0	395142003	4191853	
43929	3876	4107731	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	257513	0	180256009	4107731	
44094	3884	4043071	1989-08-26	1989-08-26 00:00:00	38000275	0	\N	\N	258059	0	228557008	4043071	
32194	2830	4107731	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	187741	0	180256009	4107731	
56412	4924	4107731	1991-10-09	1991-10-09 00:00:00	38000275	0	\N	\N	327155	0	180256009	4107731	
44677	3916	4107731	1992-01-22	1992-01-22 00:00:00	38000275	0	\N	\N	260399	0	180256009	4107731	
56712	4932	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	327893	0	180256009	4107731	
33096	2898	4107731	1995-02-07	1995-02-07 00:00:00	38000275	0	\N	\N	193095	0	180256009	4107731	
33154	2902	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	193285	0	180256009	4107731	
33400	2921	4035793	2014-11-04	2014-11-04 00:00:00	38000275	0	\N	\N	194762	0	15081005	4035793	
57582	4986	4202451	1983-09-11	1983-09-11 00:00:00	38000275	0	\N	\N	331692	0	433112001	4202451	
45670	4026	4107731	1990-04-22	1990-04-22 00:00:00	38000275	0	\N	\N	267725	0	180256009	4107731	
45941	4033	4043071	1979-10-11	1979-10-11 00:00:00	38000275	0	\N	\N	268315	0	228557008	4043071	
34202	2970	4170947	2015-01-15	2015-01-15 00:00:00	38000275	0	\N	\N	198343	0	274474001	4170947	
34337	2975	4024289	1965-11-18	1965-11-18 00:00:00	38000275	0	\N	\N	198626	0	19490002	4024289	
34512	2988	4151422	1972-09-16	1972-09-16 00:00:00	38000275	0	\N	\N	199464	0	269911007	4151422	
58540	5067	4295880	1996-10-20	1996-10-20 00:00:00	38000275	0	\N	\N	336881	0	76601001	4295880	
34968	3047	4295880	1994-12-14	1994-12-14 00:00:00	38000275	0	\N	\N	202725	0	76601001	4295880	
59048	5117	4107731	1992-12-07	1992-12-07 00:00:00	38000275	0	\N	\N	340082	0	180256009	4107731	
47138	4145	4107731	2007-01-13	2007-01-13 00:00:00	38000275	0	\N	\N	275499	0	180256009	4107731	
47489	4167	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	276956	0	180256009	4107731	
35709	3128	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	208206	0	180256009	4107731	
35812	3134	4078793	2011-03-10	2011-03-10 00:00:00	38000275	0	\N	\N	208599	0	180325003	4078793	
24025	2088	4035793	2000-06-06	2000-06-06 00:00:00	38000275	0	\N	\N	139172	0	15081005	4035793	
36217	3176	4107731	2003-06-22	2003-06-22 00:00:00	38000275	0	\N	\N	211114	0	180256009	4107731	
24461	2136	4107731	2001-12-07	2001-12-07 00:00:00	38000275	0	\N	\N	142215	0	180256009	4107731	
36579	3215	4107731	2003-09-27	2003-09-27 00:00:00	38000275	0	\N	\N	213675	0	180256009	4107731	
36778	3236	4125906	1994-06-07	1994-06-07 00:00:00	38000275	0	\N	\N	215032	0	288086009	4125906	
36857	3241	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	215482	0	180256009	4107731	
37157	3268	4293740	2013-07-25	2013-07-25 00:00:00	38000275	0	\N	\N	217214	0	384700001	4293740	
37278	3279	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	217954	0	180256009	4107731	
37467	3307	4024289	1982-03-17	1982-03-17 00:00:00	38000275	0	\N	\N	219578	0	19490002	4024289	
49573	4353	4043071	1978-03-08	1978-03-08 00:00:00	38000275	0	\N	\N	288763	0	228557008	4043071	
25977	2277	4170947	1977-04-05	1977-04-05 00:00:00	38000275	0	\N	\N	151384	0	274474001	4170947	
38084	3364	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	223061	0	180256009	4107731	
38195	3370	4107731	1993-01-24	1993-01-24 00:00:00	38000275	0	\N	\N	223471	0	180256009	4107731	
50315	4376	4078793	1979-07-03	1979-07-03 00:00:00	38000275	0	\N	\N	290797	0	180325003	4078793	
38673	3399	4107731	1997-11-24	1997-11-24 00:00:00	38000275	0	\N	\N	225474	0	180256009	4107731	
26890	2349	4107731	1990-06-24	1990-06-24 00:00:00	38000275	0	\N	\N	156443	0	180256009	4107731	
27115	2369	4107731	1996-03-31	1996-03-31 00:00:00	38000275	0	\N	\N	157686	0	180256009	4107731	
39132	3458	4125906	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	229446	0	288086009	4125906	
39327	3464	4107731	2010-04-30	2010-04-30 00:00:00	38000275	0	\N	\N	229910	0	180256009	4107731	
27571	2402	4107731	1992-09-14	1992-09-14 00:00:00	38000275	0	\N	\N	159658	0	180256009	4107731	
39693	3490	4151422	1993-06-22	1993-06-22 00:00:00	38000275	0	\N	\N	231597	0	269911007	4151422	
39851	3510	4151422	1970-02-12	1970-02-12 00:00:00	38000275	0	\N	\N	232813	0	269911007	4151422	
40143	3527	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	234112	0	180256009	4107731	
40315	3529	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	234384	0	180256009	4107731	
28595	2542	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	168132	0	180256009	4107731	
40700	3571	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	237436	0	180256009	4107731	
40832	3583	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	238237	0	180256009	4107731	
29042	2570	4195803	2015-05-22	2015-05-22 00:00:00	38000275	0	\N	\N	170200	0	312681000	4195803	
41163	3612	4024289	1991-12-02	1991-12-02 00:00:00	38000275	0	\N	\N	240000	0	19490002	4024289	
41419	3636	4043071	1985-09-19	1985-09-19 00:00:00	38000275	0	\N	\N	241800	0	228557008	4043071	
53527	4642	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	309430	0	180256009	4107731	
41863	3691	4170947	2011-06-23	2011-06-23 00:00:00	38000275	0	\N	\N	245331	0	274474001	4170947	
41954	3695	4107731	1996-02-05	1996-02-05 00:00:00	38000275	0	\N	\N	245589	0	180256009	4107731	
42129	3717	4330583	2012-05-06	2012-05-06 00:00:00	38000275	0	\N	\N	247017	0	22523008	4330583	
54272	4719	4107731	1990-12-30	1990-12-30 00:00:00	38000275	0	\N	\N	314304	0	180256009	4107731	
30641	2711	4170947	2015-11-03	2015-11-03 00:00:00	38000275	0	\N	\N	179616	0	274474001	4170947	
42644	3759	4125906	1982-08-05	1982-08-05 00:00:00	38000275	0	\N	\N	249933	0	288086009	4125906	
42918	3783	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	251443	0	180256009	4107731	
54979	4773	4151422	2009-06-04	2009-06-04 00:00:00	38000275	0	\N	\N	317852	0	269911007	4151422	
31304	2770	4107731	1991-11-09	1991-11-09 00:00:00	38000275	0	\N	\N	183386	0	180256009	4107731	
31585	2782	4125906	1945-07-03	1945-07-03 00:00:00	38000275	0	\N	\N	184404	0	288086009	4125906	
43722	3865	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	256629	0	180256009	4107731	
43930	3876	4107731	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	257475	0	180256009	4107731	
44095	3884	4043071	1988-02-13	1988-02-13 00:00:00	38000275	0	\N	\N	258134	0	228557008	4043071	
32195	2830	4107731	1992-06-22	1992-06-22 00:00:00	38000275	0	\N	\N	187738	0	180256009	4107731	
56413	4924	4107731	1993-10-13	1993-10-13 00:00:00	38000275	0	\N	\N	327276	0	180256009	4107731	
44678	3916	4191853	1979-04-17	1979-04-17 00:00:00	38000275	0	\N	\N	260278	0	395142003	4191853	
56713	4932	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	327871	0	180256009	4107731	
33097	2898	4107731	1993-06-08	1993-06-08 00:00:00	38000275	0	\N	\N	192985	0	180256009	4107731	
33155	2902	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	193380	0	395142003	4191853	
33401	2921	4035793	1996-07-23	1996-07-23 00:00:00	38000275	0	\N	\N	194702	0	15081005	4035793	
57583	4986	4078793	2014-07-13	2014-07-13 00:00:00	38000275	0	\N	\N	331665	0	180325003	4078793	
45671	4026	4107731	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	267761	0	180256009	4107731	
45942	4033	4043071	1981-03-11	1981-03-11 00:00:00	38000275	0	\N	\N	268347	0	228557008	4043071	
34203	2970	4243062	2015-01-15	2015-01-15 00:00:00	38000275	0	\N	\N	198343	0	60027007	4243062	
34338	2975	4107731	1992-04-26	1992-04-26 00:00:00	38000275	0	\N	\N	198685	0	180256009	4107731	
34513	2988	4125906	2008-12-01	2008-12-01 00:00:00	38000275	0	\N	\N	199429	0	288086009	4125906	
58541	5067	4295880	1997-07-20	1997-07-20 00:00:00	38000275	0	\N	\N	336882	0	76601001	4295880	
34969	3047	4295880	1994-09-14	1994-09-14 00:00:00	38000275	0	\N	\N	202777	0	76601001	4295880	
59049	5117	4107731	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	340125	0	180256009	4107731	
47139	4145	4107731	2009-11-07	2009-11-07 00:00:00	38000275	0	\N	\N	275463	0	180256009	4107731	
47490	4167	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	277004	0	180256009	4107731	
35710	3128	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	208191	0	180256009	4107731	
35813	3134	4125906	2001-08-01	2001-08-01 00:00:00	38000275	0	\N	\N	208558	0	288086009	4125906	
24026	2088	4035793	2013-07-09	2013-07-09 00:00:00	38000275	0	\N	\N	139196	0	15081005	4035793	
36218	3176	4107731	2003-11-16	2003-11-16 00:00:00	38000275	0	\N	\N	211091	0	180256009	4107731	
24462	2136	4107731	2003-10-31	2003-10-31 00:00:00	38000275	0	\N	\N	142226	0	180256009	4107731	
36580	3215	4107731	2005-01-01	2005-01-01 00:00:00	38000275	0	\N	\N	213616	0	180256009	4107731	
36779	3236	4057420	2000-02-25	2000-02-25 00:00:00	38000275	0	\N	\N	215042	0	18286008	4057420	
36858	3241	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	215534	0	180256009	4107731	
37158	3268	4125906	2013-07-25	2013-07-25 00:00:00	38000275	0	\N	\N	217214	0	288086009	4125906	
37279	3279	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	217922	0	180256009	4107731	
37468	3307	4170947	1982-03-17	1982-03-17 00:00:00	38000275	0	\N	\N	219578	0	274474001	4170947	
49574	4353	4043071	1980-11-05	1980-11-05 00:00:00	38000275	0	\N	\N	288748	0	228557008	4043071	
37775	3342	4057420	2011-05-04	2011-05-04 00:00:00	38000275	0	\N	\N	221664	0	18286008	4057420	
38085	3364	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	223113	0	180256009	4107731	
38196	3370	4107731	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	223402	0	180256009	4107731	
50316	4376	4035793	1994-09-27	1994-09-27 00:00:00	38000275	0	\N	\N	290704	0	15081005	4035793	
38674	3399	4107731	1997-09-02	1997-09-02 00:00:00	38000275	0	\N	\N	225472	0	180256009	4107731	
26891	2351	4163872	1958-07-26	1958-07-26 00:00:00	38000275	0	\N	\N	156569	0	399208008	4163872	
38939	3434	44783196	1951-06-13	1951-06-13 00:00:00	38000275	0	\N	\N	227679	0	699253003	44783196	
39133	3458	4151422	2004-01-04	2004-01-04 00:00:00	38000275	0	\N	\N	229460	0	269911007	4151422	
39328	3464	4107731	2012-08-17	2012-08-17 00:00:00	38000275	0	\N	\N	229919	0	180256009	4107731	
27572	2402	4107731	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	159690	0	180256009	4107731	
39694	3490	4047491	1956-01-23	1956-01-23 00:00:00	38000275	0	\N	\N	231516	0	1225002	4047491	
39852	3510	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	232922	0	180256009	4107731	
40144	3527	4163872	1979-01-15	1979-01-15 00:00:00	38000275	0	\N	\N	234050	0	399208008	4163872	
40316	3529	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	234382	0	180256009	4107731	
28596	2542	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	168099	0	180256009	4107731	
40701	3571	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	237347	0	180256009	4107731	
40833	3583	4197460	1971-11-20	1971-11-20 00:00:00	38000275	0	\N	\N	238241	0	313191000	4197460	
29043	2570	4125906	1958-08-21	1958-08-21 00:00:00	38000275	0	\N	\N	170197	0	288086009	4125906	
41164	3612	4170947	1991-12-02	1991-12-02 00:00:00	38000275	0	\N	\N	240000	0	274474001	4170947	
41420	3636	4043071	1986-05-08	1986-05-08 00:00:00	38000275	0	\N	\N	241779	0	228557008	4043071	
53528	4642	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	309418	0	180256009	4107731	
41864	3691	4125906	1989-12-24	1989-12-24 00:00:00	38000275	0	\N	\N	245330	0	288086009	4125906	
41955	3695	4125906	2015-11-14	2015-11-14 00:00:00	38000275	0	\N	\N	245567	0	288086009	4125906	
42130	3717	4107731	1992-12-12	1992-12-12 00:00:00	38000275	0	\N	\N	247043	0	180256009	4107731	
54273	4719	4107731	1990-06-24	1990-06-24 00:00:00	38000275	0	\N	\N	314303	0	180256009	4107731	
30642	2711	4024289	2015-11-03	2015-11-03 00:00:00	38000275	0	\N	\N	179616	0	19490002	4024289	
42645	3759	4163872	1974-07-18	1974-07-18 00:00:00	38000275	0	\N	\N	249932	0	399208008	4163872	
42919	3783	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	251361	0	180256009	4107731	
54980	4773	4151422	1963-10-02	1963-10-02 00:00:00	38000275	0	\N	\N	317903	0	269911007	4151422	
31305	2771	4078793	2017-09-01	2017-09-01 00:00:00	38000275	0	\N	\N	183515	0	180325003	4078793	
31586	2782	4078793	1987-07-01	1987-07-01 00:00:00	38000275	0	\N	\N	184454	0	180325003	4078793	
43723	3865	4151422	1985-12-10	1985-12-10 00:00:00	38000275	0	\N	\N	256582	0	269911007	4151422	
43931	3876	4107731	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	257435	0	180256009	4107731	
44096	3884	4043071	1985-05-04	1985-05-04 00:00:00	38000275	0	\N	\N	258040	0	228557008	4043071	
32196	2830	4191853	1990-01-01	1990-01-01 00:00:00	38000275	0	\N	\N	187787	0	395142003	4191853	
56414	4924	4107731	1994-03-09	1994-03-09 00:00:00	38000275	0	\N	\N	327197	0	180256009	4107731	
44679	3916	4107731	1992-05-27	1992-05-27 00:00:00	38000275	0	\N	\N	260409	0	180256009	4107731	
56714	4932	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	327918	0	180256009	4107731	
33098	2898	4107731	1992-03-24	1992-03-24 00:00:00	38000275	0	\N	\N	192996	0	180256009	4107731	
33156	2902	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	193309	0	180256009	4107731	
33402	2921	4035793	2006-09-19	2006-09-19 00:00:00	38000275	0	\N	\N	194749	0	15081005	4035793	
57584	4986	4078793	2004-05-16	2004-05-16 00:00:00	38000275	0	\N	\N	331660	0	180325003	4078793	
45672	4026	4107731	1990-02-18	1990-02-18 00:00:00	38000275	0	\N	\N	267665	0	180256009	4107731	
45943	4033	4043071	1980-07-03	1980-07-03 00:00:00	38000275	0	\N	\N	268302	0	228557008	4043071	
34204	2970	4107731	2002-02-28	2002-02-28 00:00:00	38000275	0	\N	\N	198300	0	180256009	4107731	
34339	2975	4107731	1991-05-05	1991-05-05 00:00:00	38000275	0	\N	\N	198573	0	180256009	4107731	
34514	2988	4252419	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	199427	0	74016001	4252419	
58542	5067	4062501	1978-06-08	1978-06-08 00:00:00	38000275	0	\N	\N	336888	0	171231001	4062501	
46807	4109	4191853	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	273140	0	395142003	4191853	
59050	5117	4107731	1992-06-22	1992-06-22 00:00:00	38000275	0	\N	\N	340148	0	180256009	4107731	
47140	4145	4151422	1993-11-25	1993-11-25 00:00:00	38000275	0	\N	\N	275495	0	269911007	4151422	
47491	4167	4107731	1994-04-27	1994-04-27 00:00:00	38000275	0	\N	\N	276883	0	180256009	4107731	
35711	3128	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	208213	0	180256009	4107731	
35814	3134	4202451	2015-04-16	2015-04-16 00:00:00	38000275	0	\N	\N	208605	0	433112001	4202451	
24027	2088	4035793	2008-02-12	2008-02-12 00:00:00	38000275	0	\N	\N	139282	0	15081005	4035793	
36219	3176	4107731	2003-01-26	2003-01-26 00:00:00	38000275	0	\N	\N	211131	0	180256009	4107731	
24463	2136	4107731	2001-10-05	2001-10-05 00:00:00	38000275	0	\N	\N	142300	0	180256009	4107731	
36581	3215	4107731	2004-07-17	2004-07-17 00:00:00	38000275	0	\N	\N	213648	0	180256009	4107731	
36780	3236	4078793	1994-01-21	1994-01-21 00:00:00	38000275	0	\N	\N	215039	0	180325003	4078793	
36859	3241	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	215526	0	180256009	4107731	
37159	3268	4125906	2018-05-21	2018-05-21 00:00:00	38000275	0	\N	\N	217215	0	288086009	4125906	
37280	3279	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	217904	0	180256009	4107731	
37469	3307	4170947	1972-09-15	1972-09-15 00:00:00	38000275	0	\N	\N	219553	0	274474001	4170947	
49575	4353	4043071	1977-12-07	1977-12-07 00:00:00	38000275	0	\N	\N	288739	0	228557008	4043071	
37776	3342	4078793	2016-06-01	2016-06-01 00:00:00	38000275	0	\N	\N	221602	0	180325003	4078793	
38086	3364	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	223062	0	395142003	4191853	
38197	3370	4107731	1992-11-22	1992-11-22 00:00:00	38000275	0	\N	\N	223439	0	180256009	4107731	
50317	4376	4078793	1994-09-27	1994-09-27 00:00:00	38000275	0	\N	\N	290704	0	180325003	4078793	
38675	3399	4107731	1999-06-15	1999-06-15 00:00:00	38000275	0	\N	\N	225437	0	180256009	4107731	
26892	2351	4125906	1968-03-16	1968-03-16 00:00:00	38000275	0	\N	\N	156507	0	288086009	4125906	
38940	3434	4043071	1957-05-18	1957-05-18 00:00:00	38000275	0	\N	\N	227724	0	228557008	4043071	
39134	3458	4125906	2013-05-05	2013-05-05 00:00:00	38000275	0	\N	\N	229448	0	288086009	4125906	
39329	3464	4107731	2011-01-07	2011-01-07 00:00:00	38000275	0	\N	\N	229970	0	180256009	4107731	
27573	2402	4107731	1992-07-13	1992-07-13 00:00:00	38000275	0	\N	\N	159597	0	180256009	4107731	
39695	3490	4170947	1956-01-23	1956-01-23 00:00:00	38000275	0	\N	\N	231516	0	274474001	4170947	
39853	3510	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	232810	0	180256009	4107731	
40145	3527	4170947	1979-01-15	1979-01-15 00:00:00	38000275	0	\N	\N	234050	0	274474001	4170947	
40317	3529	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	234424	0	180256009	4107731	
28597	2542	4191853	1986-06-26	1986-06-26 00:00:00	38000275	0	\N	\N	168123	0	395142003	4191853	
40702	3571	4191853	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	237417	0	395142003	4191853	
40834	3583	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	238270	0	180256009	4107731	
29044	2570	4170947	1946-09-23	1946-09-23 00:00:00	38000275	0	\N	\N	170196	0	274474001	4170947	
41165	3612	4145310	1974-04-05	1974-04-05 00:00:00	38000275	0	\N	\N	239999	0	268425006	4145310	
41421	3636	4043071	1985-08-15	1985-08-15 00:00:00	38000275	0	\N	\N	241799	0	228557008	4043071	
53529	4642	4151422	1984-09-09	1984-09-09 00:00:00	38000275	0	\N	\N	309471	0	269911007	4151422	
41870	3694	4043071	1965-07-21	1965-07-21 00:00:00	38000275	0	\N	\N	245477	0	228557008	4043071	
41956	3695	4107731	1995-08-21	1995-08-21 00:00:00	38000275	0	\N	\N	245657	0	180256009	4107731	
42131	3717	4107731	1993-03-27	1993-03-27 00:00:00	38000275	0	\N	\N	246977	0	180256009	4107731	
54274	4719	4107731	1991-05-26	1991-05-26 00:00:00	38000275	0	\N	\N	314295	0	180256009	4107731	
30643	2711	4195803	2015-11-03	2015-11-03 00:00:00	38000275	0	\N	\N	179616	0	312681000	4195803	
42646	3759	4170947	1974-07-18	1974-07-18 00:00:00	38000275	0	\N	\N	249932	0	274474001	4170947	
42920	3783	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	251435	0	180256009	4107731	
54994	4776	4078793	2017-05-28	2017-05-28 00:00:00	38000275	0	\N	\N	318023	0	180325003	4078793	
31306	2771	4078793	2018-09-07	2018-09-07 00:00:00	38000275	0	\N	\N	183466	0	180325003	4078793	
31587	2782	4057420	1998-03-25	1998-03-25 00:00:00	38000275	0	\N	\N	\N	0	18286008	4057420	
43724	3865	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	256675	0	180256009	4107731	
43932	3876	4107731	1991-02-04	1991-02-04 00:00:00	38000275	0	\N	\N	257498	0	180256009	4107731	
44097	3884	4107731	1991-04-29	1991-04-29 00:00:00	38000275	0	\N	\N	258101	0	180256009	4107731	
32197	2830	4107731	1993-01-18	1993-01-18 00:00:00	38000275	0	\N	\N	187686	0	180256009	4107731	
56415	4924	4107731	1991-08-28	1991-08-28 00:00:00	38000275	0	\N	\N	327212	0	180256009	4107731	
44680	3916	4107731	1992-12-02	1992-12-02 00:00:00	38000275	0	\N	\N	260410	0	180256009	4107731	
56715	4932	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	327891	0	180256009	4107731	
33099	2898	4107731	1994-11-15	1994-11-15 00:00:00	38000275	0	\N	\N	193107	0	180256009	4107731	
33157	2902	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	193288	0	180256009	4107731	
33403	2921	4035793	2012-10-23	2012-10-23 00:00:00	38000275	0	\N	\N	194745	0	15081005	4035793	
57585	4986	4078793	2006-05-28	2006-05-28 00:00:00	38000275	0	\N	\N	331661	0	180325003	4078793	
45673	4026	4107731	1991-06-16	1991-06-16 00:00:00	38000275	0	\N	\N	267775	0	180256009	4107731	
45944	4033	4043071	1979-08-09	1979-08-09 00:00:00	38000275	0	\N	\N	268342	0	228557008	4043071	
34205	2970	4107731	2000-08-31	2000-08-31 00:00:00	38000275	0	\N	\N	198330	0	180256009	4107731	
34340	2975	4107731	1992-11-01	1992-11-01 00:00:00	38000275	0	\N	\N	198577	0	180256009	4107731	
34515	2989	4252419	1960-01-28	1960-01-28 00:00:00	38000275	0	\N	\N	199586	0	74016001	4252419	
58543	5067	4125906	2002-04-27	2002-04-27 00:00:00	38000275	0	\N	\N	336821	0	288086009	4125906	
46808	4109	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	273087	0	180256009	4107731	
59051	5117	4107731	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	340062	0	180256009	4107731	
47141	4145	4107731	2007-03-17	2007-03-17 00:00:00	38000275	0	\N	\N	275517	0	180256009	4107731	
47492	4167	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	276888	0	180256009	4107731	
35712	3128	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	208131	0	180256009	4107731	
35815	3134	4078793	2018-04-19	2018-04-19 00:00:00	38000275	0	\N	\N	208603	0	180325003	4078793	
24028	2088	4035793	1997-05-20	1997-05-20 00:00:00	38000275	0	\N	\N	139280	0	15081005	4035793	
36220	3176	4107731	2002-04-28	2002-04-28 00:00:00	38000275	0	\N	\N	211128	0	180256009	4107731	
24464	2136	4151422	1983-12-11	1983-12-11 00:00:00	38000275	0	\N	\N	142212	0	269911007	4151422	
36582	3215	4107731	2004-05-15	2004-05-15 00:00:00	38000275	0	\N	\N	213614	0	180256009	4107731	
36781	3236	4078793	2003-07-04	2003-07-04 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
36860	3241	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	215516	0	180256009	4107731	
37162	3270	4043071	1981-06-22	1981-06-22 00:00:00	38000275	0	\N	\N	217247	0	228557008	4043071	
37281	3279	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	217835	0	180256009	4107731	
37470	3307	4024289	1972-09-15	1972-09-15 00:00:00	38000275	0	\N	\N	219553	0	19490002	4024289	
49576	4353	4043071	1981-02-11	1981-02-11 00:00:00	38000275	0	\N	\N	288812	0	228557008	4043071	
37777	3342	4163872	1977-08-13	1977-08-13 00:00:00	38000275	0	\N	\N	221609	0	399208008	4163872	
38087	3364	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	223119	0	395142003	4191853	
38198	3370	4107731	1991-12-22	1991-12-22 00:00:00	38000275	0	\N	\N	223419	0	180256009	4107731	
50318	4376	4145310	2010-09-19	2010-09-19 00:00:00	38000275	0	\N	\N	290735	0	268425006	4145310	
38676	3399	4107731	1997-04-29	1997-04-29 00:00:00	38000275	0	\N	\N	225481	0	180256009	4107731	
26893	2351	4058899	1993-07-22	1993-07-22 00:00:00	38000275	0	\N	\N	156509	0	168594001	4058899	
38941	3434	4252419	1951-06-06	1951-06-06 00:00:00	38000275	0	\N	\N	227681	0	74016001	4252419	
39202	3462	4125906	2018-04-29	2018-04-29 00:00:00	38000275	0	\N	\N	229770	0	288086009	4125906	
39330	3464	4107731	2011-04-22	2011-04-22 00:00:00	38000275	0	\N	\N	229936	0	180256009	4107731	
27574	2404	4252419	1986-11-11	1986-11-11 00:00:00	38000275	0	\N	\N	159762	0	74016001	4252419	
39696	3490	4125906	2012-06-27	2012-06-27 00:00:00	38000275	0	\N	\N	231523	0	288086009	4125906	
39854	3510	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	232868	0	180256009	4107731	
40146	3527	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	234138	0	180256009	4107731	
40318	3529	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	234442	0	180256009	4107731	
28598	2542	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	168078	0	180256009	4107731	
40703	3571	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	237368	0	180256009	4107731	
40835	3583	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	238244	0	395142003	4191853	
29045	2570	4047491	1946-09-23	1946-09-23 00:00:00	38000275	0	\N	\N	170196	0	1225002	4047491	
41166	3613	4198190	1989-01-23	1989-01-23 00:00:00	38000275	0	\N	\N	240060	0	80146002	4198190	
41422	3636	4275113	1986-07-14	1986-07-14 00:00:00	38000275	0	\N	\N	241872	0	65200003	4275113	
53530	4642	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	309364	0	180256009	4107731	
41871	3694	4043071	1965-10-13	1965-10-13 00:00:00	38000275	0	\N	\N	245478	0	228557008	4043071	
41957	3695	4191853	1996-08-12	1996-08-12 00:00:00	38000275	0	\N	\N	245675	0	395142003	4191853	
42132	3717	4107731	1993-03-06	1993-03-06 00:00:00	38000275	0	\N	\N	247045	0	180256009	4107731	
54275	4719	4293740	2013-12-24	2013-12-24 00:00:00	38000275	0	\N	\N	314299	0	384700001	4293740	
30644	2711	4151422	1996-04-09	1996-04-09 00:00:00	38000275	0	\N	\N	179668	0	269911007	4151422	
42647	3759	4107731	1991-03-03	1991-03-03 00:00:00	38000275	0	\N	\N	249912	0	180256009	4107731	
42921	3783	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	251337	0	180256009	4107731	
54995	4776	4078793	2016-05-22	2016-05-22 00:00:00	38000275	0	\N	\N	318039	0	180325003	4078793	
31307	2771	4151422	1920-09-15	1920-09-15 00:00:00	38000275	0	\N	\N	183508	0	269911007	4151422	
31588	2782	4078793	1979-02-07	1979-02-07 00:00:00	38000275	0	\N	\N	184360	0	180325003	4078793	
43725	3865	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	256653	0	180256009	4107731	
43933	3876	4107731	1990-05-07	1990-05-07 00:00:00	38000275	0	\N	\N	257495	0	180256009	4107731	
44098	3884	4043071	1989-07-29	1989-07-29 00:00:00	38000275	0	\N	\N	258094	0	228557008	4043071	
32198	2830	4107731	1992-02-17	1992-02-17 00:00:00	38000275	0	\N	\N	187703	0	180256009	4107731	
56416	4924	4107731	1991-08-07	1991-08-07 00:00:00	38000275	0	\N	\N	327263	0	180256009	4107731	
44681	3916	4107731	1992-09-30	1992-09-30 00:00:00	38000275	0	\N	\N	260389	0	180256009	4107731	
56716	4932	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	327875	0	180256009	4107731	
44929	3942	4058899	1989-06-21	1989-06-21 00:00:00	38000275	0	\N	\N	262086	0	168594001	4058899	
33158	2902	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	193372	0	180256009	4107731	
33404	2921	4035793	2007-09-25	2007-09-25 00:00:00	38000275	0	\N	\N	194704	0	15081005	4035793	
57586	4986	4078793	2013-07-07	2013-07-07 00:00:00	38000275	0	\N	\N	331673	0	180325003	4078793	
45674	4026	4107731	1990-06-24	1990-06-24 00:00:00	38000275	0	\N	\N	267762	0	180256009	4107731	
45945	4033	4043071	1979-11-14	1979-11-14 00:00:00	38000275	0	\N	\N	268299	0	228557008	4043071	
34206	2970	4107731	2001-10-25	2001-10-25 00:00:00	38000275	0	\N	\N	198286	0	180256009	4107731	
34341	2975	4107731	1990-08-26	1990-08-26 00:00:00	38000275	0	\N	\N	198663	0	180256009	4107731	
34516	2989	4151422	1972-03-14	1972-03-14 00:00:00	38000275	0	\N	\N	199575	0	269911007	4151422	
58544	5067	4145310	1978-04-03	1978-04-03 00:00:00	38000275	0	\N	\N	336816	0	268425006	4145310	
46809	4109	4151422	1973-05-19	1973-05-19 00:00:00	38000275	0	\N	\N	273101	0	269911007	4151422	
59052	5117	4107731	1993-03-01	1993-03-01 00:00:00	38000275	0	\N	\N	340042	0	180256009	4107731	
47142	4145	4107731	2006-09-09	2006-09-09 00:00:00	38000275	0	\N	\N	275534	0	180256009	4107731	
47493	4167	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	276958	0	180256009	4107731	
35713	3128	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	208127	0	180256009	4107731	
35816	3134	4057420	2016-04-07	2016-04-07 00:00:00	38000275	0	\N	\N	208602	0	18286008	4057420	
24029	2088	4035793	2016-07-26	2016-07-26 00:00:00	38000275	0	\N	\N	139292	0	15081005	4035793	
36221	3176	4107731	2005-05-15	2005-05-15 00:00:00	38000275	0	\N	\N	211220	0	180256009	4107731	
24465	2136	4107731	2002-05-24	2002-05-24 00:00:00	38000275	0	\N	\N	142199	0	180256009	4107731	
36583	3215	4107731	2002-12-07	2002-12-07 00:00:00	38000275	0	\N	\N	213631	0	180256009	4107731	
36782	3236	4078793	1982-12-24	1982-12-24 00:00:00	38000275	0	\N	\N	215073	0	180325003	4078793	
36861	3241	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	215484	0	180256009	4107731	
37163	3270	4043071	1981-08-31	1981-08-31 00:00:00	38000275	0	\N	\N	217357	0	228557008	4043071	
37282	3279	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	217866	0	180256009	4107731	
37471	3307	4275113	1983-10-01	1983-10-01 00:00:00	38000275	0	\N	\N	219622	0	65200003	4275113	
49577	4353	4043071	1976-09-29	1976-09-29 00:00:00	38000275	0	\N	\N	288729	0	228557008	4043071	
37778	3342	4057420	2009-04-22	2009-04-22 00:00:00	38000275	0	\N	\N	221663	0	18286008	4057420	
38088	3364	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	223111	0	180256009	4107731	
38199	3370	4107731	1991-12-01	1991-12-01 00:00:00	38000275	0	\N	\N	223501	0	180256009	4107731	
50319	4376	4195803	2010-09-19	2010-09-19 00:00:00	38000275	0	\N	\N	290735	0	312681000	4195803	
38677	3399	4170947	2000-04-09	2000-04-09 00:00:00	38000275	0	\N	\N	225520	0	274474001	4170947	
26894	2351	4125906	1963-02-27	1963-02-27 00:00:00	38000275	0	\N	\N	156558	0	288086009	4125906	
38942	3434	4163872	1965-08-12	1965-08-12 00:00:00	38000275	0	\N	\N	227683	0	399208008	4163872	
39203	3462	4301346	1985-06-21	1985-06-21 00:00:00	38000275	0	\N	\N	229697	0	387685009	4301346	
39331	3464	4107731	2010-08-13	2010-08-13 00:00:00	38000275	0	\N	\N	229893	0	180256009	4107731	
27575	2404	4243062	1968-08-21	1968-08-21 00:00:00	38000275	0	\N	\N	159758	0	60027007	4243062	
39697	3490	4125906	2017-03-17	2017-03-17 00:00:00	38000275	0	\N	\N	231524	0	288086009	4125906	
39855	3510	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	232936	0	180256009	4107731	
40147	3527	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	234113	0	180256009	4107731	
40319	3529	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	234417	0	180256009	4107731	
28599	2542	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	168110	0	180256009	4107731	
40704	3571	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	237336	0	180256009	4107731	
40836	3583	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	238255	0	180256009	4107731	
29046	2570	4195803	1946-09-23	1946-09-23 00:00:00	38000275	0	\N	\N	170196	0	312681000	4195803	
41167	3614	4151422	1959-11-25	1959-11-25 00:00:00	38000275	0	\N	\N	240141	0	269911007	4151422	
41423	3636	4170947	1981-12-24	1981-12-24 00:00:00	38000275	0	\N	\N	241832	0	274474001	4170947	
53531	4642	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	309371	0	180256009	4107731	
41872	3694	4243062	1971-08-29	1971-08-29 00:00:00	38000275	0	\N	\N	245560	0	60027007	4243062	
41958	3695	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	245667	0	180256009	4107731	
42133	3717	4107731	1991-09-28	1991-09-28 00:00:00	38000275	0	\N	\N	247025	0	180256009	4107731	
54276	4719	4125906	2013-12-24	2013-12-24 00:00:00	38000275	0	\N	\N	314299	0	288086009	4125906	
30645	2711	4107731	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	179627	0	180256009	4107731	
42648	3759	4107731	1992-11-01	1992-11-01 00:00:00	38000275	0	\N	\N	249971	0	180256009	4107731	
42922	3783	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	251339	0	180256009	4107731	
54996	4776	4078793	2018-06-03	2018-06-03 00:00:00	38000275	0	\N	\N	318040	0	180325003	4078793	
31308	2771	4078793	2003-06-13	2003-06-13 00:00:00	38000275	0	\N	\N	183425	0	180325003	4078793	
31589	2782	4078793	1996-04-24	1996-04-24 00:00:00	38000275	0	\N	\N	184378	0	180325003	4078793	
43726	3865	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	256664	0	180256009	4107731	
43934	3876	4107731	1992-10-05	1992-10-05 00:00:00	38000275	0	\N	\N	257413	0	180256009	4107731	
44099	3884	4043071	1989-12-09	1989-12-09 00:00:00	38000275	0	\N	\N	258141	0	228557008	4043071	
32199	2830	4107731	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	187794	0	180256009	4107731	
56417	4924	4107731	1993-01-13	1993-01-13 00:00:00	38000275	0	\N	\N	327218	0	180256009	4107731	
44682	3916	4295880	1997-09-24	1997-09-24 00:00:00	38000275	0	\N	\N	260314	0	76601001	4295880	
56717	4932	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	327879	0	180256009	4107731	
44930	3943	4252419	1973-03-14	1973-03-14 00:00:00	38000275	0	\N	\N	262137	0	74016001	4252419	
33159	2902	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	193297	0	180256009	4107731	
33405	2921	4035793	1994-07-12	1994-07-12 00:00:00	38000275	0	\N	\N	194701	0	15081005	4035793	
57587	4986	4057420	2018-08-26	2018-08-26 00:00:00	38000275	0	\N	\N	331707	0	18286008	4057420	
45675	4026	4107731	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	267776	0	180256009	4107731	
45946	4033	4043071	1981-04-08	1981-04-08 00:00:00	38000275	0	\N	\N	268356	0	228557008	4043071	
34207	2970	4107731	2001-03-29	2001-03-29 00:00:00	38000275	0	\N	\N	198361	0	180256009	4107731	
34342	2975	4107731	1990-06-03	1990-06-03 00:00:00	38000275	0	\N	\N	198610	0	180256009	4107731	
34517	2989	4198190	1987-06-16	1987-06-16 00:00:00	38000275	0	\N	\N	199561	0	80146002	4198190	
58545	5068	4078793	2012-12-15	2012-12-15 00:00:00	38000275	0	\N	\N	336976	0	180325003	4078793	
46810	4109	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	273139	0	180256009	4107731	
59053	5117	4107731	1992-06-01	1992-06-01 00:00:00	38000275	0	\N	\N	340039	0	180256009	4107731	
47143	4145	4107731	2008-02-16	2008-02-16 00:00:00	38000275	0	\N	\N	275455	0	180256009	4107731	
47494	4167	4191853	1995-03-29	1995-03-29 00:00:00	38000275	0	\N	\N	276898	0	395142003	4191853	
35714	3128	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	208217	0	180256009	4107731	
35817	3134	4078793	2009-02-26	2009-02-26 00:00:00	38000275	0	\N	\N	208598	0	180325003	4078793	
24030	2088	4035793	2013-03-12	2013-03-12 00:00:00	38000275	0	\N	\N	139244	0	15081005	4035793	
36222	3176	4107731	2003-07-13	2003-07-13 00:00:00	38000275	0	\N	\N	211178	0	180256009	4107731	
24466	2136	4107731	2003-08-08	2003-08-08 00:00:00	38000275	0	\N	\N	142247	0	180256009	4107731	
36584	3215	4107731	2003-03-01	2003-03-01 00:00:00	38000275	0	\N	\N	213633	0	180256009	4107731	
36783	3236	4057420	1986-01-10	1986-01-10 00:00:00	38000275	0	\N	\N	215080	0	18286008	4057420	
36862	3241	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	215533	0	180256009	4107731	
37164	3270	4043071	1984-05-21	1984-05-21 00:00:00	38000275	0	\N	\N	217329	0	228557008	4043071	
37283	3279	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	217940	0	180256009	4107731	
37472	3308	4336464	1996-11-18	1996-11-18 00:00:00	38000275	0	\N	\N	219656	0	232717009	4336464	
49578	4353	4043071	1979-09-19	1979-09-19 00:00:00	38000275	0	\N	\N	288803	0	228557008	4043071	
37779	3342	4078793	2013-05-15	2013-05-15 00:00:00	38000275	0	\N	\N	221665	0	180325003	4078793	
38089	3364	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	223060	0	180256009	4107731	
38200	3370	4107731	1991-02-10	1991-02-10 00:00:00	38000275	0	\N	\N	223518	0	180256009	4107731	
50320	4376	4035793	1991-09-10	1991-09-10 00:00:00	38000275	0	\N	\N	290805	0	15081005	4035793	
38678	3399	4047491	2000-04-09	2000-04-09 00:00:00	38000275	0	\N	\N	225520	0	1225002	4047491	
26895	2351	4024289	1964-03-07	1964-03-07 00:00:00	38000275	0	\N	\N	156505	0	19490002	4024289	
38943	3434	4125906	2009-04-23	2009-04-23 00:00:00	38000275	0	\N	\N	227685	0	288086009	4125906	
39204	3462	4151422	1994-09-26	1994-09-26 00:00:00	38000275	0	\N	\N	229733	0	269911007	4151422	
39332	3464	4107731	2010-02-05	2010-02-05 00:00:00	38000275	0	\N	\N	229908	0	180256009	4107731	
27576	2404	4170947	1968-08-21	1968-08-21 00:00:00	38000275	0	\N	\N	159758	0	274474001	4170947	
39698	3490	4195803	2005-11-11	2005-11-11 00:00:00	38000275	0	\N	\N	231570	0	312681000	4195803	
39856	3510	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	232917	0	180256009	4107731	
40148	3527	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	234056	0	180256009	4107731	
40320	3529	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	234362	0	180256009	4107731	
28600	2542	4243062	1980-03-02	1980-03-02 00:00:00	38000275	0	\N	\N	168091	0	60027007	4243062	
40705	3571	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	237331	0	180256009	4107731	
40837	3583	4107731	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	238238	0	180256009	4107731	
29047	2570	4125906	2009-06-08	2009-06-08 00:00:00	38000275	0	\N	\N	170199	0	288086009	4125906	
41168	3614	4037675	2009-06-11	2009-06-11 00:00:00	38000275	0	\N	\N	240143	0	162676008	4037675	
41424	3636	4047491	1981-12-24	1981-12-24 00:00:00	38000275	0	\N	\N	241832	0	1225002	4047491	
53532	4642	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	309472	0	180256009	4107731	
41873	3694	4170947	1971-08-29	1971-08-29 00:00:00	38000275	0	\N	\N	245560	0	274474001	4170947	
41959	3695	4107731	1994-04-04	1994-04-04 00:00:00	38000275	0	\N	\N	245652	0	180256009	4107731	
42134	3717	4107731	1992-04-04	1992-04-04 00:00:00	38000275	0	\N	\N	246972	0	180256009	4107731	
54277	4719	4107731	1993-03-28	1993-03-28 00:00:00	38000275	0	\N	\N	314284	0	180256009	4107731	
30646	2711	4107731	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	179760	0	180256009	4107731	
42649	3759	4107731	1991-10-20	1991-10-20 00:00:00	38000275	0	\N	\N	249914	0	180256009	4107731	
42923	3783	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	251351	0	180256009	4107731	
54997	4776	4078793	2018-09-16	2018-09-16 00:00:00	38000275	0	\N	\N	318055	0	180325003	4078793	
31309	2771	4202451	1993-02-19	1993-02-19 00:00:00	38000275	0	\N	\N	183476	0	433112001	4202451	
31590	2782	4078793	1997-04-30	1997-04-30 00:00:00	38000275	0	\N	\N	184394	0	180325003	4078793	
43727	3865	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	256673	0	180256009	4107731	
43935	3876	4107731	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	257480	0	180256009	4107731	
44100	3884	4107731	1991-02-25	1991-02-25 00:00:00	38000275	0	\N	\N	258066	0	180256009	4107731	
32200	2830	4107731	1992-06-01	1992-06-01 00:00:00	38000275	0	\N	\N	187798	0	180256009	4107731	
56418	4924	4107731	1991-01-30	1991-01-30 00:00:00	38000275	0	\N	\N	327163	0	180256009	4107731	
44683	3916	4062501	1980-10-10	1980-10-10 00:00:00	38000275	0	\N	\N	260340	0	171231001	4062501	
56718	4932	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	327811	0	180256009	4107731	
44931	3943	44783196	1973-03-21	1973-03-21 00:00:00	38000275	0	\N	\N	262206	0	699253003	44783196	
33160	2902	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	193358	0	180256009	4107731	
33406	2921	4035793	2009-10-06	2009-10-06 00:00:00	38000275	0	\N	\N	194705	0	15081005	4035793	
57588	4986	4125906	1965-03-05	1965-03-05 00:00:00	38000275	0	\N	\N	331615	0	288086009	4125906	
45676	4026	4107731	1992-02-23	1992-02-23 00:00:00	38000275	0	\N	\N	267740	0	180256009	4107731	
45947	4033	4043071	1980-11-12	1980-11-12 00:00:00	38000275	0	\N	\N	268345	0	228557008	4043071	
34208	2970	4107731	2002-09-26	2002-09-26 00:00:00	38000275	0	\N	\N	198385	0	180256009	4107731	
34343	2975	4107731	1992-08-30	1992-08-30 00:00:00	38000275	0	\N	\N	198592	0	180256009	4107731	
34518	2989	4151422	1993-11-10	1993-11-10 00:00:00	38000275	0	\N	\N	199576	0	269911007	4151422	
58546	5068	4078793	2010-12-04	2010-12-04 00:00:00	38000275	0	\N	\N	336975	0	180325003	4078793	
46811	4109	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	273206	0	180256009	4107731	
59054	5117	4107731	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	340034	0	180256009	4107731	
47144	4145	4107731	2008-01-05	2008-01-05 00:00:00	38000275	0	\N	\N	275505	0	180256009	4107731	
47495	4167	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	276940	0	180256009	4107731	
35715	3128	4295880	1996-03-12	1996-03-12 00:00:00	38000275	0	\N	\N	208101	0	76601001	4295880	
35818	3135	4151422	1963-09-05	1963-09-05 00:00:00	38000275	0	\N	\N	208680	0	269911007	4151422	
24031	2088	4035793	1982-09-21	1982-09-21 00:00:00	38000275	0	\N	\N	139212	0	15081005	4035793	
36223	3176	4107731	2003-03-30	2003-03-30 00:00:00	38000275	0	\N	\N	211089	0	180256009	4107731	
24467	2136	4107731	2004-10-01	2004-10-01 00:00:00	38000275	0	\N	\N	142269	0	180256009	4107731	
36585	3215	4191853	2006-04-29	2006-04-29 00:00:00	38000275	0	\N	\N	213597	0	395142003	4191853	
36784	3236	4078793	2016-09-16	2016-09-16 00:00:00	38000275	0	\N	\N	215107	0	180325003	4078793	
36863	3241	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	215567	0	180256009	4107731	
37165	3270	4043071	1981-11-09	1981-11-09 00:00:00	38000275	0	\N	\N	217303	0	228557008	4043071	
37284	3279	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	217845	0	180256009	4107731	
37473	3308	4216130	1996-11-18	1996-11-18 00:00:00	38000275	0	\N	\N	219656	0	415070008	4216130	
49579	4353	4043071	1976-12-01	1976-12-01 00:00:00	38000275	0	\N	\N	288821	0	228557008	4043071	
37780	3342	4078793	2018-06-13	2018-06-13 00:00:00	38000275	0	\N	\N	221603	0	180325003	4078793	
38090	3364	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	223086	0	180256009	4107731	
38201	3370	4125906	1977-06-14	1977-06-14 00:00:00	38000275	0	\N	\N	223392	0	288086009	4125906	
50321	4376	4078793	1991-09-10	1991-09-10 00:00:00	38000275	0	\N	\N	290805	0	180325003	4078793	
38679	3399	4107731	1999-07-06	1999-07-06 00:00:00	38000275	0	\N	\N	225523	0	180256009	4107731	
26896	2351	4170947	1964-03-07	1964-03-07 00:00:00	38000275	0	\N	\N	156505	0	274474001	4170947	
38944	3434	4170947	1965-08-12	1965-08-12 00:00:00	38000275	0	\N	\N	227683	0	274474001	4170947	
51052	4439	4330583	1991-12-13	1991-12-13 00:00:00	38000275	0	\N	\N	295104	0	22523008	4330583	
39333	3464	4107731	2011-11-18	2011-11-18 00:00:00	38000275	0	\N	\N	229974	0	180256009	4107731	
27577	2404	4125906	1998-08-10	1998-08-10 00:00:00	38000275	0	\N	\N	159763	0	288086009	4125906	
39699	3490	4062501	1947-09-21	1947-09-21 00:00:00	38000275	0	\N	\N	231487	0	171231001	4062501	
39857	3510	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	232879	0	180256009	4107731	
40149	3527	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	234010	0	180256009	4107731	
40321	3529	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	234422	0	180256009	4107731	
28601	2542	4170947	1980-03-02	1980-03-02 00:00:00	38000275	0	\N	\N	168091	0	274474001	4170947	
40706	3571	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	237414	0	180256009	4107731	
40838	3583	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	238264	0	180256009	4107731	
29049	2572	4125906	2011-10-17	2011-10-17 00:00:00	38000275	0	\N	\N	170369	0	288086009	4125906	
41169	3614	4187458	2009-06-11	2009-06-11 00:00:00	38000275	0	\N	\N	240143	0	415300000	4187458	
41425	3636	4163872	1997-10-13	1997-10-13 00:00:00	38000275	0	\N	\N	241866	0	399208008	4163872	
53533	4642	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	309361	0	180256009	4107731	
41874	3694	4043071	1965-11-10	1965-11-10 00:00:00	38000275	0	\N	\N	245495	0	228557008	4043071	
41960	3695	4107731	1994-08-29	1994-08-29 00:00:00	38000275	0	\N	\N	245650	0	180256009	4107731	
42135	3717	4107731	1991-04-13	1991-04-13 00:00:00	38000275	0	\N	\N	246960	0	180256009	4107731	
54278	4719	4107731	1990-08-05	1990-08-05 00:00:00	38000275	0	\N	\N	314237	0	180256009	4107731	
30647	2711	4107731	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	179689	0	180256009	4107731	
42650	3759	4107731	1990-06-24	1990-06-24 00:00:00	38000275	0	\N	\N	249981	0	180256009	4107731	
42924	3783	4151422	1974-06-22	1974-06-22 00:00:00	38000275	0	\N	\N	251430	0	269911007	4151422	
54998	4776	4078793	2011-04-24	2011-04-24 00:00:00	38000275	0	\N	\N	318053	0	180325003	4078793	
31310	2771	4078793	1982-02-12	1982-02-12 00:00:00	38000275	0	\N	\N	183522	0	180325003	4078793	
31591	2782	4057420	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	184416	0	18286008	4057420	
43728	3865	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	256650	0	180256009	4107731	
43936	3876	4107731	1991-02-25	1991-02-25 00:00:00	38000275	0	\N	\N	257511	0	180256009	4107731	
44101	3884	4107731	1991-04-08	1991-04-08 00:00:00	38000275	0	\N	\N	258067	0	180256009	4107731	
32201	2830	4107731	1992-12-07	1992-12-07 00:00:00	38000275	0	\N	\N	187733	0	180256009	4107731	
56419	4924	4191853	1990-12-19	1990-12-19 00:00:00	38000275	0	\N	\N	327151	0	395142003	4191853	
44684	3916	4107731	1994-12-07	1994-12-07 00:00:00	38000275	0	\N	\N	260283	0	180256009	4107731	
56719	4932	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	327915	0	180256009	4107731	
44932	3943	4170947	1986-02-11	1986-02-11 00:00:00	38000275	0	\N	\N	262138	0	274474001	4170947	
33161	2902	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	193384	0	180256009	4107731	
33407	2921	4035793	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	194757	0	15081005	4035793	
57589	4986	4078793	2010-06-20	2010-06-20 00:00:00	38000275	0	\N	\N	331663	0	180325003	4078793	
45677	4026	4107731	1992-06-28	1992-06-28 00:00:00	38000275	0	\N	\N	267743	0	180256009	4107731	
45948	4033	4043071	1981-11-04	1981-11-04 00:00:00	38000275	0	\N	\N	268349	0	228557008	4043071	
34209	2970	4107731	2001-11-15	2001-11-15 00:00:00	38000275	0	\N	\N	198316	0	180256009	4107731	
34344	2975	4107731	1992-02-23	1992-02-23 00:00:00	38000275	0	\N	\N	198669	0	180256009	4107731	
34519	2989	4151422	1986-11-16	1986-11-16 00:00:00	38000275	0	\N	\N	199545	0	269911007	4151422	
58547	5068	4202451	2009-07-11	2009-07-11 00:00:00	38000275	0	\N	\N	336974	0	433112001	4202451	
46812	4109	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	273071	0	180256009	4107731	
59055	5117	4107731	1991-11-25	1991-11-25 00:00:00	38000275	0	\N	\N	340063	0	180256009	4107731	
47145	4145	4107731	2008-04-19	2008-04-19 00:00:00	38000275	0	\N	\N	275541	0	180256009	4107731	
47496	4167	4107731	1993-11-10	1993-11-10 00:00:00	38000275	0	\N	\N	276962	0	180256009	4107731	
35716	3128	4062501	1976-07-30	1976-07-30 00:00:00	38000275	0	\N	\N	208195	0	171231001	4062501	
35819	3135	4125906	2001-07-16	2001-07-16 00:00:00	38000275	0	\N	\N	208695	0	288086009	4125906	
24032	2088	4125906	2002-10-24	2002-10-24 00:00:00	38000275	0	\N	\N	139184	0	288086009	4125906	
36224	3176	4191853	2001-12-23	2001-12-23 00:00:00	38000275	0	\N	\N	211108	0	395142003	4191853	
24468	2136	4107731	2004-05-07	2004-05-07 00:00:00	38000275	0	\N	\N	142250	0	180256009	4107731	
36586	3215	4107731	2005-03-26	2005-03-26 00:00:00	38000275	0	\N	\N	213618	0	180256009	4107731	
36785	3236	4195803	1988-07-26	1988-07-26 00:00:00	38000275	0	\N	\N	215029	0	312681000	4195803	
36864	3241	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	215523	0	180256009	4107731	
37166	3270	4043071	1986-05-26	1986-05-26 00:00:00	38000275	0	\N	\N	217294	0	228557008	4043071	
37285	3279	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	217838	0	180256009	4107731	
37474	3308	4125906	1952-09-09	1952-09-09 00:00:00	38000275	0	\N	\N	219654	0	288086009	4125906	
49580	4353	4043071	1978-06-07	1978-06-07 00:00:00	38000275	0	\N	\N	288799	0	228557008	4043071	
37781	3342	4057420	2019-06-19	2019-06-19 00:00:00	38000275	0	\N	\N	221577	0	18286008	4057420	
38091	3364	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	223059	0	180256009	4107731	
38202	3370	4107731	1991-03-03	1991-03-03 00:00:00	38000275	0	\N	\N	223457	0	180256009	4107731	
50322	4376	4195803	1989-05-05	1989-05-05 00:00:00	38000275	0	\N	\N	290733	0	312681000	4195803	
38680	3399	4107731	1997-07-01	1997-07-01 00:00:00	38000275	0	\N	\N	225458	0	180256009	4107731	
26897	2351	4047491	1966-03-27	1966-03-27 00:00:00	38000275	0	\N	\N	156506	0	1225002	4047491	
38945	3435	4170947	2019-05-22	2019-05-22 00:00:00	38000275	0	\N	\N	227831	0	274474001	4170947	
51053	4439	4125906	2002-03-01	2002-03-01 00:00:00	38000275	0	\N	\N	295082	0	288086009	4125906	
39334	3464	4024289	1997-04-15	1997-04-15 00:00:00	38000275	0	\N	\N	229947	0	19490002	4024289	
27578	2404	4202451	1997-07-13	1997-07-13 00:00:00	38000275	0	\N	\N	159736	0	433112001	4202451	
39705	3494	4035793	2016-11-17	2016-11-17 00:00:00	38000275	0	\N	\N	231738	0	15081005	4035793	
39858	3510	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	232942	0	180256009	4107731	
40150	3527	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	234106	0	180256009	4107731	
40322	3529	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	234423	0	180256009	4107731	
28602	2542	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	168170	0	180256009	4107731	
40707	3571	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	237430	0	180256009	4107731	
40839	3583	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	238185	0	180256009	4107731	
29050	2572	4293740	2011-10-17	2011-10-17 00:00:00	38000275	0	\N	\N	170369	0	384700001	4293740	
41170	3614	4326177	2009-06-11	2009-06-11 00:00:00	38000275	0	\N	\N	240143	0	430193006	4326177	
41426	3636	4043071	1986-04-10	1986-04-10 00:00:00	38000275	0	\N	\N	241802	0	228557008	4043071	
53534	4642	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	309360	0	180256009	4107731	
41875	3694	4125906	2006-07-15	2006-07-15 00:00:00	38000275	0	\N	\N	245526	0	288086009	4125906	
41961	3695	4107731	1995-07-10	1995-07-10 00:00:00	38000275	0	\N	\N	245621	0	180256009	4107731	
42136	3717	4107731	1993-04-17	1993-04-17 00:00:00	38000275	0	\N	\N	247046	0	180256009	4107731	
54279	4719	4107731	1991-03-03	1991-03-03 00:00:00	38000275	0	\N	\N	314257	0	180256009	4107731	
30648	2711	4107731	1992-06-01	1992-06-01 00:00:00	38000275	0	\N	\N	179661	0	180256009	4107731	
42651	3759	4107731	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	249884	0	180256009	4107731	
42925	3783	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	251447	0	180256009	4107731	
54999	4776	4078793	2014-05-11	2014-05-11 00:00:00	38000275	0	\N	\N	318030	0	180325003	4078793	
31311	2771	4047491	2013-09-28	2013-09-28 00:00:00	38000275	0	\N	\N	183478	0	1225002	4047491	
31592	2782	4057420	1989-07-12	1989-07-12 00:00:00	38000275	0	\N	\N	184375	0	18286008	4057420	
43729	3865	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	256623	0	180256009	4107731	
43937	3876	4107731	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	257508	0	180256009	4107731	
44102	3884	4043071	1987-04-04	1987-04-04 00:00:00	38000275	0	\N	\N	258045	0	228557008	4043071	
32202	2830	4107731	1991-09-02	1991-09-02 00:00:00	38000275	0	\N	\N	187795	0	180256009	4107731	
56420	4924	4107731	1993-06-09	1993-06-09 00:00:00	38000275	0	\N	\N	327194	0	180256009	4107731	
44685	3916	4191853	1995-04-12	1995-04-12 00:00:00	38000275	0	\N	\N	260286	0	395142003	4191853	
56720	4932	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	327864	0	180256009	4107731	
44933	3943	4163872	1986-02-11	1986-02-11 00:00:00	38000275	0	\N	\N	262138	0	399208008	4163872	
33162	2902	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	193383	0	180256009	4107731	
33408	2921	4035793	2017-11-21	2017-11-21 00:00:00	38000275	0	\N	\N	194752	0	15081005	4035793	
57590	4986	4057420	2003-05-11	2003-05-11 00:00:00	38000275	0	\N	\N	331668	0	18286008	4057420	
45678	4026	4107731	1991-09-08	1991-09-08 00:00:00	38000275	0	\N	\N	267777	0	180256009	4107731	
45949	4033	4043071	1980-09-11	1980-09-11 00:00:00	38000275	0	\N	\N	268294	0	228557008	4043071	
34210	2970	4107731	2001-12-27	2001-12-27 00:00:00	38000275	0	\N	\N	198364	0	180256009	4107731	
34345	2975	4107731	1990-10-07	1990-10-07 00:00:00	38000275	0	\N	\N	198664	0	180256009	4107731	
34520	2989	4170947	1998-10-12	1998-10-12 00:00:00	38000275	0	\N	\N	199589	0	274474001	4170947	
58548	5068	4057420	2011-12-10	2011-12-10 00:00:00	38000275	0	\N	\N	336940	0	18286008	4057420	
46813	4109	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	273190	0	180256009	4107731	
59056	5117	4107731	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	340131	0	180256009	4107731	
47146	4145	4107731	2009-09-26	2009-09-26 00:00:00	38000275	0	\N	\N	275462	0	180256009	4107731	
47497	4167	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	276892	0	180256009	4107731	
35717	3128	4295880	1996-06-11	1996-06-11 00:00:00	38000275	0	\N	\N	208087	0	76601001	4295880	
35828	3137	4202451	1987-11-14	1987-11-14 00:00:00	38000275	0	\N	\N	208867	0	433112001	4202451	
24033	2088	4035793	1992-08-11	1992-08-11 00:00:00	38000275	0	\N	\N	139237	0	15081005	4035793	
36225	3176	4107731	2002-06-30	2002-06-30 00:00:00	38000275	0	\N	\N	211086	0	180256009	4107731	
24469	2136	4107731	2002-11-29	2002-11-29 00:00:00	38000275	0	\N	\N	142205	0	180256009	4107731	
36587	3215	4107731	2005-10-01	2005-10-01 00:00:00	38000275	0	\N	\N	213619	0	180256009	4107731	
36786	3236	4170947	1988-07-26	1988-07-26 00:00:00	38000275	0	\N	\N	215029	0	274474001	4170947	
36865	3241	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	215474	0	180256009	4107731	
37167	3270	4043071	1986-08-25	1986-08-25 00:00:00	38000275	0	\N	\N	217278	0	228557008	4043071	
37286	3279	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	217839	0	180256009	4107731	
37475	3308	4330583	1992-02-06	1992-02-06 00:00:00	38000275	0	\N	\N	219659	0	22523008	4330583	
49581	4353	4043071	1979-10-24	1979-10-24 00:00:00	38000275	0	\N	\N	288804	0	228557008	4043071	
37782	3342	4125906	1968-07-14	1968-07-14 00:00:00	38000275	0	\N	\N	221566	0	288086009	4125906	
38092	3364	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	223143	0	180256009	4107731	
38203	3370	4107731	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	223525	0	180256009	4107731	
50323	4376	4170947	1989-05-05	1989-05-05 00:00:00	38000275	0	\N	\N	290733	0	274474001	4170947	
38681	3399	4107731	1998-03-30	1998-03-30 00:00:00	38000275	0	\N	\N	225461	0	180256009	4107731	
26898	2351	4170947	1966-03-27	1966-03-27 00:00:00	38000275	0	\N	\N	156506	0	274474001	4170947	
38946	3435	4047491	2019-05-22	2019-05-22 00:00:00	38000275	0	\N	\N	227831	0	1225002	4047491	
51124	4442	4151422	1994-03-10	1994-03-10 00:00:00	38000275	0	\N	\N	295295	0	269911007	4151422	
39335	3464	4170947	1997-04-15	1997-04-15 00:00:00	38000275	0	\N	\N	229947	0	274474001	4170947	
27579	2404	4125906	1980-06-24	1980-06-24 00:00:00	38000275	0	\N	\N	159761	0	288086009	4125906	
39706	3494	4125906	1984-01-27	1984-01-27 00:00:00	38000275	0	\N	\N	231766	0	288086009	4125906	
39859	3510	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	232828	0	180256009	4107731	
40151	3527	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	234137	0	180256009	4107731	
40323	3529	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	234400	0	180256009	4107731	
28603	2542	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	168208	0	180256009	4107731	
40708	3571	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	237346	0	180256009	4107731	
40840	3583	4170947	2018-12-23	2018-12-23 00:00:00	38000275	0	\N	\N	238208	0	274474001	4170947	
29051	2572	4125906	1971-05-15	1971-05-15 00:00:00	38000275	0	\N	\N	170366	0	288086009	4125906	
41171	3614	4163872	1992-07-05	1992-07-05 00:00:00	38000275	0	\N	\N	240137	0	399208008	4163872	
41427	3636	4043071	1985-11-21	1985-11-21 00:00:00	38000275	0	\N	\N	241791	0	228557008	4043071	
53535	4642	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	309479	0	180256009	4107731	
41876	3694	4043071	1965-06-16	1965-06-16 00:00:00	38000275	0	\N	\N	245476	0	228557008	4043071	
41962	3695	4107731	1995-04-17	1995-04-17 00:00:00	38000275	0	\N	\N	245619	0	180256009	4107731	
42137	3717	4107731	1990-02-17	1990-02-17 00:00:00	38000275	0	\N	\N	247018	0	180256009	4107731	
54280	4719	4107731	1990-10-28	1990-10-28 00:00:00	38000275	0	\N	\N	314239	0	180256009	4107731	
30649	2711	4191853	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	179667	0	395142003	4191853	
42652	3759	4107731	1991-09-29	1991-09-29 00:00:00	38000275	0	\N	\N	249960	0	180256009	4107731	
42926	3783	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	251434	0	180256009	4107731	
55000	4776	4078793	2013-05-05	2013-05-05 00:00:00	38000275	0	\N	\N	318054	0	180325003	4078793	
31312	2771	4170947	2013-09-28	2013-09-28 00:00:00	38000275	0	\N	\N	183478	0	274474001	4170947	
31593	2782	4202451	2002-03-06	2002-03-06 00:00:00	38000275	0	\N	\N	184443	0	433112001	4202451	
43730	3865	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	256570	0	180256009	4107731	
43938	3876	4107731	1992-10-26	1992-10-26 00:00:00	38000275	0	\N	\N	257457	0	180256009	4107731	
44103	3884	4043071	1987-08-08	1987-08-08 00:00:00	38000275	0	\N	\N	258046	0	228557008	4043071	
32203	2830	4107731	1991-03-18	1991-03-18 00:00:00	38000275	0	\N	\N	187725	0	180256009	4107731	
56421	4924	4107731	1993-02-03	1993-02-03 00:00:00	38000275	0	\N	\N	327244	0	180256009	4107731	
44686	3916	4107731	1992-06-17	1992-06-17 00:00:00	38000275	0	\N	\N	260366	0	180256009	4107731	
56721	4932	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	327851	0	180256009	4107731	
44934	3943	4151422	1985-03-01	1985-03-01 00:00:00	38000275	0	\N	\N	262150	0	269911007	4151422	
33163	2902	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	193267	0	180256009	4107731	
33409	2921	4035793	1999-08-10	1999-08-10 00:00:00	38000275	0	\N	\N	194742	0	15081005	4035793	
57591	4986	4078793	2011-06-26	2011-06-26 00:00:00	38000275	0	\N	\N	331672	0	180325003	4078793	
45679	4026	4107731	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	267778	0	180256009	4107731	
45950	4033	4043071	1980-12-10	1980-12-10 00:00:00	38000275	0	\N	\N	268304	0	228557008	4043071	
34211	2970	4107731	1999-09-30	1999-09-30 00:00:00	38000275	0	\N	\N	198368	0	180256009	4107731	
34346	2975	4197460	1975-05-30	1975-05-30 00:00:00	38000275	0	\N	\N	198628	0	313191000	4197460	
34521	2989	4163872	1998-10-12	1998-10-12 00:00:00	38000275	0	\N	\N	199589	0	399208008	4163872	
58549	5068	4078793	2018-01-13	2018-01-13 00:00:00	38000275	0	\N	\N	336995	0	180325003	4078793	
46814	4109	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	273105	0	180256009	4107731	
59057	5117	4107731	1991-11-04	1991-11-04 00:00:00	38000275	0	\N	\N	340076	0	180256009	4107731	
47147	4145	4107731	2009-02-07	2009-02-07 00:00:00	38000275	0	\N	\N	275460	0	180256009	4107731	
47498	4167	4107731	1994-09-21	1994-09-21 00:00:00	38000275	0	\N	\N	276985	0	180256009	4107731	
47499	4167	4107731	1993-08-18	1993-08-18 00:00:00	38000275	0	\N	\N	277010	0	180256009	4107731	
35829	3137	4170947	1975-04-13	1975-04-13 00:00:00	38000275	0	\N	\N	208834	0	274474001	4170947	
24034	2088	4058899	1969-03-02	1969-03-02 00:00:00	38000275	0	\N	\N	139180	0	168594001	4058899	
36226	3176	4107731	2004-09-26	2004-09-26 00:00:00	38000275	0	\N	\N	211095	0	180256009	4107731	
24470	2136	4107731	2001-12-28	2001-12-28 00:00:00	38000275	0	\N	\N	142302	0	180256009	4107731	
36588	3215	4107731	2002-11-16	2002-11-16 00:00:00	38000275	0	\N	\N	213671	0	180256009	4107731	
36787	3236	4024289	1988-07-26	1988-07-26 00:00:00	38000275	0	\N	\N	215029	0	19490002	4024289	
36866	3241	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	215574	0	180256009	4107731	
37168	3270	4043071	1984-02-20	1984-02-20 00:00:00	38000275	0	\N	\N	217364	0	228557008	4043071	
37287	3279	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	217958	0	180256009	4107731	
37476	3308	4151422	1979-11-17	1979-11-17 00:00:00	38000275	0	\N	\N	219643	0	269911007	4151422	
49582	4353	4043071	1978-04-05	1978-04-05 00:00:00	38000275	0	\N	\N	288740	0	228557008	4043071	
37783	3342	4078793	2012-05-09	2012-05-09 00:00:00	38000275	0	\N	\N	221616	0	180325003	4078793	
38093	3364	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	223057	0	180256009	4107731	
38204	3370	4107731	1991-06-16	1991-06-16 00:00:00	38000275	0	\N	\N	223418	0	180256009	4107731	
50324	4376	4024289	1989-05-05	1989-05-05 00:00:00	38000275	0	\N	\N	290733	0	19490002	4024289	
38682	3399	4107731	1997-01-13	1997-01-13 00:00:00	38000275	0	\N	\N	225509	0	180256009	4107731	
26899	2351	4170947	1958-02-23	1958-02-23 00:00:00	38000275	0	\N	\N	156557	0	274474001	4170947	
38947	3435	4047491	2009-04-23	2009-04-23 00:00:00	38000275	0	\N	\N	227834	0	1225002	4047491	
51125	4442	4058899	1991-09-12	1991-09-12 00:00:00	38000275	0	\N	\N	295333	0	168594001	4058899	
39336	3464	4107731	2010-09-24	2010-09-24 00:00:00	38000275	0	\N	\N	229894	0	180256009	4107731	
27580	2406	4202451	1993-09-23	1993-09-23 00:00:00	38000275	0	\N	\N	159858	0	433112001	4202451	
39707	3494	4035793	2013-10-31	2013-10-31 00:00:00	38000275	0	\N	\N	231765	0	15081005	4035793	
39860	3510	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	232927	0	180256009	4107731	
40152	3527	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	234006	0	180256009	4107731	
40324	3529	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	234379	0	180256009	4107731	
28604	2542	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	168077	0	180256009	4107731	
40709	3571	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	237329	0	180256009	4107731	
40841	3583	4163872	2018-12-23	2018-12-23 00:00:00	38000275	0	\N	\N	238208	0	399208008	4163872	
29052	2572	4293740	1971-05-15	1971-05-15 00:00:00	38000275	0	\N	\N	170366	0	384700001	4293740	
41172	3614	4024289	1951-05-17	1951-05-17 00:00:00	38000275	0	\N	\N	240097	0	19490002	4024289	
41428	3636	4043071	1986-03-13	1986-03-13 00:00:00	38000275	0	\N	\N	241806	0	228557008	4043071	
53536	4642	4107731	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	309473	0	180256009	4107731	
41877	3694	4043071	1966-01-12	1966-01-12 00:00:00	38000275	0	\N	\N	245538	0	228557008	4043071	
41963	3695	4107731	1993-11-29	1993-11-29 00:00:00	38000275	0	\N	\N	245647	0	180256009	4107731	
42138	3717	4107731	1992-02-01	1992-02-01 00:00:00	38000275	0	\N	\N	246985	0	180256009	4107731	
54281	4719	4107731	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	314279	0	180256009	4107731	
30650	2711	4107731	1990-05-07	1990-05-07 00:00:00	38000275	0	\N	\N	179642	0	180256009	4107731	
42653	3759	4107731	1992-11-22	1992-11-22 00:00:00	38000275	0	\N	\N	249920	0	180256009	4107731	
42927	3783	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	251362	0	180256009	4107731	
55001	4776	4078793	2012-04-29	2012-04-29 00:00:00	38000275	0	\N	\N	318029	0	180325003	4078793	
31313	2771	4195803	2013-09-28	2013-09-28 00:00:00	38000275	0	\N	\N	183478	0	312681000	4195803	
31594	2782	4057420	1999-03-17	1999-03-17 00:00:00	38000275	0	\N	\N	184456	0	18286008	4057420	
43731	3865	4047491	1957-04-24	1957-04-24 00:00:00	38000275	0	\N	\N	256554	0	1225002	4047491	
43939	3876	4107731	1991-03-18	1991-03-18 00:00:00	38000275	0	\N	\N	257499	0	180256009	4107731	
44104	3884	4043071	1986-08-02	1986-08-02 00:00:00	38000275	0	\N	\N	258112	0	228557008	4043071	
32204	2830	4197460	1988-12-02	1988-12-02 00:00:00	38000275	0	\N	\N	187723	0	313191000	4197460	
56422	4924	4107731	1992-08-19	1992-08-19 00:00:00	38000275	0	\N	\N	327159	0	180256009	4107731	
44687	3916	4107731	1992-01-01	1992-01-01 00:00:00	38000275	0	\N	\N	260268	0	180256009	4107731	
56722	4932	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	327825	0	180256009	4107731	
44935	3943	4195803	2018-07-23	2018-07-23 00:00:00	38000275	0	\N	\N	262139	0	312681000	4195803	
33164	2902	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	193373	0	180256009	4107731	
33410	2921	4035793	2015-11-10	2015-11-10 00:00:00	38000275	0	\N	\N	194751	0	15081005	4035793	
57592	4986	4057420	2005-05-22	2005-05-22 00:00:00	38000275	0	\N	\N	331669	0	18286008	4057420	
45680	4026	4107731	1991-12-22	1991-12-22 00:00:00	38000275	0	\N	\N	267769	0	180256009	4107731	
45951	4033	4043071	1980-03-19	1980-03-19 00:00:00	38000275	0	\N	\N	268317	0	228557008	4043071	
34212	2970	4107731	2000-04-06	2000-04-06 00:00:00	38000275	0	\N	\N	198309	0	180256009	4107731	
34347	2975	4107731	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	198617	0	180256009	4107731	
34522	2989	44783196	1960-02-04	1960-02-04 00:00:00	38000275	0	\N	\N	199546	0	699253003	44783196	
58550	5068	4125906	1966-06-16	1966-06-16 00:00:00	38000275	0	\N	\N	336990	0	288086009	4125906	
46815	4109	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	273108	0	180256009	4107731	
59058	5117	4107731	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	340023	0	180256009	4107731	
47148	4145	4107731	2009-04-11	2009-04-11 00:00:00	38000275	0	\N	\N	275509	0	180256009	4107731	
59291	5123	4170947	1994-09-11	1994-09-11 00:00:00	38000275	0	\N	\N	340686	0	274474001	4170947	
47500	4167	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	276890	0	180256009	4107731	
35830	3137	4163872	1975-04-13	1975-04-13 00:00:00	38000275	0	\N	\N	208834	0	399208008	4163872	
24035	2088	4195803	1969-03-02	1969-03-02 00:00:00	38000275	0	\N	\N	139180	0	312681000	4195803	
36227	3176	4107731	2002-05-19	2002-05-19 00:00:00	38000275	0	\N	\N	211203	0	180256009	4107731	
24471	2136	4107731	2001-11-16	2001-11-16 00:00:00	38000275	0	\N	\N	142301	0	180256009	4107731	
36589	3215	4107731	2005-11-12	2005-11-12 00:00:00	38000275	0	\N	\N	213620	0	180256009	4107731	
36788	3236	4078793	2012-08-24	2012-08-24 00:00:00	38000275	0	\N	\N	215103	0	180325003	4078793	
36867	3241	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	215569	0	180256009	4107731	
37169	3270	4043071	1982-09-13	1982-09-13 00:00:00	38000275	0	\N	\N	217264	0	228557008	4043071	
37288	3279	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	217837	0	180256009	4107731	
37477	3308	4163872	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	219642	0	399208008	4163872	
49583	4353	4043071	1978-09-06	1978-09-06 00:00:00	38000275	0	\N	\N	288742	0	228557008	4043071	
37784	3342	4145310	2011-10-11	2011-10-11 00:00:00	38000275	0	\N	\N	221569	0	268425006	4145310	
38094	3364	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	223145	0	180256009	4107731	
38205	3370	4107731	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	223397	0	180256009	4107731	
50325	4376	4078793	1996-10-08	1996-10-08 00:00:00	38000275	0	\N	\N	290802	0	180325003	4078793	
38683	3399	4107731	1997-11-03	1997-11-03 00:00:00	38000275	0	\N	\N	225430	0	180256009	4107731	
26900	2351	4024289	1958-02-23	1958-02-23 00:00:00	38000275	0	\N	\N	156557	0	19490002	4024289	
38948	3435	4170947	2009-04-23	2009-04-23 00:00:00	38000275	0	\N	\N	227834	0	274474001	4170947	
39337	3464	4107731	2012-04-13	2012-04-13 00:00:00	38000275	0	\N	\N	229941	0	180256009	4107731	
27581	2406	4151422	1949-01-08	1949-01-08 00:00:00	38000275	0	\N	\N	159829	0	269911007	4151422	
39708	3494	4035793	2015-11-12	2015-11-12 00:00:00	38000275	0	\N	\N	231792	0	15081005	4035793	
39861	3510	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	232918	0	180256009	4107731	
40153	3527	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	234058	0	180256009	4107731	
40325	3529	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	234377	0	180256009	4107731	
28605	2542	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	168168	0	180256009	4107731	
40710	3571	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	237403	0	180256009	4107731	
40842	3583	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	238236	0	180256009	4107731	
29054	2574	4151422	1978-12-31	1978-12-31 00:00:00	38000275	0	\N	\N	170485	0	269911007	4151422	
41173	3614	4170947	1951-05-17	1951-05-17 00:00:00	38000275	0	\N	\N	240097	0	274474001	4170947	
41429	3636	4043071	1986-01-16	1986-01-16 00:00:00	38000275	0	\N	\N	241801	0	228557008	4043071	
53537	4642	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	309419	0	180256009	4107731	
41878	3694	4043071	1965-09-15	1965-09-15 00:00:00	38000275	0	\N	\N	245537	0	228557008	4043071	
41964	3695	4107731	1995-02-13	1995-02-13 00:00:00	38000275	0	\N	\N	245656	0	180256009	4107731	
42139	3717	4107731	1990-08-04	1990-08-04 00:00:00	38000275	0	\N	\N	247080	0	180256009	4107731	
54282	4719	4107731	1990-10-07	1990-10-07 00:00:00	38000275	0	\N	\N	314293	0	180256009	4107731	
30651	2711	4107731	1990-06-18	1990-06-18 00:00:00	38000275	0	\N	\N	179758	0	180256009	4107731	
42654	3759	4107731	1990-08-05	1990-08-05 00:00:00	38000275	0	\N	\N	249885	0	180256009	4107731	
42928	3783	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	251374	0	180256009	4107731	
55002	4776	4078793	2015-05-17	2015-05-17 00:00:00	38000275	0	\N	\N	318022	0	180325003	4078793	
31314	2771	4078793	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	183481	0	180325003	4078793	
31595	2782	4078793	1990-07-18	1990-07-18 00:00:00	38000275	0	\N	\N	184393	0	180325003	4078793	
43732	3865	4170947	1957-04-24	1957-04-24 00:00:00	38000275	0	\N	\N	256554	0	274474001	4170947	
43940	3876	4107731	1991-07-22	1991-07-22 00:00:00	38000275	0	\N	\N	257478	0	180256009	4107731	
44105	3884	4043071	1986-01-11	1986-01-11 00:00:00	38000275	0	\N	\N	258027	0	228557008	4043071	
32205	2830	4107731	1993-03-01	1993-03-01 00:00:00	38000275	0	\N	\N	187687	0	180256009	4107731	
56423	4924	4107731	1991-11-20	1991-11-20 00:00:00	38000275	0	\N	\N	327156	0	180256009	4107731	
44688	3916	4107731	1993-06-30	1993-06-30 00:00:00	38000275	0	\N	\N	260303	0	180256009	4107731	
56723	4932	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	327876	0	180256009	4107731	
44936	3943	4170947	2018-07-23	2018-07-23 00:00:00	38000275	0	\N	\N	262139	0	274474001	4170947	
33165	2902	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	193374	0	180256009	4107731	
33411	2921	4035793	2008-09-30	2008-09-30 00:00:00	38000275	0	\N	\N	194743	0	15081005	4035793	
57593	4986	4078793	2007-06-03	2007-06-03 00:00:00	38000275	0	\N	\N	331670	0	180325003	4078793	
45681	4026	4191853	1993-07-11	1993-07-11 00:00:00	38000275	0	\N	\N	267711	0	395142003	4191853	
45952	4033	4043071	1979-01-10	1979-01-10 00:00:00	38000275	0	\N	\N	268310	0	228557008	4043071	
34213	2970	4107731	2001-10-04	2001-10-04 00:00:00	38000275	0	\N	\N	198315	0	180256009	4107731	
34348	2975	4191853	1990-01-07	1990-01-07 00:00:00	38000275	0	\N	\N	198625	0	395142003	4191853	
34523	2989	4125906	2010-07-16	2010-07-16 00:00:00	38000275	0	\N	\N	199591	0	288086009	4125906	
58551	5068	4151422	1975-07-19	1975-07-19 00:00:00	38000275	0	\N	\N	336948	0	269911007	4151422	
46816	4109	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	273209	0	180256009	4107731	
59059	5117	4107731	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	340038	0	180256009	4107731	
47149	4145	4107731	2007-09-22	2007-09-22 00:00:00	38000275	0	\N	\N	275518	0	180256009	4107731	
59292	5123	4163872	1994-09-11	1994-09-11 00:00:00	38000275	0	\N	\N	340686	0	399208008	4163872	
47501	4167	4107731	1995-02-15	1995-02-15 00:00:00	38000275	0	\N	\N	276977	0	180256009	4107731	
35831	3137	4195803	1975-04-13	1975-04-13 00:00:00	38000275	0	\N	\N	208834	0	312681000	4195803	
24036	2088	4035793	1981-09-15	1981-09-15 00:00:00	38000275	0	\N	\N	139312	0	15081005	4035793	
36228	3176	4107731	2003-06-01	2003-06-01 00:00:00	38000275	0	\N	\N	211134	0	180256009	4107731	
24472	2136	4107731	2004-01-23	2004-01-23 00:00:00	38000275	0	\N	\N	142289	0	180256009	4107731	
36590	3215	4107731	2005-07-30	2005-07-30 00:00:00	38000275	0	\N	\N	213594	0	180256009	4107731	
36789	3236	4151422	1987-03-27	1987-03-27 00:00:00	38000275	0	\N	\N	215060	0	269911007	4151422	
36868	3241	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	215483	0	180256009	4107731	
37170	3270	4043071	1982-04-12	1982-04-12 00:00:00	38000275	0	\N	\N	217262	0	228557008	4043071	
37289	3279	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	217864	0	180256009	4107731	
37478	3311	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	219883	0	180256009	4107731	
49584	4353	4043071	1977-07-06	1977-07-06 00:00:00	38000275	0	\N	\N	288731	0	228557008	4043071	
37785	3343	4043071	1988-04-05	1988-04-05 00:00:00	38000275	0	\N	\N	221781	0	228557008	4043071	
38095	3364	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	223034	0	180256009	4107731	
38206	3370	4107731	1990-08-26	1990-08-26 00:00:00	38000275	0	\N	\N	223456	0	180256009	4107731	
50326	4376	4035793	1996-10-08	1996-10-08 00:00:00	38000275	0	\N	\N	290802	0	15081005	4035793	
38684	3399	4107731	1997-06-10	1997-06-10 00:00:00	38000275	0	\N	\N	225482	0	180256009	4107731	
26901	2352	4107731	1992-08-24	1992-08-24 00:00:00	38000275	0	\N	\N	156670	0	180256009	4107731	
38949	3435	4125906	2014-04-27	2014-04-27 00:00:00	38000275	0	\N	\N	227835	0	288086009	4125906	
39338	3464	4107731	2010-12-17	2010-12-17 00:00:00	38000275	0	\N	\N	229912	0	180256009	4107731	
27582	2406	4057420	1961-05-11	1961-05-11 00:00:00	38000275	0	\N	\N	159828	0	18286008	4057420	
39709	3494	4035793	2012-08-16	2012-08-16 00:00:00	38000275	0	\N	\N	231754	0	15081005	4035793	
39862	3510	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	232915	0	180256009	4107731	
40154	3527	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	234012	0	180256009	4107731	
40326	3529	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	234370	0	180256009	4107731	
28606	2542	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	168169	0	180256009	4107731	
40711	3571	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	237415	0	180256009	4107731	
40843	3583	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	238189	0	180256009	4107731	
29055	2574	4293740	1976-02-19	1976-02-19 00:00:00	38000275	0	\N	\N	170494	0	384700001	4293740	
41174	3615	4151422	1977-06-15	1977-06-15 00:00:00	38000275	0	\N	\N	240214	0	269911007	4151422	
41430	3636	4186930	1991-07-12	1991-07-12 00:00:00	38000275	0	\N	\N	241786	0	46706006	4186930	
53538	4642	4197460	1953-08-22	1953-08-22 00:00:00	38000275	0	\N	\N	309390	0	313191000	4197460	
41879	3694	4181917	1969-04-06	1969-04-06 00:00:00	38000275	0	\N	\N	245559	0	54550000	4181917	
41965	3695	4107731	1994-08-08	1994-08-08 00:00:00	38000275	0	\N	\N	245627	0	180256009	4107731	
42140	3717	4107731	1990-10-06	1990-10-06 00:00:00	38000275	0	\N	\N	247000	0	180256009	4107731	
54283	4719	4107731	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	314266	0	180256009	4107731	
30652	2711	4107731	1992-03-09	1992-03-09 00:00:00	38000275	0	\N	\N	179766	0	180256009	4107731	
42655	3759	4107731	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	249990	0	180256009	4107731	
42929	3783	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	251441	0	180256009	4107731	
55003	4777	4163872	1990-10-18	1990-10-18 00:00:00	38000275	0	\N	\N	318085	0	399208008	4163872	
31315	2771	4078793	2007-07-06	2007-07-06 00:00:00	38000275	0	\N	\N	183531	0	180325003	4078793	
31596	2782	4057420	1997-12-10	1997-12-10 00:00:00	38000275	0	\N	\N	\N	0	18286008	4057420	
43733	3865	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	256648	0	180256009	4107731	
43941	3876	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	257459	0	180256009	4107731	
44106	3884	4107731	1993-01-18	1993-01-18 00:00:00	38000275	0	\N	\N	258080	0	180256009	4107731	
32206	2830	4107731	1990-06-18	1990-06-18 00:00:00	38000275	0	\N	\N	187763	0	180256009	4107731	
56424	4924	4191853	1994-06-22	1994-06-22 00:00:00	38000275	0	\N	\N	327174	0	395142003	4191853	
44689	3916	4295880	1998-03-25	1998-03-25 00:00:00	38000275	0	\N	\N	260397	0	76601001	4295880	
56724	4933	44783196	1998-11-04	1998-11-04 00:00:00	38000275	0	\N	\N	327926	0	699253003	44783196	
44937	3943	4243062	2018-07-23	2018-07-23 00:00:00	38000275	0	\N	\N	262139	0	60027007	4243062	
33166	2902	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	193370	0	180256009	4107731	
33412	2921	4145310	1989-05-07	1989-05-07 00:00:00	38000275	0	\N	\N	194716	0	268425006	4145310	
57594	4986	4078793	2012-07-01	2012-07-01 00:00:00	38000275	0	\N	\N	331664	0	180325003	4078793	
45682	4026	4107731	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	267683	0	180256009	4107731	
45953	4033	4043071	1981-07-30	1981-07-30 00:00:00	38000275	0	\N	\N	268305	0	228557008	4043071	
34214	2970	4107731	2002-08-15	2002-08-15 00:00:00	38000275	0	\N	\N	198384	0	180256009	4107731	
34349	2975	4107731	1993-05-09	1993-05-09 00:00:00	38000275	0	\N	\N	198578	0	180256009	4107731	
34526	2991	4125906	1989-09-12	1989-09-12 00:00:00	38000275	0	\N	\N	199629	0	288086009	4125906	
58552	5068	4151422	1962-04-09	1962-04-09 00:00:00	38000275	0	\N	\N	336969	0	269911007	4151422	
46817	4109	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	273214	0	180256009	4107731	
59060	5117	4107731	1992-03-09	1992-03-09 00:00:00	38000275	0	\N	\N	340037	0	180256009	4107731	
47150	4145	4107731	2009-09-05	2009-09-05 00:00:00	38000275	0	\N	\N	275525	0	180256009	4107731	
59293	5123	4058899	2004-04-21	2004-04-21 00:00:00	38000275	0	\N	\N	340687	0	168594001	4058899	
47502	4167	4186930	1997-09-17	1997-09-17 00:00:00	38000275	0	\N	\N	276929	0	46706006	4186930	
35837	3141	4198190	1978-02-06	1978-02-06 00:00:00	38000275	0	\N	\N	208992	0	80146002	4198190	
24037	2088	4035793	1984-06-26	1984-06-26 00:00:00	38000275	0	\N	\N	139285	0	15081005	4035793	
36229	3176	4107731	2003-12-28	2003-12-28 00:00:00	38000275	0	\N	\N	211092	0	180256009	4107731	
24473	2136	4107731	2004-04-16	2004-04-16 00:00:00	38000275	0	\N	\N	142210	0	180256009	4107731	
36591	3215	4107731	2005-08-20	2005-08-20 00:00:00	38000275	0	\N	\N	213601	0	180256009	4107731	
36790	3236	4195803	2014-09-05	2014-09-05 00:00:00	38000275	0	\N	\N	215106	0	312681000	4195803	
36869	3241	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	215570	0	180256009	4107731	
37171	3270	4043071	1986-11-24	1986-11-24 00:00:00	38000275	0	\N	\N	217353	0	228557008	4043071	
37290	3279	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	217955	0	180256009	4107731	
37479	3311	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	219766	0	180256009	4107731	
49585	4353	4043071	1981-04-22	1981-04-22 00:00:00	38000275	0	\N	\N	288814	0	228557008	4043071	
37786	3343	4107731	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	221868	0	180256009	4107731	
38096	3364	4191853	1977-10-02	1977-10-02 00:00:00	38000275	0	\N	\N	223078	0	395142003	4191853	
38207	3370	4107731	1990-06-03	1990-06-03 00:00:00	38000275	0	\N	\N	223454	0	180256009	4107731	
50327	4376	4057420	2001-11-06	2001-11-06 00:00:00	38000275	0	\N	\N	290836	0	18286008	4057420	
38685	3399	4107731	1998-06-23	1998-06-23 00:00:00	38000275	0	\N	\N	225432	0	180256009	4107731	
26902	2352	4107731	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	156587	0	180256009	4107731	
38950	3435	4243062	2018-04-27	2018-04-27 00:00:00	38000275	0	\N	\N	227830	0	60027007	4243062	
39339	3464	4107731	2011-06-24	2011-06-24 00:00:00	38000275	0	\N	\N	229897	0	180256009	4107731	
27583	2406	40492359	1961-05-11	1961-05-11 00:00:00	38000275	0	\N	\N	159828	0	447365002	40492359	
39710	3494	4035793	2018-11-29	2018-11-29 00:00:00	38000275	0	\N	\N	231739	0	15081005	4035793	
39863	3510	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	232827	0	180256009	4107731	
40155	3527	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	234111	0	180256009	4107731	
40327	3529	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	234398	0	180256009	4107731	
28607	2542	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	168173	0	180256009	4107731	
40712	3571	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	237335	0	180256009	4107731	
40844	3583	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	238268	0	180256009	4107731	
29056	2574	4125906	1976-02-19	1976-02-19 00:00:00	38000275	0	\N	\N	170494	0	288086009	4125906	
41175	3615	4058899	1962-05-30	1962-05-30 00:00:00	38000275	0	\N	\N	240217	0	168594001	4058899	
41431	3636	4043071	1985-10-17	1985-10-17 00:00:00	38000275	0	\N	\N	241790	0	228557008	4043071	
53539	4642	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	309367	0	180256009	4107731	
41880	3694	4078793	2018-09-25	2018-09-25 00:00:00	38000275	0	\N	\N	245556	0	180325003	4078793	
41966	3695	4107731	1994-06-27	1994-06-27 00:00:00	38000275	0	\N	\N	245626	0	180256009	4107731	
42141	3717	4163872	1989-04-10	1989-04-10 00:00:00	38000275	0	\N	\N	247066	0	399208008	4163872	
54284	4719	4107731	1992-11-22	1992-11-22 00:00:00	38000275	0	\N	\N	314265	0	180256009	4107731	
30653	2711	4107731	1991-02-04	1991-02-04 00:00:00	38000275	0	\N	\N	179645	0	180256009	4107731	
42656	3759	4107731	1991-01-20	1991-01-20 00:00:00	38000275	0	\N	\N	249953	0	180256009	4107731	
42930	3783	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	251400	0	180256009	4107731	
55004	4777	4151422	1978-05-29	1978-05-29 00:00:00	38000275	0	\N	\N	318082	0	269911007	4151422	
31316	2771	4125906	1990-09-08	1990-09-08 00:00:00	38000275	0	\N	\N	183475	0	288086009	4125906	
31597	2782	4078793	1994-08-10	1994-08-10 00:00:00	38000275	0	\N	\N	184377	0	180325003	4078793	
43734	3865	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	256669	0	395142003	4191853	
43942	3876	4107731	1992-06-22	1992-06-22 00:00:00	38000275	0	\N	\N	257436	0	180256009	4107731	
44107	3884	4107731	1992-10-26	1992-10-26 00:00:00	38000275	0	\N	\N	258051	0	180256009	4107731	
32207	2830	4107731	1991-09-23	1991-09-23 00:00:00	38000275	0	\N	\N	187735	0	180256009	4107731	
56425	4924	4107731	1991-07-17	1991-07-17 00:00:00	38000275	0	\N	\N	327211	0	180256009	4107731	
44690	3916	4295880	1998-06-24	1998-06-24 00:00:00	38000275	0	\N	\N	260315	0	76601001	4295880	
56725	4933	4181917	1978-03-03	1978-03-03 00:00:00	38000275	0	\N	\N	327966	0	54550000	4181917	
44945	3946	4125906	2007-07-12	2007-07-12 00:00:00	38000275	0	\N	\N	262355	0	288086009	4125906	
33167	2902	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	193287	0	180256009	4107731	
33413	2921	4035793	2005-09-13	2005-09-13 00:00:00	38000275	0	\N	\N	194761	0	15081005	4035793	
57595	4986	4078793	2008-06-08	2008-06-08 00:00:00	38000275	0	\N	\N	331662	0	180325003	4078793	
45683	4026	4107731	1991-11-10	1991-11-10 00:00:00	38000275	0	\N	\N	267768	0	180256009	4107731	
45961	4035	4151422	1975-07-06	1975-07-06 00:00:00	38000275	0	\N	\N	268491	0	269911007	4151422	
34215	2970	4107731	2001-12-06	2001-12-06 00:00:00	38000275	0	\N	\N	198287	0	180256009	4107731	
34350	2975	4107731	1991-05-26	1991-05-26 00:00:00	38000275	0	\N	\N	198666	0	180256009	4107731	
34527	2991	4125906	2018-10-01	2018-10-01 00:00:00	38000275	0	\N	\N	199630	0	288086009	4125906	
58553	5068	4057420	2013-12-21	2013-12-21 00:00:00	38000275	0	\N	\N	336941	0	18286008	4057420	
46818	4109	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	273168	0	180256009	4107731	
59061	5117	4107731	1991-12-16	1991-12-16 00:00:00	38000275	0	\N	\N	340077	0	180256009	4107731	
47151	4145	4107731	2009-05-23	2009-05-23 00:00:00	38000275	0	\N	\N	275510	0	180256009	4107731	
59301	5127	4024289	1980-03-25	1980-03-25 00:00:00	38000275	0	\N	\N	340894	0	19490002	4024289	
47503	4167	4107731	1993-09-29	1993-09-29 00:00:00	38000275	0	\N	\N	276961	0	180256009	4107731	
35838	3141	4125906	1998-05-28	1998-05-28 00:00:00	38000275	0	\N	\N	208990	0	288086009	4125906	
24038	2088	4125906	1923-10-18	1923-10-18 00:00:00	38000275	0	\N	\N	139178	0	288086009	4125906	
36230	3176	4107731	2004-01-18	2004-01-18 00:00:00	38000275	0	\N	\N	211136	0	180256009	4107731	
24474	2136	4107731	2002-03-22	2002-03-22 00:00:00	38000275	0	\N	\N	142219	0	180256009	4107731	
36592	3215	4107731	2004-08-07	2004-08-07 00:00:00	38000275	0	\N	\N	213589	0	180256009	4107731	
36791	3236	4078793	2014-09-05	2014-09-05 00:00:00	38000275	0	\N	\N	215106	0	180325003	4078793	
36870	3241	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	215572	0	180256009	4107731	
37172	3270	4043071	1985-05-27	1985-05-27 00:00:00	38000275	0	\N	\N	217315	0	228557008	4043071	
37291	3279	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	217908	0	180256009	4107731	
37480	3311	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	219886	0	180256009	4107731	
49586	4353	4043071	1979-12-19	1979-12-19 00:00:00	38000275	0	\N	\N	288746	0	228557008	4043071	
37787	3343	4043071	1986-12-23	1986-12-23 00:00:00	38000275	0	\N	\N	221776	0	228557008	4043071	
38097	3364	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	223112	0	180256009	4107731	
38208	3370	4107731	1991-07-07	1991-07-07 00:00:00	38000275	0	\N	\N	223434	0	180256009	4107731	
50328	4376	4035793	2001-11-06	2001-11-06 00:00:00	38000275	0	\N	\N	290836	0	15081005	4035793	
38686	3399	4107731	1996-03-25	1996-03-25 00:00:00	38000275	0	\N	\N	225513	0	180256009	4107731	
26903	2352	4191853	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	156675	0	395142003	4191853	
38951	3435	4170947	2018-04-27	2018-04-27 00:00:00	38000275	0	\N	\N	227830	0	274474001	4170947	
39429	3469	44783196	1993-03-29	1993-03-29 00:00:00	38000275	0	\N	\N	230292	0	699253003	44783196	
27584	2409	4047491	1986-07-21	1986-07-21 00:00:00	38000275	0	\N	\N	159942	0	1225002	4047491	
39711	3494	4035793	2011-08-11	2011-08-11 00:00:00	38000275	0	\N	\N	231736	0	15081005	4035793	
39864	3510	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	232835	0	180256009	4107731	
40156	3527	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	234139	0	180256009	4107731	
40328	3529	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	234364	0	180256009	4107731	
28608	2542	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	168108	0	395142003	4191853	
40713	3571	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	237341	0	180256009	4107731	
40845	3583	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	238262	0	180256009	4107731	
29057	2576	4125906	1993-10-25	1993-10-25 00:00:00	38000275	0	\N	\N	170548	0	288086009	4125906	
41176	3615	4125906	2006-10-06	2006-10-06 00:00:00	38000275	0	\N	\N	240219	0	288086009	4125906	
41432	3636	4043071	1986-02-13	1986-02-13 00:00:00	38000275	0	\N	\N	241778	0	228557008	4043071	
53540	4642	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	309406	0	180256009	4107731	
41881	3694	4043071	1965-12-15	1965-12-15 00:00:00	38000275	0	\N	\N	245496	0	228557008	4043071	
41967	3695	4107731	1995-05-08	1995-05-08 00:00:00	38000275	0	\N	\N	245630	0	180256009	4107731	
42142	3717	4107731	1991-01-19	1991-01-19 00:00:00	38000275	0	\N	\N	246958	0	180256009	4107731	
54285	4719	4107731	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	314269	0	180256009	4107731	
30654	2711	4107731	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	179694	0	180256009	4107731	
42657	3759	4191853	1990-01-07	1990-01-07 00:00:00	38000275	0	\N	\N	249969	0	395142003	4191853	
42931	3783	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	251448	0	180256009	4107731	
55005	4777	4125906	1979-09-04	1979-09-04 00:00:00	38000275	0	\N	\N	318096	0	288086009	4125906	
31317	2771	4057420	1955-11-11	1955-11-11 00:00:00	38000275	0	\N	\N	183470	0	18286008	4057420	
31598	2782	4078793	1998-05-13	1998-05-13 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
43735	3865	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	256624	0	180256009	4107731	
43943	3876	4170947	2017-12-23	2017-12-23 00:00:00	38000275	0	\N	\N	257538	0	274474001	4170947	
44108	3884	4107731	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	258148	0	180256009	4107731	
32208	2830	4107731	1992-10-05	1992-10-05 00:00:00	38000275	0	\N	\N	187749	0	180256009	4107731	
56426	4924	4107731	1991-02-20	1991-02-20 00:00:00	38000275	0	\N	\N	327153	0	180256009	4107731	
44691	3916	4107731	1993-06-09	1993-06-09 00:00:00	38000275	0	\N	\N	260404	0	180256009	4107731	
56726	4933	4252419	1998-10-28	1998-10-28 00:00:00	38000275	0	\N	\N	327970	0	74016001	4252419	
44946	3946	4125906	1964-01-01	1964-01-01 00:00:00	38000275	0	\N	\N	262352	0	288086009	4125906	
33168	2902	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	193338	0	180256009	4107731	
33414	2921	4035793	2010-10-12	2010-10-12 00:00:00	38000275	0	\N	\N	194744	0	15081005	4035793	
57596	4987	4151422	2007-01-30	2007-01-30 00:00:00	38000275	0	\N	\N	331735	0	269911007	4151422	
45684	4026	4107731	1992-01-12	1992-01-12 00:00:00	38000275	0	\N	\N	267686	0	180256009	4107731	
45969	4040	4125906	1982-11-04	1982-11-04 00:00:00	38000275	0	\N	\N	268659	0	288086009	4125906	
34216	2970	4107731	2000-05-18	2000-05-18 00:00:00	38000275	0	\N	\N	198357	0	180256009	4107731	
34351	2975	4107731	1990-12-09	1990-12-09 00:00:00	38000275	0	\N	\N	198611	0	180256009	4107731	
34528	2991	4293740	1984-04-27	1984-04-27 00:00:00	38000275	0	\N	\N	199628	0	384700001	4293740	
58554	5068	4078793	2016-01-02	2016-01-02 00:00:00	38000275	0	\N	\N	336994	0	180325003	4078793	
46819	4109	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	273217	0	180256009	4107731	
59062	5117	4107731	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	340151	0	180256009	4107731	
47152	4145	4107731	2008-10-25	2008-10-25 00:00:00	38000275	0	\N	\N	275477	0	180256009	4107731	
59302	5127	4170947	1980-03-25	1980-03-25 00:00:00	38000275	0	\N	\N	340894	0	274474001	4170947	
47504	4167	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	276889	0	180256009	4107731	
47721	4190	4125906	2000-08-23	2000-08-23 00:00:00	38000275	0	\N	\N	278065	0	288086009	4125906	
24039	2088	4035793	1980-09-09	1980-09-09 00:00:00	38000275	0	\N	\N	139275	0	15081005	4035793	
36231	3176	4107731	2002-12-15	2002-12-15 00:00:00	38000275	0	\N	\N	211113	0	180256009	4107731	
24475	2136	4107731	2004-07-09	2004-07-09 00:00:00	38000275	0	\N	\N	142272	0	180256009	4107731	
36593	3215	4107731	2003-02-08	2003-02-08 00:00:00	38000275	0	\N	\N	213673	0	180256009	4107731	
36792	3236	4078793	1996-02-02	1996-02-02 00:00:00	38000275	0	\N	\N	215040	0	180325003	4078793	
36871	3241	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	215528	0	180256009	4107731	
37173	3270	4043071	1984-01-23	1984-01-23 00:00:00	38000275	0	\N	\N	217327	0	228557008	4043071	
37292	3279	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	217850	0	180256009	4107731	
37481	3311	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	219802	0	180256009	4107731	
49587	4353	4043071	1977-02-02	1977-02-02 00:00:00	38000275	0	\N	\N	288730	0	228557008	4043071	
37788	3343	4107731	1992-11-01	1992-11-01 00:00:00	38000275	0	\N	\N	221735	0	180256009	4107731	
38098	3364	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	223144	0	180256009	4107731	
38209	3370	4107731	1991-05-05	1991-05-05 00:00:00	38000275	0	\N	\N	223417	0	180256009	4107731	
50329	4376	4035793	2017-01-31	2017-01-31 00:00:00	38000275	0	\N	\N	290758	0	15081005	4035793	
38687	3399	4107731	1996-03-04	1996-03-04 00:00:00	38000275	0	\N	\N	225505	0	180256009	4107731	
26904	2352	4107731	1992-06-01	1992-06-01 00:00:00	38000275	0	\N	\N	156595	0	180256009	4107731	
38952	3435	4151422	1989-08-23	1989-08-23 00:00:00	38000275	0	\N	\N	227811	0	269911007	4151422	
39430	3469	4170947	1986-02-08	1986-02-08 00:00:00	38000275	0	\N	\N	230251	0	274474001	4170947	
27585	2409	4170947	1986-07-21	1986-07-21 00:00:00	38000275	0	\N	\N	159942	0	274474001	4170947	
39712	3494	4035793	2012-10-25	2012-10-25 00:00:00	38000275	0	\N	\N	231755	0	15081005	4035793	
39865	3510	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	232926	0	180256009	4107731	
40157	3527	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	234008	0	180256009	4107731	
40329	3529	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	234372	0	180256009	4107731	
28609	2542	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	168195	0	180256009	4107731	
40714	3571	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	237357	0	180256009	4107731	
40846	3583	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	238281	0	180256009	4107731	
29058	2576	4125906	2015-04-24	2015-04-24 00:00:00	38000275	0	\N	\N	170549	0	288086009	4125906	
41177	3616	4125906	2019-06-01	2019-06-01 00:00:00	38000275	0	\N	\N	240294	0	288086009	4125906	
41433	3636	4125906	2017-03-18	2017-03-18 00:00:00	38000275	0	\N	\N	241835	0	288086009	4125906	
53541	4642	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	309426	0	180256009	4107731	
41882	3694	4078793	2019-02-05	2019-02-05 00:00:00	38000275	0	\N	\N	245552	0	180325003	4078793	
41969	3697	4252419	1955-02-01	1955-02-01 00:00:00	38000275	0	\N	\N	245719	0	74016001	4252419	
42143	3717	4107731	1992-10-10	1992-10-10 00:00:00	38000275	0	\N	\N	247013	0	180256009	4107731	
54286	4719	4107731	1991-08-18	1991-08-18 00:00:00	38000275	0	\N	\N	314297	0	180256009	4107731	
30655	2711	4107731	1991-09-02	1991-09-02 00:00:00	38000275	0	\N	\N	179693	0	180256009	4107731	
42658	3759	4107731	1990-08-26	1990-08-26 00:00:00	38000275	0	\N	\N	249954	0	180256009	4107731	
42932	3783	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	251431	0	180256009	4107731	
55006	4777	4293740	1979-09-04	1979-09-04 00:00:00	38000275	0	\N	\N	318096	0	384700001	4293740	
31318	2771	40492359	1955-11-11	1955-11-11 00:00:00	38000275	0	\N	\N	183470	0	447365002	40492359	
31599	2782	44783196	1955-05-10	1955-05-10 00:00:00	38000275	0	\N	\N	184453	0	699253003	44783196	
43736	3865	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	256663	0	180256009	4107731	
43944	3876	4047491	2017-12-23	2017-12-23 00:00:00	38000275	0	\N	\N	257538	0	1225002	4047491	
44109	3884	4043071	1990-02-10	1990-02-10 00:00:00	38000275	0	\N	\N	258096	0	228557008	4043071	
32209	2830	4107731	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	187810	0	180256009	4107731	
56427	4924	4107731	1993-08-11	1993-08-11 00:00:00	38000275	0	\N	\N	327170	0	180256009	4107731	
44692	3916	4107731	1994-06-01	1994-06-01 00:00:00	38000275	0	\N	\N	260282	0	180256009	4107731	
56727	4933	4024289	1970-12-30	1970-12-30 00:00:00	38000275	0	\N	\N	327964	0	19490002	4024289	
44947	3946	4151422	1999-01-04	1999-01-04 00:00:00	38000275	0	\N	\N	262343	0	269911007	4151422	
33169	2902	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	193387	0	180256009	4107731	
33415	2921	4035793	1989-05-30	1989-05-30 00:00:00	38000275	0	\N	\N	194700	0	15081005	4035793	
45685	4026	4107731	1990-06-03	1990-06-03 00:00:00	38000275	0	\N	\N	267726	0	180256009	4107731	
57784	5014	4010253	1935-06-03	1935-06-03 00:00:00	38000275	0	\N	\N	333236	0	112790001	4010253	
34217	2970	4107731	2000-12-14	2000-12-14 00:00:00	38000275	0	\N	\N	198338	0	180256009	4107731	
34352	2975	4107731	1990-10-28	1990-10-28 00:00:00	38000275	0	\N	\N	198572	0	180256009	4107731	
34529	2991	4125906	1984-04-27	1984-04-27 00:00:00	38000275	0	\N	\N	199628	0	288086009	4125906	
58555	5068	4125906	1987-10-08	1987-10-08 00:00:00	38000275	0	\N	\N	336992	0	288086009	4125906	
46820	4109	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	273208	0	180256009	4107731	
59063	5117	4191853	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	340071	0	395142003	4191853	
47153	4145	4107731	2006-08-19	2006-08-19 00:00:00	38000275	0	\N	\N	275470	0	180256009	4107731	
59303	5128	4145310	2009-12-26	2009-12-26 00:00:00	38000275	0	\N	\N	340921	0	268425006	4145310	
47505	4167	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	277007	0	180256009	4107731	
47722	4190	4125906	1987-01-13	1987-01-13 00:00:00	38000275	0	\N	\N	278064	0	288086009	4125906	
24040	2088	4035793	2015-07-21	2015-07-21 00:00:00	38000275	0	\N	\N	139197	0	15081005	4035793	
36232	3176	4107731	2002-11-24	2002-11-24 00:00:00	38000275	0	\N	\N	211176	0	180256009	4107731	
24476	2136	4107731	2003-01-31	2003-01-31 00:00:00	38000275	0	\N	\N	142223	0	180256009	4107731	
36594	3215	4107731	2002-12-28	2002-12-28 00:00:00	38000275	0	\N	\N	213672	0	180256009	4107731	
36793	3236	4078793	1999-02-19	1999-02-19 00:00:00	38000275	0	\N	\N	215098	0	180325003	4078793	
36872	3241	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	215573	0	180256009	4107731	
37174	3270	4047491	1976-02-23	1976-02-23 00:00:00	38000275	0	\N	\N	217350	0	1225002	4047491	
37293	3279	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	217847	0	180256009	4107731	
37482	3311	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	219801	0	180256009	4107731	
49588	4353	4043071	1978-01-04	1978-01-04 00:00:00	38000275	0	\N	\N	288750	0	228557008	4043071	
37789	3343	4043071	1986-02-18	1986-02-18 00:00:00	38000275	0	\N	\N	221846	0	228557008	4043071	
38099	3364	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	223038	0	180256009	4107731	
38210	3370	4107731	1990-09-16	1990-09-16 00:00:00	38000275	0	\N	\N	223399	0	180256009	4107731	
50330	4376	4078793	2017-01-31	2017-01-31 00:00:00	38000275	0	\N	\N	290758	0	180325003	4078793	
38688	3399	4107731	1997-08-12	1997-08-12 00:00:00	38000275	0	\N	\N	225518	0	180256009	4107731	
26905	2352	4107731	1990-10-01	1990-10-01 00:00:00	38000275	0	\N	\N	156719	0	180256009	4107731	
38953	3436	4151422	1964-08-05	1964-08-05 00:00:00	38000275	0	\N	\N	227856	0	269911007	4151422	
39431	3469	4243062	1986-02-08	1986-02-08 00:00:00	38000275	0	\N	\N	230251	0	60027007	4243062	
27586	2409	4058899	2011-01-25	2011-01-25 00:00:00	38000275	0	\N	\N	159944	0	168594001	4058899	
39713	3494	4151422	2003-07-03	2003-07-03 00:00:00	38000275	0	\N	\N	231782	0	269911007	4151422	
39866	3510	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	232919	0	180256009	4107731	
40158	3527	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	234009	0	180256009	4107731	
40330	3529	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	234376	0	180256009	4107731	
28610	2542	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	168206	0	180256009	4107731	
40715	3571	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	237338	0	180256009	4107731	
40847	3583	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	238188	0	180256009	4107731	
29059	2577	4107731	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	170632	0	180256009	4107731	
41178	3616	4170947	1975-11-23	1975-11-23 00:00:00	38000275	0	\N	\N	240291	0	274474001	4170947	
41434	3636	4293740	2017-03-18	2017-03-18 00:00:00	38000275	0	\N	\N	241835	0	384700001	4293740	
53542	4643	4195803	1985-02-03	1985-02-03 00:00:00	38000275	0	\N	\N	309627	0	312681000	4195803	
41883	3694	4043071	1966-02-09	1966-02-09 00:00:00	38000275	0	\N	\N	245512	0	228557008	4043071	
41970	3697	4163872	1987-04-16	1987-04-16 00:00:00	38000275	0	\N	\N	245803	0	399208008	4163872	
42144	3717	4107731	1991-09-07	1991-09-07 00:00:00	38000275	0	\N	\N	247039	0	180256009	4107731	
54287	4719	4107731	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	314175	0	180256009	4107731	
30656	2711	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	179666	0	180256009	4107731	
42659	3759	4107731	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	249902	0	180256009	4107731	
42933	3783	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	251335	0	180256009	4107731	
55007	4777	4195803	1974-11-29	1974-11-29 00:00:00	38000275	0	\N	\N	318095	0	312681000	4195803	
31319	2771	4078793	1980-02-01	1980-02-01 00:00:00	38000275	0	\N	\N	183521	0	180325003	4078793	
31600	2782	4151422	1952-02-01	1952-02-01 00:00:00	38000275	0	\N	\N	184442	0	269911007	4151422	
43737	3865	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	256565	0	180256009	4107731	
43945	3876	4107731	1990-03-05	1990-03-05 00:00:00	38000275	0	\N	\N	257473	0	180256009	4107731	
44110	3884	4107731	1990-04-16	1990-04-16 00:00:00	38000275	0	\N	\N	258062	0	180256009	4107731	
32210	2830	4107731	1990-12-03	1990-12-03 00:00:00	38000275	0	\N	\N	187811	0	180256009	4107731	
56428	4924	4107731	1991-12-11	1991-12-11 00:00:00	38000275	0	\N	\N	327167	0	180256009	4107731	
44693	3916	4107731	1993-09-22	1993-09-22 00:00:00	38000275	0	\N	\N	260370	0	180256009	4107731	
56728	4933	4170947	1970-12-30	1970-12-30 00:00:00	38000275	0	\N	\N	327964	0	274474001	4170947	
44952	3949	4043071	1979-02-27	1979-02-27 00:00:00	38000275	0	\N	\N	262447	0	228557008	4043071	
33170	2902	4330583	1983-07-03	1983-07-03 00:00:00	38000275	0	\N	\N	193302	0	22523008	4330583	
33416	2921	4035793	2013-10-29	2013-10-29 00:00:00	38000275	0	\N	\N	194750	0	15081005	4035793	
45686	4026	4107731	1991-12-01	1991-12-01 00:00:00	38000275	0	\N	\N	267685	0	180256009	4107731	
57785	5014	4151422	1915-11-29	1915-11-29 00:00:00	38000275	0	\N	\N	333311	0	269911007	4151422	
34218	2970	4107731	2000-03-16	2000-03-16 00:00:00	38000275	0	\N	\N	198335	0	180256009	4107731	
34353	2975	4107731	1993-03-28	1993-03-28 00:00:00	38000275	0	\N	\N	198598	0	180256009	4107731	
34530	2992	4202451	2011-08-19	2011-08-19 00:00:00	38000275	0	\N	\N	199719	0	433112001	4202451	
58556	5068	4078793	2014-12-27	2014-12-27 00:00:00	38000275	0	\N	\N	336977	0	180325003	4078793	
46821	4109	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	273184	0	180256009	4107731	
59064	5117	4107731	1991-09-23	1991-09-23 00:00:00	38000275	0	\N	\N	340145	0	180256009	4107731	
47154	4145	4107731	2009-05-02	2009-05-02 00:00:00	38000275	0	\N	\N	275478	0	180256009	4107731	
59304	5128	4125906	1983-05-28	1983-05-28 00:00:00	38000275	0	\N	\N	340919	0	288086009	4125906	
47506	4167	4107731	1994-03-16	1994-03-16 00:00:00	38000275	0	\N	\N	276897	0	180256009	4107731	
47723	4190	4198190	1977-07-31	1977-07-31 00:00:00	38000275	0	\N	\N	278066	0	80146002	4198190	
24041	2088	4035793	1994-05-03	1994-05-03 00:00:00	38000275	0	\N	\N	139203	0	15081005	4035793	
36233	3176	4107731	2004-05-02	2004-05-02 00:00:00	38000275	0	\N	\N	211184	0	180256009	4107731	
24477	2136	4107731	2004-01-02	2004-01-02 00:00:00	38000275	0	\N	\N	142266	0	180256009	4107731	
36595	3215	4151422	2000-03-21	2000-03-21 00:00:00	38000275	0	\N	\N	213670	0	269911007	4151422	
36794	3236	4202451	2016-07-15	2016-07-15 00:00:00	38000275	0	\N	\N	215114	0	433112001	4202451	
36873	3241	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	215495	0	180256009	4107731	
37175	3270	4170947	1976-02-23	1976-02-23 00:00:00	38000275	0	\N	\N	217350	0	274474001	4170947	
37294	3279	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	217939	0	180256009	4107731	
37483	3311	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	219792	0	180256009	4107731	
49589	4353	4043071	1978-10-11	1978-10-11 00:00:00	38000275	0	\N	\N	288752	0	228557008	4043071	
37790	3343	4043071	1985-10-01	1985-10-01 00:00:00	38000275	0	\N	\N	221808	0	228557008	4043071	
38100	3364	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	223118	0	180256009	4107731	
38211	3370	4107731	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	223416	0	180256009	4107731	
50331	4376	4078793	2010-12-28	2010-12-28 00:00:00	38000275	0	\N	\N	290781	0	180325003	4078793	
38689	3399	4107731	1996-05-07	1996-05-07 00:00:00	38000275	0	\N	\N	225514	0	180256009	4107731	
26906	2352	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	156635	0	180256009	4107731	
38954	3436	4151422	1971-07-30	1971-07-30 00:00:00	38000275	0	\N	\N	227877	0	269911007	4151422	
39432	3469	4125906	1953-08-27	1953-08-27 00:00:00	38000275	0	\N	\N	230293	0	288086009	4125906	
27587	2409	4275113	1992-09-30	1992-09-30 00:00:00	38000275	0	\N	\N	159918	0	65200003	4275113	
39714	3494	4035793	2014-11-06	2014-11-06 00:00:00	38000275	0	\N	\N	231737	0	15081005	4035793	
39867	3510	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	232938	0	180256009	4107731	
40159	3527	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	234108	0	180256009	4107731	
40331	3530	40492359	2003-01-03	2003-01-03 00:00:00	38000275	0	\N	\N	234457	0	447365002	40492359	
28611	2542	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	168171	0	180256009	4107731	
40716	3571	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	237369	0	180256009	4107731	
40848	3583	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	238263	0	180256009	4107731	
29060	2577	4107731	1990-06-23	1990-06-23 00:00:00	38000275	0	\N	\N	170623	0	180256009	4107731	
41179	3616	4024289	1975-11-23	1975-11-23 00:00:00	38000275	0	\N	\N	240291	0	19490002	4024289	
41435	3637	4125906	1989-03-15	1989-03-15 00:00:00	38000275	0	\N	\N	241886	0	288086009	4125906	
53543	4643	4170947	1985-02-03	1985-02-03 00:00:00	38000275	0	\N	\N	309627	0	274474001	4170947	
41884	3694	4170947	1972-12-21	1972-12-21 00:00:00	38000275	0	\N	\N	245561	0	274474001	4170947	
41971	3697	44783196	1955-02-08	1955-02-08 00:00:00	38000275	0	\N	\N	245778	0	699253003	44783196	
42145	3717	4107731	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	246965	0	180256009	4107731	
54288	4719	4107731	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	314271	0	180256009	4107731	
30657	2711	4107731	1991-03-18	1991-03-18 00:00:00	38000275	0	\N	\N	179761	0	180256009	4107731	
42660	3759	4107731	1992-08-30	1992-08-30 00:00:00	38000275	0	\N	\N	249918	0	180256009	4107731	
42934	3783	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	251352	0	180256009	4107731	
55008	4777	4163872	1974-11-29	1974-11-29 00:00:00	38000275	0	\N	\N	318095	0	399208008	4163872	
31320	2771	4163971	1974-09-02	1974-09-02 00:00:00	38000275	0	\N	\N	183474	0	45595009	4163971	
31601	2782	4057420	1988-07-06	1988-07-06 00:00:00	38000275	0	\N	\N	184392	0	18286008	4057420	
43738	3865	4252419	2004-11-13	2004-11-13 00:00:00	38000275	0	\N	\N	256557	0	74016001	4252419	
55736	4852	4293740	1995-01-24	1995-01-24 00:00:00	38000275	0	\N	\N	322782	0	384700001	4293740	
44111	3884	4293740	1983-02-26	1983-02-26 00:00:00	38000275	0	\N	\N	258015	0	384700001	4293740	
32211	2830	4107731	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	187793	0	180256009	4107731	
56429	4924	4107731	1993-04-07	1993-04-07 00:00:00	38000275	0	\N	\N	327275	0	180256009	4107731	
56540	4927	4295880	2003-03-21	2003-03-21 00:00:00	38000275	0	\N	\N	327530	0	76601001	4295880	
56729	4933	4024289	1980-03-03	1980-03-03 00:00:00	38000275	0	\N	\N	327967	0	19490002	4024289	
44953	3949	4043071	1978-03-21	1978-03-21 00:00:00	38000275	0	\N	\N	262441	0	228557008	4043071	
33171	2902	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	193352	0	395142003	4191853	
33417	2921	4035793	2001-08-21	2001-08-21 00:00:00	38000275	0	\N	\N	194759	0	15081005	4035793	
45687	4026	4107731	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	267710	0	180256009	4107731	
57786	5014	44783196	1943-03-03	1943-03-03 00:00:00	38000275	0	\N	\N	333312	0	699253003	44783196	
34219	2970	4191853	1999-05-06	1999-05-06 00:00:00	38000275	0	\N	\N	198331	0	395142003	4191853	
34354	2975	4107731	1993-04-18	1993-04-18 00:00:00	38000275	0	\N	\N	198594	0	180256009	4107731	
34531	2992	4125906	1981-01-29	1981-01-29 00:00:00	38000275	0	\N	\N	199764	0	288086009	4125906	
58557	5068	4078793	2017-01-07	2017-01-07 00:00:00	38000275	0	\N	\N	336978	0	180325003	4078793	
46822	4109	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	273090	0	180256009	4107731	
59065	5117	4107731	1991-01-14	1991-01-14 00:00:00	38000275	0	\N	\N	340025	0	180256009	4107731	
47155	4145	4107731	2008-09-13	2008-09-13 00:00:00	38000275	0	\N	\N	275476	0	180256009	4107731	
59305	5128	4195803	1997-02-19	1997-02-19 00:00:00	38000275	0	\N	\N	340966	0	312681000	4195803	
47507	4167	4107731	1994-02-23	1994-02-23 00:00:00	38000275	0	\N	\N	277011	0	180256009	4107731	
47724	4191	4151422	1973-08-24	1973-08-24 00:00:00	38000275	0	\N	\N	278151	0	269911007	4151422	
24042	2088	4035793	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	139236	0	15081005	4035793	
36234	3176	4107731	2002-03-17	2002-03-17 00:00:00	38000275	0	\N	\N	211110	0	180256009	4107731	
24478	2136	4107731	2001-08-03	2001-08-03 00:00:00	38000275	0	\N	\N	142307	0	180256009	4107731	
36596	3215	4058899	1995-01-02	1995-01-02 00:00:00	38000275	0	\N	\N	213684	0	168594001	4058899	
36795	3236	4078793	2009-08-07	2009-08-07 00:00:00	38000275	0	\N	\N	215092	0	180325003	4078793	
36874	3241	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	215509	0	180256009	4107731	
37176	3270	4043071	1983-01-31	1983-01-31 00:00:00	38000275	0	\N	\N	217360	0	228557008	4043071	
37295	3279	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	217863	0	180256009	4107731	
37484	3311	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	219876	0	180256009	4107731	
49590	4353	4043071	1977-10-05	1977-10-05 00:00:00	38000275	0	\N	\N	288762	0	228557008	4043071	
37791	3343	4043071	1987-01-20	1987-01-20 00:00:00	38000275	0	\N	\N	221755	0	228557008	4043071	
38101	3364	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	223043	0	180256009	4107731	
38212	3370	4107731	1990-12-09	1990-12-09 00:00:00	38000275	0	\N	\N	223401	0	180256009	4107731	
50332	4376	4035793	2010-12-28	2010-12-28 00:00:00	38000275	0	\N	\N	290781	0	15081005	4035793	
38690	3399	4107731	1996-07-09	1996-07-09 00:00:00	38000275	0	\N	\N	225467	0	180256009	4107731	
26907	2352	4107731	1993-02-08	1993-02-08 00:00:00	38000275	0	\N	\N	156600	0	180256009	4107731	
38955	3437	4170947	1915-03-13	1915-03-13 00:00:00	38000275	0	\N	\N	228017	0	274474001	4170947	
39433	3469	4252419	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	230254	0	74016001	4252419	
27588	2409	4238715	1997-01-12	1997-01-12 00:00:00	38000275	0	\N	\N	159919	0	68254000	4238715	
39715	3494	4035793	2017-11-23	2017-11-23 00:00:00	38000275	0	\N	\N	231793	0	15081005	4035793	
39868	3510	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	232937	0	180256009	4107731	
40160	3527	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	234084	0	180256009	4107731	
40332	3530	4057420	2003-01-03	2003-01-03 00:00:00	38000275	0	\N	\N	234457	0	18286008	4057420	
40393	3539	4151422	1983-06-01	1983-06-01 00:00:00	38000275	0	\N	\N	235094	0	269911007	4151422	
40717	3571	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	237402	0	180256009	4107731	
40849	3583	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	238254	0	180256009	4107731	
29061	2577	4107731	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	170678	0	180256009	4107731	
41180	3618	4125906	1936-01-02	1936-01-02 00:00:00	38000275	0	\N	\N	240397	0	288086009	4125906	
41436	3638	4125906	1987-07-09	1987-07-09 00:00:00	38000275	0	\N	\N	241967	0	288086009	4125906	
53544	4643	4163872	1985-02-03	1985-02-03 00:00:00	38000275	0	\N	\N	309627	0	399208008	4163872	
41885	3694	4024289	1972-12-21	1972-12-21 00:00:00	38000275	0	\N	\N	245561	0	19490002	4024289	
41972	3697	4125906	1988-10-12	1988-10-12 00:00:00	38000275	0	\N	\N	245720	0	288086009	4125906	
42146	3717	4107731	1991-07-27	1991-07-27 00:00:00	38000275	0	\N	\N	247038	0	180256009	4107731	
54289	4719	4107731	1993-01-24	1993-01-24 00:00:00	38000275	0	\N	\N	314275	0	180256009	4107731	
30658	2711	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	179682	0	180256009	4107731	
42661	3759	4107731	1991-07-07	1991-07-07 00:00:00	38000275	0	\N	\N	249958	0	180256009	4107731	
42935	3783	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	251336	0	180256009	4107731	
55009	4777	4170947	1974-11-29	1974-11-29 00:00:00	38000275	0	\N	\N	318095	0	274474001	4170947	
31321	2771	42535580	1974-09-02	1974-09-02 00:00:00	38000275	0	\N	\N	183474	0	426701000119108	42535580	
31602	2782	4078793	1997-12-17	1997-12-17 00:00:00	38000275	0	\N	\N	184395	0	180325003	4078793	
43739	3865	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	256649	0	180256009	4107731	
55737	4852	4125906	1995-01-24	1995-01-24 00:00:00	38000275	0	\N	\N	322782	0	288086009	4125906	
44112	3884	4125906	1983-02-26	1983-02-26 00:00:00	38000275	0	\N	\N	258015	0	288086009	4125906	
32212	2830	4107731	1992-11-16	1992-11-16 00:00:00	38000275	0	\N	\N	187750	0	180256009	4107731	
56430	4924	4107731	1994-06-01	1994-06-01 00:00:00	38000275	0	\N	\N	327199	0	180256009	4107731	
56541	4927	4295880	1998-12-25	1998-12-25 00:00:00	38000275	0	\N	\N	327451	0	76601001	4295880	
56730	4933	4170947	1980-03-03	1980-03-03 00:00:00	38000275	0	\N	\N	327967	0	274474001	4170947	
44954	3949	4043071	1978-12-26	1978-12-26 00:00:00	38000275	0	\N	\N	262443	0	228557008	4043071	
33172	2902	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	193379	0	180256009	4107731	
33418	2921	4035793	1998-08-04	1998-08-04 00:00:00	38000275	0	\N	\N	194703	0	15081005	4035793	
45688	4026	4107731	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	267687	0	180256009	4107731	
57787	5014	4202451	1996-05-28	1996-05-28 00:00:00	38000275	0	\N	\N	333290	0	433112001	4202451	
34220	2970	4107731	2001-05-31	2001-05-31 00:00:00	38000275	0	\N	\N	198297	0	180256009	4107731	
34355	2975	4107731	1991-10-20	1991-10-20 00:00:00	38000275	0	\N	\N	198588	0	180256009	4107731	
34532	2992	4151422	2016-06-30	2016-06-30 00:00:00	38000275	0	\N	\N	199745	0	269911007	4151422	
58558	5068	4078793	2019-01-19	2019-01-19 00:00:00	38000275	0	\N	\N	336979	0	180325003	4078793	
46823	4109	4062501	1967-12-08	1967-12-08 00:00:00	38000275	0	\N	\N	273154	0	171231001	4062501	
59066	5117	4107731	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	340130	0	180256009	4107731	
47156	4145	4024289	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	275464	0	19490002	4024289	
59306	5128	4145310	2019-05-08	2019-05-08 00:00:00	38000275	0	\N	\N	340922	0	268425006	4145310	
47508	4167	4107731	1993-07-28	1993-07-28 00:00:00	38000275	0	\N	\N	276970	0	180256009	4107731	
47725	4191	40492359	2013-07-26	2013-07-26 00:00:00	38000275	0	\N	\N	278185	0	447365002	40492359	
24043	2088	4035793	2005-07-05	2005-07-05 00:00:00	38000275	0	\N	\N	139241	0	15081005	4035793	
36235	3176	4107731	2004-04-11	2004-04-11 00:00:00	38000275	0	\N	\N	211181	0	180256009	4107731	
24479	2136	4107731	2001-08-24	2001-08-24 00:00:00	38000275	0	\N	\N	142196	0	180256009	4107731	
36597	3215	4107731	2005-05-07	2005-05-07 00:00:00	38000275	0	\N	\N	213592	0	180256009	4107731	
36796	3236	4078793	1987-01-16	1987-01-16 00:00:00	38000275	0	\N	\N	215052	0	180325003	4078793	
36875	3241	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	215515	0	180256009	4107731	
37177	3270	4043071	1983-11-21	1983-11-21 00:00:00	38000275	0	\N	\N	217250	0	228557008	4043071	
37296	3279	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	217961	0	180256009	4107731	
37485	3311	4107731	1993-07-30	1993-07-30 00:00:00	38000275	0	\N	\N	219830	0	180256009	4107731	
49591	4353	4043071	1978-12-13	1978-12-13 00:00:00	38000275	0	\N	\N	288802	0	228557008	4043071	
37792	3343	4107731	1992-01-12	1992-01-12 00:00:00	38000275	0	\N	\N	221706	0	180256009	4107731	
38102	3364	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	223042	0	180256009	4107731	
38213	3370	4107731	1992-08-30	1992-08-30 00:00:00	38000275	0	\N	\N	223504	0	180256009	4107731	
50333	4376	4035793	2008-12-16	2008-12-16 00:00:00	38000275	0	\N	\N	290780	0	15081005	4035793	
38691	3399	4107731	1996-12-23	1996-12-23 00:00:00	38000275	0	\N	\N	225516	0	180256009	4107731	
26908	2352	4107731	1991-04-29	1991-04-29 00:00:00	38000275	0	\N	\N	156709	0	180256009	4107731	
38956	3437	4243062	1915-03-13	1915-03-13 00:00:00	38000275	0	\N	\N	228017	0	60027007	4243062	
39434	3470	4151422	2009-03-29	2009-03-29 00:00:00	38000275	0	\N	\N	230345	0	269911007	4151422	
27589	2411	4125906	1999-10-02	1999-10-02 00:00:00	38000275	0	\N	\N	160004	0	288086009	4125906	
39716	3494	4035793	2009-07-30	2009-07-30 00:00:00	38000275	0	\N	\N	231735	0	15081005	4035793	
39869	3510	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	232806	0	180256009	4107731	
40161	3527	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	234105	0	180256009	4107731	
40333	3530	4125906	1968-12-02	1968-12-02 00:00:00	38000275	0	\N	\N	234453	0	288086009	4125906	
40394	3540	4170947	1976-09-14	1976-09-14 00:00:00	38000275	0	\N	\N	235121	0	274474001	4170947	
40718	3571	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	237334	0	180256009	4107731	
40850	3583	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	238184	0	180256009	4107731	
29062	2577	4107731	1990-10-27	1990-10-27 00:00:00	38000275	0	\N	\N	170654	0	180256009	4107731	
41181	3618	4195803	1982-06-20	1982-06-20 00:00:00	38000275	0	\N	\N	240343	0	312681000	4195803	
41437	3638	4151422	2014-07-27	2014-07-27 00:00:00	38000275	0	\N	\N	241992	0	269911007	4151422	
53545	4643	4125906	1912-12-27	1912-12-27 00:00:00	38000275	0	\N	\N	309566	0	288086009	4125906	
41886	3694	4125906	1984-02-22	1984-02-22 00:00:00	38000275	0	\N	\N	245562	0	288086009	4125906	
41973	3698	4151422	1996-03-16	1996-03-16 00:00:00	38000275	0	\N	\N	245858	0	269911007	4151422	
42147	3717	4107731	1990-04-21	1990-04-21 00:00:00	38000275	0	\N	\N	247068	0	180256009	4107731	
54290	4719	4107731	1991-01-20	1991-01-20 00:00:00	38000275	0	\N	\N	314256	0	180256009	4107731	
30659	2711	4107731	1991-08-12	1991-08-12 00:00:00	38000275	0	\N	\N	179646	0	180256009	4107731	
42662	3759	4107731	1992-06-07	1992-06-07 00:00:00	38000275	0	\N	\N	249904	0	180256009	4107731	
42936	3784	4035793	1993-08-24	1993-08-24 00:00:00	38000275	0	\N	\N	251464	0	15081005	4035793	
55010	4781	4170947	2007-05-17	2007-05-17 00:00:00	38000275	0	\N	\N	318276	0	274474001	4170947	
31322	2771	4202832	1974-09-02	1974-09-02 00:00:00	38000275	0	\N	\N	183474	0	52765003	4202832	
31603	2782	4078793	1978-02-01	1978-02-01 00:00:00	38000275	0	\N	\N	184399	0	180325003	4078793	
43740	3865	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	256646	0	180256009	4107731	
55738	4852	4151422	1951-10-17	1951-10-17 00:00:00	38000275	0	\N	\N	322846	0	269911007	4151422	
44113	3884	4043071	1989-11-04	1989-11-04 00:00:00	38000275	0	\N	\N	258140	0	228557008	4043071	
32213	2830	4107731	1992-08-24	1992-08-24 00:00:00	38000275	0	\N	\N	187705	0	180256009	4107731	
56431	4924	4107731	1993-09-01	1993-09-01 00:00:00	38000275	0	\N	\N	327196	0	180256009	4107731	
56542	4927	4295880	1997-09-26	1997-09-26 00:00:00	38000275	0	\N	\N	327524	0	76601001	4295880	
56731	4935	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	328026	0	180256009	4107731	
44955	3949	4043071	1977-12-20	1977-12-20 00:00:00	38000275	0	\N	\N	262479	0	228557008	4043071	
33173	2902	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	193350	0	180256009	4107731	
33419	2921	4035793	2000-08-15	2000-08-15 00:00:00	38000275	0	\N	\N	194746	0	15081005	4035793	
45689	4026	4107731	1993-04-18	1993-04-18 00:00:00	38000275	0	\N	\N	267639	0	180256009	4107731	
57788	5014	4151422	1925-10-29	1925-10-29 00:00:00	38000275	0	\N	\N	333258	0	269911007	4151422	
34221	2970	4191853	1999-05-06	1999-05-06 00:00:00	38000275	0	\N	\N	198331	0	395142003	4191853	
34356	2975	4107731	1991-01-20	1991-01-20 00:00:00	38000275	0	\N	\N	198585	0	180256009	4107731	
34533	2992	4151422	1966-08-29	1966-08-29 00:00:00	38000275	0	\N	\N	199693	0	269911007	4151422	
58559	5068	4163872	1983-08-29	1983-08-29 00:00:00	38000275	0	\N	\N	336949	0	399208008	4163872	
46824	4109	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	273211	0	180256009	4107731	
59067	5117	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	340152	0	180256009	4107731	
47157	4145	4170947	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	275464	0	274474001	4170947	
59307	5128	4078793	2018-10-03	2018-10-03 00:00:00	38000275	0	\N	\N	340954	0	180325003	4078793	
47509	4167	4107731	1994-11-23	1994-11-23 00:00:00	38000275	0	\N	\N	276950	0	180256009	4107731	
47726	4191	4057420	2013-07-26	2013-07-26 00:00:00	38000275	0	\N	\N	278185	0	18286008	4057420	
24044	2088	4035793	1988-07-19	1988-07-19 00:00:00	38000275	0	\N	\N	139276	0	15081005	4035793	
36236	3176	4191853	2005-06-26	2005-06-26 00:00:00	38000275	0	\N	\N	211098	0	395142003	4191853	
24480	2136	4107731	2003-10-10	2003-10-10 00:00:00	38000275	0	\N	\N	142264	0	180256009	4107731	
36598	3215	4107731	2004-11-20	2004-11-20 00:00:00	38000275	0	\N	\N	213615	0	180256009	4107731	
36797	3236	4078793	2004-03-19	2004-03-19 00:00:00	38000275	0	\N	\N	215082	0	180325003	4078793	
36876	3241	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	215530	0	180256009	4107731	
37178	3270	4043071	1982-11-22	1982-11-22 00:00:00	38000275	0	\N	\N	217324	0	228557008	4043071	
37297	3279	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	217849	0	180256009	4107731	
37486	3311	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	219851	0	180256009	4107731	
49592	4353	4043071	1978-08-02	1978-08-02 00:00:00	38000275	0	\N	\N	288741	0	228557008	4043071	
37793	3343	4191853	1990-01-07	1990-01-07 00:00:00	38000275	0	\N	\N	221826	0	395142003	4191853	
38103	3364	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	223124	0	180256009	4107731	
38214	3370	4107731	1993-02-14	1993-02-14 00:00:00	38000275	0	\N	\N	223441	0	180256009	4107731	
50334	4376	4078793	2008-12-16	2008-12-16 00:00:00	38000275	0	\N	\N	290780	0	180325003	4078793	
38693	3401	44783196	1965-10-21	1965-10-21 00:00:00	38000275	0	\N	\N	225610	0	699253003	44783196	
26909	2352	4107731	1991-02-04	1991-02-04 00:00:00	38000275	0	\N	\N	156707	0	180256009	4107731	
38957	3437	4170947	1921-03-09	1921-03-09 00:00:00	38000275	0	\N	\N	228019	0	274474001	4170947	
39435	3470	4125906	1971-10-28	1971-10-28 00:00:00	38000275	0	\N	\N	230326	0	288086009	4125906	
27590	2412	4163872	1985-10-20	1985-10-20 00:00:00	38000275	0	\N	\N	160034	0	399208008	4163872	
39717	3494	4035793	2010-08-05	2010-08-05 00:00:00	38000275	0	\N	\N	231764	0	15081005	4035793	
39870	3510	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	232863	0	180256009	4107731	
40162	3527	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	234055	0	180256009	4107731	
40334	3531	4170947	1975-07-15	1975-07-15 00:00:00	38000275	0	\N	\N	234587	0	274474001	4170947	
40395	3540	4243062	1976-09-14	1976-09-14 00:00:00	38000275	0	\N	\N	235121	0	60027007	4243062	
40719	3571	4170947	1983-10-20	1983-10-20 00:00:00	38000275	0	\N	\N	237438	0	274474001	4170947	
40851	3583	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	238278	0	180256009	4107731	
29063	2577	4107731	1990-12-29	1990-12-29 00:00:00	38000275	0	\N	\N	170593	0	180256009	4107731	
41182	3618	4024289	1982-06-20	1982-06-20 00:00:00	38000275	0	\N	\N	240343	0	19490002	4024289	
41438	3638	4062501	1967-05-08	1967-05-08 00:00:00	38000275	0	\N	\N	241971	0	171231001	4062501	
53546	4643	4047491	1978-12-07	1978-12-07 00:00:00	38000275	0	\N	\N	309626	0	1225002	4047491	
41887	3694	4078793	2016-02-23	2016-02-23 00:00:00	38000275	0	\N	\N	245555	0	180325003	4078793	
41974	3698	4151422	1989-05-05	1989-05-05 00:00:00	38000275	0	\N	\N	245829	0	269911007	4151422	
42148	3717	4191853	1990-01-06	1990-01-06 00:00:00	38000275	0	\N	\N	246997	0	395142003	4191853	
54291	4719	4107731	1990-11-18	1990-11-18 00:00:00	38000275	0	\N	\N	314294	0	180256009	4107731	
30660	2711	4107731	1990-10-01	1990-10-01 00:00:00	38000275	0	\N	\N	179749	0	180256009	4107731	
42663	3759	4107731	1991-02-10	1991-02-10 00:00:00	38000275	0	\N	\N	249983	0	180256009	4107731	
42937	3784	4035793	1987-07-21	1987-07-21 00:00:00	38000275	0	\N	\N	251461	0	15081005	4035793	
55011	4781	4163872	2007-05-17	2007-05-17 00:00:00	38000275	0	\N	\N	318276	0	399208008	4163872	
31323	2771	4163951	1974-09-02	1974-09-02 00:00:00	38000275	0	\N	\N	183474	0	29303009	4163951	
43385	3835	4125906	1986-09-17	1986-09-17 00:00:00	38000275	0	\N	\N	254662	0	288086009	4125906	
43741	3865	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	256594	0	180256009	4107731	
55739	4852	4024289	1967-03-26	1967-03-26 00:00:00	38000275	0	\N	\N	322779	0	19490002	4024289	
44114	3884	4107731	1992-12-28	1992-12-28 00:00:00	38000275	0	\N	\N	258150	0	180256009	4107731	
32214	2830	4107731	1992-10-26	1992-10-26 00:00:00	38000275	0	\N	\N	187732	0	180256009	4107731	
56432	4924	4107731	1992-11-11	1992-11-11 00:00:00	38000275	0	\N	\N	327161	0	180256009	4107731	
56543	4927	4295880	1996-09-27	1996-09-27 00:00:00	38000275	0	\N	\N	327498	0	76601001	4295880	
56732	4935	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	328062	0	180256009	4107731	
44956	3949	4043071	1979-04-03	1979-04-03 00:00:00	38000275	0	\N	\N	262482	0	228557008	4043071	
33174	2902	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	193295	0	180256009	4107731	
33420	2921	4035793	1985-05-21	1985-05-21 00:00:00	38000275	0	\N	\N	194739	0	15081005	4035793	
45690	4026	4107731	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	267741	0	180256009	4107731	
57789	5015	4125906	2010-09-25	2010-09-25 00:00:00	38000275	0	\N	\N	333378	0	288086009	4125906	
46039	4044	4151422	1973-03-09	1973-03-09 00:00:00	38000275	0	\N	\N	268970	0	269911007	4151422	
34357	2975	4107731	1990-08-05	1990-08-05 00:00:00	38000275	0	\N	\N	198570	0	180256009	4107731	
34534	2992	4125906	2007-07-01	2007-07-01 00:00:00	38000275	0	\N	\N	199766	0	288086009	4125906	
58560	5068	4078793	2009-11-28	2009-11-28 00:00:00	38000275	0	\N	\N	336939	0	180325003	4078793	
46825	4109	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	273189	0	180256009	4107731	
59068	5117	4107731	1990-03-05	1990-03-05 00:00:00	38000275	0	\N	\N	340021	0	180256009	4107731	
47158	4145	4107731	2009-07-04	2009-07-04 00:00:00	38000275	0	\N	\N	275511	0	180256009	4107731	
59308	5128	4151422	2009-07-26	2009-07-26 00:00:00	38000275	0	\N	\N	340976	0	269911007	4151422	
47510	4167	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	276982	0	180256009	4107731	
47727	4191	4202451	2004-09-17	2004-09-17 00:00:00	38000275	0	\N	\N	278156	0	433112001	4202451	
24045	2088	4035793	2018-08-07	2018-08-07 00:00:00	38000275	0	\N	\N	139290	0	15081005	4035793	
36237	3176	4107731	2002-09-01	2002-09-01 00:00:00	38000275	0	\N	\N	211174	0	180256009	4107731	
24481	2136	4107731	2003-08-29	2003-08-29 00:00:00	38000275	0	\N	\N	142208	0	180256009	4107731	
36599	3215	4107731	2004-10-30	2004-10-30 00:00:00	38000275	0	\N	\N	213591	0	180256009	4107731	
36798	3236	4078793	2013-08-30	2013-08-30 00:00:00	38000275	0	\N	\N	215085	0	180325003	4078793	
36877	3241	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	215531	0	180256009	4107731	
37179	3270	4043071	1985-01-14	1985-01-14 00:00:00	38000275	0	\N	\N	217271	0	228557008	4043071	
37298	3279	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	217840	0	180256009	4107731	
37487	3311	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	219811	0	180256009	4107731	
49593	4353	4043071	1979-11-21	1979-11-21 00:00:00	38000275	0	\N	\N	288777	0	228557008	4043071	
37794	3343	4107731	1990-08-26	1990-08-26 00:00:00	38000275	0	\N	\N	221828	0	180256009	4107731	
38104	3364	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	223141	0	180256009	4107731	
38215	3370	4107731	1992-05-17	1992-05-17 00:00:00	38000275	0	\N	\N	223522	0	180256009	4107731	
50335	4376	4078793	2013-01-08	2013-01-08 00:00:00	38000275	0	\N	\N	290782	0	180325003	4078793	
38694	3401	4252419	1965-10-14	1965-10-14 00:00:00	38000275	0	\N	\N	225623	0	74016001	4252419	
26910	2352	4107731	1992-06-22	1992-06-22 00:00:00	38000275	0	\N	\N	156598	0	180256009	4107731	
38958	3437	4163872	1921-03-09	1921-03-09 00:00:00	38000275	0	\N	\N	228019	0	399208008	4163872	
39436	3470	4125906	1988-09-12	1988-09-12 00:00:00	38000275	0	\N	\N	230327	0	288086009	4125906	
27591	2412	4125906	1951-05-21	1951-05-21 00:00:00	38000275	0	\N	\N	160093	0	288086009	4125906	
39718	3495	4125906	1995-10-10	1995-10-10 00:00:00	38000275	0	\N	\N	231815	0	288086009	4125906	
39871	3510	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	232861	0	180256009	4107731	
40163	3527	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	234107	0	180256009	4107731	
40335	3531	4163872	1975-07-15	1975-07-15 00:00:00	38000275	0	\N	\N	234587	0	399208008	4163872	
40396	3540	4125906	2019-06-13	2019-06-13 00:00:00	38000275	0	\N	\N	235125	0	288086009	4125906	
40720	3571	4243062	1983-10-20	1983-10-20 00:00:00	38000275	0	\N	\N	237438	0	60027007	4243062	
40852	3583	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	238245	0	180256009	4107731	
29064	2577	4107731	1992-06-06	1992-06-06 00:00:00	38000275	0	\N	\N	170677	0	180256009	4107731	
41183	3618	4170947	1982-06-20	1982-06-20 00:00:00	38000275	0	\N	\N	240343	0	274474001	4170947	
41439	3638	4024289	2001-01-17	2001-01-17 00:00:00	38000275	0	\N	\N	241968	0	19490002	4024289	
53547	4643	4195803	1978-12-07	1978-12-07 00:00:00	38000275	0	\N	\N	309626	0	312681000	4195803	
41888	3694	4293740	1961-11-05	1961-11-05 00:00:00	38000275	0	\N	\N	245558	0	384700001	4293740	
41975	3699	4125906	1994-10-12	1994-10-12 00:00:00	38000275	0	\N	\N	245928	0	288086009	4125906	
42149	3717	4107731	1992-04-25	1992-04-25 00:00:00	38000275	0	\N	\N	247041	0	180256009	4107731	
54292	4719	4107731	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	314264	0	180256009	4107731	
30661	2711	4107731	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	179722	0	180256009	4107731	
42664	3759	4107731	1990-06-03	1990-06-03 00:00:00	38000275	0	\N	\N	249951	0	180256009	4107731	
42938	3784	4035793	1990-08-07	1990-08-07 00:00:00	38000275	0	\N	\N	251534	0	15081005	4035793	
55012	4781	4151422	2013-09-15	2013-09-15 00:00:00	38000275	0	\N	\N	318302	0	269911007	4151422	
31324	2771	4078793	1999-05-21	1999-05-21 00:00:00	38000275	0	\N	\N	183423	0	180325003	4078793	
43386	3835	4293740	1986-09-17	1986-09-17 00:00:00	38000275	0	\N	\N	254662	0	384700001	4293740	
43742	3865	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	256562	0	180256009	4107731	
55740	4852	4170947	1967-03-26	1967-03-26 00:00:00	38000275	0	\N	\N	322779	0	274474001	4170947	
44115	3884	4043071	1984-08-11	1984-08-11 00:00:00	38000275	0	\N	\N	258175	0	228557008	4043071	
32215	2830	4107731	1991-02-25	1991-02-25 00:00:00	38000275	0	\N	\N	187698	0	180256009	4107731	
56433	4924	4275113	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	327251	0	65200003	4275113	
56544	4927	4295880	2002-03-22	2002-03-22 00:00:00	38000275	0	\N	\N	327534	0	76601001	4295880	
56733	4935	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	328115	0	180256009	4107731	
44957	3949	4170947	1980-01-19	1980-01-19 00:00:00	38000275	0	\N	\N	262519	0	274474001	4170947	
33175	2902	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	193371	0	180256009	4107731	
33421	2921	4337138	1991-08-06	1991-08-06 00:00:00	38000275	0	\N	\N	194718	0	88039007	4337138	
45691	4026	4107731	1990-09-16	1990-09-16 00:00:00	38000275	0	\N	\N	267772	0	180256009	4107731	
57790	5015	4293740	2010-09-25	2010-09-25 00:00:00	38000275	0	\N	\N	333378	0	384700001	4293740	
46040	4045	4151422	1982-03-07	1982-03-07 00:00:00	38000275	0	\N	\N	269040	0	269911007	4151422	
34358	2975	4107731	1992-02-02	1992-02-02 00:00:00	38000275	0	\N	\N	198683	0	180256009	4107731	
34535	2992	4163872	2006-01-02	2006-01-02 00:00:00	38000275	0	\N	\N	199698	0	399208008	4163872	
58561	5068	4024289	2007-11-06	2007-11-06 00:00:00	38000275	0	\N	\N	336993	0	19490002	4024289	
46826	4109	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	273210	0	180256009	4107731	
59069	5117	4107731	1992-12-28	1992-12-28 00:00:00	38000275	0	\N	\N	340149	0	180256009	4107731	
47159	4145	4107731	2008-05-10	2008-05-10 00:00:00	38000275	0	\N	\N	275457	0	180256009	4107731	
59309	5128	4078793	2018-09-26	2018-09-26 00:00:00	38000275	0	\N	\N	340972	0	180325003	4078793	
47511	4167	4107731	1994-08-10	1994-08-10 00:00:00	38000275	0	\N	\N	276984	0	180256009	4107731	
47798	4197	44783196	2009-12-15	2009-12-15 00:00:00	38000275	0	\N	\N	278527	0	699253003	44783196	
24046	2088	4035793	1993-08-17	1993-08-17 00:00:00	38000275	0	\N	\N	139278	0	15081005	4035793	
36238	3176	4107731	2004-10-17	2004-10-17 00:00:00	38000275	0	\N	\N	211207	0	180256009	4107731	
24482	2136	4107731	2004-06-18	2004-06-18 00:00:00	38000275	0	\N	\N	142251	0	180256009	4107731	
36600	3215	4107731	2004-09-18	2004-09-18 00:00:00	38000275	0	\N	\N	213590	0	180256009	4107731	
36799	3236	4078793	2002-03-08	2002-03-08 00:00:00	38000275	0	\N	\N	215043	0	180325003	4078793	
36878	3241	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	215519	0	180256009	4107731	
37180	3270	4043071	1981-12-14	1981-12-14 00:00:00	38000275	0	\N	\N	217261	0	228557008	4043071	
37299	3279	4107731	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	217846	0	180256009	4107731	
37488	3311	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	219793	0	180256009	4107731	
49594	4353	4043071	1978-11-08	1978-11-08 00:00:00	38000275	0	\N	\N	288800	0	228557008	4043071	
37795	3343	4107731	1990-04-22	1990-04-22 00:00:00	38000275	0	\N	\N	221838	0	180256009	4107731	
38105	3364	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	223149	0	180256009	4107731	
38216	3370	4107731	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	223421	0	180256009	4107731	
50336	4376	4035793	2013-01-08	2013-01-08 00:00:00	38000275	0	\N	\N	290782	0	15081005	4035793	
38695	3401	4151422	1982-08-02	1982-08-02 00:00:00	38000275	0	\N	\N	225616	0	269911007	4151422	
26911	2352	4107731	1990-04-16	1990-04-16 00:00:00	38000275	0	\N	\N	156690	0	180256009	4107731	
38959	3437	4125906	1936-03-20	1936-03-20 00:00:00	38000275	0	\N	\N	227923	0	288086009	4125906	
39437	3470	44783196	1998-08-10	1998-08-10 00:00:00	38000275	0	\N	\N	230380	0	699253003	44783196	
27597	2414	4216130	2000-04-27	2000-04-27 00:00:00	38000275	0	\N	\N	160253	0	415070008	4216130	
39719	3495	4125906	1975-05-25	1975-05-25 00:00:00	38000275	0	\N	\N	231812	0	288086009	4125906	
39872	3510	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	232803	0	180256009	4107731	
40164	3527	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	234132	0	180256009	4107731	
40336	3531	4058899	1979-05-25	1979-05-25 00:00:00	38000275	0	\N	\N	234588	0	168594001	4058899	
40397	3540	4151422	1984-05-06	1984-05-06 00:00:00	38000275	0	\N	\N	235134	0	269911007	4151422	
40721	3571	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	237360	0	180256009	4107731	
40853	3583	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	238283	0	180256009	4107731	
29065	2577	4107731	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	170702	0	180256009	4107731	
41187	3621	4035793	1995-06-03	1995-06-03 00:00:00	38000275	0	\N	\N	240598	0	15081005	4035793	
41440	3638	4170947	2001-01-17	2001-01-17 00:00:00	38000275	0	\N	\N	241968	0	274474001	4170947	
53548	4643	4170947	1978-12-07	1978-12-07 00:00:00	38000275	0	\N	\N	309626	0	274474001	4170947	
53680	4655	4107731	1990-06-03	1990-06-03 00:00:00	38000275	0	\N	\N	310311	0	180256009	4107731	
41976	3699	4326177	1999-07-08	1999-07-08 00:00:00	38000275	0	\N	\N	245930	0	430193006	4326177	
42150	3717	4107731	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	246987	0	180256009	4107731	
54293	4719	4107731	1992-02-02	1992-02-02 00:00:00	38000275	0	\N	\N	314173	0	180256009	4107731	
30662	2711	4170947	1979-05-25	1979-05-25 00:00:00	38000275	0	\N	\N	179610	0	274474001	4170947	
42665	3759	4107731	1990-10-28	1990-10-28 00:00:00	38000275	0	\N	\N	249887	0	180256009	4107731	
42939	3784	4035793	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	251463	0	15081005	4035793	
55013	4781	4198190	2002-09-29	2002-09-29 00:00:00	38000275	0	\N	\N	318306	0	80146002	4198190	
31325	2771	4078793	2008-07-11	2008-07-11 00:00:00	38000275	0	\N	\N	183485	0	180325003	4078793	
43387	3836	4163872	2002-05-19	2002-05-19 00:00:00	38000275	0	\N	\N	254723	0	399208008	4163872	
43743	3865	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	256543	0	180256009	4107731	
55741	4853	4151422	2000-07-20	2000-07-20 00:00:00	38000275	0	\N	\N	322927	0	269911007	4151422	
44116	3884	4043071	1990-03-17	1990-03-17 00:00:00	38000275	0	\N	\N	258097	0	228557008	4043071	
32216	2830	4107731	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	187761	0	180256009	4107731	
56434	4924	4107731	1992-05-06	1992-05-06 00:00:00	38000275	0	\N	\N	327266	0	180256009	4107731	
56545	4927	4151422	2016-12-09	2016-12-09 00:00:00	38000275	0	\N	\N	327496	0	269911007	4151422	
56734	4935	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	328109	0	180256009	4107731	
44958	3949	4047491	1980-01-19	1980-01-19 00:00:00	38000275	0	\N	\N	262519	0	1225002	4047491	
33176	2902	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	193335	0	180256009	4107731	
33422	2921	4035793	1997-07-29	1997-07-29 00:00:00	38000275	0	\N	\N	194741	0	15081005	4035793	
45692	4026	4107731	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	267689	0	180256009	4107731	
57791	5015	4058899	1970-11-21	1970-11-21 00:00:00	38000275	0	\N	\N	333373	0	168594001	4058899	
46041	4045	4151422	1988-02-25	1988-02-25 00:00:00	38000275	0	\N	\N	269015	0	269911007	4151422	
34359	2975	4107731	1991-08-18	1991-08-18 00:00:00	38000275	0	\N	\N	198668	0	180256009	4107731	
34536	2992	4195803	2012-05-17	2012-05-17 00:00:00	38000275	0	\N	\N	199768	0	312681000	4195803	
58562	5068	4195803	2007-11-06	2007-11-06 00:00:00	38000275	0	\N	\N	336993	0	312681000	4195803	
46827	4109	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	273202	0	180256009	4107731	
59070	5117	4107731	1992-01-06	1992-01-06 00:00:00	38000275	0	\N	\N	340064	0	180256009	4107731	
47160	4145	4107731	2006-10-21	2006-10-21 00:00:00	38000275	0	\N	\N	275535	0	180256009	4107731	
59310	5128	4057420	1955-07-27	1955-07-27 00:00:00	38000275	0	\N	\N	340918	0	18286008	4057420	
47512	4167	4107731	1994-07-20	1994-07-20 00:00:00	38000275	0	\N	\N	276947	0	180256009	4107731	
47799	4197	4186930	2007-09-02	2007-09-02 00:00:00	38000275	0	\N	\N	278502	0	46706006	4186930	
24047	2088	4035793	2006-07-11	2006-07-11 00:00:00	38000275	0	\N	\N	139281	0	15081005	4035793	
36239	3176	4107731	2003-10-05	2003-10-05 00:00:00	38000275	0	\N	\N	211180	0	180256009	4107731	
24483	2136	4107731	2002-08-16	2002-08-16 00:00:00	38000275	0	\N	\N	142242	0	180256009	4107731	
36601	3215	4107731	2003-04-12	2003-04-12 00:00:00	38000275	0	\N	\N	213565	0	180256009	4107731	
36800	3236	4078793	1998-02-13	1998-02-13 00:00:00	38000275	0	\N	\N	215041	0	180325003	4078793	
36879	3241	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	215500	0	180256009	4107731	
37181	3270	4043071	1986-09-22	1986-09-22 00:00:00	38000275	0	\N	\N	217295	0	228557008	4043071	
37300	3279	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	217865	0	180256009	4107731	
37489	3311	4125906	1965-11-13	1965-11-13 00:00:00	38000275	0	\N	\N	219796	0	288086009	4125906	
49595	4353	4043071	1980-04-30	1980-04-30 00:00:00	38000275	0	\N	\N	288778	0	228557008	4043071	
37796	3343	4107731	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	221716	0	180256009	4107731	
38106	3364	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	223114	0	180256009	4107731	
38217	3370	4107731	1991-01-20	1991-01-20 00:00:00	38000275	0	\N	\N	223497	0	180256009	4107731	
50337	4376	4035793	1990-09-04	1990-09-04 00:00:00	38000275	0	\N	\N	290800	0	15081005	4035793	
50491	4390	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	291818	0	180256009	4107731	
26912	2352	4062501	1972-11-01	1972-11-01 00:00:00	38000275	0	\N	\N	156644	0	171231001	4062501	
38960	3438	4163872	1977-08-11	1977-08-11 00:00:00	38000275	0	\N	\N	228116	0	399208008	4163872	
39438	3470	4252419	1998-08-03	1998-08-03 00:00:00	38000275	0	\N	\N	230329	0	74016001	4252419	
27598	2414	4336464	2000-04-27	2000-04-27 00:00:00	38000275	0	\N	\N	160253	0	232717009	4336464	
39720	3495	4125906	1981-05-14	1981-05-14 00:00:00	38000275	0	\N	\N	231813	0	288086009	4125906	
39873	3510	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	232934	0	180256009	4107731	
40165	3527	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	234077	0	180256009	4107731	
40337	3531	4058899	1969-01-17	1969-01-17 00:00:00	38000275	0	\N	\N	234586	0	168594001	4058899	
40398	3541	4125906	1978-12-07	1978-12-07 00:00:00	38000275	0	\N	\N	235214	0	288086009	4125906	
40722	3571	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	237303	0	180256009	4107731	
40854	3583	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	238248	0	180256009	4107731	
29066	2577	4107731	1992-12-12	1992-12-12 00:00:00	38000275	0	\N	\N	170638	0	180256009	4107731	
41188	3621	4035793	1991-05-11	1991-05-11 00:00:00	38000275	0	\N	\N	240646	0	15081005	4035793	
41441	3639	4078793	2004-11-06	2004-11-06 00:00:00	38000275	0	\N	\N	242056	0	180325003	4078793	
53549	4643	4151422	1913-05-27	1913-05-27 00:00:00	38000275	0	\N	\N	309606	0	269911007	4151422	
53681	4655	4107731	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	310387	0	180256009	4107731	
41977	3699	4037675	1999-07-08	1999-07-08 00:00:00	38000275	0	\N	\N	245930	0	162676008	4037675	
42151	3717	4107731	1991-10-19	1991-10-19 00:00:00	38000275	0	\N	\N	246962	0	180256009	4107731	
54294	4719	4107731	1992-06-28	1992-06-28 00:00:00	38000275	0	\N	\N	314281	0	180256009	4107731	
30663	2711	4047491	1979-05-25	1979-05-25 00:00:00	38000275	0	\N	\N	179610	0	1225002	4047491	
42666	3759	4107731	1990-12-09	1990-12-09 00:00:00	38000275	0	\N	\N	249888	0	180256009	4107731	
42940	3784	4337138	1986-10-07	1986-10-07 00:00:00	38000275	0	\N	\N	251498	0	88039007	4337138	
55014	4782	4295880	2004-09-07	2004-09-07 00:00:00	38000275	0	\N	\N	318360	0	76601001	4295880	
31326	2771	4078793	2001-06-01	2001-06-01 00:00:00	38000275	0	\N	\N	183424	0	180325003	4078793	
43388	3836	4125906	1984-10-23	1984-10-23 00:00:00	38000275	0	\N	\N	254748	0	288086009	4125906	
43744	3865	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	256627	0	180256009	4107731	
55742	4853	4125906	1978-04-15	1978-04-15 00:00:00	38000275	0	\N	\N	322912	0	288086009	4125906	
44117	3884	4043071	1985-07-13	1985-07-13 00:00:00	38000275	0	\N	\N	258107	0	228557008	4043071	
32217	2830	4107731	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	187808	0	180256009	4107731	
56435	4924	4107731	1993-12-15	1993-12-15 00:00:00	38000275	0	\N	\N	327248	0	180256009	4107731	
56546	4927	4295880	2003-12-19	2003-12-19 00:00:00	38000275	0	\N	\N	327531	0	76601001	4295880	
56735	4935	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	328113	0	180256009	4107731	
44959	3949	4043071	1977-11-22	1977-11-22 00:00:00	38000275	0	\N	\N	262444	0	228557008	4043071	
33177	2902	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	193337	0	180256009	4107731	
33423	2921	4035793	2004-09-07	2004-09-07 00:00:00	38000275	0	\N	\N	194748	0	15081005	4035793	
45693	4026	4107731	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	267744	0	180256009	4107731	
57792	5015	4125906	2002-05-19	2002-05-19 00:00:00	38000275	0	\N	\N	333377	0	288086009	4125906	
46043	4049	4047491	1979-11-24	1979-11-24 00:00:00	38000275	0	\N	\N	269137	0	1225002	4047491	
34360	2975	4198190	1975-04-06	1975-04-06 00:00:00	38000275	0	\N	\N	198629	0	80146002	4198190	
34537	2992	4170947	2012-05-17	2012-05-17 00:00:00	38000275	0	\N	\N	199768	0	274474001	4170947	
58563	5068	4170947	2007-11-06	2007-11-06 00:00:00	38000275	0	\N	\N	336993	0	274474001	4170947	
46828	4109	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	273150	0	180256009	4107731	
59071	5117	4107731	1993-01-18	1993-01-18 00:00:00	38000275	0	\N	\N	340041	0	180256009	4107731	
47161	4145	4107731	2009-10-17	2009-10-17 00:00:00	38000275	0	\N	\N	275526	0	180256009	4107731	
59311	5128	40492359	1955-07-27	1955-07-27 00:00:00	38000275	0	\N	\N	340918	0	447365002	40492359	
47513	4167	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	276942	0	180256009	4107731	
47800	4197	4275113	2002-08-31	2002-08-31 00:00:00	38000275	0	\N	\N	278498	0	65200003	4275113	
24048	2088	4035793	1995-05-09	1995-05-09 00:00:00	38000275	0	\N	\N	139279	0	15081005	4035793	
36240	3176	4107731	2005-03-13	2005-03-13 00:00:00	38000275	0	\N	\N	211188	0	180256009	4107731	
24484	2136	4107731	2003-04-04	2003-04-04 00:00:00	38000275	0	\N	\N	142263	0	180256009	4107731	
36602	3215	4107731	2005-04-16	2005-04-16 00:00:00	38000275	0	\N	\N	213651	0	180256009	4107731	
36801	3236	4078793	1991-01-04	1991-01-04 00:00:00	38000275	0	\N	\N	215094	0	180325003	4078793	
36880	3241	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	215481	0	180256009	4107731	
37182	3270	4043071	1981-07-27	1981-07-27 00:00:00	38000275	0	\N	\N	217248	0	228557008	4043071	
37301	3279	4024289	1974-08-14	1974-08-14 00:00:00	38000275	0	\N	\N	217920	0	19490002	4024289	
37490	3311	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	219825	0	180256009	4107731	
49596	4353	4043071	1977-05-04	1977-05-04 00:00:00	38000275	0	\N	\N	288797	0	228557008	4043071	
37797	3343	4043071	1986-05-27	1986-05-27 00:00:00	38000275	0	\N	\N	221810	0	228557008	4043071	
38107	3364	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	223032	0	180256009	4107731	
38218	3370	4107731	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	223503	0	180256009	4107731	
50338	4376	4057420	1990-09-04	1990-09-04 00:00:00	38000275	0	\N	\N	290800	0	18286008	4057420	
50492	4390	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	291892	0	395142003	4191853	
26913	2352	4107731	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	156691	0	180256009	4107731	
38961	3438	4195803	1989-06-17	1989-06-17 00:00:00	38000275	0	\N	\N	228104	0	312681000	4195803	
39439	3470	4125906	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	230328	0	288086009	4125906	
27599	2414	4057420	1994-08-18	1994-08-18 00:00:00	38000275	0	\N	\N	160263	0	18286008	4057420	
39721	3495	4293740	1981-05-14	1981-05-14 00:00:00	38000275	0	\N	\N	231813	0	384700001	4293740	
39874	3510	4151422	1975-08-05	1975-08-05 00:00:00	38000275	0	\N	\N	232913	0	269911007	4151422	
40166	3527	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	234057	0	180256009	4107731	
40338	3532	4145310	1986-12-15	1986-12-15 00:00:00	38000275	0	\N	\N	234629	0	268425006	4145310	
40399	3542	4125906	1993-01-14	1993-01-14 00:00:00	38000275	0	\N	\N	235323	0	288086009	4125906	
40723	3571	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	237404	0	180256009	4107731	
40855	3583	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	238267	0	180256009	4107731	
29067	2577	4107731	1990-03-31	1990-03-31 00:00:00	38000275	0	\N	\N	170621	0	180256009	4107731	
41189	3621	4035793	1988-10-22	1988-10-22 00:00:00	38000275	0	\N	\N	240656	0	15081005	4035793	
41442	3639	4078793	2004-01-31	2004-01-31 00:00:00	38000275	0	\N	\N	242079	0	180325003	4078793	
53550	4643	4125906	1914-02-04	1914-02-04 00:00:00	38000275	0	\N	\N	309567	0	288086009	4125906	
53682	4655	4107731	1990-07-15	1990-07-15 00:00:00	38000275	0	\N	\N	310397	0	180256009	4107731	
41978	3699	4187458	1999-07-08	1999-07-08 00:00:00	38000275	0	\N	\N	245930	0	415300000	4187458	
42152	3717	4107731	1991-05-04	1991-05-04 00:00:00	38000275	0	\N	\N	247036	0	180256009	4107731	
54295	4719	4107731	1993-02-14	1993-02-14 00:00:00	38000275	0	\N	\N	314283	0	180256009	4107731	
30664	2711	4107731	1990-03-05	1990-03-05 00:00:00	38000275	0	\N	\N	179686	0	180256009	4107731	
42667	3759	4107731	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	249949	0	180256009	4107731	
42941	3784	4125906	1952-08-02	1952-08-02 00:00:00	38000275	0	\N	\N	251489	0	288086009	4125906	
55015	4782	4295880	2004-06-08	2004-06-08 00:00:00	38000275	0	\N	\N	318310	0	76601001	4295880	
31327	2771	4078793	2012-08-03	2012-08-03 00:00:00	38000275	0	\N	\N	183463	0	180325003	4078793	
43389	3836	4151422	1987-11-17	1987-11-17 00:00:00	38000275	0	\N	\N	254737	0	269911007	4151422	
43745	3865	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	256592	0	180256009	4107731	
55743	4853	4151422	1995-03-18	1995-03-18 00:00:00	38000275	0	\N	\N	322885	0	269911007	4151422	
44118	3884	4107731	1991-03-18	1991-03-18 00:00:00	38000275	0	\N	\N	258207	0	180256009	4107731	
32218	2830	4107731	1991-01-14	1991-01-14 00:00:00	38000275	0	\N	\N	187697	0	180256009	4107731	
56436	4924	4107731	1991-01-09	1991-01-09 00:00:00	38000275	0	\N	\N	327152	0	180256009	4107731	
56547	4927	4295880	2004-09-17	2004-09-17 00:00:00	38000275	0	\N	\N	327532	0	76601001	4295880	
56736	4935	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	328067	0	180256009	4107731	
44960	3949	4043071	1979-01-30	1979-01-30 00:00:00	38000275	0	\N	\N	262493	0	228557008	4043071	
33178	2902	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	193346	0	180256009	4107731	
33424	2921	4035793	2003-09-02	2003-09-02 00:00:00	38000275	0	\N	\N	194760	0	15081005	4035793	
45694	4026	4107731	1990-08-05	1990-08-05 00:00:00	38000275	0	\N	\N	267737	0	180256009	4107731	
57793	5015	4125906	1991-04-26	1991-04-26 00:00:00	38000275	0	\N	\N	333376	0	288086009	4125906	
46044	4049	4170947	1979-11-24	1979-11-24 00:00:00	38000275	0	\N	\N	269137	0	274474001	4170947	
34361	2975	4107731	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	198607	0	180256009	4107731	
34538	2992	4024289	2012-05-17	2012-05-17 00:00:00	38000275	0	\N	\N	199768	0	19490002	4024289	
58573	5073	4057420	2004-07-31	2004-07-31 00:00:00	38000275	0	\N	\N	337216	0	18286008	4057420	
46829	4109	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	273094	0	180256009	4107731	
59072	5117	4107731	1990-04-16	1990-04-16 00:00:00	38000275	0	\N	\N	340022	0	180256009	4107731	
47162	4145	4191853	2006-07-29	2006-07-29 00:00:00	38000275	0	\N	\N	275533	0	395142003	4191853	
59314	5132	4058899	1979-09-29	1979-09-29 00:00:00	38000275	0	\N	\N	341106	0	168594001	4058899	
47514	4167	4107731	1994-06-29	1994-06-29 00:00:00	38000275	0	\N	\N	276975	0	180256009	4107731	
47801	4197	4243062	1997-03-16	1997-03-16 00:00:00	38000275	0	\N	\N	278525	0	60027007	4243062	
24049	2088	4035793	2014-07-15	2014-07-15 00:00:00	38000275	0	\N	\N	139291	0	15081005	4035793	
36241	3176	4202451	2014-01-04	2014-01-04 00:00:00	38000275	0	\N	\N	211121	0	433112001	4202451	
24485	2136	4107731	2004-07-30	2004-07-30 00:00:00	38000275	0	\N	\N	142290	0	180256009	4107731	
36603	3215	4107731	2005-01-22	2005-01-22 00:00:00	38000275	0	\N	\N	213662	0	180256009	4107731	
36802	3236	4170947	1930-07-28	1930-07-28 00:00:00	38000275	0	\N	\N	215026	0	274474001	4170947	
36881	3241	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	215508	0	180256009	4107731	
37183	3270	4043071	1985-09-02	1985-09-02 00:00:00	38000275	0	\N	\N	217274	0	228557008	4043071	
37302	3279	4170947	1974-08-14	1974-08-14 00:00:00	38000275	0	\N	\N	217920	0	274474001	4170947	
37491	3311	4125906	2011-09-18	2011-09-18 00:00:00	38000275	0	\N	\N	219835	0	288086009	4125906	
49597	4353	4043071	1980-07-02	1980-07-02 00:00:00	38000275	0	\N	\N	288747	0	228557008	4043071	
37798	3343	4107731	1991-06-16	1991-06-16 00:00:00	38000275	0	\N	\N	221727	0	180256009	4107731	
38108	3364	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	223121	0	180256009	4107731	
38219	3370	4107731	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	223505	0	180256009	4107731	
50339	4376	4078793	2019-02-12	2019-02-12 00:00:00	38000275	0	\N	\N	290759	0	180325003	4078793	
50493	4390	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	291795	0	180256009	4107731	
26914	2352	4107731	1991-11-25	1991-11-25 00:00:00	38000275	0	\N	\N	156667	0	180256009	4107731	
38962	3438	4163872	1924-06-27	1924-06-27 00:00:00	38000275	0	\N	\N	228133	0	399208008	4163872	
39450	3477	4043071	1972-07-01	1972-07-01 00:00:00	38000275	0	\N	\N	230688	0	228557008	4043071	
27600	2414	4078793	1998-09-10	1998-09-10 00:00:00	38000275	0	\N	\N	160265	0	180325003	4078793	
39729	3501	4125906	2017-12-27	2017-12-27 00:00:00	38000275	0	\N	\N	232063	0	288086009	4125906	
39875	3510	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	232941	0	180256009	4107731	
40167	3527	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	234114	0	180256009	4107731	
40339	3532	4047491	1977-07-05	1977-07-05 00:00:00	38000275	0	\N	\N	234628	0	1225002	4047491	
40400	3542	4195803	2017-09-23	2017-09-23 00:00:00	38000275	0	\N	\N	235247	0	312681000	4195803	
40724	3571	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	237322	0	395142003	4191853	
40856	3583	4191853	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	238256	0	395142003	4191853	
29068	2577	4107731	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	170631	0	180256009	4107731	
41190	3621	4170947	1929-08-03	1929-08-03 00:00:00	38000275	0	\N	\N	240657	0	274474001	4170947	
41443	3639	4078793	2007-07-07	2007-07-07 00:00:00	38000275	0	\N	\N	242080	0	180325003	4078793	
53551	4643	4170947	1946-05-01	1946-05-01 00:00:00	38000275	0	\N	\N	309571	0	274474001	4170947	
53683	4655	4107731	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	310328	0	180256009	4107731	
41979	3700	4198190	2011-08-22	2011-08-22 00:00:00	38000275	0	\N	\N	245974	0	80146002	4198190	
42153	3717	4107731	1990-06-23	1990-06-23 00:00:00	38000275	0	\N	\N	247021	0	180256009	4107731	
54296	4719	4107731	1990-08-26	1990-08-26 00:00:00	38000275	0	\N	\N	314292	0	180256009	4107731	
30665	2711	4107731	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	179759	0	180256009	4107731	
42668	3759	4107731	1993-04-18	1993-04-18 00:00:00	38000275	0	\N	\N	249908	0	180256009	4107731	
42942	3784	4170947	1945-07-19	1945-07-19 00:00:00	38000275	0	\N	\N	251487	0	274474001	4170947	
55016	4782	4295880	2006-06-06	2006-06-06 00:00:00	38000275	0	\N	\N	318320	0	76601001	4295880	
31328	2771	4078793	1983-02-18	1983-02-18 00:00:00	38000275	0	\N	\N	183480	0	180325003	4078793	
43390	3836	4058899	1986-10-04	1986-10-04 00:00:00	38000275	0	\N	\N	254749	0	168594001	4058899	
43746	3866	4125906	1968-04-30	1968-04-30 00:00:00	38000275	0	\N	\N	256700	0	288086009	4125906	
55746	4855	4170947	1987-02-20	1987-02-20 00:00:00	38000275	0	\N	\N	323022	0	274474001	4170947	
44119	3884	4107731	1992-07-13	1992-07-13 00:00:00	38000275	0	\N	\N	258187	0	180256009	4107731	
32219	2830	4107731	1992-01-06	1992-01-06 00:00:00	38000275	0	\N	\N	187702	0	180256009	4107731	
56437	4924	4107731	1992-03-25	1992-03-25 00:00:00	38000275	0	\N	\N	327265	0	180256009	4107731	
56548	4927	4295880	2004-03-19	2004-03-19 00:00:00	38000275	0	\N	\N	327516	0	76601001	4295880	
56737	4935	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	328054	0	180256009	4107731	
44961	3949	4043071	1978-10-31	1978-10-31 00:00:00	38000275	0	\N	\N	262481	0	228557008	4043071	
33179	2902	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	193340	0	180256009	4107731	
33425	2921	4035793	2002-08-27	2002-08-27 00:00:00	38000275	0	\N	\N	194747	0	15081005	4035793	
45695	4026	4107731	1990-12-09	1990-12-09 00:00:00	38000275	0	\N	\N	267727	0	180256009	4107731	
57794	5015	4125906	1982-05-22	1982-05-22 00:00:00	38000275	0	\N	\N	333374	0	288086009	4125906	
46045	4049	4125906	1999-06-10	1999-06-10 00:00:00	38000275	0	\N	\N	269140	0	288086009	4125906	
34362	2975	4107731	1991-02-10	1991-02-10 00:00:00	38000275	0	\N	\N	198616	0	180256009	4107731	
34539	2993	4125906	2017-01-19	2017-01-19 00:00:00	38000275	0	\N	\N	199831	0	288086009	4125906	
58574	5073	4078793	2011-09-10	2011-09-10 00:00:00	38000275	0	\N	\N	337183	0	180325003	4078793	
46830	4109	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	273099	0	180256009	4107731	
59073	5117	4107731	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	340123	0	180256009	4107731	
47163	4145	4107731	2008-12-06	2008-12-06 00:00:00	38000275	0	\N	\N	275522	0	180256009	4107731	
59315	5132	4170947	1973-03-04	1973-03-04 00:00:00	38000275	0	\N	\N	341105	0	274474001	4170947	
47515	4167	4238715	1997-09-24	1997-09-24 00:00:00	38000275	0	\N	\N	276993	0	68254000	4238715	
47802	4197	4170947	1997-03-16	1997-03-16 00:00:00	38000275	0	\N	\N	278525	0	274474001	4170947	
24050	2088	4035793	1996-05-14	1996-05-14 00:00:00	38000275	0	\N	\N	139239	0	15081005	4035793	
36242	3176	4107731	2003-12-07	2003-12-07 00:00:00	38000275	0	\N	\N	211135	0	180256009	4107731	
24486	2136	4107731	2002-02-08	2002-02-08 00:00:00	38000275	0	\N	\N	142241	0	180256009	4107731	
36604	3216	4125906	1961-08-14	1961-08-14 00:00:00	38000275	0	\N	\N	213706	0	288086009	4125906	
36803	3236	4047491	1930-07-28	1930-07-28 00:00:00	38000275	0	\N	\N	215026	0	1225002	4047491	
36882	3241	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	215571	0	180256009	4107731	
37184	3270	4043071	1982-03-15	1982-03-15 00:00:00	38000275	0	\N	\N	217304	0	228557008	4043071	
37303	3279	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	217815	0	180256009	4107731	
37492	3311	4151422	1981-02-18	1981-02-18 00:00:00	38000275	0	\N	\N	219799	0	269911007	4151422	
49598	4353	4043071	1979-02-21	1979-02-21 00:00:00	38000275	0	\N	\N	288776	0	228557008	4043071	
37799	3343	4197460	1977-07-01	1977-07-01 00:00:00	38000275	0	\N	\N	221859	0	313191000	4197460	
38109	3364	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	223037	0	180256009	4107731	
38220	3370	4197460	1977-01-31	1977-01-31 00:00:00	38000275	0	\N	\N	223391	0	313191000	4197460	
50340	4376	4035793	2019-02-12	2019-02-12 00:00:00	38000275	0	\N	\N	290759	0	15081005	4035793	
50494	4390	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	291825	0	180256009	4107731	
26915	2352	4107731	1992-10-05	1992-10-05 00:00:00	38000275	0	\N	\N	156671	0	180256009	4107731	
38963	3438	4170947	1924-06-27	1924-06-27 00:00:00	38000275	0	\N	\N	228133	0	274474001	4170947	
39451	3477	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	230617	0	180256009	4107731	
27601	2414	4078793	1996-08-29	1996-08-29 00:00:00	38000275	0	\N	\N	160264	0	180325003	4078793	
39730	3501	4243062	1994-03-19	1994-03-19 00:00:00	38000275	0	\N	\N	232060	0	60027007	4243062	
39876	3510	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	232807	0	180256009	4107731	
40168	3527	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	234110	0	180256009	4107731	
40340	3532	4170947	1977-07-05	1977-07-05 00:00:00	38000275	0	\N	\N	234628	0	274474001	4170947	
40401	3542	4125906	1950-11-21	1950-11-21 00:00:00	38000275	0	\N	\N	235238	0	288086009	4125906	
40725	3571	4197460	1972-12-16	1972-12-16 00:00:00	38000275	0	\N	\N	237407	0	313191000	4197460	
40857	3583	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	238251	0	180256009	4107731	
29069	2577	4107731	1990-06-02	1990-06-02 00:00:00	38000275	0	\N	\N	170608	0	180256009	4107731	
41191	3621	4047491	1929-08-03	1929-08-03 00:00:00	38000275	0	\N	\N	240657	0	1225002	4047491	
41444	3639	4078793	2005-01-29	2005-01-29 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
53552	4643	4024289	1946-05-01	1946-05-01 00:00:00	38000275	0	\N	\N	309571	0	19490002	4024289	
53684	4655	4107731	1991-12-22	1991-12-22 00:00:00	38000275	0	\N	\N	310291	0	180256009	4107731	
41980	3700	4243062	1970-06-11	1970-06-11 00:00:00	38000275	0	\N	\N	245971	0	60027007	4243062	
42154	3717	4107731	1992-06-27	1992-06-27 00:00:00	38000275	0	\N	\N	246974	0	180256009	4107731	
54297	4719	4107731	1991-09-08	1991-09-08 00:00:00	38000275	0	\N	\N	314270	0	180256009	4107731	
30666	2711	4107731	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	179763	0	180256009	4107731	
42675	3761	4252419	1994-08-28	1994-08-28 00:00:00	38000275	0	\N	\N	250043	0	74016001	4252419	
42943	3784	4163872	1945-07-19	1945-07-19 00:00:00	38000275	0	\N	\N	251487	0	399208008	4163872	
55017	4782	4295880	2007-03-06	2007-03-06 00:00:00	38000275	0	\N	\N	318361	0	76601001	4295880	
31329	2771	4078793	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	183421	0	180325003	4078793	
43396	3839	4047491	2012-05-26	2012-05-26 00:00:00	38000275	0	\N	\N	254863	0	1225002	4047491	
43747	3866	4293740	1968-04-30	1968-04-30 00:00:00	38000275	0	\N	\N	256700	0	384700001	4293740	
55747	4855	4163872	1987-02-20	1987-02-20 00:00:00	38000275	0	\N	\N	323022	0	399208008	4163872	
44120	3884	4043071	1984-05-19	1984-05-19 00:00:00	38000275	0	\N	\N	258038	0	228557008	4043071	
32220	2830	4107731	1991-11-04	1991-11-04 00:00:00	38000275	0	\N	\N	187727	0	180256009	4107731	
56438	4924	4293740	1991-06-02	1991-06-02 00:00:00	38000275	0	\N	\N	327220	0	384700001	4293740	
56549	4927	4295880	1998-09-25	1998-09-25 00:00:00	38000275	0	\N	\N	327444	0	76601001	4295880	
56738	4935	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	328106	0	180256009	4107731	
44962	3949	4043071	1977-08-23	1977-08-23 00:00:00	38000275	0	\N	\N	262478	0	228557008	4043071	
33180	2902	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	193348	0	180256009	4107731	
33426	2921	4035793	1987-05-26	1987-05-26 00:00:00	38000275	0	\N	\N	194765	0	15081005	4035793	
45696	4026	4170947	1962-11-01	1962-11-01 00:00:00	38000275	0	\N	\N	267690	0	274474001	4170947	
57795	5017	4163872	1996-09-16	1996-09-16 00:00:00	38000275	0	\N	\N	333438	0	399208008	4163872	
46046	4049	4125906	1974-08-08	1974-08-08 00:00:00	38000275	0	\N	\N	269136	0	288086009	4125906	
34363	2975	4107731	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	198689	0	180256009	4107731	
34540	2993	4125906	1989-02-03	1989-02-03 00:00:00	38000275	0	\N	\N	199828	0	288086009	4125906	
58575	5073	4057420	2008-08-23	2008-08-23 00:00:00	38000275	0	\N	\N	337174	0	18286008	4057420	
46831	4109	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	273216	0	180256009	4107731	
59074	5117	4107731	1992-10-26	1992-10-26 00:00:00	38000275	0	\N	\N	340081	0	180256009	4107731	
47164	4145	4191853	2006-07-29	2006-07-29 00:00:00	38000275	0	\N	\N	275533	0	395142003	4191853	
59316	5132	4047491	1973-03-04	1973-03-04 00:00:00	38000275	0	\N	\N	341105	0	1225002	4047491	
47603	4173	4243062	1973-03-24	1973-03-24 00:00:00	38000275	0	\N	\N	277373	0	60027007	4243062	
47803	4197	4238715	2007-12-16	2007-12-16 00:00:00	38000275	0	\N	\N	278494	0	68254000	4238715	
24051	2088	4035793	1983-06-21	1983-06-21 00:00:00	38000275	0	\N	\N	139170	0	15081005	4035793	
36243	3176	4107731	2002-11-03	2002-11-03 00:00:00	38000275	0	\N	\N	211112	0	180256009	4107731	
24487	2136	4107731	2002-06-14	2002-06-14 00:00:00	38000275	0	\N	\N	142221	0	180256009	4107731	
36605	3216	4151422	1959-10-26	1959-10-26 00:00:00	38000275	0	\N	\N	213750	0	269911007	4151422	
36804	3236	4170947	2013-10-09	2013-10-09 00:00:00	38000275	0	\N	\N	215033	0	274474001	4170947	
36883	3241	4058899	1965-03-09	1965-03-09 00:00:00	38000275	0	\N	\N	215439	0	168594001	4058899	
37185	3270	4043071	1985-12-30	1985-12-30 00:00:00	38000275	0	\N	\N	217276	0	228557008	4043071	
37304	3279	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	217910	0	180256009	4107731	
37493	3311	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	219800	0	180256009	4107731	
49599	4353	4043071	1980-01-16	1980-01-16 00:00:00	38000275	0	\N	\N	288805	0	228557008	4043071	
37800	3343	4107731	1991-05-05	1991-05-05 00:00:00	38000275	0	\N	\N	221869	0	180256009	4107731	
38110	3364	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	223117	0	180256009	4107731	
38221	3370	4107731	1993-05-09	1993-05-09 00:00:00	38000275	0	\N	\N	223527	0	180256009	4107731	
50341	4376	4035793	2018-02-06	2018-02-06 00:00:00	38000275	0	\N	\N	290829	0	15081005	4035793	
50495	4390	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	291848	0	180256009	4107731	
26916	2352	4107731	1990-05-07	1990-05-07 00:00:00	38000275	0	\N	\N	156704	0	180256009	4107731	
38964	3438	4163872	1934-09-03	1934-09-03 00:00:00	38000275	0	\N	\N	228134	0	399208008	4163872	
39452	3477	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	230603	0	180256009	4107731	
27602	2414	4058899	1933-04-29	1933-04-29 00:00:00	38000275	0	\N	\N	160249	0	168594001	4058899	
39731	3501	4170947	1994-03-19	1994-03-19 00:00:00	38000275	0	\N	\N	232060	0	274474001	4170947	
39877	3510	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	232862	0	180256009	4107731	
40169	3527	4151422	1987-09-13	1987-09-13 00:00:00	38000275	0	\N	\N	234053	0	269911007	4151422	
40341	3533	4125906	2000-04-18	2000-04-18 00:00:00	38000275	0	\N	\N	234720	0	288086009	4125906	
40402	3542	4195803	2010-07-03	2010-07-03 00:00:00	38000275	0	\N	\N	235326	0	312681000	4195803	
40726	3571	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	237372	0	180256009	4107731	
40858	3583	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	238224	0	180256009	4107731	
29070	2577	4107731	1990-01-27	1990-01-27 00:00:00	38000275	0	\N	\N	170651	0	180256009	4107731	
41192	3621	4035793	1994-05-28	1994-05-28 00:00:00	38000275	0	\N	\N	240606	0	15081005	4035793	
41445	3639	4151422	1998-06-27	1998-06-27 00:00:00	38000275	0	\N	\N	242161	0	269911007	4151422	
53553	4643	4170947	1940-08-30	1940-08-30 00:00:00	38000275	0	\N	\N	309569	0	274474001	4170947	
53685	4655	4107731	1990-12-30	1990-12-30 00:00:00	38000275	0	\N	\N	310271	0	180256009	4107731	
41981	3700	4170947	1970-06-11	1970-06-11 00:00:00	38000275	0	\N	\N	245971	0	274474001	4170947	
42155	3717	4107731	1990-03-10	1990-03-10 00:00:00	38000275	0	\N	\N	247067	0	180256009	4107731	
54298	4719	4107731	1992-02-23	1992-02-23 00:00:00	38000275	0	\N	\N	314278	0	180256009	4107731	
30667	2711	4107731	1992-03-30	1992-03-30 00:00:00	38000275	0	\N	\N	179756	0	180256009	4107731	
42676	3761	4010253	1980-10-08	1980-10-08 00:00:00	38000275	0	\N	\N	250097	0	112790001	4010253	
42944	3784	4035793	1989-08-01	1989-08-01 00:00:00	38000275	0	\N	\N	251462	0	15081005	4035793	
55018	4782	4295880	2006-03-07	2006-03-07 00:00:00	38000275	0	\N	\N	318327	0	76601001	4295880	
31330	2771	4078793	2013-08-09	2013-08-09 00:00:00	38000275	0	\N	\N	183513	0	180325003	4078793	
43397	3839	4195803	2012-05-26	2012-05-26 00:00:00	38000275	0	\N	\N	254863	0	312681000	4195803	
43748	3866	4058899	1964-08-19	1964-08-19 00:00:00	38000275	0	\N	\N	256760	0	168594001	4058899	
55760	4859	4151422	1956-08-29	1956-08-29 00:00:00	38000275	0	\N	\N	323199	0	269911007	4151422	
44121	3884	4043071	1988-07-23	1988-07-23 00:00:00	38000275	0	\N	\N	258135	0	228557008	4043071	
32221	2830	4107731	1992-07-13	1992-07-13 00:00:00	38000275	0	\N	\N	187799	0	180256009	4107731	
56439	4924	4125906	1991-06-02	1991-06-02 00:00:00	38000275	0	\N	\N	327220	0	288086009	4125906	
56550	4927	4295880	2002-12-20	2002-12-20 00:00:00	38000275	0	\N	\N	327536	0	76601001	4295880	
56739	4935	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	328090	0	180256009	4107731	
44963	3949	4043071	1978-02-21	1978-02-21 00:00:00	38000275	0	\N	\N	262457	0	228557008	4043071	
33181	2902	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	193376	0	180256009	4107731	
33427	2921	4035793	2011-10-18	2011-10-18 00:00:00	38000275	0	\N	\N	194706	0	15081005	4035793	
45697	4026	4243062	1962-11-01	1962-11-01 00:00:00	38000275	0	\N	\N	267690	0	60027007	4243062	
57796	5018	4151422	2009-08-27	2009-08-27 00:00:00	38000275	0	\N	\N	333511	0	269911007	4151422	
46047	4051	4191853	1979-02-12	1979-02-12 00:00:00	38000275	0	\N	\N	269265	0	395142003	4191853	
34364	2975	4107731	1993-02-14	1993-02-14 00:00:00	38000275	0	\N	\N	198597	0	180256009	4107731	
34544	2997	4295880	1998-03-29	1998-03-29 00:00:00	38000275	0	\N	\N	199930	0	76601001	4295880	
58576	5073	4078793	2010-02-27	2010-02-27 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
46832	4109	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	273088	0	180256009	4107731	
59075	5117	4107731	1990-07-09	1990-07-09 00:00:00	38000275	0	\N	\N	340024	0	180256009	4107731	
47165	4145	4107731	2009-01-17	2009-01-17 00:00:00	38000275	0	\N	\N	275523	0	180256009	4107731	
59317	5132	4170947	2014-05-03	2014-05-03 00:00:00	38000275	0	\N	\N	341170	0	274474001	4170947	
47604	4173	4170947	1973-03-24	1973-03-24 00:00:00	38000275	0	\N	\N	277373	0	274474001	4170947	
47804	4197	4170947	2007-02-22	2007-02-22 00:00:00	38000275	0	\N	\N	278526	0	274474001	4170947	
24052	2088	4035793	2017-08-01	2017-08-01 00:00:00	38000275	0	\N	\N	139274	0	15081005	4035793	
36244	3177	4145310	2002-07-19	2002-07-19 00:00:00	38000275	0	\N	\N	211349	0	268425006	4145310	
24488	2136	4107731	2003-06-06	2003-06-06 00:00:00	38000275	0	\N	\N	142206	0	180256009	4107731	
36606	3216	4024289	1958-06-01	1958-06-01 00:00:00	38000275	0	\N	\N	213705	0	19490002	4024289	
36805	3236	4195803	2013-10-09	2013-10-09 00:00:00	38000275	0	\N	\N	215033	0	312681000	4195803	
36884	3241	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	215499	0	180256009	4107731	
37186	3270	4043071	1986-07-21	1986-07-21 00:00:00	38000275	0	\N	\N	217352	0	228557008	4043071	
37305	3279	4107731	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	217834	0	180256009	4107731	
37494	3311	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	219765	0	180256009	4107731	
49600	4353	4043071	1977-04-06	1977-04-06 00:00:00	38000275	0	\N	\N	288727	0	228557008	4043071	
37801	3343	4197460	1978-11-25	1978-11-25 00:00:00	38000275	0	\N	\N	221860	0	313191000	4197460	
38111	3364	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	223036	0	180256009	4107731	
38222	3370	4107731	1990-02-18	1990-02-18 00:00:00	38000275	0	\N	\N	223428	0	180256009	4107731	
50342	4376	4078793	2018-02-06	2018-02-06 00:00:00	38000275	0	\N	\N	290829	0	180325003	4078793	
50496	4390	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	291843	0	180256009	4107731	
26917	2352	4107731	1992-07-13	1992-07-13 00:00:00	38000275	0	\N	\N	156596	0	180256009	4107731	
38965	3438	4170947	1934-09-03	1934-09-03 00:00:00	38000275	0	\N	\N	228134	0	274474001	4170947	
39453	3477	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	230726	0	180256009	4107731	
27603	2414	4195803	1933-04-29	1933-04-29 00:00:00	38000275	0	\N	\N	160249	0	312681000	4195803	
39732	3501	4125906	1969-01-17	1969-01-17 00:00:00	38000275	0	\N	\N	232079	0	288086009	4125906	
39878	3510	4125906	1960-03-31	1960-03-31 00:00:00	38000275	0	\N	\N	232798	0	288086009	4125906	
40170	3527	4170947	1963-04-04	1963-04-04 00:00:00	38000275	0	\N	\N	234046	0	274474001	4170947	
40342	3533	4151422	1994-10-09	1994-10-09 00:00:00	38000275	0	\N	\N	234680	0	269911007	4151422	
40403	3542	4047491	2010-07-03	2010-07-03 00:00:00	38000275	0	\N	\N	235326	0	1225002	4047491	
40727	3571	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	237327	0	180256009	4107731	
40859	3583	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	238282	0	180256009	4107731	
29071	2577	4107731	1993-05-08	1993-05-08 00:00:00	38000275	0	\N	\N	170705	0	180256009	4107731	
41193	3621	4195803	1989-01-16	1989-01-16 00:00:00	38000275	0	\N	\N	240634	0	312681000	4195803	
41446	3639	4057420	2004-12-18	2004-12-18 00:00:00	38000275	0	\N	\N	\N	0	18286008	4057420	
53554	4643	4047491	1940-08-30	1940-08-30 00:00:00	38000275	0	\N	\N	309569	0	1225002	4047491	
53686	4655	4107731	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	310319	0	180256009	4107731	
41982	3700	4010253	2011-09-26	2011-09-26 00:00:00	38000275	0	\N	\N	245997	0	112790001	4010253	
42156	3717	4107731	1992-08-29	1992-08-29 00:00:00	38000275	0	\N	\N	246966	0	180256009	4107731	
54299	4719	4191853	1993-07-11	1993-07-11 00:00:00	38000275	0	\N	\N	314267	0	395142003	4191853	
30668	2712	4151422	1988-09-26	1988-09-26 00:00:00	38000275	0	\N	\N	179815	0	269911007	4151422	
42749	3769	4202451	2016-04-17	2016-04-17 00:00:00	38000275	0	\N	\N	250560	0	433112001	4202451	
42945	3784	4035793	1992-08-18	1992-08-18 00:00:00	38000275	0	\N	\N	251535	0	15081005	4035793	
55019	4782	4295880	2009-12-01	2009-12-01 00:00:00	38000275	0	\N	\N	318349	0	76601001	4295880	
31331	2771	4078793	1985-03-01	1985-03-01 00:00:00	38000275	0	\N	\N	183501	0	180325003	4078793	
43398	3839	4170947	2012-05-26	2012-05-26 00:00:00	38000275	0	\N	\N	254863	0	274474001	4170947	
43758	3869	4151422	1953-08-31	1953-08-31 00:00:00	38000275	0	\N	\N	256929	0	269911007	4151422	
55761	4859	4163872	1985-09-22	1985-09-22 00:00:00	38000275	0	\N	\N	323252	0	399208008	4163872	
44122	3884	4043071	1987-02-07	1987-02-07 00:00:00	38000275	0	\N	\N	258028	0	228557008	4043071	
32222	2830	4107731	1991-11-25	1991-11-25 00:00:00	38000275	0	\N	\N	187701	0	180256009	4107731	
56440	4924	4107731	1993-05-19	1993-05-19 00:00:00	38000275	0	\N	\N	327168	0	180256009	4107731	
56551	4927	4295880	1995-09-29	1995-09-29 00:00:00	38000275	0	\N	\N	327440	0	76601001	4295880	
56740	4935	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	328089	0	180256009	4107731	
44964	3949	4043071	1978-06-20	1978-06-20 00:00:00	38000275	0	\N	\N	262459	0	228557008	4043071	
33182	2902	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	193381	0	180256009	4107731	
45255	3987	4170947	1964-11-19	1964-11-19 00:00:00	38000275	0	\N	\N	265027	0	274474001	4170947	
45698	4026	4058899	1973-04-07	1973-04-07 00:00:00	38000275	0	\N	\N	267697	0	168594001	4058899	
57797	5018	4125906	1963-07-16	1963-07-16 00:00:00	38000275	0	\N	\N	333481	0	288086009	4125906	
46048	4051	4163872	2005-01-08	2005-01-08 00:00:00	38000275	0	\N	\N	269267	0	399208008	4163872	
34365	2975	4107731	1992-01-12	1992-01-12 00:00:00	38000275	0	\N	\N	198590	0	180256009	4107731	
34545	2997	44783196	2004-12-23	2004-12-23 00:00:00	38000275	0	\N	\N	199956	0	699253003	44783196	
58577	5073	4163872	1936-04-07	1936-04-07 00:00:00	38000275	0	\N	\N	337159	0	399208008	4163872	
46833	4109	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	273077	0	180256009	4107731	
59076	5117	4107731	1990-10-01	1990-10-01 00:00:00	38000275	0	\N	\N	340121	0	180256009	4107731	
47166	4145	4107731	2007-10-13	2007-10-13 00:00:00	38000275	0	\N	\N	275503	0	180256009	4107731	
59318	5132	4024289	2014-05-03	2014-05-03 00:00:00	38000275	0	\N	\N	341170	0	19490002	4024289	
47605	4173	4125906	2008-08-17	2008-08-17 00:00:00	38000275	0	\N	\N	277375	0	288086009	4125906	
47805	4197	4024289	2007-02-22	2007-02-22 00:00:00	38000275	0	\N	\N	278526	0	19490002	4024289	
24053	2088	4035793	1999-06-01	1999-06-01 00:00:00	38000275	0	\N	\N	139287	0	15081005	4035793	
36245	3177	4151422	1984-03-27	1984-03-27 00:00:00	38000275	0	\N	\N	211252	0	269911007	4151422	
24489	2136	4107731	2004-09-10	2004-09-10 00:00:00	38000275	0	\N	\N	142291	0	180256009	4107731	
36607	3216	4170947	1958-06-01	1958-06-01 00:00:00	38000275	0	\N	\N	213705	0	274474001	4170947	
36806	3236	4047491	2013-10-09	2013-10-09 00:00:00	38000275	0	\N	\N	215033	0	1225002	4047491	
36885	3241	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	215521	0	180256009	4107731	
37187	3270	4043071	1983-09-12	1983-09-12 00:00:00	38000275	0	\N	\N	217310	0	228557008	4043071	
37306	3279	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	217956	0	180256009	4107731	
37495	3311	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	219829	0	180256009	4107731	
49601	4353	4043071	1978-05-03	1978-05-03 00:00:00	38000275	0	\N	\N	288751	0	228557008	4043071	
37802	3343	4043071	1986-10-28	1986-10-28 00:00:00	38000275	0	\N	\N	221832	0	228557008	4043071	
38112	3364	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	223116	0	180256009	4107731	
38223	3370	4107731	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	223398	0	180256009	4107731	
50343	4376	4078793	1978-07-18	1978-07-18 00:00:00	38000275	0	\N	\N	290796	0	180325003	4078793	
50497	4390	4125906	1973-02-13	1973-02-13 00:00:00	38000275	0	\N	\N	291790	0	288086009	4125906	
26918	2352	4107731	1991-12-16	1991-12-16 00:00:00	38000275	0	\N	\N	156678	0	180256009	4107731	
38966	3438	4037675	1980-03-30	1980-03-30 00:00:00	38000275	0	\N	\N	228075	0	162676008	4037675	
39454	3477	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	230618	0	180256009	4107731	
27604	2414	4078793	1997-09-04	1997-09-04 00:00:00	38000275	0	\N	\N	160246	0	180325003	4078793	
39733	3501	4293740	1969-01-17	1969-01-17 00:00:00	38000275	0	\N	\N	232079	0	384700001	4293740	
39879	3510	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	232809	0	180256009	4107731	
40171	3527	4047491	1963-04-04	1963-04-04 00:00:00	38000275	0	\N	\N	234046	0	1225002	4047491	
40347	3536	4125906	2006-08-07	2006-08-07 00:00:00	38000275	0	\N	\N	234808	0	288086009	4125906	
40404	3542	4170947	2010-07-03	2010-07-03 00:00:00	38000275	0	\N	\N	235326	0	274474001	4170947	
40728	3571	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	237371	0	180256009	4107731	
40860	3583	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	238274	0	180256009	4107731	
29072	2577	4107731	1992-10-10	1992-10-10 00:00:00	38000275	0	\N	\N	170712	0	180256009	4107731	
41194	3621	4170947	1989-01-16	1989-01-16 00:00:00	38000275	0	\N	\N	240634	0	274474001	4170947	
41447	3639	4078793	2006-07-01	2006-07-01 00:00:00	38000275	0	\N	\N	242093	0	180325003	4078793	
53555	4644	4125906	1995-08-16	1995-08-16 00:00:00	38000275	0	\N	\N	309630	0	288086009	4125906	
53687	4655	4107731	1991-01-20	1991-01-20 00:00:00	38000275	0	\N	\N	310356	0	180256009	4107731	
41983	3700	44783196	1971-07-13	1971-07-13 00:00:00	38000275	0	\N	\N	246007	0	699253003	44783196	
42157	3717	4107731	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	246959	0	180256009	4107731	
54300	4719	4107731	1991-05-05	1991-05-05 00:00:00	38000275	0	\N	\N	314240	0	180256009	4107731	
42450	3744	4191853	2006-07-12	2006-07-12 00:00:00	38000275	0	\N	\N	248784	0	395142003	4191853	
42750	3769	4151422	2019-03-20	2019-03-20 00:00:00	38000275	0	\N	\N	250580	0	269911007	4151422	
42946	3784	4035793	1986-08-12	1986-08-12 00:00:00	38000275	0	\N	\N	251476	0	15081005	4035793	
55020	4782	4295880	2005-03-08	2005-03-08 00:00:00	38000275	0	\N	\N	318311	0	76601001	4295880	
31332	2771	4078793	2002-06-07	2002-06-07 00:00:00	38000275	0	\N	\N	183506	0	180325003	4078793	
43399	3839	4043071	1963-12-22	1963-12-22 00:00:00	38000275	0	\N	\N	254914	0	228557008	4043071	
55554	4843	4170947	1984-06-22	1984-06-22 00:00:00	38000275	0	\N	\N	322109	0	274474001	4170947	
55762	4859	4163872	1962-02-03	1962-02-03 00:00:00	38000275	0	\N	\N	323232	0	399208008	4163872	
44123	3884	4043071	1985-10-19	1985-10-19 00:00:00	38000275	0	\N	\N	258180	0	228557008	4043071	
32223	2830	4191853	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	187752	0	395142003	4191853	
56441	4924	4107731	1992-09-30	1992-09-30 00:00:00	38000275	0	\N	\N	327160	0	180256009	4107731	
56552	4927	4295880	1996-06-28	1996-06-28 00:00:00	38000275	0	\N	\N	327441	0	76601001	4295880	
56741	4935	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	328086	0	180256009	4107731	
44965	3949	4043071	1978-05-16	1978-05-16 00:00:00	38000275	0	\N	\N	262458	0	228557008	4043071	
33183	2902	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	193388	0	180256009	4107731	
45256	3987	4078793	2016-03-05	2016-03-05 00:00:00	38000275	0	\N	\N	265060	0	180325003	4078793	
45699	4026	4107731	1993-02-14	1993-02-14 00:00:00	38000275	0	\N	\N	267745	0	180256009	4107731	
57798	5018	4058899	1976-03-30	1976-03-30 00:00:00	38000275	0	\N	\N	333482	0	168594001	4058899	
46049	4051	4125906	2018-07-20	2018-07-20 00:00:00	38000275	0	\N	\N	269263	0	288086009	4125906	
34366	2976	4035793	2010-11-04	2010-11-04 00:00:00	38000275	0	\N	\N	198748	0	15081005	4035793	
34546	2997	4295880	1997-06-29	1997-06-29 00:00:00	38000275	0	\N	\N	199942	0	76601001	4295880	
58578	5073	4170947	1936-04-07	1936-04-07 00:00:00	38000275	0	\N	\N	337159	0	274474001	4170947	
46834	4109	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	273058	0	180256009	4107731	
59077	5117	4107731	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	340129	0	180256009	4107731	
47167	4145	4107731	2007-11-03	2007-11-03 00:00:00	38000275	0	\N	\N	275519	0	180256009	4107731	
59319	5132	4195803	2019-06-06	2019-06-06 00:00:00	38000275	0	\N	\N	341172	0	312681000	4195803	
47606	4173	4125906	2012-06-18	2012-06-18 00:00:00	38000275	0	\N	\N	277328	0	288086009	4125906	
47806	4197	4252419	2009-12-08	2009-12-08 00:00:00	38000275	0	\N	\N	278540	0	74016001	4252419	
24054	2088	4125906	2012-05-25	2012-05-25 00:00:00	38000275	0	\N	\N	139185	0	288086009	4125906	
36246	3177	4078793	2012-05-09	2012-05-09 00:00:00	38000275	0	\N	\N	211369	0	180325003	4078793	
24490	2136	4107731	2002-11-08	2002-11-08 00:00:00	38000275	0	\N	\N	142244	0	180256009	4107731	
36608	3216	4010253	1999-06-29	1999-06-29 00:00:00	38000275	0	\N	\N	213711	0	112790001	4010253	
36807	3236	4078793	1988-12-23	1988-12-23 00:00:00	38000275	0	\N	\N	215075	0	180325003	4078793	
36886	3241	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	215470	0	180256009	4107731	
37188	3270	4043071	1986-04-28	1986-04-28 00:00:00	38000275	0	\N	\N	217277	0	228557008	4043071	
37307	3279	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	217813	0	395142003	4191853	
37496	3311	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	219790	0	180256009	4107731	
49602	4353	4043071	1981-03-18	1981-03-18 00:00:00	38000275	0	\N	\N	288813	0	228557008	4043071	
37803	3343	4107731	1991-12-01	1991-12-01 00:00:00	38000275	0	\N	\N	221705	0	180256009	4107731	
38113	3364	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	223070	0	180256009	4107731	
38224	3370	4107731	1990-04-22	1990-04-22 00:00:00	38000275	0	\N	\N	223452	0	180256009	4107731	
50344	4376	4078793	1986-08-12	1986-08-12 00:00:00	38000275	0	\N	\N	290798	0	180325003	4078793	
50498	4390	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	291900	0	180256009	4107731	
26919	2352	4107731	1991-07-22	1991-07-22 00:00:00	38000275	0	\N	\N	156591	0	180256009	4107731	
38967	3438	4187458	1980-03-30	1980-03-30 00:00:00	38000275	0	\N	\N	228075	0	415300000	4187458	
39455	3477	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	230640	0	180256009	4107731	
27605	2414	4078793	1999-09-16	1999-09-16 00:00:00	38000275	0	\N	\N	160247	0	180325003	4078793	
39759	3504	4170947	1937-12-25	1937-12-25 00:00:00	38000275	0	\N	\N	232333	0	274474001	4170947	
39880	3510	4151422	1997-08-06	1997-08-06 00:00:00	38000275	0	\N	\N	232831	0	269911007	4151422	
40172	3527	4202451	2013-11-28	2013-11-28 00:00:00	38000275	0	\N	\N	234074	0	433112001	4202451	
40348	3536	4125906	1994-11-24	1994-11-24 00:00:00	38000275	0	\N	\N	234807	0	288086009	4125906	
40405	3542	4125906	1957-05-09	1957-05-09 00:00:00	38000275	0	\N	\N	235322	0	288086009	4125906	
40729	3571	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	237323	0	180256009	4107731	
40861	3583	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	238221	0	180256009	4107731	
29073	2577	4107731	1991-11-09	1991-11-09 00:00:00	38000275	0	\N	\N	170628	0	180256009	4107731	
41195	3621	4163872	1989-01-16	1989-01-16 00:00:00	38000275	0	\N	\N	240634	0	399208008	4163872	
41448	3639	4151422	1960-09-29	1960-09-29 00:00:00	38000275	0	\N	\N	242063	0	269911007	4151422	
53556	4644	4151422	1981-07-01	1981-07-01 00:00:00	38000275	0	\N	\N	309646	0	269911007	4151422	
53688	4655	4107731	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	310268	0	180256009	4107731	
41984	3700	4125906	1981-01-21	1981-01-21 00:00:00	38000275	0	\N	\N	246008	0	288086009	4125906	
42158	3717	4107731	1992-11-21	1992-11-21 00:00:00	38000275	0	\N	\N	247014	0	180256009	4107731	
54301	4719	4107731	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	314258	0	180256009	4107731	
42451	3744	4058899	1990-11-08	1990-11-08 00:00:00	38000275	0	\N	\N	248851	0	168594001	4058899	
42751	3772	4107731	1991-02-09	1991-02-09 00:00:00	38000275	0	\N	\N	250700	0	180256009	4107731	
42947	3784	4035793	1988-07-26	1988-07-26 00:00:00	38000275	0	\N	\N	251533	0	15081005	4035793	
55021	4782	4295880	2007-06-05	2007-06-05 00:00:00	38000275	0	\N	\N	318314	0	76601001	4295880	
31333	2771	4293740	1961-08-27	1961-08-27 00:00:00	38000275	0	\N	\N	183471	0	384700001	4293740	
43400	3839	4170947	1972-08-03	1972-08-03 00:00:00	38000275	0	\N	\N	254861	0	274474001	4170947	
55555	4843	4243062	1984-06-22	1984-06-22 00:00:00	38000275	0	\N	\N	322109	0	60027007	4243062	
55763	4859	4243062	1982-07-11	1982-07-11 00:00:00	38000275	0	\N	\N	323227	0	60027007	4243062	
44124	3884	4043071	1990-04-14	1990-04-14 00:00:00	38000275	0	\N	\N	258202	0	228557008	4043071	
32224	2830	4107731	1990-02-12	1990-02-12 00:00:00	38000275	0	\N	\N	187789	0	180256009	4107731	
56442	4924	4107731	1992-10-21	1992-10-21 00:00:00	38000275	0	\N	\N	327229	0	180256009	4107731	
56553	4927	4295880	2003-09-19	2003-09-19 00:00:00	38000275	0	\N	\N	327456	0	76601001	4295880	
56742	4935	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	328088	0	180256009	4107731	
44966	3949	4043071	1978-11-28	1978-11-28 00:00:00	38000275	0	\N	\N	262460	0	228557008	4043071	
33184	2902	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	193305	0	180256009	4107731	
45257	3987	4195803	2010-04-20	2010-04-20 00:00:00	38000275	0	\N	\N	265030	0	312681000	4195803	
45700	4026	4107731	1990-04-01	1990-04-01 00:00:00	38000275	0	\N	\N	267666	0	180256009	4107731	
57799	5018	4151422	1979-03-13	1979-03-13 00:00:00	38000275	0	\N	\N	333543	0	269911007	4151422	
46050	4052	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	269360	0	180256009	4107731	
34367	2976	4035793	2013-07-11	2013-07-11 00:00:00	38000275	0	\N	\N	198749	0	15081005	4035793	
34547	2997	4295880	1997-12-28	1997-12-28 00:00:00	38000275	0	\N	\N	199927	0	76601001	4295880	
58579	5073	4078793	2007-08-18	2007-08-18 00:00:00	38000275	0	\N	\N	337181	0	180325003	4078793	
46835	4109	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	273218	0	180256009	4107731	
59078	5117	4107731	1990-01-22	1990-01-22 00:00:00	38000275	0	\N	\N	340128	0	180256009	4107731	
47168	4145	4107731	2009-06-13	2009-06-13 00:00:00	38000275	0	\N	\N	275479	0	180256009	4107731	
59320	5132	4243062	2019-06-06	2019-06-06 00:00:00	38000275	0	\N	\N	341172	0	60027007	4243062	
47607	4173	4047491	1964-06-09	1964-06-09 00:00:00	38000275	0	\N	\N	277372	0	1225002	4047491	
47807	4197	4202451	2011-02-20	2011-02-20 00:00:00	38000275	0	\N	\N	278508	0	433112001	4202451	
24055	2088	4035793	1987-07-14	1987-07-14 00:00:00	38000275	0	\N	\N	139254	0	15081005	4035793	
36247	3177	4202451	2012-05-30	2012-05-30 00:00:00	38000275	0	\N	\N	211369	0	433112001	4202451	
24491	2136	4191853	2004-12-24	2004-12-24 00:00:00	38000275	0	\N	\N	142252	0	395142003	4191853	
36609	3216	4125906	1963-07-26	1963-07-26 00:00:00	38000275	0	\N	\N	213707	0	288086009	4125906	
36808	3236	4057420	2010-08-13	2010-08-13 00:00:00	38000275	0	\N	\N	215102	0	18286008	4057420	
36887	3241	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	215506	0	180256009	4107731	
37189	3270	4043071	1983-06-06	1983-06-06 00:00:00	38000275	0	\N	\N	217326	0	228557008	4043071	
37308	3279	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	217844	0	180256009	4107731	
37497	3311	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	219806	0	180256009	4107731	
49603	4353	4043071	1980-02-20	1980-02-20 00:00:00	38000275	0	\N	\N	288806	0	228557008	4043071	
37804	3343	4043071	1987-06-02	1987-06-02 00:00:00	38000275	0	\N	\N	221777	0	228557008	4043071	
38114	3364	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	223146	0	180256009	4107731	
38225	3370	4107731	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	223470	0	180256009	4107731	
50345	4376	4035793	1997-10-14	1997-10-14 00:00:00	38000275	0	\N	\N	290808	0	15081005	4035793	
50499	4390	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	291824	0	180256009	4107731	
26920	2352	4107731	1992-10-26	1992-10-26 00:00:00	38000275	0	\N	\N	156735	0	180256009	4107731	
38968	3438	4326177	1980-03-30	1980-03-30 00:00:00	38000275	0	\N	\N	228075	0	430193006	4326177	
39456	3477	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	230616	0	180256009	4107731	
27606	2414	4078793	1999-12-02	1999-12-02 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
39760	3504	4243062	1937-12-25	1937-12-25 00:00:00	38000275	0	\N	\N	232333	0	60027007	4243062	
39881	3510	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	232867	0	180256009	4107731	
40173	3527	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	234060	0	180256009	4107731	
40349	3536	4293740	1994-11-24	1994-11-24 00:00:00	38000275	0	\N	\N	234807	0	384700001	4293740	
40406	3542	4252419	2002-09-15	2002-09-15 00:00:00	38000275	0	\N	\N	235324	0	74016001	4252419	
40730	3571	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	237330	0	180256009	4107731	
40862	3583	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	238250	0	180256009	4107731	
29074	2577	4107731	1991-10-19	1991-10-19 00:00:00	38000275	0	\N	\N	170674	0	180256009	4107731	
41196	3621	4035793	1996-06-08	1996-06-08 00:00:00	38000275	0	\N	\N	240607	0	15081005	4035793	
41449	3639	4163872	1995-08-15	1995-08-15 00:00:00	38000275	0	\N	\N	242034	0	399208008	4163872	
53557	4644	4010253	1996-02-04	1996-02-04 00:00:00	38000275	0	\N	\N	309689	0	112790001	4010253	
53689	4655	4107731	1990-09-16	1990-09-16 00:00:00	38000275	0	\N	\N	310395	0	180256009	4107731	
41985	3700	4252419	1971-07-06	1971-07-06 00:00:00	38000275	0	\N	\N	245972	0	74016001	4252419	
42159	3717	4107731	1991-11-09	1991-11-09 00:00:00	38000275	0	\N	\N	247026	0	180256009	4107731	
54302	4719	4107731	1993-04-18	1993-04-18 00:00:00	38000275	0	\N	\N	314277	0	180256009	4107731	
42452	3744	4107731	2006-01-25	2006-01-25 00:00:00	38000275	0	\N	\N	248809	0	180256009	4107731	
42752	3772	4107731	1993-04-17	1993-04-17 00:00:00	38000275	0	\N	\N	250685	0	180256009	4107731	
54792	4753	4043071	1973-11-03	1973-11-03 00:00:00	38000275	0	\N	\N	316552	0	228557008	4043071	
55022	4782	4295880	2007-09-04	2007-09-04 00:00:00	38000275	0	\N	\N	318329	0	76601001	4295880	
31334	2771	4125906	1961-08-27	1961-08-27 00:00:00	38000275	0	\N	\N	183471	0	288086009	4125906	
43401	3839	4243062	1972-08-03	1972-08-03 00:00:00	38000275	0	\N	\N	254861	0	60027007	4243062	
55556	4843	4151422	2009-06-13	2009-06-13 00:00:00	38000275	0	\N	\N	322118	0	269911007	4151422	
55764	4859	4170947	1982-07-11	1982-07-11 00:00:00	38000275	0	\N	\N	323227	0	274474001	4170947	
44125	3884	4107731	1993-02-08	1993-02-08 00:00:00	38000275	0	\N	\N	258151	0	180256009	4107731	
32225	2830	4107731	1990-07-09	1990-07-09 00:00:00	38000275	0	\N	\N	187696	0	180256009	4107731	
56443	4924	4107731	1992-02-12	1992-02-12 00:00:00	38000275	0	\N	\N	327158	0	180256009	4107731	
56554	4927	4295880	2005-03-18	2005-03-18 00:00:00	38000275	0	\N	\N	327468	0	76601001	4295880	
56743	4935	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	328119	0	180256009	4107731	
44967	3949	4043071	1977-04-19	1977-04-19 00:00:00	38000275	0	\N	\N	262471	0	228557008	4043071	
33185	2902	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	193343	0	180256009	4107731	
45258	3987	4047491	2010-04-20	2010-04-20 00:00:00	38000275	0	\N	\N	265030	0	1225002	4047491	
45701	4026	4107731	1993-01-24	1993-01-24 00:00:00	38000275	0	\N	\N	267637	0	180256009	4107731	
57806	5022	4293740	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	333661	0	384700001	4293740	
46051	4052	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	269321	0	180256009	4107731	
34368	2976	4035793	2007-10-18	2007-10-18 00:00:00	38000275	0	\N	\N	198732	0	15081005	4035793	
34548	2997	4295880	1997-03-30	1997-03-30 00:00:00	38000275	0	\N	\N	199959	0	76601001	4295880	
58580	5073	4078793	2001-07-14	2001-07-14 00:00:00	38000275	0	\N	\N	337206	0	180325003	4078793	
46836	4109	4107731	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	273059	0	180256009	4107731	
59079	5117	4107731	1991-04-29	1991-04-29 00:00:00	38000275	0	\N	\N	340075	0	180256009	4107731	
47169	4145	4107731	2010-01-09	2010-01-09 00:00:00	38000275	0	\N	\N	275528	0	180256009	4107731	
59321	5132	4170947	2019-06-06	2019-06-06 00:00:00	38000275	0	\N	\N	341172	0	274474001	4170947	
47608	4173	4170947	1964-06-09	1964-06-09 00:00:00	38000275	0	\N	\N	277372	0	274474001	4170947	
47808	4197	4275113	2004-08-24	2004-08-24 00:00:00	38000275	0	\N	\N	278490	0	65200003	4275113	
24056	2088	4035793	1989-07-25	1989-07-25 00:00:00	38000275	0	\N	\N	139235	0	15081005	4035793	
36248	3177	4145310	2008-02-18	2008-02-18 00:00:00	38000275	0	\N	\N	211351	0	268425006	4145310	
24492	2136	4107731	2004-02-13	2004-02-13 00:00:00	38000275	0	\N	\N	142267	0	180256009	4107731	
36610	3217	4125906	1992-01-19	1992-01-19 00:00:00	38000275	0	\N	\N	213809	0	288086009	4125906	
36809	3237	4125906	1928-05-02	1928-05-02 00:00:00	38000275	0	\N	\N	215148	0	288086009	4125906	
36888	3241	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	215520	0	180256009	4107731	
37190	3270	4043071	1985-02-18	1985-02-18 00:00:00	38000275	0	\N	\N	217272	0	228557008	4043071	
37309	3279	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	217935	0	180256009	4107731	
37498	3311	4107731	1993-08-20	1993-08-20 00:00:00	38000275	0	\N	\N	219815	0	180256009	4107731	
49604	4353	4043071	1981-01-07	1981-01-07 00:00:00	38000275	0	\N	\N	288756	0	228557008	4043071	
37805	3343	4043071	1987-08-11	1987-08-11 00:00:00	38000275	0	\N	\N	221756	0	228557008	4043071	
38115	3364	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	223087	0	180256009	4107731	
38226	3370	4107731	1990-08-05	1990-08-05 00:00:00	38000275	0	\N	\N	223415	0	180256009	4107731	
50346	4376	4078793	1997-10-14	1997-10-14 00:00:00	38000275	0	\N	\N	290808	0	180325003	4078793	
50500	4390	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	291846	0	180256009	4107731	
26921	2352	4107731	1992-01-06	1992-01-06 00:00:00	38000275	0	\N	\N	156668	0	180256009	4107731	
38969	3439	4058899	1967-01-02	1967-01-02 00:00:00	38000275	0	\N	\N	228168	0	168594001	4058899	
39457	3477	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	230724	0	180256009	4107731	
27607	2414	4151422	1978-07-25	1978-07-25 00:00:00	38000275	0	\N	\N	160221	0	269911007	4151422	
39761	3504	4024289	1939-11-15	1939-11-15 00:00:00	38000275	0	\N	\N	232334	0	19490002	4024289	
39882	3510	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	232802	0	180256009	4107731	
40174	3527	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	234115	0	180256009	4107731	
40350	3537	4197460	1962-06-20	1962-06-20 00:00:00	38000275	0	\N	\N	234981	0	313191000	4197460	
40407	3542	44783196	2002-09-22	2002-09-22 00:00:00	38000275	0	\N	\N	235321	0	699253003	44783196	
40731	3571	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	237367	0	180256009	4107731	
40863	3583	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	238219	0	180256009	4107731	
29075	2577	4107731	1991-04-13	1991-04-13 00:00:00	38000275	0	\N	\N	170617	0	180256009	4107731	
41197	3621	4125906	1950-01-15	1950-01-15 00:00:00	38000275	0	\N	\N	240659	0	288086009	4125906	
41450	3639	4125906	1961-02-16	1961-02-16 00:00:00	38000275	0	\N	\N	242121	0	288086009	4125906	
53558	4644	4151422	1970-03-14	1970-03-14 00:00:00	38000275	0	\N	\N	309687	0	269911007	4151422	
53690	4655	4107731	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	310400	0	180256009	4107731	
41986	3701	4163872	1955-08-20	1955-08-20 00:00:00	38000275	0	\N	\N	246029	0	399208008	4163872	
42160	3717	4107731	1991-06-15	1991-06-15 00:00:00	38000275	0	\N	\N	247037	0	180256009	4107731	
54303	4719	4107731	1991-12-01	1991-12-01 00:00:00	38000275	0	\N	\N	314260	0	180256009	4107731	
42453	3744	4107731	2003-08-27	2003-08-27 00:00:00	38000275	0	\N	\N	248826	0	180256009	4107731	
42753	3772	4107731	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	250654	0	180256009	4107731	
54793	4753	4043071	1973-01-27	1973-01-27 00:00:00	38000275	0	\N	\N	316479	0	228557008	4043071	
55023	4782	4295880	2008-03-04	2008-03-04 00:00:00	38000275	0	\N	\N	318315	0	76601001	4295880	
31335	2771	4078793	1988-03-18	1988-03-18 00:00:00	38000275	0	\N	\N	183420	0	180325003	4078793	
43402	3839	4043071	1964-02-16	1964-02-16 00:00:00	38000275	0	\N	\N	254920	0	228557008	4043071	
55557	4843	4330583	2015-02-14	2015-02-14 00:00:00	38000275	0	\N	\N	322122	0	22523008	4330583	
55765	4859	4151422	1980-03-14	1980-03-14 00:00:00	38000275	0	\N	\N	323248	0	269911007	4151422	
44126	3884	4043071	1989-03-11	1989-03-11 00:00:00	38000275	0	\N	\N	258138	0	228557008	4043071	
32226	2830	4107731	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	187797	0	180256009	4107731	
56444	4924	4107731	1993-04-28	1993-04-28 00:00:00	38000275	0	\N	\N	327246	0	180256009	4107731	
56555	4927	4295880	1996-03-29	1996-03-29 00:00:00	38000275	0	\N	\N	327492	0	76601001	4295880	
56744	4935	4252419	1999-02-07	1999-02-07 00:00:00	38000275	0	\N	\N	328156	0	74016001	4252419	
44968	3949	4043071	1977-10-25	1977-10-25 00:00:00	38000275	0	\N	\N	262474	0	228557008	4043071	
33186	2902	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	193265	0	180256009	4107731	
45259	3987	4170947	2010-04-20	2010-04-20 00:00:00	38000275	0	\N	\N	265030	0	274474001	4170947	
45702	4026	4107731	1992-05-17	1992-05-17 00:00:00	38000275	0	\N	\N	267742	0	180256009	4107731	
57807	5022	4125906	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	333661	0	288086009	4125906	
46052	4052	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	269338	0	180256009	4107731	
34369	2976	4035793	2015-07-23	2015-07-23 00:00:00	38000275	0	\N	\N	198751	0	15081005	4035793	
34549	2997	4295880	1998-06-28	1998-06-28 00:00:00	38000275	0	\N	\N	199975	0	76601001	4295880	
58581	5073	4078793	2002-07-20	2002-07-20 00:00:00	38000275	0	\N	\N	337215	0	180325003	4078793	
46837	4109	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	273183	0	180256009	4107731	
59080	5117	4107731	1991-02-25	1991-02-25 00:00:00	38000275	0	\N	\N	340026	0	180256009	4107731	
47170	4145	4107731	2008-06-21	2008-06-21 00:00:00	38000275	0	\N	\N	275521	0	180256009	4107731	
59336	5137	4125906	1987-06-06	1987-06-06 00:00:00	38000275	0	\N	\N	341355	0	288086009	4125906	
47616	4176	4125906	1979-03-27	1979-03-27 00:00:00	38000275	0	\N	\N	277544	0	288086009	4125906	
47811	4199	4151422	2011-02-08	2011-02-08 00:00:00	38000275	0	\N	\N	278691	0	269911007	4151422	
24057	2088	4195803	1989-07-25	1989-07-25 00:00:00	38000275	0	\N	\N	139235	0	312681000	4195803	
36249	3177	4125906	1959-04-24	1959-04-24 00:00:00	38000275	0	\N	\N	211229	0	288086009	4125906	
24493	2136	4107731	2001-09-14	2001-09-14 00:00:00	38000275	0	\N	\N	142218	0	180256009	4107731	
36611	3217	4151422	1993-08-13	1993-08-13 00:00:00	38000275	0	\N	\N	213802	0	269911007	4151422	
36810	3237	4170947	1971-01-27	1971-01-27 00:00:00	38000275	0	\N	\N	215153	0	274474001	4170947	
36889	3242	4151422	1988-04-24	1988-04-24 00:00:00	38000275	0	\N	\N	215618	0	269911007	4151422	
37191	3270	4043071	1987-06-01	1987-06-01 00:00:00	38000275	0	\N	\N	217355	0	228557008	4043071	
37310	3279	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	217953	0	180256009	4107731	
37499	3311	4191853	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	219805	0	395142003	4191853	
49605	4353	4043071	1979-06-06	1979-06-06 00:00:00	38000275	0	\N	\N	288745	0	228557008	4043071	
37806	3343	4107731	1991-09-29	1991-09-29 00:00:00	38000275	0	\N	\N	221851	0	180256009	4107731	
38116	3364	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	223030	0	180256009	4107731	
38227	3370	4107731	1992-04-26	1992-04-26 00:00:00	38000275	0	\N	\N	223468	0	180256009	4107731	
50347	4376	4035793	2015-01-20	2015-01-20 00:00:00	38000275	0	\N	\N	290839	0	15081005	4035793	
50501	4390	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	291901	0	180256009	4107731	
26922	2352	4107731	1991-09-23	1991-09-23 00:00:00	38000275	0	\N	\N	156724	0	180256009	4107731	
38970	3439	4078793	2018-12-27	2018-12-27 00:00:00	38000275	0	\N	\N	228166	0	180325003	4078793	
51257	4446	4125906	2014-06-20	2014-06-20 00:00:00	38000275	0	\N	\N	295667	0	288086009	4125906	
27608	2414	4336464	1994-05-26	1994-05-26 00:00:00	38000275	0	\N	\N	160252	0	232717009	4336464	
39762	3504	4170947	1939-11-15	1939-11-15 00:00:00	38000275	0	\N	\N	232334	0	274474001	4170947	
39883	3510	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	232924	0	180256009	4107731	
40175	3527	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	234104	0	180256009	4107731	
40351	3537	4010253	2012-05-26	2012-05-26 00:00:00	38000275	0	\N	\N	234955	0	112790001	4010253	
40408	3542	4151422	1948-06-05	1948-06-05 00:00:00	38000275	0	\N	\N	235233	0	269911007	4151422	
40732	3571	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	237328	0	180256009	4107731	
40864	3583	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	238288	0	180256009	4107731	
29076	2577	4107731	1991-03-23	1991-03-23 00:00:00	38000275	0	\N	\N	170626	0	180256009	4107731	
41198	3621	4145310	1963-12-08	1963-12-08 00:00:00	38000275	0	\N	\N	240632	0	268425006	4145310	
41451	3639	4078793	2004-10-30	2004-10-30 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
53559	4646	4078793	2002-10-15	2002-10-15 00:00:00	38000275	0	\N	\N	309781	0	180325003	4078793	
53691	4655	4107731	1991-09-08	1991-09-08 00:00:00	38000275	0	\N	\N	310358	0	180256009	4107731	
41987	3701	4252419	1984-12-18	1984-12-18 00:00:00	38000275	0	\N	\N	246068	0	74016001	4252419	
42161	3717	4107731	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	246990	0	180256009	4107731	
54304	4719	4107731	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	314276	0	180256009	4107731	
42454	3744	4107731	2005-02-23	2005-02-23 00:00:00	38000275	0	\N	\N	248857	0	180256009	4107731	
42754	3772	4107731	1992-04-25	1992-04-25 00:00:00	38000275	0	\N	\N	250678	0	180256009	4107731	
54794	4753	4043071	1973-04-28	1973-04-28 00:00:00	38000275	0	\N	\N	316537	0	228557008	4043071	
55024	4782	4295880	2008-06-03	2008-06-03 00:00:00	38000275	0	\N	\N	318331	0	76601001	4295880	
31336	2771	4078793	1992-04-10	1992-04-10 00:00:00	38000275	0	\N	\N	183422	0	180325003	4078793	
43403	3839	4195803	2017-04-30	2017-04-30 00:00:00	38000275	0	\N	\N	254864	0	312681000	4195803	
55558	4843	4047491	1974-06-17	1974-06-17 00:00:00	38000275	0	\N	\N	322106	0	1225002	4047491	
55766	4859	4202832	1971-06-05	1971-06-05 00:00:00	38000275	0	\N	\N	323226	0	52765003	4202832	
44127	3884	4107731	1992-01-27	1992-01-27 00:00:00	38000275	0	\N	\N	258048	0	180256009	4107731	
32227	2830	4107731	1991-12-16	1991-12-16 00:00:00	38000275	0	\N	\N	187728	0	180256009	4107731	
56445	4924	4107731	1994-01-26	1994-01-26 00:00:00	38000275	0	\N	\N	327249	0	180256009	4107731	
56556	4927	4295880	2000-09-22	2000-09-22 00:00:00	38000275	0	\N	\N	327501	0	76601001	4295880	
56745	4935	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	328079	0	180256009	4107731	
44969	3949	4043071	1977-06-21	1977-06-21 00:00:00	38000275	0	\N	\N	262440	0	228557008	4043071	
33187	2902	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	193341	0	180256009	4107731	
45260	3987	4078793	2018-03-17	2018-03-17 00:00:00	38000275	0	\N	\N	265061	0	180325003	4078793	
45703	4026	4107731	1991-05-26	1991-05-26 00:00:00	38000275	0	\N	\N	267619	0	180256009	4107731	
57808	5022	4145310	1984-05-04	1984-05-04 00:00:00	38000275	0	\N	\N	333659	0	268425006	4145310	
46053	4052	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	269394	0	180256009	4107731	
34370	2976	4035793	2005-06-23	2005-06-23 00:00:00	38000275	0	\N	\N	198775	0	15081005	4035793	
34550	2997	4252419	2004-12-16	2004-12-16 00:00:00	38000275	0	\N	\N	199962	0	74016001	4252419	
58582	5073	4198190	1947-04-11	1947-04-11 00:00:00	38000275	0	\N	\N	337258	0	80146002	4198190	
46838	4109	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	273095	0	180256009	4107731	
59081	5117	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	340069	0	180256009	4107731	
47171	4145	4107731	2006-12-02	2006-12-02 00:00:00	38000275	0	\N	\N	275498	0	180256009	4107731	
59337	5137	4125906	1998-04-21	1998-04-21 00:00:00	38000275	0	\N	\N	341357	0	288086009	4125906	
47617	4176	4163872	1977-09-29	1977-09-29 00:00:00	38000275	0	\N	\N	277492	0	399208008	4163872	
47812	4199	4125906	1980-06-05	1980-06-05 00:00:00	38000275	0	\N	\N	278708	0	288086009	4125906	
24058	2088	4125906	1921-09-14	1921-09-14 00:00:00	38000275	0	\N	\N	139177	0	288086009	4125906	
36250	3177	40492359	2003-01-08	2003-01-08 00:00:00	38000275	0	\N	\N	211350	0	447365002	40492359	
24494	2136	4107731	2002-05-03	2002-05-03 00:00:00	38000275	0	\N	\N	142220	0	180256009	4107731	
36612	3217	4151422	1999-07-28	1999-07-28 00:00:00	38000275	0	\N	\N	213803	0	269911007	4151422	
36811	3237	4243062	1971-01-27	1971-01-27 00:00:00	38000275	0	\N	\N	215153	0	60027007	4243062	
36890	3242	4047491	1988-03-06	1988-03-06 00:00:00	38000275	0	\N	\N	215643	0	1225002	4047491	
37192	3270	4043071	1985-10-28	1985-10-28 00:00:00	38000275	0	\N	\N	217257	0	228557008	4043071	
37311	3279	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	217937	0	180256009	4107731	
37500	3311	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	219858	0	180256009	4107731	
49606	4353	4043071	1979-07-11	1979-07-11 00:00:00	38000275	0	\N	\N	288753	0	228557008	4043071	
37807	3343	4107731	1990-12-09	1990-12-09 00:00:00	38000275	0	\N	\N	221726	0	180256009	4107731	
38117	3364	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	223035	0	180256009	4107731	
38228	3370	4107731	1990-07-15	1990-07-15 00:00:00	38000275	0	\N	\N	223455	0	180256009	4107731	
50348	4376	4078793	2015-01-20	2015-01-20 00:00:00	38000275	0	\N	\N	290839	0	180325003	4078793	
50502	4390	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	291807	0	180256009	4107731	
26923	2352	4107731	1990-01-22	1990-01-22 00:00:00	38000275	0	\N	\N	156714	0	180256009	4107731	
38971	3439	4078793	2016-12-15	2016-12-15 00:00:00	38000275	0	\N	\N	228165	0	180325003	4078793	
51258	4446	4125906	1977-04-21	1977-04-21 00:00:00	38000275	0	\N	\N	295666	0	288086009	4125906	
27609	2414	4216130	1994-05-26	1994-05-26 00:00:00	38000275	0	\N	\N	160252	0	415070008	4216130	
39763	3505	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	232527	0	180256009	4107731	
39884	3510	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	232837	0	180256009	4107731	
40176	3527	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	234116	0	180256009	4107731	
40352	3537	4170947	1980-08-01	1980-08-01 00:00:00	38000275	0	\N	\N	234966	0	274474001	4170947	
40409	3542	4125906	2009-05-18	2009-05-18 00:00:00	38000275	0	\N	\N	235325	0	288086009	4125906	
40733	3571	4107731	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	237325	0	180256009	4107731	
40865	3583	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	238284	0	180256009	4107731	
29077	2577	4107731	1992-06-27	1992-06-27 00:00:00	38000275	0	\N	\N	170701	0	180256009	4107731	
41199	3621	4035793	1989-10-28	1989-10-28 00:00:00	38000275	0	\N	\N	240596	0	15081005	4035793	
41452	3639	4078793	2005-04-16	2005-04-16 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
53560	4646	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	309871	0	180256009	4107731	
53692	4655	4107731	1991-05-26	1991-05-26 00:00:00	38000275	0	\N	\N	310401	0	180256009	4107731	
41988	3701	4293740	1962-05-13	1962-05-13 00:00:00	38000275	0	\N	\N	246066	0	384700001	4293740	
42162	3717	4107731	1990-03-31	1990-03-31 00:00:00	38000275	0	\N	\N	247019	0	180256009	4107731	
54305	4719	4107731	1990-04-01	1990-04-01 00:00:00	38000275	0	\N	\N	314301	0	180256009	4107731	
42455	3744	4107731	2003-09-17	2003-09-17 00:00:00	38000275	0	\N	\N	248752	0	180256009	4107731	
42755	3772	4107731	1990-09-15	1990-09-15 00:00:00	38000275	0	\N	\N	250668	0	180256009	4107731	
54795	4753	4043071	1972-10-28	1972-10-28 00:00:00	38000275	0	\N	\N	316484	0	228557008	4043071	
55025	4782	4059978	2008-02-12	2008-02-12 00:00:00	38000275	0	\N	\N	318330	0	169553002	4059978	
31337	2771	4078793	1991-04-05	1991-04-05 00:00:00	38000275	0	\N	\N	183504	0	180325003	4078793	
43404	3839	4243062	2017-04-30	2017-04-30 00:00:00	38000275	0	\N	\N	254864	0	60027007	4243062	
55559	4843	4195803	1974-06-17	1974-06-17 00:00:00	38000275	0	\N	\N	322106	0	312681000	4195803	
55767	4859	4163971	1971-06-05	1971-06-05 00:00:00	38000275	0	\N	\N	323226	0	45595009	4163971	
44128	3884	4191853	1990-01-01	1990-01-01 00:00:00	38000275	0	\N	\N	258142	0	395142003	4191853	
32228	2830	4107731	1992-01-27	1992-01-27 00:00:00	38000275	0	\N	\N	187729	0	180256009	4107731	
56446	4924	4107731	1992-12-02	1992-12-02 00:00:00	38000275	0	\N	\N	327230	0	180256009	4107731	
56557	4927	4295880	1997-03-28	1997-03-28 00:00:00	38000275	0	\N	\N	327442	0	76601001	4295880	
56746	4935	4191853	1985-10-11	1985-10-11 00:00:00	38000275	0	\N	\N	328074	0	395142003	4191853	
44970	3949	4125906	2009-12-12	2009-12-12 00:00:00	38000275	0	\N	\N	262520	0	288086009	4125906	
33188	2902	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	193286	0	180256009	4107731	
45261	3987	4078793	2017-03-11	2017-03-11 00:00:00	38000275	0	\N	\N	265052	0	180325003	4078793	
45704	4026	4107731	1992-11-01	1992-11-01 00:00:00	38000275	0	\N	\N	267621	0	180256009	4107731	
57809	5022	4170947	1977-07-10	1977-07-10 00:00:00	38000275	0	\N	\N	333658	0	274474001	4170947	
46054	4052	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	269412	0	180256009	4107731	
34371	2976	4035793	2018-08-09	2018-08-09 00:00:00	38000275	0	\N	\N	198767	0	15081005	4035793	
34551	2997	4295880	1997-09-28	1997-09-28 00:00:00	38000275	0	\N	\N	199974	0	76601001	4295880	
58583	5073	4078793	2005-08-06	2005-08-06 00:00:00	38000275	0	\N	\N	337208	0	180325003	4078793	
46839	4109	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	273100	0	180256009	4107731	
59082	5117	4107731	1992-08-24	1992-08-24 00:00:00	38000275	0	\N	\N	340066	0	180256009	4107731	
47172	4145	4107731	2009-12-19	2009-12-19 00:00:00	38000275	0	\N	\N	275548	0	180256009	4107731	
59338	5137	4293740	1998-04-21	1998-04-21 00:00:00	38000275	0	\N	\N	341357	0	384700001	4293740	
47618	4176	4125906	1927-11-13	1927-11-13 00:00:00	38000275	0	\N	\N	277542	0	288086009	4125906	
47813	4199	4151422	1948-03-08	1948-03-08 00:00:00	38000275	0	\N	\N	278633	0	269911007	4151422	
24059	2088	4163872	1973-04-21	1973-04-21 00:00:00	38000275	0	\N	\N	139264	0	399208008	4163872	
36251	3177	4057420	2003-01-08	2003-01-08 00:00:00	38000275	0	\N	\N	211350	0	18286008	4057420	
24495	2136	4107731	2002-01-18	2002-01-18 00:00:00	38000275	0	\N	\N	142216	0	180256009	4107731	
36613	3217	4125906	1998-05-08	1998-05-08 00:00:00	38000275	0	\N	\N	213810	0	288086009	4125906	
36812	3238	4058899	1972-11-27	1972-11-27 00:00:00	38000275	0	\N	\N	215316	0	168594001	4058899	
36891	3242	4170947	1988-03-06	1988-03-06 00:00:00	38000275	0	\N	\N	215643	0	274474001	4170947	
37193	3270	4043071	1982-06-14	1982-06-14 00:00:00	38000275	0	\N	\N	217323	0	228557008	4043071	
37312	3279	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	217916	0	180256009	4107731	
37501	3311	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	219879	0	180256009	4107731	
49607	4353	4043071	1977-06-01	1977-06-01 00:00:00	38000275	0	\N	\N	288761	0	228557008	4043071	
37808	3343	4043071	1988-05-10	1988-05-10 00:00:00	38000275	0	\N	\N	221721	0	228557008	4043071	
38118	3364	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	223067	0	180256009	4107731	
38229	3370	4107731	1992-01-12	1992-01-12 00:00:00	38000275	0	\N	\N	223435	0	180256009	4107731	
50349	4376	4035793	2014-01-14	2014-01-14 00:00:00	38000275	0	\N	\N	290823	0	15081005	4035793	
50503	4390	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	291820	0	180256009	4107731	
26924	2352	4107731	1993-03-01	1993-03-01 00:00:00	38000275	0	\N	\N	156697	0	180256009	4107731	
38972	3439	4057420	2015-12-10	2015-12-10 00:00:00	38000275	0	\N	\N	228145	0	18286008	4057420	
51259	4447	4062501	1953-08-27	1953-08-27 00:00:00	38000275	0	\N	\N	295786	0	171231001	4062501	
27610	2414	4078793	1999-11-25	1999-11-25 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
39764	3505	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	232531	0	180256009	4107731	
39885	3510	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	232921	0	180256009	4107731	
40177	3527	4197460	1962-03-10	1962-03-10 00:00:00	38000275	0	\N	\N	234045	0	313191000	4197460	
40353	3537	4047491	1980-08-01	1980-08-01 00:00:00	38000275	0	\N	\N	234966	0	1225002	4047491	
40410	3543	4252419	1978-07-14	1978-07-14 00:00:00	38000275	0	\N	\N	235330	0	74016001	4252419	
40734	3571	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	237326	0	180256009	4107731	
40866	3583	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	238190	0	180256009	4107731	
29078	2577	4107731	1993-03-27	1993-03-27 00:00:00	38000275	0	\N	\N	170704	0	180256009	4107731	
41200	3621	4035793	1986-10-11	1986-10-11 00:00:00	38000275	0	\N	\N	240655	0	15081005	4035793	
41453	3639	4078793	2005-02-12	2005-02-12 00:00:00	38000275	0	\N	\N	242047	0	180325003	4078793	
53561	4646	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	309872	0	180256009	4107731	
53693	4655	4107731	1991-09-29	1991-09-29 00:00:00	38000275	0	\N	\N	310289	0	180256009	4107731	
41989	3701	4125906	1962-05-13	1962-05-13 00:00:00	38000275	0	\N	\N	246066	0	288086009	4125906	
42163	3717	4107731	1991-07-06	1991-07-06 00:00:00	38000275	0	\N	\N	247003	0	180256009	4107731	
54306	4719	4107731	1992-08-30	1992-08-30 00:00:00	38000275	0	\N	\N	314263	0	180256009	4107731	
42456	3744	4107731	2004-04-14	2004-04-14 00:00:00	38000275	0	\N	\N	248828	0	180256009	4107731	
42756	3772	4107731	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	250706	0	180256009	4107731	
54796	4753	4043071	1974-04-27	1974-04-27 00:00:00	38000275	0	\N	\N	316567	0	228557008	4043071	
55026	4782	4295880	2004-12-07	2004-12-07 00:00:00	38000275	0	\N	\N	318318	0	76601001	4295880	
31338	2771	4202451	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	183504	0	433112001	4202451	
43405	3839	4170947	2017-04-30	2017-04-30 00:00:00	38000275	0	\N	\N	254864	0	274474001	4170947	
55560	4843	4170947	1974-06-17	1974-06-17 00:00:00	38000275	0	\N	\N	322106	0	274474001	4170947	
55768	4859	42535580	1971-06-05	1971-06-05 00:00:00	38000275	0	\N	\N	323226	0	426701000119108	42535580	
44129	3884	4043071	1984-10-20	1984-10-20 00:00:00	38000275	0	\N	\N	258039	0	228557008	4043071	
32229	2830	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	187751	0	180256009	4107731	
56447	4924	4107731	1991-04-24	1991-04-24 00:00:00	38000275	0	\N	\N	327165	0	180256009	4107731	
56558	4927	4295880	2004-12-17	2004-12-17 00:00:00	38000275	0	\N	\N	327517	0	76601001	4295880	
56747	4935	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	328031	0	180256009	4107731	
44971	3949	4043071	1978-09-26	1978-09-26 00:00:00	38000275	0	\N	\N	262446	0	228557008	4043071	
33189	2902	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	193389	0	180256009	4107731	
45262	3987	4078793	2019-03-23	2019-03-23 00:00:00	38000275	0	\N	\N	265053	0	180325003	4078793	
45705	4026	4107731	1991-01-20	1991-01-20 00:00:00	38000275	0	\N	\N	267680	0	180256009	4107731	
57810	5022	4024289	1977-07-10	1977-07-10 00:00:00	38000275	0	\N	\N	333658	0	19490002	4024289	
46055	4052	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	269388	0	180256009	4107731	
34372	2976	4035793	2016-07-28	2016-07-28 00:00:00	38000275	0	\N	\N	198766	0	15081005	4035793	
34552	2997	4295880	1996-12-29	1996-12-29 00:00:00	38000275	0	\N	\N	199973	0	76601001	4295880	
58584	5073	4057420	2009-08-29	2009-08-29 00:00:00	38000275	0	\N	\N	337182	0	18286008	4057420	
46840	4109	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	273182	0	180256009	4107731	
59083	5117	4107731	1992-10-05	1992-10-05 00:00:00	38000275	0	\N	\N	340067	0	180256009	4107731	
47173	4145	4191853	2010-01-30	2010-01-30 00:00:00	38000275	0	\N	\N	275481	0	395142003	4191853	
59339	5137	4163872	2002-09-05	2002-09-05 00:00:00	38000275	0	\N	\N	341369	0	399208008	4163872	
47619	4176	4202451	2003-10-23	2003-10-23 00:00:00	38000275	0	\N	\N	277487	0	433112001	4202451	
47814	4199	4058899	1940-02-17	1940-02-17 00:00:00	38000275	0	\N	\N	278705	0	168594001	4058899	
24060	2088	4035793	1991-08-06	1991-08-06 00:00:00	38000275	0	\N	\N	139277	0	15081005	4035793	
36252	3177	4252419	1964-02-18	1964-02-18 00:00:00	38000275	0	\N	\N	211230	0	74016001	4252419	
24496	2136	4107731	2004-11-12	2004-11-12 00:00:00	38000275	0	\N	\N	142270	0	180256009	4107731	
36614	3218	4125906	1997-03-18	1997-03-18 00:00:00	38000275	0	\N	\N	213813	0	288086009	4125906	
36813	3238	44783196	1997-05-27	1997-05-27 00:00:00	38000275	0	\N	\N	215273	0	699253003	44783196	
36892	3244	4125906	1974-04-13	1974-04-13 00:00:00	38000275	0	\N	\N	215744	0	288086009	4125906	
37194	3270	4043071	1982-12-27	1982-12-27 00:00:00	38000275	0	\N	\N	217325	0	228557008	4043071	
37313	3279	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	217932	0	180256009	4107731	
37502	3311	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	219855	0	180256009	4107731	
49608	4353	4043071	1981-05-27	1981-05-27 00:00:00	38000275	0	\N	\N	288782	0	228557008	4043071	
37809	3343	4107731	1992-06-07	1992-06-07 00:00:00	38000275	0	\N	\N	221712	0	180256009	4107731	
38119	3364	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	223152	0	180256009	4107731	
38230	3370	4107731	1993-03-28	1993-03-28 00:00:00	38000275	0	\N	\N	223526	0	180256009	4107731	
50350	4376	4057420	2014-01-14	2014-01-14 00:00:00	38000275	0	\N	\N	290823	0	18286008	4057420	
50504	4390	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	291873	0	180256009	4107731	
26925	2352	4107731	1990-06-18	1990-06-18 00:00:00	38000275	0	\N	\N	156705	0	180256009	4107731	
38973	3439	4078793	2017-12-21	2017-12-21 00:00:00	38000275	0	\N	\N	228146	0	180325003	4078793	
51260	4447	4024289	1955-08-30	1955-08-30 00:00:00	38000275	0	\N	\N	295712	0	19490002	4024289	
27611	2414	4151422	1954-05-30	1954-05-30 00:00:00	38000275	0	\N	\N	160168	0	269911007	4151422	
39765	3505	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	232522	0	180256009	4107731	
39886	3510	4125906	1982-04-19	1982-04-19 00:00:00	38000275	0	\N	\N	232799	0	288086009	4125906	
40178	3527	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	234062	0	180256009	4107731	
40354	3537	4125906	1966-01-30	1966-01-30 00:00:00	38000275	0	\N	\N	234982	0	288086009	4125906	
40411	3543	4238715	1981-08-25	1981-08-25 00:00:00	38000275	0	\N	\N	235338	0	68254000	4238715	
40735	3571	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	237359	0	180256009	4107731	
40867	3583	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	238269	0	180256009	4107731	
29079	2577	4107731	1990-07-14	1990-07-14 00:00:00	38000275	0	\N	\N	170614	0	180256009	4107731	
41201	3621	4035793	1987-10-17	1987-10-17 00:00:00	38000275	0	\N	\N	240595	0	15081005	4035793	
41454	3639	4078793	2005-01-15	2005-01-15 00:00:00	38000275	0	\N	\N	242124	0	180325003	4078793	
53562	4646	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	309803	0	180256009	4107731	
53694	4655	4191853	1993-07-11	1993-07-11 00:00:00	38000275	0	\N	\N	310367	0	395142003	4191853	
41990	3701	44783196	1984-12-25	1984-12-25 00:00:00	38000275	0	\N	\N	246071	0	699253003	44783196	
42164	3717	4107731	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	246999	0	180256009	4107731	
54307	4719	4107731	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	314274	0	180256009	4107731	
42457	3744	44783196	1994-12-24	1994-12-24 00:00:00	38000275	0	\N	\N	248757	0	699253003	44783196	
42757	3772	4107731	1992-06-27	1992-06-27 00:00:00	38000275	0	\N	\N	250705	0	180256009	4107731	
54797	4753	4043071	1973-06-30	1973-06-30 00:00:00	38000275	0	\N	\N	316486	0	228557008	4043071	
55027	4782	4295880	2005-09-06	2005-09-06 00:00:00	38000275	0	\N	\N	318319	0	76601001	4295880	
31339	2771	4078793	1997-05-09	1997-05-09 00:00:00	38000275	0	\N	\N	183483	0	180325003	4078793	
43406	3839	4170947	1951-10-18	1951-10-18 00:00:00	38000275	0	\N	\N	254857	0	274474001	4170947	
55561	4843	4151422	1988-08-13	1988-08-13 00:00:00	38000275	0	\N	\N	322152	0	269911007	4151422	
55769	4859	4242997	1971-06-05	1971-06-05 00:00:00	38000275	0	\N	\N	323226	0	38102005	4242997	
44130	3884	4043071	1988-10-22	1988-10-22 00:00:00	38000275	0	\N	\N	258131	0	228557008	4043071	
32230	2830	4107731	1990-05-07	1990-05-07 00:00:00	38000275	0	\N	\N	187762	0	180256009	4107731	
56448	4924	4107731	1991-09-18	1991-09-18 00:00:00	38000275	0	\N	\N	327264	0	180256009	4107731	
56559	4927	4295880	2000-06-23	2000-06-23 00:00:00	38000275	0	\N	\N	327454	0	76601001	4295880	
56748	4935	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	328123	0	395142003	4191853	
44972	3949	4043071	1978-07-25	1978-07-25 00:00:00	38000275	0	\N	\N	262442	0	228557008	4043071	
33190	2902	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	193298	0	180256009	4107731	
45266	3989	4024289	2003-11-21	2003-11-21 00:00:00	38000275	0	\N	\N	265248	0	19490002	4024289	
45706	4026	4107731	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	267623	0	180256009	4107731	
57811	5022	4151422	1987-08-29	1987-08-29 00:00:00	38000275	0	\N	\N	333694	0	269911007	4151422	
46056	4052	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	269329	0	180256009	4107731	
34373	2976	4035793	2008-10-23	2008-10-23 00:00:00	38000275	0	\N	\N	198777	0	15081005	4035793	
34553	2997	4295880	1996-09-25	1996-09-25 00:00:00	38000275	0	\N	\N	199958	0	76601001	4295880	
58585	5073	4170947	1967-08-19	1967-08-19 00:00:00	38000275	0	\N	\N	337163	0	274474001	4170947	
46841	4109	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	273061	0	180256009	4107731	
59084	5117	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	340083	0	180256009	4107731	
47174	4145	4107731	2008-03-08	2008-03-08 00:00:00	38000275	0	\N	\N	275540	0	180256009	4107731	
59340	5137	4151422	2011-02-24	2011-02-24 00:00:00	38000275	0	\N	\N	341372	0	269911007	4151422	
47620	4176	4125906	2010-07-03	2010-07-03 00:00:00	38000275	0	\N	\N	277546	0	288086009	4125906	
47815	4200	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	278726	0	180256009	4107731	
24061	2088	4035793	2003-06-24	2003-06-24 00:00:00	38000275	0	\N	\N	139289	0	15081005	4035793	
36253	3177	4195803	1976-10-20	1976-10-20 00:00:00	38000275	0	\N	\N	211302	0	312681000	4195803	
24497	2136	4107731	2003-07-18	2003-07-18 00:00:00	38000275	0	\N	\N	142207	0	180256009	4107731	
36615	3218	4047491	1994-01-03	1994-01-03 00:00:00	38000275	0	\N	\N	213812	0	1225002	4047491	
36814	3238	4252419	1997-05-20	1997-05-20 00:00:00	38000275	0	\N	\N	215317	0	74016001	4252419	
36893	3244	4191853	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	215732	0	395142003	4191853	
37195	3270	4043071	1983-05-09	1983-05-09 00:00:00	38000275	0	\N	\N	217249	0	228557008	4043071	
37314	3279	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	217907	0	180256009	4107731	
37503	3311	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	219863	0	180256009	4107731	
49609	4353	4043071	1976-10-27	1976-10-27 00:00:00	38000275	0	\N	\N	288820	0	228557008	4043071	
37810	3343	4043071	1985-08-06	1985-08-06 00:00:00	38000275	0	\N	\N	221844	0	228557008	4043071	
38120	3364	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	223128	0	180256009	4107731	
38231	3370	4107731	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	223437	0	180256009	4107731	
50351	4376	4078793	1981-07-14	1981-07-14 00:00:00	38000275	0	\N	\N	290833	0	180325003	4078793	
50505	4390	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	291806	0	180256009	4107731	
26926	2352	4107731	1991-01-14	1991-01-14 00:00:00	38000275	0	\N	\N	156693	0	180256009	4107731	
38974	3439	4163872	1969-02-20	1969-02-20 00:00:00	38000275	0	\N	\N	228169	0	399208008	4163872	
51261	4447	4170947	1955-08-30	1955-08-30 00:00:00	38000275	0	\N	\N	295712	0	274474001	4170947	
27612	2414	4057420	1995-08-24	1995-08-24 00:00:00	38000275	0	\N	\N	160245	0	18286008	4057420	
39766	3505	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	232504	0	180256009	4107731	
39887	3510	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	232964	0	180256009	4107731	
40179	3527	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	234083	0	180256009	4107731	
40355	3537	4151422	2008-06-03	2008-06-03 00:00:00	38000275	0	\N	\N	234939	0	269911007	4151422	
40412	3543	4275113	1976-06-23	1976-06-23 00:00:00	38000275	0	\N	\N	235377	0	65200003	4275113	
40736	3571	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	237373	0	180256009	4107731	
40868	3583	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	238266	0	180256009	4107731	
29080	2577	4107731	1991-06-15	1991-06-15 00:00:00	38000275	0	\N	\N	170671	0	180256009	4107731	
41202	3621	4323902	1987-12-19	1987-12-19 00:00:00	38000275	0	\N	\N	240589	0	429609002	4323902	
41455	3639	4163872	1954-06-03	1954-06-03 00:00:00	38000275	0	\N	\N	242061	0	399208008	4163872	
53563	4646	4163872	2001-09-20	2001-09-20 00:00:00	38000275	0	\N	\N	309826	0	399208008	4163872	
53695	4655	4107731	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	310384	0	180256009	4107731	
41991	3701	4170947	1955-12-16	1955-12-16 00:00:00	38000275	0	\N	\N	246065	0	274474001	4170947	
42165	3717	4125906	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	246969	0	288086009	4125906	
54308	4719	4107731	1991-02-10	1991-02-10 00:00:00	38000275	0	\N	\N	314305	0	180256009	4107731	
42458	3744	4107731	2004-11-10	2004-11-10 00:00:00	38000275	0	\N	\N	248771	0	180256009	4107731	
42758	3772	4107731	1992-02-22	1992-02-22 00:00:00	38000275	0	\N	\N	250735	0	180256009	4107731	
54798	4753	4043071	1974-02-02	1974-02-02 00:00:00	38000275	0	\N	\N	316566	0	228557008	4043071	
55028	4782	4295880	2008-12-02	2008-12-02 00:00:00	38000275	0	\N	\N	318321	0	76601001	4295880	
31340	2771	4078793	1994-04-22	1994-04-22 00:00:00	38000275	0	\N	\N	183524	0	180325003	4078793	
43407	3839	4243062	1951-10-18	1951-10-18 00:00:00	38000275	0	\N	\N	254857	0	60027007	4243062	
55562	4843	4010253	1987-01-05	1987-01-05 00:00:00	38000275	0	\N	\N	322117	0	112790001	4010253	
55770	4859	4163951	1971-06-05	1971-06-05 00:00:00	38000275	0	\N	\N	323226	0	29303009	4163951	
44131	3884	4107731	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	258205	0	180256009	4107731	
32231	2830	4107731	1992-12-28	1992-12-28 00:00:00	38000275	0	\N	\N	187739	0	180256009	4107731	
56449	4924	4107731	1993-03-17	1993-03-17 00:00:00	38000275	0	\N	\N	327245	0	180256009	4107731	
56560	4927	4295880	2002-06-21	2002-06-21 00:00:00	38000275	0	\N	\N	327529	0	76601001	4295880	
56749	4935	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	328059	0	180256009	4107731	
44973	3949	4043071	1977-07-19	1977-07-19 00:00:00	38000275	0	\N	\N	262508	0	228557008	4043071	
33191	2902	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	193382	0	180256009	4107731	
45267	3989	4170947	2003-11-21	2003-11-21 00:00:00	38000275	0	\N	\N	265248	0	274474001	4170947	
45707	4026	4107731	1992-08-09	1992-08-09 00:00:00	38000275	0	\N	\N	267771	0	180256009	4107731	
57812	5022	4125906	1986-01-24	1986-01-24 00:00:00	38000275	0	\N	\N	333660	0	288086009	4125906	
46057	4052	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	269409	0	180256009	4107731	
34374	2976	4035793	2006-10-12	2006-10-12 00:00:00	38000275	0	\N	\N	198776	0	15081005	4035793	
34554	2997	4295880	1998-09-27	1998-09-27 00:00:00	38000275	0	\N	\N	199928	0	76601001	4295880	
58586	5073	4163872	1967-08-19	1967-08-19 00:00:00	38000275	0	\N	\N	337163	0	399208008	4163872	
46842	4109	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	273075	0	180256009	4107731	
59085	5117	4107731	1992-07-13	1992-07-13 00:00:00	38000275	0	\N	\N	340040	0	180256009	4107731	
47175	4145	4107731	2007-09-01	2007-09-01 00:00:00	38000275	0	\N	\N	275502	0	180256009	4107731	
59341	5137	4062501	1970-06-27	1970-06-27 00:00:00	38000275	0	\N	\N	341436	0	171231001	4062501	
47621	4176	4151422	1972-12-01	1972-12-01 00:00:00	38000275	0	\N	\N	277445	0	269911007	4151422	
47816	4200	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	278768	0	180256009	4107731	
24062	2088	4035793	2002-06-18	2002-06-18 00:00:00	38000275	0	\N	\N	139173	0	15081005	4035793	
36254	3177	4170947	1993-10-04	1993-10-04 00:00:00	38000275	0	\N	\N	211234	0	274474001	4170947	
36279	3179	4202451	1987-05-23	1987-05-23 00:00:00	38000275	0	\N	\N	211539	0	433112001	4202451	
36616	3218	4170947	1994-01-03	1994-01-03 00:00:00	38000275	0	\N	\N	213812	0	274474001	4170947	
36815	3240	4125906	1969-05-06	1969-05-06 00:00:00	38000275	0	\N	\N	215433	0	288086009	4125906	
36894	3244	4151422	2007-09-26	2007-09-26 00:00:00	38000275	0	\N	\N	215719	0	269911007	4151422	
37196	3270	4043071	1986-12-22	1986-12-22 00:00:00	38000275	0	\N	\N	217279	0	228557008	4043071	
37315	3279	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	217960	0	180256009	4107731	
37504	3311	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	219812	0	180256009	4107731	
49610	4353	4043071	1979-03-28	1979-03-28 00:00:00	38000275	0	\N	\N	288743	0	228557008	4043071	
37811	3343	4043071	1987-03-31	1987-03-31 00:00:00	38000275	0	\N	\N	221834	0	228557008	4043071	
38121	3364	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	223151	0	180256009	4107731	
38232	3371	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	223593	0	180256009	4107731	
50355	4379	4170947	1987-04-14	1987-04-14 00:00:00	38000275	0	\N	\N	290992	0	274474001	4170947	
50506	4390	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	291877	0	180256009	4107731	
26927	2352	4107731	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	156696	0	180256009	4107731	
38975	3439	4170947	1969-02-20	1969-02-20 00:00:00	38000275	0	\N	\N	228169	0	274474001	4170947	
51262	4447	4125906	1975-01-17	1975-01-17 00:00:00	38000275	0	\N	\N	295715	0	288086009	4125906	
27621	2418	4170947	1981-09-09	1981-09-09 00:00:00	38000275	0	\N	\N	160441	0	274474001	4170947	
39767	3505	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	232529	0	180256009	4107731	
39888	3510	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	232928	0	180256009	4107731	
40180	3527	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	234076	0	180256009	4107731	
52174	4521	4057420	2000-06-08	2000-06-08 00:00:00	38000275	0	\N	\N	301035	0	18286008	4057420	
40413	3543	4125906	1961-04-30	1961-04-30 00:00:00	38000275	0	\N	\N	235327	0	288086009	4125906	
40737	3571	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	237304	0	180256009	4107731	
40869	3583	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	238252	0	180256009	4107731	
29081	2577	4125906	1986-07-03	1986-07-03 00:00:00	38000275	0	\N	\N	170634	0	288086009	4125906	
41203	3621	4035793	1993-05-22	1993-05-22 00:00:00	38000275	0	\N	\N	240597	0	15081005	4035793	
41456	3639	4078793	2008-07-12	2008-07-12 00:00:00	38000275	0	\N	\N	242094	0	180325003	4078793	
53564	4646	4198190	1964-07-29	1964-07-29 00:00:00	38000275	0	\N	\N	309885	0	80146002	4198190	
53696	4655	4107731	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	310294	0	180256009	4107731	
41992	3701	4243062	1955-12-16	1955-12-16 00:00:00	38000275	0	\N	\N	246065	0	60027007	4243062	
42166	3717	4107731	1992-01-11	1992-01-11 00:00:00	38000275	0	\N	\N	246964	0	180256009	4107731	
54309	4719	4107731	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	314241	0	180256009	4107731	
42459	3744	4107731	2005-06-29	2005-06-29 00:00:00	38000275	0	\N	\N	248773	0	180256009	4107731	
42759	3772	4107731	1991-11-09	1991-11-09 00:00:00	38000275	0	\N	\N	250703	0	180256009	4107731	
54799	4753	4043071	1971-10-30	1971-10-30 00:00:00	38000275	0	\N	\N	316530	0	228557008	4043071	
55029	4782	4295880	2005-12-06	2005-12-06 00:00:00	38000275	0	\N	\N	318312	0	76601001	4295880	
31341	2771	4078793	2005-06-24	2005-06-24 00:00:00	38000275	0	\N	\N	183426	0	180325003	4078793	
43408	3839	4170947	1959-05-09	1959-05-09 00:00:00	38000275	0	\N	\N	254858	0	274474001	4170947	
55563	4844	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	322188	0	180256009	4107731	
55771	4859	4125906	2013-07-28	2013-07-28 00:00:00	38000275	0	\N	\N	323228	0	288086009	4125906	
44132	3884	4043071	1988-12-31	1988-12-31 00:00:00	38000275	0	\N	\N	258136	0	228557008	4043071	
32232	2830	4107731	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	187764	0	180256009	4107731	
56450	4924	4107731	1992-01-01	1992-01-01 00:00:00	38000275	0	\N	\N	327157	0	180256009	4107731	
56561	4927	4295880	1998-06-26	1998-06-26 00:00:00	38000275	0	\N	\N	327525	0	76601001	4295880	
56750	4935	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	328114	0	180256009	4107731	
44974	3949	4043071	1977-09-20	1977-09-20 00:00:00	38000275	0	\N	\N	262473	0	228557008	4043071	
33192	2902	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	193339	0	180256009	4107731	
45268	3989	4195803	2003-11-21	2003-11-21 00:00:00	38000275	0	\N	\N	265248	0	312681000	4195803	
45708	4026	4107731	1990-12-30	1990-12-30 00:00:00	38000275	0	\N	\N	267763	0	180256009	4107731	
57813	5023	4252419	1994-04-13	1994-04-13 00:00:00	38000275	0	\N	\N	333770	0	74016001	4252419	
46058	4052	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	269362	0	180256009	4107731	
34375	2976	4035793	2017-08-03	2017-08-03 00:00:00	38000275	0	\N	\N	198752	0	15081005	4035793	
46445	4071	4163872	1965-10-03	1965-10-03 00:00:00	38000275	0	\N	\N	270611	0	399208008	4163872	
58587	5073	4078793	2010-02-20	2010-02-20 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
46843	4109	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	273098	0	180256009	4107731	
59086	5117	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	340132	0	180256009	4107731	
47176	4145	4107731	2006-12-23	2006-12-23 00:00:00	38000275	0	\N	\N	275515	0	180256009	4107731	
59342	5137	4125906	1989-05-17	1989-05-17 00:00:00	38000275	0	\N	\N	341356	0	288086009	4125906	
47622	4176	4047491	1920-04-23	1920-04-23 00:00:00	38000275	0	\N	\N	277541	0	1225002	4047491	
47817	4200	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	278761	0	180256009	4107731	
24063	2088	4035793	2009-02-17	2009-02-17 00:00:00	38000275	0	\N	\N	139273	0	15081005	4035793	
36255	3177	4024289	1993-10-04	1993-10-04 00:00:00	38000275	0	\N	\N	211234	0	19490002	4024289	
36280	3179	4195803	1979-12-29	1979-12-29 00:00:00	38000275	0	\N	\N	211522	0	312681000	4195803	
36617	3219	4198190	2015-01-11	2015-01-11 00:00:00	38000275	0	\N	\N	213928	0	80146002	4198190	
36816	3240	4202451	2008-10-08	2008-10-08 00:00:00	38000275	0	\N	\N	215384	0	433112001	4202451	
36895	3244	4151422	1985-09-14	1985-09-14 00:00:00	38000275	0	\N	\N	215689	0	269911007	4151422	
37197	3270	4043071	1984-08-13	1984-08-13 00:00:00	38000275	0	\N	\N	217270	0	228557008	4043071	
37316	3279	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	217936	0	180256009	4107731	
37505	3311	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	219767	0	180256009	4107731	
49611	4353	4043071	1976-09-01	1976-09-01 00:00:00	38000275	0	\N	\N	288759	0	228557008	4043071	
37812	3343	4107731	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	221761	0	180256009	4107731	
38122	3364	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	223123	0	180256009	4107731	
38233	3371	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	223592	0	180256009	4107731	
50356	4379	4163872	1987-04-14	1987-04-14 00:00:00	38000275	0	\N	\N	290992	0	399208008	4163872	
50507	4390	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	291799	0	180256009	4107731	
26928	2352	4107731	1991-11-04	1991-11-04 00:00:00	38000275	0	\N	\N	156677	0	180256009	4107731	
38976	3439	4125906	1962-04-02	1962-04-02 00:00:00	38000275	0	\N	\N	228138	0	288086009	4125906	
51263	4447	4170947	1989-06-16	1989-06-16 00:00:00	38000275	0	\N	\N	295719	0	274474001	4170947	
27622	2418	4243062	1981-09-09	1981-09-09 00:00:00	38000275	0	\N	\N	160441	0	60027007	4243062	
39768	3505	4125906	1993-02-16	1993-02-16 00:00:00	38000275	0	\N	\N	232380	0	288086009	4125906	
39889	3510	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	232965	0	180256009	4107731	
40181	3527	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	234109	0	180256009	4107731	
52175	4521	4078793	2002-02-07	2002-02-07 00:00:00	38000275	0	\N	\N	301023	0	180325003	4078793	
40414	3543	4186930	1981-06-23	1981-06-23 00:00:00	38000275	0	\N	\N	235394	0	46706006	4186930	
40738	3571	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	237340	0	180256009	4107731	
40870	3583	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	238253	0	180256009	4107731	
29082	2577	4293740	1986-07-03	1986-07-03 00:00:00	38000275	0	\N	\N	170634	0	384700001	4293740	
41204	3621	4035793	1990-11-03	1990-11-03 00:00:00	38000275	0	\N	\N	240605	0	15081005	4035793	
41457	3639	4078793	2005-06-25	2005-06-25 00:00:00	38000275	0	\N	\N	242057	0	180325003	4078793	
53565	4646	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	309763	0	180256009	4107731	
53697	4655	4107731	1990-12-09	1990-12-09 00:00:00	38000275	0	\N	\N	310355	0	180256009	4107731	
41993	3701	4125906	2000-01-09	2000-01-09 00:00:00	38000275	0	\N	\N	246100	0	288086009	4125906	
42167	3717	4107731	1993-05-29	1993-05-29 00:00:00	38000275	0	\N	\N	247015	0	180256009	4107731	
54310	4719	4107731	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	314252	0	180256009	4107731	
42460	3744	4107731	2003-07-16	2003-07-16 00:00:00	38000275	0	\N	\N	248825	0	180256009	4107731	
42760	3772	4107731	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	250677	0	180256009	4107731	
54800	4753	4043071	1972-05-06	1972-05-06 00:00:00	38000275	0	\N	\N	316533	0	228557008	4043071	
55030	4782	4295880	2004-03-04	2004-03-04 00:00:00	38000275	0	\N	\N	318325	0	76601001	4295880	
31342	2771	4078793	2015-08-21	2015-08-21 00:00:00	38000275	0	\N	\N	183514	0	180325003	4078793	
43409	3839	4024289	1959-05-09	1959-05-09 00:00:00	38000275	0	\N	\N	254858	0	19490002	4024289	
55564	4844	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	322242	0	180256009	4107731	
55772	4860	4058899	1995-08-01	1995-08-01 00:00:00	38000275	0	\N	\N	323340	0	168594001	4058899	
55914	4878	4107731	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	324437	0	180256009	4107731	
32233	2830	4107731	1992-08-03	1992-08-03 00:00:00	38000275	0	\N	\N	187730	0	180256009	4107731	
56451	4924	4107731	1994-03-30	1994-03-30 00:00:00	38000275	0	\N	\N	327172	0	180256009	4107731	
56562	4927	4295880	2001-12-21	2001-12-21 00:00:00	38000275	0	\N	\N	327446	0	76601001	4295880	
56751	4935	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	328083	0	180256009	4107731	
44975	3949	4043071	1978-01-17	1978-01-17 00:00:00	38000275	0	\N	\N	262456	0	228557008	4043071	
33193	2902	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	193344	0	180256009	4107731	
45269	3989	4151422	1959-01-20	1959-01-20 00:00:00	38000275	0	\N	\N	265155	0	269911007	4151422	
45709	4026	4107731	1990-07-15	1990-07-15 00:00:00	38000275	0	\N	\N	267615	0	180256009	4107731	
57814	5023	4151422	1994-09-12	1994-09-12 00:00:00	38000275	0	\N	\N	333746	0	269911007	4151422	
46059	4052	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	269413	0	180256009	4107731	
34376	2976	4181917	1955-06-23	1955-06-23 00:00:00	38000275	0	\N	\N	198734	0	54550000	4181917	
46446	4071	4037675	2005-09-19	2005-09-19 00:00:00	38000275	0	\N	\N	270627	0	162676008	4037675	
58588	5073	4057420	2010-09-04	2010-09-04 00:00:00	38000275	0	\N	\N	337256	0	18286008	4057420	
46844	4109	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	273186	0	180256009	4107731	
59087	5117	4107731	1991-09-02	1991-09-02 00:00:00	38000275	0	\N	\N	340036	0	180256009	4107731	
47177	4145	4107731	2008-11-15	2008-11-15 00:00:00	38000275	0	\N	\N	275458	0	180256009	4107731	
59343	5137	4151422	1975-01-17	1975-01-17 00:00:00	38000275	0	\N	\N	341395	0	269911007	4151422	
47623	4176	4170947	1920-04-23	1920-04-23 00:00:00	38000275	0	\N	\N	277541	0	274474001	4170947	
47818	4200	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	278834	0	180256009	4107731	
24064	2088	4035793	2001-06-12	2001-06-12 00:00:00	38000275	0	\N	\N	139288	0	15081005	4035793	
36256	3177	4170947	1985-12-15	1985-12-15 00:00:00	38000275	0	\N	\N	211233	0	274474001	4170947	
36281	3179	4125906	1944-09-11	1944-09-11 00:00:00	38000275	0	\N	\N	211529	0	288086009	4125906	
36618	3219	4151422	1985-05-24	1985-05-24 00:00:00	38000275	0	\N	\N	213908	0	269911007	4151422	
36817	3240	4151422	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	215346	0	269911007	4151422	
36896	3246	4151422	1982-02-10	1982-02-10 00:00:00	38000275	0	\N	\N	215803	0	269911007	4151422	
37198	3270	4043071	1983-12-26	1983-12-26 00:00:00	38000275	0	\N	\N	217251	0	228557008	4043071	
37317	3279	4191853	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	217867	0	395142003	4191853	
37506	3311	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	219804	0	180256009	4107731	
49612	4353	4043071	1976-12-29	1976-12-29 00:00:00	38000275	0	\N	\N	288760	0	228557008	4043071	
37813	3343	4043071	1986-07-01	1986-07-01 00:00:00	38000275	0	\N	\N	221811	0	228557008	4043071	
38123	3364	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	223110	0	180256009	4107731	
38234	3371	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	223627	0	180256009	4107731	
50357	4380	4043071	1977-05-22	1977-05-22 00:00:00	38000275	0	\N	\N	291031	0	228557008	4043071	
50508	4390	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	291814	0	180256009	4107731	
38743	3407	4238715	1978-10-27	1978-10-27 00:00:00	38000275	0	\N	\N	225962	0	68254000	4238715	
38977	3439	4151422	1988-04-26	1988-04-26 00:00:00	38000275	0	\N	\N	228188	0	269911007	4151422	
51264	4447	4047491	1989-06-16	1989-06-16 00:00:00	38000275	0	\N	\N	295719	0	1225002	4047491	
27623	2418	4125906	1996-09-20	1996-09-20 00:00:00	38000275	0	\N	\N	160467	0	288086009	4125906	
39769	3505	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	232480	0	180256009	4107731	
39890	3510	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	232825	0	180256009	4107731	
40182	3527	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	234078	0	180256009	4107731	
52176	4521	4125906	1951-12-07	1951-12-07 00:00:00	38000275	0	\N	\N	301011	0	288086009	4125906	
40415	3543	44783196	1978-07-21	1978-07-21 00:00:00	38000275	0	\N	\N	235332	0	699253003	44783196	
40739	3571	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	237302	0	180256009	4107731	
40871	3583	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	238220	0	180256009	4107731	
29083	2577	4107731	1993-01-23	1993-01-23 00:00:00	38000275	0	\N	\N	170679	0	180256009	4107731	
41205	3621	4125906	1973-12-15	1973-12-15 00:00:00	38000275	0	\N	\N	240633	0	288086009	4125906	
41458	3639	4078793	2005-06-11	2005-06-11 00:00:00	38000275	0	\N	\N	242048	0	180325003	4078793	
53566	4646	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	309820	0	180256009	4107731	
53698	4655	4107731	1990-04-01	1990-04-01 00:00:00	38000275	0	\N	\N	310267	0	180256009	4107731	
41998	3703	4107731	1990-06-02	1990-06-02 00:00:00	38000275	0	\N	\N	246213	0	180256009	4107731	
42168	3717	4107731	1992-02-22	1992-02-22 00:00:00	38000275	0	\N	\N	246971	0	180256009	4107731	
54311	4719	4107731	1993-05-09	1993-05-09 00:00:00	38000275	0	\N	\N	314177	0	180256009	4107731	
42461	3744	4107731	2005-12-14	2005-12-14 00:00:00	38000275	0	\N	\N	248808	0	180256009	4107731	
42761	3772	4107731	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	250701	0	180256009	4107731	
54801	4753	4043071	1973-05-26	1973-05-26 00:00:00	38000275	0	\N	\N	316551	0	228557008	4043071	
55031	4782	4295880	2009-03-03	2009-03-03 00:00:00	38000275	0	\N	\N	318332	0	76601001	4295880	
31343	2771	4125906	1946-11-23	1946-11-23 00:00:00	38000275	0	\N	\N	183469	0	288086009	4125906	
43410	3839	4043071	1963-11-24	1963-11-24 00:00:00	38000275	0	\N	\N	254871	0	228557008	4043071	
55565	4844	4197460	1959-09-24	1959-09-24 00:00:00	38000275	0	\N	\N	322277	0	313191000	4197460	
55773	4860	4151422	1980-06-21	1980-06-21 00:00:00	38000275	0	\N	\N	323343	0	269911007	4151422	
55915	4878	4107731	1992-12-12	1992-12-12 00:00:00	38000275	0	\N	\N	324363	0	180256009	4107731	
32234	2830	4107731	1990-04-16	1990-04-16 00:00:00	38000275	0	\N	\N	187710	0	180256009	4107731	
56452	4924	4107731	1991-03-13	1991-03-13 00:00:00	38000275	0	\N	\N	327164	0	180256009	4107731	
56563	4927	4295880	2004-06-18	2004-06-18 00:00:00	38000275	0	\N	\N	327467	0	76601001	4295880	
56752	4935	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	328058	0	180256009	4107731	
44976	3949	4043071	1978-04-18	1978-04-18 00:00:00	38000275	0	\N	\N	262480	0	228557008	4043071	
33194	2902	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	193345	0	180256009	4107731	
45270	3989	4195803	2018-01-29	2018-01-29 00:00:00	38000275	0	\N	\N	265193	0	312681000	4195803	
45710	4026	4107731	1991-05-05	1991-05-05 00:00:00	38000275	0	\N	\N	267774	0	180256009	4107731	
57815	5023	44783196	1994-04-20	1994-04-20 00:00:00	38000275	0	\N	\N	333798	0	699253003	44783196	
46060	4052	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	269358	0	180256009	4107731	
34377	2976	4035793	2009-10-29	2009-10-29 00:00:00	38000275	0	\N	\N	198733	0	15081005	4035793	
46447	4071	4187458	2005-09-19	2005-09-19 00:00:00	38000275	0	\N	\N	270627	0	415300000	4187458	
58589	5073	4078793	2003-07-26	2003-07-26 00:00:00	38000275	0	\N	\N	337207	0	180325003	4078793	
46845	4109	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	273092	0	180256009	4107731	
59088	5117	4107731	1990-08-20	1990-08-20 00:00:00	38000275	0	\N	\N	340120	0	180256009	4107731	
47178	4145	4107731	2008-10-04	2008-10-04 00:00:00	38000275	0	\N	\N	275508	0	180256009	4107731	
59344	5138	4243062	2011-02-28	2011-02-28 00:00:00	38000275	0	\N	\N	341455	0	60027007	4243062	
59467	5145	4151422	2000-02-18	2000-02-18 00:00:00	38000275	0	\N	\N	342006	0	269911007	4151422	
47819	4200	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	278807	0	180256009	4107731	
24065	2088	4170947	1911-09-07	1911-09-07 00:00:00	38000275	0	\N	\N	139176	0	274474001	4170947	
36257	3177	4243062	1985-12-15	1985-12-15 00:00:00	38000275	0	\N	\N	211233	0	60027007	4243062	
36287	3181	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	211757	0	395142003	4191853	
36619	3219	4170947	2005-11-08	2005-11-08 00:00:00	38000275	0	\N	\N	213931	0	274474001	4170947	
36818	3240	4170947	1951-05-27	1951-05-27 00:00:00	38000275	0	\N	\N	215430	0	274474001	4170947	
36897	3246	4058899	1984-06-27	1984-06-27 00:00:00	38000275	0	\N	\N	215819	0	168594001	4058899	
37199	3270	4043071	1986-02-03	1986-02-03 00:00:00	38000275	0	\N	\N	217293	0	228557008	4043071	
37318	3279	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	217836	0	180256009	4107731	
37507	3311	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	219880	0	180256009	4107731	
49613	4353	4043071	1977-03-02	1977-03-02 00:00:00	38000275	0	\N	\N	288726	0	228557008	4043071	
37814	3343	4107731	1992-05-17	1992-05-17 00:00:00	38000275	0	\N	\N	221853	0	180256009	4107731	
38124	3364	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	223033	0	180256009	4107731	
38235	3371	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	223575	0	180256009	4107731	
50358	4380	4043071	1977-08-28	1977-08-28 00:00:00	38000275	0	\N	\N	291019	0	228557008	4043071	
50509	4390	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	291840	0	180256009	4107731	
38744	3407	4275113	1977-01-24	1977-01-24 00:00:00	38000275	0	\N	\N	225955	0	65200003	4275113	
38978	3440	4125906	1981-09-21	1981-09-21 00:00:00	38000275	0	\N	\N	228227	0	288086009	4125906	
51265	4448	4163872	1962-04-05	1962-04-05 00:00:00	38000275	0	\N	\N	295850	0	399208008	4163872	
27624	2418	4198190	1995-09-01	1995-09-01 00:00:00	38000275	0	\N	\N	160468	0	80146002	4198190	
39770	3505	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	232452	0	180256009	4107731	
39891	3510	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	232824	0	180256009	4107731	
40183	3527	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	234093	0	180256009	4107731	
52177	4521	4293740	1951-12-07	1951-12-07 00:00:00	38000275	0	\N	\N	301011	0	384700001	4293740	
40416	3545	4151422	1998-09-13	1998-09-13 00:00:00	38000275	0	\N	\N	235448	0	269911007	4151422	
40740	3571	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	237339	0	180256009	4107731	
40872	3583	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	238182	0	180256009	4107731	
29084	2577	4107731	1991-07-27	1991-07-27 00:00:00	38000275	0	\N	\N	170672	0	180256009	4107731	
41206	3621	4035793	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	240604	0	15081005	4035793	
41459	3639	4078793	2005-04-23	2005-04-23 00:00:00	38000275	0	\N	\N	242092	0	180325003	4078793	
53567	4646	4151422	1986-06-11	1986-06-11 00:00:00	38000275	0	\N	\N	309856	0	269911007	4151422	
53699	4655	4107731	1993-05-09	1993-05-09 00:00:00	38000275	0	\N	\N	310295	0	180256009	4107731	
41999	3703	4107731	1990-01-27	1990-01-27 00:00:00	38000275	0	\N	\N	246260	0	180256009	4107731	
42169	3717	4107731	1991-05-25	1991-05-25 00:00:00	38000275	0	\N	\N	247002	0	180256009	4107731	
54312	4719	4107731	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	314282	0	180256009	4107731	
42462	3744	4107731	2006-01-04	2006-01-04 00:00:00	38000275	0	\N	\N	248833	0	180256009	4107731	
42762	3772	4107731	1990-06-02	1990-06-02 00:00:00	38000275	0	\N	\N	250699	0	180256009	4107731	
54802	4753	4043071	1972-02-05	1972-02-05 00:00:00	38000275	0	\N	\N	316482	0	228557008	4043071	
55032	4782	4295880	2009-06-02	2009-06-02 00:00:00	38000275	0	\N	\N	318334	0	76601001	4295880	
31344	2771	4078793	1989-03-24	1989-03-24 00:00:00	38000275	0	\N	\N	183503	0	180325003	4078793	
43411	3839	4043071	1964-03-22	1964-03-22 00:00:00	38000275	0	\N	\N	254872	0	228557008	4043071	
55566	4844	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	322212	0	180256009	4107731	
55774	4860	4151422	2015-11-14	2015-11-14 00:00:00	38000275	0	\N	\N	323291	0	269911007	4151422	
55916	4878	4107731	1990-04-21	1990-04-21 00:00:00	38000275	0	\N	\N	324378	0	180256009	4107731	
32235	2830	4107731	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	187809	0	180256009	4107731	
56453	4924	4107731	1992-04-15	1992-04-15 00:00:00	38000275	0	\N	\N	327214	0	180256009	4107731	
56564	4927	4295880	1998-03-27	1998-03-27 00:00:00	38000275	0	\N	\N	327450	0	76601001	4295880	
56753	4935	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	328030	0	180256009	4107731	
44977	3949	4043071	1978-08-22	1978-08-22 00:00:00	38000275	0	\N	\N	262445	0	228557008	4043071	
33195	2902	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	193296	0	180256009	4107731	
45272	3991	4195803	2016-01-23	2016-01-23 00:00:00	38000275	0	\N	\N	265352	0	312681000	4195803	
45711	4026	4107731	1993-05-09	1993-05-09 00:00:00	38000275	0	\N	\N	267622	0	180256009	4107731	
57816	5023	4151422	2003-02-01	2003-02-01 00:00:00	38000275	0	\N	\N	333777	0	269911007	4151422	
46061	4052	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	269295	0	180256009	4107731	
34378	2976	4035793	2014-07-17	2014-07-17 00:00:00	38000275	0	\N	\N	198765	0	15081005	4035793	
46448	4071	4326177	2005-09-19	2005-09-19 00:00:00	38000275	0	\N	\N	270627	0	430193006	4326177	
58590	5073	4057420	2006-08-12	2006-08-12 00:00:00	38000275	0	\N	\N	337217	0	18286008	4057420	
46846	4109	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	273148	0	180256009	4107731	
59089	5117	4107731	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	340147	0	180256009	4107731	
47179	4145	4107731	2007-07-21	2007-07-21 00:00:00	38000275	0	\N	\N	275538	0	180256009	4107731	
59345	5138	4170947	2011-02-28	2011-02-28 00:00:00	38000275	0	\N	\N	341455	0	274474001	4170947	
59468	5146	4202451	2013-07-15	2013-07-15 00:00:00	38000275	0	\N	\N	342126	0	433112001	4202451	
47820	4200	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	278842	0	180256009	4107731	
24066	2088	4024289	1911-09-07	1911-09-07 00:00:00	38000275	0	\N	\N	139176	0	19490002	4024289	
36258	3177	4293740	1934-10-27	1934-10-27 00:00:00	38000275	0	\N	\N	211227	0	384700001	4293740	
36288	3181	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	211811	0	180256009	4107731	
36620	3219	4024289	2005-11-08	2005-11-08 00:00:00	38000275	0	\N	\N	213931	0	19490002	4024289	
36819	3240	4024289	1951-05-27	1951-05-27 00:00:00	38000275	0	\N	\N	215430	0	19490002	4024289	
36901	3248	4078793	2010-04-16	2010-04-16 00:00:00	38000275	0	\N	\N	215916	0	180325003	4078793	
37200	3270	4043071	1982-01-11	1982-01-11 00:00:00	38000275	0	\N	\N	217321	0	228557008	4043071	
37319	3279	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	217832	0	180256009	4107731	
37508	3311	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	219807	0	180256009	4107731	
49614	4353	4043071	1979-01-17	1979-01-17 00:00:00	38000275	0	\N	\N	288765	0	228557008	4043071	
37815	3343	4107731	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	221722	0	180256009	4107731	
38125	3364	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	223147	0	180256009	4107731	
38236	3371	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	223616	0	180256009	4107731	
50359	4380	4170947	1970-05-19	1970-05-19 00:00:00	38000275	0	\N	\N	290995	0	274474001	4170947	
50510	4390	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	291918	0	180256009	4107731	
38745	3407	4125906	2006-05-30	2006-05-30 00:00:00	38000275	0	\N	\N	225978	0	288086009	4125906	
38979	3440	4125906	2004-12-22	2004-12-22 00:00:00	38000275	0	\N	\N	228229	0	288086009	4125906	
51336	4450	4252419	1976-11-22	1976-11-22 00:00:00	38000275	0	\N	\N	296084	0	74016001	4252419	
27625	2419	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	160495	0	180256009	4107731	
39771	3505	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	232451	0	180256009	4107731	
39892	3510	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	232865	0	180256009	4107731	
40184	3527	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	234061	0	180256009	4107731	
52178	4521	4078793	2006-10-26	2006-10-26 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
40417	3545	4151422	1985-05-15	1985-05-15 00:00:00	38000275	0	\N	\N	235482	0	269911007	4151422	
40741	3571	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	237333	0	180256009	4107731	
40873	3583	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	238277	0	180256009	4107731	
29085	2577	4107731	1993-02-13	1993-02-13 00:00:00	38000275	0	\N	\N	170703	0	180256009	4107731	
41207	3622	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	240812	0	180256009	4107731	
41460	3639	4078793	2009-07-18	2009-07-18 00:00:00	38000275	0	\N	\N	242081	0	180325003	4078793	
53568	4646	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	309771	0	180256009	4107731	
53700	4655	4107731	1991-03-03	1991-03-03 00:00:00	38000275	0	\N	\N	310357	0	180256009	4107731	
42000	3703	4107731	1990-04-21	1990-04-21 00:00:00	38000275	0	\N	\N	246212	0	180256009	4107731	
42170	3717	4107731	1993-02-13	1993-02-13 00:00:00	38000275	0	\N	\N	246976	0	180256009	4107731	
54313	4719	4107731	1992-01-12	1992-01-12 00:00:00	38000275	0	\N	\N	314261	0	180256009	4107731	
42463	3744	4107731	2003-08-06	2003-08-06 00:00:00	38000275	0	\N	\N	248796	0	180256009	4107731	
42763	3772	4107731	1990-07-14	1990-07-14 00:00:00	38000275	0	\N	\N	250728	0	180256009	4107731	
54803	4753	4043071	1974-03-02	1974-03-02 00:00:00	38000275	0	\N	\N	316553	0	228557008	4043071	
55033	4782	4295880	2006-12-05	2006-12-05 00:00:00	38000275	0	\N	\N	318328	0	76601001	4295880	
31345	2771	4078793	1981-02-06	1981-02-06 00:00:00	38000275	0	\N	\N	183479	0	180325003	4078793	
43412	3839	4043071	1964-01-19	1964-01-19 00:00:00	38000275	0	\N	\N	254839	0	228557008	4043071	
55567	4844	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	322183	0	180256009	4107731	
55775	4860	4163872	1988-05-27	1988-05-27 00:00:00	38000275	0	\N	\N	323289	0	399208008	4163872	
55917	4878	4107731	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	324426	0	180256009	4107731	
32236	2830	4107731	1991-08-12	1991-08-12 00:00:00	38000275	0	\N	\N	187734	0	180256009	4107731	
56454	4924	4107731	1993-02-24	1993-02-24 00:00:00	38000275	0	\N	\N	327274	0	180256009	4107731	
56565	4927	4295880	2001-06-22	2001-06-22 00:00:00	38000275	0	\N	\N	327503	0	76601001	4295880	
56754	4935	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	328065	0	180256009	4107731	
44978	3949	4043071	1977-05-24	1977-05-24 00:00:00	38000275	0	\N	\N	262472	0	228557008	4043071	
33196	2902	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	193270	0	180256009	4107731	
45273	3991	4047491	1958-01-29	1958-01-29 00:00:00	38000275	0	\N	\N	265375	0	1225002	4047491	
45712	4026	4243062	1970-07-22	1970-07-22 00:00:00	38000275	0	\N	\N	267695	0	60027007	4243062	
57817	5023	4062501	1974-08-13	1974-08-13 00:00:00	38000275	0	\N	\N	333749	0	171231001	4062501	
46062	4052	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	269411	0	180256009	4107731	
34379	2976	4337138	2006-12-07	2006-12-07 00:00:00	38000275	0	\N	\N	198747	0	88039007	4337138	
46449	4071	4125906	2003-06-24	2003-06-24 00:00:00	38000275	0	\N	\N	270615	0	288086009	4125906	
58592	5076	4043071	1946-04-03	1946-04-03 00:00:00	38000275	0	\N	\N	337426	0	228557008	4043071	
46847	4109	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	273097	0	180256009	4107731	
59090	5117	4107731	1992-11-16	1992-11-16 00:00:00	38000275	0	\N	\N	340068	0	180256009	4107731	
47180	4145	4107731	2007-05-19	2007-05-19 00:00:00	38000275	0	\N	\N	275473	0	180256009	4107731	
59346	5138	4047491	2001-08-28	2001-08-28 00:00:00	38000275	0	\N	\N	341453	0	1225002	4047491	
59469	5146	4151422	2012-05-29	2012-05-29 00:00:00	38000275	0	\N	\N	342113	0	269911007	4151422	
47821	4200	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	278804	0	180256009	4107731	
24067	2090	4047491	1971-03-07	1971-03-07 00:00:00	38000275	0	\N	\N	139371	0	1225002	4047491	
36259	3177	4125906	1934-10-27	1934-10-27 00:00:00	38000275	0	\N	\N	211227	0	288086009	4125906	
36289	3181	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	211670	0	180256009	4107731	
36621	3219	4163872	1997-09-15	1997-09-15 00:00:00	38000275	0	\N	\N	213911	0	399208008	4163872	
36820	3240	4125906	1963-02-23	1963-02-23 00:00:00	38000275	0	\N	\N	215431	0	288086009	4125906	
36902	3248	4078793	2018-06-01	2018-06-01 00:00:00	38000275	0	\N	\N	215891	0	180325003	4078793	
37201	3270	4043071	1985-11-25	1985-11-25 00:00:00	38000275	0	\N	\N	217275	0	228557008	4043071	
37320	3279	4151422	1966-09-14	1966-09-14 00:00:00	38000275	0	\N	\N	217884	0	269911007	4151422	
37509	3311	4151422	1969-10-10	1969-10-10 00:00:00	38000275	0	\N	\N	219754	0	269911007	4151422	
49615	4353	4043071	1979-05-02	1979-05-02 00:00:00	38000275	0	\N	\N	288744	0	228557008	4043071	
37816	3343	4107731	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	221837	0	180256009	4107731	
38126	3364	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	223127	0	180256009	4107731	
38237	3371	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	223533	0	180256009	4107731	
50360	4380	4163872	1970-05-19	1970-05-19 00:00:00	38000275	0	\N	\N	290995	0	399208008	4163872	
50511	4390	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	291885	0	180256009	4107731	
38746	3408	4125906	1999-06-12	1999-06-12 00:00:00	38000275	0	\N	\N	226022	0	288086009	4125906	
38980	3440	4125906	2014-09-20	2014-09-20 00:00:00	38000275	0	\N	\N	228231	0	288086009	4125906	
51337	4450	4170947	2015-04-16	2015-04-16 00:00:00	38000275	0	\N	\N	296086	0	274474001	4170947	
27626	2419	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	160621	0	180256009	4107731	
39772	3505	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	232443	0	180256009	4107731	
39893	3510	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	232906	0	180256009	4107731	
40185	3527	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	234063	0	180256009	4107731	
52179	4521	4078793	2003-10-30	2003-10-30 00:00:00	38000275	0	\N	\N	301024	0	180325003	4078793	
40418	3545	4145310	1983-05-29	1983-05-29 00:00:00	38000275	0	\N	\N	235438	0	268425006	4145310	
40742	3571	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	237412	0	180256009	4107731	
40874	3583	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	238187	0	180256009	4107731	
29086	2577	4107731	1992-02-01	1992-02-01 00:00:00	38000275	0	\N	\N	170630	0	180256009	4107731	
41208	3622	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	240663	0	180256009	4107731	
41461	3639	4170947	1931-12-21	1931-12-21 00:00:00	38000275	0	\N	\N	242120	0	274474001	4170947	
53569	4646	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	309873	0	180256009	4107731	
53701	4655	4107731	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	310396	0	180256009	4107731	
42001	3703	4151422	2013-08-09	2013-08-09 00:00:00	38000275	0	\N	\N	246230	0	269911007	4151422	
42171	3717	4107731	1990-06-02	1990-06-02 00:00:00	38000275	0	\N	\N	247069	0	180256009	4107731	
54314	4719	4107731	1990-09-16	1990-09-16 00:00:00	38000275	0	\N	\N	314238	0	180256009	4107731	
42464	3744	4107731	2006-05-31	2006-05-31 00:00:00	38000275	0	\N	\N	248783	0	180256009	4107731	
42764	3772	4107731	1993-05-29	1993-05-29 00:00:00	38000275	0	\N	\N	250686	0	180256009	4107731	
54804	4753	4043071	1971-10-02	1971-10-02 00:00:00	38000275	0	\N	\N	316481	0	228557008	4043071	
55034	4782	4295880	2008-09-02	2008-09-02 00:00:00	38000275	0	\N	\N	318363	0	76601001	4295880	
31346	2771	4078793	2004-06-18	2004-06-18 00:00:00	38000275	0	\N	\N	183512	0	180325003	4078793	
43413	3839	4010253	1962-07-18	1962-07-18 00:00:00	38000275	0	\N	\N	254908	0	112790001	4010253	
55568	4844	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	322204	0	180256009	4107731	
55776	4861	4062501	1982-06-02	1982-06-02 00:00:00	38000275	0	\N	\N	323415	0	171231001	4062501	
55918	4878	4107731	1992-02-22	1992-02-22 00:00:00	38000275	0	\N	\N	324435	0	180256009	4107731	
32237	2830	4062501	2006-08-11	2006-08-11 00:00:00	38000275	0	\N	\N	187767	0	171231001	4062501	
56455	4924	4107731	1992-07-08	1992-07-08 00:00:00	38000275	0	\N	\N	327216	0	180256009	4107731	
56566	4927	4295880	1995-12-29	1995-12-29 00:00:00	38000275	0	\N	\N	327497	0	76601001	4295880	
56755	4935	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	328029	0	180256009	4107731	
44979	3950	4043071	1982-03-29	1982-03-29 00:00:00	38000275	0	\N	\N	262530	0	228557008	4043071	
33197	2902	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	193269	0	180256009	4107731	
45274	3991	4170947	1958-01-29	1958-01-29 00:00:00	38000275	0	\N	\N	265375	0	274474001	4170947	
45713	4026	4170947	1970-07-22	1970-07-22 00:00:00	38000275	0	\N	\N	267695	0	274474001	4170947	
57818	5023	4330583	2002-08-13	2002-08-13 00:00:00	38000275	0	\N	\N	333740	0	22523008	4330583	
46063	4052	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	269395	0	180256009	4107731	
34380	2976	4035793	2011-11-10	2011-11-10 00:00:00	38000275	0	\N	\N	198764	0	15081005	4035793	
46450	4072	4125906	2013-12-09	2013-12-09 00:00:00	38000275	0	\N	\N	270691	0	288086009	4125906	
58593	5076	4043071	1946-05-08	1946-05-08 00:00:00	38000275	0	\N	\N	337427	0	228557008	4043071	
46848	4109	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	273212	0	180256009	4107731	
59091	5117	4107731	1990-06-18	1990-06-18 00:00:00	38000275	0	\N	\N	340099	0	180256009	4107731	
47181	4145	4125906	2012-09-15	2012-09-15 00:00:00	38000275	0	\N	\N	275465	0	288086009	4125906	
59347	5138	4170947	2001-08-28	2001-08-28 00:00:00	38000275	0	\N	\N	341453	0	274474001	4170947	
59470	5146	4125906	1953-08-19	1953-08-19 00:00:00	38000275	0	\N	\N	342082	0	288086009	4125906	
47822	4200	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	278806	0	180256009	4107731	
24068	2090	4170947	1971-03-07	1971-03-07 00:00:00	38000275	0	\N	\N	139371	0	274474001	4170947	
36260	3178	4078793	2010-10-16	2010-10-16 00:00:00	38000275	0	\N	\N	211436	0	180325003	4078793	
36290	3181	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	211816	0	180256009	4107731	
36622	3219	4145310	1996-08-27	1996-08-27 00:00:00	38000275	0	\N	\N	213930	0	268425006	4145310	
36821	3241	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	215471	0	180256009	4107731	
36903	3248	4125906	1968-09-29	1968-09-29 00:00:00	38000275	0	\N	\N	215879	0	288086009	4125906	
37202	3270	4043071	1987-04-27	1987-04-27 00:00:00	38000275	0	\N	\N	217354	0	228557008	4043071	
37321	3279	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	217862	0	180256009	4107731	
37510	3311	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	219882	0	180256009	4107731	
49668	4355	4125906	2013-05-14	2013-05-14 00:00:00	38000275	0	\N	\N	288963	0	288086009	4125906	
37817	3343	4107731	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	221703	0	180256009	4107731	
38127	3364	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	223120	0	180256009	4107731	
38238	3371	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	223617	0	180256009	4107731	
50361	4380	4043071	1977-07-24	1977-07-24 00:00:00	38000275	0	\N	\N	291018	0	228557008	4043071	
50512	4390	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	291842	0	180256009	4107731	
38747	3409	4170947	2005-01-27	2005-01-27 00:00:00	38000275	0	\N	\N	226123	0	274474001	4170947	
38981	3440	4195803	1944-01-29	1944-01-29 00:00:00	38000275	0	\N	\N	228291	0	312681000	4195803	
51338	4450	4024289	2015-04-16	2015-04-16 00:00:00	38000275	0	\N	\N	296086	0	19490002	4024289	
27627	2419	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	160521	0	180256009	4107731	
39773	3505	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	232506	0	180256009	4107731	
39894	3510	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	232911	0	180256009	4107731	
40186	3527	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	234092	0	180256009	4107731	
52180	4521	4078793	2004-11-04	2004-11-04 00:00:00	38000275	0	\N	\N	301038	0	180325003	4078793	
40421	3547	4170947	1977-12-03	1977-12-03 00:00:00	38000275	0	\N	\N	235540	0	274474001	4170947	
40743	3571	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	237362	0	180256009	4107731	
40875	3583	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	238239	0	180256009	4107731	
29087	2577	4107731	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	170633	0	180256009	4107731	
41209	3622	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	240750	0	180256009	4107731	
41462	3639	4024289	1931-12-21	1931-12-21 00:00:00	38000275	0	\N	\N	242120	0	19490002	4024289	
53570	4646	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	309875	0	180256009	4107731	
53702	4655	4107731	1992-05-17	1992-05-17 00:00:00	38000275	0	\N	\N	310329	0	180256009	4107731	
42002	3703	4107731	1992-10-10	1992-10-10 00:00:00	38000275	0	\N	\N	246243	0	180256009	4107731	
42172	3717	4107731	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	247040	0	180256009	4107731	
54315	4719	4107731	1991-06-16	1991-06-16 00:00:00	38000275	0	\N	\N	314268	0	180256009	4107731	
42465	3744	4293740	2019-01-17	2019-01-17 00:00:00	38000275	0	\N	\N	248853	0	384700001	4293740	
42765	3772	4107731	1990-05-12	1990-05-12 00:00:00	38000275	0	\N	\N	250681	0	180256009	4107731	
54805	4753	4043071	1974-01-05	1974-01-05 00:00:00	38000275	0	\N	\N	316543	0	228557008	4043071	
55035	4782	4295880	2006-09-05	2006-09-05 00:00:00	38000275	0	\N	\N	318313	0	76601001	4295880	
31347	2771	4078793	1996-05-03	1996-05-03 00:00:00	38000275	0	\N	\N	183525	0	180325003	4078793	
43421	3841	4043071	1985-01-01	1985-01-01 00:00:00	38000275	0	\N	\N	255036	0	228557008	4043071	
55569	4844	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	322237	0	180256009	4107731	
55777	4861	4195803	2007-05-22	2007-05-22 00:00:00	38000275	0	\N	\N	323399	0	312681000	4195803	
55919	4878	4107731	1992-04-25	1992-04-25 00:00:00	38000275	0	\N	\N	324361	0	180256009	4107731	
32238	2830	4107731	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	187812	0	180256009	4107731	
56456	4924	4107731	1994-02-16	1994-02-16 00:00:00	38000275	0	\N	\N	327189	0	180256009	4107731	
56567	4927	4295880	1999-12-24	1999-12-24 00:00:00	38000275	0	\N	\N	327500	0	76601001	4295880	
56756	4935	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	328120	0	180256009	4107731	
44980	3950	4043071	1981-11-23	1981-11-23 00:00:00	38000275	0	\N	\N	262587	0	228557008	4043071	
33198	2902	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	193351	0	180256009	4107731	
45275	3991	4010253	2005-01-20	2005-01-20 00:00:00	38000275	0	\N	\N	265384	0	112790001	4010253	
45714	4026	4107731	1991-03-03	1991-03-03 00:00:00	38000275	0	\N	\N	267682	0	180256009	4107731	
46064	4052	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	269310	0	180256009	4107731	
34381	2976	4035793	2012-11-15	2012-11-15 00:00:00	38000275	0	\N	\N	198750	0	15081005	4035793	
46451	4072	4198190	2004-08-31	2004-08-31 00:00:00	38000275	0	\N	\N	270692	0	80146002	4198190	
58594	5076	4043071	1947-01-22	1947-01-22 00:00:00	38000275	0	\N	\N	337383	0	228557008	4043071	
46849	4109	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	273200	0	395142003	4191853	
59092	5117	4107731	1991-03-18	1991-03-18 00:00:00	38000275	0	\N	\N	340074	0	180256009	4107731	
47182	4145	4107731	2006-11-11	2006-11-11 00:00:00	38000275	0	\N	\N	275514	0	180256009	4107731	
59348	5138	4125906	2013-03-19	2013-03-19 00:00:00	38000275	0	\N	\N	341456	0	288086009	4125906	
59472	5148	4170947	1974-09-30	1974-09-30 00:00:00	38000275	0	\N	\N	342222	0	274474001	4170947	
47823	4200	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	278738	0	180256009	4107731	
24069	2090	40492359	1974-03-20	1974-03-20 00:00:00	38000275	0	\N	\N	139372	0	447365002	40492359	
36261	3178	4078793	2006-09-23	2006-09-23 00:00:00	38000275	0	\N	\N	211447	0	180325003	4078793	
36291	3181	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	211671	0	180256009	4107731	
48434	4247	4043071	2000-04-13	2000-04-13 00:00:00	38000275	0	\N	\N	281994	0	228557008	4043071	
36822	3241	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	215472	0	180256009	4107731	
36904	3248	4078793	2012-04-27	2012-04-27 00:00:00	38000275	0	\N	\N	215849	0	180325003	4078793	
37203	3270	4043071	1982-07-12	1982-07-12 00:00:00	38000275	0	\N	\N	217359	0	228557008	4043071	
37322	3279	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	217959	0	180256009	4107731	
37511	3311	4107731	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	219885	0	180256009	4107731	
49669	4355	4125906	2017-05-07	2017-05-07 00:00:00	38000275	0	\N	\N	288964	0	288086009	4125906	
37818	3343	4043071	1986-11-25	1986-11-25 00:00:00	38000275	0	\N	\N	221823	0	228557008	4043071	
38128	3364	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	223122	0	180256009	4107731	
38239	3371	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	223614	0	180256009	4107731	
50362	4380	4043071	1978-01-01	1978-01-01 00:00:00	38000275	0	\N	\N	291039	0	228557008	4043071	
50513	4390	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	291875	0	180256009	4107731	
38748	3409	4243062	2005-01-27	2005-01-27 00:00:00	38000275	0	\N	\N	226123	0	60027007	4243062	
38982	3440	4170947	1944-01-29	1944-01-29 00:00:00	38000275	0	\N	\N	228291	0	274474001	4170947	
51339	4450	4293740	2008-01-09	2008-01-09 00:00:00	38000275	0	\N	\N	296085	0	384700001	4293740	
27628	2419	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	160487	0	180256009	4107731	
39774	3505	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	232444	0	180256009	4107731	
39895	3510	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	232804	0	180256009	4107731	
40187	3527	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	234059	0	180256009	4107731	
52181	4522	4199276	1996-05-31	1996-05-31 00:00:00	38000275	0	\N	\N	301111	0	301807007	4199276	
40422	3547	4024289	1977-12-03	1977-12-03 00:00:00	38000275	0	\N	\N	235540	0	19490002	4024289	
40744	3571	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	237435	0	180256009	4107731	
40876	3583	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	238289	0	180256009	4107731	
29088	2577	4107731	1992-11-21	1992-11-21 00:00:00	38000275	0	\N	\N	170594	0	180256009	4107731	
41210	3622	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	240673	0	180256009	4107731	
41463	3639	4078793	2004-12-04	2004-12-04 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
53571	4646	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	309753	0	180256009	4107731	
53703	4655	4107731	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	310383	0	180256009	4107731	
42003	3703	4107731	1993-03-06	1993-03-06 00:00:00	38000275	0	\N	\N	246225	0	180256009	4107731	
42173	3717	4107731	1993-01-02	1993-01-02 00:00:00	38000275	0	\N	\N	246975	0	180256009	4107731	
54316	4719	4107731	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	314306	0	180256009	4107731	
42466	3744	4125906	2019-01-17	2019-01-17 00:00:00	38000275	0	\N	\N	248853	0	288086009	4125906	
42766	3772	4107731	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	250707	0	180256009	4107731	
54806	4753	4043071	1974-06-29	1974-06-29 00:00:00	38000275	0	\N	\N	316569	0	228557008	4043071	
55036	4782	4295880	2009-09-01	2009-09-01 00:00:00	38000275	0	\N	\N	318322	0	76601001	4295880	
31348	2771	4078793	1986-03-07	1986-03-07 00:00:00	38000275	0	\N	\N	183419	0	180325003	4078793	
43422	3841	4043071	1985-08-13	1985-08-13 00:00:00	38000275	0	\N	\N	255025	0	228557008	4043071	
55570	4844	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	322263	0	180256009	4107731	
55778	4861	4047491	1994-01-22	1994-01-22 00:00:00	38000275	0	\N	\N	323378	0	1225002	4047491	
55920	4878	4107731	1993-03-27	1993-03-27 00:00:00	38000275	0	\N	\N	324427	0	180256009	4107731	
32239	2830	4107731	1991-02-04	1991-02-04 00:00:00	38000275	0	\N	\N	187724	0	180256009	4107731	
56457	4924	4107731	1994-04-20	1994-04-20 00:00:00	38000275	0	\N	\N	327198	0	180256009	4107731	
56568	4927	4295880	2001-03-23	2001-03-23 00:00:00	38000275	0	\N	\N	327455	0	76601001	4295880	
56757	4935	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	328096	0	180256009	4107731	
44981	3950	4125906	1979-06-07	1979-06-07 00:00:00	38000275	0	\N	\N	262523	0	288086009	4125906	
33199	2902	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	193347	0	180256009	4107731	
45276	3991	4010253	1969-08-03	1969-08-03 00:00:00	38000275	0	\N	\N	265299	0	112790001	4010253	
45715	4026	4107731	1991-02-10	1991-02-10 00:00:00	38000275	0	\N	\N	267764	0	180256009	4107731	
46065	4052	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	269353	0	180256009	4107731	
34382	2976	4035793	2005-10-06	2005-10-06 00:00:00	38000275	0	\N	\N	198731	0	15081005	4035793	
46452	4072	4125906	2004-04-16	2004-04-16 00:00:00	38000275	0	\N	\N	270689	0	288086009	4125906	
58595	5076	4043071	1947-02-26	1947-02-26 00:00:00	38000275	0	\N	\N	337384	0	228557008	4043071	
46850	4109	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	273187	0	180256009	4107731	
47183	4145	4107731	2009-07-25	2009-07-25 00:00:00	38000275	0	\N	\N	275480	0	180256009	4107731	
59349	5138	4151422	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	341504	0	269911007	4151422	
59473	5148	4047491	1974-09-30	1974-09-30 00:00:00	38000275	0	\N	\N	342222	0	1225002	4047491	
47824	4200	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	278725	0	180256009	4107731	
24070	2090	4057420	1974-03-20	1974-03-20 00:00:00	38000275	0	\N	\N	139372	0	18286008	4057420	
36262	3178	4078793	2017-11-25	2017-11-25 00:00:00	38000275	0	\N	\N	211416	0	180325003	4078793	
36292	3181	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	211814	0	180256009	4107731	
48435	4247	4043071	1999-03-11	1999-03-11 00:00:00	38000275	0	\N	\N	282118	0	228557008	4043071	
36823	3241	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	215494	0	180256009	4107731	
36905	3248	4057420	2015-05-15	2015-05-15 00:00:00	38000275	0	\N	\N	215876	0	18286008	4057420	
37204	3270	4043071	1984-04-16	1984-04-16 00:00:00	38000275	0	\N	\N	217328	0	228557008	4043071	
37323	3279	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	217861	0	180256009	4107731	
37512	3311	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	219877	0	180256009	4107731	
49724	4359	4195803	2013-09-04	2013-09-04 00:00:00	38000275	0	\N	\N	289209	0	312681000	4195803	
37819	3343	4043071	1988-02-02	1988-02-02 00:00:00	38000275	0	\N	\N	221825	0	228557008	4043071	
38129	3364	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	223126	0	180256009	4107731	
38240	3371	4295880	2005-08-19	2005-08-19 00:00:00	38000275	0	\N	\N	223639	0	76601001	4295880	
50363	4380	4043071	1977-09-25	1977-09-25 00:00:00	38000275	0	\N	\N	291046	0	228557008	4043071	
50514	4390	4151422	2006-11-18	2006-11-18 00:00:00	38000275	0	\N	\N	291921	0	269911007	4151422	
38749	3409	4151422	2001-12-27	2001-12-27 00:00:00	38000275	0	\N	\N	226074	0	269911007	4151422	
38983	3440	4243062	1944-01-29	1944-01-29 00:00:00	38000275	0	\N	\N	228291	0	60027007	4243062	
51340	4450	4125906	2008-01-09	2008-01-09 00:00:00	38000275	0	\N	\N	296085	0	288086009	4125906	
27629	2419	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	160559	0	180256009	4107731	
39775	3505	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	232524	0	180256009	4107731	
39896	3510	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	232920	0	180256009	4107731	
40188	3527	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	234119	0	180256009	4107731	
52182	4522	4059978	1993-12-15	1993-12-15 00:00:00	38000275	0	\N	\N	301138	0	169553002	4059978	
40423	3549	4125906	2015-05-31	2015-05-31 00:00:00	38000275	0	\N	\N	235632	0	288086009	4125906	
40745	3571	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	237433	0	180256009	4107731	
40877	3583	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	238223	0	180256009	4107731	
29089	2577	4107731	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	170616	0	180256009	4107731	
41211	3622	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	240827	0	180256009	4107731	
41466	3641	4043071	1921-07-30	1921-07-30 00:00:00	38000275	0	\N	\N	242327	0	228557008	4043071	
53572	4646	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	309802	0	180256009	4107731	
53704	4655	4107731	1991-05-05	1991-05-05 00:00:00	38000275	0	\N	\N	310315	0	180256009	4107731	
42004	3703	4107731	1990-02-17	1990-02-17 00:00:00	38000275	0	\N	\N	246286	0	180256009	4107731	
42174	3717	4107731	1991-02-09	1991-02-09 00:00:00	38000275	0	\N	\N	247023	0	180256009	4107731	
54317	4719	4197460	1940-09-01	1940-09-01 00:00:00	38000275	0	\N	\N	314226	0	313191000	4197460	
42467	3744	4107731	2003-06-25	2003-06-25 00:00:00	38000275	0	\N	\N	248795	0	180256009	4107731	
42767	3772	4107731	1991-05-04	1991-05-04 00:00:00	38000275	0	\N	\N	250670	0	180256009	4107731	
54807	4753	4043071	1972-12-23	1972-12-23 00:00:00	38000275	0	\N	\N	316478	0	228557008	4043071	
55037	4782	4295880	2007-12-04	2007-12-04 00:00:00	38000275	0	\N	\N	318362	0	76601001	4295880	
31349	2771	4078793	1987-03-13	1987-03-13 00:00:00	38000275	0	\N	\N	183502	0	180325003	4078793	
43423	3841	4151422	1975-04-13	1975-04-13 00:00:00	38000275	0	\N	\N	255021	0	269911007	4151422	
55571	4844	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	322190	0	180256009	4107731	
55779	4861	4170947	1994-01-22	1994-01-22 00:00:00	38000275	0	\N	\N	323378	0	274474001	4170947	
55921	4878	4107731	1990-09-15	1990-09-15 00:00:00	38000275	0	\N	\N	324343	0	180256009	4107731	
32240	2830	4107731	1993-02-08	1993-02-08 00:00:00	38000275	0	\N	\N	187740	0	180256009	4107731	
56458	4924	4107731	1993-09-22	1993-09-22 00:00:00	38000275	0	\N	\N	327171	0	180256009	4107731	
56569	4927	4295880	1999-06-25	1999-06-25 00:00:00	38000275	0	\N	\N	327445	0	76601001	4295880	
56758	4935	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	328036	0	395142003	4191853	
44982	3950	4170947	1971-09-26	1971-09-26 00:00:00	38000275	0	\N	\N	262521	0	274474001	4170947	
33200	2902	4151422	2000-09-21	2000-09-21 00:00:00	38000275	0	\N	\N	193300	0	269911007	4151422	
45278	3993	4151422	1947-07-06	1947-07-06 00:00:00	38000275	0	\N	\N	265479	0	269911007	4151422	
45716	4027	4107731	1993-03-27	1993-03-27 00:00:00	38000275	0	\N	\N	267789	0	180256009	4107731	
46066	4052	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	269355	0	180256009	4107731	
34387	2980	4107731	1992-01-12	1992-01-12 00:00:00	38000275	0	\N	\N	198933	0	180256009	4107731	
46453	4072	4170947	1977-10-21	1977-10-21 00:00:00	38000275	0	\N	\N	270687	0	274474001	4170947	
58596	5076	4125906	1947-11-21	1947-11-21 00:00:00	38000275	0	\N	\N	337327	0	288086009	4125906	
46851	4109	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	273215	0	180256009	4107731	
47184	4145	4107731	2009-08-15	2009-08-15 00:00:00	38000275	0	\N	\N	275543	0	180256009	4107731	
59422	5142	4043071	1953-08-12	1953-08-12 00:00:00	38000275	0	\N	\N	341763	0	228557008	4043071	
59474	5148	4058899	1996-05-07	1996-05-07 00:00:00	38000275	0	\N	\N	342223	0	168594001	4058899	
47825	4200	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	278824	0	180256009	4107731	
24071	2090	4058899	2004-09-07	2004-09-07 00:00:00	38000275	0	\N	\N	139374	0	168594001	4058899	
36263	3178	4078793	2009-10-10	2009-10-10 00:00:00	38000275	0	\N	\N	211414	0	180325003	4078793	
36293	3181	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	211643	0	180256009	4107731	
48436	4247	4043071	1999-07-29	1999-07-29 00:00:00	38000275	0	\N	\N	282016	0	228557008	4043071	
36824	3241	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	215525	0	180256009	4107731	
36906	3248	4078793	2014-05-09	2014-05-09 00:00:00	38000275	0	\N	\N	215850	0	180325003	4078793	
37205	3270	4043071	1986-10-20	1986-10-20 00:00:00	38000275	0	\N	\N	217318	0	228557008	4043071	
37324	3279	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	217906	0	180256009	4107731	
37513	3311	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	219759	0	180256009	4107731	
49725	4359	4058899	2012-06-17	2012-06-17 00:00:00	38000275	0	\N	\N	289214	0	168594001	4058899	
37820	3343	4107731	1990-09-16	1990-09-16 00:00:00	38000275	0	\N	\N	221724	0	180256009	4107731	
38130	3364	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	223072	0	180256009	4107731	
38241	3371	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	223609	0	180256009	4107731	
50364	4380	4151422	1977-04-23	1977-04-23 00:00:00	38000275	0	\N	\N	291030	0	269911007	4151422	
50515	4390	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	291847	0	180256009	4107731	
38750	3409	4170947	1957-05-06	1957-05-06 00:00:00	38000275	0	\N	\N	226136	0	274474001	4170947	
38984	3440	4195803	2015-10-29	2015-10-29 00:00:00	38000275	0	\N	\N	228232	0	312681000	4195803	
51341	4451	4043071	1963-06-13	1963-06-13 00:00:00	38000275	0	\N	\N	296145	0	228557008	4043071	
27630	2419	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	160564	0	180256009	4107731	
39776	3505	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	232508	0	180256009	4107731	
39897	3510	4170947	1951-02-12	1951-02-12 00:00:00	38000275	0	\N	\N	232796	0	274474001	4170947	
40189	3527	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	234015	0	180256009	4107731	
52183	4523	4243062	1989-01-21	1989-01-21 00:00:00	38000275	0	\N	\N	301154	0	60027007	4243062	
40424	3549	4170947	2012-02-16	2012-02-16 00:00:00	38000275	0	\N	\N	235631	0	274474001	4170947	
40746	3571	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	237431	0	180256009	4107731	
40878	3583	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	238183	0	180256009	4107731	
29090	2577	4107731	1993-03-06	1993-03-06 00:00:00	38000275	0	\N	\N	170680	0	180256009	4107731	
41212	3622	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	240745	0	180256009	4107731	
41467	3641	4043071	1921-04-16	1921-04-16 00:00:00	38000275	0	\N	\N	242318	0	228557008	4043071	
53573	4646	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	309810	0	180256009	4107731	
53705	4655	4107731	1990-06-24	1990-06-24 00:00:00	38000275	0	\N	\N	310393	0	180256009	4107731	
42005	3703	4107731	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	246292	0	180256009	4107731	
42175	3717	4107731	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	246988	0	180256009	4107731	
54318	4719	4191853	1990-01-07	1990-01-07 00:00:00	38000275	0	\N	\N	314290	0	395142003	4191853	
42468	3744	4107731	2004-05-26	2004-05-26 00:00:00	38000275	0	\N	\N	248854	0	180256009	4107731	
42768	3772	4107731	1990-12-08	1990-12-08 00:00:00	38000275	0	\N	\N	250652	0	180256009	4107731	
54808	4753	4043071	1973-08-04	1973-08-04 00:00:00	38000275	0	\N	\N	316540	0	228557008	4043071	
55038	4782	4295880	2005-06-07	2005-06-07 00:00:00	38000275	0	\N	\N	318326	0	76601001	4295880	
31350	2771	4078793	1998-05-15	1998-05-15 00:00:00	38000275	0	\N	\N	183530	0	180325003	4078793	
43424	3841	4043071	1985-10-22	1985-10-22 00:00:00	38000275	0	\N	\N	255039	0	228557008	4043071	
55572	4844	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	322239	0	180256009	4107731	
55780	4861	4145310	2008-05-09	2008-05-09 00:00:00	38000275	0	\N	\N	323459	0	268425006	4145310	
55922	4878	4197460	1963-08-03	1963-08-03 00:00:00	38000275	0	\N	\N	324459	0	313191000	4197460	
32241	2830	4107731	1991-04-29	1991-04-29 00:00:00	38000275	0	\N	\N	187726	0	180256009	4107731	
56459	4924	4107731	1994-05-11	1994-05-11 00:00:00	38000275	0	\N	\N	327173	0	180256009	4107731	
56570	4927	4295880	1997-12-26	1997-12-26 00:00:00	38000275	0	\N	\N	327443	0	76601001	4295880	
56759	4935	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	328081	0	180256009	4107731	
44983	3950	4047491	1971-09-26	1971-09-26 00:00:00	38000275	0	\N	\N	262521	0	1225002	4047491	
33201	2902	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	193378	0	180256009	4107731	
45279	3993	4125906	1999-03-13	1999-03-13 00:00:00	38000275	0	\N	\N	265522	0	288086009	4125906	
45717	4027	4107731	1991-06-15	1991-06-15 00:00:00	38000275	0	\N	\N	267863	0	180256009	4107731	
46067	4052	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	269323	0	180256009	4107731	
34388	2980	4107731	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	198965	0	180256009	4107731	
46454	4072	4243062	1977-10-21	1977-10-21 00:00:00	38000275	0	\N	\N	270687	0	60027007	4243062	
58597	5076	4293740	1947-11-21	1947-11-21 00:00:00	38000275	0	\N	\N	337327	0	384700001	4293740	
46852	4109	4107731	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	273204	0	180256009	4107731	
47185	4145	4107731	2009-11-28	2009-11-28 00:00:00	38000275	0	\N	\N	275527	0	180256009	4107731	
59423	5142	4058899	1965-07-02	1965-07-02 00:00:00	38000275	0	\N	\N	341693	0	168594001	4058899	
59475	5148	4170947	1970-08-22	1970-08-22 00:00:00	38000275	0	\N	\N	342221	0	274474001	4170947	
47826	4200	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	278760	0	180256009	4107731	
24072	2091	4151422	1995-12-27	1995-12-27 00:00:00	38000275	0	\N	\N	139476	0	269911007	4151422	
36264	3178	4163951	2014-03-13	2014-03-13 00:00:00	38000275	0	\N	\N	211388	0	29303009	4163951	
36294	3181	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	211804	0	180256009	4107731	
48437	4247	4043071	1995-07-27	1995-07-27 00:00:00	38000275	0	\N	\N	282035	0	228557008	4043071	
36825	3241	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	215473	0	180256009	4107731	
36907	3248	4078793	2007-03-30	2007-03-30 00:00:00	38000275	0	\N	\N	215888	0	180325003	4078793	
37206	3270	4043071	1984-09-10	1984-09-10 00:00:00	38000275	0	\N	\N	217366	0	228557008	4043071	
37325	3279	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	217952	0	180256009	4107731	
37514	3311	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	219864	0	180256009	4107731	
49726	4359	4195803	2012-06-17	2012-06-17 00:00:00	38000275	0	\N	\N	289214	0	312681000	4195803	
37821	3343	4107731	1993-01-24	1993-01-24 00:00:00	38000275	0	\N	\N	221715	0	180256009	4107731	
38131	3364	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	223045	0	180256009	4107731	
38242	3371	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	223537	0	180256009	4107731	
50365	4380	4043071	1977-10-30	1977-10-30 00:00:00	38000275	0	\N	\N	291032	0	228557008	4043071	
50516	4390	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	291828	0	180256009	4107731	
38751	3409	4243062	1957-05-06	1957-05-06 00:00:00	38000275	0	\N	\N	226136	0	60027007	4243062	
38985	3440	4243062	2015-10-29	2015-10-29 00:00:00	38000275	0	\N	\N	228232	0	60027007	4243062	
51342	4451	4252419	1997-02-24	1997-02-24 00:00:00	38000275	0	\N	\N	296140	0	74016001	4252419	
27631	2419	4151422	1972-11-19	1972-11-19 00:00:00	38000275	0	\N	\N	160571	0	269911007	4151422	
39777	3505	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	232501	0	180256009	4107731	
39898	3510	4024289	1951-02-12	1951-02-12 00:00:00	38000275	0	\N	\N	232796	0	19490002	4024289	
40190	3527	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	234011	0	180256009	4107731	
52184	4523	4170947	1989-01-21	1989-01-21 00:00:00	38000275	0	\N	\N	301154	0	274474001	4170947	
40425	3549	4243062	2012-02-16	2012-02-16 00:00:00	38000275	0	\N	\N	235631	0	60027007	4243062	
40747	3572	4125906	1975-01-11	1975-01-11 00:00:00	38000275	0	\N	\N	237442	0	288086009	4125906	
40879	3583	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	238226	0	180256009	4107731	
29091	2577	4107731	1992-02-22	1992-02-22 00:00:00	38000275	0	\N	\N	170710	0	180256009	4107731	
41213	3622	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	240800	0	180256009	4107731	
41468	3641	4043071	1921-12-03	1921-12-03 00:00:00	38000275	0	\N	\N	242266	0	228557008	4043071	
53574	4646	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	309831	0	180256009	4107731	
53706	4655	4107731	1990-08-26	1990-08-26 00:00:00	38000275	0	\N	\N	310398	0	180256009	4107731	
42006	3703	4107731	1992-06-06	1992-06-06 00:00:00	38000275	0	\N	\N	246222	0	180256009	4107731	
42176	3717	4107731	1990-10-27	1990-10-27 00:00:00	38000275	0	\N	\N	247035	0	180256009	4107731	
54319	4719	4107731	1992-06-07	1992-06-07 00:00:00	38000275	0	\N	\N	314273	0	180256009	4107731	
42469	3744	4107731	2004-07-07	2004-07-07 00:00:00	38000275	0	\N	\N	248855	0	180256009	4107731	
42769	3772	4107731	1990-04-21	1990-04-21 00:00:00	38000275	0	\N	\N	250650	0	180256009	4107731	
54809	4753	4043071	1972-11-25	1972-11-25 00:00:00	38000275	0	\N	\N	316535	0	228557008	4043071	
55042	4784	4125906	2009-11-22	2009-11-22 00:00:00	38000275	0	\N	\N	318452	0	288086009	4125906	
31351	2771	4078793	2014-08-15	2014-08-15 00:00:00	38000275	0	\N	\N	183464	0	180325003	4078793	
43425	3841	4043071	1986-01-28	1986-01-28 00:00:00	38000275	0	\N	\N	254986	0	228557008	4043071	
55573	4844	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	322256	0	180256009	4107731	
55783	4865	44783196	1977-11-15	1977-11-15 00:00:00	38000275	0	\N	\N	323495	0	699253003	44783196	
55923	4878	4107731	1991-01-19	1991-01-19 00:00:00	38000275	0	\N	\N	324444	0	180256009	4107731	
32242	2830	4107731	1990-03-05	1990-03-05 00:00:00	38000275	0	\N	\N	187709	0	180256009	4107731	
56460	4924	4107731	1991-05-15	1991-05-15 00:00:00	38000275	0	\N	\N	327261	0	180256009	4107731	
56571	4927	4295880	2000-12-22	2000-12-22 00:00:00	38000275	0	\N	\N	327527	0	76601001	4295880	
56760	4935	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	328027	0	180256009	4107731	
44984	3950	4043071	1982-03-01	1982-03-01 00:00:00	38000275	0	\N	\N	262595	0	228557008	4043071	
33202	2902	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	193268	0	180256009	4107731	
45280	3993	4151422	1976-08-11	1976-08-11 00:00:00	38000275	0	\N	\N	265542	0	269911007	4151422	
45718	4027	4107731	1990-06-02	1990-06-02 00:00:00	38000275	0	\N	\N	267872	0	180256009	4107731	
46068	4052	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	269324	0	180256009	4107731	
34389	2980	4107731	1990-10-28	1990-10-28 00:00:00	38000275	0	\N	\N	199008	0	180256009	4107731	
46466	4077	4024289	1979-08-18	1979-08-18 00:00:00	38000275	0	\N	\N	270887	0	19490002	4024289	
58598	5076	4043071	1947-04-23	1947-04-23 00:00:00	38000275	0	\N	\N	337419	0	228557008	4043071	
46853	4109	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	273203	0	180256009	4107731	
47186	4145	4107731	2007-02-03	2007-02-03 00:00:00	38000275	0	\N	\N	275516	0	180256009	4107731	
59424	5142	4195803	2014-06-18	2014-06-18 00:00:00	38000275	0	\N	\N	341699	0	312681000	4195803	
59476	5148	4163872	1970-08-22	1970-08-22 00:00:00	38000275	0	\N	\N	342221	0	399208008	4163872	
47827	4200	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	278762	0	180256009	4107731	
24073	2091	4125906	1988-06-25	1988-06-25 00:00:00	38000275	0	\N	\N	139481	0	288086009	4125906	
36265	3178	4163971	2014-03-14	2014-03-14 00:00:00	38000275	0	\N	\N	211388	0	45595009	4163971	
36295	3181	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	211766	0	180256009	4107731	
48438	4247	4043071	1998-08-20	1998-08-20 00:00:00	38000275	0	\N	\N	282050	0	228557008	4043071	
36826	3241	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	215469	0	180256009	4107731	
36908	3248	4078793	2009-04-10	2009-04-10 00:00:00	38000275	0	\N	\N	215889	0	180325003	4078793	
37207	3270	4043071	1985-07-29	1985-07-29 00:00:00	38000275	0	\N	\N	217273	0	228557008	4043071	
37326	3279	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	217938	0	180256009	4107731	
37515	3311	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	219854	0	180256009	4107731	
49727	4359	4125906	1979-06-29	1979-06-29 00:00:00	38000275	0	\N	\N	289212	0	288086009	4125906	
37822	3343	4107731	1991-09-08	1991-09-08 00:00:00	38000275	0	\N	\N	221729	0	180256009	4107731	
38132	3364	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	223142	0	180256009	4107731	
38243	3371	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	223646	0	180256009	4107731	
50366	4380	4043071	1978-01-29	1978-01-29 00:00:00	38000275	0	\N	\N	291020	0	228557008	4043071	
50517	4390	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	291808	0	180256009	4107731	
38752	3409	4125906	1984-06-04	1984-06-04 00:00:00	38000275	0	\N	\N	226121	0	288086009	4125906	
38986	3440	4170947	2015-10-29	2015-10-29 00:00:00	38000275	0	\N	\N	228232	0	274474001	4170947	
51343	4451	4043071	1963-03-07	1963-03-07 00:00:00	38000275	0	\N	\N	296163	0	228557008	4043071	
27632	2419	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	160618	0	180256009	4107731	
39778	3505	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	232532	0	180256009	4107731	
39899	3510	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	232916	0	180256009	4107731	
40191	3527	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	234022	0	180256009	4107731	
52185	4523	4293740	2016-11-28	2016-11-28 00:00:00	38000275	0	\N	\N	301158	0	384700001	4293740	
40426	3549	4195803	2012-02-16	2012-02-16 00:00:00	38000275	0	\N	\N	235631	0	312681000	4195803	
40748	3572	4058899	1984-01-20	1984-01-20 00:00:00	38000275	0	\N	\N	237444	0	168594001	4058899	
40880	3583	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	238222	0	180256009	4107731	
29092	2577	4107731	1992-08-29	1992-08-29 00:00:00	38000275	0	\N	\N	170711	0	180256009	4107731	
41214	3622	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	240746	0	180256009	4107731	
41469	3641	4043071	1921-02-05	1921-02-05 00:00:00	38000275	0	\N	\N	242358	0	228557008	4043071	
53575	4646	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	309833	0	180256009	4107731	
53707	4655	4107731	1992-06-28	1992-06-28 00:00:00	38000275	0	\N	\N	310292	0	180256009	4107731	
42007	3703	4107731	1991-11-09	1991-11-09 00:00:00	38000275	0	\N	\N	246204	0	180256009	4107731	
42177	3717	4107731	1993-05-08	1993-05-08 00:00:00	38000275	0	\N	\N	246989	0	180256009	4107731	
54320	4719	4107731	1992-05-17	1992-05-17 00:00:00	38000275	0	\N	\N	314280	0	180256009	4107731	
42470	3745	4035793	2014-09-24	2014-09-24 00:00:00	38000275	0	\N	\N	248974	0	15081005	4035793	
42770	3772	4107731	1992-10-10	1992-10-10 00:00:00	38000275	0	\N	\N	250684	0	180256009	4107731	
54810	4753	4043071	1972-06-03	1972-06-03 00:00:00	38000275	0	\N	\N	316475	0	228557008	4043071	
55043	4784	4293740	1998-07-09	1998-07-09 00:00:00	38000275	0	\N	\N	318451	0	384700001	4293740	
31352	2771	4181917	1972-09-01	1972-09-01 00:00:00	38000275	0	\N	\N	183473	0	54550000	4181917	
43426	3841	4043071	1984-10-30	1984-10-30 00:00:00	38000275	0	\N	\N	255020	0	228557008	4043071	
55574	4844	4197460	1978-03-27	1978-03-27 00:00:00	38000275	0	\N	\N	322282	0	313191000	4197460	
55784	4865	44783196	1981-12-01	1981-12-01 00:00:00	38000275	0	\N	\N	323552	0	699253003	44783196	
55924	4878	4107731	1993-01-23	1993-01-23 00:00:00	38000275	0	\N	\N	324364	0	180256009	4107731	
32243	2830	4107731	1990-01-22	1990-01-22 00:00:00	38000275	0	\N	\N	187807	0	180256009	4107731	
56461	4924	4107731	1991-10-30	1991-10-30 00:00:00	38000275	0	\N	\N	327166	0	180256009	4107731	
56572	4927	4295880	2000-03-24	2000-03-24 00:00:00	38000275	0	\N	\N	327526	0	76601001	4295880	
56761	4935	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	328057	0	180256009	4107731	
44985	3950	4198190	2008-09-23	2008-09-23 00:00:00	38000275	0	\N	\N	262599	0	80146002	4198190	
33203	2902	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	193359	0	180256009	4107731	
45281	3993	4293740	1991-08-31	1991-08-31 00:00:00	38000275	0	\N	\N	265521	0	384700001	4293740	
45719	4027	4107731	1992-08-29	1992-08-29 00:00:00	38000275	0	\N	\N	267845	0	180256009	4107731	
46069	4052	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	269379	0	180256009	4107731	
34390	2980	4107731	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	198889	0	180256009	4107731	
46467	4077	4170947	1979-08-18	1979-08-18 00:00:00	38000275	0	\N	\N	270887	0	274474001	4170947	
58599	5076	4043071	1946-12-25	1946-12-25 00:00:00	38000275	0	\N	\N	337418	0	228557008	4043071	
46854	4109	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	273110	0	180256009	4107731	
47187	4145	4107731	2007-12-15	2007-12-15 00:00:00	38000275	0	\N	\N	275520	0	180256009	4107731	
59425	5142	4145310	2014-06-18	2014-06-18 00:00:00	38000275	0	\N	\N	341699	0	268425006	4145310	
59481	5150	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	342471	0	180256009	4107731	
47828	4200	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	278831	0	180256009	4107731	
24084	2094	4330583	1987-01-05	1987-01-05 00:00:00	38000275	0	\N	\N	139647	0	22523008	4330583	
36266	3178	4202832	2014-03-14	2014-03-14 00:00:00	38000275	0	\N	\N	211388	0	52765003	4202832	
36296	3181	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	211761	0	180256009	4107731	
48439	4247	4043071	1998-12-17	1998-12-17 00:00:00	38000275	0	\N	\N	282117	0	228557008	4043071	
36827	3241	4202451	1990-08-16	1990-08-16 00:00:00	38000275	0	\N	\N	215469	0	433112001	4202451	
36909	3248	4057420	2013-05-03	2013-05-03 00:00:00	38000275	0	\N	\N	215875	0	18286008	4057420	
37208	3270	4043071	1981-05-18	1981-05-18 00:00:00	38000275	0	\N	\N	217320	0	228557008	4043071	
37327	3279	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	217912	0	180256009	4107731	
37516	3311	4191853	1993-10-01	1993-10-01 00:00:00	38000275	0	\N	\N	219768	0	395142003	4191853	
49736	4364	44783196	1963-10-01	1963-10-01 00:00:00	38000275	0	\N	\N	289496	0	699253003	44783196	
37823	3343	4107731	1992-04-26	1992-04-26 00:00:00	38000275	0	\N	\N	221711	0	180256009	4107731	
38133	3364	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	223115	0	180256009	4107731	
38244	3371	4295880	2005-11-18	2005-11-18 00:00:00	38000275	0	\N	\N	223656	0	76601001	4295880	
50367	4380	4043071	1977-11-27	1977-11-27 00:00:00	38000275	0	\N	\N	291038	0	228557008	4043071	
50518	4390	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	291823	0	180256009	4107731	
38753	3409	4058899	2011-04-26	2011-04-26 00:00:00	38000275	0	\N	\N	226124	0	168594001	4058899	
38987	3440	4170947	1955-05-31	1955-05-31 00:00:00	38000275	0	\N	\N	228292	0	274474001	4170947	
51344	4451	4043071	1962-07-05	1962-07-05 00:00:00	38000275	0	\N	\N	296142	0	228557008	4043071	
27633	2419	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	160620	0	180256009	4107731	
39779	3505	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	232502	0	180256009	4107731	
39900	3510	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	232910	0	180256009	4107731	
40192	3527	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	234013	0	180256009	4107731	
52186	4523	4125906	2016-11-28	2016-11-28 00:00:00	38000275	0	\N	\N	301158	0	288086009	4125906	
40427	3550	4125906	2012-07-04	2012-07-04 00:00:00	38000275	0	\N	\N	235758	0	288086009	4125906	
40749	3572	4202451	2014-04-09	2014-04-09 00:00:00	38000275	0	\N	\N	237477	0	433112001	4202451	
40881	3583	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	238186	0	180256009	4107731	
29093	2577	4197460	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	170635	0	313191000	4197460	
41215	3622	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	240806	0	180256009	4107731	
41470	3641	4043071	1922-02-11	1922-02-11 00:00:00	38000275	0	\N	\N	242328	0	228557008	4043071	
53576	4646	4330583	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	309752	0	22523008	4330583	
53708	4655	4107731	1991-10-20	1991-10-20 00:00:00	38000275	0	\N	\N	310359	0	180256009	4107731	
42008	3703	4107731	1993-01-02	1993-01-02 00:00:00	38000275	0	\N	\N	246302	0	180256009	4107731	
42178	3717	4107731	1990-11-17	1990-11-17 00:00:00	38000275	0	\N	\N	247001	0	180256009	4107731	
54321	4719	4107731	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	314236	0	180256009	4107731	
42471	3745	4035793	2010-09-01	2010-09-01 00:00:00	38000275	0	\N	\N	248969	0	15081005	4035793	
42771	3772	4107731	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	250737	0	180256009	4107731	
54811	4753	4043071	1973-02-24	1973-02-24 00:00:00	38000275	0	\N	\N	316485	0	228557008	4043071	
55044	4784	4125906	1998-07-09	1998-07-09 00:00:00	38000275	0	\N	\N	318451	0	288086009	4125906	
31359	2774	4163872	1941-04-17	1941-04-17 00:00:00	38000275	0	\N	\N	183655	0	399208008	4163872	
43427	3841	4043071	1986-02-25	1986-02-25 00:00:00	38000275	0	\N	\N	255027	0	228557008	4043071	
55575	4844	4125906	1960-02-21	1960-02-21 00:00:00	38000275	0	\N	\N	322278	0	288086009	4125906	
55785	4865	4125906	1991-01-11	1991-01-11 00:00:00	38000275	0	\N	\N	323503	0	288086009	4125906	
55925	4878	4107731	1991-09-07	1991-09-07 00:00:00	38000275	0	\N	\N	324447	0	180256009	4107731	
32244	2830	4107731	1990-08-20	1990-08-20 00:00:00	38000275	0	\N	\N	187790	0	180256009	4107731	
56462	4924	4191853	1978-06-24	1978-06-24 00:00:00	38000275	0	\N	\N	327278	0	395142003	4191853	
56573	4927	4295880	1996-12-27	1996-12-27 00:00:00	38000275	0	\N	\N	327493	0	76601001	4295880	
56762	4935	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	328111	0	180256009	4107731	
44986	3950	4043071	1982-01-25	1982-01-25 00:00:00	38000275	0	\N	\N	262594	0	228557008	4043071	
33204	2902	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	193375	0	180256009	4107731	
45282	3993	4125906	1991-08-31	1991-08-31 00:00:00	38000275	0	\N	\N	265521	0	288086009	4125906	
45720	4027	4107731	1992-04-04	1992-04-04 00:00:00	38000275	0	\N	\N	267784	0	180256009	4107731	
46070	4052	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	269356	0	180256009	4107731	
34391	2980	4107731	1991-08-18	1991-08-18 00:00:00	38000275	0	\N	\N	198950	0	180256009	4107731	
46468	4078	4107731	1990-04-16	1990-04-16 00:00:00	38000275	0	\N	\N	270952	0	180256009	4107731	
58600	5076	4163872	1951-09-04	1951-09-04 00:00:00	38000275	0	\N	\N	337409	0	399208008	4163872	
46855	4109	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	273086	0	180256009	4107731	
47188	4145	4107731	2008-07-12	2008-07-12 00:00:00	38000275	0	\N	\N	275506	0	180256009	4107731	
59426	5142	4336464	2012-04-03	2012-04-03 00:00:00	38000275	0	\N	\N	341697	0	232717009	4336464	
59482	5150	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	342423	0	180256009	4107731	
47829	4200	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	278721	0	180256009	4107731	
24085	2094	4024289	1948-09-14	1948-09-14 00:00:00	38000275	0	\N	\N	139571	0	19490002	4024289	
36267	3178	42535580	2014-03-13	2014-03-13 00:00:00	38000275	0	\N	\N	211388	0	426701000119108	42535580	
36297	3181	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	211756	0	180256009	4107731	
48440	4247	4043071	2000-09-14	2000-09-14 00:00:00	38000275	0	\N	\N	281996	0	228557008	4043071	
36828	3241	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	215498	0	180256009	4107731	
36910	3248	4078793	2011-04-22	2011-04-22 00:00:00	38000275	0	\N	\N	215890	0	180325003	4078793	
37209	3270	4043071	1983-10-17	1983-10-17 00:00:00	38000275	0	\N	\N	217311	0	228557008	4043071	
37328	3279	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	217934	0	180256009	4107731	
37517	3311	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	219884	0	180256009	4107731	
49737	4364	4151422	2005-03-18	2005-03-18 00:00:00	38000275	0	\N	\N	289464	0	269911007	4151422	
37824	3343	4107731	1990-07-15	1990-07-15 00:00:00	38000275	0	\N	\N	221840	0	180256009	4107731	
38134	3364	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	223150	0	180256009	4107731	
38245	3371	4191853	1976-03-23	1976-03-23 00:00:00	38000275	0	\N	\N	223598	0	395142003	4191853	
50368	4380	4043071	1977-06-19	1977-06-19 00:00:00	38000275	0	\N	\N	291037	0	228557008	4043071	
50519	4390	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	291798	0	180256009	4107731	
38754	3409	4195803	2011-04-26	2011-04-26 00:00:00	38000275	0	\N	\N	226124	0	312681000	4195803	
38988	3440	4024289	1955-05-31	1955-05-31 00:00:00	38000275	0	\N	\N	228292	0	19490002	4024289	
51345	4451	4043071	1963-08-15	1963-08-15 00:00:00	38000275	0	\N	\N	296128	0	228557008	4043071	
27634	2419	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	160517	0	180256009	4107731	
39780	3505	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	232526	0	180256009	4107731	
39901	3510	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	232829	0	180256009	4107731	
40193	3528	4107731	1990-04-16	1990-04-16 00:00:00	38000275	0	\N	\N	234179	0	180256009	4107731	
52187	4523	4059978	1993-12-31	1993-12-31 00:00:00	38000275	0	\N	\N	301177	0	169553002	4059978	
40428	3550	4010253	2014-10-31	2014-10-31 00:00:00	38000275	0	\N	\N	235749	0	112790001	4010253	
40750	3573	4243062	1934-10-27	1934-10-27 00:00:00	38000275	0	\N	\N	237622	0	60027007	4243062	
40882	3583	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	238217	0	180256009	4107731	
29094	2577	4107731	1993-04-17	1993-04-17 00:00:00	38000275	0	\N	\N	170688	0	180256009	4107731	
41216	3622	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	240772	0	180256009	4107731	
41471	3641	4043071	1922-04-08	1922-04-08 00:00:00	38000275	0	\N	\N	242321	0	228557008	4043071	
53577	4646	4078793	2008-11-18	2008-11-18 00:00:00	38000275	0	\N	\N	309842	0	180325003	4078793	
53709	4655	4107731	1992-11-22	1992-11-22 00:00:00	38000275	0	\N	\N	310330	0	180256009	4107731	
42009	3703	4107731	1991-07-06	1991-07-06 00:00:00	38000275	0	\N	\N	246291	0	180256009	4107731	
42179	3717	4107731	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	247004	0	180256009	4107731	
54322	4719	4107731	1990-12-09	1990-12-09 00:00:00	38000275	0	\N	\N	314255	0	180256009	4107731	
42472	3745	4151422	1944-02-28	1944-02-28 00:00:00	38000275	0	\N	\N	248909	0	269911007	4151422	
42772	3772	4107731	1991-03-23	1991-03-23 00:00:00	38000275	0	\N	\N	250669	0	180256009	4107731	
54812	4753	4043071	1971-12-04	1971-12-04 00:00:00	38000275	0	\N	\N	316531	0	228557008	4043071	
55045	4784	4151422	2010-07-18	2010-07-18 00:00:00	38000275	0	\N	\N	318484	0	269911007	4151422	
31360	2774	4163872	1952-01-18	1952-01-18 00:00:00	38000275	0	\N	\N	183724	0	399208008	4163872	
43428	3841	4043071	1985-11-26	1985-11-26 00:00:00	38000275	0	\N	\N	255040	0	228557008	4043071	
55576	4844	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	322189	0	180256009	4107731	
55786	4865	4252419	1981-11-24	1981-11-24 00:00:00	38000275	0	\N	\N	323501	0	74016001	4252419	
55926	4878	4107731	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	324388	0	180256009	4107731	
32245	2830	4197460	1985-11-12	1985-11-12 00:00:00	38000275	0	\N	\N	187721	0	313191000	4197460	
56463	4924	4107731	1992-07-29	1992-07-29 00:00:00	38000275	0	\N	\N	327227	0	180256009	4107731	
56574	4927	4295880	2003-06-20	2003-06-20 00:00:00	38000275	0	\N	\N	327515	0	76601001	4295880	
56763	4935	44783196	1999-02-14	1999-02-14 00:00:00	38000275	0	\N	\N	328052	0	699253003	44783196	
44987	3950	4043071	1981-10-26	1981-10-26 00:00:00	38000275	0	\N	\N	262529	0	228557008	4043071	
33205	2902	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	193306	0	180256009	4107731	
45283	3995	4125906	1986-01-09	1986-01-09 00:00:00	38000275	0	\N	\N	265614	0	288086009	4125906	
45721	4027	4107731	1993-01-02	1993-01-02 00:00:00	38000275	0	\N	\N	267787	0	180256009	4107731	
46071	4052	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	269376	0	180256009	4107731	
34392	2980	4107731	1991-06-16	1991-06-16 00:00:00	38000275	0	\N	\N	198986	0	180256009	4107731	
46469	4078	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	271079	0	180256009	4107731	
58601	5076	4043071	1946-06-12	1946-06-12 00:00:00	38000275	0	\N	\N	337417	0	228557008	4043071	
46856	4109	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	273076	0	180256009	4107731	
47189	4145	4107731	2009-02-28	2009-02-28 00:00:00	38000275	0	\N	\N	275524	0	180256009	4107731	
59427	5142	4216130	2012-04-03	2012-04-03 00:00:00	38000275	0	\N	\N	341697	0	415070008	4216130	
59483	5150	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	342408	0	180256009	4107731	
47830	4200	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	278797	0	180256009	4107731	
24086	2094	4170947	1948-09-14	1948-09-14 00:00:00	38000275	0	\N	\N	139571	0	274474001	4170947	
36268	3178	4078793	2012-10-27	2012-10-27 00:00:00	38000275	0	\N	\N	211437	0	180325003	4078793	
36298	3181	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	211815	0	180256009	4107731	
48441	4247	4062501	1986-03-25	1986-03-25 00:00:00	38000275	0	\N	\N	282057	0	171231001	4062501	
36829	3241	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	215468	0	180256009	4107731	
36911	3248	4057420	2016-05-20	2016-05-20 00:00:00	38000275	0	\N	\N	215851	0	18286008	4057420	
37210	3270	4043071	1985-03-25	1985-03-25 00:00:00	38000275	0	\N	\N	217291	0	228557008	4043071	
37329	3279	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	217833	0	180256009	4107731	
37518	3311	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	219794	0	180256009	4107731	
49738	4364	4252419	1963-09-24	1963-09-24 00:00:00	38000275	0	\N	\N	289423	0	74016001	4252419	
37825	3343	4191853	1993-07-11	1993-07-11 00:00:00	38000275	0	\N	\N	221764	0	395142003	4191853	
38135	3364	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	223031	0	180256009	4107731	
38246	3371	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	223618	0	180256009	4107731	
50369	4381	4252419	1965-04-28	1965-04-28 00:00:00	38000275	0	\N	\N	291142	0	74016001	4252419	
50520	4390	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	291888	0	180256009	4107731	
38755	3410	4125906	1965-05-10	1965-05-10 00:00:00	38000275	0	\N	\N	226176	0	288086009	4125906	
38989	3440	4301346	1995-10-06	1995-10-06 00:00:00	38000275	0	\N	\N	228225	0	387685009	4301346	
51346	4451	4043071	1964-03-05	1964-03-05 00:00:00	38000275	0	\N	\N	296183	0	228557008	4043071	
27635	2419	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	160491	0	180256009	4107731	
39781	3505	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	232517	0	180256009	4107731	
39902	3510	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	232940	0	180256009	4107731	
40194	3528	4107731	1990-08-20	1990-08-20 00:00:00	38000275	0	\N	\N	234251	0	180256009	4107731	
52188	4523	4125906	2015-11-20	2015-11-20 00:00:00	38000275	0	\N	\N	301157	0	288086009	4125906	
40429	3552	4151422	1961-04-24	1961-04-24 00:00:00	38000275	0	\N	\N	235785	0	269911007	4151422	
40751	3573	4170947	1934-10-27	1934-10-27 00:00:00	38000275	0	\N	\N	237622	0	274474001	4170947	
40883	3583	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	238191	0	180256009	4107731	
29095	2577	4107731	1992-01-11	1992-01-11 00:00:00	38000275	0	\N	\N	170709	0	180256009	4107731	
41217	3622	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	240662	0	180256009	4107731	
41472	3641	4043071	1921-05-21	1921-05-21 00:00:00	38000275	0	\N	\N	242264	0	228557008	4043071	
53578	4646	4078793	2013-05-14	2013-05-14 00:00:00	38000275	0	\N	\N	309869	0	180325003	4078793	
53710	4655	4107731	1990-10-07	1990-10-07 00:00:00	38000275	0	\N	\N	310399	0	180256009	4107731	
42010	3703	4107731	1993-05-29	1993-05-29 00:00:00	38000275	0	\N	\N	246245	0	180256009	4107731	
42180	3717	4107731	1990-01-27	1990-01-27 00:00:00	38000275	0	\N	\N	247079	0	180256009	4107731	
54323	4719	4107731	1990-07-15	1990-07-15 00:00:00	38000275	0	\N	\N	314291	0	180256009	4107731	
42473	3745	4024289	1933-03-01	1933-03-01 00:00:00	38000275	0	\N	\N	248874	0	19490002	4024289	
42773	3772	4170947	1980-07-17	1980-07-17 00:00:00	38000275	0	\N	\N	250671	0	274474001	4170947	
54813	4753	4043071	1971-08-07	1971-08-07 00:00:00	38000275	0	\N	\N	316562	0	228557008	4043071	
55046	4784	4151422	1987-01-06	1987-01-06 00:00:00	38000275	0	\N	\N	318495	0	269911007	4151422	
31361	2774	4145310	2011-03-27	2011-03-27 00:00:00	38000275	0	\N	\N	183692	0	268425006	4145310	
43429	3841	4043071	1985-05-14	1985-05-14 00:00:00	38000275	0	\N	\N	255038	0	228557008	4043071	
55577	4844	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	322240	0	180256009	4107731	
55787	4865	4252419	1977-11-08	1977-11-08 00:00:00	38000275	0	\N	\N	323500	0	74016001	4252419	
55927	4878	4107731	1990-10-06	1990-10-06 00:00:00	38000275	0	\N	\N	324406	0	180256009	4107731	
32246	2830	4107731	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	187711	0	180256009	4107731	
56464	4924	4107731	1992-12-23	1992-12-23 00:00:00	38000275	0	\N	\N	327268	0	180256009	4107731	
56575	4927	4295880	2002-09-20	2002-09-20 00:00:00	38000275	0	\N	\N	327514	0	76601001	4295880	
56764	4935	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	328085	0	180256009	4107731	
44988	3950	4043071	1982-08-23	1982-08-23 00:00:00	38000275	0	\N	\N	262590	0	228557008	4043071	
33206	2902	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	193271	0	180256009	4107731	
45284	3995	4047491	1974-02-27	1974-02-27 00:00:00	38000275	0	\N	\N	265612	0	1225002	4047491	
45722	4027	4107731	1990-01-27	1990-01-27 00:00:00	38000275	0	\N	\N	267869	0	180256009	4107731	
46072	4052	4058899	1985-11-24	1985-11-24 00:00:00	38000275	0	\N	\N	269341	0	168594001	4058899	
34393	2980	4107731	1990-06-03	1990-06-03 00:00:00	38000275	0	\N	\N	198969	0	180256009	4107731	
46470	4078	4107731	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	270980	0	180256009	4107731	
58602	5076	4043071	1946-08-14	1946-08-14 00:00:00	38000275	0	\N	\N	337382	0	228557008	4043071	
46857	4109	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	273213	0	180256009	4107731	
47190	4145	4107731	2008-01-26	2008-01-26 00:00:00	38000275	0	\N	\N	275539	0	180256009	4107731	
59428	5142	4163872	1988-07-10	1988-07-10 00:00:00	38000275	0	\N	\N	341709	0	399208008	4163872	
59484	5150	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	342347	0	180256009	4107731	
47831	4200	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	278766	0	180256009	4107731	
24087	2094	4058899	1950-07-06	1950-07-06 00:00:00	38000275	0	\N	\N	139572	0	168594001	4058899	
36269	3178	4078793	2015-11-14	2015-11-14 00:00:00	38000275	0	\N	\N	211449	0	180325003	4078793	
36299	3181	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	211818	0	180256009	4107731	
48442	4247	4043071	2000-01-06	2000-01-06 00:00:00	38000275	0	\N	\N	282054	0	228557008	4043071	
36830	3241	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	215446	0	180256009	4107731	
36912	3248	4057420	2017-05-26	2017-05-26 00:00:00	38000275	0	\N	\N	215877	0	18286008	4057420	
37211	3270	4043071	1983-04-04	1983-04-04 00:00:00	38000275	0	\N	\N	217305	0	228557008	4043071	
37330	3279	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	217841	0	180256009	4107731	
37519	3311	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	219757	0	180256009	4107731	
49739	4364	4170947	1960-10-09	1960-10-09 00:00:00	38000275	0	\N	\N	289422	0	274474001	4170947	
37826	3343	4107731	1991-03-03	1991-03-03 00:00:00	38000275	0	\N	\N	221702	0	180256009	4107731	
38136	3364	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	223148	0	180256009	4107731	
38247	3371	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	223534	0	180256009	4107731	
50370	4381	44783196	1965-05-05	1965-05-05 00:00:00	38000275	0	\N	\N	291146	0	699253003	44783196	
50521	4390	4151422	1997-02-21	1997-02-21 00:00:00	38000275	0	\N	\N	291919	0	269911007	4151422	
38789	3413	4170947	1975-08-08	1975-08-08 00:00:00	38000275	0	\N	\N	226402	0	274474001	4170947	
38990	3440	4163872	1942-10-07	1942-10-07 00:00:00	38000275	0	\N	\N	228327	0	399208008	4163872	
51347	4451	4043071	1962-12-27	1962-12-27 00:00:00	38000275	0	\N	\N	296181	0	228557008	4043071	
27636	2419	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	160619	0	180256009	4107731	
39782	3505	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	232427	0	180256009	4107731	
39903	3510	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	232864	0	180256009	4107731	
40195	3528	4107731	1993-01-18	1993-01-18 00:00:00	38000275	0	\N	\N	234218	0	180256009	4107731	
52189	4523	4199276	1995-05-28	1995-05-28 00:00:00	38000275	0	\N	\N	301204	0	301807007	4199276	
40430	3552	4125906	2017-05-04	2017-05-04 00:00:00	38000275	0	\N	\N	235862	0	288086009	4125906	
40752	3573	4170947	1936-02-19	1936-02-19 00:00:00	38000275	0	\N	\N	237623	0	274474001	4170947	
40884	3583	4197460	1975-07-05	1975-07-05 00:00:00	38000275	0	\N	\N	238242	0	313191000	4197460	
29096	2577	4107731	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	170700	0	180256009	4107731	
41218	3622	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	240773	0	180256009	4107731	
41473	3641	4170947	1992-11-30	1992-11-30 00:00:00	38000275	0	\N	\N	242315	0	274474001	4170947	
53579	4646	4078793	2012-05-08	2012-05-08 00:00:00	38000275	0	\N	\N	309817	0	180325003	4078793	
53711	4655	4181917	1982-12-08	1982-12-08 00:00:00	38000275	0	\N	\N	310302	0	54550000	4181917	
42011	3703	4107731	1990-03-10	1990-03-10 00:00:00	38000275	0	\N	\N	246185	0	180256009	4107731	
42181	3717	4107731	1990-07-14	1990-07-14 00:00:00	38000275	0	\N	\N	246998	0	180256009	4107731	
54324	4719	4107731	1991-11-10	1991-11-10 00:00:00	38000275	0	\N	\N	314308	0	180256009	4107731	
42474	3745	4170947	1933-03-01	1933-03-01 00:00:00	38000275	0	\N	\N	248874	0	274474001	4170947	
42774	3772	4047491	1980-07-17	1980-07-17 00:00:00	38000275	0	\N	\N	250671	0	1225002	4047491	
54814	4753	4043071	1974-03-30	1974-03-30 00:00:00	38000275	0	\N	\N	316544	0	228557008	4043071	
55047	4784	4151422	1953-10-08	1953-10-08 00:00:00	38000275	0	\N	\N	318455	0	269911007	4151422	
31362	2774	4195803	2011-03-27	2011-03-27 00:00:00	38000275	0	\N	\N	183692	0	312681000	4195803	
43430	3841	4043071	1985-06-11	1985-06-11 00:00:00	38000275	0	\N	\N	255030	0	228557008	4043071	
55578	4844	4197460	1975-03-12	1975-03-12 00:00:00	38000275	0	\N	\N	322281	0	313191000	4197460	
55791	4867	4293740	1988-08-21	1988-08-21 00:00:00	38000275	0	\N	\N	323686	0	384700001	4293740	
55928	4878	4107731	1991-03-23	1991-03-23 00:00:00	38000275	0	\N	\N	324344	0	180256009	4107731	
32247	2830	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	187765	0	180256009	4107731	
56465	4924	4107731	1992-03-04	1992-03-04 00:00:00	38000275	0	\N	\N	327213	0	180256009	4107731	
56576	4927	4295880	1999-03-26	1999-03-26 00:00:00	38000275	0	\N	\N	327499	0	76601001	4295880	
56765	4935	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	328080	0	180256009	4107731	
44989	3950	4043071	1982-05-31	1982-05-31 00:00:00	38000275	0	\N	\N	262583	0	228557008	4043071	
33207	2902	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	193386	0	180256009	4107731	
45285	3995	4170947	1974-02-27	1974-02-27 00:00:00	38000275	0	\N	\N	265612	0	274474001	4170947	
45723	4027	4107731	1990-08-04	1990-08-04 00:00:00	38000275	0	\N	\N	267859	0	180256009	4107731	
46073	4052	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	269327	0	180256009	4107731	
34394	2980	4107731	1991-11-10	1991-11-10 00:00:00	38000275	0	\N	\N	198952	0	180256009	4107731	
46471	4078	4107731	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	271034	0	180256009	4107731	
58603	5076	4151422	2003-01-09	2003-01-09 00:00:00	38000275	0	\N	\N	337399	0	269911007	4151422	
46858	4109	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	273185	0	180256009	4107731	
47191	4145	4107731	2007-11-24	2007-11-24 00:00:00	38000275	0	\N	\N	275504	0	180256009	4107731	
59429	5142	4043071	1953-09-16	1953-09-16 00:00:00	38000275	0	\N	\N	341764	0	228557008	4043071	
59485	5150	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	342479	0	180256009	4107731	
47832	4200	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	278801	0	180256009	4107731	
24088	2094	4125906	2002-07-17	2002-07-17 00:00:00	38000275	0	\N	\N	139574	0	288086009	4125906	
36270	3178	4078793	2016-11-19	2016-11-19 00:00:00	38000275	0	\N	\N	211445	0	180325003	4078793	
36300	3181	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	211769	0	180256009	4107731	
48443	4247	4043071	1995-11-30	1995-11-30 00:00:00	38000275	0	\N	\N	282067	0	228557008	4043071	
36831	3241	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	215491	0	180256009	4107731	
36913	3248	4163951	2016-06-26	2016-06-26 00:00:00	38000275	0	\N	\N	215881	0	29303009	4163951	
37212	3270	4043071	1981-10-05	1981-10-05 00:00:00	38000275	0	\N	\N	217302	0	228557008	4043071	
37331	3280	4195803	2011-11-10	2011-11-10 00:00:00	38000275	0	\N	\N	217974	0	312681000	4195803	
37520	3311	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	219856	0	180256009	4107731	
49740	4364	4243062	1960-10-09	1960-10-09 00:00:00	38000275	0	\N	\N	289422	0	60027007	4243062	
37827	3343	4107731	1992-08-09	1992-08-09 00:00:00	38000275	0	\N	\N	221733	0	180256009	4107731	
38137	3364	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	223041	0	180256009	4107731	
38248	3371	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	223536	0	180256009	4107731	
50371	4381	4058899	1973-02-22	1973-02-22 00:00:00	38000275	0	\N	\N	291143	0	168594001	4058899	
50522	4390	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	291800	0	180256009	4107731	
38790	3413	4047491	1975-08-08	1975-08-08 00:00:00	38000275	0	\N	\N	226402	0	1225002	4047491	
38991	3440	4170947	1959-12-20	1959-12-20 00:00:00	38000275	0	\N	\N	228294	0	274474001	4170947	
51348	4451	4043071	1963-07-11	1963-07-11 00:00:00	38000275	0	\N	\N	296182	0	228557008	4043071	
27637	2419	4151422	1985-06-09	1985-06-09 00:00:00	38000275	0	\N	\N	160483	0	269911007	4151422	
39783	3505	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	232518	0	180256009	4107731	
39904	3510	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	232909	0	180256009	4107731	
40196	3528	4107731	1991-02-04	1991-02-04 00:00:00	38000275	0	\N	\N	234170	0	180256009	4107731	
52190	4523	4125906	2013-12-09	2013-12-09 00:00:00	38000275	0	\N	\N	301156	0	288086009	4125906	
40431	3552	4301346	1965-07-08	1965-07-08 00:00:00	38000275	0	\N	\N	235837	0	387685009	4301346	
40753	3573	4243062	1936-02-19	1936-02-19 00:00:00	38000275	0	\N	\N	237623	0	60027007	4243062	
40885	3583	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	238275	0	180256009	4107731	
29097	2577	4107731	1990-03-10	1990-03-10 00:00:00	38000275	0	\N	\N	170652	0	180256009	4107731	
41219	3622	4078793	2005-02-02	2005-02-02 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
41474	3641	4195803	1992-11-30	1992-11-30 00:00:00	38000275	0	\N	\N	242315	0	312681000	4195803	
53580	4646	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	309834	0	180256009	4107731	
53712	4655	4107731	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	310366	0	180256009	4107731	
42012	3703	4107731	1991-02-09	1991-02-09 00:00:00	38000275	0	\N	\N	246251	0	180256009	4107731	
42182	3717	4191853	1993-07-10	1993-07-10 00:00:00	38000275	0	\N	\N	247016	0	395142003	4191853	
54325	4719	4107731	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	314302	0	180256009	4107731	
42475	3745	4035793	2018-10-17	2018-10-17 00:00:00	38000275	0	\N	\N	248976	0	15081005	4035793	
42775	3772	4107731	1993-05-08	1993-05-08 00:00:00	38000275	0	\N	\N	250709	0	180256009	4107731	
54815	4753	4170947	2006-02-25	2006-02-25 00:00:00	38000275	0	\N	\N	316518	0	274474001	4170947	
55063	4791	4243062	1968-06-18	1968-06-18 00:00:00	38000275	0	\N	\N	318771	0	60027007	4243062	
31363	2774	4151422	1995-12-03	1995-12-03 00:00:00	38000275	0	\N	\N	183705	0	269911007	4151422	
43431	3841	4151422	2002-08-29	2002-08-29 00:00:00	38000275	0	\N	\N	255033	0	269911007	4151422	
55579	4844	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	322238	0	180256009	4107731	
55792	4867	4125906	1988-08-21	1988-08-21 00:00:00	38000275	0	\N	\N	323686	0	288086009	4125906	
55929	4878	4107731	1990-02-17	1990-02-17 00:00:00	38000275	0	\N	\N	324404	0	180256009	4107731	
32248	2830	4107731	1992-09-14	1992-09-14 00:00:00	38000275	0	\N	\N	187731	0	180256009	4107731	
56466	4924	4107731	1991-04-03	1991-04-03 00:00:00	38000275	0	\N	\N	327154	0	180256009	4107731	
56577	4927	4295880	1995-06-28	1995-06-28 00:00:00	38000275	0	\N	\N	327447	0	76601001	4295880	
56766	4935	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	328112	0	180256009	4107731	
44990	3950	4043071	1982-07-26	1982-07-26 00:00:00	38000275	0	\N	\N	262531	0	228557008	4043071	
33208	2902	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	193385	0	180256009	4107731	
45286	3995	4293740	1978-01-07	1978-01-07 00:00:00	38000275	0	\N	\N	265613	0	384700001	4293740	
45724	4027	4107731	1993-02-13	1993-02-13 00:00:00	38000275	0	\N	\N	267788	0	180256009	4107731	
46074	4052	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	269377	0	180256009	4107731	
34395	2980	4107731	1990-04-01	1990-04-01 00:00:00	38000275	0	\N	\N	198945	0	180256009	4107731	
46472	4078	4191853	1990-01-01	1990-01-01 00:00:00	38000275	0	\N	\N	271017	0	395142003	4191853	
58604	5076	4043071	1946-07-10	1946-07-10 00:00:00	38000275	0	\N	\N	337381	0	228557008	4043071	
46859	4109	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	273096	0	180256009	4107731	
47192	4145	4107731	2007-02-24	2007-02-24 00:00:00	38000275	0	\N	\N	275500	0	180256009	4107731	
59430	5142	4043071	1953-10-21	1953-10-21 00:00:00	38000275	0	\N	\N	341723	0	228557008	4043071	
59486	5150	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	342461	0	180256009	4107731	
47833	4200	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	278781	0	395142003	4191853	
24099	2097	4293740	1993-02-07	1993-02-07 00:00:00	38000275	0	\N	\N	139808	0	384700001	4293740	
36271	3178	4078793	2011-10-22	2011-10-22 00:00:00	38000275	0	\N	\N	211415	0	180325003	4078793	
36301	3181	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	211803	0	180256009	4107731	
48444	4247	4043071	1997-12-18	1997-12-18 00:00:00	38000275	0	\N	\N	282072	0	228557008	4043071	
36832	3241	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	215517	0	180256009	4107731	
36914	3248	4163971	2016-06-26	2016-06-26 00:00:00	38000275	0	\N	\N	215881	0	45595009	4163971	
37213	3270	4043071	1983-07-04	1983-07-04 00:00:00	38000275	0	\N	\N	217362	0	228557008	4043071	
37332	3280	4058899	1954-09-25	1954-09-25 00:00:00	38000275	0	\N	\N	218034	0	168594001	4058899	
37521	3311	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	219865	0	180256009	4107731	
49741	4365	4181917	1982-07-15	1982-07-15 00:00:00	38000275	0	\N	\N	289586	0	54550000	4181917	
37828	3343	4107731	1990-06-03	1990-06-03 00:00:00	38000275	0	\N	\N	221839	0	180256009	4107731	
38138	3364	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	223071	0	180256009	4107731	
38249	3371	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	223564	0	180256009	4107731	
50372	4381	4151422	1972-04-23	1972-04-23 00:00:00	38000275	0	\N	\N	291148	0	269911007	4151422	
50523	4390	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	291882	0	180256009	4107731	
38791	3413	4058899	2007-04-22	2007-04-22 00:00:00	38000275	0	\N	\N	226403	0	168594001	4058899	
38992	3440	4047491	1959-12-20	1959-12-20 00:00:00	38000275	0	\N	\N	228294	0	1225002	4047491	
51349	4451	4043071	1963-09-19	1963-09-19 00:00:00	38000275	0	\N	\N	296129	0	228557008	4043071	
27638	2419	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	160565	0	180256009	4107731	
39784	3505	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	232447	0	180256009	4107731	
39905	3510	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	232929	0	180256009	4107731	
40197	3528	4181917	1959-11-16	1959-11-16 00:00:00	38000275	0	\N	\N	234248	0	54550000	4181917	
52195	4525	4010253	1988-01-04	1988-01-04 00:00:00	38000275	0	\N	\N	301302	0	112790001	4010253	
40432	3553	4151422	1973-09-24	1973-09-24 00:00:00	38000275	0	\N	\N	235925	0	269911007	4151422	
40754	3573	4125906	1989-03-31	1989-03-31 00:00:00	38000275	0	\N	\N	237629	0	288086009	4125906	
40886	3583	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	238286	0	180256009	4107731	
29098	2577	4107731	1991-11-30	1991-11-30 00:00:00	38000275	0	\N	\N	170708	0	180256009	4107731	
41220	3622	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	240732	0	180256009	4107731	
41475	3641	4047491	1992-11-30	1992-11-30 00:00:00	38000275	0	\N	\N	242315	0	1225002	4047491	
53581	4646	4078793	2001-10-09	2001-10-09 00:00:00	38000275	0	\N	\N	309867	0	180325003	4078793	
53713	4655	4107731	1992-04-26	1992-04-26 00:00:00	38000275	0	\N	\N	310320	0	180256009	4107731	
42013	3703	4107731	1991-12-21	1991-12-21 00:00:00	38000275	0	\N	\N	246205	0	180256009	4107731	
42183	3717	4107731	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	246986	0	180256009	4107731	
54326	4719	4107731	1990-06-03	1990-06-03 00:00:00	38000275	0	\N	\N	314254	0	180256009	4107731	
42476	3745	4198190	1935-03-13	1935-03-13 00:00:00	38000275	0	\N	\N	248971	0	80146002	4198190	
42776	3772	4107731	1992-08-29	1992-08-29 00:00:00	38000275	0	\N	\N	250660	0	180256009	4107731	
54816	4753	4024289	2006-02-25	2006-02-25 00:00:00	38000275	0	\N	\N	316518	0	19490002	4024289	
55064	4791	4170947	1968-06-18	1968-06-18 00:00:00	38000275	0	\N	\N	318771	0	274474001	4170947	
31364	2774	4125906	2016-10-26	2016-10-26 00:00:00	38000275	0	\N	\N	183727	0	288086009	4125906	
43432	3841	4043071	1985-09-17	1985-09-17 00:00:00	38000275	0	\N	\N	255026	0	228557008	4043071	
55580	4844	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	322208	0	180256009	4107731	
55793	4867	44783196	2011-03-15	2011-03-15 00:00:00	38000275	0	\N	\N	323690	0	699253003	44783196	
55930	4878	4107731	1993-05-29	1993-05-29 00:00:00	38000275	0	\N	\N	324319	0	180256009	4107731	
32249	2830	4107731	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	187792	0	180256009	4107731	
56467	4924	4107731	1992-05-27	1992-05-27 00:00:00	38000275	0	\N	\N	327215	0	180256009	4107731	
56578	4927	4295880	1999-09-24	1999-09-24 00:00:00	38000275	0	\N	\N	327464	0	76601001	4295880	
56767	4935	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	328039	0	180256009	4107731	
44991	3950	4043071	1982-04-26	1982-04-26 00:00:00	38000275	0	\N	\N	262589	0	228557008	4043071	
33209	2902	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	193307	0	180256009	4107731	
45287	3995	4125906	1978-01-07	1978-01-07 00:00:00	38000275	0	\N	\N	265613	0	288086009	4125906	
45725	4027	4191853	1990-01-06	1990-01-06 00:00:00	38000275	0	\N	\N	267897	0	395142003	4191853	
46075	4052	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	269339	0	180256009	4107731	
34396	2980	4107731	1993-03-28	1993-03-28 00:00:00	38000275	0	\N	\N	198904	0	180256009	4107731	
46473	4078	4107731	1991-04-08	1991-04-08 00:00:00	38000275	0	\N	\N	270957	0	180256009	4107731	
58605	5076	4043071	1946-09-18	1946-09-18 00:00:00	38000275	0	\N	\N	337408	0	228557008	4043071	
46860	4109	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	273070	0	180256009	4107731	
47193	4145	4107731	2008-08-23	2008-08-23 00:00:00	38000275	0	\N	\N	275507	0	180256009	4107731	
59431	5142	4151422	1963-11-12	1963-11-12 00:00:00	38000275	0	\N	\N	341706	0	269911007	4151422	
59487	5150	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	342348	0	180256009	4107731	
47834	4200	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	278826	0	180256009	4107731	
24100	2097	4125906	1993-02-07	1993-02-07 00:00:00	38000275	0	\N	\N	139808	0	288086009	4125906	
36272	3178	4078793	2008-10-04	2008-10-04 00:00:00	38000275	0	\N	\N	211435	0	180325003	4078793	
36302	3181	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	211805	0	180256009	4107731	
48445	4247	4043071	2000-07-13	2000-07-13 00:00:00	38000275	0	\N	\N	282019	0	228557008	4043071	
36833	3241	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	215447	0	180256009	4107731	
36915	3248	4202832	2016-06-26	2016-06-26 00:00:00	38000275	0	\N	\N	215881	0	52765003	4202832	
48995	4305	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	285584	0	180256009	4107731	
37333	3280	4125906	1969-08-28	1969-08-28 00:00:00	38000275	0	\N	\N	218037	0	288086009	4125906	
37522	3311	4107731	1993-09-10	1993-09-10 00:00:00	38000275	0	\N	\N	219831	0	180256009	4107731	
49742	4365	4078793	2009-01-04	2009-01-04 00:00:00	38000275	0	\N	\N	289581	0	180325003	4078793	
37829	3343	4043071	1986-04-29	1986-04-29 00:00:00	38000275	0	\N	\N	221848	0	228557008	4043071	
38139	3364	4145310	1994-12-01	1994-12-01 00:00:00	38000275	0	\N	\N	223107	0	268425006	4145310	
38250	3371	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	223532	0	180256009	4107731	
50373	4381	4151422	2012-11-20	2012-11-20 00:00:00	38000275	0	\N	\N	291074	0	269911007	4151422	
50524	4390	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	291819	0	180256009	4107731	
38792	3413	4151422	1974-09-13	1974-09-13 00:00:00	38000275	0	\N	\N	226418	0	269911007	4151422	
38993	3443	4163872	1981-09-16	1981-09-16 00:00:00	38000275	0	\N	\N	228480	0	399208008	4163872	
51350	4451	4043071	1962-08-02	1962-08-02 00:00:00	38000275	0	\N	\N	296197	0	228557008	4043071	
27639	2419	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	160490	0	180256009	4107731	
39785	3505	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	232481	0	180256009	4107731	
39906	3510	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	232907	0	180256009	4107731	
40198	3528	4107731	1991-09-02	1991-09-02 00:00:00	38000275	0	\N	\N	234184	0	180256009	4107731	
52196	4526	4047491	1987-08-12	1987-08-12 00:00:00	38000275	0	\N	\N	301374	0	1225002	4047491	
40433	3553	4151422	1977-05-13	1977-05-13 00:00:00	38000275	0	\N	\N	235926	0	269911007	4151422	
40755	3573	4293740	1989-03-31	1989-03-31 00:00:00	38000275	0	\N	\N	237629	0	384700001	4293740	
40887	3583	4107731	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	238218	0	180256009	4107731	
29099	2577	4107731	1991-05-04	1991-05-04 00:00:00	38000275	0	\N	\N	170627	0	180256009	4107731	
41221	3622	4078793	2011-03-16	2011-03-16 00:00:00	38000275	0	\N	\N	240714	0	180325003	4078793	
41476	3641	4043071	1921-09-24	1921-09-24 00:00:00	38000275	0	\N	\N	242319	0	228557008	4043071	
53582	4646	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	309858	0	180256009	4107731	
53714	4655	4197460	1963-05-22	1963-05-22 00:00:00	38000275	0	\N	\N	310298	0	313191000	4197460	
42014	3703	4125906	1999-07-24	1999-07-24 00:00:00	38000275	0	\N	\N	246257	0	288086009	4125906	
42184	3717	4107731	1990-12-08	1990-12-08 00:00:00	38000275	0	\N	\N	246957	0	180256009	4107731	
54327	4719	4107731	1991-12-22	1991-12-22 00:00:00	38000275	0	\N	\N	314309	0	180256009	4107731	
42477	3745	44783196	1997-03-02	1997-03-02 00:00:00	38000275	0	\N	\N	248907	0	699253003	44783196	
42777	3772	4107731	1992-11-21	1992-11-21 00:00:00	38000275	0	\N	\N	250757	0	180256009	4107731	
54817	4753	4043071	1972-08-26	1972-08-26 00:00:00	38000275	0	\N	\N	316476	0	228557008	4043071	
55065	4791	4058899	2002-04-21	2002-04-21 00:00:00	38000275	0	\N	\N	318824	0	168594001	4058899	
31369	2776	4191853	2005-07-26	2005-07-26 00:00:00	38000275	0	\N	\N	183776	0	395142003	4191853	
43433	3841	4043071	1985-07-16	1985-07-16 00:00:00	38000275	0	\N	\N	254985	0	228557008	4043071	
55581	4844	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	322289	0	180256009	4107731	
55794	4867	4252419	2011-03-08	2011-03-08 00:00:00	38000275	0	\N	\N	323691	0	74016001	4252419	
55931	4878	4107731	1990-06-02	1990-06-02 00:00:00	38000275	0	\N	\N	324347	0	180256009	4107731	
32250	2830	4107731	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	187737	0	180256009	4107731	
56468	4924	4107731	1993-11-03	1993-11-03 00:00:00	38000275	0	\N	\N	327247	0	180256009	4107731	
56579	4927	4125906	2000-10-10	2000-10-10 00:00:00	38000275	0	\N	\N	327479	0	288086009	4125906	
56768	4935	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	328053	0	180256009	4107731	
44992	3950	4043071	1981-12-28	1981-12-28 00:00:00	38000275	0	\N	\N	262588	0	228557008	4043071	
33210	2902	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	193349	0	180256009	4107731	
45288	3995	4125906	2010-03-25	2010-03-25 00:00:00	38000275	0	\N	\N	265615	0	288086009	4125906	
45726	4027	4107731	1990-03-31	1990-03-31 00:00:00	38000275	0	\N	\N	267807	0	180256009	4107731	
46076	4052	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	269410	0	180256009	4107731	
34397	2980	4107731	1993-05-09	1993-05-09 00:00:00	38000275	0	\N	\N	198905	0	180256009	4107731	
46474	4078	4107731	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	270984	0	180256009	4107731	
58606	5076	4125906	1983-04-05	1983-04-05 00:00:00	38000275	0	\N	\N	337329	0	288086009	4125906	
46861	4109	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	273107	0	180256009	4107731	
47194	4145	4107731	2008-12-27	2008-12-27 00:00:00	38000275	0	\N	\N	275459	0	180256009	4107731	
59432	5142	4151422	1972-07-25	1972-07-25 00:00:00	38000275	0	\N	\N	341708	0	269911007	4151422	
59488	5150	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	342360	0	180256009	4107731	
47835	4200	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	278745	0	180256009	4107731	
24101	2097	4275113	1994-02-18	1994-02-18 00:00:00	38000275	0	\N	\N	139773	0	65200003	4275113	
36273	3178	4078793	2014-11-08	2014-11-08 00:00:00	38000275	0	\N	\N	211444	0	180325003	4078793	
36303	3181	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	211673	0	180256009	4107731	
48446	4247	4043071	1997-11-20	1997-11-20 00:00:00	38000275	0	\N	\N	282115	0	228557008	4043071	
36834	3241	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	215518	0	180256009	4107731	
36916	3248	42535580	2016-06-26	2016-06-26 00:00:00	38000275	0	\N	\N	215881	0	426701000119108	42535580	
48996	4305	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	285604	0	180256009	4107731	
37338	3283	4163872	1987-11-24	1987-11-24 00:00:00	38000275	0	\N	\N	218107	0	399208008	4163872	
37523	3311	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	219814	0	180256009	4107731	
61524	5322	4197460	1963-06-27	1963-06-27 00:00:00	38000275	0	\N	\N	354088	0	313191000	4197460	
37830	3343	4043071	1985-10-29	1985-10-29 00:00:00	38000275	0	\N	\N	221774	0	228557008	4043071	
38140	3364	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	223125	0	180256009	4107731	
38251	3371	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	223612	0	180256009	4107731	
50374	4382	4293740	2000-06-16	2000-06-16 00:00:00	38000275	0	\N	\N	291171	0	384700001	4293740	
50525	4390	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	291878	0	180256009	4107731	
38793	3414	4151422	1985-03-05	1985-03-05 00:00:00	38000275	0	\N	\N	226485	0	269911007	4151422	
38994	3443	4199276	2003-12-30	2003-12-30 00:00:00	38000275	0	\N	\N	228462	0	301807007	4199276	
51351	4451	4024289	2003-09-28	2003-09-28 00:00:00	38000275	0	\N	\N	296141	0	19490002	4024289	
27640	2419	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	160556	0	180256009	4107731	
39786	3505	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	232430	0	180256009	4107731	
39907	3510	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	232834	0	180256009	4107731	
40199	3528	4107731	1991-07-22	1991-07-22 00:00:00	38000275	0	\N	\N	234269	0	180256009	4107731	
52197	4526	4170947	1987-08-12	1987-08-12 00:00:00	38000275	0	\N	\N	301374	0	274474001	4170947	
40434	3553	4151422	1942-09-08	1942-09-08 00:00:00	38000275	0	\N	\N	235922	0	269911007	4151422	
40756	3573	4125906	1937-03-15	1937-03-15 00:00:00	38000275	0	\N	\N	237624	0	288086009	4125906	
40906	3589	4107731	1995-11-27	1995-11-27 00:00:00	38000275	0	\N	\N	238467	0	180256009	4107731	
29100	2577	4107731	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	170657	0	180256009	4107731	
41222	3622	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	240795	0	180256009	4107731	
41477	3641	4043071	1920-12-04	1920-12-04 00:00:00	38000275	0	\N	\N	242361	0	228557008	4043071	
53583	4646	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	309859	0	180256009	4107731	
53715	4655	4107731	1992-02-02	1992-02-02 00:00:00	38000275	0	\N	\N	310318	0	180256009	4107731	
42015	3703	4293740	1999-07-24	1999-07-24 00:00:00	38000275	0	\N	\N	246257	0	384700001	4293740	
42185	3718	4058899	1974-08-07	1974-08-07 00:00:00	38000275	0	\N	\N	247144	0	168594001	4058899	
54328	4719	4107731	1990-02-18	1990-02-18 00:00:00	38000275	0	\N	\N	314300	0	180256009	4107731	
42478	3745	4035793	2015-09-30	2015-09-30 00:00:00	38000275	0	\N	\N	248895	0	15081005	4035793	
42778	3772	4107731	1991-04-13	1991-04-13 00:00:00	38000275	0	\N	\N	250731	0	180256009	4107731	
54818	4753	4043071	1972-09-30	1972-09-30 00:00:00	38000275	0	\N	\N	316477	0	228557008	4043071	
55066	4792	4202451	1974-11-05	1974-11-05 00:00:00	38000275	0	\N	\N	318868	0	433112001	4202451	
31370	2776	4107731	2007-09-11	2007-09-11 00:00:00	38000275	0	\N	\N	183829	0	180256009	4107731	
43434	3841	4043071	1985-12-31	1985-12-31 00:00:00	38000275	0	\N	\N	255031	0	228557008	4043071	
55582	4844	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	322255	0	180256009	4107731	
55795	4867	4243062	1979-09-08	1979-09-08 00:00:00	38000275	0	\N	\N	323684	0	60027007	4243062	
55932	4878	4107731	1990-10-27	1990-10-27 00:00:00	38000275	0	\N	\N	324380	0	180256009	4107731	
32251	2830	4107731	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	187700	0	180256009	4107731	
56469	4924	4107731	1991-06-05	1991-06-05 00:00:00	38000275	0	\N	\N	327210	0	180256009	4107731	
56580	4927	4295880	1997-06-27	1997-06-27 00:00:00	38000275	0	\N	\N	327449	0	76601001	4295880	
56769	4935	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	328116	0	180256009	4107731	
44993	3950	4043071	1982-06-28	1982-06-28 00:00:00	38000275	0	\N	\N	262596	0	228557008	4043071	
33211	2902	4202451	2011-02-11	2011-02-11 00:00:00	38000275	0	\N	\N	193399	0	433112001	4202451	
45289	3996	4252419	1989-05-08	1989-05-08 00:00:00	38000275	0	\N	\N	265696	0	74016001	4252419	
45727	4027	4107731	1993-01-23	1993-01-23 00:00:00	38000275	0	\N	\N	267823	0	180256009	4107731	
46077	4052	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	269298	0	180256009	4107731	
34398	2980	4107731	1990-10-07	1990-10-07 00:00:00	38000275	0	\N	\N	198946	0	180256009	4107731	
46475	4078	4107731	1992-07-13	1992-07-13 00:00:00	38000275	0	\N	\N	271088	0	180256009	4107731	
58607	5076	4043071	1946-10-16	1946-10-16 00:00:00	38000275	0	\N	\N	337428	0	228557008	4043071	
46862	4109	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	273109	0	180256009	4107731	
47195	4145	4107731	2008-08-02	2008-08-02 00:00:00	38000275	0	\N	\N	275475	0	180256009	4107731	
59433	5142	4170947	2013-07-23	2013-07-23 00:00:00	38000275	0	\N	\N	341698	0	274474001	4170947	
59489	5150	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	342474	0	180256009	4107731	
47836	4200	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	278840	0	180256009	4107731	
24102	2097	4238715	1995-02-25	1995-02-25 00:00:00	38000275	0	\N	\N	139802	0	68254000	4238715	
36274	3178	4078793	2013-11-02	2013-11-02 00:00:00	38000275	0	\N	\N	211448	0	180325003	4078793	
36304	3181	4125906	1982-04-25	1982-04-25 00:00:00	38000275	0	\N	\N	211657	0	288086009	4125906	
48447	4247	4043071	1998-01-15	1998-01-15 00:00:00	38000275	0	\N	\N	282042	0	228557008	4043071	
36835	3241	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	215496	0	180256009	4107731	
36917	3248	4057420	2019-06-07	2019-06-07 00:00:00	38000275	0	\N	\N	215944	0	18286008	4057420	
48997	4305	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	285552	0	180256009	4107731	
37339	3283	4170947	1987-11-24	1987-11-24 00:00:00	38000275	0	\N	\N	218107	0	274474001	4170947	
37524	3311	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	219857	0	180256009	4107731	
61525	5322	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	354188	0	180256009	4107731	
37831	3343	4043071	1988-03-01	1988-03-01 00:00:00	38000275	0	\N	\N	221780	0	228557008	4043071	
38141	3364	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	223058	0	180256009	4107731	
38252	3371	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	223624	0	180256009	4107731	
50375	4382	4125906	2000-06-16	2000-06-16 00:00:00	38000275	0	\N	\N	291171	0	288086009	4125906	
50526	4390	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	291826	0	180256009	4107731	
38794	3414	4151422	1981-05-01	1981-05-01 00:00:00	38000275	0	\N	\N	226468	0	269911007	4151422	
38995	3443	4059978	2003-01-01	2003-01-01 00:00:00	38000275	0	\N	\N	228461	0	169553002	4059978	
51352	4451	4170947	2003-09-28	2003-09-28 00:00:00	38000275	0	\N	\N	296141	0	274474001	4170947	
27641	2419	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	160519	0	180256009	4107731	
39787	3505	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	232516	0	180256009	4107731	
39908	3510	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	232939	0	180256009	4107731	
40200	3528	4107731	1992-10-05	1992-10-05 00:00:00	38000275	0	\N	\N	234236	0	180256009	4107731	
52198	4527	4202451	2001-03-02	2001-03-02 00:00:00	38000275	0	\N	\N	301441	0	433112001	4202451	
40435	3553	4326177	1982-10-26	1982-10-26 00:00:00	38000275	0	\N	\N	235891	0	430193006	4326177	
40757	3573	4170947	1957-07-12	1957-07-12 00:00:00	38000275	0	\N	\N	237626	0	274474001	4170947	
40907	3589	4107731	1994-06-21	1994-06-21 00:00:00	38000275	0	\N	\N	238402	0	180256009	4107731	
29101	2577	4107731	1993-01-02	1993-01-02 00:00:00	38000275	0	\N	\N	170595	0	180256009	4107731	
41223	3622	4078793	2010-03-10	2010-03-10 00:00:00	38000275	0	\N	\N	240723	0	180325003	4078793	
41478	3641	4043071	1921-06-25	1921-06-25 00:00:00	38000275	0	\N	\N	242265	0	228557008	4043071	
53584	4646	4057420	2005-11-01	2005-11-01 00:00:00	38000275	0	\N	\N	309747	0	18286008	4057420	
53716	4655	4107731	1991-02-10	1991-02-10 00:00:00	38000275	0	\N	\N	310272	0	180256009	4107731	
42016	3703	4107731	1990-03-31	1990-03-31 00:00:00	38000275	0	\N	\N	246247	0	180256009	4107731	
42186	3719	4163872	2004-06-04	2004-06-04 00:00:00	38000275	0	\N	\N	247169	0	399208008	4163872	
54329	4719	4107731	1991-10-20	1991-10-20 00:00:00	38000275	0	\N	\N	314259	0	180256009	4107731	
42479	3745	4197460	1935-05-19	1935-05-19 00:00:00	38000275	0	\N	\N	248876	0	313191000	4197460	
42779	3772	4107731	1990-10-27	1990-10-27 00:00:00	38000275	0	\N	\N	250651	0	180256009	4107731	
54819	4753	4043071	1973-12-01	1973-12-01 00:00:00	38000275	0	\N	\N	316542	0	228557008	4043071	
55067	4792	4238715	1975-12-02	1975-12-02 00:00:00	38000275	0	\N	\N	318851	0	68254000	4238715	
31371	2776	4107731	2008-02-05	2008-02-05 00:00:00	38000275	0	\N	\N	183845	0	180256009	4107731	
43435	3841	4043071	1985-01-29	1985-01-29 00:00:00	38000275	0	\N	\N	255023	0	228557008	4043071	
55583	4844	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	322235	0	180256009	4107731	
55796	4867	4170947	1979-09-08	1979-09-08 00:00:00	38000275	0	\N	\N	323684	0	274474001	4170947	
55933	4878	4125906	1964-01-30	1964-01-30 00:00:00	38000275	0	\N	\N	324460	0	288086009	4125906	
32255	2832	4107731	1997-03-22	1997-03-22 00:00:00	38000275	0	\N	\N	187882	0	180256009	4107731	
56470	4924	4238715	1997-04-30	1997-04-30 00:00:00	38000275	0	\N	\N	327234	0	68254000	4238715	
56581	4927	4295880	2001-09-21	2001-09-21 00:00:00	38000275	0	\N	\N	327528	0	76601001	4295880	
56770	4935	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	328087	0	180256009	4107731	
44994	3950	4151422	2001-12-11	2001-12-11 00:00:00	38000275	0	\N	\N	262591	0	269911007	4151422	
33212	2902	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	193377	0	180256009	4107731	
45290	3996	44783196	1989-05-15	1989-05-15 00:00:00	38000275	0	\N	\N	265650	0	699253003	44783196	
45728	4027	4107731	1990-02-17	1990-02-17 00:00:00	38000275	0	\N	\N	267835	0	180256009	4107731	
46078	4052	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	269319	0	180256009	4107731	
34399	2980	4107731	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	198938	0	180256009	4107731	
46476	4078	4107731	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	270958	0	180256009	4107731	
58608	5076	4043071	1946-11-20	1946-11-20 00:00:00	38000275	0	\N	\N	337429	0	228557008	4043071	
46863	4109	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	273089	0	180256009	4107731	
47196	4145	4107731	2006-09-30	2006-09-30 00:00:00	38000275	0	\N	\N	275471	0	180256009	4107731	
59434	5142	4024289	2013-07-23	2013-07-23 00:00:00	38000275	0	\N	\N	341698	0	19490002	4024289	
59490	5150	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	342483	0	180256009	4107731	
47837	4200	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	278837	0	180256009	4107731	
24103	2098	4275113	1981-06-06	1981-06-06 00:00:00	38000275	0	\N	\N	139879	0	65200003	4275113	
36275	3178	4078793	2007-09-29	2007-09-29 00:00:00	38000275	0	\N	\N	211413	0	180325003	4078793	
36305	3181	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	211649	0	180256009	4107731	
48448	4247	4043071	1999-05-20	1999-05-20 00:00:00	38000275	0	\N	\N	282051	0	228557008	4043071	
36836	3241	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	215488	0	395142003	4191853	
36918	3248	4078793	2008-04-04	2008-04-04 00:00:00	38000275	0	\N	\N	215915	0	180325003	4078793	
48998	4305	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	285597	0	180256009	4107731	
37340	3283	4238715	1994-12-23	1994-12-23 00:00:00	38000275	0	\N	\N	218115	0	68254000	4238715	
37525	3311	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	219808	0	180256009	4107731	
61526	5322	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	354236	0	180256009	4107731	
37832	3343	4107731	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	221763	0	180256009	4107731	
38142	3364	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	223040	0	180256009	4107731	
38253	3371	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	223558	0	180256009	4107731	
50376	4382	4125906	1985-12-18	1985-12-18 00:00:00	38000275	0	\N	\N	291169	0	288086009	4125906	
50527	4390	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	291844	0	180256009	4107731	
38795	3414	4151422	1994-07-24	1994-07-24 00:00:00	38000275	0	\N	\N	226486	0	269911007	4151422	
38996	3444	4151422	2013-08-07	2013-08-07 00:00:00	38000275	0	\N	\N	228578	0	269911007	4151422	
51353	4451	4195803	2003-09-28	2003-09-28 00:00:00	38000275	0	\N	\N	296141	0	312681000	4195803	
27642	2419	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	160604	0	180256009	4107731	
39788	3505	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	232473	0	180256009	4107731	
39909	3510	4195803	2015-11-27	2015-11-27 00:00:00	38000275	0	\N	\N	232847	0	312681000	4195803	
40201	3528	4107731	1993-02-08	1993-02-08 00:00:00	38000275	0	\N	\N	234149	0	180256009	4107731	
52199	4527	4024289	2011-09-02	2011-09-02 00:00:00	38000275	0	\N	\N	301446	0	19490002	4024289	
40436	3553	4037675	1982-10-26	1982-10-26 00:00:00	38000275	0	\N	\N	235891	0	162676008	4037675	
40758	3573	4047491	1957-07-12	1957-07-12 00:00:00	38000275	0	\N	\N	237626	0	1225002	4047491	
40908	3589	4107731	1994-04-19	1994-04-19 00:00:00	38000275	0	\N	\N	238429	0	180256009	4107731	
29102	2577	4107731	1991-05-25	1991-05-25 00:00:00	38000275	0	\N	\N	170618	0	180256009	4107731	
41224	3622	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	240748	0	180256009	4107731	
41479	3641	4043071	1921-10-29	1921-10-29 00:00:00	38000275	0	\N	\N	242320	0	228557008	4043071	
53585	4646	4078793	2007-11-13	2007-11-13 00:00:00	38000275	0	\N	\N	309748	0	180325003	4078793	
53717	4655	4107731	1990-04-22	1990-04-22 00:00:00	38000275	0	\N	\N	310385	0	180256009	4107731	
42017	3703	4107731	1990-06-23	1990-06-23 00:00:00	38000275	0	\N	\N	246249	0	180256009	4107731	
42187	3719	4170947	2004-06-04	2004-06-04 00:00:00	38000275	0	\N	\N	247169	0	274474001	4170947	
54330	4719	4107731	1991-07-07	1991-07-07 00:00:00	38000275	0	\N	\N	314296	0	180256009	4107731	
42480	3745	4035793	2009-08-26	2009-08-26 00:00:00	38000275	0	\N	\N	248963	0	15081005	4035793	
42780	3772	4107731	1991-10-19	1991-10-19 00:00:00	38000275	0	\N	\N	250656	0	180256009	4107731	
54820	4753	4170947	1968-04-01	1968-04-01 00:00:00	38000275	0	\N	\N	316573	0	274474001	4170947	
55068	4792	4275113	1972-02-07	1972-02-07 00:00:00	38000275	0	\N	\N	318849	0	65200003	4275113	
31372	2776	4107731	2008-06-10	2008-06-10 00:00:00	38000275	0	\N	\N	183832	0	180256009	4107731	
43436	3841	4043071	1985-03-05	1985-03-05 00:00:00	38000275	0	\N	\N	255024	0	228557008	4043071	
55584	4844	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	322185	0	180256009	4107731	
55797	4867	4195803	1979-09-08	1979-09-08 00:00:00	38000275	0	\N	\N	323684	0	312681000	4195803	
55934	4878	4107731	1992-04-04	1992-04-04 00:00:00	38000275	0	\N	\N	324436	0	180256009	4107731	
32256	2832	4107731	1996-11-16	1996-11-16 00:00:00	38000275	0	\N	\N	187904	0	180256009	4107731	
56471	4924	4107731	1993-11-24	1993-11-24 00:00:00	38000275	0	\N	\N	327277	0	180256009	4107731	
56654	4929	4170947	1969-12-18	1969-12-18 00:00:00	38000275	0	\N	\N	327670	0	274474001	4170947	
56771	4935	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	328108	0	180256009	4107731	
44995	3951	4010253	2004-09-16	2004-09-16 00:00:00	38000275	0	\N	\N	262689	0	112790001	4010253	
33213	2902	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	193308	0	180256009	4107731	
45291	3996	4170947	2010-08-23	2010-08-23 00:00:00	38000275	0	\N	\N	265697	0	274474001	4170947	
45729	4027	4107731	1990-09-15	1990-09-15 00:00:00	38000275	0	\N	\N	267860	0	180256009	4107731	
46079	4052	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	269299	0	180256009	4107731	
34400	2980	4107731	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	198935	0	180256009	4107731	
46477	4078	4107731	1990-12-03	1990-12-03 00:00:00	38000275	0	\N	\N	270983	0	180256009	4107731	
58609	5076	4043071	1947-03-26	1947-03-26 00:00:00	38000275	0	\N	\N	337430	0	228557008	4043071	
46864	4109	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	273149	0	180256009	4107731	
47197	4145	4107731	2007-06-30	2007-06-30 00:00:00	38000275	0	\N	\N	275474	0	180256009	4107731	
59435	5142	4195803	2013-07-23	2013-07-23 00:00:00	38000275	0	\N	\N	341698	0	312681000	4195803	
59491	5150	4151422	1973-12-13	1973-12-13 00:00:00	38000275	0	\N	\N	342379	0	269911007	4151422	
47838	4200	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	278724	0	180256009	4107731	
24104	2098	4151422	1973-11-19	1973-11-19 00:00:00	38000275	0	\N	\N	139855	0	269911007	4151422	
36276	3178	4078793	2018-09-15	2018-09-15 00:00:00	38000275	0	\N	\N	211438	0	180325003	4078793	
36306	3181	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	211764	0	180256009	4107731	
48449	4247	4043071	1995-04-20	1995-04-20 00:00:00	38000275	0	\N	\N	282104	0	228557008	4043071	
36837	3241	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	215510	0	180256009	4107731	
36919	3249	4163872	2008-02-29	2008-02-29 00:00:00	38000275	0	\N	\N	215992	0	399208008	4163872	
48999	4305	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	285656	0	180256009	4107731	
37341	3283	4275113	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	218104	0	65200003	4275113	
37526	3311	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	219764	0	180256009	4107731	
61527	5322	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	354091	0	180256009	4107731	
37833	3343	4107731	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	221730	0	180256009	4107731	
38143	3364	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	223044	0	180256009	4107731	
38254	3371	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	223559	0	180256009	4107731	
50377	4382	4238715	1982-12-27	1982-12-27 00:00:00	38000275	0	\N	\N	291276	0	68254000	4238715	
50528	4390	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	291810	0	180256009	4107731	
38796	3414	4125906	1974-11-18	1974-11-18 00:00:00	38000275	0	\N	\N	226451	0	288086009	4125906	
38997	3444	4202451	2018-10-29	2018-10-29 00:00:00	38000275	0	\N	\N	228576	0	433112001	4202451	
51354	4451	4170947	1976-04-01	1976-04-01 00:00:00	38000275	0	\N	\N	296138	0	274474001	4170947	
27643	2419	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	160497	0	180256009	4107731	
39789	3505	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	232450	0	180256009	4107731	
39910	3510	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	232925	0	180256009	4107731	
40202	3528	4170947	2015-05-04	2015-05-04 00:00:00	38000275	0	\N	\N	234284	0	274474001	4170947	
52200	4527	4170947	2011-09-02	2011-09-02 00:00:00	38000275	0	\N	\N	301446	0	274474001	4170947	
40437	3553	4187458	1982-10-26	1982-10-26 00:00:00	38000275	0	\N	\N	235891	0	415300000	4187458	
40759	3573	4195803	2003-10-18	2003-10-18 00:00:00	38000275	0	\N	\N	237525	0	312681000	4195803	
40909	3589	4107731	1997-04-15	1997-04-15 00:00:00	38000275	0	\N	\N	238426	0	180256009	4107731	
29103	2577	4107731	1990-02-17	1990-02-17 00:00:00	38000275	0	\N	\N	170589	0	180256009	4107731	
41225	3622	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	240737	0	180256009	4107731	
41480	3641	4043071	1921-08-27	1921-08-27 00:00:00	38000275	0	\N	\N	242359	0	228557008	4043071	
53586	4646	4078793	2010-04-27	2010-04-27 00:00:00	38000275	0	\N	\N	309816	0	180325003	4078793	
53718	4655	4107731	1992-08-09	1992-08-09 00:00:00	38000275	0	\N	\N	310293	0	180256009	4107731	
42018	3703	4125906	1971-10-30	1971-10-30 00:00:00	38000275	0	\N	\N	246253	0	288086009	4125906	
42188	3719	4151422	1986-11-19	1986-11-19 00:00:00	38000275	0	\N	\N	247194	0	269911007	4151422	
54331	4719	4107731	1991-09-29	1991-09-29 00:00:00	38000275	0	\N	\N	314307	0	180256009	4107731	
42481	3745	4197460	1931-03-07	1931-03-07 00:00:00	38000275	0	\N	\N	248872	0	313191000	4197460	
42781	3772	4107731	1990-06-23	1990-06-23 00:00:00	38000275	0	\N	\N	250666	0	180256009	4107731	
54821	4753	4243062	1968-04-01	1968-04-01 00:00:00	38000275	0	\N	\N	316573	0	60027007	4243062	
55069	4792	4024289	1969-03-11	1969-03-11 00:00:00	38000275	0	\N	\N	318826	0	19490002	4024289	
31373	2776	4107731	2005-12-20	2005-12-20 00:00:00	38000275	0	\N	\N	183857	0	180256009	4107731	
43437	3841	4043071	1984-11-27	1984-11-27 00:00:00	38000275	0	\N	\N	255029	0	228557008	4043071	
55585	4844	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	322296	0	395142003	4191853	
55798	4867	4151422	1948-01-20	1948-01-20 00:00:00	38000275	0	\N	\N	323707	0	269911007	4151422	
55935	4878	4107731	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	324350	0	180256009	4107731	
32257	2832	4107731	1996-05-11	1996-05-11 00:00:00	38000275	0	\N	\N	187878	0	180256009	4107731	
56655	4929	4024289	1969-12-18	1969-12-18 00:00:00	38000275	0	\N	\N	327670	0	19490002	4024289	
56772	4935	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	328117	0	180256009	4107731	
44996	3951	4195803	2011-05-31	2011-05-31 00:00:00	38000275	0	\N	\N	262602	0	312681000	4195803	
33214	2902	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	193311	0	180256009	4107731	
45292	3996	4047491	2010-08-23	2010-08-23 00:00:00	38000275	0	\N	\N	265697	0	1225002	4047491	
45730	4027	4107731	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	267852	0	180256009	4107731	
46080	4052	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	269391	0	180256009	4107731	
34401	2980	4107731	1991-07-07	1991-07-07 00:00:00	38000275	0	\N	\N	198949	0	180256009	4107731	
46478	4078	4107731	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	270953	0	180256009	4107731	
58610	5076	4043071	1947-06-25	1947-06-25 00:00:00	38000275	0	\N	\N	337385	0	228557008	4043071	
46865	4109	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	273093	0	180256009	4107731	
47198	4145	4107731	2009-03-21	2009-03-21 00:00:00	38000275	0	\N	\N	275461	0	180256009	4107731	
59436	5142	4043071	1953-11-25	1953-11-25 00:00:00	38000275	0	\N	\N	341724	0	228557008	4043071	
59492	5150	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	342351	0	180256009	4107731	
47839	4200	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	278839	0	180256009	4107731	
24105	2098	4125906	2005-07-18	2005-07-18 00:00:00	38000275	0	\N	\N	139841	0	288086009	4125906	
36277	3179	4170947	1932-10-14	1932-10-14 00:00:00	38000275	0	\N	\N	211527	0	274474001	4170947	
36307	3181	4170947	2018-11-15	2018-11-15 00:00:00	38000275	0	\N	\N	211691	0	274474001	4170947	
48450	4247	4043071	1995-09-28	1995-09-28 00:00:00	38000275	0	\N	\N	282102	0	228557008	4043071	
36838	3241	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	215527	0	180256009	4107731	
36920	3249	4170947	2008-02-29	2008-02-29 00:00:00	38000275	0	\N	\N	215992	0	274474001	4170947	
49000	4305	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	285612	0	180256009	4107731	
37342	3283	4151422	2001-12-12	2001-12-12 00:00:00	38000275	0	\N	\N	218111	0	269911007	4151422	
37527	3311	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	219810	0	180256009	4107731	
61528	5322	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	354193	0	180256009	4107731	
37834	3343	4107731	1993-05-09	1993-05-09 00:00:00	38000275	0	\N	\N	221858	0	180256009	4107731	
38144	3365	4043071	1971-08-20	1971-08-20 00:00:00	38000275	0	\N	\N	223166	0	228557008	4043071	
38255	3371	4125906	1998-06-25	1998-06-25 00:00:00	38000275	0	\N	\N	223600	0	288086009	4125906	
50378	4382	4151422	1955-08-17	1955-08-17 00:00:00	38000275	0	\N	\N	291207	0	269911007	4151422	
50529	4390	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	291845	0	180256009	4107731	
38797	3415	4125906	2015-08-22	2015-08-22 00:00:00	38000275	0	\N	\N	226552	0	288086009	4125906	
38998	3444	4151422	1978-06-04	1978-06-04 00:00:00	38000275	0	\N	\N	228537	0	269911007	4151422	
51355	4451	4163872	1976-04-01	1976-04-01 00:00:00	38000275	0	\N	\N	296138	0	399208008	4163872	
27644	2419	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	160561	0	180256009	4107731	
39790	3505	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	232383	0	180256009	4107731	
39911	3510	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	232805	0	180256009	4107731	
40203	3528	4195803	2015-05-04	2015-05-04 00:00:00	38000275	0	\N	\N	234284	0	312681000	4195803	
52201	4527	4195803	2011-09-02	2011-09-02 00:00:00	38000275	0	\N	\N	301446	0	312681000	4195803	
40474	3556	4125906	2002-01-03	2002-01-03 00:00:00	38000275	0	\N	\N	236130	0	288086009	4125906	
40760	3573	4151422	1968-11-30	1968-11-30 00:00:00	38000275	0	\N	\N	237578	0	269911007	4151422	
40910	3589	4107731	1995-09-05	1995-09-05 00:00:00	38000275	0	\N	\N	238420	0	180256009	4107731	
29104	2577	4107731	1990-11-17	1990-11-17 00:00:00	38000275	0	\N	\N	170592	0	180256009	4107731	
41226	3622	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	240744	0	180256009	4107731	
41481	3641	4043071	1921-01-08	1921-01-08 00:00:00	38000275	0	\N	\N	242326	0	228557008	4043071	
53587	4646	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	309874	0	180256009	4107731	
53719	4655	4107731	1992-02-23	1992-02-23 00:00:00	38000275	0	\N	\N	310327	0	180256009	4107731	
42019	3703	4107731	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	246208	0	180256009	4107731	
42189	3719	4170947	1968-11-07	1968-11-07 00:00:00	38000275	0	\N	\N	247203	0	274474001	4170947	
54332	4719	4107731	1990-04-22	1990-04-22 00:00:00	38000275	0	\N	\N	314253	0	180256009	4107731	
42482	3745	4151422	1984-05-13	1984-05-13 00:00:00	38000275	0	\N	\N	248956	0	269911007	4151422	
42782	3772	4107731	1992-01-11	1992-01-11 00:00:00	38000275	0	\N	\N	250734	0	180256009	4107731	
54822	4753	4043071	1974-06-01	1974-06-01 00:00:00	38000275	0	\N	\N	316568	0	228557008	4043071	
55070	4792	4170947	1969-03-11	1969-03-11 00:00:00	38000275	0	\N	\N	318826	0	274474001	4170947	
31374	2776	4107731	2007-11-13	2007-11-13 00:00:00	38000275	0	\N	\N	183880	0	180256009	4107731	
43438	3841	4043071	1985-04-09	1985-04-09 00:00:00	38000275	0	\N	\N	255037	0	228557008	4043071	
55586	4844	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	322180	0	180256009	4107731	
55799	4867	4170947	1926-11-01	1926-11-01 00:00:00	38000275	0	\N	\N	323682	0	274474001	4170947	
55936	4878	4107731	1991-09-28	1991-09-28 00:00:00	38000275	0	\N	\N	324389	0	180256009	4107731	
32258	2832	4107731	1997-06-14	1997-06-14 00:00:00	38000275	0	\N	\N	187930	0	180256009	4107731	
56656	4929	4125906	1965-11-25	1965-11-25 00:00:00	38000275	0	\N	\N	327669	0	288086009	4125906	
56773	4935	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	328066	0	180256009	4107731	
44997	3951	4058899	2011-05-31	2011-05-31 00:00:00	38000275	0	\N	\N	262602	0	168594001	4058899	
33215	2902	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	193310	0	180256009	4107731	
45293	3997	4293740	1998-02-25	1998-02-25 00:00:00	38000275	0	\N	\N	265703	0	384700001	4293740	
45731	4027	4107731	1993-05-08	1993-05-08 00:00:00	38000275	0	\N	\N	267851	0	180256009	4107731	
46081	4052	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	269309	0	180256009	4107731	
34402	2980	4107731	1990-12-30	1990-12-30 00:00:00	38000275	0	\N	\N	198948	0	180256009	4107731	
46479	4078	4107731	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	270981	0	180256009	4107731	
58611	5076	4043071	1947-05-28	1947-05-28 00:00:00	38000275	0	\N	\N	337420	0	228557008	4043071	
46866	4109	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	273106	0	180256009	4107731	
47199	4145	4107731	2007-08-11	2007-08-11 00:00:00	38000275	0	\N	\N	275454	0	180256009	4107731	
59437	5143	4043071	1973-03-28	1973-03-28 00:00:00	38000275	0	\N	\N	341863	0	228557008	4043071	
59493	5150	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	342362	0	180256009	4107731	
47840	4200	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	278727	0	180256009	4107731	
24106	2098	4125906	2007-04-23	2007-04-23 00:00:00	38000275	0	\N	\N	139842	0	288086009	4125906	
36278	3179	4024289	1932-10-14	1932-10-14 00:00:00	38000275	0	\N	\N	211527	0	19490002	4024289	
36308	3181	4024289	2018-11-15	2018-11-15 00:00:00	38000275	0	\N	\N	211691	0	19490002	4024289	
48451	4247	4043071	1997-07-17	1997-07-17 00:00:00	38000275	0	\N	\N	282048	0	228557008	4043071	
36839	3241	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	215479	0	180256009	4107731	
36921	3249	4043071	1967-08-09	1967-08-09 00:00:00	38000275	0	\N	\N	215962	0	228557008	4043071	
49001	4305	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	285602	0	180256009	4107731	
37343	3283	4024289	2018-10-12	2018-10-12 00:00:00	38000275	0	\N	\N	218108	0	19490002	4024289	
37528	3311	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	219803	0	180256009	4107731	
61529	5322	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	354165	0	180256009	4107731	
37835	3343	4043071	1986-09-30	1986-09-30 00:00:00	38000275	0	\N	\N	221754	0	228557008	4043071	
38145	3365	4043071	1972-04-14	1972-04-14 00:00:00	38000275	0	\N	\N	223170	0	228557008	4043071	
38256	3371	4293740	1998-06-25	1998-06-25 00:00:00	38000275	0	\N	\N	223600	0	384700001	4293740	
50379	4382	4275113	1980-10-17	1980-10-17 00:00:00	38000275	0	\N	\N	291231	0	65200003	4275113	
50530	4390	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	291804	0	395142003	4191853	
38798	3415	4301346	1983-09-09	1983-09-09 00:00:00	38000275	0	\N	\N	226550	0	387685009	4301346	
39066	3446	4043071	1952-06-24	1952-06-24 00:00:00	38000275	0	\N	\N	228868	0	228557008	4043071	
51356	4451	4043071	1963-01-31	1963-01-31 00:00:00	38000275	0	\N	\N	296162	0	228557008	4043071	
27645	2419	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	160498	0	180256009	4107731	
39791	3505	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	232471	0	180256009	4107731	
39912	3510	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	232866	0	180256009	4107731	
40204	3528	4024289	2015-05-04	2015-05-04 00:00:00	38000275	0	\N	\N	234284	0	19490002	4024289	
52204	4529	4035793	2015-11-29	2015-11-29 00:00:00	38000275	0	\N	\N	301558	0	15081005	4035793	
40475	3556	4151422	2000-08-22	2000-08-22 00:00:00	38000275	0	\N	\N	236120	0	269911007	4151422	
40761	3573	4195803	2000-01-24	2000-01-24 00:00:00	38000275	0	\N	\N	237630	0	312681000	4195803	
40911	3589	4107731	1994-08-23	1994-08-23 00:00:00	38000275	0	\N	\N	238452	0	180256009	4107731	
29105	2577	4191853	1990-01-06	1990-01-06 00:00:00	38000275	0	\N	\N	170588	0	395142003	4191853	
41227	3622	4078793	2004-11-24	2004-11-24 00:00:00	38000275	0	\N	\N	240701	0	180325003	4078793	
41482	3641	4043071	1921-03-12	1921-03-12 00:00:00	38000275	0	\N	\N	242317	0	228557008	4043071	
53588	4646	4078793	2003-10-21	2003-10-21 00:00:00	38000275	0	\N	\N	309746	0	180325003	4078793	
53720	4655	4191853	1990-01-07	1990-01-07 00:00:00	38000275	0	\N	\N	310265	0	395142003	4191853	
42020	3703	4107731	1991-05-04	1991-05-04 00:00:00	38000275	0	\N	\N	246203	0	180256009	4107731	
42190	3719	4047491	1968-11-07	1968-11-07 00:00:00	38000275	0	\N	\N	247203	0	1225002	4047491	
54333	4719	4107731	1992-11-01	1992-11-01 00:00:00	38000275	0	\N	\N	314176	0	180256009	4107731	
42483	3745	4035793	2011-09-07	2011-09-07 00:00:00	38000275	0	\N	\N	248964	0	15081005	4035793	
42783	3772	4107731	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	250659	0	180256009	4107731	
54823	4753	4043071	1973-03-24	1973-03-24 00:00:00	38000275	0	\N	\N	316536	0	228557008	4043071	
55071	4792	4125906	2017-04-03	2017-04-03 00:00:00	38000275	0	\N	\N	318829	0	288086009	4125906	
31375	2776	4107731	2007-03-06	2007-03-06 00:00:00	38000275	0	\N	\N	183837	0	180256009	4107731	
43439	3843	4010253	2001-06-15	2001-06-15 00:00:00	38000275	0	\N	\N	255093	0	112790001	4010253	
55587	4844	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	322233	0	180256009	4107731	
55800	4867	4024289	1926-11-01	1926-11-01 00:00:00	38000275	0	\N	\N	323682	0	19490002	4024289	
55937	4878	4107731	1991-02-09	1991-02-09 00:00:00	38000275	0	\N	\N	324387	0	180256009	4107731	
32259	2832	4107731	1994-12-03	1994-12-03 00:00:00	38000275	0	\N	\N	188006	0	180256009	4107731	
56657	4929	4125906	2004-10-20	2004-10-20 00:00:00	38000275	0	\N	\N	327673	0	288086009	4125906	
56774	4935	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	328093	0	180256009	4107731	
44998	3951	4170947	1950-01-21	1950-01-21 00:00:00	38000275	0	\N	\N	262600	0	274474001	4170947	
33216	2902	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	193266	0	180256009	4107731	
45294	3997	4125906	1998-02-25	1998-02-25 00:00:00	38000275	0	\N	\N	265703	0	288086009	4125906	
45732	4027	4107731	1990-03-10	1990-03-10 00:00:00	38000275	0	\N	\N	267870	0	180256009	4107731	
46082	4052	4191853	1977-12-04	1977-12-04 00:00:00	38000275	0	\N	\N	269373	0	395142003	4191853	
34403	2980	4107731	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	198989	0	180256009	4107731	
46480	4078	4107731	1992-06-01	1992-06-01 00:00:00	38000275	0	\N	\N	271087	0	180256009	4107731	
58612	5076	4024289	2005-09-02	2005-09-02 00:00:00	38000275	0	\N	\N	337331	0	19490002	4024289	
46867	4109	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	273205	0	180256009	4107731	
47214	4149	4125906	2006-04-26	2006-04-26 00:00:00	38000275	0	\N	\N	275760	0	288086009	4125906	
59438	5143	4043071	1973-07-18	1973-07-18 00:00:00	38000275	0	\N	\N	341855	0	228557008	4043071	
59494	5150	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	342361	0	180256009	4107731	
47841	4200	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	278741	0	395142003	4191853	
24107	2098	4238715	1983-11-23	1983-11-23 00:00:00	38000275	0	\N	\N	139907	0	68254000	4238715	
48060	4217	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	279979	0	180256009	4107731	
36309	3181	4195803	2018-11-15	2018-11-15 00:00:00	38000275	0	\N	\N	211691	0	312681000	4195803	
48452	4247	4043071	2000-02-10	2000-02-10 00:00:00	38000275	0	\N	\N	282017	0	228557008	4043071	
48621	4274	4195803	2002-07-03	2002-07-03 00:00:00	38000275	0	\N	\N	283562	0	312681000	4195803	
36922	3249	4024289	1999-09-14	1999-09-14 00:00:00	38000275	0	\N	\N	215990	0	19490002	4024289	
49002	4305	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	285641	0	180256009	4107731	
37344	3283	4170947	2018-10-12	2018-10-12 00:00:00	38000275	0	\N	\N	218108	0	274474001	4170947	
37529	3311	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	219826	0	180256009	4107731	
61530	5322	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	354234	0	180256009	4107731	
37836	3343	4043071	1987-07-07	1987-07-07 00:00:00	38000275	0	\N	\N	221778	0	228557008	4043071	
38146	3365	4043071	1972-02-04	1972-02-04 00:00:00	38000275	0	\N	\N	223168	0	228557008	4043071	
38257	3371	4047491	1982-12-06	1982-12-06 00:00:00	38000275	0	\N	\N	223669	0	1225002	4047491	
50380	4382	4062501	1955-01-05	1955-01-05 00:00:00	38000275	0	\N	\N	291260	0	171231001	4062501	
50531	4390	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	291881	0	180256009	4107731	
38799	3415	4151422	1985-10-22	1985-10-22 00:00:00	38000275	0	\N	\N	226547	0	269911007	4151422	
39067	3446	4043071	1953-03-31	1953-03-31 00:00:00	38000275	0	\N	\N	228805	0	228557008	4043071	
51357	4451	4043071	1962-10-25	1962-10-25 00:00:00	38000275	0	\N	\N	296198	0	228557008	4043071	
27646	2419	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	160594	0	180256009	4107731	
39792	3505	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	232514	0	180256009	4107731	
39913	3510	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	232943	0	395142003	4191853	
40205	3528	4107731	1991-12-16	1991-12-16 00:00:00	38000275	0	\N	\N	234175	0	180256009	4107731	
52205	4529	4275113	1983-10-16	1983-10-16 00:00:00	38000275	0	\N	\N	301606	0	65200003	4275113	
40476	3556	4243062	1994-01-24	1994-01-24 00:00:00	38000275	0	\N	\N	236128	0	60027007	4243062	
40762	3573	4163872	2000-01-24	2000-01-24 00:00:00	38000275	0	\N	\N	237630	0	399208008	4163872	
40912	3589	4107731	1994-12-05	1994-12-05 00:00:00	38000275	0	\N	\N	238480	0	180256009	4107731	
29106	2577	4191853	1993-07-10	1993-07-10 00:00:00	38000275	0	\N	\N	170596	0	395142003	4191853	
41228	3622	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	240811	0	180256009	4107731	
41483	3641	4043071	1922-03-11	1922-03-11 00:00:00	38000275	0	\N	\N	242360	0	228557008	4043071	
53589	4646	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	309870	0	180256009	4107731	
53721	4655	4107731	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	310322	0	180256009	4107731	
42021	3703	4107731	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	246209	0	180256009	4107731	
42191	3719	4170947	1985-10-09	1985-10-09 00:00:00	38000275	0	\N	\N	247166	0	274474001	4170947	
54334	4720	4275113	1994-05-26	1994-05-26 00:00:00	38000275	0	\N	\N	314362	0	65200003	4275113	
42484	3745	4035793	2012-09-12	2012-09-12 00:00:00	38000275	0	\N	\N	248970	0	15081005	4035793	
42784	3772	4107731	1992-12-12	1992-12-12 00:00:00	38000275	0	\N	\N	250711	0	180256009	4107731	
54824	4753	40492359	1987-11-18	1987-11-18 00:00:00	38000275	0	\N	\N	316575	0	447365002	40492359	
55072	4792	4252419	1988-01-01	1988-01-01 00:00:00	38000275	0	\N	\N	318827	0	74016001	4252419	
31376	2776	4107731	2008-07-01	2008-07-01 00:00:00	38000275	0	\N	\N	183882	0	180256009	4107731	
43440	3844	4151422	1981-04-01	1981-04-01 00:00:00	38000275	0	\N	\N	255133	0	269911007	4151422	
55588	4844	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	322210	0	180256009	4107731	
55801	4867	4163872	1987-05-29	1987-05-29 00:00:00	38000275	0	\N	\N	323685	0	399208008	4163872	
55938	4878	4107731	1990-08-04	1990-08-04 00:00:00	38000275	0	\N	\N	324342	0	180256009	4107731	
32260	2832	4107731	1994-10-22	1994-10-22 00:00:00	38000275	0	\N	\N	188005	0	180256009	4107731	
56660	4932	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	327919	0	180256009	4107731	
56775	4935	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	328084	0	180256009	4107731	
44999	3951	4243062	1950-01-21	1950-01-21 00:00:00	38000275	0	\N	\N	262600	0	60027007	4243062	
33217	2903	4151422	1979-01-26	1979-01-26 00:00:00	38000275	0	\N	\N	193410	0	269911007	4151422	
45295	3997	4243062	1978-04-13	1978-04-13 00:00:00	38000275	0	\N	\N	265700	0	60027007	4243062	
45733	4027	4107731	1991-07-27	1991-07-27 00:00:00	38000275	0	\N	\N	267864	0	180256009	4107731	
46083	4052	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	269414	0	180256009	4107731	
34404	2980	4107731	1991-02-10	1991-02-10 00:00:00	38000275	0	\N	\N	198964	0	180256009	4107731	
46481	4078	4107731	1990-05-07	1990-05-07 00:00:00	38000275	0	\N	\N	271061	0	180256009	4107731	
58613	5076	4170947	2005-09-02	2005-09-02 00:00:00	38000275	0	\N	\N	337331	0	274474001	4170947	
46868	4109	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	273188	0	180256009	4107731	
47215	4149	4125906	2007-06-04	2007-06-04 00:00:00	38000275	0	\N	\N	275761	0	288086009	4125906	
59439	5143	4151422	1967-03-09	1967-03-09 00:00:00	38000275	0	\N	\N	341851	0	269911007	4151422	
59495	5150	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	342403	0	180256009	4107731	
47842	4200	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	278827	0	180256009	4107731	
24109	2100	4125906	2014-12-16	2014-12-16 00:00:00	38000275	0	\N	\N	139974	0	288086009	4125906	
48061	4217	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	280044	0	180256009	4107731	
36310	3181	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	211821	0	180256009	4107731	
48456	4250	4163872	1947-11-20	1947-11-20 00:00:00	38000275	0	\N	\N	282285	0	399208008	4163872	
48622	4274	4047491	2002-07-03	2002-07-03 00:00:00	38000275	0	\N	\N	283562	0	1225002	4047491	
36923	3249	4170947	1999-09-14	1999-09-14 00:00:00	38000275	0	\N	\N	215990	0	274474001	4170947	
49003	4305	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	285554	0	180256009	4107731	
37345	3283	4058899	1981-02-28	1981-02-28 00:00:00	38000275	0	\N	\N	218106	0	168594001	4058899	
37530	3311	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	219881	0	180256009	4107731	
61531	5322	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	354169	0	180256009	4107731	
37837	3343	4107731	1991-12-22	1991-12-22 00:00:00	38000275	0	\N	\N	221873	0	180256009	4107731	
38147	3365	4043071	1971-12-31	1971-12-31 00:00:00	38000275	0	\N	\N	223191	0	228557008	4043071	
38258	3371	4170947	1982-12-06	1982-12-06 00:00:00	38000275	0	\N	\N	223669	0	274474001	4170947	
50381	4382	4293740	2017-03-03	2017-03-03 00:00:00	38000275	0	\N	\N	291175	0	384700001	4293740	
50532	4390	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	291898	0	180256009	4107731	
38800	3415	4243062	1979-11-22	1979-11-22 00:00:00	38000275	0	\N	\N	226551	0	60027007	4243062	
39068	3446	4043071	1952-07-22	1952-07-22 00:00:00	38000275	0	\N	\N	228832	0	228557008	4043071	
51358	4451	4043071	1962-11-29	1962-11-29 00:00:00	38000275	0	\N	\N	296199	0	228557008	4043071	
27647	2419	4125906	1959-05-10	1959-05-10 00:00:00	38000275	0	\N	\N	160506	0	288086009	4125906	
39793	3505	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	232429	0	180256009	4107731	
39914	3510	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	232808	0	180256009	4107731	
51987	4505	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	299974	0	180256009	4107731	
52206	4529	4035793	2016-12-04	2016-12-04 00:00:00	38000275	0	\N	\N	301603	0	15081005	4035793	
40477	3556	4170947	1994-01-24	1994-01-24 00:00:00	38000275	0	\N	\N	236128	0	274474001	4170947	
40763	3573	4170947	2000-01-24	2000-01-24 00:00:00	38000275	0	\N	\N	237630	0	274474001	4170947	
40913	3589	4107731	1995-01-16	1995-01-16 00:00:00	38000275	0	\N	\N	238432	0	180256009	4107731	
29107	2577	4107731	1993-05-29	1993-05-29 00:00:00	38000275	0	\N	\N	170689	0	180256009	4107731	
41229	3622	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	240676	0	395142003	4191853	
41484	3641	4043071	1922-01-07	1922-01-07 00:00:00	38000275	0	\N	\N	242267	0	228557008	4043071	
53590	4646	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	309845	0	395142003	4191853	
53722	4655	4107731	1993-04-18	1993-04-18 00:00:00	38000275	0	\N	\N	310365	0	180256009	4107731	
42022	3703	4107731	1990-11-17	1990-11-17 00:00:00	38000275	0	\N	\N	246289	0	180256009	4107731	
42192	3719	4047491	1985-10-09	1985-10-09 00:00:00	38000275	0	\N	\N	247166	0	1225002	4047491	
54335	4720	4151422	1989-08-30	1989-08-30 00:00:00	38000275	0	\N	\N	314402	0	269911007	4151422	
42485	3745	4035793	2016-10-05	2016-10-05 00:00:00	38000275	0	\N	\N	248975	0	15081005	4035793	
42785	3772	4107731	1990-01-27	1990-01-27 00:00:00	38000275	0	\N	\N	250648	0	180256009	4107731	
54825	4753	4057420	1987-11-18	1987-11-18 00:00:00	38000275	0	\N	\N	316575	0	18286008	4057420	
55073	4792	4151422	2000-12-10	2000-12-10 00:00:00	38000275	0	\N	\N	318844	0	269911007	4151422	
31377	2776	4107731	2006-08-29	2006-08-29 00:00:00	38000275	0	\N	\N	183836	0	180256009	4107731	
43441	3844	4010253	1993-07-31	1993-07-31 00:00:00	38000275	0	\N	\N	255188	0	112790001	4010253	
55589	4844	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	322230	0	180256009	4107731	
55802	4867	4170947	1987-05-29	1987-05-29 00:00:00	38000275	0	\N	\N	323685	0	274474001	4170947	
55939	4878	4107731	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	324393	0	180256009	4107731	
32261	2832	4151422	2000-04-13	2000-04-13 00:00:00	38000275	0	\N	\N	187935	0	269911007	4151422	
56661	4932	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	327815	0	180256009	4107731	
56776	4935	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	328056	0	180256009	4107731	
45008	3955	4243062	1994-02-28	1994-02-28 00:00:00	38000275	0	\N	\N	262901	0	60027007	4243062	
33218	2903	4125906	1973-08-23	1973-08-23 00:00:00	38000275	0	\N	\N	193430	0	288086009	4125906	
45296	3997	4170947	1978-04-13	1978-04-13 00:00:00	38000275	0	\N	\N	265700	0	274474001	4170947	
45734	4027	4107731	1990-10-27	1990-10-27 00:00:00	38000275	0	\N	\N	267861	0	180256009	4107731	
46084	4052	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	269389	0	180256009	4107731	
34405	2980	4107731	1992-11-22	1992-11-22 00:00:00	38000275	0	\N	\N	198937	0	180256009	4107731	
46482	4078	4107731	1991-07-22	1991-07-22 00:00:00	38000275	0	\N	\N	270985	0	180256009	4107731	
58614	5076	4195803	2005-09-02	2005-09-02 00:00:00	38000275	0	\N	\N	337331	0	312681000	4195803	
46869	4109	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	273201	0	180256009	4107731	
47311	4153	4170947	2005-05-10	2005-05-10 00:00:00	38000275	0	\N	\N	276008	0	274474001	4170947	
59440	5143	4043071	1974-01-30	1974-01-30 00:00:00	38000275	0	\N	\N	341856	0	228557008	4043071	
59496	5150	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	342404	0	180256009	4107731	
47843	4200	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	278747	0	180256009	4107731	
24110	2100	4195803	2012-08-28	2012-08-28 00:00:00	38000275	0	\N	\N	139973	0	312681000	4195803	
48062	4217	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	279944	0	180256009	4107731	
36311	3181	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	211755	0	180256009	4107731	
48457	4250	4125906	1949-01-11	1949-01-11 00:00:00	38000275	0	\N	\N	282261	0	288086009	4125906	
48623	4274	4024289	1943-01-30	1943-01-30 00:00:00	38000275	0	\N	\N	283559	0	19490002	4024289	
36924	3249	4125906	1988-07-01	1988-07-01 00:00:00	38000275	0	\N	\N	215988	0	288086009	4125906	
49004	4305	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	285581	0	180256009	4107731	
37347	3285	40492359	2011-03-12	2011-03-12 00:00:00	38000275	0	\N	\N	218180	0	447365002	40492359	
37531	3311	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	219813	0	180256009	4107731	
61532	5322	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	354128	0	180256009	4107731	
37838	3343	4107731	1991-08-18	1991-08-18 00:00:00	38000275	0	\N	\N	221850	0	180256009	4107731	
38148	3365	4043071	1972-05-19	1972-05-19 00:00:00	38000275	0	\N	\N	223199	0	228557008	4043071	
38259	3371	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	223597	0	180256009	4107731	
50382	4382	4125906	2017-03-03	2017-03-03 00:00:00	38000275	0	\N	\N	291175	0	288086009	4125906	
50533	4390	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	291917	0	180256009	4107731	
38801	3415	4170947	1979-11-22	1979-11-22 00:00:00	38000275	0	\N	\N	226551	0	274474001	4170947	
39069	3446	4181917	1958-04-07	1958-04-07 00:00:00	38000275	0	\N	\N	228778	0	54550000	4181917	
51359	4451	4043071	1962-06-07	1962-06-07 00:00:00	38000275	0	\N	\N	296160	0	228557008	4043071	
27648	2419	4293740	1959-05-10	1959-05-10 00:00:00	38000275	0	\N	\N	160506	0	384700001	4293740	
39794	3505	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	232505	0	180256009	4107731	
39915	3510	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	232905	0	395142003	4191853	
51988	4505	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	300114	0	180256009	4107731	
52207	4529	44783196	1998-10-05	1998-10-05 00:00:00	38000275	0	\N	\N	301614	0	699253003	44783196	
40478	3556	4125906	2000-01-23	2000-01-23 00:00:00	38000275	0	\N	\N	236129	0	288086009	4125906	
40764	3573	4125906	1978-09-04	1978-09-04 00:00:00	38000275	0	\N	\N	237628	0	288086009	4125906	
40914	3589	4107731	1997-06-17	1997-06-17 00:00:00	38000275	0	\N	\N	238444	0	180256009	4107731	
29108	2577	4107731	1991-09-28	1991-09-28 00:00:00	38000275	0	\N	\N	170698	0	180256009	4107731	
41230	3622	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	240728	0	180256009	4107731	
41485	3641	4125906	1979-04-01	1979-04-01 00:00:00	38000275	0	\N	\N	242313	0	288086009	4125906	
53591	4646	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	309765	0	180256009	4107731	
53723	4655	4107731	1993-02-14	1993-02-14 00:00:00	38000275	0	\N	\N	310332	0	180256009	4107731	
42023	3703	4024289	1982-01-24	1982-01-24 00:00:00	38000275	0	\N	\N	246255	0	19490002	4024289	
42193	3720	4010253	1980-11-14	1980-11-14 00:00:00	38000275	0	\N	\N	247244	0	112790001	4010253	
54336	4720	4326177	2007-06-08	2007-06-08 00:00:00	38000275	0	\N	\N	314409	0	430193006	4326177	
42486	3745	4035793	2013-09-18	2013-09-18 00:00:00	38000275	0	\N	\N	248965	0	15081005	4035793	
42786	3772	4107731	1991-06-15	1991-06-15 00:00:00	38000275	0	\N	\N	250674	0	180256009	4107731	
54826	4753	4043071	1972-04-08	1972-04-08 00:00:00	38000275	0	\N	\N	316564	0	228557008	4043071	
55075	4795	4151422	1974-02-20	1974-02-20 00:00:00	38000275	0	\N	\N	318993	0	269911007	4151422	
31378	2776	4107731	2005-11-08	2005-11-08 00:00:00	38000275	0	\N	\N	183864	0	180256009	4107731	
43442	3844	4170947	1970-03-26	1970-03-26 00:00:00	38000275	0	\N	\N	255129	0	274474001	4170947	
55590	4844	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	322234	0	180256009	4107731	
55803	4867	4195803	1987-05-29	1987-05-29 00:00:00	38000275	0	\N	\N	323685	0	312681000	4195803	
55940	4878	4107731	1991-05-25	1991-05-25 00:00:00	38000275	0	\N	\N	324353	0	180256009	4107731	
32262	2832	4107731	1995-10-14	1995-10-14 00:00:00	38000275	0	\N	\N	188011	0	180256009	4107731	
56777	4935	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	328060	0	180256009	4107731	
45009	3955	4170947	1994-02-28	1994-02-28 00:00:00	38000275	0	\N	\N	262901	0	274474001	4170947	
33219	2903	4293740	1973-08-23	1973-08-23 00:00:00	38000275	0	\N	\N	193430	0	384700001	4293740	
45297	3997	4187458	2018-11-08	2018-11-08 00:00:00	38000275	0	\N	\N	265735	0	415300000	4187458	
45735	4027	4107731	1991-09-28	1991-09-28 00:00:00	38000275	0	\N	\N	267892	0	180256009	4107731	
46085	4052	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	269361	0	180256009	4107731	
34406	2980	4107731	1992-11-01	1992-11-01 00:00:00	38000275	0	\N	\N	198888	0	180256009	4107731	
46483	4078	4107731	1993-02-08	1993-02-08 00:00:00	38000275	0	\N	\N	271077	0	180256009	4107731	
58615	5077	4151422	1998-12-12	1998-12-12 00:00:00	38000275	0	\N	\N	337444	0	269911007	4151422	
46870	4109	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	273207	0	180256009	4107731	
59093	5117	4058899	1988-03-16	1988-03-16 00:00:00	38000275	0	\N	\N	340144	0	168594001	4058899	
59441	5143	4043071	1973-02-28	1973-02-28 00:00:00	38000275	0	\N	\N	341841	0	228557008	4043071	
59497	5150	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	342462	0	180256009	4107731	
47844	4200	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	278767	0	180256009	4107731	
24111	2100	4047491	2012-08-28	2012-08-28 00:00:00	38000275	0	\N	\N	139973	0	1225002	4047491	
48063	4217	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	279925	0	180256009	4107731	
36312	3181	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	211667	0	180256009	4107731	
48458	4250	4243062	2000-06-24	2000-06-24 00:00:00	38000275	0	\N	\N	282263	0	60027007	4243062	
48624	4274	4170947	1943-01-30	1943-01-30 00:00:00	38000275	0	\N	\N	283559	0	274474001	4170947	
36925	3249	4151422	1962-09-17	1962-09-17 00:00:00	38000275	0	\N	\N	215960	0	269911007	4151422	
49005	4305	4125906	1973-09-29	1973-09-29 00:00:00	38000275	0	\N	\N	285658	0	288086009	4125906	
37348	3285	4057420	2011-03-12	2011-03-12 00:00:00	38000275	0	\N	\N	218180	0	18286008	4057420	
37532	3311	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	219828	0	180256009	4107731	
61533	5322	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	354235	0	180256009	4107731	
37839	3343	4107731	1991-07-07	1991-07-07 00:00:00	38000275	0	\N	\N	221849	0	180256009	4107731	
50036	4370	4293740	1966-10-06	1966-10-06 00:00:00	38000275	0	\N	\N	290119	0	384700001	4293740	
38260	3371	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	223568	0	395142003	4191853	
50383	4382	4293740	1964-10-27	1964-10-27 00:00:00	38000275	0	\N	\N	291167	0	384700001	4293740	
50534	4390	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	291821	0	180256009	4107731	
38802	3417	4125906	1937-04-20	1937-04-20 00:00:00	38000275	0	\N	\N	226622	0	288086009	4125906	
39070	3446	4043071	1952-08-19	1952-08-19 00:00:00	38000275	0	\N	\N	228798	0	228557008	4043071	
51360	4451	44783196	1997-03-03	1997-03-03 00:00:00	38000275	0	\N	\N	296176	0	699253003	44783196	
27649	2419	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	160558	0	180256009	4107731	
39795	3505	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	232370	0	180256009	4107731	
39916	3510	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	232826	0	180256009	4107731	
51989	4505	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	299969	0	180256009	4107731	
52208	4529	4151422	1965-04-12	1965-04-12 00:00:00	38000275	0	\N	\N	301546	0	269911007	4151422	
40479	3556	4293740	2000-01-23	2000-01-23 00:00:00	38000275	0	\N	\N	236129	0	384700001	4293740	
40765	3573	4125906	2010-11-27	2010-11-27 00:00:00	38000275	0	\N	\N	237631	0	288086009	4125906	
40915	3589	4107731	1996-01-08	1996-01-08 00:00:00	38000275	0	\N	\N	238468	0	180256009	4107731	
29109	2577	4107731	1991-09-07	1991-09-07 00:00:00	38000275	0	\N	\N	170673	0	180256009	4107731	
41231	3622	4078793	2017-04-19	2017-04-19 00:00:00	38000275	0	\N	\N	240724	0	180325003	4078793	
41486	3641	4170947	1915-08-18	1915-08-18 00:00:00	38000275	0	\N	\N	242309	0	274474001	4170947	
53592	4646	4078793	2016-05-31	2016-05-31 00:00:00	38000275	0	\N	\N	309843	0	180325003	4078793	
53724	4655	4107731	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	310364	0	180256009	4107731	
42024	3703	4170947	1982-01-24	1982-01-24 00:00:00	38000275	0	\N	\N	246255	0	274474001	4170947	
42194	3720	4047491	1968-09-10	1968-09-10 00:00:00	38000275	0	\N	\N	247308	0	1225002	4047491	
54337	4720	4037675	2007-06-08	2007-06-08 00:00:00	38000275	0	\N	\N	314409	0	162676008	4037675	
42487	3745	4145310	2018-05-16	2018-05-16 00:00:00	38000275	0	\N	\N	248880	0	268425006	4145310	
42787	3772	4107731	1990-11-17	1990-11-17 00:00:00	38000275	0	\N	\N	250682	0	180256009	4107731	
54827	4754	4151422	1994-08-07	1994-08-07 00:00:00	38000275	0	\N	\N	316643	0	269911007	4151422	
55076	4795	4010253	2008-07-22	2008-07-22 00:00:00	38000275	0	\N	\N	319001	0	112790001	4010253	
31379	2776	4107731	2005-09-06	2005-09-06 00:00:00	38000275	0	\N	\N	183777	0	180256009	4107731	
43443	3844	4047491	1970-03-26	1970-03-26 00:00:00	38000275	0	\N	\N	255129	0	1225002	4047491	
55591	4844	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	322207	0	180256009	4107731	
55804	4867	4202451	2009-08-26	2009-08-26 00:00:00	38000275	0	\N	\N	323695	0	433112001	4202451	
55941	4878	4198190	2011-12-25	2011-12-25 00:00:00	38000275	0	\N	\N	324461	0	80146002	4198190	
32263	2832	4107731	1995-09-23	1995-09-23 00:00:00	38000275	0	\N	\N	187876	0	180256009	4107731	
56778	4935	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	328063	0	180256009	4107731	
45010	3956	4058899	1924-06-18	1924-06-18 00:00:00	38000275	0	\N	\N	262903	0	168594001	4058899	
33220	2903	4198190	1975-09-13	1975-09-13 00:00:00	38000275	0	\N	\N	193482	0	80146002	4198190	
45298	3997	4326177	2018-11-08	2018-11-08 00:00:00	38000275	0	\N	\N	265735	0	430193006	4326177	
45736	4027	4107731	1991-04-13	1991-04-13 00:00:00	38000275	0	\N	\N	267901	0	180256009	4107731	
46086	4052	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	269326	0	180256009	4107731	
34407	2980	4107731	1991-05-26	1991-05-26 00:00:00	38000275	0	\N	\N	198931	0	180256009	4107731	
46484	4078	4191853	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	271070	0	395142003	4191853	
58616	5077	4181917	2017-03-04	2017-03-04 00:00:00	38000275	0	\N	\N	337490	0	54550000	4181917	
46907	4113	4163872	1958-07-08	1958-07-08 00:00:00	38000275	0	\N	\N	273454	0	399208008	4163872	
59094	5118	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	340249	0	180256009	4107731	
59442	5143	4043071	1973-01-31	1973-01-31 00:00:00	38000275	0	\N	\N	341792	0	228557008	4043071	
59498	5150	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	342359	0	180256009	4107731	
47845	4200	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	278744	0	180256009	4107731	
24112	2100	4170947	2012-08-28	2012-08-28 00:00:00	38000275	0	\N	\N	139973	0	274474001	4170947	
48064	4217	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	279942	0	180256009	4107731	
36313	3181	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	211666	0	395142003	4191853	
48459	4250	4170947	2000-06-24	2000-06-24 00:00:00	38000275	0	\N	\N	282263	0	274474001	4170947	
48625	4274	4125906	1997-11-12	1997-11-12 00:00:00	38000275	0	\N	\N	283561	0	288086009	4125906	
36926	3250	4151422	1964-05-03	1964-05-03 00:00:00	38000275	0	\N	\N	216038	0	269911007	4151422	
49006	4305	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	285603	0	180256009	4107731	
37349	3285	4125906	1980-06-04	1980-06-04 00:00:00	38000275	0	\N	\N	218179	0	288086009	4125906	
37533	3311	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	219791	0	180256009	4107731	
61534	5322	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	354184	0	395142003	4191853	
37840	3343	4043071	1985-12-24	1985-12-24 00:00:00	38000275	0	\N	\N	221753	0	228557008	4043071	
50037	4370	4125906	1966-10-06	1966-10-06 00:00:00	38000275	0	\N	\N	290119	0	288086009	4125906	
38261	3371	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	223553	0	180256009	4107731	
50384	4382	4125906	1964-10-27	1964-10-27 00:00:00	38000275	0	\N	\N	291167	0	288086009	4125906	
50535	4390	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	291897	0	180256009	4107731	
38803	3417	4151422	2004-02-25	2004-02-25 00:00:00	38000275	0	\N	\N	226619	0	269911007	4151422	
39071	3446	4043071	1953-02-03	1953-02-03 00:00:00	38000275	0	\N	\N	228833	0	228557008	4043071	
51361	4451	4151422	1974-12-27	1974-12-27 00:00:00	38000275	0	\N	\N	296098	0	269911007	4151422	
27650	2419	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	160592	0	180256009	4107731	
39796	3505	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	232530	0	180256009	4107731	
39917	3510	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	232836	0	180256009	4107731	
51990	4505	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	300060	0	180256009	4107731	
52209	4529	4035793	2017-12-10	2017-12-10 00:00:00	38000275	0	\N	\N	301565	0	15081005	4035793	
40480	3558	4163872	1964-02-02	1964-02-02 00:00:00	38000275	0	\N	\N	236218	0	399208008	4163872	
52548	4551	4243062	2001-04-20	2001-04-20 00:00:00	38000275	0	\N	\N	303327	0	60027007	4243062	
40916	3589	4191853	1981-08-09	1981-08-09 00:00:00	38000275	0	\N	\N	238475	0	395142003	4191853	
29110	2577	4107731	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	170639	0	180256009	4107731	
41232	3622	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	240798	0	180256009	4107731	
41487	3641	4243062	1915-08-18	1915-08-18 00:00:00	38000275	0	\N	\N	242309	0	60027007	4243062	
53593	4646	4057420	2001-10-02	2001-10-02 00:00:00	38000275	0	\N	\N	\N	0	18286008	4057420	
53725	4655	4107731	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	310317	0	180256009	4107731	
42025	3703	4107731	1991-09-07	1991-09-07 00:00:00	38000275	0	\N	\N	246219	0	180256009	4107731	
42195	3720	4170947	1968-09-10	1968-09-10 00:00:00	38000275	0	\N	\N	247308	0	274474001	4170947	
54338	4720	4187458	2007-06-08	2007-06-08 00:00:00	38000275	0	\N	\N	314409	0	415300000	4187458	
42488	3745	4252419	1997-02-23	1997-02-23 00:00:00	38000275	0	\N	\N	248878	0	74016001	4252419	
42788	3772	4107731	1991-11-30	1991-11-30 00:00:00	38000275	0	\N	\N	250657	0	180256009	4107731	
54828	4755	4058899	1925-12-02	1925-12-02 00:00:00	38000275	0	\N	\N	316706	0	168594001	4058899	
55086	4799	40492359	2010-05-01	2010-05-01 00:00:00	38000275	0	\N	\N	319291	0	447365002	40492359	
31380	2776	4107731	2007-02-13	2007-02-13 00:00:00	38000275	0	\N	\N	183840	0	180256009	4107731	
43444	3844	4125906	1985-09-03	1985-09-03 00:00:00	38000275	0	\N	\N	255130	0	288086009	4125906	
55592	4844	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	322211	0	180256009	4107731	
55805	4867	4195803	1995-04-01	1995-04-01 00:00:00	38000275	0	\N	\N	323687	0	312681000	4195803	
55942	4878	4062501	1965-01-11	1965-01-11 00:00:00	38000275	0	\N	\N	324409	0	171231001	4062501	
32264	2832	4107731	1995-07-22	1995-07-22 00:00:00	38000275	0	\N	\N	188009	0	180256009	4107731	
56779	4935	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	328068	0	180256009	4107731	
45011	3956	4037675	1996-10-18	1996-10-18 00:00:00	38000275	0	\N	\N	262965	0	162676008	4037675	
33221	2905	4151422	2012-12-03	2012-12-03 00:00:00	38000275	0	\N	\N	193601	0	269911007	4151422	
45299	3997	4037675	2018-11-08	2018-11-08 00:00:00	38000275	0	\N	\N	265735	0	162676008	4037675	
45737	4027	4107731	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	267782	0	180256009	4107731	
46087	4052	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	269415	0	180256009	4107731	
34408	2980	4107731	1992-02-02	1992-02-02 00:00:00	38000275	0	\N	\N	198988	0	180256009	4107731	
46485	4078	4107731	1990-10-01	1990-10-01 00:00:00	38000275	0	\N	\N	271033	0	180256009	4107731	
58617	5077	4293740	1973-10-31	1973-10-31 00:00:00	38000275	0	\N	\N	337488	0	384700001	4293740	
46908	4113	4125906	2008-10-14	2008-10-14 00:00:00	38000275	0	\N	\N	273390	0	288086009	4125906	
59095	5118	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	340247	0	180256009	4107731	
59443	5143	4043071	1973-10-17	1973-10-17 00:00:00	38000275	0	\N	\N	341843	0	228557008	4043071	
59499	5150	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	342406	0	180256009	4107731	
47846	4200	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	278841	0	180256009	4107731	
24113	2100	4010253	1953-04-02	1953-04-02 00:00:00	38000275	0	\N	\N	140032	0	112790001	4010253	
48065	4217	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	280032	0	180256009	4107731	
36314	3181	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	211652	0	180256009	4107731	
48460	4250	4195803	2000-06-24	2000-06-24 00:00:00	38000275	0	\N	\N	282263	0	312681000	4195803	
48626	4275	4252419	1992-05-10	1992-05-10 00:00:00	38000275	0	\N	\N	283715	0	74016001	4252419	
36927	3250	4243062	1973-06-14	1973-06-14 00:00:00	38000275	0	\N	\N	216088	0	60027007	4243062	
49007	4305	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	285562	0	180256009	4107731	
37350	3285	4125906	1970-11-10	1970-11-10 00:00:00	38000275	0	\N	\N	218178	0	288086009	4125906	
37534	3311	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	219760	0	180256009	4107731	
61535	5322	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	354098	0	180256009	4107731	
37841	3343	4107731	1990-11-18	1990-11-18 00:00:00	38000275	0	\N	\N	221830	0	180256009	4107731	
50038	4370	4301346	1991-11-22	1991-11-22 00:00:00	38000275	0	\N	\N	290161	0	387685009	4301346	
38262	3371	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	223591	0	180256009	4107731	
50385	4382	4163872	1968-06-13	1968-06-13 00:00:00	38000275	0	\N	\N	291180	0	399208008	4163872	
50536	4390	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	291886	0	180256009	4107731	
38804	3417	4195803	1980-06-15	1980-06-15 00:00:00	38000275	0	\N	\N	226624	0	312681000	4195803	
39072	3446	4043071	1952-03-18	1952-03-18 00:00:00	38000275	0	\N	\N	228796	0	228557008	4043071	
51362	4451	4043071	1963-05-09	1963-05-09 00:00:00	38000275	0	\N	\N	296144	0	228557008	4043071	
27651	2419	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	160562	0	180256009	4107731	
39797	3505	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	232470	0	180256009	4107731	
39983	3513	4125906	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	233118	0	288086009	4125906	
51991	4505	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	299973	0	180256009	4107731	
52210	4529	4252419	1998-09-28	1998-09-28 00:00:00	38000275	0	\N	\N	301615	0	74016001	4252419	
40481	3558	4125906	2011-03-09	2011-03-09 00:00:00	38000275	0	\N	\N	236217	0	288086009	4125906	
52549	4551	4170947	2001-04-20	2001-04-20 00:00:00	38000275	0	\N	\N	303327	0	274474001	4170947	
40917	3589	4107731	1995-06-13	1995-06-13 00:00:00	38000275	0	\N	\N	238418	0	180256009	4107731	
29111	2577	4107731	1992-04-25	1992-04-25 00:00:00	38000275	0	\N	\N	170676	0	180256009	4107731	
41233	3622	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	240733	0	180256009	4107731	
41488	3641	4293740	1924-08-30	1924-08-30 00:00:00	38000275	0	\N	\N	242310	0	384700001	4293740	
53594	4646	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	309877	0	180256009	4107731	
53726	4655	4107731	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	310362	0	180256009	4107731	
42026	3703	4107731	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	246211	0	180256009	4107731	
42196	3720	4163872	1967-01-07	1967-01-07 00:00:00	38000275	0	\N	\N	247282	0	399208008	4163872	
54339	4720	4293740	1987-04-19	1987-04-19 00:00:00	38000275	0	\N	\N	314370	0	384700001	4293740	
42489	3745	4035793	2017-10-11	2017-10-11 00:00:00	38000275	0	\N	\N	248896	0	15081005	4035793	
42789	3772	4107731	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	250710	0	180256009	4107731	
54829	4755	4125906	1933-01-24	1933-01-24 00:00:00	38000275	0	\N	\N	316707	0	288086009	4125906	
55087	4799	4057420	2010-05-01	2010-05-01 00:00:00	38000275	0	\N	\N	319291	0	18286008	4057420	
31381	2776	4107731	2006-10-31	2006-10-31 00:00:00	38000275	0	\N	\N	183825	0	180256009	4107731	
43455	3849	4326177	2015-11-08	2015-11-08 00:00:00	38000275	0	\N	\N	255395	0	430193006	4326177	
55593	4844	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	322260	0	180256009	4107731	
55806	4867	4163872	1995-04-01	1995-04-01 00:00:00	38000275	0	\N	\N	323687	0	399208008	4163872	
55943	4878	4107731	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	324362	0	180256009	4107731	
32265	2832	4107731	1994-04-16	1994-04-16 00:00:00	38000275	0	\N	\N	187976	0	180256009	4107731	
56780	4935	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	328122	0	180256009	4107731	
45012	3956	4187458	1996-10-18	1996-10-18 00:00:00	38000275	0	\N	\N	262965	0	415300000	4187458	
33222	2905	4151422	1995-08-29	1995-08-29 00:00:00	38000275	0	\N	\N	193598	0	269911007	4151422	
45300	3997	4125906	1967-09-17	1967-09-17 00:00:00	38000275	0	\N	\N	265699	0	288086009	4125906	
45738	4027	4107731	1991-02-09	1991-02-09 00:00:00	38000275	0	\N	\N	267811	0	180256009	4107731	
46088	4052	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	269343	0	395142003	4191853	
46211	4064	4107731	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	270045	0	180256009	4107731	
46486	4078	4107731	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	271086	0	180256009	4107731	
58618	5077	4125906	1973-10-31	1973-10-31 00:00:00	38000275	0	\N	\N	337488	0	288086009	4125906	
46909	4113	4252419	1997-01-17	1997-01-17 00:00:00	38000275	0	\N	\N	273388	0	74016001	4252419	
59096	5118	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	340167	0	180256009	4107731	
59444	5143	4170947	1965-04-07	1965-04-07 00:00:00	38000275	0	\N	\N	341882	0	274474001	4170947	
59500	5150	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	342407	0	180256009	4107731	
47847	4200	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	278829	0	180256009	4107731	
24114	2100	4125906	1959-08-13	1959-08-13 00:00:00	38000275	0	\N	\N	139968	0	288086009	4125906	
48066	4217	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	279976	0	180256009	4107731	
36315	3181	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	211625	0	180256009	4107731	
48461	4250	4163872	1988-08-26	1988-08-26 00:00:00	38000275	0	\N	\N	282288	0	399208008	4163872	
48627	4275	44783196	1992-05-17	1992-05-17 00:00:00	38000275	0	\N	\N	283708	0	699253003	44783196	
36928	3250	4170947	1973-06-14	1973-06-14 00:00:00	38000275	0	\N	\N	216088	0	274474001	4170947	
49008	4305	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	285606	0	180256009	4107731	
37352	3287	40492359	1967-07-10	1967-07-10 00:00:00	38000275	0	\N	\N	218352	0	447365002	40492359	
37535	3311	4293740	1965-01-03	1965-01-03 00:00:00	38000275	0	\N	\N	219795	0	384700001	4293740	
61536	5322	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	354095	0	180256009	4107731	
37842	3343	4107731	1990-02-18	1990-02-18 00:00:00	38000275	0	\N	\N	221827	0	180256009	4107731	
50043	4372	4107731	1995-06-29	1995-06-29 00:00:00	38000275	0	\N	\N	290302	0	180256009	4107731	
38263	3371	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	223528	0	180256009	4107731	
50386	4383	4170947	1975-06-04	1975-06-04 00:00:00	38000275	0	\N	\N	291335	0	274474001	4170947	
50537	4390	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	291889	0	180256009	4107731	
38805	3417	4058899	1980-06-15	1980-06-15 00:00:00	38000275	0	\N	\N	226624	0	168594001	4058899	
39073	3446	4043071	1952-12-30	1952-12-30 00:00:00	38000275	0	\N	\N	228870	0	228557008	4043071	
51363	4451	4043071	1963-12-26	1963-12-26 00:00:00	38000275	0	\N	\N	296146	0	228557008	4043071	
27652	2419	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	160593	0	180256009	4107731	
39798	3505	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	232368	0	180256009	4107731	
39984	3513	4125906	1985-02-09	1985-02-09 00:00:00	38000275	0	\N	\N	233117	0	288086009	4125906	
51992	4505	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	300027	0	180256009	4107731	
52211	4529	4125906	1985-04-25	1985-04-25 00:00:00	38000275	0	\N	\N	301560	0	288086009	4125906	
40482	3559	4170947	1953-06-20	1953-06-20 00:00:00	38000275	0	\N	\N	236257	0	274474001	4170947	
52550	4551	4163872	2016-07-20	2016-07-20 00:00:00	38000275	0	\N	\N	303289	0	399208008	4163872	
40918	3589	4107731	1996-05-14	1996-05-14 00:00:00	38000275	0	\N	\N	238438	0	180256009	4107731	
29112	2577	4107731	1990-04-21	1990-04-21 00:00:00	38000275	0	\N	\N	170607	0	180256009	4107731	
41234	3622	4078793	2001-11-07	2001-11-07 00:00:00	38000275	0	\N	\N	240698	0	180325003	4078793	
41489	3641	4125906	1924-08-30	1924-08-30 00:00:00	38000275	0	\N	\N	242310	0	288086009	4125906	
53595	4646	4078793	2014-05-20	2014-05-20 00:00:00	38000275	0	\N	\N	309818	0	180325003	4078793	
53727	4655	4107731	1993-01-24	1993-01-24 00:00:00	38000275	0	\N	\N	310323	0	180256009	4107731	
42027	3703	4107731	1991-04-13	1991-04-13 00:00:00	38000275	0	\N	\N	246237	0	180256009	4107731	
42197	3720	4125906	2013-01-01	2013-01-01 00:00:00	38000275	0	\N	\N	247321	0	288086009	4125906	
54340	4720	4125906	1987-04-19	1987-04-19 00:00:00	38000275	0	\N	\N	314370	0	288086009	4125906	
42490	3745	4195803	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	248869	0	312681000	4195803	
42790	3772	4107731	1991-09-07	1991-09-07 00:00:00	38000275	0	\N	\N	250655	0	180256009	4107731	
54830	4755	4125906	1945-03-13	1945-03-13 00:00:00	38000275	0	\N	\N	316709	0	288086009	4125906	
55088	4799	4170947	1977-01-10	1977-01-10 00:00:00	38000275	0	\N	\N	319245	0	274474001	4170947	
31382	2776	4107731	2007-12-04	2007-12-04 00:00:00	38000275	0	\N	\N	183831	0	180256009	4107731	
43456	3849	4187458	2015-11-08	2015-11-08 00:00:00	38000275	0	\N	\N	255395	0	415300000	4187458	
55594	4844	4151422	1970-05-30	1970-05-30 00:00:00	38000275	0	\N	\N	322200	0	269911007	4151422	
55807	4867	4170947	1995-04-01	1995-04-01 00:00:00	38000275	0	\N	\N	323687	0	274474001	4170947	
55944	4878	4107731	1990-05-12	1990-05-12 00:00:00	38000275	0	\N	\N	324413	0	180256009	4107731	
32266	2832	4191853	1994-03-05	1994-03-05 00:00:00	38000275	0	\N	\N	187897	0	395142003	4191853	
56781	4935	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	328078	0	180256009	4107731	
45013	3956	4326177	1996-10-18	1996-10-18 00:00:00	38000275	0	\N	\N	262965	0	430193006	4326177	
33223	2906	4195803	2014-07-12	2014-07-12 00:00:00	38000275	0	\N	\N	193623	0	312681000	4195803	
45301	3997	4125906	1997-01-17	1997-01-17 00:00:00	38000275	0	\N	\N	265702	0	288086009	4125906	
45739	4027	4107731	1991-11-30	1991-11-30 00:00:00	38000275	0	\N	\N	267842	0	180256009	4107731	
46089	4052	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	269308	0	180256009	4107731	
46212	4064	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	270029	0	180256009	4107731	
46487	4078	4107731	1991-02-04	1991-02-04 00:00:00	38000275	0	\N	\N	271064	0	180256009	4107731	
58619	5077	4151422	2014-05-18	2014-05-18 00:00:00	38000275	0	\N	\N	337447	0	269911007	4151422	
46910	4113	4058899	1969-03-31	1969-03-31 00:00:00	38000275	0	\N	\N	273386	0	168594001	4058899	
59097	5118	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	340173	0	180256009	4107731	
59445	5143	4024289	1965-04-07	1965-04-07 00:00:00	38000275	0	\N	\N	341882	0	19490002	4024289	
59501	5150	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	342340	0	180256009	4107731	
47848	4200	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	278759	0	180256009	4107731	
24115	2100	44783196	1976-06-10	1976-06-10 00:00:00	38000275	0	\N	\N	139975	0	699253003	44783196	
48067	4217	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	279994	0	180256009	4107731	
36316	3181	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	211737	0	180256009	4107731	
48462	4250	4195803	2015-04-07	2015-04-07 00:00:00	38000275	0	\N	\N	282264	0	312681000	4195803	
48628	4276	4198190	2006-12-14	2006-12-14 00:00:00	38000275	0	\N	\N	283770	0	80146002	4198190	
36995	3253	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	216255	0	180256009	4107731	
49009	4305	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	285640	0	180256009	4107731	
37353	3287	4057420	1967-07-10	1967-07-10 00:00:00	38000275	0	\N	\N	218352	0	18286008	4057420	
37536	3311	4125906	1965-01-03	1965-01-03 00:00:00	38000275	0	\N	\N	219795	0	288086009	4125906	
61537	5322	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	354197	0	180256009	4107731	
37843	3343	4107731	1991-02-10	1991-02-10 00:00:00	38000275	0	\N	\N	221867	0	180256009	4107731	
50044	4372	4107731	1995-10-12	1995-10-12 00:00:00	38000275	0	\N	\N	290258	0	180256009	4107731	
38264	3371	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	223590	0	180256009	4107731	
50387	4383	4243062	1975-06-04	1975-06-04 00:00:00	38000275	0	\N	\N	291335	0	60027007	4243062	
50538	4390	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	291805	0	180256009	4107731	
38806	3417	4151422	1989-03-28	1989-03-28 00:00:00	38000275	0	\N	\N	226654	0	269911007	4151422	
39074	3446	4293740	1982-10-20	1982-10-20 00:00:00	38000275	0	\N	\N	228783	0	384700001	4293740	
51364	4451	4043071	1962-09-27	1962-09-27 00:00:00	38000275	0	\N	\N	296161	0	228557008	4043071	
27653	2419	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	160488	0	180256009	4107731	
39799	3505	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	232446	0	180256009	4107731	
39985	3513	4170947	1979-08-10	1979-08-10 00:00:00	38000275	0	\N	\N	233116	0	274474001	4170947	
51993	4505	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	299985	0	180256009	4107731	
52212	4529	4035793	2018-12-16	2018-12-16 00:00:00	38000275	0	\N	\N	301581	0	15081005	4035793	
40483	3559	4047491	1953-06-20	1953-06-20 00:00:00	38000275	0	\N	\N	236257	0	1225002	4047491	
52562	4557	4170947	1969-11-12	1969-11-12 00:00:00	38000275	0	\N	\N	303641	0	274474001	4170947	
40919	3589	4197460	1998-03-30	1998-03-30 00:00:00	38000275	0	\N	\N	238448	0	313191000	4197460	
29113	2577	4107731	1991-07-06	1991-07-06 00:00:00	38000275	0	\N	\N	170656	0	180256009	4107731	
41235	3622	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	240751	0	180256009	4107731	
41499	3644	4125906	1979-09-22	1979-09-22 00:00:00	38000275	0	\N	\N	242491	0	288086009	4125906	
53596	4646	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	309824	0	180256009	4107731	
53728	4655	4107731	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	310324	0	180256009	4107731	
42028	3703	4107731	1991-06-15	1991-06-15 00:00:00	38000275	0	\N	\N	246217	0	180256009	4107731	
42198	3720	4293740	2013-01-01	2013-01-01 00:00:00	38000275	0	\N	\N	247321	0	384700001	4293740	
54341	4720	4163872	1982-02-14	1982-02-14 00:00:00	38000275	0	\N	\N	314369	0	399208008	4163872	
42491	3746	4170947	2012-11-02	2012-11-02 00:00:00	38000275	0	\N	\N	249066	0	274474001	4170947	
42791	3772	4107731	1991-07-06	1991-07-06 00:00:00	38000275	0	\N	\N	250733	0	180256009	4107731	
54831	4755	4198190	1933-11-06	1933-11-06 00:00:00	38000275	0	\N	\N	316779	0	80146002	4198190	
55089	4799	4243062	1977-01-10	1977-01-10 00:00:00	38000275	0	\N	\N	319245	0	60027007	4243062	
31383	2776	4107731	2005-08-16	2005-08-16 00:00:00	38000275	0	\N	\N	183862	0	180256009	4107731	
43457	3849	4037675	2015-11-08	2015-11-08 00:00:00	38000275	0	\N	\N	255395	0	162676008	4037675	
55595	4844	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	322203	0	180256009	4107731	
55808	4867	4151422	1918-03-20	1918-03-20 00:00:00	38000275	0	\N	\N	323640	0	269911007	4151422	
55945	4878	4107731	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	324351	0	180256009	4107731	
32267	2832	4107731	1994-07-09	1994-07-09 00:00:00	38000275	0	\N	\N	187978	0	180256009	4107731	
56782	4935	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	328028	0	180256009	4107731	
45014	3956	4198190	1952-10-30	1952-10-30 00:00:00	38000275	0	\N	\N	262942	0	80146002	4198190	
33224	2906	4047491	1934-08-25	1934-08-25 00:00:00	38000275	0	\N	\N	193718	0	1225002	4047491	
45302	3998	4330583	1985-06-09	1985-06-09 00:00:00	38000275	0	\N	\N	265808	0	22523008	4330583	
45740	4027	4107731	1992-04-25	1992-04-25 00:00:00	38000275	0	\N	\N	267820	0	180256009	4107731	
46090	4052	4125906	1986-12-19	1986-12-19 00:00:00	38000275	0	\N	\N	269342	0	288086009	4125906	
46213	4064	4107731	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	270079	0	180256009	4107731	
46488	4078	4107731	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	271063	0	180256009	4107731	
58620	5077	4151422	1971-02-16	1971-02-16 00:00:00	38000275	0	\N	\N	337448	0	269911007	4151422	
46911	4113	44783196	1997-01-24	1997-01-24 00:00:00	38000275	0	\N	\N	273393	0	699253003	44783196	
59098	5118	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	340192	0	180256009	4107731	
59446	5143	4151422	2006-01-01	2006-01-01 00:00:00	38000275	0	\N	\N	341818	0	269911007	4151422	
59502	5150	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	342357	0	180256009	4107731	
47849	4200	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	278835	0	180256009	4107731	
24116	2100	4187458	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	139958	0	415300000	4187458	
48068	4217	4293740	1965-10-05	1965-10-05 00:00:00	38000275	0	\N	\N	279908	0	384700001	4293740	
36317	3181	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	211753	0	180256009	4107731	
48463	4250	4024289	2015-04-07	2015-04-07 00:00:00	38000275	0	\N	\N	282264	0	19490002	4024289	
48629	4276	4145310	1977-07-17	1977-07-17 00:00:00	38000275	0	\N	\N	283771	0	268425006	4145310	
36996	3253	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	216276	0	180256009	4107731	
49010	4305	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	285556	0	180256009	4107731	
37354	3287	4125906	1966-12-10	1966-12-10 00:00:00	38000275	0	\N	\N	218351	0	288086009	4125906	
37537	3311	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	219850	0	180256009	4107731	
61538	5322	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	354194	0	180256009	4107731	
37844	3343	4107731	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	221855	0	180256009	4107731	
50045	4372	4107731	1996-08-01	1996-08-01 00:00:00	38000275	0	\N	\N	290308	0	180256009	4107731	
38265	3371	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	223588	0	180256009	4107731	
50388	4383	4125906	1970-09-07	1970-09-07 00:00:00	38000275	0	\N	\N	291334	0	288086009	4125906	
50539	4390	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	291880	0	180256009	4107731	
38807	3417	4145310	2018-03-28	2018-03-28 00:00:00	38000275	0	\N	\N	226627	0	268425006	4145310	
39075	3446	4125906	1982-10-20	1982-10-20 00:00:00	38000275	0	\N	\N	228783	0	288086009	4125906	
51365	4451	4043071	1964-01-30	1964-01-30 00:00:00	38000275	0	\N	\N	296147	0	228557008	4043071	
27654	2419	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	160493	0	180256009	4107731	
39800	3505	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	232503	0	180256009	4107731	
39986	3513	4163872	1979-08-10	1979-08-10 00:00:00	38000275	0	\N	\N	233116	0	399208008	4163872	
51994	4505	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	300068	0	180256009	4107731	
52213	4529	4238715	1988-05-22	1988-05-22 00:00:00	38000275	0	\N	\N	301570	0	68254000	4238715	
40484	3559	4151422	1983-04-29	1983-04-29 00:00:00	38000275	0	\N	\N	236276	0	269911007	4151422	
52563	4557	4024289	1969-11-12	1969-11-12 00:00:00	38000275	0	\N	\N	303641	0	19490002	4024289	
40920	3589	4107731	1996-08-27	1996-08-27 00:00:00	38000275	0	\N	\N	238470	0	180256009	4107731	
29114	2577	4107731	1990-12-08	1990-12-08 00:00:00	38000275	0	\N	\N	170655	0	180256009	4107731	
41236	3622	4024289	2008-11-18	2008-11-18 00:00:00	38000275	0	\N	\N	240712	0	19490002	4024289	
41500	3644	4151422	1959-11-11	1959-11-11 00:00:00	38000275	0	\N	\N	242504	0	269911007	4151422	
53597	4646	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	309832	0	180256009	4107731	
53729	4655	4107731	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	310331	0	180256009	4107731	
42029	3703	4107731	1990-10-27	1990-10-27 00:00:00	38000275	0	\N	\N	246263	0	180256009	4107731	
42199	3720	4163872	1979-01-16	1979-01-16 00:00:00	38000275	0	\N	\N	247309	0	399208008	4163872	
54342	4720	4170947	1982-02-14	1982-02-14 00:00:00	38000275	0	\N	\N	314369	0	274474001	4170947	
42492	3746	4195803	2012-11-02	2012-11-02 00:00:00	38000275	0	\N	\N	249066	0	312681000	4195803	
42792	3772	4107731	1990-08-04	1990-08-04 00:00:00	38000275	0	\N	\N	250667	0	180256009	4107731	
54832	4755	4243062	2014-05-24	2014-05-24 00:00:00	38000275	0	\N	\N	316711	0	60027007	4243062	
55090	4799	4151422	2010-01-16	2010-01-16 00:00:00	38000275	0	\N	\N	319218	0	269911007	4151422	
31384	2776	4107731	2006-11-21	2006-11-21 00:00:00	38000275	0	\N	\N	183876	0	180256009	4107731	
43458	3849	4238715	1984-08-02	1984-08-02 00:00:00	38000275	0	\N	\N	255402	0	68254000	4238715	
55596	4844	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	322236	0	180256009	4107731	
55876	4872	4125906	2018-11-07	2018-11-07 00:00:00	38000275	0	\N	\N	324094	0	288086009	4125906	
55946	4878	4107731	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	324451	0	180256009	4107731	
32268	2832	4191853	1997-09-06	1997-09-06 00:00:00	38000275	0	\N	\N	187932	0	395142003	4191853	
56783	4935	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	328121	0	180256009	4107731	
45015	3956	4125906	1983-05-20	1983-05-20 00:00:00	38000275	0	\N	\N	262907	0	288086009	4125906	
33225	2906	4170947	1934-08-25	1934-08-25 00:00:00	38000275	0	\N	\N	193718	0	274474001	4170947	
45303	3998	4057420	1982-08-26	1982-08-26 00:00:00	38000275	0	\N	\N	265792	0	18286008	4057420	
45741	4027	4107731	1992-11-21	1992-11-21 00:00:00	38000275	0	\N	\N	267786	0	180256009	4107731	
46091	4052	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	269336	0	395142003	4191853	
46214	4064	4107731	1992-10-26	1992-10-26 00:00:00	38000275	0	\N	\N	270113	0	180256009	4107731	
46489	4078	4107731	1992-02-17	1992-02-17 00:00:00	38000275	0	\N	\N	270961	0	180256009	4107731	
58621	5078	4293740	1942-02-17	1942-02-17 00:00:00	38000275	0	\N	\N	337522	0	384700001	4293740	
46912	4113	4125906	2005-11-08	2005-11-08 00:00:00	38000275	0	\N	\N	273389	0	288086009	4125906	
59099	5118	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	340204	0	180256009	4107731	
59447	5143	4151422	1982-03-01	1982-03-01 00:00:00	38000275	0	\N	\N	341795	0	269911007	4151422	
59503	5150	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	342350	0	180256009	4107731	
47850	4200	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	278742	0	180256009	4107731	
24117	2100	4037675	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	139958	0	162676008	4037675	
48069	4217	4125906	1965-10-05	1965-10-05 00:00:00	38000275	0	\N	\N	279908	0	288086009	4125906	
36318	3181	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	211738	0	180256009	4107731	
48464	4250	4170947	2015-04-07	2015-04-07 00:00:00	38000275	0	\N	\N	282264	0	274474001	4170947	
48630	4276	4170947	2005-05-21	2005-05-21 00:00:00	38000275	0	\N	\N	283772	0	274474001	4170947	
36997	3253	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	216364	0	180256009	4107731	
49011	4305	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	285617	0	180256009	4107731	
37355	3287	4301346	1988-11-12	1988-11-12 00:00:00	38000275	0	\N	\N	218312	0	387685009	4301346	
37538	3311	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	219809	0	180256009	4107731	
61539	5322	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	354240	0	180256009	4107731	
37845	3343	4107731	1990-10-07	1990-10-07 00:00:00	38000275	0	\N	\N	221829	0	180256009	4107731	
50046	4372	4107731	1996-10-03	1996-10-03 00:00:00	38000275	0	\N	\N	290276	0	180256009	4107731	
38266	3371	4295880	2006-02-17	2006-02-17 00:00:00	38000275	0	\N	\N	223562	0	76601001	4295880	
50389	4383	4293740	1970-09-07	1970-09-07 00:00:00	38000275	0	\N	\N	291334	0	384700001	4293740	
50540	4390	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	291797	0	180256009	4107731	
38808	3417	4170947	2014-06-17	2014-06-17 00:00:00	38000275	0	\N	\N	226626	0	274474001	4170947	
39076	3446	4043071	1952-02-12	1952-02-12 00:00:00	38000275	0	\N	\N	228831	0	228557008	4043071	
51366	4451	4043071	1963-11-28	1963-11-28 00:00:00	38000275	0	\N	\N	296143	0	228557008	4043071	
27655	2419	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	160606	0	180256009	4107731	
39801	3505	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	232369	0	180256009	4107731	
39987	3513	4125906	2016-07-08	2016-07-08 00:00:00	38000275	0	\N	\N	233120	0	288086009	4125906	
51995	4505	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	300111	0	180256009	4107731	
52214	4530	4024289	1980-07-19	1980-07-19 00:00:00	38000275	0	\N	\N	301619	0	19490002	4024289	
40485	3559	4170947	1995-09-18	1995-09-18 00:00:00	38000275	0	\N	\N	236261	0	274474001	4170947	
52564	4557	4125906	1924-05-27	1924-05-27 00:00:00	38000275	0	\N	\N	303637	0	288086009	4125906	
40921	3589	4107731	1997-05-27	1997-05-27 00:00:00	38000275	0	\N	\N	238427	0	180256009	4107731	
29115	2577	4125906	2013-02-02	2013-02-02 00:00:00	38000275	0	\N	\N	170636	0	288086009	4125906	
41237	3622	4170947	2008-11-18	2008-11-18 00:00:00	38000275	0	\N	\N	240712	0	274474001	4170947	
41501	3644	40492359	1982-02-24	1982-02-24 00:00:00	38000275	0	\N	\N	242492	0	447365002	40492359	
53598	4646	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	309807	0	180256009	4107731	
53730	4655	4107731	1992-06-07	1992-06-07 00:00:00	38000275	0	\N	\N	310361	0	180256009	4107731	
42030	3703	4107731	1992-04-25	1992-04-25 00:00:00	38000275	0	\N	\N	246221	0	180256009	4107731	
42200	3720	4170947	1979-01-16	1979-01-16 00:00:00	38000275	0	\N	\N	247309	0	274474001	4170947	
54343	4720	4238715	1996-06-25	1996-06-25 00:00:00	38000275	0	\N	\N	314377	0	68254000	4238715	
42493	3746	4047491	2012-11-02	2012-11-02 00:00:00	38000275	0	\N	\N	249066	0	1225002	4047491	
42793	3772	4107731	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	250738	0	180256009	4107731	
54833	4755	4195803	2014-05-24	2014-05-24 00:00:00	38000275	0	\N	\N	316711	0	312681000	4195803	
55091	4799	4125906	1969-04-17	1969-04-17 00:00:00	38000275	0	\N	\N	319242	0	288086009	4125906	
31385	2776	4107731	2008-10-14	2008-10-14 00:00:00	38000275	0	\N	\N	183809	0	180256009	4107731	
43459	3849	4275113	1977-11-21	1977-11-21 00:00:00	38000275	0	\N	\N	255408	0	65200003	4275113	
55597	4844	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	322231	0	180256009	4107731	
55877	4872	4163872	1952-08-14	1952-08-14 00:00:00	38000275	0	\N	\N	324008	0	399208008	4163872	
55947	4878	4107731	1993-05-08	1993-05-08 00:00:00	38000275	0	\N	\N	324392	0	180256009	4107731	
32269	2832	4107731	1995-03-18	1995-03-18 00:00:00	38000275	0	\N	\N	187951	0	180256009	4107731	
56784	4935	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	328092	0	180256009	4107731	
45016	3956	4195803	2013-02-25	2013-02-25 00:00:00	38000275	0	\N	\N	262908	0	312681000	4195803	
33226	2906	4125906	1940-05-09	1940-05-09 00:00:00	38000275	0	\N	\N	193720	0	288086009	4125906	
45304	3998	40492359	1982-08-26	1982-08-26 00:00:00	38000275	0	\N	\N	265792	0	447365002	40492359	
45742	4027	4057420	2014-06-21	2014-06-21 00:00:00	38000275	0	\N	\N	267885	0	18286008	4057420	
46092	4052	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	269306	0	180256009	4107731	
46215	4064	4107731	1991-04-08	1991-04-08 00:00:00	38000275	0	\N	\N	269992	0	180256009	4107731	
46490	4078	4107731	1992-01-06	1992-01-06 00:00:00	38000275	0	\N	\N	270960	0	180256009	4107731	
58622	5078	4125906	1942-02-17	1942-02-17 00:00:00	38000275	0	\N	\N	337522	0	288086009	4125906	
58719	5097	4107731	1993-05-09	1993-05-09 00:00:00	38000275	0	\N	\N	338673	0	180256009	4107731	
59100	5118	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	340274	0	180256009	4107731	
59448	5143	4043071	1973-12-26	1973-12-26 00:00:00	38000275	0	\N	\N	341830	0	228557008	4043071	
59504	5150	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	342346	0	180256009	4107731	
47851	4200	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	278838	0	180256009	4107731	
24118	2100	4326177	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	139958	0	430193006	4326177	
48070	4217	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	279921	0	180256009	4107731	
36319	3181	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	211740	0	180256009	4107731	
48465	4250	4170947	2016-05-31	2016-05-31 00:00:00	38000275	0	\N	\N	282265	0	274474001	4170947	
48631	4276	4163872	2005-05-21	2005-05-21 00:00:00	38000275	0	\N	\N	283772	0	399208008	4163872	
36998	3253	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	216387	0	180256009	4107731	
49012	4305	4151422	1999-10-14	1999-10-14 00:00:00	38000275	0	\N	\N	285531	0	269911007	4151422	
37360	3289	4043071	1966-06-27	1966-06-27 00:00:00	38000275	0	\N	\N	218533	0	228557008	4043071	
37539	3311	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	219761	0	180256009	4107731	
61540	5322	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	354151	0	180256009	4107731	
37846	3343	4043071	1985-11-26	1985-11-26 00:00:00	38000275	0	\N	\N	221845	0	228557008	4043071	
50047	4372	4191853	1993-05-13	1993-05-13 00:00:00	38000275	0	\N	\N	290262	0	395142003	4191853	
38267	3371	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	223622	0	180256009	4107731	
50390	4383	4151422	2000-03-12	2000-03-12 00:00:00	38000275	0	\N	\N	291326	0	269911007	4151422	
50541	4390	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	291813	0	180256009	4107731	
38809	3417	4163872	2014-06-17	2014-06-17 00:00:00	38000275	0	\N	\N	226626	0	399208008	4163872	
39077	3446	4170947	1950-08-08	1950-08-08 00:00:00	38000275	0	\N	\N	228827	0	274474001	4170947	
51367	4451	4043071	1963-04-11	1963-04-11 00:00:00	38000275	0	\N	\N	296164	0	228557008	4043071	
27656	2419	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	160520	0	180256009	4107731	
39802	3505	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	232519	0	180256009	4107731	
39988	3514	4199276	2000-04-24	2000-04-24 00:00:00	38000275	0	\N	\N	233217	0	301807007	4199276	
51996	4505	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	299982	0	180256009	4107731	
52215	4530	4170947	1980-07-19	1980-07-19 00:00:00	38000275	0	\N	\N	301619	0	274474001	4170947	
40486	3559	4047491	1995-09-18	1995-09-18 00:00:00	38000275	0	\N	\N	236261	0	1225002	4047491	
52565	4557	4058899	2001-11-15	2001-11-15 00:00:00	38000275	0	\N	\N	303644	0	168594001	4058899	
40922	3589	4107731	1996-01-29	1996-01-29 00:00:00	38000275	0	\N	\N	238492	0	180256009	4107731	
29116	2577	4107731	1991-01-19	1991-01-19 00:00:00	38000275	0	\N	\N	170615	0	180256009	4107731	
41238	3622	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	240825	0	180256009	4107731	
41502	3644	4057420	1982-02-24	1982-02-24 00:00:00	38000275	0	\N	\N	242492	0	18286008	4057420	
53599	4646	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	309752	0	180256009	4107731	
53731	4655	4107731	1991-07-07	1991-07-07 00:00:00	38000275	0	\N	\N	310325	0	180256009	4107731	
42031	3703	4107731	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	246223	0	180256009	4107731	
42201	3721	4163872	1968-11-28	1968-11-28 00:00:00	38000275	0	\N	\N	247350	0	399208008	4163872	
54361	4722	4047491	2015-09-29	2015-09-29 00:00:00	38000275	0	\N	\N	314617	0	1225002	4047491	
42494	3746	4195803	2014-06-12	2014-06-12 00:00:00	38000275	0	\N	\N	249073	0	312681000	4195803	
42794	3772	4107731	1991-12-21	1991-12-21 00:00:00	38000275	0	\N	\N	250704	0	180256009	4107731	
54834	4755	4170947	2014-05-24	2014-05-24 00:00:00	38000275	0	\N	\N	316711	0	274474001	4170947	
55092	4799	4293740	1969-04-17	1969-04-17 00:00:00	38000275	0	\N	\N	319242	0	384700001	4293740	
31386	2776	4107731	2009-01-06	2009-01-06 00:00:00	38000275	0	\N	\N	183811	0	180256009	4107731	
43460	3849	4186930	1982-11-18	1982-11-18 00:00:00	38000275	0	\N	\N	255382	0	46706006	4186930	
55598	4844	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	322241	0	180256009	4107731	
55878	4872	4151422	2007-09-22	2007-09-22 00:00:00	38000275	0	\N	\N	324057	0	269911007	4151422	
55948	4878	4107731	1990-03-10	1990-03-10 00:00:00	38000275	0	\N	\N	324377	0	180256009	4107731	
32270	2832	4107731	1994-06-18	1994-06-18 00:00:00	38000275	0	\N	\N	187948	0	180256009	4107731	
56785	4935	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	328038	0	180256009	4107731	
45017	3956	4058899	2013-02-25	2013-02-25 00:00:00	38000275	0	\N	\N	262908	0	168594001	4058899	
33227	2906	4301346	1929-01-23	1929-01-23 00:00:00	38000275	0	\N	\N	193667	0	387685009	4301346	
45305	3998	4243062	1970-09-09	1970-09-09 00:00:00	38000275	0	\N	\N	265849	0	60027007	4243062	
45743	4027	40492359	2014-06-21	2014-06-21 00:00:00	38000275	0	\N	\N	267885	0	447365002	40492359	
46093	4052	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	269354	0	180256009	4107731	
46216	4064	4107731	1991-03-18	1991-03-18 00:00:00	38000275	0	\N	\N	270002	0	180256009	4107731	
46491	4078	4107731	1992-01-27	1992-01-27 00:00:00	38000275	0	\N	\N	270991	0	180256009	4107731	
58623	5078	4252419	1997-09-02	1997-09-02 00:00:00	38000275	0	\N	\N	337629	0	74016001	4252419	
58720	5097	4107731	1993-10-24	1993-10-24 00:00:00	38000275	0	\N	\N	338721	0	180256009	4107731	
59101	5118	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	340253	0	180256009	4107731	
59449	5143	4043071	1973-06-20	1973-06-20 00:00:00	38000275	0	\N	\N	341864	0	228557008	4043071	
59505	5150	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	342427	0	180256009	4107731	
47852	4200	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	278805	0	180256009	4107731	
24119	2100	4252419	1976-06-03	1976-06-03 00:00:00	38000275	0	\N	\N	139971	0	74016001	4252419	
48071	4217	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	279996	0	180256009	4107731	
36320	3181	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	211763	0	180256009	4107731	
48466	4250	4195803	2016-05-31	2016-05-31 00:00:00	38000275	0	\N	\N	282265	0	312681000	4195803	
48632	4276	4195803	2005-05-21	2005-05-21 00:00:00	38000275	0	\N	\N	283772	0	312681000	4195803	
36999	3253	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	216260	0	180256009	4107731	
49013	4305	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	285614	0	180256009	4107731	
37361	3289	4043071	1966-05-30	1966-05-30 00:00:00	38000275	0	\N	\N	218528	0	228557008	4043071	
37540	3311	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	219849	0	180256009	4107731	
61541	5322	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	354168	0	180256009	4107731	
37847	3343	4107731	1991-10-20	1991-10-20 00:00:00	38000275	0	\N	\N	221704	0	180256009	4107731	
50048	4372	4107731	1994-02-10	1994-02-10 00:00:00	38000275	0	\N	\N	290265	0	180256009	4107731	
38268	3371	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	223529	0	180256009	4107731	
50391	4383	4151422	1990-12-20	1990-12-20 00:00:00	38000275	0	\N	\N	291307	0	269911007	4151422	
50542	4390	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	291849	0	180256009	4107731	
38810	3417	4195803	1999-09-04	1999-09-04 00:00:00	38000275	0	\N	\N	226701	0	312681000	4195803	
39078	3446	4243062	1950-08-08	1950-08-08 00:00:00	38000275	0	\N	\N	228827	0	60027007	4243062	
51368	4451	4125906	1980-01-11	1980-01-11 00:00:00	38000275	0	\N	\N	296139	0	288086009	4125906	
27657	2419	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	160486	0	180256009	4107731	
39803	3505	4195803	2009-08-12	2009-08-12 00:00:00	38000275	0	\N	\N	232382	0	312681000	4195803	
39989	3514	4059978	1994-07-15	1994-07-15 00:00:00	38000275	0	\N	\N	233199	0	169553002	4059978	
51997	4505	4024289	1938-04-12	1938-04-12 00:00:00	38000275	0	\N	\N	300077	0	19490002	4024289	
52216	4530	4151422	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	301636	0	269911007	4151422	
40487	3559	4293740	1951-06-17	1951-06-17 00:00:00	38000275	0	\N	\N	236256	0	384700001	4293740	
52566	4557	4151422	1942-12-20	1942-12-20 00:00:00	38000275	0	\N	\N	303573	0	269911007	4151422	
40923	3589	4107731	1995-12-18	1995-12-18 00:00:00	38000275	0	\N	\N	238491	0	180256009	4107731	
29117	2577	4107731	1992-04-04	1992-04-04 00:00:00	38000275	0	\N	\N	170699	0	180256009	4107731	
41239	3622	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	240672	0	180256009	4107731	
41503	3644	4170947	1962-03-04	1962-03-04 00:00:00	38000275	0	\N	\N	242489	0	274474001	4170947	
53600	4646	4078793	2009-11-24	2009-11-24 00:00:00	38000275	0	\N	\N	309815	0	180325003	4078793	
53732	4655	4107731	1991-12-01	1991-12-01 00:00:00	38000275	0	\N	\N	310360	0	180256009	4107731	
42032	3703	4107731	1991-01-19	1991-01-19 00:00:00	38000275	0	\N	\N	246215	0	180256009	4107731	
42234	3725	4125906	1970-09-23	1970-09-23 00:00:00	38000275	0	\N	\N	247589	0	288086009	4125906	
54362	4722	4195803	2015-09-29	2015-09-29 00:00:00	38000275	0	\N	\N	314617	0	312681000	4195803	
42497	3748	4024289	1987-11-27	1987-11-27 00:00:00	38000275	0	\N	\N	249095	0	19490002	4024289	
42795	3772	4107731	1991-01-19	1991-01-19 00:00:00	38000275	0	\N	\N	250653	0	180256009	4107731	
54835	4756	4125906	1997-10-26	1997-10-26 00:00:00	38000275	0	\N	\N	316784	0	288086009	4125906	
55093	4800	4024289	1978-11-30	1978-11-30 00:00:00	38000275	0	\N	\N	319293	0	19490002	4024289	
31387	2776	4107731	2008-02-26	2008-02-26 00:00:00	38000275	0	\N	\N	183807	0	180256009	4107731	
43461	3851	4057420	1985-10-14	1985-10-14 00:00:00	38000275	0	\N	\N	255594	0	18286008	4057420	
55599	4844	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	322206	0	180256009	4107731	
55879	4872	4125906	1926-12-29	1926-12-29 00:00:00	38000275	0	\N	\N	323950	0	288086009	4125906	
55949	4878	4107731	1991-12-21	1991-12-21 00:00:00	38000275	0	\N	\N	324391	0	180256009	4107731	
32271	2832	4107731	1996-01-27	1996-01-27 00:00:00	38000275	0	\N	\N	187925	0	180256009	4107731	
56786	4935	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	328095	0	180256009	4107731	
45018	3956	4163872	1975-11-07	1975-11-07 00:00:00	38000275	0	\N	\N	262997	0	399208008	4163872	
33228	2906	4125906	1936-08-14	1936-08-14 00:00:00	38000275	0	\N	\N	193719	0	288086009	4125906	
45306	3998	4170947	1970-09-09	1970-09-09 00:00:00	38000275	0	\N	\N	265849	0	274474001	4170947	
45744	4027	4107731	1990-11-17	1990-11-17 00:00:00	38000275	0	\N	\N	267809	0	180256009	4107731	
46094	4052	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	269370	0	180256009	4107731	
46217	4064	4107731	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	270017	0	180256009	4107731	
46492	4078	4107731	1990-08-20	1990-08-20 00:00:00	38000275	0	\N	\N	271032	0	180256009	4107731	
58624	5078	4125906	1956-05-25	1956-05-25 00:00:00	38000275	0	\N	\N	337523	0	288086009	4125906	
58721	5097	4191853	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	338637	0	395142003	4191853	
59102	5118	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	340175	0	180256009	4107731	
59450	5143	4043071	1973-05-23	1973-05-23 00:00:00	38000275	0	\N	\N	341793	0	228557008	4043071	
59506	5150	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	342345	0	180256009	4107731	
47853	4200	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	278765	0	180256009	4107731	
24120	2103	4195803	1975-02-27	1975-02-27 00:00:00	38000275	0	\N	\N	140121	0	312681000	4195803	
48072	4217	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	279969	0	180256009	4107731	
36321	3181	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	211675	0	180256009	4107731	
48467	4250	4024289	2016-05-31	2016-05-31 00:00:00	38000275	0	\N	\N	282265	0	19490002	4024289	
48635	4278	4035793	2000-01-28	2000-01-28 00:00:00	38000275	0	\N	\N	283927	0	15081005	4035793	
37000	3253	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	216336	0	180256009	4107731	
49014	4305	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	285657	0	180256009	4107731	
37362	3289	4243062	1966-12-16	1966-12-16 00:00:00	38000275	0	\N	\N	218490	0	60027007	4243062	
37541	3311	4125906	1974-07-20	1974-07-20 00:00:00	38000275	0	\N	\N	219797	0	288086009	4125906	
61542	5322	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	354229	0	180256009	4107731	
37848	3343	4043071	1987-04-28	1987-04-28 00:00:00	38000275	0	\N	\N	221824	0	228557008	4043071	
50049	4372	4107731	1995-12-14	1995-12-14 00:00:00	38000275	0	\N	\N	290327	0	180256009	4107731	
38269	3371	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	223619	0	180256009	4107731	
50392	4383	4010253	1983-07-25	1983-07-25 00:00:00	38000275	0	\N	\N	291306	0	112790001	4010253	
50543	4390	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	291874	0	180256009	4107731	
38811	3418	4293740	2005-11-20	2005-11-20 00:00:00	38000275	0	\N	\N	226756	0	384700001	4293740	
39079	3446	4043071	1952-10-28	1952-10-28 00:00:00	38000275	0	\N	\N	228804	0	228557008	4043071	
51369	4451	4043071	1963-10-24	1963-10-24 00:00:00	38000275	0	\N	\N	296130	0	228557008	4043071	
27658	2419	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	160622	0	180256009	4107731	
39804	3505	4058899	2009-08-12	2009-08-12 00:00:00	38000275	0	\N	\N	232382	0	168594001	4058899	
39990	3514	4125906	1975-09-13	1975-09-13 00:00:00	38000275	0	\N	\N	233211	0	288086009	4125906	
51998	4505	4170947	1938-04-12	1938-04-12 00:00:00	38000275	0	\N	\N	300077	0	274474001	4170947	
52217	4530	4170947	1988-07-07	1988-07-07 00:00:00	38000275	0	\N	\N	301620	0	274474001	4170947	
40488	3559	4125906	1951-06-17	1951-06-17 00:00:00	38000275	0	\N	\N	236256	0	288086009	4125906	
52567	4557	4195803	1990-08-12	1990-08-12 00:00:00	38000275	0	\N	\N	303660	0	312681000	4195803	
40924	3589	4107731	1995-05-02	1995-05-02 00:00:00	38000275	0	\N	\N	238406	0	180256009	4107731	
29118	2577	4107731	1991-02-09	1991-02-09 00:00:00	38000275	0	\N	\N	170625	0	180256009	4107731	
41240	3622	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	240729	0	180256009	4107731	
41504	3644	4163872	1962-03-04	1962-03-04 00:00:00	38000275	0	\N	\N	242489	0	399208008	4163872	
53601	4646	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	309789	0	180256009	4107731	
53733	4655	4010253	2017-11-23	2017-11-23 00:00:00	38000275	0	\N	\N	310348	0	112790001	4010253	
42033	3703	4107731	1991-11-30	1991-11-30 00:00:00	38000275	0	\N	\N	246239	0	180256009	4107731	
42235	3725	4024289	1981-09-16	1981-09-16 00:00:00	38000275	0	\N	\N	247576	0	19490002	4024289	
54363	4722	4170947	2015-09-29	2015-09-29 00:00:00	38000275	0	\N	\N	314617	0	274474001	4170947	
42498	3748	4170947	1987-11-27	1987-11-27 00:00:00	38000275	0	\N	\N	249095	0	274474001	4170947	
42796	3772	4107731	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	250729	0	180256009	4107731	
54836	4756	4125906	2010-12-01	2010-12-01 00:00:00	38000275	0	\N	\N	316786	0	288086009	4125906	
55094	4800	4170947	1978-11-30	1978-11-30 00:00:00	38000275	0	\N	\N	319293	0	274474001	4170947	
31388	2776	4107731	2007-05-29	2007-05-29 00:00:00	38000275	0	\N	\N	183804	0	180256009	4107731	
43462	3851	40492359	1985-10-14	1985-10-14 00:00:00	38000275	0	\N	\N	255594	0	447365002	40492359	
55600	4844	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	322205	0	180256009	4107731	
55880	4872	4125906	1968-06-01	1968-06-01 00:00:00	38000275	0	\N	\N	324090	0	288086009	4125906	
55950	4878	4125906	1970-12-06	1970-12-06 00:00:00	38000275	0	\N	\N	324430	0	288086009	4125906	
32272	2832	4107731	1995-02-04	1995-02-04 00:00:00	38000275	0	\N	\N	187950	0	180256009	4107731	
56787	4935	4125906	1981-08-26	1981-08-26 00:00:00	38000275	0	\N	\N	328154	0	288086009	4125906	
45019	3957	4035793	2012-10-11	2012-10-11 00:00:00	38000275	0	\N	\N	263059	0	15081005	4035793	
33229	2906	4125906	1941-05-25	1941-05-25 00:00:00	38000275	0	\N	\N	193721	0	288086009	4125906	
45307	3998	4195803	2016-10-24	2016-10-24 00:00:00	38000275	0	\N	\N	265850	0	312681000	4195803	
45745	4027	4107731	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	267819	0	180256009	4107731	
46095	4052	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	269357	0	180256009	4107731	
46218	4064	4107731	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	269993	0	180256009	4107731	
46493	4078	4107731	1992-11-16	1992-11-16 00:00:00	38000275	0	\N	\N	271068	0	180256009	4107731	
58625	5078	4125906	1988-05-31	1988-05-31 00:00:00	38000275	0	\N	\N	337627	0	288086009	4125906	
58722	5097	4107731	1995-04-02	1995-04-02 00:00:00	38000275	0	\N	\N	338707	0	180256009	4107731	
59103	5118	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	340231	0	180256009	4107731	
59451	5143	4043071	1973-11-21	1973-11-21 00:00:00	38000275	0	\N	\N	341865	0	228557008	4043071	
59507	5150	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	342424	0	180256009	4107731	
47854	4200	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	278828	0	180256009	4107731	
24121	2103	4170947	1975-02-27	1975-02-27 00:00:00	38000275	0	\N	\N	140121	0	274474001	4170947	
48073	4217	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	279992	0	180256009	4107731	
36322	3181	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	211823	0	180256009	4107731	
48494	4253	4059978	2002-11-07	2002-11-07 00:00:00	38000275	0	\N	\N	282451	0	169553002	4059978	
48636	4278	4035793	2015-11-20	2015-11-20 00:00:00	38000275	0	\N	\N	283868	0	15081005	4035793	
37001	3253	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	216277	0	180256009	4107731	
49015	4305	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	285550	0	180256009	4107731	
37363	3289	4170947	1966-12-16	1966-12-16 00:00:00	38000275	0	\N	\N	218490	0	274474001	4170947	
37542	3311	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	219758	0	180256009	4107731	
61543	5322	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	354076	0	180256009	4107731	
37849	3343	4107731	1990-04-01	1990-04-01 00:00:00	38000275	0	\N	\N	221783	0	180256009	4107731	
50050	4372	4107731	1996-05-30	1996-05-30 00:00:00	38000275	0	\N	\N	290240	0	180256009	4107731	
38270	3371	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	223594	0	180256009	4107731	
50393	4384	4293740	1982-12-08	1982-12-08 00:00:00	38000275	0	\N	\N	291364	0	384700001	4293740	
50544	4390	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	291879	0	180256009	4107731	
38812	3418	4125906	2005-11-20	2005-11-20 00:00:00	38000275	0	\N	\N	226756	0	288086009	4125906	
39080	3446	4043071	1952-01-08	1952-01-08 00:00:00	38000275	0	\N	\N	228830	0	228557008	4043071	
51370	4451	4043071	1962-08-30	1962-08-30 00:00:00	38000275	0	\N	\N	296180	0	228557008	4043071	
27659	2419	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	160626	0	180256009	4107731	
39805	3505	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	232426	0	180256009	4107731	
39991	3514	4187458	1997-08-13	1997-08-13 00:00:00	38000275	0	\N	\N	233216	0	415300000	4187458	
51999	4505	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	299977	0	395142003	4191853	
52218	4530	4243062	1988-07-07	1988-07-07 00:00:00	38000275	0	\N	\N	301620	0	60027007	4243062	
40489	3560	4151422	2012-04-28	2012-04-28 00:00:00	38000275	0	\N	\N	236372	0	269911007	4151422	
52568	4557	4057420	1978-12-31	1978-12-31 00:00:00	38000275	0	\N	\N	303643	0	18286008	4057420	
40925	3589	4107731	1996-07-16	1996-07-16 00:00:00	38000275	0	\N	\N	238424	0	180256009	4107731	
29119	2577	4107731	1990-08-04	1990-08-04 00:00:00	38000275	0	\N	\N	170624	0	180256009	4107731	
41241	3622	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	240753	0	180256009	4107731	
41509	3647	4043071	1944-08-02	1944-08-02 00:00:00	38000275	0	\N	\N	242652	0	228557008	4043071	
53602	4646	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	309750	0	180256009	4107731	
53734	4655	4107731	1990-08-05	1990-08-05 00:00:00	38000275	0	\N	\N	310394	0	180256009	4107731	
42034	3703	4107731	1990-12-29	1990-12-29 00:00:00	38000275	0	\N	\N	246250	0	180256009	4107731	
42236	3725	4170947	1981-09-16	1981-09-16 00:00:00	38000275	0	\N	\N	247576	0	274474001	4170947	
54364	4722	4125906	1996-06-19	1996-06-19 00:00:00	38000275	0	\N	\N	314615	0	288086009	4125906	
42499	3748	4125906	2015-12-28	2015-12-28 00:00:00	38000275	0	\N	\N	249097	0	288086009	4125906	
42797	3772	4191853	1990-01-06	1990-01-06 00:00:00	38000275	0	\N	\N	250664	0	395142003	4191853	
54837	4756	4195803	2004-09-11	2004-09-11 00:00:00	38000275	0	\N	\N	316875	0	312681000	4195803	
55095	4800	4125906	1983-02-07	1983-02-07 00:00:00	38000275	0	\N	\N	319294	0	288086009	4125906	
31389	2776	4107731	2006-05-16	2006-05-16 00:00:00	38000275	0	\N	\N	183865	0	180256009	4107731	
43463	3851	4252419	1927-10-04	1927-10-04 00:00:00	38000275	0	\N	\N	255592	0	74016001	4252419	
55601	4844	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	322253	0	180256009	4107731	
55881	4872	4293740	1968-06-01	1968-06-01 00:00:00	38000275	0	\N	\N	324090	0	384700001	4293740	
55951	4878	4107731	1993-03-06	1993-03-06 00:00:00	38000275	0	\N	\N	324365	0	180256009	4107731	
32273	2832	4107731	1995-08-12	1995-08-12 00:00:00	38000275	0	\N	\N	187875	0	180256009	4107731	
56788	4935	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	328037	0	180256009	4107731	
45020	3957	4125906	2001-12-10	2001-12-10 00:00:00	38000275	0	\N	\N	263064	0	288086009	4125906	
33230	2906	4293740	1941-05-25	1941-05-25 00:00:00	38000275	0	\N	\N	193721	0	384700001	4293740	
45308	3998	4058899	2016-10-24	2016-10-24 00:00:00	38000275	0	\N	\N	265850	0	168594001	4058899	
45746	4027	4107731	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	267844	0	180256009	4107731	
46096	4052	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	269386	0	180256009	4107731	
46219	4064	4107731	1990-05-07	1990-05-07 00:00:00	38000275	0	\N	\N	270016	0	180256009	4107731	
46494	4078	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	271091	0	180256009	4107731	
58626	5078	4195803	1983-05-23	1983-05-23 00:00:00	38000275	0	\N	\N	337526	0	312681000	4195803	
58723	5097	4107731	1995-03-12	1995-03-12 00:00:00	38000275	0	\N	\N	338740	0	180256009	4107731	
59104	5118	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	340272	0	180256009	4107731	
59452	5143	4043071	1973-04-25	1973-04-25 00:00:00	38000275	0	\N	\N	341854	0	228557008	4043071	
59508	5150	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	342475	0	180256009	4107731	
47855	4200	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	278780	0	180256009	4107731	
24122	2103	4047491	1975-02-27	1975-02-27 00:00:00	38000275	0	\N	\N	140121	0	1225002	4047491	
48074	4217	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	280027	0	180256009	4107731	
36323	3181	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	211768	0	180256009	4107731	
48495	4253	4125906	2010-08-16	2010-08-16 00:00:00	38000275	0	\N	\N	282428	0	288086009	4125906	
48637	4278	4035793	2018-12-07	2018-12-07 00:00:00	38000275	0	\N	\N	283863	0	15081005	4035793	
37002	3253	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	216259	0	180256009	4107731	
49016	4305	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	285608	0	180256009	4107731	
37364	3289	4043071	1966-02-21	1966-02-21 00:00:00	38000275	0	\N	\N	218446	0	228557008	4043071	
37543	3311	4191853	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	219805	0	395142003	4191853	
61544	5322	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	354075	0	180256009	4107731	
37850	3343	4107731	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	221737	0	180256009	4107731	
50051	4372	4107731	1996-03-28	1996-03-28 00:00:00	38000275	0	\N	\N	290275	0	180256009	4107731	
38271	3371	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	223621	0	180256009	4107731	
50394	4384	4125906	1982-12-08	1982-12-08 00:00:00	38000275	0	\N	\N	291364	0	288086009	4125906	
50545	4390	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	291822	0	180256009	4107731	
38813	3418	4238715	1971-09-05	1971-09-05 00:00:00	38000275	0	\N	\N	226801	0	68254000	4238715	
39081	3446	4043071	1952-04-22	1952-04-22 00:00:00	38000275	0	\N	\N	228797	0	228557008	4043071	
51371	4452	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	296259	0	180256009	4107731	
27660	2419	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	160536	0	180256009	4107731	
39806	3505	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	232507	0	180256009	4107731	
39992	3514	4037675	1997-08-13	1997-08-13 00:00:00	38000275	0	\N	\N	233216	0	162676008	4037675	
52000	4505	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	300030	0	180256009	4107731	
52219	4530	4058899	1969-05-13	1969-05-13 00:00:00	38000275	0	\N	\N	301617	0	168594001	4058899	
40490	3560	4125906	2017-04-10	2017-04-10 00:00:00	38000275	0	\N	\N	236410	0	288086009	4125906	
52569	4557	40492359	1978-12-31	1978-12-31 00:00:00	38000275	0	\N	\N	303643	0	447365002	40492359	
40926	3589	4107731	1997-05-06	1997-05-06 00:00:00	38000275	0	\N	\N	238443	0	180256009	4107731	
29120	2577	4107731	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	170590	0	180256009	4107731	
41242	3622	4202451	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	240809	0	433112001	4202451	
41510	3647	4043071	1944-06-07	1944-06-07 00:00:00	38000275	0	\N	\N	242614	0	228557008	4043071	
53603	4646	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	309876	0	180256009	4107731	
53735	4655	4107731	1990-11-18	1990-11-18 00:00:00	38000275	0	\N	\N	310270	0	180256009	4107731	
42035	3703	4107731	1992-12-12	1992-12-12 00:00:00	38000275	0	\N	\N	246210	0	180256009	4107731	
42237	3725	4170947	1972-06-05	1972-06-05 00:00:00	38000275	0	\N	\N	247590	0	274474001	4170947	
54365	4722	4195803	1984-04-09	1984-04-09 00:00:00	38000275	0	\N	\N	314613	0	312681000	4195803	
42504	3750	4243062	1999-03-20	1999-03-20 00:00:00	38000275	0	\N	\N	249241	0	60027007	4243062	
42798	3772	4107731	1990-12-29	1990-12-29 00:00:00	38000275	0	\N	\N	250683	0	180256009	4107731	
54838	4756	4125906	1991-07-18	1991-07-18 00:00:00	38000275	0	\N	\N	316782	0	288086009	4125906	
55096	4800	4151422	2007-11-14	2007-11-14 00:00:00	38000275	0	\N	\N	319324	0	269911007	4151422	
31390	2776	4107731	2008-04-08	2008-04-08 00:00:00	38000275	0	\N	\N	183808	0	180256009	4107731	
43464	3851	4151422	1935-12-31	1935-12-31 00:00:00	38000275	0	\N	\N	255509	0	269911007	4151422	
55602	4844	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	322295	0	180256009	4107731	
55882	4874	4125906	1992-12-25	1992-12-25 00:00:00	38000275	0	\N	\N	324212	0	288086009	4125906	
55952	4878	4107731	1993-02-13	1993-02-13 00:00:00	38000275	0	\N	\N	324441	0	180256009	4107731	
32274	2832	4107731	1995-07-01	1995-07-01 00:00:00	38000275	0	\N	\N	187874	0	180256009	4107731	
56789	4935	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	328094	0	180256009	4107731	
45021	3957	4035793	2017-11-09	2017-11-09 00:00:00	38000275	0	\N	\N	263082	0	15081005	4035793	
33231	2906	4125906	1971-03-15	1971-03-15 00:00:00	38000275	0	\N	\N	193724	0	288086009	4125906	
45309	3998	4151422	1975-03-07	1975-03-07 00:00:00	38000275	0	\N	\N	265858	0	269911007	4151422	
45747	4027	4107731	1992-06-06	1992-06-06 00:00:00	38000275	0	\N	\N	267821	0	180256009	4107731	
46097	4052	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	269296	0	180256009	4107731	
46220	4064	4107731	1993-02-08	1993-02-08 00:00:00	38000275	0	\N	\N	270044	0	180256009	4107731	
46495	4078	4107731	1991-03-18	1991-03-18 00:00:00	38000275	0	\N	\N	271065	0	180256009	4107731	
58627	5078	4243062	1983-05-23	1983-05-23 00:00:00	38000275	0	\N	\N	337526	0	60027007	4243062	
58724	5097	4107731	1995-07-16	1995-07-16 00:00:00	38000275	0	\N	\N	338736	0	180256009	4107731	
59105	5118	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	340248	0	180256009	4107731	
59453	5143	4043071	1973-01-03	1973-01-03 00:00:00	38000275	0	\N	\N	341853	0	228557008	4043071	
59509	5150	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	342380	0	395142003	4191853	
47856	4200	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	278722	0	180256009	4107731	
24123	2103	4125906	2002-08-18	2002-08-18 00:00:00	38000275	0	\N	\N	140124	0	288086009	4125906	
48075	4217	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	279980	0	395142003	4191853	
36324	3181	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	211627	0	180256009	4107731	
48496	4253	4199276	2006-12-18	2006-12-18 00:00:00	38000275	0	\N	\N	282423	0	301807007	4199276	
48638	4278	4035793	2009-10-16	2009-10-16 00:00:00	38000275	0	\N	\N	283862	0	15081005	4035793	
37003	3253	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	216280	0	180256009	4107731	
49017	4305	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	285652	0	180256009	4107731	
37365	3289	4043071	1966-01-24	1966-01-24 00:00:00	38000275	0	\N	\N	218532	0	228557008	4043071	
37544	3311	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	219878	0	180256009	4107731	
61545	5322	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	354097	0	180256009	4107731	
37851	3343	4043071	1985-09-03	1985-09-03 00:00:00	38000275	0	\N	\N	221751	0	228557008	4043071	
50052	4372	4107731	1994-05-05	1994-05-05 00:00:00	38000275	0	\N	\N	290320	0	180256009	4107731	
38272	3371	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	223560	0	180256009	4107731	
50395	4384	4197460	1976-03-31	1976-03-31 00:00:00	38000275	0	\N	\N	291363	0	313191000	4197460	
50546	4390	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	291809	0	180256009	4107731	
38814	3418	4275113	1968-08-20	1968-08-20 00:00:00	38000275	0	\N	\N	226720	0	65200003	4275113	
39082	3446	4043071	1952-09-23	1952-09-23 00:00:00	38000275	0	\N	\N	228799	0	228557008	4043071	
51372	4452	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	296293	0	180256009	4107731	
27661	2419	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	160513	0	180256009	4107731	
39807	3505	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	232367	0	180256009	4107731	
39993	3514	4326177	1997-08-13	1997-08-13 00:00:00	38000275	0	\N	\N	233216	0	430193006	4326177	
52001	4505	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	300006	0	180256009	4107731	
52220	4530	4125906	2008-09-20	2008-09-20 00:00:00	38000275	0	\N	\N	301621	0	288086009	4125906	
40491	3560	4163872	1991-08-22	1991-08-22 00:00:00	38000275	0	\N	\N	236357	0	399208008	4163872	
52570	4557	4047491	2017-06-24	2017-06-24 00:00:00	38000275	0	\N	\N	303645	0	1225002	4047491	
40927	3589	4191853	1994-01-03	1994-01-03 00:00:00	38000275	0	\N	\N	238450	0	395142003	4191853	
29121	2577	4107731	1990-05-12	1990-05-12 00:00:00	38000275	0	\N	\N	170622	0	180256009	4107731	
41243	3622	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	240809	0	180256009	4107731	
41511	3647	4151422	1950-12-08	1950-12-08 00:00:00	38000275	0	\N	\N	242677	0	269911007	4151422	
53604	4646	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	309864	0	180256009	4107731	
53736	4655	4107731	1990-10-28	1990-10-28 00:00:00	38000275	0	\N	\N	310386	0	180256009	4107731	
42036	3703	4107731	1993-01-23	1993-01-23 00:00:00	38000275	0	\N	\N	246224	0	180256009	4107731	
42238	3725	4047491	1972-06-05	1972-06-05 00:00:00	38000275	0	\N	\N	247590	0	1225002	4047491	
54366	4722	4170947	1984-04-09	1984-04-09 00:00:00	38000275	0	\N	\N	314613	0	274474001	4170947	
42505	3750	4170947	1999-03-20	1999-03-20 00:00:00	38000275	0	\N	\N	249241	0	274474001	4170947	
42799	3772	4107731	1990-02-17	1990-02-17 00:00:00	38000275	0	\N	\N	250679	0	180256009	4107731	
54839	4756	4151422	1977-06-03	1977-06-03 00:00:00	38000275	0	\N	\N	316843	0	269911007	4151422	
55097	4800	4125906	1974-11-07	1974-11-07 00:00:00	38000275	0	\N	\N	319292	0	288086009	4125906	
31391	2776	4107731	2005-09-27	2005-09-27 00:00:00	38000275	0	\N	\N	183863	0	180256009	4107731	
43465	3851	44783196	1927-10-11	1927-10-11 00:00:00	38000275	0	\N	\N	255559	0	699253003	44783196	
55603	4844	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	322181	0	180256009	4107731	
55883	4874	4010253	1980-11-01	1980-11-01 00:00:00	38000275	0	\N	\N	324160	0	112790001	4010253	
55953	4878	4107731	1992-06-27	1992-06-27 00:00:00	38000275	0	\N	\N	324424	0	180256009	4107731	
32275	2832	4107731	1996-10-26	1996-10-26 00:00:00	38000275	0	\N	\N	187928	0	180256009	4107731	
56790	4935	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	328082	0	180256009	4107731	
45022	3957	4035793	2007-09-13	2007-09-13 00:00:00	38000275	0	\N	\N	263104	0	15081005	4035793	
33232	2906	4252419	1956-11-23	1956-11-23 00:00:00	38000275	0	\N	\N	193722	0	74016001	4252419	
45310	3998	4243062	1972-10-28	1972-10-28 00:00:00	38000275	0	\N	\N	265789	0	60027007	4243062	
45748	4027	4107731	1992-06-27	1992-06-27 00:00:00	38000275	0	\N	\N	267895	0	180256009	4107731	
46098	4052	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	269320	0	180256009	4107731	
46221	4064	4107731	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	270018	0	180256009	4107731	
46496	4078	4107731	1992-10-26	1992-10-26 00:00:00	38000275	0	\N	\N	270994	0	180256009	4107731	
58628	5078	4170947	1983-05-23	1983-05-23 00:00:00	38000275	0	\N	\N	337526	0	274474001	4170947	
58725	5097	4107731	1995-01-08	1995-01-08 00:00:00	38000275	0	\N	\N	338705	0	180256009	4107731	
59106	5118	4170947	1980-10-08	1980-10-08 00:00:00	38000275	0	\N	\N	340158	0	274474001	4170947	
59454	5143	4043071	1973-09-12	1973-09-12 00:00:00	38000275	0	\N	\N	341842	0	228557008	4043071	
59510	5150	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	342481	0	180256009	4107731	
47857	4200	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	278836	0	180256009	4107731	
35908	3144	4151422	1974-11-16	1974-11-16 00:00:00	38000275	0	\N	\N	209181	0	269911007	4151422	
48076	4217	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	279995	0	180256009	4107731	
36325	3181	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	211645	0	180256009	4107731	
48497	4253	44805732	2006-11-13	2006-11-13 00:00:00	38000275	0	\N	\N	282422	0	755621000000101	44805732	
48639	4278	4125906	1978-03-18	1978-03-18 00:00:00	38000275	0	\N	\N	283932	0	288086009	4125906	
37004	3253	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	216253	0	180256009	4107731	
49018	4305	4195803	2019-06-12	2019-06-12 00:00:00	38000275	0	\N	\N	285537	0	312681000	4195803	
37366	3289	4043071	1966-08-29	1966-08-29 00:00:00	38000275	0	\N	\N	218483	0	228557008	4043071	
37545	3311	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	219853	0	180256009	4107731	
61546	5322	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	354233	0	180256009	4107731	
37852	3343	4107731	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	221736	0	180256009	4107731	
50053	4372	4107731	1993-08-26	1993-08-26 00:00:00	38000275	0	\N	\N	290224	0	180256009	4107731	
38273	3371	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	223563	0	180256009	4107731	
50396	4384	4197460	1968-09-08	1968-09-08 00:00:00	38000275	0	\N	\N	291362	0	313191000	4197460	
50547	4390	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	291899	0	180256009	4107731	
38815	3420	4170947	2003-01-27	2003-01-27 00:00:00	38000275	0	\N	\N	226912	0	274474001	4170947	
39083	3446	4043071	1953-07-28	1953-07-28 00:00:00	38000275	0	\N	\N	228806	0	228557008	4043071	
51373	4452	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	296230	0	180256009	4107731	
27662	2419	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	160526	0	395142003	4191853	
39808	3505	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	232523	0	180256009	4107731	
39994	3514	4163872	1989-09-09	1989-09-09 00:00:00	38000275	0	\N	\N	233187	0	399208008	4163872	
52002	4505	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	300092	0	180256009	4107731	
52221	4531	4125906	2004-10-29	2004-10-29 00:00:00	38000275	0	\N	\N	301709	0	288086009	4125906	
40492	3560	4047491	1988-04-12	1988-04-12 00:00:00	38000275	0	\N	\N	236409	0	1225002	4047491	
52571	4557	4170947	2017-06-24	2017-06-24 00:00:00	38000275	0	\N	\N	303645	0	274474001	4170947	
40928	3589	4107731	1995-05-23	1995-05-23 00:00:00	38000275	0	\N	\N	238466	0	180256009	4107731	
29122	2577	4107731	1990-10-06	1990-10-06 00:00:00	38000275	0	\N	\N	170591	0	180256009	4107731	
41244	3622	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	240797	0	180256009	4107731	
41512	3647	4043071	1946-02-27	1946-02-27 00:00:00	38000275	0	\N	\N	242676	0	228557008	4043071	
53605	4646	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	309809	0	180256009	4107731	
53737	4655	4107731	1992-01-12	1992-01-12 00:00:00	38000275	0	\N	\N	310326	0	180256009	4107731	
42037	3703	4107731	1992-11-21	1992-11-21 00:00:00	38000275	0	\N	\N	246244	0	180256009	4107731	
42243	3728	4024289	2007-07-30	2007-07-30 00:00:00	38000275	0	\N	\N	247697	0	19490002	4024289	
54367	4722	4243062	1984-04-09	1984-04-09 00:00:00	38000275	0	\N	\N	314613	0	60027007	4243062	
42506	3750	4151422	1987-11-13	1987-11-13 00:00:00	38000275	0	\N	\N	249245	0	269911007	4151422	
42800	3772	4107731	1993-02-13	1993-02-13 00:00:00	38000275	0	\N	\N	250759	0	180256009	4107731	
54840	4756	4125906	1985-11-25	1985-11-25 00:00:00	38000275	0	\N	\N	316781	0	288086009	4125906	
55098	4800	4293740	1974-11-07	1974-11-07 00:00:00	38000275	0	\N	\N	319292	0	384700001	4293740	
31392	2776	4107731	2007-12-25	2007-12-25 00:00:00	38000275	0	\N	\N	183844	0	180256009	4107731	
43466	3852	4107731	1993-03-01	1993-03-01 00:00:00	38000275	0	\N	\N	255742	0	180256009	4107731	
55604	4844	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	322259	0	180256009	4107731	
55884	4874	4151422	1972-09-20	1972-09-20 00:00:00	38000275	0	\N	\N	324167	0	269911007	4151422	
55954	4878	4107731	1990-12-29	1990-12-29 00:00:00	38000275	0	\N	\N	324386	0	180256009	4107731	
32276	2832	4107731	1996-08-03	1996-08-03 00:00:00	38000275	0	\N	\N	187880	0	180256009	4107731	
56791	4935	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	328110	0	180256009	4107731	
45023	3957	4035793	2008-09-18	2008-09-18 00:00:00	38000275	0	\N	\N	263079	0	15081005	4035793	
33239	2909	4035793	1990-04-22	1990-04-22 00:00:00	38000275	0	\N	\N	193925	0	15081005	4035793	
45311	3998	4170947	1972-10-28	1972-10-28 00:00:00	38000275	0	\N	\N	265789	0	274474001	4170947	
45749	4027	4125906	2012-03-21	2012-03-21 00:00:00	38000275	0	\N	\N	267884	0	288086009	4125906	
46099	4052	4125906	2007-01-01	2007-01-01 00:00:00	38000275	0	\N	\N	269417	0	288086009	4125906	
46222	4064	4107731	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	270004	0	180256009	4107731	
46497	4078	4107731	1991-08-12	1991-08-12 00:00:00	38000275	0	\N	\N	271037	0	180256009	4107731	
58629	5078	4125906	1998-09-27	1998-09-27 00:00:00	38000275	0	\N	\N	337631	0	288086009	4125906	
58726	5097	4107731	1995-01-29	1995-01-29 00:00:00	38000275	0	\N	\N	338682	0	180256009	4107731	
59107	5118	4243062	1980-10-08	1980-10-08 00:00:00	38000275	0	\N	\N	340158	0	60027007	4243062	
59455	5143	4043071	1973-08-15	1973-08-15 00:00:00	38000275	0	\N	\N	341794	0	228557008	4043071	
59511	5150	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	342355	0	180256009	4107731	
47858	4200	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	278833	0	180256009	4107731	
35909	3144	4151422	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	209212	0	269911007	4151422	
48077	4217	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	279924	0	180256009	4107731	
36326	3181	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	211765	0	180256009	4107731	
48498	4255	4125906	1975-01-18	1975-01-18 00:00:00	38000275	0	\N	\N	282502	0	288086009	4125906	
48640	4278	4035793	2005-09-23	2005-09-23 00:00:00	38000275	0	\N	\N	283860	0	15081005	4035793	
37005	3253	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	216385	0	180256009	4107731	
49019	4305	4170947	2019-06-12	2019-06-12 00:00:00	38000275	0	\N	\N	285537	0	274474001	4170947	
37367	3289	4043071	1966-03-28	1966-03-28 00:00:00	38000275	0	\N	\N	218447	0	228557008	4043071	
37546	3311	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	219827	0	180256009	4107731	
61547	5322	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	354164	0	180256009	4107731	
37853	3343	4062501	1978-06-13	1978-06-13 00:00:00	38000275	0	\N	\N	221805	0	171231001	4062501	
50054	4372	4107731	1996-04-18	1996-04-18 00:00:00	38000275	0	\N	\N	290239	0	180256009	4107731	
38274	3371	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	223644	0	180256009	4107731	
50397	4384	4151422	2008-11-27	2008-11-27 00:00:00	38000275	0	\N	\N	291402	0	269911007	4151422	
50548	4390	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	291884	0	180256009	4107731	
38816	3420	4243062	2003-01-27	2003-01-27 00:00:00	38000275	0	\N	\N	226912	0	60027007	4243062	
50913	4433	4078793	2014-08-09	2014-08-09 00:00:00	38000275	0	\N	\N	294714	0	180325003	4078793	
51374	4452	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	296297	0	180256009	4107731	
27663	2419	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	160625	0	180256009	4107731	
39809	3505	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	232474	0	180256009	4107731	
39995	3514	44805732	1998-07-20	1998-07-20 00:00:00	38000275	0	\N	\N	233170	0	755621000000101	44805732	
52003	4505	4125906	1985-04-26	1985-04-26 00:00:00	38000275	0	\N	\N	300079	0	288086009	4125906	
52222	4531	4125906	1916-07-19	1916-07-19 00:00:00	38000275	0	\N	\N	301822	0	288086009	4125906	
40493	3560	4170947	1988-04-12	1988-04-12 00:00:00	38000275	0	\N	\N	236409	0	274474001	4170947	
52572	4557	4125906	1968-01-31	1968-01-31 00:00:00	38000275	0	\N	\N	303640	0	288086009	4125906	
40929	3589	4107731	1997-01-20	1997-01-20 00:00:00	38000275	0	\N	\N	238497	0	180256009	4107731	
29123	2577	4107731	1991-12-21	1991-12-21 00:00:00	38000275	0	\N	\N	170629	0	180256009	4107731	
41245	3622	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	240802	0	180256009	4107731	
41513	3647	4043071	1944-12-06	1944-12-06 00:00:00	38000275	0	\N	\N	242598	0	228557008	4043071	
53606	4646	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	309863	0	180256009	4107731	
53738	4655	4107731	1991-06-16	1991-06-16 00:00:00	38000275	0	\N	\N	310316	0	180256009	4107731	
42038	3703	4107731	1990-08-04	1990-08-04 00:00:00	38000275	0	\N	\N	246261	0	180256009	4107731	
42244	3728	4170947	2007-07-30	2007-07-30 00:00:00	38000275	0	\N	\N	247697	0	274474001	4170947	
54368	4722	4047491	1918-04-19	1918-04-19 00:00:00	38000275	0	\N	\N	314609	0	1225002	4047491	
42507	3750	4145310	2012-01-11	2012-01-11 00:00:00	38000275	0	\N	\N	249242	0	268425006	4145310	
42801	3772	4107731	1991-09-28	1991-09-28 00:00:00	38000275	0	\N	\N	250702	0	180256009	4107731	
54841	4757	4151422	1961-10-29	1961-10-29 00:00:00	38000275	0	\N	\N	316900	0	269911007	4151422	
55099	4800	4326177	1970-10-29	1970-10-29 00:00:00	38000275	0	\N	\N	319321	0	430193006	4326177	
31393	2776	4107731	2005-11-29	2005-11-29 00:00:00	38000275	0	\N	\N	183769	0	180256009	4107731	
43467	3852	4293740	1995-01-20	1995-01-20 00:00:00	38000275	0	\N	\N	255632	0	384700001	4293740	
55605	4844	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	322290	0	180256009	4107731	
55886	4876	4151422	1994-12-23	1994-12-23 00:00:00	38000275	0	\N	\N	324287	0	269911007	4151422	
55955	4878	4107731	1991-07-06	1991-07-06 00:00:00	38000275	0	\N	\N	324354	0	180256009	4107731	
32277	2832	4191853	1994-03-05	1994-03-05 00:00:00	38000275	0	\N	\N	187897	0	395142003	4191853	
56792	4935	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	328118	0	180256009	4107731	
45024	3957	4035793	2013-10-17	2013-10-17 00:00:00	38000275	0	\N	\N	263062	0	15081005	4035793	
33240	2909	42535580	1962-04-07	1962-04-07 00:00:00	38000275	0	\N	\N	193910	0	426701000119108	42535580	
45312	3998	4151422	1990-02-05	1990-02-05 00:00:00	38000275	0	\N	\N	265805	0	269911007	4151422	
45750	4027	4107731	1991-12-21	1991-12-21 00:00:00	38000275	0	\N	\N	267894	0	180256009	4107731	
46100	4052	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	269387	0	180256009	4107731	
46223	4064	4107731	1992-06-22	1992-06-22 00:00:00	38000275	0	\N	\N	270084	0	180256009	4107731	
46498	4078	4107731	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	271035	0	180256009	4107731	
58630	5078	4062501	1914-05-07	1914-05-07 00:00:00	38000275	0	\N	\N	337642	0	171231001	4062501	
58727	5097	4107731	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	338719	0	180256009	4107731	
59108	5118	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	340277	0	180256009	4107731	
59456	5144	4151422	1957-05-25	1957-05-25 00:00:00	38000275	0	\N	\N	341943	0	269911007	4151422	
59512	5150	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	342349	0	180256009	4107731	
47859	4200	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	278802	0	180256009	4107731	
35910	3145	4151422	2005-05-08	2005-05-08 00:00:00	38000275	0	\N	\N	209287	0	269911007	4151422	
48078	4217	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	280046	0	180256009	4107731	
36327	3181	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	211813	0	180256009	4107731	
48499	4255	4293740	2019-06-29	2019-06-29 00:00:00	38000275	0	\N	\N	282506	0	384700001	4293740	
48641	4278	4035793	2004-09-17	2004-09-17 00:00:00	38000275	0	\N	\N	283865	0	15081005	4035793	
37006	3253	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	216378	0	180256009	4107731	
49020	4305	4047491	2019-06-12	2019-06-12 00:00:00	38000275	0	\N	\N	285537	0	1225002	4047491	
37368	3289	4043071	1966-07-25	1966-07-25 00:00:00	38000275	0	\N	\N	218458	0	228557008	4043071	
37547	3311	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	219852	0	180256009	4107731	
61548	5322	4195803	2007-05-09	2007-05-09 00:00:00	38000275	0	\N	\N	354256	0	312681000	4195803	
37854	3343	4107731	1992-06-28	1992-06-28 00:00:00	38000275	0	\N	\N	221854	0	180256009	4107731	
50055	4372	4107731	1996-07-11	1996-07-11 00:00:00	38000275	0	\N	\N	290241	0	180256009	4107731	
38275	3371	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	223555	0	180256009	4107731	
50398	4384	4125906	1968-03-12	1968-03-12 00:00:00	38000275	0	\N	\N	291361	0	288086009	4125906	
50549	4390	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	291876	0	180256009	4107731	
38817	3420	4024289	1969-09-03	1969-09-03 00:00:00	38000275	0	\N	\N	226881	0	19490002	4024289	
50914	4433	4078793	2018-09-01	2018-09-01 00:00:00	38000275	0	\N	\N	294718	0	180325003	4078793	
51375	4452	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	296216	0	180256009	4107731	
27664	2419	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	160516	0	180256009	4107731	
39810	3505	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	232449	0	180256009	4107731	
39996	3514	4198190	2015-08-11	2015-08-11 00:00:00	38000275	0	\N	\N	233189	0	80146002	4198190	
52004	4505	4293740	1985-04-26	1985-04-26 00:00:00	38000275	0	\N	\N	300079	0	384700001	4293740	
52223	4531	4151422	2008-07-24	2008-07-24 00:00:00	38000275	0	\N	\N	301819	0	269911007	4151422	
40494	3560	4125906	1987-02-26	1987-02-26 00:00:00	38000275	0	\N	\N	236412	0	288086009	4125906	
52573	4557	4293740	1968-01-31	1968-01-31 00:00:00	38000275	0	\N	\N	303640	0	384700001	4293740	
40930	3589	4107731	1996-12-30	1996-12-30 00:00:00	38000275	0	\N	\N	238473	0	180256009	4107731	
29124	2577	4107731	1990-09-15	1990-09-15 00:00:00	38000275	0	\N	\N	170653	0	180256009	4107731	
41246	3622	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	240674	0	180256009	4107731	
41514	3647	4043071	1944-03-29	1944-03-29 00:00:00	38000275	0	\N	\N	242669	0	228557008	4043071	
53607	4646	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	309830	0	180256009	4107731	
53739	4655	4107731	1992-08-30	1992-08-30 00:00:00	38000275	0	\N	\N	310363	0	180256009	4107731	
42039	3703	4107731	1990-09-15	1990-09-15 00:00:00	38000275	0	\N	\N	246262	0	180256009	4107731	
42245	3728	4125906	1995-04-13	1995-04-13 00:00:00	38000275	0	\N	\N	247696	0	288086009	4125906	
54369	4722	4170947	1918-04-19	1918-04-19 00:00:00	38000275	0	\N	\N	314609	0	274474001	4170947	
42508	3750	4195803	2012-01-11	2012-01-11 00:00:00	38000275	0	\N	\N	249242	0	312681000	4195803	
42802	3772	4107731	1992-02-01	1992-02-01 00:00:00	38000275	0	\N	\N	250676	0	180256009	4107731	
54842	4757	4125906	1982-09-06	1982-09-06 00:00:00	38000275	0	\N	\N	316962	0	288086009	4125906	
55100	4800	4037675	1970-10-29	1970-10-29 00:00:00	38000275	0	\N	\N	319321	0	162676008	4037675	
31394	2776	4107731	2007-07-10	2007-07-10 00:00:00	38000275	0	\N	\N	183805	0	180256009	4107731	
43468	3852	4125906	1995-01-20	1995-01-20 00:00:00	38000275	0	\N	\N	255632	0	288086009	4125906	
55606	4844	4151422	2000-09-16	2000-09-16 00:00:00	38000275	0	\N	\N	322322	0	269911007	4151422	
55887	4876	4186930	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	324289	0	46706006	4186930	
55956	4878	4107731	1991-10-19	1991-10-19 00:00:00	38000275	0	\N	\N	324448	0	180256009	4107731	
32278	2832	4107731	1996-06-01	1996-06-01 00:00:00	38000275	0	\N	\N	188013	0	180256009	4107731	
56793	4935	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	328061	0	180256009	4107731	
45025	3957	4035793	2015-10-29	2015-10-29 00:00:00	38000275	0	\N	\N	263081	0	15081005	4035793	
33241	2909	4202832	1962-04-07	1962-04-07 00:00:00	38000275	0	\N	\N	193910	0	52765003	4202832	
45325	4005	4125906	1971-05-12	1971-05-12 00:00:00	38000275	0	\N	\N	266081	0	288086009	4125906	
45751	4027	4107731	1990-12-29	1990-12-29 00:00:00	38000275	0	\N	\N	267810	0	180256009	4107731	
46101	4052	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	269307	0	180256009	4107731	
46224	4064	4107731	1992-11-16	1992-11-16 00:00:00	38000275	0	\N	\N	270042	0	180256009	4107731	
46499	4078	4107731	1991-02-25	1991-02-25 00:00:00	38000275	0	\N	\N	270956	0	180256009	4107731	
58631	5079	4058899	1969-07-28	1969-07-28 00:00:00	38000275	0	\N	\N	337687	0	168594001	4058899	
58728	5097	4107731	1994-01-16	1994-01-16 00:00:00	38000275	0	\N	\N	338730	0	180256009	4107731	
59109	5118	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	340165	0	180256009	4107731	
59457	5144	4163872	1942-02-28	1942-02-28 00:00:00	38000275	0	\N	\N	341926	0	399208008	4163872	
59513	5150	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	342358	0	180256009	4107731	
47860	4200	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	278734	0	180256009	4107731	
35911	3145	4163872	1974-05-11	1974-05-11 00:00:00	38000275	0	\N	\N	209300	0	399208008	4163872	
48079	4217	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	279978	0	180256009	4107731	
36328	3181	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	211751	0	180256009	4107731	
48500	4255	4125906	2019-06-29	2019-06-29 00:00:00	38000275	0	\N	\N	282506	0	288086009	4125906	
48642	4278	4035793	2016-11-25	2016-11-25 00:00:00	38000275	0	\N	\N	283851	0	15081005	4035793	
37007	3253	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	216248	0	180256009	4107731	
49021	4305	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	285638	0	180256009	4107731	
37369	3289	4043071	1966-04-25	1966-04-25 00:00:00	38000275	0	\N	\N	218482	0	228557008	4043071	
37559	3313	4238715	1982-02-26	1982-02-26 00:00:00	38000275	0	\N	\N	220040	0	68254000	4238715	
61549	5322	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	354231	0	180256009	4107731	
37855	3343	4043071	1986-01-21	1986-01-21 00:00:00	38000275	0	\N	\N	221809	0	228557008	4043071	
50056	4372	4107731	1996-02-15	1996-02-15 00:00:00	38000275	0	\N	\N	290274	0	180256009	4107731	
38276	3371	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	223620	0	180256009	4107731	
50399	4384	4010253	2018-03-07	2018-03-07 00:00:00	38000275	0	\N	\N	291404	0	112790001	4010253	
50550	4391	4170947	1945-12-13	1945-12-13 00:00:00	38000275	0	\N	\N	291938	0	274474001	4170947	
38818	3420	4170947	1969-09-03	1969-09-03 00:00:00	38000275	0	\N	\N	226881	0	274474001	4170947	
50915	4433	4057420	1996-04-27	1996-04-27 00:00:00	38000275	0	\N	\N	294711	0	18286008	4057420	
51376	4452	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	296261	0	180256009	4107731	
27665	2419	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	160608	0	180256009	4107731	
39811	3505	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	232441	0	180256009	4107731	
40000	3516	4326177	1964-07-21	1964-07-21 00:00:00	38000275	0	\N	\N	233294	0	430193006	4326177	
52005	4505	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	299981	0	180256009	4107731	
52224	4531	4216130	2017-04-29	2017-04-29 00:00:00	38000275	0	\N	\N	301711	0	415070008	4216130	
40495	3561	4078793	1996-11-11	1996-11-11 00:00:00	38000275	0	\N	\N	236446	0	180325003	4078793	
52574	4557	4151422	1988-12-26	1988-12-26 00:00:00	38000275	0	\N	\N	303578	0	269911007	4151422	
40931	3589	4107731	1994-11-14	1994-11-14 00:00:00	38000275	0	\N	\N	238454	0	180256009	4107731	
29125	2579	4202451	1978-07-02	1978-07-02 00:00:00	38000275	0	\N	\N	170793	0	433112001	4202451	
41247	3622	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	240823	0	180256009	4107731	
53296	4626	4107731	1999-10-15	1999-10-15 00:00:00	38000275	0	\N	\N	308158	0	180256009	4107731	
53608	4646	4107731	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	309860	0	180256009	4107731	
53740	4655	4107731	1992-11-01	1992-11-01 00:00:00	38000275	0	\N	\N	310321	0	180256009	4107731	
42040	3703	4107731	1991-09-28	1991-09-28 00:00:00	38000275	0	\N	\N	246293	0	180256009	4107731	
42246	3728	4186930	1992-01-12	1992-01-12 00:00:00	38000275	0	\N	\N	247722	0	46706006	4186930	
54370	4722	44783196	1924-02-24	1924-02-24 00:00:00	38000275	0	\N	\N	314540	0	699253003	44783196	
42509	3752	4170947	1959-08-04	1959-08-04 00:00:00	38000275	0	\N	\N	249363	0	274474001	4170947	
42803	3772	4107731	1991-07-27	1991-07-27 00:00:00	38000275	0	\N	\N	250675	0	180256009	4107731	
54843	4757	4125906	2004-05-27	2004-05-27 00:00:00	38000275	0	\N	\N	316964	0	288086009	4125906	
55101	4800	4187458	1970-10-29	1970-10-29 00:00:00	38000275	0	\N	\N	319321	0	415300000	4187458	
31395	2776	4107731	2006-02-21	2006-02-21 00:00:00	38000275	0	\N	\N	183771	0	180256009	4107731	
43469	3852	4170947	1964-12-28	1964-12-28 00:00:00	38000275	0	\N	\N	255631	0	274474001	4170947	
55607	4844	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	322216	0	180256009	4107731	
55888	4876	4275113	1987-05-16	1987-05-16 00:00:00	38000275	0	\N	\N	324256	0	65200003	4275113	
55957	4878	4107731	1992-08-29	1992-08-29 00:00:00	38000275	0	\N	\N	324452	0	180256009	4107731	
32279	2832	4107731	1994-08-20	1994-08-20 00:00:00	38000275	0	\N	\N	187899	0	180256009	4107731	
56794	4935	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	328091	0	180256009	4107731	
45026	3957	4035793	2010-09-30	2010-09-30 00:00:00	38000275	0	\N	\N	263058	0	15081005	4035793	
33242	2909	4163971	1962-04-07	1962-04-07 00:00:00	38000275	0	\N	\N	193910	0	45595009	4163971	
45326	4005	4170947	1981-05-03	1981-05-03 00:00:00	38000275	0	\N	\N	266082	0	274474001	4170947	
45752	4027	4107731	1991-09-07	1991-09-07 00:00:00	38000275	0	\N	\N	267840	0	180256009	4107731	
46102	4052	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	269359	0	180256009	4107731	
46225	4064	4191853	1990-01-01	1990-01-01 00:00:00	38000275	0	\N	\N	270013	0	395142003	4191853	
46500	4078	4107731	1992-03-30	1992-03-30 00:00:00	38000275	0	\N	\N	271039	0	180256009	4107731	
58632	5079	4151422	1999-11-08	1999-11-08 00:00:00	38000275	0	\N	\N	337678	0	269911007	4151422	
58729	5097	4151422	2009-01-11	2009-01-11 00:00:00	38000275	0	\N	\N	338745	0	269911007	4151422	
59110	5118	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	340228	0	180256009	4107731	
59458	5144	4151422	2013-05-08	2013-05-08 00:00:00	38000275	0	\N	\N	341901	0	269911007	4151422	
59514	5150	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	342398	0	180256009	4107731	
47861	4200	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	278729	0	180256009	4107731	
35912	3145	4170947	1974-05-11	1974-05-11 00:00:00	38000275	0	\N	\N	209300	0	274474001	4170947	
48080	4217	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	280005	0	180256009	4107731	
36329	3181	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	211754	0	180256009	4107731	
48501	4256	4202832	1963-11-14	1963-11-14 00:00:00	38000275	0	\N	\N	282589	0	52765003	4202832	
48643	4278	4035793	2010-10-22	2010-10-22 00:00:00	38000275	0	\N	\N	283853	0	15081005	4035793	
37008	3253	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	216360	0	180256009	4107731	
49022	4305	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	285654	0	180256009	4107731	
37370	3290	4125906	1997-12-06	1997-12-06 00:00:00	38000275	0	\N	\N	218619	0	288086009	4125906	
37560	3313	4058899	1960-07-23	1960-07-23 00:00:00	38000275	0	\N	\N	219995	0	168594001	4058899	
61550	5322	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	354237	0	180256009	4107731	
37856	3343	4191853	1977-07-13	1977-07-13 00:00:00	38000275	0	\N	\N	221770	0	395142003	4191853	
50057	4372	4107731	1996-06-20	1996-06-20 00:00:00	38000275	0	\N	\N	290307	0	180256009	4107731	
38277	3371	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	223589	0	180256009	4107731	
50468	4387	4330583	2011-08-24	2011-08-24 00:00:00	38000275	0	\N	\N	291611	0	22523008	4330583	
50551	4391	4163872	1945-12-13	1945-12-13 00:00:00	38000275	0	\N	\N	291938	0	399208008	4163872	
38820	3422	4181917	1978-12-16	1978-12-16 00:00:00	38000275	0	\N	\N	226981	0	54550000	4181917	
50916	4433	4078793	2013-08-03	2013-08-03 00:00:00	38000275	0	\N	\N	294697	0	180325003	4078793	
51377	4452	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	296251	0	180256009	4107731	
27666	2419	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	160537	0	180256009	4107731	
39812	3505	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	232472	0	180256009	4107731	
40001	3516	4037675	1964-07-21	1964-07-21 00:00:00	38000275	0	\N	\N	233294	0	162676008	4037675	
52006	4505	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	300085	0	180256009	4107731	
52225	4531	4336464	2017-04-29	2017-04-29 00:00:00	38000275	0	\N	\N	301711	0	232717009	4336464	
40496	3561	4163872	1925-02-12	1925-02-12 00:00:00	38000275	0	\N	\N	236498	0	399208008	4163872	
52575	4559	4195803	2015-07-28	2015-07-28 00:00:00	38000275	0	\N	\N	303732	0	312681000	4195803	
40932	3589	4107731	1997-02-10	1997-02-10 00:00:00	38000275	0	\N	\N	238441	0	180256009	4107731	
29126	2579	4047491	1961-08-31	1961-08-31 00:00:00	38000275	0	\N	\N	170790	0	1225002	4047491	
41248	3622	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	240743	0	180256009	4107731	
53297	4626	4145310	2016-05-01	2016-05-01 00:00:00	38000275	0	\N	\N	308211	0	268425006	4145310	
53609	4646	4078793	2011-05-03	2011-05-03 00:00:00	38000275	0	\N	\N	309868	0	180325003	4078793	
53741	4655	4125906	2009-04-28	2009-04-28 00:00:00	38000275	0	\N	\N	310304	0	288086009	4125906	
42041	3703	4107731	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	246287	0	180256009	4107731	
42247	3728	4275113	1987-01-09	1987-01-09 00:00:00	38000275	0	\N	\N	247699	0	65200003	4275113	
54371	4722	4125906	1994-07-16	1994-07-16 00:00:00	38000275	0	\N	\N	314614	0	288086009	4125906	
42510	3752	4024289	1959-08-04	1959-08-04 00:00:00	38000275	0	\N	\N	249363	0	19490002	4024289	
42804	3772	4107731	1991-05-25	1991-05-25 00:00:00	38000275	0	\N	\N	250732	0	180256009	4107731	
54844	4757	4181917	2001-03-17	2001-03-17 00:00:00	38000275	0	\N	\N	316963	0	54550000	4181917	
55102	4800	4170947	1989-07-27	1989-07-27 00:00:00	38000275	0	\N	\N	319296	0	274474001	4170947	
31396	2776	4107731	2006-12-12	2006-12-12 00:00:00	38000275	0	\N	\N	183826	0	180256009	4107731	
43470	3852	4047491	1964-12-28	1964-12-28 00:00:00	38000275	0	\N	\N	255631	0	1225002	4047491	
55608	4844	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	322184	0	180256009	4107731	
55889	4876	4295880	1992-04-19	1992-04-19 00:00:00	38000275	0	\N	\N	324245	0	76601001	4295880	
55958	4878	4107731	1992-11-21	1992-11-21 00:00:00	38000275	0	\N	\N	324438	0	180256009	4107731	
32280	2832	4107731	1996-12-07	1996-12-07 00:00:00	38000275	0	\N	\N	187929	0	180256009	4107731	
56795	4935	4198190	1995-09-18	1995-09-18 00:00:00	38000275	0	\N	\N	328153	0	80146002	4198190	
45027	3957	4035793	2018-11-15	2018-11-15 00:00:00	38000275	0	\N	\N	263106	0	15081005	4035793	
33243	2909	4163951	1962-04-07	1962-04-07 00:00:00	38000275	0	\N	\N	193910	0	29303009	4163951	
45327	4005	4243062	1981-05-03	1981-05-03 00:00:00	38000275	0	\N	\N	266082	0	60027007	4243062	
45753	4027	4107731	1992-12-12	1992-12-12 00:00:00	38000275	0	\N	\N	267822	0	180256009	4107731	
46103	4052	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	269393	0	180256009	4107731	
46226	4064	4197460	1966-02-08	1966-02-08 00:00:00	38000275	0	\N	\N	269996	0	313191000	4197460	
46501	4078	4107731	1992-12-28	1992-12-28 00:00:00	38000275	0	\N	\N	271076	0	180256009	4107731	
58633	5079	4125906	1981-08-24	1981-08-24 00:00:00	38000275	0	\N	\N	337688	0	288086009	4125906	
58730	5097	4107731	1993-10-03	1993-10-03 00:00:00	38000275	0	\N	\N	338634	0	180256009	4107731	
59111	5118	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	340225	0	180256009	4107731	
59459	5144	4151422	1962-06-21	1962-06-21 00:00:00	38000275	0	\N	\N	341965	0	269911007	4151422	
59515	5150	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	342394	0	180256009	4107731	
47862	4200	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	278763	0	180256009	4107731	
35913	3145	4125906	2001-12-15	2001-12-15 00:00:00	38000275	0	\N	\N	209303	0	288086009	4125906	
48081	4217	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	279952	0	180256009	4107731	
36330	3181	4197460	1959-05-05	1959-05-05 00:00:00	38000275	0	\N	\N	211653	0	313191000	4197460	
48502	4256	42535580	1963-11-14	1963-11-14 00:00:00	38000275	0	\N	\N	282589	0	426701000119108	42535580	
48644	4278	4035793	2017-12-01	2017-12-01 00:00:00	38000275	0	\N	\N	283943	0	15081005	4035793	
37009	3253	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	216361	0	180256009	4107731	
49023	4305	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	285618	0	180256009	4107731	
37371	3290	4151422	1985-01-18	1985-01-18 00:00:00	38000275	0	\N	\N	218609	0	269911007	4151422	
37561	3313	4125906	2010-11-03	2010-11-03 00:00:00	38000275	0	\N	\N	219998	0	288086009	4125906	
61551	5322	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	354190	0	180256009	4107731	
37857	3343	4107731	1990-08-05	1990-08-05 00:00:00	38000275	0	\N	\N	221723	0	180256009	4107731	
50058	4372	4107731	1994-06-16	1994-06-16 00:00:00	38000275	0	\N	\N	290321	0	180256009	4107731	
38278	3371	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	223539	0	180256009	4107731	
50469	4387	4301346	1972-07-15	1972-07-15 00:00:00	38000275	0	\N	\N	291618	0	387685009	4301346	
50552	4391	4195803	2016-11-26	2016-11-26 00:00:00	38000275	0	\N	\N	291943	0	312681000	4195803	
38821	3422	4125906	1990-01-22	1990-01-22 00:00:00	38000275	0	\N	\N	226984	0	288086009	4125906	
50917	4433	4078793	1998-05-09	1998-05-09 00:00:00	38000275	0	\N	\N	294741	0	180325003	4078793	
51378	4452	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	296223	0	180256009	4107731	
27667	2419	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	160624	0	180256009	4107731	
39813	3505	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	232542	0	180256009	4107731	
40002	3516	4187458	1964-07-21	1964-07-21 00:00:00	38000275	0	\N	\N	233294	0	415300000	4187458	
52007	4505	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	300025	0	180256009	4107731	
52226	4531	4163872	1949-05-21	1949-05-21 00:00:00	38000275	0	\N	\N	301814	0	399208008	4163872	
40497	3561	4078793	1986-09-15	1986-09-15 00:00:00	38000275	0	\N	\N	236538	0	180325003	4078793	
52576	4559	4024289	1945-12-14	1945-12-14 00:00:00	38000275	0	\N	\N	303766	0	19490002	4024289	
40933	3589	4107731	1994-03-28	1994-03-28 00:00:00	38000275	0	\N	\N	238400	0	180256009	4107731	
29127	2579	4170947	1961-08-31	1961-08-31 00:00:00	38000275	0	\N	\N	170790	0	274474001	4170947	
41249	3622	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	240803	0	395142003	4191853	
53298	4626	4107731	2000-10-06	2000-10-06 00:00:00	38000275	0	\N	\N	308223	0	180256009	4107731	
53610	4646	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	309852	0	180256009	4107731	
53742	4655	4107731	1990-02-18	1990-02-18 00:00:00	38000275	0	\N	\N	310266	0	180256009	4107731	
42042	3703	4197460	1985-03-29	1985-03-29 00:00:00	38000275	0	\N	\N	246256	0	313191000	4197460	
42248	3728	4151422	2005-11-19	2005-11-19 00:00:00	38000275	0	\N	\N	247741	0	269911007	4151422	
54372	4722	4252419	1924-02-17	1924-02-17 00:00:00	38000275	0	\N	\N	314610	0	74016001	4252419	
42511	3752	4163872	1997-12-26	1997-12-26 00:00:00	38000275	0	\N	\N	249365	0	399208008	4163872	
42805	3772	4191853	1993-07-10	1993-07-10 00:00:00	38000275	0	\N	\N	250687	0	395142003	4191853	
54845	4758	4151422	1967-01-22	1967-01-22 00:00:00	38000275	0	\N	\N	316996	0	269911007	4151422	
55103	4800	4243062	1989-07-27	1989-07-27 00:00:00	38000275	0	\N	\N	319296	0	60027007	4243062	
31397	2776	4107731	2006-03-14	2006-03-14 00:00:00	38000275	0	\N	\N	183823	0	180256009	4107731	
43471	3852	4107731	1992-06-01	1992-06-01 00:00:00	38000275	0	\N	\N	255739	0	180256009	4107731	
55609	4844	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	322291	0	180256009	4107731	
55890	4876	4252419	2018-01-19	2018-01-19 00:00:00	38000275	0	\N	\N	324304	0	74016001	4252419	
55961	4881	4202451	2017-03-05	2017-03-05 00:00:00	38000275	0	\N	\N	324558	0	433112001	4202451	
32281	2832	4107731	1994-05-07	1994-05-07 00:00:00	38000275	0	\N	\N	187947	0	180256009	4107731	
56796	4935	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	328064	0	180256009	4107731	
45028	3957	4151422	2006-08-22	2006-08-22 00:00:00	38000275	0	\N	\N	263088	0	269911007	4151422	
33244	2909	4035793	1995-05-07	1995-05-07 00:00:00	38000275	0	\N	\N	193926	0	15081005	4035793	
45328	4005	4125906	1992-09-02	1992-09-02 00:00:00	38000275	0	\N	\N	266084	0	288086009	4125906	
45754	4027	4107731	1993-03-06	1993-03-06 00:00:00	38000275	0	\N	\N	267824	0	180256009	4107731	
46104	4052	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	269300	0	180256009	4107731	
46227	4064	4191853	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	270030	0	395142003	4191853	
46502	4078	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	271069	0	180256009	4107731	
58642	5081	4195803	1989-08-10	1989-08-10 00:00:00	38000275	0	\N	\N	337809	0	312681000	4195803	
58731	5097	4107731	1993-12-26	1993-12-26 00:00:00	38000275	0	\N	\N	338636	0	180256009	4107731	
59112	5118	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	340202	0	180256009	4107731	
59460	5144	4125906	2009-11-14	2009-11-14 00:00:00	38000275	0	\N	\N	341889	0	288086009	4125906	
59516	5150	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	342395	0	180256009	4107731	
47863	4200	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	278779	0	180256009	4107731	
35914	3145	4043071	1980-10-01	1980-10-01 00:00:00	38000275	0	\N	\N	209291	0	228557008	4043071	
48082	4217	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	280047	0	180256009	4107731	
36331	3181	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	211767	0	180256009	4107731	
48503	4256	4163971	1963-11-14	1963-11-14 00:00:00	38000275	0	\N	\N	282589	0	45595009	4163971	
48645	4278	4035793	2012-11-02	2012-11-02 00:00:00	38000275	0	\N	\N	283849	0	15081005	4035793	
37010	3253	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	216332	0	180256009	4107731	
49024	4305	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	285577	0	180256009	4107731	
37374	3293	4330583	1949-03-21	1949-03-21 00:00:00	38000275	0	\N	\N	218672	0	22523008	4330583	
37562	3313	4275113	1980-11-19	1980-11-19 00:00:00	38000275	0	\N	\N	220037	0	65200003	4275113	
61552	5322	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	354191	0	180256009	4107731	
37858	3343	4043071	1986-07-29	1986-07-29 00:00:00	38000275	0	\N	\N	221822	0	228557008	4043071	
50059	4372	4107731	1995-03-16	1995-03-16 00:00:00	38000275	0	\N	\N	290324	0	180256009	4107731	
38279	3371	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	223608	0	180256009	4107731	
50470	4387	4151422	2002-08-04	2002-08-04 00:00:00	38000275	0	\N	\N	291603	0	269911007	4151422	
50553	4391	4058899	2016-11-26	2016-11-26 00:00:00	38000275	0	\N	\N	291943	0	168594001	4058899	
38822	3422	4181917	1980-04-14	1980-04-14 00:00:00	38000275	0	\N	\N	226982	0	54550000	4181917	
50918	4433	4078793	1994-04-16	1994-04-16 00:00:00	38000275	0	\N	\N	294710	0	180325003	4078793	
51379	4452	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	296312	0	180256009	4107731	
27668	2419	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	160522	0	180256009	4107731	
39814	3505	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	232428	0	180256009	4107731	
40003	3516	4252419	2017-03-08	2017-03-08 00:00:00	38000275	0	\N	\N	233369	0	74016001	4252419	
52008	4505	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	300032	0	180256009	4107731	
52227	4531	4047491	1983-07-22	1983-07-22 00:00:00	38000275	0	\N	\N	301707	0	1225002	4047491	
40498	3561	4078793	1999-11-29	1999-11-29 00:00:00	38000275	0	\N	\N	236477	0	180325003	4078793	
52577	4559	4170947	1945-12-14	1945-12-14 00:00:00	38000275	0	\N	\N	303766	0	274474001	4170947	
40934	3589	4107731	1995-04-11	1995-04-11 00:00:00	38000275	0	\N	\N	238465	0	180256009	4107731	
29128	2579	4151422	2000-03-31	2000-03-31 00:00:00	38000275	0	\N	\N	170773	0	269911007	4151422	
41250	3622	4078793	2019-04-03	2019-04-03 00:00:00	38000275	0	\N	\N	240717	0	180325003	4078793	
53299	4626	4107731	1998-10-02	1998-10-02 00:00:00	38000275	0	\N	\N	308217	0	180256009	4107731	
53611	4646	4107731	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	309848	0	180256009	4107731	
53743	4655	4107731	1991-11-10	1991-11-10 00:00:00	38000275	0	\N	\N	310290	0	180256009	4107731	
42043	3703	4107731	1992-02-01	1992-02-01 00:00:00	38000275	0	\N	\N	246206	0	180256009	4107731	
42249	3728	4238715	1994-04-10	1994-04-10 00:00:00	38000275	0	\N	\N	247732	0	68254000	4238715	
54373	4722	4195803	2012-10-14	2012-10-14 00:00:00	38000275	0	\N	\N	314616	0	312681000	4195803	
42512	3752	4170947	1997-12-26	1997-12-26 00:00:00	38000275	0	\N	\N	249365	0	274474001	4170947	
42806	3772	4107731	1993-01-02	1993-01-02 00:00:00	38000275	0	\N	\N	250758	0	180256009	4107731	
54846	4758	4151422	2013-06-09	2013-06-09 00:00:00	38000275	0	\N	\N	316998	0	269911007	4151422	
55104	4800	4243062	1985-10-16	1985-10-16 00:00:00	38000275	0	\N	\N	319295	0	60027007	4243062	
31398	2776	4107731	2008-01-15	2008-01-15 00:00:00	38000275	0	\N	\N	183806	0	180256009	4107731	
43472	3852	4107731	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	255653	0	180256009	4107731	
55610	4844	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	322179	0	180256009	4107731	
55891	4876	4238715	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	324266	0	68254000	4238715	
55962	4881	44783196	1981-12-25	1981-12-25 00:00:00	38000275	0	\N	\N	324523	0	699253003	44783196	
32282	2832	4107731	1996-04-20	1996-04-20 00:00:00	38000275	0	\N	\N	188012	0	180256009	4107731	
56797	4935	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	328055	0	180256009	4107731	
45029	3957	4035793	2014-10-23	2014-10-23 00:00:00	38000275	0	\N	\N	263060	0	15081005	4035793	
33245	2909	4035793	2006-07-09	2006-07-09 00:00:00	38000275	0	\N	\N	193928	0	15081005	4035793	
45329	4005	4293740	1992-09-02	1992-09-02 00:00:00	38000275	0	\N	\N	266084	0	384700001	4293740	
45755	4027	4107731	1990-05-12	1990-05-12 00:00:00	38000275	0	\N	\N	267808	0	180256009	4107731	
46105	4052	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	269407	0	180256009	4107731	
46228	4064	4107731	1993-03-01	1993-03-01 00:00:00	38000275	0	\N	\N	270116	0	180256009	4107731	
46503	4078	4107731	1991-09-23	1991-09-23 00:00:00	38000275	0	\N	\N	271038	0	180256009	4107731	
58643	5081	4243062	1989-08-10	1989-08-10 00:00:00	38000275	0	\N	\N	337809	0	60027007	4243062	
58732	5097	4107731	1994-03-20	1994-03-20 00:00:00	38000275	0	\N	\N	338678	0	180256009	4107731	
59113	5118	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	340227	0	180256009	4107731	
59461	5144	4293740	1968-07-01	1968-07-01 00:00:00	38000275	0	\N	\N	341888	0	384700001	4293740	
59517	5150	4151422	1978-06-24	1978-06-24 00:00:00	38000275	0	\N	\N	342343	0	269911007	4151422	
47864	4200	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	278733	0	180256009	4107731	
35915	3145	4047491	1976-03-01	1976-03-01 00:00:00	38000275	0	\N	\N	209301	0	1225002	4047491	
48083	4217	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	279998	0	180256009	4107731	
36332	3181	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	211648	0	180256009	4107731	
48504	4256	4163951	1963-11-14	1963-11-14 00:00:00	38000275	0	\N	\N	282589	0	29303009	4163951	
48646	4278	4035793	2011-10-28	2011-10-28 00:00:00	38000275	0	\N	\N	283866	0	15081005	4035793	
37011	3253	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	216278	0	180256009	4107731	
49025	4305	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	285529	0	180256009	4107731	
37375	3293	4125906	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	218668	0	288086009	4125906	
37563	3313	4125906	1976-08-28	1976-08-28 00:00:00	38000275	0	\N	\N	219996	0	288086009	4125906	
61553	5322	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	354166	0	180256009	4107731	
37859	3343	4197460	1993-04-11	1993-04-11 00:00:00	38000275	0	\N	\N	221862	0	313191000	4197460	
50060	4372	4107731	1993-11-18	1993-11-18 00:00:00	38000275	0	\N	\N	290263	0	180256009	4107731	
38280	3371	4295880	2005-05-19	2005-05-19 00:00:00	38000275	0	\N	\N	223655	0	76601001	4295880	
50471	4387	4125906	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	291620	0	288086009	4125906	
50554	4391	4125906	1952-11-06	1952-11-06 00:00:00	38000275	0	\N	\N	291939	0	288086009	4125906	
38823	3422	4181917	1980-09-15	1980-09-15 00:00:00	38000275	0	\N	\N	226983	0	54550000	4181917	
50919	4433	4078793	2002-06-01	2002-06-01 00:00:00	38000275	0	\N	\N	294651	0	180325003	4078793	
51380	4452	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	296226	0	180256009	4107731	
27669	2419	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	160518	0	180256009	4107731	
39815	3505	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	232448	0	180256009	4107731	
40004	3516	4145310	1981-12-12	1981-12-12 00:00:00	38000275	0	\N	\N	233367	0	268425006	4145310	
52009	4505	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	300009	0	180256009	4107731	
52228	4531	4195803	1983-07-22	1983-07-22 00:00:00	38000275	0	\N	\N	301707	0	312681000	4195803	
40499	3561	4151422	2002-06-13	2002-06-13 00:00:00	38000275	0	\N	\N	236519	0	269911007	4151422	
52578	4560	4058899	1983-07-06	1983-07-06 00:00:00	38000275	0	\N	\N	303810	0	168594001	4058899	
40935	3589	4163872	2007-03-16	2007-03-16 00:00:00	38000275	0	\N	\N	238459	0	399208008	4163872	
29129	2579	4198190	2008-04-07	2008-04-07 00:00:00	38000275	0	\N	\N	170789	0	80146002	4198190	
41251	3622	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	240742	0	180256009	4107731	
53300	4626	4107731	1998-11-13	1998-11-13 00:00:00	38000275	0	\N	\N	308218	0	180256009	4107731	
53612	4646	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	309847	0	180256009	4107731	
53744	4655	4107731	1993-03-28	1993-03-28 00:00:00	38000275	0	\N	\N	310333	0	180256009	4107731	
42044	3703	4107731	1990-12-08	1990-12-08 00:00:00	38000275	0	\N	\N	246264	0	180256009	4107731	
42252	3730	4058899	2002-07-23	2002-07-23 00:00:00	38000275	0	\N	\N	247808	0	168594001	4058899	
54374	4722	4047491	2012-10-14	2012-10-14 00:00:00	38000275	0	\N	\N	314616	0	1225002	4047491	
42513	3754	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	249508	0	180256009	4107731	
42807	3772	4107731	1992-04-04	1992-04-04 00:00:00	38000275	0	\N	\N	250736	0	180256009	4107731	
54847	4758	4047491	1999-11-11	1999-11-11 00:00:00	38000275	0	\N	\N	316969	0	1225002	4047491	
55105	4800	4170947	1985-10-16	1985-10-16 00:00:00	38000275	0	\N	\N	319295	0	274474001	4170947	
31399	2776	4107731	2008-11-25	2008-11-25 00:00:00	38000275	0	\N	\N	183810	0	180256009	4107731	
43473	3852	4107731	1991-07-22	1991-07-22 00:00:00	38000275	0	\N	\N	255675	0	180256009	4107731	
55611	4844	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	322215	0	180256009	4107731	
55892	4878	4107731	1990-06-23	1990-06-23 00:00:00	38000275	0	\N	\N	324340	0	180256009	4107731	
55963	4881	4252419	1981-12-18	1981-12-18 00:00:00	38000275	0	\N	\N	324545	0	74016001	4252419	
32283	2832	4107731	1994-11-12	1994-11-12 00:00:00	38000275	0	\N	\N	187901	0	180256009	4107731	
45030	3957	4035793	2016-11-03	2016-11-03 00:00:00	38000275	0	\N	\N	263105	0	15081005	4035793	
33246	2909	4035793	1988-04-17	1988-04-17 00:00:00	38000275	0	\N	\N	193852	0	15081005	4035793	
45330	4005	4125906	2006-11-23	2006-11-23 00:00:00	38000275	0	\N	\N	266086	0	288086009	4125906	
45756	4027	4107731	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	267899	0	180256009	4107731	
46106	4052	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	269380	0	180256009	4107731	
46229	4064	4107731	1992-02-17	1992-02-17 00:00:00	38000275	0	\N	\N	270039	0	180256009	4107731	
46504	4078	4107731	1990-01-22	1990-01-22 00:00:00	38000275	0	\N	\N	270979	0	180256009	4107731	
58644	5081	4170947	1989-08-10	1989-08-10 00:00:00	38000275	0	\N	\N	337809	0	274474001	4170947	
58733	5097	4107731	1995-04-23	1995-04-23 00:00:00	38000275	0	\N	\N	338741	0	180256009	4107731	
59114	5118	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	340191	0	395142003	4191853	
59462	5144	4125906	1968-07-01	1968-07-01 00:00:00	38000275	0	\N	\N	341888	0	288086009	4125906	
59518	5150	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	342472	0	180256009	4107731	
47865	4200	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	278830	0	180256009	4107731	
35916	3145	4170947	1976-03-01	1976-03-01 00:00:00	38000275	0	\N	\N	209301	0	274474001	4170947	
48084	4217	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	279926	0	180256009	4107731	
36333	3181	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	211669	0	180256009	4107731	
48505	4256	4252419	2009-12-26	2009-12-26 00:00:00	38000275	0	\N	\N	282635	0	74016001	4252419	
48647	4278	4035793	2014-11-14	2014-11-14 00:00:00	38000275	0	\N	\N	283850	0	15081005	4035793	
37012	3253	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	216302	0	180256009	4107731	
49026	4305	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	285585	0	180256009	4107731	
37376	3293	4058899	2005-06-23	2005-06-23 00:00:00	38000275	0	\N	\N	218697	0	168594001	4058899	
37564	3313	4151422	1978-03-31	1978-03-31 00:00:00	38000275	0	\N	\N	220035	0	269911007	4151422	
61554	5322	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	354232	0	180256009	4107731	
37860	3343	4043071	1986-09-02	1986-09-02 00:00:00	38000275	0	\N	\N	221775	0	228557008	4043071	
50061	4372	4107731	1994-07-28	1994-07-28 00:00:00	38000275	0	\N	\N	290322	0	180256009	4107731	
38281	3371	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	223611	0	180256009	4107731	
50472	4388	4252419	1996-10-21	1996-10-21 00:00:00	38000275	0	\N	\N	291643	0	74016001	4252419	
50555	4391	4252419	2012-09-18	2012-09-18 00:00:00	38000275	0	\N	\N	291942	0	74016001	4252419	
38824	3422	40492359	1973-11-12	1973-11-12 00:00:00	38000275	0	\N	\N	226979	0	447365002	40492359	
50920	4433	4078793	2000-05-20	2000-05-20 00:00:00	38000275	0	\N	\N	294742	0	180325003	4078793	
51381	4452	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	296214	0	395142003	4191853	
27670	2419	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	160539	0	180256009	4107731	
39816	3505	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	232521	0	180256009	4107731	
40005	3516	44783196	2017-03-15	2017-03-15 00:00:00	38000275	0	\N	\N	233350	0	699253003	44783196	
52010	4505	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	299986	0	180256009	4107731	
52229	4531	4170947	1983-07-22	1983-07-22 00:00:00	38000275	0	\N	\N	301707	0	274474001	4170947	
40500	3561	4078793	1984-09-03	1984-09-03 00:00:00	38000275	0	\N	\N	236443	0	180325003	4078793	
52579	4560	4198190	1977-10-30	1977-10-30 00:00:00	38000275	0	\N	\N	303812	0	80146002	4198190	
40936	3589	4107731	1994-07-12	1994-07-12 00:00:00	38000275	0	\N	\N	238431	0	180256009	4107731	
29130	2580	4163872	2015-08-21	2015-08-21 00:00:00	38000275	0	\N	\N	170868	0	399208008	4163872	
41252	3622	4078793	2014-04-02	2014-04-02 00:00:00	38000275	0	\N	\N	240766	0	180325003	4078793	
53301	4626	4107731	1998-10-23	1998-10-23 00:00:00	38000275	0	\N	\N	308153	0	180256009	4107731	
53613	4646	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	309846	0	180256009	4107731	
53745	4655	4107731	1991-08-18	1991-08-18 00:00:00	38000275	0	\N	\N	310288	0	180256009	4107731	
42045	3703	4107731	1992-04-04	1992-04-04 00:00:00	38000275	0	\N	\N	246294	0	180256009	4107731	
42253	3730	4057420	1994-07-28	1994-07-28 00:00:00	38000275	0	\N	\N	247807	0	18286008	4057420	
54375	4722	4170947	2012-10-14	2012-10-14 00:00:00	38000275	0	\N	\N	314616	0	274474001	4170947	
42514	3754	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	249474	0	180256009	4107731	
42808	3772	4107731	1993-03-06	1993-03-06 00:00:00	38000275	0	\N	\N	250713	0	180256009	4107731	
54848	4758	4170947	1999-11-11	1999-11-11 00:00:00	38000275	0	\N	\N	316969	0	274474001	4170947	
55106	4801	4275113	1987-07-14	1987-07-14 00:00:00	38000275	0	\N	\N	319393	0	65200003	4275113	
31400	2776	4107731	2007-10-23	2007-10-23 00:00:00	38000275	0	\N	\N	183830	0	180256009	4107731	
43474	3852	4107731	1992-12-28	1992-12-28 00:00:00	38000275	0	\N	\N	255679	0	180256009	4107731	
55612	4844	4197460	1973-10-17	1973-10-17 00:00:00	38000275	0	\N	\N	322280	0	313191000	4197460	
55893	4878	4107731	1991-06-15	1991-06-15 00:00:00	38000275	0	\N	\N	324358	0	180256009	4107731	
55967	4883	4293740	1975-06-13	1975-06-13 00:00:00	38000275	0	\N	\N	324681	0	384700001	4293740	
32284	2832	4107731	1995-12-16	1995-12-16 00:00:00	38000275	0	\N	\N	187924	0	180256009	4107731	
45031	3957	4035793	2011-10-06	2011-10-06 00:00:00	38000275	0	\N	\N	263061	0	15081005	4035793	
33247	2909	4035793	2005-07-03	2005-07-03 00:00:00	38000275	0	\N	\N	193880	0	15081005	4035793	
45331	4006	4202451	2016-08-02	2016-08-02 00:00:00	38000275	0	\N	\N	266192	0	433112001	4202451	
45757	4027	4107731	1990-12-08	1990-12-08 00:00:00	38000275	0	\N	\N	267836	0	180256009	4107731	
46107	4052	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	269392	0	180256009	4107731	
46230	4064	4107731	1990-12-03	1990-12-03 00:00:00	38000275	0	\N	\N	269975	0	180256009	4107731	
46505	4078	4107731	1991-11-04	1991-11-04 00:00:00	38000275	0	\N	\N	270989	0	180256009	4107731	
58645	5081	4125906	1939-03-21	1939-03-21 00:00:00	38000275	0	\N	\N	337900	0	288086009	4125906	
58734	5097	4107731	1995-02-19	1995-02-19 00:00:00	38000275	0	\N	\N	338706	0	180256009	4107731	
59115	5118	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	340195	0	180256009	4107731	
59463	5145	40492359	2018-01-13	2018-01-13 00:00:00	38000275	0	\N	\N	342080	0	447365002	40492359	
59519	5150	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	342381	0	180256009	4107731	
47866	4200	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	278823	0	180256009	4107731	
35917	3145	4043071	1980-11-05	1980-11-05 00:00:00	38000275	0	\N	\N	209292	0	228557008	4043071	
48085	4217	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	280024	0	180256009	4107731	
36334	3181	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	211802	0	180256009	4107731	
48506	4256	4170947	1961-04-21	1961-04-21 00:00:00	38000275	0	\N	\N	282588	0	274474001	4170947	
48648	4278	4035793	2007-10-05	2007-10-05 00:00:00	38000275	0	\N	\N	283861	0	15081005	4035793	
37013	3253	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	216389	0	180256009	4107731	
49027	4305	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	285576	0	180256009	4107731	
37377	3293	4195803	2005-06-23	2005-06-23 00:00:00	38000275	0	\N	\N	218697	0	312681000	4195803	
37565	3314	4151422	1986-08-05	1986-08-05 00:00:00	38000275	0	\N	\N	220076	0	269911007	4151422	
61555	5322	4058899	2014-03-18	2014-03-18 00:00:00	38000275	0	\N	\N	354264	0	168594001	4058899	
37861	3343	4107731	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	221728	0	180256009	4107731	
50062	4372	4107731	1995-06-08	1995-06-08 00:00:00	38000275	0	\N	\N	290326	0	180256009	4107731	
38282	3371	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	223556	0	180256009	4107731	
50473	4388	4163872	1981-06-03	1981-06-03 00:00:00	38000275	0	\N	\N	291736	0	399208008	4163872	
50556	4392	4293740	2001-09-18	2001-09-18 00:00:00	38000275	0	\N	\N	292085	0	384700001	4293740	
38825	3422	4057420	1973-11-12	1973-11-12 00:00:00	38000275	0	\N	\N	226979	0	18286008	4057420	
50921	4433	4078793	2012-07-28	2012-07-28 00:00:00	38000275	0	\N	\N	294713	0	180325003	4078793	
51382	4452	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	296284	0	180256009	4107731	
27671	2419	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	160494	0	180256009	4107731	
39817	3505	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	232442	0	180256009	4107731	
40006	3516	4195803	1996-09-24	1996-09-24 00:00:00	38000275	0	\N	\N	233368	0	312681000	4195803	
52011	4505	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	300115	0	180256009	4107731	
52230	4531	4195803	2004-12-25	2004-12-25 00:00:00	38000275	0	\N	\N	301781	0	312681000	4195803	
40501	3561	4078793	2010-09-20	2010-09-20 00:00:00	38000275	0	\N	\N	236552	0	180325003	4078793	
52580	4561	4024289	1988-08-20	1988-08-20 00:00:00	38000275	0	\N	\N	303948	0	19490002	4024289	
40937	3589	4107731	1994-01-24	1994-01-24 00:00:00	38000275	0	\N	\N	238476	0	180256009	4107731	
29131	2580	4151422	1989-07-29	1989-07-29 00:00:00	38000275	0	\N	\N	170923	0	269911007	4151422	
41253	3622	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	240730	0	180256009	4107731	
53302	4626	4107731	1999-05-21	1999-05-21 00:00:00	38000275	0	\N	\N	308264	0	180256009	4107731	
53614	4646	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	309768	0	180256009	4107731	
53746	4656	4293740	1989-05-12	1989-05-12 00:00:00	38000275	0	\N	\N	310470	0	384700001	4293740	
42046	3703	4107731	1990-05-12	1990-05-12 00:00:00	38000275	0	\N	\N	246248	0	180256009	4107731	
42254	3730	40492359	1994-07-28	1994-07-28 00:00:00	38000275	0	\N	\N	247807	0	447365002	40492359	
54381	4724	4275113	1969-02-25	1969-02-25 00:00:00	38000275	0	\N	\N	314764	0	65200003	4275113	
42515	3754	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	249519	0	180256009	4107731	
42809	3772	4107731	1990-03-31	1990-03-31 00:00:00	38000275	0	\N	\N	250680	0	180256009	4107731	
54849	4758	4125906	1987-06-05	1987-06-05 00:00:00	38000275	0	\N	\N	316966	0	288086009	4125906	
55107	4801	4238715	1991-08-03	1991-08-03 00:00:00	38000275	0	\N	\N	319394	0	68254000	4238715	
31401	2776	4151422	1987-03-01	1987-03-01 00:00:00	38000275	0	\N	\N	183774	0	269911007	4151422	
43475	3852	4107731	1992-08-03	1992-08-03 00:00:00	38000275	0	\N	\N	255750	0	180256009	4107731	
55613	4844	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	322264	0	180256009	4107731	
55894	4878	4107731	1991-05-04	1991-05-04 00:00:00	38000275	0	\N	\N	324357	0	180256009	4107731	
55968	4883	4125906	1975-06-13	1975-06-13 00:00:00	38000275	0	\N	\N	324681	0	288086009	4125906	
32285	2832	4107731	1994-10-01	1994-10-01 00:00:00	38000275	0	\N	\N	187900	0	180256009	4107731	
45032	3957	4035793	2009-09-24	2009-09-24 00:00:00	38000275	0	\N	\N	263069	0	15081005	4035793	
33248	2909	4035793	1996-05-12	1996-05-12 00:00:00	38000275	0	\N	\N	193868	0	15081005	4035793	
45332	4006	4170947	1997-12-09	1997-12-09 00:00:00	38000275	0	\N	\N	266145	0	274474001	4170947	
45758	4027	4107731	1991-03-23	1991-03-23 00:00:00	38000275	0	\N	\N	267891	0	180256009	4107731	
46108	4052	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	269325	0	180256009	4107731	
46231	4064	4107731	1992-07-13	1992-07-13 00:00:00	38000275	0	\N	\N	269982	0	180256009	4107731	
46506	4078	4107731	1990-06-18	1990-06-18 00:00:00	38000275	0	\N	\N	271062	0	180256009	4107731	
58646	5081	4057420	1935-05-17	1935-05-17 00:00:00	38000275	0	\N	\N	337899	0	18286008	4057420	
58735	5097	4107731	1993-01-24	1993-01-24 00:00:00	38000275	0	\N	\N	338718	0	180256009	4107731	
59116	5118	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	340279	0	180256009	4107731	
59464	5145	4057420	2018-01-13	2018-01-13 00:00:00	38000275	0	\N	\N	342080	0	18286008	4057420	
59520	5150	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	342463	0	180256009	4107731	
47867	4200	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	278758	0	180256009	4107731	
35919	3147	4035793	2002-03-11	2002-03-11 00:00:00	38000275	0	\N	\N	209407	0	15081005	4035793	
48086	4217	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	279991	0	180256009	4107731	
36335	3181	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	211752	0	180256009	4107731	
48507	4256	4243062	1961-04-21	1961-04-21 00:00:00	38000275	0	\N	\N	282588	0	60027007	4243062	
48649	4278	4035793	2006-09-29	2006-09-29 00:00:00	38000275	0	\N	\N	283929	0	15081005	4035793	
37014	3253	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	216383	0	395142003	4191853	
49028	4305	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	285553	0	180256009	4107731	
37378	3293	4170947	1996-11-07	1996-11-07 00:00:00	38000275	0	\N	\N	218695	0	274474001	4170947	
37566	3314	4058899	1976-08-25	1976-08-25 00:00:00	38000275	0	\N	\N	220084	0	168594001	4058899	
61556	5322	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	354239	0	180256009	4107731	
37862	3343	4043071	1987-11-24	1987-11-24 00:00:00	38000275	0	\N	\N	221835	0	228557008	4043071	
50063	4372	4107731	1995-09-21	1995-09-21 00:00:00	38000275	0	\N	\N	290304	0	180256009	4107731	
38283	3371	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	223596	0	180256009	4107731	
50474	4388	4047491	1975-01-15	1975-01-15 00:00:00	38000275	0	\N	\N	291638	0	1225002	4047491	
50557	4392	4125906	2001-09-18	2001-09-18 00:00:00	38000275	0	\N	\N	292085	0	288086009	4125906	
38826	3422	4191853	1994-01-09	1994-01-09 00:00:00	38000275	0	\N	\N	227027	0	395142003	4191853	
50922	4433	4078793	1993-07-17	1993-07-17 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
51383	4452	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	296296	0	180256009	4107731	
27672	2419	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	160605	0	180256009	4107731	
39818	3505	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	232525	0	180256009	4107731	
40007	3516	4058899	1996-09-24	1996-09-24 00:00:00	38000275	0	\N	\N	233368	0	168594001	4058899	
52012	4505	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	299970	0	180256009	4107731	
52231	4531	4125906	2017-04-15	2017-04-15 00:00:00	38000275	0	\N	\N	301710	0	288086009	4125906	
40502	3561	4078793	2003-12-22	2003-12-22 00:00:00	38000275	0	\N	\N	236479	0	180325003	4078793	
52581	4561	4170947	1988-08-20	1988-08-20 00:00:00	38000275	0	\N	\N	303948	0	274474001	4170947	
40938	3589	4107731	1995-11-06	1995-11-06 00:00:00	38000275	0	\N	\N	238490	0	180256009	4107731	
29132	2580	4151422	1991-10-03	1991-10-03 00:00:00	38000275	0	\N	\N	170882	0	269911007	4151422	
41254	3622	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	240738	0	180256009	4107731	
53303	4626	4191853	1997-11-21	1997-11-21 00:00:00	38000275	0	\N	\N	308259	0	395142003	4191853	
53615	4646	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	309766	0	180256009	4107731	
53747	4656	4125906	1989-05-12	1989-05-12 00:00:00	38000275	0	\N	\N	310470	0	288086009	4125906	
42047	3703	4107731	1991-10-19	1991-10-19 00:00:00	38000275	0	\N	\N	246238	0	180256009	4107731	
42255	3731	44783196	1984-08-03	1984-08-03 00:00:00	38000275	0	\N	\N	247956	0	699253003	44783196	
54382	4724	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	314670	0	180256009	4107731	
42516	3754	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	249517	0	180256009	4107731	
42810	3772	4197460	1983-01-03	1983-01-03 00:00:00	38000275	0	\N	\N	250672	0	313191000	4197460	
54850	4758	4057420	1989-08-13	1989-08-13 00:00:00	38000275	0	\N	\N	316967	0	18286008	4057420	
55108	4801	4058899	1983-03-23	1983-03-23 00:00:00	38000275	0	\N	\N	319421	0	168594001	4058899	
31402	2776	4107731	2006-04-25	2006-04-25 00:00:00	38000275	0	\N	\N	183833	0	180256009	4107731	
43476	3852	4107731	1990-12-03	1990-12-03 00:00:00	38000275	0	\N	\N	255654	0	180256009	4107731	
55614	4844	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	322232	0	180256009	4107731	
55895	4878	4107731	1990-11-17	1990-11-17 00:00:00	38000275	0	\N	\N	324407	0	180256009	4107731	
55969	4883	4170947	1973-04-24	1973-04-24 00:00:00	38000275	0	\N	\N	324680	0	274474001	4170947	
32286	2832	4107731	1997-05-24	1997-05-24 00:00:00	38000275	0	\N	\N	187998	0	180256009	4107731	
45033	3957	4125906	1988-04-01	1988-04-01 00:00:00	38000275	0	\N	\N	263063	0	288086009	4125906	
33249	2909	4035793	1978-04-02	1978-04-02 00:00:00	38000275	0	\N	\N	193917	0	15081005	4035793	
45333	4006	4243062	1997-12-09	1997-12-09 00:00:00	38000275	0	\N	\N	266145	0	60027007	4243062	
45759	4027	4191853	1975-02-13	1975-02-13 00:00:00	38000275	0	\N	\N	267867	0	395142003	4191853	
46109	4052	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	269322	0	180256009	4107731	
46232	4064	4107731	1991-11-04	1991-11-04 00:00:00	38000275	0	\N	\N	270082	0	180256009	4107731	
46507	4078	4107731	1991-12-16	1991-12-16 00:00:00	38000275	0	\N	\N	270990	0	180256009	4107731	
58647	5081	40492359	1935-05-17	1935-05-17 00:00:00	38000275	0	\N	\N	337899	0	447365002	40492359	
58736	5097	4107731	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	338674	0	180256009	4107731	
59117	5118	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	340236	0	180256009	4107731	
59465	5145	4058899	2001-11-26	2001-11-26 00:00:00	38000275	0	\N	\N	342079	0	168594001	4058899	
59521	5150	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	342397	0	180256009	4107731	
47868	4200	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	278803	0	180256009	4107731	
35920	3147	4330583	1979-02-09	1979-02-09 00:00:00	38000275	0	\N	\N	209342	0	22523008	4330583	
48087	4217	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	279938	0	180256009	4107731	
36336	3181	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	211820	0	180256009	4107731	
48508	4256	44783196	2010-01-02	2010-01-02 00:00:00	38000275	0	\N	\N	282590	0	699253003	44783196	
48650	4278	4035793	2000-08-25	2000-08-25 00:00:00	38000275	0	\N	\N	283888	0	15081005	4035793	
37015	3253	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	216331	0	180256009	4107731	
49029	4305	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	285613	0	180256009	4107731	
37379	3293	4163872	1996-11-07	1996-11-07 00:00:00	38000275	0	\N	\N	218695	0	399208008	4163872	
37567	3315	44783196	2006-09-24	2006-09-24 00:00:00	38000275	0	\N	\N	220134	0	699253003	44783196	
61557	5322	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	354154	0	180256009	4107731	
37863	3343	4043071	1986-03-25	1986-03-25 00:00:00	38000275	0	\N	\N	221847	0	228557008	4043071	
50064	4372	4107731	1996-03-07	1996-03-07 00:00:00	38000275	0	\N	\N	290229	0	180256009	4107731	
38284	3371	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	223566	0	180256009	4107731	
50475	4388	4170947	1975-01-15	1975-01-15 00:00:00	38000275	0	\N	\N	291638	0	274474001	4170947	
50558	4392	4295880	1998-01-09	1998-01-09 00:00:00	38000275	0	\N	\N	292068	0	76601001	4295880	
38827	3423	4198190	2007-03-14	2007-03-14 00:00:00	38000275	0	\N	\N	227090	0	80146002	4198190	
50923	4433	4078793	2008-07-05	2008-07-05 00:00:00	38000275	0	\N	\N	294653	0	180325003	4078793	
51384	4452	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	296220	0	180256009	4107731	
27673	2419	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	160512	0	180256009	4107731	
39819	3505	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	232520	0	180256009	4107731	
40008	3516	4198190	1950-07-26	1950-07-26 00:00:00	38000275	0	\N	\N	233390	0	80146002	4198190	
52013	4506	4151422	1964-09-20	1964-09-20 00:00:00	38000275	0	\N	\N	300204	0	269911007	4151422	
52232	4531	4293740	2017-04-15	2017-04-15 00:00:00	38000275	0	\N	\N	301710	0	384700001	4293740	
40503	3561	4078793	1981-08-17	1981-08-17 00:00:00	38000275	0	\N	\N	236466	0	180325003	4078793	
52582	4562	4252419	1984-12-28	1984-12-28 00:00:00	38000275	0	\N	\N	303955	0	74016001	4252419	
40939	3589	4107731	1996-02-19	1996-02-19 00:00:00	38000275	0	\N	\N	238469	0	180256009	4107731	
29133	2580	4057420	1979-05-07	1979-05-07 00:00:00	38000275	0	\N	\N	170920	0	18286008	4057420	
41255	3622	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	240799	0	180256009	4107731	
53304	4626	4107731	2000-02-18	2000-02-18 00:00:00	38000275	0	\N	\N	308267	0	180256009	4107731	
53616	4646	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	309756	0	180256009	4107731	
53748	4656	4195803	2009-11-08	2009-11-08 00:00:00	38000275	0	\N	\N	310440	0	312681000	4195803	
42048	3703	4107731	1992-02-22	1992-02-22 00:00:00	38000275	0	\N	\N	246241	0	180256009	4107731	
42256	3731	4170947	1989-03-31	1989-03-31 00:00:00	38000275	0	\N	\N	247937	0	274474001	4170947	
54383	4724	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	314776	0	180256009	4107731	
42517	3754	4191853	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	249539	0	395142003	4191853	
42811	3772	4107731	1990-03-10	1990-03-10 00:00:00	38000275	0	\N	\N	250649	0	180256009	4107731	
54851	4758	40492359	1989-08-13	1989-08-13 00:00:00	38000275	0	\N	\N	316967	0	447365002	40492359	
55109	4801	4125906	1991-01-10	1991-01-10 00:00:00	38000275	0	\N	\N	319422	0	288086009	4125906	
31403	2776	4107731	2006-01-10	2006-01-10 00:00:00	38000275	0	\N	\N	183770	0	180256009	4107731	
43477	3852	4107731	1992-12-07	1992-12-07 00:00:00	38000275	0	\N	\N	255740	0	180256009	4107731	
55615	4844	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	322292	0	180256009	4107731	
55896	4878	4107731	1990-07-14	1990-07-14 00:00:00	38000275	0	\N	\N	324348	0	180256009	4107731	
55970	4883	4024289	1973-04-24	1973-04-24 00:00:00	38000275	0	\N	\N	324680	0	19490002	4024289	
32287	2832	4107731	1995-06-10	1995-06-10 00:00:00	38000275	0	\N	\N	188008	0	180256009	4107731	
45034	3957	4058899	1964-05-07	1964-05-07 00:00:00	38000275	0	\N	\N	263144	0	168594001	4058899	
33250	2909	4035793	2007-07-15	2007-07-15 00:00:00	38000275	0	\N	\N	193881	0	15081005	4035793	
45409	4009	4181917	2006-01-09	2006-01-09 00:00:00	38000275	0	\N	\N	266440	0	54550000	4181917	
45760	4027	4107731	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	267785	0	180256009	4107731	
46110	4052	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	269406	0	180256009	4107731	
46233	4064	4107731	1990-01-22	1990-01-22 00:00:00	38000275	0	\N	\N	270076	0	180256009	4107731	
46508	4078	4107731	1992-03-09	1992-03-09 00:00:00	38000275	0	\N	\N	270987	0	180256009	4107731	
58648	5081	4125906	1986-09-04	1986-09-04 00:00:00	38000275	0	\N	\N	337905	0	288086009	4125906	
58737	5097	4191853	1996-01-21	1996-01-21 00:00:00	38000275	0	\N	\N	338744	0	395142003	4191853	
59118	5118	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	340205	0	180256009	4107731	
59466	5145	4125906	1968-04-04	1968-04-04 00:00:00	38000275	0	\N	\N	342077	0	288086009	4125906	
59522	5150	4163872	1979-10-03	1979-10-03 00:00:00	38000275	0	\N	\N	342344	0	399208008	4163872	
47869	4200	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	278769	0	180256009	4107731	
35921	3147	4337138	2003-04-28	2003-04-28 00:00:00	38000275	0	\N	\N	209420	0	88039007	4337138	
48088	4217	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	280026	0	180256009	4107731	
36337	3181	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	211646	0	180256009	4107731	
48509	4256	4125906	1974-09-10	1974-09-10 00:00:00	38000275	0	\N	\N	282634	0	288086009	4125906	
48651	4278	4125906	1959-02-05	1959-02-05 00:00:00	38000275	0	\N	\N	283930	0	288086009	4125906	
37016	3253	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	216254	0	180256009	4107731	
49030	4305	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	285616	0	395142003	4191853	
37380	3293	4195803	1996-11-07	1996-11-07 00:00:00	38000275	0	\N	\N	218695	0	312681000	4195803	
37568	3315	4125906	1983-03-08	1983-03-08 00:00:00	38000275	0	\N	\N	220131	0	288086009	4125906	
61558	5322	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	354198	0	180256009	4107731	
37864	3343	4107731	1993-03-28	1993-03-28 00:00:00	38000275	0	\N	\N	221857	0	180256009	4107731	
50065	4372	4107731	1994-09-08	1994-09-08 00:00:00	38000275	0	\N	\N	290237	0	180256009	4107731	
38285	3371	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	223647	0	180256009	4107731	
50476	4388	4125906	1971-03-02	1971-03-02 00:00:00	38000275	0	\N	\N	291636	0	288086009	4125906	
50559	4392	4125906	1997-07-27	1997-07-27 00:00:00	38000275	0	\N	\N	292084	0	288086009	4125906	
38828	3423	4125906	1989-12-02	1989-12-02 00:00:00	38000275	0	\N	\N	227094	0	288086009	4125906	
50924	4433	4078793	1993-04-10	1993-04-10 00:00:00	38000275	0	\N	\N	294693	0	180325003	4078793	
51385	4452	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	296276	0	180256009	4107731	
27674	2419	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	160557	0	180256009	4107731	
39820	3505	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	232528	0	180256009	4107731	
40009	3516	4151422	1984-06-10	1984-06-10 00:00:00	38000275	0	\N	\N	233325	0	269911007	4151422	
52014	4506	4151422	1980-03-20	1980-03-20 00:00:00	38000275	0	\N	\N	300222	0	269911007	4151422	
52233	4531	4202451	1965-01-09	1965-01-09 00:00:00	38000275	0	\N	\N	301695	0	433112001	4202451	
40504	3561	4078793	2009-09-14	2009-09-14 00:00:00	38000275	0	\N	\N	236568	0	180325003	4078793	
52583	4562	4062501	1964-02-04	1964-02-04 00:00:00	38000275	0	\N	\N	304011	0	171231001	4062501	
40940	3589	4107731	1997-03-03	1997-03-03 00:00:00	38000275	0	\N	\N	238425	0	180256009	4107731	
29134	2580	40492359	1979-05-07	1979-05-07 00:00:00	38000275	0	\N	\N	170920	0	447365002	40492359	
41256	3622	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	240807	0	180256009	4107731	
53305	4626	4107731	2000-12-29	2000-12-29 00:00:00	38000275	0	\N	\N	308185	0	180256009	4107731	
53617	4646	4010253	1971-01-13	1971-01-13 00:00:00	38000275	0	\N	\N	309761	0	112790001	4010253	
53749	4656	4216130	2008-06-29	2008-06-29 00:00:00	38000275	0	\N	\N	310471	0	415070008	4216130	
42049	3703	4107731	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	246207	0	180256009	4107731	
42257	3731	4024289	1989-03-31	1989-03-31 00:00:00	38000275	0	\N	\N	247937	0	19490002	4024289	
54384	4724	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	314694	0	180256009	4107731	
42518	3754	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	249423	0	180256009	4107731	
42812	3772	4107731	1992-06-06	1992-06-06 00:00:00	38000275	0	\N	\N	250658	0	180256009	4107731	
54852	4758	4125906	1991-05-06	1991-05-06 00:00:00	38000275	0	\N	\N	316968	0	288086009	4125906	
55110	4801	4058899	2016-12-08	2016-12-08 00:00:00	38000275	0	\N	\N	319401	0	168594001	4058899	
31404	2776	4107731	2007-03-27	2007-03-27 00:00:00	38000275	0	\N	\N	183841	0	180256009	4107731	
43478	3852	4151422	1965-11-25	1965-11-25 00:00:00	38000275	0	\N	\N	255628	0	269911007	4151422	
55616	4844	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	322213	0	180256009	4107731	
55897	4878	4107731	1992-02-01	1992-02-01 00:00:00	38000275	0	\N	\N	324359	0	180256009	4107731	
55971	4883	4163872	2008-08-15	2008-08-15 00:00:00	38000275	0	\N	\N	324643	0	399208008	4163872	
32288	2832	4107731	1997-07-26	1997-07-26 00:00:00	38000275	0	\N	\N	187931	0	180256009	4107731	
45035	3958	4125906	1996-10-07	1996-10-07 00:00:00	38000275	0	\N	\N	263175	0	288086009	4125906	
33251	2909	4035793	1997-05-18	1997-05-18 00:00:00	38000275	0	\N	\N	193921	0	15081005	4035793	
45410	4009	4181917	2005-07-26	2005-07-26 00:00:00	38000275	0	\N	\N	266396	0	54550000	4181917	
45761	4027	4107731	1992-10-10	1992-10-10 00:00:00	38000275	0	\N	\N	267797	0	180256009	4107731	
46111	4052	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	269408	0	180256009	4107731	
46234	4064	4107731	1991-04-29	1991-04-29 00:00:00	38000275	0	\N	\N	270003	0	180256009	4107731	
46509	4078	4107731	1992-06-22	1992-06-22 00:00:00	38000275	0	\N	\N	271041	0	180256009	4107731	
58649	5081	4195803	2004-11-19	2004-11-19 00:00:00	38000275	0	\N	\N	337810	0	312681000	4195803	
58738	5097	4107731	1992-11-01	1992-11-01 00:00:00	38000275	0	\N	\N	338660	0	180256009	4107731	
59119	5118	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	340278	0	180256009	4107731	
59523	5150	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	342477	0	180256009	4107731	
47870	4200	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	278743	0	180256009	4107731	
35922	3147	4125906	2014-07-28	2014-07-28 00:00:00	38000275	0	\N	\N	209429	0	288086009	4125906	
48089	4217	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	279937	0	180256009	4107731	
36338	3181	4062501	1953-09-20	1953-09-20 00:00:00	38000275	0	\N	\N	211630	0	171231001	4062501	
48515	4260	4151422	1968-12-19	1968-12-19 00:00:00	38000275	0	\N	\N	282755	0	269911007	4151422	
48652	4278	4125906	1995-06-08	1995-06-08 00:00:00	38000275	0	\N	\N	283934	0	288086009	4125906	
37017	3253	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	216339	0	180256009	4107731	
49031	4305	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	285578	0	180256009	4107731	
37381	3293	4195803	2000-10-17	2000-10-17 00:00:00	38000275	0	\N	\N	218696	0	312681000	4195803	
37569	3315	4252419	2006-09-17	2006-09-17 00:00:00	38000275	0	\N	\N	220132	0	74016001	4252419	
61559	5322	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	354150	0	180256009	4107731	
37865	3343	4107731	1992-02-23	1992-02-23 00:00:00	38000275	0	\N	\N	221759	0	180256009	4107731	
50066	4372	4107731	1993-12-09	1993-12-09 00:00:00	38000275	0	\N	\N	290249	0	180256009	4107731	
38286	3371	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	223613	0	180256009	4107731	
50477	4388	4170947	1968-05-11	1968-05-11 00:00:00	38000275	0	\N	\N	291634	0	274474001	4170947	
50560	4392	4295880	1998-04-10	1998-04-10 00:00:00	38000275	0	\N	\N	292063	0	76601001	4295880	
38829	3423	4151422	2010-10-25	2010-10-25 00:00:00	38000275	0	\N	\N	227059	0	269911007	4151422	
50925	4433	4057420	2001-05-26	2001-05-26 00:00:00	38000275	0	\N	\N	294682	0	18286008	4057420	
51386	4452	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	296250	0	180256009	4107731	
27675	2419	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	160514	0	180256009	4107731	
39821	3505	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	232500	0	180256009	4107731	
51800	4490	4125906	1956-02-09	1956-02-09 00:00:00	38000275	0	\N	\N	298885	0	288086009	4125906	
52015	4506	4145310	2001-10-13	2001-10-13 00:00:00	38000275	0	\N	\N	300228	0	268425006	4145310	
52234	4531	4170947	1995-04-20	1995-04-20 00:00:00	38000275	0	\N	\N	301708	0	274474001	4170947	
40505	3561	4078793	1992-10-19	1992-10-19 00:00:00	38000275	0	\N	\N	236444	0	180325003	4078793	
52584	4562	4125906	1966-07-01	1966-07-01 00:00:00	38000275	0	\N	\N	303951	0	288086009	4125906	
40941	3589	4107731	1997-03-24	1997-03-24 00:00:00	38000275	0	\N	\N	238442	0	180256009	4107731	
29135	2580	4151422	2012-06-14	2012-06-14 00:00:00	38000275	0	\N	\N	170910	0	269911007	4151422	
41257	3622	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	240796	0	180256009	4107731	
53306	4626	4107731	2001-03-23	2001-03-23 00:00:00	38000275	0	\N	\N	308168	0	180256009	4107731	
53618	4646	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	309806	0	180256009	4107731	
53750	4656	4336464	2008-06-29	2008-06-29 00:00:00	38000275	0	\N	\N	310471	0	232717009	4336464	
42050	3703	4107731	1991-03-23	1991-03-23 00:00:00	38000275	0	\N	\N	246202	0	180256009	4107731	
42258	3731	4252419	1984-07-27	1984-07-27 00:00:00	38000275	0	\N	\N	247955	0	74016001	4252419	
54385	4724	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	314715	0	180256009	4107731	
42519	3754	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	249492	0	180256009	4107731	
42813	3772	4107731	1993-01-23	1993-01-23 00:00:00	38000275	0	\N	\N	250712	0	180256009	4107731	
54853	4759	4058899	1979-12-01	1979-12-01 00:00:00	38000275	0	\N	\N	317116	0	168594001	4058899	
55111	4802	4125906	2003-12-17	2003-12-17 00:00:00	38000275	0	\N	\N	319438	0	288086009	4125906	
31405	2776	4107731	2008-09-02	2008-09-02 00:00:00	38000275	0	\N	\N	183814	0	180256009	4107731	
43479	3852	4107731	1990-01-22	1990-01-22 00:00:00	38000275	0	\N	\N	255669	0	180256009	4107731	
55617	4844	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	322254	0	180256009	4107731	
55898	4878	4191853	1993-07-10	1993-07-10 00:00:00	38000275	0	\N	\N	324320	0	395142003	4191853	
55972	4883	4125906	1947-12-11	1947-12-11 00:00:00	38000275	0	\N	\N	324678	0	288086009	4125906	
32289	2832	4107731	1996-07-13	1996-07-13 00:00:00	38000275	0	\N	\N	188014	0	180256009	4107731	
45036	3958	4125906	2000-08-08	2000-08-08 00:00:00	38000275	0	\N	\N	263176	0	288086009	4125906	
33252	2909	4035793	1994-05-01	1994-05-01 00:00:00	38000275	0	\N	\N	193867	0	15081005	4035793	
45411	4009	4125906	2004-06-06	2004-06-06 00:00:00	38000275	0	\N	\N	266434	0	288086009	4125906	
45762	4027	4163872	1974-10-04	1974-10-04 00:00:00	38000275	0	\N	\N	267866	0	399208008	4163872	
46112	4052	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	269337	0	180256009	4107731	
46235	4064	4107731	1991-09-02	1991-09-02 00:00:00	38000275	0	\N	\N	269978	0	180256009	4107731	
46510	4078	4107731	1991-11-25	1991-11-25 00:00:00	38000275	0	\N	\N	270959	0	180256009	4107731	
58650	5081	4145310	2004-11-19	2004-11-19 00:00:00	38000275	0	\N	\N	337810	0	268425006	4145310	
58739	5097	4107731	1992-08-09	1992-08-09 00:00:00	38000275	0	\N	\N	338658	0	180256009	4107731	
59120	5118	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	340194	0	180256009	4107731	
59524	5150	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	342428	0	180256009	4107731	
47871	4200	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	278764	0	180256009	4107731	
35923	3147	4170947	1955-01-29	1955-01-29 00:00:00	38000275	0	\N	\N	209351	0	274474001	4170947	
48090	4217	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	279939	0	180256009	4107731	
36339	3181	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	211651	0	180256009	4107731	
48516	4261	4078793	2013-02-10	2013-02-10 00:00:00	38000275	0	\N	\N	282918	0	180325003	4078793	
48653	4278	4293740	1995-06-08	1995-06-08 00:00:00	38000275	0	\N	\N	283934	0	384700001	4293740	
37018	3253	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	216256	0	180256009	4107731	
49032	4305	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	285605	0	180256009	4107731	
37382	3293	4170947	2000-10-17	2000-10-17 00:00:00	38000275	0	\N	\N	218696	0	274474001	4170947	
37570	3315	4125906	1977-07-16	1977-07-16 00:00:00	38000275	0	\N	\N	220130	0	288086009	4125906	
61560	5322	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	354187	0	180256009	4107731	
37866	3343	4107731	1992-08-30	1992-08-30 00:00:00	38000275	0	\N	\N	221760	0	180256009	4107731	
50067	4372	4107731	1995-02-02	1995-02-02 00:00:00	38000275	0	\N	\N	290323	0	180256009	4107731	
38287	3371	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	223595	0	180256009	4107731	
50478	4388	4243062	1968-05-11	1968-05-11 00:00:00	38000275	0	\N	\N	291634	0	60027007	4243062	
50561	4392	4170947	2005-09-18	2005-09-18 00:00:00	38000275	0	\N	\N	292047	0	274474001	4170947	
38830	3423	4125906	1986-10-28	1986-10-28 00:00:00	38000275	0	\N	\N	227093	0	288086009	4125906	
50926	4433	4078793	2016-08-20	2016-08-20 00:00:00	38000275	0	\N	\N	294715	0	180325003	4078793	
51387	4452	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	296333	0	395142003	4191853	
27676	2419	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	160602	0	180256009	4107731	
39822	3505	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	232454	0	180256009	4107731	
51801	4490	4058899	1932-12-11	1932-12-11 00:00:00	38000275	0	\N	\N	298883	0	168594001	4058899	
52016	4506	4151422	1978-11-21	1978-11-21 00:00:00	38000275	0	\N	\N	300221	0	269911007	4151422	
52235	4531	4024289	1995-04-20	1995-04-20 00:00:00	38000275	0	\N	\N	301708	0	19490002	4024289	
40506	3561	4125906	1998-08-22	1998-08-22 00:00:00	38000275	0	\N	\N	236476	0	288086009	4125906	
52585	4562	4197460	1962-06-22	1962-06-22 00:00:00	38000275	0	\N	\N	303950	0	313191000	4197460	
40942	3589	4107731	1994-10-25	1994-10-25 00:00:00	38000275	0	\N	\N	238479	0	180256009	4107731	
29139	2583	4198190	2001-06-08	2001-06-08 00:00:00	38000275	0	\N	\N	171074	0	80146002	4198190	
41258	3622	4078793	2018-04-25	2018-04-25 00:00:00	38000275	0	\N	\N	240726	0	180325003	4078793	
53307	4626	4107731	1999-02-26	1999-02-26 00:00:00	38000275	0	\N	\N	308156	0	180256009	4107731	
53619	4646	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	309751	0	180256009	4107731	
53751	4656	4170947	1966-11-09	1966-11-09 00:00:00	38000275	0	\N	\N	310469	0	274474001	4170947	
42051	3703	4107731	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	246300	0	180256009	4107731	
42259	3731	4151422	2011-08-22	2011-08-22 00:00:00	38000275	0	\N	\N	247918	0	269911007	4151422	
54386	4724	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	314777	0	180256009	4107731	
42520	3754	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	249516	0	180256009	4107731	
42814	3772	4107731	1993-03-27	1993-03-27 00:00:00	38000275	0	\N	\N	250708	0	180256009	4107731	
54854	4759	4181917	2016-01-12	2016-01-12 00:00:00	38000275	0	\N	\N	317070	0	54550000	4181917	
55112	4802	4151422	1970-03-23	1970-03-23 00:00:00	38000275	0	\N	\N	319459	0	269911007	4151422	
31406	2776	4191853	2005-07-26	2005-07-26 00:00:00	38000275	0	\N	\N	183776	0	395142003	4191853	
43480	3852	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	255734	0	180256009	4107731	
55618	4844	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	322214	0	180256009	4107731	
55899	4878	4191853	1990-01-06	1990-01-06 00:00:00	38000275	0	\N	\N	324403	0	395142003	4191853	
55973	4883	4293740	1947-12-11	1947-12-11 00:00:00	38000275	0	\N	\N	324678	0	384700001	4293740	
32290	2832	4107731	1997-02-08	1997-02-08 00:00:00	38000275	0	\N	\N	187881	0	180256009	4107731	
45037	3960	4151422	1963-01-08	1963-01-08 00:00:00	38000275	0	\N	\N	263250	0	269911007	4151422	
33253	2909	4035793	2000-06-04	2000-06-04 00:00:00	38000275	0	\N	\N	193854	0	15081005	4035793	
45412	4010	4125906	2019-05-25	2019-05-25 00:00:00	38000275	0	\N	\N	266492	0	288086009	4125906	
45763	4027	4107731	1992-02-01	1992-02-01 00:00:00	38000275	0	\N	\N	267865	0	180256009	4107731	
46113	4052	4151422	2004-02-26	2004-02-26 00:00:00	38000275	0	\N	\N	269345	0	269911007	4151422	
46236	4064	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	270088	0	180256009	4107731	
46511	4078	4107731	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	271036	0	180256009	4107731	
58655	5083	4010253	1975-09-07	1975-09-07 00:00:00	38000275	0	\N	\N	338014	0	112790001	4010253	
58740	5097	4107731	1995-12-10	1995-12-10 00:00:00	38000275	0	\N	\N	338743	0	180256009	4107731	
59121	5118	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	340211	0	180256009	4107731	
59525	5150	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	342459	0	180256009	4107731	
47872	4200	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	278735	0	180256009	4107731	
35924	3147	4024289	1955-01-29	1955-01-29 00:00:00	38000275	0	\N	\N	209351	0	19490002	4024289	
48091	4217	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	280045	0	180256009	4107731	
36340	3181	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	211770	0	180256009	4107731	
48517	4261	4125906	1995-10-27	1995-10-27 00:00:00	38000275	0	\N	\N	282894	0	288086009	4125906	
48654	4278	4035793	2001-08-31	2001-08-31 00:00:00	38000275	0	\N	\N	283847	0	15081005	4035793	
37019	3253	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	216333	0	180256009	4107731	
49033	4305	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	285549	0	180256009	4107731	
37383	3293	4047491	2000-10-17	2000-10-17 00:00:00	38000275	0	\N	\N	218696	0	1225002	4047491	
49369	4342	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	287909	0	180256009	4107731	
61561	5322	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	354099	0	180256009	4107731	
37867	3343	4107731	1991-01-20	1991-01-20 00:00:00	38000275	0	\N	\N	221841	0	180256009	4107731	
50068	4372	4107731	1995-04-27	1995-04-27 00:00:00	38000275	0	\N	\N	290325	0	180256009	4107731	
38288	3371	4295880	2006-11-17	2006-11-17 00:00:00	38000275	0	\N	\N	223629	0	76601001	4295880	
50479	4388	4125906	1974-01-29	1974-01-29 00:00:00	38000275	0	\N	\N	291637	0	288086009	4125906	
50562	4392	4047491	2005-09-18	2005-09-18 00:00:00	38000275	0	\N	\N	292047	0	1225002	4047491	
38835	3427	4252419	1970-02-14	1970-02-14 00:00:00	38000275	0	\N	\N	227245	0	74016001	4252419	
50927	4433	4078793	1995-04-22	1995-04-22 00:00:00	38000275	0	\N	\N	294694	0	180325003	4078793	
51388	4452	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	296288	0	180256009	4107731	
39458	3477	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	230676	0	180256009	4107731	
39823	3505	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	232445	0	180256009	4107731	
51802	4490	4170947	1936-01-25	1936-01-25 00:00:00	38000275	0	\N	\N	298884	0	274474001	4170947	
52017	4506	4243062	1955-11-14	1955-11-14 00:00:00	38000275	0	\N	\N	300227	0	60027007	4243062	
52236	4531	4195803	1995-04-20	1995-04-20 00:00:00	38000275	0	\N	\N	301708	0	312681000	4195803	
40507	3561	4078793	1998-11-23	1998-11-23 00:00:00	38000275	0	\N	\N	236541	0	180325003	4078793	
52586	4562	4197460	1970-11-08	1970-11-08 00:00:00	38000275	0	\N	\N	303952	0	313191000	4197460	
40943	3589	4107731	1994-05-31	1994-05-31 00:00:00	38000275	0	\N	\N	238430	0	180256009	4107731	
29140	2583	4024289	1993-06-28	1993-06-28 00:00:00	38000275	0	\N	\N	171045	0	19490002	4024289	
41259	3622	4078793	2015-04-08	2015-04-08 00:00:00	38000275	0	\N	\N	240716	0	180325003	4078793	
53308	4626	4107731	1998-05-29	1998-05-29 00:00:00	38000275	0	\N	\N	308260	0	180256009	4107731	
53620	4646	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	309770	0	180256009	4107731	
53752	4656	4024289	1966-11-09	1966-11-09 00:00:00	38000275	0	\N	\N	310469	0	19490002	4024289	
42052	3703	4107731	1991-05-25	1991-05-25 00:00:00	38000275	0	\N	\N	246290	0	180256009	4107731	
42260	3731	4243062	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	247938	0	60027007	4243062	
54387	4724	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	314831	0	180256009	4107731	
42521	3754	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	249493	0	180256009	4107731	
42815	3772	4107731	1990-10-06	1990-10-06 00:00:00	38000275	0	\N	\N	250730	0	180256009	4107731	
54855	4759	4151422	2007-06-08	2007-06-08 00:00:00	38000275	0	\N	\N	317103	0	269911007	4151422	
55113	4802	4151422	2003-05-17	2003-05-17 00:00:00	38000275	0	\N	\N	319455	0	269911007	4151422	
31407	2776	4107731	2006-07-18	2006-07-18 00:00:00	38000275	0	\N	\N	183835	0	180256009	4107731	
43481	3852	4107731	1991-11-25	1991-11-25 00:00:00	38000275	0	\N	\N	255659	0	180256009	4107731	
55619	4844	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	322288	0	180256009	4107731	
55900	4878	4107731	1991-11-30	1991-11-30 00:00:00	38000275	0	\N	\N	324449	0	180256009	4107731	
55974	4883	4202451	1967-04-07	1967-04-07 00:00:00	38000275	0	\N	\N	324714	0	433112001	4202451	
32291	2832	4107731	1997-03-01	1997-03-01 00:00:00	38000275	0	\N	\N	187996	0	180256009	4107731	
45038	3960	4163872	1983-04-08	1983-04-08 00:00:00	38000275	0	\N	\N	263259	0	399208008	4163872	
33254	2909	4035793	2003-06-22	2003-06-22 00:00:00	38000275	0	\N	\N	193879	0	15081005	4035793	
45413	4010	4293740	2019-05-25	2019-05-25 00:00:00	38000275	0	\N	\N	266492	0	384700001	4293740	
45764	4027	4107731	1991-11-09	1991-11-09 00:00:00	38000275	0	\N	\N	267893	0	180256009	4107731	
46114	4052	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	269297	0	180256009	4107731	
46237	4064	4107731	1992-08-24	1992-08-24 00:00:00	38000275	0	\N	\N	269983	0	180256009	4107731	
46512	4078	4107731	1992-08-03	1992-08-03 00:00:00	38000275	0	\N	\N	270992	0	180256009	4107731	
58656	5083	4125906	2013-06-11	2013-06-11 00:00:00	38000275	0	\N	\N	338032	0	288086009	4125906	
58741	5097	4107731	1994-09-04	1994-09-04 00:00:00	38000275	0	\N	\N	338732	0	180256009	4107731	
59122	5118	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	340166	0	180256009	4107731	
59526	5150	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	342480	0	180256009	4107731	
59654	5165	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	343319	0	180256009	4107731	
35925	3147	4151422	2008-06-18	2008-06-18 00:00:00	38000275	0	\N	\N	209396	0	269911007	4151422	
48092	4217	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	280031	0	180256009	4107731	
36341	3181	4125906	2001-05-27	2001-05-27 00:00:00	38000275	0	\N	\N	211688	0	288086009	4125906	
48518	4261	4293740	1995-10-27	1995-10-27 00:00:00	38000275	0	\N	\N	282894	0	384700001	4293740	
48655	4278	4035793	2008-10-10	2008-10-10 00:00:00	38000275	0	\N	\N	283852	0	15081005	4035793	
37020	3253	4243062	2012-02-08	2012-02-08 00:00:00	38000275	0	\N	\N	216244	0	60027007	4243062	
49034	4305	4243062	1969-09-20	1969-09-20 00:00:00	38000275	0	\N	\N	285583	0	60027007	4243062	
37384	3293	4170947	1944-02-27	1944-02-27 00:00:00	38000275	0	\N	\N	218665	0	274474001	4170947	
49370	4342	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	287886	0	180256009	4107731	
61562	5322	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	354129	0	180256009	4107731	
37868	3343	4107731	1992-11-22	1992-11-22 00:00:00	38000275	0	\N	\N	221762	0	180256009	4107731	
50069	4372	4107731	1994-05-26	1994-05-26 00:00:00	38000275	0	\N	\N	290227	0	180256009	4107731	
38289	3371	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	223540	0	180256009	4107731	
50480	4388	4062501	1970-08-26	1970-08-26 00:00:00	38000275	0	\N	\N	291686	0	171231001	4062501	
50563	4392	4295880	1998-07-10	1998-07-10 00:00:00	38000275	0	\N	\N	292075	0	76601001	4295880	
38836	3427	44783196	1970-02-21	1970-02-21 00:00:00	38000275	0	\N	\N	227226	0	699253003	44783196	
50928	4433	4125906	2002-12-08	2002-12-08 00:00:00	38000275	0	\N	\N	294729	0	288086009	4125906	
51389	4452	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	296331	0	180256009	4107731	
39459	3477	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	230718	0	180256009	4107731	
39824	3505	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	232384	0	395142003	4191853	
51803	4490	4047491	1936-01-25	1936-01-25 00:00:00	38000275	0	\N	\N	298884	0	1225002	4047491	
52018	4506	4170947	1955-11-14	1955-11-14 00:00:00	38000275	0	\N	\N	300227	0	274474001	4170947	
52237	4531	4163872	1944-05-20	1944-05-20 00:00:00	38000275	0	\N	\N	301745	0	399208008	4163872	
40508	3561	4078793	2007-09-03	2007-09-03 00:00:00	38000275	0	\N	\N	236567	0	180325003	4078793	
52587	4562	4151422	1985-04-30	1985-04-30 00:00:00	38000275	0	\N	\N	304041	0	269911007	4151422	
40944	3589	4107731	1996-10-28	1996-10-28 00:00:00	38000275	0	\N	\N	238495	0	180256009	4107731	
29141	2583	4170947	1993-06-28	1993-06-28 00:00:00	38000275	0	\N	\N	171045	0	274474001	4170947	
41260	3622	4078793	1999-10-27	1999-10-27 00:00:00	38000275	0	\N	\N	240697	0	180325003	4078793	
53309	4626	4107731	1999-09-03	1999-09-03 00:00:00	38000275	0	\N	\N	308157	0	180256009	4107731	
53621	4646	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	309849	0	180256009	4107731	
53753	4656	4216130	2014-05-11	2014-05-11 00:00:00	38000275	0	\N	\N	310472	0	415070008	4216130	
42053	3703	4107731	1991-07-27	1991-07-27 00:00:00	38000275	0	\N	\N	246218	0	180256009	4107731	
42261	3731	4170947	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	247938	0	274474001	4170947	
54388	4724	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	314667	0	180256009	4107731	
42522	3754	4125906	1986-07-16	1986-07-16 00:00:00	38000275	0	\N	\N	249513	0	288086009	4125906	
42816	3773	4170947	1981-01-22	1981-01-22 00:00:00	38000275	0	\N	\N	250813	0	274474001	4170947	
54856	4759	4181917	2008-11-08	2008-11-08 00:00:00	38000275	0	\N	\N	317067	0	54550000	4181917	
55114	4802	4024289	1971-12-05	1971-12-05 00:00:00	38000275	0	\N	\N	319437	0	19490002	4024289	
31408	2776	4107731	2006-08-08	2006-08-08 00:00:00	38000275	0	\N	\N	183839	0	180256009	4107731	
43482	3852	4107731	1993-01-18	1993-01-18 00:00:00	38000275	0	\N	\N	255741	0	180256009	4107731	
55620	4844	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	322209	0	180256009	4107731	
55901	4878	4107731	1991-07-27	1991-07-27 00:00:00	38000275	0	\N	\N	324446	0	180256009	4107731	
55975	4884	4170947	1989-07-08	1989-07-08 00:00:00	38000275	0	\N	\N	324736	0	274474001	4170947	
32292	2832	4107731	1995-04-08	1995-04-08 00:00:00	38000275	0	\N	\N	187960	0	180256009	4107731	
45039	3961	4151422	1973-03-09	1973-03-09 00:00:00	38000275	0	\N	\N	263368	0	269911007	4151422	
33255	2909	4035793	1998-05-24	1998-05-24 00:00:00	38000275	0	\N	\N	193853	0	15081005	4035793	
45414	4010	4181917	1977-12-15	1977-12-15 00:00:00	38000275	0	\N	\N	266487	0	54550000	4181917	
45765	4027	4107731	1992-01-11	1992-01-11 00:00:00	38000275	0	\N	\N	267843	0	180256009	4107731	
46115	4052	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	269340	0	180256009	4107731	
46238	4064	4107731	1991-09-23	1991-09-23 00:00:00	38000275	0	\N	\N	270081	0	180256009	4107731	
46513	4078	4107731	1992-10-05	1992-10-05 00:00:00	38000275	0	\N	\N	271067	0	180256009	4107731	
58657	5083	4151422	1970-04-21	1970-04-21 00:00:00	38000275	0	\N	\N	338022	0	269911007	4151422	
58742	5097	4107731	1993-11-14	1993-11-14 00:00:00	38000275	0	\N	\N	338635	0	180256009	4107731	
59123	5118	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	340209	0	180256009	4107731	
59527	5150	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	342478	0	180256009	4107731	
59655	5165	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	343287	0	395142003	4191853	
35926	3147	4035793	2019-06-17	2019-06-17 00:00:00	38000275	0	\N	\N	209426	0	15081005	4035793	
48093	4217	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	280029	0	180256009	4107731	
36342	3181	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	211822	0	180256009	4107731	
48519	4261	4151422	1998-11-12	1998-11-12 00:00:00	38000275	0	\N	\N	282942	0	269911007	4151422	
48656	4278	4035793	2000-04-28	2000-04-28 00:00:00	38000275	0	\N	\N	283886	0	15081005	4035793	
37021	3253	4170947	2012-02-08	2012-02-08 00:00:00	38000275	0	\N	\N	216244	0	274474001	4170947	
49035	4305	4170947	1969-09-20	1969-09-20 00:00:00	38000275	0	\N	\N	285583	0	274474001	4170947	
37385	3293	4024289	1944-02-27	1944-02-27 00:00:00	38000275	0	\N	\N	218665	0	19490002	4024289	
49371	4342	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	287885	0	180256009	4107731	
61563	5322	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	354096	0	180256009	4107731	
37869	3343	4043071	1985-07-09	1985-07-09 00:00:00	38000275	0	\N	\N	221807	0	228557008	4043071	
50070	4372	4107731	1996-09-12	1996-09-12 00:00:00	38000275	0	\N	\N	290309	0	180256009	4107731	
38290	3371	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	223557	0	180256009	4107731	
50481	4388	44783196	1996-10-28	1996-10-28 00:00:00	38000275	0	\N	\N	291750	0	699253003	44783196	
50564	4392	4295880	1997-10-10	1997-10-10 00:00:00	38000275	0	\N	\N	292074	0	76601001	4295880	
38837	3427	4047491	2013-01-04	2013-01-04 00:00:00	38000275	0	\N	\N	227229	0	1225002	4047491	
50929	4433	4078793	2010-07-17	2010-07-17 00:00:00	38000275	0	\N	\N	294654	0	180325003	4078793	
51390	4452	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	296301	0	180256009	4107731	
39460	3477	4107731	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	230613	0	180256009	4107731	
39825	3505	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	232491	0	180256009	4107731	
51804	4491	4024289	1992-04-07	1992-04-07 00:00:00	38000275	0	\N	\N	299027	0	19490002	4024289	
52036	4509	4047491	1968-09-22	1968-09-22 00:00:00	38000275	0	\N	\N	300362	0	1225002	4047491	
52238	4531	4125906	1943-09-08	1943-09-08 00:00:00	38000275	0	\N	\N	301704	0	288086009	4125906	
40509	3561	4078793	2017-10-30	2017-10-30 00:00:00	38000275	0	\N	\N	236482	0	180325003	4078793	
52588	4563	4151422	1976-06-27	1976-06-27 00:00:00	38000275	0	\N	\N	304113	0	269911007	4151422	
40945	3589	4107731	1996-11-18	1996-11-18 00:00:00	38000275	0	\N	\N	238472	0	180256009	4107731	
29142	2583	4170947	1986-08-20	1986-08-20 00:00:00	38000275	0	\N	\N	171043	0	274474001	4170947	
41261	3622	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	240752	0	180256009	4107731	
53310	4626	4107731	2000-11-17	2000-11-17 00:00:00	38000275	0	\N	\N	308184	0	180256009	4107731	
53622	4646	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	309769	0	180256009	4107731	
53754	4656	4336464	2014-05-11	2014-05-11 00:00:00	38000275	0	\N	\N	310472	0	232717009	4336464	
42054	3703	4191853	1990-01-06	1990-01-06 00:00:00	38000275	0	\N	\N	246285	0	395142003	4191853	
42262	3732	4252419	2015-11-09	2015-11-09 00:00:00	38000275	0	\N	\N	247988	0	74016001	4252419	
54389	4724	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	314716	0	180256009	4107731	
42523	3754	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	249504	0	395142003	4191853	
42817	3773	4024289	1981-01-22	1981-01-22 00:00:00	38000275	0	\N	\N	250813	0	19490002	4024289	
54857	4759	4170947	1989-06-16	1989-06-16 00:00:00	38000275	0	\N	\N	317119	0	274474001	4170947	
55115	4802	4170947	1971-12-05	1971-12-05 00:00:00	38000275	0	\N	\N	319437	0	274474001	4170947	
31409	2776	4107731	2008-04-29	2008-04-29 00:00:00	38000275	0	\N	\N	183847	0	180256009	4107731	
43483	3852	4107731	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	255672	0	180256009	4107731	
55621	4844	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	322293	0	180256009	4107731	
55902	4878	4107731	1993-01-02	1993-01-02 00:00:00	38000275	0	\N	\N	324439	0	180256009	4107731	
55976	4884	4243062	1989-07-08	1989-07-08 00:00:00	38000275	0	\N	\N	324736	0	60027007	4243062	
32293	2832	4107731	1996-12-28	1996-12-28 00:00:00	38000275	0	\N	\N	187905	0	180256009	4107731	
45040	3961	4252419	1974-10-29	1974-10-29 00:00:00	38000275	0	\N	\N	263350	0	74016001	4252419	
33256	2909	4035793	1999-05-30	1999-05-30 00:00:00	38000275	0	\N	\N	193922	0	15081005	4035793	
45415	4010	4059978	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	266496	0	169553002	4059978	
45766	4027	4107731	1991-05-25	1991-05-25 00:00:00	38000275	0	\N	\N	267902	0	180256009	4107731	
46116	4052	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	269390	0	180256009	4107731	
46239	4064	4151422	1984-11-01	1984-11-01 00:00:00	38000275	0	\N	\N	270011	0	269911007	4151422	
46514	4078	4107731	1992-08-24	1992-08-24 00:00:00	38000275	0	\N	\N	271066	0	180256009	4107731	
58658	5083	4170947	1995-06-02	1995-06-02 00:00:00	38000275	0	\N	\N	337992	0	274474001	4170947	
58743	5097	4107731	1995-08-06	1995-08-06 00:00:00	38000275	0	\N	\N	338694	0	180256009	4107731	
59124	5118	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	340222	0	180256009	4107731	
59528	5150	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	342482	0	180256009	4107731	
59656	5165	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	343343	0	180256009	4107731	
35927	3147	4035793	2009-04-20	2009-04-20 00:00:00	38000275	0	\N	\N	209349	0	15081005	4035793	
48094	4217	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	279930	0	180256009	4107731	
36343	3181	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	211739	0	180256009	4107731	
48520	4261	4151422	1929-09-02	1929-09-02 00:00:00	38000275	0	\N	\N	282862	0	269911007	4151422	
48657	4278	4035793	2000-07-14	2000-07-14 00:00:00	38000275	0	\N	\N	283887	0	15081005	4035793	
37022	3253	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	216258	0	180256009	4107731	
49036	4305	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	285582	0	180256009	4107731	
37386	3293	4202451	2006-11-25	2006-11-25 00:00:00	38000275	0	\N	\N	218743	0	433112001	4202451	
49372	4342	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	287894	0	180256009	4107731	
61564	5322	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	354077	0	180256009	4107731	
37870	3343	4107731	1992-02-02	1992-02-02 00:00:00	38000275	0	\N	\N	221874	0	180256009	4107731	
50071	4372	4107731	1993-08-05	1993-08-05 00:00:00	38000275	0	\N	\N	290208	0	180256009	4107731	
38291	3371	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	223530	0	180256009	4107731	
50485	4390	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	291841	0	180256009	4107731	
50565	4392	4295880	1997-07-09	1997-07-09 00:00:00	38000275	0	\N	\N	292073	0	76601001	4295880	
38838	3427	4170947	2013-01-04	2013-01-04 00:00:00	38000275	0	\N	\N	227229	0	274474001	4170947	
50930	4433	4078793	1993-07-10	1993-07-10 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
51391	4452	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	296280	0	180256009	4107731	
39461	3477	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	230614	0	180256009	4107731	
39826	3505	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	232469	0	395142003	4191853	
51805	4491	4170947	1992-04-07	1992-04-07 00:00:00	38000275	0	\N	\N	299027	0	274474001	4170947	
52037	4509	4170947	1968-09-22	1968-09-22 00:00:00	38000275	0	\N	\N	300362	0	274474001	4170947	
52239	4532	4037675	1960-04-04	1960-04-04 00:00:00	38000275	0	\N	\N	301954	0	162676008	4037675	
40510	3561	4078793	1993-10-25	1993-10-25 00:00:00	38000275	0	\N	\N	236550	0	180325003	4078793	
52589	4563	4170947	1981-04-10	1981-04-10 00:00:00	38000275	0	\N	\N	304074	0	274474001	4170947	
40946	3589	4107731	1996-06-25	1996-06-25 00:00:00	38000275	0	\N	\N	238439	0	180256009	4107731	
29143	2583	4243062	1986-08-20	1986-08-20 00:00:00	38000275	0	\N	\N	171043	0	60027007	4243062	
41262	3622	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	240826	0	180256009	4107731	
53311	4626	4107731	1999-04-09	1999-04-09 00:00:00	38000275	0	\N	\N	308263	0	180256009	4107731	
53623	4646	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	309851	0	180256009	4107731	
53755	4657	4047491	1969-03-24	1969-03-24 00:00:00	38000275	0	\N	\N	310509	0	1225002	4047491	
42055	3703	4107731	1992-01-11	1992-01-11 00:00:00	38000275	0	\N	\N	246240	0	180256009	4107731	
54044	4694	4107731	1995-02-19	1995-02-19 00:00:00	38000275	0	\N	\N	312707	0	180256009	4107731	
54390	4724	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	314668	0	180256009	4107731	
42524	3754	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	249428	0	180256009	4107731	
42818	3773	4151422	1982-06-21	1982-06-21 00:00:00	38000275	0	\N	\N	250807	0	269911007	4151422	
54858	4759	4163872	1989-06-16	1989-06-16 00:00:00	38000275	0	\N	\N	317119	0	399208008	4163872	
55118	4804	4197460	1978-01-15	1978-01-15 00:00:00	38000275	0	\N	\N	319590	0	313191000	4197460	
31410	2776	4107731	2006-01-31	2006-01-31 00:00:00	38000275	0	\N	\N	183858	0	180256009	4107731	
43484	3852	4107731	1991-01-14	1991-01-14 00:00:00	38000275	0	\N	\N	255655	0	180256009	4107731	
55622	4844	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	322265	0	180256009	4107731	
55903	4878	4107731	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	324360	0	180256009	4107731	
55977	4884	4195803	1989-07-08	1989-07-08 00:00:00	38000275	0	\N	\N	324736	0	312681000	4195803	
32294	2832	4275113	1985-01-16	1985-01-16 00:00:00	38000275	0	\N	\N	187941	0	65200003	4275113	
45041	3961	4125906	2018-12-10	2018-12-10 00:00:00	38000275	0	\N	\N	263353	0	288086009	4125906	
33257	2909	4035793	1975-03-30	1975-03-30 00:00:00	38000275	0	\N	\N	193923	0	15081005	4035793	
45416	4010	4163872	1994-01-27	1994-01-27 00:00:00	38000275	0	\N	\N	266515	0	399208008	4163872	
45767	4027	4107731	1991-10-19	1991-10-19 00:00:00	38000275	0	\N	\N	267841	0	180256009	4107731	
46117	4053	4010253	1968-05-07	1968-05-07 00:00:00	38000275	0	\N	\N	269451	0	112790001	4010253	
46240	4064	4107731	1992-08-03	1992-08-03 00:00:00	38000275	0	\N	\N	270085	0	180256009	4107731	
46515	4078	4107731	1990-03-05	1990-03-05 00:00:00	38000275	0	\N	\N	271060	0	180256009	4107731	
58659	5083	4024289	1995-06-02	1995-06-02 00:00:00	38000275	0	\N	\N	337992	0	19490002	4024289	
58744	5097	4107731	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	338717	0	180256009	4107731	
59125	5118	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	340254	0	180256009	4107731	
59529	5150	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	342422	0	180256009	4107731	
59657	5165	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	343278	0	180256009	4107731	
35928	3147	4035793	2000-02-28	2000-02-28 00:00:00	38000275	0	\N	\N	209425	0	15081005	4035793	
48095	4217	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	279929	0	180256009	4107731	
36344	3181	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	211801	0	180256009	4107731	
48521	4261	4293740	1999-11-19	1999-11-19 00:00:00	38000275	0	\N	\N	282895	0	384700001	4293740	
48658	4278	4125906	2010-09-01	2010-09-01 00:00:00	38000275	0	\N	\N	283935	0	288086009	4125906	
37023	3253	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	216335	0	180256009	4107731	
49037	4305	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	285642	0	395142003	4191853	
37387	3294	4243062	2017-08-20	2017-08-20 00:00:00	38000275	0	\N	\N	218853	0	60027007	4243062	
49373	4342	4197460	1958-10-28	1958-10-28 00:00:00	38000275	0	\N	\N	287842	0	313191000	4197460	
61565	5322	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	354196	0	180256009	4107731	
37871	3343	4107731	1993-02-14	1993-02-14 00:00:00	38000275	0	\N	\N	221856	0	180256009	4107731	
50072	4372	4107731	1993-09-16	1993-09-16 00:00:00	38000275	0	\N	\N	290209	0	180256009	4107731	
38292	3371	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	223645	0	180256009	4107731	
50486	4390	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	291887	0	180256009	4107731	
50566	4393	4145310	1987-10-30	1987-10-30 00:00:00	38000275	0	\N	\N	292101	0	268425006	4145310	
38839	3428	4058899	2004-06-04	2004-06-04 00:00:00	38000275	0	\N	\N	227262	0	168594001	4058899	
50931	4433	4057420	2004-06-12	2004-06-12 00:00:00	38000275	0	\N	\N	294695	0	18286008	4057420	
51392	4452	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	296285	0	180256009	4107731	
39462	3477	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	230655	0	180256009	4107731	
39827	3505	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	232371	0	180256009	4107731	
51806	4491	4047491	1952-02-02	1952-02-02 00:00:00	38000275	0	\N	\N	299023	0	1225002	4047491	
52038	4509	4125906	1991-11-21	1991-11-21 00:00:00	38000275	0	\N	\N	300401	0	288086009	4125906	
52240	4532	4326177	1960-04-04	1960-04-04 00:00:00	38000275	0	\N	\N	301954	0	430193006	4326177	
40511	3561	4078793	1988-09-26	1988-09-26 00:00:00	38000275	0	\N	\N	236539	0	180325003	4078793	
52590	4563	4163872	1981-04-10	1981-04-10 00:00:00	38000275	0	\N	\N	304074	0	399208008	4163872	
40947	3589	4107731	1995-02-06	1995-02-06 00:00:00	38000275	0	\N	\N	238404	0	180256009	4107731	
29144	2583	4024289	1971-07-10	1971-07-10 00:00:00	38000275	0	\N	\N	171042	0	19490002	4024289	
41263	3622	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	240754	0	180256009	4107731	
53312	4626	4107731	2000-03-31	2000-03-31 00:00:00	38000275	0	\N	\N	308182	0	180256009	4107731	
53624	4646	4293740	1946-09-16	1946-09-16 00:00:00	38000275	0	\N	\N	309737	0	384700001	4293740	
53756	4657	4170947	1969-03-24	1969-03-24 00:00:00	38000275	0	\N	\N	310509	0	274474001	4170947	
42056	3703	4191853	1993-07-10	1993-07-10 00:00:00	38000275	0	\N	\N	246246	0	395142003	4191853	
54045	4694	4107731	1997-10-12	1997-10-12 00:00:00	38000275	0	\N	\N	312760	0	180256009	4107731	
54391	4724	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	314669	0	180256009	4107731	
42525	3754	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	249527	0	180256009	4107731	
42819	3773	4293740	1963-02-05	1963-02-05 00:00:00	38000275	0	\N	\N	250812	0	384700001	4293740	
54859	4759	4125906	1992-06-30	1992-06-30 00:00:00	38000275	0	\N	\N	317120	0	288086009	4125906	
55119	4804	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	319570	0	180256009	4107731	
31411	2776	4107731	2008-09-23	2008-09-23 00:00:00	38000275	0	\N	\N	183884	0	180256009	4107731	
43485	3852	4107731	1992-09-14	1992-09-14 00:00:00	38000275	0	\N	\N	255751	0	180256009	4107731	
55623	4844	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	322186	0	180256009	4107731	
55904	4878	4107731	1990-01-27	1990-01-27 00:00:00	38000275	0	\N	\N	324317	0	180256009	4107731	
55978	4884	4252419	1980-12-22	1980-12-22 00:00:00	38000275	0	\N	\N	324734	0	74016001	4252419	
32295	2832	4107731	1995-09-02	1995-09-02 00:00:00	38000275	0	\N	\N	188010	0	180256009	4107731	
45042	3961	4125906	1975-10-31	1975-10-31 00:00:00	38000275	0	\N	\N	263351	0	288086009	4125906	
33258	2909	4035793	2004-06-27	2004-06-27 00:00:00	38000275	0	\N	\N	193927	0	15081005	4035793	
45417	4010	4181917	1977-05-05	1977-05-05 00:00:00	38000275	0	\N	\N	266485	0	54550000	4181917	
45768	4027	4107731	1993-04-17	1993-04-17 00:00:00	38000275	0	\N	\N	267798	0	180256009	4107731	
46118	4053	4125906	1988-06-28	1988-06-28 00:00:00	38000275	0	\N	\N	269419	0	288086009	4125906	
46241	4064	4107731	1992-03-09	1992-03-09 00:00:00	38000275	0	\N	\N	270007	0	180256009	4107731	
46516	4078	4107731	1993-01-18	1993-01-18 00:00:00	38000275	0	\N	\N	271089	0	180256009	4107731	
58660	5083	4125906	2011-06-08	2011-06-08 00:00:00	38000275	0	\N	\N	338031	0	288086009	4125906	
58745	5097	4107731	1995-06-04	1995-06-04 00:00:00	38000275	0	\N	\N	338735	0	180256009	4107731	
59126	5118	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	340230	0	180256009	4107731	
59530	5150	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	342425	0	180256009	4107731	
59658	5165	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	343333	0	180256009	4107731	
35929	3147	4035793	2017-06-05	2017-06-05 00:00:00	38000275	0	\N	\N	209412	0	15081005	4035793	
48096	4217	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	280034	0	180256009	4107731	
36345	3181	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	211668	0	180256009	4107731	
48522	4261	4125906	1999-11-19	1999-11-19 00:00:00	38000275	0	\N	\N	282895	0	288086009	4125906	
48659	4278	4035793	2002-09-06	2002-09-06 00:00:00	38000275	0	\N	\N	283864	0	15081005	4035793	
37024	3253	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	216363	0	180256009	4107731	
49038	4305	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	285555	0	180256009	4107731	
37388	3294	4170947	2017-08-20	2017-08-20 00:00:00	38000275	0	\N	\N	218853	0	274474001	4170947	
49374	4342	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	287927	0	180256009	4107731	
61566	5322	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	354215	0	180256009	4107731	
37872	3343	4107731	1993-04-18	1993-04-18 00:00:00	38000275	0	\N	\N	221717	0	180256009	4107731	
50073	4372	4107731	1995-05-18	1995-05-18 00:00:00	38000275	0	\N	\N	290271	0	180256009	4107731	
38293	3371	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	223567	0	180256009	4107731	
50487	4390	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	291883	0	180256009	4107731	
50567	4393	4163872	2000-08-02	2000-08-02 00:00:00	38000275	0	\N	\N	292088	0	399208008	4163872	
38840	3428	4125906	2010-06-03	2010-06-03 00:00:00	38000275	0	\N	\N	227263	0	288086009	4125906	
50932	4433	4078793	2007-06-30	2007-06-30 00:00:00	38000275	0	\N	\N	294716	0	180325003	4078793	
51393	4452	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	296277	0	180256009	4107731	
39463	3477	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	230708	0	180256009	4107731	
51613	4476	4047491	1968-08-15	1968-08-15 00:00:00	38000275	0	\N	\N	297894	0	1225002	4047491	
51807	4491	4170947	1952-02-02	1952-02-02 00:00:00	38000275	0	\N	\N	299023	0	274474001	4170947	
52039	4509	4047491	1978-02-02	1978-02-02 00:00:00	38000275	0	\N	\N	300363	0	1225002	4047491	
52241	4532	4187458	1960-04-04	1960-04-04 00:00:00	38000275	0	\N	\N	301954	0	415300000	4187458	
40512	3561	4125906	1997-09-12	1997-09-12 00:00:00	38000275	0	\N	\N	236475	0	288086009	4125906	
52591	4563	4151422	1970-04-12	1970-04-12 00:00:00	38000275	0	\N	\N	304091	0	269911007	4151422	
40948	3589	4107731	1995-03-20	1995-03-20 00:00:00	38000275	0	\N	\N	238405	0	180256009	4107731	
29145	2583	4170947	1971-07-10	1971-07-10 00:00:00	38000275	0	\N	\N	171042	0	274474001	4170947	
41264	3622	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	240675	0	180256009	4107731	
53313	4626	4191853	2001-05-25	2001-05-25 00:00:00	38000275	0	\N	\N	308225	0	395142003	4191853	
53625	4646	4125906	1946-09-16	1946-09-16 00:00:00	38000275	0	\N	\N	309737	0	288086009	4125906	
53757	4657	4151422	1987-08-07	1987-08-07 00:00:00	38000275	0	\N	\N	310551	0	269911007	4151422	
42057	3703	4107731	1992-08-29	1992-08-29 00:00:00	38000275	0	\N	\N	246242	0	180256009	4107731	
54046	4694	4107731	1997-08-31	1997-08-31 00:00:00	38000275	0	\N	\N	312759	0	180256009	4107731	
54392	4724	4186930	1973-02-28	1973-02-28 00:00:00	38000275	0	\N	\N	314801	0	46706006	4186930	
42526	3754	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	249473	0	180256009	4107731	
42820	3773	4125906	1963-02-05	1963-02-05 00:00:00	38000275	0	\N	\N	250812	0	288086009	4125906	
54860	4759	4058899	1985-05-08	1985-05-08 00:00:00	38000275	0	\N	\N	317118	0	168594001	4058899	
55120	4804	4107731	1992-10-26	1992-10-26 00:00:00	38000275	0	\N	\N	319596	0	180256009	4107731	
31412	2776	4107731	2007-06-19	2007-06-19 00:00:00	38000275	0	\N	\N	183843	0	180256009	4107731	
43486	3852	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	255755	0	180256009	4107731	
55624	4844	4170947	1965-12-05	1965-12-05 00:00:00	38000275	0	\N	\N	322279	0	274474001	4170947	
55905	4878	4107731	1991-04-13	1991-04-13 00:00:00	38000275	0	\N	\N	324352	0	180256009	4107731	
55979	4884	4125906	1978-02-22	1978-02-22 00:00:00	38000275	0	\N	\N	324733	0	288086009	4125906	
32296	2832	4107731	1997-05-03	1997-05-03 00:00:00	38000275	0	\N	\N	187934	0	180256009	4107731	
45043	3961	4293740	1975-10-31	1975-10-31 00:00:00	38000275	0	\N	\N	263351	0	384700001	4293740	
33259	2909	4035793	2002-06-16	2002-06-16 00:00:00	38000275	0	\N	\N	193855	0	15081005	4035793	
45418	4010	4163872	1999-11-24	1999-11-24 00:00:00	38000275	0	\N	\N	266516	0	399208008	4163872	
45769	4027	4107731	1990-04-21	1990-04-21 00:00:00	38000275	0	\N	\N	267871	0	180256009	4107731	
57994	5031	4181917	1948-07-17	1948-07-17 00:00:00	38000275	0	\N	\N	334276	0	54550000	4181917	
46242	4064	4107731	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	269999	0	180256009	4107731	
46517	4078	4107731	1991-09-02	1991-09-02 00:00:00	38000275	0	\N	\N	270986	0	180256009	4107731	
58661	5085	4125906	2003-05-21	2003-05-21 00:00:00	38000275	0	\N	\N	338098	0	288086009	4125906	
58746	5097	4107731	1994-06-12	1994-06-12 00:00:00	38000275	0	\N	\N	338680	0	180256009	4107731	
59127	5118	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	340276	0	180256009	4107731	
59531	5150	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	342352	0	180256009	4107731	
59659	5165	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	343286	0	180256009	4107731	
35930	3147	4035793	2011-05-02	2011-05-02 00:00:00	38000275	0	\N	\N	209409	0	15081005	4035793	
48097	4217	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	279928	0	180256009	4107731	
36346	3181	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	211672	0	180256009	4107731	
48523	4261	4078793	2016-02-28	2016-02-28 00:00:00	38000275	0	\N	\N	282958	0	180325003	4078793	
48660	4278	4035793	2000-07-07	2000-07-07 00:00:00	38000275	0	\N	\N	283839	0	15081005	4035793	
37025	3253	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	216391	0	180256009	4107731	
49039	4305	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	285611	0	180256009	4107731	
37389	3294	4195803	2017-08-20	2017-08-20 00:00:00	38000275	0	\N	\N	218853	0	312681000	4195803	
49375	4342	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	287874	0	180256009	4107731	
61567	5322	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	354161	0	180256009	4107731	
37873	3343	4107731	1991-11-10	1991-11-10 00:00:00	38000275	0	\N	\N	221872	0	180256009	4107731	
50074	4372	4107731	1993-10-07	1993-10-07 00:00:00	38000275	0	\N	\N	290225	0	180256009	4107731	
38294	3371	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	223565	0	180256009	4107731	
50488	4390	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	291796	0	180256009	4107731	
50568	4393	4163872	2011-12-20	2011-12-20 00:00:00	38000275	0	\N	\N	292091	0	399208008	4163872	
38841	3428	4151422	1976-12-20	1976-12-20 00:00:00	38000275	0	\N	\N	227253	0	269911007	4151422	
50933	4433	4057420	2003-06-07	2003-06-07 00:00:00	38000275	0	\N	\N	294683	0	18286008	4057420	
51394	4452	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	296253	0	180256009	4107731	
39464	3477	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	230719	0	180256009	4107731	
51614	4476	4170947	1968-08-15	1968-08-15 00:00:00	38000275	0	\N	\N	297894	0	274474001	4170947	
51808	4491	4195803	2006-07-09	2006-07-09 00:00:00	38000275	0	\N	\N	299006	0	312681000	4195803	
52040	4509	4170947	1978-02-02	1978-02-02 00:00:00	38000275	0	\N	\N	300363	0	274474001	4170947	
52242	4532	4125906	1956-10-21	1956-10-21 00:00:00	38000275	0	\N	\N	301891	0	288086009	4125906	
40513	3561	4078793	1989-10-02	1989-10-02 00:00:00	38000275	0	\N	\N	236540	0	180325003	4078793	
52592	4565	4151422	1993-08-25	1993-08-25 00:00:00	38000275	0	\N	\N	304165	0	269911007	4151422	
40949	3589	4107731	1994-12-26	1994-12-26 00:00:00	38000275	0	\N	\N	238455	0	180256009	4107731	
29150	2586	4043071	1983-01-08	1983-01-08 00:00:00	38000275	0	\N	\N	171141	0	228557008	4043071	
41265	3622	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	240824	0	180256009	4107731	
53314	4626	4107731	2001-05-04	2001-05-04 00:00:00	38000275	0	\N	\N	308169	0	180256009	4107731	
53626	4646	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	309755	0	180256009	4107731	
53758	4657	4163872	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	310505	0	399208008	4163872	
42058	3703	4107731	1992-06-27	1992-06-27 00:00:00	38000275	0	\N	\N	246301	0	180256009	4107731	
54047	4694	4107731	1995-12-31	1995-12-31 00:00:00	38000275	0	\N	\N	312711	0	180256009	4107731	
54393	4724	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	314751	0	180256009	4107731	
42527	3754	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	249495	0	180256009	4107731	
42821	3773	4326177	1960-05-01	1960-05-01 00:00:00	38000275	0	\N	\N	250803	0	430193006	4326177	
54861	4759	4181917	2016-04-19	2016-04-19 00:00:00	38000275	0	\N	\N	317071	0	54550000	4181917	
55121	4804	4107731	1993-01-18	1993-01-18 00:00:00	38000275	0	\N	\N	319560	0	180256009	4107731	
31413	2776	4107731	2006-09-19	2006-09-19 00:00:00	38000275	0	\N	\N	183824	0	180256009	4107731	
43487	3852	4107731	1992-11-16	1992-11-16 00:00:00	38000275	0	\N	\N	255733	0	180256009	4107731	
55625	4844	4047491	1965-12-05	1965-12-05 00:00:00	38000275	0	\N	\N	322279	0	1225002	4047491	
55906	4878	4107731	1991-11-09	1991-11-09 00:00:00	38000275	0	\N	\N	324390	0	180256009	4107731	
55980	4884	4062501	1975-10-28	1975-10-28 00:00:00	38000275	0	\N	\N	324726	0	171231001	4062501	
32297	2832	4238715	1988-08-14	1988-08-14 00:00:00	38000275	0	\N	\N	188000	0	68254000	4238715	
45044	3961	44783196	1974-11-05	1974-11-05 00:00:00	38000275	0	\N	\N	263348	0	699253003	44783196	
33260	2909	4117038	1970-12-28	1970-12-28 00:00:00	38000275	0	\N	\N	193908	0	287664005	4117038	
45419	4010	4181917	1979-05-17	1979-05-17 00:00:00	38000275	0	\N	\N	266490	0	54550000	4181917	
45770	4027	4107731	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	267850	0	180256009	4107731	
57995	5031	4181917	1941-05-24	1941-05-24 00:00:00	38000275	0	\N	\N	334344	0	54550000	4181917	
46243	4064	4107731	1991-02-04	1991-02-04 00:00:00	38000275	0	\N	\N	270020	0	180256009	4107731	
46518	4078	4107731	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	271040	0	180256009	4107731	
58662	5086	4243062	1978-04-02	1978-04-02 00:00:00	38000275	0	\N	\N	338199	0	60027007	4243062	
58747	5097	4107731	1993-02-14	1993-02-14 00:00:00	38000275	0	\N	\N	338632	0	180256009	4107731	
59128	5118	4151422	2013-08-18	2013-08-18 00:00:00	38000275	0	\N	\N	340237	0	269911007	4151422	
59532	5150	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	342392	0	180256009	4107731	
59660	5165	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	343271	0	180256009	4107731	
35931	3147	4035793	2004-03-22	2004-03-22 00:00:00	38000275	0	\N	\N	209408	0	15081005	4035793	
48102	4220	4125906	1995-04-21	1995-04-21 00:00:00	38000275	0	\N	\N	280152	0	288086009	4125906	
36347	3181	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	211681	0	180256009	4107731	
48524	4261	4057420	2010-01-24	2010-01-24 00:00:00	38000275	0	\N	\N	282955	0	18286008	4057420	
48661	4278	4337138	2000-06-09	2000-06-09 00:00:00	38000275	0	\N	\N	283936	0	88039007	4337138	
37026	3253	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	216377	0	180256009	4107731	
49042	4308	4062501	1915-08-28	1915-08-28 00:00:00	38000275	0	\N	\N	285714	0	171231001	4062501	
37390	3294	4198190	1977-10-13	1977-10-13 00:00:00	38000275	0	\N	\N	218835	0	80146002	4198190	
49376	4342	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	287923	0	180256009	4107731	
61586	5325	4024289	1948-11-21	1948-11-21 00:00:00	38000275	0	\N	\N	354435	0	19490002	4024289	
37874	3343	4043071	1987-02-24	1987-02-24 00:00:00	38000275	0	\N	\N	221833	0	228557008	4043071	
50075	4372	4107731	1995-02-23	1995-02-23 00:00:00	38000275	0	\N	\N	290269	0	180256009	4107731	
38295	3371	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	223623	0	180256009	4107731	
50489	4390	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	291827	0	180256009	4107731	
50569	4393	4170947	2016-08-28	2016-08-28 00:00:00	38000275	0	\N	\N	292102	0	274474001	4170947	
38842	3430	4170947	1972-10-15	1972-10-15 00:00:00	38000275	0	\N	\N	227329	0	274474001	4170947	
50934	4433	4057420	2011-07-23	2011-07-23 00:00:00	38000275	0	\N	\N	294696	0	18286008	4057420	
51395	4452	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	296221	0	180256009	4107731	
39465	3477	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	230728	0	180256009	4107731	
51615	4476	4107731	1990-07-15	1990-07-15 00:00:00	38000275	0	\N	\N	297807	0	180256009	4107731	
51809	4491	4151422	2018-06-08	2018-06-08 00:00:00	38000275	0	\N	\N	298987	0	269911007	4151422	
52043	4513	4145310	1976-03-27	1976-03-27 00:00:00	38000275	0	\N	\N	300569	0	268425006	4145310	
52243	4532	4195803	1984-03-03	1984-03-03 00:00:00	38000275	0	\N	\N	301893	0	312681000	4195803	
40514	3561	4243062	1943-12-04	1943-12-04 00:00:00	38000275	0	\N	\N	236470	0	60027007	4243062	
52593	4565	4252419	1962-07-14	1962-07-14 00:00:00	38000275	0	\N	\N	304208	0	74016001	4252419	
40950	3589	4107731	1996-03-11	1996-03-11 00:00:00	38000275	0	\N	\N	238493	0	180256009	4107731	
29151	2586	4043071	1981-11-07	1981-11-07 00:00:00	38000275	0	\N	\N	171152	0	228557008	4043071	
41266	3622	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	240671	0	180256009	4107731	
53315	4626	4107731	1998-08-21	1998-08-21 00:00:00	38000275	0	\N	\N	308262	0	180256009	4107731	
53627	4646	4078793	2017-06-06	2017-06-06 00:00:00	38000275	0	\N	\N	309790	0	180325003	4078793	
53759	4657	4252419	1995-06-06	1995-06-06 00:00:00	38000275	0	\N	\N	310510	0	74016001	4252419	
42059	3703	4107731	1993-04-17	1993-04-17 00:00:00	38000275	0	\N	\N	246226	0	180256009	4107731	
54048	4694	4024289	1998-02-11	1998-02-11 00:00:00	38000275	0	\N	\N	312719	0	19490002	4024289	
54394	4724	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	314832	0	180256009	4107731	
42528	3754	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	249521	0	180256009	4107731	
42822	3773	4187458	1960-05-01	1960-05-01 00:00:00	38000275	0	\N	\N	250803	0	415300000	4187458	
54862	4759	4125906	2017-01-02	2017-01-02 00:00:00	38000275	0	\N	\N	317072	0	288086009	4125906	
55122	4804	4107731	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	319617	0	180256009	4107731	
31414	2776	4107731	2007-04-17	2007-04-17 00:00:00	38000275	0	\N	\N	183803	0	180256009	4107731	
43488	3852	4107731	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	255763	0	180256009	4107731	
55626	4844	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	322229	0	395142003	4191853	
55907	4878	4107731	1992-06-06	1992-06-06 00:00:00	38000275	0	\N	\N	324450	0	180256009	4107731	
55984	4886	4058899	1973-08-25	1973-08-25 00:00:00	38000275	0	\N	\N	324931	0	168594001	4058899	
32298	2832	4275113	1980-02-10	1980-02-10 00:00:00	38000275	0	\N	\N	187910	0	65200003	4275113	
45045	3961	4202451	2014-10-28	2014-10-28 00:00:00	38000275	0	\N	\N	263347	0	433112001	4202451	
33261	2909	4035793	1992-04-26	1992-04-26 00:00:00	38000275	0	\N	\N	193920	0	15081005	4035793	
45420	4010	4326177	1999-04-30	1999-04-30 00:00:00	38000275	0	\N	\N	266454	0	430193006	4326177	
45771	4027	4107731	1992-02-22	1992-02-22 00:00:00	38000275	0	\N	\N	267783	0	180256009	4107731	
57996	5031	4170947	1990-08-17	1990-08-17 00:00:00	38000275	0	\N	\N	334281	0	274474001	4170947	
46244	4064	4107731	1990-10-01	1990-10-01 00:00:00	38000275	0	\N	\N	269991	0	180256009	4107731	
46519	4078	4107731	1993-03-01	1993-03-01 00:00:00	38000275	0	\N	\N	271090	0	180256009	4107731	
58663	5086	4170947	1978-04-02	1978-04-02 00:00:00	38000275	0	\N	\N	338199	0	274474001	4170947	
58748	5097	4107731	1994-11-27	1994-11-27 00:00:00	38000275	0	\N	\N	338734	0	180256009	4107731	
59129	5118	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	340170	0	180256009	4107731	
59533	5150	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	342409	0	395142003	4191853	
59661	5165	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	343273	0	180256009	4107731	
35932	3147	4035793	2001-03-05	2001-03-05 00:00:00	38000275	0	\N	\N	209365	0	15081005	4035793	
48103	4220	4058899	2012-08-10	2012-08-10 00:00:00	38000275	0	\N	\N	280153	0	168594001	4058899	
36348	3181	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	211812	0	180256009	4107731	
48525	4261	4078793	2014-02-16	2014-02-16 00:00:00	38000275	0	\N	\N	282957	0	180325003	4078793	
48662	4278	4035793	2013-11-08	2013-11-08 00:00:00	38000275	0	\N	\N	283867	0	15081005	4035793	
48857	4289	4037675	2005-07-03	2005-07-03 00:00:00	38000275	0	\N	\N	284752	0	162676008	4037675	
49043	4308	4170947	1925-05-06	1925-05-06 00:00:00	38000275	0	\N	\N	285772	0	274474001	4170947	
37391	3295	4078793	1995-05-29	1995-05-29 00:00:00	38000275	0	\N	\N	218978	0	180325003	4078793	
49377	4342	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	287962	0	180256009	4107731	
61587	5325	4170947	1948-11-21	1948-11-21 00:00:00	38000275	0	\N	\N	354435	0	274474001	4170947	
37875	3343	4107731	1990-10-28	1990-10-28 00:00:00	38000275	0	\N	\N	221725	0	180256009	4107731	
50076	4372	4107731	1995-01-12	1995-01-12 00:00:00	38000275	0	\N	\N	290255	0	180256009	4107731	
38296	3371	4295880	2006-08-18	2006-08-18 00:00:00	38000275	0	\N	\N	223572	0	76601001	4295880	
50490	4390	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	291872	0	180256009	4107731	
50570	4393	4243062	2016-08-28	2016-08-28 00:00:00	38000275	0	\N	\N	292102	0	60027007	4243062	
38843	3430	4243062	1972-10-15	1972-10-15 00:00:00	38000275	0	\N	\N	227329	0	60027007	4243062	
50935	4433	4195803	2015-12-12	2015-12-12 00:00:00	38000275	0	\N	\N	294731	0	312681000	4195803	
51396	4452	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	296252	0	180256009	4107731	
39466	3477	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	230634	0	180256009	4107731	
51616	4476	4107731	1991-05-05	1991-05-05 00:00:00	38000275	0	\N	\N	297821	0	180256009	4107731	
51810	4492	4058899	1959-05-19	1959-05-19 00:00:00	38000275	0	\N	\N	299047	0	168594001	4058899	
52044	4513	4151422	1978-12-05	1978-12-05 00:00:00	38000275	0	\N	\N	300519	0	269911007	4151422	
52244	4532	4058899	1984-03-03	1984-03-03 00:00:00	38000275	0	\N	\N	301893	0	168594001	4058899	
40515	3561	4170947	1943-12-04	1943-12-04 00:00:00	38000275	0	\N	\N	236470	0	274474001	4170947	
52594	4565	4125906	1955-12-13	1955-12-13 00:00:00	38000275	0	\N	\N	304210	0	288086009	4125906	
40951	3589	4191853	1997-07-08	1997-07-08 00:00:00	38000275	0	\N	\N	238474	0	395142003	4191853	
29152	2586	4043071	1982-03-06	1982-03-06 00:00:00	38000275	0	\N	\N	171153	0	228557008	4043071	
41267	3622	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	240804	0	180256009	4107731	
53316	4626	4107731	1998-04-17	1998-04-17 00:00:00	38000275	0	\N	\N	308152	0	180256009	4107731	
53628	4646	4078793	2019-06-18	2019-06-18 00:00:00	38000275	0	\N	\N	309791	0	180325003	4078793	
53760	4657	44783196	1995-06-13	1995-06-13 00:00:00	38000275	0	\N	\N	310574	0	699253003	44783196	
42060	3703	4107731	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	246216	0	180256009	4107731	
54049	4694	4170947	1998-02-11	1998-02-11 00:00:00	38000275	0	\N	\N	312719	0	274474001	4170947	
54395	4724	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	314672	0	180256009	4107731	
42529	3754	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	249425	0	180256009	4107731	
42823	3773	4037675	1960-05-01	1960-05-01 00:00:00	38000275	0	\N	\N	250803	0	162676008	4037675	
54863	4759	4181917	2012-11-06	2012-11-06 00:00:00	38000275	0	\N	\N	317068	0	54550000	4181917	
55123	4804	4107731	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	319637	0	180256009	4107731	
31415	2776	4107731	2007-01-02	2007-01-02 00:00:00	38000275	0	\N	\N	183877	0	180256009	4107731	
43489	3852	4107731	1991-09-23	1991-09-23 00:00:00	38000275	0	\N	\N	255647	0	180256009	4107731	
55627	4844	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	322257	0	180256009	4107731	
55908	4878	4107731	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	324425	0	180256009	4107731	
55985	4886	4058899	1970-11-09	1970-11-09 00:00:00	38000275	0	\N	\N	324930	0	168594001	4058899	
32299	2832	4107731	1996-01-06	1996-01-06 00:00:00	38000275	0	\N	\N	187963	0	180256009	4107731	
45046	3962	4293740	2015-09-03	2015-09-03 00:00:00	38000275	0	\N	\N	263467	0	384700001	4293740	
33262	2909	4035793	1984-04-08	1984-04-08 00:00:00	38000275	0	\N	\N	193919	0	15081005	4035793	
45421	4010	4037675	1999-04-30	1999-04-30 00:00:00	38000275	0	\N	\N	266454	0	162676008	4037675	
45772	4027	4107731	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	267849	0	180256009	4107731	
57997	5031	4243062	1990-08-17	1990-08-17 00:00:00	38000275	0	\N	\N	334281	0	60027007	4243062	
46245	4064	4107731	1992-06-01	1992-06-01 00:00:00	38000275	0	\N	\N	269981	0	180256009	4107731	
46520	4078	4107731	1992-12-07	1992-12-07 00:00:00	38000275	0	\N	\N	270995	0	180256009	4107731	
58682	5094	4191853	1999-05-19	1999-05-19 00:00:00	38000275	0	\N	\N	338442	0	395142003	4191853	
58749	5097	4107731	1993-07-11	1993-07-11 00:00:00	38000275	0	\N	\N	338699	0	180256009	4107731	
59130	5118	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	340176	0	180256009	4107731	
59534	5150	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	342396	0	180256009	4107731	
59662	5165	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	343264	0	180256009	4107731	
35933	3147	4035793	2005-03-28	2005-03-28 00:00:00	38000275	0	\N	\N	209347	0	15081005	4035793	
48104	4220	4195803	2012-08-10	2012-08-10 00:00:00	38000275	0	\N	\N	280153	0	312681000	4195803	
36349	3181	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	211644	0	180256009	4107731	
48526	4261	4195803	1982-05-09	1982-05-09 00:00:00	38000275	0	\N	\N	282950	0	312681000	4195803	
48663	4278	4035793	2003-09-12	2003-09-12 00:00:00	38000275	0	\N	\N	283848	0	15081005	4035793	
48858	4289	4326177	2005-07-03	2005-07-03 00:00:00	38000275	0	\N	\N	284752	0	430193006	4326177	
49044	4308	4047491	1925-05-06	1925-05-06 00:00:00	38000275	0	\N	\N	285772	0	1225002	4047491	
37392	3295	4078793	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	218938	0	180325003	4078793	
49378	4342	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	287951	0	180256009	4107731	
61588	5325	4170947	1955-01-10	1955-01-10 00:00:00	38000275	0	\N	\N	354437	0	274474001	4170947	
37876	3343	4043071	1987-09-15	1987-09-15 00:00:00	38000275	0	\N	\N	221757	0	228557008	4043071	
50077	4372	4107731	1994-10-20	1994-10-20 00:00:00	38000275	0	\N	\N	290253	0	180256009	4107731	
38297	3371	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	223538	0	180256009	4107731	
50571	4393	4151422	1995-10-20	1995-10-20 00:00:00	38000275	0	\N	\N	292087	0	269911007	4151422	
38844	3430	4337138	2005-05-14	2005-05-14 00:00:00	38000275	0	\N	\N	227361	0	88039007	4337138	
50936	4433	4243062	2015-12-12	2015-12-12 00:00:00	38000275	0	\N	\N	294731	0	60027007	4243062	
51397	4452	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	296219	0	180256009	4107731	
39467	3477	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	230620	0	180256009	4107731	
51617	4476	4107731	1990-08-26	1990-08-26 00:00:00	38000275	0	\N	\N	297808	0	180256009	4107731	
51811	4492	4058899	1964-03-23	1964-03-23 00:00:00	38000275	0	\N	\N	299048	0	168594001	4058899	
52045	4513	4170947	1978-01-16	1978-01-16 00:00:00	38000275	0	\N	\N	300570	0	274474001	4170947	
52245	4532	4151422	1983-02-02	1983-02-02 00:00:00	38000275	0	\N	\N	301847	0	269911007	4151422	
40516	3561	4078793	2015-10-19	2015-10-19 00:00:00	38000275	0	\N	\N	236481	0	180325003	4078793	
52595	4565	4293740	1955-12-13	1955-12-13 00:00:00	38000275	0	\N	\N	304210	0	384700001	4293740	
40952	3589	4107731	1994-03-07	1994-03-07 00:00:00	38000275	0	\N	\N	238477	0	180256009	4107731	
29153	2586	4043071	1984-03-24	1984-03-24 00:00:00	38000275	0	\N	\N	171196	0	228557008	4043071	
41268	3622	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	240741	0	180256009	4107731	
53317	4626	4107731	1999-07-02	1999-07-02 00:00:00	38000275	0	\N	\N	308265	0	180256009	4107731	
53629	4646	4078793	2006-11-07	2006-11-07 00:00:00	38000275	0	\N	\N	309841	0	180325003	4078793	
53762	4660	4151422	1995-11-24	1995-11-24 00:00:00	38000275	0	\N	\N	310599	0	269911007	4151422	
42061	3703	4107731	1990-07-14	1990-07-14 00:00:00	38000275	0	\N	\N	246214	0	180256009	4107731	
54050	4694	4107731	1996-07-28	1996-07-28 00:00:00	38000275	0	\N	\N	312661	0	180256009	4107731	
54396	4724	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	314753	0	180256009	4107731	
42530	3754	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	249533	0	180256009	4107731	
54619	4739	4151422	1930-08-05	1930-08-05 00:00:00	38000275	0	\N	\N	315682	0	269911007	4151422	
54864	4759	4181917	2012-12-25	2012-12-25 00:00:00	38000275	0	\N	\N	317069	0	54550000	4181917	
55124	4804	4107731	1992-01-06	1992-01-06 00:00:00	38000275	0	\N	\N	319627	0	180256009	4107731	
31416	2776	4107731	2008-12-16	2008-12-16 00:00:00	38000275	0	\N	\N	183867	0	180256009	4107731	
43490	3852	4107731	1992-01-06	1992-01-06 00:00:00	38000275	0	\N	\N	255729	0	180256009	4107731	
55628	4844	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	322196	0	180256009	4107731	
55909	4878	4107731	1993-04-17	1993-04-17 00:00:00	38000275	0	\N	\N	324318	0	180256009	4107731	
55986	4886	4151422	2005-04-06	2005-04-06 00:00:00	38000275	0	\N	\N	324880	0	269911007	4151422	
32300	2832	4107731	1996-03-09	1996-03-09 00:00:00	38000275	0	\N	\N	187926	0	180256009	4107731	
45047	3962	4125906	2015-09-03	2015-09-03 00:00:00	38000275	0	\N	\N	263467	0	288086009	4125906	
33263	2909	4337138	1988-06-26	1988-06-26 00:00:00	38000275	0	\N	\N	193892	0	88039007	4337138	
45422	4010	4187458	1999-04-30	1999-04-30 00:00:00	38000275	0	\N	\N	266454	0	415300000	4187458	
45773	4027	4107731	1990-10-06	1990-10-06 00:00:00	38000275	0	\N	\N	267900	0	180256009	4107731	
57998	5031	4195803	1990-08-17	1990-08-17 00:00:00	38000275	0	\N	\N	334281	0	312681000	4195803	
46246	4064	4243062	1969-11-18	1969-11-18 00:00:00	38000275	0	\N	\N	269997	0	60027007	4243062	
46521	4078	4107731	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	270951	0	180256009	4107731	
58683	5094	4058899	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	338493	0	168594001	4058899	
58758	5099	4125906	1978-11-27	1978-11-27 00:00:00	38000275	0	\N	\N	338866	0	288086009	4125906	
59131	5118	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	340246	0	180256009	4107731	
59535	5150	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	342476	0	180256009	4107731	
59663	5165	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	343331	0	180256009	4107731	
35934	3147	4035793	2007-04-09	2007-04-09 00:00:00	38000275	0	\N	\N	209348	0	15081005	4035793	
48105	4220	4163872	1992-03-29	1992-03-29 00:00:00	38000275	0	\N	\N	280209	0	399208008	4163872	
36350	3181	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	211628	0	180256009	4107731	
48527	4261	4078793	2017-03-05	2017-03-05 00:00:00	38000275	0	\N	\N	282929	0	180325003	4078793	
48664	4279	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	283976	0	180256009	4107731	
48859	4289	4187458	2005-07-03	2005-07-03 00:00:00	38000275	0	\N	\N	284752	0	415300000	4187458	
49092	4312	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	286086	0	180256009	4107731	
37393	3295	4078793	2002-12-09	2002-12-09 00:00:00	38000275	0	\N	\N	218960	0	180325003	4078793	
49379	4342	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	287895	0	180256009	4107731	
61589	5325	4024289	1955-01-10	1955-01-10 00:00:00	38000275	0	\N	\N	354437	0	19490002	4024289	
37877	3343	4107731	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	221784	0	180256009	4107731	
50078	4372	4107731	1993-10-28	1993-10-28 00:00:00	38000275	0	\N	\N	290319	0	180256009	4107731	
38298	3371	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	223554	0	180256009	4107731	
50572	4394	4058899	2000-08-12	2000-08-12 00:00:00	38000275	0	\N	\N	292168	0	168594001	4058899	
38845	3430	4035793	2018-05-19	2018-05-19 00:00:00	38000275	0	\N	\N	227330	0	15081005	4035793	
50937	4433	4170947	2015-12-12	2015-12-12 00:00:00	38000275	0	\N	\N	294731	0	274474001	4170947	
51398	4452	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	296260	0	180256009	4107731	
39468	3477	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	230654	0	180256009	4107731	
51618	4476	4107731	1993-02-14	1993-02-14 00:00:00	38000275	0	\N	\N	297799	0	180256009	4107731	
51812	4492	4125906	1996-12-21	1996-12-21 00:00:00	38000275	0	\N	\N	299095	0	288086009	4125906	
52046	4513	4047491	1978-01-16	1978-01-16 00:00:00	38000275	0	\N	\N	300570	0	1225002	4047491	
52246	4532	4198190	1946-04-10	1946-04-10 00:00:00	38000275	0	\N	\N	301940	0	80146002	4198190	
40517	3561	4057420	1980-08-11	1980-08-11 00:00:00	38000275	0	\N	\N	236437	0	18286008	4057420	
52596	4565	4151422	1972-02-18	1972-02-18 00:00:00	38000275	0	\N	\N	304217	0	269911007	4151422	
40953	3589	4107731	1996-08-06	1996-08-06 00:00:00	38000275	0	\N	\N	238440	0	180256009	4107731	
29154	2586	4043071	1982-05-08	1982-05-08 00:00:00	38000275	0	\N	\N	171210	0	228557008	4043071	
41269	3622	4078793	2012-03-21	2012-03-21 00:00:00	38000275	0	\N	\N	240765	0	180325003	4078793	
53318	4626	4107731	1998-07-31	1998-07-31 00:00:00	38000275	0	\N	\N	308237	0	180256009	4107731	
53630	4646	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	309811	0	180256009	4107731	
53763	4662	4125906	1998-07-29	1998-07-29 00:00:00	38000275	0	\N	\N	310774	0	288086009	4125906	
42062	3703	4107731	1993-03-27	1993-03-27 00:00:00	38000275	0	\N	\N	246304	0	180256009	4107731	
54051	4694	4107731	1996-03-03	1996-03-03 00:00:00	38000275	0	\N	\N	312743	0	180256009	4107731	
54397	4724	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	314779	0	180256009	4107731	
42531	3754	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	249529	0	180256009	4107731	
54620	4739	4151422	1919-09-15	1919-09-15 00:00:00	38000275	0	\N	\N	315732	0	269911007	4151422	
54865	4760	4252419	1956-10-16	1956-10-16 00:00:00	38000275	0	\N	\N	317194	0	74016001	4252419	
55125	4804	4107731	1991-03-18	1991-03-18 00:00:00	38000275	0	\N	\N	319609	0	180256009	4107731	
43198	3814	4295880	1994-02-06	1994-02-06 00:00:00	38000275	0	\N	\N	253358	0	76601001	4295880	
43491	3852	4107731	1991-02-25	1991-02-25 00:00:00	38000275	0	\N	\N	255656	0	180256009	4107731	
55629	4844	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	322182	0	180256009	4107731	
55910	4878	4107731	1992-10-10	1992-10-10 00:00:00	38000275	0	\N	\N	324453	0	180256009	4107731	
55987	4886	4058899	1982-06-07	1982-06-07 00:00:00	38000275	0	\N	\N	324933	0	168594001	4058899	
32301	2832	4107731	1994-03-26	1994-03-26 00:00:00	38000275	0	\N	\N	187946	0	180256009	4107731	
45048	3962	4293740	1981-09-21	1981-09-21 00:00:00	38000275	0	\N	\N	263463	0	384700001	4293740	
33264	2909	4035793	1986-04-13	1986-04-13 00:00:00	38000275	0	\N	\N	193924	0	15081005	4035793	
45423	4010	4181917	1978-10-19	1978-10-19 00:00:00	38000275	0	\N	\N	266488	0	54550000	4181917	
45774	4027	4107731	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	267838	0	180256009	4107731	
57999	5031	4151422	2015-01-07	2015-01-07 00:00:00	38000275	0	\N	\N	334322	0	269911007	4151422	
46247	4064	4170947	1969-11-18	1969-11-18 00:00:00	38000275	0	\N	\N	269997	0	274474001	4170947	
46522	4078	4107731	1990-02-12	1990-02-12 00:00:00	38000275	0	\N	\N	271018	0	180256009	4107731	
58684	5095	4202451	2007-01-15	2007-01-15 00:00:00	38000275	0	\N	\N	338519	0	433112001	4202451	
58760	5101	4145310	2002-12-17	2002-12-17 00:00:00	38000275	0	\N	\N	338977	0	268425006	4145310	
59132	5118	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	340212	0	180256009	4107731	
59536	5150	4125906	1970-11-01	1970-11-01 00:00:00	38000275	0	\N	\N	342335	0	288086009	4125906	
59664	5165	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	343252	0	180256009	4107731	
35935	3147	4035793	2003-03-17	2003-03-17 00:00:00	38000275	0	\N	\N	209366	0	15081005	4035793	
48108	4223	4151422	1973-02-27	1973-02-27 00:00:00	38000275	0	\N	\N	280392	0	269911007	4151422	
36351	3181	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	211762	0	180256009	4107731	
48528	4261	4078793	2015-02-22	2015-02-22 00:00:00	38000275	0	\N	\N	282919	0	180325003	4078793	
48665	4279	4151422	1980-12-23	1980-12-23 00:00:00	38000275	0	\N	\N	283951	0	269911007	4151422	
48860	4289	4125906	1965-03-25	1965-03-25 00:00:00	38000275	0	\N	\N	284741	0	288086009	4125906	
49093	4312	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	286217	0	180256009	4107731	
37394	3295	4078793	2005-03-14	2005-03-14 00:00:00	38000275	0	\N	\N	218961	0	180325003	4078793	
49380	4342	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	287928	0	180256009	4107731	
61590	5325	4125906	1952-01-05	1952-01-05 00:00:00	38000275	0	\N	\N	354436	0	288086009	4125906	
37878	3343	4043071	1987-10-20	1987-10-20 00:00:00	38000275	0	\N	\N	221758	0	228557008	4043071	
50079	4372	4107731	1994-03-03	1994-03-03 00:00:00	38000275	0	\N	\N	290251	0	180256009	4107731	
38299	3371	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	223628	0	180256009	4107731	
50573	4395	4010253	2014-02-11	2014-02-11 00:00:00	38000275	0	\N	\N	292244	0	112790001	4010253	
38846	3430	4202451	2011-10-08	2011-10-08 00:00:00	38000275	0	\N	\N	227336	0	433112001	4202451	
50938	4433	4078793	2009-07-11	2009-07-11 00:00:00	38000275	0	\N	\N	294717	0	180325003	4078793	
51399	4452	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	296217	0	180256009	4107731	
39469	3477	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	230656	0	180256009	4107731	
51619	4476	4107731	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	297843	0	180256009	4107731	
51813	4492	4010253	1958-09-06	1958-09-06 00:00:00	38000275	0	\N	\N	299082	0	112790001	4010253	
52047	4513	4047491	2004-08-02	2004-08-02 00:00:00	38000275	0	\N	\N	300588	0	1225002	4047491	
52247	4532	4151422	1943-04-20	1943-04-20 00:00:00	38000275	0	\N	\N	301831	0	269911007	4151422	
40518	3561	4057420	1979-08-06	1979-08-06 00:00:00	38000275	0	\N	\N	236465	0	18286008	4057420	
52597	4565	4170947	2016-11-04	2016-11-04 00:00:00	38000275	0	\N	\N	304213	0	274474001	4170947	
52809	4586	4010253	1964-08-28	1964-08-28 00:00:00	38000275	0	\N	\N	305506	0	112790001	4010253	
29155	2586	4043071	1983-04-16	1983-04-16 00:00:00	38000275	0	\N	\N	171188	0	228557008	4043071	
41270	3622	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	240794	0	180256009	4107731	
53319	4626	4107731	1999-01-15	1999-01-15 00:00:00	38000275	0	\N	\N	308155	0	180256009	4107731	
53631	4646	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	309823	0	180256009	4107731	
53764	4662	4125906	1953-04-21	1953-04-21 00:00:00	38000275	0	\N	\N	310770	0	288086009	4125906	
42063	3703	4107731	1990-10-06	1990-10-06 00:00:00	38000275	0	\N	\N	246288	0	180256009	4107731	
54052	4694	4107731	1994-11-06	1994-11-06 00:00:00	38000275	0	\N	\N	312653	0	180256009	4107731	
54398	4724	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	314778	0	180256009	4107731	
42532	3754	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	249478	0	180256009	4107731	
54621	4739	4125906	1913-09-07	1913-09-07 00:00:00	38000275	0	\N	\N	315723	0	288086009	4125906	
54866	4760	4202451	2018-03-28	2018-03-28 00:00:00	38000275	0	\N	\N	317165	0	433112001	4202451	
55126	4804	4107731	1991-02-04	1991-02-04 00:00:00	38000275	0	\N	\N	319608	0	180256009	4107731	
43199	3814	4295880	1999-08-01	1999-08-01 00:00:00	38000275	0	\N	\N	253329	0	76601001	4295880	
43492	3852	4107731	1990-03-05	1990-03-05 00:00:00	38000275	0	\N	\N	255651	0	180256009	4107731	
55630	4844	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	322294	0	180256009	4107731	
55911	4878	4107731	1992-01-11	1992-01-11 00:00:00	38000275	0	\N	\N	324434	0	180256009	4107731	
55988	4886	4243062	1968-07-22	1968-07-22 00:00:00	38000275	0	\N	\N	324929	0	60027007	4243062	
32302	2832	4107731	1997-07-05	1997-07-05 00:00:00	38000275	0	\N	\N	187906	0	180256009	4107731	
45049	3962	4125906	1981-09-21	1981-09-21 00:00:00	38000275	0	\N	\N	263463	0	288086009	4125906	
33265	2909	4035793	2001-06-10	2001-06-10 00:00:00	38000275	0	\N	\N	193878	0	15081005	4035793	
45424	4010	4199276	2001-10-25	2001-10-25 00:00:00	38000275	0	\N	\N	266458	0	301807007	4199276	
45775	4027	4107731	1991-07-06	1991-07-06 00:00:00	38000275	0	\N	\N	267903	0	180256009	4107731	
58000	5031	4202451	1995-08-19	1995-08-19 00:00:00	38000275	0	\N	\N	334282	0	433112001	4202451	
46248	4064	4107731	1990-02-12	1990-02-12 00:00:00	38000275	0	\N	\N	270014	0	180256009	4107731	
46523	4078	4107731	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	270982	0	180256009	4107731	
58685	5096	4151422	2000-09-02	2000-09-02 00:00:00	38000275	0	\N	\N	338579	0	269911007	4151422	
58761	5101	4125906	2004-09-07	2004-09-07 00:00:00	38000275	0	\N	\N	338978	0	288086009	4125906	
59133	5118	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	340250	0	180256009	4107731	
59537	5150	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	342363	0	180256009	4107731	
59665	5165	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	343339	0	180256009	4107731	
35936	3147	4035793	2013-05-13	2013-05-13 00:00:00	38000275	0	\N	\N	209410	0	15081005	4035793	
48109	4223	4170947	1973-05-01	1973-05-01 00:00:00	38000275	0	\N	\N	280379	0	274474001	4170947	
36352	3181	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	211674	0	180256009	4107731	
48529	4261	4078793	2019-03-17	2019-03-17 00:00:00	38000275	0	\N	\N	282945	0	180325003	4078793	
48666	4279	4195803	2011-07-21	2011-07-21 00:00:00	38000275	0	\N	\N	284092	0	312681000	4195803	
48861	4289	4125906	1994-06-26	1994-06-26 00:00:00	38000275	0	\N	\N	284743	0	288086009	4125906	
49094	4312	4275113	1973-09-14	1973-09-14 00:00:00	38000275	0	\N	\N	286111	0	65200003	4275113	
37395	3295	4078793	1999-11-22	1999-11-22 00:00:00	38000275	0	\N	\N	218940	0	180325003	4078793	
49381	4342	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	287936	0	180256009	4107731	
61593	5328	4125906	1995-09-13	1995-09-13 00:00:00	38000275	0	\N	\N	354591	0	288086009	4125906	
37879	3343	4107731	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	221713	0	180256009	4107731	
50080	4372	4107731	1996-10-24	1996-10-24 00:00:00	38000275	0	\N	\N	290230	0	180256009	4107731	
38300	3371	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	223610	0	180256009	4107731	
50574	4395	4243062	1960-11-27	1960-11-27 00:00:00	38000275	0	\N	\N	292237	0	60027007	4243062	
38847	3430	4035793	2011-04-09	2011-04-09 00:00:00	38000275	0	\N	\N	227336	0	15081005	4035793	
50939	4433	4078793	2006-06-24	2006-06-24 00:00:00	38000275	0	\N	\N	294652	0	180325003	4078793	
51400	4452	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	296332	0	180256009	4107731	
39470	3477	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	230652	0	180256009	4107731	
51620	4476	4107731	1990-04-01	1990-04-01 00:00:00	38000275	0	\N	\N	297831	0	180256009	4107731	
51814	4492	4202451	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	299101	0	433112001	4202451	
52048	4513	4170947	2004-08-02	2004-08-02 00:00:00	38000275	0	\N	\N	300588	0	274474001	4170947	
52248	4532	4125906	1946-03-04	1946-03-04 00:00:00	38000275	0	\N	\N	301938	0	288086009	4125906	
40519	3561	4151422	1930-09-23	1930-09-23 00:00:00	38000275	0	\N	\N	236496	0	269911007	4151422	
52598	4565	4047491	2016-11-04	2016-11-04 00:00:00	38000275	0	\N	\N	304213	0	1225002	4047491	
52810	4587	44783196	1960-04-08	1960-04-08 00:00:00	38000275	0	\N	\N	305634	0	699253003	44783196	
29156	2586	4043071	1983-07-23	1983-07-23 00:00:00	38000275	0	\N	\N	171143	0	228557008	4043071	
41271	3622	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	240749	0	180256009	4107731	
53320	4626	4107731	2000-04-21	2000-04-21 00:00:00	38000275	0	\N	\N	308248	0	180256009	4107731	
53632	4646	4078793	2015-05-26	2015-05-26 00:00:00	38000275	0	\N	\N	309749	0	180325003	4078793	
53765	4662	4243062	1965-01-02	1965-01-02 00:00:00	38000275	0	\N	\N	310771	0	60027007	4243062	
42064	3703	4107731	1993-02-13	1993-02-13 00:00:00	38000275	0	\N	\N	246303	0	180256009	4107731	
54056	4696	4151422	1958-12-31	1958-12-31 00:00:00	38000275	0	\N	\N	312833	0	269911007	4151422	
54399	4724	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	314833	0	180256009	4107731	
42533	3754	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	249424	0	180256009	4107731	
54622	4739	4151422	1962-08-08	1962-08-08 00:00:00	38000275	0	\N	\N	315702	0	269911007	4151422	
54867	4760	4151422	1971-03-04	1971-03-04 00:00:00	38000275	0	\N	\N	317142	0	269911007	4151422	
55127	4804	4107731	1993-03-01	1993-03-01 00:00:00	38000275	0	\N	\N	319561	0	180256009	4107731	
43200	3814	4295880	1998-02-01	1998-02-01 00:00:00	38000275	0	\N	\N	253327	0	76601001	4295880	
43493	3852	4107731	1991-03-18	1991-03-18 00:00:00	38000275	0	\N	\N	255646	0	180256009	4107731	
55631	4844	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	322191	0	180256009	4107731	
55912	4878	4107731	1990-12-08	1990-12-08 00:00:00	38000275	0	\N	\N	324381	0	180256009	4107731	
55989	4886	4170947	1968-07-22	1968-07-22 00:00:00	38000275	0	\N	\N	324929	0	274474001	4170947	
32303	2832	4107731	1995-04-29	1995-04-29 00:00:00	38000275	0	\N	\N	187952	0	180256009	4107731	
45050	3962	4151422	1963-10-13	1963-10-13 00:00:00	38000275	0	\N	\N	263476	0	269911007	4151422	
33266	2909	4035793	1981-04-05	1981-04-05 00:00:00	38000275	0	\N	\N	193918	0	15081005	4035793	
45425	4010	44805732	1995-05-04	1995-05-04 00:00:00	38000275	0	\N	\N	266518	0	755621000000101	44805732	
45776	4027	4107731	1991-01-19	1991-01-19 00:00:00	38000275	0	\N	\N	267837	0	180256009	4107731	
58001	5031	4181917	1941-02-01	1941-02-01 00:00:00	38000275	0	\N	\N	334343	0	54550000	4181917	
46249	4064	4107731	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	270041	0	180256009	4107731	
46524	4078	4107731	1990-07-09	1990-07-09 00:00:00	38000275	0	\N	\N	270954	0	180256009	4107731	
58686	5097	4107731	1992-11-22	1992-11-22 00:00:00	38000275	0	\N	\N	338630	0	180256009	4107731	
58763	5103	4043071	1957-11-04	1957-11-04 00:00:00	38000275	0	\N	\N	339118	0	228557008	4043071	
59134	5118	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	340168	0	180256009	4107731	
59538	5150	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	342473	0	180256009	4107731	
59666	5165	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	343283	0	180256009	4107731	
35937	3147	4035793	2015-05-25	2015-05-25 00:00:00	38000275	0	\N	\N	209411	0	15081005	4035793	
48110	4223	4163872	1973-05-01	1973-05-01 00:00:00	38000275	0	\N	\N	280379	0	399208008	4163872	
36353	3181	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	211819	0	180256009	4107731	
48530	4261	4078793	2018-03-11	2018-03-11 00:00:00	38000275	0	\N	\N	282959	0	180325003	4078793	
48667	4279	4163872	2011-07-21	2011-07-21 00:00:00	38000275	0	\N	\N	284092	0	399208008	4163872	
48862	4289	4151422	2018-01-18	2018-01-18 00:00:00	38000275	0	\N	\N	284755	0	269911007	4151422	
49095	4312	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	286048	0	180256009	4107731	
37396	3295	4078793	2006-03-20	2006-03-20 00:00:00	38000275	0	\N	\N	218943	0	180325003	4078793	
49382	4342	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	287967	0	180256009	4107731	
61594	5328	4170947	1955-02-03	1955-02-03 00:00:00	38000275	0	\N	\N	354588	0	274474001	4170947	
37880	3343	4107731	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	221852	0	180256009	4107731	
50081	4372	4107731	1995-11-02	1995-11-02 00:00:00	38000275	0	\N	\N	290305	0	180256009	4107731	
38301	3371	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	223535	0	180256009	4107731	
50575	4395	4170947	1960-11-27	1960-11-27 00:00:00	38000275	0	\N	\N	292237	0	274474001	4170947	
38848	3430	4035793	2003-03-22	2003-03-22 00:00:00	38000275	0	\N	\N	227335	0	15081005	4035793	
50940	4433	4078793	2017-08-26	2017-08-26 00:00:00	38000275	0	\N	\N	294699	0	180325003	4078793	
51401	4452	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	296218	0	180256009	4107731	
39471	3477	4107731	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	230716	0	180256009	4107731	
51621	4476	4107731	1992-05-17	1992-05-17 00:00:00	38000275	0	\N	\N	297796	0	180256009	4107731	
51815	4492	4170947	1975-01-25	1975-01-25 00:00:00	38000275	0	\N	\N	299091	0	274474001	4170947	
52049	4513	4151422	1969-02-03	1969-02-03 00:00:00	38000275	0	\N	\N	300580	0	269911007	4151422	
52265	4534	4043071	1956-01-30	1956-01-30 00:00:00	38000275	0	\N	\N	302055	0	228557008	4043071	
40520	3561	4057420	2016-10-24	2016-10-24 00:00:00	38000275	0	\N	\N	236545	0	18286008	4057420	
52599	4565	4195803	2016-11-04	2016-11-04 00:00:00	38000275	0	\N	\N	304213	0	312681000	4195803	
52811	4587	4243062	1940-01-17	1940-01-17 00:00:00	38000275	0	\N	\N	305566	0	60027007	4243062	
29157	2586	4043071	1981-10-03	1981-10-03 00:00:00	38000275	0	\N	\N	171151	0	228557008	4043071	
41272	3622	4078793	2009-03-04	2009-03-04 00:00:00	38000275	0	\N	\N	240725	0	180325003	4078793	
53321	4626	4107731	2001-02-09	2001-02-09 00:00:00	38000275	0	\N	\N	308186	0	180256009	4107731	
53633	4646	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	309822	0	180256009	4107731	
53766	4662	4170947	1965-01-02	1965-01-02 00:00:00	38000275	0	\N	\N	310771	0	274474001	4170947	
42065	3703	4107731	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	246220	0	180256009	4107731	
54057	4696	4151422	1954-12-24	1954-12-24 00:00:00	38000275	0	\N	\N	312853	0	269911007	4151422	
54400	4724	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	314699	0	180256009	4107731	
42534	3754	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	249447	0	180256009	4107731	
54623	4739	4125906	1950-10-03	1950-10-03 00:00:00	38000275	0	\N	\N	315728	0	288086009	4125906	
54868	4760	4058899	1969-05-18	1969-05-18 00:00:00	38000275	0	\N	\N	317197	0	168594001	4058899	
55128	4804	4107731	1993-02-08	1993-02-08 00:00:00	38000275	0	\N	\N	319584	0	180256009	4107731	
43201	3814	4295880	1998-08-02	1998-08-02 00:00:00	38000275	0	\N	\N	253372	0	76601001	4295880	
43494	3852	4107731	1991-04-29	1991-04-29 00:00:00	38000275	0	\N	\N	255673	0	180256009	4107731	
55632	4844	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	322261	0	180256009	4107731	
55913	4878	4107731	1990-03-31	1990-03-31 00:00:00	38000275	0	\N	\N	324405	0	180256009	4107731	
55990	4886	4151422	1989-08-12	1989-08-12 00:00:00	38000275	0	\N	\N	324889	0	269911007	4151422	
32304	2832	4107731	1996-10-05	1996-10-05 00:00:00	38000275	0	\N	\N	187967	0	180256009	4107731	
56879	4942	4078793	2006-05-11	2006-05-11 00:00:00	38000275	0	\N	\N	328522	0	180325003	4078793	
33270	2913	4058899	1948-01-14	1948-01-14 00:00:00	38000275	0	\N	\N	194138	0	168594001	4058899	
45426	4010	4151422	2006-01-13	2006-01-13 00:00:00	38000275	0	\N	\N	266494	0	269911007	4151422	
45777	4027	4107731	1991-05-04	1991-05-04 00:00:00	38000275	0	\N	\N	267862	0	180256009	4107731	
58002	5031	4181917	1948-10-02	1948-10-02 00:00:00	38000275	0	\N	\N	334277	0	54550000	4181917	
46250	4064	4107731	1992-03-30	1992-03-30 00:00:00	38000275	0	\N	\N	270040	0	180256009	4107731	
46525	4078	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	270996	0	180256009	4107731	
58687	5097	4107731	1994-07-03	1994-07-03 00:00:00	38000275	0	\N	\N	338704	0	180256009	4107731	
58764	5103	4125906	1962-02-20	1962-02-20 00:00:00	38000275	0	\N	\N	339105	0	288086009	4125906	
59135	5118	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	340203	0	180256009	4107731	
59539	5150	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	342402	0	180256009	4107731	
59667	5165	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	343334	0	180256009	4107731	
35938	3147	4035793	2014-05-19	2014-05-19 00:00:00	38000275	0	\N	\N	209368	0	15081005	4035793	
48111	4223	4243062	1972-04-06	1972-04-06 00:00:00	38000275	0	\N	\N	280378	0	60027007	4243062	
36354	3181	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	211817	0	180256009	4107731	
48531	4261	4078793	2012-02-05	2012-02-05 00:00:00	38000275	0	\N	\N	282956	0	180325003	4078793	
48668	4279	4170947	2011-07-21	2011-07-21 00:00:00	38000275	0	\N	\N	284092	0	274474001	4170947	
48863	4289	4125906	1967-01-28	1967-01-28 00:00:00	38000275	0	\N	\N	284742	0	288086009	4125906	
49096	4312	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	286079	0	180256009	4107731	
37397	3295	4078793	2000-11-27	2000-11-27 00:00:00	38000275	0	\N	\N	218959	0	180325003	4078793	
49383	4342	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	287932	0	180256009	4107731	
61595	5328	4047491	1955-02-03	1955-02-03 00:00:00	38000275	0	\N	\N	354588	0	1225002	4047491	
37881	3343	4107731	1990-12-30	1990-12-30 00:00:00	38000275	0	\N	\N	221866	0	180256009	4107731	
50082	4372	4252419	1993-10-27	1993-10-27 00:00:00	38000275	0	\N	\N	290286	0	74016001	4252419	
38302	3371	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	223607	0	180256009	4107731	
50576	4395	4024289	1949-10-26	1949-10-26 00:00:00	38000275	0	\N	\N	292236	0	19490002	4024289	
38849	3430	4035793	2015-05-02	2015-05-02 00:00:00	38000275	0	\N	\N	227356	0	15081005	4035793	
50941	4433	4078793	1997-05-03	1997-05-03 00:00:00	38000275	0	\N	\N	294712	0	180325003	4078793	
51402	4452	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	296215	0	180256009	4107731	
39472	3477	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	230638	0	180256009	4107731	
51622	4476	4107731	1991-12-01	1991-12-01 00:00:00	38000275	0	\N	\N	297767	0	180256009	4107731	
51816	4492	4243062	1975-01-25	1975-01-25 00:00:00	38000275	0	\N	\N	299091	0	60027007	4243062	
52050	4513	4163872	1966-03-01	1966-03-01 00:00:00	38000275	0	\N	\N	300579	0	399208008	4163872	
52266	4534	4216130	2011-11-30	2011-11-30 00:00:00	38000275	0	\N	\N	302079	0	415070008	4216130	
40521	3561	4078793	1997-11-17	1997-11-17 00:00:00	38000275	0	\N	\N	236564	0	180325003	4078793	
52600	4565	44783196	1962-07-21	1962-07-21 00:00:00	38000275	0	\N	\N	304206	0	699253003	44783196	
52812	4587	4170947	1940-01-17	1940-01-17 00:00:00	38000275	0	\N	\N	305566	0	274474001	4170947	
29158	2586	4043071	1981-08-29	1981-08-29 00:00:00	38000275	0	\N	\N	171127	0	228557008	4043071	
41273	3622	4078793	2008-02-27	2008-02-27 00:00:00	38000275	0	\N	\N	240722	0	180325003	4078793	
53322	4626	4107731	1999-06-11	1999-06-11 00:00:00	38000275	0	\N	\N	308241	0	180256009	4107731	
53634	4646	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	309764	0	180256009	4107731	
53767	4662	4163951	1989-07-27	1989-07-27 00:00:00	38000275	0	\N	\N	310773	0	29303009	4163951	
42066	3703	4107731	1993-05-08	1993-05-08 00:00:00	38000275	0	\N	\N	246295	0	180256009	4107731	
54058	4696	4125906	2017-06-30	2017-06-30 00:00:00	38000275	0	\N	\N	312836	0	288086009	4125906	
54401	4724	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	314728	0	180256009	4107731	
42535	3754	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	249479	0	180256009	4107731	
54624	4739	4197460	1915-03-31	1915-03-31 00:00:00	38000275	0	\N	\N	315724	0	313191000	4197460	
54869	4760	4293740	2012-11-28	2012-11-28 00:00:00	38000275	0	\N	\N	317199	0	384700001	4293740	
55129	4804	4191853	1993-09-27	1993-09-27 00:00:00	38000275	0	\N	\N	319586	0	395142003	4191853	
43202	3814	4295880	1998-05-03	1998-05-03 00:00:00	38000275	0	\N	\N	253390	0	76601001	4295880	
43495	3852	4107731	1990-08-20	1990-08-20 00:00:00	38000275	0	\N	\N	255759	0	180256009	4107731	
55633	4844	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	322187	0	180256009	4107731	
55991	4886	4163872	1979-09-25	1979-09-25 00:00:00	38000275	0	\N	\N	324940	0	399208008	4163872	
32305	2832	4107731	1995-11-25	1995-11-25 00:00:00	38000275	0	\N	\N	187962	0	180256009	4107731	
56880	4942	4202451	2006-08-03	2006-08-03 00:00:00	38000275	0	\N	\N	328522	0	433112001	4202451	
33271	2913	4293740	2002-05-14	2002-05-14 00:00:00	38000275	0	\N	\N	194108	0	384700001	4293740	
45427	4010	4058899	2018-04-30	2018-04-30 00:00:00	38000275	0	\N	\N	266491	0	168594001	4058899	
45778	4027	4107731	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	267848	0	180256009	4107731	
58003	5031	4195803	2000-10-14	2000-10-14 00:00:00	38000275	0	\N	\N	334341	0	312681000	4195803	
46251	4064	4107731	1990-08-20	1990-08-20 00:00:00	38000275	0	\N	\N	269990	0	180256009	4107731	
46526	4078	4107731	1991-04-29	1991-04-29 00:00:00	38000275	0	\N	\N	270988	0	180256009	4107731	
58688	5097	4107731	1993-03-28	1993-03-28 00:00:00	38000275	0	\N	\N	338633	0	180256009	4107731	
58765	5103	4043071	1957-12-30	1957-12-30 00:00:00	38000275	0	\N	\N	339047	0	228557008	4043071	
59136	5118	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	340169	0	180256009	4107731	
59540	5150	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	342393	0	180256009	4107731	
59668	5165	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	343323	0	180256009	4107731	
35939	3147	4035793	2010-04-26	2010-04-26 00:00:00	38000275	0	\N	\N	209389	0	15081005	4035793	
48112	4223	4170947	1972-04-06	1972-04-06 00:00:00	38000275	0	\N	\N	280378	0	274474001	4170947	
36355	3181	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	211650	0	180256009	4107731	
48532	4261	4078793	2011-01-30	2011-01-30 00:00:00	38000275	0	\N	\N	282917	0	180325003	4078793	
48669	4279	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	284046	0	180256009	4107731	
48864	4289	4058899	1944-06-08	1944-06-08 00:00:00	38000275	0	\N	\N	284738	0	168594001	4058899	
49097	4312	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	286051	0	180256009	4107731	
37398	3295	4078793	2004-12-20	2004-12-20 00:00:00	38000275	0	\N	\N	218980	0	180325003	4078793	
49384	4342	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	287934	0	180256009	4107731	
61596	5328	4195803	2000-01-26	2000-01-26 00:00:00	38000275	0	\N	\N	354600	0	312681000	4195803	
37882	3343	4043071	1987-12-29	1987-12-29 00:00:00	38000275	0	\N	\N	221836	0	228557008	4043071	
50083	4372	4107731	1995-08-31	1995-08-31 00:00:00	38000275	0	\N	\N	290257	0	180256009	4107731	
38303	3371	4295880	2006-05-19	2006-05-19 00:00:00	38000275	0	\N	\N	223640	0	76601001	4295880	
50577	4395	4170947	1949-10-26	1949-10-26 00:00:00	38000275	0	\N	\N	292236	0	274474001	4170947	
38850	3430	4125906	2005-09-22	2005-09-22 00:00:00	38000275	0	\N	\N	227363	0	288086009	4125906	
50942	4433	4078793	1999-05-15	1999-05-15 00:00:00	38000275	0	\N	\N	294681	0	180325003	4078793	
51403	4452	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	296289	0	180256009	4107731	
39473	3477	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	230658	0	180256009	4107731	
51623	4476	4107731	1990-10-07	1990-10-07 00:00:00	38000275	0	\N	\N	297809	0	180256009	4107731	
51817	4493	4151422	1989-11-13	1989-11-13 00:00:00	38000275	0	\N	\N	299162	0	269911007	4151422	
52051	4514	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	300606	0	180256009	4107731	
52267	4534	4336464	2011-11-30	2011-11-30 00:00:00	38000275	0	\N	\N	302079	0	232717009	4336464	
40522	3561	4078793	1987-09-21	1987-09-21 00:00:00	38000275	0	\N	\N	236467	0	180325003	4078793	
52601	4565	4125906	2018-11-24	2018-11-24 00:00:00	38000275	0	\N	\N	304214	0	288086009	4125906	
52813	4587	4170947	2018-04-25	2018-04-25 00:00:00	38000275	0	\N	\N	305571	0	274474001	4170947	
29159	2586	4043071	1982-08-14	1982-08-14 00:00:00	38000275	0	\N	\N	171155	0	228557008	4043071	
41274	3622	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	240731	0	180256009	4107731	
53323	4626	4107731	1998-03-27	1998-03-27 00:00:00	38000275	0	\N	\N	308216	0	180256009	4107731	
53635	4646	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	309853	0	180256009	4107731	
53768	4662	42535580	1989-07-27	1989-07-27 00:00:00	38000275	0	\N	\N	310773	0	426701000119108	42535580	
42070	3708	4163872	1998-06-30	1998-06-30 00:00:00	38000275	0	\N	\N	246524	0	399208008	4163872	
54059	4696	4037675	1997-03-02	1997-03-02 00:00:00	38000275	0	\N	\N	312822	0	162676008	4037675	
54402	4724	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	314792	0	180256009	4107731	
42536	3754	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	249510	0	180256009	4107731	
54625	4739	4197460	1922-02-25	1922-02-25 00:00:00	38000275	0	\N	\N	315725	0	313191000	4197460	
54870	4760	4125906	2012-11-28	2012-11-28 00:00:00	38000275	0	\N	\N	317199	0	288086009	4125906	
55130	4804	4107731	1990-08-20	1990-08-20 00:00:00	38000275	0	\N	\N	319635	0	180256009	4107731	
43203	3814	4295880	1994-08-07	1994-08-07 00:00:00	38000275	0	\N	\N	253366	0	76601001	4295880	
43496	3852	4107731	1990-06-18	1990-06-18 00:00:00	38000275	0	\N	\N	255643	0	180256009	4107731	
55635	4847	4252419	1950-12-06	1950-12-06 00:00:00	38000275	0	\N	\N	322423	0	74016001	4252419	
55992	4886	4151422	2017-12-16	2017-12-16 00:00:00	38000275	0	\N	\N	324881	0	269911007	4151422	
32306	2832	4107731	1996-03-30	1996-03-30 00:00:00	38000275	0	\N	\N	187877	0	180256009	4107731	
56881	4942	4125906	1972-11-04	1972-11-04 00:00:00	38000275	0	\N	\N	328463	0	288086009	4125906	
33272	2913	4125906	2002-05-14	2002-05-14 00:00:00	38000275	0	\N	\N	194108	0	288086009	4125906	
45428	4010	4181917	1977-11-17	1977-11-17 00:00:00	38000275	0	\N	\N	266486	0	54550000	4181917	
45779	4027	4107731	1990-07-14	1990-07-14 00:00:00	38000275	0	\N	\N	267898	0	180256009	4107731	
58004	5034	4125906	1945-02-10	1945-02-10 00:00:00	38000275	0	\N	\N	334458	0	288086009	4125906	
46252	4064	4107731	1992-01-06	1992-01-06 00:00:00	38000275	0	\N	\N	270038	0	180256009	4107731	
46527	4078	4107731	1992-09-14	1992-09-14 00:00:00	38000275	0	\N	\N	270993	0	180256009	4107731	
58689	5097	4107731	1994-05-01	1994-05-01 00:00:00	38000275	0	\N	\N	338679	0	180256009	4107731	
58766	5103	4151422	1950-01-23	1950-01-23 00:00:00	38000275	0	\N	\N	339046	0	269911007	4151422	
59137	5118	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	340196	0	180256009	4107731	
59541	5150	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	342356	0	180256009	4107731	
59669	5165	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	343321	0	180256009	4107731	
35940	3147	4035793	2018-06-11	2018-06-11 00:00:00	38000275	0	\N	\N	209350	0	15081005	4035793	
48113	4223	4293740	1997-05-16	1997-05-16 00:00:00	38000275	0	\N	\N	280365	0	384700001	4293740	
36356	3183	4145310	1999-07-04	1999-07-04 00:00:00	38000275	0	\N	\N	211918	0	268425006	4145310	
48575	4268	4195803	2016-01-11	2016-01-11 00:00:00	38000275	0	\N	\N	283237	0	312681000	4195803	
48670	4279	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	284047	0	180256009	4107731	
48865	4289	4170947	1952-07-01	1952-07-01 00:00:00	38000275	0	\N	\N	284740	0	274474001	4170947	
49098	4312	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	286058	0	395142003	4191853	
37399	3295	4057420	2010-04-12	2010-04-12 00:00:00	38000275	0	\N	\N	218908	0	18286008	4057420	
49385	4342	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	287918	0	180256009	4107731	
61597	5328	4151422	2002-11-18	2002-11-18 00:00:00	38000275	0	\N	\N	354713	0	269911007	4151422	
37883	3343	4107731	1991-05-26	1991-05-26 00:00:00	38000275	0	\N	\N	221831	0	180256009	4107731	
50084	4372	4107731	1994-01-20	1994-01-20 00:00:00	38000275	0	\N	\N	290250	0	180256009	4107731	
38304	3371	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	223626	0	395142003	4191853	
50578	4395	4058899	1963-03-17	1963-03-17 00:00:00	38000275	0	\N	\N	292238	0	168594001	4058899	
38851	3430	4035793	2019-05-25	2019-05-25 00:00:00	38000275	0	\N	\N	227339	0	15081005	4035793	
50943	4433	4078793	2015-08-15	2015-08-15 00:00:00	38000275	0	\N	\N	294698	0	180325003	4078793	
51404	4452	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	296314	0	180256009	4107731	
39474	3477	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	230701	0	180256009	4107731	
51624	4476	4107731	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	297837	0	180256009	4107731	
51828	4496	4243062	1970-06-22	1970-06-22 00:00:00	38000275	0	\N	\N	299307	0	60027007	4243062	
52052	4514	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	300675	0	180256009	4107731	
52268	4534	4043071	1955-11-28	1955-11-28 00:00:00	38000275	0	\N	\N	302098	0	228557008	4043071	
40523	3561	4195803	2010-06-11	2010-06-11 00:00:00	38000275	0	\N	\N	236537	0	312681000	4195803	
52604	4569	4163872	1963-04-19	1963-04-19 00:00:00	38000275	0	\N	\N	304369	0	399208008	4163872	
52814	4587	4243062	2018-04-25	2018-04-25 00:00:00	38000275	0	\N	\N	305571	0	60027007	4243062	
29160	2586	4043071	1982-12-11	1982-12-11 00:00:00	38000275	0	\N	\N	171187	0	228557008	4043071	
41275	3622	4170947	1925-02-07	1925-02-07 00:00:00	38000275	0	\N	\N	240709	0	274474001	4170947	
53324	4626	4107731	2000-08-25	2000-08-25 00:00:00	38000275	0	\N	\N	308222	0	180256009	4107731	
53636	4646	4191853	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	309825	0	395142003	4191853	
53769	4662	4202832	1989-07-27	1989-07-27 00:00:00	38000275	0	\N	\N	310773	0	52765003	4202832	
42071	3708	4059978	1999-03-29	1999-03-29 00:00:00	38000275	0	\N	\N	246541	0	169553002	4059978	
54060	4696	4187458	1997-03-02	1997-03-02 00:00:00	38000275	0	\N	\N	312822	0	415300000	4187458	
54403	4724	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	314711	0	180256009	4107731	
42537	3754	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	249497	0	180256009	4107731	
54626	4739	4216130	1993-06-26	1993-06-26 00:00:00	38000275	0	\N	\N	315731	0	415070008	4216130	
54871	4760	44783196	1956-10-23	1956-10-23 00:00:00	38000275	0	\N	\N	317196	0	699253003	44783196	
55131	4804	4107731	1991-11-04	1991-11-04 00:00:00	38000275	0	\N	\N	319611	0	180256009	4107731	
43204	3814	4295880	1997-02-02	1997-02-02 00:00:00	38000275	0	\N	\N	253339	0	76601001	4295880	
43497	3852	4107731	1990-10-01	1990-10-01 00:00:00	38000275	0	\N	\N	255760	0	180256009	4107731	
55636	4847	4035793	2006-02-22	2006-02-22 00:00:00	38000275	0	\N	\N	322419	0	15081005	4035793	
55997	4890	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	325087	0	180256009	4107731	
32307	2832	4163872	2003-04-26	2003-04-26 00:00:00	38000275	0	\N	\N	187902	0	399208008	4163872	
56882	4942	4293740	1957-03-14	1957-03-14 00:00:00	38000275	0	\N	\N	328461	0	384700001	4293740	
33273	2914	4151422	2008-06-05	2008-06-05 00:00:00	38000275	0	\N	\N	194214	0	269911007	4151422	
45429	4010	4181917	1979-02-08	1979-02-08 00:00:00	38000275	0	\N	\N	266489	0	54550000	4181917	
45780	4027	4107731	1990-06-23	1990-06-23 00:00:00	38000275	0	\N	\N	267858	0	180256009	4107731	
58005	5034	4043071	1932-06-14	1932-06-14 00:00:00	38000275	0	\N	\N	334436	0	228557008	4043071	
46253	4064	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	270028	0	180256009	4107731	
46528	4078	4107731	1991-01-14	1991-01-14 00:00:00	38000275	0	\N	\N	270955	0	180256009	4107731	
58690	5097	4107731	1993-08-22	1993-08-22 00:00:00	38000275	0	\N	\N	338700	0	180256009	4107731	
58767	5103	4043071	1957-12-02	1957-12-02 00:00:00	38000275	0	\N	\N	339063	0	228557008	4043071	
59138	5118	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	340201	0	180256009	4107731	
59542	5150	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	342429	0	180256009	4107731	
59670	5165	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	343322	0	180256009	4107731	
35941	3147	4035793	2016-05-30	2016-05-30 00:00:00	38000275	0	\N	\N	209369	0	15081005	4035793	
48114	4223	4125906	1997-05-16	1997-05-16 00:00:00	38000275	0	\N	\N	280365	0	288086009	4125906	
36357	3183	4024289	1988-05-02	1988-05-02 00:00:00	38000275	0	\N	\N	211926	0	19490002	4024289	
48576	4268	44783196	1970-05-03	1970-05-03 00:00:00	38000275	0	\N	\N	283264	0	699253003	44783196	
48671	4279	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	284097	0	180256009	4107731	
48866	4289	4243062	1952-07-01	1952-07-01 00:00:00	38000275	0	\N	\N	284740	0	60027007	4243062	
49099	4312	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	286047	0	180256009	4107731	
37400	3295	4057420	2001-12-03	2001-12-03 00:00:00	38000275	0	\N	\N	218941	0	18286008	4057420	
49386	4342	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	287919	0	180256009	4107731	
61598	5329	4125906	1998-07-14	1998-07-14 00:00:00	38000275	0	\N	\N	354832	0	288086009	4125906	
37884	3343	4125906	2017-04-07	2017-04-07 00:00:00	38000275	0	\N	\N	221701	0	288086009	4125906	
50085	4372	4107731	1993-06-24	1993-06-24 00:00:00	38000275	0	\N	\N	290207	0	180256009	4107731	
38305	3371	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	223531	0	180256009	4107731	
50579	4395	4145310	2013-11-08	2013-11-08 00:00:00	38000275	0	\N	\N	292288	0	268425006	4145310	
38852	3430	4035793	2009-04-04	2009-04-04 00:00:00	38000275	0	\N	\N	227372	0	15081005	4035793	
50944	4433	4078793	2005-06-18	2005-06-18 00:00:00	38000275	0	\N	\N	294684	0	180325003	4078793	
51405	4452	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	296299	0	180256009	4107731	
39475	3477	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	230702	0	180256009	4107731	
51625	4476	4107731	1991-09-08	1991-09-08 00:00:00	38000275	0	\N	\N	297908	0	180256009	4107731	
51829	4496	4170947	1970-06-22	1970-06-22 00:00:00	38000275	0	\N	\N	299307	0	274474001	4170947	
52053	4514	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	300635	0	180256009	4107731	
52269	4534	4195803	1996-05-21	1996-05-21 00:00:00	38000275	0	\N	\N	302077	0	312681000	4195803	
40524	3561	4170947	2010-06-11	2010-06-11 00:00:00	38000275	0	\N	\N	236537	0	274474001	4170947	
52605	4570	4195803	1997-01-25	1997-01-25 00:00:00	38000275	0	\N	\N	304494	0	312681000	4195803	
52815	4587	4195803	2018-04-25	2018-04-25 00:00:00	38000275	0	\N	\N	305571	0	312681000	4195803	
29161	2586	4043071	1982-06-12	1982-06-12 00:00:00	38000275	0	\N	\N	171211	0	228557008	4043071	
41276	3622	4047491	1925-02-07	1925-02-07 00:00:00	38000275	0	\N	\N	240709	0	1225002	4047491	
53326	4628	4125906	2016-08-23	2016-08-23 00:00:00	38000275	0	\N	\N	308352	0	288086009	4125906	
53637	4646	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	309754	0	180256009	4107731	
53770	4662	4163971	1989-07-27	1989-07-27 00:00:00	38000275	0	\N	\N	310773	0	45595009	4163971	
42072	3708	4062501	1979-05-20	1979-05-20 00:00:00	38000275	0	\N	\N	246469	0	171231001	4062501	
54061	4696	4326177	1997-03-02	1997-03-02 00:00:00	38000275	0	\N	\N	312822	0	430193006	4326177	
54404	4724	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	314796	0	180256009	4107731	
42538	3754	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	249506	0	180256009	4107731	
54627	4739	4336464	1993-06-26	1993-06-26 00:00:00	38000275	0	\N	\N	315731	0	232717009	4336464	
54872	4760	4170947	1964-07-13	1964-07-13 00:00:00	38000275	0	\N	\N	317195	0	274474001	4170947	
55132	4804	4107731	1991-02-25	1991-02-25 00:00:00	38000275	0	\N	\N	319623	0	180256009	4107731	
43205	3814	4295880	1999-10-31	1999-10-31 00:00:00	38000275	0	\N	\N	253392	0	76601001	4295880	
43498	3852	4107731	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	255674	0	180256009	4107731	
55637	4847	4151422	2002-01-20	2002-01-20 00:00:00	38000275	0	\N	\N	322483	0	269911007	4151422	
55998	4890	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	325188	0	395142003	4191853	
32308	2832	4170947	2003-04-26	2003-04-26 00:00:00	38000275	0	\N	\N	187902	0	274474001	4170947	
56883	4942	4125906	1957-03-14	1957-03-14 00:00:00	38000275	0	\N	\N	328461	0	288086009	4125906	
33274	2914	4057420	1986-09-06	1986-09-06 00:00:00	38000275	0	\N	\N	194195	0	18286008	4057420	
45430	4010	44805732	1999-05-06	1999-05-06 00:00:00	38000275	0	\N	\N	266457	0	755621000000101	44805732	
45781	4027	4107731	1993-05-29	1993-05-29 00:00:00	38000275	0	\N	\N	267799	0	180256009	4107731	
58006	5034	4043071	1932-05-10	1932-05-10 00:00:00	38000275	0	\N	\N	334435	0	228557008	4043071	
46254	4064	4107731	1992-12-28	1992-12-28 00:00:00	38000275	0	\N	\N	270043	0	180256009	4107731	
46529	4078	4107731	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	271078	0	180256009	4107731	
58691	5097	4107731	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	338698	0	180256009	4107731	
58768	5103	4125906	1946-07-25	1946-07-25 00:00:00	38000275	0	\N	\N	339102	0	288086009	4125906	
59139	5118	4058899	1977-12-23	1977-12-23 00:00:00	38000275	0	\N	\N	340157	0	168594001	4058899	
59543	5150	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	342383	0	180256009	4107731	
59671	5165	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	343249	0	180256009	4107731	
35942	3147	4035793	1999-02-22	1999-02-22 00:00:00	38000275	0	\N	\N	209364	0	15081005	4035793	
48115	4223	4125906	2004-05-23	2004-05-23 00:00:00	38000275	0	\N	\N	280366	0	288086009	4125906	
36358	3183	4170947	1988-05-02	1988-05-02 00:00:00	38000275	0	\N	\N	211926	0	274474001	4170947	
48577	4268	4163872	1969-09-28	1969-09-28 00:00:00	38000275	0	\N	\N	283217	0	399208008	4163872	
48672	4279	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	284034	0	180256009	4107731	
48867	4289	4195803	2017-05-10	2017-05-10 00:00:00	38000275	0	\N	\N	284744	0	312681000	4195803	
49100	4312	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	286156	0	180256009	4107731	
49182	4313	4107731	1991-07-06	1991-07-06 00:00:00	38000275	0	\N	\N	286355	0	180256009	4107731	
49387	4342	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	287960	0	180256009	4107731	
61599	5329	4202451	1989-03-01	1989-03-01 00:00:00	38000275	0	\N	\N	354810	0	433112001	4202451	
37885	3343	4107731	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	221734	0	180256009	4107731	
50086	4372	4107731	1994-03-24	1994-03-24 00:00:00	38000275	0	\N	\N	290266	0	180256009	4107731	
38306	3371	4295880	2007-02-16	2007-02-16 00:00:00	38000275	0	\N	\N	223641	0	76601001	4295880	
50580	4395	4195803	2013-11-08	2013-11-08 00:00:00	38000275	0	\N	\N	292288	0	312681000	4195803	
38853	3430	4035793	2001-03-17	2001-03-17 00:00:00	38000275	0	\N	\N	227371	0	15081005	4035793	
50946	4435	4195803	2015-09-28	2015-09-28 00:00:00	38000275	0	\N	\N	294783	0	312681000	4195803	
51406	4452	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	296256	0	180256009	4107731	
39476	3477	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	230703	0	180256009	4107731	
51626	4477	4186930	1987-10-29	1987-10-29 00:00:00	38000275	0	\N	\N	297968	0	46706006	4186930	
51830	4496	4151422	1972-03-02	1972-03-02 00:00:00	38000275	0	\N	\N	299270	0	269911007	4151422	
52054	4514	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	300594	0	180256009	4107731	
52270	4534	4243062	1996-05-21	1996-05-21 00:00:00	38000275	0	\N	\N	302077	0	60027007	4243062	
40525	3561	4024289	2010-06-11	2010-06-11 00:00:00	38000275	0	\N	\N	236537	0	19490002	4024289	
52606	4570	4243062	1942-10-24	1942-10-24 00:00:00	38000275	0	\N	\N	304452	0	60027007	4243062	
52816	4587	4252419	1960-04-01	1960-04-01 00:00:00	38000275	0	\N	\N	305567	0	74016001	4252419	
29162	2586	4043071	1983-10-29	1983-10-29 00:00:00	38000275	0	\N	\N	171189	0	228557008	4043071	
41277	3622	4078793	2000-11-01	2000-11-01 00:00:00	38000275	0	\N	\N	240763	0	180325003	4078793	
53327	4628	4191853	1986-10-24	1986-10-24 00:00:00	38000275	0	\N	\N	308311	0	395142003	4191853	
53638	4646	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	309821	0	180256009	4107731	
53775	4665	4202451	2009-01-31	2009-01-31 00:00:00	38000275	0	\N	\N	310894	0	433112001	4202451	
42073	3708	4197460	1978-01-08	1978-01-08 00:00:00	38000275	0	\N	\N	246505	0	313191000	4197460	
54067	4700	4043071	1965-06-15	1965-06-15 00:00:00	38000275	0	\N	\N	313026	0	228557008	4043071	
54405	4724	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	314693	0	180256009	4107731	
42539	3754	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	249522	0	180256009	4107731	
54628	4739	4125906	1934-10-01	1934-10-01 00:00:00	38000275	0	\N	\N	315726	0	288086009	4125906	
54873	4760	4024289	1964-07-13	1964-07-13 00:00:00	38000275	0	\N	\N	317195	0	19490002	4024289	
55133	4804	4107731	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	319620	0	180256009	4107731	
43206	3814	4295880	1997-11-02	1997-11-02 00:00:00	38000275	0	\N	\N	253341	0	76601001	4295880	
43499	3852	4107731	1992-10-26	1992-10-26 00:00:00	38000275	0	\N	\N	255752	0	180256009	4107731	
55638	4847	4035793	1994-06-08	1994-06-08 00:00:00	38000275	0	\N	\N	322417	0	15081005	4035793	
55999	4890	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	325115	0	180256009	4107731	
32309	2832	4186930	1985-02-10	1985-02-10 00:00:00	38000275	0	\N	\N	187989	0	46706006	4186930	
56884	4942	4163872	1986-12-08	1986-12-08 00:00:00	38000275	0	\N	\N	328482	0	399208008	4163872	
33275	2914	40492359	1986-09-06	1986-09-06 00:00:00	38000275	0	\N	\N	194195	0	447365002	40492359	
45433	4013	4163872	1988-01-10	1988-01-10 00:00:00	38000275	0	\N	\N	266667	0	399208008	4163872	
45782	4027	4191853	1993-07-10	1993-07-10 00:00:00	38000275	0	\N	\N	267800	0	395142003	4191853	
58007	5034	4216130	1993-11-13	1993-11-13 00:00:00	38000275	0	\N	\N	334462	0	415070008	4216130	
46255	4064	4107731	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	269979	0	180256009	4107731	
46533	4080	4125906	1970-10-03	1970-10-03 00:00:00	38000275	0	\N	\N	271172	0	288086009	4125906	
58692	5097	4107731	1994-09-25	1994-09-25 00:00:00	38000275	0	\N	\N	338710	0	180256009	4107731	
58769	5103	4170947	1956-01-25	1956-01-25 00:00:00	38000275	0	\N	\N	339103	0	274474001	4170947	
59140	5118	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	340245	0	180256009	4107731	
59544	5150	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	342382	0	180256009	4107731	
59672	5165	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	343250	0	180256009	4107731	
35943	3147	4035793	2008-04-14	2008-04-14 00:00:00	38000275	0	\N	\N	209388	0	15081005	4035793	
48116	4224	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	280448	0	180256009	4107731	
36359	3183	4191853	1981-08-20	1981-08-20 00:00:00	38000275	0	\N	\N	211895	0	395142003	4191853	
48578	4268	4024289	1961-06-12	1961-06-12 00:00:00	38000275	0	\N	\N	283208	0	19490002	4024289	
48673	4279	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	283975	0	180256009	4107731	
48868	4289	4047491	2017-05-10	2017-05-10 00:00:00	38000275	0	\N	\N	284744	0	1225002	4047491	
49101	4312	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	286052	0	180256009	4107731	
49183	4313	4107731	1990-10-27	1990-10-27 00:00:00	38000275	0	\N	\N	286260	0	180256009	4107731	
49388	4342	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	287947	0	180256009	4107731	
61600	5329	4125906	1946-10-03	1946-10-03 00:00:00	38000275	0	\N	\N	354812	0	288086009	4125906	
37886	3343	4107731	1990-06-24	1990-06-24 00:00:00	38000275	0	\N	\N	221865	0	180256009	4107731	
50087	4372	4107731	1993-12-30	1993-12-30 00:00:00	38000275	0	\N	\N	290264	0	180256009	4107731	
50117	4373	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	290383	0	180256009	4107731	
50587	4398	4163872	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	292451	0	399208008	4163872	
38854	3430	4035793	2014-04-26	2014-04-26 00:00:00	38000275	0	\N	\N	227377	0	15081005	4035793	
50947	4435	4058899	2015-09-28	2015-09-28 00:00:00	38000275	0	\N	\N	294783	0	168594001	4058899	
51407	4452	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	296227	0	180256009	4107731	
39477	3477	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	230659	0	180256009	4107731	
51627	4477	4058899	1970-10-13	1970-10-13 00:00:00	38000275	0	\N	\N	297912	0	168594001	4058899	
51831	4496	4125906	1960-12-29	1960-12-29 00:00:00	38000275	0	\N	\N	299305	0	288086009	4125906	
52055	4514	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	300619	0	180256009	4107731	
52271	4534	4170947	1996-05-21	1996-05-21 00:00:00	38000275	0	\N	\N	302077	0	274474001	4170947	
40526	3561	4078793	1983-08-29	1983-08-29 00:00:00	38000275	0	\N	\N	236547	0	180325003	4078793	
52607	4570	4170947	1942-10-24	1942-10-24 00:00:00	38000275	0	\N	\N	304452	0	274474001	4170947	
52817	4587	4202451	2017-11-18	2017-11-18 00:00:00	38000275	0	\N	\N	305610	0	433112001	4202451	
29163	2586	4043071	1984-02-18	1984-02-18 00:00:00	38000275	0	\N	\N	171190	0	228557008	4043071	
41278	3622	4078793	2006-02-15	2006-02-15 00:00:00	38000275	0	\N	\N	240721	0	180325003	4078793	
53334	4630	4125906	1993-11-29	1993-11-29 00:00:00	38000275	0	\N	\N	308522	0	288086009	4125906	
53639	4646	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	309804	0	180256009	4107731	
53776	4666	4163872	1978-11-04	1978-11-04 00:00:00	38000275	0	\N	\N	310944	0	399208008	4163872	
42074	3708	4170947	2003-07-26	2003-07-26 00:00:00	38000275	0	\N	\N	246495	0	274474001	4170947	
54068	4700	4043071	1966-08-30	1966-08-30 00:00:00	38000275	0	\N	\N	313106	0	228557008	4043071	
54406	4724	4151422	1977-12-26	1977-12-26 00:00:00	38000275	0	\N	\N	314771	0	269911007	4151422	
42540	3754	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	249491	0	180256009	4107731	
54629	4739	4125906	1954-09-03	1954-09-03 00:00:00	38000275	0	\N	\N	315730	0	288086009	4125906	
54874	4760	4163872	1972-07-31	1972-07-31 00:00:00	38000275	0	\N	\N	317198	0	399208008	4163872	
55134	4804	4107731	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	319625	0	180256009	4107731	
43207	3814	4295880	1994-05-08	1994-05-08 00:00:00	38000275	0	\N	\N	253318	0	76601001	4295880	
43500	3852	4107731	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	255761	0	180256009	4107731	
55639	4847	4035793	2011-03-16	2011-03-16 00:00:00	38000275	0	\N	\N	322453	0	15081005	4035793	
56000	4890	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	325084	0	180256009	4107731	
32310	2832	4107731	1996-08-24	1996-08-24 00:00:00	38000275	0	\N	\N	187966	0	180256009	4107731	
56885	4942	4078793	2004-04-29	2004-04-29 00:00:00	38000275	0	\N	\N	328521	0	180325003	4078793	
33276	2914	4151422	1985-07-28	1985-07-28 00:00:00	38000275	0	\N	\N	194212	0	269911007	4151422	
45434	4014	4107731	1999-11-23	1999-11-23 00:00:00	38000275	0	\N	\N	266742	0	180256009	4107731	
57597	4987	4125906	1970-01-27	1970-01-27 00:00:00	38000275	0	\N	\N	331786	0	288086009	4125906	
58008	5034	4336464	1993-11-13	1993-11-13 00:00:00	38000275	0	\N	\N	334462	0	232717009	4336464	
46256	4064	4107731	1992-10-05	1992-10-05 00:00:00	38000275	0	\N	\N	269984	0	180256009	4107731	
46534	4080	4170947	1971-11-18	1971-11-18 00:00:00	38000275	0	\N	\N	271173	0	274474001	4170947	
58693	5097	4107731	1994-07-24	1994-07-24 00:00:00	38000275	0	\N	\N	338731	0	180256009	4107731	
58770	5103	4243062	1956-01-25	1956-01-25 00:00:00	38000275	0	\N	\N	339103	0	60027007	4243062	
59141	5118	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	340206	0	180256009	4107731	
59545	5150	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	342426	0	180256009	4107731	
59673	5165	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	343253	0	180256009	4107731	
35944	3147	4035793	2006-04-03	2006-04-03 00:00:00	38000275	0	\N	\N	209387	0	15081005	4035793	
48117	4224	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	280465	0	180256009	4107731	
36360	3183	4170947	2017-05-30	2017-05-30 00:00:00	38000275	0	\N	\N	211919	0	274474001	4170947	
48579	4268	4170947	1961-06-12	1961-06-12 00:00:00	38000275	0	\N	\N	283208	0	274474001	4170947	
48674	4279	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	284004	0	180256009	4107731	
48869	4289	4170947	2017-05-10	2017-05-10 00:00:00	38000275	0	\N	\N	284744	0	274474001	4170947	
49102	4312	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	286169	0	180256009	4107731	
49184	4313	4191853	1990-01-06	1990-01-06 00:00:00	38000275	0	\N	\N	286276	0	395142003	4191853	
49389	4342	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	287968	0	180256009	4107731	
61601	5329	4125906	2000-09-22	2000-09-22 00:00:00	38000275	0	\N	\N	354833	0	288086009	4125906	
37893	3347	4252419	1993-10-22	1993-10-22 00:00:00	38000275	0	\N	\N	222019	0	74016001	4252419	
50088	4372	4107731	1994-11-10	1994-11-10 00:00:00	38000275	0	\N	\N	290300	0	180256009	4107731	
50118	4373	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	290395	0	180256009	4107731	
50588	4398	4058899	1961-02-06	1961-02-06 00:00:00	38000275	0	\N	\N	292430	0	168594001	4058899	
38855	3430	4035793	2012-04-14	2012-04-14 00:00:00	38000275	0	\N	\N	227376	0	15081005	4035793	
50948	4435	4293740	1978-04-03	1978-04-03 00:00:00	38000275	0	\N	\N	294822	0	384700001	4293740	
51408	4452	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	296258	0	180256009	4107731	
39478	3477	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	230709	0	180256009	4107731	
51628	4477	4252419	2012-06-25	2012-06-25 00:00:00	38000275	0	\N	\N	297915	0	74016001	4252419	
51832	4497	4163872	1987-07-18	1987-07-18 00:00:00	38000275	0	\N	\N	299369	0	399208008	4163872	
52056	4514	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	300608	0	180256009	4107731	
52272	4534	4181917	1956-10-23	1956-10-23 00:00:00	38000275	0	\N	\N	302074	0	54550000	4181917	
40527	3561	4057420	1975-04-28	1975-04-28 00:00:00	38000275	0	\N	\N	236441	0	18286008	4057420	
52608	4570	4151422	1997-05-31	1997-05-31 00:00:00	38000275	0	\N	\N	304464	0	269911007	4151422	
52818	4587	4170947	2011-09-29	2011-09-29 00:00:00	38000275	0	\N	\N	305570	0	274474001	4170947	
29164	2586	4043071	1983-06-18	1983-06-18 00:00:00	38000275	0	\N	\N	171158	0	228557008	4043071	
41279	3622	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	240755	0	180256009	4107731	
53335	4630	4170947	1965-09-15	1965-09-15 00:00:00	38000275	0	\N	\N	308519	0	274474001	4170947	
53640	4646	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	309862	0	180256009	4107731	
53777	4666	4170947	1978-11-04	1978-11-04 00:00:00	38000275	0	\N	\N	310944	0	274474001	4170947	
42075	3708	4163872	2003-07-26	2003-07-26 00:00:00	38000275	0	\N	\N	246495	0	399208008	4163872	
54069	4700	4043071	1966-03-15	1966-03-15 00:00:00	38000275	0	\N	\N	313062	0	228557008	4043071	
54407	4724	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	314834	0	180256009	4107731	
42541	3754	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	249452	0	180256009	4107731	
54630	4739	4293740	1954-09-03	1954-09-03 00:00:00	38000275	0	\N	\N	315730	0	384700001	4293740	
54875	4760	4170947	1972-07-31	1972-07-31 00:00:00	38000275	0	\N	\N	317198	0	274474001	4170947	
55135	4804	4107731	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	319557	0	180256009	4107731	
43208	3814	4295880	1999-05-02	1999-05-02 00:00:00	38000275	0	\N	\N	253373	0	76601001	4295880	
43501	3852	4107731	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	255658	0	180256009	4107731	
55640	4847	4035793	2008-02-27	2008-02-27 00:00:00	38000275	0	\N	\N	322429	0	15081005	4035793	
56001	4890	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	325186	0	180256009	4107731	
32311	2832	4107731	1996-06-22	1996-06-22 00:00:00	38000275	0	\N	\N	187879	0	180256009	4107731	
56886	4942	4057420	2005-05-05	2005-05-05 00:00:00	38000275	0	\N	\N	328535	0	18286008	4057420	
33277	2914	4037675	1956-09-30	1956-09-30 00:00:00	38000275	0	\N	\N	194189	0	162676008	4037675	
45435	4014	4107731	1999-10-12	1999-10-12 00:00:00	38000275	0	\N	\N	266739	0	180256009	4107731	
57598	4987	4125906	1980-05-25	1980-05-25 00:00:00	38000275	0	\N	\N	331787	0	288086009	4125906	
58009	5034	4336464	1994-02-26	1994-02-26 00:00:00	38000275	0	\N	\N	334463	0	232717009	4336464	
46257	4064	4107731	1991-01-14	1991-01-14 00:00:00	38000275	0	\N	\N	269976	0	180256009	4107731	
46535	4080	4243062	1971-11-18	1971-11-18 00:00:00	38000275	0	\N	\N	271173	0	60027007	4243062	
58694	5097	4107731	1993-08-01	1993-08-01 00:00:00	38000275	0	\N	\N	338675	0	180256009	4107731	
58771	5103	4108705	1984-09-30	1984-09-30 00:00:00	38000275	0	\N	\N	339107	0	180207008	4108705	
59142	5118	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	340171	0	180256009	4107731	
59546	5150	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	342460	0	180256009	4107731	
59674	5165	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	343259	0	180256009	4107731	
35945	3147	4035793	2012-05-07	2012-05-07 00:00:00	38000275	0	\N	\N	209367	0	15081005	4035793	
48118	4224	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	280462	0	180256009	4107731	
36361	3183	4047491	2017-05-30	2017-05-30 00:00:00	38000275	0	\N	\N	211919	0	1225002	4047491	
48580	4268	4125906	1980-01-25	1980-01-25 00:00:00	38000275	0	\N	\N	283211	0	288086009	4125906	
48675	4279	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	283987	0	180256009	4107731	
48872	4291	4151422	1982-12-08	1982-12-08 00:00:00	38000275	0	\N	\N	284878	0	269911007	4151422	
49103	4312	4186930	1978-09-13	1978-09-13 00:00:00	38000275	0	\N	\N	286112	0	46706006	4186930	
49185	4313	4107731	1990-12-08	1990-12-08 00:00:00	38000275	0	\N	\N	286316	0	180256009	4107731	
49390	4342	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	287907	0	180256009	4107731	
61602	5329	4252419	1968-12-18	1968-12-18 00:00:00	38000275	0	\N	\N	354830	0	74016001	4252419	
37894	3347	44783196	1993-10-29	1993-10-29 00:00:00	38000275	0	\N	\N	222016	0	699253003	44783196	
50089	4372	4191853	1981-01-19	1981-01-19 00:00:00	38000275	0	\N	\N	290260	0	395142003	4191853	
50119	4373	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	290422	0	180256009	4107731	
50589	4398	4058899	1990-08-08	1990-08-08 00:00:00	38000275	0	\N	\N	292433	0	168594001	4058899	
38856	3430	4035793	2013-04-20	2013-04-20 00:00:00	38000275	0	\N	\N	227337	0	15081005	4035793	
50949	4435	4125906	1978-04-03	1978-04-03 00:00:00	38000275	0	\N	\N	294822	0	288086009	4125906	
51409	4452	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	296313	0	180256009	4107731	
39479	3477	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	230653	0	180256009	4107731	
51629	4477	4238715	1988-11-10	1988-11-10 00:00:00	38000275	0	\N	\N	297952	0	68254000	4238715	
51833	4497	4170947	1987-07-18	1987-07-18 00:00:00	38000275	0	\N	\N	299369	0	274474001	4170947	
52057	4514	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	300597	0	180256009	4107731	
52273	4534	4252419	1998-06-10	1998-06-10 00:00:00	38000275	0	\N	\N	302078	0	74016001	4252419	
40528	3561	4057420	2002-06-24	2002-06-24 00:00:00	38000275	0	\N	\N	\N	0	18286008	4057420	
52609	4570	4202451	1991-09-21	1991-09-21 00:00:00	38000275	0	\N	\N	304477	0	433112001	4202451	
52819	4587	4195803	2011-09-29	2011-09-29 00:00:00	38000275	0	\N	\N	305570	0	312681000	4195803	
29165	2586	4043071	1982-07-10	1982-07-10 00:00:00	38000275	0	\N	\N	171186	0	228557008	4043071	
41280	3622	4195803	1982-07-21	1982-07-21 00:00:00	38000275	0	\N	\N	240845	0	312681000	4195803	
53336	4630	4024289	1965-09-15	1965-09-15 00:00:00	38000275	0	\N	\N	308519	0	19490002	4024289	
53641	4646	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	309805	0	180256009	4107731	
53778	4666	4125906	2015-08-22	2015-08-22 00:00:00	38000275	0	\N	\N	310945	0	288086009	4125906	
53857	4677	4125906	1993-10-13	1993-10-13 00:00:00	38000275	0	\N	\N	311723	0	288086009	4125906	
54070	4700	4043071	1967-05-30	1967-05-30 00:00:00	38000275	0	\N	\N	313030	0	228557008	4043071	
54408	4724	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	314717	0	180256009	4107731	
42542	3754	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	249505	0	180256009	4107731	
54633	4745	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	315908	0	180256009	4107731	
54876	4761	4107731	1996-03-25	1996-03-25 00:00:00	38000275	0	\N	\N	317249	0	180256009	4107731	
55136	4804	4107731	1992-07-13	1992-07-13 00:00:00	38000275	0	\N	\N	319628	0	180256009	4107731	
43209	3814	4295880	1997-08-03	1997-08-03 00:00:00	38000275	0	\N	\N	253320	0	76601001	4295880	
43502	3852	4107731	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	255670	0	180256009	4107731	
55641	4847	4035793	1998-07-01	1998-07-01 00:00:00	38000275	0	\N	\N	322411	0	15081005	4035793	
56002	4890	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	325120	0	180256009	4107731	
32312	2832	4107731	1996-09-14	1996-09-14 00:00:00	38000275	0	\N	\N	187927	0	180256009	4107731	
56887	4942	4125906	1981-12-08	1981-12-08 00:00:00	38000275	0	\N	\N	328464	0	288086009	4125906	
33278	2914	4326177	1956-09-30	1956-09-30 00:00:00	38000275	0	\N	\N	194189	0	430193006	4326177	
45436	4014	4107731	1999-02-23	1999-02-23 00:00:00	38000275	0	\N	\N	266737	0	180256009	4107731	
57599	4988	4151422	1988-03-28	1988-03-28 00:00:00	38000275	0	\N	\N	331824	0	269911007	4151422	
58010	5034	4216130	1994-02-26	1994-02-26 00:00:00	38000275	0	\N	\N	334463	0	415070008	4216130	
46258	4064	4107731	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	270008	0	180256009	4107731	
46536	4080	4170947	1998-01-30	1998-01-30 00:00:00	38000275	0	\N	\N	271175	0	274474001	4170947	
58695	5097	4107731	1992-08-30	1992-08-30 00:00:00	38000275	0	\N	\N	338638	0	180256009	4107731	
58772	5103	4170947	1993-06-28	1993-06-28 00:00:00	38000275	0	\N	\N	339106	0	274474001	4170947	
59143	5118	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	340232	0	395142003	4191853	
59547	5151	4293740	2000-11-05	2000-11-05 00:00:00	38000275	0	\N	\N	342591	0	384700001	4293740	
59675	5165	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	343328	0	180256009	4107731	
35946	3149	4151422	1992-05-22	1992-05-22 00:00:00	38000275	0	\N	\N	209488	0	269911007	4151422	
48119	4224	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	280551	0	180256009	4107731	
36362	3183	4197460	1981-08-07	1981-08-07 00:00:00	38000275	0	\N	\N	211925	0	313191000	4197460	
48581	4268	4252419	1970-04-26	1970-04-26 00:00:00	38000275	0	\N	\N	283209	0	74016001	4252419	
48676	4279	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	283977	0	180256009	4107731	
48873	4291	4145310	1978-09-28	1978-09-28 00:00:00	38000275	0	\N	\N	284892	0	268425006	4145310	
49104	4312	4238715	1983-03-02	1983-03-02 00:00:00	38000275	0	\N	\N	286184	0	68254000	4238715	
49186	4313	4107731	1990-12-29	1990-12-29 00:00:00	38000275	0	\N	\N	286320	0	180256009	4107731	
49391	4342	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	287916	0	180256009	4107731	
61603	5329	4125906	1953-09-17	1953-09-17 00:00:00	38000275	0	\N	\N	354829	0	288086009	4125906	
37895	3347	4195803	2011-02-16	2011-02-16 00:00:00	38000275	0	\N	\N	222022	0	312681000	4195803	
50090	4372	4191853	1996-11-14	1996-11-14 00:00:00	38000275	0	\N	\N	290277	0	395142003	4191853	
50120	4373	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	290392	0	180256009	4107731	
50590	4398	4058899	1970-08-23	1970-08-23 00:00:00	38000275	0	\N	\N	292432	0	168594001	4058899	
38857	3430	4035793	2017-05-13	2017-05-13 00:00:00	38000275	0	\N	\N	227341	0	15081005	4035793	
50950	4435	4010253	1996-05-23	1996-05-23 00:00:00	38000275	0	\N	\N	294817	0	112790001	4010253	
51410	4452	4151422	1964-04-18	1964-04-18 00:00:00	38000275	0	\N	\N	296225	0	269911007	4151422	
39480	3477	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	230664	0	180256009	4107731	
51630	4477	4125906	1978-10-01	1978-10-01 00:00:00	38000275	0	\N	\N	297913	0	288086009	4125906	
51834	4498	4191853	1978-03-01	1978-03-01 00:00:00	38000275	0	\N	\N	299481	0	395142003	4191853	
52058	4514	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	300657	0	180256009	4107731	
52274	4534	4181917	1957-05-21	1957-05-21 00:00:00	38000275	0	\N	\N	302076	0	54550000	4181917	
40529	3561	4057420	1990-10-08	1990-10-08 00:00:00	38000275	0	\N	\N	236468	0	18286008	4057420	
52610	4570	4145310	2003-08-10	2003-08-10 00:00:00	38000275	0	\N	\N	304492	0	268425006	4145310	
52820	4587	4024289	2011-09-29	2011-09-29 00:00:00	38000275	0	\N	\N	305570	0	19490002	4024289	
29166	2586	4043071	1982-09-11	1982-09-11 00:00:00	38000275	0	\N	\N	171164	0	228557008	4043071	
41281	3622	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	240740	0	180256009	4107731	
53337	4630	4151422	2002-11-14	2002-11-14 00:00:00	38000275	0	\N	\N	308476	0	269911007	4151422	
53642	4646	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	309854	0	180256009	4107731	
53779	4666	4293740	2015-08-22	2015-08-22 00:00:00	38000275	0	\N	\N	310945	0	384700001	4293740	
53858	4677	4125906	1973-07-20	1973-07-20 00:00:00	38000275	0	\N	\N	311666	0	288086009	4125906	
54071	4700	4202451	1973-03-13	1973-03-13 00:00:00	38000275	0	\N	\N	313031	0	433112001	4202451	
54409	4724	4195803	2008-12-16	2008-12-16 00:00:00	38000275	0	\N	\N	314861	0	312681000	4195803	
42543	3754	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	249538	0	180256009	4107731	
54634	4745	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	315996	0	180256009	4107731	
54877	4761	4107731	1994-03-21	1994-03-21 00:00:00	38000275	0	\N	\N	317280	0	180256009	4107731	
55137	4804	4107731	1992-06-22	1992-06-22 00:00:00	38000275	0	\N	\N	319582	0	180256009	4107731	
43210	3814	4295880	1995-05-07	1995-05-07 00:00:00	38000275	0	\N	\N	253367	0	76601001	4295880	
43503	3852	4191853	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	255735	0	395142003	4191853	
55642	4847	4035793	1993-06-02	1993-06-02 00:00:00	38000275	0	\N	\N	322455	0	15081005	4035793	
56003	4890	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	325244	0	180256009	4107731	
32313	2832	4107731	1995-05-20	1995-05-20 00:00:00	38000275	0	\N	\N	187961	0	180256009	4107731	
56888	4942	4151422	1989-12-16	1989-12-16 00:00:00	38000275	0	\N	\N	328504	0	269911007	4151422	
33279	2914	4187458	1956-09-30	1956-09-30 00:00:00	38000275	0	\N	\N	194189	0	415300000	4187458	
45437	4014	4191853	1997-12-09	1997-12-09 00:00:00	38000275	0	\N	\N	266770	0	395142003	4191853	
57600	4988	4275113	1971-03-30	1971-03-30 00:00:00	38000275	0	\N	\N	331800	0	65200003	4275113	
58011	5034	4043071	1932-03-08	1932-03-08 00:00:00	38000275	0	\N	\N	334482	0	228557008	4043071	
46259	4064	4107731	1992-12-07	1992-12-07 00:00:00	38000275	0	\N	\N	270114	0	180256009	4107731	
46537	4080	4243062	1998-01-30	1998-01-30 00:00:00	38000275	0	\N	\N	271175	0	60027007	4243062	
58696	5097	4191853	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	338637	0	395142003	4191853	
58773	5103	4047491	1993-06-28	1993-06-28 00:00:00	38000275	0	\N	\N	339106	0	1225002	4047491	
59144	5118	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	340226	0	180256009	4107731	
59548	5151	4125906	2000-11-05	2000-11-05 00:00:00	38000275	0	\N	\N	342591	0	288086009	4125906	
59676	5165	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	343346	0	180256009	4107731	
35947	3149	4195803	2012-11-22	2012-11-22 00:00:00	38000275	0	\N	\N	209567	0	312681000	4195803	
48120	4224	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	280533	0	180256009	4107731	
36363	3184	4198190	2000-02-23	2000-02-23 00:00:00	38000275	0	\N	\N	212007	0	80146002	4198190	
48582	4268	4125906	2012-05-18	2012-05-18 00:00:00	38000275	0	\N	\N	283213	0	288086009	4125906	
48677	4279	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	283985	0	180256009	4107731	
48874	4291	4125906	1994-11-03	1994-11-03 00:00:00	38000275	0	\N	\N	284893	0	288086009	4125906	
49105	4312	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	286080	0	180256009	4107731	
49187	4313	4107731	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	286282	0	180256009	4107731	
49392	4342	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	287966	0	180256009	4107731	
61604	5329	4151422	1947-01-03	1947-01-03 00:00:00	38000275	0	\N	\N	354740	0	269911007	4151422	
37896	3347	4058899	2011-02-16	2011-02-16 00:00:00	38000275	0	\N	\N	222022	0	168594001	4058899	
50091	4372	4107731	1995-11-23	1995-11-23 00:00:00	38000275	0	\N	\N	290272	0	180256009	4107731	
50121	4373	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	290386	0	180256009	4107731	
50591	4398	4151422	1996-09-05	1996-09-05 00:00:00	38000275	0	\N	\N	292448	0	269911007	4151422	
38858	3430	4035793	2016-05-07	2016-05-07 00:00:00	38000275	0	\N	\N	227373	0	15081005	4035793	
50951	4436	4191853	1984-06-17	1984-06-17 00:00:00	38000275	0	\N	\N	294875	0	395142003	4191853	
51411	4452	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	296229	0	180256009	4107731	
39481	3477	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	230727	0	180256009	4107731	
51631	4477	4275113	1982-10-24	1982-10-24 00:00:00	38000275	0	\N	\N	297967	0	65200003	4275113	
51835	4498	4059978	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	299455	0	169553002	4059978	
52059	4514	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	300632	0	180256009	4107731	
52275	4534	4181917	1957-02-26	1957-02-26 00:00:00	38000275	0	\N	\N	302075	0	54550000	4181917	
40530	3561	4057420	2000-12-04	2000-12-04 00:00:00	38000275	0	\N	\N	236542	0	18286008	4057420	
52611	4570	4125906	1961-11-27	1961-11-27 00:00:00	38000275	0	\N	\N	304491	0	288086009	4125906	
52821	4587	4125906	2004-04-17	2004-04-17 00:00:00	38000275	0	\N	\N	305568	0	288086009	4125906	
29167	2586	4043071	1984-04-21	1984-04-21 00:00:00	38000275	0	\N	\N	171146	0	228557008	4043071	
41282	3622	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	240778	0	180256009	4107731	
53338	4630	4151422	2009-09-17	2009-09-17 00:00:00	38000275	0	\N	\N	308485	0	269911007	4151422	
53643	4646	4078793	2004-10-26	2004-10-26 00:00:00	38000275	0	\N	\N	309840	0	180325003	4078793	
53783	4668	4252419	1987-06-22	1987-06-22 00:00:00	38000275	0	\N	\N	311086	0	74016001	4252419	
53859	4677	4151422	1967-12-23	1967-12-23 00:00:00	38000275	0	\N	\N	311696	0	269911007	4151422	
54072	4700	4043071	1967-03-28	1967-03-28 00:00:00	38000275	0	\N	\N	313055	0	228557008	4043071	
54410	4724	4058899	2008-12-16	2008-12-16 00:00:00	38000275	0	\N	\N	314861	0	168594001	4058899	
42544	3754	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	249477	0	180256009	4107731	
54635	4745	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	316011	0	180256009	4107731	
54878	4761	4058899	1989-11-14	1989-11-14 00:00:00	38000275	0	\N	\N	317236	0	168594001	4058899	
55138	4804	4107731	1992-11-16	1992-11-16 00:00:00	38000275	0	\N	\N	319631	0	180256009	4107731	
43211	3814	4295880	1997-05-04	1997-05-04 00:00:00	38000275	0	\N	\N	253353	0	76601001	4295880	
43504	3852	4107731	1991-09-02	1991-09-02 00:00:00	38000275	0	\N	\N	255676	0	180256009	4107731	
55643	4847	4035793	2000-07-12	2000-07-12 00:00:00	38000275	0	\N	\N	322412	0	15081005	4035793	
56004	4890	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	325092	0	180256009	4107731	
32314	2832	4107731	1997-08-16	1997-08-16 00:00:00	38000275	0	\N	\N	187907	0	180256009	4107731	
56889	4942	4024289	1955-02-23	1955-02-23 00:00:00	38000275	0	\N	\N	328460	0	19490002	4024289	
33280	2914	4125906	1991-03-17	1991-03-17 00:00:00	38000275	0	\N	\N	194196	0	288086009	4125906	
45438	4014	4107731	2000-12-26	2000-12-26 00:00:00	38000275	0	\N	\N	266797	0	180256009	4107731	
57601	4988	4151422	1977-04-17	1977-04-17 00:00:00	38000275	0	\N	\N	331844	0	269911007	4151422	
58012	5034	4043071	1932-09-20	1932-09-20 00:00:00	38000275	0	\N	\N	334484	0	228557008	4043071	
46260	4064	4107731	1991-11-25	1991-11-25 00:00:00	38000275	0	\N	\N	269980	0	180256009	4107731	
46538	4080	4125906	2014-05-06	2014-05-06 00:00:00	38000275	0	\N	\N	271177	0	288086009	4125906	
58697	5097	4107731	1994-10-16	1994-10-16 00:00:00	38000275	0	\N	\N	338733	0	180256009	4107731	
58774	5103	4187458	1984-09-30	1984-09-30 00:00:00	38000275	0	\N	\N	339107	0	415300000	4187458	
59145	5118	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	340252	0	180256009	4107731	
59549	5151	4293740	1987-04-13	1987-04-13 00:00:00	38000275	0	\N	\N	342588	0	384700001	4293740	
59677	5165	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	343270	0	180256009	4107731	
35948	3149	4170947	2012-11-22	2012-11-22 00:00:00	38000275	0	\N	\N	209567	0	274474001	4170947	
48121	4224	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	280552	0	180256009	4107731	
36364	3184	4125906	1997-06-19	1997-06-19 00:00:00	38000275	0	\N	\N	211992	0	288086009	4125906	
48583	4268	4151422	1963-02-04	1963-02-04 00:00:00	38000275	0	\N	\N	283216	0	269911007	4151422	
48678	4279	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	284005	0	180256009	4107731	
48875	4291	4058899	2017-01-27	2017-01-27 00:00:00	38000275	0	\N	\N	284894	0	168594001	4058899	
49106	4312	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	286155	0	180256009	4107731	
49188	4313	4107731	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	286356	0	180256009	4107731	
49393	4342	4125906	2016-07-21	2016-07-21 00:00:00	38000275	0	\N	\N	287848	0	288086009	4125906	
61623	5331	4151422	2017-08-19	2017-08-19 00:00:00	38000275	0	\N	\N	354949	0	269911007	4151422	
37897	3347	4125906	2008-06-10	2008-06-10 00:00:00	38000275	0	\N	\N	222021	0	288086009	4125906	
50092	4372	4107731	1996-01-25	1996-01-25 00:00:00	38000275	0	\N	\N	290328	0	180256009	4107731	
50122	4373	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	290387	0	180256009	4107731	
50592	4398	4151422	1984-02-07	1984-02-07 00:00:00	38000275	0	\N	\N	292389	0	269911007	4151422	
38859	3430	4035793	2005-03-26	2005-03-26 00:00:00	38000275	0	\N	\N	227340	0	15081005	4035793	
50952	4436	4252419	2017-06-22	2017-06-22 00:00:00	38000275	0	\N	\N	294883	0	74016001	4252419	
51412	4452	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	296294	0	180256009	4107731	
39482	3477	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	230615	0	180256009	4107731	
51632	4477	44783196	2012-07-02	2012-07-02 00:00:00	38000275	0	\N	\N	297940	0	699253003	44783196	
51836	4498	4151422	2005-04-29	2005-04-29 00:00:00	38000275	0	\N	\N	299439	0	269911007	4151422	
52060	4514	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	300639	0	180256009	4107731	
52276	4534	44783196	1998-06-17	1998-06-17 00:00:00	38000275	0	\N	\N	302080	0	699253003	44783196	
40531	3561	4195803	1967-04-02	1967-04-02 00:00:00	38000275	0	\N	\N	236472	0	312681000	4195803	
52612	4570	4125906	1954-11-20	1954-11-20 00:00:00	38000275	0	\N	\N	304490	0	288086009	4125906	
52915	4590	4047491	2002-09-29	2002-09-29 00:00:00	38000275	0	\N	\N	305863	0	1225002	4047491	
29168	2586	4043071	1983-02-12	1983-02-12 00:00:00	38000275	0	\N	\N	171142	0	228557008	4043071	
41283	3622	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	240801	0	180256009	4107731	
53339	4630	4125906	1982-08-08	1982-08-08 00:00:00	38000275	0	\N	\N	308521	0	288086009	4125906	
53644	4646	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	309850	0	180256009	4107731	
53784	4668	4151422	2003-10-07	2003-10-07 00:00:00	38000275	0	\N	\N	311036	0	269911007	4151422	
53860	4678	4125906	1982-09-22	1982-09-22 00:00:00	38000275	0	\N	\N	311727	0	288086009	4125906	
54073	4700	4125906	1952-03-17	1952-03-17 00:00:00	38000275	0	\N	\N	313115	0	288086009	4125906	
54411	4724	4151422	1993-05-14	1993-05-14 00:00:00	38000275	0	\N	\N	314756	0	269911007	4151422	
42545	3754	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	249460	0	180256009	4107731	
54636	4745	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	315906	0	180256009	4107731	
54879	4761	4107731	1993-06-21	1993-06-21 00:00:00	38000275	0	\N	\N	317268	0	180256009	4107731	
55139	4804	4107731	1991-09-23	1991-09-23 00:00:00	38000275	0	\N	\N	319610	0	180256009	4107731	
43212	3814	4295880	1996-11-03	1996-11-03 00:00:00	38000275	0	\N	\N	253319	0	76601001	4295880	
43505	3852	4107731	1990-04-16	1990-04-16 00:00:00	38000275	0	\N	\N	255652	0	180256009	4107731	
55644	4847	4035793	1989-06-21	1989-06-21 00:00:00	38000275	0	\N	\N	322410	0	15081005	4035793	
56005	4890	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	325097	0	180256009	4107731	
32315	2832	4107731	1995-11-04	1995-11-04 00:00:00	38000275	0	\N	\N	187953	0	180256009	4107731	
56890	4942	4170947	1955-02-23	1955-02-23 00:00:00	38000275	0	\N	\N	328460	0	274474001	4170947	
33281	2915	4125906	1955-10-28	1955-10-28 00:00:00	38000275	0	\N	\N	194302	0	288086009	4125906	
45439	4014	4191853	2001-06-12	2001-06-12 00:00:00	38000275	0	\N	\N	266725	0	395142003	4191853	
57602	4988	4238715	1976-08-24	1976-08-24 00:00:00	38000275	0	\N	\N	331860	0	68254000	4238715	
58013	5034	4125906	1967-04-07	1967-04-07 00:00:00	38000275	0	\N	\N	334460	0	288086009	4125906	
46261	4064	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	270087	0	180256009	4107731	
46539	4081	4010253	1998-05-02	1998-05-02 00:00:00	38000275	0	\N	\N	271263	0	112790001	4010253	
58698	5097	4107731	1995-09-17	1995-09-17 00:00:00	38000275	0	\N	\N	338695	0	180256009	4107731	
58775	5103	4037675	1984-09-30	1984-09-30 00:00:00	38000275	0	\N	\N	339107	0	162676008	4037675	
59146	5118	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	340193	0	180256009	4107731	
59550	5151	4125906	1987-04-13	1987-04-13 00:00:00	38000275	0	\N	\N	342588	0	288086009	4125906	
59678	5165	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	343338	0	180256009	4107731	
35949	3149	4243062	2012-11-22	2012-11-22 00:00:00	38000275	0	\N	\N	209567	0	60027007	4243062	
48122	4224	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	280459	0	180256009	4107731	
36365	3184	4293740	1997-06-19	1997-06-19 00:00:00	38000275	0	\N	\N	211992	0	384700001	4293740	
48584	4269	4125906	1981-04-14	1981-04-14 00:00:00	38000275	0	\N	\N	283352	0	288086009	4125906	
48679	4279	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	284072	0	180256009	4107731	
48884	4295	4125906	1997-12-18	1997-12-18 00:00:00	38000275	0	\N	\N	285077	0	288086009	4125906	
49107	4312	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	286201	0	180256009	4107731	
49189	4313	4191853	1993-07-10	1993-07-10 00:00:00	38000275	0	\N	\N	286336	0	395142003	4191853	
49394	4342	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	287959	0	180256009	4107731	
61624	5331	4170947	1970-03-26	1970-03-26 00:00:00	38000275	0	\N	\N	354939	0	274474001	4170947	
49743	4365	4078793	2001-07-23	2001-07-23 00:00:00	38000275	0	\N	\N	289578	0	180325003	4078793	
50093	4372	4107731	1993-07-15	1993-07-15 00:00:00	38000275	0	\N	\N	290223	0	180256009	4107731	
50123	4373	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	290348	0	180256009	4107731	
50593	4401	4125906	2017-05-04	2017-05-04 00:00:00	38000275	0	\N	\N	292565	0	288086009	4125906	
38860	3430	4035793	2007-03-31	2007-03-31 00:00:00	38000275	0	\N	\N	227375	0	15081005	4035793	
50953	4436	44783196	2017-06-29	2017-06-29 00:00:00	38000275	0	\N	\N	294884	0	699253003	44783196	
51413	4452	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	296295	0	180256009	4107731	
39483	3477	4043071	1972-05-27	1972-05-27 00:00:00	38000275	0	\N	\N	230712	0	228557008	4043071	
51633	4477	4170947	1967-08-30	1967-08-30 00:00:00	38000275	0	\N	\N	297911	0	274474001	4170947	
51837	4498	4197460	1978-02-18	1978-02-18 00:00:00	38000275	0	\N	\N	299492	0	313191000	4197460	
52061	4514	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	300685	0	180256009	4107731	
52277	4534	4043071	1956-01-02	1956-01-02 00:00:00	38000275	0	\N	\N	302020	0	228557008	4043071	
40532	3561	4243062	1967-04-02	1967-04-02 00:00:00	38000275	0	\N	\N	236472	0	60027007	4243062	
52613	4570	4151422	1964-08-30	1964-08-30 00:00:00	38000275	0	\N	\N	304482	0	269911007	4151422	
52916	4590	4170947	2002-09-29	2002-09-29 00:00:00	38000275	0	\N	\N	305863	0	274474001	4170947	
29169	2586	4043071	1982-02-06	1982-02-06 00:00:00	38000275	0	\N	\N	171185	0	228557008	4043071	
41284	3622	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	240756	0	180256009	4107731	
53340	4630	4293740	1982-08-08	1982-08-08 00:00:00	38000275	0	\N	\N	308521	0	384700001	4293740	
53645	4646	4078793	2018-06-12	2018-06-12 00:00:00	38000275	0	\N	\N	309844	0	180325003	4078793	
53785	4668	4125906	2014-12-09	2014-12-09 00:00:00	38000275	0	\N	\N	311090	0	288086009	4125906	
53861	4678	4163872	1973-01-23	1973-01-23 00:00:00	38000275	0	\N	\N	311764	0	399208008	4163872	
54074	4700	4043071	1965-10-12	1965-10-12 00:00:00	38000275	0	\N	\N	313027	0	228557008	4043071	
54412	4724	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	314666	0	180256009	4107731	
42546	3754	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	249427	0	180256009	4107731	
54637	4745	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	315953	0	180256009	4107731	
54880	4761	4107731	1994-11-07	1994-11-07 00:00:00	38000275	0	\N	\N	317282	0	180256009	4107731	
55140	4804	4107731	1991-08-12	1991-08-12 00:00:00	38000275	0	\N	\N	319640	0	180256009	4107731	
43213	3814	4295880	1995-11-05	1995-11-05 00:00:00	38000275	0	\N	\N	253351	0	76601001	4295880	
43506	3852	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	255754	0	180256009	4107731	
55645	4847	4035793	2015-04-08	2015-04-08 00:00:00	38000275	0	\N	\N	322421	0	15081005	4035793	
56006	4890	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	325118	0	180256009	4107731	
32316	2832	4107731	1995-01-14	1995-01-14 00:00:00	38000275	0	\N	\N	187958	0	180256009	4107731	
56891	4943	4058899	1974-02-14	1974-02-14 00:00:00	38000275	0	\N	\N	328621	0	168594001	4058899	
33282	2915	4191853	1993-07-11	1993-07-11 00:00:00	38000275	0	\N	\N	194256	0	395142003	4191853	
45440	4014	4107731	1999-11-02	1999-11-02 00:00:00	38000275	0	\N	\N	266804	0	180256009	4107731	
57603	4988	4163872	1956-02-05	1956-02-05 00:00:00	38000275	0	\N	\N	331792	0	399208008	4163872	
58014	5034	44783196	1971-03-15	1971-03-15 00:00:00	38000275	0	\N	\N	334457	0	699253003	44783196	
46262	4064	4197460	1961-10-01	1961-10-01 00:00:00	38000275	0	\N	\N	269995	0	313191000	4197460	
46540	4081	4170947	1965-03-20	1965-03-20 00:00:00	38000275	0	\N	\N	271237	0	274474001	4170947	
58699	5097	4107731	1995-11-19	1995-11-19 00:00:00	38000275	0	\N	\N	338684	0	180256009	4107731	
58776	5103	4326177	1984-09-30	1984-09-30 00:00:00	38000275	0	\N	\N	339107	0	430193006	4326177	
59147	5118	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	340208	0	180256009	4107731	
59551	5151	4330583	2002-10-29	2002-10-29 00:00:00	38000275	0	\N	\N	342583	0	22523008	4330583	
59679	5165	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	343340	0	180256009	4107731	
35950	3149	44783196	1965-10-30	1965-10-30 00:00:00	38000275	0	\N	\N	209503	0	699253003	44783196	
48123	4224	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	280550	0	180256009	4107731	
36366	3184	4151422	2017-08-11	2017-08-11 00:00:00	38000275	0	\N	\N	211964	0	269911007	4151422	
48585	4269	4293740	1981-04-14	1981-04-14 00:00:00	38000275	0	\N	\N	283352	0	384700001	4293740	
48680	4279	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	283980	0	180256009	4107731	
48885	4295	4163872	1992-06-18	1992-06-18 00:00:00	38000275	0	\N	\N	285071	0	399208008	4163872	
49108	4312	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	286157	0	180256009	4107731	
49190	4313	4107731	1991-04-13	1991-04-13 00:00:00	38000275	0	\N	\N	286283	0	180256009	4107731	
49395	4342	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	287961	0	180256009	4107731	
61625	5331	4243062	1970-03-26	1970-03-26 00:00:00	38000275	0	\N	\N	354939	0	60027007	4243062	
49744	4365	4078793	2002-07-29	2002-07-29 00:00:00	38000275	0	\N	\N	289550	0	180325003	4078793	
50094	4372	4107731	1994-08-18	1994-08-18 00:00:00	38000275	0	\N	\N	290268	0	180256009	4107731	
50124	4373	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	290418	0	180256009	4107731	
50594	4401	4062501	1973-01-10	1973-01-10 00:00:00	38000275	0	\N	\N	292577	0	171231001	4062501	
38861	3431	4062501	1964-10-16	1964-10-16 00:00:00	38000275	0	\N	\N	227454	0	171231001	4062501	
50954	4436	4125906	2007-08-30	2007-08-30 00:00:00	38000275	0	\N	\N	294882	0	288086009	4125906	
51414	4452	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	296255	0	180256009	4107731	
39484	3477	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	230717	0	180256009	4107731	
51634	4477	4024289	1967-08-30	1967-08-30 00:00:00	38000275	0	\N	\N	297911	0	19490002	4024289	
51838	4498	4058899	1983-11-19	1983-11-19 00:00:00	38000275	0	\N	\N	299493	0	168594001	4058899	
52062	4514	4191853	1976-06-28	1976-06-28 00:00:00	38000275	0	\N	\N	300670	0	395142003	4191853	
52346	4538	4170947	2011-10-29	2011-10-29 00:00:00	38000275	0	\N	\N	302317	0	274474001	4170947	
40533	3561	4170947	1967-04-02	1967-04-02 00:00:00	38000275	0	\N	\N	236472	0	274474001	4170947	
52614	4571	44783196	2001-03-24	2001-03-24 00:00:00	38000275	0	\N	\N	304551	0	699253003	44783196	
52917	4590	4238715	1976-02-02	1976-02-02 00:00:00	38000275	0	\N	\N	305860	0	68254000	4238715	
29170	2586	4043071	1983-03-12	1983-03-12 00:00:00	38000275	0	\N	\N	171213	0	228557008	4043071	
41285	3622	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	240727	0	180256009	4107731	
53341	4631	4163872	1939-10-21	1939-10-21 00:00:00	38000275	0	\N	\N	308573	0	399208008	4163872	
53646	4646	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	309808	0	180256009	4107731	
53786	4668	4125906	1998-06-01	1998-06-01 00:00:00	38000275	0	\N	\N	311087	0	288086009	4125906	
53862	4678	4151422	2016-07-02	2016-07-02 00:00:00	38000275	0	\N	\N	311742	0	269911007	4151422	
54075	4700	4043071	1965-07-13	1965-07-13 00:00:00	38000275	0	\N	\N	313024	0	228557008	4043071	
54413	4724	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	314830	0	180256009	4107731	
42547	3754	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	249523	0	180256009	4107731	
54638	4745	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	316008	0	180256009	4107731	
54881	4761	4107731	1996-06-17	1996-06-17 00:00:00	38000275	0	\N	\N	317303	0	180256009	4107731	
55141	4804	4107731	1991-07-22	1991-07-22 00:00:00	38000275	0	\N	\N	319621	0	180256009	4107731	
43214	3814	4295880	2000-01-30	2000-01-30 00:00:00	38000275	0	\N	\N	253374	0	76601001	4295880	
43507	3852	4107731	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	255681	0	180256009	4107731	
55646	4847	4035793	2001-07-18	2001-07-18 00:00:00	38000275	0	\N	\N	322449	0	15081005	4035793	
56007	4890	4078793	2016-01-13	2016-01-13 00:00:00	38000275	0	\N	\N	325138	0	180325003	4078793	
32317	2832	4107731	1994-05-28	1994-05-28 00:00:00	38000275	0	\N	\N	187977	0	180256009	4107731	
56892	4943	4181917	1962-02-01	1962-02-01 00:00:00	38000275	0	\N	\N	328618	0	54550000	4181917	
33283	2915	4107731	1992-08-30	1992-08-30 00:00:00	38000275	0	\N	\N	194252	0	180256009	4107731	
45441	4014	4107731	1997-12-30	1997-12-30 00:00:00	38000275	0	\N	\N	266784	0	180256009	4107731	
57604	4988	4170947	1956-02-05	1956-02-05 00:00:00	38000275	0	\N	\N	331792	0	274474001	4170947	
58015	5034	4151422	1973-12-22	1973-12-22 00:00:00	38000275	0	\N	\N	334531	0	269911007	4151422	
46263	4064	4107731	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	270000	0	180256009	4107731	
46541	4081	4243062	1965-03-20	1965-03-20 00:00:00	38000275	0	\N	\N	271237	0	60027007	4243062	
58700	5097	4107731	1994-05-22	1994-05-22 00:00:00	38000275	0	\N	\N	338703	0	180256009	4107731	
58777	5103	4043071	1958-02-03	1958-02-03 00:00:00	38000275	0	\N	\N	339094	0	228557008	4043071	
59148	5118	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	340275	0	180256009	4107731	
59552	5152	4125906	2002-09-18	2002-09-18 00:00:00	38000275	0	\N	\N	342594	0	288086009	4125906	
59680	5165	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	343279	0	180256009	4107731	
35951	3149	4252419	1965-10-23	1965-10-23 00:00:00	38000275	0	\N	\N	209566	0	74016001	4252419	
48124	4224	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	280472	0	180256009	4107731	
36394	3189	4043071	1974-11-28	1974-11-28 00:00:00	38000275	0	\N	\N	212299	0	228557008	4043071	
48586	4269	4198190	1976-05-01	1976-05-01 00:00:00	38000275	0	\N	\N	283316	0	80146002	4198190	
48681	4279	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	284001	0	180256009	4107731	
48886	4295	4163872	1973-07-14	1973-07-14 00:00:00	38000275	0	\N	\N	285044	0	399208008	4163872	
49109	4312	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	286085	0	180256009	4107731	
49191	4313	4107731	1993-04-17	1993-04-17 00:00:00	38000275	0	\N	\N	286245	0	180256009	4107731	
49396	4342	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	287925	0	180256009	4107731	
61695	5333	4163872	1993-12-20	1993-12-20 00:00:00	38000275	0	\N	\N	355094	0	399208008	4163872	
49745	4365	4181917	1983-08-08	1983-08-08 00:00:00	38000275	0	\N	\N	289589	0	54550000	4181917	
50095	4372	4197460	1981-01-03	1981-01-03 00:00:00	38000275	0	\N	\N	290259	0	313191000	4197460	
50125	4373	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	290345	0	180256009	4107731	
50599	4403	4035793	1999-07-10	1999-07-10 00:00:00	38000275	0	\N	\N	292697	0	15081005	4035793	
38862	3431	4202451	2001-10-17	2001-10-17 00:00:00	38000275	0	\N	\N	227443	0	433112001	4202451	
50955	4436	4125906	1968-05-12	1968-05-12 00:00:00	38000275	0	\N	\N	294878	0	288086009	4125906	
51415	4452	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	296317	0	180256009	4107731	
39485	3477	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	230723	0	180256009	4107731	
51700	4480	4238715	1989-09-12	1989-09-12 00:00:00	38000275	0	\N	\N	298175	0	68254000	4238715	
51839	4498	4151422	1983-12-01	1983-12-01 00:00:00	38000275	0	\N	\N	299435	0	269911007	4151422	
52063	4514	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	300658	0	180256009	4107731	
52347	4538	4047491	2011-10-29	2011-10-29 00:00:00	38000275	0	\N	\N	302317	0	1225002	4047491	
40534	3561	4078793	2008-09-08	2008-09-08 00:00:00	38000275	0	\N	\N	236448	0	180325003	4078793	
52615	4571	4125906	1979-02-06	1979-02-06 00:00:00	38000275	0	\N	\N	304553	0	288086009	4125906	
52918	4590	4275113	1974-10-19	1974-10-19 00:00:00	38000275	0	\N	\N	305851	0	65200003	4275113	
29171	2586	4043071	1982-10-16	1982-10-16 00:00:00	38000275	0	\N	\N	171140	0	228557008	4043071	
41286	3622	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	240805	0	180256009	4107731	
53342	4631	4151422	1918-12-21	1918-12-21 00:00:00	38000275	0	\N	\N	308601	0	269911007	4151422	
53647	4646	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	309767	0	180256009	4107731	
53787	4668	44783196	1987-06-29	1987-06-29 00:00:00	38000275	0	\N	\N	311069	0	699253003	44783196	
53866	4680	4202451	2000-01-01	2000-01-01 00:00:00	38000275	0	\N	\N	311966	0	433112001	4202451	
54076	4700	4043071	1965-09-14	1965-09-14 00:00:00	38000275	0	\N	\N	313038	0	228557008	4043071	
54414	4724	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	314712	0	180256009	4107731	
42548	3754	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	249461	0	180256009	4107731	
54639	4745	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	315934	0	180256009	4107731	
54882	4761	4170947	1983-11-16	1983-11-16 00:00:00	38000275	0	\N	\N	317235	0	274474001	4170947	
55142	4804	4107731	1990-06-18	1990-06-18 00:00:00	38000275	0	\N	\N	319606	0	180256009	4107731	
43215	3814	4295880	1993-11-01	1993-11-01 00:00:00	38000275	0	\N	\N	253357	0	76601001	4295880	
43508	3852	4107731	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	255762	0	180256009	4107731	
55647	4847	4035793	1991-06-26	1991-06-26 00:00:00	38000275	0	\N	\N	322474	0	15081005	4035793	
56008	4890	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	325154	0	180256009	4107731	
32318	2832	4107731	1996-02-17	1996-02-17 00:00:00	38000275	0	\N	\N	187964	0	180256009	4107731	
56893	4943	4170947	1970-07-05	1970-07-05 00:00:00	38000275	0	\N	\N	328620	0	274474001	4170947	
33284	2915	4107731	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	194269	0	180256009	4107731	
57223	4964	4108705	2016-01-30	2016-01-30 00:00:00	38000275	0	\N	\N	329971	0	180207008	4108705	
57605	4988	4125906	1960-09-11	1960-09-11 00:00:00	38000275	0	\N	\N	331793	0	288086009	4125906	
58016	5034	4043071	1932-08-16	1932-08-16 00:00:00	38000275	0	\N	\N	334483	0	228557008	4043071	
46264	4064	4107731	1990-03-05	1990-03-05 00:00:00	38000275	0	\N	\N	270077	0	180256009	4107731	
46542	4084	4125906	1978-06-22	1978-06-22 00:00:00	38000275	0	\N	\N	271436	0	288086009	4125906	
58701	5097	4107731	1995-08-27	1995-08-27 00:00:00	38000275	0	\N	\N	338737	0	180256009	4107731	
58778	5104	4043071	1992-09-04	1992-09-04 00:00:00	38000275	0	\N	\N	339167	0	228557008	4043071	
59149	5118	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	340273	0	180256009	4107731	
59553	5153	4252419	2014-06-14	2014-06-14 00:00:00	38000275	0	\N	\N	342653	0	74016001	4252419	
59681	5165	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	343324	0	180256009	4107731	
35952	3149	4170947	1961-12-13	1961-12-13 00:00:00	38000275	0	\N	\N	209565	0	274474001	4170947	
48125	4224	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	280471	0	180256009	4107731	
36395	3189	4043071	1973-09-20	1973-09-20 00:00:00	38000275	0	\N	\N	212249	0	228557008	4043071	
48587	4269	4252419	2006-07-07	2006-07-07 00:00:00	38000275	0	\N	\N	283354	0	74016001	4252419	
48682	4279	4195803	2018-03-16	2018-03-16 00:00:00	38000275	0	\N	\N	284093	0	312681000	4195803	
48891	4297	4243062	1978-09-07	1978-09-07 00:00:00	38000275	0	\N	\N	285175	0	60027007	4243062	
49110	4312	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	286092	0	180256009	4107731	
49192	4313	4107731	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	286296	0	180256009	4107731	
49397	4342	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	287970	0	180256009	4107731	
61696	5333	4170947	1962-12-22	1962-12-22 00:00:00	38000275	0	\N	\N	355121	0	274474001	4170947	
49746	4365	4078793	2014-02-02	2014-02-02 00:00:00	38000275	0	\N	\N	289562	0	180325003	4078793	
50096	4372	4107731	1994-09-29	1994-09-29 00:00:00	38000275	0	\N	\N	290267	0	180256009	4107731	
50126	4373	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	290411	0	180256009	4107731	
50600	4403	4035793	1998-07-04	1998-07-04 00:00:00	38000275	0	\N	\N	292692	0	15081005	4035793	
38863	3431	4125906	2000-08-17	2000-08-17 00:00:00	38000275	0	\N	\N	227482	0	288086009	4125906	
50956	4436	40492359	2003-06-13	2003-06-13 00:00:00	38000275	0	\N	\N	294881	0	447365002	40492359	
51416	4452	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	296315	0	180256009	4107731	
39486	3477	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	230602	0	180256009	4107731	
51701	4480	4170947	1993-12-14	1993-12-14 00:00:00	38000275	0	\N	\N	298188	0	274474001	4170947	
51840	4498	4199276	1994-09-20	1994-09-20 00:00:00	38000275	0	\N	\N	299457	0	301807007	4199276	
52064	4514	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	300629	0	180256009	4107731	
52348	4538	4195803	2011-10-29	2011-10-29 00:00:00	38000275	0	\N	\N	302317	0	312681000	4195803	
40535	3561	4057420	2018-11-05	2018-11-05 00:00:00	38000275	0	\N	\N	236546	0	18286008	4057420	
52616	4571	4125906	1981-03-18	1981-03-18 00:00:00	38000275	0	\N	\N	304554	0	288086009	4125906	
52919	4590	4125906	1962-06-10	1962-06-10 00:00:00	38000275	0	\N	\N	305862	0	288086009	4125906	
29172	2586	4043071	1984-01-21	1984-01-21 00:00:00	38000275	0	\N	\N	171175	0	228557008	4043071	
41287	3622	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	240739	0	180256009	4107731	
53343	4631	4010253	1978-12-17	1978-12-17 00:00:00	38000275	0	\N	\N	308577	0	112790001	4010253	
53653	4649	4047491	1984-05-06	1984-05-06 00:00:00	38000275	0	\N	\N	309990	0	1225002	4047491	
53788	4668	4243062	1985-06-02	1985-06-02 00:00:00	38000275	0	\N	\N	311085	0	60027007	4243062	
53867	4680	4058899	1985-06-24	1985-06-24 00:00:00	38000275	0	\N	\N	311949	0	168594001	4058899	
54077	4700	4043071	1967-02-21	1967-02-21 00:00:00	38000275	0	\N	\N	313054	0	228557008	4043071	
54415	4724	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	314729	0	180256009	4107731	
42549	3754	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	249509	0	180256009	4107731	
54640	4745	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	315922	0	180256009	4107731	
54883	4761	4047491	1983-11-16	1983-11-16 00:00:00	38000275	0	\N	\N	317235	0	1225002	4047491	
55143	4804	4107731	1992-03-09	1992-03-09 00:00:00	38000275	0	\N	\N	319556	0	180256009	4107731	
43216	3814	4295880	1998-11-01	1998-11-01 00:00:00	38000275	0	\N	\N	253328	0	76601001	4295880	
43509	3852	4107731	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	255641	0	180256009	4107731	
55648	4847	4035793	2007-02-28	2007-02-28 00:00:00	38000275	0	\N	\N	322459	0	15081005	4035793	
56009	4890	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	325112	0	180256009	4107731	
32319	2832	4107731	1994-12-24	1994-12-24 00:00:00	38000275	0	\N	\N	187873	0	180256009	4107731	
56894	4943	4243062	1970-07-05	1970-07-05 00:00:00	38000275	0	\N	\N	328620	0	60027007	4243062	
33285	2915	4107731	1992-05-17	1992-05-17 00:00:00	38000275	0	\N	\N	194395	0	180256009	4107731	
57224	4964	4195803	2015-09-27	2015-09-27 00:00:00	38000275	0	\N	\N	329972	0	312681000	4195803	
57606	4988	4125906	2007-09-13	2007-09-13 00:00:00	38000275	0	\N	\N	331829	0	288086009	4125906	
58017	5034	4252419	1971-03-08	1971-03-08 00:00:00	38000275	0	\N	\N	334461	0	74016001	4252419	
46265	4064	4107731	1990-04-16	1990-04-16 00:00:00	38000275	0	\N	\N	270078	0	180256009	4107731	
46543	4084	4243062	1976-08-01	1976-08-01 00:00:00	38000275	0	\N	\N	271435	0	60027007	4243062	
58702	5097	4107731	1993-04-18	1993-04-18 00:00:00	38000275	0	\N	\N	338720	0	180256009	4107731	
58779	5104	4043071	1993-12-16	1993-12-16 00:00:00	38000275	0	\N	\N	339170	0	228557008	4043071	
59150	5118	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	340280	0	180256009	4107731	
59554	5153	4024289	1977-03-30	1977-03-30 00:00:00	38000275	0	\N	\N	342652	0	19490002	4024289	
59682	5166	4243062	1955-02-22	1955-02-22 00:00:00	38000275	0	\N	\N	343399	0	60027007	4243062	
35953	3149	4243062	1961-12-13	1961-12-13 00:00:00	38000275	0	\N	\N	209565	0	60027007	4243062	
48126	4224	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	280460	0	180256009	4107731	
36396	3189	4043071	1974-06-27	1974-06-27 00:00:00	38000275	0	\N	\N	212251	0	228557008	4043071	
48588	4270	4043071	1977-04-22	1977-04-22 00:00:00	38000275	0	\N	\N	283445	0	228557008	4043071	
48683	4279	4024289	2018-03-16	2018-03-16 00:00:00	38000275	0	\N	\N	284093	0	19490002	4024289	
48892	4297	4170947	1978-09-07	1978-09-07 00:00:00	38000275	0	\N	\N	285175	0	274474001	4170947	
49111	4312	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	286200	0	180256009	4107731	
49193	4313	4107731	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	286239	0	180256009	4107731	
49398	4342	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	287926	0	180256009	4107731	
61697	5333	4024289	1962-12-22	1962-12-22 00:00:00	38000275	0	\N	\N	355121	0	19490002	4024289	
49747	4365	4202451	2016-01-10	2016-01-10 00:00:00	38000275	0	\N	\N	289584	0	433112001	4202451	
50097	4372	4107731	1995-04-06	1995-04-06 00:00:00	38000275	0	\N	\N	290270	0	180256009	4107731	
50127	4373	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	290358	0	180256009	4107731	
50601	4403	4035793	1997-06-28	1997-06-28 00:00:00	38000275	0	\N	\N	292696	0	15081005	4035793	
38864	3431	4125906	1975-11-22	1975-11-22 00:00:00	38000275	0	\N	\N	227475	0	288086009	4125906	
50957	4436	4057420	2003-06-13	2003-06-13 00:00:00	38000275	0	\N	\N	294881	0	18286008	4057420	
51417	4452	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	296290	0	180256009	4107731	
39487	3477	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	230675	0	180256009	4107731	
51702	4480	4024289	1993-12-14	1993-12-14 00:00:00	38000275	0	\N	\N	298188	0	19490002	4024289	
51842	4500	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	299573	0	180256009	4107731	
52065	4514	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	300628	0	180256009	4107731	
52349	4538	4125906	2003-12-26	2003-12-26 00:00:00	38000275	0	\N	\N	302316	0	288086009	4125906	
40536	3561	4078793	1976-05-03	1976-05-03 00:00:00	38000275	0	\N	\N	236428	0	180325003	4078793	
52617	4571	4252419	2001-03-17	2001-03-17 00:00:00	38000275	0	\N	\N	304555	0	74016001	4252419	
52920	4591	4125906	2018-04-08	2018-04-08 00:00:00	38000275	0	\N	\N	305898	0	288086009	4125906	
40954	3589	4107731	1996-04-01	1996-04-01 00:00:00	38000275	0	\N	\N	238437	0	180256009	4107731	
41288	3622	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	240661	0	180256009	4107731	
53344	4631	4170947	2002-06-28	2002-06-28 00:00:00	38000275	0	\N	\N	308560	0	274474001	4170947	
53654	4649	4170947	1984-05-06	1984-05-06 00:00:00	38000275	0	\N	\N	309990	0	274474001	4170947	
53789	4668	4170947	1985-06-02	1985-06-02 00:00:00	38000275	0	\N	\N	311085	0	274474001	4170947	
53868	4680	4195803	1985-06-24	1985-06-24 00:00:00	38000275	0	\N	\N	311949	0	312681000	4195803	
54078	4700	4043071	1965-11-16	1965-11-16 00:00:00	38000275	0	\N	\N	313025	0	228557008	4043071	
54416	4724	4238715	1973-06-20	1973-06-20 00:00:00	38000275	0	\N	\N	314802	0	68254000	4238715	
42550	3754	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	249526	0	180256009	4107731	
54641	4745	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	315997	0	180256009	4107731	
54884	4761	4151422	2014-06-19	2014-06-19 00:00:00	38000275	0	\N	\N	317325	0	269911007	4151422	
55144	4804	4191853	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	319661	0	395142003	4191853	
43217	3814	4163872	1987-06-26	1987-06-26 00:00:00	38000275	0	\N	\N	253313	0	399208008	4163872	
43510	3852	4107731	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	255678	0	180256009	4107731	
55649	4847	4035793	2004-02-11	2004-02-11 00:00:00	38000275	0	\N	\N	322451	0	15081005	4035793	
56010	4890	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	325114	0	180256009	4107731	
32320	2832	4107731	1997-04-12	1997-04-12 00:00:00	38000275	0	\N	\N	187997	0	180256009	4107731	
56895	4943	4252419	1979-11-15	1979-11-15 00:00:00	38000275	0	\N	\N	328622	0	74016001	4252419	
33286	2915	4107731	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	194260	0	180256009	4107731	
57225	4964	4024289	2015-09-27	2015-09-27 00:00:00	38000275	0	\N	\N	329972	0	19490002	4024289	
57607	4988	4186930	1976-03-30	1976-03-30 00:00:00	38000275	0	\N	\N	331827	0	46706006	4186930	
58018	5034	4043071	1932-07-12	1932-07-12 00:00:00	38000275	0	\N	\N	334528	0	228557008	4043071	
46266	4064	4107731	1990-07-09	1990-07-09 00:00:00	38000275	0	\N	\N	269989	0	180256009	4107731	
46544	4084	4170947	1976-08-01	1976-08-01 00:00:00	38000275	0	\N	\N	271435	0	274474001	4170947	
58703	5097	4107731	1995-12-31	1995-12-31 00:00:00	38000275	0	\N	\N	338685	0	180256009	4107731	
58780	5104	4043071	1993-01-07	1993-01-07 00:00:00	38000275	0	\N	\N	339206	0	228557008	4043071	
59151	5118	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	340235	0	180256009	4107731	
59555	5153	4170947	1977-03-30	1977-03-30 00:00:00	38000275	0	\N	\N	342652	0	274474001	4170947	
59683	5166	4170947	1955-02-22	1955-02-22 00:00:00	38000275	0	\N	\N	343399	0	274474001	4170947	
35954	3150	4163872	1955-12-24	1955-12-24 00:00:00	38000275	0	\N	\N	209606	0	399208008	4163872	
48127	4224	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	280458	0	180256009	4107731	
36397	3189	4043071	1974-09-05	1974-09-05 00:00:00	38000275	0	\N	\N	212253	0	228557008	4043071	
48589	4270	4043071	1978-05-19	1978-05-19 00:00:00	38000275	0	\N	\N	283447	0	228557008	4043071	
48684	4279	4170947	2018-03-16	2018-03-16 00:00:00	38000275	0	\N	\N	284093	0	274474001	4170947	
48893	4297	4202832	1991-02-19	1991-02-19 00:00:00	38000275	0	\N	\N	285178	0	52765003	4202832	
49112	4312	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	286203	0	180256009	4107731	
49194	4313	4107731	1992-04-25	1992-04-25 00:00:00	38000275	0	\N	\N	286240	0	180256009	4107731	
49399	4342	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	287964	0	395142003	4191853	
61698	5333	4163872	1993-08-27	1993-08-27 00:00:00	38000275	0	\N	\N	355148	0	399208008	4163872	
49748	4365	4078793	2015-02-08	2015-02-08 00:00:00	38000275	0	\N	\N	289584	0	180325003	4078793	
50098	4372	4107731	1993-06-03	1993-06-03 00:00:00	38000275	0	\N	\N	290331	0	180256009	4107731	
50128	4373	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	290347	0	180256009	4107731	
50602	4403	4170947	1943-11-15	1943-11-15 00:00:00	38000275	0	\N	\N	292704	0	274474001	4170947	
38865	3431	4293740	1975-11-22	1975-11-22 00:00:00	38000275	0	\N	\N	227475	0	384700001	4293740	
50958	4436	4170947	1980-05-23	1980-05-23 00:00:00	38000275	0	\N	\N	294879	0	274474001	4170947	
51418	4452	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	296282	0	180256009	4107731	
39488	3477	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	230725	0	180256009	4107731	
51703	4480	4170947	1966-09-02	1966-09-02 00:00:00	38000275	0	\N	\N	298204	0	274474001	4170947	
51843	4500	4125906	2007-07-19	2007-07-19 00:00:00	38000275	0	\N	\N	299606	0	288086009	4125906	
52066	4514	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	300684	0	395142003	4191853	
52350	4538	4252419	1972-10-02	1972-10-02 00:00:00	38000275	0	\N	\N	302314	0	74016001	4252419	
40537	3561	4078793	1995-11-06	1995-11-06 00:00:00	38000275	0	\N	\N	236551	0	180325003	4078793	
52618	4571	4151422	1993-12-29	1993-12-29 00:00:00	38000275	0	\N	\N	304560	0	269911007	4151422	
52921	4591	4125906	1989-11-22	1989-11-22 00:00:00	38000275	0	\N	\N	305896	0	288086009	4125906	
40955	3589	4107731	1995-09-26	1995-09-26 00:00:00	38000275	0	\N	\N	238458	0	180256009	4107731	
41289	3622	40492359	1953-04-22	1953-04-22 00:00:00	38000275	0	\N	\N	240710	0	447365002	40492359	
53345	4631	4024289	2002-06-28	2002-06-28 00:00:00	38000275	0	\N	\N	308560	0	19490002	4024289	
53657	4653	4151422	2011-06-28	2011-06-28 00:00:00	38000275	0	\N	\N	310148	0	269911007	4151422	
53790	4668	40492359	2011-04-26	2011-04-26 00:00:00	38000275	0	\N	\N	311088	0	447365002	40492359	
53869	4680	4125906	1944-12-30	1944-12-30 00:00:00	38000275	0	\N	\N	311941	0	288086009	4125906	
54079	4700	4043071	1966-10-04	1966-10-04 00:00:00	38000275	0	\N	\N	313028	0	228557008	4043071	
54417	4724	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	314713	0	180256009	4107731	
42551	3754	44783196	2017-05-25	2017-05-25 00:00:00	38000275	0	\N	\N	249514	0	699253003	44783196	
54642	4745	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	315905	0	180256009	4107731	
54885	4761	4107731	1993-11-15	1993-11-15 00:00:00	38000275	0	\N	\N	317277	0	180256009	4107731	
55145	4804	4107731	1991-04-29	1991-04-29 00:00:00	38000275	0	\N	\N	319619	0	180256009	4107731	
43218	3814	4170947	1987-06-26	1987-06-26 00:00:00	38000275	0	\N	\N	253313	0	274474001	4170947	
43511	3852	4107731	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	255767	0	180256009	4107731	
55650	4847	4035793	2009-03-04	2009-03-04 00:00:00	38000275	0	\N	\N	322452	0	15081005	4035793	
56011	4890	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	325155	0	180256009	4107731	
32321	2832	4107731	1994-07-30	1994-07-30 00:00:00	38000275	0	\N	\N	187949	0	180256009	4107731	
56896	4943	44783196	1979-11-22	1979-11-22 00:00:00	38000275	0	\N	\N	328563	0	699253003	44783196	
45117	3966	4125906	1977-06-29	1977-06-29 00:00:00	38000275	0	\N	\N	263663	0	288086009	4125906	
57226	4964	4170947	2015-09-27	2015-09-27 00:00:00	38000275	0	\N	\N	329972	0	274474001	4170947	
57609	4990	4058899	1967-03-29	1967-03-29 00:00:00	38000275	0	\N	\N	331968	0	168594001	4058899	
58019	5034	4043071	1932-04-05	1932-04-05 00:00:00	38000275	0	\N	\N	334441	0	228557008	4043071	
46267	4064	4107731	1991-07-22	1991-07-22 00:00:00	38000275	0	\N	\N	270005	0	180256009	4107731	
46545	4084	4057420	2010-10-03	2010-10-03 00:00:00	38000275	0	\N	\N	271438	0	18286008	4057420	
58704	5097	4107731	1994-04-10	1994-04-10 00:00:00	38000275	0	\N	\N	338702	0	180256009	4107731	
58781	5104	4043071	1993-11-18	1993-11-18 00:00:00	38000275	0	\N	\N	339196	0	228557008	4043071	
59152	5118	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	340172	0	180256009	4107731	
59556	5153	44783196	2014-06-21	2014-06-21 00:00:00	38000275	0	\N	\N	342742	0	699253003	44783196	
59684	5166	4170947	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	343403	0	274474001	4170947	
35955	3150	4058899	1957-01-22	1957-01-22 00:00:00	38000275	0	\N	\N	209568	0	168594001	4058899	
48128	4224	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	280516	0	180256009	4107731	
36398	3189	4125906	1973-01-05	1973-01-05 00:00:00	38000275	0	\N	\N	212270	0	288086009	4125906	
48590	4270	4043071	1978-06-23	1978-06-23 00:00:00	38000275	0	\N	\N	283399	0	228557008	4043071	
48685	4279	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	283981	0	180256009	4107731	
48894	4297	4163971	1991-02-19	1991-02-19 00:00:00	38000275	0	\N	\N	285178	0	45595009	4163971	
49113	4312	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	286206	0	180256009	4107731	
49195	4313	4107731	1990-02-17	1990-02-17 00:00:00	38000275	0	\N	\N	286292	0	180256009	4107731	
49400	4342	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	287913	0	180256009	4107731	
61699	5334	4125906	2008-08-24	2008-08-24 00:00:00	38000275	0	\N	\N	355236	0	288086009	4125906	
49749	4365	4181917	1982-11-24	1982-11-24 00:00:00	38000275	0	\N	\N	289587	0	54550000	4181917	
50099	4372	4107731	1995-07-20	1995-07-20 00:00:00	38000275	0	\N	\N	290256	0	180256009	4107731	
50129	4373	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	290397	0	180256009	4107731	
50603	4403	4024289	1943-11-15	1943-11-15 00:00:00	38000275	0	\N	\N	292704	0	19490002	4024289	
38866	3432	4181917	1953-11-08	1953-11-08 00:00:00	38000275	0	\N	\N	227483	0	54550000	4181917	
50959	4436	4243062	1980-05-23	1980-05-23 00:00:00	38000275	0	\N	\N	294879	0	60027007	4243062	
51419	4452	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	296278	0	180256009	4107731	
39489	3477	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	230722	0	180256009	4107731	
51704	4480	4243062	1966-09-02	1966-09-02 00:00:00	38000275	0	\N	\N	298204	0	60027007	4243062	
51844	4500	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	299576	0	180256009	4107731	
52067	4514	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	300593	0	180256009	4107731	
52351	4538	44783196	1972-10-09	1972-10-09 00:00:00	38000275	0	\N	\N	302360	0	699253003	44783196	
40538	3561	4057420	1973-04-16	1973-04-16 00:00:00	38000275	0	\N	\N	236440	0	18286008	4057420	
52619	4572	4125906	2002-05-06	2002-05-06 00:00:00	38000275	0	\N	\N	304637	0	288086009	4125906	
40956	3589	4107731	1994-05-10	1994-05-10 00:00:00	38000275	0	\N	\N	238401	0	180256009	4107731	
41290	3622	4057420	1953-04-22	1953-04-22 00:00:00	38000275	0	\N	\N	240710	0	18286008	4057420	
53346	4631	4195803	2002-06-28	2002-06-28 00:00:00	38000275	0	\N	\N	308560	0	312681000	4195803	
53658	4653	4010253	1960-01-08	1960-01-08 00:00:00	38000275	0	\N	\N	310187	0	112790001	4010253	
53791	4668	4057420	2011-04-26	2011-04-26 00:00:00	38000275	0	\N	\N	311088	0	18286008	4057420	
53870	4680	4125906	1957-04-10	1957-04-10 00:00:00	38000275	0	\N	\N	311945	0	288086009	4125906	
54080	4700	4043071	1966-04-19	1966-04-19 00:00:00	38000275	0	\N	\N	313063	0	228557008	4043071	
42552	3754	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	249490	0	180256009	4107731	
54643	4745	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	315921	0	180256009	4107731	
54886	4761	4107731	1995-08-28	1995-08-28 00:00:00	38000275	0	\N	\N	317228	0	180256009	4107731	
55146	4804	4107731	1992-02-17	1992-02-17 00:00:00	38000275	0	\N	\N	319641	0	180256009	4107731	
43219	3814	4295880	1996-02-04	1996-02-04 00:00:00	38000275	0	\N	\N	253371	0	76601001	4295880	
43512	3852	4107731	1992-01-27	1992-01-27 00:00:00	38000275	0	\N	\N	255749	0	180256009	4107731	
55651	4847	4035793	2005-02-16	2005-02-16 00:00:00	38000275	0	\N	\N	322458	0	15081005	4035793	
56012	4890	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	325094	0	180256009	4107731	
32322	2832	4107731	1994-09-10	1994-09-10 00:00:00	38000275	0	\N	\N	187898	0	180256009	4107731	
56897	4943	4151422	2014-09-30	2014-09-30 00:00:00	38000275	0	\N	\N	328582	0	269911007	4151422	
45118	3966	4151422	2005-10-18	2005-10-18 00:00:00	38000275	0	\N	\N	263635	0	269911007	4151422	
57227	4964	4326177	2016-01-30	2016-01-30 00:00:00	38000275	0	\N	\N	329971	0	430193006	4326177	
57610	4990	4058899	1974-01-21	1974-01-21 00:00:00	38000275	0	\N	\N	331969	0	168594001	4058899	
58020	5034	4151422	1956-12-14	1956-12-14 00:00:00	38000275	0	\N	\N	334516	0	269911007	4151422	
46268	4064	4107731	1992-09-14	1992-09-14 00:00:00	38000275	0	\N	\N	270086	0	180256009	4107731	
46546	4084	40492359	2010-10-03	2010-10-03 00:00:00	38000275	0	\N	\N	271438	0	447365002	40492359	
58705	5097	4107731	1995-05-14	1995-05-14 00:00:00	38000275	0	\N	\N	338712	0	180256009	4107731	
58782	5104	4043071	1993-08-20	1993-08-20 00:00:00	38000275	0	\N	\N	339213	0	228557008	4043071	
59153	5118	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	340281	0	180256009	4107731	
59557	5153	4198190	1963-12-25	1963-12-25 00:00:00	38000275	0	\N	\N	342654	0	80146002	4198190	
59685	5166	4243062	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	343403	0	60027007	4243062	
35956	3150	4151422	1955-01-20	1955-01-20 00:00:00	38000275	0	\N	\N	209582	0	269911007	4151422	
48129	4224	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	280470	0	180256009	4107731	
36399	3189	4117038	1991-04-18	1991-04-18 00:00:00	38000275	0	\N	\N	212303	0	287664005	4117038	
48591	4270	4151422	1995-09-22	1995-09-22 00:00:00	38000275	0	\N	\N	283438	0	269911007	4151422	
48686	4279	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	284050	0	180256009	4107731	
48895	4297	42535580	1991-02-19	1991-02-19 00:00:00	38000275	0	\N	\N	285178	0	426701000119108	42535580	
49114	4312	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	286082	0	180256009	4107731	
49196	4313	4047491	1953-09-06	1953-09-06 00:00:00	38000275	0	\N	\N	286307	0	1225002	4047491	
49401	4342	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	287905	0	180256009	4107731	
61700	5335	4043071	1967-01-13	1967-01-13 00:00:00	38000275	0	\N	\N	355294	0	228557008	4043071	
49750	4365	4078793	2004-08-09	2004-08-09 00:00:00	38000275	0	\N	\N	289551	0	180325003	4078793	
50100	4372	4107731	1995-08-10	1995-08-10 00:00:00	38000275	0	\N	\N	290303	0	180256009	4107731	
50130	4373	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	290384	0	180256009	4107731	
50604	4403	4125906	1949-10-14	1949-10-14 00:00:00	38000275	0	\N	\N	292706	0	288086009	4125906	
38867	3432	4195803	2007-09-10	2007-09-10 00:00:00	38000275	0	\N	\N	227490	0	312681000	4195803	
51420	4452	4163872	1995-02-06	1995-02-06 00:00:00	38000275	0	\N	\N	296346	0	399208008	4163872	
39490	3477	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	230606	0	180256009	4107731	
51705	4480	4151422	1965-09-08	1965-09-08 00:00:00	38000275	0	\N	\N	298122	0	269911007	4151422	
51845	4500	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	299581	0	180256009	4107731	
52068	4514	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	300651	0	180256009	4107731	
52359	4543	4125906	2001-06-05	2001-06-05 00:00:00	38000275	0	\N	\N	302642	0	288086009	4125906	
40539	3561	4078793	2007-01-08	2007-01-08 00:00:00	38000275	0	\N	\N	236566	0	180325003	4078793	
52622	4574	4326177	1974-03-12	1974-03-12 00:00:00	38000275	0	\N	\N	304682	0	430193006	4326177	
40957	3589	4107731	1994-09-13	1994-09-13 00:00:00	38000275	0	\N	\N	238478	0	180256009	4107731	
41291	3622	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	240810	0	180256009	4107731	
53347	4631	4125906	1982-06-03	1982-06-03 00:00:00	38000275	0	\N	\N	308555	0	288086009	4125906	
53659	4653	4151422	1993-07-04	1993-07-04 00:00:00	38000275	0	\N	\N	310146	0	269911007	4151422	
53793	4670	4238715	1980-04-23	1980-04-23 00:00:00	38000275	0	\N	\N	311168	0	68254000	4238715	
53871	4680	4293740	1957-04-10	1957-04-10 00:00:00	38000275	0	\N	\N	311945	0	384700001	4293740	
54081	4700	4043071	1967-05-02	1967-05-02 00:00:00	38000275	0	\N	\N	313056	0	228557008	4043071	
42553	3754	4252419	2017-05-18	2017-05-18 00:00:00	38000275	0	\N	\N	249553	0	74016001	4252419	
54644	4745	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	315900	0	180256009	4107731	
54887	4761	4107731	1994-02-28	1994-02-28 00:00:00	38000275	0	\N	\N	317218	0	180256009	4107731	
55147	4804	4107731	1992-06-01	1992-06-01 00:00:00	38000275	0	\N	\N	319558	0	180256009	4107731	
43220	3814	4295880	1996-08-04	1996-08-04 00:00:00	38000275	0	\N	\N	253352	0	76601001	4295880	
43513	3852	4191853	1990-01-01	1990-01-01 00:00:00	38000275	0	\N	\N	255637	0	395142003	4191853	
55652	4847	4035793	2012-03-21	2012-03-21 00:00:00	38000275	0	\N	\N	322480	0	15081005	4035793	
56013	4890	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	325124	0	180256009	4107731	
32323	2832	4107731	1995-02-25	1995-02-25 00:00:00	38000275	0	\N	\N	187959	0	180256009	4107731	
56900	4945	4151422	1982-05-03	1982-05-03 00:00:00	38000275	0	\N	\N	328667	0	269911007	4151422	
45119	3967	4151422	2018-06-17	2018-06-17 00:00:00	38000275	0	\N	\N	263776	0	269911007	4151422	
57228	4964	4037675	2016-01-30	2016-01-30 00:00:00	38000275	0	\N	\N	329971	0	162676008	4037675	
57611	4990	4058899	1979-12-21	1979-12-21 00:00:00	38000275	0	\N	\N	331970	0	168594001	4058899	
58021	5035	4024289	1996-06-20	1996-06-20 00:00:00	38000275	0	\N	\N	334620	0	19490002	4024289	
46269	4064	4107731	1993-01-18	1993-01-18 00:00:00	38000275	0	\N	\N	270115	0	180256009	4107731	
46547	4084	4170947	1994-08-18	1994-08-18 00:00:00	38000275	0	\N	\N	271437	0	274474001	4170947	
58706	5097	4107731	1995-10-08	1995-10-08 00:00:00	38000275	0	\N	\N	338683	0	180256009	4107731	
58783	5104	4043071	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	339211	0	228557008	4043071	
59154	5118	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	340174	0	180256009	4107731	
59561	5157	4024289	2018-01-22	2018-01-22 00:00:00	38000275	0	\N	\N	342948	0	19490002	4024289	
59686	5166	4047491	1966-05-25	1966-05-25 00:00:00	38000275	0	\N	\N	343400	0	1225002	4047491	
35964	3157	4243062	1964-07-29	1964-07-29 00:00:00	38000275	0	\N	\N	209878	0	60027007	4243062	
48130	4224	4151422	1973-12-15	1973-12-15 00:00:00	38000275	0	\N	\N	280532	0	269911007	4151422	
36400	3189	4043071	1973-08-16	1973-08-16 00:00:00	38000275	0	\N	\N	212248	0	228557008	4043071	
48592	4270	4043071	1977-11-11	1977-11-11 00:00:00	38000275	0	\N	\N	283390	0	228557008	4043071	
48687	4279	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	284036	0	180256009	4107731	
48896	4297	4163951	1991-02-19	1991-02-19 00:00:00	38000275	0	\N	\N	285178	0	29303009	4163951	
49115	4312	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	286091	0	180256009	4107731	
49197	4313	4170947	1953-09-06	1953-09-06 00:00:00	38000275	0	\N	\N	286307	0	274474001	4170947	
49402	4342	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	287910	0	180256009	4107731	
61701	5335	4043071	1967-12-08	1967-12-08 00:00:00	38000275	0	\N	\N	355244	0	228557008	4043071	
49751	4365	4078793	2003-08-04	2003-08-04 00:00:00	38000275	0	\N	\N	289574	0	180325003	4078793	
50101	4372	4125906	2019-06-04	2019-06-04 00:00:00	38000275	0	\N	\N	290289	0	288086009	4125906	
50131	4373	4191853	1976-07-18	1976-07-18 00:00:00	38000275	0	\N	\N	290341	0	395142003	4191853	
50605	4403	4125906	1962-06-29	1962-06-29 00:00:00	38000275	0	\N	\N	292707	0	288086009	4125906	
38868	3432	4170947	2007-09-10	2007-09-10 00:00:00	38000275	0	\N	\N	227490	0	274474001	4170947	
51421	4452	4170947	1995-02-06	1995-02-06 00:00:00	38000275	0	\N	\N	296346	0	274474001	4170947	
39491	3477	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	230663	0	180256009	4107731	
51706	4480	4186930	1985-12-31	1985-12-31 00:00:00	38000275	0	\N	\N	298192	0	46706006	4186930	
51846	4500	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	299565	0	180256009	4107731	
52069	4514	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	300654	0	180256009	4107731	
52360	4543	4293740	2001-06-05	2001-06-05 00:00:00	38000275	0	\N	\N	302642	0	384700001	4293740	
40540	3561	4078793	1974-04-22	1974-04-22 00:00:00	38000275	0	\N	\N	236427	0	180325003	4078793	
52623	4574	4187458	1974-03-12	1974-03-12 00:00:00	38000275	0	\N	\N	304682	0	415300000	4187458	
40958	3589	4107731	1994-02-14	1994-02-14 00:00:00	38000275	0	\N	\N	238451	0	180256009	4107731	
41292	3622	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	240808	0	180256009	4107731	
53348	4631	4058899	1929-10-09	1929-10-09 00:00:00	38000275	0	\N	\N	308553	0	168594001	4058899	
53794	4670	4275113	1978-02-06	1978-02-06 00:00:00	38000275	0	\N	\N	311167	0	65200003	4275113	
53872	4680	4181917	1946-04-08	1946-04-08 00:00:00	38000275	0	\N	\N	311942	0	54550000	4181917	
54082	4700	4043071	1965-12-14	1965-12-14 00:00:00	38000275	0	\N	\N	313053	0	228557008	4043071	
42554	3754	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	249458	0	180256009	4107731	
54645	4745	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	315971	0	395142003	4191853	
54888	4761	4107731	1993-09-13	1993-09-13 00:00:00	38000275	0	\N	\N	317270	0	180256009	4107731	
55148	4804	4107731	1990-10-01	1990-10-01 00:00:00	38000275	0	\N	\N	319636	0	180256009	4107731	
43224	3817	4125906	2011-05-17	2011-05-17 00:00:00	38000275	0	\N	\N	253530	0	288086009	4125906	
43514	3852	4107731	1992-06-22	1992-06-22 00:00:00	38000275	0	\N	\N	255768	0	180256009	4107731	
55653	4847	4035793	1991-09-11	1991-09-11 00:00:00	38000275	0	\N	\N	322454	0	15081005	4035793	
56014	4890	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	325100	0	180256009	4107731	
32324	2832	4107731	1997-01-18	1997-01-18 00:00:00	38000275	0	\N	\N	187995	0	180256009	4107731	
56901	4945	4010253	1974-05-07	1974-05-07 00:00:00	38000275	0	\N	\N	328666	0	112790001	4010253	
45120	3967	4198190	1993-04-25	1993-04-25 00:00:00	38000275	0	\N	\N	263743	0	80146002	4198190	
57229	4964	4187458	2016-01-30	2016-01-30 00:00:00	38000275	0	\N	\N	329971	0	415300000	4187458	
57612	4990	4170947	1966-03-04	1966-03-04 00:00:00	38000275	0	\N	\N	331967	0	274474001	4170947	
58022	5035	4170947	1996-06-20	1996-06-20 00:00:00	38000275	0	\N	\N	334620	0	274474001	4170947	
46270	4064	4107731	1990-06-18	1990-06-18 00:00:00	38000275	0	\N	\N	270092	0	180256009	4107731	
46548	4084	4243062	1994-08-18	1994-08-18 00:00:00	38000275	0	\N	\N	271437	0	60027007	4243062	
58707	5097	4107731	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	338631	0	180256009	4107731	
58784	5104	4043071	1993-10-15	1993-10-15 00:00:00	38000275	0	\N	\N	339195	0	228557008	4043071	
59155	5118	4197460	1968-10-11	1968-10-11 00:00:00	38000275	0	\N	\N	340156	0	313191000	4197460	
59562	5157	4170947	2018-01-22	2018-01-22 00:00:00	38000275	0	\N	\N	342948	0	274474001	4170947	
59687	5166	4170947	1966-05-25	1966-05-25 00:00:00	38000275	0	\N	\N	343400	0	274474001	4170947	
35965	3157	4170947	1964-07-29	1964-07-29 00:00:00	38000275	0	\N	\N	209878	0	274474001	4170947	
48131	4224	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	280576	0	180256009	4107731	
36401	3189	4043071	1974-04-25	1974-04-25 00:00:00	38000275	0	\N	\N	212221	0	228557008	4043071	
48593	4270	4043071	1977-09-09	1977-09-09 00:00:00	38000275	0	\N	\N	283434	0	228557008	4043071	
48688	4279	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	284064	0	180256009	4107731	
48897	4297	4125906	1979-11-01	1979-11-01 00:00:00	38000275	0	\N	\N	285176	0	288086009	4125906	
49116	4312	4062501	1963-09-22	1963-09-22 00:00:00	38000275	0	\N	\N	286193	0	171231001	4062501	
49198	4313	4107731	1992-02-22	1992-02-22 00:00:00	38000275	0	\N	\N	286357	0	180256009	4107731	
49403	4342	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	287876	0	180256009	4107731	
61702	5335	4043071	1966-12-16	1966-12-16 00:00:00	38000275	0	\N	\N	355241	0	228557008	4043071	
49752	4365	4078793	2011-01-16	2011-01-16 00:00:00	38000275	0	\N	\N	289582	0	180325003	4078793	
50102	4372	4107731	1994-12-01	1994-12-01 00:00:00	38000275	0	\N	\N	290254	0	180256009	4107731	
50132	4373	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	290357	0	180256009	4107731	
50606	4403	4293740	1962-06-29	1962-06-29 00:00:00	38000275	0	\N	\N	292707	0	384700001	4293740	
38869	3432	4047491	2007-09-10	2007-09-10 00:00:00	38000275	0	\N	\N	227490	0	1225002	4047491	
51422	4452	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	296275	0	180256009	4107731	
39492	3477	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	230729	0	180256009	4107731	
51707	4480	4275113	1980-12-30	1980-12-30 00:00:00	38000275	0	\N	\N	298146	0	65200003	4275113	
51847	4500	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	299562	0	180256009	4107731	
52070	4514	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	300626	0	180256009	4107731	
40541	3561	4078793	1994-10-31	1994-10-31 00:00:00	38000275	0	\N	\N	236445	0	180325003	4078793	
52624	4574	4037675	1974-03-12	1974-03-12 00:00:00	38000275	0	\N	\N	304682	0	162676008	4037675	
40959	3589	4107731	1994-08-02	1994-08-02 00:00:00	38000275	0	\N	\N	238403	0	180256009	4107731	
41293	3622	4078793	2007-02-21	2007-02-21 00:00:00	38000275	0	\N	\N	240703	0	180325003	4078793	
53349	4631	4198190	1934-08-04	1934-08-04 00:00:00	38000275	0	\N	\N	308630	0	80146002	4198190	
53795	4670	4125906	1958-02-08	1958-02-08 00:00:00	38000275	0	\N	\N	311154	0	288086009	4125906	
53873	4680	4163872	1928-09-25	1928-09-25 00:00:00	38000275	0	\N	\N	311940	0	399208008	4163872	
54083	4700	4043071	1966-06-21	1966-06-21 00:00:00	38000275	0	\N	\N	313041	0	228557008	4043071	
42555	3754	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	249528	0	180256009	4107731	
54646	4745	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	315970	0	180256009	4107731	
54889	4761	4107731	1995-09-18	1995-09-18 00:00:00	38000275	0	\N	\N	317286	0	180256009	4107731	
55149	4804	4107731	1993-08-16	1993-08-16 00:00:00	38000275	0	\N	\N	319572	0	180256009	4107731	
43225	3817	4170947	1995-10-08	1995-10-08 00:00:00	38000275	0	\N	\N	253529	0	274474001	4170947	
43515	3852	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	255743	0	180256009	4107731	
55654	4847	4035793	1995-06-14	1995-06-14 00:00:00	38000275	0	\N	\N	322456	0	15081005	4035793	
56015	4890	4057420	2018-01-24	2018-01-24 00:00:00	38000275	0	\N	\N	325139	0	18286008	4057420	
32325	2833	4125906	1979-12-20	1979-12-20 00:00:00	38000275	0	\N	\N	188075	0	288086009	4125906	
57003	4952	4187458	1991-03-16	1991-03-16 00:00:00	38000275	0	\N	\N	329128	0	415300000	4187458	
45121	3967	4125906	1978-08-16	1978-08-16 00:00:00	38000275	0	\N	\N	263744	0	288086009	4125906	
57230	4964	4125906	1961-02-07	1961-02-07 00:00:00	38000275	0	\N	\N	329968	0	288086009	4125906	
57613	4990	4163872	1966-03-04	1966-03-04 00:00:00	38000275	0	\N	\N	331967	0	399208008	4163872	
58023	5035	4195803	1996-06-20	1996-06-20 00:00:00	38000275	0	\N	\N	334620	0	312681000	4195803	
46271	4064	4058899	2004-02-23	2004-02-23 00:00:00	38000275	0	\N	\N	270124	0	168594001	4058899	
46549	4084	4170947	1973-03-20	1973-03-20 00:00:00	38000275	0	\N	\N	271434	0	274474001	4170947	
58708	5097	4107731	1993-09-12	1993-09-12 00:00:00	38000275	0	\N	\N	338676	0	180256009	4107731	
58785	5104	4043071	1992-05-08	1992-05-08 00:00:00	38000275	0	\N	\N	339165	0	228557008	4043071	
59156	5118	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	340213	0	180256009	4107731	
59563	5157	4195803	2018-01-22	2018-01-22 00:00:00	38000275	0	\N	\N	342948	0	312681000	4195803	
59688	5166	4151422	2015-05-14	2015-05-14 00:00:00	38000275	0	\N	\N	343443	0	269911007	4151422	
35966	3157	4170947	1960-03-22	1960-03-22 00:00:00	38000275	0	\N	\N	209877	0	274474001	4170947	
48132	4224	4163872	1978-07-24	1978-07-24 00:00:00	38000275	0	\N	\N	280515	0	399208008	4163872	
36402	3189	4043071	1975-01-02	1975-01-02 00:00:00	38000275	0	\N	\N	212254	0	228557008	4043071	
48594	4270	4043071	1978-04-14	1978-04-14 00:00:00	38000275	0	\N	\N	283446	0	228557008	4043071	
48689	4279	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	284096	0	180256009	4107731	
48898	4299	4125906	2011-11-20	2011-11-20 00:00:00	38000275	0	\N	\N	285236	0	288086009	4125906	
49117	4312	4151422	1982-10-16	1982-10-16 00:00:00	38000275	0	\N	\N	286089	0	269911007	4151422	
49199	4313	4107731	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	286359	0	180256009	4107731	
49404	4342	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	287971	0	180256009	4107731	
61703	5335	4043071	1966-11-11	1966-11-11 00:00:00	38000275	0	\N	\N	355278	0	228557008	4043071	
49753	4365	4078793	2007-12-30	2007-12-30 00:00:00	38000275	0	\N	\N	289580	0	180325003	4078793	
50103	4372	4107731	1996-08-22	1996-08-22 00:00:00	38000275	0	\N	\N	290242	0	180256009	4107731	
50133	4373	4107731	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	290385	0	180256009	4107731	
50607	4403	4035793	2000-07-15	2000-07-15 00:00:00	38000275	0	\N	\N	292650	0	15081005	4035793	
38870	3432	4181917	1954-09-03	1954-09-03 00:00:00	38000275	0	\N	\N	227484	0	54550000	4181917	
51423	4452	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	296286	0	180256009	4107731	
39493	3477	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	230601	0	180256009	4107731	
51708	4480	4125906	1974-08-21	1974-08-21 00:00:00	38000275	0	\N	\N	298184	0	288086009	4125906	
51848	4500	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	299612	0	180256009	4107731	
52071	4514	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	300674	0	180256009	4107731	
40542	3561	4078793	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	236549	0	180325003	4078793	
52625	4574	4125906	1985-10-15	1985-10-15 00:00:00	38000275	0	\N	\N	304712	0	288086009	4125906	
40960	3589	4107731	1996-06-04	1996-06-04 00:00:00	38000275	0	\N	\N	238423	0	180256009	4107731	
41294	3623	4125906	1958-02-02	1958-02-02 00:00:00	38000275	0	\N	\N	240895	0	288086009	4125906	
53350	4631	4151422	1936-04-01	1936-04-01 00:00:00	38000275	0	\N	\N	308572	0	269911007	4151422	
53796	4670	4293740	1958-02-08	1958-02-08 00:00:00	38000275	0	\N	\N	311154	0	384700001	4293740	
53874	4680	4195803	1928-09-25	1928-09-25 00:00:00	38000275	0	\N	\N	311940	0	312681000	4195803	
54084	4700	4043071	1966-11-08	1966-11-08 00:00:00	38000275	0	\N	\N	313029	0	228557008	4043071	
42556	3754	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	249480	0	180256009	4107731	
54647	4745	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	316000	0	180256009	4107731	
54890	4761	4107731	1994-09-26	1994-09-26 00:00:00	38000275	0	\N	\N	317281	0	180256009	4107731	
55150	4804	4107731	1993-07-26	1993-07-26 00:00:00	38000275	0	\N	\N	319599	0	180256009	4107731	
43226	3817	4024289	1995-10-08	1995-10-08 00:00:00	38000275	0	\N	\N	253529	0	19490002	4024289	
43516	3852	4107731	1991-02-04	1991-02-04 00:00:00	38000275	0	\N	\N	255645	0	180256009	4107731	
55655	4847	4035793	2013-03-27	2013-03-27 00:00:00	38000275	0	\N	\N	322420	0	15081005	4035793	
56016	4890	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	325122	0	180256009	4107731	
32326	2833	4151422	1980-04-01	1980-04-01 00:00:00	38000275	0	\N	\N	188037	0	269911007	4151422	
57004	4952	4037675	1991-03-16	1991-03-16 00:00:00	38000275	0	\N	\N	329128	0	162676008	4037675	
45122	3968	4078793	2007-06-01	2007-06-01 00:00:00	38000275	0	\N	\N	263801	0	180325003	4078793	
57231	4964	4058899	1978-06-13	1978-06-13 00:00:00	38000275	0	\N	\N	329970	0	168594001	4058899	
57614	4991	4125906	1994-08-04	1994-08-04 00:00:00	38000275	0	\N	\N	332055	0	288086009	4125906	
58024	5035	4078793	2012-08-20	2012-08-20 00:00:00	38000275	0	\N	\N	334541	0	180325003	4078793	
46272	4064	4107731	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	270015	0	180256009	4107731	
46550	4084	4047491	1973-03-20	1973-03-20 00:00:00	38000275	0	\N	\N	271434	0	1225002	4047491	
58709	5097	4107731	1994-02-06	1994-02-06 00:00:00	38000275	0	\N	\N	338708	0	180256009	4107731	
58786	5104	4043071	1993-07-23	1993-07-23 00:00:00	38000275	0	\N	\N	339194	0	228557008	4043071	
59157	5118	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	340229	0	180256009	4107731	
59564	5157	4057420	2019-05-16	2019-05-16 00:00:00	38000275	0	\N	\N	342902	0	18286008	4057420	
59754	5168	4187458	2015-02-15	2015-02-15 00:00:00	38000275	0	\N	\N	343612	0	415300000	4187458	
35967	3157	4163872	1960-03-22	1960-03-22 00:00:00	38000275	0	\N	\N	209877	0	399208008	4163872	
48133	4224	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	280539	0	180256009	4107731	
36403	3189	4043071	1974-05-30	1974-05-30 00:00:00	38000275	0	\N	\N	212298	0	228557008	4043071	
48595	4270	4043071	1978-02-10	1978-02-10 00:00:00	38000275	0	\N	\N	283424	0	228557008	4043071	
48690	4279	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	284098	0	180256009	4107731	
48966	4304	4151422	1967-05-11	1967-05-11 00:00:00	38000275	0	\N	\N	285484	0	269911007	4151422	
49118	4312	4125906	1999-04-10	1999-04-10 00:00:00	38000275	0	\N	\N	286125	0	288086009	4125906	
49200	4313	4107731	1993-03-27	1993-03-27 00:00:00	38000275	0	\N	\N	286363	0	180256009	4107731	
49405	4343	4151422	1961-07-28	1961-07-28 00:00:00	38000275	0	\N	\N	288008	0	269911007	4151422	
61704	5335	4043071	1968-01-05	1968-01-05 00:00:00	38000275	0	\N	\N	355296	0	228557008	4043071	
49754	4365	4057420	2010-01-10	2010-01-10 00:00:00	38000275	0	\N	\N	289560	0	18286008	4057420	
50104	4372	4107731	1994-04-14	1994-04-14 00:00:00	38000275	0	\N	\N	290226	0	180256009	4107731	
50134	4373	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	290396	0	180256009	4107731	
50608	4403	4024289	1940-10-01	1940-10-01 00:00:00	38000275	0	\N	\N	292703	0	19490002	4024289	
38871	3432	4047491	1967-05-10	1967-05-10 00:00:00	38000275	0	\N	\N	227486	0	1225002	4047491	
51424	4452	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	296257	0	180256009	4107731	
39494	3477	4191853	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	230607	0	395142003	4191853	
51709	4480	4293740	1974-08-21	1974-08-21 00:00:00	38000275	0	\N	\N	298184	0	384700001	4293740	
51849	4500	4047491	2010-04-25	2010-04-25 00:00:00	38000275	0	\N	\N	299607	0	1225002	4047491	
52072	4514	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	300661	0	180256009	4107731	
40543	3561	4078793	1982-08-23	1982-08-23 00:00:00	38000275	0	\N	\N	236438	0	180325003	4078793	
52626	4574	4151422	1990-02-06	1990-02-06 00:00:00	38000275	0	\N	\N	304739	0	269911007	4151422	
40961	3589	4107731	1995-07-04	1995-07-04 00:00:00	38000275	0	\N	\N	238456	0	180256009	4107731	
41295	3623	4151422	1951-01-12	1951-01-12 00:00:00	38000275	0	\N	\N	240890	0	269911007	4151422	
53351	4631	4125906	1995-03-09	1995-03-09 00:00:00	38000275	0	\N	\N	308558	0	288086009	4125906	
53797	4670	4293740	2018-07-10	2018-07-10 00:00:00	38000275	0	\N	\N	311159	0	384700001	4293740	
53875	4680	4170947	1928-09-25	1928-09-25 00:00:00	38000275	0	\N	\N	311940	0	274474001	4170947	
54085	4700	4151422	1963-03-21	1963-03-21 00:00:00	38000275	0	\N	\N	313023	0	269911007	4151422	
42557	3754	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	249537	0	180256009	4107731	
54648	4745	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	315982	0	180256009	4107731	
54891	4761	4107731	1995-05-15	1995-05-15 00:00:00	38000275	0	\N	\N	317318	0	180256009	4107731	
55151	4804	4107731	1991-12-16	1991-12-16 00:00:00	38000275	0	\N	\N	319612	0	180256009	4107731	
43227	3817	4151422	1997-06-12	1997-06-12 00:00:00	38000275	0	\N	\N	253490	0	269911007	4151422	
43517	3852	4107731	1993-02-08	1993-02-08 00:00:00	38000275	0	\N	\N	255680	0	180256009	4107731	
55656	4847	4163872	1996-04-11	1996-04-11 00:00:00	38000275	0	\N	\N	322463	0	399208008	4163872	
56017	4890	4057420	2012-12-26	2012-12-26 00:00:00	38000275	0	\N	\N	325180	0	18286008	4057420	
32327	2834	4151422	1964-06-02	1964-06-02 00:00:00	38000275	0	\N	\N	188189	0	269911007	4151422	
57005	4952	4326177	1991-03-16	1991-03-16 00:00:00	38000275	0	\N	\N	329128	0	430193006	4326177	
45123	3968	4170947	2003-06-13	2003-06-13 00:00:00	38000275	0	\N	\N	263907	0	274474001	4170947	
57242	4967	4170947	1982-07-08	1982-07-08 00:00:00	38000275	0	\N	\N	330154	0	274474001	4170947	
57615	4991	4191853	1997-08-01	1997-08-01 00:00:00	38000275	0	\N	\N	332033	0	395142003	4191853	
58025	5035	4202451	1995-06-19	1995-06-19 00:00:00	38000275	0	\N	\N	334597	0	433112001	4202451	
46273	4064	4107731	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	269994	0	180256009	4107731	
46551	4085	4043071	1968-09-22	1968-09-22 00:00:00	38000275	0	\N	\N	271538	0	228557008	4043071	
58710	5097	4107731	1994-12-18	1994-12-18 00:00:00	38000275	0	\N	\N	338681	0	180256009	4107731	
58787	5104	4043071	1992-11-05	1992-11-05 00:00:00	38000275	0	\N	\N	339158	0	228557008	4043071	
59158	5118	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	340215	0	180256009	4107731	
59565	5157	4170947	1974-02-12	1974-02-12 00:00:00	38000275	0	\N	\N	342945	0	274474001	4170947	
59755	5168	4326177	2015-02-15	2015-02-15 00:00:00	38000275	0	\N	\N	343612	0	430193006	4326177	
35968	3157	4125906	2011-02-12	2011-02-12 00:00:00	38000275	0	\N	\N	209881	0	288086009	4125906	
48134	4224	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	280573	0	180256009	4107731	
36404	3189	4043071	1973-07-19	1973-07-19 00:00:00	38000275	0	\N	\N	212294	0	228557008	4043071	
48596	4270	4043071	1977-08-05	1977-08-05 00:00:00	38000275	0	\N	\N	283397	0	228557008	4043071	
48691	4279	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	283982	0	180256009	4107731	
48967	4304	4181917	1978-01-26	1978-01-26 00:00:00	38000275	0	\N	\N	285472	0	54550000	4181917	
49119	4312	4125906	2019-05-16	2019-05-16 00:00:00	38000275	0	\N	\N	286126	0	288086009	4125906	
49201	4313	4107731	1992-02-01	1992-02-01 00:00:00	38000275	0	\N	\N	286326	0	180256009	4107731	
49406	4343	44783196	1958-08-05	1958-08-05 00:00:00	38000275	0	\N	\N	288015	0	699253003	44783196	
61705	5335	4043071	1968-03-01	1968-03-01 00:00:00	38000275	0	\N	\N	355255	0	228557008	4043071	
49755	4365	4078793	2005-08-15	2005-08-15 00:00:00	38000275	0	\N	\N	289559	0	180325003	4078793	
50105	4372	4107731	1994-12-22	1994-12-22 00:00:00	38000275	0	\N	\N	290301	0	180256009	4107731	
50135	4373	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	290342	0	180256009	4107731	
50609	4403	4170947	1940-10-01	1940-10-01 00:00:00	38000275	0	\N	\N	292703	0	274474001	4170947	
38872	3432	4170947	1967-05-10	1967-05-10 00:00:00	38000275	0	\N	\N	227486	0	274474001	4170947	
51425	4452	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	296316	0	180256009	4107731	
39495	3477	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	230651	0	395142003	4191853	
51777	4482	4243062	1966-12-23	1966-12-23 00:00:00	38000275	0	\N	\N	298356	0	60027007	4243062	
51850	4500	4170947	2010-04-25	2010-04-25 00:00:00	38000275	0	\N	\N	299607	0	274474001	4170947	
52073	4514	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	300678	0	180256009	4107731	
40544	3561	4078793	2001-12-10	2001-12-10 00:00:00	38000275	0	\N	\N	236478	0	180325003	4078793	
52627	4576	4058899	1962-02-15	1962-02-15 00:00:00	38000275	0	\N	\N	304850	0	168594001	4058899	
40962	3589	4107731	1995-08-15	1995-08-15 00:00:00	38000275	0	\N	\N	238457	0	180256009	4107731	
41296	3623	4125906	2013-01-30	2013-01-30 00:00:00	38000275	0	\N	\N	240940	0	288086009	4125906	
53352	4631	4125906	1997-03-12	1997-03-12 00:00:00	38000275	0	\N	\N	308559	0	288086009	4125906	
53798	4670	4125906	2018-07-10	2018-07-10 00:00:00	38000275	0	\N	\N	311159	0	288086009	4125906	
53876	4680	4181917	1946-11-11	1946-11-11 00:00:00	38000275	0	\N	\N	311944	0	54550000	4181917	
54086	4700	4043071	1966-07-26	1966-07-26 00:00:00	38000275	0	\N	\N	313105	0	228557008	4043071	
42558	3754	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	249507	0	180256009	4107731	
54649	4745	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	315955	0	180256009	4107731	
54892	4761	4107731	1995-10-09	1995-10-09 00:00:00	38000275	0	\N	\N	317229	0	180256009	4107731	
55152	4804	4107731	1991-01-14	1991-01-14 00:00:00	38000275	0	\N	\N	319622	0	180256009	4107731	
43230	3820	4125906	1998-03-07	1998-03-07 00:00:00	38000275	0	\N	\N	253653	0	288086009	4125906	
43518	3852	4107731	1992-07-13	1992-07-13 00:00:00	38000275	0	\N	\N	255730	0	180256009	4107731	
55657	4847	4035793	2002-01-30	2002-01-30 00:00:00	38000275	0	\N	\N	322450	0	15081005	4035793	
56018	4890	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	325242	0	180256009	4107731	
32328	2834	4125906	1985-01-12	1985-01-12 00:00:00	38000275	0	\N	\N	188164	0	288086009	4125906	
57006	4952	4252419	1979-06-02	1979-06-02 00:00:00	38000275	0	\N	\N	329121	0	74016001	4252419	
45124	3968	4047491	2003-06-13	2003-06-13 00:00:00	38000275	0	\N	\N	263907	0	1225002	4047491	
57243	4967	4243062	1982-07-08	1982-07-08 00:00:00	38000275	0	\N	\N	330154	0	60027007	4243062	
57616	4991	4125906	1973-03-31	1973-03-31 00:00:00	38000275	0	\N	\N	332052	0	288086009	4125906	
58026	5035	4078793	2011-10-31	2011-10-31 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
46274	4064	4107731	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	269988	0	180256009	4107731	
46552	4085	4043071	1969-01-05	1969-01-05 00:00:00	38000275	0	\N	\N	271519	0	228557008	4043071	
58711	5097	4107731	1995-10-29	1995-10-29 00:00:00	38000275	0	\N	\N	338742	0	180256009	4107731	
58788	5104	4043071	1994-01-20	1994-01-20 00:00:00	38000275	0	\N	\N	339214	0	228557008	4043071	
59159	5118	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	340251	0	180256009	4107731	
59566	5157	4024289	1974-02-12	1974-02-12 00:00:00	38000275	0	\N	\N	342945	0	19490002	4024289	
59756	5168	4037675	2015-02-15	2015-02-15 00:00:00	38000275	0	\N	\N	343612	0	162676008	4037675	
35969	3158	4043071	1965-08-26	1965-08-26 00:00:00	38000275	0	\N	\N	209914	0	228557008	4043071	
48135	4224	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	280490	0	180256009	4107731	
36405	3189	4043071	1973-12-20	1973-12-20 00:00:00	38000275	0	\N	\N	212297	0	228557008	4043071	
48597	4270	4043071	1977-02-18	1977-02-18 00:00:00	38000275	0	\N	\N	283387	0	228557008	4043071	
48692	4279	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	284002	0	180256009	4107731	
48968	4304	4181917	1978-11-12	1978-11-12 00:00:00	38000275	0	\N	\N	285473	0	54550000	4181917	
49120	4312	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	286151	0	180256009	4107731	
49202	4313	4107731	1990-08-04	1990-08-04 00:00:00	38000275	0	\N	\N	286258	0	180256009	4107731	
49407	4343	4163872	1955-07-17	1955-07-17 00:00:00	38000275	0	\N	\N	287987	0	399208008	4163872	
61706	5335	4043071	1968-02-02	1968-02-02 00:00:00	38000275	0	\N	\N	355315	0	228557008	4043071	
49756	4365	4125906	1976-03-12	1976-03-12 00:00:00	38000275	0	\N	\N	289585	0	288086009	4125906	
50106	4372	4107731	1994-07-07	1994-07-07 00:00:00	38000275	0	\N	\N	290228	0	180256009	4107731	
50136	4373	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	290346	0	180256009	4107731	
50610	4403	4151422	1950-08-12	1950-08-12 00:00:00	38000275	0	\N	\N	292719	0	269911007	4151422	
38873	3432	4125906	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	227489	0	288086009	4125906	
39496	3477	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	230636	0	180256009	4107731	
51778	4482	4170947	1966-12-23	1966-12-23 00:00:00	38000275	0	\N	\N	298356	0	274474001	4170947	
51851	4500	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	299566	0	180256009	4107731	
52074	4514	4125906	1977-02-11	1977-02-11 00:00:00	38000275	0	\N	\N	300589	0	288086009	4125906	
40545	3561	4078793	2012-10-01	2012-10-01 00:00:00	38000275	0	\N	\N	236553	0	180325003	4078793	
52628	4576	4202451	1984-08-08	1984-08-08 00:00:00	38000275	0	\N	\N	304803	0	433112001	4202451	
40963	3589	4107731	1996-04-23	1996-04-23 00:00:00	38000275	0	\N	\N	238422	0	180256009	4107731	
41297	3623	4198190	2009-06-05	2009-06-05 00:00:00	38000275	0	\N	\N	240878	0	80146002	4198190	
53369	4633	44783196	1974-01-12	1974-01-12 00:00:00	38000275	0	\N	\N	308767	0	699253003	44783196	
53799	4670	4151422	1967-02-23	1967-02-23 00:00:00	38000275	0	\N	\N	311227	0	269911007	4151422	
53877	4680	4125906	1967-07-31	1967-07-31 00:00:00	38000275	0	\N	\N	311946	0	288086009	4125906	
54087	4700	4043071	1966-12-13	1966-12-13 00:00:00	38000275	0	\N	\N	313065	0	228557008	4043071	
42559	3754	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	249489	0	180256009	4107731	
54650	4745	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	315938	0	180256009	4107731	
54893	4761	4107731	1994-02-07	1994-02-07 00:00:00	38000275	0	\N	\N	317310	0	180256009	4107731	
55153	4804	4107731	1990-04-16	1990-04-16 00:00:00	38000275	0	\N	\N	319551	0	180256009	4107731	
43231	3820	4125906	2002-12-25	2002-12-25 00:00:00	38000275	0	\N	\N	253654	0	288086009	4125906	
43519	3852	4107731	1992-08-24	1992-08-24 00:00:00	38000275	0	\N	\N	255731	0	180256009	4107731	
55658	4847	4035793	1999-07-07	1999-07-07 00:00:00	38000275	0	\N	\N	322448	0	15081005	4035793	
56019	4890	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	325090	0	180256009	4107731	
32329	2834	4293740	1985-01-12	1985-01-12 00:00:00	38000275	0	\N	\N	188164	0	384700001	4293740	
45125	3968	4125906	1952-02-29	1952-02-29 00:00:00	38000275	0	\N	\N	263904	0	288086009	4125906	
57281	4970	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	330363	0	180256009	4107731	
57617	4991	4163872	1976-04-16	1976-04-16 00:00:00	38000275	0	\N	\N	332071	0	399208008	4163872	
58027	5035	40492359	2003-03-03	2003-03-03 00:00:00	38000275	0	\N	\N	334577	0	447365002	40492359	
46275	4064	4107731	1991-02-25	1991-02-25 00:00:00	38000275	0	\N	\N	269977	0	180256009	4107731	
46553	4085	4043071	1968-04-21	1968-04-21 00:00:00	38000275	0	\N	\N	271489	0	228557008	4043071	
58712	5097	4107731	1994-11-06	1994-11-06 00:00:00	38000275	0	\N	\N	338711	0	180256009	4107731	
58789	5104	4170947	1987-04-08	1987-04-08 00:00:00	38000275	0	\N	\N	339183	0	274474001	4170947	
59160	5118	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	340207	0	180256009	4107731	
59567	5157	4198190	1985-04-06	1985-04-06 00:00:00	38000275	0	\N	\N	342949	0	80146002	4198190	
59757	5169	4125906	1954-06-26	1954-06-26 00:00:00	38000275	0	\N	\N	343731	0	288086009	4125906	
35970	3158	4058899	1977-04-01	1977-04-01 00:00:00	38000275	0	\N	\N	209949	0	168594001	4058899	
48136	4224	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	280534	0	180256009	4107731	
36406	3189	44783196	1985-09-27	1985-09-27 00:00:00	38000275	0	\N	\N	212225	0	699253003	44783196	
48598	4270	4043071	1977-12-09	1977-12-09 00:00:00	38000275	0	\N	\N	283398	0	228557008	4043071	
48693	4279	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	284071	0	180256009	4107731	
48969	4304	4181917	1977-09-08	1977-09-08 00:00:00	38000275	0	\N	\N	285471	0	54550000	4181917	
49121	4312	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	286164	0	180256009	4107731	
49203	4313	4107731	1992-01-11	1992-01-11 00:00:00	38000275	0	\N	\N	286286	0	180256009	4107731	
49408	4343	4125906	1963-04-11	1963-04-11 00:00:00	38000275	0	\N	\N	288077	0	288086009	4125906	
61707	5335	4043071	1967-07-28	1967-07-28 00:00:00	38000275	0	\N	\N	355295	0	228557008	4043071	
49757	4365	4078793	2005-12-18	2005-12-18 00:00:00	38000275	0	\N	\N	289579	0	180325003	4078793	
50107	4372	4107731	1996-05-09	1996-05-09 00:00:00	38000275	0	\N	\N	290306	0	180256009	4107731	
50137	4373	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	290405	0	180256009	4107731	
50611	4403	4170947	1946-11-29	1946-11-29 00:00:00	38000275	0	\N	\N	292705	0	274474001	4170947	
50678	4412	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	293282	0	180256009	4107731	
39497	3477	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	230704	0	180256009	4107731	
51779	4482	4151422	1994-04-12	1994-04-12 00:00:00	38000275	0	\N	\N	298394	0	269911007	4151422	
51852	4500	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	299536	0	180256009	4107731	
52075	4514	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	300683	0	180256009	4107731	
40546	3561	4057420	2006-01-02	2006-01-02 00:00:00	38000275	0	\N	\N	236447	0	18286008	4057420	
52629	4576	4151422	1988-05-03	1988-05-03 00:00:00	38000275	0	\N	\N	304787	0	269911007	4151422	
40964	3589	4107731	1996-12-09	1996-12-09 00:00:00	38000275	0	\N	\N	238496	0	180256009	4107731	
41298	3624	4163872	1983-08-02	1983-08-02 00:00:00	38000275	0	\N	\N	240945	0	399208008	4163872	
53370	4633	4078793	2009-12-01	2009-12-01 00:00:00	38000275	0	\N	\N	308816	0	180325003	4078793	
53800	4670	4125906	1994-04-26	1994-04-26 00:00:00	38000275	0	\N	\N	311158	0	288086009	4125906	
53878	4680	4047491	1987-05-15	1987-05-15 00:00:00	38000275	0	\N	\N	311950	0	1225002	4047491	
54088	4700	4043071	1966-05-24	1966-05-24 00:00:00	38000275	0	\N	\N	313064	0	228557008	4043071	
42560	3754	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	249520	0	180256009	4107731	
54651	4745	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	315985	0	180256009	4107731	
54894	4761	4107731	1994-12-19	1994-12-19 00:00:00	38000275	0	\N	\N	317283	0	180256009	4107731	
55154	4804	4107731	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	319618	0	180256009	4107731	
43232	3820	4151422	1979-09-05	1979-09-05 00:00:00	38000275	0	\N	\N	253614	0	269911007	4151422	
43520	3852	4107731	1991-08-12	1991-08-12 00:00:00	38000275	0	\N	\N	255764	0	180256009	4107731	
55659	4847	4035793	1996-06-19	1996-06-19 00:00:00	38000275	0	\N	\N	322418	0	15081005	4035793	
56020	4890	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	325116	0	180256009	4107731	
32330	2834	4163872	1990-06-26	1990-06-26 00:00:00	38000275	0	\N	\N	188188	0	399208008	4163872	
45126	3968	4151422	1944-02-04	1944-02-04 00:00:00	38000275	0	\N	\N	263897	0	269911007	4151422	
57282	4970	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	330418	0	180256009	4107731	
57618	4992	4043071	1996-02-04	1996-02-04 00:00:00	38000275	0	\N	\N	332110	0	228557008	4043071	
58028	5035	4057420	2003-03-03	2003-03-03 00:00:00	38000275	0	\N	\N	334577	0	18286008	4057420	
46276	4064	4107731	1992-01-27	1992-01-27 00:00:00	38000275	0	\N	\N	270006	0	180256009	4107731	
46554	4085	4043071	1968-07-21	1968-07-21 00:00:00	38000275	0	\N	\N	271518	0	228557008	4043071	
58713	5097	4107731	1993-12-05	1993-12-05 00:00:00	38000275	0	\N	\N	338722	0	180256009	4107731	
58790	5104	4047491	1987-04-08	1987-04-08 00:00:00	38000275	0	\N	\N	339183	0	1225002	4047491	
59161	5119	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	340357	0	180256009	4107731	
59568	5157	4202451	2015-05-14	2015-05-14 00:00:00	38000275	0	\N	\N	342944	0	433112001	4202451	
59758	5170	4151422	2015-12-23	2015-12-23 00:00:00	38000275	0	\N	\N	343796	0	269911007	4151422	
35971	3158	4043071	1965-04-15	1965-04-15 00:00:00	38000275	0	\N	\N	209999	0	228557008	4043071	
48137	4224	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	280491	0	180256009	4107731	
36407	3189	4047491	2015-10-11	2015-10-11 00:00:00	38000275	0	\N	\N	212275	0	1225002	4047491	
48599	4270	4043071	1977-03-25	1977-03-25 00:00:00	38000275	0	\N	\N	283388	0	228557008	4043071	
48694	4279	4058899	1966-11-14	1966-11-14 00:00:00	38000275	0	\N	\N	284091	0	168594001	4058899	
48970	4305	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	285596	0	180256009	4107731	
49122	4312	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	286170	0	180256009	4107731	
49204	4313	4107731	1990-06-23	1990-06-23 00:00:00	38000275	0	\N	\N	286295	0	180256009	4107731	
49409	4343	4170947	1967-03-05	1967-03-05 00:00:00	38000275	0	\N	\N	288078	0	274474001	4170947	
61708	5335	4043071	1966-10-14	1966-10-14 00:00:00	38000275	0	\N	\N	355257	0	228557008	4043071	
49758	4365	4078793	2012-01-22	2012-01-22 00:00:00	38000275	0	\N	\N	289561	0	180325003	4078793	
50108	4372	4107731	1996-01-04	1996-01-04 00:00:00	38000275	0	\N	\N	290273	0	180256009	4107731	
50138	4373	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	290424	0	180256009	4107731	
50612	4403	4024289	1946-11-29	1946-11-29 00:00:00	38000275	0	\N	\N	292705	0	19490002	4024289	
50679	4412	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	293411	0	180256009	4107731	
39498	3477	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	230660	0	180256009	4107731	
51780	4484	4057420	2019-06-20	2019-06-20 00:00:00	38000275	0	\N	\N	298493	0	18286008	4057420	
51853	4500	4293740	1984-03-16	1984-03-16 00:00:00	38000275	0	\N	\N	299603	0	384700001	4293740	
52076	4514	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	300680	0	180256009	4107731	
40547	3561	4078793	2013-10-07	2013-10-07 00:00:00	38000275	0	\N	\N	236480	0	180325003	4078793	
52630	4576	4151422	1968-05-13	1968-05-13 00:00:00	38000275	0	\N	\N	304770	0	269911007	4151422	
40965	3589	4107731	1996-10-08	1996-10-08 00:00:00	38000275	0	\N	\N	238471	0	180256009	4107731	
41299	3624	4010253	1953-12-03	1953-12-03 00:00:00	38000275	0	\N	\N	240965	0	112790001	4010253	
53371	4633	4057420	2014-12-30	2014-12-30 00:00:00	38000275	0	\N	\N	308790	0	18286008	4057420	
53801	4670	4293740	1994-04-26	1994-04-26 00:00:00	38000275	0	\N	\N	311158	0	384700001	4293740	
53879	4680	4195803	1987-05-15	1987-05-15 00:00:00	38000275	0	\N	\N	311950	0	312681000	4195803	
54089	4700	4043071	1965-08-10	1965-08-10 00:00:00	38000275	0	\N	\N	313037	0	228557008	4043071	
42561	3754	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	249518	0	180256009	4107731	
54652	4745	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	315968	0	180256009	4107731	
54895	4761	4107731	1996-09-30	1996-09-30 00:00:00	38000275	0	\N	\N	317250	0	180256009	4107731	
55155	4804	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	319562	0	180256009	4107731	
43324	3822	4170947	1988-07-09	1988-07-09 00:00:00	38000275	0	\N	\N	253836	0	274474001	4170947	
43521	3852	4107731	1992-03-09	1992-03-09 00:00:00	38000275	0	\N	\N	255677	0	180256009	4107731	
55660	4847	4035793	2010-03-10	2010-03-10 00:00:00	38000275	0	\N	\N	322479	0	15081005	4035793	
56021	4890	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	325153	0	180256009	4107731	
32331	2834	4336464	1999-12-04	1999-12-04 00:00:00	38000275	0	\N	\N	188165	0	232717009	4336464	
45127	3968	4170947	1954-01-03	1954-01-03 00:00:00	38000275	0	\N	\N	263905	0	274474001	4170947	
57283	4970	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	330476	0	180256009	4107731	
57619	4992	4043071	1996-07-14	1996-07-14 00:00:00	38000275	0	\N	\N	332112	0	228557008	4043071	
58029	5035	4078793	2011-08-15	2011-08-15 00:00:00	38000275	0	\N	\N	334646	0	180325003	4078793	
46277	4064	4107731	1991-08-12	1991-08-12 00:00:00	38000275	0	\N	\N	270080	0	180256009	4107731	
46555	4085	4043071	1968-08-18	1968-08-18 00:00:00	38000275	0	\N	\N	271490	0	228557008	4043071	
58714	5097	4107731	1995-06-25	1995-06-25 00:00:00	38000275	0	\N	\N	338693	0	180256009	4107731	
58791	5104	4043071	1994-05-06	1994-05-06 00:00:00	38000275	0	\N	\N	339162	0	228557008	4043071	
59162	5119	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	340317	0	180256009	4107731	
59619	5165	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	343341	0	180256009	4107731	
59759	5170	44783196	1981-02-11	1981-02-11 00:00:00	38000275	0	\N	\N	343739	0	699253003	44783196	
35972	3158	4043071	1967-03-30	1967-03-30 00:00:00	38000275	0	\N	\N	209964	0	228557008	4043071	
48138	4224	4125906	1956-01-24	1956-01-24 00:00:00	38000275	0	\N	\N	280590	0	288086009	4125906	
36408	3189	4170947	2015-10-11	2015-10-11 00:00:00	38000275	0	\N	\N	212275	0	274474001	4170947	
48600	4270	4043071	1977-10-07	1977-10-07 00:00:00	38000275	0	\N	\N	283389	0	228557008	4043071	
48695	4279	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	284066	0	180256009	4107731	
48971	4305	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	285601	0	180256009	4107731	
49123	4312	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	286083	0	180256009	4107731	
49205	4313	4107731	1991-05-25	1991-05-25 00:00:00	38000275	0	\N	\N	286354	0	180256009	4107731	
49410	4343	4047491	1967-03-05	1967-03-05 00:00:00	38000275	0	\N	\N	288078	0	1225002	4047491	
61709	5335	4043071	1967-06-30	1967-06-30 00:00:00	38000275	0	\N	\N	355243	0	228557008	4043071	
49759	4365	4078793	2013-01-27	2013-01-27 00:00:00	38000275	0	\N	\N	289583	0	180325003	4078793	
50109	4373	4191853	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	290425	0	395142003	4191853	
50139	4373	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	290416	0	180256009	4107731	
50613	4403	4163872	1969-02-21	1969-02-21 00:00:00	38000275	0	\N	\N	292660	0	399208008	4163872	
50680	4412	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	293363	0	180256009	4107731	
39499	3477	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	230635	0	180256009	4107731	
51781	4484	4057420	2017-06-08	2017-06-08 00:00:00	38000275	0	\N	\N	298520	0	18286008	4057420	
51854	4500	4125906	1984-03-16	1984-03-16 00:00:00	38000275	0	\N	\N	299603	0	288086009	4125906	
52077	4514	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	300677	0	180256009	4107731	
40548	3561	4078793	1977-07-25	1977-07-25 00:00:00	38000275	0	\N	\N	236464	0	180325003	4078793	
52631	4576	4125906	1981-11-02	1981-11-02 00:00:00	38000275	0	\N	\N	304851	0	288086009	4125906	
40966	3589	4107731	1995-10-17	1995-10-17 00:00:00	38000275	0	\N	\N	238421	0	180256009	4107731	
41300	3624	4163872	1957-03-10	1957-03-10 00:00:00	38000275	0	\N	\N	240991	0	399208008	4163872	
53372	4633	4078793	2016-01-05	2016-01-05 00:00:00	38000275	0	\N	\N	308747	0	180325003	4078793	
53808	4674	4125906	1984-03-11	1984-03-11 00:00:00	38000275	0	\N	\N	311387	0	288086009	4125906	
53880	4680	4170947	1987-05-15	1987-05-15 00:00:00	38000275	0	\N	\N	311950	0	274474001	4170947	
54090	4700	4043071	1966-01-11	1966-01-11 00:00:00	38000275	0	\N	\N	313039	0	228557008	4043071	
42562	3754	4107731	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	249471	0	180256009	4107731	
54653	4745	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	315925	0	180256009	4107731	
54896	4761	4107731	1996-01-22	1996-01-22 00:00:00	38000275	0	\N	\N	317265	0	180256009	4107731	
55156	4804	4197460	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	319591	0	313191000	4197460	
43325	3822	4024289	1988-07-09	1988-07-09 00:00:00	38000275	0	\N	\N	253836	0	19490002	4024289	
43522	3852	4107731	1992-10-05	1992-10-05 00:00:00	38000275	0	\N	\N	255732	0	180256009	4107731	
55661	4847	4323902	2001-09-26	2001-09-26 00:00:00	38000275	0	\N	\N	322422	0	429609002	4323902	
56022	4890	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	325187	0	180256009	4107731	
32332	2834	4216130	1999-12-04	1999-12-04 00:00:00	38000275	0	\N	\N	188165	0	415070008	4216130	
45128	3968	4243062	1954-01-03	1954-01-03 00:00:00	38000275	0	\N	\N	263905	0	60027007	4243062	
57284	4970	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	330433	0	180256009	4107731	
57620	4992	4043071	1998-05-31	1998-05-31 00:00:00	38000275	0	\N	\N	332154	0	228557008	4043071	
58030	5035	4170947	1997-08-14	1997-08-14 00:00:00	38000275	0	\N	\N	334576	0	274474001	4170947	
46278	4064	4107731	1991-12-16	1991-12-16 00:00:00	38000275	0	\N	\N	270083	0	180256009	4107731	
46556	4085	4043071	1968-05-19	1968-05-19 00:00:00	38000275	0	\N	\N	271468	0	228557008	4043071	
58715	5097	4107731	1994-08-14	1994-08-14 00:00:00	38000275	0	\N	\N	338709	0	180256009	4107731	
58792	5104	4043071	1992-01-02	1992-01-02 00:00:00	38000275	0	\N	\N	339210	0	228557008	4043071	
59163	5119	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	340412	0	180256009	4107731	
59620	5165	4163872	1970-09-09	1970-09-09 00:00:00	38000275	0	\N	\N	343255	0	399208008	4163872	
59760	5170	4293740	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	343737	0	384700001	4293740	
35973	3158	4043071	1966-08-25	1966-08-25 00:00:00	38000275	0	\N	\N	209940	0	228557008	4043071	
48139	4224	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	280519	0	180256009	4107731	
36409	3189	4043071	1974-02-21	1974-02-21 00:00:00	38000275	0	\N	\N	212241	0	228557008	4043071	
48601	4270	4043071	1977-07-01	1977-07-01 00:00:00	38000275	0	\N	\N	283396	0	228557008	4043071	
48696	4279	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	284045	0	180256009	4107731	
48972	4305	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	285557	0	180256009	4107731	
49124	4312	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	286159	0	180256009	4107731	
49206	4313	4107731	1991-11-30	1991-11-30 00:00:00	38000275	0	\N	\N	286285	0	180256009	4107731	
49411	4343	4252419	1958-07-29	1958-07-29 00:00:00	38000275	0	\N	\N	288076	0	74016001	4252419	
61710	5335	4043071	1967-05-26	1967-05-26 00:00:00	38000275	0	\N	\N	355242	0	228557008	4043071	
49760	4365	4078793	2006-12-24	2006-12-24 00:00:00	38000275	0	\N	\N	289558	0	180325003	4078793	
50110	4373	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	290391	0	180256009	4107731	
50140	4373	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	290421	0	180256009	4107731	
50614	4403	4145310	1992-10-04	1992-10-04 00:00:00	38000275	0	\N	\N	292712	0	268425006	4145310	
50681	4412	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	293384	0	395142003	4191853	
39500	3477	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	230720	0	180256009	4107731	
51782	4484	4078793	2018-06-14	2018-06-14 00:00:00	38000275	0	\N	\N	298530	0	180325003	4078793	
51855	4500	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	299567	0	180256009	4107731	
52078	4514	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	300605	0	180256009	4107731	
40549	3561	4057420	2014-10-13	2014-10-13 00:00:00	38000275	0	\N	\N	236544	0	18286008	4057420	
52632	4576	4151422	1983-06-02	1983-06-02 00:00:00	38000275	0	\N	\N	304771	0	269911007	4151422	
40967	3589	4107731	1996-09-17	1996-09-17 00:00:00	38000275	0	\N	\N	238494	0	180256009	4107731	
41301	3624	4125906	2008-05-26	2008-05-26 00:00:00	38000275	0	\N	\N	241012	0	288086009	4125906	
53373	4633	4078793	2012-12-18	2012-12-18 00:00:00	38000275	0	\N	\N	308789	0	180325003	4078793	
53809	4674	4151422	2006-04-17	2006-04-17 00:00:00	38000275	0	\N	\N	311366	0	269911007	4151422	
53881	4680	4170947	1995-01-24	1995-01-24 00:00:00	38000275	0	\N	\N	311952	0	274474001	4170947	
54091	4700	4043071	1967-01-17	1967-01-17 00:00:00	38000275	0	\N	\N	313066	0	228557008	4043071	
42563	3754	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	249525	0	180256009	4107731	
54654	4745	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	316009	0	180256009	4107731	
54897	4761	4107731	1994-09-05	1994-09-05 00:00:00	38000275	0	\N	\N	317219	0	180256009	4107731	
55157	4804	4107731	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	319571	0	180256009	4107731	
43326	3822	4078793	2019-05-20	2019-05-20 00:00:00	38000275	0	\N	\N	253832	0	180325003	4078793	
43523	3852	4107731	1992-02-17	1992-02-17 00:00:00	38000275	0	\N	\N	255765	0	180256009	4107731	
55662	4847	44783196	1950-12-13	1950-12-13 00:00:00	38000275	0	\N	\N	322476	0	699253003	44783196	
56023	4890	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	325150	0	180256009	4107731	
32333	2835	4202451	1988-07-05	1988-07-05 00:00:00	38000275	0	\N	\N	188306	0	433112001	4202451	
45129	3968	4170947	2018-05-25	2018-05-25 00:00:00	38000275	0	\N	\N	263865	0	274474001	4170947	
57285	4970	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	330375	0	180256009	4107731	
57621	4992	4043071	1996-12-15	1996-12-15 00:00:00	38000275	0	\N	\N	332114	0	228557008	4043071	
58031	5035	4047491	1997-08-14	1997-08-14 00:00:00	38000275	0	\N	\N	334576	0	1225002	4047491	
46286	4067	4163872	1983-01-14	1983-01-14 00:00:00	38000275	0	\N	\N	270197	0	399208008	4163872	
46557	4085	4043071	1967-12-10	1967-12-10 00:00:00	38000275	0	\N	\N	271466	0	228557008	4043071	
58716	5097	4107731	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	338659	0	180256009	4107731	
58793	5104	4043071	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	339159	0	228557008	4043071	
59164	5119	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	340375	0	180256009	4107731	
59621	5165	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	343251	0	180256009	4107731	
59761	5170	4125906	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	343737	0	288086009	4125906	
35974	3158	4043071	1966-04-21	1966-04-21 00:00:00	38000275	0	\N	\N	209984	0	228557008	4043071	
48140	4224	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	280447	0	180256009	4107731	
36410	3189	4043071	1973-10-18	1973-10-18 00:00:00	38000275	0	\N	\N	212220	0	228557008	4043071	
48602	4270	4043071	1977-05-27	1977-05-27 00:00:00	38000275	0	\N	\N	283395	0	228557008	4043071	
48697	4279	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	284049	0	180256009	4107731	
48973	4305	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	285610	0	180256009	4107731	
49125	4312	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	286161	0	180256009	4107731	
49207	4313	4107731	1992-04-04	1992-04-04 00:00:00	38000275	0	\N	\N	286358	0	180256009	4107731	
49412	4343	4293740	1978-10-03	1978-10-03 00:00:00	38000275	0	\N	\N	288079	0	384700001	4293740	
49761	4366	4293740	2000-09-27	2000-09-27 00:00:00	38000275	0	\N	\N	289597	0	384700001	4293740	
50111	4373	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	290351	0	180256009	4107731	
50141	4373	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	290380	0	395142003	4191853	
50615	4403	4195803	1992-10-04	1992-10-04 00:00:00	38000275	0	\N	\N	292712	0	312681000	4195803	
50682	4412	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	293377	0	180256009	4107731	
39501	3477	4191853	1986-04-20	1986-04-20 00:00:00	38000275	0	\N	\N	230612	0	395142003	4191853	
51783	4485	4151422	1963-02-08	1963-02-08 00:00:00	38000275	0	\N	\N	298541	0	269911007	4151422	
51856	4500	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	299625	0	180256009	4107731	
52079	4514	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	300634	0	180256009	4107731	
40550	3561	4078793	1985-09-09	1985-09-09 00:00:00	38000275	0	\N	\N	236548	0	180325003	4078793	
52633	4577	4252419	2002-03-31	2002-03-31 00:00:00	38000275	0	\N	\N	304857	0	74016001	4252419	
40968	3589	4107731	1995-02-27	1995-02-27 00:00:00	38000275	0	\N	\N	238433	0	180256009	4107731	
41302	3625	4037675	1997-07-03	1997-07-03 00:00:00	38000275	0	\N	\N	241122	0	162676008	4037675	
53374	4633	4078793	2010-12-07	2010-12-07 00:00:00	38000275	0	\N	\N	308798	0	180325003	4078793	
53810	4674	4125906	1973-07-23	1973-07-23 00:00:00	38000275	0	\N	\N	311385	0	288086009	4125906	
53882	4680	4024289	1995-01-24	1995-01-24 00:00:00	38000275	0	\N	\N	311952	0	19490002	4024289	
54092	4700	4043071	1966-02-15	1966-02-15 00:00:00	38000275	0	\N	\N	313040	0	228557008	4043071	
42564	3754	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	249494	0	180256009	4107731	
54655	4745	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	315984	0	180256009	4107731	
54898	4761	4107731	1994-04-11	1994-04-11 00:00:00	38000275	0	\N	\N	317312	0	180256009	4107731	
55158	4804	4062501	1997-03-23	1997-03-23 00:00:00	38000275	0	\N	\N	319587	0	171231001	4062501	
43327	3822	4078793	2016-05-02	2016-05-02 00:00:00	38000275	0	\N	\N	253906	0	180325003	4078793	
43524	3852	4107731	1992-03-30	1992-03-30 00:00:00	38000275	0	\N	\N	255766	0	180256009	4107731	
55663	4847	4035793	2014-04-02	2014-04-02 00:00:00	38000275	0	\N	\N	322460	0	15081005	4035793	
56024	4890	4252419	1972-02-10	1972-02-10 00:00:00	38000275	0	\N	\N	325145	0	74016001	4252419	
32334	2835	4058899	2012-01-31	2012-01-31 00:00:00	38000275	0	\N	\N	188346	0	168594001	4058899	
45130	3968	4243062	2018-05-25	2018-05-25 00:00:00	38000275	0	\N	\N	263865	0	60027007	4243062	
57286	4970	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	330369	0	180256009	4107731	
57622	4992	4043071	1996-06-16	1996-06-16 00:00:00	38000275	0	\N	\N	332126	0	228557008	4043071	
58032	5035	4195803	1997-08-14	1997-08-14 00:00:00	38000275	0	\N	\N	334576	0	312681000	4195803	
46287	4067	4170947	1983-01-14	1983-01-14 00:00:00	38000275	0	\N	\N	270197	0	274474001	4170947	
46558	4085	4043071	1967-06-04	1967-06-04 00:00:00	38000275	0	\N	\N	271536	0	228557008	4043071	
58717	5097	4107731	1994-02-27	1994-02-27 00:00:00	38000275	0	\N	\N	338701	0	180256009	4107731	
58794	5104	4043071	1993-03-18	1993-03-18 00:00:00	38000275	0	\N	\N	339169	0	228557008	4043071	
59165	5119	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	340294	0	180256009	4107731	
59622	5165	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	343292	0	180256009	4107731	
59762	5170	4170947	1983-04-02	1983-04-02 00:00:00	38000275	0	\N	\N	343736	0	274474001	4170947	
35975	3158	4043071	1965-12-23	1965-12-23 00:00:00	38000275	0	\N	\N	209983	0	228557008	4043071	
48141	4224	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	280449	0	180256009	4107731	
36411	3189	4043071	1974-01-17	1974-01-17 00:00:00	38000275	0	\N	\N	212250	0	228557008	4043071	
48603	4270	4043071	1978-03-10	1978-03-10 00:00:00	38000275	0	\N	\N	283391	0	228557008	4043071	
48698	4279	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	284003	0	180256009	4107731	
48974	4305	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	285607	0	180256009	4107731	
49126	4312	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	286053	0	180256009	4107731	
49208	4313	4107731	1991-03-23	1991-03-23 00:00:00	38000275	0	\N	\N	286322	0	180256009	4107731	
49413	4343	4125906	1978-10-03	1978-10-03 00:00:00	38000275	0	\N	\N	288079	0	288086009	4125906	
49762	4366	4125906	2000-09-27	2000-09-27 00:00:00	38000275	0	\N	\N	289597	0	288086009	4125906	
50112	4373	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	290438	0	180256009	4107731	
50142	4373	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	290363	0	180256009	4107731	
50616	4403	4337138	1999-08-28	1999-08-28 00:00:00	38000275	0	\N	\N	292656	0	88039007	4337138	
50683	4412	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	293333	0	180256009	4107731	
39502	3477	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	230639	0	180256009	4107731	
51784	4485	4125906	2003-05-07	2003-05-07 00:00:00	38000275	0	\N	\N	298619	0	288086009	4125906	
51857	4500	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	299531	0	180256009	4107731	
52080	4514	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	300613	0	180256009	4107731	
40551	3561	4078793	1977-05-09	1977-05-09 00:00:00	38000275	0	\N	\N	236442	0	180325003	4078793	
52634	4577	44783196	2002-04-07	2002-04-07 00:00:00	38000275	0	\N	\N	304868	0	699253003	44783196	
40969	3589	4107731	1995-07-25	1995-07-25 00:00:00	38000275	0	\N	\N	238419	0	180256009	4107731	
41303	3625	4187458	1997-07-03	1997-07-03 00:00:00	38000275	0	\N	\N	241122	0	415300000	4187458	
53375	4633	4078793	2017-01-10	2017-01-10 00:00:00	38000275	0	\N	\N	308791	0	180325003	4078793	
53811	4674	4301346	2017-06-28	2017-06-28 00:00:00	38000275	0	\N	\N	311416	0	387685009	4301346	
53883	4680	4195803	1995-01-24	1995-01-24 00:00:00	38000275	0	\N	\N	311952	0	312681000	4195803	
54093	4701	4238715	1990-11-09	1990-11-09 00:00:00	38000275	0	\N	\N	313140	0	68254000	4238715	
42565	3754	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	249535	0	180256009	4107731	
54656	4745	4163872	1981-11-27	1981-11-27 00:00:00	38000275	0	\N	\N	315940	0	399208008	4163872	
54899	4761	4107731	1996-08-19	1996-08-19 00:00:00	38000275	0	\N	\N	317233	0	180256009	4107731	
55159	4804	4107731	1992-09-14	1992-09-14 00:00:00	38000275	0	\N	\N	319595	0	180256009	4107731	
43328	3822	4057420	2018-05-14	2018-05-14 00:00:00	38000275	0	\N	\N	253897	0	18286008	4057420	
43525	3852	4057420	2008-03-31	2008-03-31 00:00:00	38000275	0	\N	\N	255634	0	18286008	4057420	
55664	4847	4035793	1997-06-25	1997-06-25 00:00:00	38000275	0	\N	\N	322457	0	15081005	4035793	
56025	4890	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	325125	0	180256009	4107731	
32335	2835	4195803	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	188308	0	312681000	4195803	
45131	3968	4078793	2015-07-17	2015-07-17 00:00:00	38000275	0	\N	\N	263874	0	180325003	4078793	
57287	4970	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	330406	0	180256009	4107731	
57623	4992	4198190	2007-05-12	2007-05-12 00:00:00	38000275	0	\N	\N	332122	0	80146002	4198190	
58033	5035	4170947	1948-04-19	1948-04-19 00:00:00	38000275	0	\N	\N	334618	0	274474001	4170947	
46288	4067	4181917	1971-03-27	1971-03-27 00:00:00	38000275	0	\N	\N	270199	0	54550000	4181917	
46559	4085	4151422	2006-08-25	2006-08-25 00:00:00	38000275	0	\N	\N	271454	0	269911007	4151422	
58718	5097	4107731	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	338639	0	180256009	4107731	
58795	5104	4043071	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	339157	0	228557008	4043071	
59166	5119	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	340321	0	180256009	4107731	
59623	5165	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	343260	0	180256009	4107731	
59763	5170	4024289	1983-04-02	1983-04-02 00:00:00	38000275	0	\N	\N	343736	0	19490002	4024289	
35976	3158	4043071	1963-12-19	1963-12-19 00:00:00	38000275	0	\N	\N	210012	0	228557008	4043071	
48142	4224	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	280538	0	180256009	4107731	
36412	3189	4043071	1974-10-31	1974-10-31 00:00:00	38000275	0	\N	\N	212222	0	228557008	4043071	
48604	4270	4043071	1978-01-06	1978-01-06 00:00:00	38000275	0	\N	\N	283423	0	228557008	4043071	
48699	4279	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	284051	0	180256009	4107731	
48975	4305	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	285639	0	180256009	4107731	
49127	4312	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	286094	0	180256009	4107731	
49209	4313	4107731	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	286329	0	180256009	4107731	
49414	4343	4125906	2009-10-23	2009-10-23 00:00:00	38000275	0	\N	\N	288082	0	288086009	4125906	
49763	4366	4107731	1995-12-19	1995-12-19 00:00:00	38000275	0	\N	\N	289644	0	180256009	4107731	
50113	4373	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	290364	0	180256009	4107731	
50143	4373	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	290393	0	180256009	4107731	
50618	4405	4151422	1996-04-28	1996-04-28 00:00:00	38000275	0	\N	\N	292786	0	269911007	4151422	
50684	4412	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	293376	0	180256009	4107731	
39503	3477	4043071	1972-04-22	1972-04-22 00:00:00	38000275	0	\N	\N	230711	0	228557008	4043071	
51785	4485	4151422	2002-08-22	2002-08-22 00:00:00	38000275	0	\N	\N	298599	0	269911007	4151422	
51858	4500	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	299537	0	180256009	4107731	
52081	4514	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	300637	0	180256009	4107731	
40552	3561	4078793	2011-09-26	2011-09-26 00:00:00	38000275	0	\N	\N	236569	0	180325003	4078793	
52635	4578	4170947	1979-02-03	1979-02-03 00:00:00	38000275	0	\N	\N	304988	0	274474001	4170947	
40970	3589	4107731	1994-10-04	1994-10-04 00:00:00	38000275	0	\N	\N	238453	0	180256009	4107731	
41304	3625	4326177	1997-07-03	1997-07-03 00:00:00	38000275	0	\N	\N	241122	0	430193006	4326177	
53376	4633	4078793	2019-01-22	2019-01-22 00:00:00	38000275	0	\N	\N	308817	0	180325003	4078793	
53812	4674	4293740	1987-02-08	1987-02-08 00:00:00	38000275	0	\N	\N	311388	0	384700001	4293740	
53884	4680	4181917	1946-06-17	1946-06-17 00:00:00	38000275	0	\N	\N	311943	0	54550000	4181917	
54094	4701	4151422	1991-02-01	1991-02-01 00:00:00	38000275	0	\N	\N	313138	0	269911007	4151422	
42566	3754	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	249426	0	180256009	4107731	
54657	4745	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	315958	0	180256009	4107731	
54900	4761	4107731	1994-06-13	1994-06-13 00:00:00	38000275	0	\N	\N	317273	0	180256009	4107731	
55160	4804	4107731	1992-08-03	1992-08-03 00:00:00	38000275	0	\N	\N	319614	0	180256009	4107731	
43329	3822	4078793	2015-04-27	2015-04-27 00:00:00	38000275	0	\N	\N	253846	0	180325003	4078793	
43526	3852	40492359	2008-03-31	2008-03-31 00:00:00	38000275	0	\N	\N	255634	0	447365002	40492359	
55665	4847	4035793	2003-02-05	2003-02-05 00:00:00	38000275	0	\N	\N	322477	0	15081005	4035793	
56026	4890	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	325119	0	180256009	4107731	
32336	2835	44783196	1989-10-28	1989-10-28 00:00:00	38000275	0	\N	\N	188337	0	699253003	44783196	
45132	3968	4195803	1994-01-21	1994-01-21 00:00:00	38000275	0	\N	\N	263869	0	312681000	4195803	
57288	4970	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	330384	0	180256009	4107731	
57624	4992	4043071	1998-03-22	1998-03-22 00:00:00	38000275	0	\N	\N	332082	0	228557008	4043071	
58034	5035	4163872	1948-04-19	1948-04-19 00:00:00	38000275	0	\N	\N	334618	0	399208008	4163872	
46289	4067	4293740	1977-06-23	1977-06-23 00:00:00	38000275	0	\N	\N	270200	0	384700001	4293740	
46560	4085	4043071	1967-03-05	1967-03-05 00:00:00	38000275	0	\N	\N	271513	0	228557008	4043071	
58796	5104	4043071	1994-03-31	1994-03-31 00:00:00	38000275	0	\N	\N	339161	0	228557008	4043071	
59167	5119	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	340376	0	180256009	4107731	
59624	5165	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	343290	0	180256009	4107731	
59764	5170	4252419	1981-02-04	1981-02-04 00:00:00	38000275	0	\N	\N	343735	0	74016001	4252419	
35977	3158	4043071	1966-02-24	1966-02-24 00:00:00	38000275	0	\N	\N	209930	0	228557008	4043071	
48143	4224	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	280577	0	180256009	4107731	
36413	3189	4043071	1974-03-28	1974-03-28 00:00:00	38000275	0	\N	\N	212242	0	228557008	4043071	
48616	4274	4195803	1995-08-25	1995-08-25 00:00:00	38000275	0	\N	\N	283560	0	312681000	4195803	
48700	4279	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	283986	0	180256009	4107731	
48976	4305	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	285580	0	180256009	4107731	
49128	4312	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	286218	0	180256009	4107731	
49210	4313	4107731	1991-10-19	1991-10-19 00:00:00	38000275	0	\N	\N	286284	0	180256009	4107731	
49415	4343	4195803	2014-12-15	2014-12-15 00:00:00	38000275	0	\N	\N	288073	0	312681000	4195803	
49764	4366	4107731	1997-01-21	1997-01-21 00:00:00	38000275	0	\N	\N	289651	0	180256009	4107731	
50114	4373	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	290361	0	180256009	4107731	
50144	4373	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	290381	0	180256009	4107731	
50619	4405	4163872	1983-05-10	1983-05-10 00:00:00	38000275	0	\N	\N	292810	0	399208008	4163872	
50685	4412	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	293361	0	180256009	4107731	
39504	3477	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	230662	0	180256009	4107731	
51788	4487	4145310	1953-09-12	1953-09-12 00:00:00	38000275	0	\N	\N	298681	0	268425006	4145310	
51859	4500	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	299544	0	180256009	4107731	
52082	4514	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	300676	0	180256009	4107731	
40553	3561	4078793	2002-12-16	2002-12-16 00:00:00	38000275	0	\N	\N	236543	0	180325003	4078793	
52636	4578	4243062	1979-02-03	1979-02-03 00:00:00	38000275	0	\N	\N	304988	0	60027007	4243062	
40973	3592	4163872	1978-09-07	1978-09-07 00:00:00	38000275	0	\N	\N	238591	0	399208008	4163872	
41305	3625	4151422	1991-09-10	1991-09-10 00:00:00	38000275	0	\N	\N	241063	0	269911007	4151422	
53377	4633	4125906	2014-10-11	2014-10-11 00:00:00	38000275	0	\N	\N	308765	0	288086009	4125906	
53813	4674	4125906	1987-02-08	1987-02-08 00:00:00	38000275	0	\N	\N	311388	0	288086009	4125906	
53885	4680	4195803	1979-10-24	1979-10-24 00:00:00	38000275	0	\N	\N	311948	0	312681000	4195803	
54095	4701	4202451	2015-04-03	2015-04-03 00:00:00	38000275	0	\N	\N	313191	0	433112001	4202451	
42567	3754	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	249536	0	180256009	4107731	
54658	4745	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	315966	0	180256009	4107731	
54901	4761	4107731	1993-12-27	1993-12-27 00:00:00	38000275	0	\N	\N	317278	0	180256009	4107731	
55161	4804	4191853	1978-01-28	1978-01-28 00:00:00	38000275	0	\N	\N	319658	0	395142003	4191853	
43330	3822	4125906	1964-06-03	1964-06-03 00:00:00	38000275	0	\N	\N	253833	0	288086009	4125906	
43527	3852	4107731	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	255644	0	180256009	4107731	
55666	4848	4163872	1966-10-01	1966-10-01 00:00:00	38000275	0	\N	\N	322560	0	399208008	4163872	
56027	4890	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	325158	0	180256009	4107731	
32337	2835	4243062	1913-11-07	1913-11-07 00:00:00	38000275	0	\N	\N	188299	0	60027007	4243062	
45133	3968	4078793	2010-06-18	2010-06-18 00:00:00	38000275	0	\N	\N	263916	0	180325003	4078793	
57289	4970	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	330361	0	180256009	4107731	
57625	4992	4043071	1995-11-26	1995-11-26 00:00:00	38000275	0	\N	\N	332125	0	228557008	4043071	
58035	5035	4151422	1982-03-02	1982-03-02 00:00:00	38000275	0	\N	\N	334590	0	269911007	4151422	
46290	4067	4125906	1977-06-23	1977-06-23 00:00:00	38000275	0	\N	\N	270200	0	288086009	4125906	
46561	4085	4043071	1968-06-16	1968-06-16 00:00:00	38000275	0	\N	\N	271517	0	228557008	4043071	
58797	5104	4043071	1992-03-05	1992-03-05 00:00:00	38000275	0	\N	\N	339204	0	228557008	4043071	
59168	5119	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	340346	0	180256009	4107731	
59625	5165	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	343254	0	180256009	4107731	
59765	5172	4125906	1988-11-16	1988-11-16 00:00:00	38000275	0	\N	\N	343920	0	288086009	4125906	
35978	3158	4043071	1965-06-24	1965-06-24 00:00:00	38000275	0	\N	\N	209935	0	228557008	4043071	
48144	4224	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	280517	0	180256009	4107731	
36414	3189	4043071	1974-10-03	1974-10-03 00:00:00	38000275	0	\N	\N	212243	0	228557008	4043071	
48617	4274	4058899	1995-08-25	1995-08-25 00:00:00	38000275	0	\N	\N	283560	0	168594001	4058899	
48701	4279	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	283973	0	180256009	4107731	
48977	4305	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	285653	0	180256009	4107731	
49129	4312	4125906	1989-09-08	1989-09-08 00:00:00	38000275	0	\N	\N	286124	0	288086009	4125906	
49211	4313	4107731	1992-06-27	1992-06-27 00:00:00	38000275	0	\N	\N	286360	0	180256009	4107731	
49416	4343	4125906	1999-07-04	1999-07-04 00:00:00	38000275	0	\N	\N	288081	0	288086009	4125906	
49765	4366	4107731	1994-08-02	1994-08-02 00:00:00	38000275	0	\N	\N	289675	0	180256009	4107731	
50115	4373	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	290353	0	180256009	4107731	
50145	4373	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	290415	0	180256009	4107731	
50623	4408	4125906	2014-05-29	2014-05-29 00:00:00	38000275	0	\N	\N	293001	0	288086009	4125906	
50686	4412	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	293370	0	180256009	4107731	
39505	3477	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	230706	0	180256009	4107731	
51789	4487	4125906	1968-06-07	1968-06-07 00:00:00	38000275	0	\N	\N	298684	0	288086009	4125906	
51860	4500	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	299541	0	180256009	4107731	
52083	4514	4170947	1979-04-16	1979-04-16 00:00:00	38000275	0	\N	\N	300590	0	274474001	4170947	
40554	3561	4078793	2004-12-27	2004-12-27 00:00:00	38000275	0	\N	\N	236565	0	180325003	4078793	
52637	4578	4125906	1981-10-20	1981-10-20 00:00:00	38000275	0	\N	\N	305003	0	288086009	4125906	
40974	3592	4170947	1978-09-07	1978-09-07 00:00:00	38000275	0	\N	\N	238591	0	274474001	4170947	
41306	3625	4078793	2015-09-22	2015-09-22 00:00:00	38000275	0	\N	\N	241033	0	180325003	4078793	
53378	4633	4057420	2018-01-16	2018-01-16 00:00:00	38000275	0	\N	\N	308799	0	18286008	4057420	
53814	4674	4198190	1978-08-20	1978-08-20 00:00:00	38000275	0	\N	\N	311415	0	80146002	4198190	
53886	4680	4058899	1979-10-24	1979-10-24 00:00:00	38000275	0	\N	\N	311948	0	168594001	4058899	
54096	4701	4293740	2015-11-11	2015-11-11 00:00:00	38000275	0	\N	\N	313174	0	384700001	4293740	
42568	3754	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	249472	0	180256009	4107731	
54659	4745	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	315983	0	180256009	4107731	
54902	4761	4107731	1996-01-01	1996-01-01 00:00:00	38000275	0	\N	\N	317320	0	180256009	4107731	
55162	4804	4107731	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	319639	0	180256009	4107731	
43331	3822	4078793	2017-05-08	2017-05-08 00:00:00	38000275	0	\N	\N	253877	0	180325003	4078793	
43528	3852	4107731	1990-05-07	1990-05-07 00:00:00	38000275	0	\N	\N	255642	0	180256009	4107731	
55667	4848	4170947	1966-10-01	1966-10-01 00:00:00	38000275	0	\N	\N	322560	0	274474001	4170947	
56028	4890	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	325098	0	180256009	4107731	
32338	2835	4170947	1913-11-07	1913-11-07 00:00:00	38000275	0	\N	\N	188299	0	274474001	4170947	
45134	3968	4078793	2006-03-31	2006-03-31 00:00:00	38000275	0	\N	\N	263800	0	180325003	4078793	
57290	4970	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	330478	0	180256009	4107731	
57626	4992	4043071	1997-11-09	1997-11-09 00:00:00	38000275	0	\N	\N	332089	0	228557008	4043071	
58036	5035	4078793	2014-09-01	2014-09-01 00:00:00	38000275	0	\N	\N	334604	0	180325003	4078793	
58200	5043	4252419	1994-08-26	1994-08-26 00:00:00	38000275	0	\N	\N	335130	0	74016001	4252419	
46562	4085	4043071	1967-07-09	1967-07-09 00:00:00	38000275	0	\N	\N	271465	0	228557008	4043071	
58798	5104	4043071	1993-09-17	1993-09-17 00:00:00	38000275	0	\N	\N	339160	0	228557008	4043071	
59169	5119	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	340416	0	180256009	4107731	
59626	5165	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	343280	0	180256009	4107731	
59766	5172	4125906	1952-10-23	1952-10-23 00:00:00	38000275	0	\N	\N	343917	0	288086009	4125906	
35979	3158	4043071	1965-05-20	1965-05-20 00:00:00	38000275	0	\N	\N	209928	0	228557008	4043071	
48145	4224	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	280570	0	180256009	4107731	
36415	3189	4043071	1973-11-15	1973-11-15 00:00:00	38000275	0	\N	\N	212295	0	228557008	4043071	
48618	4274	4195803	2018-04-10	2018-04-10 00:00:00	38000275	0	\N	\N	283563	0	312681000	4195803	
48702	4279	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	284065	0	180256009	4107731	
48978	4305	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	285526	0	180256009	4107731	
49130	4312	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	286050	0	180256009	4107731	
49212	4313	4107731	1992-10-10	1992-10-10 00:00:00	38000275	0	\N	\N	286289	0	180256009	4107731	
49465	4347	4243062	1972-11-09	1972-11-09 00:00:00	38000275	0	\N	\N	288290	0	60027007	4243062	
49766	4366	4107731	1994-06-21	1994-06-21 00:00:00	38000275	0	\N	\N	289674	0	180256009	4107731	
50116	4373	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	290409	0	180256009	4107731	
50146	4373	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	290419	0	180256009	4107731	
50624	4408	4125906	2019-02-23	2019-02-23 00:00:00	38000275	0	\N	\N	293002	0	288086009	4125906	
50687	4412	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	293371	0	180256009	4107731	
39506	3477	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	230605	0	180256009	4107731	
51790	4487	4336464	2010-02-12	2010-02-12 00:00:00	38000275	0	\N	\N	298687	0	232717009	4336464	
51861	4500	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	299626	0	180256009	4107731	
52084	4514	4243062	1979-04-16	1979-04-16 00:00:00	38000275	0	\N	\N	300590	0	60027007	4243062	
40555	3561	4078793	1978-07-31	1978-07-31 00:00:00	38000275	0	\N	\N	236436	0	180325003	4078793	
52638	4578	4170947	1973-06-04	1973-06-04 00:00:00	38000275	0	\N	\N	304987	0	274474001	4170947	
40975	3592	4151422	1998-11-27	1998-11-27 00:00:00	38000275	0	\N	\N	238594	0	269911007	4151422	
41307	3625	4078793	2017-10-03	2017-10-03 00:00:00	38000275	0	\N	\N	241100	0	180325003	4078793	
53379	4633	4252419	1974-01-05	1974-01-05 00:00:00	38000275	0	\N	\N	308763	0	74016001	4252419	
53815	4675	4170947	2006-11-11	2006-11-11 00:00:00	38000275	0	\N	\N	311448	0	274474001	4170947	
53887	4682	4163872	1993-04-10	1993-04-10 00:00:00	38000275	0	\N	\N	312005	0	399208008	4163872	
54097	4701	4125906	2015-11-11	2015-11-11 00:00:00	38000275	0	\N	\N	313174	0	288086009	4125906	
42569	3754	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	249496	0	180256009	4107731	
54660	4745	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	315939	0	180256009	4107731	
54903	4761	4107731	1996-02-12	1996-02-12 00:00:00	38000275	0	\N	\N	317248	0	180256009	4107731	
55163	4804	4151422	1978-10-14	1978-10-14 00:00:00	38000275	0	\N	\N	319615	0	269911007	4151422	
43332	3823	4202451	2016-11-16	2016-11-16 00:00:00	38000275	0	\N	\N	253946	0	433112001	4202451	
43529	3852	4107731	1991-12-16	1991-12-16 00:00:00	38000275	0	\N	\N	255649	0	180256009	4107731	
55668	4848	4125906	1988-10-24	1988-10-24 00:00:00	38000275	0	\N	\N	322563	0	288086009	4125906	
56029	4890	4195803	1998-09-28	1998-09-28 00:00:00	38000275	0	\N	\N	325147	0	312681000	4195803	
32339	2835	4202451	1994-09-27	1994-09-27 00:00:00	38000275	0	\N	\N	188345	0	433112001	4202451	
45135	3968	4078793	2016-07-22	2016-07-22 00:00:00	38000275	0	\N	\N	263803	0	180325003	4078793	
57291	4970	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	330419	0	180256009	4107731	
57627	4992	4043071	1997-03-30	1997-03-30 00:00:00	38000275	0	\N	\N	332079	0	228557008	4043071	
58037	5035	4078793	2013-08-26	2013-08-26 00:00:00	38000275	0	\N	\N	334647	0	180325003	4078793	
58201	5043	44783196	1994-09-02	1994-09-02 00:00:00	38000275	0	\N	\N	335153	0	699253003	44783196	
46563	4085	4043071	1968-10-27	1968-10-27 00:00:00	38000275	0	\N	\N	271539	0	228557008	4043071	
58799	5104	4043071	1992-07-31	1992-07-31 00:00:00	38000275	0	\N	\N	339166	0	228557008	4043071	
59170	5119	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	340413	0	180256009	4107731	
59627	5165	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	343303	0	180256009	4107731	
59767	5172	4125906	1959-07-08	1959-07-08 00:00:00	38000275	0	\N	\N	343919	0	288086009	4125906	
35980	3158	4043071	1964-03-19	1964-03-19 00:00:00	38000275	0	\N	\N	209996	0	228557008	4043071	
48146	4224	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	280451	0	180256009	4107731	
36416	3189	4252419	1985-09-20	1985-09-20 00:00:00	38000275	0	\N	\N	212271	0	74016001	4252419	
48619	4274	4058899	2018-04-10	2018-04-10 00:00:00	38000275	0	\N	\N	283563	0	168594001	4058899	
48703	4279	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	283974	0	180256009	4107731	
48979	4305	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	285609	0	180256009	4107731	
49131	4312	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	286166	0	180256009	4107731	
49213	4313	4107731	1993-01-23	1993-01-23 00:00:00	38000275	0	\N	\N	286243	0	180256009	4107731	
49466	4347	4170947	1972-11-09	1972-11-09 00:00:00	38000275	0	\N	\N	288290	0	274474001	4170947	
49767	4366	4107731	1994-05-31	1994-05-31 00:00:00	38000275	0	\N	\N	289694	0	180256009	4107731	
61923	5343	4107731	1999-01-03	1999-01-03 00:00:00	38000275	0	\N	\N	355822	0	180256009	4107731	
50147	4373	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	290417	0	180256009	4107731	
50625	4408	4058899	2011-07-14	2011-07-14 00:00:00	38000275	0	\N	\N	293000	0	168594001	4058899	
50688	4412	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	293412	0	180256009	4107731	
39507	3477	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	230657	0	180256009	4107731	
51791	4487	4216130	2010-02-12	2010-02-12 00:00:00	38000275	0	\N	\N	298687	0	415070008	4216130	
51862	4500	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	299577	0	180256009	4107731	
52085	4514	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	300692	0	180256009	4107731	
40556	3562	4170947	1974-07-21	1974-07-21 00:00:00	38000275	0	\N	\N	236605	0	274474001	4170947	
52639	4578	4243062	1973-06-04	1973-06-04 00:00:00	38000275	0	\N	\N	304987	0	60027007	4243062	
40976	3592	4151422	1986-05-09	1986-05-09 00:00:00	38000275	0	\N	\N	238587	0	269911007	4151422	
41308	3625	4078793	2018-10-09	2018-10-09 00:00:00	38000275	0	\N	\N	241105	0	180325003	4078793	
53380	4633	4078793	2013-12-24	2013-12-24 00:00:00	38000275	0	\N	\N	308762	0	180325003	4078793	
53816	4675	4047491	2006-11-11	2006-11-11 00:00:00	38000275	0	\N	\N	311448	0	1225002	4047491	
53888	4682	4125906	2009-12-19	2009-12-19 00:00:00	38000275	0	\N	\N	312045	0	288086009	4125906	
54098	4701	4151422	1975-06-06	1975-06-06 00:00:00	38000275	0	\N	\N	313134	0	269911007	4151422	
42570	3754	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	249459	0	180256009	4107731	
54661	4745	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	315909	0	180256009	4107731	
54904	4761	4107731	1996-04-15	1996-04-15 00:00:00	38000275	0	\N	\N	317230	0	180256009	4107731	
55164	4804	4107731	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	319567	0	180256009	4107731	
43333	3823	4078793	2016-06-08	2016-06-08 00:00:00	38000275	0	\N	\N	253946	0	180325003	4078793	
43530	3852	4107731	1990-07-09	1990-07-09 00:00:00	38000275	0	\N	\N	255638	0	180256009	4107731	
55669	4848	4125906	1980-08-16	1980-08-16 00:00:00	38000275	0	\N	\N	322562	0	288086009	4125906	
56030	4890	4058899	1998-09-28	1998-09-28 00:00:00	38000275	0	\N	\N	325147	0	168594001	4058899	
32340	2835	4252419	1989-10-21	1989-10-21 00:00:00	38000275	0	\N	\N	188344	0	74016001	4252419	
45136	3968	4078793	2012-06-29	2012-06-29 00:00:00	38000275	0	\N	\N	263917	0	180325003	4078793	
57292	4970	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	330423	0	180256009	4107731	
57628	4992	4043071	1995-06-18	1995-06-18 00:00:00	38000275	0	\N	\N	332107	0	228557008	4043071	
58044	5037	4295880	1995-05-10	1995-05-10 00:00:00	38000275	0	\N	\N	334785	0	76601001	4295880	
58202	5045	4151422	1967-04-28	1967-04-28 00:00:00	38000275	0	\N	\N	335231	0	269911007	4151422	
58417	5051	4107731	1994-01-27	1994-01-27 00:00:00	38000275	0	\N	\N	335842	0	180256009	4107731	
58800	5104	4043071	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	339168	0	228557008	4043071	
59171	5119	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	340380	0	180256009	4107731	
59628	5165	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	343325	0	180256009	4107731	
59771	5174	4047491	2003-05-13	2003-05-13 00:00:00	38000275	0	\N	\N	344067	0	1225002	4047491	
35981	3158	4043071	1966-06-23	1966-06-23 00:00:00	38000275	0	\N	\N	209931	0	228557008	4043071	
48147	4224	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	280535	0	180256009	4107731	
36417	3189	4043071	1974-08-01	1974-08-01 00:00:00	38000275	0	\N	\N	212252	0	228557008	4043071	
48620	4274	4170947	2002-07-03	2002-07-03 00:00:00	38000275	0	\N	\N	283562	0	274474001	4170947	
48704	4279	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	283983	0	180256009	4107731	
48980	4305	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	285648	0	180256009	4107731	
49132	4312	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	286160	0	180256009	4107731	
49214	4313	4107731	1993-05-08	1993-05-08 00:00:00	38000275	0	\N	\N	286364	0	180256009	4107731	
49467	4347	4163872	1974-02-02	1974-02-02 00:00:00	38000275	0	\N	\N	288291	0	399208008	4163872	
49768	4366	4107731	1997-09-30	1997-09-30 00:00:00	38000275	0	\N	\N	289728	0	180256009	4107731	
61924	5343	4107731	1996-12-08	1996-12-08 00:00:00	38000275	0	\N	\N	355906	0	180256009	4107731	
50148	4373	4107731	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	290354	0	180256009	4107731	
50626	4408	4151422	1989-10-09	1989-10-09 00:00:00	38000275	0	\N	\N	293040	0	269911007	4151422	
50689	4412	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	293402	0	180256009	4107731	
39508	3477	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	230705	0	180256009	4107731	
51792	4488	4170947	2012-02-27	2012-02-27 00:00:00	38000275	0	\N	\N	298832	0	274474001	4170947	
51863	4500	4181917	1961-09-13	1961-09-13 00:00:00	38000275	0	\N	\N	299601	0	54550000	4181917	
52086	4514	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	300693	0	180256009	4107731	
40557	3562	4047491	1974-07-21	1974-07-21 00:00:00	38000275	0	\N	\N	236605	0	1225002	4047491	
52640	4579	4151422	2010-06-10	2010-06-10 00:00:00	38000275	0	\N	\N	305031	0	269911007	4151422	
40977	3593	4078793	2019-06-26	2019-06-26 00:00:00	38000275	0	\N	\N	238653	0	180325003	4078793	
41309	3625	4195803	2013-09-10	2013-09-10 00:00:00	38000275	0	\N	\N	241115	0	312681000	4195803	
53381	4633	4078793	2011-12-13	2011-12-13 00:00:00	38000275	0	\N	\N	308761	0	180325003	4078793	
53817	4675	4078793	2006-01-08	2006-01-08 00:00:00	38000275	0	\N	\N	311519	0	180325003	4078793	
53889	4682	4125906	2000-09-09	2000-09-09 00:00:00	38000275	0	\N	\N	312043	0	288086009	4125906	
54099	4701	4275113	1985-11-22	1985-11-22 00:00:00	38000275	0	\N	\N	313132	0	65200003	4275113	
42571	3754	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	249524	0	180256009	4107731	
54662	4745	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	316007	0	395142003	4191853	
54905	4761	4191853	1993-05-10	1993-05-10 00:00:00	38000275	0	\N	\N	317261	0	395142003	4191853	
55165	4804	4107731	1991-11-25	1991-11-25 00:00:00	38000275	0	\N	\N	319626	0	180256009	4107731	
43334	3823	4078793	2013-02-20	2013-02-20 00:00:00	38000275	0	\N	\N	253985	0	180325003	4078793	
43531	3852	4107731	1991-04-08	1991-04-08 00:00:00	38000275	0	\N	\N	255657	0	180256009	4107731	
56031	4890	44783196	1972-02-17	1972-02-17 00:00:00	38000275	0	\N	\N	325255	0	699253003	44783196	
32341	2836	4047491	1984-02-13	1984-02-13 00:00:00	38000275	0	\N	\N	188372	0	1225002	4047491	
45137	3968	40492359	1928-02-03	1928-02-03 00:00:00	38000275	0	\N	\N	263901	0	447365002	40492359	
57293	4970	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	330374	0	180256009	4107731	
57629	4992	4043071	1995-12-31	1995-12-31 00:00:00	38000275	0	\N	\N	332109	0	228557008	4043071	
58045	5037	4295880	2001-10-31	2001-10-31 00:00:00	38000275	0	\N	\N	334731	0	76601001	4295880	
58203	5046	4125906	2012-11-12	2012-11-12 00:00:00	38000275	0	\N	\N	335342	0	288086009	4125906	
58418	5051	4191853	1990-11-29	1990-11-29 00:00:00	38000275	0	\N	\N	335899	0	395142003	4191853	
58801	5104	4043071	1994-02-24	1994-02-24 00:00:00	38000275	0	\N	\N	339185	0	228557008	4043071	
59172	5119	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	340415	0	180256009	4107731	
59629	5165	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	343332	0	180256009	4107731	
59772	5174	4170947	2003-05-13	2003-05-13 00:00:00	38000275	0	\N	\N	344067	0	274474001	4170947	
35982	3158	4043071	1965-07-29	1965-07-29 00:00:00	38000275	0	\N	\N	209936	0	228557008	4043071	
48148	4224	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	280537	0	180256009	4107731	
36418	3191	4058899	1969-11-06	1969-11-06 00:00:00	38000275	0	\N	\N	212387	0	168594001	4058899	
60434	5222	4057420	2015-07-30	2015-07-30 00:00:00	38000275	0	\N	\N	\N	0	18286008	4057420	
48705	4279	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	283969	0	180256009	4107731	
48981	4305	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	285528	0	180256009	4107731	
49133	4312	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	286077	0	180256009	4107731	
49215	4313	4107731	1990-03-10	1990-03-10 00:00:00	38000275	0	\N	\N	286312	0	180256009	4107731	
49468	4347	4170947	1974-02-02	1974-02-02 00:00:00	38000275	0	\N	\N	288291	0	274474001	4170947	
49769	4366	4107731	1995-03-21	1995-03-21 00:00:00	38000275	0	\N	\N	289677	0	180256009	4107731	
61925	5343	4295880	1997-12-28	1997-12-28 00:00:00	38000275	0	\N	\N	355829	0	76601001	4295880	
50149	4373	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	290420	0	180256009	4107731	
50627	4409	4057420	1999-10-28	1999-10-28 00:00:00	38000275	0	\N	\N	293129	0	18286008	4057420	
50690	4412	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	293347	0	180256009	4107731	
39509	3477	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	230619	0	180256009	4107731	
51793	4488	4047491	2012-02-27	2012-02-27 00:00:00	38000275	0	\N	\N	298832	0	1225002	4047491	
51864	4500	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	299610	0	395142003	4191853	
52087	4514	4151422	2014-06-29	2014-06-29 00:00:00	38000275	0	\N	\N	300663	0	269911007	4151422	
40558	3562	4125906	2005-11-06	2005-11-06 00:00:00	38000275	0	\N	\N	236609	0	288086009	4125906	
52641	4579	4151422	1969-07-05	1969-07-05 00:00:00	38000275	0	\N	\N	305027	0	269911007	4151422	
40978	3593	4125906	1987-09-03	1987-09-03 00:00:00	38000275	0	\N	\N	238688	0	288086009	4125906	
41310	3625	4078793	2013-09-10	2013-09-10 00:00:00	38000275	0	\N	\N	241115	0	180325003	4078793	
53382	4634	4293740	1989-09-17	1989-09-17 00:00:00	38000275	0	\N	\N	308858	0	384700001	4293740	
53818	4675	4078793	2016-03-06	2016-03-06 00:00:00	38000275	0	\N	\N	311500	0	180325003	4078793	
53890	4682	4163872	2008-05-24	2008-05-24 00:00:00	38000275	0	\N	\N	312025	0	399208008	4163872	
54170	4704	4186930	1984-12-15	1984-12-15 00:00:00	38000275	0	\N	\N	313415	0	46706006	4186930	
42572	3754	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	249530	0	180256009	4107731	
54663	4745	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	315959	0	180256009	4107731	
54906	4761	4107731	1994-07-25	1994-07-25 00:00:00	38000275	0	\N	\N	317274	0	180256009	4107731	
43335	3823	4078793	2014-05-28	2014-05-28 00:00:00	38000275	0	\N	\N	253945	0	180325003	4078793	
43532	3852	4107731	1990-02-12	1990-02-12 00:00:00	38000275	0	\N	\N	255640	0	180256009	4107731	
56032	4890	4078793	2010-12-15	2010-12-15 00:00:00	38000275	0	\N	\N	325179	0	180325003	4078793	
32342	2836	4170947	1984-02-13	1984-02-13 00:00:00	38000275	0	\N	\N	188372	0	274474001	4170947	
45138	3968	4057420	1928-02-03	1928-02-03 00:00:00	38000275	0	\N	\N	263901	0	18286008	4057420	
57294	4970	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	330364	0	180256009	4107731	
57630	4992	4043071	1998-02-15	1998-02-15 00:00:00	38000275	0	\N	\N	332081	0	228557008	4043071	
58046	5037	4295880	2002-01-30	2002-01-30 00:00:00	38000275	0	\N	\N	334815	0	76601001	4295880	
58206	5048	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	335534	0	180256009	4107731	
58419	5051	4107731	1993-10-14	1993-10-14 00:00:00	38000275	0	\N	\N	335937	0	180256009	4107731	
58802	5104	4043071	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	339208	0	228557008	4043071	
59173	5119	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	340362	0	180256009	4107731	
59630	5165	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	343327	0	180256009	4107731	
59773	5174	4024289	1947-02-08	1947-02-08 00:00:00	38000275	0	\N	\N	344063	0	19490002	4024289	
35983	3158	4043071	1966-05-19	1966-05-19 00:00:00	38000275	0	\N	\N	210019	0	228557008	4043071	
48149	4224	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	280574	0	180256009	4107731	
36419	3191	4151422	2000-10-05	2000-10-05 00:00:00	38000275	0	\N	\N	212361	0	269911007	4151422	
60435	5222	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	347454	0	180256009	4107731	
48706	4279	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	284094	0	180256009	4107731	
48982	4305	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	285586	0	180256009	4107731	
49134	4312	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	286158	0	180256009	4107731	
49216	4313	4107731	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	286327	0	180256009	4107731	
49469	4347	4198190	1993-04-05	1993-04-05 00:00:00	38000275	0	\N	\N	288294	0	80146002	4198190	
49770	4366	4107731	1995-06-13	1995-06-13 00:00:00	38000275	0	\N	\N	289685	0	180256009	4107731	
61926	5343	4107731	1998-02-22	1998-02-22 00:00:00	38000275	0	\N	\N	355922	0	180256009	4107731	
50150	4373	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	290389	0	180256009	4107731	
50628	4409	40492359	1999-10-28	1999-10-28 00:00:00	38000275	0	\N	\N	293129	0	447365002	40492359	
50691	4412	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	293334	0	180256009	4107731	
39510	3477	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	230661	0	180256009	4107731	
51794	4488	4125906	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	298831	0	288086009	4125906	
51865	4500	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	299619	0	180256009	4107731	
52088	4514	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	300602	0	180256009	4107731	
40563	3565	4037675	1976-02-25	1976-02-25 00:00:00	38000275	0	\N	\N	236785	0	162676008	4037675	
52642	4579	4010253	2011-04-04	2011-04-04 00:00:00	38000275	0	\N	\N	305062	0	112790001	4010253	
40979	3593	4057420	2017-06-14	2017-06-14 00:00:00	38000275	0	\N	\N	238652	0	18286008	4057420	
41311	3625	4125906	2000-07-03	2000-07-03 00:00:00	38000275	0	\N	\N	241058	0	288086009	4125906	
53383	4634	4125906	1989-09-17	1989-09-17 00:00:00	38000275	0	\N	\N	308858	0	288086009	4125906	
53819	4675	4243062	1949-04-16	1949-04-16 00:00:00	38000275	0	\N	\N	311505	0	60027007	4243062	
53891	4682	4151422	2001-05-10	2001-05-10 00:00:00	38000275	0	\N	\N	312024	0	269911007	4151422	
54171	4704	4238715	1987-11-14	1987-11-14 00:00:00	38000275	0	\N	\N	313422	0	68254000	4238715	
42573	3754	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	249532	0	180256009	4107731	
54664	4745	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	315931	0	180256009	4107731	
54907	4761	4107731	1993-08-02	1993-08-02 00:00:00	38000275	0	\N	\N	317269	0	180256009	4107731	
43336	3823	4057420	2013-08-14	2013-08-14 00:00:00	38000275	0	\N	\N	\N	0	18286008	4057420	
43533	3852	4107731	1991-11-04	1991-11-04 00:00:00	38000275	0	\N	\N	255648	0	180256009	4107731	
56033	4890	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	325123	0	180256009	4107731	
32343	2836	4125906	1986-02-02	1986-02-02 00:00:00	38000275	0	\N	\N	188373	0	288086009	4125906	
45139	3968	4078793	2008-06-06	2008-06-06 00:00:00	38000275	0	\N	\N	263915	0	180325003	4078793	
57295	4970	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	330386	0	180256009	4107731	
57631	4992	4043071	1995-09-24	1995-09-24 00:00:00	38000275	0	\N	\N	332118	0	228557008	4043071	
58047	5037	4295880	1995-11-08	1995-11-08 00:00:00	38000275	0	\N	\N	334809	0	76601001	4295880	
58207	5048	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	335529	0	180256009	4107731	
58420	5051	4107731	1992-12-24	1992-12-24 00:00:00	38000275	0	\N	\N	335866	0	180256009	4107731	
58803	5104	4043071	1993-05-14	1993-05-14 00:00:00	38000275	0	\N	\N	339207	0	228557008	4043071	
59174	5119	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	340343	0	180256009	4107731	
59631	5165	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	343344	0	180256009	4107731	
59774	5174	4170947	1947-02-08	1947-02-08 00:00:00	38000275	0	\N	\N	344063	0	274474001	4170947	
35984	3158	4043071	1965-01-21	1965-01-21 00:00:00	38000275	0	\N	\N	209934	0	228557008	4043071	
48150	4224	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	280543	0	180256009	4107731	
36420	3191	4125906	1968-09-28	1968-09-28 00:00:00	38000275	0	\N	\N	212386	0	288086009	4125906	
60436	5222	4078793	2009-10-29	2009-10-29 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
48707	4279	4151422	1970-10-20	1970-10-20 00:00:00	38000275	0	\N	\N	283947	0	269911007	4151422	
48983	4305	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	285650	0	180256009	4107731	
49135	4312	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	286148	0	180256009	4107731	
49217	4313	4107731	1993-02-13	1993-02-13 00:00:00	38000275	0	\N	\N	286362	0	180256009	4107731	
49470	4347	4163872	2001-05-07	2001-05-07 00:00:00	38000275	0	\N	\N	288268	0	399208008	4163872	
49771	4366	4107731	1997-05-06	1997-05-06 00:00:00	38000275	0	\N	\N	289716	0	180256009	4107731	
61927	5343	4107731	1998-01-11	1998-01-11 00:00:00	38000275	0	\N	\N	355921	0	180256009	4107731	
50151	4373	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	290343	0	180256009	4107731	
50629	4409	4275113	1987-12-12	1987-12-12 00:00:00	38000275	0	\N	\N	293111	0	65200003	4275113	
50692	4412	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	293397	0	180256009	4107731	
39511	3477	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	230707	0	180256009	4107731	
51795	4488	4163872	1982-09-27	1982-09-27 00:00:00	38000275	0	\N	\N	298843	0	399208008	4163872	
51866	4500	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	299563	0	180256009	4107731	
52089	4514	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	300686	0	180256009	4107731	
40564	3565	4187458	1976-02-25	1976-02-25 00:00:00	38000275	0	\N	\N	236785	0	415300000	4187458	
52643	4579	4047491	1977-11-18	1977-11-18 00:00:00	38000275	0	\N	\N	305005	0	1225002	4047491	
40980	3593	4125906	1984-01-01	1984-01-01 00:00:00	38000275	0	\N	\N	238687	0	288086009	4125906	
41312	3625	4078793	2012-09-04	2012-09-04 00:00:00	38000275	0	\N	\N	241072	0	180325003	4078793	
53388	4636	4195803	2006-08-15	2006-08-15 00:00:00	38000275	0	\N	\N	308943	0	312681000	4195803	
53820	4675	4170947	1949-04-16	1949-04-16 00:00:00	38000275	0	\N	\N	311505	0	274474001	4170947	
53894	4685	4243062	1975-01-22	1975-01-22 00:00:00	38000275	0	\N	\N	312153	0	60027007	4243062	
54172	4704	4275113	1979-12-19	1979-12-19 00:00:00	38000275	0	\N	\N	313371	0	65200003	4275113	
42574	3754	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	249475	0	180256009	4107731	
54665	4745	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	315901	0	180256009	4107731	
54908	4761	4107731	1995-10-30	1995-10-30 00:00:00	38000275	0	\N	\N	317301	0	180256009	4107731	
43337	3823	4078793	2013-08-21	2013-08-21 00:00:00	38000275	0	\N	\N	253961	0	180325003	4078793	
43534	3852	4107731	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	255671	0	180256009	4107731	
56034	4890	4170947	1981-12-26	1981-12-26 00:00:00	38000275	0	\N	\N	325146	0	274474001	4170947	
32344	2837	4198190	1996-07-28	1996-07-28 00:00:00	38000275	0	\N	\N	188474	0	80146002	4198190	
45140	3968	4078793	2013-07-05	2013-07-05 00:00:00	38000275	0	\N	\N	263883	0	180325003	4078793	
57296	4970	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	330428	0	180256009	4107731	
57632	4992	4043071	1997-06-01	1997-06-01 00:00:00	38000275	0	\N	\N	332151	0	228557008	4043071	
58048	5037	4295880	1996-05-08	1996-05-08 00:00:00	38000275	0	\N	\N	334726	0	76601001	4295880	
58208	5048	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	335473	0	180256009	4107731	
58421	5051	4107731	1993-08-12	1993-08-12 00:00:00	38000275	0	\N	\N	335858	0	180256009	4107731	
58804	5104	4043071	1992-07-03	1992-07-03 00:00:00	38000275	0	\N	\N	339205	0	228557008	4043071	
59175	5119	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	340306	0	180256009	4107731	
59632	5165	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	343342	0	180256009	4107731	
59775	5174	4058899	1944-12-20	1944-12-20 00:00:00	38000275	0	\N	\N	344062	0	168594001	4058899	
35985	3158	4043071	1967-02-02	1967-02-02 00:00:00	38000275	0	\N	\N	209941	0	228557008	4043071	
48151	4224	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	280571	0	180256009	4107731	
36421	3191	4151422	2016-07-03	2016-07-03 00:00:00	38000275	0	\N	\N	212341	0	269911007	4151422	
60437	5222	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	347488	0	180256009	4107731	
48708	4279	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	284037	0	180256009	4107731	
48984	4305	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	285525	0	180256009	4107731	
49136	4312	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	286057	0	180256009	4107731	
49218	4313	4107731	1992-11-21	1992-11-21 00:00:00	38000275	0	\N	\N	286290	0	180256009	4107731	
49471	4348	4062501	1985-10-27	1985-10-27 00:00:00	38000275	0	\N	\N	288327	0	171231001	4062501	
49772	4366	4107731	1996-02-20	1996-02-20 00:00:00	38000275	0	\N	\N	289702	0	180256009	4107731	
61928	5343	4107731	1997-05-25	1997-05-25 00:00:00	38000275	0	\N	\N	355919	0	180256009	4107731	
50152	4373	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	290410	0	180256009	4107731	
50630	4409	4238715	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	293112	0	68254000	4238715	
50693	4412	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	293362	0	180256009	4107731	
39512	3477	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	230715	0	180256009	4107731	
51796	4488	4170947	1982-09-27	1982-09-27 00:00:00	38000275	0	\N	\N	298843	0	274474001	4170947	
51867	4500	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	299550	0	180256009	4107731	
52090	4514	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	300660	0	180256009	4107731	
40565	3565	4326177	1976-02-25	1976-02-25 00:00:00	38000275	0	\N	\N	236785	0	430193006	4326177	
52644	4579	4170947	1977-11-18	1977-11-18 00:00:00	38000275	0	\N	\N	305005	0	274474001	4170947	
40981	3593	4078793	2018-06-20	2018-06-20 00:00:00	38000275	0	\N	\N	238716	0	180325003	4078793	
41313	3625	4293740	1960-01-14	1960-01-14 00:00:00	38000275	0	\N	\N	241056	0	384700001	4293740	
53389	4636	4151422	1972-07-01	1972-07-01 00:00:00	38000275	0	\N	\N	308967	0	269911007	4151422	
53821	4675	4078793	1999-12-05	1999-12-05 00:00:00	38000275	0	\N	\N	311571	0	180325003	4078793	
53895	4685	4170947	1975-01-22	1975-01-22 00:00:00	38000275	0	\N	\N	312153	0	274474001	4170947	
54173	4704	4125906	1969-01-01	1969-01-01 00:00:00	38000275	0	\N	\N	313430	0	288086009	4125906	
42575	3754	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	249476	0	180256009	4107731	
54666	4745	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	315928	0	180256009	4107731	
54909	4761	4107731	1993-05-31	1993-05-31 00:00:00	38000275	0	\N	\N	317215	0	180256009	4107731	
43338	3823	4078793	2009-11-11	2009-11-11 00:00:00	38000275	0	\N	\N	253959	0	180325003	4078793	
43543	3857	4035793	1995-01-10	1995-01-10 00:00:00	38000275	0	\N	\N	256055	0	15081005	4035793	
56035	4890	4163872	1981-12-26	1981-12-26 00:00:00	38000275	0	\N	\N	325146	0	399208008	4163872	
32347	2839	4125906	2017-08-14	2017-08-14 00:00:00	38000275	0	\N	\N	188552	0	288086009	4125906	
45141	3968	4078793	2007-04-06	2007-04-06 00:00:00	38000275	0	\N	\N	263873	0	180325003	4078793	
57297	4970	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	330362	0	180256009	4107731	
57633	4992	4043071	1997-12-07	1997-12-07 00:00:00	38000275	0	\N	\N	332115	0	228557008	4043071	
58049	5037	4295880	2000-02-02	2000-02-02 00:00:00	38000275	0	\N	\N	334789	0	76601001	4295880	
58209	5048	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	335512	0	180256009	4107731	
58422	5051	4107731	1992-05-28	1992-05-28 00:00:00	38000275	0	\N	\N	335932	0	180256009	4107731	
58805	5104	4125906	1986-05-29	1986-05-29 00:00:00	38000275	0	\N	\N	339182	0	288086009	4125906	
59176	5119	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	340385	0	180256009	4107731	
59633	5165	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	343282	0	180256009	4107731	
59776	5174	4195803	1997-03-27	1997-03-27 00:00:00	38000275	0	\N	\N	344008	0	312681000	4195803	
35986	3158	4043071	1966-12-01	1966-12-01 00:00:00	38000275	0	\N	\N	209963	0	228557008	4043071	
48152	4224	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	280468	0	180256009	4107731	
36422	3191	4125906	1976-08-31	1976-08-31 00:00:00	38000275	0	\N	\N	212388	0	288086009	4125906	
60438	5222	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	347463	0	180256009	4107731	
48709	4279	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	283971	0	180256009	4107731	
48985	4305	4197460	2004-04-19	2004-04-19 00:00:00	38000275	0	\N	\N	285535	0	313191000	4197460	
49137	4312	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	286096	0	180256009	4107731	
49219	4313	4107731	1991-09-07	1991-09-07 00:00:00	38000275	0	\N	\N	286232	0	180256009	4107731	
49472	4348	4293740	1995-11-07	1995-11-07 00:00:00	38000275	0	\N	\N	288326	0	384700001	4293740	
49773	4366	4107731	1996-06-25	1996-06-25 00:00:00	38000275	0	\N	\N	289630	0	180256009	4107731	
61929	5343	4107731	1997-08-17	1997-08-17 00:00:00	38000275	0	\N	\N	355884	0	180256009	4107731	
50153	4373	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	290394	0	180256009	4107731	
50634	4411	4243062	1950-01-20	1950-01-20 00:00:00	38000275	0	\N	\N	293248	0	60027007	4243062	
50694	4412	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	293369	0	180256009	4107731	
39513	3477	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	230604	0	180256009	4107731	
51798	4490	4336464	1988-04-23	1988-04-23 00:00:00	38000275	0	\N	\N	298886	0	232717009	4336464	
51868	4500	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	299648	0	180256009	4107731	
52091	4514	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	300607	0	180256009	4107731	
40566	3566	4107731	1991-07-22	1991-07-22 00:00:00	38000275	0	\N	\N	236842	0	180256009	4107731	
52645	4580	4238715	1985-06-11	1985-06-11 00:00:00	38000275	0	\N	\N	305110	0	68254000	4238715	
40982	3593	4163872	1953-03-14	1953-03-14 00:00:00	38000275	0	\N	\N	238686	0	399208008	4163872	
41314	3625	4078793	2014-09-16	2014-09-16 00:00:00	38000275	0	\N	\N	241073	0	180325003	4078793	
53390	4636	4125906	1948-05-08	1948-05-08 00:00:00	38000275	0	\N	\N	308977	0	288086009	4125906	
53822	4675	4078793	2008-01-20	2008-01-20 00:00:00	38000275	0	\N	\N	311530	0	180325003	4078793	
53896	4685	4202451	1992-05-25	1992-05-25 00:00:00	38000275	0	\N	\N	312117	0	433112001	4202451	
54174	4704	4170947	1982-09-04	1982-09-04 00:00:00	38000275	0	\N	\N	313431	0	274474001	4170947	
42576	3754	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	249498	0	180256009	4107731	
54667	4745	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	315926	0	180256009	4107731	
54910	4761	4107731	1994-05-23	1994-05-23 00:00:00	38000275	0	\N	\N	317313	0	180256009	4107731	
43339	3823	4078793	2008-11-05	2008-11-05 00:00:00	38000275	0	\N	\N	253982	0	180325003	4078793	
43544	3857	4035793	2014-10-07	2014-10-07 00:00:00	38000275	0	\N	\N	255998	0	15081005	4035793	
56036	4890	4195803	1981-12-26	1981-12-26 00:00:00	38000275	0	\N	\N	325146	0	312681000	4195803	
32348	2839	4252419	1986-04-29	1986-04-29 00:00:00	38000275	0	\N	\N	188534	0	74016001	4252419	
45142	3968	4078793	2009-06-12	2009-06-12 00:00:00	38000275	0	\N	\N	263881	0	180325003	4078793	
57298	4970	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	330373	0	180256009	4107731	
57634	4992	4043071	1996-10-13	1996-10-13 00:00:00	38000275	0	\N	\N	332149	0	228557008	4043071	
58050	5037	4295880	1996-11-06	1996-11-06 00:00:00	38000275	0	\N	\N	334744	0	76601001	4295880	
58210	5048	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	335541	0	180256009	4107731	
58423	5051	4107731	1992-05-07	1992-05-07 00:00:00	38000275	0	\N	\N	335864	0	180256009	4107731	
58806	5104	4043071	1992-02-06	1992-02-06 00:00:00	38000275	0	\N	\N	339156	0	228557008	4043071	
59177	5119	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	340378	0	180256009	4107731	
59634	5165	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	343329	0	180256009	4107731	
59777	5174	4125906	1954-09-29	1954-09-29 00:00:00	38000275	0	\N	\N	344064	0	288086009	4125906	
35987	3158	4043071	1964-06-25	1964-06-25 00:00:00	38000275	0	\N	\N	209911	0	228557008	4043071	
48153	4224	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	280467	0	395142003	4191853	
36423	3191	4293740	1976-08-31	1976-08-31 00:00:00	38000275	0	\N	\N	212388	0	384700001	4293740	
60439	5222	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	347435	0	180256009	4107731	
48710	4279	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	283968	0	180256009	4107731	
48986	4305	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	285655	0	180256009	4107731	
49138	4312	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	286168	0	180256009	4107731	
49220	4313	4107731	1990-07-14	1990-07-14 00:00:00	38000275	0	\N	\N	286350	0	180256009	4107731	
49473	4348	4125906	1995-11-07	1995-11-07 00:00:00	38000275	0	\N	\N	288326	0	288086009	4125906	
49774	4366	4170947	1996-11-12	1996-11-12 00:00:00	38000275	0	\N	\N	289595	0	274474001	4170947	
61930	5343	4107731	1998-06-07	1998-06-07 00:00:00	38000275	0	\N	\N	355913	0	180256009	4107731	
50154	4373	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	290423	0	180256009	4107731	
50635	4411	4170947	1950-01-20	1950-01-20 00:00:00	38000275	0	\N	\N	293248	0	274474001	4170947	
50695	4412	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	293407	0	180256009	4107731	
39514	3477	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	230633	0	180256009	4107731	
51799	4490	4216130	1988-04-23	1988-04-23 00:00:00	38000275	0	\N	\N	298886	0	415070008	4216130	
51869	4500	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	299535	0	180256009	4107731	
52092	4514	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	300652	0	180256009	4107731	
40567	3566	4107731	1993-02-08	1993-02-08 00:00:00	38000275	0	\N	\N	236967	0	180256009	4107731	
52646	4580	4151422	1967-05-26	1967-05-26 00:00:00	38000275	0	\N	\N	305119	0	269911007	4151422	
40983	3593	4170947	1953-03-14	1953-03-14 00:00:00	38000275	0	\N	\N	238686	0	274474001	4170947	
41315	3625	4078793	2016-09-27	2016-09-27 00:00:00	38000275	0	\N	\N	241074	0	180325003	4078793	
53391	4636	4151422	1963-10-18	1963-10-18 00:00:00	38000275	0	\N	\N	308933	0	269911007	4151422	
53823	4675	4078793	2011-02-06	2011-02-06 00:00:00	38000275	0	\N	\N	311574	0	180325003	4078793	
53953	4689	4252419	2017-02-09	2017-02-09 00:00:00	38000275	0	\N	\N	312396	0	74016001	4252419	
54175	4704	4243062	1982-09-04	1982-09-04 00:00:00	38000275	0	\N	\N	313431	0	60027007	4243062	
42577	3754	4107731	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	249515	0	180256009	4107731	
54668	4745	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	315924	0	180256009	4107731	
54911	4761	4107731	1993-08-23	1993-08-23 00:00:00	38000275	0	\N	\N	317224	0	180256009	4107731	
43340	3823	4078793	2011-02-09	2011-02-09 00:00:00	38000275	0	\N	\N	253984	0	180325003	4078793	
43545	3857	4035793	1997-04-01	1997-04-01 00:00:00	38000275	0	\N	\N	256019	0	15081005	4035793	
56037	4890	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	325085	0	180256009	4107731	
32350	2841	4216130	1994-08-21	1994-08-21 00:00:00	38000275	0	\N	\N	188636	0	415070008	4216130	
45143	3968	4202451	1972-07-07	1972-07-07 00:00:00	38000275	0	\N	\N	263836	0	433112001	4202451	
57299	4970	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	330496	0	180256009	4107731	
57635	4992	4043071	1995-08-20	1995-08-20 00:00:00	38000275	0	\N	\N	332141	0	228557008	4043071	
58051	5037	4295880	2002-10-30	2002-10-30 00:00:00	38000275	0	\N	\N	334816	0	76601001	4295880	
58211	5048	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	335467	0	180256009	4107731	
58424	5051	4107731	1991-06-06	1991-06-06 00:00:00	38000275	0	\N	\N	335909	0	180256009	4107731	
58807	5104	4043071	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	339212	0	228557008	4043071	
59178	5119	4191853	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	340417	0	395142003	4191853	
59635	5165	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	343284	0	180256009	4107731	
35988	3158	4043071	1964-01-23	1964-01-23 00:00:00	38000275	0	\N	\N	209909	0	228557008	4043071	
48154	4224	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	280575	0	180256009	4107731	
36424	3191	4202451	2015-09-24	2015-09-24 00:00:00	38000275	0	\N	\N	212402	0	433112001	4202451	
60440	5222	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	347447	0	180256009	4107731	
48711	4279	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	283967	0	180256009	4107731	
48987	4305	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	285579	0	180256009	4107731	
49139	4312	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	286167	0	180256009	4107731	
49221	4313	4107731	1990-04-21	1990-04-21 00:00:00	38000275	0	\N	\N	286313	0	180256009	4107731	
49474	4349	4293740	1987-01-10	1987-01-10 00:00:00	38000275	0	\N	\N	288400	0	384700001	4293740	
49775	4366	4024289	1996-11-12	1996-11-12 00:00:00	38000275	0	\N	\N	289595	0	19490002	4024289	
61931	5343	4170947	1998-09-10	1998-09-10 00:00:00	38000275	0	\N	\N	355928	0	274474001	4170947	
50155	4373	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	290359	0	180256009	4107731	
50636	4411	4243062	1953-10-31	1953-10-31 00:00:00	38000275	0	\N	\N	293249	0	60027007	4243062	
50696	4412	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	293330	0	180256009	4107731	
39515	3477	4151422	1969-03-18	1969-03-18 00:00:00	38000275	0	\N	\N	230600	0	269911007	4151422	
51870	4500	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	299650	0	180256009	4107731	
52093	4514	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	300599	0	180256009	4107731	
40568	3566	4107731	1991-02-04	1991-02-04 00:00:00	38000275	0	\N	\N	236958	0	180256009	4107731	
52647	4580	4275113	1984-02-09	1984-02-09 00:00:00	38000275	0	\N	\N	305116	0	65200003	4275113	
40991	3595	4125906	1987-07-29	1987-07-29 00:00:00	38000275	0	\N	\N	238832	0	288086009	4125906	
41316	3625	4125906	1960-01-14	1960-01-14 00:00:00	38000275	0	\N	\N	241056	0	288086009	4125906	
53392	4637	4125906	2011-12-25	2011-12-25 00:00:00	38000275	0	\N	\N	309050	0	288086009	4125906	
53824	4675	4078793	2007-01-14	2007-01-14 00:00:00	38000275	0	\N	\N	311572	0	180325003	4078793	
53954	4689	4125906	2005-12-27	2005-12-27 00:00:00	38000275	0	\N	\N	312394	0	288086009	4125906	
54176	4704	4125906	1998-04-13	1998-04-13 00:00:00	38000275	0	\N	\N	313432	0	288086009	4125906	
42579	3756	4198190	2017-12-03	2017-12-03 00:00:00	38000275	0	\N	\N	249610	0	80146002	4198190	
54669	4745	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	315923	0	180256009	4107731	
54912	4761	4107731	1994-10-17	1994-10-17 00:00:00	38000275	0	\N	\N	317220	0	180256009	4107731	
43341	3823	4125906	2009-01-27	2009-01-27 00:00:00	38000275	0	\N	\N	253974	0	288086009	4125906	
43546	3857	4337138	1999-09-07	1999-09-07 00:00:00	38000275	0	\N	\N	256026	0	88039007	4337138	
56038	4890	4078793	2017-01-18	2017-01-18 00:00:00	38000275	0	\N	\N	325077	0	180325003	4078793	
32351	2841	4336464	1994-08-21	1994-08-21 00:00:00	38000275	0	\N	\N	188636	0	232717009	4336464	
45144	3968	4078793	2018-08-03	2018-08-03 00:00:00	38000275	0	\N	\N	263804	0	180325003	4078793	
57300	4970	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	330370	0	180256009	4107731	
57636	4992	4043071	1996-05-12	1996-05-12 00:00:00	38000275	0	\N	\N	332120	0	228557008	4043071	
58052	5037	4295880	2000-05-03	2000-05-03 00:00:00	38000275	0	\N	\N	334729	0	76601001	4295880	
58212	5048	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	335527	0	180256009	4107731	
58425	5051	4107731	1992-03-26	1992-03-26 00:00:00	38000275	0	\N	\N	335863	0	180256009	4107731	
58808	5104	4043071	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	339164	0	228557008	4043071	
59179	5119	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	340322	0	180256009	4107731	
59636	5165	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	343291	0	180256009	4107731	
35989	3158	4151422	1985-10-20	1985-10-20 00:00:00	38000275	0	\N	\N	209965	0	269911007	4151422	
48155	4224	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	280463	0	180256009	4107731	
36425	3191	4151422	1992-05-26	1992-05-26 00:00:00	38000275	0	\N	\N	212345	0	269911007	4151422	
60441	5222	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	347455	0	180256009	4107731	
48712	4279	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	283970	0	180256009	4107731	
48988	4305	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	285600	0	180256009	4107731	
49140	4312	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	286095	0	180256009	4107731	
49222	4313	4107731	1991-11-09	1991-11-09 00:00:00	38000275	0	\N	\N	286324	0	180256009	4107731	
49475	4349	4125906	1987-01-10	1987-01-10 00:00:00	38000275	0	\N	\N	288400	0	288086009	4125906	
49776	4366	4107731	1994-12-27	1994-12-27 00:00:00	38000275	0	\N	\N	289624	0	180256009	4107731	
61932	5343	4047491	1998-09-10	1998-09-10 00:00:00	38000275	0	\N	\N	355928	0	1225002	4047491	
50156	4373	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	290388	0	180256009	4107731	
50637	4411	4170947	1953-10-31	1953-10-31 00:00:00	38000275	0	\N	\N	293249	0	274474001	4170947	
50697	4412	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	293401	0	180256009	4107731	
39516	3477	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	230637	0	180256009	4107731	
51871	4500	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	299539	0	180256009	4107731	
52094	4514	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	300687	0	180256009	4107731	
40569	3566	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	236937	0	180256009	4107731	
40992	3595	4293740	1987-07-29	1987-07-29 00:00:00	38000275	0	\N	\N	238832	0	384700001	4293740	
41317	3625	4058899	1968-07-21	1968-07-21 00:00:00	38000275	0	\N	\N	241057	0	168594001	4058899	
53393	4637	4151422	1988-05-09	1988-05-09 00:00:00	38000275	0	\N	\N	309013	0	269911007	4151422	
53825	4675	4057420	2013-02-17	2013-02-17 00:00:00	38000275	0	\N	\N	311575	0	18286008	4057420	
53955	4689	4043071	1981-06-03	1981-06-03 00:00:00	38000275	0	\N	\N	312440	0	228557008	4043071	
54177	4704	4151422	1982-01-03	1982-01-03 00:00:00	38000275	0	\N	\N	313412	0	269911007	4151422	
42580	3756	4035793	2017-07-15	2017-07-15 00:00:00	38000275	0	\N	\N	249709	0	15081005	4035793	
54670	4745	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	315935	0	180256009	4107731	
54913	4761	4191853	1996-11-11	1996-11-11 00:00:00	38000275	0	\N	\N	317251	0	395142003	4191853	
43342	3823	4163872	2014-05-20	2014-05-20 00:00:00	38000275	0	\N	\N	253924	0	399208008	4163872	
43547	3857	4035793	2009-09-08	2009-09-08 00:00:00	38000275	0	\N	\N	256004	0	15081005	4035793	
56039	4890	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	325096	0	180256009	4107731	
44133	3884	4107731	1992-06-22	1992-06-22 00:00:00	38000275	0	\N	\N	258149	0	180256009	4107731	
45145	3968	4078793	2014-07-11	2014-07-11 00:00:00	38000275	0	\N	\N	263802	0	180325003	4078793	
57301	4970	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	330368	0	180256009	4107731	
57637	4992	4043071	1995-10-29	1995-10-29 00:00:00	38000275	0	\N	\N	332119	0	228557008	4043071	
58053	5037	4295880	1994-05-11	1994-05-11 00:00:00	38000275	0	\N	\N	334723	0	76601001	4295880	
58213	5048	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	335441	0	395142003	4191853	
58426	5051	4107731	1994-04-21	1994-04-21 00:00:00	38000275	0	\N	\N	335888	0	180256009	4107731	
58815	5107	4151422	1997-10-05	1997-10-05 00:00:00	38000275	0	\N	\N	339320	0	269911007	4151422	
59180	5119	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	340381	0	180256009	4107731	
59637	5165	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	343258	0	180256009	4107731	
35990	3158	4043071	1964-09-17	1964-09-17 00:00:00	38000275	0	\N	\N	209933	0	228557008	4043071	
48156	4224	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	280536	0	180256009	4107731	
36427	3194	4125906	1954-05-04	1954-05-04 00:00:00	38000275	0	\N	\N	212459	0	288086009	4125906	
60442	5222	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	347388	0	180256009	4107731	
48713	4279	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	283965	0	180256009	4107731	
48989	4305	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	285551	0	180256009	4107731	
49141	4312	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	286152	0	180256009	4107731	
49223	4313	4107731	1992-06-06	1992-06-06 00:00:00	38000275	0	\N	\N	286241	0	180256009	4107731	
49476	4349	4243062	1984-11-21	1984-11-21 00:00:00	38000275	0	\N	\N	288399	0	60027007	4243062	
49777	4366	4107731	1995-10-17	1995-10-17 00:00:00	38000275	0	\N	\N	289688	0	180256009	4107731	
61933	5343	4107731	1996-11-17	1996-11-17 00:00:00	38000275	0	\N	\N	355881	0	180256009	4107731	
50157	4373	4197460	1976-07-04	1976-07-04 00:00:00	38000275	0	\N	\N	290372	0	313191000	4197460	
50638	4411	4195803	2014-11-24	2014-11-24 00:00:00	38000275	0	\N	\N	293251	0	312681000	4195803	
50698	4412	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	293328	0	180256009	4107731	
39524	3481	4336464	2015-04-04	2015-04-04 00:00:00	38000275	0	\N	\N	230888	0	232717009	4336464	
51872	4500	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	299611	0	180256009	4107731	
52095	4514	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	300653	0	180256009	4107731	
40570	3566	4107731	1990-12-03	1990-12-03 00:00:00	38000275	0	\N	\N	236886	0	180256009	4107731	
40993	3595	4151422	1973-03-31	1973-03-31 00:00:00	38000275	0	\N	\N	238779	0	269911007	4151422	
53187	4621	4125906	1989-09-30	1989-09-30 00:00:00	38000275	0	\N	\N	307743	0	288086009	4125906	
53394	4637	4125906	1989-08-10	1989-08-10 00:00:00	38000275	0	\N	\N	309045	0	288086009	4125906	
53826	4675	4078793	2010-01-31	2010-01-31 00:00:00	38000275	0	\N	\N	311531	0	180325003	4078793	
53956	4689	4125906	1994-08-07	1994-08-07 00:00:00	38000275	0	\N	\N	312393	0	288086009	4125906	
54178	4705	4170947	1975-11-27	1975-11-27 00:00:00	38000275	0	\N	\N	313434	0	274474001	4170947	
42581	3756	4035793	2015-07-04	2015-07-04 00:00:00	38000275	0	\N	\N	249708	0	15081005	4035793	
54671	4745	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	315936	0	180256009	4107731	
54914	4761	4107731	1994-01-17	1994-01-17 00:00:00	38000275	0	\N	\N	317217	0	180256009	4107731	
43343	3823	4243062	1976-01-21	1976-01-21 00:00:00	38000275	0	\N	\N	253973	0	60027007	4243062	
43548	3857	4035793	1997-01-21	1997-01-21 00:00:00	38000275	0	\N	\N	256001	0	15081005	4035793	
56040	4890	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	325099	0	180256009	4107731	
44134	3884	4043071	1988-11-26	1988-11-26 00:00:00	38000275	0	\N	\N	258132	0	228557008	4043071	
45146	3968	4078793	2017-07-28	2017-07-28 00:00:00	38000275	0	\N	\N	263875	0	180325003	4078793	
57302	4970	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	330454	0	180256009	4107731	
57638	4992	4043071	1997-01-19	1997-01-19 00:00:00	38000275	0	\N	\N	332146	0	228557008	4043071	
58054	5037	4295880	2004-07-28	2004-07-28 00:00:00	38000275	0	\N	\N	334766	0	76601001	4295880	
58214	5048	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	335474	0	180256009	4107731	
58427	5051	4107731	1993-11-25	1993-11-25 00:00:00	38000275	0	\N	\N	335920	0	180256009	4107731	
58816	5108	4047491	1974-03-14	1974-03-14 00:00:00	38000275	0	\N	\N	339382	0	1225002	4047491	
59181	5119	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	340307	0	180256009	4107731	
59638	5165	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	343326	0	180256009	4107731	
35991	3158	4043071	1965-02-18	1965-02-18 00:00:00	38000275	0	\N	\N	209913	0	228557008	4043071	
48157	4224	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	280488	0	180256009	4107731	
36428	3194	4125906	1950-07-03	1950-07-03 00:00:00	38000275	0	\N	\N	212458	0	288086009	4125906	
60443	5222	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	347446	0	180256009	4107731	
48714	4279	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	284032	0	180256009	4107731	
48990	4305	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	285527	0	180256009	4107731	
49142	4312	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	286084	0	180256009	4107731	
49224	4313	4107731	1990-10-06	1990-10-06 00:00:00	38000275	0	\N	\N	286352	0	180256009	4107731	
49477	4349	4170947	1984-11-21	1984-11-21 00:00:00	38000275	0	\N	\N	288399	0	274474001	4170947	
49778	4366	4107731	1995-04-11	1995-04-11 00:00:00	38000275	0	\N	\N	289698	0	180256009	4107731	
61934	5343	4107731	1996-09-15	1996-09-15 00:00:00	38000275	0	\N	\N	355819	0	180256009	4107731	
50158	4373	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	290406	0	180256009	4107731	
50639	4411	4047491	2014-11-24	2014-11-24 00:00:00	38000275	0	\N	\N	293251	0	1225002	4047491	
50699	4412	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	293349	0	180256009	4107731	
39525	3481	4216130	2015-04-04	2015-04-04 00:00:00	38000275	0	\N	\N	230888	0	415070008	4216130	
51873	4500	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	299572	0	180256009	4107731	
52096	4514	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	300592	0	180256009	4107731	
40571	3566	4107731	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	236833	0	180256009	4107731	
40994	3595	4243062	1985-06-09	1985-06-09 00:00:00	38000275	0	\N	\N	238831	0	60027007	4243062	
53188	4621	4125906	1978-04-17	1978-04-17 00:00:00	38000275	0	\N	\N	307741	0	288086009	4125906	
53395	4637	4151422	2009-05-28	2009-05-28 00:00:00	38000275	0	\N	\N	309018	0	269911007	4151422	
53827	4675	4078793	2000-12-10	2000-12-10 00:00:00	38000275	0	\N	\N	311516	0	180325003	4078793	
53957	4689	4125906	1972-01-13	1972-01-13 00:00:00	38000275	0	\N	\N	312392	0	288086009	4125906	
54179	4705	4243062	1975-11-27	1975-11-27 00:00:00	38000275	0	\N	\N	313434	0	60027007	4243062	
42582	3756	4035793	2018-07-21	2018-07-21 00:00:00	38000275	0	\N	\N	249694	0	15081005	4035793	
54672	4745	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	315929	0	180256009	4107731	
54915	4761	4107731	1994-08-15	1994-08-15 00:00:00	38000275	0	\N	\N	317315	0	180256009	4107731	
43344	3823	4170947	1976-01-21	1976-01-21 00:00:00	38000275	0	\N	\N	253973	0	274474001	4170947	
43549	3857	4035793	1996-01-16	1996-01-16 00:00:00	38000275	0	\N	\N	255987	0	15081005	4035793	
56041	4890	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	325117	0	180256009	4107731	
44135	3884	4043071	1989-06-03	1989-06-03 00:00:00	38000275	0	\N	\N	258139	0	228557008	4043071	
45147	3968	4125906	1936-10-29	1936-10-29 00:00:00	38000275	0	\N	\N	263902	0	288086009	4125906	
57303	4970	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	330377	0	180256009	4107731	
57639	4992	4043071	1997-07-06	1997-07-06 00:00:00	38000275	0	\N	\N	332152	0	228557008	4043071	
58055	5037	4059978	2000-12-22	2000-12-22 00:00:00	38000275	0	\N	\N	334762	0	169553002	4059978	
58215	5048	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	335510	0	180256009	4107731	
58428	5051	4107731	1994-03-31	1994-03-31 00:00:00	38000275	0	\N	\N	335835	0	180256009	4107731	
58817	5108	4170947	1974-03-14	1974-03-14 00:00:00	38000275	0	\N	\N	339382	0	274474001	4170947	
59182	5119	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	340352	0	180256009	4107731	
59639	5165	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	343261	0	180256009	4107731	
35992	3158	4043071	1965-11-18	1965-11-18 00:00:00	38000275	0	\N	\N	209915	0	228557008	4043071	
48158	4224	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	280492	0	180256009	4107731	
36429	3194	40492359	1983-03-28	1983-03-28 00:00:00	38000275	0	\N	\N	212460	0	447365002	40492359	
60444	5222	4078793	2016-08-11	2016-08-11 00:00:00	38000275	0	\N	\N	347428	0	180325003	4078793	
48715	4279	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	283991	0	180256009	4107731	
48991	4305	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	285595	0	180256009	4107731	
49143	4312	4197460	1978-06-09	1978-06-09 00:00:00	38000275	0	\N	\N	286123	0	313191000	4197460	
49225	4313	4107731	1990-06-02	1990-06-02 00:00:00	38000275	0	\N	\N	286315	0	180256009	4107731	
49551	4352	4170947	1965-11-27	1965-11-27 00:00:00	38000275	0	\N	\N	288648	0	274474001	4170947	
49779	4366	4107731	1996-01-09	1996-01-09 00:00:00	38000275	0	\N	\N	289701	0	180256009	4107731	
61935	5343	4107731	1996-03-10	1996-03-10 00:00:00	38000275	0	\N	\N	355833	0	180256009	4107731	
50159	4373	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	290360	0	180256009	4107731	
50640	4411	4170947	2014-11-24	2014-11-24 00:00:00	38000275	0	\N	\N	293251	0	274474001	4170947	
50700	4412	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	293367	0	180256009	4107731	
39526	3481	4125906	2007-07-02	2007-07-02 00:00:00	38000275	0	\N	\N	230887	0	288086009	4125906	
51874	4500	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	299620	0	180256009	4107731	
52097	4514	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	300636	0	180256009	4107731	
40572	3566	4107731	1991-03-18	1991-03-18 00:00:00	38000275	0	\N	\N	236959	0	180256009	4107731	
40995	3595	4170947	1985-06-09	1985-06-09 00:00:00	38000275	0	\N	\N	238831	0	274474001	4170947	
53189	4621	4181917	1976-07-26	1976-07-26 00:00:00	38000275	0	\N	\N	307740	0	54550000	4181917	
53462	4639	4199276	1997-12-12	1997-12-12 00:00:00	38000275	0	\N	\N	309224	0	301807007	4199276	
53828	4675	4151422	1988-09-22	1988-09-22 00:00:00	38000275	0	\N	\N	311433	0	269911007	4151422	
53958	4689	4293740	1972-01-13	1972-01-13 00:00:00	38000275	0	\N	\N	312392	0	384700001	4293740	
54180	4705	4151422	1997-07-14	1997-07-14 00:00:00	38000275	0	\N	\N	313479	0	269911007	4151422	
42583	3756	4035793	2013-06-22	2013-06-22 00:00:00	38000275	0	\N	\N	249662	0	15081005	4035793	
54673	4745	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	315920	0	180256009	4107731	
54916	4761	4107731	1994-05-02	1994-05-02 00:00:00	38000275	0	\N	\N	317272	0	180256009	4107731	
43345	3823	4078793	2015-06-03	2015-06-03 00:00:00	38000275	0	\N	\N	253919	0	180325003	4078793	
43550	3857	4035793	2011-09-20	2011-09-20 00:00:00	38000275	0	\N	\N	256023	0	15081005	4035793	
56042	4890	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	325086	0	180256009	4107731	
44136	3884	4043071	1986-03-22	1986-03-22 00:00:00	38000275	0	\N	\N	258124	0	228557008	4043071	
45185	3972	4170947	1967-10-26	1967-10-26 00:00:00	38000275	0	\N	\N	264134	0	274474001	4170947	
57304	4970	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	330417	0	180256009	4107731	
57640	4992	4151422	2004-05-07	2004-05-07 00:00:00	38000275	0	\N	\N	332090	0	269911007	4151422	
58056	5037	4295880	2003-04-30	2003-04-30 00:00:00	38000275	0	\N	\N	334733	0	76601001	4295880	
58216	5048	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	335522	0	180256009	4107731	
58429	5051	4107731	1991-01-10	1991-01-10 00:00:00	38000275	0	\N	\N	335900	0	180256009	4107731	
58818	5108	4151422	2002-11-14	2002-11-14 00:00:00	38000275	0	\N	\N	339400	0	269911007	4151422	
59183	5119	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	340348	0	180256009	4107731	
59640	5165	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	343257	0	395142003	4191853	
35993	3158	4043071	1966-09-29	1966-09-29 00:00:00	38000275	0	\N	\N	209985	0	228557008	4043071	
48159	4224	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	280547	0	180256009	4107731	
36430	3194	4057420	1983-03-28	1983-03-28 00:00:00	38000275	0	\N	\N	212460	0	18286008	4057420	
60445	5222	4035793	2016-08-11	2016-08-11 00:00:00	38000275	0	\N	\N	347428	0	15081005	4035793	
48716	4279	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	283984	0	180256009	4107731	
48992	4305	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	285594	0	180256009	4107731	
49144	4312	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	286219	0	180256009	4107731	
49226	4313	4107731	1990-03-31	1990-03-31 00:00:00	38000275	0	\N	\N	286293	0	180256009	4107731	
49552	4352	4047491	1965-11-27	1965-11-27 00:00:00	38000275	0	\N	\N	288648	0	1225002	4047491	
49780	4366	4107731	1994-09-13	1994-09-13 00:00:00	38000275	0	\N	\N	289682	0	180256009	4107731	
61936	5343	4295880	1998-06-28	1998-06-28 00:00:00	38000275	0	\N	\N	355889	0	76601001	4295880	
50160	4373	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	290404	0	180256009	4107731	
50641	4412	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	293378	0	180256009	4107731	
50701	4412	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	293336	0	180256009	4107731	
39527	3481	4293740	2007-07-02	2007-07-02 00:00:00	38000275	0	\N	\N	230887	0	384700001	4293740	
51875	4500	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	299624	0	180256009	4107731	
52098	4514	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	300604	0	180256009	4107731	
40573	3566	4151422	1977-02-23	1977-02-23 00:00:00	38000275	0	\N	\N	236911	0	269911007	4151422	
41000	3598	4058899	1945-01-20	1945-01-20 00:00:00	38000275	0	\N	\N	238941	0	168594001	4058899	
53190	4622	4163872	1986-09-14	1986-09-14 00:00:00	38000275	0	\N	\N	307816	0	399208008	4163872	
53463	4639	4170947	1986-03-26	1986-03-26 00:00:00	38000275	0	\N	\N	309191	0	274474001	4170947	
53829	4675	4078793	2019-03-24	2019-03-24 00:00:00	38000275	0	\N	\N	311522	0	180325003	4078793	
53959	4689	4043071	1981-07-01	1981-07-01 00:00:00	38000275	0	\N	\N	312378	0	228557008	4043071	
54185	4707	4151422	1986-04-12	1986-04-12 00:00:00	38000275	0	\N	\N	313572	0	269911007	4151422	
42584	3756	4151422	1943-11-07	1943-11-07 00:00:00	38000275	0	\N	\N	249608	0	269911007	4151422	
54674	4745	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	315969	0	180256009	4107731	
54917	4761	4107731	1993-10-25	1993-10-25 00:00:00	38000275	0	\N	\N	317271	0	180256009	4107731	
43346	3823	4163872	1997-07-09	1997-07-09 00:00:00	38000275	0	\N	\N	253921	0	399208008	4163872	
43551	3857	4035793	2013-10-01	2013-10-01 00:00:00	38000275	0	\N	\N	256024	0	15081005	4035793	
56043	4890	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	325240	0	180256009	4107731	
44137	3884	4107731	1990-05-07	1990-05-07 00:00:00	38000275	0	\N	\N	258203	0	180256009	4107731	
45186	3972	4047491	1967-10-26	1967-10-26 00:00:00	38000275	0	\N	\N	264134	0	1225002	4047491	
57305	4970	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	330434	0	395142003	4191853	
57641	4992	4043071	1997-02-23	1997-02-23 00:00:00	38000275	0	\N	\N	332147	0	228557008	4043071	
58057	5037	4295880	1993-08-11	1993-08-11 00:00:00	38000275	0	\N	\N	334741	0	76601001	4295880	
58217	5048	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	335509	0	180256009	4107731	
58430	5051	4107731	1993-04-29	1993-04-29 00:00:00	38000275	0	\N	\N	335883	0	180256009	4107731	
58884	5111	4216130	1984-12-03	1984-12-03 00:00:00	38000275	0	\N	\N	339626	0	415070008	4216130	
59184	5119	4107731	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	340341	0	180256009	4107731	
59641	5165	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	343345	0	180256009	4107731	
35994	3158	4043071	1964-07-23	1964-07-23 00:00:00	38000275	0	\N	\N	210007	0	228557008	4043071	
48160	4224	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	280546	0	180256009	4107731	
36431	3195	4181917	1953-11-21	1953-11-21 00:00:00	38000275	0	\N	\N	212563	0	54550000	4181917	
60446	5222	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	347461	0	180256009	4107731	
48717	4279	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	283993	0	395142003	4191853	
48993	4305	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	285651	0	180256009	4107731	
49145	4312	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	286202	0	180256009	4107731	
49227	4313	4107731	1991-12-21	1991-12-21 00:00:00	38000275	0	\N	\N	286325	0	180256009	4107731	
49553	4352	4024289	1956-03-19	1956-03-19 00:00:00	38000275	0	\N	\N	288672	0	19490002	4024289	
49781	4366	4151422	1982-05-02	1982-05-02 00:00:00	38000275	0	\N	\N	289664	0	269911007	4151422	
61937	5343	4107731	1999-06-20	1999-06-20 00:00:00	38000275	0	\N	\N	355943	0	180256009	4107731	
50161	4373	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	290355	0	180256009	4107731	
50642	4412	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	293382	0	180256009	4107731	
50702	4412	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	293326	0	180256009	4107731	
39528	3481	40492359	2001-05-12	2001-05-12 00:00:00	38000275	0	\N	\N	230885	0	447365002	40492359	
51876	4500	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	299582	0	180256009	4107731	
52099	4514	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	300598	0	180256009	4107731	
40574	3566	4043071	1959-09-14	1959-09-14 00:00:00	38000275	0	\N	\N	236912	0	228557008	4043071	
41001	3598	4216130	2014-12-14	2014-12-14 00:00:00	38000275	0	\N	\N	238946	0	415070008	4216130	
53191	4623	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	307910	0	180256009	4107731	
53464	4639	4024289	1986-03-26	1986-03-26 00:00:00	38000275	0	\N	\N	309191	0	19490002	4024289	
53830	4675	4024289	2012-07-12	2012-07-12 00:00:00	38000275	0	\N	\N	311450	0	19490002	4024289	
53960	4689	4202451	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	312415	0	433112001	4202451	
54186	4707	4170947	1977-03-19	1977-03-19 00:00:00	38000275	0	\N	\N	313554	0	274474001	4170947	
42585	3756	4058899	1950-07-02	1950-07-02 00:00:00	38000275	0	\N	\N	249710	0	168594001	4058899	
54675	4745	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	315956	0	180256009	4107731	
54918	4761	4107731	1996-10-21	1996-10-21 00:00:00	38000275	0	\N	\N	317288	0	180256009	4107731	
43347	3823	4170947	1959-05-20	1959-05-20 00:00:00	38000275	0	\N	\N	253972	0	274474001	4170947	
43552	3857	4035793	2000-07-18	2000-07-18 00:00:00	38000275	0	\N	\N	256021	0	15081005	4035793	
56044	4890	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	325245	0	180256009	4107731	
44138	3884	4043071	1988-04-23	1988-04-23 00:00:00	38000275	0	\N	\N	258088	0	228557008	4043071	
45187	3973	4170947	2005-07-09	2005-07-09 00:00:00	38000275	0	\N	\N	264219	0	274474001	4170947	
57306	4970	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	330421	0	180256009	4107731	
57642	4992	4043071	1996-08-11	1996-08-11 00:00:00	38000275	0	\N	\N	332144	0	228557008	4043071	
58058	5037	4295880	2005-07-27	2005-07-27 00:00:00	38000275	0	\N	\N	334780	0	76601001	4295880	
58218	5048	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	335542	0	180256009	4107731	
58431	5051	4107731	1991-07-18	1991-07-18 00:00:00	38000275	0	\N	\N	335910	0	180256009	4107731	
58885	5111	4336464	1984-12-03	1984-12-03 00:00:00	38000275	0	\N	\N	339626	0	232717009	4336464	
59185	5119	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	340359	0	180256009	4107731	
59642	5165	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	343263	0	180256009	4107731	
35995	3158	4043071	1963-09-19	1963-09-19 00:00:00	38000275	0	\N	\N	210004	0	228557008	4043071	
48161	4224	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	280487	0	180256009	4107731	
36432	3195	44783196	2015-09-14	2015-09-14 00:00:00	38000275	0	\N	\N	212562	0	699253003	44783196	
60447	5222	4078793	2009-10-22	2009-10-22 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
48718	4279	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	284043	0	180256009	4107731	
48994	4305	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	285649	0	180256009	4107731	
49146	4312	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	286205	0	180256009	4107731	
49228	4317	4058899	1961-11-19	1961-11-19 00:00:00	38000275	0	\N	\N	286477	0	168594001	4058899	
49554	4352	4170947	1956-03-19	1956-03-19 00:00:00	38000275	0	\N	\N	288672	0	274474001	4170947	
49782	4366	4107731	1996-08-06	1996-08-06 00:00:00	38000275	0	\N	\N	289631	0	180256009	4107731	
61938	5343	4107731	1998-06-28	1998-06-28 00:00:00	38000275	0	\N	\N	355889	0	180256009	4107731	
50162	4373	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	290350	0	180256009	4107731	
50643	4412	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	293337	0	180256009	4107731	
50703	4412	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	293413	0	180256009	4107731	
39529	3481	4057420	2001-05-12	2001-05-12 00:00:00	38000275	0	\N	\N	230885	0	18286008	4057420	
51877	4500	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	299613	0	180256009	4107731	
52100	4514	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	300627	0	180256009	4107731	
40575	3566	4043071	1961-03-06	1961-03-06 00:00:00	38000275	0	\N	\N	236867	0	228557008	4043071	
41002	3598	4336464	2014-12-14	2014-12-14 00:00:00	38000275	0	\N	\N	238946	0	232717009	4336464	
53192	4623	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	307986	0	180256009	4107731	
53465	4639	4059978	1996-12-10	1996-12-10 00:00:00	38000275	0	\N	\N	309223	0	169553002	4059978	
53831	4675	4170947	2012-07-12	2012-07-12 00:00:00	38000275	0	\N	\N	311450	0	274474001	4170947	
53961	4690	4125906	2007-05-05	2007-05-05 00:00:00	38000275	0	\N	\N	312471	0	288086009	4125906	
54187	4707	4163872	1977-03-19	1977-03-19 00:00:00	38000275	0	\N	\N	313554	0	399208008	4163872	
42586	3756	4035793	2014-06-28	2014-06-28 00:00:00	38000275	0	\N	\N	249692	0	15081005	4035793	
54676	4745	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	315937	0	180256009	4107731	
54919	4761	4107731	1994-11-28	1994-11-28 00:00:00	38000275	0	\N	\N	317225	0	180256009	4107731	
43348	3823	4024289	1959-05-20	1959-05-20 00:00:00	38000275	0	\N	\N	253972	0	19490002	4024289	
43553	3857	4035793	2001-07-24	2001-07-24 00:00:00	38000275	0	\N	\N	255995	0	15081005	4035793	
56045	4890	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	325113	0	180256009	4107731	
44139	3884	4151422	1997-01-12	1997-01-12 00:00:00	38000275	0	\N	\N	258055	0	269911007	4151422	
45188	3973	4024289	2005-07-09	2005-07-09 00:00:00	38000275	0	\N	\N	264219	0	19490002	4024289	
57307	4970	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	330332	0	180256009	4107731	
57643	4992	4043071	1996-11-10	1996-11-10 00:00:00	38000275	0	\N	\N	332113	0	228557008	4043071	
58059	5037	4295880	1992-02-08	1992-02-08 00:00:00	38000275	0	\N	\N	334720	0	76601001	4295880	
58219	5048	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	335508	0	180256009	4107731	
58432	5051	4107731	1993-02-04	1993-02-04 00:00:00	38000275	0	\N	\N	335867	0	180256009	4107731	
58886	5111	4151422	1948-09-10	1948-09-10 00:00:00	38000275	0	\N	\N	339600	0	269911007	4151422	
59186	5119	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	340389	0	180256009	4107731	
59643	5165	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	343285	0	180256009	4107731	
35996	3158	4043071	1967-03-02	1967-03-02 00:00:00	38000275	0	\N	\N	209987	0	228557008	4043071	
48162	4224	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	280545	0	180256009	4107731	
36433	3195	4151422	1968-02-13	1968-02-13 00:00:00	38000275	0	\N	\N	212511	0	269911007	4151422	
60448	5222	4078793	2008-03-06	2008-03-06 00:00:00	38000275	0	\N	\N	347348	0	180325003	4078793	
48719	4279	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	283966	0	180256009	4107731	
60793	5264	4058899	1977-09-08	1977-09-08 00:00:00	38000275	0	\N	\N	350204	0	168594001	4058899	
49147	4312	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	286165	0	180256009	4107731	
49229	4317	4151422	1977-11-23	1977-11-23 00:00:00	38000275	0	\N	\N	286508	0	269911007	4151422	
49555	4353	4043071	1977-09-07	1977-09-07 00:00:00	38000275	0	\N	\N	288749	0	228557008	4043071	
49783	4366	4107731	1995-07-04	1995-07-04 00:00:00	38000275	0	\N	\N	289625	0	180256009	4107731	
61939	5343	4107731	1997-11-09	1997-11-09 00:00:00	38000275	0	\N	\N	355898	0	180256009	4107731	
50163	4373	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	290349	0	180256009	4107731	
50644	4412	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	293381	0	180256009	4107731	
50704	4412	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	293400	0	180256009	4107731	
39530	3481	4125906	1981-04-09	1981-04-09 00:00:00	38000275	0	\N	\N	230872	0	288086009	4125906	
51878	4500	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	299647	0	180256009	4107731	
52101	4514	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	300682	0	180256009	4107731	
40576	3566	4107731	1992-10-26	1992-10-26 00:00:00	38000275	0	\N	\N	236936	0	180256009	4107731	
41003	3598	4170947	1985-02-19	1985-02-19 00:00:00	38000275	0	\N	\N	238944	0	274474001	4170947	
53193	4623	4191853	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	307872	0	395142003	4191853	
53466	4641	4125906	2017-07-20	2017-07-20 00:00:00	38000275	0	\N	\N	309338	0	288086009	4125906	
53832	4675	4078793	2003-12-28	2003-12-28 00:00:00	38000275	0	\N	\N	311518	0	180325003	4078793	
53962	4690	4170947	1959-02-24	1959-02-24 00:00:00	38000275	0	\N	\N	312519	0	274474001	4170947	
54188	4707	4170947	2018-07-12	2018-07-12 00:00:00	38000275	0	\N	\N	313555	0	274474001	4170947	
42587	3756	4047491	2001-08-02	2001-08-02 00:00:00	38000275	0	\N	\N	249664	0	1225002	4047491	
54677	4745	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	316010	0	180256009	4107731	
54920	4761	4107731	1995-04-03	1995-04-03 00:00:00	38000275	0	\N	\N	317317	0	180256009	4107731	
43349	3823	4078793	2010-11-17	2010-11-17 00:00:00	38000275	0	\N	\N	253983	0	180325003	4078793	
43554	3857	4035793	1998-07-07	1998-07-07 00:00:00	38000275	0	\N	\N	256020	0	15081005	4035793	
56046	4890	4078793	2011-12-21	2011-12-21 00:00:00	38000275	0	\N	\N	325167	0	180325003	4078793	
44140	3884	4043071	1990-01-13	1990-01-13 00:00:00	38000275	0	\N	\N	258060	0	228557008	4043071	
45189	3973	4078793	2018-08-30	2018-08-30 00:00:00	38000275	0	\N	\N	264215	0	180325003	4078793	
57308	4970	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	330447	0	180256009	4107731	
57644	4992	4043071	1996-03-10	1996-03-10 00:00:00	38000275	0	\N	\N	332142	0	228557008	4043071	
58060	5037	4295880	2001-01-31	2001-01-31 00:00:00	38000275	0	\N	\N	334730	0	76601001	4295880	
58220	5048	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	335531	0	180256009	4107731	
58433	5051	4107731	1993-09-02	1993-09-02 00:00:00	38000275	0	\N	\N	335886	0	180256009	4107731	
58891	5113	4181917	1977-05-21	1977-05-21 00:00:00	38000275	0	\N	\N	339724	0	54550000	4181917	
59187	5119	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	340316	0	395142003	4191853	
59644	5165	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	343305	0	180256009	4107731	
35997	3158	4043071	1964-11-19	1964-11-19 00:00:00	38000275	0	\N	\N	210015	0	228557008	4043071	
48163	4224	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	280554	0	180256009	4107731	
36434	3195	4252419	2015-09-07	2015-09-07 00:00:00	38000275	0	\N	\N	212594	0	74016001	4252419	
60449	5222	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	347360	0	180256009	4107731	
48720	4279	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	284048	0	180256009	4107731	
60794	5265	4125906	2008-03-12	2008-03-12 00:00:00	38000275	0	\N	\N	350270	0	288086009	4125906	
49148	4312	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	286154	0	180256009	4107731	
49230	4317	4145310	1998-11-05	1998-11-05 00:00:00	38000275	0	\N	\N	286479	0	268425006	4145310	
61502	5322	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	354093	0	180256009	4107731	
49784	4366	4107731	1996-11-19	1996-11-19 00:00:00	38000275	0	\N	\N	289724	0	180256009	4107731	
61940	5343	4107731	1998-10-11	1998-10-11 00:00:00	38000275	0	\N	\N	355924	0	180256009	4107731	
50164	4373	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	290344	0	180256009	4107731	
50645	4412	4151422	2016-03-13	2016-03-13 00:00:00	38000275	0	\N	\N	293389	0	269911007	4151422	
50705	4412	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	293345	0	180256009	4107731	
39597	3483	4043071	1963-06-17	1963-06-17 00:00:00	38000275	0	\N	\N	231095	0	228557008	4043071	
51879	4500	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	299627	0	180256009	4107731	
52102	4514	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	300633	0	180256009	4107731	
40577	3566	4107731	1991-01-14	1991-01-14 00:00:00	38000275	0	\N	\N	236887	0	180256009	4107731	
41004	3598	4024289	1985-02-19	1985-02-19 00:00:00	38000275	0	\N	\N	238944	0	19490002	4024289	
53194	4623	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	307974	0	180256009	4107731	
53467	4641	4035793	2007-07-19	2007-07-19 00:00:00	38000275	0	\N	\N	309344	0	15081005	4035793	
53833	4675	4195803	1991-10-20	1991-10-20 00:00:00	38000275	0	\N	\N	311565	0	312681000	4195803	
53963	4690	4047491	1959-02-24	1959-02-24 00:00:00	38000275	0	\N	\N	312519	0	1225002	4047491	
54189	4707	4047491	2018-07-12	2018-07-12 00:00:00	38000275	0	\N	\N	313555	0	1225002	4047491	
42588	3756	4195803	2001-08-02	2001-08-02 00:00:00	38000275	0	\N	\N	249664	0	312681000	4195803	
54678	4745	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	315904	0	180256009	4107731	
54921	4761	4058899	1998-01-01	1998-01-01 00:00:00	38000275	0	\N	\N	317237	0	168594001	4058899	
43350	3823	4078793	2012-02-15	2012-02-15 00:00:00	38000275	0	\N	\N	253960	0	180325003	4078793	
43555	3857	4035793	2005-08-16	2005-08-16 00:00:00	38000275	0	\N	\N	256002	0	15081005	4035793	
56047	4890	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	325156	0	180256009	4107731	
44141	3884	4043071	1987-09-12	1987-09-12 00:00:00	38000275	0	\N	\N	258047	0	228557008	4043071	
45191	3976	4125906	1977-05-25	1977-05-25 00:00:00	38000275	0	\N	\N	264350	0	288086009	4125906	
57309	4970	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	330444	0	180256009	4107731	
57645	4992	4043071	1997-04-27	1997-04-27 00:00:00	38000275	0	\N	\N	332150	0	228557008	4043071	
58061	5037	4295880	1994-08-10	1994-08-10 00:00:00	38000275	0	\N	\N	334784	0	76601001	4295880	
58221	5048	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	335420	0	395142003	4191853	
58434	5051	4107731	1992-04-16	1992-04-16 00:00:00	38000275	0	\N	\N	335930	0	180256009	4107731	
58892	5113	4181917	1974-03-14	1974-03-14 00:00:00	38000275	0	\N	\N	339723	0	54550000	4181917	
59188	5119	4024289	1998-08-11	1998-08-11 00:00:00	38000275	0	\N	\N	340421	0	19490002	4024289	
59645	5165	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	343381	0	180256009	4107731	
35998	3158	4043071	1966-07-21	1966-07-21 00:00:00	38000275	0	\N	\N	209939	0	228557008	4043071	
48164	4224	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	280469	0	180256009	4107731	
36435	3195	4243062	1962-04-13	1962-04-13 00:00:00	38000275	0	\N	\N	212591	0	60027007	4243062	
60450	5222	4078793	2006-02-23	2006-02-23 00:00:00	38000275	0	\N	\N	347467	0	180325003	4078793	
48721	4279	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	284035	0	180256009	4107731	
60795	5265	4125906	1970-12-08	1970-12-08 00:00:00	38000275	0	\N	\N	350326	0	288086009	4125906	
49149	4312	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	286199	0	180256009	4107731	
49231	4317	4195803	1998-11-05	1998-11-05 00:00:00	38000275	0	\N	\N	286479	0	312681000	4195803	
61503	5322	4062501	1951-01-28	1951-01-28 00:00:00	38000275	0	\N	\N	354266	0	171231001	4062501	
49785	4366	4107731	1997-02-11	1997-02-11 00:00:00	38000275	0	\N	\N	289714	0	180256009	4107731	
61941	5343	4107731	1996-04-21	1996-04-21 00:00:00	38000275	0	\N	\N	355834	0	180256009	4107731	
50165	4373	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	290402	0	180256009	4107731	
50646	4412	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	293359	0	180256009	4107731	
50706	4412	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	293396	0	180256009	4107731	
39598	3483	4043071	1962-07-30	1962-07-30 00:00:00	38000275	0	\N	\N	231093	0	228557008	4043071	
51880	4500	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	299538	0	180256009	4107731	
52103	4514	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	300595	0	180256009	4107731	
40578	3566	4043071	1960-09-26	1960-09-26 00:00:00	38000275	0	\N	\N	236814	0	228557008	4043071	
41005	3599	4301346	2015-03-23	2015-03-23 00:00:00	38000275	0	\N	\N	239071	0	387685009	4301346	
53195	4623	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	307977	0	180256009	4107731	
53468	4641	4337138	2017-09-14	2017-09-14 00:00:00	38000275	0	\N	\N	309348	0	88039007	4337138	
53834	4675	4078793	2009-01-25	2009-01-25 00:00:00	38000275	0	\N	\N	311573	0	180325003	4078793	
53964	4690	4195803	2016-10-01	2016-10-01 00:00:00	38000275	0	\N	\N	312474	0	312681000	4195803	
54190	4707	4151422	2014-03-20	2014-03-20 00:00:00	38000275	0	\N	\N	313581	0	269911007	4151422	
42589	3756	4170947	2001-08-02	2001-08-02 00:00:00	38000275	0	\N	\N	249664	0	274474001	4170947	
54679	4745	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	315902	0	180256009	4107731	
54922	4761	4107731	1994-07-04	1994-07-04 00:00:00	38000275	0	\N	\N	317314	0	180256009	4107731	
43354	3825	4125906	1965-10-11	1965-10-11 00:00:00	38000275	0	\N	\N	254065	0	288086009	4125906	
43556	3857	4035793	2008-09-02	2008-09-02 00:00:00	38000275	0	\N	\N	255964	0	15081005	4035793	
56048	4890	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	325149	0	180256009	4107731	
44142	3884	4151422	2001-08-27	2001-08-27 00:00:00	38000275	0	\N	\N	258115	0	269911007	4151422	
45192	3976	4195803	2017-11-10	2017-11-10 00:00:00	38000275	0	\N	\N	264353	0	312681000	4195803	
57310	4970	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	330376	0	180256009	4107731	
57646	4992	4043071	1997-10-05	1997-10-05 00:00:00	38000275	0	\N	\N	332153	0	228557008	4043071	
58062	5037	4295880	2001-12-17	2001-12-17 00:00:00	38000275	0	\N	\N	334763	0	76601001	4295880	
58222	5048	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	335507	0	180256009	4107731	
58435	5051	4107731	1993-07-22	1993-07-22 00:00:00	38000275	0	\N	\N	335885	0	180256009	4107731	
58893	5113	4125906	1978-12-28	1978-12-28 00:00:00	38000275	0	\N	\N	339725	0	288086009	4125906	
59189	5119	4170947	1998-08-11	1998-08-11 00:00:00	38000275	0	\N	\N	340421	0	274474001	4170947	
59646	5165	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	343266	0	180256009	4107731	
35999	3158	4043071	1964-12-24	1964-12-24 00:00:00	38000275	0	\N	\N	210016	0	228557008	4043071	
48165	4224	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	280475	0	180256009	4107731	
36436	3195	4170947	1962-04-13	1962-04-13 00:00:00	38000275	0	\N	\N	212591	0	274474001	4170947	
60451	5222	4151422	2015-07-21	2015-07-21 00:00:00	38000275	0	\N	\N	347503	0	269911007	4151422	
48722	4279	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	284070	0	180256009	4107731	
60796	5265	4057420	2008-06-05	2008-06-05 00:00:00	38000275	0	\N	\N	350271	0	18286008	4057420	
49150	4312	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	286204	0	180256009	4107731	
49232	4317	4047491	1964-10-04	1964-10-04 00:00:00	38000275	0	\N	\N	286478	0	1225002	4047491	
61504	5322	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	354092	0	180256009	4107731	
49786	4366	4107731	1995-02-07	1995-02-07 00:00:00	38000275	0	\N	\N	289676	0	180256009	4107731	
61942	5343	4295880	1998-12-27	1998-12-27 00:00:00	38000275	0	\N	\N	355840	0	76601001	4295880	
50166	4373	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	290407	0	180256009	4107731	
50647	4412	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	293398	0	180256009	4107731	
50707	4412	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	293383	0	180256009	4107731	
39599	3483	4043071	1963-07-22	1963-07-22 00:00:00	38000275	0	\N	\N	231096	0	228557008	4043071	
51881	4500	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	299568	0	180256009	4107731	
52104	4514	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	300640	0	395142003	4191853	
40579	3566	4107731	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	236844	0	180256009	4107731	
41006	3599	4151422	2018-08-29	2018-08-29 00:00:00	38000275	0	\N	\N	239033	0	269911007	4151422	
53196	4623	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	307983	0	180256009	4107731	
53469	4641	4035793	2004-09-09	2004-09-09 00:00:00	38000275	0	\N	\N	309351	0	15081005	4035793	
53835	4675	4243062	1994-07-17	1994-07-17 00:00:00	38000275	0	\N	\N	311446	0	60027007	4243062	
53965	4690	4125906	1993-05-20	1993-05-20 00:00:00	38000275	0	\N	\N	312469	0	288086009	4125906	
54191	4709	4163872	1993-08-23	1993-08-23 00:00:00	38000275	0	\N	\N	313701	0	399208008	4163872	
42590	3756	4170947	1953-06-16	1953-06-16 00:00:00	38000275	0	\N	\N	249711	0	274474001	4170947	
54680	4745	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	315932	0	180256009	4107731	
54923	4761	4107731	1993-10-04	1993-10-04 00:00:00	38000275	0	\N	\N	317311	0	180256009	4107731	
43355	3825	4202451	1998-01-02	1998-01-02 00:00:00	38000275	0	\N	\N	254062	0	433112001	4202451	
43557	3857	4035793	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	255993	0	15081005	4035793	
56049	4890	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	325184	0	180256009	4107731	
44143	3884	4107731	1991-02-04	1991-02-04 00:00:00	38000275	0	\N	\N	258206	0	180256009	4107731	
45193	3976	4170947	2017-11-10	2017-11-10 00:00:00	38000275	0	\N	\N	264353	0	274474001	4170947	
57311	4970	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	330429	0	180256009	4107731	
57647	4992	4043071	1998-01-11	1998-01-11 00:00:00	38000275	0	\N	\N	332116	0	228557008	4043071	
58063	5037	4295880	2008-01-23	2008-01-23 00:00:00	38000275	0	\N	\N	334820	0	76601001	4295880	
58223	5048	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	335535	0	180256009	4107731	
58436	5051	4191853	1994-06-02	1994-06-02 00:00:00	38000275	0	\N	\N	335889	0	395142003	4191853	
58894	5113	4125906	1981-02-06	1981-02-06 00:00:00	38000275	0	\N	\N	339726	0	288086009	4125906	
59190	5119	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	340363	0	180256009	4107731	
59647	5165	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	343274	0	180256009	4107731	
36000	3158	4043071	1967-01-05	1967-01-05 00:00:00	38000275	0	\N	\N	209932	0	228557008	4043071	
48166	4224	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	280473	0	180256009	4107731	
36437	3195	4170947	2006-11-23	2006-11-23 00:00:00	38000275	0	\N	\N	212593	0	274474001	4170947	
60452	5222	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	347390	0	180256009	4107731	
48723	4279	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	284095	0	180256009	4107731	
60797	5265	40492359	2008-06-05	2008-06-05 00:00:00	38000275	0	\N	\N	350271	0	447365002	40492359	
49151	4312	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	286049	0	180256009	4107731	
49233	4317	4047491	1954-01-30	1954-01-30 00:00:00	38000275	0	\N	\N	286476	0	1225002	4047491	
61505	5322	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	354079	0	180256009	4107731	
49787	4366	4107731	1996-04-02	1996-04-02 00:00:00	38000275	0	\N	\N	289628	0	180256009	4107731	
61943	5343	4107731	1996-12-29	1996-12-29 00:00:00	38000275	0	\N	\N	355882	0	180256009	4107731	
50167	4373	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	290408	0	180256009	4107731	
50648	4412	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	293399	0	180256009	4107731	
50708	4413	4151422	2013-06-21	2013-06-21 00:00:00	38000275	0	\N	\N	293492	0	269911007	4151422	
39600	3483	4043071	1962-03-26	1962-03-26 00:00:00	38000275	0	\N	\N	231013	0	228557008	4043071	
51882	4500	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	299622	0	180256009	4107731	
52105	4514	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	300681	0	180256009	4107731	
52361	4543	4295880	1997-11-29	1997-11-29 00:00:00	38000275	0	\N	\N	302636	0	76601001	4295880	
41007	3601	4326177	2018-06-04	2018-06-04 00:00:00	38000275	0	\N	\N	239253	0	430193006	4326177	
53197	4623	4107731	1991-02-26	1991-02-26 00:00:00	38000275	0	\N	\N	307907	0	180256009	4107731	
53470	4641	4117038	1993-05-14	1993-05-14 00:00:00	38000275	0	\N	\N	309327	0	287664005	4117038	
53836	4675	4170947	1994-07-17	1994-07-17 00:00:00	38000275	0	\N	\N	311446	0	274474001	4170947	
53966	4690	4125906	1980-02-09	1980-02-09 00:00:00	38000275	0	\N	\N	312492	0	288086009	4125906	
54192	4709	4125906	1962-03-07	1962-03-07 00:00:00	38000275	0	\N	\N	313645	0	288086009	4125906	
42591	3756	4243062	1953-06-16	1953-06-16 00:00:00	38000275	0	\N	\N	249711	0	60027007	4243062	
54681	4745	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	315965	0	180256009	4107731	
54924	4761	4107731	1995-01-30	1995-01-30 00:00:00	38000275	0	\N	\N	317275	0	180256009	4107731	
43356	3825	4170947	1956-05-31	1956-05-31 00:00:00	38000275	0	\N	\N	254107	0	274474001	4170947	
43558	3857	4035793	2004-08-10	2004-08-10 00:00:00	38000275	0	\N	\N	255989	0	15081005	4035793	
56050	4890	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	325241	0	180256009	4107731	
44144	3884	4043071	1986-11-01	1986-11-01 00:00:00	38000275	0	\N	\N	258044	0	228557008	4043071	
45194	3976	4047491	2017-11-10	2017-11-10 00:00:00	38000275	0	\N	\N	264353	0	1225002	4047491	
57312	4970	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	330430	0	180256009	4107731	
57648	4992	4043071	1998-04-26	1998-04-26 00:00:00	38000275	0	\N	\N	332083	0	228557008	4043071	
58064	5037	4295880	2000-08-02	2000-08-02 00:00:00	38000275	0	\N	\N	334761	0	76601001	4295880	
58224	5048	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	335537	0	180256009	4107731	
58437	5051	4107731	1992-10-01	1992-10-01 00:00:00	38000275	0	\N	\N	335854	0	180256009	4107731	
58895	5113	4198190	2017-03-05	2017-03-05 00:00:00	38000275	0	\N	\N	339717	0	80146002	4198190	
59191	5119	4107731	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	340353	0	180256009	4107731	
59648	5165	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	343272	0	180256009	4107731	
36001	3158	4043071	1963-11-14	1963-11-14 00:00:00	38000275	0	\N	\N	210011	0	228557008	4043071	
48167	4224	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	280464	0	180256009	4107731	
36438	3195	4195803	2006-11-23	2006-11-23 00:00:00	38000275	0	\N	\N	212593	0	312681000	4195803	
60453	5222	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	347449	0	395142003	4191853	
48724	4279	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	284061	0	180256009	4107731	
60798	5267	4107731	1998-08-15	1998-08-15 00:00:00	38000275	0	\N	\N	350441	0	180256009	4107731	
49152	4312	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	286153	0	180256009	4107731	
49234	4317	4170947	1954-01-30	1954-01-30 00:00:00	38000275	0	\N	\N	286476	0	274474001	4170947	
61506	5322	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	354167	0	180256009	4107731	
49788	4366	4107731	1995-05-02	1995-05-02 00:00:00	38000275	0	\N	\N	289678	0	180256009	4107731	
61944	5343	4125906	2016-11-04	2016-11-04 00:00:00	38000275	0	\N	\N	355930	0	288086009	4125906	
50168	4373	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	290403	0	180256009	4107731	
50649	4412	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	293332	0	180256009	4107731	
50709	4413	4151422	2012-04-18	2012-04-18 00:00:00	38000275	0	\N	\N	293480	0	269911007	4151422	
39601	3483	4043071	1964-01-06	1964-01-06 00:00:00	38000275	0	\N	\N	231020	0	228557008	4043071	
51883	4500	4125906	2003-12-16	2003-12-16 00:00:00	38000275	0	\N	\N	299605	0	288086009	4125906	
52106	4514	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	300603	0	180256009	4107731	
52362	4543	4295880	1994-12-03	1994-12-03 00:00:00	38000275	0	\N	\N	302632	0	76601001	4295880	
41008	3601	4187458	2018-06-04	2018-06-04 00:00:00	38000275	0	\N	\N	239253	0	415300000	4187458	
53198	4623	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	307911	0	180256009	4107731	
53471	4641	4035793	2018-07-19	2018-07-19 00:00:00	38000275	0	\N	\N	309353	0	15081005	4035793	
53837	4675	4078793	2005-01-02	2005-01-02 00:00:00	38000275	0	\N	\N	311498	0	180325003	4078793	
53967	4690	4293740	1980-02-09	1980-02-09 00:00:00	38000275	0	\N	\N	312492	0	384700001	4293740	
54193	4709	4125906	1983-03-31	1983-03-31 00:00:00	38000275	0	\N	\N	313646	0	288086009	4125906	
42592	3756	4035793	2016-07-09	2016-07-09 00:00:00	38000275	0	\N	\N	249693	0	15081005	4035793	
54682	4745	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	315927	0	180256009	4107731	
54925	4761	4107731	1995-03-13	1995-03-13 00:00:00	38000275	0	\N	\N	317276	0	180256009	4107731	
43357	3825	4024289	1956-05-31	1956-05-31 00:00:00	38000275	0	\N	\N	254107	0	19490002	4024289	
43559	3857	4125906	1944-11-29	1944-11-29 00:00:00	38000275	0	\N	\N	256033	0	288086009	4125906	
56051	4890	4078793	2014-01-01	2014-01-01 00:00:00	38000275	0	\N	\N	325168	0	180325003	4078793	
44145	3884	4043071	1987-05-09	1987-05-09 00:00:00	38000275	0	\N	\N	258085	0	228557008	4043071	
45195	3976	4024289	1969-01-16	1969-01-16 00:00:00	38000275	0	\N	\N	264348	0	19490002	4024289	
57313	4970	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	330371	0	180256009	4107731	
57649	4992	4043071	1996-04-14	1996-04-14 00:00:00	38000275	0	\N	\N	332143	0	228557008	4043071	
58065	5037	4295880	1994-11-09	1994-11-09 00:00:00	38000275	0	\N	\N	334724	0	76601001	4295880	
58225	5048	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	335424	0	180256009	4107731	
58438	5051	4107731	1992-11-12	1992-11-12 00:00:00	38000275	0	\N	\N	335855	0	180256009	4107731	
58896	5113	4024289	1986-01-02	1986-01-02 00:00:00	38000275	0	\N	\N	339727	0	19490002	4024289	
59192	5119	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	340311	0	180256009	4107731	
59649	5165	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	343281	0	180256009	4107731	
36002	3158	4043071	1966-01-27	1966-01-27 00:00:00	38000275	0	\N	\N	210018	0	228557008	4043071	
48168	4224	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	280578	0	180256009	4107731	
36439	3195	4243062	2006-11-23	2006-11-23 00:00:00	38000275	0	\N	\N	212593	0	60027007	4243062	
60454	5222	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	347459	0	180256009	4107731	
48725	4279	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	283972	0	180256009	4107731	
60799	5267	4107731	1996-11-23	1996-11-23 00:00:00	38000275	0	\N	\N	350367	0	180256009	4107731	
49153	4312	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	286149	0	180256009	4107731	
49235	4317	4170947	1964-10-04	1964-10-04 00:00:00	38000275	0	\N	\N	286478	0	274474001	4170947	
61507	5322	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	354214	0	180256009	4107731	
49789	4366	4107731	1996-01-30	1996-01-30 00:00:00	38000275	0	\N	\N	289645	0	180256009	4107731	
61945	5343	4107731	1996-05-12	1996-05-12 00:00:00	38000275	0	\N	\N	355863	0	180256009	4107731	
50169	4373	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	290356	0	180256009	4107731	
50650	4412	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	293379	0	180256009	4107731	
50710	4413	4181917	1996-11-29	1996-11-29 00:00:00	38000275	0	\N	\N	293419	0	54550000	4181917	
39602	3483	4043071	1962-12-03	1962-12-03 00:00:00	38000275	0	\N	\N	231094	0	228557008	4043071	
51884	4500	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	299542	0	180256009	4107731	
52107	4514	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	300689	0	180256009	4107731	
52363	4543	4295880	1997-03-01	1997-03-01 00:00:00	38000275	0	\N	\N	302635	0	76601001	4295880	
41009	3601	4037675	2018-06-04	2018-06-04 00:00:00	38000275	0	\N	\N	239253	0	162676008	4037675	
53199	4623	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	307886	0	180256009	4107731	
53472	4641	4035793	2011-07-28	2011-07-28 00:00:00	38000275	0	\N	\N	309352	0	15081005	4035793	
53838	4675	4078793	2015-03-01	2015-03-01 00:00:00	38000275	0	\N	\N	311520	0	180325003	4078793	
53968	4690	4125906	2004-05-06	2004-05-06 00:00:00	38000275	0	\N	\N	312470	0	288086009	4125906	
54194	4712	4078793	2018-03-23	2018-03-23 00:00:00	38000275	0	\N	\N	313779	0	180325003	4078793	
42593	3756	4202451	2006-02-04	2006-02-04 00:00:00	38000275	0	\N	\N	249690	0	433112001	4202451	
54683	4745	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	316012	0	180256009	4107731	
54926	4761	4107731	1995-12-11	1995-12-11 00:00:00	38000275	0	\N	\N	317264	0	180256009	4107731	
43358	3825	4151422	1958-08-15	1958-08-15 00:00:00	38000275	0	\N	\N	254080	0	269911007	4151422	
43560	3857	4293740	1944-11-29	1944-11-29 00:00:00	38000275	0	\N	\N	256033	0	384700001	4293740	
56052	4890	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	325246	0	180256009	4107731	
44146	3884	4043071	1987-10-17	1987-10-17 00:00:00	38000275	0	\N	\N	258133	0	228557008	4043071	
45196	3976	4170947	1969-01-16	1969-01-16 00:00:00	38000275	0	\N	\N	264348	0	274474001	4170947	
57314	4970	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	330404	0	180256009	4107731	
57650	4992	4043071	1997-08-31	1997-08-31 00:00:00	38000275	0	\N	\N	332121	0	228557008	4043071	
58066	5037	4295880	1999-02-03	1999-02-03 00:00:00	38000275	0	\N	\N	334758	0	76601001	4295880	
58226	5048	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	335468	0	180256009	4107731	
58439	5051	4107731	1992-01-02	1992-01-02 00:00:00	38000275	0	\N	\N	335851	0	180256009	4107731	
58897	5113	4170947	1986-01-02	1986-01-02 00:00:00	38000275	0	\N	\N	339727	0	274474001	4170947	
59193	5119	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	340308	0	180256009	4107731	
59650	5165	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	343262	0	180256009	4107731	
36003	3158	4125906	1974-05-03	1974-05-03 00:00:00	38000275	0	\N	\N	209948	0	288086009	4125906	
48169	4224	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	280540	0	395142003	4191853	
36440	3196	4151422	2004-01-19	2004-01-19 00:00:00	38000275	0	\N	\N	212616	0	269911007	4151422	
60455	5222	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	347498	0	180256009	4107731	
48726	4279	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	284042	0	180256009	4107731	
60800	5267	4107731	1997-02-15	1997-02-15 00:00:00	38000275	0	\N	\N	350387	0	180256009	4107731	
49154	4312	4197460	1961-02-07	1961-02-07 00:00:00	38000275	0	\N	\N	286132	0	313191000	4197460	
49237	4319	4125906	1982-09-12	1982-09-12 00:00:00	38000275	0	\N	\N	286581	0	288086009	4125906	
61508	5322	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	354195	0	180256009	4107731	
49790	4366	4107731	1995-09-05	1995-09-05 00:00:00	38000275	0	\N	\N	289687	0	180256009	4107731	
61946	5343	4107731	1998-04-05	1998-04-05 00:00:00	38000275	0	\N	\N	355887	0	180256009	4107731	
50170	4373	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	290362	0	180256009	4107731	
50651	4412	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	293408	0	180256009	4107731	
50711	4413	4125906	1975-08-22	1975-08-22 00:00:00	38000275	0	\N	\N	293416	0	288086009	4125906	
39603	3483	4043071	1964-03-16	1964-03-16 00:00:00	38000275	0	\N	\N	231098	0	228557008	4043071	
51885	4500	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	299574	0	180256009	4107731	
52108	4514	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	300596	0	180256009	4107731	
52364	4543	4295880	1998-08-29	1998-08-29 00:00:00	38000275	0	\N	\N	302637	0	76601001	4295880	
41010	3601	4151422	2011-08-26	2011-08-26 00:00:00	38000275	0	\N	\N	239251	0	269911007	4151422	
53200	4623	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	307945	0	395142003	4191853	
53473	4641	4035793	2015-08-06	2015-08-06 00:00:00	38000275	0	\N	\N	309345	0	15081005	4035793	
53839	4675	4078793	2001-12-16	2001-12-16 00:00:00	38000275	0	\N	\N	311481	0	180325003	4078793	
53969	4690	4170947	1965-02-22	1965-02-22 00:00:00	38000275	0	\N	\N	312520	0	274474001	4170947	
54195	4712	4078793	2019-03-29	2019-03-29 00:00:00	38000275	0	\N	\N	313785	0	180325003	4078793	
42594	3757	4151422	1973-01-12	1973-01-12 00:00:00	38000275	0	\N	\N	249726	0	269911007	4151422	
54684	4745	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	315897	0	180256009	4107731	
54927	4761	4107731	1995-08-07	1995-08-07 00:00:00	38000275	0	\N	\N	317285	0	180256009	4107731	
43359	3825	4125906	2009-03-13	2009-03-13 00:00:00	38000275	0	\N	\N	254068	0	288086009	4125906	
43561	3857	4035793	2017-07-25	2017-07-25 00:00:00	38000275	0	\N	\N	256000	0	15081005	4035793	
56053	4890	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	325095	0	180256009	4107731	
44147	3884	4107731	1991-01-14	1991-01-14 00:00:00	38000275	0	\N	\N	258065	0	180256009	4107731	
45197	3976	4151422	1985-10-29	1985-10-29 00:00:00	38000275	0	\N	\N	264387	0	269911007	4151422	
57315	4970	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	330405	0	180256009	4107731	
57651	4992	4043071	1996-09-15	1996-09-15 00:00:00	38000275	0	\N	\N	332145	0	228557008	4043071	
58067	5037	4295880	2002-07-31	2002-07-31 00:00:00	38000275	0	\N	\N	334732	0	76601001	4295880	
58227	5048	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	335515	0	180256009	4107731	
58440	5051	4170947	1983-08-25	1983-08-25 00:00:00	38000275	0	\N	\N	335904	0	274474001	4170947	
58898	5113	44783196	1974-02-22	1974-02-22 00:00:00	38000275	0	\N	\N	339731	0	699253003	44783196	
59194	5119	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	340320	0	180256009	4107731	
59651	5165	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	343330	0	180256009	4107731	
36004	3158	4043071	1965-10-21	1965-10-21 00:00:00	38000275	0	\N	\N	209937	0	228557008	4043071	
48170	4224	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	280489	0	180256009	4107731	
36441	3196	4151422	1995-10-31	1995-10-31 00:00:00	38000275	0	\N	\N	212629	0	269911007	4151422	
60456	5222	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	347358	0	180256009	4107731	
48727	4279	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	284033	0	180256009	4107731	
60801	5267	4107731	1998-11-07	1998-11-07 00:00:00	38000275	0	\N	\N	350410	0	180256009	4107731	
49155	4312	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	286093	0	180256009	4107731	
49238	4319	4125906	1997-12-18	1997-12-18 00:00:00	38000275	0	\N	\N	286584	0	288086009	4125906	
61509	5322	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	354186	0	180256009	4107731	
49791	4366	4107731	1997-06-17	1997-06-17 00:00:00	38000275	0	\N	\N	289717	0	180256009	4107731	
61947	5343	4107731	1996-01-28	1996-01-28 00:00:00	38000275	0	\N	\N	355817	0	180256009	4107731	
50171	4373	4107731	1991-09-03	1991-09-03 00:00:00	38000275	0	\N	\N	290390	0	180256009	4107731	
50652	4412	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	293380	0	180256009	4107731	
50712	4413	4047491	1976-08-07	1976-08-07 00:00:00	38000275	0	\N	\N	293417	0	1225002	4047491	
39604	3483	4043071	1962-02-26	1962-02-26 00:00:00	38000275	0	\N	\N	231092	0	228557008	4043071	
51886	4500	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	299564	0	180256009	4107731	
52109	4514	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	300609	0	180256009	4107731	
52365	4543	4295880	1999-02-27	1999-02-27 00:00:00	38000275	0	\N	\N	302592	0	76601001	4295880	
41011	3601	4197460	1976-03-25	1976-03-25 00:00:00	38000275	0	\N	\N	239219	0	313191000	4197460	
53201	4623	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	307990	0	180256009	4107731	
53474	4641	4035793	2017-07-13	2017-07-13 00:00:00	38000275	0	\N	\N	309346	0	15081005	4035793	
53840	4675	4047491	2007-12-06	2007-12-06 00:00:00	38000275	0	\N	\N	311449	0	1225002	4047491	
53970	4690	4243062	1965-02-22	1965-02-22 00:00:00	38000275	0	\N	\N	312520	0	60027007	4243062	
54196	4712	4198190	1972-01-20	1972-01-20 00:00:00	38000275	0	\N	\N	313780	0	80146002	4198190	
42595	3757	4163872	1957-09-14	1957-09-14 00:00:00	38000275	0	\N	\N	249762	0	399208008	4163872	
54685	4745	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	315999	0	180256009	4107731	
54928	4761	4107731	1995-06-05	1995-06-05 00:00:00	38000275	0	\N	\N	317263	0	180256009	4107731	
43360	3825	4125906	1988-01-28	1988-01-28 00:00:00	38000275	0	\N	\N	254066	0	288086009	4125906	
43562	3857	4035793	2007-08-28	2007-08-28 00:00:00	38000275	0	\N	\N	256003	0	15081005	4035793	
56054	4890	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	325248	0	180256009	4107731	
44148	3884	4043071	1984-11-17	1984-11-17 00:00:00	38000275	0	\N	\N	258106	0	228557008	4043071	
45222	3980	4125906	1977-07-13	1977-07-13 00:00:00	38000275	0	\N	\N	264589	0	288086009	4125906	
57316	4970	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	330431	0	180256009	4107731	
57652	4992	4043071	1997-08-03	1997-08-03 00:00:00	38000275	0	\N	\N	332080	0	228557008	4043071	
58068	5037	4295880	2006-04-26	2006-04-26 00:00:00	38000275	0	\N	\N	334781	0	76601001	4295880	
58228	5048	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	335545	0	180256009	4107731	
58441	5051	4024289	1983-08-25	1983-08-25 00:00:00	38000275	0	\N	\N	335904	0	19490002	4024289	
58899	5113	4252419	1974-02-15	1974-02-15 00:00:00	38000275	0	\N	\N	339722	0	74016001	4252419	
59195	5119	4107731	1992-01-28	1992-01-28 00:00:00	38000275	0	\N	\N	340349	0	180256009	4107731	
59652	5165	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	343304	0	180256009	4107731	
36005	3158	4293740	1963-04-14	1963-04-14 00:00:00	38000275	0	\N	\N	209944	0	384700001	4293740	
48171	4224	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	280544	0	180256009	4107731	
36442	3196	4151422	1983-09-16	1983-09-16 00:00:00	38000275	0	\N	\N	212627	0	269911007	4151422	
60457	5222	4057420	2011-03-24	2011-03-24 00:00:00	38000275	0	\N	\N	347424	0	18286008	4057420	
48728	4279	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	284044	0	180256009	4107731	
60802	5267	4191853	1999-06-26	1999-06-26 00:00:00	38000275	0	\N	\N	350412	0	395142003	4191853	
49156	4312	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	286162	0	180256009	4107731	
49239	4319	4243062	2014-05-28	2014-05-28 00:00:00	38000275	0	\N	\N	286586	0	60027007	4243062	
61510	5322	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	354230	0	180256009	4107731	
49792	4366	4062501	1984-05-11	1984-05-11 00:00:00	38000275	0	\N	\N	289632	0	171231001	4062501	
61948	5343	4107731	1997-10-19	1997-10-19 00:00:00	38000275	0	\N	\N	355910	0	180256009	4107731	
50172	4373	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	290376	0	180256009	4107731	
50653	4412	44783196	2000-09-21	2000-09-21 00:00:00	38000275	0	\N	\N	293364	0	699253003	44783196	
50713	4413	4170947	1976-08-07	1976-08-07 00:00:00	38000275	0	\N	\N	293417	0	274474001	4170947	
39605	3483	4043071	1963-02-04	1963-02-04 00:00:00	38000275	0	\N	\N	231122	0	228557008	4043071	
51887	4500	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	299615	0	180256009	4107731	
52110	4514	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	300612	0	180256009	4107731	
52366	4543	4295880	2000-02-26	2000-02-26 00:00:00	38000275	0	\N	\N	302630	0	76601001	4295880	
41012	3601	4151422	1971-05-18	1971-05-18 00:00:00	38000275	0	\N	\N	239149	0	269911007	4151422	
53202	4623	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	307984	0	180256009	4107731	
53475	4641	4035793	2009-07-23	2009-07-23 00:00:00	38000275	0	\N	\N	309318	0	15081005	4035793	
53841	4675	4170947	2007-12-06	2007-12-06 00:00:00	38000275	0	\N	\N	311449	0	274474001	4170947	
53971	4690	4125906	1991-05-26	1991-05-26 00:00:00	38000275	0	\N	\N	312467	0	288086009	4125906	
54197	4712	4163872	2007-05-25	2007-05-25 00:00:00	38000275	0	\N	\N	313787	0	399208008	4163872	
42596	3757	4170947	1957-09-14	1957-09-14 00:00:00	38000275	0	\N	\N	249762	0	274474001	4170947	
54686	4745	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	315998	0	180256009	4107731	
54929	4761	4107731	1995-07-17	1995-07-17 00:00:00	38000275	0	\N	\N	317227	0	180256009	4107731	
43361	3825	4125906	1988-12-14	1988-12-14 00:00:00	38000275	0	\N	\N	254067	0	288086009	4125906	
43563	3857	4035793	1999-07-13	1999-07-13 00:00:00	38000275	0	\N	\N	255994	0	15081005	4035793	
56055	4890	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	325162	0	180256009	4107731	
44149	3884	4107731	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	258170	0	180256009	4107731	
45223	3980	4293740	1977-07-13	1977-07-13 00:00:00	38000275	0	\N	\N	264589	0	384700001	4293740	
57317	4970	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	330495	0	395142003	4191853	
57653	4992	4043071	1995-07-23	1995-07-23 00:00:00	38000275	0	\N	\N	332108	0	228557008	4043071	
58069	5037	4295880	2000-11-01	2000-11-01 00:00:00	38000275	0	\N	\N	334790	0	76601001	4295880	
58229	5048	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	335464	0	180256009	4107731	
58442	5051	4107731	1993-07-01	1993-07-01 00:00:00	38000275	0	\N	\N	335857	0	180256009	4107731	
59196	5119	4107731	1992-06-02	1992-06-02 00:00:00	38000275	0	\N	\N	340388	0	180256009	4107731	
59653	5165	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	343265	0	180256009	4107731	
36006	3158	4125906	1963-04-14	1963-04-14 00:00:00	38000275	0	\N	\N	209944	0	288086009	4125906	
48172	4224	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	280553	0	180256009	4107731	
36447	3199	4198190	2006-01-25	2006-01-25 00:00:00	38000275	0	\N	\N	212740	0	80146002	4198190	
60458	5222	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	347359	0	180256009	4107731	
48729	4279	4151422	1976-03-08	1976-03-08 00:00:00	38000275	0	\N	\N	283949	0	269911007	4151422	
60803	5267	4107731	1997-06-21	1997-06-21 00:00:00	38000275	0	\N	\N	350472	0	180256009	4107731	
49157	4312	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	286163	0	180256009	4107731	
49240	4319	4170947	2014-05-28	2014-05-28 00:00:00	38000275	0	\N	\N	286586	0	274474001	4170947	
61511	5322	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	354100	0	180256009	4107731	
49793	4366	4107731	1995-05-23	1995-05-23 00:00:00	38000275	0	\N	\N	289699	0	180256009	4107731	
61949	5343	4107731	1996-06-02	1996-06-02 00:00:00	38000275	0	\N	\N	355835	0	180256009	4107731	
50173	4374	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	290479	0	180256009	4107731	
50654	4412	4198190	2010-07-22	2010-07-22 00:00:00	38000275	0	\N	\N	293415	0	80146002	4198190	
50739	4418	44783196	2006-10-07	2006-10-07 00:00:00	38000275	0	\N	\N	293793	0	699253003	44783196	
39606	3483	4043071	1964-10-12	1964-10-12 00:00:00	38000275	0	\N	\N	231058	0	228557008	4043071	
51888	4500	4330583	1993-09-12	1993-09-12 00:00:00	38000275	0	\N	\N	299659	0	22523008	4330583	
52111	4514	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	300638	0	180256009	4107731	
52367	4543	4151422	1984-04-16	1984-04-16 00:00:00	38000275	0	\N	\N	302603	0	269911007	4151422	
41013	3601	4197460	1965-01-18	1965-01-18 00:00:00	38000275	0	\N	\N	239217	0	313191000	4197460	
53203	4623	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	307972	0	180256009	4107731	
53476	4641	4035793	2013-08-01	2013-08-01 00:00:00	38000275	0	\N	\N	309303	0	15081005	4035793	
53842	4675	4078793	2012-02-12	2012-02-12 00:00:00	38000275	0	\N	\N	311532	0	180325003	4078793	
53972	4690	4125906	1992-05-04	1992-05-04 00:00:00	38000275	0	\N	\N	312468	0	288086009	4125906	
54198	4712	4151422	2013-02-28	2013-02-28 00:00:00	38000275	0	\N	\N	313762	0	269911007	4151422	
42602	3759	4107731	1991-08-18	1991-08-18 00:00:00	38000275	0	\N	\N	249959	0	180256009	4107731	
54687	4745	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	315952	0	180256009	4107731	
54930	4761	4107731	1995-11-20	1995-11-20 00:00:00	38000275	0	\N	\N	317319	0	180256009	4107731	
43364	3827	4151422	1963-10-06	1963-10-06 00:00:00	38000275	0	\N	\N	254158	0	269911007	4151422	
43564	3857	4035793	2012-09-25	2012-09-25 00:00:00	38000275	0	\N	\N	255997	0	15081005	4035793	
56056	4890	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	325101	0	180256009	4107731	
44150	3884	4043071	1987-03-07	1987-03-07 00:00:00	38000275	0	\N	\N	258127	0	228557008	4043071	
45224	3980	4243062	1986-04-18	1986-04-18 00:00:00	38000275	0	\N	\N	264578	0	60027007	4243062	
57318	4970	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	330415	0	180256009	4107731	
57668	4998	4062501	1968-10-15	1968-10-15 00:00:00	38000275	0	\N	\N	332403	0	171231001	4062501	
58070	5037	4295880	2005-10-26	2005-10-26 00:00:00	38000275	0	\N	\N	334827	0	76601001	4295880	
58230	5048	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	335539	0	180256009	4107731	
58443	5051	4107731	1991-11-21	1991-11-21 00:00:00	38000275	0	\N	\N	335850	0	180256009	4107731	
59197	5119	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	340374	0	180256009	4107731	
36007	3158	4043071	1965-09-23	1965-09-23 00:00:00	38000275	0	\N	\N	209929	0	228557008	4043071	
48173	4224	4252419	1950-11-14	1950-11-14 00:00:00	38000275	0	\N	\N	280589	0	74016001	4252419	
36448	3200	4047491	2013-08-19	2013-08-19 00:00:00	38000275	0	\N	\N	212828	0	1225002	4047491	
60459	5222	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	347411	0	180256009	4107731	
48730	4279	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	283952	0	395142003	4191853	
60804	5267	4107731	1997-10-25	1997-10-25 00:00:00	38000275	0	\N	\N	350370	0	180256009	4107731	
49158	4312	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	286090	0	395142003	4191853	
49241	4319	4170947	1995-10-30	1995-10-30 00:00:00	38000275	0	\N	\N	286583	0	274474001	4170947	
61512	5322	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	354126	0	180256009	4107731	
49794	4366	4107731	1997-07-08	1997-07-08 00:00:00	38000275	0	\N	\N	289726	0	180256009	4107731	
61950	5343	4107731	1996-06-23	1996-06-23 00:00:00	38000275	0	\N	\N	355864	0	180256009	4107731	
50174	4374	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	290560	0	180256009	4107731	
50655	4412	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	293344	0	180256009	4107731	
50740	4418	4198190	1954-07-27	1954-07-27 00:00:00	38000275	0	\N	\N	293743	0	80146002	4198190	
39607	3483	4043071	1964-09-14	1964-09-14 00:00:00	38000275	0	\N	\N	231125	0	228557008	4043071	
51889	4500	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	299617	0	180256009	4107731	
52112	4514	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	300688	0	180256009	4107731	
52368	4543	4295880	1995-06-03	1995-06-03 00:00:00	38000275	0	\N	\N	302624	0	76601001	4295880	
41014	3601	4125906	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	239224	0	288086009	4125906	
53204	4623	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	307936	0	180256009	4107731	
53477	4642	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	309398	0	180256009	4107731	
53843	4675	4078793	2014-02-23	2014-02-23 00:00:00	38000275	0	\N	\N	311499	0	180325003	4078793	
53973	4691	4024289	1962-03-28	1962-03-28 00:00:00	38000275	0	\N	\N	312596	0	19490002	4024289	
54199	4712	4057420	2017-03-17	2017-03-17 00:00:00	38000275	0	\N	\N	313784	0	18286008	4057420	
42603	3759	4107731	1991-09-08	1991-09-08 00:00:00	38000275	0	\N	\N	249891	0	180256009	4107731	
54688	4745	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	315957	0	180256009	4107731	
54931	4761	4107731	1996-09-09	1996-09-09 00:00:00	38000275	0	\N	\N	317287	0	180256009	4107731	
43365	3827	4125906	1986-07-08	1986-07-08 00:00:00	38000275	0	\N	\N	254189	0	288086009	4125906	
43565	3857	4035793	2010-09-14	2010-09-14 00:00:00	38000275	0	\N	\N	255965	0	15081005	4035793	
56057	4890	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	325243	0	180256009	4107731	
44151	3884	4107731	1992-09-14	1992-09-14 00:00:00	38000275	0	\N	\N	258050	0	180256009	4107731	
45225	3980	4170947	1986-04-18	1986-04-18 00:00:00	38000275	0	\N	\N	264578	0	274474001	4170947	
57319	4970	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	330456	0	180256009	4107731	
57669	4999	4057420	2019-01-27	2019-01-27 00:00:00	38000275	0	\N	\N	332474	0	18286008	4057420	
58071	5037	4295880	1997-08-06	1997-08-06 00:00:00	38000275	0	\N	\N	334746	0	76601001	4295880	
58231	5048	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	335494	0	180256009	4107731	
58444	5051	4107731	1994-02-17	1994-02-17 00:00:00	38000275	0	\N	\N	335859	0	180256009	4107731	
59198	5119	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	340364	0	180256009	4107731	
36008	3158	4043071	1966-11-03	1966-11-03 00:00:00	38000275	0	\N	\N	209986	0	228557008	4043071	
48174	4224	4151422	2019-03-30	2019-03-30 00:00:00	38000275	0	\N	\N	280555	0	269911007	4151422	
36449	3200	4195803	2013-08-19	2013-08-19 00:00:00	38000275	0	\N	\N	212828	0	312681000	4195803	
60460	5222	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	347413	0	180256009	4107731	
48731	4279	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	284063	0	180256009	4107731	
60805	5267	4107731	1999-01-30	1999-01-30 00:00:00	38000275	0	\N	\N	350374	0	180256009	4107731	
49159	4312	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	286078	0	180256009	4107731	
49242	4319	4024289	1995-10-30	1995-10-30 00:00:00	38000275	0	\N	\N	286583	0	19490002	4024289	
61513	5322	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	354153	0	180256009	4107731	
49795	4366	4107731	1994-07-12	1994-07-12 00:00:00	38000275	0	\N	\N	289695	0	180256009	4107731	
61951	5343	4107731	1998-04-26	1998-04-26 00:00:00	38000275	0	\N	\N	355912	0	180256009	4107731	
50175	4374	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	290584	0	180256009	4107731	
50656	4412	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	293329	0	180256009	4107731	
50741	4418	4151422	1979-10-22	1979-10-22 00:00:00	38000275	0	\N	\N	293750	0	269911007	4151422	
39608	3483	4043071	1962-08-27	1962-08-27 00:00:00	38000275	0	\N	\N	231014	0	228557008	4043071	
51890	4500	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	299671	0	180256009	4107731	
52113	4514	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	300673	0	180256009	4107731	
52369	4543	4295880	1997-08-30	1997-08-30 00:00:00	38000275	0	\N	\N	302590	0	76601001	4295880	
41015	3601	4062501	1962-06-25	1962-06-25 00:00:00	38000275	0	\N	\N	239234	0	171231001	4062501	
53205	4623	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	307989	0	180256009	4107731	
53478	4642	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	309482	0	180256009	4107731	
53844	4675	4293740	1917-01-01	1917-01-01 00:00:00	38000275	0	\N	\N	311502	0	384700001	4293740	
53974	4691	4170947	1962-03-28	1962-03-28 00:00:00	38000275	0	\N	\N	312596	0	274474001	4170947	
54200	4713	4151422	1978-09-02	1978-09-02 00:00:00	38000275	0	\N	\N	313828	0	269911007	4151422	
42604	3759	4107731	1991-12-22	1991-12-22 00:00:00	38000275	0	\N	\N	249987	0	180256009	4107731	
54689	4745	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	315954	0	180256009	4107731	
54932	4761	4107731	1995-01-09	1995-01-09 00:00:00	38000275	0	\N	\N	317226	0	180256009	4107731	
43366	3827	4170947	2015-08-24	2015-08-24 00:00:00	38000275	0	\N	\N	254191	0	274474001	4170947	
43566	3857	4035793	2016-07-19	2016-07-19 00:00:00	38000275	0	\N	\N	256025	0	15081005	4035793	
56058	4890	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	325067	0	180256009	4107731	
44152	3884	4107731	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	258098	0	180256009	4107731	
45226	3982	4151422	2007-12-10	2007-12-10 00:00:00	38000275	0	\N	\N	264731	0	269911007	4151422	
57320	4970	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	330387	0	180256009	4107731	
57670	4999	4078793	2018-01-21	2018-01-21 00:00:00	38000275	0	\N	\N	332478	0	180325003	4078793	
58072	5037	4295880	1995-08-09	1995-08-09 00:00:00	38000275	0	\N	\N	334725	0	76601001	4295880	
58232	5048	4151422	1959-10-20	1959-10-20 00:00:00	38000275	0	\N	\N	335517	0	269911007	4151422	
58445	5051	4107731	1992-08-20	1992-08-20 00:00:00	38000275	0	\N	\N	335853	0	180256009	4107731	
59199	5119	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	340360	0	180256009	4107731	
36009	3158	4043071	1964-05-21	1964-05-21 00:00:00	38000275	0	\N	\N	209910	0	228557008	4043071	
48175	4224	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	280549	0	180256009	4107731	
36450	3200	4170947	2013-08-19	2013-08-19 00:00:00	38000275	0	\N	\N	212828	0	274474001	4170947	
60461	5222	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	347380	0	180256009	4107731	
48732	4279	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	284062	0	180256009	4107731	
60806	5267	4107731	1997-10-04	1997-10-04 00:00:00	38000275	0	\N	\N	350437	0	180256009	4107731	
49160	4312	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	286150	0	180256009	4107731	
49243	4320	4125906	1979-07-10	1979-07-10 00:00:00	38000275	0	\N	\N	286670	0	288086009	4125906	
61514	5322	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	354127	0	180256009	4107731	
49796	4366	4107731	1996-06-04	1996-06-04 00:00:00	38000275	0	\N	\N	289653	0	180256009	4107731	
61952	5343	4107731	1998-12-13	1998-12-13 00:00:00	38000275	0	\N	\N	355904	0	180256009	4107731	
50176	4374	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	290459	0	395142003	4191853	
50657	4412	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	293409	0	180256009	4107731	
50742	4418	4043071	1960-09-25	1960-09-25 00:00:00	38000275	0	\N	\N	293716	0	228557008	4043071	
39609	3483	4043071	1964-02-10	1964-02-10 00:00:00	38000275	0	\N	\N	231021	0	228557008	4043071	
51891	4500	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	299618	0	180256009	4107731	
52114	4514	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	300691	0	180256009	4107731	
52370	4543	4295880	1996-08-31	1996-08-31 00:00:00	38000275	0	\N	\N	302647	0	76601001	4295880	
41018	3603	4107731	1993-02-14	1993-02-14 00:00:00	38000275	0	\N	\N	239319	0	180256009	4107731	
53206	4623	4107731	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	307933	0	180256009	4107731	
53479	4642	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	309428	0	180256009	4107731	
53845	4675	4125906	1917-01-01	1917-01-01 00:00:00	38000275	0	\N	\N	311502	0	288086009	4125906	
53975	4691	4151422	2006-03-09	2006-03-09 00:00:00	38000275	0	\N	\N	312540	0	269911007	4151422	
54201	4713	4047491	1970-12-12	1970-12-12 00:00:00	38000275	0	\N	\N	313861	0	1225002	4047491	
42605	3759	4107731	1992-06-28	1992-06-28 00:00:00	38000275	0	\N	\N	249963	0	180256009	4107731	
54690	4745	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	315933	0	180256009	4107731	
54933	4761	4107731	1993-12-06	1993-12-06 00:00:00	38000275	0	\N	\N	317216	0	180256009	4107731	
43367	3827	4163872	2015-08-24	2015-08-24 00:00:00	38000275	0	\N	\N	254191	0	399208008	4163872	
43567	3857	4035793	2003-08-05	2003-08-05 00:00:00	38000275	0	\N	\N	255996	0	15081005	4035793	
56059	4890	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	325126	0	180256009	4107731	
44153	3884	4043071	1986-08-30	1986-08-30 00:00:00	38000275	0	\N	\N	258125	0	228557008	4043071	
45227	3982	4163872	1984-05-16	1984-05-16 00:00:00	38000275	0	\N	\N	264712	0	399208008	4163872	
57321	4970	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	330422	0	180256009	4107731	
57671	5000	4125906	1947-05-22	1947-05-22 00:00:00	38000275	0	\N	\N	332550	0	288086009	4125906	
58073	5037	4295880	2001-05-02	2001-05-02 00:00:00	38000275	0	\N	\N	334814	0	76601001	4295880	
58233	5048	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	335520	0	180256009	4107731	
58446	5051	4107731	1993-03-18	1993-03-18 00:00:00	38000275	0	\N	\N	335868	0	180256009	4107731	
59200	5119	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	340354	0	180256009	4107731	
36010	3158	4043071	1963-10-17	1963-10-17 00:00:00	38000275	0	\N	\N	209995	0	228557008	4043071	
48176	4224	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	280474	0	180256009	4107731	
36451	3200	4145310	2014-09-13	2014-09-13 00:00:00	38000275	0	\N	\N	212829	0	268425006	4145310	
60462	5222	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	347389	0	180256009	4107731	
48733	4279	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	284060	0	180256009	4107731	
60807	5267	4107731	1996-02-03	1996-02-03 00:00:00	38000275	0	\N	\N	350432	0	180256009	4107731	
49161	4312	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	286081	0	180256009	4107731	
49244	4320	4293740	1979-07-10	1979-07-10 00:00:00	38000275	0	\N	\N	286670	0	384700001	4293740	
61515	5322	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	354094	0	180256009	4107731	
49797	4366	4151422	1985-09-24	1985-09-24 00:00:00	38000275	0	\N	\N	289690	0	269911007	4151422	
61953	5343	4295880	1997-09-28	1997-09-28 00:00:00	38000275	0	\N	\N	355886	0	76601001	4295880	
50177	4374	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	290582	0	180256009	4107731	
50658	4412	4252419	2000-09-14	2000-09-14 00:00:00	38000275	0	\N	\N	293285	0	74016001	4252419	
50743	4418	4043071	1961-03-12	1961-03-12 00:00:00	38000275	0	\N	\N	293779	0	228557008	4043071	
39610	3483	4043071	1964-08-17	1964-08-17 00:00:00	38000275	0	\N	\N	231085	0	228557008	4043071	
51892	4500	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	299583	0	180256009	4107731	
52115	4514	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	300656	0	180256009	4107731	
52371	4543	4295880	1998-11-28	1998-11-28 00:00:00	38000275	0	\N	\N	302650	0	76601001	4295880	
41019	3603	4125906	2017-06-08	2017-06-08 00:00:00	38000275	0	\N	\N	239394	0	288086009	4125906	
53207	4623	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	307885	0	180256009	4107731	
53480	4642	4191853	1990-01-02	1990-01-02 00:00:00	38000275	0	\N	\N	309381	0	395142003	4191853	
53846	4675	4078793	2017-03-12	2017-03-12 00:00:00	38000275	0	\N	\N	311521	0	180325003	4078793	
53976	4691	4243062	1978-12-29	1978-12-29 00:00:00	38000275	0	\N	\N	312598	0	60027007	4243062	
54202	4713	4170947	1970-12-12	1970-12-12 00:00:00	38000275	0	\N	\N	313861	0	274474001	4170947	
42606	3759	4107731	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	249913	0	180256009	4107731	
54691	4745	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	315903	0	180256009	4107731	
54934	4761	4107731	1995-02-20	1995-02-20 00:00:00	38000275	0	\N	\N	317316	0	180256009	4107731	
43368	3827	4195803	2015-08-24	2015-08-24 00:00:00	38000275	0	\N	\N	254191	0	312681000	4195803	
43568	3857	4035793	1998-04-07	1998-04-07 00:00:00	38000275	0	\N	\N	255988	0	15081005	4035793	
56060	4890	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	325148	0	180256009	4107731	
44154	3884	4107731	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	258100	0	180256009	4107731	
45228	3982	4151422	1952-08-18	1952-08-18 00:00:00	38000275	0	\N	\N	264653	0	269911007	4151422	
57322	4970	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	330477	0	180256009	4107731	
57672	5000	4195803	2000-06-01	2000-06-01 00:00:00	38000275	0	\N	\N	332554	0	312681000	4195803	
58074	5037	4295880	2003-07-30	2003-07-30 00:00:00	38000275	0	\N	\N	334824	0	76601001	4295880	
58234	5048	4195803	2016-05-23	2016-05-23 00:00:00	38000275	0	\N	\N	335506	0	312681000	4195803	
58447	5051	4107731	1991-02-21	1991-02-21 00:00:00	38000275	0	\N	\N	335901	0	180256009	4107731	
59201	5119	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	340414	0	180256009	4107731	
36011	3158	4043071	1964-04-23	1964-04-23 00:00:00	38000275	0	\N	\N	209997	0	228557008	4043071	
48177	4224	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	280569	0	180256009	4107731	
36452	3200	4195803	2014-09-13	2014-09-13 00:00:00	38000275	0	\N	\N	212829	0	312681000	4195803	
60463	5222	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	347445	0	180256009	4107731	
48734	4279	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	283979	0	180256009	4107731	
60808	5267	4107731	1996-12-14	1996-12-14 00:00:00	38000275	0	\N	\N	350471	0	180256009	4107731	
49162	4312	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	286147	0	180256009	4107731	
49245	4320	4202832	1970-05-14	1970-05-14 00:00:00	38000275	0	\N	\N	286692	0	52765003	4202832	
61516	5322	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	354078	0	180256009	4107731	
49798	4366	4107731	1996-10-29	1996-10-29 00:00:00	38000275	0	\N	\N	289648	0	180256009	4107731	
61954	5343	4107731	1999-01-24	1999-01-24 00:00:00	38000275	0	\N	\N	355915	0	180256009	4107731	
50178	4374	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	290523	0	180256009	4107731	
50659	4412	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	293410	0	180256009	4107731	
50744	4418	4043071	1961-02-05	1961-02-05 00:00:00	38000275	0	\N	\N	293764	0	228557008	4043071	
39611	3483	4043071	1962-07-02	1962-07-02 00:00:00	38000275	0	\N	\N	231015	0	228557008	4043071	
51893	4500	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	299623	0	180256009	4107731	
52116	4514	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	300659	0	180256009	4107731	
52372	4543	4295880	1994-08-30	1994-08-30 00:00:00	38000275	0	\N	\N	302608	0	76601001	4295880	
41020	3603	4191853	1993-07-11	1993-07-11 00:00:00	38000275	0	\N	\N	239334	0	395142003	4191853	
53208	4623	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	307915	0	180256009	4107731	
53481	4642	4191853	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	309400	0	395142003	4191853	
53847	4675	4078793	1998-11-29	1998-11-29 00:00:00	38000275	0	\N	\N	311529	0	180325003	4078793	
53977	4691	4170947	1978-12-29	1978-12-29 00:00:00	38000275	0	\N	\N	312598	0	274474001	4170947	
54203	4715	4125906	2008-09-03	2008-09-03 00:00:00	38000275	0	\N	\N	313923	0	288086009	4125906	
42607	3759	4107731	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	249921	0	180256009	4107731	
54692	4745	4191853	1978-05-01	1978-05-01 00:00:00	38000275	0	\N	\N	315993	0	395142003	4191853	
54935	4761	4107731	1996-05-06	1996-05-06 00:00:00	38000275	0	\N	\N	317302	0	180256009	4107731	
43369	3827	4151422	1961-10-07	1961-10-07 00:00:00	38000275	0	\N	\N	254157	0	269911007	4151422	
43569	3857	4035793	1994-01-04	1994-01-04 00:00:00	38000275	0	\N	\N	256018	0	15081005	4035793	
56061	4890	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	325089	0	180256009	4107731	
44155	3884	4107731	1990-06-18	1990-06-18 00:00:00	38000275	0	\N	\N	258204	0	180256009	4107731	
45229	3982	4151422	2015-01-17	2015-01-17 00:00:00	38000275	0	\N	\N	264754	0	269911007	4151422	
57323	4970	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	330385	0	180256009	4107731	
57673	5000	4024289	2000-06-01	2000-06-01 00:00:00	38000275	0	\N	\N	332554	0	19490002	4024289	
58075	5037	4295880	1997-11-05	1997-11-05 00:00:00	38000275	0	\N	\N	334786	0	76601001	4295880	
58235	5048	4047491	2016-05-23	2016-05-23 00:00:00	38000275	0	\N	\N	335506	0	1225002	4047491	
58448	5051	4107731	1991-04-04	1991-04-04 00:00:00	38000275	0	\N	\N	335902	0	180256009	4107731	
59202	5119	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	340379	0	180256009	4107731	
36012	3158	4043071	1965-03-18	1965-03-18 00:00:00	38000275	0	\N	\N	210017	0	228557008	4043071	
48178	4224	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	280450	0	180256009	4107731	
36453	3201	4243062	1953-06-19	1953-06-19 00:00:00	38000275	0	\N	\N	212916	0	60027007	4243062	
60464	5222	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	347382	0	180256009	4107731	
48735	4279	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	283978	0	180256009	4107731	
60809	5267	4107731	1997-03-29	1997-03-29 00:00:00	38000275	0	\N	\N	350388	0	180256009	4107731	
49163	4312	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	286146	0	180256009	4107731	
49246	4320	4163971	1970-05-14	1970-05-14 00:00:00	38000275	0	\N	\N	286692	0	45595009	4163971	
61517	5322	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	354238	0	180256009	4107731	
49799	4366	4107731	1996-12-10	1996-12-10 00:00:00	38000275	0	\N	\N	289649	0	180256009	4107731	
61955	5343	4107731	1996-07-14	1996-07-14 00:00:00	38000275	0	\N	\N	355836	0	180256009	4107731	
50179	4374	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	290561	0	180256009	4107731	
50660	4412	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	293335	0	180256009	4107731	
50745	4418	4252419	2006-09-30	2006-09-30 00:00:00	38000275	0	\N	\N	293748	0	74016001	4252419	
39612	3483	4043071	1962-12-31	1962-12-31 00:00:00	38000275	0	\N	\N	231121	0	228557008	4043071	
51894	4500	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	299561	0	180256009	4107731	
52117	4514	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	300679	0	180256009	4107731	
52373	4543	4295880	1995-12-02	1995-12-02 00:00:00	38000275	0	\N	\N	302646	0	76601001	4295880	
41021	3603	4062501	1969-02-12	1969-02-12 00:00:00	38000275	0	\N	\N	239374	0	171231001	4062501	
53209	4623	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	307947	0	180256009	4107731	
53482	4642	4107731	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	309416	0	180256009	4107731	
53848	4675	4202451	1975-09-07	1975-09-07 00:00:00	38000275	0	\N	\N	311561	0	433112001	4202451	
53978	4691	4047491	1969-05-20	1969-05-20 00:00:00	38000275	0	\N	\N	312597	0	1225002	4047491	
42608	3759	4107731	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	249972	0	180256009	4107731	
54693	4745	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	315910	0	180256009	4107731	
54936	4761	4107731	1996-07-29	1996-07-29 00:00:00	38000275	0	\N	\N	317304	0	180256009	4107731	
43370	3827	4125906	1977-10-09	1977-10-09 00:00:00	38000275	0	\N	\N	254188	0	288086009	4125906	
43570	3857	4035793	2018-07-31	2018-07-31 00:00:00	38000275	0	\N	\N	256032	0	15081005	4035793	
56062	4890	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	325088	0	180256009	4107731	
44156	3884	4043071	1985-11-16	1985-11-16 00:00:00	38000275	0	\N	\N	258042	0	228557008	4043071	
45230	3982	4202451	2018-04-27	2018-04-27 00:00:00	38000275	0	\N	\N	264663	0	433112001	4202451	
57324	4970	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	330452	0	180256009	4107731	
57674	5000	4170947	2000-06-01	2000-06-01 00:00:00	38000275	0	\N	\N	332554	0	274474001	4170947	
58076	5037	4295880	2005-01-26	2005-01-26 00:00:00	38000275	0	\N	\N	334826	0	76601001	4295880	
58236	5048	4170947	2016-05-23	2016-05-23 00:00:00	38000275	0	\N	\N	335506	0	274474001	4170947	
58449	5051	4107731	1992-06-18	1992-06-18 00:00:00	38000275	0	\N	\N	335865	0	180256009	4107731	
59203	5119	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	340410	0	180256009	4107731	
36013	3158	4043071	1964-10-22	1964-10-22 00:00:00	38000275	0	\N	\N	209912	0	228557008	4043071	
48179	4224	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	280461	0	180256009	4107731	
36454	3201	4170947	1953-06-19	1953-06-19 00:00:00	38000275	0	\N	\N	212916	0	274474001	4170947	
60465	5222	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	347377	0	180256009	4107731	
48737	4282	4198190	1978-04-05	1978-04-05 00:00:00	38000275	0	\N	\N	284194	0	80146002	4198190	
60810	5267	4107731	1997-08-02	1997-08-02 00:00:00	38000275	0	\N	\N	350368	0	180256009	4107731	
49164	4313	4107731	1990-05-12	1990-05-12 00:00:00	38000275	0	\N	\N	286294	0	180256009	4107731	
49247	4320	42535580	1970-05-14	1970-05-14 00:00:00	38000275	0	\N	\N	286692	0	426701000119108	42535580	
61518	5322	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	354081	0	180256009	4107731	
49800	4366	4107731	1996-07-16	1996-07-16 00:00:00	38000275	0	\N	\N	289614	0	180256009	4107731	
61956	5343	4107731	1999-05-09	1999-05-09 00:00:00	38000275	0	\N	\N	355894	0	180256009	4107731	
50180	4374	4295880	1994-11-03	1994-11-03 00:00:00	38000275	0	\N	\N	290534	0	76601001	4295880	
50661	4412	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	293346	0	180256009	4107731	
50746	4418	4125906	1994-07-23	1994-07-23 00:00:00	38000275	0	\N	\N	293746	0	288086009	4125906	
39613	3483	4043071	1963-05-13	1963-05-13 00:00:00	38000275	0	\N	\N	231019	0	228557008	4043071	
51895	4500	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	299540	0	180256009	4107731	
52131	4520	4163872	1948-10-16	1948-10-16 00:00:00	38000275	0	\N	\N	300945	0	399208008	4163872	
52374	4543	4295880	1998-05-30	1998-05-30 00:00:00	38000275	0	\N	\N	302591	0	76601001	4295880	
41022	3603	4107731	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	239386	0	180256009	4107731	
53210	4623	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	307902	0	180256009	4107731	
53849	4675	4078793	2018-03-18	2018-03-18 00:00:00	38000275	0	\N	\N	311501	0	180325003	4078793	
53979	4691	4170947	1969-05-20	1969-05-20 00:00:00	38000275	0	\N	\N	312597	0	274474001	4170947	
42609	3759	4107731	1990-07-15	1990-07-15 00:00:00	38000275	0	\N	\N	249952	0	180256009	4107731	
54694	4745	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	315967	0	180256009	4107731	
54937	4761	4107731	1995-04-24	1995-04-24 00:00:00	38000275	0	\N	\N	317262	0	180256009	4107731	
43372	3831	4058899	1971-08-20	1971-08-20 00:00:00	38000275	0	\N	\N	254328	0	168594001	4058899	
43571	3857	4035793	2015-07-14	2015-07-14 00:00:00	38000275	0	\N	\N	255999	0	15081005	4035793	
56063	4890	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	325160	0	180256009	4107731	
44157	3884	4043071	1984-06-16	1984-06-16 00:00:00	38000275	0	\N	\N	258105	0	228557008	4043071	
45231	3982	4125906	1995-09-13	1995-09-13 00:00:00	38000275	0	\N	\N	264675	0	288086009	4125906	
57325	4970	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	330420	0	180256009	4107731	
57675	5000	4151422	1992-11-06	1992-11-06 00:00:00	38000275	0	\N	\N	332527	0	269911007	4151422	
58077	5037	4295880	1997-02-05	1997-02-05 00:00:00	38000275	0	\N	\N	334727	0	76601001	4295880	
58237	5048	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	335513	0	180256009	4107731	
58450	5051	4107731	1994-01-06	1994-01-06 00:00:00	38000275	0	\N	\N	335921	0	180256009	4107731	
59204	5119	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	340342	0	180256009	4107731	
36014	3158	4043071	1966-03-24	1966-03-24 00:00:00	38000275	0	\N	\N	209938	0	228557008	4043071	
48180	4224	44783196	1950-11-21	1950-11-21 00:00:00	38000275	0	\N	\N	280548	0	699253003	44783196	
36455	3201	4163872	1958-08-25	1958-08-25 00:00:00	38000275	0	\N	\N	212921	0	399208008	4163872	
60466	5222	4078793	2010-03-18	2010-03-18 00:00:00	38000275	0	\N	\N	347349	0	180325003	4078793	
48738	4282	4202451	2007-10-10	2007-10-10 00:00:00	38000275	0	\N	\N	284176	0	433112001	4202451	
60811	5267	4107731	1998-01-17	1998-01-17 00:00:00	38000275	0	\N	\N	350381	0	180256009	4107731	
49165	4313	4107731	1991-05-04	1991-05-04 00:00:00	38000275	0	\N	\N	286261	0	180256009	4107731	
49248	4320	4163951	1970-05-14	1970-05-14 00:00:00	38000275	0	\N	\N	286692	0	29303009	4163951	
61519	5322	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	354162	0	180256009	4107731	
49801	4366	4107731	1997-03-25	1997-03-25 00:00:00	38000275	0	\N	\N	289715	0	180256009	4107731	
61957	5343	4107731	1996-08-25	1996-08-25 00:00:00	38000275	0	\N	\N	355879	0	180256009	4107731	
50181	4374	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	290526	0	180256009	4107731	
50662	4412	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	293343	0	180256009	4107731	
50747	4418	4043071	1960-08-21	1960-08-21 00:00:00	38000275	0	\N	\N	293749	0	228557008	4043071	
39614	3483	4043071	1964-06-15	1964-06-15 00:00:00	38000275	0	\N	\N	231057	0	228557008	4043071	
51896	4500	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	299546	0	180256009	4107731	
52132	4520	4035793	1983-11-26	1983-11-26 00:00:00	38000275	0	\N	\N	300937	0	15081005	4035793	
52375	4543	4295880	1999-08-28	1999-08-28 00:00:00	38000275	0	\N	\N	302651	0	76601001	4295880	
41023	3603	4107731	1990-08-26	1990-08-26 00:00:00	38000275	0	\N	\N	239406	0	180256009	4107731	
53211	4623	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	307883	0	180256009	4107731	
53850	4675	4151422	1971-11-28	1971-11-28 00:00:00	38000275	0	\N	\N	311549	0	269911007	4151422	
53982	4694	4107731	1996-08-18	1996-08-18 00:00:00	38000275	0	\N	\N	312668	0	180256009	4107731	
42610	3759	4107731	1992-04-26	1992-04-26 00:00:00	38000275	0	\N	\N	249903	0	180256009	4107731	
54695	4745	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	315981	0	180256009	4107731	
54938	4761	4107731	1996-05-27	1996-05-27 00:00:00	38000275	0	\N	\N	317231	0	180256009	4107731	
43373	3831	4151422	2001-12-07	2001-12-07 00:00:00	38000275	0	\N	\N	254331	0	269911007	4151422	
55353	4826	4107731	1991-09-07	1991-09-07 00:00:00	38000275	0	\N	\N	320944	0	180256009	4107731	
56064	4890	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	325161	0	180256009	4107731	
44158	3884	4107731	1991-08-12	1991-08-12 00:00:00	38000275	0	\N	\N	258171	0	180256009	4107731	
45232	3982	4151422	1956-02-23	1956-02-23 00:00:00	38000275	0	\N	\N	264647	0	269911007	4151422	
57326	4970	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	330366	0	180256009	4107731	
57676	5000	4330583	1982-08-26	1982-08-26 00:00:00	38000275	0	\N	\N	332590	0	22523008	4330583	
58078	5037	4295880	1992-11-11	1992-11-11 00:00:00	38000275	0	\N	\N	334740	0	76601001	4295880	
58238	5048	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	335511	0	180256009	4107731	
58451	5051	4107731	1992-12-03	1992-12-03 00:00:00	38000275	0	\N	\N	335933	0	180256009	4107731	
59205	5119	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	340386	0	180256009	4107731	
36015	3158	4043071	1964-08-20	1964-08-20 00:00:00	38000275	0	\N	\N	209998	0	228557008	4043071	
48181	4224	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	280452	0	180256009	4107731	
36456	3201	4125906	1973-04-19	1973-04-19 00:00:00	38000275	0	\N	\N	212918	0	288086009	4125906	
60467	5222	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	347494	0	180256009	4107731	
48739	4282	4170947	1970-02-14	1970-02-14 00:00:00	38000275	0	\N	\N	284192	0	274474001	4170947	
60812	5267	4107731	1998-09-26	1998-09-26 00:00:00	38000275	0	\N	\N	350409	0	180256009	4107731	
49166	4313	4107731	1990-01-27	1990-01-27 00:00:00	38000275	0	\N	\N	286256	0	180256009	4107731	
49249	4320	4010253	1984-04-01	1984-04-01 00:00:00	38000275	0	\N	\N	286651	0	112790001	4010253	
61520	5322	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	354192	0	180256009	4107731	
49802	4366	4107731	1995-01-17	1995-01-17 00:00:00	38000275	0	\N	\N	289696	0	180256009	4107731	
61958	5343	4107731	1997-06-15	1997-06-15 00:00:00	38000275	0	\N	\N	355907	0	180256009	4107731	
50182	4374	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	290489	0	180256009	4107731	
50663	4412	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	293348	0	180256009	4107731	
50748	4418	4043071	1960-11-27	1960-11-27 00:00:00	38000275	0	\N	\N	293760	0	228557008	4043071	
39615	3483	4043071	1962-10-29	1962-10-29 00:00:00	38000275	0	\N	\N	231017	0	228557008	4043071	
51897	4500	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	299551	0	180256009	4107731	
52133	4520	4035793	1986-12-13	1986-12-13 00:00:00	38000275	0	\N	\N	300925	0	15081005	4035793	
52376	4543	4295880	2000-05-27	2000-05-27 00:00:00	38000275	0	\N	\N	302638	0	76601001	4295880	
41024	3603	4107731	1991-05-05	1991-05-05 00:00:00	38000275	0	\N	\N	239447	0	180256009	4107731	
53212	4623	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	307900	0	180256009	4107731	
53851	4675	4078793	2002-12-22	2002-12-22 00:00:00	38000275	0	\N	\N	311517	0	180325003	4078793	
53983	4694	4107731	1998-01-25	1998-01-25 00:00:00	38000275	0	\N	\N	312772	0	180256009	4107731	
42611	3759	4107731	1992-02-23	1992-02-23 00:00:00	38000275	0	\N	\N	249917	0	180256009	4107731	
54696	4745	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	315907	0	180256009	4107731	
54939	4761	4107731	1996-03-04	1996-03-04 00:00:00	38000275	0	\N	\N	317266	0	180256009	4107731	
43374	3832	4151422	1993-08-23	1993-08-23 00:00:00	38000275	0	\N	\N	254453	0	269911007	4151422	
55354	4826	4330583	1989-06-13	1989-06-13 00:00:00	38000275	0	\N	\N	321047	0	22523008	4330583	
56065	4890	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	325185	0	180256009	4107731	
44159	3884	4107731	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	258077	0	180256009	4107731	
45234	3984	4170947	2018-07-21	2018-07-21 00:00:00	38000275	0	\N	\N	264888	0	274474001	4170947	
57327	4970	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	330372	0	180256009	4107731	
57677	5000	4047491	2011-03-06	2011-03-06 00:00:00	38000275	0	\N	\N	332555	0	1225002	4047491	
58079	5037	4295880	1999-05-05	1999-05-05 00:00:00	38000275	0	\N	\N	334788	0	76601001	4295880	
58239	5048	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	335538	0	180256009	4107731	
58452	5051	4107731	1991-03-14	1991-03-14 00:00:00	38000275	0	\N	\N	335874	0	180256009	4107731	
59206	5119	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	340356	0	180256009	4107731	
36016	3158	4170947	1964-05-22	1964-05-22 00:00:00	38000275	0	\N	\N	209945	0	274474001	4170947	
48182	4224	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	280572	0	180256009	4107731	
36457	3201	4293740	1973-04-19	1973-04-19 00:00:00	38000275	0	\N	\N	212918	0	384700001	4293740	
60468	5222	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	347444	0	180256009	4107731	
48740	4282	4047491	1970-02-14	1970-02-14 00:00:00	38000275	0	\N	\N	284192	0	1225002	4047491	
60813	5267	4107731	1996-04-06	1996-04-06 00:00:00	38000275	0	\N	\N	350383	0	180256009	4107731	
49167	4313	4107731	1990-09-15	1990-09-15 00:00:00	38000275	0	\N	\N	286259	0	180256009	4107731	
49250	4320	4151422	2018-07-22	2018-07-22 00:00:00	38000275	0	\N	\N	286679	0	269911007	4151422	
61521	5322	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	354082	0	395142003	4191853	
49803	4366	4191853	1997-11-11	1997-11-11 00:00:00	38000275	0	\N	\N	289729	0	395142003	4191853	
61959	5343	4107731	1998-11-22	1998-11-22 00:00:00	38000275	0	\N	\N	355821	0	180256009	4107731	
50183	4374	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	290452	0	180256009	4107731	
50664	4412	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	293375	0	180256009	4107731	
50749	4418	4043071	1960-10-23	1960-10-23 00:00:00	38000275	0	\N	\N	293759	0	228557008	4043071	
39616	3483	4043071	1963-10-28	1963-10-28 00:00:00	38000275	0	\N	\N	231076	0	228557008	4043071	
51898	4500	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	299530	0	180256009	4107731	
52134	4520	4035793	1984-12-01	1984-12-01 00:00:00	38000275	0	\N	\N	300924	0	15081005	4035793	
52377	4543	4295880	1995-03-04	1995-03-04 00:00:00	38000275	0	\N	\N	302589	0	76601001	4295880	
41025	3603	4107731	1990-09-16	1990-09-16 00:00:00	38000275	0	\N	\N	239445	0	180256009	4107731	
53213	4623	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	307901	0	180256009	4107731	
53852	4676	4170947	1981-08-21	1981-08-21 00:00:00	38000275	0	\N	\N	311618	0	274474001	4170947	
53984	4694	4295880	2002-09-29	2002-09-29 00:00:00	38000275	0	\N	\N	312679	0	76601001	4295880	
42612	3759	4107731	1990-12-30	1990-12-30 00:00:00	38000275	0	\N	\N	249982	0	180256009	4107731	
54703	4748	4252419	1997-07-19	1997-07-19 00:00:00	38000275	0	\N	\N	316222	0	74016001	4252419	
54940	4761	4107731	1993-07-12	1993-07-12 00:00:00	38000275	0	\N	\N	317223	0	180256009	4107731	
43375	3832	4197460	2010-12-21	2010-12-21 00:00:00	38000275	0	\N	\N	254429	0	313191000	4197460	
55355	4826	4107731	1992-02-22	1992-02-22 00:00:00	38000275	0	\N	\N	320941	0	180256009	4107731	
56066	4890	4078793	2015-01-07	2015-01-07 00:00:00	38000275	0	\N	\N	325076	0	180325003	4078793	
44160	3884	4191853	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	258114	0	395142003	4191853	
45235	3984	4195803	2018-07-21	2018-07-21 00:00:00	38000275	0	\N	\N	264888	0	312681000	4195803	
57328	4970	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	330480	0	180256009	4107731	
57678	5000	4170947	2011-03-06	2011-03-06 00:00:00	38000275	0	\N	\N	332555	0	274474001	4170947	
58080	5037	4295880	1998-11-04	1998-11-04 00:00:00	38000275	0	\N	\N	334813	0	76601001	4295880	
58240	5048	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	335540	0	180256009	4107731	
58453	5051	4107731	1993-06-10	1993-06-10 00:00:00	38000275	0	\N	\N	335884	0	180256009	4107731	
59207	5119	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	340347	0	180256009	4107731	
36017	3158	4047491	1964-05-22	1964-05-22 00:00:00	38000275	0	\N	\N	209945	0	1225002	4047491	
48183	4224	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	280518	0	180256009	4107731	
36458	3201	4202451	1984-12-26	1984-12-26 00:00:00	38000275	0	\N	\N	212903	0	433112001	4202451	
60469	5222	4151422	1924-01-15	1924-01-15 00:00:00	38000275	0	\N	\N	347362	0	269911007	4151422	
48741	4283	4301346	1955-11-26	1955-11-26 00:00:00	38000275	0	\N	\N	284277	0	387685009	4301346	
60814	5267	4107731	1999-05-15	1999-05-15 00:00:00	38000275	0	\N	\N	350397	0	180256009	4107731	
49168	4313	4107731	1992-12-12	1992-12-12 00:00:00	38000275	0	\N	\N	286242	0	180256009	4107731	
49251	4321	4151422	1968-09-30	1968-09-30 00:00:00	38000275	0	\N	\N	286754	0	269911007	4151422	
61522	5322	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	354163	0	180256009	4107731	
49804	4366	4191853	1994-05-10	1994-05-10 00:00:00	38000275	0	\N	\N	289673	0	395142003	4191853	
61960	5343	4107731	1997-01-19	1997-01-19 00:00:00	38000275	0	\N	\N	355916	0	180256009	4107731	
50184	4374	4295880	1994-02-03	1994-02-03 00:00:00	38000275	0	\N	\N	290533	0	76601001	4295880	
50665	4412	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	293395	0	180256009	4107731	
50750	4418	4043071	1961-01-01	1961-01-01 00:00:00	38000275	0	\N	\N	293763	0	228557008	4043071	
39617	3483	4047491	1970-05-09	1970-05-09 00:00:00	38000275	0	\N	\N	231117	0	1225002	4047491	
51899	4500	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	299616	0	180256009	4107731	
52135	4520	4035793	1987-12-19	1987-12-19 00:00:00	38000275	0	\N	\N	300933	0	15081005	4035793	
52378	4543	4295880	1998-02-28	1998-02-28 00:00:00	38000275	0	\N	\N	302649	0	76601001	4295880	
41026	3603	4107731	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	239333	0	180256009	4107731	
53214	4623	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	307985	0	180256009	4107731	
53853	4676	4047491	1981-08-21	1981-08-21 00:00:00	38000275	0	\N	\N	311618	0	1225002	4047491	
53985	4694	4107731	1997-06-08	1997-06-08 00:00:00	38000275	0	\N	\N	312770	0	180256009	4107731	
42613	3759	4107731	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	249901	0	180256009	4107731	
54704	4748	4243062	1946-08-27	1946-08-27 00:00:00	38000275	0	\N	\N	316139	0	60027007	4243062	
54941	4761	4107731	1996-07-08	1996-07-08 00:00:00	38000275	0	\N	\N	317232	0	180256009	4107731	
43376	3832	4191853	1984-11-17	1984-11-17 00:00:00	38000275	0	\N	\N	254407	0	395142003	4191853	
55356	4826	4107731	1991-04-13	1991-04-13 00:00:00	38000275	0	\N	\N	320937	0	180256009	4107731	
56067	4890	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	325093	0	180256009	4107731	
44161	3884	4043071	1989-07-01	1989-07-01 00:00:00	38000275	0	\N	\N	258090	0	228557008	4043071	
45236	3984	4047491	2018-07-21	2018-07-21 00:00:00	38000275	0	\N	\N	264888	0	1225002	4047491	
57329	4970	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	330448	0	180256009	4107731	
57679	5000	4195803	2011-03-06	2011-03-06 00:00:00	38000275	0	\N	\N	332555	0	312681000	4195803	
58081	5037	4295880	1996-08-07	1996-08-07 00:00:00	38000275	0	\N	\N	334810	0	76601001	4295880	
58241	5048	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	335492	0	180256009	4107731	
58454	5051	4107731	1991-08-29	1991-08-29 00:00:00	38000275	0	\N	\N	335928	0	180256009	4107731	
59208	5119	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	340340	0	180256009	4107731	
36018	3158	4043071	1964-02-20	1964-02-20 00:00:00	38000275	0	\N	\N	210005	0	228557008	4043071	
48184	4226	4107731	1991-10-20	1991-10-20 00:00:00	38000275	0	\N	\N	280687	0	180256009	4107731	
36459	3201	4125906	1964-09-19	1964-09-19 00:00:00	38000275	0	\N	\N	212917	0	288086009	4125906	
60470	5222	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	347460	0	180256009	4107731	
48742	4283	4170947	1959-02-08	1959-02-08 00:00:00	38000275	0	\N	\N	284280	0	274474001	4170947	
60815	5267	4107731	1997-08-23	1997-08-23 00:00:00	38000275	0	\N	\N	350436	0	180256009	4107731	
49169	4313	4107731	1990-11-17	1990-11-17 00:00:00	38000275	0	\N	\N	286353	0	180256009	4107731	
49252	4321	4125906	1965-11-14	1965-11-14 00:00:00	38000275	0	\N	\N	286751	0	288086009	4125906	
61523	5322	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	354185	0	180256009	4107731	
49805	4366	4107731	1997-09-09	1997-09-09 00:00:00	38000275	0	\N	\N	289610	0	180256009	4107731	
61961	5343	4107731	1997-09-28	1997-09-28 00:00:00	38000275	0	\N	\N	355886	0	180256009	4107731	
50185	4374	4125906	2003-12-16	2003-12-16 00:00:00	38000275	0	\N	\N	290538	0	288086009	4125906	
50666	4412	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	293342	0	180256009	4107731	
50823	4423	4058899	1979-03-04	1979-03-04 00:00:00	38000275	0	\N	\N	294120	0	168594001	4058899	
39618	3483	4170947	1970-05-09	1970-05-09 00:00:00	38000275	0	\N	\N	231117	0	274474001	4170947	
51900	4500	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	299569	0	180256009	4107731	
52136	4520	4035793	1993-01-16	1993-01-16 00:00:00	38000275	0	\N	\N	300928	0	15081005	4035793	
52379	4543	4295880	1996-03-02	1996-03-02 00:00:00	38000275	0	\N	\N	302625	0	76601001	4295880	
41027	3603	4107731	1990-11-18	1990-11-18 00:00:00	38000275	0	\N	\N	239408	0	180256009	4107731	
53215	4623	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	307958	0	180256009	4107731	
53854	4676	4037675	1983-08-01	1983-08-01 00:00:00	38000275	0	\N	\N	311586	0	162676008	4037675	
53986	4694	4107731	1996-11-10	1996-11-10 00:00:00	38000275	0	\N	\N	312690	0	180256009	4107731	
42614	3759	4107731	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	249922	0	180256009	4107731	
54705	4748	4125906	1982-10-22	1982-10-22 00:00:00	38000275	0	\N	\N	316220	0	288086009	4125906	
54942	4761	4107731	1995-06-26	1995-06-26 00:00:00	38000275	0	\N	\N	317284	0	180256009	4107731	
43377	3833	4125906	2005-10-27	2005-10-27 00:00:00	38000275	0	\N	\N	254527	0	288086009	4125906	
55357	4826	4107731	1991-06-15	1991-06-15 00:00:00	38000275	0	\N	\N	320969	0	180256009	4107731	
56068	4890	4078793	2009-12-09	2009-12-09 00:00:00	38000275	0	\N	\N	325166	0	180325003	4078793	
44162	3884	4107731	1992-02-17	1992-02-17 00:00:00	38000275	0	\N	\N	258173	0	180256009	4107731	
45237	3984	4057420	2015-12-02	2015-12-02 00:00:00	38000275	0	\N	\N	264815	0	18286008	4057420	
57330	4970	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	330432	0	180256009	4107731	
57680	5001	4125906	1993-09-24	1993-09-24 00:00:00	38000275	0	\N	\N	332671	0	288086009	4125906	
58082	5037	4275113	2006-11-24	2006-11-24 00:00:00	38000275	0	\N	\N	334798	0	65200003	4275113	
58242	5048	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	335472	0	180256009	4107731	
58455	5051	4107731	1991-08-08	1991-08-08 00:00:00	38000275	0	\N	\N	335861	0	180256009	4107731	
59209	5119	4107731	1992-01-07	1992-01-07 00:00:00	38000275	0	\N	\N	340411	0	180256009	4107731	
36019	3158	4202451	2002-01-10	2002-01-10 00:00:00	38000275	0	\N	\N	209966	0	433112001	4202451	
48185	4226	4107731	1992-11-01	1992-11-01 00:00:00	38000275	0	\N	\N	280755	0	180256009	4107731	
48247	4227	4238715	1978-01-29	1978-01-29 00:00:00	38000275	0	\N	\N	280822	0	68254000	4238715	
60471	5222	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	347392	0	180256009	4107731	
48743	4283	4024289	1959-02-08	1959-02-08 00:00:00	38000275	0	\N	\N	284280	0	19490002	4024289	
60816	5267	4107731	1998-07-04	1998-07-04 00:00:00	38000275	0	\N	\N	350440	0	180256009	4107731	
49170	4313	4107731	1991-09-28	1991-09-28 00:00:00	38000275	0	\N	\N	286323	0	180256009	4107731	
49253	4321	4293740	1965-11-14	1965-11-14 00:00:00	38000275	0	\N	\N	286751	0	384700001	4293740	
49806	4366	4107731	1997-05-27	1997-05-27 00:00:00	38000275	0	\N	\N	289619	0	180256009	4107731	
61962	5343	4107731	1999-05-30	1999-05-30 00:00:00	38000275	0	\N	\N	355934	0	180256009	4107731	
50186	4374	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	290528	0	180256009	4107731	
50667	4412	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	293366	0	180256009	4107731	
50824	4423	40492359	1989-04-21	1989-04-21 00:00:00	38000275	0	\N	\N	294121	0	447365002	40492359	
39619	3483	4043071	1964-04-13	1964-04-13 00:00:00	38000275	0	\N	\N	231123	0	228557008	4043071	
51901	4500	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	299529	0	180256009	4107731	
52137	4520	4035793	1992-01-11	1992-01-11 00:00:00	38000275	0	\N	\N	300935	0	15081005	4035793	
52380	4543	4295880	1996-11-30	1996-11-30 00:00:00	38000275	0	\N	\N	302626	0	76601001	4295880	
41028	3603	4107731	1990-06-03	1990-06-03 00:00:00	38000275	0	\N	\N	239419	0	180256009	4107731	
53216	4623	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	307960	0	180256009	4107731	
53855	4676	4326177	1983-08-01	1983-08-01 00:00:00	38000275	0	\N	\N	311586	0	430193006	4326177	
53987	4694	4107731	1997-08-10	1997-08-10 00:00:00	38000275	0	\N	\N	312673	0	180256009	4107731	
42615	3759	4107731	1992-02-02	1992-02-02 00:00:00	38000275	0	\N	\N	249988	0	180256009	4107731	
54706	4748	4170947	1946-08-27	1946-08-27 00:00:00	38000275	0	\N	\N	316139	0	274474001	4170947	
54943	4761	4191853	1984-05-29	1984-05-29 00:00:00	38000275	0	\N	\N	317259	0	395142003	4191853	
43378	3833	4047491	1976-04-02	1976-04-02 00:00:00	38000275	0	\N	\N	254526	0	1225002	4047491	
55358	4826	4107731	1990-06-23	1990-06-23 00:00:00	38000275	0	\N	\N	320964	0	180256009	4107731	
56069	4890	4078793	2019-01-30	2019-01-30 00:00:00	38000275	0	\N	\N	325091	0	180325003	4078793	
44163	3884	4043071	1986-04-19	1986-04-19 00:00:00	38000275	0	\N	\N	258043	0	228557008	4043071	
45238	3984	4151422	2008-10-16	2008-10-16 00:00:00	38000275	0	\N	\N	264844	0	269911007	4151422	
57331	4970	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	330367	0	180256009	4107731	
57681	5001	4293740	1993-09-24	1993-09-24 00:00:00	38000275	0	\N	\N	332671	0	384700001	4293740	
58083	5037	4295880	2006-01-25	2006-01-25 00:00:00	38000275	0	\N	\N	334748	0	76601001	4295880	
58243	5048	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	335532	0	180256009	4107731	
58456	5051	4107731	1991-09-19	1991-09-19 00:00:00	38000275	0	\N	\N	335875	0	180256009	4107731	
59210	5119	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	340387	0	180256009	4107731	
36020	3159	4202451	2001-05-03	2001-05-03 00:00:00	38000275	0	\N	\N	210030	0	433112001	4202451	
48186	4226	4107731	1990-08-05	1990-08-05 00:00:00	38000275	0	\N	\N	280726	0	180256009	4107731	
48248	4227	4186930	1976-02-01	1976-02-01 00:00:00	38000275	0	\N	\N	280860	0	46706006	4186930	
60472	5222	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	347462	0	180256009	4107731	
48744	4283	4170947	1953-10-30	1953-10-30 00:00:00	38000275	0	\N	\N	284278	0	274474001	4170947	
60817	5267	4107731	1997-07-12	1997-07-12 00:00:00	38000275	0	\N	\N	350435	0	180256009	4107731	
49171	4313	4107731	1991-07-27	1991-07-27 00:00:00	38000275	0	\N	\N	286263	0	180256009	4107731	
49254	4321	4151422	1993-08-18	1993-08-18 00:00:00	38000275	0	\N	\N	286705	0	269911007	4151422	
49807	4366	4107731	1997-07-29	1997-07-29 00:00:00	38000275	0	\N	\N	289609	0	180256009	4107731	
61963	5343	4107731	1997-07-27	1997-07-27 00:00:00	38000275	0	\N	\N	355908	0	180256009	4107731	
50187	4374	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	290559	0	180256009	4107731	
50668	4412	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	293360	0	180256009	4107731	
50825	4423	4057420	1989-04-21	1989-04-21 00:00:00	38000275	0	\N	\N	294121	0	18286008	4057420	
39620	3483	4043071	1962-09-24	1962-09-24 00:00:00	38000275	0	\N	\N	231016	0	228557008	4043071	
51902	4500	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	299543	0	180256009	4107731	
52138	4520	4216130	1996-09-28	1996-09-28 00:00:00	38000275	0	\N	\N	300940	0	415070008	4216130	
52381	4543	4295880	1996-06-01	1996-06-01 00:00:00	38000275	0	\N	\N	302634	0	76601001	4295880	
41029	3603	4107731	1992-02-02	1992-02-02 00:00:00	38000275	0	\N	\N	239348	0	180256009	4107731	
53217	4623	4107731	1992-02-18	1992-02-18 00:00:00	38000275	0	\N	\N	307912	0	180256009	4107731	
53856	4676	4187458	1983-08-01	1983-08-01 00:00:00	38000275	0	\N	\N	311586	0	415300000	4187458	
53988	4694	4295880	2002-12-29	2002-12-29 00:00:00	38000275	0	\N	\N	312766	0	76601001	4295880	
42616	3759	4107731	1992-01-12	1992-01-12 00:00:00	38000275	0	\N	\N	249916	0	180256009	4107731	
54707	4748	4024289	1984-10-25	1984-10-25 00:00:00	38000275	0	\N	\N	316221	0	19490002	4024289	
54944	4763	4252419	1983-06-21	1983-06-21 00:00:00	38000275	0	\N	\N	317455	0	74016001	4252419	
43379	3833	4170947	1976-04-02	1976-04-02 00:00:00	38000275	0	\N	\N	254526	0	274474001	4170947	
55359	4826	4107731	1990-06-02	1990-06-02 00:00:00	38000275	0	\N	\N	321072	0	180256009	4107731	
56070	4890	4195803	2000-09-06	2000-09-06 00:00:00	38000275	0	\N	\N	325251	0	312681000	4195803	
44164	3884	4043071	1987-07-11	1987-07-11 00:00:00	38000275	0	\N	\N	258029	0	228557008	4043071	
45239	3984	4078793	2017-12-13	2017-12-13 00:00:00	38000275	0	\N	\N	264816	0	180325003	4078793	
57332	4970	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	330383	0	180256009	4107731	
57682	5001	4151422	1961-01-19	1961-01-19 00:00:00	38000275	0	\N	\N	332615	0	269911007	4151422	
58084	5037	4295880	2005-04-27	2005-04-27 00:00:00	38000275	0	\N	\N	334767	0	76601001	4295880	
58244	5048	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	335514	0	180256009	4107731	
58457	5051	4107731	1993-12-16	1993-12-16 00:00:00	38000275	0	\N	\N	335841	0	180256009	4107731	
59211	5119	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	340345	0	180256009	4107731	
36021	3159	4058899	1994-12-18	1994-12-18 00:00:00	38000275	0	\N	\N	210081	0	168594001	4058899	
48187	4226	4107731	1993-02-14	1993-02-14 00:00:00	38000275	0	\N	\N	280658	0	180256009	4107731	
48249	4227	40492359	2003-04-06	2003-04-06 00:00:00	38000275	0	\N	\N	280798	0	447365002	40492359	
60473	5222	4078793	2015-08-06	2015-08-06 00:00:00	38000275	0	\N	\N	347469	0	180325003	4078793	
48745	4283	4024289	1953-10-30	1953-10-30 00:00:00	38000275	0	\N	\N	284278	0	19490002	4024289	
60818	5267	4107731	1996-08-10	1996-08-10 00:00:00	38000275	0	\N	\N	350386	0	180256009	4107731	
49172	4313	4107731	1991-01-19	1991-01-19 00:00:00	38000275	0	\N	\N	286281	0	180256009	4107731	
49255	4321	4151422	2002-10-05	2002-10-05 00:00:00	38000275	0	\N	\N	286755	0	269911007	4151422	
49808	4366	4107731	1995-09-26	1995-09-26 00:00:00	38000275	0	\N	\N	289627	0	180256009	4107731	
61964	5343	4191853	1984-05-11	1984-05-11 00:00:00	38000275	0	\N	\N	355857	0	395142003	4191853	
50188	4374	4125906	1986-03-29	1986-03-29 00:00:00	38000275	0	\N	\N	290537	0	288086009	4125906	
50669	4412	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	293281	0	180256009	4107731	
39621	3483	4043071	1962-04-30	1962-04-30 00:00:00	38000275	0	\N	\N	231072	0	228557008	4043071	
51903	4500	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	299614	0	180256009	4107731	
52139	4520	4336464	1996-09-28	1996-09-28 00:00:00	38000275	0	\N	\N	300940	0	232717009	4336464	
52382	4543	4295880	1999-11-27	1999-11-27 00:00:00	38000275	0	\N	\N	302593	0	76601001	4295880	
41030	3603	4198190	1967-02-08	1967-02-08 00:00:00	38000275	0	\N	\N	239405	0	80146002	4198190	
53218	4623	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	307976	0	180256009	4107731	
53989	4694	4107731	1995-07-16	1995-07-16 00:00:00	38000275	0	\N	\N	312741	0	180256009	4107731	
42617	3759	4107731	1991-11-10	1991-11-10 00:00:00	38000275	0	\N	\N	249986	0	180256009	4107731	
54708	4748	4170947	1984-10-25	1984-10-25 00:00:00	38000275	0	\N	\N	316221	0	274474001	4170947	
54945	4763	4058899	1966-08-19	1966-08-19 00:00:00	38000275	0	\N	\N	317454	0	168594001	4058899	
43380	3833	4163872	1971-04-29	1971-04-29 00:00:00	38000275	0	\N	\N	254525	0	399208008	4163872	
55360	4826	4107731	1992-08-29	1992-08-29 00:00:00	38000275	0	\N	\N	320950	0	180256009	4107731	
56071	4890	4125906	1942-05-13	1942-05-13 00:00:00	38000275	0	\N	\N	325143	0	288086009	4125906	
44165	3884	4107731	1991-07-22	1991-07-22 00:00:00	38000275	0	\N	\N	258073	0	180256009	4107731	
45240	3984	4078793	2018-12-19	2018-12-19 00:00:00	38000275	0	\N	\N	264867	0	180325003	4078793	
57333	4970	4170947	1962-06-27	1962-06-27 00:00:00	38000275	0	\N	\N	330395	0	274474001	4170947	
57683	5001	44783196	1975-05-02	1975-05-02 00:00:00	38000275	0	\N	\N	332614	0	699253003	44783196	
58085	5037	4295880	2006-07-26	2006-07-26 00:00:00	38000275	0	\N	\N	334818	0	76601001	4295880	
58245	5048	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	335422	0	180256009	4107731	
58458	5051	4107731	1992-07-09	1992-07-09 00:00:00	38000275	0	\N	\N	335852	0	180256009	4107731	
59212	5119	4151422	1997-10-24	1997-10-24 00:00:00	38000275	0	\N	\N	340418	0	269911007	4151422	
36022	3159	4058899	1970-06-27	1970-06-27 00:00:00	38000275	0	\N	\N	210080	0	168594001	4058899	
48188	4226	4107731	1992-04-26	1992-04-26 00:00:00	38000275	0	\N	\N	280688	0	180256009	4107731	
48250	4227	4057420	2003-04-06	2003-04-06 00:00:00	38000275	0	\N	\N	280798	0	18286008	4057420	
60474	5222	4035793	2015-08-06	2015-08-06 00:00:00	38000275	0	\N	\N	347469	0	15081005	4035793	
48746	4283	4145310	1956-12-20	1956-12-20 00:00:00	38000275	0	\N	\N	284279	0	268425006	4145310	
60819	5267	4107731	1996-06-29	1996-06-29 00:00:00	38000275	0	\N	\N	350385	0	180256009	4107731	
49173	4313	4107731	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	286351	0	180256009	4107731	
49257	4324	4191853	1981-06-30	1981-06-30 00:00:00	38000275	0	\N	\N	286849	0	395142003	4191853	
49809	4366	4107731	1994-11-15	1994-11-15 00:00:00	38000275	0	\N	\N	289623	0	180256009	4107731	
61965	5343	4107731	1998-03-15	1998-03-15 00:00:00	38000275	0	\N	\N	355901	0	180256009	4107731	
50189	4374	4295880	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	290486	0	76601001	4295880	
50670	4412	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	293338	0	180256009	4107731	
39622	3483	4043071	1963-12-02	1963-12-02 00:00:00	38000275	0	\N	\N	231056	0	228557008	4043071	
51904	4500	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	299649	0	180256009	4107731	
52140	4520	4035793	1995-01-28	1995-01-28 00:00:00	38000275	0	\N	\N	300961	0	15081005	4035793	
52383	4543	4295880	2000-08-26	2000-08-26 00:00:00	38000275	0	\N	\N	302617	0	76601001	4295880	
41031	3603	4107731	1992-11-01	1992-11-01 00:00:00	38000275	0	\N	\N	239351	0	180256009	4107731	
53219	4623	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	307904	0	180256009	4107731	
53990	4694	4107731	1995-03-12	1995-03-12 00:00:00	38000275	0	\N	\N	312656	0	180256009	4107731	
42618	3759	4107731	1990-10-07	1990-10-07 00:00:00	38000275	0	\N	\N	249955	0	180256009	4107731	
54709	4748	4151422	1959-03-23	1959-03-23 00:00:00	38000275	0	\N	\N	316157	0	269911007	4151422	
54946	4763	4252419	1989-11-21	1989-11-21 00:00:00	38000275	0	\N	\N	317457	0	74016001	4252419	
43381	3833	4170947	1971-04-29	1971-04-29 00:00:00	38000275	0	\N	\N	254525	0	274474001	4170947	
55361	4827	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	321172	0	180256009	4107731	
56072	4890	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	325121	0	180256009	4107731	
44166	3884	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	258053	0	180256009	4107731	
45241	3984	4057420	2016-12-07	2016-12-07 00:00:00	38000275	0	\N	\N	264866	0	18286008	4057420	
57334	4970	4047491	1962-06-27	1962-06-27 00:00:00	38000275	0	\N	\N	330395	0	1225002	4047491	
57684	5001	4252419	1975-04-25	1975-04-25 00:00:00	38000275	0	\N	\N	332670	0	74016001	4252419	
58086	5037	4125906	1994-12-14	1994-12-14 00:00:00	38000275	0	\N	\N	334734	0	288086009	4125906	
58246	5048	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	335426	0	180256009	4107731	
58459	5051	4107731	1993-09-23	1993-09-23 00:00:00	38000275	0	\N	\N	335869	0	180256009	4107731	
59213	5119	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	340318	0	180256009	4107731	
36041	3161	4125906	1970-07-08	1970-07-08 00:00:00	38000275	0	\N	\N	210203	0	288086009	4125906	
48189	4226	4107731	1991-01-20	1991-01-20 00:00:00	38000275	0	\N	\N	280733	0	180256009	4107731	
48251	4227	4275113	1971-02-01	1971-02-01 00:00:00	38000275	0	\N	\N	280851	0	65200003	4275113	
60475	5222	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	347456	0	180256009	4107731	
48747	4283	4170947	1961-06-27	1961-06-27 00:00:00	38000275	0	\N	\N	284274	0	274474001	4170947	
60820	5267	4107731	1998-04-11	1998-04-11 00:00:00	38000275	0	\N	\N	350438	0	180256009	4107731	
49174	4313	4107731	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	286287	0	180256009	4107731	
49258	4324	4125906	1980-07-31	1980-07-31 00:00:00	38000275	0	\N	\N	286823	0	288086009	4125906	
49810	4366	4107731	1994-10-04	1994-10-04 00:00:00	38000275	0	\N	\N	289622	0	180256009	4107731	
61966	5343	4107731	1998-11-01	1998-11-01 00:00:00	38000275	0	\N	\N	355903	0	180256009	4107731	
50190	4374	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	290477	0	180256009	4107731	
50671	4412	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	293327	0	180256009	4107731	
39623	3483	4043071	1962-06-04	1962-06-04 00:00:00	38000275	0	\N	\N	231073	0	228557008	4043071	
51905	4500	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	299570	0	395142003	4191853	
52141	4520	4035793	1991-01-05	1991-01-05 00:00:00	38000275	0	\N	\N	300927	0	15081005	4035793	
52384	4543	4295880	1997-05-31	1997-05-31 00:00:00	38000275	0	\N	\N	302648	0	76601001	4295880	
41032	3603	4107731	1992-01-12	1992-01-12 00:00:00	38000275	0	\N	\N	239328	0	180256009	4107731	
53220	4623	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	307946	0	180256009	4107731	
53991	4694	4107731	1995-06-25	1995-06-25 00:00:00	38000275	0	\N	\N	312755	0	180256009	4107731	
42619	3759	4107731	1993-01-24	1993-01-24 00:00:00	38000275	0	\N	\N	249906	0	180256009	4107731	
54710	4748	4024289	1976-03-27	1976-03-27 00:00:00	38000275	0	\N	\N	316219	0	19490002	4024289	
54947	4763	4151422	2009-04-23	2009-04-23 00:00:00	38000275	0	\N	\N	317380	0	269911007	4151422	
43382	3834	4047491	1963-10-03	1963-10-03 00:00:00	38000275	0	\N	\N	254587	0	1225002	4047491	
55362	4827	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	321177	0	180256009	4107731	
56073	4890	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	325152	0	180256009	4107731	
44167	3884	4107731	1991-11-04	1991-11-04 00:00:00	38000275	0	\N	\N	258209	0	180256009	4107731	
45242	3984	4078793	2014-11-26	2014-11-26 00:00:00	38000275	0	\N	\N	264884	0	180325003	4078793	
57335	4970	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	330455	0	180256009	4107731	
57685	5001	4163872	2000-06-07	2000-06-07 00:00:00	38000275	0	\N	\N	332655	0	399208008	4163872	
58087	5037	4293740	1994-12-14	1994-12-14 00:00:00	38000275	0	\N	\N	334734	0	384700001	4293740	
58247	5048	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	335423	0	180256009	4107731	
58460	5051	4107731	1992-03-05	1992-03-05 00:00:00	38000275	0	\N	\N	335929	0	180256009	4107731	
59214	5119	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	340312	0	180256009	4107731	
36042	3161	4058899	1979-11-09	1979-11-09 00:00:00	38000275	0	\N	\N	210204	0	168594001	4058899	
48190	4226	4107731	1990-10-28	1990-10-28 00:00:00	38000275	0	\N	\N	280697	0	180256009	4107731	
48252	4227	4125906	1969-06-29	1969-06-29 00:00:00	38000275	0	\N	\N	280796	0	288086009	4125906	
60476	5222	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	347487	0	180256009	4107731	
48748	4283	4047491	1961-06-27	1961-06-27 00:00:00	38000275	0	\N	\N	284274	0	1225002	4047491	
60821	5267	4107731	1996-08-31	1996-08-31 00:00:00	38000275	0	\N	\N	350365	0	180256009	4107731	
49175	4313	4107731	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	286328	0	180256009	4107731	
49259	4325	4151422	2014-08-19	2014-08-19 00:00:00	38000275	0	\N	\N	286888	0	269911007	4151422	
49811	4366	4107731	1996-05-14	1996-05-14 00:00:00	38000275	0	\N	\N	289629	0	180256009	4107731	
61967	5343	4107731	1997-11-30	1997-11-30 00:00:00	38000275	0	\N	\N	355920	0	180256009	4107731	
50191	4374	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	290557	0	180256009	4107731	
50672	4412	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	293368	0	180256009	4107731	
39624	3483	4043071	1963-08-26	1963-08-26 00:00:00	38000275	0	\N	\N	231097	0	228557008	4043071	
51906	4500	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	299545	0	180256009	4107731	
52142	4520	4035793	1982-11-20	1982-11-20 00:00:00	38000275	0	\N	\N	300960	0	15081005	4035793	
52385	4543	4295880	2000-11-25	2000-11-25 00:00:00	38000275	0	\N	\N	302579	0	76601001	4295880	
41033	3603	4107731	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	239401	0	180256009	4107731	
53221	4623	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	307932	0	180256009	4107731	
53992	4694	4107731	1997-04-06	1997-04-06 00:00:00	38000275	0	\N	\N	312670	0	180256009	4107731	
42620	3759	4107731	1991-05-05	1991-05-05 00:00:00	38000275	0	\N	\N	249985	0	180256009	4107731	
54711	4748	4170947	1976-03-27	1976-03-27 00:00:00	38000275	0	\N	\N	316219	0	274474001	4170947	
43383	3834	4170947	1963-10-03	1963-10-03 00:00:00	38000275	0	\N	\N	254587	0	274474001	4170947	
55363	4827	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	321117	0	180256009	4107731	
56074	4890	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	325151	0	180256009	4107731	
44168	3884	4043071	1986-05-24	1986-05-24 00:00:00	38000275	0	\N	\N	258110	0	228557008	4043071	
45245	3986	4125906	1990-04-09	1990-04-09 00:00:00	38000275	0	\N	\N	265021	0	288086009	4125906	
57336	4970	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	330416	0	180256009	4107731	
57686	5001	4058899	1973-05-05	1973-05-05 00:00:00	38000275	0	\N	\N	332685	0	168594001	4058899	
58088	5037	4295880	1994-02-09	1994-02-09 00:00:00	38000275	0	\N	\N	334715	0	76601001	4295880	
58248	5048	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	335498	0	180256009	4107731	
58461	5051	4107731	1993-05-20	1993-05-20 00:00:00	38000275	0	\N	\N	335856	0	180256009	4107731	
59215	5119	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	340373	0	180256009	4107731	
36043	3161	4151422	2018-03-22	2018-03-22 00:00:00	38000275	0	\N	\N	210216	0	269911007	4151422	
48191	4226	4107731	1991-06-16	1991-06-16 00:00:00	38000275	0	\N	\N	280699	0	180256009	4107731	
48253	4227	4293740	1969-06-29	1969-06-29 00:00:00	38000275	0	\N	\N	280796	0	384700001	4293740	
60477	5222	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	347495	0	180256009	4107731	
48749	4283	4151422	1967-03-09	1967-03-09 00:00:00	38000275	0	\N	\N	284262	0	269911007	4151422	
60822	5267	4107731	1997-01-04	1997-01-04 00:00:00	38000275	0	\N	\N	350434	0	180256009	4107731	
49176	4313	4107731	1992-08-29	1992-08-29 00:00:00	38000275	0	\N	\N	286288	0	180256009	4107731	
49261	4328	4151422	2003-08-06	2003-08-06 00:00:00	38000275	0	\N	\N	287035	0	269911007	4151422	
49812	4366	4107731	1995-11-07	1995-11-07 00:00:00	38000275	0	\N	\N	289643	0	180256009	4107731	
61968	5343	4107731	1997-02-09	1997-02-09 00:00:00	38000275	0	\N	\N	355895	0	180256009	4107731	
50192	4374	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	290481	0	180256009	4107731	
50673	4412	4125906	2007-01-18	2007-01-18 00:00:00	38000275	0	\N	\N	293286	0	288086009	4125906	
39625	3483	4043071	1964-07-20	1964-07-20 00:00:00	38000275	0	\N	\N	231022	0	228557008	4043071	
51907	4500	4197460	1962-08-09	1962-08-09 00:00:00	38000275	0	\N	\N	299602	0	313191000	4197460	
52143	4520	4125906	1937-08-28	1937-08-28 00:00:00	38000275	0	\N	\N	300890	0	288086009	4125906	
52386	4543	4295880	1995-09-02	1995-09-02 00:00:00	38000275	0	\N	\N	302633	0	76601001	4295880	
41034	3603	4107731	1993-01-24	1993-01-24 00:00:00	38000275	0	\N	\N	239385	0	180256009	4107731	
53222	4623	4107731	1992-08-25	1992-08-25 00:00:00	38000275	0	\N	\N	307913	0	180256009	4107731	
53993	4694	4107731	1997-02-02	1997-02-02 00:00:00	38000275	0	\N	\N	312692	0	180256009	4107731	
42621	3759	4191853	1983-08-31	1983-08-31 00:00:00	38000275	0	\N	\N	249968	0	395142003	4191853	
54712	4748	44783196	1997-07-26	1997-07-26 00:00:00	38000275	0	\N	\N	316216	0	699253003	44783196	
43384	3834	4125906	2012-04-18	2012-04-18 00:00:00	38000275	0	\N	\N	254589	0	288086009	4125906	
55364	4827	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	321123	0	180256009	4107731	
56075	4890	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	325066	0	395142003	4191853	
44169	3884	4107731	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	258201	0	180256009	4107731	
45246	3986	4125906	1987-04-11	1987-04-11 00:00:00	38000275	0	\N	\N	265020	0	288086009	4125906	
57337	4970	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	330453	0	180256009	4107731	
57687	5001	4125906	1970-01-30	1970-01-30 00:00:00	38000275	0	\N	\N	332684	0	288086009	4125906	
58089	5037	4295880	1993-05-12	1993-05-12 00:00:00	38000275	0	\N	\N	334714	0	76601001	4295880	
58249	5048	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	335427	0	180256009	4107731	
58462	5051	4107731	1991-12-12	1991-12-12 00:00:00	38000275	0	\N	\N	335877	0	180256009	4107731	
59216	5119	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	340309	0	180256009	4107731	
36044	3161	4125906	1960-06-25	1960-06-25 00:00:00	38000275	0	\N	\N	210248	0	288086009	4125906	
48192	4226	4107731	1990-12-30	1990-12-30 00:00:00	38000275	0	\N	\N	280675	0	180256009	4107731	
48255	4229	4151422	1963-06-26	1963-06-26 00:00:00	38000275	0	\N	\N	280960	0	269911007	4151422	
60478	5222	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	347374	0	180256009	4107731	
60589	5236	4043071	1985-01-15	1985-01-15 00:00:00	38000275	0	\N	\N	348419	0	228557008	4043071	
60823	5267	4107731	1998-02-28	1998-02-28 00:00:00	38000275	0	\N	\N	350382	0	180256009	4107731	
49177	4313	4107731	1993-05-29	1993-05-29 00:00:00	38000275	0	\N	\N	286335	0	180256009	4107731	
49262	4328	4170947	1995-06-22	1995-06-22 00:00:00	38000275	0	\N	\N	287016	0	274474001	4170947	
49813	4366	4191853	1982-04-19	1982-04-19 00:00:00	38000275	0	\N	\N	289663	0	395142003	4191853	
61969	5343	4107731	1996-08-04	1996-08-04 00:00:00	38000275	0	\N	\N	355818	0	180256009	4107731	
50193	4374	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	290483	0	180256009	4107731	
50674	4412	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	293331	0	395142003	4191853	
39626	3483	4043071	1963-04-08	1963-04-08 00:00:00	38000275	0	\N	\N	231018	0	228557008	4043071	
51908	4500	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	299571	0	180256009	4107731	
52144	4520	4035793	1994-01-22	1994-01-22 00:00:00	38000275	0	\N	\N	300938	0	15081005	4035793	
52387	4543	4295880	1999-05-29	1999-05-29 00:00:00	38000275	0	\N	\N	302628	0	76601001	4295880	
41035	3603	4107731	1990-10-07	1990-10-07 00:00:00	38000275	0	\N	\N	239407	0	180256009	4107731	
53223	4623	4107731	1990-03-06	1990-03-06 00:00:00	38000275	0	\N	\N	307968	0	180256009	4107731	
53994	4694	4107731	1996-04-14	1996-04-14 00:00:00	38000275	0	\N	\N	312744	0	180256009	4107731	
42622	3759	4107731	1990-02-18	1990-02-18 00:00:00	38000275	0	\N	\N	249970	0	180256009	4107731	
54713	4749	44783196	1999-08-08	1999-08-08 00:00:00	38000275	0	\N	\N	316226	0	699253003	44783196	
55166	4804	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	319598	0	180256009	4107731	
55365	4827	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	321162	0	180256009	4107731	
56076	4890	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	325159	0	180256009	4107731	
44170	3884	4107731	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	258063	0	180256009	4107731	
45247	3986	4125906	2014-08-18	2014-08-18 00:00:00	38000275	0	\N	\N	265025	0	288086009	4125906	
57338	4970	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	330388	0	180256009	4107731	
57688	5002	4243062	1996-03-30	1996-03-30 00:00:00	38000275	0	\N	\N	332714	0	60027007	4243062	
58090	5037	4295880	1997-05-07	1997-05-07 00:00:00	38000275	0	\N	\N	334811	0	76601001	4295880	
58250	5048	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	335475	0	180256009	4107731	
58463	5051	4107731	1993-11-04	1993-11-04 00:00:00	38000275	0	\N	\N	335840	0	180256009	4107731	
59217	5119	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	340355	0	180256009	4107731	
47873	4200	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	278723	0	180256009	4107731	
48193	4226	4107731	1990-02-18	1990-02-18 00:00:00	38000275	0	\N	\N	280671	0	180256009	4107731	
48256	4229	4058899	1957-03-02	1957-03-02 00:00:00	38000275	0	\N	\N	280921	0	168594001	4058899	
60479	5222	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	347342	0	180256009	4107731	
60590	5236	4043071	1984-07-31	1984-07-31 00:00:00	38000275	0	\N	\N	348375	0	228557008	4043071	
60824	5267	4107731	1996-11-02	1996-11-02 00:00:00	38000275	0	\N	\N	350470	0	180256009	4107731	
49178	4313	4107731	1993-03-06	1993-03-06 00:00:00	38000275	0	\N	\N	286244	0	180256009	4107731	
49263	4328	4047491	1995-06-22	1995-06-22 00:00:00	38000275	0	\N	\N	287016	0	1225002	4047491	
49814	4366	4107731	1997-10-21	1997-10-21 00:00:00	38000275	0	\N	\N	289611	0	180256009	4107731	
61970	5343	4191853	1999-07-11	1999-07-11 00:00:00	38000275	0	\N	\N	355823	0	395142003	4191853	
50194	4374	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	290555	0	180256009	4107731	
50675	4412	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	293372	0	180256009	4107731	
39627	3483	4125906	1953-11-20	1953-11-20 00:00:00	38000275	0	\N	\N	231116	0	288086009	4125906	
51909	4500	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	299621	0	180256009	4107731	
52145	4520	4035793	1985-12-07	1985-12-07 00:00:00	38000275	0	\N	\N	300932	0	15081005	4035793	
52388	4544	4336464	1994-02-01	1994-02-01 00:00:00	38000275	0	\N	\N	302672	0	232717009	4336464	
41036	3603	4107731	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	239318	0	180256009	4107731	
53224	4623	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	307957	0	180256009	4107731	
53995	4694	4107731	1995-12-10	1995-12-10 00:00:00	38000275	0	\N	\N	312659	0	180256009	4107731	
42623	3759	4107731	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	249961	0	180256009	4107731	
54714	4749	4151422	1978-07-23	1978-07-23 00:00:00	38000275	0	\N	\N	316237	0	269911007	4151422	
55167	4804	4107731	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	319585	0	180256009	4107731	
55366	4827	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	321183	0	180256009	4107731	
56077	4890	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	325247	0	180256009	4107731	
44171	3884	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	258082	0	180256009	4107731	
45248	3986	4181917	2009-08-13	2009-08-13 00:00:00	38000275	0	\N	\N	265023	0	54550000	4181917	
57339	4970	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	330446	0	180256009	4107731	
57689	5002	4170947	1996-03-30	1996-03-30 00:00:00	38000275	0	\N	\N	332714	0	274474001	4170947	
58091	5037	4295880	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	334776	0	76601001	4295880	
58251	5048	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	335430	0	180256009	4107731	
58464	5051	4107731	1992-09-10	1992-09-10 00:00:00	38000275	0	\N	\N	335880	0	180256009	4107731	
59218	5119	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	340319	0	180256009	4107731	
47874	4200	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	278730	0	180256009	4107731	
48194	4226	4107731	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	280753	0	180256009	4107731	
48257	4229	4151422	2011-10-20	2011-10-20 00:00:00	38000275	0	\N	\N	280903	0	269911007	4151422	
60480	5222	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	347391	0	180256009	4107731	
60591	5236	4145310	1986-07-10	1986-07-10 00:00:00	38000275	0	\N	\N	348426	0	268425006	4145310	
60825	5267	4107731	1996-09-21	1996-09-21 00:00:00	38000275	0	\N	\N	350469	0	180256009	4107731	
49179	4313	4107731	1993-01-02	1993-01-02 00:00:00	38000275	0	\N	\N	286361	0	180256009	4107731	
49264	4328	4151422	1993-12-31	1993-12-31 00:00:00	38000275	0	\N	\N	287015	0	269911007	4151422	
49815	4366	4107731	1995-11-28	1995-11-28 00:00:00	38000275	0	\N	\N	289700	0	180256009	4107731	
61971	5343	4197460	1999-05-11	1999-05-11 00:00:00	38000275	0	\N	\N	355929	0	313191000	4197460	
50195	4374	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	290506	0	180256009	4107731	
50676	4412	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	293280	0	180256009	4107731	
39628	3483	4043071	1964-05-18	1964-05-18 00:00:00	38000275	0	\N	\N	231124	0	228557008	4043071	
51910	4500	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	299651	0	180256009	4107731	
52146	4520	4035793	1996-02-03	1996-02-03 00:00:00	38000275	0	\N	\N	300939	0	15081005	4035793	
52389	4544	4216130	1994-02-01	1994-02-01 00:00:00	38000275	0	\N	\N	302672	0	415070008	4216130	
41037	3603	4107731	1992-11-22	1992-11-22 00:00:00	38000275	0	\N	\N	239332	0	180256009	4107731	
53225	4623	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	307955	0	180256009	4107731	
53996	4694	4107731	1997-11-02	1997-11-02 00:00:00	38000275	0	\N	\N	312695	0	180256009	4107731	
42624	3759	4107731	1990-04-22	1990-04-22 00:00:00	38000275	0	\N	\N	249950	0	180256009	4107731	
54715	4749	4252419	2014-02-18	2014-02-18 00:00:00	38000275	0	\N	\N	316225	0	74016001	4252419	
55168	4804	4107731	1990-05-07	1990-05-07 00:00:00	38000275	0	\N	\N	319605	0	180256009	4107731	
55367	4827	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	321115	0	180256009	4107731	
44172	3884	4107731	1992-11-16	1992-11-16 00:00:00	38000275	0	\N	\N	258190	0	180256009	4107731	
45249	3987	4195803	2014-02-22	2014-02-22 00:00:00	38000275	0	\N	\N	265059	0	312681000	4195803	
57340	4970	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	330445	0	180256009	4107731	
57690	5004	4107731	1991-03-05	1991-03-05 00:00:00	38000275	0	\N	\N	332844	0	180256009	4107731	
58092	5037	4295880	1999-08-04	1999-08-04 00:00:00	38000275	0	\N	\N	334728	0	76601001	4295880	
58252	5048	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	335421	0	180256009	4107731	
58465	5051	4107731	1990-12-20	1990-12-20 00:00:00	38000275	0	\N	\N	335872	0	180256009	4107731	
59219	5119	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	340305	0	180256009	4107731	
47875	4200	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	278825	0	180256009	4107731	
48195	4226	4107731	1991-03-03	1991-03-03 00:00:00	38000275	0	\N	\N	280734	0	180256009	4107731	
48258	4229	4125906	1953-05-17	1953-05-17 00:00:00	38000275	0	\N	\N	280919	0	288086009	4125906	
60481	5222	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	347378	0	180256009	4107731	
60592	5236	4043071	1984-05-01	1984-05-01 00:00:00	38000275	0	\N	\N	348433	0	228557008	4043071	
60826	5267	4107731	1997-04-19	1997-04-19 00:00:00	38000275	0	\N	\N	350378	0	180256009	4107731	
49180	4313	4107731	1991-06-15	1991-06-15 00:00:00	38000275	0	\N	\N	286262	0	180256009	4107731	
49265	4329	4295880	2000-03-12	2000-03-12 00:00:00	38000275	0	\N	\N	287165	0	76601001	4295880	
49816	4366	4107731	1996-12-31	1996-12-31 00:00:00	38000275	0	\N	\N	289725	0	180256009	4107731	
61972	5343	4295880	1997-06-29	1997-06-29 00:00:00	38000275	0	\N	\N	355838	0	76601001	4295880	
50196	4374	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	290581	0	180256009	4107731	
50677	4412	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	293414	0	180256009	4107731	
39629	3483	4043071	1963-03-11	1963-03-11 00:00:00	38000275	0	\N	\N	231074	0	228557008	4043071	
51911	4500	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	299575	0	180256009	4107731	
52147	4520	4035793	1988-12-24	1988-12-24 00:00:00	38000275	0	\N	\N	300926	0	15081005	4035793	
52390	4544	4163872	1949-10-31	1949-10-31 00:00:00	38000275	0	\N	\N	302668	0	399208008	4163872	
41038	3603	4107731	1993-04-18	1993-04-18 00:00:00	38000275	0	\N	\N	239387	0	180256009	4107731	
53226	4623	4107731	1992-08-04	1992-08-04 00:00:00	38000275	0	\N	\N	307973	0	180256009	4107731	
53997	4694	4107731	1996-02-11	1996-02-11 00:00:00	38000275	0	\N	\N	312687	0	180256009	4107731	
42625	3759	4107731	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	249938	0	180256009	4107731	
54716	4749	4252419	1999-08-01	1999-08-01 00:00:00	38000275	0	\N	\N	316223	0	74016001	4252419	
55169	4804	4107731	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	319616	0	180256009	4107731	
55368	4827	4170947	1983-04-28	1983-04-28 00:00:00	38000275	0	\N	\N	321146	0	274474001	4170947	
44173	3884	4043071	1989-04-08	1989-04-08 00:00:00	38000275	0	\N	\N	258093	0	228557008	4043071	
45250	3987	4170947	2008-03-01	2008-03-01 00:00:00	38000275	0	\N	\N	265029	0	274474001	4170947	
57341	4970	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	330414	0	180256009	4107731	
57691	5004	4107731	1993-07-13	1993-07-13 00:00:00	38000275	0	\N	\N	332815	0	180256009	4107731	
58093	5037	4295880	2001-08-01	2001-08-01 00:00:00	38000275	0	\N	\N	334791	0	76601001	4295880	
58253	5048	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	335533	0	180256009	4107731	
58466	5051	4107731	1993-02-25	1993-02-25 00:00:00	38000275	0	\N	\N	335935	0	180256009	4107731	
59220	5119	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	340310	0	180256009	4107731	
47876	4200	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	278746	0	180256009	4107731	
48196	4226	4107731	1992-01-12	1992-01-12 00:00:00	38000275	0	\N	\N	280738	0	180256009	4107731	
48259	4229	4151422	2008-08-14	2008-08-14 00:00:00	38000275	0	\N	\N	280949	0	269911007	4151422	
60482	5222	4078793	2012-03-29	2012-03-29 00:00:00	38000275	0	\N	\N	347350	0	180325003	4078793	
60593	5236	4163872	2008-08-18	2008-08-18 00:00:00	38000275	0	\N	\N	348422	0	399208008	4163872	
60827	5267	4107731	1999-02-20	1999-02-20 00:00:00	38000275	0	\N	\N	350442	0	180256009	4107731	
49181	4313	4107731	1991-02-09	1991-02-09 00:00:00	38000275	0	\N	\N	286321	0	180256009	4107731	
49266	4329	4295880	1995-09-18	1995-09-18 00:00:00	38000275	0	\N	\N	287109	0	76601001	4295880	
49817	4366	4107731	1995-08-15	1995-08-15 00:00:00	38000275	0	\N	\N	289626	0	180256009	4107731	
61973	5343	4107731	1998-05-17	1998-05-17 00:00:00	38000275	0	\N	\N	355888	0	180256009	4107731	
50197	4374	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	290490	0	180256009	4107731	
39630	3483	4043071	1963-09-23	1963-09-23 00:00:00	38000275	0	\N	\N	231075	0	228557008	4043071	
51912	4500	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	299533	0	180256009	4107731	
52148	4520	4323902	1981-12-26	1981-12-26 00:00:00	38000275	0	\N	\N	300941	0	429609002	4323902	
52391	4544	4170947	1949-10-31	1949-10-31 00:00:00	38000275	0	\N	\N	302668	0	274474001	4170947	
41039	3603	4107731	1991-02-10	1991-02-10 00:00:00	38000275	0	\N	\N	239404	0	180256009	4107731	
53227	4623	4107731	1991-11-05	1991-11-05 00:00:00	38000275	0	\N	\N	307884	0	180256009	4107731	
53998	4694	4058899	1982-08-04	1982-08-04 00:00:00	38000275	0	\N	\N	312718	0	168594001	4058899	
42626	3759	4107731	1991-12-01	1991-12-01 00:00:00	38000275	0	\N	\N	249915	0	180256009	4107731	
54717	4749	44783196	2014-02-25	2014-02-25 00:00:00	38000275	0	\N	\N	316275	0	699253003	44783196	
55170	4804	4107731	1991-04-08	1991-04-08 00:00:00	38000275	0	\N	\N	319624	0	180256009	4107731	
55369	4827	4024289	1983-04-28	1983-04-28 00:00:00	38000275	0	\N	\N	321146	0	19490002	4024289	
44174	3884	4107731	1991-11-25	1991-11-25 00:00:00	38000275	0	\N	\N	258182	0	180256009	4107731	
45251	3987	4024289	2008-03-01	2008-03-01 00:00:00	38000275	0	\N	\N	265029	0	19490002	4024289	
57342	4970	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	330378	0	180256009	4107731	
57692	5004	4107731	1991-07-30	1991-07-30 00:00:00	38000275	0	\N	\N	332897	0	180256009	4107731	
58094	5037	4295880	1995-02-08	1995-02-08 00:00:00	38000275	0	\N	\N	334808	0	76601001	4295880	
58254	5048	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	335526	0	180256009	4107731	
58467	5051	4107731	1993-04-08	1993-04-08 00:00:00	38000275	0	\N	\N	335936	0	180256009	4107731	
59221	5119	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	340382	0	180256009	4107731	
47886	4202	4197460	1972-10-06	1972-10-06 00:00:00	38000275	0	\N	\N	278926	0	313191000	4197460	
48197	4226	4107731	1992-08-09	1992-08-09 00:00:00	38000275	0	\N	\N	280657	0	180256009	4107731	
48281	4235	4252419	2007-03-09	2007-03-09 00:00:00	38000275	0	\N	\N	281212	0	74016001	4252419	
60483	5222	4035793	2015-04-16	2015-04-16 00:00:00	38000275	0	\N	\N	347468	0	15081005	4035793	
60594	5236	4125906	1982-10-08	1982-10-08 00:00:00	38000275	0	\N	\N	348425	0	288086009	4125906	
60828	5267	4107731	1998-12-19	1998-12-19 00:00:00	38000275	0	\N	\N	350411	0	180256009	4107731	
60984	5283	4058899	1975-08-21	1975-08-21 00:00:00	38000275	0	\N	\N	351476	0	168594001	4058899	
49267	4329	4295880	1997-03-16	1997-03-16 00:00:00	38000275	0	\N	\N	287160	0	76601001	4295880	
49818	4366	4107731	1997-04-15	1997-04-15 00:00:00	38000275	0	\N	\N	289618	0	180256009	4107731	
61974	5343	4107731	1996-10-06	1996-10-06 00:00:00	38000275	0	\N	\N	355880	0	180256009	4107731	
50198	4374	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	290448	0	180256009	4107731	
39633	3486	4043071	1974-08-30	1974-08-30 00:00:00	38000275	0	\N	\N	231204	0	228557008	4043071	
51913	4501	4295880	1998-01-01	1998-01-01 00:00:00	38000275	0	\N	\N	299719	0	76601001	4295880	
52149	4520	4125906	1935-10-24	1935-10-24 00:00:00	38000275	0	\N	\N	300889	0	288086009	4125906	
52392	4544	4125906	1970-07-13	1970-07-13 00:00:00	38000275	0	\N	\N	302669	0	288086009	4125906	
41040	3603	4107731	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	239443	0	180256009	4107731	
53228	4623	4107731	1992-07-14	1992-07-14 00:00:00	38000275	0	\N	\N	307987	0	180256009	4107731	
53999	4694	4107731	1995-06-04	1995-06-04 00:00:00	38000275	0	\N	\N	312740	0	180256009	4107731	
42627	3759	4107731	1990-04-01	1990-04-01 00:00:00	38000275	0	\N	\N	249937	0	180256009	4107731	
54718	4750	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	316349	0	180256009	4107731	
55171	4804	4107731	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	319607	0	180256009	4107731	
55370	4827	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	321175	0	180256009	4107731	
44175	3884	4107731	1991-09-23	1991-09-23 00:00:00	38000275	0	\N	\N	258208	0	180256009	4107731	
45252	3987	4195803	2008-03-01	2008-03-01 00:00:00	38000275	0	\N	\N	265029	0	312681000	4195803	
57343	4970	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	330365	0	180256009	4107731	
57693	5004	4047491	2015-07-17	2015-07-17 00:00:00	38000275	0	\N	\N	332907	0	1225002	4047491	
58095	5037	4295880	2004-01-28	2004-01-28 00:00:00	38000275	0	\N	\N	334817	0	76601001	4295880	
58255	5048	4125906	1975-11-22	1975-11-22 00:00:00	38000275	0	\N	\N	335502	0	288086009	4125906	
58468	5051	4107731	1991-10-10	1991-10-10 00:00:00	38000275	0	\N	\N	335903	0	180256009	4107731	
59222	5119	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	340358	0	180256009	4107731	
47887	4202	4170947	1974-02-28	1974-02-28 00:00:00	38000275	0	\N	\N	278927	0	274474001	4170947	
48198	4226	4107731	1991-09-08	1991-09-08 00:00:00	38000275	0	\N	\N	280686	0	180256009	4107731	
48282	4235	44783196	2007-03-16	2007-03-16 00:00:00	38000275	0	\N	\N	281189	0	699253003	44783196	
60484	5222	4057420	2015-04-16	2015-04-16 00:00:00	38000275	0	\N	\N	347468	0	18286008	4057420	
60595	5236	4043071	1984-06-05	1984-06-05 00:00:00	38000275	0	\N	\N	348434	0	228557008	4043071	
60829	5267	4107731	1999-03-13	1999-03-13 00:00:00	38000275	0	\N	\N	350375	0	180256009	4107731	
60985	5283	4151422	2008-05-08	2008-05-08 00:00:00	38000275	0	\N	\N	351426	0	269911007	4151422	
49268	4329	4010253	2018-12-30	2018-12-30 00:00:00	38000275	0	\N	\N	287149	0	112790001	4010253	
49819	4366	4107731	1996-04-23	1996-04-23 00:00:00	38000275	0	\N	\N	289652	0	180256009	4107731	
61975	5343	4107731	1996-02-18	1996-02-18 00:00:00	38000275	0	\N	\N	355878	0	180256009	4107731	
50199	4374	4295880	1994-05-05	1994-05-05 00:00:00	38000275	0	\N	\N	290572	0	76601001	4295880	
39634	3486	4043071	1975-04-11	1975-04-11 00:00:00	38000275	0	\N	\N	231280	0	228557008	4043071	
51914	4501	4295880	2000-03-30	2000-03-30 00:00:00	38000275	0	\N	\N	299686	0	76601001	4295880	
52150	4520	4035793	1989-12-30	1989-12-30 00:00:00	38000275	0	\N	\N	300934	0	15081005	4035793	
52393	4546	4151422	2012-12-19	2012-12-19 00:00:00	38000275	0	\N	\N	302801	0	269911007	4151422	
41041	3603	4107731	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	239423	0	180256009	4107731	
53229	4623	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	307970	0	180256009	4107731	
54000	4694	4107731	1997-11-23	1997-11-23 00:00:00	38000275	0	\N	\N	312761	0	180256009	4107731	
42628	3759	4107731	1993-02-14	1993-02-14 00:00:00	38000275	0	\N	\N	249923	0	180256009	4107731	
54719	4750	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	316370	0	180256009	4107731	
55172	4804	4107731	1990-07-09	1990-07-09 00:00:00	38000275	0	\N	\N	319634	0	180256009	4107731	
55371	4827	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	321120	0	180256009	4107731	
44176	3884	4043071	1988-05-21	1988-05-21 00:00:00	38000275	0	\N	\N	258031	0	228557008	4043071	
45253	3987	4243062	1964-11-19	1964-11-19 00:00:00	38000275	0	\N	\N	265027	0	60027007	4243062	
57344	4970	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	330479	0	180256009	4107731	
57694	5004	4170947	2015-07-17	2015-07-17 00:00:00	38000275	0	\N	\N	332907	0	274474001	4170947	
58096	5037	4295880	1993-11-10	1993-11-10 00:00:00	38000275	0	\N	\N	334783	0	76601001	4295880	
58256	5048	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	335491	0	180256009	4107731	
58469	5051	4107731	1992-01-23	1992-01-23 00:00:00	38000275	0	\N	\N	335878	0	180256009	4107731	
59223	5119	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	340377	0	180256009	4107731	
47888	4202	4243062	1974-02-28	1974-02-28 00:00:00	38000275	0	\N	\N	278927	0	60027007	4243062	
48199	4226	4107731	1990-06-24	1990-06-24 00:00:00	38000275	0	\N	\N	280725	0	180256009	4107731	
48351	4238	44783196	2013-06-25	2013-06-25 00:00:00	38000275	0	\N	\N	281438	0	699253003	44783196	
60485	5222	4163872	1928-02-06	1928-02-06 00:00:00	38000275	0	\N	\N	347508	0	399208008	4163872	
60596	5236	4043071	1984-07-03	1984-07-03 00:00:00	38000275	0	\N	\N	348418	0	228557008	4043071	
60830	5267	4107731	1997-12-06	1997-12-06 00:00:00	38000275	0	\N	\N	350380	0	180256009	4107731	
60986	5283	4170947	1984-09-07	1984-09-07 00:00:00	38000275	0	\N	\N	351478	0	274474001	4170947	
49269	4329	4024289	1991-09-20	1991-09-20 00:00:00	38000275	0	\N	\N	287105	0	19490002	4024289	
49820	4366	4107731	1994-12-06	1994-12-06 00:00:00	38000275	0	\N	\N	289684	0	180256009	4107731	
61976	5343	4191853	1996-01-07	1996-01-07 00:00:00	38000275	0	\N	\N	355877	0	395142003	4191853	
50200	4374	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	290456	0	180256009	4107731	
39635	3486	4043071	1975-03-14	1975-03-14 00:00:00	38000275	0	\N	\N	231235	0	228557008	4043071	
51915	4501	4295880	1998-10-01	1998-10-01 00:00:00	38000275	0	\N	\N	299684	0	76601001	4295880	
52151	4521	4057420	2001-02-01	2001-02-01 00:00:00	38000275	0	\N	\N	301036	0	18286008	4057420	
52394	4546	4151422	1994-04-03	1994-04-03 00:00:00	38000275	0	\N	\N	302781	0	269911007	4151422	
41042	3603	4107731	1991-12-01	1991-12-01 00:00:00	38000275	0	\N	\N	239425	0	180256009	4107731	
53230	4623	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	307909	0	180256009	4107731	
54001	4694	4107731	1996-06-16	1996-06-16 00:00:00	38000275	0	\N	\N	312660	0	180256009	4107731	
42629	3759	4107731	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	249890	0	180256009	4107731	
54720	4750	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	316400	0	180256009	4107731	
55173	4804	4107731	1992-08-24	1992-08-24 00:00:00	38000275	0	\N	\N	319629	0	180256009	4107731	
55372	4827	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	321088	0	180256009	4107731	
44177	3884	4107731	1990-10-01	1990-10-01 00:00:00	38000275	0	\N	\N	258167	0	180256009	4107731	
45254	3987	4195803	1964-11-19	1964-11-19 00:00:00	38000275	0	\N	\N	265027	0	312681000	4195803	
57345	4971	4043071	1949-05-29	1949-05-29 00:00:00	38000275	0	\N	\N	330523	0	228557008	4043071	
57695	5004	4107731	1992-06-09	1992-06-09 00:00:00	38000275	0	\N	\N	332901	0	180256009	4107731	
58097	5037	4295880	1999-11-03	1999-11-03 00:00:00	38000275	0	\N	\N	334759	0	76601001	4295880	
58257	5048	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	335544	0	180256009	4107731	
58470	5051	4107731	1992-07-30	1992-07-30 00:00:00	38000275	0	\N	\N	335879	0	180256009	4107731	
59224	5119	4107731	1991-02-05	1991-02-05 00:00:00	38000275	0	\N	\N	340344	0	180256009	4107731	
47889	4202	4151422	1995-02-10	1995-02-10 00:00:00	38000275	0	\N	\N	278993	0	269911007	4151422	
48200	4226	4107731	1990-08-26	1990-08-26 00:00:00	38000275	0	\N	\N	280672	0	180256009	4107731	
48352	4238	40492359	1978-12-28	1978-12-28 00:00:00	38000275	0	\N	\N	281383	0	447365002	40492359	
60486	5222	4170947	1928-02-06	1928-02-06 00:00:00	38000275	0	\N	\N	347508	0	274474001	4170947	
60597	5236	4043071	1984-09-04	1984-09-04 00:00:00	38000275	0	\N	\N	348376	0	228557008	4043071	
60831	5267	4191853	1995-12-23	1995-12-23 00:00:00	38000275	0	\N	\N	350431	0	395142003	4191853	
60987	5283	4047491	1984-09-07	1984-09-07 00:00:00	38000275	0	\N	\N	351478	0	1225002	4047491	
49270	4329	4170947	1991-09-20	1991-09-20 00:00:00	38000275	0	\N	\N	287105	0	274474001	4170947	
49821	4366	4107731	1994-08-23	1994-08-23 00:00:00	38000275	0	\N	\N	289668	0	180256009	4107731	
61977	5343	4107731	1998-09-20	1998-09-20 00:00:00	38000275	0	\N	\N	355902	0	180256009	4107731	
50201	4374	4295880	1993-02-04	1993-02-04 00:00:00	38000275	0	\N	\N	290542	0	76601001	4295880	
39636	3486	4195803	2012-04-16	2012-04-16 00:00:00	38000275	0	\N	\N	231299	0	312681000	4195803	
51916	4501	4295880	1999-07-01	1999-07-01 00:00:00	38000275	0	\N	\N	299685	0	76601001	4295880	
52152	4521	4243062	1928-03-12	1928-03-12 00:00:00	38000275	0	\N	\N	301009	0	60027007	4243062	
52395	4547	4145310	1982-01-17	1982-01-17 00:00:00	38000275	0	\N	\N	302959	0	268425006	4145310	
41043	3603	4107731	1991-11-10	1991-11-10 00:00:00	38000275	0	\N	\N	239346	0	180256009	4107731	
53231	4623	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	307903	0	180256009	4107731	
54002	4694	4107731	1994-12-18	1994-12-18 00:00:00	38000275	0	\N	\N	312654	0	180256009	4107731	
42630	3759	4107731	1991-05-26	1991-05-26 00:00:00	38000275	0	\N	\N	249957	0	180256009	4107731	
54721	4750	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	316339	0	180256009	4107731	
55174	4804	4107731	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	319581	0	180256009	4107731	
55373	4827	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	321089	0	180256009	4107731	
44178	3884	4107731	1992-06-01	1992-06-01 00:00:00	38000275	0	\N	\N	258078	0	180256009	4107731	
57150	4957	4170947	1986-08-14	1986-08-14 00:00:00	38000275	0	\N	\N	329510	0	274474001	4170947	
57346	4971	4043071	1950-07-30	1950-07-30 00:00:00	38000275	0	\N	\N	330586	0	228557008	4043071	
57696	5004	4107731	1990-07-17	1990-07-17 00:00:00	38000275	0	\N	\N	332874	0	180256009	4107731	
58098	5037	4295880	2006-10-25	2006-10-25 00:00:00	38000275	0	\N	\N	334749	0	76601001	4295880	
58258	5048	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	335465	0	180256009	4107731	
58471	5051	4107731	1991-06-27	1991-06-27 00:00:00	38000275	0	\N	\N	335860	0	180256009	4107731	
59225	5119	4107731	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	340361	0	180256009	4107731	
47902	4204	4125906	2006-07-17	2006-07-17 00:00:00	38000275	0	\N	\N	279067	0	288086009	4125906	
48201	4226	4107731	1990-07-15	1990-07-15 00:00:00	38000275	0	\N	\N	280732	0	180256009	4107731	
48353	4238	4057420	1978-12-28	1978-12-28 00:00:00	38000275	0	\N	\N	281383	0	18286008	4057420	
60487	5222	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	347379	0	180256009	4107731	
60598	5236	4043071	1984-11-06	1984-11-06 00:00:00	38000275	0	\N	\N	348392	0	228557008	4043071	
60832	5267	4107731	1998-06-13	1998-06-13 00:00:00	38000275	0	\N	\N	350372	0	180256009	4107731	
60988	5284	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	351596	0	395142003	4191853	
49271	4329	4295880	1996-12-15	1996-12-15 00:00:00	38000275	0	\N	\N	287083	0	76601001	4295880	
49822	4366	4107731	1996-08-27	1996-08-27 00:00:00	38000275	0	\N	\N	289615	0	180256009	4107731	
61978	5343	4295880	1997-03-30	1997-03-30 00:00:00	38000275	0	\N	\N	355828	0	76601001	4295880	
50202	4374	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	290580	0	180256009	4107731	
39637	3486	4058899	2012-04-16	2012-04-16 00:00:00	38000275	0	\N	\N	231299	0	168594001	4058899	
51917	4501	4295880	1998-07-02	1998-07-02 00:00:00	38000275	0	\N	\N	299707	0	76601001	4295880	
52153	4521	4170947	1928-03-12	1928-03-12 00:00:00	38000275	0	\N	\N	301009	0	274474001	4170947	
52396	4547	4043071	1915-11-21	1915-11-21 00:00:00	38000275	0	\N	\N	302853	0	228557008	4043071	
41044	3603	4107731	1990-12-09	1990-12-09 00:00:00	38000275	0	\N	\N	239420	0	180256009	4107731	
53232	4623	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	307952	0	180256009	4107731	
54003	4694	4107731	1996-05-26	1996-05-26 00:00:00	38000275	0	\N	\N	312745	0	180256009	4107731	
42631	3759	4107731	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	249905	0	180256009	4107731	
54722	4750	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	316408	0	180256009	4107731	
55175	4804	4107731	1992-03-30	1992-03-30 00:00:00	38000275	0	\N	\N	319580	0	180256009	4107731	
55374	4827	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	321163	0	180256009	4107731	
44179	3884	4043071	1985-08-17	1985-08-17 00:00:00	38000275	0	\N	\N	258108	0	228557008	4043071	
57151	4957	4243062	1986-08-14	1986-08-14 00:00:00	38000275	0	\N	\N	329510	0	60027007	4243062	
57347	4971	4058899	1940-04-19	1940-04-19 00:00:00	38000275	0	\N	\N	330662	0	168594001	4058899	
57697	5004	4191853	1990-03-13	1990-03-13 00:00:00	38000275	0	\N	\N	332871	0	395142003	4191853	
58099	5037	4295880	1996-02-07	1996-02-07 00:00:00	38000275	0	\N	\N	334743	0	76601001	4295880	
58259	5048	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	335543	0	180256009	4107731	
58472	5051	4191853	1978-10-04	1978-10-04 00:00:00	38000275	0	\N	\N	335893	0	395142003	4191853	
59226	5121	4125906	2013-06-30	2013-06-30 00:00:00	38000275	0	\N	\N	340508	0	288086009	4125906	
47903	4204	4293740	2006-07-17	2006-07-17 00:00:00	38000275	0	\N	\N	279067	0	384700001	4293740	
48202	4226	4191853	1993-07-11	1993-07-11 00:00:00	38000275	0	\N	\N	280641	0	395142003	4191853	
48354	4238	4125906	1998-10-21	1998-10-21 00:00:00	38000275	0	\N	\N	281384	0	288086009	4125906	
60488	5222	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	347414	0	180256009	4107731	
60599	5236	4043071	1984-04-03	1984-04-03 00:00:00	38000275	0	\N	\N	348374	0	228557008	4043071	
60833	5267	4107731	1998-07-25	1998-07-25 00:00:00	38000275	0	\N	\N	350373	0	180256009	4107731	
60989	5284	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	351555	0	180256009	4107731	
49272	4329	4295880	1996-09-16	1996-09-16 00:00:00	38000275	0	\N	\N	287130	0	76601001	4295880	
49823	4366	4107731	1996-03-12	1996-03-12 00:00:00	38000275	0	\N	\N	289646	0	180256009	4107731	
61979	5343	4107731	1998-07-19	1998-07-19 00:00:00	38000275	0	\N	\N	355914	0	180256009	4107731	
50203	4374	4295880	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	290492	0	76601001	4295880	
39638	3486	4043071	1975-06-06	1975-06-06 00:00:00	38000275	0	\N	\N	231233	0	228557008	4043071	
51918	4501	4295880	1997-09-30	1997-09-30 00:00:00	38000275	0	\N	\N	299718	0	76601001	4295880	
52154	4521	4078793	2006-05-18	2006-05-18 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
52397	4547	4125906	1933-09-12	1933-09-12 00:00:00	38000275	0	\N	\N	302957	0	288086009	4125906	
41045	3603	4107731	1990-10-28	1990-10-28 00:00:00	38000275	0	\N	\N	239446	0	180256009	4107731	
53233	4623	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	307956	0	180256009	4107731	
54004	4694	4107731	1997-05-18	1997-05-18 00:00:00	38000275	0	\N	\N	312671	0	180256009	4107731	
42632	3759	4107731	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	249973	0	180256009	4107731	
54723	4750	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	316290	0	180256009	4107731	
55176	4804	4107731	1992-01-27	1992-01-27 00:00:00	38000275	0	\N	\N	319613	0	180256009	4107731	
55375	4827	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	321214	0	180256009	4107731	
44180	3884	4043071	1985-02-23	1985-02-23 00:00:00	38000275	0	\N	\N	258178	0	228557008	4043071	
57152	4957	4163872	2009-09-30	2009-09-30 00:00:00	38000275	0	\N	\N	329534	0	399208008	4163872	
57348	4971	4043071	1950-11-05	1950-11-05 00:00:00	38000275	0	\N	\N	330648	0	228557008	4043071	
57698	5004	4107731	1990-09-18	1990-09-18 00:00:00	38000275	0	\N	\N	332884	0	180256009	4107731	
58100	5037	4295880	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	334782	0	76601001	4295880	
58260	5048	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	335476	0	180256009	4107731	
58473	5051	4107731	1994-05-12	1994-05-12 00:00:00	38000275	0	\N	\N	335836	0	180256009	4107731	
47904	4204	4125906	1972-04-20	1972-04-20 00:00:00	38000275	0	\N	\N	279065	0	288086009	4125906	
48203	4226	4107731	1990-04-01	1990-04-01 00:00:00	38000275	0	\N	\N	280723	0	180256009	4107731	
48355	4238	4252419	2013-06-18	2013-06-18 00:00:00	38000275	0	\N	\N	281411	0	74016001	4252419	
60489	5222	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	347490	0	180256009	4107731	
60600	5236	4043071	1984-12-11	1984-12-11 00:00:00	38000275	0	\N	\N	348393	0	228557008	4043071	
60834	5267	4107731	1998-03-21	1998-03-21 00:00:00	38000275	0	\N	\N	350408	0	180256009	4107731	
60990	5284	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	351605	0	180256009	4107731	
49273	4329	4295880	1996-06-17	1996-06-17 00:00:00	38000275	0	\N	\N	287110	0	76601001	4295880	
49824	4366	4107731	1995-02-28	1995-02-28 00:00:00	38000275	0	\N	\N	289602	0	180256009	4107731	
61980	5343	4107731	1997-03-02	1997-03-02 00:00:00	38000275	0	\N	\N	355917	0	180256009	4107731	
50204	4374	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	290527	0	180256009	4107731	
39639	3486	4043071	1975-09-19	1975-09-19 00:00:00	38000275	0	\N	\N	231281	0	228557008	4043071	
51919	4501	4295880	1998-12-31	1998-12-31 00:00:00	38000275	0	\N	\N	299681	0	76601001	4295880	
52155	4521	4170947	1924-04-02	1924-04-02 00:00:00	38000275	0	\N	\N	301008	0	274474001	4170947	
52398	4547	4125906	1918-10-10	1918-10-10 00:00:00	38000275	0	\N	\N	302956	0	288086009	4125906	
41046	3603	4191853	1990-01-07	1990-01-07 00:00:00	38000275	0	\N	\N	239365	0	395142003	4191853	
53234	4623	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	307971	0	180256009	4107731	
54005	4694	4107731	1995-11-19	1995-11-19 00:00:00	38000275	0	\N	\N	312710	0	180256009	4107731	
42633	3759	4107731	1991-06-16	1991-06-16 00:00:00	38000275	0	\N	\N	249889	0	180256009	4107731	
54724	4750	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	316397	0	180256009	4107731	
55177	4804	4107731	1993-09-06	1993-09-06 00:00:00	38000275	0	\N	\N	319600	0	180256009	4107731	
55376	4827	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	321092	0	180256009	4107731	
44181	3884	4107731	1990-12-03	1990-12-03 00:00:00	38000275	0	\N	\N	258064	0	180256009	4107731	
57153	4957	4151422	2003-09-05	2003-09-05 00:00:00	38000275	0	\N	\N	329555	0	269911007	4151422	
57349	4971	4043071	1947-07-27	1947-07-27 00:00:00	38000275	0	\N	\N	330623	0	228557008	4043071	
57699	5004	4107731	1992-05-19	1992-05-19 00:00:00	38000275	0	\N	\N	332857	0	180256009	4107731	
58101	5037	4295880	1992-08-12	1992-08-12 00:00:00	38000275	0	\N	\N	334721	0	76601001	4295880	
58261	5048	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	335530	0	180256009	4107731	
58474	5051	4107731	1991-04-25	1991-04-25 00:00:00	38000275	0	\N	\N	335908	0	180256009	4107731	
47905	4205	4107731	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	279218	0	180256009	4107731	
48204	4226	4107731	1990-12-09	1990-12-09 00:00:00	38000275	0	\N	\N	280698	0	180256009	4107731	
48356	4239	4170947	1958-02-03	1958-02-03 00:00:00	38000275	0	\N	\N	281502	0	274474001	4170947	
60490	5222	4078793	2007-03-01	2007-03-01 00:00:00	38000275	0	\N	\N	347426	0	180325003	4078793	
60606	5239	4170947	1972-08-19	1972-08-19 00:00:00	38000275	0	\N	\N	348556	0	274474001	4170947	
60835	5267	4107731	1999-04-24	1999-04-24 00:00:00	38000275	0	\N	\N	350376	0	180256009	4107731	
60991	5284	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	351615	0	180256009	4107731	
49274	4329	4295880	1999-06-14	1999-06-14 00:00:00	38000275	0	\N	\N	287163	0	76601001	4295880	
49825	4366	4107731	1996-09-17	1996-09-17 00:00:00	38000275	0	\N	\N	289647	0	180256009	4107731	
61981	5343	4107731	1999-03-07	1999-03-07 00:00:00	38000275	0	\N	\N	355932	0	180256009	4107731	
50205	4374	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	290462	0	180256009	4107731	
39640	3486	4043071	1974-12-06	1974-12-06 00:00:00	38000275	0	\N	\N	231208	0	228557008	4043071	
51920	4501	4059978	1998-09-25	1998-09-25 00:00:00	38000275	0	\N	\N	299720	0	169553002	4059978	
52156	4521	4047491	1924-04-02	1924-04-02 00:00:00	38000275	0	\N	\N	301008	0	1225002	4047491	
52399	4547	4043071	1916-02-13	1916-02-13 00:00:00	38000275	0	\N	\N	302841	0	228557008	4043071	
41047	3603	4107731	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	239353	0	180256009	4107731	
53235	4623	4195803	1989-09-26	1989-09-26 00:00:00	38000275	0	\N	\N	307998	0	312681000	4195803	
54006	4694	4107731	1996-05-05	1996-05-05 00:00:00	38000275	0	\N	\N	312689	0	180256009	4107731	
42634	3759	4107731	1992-08-09	1992-08-09 00:00:00	38000275	0	\N	\N	249989	0	180256009	4107731	
54725	4750	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	316382	0	180256009	4107731	
55178	4804	4107731	1991-09-02	1991-09-02 00:00:00	38000275	0	\N	\N	319555	0	180256009	4107731	
55377	4827	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	321169	0	180256009	4107731	
44182	3884	4043071	1987-01-10	1987-01-10 00:00:00	38000275	0	\N	\N	258084	0	228557008	4043071	
57160	4960	4195803	1989-12-21	1989-12-21 00:00:00	38000275	0	\N	\N	329712	0	312681000	4195803	
57350	4971	4043071	1948-11-14	1948-11-14 00:00:00	38000275	0	\N	\N	330521	0	228557008	4043071	
57700	5004	4191853	1977-11-26	1977-11-26 00:00:00	38000275	0	\N	\N	332831	0	395142003	4191853	
58102	5037	4295880	2007-10-24	2007-10-24 00:00:00	38000275	0	\N	\N	334800	0	76601001	4295880	
58262	5048	4125906	2007-12-23	2007-12-23 00:00:00	38000275	0	\N	\N	335505	0	288086009	4125906	
58475	5051	4107731	1991-10-31	1991-10-31 00:00:00	38000275	0	\N	\N	335876	0	180256009	4107731	
47906	4205	4107731	1992-11-21	1992-11-21 00:00:00	38000275	0	\N	\N	279247	0	180256009	4107731	
48205	4226	4107731	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	280690	0	180256009	4107731	
48357	4239	4163872	1958-02-03	1958-02-03 00:00:00	38000275	0	\N	\N	281502	0	399208008	4163872	
60491	5222	4035793	2014-04-10	2014-04-10 00:00:00	38000275	0	\N	\N	347427	0	15081005	4035793	
60607	5239	4024289	1972-08-19	1972-08-19 00:00:00	38000275	0	\N	\N	348556	0	19490002	4024289	
60836	5267	4151422	2008-09-26	2008-09-26 00:00:00	38000275	0	\N	\N	350399	0	269911007	4151422	
60992	5284	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	351610	0	180256009	4107731	
49275	4329	4295880	1995-12-17	1995-12-17 00:00:00	38000275	0	\N	\N	287129	0	76601001	4295880	
49826	4366	4107731	1997-03-04	1997-03-04 00:00:00	38000275	0	\N	\N	289617	0	180256009	4107731	
61982	5343	4107731	1997-07-06	1997-07-06 00:00:00	38000275	0	\N	\N	355883	0	180256009	4107731	
50206	4374	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	290521	0	180256009	4107731	
39641	3486	4043071	1976-02-20	1976-02-20 00:00:00	38000275	0	\N	\N	231282	0	228557008	4043071	
51921	4501	4295880	1999-09-30	1999-09-30 00:00:00	38000275	0	\N	\N	299738	0	76601001	4295880	
52157	4521	4195803	1972-05-11	1972-05-11 00:00:00	38000275	0	\N	\N	301012	0	312681000	4195803	
52400	4547	4043071	1915-12-19	1915-12-19 00:00:00	38000275	0	\N	\N	302930	0	228557008	4043071	
41048	3603	4107731	1991-12-22	1991-12-22 00:00:00	38000275	0	\N	\N	239347	0	180256009	4107731	
53236	4623	4107731	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	307969	0	180256009	4107731	
54007	4694	4107731	1995-01-29	1995-01-29 00:00:00	38000275	0	\N	\N	312728	0	180256009	4107731	
42635	3759	4191853	1993-07-11	1993-07-11 00:00:00	38000275	0	\N	\N	249857	0	395142003	4191853	
54726	4750	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	316388	0	180256009	4107731	
55179	4804	4107731	1992-12-07	1992-12-07 00:00:00	38000275	0	\N	\N	319559	0	180256009	4107731	
55378	4827	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	321171	0	180256009	4107731	
44183	3884	4043071	1989-09-30	1989-09-30 00:00:00	38000275	0	\N	\N	258091	0	228557008	4043071	
57161	4960	4058899	1989-12-21	1989-12-21 00:00:00	38000275	0	\N	\N	329712	0	168594001	4058899	
57351	4971	4043071	1947-09-21	1947-09-21 00:00:00	38000275	0	\N	\N	330530	0	228557008	4043071	
57701	5004	4107731	1990-04-03	1990-04-03 00:00:00	38000275	0	\N	\N	332842	0	180256009	4107731	
58103	5037	4295880	2007-01-24	2007-01-24 00:00:00	38000275	0	\N	\N	334799	0	76601001	4295880	
58263	5048	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	335528	0	180256009	4107731	
58476	5051	4107731	1994-03-10	1994-03-10 00:00:00	38000275	0	\N	\N	335887	0	180256009	4107731	
47907	4205	4107731	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	279244	0	180256009	4107731	
48206	4226	4107731	1993-05-09	1993-05-09 00:00:00	38000275	0	\N	\N	280660	0	180256009	4107731	
48358	4239	4252419	1993-07-29	1993-07-29 00:00:00	38000275	0	\N	\N	281507	0	74016001	4252419	
60492	5222	4078793	2014-04-10	2014-04-10 00:00:00	38000275	0	\N	\N	347427	0	180325003	4078793	
60608	5239	4047491	1997-03-11	1997-03-11 00:00:00	38000275	0	\N	\N	348604	0	1225002	4047491	
60837	5267	4107731	1998-09-05	1998-09-05 00:00:00	38000275	0	\N	\N	350454	0	180256009	4107731	
60993	5284	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	351604	0	180256009	4107731	
49276	4329	44783196	2014-10-26	2014-10-26 00:00:00	38000275	0	\N	\N	287103	0	699253003	44783196	
49827	4366	4107731	1995-07-25	1995-07-25 00:00:00	38000275	0	\N	\N	289686	0	180256009	4107731	
61983	5343	4107731	1996-10-27	1996-10-27 00:00:00	38000275	0	\N	\N	355820	0	180256009	4107731	
50207	4374	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	290463	0	180256009	4107731	
39642	3486	4043071	1974-05-03	1974-05-03 00:00:00	38000275	0	\N	\N	231203	0	228557008	4043071	
51922	4501	4295880	2000-09-28	2000-09-28 00:00:00	38000275	0	\N	\N	299687	0	76601001	4295880	
52158	4521	4163872	1972-05-11	1972-05-11 00:00:00	38000275	0	\N	\N	301012	0	399208008	4163872	
52401	4547	4043071	1916-03-19	1916-03-19 00:00:00	38000275	0	\N	\N	302842	0	228557008	4043071	
41049	3603	4107731	1990-04-22	1990-04-22 00:00:00	38000275	0	\N	\N	239418	0	180256009	4107731	
53237	4623	4107731	1990-11-13	1990-11-13 00:00:00	38000275	0	\N	\N	307949	0	180256009	4107731	
54008	4694	4107731	1995-09-17	1995-09-17 00:00:00	38000275	0	\N	\N	312657	0	180256009	4107731	
42636	3759	4107731	1990-11-18	1990-11-18 00:00:00	38000275	0	\N	\N	249956	0	180256009	4107731	
54727	4750	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	316351	0	180256009	4107731	
55180	4804	4107731	1992-12-28	1992-12-28 00:00:00	38000275	0	\N	\N	319583	0	180256009	4107731	
55379	4827	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	321124	0	180256009	4107731	
44184	3884	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	258054	0	180256009	4107731	
57162	4960	4125906	1955-08-17	1955-08-17 00:00:00	38000275	0	\N	\N	329709	0	288086009	4125906	
57352	4971	4043071	1947-08-24	1947-08-24 00:00:00	38000275	0	\N	\N	330609	0	228557008	4043071	
57702	5004	4107731	1991-01-22	1991-01-22 00:00:00	38000275	0	\N	\N	332876	0	180256009	4107731	
58104	5037	4295880	2007-04-25	2007-04-25 00:00:00	38000275	0	\N	\N	334819	0	76601001	4295880	
58264	5048	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	335440	0	180256009	4107731	
58477	5051	4107731	1992-10-22	1992-10-22 00:00:00	38000275	0	\N	\N	335881	0	180256009	4107731	
47908	4205	4107731	1991-07-27	1991-07-27 00:00:00	38000275	0	\N	\N	279187	0	180256009	4107731	
48207	4226	4107731	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	280638	0	180256009	4107731	
48359	4239	4151422	1952-09-06	1952-09-06 00:00:00	38000275	0	\N	\N	281513	0	269911007	4151422	
60493	5222	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	347357	0	395142003	4191853	
60609	5239	4170947	1997-03-11	1997-03-11 00:00:00	38000275	0	\N	\N	348604	0	274474001	4170947	
60838	5267	4107731	1997-05-31	1997-05-31 00:00:00	38000275	0	\N	\N	350379	0	180256009	4107731	
60994	5284	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	351496	0	180256009	4107731	
49277	4329	4295880	1994-09-19	1994-09-19 00:00:00	38000275	0	\N	\N	287151	0	76601001	4295880	
49828	4366	4107731	1994-10-25	1994-10-25 00:00:00	38000275	0	\N	\N	289683	0	180256009	4107731	
61984	5343	4107731	1999-02-14	1999-02-14 00:00:00	38000275	0	\N	\N	355891	0	180256009	4107731	
50208	4374	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	290505	0	180256009	4107731	
39643	3486	4043071	1975-05-09	1975-05-09 00:00:00	38000275	0	\N	\N	231210	0	228557008	4043071	
51923	4501	4295880	2000-12-28	2000-12-28 00:00:00	38000275	0	\N	\N	299722	0	76601001	4295880	
52159	4521	4170947	1972-05-11	1972-05-11 00:00:00	38000275	0	\N	\N	301012	0	274474001	4170947	
52402	4547	4043071	1916-06-25	1916-06-25 00:00:00	38000275	0	\N	\N	302931	0	228557008	4043071	
41050	3603	4107731	1990-12-30	1990-12-30 00:00:00	38000275	0	\N	\N	239403	0	180256009	4107731	
53238	4623	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	307951	0	180256009	4107731	
54009	4694	4107731	1995-05-14	1995-05-14 00:00:00	38000275	0	\N	\N	312754	0	180256009	4107731	
54418	4724	4275113	1968-02-28	1968-02-28 00:00:00	38000275	0	\N	\N	314762	0	65200003	4275113	
54728	4750	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	316359	0	180256009	4107731	
55181	4804	4107731	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	319638	0	180256009	4107731	
55380	4827	4170947	1963-08-27	1963-08-27 00:00:00	38000275	0	\N	\N	321144	0	274474001	4170947	
44185	3884	4107731	1990-03-05	1990-03-05 00:00:00	38000275	0	\N	\N	258061	0	180256009	4107731	
57163	4960	4125906	1935-01-01	1935-01-01 00:00:00	38000275	0	\N	\N	329705	0	288086009	4125906	
57353	4971	4043071	1947-03-23	1947-03-23 00:00:00	38000275	0	\N	\N	330621	0	228557008	4043071	
57703	5004	4107731	1991-11-12	1991-11-12 00:00:00	38000275	0	\N	\N	332793	0	180256009	4107731	
58105	5037	4295880	2004-10-27	2004-10-27 00:00:00	38000275	0	\N	\N	334778	0	76601001	4295880	
58265	5048	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	335536	0	180256009	4107731	
58478	5051	4107731	1992-02-13	1992-02-13 00:00:00	38000275	0	\N	\N	335862	0	180256009	4107731	
47909	4205	4107731	1990-10-27	1990-10-27 00:00:00	38000275	0	\N	\N	279184	0	180256009	4107731	
48208	4226	4107731	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	280773	0	180256009	4107731	
48360	4239	44783196	2019-04-19	2019-04-19 00:00:00	38000275	0	\N	\N	281511	0	699253003	44783196	
60494	5222	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	347499	0	180256009	4107731	
60610	5240	4163872	1997-04-08	1997-04-08 00:00:00	38000275	0	\N	\N	348612	0	399208008	4163872	
60839	5267	4107731	1997-01-25	1997-01-25 00:00:00	38000275	0	\N	\N	350467	0	180256009	4107731	
60995	5284	4151422	2010-08-07	2010-08-07 00:00:00	38000275	0	\N	\N	351598	0	269911007	4151422	
49278	4329	4295880	1999-12-12	1999-12-12 00:00:00	38000275	0	\N	\N	287087	0	76601001	4295880	
49829	4366	4107731	1997-08-19	1997-08-19 00:00:00	38000275	0	\N	\N	289727	0	180256009	4107731	
61985	5343	4107731	1997-05-04	1997-05-04 00:00:00	38000275	0	\N	\N	355897	0	180256009	4107731	
50209	4374	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	290466	0	180256009	4107731	
39644	3486	4043071	1974-09-27	1974-09-27 00:00:00	38000275	0	\N	\N	231278	0	228557008	4043071	
51924	4501	4295880	2000-06-29	2000-06-29 00:00:00	38000275	0	\N	\N	299739	0	76601001	4295880	
52160	4521	4170947	1933-04-15	1933-04-15 00:00:00	38000275	0	\N	\N	301010	0	274474001	4170947	
52403	4547	4043071	1916-05-28	1916-05-28 00:00:00	38000275	0	\N	\N	302855	0	228557008	4043071	
41051	3603	4107731	1990-04-01	1990-04-01 00:00:00	38000275	0	\N	\N	239400	0	180256009	4107731	
53239	4623	4107731	1992-03-31	1992-03-31 00:00:00	38000275	0	\N	\N	307954	0	180256009	4107731	
54010	4694	4107731	1996-07-07	1996-07-07 00:00:00	38000275	0	\N	\N	312667	0	180256009	4107731	
54419	4724	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	314698	0	180256009	4107731	
54729	4750	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	316372	0	180256009	4107731	
55182	4804	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	319597	0	180256009	4107731	
55381	4827	4047491	1963-08-27	1963-08-27 00:00:00	38000275	0	\N	\N	321144	0	1225002	4047491	
44186	3884	4043071	1986-02-15	1986-02-15 00:00:00	38000275	0	\N	\N	258123	0	228557008	4043071	
57164	4960	4125906	1991-02-14	1991-02-14 00:00:00	38000275	0	\N	\N	329714	0	288086009	4125906	
57354	4971	4043071	1948-06-20	1948-06-20 00:00:00	38000275	0	\N	\N	330606	0	228557008	4043071	
57704	5004	4107731	1992-07-21	1992-07-21 00:00:00	38000275	0	\N	\N	332902	0	180256009	4107731	
58106	5037	4295880	2002-05-01	2002-05-01 00:00:00	38000275	0	\N	\N	334777	0	76601001	4295880	
58266	5048	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	335499	0	180256009	4107731	
58479	5051	4107731	1991-01-31	1991-01-31 00:00:00	38000275	0	\N	\N	335873	0	180256009	4107731	
47910	4205	4107731	1992-10-10	1992-10-10 00:00:00	38000275	0	\N	\N	279246	0	180256009	4107731	
48209	4226	4107731	1991-08-18	1991-08-18 00:00:00	38000275	0	\N	\N	280652	0	180256009	4107731	
48361	4239	4252419	2019-04-12	2019-04-12 00:00:00	38000275	0	\N	\N	281553	0	74016001	4252419	
60495	5222	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	347376	0	180256009	4107731	
60611	5240	4195803	1997-04-08	1997-04-08 00:00:00	38000275	0	\N	\N	348612	0	312681000	4195803	
60840	5267	4107731	1999-01-09	1999-01-09 00:00:00	38000275	0	\N	\N	350457	0	180256009	4107731	
60996	5284	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	351585	0	180256009	4107731	
49279	4329	4295880	1997-09-15	1997-09-15 00:00:00	38000275	0	\N	\N	287084	0	76601001	4295880	
49830	4366	4107731	1996-10-08	1996-10-08 00:00:00	38000275	0	\N	\N	289703	0	180256009	4107731	
61986	5343	4107731	1997-04-13	1997-04-13 00:00:00	38000275	0	\N	\N	355918	0	180256009	4107731	
50210	4374	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	290453	0	180256009	4107731	
51426	4452	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	296279	0	180256009	4107731	
51925	4501	4295880	1999-12-30	1999-12-30 00:00:00	38000275	0	\N	\N	299709	0	76601001	4295880	
52161	4521	4024289	1933-04-15	1933-04-15 00:00:00	38000275	0	\N	\N	301010	0	19490002	4024289	
52404	4547	4195803	1969-06-29	1969-06-29 00:00:00	38000275	0	\N	\N	302950	0	312681000	4195803	
41052	3603	4151422	1973-12-13	1973-12-13 00:00:00	38000275	0	\N	\N	239360	0	269911007	4151422	
53240	4623	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	307959	0	180256009	4107731	
54011	4694	4107731	1997-03-16	1997-03-16 00:00:00	38000275	0	\N	\N	312693	0	180256009	4107731	
54420	4724	4062501	1945-05-13	1945-05-13 00:00:00	38000275	0	\N	\N	314745	0	171231001	4062501	
54730	4750	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	316387	0	180256009	4107731	
55183	4804	4107731	1992-10-05	1992-10-05 00:00:00	38000275	0	\N	\N	319630	0	180256009	4107731	
55382	4827	4024289	1990-01-21	1990-01-21 00:00:00	38000275	0	\N	\N	321147	0	19490002	4024289	
44187	3884	4043071	1986-06-28	1986-06-28 00:00:00	38000275	0	\N	\N	258111	0	228557008	4043071	
57165	4960	4293740	1991-02-14	1991-02-14 00:00:00	38000275	0	\N	\N	329714	0	384700001	4293740	
57355	4971	4043071	1950-02-26	1950-02-26 00:00:00	38000275	0	\N	\N	330584	0	228557008	4043071	
57705	5004	4107731	1991-08-20	1991-08-20 00:00:00	38000275	0	\N	\N	332869	0	180256009	4107731	
58107	5037	4295880	1998-05-06	1998-05-06 00:00:00	38000275	0	\N	\N	334747	0	76601001	4295880	
58267	5048	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	335497	0	180256009	4107731	
58480	5051	4107731	1991-05-16	1991-05-16 00:00:00	38000275	0	\N	\N	335896	0	180256009	4107731	
47911	4205	4107731	1991-09-28	1991-09-28 00:00:00	38000275	0	\N	\N	279173	0	180256009	4107731	
48210	4226	4107731	1991-07-07	1991-07-07 00:00:00	38000275	0	\N	\N	280676	0	180256009	4107731	
48362	4239	4062501	1952-10-01	1952-10-01 00:00:00	38000275	0	\N	\N	281536	0	171231001	4062501	
60496	5222	4078793	2005-02-17	2005-02-17 00:00:00	38000275	0	\N	\N	347425	0	180325003	4078793	
60612	5240	4170947	1997-04-08	1997-04-08 00:00:00	38000275	0	\N	\N	348612	0	274474001	4170947	
60841	5267	4107731	1996-01-13	1996-01-13 00:00:00	38000275	0	\N	\N	350363	0	180256009	4107731	
60997	5284	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	351576	0	180256009	4107731	
49280	4329	4295880	1995-06-19	1995-06-19 00:00:00	38000275	0	\N	\N	287081	0	76601001	4295880	
61711	5335	4043071	1967-09-29	1967-09-29 00:00:00	38000275	0	\N	\N	355253	0	228557008	4043071	
61987	5343	4107731	1997-03-23	1997-03-23 00:00:00	38000275	0	\N	\N	355896	0	180256009	4107731	
50211	4374	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	290556	0	180256009	4107731	
51427	4452	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	296318	0	180256009	4107731	
51926	4501	4295880	1999-04-01	1999-04-01 00:00:00	38000275	0	\N	\N	299708	0	76601001	4295880	
52162	4521	4078793	2003-02-13	2003-02-13 00:00:00	38000275	0	\N	\N	301037	0	180325003	4078793	
52405	4547	4043071	1916-04-23	1916-04-23 00:00:00	38000275	0	\N	\N	302854	0	228557008	4043071	
41053	3603	4107731	1991-07-07	1991-07-07 00:00:00	38000275	0	\N	\N	239410	0	180256009	4107731	
53241	4623	4107731	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	307914	0	180256009	4107731	
54012	4694	4107731	1996-03-24	1996-03-24 00:00:00	38000275	0	\N	\N	312688	0	180256009	4107731	
54421	4724	4047491	2003-09-14	2003-09-14 00:00:00	38000275	0	\N	\N	314690	0	1225002	4047491	
54731	4750	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	316401	0	180256009	4107731	
55184	4804	4107731	1990-12-03	1990-12-03 00:00:00	38000275	0	\N	\N	319569	0	180256009	4107731	
55383	4827	4170947	1990-01-21	1990-01-21 00:00:00	38000275	0	\N	\N	321147	0	274474001	4170947	
44188	3884	4107731	1993-03-01	1993-03-01 00:00:00	38000275	0	\N	\N	258081	0	180256009	4107731	
57166	4960	4125906	1964-10-19	1964-10-19 00:00:00	38000275	0	\N	\N	329710	0	288086009	4125906	
57356	4971	4195803	2015-02-24	2015-02-24 00:00:00	38000275	0	\N	\N	330583	0	312681000	4195803	
57706	5004	4107731	1993-01-26	1993-01-26 00:00:00	38000275	0	\N	\N	332903	0	180256009	4107731	
58108	5037	4295880	2003-01-29	2003-01-29 00:00:00	38000275	0	\N	\N	334764	0	76601001	4295880	
58268	5048	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	335477	0	180256009	4107731	
58481	5051	4107731	1993-01-14	1993-01-14 00:00:00	38000275	0	\N	\N	335934	0	180256009	4107731	
47912	4205	4107731	1990-04-21	1990-04-21 00:00:00	38000275	0	\N	\N	279255	0	180256009	4107731	
48211	4226	4107731	1990-10-07	1990-10-07 00:00:00	38000275	0	\N	\N	280673	0	180256009	4107731	
48363	4239	44783196	1993-08-05	1993-08-05 00:00:00	38000275	0	\N	\N	281510	0	699253003	44783196	
60497	5222	4078793	2017-08-17	2017-08-17 00:00:00	38000275	0	\N	\N	347351	0	180325003	4078793	
60613	5240	4125906	1975-06-14	1975-06-14 00:00:00	38000275	0	\N	\N	348609	0	288086009	4125906	
60842	5267	4191853	1995-12-23	1995-12-23 00:00:00	38000275	0	\N	\N	350431	0	395142003	4191853	
60998	5284	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	351563	0	180256009	4107731	
49281	4329	4252419	2014-10-19	2014-10-19 00:00:00	38000275	0	\N	\N	287106	0	74016001	4252419	
61712	5335	4125906	1975-08-18	1975-08-18 00:00:00	38000275	0	\N	\N	355239	0	288086009	4125906	
61988	5343	4107731	1998-02-01	1998-02-01 00:00:00	38000275	0	\N	\N	355900	0	180256009	4107731	
50212	4374	4295880	1995-05-04	1995-05-04 00:00:00	38000275	0	\N	\N	290467	0	76601001	4295880	
51428	4452	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	296222	0	180256009	4107731	
51927	4501	4295880	1998-04-02	1998-04-02 00:00:00	38000275	0	\N	\N	299680	0	76601001	4295880	
52163	4521	4078793	2001-01-25	2001-01-25 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
52406	4547	4125906	1916-10-06	1916-10-06 00:00:00	38000275	0	\N	\N	302955	0	288086009	4125906	
41054	3603	4107731	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	239449	0	180256009	4107731	
53242	4623	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	307975	0	180256009	4107731	
54013	4694	4107731	1994-10-16	1994-10-16 00:00:00	38000275	0	\N	\N	312738	0	180256009	4107731	
54422	4724	4195803	2003-09-14	2003-09-14 00:00:00	38000275	0	\N	\N	314690	0	312681000	4195803	
54732	4750	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	316288	0	180256009	4107731	
55185	4805	4163872	2019-02-13	2019-02-13 00:00:00	38000275	0	\N	\N	319687	0	399208008	4163872	
55384	4827	4125906	1970-12-18	1970-12-18 00:00:00	38000275	0	\N	\N	321145	0	288086009	4125906	
44189	3884	4043071	1984-09-15	1984-09-15 00:00:00	38000275	0	\N	\N	258176	0	228557008	4043071	
57180	4963	4043071	1988-09-12	1988-09-12 00:00:00	38000275	0	\N	\N	329901	0	228557008	4043071	
57357	4971	4151422	1968-03-06	1968-03-06 00:00:00	38000275	0	\N	\N	330548	0	269911007	4151422	
57707	5004	4151422	1984-07-30	1984-07-30 00:00:00	38000275	0	\N	\N	332882	0	269911007	4151422	
58109	5037	4295880	2004-04-28	2004-04-28 00:00:00	38000275	0	\N	\N	334825	0	76601001	4295880	
58269	5048	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	335521	0	180256009	4107731	
58482	5053	4125906	2001-07-15	2001-07-15 00:00:00	38000275	0	\N	\N	336021	0	288086009	4125906	
47913	4205	4107731	1990-07-14	1990-07-14 00:00:00	38000275	0	\N	\N	279162	0	180256009	4107731	
48212	4226	4107731	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	280700	0	180256009	4107731	
48364	4240	4195803	2010-10-04	2010-10-04 00:00:00	38000275	0	\N	\N	281594	0	312681000	4195803	
60498	5222	4035793	2017-08-17	2017-08-17 00:00:00	38000275	0	\N	\N	347351	0	15081005	4035793	
60614	5240	4151422	1942-01-14	1942-01-14 00:00:00	38000275	0	\N	\N	348711	0	269911007	4151422	
60843	5267	4107731	1996-05-18	1996-05-18 00:00:00	38000275	0	\N	\N	350384	0	180256009	4107731	
60999	5284	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	351578	0	180256009	4107731	
49282	4329	4295880	1998-06-15	1998-06-15 00:00:00	38000275	0	\N	\N	287085	0	76601001	4295880	
61713	5335	4043071	1967-03-17	1967-03-17 00:00:00	38000275	0	\N	\N	355251	0	228557008	4043071	
61989	5343	4295880	1999-03-28	1999-03-28 00:00:00	38000275	0	\N	\N	355893	0	76601001	4295880	
50213	4374	4191853	1979-06-16	1979-06-16 00:00:00	38000275	0	\N	\N	290554	0	395142003	4191853	
51429	4452	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	296287	0	180256009	4107731	
51928	4503	4078793	2018-04-24	2018-04-24 00:00:00	38000275	0	\N	\N	299827	0	180325003	4078793	
52164	4521	4243062	1996-12-15	1996-12-15 00:00:00	38000275	0	\N	\N	301015	0	60027007	4243062	
52407	4547	4170947	1997-09-07	1997-09-07 00:00:00	38000275	0	\N	\N	302962	0	274474001	4170947	
41055	3603	4107731	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	239381	0	180256009	4107731	
53243	4623	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	307948	0	180256009	4107731	
54014	4694	4107731	1997-06-29	1997-06-29 00:00:00	38000275	0	\N	\N	312672	0	180256009	4107731	
54423	4724	4170947	2003-09-14	2003-09-14 00:00:00	38000275	0	\N	\N	314690	0	274474001	4170947	
54733	4750	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	316350	0	180256009	4107731	
55186	4805	4125906	1972-05-04	1972-05-04 00:00:00	38000275	0	\N	\N	319731	0	288086009	4125906	
55385	4827	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	321166	0	180256009	4107731	
44190	3884	4107731	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	258169	0	180256009	4107731	
57181	4963	4043071	1988-12-12	1988-12-12 00:00:00	38000275	0	\N	\N	329949	0	228557008	4043071	
57358	4971	4043071	1949-06-26	1949-06-26 00:00:00	38000275	0	\N	\N	330627	0	228557008	4043071	
57708	5004	4107731	1991-10-22	1991-10-22 00:00:00	38000275	0	\N	\N	332846	0	180256009	4107731	
58110	5037	4295880	2007-07-25	2007-07-25 00:00:00	38000275	0	\N	\N	334828	0	76601001	4295880	
58270	5048	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	335425	0	180256009	4107731	
58483	5053	4293740	2001-07-15	2001-07-15 00:00:00	38000275	0	\N	\N	336021	0	384700001	4293740	
47914	4205	4191853	1993-07-10	1993-07-10 00:00:00	38000275	0	\N	\N	279249	0	395142003	4191853	
48213	4226	4107731	1993-04-18	1993-04-18 00:00:00	38000275	0	\N	\N	280774	0	180256009	4107731	
48365	4240	4170947	2010-10-04	2010-10-04 00:00:00	38000275	0	\N	\N	281594	0	274474001	4170947	
60499	5222	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	347436	0	180256009	4107731	
60615	5240	4010253	1970-10-09	1970-10-09 00:00:00	38000275	0	\N	\N	348714	0	112790001	4010253	
60844	5267	4107731	1996-04-27	1996-04-27 00:00:00	38000275	0	\N	\N	350464	0	180256009	4107731	
61000	5284	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	351558	0	180256009	4107731	
49283	4329	4163872	2013-12-19	2013-12-19 00:00:00	38000275	0	\N	\N	287125	0	399208008	4163872	
61714	5335	4043071	1967-04-21	1967-04-21 00:00:00	38000275	0	\N	\N	355252	0	228557008	4043071	
61990	5343	4295880	1998-09-27	1998-09-27 00:00:00	38000275	0	\N	\N	355830	0	76601001	4295880	
50214	4374	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	290480	0	180256009	4107731	
51430	4452	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	296283	0	180256009	4107731	
51929	4503	4057420	2016-04-12	2016-04-12 00:00:00	38000275	0	\N	\N	299826	0	18286008	4057420	
52165	4521	4170947	1996-12-15	1996-12-15 00:00:00	38000275	0	\N	\N	301015	0	274474001	4170947	
52408	4547	4047491	1997-09-07	1997-09-07 00:00:00	38000275	0	\N	\N	302962	0	1225002	4047491	
41056	3603	4107731	1991-01-20	1991-01-20 00:00:00	38000275	0	\N	\N	239421	0	180256009	4107731	
53244	4623	4107731	1993-05-25	1993-05-25 00:00:00	38000275	0	\N	\N	307916	0	180256009	4107731	
54015	4694	4107731	1994-09-04	1994-09-04 00:00:00	38000275	0	\N	\N	312737	0	180256009	4107731	
54424	4724	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	314829	0	180256009	4107731	
54734	4750	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	316341	0	180256009	4107731	
55187	4807	4151422	1988-07-27	1988-07-27 00:00:00	38000275	0	\N	\N	319799	0	269911007	4151422	
55386	4827	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	321223	0	180256009	4107731	
44191	3884	4043071	1985-01-19	1985-01-19 00:00:00	38000275	0	\N	\N	258177	0	228557008	4043071	
57182	4963	4043071	1987-06-08	1987-06-08 00:00:00	38000275	0	\N	\N	329868	0	228557008	4043071	
57359	4971	4043071	1947-04-20	1947-04-20 00:00:00	38000275	0	\N	\N	330528	0	228557008	4043071	
57709	5004	4107731	1991-12-24	1991-12-24 00:00:00	38000275	0	\N	\N	332794	0	180256009	4107731	
58111	5037	4295880	2003-10-29	2003-10-29 00:00:00	38000275	0	\N	\N	334765	0	76601001	4295880	
58271	5048	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	335493	0	180256009	4107731	
58484	5053	4125906	2013-09-22	2013-09-22 00:00:00	38000275	0	\N	\N	336023	0	288086009	4125906	
47915	4205	4107731	1990-12-08	1990-12-08 00:00:00	38000275	0	\N	\N	279257	0	180256009	4107731	
48214	4226	4107731	1991-11-10	1991-11-10 00:00:00	38000275	0	\N	\N	280730	0	180256009	4107731	
48366	4240	4243062	2010-10-04	2010-10-04 00:00:00	38000275	0	\N	\N	281594	0	60027007	4243062	
60500	5222	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	347412	0	180256009	4107731	
60616	5240	4151422	1956-12-06	1956-12-06 00:00:00	38000275	0	\N	\N	348713	0	269911007	4151422	
60845	5267	4107731	1997-05-10	1997-05-10 00:00:00	38000275	0	\N	\N	350389	0	180256009	4107731	
61001	5284	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	351538	0	180256009	4107731	
49284	4329	4295880	1998-09-14	1998-09-14 00:00:00	38000275	0	\N	\N	287162	0	76601001	4295880	
61715	5335	4043071	1966-09-16	1966-09-16 00:00:00	38000275	0	\N	\N	355293	0	228557008	4043071	
61991	5343	4197460	1984-04-26	1984-04-26 00:00:00	38000275	0	\N	\N	355926	0	313191000	4197460	
50215	4374	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	290503	0	180256009	4107731	
51431	4452	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	296228	0	180256009	4107731	
51930	4503	4078793	2015-04-07	2015-04-07 00:00:00	38000275	0	\N	\N	299847	0	180325003	4078793	
52166	4521	4195803	1996-12-15	1996-12-15 00:00:00	38000275	0	\N	\N	301015	0	312681000	4195803	
52409	4547	4024289	2016-10-02	2016-10-02 00:00:00	38000275	0	\N	\N	302964	0	19490002	4024289	
41057	3603	4107731	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	239417	0	180256009	4107731	
53245	4623	4107731	1991-04-09	1991-04-09 00:00:00	38000275	0	\N	\N	307908	0	180256009	4107731	
54016	4694	4191853	1994-08-14	1994-08-14 00:00:00	38000275	0	\N	\N	312751	0	395142003	4191853	
54425	4724	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	314828	0	180256009	4107731	
54735	4750	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	316407	0	180256009	4107731	
55188	4807	4125906	1946-03-24	1946-03-24 00:00:00	38000275	0	\N	\N	319805	0	288086009	4125906	
55387	4827	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	321224	0	395142003	4191853	
44192	3884	4043071	1988-09-17	1988-09-17 00:00:00	38000275	0	\N	\N	258032	0	228557008	4043071	
57183	4963	4043071	1990-07-02	1990-07-02 00:00:00	38000275	0	\N	\N	329937	0	228557008	4043071	
57360	4971	4043071	1949-02-20	1949-02-20 00:00:00	38000275	0	\N	\N	330613	0	228557008	4043071	
57710	5004	4107731	1992-04-07	1992-04-07 00:00:00	38000275	0	\N	\N	332856	0	180256009	4107731	
58112	5037	4295880	1998-08-05	1998-08-05 00:00:00	38000275	0	\N	\N	334787	0	76601001	4295880	
58272	5048	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	335466	0	180256009	4107731	
58485	5053	4125906	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	336020	0	288086009	4125906	
47916	4205	4107731	1990-09-15	1990-09-15 00:00:00	38000275	0	\N	\N	279183	0	180256009	4107731	
48215	4226	4107731	1991-09-29	1991-09-29 00:00:00	38000275	0	\N	\N	280653	0	180256009	4107731	
48367	4240	4198190	1965-07-16	1965-07-16 00:00:00	38000275	0	\N	\N	281640	0	80146002	4198190	
60501	5222	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	347343	0	180256009	4107731	
60617	5240	4252419	1979-04-06	1979-04-06 00:00:00	38000275	0	\N	\N	348611	0	74016001	4252419	
60846	5267	4107731	1998-05-02	1998-05-02 00:00:00	38000275	0	\N	\N	350371	0	180256009	4107731	
61002	5284	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	351534	0	180256009	4107731	
49285	4329	4295880	1997-06-16	1997-06-16 00:00:00	38000275	0	\N	\N	287131	0	76601001	4295880	
61716	5335	4043071	1968-04-05	1968-04-05 00:00:00	38000275	0	\N	\N	355256	0	228557008	4043071	
61992	5343	4107731	1999-03-28	1999-03-28 00:00:00	38000275	0	\N	\N	355893	0	180256009	4107731	
50216	4374	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	290583	0	180256009	4107731	
51432	4452	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	296292	0	180256009	4107731	
51931	4503	4078793	2019-04-30	2019-04-30 00:00:00	38000275	0	\N	\N	299828	0	180325003	4078793	
52167	4521	4078793	2006-05-25	2006-05-25 00:00:00	38000275	0	\N	\N	301026	0	180325003	4078793	
52410	4547	4170947	2016-10-02	2016-10-02 00:00:00	38000275	0	\N	\N	302964	0	274474001	4170947	
41058	3603	4107731	1993-05-09	1993-05-09 00:00:00	38000275	0	\N	\N	239352	0	180256009	4107731	
53246	4623	4107731	1990-06-19	1990-06-19 00:00:00	38000275	0	\N	\N	307934	0	180256009	4107731	
54017	4694	4107731	1995-08-27	1995-08-27 00:00:00	38000275	0	\N	\N	312708	0	180256009	4107731	
54426	4724	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	314775	0	180256009	4107731	
54736	4750	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	316365	0	180256009	4107731	
55189	4807	4195803	2006-03-09	2006-03-09 00:00:00	38000275	0	\N	\N	319872	0	312681000	4195803	
55388	4827	4151422	1995-02-02	1995-02-02 00:00:00	38000275	0	\N	\N	321094	0	269911007	4151422	
44193	3884	4107731	1990-02-12	1990-02-12 00:00:00	38000275	0	\N	\N	258092	0	180256009	4107731	
57184	4963	4043071	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	329917	0	228557008	4043071	
57361	4971	4043071	1950-12-10	1950-12-10 00:00:00	38000275	0	\N	\N	330642	0	228557008	4043071	
57711	5004	4107731	1993-01-05	1993-01-05 00:00:00	38000275	0	\N	\N	332859	0	180256009	4107731	
58113	5037	4151422	2002-04-08	2002-04-08 00:00:00	38000275	0	\N	\N	334711	0	269911007	4151422	
58273	5048	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	335495	0	180256009	4107731	
58486	5053	4163872	1979-08-27	1979-08-27 00:00:00	38000275	0	\N	\N	335990	0	399208008	4163872	
47917	4205	4107731	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	279189	0	180256009	4107731	
48216	4226	4107731	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	280695	0	180256009	4107731	
48368	4240	4010253	1967-06-26	1967-06-26 00:00:00	38000275	0	\N	\N	281668	0	112790001	4010253	
60502	5222	4078793	2004-02-12	2004-02-12 00:00:00	38000275	0	\N	\N	347466	0	180325003	4078793	
60618	5240	44783196	1979-04-13	1979-04-13 00:00:00	38000275	0	\N	\N	348689	0	699253003	44783196	
60847	5267	4107731	1998-10-17	1998-10-17 00:00:00	38000275	0	\N	\N	350455	0	180256009	4107731	
61003	5284	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	351557	0	180256009	4107731	
49286	4329	4295880	1994-06-20	1994-06-20 00:00:00	38000275	0	\N	\N	287077	0	76601001	4295880	
61717	5335	4043071	1967-11-03	1967-11-03 00:00:00	38000275	0	\N	\N	355254	0	228557008	4043071	
61993	5343	4107731	1998-08-30	1998-08-30 00:00:00	38000275	0	\N	\N	355923	0	180256009	4107731	
50217	4374	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	290562	0	180256009	4107731	
51433	4452	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	296254	0	180256009	4107731	
51932	4503	4057420	2017-04-18	2017-04-18 00:00:00	38000275	0	\N	\N	299848	0	18286008	4057420	
52168	4521	4078793	2005-11-10	2005-11-10 00:00:00	38000275	0	\N	\N	301025	0	180325003	4078793	
52411	4547	4043071	1916-01-16	1916-01-16 00:00:00	38000275	0	\N	\N	302975	0	228557008	4043071	
41059	3603	4107731	1991-03-03	1991-03-03 00:00:00	38000275	0	\N	\N	239422	0	180256009	4107731	
53247	4623	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	307905	0	180256009	4107731	
54018	4694	4107731	1997-07-20	1997-07-20 00:00:00	38000275	0	\N	\N	312771	0	180256009	4107731	
54427	4724	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	314791	0	180256009	4107731	
54737	4750	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	316346	0	180256009	4107731	
55190	4807	4293740	1954-03-03	1954-03-03 00:00:00	38000275	0	\N	\N	319806	0	384700001	4293740	
55389	4827	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	321187	0	180256009	4107731	
44194	3884	4043071	1987-12-12	1987-12-12 00:00:00	38000275	0	\N	\N	258128	0	228557008	4043071	
57185	4963	4043071	1988-02-29	1988-02-29 00:00:00	38000275	0	\N	\N	329900	0	228557008	4043071	
57362	4971	4043071	1947-10-19	1947-10-19 00:00:00	38000275	0	\N	\N	330518	0	228557008	4043071	
57712	5004	4107731	1993-06-01	1993-06-01 00:00:00	38000275	0	\N	\N	332853	0	180256009	4107731	
58114	5037	4295880	1998-02-04	1998-02-04 00:00:00	38000275	0	\N	\N	334812	0	76601001	4295880	
58274	5049	4057420	1998-02-18	1998-02-18 00:00:00	38000275	0	\N	\N	335586	0	18286008	4057420	
58487	5053	4024289	1991-06-24	1991-06-24 00:00:00	38000275	0	\N	\N	336019	0	19490002	4024289	
47918	4205	4107731	1992-02-22	1992-02-22 00:00:00	38000275	0	\N	\N	279230	0	180256009	4107731	
48217	4226	4107731	1991-12-22	1991-12-22 00:00:00	38000275	0	\N	\N	280751	0	180256009	4107731	
48369	4240	4125906	1981-11-21	1981-11-21 00:00:00	38000275	0	\N	\N	281593	0	288086009	4125906	
60503	5222	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	347491	0	180256009	4107731	
60619	5241	4125906	2012-10-26	2012-10-26 00:00:00	38000275	0	\N	\N	348800	0	288086009	4125906	
60848	5267	4107731	1997-12-27	1997-12-27 00:00:00	38000275	0	\N	\N	350391	0	180256009	4107731	
61004	5284	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	351556	0	180256009	4107731	
49287	4329	4295880	2000-09-11	2000-09-11 00:00:00	38000275	0	\N	\N	287133	0	76601001	4295880	
61718	5335	4043071	1967-02-17	1967-02-17 00:00:00	38000275	0	\N	\N	355313	0	228557008	4043071	
61994	5343	4107731	1999-04-18	1999-04-18 00:00:00	38000275	0	\N	\N	355933	0	180256009	4107731	
50218	4374	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	290461	0	180256009	4107731	
51434	4452	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	296298	0	180256009	4107731	
51933	4503	4252419	2001-02-10	2001-02-10 00:00:00	38000275	0	\N	\N	299862	0	74016001	4252419	
52169	4521	4078793	2007-11-08	2007-11-08 00:00:00	38000275	0	\N	\N	300973	0	180325003	4078793	
52412	4548	4107731	1999-05-04	1999-05-04 00:00:00	38000275	0	\N	\N	303036	0	180256009	4107731	
41060	3603	4107731	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	239331	0	180256009	4107731	
53248	4623	4125906	1970-12-10	1970-12-10 00:00:00	38000275	0	\N	\N	308005	0	288086009	4125906	
54019	4694	4107731	1996-01-21	1996-01-21 00:00:00	38000275	0	\N	\N	312742	0	180256009	4107731	
54428	4724	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	314827	0	180256009	4107731	
54738	4750	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	316344	0	180256009	4107731	
55191	4807	4125906	1954-03-03	1954-03-03 00:00:00	38000275	0	\N	\N	319806	0	288086009	4125906	
55390	4827	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	321215	0	180256009	4107731	
44195	3884	4191853	1975-04-23	1975-04-23 00:00:00	38000275	0	\N	\N	258017	0	395142003	4191853	
57186	4963	4163872	2011-12-24	2011-12-24 00:00:00	38000275	0	\N	\N	329908	0	399208008	4163872	
57363	4971	4043071	1947-12-28	1947-12-28 00:00:00	38000275	0	\N	\N	330624	0	228557008	4043071	
57713	5004	4107731	1990-12-11	1990-12-11 00:00:00	38000275	0	\N	\N	332886	0	180256009	4107731	
58115	5039	4125906	1976-05-13	1976-05-13 00:00:00	38000275	0	\N	\N	334865	0	288086009	4125906	
58275	5049	40492359	1998-02-18	1998-02-18 00:00:00	38000275	0	\N	\N	335586	0	447365002	40492359	
58488	5053	4170947	1991-06-24	1991-06-24 00:00:00	38000275	0	\N	\N	336019	0	274474001	4170947	
47919	4205	4107731	1992-06-27	1992-06-27 00:00:00	38000275	0	\N	\N	279233	0	180256009	4107731	
48218	4226	4107731	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	280640	0	180256009	4107731	
48370	4241	4125906	1985-02-28	1985-02-28 00:00:00	38000275	0	\N	\N	281698	0	288086009	4125906	
60504	5222	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	347500	0	180256009	4107731	
60620	5241	4170947	1969-04-19	1969-04-19 00:00:00	38000275	0	\N	\N	348786	0	274474001	4170947	
60849	5267	4107731	1998-02-07	1998-02-07 00:00:00	38000275	0	\N	\N	350392	0	180256009	4107731	
61005	5284	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	351552	0	180256009	4107731	
49288	4329	4295880	1996-03-17	1996-03-17 00:00:00	38000275	0	\N	\N	287082	0	76601001	4295880	
61719	5335	4043071	1967-08-25	1967-08-25 00:00:00	38000275	0	\N	\N	355314	0	228557008	4043071	
61995	5343	4107731	1997-12-21	1997-12-21 00:00:00	38000275	0	\N	\N	355899	0	180256009	4107731	
50219	4374	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	290491	0	180256009	4107731	
51435	4452	4058899	1956-06-27	1956-06-27 00:00:00	38000275	0	\N	\N	296341	0	168594001	4058899	
51934	4503	4078793	2014-04-01	2014-04-01 00:00:00	38000275	0	\N	\N	299856	0	180325003	4078793	
52170	4521	4078793	2006-11-02	2006-11-02 00:00:00	38000275	0	\N	\N	301027	0	180325003	4078793	
52413	4548	4107731	1998-12-29	1998-12-29 00:00:00	38000275	0	\N	\N	303005	0	180256009	4107731	
41061	3603	4107731	1992-05-17	1992-05-17 00:00:00	38000275	0	\N	\N	239414	0	180256009	4107731	
53249	4623	4107731	1990-12-25	1990-12-25 00:00:00	38000275	0	\N	\N	307935	0	180256009	4107731	
54020	4694	4191853	1982-07-22	1982-07-22 00:00:00	38000275	0	\N	\N	312703	0	395142003	4191853	
54429	4724	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	314665	0	180256009	4107731	
54739	4750	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	316338	0	180256009	4107731	
55192	4807	4163872	1974-03-15	1974-03-15 00:00:00	38000275	0	\N	\N	319856	0	399208008	4163872	
55391	4827	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	321210	0	180256009	4107731	
44196	3884	4043071	1985-12-14	1985-12-14 00:00:00	38000275	0	\N	\N	258109	0	228557008	4043071	
57187	4963	4043071	1989-07-03	1989-07-03 00:00:00	38000275	0	\N	\N	329904	0	228557008	4043071	
57364	4971	4043071	1947-02-16	1947-02-16 00:00:00	38000275	0	\N	\N	330620	0	228557008	4043071	
57714	5004	4107731	1990-11-20	1990-11-20 00:00:00	38000275	0	\N	\N	332880	0	180256009	4107731	
58116	5039	4293740	1976-05-13	1976-05-13 00:00:00	38000275	0	\N	\N	334865	0	384700001	4293740	
58276	5049	4043071	1971-06-04	1971-06-04 00:00:00	38000275	0	\N	\N	335559	0	228557008	4043071	
58489	5053	4195803	1991-06-24	1991-06-24 00:00:00	38000275	0	\N	\N	336019	0	312681000	4195803	
47920	4205	4107731	1991-10-19	1991-10-19 00:00:00	38000275	0	\N	\N	279261	0	180256009	4107731	
48219	4226	4107731	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	280754	0	180256009	4107731	
48371	4241	4293740	1985-02-28	1985-02-28 00:00:00	38000275	0	\N	\N	281698	0	384700001	4293740	
60505	5222	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	347497	0	180256009	4107731	
60621	5241	4163872	1969-04-19	1969-04-19 00:00:00	38000275	0	\N	\N	348786	0	399208008	4163872	
60850	5267	4107731	1996-03-16	1996-03-16 00:00:00	38000275	0	\N	\N	350433	0	180256009	4107731	
61006	5284	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	351561	0	180256009	4107731	
49289	4329	4151422	1981-10-16	1981-10-16 00:00:00	38000275	0	\N	\N	287120	0	269911007	4151422	
61722	5337	4107731	1991-11-03	1991-11-03 00:00:00	38000275	0	\N	\N	355473	0	180256009	4107731	
61996	5343	4107731	1996-03-31	1996-03-31 00:00:00	38000275	0	\N	\N	355862	0	180256009	4107731	
50220	4374	4295880	1993-11-04	1993-11-04 00:00:00	38000275	0	\N	\N	290543	0	76601001	4295880	
51436	4452	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	296300	0	180256009	4107731	
51935	4503	44783196	2001-02-17	2001-02-17 00:00:00	38000275	0	\N	\N	299863	0	699253003	44783196	
52171	4521	4195803	2008-11-13	2008-11-13 00:00:00	38000275	0	\N	\N	301028	0	312681000	4195803	
52414	4548	4107731	1999-08-17	1999-08-17 00:00:00	38000275	0	\N	\N	302987	0	180256009	4107731	
41062	3603	4107731	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	239350	0	180256009	4107731	
53250	4623	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	307950	0	180256009	4107731	
54021	4694	4107731	1996-09-08	1996-09-08 00:00:00	38000275	0	\N	\N	312767	0	180256009	4107731	
54430	4724	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	314696	0	180256009	4107731	
54740	4750	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	316337	0	180256009	4107731	
55193	4807	4010253	1959-09-14	1959-09-14 00:00:00	38000275	0	\N	\N	319786	0	112790001	4010253	
55392	4827	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	321090	0	180256009	4107731	
44197	3884	4043071	1986-10-04	1986-10-04 00:00:00	38000275	0	\N	\N	258126	0	228557008	4043071	
57188	4963	4043071	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	329906	0	228557008	4043071	
57365	4971	4043071	1948-10-17	1948-10-17 00:00:00	38000275	0	\N	\N	330608	0	228557008	4043071	
57715	5004	4107731	1993-08-03	1993-08-03 00:00:00	38000275	0	\N	\N	332801	0	180256009	4107731	
58117	5039	4058899	1994-12-17	1994-12-17 00:00:00	38000275	0	\N	\N	334867	0	168594001	4058899	
58277	5049	4043071	1972-07-21	1972-07-21 00:00:00	38000275	0	\N	\N	335626	0	228557008	4043071	
58490	5053	4163872	2018-07-21	2018-07-21 00:00:00	38000275	0	\N	\N	336031	0	399208008	4163872	
47921	4205	4107731	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	279220	0	180256009	4107731	
48220	4226	4107731	1993-03-28	1993-03-28 00:00:00	38000275	0	\N	\N	280659	0	180256009	4107731	
48372	4241	4125906	1976-05-02	1976-05-02 00:00:00	38000275	0	\N	\N	281750	0	288086009	4125906	
60506	5222	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	347339	0	180256009	4107731	
60622	5241	4195803	2017-05-17	2017-05-17 00:00:00	38000275	0	\N	\N	348801	0	312681000	4195803	
60851	5267	4107731	1997-09-13	1997-09-13 00:00:00	38000275	0	\N	\N	350369	0	180256009	4107731	
61007	5284	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	351579	0	180256009	4107731	
49290	4329	4295880	1998-03-15	1998-03-15 00:00:00	38000275	0	\N	\N	287132	0	76601001	4295880	
61723	5337	4107731	1992-08-23	1992-08-23 00:00:00	38000275	0	\N	\N	355414	0	180256009	4107731	
61997	5343	4107731	1997-09-07	1997-09-07 00:00:00	38000275	0	\N	\N	355909	0	180256009	4107731	
50221	4374	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	290579	0	180256009	4107731	
51437	4454	4243062	1996-02-28	1996-02-28 00:00:00	38000275	0	\N	\N	296501	0	60027007	4243062	
51936	4504	4125906	2008-08-10	2008-08-10 00:00:00	38000275	0	\N	\N	299903	0	288086009	4125906	
52172	4521	4057420	2008-11-13	2008-11-13 00:00:00	38000275	0	\N	\N	301028	0	18286008	4057420	
52415	4548	4107731	1998-03-10	1998-03-10 00:00:00	38000275	0	\N	\N	303022	0	180256009	4107731	
41063	3603	4107731	1991-05-26	1991-05-26 00:00:00	38000275	0	\N	\N	239409	0	180256009	4107731	
53251	4623	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	307988	0	180256009	4107731	
54022	4694	4107731	1998-01-04	1998-01-04 00:00:00	38000275	0	\N	\N	312762	0	180256009	4107731	
54431	4724	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	314692	0	180256009	4107731	
54741	4750	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	316348	0	180256009	4107731	
55194	4807	4151422	2012-04-08	2012-04-08 00:00:00	38000275	0	\N	\N	319888	0	269911007	4151422	
55393	4827	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	321122	0	180256009	4107731	
44198	3885	4151422	2014-06-18	2014-06-18 00:00:00	38000275	0	\N	\N	258227	0	269911007	4151422	
57189	4963	4043071	1989-11-13	1989-11-13 00:00:00	38000275	0	\N	\N	329915	0	228557008	4043071	
57366	4971	4043071	1948-03-21	1948-03-21 00:00:00	38000275	0	\N	\N	330520	0	228557008	4043071	
57716	5004	4107731	1991-07-09	1991-07-09 00:00:00	38000275	0	\N	\N	332868	0	180256009	4107731	
58118	5039	4163872	1979-12-25	1979-12-25 00:00:00	38000275	0	\N	\N	334855	0	399208008	4163872	
58278	5049	4170947	1970-07-18	1970-07-18 00:00:00	38000275	0	\N	\N	335584	0	274474001	4170947	
58492	5056	4202451	2003-05-22	2003-05-22 00:00:00	38000275	0	\N	\N	336194	0	433112001	4202451	
47922	4205	4107731	1992-04-04	1992-04-04 00:00:00	38000275	0	\N	\N	279231	0	180256009	4107731	
48221	4226	4107731	1992-06-07	1992-06-07 00:00:00	38000275	0	\N	\N	280689	0	180256009	4107731	
48373	4241	4163872	1996-02-07	1996-02-07 00:00:00	38000275	0	\N	\N	281754	0	399208008	4163872	
60507	5222	4078793	2009-03-12	2009-03-12 00:00:00	38000275	0	\N	\N	347423	0	180325003	4078793	
60623	5241	4024289	2017-05-17	2017-05-17 00:00:00	38000275	0	\N	\N	348801	0	19490002	4024289	
60852	5267	4107731	1998-05-23	1998-05-23 00:00:00	38000275	0	\N	\N	350439	0	180256009	4107731	
61008	5284	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	351523	0	180256009	4107731	
49291	4329	4295880	1999-03-14	1999-03-14 00:00:00	38000275	0	\N	\N	287086	0	76601001	4295880	
61724	5337	4107731	1992-02-16	1992-02-16 00:00:00	38000275	0	\N	\N	355458	0	180256009	4107731	
61998	5343	4295880	1996-12-29	1996-12-29 00:00:00	38000275	0	\N	\N	355882	0	76601001	4295880	
50222	4374	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	290450	0	180256009	4107731	
51438	4454	4195803	1996-02-28	1996-02-28 00:00:00	38000275	0	\N	\N	296501	0	312681000	4195803	
51937	4504	4058899	2003-11-05	2003-11-05 00:00:00	38000275	0	\N	\N	299902	0	168594001	4058899	
52173	4521	4078793	2003-10-23	2003-10-23 00:00:00	38000275	0	\N	\N	\N	0	180325003	4078793	
52416	4548	4107731	1998-11-17	1998-11-17 00:00:00	38000275	0	\N	\N	303004	0	180256009	4107731	
41064	3603	4107731	1992-08-09	1992-08-09 00:00:00	38000275	0	\N	\N	239349	0	180256009	4107731	
53252	4623	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	307882	0	180256009	4107731	
54023	4694	4107731	1995-10-08	1995-10-08 00:00:00	38000275	0	\N	\N	312709	0	180256009	4107731	
54432	4724	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	314726	0	180256009	4107731	
54742	4750	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	316343	0	180256009	4107731	
55201	4811	4198190	1995-04-10	1995-04-10 00:00:00	38000275	0	\N	\N	320081	0	80146002	4198190	
55394	4827	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	321165	0	180256009	4107731	
44199	3885	4125906	2011-12-19	2011-12-19 00:00:00	38000275	0	\N	\N	258220	0	288086009	4125906	
57190	4963	4151422	1980-10-29	1980-10-29 00:00:00	38000275	0	\N	\N	329962	0	269911007	4151422	
57367	4971	4043071	1949-03-27	1949-03-27 00:00:00	38000275	0	\N	\N	330614	0	228557008	4043071	
57717	5004	4107731	1993-02-16	1993-02-16 00:00:00	38000275	0	\N	\N	332860	0	180256009	4107731	
58119	5039	4125906	1984-02-22	1984-02-22 00:00:00	38000275	0	\N	\N	334866	0	288086009	4125906	
58279	5049	4024289	1970-07-18	1970-07-18 00:00:00	38000275	0	\N	\N	335584	0	19490002	4024289	
58493	5056	4145310	1950-09-03	1950-09-03 00:00:00	38000275	0	\N	\N	336162	0	268425006	4145310	
47923	4205	4107731	1990-06-02	1990-06-02 00:00:00	38000275	0	\N	\N	279256	0	180256009	4107731	
48222	4226	4107731	1991-02-10	1991-02-10 00:00:00	38000275	0	\N	\N	280727	0	180256009	4107731	
48374	4241	4125906	1965-10-22	1965-10-22 00:00:00	38000275	0	\N	\N	281747	0	288086009	4125906	
60508	5222	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	347373	0	180256009	4107731	
60624	5241	4170947	2017-05-17	2017-05-17 00:00:00	38000275	0	\N	\N	348801	0	274474001	4170947	
60853	5267	4107731	1997-11-15	1997-11-15 00:00:00	38000275	0	\N	\N	350390	0	180256009	4107731	
61009	5284	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	351521	0	180256009	4107731	
49292	4329	4295880	1997-12-14	1997-12-14 00:00:00	38000275	0	\N	\N	287161	0	76601001	4295880	
61725	5337	4107731	1990-10-21	1990-10-21 00:00:00	38000275	0	\N	\N	355453	0	180256009	4107731	
61999	5343	4107731	1998-08-09	1998-08-09 00:00:00	38000275	0	\N	\N	355890	0	180256009	4107731	
50223	4374	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	290576	0	180256009	4107731	
51439	4454	4170947	1996-02-28	1996-02-28 00:00:00	38000275	0	\N	\N	296501	0	274474001	4170947	
51938	4504	4024289	1992-03-07	1992-03-07 00:00:00	38000275	0	\N	\N	299901	0	19490002	4024289	
52417	4548	4107731	1998-06-23	1998-06-23 00:00:00	38000275	0	\N	\N	303105	0	180256009	4107731	
41065	3603	4107731	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	239384	0	180256009	4107731	
53253	4623	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	307906	0	180256009	4107731	
54024	4694	4107731	1996-12-22	1996-12-22 00:00:00	38000275	0	\N	\N	312691	0	180256009	4107731	
54433	4724	4037675	1941-05-07	1941-05-07 00:00:00	38000275	0	\N	\N	314678	0	162676008	4037675	
54743	4750	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	316347	0	180256009	4107731	
55202	4811	4243062	1965-12-26	1965-12-26 00:00:00	38000275	0	\N	\N	320082	0	60027007	4243062	
55395	4827	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	321185	0	180256009	4107731	
44200	3885	4125906	1987-11-29	1987-11-29 00:00:00	38000275	0	\N	\N	258217	0	288086009	4125906	
57191	4963	4043071	1990-01-22	1990-01-22 00:00:00	38000275	0	\N	\N	329875	0	228557008	4043071	
57368	4971	4043071	1948-08-22	1948-08-22 00:00:00	38000275	0	\N	\N	330626	0	228557008	4043071	
57718	5004	4107731	1991-01-01	1991-01-01 00:00:00	38000275	0	\N	\N	332827	0	180256009	4107731	
58120	5041	4010253	1981-12-01	1981-12-01 00:00:00	38000275	0	\N	\N	334917	0	112790001	4010253	
58280	5049	4043071	1972-03-24	1972-03-24 00:00:00	38000275	0	\N	\N	335625	0	228557008	4043071	
58494	5056	4151422	2000-09-14	2000-09-14 00:00:00	38000275	0	\N	\N	336124	0	269911007	4151422	
47924	4205	4107731	1991-02-09	1991-02-09 00:00:00	38000275	0	\N	\N	279171	0	180256009	4107731	
48223	4226	4107731	1991-05-05	1991-05-05 00:00:00	38000275	0	\N	\N	280729	0	180256009	4107731	
48375	4243	4125906	1987-02-08	1987-02-08 00:00:00	38000275	0	\N	\N	281802	0	288086009	4125906	
60509	5222	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	347493	0	180256009	4107731	
60625	5242	4078793	2018-08-31	2018-08-31 00:00:00	38000275	0	\N	\N	348827	0	180325003	4078793	
60854	5267	4107731	1999-04-03	1999-04-03 00:00:00	38000275	0	\N	\N	350443	0	180256009	4107731	
61010	5284	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	351594	0	180256009	4107731	
49293	4329	4295880	1994-03-19	1994-03-19 00:00:00	38000275	0	\N	\N	287150	0	76601001	4295880	
61726	5337	4107731	1991-06-30	1991-06-30 00:00:00	38000275	0	\N	\N	355401	0	180256009	4107731	
62000	5343	4295880	1998-03-29	1998-03-29 00:00:00	38000275	0	\N	\N	355839	0	76601001	4295880	
50224	4374	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	290457	0	180256009	4107731	
51440	4454	4078793	2009-10-24	2009-10-24 00:00:00	38000275	0	\N	\N	296378	0	180325003	4078793	
51939	4504	4170947	1992-03-07	1992-03-07 00:00:00	38000275	0	\N	\N	299901	0	274474001	4170947	
52418	4548	4107731	1998-07-14	1998-07-14 00:00:00	38000275	0	\N	\N	303043	0	180256009	4107731	
41066	3603	4107731	1992-04-26	1992-04-26 00:00:00	38000275	0	\N	\N	239382	0	180256009	4107731	
53254	4623	4107731	1991-09-24	1991-09-24 00:00:00	38000275	0	\N	\N	307953	0	180256009	4107731	
54025	4694	4107731	1997-01-12	1997-01-12 00:00:00	38000275	0	\N	\N	312757	0	180256009	4107731	
54434	4724	4326177	1941-05-07	1941-05-07 00:00:00	38000275	0	\N	\N	314678	0	430193006	4326177	
54744	4750	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	316345	0	180256009	4107731	
55203	4811	4170947	1965-12-26	1965-12-26 00:00:00	38000275	0	\N	\N	320082	0	274474001	4170947	
55396	4827	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	321184	0	180256009	4107731	
44201	3885	4024289	1968-09-06	1968-09-06 00:00:00	38000275	0	\N	\N	258295	0	19490002	4024289	
57192	4963	4043071	1988-07-04	1988-07-04 00:00:00	38000275	0	\N	\N	329871	0	228557008	4043071	
57369	4971	4043071	1950-01-29	1950-01-29 00:00:00	38000275	0	\N	\N	330640	0	228557008	4043071	
57719	5004	4107731	1993-06-22	1993-06-22 00:00:00	38000275	0	\N	\N	332800	0	180256009	4107731	
58121	5041	4170947	2013-01-17	2013-01-17 00:00:00	38000275	0	\N	\N	334921	0	274474001	4170947	
58281	5049	4043071	1972-04-21	1972-04-21 00:00:00	38000275	0	\N	\N	335591	0	228557008	4043071	
58495	5056	4195803	2005-10-12	2005-10-12 00:00:00	38000275	0	\N	\N	336181	0	312681000	4195803	
47925	4205	4107731	1991-09-07	1991-09-07 00:00:00	38000275	0	\N	\N	279188	0	180256009	4107731	
48224	4226	4107731	1990-06-03	1990-06-03 00:00:00	38000275	0	\N	\N	280731	0	180256009	4107731	
48376	4243	4293740	1987-02-08	1987-02-08 00:00:00	38000275	0	\N	\N	281802	0	384700001	4293740	
60510	5222	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	347458	0	180256009	4107731	
60631	5245	4125906	2004-06-02	2004-06-02 00:00:00	38000275	0	\N	\N	348937	0	288086009	4125906	
60855	5267	4107731	1996-06-08	1996-06-08 00:00:00	38000275	0	\N	\N	350465	0	180256009	4107731	
61011	5284	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	351566	0	180256009	4107731	
49294	4329	4295880	2000-06-12	2000-06-12 00:00:00	38000275	0	\N	\N	287113	0	76601001	4295880	
61727	5337	4107731	1991-09-22	1991-09-22 00:00:00	38000275	0	\N	\N	355472	0	180256009	4107731	
50225	4374	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	290455	0	180256009	4107731	
51441	4454	4078793	2006-10-07	2006-10-07 00:00:00	38000275	0	\N	\N	296468	0	180325003	4078793	
51940	4504	4024289	1978-01-20	1978-01-20 00:00:00	38000275	0	\N	\N	299900	0	19490002	4024289	
52419	4548	4107731	1998-03-31	1998-03-31 00:00:00	38000275	0	\N	\N	303002	0	180256009	4107731	
41067	3603	4107731	1991-10-20	1991-10-20 00:00:00	38000275	0	\N	\N	239424	0	180256009	4107731	
53255	4625	4125906	1991-07-15	1991-07-15 00:00:00	38000275	0	\N	\N	308132	0	288086009	4125906	
54026	4694	4295880	2002-06-30	2002-06-30 00:00:00	38000275	0	\N	\N	312715	0	76601001	4295880	
54435	4724	4187458	1941-05-07	1941-05-07 00:00:00	38000275	0	\N	\N	314678	0	415300000	4187458	
54745	4750	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	316414	0	180256009	4107731	
55204	4811	4125906	2011-02-17	2011-02-17 00:00:00	38000275	0	\N	\N	320053	0	288086009	4125906	
55397	4827	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	321087	0	180256009	4107731	
44202	3885	4170947	1968-09-06	1968-09-06 00:00:00	38000275	0	\N	\N	258295	0	274474001	4170947	
57193	4963	4043071	1989-02-06	1989-02-06 00:00:00	38000275	0	\N	\N	329934	0	228557008	4043071	
57370	4971	4043071	1948-12-19	1948-12-19 00:00:00	38000275	0	\N	\N	330522	0	228557008	4043071	
57720	5004	4107731	1990-06-05	1990-06-05 00:00:00	38000275	0	\N	\N	332873	0	180256009	4107731	
58122	5041	4163872	2013-01-17	2013-01-17 00:00:00	38000275	0	\N	\N	334921	0	399208008	4163872	
58282	5049	4043071	1971-10-08	1971-10-08 00:00:00	38000275	0	\N	\N	335590	0	228557008	4043071	
58496	5056	4170947	2005-10-12	2005-10-12 00:00:00	38000275	0	\N	\N	336181	0	274474001	4170947	
47926	4205	4107731	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	279232	0	180256009	4107731	
48225	4226	4107731	1990-04-22	1990-04-22 00:00:00	38000275	0	\N	\N	280770	0	180256009	4107731	
48380	4246	4151422	1989-05-02	1989-05-02 00:00:00	38000275	0	\N	\N	281951	0	269911007	4151422	
60511	5222	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	347457	0	180256009	4107731	
60632	5245	4107731	1990-03-04	1990-03-04 00:00:00	38000275	0	\N	\N	348968	0	180256009	4107731	
60856	5267	4107731	1996-02-24	1996-02-24 00:00:00	38000275	0	\N	\N	350364	0	180256009	4107731	
61012	5284	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	351493	0	180256009	4107731	
49295	4329	4295880	1995-03-19	1995-03-19 00:00:00	38000275	0	\N	\N	287128	0	76601001	4295880	
61728	5337	4107731	1991-03-17	1991-03-17 00:00:00	38000275	0	\N	\N	355471	0	180256009	4107731	
50226	4374	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	290460	0	180256009	4107731	
51442	4454	4058899	1955-12-16	1955-12-16 00:00:00	38000275	0	\N	\N	296499	0	168594001	4058899	
51941	4504	4170947	1978-01-20	1978-01-20 00:00:00	38000275	0	\N	\N	299900	0	274474001	4170947	
52420	4548	4107731	1998-01-06	1998-01-06 00:00:00	38000275	0	\N	\N	303000	0	180256009	4107731	
41068	3603	4107731	1990-08-05	1990-08-05 00:00:00	38000275	0	\N	\N	239444	0	180256009	4107731	
53256	4625	4163872	1975-03-29	1975-03-29 00:00:00	38000275	0	\N	\N	308129	0	399208008	4163872	
54027	4694	4107731	1997-12-14	1997-12-14 00:00:00	38000275	0	\N	\N	312696	0	180256009	4107731	
54436	4724	4170947	2011-03-06	2011-03-06 00:00:00	38000275	0	\N	\N	314862	0	274474001	4170947	
54746	4750	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	316294	0	180256009	4107731	
55205	4812	4238715	1982-01-13	1982-01-13 00:00:00	38000275	0	\N	\N	320094	0	68254000	4238715	
55398	4827	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	321164	0	180256009	4107731	
44203	3885	4125906	1963-11-11	1963-11-11 00:00:00	38000275	0	\N	\N	258294	0	288086009	4125906	
57194	4963	4043071	1988-10-10	1988-10-10 00:00:00	38000275	0	\N	\N	329933	0	228557008	4043071	
57371	4971	4043071	1949-05-01	1949-05-01 00:00:00	38000275	0	\N	\N	330638	0	228557008	4043071	
57721	5004	4107731	1992-09-22	1992-09-22 00:00:00	38000275	0	\N	\N	332797	0	180256009	4107731	
58283	5049	4043071	1971-04-30	1971-04-30 00:00:00	38000275	0	\N	\N	335558	0	228557008	4043071	
58497	5056	4047491	2005-10-12	2005-10-12 00:00:00	38000275	0	\N	\N	336181	0	1225002	4047491	
47927	4205	4107731	1993-04-17	1993-04-17 00:00:00	38000275	0	\N	\N	279174	0	180256009	4107731	
48226	4226	4107731	1990-11-18	1990-11-18 00:00:00	38000275	0	\N	\N	280674	0	180256009	4107731	
48381	4247	4043071	1996-04-11	1996-04-11 00:00:00	38000275	0	\N	\N	282110	0	228557008	4043071	
60512	5222	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	347434	0	180256009	4107731	
60633	5245	4107731	1991-10-13	1991-10-13 00:00:00	38000275	0	\N	\N	349026	0	180256009	4107731	
60857	5267	4107731	1997-03-08	1997-03-08 00:00:00	38000275	0	\N	\N	350468	0	180256009	4107731	
61013	5284	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	351607	0	180256009	4107731	
49296	4329	4295880	2000-12-10	2000-12-10 00:00:00	38000275	0	\N	\N	287166	0	76601001	4295880	
61729	5337	4107731	1991-12-15	1991-12-15 00:00:00	38000275	0	\N	\N	355474	0	180256009	4107731	
50227	4374	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	290504	0	180256009	4107731	
51443	4454	4057420	2015-12-26	2015-12-26 00:00:00	38000275	0	\N	\N	296469	0	18286008	4057420	
51942	4504	4163872	1983-11-11	1983-11-11 00:00:00	38000275	0	\N	\N	299946	0	399208008	4163872	
52421	4548	4107731	1997-06-10	1997-06-10 00:00:00	38000275	0	\N	\N	303019	0	180256009	4107731	
41069	3603	4107731	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	239344	0	180256009	4107731	
53257	4625	4170947	1975-03-29	1975-03-29 00:00:00	38000275	0	\N	\N	308129	0	274474001	4170947	
54028	4694	4107731	1995-04-02	1995-04-02 00:00:00	38000275	0	\N	\N	312753	0	180256009	4107731	
54437	4724	4195803	2011-03-06	2011-03-06 00:00:00	38000275	0	\N	\N	314862	0	312681000	4195803	
54747	4750	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	316384	0	180256009	4107731	
55206	4812	4275113	1970-10-01	1970-10-01 00:00:00	38000275	0	\N	\N	320130	0	65200003	4275113	
55399	4827	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	321125	0	180256009	4107731	
44204	3885	4125906	1995-02-11	1995-02-11 00:00:00	38000275	0	\N	\N	258218	0	288086009	4125906	
57195	4963	4043071	1989-03-13	1989-03-13 00:00:00	38000275	0	\N	\N	329935	0	228557008	4043071	
57372	4971	4043071	1949-10-30	1949-10-30 00:00:00	38000275	0	\N	\N	330525	0	228557008	4043071	
57722	5004	4107731	1992-02-04	1992-02-04 00:00:00	38000275	0	\N	\N	332795	0	180256009	4107731	
58284	5049	4043071	1971-08-06	1971-08-06 00:00:00	38000275	0	\N	\N	335622	0	228557008	4043071	
58498	5056	4010253	1985-05-30	1985-05-30 00:00:00	38000275	0	\N	\N	336141	0	112790001	4010253	
47928	4205	4107731	1990-03-31	1990-03-31 00:00:00	38000275	0	\N	\N	279167	0	180256009	4107731	
48227	4226	4107731	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	280728	0	180256009	4107731	
48382	4247	4043071	1997-05-15	1997-05-15 00:00:00	38000275	0	\N	\N	282113	0	228557008	4043071	
60513	5222	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	347492	0	180256009	4107731	
60634	5245	4107731	1992-03-08	1992-03-08 00:00:00	38000275	0	\N	\N	349023	0	180256009	4107731	
60858	5267	4107731	1996-10-12	1996-10-12 00:00:00	38000275	0	\N	\N	350366	0	180256009	4107731	
61014	5284	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	351536	0	180256009	4107731	
49297	4329	4295880	1999-09-13	1999-09-13 00:00:00	38000275	0	\N	\N	287112	0	76601001	4295880	
61730	5337	4107731	1992-10-04	1992-10-04 00:00:00	38000275	0	\N	\N	355415	0	180256009	4107731	
50228	4374	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	290502	0	180256009	4107731	
51444	4454	4078793	2014-11-22	2014-11-22 00:00:00	38000275	0	\N	\N	296489	0	180325003	4078793	
51943	4504	4057420	2019-06-22	2019-06-22 00:00:00	38000275	0	\N	\N	299921	0	18286008	4057420	
52422	4548	4107731	1998-04-21	1998-04-21 00:00:00	38000275	0	\N	\N	303023	0	180256009	4107731	
41070	3603	4107731	1992-02-23	1992-02-23 00:00:00	38000275	0	\N	\N	239412	0	180256009	4107731	
53258	4625	4125906	1964-01-28	1964-01-28 00:00:00	38000275	0	\N	\N	308126	0	288086009	4125906	
54029	4694	4107731	1997-09-21	1997-09-21 00:00:00	38000275	0	\N	\N	312694	0	180256009	4107731	
54438	4724	4047491	2011-03-06	2011-03-06 00:00:00	38000275	0	\N	\N	314862	0	1225002	4047491	
54748	4750	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	316369	0	180256009	4107731	
55207	4812	4170947	1972-03-08	1972-03-08 00:00:00	38000275	0	\N	\N	320162	0	274474001	4170947	
55400	4827	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	321218	0	180256009	4107731	
44205	3885	4163872	1978-07-27	1978-07-27 00:00:00	38000275	0	\N	\N	258222	0	399208008	4163872	
57196	4963	4043071	1988-01-25	1988-01-25 00:00:00	38000275	0	\N	\N	329870	0	228557008	4043071	
57373	4971	4043071	1950-10-01	1950-10-01 00:00:00	38000275	0	\N	\N	330618	0	228557008	4043071	
57723	5004	4107731	1992-03-17	1992-03-17 00:00:00	38000275	0	\N	\N	332899	0	180256009	4107731	
58285	5049	4043071	1972-02-18	1972-02-18 00:00:00	38000275	0	\N	\N	335624	0	228557008	4043071	
58499	5056	4058899	1982-04-16	1982-04-16 00:00:00	38000275	0	\N	\N	336165	0	168594001	4058899	
47929	4205	4107731	1990-12-29	1990-12-29 00:00:00	38000275	0	\N	\N	279170	0	180256009	4107731	
48228	4226	4107731	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	280735	0	180256009	4107731	
48383	4247	4043071	1995-05-25	1995-05-25 00:00:00	38000275	0	\N	\N	282105	0	228557008	4043071	
60514	5222	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	347381	0	180256009	4107731	
60635	5245	4107731	1991-11-03	1991-11-03 00:00:00	38000275	0	\N	\N	349020	0	180256009	4107731	
60859	5267	4107731	1996-07-20	1996-07-20 00:00:00	38000275	0	\N	\N	350466	0	180256009	4107731	
61015	5284	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	351593	0	180256009	4107731	
49298	4329	4295880	1998-12-13	1998-12-13 00:00:00	38000275	0	\N	\N	287111	0	76601001	4295880	
61731	5337	4107731	1991-04-28	1991-04-28 00:00:00	38000275	0	\N	\N	355454	0	180256009	4107731	
50229	4374	4295880	1992-11-05	1992-11-05 00:00:00	38000275	0	\N	\N	290570	0	76601001	4295880	
51445	4454	4195803	2007-03-23	2007-03-23 00:00:00	38000275	0	\N	\N	296504	0	312681000	4195803	
51944	4505	4107731	1992-10-27	1992-10-27 00:00:00	38000275	0	\N	\N	300061	0	180256009	4107731	
52423	4548	4107731	1999-11-30	1999-11-30 00:00:00	38000275	0	\N	\N	303010	0	180256009	4107731	
41071	3603	4107731	1992-08-30	1992-08-30 00:00:00	38000275	0	\N	\N	239330	0	180256009	4107731	
53259	4625	4125906	1974-05-19	1974-05-19 00:00:00	38000275	0	\N	\N	308128	0	288086009	4125906	
54030	4694	4107731	1995-10-29	1995-10-29 00:00:00	38000275	0	\N	\N	312658	0	180256009	4107731	
54439	4724	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	314700	0	180256009	4107731	
54749	4750	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	316352	0	395142003	4191853	
55208	4812	4243062	1972-03-08	1972-03-08 00:00:00	38000275	0	\N	\N	320162	0	60027007	4243062	
55401	4827	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	321216	0	180256009	4107731	
44207	3887	4151422	1975-06-22	1975-06-22 00:00:00	38000275	0	\N	\N	258340	0	269911007	4151422	
57197	4963	4043071	1987-08-03	1987-08-03 00:00:00	38000275	0	\N	\N	329930	0	228557008	4043071	
57374	4971	4043071	1949-11-27	1949-11-27 00:00:00	38000275	0	\N	\N	330544	0	228557008	4043071	
57724	5004	4107731	1990-06-26	1990-06-26 00:00:00	38000275	0	\N	\N	332826	0	180256009	4107731	
58286	5049	4151422	1996-04-28	1996-04-28 00:00:00	38000275	0	\N	\N	335578	0	269911007	4151422	
58500	5058	4252419	2014-07-17	2014-07-17 00:00:00	38000275	0	\N	\N	336348	0	74016001	4252419	
47930	4205	4107731	1990-03-10	1990-03-10 00:00:00	38000275	0	\N	\N	279254	0	180256009	4107731	
48229	4226	4107731	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	280757	0	180256009	4107731	
48384	4247	4043071	1999-02-11	1999-02-11 00:00:00	38000275	0	\N	\N	281991	0	228557008	4043071	
60515	5222	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	347341	0	180256009	4107731	
60636	5245	4107731	1992-03-29	1992-03-29 00:00:00	38000275	0	\N	\N	348948	0	180256009	4107731	
60860	5267	4107731	1998-11-28	1998-11-28 00:00:00	38000275	0	\N	\N	350456	0	180256009	4107731	
61016	5284	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	351611	0	180256009	4107731	
49299	4329	4275113	1996-03-11	1996-03-11 00:00:00	38000275	0	\N	\N	287154	0	65200003	4275113	
61732	5337	4107731	1990-09-09	1990-09-09 00:00:00	38000275	0	\N	\N	355452	0	180256009	4107731	
50230	4374	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	290522	0	180256009	4107731	
51446	4454	4047491	2007-03-23	2007-03-23 00:00:00	38000275	0	\N	\N	296504	0	1225002	4047491	
51945	4505	4107731	1992-12-08	1992-12-08 00:00:00	38000275	0	\N	\N	300062	0	180256009	4107731	
52424	4548	4107731	1997-09-02	1997-09-02 00:00:00	38000275	0	\N	\N	303087	0	180256009	4107731	
41072	3603	4107731	1991-09-08	1991-09-08 00:00:00	38000275	0	\N	\N	239380	0	180256009	4107731	
53260	4626	4107731	2000-12-08	2000-12-08 00:00:00	38000275	0	\N	\N	308250	0	180256009	4107731	
54031	4694	4107731	1996-10-20	1996-10-20 00:00:00	38000275	0	\N	\N	312768	0	180256009	4107731	
54440	4724	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	314724	0	395142003	4191853	
54750	4750	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	316411	0	180256009	4107731	
55209	4812	4125906	1981-12-16	1981-12-16 00:00:00	38000275	0	\N	\N	320163	0	288086009	4125906	
55402	4827	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	321212	0	180256009	4107731	
44208	3887	4163872	1982-11-28	1982-11-28 00:00:00	38000275	0	\N	\N	258403	0	399208008	4163872	
57198	4963	4043071	1987-11-02	1987-11-02 00:00:00	38000275	0	\N	\N	329899	0	228557008	4043071	
57375	4971	4043071	1946-12-08	1946-12-08 00:00:00	38000275	0	\N	\N	330516	0	228557008	4043071	
57725	5004	4191853	1993-09-14	1993-09-14 00:00:00	38000275	0	\N	\N	332834	0	395142003	4191853	
58287	5049	4043071	1971-07-02	1971-07-02 00:00:00	38000275	0	\N	\N	335628	0	228557008	4043071	
58501	5058	4195803	2011-10-31	2011-10-31 00:00:00	38000275	0	\N	\N	336347	0	312681000	4195803	
47931	4205	4107731	1991-06-15	1991-06-15 00:00:00	38000275	0	\N	\N	279186	0	180256009	4107731	
48230	4226	4107731	1992-02-23	1992-02-23 00:00:00	38000275	0	\N	\N	280739	0	180256009	4107731	
48385	4247	4043071	1998-11-19	1998-11-19 00:00:00	38000275	0	\N	\N	281990	0	228557008	4043071	
60516	5222	4035793	2018-08-23	2018-08-23 00:00:00	38000275	0	\N	\N	347345	0	15081005	4035793	
60637	5245	4107731	1990-09-09	1990-09-09 00:00:00	38000275	0	\N	\N	348969	0	180256009	4107731	
60861	5267	4107731	1999-06-05	1999-06-05 00:00:00	38000275	0	\N	\N	350377	0	180256009	4107731	
61017	5284	4043071	1980-10-15	1980-10-15 00:00:00	38000275	0	\N	\N	351520	0	228557008	4043071	
49300	4329	4295880	2001-03-11	2001-03-11 00:00:00	38000275	0	\N	\N	287114	0	76601001	4295880	
61733	5337	4107731	1991-04-07	1991-04-07 00:00:00	38000275	0	\N	\N	355409	0	180256009	4107731	
50231	4374	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	290478	0	180256009	4107731	
51447	4454	4170947	2007-03-23	2007-03-23 00:00:00	38000275	0	\N	\N	296504	0	274474001	4170947	
51946	4505	4107731	1993-01-19	1993-01-19 00:00:00	38000275	0	\N	\N	300117	0	180256009	4107731	
52425	4548	4107731	1999-10-19	1999-10-19 00:00:00	38000275	0	\N	\N	303009	0	180256009	4107731	
41073	3603	4107731	1991-09-29	1991-09-29 00:00:00	38000275	0	\N	\N	239345	0	180256009	4107731	
53261	4626	4107731	1998-12-25	1998-12-25 00:00:00	38000275	0	\N	\N	308219	0	180256009	4107731	
54032	4694	4107731	1994-09-25	1994-09-25 00:00:00	38000275	0	\N	\N	312752	0	180256009	4107731	
54441	4724	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	314714	0	180256009	4107731	
54751	4750	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	316415	0	180256009	4107731	
55210	4812	4186930	1975-10-01	1975-10-01 00:00:00	38000275	0	\N	\N	320141	0	46706006	4186930	
55403	4827	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	321168	0	180256009	4107731	
44209	3887	4170947	1968-12-08	1968-12-08 00:00:00	38000275	0	\N	\N	258364	0	274474001	4170947	
57199	4963	4043071	1988-04-25	1988-04-25 00:00:00	38000275	0	\N	\N	329946	0	228557008	4043071	
57376	4971	4043071	1950-09-03	1950-09-03 00:00:00	38000275	0	\N	\N	330546	0	228557008	4043071	
57726	5004	4107731	1993-05-11	1993-05-11 00:00:00	38000275	0	\N	\N	332862	0	180256009	4107731	
58288	5049	4043071	1972-10-20	1972-10-20 00:00:00	38000275	0	\N	\N	335563	0	228557008	4043071	
58502	5058	4170947	2011-10-31	2011-10-31 00:00:00	38000275	0	\N	\N	336347	0	274474001	4170947	
47932	4205	4107731	1991-12-21	1991-12-21 00:00:00	38000275	0	\N	\N	279216	0	180256009	4107731	
48231	4226	4107731	1993-01-24	1993-01-24 00:00:00	38000275	0	\N	\N	280772	0	180256009	4107731	
48386	4247	4043071	1999-06-24	1999-06-24 00:00:00	38000275	0	\N	\N	282052	0	228557008	4043071	
60517	5222	4078793	2018-08-23	2018-08-23 00:00:00	38000275	0	\N	\N	347345	0	180325003	4078793	
60638	5245	4107731	1990-04-15	1990-04-15 00:00:00	38000275	0	\N	\N	348988	0	180256009	4107731	
60862	5268	4275113	1980-06-21	1980-06-21 00:00:00	38000275	0	\N	\N	350504	0	65200003	4275113	
61018	5284	4058899	1997-04-13	1997-04-13 00:00:00	38000275	0	\N	\N	351517	0	168594001	4058899	
49301	4329	4295880	1994-12-18	1994-12-18 00:00:00	38000275	0	\N	\N	287108	0	76601001	4295880	
61734	5337	4243062	1973-10-04	1973-10-04 00:00:00	38000275	0	\N	\N	355386	0	60027007	4243062	
50232	4374	4295880	1995-02-02	1995-02-02 00:00:00	38000275	0	\N	\N	290512	0	76601001	4295880	
51448	4454	4151422	2005-09-20	2005-09-20 00:00:00	38000275	0	\N	\N	296418	0	269911007	4151422	
51947	4505	4107731	1992-03-10	1992-03-10 00:00:00	38000275	0	\N	\N	300033	0	180256009	4107731	
52426	4548	4107731	1997-11-04	1997-11-04 00:00:00	38000275	0	\N	\N	303103	0	180256009	4107731	
41074	3603	4151422	1974-06-14	1974-06-14 00:00:00	38000275	0	\N	\N	239361	0	269911007	4151422	
53262	4626	4151422	2007-01-05	2007-01-05 00:00:00	38000275	0	\N	\N	308188	0	269911007	4151422	
54033	4694	4107731	1994-11-27	1994-11-27 00:00:00	38000275	0	\N	\N	312705	0	180256009	4107731	
54442	4724	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	314752	0	180256009	4107731	
54752	4750	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	316386	0	180256009	4107731	
55211	4812	4186930	1980-10-01	1980-10-01 00:00:00	38000275	0	\N	\N	320133	0	46706006	4186930	
55404	4827	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	321211	0	180256009	4107731	
44210	3887	4047491	1968-12-08	1968-12-08 00:00:00	38000275	0	\N	\N	258364	0	1225002	4047491	
57200	4963	4125906	2006-02-25	2006-02-25 00:00:00	38000275	0	\N	\N	329967	0	288086009	4125906	
57377	4971	4043071	1947-05-25	1947-05-25 00:00:00	38000275	0	\N	\N	330529	0	228557008	4043071	
57727	5004	4107731	1993-03-09	1993-03-09 00:00:00	38000275	0	\N	\N	332904	0	180256009	4107731	
58289	5049	4043071	1971-04-02	1971-04-02 00:00:00	38000275	0	\N	\N	335621	0	228557008	4043071	
58503	5058	4024289	2011-10-31	2011-10-31 00:00:00	38000275	0	\N	\N	336347	0	19490002	4024289	
47933	4205	4107731	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	279219	0	180256009	4107731	
48232	4226	4191853	1990-01-07	1990-01-07 00:00:00	38000275	0	\N	\N	280670	0	395142003	4191853	
48387	4247	4043071	2000-11-09	2000-11-09 00:00:00	38000275	0	\N	\N	282020	0	228557008	4043071	
60518	5222	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	347496	0	180256009	4107731	
60639	5245	4107731	1991-04-28	1991-04-28 00:00:00	38000275	0	\N	\N	349019	0	180256009	4107731	
60863	5268	4058899	2008-08-24	2008-08-24 00:00:00	38000275	0	\N	\N	350491	0	168594001	4058899	
61019	5284	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	351575	0	180256009	4107731	
49302	4330	4170947	1968-09-04	1968-09-04 00:00:00	38000275	0	\N	\N	287260	0	274474001	4170947	
61735	5337	4170947	1973-10-04	1973-10-04 00:00:00	38000275	0	\N	\N	355386	0	274474001	4170947	
50233	4374	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	290563	0	180256009	4107731	
51449	4454	4078793	2010-10-30	2010-10-30 00:00:00	38000275	0	\N	\N	296487	0	180325003	4078793	
51948	4505	4107731	1993-03-02	1993-03-02 00:00:00	38000275	0	\N	\N	300118	0	180256009	4107731	
52427	4548	4191853	1986-11-17	1986-11-17 00:00:00	38000275	0	\N	\N	303082	0	395142003	4191853	
41075	3603	4107731	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	239413	0	180256009	4107731	
53263	4626	4107731	2001-03-02	2001-03-02 00:00:00	38000275	0	\N	\N	308252	0	180256009	4107731	
54034	4694	4107731	1995-04-23	1995-04-23 00:00:00	38000275	0	\N	\N	312739	0	180256009	4107731	
54443	4724	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	314755	0	180256009	4107731	
54753	4750	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	316399	0	180256009	4107731	
55215	4814	4125906	1946-01-03	1946-01-03 00:00:00	38000275	0	\N	\N	320244	0	288086009	4125906	
55405	4827	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	321220	0	180256009	4107731	
44211	3887	4125906	1984-11-14	1984-11-14 00:00:00	38000275	0	\N	\N	258404	0	288086009	4125906	
57201	4963	4043071	1987-07-06	1987-07-06 00:00:00	38000275	0	\N	\N	329898	0	228557008	4043071	
57378	4971	4043071	1950-06-25	1950-06-25 00:00:00	38000275	0	\N	\N	330585	0	228557008	4043071	
57728	5004	4107731	1991-09-10	1991-09-10 00:00:00	38000275	0	\N	\N	332898	0	180256009	4107731	
58290	5049	4043071	1972-06-16	1972-06-16 00:00:00	38000275	0	\N	\N	335631	0	228557008	4043071	
58504	5058	4195803	2017-03-05	2017-03-05 00:00:00	38000275	0	\N	\N	336327	0	312681000	4195803	
47934	4205	4107731	1990-06-23	1990-06-23 00:00:00	38000275	0	\N	\N	279169	0	180256009	4107731	
48233	4226	4107731	1992-08-30	1992-08-30 00:00:00	38000275	0	\N	\N	280740	0	180256009	4107731	
48388	4247	4043071	2000-03-16	2000-03-16 00:00:00	38000275	0	\N	\N	282018	0	228557008	4043071	
60519	5222	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	347448	0	180256009	4107731	
60640	5245	4107731	1992-08-23	1992-08-23 00:00:00	38000275	0	\N	\N	349041	0	180256009	4107731	
60864	5268	4163872	1972-03-24	1972-03-24 00:00:00	38000275	0	\N	\N	350478	0	399208008	4163872	
61020	5284	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	351609	0	180256009	4107731	
49303	4330	4047491	1968-09-04	1968-09-04 00:00:00	38000275	0	\N	\N	287260	0	1225002	4047491	
61736	5337	4107731	1993-05-23	1993-05-23 00:00:00	38000275	0	\N	\N	355417	0	180256009	4107731	
50234	4374	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	290578	0	180256009	4107731	
51450	4454	4151422	1931-12-30	1931-12-30 00:00:00	38000275	0	\N	\N	296464	0	269911007	4151422	
51949	4505	4107731	1991-01-15	1991-01-15 00:00:00	38000275	0	\N	\N	299968	0	180256009	4107731	
52428	4548	4191853	2000-04-25	2000-04-25 00:00:00	38000275	0	\N	\N	303041	0	395142003	4191853	
41076	3603	4107731	1993-03-28	1993-03-28 00:00:00	38000275	0	\N	\N	239320	0	180256009	4107731	
53264	4626	4107731	2000-07-14	2000-07-14 00:00:00	38000275	0	\N	\N	308161	0	180256009	4107731	
54035	4694	4107731	1995-08-06	1995-08-06 00:00:00	38000275	0	\N	\N	312756	0	180256009	4107731	
54444	4724	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	314695	0	180256009	4107731	
54754	4750	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	316381	0	180256009	4107731	
55216	4814	4058899	1939-04-26	1939-04-26 00:00:00	38000275	0	\N	\N	320292	0	168594001	4058899	
55406	4827	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	321213	0	180256009	4107731	
44212	3887	4151422	1963-09-19	1963-09-19 00:00:00	38000275	0	\N	\N	258387	0	269911007	4151422	
57202	4963	4043071	1990-08-06	1990-08-06 00:00:00	38000275	0	\N	\N	329876	0	228557008	4043071	
57379	4971	4043071	1947-11-23	1947-11-23 00:00:00	38000275	0	\N	\N	330519	0	228557008	4043071	
57729	5004	4107731	1991-04-16	1991-04-16 00:00:00	38000275	0	\N	\N	332845	0	180256009	4107731	
58291	5049	4043071	1971-09-10	1971-09-10 00:00:00	38000275	0	\N	\N	335623	0	228557008	4043071	
58505	5058	4151422	1980-11-19	1980-11-19 00:00:00	38000275	0	\N	\N	336329	0	269911007	4151422	
47935	4205	4107731	1993-01-02	1993-01-02 00:00:00	38000275	0	\N	\N	279234	0	180256009	4107731	
48234	4226	4107731	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	280724	0	180256009	4107731	
48389	4247	4043071	1998-09-17	1998-09-17 00:00:00	38000275	0	\N	\N	282075	0	228557008	4043071	
60520	5222	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	347375	0	180256009	4107731	
60641	5245	4107731	1992-05-31	1992-05-31 00:00:00	38000275	0	\N	\N	349028	0	180256009	4107731	
60865	5268	4125906	2004-08-31	2004-08-31 00:00:00	38000275	0	\N	\N	350534	0	288086009	4125906	
61021	5284	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	351554	0	180256009	4107731	
49304	4330	4243062	1963-09-01	1963-09-01 00:00:00	38000275	0	\N	\N	287259	0	60027007	4243062	
61737	5337	4191853	1993-07-04	1993-07-04 00:00:00	38000275	0	\N	\N	355418	0	395142003	4191853	
50235	4374	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	290558	0	180256009	4107731	
51451	4454	4078793	2018-01-06	2018-01-06 00:00:00	38000275	0	\N	\N	296470	0	180325003	4078793	
51950	4505	4107731	1990-12-04	1990-12-04 00:00:00	38000275	0	\N	\N	300088	0	180256009	4107731	
52429	4548	4107731	1998-05-12	1998-05-12 00:00:00	38000275	0	\N	\N	303003	0	180256009	4107731	
41077	3603	4107731	1990-06-24	1990-06-24 00:00:00	38000275	0	\N	\N	239402	0	180256009	4107731	
53265	4626	4107731	2000-10-27	2000-10-27 00:00:00	38000275	0	\N	\N	308249	0	180256009	4107731	
54036	4694	4047491	2001-02-25	2001-02-25 00:00:00	38000275	0	\N	\N	312720	0	1225002	4047491	
54445	4724	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	314664	0	180256009	4107731	
54755	4750	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	316416	0	180256009	4107731	
55217	4814	4195803	2016-08-15	2016-08-15 00:00:00	38000275	0	\N	\N	320266	0	312681000	4195803	
55407	4827	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	321219	0	180256009	4107731	
44215	3889	4078793	2013-03-03	2013-03-03 00:00:00	38000275	0	\N	\N	258534	0	180325003	4078793	
57203	4963	4043071	1989-10-09	1989-10-09 00:00:00	38000275	0	\N	\N	329914	0	228557008	4043071	
57380	4971	4043071	1950-04-23	1950-04-23 00:00:00	38000275	0	\N	\N	330617	0	228557008	4043071	
57730	5004	4107731	1991-02-12	1991-02-12 00:00:00	38000275	0	\N	\N	332828	0	180256009	4107731	
58292	5049	4043071	1971-11-05	1971-11-05 00:00:00	38000275	0	\N	\N	335560	0	228557008	4043071	
58506	5058	44783196	2014-07-24	2014-07-24 00:00:00	38000275	0	\N	\N	336277	0	699253003	44783196	
47936	4205	4107731	1992-08-29	1992-08-29 00:00:00	38000275	0	\N	\N	279245	0	180256009	4107731	
48235	4226	4010253	1977-01-14	1977-01-14 00:00:00	38000275	0	\N	\N	280691	0	112790001	4010253	
48390	4247	4043071	1998-07-23	1998-07-23 00:00:00	38000275	0	\N	\N	281989	0	228557008	4043071	
60521	5222	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	347340	0	180256009	4107731	
60642	5245	4107731	1993-06-13	1993-06-13 00:00:00	38000275	0	\N	\N	348976	0	180256009	4107731	
60866	5268	4293740	2004-08-31	2004-08-31 00:00:00	38000275	0	\N	\N	350534	0	384700001	4293740	
61022	5284	4043071	1981-02-25	1981-02-25 00:00:00	38000275	0	\N	\N	351492	0	228557008	4043071	
49305	4330	4170947	1963-09-01	1963-09-01 00:00:00	38000275	0	\N	\N	287259	0	274474001	4170947	
61738	5337	4107731	1991-06-09	1991-06-09 00:00:00	38000275	0	\N	\N	355455	0	180256009	4107731	
50236	4374	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	290524	0	180256009	4107731	
51452	4454	4078793	2015-11-28	2015-11-28 00:00:00	38000275	0	\N	\N	296490	0	180325003	4078793	
51951	4505	4107731	1993-03-23	1993-03-23 00:00:00	38000275	0	\N	\N	299996	0	180256009	4107731	
52430	4548	4107731	1998-06-02	1998-06-02 00:00:00	38000275	0	\N	\N	303090	0	180256009	4107731	
41078	3603	4107731	1991-08-18	1991-08-18 00:00:00	38000275	0	\N	\N	239411	0	180256009	4107731	
53266	4626	4107731	1998-05-08	1998-05-08 00:00:00	38000275	0	\N	\N	308235	0	180256009	4107731	
54037	4694	4170947	2001-02-25	2001-02-25 00:00:00	38000275	0	\N	\N	312720	0	274474001	4170947	
54446	4724	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	314773	0	180256009	4107731	
54756	4750	4202451	2019-02-13	2019-02-13 00:00:00	38000275	0	\N	\N	316380	0	433112001	4202451	
55218	4814	4125906	1970-07-29	1970-07-29 00:00:00	38000275	0	\N	\N	320247	0	288086009	4125906	
55408	4827	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	321085	0	180256009	4107731	
44216	3889	4057420	2004-03-21	2004-03-21 00:00:00	38000275	0	\N	\N	\N	0	18286008	4057420	
57204	4963	4043071	1988-03-28	1988-03-28 00:00:00	38000275	0	\N	\N	329932	0	228557008	4043071	
57381	4971	4043071	1948-01-25	1948-01-25 00:00:00	38000275	0	\N	\N	330610	0	228557008	4043071	
57731	5004	4107731	1992-11-03	1992-11-03 00:00:00	38000275	0	\N	\N	332798	0	180256009	4107731	
58293	5049	4202451	2002-07-31	2002-07-31 00:00:00	38000275	0	\N	\N	335546	0	433112001	4202451	
58507	5060	4170947	2012-10-23	2012-10-23 00:00:00	38000275	0	\N	\N	336407	0	274474001	4170947	
47937	4205	4107731	1990-05-12	1990-05-12 00:00:00	38000275	0	\N	\N	279168	0	180256009	4107731	
48236	4226	4107731	1992-06-28	1992-06-28 00:00:00	38000275	0	\N	\N	280656	0	180256009	4107731	
48391	4247	4043071	1996-06-13	1996-06-13 00:00:00	38000275	0	\N	\N	282069	0	228557008	4043071	
60522	5222	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	347387	0	180256009	4107731	
60643	5245	4107731	1990-07-08	1990-07-08 00:00:00	38000275	0	\N	\N	348990	0	180256009	4107731	
60867	5268	4238715	1983-06-19	1983-06-19 00:00:00	38000275	0	\N	\N	350514	0	68254000	4238715	
61023	5284	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	351537	0	180256009	4107731	
49306	4330	4125906	1953-07-13	1953-07-13 00:00:00	38000275	0	\N	\N	287257	0	288086009	4125906	
61739	5337	4191853	1989-12-31	1989-12-31 00:00:00	38000275	0	\N	\N	355395	0	395142003	4191853	
50237	4374	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	290464	0	180256009	4107731	
51453	4454	4024289	1927-01-23	1927-01-23 00:00:00	38000275	0	\N	\N	296491	0	19490002	4024289	
51952	4505	4107731	1991-07-02	1991-07-02 00:00:00	38000275	0	\N	\N	299983	0	180256009	4107731	
52431	4548	4107731	2000-02-01	2000-02-01 00:00:00	38000275	0	\N	\N	303039	0	180256009	4107731	
41079	3603	4107731	1991-06-16	1991-06-16 00:00:00	38000275	0	\N	\N	239448	0	180256009	4107731	
53267	4626	4107731	1999-11-26	1999-11-26 00:00:00	38000275	0	\N	\N	308159	0	180256009	4107731	
54038	4694	4107731	1996-09-29	1996-09-29 00:00:00	38000275	0	\N	\N	312669	0	180256009	4107731	
54447	4724	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	314697	0	180256009	4107731	
54757	4750	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	316293	0	180256009	4107731	
55219	4815	4125906	1985-09-26	1985-09-26 00:00:00	38000275	0	\N	\N	320356	0	288086009	4125906	
55409	4827	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	321138	0	180256009	4107731	
44217	3889	4151422	2004-03-09	2004-03-09 00:00:00	38000275	0	\N	\N	258456	0	269911007	4151422	
57205	4963	4043071	1987-12-28	1987-12-28 00:00:00	38000275	0	\N	\N	329945	0	228557008	4043071	
57382	4971	4043071	1948-07-25	1948-07-25 00:00:00	38000275	0	\N	\N	330607	0	228557008	4043071	
57732	5004	4107731	1991-06-18	1991-06-18 00:00:00	38000275	0	\N	\N	332896	0	180256009	4107731	
58294	5049	4043071	1971-02-26	1971-02-26 00:00:00	38000275	0	\N	\N	335620	0	228557008	4043071	
58508	5060	4243062	2012-10-23	2012-10-23 00:00:00	38000275	0	\N	\N	336407	0	60027007	4243062	
47938	4205	4107731	1991-05-25	1991-05-25 00:00:00	38000275	0	\N	\N	279227	0	180256009	4107731	
48237	4226	4107731	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	280694	0	180256009	4107731	
48392	4247	4043071	1996-03-07	1996-03-07 00:00:00	38000275	0	\N	\N	282103	0	228557008	4043071	
60523	5222	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	347489	0	180256009	4107731	
60644	5245	4191853	1993-07-04	1993-07-04 00:00:00	38000275	0	\N	\N	349045	0	395142003	4191853	
60869	5272	4195803	1977-02-09	1977-02-09 00:00:00	38000275	0	\N	\N	350685	0	312681000	4195803	
61024	5284	4043071	1980-11-19	1980-11-19 00:00:00	38000275	0	\N	\N	351582	0	228557008	4043071	
49307	4330	4243062	2012-03-20	2012-03-20 00:00:00	38000275	0	\N	\N	287221	0	60027007	4243062	
61740	5337	4107731	1992-01-05	1992-01-05 00:00:00	38000275	0	\N	\N	355412	0	180256009	4107731	
50238	4374	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	290465	0	180256009	4107731	
51454	4454	4170947	1927-01-23	1927-01-23 00:00:00	38000275	0	\N	\N	296491	0	274474001	4170947	
51953	4505	4107731	1990-10-23	1990-10-23 00:00:00	38000275	0	\N	\N	300087	0	180256009	4107731	
52432	4548	4107731	1998-01-27	1998-01-27 00:00:00	38000275	0	\N	\N	303021	0	180256009	4107731	
41080	3603	4107731	1992-06-28	1992-06-28 00:00:00	38000275	0	\N	\N	239415	0	180256009	4107731	
53268	4626	4107731	1998-12-04	1998-12-04 00:00:00	38000275	0	\N	\N	308154	0	180256009	4107731	
54039	4694	4107731	1996-12-01	1996-12-01 00:00:00	38000275	0	\N	\N	312746	0	180256009	4107731	
54448	4724	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	314794	0	180256009	4107731	
54758	4750	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	316340	0	180256009	4107731	
55220	4815	4058899	1988-08-25	1988-08-25 00:00:00	38000275	0	\N	\N	320334	0	168594001	4058899	
55410	4827	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	321121	0	180256009	4107731	
44218	3889	4078793	2015-03-15	2015-03-15 00:00:00	38000275	0	\N	\N	258535	0	180325003	4078793	
57206	4963	4043071	1989-12-18	1989-12-18 00:00:00	38000275	0	\N	\N	329916	0	228557008	4043071	
57383	4971	4125906	1936-06-25	1936-06-25 00:00:00	38000275	0	\N	\N	330543	0	288086009	4125906	
57733	5004	4107731	1990-04-24	1990-04-24 00:00:00	38000275	0	\N	\N	332872	0	180256009	4107731	
58295	5049	4043071	1971-12-10	1971-12-10 00:00:00	38000275	0	\N	\N	335629	0	228557008	4043071	
58509	5060	4170947	1988-06-01	1988-06-01 00:00:00	38000275	0	\N	\N	336406	0	274474001	4170947	
47939	4205	4107731	1990-10-06	1990-10-06 00:00:00	38000275	0	\N	\N	279225	0	180256009	4107731	
48238	4226	4107731	1991-05-26	1991-05-26 00:00:00	38000275	0	\N	\N	280736	0	180256009	4107731	
48393	4247	4043071	1996-10-17	1996-10-17 00:00:00	38000275	0	\N	\N	282108	0	228557008	4043071	
60524	5222	4078793	2013-04-04	2013-04-04 00:00:00	38000275	0	\N	\N	347344	0	180325003	4078793	
60645	5245	4107731	1992-07-12	1992-07-12 00:00:00	38000275	0	\N	\N	349029	0	180256009	4107731	
60870	5272	4151422	2016-11-13	2016-11-13 00:00:00	38000275	0	\N	\N	350622	0	269911007	4151422	
61025	5284	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	351559	0	180256009	4107731	
49308	4330	4170947	2012-03-20	2012-03-20 00:00:00	38000275	0	\N	\N	287221	0	274474001	4170947	
61741	5337	4107731	1991-11-24	1991-11-24 00:00:00	38000275	0	\N	\N	355411	0	180256009	4107731	
50239	4374	4295880	1994-08-04	1994-08-04 00:00:00	38000275	0	\N	\N	290544	0	76601001	4295880	
51455	4454	4170947	2018-02-23	2018-02-23 00:00:00	38000275	0	\N	\N	296460	0	274474001	4170947	
51954	4505	4107731	1992-11-17	1992-11-17 00:00:00	38000275	0	\N	\N	299987	0	180256009	4107731	
52433	4548	4107731	1999-01-19	1999-01-19 00:00:00	38000275	0	\N	\N	303006	0	180256009	4107731	
41081	3603	4107731	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	239329	0	180256009	4107731	
53269	4626	4191853	1997-11-21	1997-11-21 00:00:00	38000275	0	\N	\N	308259	0	395142003	4191853	
54040	4694	4191853	1998-02-15	1998-02-15 00:00:00	38000275	0	\N	\N	312735	0	395142003	4191853	
54449	4724	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	314750	0	180256009	4107731	
54759	4750	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	316383	0	180256009	4107731	
55221	4815	4125906	1982-10-28	1982-10-28 00:00:00	38000275	0	\N	\N	320355	0	288086009	4125906	
55411	4827	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	321126	0	180256009	4107731	
44219	3889	4078793	2009-02-08	2009-02-08 00:00:00	38000275	0	\N	\N	258545	0	180325003	4078793	
57207	4963	4043071	1988-08-08	1988-08-08 00:00:00	38000275	0	\N	\N	329872	0	228557008	4043071	
57384	4971	4043071	1949-09-25	1949-09-25 00:00:00	38000275	0	\N	\N	330524	0	228557008	4043071	
57734	5004	4107731	1992-02-25	1992-02-25 00:00:00	38000275	0	\N	\N	332849	0	180256009	4107731	
58296	5049	4043071	1972-09-22	1972-09-22 00:00:00	38000275	0	\N	\N	335592	0	228557008	4043071	
58510	5060	4047491	1988-06-01	1988-06-01 00:00:00	38000275	0	\N	\N	336406	0	1225002	4047491	
47940	4205	4107731	1991-05-04	1991-05-04 00:00:00	38000275	0	\N	\N	279185	0	180256009	4107731	
48239	4226	4107731	1992-11-22	1992-11-22 00:00:00	38000275	0	\N	\N	280639	0	180256009	4107731	
48394	4247	4043071	1997-01-16	1997-01-16 00:00:00	38000275	0	\N	\N	282112	0	228557008	4043071	
60525	5222	4035793	2013-04-04	2013-04-04 00:00:00	38000275	0	\N	\N	347344	0	15081005	4035793	
60646	5245	4107731	1991-03-17	1991-03-17 00:00:00	38000275	0	\N	\N	349018	0	180256009	4107731	
60871	5272	4163872	2009-01-04	2009-01-04 00:00:00	38000275	0	\N	\N	350657	0	399208008	4163872	
61026	5284	4151422	1969-11-08	1969-11-08 00:00:00	38000275	0	\N	\N	351519	0	269911007	4151422	
49309	4330	4125906	1995-12-31	1995-12-31 00:00:00	38000275	0	\N	\N	287263	0	288086009	4125906	
61742	5337	4107731	1992-09-13	1992-09-13 00:00:00	38000275	0	\N	\N	355477	0	180256009	4107731	
50240	4374	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	290564	0	395142003	4191853	
51456	4454	4163872	2018-02-23	2018-02-23 00:00:00	38000275	0	\N	\N	296460	0	399208008	4163872	
51955	4505	4107731	1991-08-13	1991-08-13 00:00:00	38000275	0	\N	\N	299984	0	180256009	4107731	
52434	4548	4107731	1998-08-04	1998-08-04 00:00:00	38000275	0	\N	\N	303033	0	180256009	4107731	
41082	3603	4107731	1992-06-07	1992-06-07 00:00:00	38000275	0	\N	\N	239383	0	180256009	4107731	
53270	4626	4107731	1998-02-13	1998-02-13 00:00:00	38000275	0	\N	\N	308215	0	180256009	4107731	
54041	4694	4107731	1997-02-23	1997-02-23 00:00:00	38000275	0	\N	\N	312758	0	180256009	4107731	
54450	4724	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	314754	0	180256009	4107731	
54760	4750	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	316360	0	180256009	4107731	
55222	4816	4295880	1999-02-01	1999-02-01 00:00:00	38000275	0	\N	\N	320414	0	76601001	4295880	
55412	4827	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	321118	0	180256009	4107731	
44220	3889	4078793	2004-10-17	2004-10-17 00:00:00	38000275	0	\N	\N	258532	0	180325003	4078793	
57208	4963	4043071	1989-06-05	1989-06-05 00:00:00	38000275	0	\N	\N	329936	0	228557008	4043071	
57385	4971	4202451	2007-09-04	2007-09-04 00:00:00	38000275	0	\N	\N	330506	0	433112001	4202451	
57735	5004	4107731	1992-06-30	1992-06-30 00:00:00	38000275	0	\N	\N	332858	0	180256009	4107731	
58297	5049	4043071	1972-08-25	1972-08-25 00:00:00	38000275	0	\N	\N	335573	0	228557008	4043071	
58516	5063	4170947	2019-02-08	2019-02-08 00:00:00	38000275	0	\N	\N	336541	0	274474001	4170947	
47941	4205	4107731	1991-11-09	1991-11-09 00:00:00	38000275	0	\N	\N	279215	0	180256009	4107731	
48240	4226	4107731	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	280775	0	180256009	4107731	
48395	4247	4043071	1998-04-23	1998-04-23 00:00:00	38000275	0	\N	\N	282049	0	228557008	4043071	
60526	5223	4125906	2005-10-07	2005-10-07 00:00:00	38000275	0	\N	\N	347546	0	288086009	4125906	
60647	5245	4107731	1991-07-21	1991-07-21 00:00:00	38000275	0	\N	\N	348973	0	180256009	4107731	
60876	5274	4047491	2006-06-16	2006-06-16 00:00:00	38000275	0	\N	\N	350844	0	1225002	4047491	
61027	5284	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	351535	0	180256009	4107731	
49310	4330	4195803	2006-02-18	2006-02-18 00:00:00	38000275	0	\N	\N	287247	0	312681000	4195803	
61743	5337	4107731	1992-12-27	1992-12-27 00:00:00	38000275	0	\N	\N	355462	0	180256009	4107731	
50241	4374	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	290507	0	180256009	4107731	
51457	4454	4195803	2018-02-23	2018-02-23 00:00:00	38000275	0	\N	\N	296460	0	312681000	4195803	
51956	4505	4107731	1990-03-27	1990-03-27 00:00:00	38000275	0	\N	\N	300047	0	180256009	4107731	
52435	4548	4107731	1997-03-18	1997-03-18 00:00:00	38000275	0	\N	\N	303017	0	180256009	4107731	
41083	3603	4107731	1990-02-18	1990-02-18 00:00:00	38000275	0	\N	\N	239399	0	180256009	4107731	
53271	4626	4107731	1997-12-12	1997-12-12 00:00:00	38000275	0	\N	\N	308179	0	180256009	4107731	
54042	4694	4107731	1997-04-27	1997-04-27 00:00:00	38000275	0	\N	\N	312769	0	180256009	4107731	
54451	4724	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	314793	0	180256009	4107731	
54761	4750	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	316286	0	395142003	4191853	
55223	4816	4295880	1999-05-03	1999-05-03 00:00:00	38000275	0	\N	\N	320382	0	76601001	4295880	
55413	4827	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	321133	0	180256009	4107731	
44221	3889	4078793	2018-04-01	2018-04-01 00:00:00	38000275	0	\N	\N	258546	0	180325003	4078793	
57209	4963	4043071	1990-02-19	1990-02-19 00:00:00	38000275	0	\N	\N	329905	0	228557008	4043071	
57386	4971	4043071	1949-08-28	1949-08-28 00:00:00	38000275	0	\N	\N	330639	0	228557008	4043071	
57736	5004	4107731	1991-12-03	1991-12-03 00:00:00	38000275	0	\N	\N	332847	0	180256009	4107731	
58298	5049	4043071	1972-05-19	1972-05-19 00:00:00	38000275	0	\N	\N	335561	0	228557008	4043071	
58517	5063	4195803	2019-02-08	2019-02-08 00:00:00	38000275	0	\N	\N	336541	0	312681000	4195803	
47942	4205	4107731	1993-05-29	1993-05-29 00:00:00	38000275	0	\N	\N	279248	0	180256009	4107731	
48241	4226	4107731	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	280756	0	180256009	4107731	
48396	4247	4043071	1998-10-22	1998-10-22 00:00:00	38000275	0	\N	\N	282014	0	228557008	4043071	
60527	5223	4151422	2010-10-17	2010-10-17 00:00:00	38000275	0	\N	\N	347531	0	269911007	4151422	
60648	5245	4107731	1992-10-04	1992-10-04 00:00:00	38000275	0	\N	\N	349042	0	180256009	4107731	
60877	5274	4195803	2006-06-16	2006-06-16 00:00:00	38000275	0	\N	\N	350844	0	312681000	4195803	
61028	5284	4275113	1980-08-22	1980-08-22 00:00:00	38000275	0	\N	\N	351618	0	65200003	4275113	
49311	4331	4125906	1989-10-27	1989-10-27 00:00:00	38000275	0	\N	\N	287326	0	288086009	4125906	
61744	5337	4170947	1981-07-24	1981-07-24 00:00:00	38000275	0	\N	\N	355387	0	274474001	4170947	
50242	4374	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	290449	0	180256009	4107731	
51458	4454	4058899	1950-02-15	1950-02-15 00:00:00	38000275	0	\N	\N	296498	0	168594001	4058899	
51957	4505	4107731	1992-12-29	1992-12-29 00:00:00	38000275	0	\N	\N	299988	0	180256009	4107731	
52436	4548	4107731	1999-05-25	1999-05-25 00:00:00	38000275	0	\N	\N	303070	0	180256009	4107731	
41084	3603	4107731	1990-07-15	1990-07-15 00:00:00	38000275	0	\N	\N	239366	0	180256009	4107731	
53272	4626	4107731	1998-06-19	1998-06-19 00:00:00	38000275	0	\N	\N	308236	0	180256009	4107731	
54043	4694	4107731	1995-01-08	1995-01-08 00:00:00	38000275	0	\N	\N	312706	0	180256009	4107731	
54452	4724	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	314774	0	180256009	4107731	
54762	4750	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	316385	0	180256009	4107731	
55224	4816	4295880	1998-05-04	1998-05-04 00:00:00	38000275	0	\N	\N	320413	0	76601001	4295880	
55414	4827	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	321182	0	180256009	4107731	
44222	3889	4078793	2005-01-16	2005-01-16 00:00:00	38000275	0	\N	\N	258543	0	180325003	4078793	
57210	4963	4043071	1989-07-31	1989-07-31 00:00:00	38000275	0	\N	\N	329873	0	228557008	4043071	
57387	4971	4043071	1947-06-22	1947-06-22 00:00:00	38000275	0	\N	\N	330517	0	228557008	4043071	
57737	5004	4107731	1992-09-01	1992-09-01 00:00:00	38000275	0	\N	\N	332850	0	180256009	4107731	
58299	5049	4043071	1972-12-22	1972-12-22 00:00:00	38000275	0	\N	\N	335574	0	228557008	4043071	
58518	5063	4243062	2019-02-08	2019-02-08 00:00:00	38000275	0	\N	\N	336541	0	60027007	4243062	
47943	4205	4107731	1992-01-11	1992-01-11 00:00:00	38000275	0	\N	\N	279263	0	180256009	4107731	
48242	4226	4107731	1990-09-16	1990-09-16 00:00:00	38000275	0	\N	\N	280696	0	180256009	4107731	
48397	4247	4043071	1997-09-18	1997-09-18 00:00:00	38000275	0	\N	\N	282040	0	228557008	4043071	
60528	5223	4151422	1970-10-20	1970-10-20 00:00:00	38000275	0	\N	\N	347548	0	269911007	4151422	
60649	5245	4107731	1993-04-11	1993-04-11 00:00:00	38000275	0	\N	\N	349032	0	180256009	4107731	
60878	5274	4170947	2006-06-16	2006-06-16 00:00:00	38000275	0	\N	\N	350844	0	274474001	4170947	
61029	5284	4043071	1981-01-21	1981-01-21 00:00:00	38000275	0	\N	\N	351481	0	228557008	4043071	
49312	4331	4293740	1989-10-27	1989-10-27 00:00:00	38000275	0	\N	\N	287326	0	384700001	4293740	
61745	5337	4047491	1981-07-24	1981-07-24 00:00:00	38000275	0	\N	\N	355387	0	1225002	4047491	
50243	4374	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	290482	0	180256009	4107731	
51459	4454	4078793	2007-10-13	2007-10-13 00:00:00	38000275	0	\N	\N	296434	0	180325003	4078793	
51958	4505	4107731	1990-09-11	1990-09-11 00:00:00	38000275	0	\N	\N	300086	0	180256009	4107731	
52437	4548	4107731	1997-12-16	1997-12-16 00:00:00	38000275	0	\N	\N	303104	0	180256009	4107731	
41085	3604	4107731	2000-05-05	2000-05-05 00:00:00	38000275	0	\N	\N	239537	0	180256009	4107731	
53273	4626	4107731	1999-07-23	1999-07-23 00:00:00	38000275	0	\N	\N	308242	0	180256009	4107731	
54453	4724	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	314795	0	180256009	4107731	
54763	4750	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	316342	0	180256009	4107731	
55225	4816	4295880	1997-02-03	1997-02-03 00:00:00	38000275	0	\N	\N	320439	0	76601001	4295880	
55415	4827	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	321116	0	180256009	4107731	
44223	3889	4078793	2019-04-07	2019-04-07 00:00:00	38000275	0	\N	\N	258527	0	180325003	4078793	
57211	4963	4043071	1989-05-08	1989-05-08 00:00:00	38000275	0	\N	\N	329913	0	228557008	4043071	
57388	4971	4043071	1950-03-26	1950-03-26 00:00:00	38000275	0	\N	\N	330545	0	228557008	4043071	
57738	5004	4107731	1990-08-28	1990-08-28 00:00:00	38000275	0	\N	\N	332878	0	180256009	4107731	
58300	5049	4043071	1972-01-14	1972-01-14 00:00:00	38000275	0	\N	\N	335630	0	228557008	4043071	
58519	5063	4024289	1957-10-07	1957-10-07 00:00:00	38000275	0	\N	\N	336598	0	19490002	4024289	
47944	4205	4107731	1990-02-17	1990-02-17 00:00:00	38000275	0	\N	\N	279166	0	180256009	4107731	
48243	4226	4107731	1992-02-02	1992-02-02 00:00:00	38000275	0	\N	\N	280752	0	180256009	4107731	
48398	4247	4043071	1995-08-24	1995-08-24 00:00:00	38000275	0	\N	\N	282101	0	228557008	4043071	
60534	5228	4125906	2007-11-16	2007-11-16 00:00:00	38000275	0	\N	\N	347862	0	288086009	4125906	
60650	5245	4107731	1991-02-03	1991-02-03 00:00:00	38000275	0	\N	\N	349017	0	180256009	4107731	
60879	5274	4151422	1998-03-16	1998-03-16 00:00:00	38000275	0	\N	\N	350836	0	269911007	4151422	
61030	5284	4043071	1980-09-17	1980-09-17 00:00:00	38000275	0	\N	\N	351491	0	228557008	4043071	
49313	4333	4125906	1980-05-03	1980-05-03 00:00:00	38000275	0	\N	\N	287411	0	288086009	4125906	
61746	5337	4107731	1993-03-21	1993-03-21 00:00:00	38000275	0	\N	\N	355464	0	180256009	4107731	
50244	4374	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	290451	0	180256009	4107731	
51460	4454	4057420	2013-11-16	2013-11-16 00:00:00	38000275	0	\N	\N	296380	0	18286008	4057420	
51959	4505	4107731	1991-03-19	1991-03-19 00:00:00	38000275	0	\N	\N	300028	0	180256009	4107731	
52438	4548	4107731	1998-09-15	1998-09-15 00:00:00	38000275	0	\N	\N	303034	0	180256009	4107731	
41086	3604	4107731	1998-02-27	1998-02-27 00:00:00	38000275	0	\N	\N	239542	0	180256009	4107731	
53274	4626	4107731	1998-01-23	1998-01-23 00:00:00	38000275	0	\N	\N	308180	0	180256009	4107731	
54454	4724	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	314790	0	180256009	4107731	
54764	4750	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	316362	0	180256009	4107731	
55226	4816	4295880	1998-08-03	1998-08-03 00:00:00	38000275	0	\N	\N	320402	0	76601001	4295880	
55416	4827	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	321222	0	180256009	4107731	
44224	3889	4078793	2012-02-26	2012-02-26 00:00:00	38000275	0	\N	\N	258493	0	180325003	4078793	
57212	4963	4043071	1989-04-10	1989-04-10 00:00:00	38000275	0	\N	\N	329903	0	228557008	4043071	
57389	4971	4043071	1949-07-24	1949-07-24 00:00:00	38000275	0	\N	\N	330615	0	228557008	4043071	
57739	5004	4107731	1993-04-20	1993-04-20 00:00:00	38000275	0	\N	\N	332824	0	180256009	4107731	
58301	5049	4043071	1972-11-24	1972-11-24 00:00:00	38000275	0	\N	\N	335564	0	228557008	4043071	
58520	5063	4170947	1957-10-07	1957-10-07 00:00:00	38000275	0	\N	\N	336598	0	274474001	4170947	
47945	4205	4107731	1990-08-04	1990-08-04 00:00:00	38000275	0	\N	\N	279182	0	180256009	4107731	
48244	4226	4107731	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	280654	0	180256009	4107731	
48399	4247	4043071	1997-04-17	1997-04-17 00:00:00	38000275	0	\N	\N	282039	0	228557008	4043071	
60535	5228	4151422	1971-03-04	1971-03-04 00:00:00	38000275	0	\N	\N	347853	0	269911007	4151422	
60651	5245	4107731	1992-01-05	1992-01-05 00:00:00	38000275	0	\N	\N	349039	0	180256009	4107731	
60880	5274	4170947	1956-12-11	1956-12-11 00:00:00	38000275	0	\N	\N	350838	0	274474001	4170947	
61031	5284	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	351595	0	180256009	4107731	
49314	4333	4293740	1980-05-03	1980-05-03 00:00:00	38000275	0	\N	\N	287411	0	384700001	4293740	
61747	5337	4107731	1991-01-13	1991-01-13 00:00:00	38000275	0	\N	\N	355407	0	180256009	4107731	
50245	4374	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	290525	0	180256009	4107731	
51461	4454	4195803	1998-02-17	1998-02-17 00:00:00	38000275	0	\N	\N	296502	0	312681000	4195803	
51960	4505	4107731	1991-07-23	1991-07-23 00:00:00	38000275	0	\N	\N	300110	0	180256009	4107731	
52439	4548	4107731	1997-08-12	1997-08-12 00:00:00	38000275	0	\N	\N	303101	0	180256009	4107731	
41087	3604	4107731	1999-12-10	1999-12-10 00:00:00	38000275	0	\N	\N	239456	0	180256009	4107731	
53275	4626	4107731	1999-11-05	1999-11-05 00:00:00	38000275	0	\N	\N	308163	0	180256009	4107731	
54455	4724	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	314797	0	395142003	4191853	
54765	4750	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	316371	0	180256009	4107731	
55227	4816	4295880	2000-07-31	2000-07-31 00:00:00	38000275	0	\N	\N	320390	0	76601001	4295880	
55417	4827	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	321176	0	180256009	4107731	
44225	3889	4078793	2007-01-28	2007-01-28 00:00:00	38000275	0	\N	\N	258544	0	180325003	4078793	
57213	4963	4043071	1988-05-30	1988-05-30 00:00:00	38000275	0	\N	\N	329947	0	228557008	4043071	
57390	4971	4043071	1948-09-19	1948-09-19 00:00:00	38000275	0	\N	\N	330611	0	228557008	4043071	
57740	5004	4107731	1992-04-28	1992-04-28 00:00:00	38000275	0	\N	\N	332900	0	180256009	4107731	
58521	5063	4151422	1944-05-20	1944-05-20 00:00:00	38000275	0	\N	\N	336532	0	269911007	4151422	
47946	4205	4107731	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	279259	0	180256009	4107731	
48245	4226	4107731	1991-12-01	1991-12-01 00:00:00	38000275	0	\N	\N	280737	0	180256009	4107731	
48400	4247	4151422	2006-12-08	2006-12-08 00:00:00	38000275	0	\N	\N	282023	0	269911007	4151422	
60536	5228	4058899	2013-08-30	2013-08-30 00:00:00	38000275	0	\N	\N	347863	0	168594001	4058899	
60652	5245	4107731	1993-05-02	1993-05-02 00:00:00	38000275	0	\N	\N	349007	0	180256009	4107731	
60881	5274	4163872	1956-12-11	1956-12-11 00:00:00	38000275	0	\N	\N	350838	0	399208008	4163872	
61032	5284	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	351551	0	395142003	4191853	
49315	4333	4198190	1980-08-22	1980-08-22 00:00:00	38000275	0	\N	\N	287399	0	80146002	4198190	
61748	5337	4107731	1990-01-21	1990-01-21 00:00:00	38000275	0	\N	\N	355450	0	180256009	4107731	
50246	4374	4295880	1992-05-06	1992-05-06 00:00:00	38000275	0	\N	\N	290569	0	76601001	4295880	
51462	4454	4170947	1998-02-17	1998-02-17 00:00:00	38000275	0	\N	\N	296502	0	274474001	4170947	
51961	4505	4107731	1991-11-26	1991-11-26 00:00:00	38000275	0	\N	\N	299972	0	180256009	4107731	
52440	4548	4151422	1989-06-27	1989-06-27 00:00:00	38000275	0	\N	\N	303106	0	269911007	4151422	
41088	3604	4107731	1997-12-26	1997-12-26 00:00:00	38000275	0	\N	\N	239523	0	180256009	4107731	
53276	4626	4107731	2000-08-04	2000-08-04 00:00:00	38000275	0	\N	\N	308166	0	180256009	4107731	
54456	4724	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	314730	0	180256009	4107731	
54766	4750	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	316364	0	180256009	4107731	
55228	4816	4295880	1999-11-01	1999-11-01 00:00:00	38000275	0	\N	\N	320389	0	76601001	4295880	
55418	4827	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	321209	0	180256009	4107731	
44226	3889	4078793	2016-03-20	2016-03-20 00:00:00	38000275	0	\N	\N	258536	0	180325003	4078793	
57214	4963	4043071	1987-10-05	1987-10-05 00:00:00	38000275	0	\N	\N	329869	0	228557008	4043071	
57391	4971	4243062	2004-01-26	2004-01-26 00:00:00	38000275	0	\N	\N	330515	0	60027007	4243062	
57741	5004	4107731	1991-03-26	1991-03-26 00:00:00	38000275	0	\N	\N	332829	0	180256009	4107731	
58522	5063	4010253	1969-09-21	1969-09-21 00:00:00	38000275	0	\N	\N	336633	0	112790001	4010253	
47947	4205	4107731	1992-06-06	1992-06-06 00:00:00	38000275	0	\N	\N	279191	0	180256009	4107731	
48246	4226	4107731	1992-05-17	1992-05-17 00:00:00	38000275	0	\N	\N	280655	0	180256009	4107731	
48401	4247	4043071	1998-03-19	1998-03-19 00:00:00	38000275	0	\N	\N	282116	0	228557008	4043071	
60537	5228	4195803	2013-08-30	2013-08-30 00:00:00	38000275	0	\N	\N	347863	0	312681000	4195803	
60653	5245	4107731	1993-02-07	1993-02-07 00:00:00	38000275	0	\N	\N	348953	0	180256009	4107731	
60882	5274	4151422	1953-09-29	1953-09-29 00:00:00	38000275	0	\N	\N	350767	0	269911007	4151422	
61033	5284	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	351606	0	180256009	4107731	
49323	4337	4151422	1984-09-13	1984-09-13 00:00:00	38000275	0	\N	\N	287585	0	269911007	4151422	
61749	5337	4107731	1991-08-11	1991-08-11 00:00:00	38000275	0	\N	\N	355402	0	180256009	4107731	
50247	4374	4151422	2000-07-27	2000-07-27 00:00:00	38000275	0	\N	\N	290509	0	269911007	4151422	
51463	4454	4243062	1998-02-17	1998-02-17 00:00:00	38000275	0	\N	\N	296502	0	60027007	4243062	
51962	4505	4107731	1992-05-12	1992-05-12 00:00:00	38000275	0	\N	\N	300007	0	180256009	4107731	
52441	4548	4107731	1997-09-23	1997-09-23 00:00:00	38000275	0	\N	\N	303102	0	180256009	4107731	
41089	3604	4107731	1997-12-05	1997-12-05 00:00:00	38000275	0	\N	\N	239528	0	180256009	4107731	
53277	4626	4107731	1998-01-02	1998-01-02 00:00:00	38000275	0	\N	\N	308214	0	180256009	4107731	
54457	4724	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	314671	0	180256009	4107731	
54767	4750	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	316363	0	180256009	4107731	
55229	4816	4295880	1999-08-02	1999-08-02 00:00:00	38000275	0	\N	\N	320393	0	76601001	4295880	
55419	4827	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	321167	0	180256009	4107731	
44227	3889	4078793	2014-03-09	2014-03-09 00:00:00	38000275	0	\N	\N	258494	0	180325003	4078793	
57215	4963	4043071	1987-11-30	1987-11-30 00:00:00	38000275	0	\N	\N	329931	0	228557008	4043071	
57392	4971	4195803	2004-01-26	2004-01-26 00:00:00	38000275	0	\N	\N	330515	0	312681000	4195803	
57742	5004	4107731	1992-11-24	1992-11-24 00:00:00	38000275	0	\N	\N	332852	0	180256009	4107731	
58527	5065	4216130	2005-03-15	2005-03-15 00:00:00	38000275	0	\N	\N	336708	0	415070008	4216130	
47948	4205	4107731	1993-03-06	1993-03-06 00:00:00	38000275	0	\N	\N	279194	0	180256009	4107731	
60028	5193	4170947	1965-07-30	1965-07-30 00:00:00	38000275	0	\N	\N	345176	0	274474001	4170947	
48402	4247	4043071	1999-08-26	1999-08-26 00:00:00	38000275	0	\N	\N	281992	0	228557008	4043071	
60538	5228	4170947	1941-01-01	1941-01-01 00:00:00	38000275	0	\N	\N	347860	0	274474001	4170947	
60654	5245	4107731	1990-12-02	1990-12-02 00:00:00	38000275	0	\N	\N	348971	0	180256009	4107731	
60883	5276	4078793	2009-12-27	2009-12-27 00:00:00	38000275	0	\N	\N	350871	0	180325003	4078793	
61034	5284	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	351612	0	180256009	4107731	
49324	4337	4163872	1977-02-07	1977-02-07 00:00:00	38000275	0	\N	\N	287589	0	399208008	4163872	
61750	5337	4107731	1990-12-23	1990-12-23 00:00:00	38000275	0	\N	\N	355469	0	180256009	4107731	
50248	4374	4295880	1993-08-05	1993-08-05 00:00:00	38000275	0	\N	\N	290571	0	76601001	4295880	
51464	4454	4125906	1945-04-30	1945-04-30 00:00:00	38000275	0	\N	\N	296495	0	288086009	4125906	
51963	4505	4107731	1990-10-02	1990-10-02 00:00:00	38000275	0	\N	\N	299980	0	180256009	4107731	
52442	4548	4170947	2016-08-03	2016-08-03 00:00:00	38000275	0	\N	\N	303028	0	274474001	4170947	
41090	3604	4107731	1998-11-06	1998-11-06 00:00:00	38000275	0	\N	\N	239531	0	180256009	4107731	
53278	4626	4107731	2000-03-10	2000-03-10 00:00:00	38000275	0	\N	\N	308244	0	180256009	4107731	
54458	4724	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	314826	0	180256009	4107731	
54768	4750	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	316413	0	180256009	4107731	
55230	4816	4295880	1998-02-02	1998-02-02 00:00:00	38000275	0	\N	\N	320391	0	76601001	4295880	
55420	4827	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	321217	0	180256009	4107731	
44228	3889	4125906	1949-06-11	1949-06-11 00:00:00	38000275	0	\N	\N	258516	0	288086009	4125906	
57216	4963	4043071	1990-09-03	1990-09-03 00:00:00	38000275	0	\N	\N	329907	0	228557008	4043071	
57393	4971	4170947	2004-01-26	2004-01-26 00:00:00	38000275	0	\N	\N	330515	0	274474001	4170947	
57743	5004	4107731	1991-05-07	1991-05-07 00:00:00	38000275	0	\N	\N	332792	0	180256009	4107731	
58528	5065	4336464	2005-03-15	2005-03-15 00:00:00	38000275	0	\N	\N	336708	0	232717009	4336464	
47949	4205	4107731	1991-11-30	1991-11-30 00:00:00	38000275	0	\N	\N	279262	0	180256009	4107731	
60029	5193	4078793	2015-09-24	2015-09-24 00:00:00	38000275	0	\N	\N	345235	0	180325003	4078793	
48403	4247	4043071	1996-12-19	1996-12-19 00:00:00	38000275	0	\N	\N	282038	0	228557008	4043071	
60539	5228	4243062	1941-01-01	1941-01-01 00:00:00	38000275	0	\N	\N	347860	0	60027007	4243062	
60655	5245	4107731	1990-05-06	1990-05-06 00:00:00	38000275	0	\N	\N	348942	0	180256009	4107731	
60884	5276	44783196	2015-05-21	2015-05-21 00:00:00	38000275	0	\N	\N	350950	0	699253003	44783196	
61035	5284	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	351571	0	180256009	4107731	
49325	4337	4202451	1991-02-22	1991-02-22 00:00:00	38000275	0	\N	\N	287563	0	433112001	4202451	
61751	5337	4107731	1993-04-11	1993-04-11 00:00:00	38000275	0	\N	\N	355485	0	180256009	4107731	
50249	4374	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	290454	0	180256009	4107731	
51465	4454	4078793	2011-11-05	2011-11-05 00:00:00	38000275	0	\N	\N	296379	0	180325003	4078793	
51964	4505	4107731	1992-06-23	1992-06-23 00:00:00	38000275	0	\N	\N	300008	0	180256009	4107731	
52443	4548	4047491	2016-08-03	2016-08-03 00:00:00	38000275	0	\N	\N	303028	0	1225002	4047491	
41091	3604	4107731	1998-05-01	1998-05-01 00:00:00	38000275	0	\N	\N	239482	0	180256009	4107731	
53279	4626	4107731	1999-03-19	1999-03-19 00:00:00	38000275	0	\N	\N	308239	0	180256009	4107731	
54459	4724	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	314725	0	180256009	4107731	
54769	4750	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	316358	0	180256009	4107731	
55231	4816	4295880	1997-11-03	1997-11-03 00:00:00	38000275	0	\N	\N	320401	0	76601001	4295880	
55421	4827	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	321186	0	180256009	4107731	
44229	3889	4078793	2017-03-26	2017-03-26 00:00:00	38000275	0	\N	\N	258526	0	180325003	4078793	
57217	4963	4043071	1989-01-09	1989-01-09 00:00:00	38000275	0	\N	\N	329902	0	228557008	4043071	
57394	4971	4043071	1948-02-22	1948-02-22 00:00:00	38000275	0	\N	\N	330604	0	228557008	4043071	
57744	5004	4107731	1992-12-15	1992-12-15 00:00:00	38000275	0	\N	\N	332799	0	180256009	4107731	
58529	5066	4252419	1983-08-31	1983-08-31 00:00:00	38000275	0	\N	\N	336805	0	74016001	4252419	
47950	4205	4107731	1991-01-19	1991-01-19 00:00:00	38000275	0	\N	\N	279258	0	180256009	4107731	
60030	5194	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	345368	0	180256009	4107731	
48404	4247	4043071	1997-08-14	1997-08-14 00:00:00	38000275	0	\N	\N	282071	0	228557008	4043071	
60540	5228	4125906	1938-02-04	1938-02-04 00:00:00	38000275	0	\N	\N	347851	0	288086009	4125906	
60656	5245	4107731	1991-08-11	1991-08-11 00:00:00	38000275	0	\N	\N	348946	0	180256009	4107731	
60885	5276	4198190	2011-01-07	2011-01-07 00:00:00	38000275	0	\N	\N	350926	0	80146002	4198190	
61036	5284	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	351567	0	180256009	4107731	
49326	4338	4125906	1973-02-28	1973-02-28 00:00:00	38000275	0	\N	\N	287671	0	288086009	4125906	
61752	5337	4107731	1990-07-29	1990-07-29 00:00:00	38000275	0	\N	\N	355451	0	180256009	4107731	
50250	4374	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	290520	0	180256009	4107731	
51466	4454	4151422	1934-02-20	1934-02-20 00:00:00	38000275	0	\N	\N	296370	0	269911007	4151422	
51965	4505	4107731	1991-12-17	1991-12-17 00:00:00	38000275	0	\N	\N	300031	0	180256009	4107731	
52444	4548	4107731	1999-03-02	1999-03-02 00:00:00	38000275	0	\N	\N	303007	0	180256009	4107731	
41092	3604	4107731	1998-06-12	1998-06-12 00:00:00	38000275	0	\N	\N	239450	0	180256009	4107731	
53280	4626	4107731	1999-08-13	1999-08-13 00:00:00	38000275	0	\N	\N	308221	0	180256009	4107731	
54460	4724	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	314727	0	180256009	4107731	
54770	4750	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	316289	0	180256009	4107731	
55232	4816	4295880	1996-10-31	1996-10-31 00:00:00	38000275	0	\N	\N	320386	0	76601001	4295880	
55422	4827	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	321119	0	180256009	4107731	
44230	3889	4078793	2006-01-22	2006-01-22 00:00:00	38000275	0	\N	\N	258523	0	180325003	4078793	
57218	4963	4043071	1989-09-04	1989-09-04 00:00:00	38000275	0	\N	\N	329874	0	228557008	4043071	
57395	4971	4043071	1950-01-01	1950-01-01 00:00:00	38000275	0	\N	\N	330616	0	228557008	4043071	
57745	5004	4107731	1993-03-30	1993-03-30 00:00:00	38000275	0	\N	\N	332861	0	180256009	4107731	
58530	5066	4125906	1997-08-17	1997-08-17 00:00:00	38000275	0	\N	\N	336813	0	288086009	4125906	
47951	4205	4107731	1993-05-08	1993-05-08 00:00:00	38000275	0	\N	\N	279221	0	180256009	4107731	
60031	5194	4163872	2009-01-27	2009-01-27 00:00:00	38000275	0	\N	\N	345351	0	399208008	4163872	
48405	4247	4043071	1998-05-21	1998-05-21 00:00:00	38000275	0	\N	\N	282073	0	228557008	4043071	
60541	5229	4024289	1989-10-06	1989-10-06 00:00:00	38000275	0	\N	\N	347869	0	19490002	4024289	
60657	5245	4107731	1992-06-21	1992-06-21 00:00:00	38000275	0	\N	\N	348950	0	180256009	4107731	
60886	5276	4078793	2013-09-01	2013-09-01 00:00:00	38000275	0	\N	\N	350898	0	180325003	4078793	
61037	5284	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	351562	0	180256009	4107731	
49327	4338	4047491	1966-06-05	1966-06-05 00:00:00	38000275	0	\N	\N	287670	0	1225002	4047491	
61753	5337	4107731	1990-03-25	1990-03-25 00:00:00	38000275	0	\N	\N	355391	0	180256009	4107731	
50251	4374	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	290577	0	180256009	4107731	
51467	4454	4047491	1932-04-26	1932-04-26 00:00:00	38000275	0	\N	\N	296492	0	1225002	4047491	
51966	4505	4107731	1990-02-13	1990-02-13 00:00:00	38000275	0	\N	\N	299978	0	180256009	4107731	
52445	4548	4107731	1997-07-22	1997-07-22 00:00:00	38000275	0	\N	\N	303020	0	180256009	4107731	
41093	3604	4107731	1998-04-10	1998-04-10 00:00:00	38000275	0	\N	\N	239516	0	180256009	4107731	
53281	4626	4107731	2000-09-15	2000-09-15 00:00:00	38000275	0	\N	\N	308167	0	180256009	4107731	
54461	4725	4107731	1992-10-05	1992-10-05 00:00:00	38000275	0	\N	\N	314938	0	180256009	4107731	
54771	4750	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	316398	0	180256009	4107731	
55233	4816	4170947	1997-03-09	1997-03-09 00:00:00	38000275	0	\N	\N	320433	0	274474001	4170947	
55423	4827	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	321208	0	180256009	4107731	
44231	3889	4078793	2010-02-14	2010-02-14 00:00:00	38000275	0	\N	\N	258525	0	180325003	4078793	
57219	4963	4043071	1990-04-30	1990-04-30 00:00:00	38000275	0	\N	\N	329887	0	228557008	4043071	
57396	4971	4043071	1950-05-28	1950-05-28 00:00:00	38000275	0	\N	\N	330641	0	228557008	4043071	
57746	5004	4107731	1990-05-15	1990-05-15 00:00:00	38000275	0	\N	\N	332825	0	180256009	4107731	
58531	5066	4170947	2015-02-28	2015-02-28 00:00:00	38000275	0	\N	\N	336814	0	274474001	4170947	
47952	4205	4107731	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	279163	0	180256009	4107731	
60032	5194	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	345399	0	180256009	4107731	
48406	4247	4043071	1997-03-20	1997-03-20 00:00:00	38000275	0	\N	\N	282047	0	228557008	4043071	
60542	5229	4170947	1989-10-06	1989-10-06 00:00:00	38000275	0	\N	\N	347869	0	274474001	4170947	
60658	5245	4107731	1992-11-15	1992-11-15 00:00:00	38000275	0	\N	\N	349043	0	180256009	4107731	
60887	5276	4078793	2018-09-30	2018-09-30 00:00:00	38000275	0	\N	\N	350957	0	180325003	4078793	
61038	5284	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	351584	0	180256009	4107731	
49328	4338	4170947	1966-06-05	1966-06-05 00:00:00	38000275	0	\N	\N	287670	0	274474001	4170947	
61754	5337	4107731	1991-09-01	1991-09-01 00:00:00	38000275	0	\N	\N	355478	0	180256009	4107731	
50252	4375	4057420	2017-02-26	2017-02-26 00:00:00	38000275	0	\N	\N	290625	0	18286008	4057420	
51468	4454	4170947	1932-04-26	1932-04-26 00:00:00	38000275	0	\N	\N	296492	0	274474001	4170947	
51967	4505	4107731	1990-07-10	1990-07-10 00:00:00	38000275	0	\N	\N	299967	0	180256009	4107731	
52446	4548	4107731	1999-11-09	1999-11-09 00:00:00	38000275	0	\N	\N	302989	0	180256009	4107731	
41094	3604	4107731	1998-02-06	1998-02-06 00:00:00	38000275	0	\N	\N	239524	0	180256009	4107731	
53282	4626	4107731	2000-05-12	2000-05-12 00:00:00	38000275	0	\N	\N	308183	0	180256009	4107731	
54462	4725	4107731	1991-12-16	1991-12-16 00:00:00	38000275	0	\N	\N	314957	0	180256009	4107731	
54772	4750	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	316409	0	180256009	4107731	
55234	4816	4024289	1997-03-09	1997-03-09 00:00:00	38000275	0	\N	\N	320433	0	19490002	4024289	
55424	4827	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	321086	0	180256009	4107731	
44232	3889	4078793	2011-02-20	2011-02-20 00:00:00	38000275	0	\N	\N	258533	0	180325003	4078793	
57220	4963	4043071	1987-09-07	1987-09-07 00:00:00	38000275	0	\N	\N	329944	0	228557008	4043071	
57397	4971	4163872	1979-01-09	1979-01-09 00:00:00	38000275	0	\N	\N	330651	0	399208008	4163872	
57747	5004	4107731	1992-10-13	1992-10-13 00:00:00	38000275	0	\N	\N	332851	0	180256009	4107731	
47953	4205	4187458	1995-01-02	1995-01-02 00:00:00	38000275	0	\N	\N	279207	0	415300000	4187458	
60033	5194	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	345369	0	180256009	4107731	
48407	4247	4043071	1995-06-29	1995-06-29 00:00:00	38000275	0	\N	\N	282046	0	228557008	4043071	
60543	5229	4058899	1977-06-20	1977-06-20 00:00:00	38000275	0	\N	\N	347867	0	168594001	4058899	
60659	5245	4107731	1991-05-19	1991-05-19 00:00:00	38000275	0	\N	\N	348994	0	180256009	4107731	
60888	5276	4078793	2011-01-02	2011-01-02 00:00:00	38000275	0	\N	\N	350933	0	180325003	4078793	
61039	5284	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	351577	0	180256009	4107731	
49339	4342	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	287945	0	180256009	4107731	
61755	5337	4107731	1992-03-29	1992-03-29 00:00:00	38000275	0	\N	\N	355459	0	180256009	4107731	
50253	4375	4151422	1966-07-08	1966-07-08 00:00:00	38000275	0	\N	\N	290605	0	269911007	4151422	
51469	4454	4151422	1932-10-04	1932-10-04 00:00:00	38000275	0	\N	\N	296413	0	269911007	4151422	
51968	4505	4107731	1992-04-21	1992-04-21 00:00:00	38000275	0	\N	\N	300113	0	180256009	4107731	
52447	4548	4107731	1998-12-08	1998-12-08 00:00:00	38000275	0	\N	\N	303025	0	180256009	4107731	
41095	3604	4107731	1999-09-17	1999-09-17 00:00:00	38000275	0	\N	\N	239535	0	180256009	4107731	
53283	4626	4107731	2000-06-02	2000-06-02 00:00:00	38000275	0	\N	\N	308160	0	180256009	4107731	
54463	4725	4107731	1990-10-22	1990-10-22 00:00:00	38000275	0	\N	\N	314965	0	180256009	4107731	
54773	4750	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	316412	0	180256009	4107731	
55235	4816	4295880	2001-01-29	2001-01-29 00:00:00	38000275	0	\N	\N	320395	0	76601001	4295880	
55425	4827	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	321174	0	180256009	4107731	
44233	3889	4078793	2003-10-12	2003-10-12 00:00:00	38000275	0	\N	\N	258492	0	180325003	4078793	
57221	4963	4043071	1988-11-07	1988-11-07 00:00:00	38000275	0	\N	\N	329948	0	228557008	4043071	
57398	4971	4170947	2000-11-12	2000-11-12 00:00:00	38000275	0	\N	\N	330514	0	274474001	4170947	
57748	5004	4107731	1990-08-07	1990-08-07 00:00:00	38000275	0	\N	\N	332883	0	180256009	4107731	
47954	4205	4326177	1995-01-02	1995-01-02 00:00:00	38000275	0	\N	\N	279207	0	430193006	4326177	
60034	5194	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	345261	0	180256009	4107731	
48408	4247	4043071	1996-02-08	1996-02-08 00:00:00	38000275	0	\N	\N	282036	0	228557008	4043071	
60544	5229	4151422	2001-12-17	2001-12-17 00:00:00	38000275	0	\N	\N	347925	0	269911007	4151422	
60660	5245	4107731	1990-10-21	1990-10-21 00:00:00	38000275	0	\N	\N	348970	0	180256009	4107731	
60889	5276	4078793	2012-08-26	2012-08-26 00:00:00	38000275	0	\N	\N	350873	0	180325003	4078793	
61040	5284	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	351540	0	180256009	4107731	
49340	4342	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	287952	0	180256009	4107731	
61756	5337	4107731	1990-05-06	1990-05-06 00:00:00	38000275	0	\N	\N	355392	0	180256009	4107731	
50254	4375	4057420	2014-08-10	2014-08-10 00:00:00	38000275	0	\N	\N	290657	0	18286008	4057420	
51470	4454	4125906	1969-09-03	1969-09-03 00:00:00	38000275	0	\N	\N	296500	0	288086009	4125906	
51969	4505	4107731	1993-05-04	1993-05-04 00:00:00	38000275	0	\N	\N	299997	0	180256009	4107731	
52448	4548	4107731	1996-12-03	1996-12-03 00:00:00	38000275	0	\N	\N	303084	0	180256009	4107731	
41096	3604	4107731	2000-06-16	2000-06-16 00:00:00	38000275	0	\N	\N	239538	0	180256009	4107731	
53284	4626	4107731	2000-06-23	2000-06-23 00:00:00	38000275	0	\N	\N	308165	0	180256009	4107731	
54464	4725	4107731	1992-11-16	1992-11-16 00:00:00	38000275	0	\N	\N	314939	0	180256009	4107731	
54774	4750	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	316292	0	180256009	4107731	
55236	4816	4198190	1982-11-11	1982-11-11 00:00:00	38000275	0	\N	\N	320435	0	80146002	4198190	
55426	4827	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	321221	0	180256009	4107731	
44234	3889	4125906	2010-05-04	2010-05-04 00:00:00	38000275	0	\N	\N	258518	0	288086009	4125906	
57222	4964	4151422	1966-05-13	1966-05-13 00:00:00	38000275	0	\N	\N	329983	0	269911007	4151422	
57399	4971	4243062	2000-11-12	2000-11-12 00:00:00	38000275	0	\N	\N	330514	0	60027007	4243062	
57749	5004	4107731	1991-05-28	1991-05-28 00:00:00	38000275	0	\N	\N	332866	0	180256009	4107731	
47955	4205	4037675	1995-01-02	1995-01-02 00:00:00	38000275	0	\N	\N	279207	0	162676008	4037675	
60035	5194	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	345273	0	180256009	4107731	
48409	4247	4043071	1999-09-30	1999-09-30 00:00:00	38000275	0	\N	\N	281993	0	228557008	4043071	
60545	5229	4125906	1986-11-30	1986-11-30 00:00:00	38000275	0	\N	\N	347868	0	288086009	4125906	
60661	5245	4125906	1989-09-07	1989-09-07 00:00:00	38000275	0	\N	\N	348934	0	288086009	4125906	
60890	5276	4078793	2016-09-18	2016-09-18 00:00:00	38000275	0	\N	\N	350956	0	180325003	4078793	
61041	5284	4186930	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	351585	0	46706006	4186930	
49341	4342	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	287884	0	180256009	4107731	
61757	5337	4107731	1991-10-13	1991-10-13 00:00:00	38000275	0	\N	\N	355410	0	180256009	4107731	
50255	4375	4078793	2009-07-12	2009-07-12 00:00:00	38000275	0	\N	\N	290648	0	180325003	4078793	
51471	4454	4078793	2016-12-31	2016-12-31 00:00:00	38000275	0	\N	\N	296381	0	180325003	4078793	
51970	4505	4107731	1990-05-29	1990-05-29 00:00:00	38000275	0	\N	\N	299966	0	180256009	4107731	
52449	4548	4107731	1999-02-09	1999-02-09 00:00:00	38000275	0	\N	\N	302986	0	180256009	4107731	
41097	3604	4107731	1997-10-03	1997-10-03 00:00:00	38000275	0	\N	\N	239515	0	180256009	4107731	
53285	4626	4107731	1998-03-06	1998-03-06 00:00:00	38000275	0	\N	\N	308181	0	180256009	4107731	
54465	4725	4107731	1990-09-10	1990-09-10 00:00:00	38000275	0	\N	\N	314964	0	180256009	4107731	
54775	4750	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	316287	0	180256009	4107731	
55237	4816	4295880	2001-07-30	2001-07-30 00:00:00	38000275	0	\N	\N	320415	0	76601001	4295880	
55427	4827	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	321091	0	180256009	4107731	
44235	3889	4057420	2008-02-03	2008-02-03 00:00:00	38000275	0	\N	\N	258524	0	18286008	4057420	
57400	4971	4195803	2000-11-12	2000-11-12 00:00:00	38000275	0	\N	\N	330514	0	312681000	4195803	
57750	5004	4107731	1990-10-30	1990-10-30 00:00:00	38000275	0	\N	\N	332885	0	180256009	4107731	
47956	4205	4107731	1993-03-27	1993-03-27 00:00:00	38000275	0	\N	\N	279206	0	180256009	4107731	
60036	5194	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	345373	0	180256009	4107731	
48410	4247	4043071	2001-03-22	2001-03-22 00:00:00	38000275	0	\N	\N	282064	0	228557008	4043071	
60546	5229	4125906	1968-07-02	1968-07-02 00:00:00	38000275	0	\N	\N	347865	0	288086009	4125906	
60662	5245	4107731	1990-09-30	1990-09-30 00:00:00	38000275	0	\N	\N	348964	0	180256009	4107731	
60891	5276	4078793	2012-01-08	2012-01-08 00:00:00	38000275	0	\N	\N	350872	0	180325003	4078793	
61042	5284	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	351572	0	180256009	4107731	
49342	4342	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	287917	0	180256009	4107731	
61758	5337	4107731	1990-04-15	1990-04-15 00:00:00	38000275	0	\N	\N	355404	0	180256009	4107731	
50256	4375	4195803	2018-03-04	2018-03-04 00:00:00	38000275	0	\N	\N	290599	0	312681000	4195803	
51472	4454	4078793	2019-01-12	2019-01-12 00:00:00	38000275	0	\N	\N	296382	0	180325003	4078793	
51971	4505	4107731	1991-10-15	1991-10-15 00:00:00	38000275	0	\N	\N	300112	0	180256009	4107731	
52450	4548	4107731	1997-02-04	1997-02-04 00:00:00	38000275	0	\N	\N	303100	0	180256009	4107731	
41098	3604	4107731	1997-10-24	1997-10-24 00:00:00	38000275	0	\N	\N	239480	0	180256009	4107731	
53286	4626	4107731	1998-07-10	1998-07-10 00:00:00	38000275	0	\N	\N	308261	0	180256009	4107731	
54466	4725	4107731	1992-04-20	1992-04-20 00:00:00	38000275	0	\N	\N	314971	0	180256009	4107731	
54776	4750	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	316291	0	180256009	4107731	
55238	4816	4295880	1998-11-02	1998-11-02 00:00:00	38000275	0	\N	\N	320392	0	76601001	4295880	
55428	4827	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	321228	0	180256009	4107731	
44236	3889	4151422	1958-04-16	1958-04-16 00:00:00	38000275	0	\N	\N	258453	0	269911007	4151422	
57401	4971	4043071	1948-04-18	1948-04-18 00:00:00	38000275	0	\N	\N	330625	0	228557008	4043071	
57751	5004	4107731	1990-10-09	1990-10-09 00:00:00	38000275	0	\N	\N	332879	0	180256009	4107731	
47957	4205	4107731	1993-02-13	1993-02-13 00:00:00	38000275	0	\N	\N	279205	0	180256009	4107731	
60037	5194	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	345249	0	180256009	4107731	
48411	4247	4043071	2000-08-10	2000-08-10 00:00:00	38000275	0	\N	\N	281995	0	228557008	4043071	
60547	5229	4170947	1963-11-26	1963-11-26 00:00:00	38000275	0	\N	\N	347864	0	274474001	4170947	
60663	5245	4107731	1992-01-26	1992-01-26 00:00:00	38000275	0	\N	\N	349022	0	180256009	4107731	
60892	5276	4078793	2015-09-13	2015-09-13 00:00:00	38000275	0	\N	\N	350899	0	180325003	4078793	
61043	5284	4238715	1991-01-02	1991-01-02 00:00:00	38000275	0	\N	\N	351601	0	68254000	4238715	
49343	4342	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	287911	0	180256009	4107731	
61759	5337	4107731	1992-10-25	1992-10-25 00:00:00	38000275	0	\N	\N	355431	0	180256009	4107731	
50257	4375	4078793	2018-03-04	2018-03-04 00:00:00	38000275	0	\N	\N	290599	0	180325003	4078793	
51473	4454	4078793	2008-10-18	2008-10-18 00:00:00	38000275	0	\N	\N	296486	0	180325003	4078793	
51972	4505	4107731	1991-06-11	1991-06-11 00:00:00	38000275	0	\N	\N	300109	0	180256009	4107731	
52451	4548	4163872	1987-01-02	1987-01-02 00:00:00	38000275	0	\N	\N	303094	0	399208008	4163872	
41099	3604	4107731	1998-03-20	1998-03-20 00:00:00	38000275	0	\N	\N	239529	0	180256009	4107731	
53287	4626	4107731	2000-01-07	2000-01-07 00:00:00	38000275	0	\N	\N	308266	0	180256009	4107731	
54467	4725	4107731	1990-03-05	1990-03-05 00:00:00	38000275	0	\N	\N	314911	0	180256009	4107731	
54777	4750	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	316336	0	180256009	4107731	
55239	4816	4295880	2000-10-30	2000-10-30 00:00:00	38000275	0	\N	\N	320405	0	76601001	4295880	
55429	4827	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	321161	0	395142003	4191853	
44237	3891	4107731	1997-01-01	1997-01-01 00:00:00	38000275	0	\N	\N	258667	0	180256009	4107731	
57402	4971	4043071	1946-11-10	1946-11-10 00:00:00	38000275	0	\N	\N	330527	0	228557008	4043071	
57752	5004	4107731	1991-10-01	1991-10-01 00:00:00	38000275	0	\N	\N	332870	0	180256009	4107731	
47958	4205	4107731	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	279222	0	180256009	4107731	
60038	5194	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	345245	0	180256009	4107731	
48412	4247	4043071	1995-10-26	1995-10-26 00:00:00	38000275	0	\N	\N	282066	0	228557008	4043071	
60548	5229	4047491	1963-11-26	1963-11-26 00:00:00	38000275	0	\N	\N	347864	0	1225002	4047491	
60664	5245	4107731	1992-08-02	1992-08-02 00:00:00	38000275	0	\N	\N	348951	0	180256009	4107731	
60893	5276	4078793	2017-09-24	2017-09-24 00:00:00	38000275	0	\N	\N	350900	0	180325003	4078793	
61044	5284	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	351573	0	180256009	4107731	
49344	4342	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	287931	0	180256009	4107731	
61760	5337	4107731	1992-06-21	1992-06-21 00:00:00	38000275	0	\N	\N	355461	0	180256009	4107731	
50258	4375	4078793	2011-07-24	2011-07-24 00:00:00	38000275	0	\N	\N	290649	0	180325003	4078793	
51474	4454	4057420	2012-11-10	2012-11-10 00:00:00	38000275	0	\N	\N	296488	0	18286008	4057420	
51973	4505	4107731	1991-05-21	1991-05-21 00:00:00	38000275	0	\N	\N	299971	0	180256009	4107731	
52452	4548	4107731	1996-12-24	1996-12-24 00:00:00	38000275	0	\N	\N	303099	0	180256009	4107731	
41100	3604	4107731	2000-03-03	2000-03-03 00:00:00	38000275	0	\N	\N	239458	0	180256009	4107731	
53288	4626	4107731	1999-02-05	1999-02-05 00:00:00	38000275	0	\N	\N	308220	0	180256009	4107731	
54468	4725	4107731	1992-10-26	1992-10-26 00:00:00	38000275	0	\N	\N	314878	0	180256009	4107731	
54778	4750	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	316368	0	180256009	4107731	
55240	4816	4295880	2002-01-28	2002-01-28 00:00:00	38000275	0	\N	\N	320441	0	76601001	4295880	
55430	4827	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	321170	0	180256009	4107731	
44238	3891	4107731	1998-12-16	1998-12-16 00:00:00	38000275	0	\N	\N	258640	0	180256009	4107731	
57403	4971	4043071	1949-01-16	1949-01-16 00:00:00	38000275	0	\N	\N	330612	0	228557008	4043071	
57753	5004	4107731	1993-08-24	1993-08-24 00:00:00	38000275	0	\N	\N	332816	0	180256009	4107731	
47959	4205	4107731	1993-01-23	1993-01-23 00:00:00	38000275	0	\N	\N	279193	0	180256009	4107731	
60039	5194	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	345259	0	180256009	4107731	
48413	4247	4043071	2000-10-12	2000-10-12 00:00:00	38000275	0	\N	\N	282056	0	228557008	4043071	
60549	5230	4195803	2005-11-09	2005-11-09 00:00:00	38000275	0	\N	\N	348020	0	312681000	4195803	
60665	5245	4107731	1991-11-24	1991-11-24 00:00:00	38000275	0	\N	\N	349038	0	180256009	4107731	
60894	5276	4252419	2015-05-14	2015-05-14 00:00:00	38000275	0	\N	\N	350921	0	74016001	4252419	
61045	5284	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	351570	0	180256009	4107731	
49345	4342	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	287950	0	180256009	4107731	
61761	5337	4107731	1990-06-17	1990-06-17 00:00:00	38000275	0	\N	\N	355468	0	180256009	4107731	
50259	4375	4078793	2015-08-16	2015-08-16 00:00:00	38000275	0	\N	\N	290647	0	180325003	4078793	
51477	4456	4170947	1965-06-18	1965-06-18 00:00:00	38000275	0	\N	\N	296616	0	274474001	4170947	
51974	4505	4107731	1990-07-31	1990-07-31 00:00:00	38000275	0	\N	\N	300026	0	180256009	4107731	
52453	4548	4107731	1998-10-06	1998-10-06 00:00:00	38000275	0	\N	\N	303045	0	180256009	4107731	
41101	3604	4107731	1999-12-31	1999-12-31 00:00:00	38000275	0	\N	\N	239492	0	180256009	4107731	
53289	4626	4107731	2001-01-19	2001-01-19 00:00:00	38000275	0	\N	\N	308251	0	180256009	4107731	
54469	4725	4107731	1992-08-24	1992-08-24 00:00:00	38000275	0	\N	\N	314937	0	180256009	4107731	
54779	4750	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	316410	0	180256009	4107731	
55241	4816	4295880	2000-05-01	2000-05-01 00:00:00	38000275	0	\N	\N	320394	0	76601001	4295880	
55431	4828	4047491	1984-05-01	1984-05-01 00:00:00	38000275	0	\N	\N	321252	0	1225002	4047491	
44239	3891	4107731	1996-09-18	1996-09-18 00:00:00	38000275	0	\N	\N	258634	0	180256009	4107731	
57404	4971	4043071	1947-01-12	1947-01-12 00:00:00	38000275	0	\N	\N	330619	0	228557008	4043071	
57754	5004	4107731	1992-01-14	1992-01-14 00:00:00	38000275	0	\N	\N	332848	0	180256009	4107731	
47960	4205	4107731	1992-12-12	1992-12-12 00:00:00	38000275	0	\N	\N	279192	0	180256009	4107731	
60040	5194	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	345291	0	180256009	4107731	
48414	4247	4043071	1998-06-25	1998-06-25 00:00:00	38000275	0	\N	\N	282074	0	228557008	4043071	
60550	5230	4047491	1961-09-06	1961-09-06 00:00:00	38000275	0	\N	\N	347940	0	1225002	4047491	
60666	5245	4107731	1993-05-23	1993-05-23 00:00:00	38000275	0	\N	\N	349033	0	180256009	4107731	
60895	5276	4057420	2014-09-07	2014-09-07 00:00:00	38000275	0	\N	\N	350955	0	18286008	4057420	
61046	5284	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	351495	0	180256009	4107731	
49346	4342	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	287972	0	180256009	4107731	
61762	5337	4107731	1991-05-19	1991-05-19 00:00:00	38000275	0	\N	\N	355400	0	180256009	4107731	
50260	4375	4151422	1952-06-13	1952-06-13 00:00:00	38000275	0	\N	\N	290603	0	269911007	4151422	
51478	4456	4024289	1965-06-18	1965-06-18 00:00:00	38000275	0	\N	\N	296616	0	19490002	4024289	
51975	4505	4107731	1991-04-30	1991-04-30 00:00:00	38000275	0	\N	\N	300029	0	180256009	4107731	
52454	4548	4107731	2000-02-22	2000-02-22 00:00:00	38000275	0	\N	\N	303050	0	180256009	4107731	
41102	3604	4107731	1997-06-20	1997-06-20 00:00:00	38000275	0	\N	\N	239477	0	180256009	4107731	
53290	4626	4107731	1999-12-17	1999-12-17 00:00:00	38000275	0	\N	\N	308164	0	180256009	4107731	
54470	4725	4107731	1991-09-23	1991-09-23 00:00:00	38000275	0	\N	\N	314955	0	180256009	4107731	
54780	4750	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	316361	0	180256009	4107731	
55242	4816	4295880	2000-01-31	2000-01-31 00:00:00	38000275	0	\N	\N	320404	0	76601001	4295880	
55432	4828	4170947	1984-05-01	1984-05-01 00:00:00	38000275	0	\N	\N	321252	0	274474001	4170947	
44240	3891	4107731	1997-10-01	1997-10-01 00:00:00	38000275	0	\N	\N	258750	0	180256009	4107731	
57405	4971	4043071	1946-10-06	1946-10-06 00:00:00	38000275	0	\N	\N	330542	0	228557008	4043071	
57755	5004	4107731	1992-08-11	1992-08-11 00:00:00	38000275	0	\N	\N	332796	0	180256009	4107731	
47961	4205	4107731	1992-02-01	1992-02-01 00:00:00	38000275	0	\N	\N	279217	0	180256009	4107731	
60041	5194	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	345371	0	180256009	4107731	
48415	4247	4043071	1999-04-15	1999-04-15 00:00:00	38000275	0	\N	\N	282119	0	228557008	4043071	
60551	5230	4170947	1961-09-06	1961-09-06 00:00:00	38000275	0	\N	\N	347940	0	274474001	4170947	
60667	5245	4107731	1990-01-21	1990-01-21 00:00:00	38000275	0	\N	\N	348967	0	180256009	4107731	
60896	5277	4058899	1955-12-31	1955-12-31 00:00:00	38000275	0	\N	\N	350974	0	168594001	4058899	
61047	5284	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	351539	0	180256009	4107731	
49347	4342	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	287904	0	180256009	4107731	
61763	5337	4107731	1990-07-08	1990-07-08 00:00:00	38000275	0	\N	\N	355396	0	180256009	4107731	
50261	4375	4078793	2010-07-18	2010-07-18 00:00:00	38000275	0	\N	\N	290597	0	180325003	4078793	
51479	4457	4058899	1999-09-27	1999-09-27 00:00:00	38000275	0	\N	\N	296639	0	168594001	4058899	
51976	4505	4202451	1980-12-16	1980-12-16 00:00:00	38000275	0	\N	\N	300090	0	433112001	4202451	
52455	4548	4191853	1996-10-22	1996-10-22 00:00:00	38000275	0	\N	\N	303083	0	395142003	4191853	
41103	3604	4191853	2000-11-10	2000-11-10 00:00:00	38000275	0	\N	\N	239496	0	395142003	4191853	
53291	4626	4107731	1998-09-11	1998-09-11 00:00:00	38000275	0	\N	\N	308238	0	180256009	4107731	
54471	4725	4107731	1990-04-16	1990-04-16 00:00:00	38000275	0	\N	\N	314912	0	180256009	4107731	
54783	4753	4043071	1972-07-01	1972-07-01 00:00:00	38000275	0	\N	\N	316565	0	228557008	4043071	
55243	4816	4295880	1997-05-05	1997-05-05 00:00:00	38000275	0	\N	\N	320387	0	76601001	4295880	
55433	4828	4125906	2000-11-02	2000-11-02 00:00:00	38000275	0	\N	\N	321254	0	288086009	4125906	
44241	3891	4107731	1999-04-21	1999-04-21 00:00:00	38000275	0	\N	\N	258655	0	180256009	4107731	
57406	4971	4043071	1948-05-16	1948-05-16 00:00:00	38000275	0	\N	\N	330605	0	228557008	4043071	
57756	5005	4163872	2008-08-28	2008-08-28 00:00:00	38000275	0	\N	\N	332929	0	399208008	4163872	
47962	4205	4107731	1991-03-23	1991-03-23 00:00:00	38000275	0	\N	\N	279172	0	180256009	4107731	
60042	5194	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	345255	0	180256009	4107731	
48416	4247	4043071	2001-02-15	2001-02-15 00:00:00	38000275	0	\N	\N	282063	0	228557008	4043071	
60552	5230	4195803	2002-03-05	2002-03-05 00:00:00	38000275	0	\N	\N	347941	0	312681000	4195803	
60668	5245	4107731	1992-04-19	1992-04-19 00:00:00	38000275	0	\N	\N	349027	0	180256009	4107731	
60897	5278	4145310	1971-06-28	1971-06-28 00:00:00	38000275	0	\N	\N	351125	0	268425006	4145310	
61048	5284	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	351569	0	180256009	4107731	
49348	4342	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	287948	0	180256009	4107731	
61764	5337	4107731	1990-02-11	1990-02-11 00:00:00	38000275	0	\N	\N	355390	0	180256009	4107731	
50262	4375	4198190	1946-07-06	1946-07-06 00:00:00	38000275	0	\N	\N	290600	0	80146002	4198190	
51480	4457	4058899	2006-07-22	2006-07-22 00:00:00	38000275	0	\N	\N	296640	0	168594001	4058899	
51977	4505	4107731	1990-04-17	1990-04-17 00:00:00	38000275	0	\N	\N	300043	0	180256009	4107731	
52456	4548	4107731	1998-10-27	1998-10-27 00:00:00	38000275	0	\N	\N	303024	0	180256009	4107731	
41104	3604	4107731	1999-08-27	1999-08-27 00:00:00	38000275	0	\N	\N	239548	0	180256009	4107731	
53292	4626	4107731	1999-09-24	1999-09-24 00:00:00	38000275	0	\N	\N	308162	0	180256009	4107731	
54472	4725	4107731	1993-05-24	1993-05-24 00:00:00	38000275	0	\N	\N	314893	0	180256009	4107731	
54784	4753	4043071	1971-07-03	1971-07-03 00:00:00	38000275	0	\N	\N	316561	0	228557008	4043071	
55244	4816	4125906	1990-05-26	1990-05-26 00:00:00	38000275	0	\N	\N	320431	0	288086009	4125906	
55436	4834	4243062	1971-03-24	1971-03-24 00:00:00	38000275	0	\N	\N	321546	0	60027007	4243062	
44242	3891	4107731	1996-11-20	1996-11-20 00:00:00	38000275	0	\N	\N	258746	0	180256009	4107731	
57407	4972	4145310	1999-08-20	1999-08-20 00:00:00	38000275	0	\N	\N	330664	0	268425006	4145310	
57757	5005	44783196	2010-03-24	2010-03-24 00:00:00	38000275	0	\N	\N	332957	0	699253003	44783196	
47963	4205	4107731	1990-01-27	1990-01-27 00:00:00	38000275	0	\N	\N	279181	0	180256009	4107731	
60043	5194	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	345247	0	180256009	4107731	
48417	4247	4043071	1999-12-02	1999-12-02 00:00:00	38000275	0	\N	\N	282053	0	228557008	4043071	
60553	5230	4170947	2002-03-05	2002-03-05 00:00:00	38000275	0	\N	\N	347941	0	274474001	4170947	
60669	5245	4107731	1990-02-11	1990-02-11 00:00:00	38000275	0	\N	\N	348962	0	180256009	4107731	
60898	5278	4195803	1971-06-28	1971-06-28 00:00:00	38000275	0	\N	\N	351125	0	312681000	4195803	
61049	5284	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	351494	0	180256009	4107731	
49349	4342	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	287929	0	180256009	4107731	
61765	5337	4107731	1991-07-21	1991-07-21 00:00:00	38000275	0	\N	\N	355456	0	180256009	4107731	
50263	4375	4078793	2006-06-25	2006-06-25 00:00:00	38000275	0	\N	\N	290646	0	180325003	4078793	
51481	4457	4125906	1994-02-11	1994-02-11 00:00:00	38000275	0	\N	\N	296638	0	288086009	4125906	
51978	4505	4107731	1990-08-21	1990-08-21 00:00:00	38000275	0	\N	\N	299979	0	180256009	4107731	
52457	4548	4107731	1999-07-27	1999-07-27 00:00:00	38000275	0	\N	\N	303038	0	180256009	4107731	
41105	3604	4191853	1997-05-09	1997-05-09 00:00:00	38000275	0	\N	\N	239521	0	395142003	4191853	
53293	4626	4107731	2000-01-28	2000-01-28 00:00:00	38000275	0	\N	\N	308243	0	180256009	4107731	
54473	4725	4107731	1990-01-22	1990-01-22 00:00:00	38000275	0	\N	\N	314962	0	180256009	4107731	
54785	4753	4043071	1972-01-08	1972-01-08 00:00:00	38000275	0	\N	\N	316532	0	228557008	4043071	
55245	4816	4293740	1990-05-26	1990-05-26 00:00:00	38000275	0	\N	\N	320431	0	384700001	4293740	
55437	4834	4170947	1971-03-24	1971-03-24 00:00:00	38000275	0	\N	\N	321546	0	274474001	4170947	
44243	3891	4107731	1996-07-17	1996-07-17 00:00:00	38000275	0	\N	\N	258760	0	180256009	4107731	
57408	4972	4145310	1997-08-30	1997-08-30 00:00:00	38000275	0	\N	\N	330724	0	268425006	4145310	
57758	5005	4125906	2004-08-31	2004-08-31 00:00:00	38000275	0	\N	\N	332909	0	288086009	4125906	
47964	4205	4107731	1991-07-06	1991-07-06 00:00:00	38000275	0	\N	\N	279228	0	180256009	4107731	
60044	5194	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	345293	0	180256009	4107731	
48418	4247	4043071	1996-11-21	1996-11-21 00:00:00	38000275	0	\N	\N	282070	0	228557008	4043071	
60554	5230	4243062	2002-03-05	2002-03-05 00:00:00	38000275	0	\N	\N	347941	0	60027007	4243062	
60670	5245	4191853	1989-12-31	1989-12-31 00:00:00	38000275	0	\N	\N	348961	0	395142003	4191853	
60899	5278	4047491	1984-12-16	1984-12-16 00:00:00	38000275	0	\N	\N	351129	0	1225002	4047491	
61050	5284	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	351541	0	180256009	4107731	
49350	4342	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	287946	0	180256009	4107731	
61766	5337	4107731	1993-06-13	1993-06-13 00:00:00	38000275	0	\N	\N	355433	0	180256009	4107731	
50264	4375	4078793	2019-03-10	2019-03-10 00:00:00	38000275	0	\N	\N	290652	0	180325003	4078793	
51482	4460	4163872	1989-04-05	1989-04-05 00:00:00	38000275	0	\N	\N	296812	0	399208008	4163872	
51979	4505	4107731	1990-05-08	1990-05-08 00:00:00	38000275	0	\N	\N	300024	0	180256009	4107731	
52458	4548	4107731	1996-11-12	1996-11-12 00:00:00	38000275	0	\N	\N	303098	0	180256009	4107731	
41106	3604	4107731	1999-02-19	1999-02-19 00:00:00	38000275	0	\N	\N	239488	0	180256009	4107731	
53294	4626	4107731	1999-04-30	1999-04-30 00:00:00	38000275	0	\N	\N	308240	0	180256009	4107731	
54474	4725	4107731	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	314952	0	180256009	4107731	
54786	4753	4043071	1971-09-04	1971-09-04 00:00:00	38000275	0	\N	\N	316474	0	228557008	4043071	
55246	4816	4295880	1997-08-04	1997-08-04 00:00:00	38000275	0	\N	\N	320412	0	76601001	4295880	
55438	4834	4125906	2008-12-30	2008-12-30 00:00:00	38000275	0	\N	\N	321550	0	288086009	4125906	
44244	3891	4107731	1996-04-03	1996-04-03 00:00:00	38000275	0	\N	\N	258727	0	180256009	4107731	
57409	4972	4195803	2016-09-19	2016-09-19 00:00:00	38000275	0	\N	\N	330665	0	312681000	4195803	
57759	5005	4252419	2010-03-17	2010-03-17 00:00:00	38000275	0	\N	\N	332910	0	74016001	4252419	
47965	4205	4191853	1990-01-06	1990-01-06 00:00:00	38000275	0	\N	\N	279161	0	395142003	4191853	
60045	5194	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	345262	0	180256009	4107731	
48419	4247	4043071	1996-09-12	1996-09-12 00:00:00	38000275	0	\N	\N	282107	0	228557008	4043071	
60555	5230	4243062	2014-02-14	2014-02-14 00:00:00	38000275	0	\N	\N	347944	0	60027007	4243062	
60671	5245	4107731	1992-09-13	1992-09-13 00:00:00	38000275	0	\N	\N	349024	0	180256009	4107731	
60900	5278	4170947	1984-12-16	1984-12-16 00:00:00	38000275	0	\N	\N	351129	0	274474001	4170947	
61051	5284	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	351580	0	180256009	4107731	
49351	4342	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	287920	0	180256009	4107731	
61767	5337	4107731	1992-01-26	1992-01-26 00:00:00	38000275	0	\N	\N	355475	0	180256009	4107731	
50265	4375	4078793	2016-08-21	2016-08-21 00:00:00	38000275	0	\N	\N	290658	0	180325003	4078793	
51483	4460	4195803	2012-04-02	2012-04-02 00:00:00	38000275	0	\N	\N	296797	0	312681000	4195803	
51980	4505	4125906	1942-02-20	1942-02-20 00:00:00	38000275	0	\N	\N	300078	0	288086009	4125906	
52459	4548	4107731	1999-03-23	1999-03-23 00:00:00	38000275	0	\N	\N	303035	0	180256009	4107731	
41107	3604	4107731	1998-05-22	1998-05-22 00:00:00	38000275	0	\N	\N	239517	0	180256009	4107731	
53295	4626	4107731	2001-04-13	2001-04-13 00:00:00	38000275	0	\N	\N	308224	0	180256009	4107731	
54475	4725	4047491	1975-08-19	1975-08-19 00:00:00	38000275	0	\N	\N	314863	0	1225002	4047491	
54787	4753	4043071	1972-07-29	1972-07-29 00:00:00	38000275	0	\N	\N	316534	0	228557008	4043071	
55247	4816	4295880	2001-04-30	2001-04-30 00:00:00	38000275	0	\N	\N	320440	0	76601001	4295880	
55439	4835	4145310	1974-03-10	1974-03-10 00:00:00	38000275	0	\N	\N	321633	0	268425006	4145310	
44245	3891	4107731	1997-01-22	1997-01-22 00:00:00	38000275	0	\N	\N	258761	0	180256009	4107731	
57764	5007	4181917	1995-03-24	1995-03-24 00:00:00	38000275	0	\N	\N	332996	0	54550000	4181917	
47966	4205	4107731	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	279229	0	180256009	4107731	
60046	5194	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	345251	0	180256009	4107731	
48420	4247	4043071	1997-10-23	1997-10-23 00:00:00	38000275	0	\N	\N	282041	0	228557008	4043071	
60556	5230	4170947	2014-02-14	2014-02-14 00:00:00	38000275	0	\N	\N	347944	0	274474001	4170947	
60672	5245	4107731	1990-11-11	1990-11-11 00:00:00	38000275	0	\N	\N	348965	0	180256009	4107731	
60901	5278	4151422	1981-06-07	1981-06-07 00:00:00	38000275	0	\N	\N	351055	0	269911007	4151422	
61052	5284	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	351614	0	180256009	4107731	
49352	4342	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	287924	0	180256009	4107731	
61768	5337	4107731	1993-01-17	1993-01-17 00:00:00	38000275	0	\N	\N	355483	0	180256009	4107731	
50266	4375	4078793	2013-08-04	2013-08-04 00:00:00	38000275	0	\N	\N	290650	0	180325003	4078793	
51484	4460	4170947	2012-04-02	2012-04-02 00:00:00	38000275	0	\N	\N	296797	0	274474001	4170947	
51981	4505	4107731	1993-04-13	1993-04-13 00:00:00	38000275	0	\N	\N	300067	0	180256009	4107731	
52460	4548	4107731	1999-09-07	1999-09-07 00:00:00	38000275	0	\N	\N	303008	0	180256009	4107731	
41108	3604	4107731	1999-07-16	1999-07-16 00:00:00	38000275	0	\N	\N	239547	0	180256009	4107731	
54476	4725	4170947	1975-08-19	1975-08-19 00:00:00	38000275	0	\N	\N	314863	0	274474001	4170947	
54788	4753	4043071	1973-09-08	1973-09-08 00:00:00	38000275	0	\N	\N	316541	0	228557008	4043071	
55248	4816	4295880	2001-10-29	2001-10-29 00:00:00	38000275	0	\N	\N	320396	0	76601001	4295880	
55440	4835	4198190	1985-04-26	1985-04-26 00:00:00	38000275	0	\N	\N	321666	0	80146002	4198190	
44246	3891	4107731	1998-04-29	1998-04-29 00:00:00	38000275	0	\N	\N	258741	0	180256009	4107731	
57765	5007	4125906	2008-08-26	2008-08-26 00:00:00	38000275	0	\N	\N	332998	0	288086009	4125906	
47967	4205	4107731	1992-04-25	1992-04-25 00:00:00	38000275	0	\N	\N	279190	0	180256009	4107731	
60047	5194	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	345312	0	180256009	4107731	
48421	4247	4043071	1996-08-08	1996-08-08 00:00:00	38000275	0	\N	\N	282111	0	228557008	4043071	
60557	5230	4125906	2013-04-06	2013-04-06 00:00:00	38000275	0	\N	\N	347943	0	288086009	4125906	
60673	5245	4107731	1990-07-29	1990-07-29 00:00:00	38000275	0	\N	\N	349016	0	180256009	4107731	
60902	5278	4062501	1973-05-15	1973-05-15 00:00:00	38000275	0	\N	\N	351068	0	171231001	4062501	
61053	5284	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	351522	0	180256009	4107731	
49353	4342	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	287949	0	180256009	4107731	
61769	5337	4107731	1990-05-27	1990-05-27 00:00:00	38000275	0	\N	\N	355405	0	180256009	4107731	
50267	4375	4078793	2008-07-06	2008-07-06 00:00:00	38000275	0	\N	\N	290596	0	180325003	4078793	
51485	4460	4243062	2012-04-02	2012-04-02 00:00:00	38000275	0	\N	\N	296797	0	60027007	4243062	
51982	4505	4125906	2016-04-02	2016-04-02 00:00:00	38000275	0	\N	\N	300011	0	288086009	4125906	
52461	4548	4107731	1999-07-06	1999-07-06 00:00:00	38000275	0	\N	\N	303048	0	180256009	4107731	
41109	3604	4107731	1999-01-08	1999-01-08 00:00:00	38000275	0	\N	\N	239546	0	180256009	4107731	
54477	4725	4107731	1991-04-29	1991-04-29 00:00:00	38000275	0	\N	\N	314966	0	180256009	4107731	
54789	4753	4043071	1973-10-06	1973-10-06 00:00:00	38000275	0	\N	\N	316538	0	228557008	4043071	
55252	4819	4125906	1988-01-23	1988-01-23 00:00:00	38000275	0	\N	\N	320546	0	288086009	4125906	
55506	4837	4078793	2019-01-15	2019-01-15 00:00:00	38000275	0	\N	\N	321832	0	180325003	4078793	
44247	3891	4107731	1998-11-25	1998-11-25 00:00:00	38000275	0	\N	\N	258688	0	180256009	4107731	
57766	5007	4125906	2000-06-25	2000-06-25 00:00:00	38000275	0	\N	\N	332997	0	288086009	4125906	
47968	4205	4107731	1991-04-13	1991-04-13 00:00:00	38000275	0	\N	\N	279260	0	180256009	4107731	
60048	5194	4197460	1953-04-10	1953-04-10 00:00:00	38000275	0	\N	\N	345404	0	313191000	4197460	
48422	4247	4043071	2000-12-14	2000-12-14 00:00:00	38000275	0	\N	\N	282022	0	228557008	4043071	
60558	5232	4058899	1972-06-12	1972-06-12 00:00:00	38000275	0	\N	\N	348065	0	168594001	4058899	
60674	5245	4107731	1991-06-09	1991-06-09 00:00:00	38000275	0	\N	\N	348972	0	180256009	4107731	
60903	5279	4163872	1965-11-19	1965-11-19 00:00:00	38000275	0	\N	\N	351183	0	399208008	4163872	
61054	5284	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	351613	0	180256009	4107731	
49354	4342	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	287933	0	180256009	4107731	
61770	5337	4107731	1992-12-06	1992-12-06 00:00:00	38000275	0	\N	\N	355482	0	180256009	4107731	
50268	4375	4078793	2007-07-01	2007-07-01 00:00:00	38000275	0	\N	\N	290678	0	180325003	4078793	
51486	4460	4293740	1993-12-17	1993-12-17 00:00:00	38000275	0	\N	\N	296740	0	384700001	4293740	
51983	4505	4107731	1990-01-23	1990-01-23 00:00:00	38000275	0	\N	\N	300084	0	180256009	4107731	
52462	4548	4107731	1997-02-25	1997-02-25 00:00:00	38000275	0	\N	\N	303086	0	180256009	4107731	
41110	3604	4107731	2000-01-21	2000-01-21 00:00:00	38000275	0	\N	\N	239457	0	180256009	4107731	
54478	4725	4107731	1990-11-12	1990-11-12 00:00:00	38000275	0	\N	\N	314873	0	180256009	4107731	
54790	4753	4043071	1974-07-27	1974-07-27 00:00:00	38000275	0	\N	\N	316554	0	228557008	4043071	
55253	4819	4037675	1960-09-21	1960-09-21 00:00:00	38000275	0	\N	\N	320582	0	162676008	4037675	
55507	4837	4151422	2008-05-29	2008-05-29 00:00:00	38000275	0	\N	\N	321839	0	269911007	4151422	
44248	3891	4107731	1997-03-26	1997-03-26 00:00:00	38000275	0	\N	\N	258669	0	180256009	4107731	
57777	5013	4151422	1966-10-12	1966-10-12 00:00:00	38000275	0	\N	\N	333203	0	269911007	4151422	
47969	4205	4107731	1990-11-17	1990-11-17 00:00:00	38000275	0	\N	\N	279226	0	180256009	4107731	
60049	5194	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	345325	0	180256009	4107731	
48423	4247	4043071	2000-05-11	2000-05-11 00:00:00	38000275	0	\N	\N	282062	0	228557008	4043071	
60559	5232	4024289	2016-09-19	2016-09-19 00:00:00	38000275	0	\N	\N	348067	0	19490002	4024289	
60675	5245	4107731	1990-06-17	1990-06-17 00:00:00	38000275	0	\N	\N	348943	0	180256009	4107731	
60904	5279	4047491	1963-04-28	1963-04-28 00:00:00	38000275	0	\N	\N	351133	0	1225002	4047491	
61055	5284	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	351574	0	180256009	4107731	
49355	4342	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	287935	0	180256009	4107731	
61771	5337	4107731	1990-08-19	1990-08-19 00:00:00	38000275	0	\N	\N	355397	0	180256009	4107731	
50269	4375	4078793	2012-07-29	2012-07-29 00:00:00	38000275	0	\N	\N	290598	0	180325003	4078793	
51487	4460	4125906	1993-12-17	1993-12-17 00:00:00	38000275	0	\N	\N	296740	0	288086009	4125906	
51984	4505	4191853	1993-07-06	1993-07-06 00:00:00	38000275	0	\N	\N	299990	0	395142003	4191853	
52463	4548	4107731	1998-08-25	1998-08-25 00:00:00	38000275	0	\N	\N	303044	0	180256009	4107731	
41111	3604	4107731	2000-07-28	2000-07-28 00:00:00	38000275	0	\N	\N	239551	0	180256009	4107731	
54479	4725	4107731	1991-01-14	1991-01-14 00:00:00	38000275	0	\N	\N	314930	0	180256009	4107731	
54791	4753	4043071	1972-03-11	1972-03-11 00:00:00	38000275	0	\N	\N	316483	0	228557008	4043071	
55254	4819	4326177	1960-09-21	1960-09-21 00:00:00	38000275	0	\N	\N	320582	0	430193006	4326177	
55508	4837	40492359	2004-03-23	2004-03-23 00:00:00	38000275	0	\N	\N	321870	0	447365002	40492359	
44249	3891	4107731	1998-08-12	1998-08-12 00:00:00	38000275	0	\N	\N	258767	0	180256009	4107731	
57778	5013	4125906	2003-04-11	2003-04-11 00:00:00	38000275	0	\N	\N	333200	0	288086009	4125906	
47970	4206	4035793	1994-09-12	1994-09-12 00:00:00	38000275	0	\N	\N	279323	0	15081005	4035793	
60050	5194	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	345313	0	180256009	4107731	
48424	4247	4043071	1996-01-04	1996-01-04 00:00:00	38000275	0	\N	\N	282068	0	228557008	4043071	
60560	5232	4170947	2016-09-19	2016-09-19 00:00:00	38000275	0	\N	\N	348067	0	274474001	4170947	
60676	5245	4107731	1991-12-15	1991-12-15 00:00:00	38000275	0	\N	\N	349021	0	180256009	4107731	
60905	5279	4170947	1963-04-28	1963-04-28 00:00:00	38000275	0	\N	\N	351133	0	274474001	4170947	
61056	5284	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	351608	0	180256009	4107731	
49356	4342	4125906	2015-08-05	2015-08-05 00:00:00	38000275	0	\N	\N	287847	0	288086009	4125906	
61772	5337	4107731	1992-05-31	1992-05-31 00:00:00	38000275	0	\N	\N	355481	0	180256009	4107731	
50270	4376	4035793	2012-01-03	2012-01-03 00:00:00	38000275	0	\N	\N	290822	0	15081005	4035793	
51488	4460	4047491	2003-07-19	2003-07-19 00:00:00	38000275	0	\N	\N	296741	0	1225002	4047491	
51985	4505	4107731	1993-06-15	1993-06-15 00:00:00	38000275	0	\N	\N	300063	0	180256009	4107731	
52464	4548	4107731	1999-04-13	1999-04-13 00:00:00	38000275	0	\N	\N	303046	0	180256009	4107731	
41112	3604	4107731	1998-09-04	1998-09-04 00:00:00	38000275	0	\N	\N	239543	0	180256009	4107731	
54480	4725	4107731	1992-12-07	1992-12-07 00:00:00	38000275	0	\N	\N	314973	0	180256009	4107731	
55255	4819	4187458	1960-09-21	1960-09-21 00:00:00	38000275	0	\N	\N	320582	0	415300000	4187458	
55509	4837	4057420	2004-03-23	2004-03-23 00:00:00	38000275	0	\N	\N	321870	0	18286008	4057420	
44250	3891	4107731	1997-04-16	1997-04-16 00:00:00	38000275	0	\N	\N	258763	0	180256009	4107731	
57779	5013	4216130	2013-05-31	2013-05-31 00:00:00	38000275	0	\N	\N	333201	0	415070008	4216130	
47971	4206	4035793	1991-09-30	1991-09-30 00:00:00	38000275	0	\N	\N	279308	0	15081005	4035793	
60051	5194	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	345395	0	180256009	4107731	
48425	4247	4043071	1996-07-11	1996-07-11 00:00:00	38000275	0	\N	\N	282037	0	228557008	4043071	
60561	5232	4058899	1976-07-21	1976-07-21 00:00:00	38000275	0	\N	\N	348066	0	168594001	4058899	
60677	5245	4107731	1991-02-24	1991-02-24 00:00:00	38000275	0	\N	\N	348992	0	180256009	4107731	
60906	5279	4125906	1965-05-17	1965-05-17 00:00:00	38000275	0	\N	\N	351134	0	288086009	4125906	
61057	5284	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	351590	0	180256009	4107731	
49357	4342	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	287965	0	180256009	4107731	
61773	5337	4107731	1992-11-15	1992-11-15 00:00:00	38000275	0	\N	\N	355416	0	180256009	4107731	
50271	4376	4057420	2012-01-03	2012-01-03 00:00:00	38000275	0	\N	\N	290822	0	18286008	4057420	
51489	4460	4195803	2003-07-19	2003-07-19 00:00:00	38000275	0	\N	\N	296741	0	312681000	4195803	
51986	4505	4107731	1993-02-09	1993-02-09 00:00:00	38000275	0	\N	\N	300010	0	180256009	4107731	
52465	4548	4125906	1986-10-07	1986-10-07 00:00:00	38000275	0	\N	\N	303030	0	288086009	4125906	
41113	3604	4107731	1999-08-06	1999-08-06 00:00:00	38000275	0	\N	\N	239534	0	180256009	4107731	
54481	4725	4107731	1990-05-07	1990-05-07 00:00:00	38000275	0	\N	\N	314950	0	180256009	4107731	
55256	4819	4145310	1976-09-22	1976-09-22 00:00:00	38000275	0	\N	\N	320545	0	268425006	4145310	
55510	4837	4078793	2009-11-24	2009-11-24 00:00:00	38000275	0	\N	\N	321833	0	180325003	4078793	
44251	3891	4107731	1997-03-05	1997-03-05 00:00:00	38000275	0	\N	\N	258762	0	180256009	4107731	
57780	5013	4336464	2013-05-31	2013-05-31 00:00:00	38000275	0	\N	\N	333201	0	232717009	4336464	
47972	4206	4035793	1995-09-18	1995-09-18 00:00:00	38000275	0	\N	\N	279310	0	15081005	4035793	
60052	5194	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	345294	0	180256009	4107731	
48426	4247	4043071	1997-06-19	1997-06-19 00:00:00	38000275	0	\N	\N	282114	0	228557008	4043071	
60562	5232	4151422	1983-02-17	1983-02-17 00:00:00	38000275	0	\N	\N	348089	0	269911007	4151422	
60678	5245	4107731	1990-12-23	1990-12-23 00:00:00	38000275	0	\N	\N	348944	0	180256009	4107731	
61058	5284	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	351568	0	180256009	4107731	
49358	4342	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	287906	0	180256009	4107731	
61774	5337	4107731	1992-05-10	1992-05-10 00:00:00	38000275	0	\N	\N	355460	0	180256009	4107731	
50272	4376	4035793	1989-08-29	1989-08-29 00:00:00	38000275	0	\N	\N	290804	0	15081005	4035793	
51490	4460	4170947	2003-07-19	2003-07-19 00:00:00	38000275	0	\N	\N	296741	0	274474001	4170947	
52466	4548	4293740	1986-10-07	1986-10-07 00:00:00	38000275	0	\N	\N	303030	0	384700001	4293740	
41114	3604	4107731	1997-09-12	1997-09-12 00:00:00	38000275	0	\N	\N	239479	0	180256009	4107731	
54482	4725	4107731	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	314963	0	180256009	4107731	
55257	4820	4125906	1966-01-28	1966-01-28 00:00:00	38000275	0	\N	\N	320644	0	288086009	4125906	
55511	4837	4078793	2008-11-18	2008-11-18 00:00:00	38000275	0	\N	\N	321813	0	180325003	4078793	
44252	3891	4107731	1996-01-31	1996-01-31 00:00:00	38000275	0	\N	\N	258632	0	180256009	4107731	
57781	5014	4252419	1943-02-24	1943-02-24 00:00:00	38000275	0	\N	\N	333253	0	74016001	4252419	
47973	4206	4035793	1996-09-23	1996-09-23 00:00:00	38000275	0	\N	\N	279324	0	15081005	4035793	
60053	5194	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	345274	0	180256009	4107731	
48427	4247	4043071	1997-02-13	1997-02-13 00:00:00	38000275	0	\N	\N	282109	0	228557008	4043071	
60563	5232	4163872	2003-07-09	2003-07-09 00:00:00	38000275	0	\N	\N	348098	0	399208008	4163872	
60679	5245	4107731	1992-05-10	1992-05-10 00:00:00	38000275	0	\N	\N	348949	0	180256009	4107731	
61059	5284	4186930	1985-08-21	1985-08-21 00:00:00	38000275	0	\N	\N	351619	0	46706006	4186930	
49359	4342	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	287908	0	180256009	4107731	
61775	5337	4107731	1993-02-28	1993-02-28 00:00:00	38000275	0	\N	\N	355484	0	180256009	4107731	
50273	4376	4078793	1989-08-29	1989-08-29 00:00:00	38000275	0	\N	\N	290804	0	180325003	4078793	
51491	4460	4125906	1961-03-19	1961-03-19 00:00:00	38000275	0	\N	\N	296738	0	288086009	4125906	
52467	4548	4107731	2000-01-11	2000-01-11 00:00:00	38000275	0	\N	\N	303049	0	180256009	4107731	
41115	3604	4107731	1998-12-18	1998-12-18 00:00:00	38000275	0	\N	\N	239532	0	180256009	4107731	
54483	4725	4107731	1990-07-09	1990-07-09 00:00:00	38000275	0	\N	\N	314891	0	180256009	4107731	
55258	4820	4170947	1967-02-13	1967-02-13 00:00:00	38000275	0	\N	\N	320645	0	274474001	4170947	
55512	4837	4078793	2012-12-11	2012-12-11 00:00:00	38000275	0	\N	\N	321801	0	180325003	4078793	
44253	3891	4107731	1996-02-21	1996-02-21 00:00:00	38000275	0	\N	\N	258677	0	180256009	4107731	
57782	5014	4170947	1938-02-20	1938-02-20 00:00:00	38000275	0	\N	\N	333252	0	274474001	4170947	
47974	4206	4035793	1993-09-06	1993-09-06 00:00:00	38000275	0	\N	\N	279309	0	15081005	4035793	
60054	5194	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	345311	0	180256009	4107731	
48428	4247	4043071	1999-01-14	1999-01-14 00:00:00	38000275	0	\N	\N	282015	0	228557008	4043071	
60564	5233	4047491	1980-04-20	1980-04-20 00:00:00	38000275	0	\N	\N	348173	0	1225002	4047491	
60680	5245	4107731	1991-01-13	1991-01-13 00:00:00	38000275	0	\N	\N	348991	0	180256009	4107731	
61060	5284	4043071	1980-12-24	1980-12-24 00:00:00	38000275	0	\N	\N	351583	0	228557008	4043071	
49360	4342	4197460	1993-01-30	1993-01-30 00:00:00	38000275	0	\N	\N	287845	0	313191000	4197460	
61776	5337	4107731	1992-04-19	1992-04-19 00:00:00	38000275	0	\N	\N	355480	0	180256009	4107731	
50274	4376	4078793	1985-08-06	1985-08-06 00:00:00	38000275	0	\N	\N	290835	0	180325003	4078793	
51492	4460	4293740	1961-03-19	1961-03-19 00:00:00	38000275	0	\N	\N	296738	0	384700001	4293740	
52468	4548	4107731	1999-12-21	1999-12-21 00:00:00	38000275	0	\N	\N	302990	0	180256009	4107731	
41116	3604	4107731	1999-06-04	1999-06-04 00:00:00	38000275	0	\N	\N	239455	0	180256009	4107731	
54484	4725	4107731	1991-06-10	1991-06-10 00:00:00	38000275	0	\N	\N	314967	0	180256009	4107731	
55259	4820	4024289	1967-02-13	1967-02-13 00:00:00	38000275	0	\N	\N	320645	0	19490002	4024289	
55513	4837	4078793	2013-12-17	2013-12-17 00:00:00	38000275	0	\N	\N	321835	0	180325003	4078793	
44254	3891	4125906	2007-10-14	2007-10-14 00:00:00	38000275	0	\N	\N	258754	0	288086009	4125906	
57783	5014	4243062	1938-02-20	1938-02-20 00:00:00	38000275	0	\N	\N	333252	0	60027007	4243062	
47975	4208	4058899	1944-11-20	1944-11-20 00:00:00	38000275	0	\N	\N	279425	0	168594001	4058899	
60055	5194	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	345253	0	180256009	4107731	
48429	4247	4043071	2001-01-18	2001-01-18 00:00:00	38000275	0	\N	\N	281997	0	228557008	4043071	
60565	5233	4170947	1980-04-20	1980-04-20 00:00:00	38000275	0	\N	\N	348173	0	274474001	4170947	
60681	5245	4107731	1993-01-17	1993-01-17 00:00:00	38000275	0	\N	\N	349030	0	180256009	4107731	
61061	5284	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	351553	0	180256009	4107731	
49361	4342	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	287954	0	395142003	4191853	
61777	5337	4107731	1992-08-02	1992-08-02 00:00:00	38000275	0	\N	\N	355476	0	180256009	4107731	
50275	4376	4078793	1983-07-26	1983-07-26 00:00:00	38000275	0	\N	\N	290834	0	180325003	4078793	
51499	4462	4035793	2018-04-19	2018-04-19 00:00:00	38000275	0	\N	\N	296926	0	15081005	4035793	
52469	4548	4107731	1997-04-08	1997-04-08 00:00:00	38000275	0	\N	\N	302996	0	180256009	4107731	
41117	3604	4107731	1998-09-25	1998-09-25 00:00:00	38000275	0	\N	\N	239530	0	180256009	4107731	
54485	4725	4191853	1990-01-01	1990-01-01 00:00:00	38000275	0	\N	\N	314890	0	395142003	4191853	
55260	4820	4151422	1982-12-05	1982-12-05 00:00:00	38000275	0	\N	\N	320668	0	269911007	4151422	
55514	4837	4078793	2011-12-06	2011-12-06 00:00:00	38000275	0	\N	\N	321834	0	180325003	4078793	
44255	3891	4107731	1998-07-01	1998-07-01 00:00:00	38000275	0	\N	\N	258708	0	180256009	4107731	
47976	4208	4151422	1943-10-15	1943-10-15 00:00:00	38000275	0	\N	\N	279431	0	269911007	4151422	
60056	5194	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	345260	0	180256009	4107731	
48430	4247	4043071	1998-02-19	1998-02-19 00:00:00	38000275	0	\N	\N	282043	0	228557008	4043071	
60566	5233	4125906	2003-02-17	2003-02-17 00:00:00	38000275	0	\N	\N	348175	0	288086009	4125906	
60682	5245	4107731	1991-09-22	1991-09-22 00:00:00	38000275	0	\N	\N	348947	0	180256009	4107731	
61062	5284	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	351564	0	180256009	4107731	
49362	4342	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	287922	0	180256009	4107731	
61778	5337	4107731	1993-02-07	1993-02-07 00:00:00	38000275	0	\N	\N	355463	0	180256009	4107731	
50276	4376	4293740	2011-10-14	2011-10-14 00:00:00	38000275	0	\N	\N	290736	0	384700001	4293740	
51500	4462	4035793	2012-03-15	2012-03-15 00:00:00	38000275	0	\N	\N	296923	0	15081005	4035793	
52470	4548	4107731	1997-11-25	1997-11-25 00:00:00	38000275	0	\N	\N	303089	0	180256009	4107731	
41118	3604	4107731	1998-01-16	1998-01-16 00:00:00	38000275	0	\N	\N	239541	0	180256009	4107731	
54486	4725	4107731	1991-04-08	1991-04-08 00:00:00	38000275	0	\N	\N	314932	0	180256009	4107731	
55261	4820	4125906	2002-08-08	2002-08-08 00:00:00	38000275	0	\N	\N	320646	0	288086009	4125906	
55515	4837	4078793	2014-12-23	2014-12-23 00:00:00	38000275	0	\N	\N	321802	0	180325003	4078793	
44256	3891	4191853	1999-06-02	1999-06-02 00:00:00	38000275	0	\N	\N	258689	0	395142003	4191853	
47977	4208	4170947	2013-10-04	2013-10-04 00:00:00	38000275	0	\N	\N	279460	0	274474001	4170947	
60057	5194	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	345270	0	180256009	4107731	
48431	4247	4043071	1999-11-04	1999-11-04 00:00:00	38000275	0	\N	\N	282061	0	228557008	4043071	
60567	5234	4198190	1977-08-24	1977-08-24 00:00:00	38000275	0	\N	\N	348231	0	80146002	4198190	
60683	5245	4107731	1992-12-27	1992-12-27 00:00:00	38000275	0	\N	\N	349044	0	180256009	4107731	
61063	5285	4125906	1985-05-08	1985-05-08 00:00:00	38000275	0	\N	\N	351689	0	288086009	4125906	
49363	4342	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	287875	0	180256009	4107731	
61779	5337	4107731	1990-11-11	1990-11-11 00:00:00	38000275	0	\N	\N	355399	0	180256009	4107731	
50277	4376	4125906	2011-10-14	2011-10-14 00:00:00	38000275	0	\N	\N	290736	0	288086009	4125906	
51501	4462	4151422	1997-05-20	1997-05-20 00:00:00	38000275	0	\N	\N	296893	0	269911007	4151422	
52471	4548	4107731	1997-01-14	1997-01-14 00:00:00	38000275	0	\N	\N	303085	0	180256009	4107731	
41119	3604	4107731	2000-09-08	2000-09-08 00:00:00	38000275	0	\N	\N	239501	0	180256009	4107731	
54487	4725	4107731	1993-05-03	1993-05-03 00:00:00	38000275	0	\N	\N	314879	0	180256009	4107731	
55263	4822	4125906	1966-08-20	1966-08-20 00:00:00	38000275	0	\N	\N	320724	0	288086009	4125906	
55516	4837	4125906	1964-02-15	1964-02-15 00:00:00	38000275	0	\N	\N	321817	0	288086009	4125906	
44257	3891	4058899	1986-11-03	1986-11-03 00:00:00	38000275	0	\N	\N	258751	0	168594001	4058899	
47978	4208	4125906	1972-10-08	1972-10-08 00:00:00	38000275	0	\N	\N	279427	0	288086009	4125906	
60058	5194	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	345367	0	180256009	4107731	
48432	4247	4043071	1996-05-16	1996-05-16 00:00:00	38000275	0	\N	\N	282106	0	228557008	4043071	
60568	5234	4125906	1965-09-05	1965-09-05 00:00:00	38000275	0	\N	\N	348230	0	288086009	4125906	
60684	5245	4107731	1992-10-25	1992-10-25 00:00:00	38000275	0	\N	\N	349025	0	180256009	4107731	
61064	5285	4151422	2009-09-03	2009-09-03 00:00:00	38000275	0	\N	\N	351663	0	269911007	4151422	
49364	4342	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	287921	0	180256009	4107731	
61780	5337	4107731	1990-03-04	1990-03-04 00:00:00	38000275	0	\N	\N	355403	0	180256009	4107731	
50278	4376	4035793	2016-01-26	2016-01-26 00:00:00	38000275	0	\N	\N	290708	0	15081005	4035793	
51502	4462	4035793	2016-04-07	2016-04-07 00:00:00	38000275	0	\N	\N	296925	0	15081005	4035793	
52472	4548	4107731	1999-09-28	1999-09-28 00:00:00	38000275	0	\N	\N	302988	0	180256009	4107731	
41120	3604	4107731	2000-05-26	2000-05-26 00:00:00	38000275	0	\N	\N	239561	0	180256009	4107731	
54488	4725	4107731	1992-03-30	1992-03-30 00:00:00	38000275	0	\N	\N	314922	0	180256009	4107731	
55264	4822	4187458	1993-09-12	1993-09-12 00:00:00	38000275	0	\N	\N	320747	0	415300000	4187458	
55517	4837	4078793	2018-01-09	2018-01-09 00:00:00	38000275	0	\N	\N	321815	0	180325003	4078793	
44258	3891	4062501	1984-11-30	1984-11-30 00:00:00	38000275	0	\N	\N	258627	0	171231001	4062501	
47979	4208	40492359	1981-04-07	1981-04-07 00:00:00	38000275	0	\N	\N	279428	0	447365002	40492359	
60059	5194	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	345316	0	180256009	4107731	
48433	4247	4043071	2000-06-15	2000-06-15 00:00:00	38000275	0	\N	\N	282055	0	228557008	4043071	
60569	5234	4293740	1965-09-05	1965-09-05 00:00:00	38000275	0	\N	\N	348230	0	384700001	4293740	
60685	5245	4107731	1990-03-25	1990-03-25 00:00:00	38000275	0	\N	\N	348941	0	180256009	4107731	
61065	5285	4336464	2008-07-06	2008-07-06 00:00:00	38000275	0	\N	\N	351690	0	232717009	4336464	
49365	4342	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	287912	0	180256009	4107731	
61781	5337	4107731	1990-12-02	1990-12-02 00:00:00	38000275	0	\N	\N	355406	0	180256009	4107731	
50279	4376	4078793	2016-01-26	2016-01-26 00:00:00	38000275	0	\N	\N	290708	0	180325003	4078793	
51503	4462	4035793	2017-04-13	2017-04-13 00:00:00	38000275	0	\N	\N	296875	0	15081005	4035793	
52473	4548	4107731	1997-04-29	1997-04-29 00:00:00	38000275	0	\N	\N	303018	0	180256009	4107731	
41121	3604	4107731	2000-04-14	2000-04-14 00:00:00	38000275	0	\N	\N	239550	0	180256009	4107731	
54489	4725	4107731	1993-02-08	1993-02-08 00:00:00	38000275	0	\N	\N	314940	0	180256009	4107731	
55265	4822	4037675	1993-09-12	1993-09-12 00:00:00	38000275	0	\N	\N	320747	0	162676008	4037675	
55518	4837	4078793	2017-01-03	2017-01-03 00:00:00	38000275	0	\N	\N	321831	0	180325003	4078793	
44259	3891	4107731	1998-02-25	1998-02-25 00:00:00	38000275	0	\N	\N	258685	0	180256009	4107731	
47980	4208	4057420	1981-04-07	1981-04-07 00:00:00	38000275	0	\N	\N	279428	0	18286008	4057420	
60060	5194	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	345257	0	180256009	4107731	
60217	5206	4151422	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	346292	0	269911007	4151422	
60570	5234	4151422	1995-04-02	1995-04-02 00:00:00	38000275	0	\N	\N	348286	0	269911007	4151422	
60686	5245	4107731	1992-02-16	1992-02-16 00:00:00	38000275	0	\N	\N	349040	0	180256009	4107731	
61066	5285	4216130	2008-07-06	2008-07-06 00:00:00	38000275	0	\N	\N	351690	0	415070008	4216130	
49366	4342	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	287887	0	180256009	4107731	
61782	5337	4107731	1990-09-30	1990-09-30 00:00:00	38000275	0	\N	\N	355398	0	180256009	4107731	
50280	4376	4035793	2003-11-18	2003-11-18 00:00:00	38000275	0	\N	\N	290837	0	15081005	4035793	
51504	4462	4035793	2011-03-10	2011-03-10 00:00:00	38000275	0	\N	\N	296909	0	15081005	4035793	
52474	4548	4107731	1998-02-17	1998-02-17 00:00:00	38000275	0	\N	\N	303001	0	180256009	4107731	
41122	3604	4107731	1999-03-12	1999-03-12 00:00:00	38000275	0	\N	\N	239453	0	180256009	4107731	
54490	4725	4191853	1993-07-05	1993-07-05 00:00:00	38000275	0	\N	\N	314894	0	395142003	4191853	
55266	4822	4326177	1993-09-12	1993-09-12 00:00:00	38000275	0	\N	\N	320747	0	430193006	4326177	
44260	3891	4107731	1998-09-23	1998-09-23 00:00:00	38000275	0	\N	\N	258638	0	180256009	4107731	
47981	4208	4024289	2013-10-04	2013-10-04 00:00:00	38000275	0	\N	\N	279460	0	19490002	4024289	
60061	5194	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	345248	0	180256009	4107731	
60218	5207	4151422	2001-07-21	2001-07-21 00:00:00	38000275	0	\N	\N	346349	0	269911007	4151422	
60571	5234	4125906	1993-08-28	1993-08-28 00:00:00	38000275	0	\N	\N	348215	0	288086009	4125906	
60687	5245	4107731	1990-05-27	1990-05-27 00:00:00	38000275	0	\N	\N	348989	0	180256009	4107731	
61129	5290	4107731	1991-09-27	1991-09-27 00:00:00	38000275	0	\N	\N	351934	0	180256009	4107731	
49367	4342	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	287969	0	180256009	4107731	
61783	5337	4107731	1992-03-08	1992-03-08 00:00:00	38000275	0	\N	\N	355479	0	180256009	4107731	
50281	4376	4078793	2003-11-18	2003-11-18 00:00:00	38000275	0	\N	\N	290837	0	180325003	4078793	
51505	4462	4323902	2010-05-13	2010-05-13 00:00:00	38000275	0	\N	\N	296902	0	429609002	4323902	
52475	4548	4107731	2000-04-04	2000-04-04 00:00:00	38000275	0	\N	\N	303051	0	180256009	4107731	
41123	3604	4107731	1998-07-03	1998-07-03 00:00:00	38000275	0	\N	\N	239518	0	180256009	4107731	
54491	4725	4107731	1992-03-09	1992-03-09 00:00:00	38000275	0	\N	\N	314970	0	180256009	4107731	
55267	4822	4125906	1951-08-04	1951-08-04 00:00:00	38000275	0	\N	\N	320722	0	288086009	4125906	
44261	3891	4107731	1998-07-22	1998-07-22 00:00:00	38000275	0	\N	\N	258743	0	180256009	4107731	
47982	4208	4195803	2013-10-04	2013-10-04 00:00:00	38000275	0	\N	\N	279460	0	312681000	4195803	
60062	5194	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	345266	0	180256009	4107731	
60219	5207	4170947	1960-05-19	1960-05-19 00:00:00	38000275	0	\N	\N	346374	0	274474001	4170947	
60572	5234	4252419	1953-02-05	1953-02-05 00:00:00	38000275	0	\N	\N	348227	0	74016001	4252419	
60688	5245	4107731	1990-08-19	1990-08-19 00:00:00	38000275	0	\N	\N	348963	0	180256009	4107731	
61130	5290	4107731	1993-03-05	1993-03-05 00:00:00	38000275	0	\N	\N	351994	0	180256009	4107731	
49368	4342	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	287930	0	180256009	4107731	
61784	5337	4107731	1993-05-02	1993-05-02 00:00:00	38000275	0	\N	\N	355432	0	180256009	4107731	
50282	4376	4057420	1984-07-31	1984-07-31 00:00:00	38000275	0	\N	\N	290703	0	18286008	4057420	
51506	4462	4035793	2014-03-27	2014-03-27 00:00:00	38000275	0	\N	\N	296924	0	15081005	4035793	
52476	4548	4107731	1997-07-01	1997-07-01 00:00:00	38000275	0	\N	\N	302998	0	180256009	4107731	
41124	3604	4107731	1998-07-24	1998-07-24 00:00:00	38000275	0	\N	\N	239451	0	180256009	4107731	
54492	4725	4107731	1993-03-01	1993-03-01 00:00:00	38000275	0	\N	\N	314975	0	180256009	4107731	
55268	4822	4125906	1967-08-29	1967-08-29 00:00:00	38000275	0	\N	\N	320726	0	288086009	4125906	
44262	3891	4107731	1999-01-27	1999-01-27 00:00:00	38000275	0	\N	\N	258744	0	180256009	4107731	
47984	4210	4151422	2014-02-24	2014-02-24 00:00:00	38000275	0	\N	\N	279565	0	269911007	4151422	
60063	5194	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	345372	0	180256009	4107731	
60220	5207	4243062	1960-05-19	1960-05-19 00:00:00	38000275	0	\N	\N	346374	0	60027007	4243062	
60573	5234	4195803	1989-07-20	1989-07-20 00:00:00	38000275	0	\N	\N	348214	0	312681000	4195803	
60689	5245	4107731	1993-02-28	1993-02-28 00:00:00	38000275	0	\N	\N	349031	0	180256009	4107731	
61131	5290	4191853	1990-01-05	1990-01-05 00:00:00	38000275	0	\N	\N	351927	0	395142003	4191853	
61150	5290	4107731	1991-08-16	1991-08-16 00:00:00	38000275	0	\N	\N	351933	0	180256009	4107731	
61785	5337	4107731	1991-02-24	1991-02-24 00:00:00	38000275	0	\N	\N	355408	0	180256009	4107731	
50283	4376	4202451	1985-03-19	1985-03-19 00:00:00	38000275	0	\N	\N	290703	0	433112001	4202451	
51507	4462	4035793	2015-04-02	2015-04-02 00:00:00	38000275	0	\N	\N	296874	0	15081005	4035793	
52477	4548	4107731	1997-05-20	1997-05-20 00:00:00	38000275	0	\N	\N	302997	0	180256009	4107731	
41125	3604	4107731	1997-05-30	1997-05-30 00:00:00	38000275	0	\N	\N	239527	0	180256009	4107731	
54493	4725	4107731	1992-08-03	1992-08-03 00:00:00	38000275	0	\N	\N	314959	0	180256009	4107731	
55292	4826	4107731	1991-09-28	1991-09-28 00:00:00	38000275	0	\N	\N	321055	0	180256009	4107731	
44263	3891	4107731	1997-10-22	1997-10-22 00:00:00	38000275	0	\N	\N	258764	0	180256009	4107731	
47985	4210	4024289	1984-12-18	1984-12-18 00:00:00	38000275	0	\N	\N	279577	0	19490002	4024289	
60064	5194	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	345315	0	180256009	4107731	
60221	5210	4125906	2009-03-04	2009-03-04 00:00:00	38000275	0	\N	\N	346449	0	288086009	4125906	
60574	5234	4170947	1989-07-20	1989-07-20 00:00:00	38000275	0	\N	\N	348214	0	274474001	4170947	
60690	5245	4107731	1991-09-01	1991-09-01 00:00:00	38000275	0	\N	\N	348974	0	180256009	4107731	
61132	5290	4107731	1992-10-30	1992-10-30 00:00:00	38000275	0	\N	\N	351986	0	180256009	4107731	
61151	5290	4107731	1990-03-09	1990-03-09 00:00:00	38000275	0	\N	\N	351914	0	180256009	4107731	
61786	5337	4107731	1991-02-03	1991-02-03 00:00:00	38000275	0	\N	\N	355470	0	180256009	4107731	
50284	4376	4078793	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	290801	0	180325003	4078793	
51508	4462	4035793	2013-03-21	2013-03-21 00:00:00	38000275	0	\N	\N	296873	0	15081005	4035793	
52478	4548	4107731	1999-06-15	1999-06-15 00:00:00	38000275	0	\N	\N	303037	0	180256009	4107731	
41126	3604	4107731	1997-07-11	1997-07-11 00:00:00	38000275	0	\N	\N	239513	0	180256009	4107731	
54494	4725	4107731	1991-02-25	1991-02-25 00:00:00	38000275	0	\N	\N	314931	0	180256009	4107731	
55293	4826	4107731	1992-12-12	1992-12-12 00:00:00	38000275	0	\N	\N	320960	0	180256009	4107731	
44264	3891	4107731	1996-03-13	1996-03-13 00:00:00	38000275	0	\N	\N	258756	0	180256009	4107731	
47986	4210	4170947	1984-12-18	1984-12-18 00:00:00	38000275	0	\N	\N	279577	0	274474001	4170947	
60065	5194	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	345324	0	180256009	4107731	
60222	5210	4125906	1996-09-26	1996-09-26 00:00:00	38000275	0	\N	\N	346447	0	288086009	4125906	
60575	5234	4163872	1989-07-20	1989-07-20 00:00:00	38000275	0	\N	\N	348214	0	399208008	4163872	
60691	5245	4107731	1991-04-07	1991-04-07 00:00:00	38000275	0	\N	\N	348993	0	180256009	4107731	
61133	5290	4107731	1992-08-28	1992-08-28 00:00:00	38000275	0	\N	\N	351993	0	180256009	4107731	
61152	5290	4107731	1990-03-30	1990-03-30 00:00:00	38000275	0	\N	\N	351929	0	180256009	4107731	
61787	5337	4107731	1992-07-12	1992-07-12 00:00:00	38000275	0	\N	\N	355413	0	180256009	4107731	
50285	4376	4035793	1992-09-15	1992-09-15 00:00:00	38000275	0	\N	\N	290801	0	15081005	4035793	
51509	4462	4035793	2009-02-26	2009-02-26 00:00:00	38000275	0	\N	\N	296908	0	15081005	4035793	
52479	4548	4107731	2000-03-14	2000-03-14 00:00:00	38000275	0	\N	\N	303040	0	180256009	4107731	
41127	3604	4107731	1999-10-29	1999-10-29 00:00:00	38000275	0	\N	\N	239536	0	180256009	4107731	
54495	4725	4107731	1992-01-06	1992-01-06 00:00:00	38000275	0	\N	\N	314935	0	180256009	4107731	
55294	4826	4107731	1993-03-06	1993-03-06 00:00:00	38000275	0	\N	\N	320962	0	180256009	4107731	
44265	3891	4107731	1996-05-15	1996-05-15 00:00:00	38000275	0	\N	\N	258665	0	180256009	4107731	
47987	4210	4151422	1991-04-13	1991-04-13 00:00:00	38000275	0	\N	\N	279520	0	269911007	4151422	
60066	5194	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	345246	0	180256009	4107731	
60223	5210	4151422	1981-05-20	1981-05-20 00:00:00	38000275	0	\N	\N	346458	0	269911007	4151422	
60576	5234	4293740	1960-09-26	1960-09-26 00:00:00	38000275	0	\N	\N	348228	0	384700001	4293740	
60692	5245	4107731	1991-06-30	1991-06-30 00:00:00	38000275	0	\N	\N	348945	0	180256009	4107731	
61134	5290	4107731	1992-04-24	1992-04-24 00:00:00	38000275	0	\N	\N	351985	0	180256009	4107731	
61153	5290	4107731	1992-06-26	1992-06-26 00:00:00	38000275	0	\N	\N	351947	0	180256009	4107731	
50286	4376	4078793	2002-11-12	2002-11-12 00:00:00	38000275	0	\N	\N	290705	0	180325003	4078793	
51510	4462	4151422	1978-09-02	1978-09-02 00:00:00	38000275	0	\N	\N	296914	0	269911007	4151422	
52480	4548	4107731	1997-10-14	1997-10-14 00:00:00	38000275	0	\N	\N	303088	0	180256009	4107731	
41128	3604	4107731	2000-07-07	2000-07-07 00:00:00	38000275	0	\N	\N	239562	0	180256009	4107731	
54496	4725	4107731	1991-07-01	1991-07-01 00:00:00	38000275	0	\N	\N	314875	0	180256009	4107731	
55295	4826	4107731	1990-12-08	1990-12-08 00:00:00	38000275	0	\N	\N	321073	0	180256009	4107731	
44266	3891	4107731	1997-11-12	1997-11-12 00:00:00	38000275	0	\N	\N	258671	0	180256009	4107731	
47988	4210	4125906	2017-07-17	2017-07-17 00:00:00	38000275	0	\N	\N	279552	0	288086009	4125906	
60067	5194	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	345320	0	395142003	4191853	
60224	5210	4125906	2000-05-29	2000-05-29 00:00:00	38000275	0	\N	\N	346448	0	288086009	4125906	
60577	5234	4125906	1960-09-26	1960-09-26 00:00:00	38000275	0	\N	\N	348228	0	288086009	4125906	
60693	5245	4107731	1993-03-21	1993-03-21 00:00:00	38000275	0	\N	\N	349006	0	180256009	4107731	
61135	5290	4197460	1955-01-30	1955-01-30 00:00:00	38000275	0	\N	\N	352029	0	313191000	4197460	
61154	5290	4170947	1954-11-01	1954-11-01 00:00:00	38000275	0	\N	\N	352028	0	274474001	4170947	
50287	4376	4035793	2002-11-12	2002-11-12 00:00:00	38000275	0	\N	\N	290705	0	15081005	4035793	
51511	4462	4035793	2010-03-04	2010-03-04 00:00:00	38000275	0	\N	\N	296881	0	15081005	4035793	
52484	4550	4107731	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	303198	0	180256009	4107731	
41129	3604	4107731	1997-11-14	1997-11-14 00:00:00	38000275	0	\N	\N	239522	0	180256009	4107731	
54497	4725	4107731	1990-02-12	1990-02-12 00:00:00	38000275	0	\N	\N	314870	0	180256009	4107731	
55296	4826	4107731	1992-04-04	1992-04-04 00:00:00	38000275	0	\N	\N	320942	0	180256009	4107731	
44267	3891	4107731	1997-07-30	1997-07-30 00:00:00	38000275	0	\N	\N	258737	0	180256009	4107731	
47990	4212	4170947	1981-01-31	1981-01-31 00:00:00	38000275	0	\N	\N	279650	0	274474001	4170947	
60068	5194	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	345396	0	180256009	4107731	
60297	5213	4151422	1984-03-24	1984-03-24 00:00:00	38000275	0	\N	\N	346708	0	269911007	4151422	
60578	5234	4151422	1949-02-28	1949-02-28 00:00:00	38000275	0	\N	\N	348219	0	269911007	4151422	
60694	5245	4107731	1992-12-06	1992-12-06 00:00:00	38000275	0	\N	\N	348975	0	180256009	4107731	
61136	5290	4107731	1990-08-24	1990-08-24 00:00:00	38000275	0	\N	\N	351959	0	180256009	4107731	
61155	5290	4243062	1954-11-01	1954-11-01 00:00:00	38000275	0	\N	\N	352028	0	60027007	4243062	
50288	4376	4035793	2005-11-29	2005-11-29 00:00:00	38000275	0	\N	\N	290838	0	15081005	4035793	
51512	4462	4035793	2008-02-21	2008-02-21 00:00:00	38000275	0	\N	\N	296880	0	15081005	4035793	
52485	4550	4107731	1991-09-29	1991-09-29 00:00:00	38000275	0	\N	\N	303250	0	180256009	4107731	
41130	3604	4107731	1999-11-19	1999-11-19 00:00:00	38000275	0	\N	\N	239491	0	180256009	4107731	
54498	4725	4107731	1991-03-18	1991-03-18 00:00:00	38000275	0	\N	\N	314954	0	180256009	4107731	
55297	4826	4107731	1992-08-08	1992-08-08 00:00:00	38000275	0	\N	\N	321059	0	180256009	4107731	
44268	3891	4107731	1997-05-07	1997-05-07 00:00:00	38000275	0	\N	\N	258670	0	180256009	4107731	
47991	4212	4163872	1981-01-31	1981-01-31 00:00:00	38000275	0	\N	\N	279650	0	399208008	4163872	
60069	5194	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	345322	0	180256009	4107731	
60298	5213	4125906	1975-03-04	1975-03-04 00:00:00	38000275	0	\N	\N	346773	0	288086009	4125906	
60579	5234	4125906	1962-09-30	1962-09-30 00:00:00	38000275	0	\N	\N	348229	0	288086009	4125906	
60699	5249	4202451	2004-04-25	2004-04-25 00:00:00	38000275	0	\N	\N	349230	0	433112001	4202451	
61137	5290	4107731	1991-05-24	1991-05-24 00:00:00	38000275	0	\N	\N	351962	0	180256009	4107731	
61156	5290	4107731	1990-06-22	1990-06-22 00:00:00	38000275	0	\N	\N	351898	0	180256009	4107731	
50289	4376	4078793	2005-11-29	2005-11-29 00:00:00	38000275	0	\N	\N	290838	0	180325003	4078793	
51523	4465	4170947	1987-05-04	1987-05-04 00:00:00	38000275	0	\N	\N	297076	0	274474001	4170947	
52486	4550	4107731	1992-01-12	1992-01-12 00:00:00	38000275	0	\N	\N	303165	0	180256009	4107731	
41131	3604	4107731	1998-10-16	1998-10-16 00:00:00	38000275	0	\N	\N	239544	0	180256009	4107731	
54499	4725	4107731	1990-10-01	1990-10-01 00:00:00	38000275	0	\N	\N	314872	0	180256009	4107731	
55298	4826	4107731	1991-07-27	1991-07-27 00:00:00	38000275	0	\N	\N	320970	0	180256009	4107731	
44269	3891	4107731	1997-05-28	1997-05-28 00:00:00	38000275	0	\N	\N	258747	0	180256009	4107731	
47992	4212	4243062	1984-01-14	1984-01-14 00:00:00	38000275	0	\N	\N	279652	0	60027007	4243062	
60070	5194	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	345327	0	180256009	4107731	
60299	5213	4151422	2003-11-11	2003-11-11 00:00:00	38000275	0	\N	\N	346741	0	269911007	4151422	
60580	5235	4293740	1954-01-15	1954-01-15 00:00:00	38000275	0	\N	\N	348365	0	384700001	4293740	
60700	5249	4010253	1954-12-17	1954-12-17 00:00:00	38000275	0	\N	\N	349192	0	112790001	4010253	
61138	5290	4107731	1991-07-26	1991-07-26 00:00:00	38000275	0	\N	\N	351909	0	180256009	4107731	
61157	5290	4107731	1991-11-29	1991-11-29 00:00:00	38000275	0	\N	\N	351990	0	180256009	4107731	
50290	4376	4252419	1999-06-12	1999-06-12 00:00:00	38000275	0	\N	\N	290734	0	74016001	4252419	
51524	4465	4024289	1987-05-04	1987-05-04 00:00:00	38000275	0	\N	\N	297076	0	19490002	4024289	
52487	4550	4107731	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	303280	0	180256009	4107731	
41132	3604	4107731	1999-04-02	1999-04-02 00:00:00	38000275	0	\N	\N	239489	0	180256009	4107731	
54500	4725	4107731	1993-03-22	1993-03-22 00:00:00	38000275	0	\N	\N	314941	0	180256009	4107731	
55299	4826	4107731	1991-12-21	1991-12-21 00:00:00	38000275	0	\N	\N	321057	0	180256009	4107731	
44270	3891	4107731	1998-09-02	1998-09-02 00:00:00	38000275	0	\N	\N	258686	0	180256009	4107731	
47993	4212	4170947	1984-01-14	1984-01-14 00:00:00	38000275	0	\N	\N	279652	0	274474001	4170947	
60071	5194	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	345268	0	180256009	4107731	
60300	5213	4326177	2018-05-27	2018-05-27 00:00:00	38000275	0	\N	\N	346744	0	430193006	4326177	
60581	5235	4125906	1954-01-15	1954-01-15 00:00:00	38000275	0	\N	\N	348365	0	288086009	4125906	
60701	5249	4170947	1951-08-21	1951-08-21 00:00:00	38000275	0	\N	\N	349244	0	274474001	4170947	
61139	5290	4191853	1993-07-09	1993-07-09 00:00:00	38000275	0	\N	\N	351997	0	395142003	4191853	
61158	5290	4107731	1990-04-20	1990-04-20 00:00:00	38000275	0	\N	\N	351956	0	180256009	4107731	
50291	4376	4078793	1982-07-20	1982-07-20 00:00:00	38000275	0	\N	\N	290702	0	180325003	4078793	
51525	4465	4151422	1986-09-17	1986-09-17 00:00:00	38000275	0	\N	\N	297039	0	269911007	4151422	
52488	4550	4107731	1991-03-03	1991-03-03 00:00:00	38000275	0	\N	\N	303232	0	180256009	4107731	
41133	3604	4107731	2000-10-20	2000-10-20 00:00:00	38000275	0	\N	\N	239502	0	180256009	4107731	
54501	4725	4107731	1990-12-03	1990-12-03 00:00:00	38000275	0	\N	\N	314914	0	180256009	4107731	
55300	4826	4191853	1990-01-06	1990-01-06 00:00:00	38000275	0	\N	\N	320923	0	395142003	4191853	
44271	3891	4191853	1995-11-29	1995-11-29 00:00:00	38000275	0	\N	\N	258675	0	395142003	4191853	
48031	4217	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	279943	0	180256009	4107731	
60072	5194	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	345326	0	180256009	4107731	
60301	5213	4187458	2018-05-27	2018-05-27 00:00:00	38000275	0	\N	\N	346744	0	415300000	4187458	
60582	5235	4078793	1981-12-12	1981-12-12 00:00:00	38000275	0	\N	\N	348373	0	180325003	4078793	
60702	5249	4024289	1951-08-21	1951-08-21 00:00:00	38000275	0	\N	\N	349244	0	19490002	4024289	
61140	5290	4107731	1993-05-07	1993-05-07 00:00:00	38000275	0	\N	\N	351951	0	180256009	4107731	
61159	5290	4107731	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	351963	0	180256009	4107731	
50292	4376	4078793	2007-12-11	2007-12-11 00:00:00	38000275	0	\N	\N	290820	0	180325003	4078793	
51526	4466	4125906	2016-09-04	2016-09-04 00:00:00	38000275	0	\N	\N	297159	0	288086009	4125906	
52489	4550	4107731	1992-08-09	1992-08-09 00:00:00	38000275	0	\N	\N	303254	0	180256009	4107731	
41134	3604	4107731	1999-04-23	1999-04-23 00:00:00	38000275	0	\N	\N	239454	0	180256009	4107731	
54502	4725	4107731	1992-09-14	1992-09-14 00:00:00	38000275	0	\N	\N	314877	0	180256009	4107731	
55301	4826	4107731	1992-04-25	1992-04-25 00:00:00	38000275	0	\N	\N	320973	0	180256009	4107731	
44272	3891	4107731	1996-06-26	1996-06-26 00:00:00	38000275	0	\N	\N	258666	0	180256009	4107731	
48032	4217	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	280023	0	180256009	4107731	
60073	5194	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	345272	0	180256009	4107731	
60302	5213	4037675	2018-05-27	2018-05-27 00:00:00	38000275	0	\N	\N	346744	0	162676008	4037675	
60583	5235	4125906	1930-04-07	1930-04-07 00:00:00	38000275	0	\N	\N	348364	0	288086009	4125906	
60703	5249	4010253	1981-11-29	1981-11-29 00:00:00	38000275	0	\N	\N	349184	0	112790001	4010253	
61141	5290	4107731	1991-12-20	1991-12-20 00:00:00	38000275	0	\N	\N	351982	0	180256009	4107731	
61160	5290	4107731	1990-01-26	1990-01-26 00:00:00	38000275	0	\N	\N	351913	0	180256009	4107731	
50293	4376	4035793	2007-12-11	2007-12-11 00:00:00	38000275	0	\N	\N	290820	0	15081005	4035793	
51527	4467	4151422	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	297185	0	269911007	4151422	
52490	4550	4107731	1992-04-26	1992-04-26 00:00:00	38000275	0	\N	\N	303199	0	180256009	4107731	
41135	3604	4107731	1999-05-14	1999-05-14 00:00:00	38000275	0	\N	\N	239490	0	180256009	4107731	
54503	4725	4107731	1991-09-02	1991-09-02 00:00:00	38000275	0	\N	\N	314969	0	180256009	4107731	
55302	4826	4293740	2002-11-22	2002-11-22 00:00:00	38000275	0	\N	\N	320987	0	384700001	4293740	
44273	3891	4191853	1983-11-05	1983-11-05 00:00:00	38000275	0	\N	\N	258719	0	395142003	4191853	
48033	4217	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	279941	0	180256009	4107731	
60074	5194	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	345394	0	180256009	4107731	
60308	5215	4195803	2004-03-30	2004-03-30 00:00:00	38000275	0	\N	\N	346922	0	312681000	4195803	
60584	5235	4336464	1982-01-23	1982-01-23 00:00:00	38000275	0	\N	\N	348320	0	232717009	4336464	
60704	5249	4163872	2007-12-03	2007-12-03 00:00:00	38000275	0	\N	\N	349186	0	399208008	4163872	
61142	5290	4107731	1992-09-18	1992-09-18 00:00:00	38000275	0	\N	\N	351949	0	180256009	4107731	
61161	5290	4107731	1992-10-09	1992-10-09 00:00:00	38000275	0	\N	\N	351936	0	180256009	4107731	
50294	4376	4078793	1999-10-26	1999-10-26 00:00:00	38000275	0	\N	\N	290779	0	180325003	4078793	
51528	4467	4125906	2016-01-10	2016-01-10 00:00:00	38000275	0	\N	\N	297166	0	288086009	4125906	
52491	4550	4107731	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	303228	0	180256009	4107731	
41136	3604	4107731	2000-03-24	2000-03-24 00:00:00	38000275	0	\N	\N	239494	0	180256009	4107731	
54504	4725	4107731	1992-12-28	1992-12-28 00:00:00	38000275	0	\N	\N	314925	0	180256009	4107731	
55303	4826	4125906	2002-11-22	2002-11-22 00:00:00	38000275	0	\N	\N	320987	0	288086009	4125906	
44274	3891	4170947	1984-09-14	1984-09-14 00:00:00	38000275	0	\N	\N	258716	0	274474001	4170947	
48034	4217	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	279990	0	180256009	4107731	
60075	5194	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	345265	0	180256009	4107731	
60309	5215	4058899	2004-03-30	2004-03-30 00:00:00	38000275	0	\N	\N	346922	0	168594001	4058899	
60585	5235	4216130	1982-01-23	1982-01-23 00:00:00	38000275	0	\N	\N	348320	0	415070008	4216130	
60705	5249	4125906	1966-05-25	1966-05-25 00:00:00	38000275	0	\N	\N	349246	0	288086009	4125906	
61143	5290	4107731	1990-09-14	1990-09-14 00:00:00	38000275	0	\N	\N	351905	0	180256009	4107731	
61162	5290	4107731	1991-03-01	1991-03-01 00:00:00	38000275	0	\N	\N	351960	0	180256009	4107731	
50295	4376	4035793	1999-10-26	1999-10-26 00:00:00	38000275	0	\N	\N	290779	0	15081005	4035793	
51529	4467	4125906	1956-05-02	1956-05-02 00:00:00	38000275	0	\N	\N	297160	0	288086009	4125906	
52492	4550	4107731	1992-11-01	1992-11-01 00:00:00	38000275	0	\N	\N	303266	0	180256009	4107731	
41137	3604	4163872	2000-05-06	2000-05-06 00:00:00	38000275	0	\N	\N	239459	0	399208008	4163872	
54505	4725	4107731	1991-02-04	1991-02-04 00:00:00	38000275	0	\N	\N	314953	0	180256009	4107731	
55304	4826	4107731	1991-05-04	1991-05-04 00:00:00	38000275	0	\N	\N	320968	0	180256009	4107731	
44275	3891	4024289	1984-09-14	1984-09-14 00:00:00	38000275	0	\N	\N	258716	0	19490002	4024289	
48035	4217	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	279951	0	180256009	4107731	
60076	5194	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	345256	0	180256009	4107731	
60310	5215	4125906	1973-10-17	1973-10-17 00:00:00	38000275	0	\N	\N	346839	0	288086009	4125906	
60586	5235	4125906	1967-07-20	1967-07-20 00:00:00	38000275	0	\N	\N	348366	0	288086009	4125906	
60706	5249	4293740	1966-05-25	1966-05-25 00:00:00	38000275	0	\N	\N	349246	0	384700001	4293740	
61144	5290	4107731	1992-11-20	1992-11-20 00:00:00	38000275	0	\N	\N	351938	0	180256009	4107731	
61163	5290	4107731	1992-12-11	1992-12-11 00:00:00	38000275	0	\N	\N	351987	0	180256009	4107731	
50296	4376	4035793	2004-11-23	2004-11-23 00:00:00	38000275	0	\N	\N	290706	0	15081005	4035793	
51535	4470	4163872	2007-04-24	2007-04-24 00:00:00	38000275	0	\N	\N	297392	0	399208008	4163872	
52493	4550	4107731	1990-10-07	1990-10-07 00:00:00	38000275	0	\N	\N	303220	0	180256009	4107731	
41138	3604	4107731	2000-09-29	2000-09-29 00:00:00	38000275	0	\N	\N	239495	0	180256009	4107731	
54506	4725	4107731	1993-01-18	1993-01-18 00:00:00	38000275	0	\N	\N	314974	0	180256009	4107731	
55305	4826	4107731	1990-05-12	1990-05-12 00:00:00	38000275	0	\N	\N	321065	0	180256009	4107731	
44276	3891	4107731	1998-04-08	1998-04-08 00:00:00	38000275	0	\N	\N	258682	0	180256009	4107731	
48036	4217	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	279922	0	180256009	4107731	
60077	5194	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	345314	0	180256009	4107731	
60311	5215	4170947	1941-04-08	1941-04-08 00:00:00	38000275	0	\N	\N	346836	0	274474001	4170947	
60587	5235	4293740	1967-07-20	1967-07-20 00:00:00	38000275	0	\N	\N	348366	0	384700001	4293740	
60711	5251	4181917	1922-02-27	1922-02-27 00:00:00	38000275	0	\N	\N	349386	0	54550000	4181917	
61145	5290	4107731	1992-07-17	1992-07-17 00:00:00	38000275	0	\N	\N	351992	0	180256009	4107731	
61164	5290	4107731	1990-07-13	1990-07-13 00:00:00	38000275	0	\N	\N	351958	0	180256009	4107731	
50297	4376	4078793	2004-11-23	2004-11-23 00:00:00	38000275	0	\N	\N	290706	0	180325003	4078793	
51536	4470	4198190	2010-12-31	2010-12-31 00:00:00	38000275	0	\N	\N	297389	0	80146002	4198190	
52494	4550	4107731	1991-12-22	1991-12-22 00:00:00	38000275	0	\N	\N	303196	0	180256009	4107731	
41139	3604	4107731	1997-08-01	1997-08-01 00:00:00	38000275	0	\N	\N	239478	0	180256009	4107731	
54507	4725	4191853	1976-10-20	1976-10-20 00:00:00	38000275	0	\N	\N	314867	0	395142003	4191853	
55306	4826	4107731	1991-11-30	1991-11-30 00:00:00	38000275	0	\N	\N	320947	0	180256009	4107731	
44277	3891	4107731	1996-06-05	1996-06-05 00:00:00	38000275	0	\N	\N	258759	0	180256009	4107731	
48037	4217	4151422	1976-06-11	1976-06-11 00:00:00	38000275	0	\N	\N	279975	0	269911007	4151422	
60078	5194	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	345317	0	180256009	4107731	
60312	5215	4163872	1941-04-08	1941-04-08 00:00:00	38000275	0	\N	\N	346836	0	399208008	4163872	
60588	5236	4043071	1984-10-02	1984-10-02 00:00:00	38000275	0	\N	\N	348435	0	228557008	4043071	
60712	5251	4170947	1933-11-15	1933-11-15 00:00:00	38000275	0	\N	\N	349383	0	274474001	4170947	
61146	5290	4107731	1990-02-16	1990-02-16 00:00:00	38000275	0	\N	\N	351928	0	180256009	4107731	
61165	5290	4107731	1993-02-12	1993-02-12 00:00:00	38000275	0	\N	\N	351940	0	180256009	4107731	
50298	4376	4078793	1987-08-18	1987-08-18 00:00:00	38000275	0	\N	\N	290818	0	180325003	4078793	
51537	4471	4202451	2001-01-08	2001-01-08 00:00:00	38000275	0	\N	\N	297427	0	433112001	4202451	
52495	4550	4107731	1991-10-20	1991-10-20 00:00:00	38000275	0	\N	\N	303221	0	180256009	4107731	
41140	3604	4107731	1997-08-22	1997-08-22 00:00:00	38000275	0	\N	\N	239514	0	180256009	4107731	
54508	4725	4107731	1990-08-20	1990-08-20 00:00:00	38000275	0	\N	\N	314892	0	180256009	4107731	
55307	4826	4107731	1993-05-29	1993-05-29 00:00:00	38000275	0	\N	\N	320953	0	180256009	4107731	
44278	3891	4107731	1999-02-17	1999-02-17 00:00:00	38000275	0	\N	\N	258710	0	180256009	4107731	
48038	4217	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	279940	0	180256009	4107731	
60079	5194	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	345258	0	180256009	4107731	
60313	5215	4170947	1970-02-05	1970-02-05 00:00:00	38000275	0	\N	\N	346838	0	274474001	4170947	
60713	5251	4047491	1933-11-15	1933-11-15 00:00:00	38000275	0	\N	\N	349383	0	1225002	4047491	
61147	5290	4107731	1992-04-03	1992-04-03 00:00:00	38000275	0	\N	\N	351935	0	180256009	4107731	
61166	5290	4107731	1991-06-14	1991-06-14 00:00:00	38000275	0	\N	\N	351981	0	180256009	4107731	
50299	4376	4035793	2009-12-22	2009-12-22 00:00:00	38000275	0	\N	\N	290821	0	15081005	4035793	
51538	4471	4151422	1963-11-14	1963-11-14 00:00:00	38000275	0	\N	\N	297444	0	269911007	4151422	
52496	4550	4107731	1990-10-28	1990-10-28 00:00:00	38000275	0	\N	\N	303283	0	180256009	4107731	
52926	4595	4252419	1996-02-14	1996-02-14 00:00:00	38000275	0	\N	\N	306179	0	74016001	4252419	
54509	4725	4107731	1992-06-01	1992-06-01 00:00:00	38000275	0	\N	\N	314972	0	180256009	4107731	
55308	4826	4107731	1992-01-11	1992-01-11 00:00:00	38000275	0	\N	\N	320948	0	180256009	4107731	
44279	3891	4107731	1996-01-10	1996-01-10 00:00:00	38000275	0	\N	\N	258676	0	180256009	4107731	
48039	4217	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	279999	0	180256009	4107731	
60080	5194	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	345269	0	180256009	4107731	
60314	5215	4024289	1970-02-05	1970-02-05 00:00:00	38000275	0	\N	\N	346838	0	19490002	4024289	
60714	5251	4125906	1923-03-24	1923-03-24 00:00:00	38000275	0	\N	\N	349387	0	288086009	4125906	
61148	5290	4107731	1993-01-01	1993-01-01 00:00:00	38000275	0	\N	\N	351939	0	180256009	4107731	
61167	5290	4107731	1990-08-03	1990-08-03 00:00:00	38000275	0	\N	\N	351899	0	180256009	4107731	
50300	4376	4078793	2009-12-22	2009-12-22 00:00:00	38000275	0	\N	\N	290821	0	180325003	4078793	
51539	4471	4058899	1996-04-03	1996-04-03 00:00:00	38000275	0	\N	\N	297400	0	168594001	4058899	
52497	4550	4107731	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	303206	0	180256009	4107731	
52927	4595	44783196	1996-02-21	1996-02-21 00:00:00	38000275	0	\N	\N	306147	0	699253003	44783196	
54510	4725	4107731	1991-11-25	1991-11-25 00:00:00	38000275	0	\N	\N	314934	0	180256009	4107731	
55309	4826	4107731	1992-05-16	1992-05-16 00:00:00	38000275	0	\N	\N	321025	0	180256009	4107731	
44280	3891	4151422	2002-08-12	2002-08-12 00:00:00	38000275	0	\N	\N	258690	0	269911007	4151422	
48040	4217	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	279966	0	180256009	4107731	
60081	5194	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	345323	0	180256009	4107731	
60315	5215	40492359	1960-07-11	1960-07-11 00:00:00	38000275	0	\N	\N	346837	0	447365002	40492359	
60715	5252	4125906	2015-11-04	2015-11-04 00:00:00	38000275	0	\N	\N	349400	0	288086009	4125906	
61149	5290	4107731	1990-06-01	1990-06-01 00:00:00	38000275	0	\N	\N	351957	0	180256009	4107731	
61168	5290	4058899	1979-05-29	1979-05-29 00:00:00	38000275	0	\N	\N	352032	0	168594001	4058899	
50301	4376	44783196	1999-06-19	1999-06-19 00:00:00	38000275	0	\N	\N	290783	0	699253003	44783196	
51540	4472	4151422	1960-09-16	1960-09-16 00:00:00	38000275	0	\N	\N	297480	0	269911007	4151422	
52498	4550	4107731	1990-06-24	1990-06-24 00:00:00	38000275	0	\N	\N	303190	0	180256009	4107731	
52928	4595	4170947	1974-08-09	1974-08-09 00:00:00	38000275	0	\N	\N	306182	0	274474001	4170947	
54511	4725	4107731	1991-11-04	1991-11-04 00:00:00	38000275	0	\N	\N	314956	0	180256009	4107731	
55310	4826	4243062	1967-11-26	1967-11-26 00:00:00	38000275	0	\N	\N	320985	0	60027007	4243062	
44281	3891	4107731	1996-12-11	1996-12-11 00:00:00	38000275	0	\N	\N	258636	0	180256009	4107731	
48041	4217	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	280030	0	180256009	4107731	
60082	5194	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	345298	0	180256009	4107731	
60316	5215	4057420	1960-07-11	1960-07-11 00:00:00	38000275	0	\N	\N	346837	0	18286008	4057420	
60716	5252	4058899	2005-03-31	2005-03-31 00:00:00	38000275	0	\N	\N	349451	0	168594001	4058899	
61169	5290	4107731	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	351995	0	180256009	4107731	
50302	4376	4035793	1995-10-03	1995-10-03 00:00:00	38000275	0	\N	\N	290807	0	15081005	4035793	
51541	4472	4170947	2005-11-13	2005-11-13 00:00:00	38000275	0	\N	\N	297546	0	274474001	4170947	
52499	4550	4107731	1991-01-20	1991-01-20 00:00:00	38000275	0	\N	\N	303285	0	180256009	4107731	
52929	4595	4047491	1974-08-09	1974-08-09 00:00:00	38000275	0	\N	\N	306182	0	1225002	4047491	
54512	4725	4107731	1990-03-26	1990-03-26 00:00:00	38000275	0	\N	\N	314871	0	180256009	4107731	
55311	4826	4170947	1967-11-26	1967-11-26 00:00:00	38000275	0	\N	\N	320985	0	274474001	4170947	
44282	3891	4107731	1997-07-09	1997-07-09 00:00:00	38000275	0	\N	\N	258748	0	180256009	4107731	
48042	4217	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	279927	0	180256009	4107731	
60083	5194	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	345252	0	180256009	4107731	
60717	5252	4195803	2005-03-31	2005-03-31 00:00:00	38000275	0	\N	\N	349451	0	312681000	4195803	
61170	5290	4107731	1993-03-26	1993-03-26 00:00:00	38000275	0	\N	\N	351950	0	180256009	4107731	
50303	4376	4057420	1995-10-03	1995-10-03 00:00:00	38000275	0	\N	\N	290807	0	18286008	4057420	
51542	4472	4195803	2005-11-13	2005-11-13 00:00:00	38000275	0	\N	\N	297546	0	312681000	4195803	
52500	4550	4191853	1993-07-11	1993-07-11 00:00:00	38000275	0	\N	\N	303229	0	395142003	4191853	
52930	4595	4125906	2017-01-31	2017-01-31 00:00:00	38000275	0	\N	\N	306180	0	288086009	4125906	
54513	4725	4107731	1991-10-14	1991-10-14 00:00:00	38000275	0	\N	\N	314933	0	180256009	4107731	
55312	4826	4107731	1991-07-06	1991-07-06 00:00:00	38000275	0	\N	\N	320939	0	180256009	4107731	
44283	3891	4107731	1997-12-03	1997-12-03 00:00:00	38000275	0	\N	\N	258683	0	180256009	4107731	
48043	4217	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	280006	0	180256009	4107731	
60084	5194	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	345254	0	180256009	4107731	
60718	5252	4043071	1965-02-02	1965-02-02 00:00:00	38000275	0	\N	\N	349410	0	228557008	4043071	
61171	5290	4163872	1957-06-19	1957-06-19 00:00:00	38000275	0	\N	\N	351911	0	399208008	4163872	
51543	4472	4047491	2005-11-13	2005-11-13 00:00:00	38000275	0	\N	\N	297546	0	1225002	4047491	
52501	4550	4107731	1992-05-17	1992-05-17 00:00:00	38000275	0	\N	\N	303252	0	180256009	4107731	
52931	4596	4078793	2018-01-14	2018-01-14 00:00:00	38000275	0	\N	\N	306329	0	180325003	4078793	
54514	4725	4107731	1992-01-27	1992-01-27 00:00:00	38000275	0	\N	\N	314958	0	180256009	4107731	
55313	4826	4107731	1992-03-14	1992-03-14 00:00:00	38000275	0	\N	\N	320972	0	180256009	4107731	
44284	3891	4107731	1997-02-12	1997-02-12 00:00:00	38000275	0	\N	\N	258668	0	180256009	4107731	
48044	4217	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	279997	0	180256009	4107731	
60085	5194	4151422	1946-06-17	1946-06-17 00:00:00	38000275	0	\N	\N	345295	0	269911007	4151422	
60719	5252	4043071	1965-06-15	1965-06-15 00:00:00	38000275	0	\N	\N	349456	0	228557008	4043071	
61172	5290	4107731	1993-01-22	1993-01-22 00:00:00	38000275	0	\N	\N	351998	0	180256009	4107731	
51544	4472	4125906	2000-12-18	2000-12-18 00:00:00	38000275	0	\N	\N	297545	0	288086009	4125906	
52502	4550	4107731	1992-06-28	1992-06-28 00:00:00	38000275	0	\N	\N	303253	0	180256009	4107731	
52932	4596	4078793	2013-04-14	2013-04-14 00:00:00	38000275	0	\N	\N	306282	0	180325003	4078793	
54515	4725	4107731	1993-04-12	1993-04-12 00:00:00	38000275	0	\N	\N	314976	0	180256009	4107731	
55314	4826	4047491	1969-01-19	1969-01-19 00:00:00	38000275	0	\N	\N	320986	0	1225002	4047491	
44285	3891	4107731	1998-01-14	1998-01-14 00:00:00	38000275	0	\N	\N	258684	0	180256009	4107731	
48045	4217	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	280028	0	180256009	4107731	
60086	5194	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	345250	0	180256009	4107731	
60720	5252	4043071	1965-10-26	1965-10-26 00:00:00	38000275	0	\N	\N	349430	0	228557008	4043071	
61173	5290	4107731	1990-12-28	1990-12-28 00:00:00	38000275	0	\N	\N	351932	0	180256009	4107731	
51545	4472	4151422	1940-05-18	1940-05-18 00:00:00	38000275	0	\N	\N	297479	0	269911007	4151422	
52503	4550	4107731	1990-09-16	1990-09-16 00:00:00	38000275	0	\N	\N	303192	0	180256009	4107731	
52933	4596	4057420	2014-04-20	2014-04-20 00:00:00	38000275	0	\N	\N	306246	0	18286008	4057420	
54516	4725	4107731	1990-05-28	1990-05-28 00:00:00	38000275	0	\N	\N	314913	0	180256009	4107731	
55315	4826	4170947	1969-01-19	1969-01-19 00:00:00	38000275	0	\N	\N	320986	0	274474001	4170947	
44286	3891	4107731	1996-08-07	1996-08-07 00:00:00	38000275	0	\N	\N	258633	0	180256009	4107731	
48046	4217	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	279945	0	180256009	4107731	
60087	5194	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	345393	0	180256009	4107731	
60721	5252	4125906	1987-10-11	1987-10-11 00:00:00	38000275	0	\N	\N	349450	0	288086009	4125906	
61174	5290	4107731	1991-03-22	1991-03-22 00:00:00	38000275	0	\N	\N	351979	0	180256009	4107731	
51546	4472	4216130	2015-10-03	2015-10-03 00:00:00	38000275	0	\N	\N	297547	0	415070008	4216130	
52504	4550	4107731	1992-09-20	1992-09-20 00:00:00	38000275	0	\N	\N	303255	0	180256009	4107731	
52934	4596	4078793	2017-01-08	2017-01-08 00:00:00	38000275	0	\N	\N	306284	0	180325003	4078793	
54517	4725	4107731	1992-02-17	1992-02-17 00:00:00	38000275	0	\N	\N	314921	0	180256009	4107731	
55316	4826	4107731	1990-03-10	1990-03-10 00:00:00	38000275	0	\N	\N	321070	0	180256009	4107731	
44287	3891	4107731	1997-09-10	1997-09-10 00:00:00	38000275	0	\N	\N	258738	0	180256009	4107731	
48047	4217	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	279953	0	180256009	4107731	
60088	5194	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	345292	0	180256009	4107731	
60722	5252	4202451	2018-11-27	2018-11-27 00:00:00	38000275	0	\N	\N	349481	0	433112001	4202451	
61175	5290	4107731	1993-06-18	1993-06-18 00:00:00	38000275	0	\N	\N	351952	0	180256009	4107731	
51547	4472	4336464	2015-10-03	2015-10-03 00:00:00	38000275	0	\N	\N	297547	0	232717009	4336464	
52505	4550	4107731	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	303193	0	180256009	4107731	
52935	4596	4151422	1958-11-14	1958-11-14 00:00:00	38000275	0	\N	\N	306288	0	269911007	4151422	
54518	4725	4107731	1992-07-13	1992-07-13 00:00:00	38000275	0	\N	\N	314936	0	180256009	4107731	
55317	4826	4107731	1992-10-31	1992-10-31 00:00:00	38000275	0	\N	\N	321041	0	180256009	4107731	
44288	3891	4107731	1995-12-20	1995-12-20 00:00:00	38000275	0	\N	\N	258631	0	180256009	4107731	
48048	4217	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	280035	0	180256009	4107731	
60089	5194	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	345398	0	180256009	4107731	
60723	5252	4043071	1965-04-06	1965-04-06 00:00:00	38000275	0	\N	\N	349429	0	228557008	4043071	
61176	5290	4107731	1991-09-06	1991-09-06 00:00:00	38000275	0	\N	\N	351988	0	180256009	4107731	
51548	4474	4151422	1966-02-23	1966-02-23 00:00:00	38000275	0	\N	\N	297694	0	269911007	4151422	
52506	4550	4107731	1993-03-28	1993-03-28 00:00:00	38000275	0	\N	\N	303256	0	180256009	4107731	
52936	4596	4078793	2016-05-01	2016-05-01 00:00:00	38000275	0	\N	\N	306328	0	180325003	4078793	
54519	4725	4107731	1992-05-11	1992-05-11 00:00:00	38000275	0	\N	\N	314923	0	180256009	4107731	
55318	4826	4191853	1993-07-10	1993-07-10 00:00:00	38000275	0	\N	\N	321004	0	395142003	4191853	
44289	3891	4107731	1996-08-28	1996-08-28 00:00:00	38000275	0	\N	\N	258678	0	180256009	4107731	
48049	4217	4047491	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	279909	0	1225002	4047491	
60090	5194	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	345397	0	180256009	4107731	
60724	5252	4043071	1965-05-11	1965-05-11 00:00:00	38000275	0	\N	\N	349455	0	228557008	4043071	
61177	5290	4107731	1991-04-12	1991-04-12 00:00:00	38000275	0	\N	\N	351961	0	180256009	4107731	
51549	4474	4125906	2002-05-18	2002-05-18 00:00:00	38000275	0	\N	\N	297691	0	288086009	4125906	
52507	4550	4107731	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	303258	0	180256009	4107731	
52937	4596	4151422	1978-11-24	1978-11-24 00:00:00	38000275	0	\N	\N	306263	0	269911007	4151422	
54520	4725	4107731	1993-06-14	1993-06-14 00:00:00	38000275	0	\N	\N	314880	0	180256009	4107731	
55319	4826	4107731	1992-09-19	1992-09-19 00:00:00	38000275	0	\N	\N	321040	0	180256009	4107731	
44290	3891	4107731	1998-05-20	1998-05-20 00:00:00	38000275	0	\N	\N	258707	0	180256009	4107731	
48050	4217	4170947	1991-07-05	1991-07-05 00:00:00	38000275	0	\N	\N	279909	0	274474001	4170947	
60091	5194	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	345267	0	180256009	4107731	
60725	5252	4043071	1965-07-13	1965-07-13 00:00:00	38000275	0	\N	\N	349441	0	228557008	4043071	
61178	5290	4107731	1992-03-13	1992-03-13 00:00:00	38000275	0	\N	\N	351984	0	180256009	4107731	
51550	4474	4163872	2018-10-02	2018-10-02 00:00:00	38000275	0	\N	\N	297681	0	399208008	4163872	
52508	4550	4107731	1990-08-05	1990-08-05 00:00:00	38000275	0	\N	\N	303191	0	180256009	4107731	
52938	4596	4125906	1983-12-07	1983-12-07 00:00:00	38000275	0	\N	\N	306270	0	288086009	4125906	
54521	4725	4107731	1991-05-20	1991-05-20 00:00:00	38000275	0	\N	\N	314874	0	180256009	4107731	
55320	4826	4107731	1990-12-29	1990-12-29 00:00:00	38000275	0	\N	\N	321052	0	180256009	4107731	
44291	3891	4107731	1999-03-31	1999-03-31 00:00:00	38000275	0	\N	\N	258711	0	180256009	4107731	
48051	4217	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	280033	0	180256009	4107731	
60092	5194	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	345299	0	395142003	4191853	
60726	5252	4043071	1965-01-05	1965-01-05 00:00:00	38000275	0	\N	\N	349440	0	228557008	4043071	
61179	5290	4107731	1992-05-15	1992-05-15 00:00:00	38000275	0	\N	\N	351946	0	180256009	4107731	
51551	4475	4170947	1994-03-28	1994-03-28 00:00:00	38000275	0	\N	\N	297715	0	274474001	4170947	
52509	4550	4107731	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	303168	0	180256009	4107731	
52939	4596	4057420	2015-04-26	2015-04-26 00:00:00	38000275	0	\N	\N	306283	0	18286008	4057420	
54522	4725	4107731	1990-06-18	1990-06-18 00:00:00	38000275	0	\N	\N	314951	0	180256009	4107731	
55321	4826	4107731	1991-05-25	1991-05-25 00:00:00	38000275	0	\N	\N	320938	0	180256009	4107731	
44292	3891	4107731	1998-11-04	1998-11-04 00:00:00	38000275	0	\N	\N	258639	0	180256009	4107731	
48052	4217	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	279923	0	180256009	4107731	
60093	5194	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	345271	0	180256009	4107731	
60727	5252	4047491	1969-10-01	1969-10-01 00:00:00	38000275	0	\N	\N	349398	0	1225002	4047491	
61180	5290	4107731	1992-02-21	1992-02-21 00:00:00	38000275	0	\N	\N	351965	0	180256009	4107731	
51552	4475	4024289	1994-03-28	1994-03-28 00:00:00	38000275	0	\N	\N	297715	0	19490002	4024289	
52510	4550	4107731	1990-04-01	1990-04-01 00:00:00	38000275	0	\N	\N	303219	0	180256009	4107731	
52940	4596	4125906	1954-07-30	1954-07-30 00:00:00	38000275	0	\N	\N	306267	0	288086009	4125906	
54523	4725	4107731	1991-07-22	1991-07-22 00:00:00	38000275	0	\N	\N	314968	0	180256009	4107731	
55322	4826	4107731	1993-01-02	1993-01-02 00:00:00	38000275	0	\N	\N	321027	0	180256009	4107731	
44293	3891	4107731	1998-03-18	1998-03-18 00:00:00	38000275	0	\N	\N	258740	0	180256009	4107731	
48053	4217	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	279977	0	180256009	4107731	
60094	5194	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	345370	0	180256009	4107731	
60728	5252	4170947	1969-10-01	1969-10-01 00:00:00	38000275	0	\N	\N	349398	0	274474001	4170947	
61181	5290	4107731	1990-12-07	1990-12-07 00:00:00	38000275	0	\N	\N	351907	0	180256009	4107731	
51553	4475	4170947	1988-08-27	1988-08-27 00:00:00	38000275	0	\N	\N	297714	0	274474001	4170947	
52511	4550	4170947	1971-03-26	1971-03-26 00:00:00	38000275	0	\N	\N	303200	0	274474001	4170947	
52941	4596	4078793	2019-01-20	2019-01-20 00:00:00	38000275	0	\N	\N	306250	0	180325003	4078793	
54524	4725	4107731	1991-08-12	1991-08-12 00:00:00	38000275	0	\N	\N	314876	0	180256009	4107731	
55323	4826	4107731	1991-03-02	1991-03-02 00:00:00	38000275	0	\N	\N	321075	0	180256009	4107731	
44294	3891	4107731	1998-10-14	1998-10-14 00:00:00	38000275	0	\N	\N	258687	0	180256009	4107731	
48054	4217	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	279950	0	180256009	4107731	
60095	5195	4125906	1968-12-22	1968-12-22 00:00:00	38000275	0	\N	\N	345409	0	288086009	4125906	
60729	5252	4043071	1965-03-09	1965-03-09 00:00:00	38000275	0	\N	\N	349411	0	228557008	4043071	
61182	5290	4107731	1990-10-05	1990-10-05 00:00:00	38000275	0	\N	\N	351930	0	180256009	4107731	
51554	4475	4243062	1988-08-27	1988-08-27 00:00:00	38000275	0	\N	\N	297714	0	60027007	4243062	
52512	4550	4243062	1971-03-26	1971-03-26 00:00:00	38000275	0	\N	\N	303200	0	60027007	4243062	
52951	4602	4043071	1988-09-15	1988-09-15 00:00:00	38000275	0	\N	\N	306583	0	228557008	4043071	
54525	4725	4107731	1992-06-22	1992-06-22 00:00:00	38000275	0	\N	\N	314924	0	180256009	4107731	
55324	4826	4107731	1991-10-19	1991-10-19 00:00:00	38000275	0	\N	\N	320945	0	180256009	4107731	
44295	3891	4107731	1999-03-10	1999-03-10 00:00:00	38000275	0	\N	\N	258745	0	180256009	4107731	
48055	4217	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	280043	0	180256009	4107731	
60096	5195	4151422	1993-09-01	1993-09-01 00:00:00	38000275	0	\N	\N	345446	0	269911007	4151422	
60730	5252	4043071	1965-09-21	1965-09-21 00:00:00	38000275	0	\N	\N	349413	0	228557008	4043071	
61183	5290	4107731	1991-01-18	1991-01-18 00:00:00	38000275	0	\N	\N	351908	0	180256009	4107731	
51555	4475	4047491	1983-08-24	1983-08-24 00:00:00	38000275	0	\N	\N	297713	0	1225002	4047491	
52513	4550	4107731	1992-08-30	1992-08-30 00:00:00	38000275	0	\N	\N	303225	0	180256009	4107731	
52952	4602	4043071	1987-08-06	1987-08-06 00:00:00	38000275	0	\N	\N	306533	0	228557008	4043071	
54529	4729	4125906	1993-11-20	1993-11-20 00:00:00	38000275	0	\N	\N	315106	0	288086009	4125906	
55325	4826	4107731	1991-11-09	1991-11-09 00:00:00	38000275	0	\N	\N	321056	0	180256009	4107731	
44296	3891	4107731	1997-06-18	1997-06-18 00:00:00	38000275	0	\N	\N	258736	0	180256009	4107731	
48056	4217	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	279965	0	180256009	4107731	
60097	5195	4145310	2015-09-08	2015-09-08 00:00:00	38000275	0	\N	\N	345410	0	268425006	4145310	
60731	5252	4043071	1965-08-17	1965-08-17 00:00:00	38000275	0	\N	\N	349412	0	228557008	4043071	
61184	5290	4107731	1990-11-16	1990-11-16 00:00:00	38000275	0	\N	\N	351931	0	180256009	4107731	
51556	4475	4170947	1983-08-24	1983-08-24 00:00:00	38000275	0	\N	\N	297713	0	274474001	4170947	
52514	4550	4107731	1992-11-22	1992-11-22 00:00:00	38000275	0	\N	\N	303169	0	180256009	4107731	
52953	4602	4043071	1989-03-02	1989-03-02 00:00:00	38000275	0	\N	\N	306523	0	228557008	4043071	
54530	4729	4024289	1967-11-07	1967-11-07 00:00:00	38000275	0	\N	\N	315104	0	19490002	4024289	
55326	4826	4107731	1990-10-27	1990-10-27 00:00:00	38000275	0	\N	\N	320967	0	180256009	4107731	
44297	3891	4197460	1998-01-04	1998-01-04 00:00:00	38000275	0	\N	\N	258753	0	313191000	4197460	
48057	4217	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	279936	0	180256009	4107731	
60098	5195	4195803	2015-09-08	2015-09-08 00:00:00	38000275	0	\N	\N	345410	0	312681000	4195803	
60732	5253	4035793	2019-05-25	2019-05-25 00:00:00	38000275	0	\N	\N	349516	0	15081005	4035793	
61185	5290	4107731	1990-05-11	1990-05-11 00:00:00	38000275	0	\N	\N	351897	0	180256009	4107731	
51557	4476	4125906	2001-12-25	2001-12-25 00:00:00	38000275	0	\N	\N	297899	0	288086009	4125906	
52515	4550	4107731	1990-12-09	1990-12-09 00:00:00	38000275	0	\N	\N	303284	0	180256009	4107731	
52954	4602	4043071	1988-05-26	1988-05-26 00:00:00	38000275	0	\N	\N	306522	0	228557008	4043071	
54531	4729	4170947	1967-11-07	1967-11-07 00:00:00	38000275	0	\N	\N	315104	0	274474001	4170947	
55327	4826	4107731	1990-08-25	1990-08-25 00:00:00	38000275	0	\N	\N	320935	0	180256009	4107731	
44298	3891	4107731	1997-12-24	1997-12-24 00:00:00	38000275	0	\N	\N	258672	0	180256009	4107731	
48058	4217	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	279964	0	395142003	4191853	
60099	5195	4151422	1985-04-07	1985-04-07 00:00:00	38000275	0	\N	\N	345464	0	269911007	4151422	
60733	5253	4035793	2018-05-19	2018-05-19 00:00:00	38000275	0	\N	\N	349570	0	15081005	4035793	
61186	5290	4107731	1991-02-08	1991-02-08 00:00:00	38000275	0	\N	\N	351978	0	180256009	4107731	
51558	4476	4107731	1990-06-24	1990-06-24 00:00:00	38000275	0	\N	\N	297817	0	180256009	4107731	
52516	4550	4107731	1991-05-26	1991-05-26 00:00:00	38000275	0	\N	\N	303234	0	180256009	4107731	
52955	4602	4043071	1988-01-21	1988-01-21 00:00:00	38000275	0	\N	\N	306554	0	228557008	4043071	
54532	4729	4238715	1983-09-30	1983-09-30 00:00:00	38000275	0	\N	\N	315089	0	68254000	4238715	
55328	4826	4107731	1992-06-06	1992-06-06 00:00:00	38000275	0	\N	\N	320959	0	180256009	4107731	
44299	3891	4107731	1998-06-10	1998-06-10 00:00:00	38000275	0	\N	\N	258742	0	180256009	4107731	
48059	4217	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	280025	0	180256009	4107731	
60100	5196	4151422	2017-01-10	2017-01-10 00:00:00	38000275	0	\N	\N	345549	0	269911007	4151422	
60734	5253	4170947	1979-05-08	1979-05-08 00:00:00	38000275	0	\N	\N	349572	0	274474001	4170947	
61187	5290	4107731	1992-08-07	1992-08-07 00:00:00	38000275	0	\N	\N	351948	0	180256009	4107731	
51559	4476	4107731	1991-02-10	1991-02-10 00:00:00	38000275	0	\N	\N	297836	0	180256009	4107731	
52517	4550	4107731	1991-12-01	1991-12-01 00:00:00	38000275	0	\N	\N	303222	0	180256009	4107731	
52956	4602	4043071	1988-06-23	1988-06-23 00:00:00	38000275	0	\N	\N	306556	0	228557008	4043071	
54533	4729	4170947	1965-09-18	1965-09-18 00:00:00	38000275	0	\N	\N	315097	0	274474001	4170947	
55329	4826	4107731	1993-03-27	1993-03-27 00:00:00	38000275	0	\N	\N	321029	0	180256009	4107731	
44300	3891	4107731	1999-01-06	1999-01-06 00:00:00	38000275	0	\N	\N	258709	0	180256009	4107731	
59924	5184	4163872	1984-01-07	1984-01-07 00:00:00	38000275	0	\N	\N	344566	0	399208008	4163872	
60101	5196	4151422	2006-10-07	2006-10-07 00:00:00	38000275	0	\N	\N	345521	0	269911007	4151422	
60735	5253	4024289	1979-05-08	1979-05-08 00:00:00	38000275	0	\N	\N	349572	0	19490002	4024289	
61188	5290	4107731	1992-01-31	1992-01-31 00:00:00	38000275	0	\N	\N	351983	0	180256009	4107731	
51560	4476	4107731	1991-01-20	1991-01-20 00:00:00	38000275	0	\N	\N	297906	0	180256009	4107731	
52518	4550	4107731	1990-06-03	1990-06-03 00:00:00	38000275	0	\N	\N	303277	0	180256009	4107731	
52957	4602	4043071	1987-09-03	1987-09-03 00:00:00	38000275	0	\N	\N	306550	0	228557008	4043071	
54534	4729	4024289	1965-09-18	1965-09-18 00:00:00	38000275	0	\N	\N	315097	0	19490002	4024289	
55330	4826	4107731	1992-07-18	1992-07-18 00:00:00	38000275	0	\N	\N	320949	0	180256009	4107731	
44301	3891	4107731	1997-08-20	1997-08-20 00:00:00	38000275	0	\N	\N	258749	0	180256009	4107731	
59925	5184	4243062	1965-05-15	1965-05-15 00:00:00	38000275	0	\N	\N	344591	0	60027007	4243062	
60102	5197	4163951	1962-06-05	1962-06-05 00:00:00	38000275	0	\N	\N	345571	0	29303009	4163951	
60736	5253	4058899	1971-04-20	1971-04-20 00:00:00	38000275	0	\N	\N	349571	0	168594001	4058899	
61189	5290	4107731	1992-01-10	1992-01-10 00:00:00	38000275	0	\N	\N	351964	0	180256009	4107731	
51561	4476	4107731	1992-08-30	1992-08-30 00:00:00	38000275	0	\N	\N	297771	0	180256009	4107731	
52519	4550	4107731	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	303226	0	180256009	4107731	
52958	4602	4043071	1987-07-09	1987-07-09 00:00:00	38000275	0	\N	\N	306553	0	228557008	4043071	
54535	4729	4275113	1979-01-21	1979-01-21 00:00:00	38000275	0	\N	\N	315100	0	65200003	4275113	
55331	4826	4107731	1992-06-27	1992-06-27 00:00:00	38000275	0	\N	\N	321058	0	180256009	4107731	
44302	3891	4107731	1996-10-09	1996-10-09 00:00:00	38000275	0	\N	\N	258679	0	180256009	4107731	
59926	5184	4170947	1965-05-15	1965-05-15 00:00:00	38000275	0	\N	\N	344591	0	274474001	4170947	
60103	5197	42535580	1962-06-05	1962-06-05 00:00:00	38000275	0	\N	\N	345571	0	426701000119108	42535580	
60739	5255	4125906	2015-12-18	2015-12-18 00:00:00	38000275	0	\N	\N	349706	0	288086009	4125906	
61190	5290	4107731	1991-11-08	1991-11-08 00:00:00	38000275	0	\N	\N	351945	0	180256009	4107731	
51562	4476	4107731	1993-04-18	1993-04-18 00:00:00	38000275	0	\N	\N	297824	0	180256009	4107731	
52520	4550	4107731	1990-08-26	1990-08-26 00:00:00	38000275	0	\N	\N	303231	0	180256009	4107731	
52959	4602	4043071	1987-11-12	1987-11-12 00:00:00	38000275	0	\N	\N	306560	0	228557008	4043071	
54536	4731	4043071	1982-08-27	1982-08-27 00:00:00	38000275	0	\N	\N	315165	0	228557008	4043071	
55332	4826	4107731	1990-01-27	1990-01-27 00:00:00	38000275	0	\N	\N	321069	0	180256009	4107731	
44303	3891	4107731	1996-04-24	1996-04-24 00:00:00	38000275	0	\N	\N	258758	0	180256009	4107731	
59927	5185	4125906	1949-08-01	1949-08-01 00:00:00	38000275	0	\N	\N	344600	0	288086009	4125906	
60104	5197	4163971	1962-06-06	1962-06-06 00:00:00	38000275	0	\N	\N	345571	0	45595009	4163971	
60740	5255	4125906	2004-06-04	2004-06-04 00:00:00	38000275	0	\N	\N	349704	0	288086009	4125906	
61191	5290	4107731	1990-10-26	1990-10-26 00:00:00	38000275	0	\N	\N	351906	0	180256009	4107731	
51563	4476	4107731	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	297846	0	180256009	4107731	
52521	4550	4107731	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	303233	0	180256009	4107731	
52960	4602	4043071	1989-01-26	1989-01-26 00:00:00	38000275	0	\N	\N	306541	0	228557008	4043071	
54537	4731	4043071	1983-08-12	1983-08-12 00:00:00	38000275	0	\N	\N	315235	0	228557008	4043071	
55333	4826	4107731	1990-04-21	1990-04-21 00:00:00	38000275	0	\N	\N	321071	0	180256009	4107731	
44304	3891	4107731	1996-10-30	1996-10-30 00:00:00	38000275	0	\N	\N	258635	0	180256009	4107731	
59928	5185	40492359	1961-11-13	1961-11-13 00:00:00	38000275	0	\N	\N	344602	0	447365002	40492359	
60105	5197	4202832	1962-06-06	1962-06-06 00:00:00	38000275	0	\N	\N	345571	0	52765003	4202832	
60741	5256	4151422	1987-08-23	1987-08-23 00:00:00	38000275	0	\N	\N	349774	0	269911007	4151422	
61192	5290	4107731	1991-05-03	1991-05-03 00:00:00	38000275	0	\N	\N	351980	0	180256009	4107731	
51564	4476	4107731	1991-08-18	1991-08-18 00:00:00	38000275	0	\N	\N	297813	0	180256009	4107731	
52522	4550	4107731	1991-05-05	1991-05-05 00:00:00	38000275	0	\N	\N	303194	0	180256009	4107731	
52961	4602	4043071	1988-07-21	1988-07-21 00:00:00	38000275	0	\N	\N	306535	0	228557008	4043071	
54538	4731	4043071	1983-02-04	1983-02-04 00:00:00	38000275	0	\N	\N	315209	0	228557008	4043071	
55334	4826	4107731	1990-09-15	1990-09-15 00:00:00	38000275	0	\N	\N	320966	0	180256009	4107731	
44305	3891	4107731	1998-02-04	1998-02-04 00:00:00	38000275	0	\N	\N	258673	0	180256009	4107731	
59929	5185	4057420	1961-11-13	1961-11-13 00:00:00	38000275	0	\N	\N	344602	0	18286008	4057420	
60106	5197	4202451	2012-05-08	2012-05-08 00:00:00	38000275	0	\N	\N	345612	0	433112001	4202451	
60742	5256	4163872	2008-03-05	2008-03-05 00:00:00	38000275	0	\N	\N	349708	0	399208008	4163872	
61193	5290	4107731	1992-06-05	1992-06-05 00:00:00	38000275	0	\N	\N	351991	0	180256009	4107731	
51565	4476	4107731	1992-11-01	1992-11-01 00:00:00	38000275	0	\N	\N	297844	0	180256009	4107731	
52523	4550	4107731	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	303170	0	180256009	4107731	
52962	4602	4043071	1987-12-17	1987-12-17 00:00:00	38000275	0	\N	\N	306561	0	228557008	4043071	
54539	4731	4043071	1983-09-09	1983-09-09 00:00:00	38000275	0	\N	\N	315182	0	228557008	4043071	
55335	4826	4107731	1993-06-19	1993-06-19 00:00:00	38000275	0	\N	\N	321043	0	180256009	4107731	
44306	3891	4107731	1999-05-12	1999-05-12 00:00:00	38000275	0	\N	\N	258712	0	180256009	4107731	
59930	5185	44783196	2000-01-11	2000-01-11 00:00:00	38000275	0	\N	\N	344727	0	699253003	44783196	
60107	5197	4230209	1993-04-16	1993-04-16 00:00:00	38000275	0	\N	\N	345584	0	88848003	4230209	
60743	5256	4170947	2008-03-05	2008-03-05 00:00:00	38000275	0	\N	\N	349708	0	274474001	4170947	
61194	5290	4107731	1993-05-28	1993-05-28 00:00:00	38000275	0	\N	\N	351996	0	180256009	4107731	
51566	4476	4107731	1990-09-16	1990-09-16 00:00:00	38000275	0	\N	\N	297819	0	180256009	4107731	
52524	4550	4107731	1991-09-08	1991-09-08 00:00:00	38000275	0	\N	\N	303287	0	180256009	4107731	
52963	4602	4043071	1988-11-17	1988-11-17 00:00:00	38000275	0	\N	\N	306537	0	228557008	4043071	
54540	4731	4043071	1982-04-09	1982-04-09 00:00:00	38000275	0	\N	\N	315230	0	228557008	4043071	
55336	4826	4107731	1993-05-08	1993-05-08 00:00:00	38000275	0	\N	\N	321042	0	180256009	4107731	
44307	3892	4125906	2013-02-23	2013-02-23 00:00:00	38000275	0	\N	\N	258773	0	288086009	4125906	
59931	5185	4125906	1956-07-09	1956-07-09 00:00:00	38000275	0	\N	\N	344601	0	288086009	4125906	
60108	5197	4125906	1995-08-28	1995-08-28 00:00:00	38000275	0	\N	\N	345576	0	288086009	4125906	
60744	5257	44783196	2014-04-10	2014-04-10 00:00:00	38000275	0	\N	\N	349844	0	699253003	44783196	
61195	5290	4107731	1991-10-18	1991-10-18 00:00:00	38000275	0	\N	\N	351989	0	180256009	4107731	
51567	4476	4107731	1990-01-28	1990-01-28 00:00:00	38000275	0	\N	\N	297901	0	180256009	4107731	
52525	4550	4107731	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	303224	0	180256009	4107731	
52964	4602	4043071	1987-10-08	1987-10-08 00:00:00	38000275	0	\N	\N	306559	0	228557008	4043071	
54541	4731	4043071	1983-03-11	1983-03-11 00:00:00	38000275	0	\N	\N	315167	0	228557008	4043071	
55337	4826	4107731	1992-11-21	1992-11-21 00:00:00	38000275	0	\N	\N	321026	0	180256009	4107731	
44308	3892	4125906	1970-12-15	1970-12-15 00:00:00	38000275	0	\N	\N	258772	0	288086009	4125906	
59932	5185	4195803	1989-01-01	1989-01-01 00:00:00	38000275	0	\N	\N	344603	0	312681000	4195803	
60109	5197	4234705	1993-04-11	1993-04-11 00:00:00	38000275	0	\N	\N	345575	0	90407005	4234705	
60745	5257	4059978	2005-01-02	2005-01-02 00:00:00	38000275	0	\N	\N	349789	0	169553002	4059978	
61196	5291	4151422	2002-01-02	2002-01-02 00:00:00	38000275	0	\N	\N	352055	0	269911007	4151422	
51568	4476	4107731	1993-05-09	1993-05-09 00:00:00	38000275	0	\N	\N	297845	0	180256009	4107731	
52526	4550	4107731	1991-07-07	1991-07-07 00:00:00	38000275	0	\N	\N	303235	0	180256009	4107731	
52965	4602	4043071	1988-08-18	1988-08-18 00:00:00	38000275	0	\N	\N	306539	0	228557008	4043071	
54542	4731	4043071	1982-11-05	1982-11-05 00:00:00	38000275	0	\N	\N	315180	0	228557008	4043071	
55338	4826	4107731	1991-01-19	1991-01-19 00:00:00	38000275	0	\N	\N	321074	0	180256009	4107731	
44309	3892	4151422	2019-02-02	2019-02-02 00:00:00	38000275	0	\N	\N	258784	0	269911007	4151422	
59933	5185	4058899	1989-01-01	1989-01-01 00:00:00	38000275	0	\N	\N	344603	0	168594001	4058899	
60132	5199	4151422	1974-08-21	1974-08-21 00:00:00	38000275	0	\N	\N	345779	0	269911007	4151422	
60746	5257	44805732	2002-02-13	2002-02-13 00:00:00	38000275	0	\N	\N	349829	0	755621000000101	44805732	
61197	5291	4125906	2008-03-29	2008-03-29 00:00:00	38000275	0	\N	\N	352036	0	288086009	4125906	
51569	4476	4107731	1991-07-07	1991-07-07 00:00:00	38000275	0	\N	\N	297812	0	180256009	4107731	
52527	4550	4107731	1990-11-18	1990-11-18 00:00:00	38000275	0	\N	\N	303243	0	180256009	4107731	
52966	4602	4043071	1988-03-24	1988-03-24 00:00:00	38000275	0	\N	\N	306534	0	228557008	4043071	
54543	4731	4043071	1982-01-29	1982-01-29 00:00:00	38000275	0	\N	\N	315179	0	228557008	4043071	
55339	4826	4107731	1992-02-01	1992-02-01 00:00:00	38000275	0	\N	\N	320971	0	180256009	4107731	
44310	3893	4125906	1999-11-15	1999-11-15 00:00:00	38000275	0	\N	\N	258836	0	288086009	4125906	
59934	5185	4195803	2010-09-22	2010-09-22 00:00:00	38000275	0	\N	\N	344726	0	312681000	4195803	
60133	5199	4170947	2011-06-08	2011-06-08 00:00:00	38000275	0	\N	\N	345723	0	274474001	4170947	
60747	5257	4145310	1989-02-13	1989-02-13 00:00:00	38000275	0	\N	\N	349843	0	268425006	4145310	
61205	5295	4170947	1971-02-18	1971-02-18 00:00:00	38000275	0	\N	\N	352210	0	274474001	4170947	
51570	4476	4191853	1990-01-07	1990-01-07 00:00:00	38000275	0	\N	\N	297806	0	395142003	4191853	
52528	4550	4107731	1993-05-09	1993-05-09 00:00:00	38000275	0	\N	\N	303257	0	180256009	4107731	
52967	4602	4043071	1988-12-22	1988-12-22 00:00:00	38000275	0	\N	\N	306540	0	228557008	4043071	
54544	4731	4043071	1982-05-14	1982-05-14 00:00:00	38000275	0	\N	\N	315206	0	228557008	4043071	
55340	4826	4107731	1993-01-23	1993-01-23 00:00:00	38000275	0	\N	\N	320961	0	180256009	4107731	
56182	4898	4151422	1954-03-14	1954-03-14 00:00:00	38000275	0	\N	\N	325663	0	269911007	4151422	
59935	5185	4170947	2010-09-22	2010-09-22 00:00:00	38000275	0	\N	\N	344726	0	274474001	4170947	
60134	5199	4243062	2011-06-08	2011-06-08 00:00:00	38000275	0	\N	\N	345723	0	60027007	4243062	
60748	5257	4252419	2014-04-03	2014-04-03 00:00:00	38000275	0	\N	\N	349786	0	74016001	4252419	
61206	5295	4243062	1971-02-18	1971-02-18 00:00:00	38000275	0	\N	\N	352210	0	60027007	4243062	
51571	4476	4197460	1972-12-22	1972-12-22 00:00:00	38000275	0	\N	\N	297896	0	313191000	4197460	
52529	4550	4107731	1993-04-18	1993-04-18 00:00:00	38000275	0	\N	\N	303227	0	180256009	4107731	
52968	4602	4043071	1988-02-25	1988-02-25 00:00:00	38000275	0	\N	\N	306555	0	228557008	4043071	
54545	4731	4024289	1972-10-27	1972-10-27 00:00:00	38000275	0	\N	\N	315215	0	19490002	4024289	
55341	4826	4107731	1990-11-17	1990-11-17 00:00:00	38000275	0	\N	\N	321051	0	180256009	4107731	
56183	4898	4047491	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	325705	0	1225002	4047491	
59936	5185	4252419	2002-11-26	2002-11-26 00:00:00	38000275	0	\N	\N	344725	0	74016001	4252419	
60135	5199	4181917	1976-01-13	1976-01-13 00:00:00	38000275	0	\N	\N	345722	0	54550000	4181917	
60749	5257	44805732	2010-02-17	2010-02-17 00:00:00	38000275	0	\N	\N	349814	0	755621000000101	44805732	
61207	5295	4195803	1971-02-18	1971-02-18 00:00:00	38000275	0	\N	\N	352210	0	312681000	4195803	
51572	4476	4107731	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	297854	0	180256009	4107731	
52530	4550	4107731	1990-02-18	1990-02-18 00:00:00	38000275	0	\N	\N	303218	0	180256009	4107731	
52969	4602	4043071	1988-04-21	1988-04-21 00:00:00	38000275	0	\N	\N	306562	0	228557008	4043071	
54546	4731	4170947	1972-10-27	1972-10-27 00:00:00	38000275	0	\N	\N	315215	0	274474001	4170947	
55342	4826	4107731	1990-02-17	1990-02-17 00:00:00	38000275	0	\N	\N	321063	0	180256009	4107731	
56184	4898	4170947	1990-07-30	1990-07-30 00:00:00	38000275	0	\N	\N	325705	0	274474001	4170947	
59937	5185	44783196	2002-12-03	2002-12-03 00:00:00	38000275	0	\N	\N	344657	0	699253003	44783196	
60136	5200	4191853	1993-07-07	1993-07-07 00:00:00	38000275	0	\N	\N	345811	0	395142003	4191853	
60750	5257	4275113	2006-12-26	2006-12-26 00:00:00	38000275	0	\N	\N	349791	0	65200003	4275113	
61208	5295	4293740	1958-10-03	1958-10-03 00:00:00	38000275	0	\N	\N	352209	0	384700001	4293740	
51573	4476	4107731	1991-05-26	1991-05-26 00:00:00	38000275	0	\N	\N	297811	0	180256009	4107731	
52531	4550	4107731	1991-11-10	1991-11-10 00:00:00	38000275	0	\N	\N	303251	0	180256009	4107731	
52970	4602	4043071	1988-10-13	1988-10-13 00:00:00	38000275	0	\N	\N	306536	0	228557008	4043071	
54547	4731	4043071	1983-10-07	1983-10-07 00:00:00	38000275	0	\N	\N	315194	0	228557008	4043071	
55343	4826	4107731	1993-02-13	1993-02-13 00:00:00	38000275	0	\N	\N	321028	0	180256009	4107731	
56185	4898	4170947	1962-10-27	1962-10-27 00:00:00	38000275	0	\N	\N	325703	0	274474001	4170947	
59938	5185	4163872	2010-09-22	2010-09-22 00:00:00	38000275	0	\N	\N	344726	0	399208008	4163872	
60137	5200	4107731	1991-04-10	1991-04-10 00:00:00	38000275	0	\N	\N	345842	0	180256009	4107731	
60751	5257	4059978	2004-01-08	2004-01-08 00:00:00	38000275	0	\N	\N	349841	0	169553002	4059978	
61209	5295	4125906	1958-10-03	1958-10-03 00:00:00	38000275	0	\N	\N	352209	0	288086009	4125906	
51574	4476	4107731	1990-12-30	1990-12-30 00:00:00	38000275	0	\N	\N	297835	0	180256009	4107731	
52532	4550	4191853	1990-01-07	1990-01-07 00:00:00	38000275	0	\N	\N	303217	0	395142003	4191853	
52971	4602	4043071	1987-06-04	1987-06-04 00:00:00	38000275	0	\N	\N	306558	0	228557008	4043071	
54548	4731	4043071	1982-12-03	1982-12-03 00:00:00	38000275	0	\N	\N	315231	0	228557008	4043071	
55344	4826	4107731	1990-10-06	1990-10-06 00:00:00	38000275	0	\N	\N	320936	0	180256009	4107731	
56186	4898	4024289	1962-10-27	1962-10-27 00:00:00	38000275	0	\N	\N	325703	0	19490002	4024289	
59939	5185	4252419	2000-01-04	2000-01-04 00:00:00	38000275	0	\N	\N	344724	0	74016001	4252419	
60138	5200	4107731	1991-05-22	1991-05-22 00:00:00	38000275	0	\N	\N	345843	0	180256009	4107731	
60752	5257	4199276	2010-12-29	2010-12-29 00:00:00	38000275	0	\N	\N	349815	0	301807007	4199276	
61210	5295	4202451	1982-07-07	1982-07-07 00:00:00	38000275	0	\N	\N	352312	0	433112001	4202451	
51575	4476	4107731	1991-06-16	1991-06-16 00:00:00	38000275	0	\N	\N	297822	0	180256009	4107731	
52533	4550	4107731	1992-12-13	1992-12-13 00:00:00	38000275	0	\N	\N	303267	0	180256009	4107731	
52972	4603	4195803	2010-10-28	2010-10-28 00:00:00	38000275	0	\N	\N	306633	0	312681000	4195803	
54549	4731	4043071	1981-11-27	1981-11-27 00:00:00	38000275	0	\N	\N	315163	0	228557008	4043071	
55345	4826	4107731	1990-07-14	1990-07-14 00:00:00	38000275	0	\N	\N	320934	0	180256009	4107731	
56187	4898	4125906	1991-08-24	1991-08-24 00:00:00	38000275	0	\N	\N	325706	0	288086009	4125906	
60008	5189	4293740	2018-07-25	2018-07-25 00:00:00	38000275	0	\N	\N	344900	0	384700001	4293740	
60139	5200	4107731	1991-11-27	1991-11-27 00:00:00	38000275	0	\N	\N	345844	0	180256009	4107731	
60753	5257	4059978	1998-02-08	1998-02-08 00:00:00	38000275	0	\N	\N	349837	0	169553002	4059978	
61211	5295	4125906	1933-07-25	1933-07-25 00:00:00	38000275	0	\N	\N	352208	0	288086009	4125906	
51576	4476	4107731	1992-04-26	1992-04-26 00:00:00	38000275	0	\N	\N	297851	0	180256009	4107731	
52534	4550	4107731	1992-06-07	1992-06-07 00:00:00	38000275	0	\N	\N	303223	0	180256009	4107731	
52973	4603	4058899	2004-09-07	2004-09-07 00:00:00	38000275	0	\N	\N	306623	0	168594001	4058899	
54550	4731	4043071	1983-04-08	1983-04-08 00:00:00	38000275	0	\N	\N	315181	0	228557008	4043071	
55346	4826	4107731	1993-04-17	1993-04-17 00:00:00	38000275	0	\N	\N	320952	0	180256009	4107731	
56188	4898	4151422	1966-09-20	1966-09-20 00:00:00	38000275	0	\N	\N	325678	0	269911007	4151422	
60009	5189	4125906	2018-07-25	2018-07-25 00:00:00	38000275	0	\N	\N	344900	0	288086009	4125906	
60140	5200	4107731	1992-08-05	1992-08-05 00:00:00	38000275	0	\N	\N	345894	0	180256009	4107731	
60754	5257	44805732	2006-02-15	2006-02-15 00:00:00	38000275	0	\N	\N	349799	0	755621000000101	44805732	
61212	5295	4170947	1977-12-13	1977-12-13 00:00:00	38000275	0	\N	\N	352212	0	274474001	4170947	
51577	4476	4191853	1993-07-11	1993-07-11 00:00:00	38000275	0	\N	\N	297826	0	395142003	4191853	
52535	4550	4107731	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	303286	0	180256009	4107731	
52974	4603	4195803	2004-09-07	2004-09-07 00:00:00	38000275	0	\N	\N	306623	0	312681000	4195803	
54551	4731	4043071	1983-07-08	1983-07-08 00:00:00	38000275	0	\N	\N	315234	0	228557008	4043071	
55347	4826	4107731	1990-08-04	1990-08-04 00:00:00	38000275	0	\N	\N	320965	0	180256009	4107731	
56189	4898	4238715	1972-04-12	1972-04-12 00:00:00	38000275	0	\N	\N	325699	0	68254000	4238715	
60010	5189	4202451	2007-09-09	2007-09-09 00:00:00	38000275	0	\N	\N	344938	0	433112001	4202451	
60141	5200	4107731	1990-06-20	1990-06-20 00:00:00	38000275	0	\N	\N	345870	0	180256009	4107731	
60755	5258	4170947	1968-01-14	1968-01-14 00:00:00	38000275	0	\N	\N	349869	0	274474001	4170947	
61213	5295	4195803	1977-12-13	1977-12-13 00:00:00	38000275	0	\N	\N	352212	0	312681000	4195803	
51578	4476	4107731	1992-01-12	1992-01-12 00:00:00	38000275	0	\N	\N	297768	0	180256009	4107731	
52536	4550	4107731	1993-02-14	1993-02-14 00:00:00	38000275	0	\N	\N	303171	0	180256009	4107731	
52975	4603	4047491	2018-01-18	2018-01-18 00:00:00	38000275	0	\N	\N	306625	0	1225002	4047491	
54552	4731	4043071	1983-01-07	1983-01-07 00:00:00	38000275	0	\N	\N	315232	0	228557008	4043071	
55348	4826	4107731	1991-03-23	1991-03-23 00:00:00	38000275	0	\N	\N	321054	0	180256009	4107731	
56190	4898	4275113	1971-02-24	1971-02-24 00:00:00	38000275	0	\N	\N	325669	0	65200003	4275113	
60011	5190	4170947	1969-04-01	1969-04-01 00:00:00	38000275	0	\N	\N	345059	0	274474001	4170947	
60142	5200	4107731	1993-05-05	1993-05-05 00:00:00	38000275	0	\N	\N	345897	0	180256009	4107731	
60756	5258	4024289	1968-01-14	1968-01-14 00:00:00	38000275	0	\N	\N	349869	0	19490002	4024289	
61214	5295	4243062	1977-12-13	1977-12-13 00:00:00	38000275	0	\N	\N	352212	0	60027007	4243062	
51579	4476	4107731	1991-09-29	1991-09-29 00:00:00	38000275	0	\N	\N	297838	0	180256009	4107731	
52537	4550	4107731	1990-04-22	1990-04-22 00:00:00	38000275	0	\N	\N	303282	0	180256009	4107731	
52976	4603	4170947	2018-01-18	2018-01-18 00:00:00	38000275	0	\N	\N	306625	0	274474001	4170947	
54553	4731	4043071	1982-06-18	1982-06-18 00:00:00	38000275	0	\N	\N	315207	0	228557008	4043071	
55349	4826	4107731	1991-08-17	1991-08-17 00:00:00	38000275	0	\N	\N	320940	0	180256009	4107731	
56191	4899	4035793	1992-10-06	1992-10-06 00:00:00	38000275	0	\N	\N	325860	0	15081005	4035793	
60012	5190	4163872	1969-04-01	1969-04-01 00:00:00	38000275	0	\N	\N	345059	0	399208008	4163872	
60143	5200	4107731	1992-10-07	1992-10-07 00:00:00	38000275	0	\N	\N	345808	0	180256009	4107731	
60757	5259	4125906	2012-03-06	2012-03-06 00:00:00	38000275	0	\N	\N	350006	0	288086009	4125906	
61215	5295	4195803	1990-08-08	1990-08-08 00:00:00	38000275	0	\N	\N	352293	0	312681000	4195803	
51580	4476	4107731	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	297795	0	180256009	4107731	
52538	4550	4107731	1991-06-16	1991-06-16 00:00:00	38000275	0	\N	\N	303195	0	180256009	4107731	
52977	4603	4125906	1982-04-17	1982-04-17 00:00:00	38000275	0	\N	\N	306621	0	288086009	4125906	
54554	4731	4043071	1982-03-05	1982-03-05 00:00:00	38000275	0	\N	\N	315229	0	228557008	4043071	
55350	4826	4107731	1990-03-31	1990-03-31 00:00:00	38000275	0	\N	\N	321064	0	180256009	4107731	
56192	4899	4035793	1987-09-08	1987-09-08 00:00:00	38000275	0	\N	\N	325845	0	15081005	4035793	
60013	5190	4151422	1998-07-21	1998-07-21 00:00:00	38000275	0	\N	\N	345031	0	269911007	4151422	
60144	5200	4107731	1992-09-16	1992-09-16 00:00:00	38000275	0	\N	\N	345883	0	180256009	4107731	
60758	5259	4125906	2004-05-19	2004-05-19 00:00:00	38000275	0	\N	\N	350004	0	288086009	4125906	
61216	5295	4125906	1995-04-13	1995-04-13 00:00:00	38000275	0	\N	\N	352213	0	288086009	4125906	
51581	4476	4107731	1992-06-07	1992-06-07 00:00:00	38000275	0	\N	\N	297853	0	180256009	4107731	
52539	4550	4107731	1990-12-30	1990-12-30 00:00:00	38000275	0	\N	\N	303247	0	180256009	4107731	
52978	4603	4125906	2014-03-19	2014-03-19 00:00:00	38000275	0	\N	\N	306624	0	288086009	4125906	
54555	4731	4043071	1982-01-01	1982-01-01 00:00:00	38000275	0	\N	\N	315164	0	228557008	4043071	
55351	4826	4107731	1992-10-10	1992-10-10 00:00:00	38000275	0	\N	\N	320951	0	180256009	4107731	
56193	4899	4035793	1990-09-25	1990-09-25 00:00:00	38000275	0	\N	\N	325850	0	15081005	4035793	
60014	5190	4293740	1988-01-20	1988-01-20 00:00:00	38000275	0	\N	\N	345053	0	384700001	4293740	
60145	5200	4107731	1990-09-12	1990-09-12 00:00:00	38000275	0	\N	\N	345853	0	180256009	4107731	
60759	5259	44783196	2008-04-26	2008-04-26 00:00:00	38000275	0	\N	\N	350015	0	699253003	44783196	
61217	5295	4202451	1998-06-10	1998-06-10 00:00:00	38000275	0	\N	\N	352214	0	433112001	4202451	
51582	4476	4107731	1993-03-07	1993-03-07 00:00:00	38000275	0	\N	\N	297856	0	180256009	4107731	
52540	4550	4107731	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	303281	0	180256009	4107731	
52979	4604	4151422	1991-09-10	1991-09-10 00:00:00	38000275	0	\N	\N	306748	0	269911007	4151422	
54556	4731	4043071	1983-11-11	1983-11-11 00:00:00	38000275	0	\N	\N	315211	0	228557008	4043071	
55352	4826	4107731	1991-02-09	1991-02-09 00:00:00	38000275	0	\N	\N	321053	0	180256009	4107731	
56194	4899	4035793	1981-08-04	1981-08-04 00:00:00	38000275	0	\N	\N	325829	0	15081005	4035793	
60015	5190	4125906	1988-01-20	1988-01-20 00:00:00	38000275	0	\N	\N	345053	0	288086009	4125906	
60146	5200	4107731	1990-03-07	1990-03-07 00:00:00	38000275	0	\N	\N	345852	0	180256009	4107731	
60760	5259	4252419	2008-04-19	2008-04-19 00:00:00	38000275	0	\N	\N	350005	0	74016001	4252419	
61218	5295	4151422	1961-09-22	1961-09-22 00:00:00	38000275	0	\N	\N	352282	0	269911007	4151422	
51583	4476	4107731	1992-02-02	1992-02-02 00:00:00	38000275	0	\N	\N	297849	0	180256009	4107731	
52541	4550	4107731	1993-01-24	1993-01-24 00:00:00	38000275	0	\N	\N	303268	0	180256009	4107731	
52980	4604	4293740	2000-04-21	2000-04-21 00:00:00	38000275	0	\N	\N	306760	0	384700001	4293740	
54557	4731	4043071	1983-06-03	1983-06-03 00:00:00	38000275	0	\N	\N	315210	0	228557008	4043071	
56195	4899	4035793	1996-10-29	1996-10-29 00:00:00	38000275	0	\N	\N	325862	0	15081005	4035793	
60016	5190	4125906	1962-06-02	1962-06-02 00:00:00	38000275	0	\N	\N	345057	0	288086009	4125906	
60147	5200	4107731	1991-02-27	1991-02-27 00:00:00	38000275	0	\N	\N	345841	0	180256009	4107731	
60761	5259	4170947	1973-09-29	1973-09-29 00:00:00	38000275	0	\N	\N	350003	0	274474001	4170947	
61221	5298	4151422	1963-10-10	1963-10-10 00:00:00	38000275	0	\N	\N	352409	0	269911007	4151422	
51584	4476	4107731	1991-03-03	1991-03-03 00:00:00	38000275	0	\N	\N	297907	0	180256009	4107731	
52542	4550	4107731	1992-02-23	1992-02-23 00:00:00	38000275	0	\N	\N	303166	0	180256009	4107731	
52981	4604	4125906	2000-04-21	2000-04-21 00:00:00	38000275	0	\N	\N	306760	0	288086009	4125906	
54558	4731	4043071	1982-07-23	1982-07-23 00:00:00	38000275	0	\N	\N	315208	0	228557008	4043071	
56196	4899	4035793	1986-09-02	1986-09-02 00:00:00	38000275	0	\N	\N	325848	0	15081005	4035793	
60017	5190	4125906	1971-05-21	1971-05-21 00:00:00	38000275	0	\N	\N	345051	0	288086009	4125906	
60148	5200	4107731	1992-01-08	1992-01-08 00:00:00	38000275	0	\N	\N	345845	0	180256009	4107731	
60762	5259	4047491	1973-09-29	1973-09-29 00:00:00	38000275	0	\N	\N	350003	0	1225002	4047491	
61222	5298	4125906	1991-08-11	1991-08-11 00:00:00	38000275	0	\N	\N	352438	0	288086009	4125906	
51585	4476	4107731	1990-02-18	1990-02-18 00:00:00	38000275	0	\N	\N	297830	0	180256009	4107731	
52543	4550	4107731	1991-08-18	1991-08-18 00:00:00	38000275	0	\N	\N	303249	0	180256009	4107731	
52987	4606	4163872	1990-10-09	1990-10-09 00:00:00	38000275	0	\N	\N	306857	0	399208008	4163872	
54559	4731	4043071	1982-10-01	1982-10-01 00:00:00	38000275	0	\N	\N	315166	0	228557008	4043071	
56197	4899	4125906	1973-09-10	1973-09-10 00:00:00	38000275	0	\N	\N	325809	0	288086009	4125906	
60018	5191	4151422	1998-03-06	1998-03-06 00:00:00	38000275	0	\N	\N	345089	0	269911007	4151422	
60149	5200	4107731	1991-05-01	1991-05-01 00:00:00	38000275	0	\N	\N	345877	0	180256009	4107731	
60766	5262	4125906	1973-08-20	1973-08-20 00:00:00	38000275	0	\N	\N	350073	0	288086009	4125906	
61223	5298	4125906	1986-07-24	1986-07-24 00:00:00	38000275	0	\N	\N	352437	0	288086009	4125906	
51586	4476	4107731	1993-01-03	1993-01-03 00:00:00	38000275	0	\N	\N	297798	0	180256009	4107731	
52544	4550	4107731	1991-02-10	1991-02-10 00:00:00	38000275	0	\N	\N	303248	0	180256009	4107731	
52988	4606	4125906	2006-10-24	2006-10-24 00:00:00	38000275	0	\N	\N	306866	0	288086009	4125906	
54560	4731	4043071	1983-05-06	1983-05-06 00:00:00	38000275	0	\N	\N	315233	0	228557008	4043071	
56198	4899	4035793	1994-10-18	1994-10-18 00:00:00	38000275	0	\N	\N	325861	0	15081005	4035793	
60019	5191	4293740	1977-08-18	1977-08-18 00:00:00	38000275	0	\N	\N	345061	0	384700001	4293740	
60150	5200	4107731	1992-03-11	1992-03-11 00:00:00	38000275	0	\N	\N	345882	0	180256009	4107731	
60767	5262	4186930	1995-12-03	1995-12-03 00:00:00	38000275	0	\N	\N	350092	0	46706006	4186930	
61224	5299	4043071	1980-12-16	1980-12-16 00:00:00	38000275	0	\N	\N	352510	0	228557008	4043071	
51587	4476	4107731	1991-11-10	1991-11-10 00:00:00	38000275	0	\N	\N	297839	0	180256009	4107731	
52545	4550	4107731	1990-07-15	1990-07-15 00:00:00	38000275	0	\N	\N	303278	0	180256009	4107731	
52989	4606	4243062	2013-06-03	2013-06-03 00:00:00	38000275	0	\N	\N	306867	0	60027007	4243062	
54561	4732	4198190	1970-07-21	1970-07-21 00:00:00	38000275	0	\N	\N	315275	0	80146002	4198190	
56199	4899	4035793	1984-08-21	1984-08-21 00:00:00	38000275	0	\N	\N	325856	0	15081005	4035793	
60020	5191	4125906	1977-08-18	1977-08-18 00:00:00	38000275	0	\N	\N	345061	0	288086009	4125906	
60151	5200	4107731	1992-04-22	1992-04-22 00:00:00	38000275	0	\N	\N	345820	0	180256009	4107731	
60768	5262	4238715	1999-04-25	1999-04-25 00:00:00	38000275	0	\N	\N	350129	0	68254000	4238715	
61225	5299	4043071	1981-02-10	1981-02-10 00:00:00	38000275	0	\N	\N	352541	0	228557008	4043071	
51588	4476	4107731	1990-11-18	1990-11-18 00:00:00	38000275	0	\N	\N	297834	0	180256009	4107731	
52546	4550	4107731	1992-02-02	1992-02-02 00:00:00	38000275	0	\N	\N	303197	0	180256009	4107731	
52990	4606	4170947	2013-06-03	2013-06-03 00:00:00	38000275	0	\N	\N	306867	0	274474001	4170947	
54562	4732	4293740	1997-11-24	1997-11-24 00:00:00	38000275	0	\N	\N	315277	0	384700001	4293740	
56200	4899	4035793	1997-11-04	1997-11-04 00:00:00	38000275	0	\N	\N	325833	0	15081005	4035793	
60021	5191	4151422	2014-09-03	2014-09-03 00:00:00	38000275	0	\N	\N	345090	0	269911007	4151422	
60152	5200	4107731	1993-03-03	1993-03-03 00:00:00	38000275	0	\N	\N	345824	0	180256009	4107731	
60769	5262	4125906	2007-01-29	2007-01-29 00:00:00	38000275	0	\N	\N	350076	0	288086009	4125906	
61226	5299	4043071	1980-11-18	1980-11-18 00:00:00	38000275	0	\N	\N	352540	0	228557008	4043071	
51589	4476	4107731	1992-02-23	1992-02-23 00:00:00	38000275	0	\N	\N	297814	0	180256009	4107731	
52547	4550	4107731	1992-04-05	1992-04-05 00:00:00	38000275	0	\N	\N	303167	0	180256009	4107731	
52991	4607	4243062	1988-10-13	1988-10-13 00:00:00	38000275	0	\N	\N	306875	0	60027007	4243062	
54563	4732	4125906	1997-11-24	1997-11-24 00:00:00	38000275	0	\N	\N	315277	0	288086009	4125906	
56201	4899	4252419	1976-10-15	1976-10-15 00:00:00	38000275	0	\N	\N	325810	0	74016001	4252419	
60023	5193	4078793	2016-09-29	2016-09-29 00:00:00	38000275	0	\N	\N	345218	0	180325003	4078793	
60153	5200	4107731	1992-06-03	1992-06-03 00:00:00	38000275	0	\N	\N	345821	0	180256009	4107731	
60770	5262	4059978	1996-10-31	1996-10-31 00:00:00	38000275	0	\N	\N	350082	0	169553002	4059978	
61227	5299	4043071	1980-07-15	1980-07-15 00:00:00	38000275	0	\N	\N	352508	0	228557008	4043071	
51590	4476	4107731	1992-03-15	1992-03-15 00:00:00	38000275	0	\N	\N	297850	0	180256009	4107731	
52992	4607	4170947	1988-10-13	1988-10-13 00:00:00	38000275	0	\N	\N	306875	0	274474001	4170947	
54564	4732	4058899	1961-11-19	1961-11-19 00:00:00	38000275	0	\N	\N	315273	0	168594001	4058899	
56202	4899	4035793	1993-10-12	1993-10-12 00:00:00	38000275	0	\N	\N	325831	0	15081005	4035793	
60024	5193	4078793	2018-10-11	2018-10-11 00:00:00	38000275	0	\N	\N	345219	0	180325003	4078793	
60154	5200	4107731	1990-08-01	1990-08-01 00:00:00	38000275	0	\N	\N	345925	0	180256009	4107731	
60771	5262	4275113	1990-12-01	1990-12-01 00:00:00	38000275	0	\N	\N	350091	0	65200003	4275113	
61228	5299	4024289	1988-11-10	1988-11-10 00:00:00	38000275	0	\N	\N	352523	0	19490002	4024289	
51591	4476	4107731	1990-03-11	1990-03-11 00:00:00	38000275	0	\N	\N	297902	0	180256009	4107731	
52993	4607	4125906	1984-10-13	1984-10-13 00:00:00	38000275	0	\N	\N	306874	0	288086009	4125906	
54570	4735	4151422	1993-06-20	1993-06-20 00:00:00	38000275	0	\N	\N	315443	0	269911007	4151422	
56203	4899	4035793	1982-08-10	1982-08-10 00:00:00	38000275	0	\N	\N	325859	0	15081005	4035793	
60025	5193	4078793	2017-10-05	2017-10-05 00:00:00	38000275	0	\N	\N	345236	0	180325003	4078793	
60155	5200	4191853	1982-09-04	1982-09-04 00:00:00	38000275	0	\N	\N	345935	0	395142003	4191853	
60772	5262	4163872	2008-06-22	2008-06-22 00:00:00	38000275	0	\N	\N	350122	0	399208008	4163872	
61229	5299	4170947	1988-11-10	1988-11-10 00:00:00	38000275	0	\N	\N	352523	0	274474001	4170947	
51592	4476	4107731	1993-03-28	1993-03-28 00:00:00	38000275	0	\N	\N	297800	0	180256009	4107731	
52994	4608	4107731	1991-11-07	1991-11-07 00:00:00	38000275	0	\N	\N	306974	0	180256009	4107731	
54571	4735	4238715	1990-07-26	1990-07-26 00:00:00	38000275	0	\N	\N	315447	0	68254000	4238715	
56204	4899	4035793	1985-08-27	1985-08-27 00:00:00	38000275	0	\N	\N	325844	0	15081005	4035793	
60026	5193	4202451	2010-06-10	2010-06-10 00:00:00	38000275	0	\N	\N	345180	0	433112001	4202451	
60156	5200	4107731	1990-03-28	1990-03-28 00:00:00	38000275	0	\N	\N	345868	0	180256009	4107731	
60773	5262	4047491	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	350075	0	1225002	4047491	
61230	5299	4043071	1980-09-16	1980-09-16 00:00:00	38000275	0	\N	\N	352533	0	228557008	4043071	
51593	4476	4107731	1993-05-30	1993-05-30 00:00:00	38000275	0	\N	\N	297825	0	180256009	4107731	
52995	4608	4107731	1992-04-02	1992-04-02 00:00:00	38000275	0	\N	\N	306952	0	180256009	4107731	
54572	4735	4058899	1982-04-17	1982-04-17 00:00:00	38000275	0	\N	\N	315451	0	168594001	4058899	
56205	4899	4035793	1991-10-01	1991-10-01 00:00:00	38000275	0	\N	\N	325830	0	15081005	4035793	
60027	5193	4243062	1965-07-30	1965-07-30 00:00:00	38000275	0	\N	\N	345176	0	60027007	4243062	
60157	5200	4107731	1990-12-26	1990-12-26 00:00:00	38000275	0	\N	\N	345907	0	180256009	4107731	
60774	5262	4170947	1990-12-24	1990-12-24 00:00:00	38000275	0	\N	\N	350075	0	274474001	4170947	
61231	5299	4043071	1980-08-19	1980-08-19 00:00:00	38000275	0	\N	\N	352509	0	228557008	4043071	
51594	4476	4107731	1992-07-19	1992-07-19 00:00:00	38000275	0	\N	\N	297770	0	180256009	4107731	
52996	4608	4035793	2017-02-23	2017-02-23 00:00:00	38000275	0	\N	\N	306945	0	15081005	4035793	
54573	4735	4275113	1988-12-25	1988-12-25 00:00:00	38000275	0	\N	\N	315415	0	65200003	4275113	
56206	4899	4337138	1979-09-11	1979-09-11 00:00:00	38000275	0	\N	\N	325808	0	88039007	4337138	
60158	5200	4107731	1990-05-30	1990-05-30 00:00:00	38000275	0	\N	\N	345838	0	180256009	4107731	
61232	5299	4181917	2011-11-13	2011-11-13 00:00:00	38000275	0	\N	\N	352486	0	54550000	4181917	
51595	4476	4107731	1993-01-24	1993-01-24 00:00:00	38000275	0	\N	\N	297855	0	180256009	4107731	
52997	4608	4035793	2003-02-27	2003-02-27 00:00:00	38000275	0	\N	\N	306941	0	15081005	4035793	
54574	4735	40492359	1983-06-16	1983-06-16 00:00:00	38000275	0	\N	\N	315452	0	447365002	40492359	
56207	4899	4035793	1983-08-16	1983-08-16 00:00:00	38000275	0	\N	\N	325796	0	15081005	4035793	
60159	5200	4125906	1974-05-21	1974-05-21 00:00:00	38000275	0	\N	\N	345939	0	288086009	4125906	
61233	5299	4181917	2011-09-18	2011-09-18 00:00:00	38000275	0	\N	\N	352526	0	54550000	4181917	
51596	4476	4107731	1992-10-11	1992-10-11 00:00:00	38000275	0	\N	\N	297823	0	180256009	4107731	
52998	4608	4197460	1967-02-11	1967-02-11 00:00:00	38000275	0	\N	\N	307065	0	313191000	4197460	
54575	4735	4057420	1983-06-16	1983-06-16 00:00:00	38000275	0	\N	\N	315452	0	18286008	4057420	
56208	4899	44783196	1976-10-22	1976-10-22 00:00:00	38000275	0	\N	\N	325851	0	699253003	44783196	
60160	5200	4107731	1992-02-19	1992-02-19 00:00:00	38000275	0	\N	\N	345846	0	180256009	4107731	
61234	5299	4043071	1980-10-14	1980-10-14 00:00:00	38000275	0	\N	\N	352539	0	228557008	4043071	
51597	4476	4107731	1991-04-14	1991-04-14 00:00:00	38000275	0	\N	\N	297810	0	180256009	4107731	
52999	4608	4151422	1977-07-04	1977-07-04 00:00:00	38000275	0	\N	\N	306970	0	269911007	4151422	
54576	4735	4058899	2011-01-15	2011-01-15 00:00:00	38000275	0	\N	\N	315454	0	168594001	4058899	
56209	4899	4035793	1979-07-24	1979-07-24 00:00:00	38000275	0	\N	\N	325828	0	15081005	4035793	
60161	5200	4191853	1990-01-03	1990-01-03 00:00:00	38000275	0	\N	\N	345902	0	395142003	4191853	
61235	5299	4181917	1998-06-06	1998-06-06 00:00:00	38000275	0	\N	\N	352525	0	54550000	4181917	
51598	4476	4107731	1992-11-22	1992-11-22 00:00:00	38000275	0	\N	\N	297797	0	180256009	4107731	
53000	4608	4107731	1993-04-15	1993-04-15 00:00:00	38000275	0	\N	\N	306959	0	180256009	4107731	
54577	4735	4125906	2014-05-29	2014-05-29 00:00:00	38000275	0	\N	\N	315430	0	288086009	4125906	
56210	4899	4035793	1980-07-29	1980-07-29 00:00:00	38000275	0	\N	\N	325858	0	15081005	4035793	
60162	5200	4107731	1991-10-16	1991-10-16 00:00:00	38000275	0	\N	\N	345819	0	180256009	4107731	
61236	5299	4043071	1981-01-13	1981-01-13 00:00:00	38000275	0	\N	\N	352527	0	228557008	4043071	
51599	4476	4107731	1990-05-13	1990-05-13 00:00:00	38000275	0	\N	\N	297833	0	180256009	4107731	
53001	4608	4191853	1990-01-04	1990-01-04 00:00:00	38000275	0	\N	\N	307083	0	395142003	4191853	
54578	4735	4047491	1998-06-22	1998-06-22 00:00:00	38000275	0	\N	\N	315453	0	1225002	4047491	
56211	4899	4035793	1988-09-13	1988-09-13 00:00:00	38000275	0	\N	\N	325849	0	15081005	4035793	
60163	5200	4107731	1992-05-13	1992-05-13 00:00:00	38000275	0	\N	\N	345892	0	180256009	4107731	
61237	5299	4043071	1981-03-17	1981-03-17 00:00:00	38000275	0	\N	\N	352542	0	228557008	4043071	
51600	4476	4107731	1990-08-05	1990-08-05 00:00:00	38000275	0	\N	\N	297818	0	180256009	4107731	
53002	4608	44783196	1987-10-15	1987-10-15 00:00:00	38000275	0	\N	\N	306947	0	699253003	44783196	
54579	4735	4170947	1998-06-22	1998-06-22 00:00:00	38000275	0	\N	\N	315453	0	274474001	4170947	
56212	4899	4035793	1998-11-10	1998-11-10 00:00:00	38000275	0	\N	\N	325847	0	15081005	4035793	
60164	5200	4107731	1993-04-14	1993-04-14 00:00:00	38000275	0	\N	\N	345825	0	180256009	4107731	
61238	5299	4125906	1994-09-10	1994-09-10 00:00:00	38000275	0	\N	\N	352524	0	288086009	4125906	
51601	4476	4107731	1990-06-03	1990-06-03 00:00:00	38000275	0	\N	\N	297904	0	180256009	4107731	
53003	4608	4035793	2019-03-07	2019-03-07 00:00:00	38000275	0	\N	\N	306946	0	15081005	4035793	
54580	4736	4163872	1982-08-17	1982-08-17 00:00:00	38000275	0	\N	\N	315477	0	399208008	4163872	
56213	4899	4035793	1995-10-24	1995-10-24 00:00:00	38000275	0	\N	\N	325832	0	15081005	4035793	
60165	5200	4107731	1990-07-11	1990-07-11 00:00:00	38000275	0	\N	\N	345839	0	180256009	4107731	
61239	5300	4243062	1942-11-17	1942-11-17 00:00:00	38000275	0	\N	\N	352653	0	60027007	4243062	
51602	4476	4107731	1990-10-28	1990-10-28 00:00:00	38000275	0	\N	\N	297820	0	180256009	4107731	
53004	4608	4107731	1992-07-16	1992-07-16 00:00:00	38000275	0	\N	\N	307030	0	180256009	4107731	
54581	4736	4151422	1994-09-30	1994-09-30 00:00:00	38000275	0	\N	\N	315478	0	269911007	4151422	
56214	4899	4035793	1989-09-19	1989-09-19 00:00:00	38000275	0	\N	\N	325846	0	15081005	4035793	
60166	5200	4107731	1992-10-28	1992-10-28 00:00:00	38000275	0	\N	\N	345828	0	180256009	4107731	
61240	5300	4170947	1942-11-17	1942-11-17 00:00:00	38000275	0	\N	\N	352653	0	274474001	4170947	
51603	4476	4107731	1992-06-28	1992-06-28 00:00:00	38000275	0	\N	\N	297841	0	180256009	4107731	
53005	4608	4107731	1993-03-04	1993-03-04 00:00:00	38000275	0	\N	\N	306958	0	180256009	4107731	
54582	4736	4058899	2009-01-25	2009-01-25 00:00:00	38000275	0	\N	\N	315515	0	168594001	4058899	
56215	4899	4125906	1945-06-20	1945-06-20 00:00:00	38000275	0	\N	\N	325814	0	288086009	4125906	
60167	5200	4107731	1990-04-18	1990-04-18 00:00:00	38000275	0	\N	\N	345873	0	180256009	4107731	
61241	5300	4058899	2018-03-18	2018-03-18 00:00:00	38000275	0	\N	\N	352657	0	168594001	4058899	
51604	4476	4107731	1990-04-22	1990-04-22 00:00:00	38000275	0	\N	\N	297903	0	180256009	4107731	
53006	4608	4107731	1991-10-17	1991-10-17 00:00:00	38000275	0	\N	\N	307027	0	180256009	4107731	
54583	4736	4252419	2002-08-23	2002-08-23 00:00:00	38000275	0	\N	\N	315514	0	74016001	4252419	
56226	4905	4125906	2018-09-20	2018-09-20 00:00:00	38000275	0	\N	\N	326059	0	288086009	4125906	
60168	5200	4107731	1992-04-01	1992-04-01 00:00:00	38000275	0	\N	\N	345847	0	180256009	4107731	
61242	5300	4195803	2018-03-18	2018-03-18 00:00:00	38000275	0	\N	\N	352657	0	312681000	4195803	
51605	4476	4163872	1992-05-25	1992-05-25 00:00:00	38000275	0	\N	\N	297852	0	399208008	4163872	
53007	4608	4107731	1991-09-05	1991-09-05 00:00:00	38000275	0	\N	\N	306997	0	180256009	4107731	
54584	4736	44783196	2002-08-30	2002-08-30 00:00:00	38000275	0	\N	\N	315516	0	699253003	44783196	
56227	4905	4058899	1978-07-31	1978-07-31 00:00:00	38000275	0	\N	\N	326057	0	168594001	4058899	
60169	5200	4107731	1990-12-05	1990-12-05 00:00:00	38000275	0	\N	\N	345855	0	180256009	4107731	
61243	5300	4125906	2015-04-19	2015-04-19 00:00:00	38000275	0	\N	\N	352656	0	288086009	4125906	
51606	4476	4107731	1991-12-22	1991-12-22 00:00:00	38000275	0	\N	\N	297840	0	180256009	4107731	
53008	4608	4107731	1991-12-19	1991-12-19 00:00:00	38000275	0	\N	\N	306975	0	180256009	4107731	
54585	4736	4151422	1987-10-29	1987-10-29 00:00:00	38000275	0	\N	\N	315484	0	269911007	4151422	
56228	4907	4170947	1953-03-27	1953-03-27 00:00:00	38000275	0	\N	\N	326194	0	274474001	4170947	
60170	5200	4107731	1991-09-25	1991-09-25 00:00:00	38000275	0	\N	\N	345911	0	180256009	4107731	
61244	5300	4151422	1959-05-24	1959-05-24 00:00:00	38000275	0	\N	\N	352633	0	269911007	4151422	
51607	4476	4107731	1991-07-28	1991-07-28 00:00:00	38000275	0	\N	\N	297848	0	180256009	4107731	
53009	4608	4107731	1990-09-13	1990-09-13 00:00:00	38000275	0	\N	\N	306938	0	180256009	4107731	
54586	4736	4125906	1981-04-01	1981-04-01 00:00:00	38000275	0	\N	\N	315513	0	288086009	4125906	
56229	4907	4243062	1953-03-27	1953-03-27 00:00:00	38000275	0	\N	\N	326194	0	60027007	4243062	
60171	5200	4107731	1991-02-06	1991-02-06 00:00:00	38000275	0	\N	\N	345874	0	180256009	4107731	
61245	5300	4202832	1945-02-13	1945-02-13 00:00:00	38000275	0	\N	\N	352654	0	52765003	4202832	
51608	4476	4107731	1990-12-09	1990-12-09 00:00:00	38000275	0	\N	\N	297905	0	180256009	4107731	
53010	4608	4107731	1990-03-08	1990-03-08 00:00:00	38000275	0	\N	\N	306971	0	180256009	4107731	
56230	4907	4151422	2004-09-07	2004-09-07 00:00:00	38000275	0	\N	\N	326175	0	269911007	4151422	
60172	5200	4107731	1991-11-06	1991-11-06 00:00:00	38000275	0	\N	\N	345879	0	180256009	4107731	
61246	5300	4163971	1945-02-13	1945-02-13 00:00:00	38000275	0	\N	\N	352654	0	45595009	4163971	
51609	4476	4107731	1991-10-20	1991-10-20 00:00:00	38000275	0	\N	\N	297909	0	180256009	4107731	
53011	4608	4035793	2012-01-26	2012-01-26 00:00:00	38000275	0	\N	\N	306944	0	15081005	4035793	
56231	4907	4125906	1964-06-27	1964-06-27 00:00:00	38000275	0	\N	\N	326202	0	288086009	4125906	
60173	5200	4107731	1993-01-20	1993-01-20 00:00:00	38000275	0	\N	\N	345830	0	180256009	4107731	
61247	5300	42535580	1945-02-13	1945-02-13 00:00:00	38000275	0	\N	\N	352654	0	426701000119108	42535580	
51610	4476	4107731	1992-08-09	1992-08-09 00:00:00	38000275	0	\N	\N	297842	0	180256009	4107731	
53012	4608	4107731	1990-03-29	1990-03-29 00:00:00	38000275	0	\N	\N	307085	0	180256009	4107731	
56232	4907	4195803	2016-05-14	2016-05-14 00:00:00	38000275	0	\N	\N	326156	0	312681000	4195803	
60174	5200	4107731	1991-03-20	1991-03-20 00:00:00	38000275	0	\N	\N	345875	0	180256009	4107731	
61248	5300	4163951	1945-02-13	1945-02-13 00:00:00	38000275	0	\N	\N	352654	0	29303009	4163951	
51611	4476	4057420	1975-05-04	1975-05-04 00:00:00	38000275	0	\N	\N	297897	0	18286008	4057420	
53013	4608	4107731	1992-11-19	1992-11-19 00:00:00	38000275	0	\N	\N	307004	0	180256009	4107731	
56233	4907	4198190	1948-02-03	1948-02-03 00:00:00	38000275	0	\N	\N	326167	0	80146002	4198190	
60175	5200	4107731	1991-07-24	1991-07-24 00:00:00	38000275	0	\N	\N	345857	0	180256009	4107731	
61249	5301	4078793	2000-01-13	2000-01-13 00:00:00	38000275	0	\N	\N	352722	0	180325003	4078793	
51612	4476	40492359	1975-05-04	1975-05-04 00:00:00	38000275	0	\N	\N	297897	0	447365002	40492359	
53014	4608	4107731	1990-12-06	1990-12-06 00:00:00	38000275	0	\N	\N	307023	0	180256009	4107731	
56234	4909	4125906	1985-12-25	1985-12-25 00:00:00	38000275	0	\N	\N	326277	0	288086009	4125906	
60176	5200	4107731	1990-02-14	1990-02-14 00:00:00	38000275	0	\N	\N	345903	0	180256009	4107731	
61250	5301	4243062	1925-11-30	1925-11-30 00:00:00	38000275	0	\N	\N	352658	0	60027007	4243062	
53015	4608	4107731	1991-03-21	1991-03-21 00:00:00	38000275	0	\N	\N	306957	0	180256009	4107731	
60177	5200	4107731	1993-05-26	1993-05-26 00:00:00	38000275	0	\N	\N	345826	0	180256009	4107731	
61251	5301	4170947	1925-11-30	1925-11-30 00:00:00	38000275	0	\N	\N	352658	0	274474001	4170947	
53016	4608	4107731	1991-09-26	1991-09-26 00:00:00	38000275	0	\N	\N	306973	0	180256009	4107731	
60178	5200	4107731	1992-12-30	1992-12-30 00:00:00	38000275	0	\N	\N	345810	0	180256009	4107731	
61252	5301	4151422	1949-04-30	1949-04-30 00:00:00	38000275	0	\N	\N	352729	0	269911007	4151422	
53017	4608	4252419	2008-08-23	2008-08-23 00:00:00	38000275	0	\N	\N	307070	0	74016001	4252419	
60179	5200	4107731	1991-07-03	1991-07-03 00:00:00	38000275	0	\N	\N	345909	0	180256009	4107731	
61253	5301	4163872	1974-06-14	1974-06-14 00:00:00	38000275	0	\N	\N	352731	0	399208008	4163872	
53018	4608	4125906	1964-02-27	1964-02-27 00:00:00	38000275	0	\N	\N	307063	0	288086009	4125906	
60180	5200	4107731	1991-08-14	1991-08-14 00:00:00	38000275	0	\N	\N	345910	0	180256009	4107731	
61254	5301	4057420	2002-01-24	2002-01-24 00:00:00	38000275	0	\N	\N	352703	0	18286008	4057420	
53019	4608	4107731	1992-01-09	1992-01-09 00:00:00	38000275	0	\N	\N	307029	0	180256009	4107731	
60181	5200	4107731	1992-06-24	1992-06-24 00:00:00	38000275	0	\N	\N	345893	0	180256009	4107731	
61255	5301	4078793	1999-01-07	1999-01-07 00:00:00	38000275	0	\N	\N	352693	0	180325003	4078793	
53020	4608	4035793	2016-02-18	2016-02-18 00:00:00	38000275	0	\N	\N	307092	0	15081005	4035793	
60182	5200	4125906	1982-03-31	1982-03-31 00:00:00	38000275	0	\N	\N	345940	0	288086009	4125906	
61256	5301	4057420	2001-01-18	2001-01-18 00:00:00	38000275	0	\N	\N	352673	0	18286008	4057420	
53021	4608	4107731	1993-03-25	1993-03-25 00:00:00	38000275	0	\N	\N	306987	0	180256009	4107731	
60183	5200	4107731	1990-11-14	1990-11-14 00:00:00	38000275	0	\N	\N	345906	0	180256009	4107731	
61257	5301	4078793	2003-01-30	2003-01-30 00:00:00	38000275	0	\N	\N	352672	0	180325003	4078793	
53022	4608	4107731	1991-06-13	1991-06-13 00:00:00	38000275	0	\N	\N	306995	0	180256009	4107731	
60184	5200	4107731	1990-01-24	1990-01-24 00:00:00	38000275	0	\N	\N	345851	0	180256009	4107731	
61258	5301	4202451	2003-05-01	2003-05-01 00:00:00	38000275	0	\N	\N	352672	0	433112001	4202451	
53023	4608	4107731	1990-08-02	1990-08-02 00:00:00	38000275	0	\N	\N	306937	0	180256009	4107731	
60185	5200	4107731	1992-12-09	1992-12-09 00:00:00	38000275	0	\N	\N	345829	0	180256009	4107731	
61264	5306	4326177	1989-01-14	1989-01-14 00:00:00	38000275	0	\N	\N	352949	0	430193006	4326177	
53024	4608	4107731	1990-10-25	1990-10-25 00:00:00	38000275	0	\N	\N	306993	0	180256009	4107731	
60186	5200	4107731	1991-01-16	1991-01-16 00:00:00	38000275	0	\N	\N	345840	0	180256009	4107731	
61265	5306	4037675	1989-01-14	1989-01-14 00:00:00	38000275	0	\N	\N	352949	0	162676008	4037675	
53025	4608	4035793	2009-01-08	2009-01-08 00:00:00	38000275	0	\N	\N	307019	0	15081005	4035793	
60187	5200	4107731	1992-07-15	1992-07-15 00:00:00	38000275	0	\N	\N	345822	0	180256009	4107731	
61266	5306	4187458	1989-01-14	1989-01-14 00:00:00	38000275	0	\N	\N	352949	0	415300000	4187458	
53026	4608	4107731	1992-03-12	1992-03-12 00:00:00	38000275	0	\N	\N	306998	0	180256009	4107731	
60188	5200	4107731	1992-08-26	1992-08-26 00:00:00	38000275	0	\N	\N	345823	0	180256009	4107731	
61269	5309	4047491	1962-01-22	1962-01-22 00:00:00	38000275	0	\N	\N	353145	0	1225002	4047491	
53027	4608	4107731	1993-05-06	1993-05-06 00:00:00	38000275	0	\N	\N	306982	0	180256009	4107731	
60189	5200	4107731	1990-08-22	1990-08-22 00:00:00	38000275	0	\N	\N	345904	0	180256009	4107731	
61270	5309	4170947	1962-01-22	1962-01-22 00:00:00	38000275	0	\N	\N	353145	0	274474001	4170947	
53028	4608	4107731	1992-06-25	1992-06-25 00:00:00	38000275	0	\N	\N	306984	0	180256009	4107731	
60190	5200	4107731	1990-05-09	1990-05-09 00:00:00	38000275	0	\N	\N	345869	0	180256009	4107731	
61271	5309	4125906	1957-05-04	1957-05-04 00:00:00	38000275	0	\N	\N	353144	0	288086009	4125906	
53029	4608	4035793	2014-02-06	2014-02-06 00:00:00	38000275	0	\N	\N	307091	0	15081005	4035793	
60191	5200	4107731	1991-06-12	1991-06-12 00:00:00	38000275	0	\N	\N	345856	0	180256009	4107731	
61272	5309	4238715	1971-04-19	1971-04-19 00:00:00	38000275	0	\N	\N	353069	0	68254000	4238715	
53030	4608	4107731	1991-04-11	1991-04-11 00:00:00	38000275	0	\N	\N	307026	0	180256009	4107731	
60192	5200	4107731	1993-02-10	1993-02-10 00:00:00	38000275	0	\N	\N	345895	0	180256009	4107731	
61273	5309	4252419	1955-08-06	1955-08-06 00:00:00	38000275	0	\N	\N	353143	0	74016001	4252419	
53031	4608	4107731	1990-12-27	1990-12-27 00:00:00	38000275	0	\N	\N	306955	0	180256009	4107731	
60193	5200	4107731	1993-03-24	1993-03-24 00:00:00	38000275	0	\N	\N	345896	0	180256009	4107731	
61274	5309	4275113	1969-01-07	1969-01-07 00:00:00	38000275	0	\N	\N	353067	0	65200003	4275113	
53032	4608	4243062	1992-06-20	1992-06-20 00:00:00	38000275	0	\N	\N	307067	0	60027007	4243062	
60194	5200	4107731	1991-12-18	1991-12-18 00:00:00	38000275	0	\N	\N	345880	0	180256009	4107731	
61275	5309	4243062	1967-10-28	1967-10-28 00:00:00	38000275	0	\N	\N	353147	0	60027007	4243062	
53033	4608	4170947	1992-06-20	1992-06-20 00:00:00	38000275	0	\N	\N	307067	0	274474001	4170947	
60195	5200	4107731	1992-11-18	1992-11-18 00:00:00	38000275	0	\N	\N	345809	0	180256009	4107731	
61276	5309	4170947	1967-10-28	1967-10-28 00:00:00	38000275	0	\N	\N	353147	0	274474001	4170947	
53034	4608	4107731	1992-10-08	1992-10-08 00:00:00	38000275	0	\N	\N	307003	0	180256009	4107731	
60196	5200	4107731	1990-10-03	1990-10-03 00:00:00	38000275	0	\N	\N	345905	0	180256009	4107731	
61277	5309	4170947	2018-06-16	2018-06-16 00:00:00	38000275	0	\N	\N	353149	0	274474001	4170947	
53035	4608	4107731	1990-02-15	1990-02-15 00:00:00	38000275	0	\N	\N	307084	0	180256009	4107731	
60197	5200	4107731	1993-06-16	1993-06-16 00:00:00	38000275	0	\N	\N	345898	0	180256009	4107731	
61278	5309	4047491	2018-06-16	2018-06-16 00:00:00	38000275	0	\N	\N	353149	0	1225002	4047491	
53036	4608	4107731	1992-05-14	1992-05-14 00:00:00	38000275	0	\N	\N	306983	0	180256009	4107731	
60198	5200	4107731	1992-01-29	1992-01-29 00:00:00	38000275	0	\N	\N	345881	0	180256009	4107731	
61279	5309	4195803	2018-06-16	2018-06-16 00:00:00	38000275	0	\N	\N	353149	0	312681000	4195803	
53037	4608	4035793	2018-03-01	2018-03-01 00:00:00	38000275	0	\N	\N	307093	0	15081005	4035793	
60199	5200	4107731	1991-09-04	1991-09-04 00:00:00	38000275	0	\N	\N	345818	0	180256009	4107731	
61280	5309	4125906	1986-04-21	1986-04-21 00:00:00	38000275	0	\N	\N	353148	0	288086009	4125906	
53038	4608	4107731	1990-06-21	1990-06-21 00:00:00	38000275	0	\N	\N	306954	0	180256009	4107731	
60200	5200	4107731	1990-10-24	1990-10-24 00:00:00	38000275	0	\N	\N	345854	0	180256009	4107731	
61281	5309	44783196	1955-08-13	1955-08-13 00:00:00	38000275	0	\N	\N	353160	0	699253003	44783196	
53039	4608	4035793	2006-12-28	2006-12-28 00:00:00	38000275	0	\N	\N	307090	0	15081005	4035793	
60201	5201	4163872	1979-05-02	1979-05-02 00:00:00	38000275	0	\N	\N	345989	0	399208008	4163872	
61285	5312	4293740	1971-08-30	1971-08-30 00:00:00	38000275	0	\N	\N	353229	0	384700001	4293740	
53040	4608	4107731	1990-04-19	1990-04-19 00:00:00	38000275	0	\N	\N	306972	0	180256009	4107731	
60204	5203	4151422	1941-05-16	1941-05-16 00:00:00	38000275	0	\N	\N	346112	0	269911007	4151422	
61286	5312	4125906	1971-08-30	1971-08-30 00:00:00	38000275	0	\N	\N	353229	0	288086009	4125906	
53041	4608	4107731	1990-08-23	1990-08-23 00:00:00	38000275	0	\N	\N	307078	0	180256009	4107731	
60205	5203	4216130	1999-02-17	1999-02-17 00:00:00	38000275	0	\N	\N	346136	0	415070008	4216130	
61287	5312	4125906	1942-09-10	1942-09-10 00:00:00	38000275	0	\N	\N	353228	0	288086009	4125906	
53042	4608	4107731	1990-07-12	1990-07-12 00:00:00	38000275	0	\N	\N	307077	0	180256009	4107731	
60206	5203	4336464	1999-02-17	1999-02-17 00:00:00	38000275	0	\N	\N	346136	0	232717009	4336464	
61288	5312	4151422	1961-12-09	1961-12-09 00:00:00	38000275	0	\N	\N	353249	0	269911007	4151422	
53043	4608	4107731	1992-08-06	1992-08-06 00:00:00	38000275	0	\N	\N	306978	0	180256009	4107731	
60207	5203	4336464	2003-03-19	2003-03-19 00:00:00	38000275	0	\N	\N	346137	0	232717009	4336464	
61289	5312	4195803	1998-12-14	1998-12-14 00:00:00	38000275	0	\N	\N	353233	0	312681000	4195803	
53044	4608	4323902	2010-03-18	2010-03-18 00:00:00	38000275	0	\N	\N	307064	0	429609002	4323902	
60208	5203	4216130	2003-03-19	2003-03-19 00:00:00	38000275	0	\N	\N	346137	0	415070008	4216130	
61290	5312	4151422	2005-04-24	2005-04-24 00:00:00	38000275	0	\N	\N	353272	0	269911007	4151422	
53045	4608	4035793	2005-12-22	2005-12-22 00:00:00	38000275	0	\N	\N	307060	0	15081005	4035793	
61293	5314	4125906	1997-05-05	1997-05-05 00:00:00	38000275	0	\N	\N	353457	0	288086009	4125906	
53046	4608	4035793	2011-01-20	2011-01-20 00:00:00	38000275	0	\N	\N	307020	0	15081005	4035793	
61294	5314	4125906	1951-11-19	1951-11-19 00:00:00	38000275	0	\N	\N	353367	0	288086009	4125906	
53047	4608	4107731	1990-11-15	1990-11-15 00:00:00	38000275	0	\N	\N	307080	0	180256009	4107731	
61295	5315	4336464	1979-04-15	1979-04-15 00:00:00	38000275	0	\N	\N	353459	0	232717009	4336464	
53048	4608	4107731	1992-10-29	1992-10-29 00:00:00	38000275	0	\N	\N	306981	0	180256009	4107731	
61296	5315	4216130	1979-04-15	1979-04-15 00:00:00	38000275	0	\N	\N	353459	0	415070008	4216130	
53049	4608	4107731	1993-05-27	1993-05-27 00:00:00	38000275	0	\N	\N	307005	0	180256009	4107731	
61297	5316	4125906	1993-03-30	1993-03-30 00:00:00	38000275	0	\N	\N	353609	0	288086009	4125906	
53050	4608	4107731	1992-09-17	1992-09-17 00:00:00	38000275	0	\N	\N	306980	0	180256009	4107731	
61298	5316	40492359	1984-01-02	1984-01-02 00:00:00	38000275	0	\N	\N	353608	0	447365002	40492359	
53051	4608	4107731	1992-12-31	1992-12-31 00:00:00	38000275	0	\N	\N	306985	0	180256009	4107731	
61299	5316	4057420	1984-01-02	1984-01-02 00:00:00	38000275	0	\N	\N	353608	0	18286008	4057420	
53052	4608	4107731	1991-01-17	1991-01-17 00:00:00	38000275	0	\N	\N	307024	0	180256009	4107731	
61300	5316	4151422	2011-08-04	2011-08-04 00:00:00	38000275	0	\N	\N	353586	0	269911007	4151422	
53053	4608	4035793	2010-01-14	2010-01-14 00:00:00	38000275	0	\N	\N	306943	0	15081005	4035793	
61301	5316	4125906	1966-09-27	1966-09-27 00:00:00	38000275	0	\N	\N	353607	0	288086009	4125906	
53054	4608	4107731	1990-05-31	1990-05-31 00:00:00	38000275	0	\N	\N	307022	0	180256009	4107731	
61302	5317	4151422	2012-08-31	2012-08-31 00:00:00	38000275	0	\N	\N	353654	0	269911007	4151422	
53055	4608	4107731	1992-01-30	1992-01-30 00:00:00	38000275	0	\N	\N	306976	0	180256009	4107731	
53056	4608	4107731	1992-06-04	1992-06-04 00:00:00	38000275	0	\N	\N	307000	0	180256009	4107731	
53057	4608	4107731	1993-06-17	1993-06-17 00:00:00	38000275	0	\N	\N	307032	0	180256009	4107731	
53058	4608	4107731	1991-11-28	1991-11-28 00:00:00	38000275	0	\N	\N	307028	0	180256009	4107731	
53059	4608	4107731	1991-05-02	1991-05-02 00:00:00	38000275	0	\N	\N	306994	0	180256009	4107731	
53060	4608	4107731	1990-05-10	1990-05-10 00:00:00	38000275	0	\N	\N	306953	0	180256009	4107731	
53061	4608	4035793	2015-02-12	2015-02-12 00:00:00	38000275	0	\N	\N	307061	0	15081005	4035793	
53062	4608	4107731	1990-01-25	1990-01-25 00:00:00	38000275	0	\N	\N	306936	0	180256009	4107731	
53063	4608	4107731	1991-07-04	1991-07-04 00:00:00	38000275	0	\N	\N	306949	0	180256009	4107731	
53064	4608	4191853	1993-07-08	1993-07-08 00:00:00	38000275	0	\N	\N	307006	0	395142003	4191853	
53065	4608	4252419	1987-10-08	1987-10-08 00:00:00	38000275	0	\N	\N	307066	0	74016001	4252419	
53066	4608	4107731	1992-08-27	1992-08-27 00:00:00	38000275	0	\N	\N	307031	0	180256009	4107731	
53067	4608	4107731	1992-12-10	1992-12-10 00:00:00	38000275	0	\N	\N	307001	0	180256009	4107731	
53068	4608	4107731	1991-02-28	1991-02-28 00:00:00	38000275	0	\N	\N	307025	0	180256009	4107731	
53069	4608	4107731	1990-10-04	1990-10-04 00:00:00	38000275	0	\N	\N	307079	0	180256009	4107731	
53070	4608	4107731	1991-07-25	1991-07-25 00:00:00	38000275	0	\N	\N	306996	0	180256009	4107731	
53071	4608	4035793	2013-01-31	2013-01-31 00:00:00	38000275	0	\N	\N	307021	0	15081005	4035793	
53072	4608	4035793	2004-12-16	2004-12-16 00:00:00	38000275	0	\N	\N	307089	0	15081005	4035793	
53073	4608	4107731	1991-08-15	1991-08-15 00:00:00	38000275	0	\N	\N	306950	0	180256009	4107731	
53074	4608	4107731	1993-02-11	1993-02-11 00:00:00	38000275	0	\N	\N	306986	0	180256009	4107731	
53075	4608	4107731	1992-02-20	1992-02-20 00:00:00	38000275	0	\N	\N	306951	0	180256009	4107731	
53076	4608	4107731	1993-01-21	1993-01-21 00:00:00	38000275	0	\N	\N	307002	0	180256009	4107731	
53077	4608	4035793	2008-01-03	2008-01-03 00:00:00	38000275	0	\N	\N	306942	0	15081005	4035793	
53078	4608	4107731	1991-02-07	1991-02-07 00:00:00	38000275	0	\N	\N	306956	0	180256009	4107731	
53079	4608	4107731	1991-05-23	1991-05-23 00:00:00	38000275	0	\N	\N	306948	0	180256009	4107731	
53080	4608	4243062	2010-07-14	2010-07-14 00:00:00	38000275	0	\N	\N	307071	0	60027007	4243062	
53081	4608	4170947	2010-07-14	2010-07-14 00:00:00	38000275	0	\N	\N	307071	0	274474001	4170947	
53082	4608	4195803	2010-07-14	2010-07-14 00:00:00	38000275	0	\N	\N	307071	0	312681000	4195803	
53083	4608	4107731	1992-04-23	1992-04-23 00:00:00	38000275	0	\N	\N	306999	0	180256009	4107731	
53089	4613	4295880	2007-01-06	2007-01-06 00:00:00	38000275	0	\N	\N	307279	0	76601001	4295880	
53090	4613	4186930	2001-03-25	2001-03-25 00:00:00	38000275	0	\N	\N	307297	0	46706006	4186930	
53091	4613	4238715	2016-11-20	2016-11-20 00:00:00	38000275	0	\N	\N	307239	0	68254000	4238715	
53092	4613	4170947	1990-03-13	1990-03-13 00:00:00	38000275	0	\N	\N	307232	0	274474001	4170947	
53093	4613	4024289	1990-03-13	1990-03-13 00:00:00	38000275	0	\N	\N	307232	0	19490002	4024289	
53094	4613	4295880	1993-03-13	1993-03-13 00:00:00	38000275	0	\N	\N	307319	0	76601001	4295880	
53095	4613	4186930	2006-03-26	2006-03-26 00:00:00	38000275	0	\N	\N	307278	0	46706006	4186930	
53096	4613	4275113	2014-11-28	2014-11-28 00:00:00	38000275	0	\N	\N	307238	0	65200003	4275113	
53097	4613	4059978	1995-03-03	1995-03-03 00:00:00	38000275	0	\N	\N	307320	0	169553002	4059978	
53098	4613	4275113	1991-03-24	1991-03-24 00:00:00	38000275	0	\N	\N	307276	0	65200003	4275113	
53099	4613	4163872	1996-09-21	1996-09-21 00:00:00	38000275	0	\N	\N	307272	0	399208008	4163872	
53100	4613	4186930	2011-03-27	2011-03-27 00:00:00	38000275	0	\N	\N	307285	0	46706006	4186930	
53101	4613	4275113	1998-02-17	1998-02-17 00:00:00	38000275	0	\N	\N	307277	0	65200003	4275113	
53102	4613	4125906	1980-09-10	1980-09-10 00:00:00	38000275	0	\N	\N	307231	0	288086009	4125906	
53103	4613	4186930	2016-03-27	2016-03-27 00:00:00	38000275	0	\N	\N	307298	0	46706006	4186930	
53104	4613	4186930	1996-03-24	1996-03-24 00:00:00	38000275	0	\N	\N	307250	0	46706006	4186930	
53107	4615	4163872	2004-12-25	2004-12-25 00:00:00	38000275	0	\N	\N	307425	0	399208008	4163872	
\.


--
-- TOC entry 3911 (class 0 OID 3185586)
-- Dependencies: 233
-- Data for Name: provider; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".provider (provider_id, provider_name, npi, dea, specialty_concept_id, care_site_id, year_of_birth, gender_concept_id, provider_source_value, specialty_source_value, specialty_source_concept_id, gender_source_value, gender_source_concept_id) FROM stdin;
\.


--
-- TOC entry 3912 (class 0 OID 3185589)
-- Dependencies: 234
-- Data for Name: relationship; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".relationship (relationship_id, relationship_name, is_hierarchical, defines_ancestry, reverse_relationship_id, relationship_concept_id) FROM stdin;
Acc device used by	Access device used by (SNOMED)	0	0	Using acc device	44818895
Access of	Access of (SNOMED)	0	0	Has access	44818847
Active ing of	Active ingredient of (SNOMED)	0	0	Has active ing	44818859
Admin method of	Dose form administration method of (SNOMED)	0	0	Has admin method	581464
AMP of	Actual Medicinal Product of (SNOMED)	0	0	Has AMP	45905757
Answer of	Answer of (LOINC)	0	0	Has Answer	45754684
Answer of (PPI)	Answer of (PPI)	0	0	Has answer (PPI)	32443
Approach of	Approach of (SNOMED)	0	0	Has approach	45754821
ARP of	ARP of (SNOMED)	0	0	Has ARP	45905797
Asso finding of	Associated finding of (SNOMED)	0	0	Has asso finding	44818868
Asso morph of	Associated morphology of (SNOMED)	0	0	Has asso morph	44818867
Asso proc of	Associated procedure of (SNOMED)	0	0	Has asso proc	44818882
Asso with finding	Associated with finding (SNOMED)	0	0	Finding asso with	44818792
ATC - SNOMED eq	ATC to SNOMED equivalent (RxNorm)	0	0	SNOMED - ATC eq	45754850
ATC to NDFRT eq	ATC to NDFRT equivalent (NDF-RT)	0	0	NDFRT to ATC eq	45754838
ATC to VA Class eq	ATC to VA Class equivalent (NDF-RT)	0	0	VA Class to ATC eq	45754836
Basic dose form of	Basic dose form of (SNOMED)	0	0	Has basic dose form	581460
Basis str subst of	Basis of strength substance of (SNOMED)	0	0	Has basis str subst	45905750
Causative agent of	Causative agent of (SNOMED)	0	0	Has causative agent	44818866
Caused by	Caused by (SNOMED)	0	0	Causes	45754810
Causes	Causes (SNOMED)	0	0	Caused by	45754811
Characterizes	Characterizes (SNOMED)	0	0	Is characterized by	5081
Clinical course of	Has clinical course of (SNOMED)	0	0	Has clinical course	44818896
Component of	Component of (SNOMED)	0	0	Has component	44818865
Conc denom unit of	Concentration strength denominator unit of (SNOMED)	0	0	Has conc denom unit	32436
Conc denom val of	Concentration strength denominator value of (SNOMED)	0	0	Has conc denom val	32434
Conc num unit of	Concentration strength numerator unit of (SNOMED)	0	0	Has conc num unit	32438
Conc num val of	Concentration strength numerator value of (SNOMED)	0	0	Has conc num val	32432
Concept alt_to from	Active alternative_to inactive (SNOMED)	0	0	Concept alt_to to	44818961
Concept alt_to to	Inactive alternative_to active (SNOMED)	0	0	Concept alt_to from	44818960
Concept poss_eq from	Active possibly_equivalent_to inactive (SNOMED)	0	0	Concept poss_eq to	44818963
Concept poss_eq to	Inactive possibly_equivalent_to active (SNOMED)	0	0	Concept poss_eq from	44818962
Concept replaced by	Concept replaced by	0	0	Concept replaces	44818956
Concept replaces	Concept replaces	0	0	Concept replaced by	44818957
Concept same_as from	Active same_as inactive (SNOMED)	0	0	Concept same_as to	44818959
Concept same_as to	Inactive same_as active (SNOMED)	0	0	Concept same_as from	44818958
Concept was_a from	Active was_a inactive (SNOMED)	0	0	Concept was_a to	44818965
Concept was_a to	Inactive was_a active (SNOMED)	0	0	Concept was_a from	44818964
Count of ing of	Count of base of active ingredient of (SNOMED)	0	0	Has count of ing	32442
CPT4 - LOINC eq	CPT4 to LOINC equivalent (SNOMED)	0	0	LOINC - CPT4 eq	45956698
CPT4 - SNOMED eq	CPT-4 to SNOMED equivalent (OMOP)	0	0	SNOMED - CPT4 eq	44818804
Denom value of	Presentation strength denominator value of (SNOMED)	0	0	Has denomin value	581419
Denominator unit of	Presentation strength denominator unit of (SNOMED)	0	0	Has denominator unit	581417
Device used by	Device used by (SNOMED)	0	0	Using device	44818892
Dir device of	Direct device of (SNOMED)	0	0	Has dir device	44818864
Dir morph of	Direct morphology of (SNOMED)	0	0	Has dir morph	44818863
Dir proc site of	Direct procedure site of (SNOMED)	0	0	Has dir proc site	44818883
Dir subst of	Direct substance of (SNOMED)	0	0	Has dir subst	44818862
Direct site of	Direct site of (SNOMED)	0	0	Has direct site	5080
Disc indicator of	Discontinued indicator of (SNOMED)	0	0	Has disc indicator	45905805
Disp dose form of	Dispensed dose form of (SNOMED)	0	0	Has disp dose form	45905748
Disposition of	Disposition of (SNOMED)	0	0	Has disposition	581462
Dose form of	Dose form of (SNOMED)	0	0	Has dose form	44818880
Dose form unit of	Unit relating to the size of (DM+D)	0	0	Has dose form unit	45905754
DRG - MS-DRG eq	DRG to MS-DRG equivalent (CMS)	0	0	MS-DRG - DRG eq	44818936
Drug-drug inter for	Drug-drug interaction for (NDF)	0	0	Has drug-drug inter	44818914
Due to of	Due to of (SNOMED)	0	0	Has due to	44818878
During	During (SNOMED)	0	0	Has complication	581424
Energy used by	Energy used by (SNOMED)	0	0	Using energy	44818893
Episodicity of	Episodicity of (SNOMED)	0	0	Has episodicity	44818861
Etiology of	Etiology of (SNOMED)	0	0	Has etiology	45754813
Excipient of	Excipient of (SNOMED)	0	0	Has excipient	45905790
Excluded in map from	Standard to Non-standard exclude child (OMOP)	0	0	Map excludes child	44818970
Extent of	Extent of (SNOMED)	0	0	Has extent	45754817
FDB Ind - ICD9CM	FDB Indication/Contraindication to ICD-9-CM (FDB)	0	0	ICD9CM - FDB Ind	44819289
Finding asso with	Finding associated with (SNOMED)	0	0	Asso with finding	44818890
Finding context of	Finding context of (SNOMED)	0	0	Has finding context	44818887
Finding inform of	Finding informer of (SNOMED)	0	0	Using finding inform	44818899
Finding method of	Finding method of (SNOMED)	0	0	Using finding method	44818898
Spec active ing of	Specific active ingredient of (SNOMED)	0	0	Has spec active ing	45905749
Specimen identity of	Specimen source identity of (SNOMED)	0	0	Has specimen source	44818874
Specimen morph of	Specimen source morphology of (SNOMED)	0	0	Has specimen morph	44818875
Specimen of	Specimen of (SNOMED)	0	0	Has specimen	44818854
Specimen proc of	Specimen procedure of (SNOMED)	0	0	Has specimen proc	44818873
Specimen subst of	Specimen substance of (SNOMED)	0	0	Has specimen subst	44818877
Specimen topo of	Specimen source topography of (SNOMED)	0	0	Has specimen topo	44818876
Stage of	Stage of (SNOMED)	0	0	Has stage	45754815
State of matter of	State of matter of (SNOMED)	0	0	Has state of matter	581472
Subject matter of	Subject matter domain of (LOINC)	0	0	Has subject matter	32455
Subst used by	Substance used by (SNOMED)	0	0	Using subst	44818894
Supplier of	Supplier or manufacturer of (OMOP)	0	0	Has supplier	249
Surgical appr of	Surgical approach of (SNOMED)	0	0	Has surgical appr	44818891
Technique of	Technique of (SNOMED)	0	0	Has technique	5070
Temp related to	Temporally related to (SNOMED)	0	0	Has temp finding	581473
Temporal context of	Temporal context of (SNOMED)	0	0	Has temporal context	44818889
Time aspect of	Time aspect of (SNOMED)	0	0	Has time aspect	44818872
Topography of ICDO	Topography of ICDO	0	0	Has Topography ICDO	581430
Trade family grp of	Trade family group of (SNOMED)	0	0	Has trade family grp	45905759
Tradename of	Tradename of (RxNorm)	0	0	Has tradename	44818814
Transformation of	Dose form transformation of (SNOMED)	0	0	Has transformation	581470
Typ bill - Freq Code	Typ bill Full to Frequency code (UB04)	0	0	Freq Code - Typ bill	32403
Typ bill - Typ bill3	Typ bill Full to Typ bill 3 digits (UB04)	0	0	Typ bill3 - Typ bill	32405
Typ bill3 - Typ bill	Typ bill 3 digits to Typ bill Full (UB04)	0	0	Typ bill - Typ bill3	32406
Type mapped from	Type concept to non-standard map (OMOP)	0	0	Maps to type	44819240
Type of service of	Type of service of (LOINC)	0	0	Has type of service	32457
UCUM replaced by	Concept replaced by (UCUM)	0	0	UCUM replaces	44818978
UCUM replaces	Concept replaces (UCUM)	0	0	UCUM replaced by	44818979
Unit mapped from	Unit concept to non-standard map (OMOP)	0	0	Maps to unit	44819241
Unit of admin of	Unit of administration of (SNOMED)	0	0	Has unit of admin	32410
Unit of presen of	Unit of presentation of (SNOMED)	0	0	Has unit of presen	32430
Unit of prod use of	Unit relating to the entity that can be handled of (DM+D)	0	0	Has unit of prod use	45905755
Using acc device	Using access device (SNOMED)	0	0	Acc device used by	44818797
Using device	Using device (SNOMED)	0	0	Device used by	44818794
Using energy	Using energy (SNOMED)	0	0	Energy used by	44818795
Using finding inform	Using finding informer (SNOMED)	0	0	Finding inform of	44818801
Using finding method	Using finding method (SNOMED)	0	0	Finding method of	44818800
Using subst	Using substance (SNOMED)	0	0	Subst used by	44818796
VA Class - SNOMED eq	VA Class to SNOMED equivalent (RxNorm)	0	0	SNOMED - VA Class eq	45754848
VA Class to ATC eq	VA Class to ATC equivalent (NDF-RT)	0	0	ATC to VA Class eq	45754835
VA Class to NDFRT eq	VA Class to NDFRT equivalent (NDF-RT)	0	0	NDFRT to VA Class eq	45754839
Value mapped from	Value_as_concept to non-standard map (OMOP)	0	0	Maps to value	44819242
VAProd - NDFRT	VA Product to NDF-RT (NDF-RT)	0	0	NDFRT - VAProd	44818942
VMP has prescr stat	VMP has prescribing status (SNOMED)	0	0	VMP prescr stat of	45905810
VMP of	Virtual Medicinal Product of (SNOMED)	0	0	Has VMP	45905751
VMP prescr stat of	VMP prescribing status of (SNOMED)	0	0	VMP has prescr stat	45905811
VRP has prescr stat	VRP has prescribing status (SNOMED)	0	0	VRP prescr stat of	45905806
VRP of	VRP of (SNOMED)	0	0	Has VRP	45905799
VRP prescr stat of	VRP prescribing status of (SNOMED)	0	0	VRP has prescr stat	45905807
Finding site of	Finding site of (SNOMED)	0	0	Has finding site	44818860
Flavor of	Flavor of (SNOMED)	0	0	Has flavor	45905803
Focus of	Focus of (SNOMED)	0	0	Has focus	44818857
Followed by	Followed by (SNOMED)	0	0	Follows	45905793
Follows	Follows (SNOMED)	0	0	Followed by	45905792
Form of	Form of (RxNorm)	0	0	Has form	44818816
Freq Code - Typ bill	Frequency code to Typ bill Full (UB04)	0	0	Typ bill - Freq Code	32404
Has access	Has access (SNOMED)	0	0	Access of	44818749
Has active ing	Has active ingredient (SNOMED)	0	0	Active ing of	44818761
Has admin method	Has dose form administration method (SNOMED)	0	0	Admin method of	581463
Has AMP	Has Actual Medicinal Product (SNOMED)	0	0	AMP of	45905745
Has Answer	Has Answer (LOINC)	0	0	Answer of	45754683
Has answer (PPI)	Has answer (PPI)	0	0	Answer of (PPI)	32444
Has approach	Has Approach (SNOMED)	0	0	Approach of	45754820
Has ARP	Has ARP (SNOMED)	0	0	ARP of	45905796
Has asso finding	Has associated finding (SNOMED)	0	0	Asso finding of	44818770
Has asso morph	Has associated morphology (SNOMED)	0	0	Asso morph of	44818769
Has asso proc	Has associated procedure (SNOMED)	0	0	Asso proc of	44818784
Has basic dose form	Has basic dose form (SNOMED)	0	0	Basic dose form of	581459
Has basis str subst	Has basis of strength substance (SNOMED)	0	0	Basis str subst of	45905738
Has causative agent	Has causative agent (SNOMED)	0	0	Causative agent of	44818768
Has CI	Has drug contra-indication (FDB)	0	0	Is CI of	44818808
Has clinical course	Has clinical course (SNOMED)	0	0	Clinical course of	44818798
Has complication	Has complication (SNOMED)	0	0	During	581425
Has component	Has component (SNOMED)	0	0	Component of	44818767
Has conc denom unit	Has concentration strength denominator unit (SNOMED)	0	0	Conc denom unit of	32435
Has conc denom val	Has concentration strength denominator value (SNOMED)	0	0	Conc denom val of	32433
Has conc num unit	Has concentration strength numerator unit (SNOMED)	0	0	Conc num unit of	32437
Has conc num val	Has concentration strength numerator value (SNOMED)	0	0	Conc num val of	32431
Has count of ing	Has count of base of active ingredient (SNOMED)	0	0	Count of ing of	32441
Has denomin value	Has presentation strength denominator value (SNOMED)	0	0	Denom value of	581418
Has denominator unit	Has presentation strength denominator unit (SNOMED)	0	0	Denominator unit of	581416
Has dir device	Has direct device (SNOMED)	0	0	Dir device of	44818766
Has dir morph	Has direct morphology (SNOMED)	0	0	Dir morph of	44818765
Has dir proc site	Has direct procedure site (SNOMED)	0	0	Dir proc site of	44818785
Has dir subst	Has direct substance (SNOMED)	0	0	Dir subst of	44818764
Has direct site	Has direct site (SNOMED)	0	0	Direct site of	5079
Has disc indicator	Has discontinued indicator (SNOMED)	0	0	Disc indicator of	45905804
Has disp dose form	Has dispensed dose form (SNOMED)	0	0	Disp dose form of	45905736
Has disposition	Has disposition (SNOMED)	0	0	Disposition of	581461
Has dose form	Has dose form (SNOMED)	0	0	Dose form of	44818782
Has dose form unit	Has unit relating to the size (DM+D)	0	0	Dose form unit of	45905742
Has drug-drug inter	Is involved in drug-drug interaction (NDF)	0	0	Drug-drug inter for	44818915
Has due to	Has due to (SNOMED)	0	0	Due to of	44818780
Has episodicity	Has episodicity (SNOMED)	0	0	Episodicity of	44818763
Has etiology	Has Etiology (SNOMED)	0	0	Etiology of	45754812
Has excipient	Has excipient (SNOMED)	0	0	Excipient of	45905791
Has extent	Has Extent (SNOMED)	0	0	Extent of	45754816
Has finding context	Has finding context (SNOMED)	0	0	Finding context of	44818789
Has finding site	Has finding site (SNOMED)	0	0	Finding site of	44818762
Has flavor	Has flavor (SNOMED)	0	0	Flavor of	45905802
Has focus	Has focus (SNOMED)	0	0	Focus of	44818759
Has form	Has form (RxNorm)	0	0	Form of	44818718
Has Histology ICDO	Has Histology ICDO	0	0	Histology of ICDO	581427
Has incipient	Has incipient (DM+D)	0	0	Incipient of	45905740
Has indir device	Has indirect device (SNOMED)	0	0	Indir device of	44818755
Has indir morph	Has indirect morphology (SNOMED)	0	0	Indir morph of	44818754
Has indir proc site	Has indirect procedure site (SNOMED)	0	0	Indir proc site of	44818786
Has inherent	Has inherent (SNOMED)	0	0	Inheres in	5078
Has inherent loc	Has inherent location (SNOMED)	0	0	Inherent location of	5067
Has intended site	Has dose form intended site (SNOMED)	0	0	Intended site of	581465
Has intent	Has intent (SNOMED)	0	0	Intent of	44818758
Has interpretation	Has interpretation (SNOMED)	0	0	Interpretation of	44818757
Has interprets	Has interprets (SNOMED)	0	0	Interprets of	44818753
Has kind	Has kind (LOINC)	0	0	Kind of	32460
Has laterality	Has laterality (SNOMED)	0	0	Laterality of	44818752
Has legal category	Has legal category (SNOMED)	0	0	Legal category of	45905812
Has licensed route	Has licensed route (DM+D)	0	0	Licensed route of	45905741
Has manifestation	Has definitional manifestation (SNOMED)	0	0	Manifestation of	44818760
Has meas component	Has Measured Component (SNOMED)	0	0	Meas component of	45754808
Has measurement	Has measurement method (SNOMED)	0	0	Measurement of	44818771
Has method	Has method (SNOMED)	0	0	Method of	44818751
Has modification	Has modification of (SNOMED)	0	0	Modification of	32440
Has Module	Has Module	0	0	Module of	581406
Has morphology	Has Morphology (SNOMED)	0	0	Morphology of	45754806
Has non-avail ind	Has VMP non-availability indicator (SNOMED)	0	0	Non-avail ind of	45905794
Has numerator unit	Has presentation strength numerator unit (SNOMED)	0	0	Numerator unit of	581420
Has numerator value	Has presentation strength numerator value (SNOMED)	0	0	Numerator value of	581422
Has occurrence	Has occurrence (SNOMED)	0	0	Occurrence of	44818750
Has pack	Has pack (SNOMED)	0	0	Is pack of	45905758
Has part of	Has part of (SNOMED)	0	0	Part of	44818746
Has pathology	Has pathological process (SNOMED)	0	0	Pathology of	44818745
Has pharma prep	Has pharmaceutical preparation (NDF)	0	0	Pharma prep in	44818916
Has PPI parent code	Has PPI parent code	0	0	PPI parent code of	32469
Has prec ingredient	Has precise active ingredient (SNOMED)	0	0	Prec ingredient of	32427
Has precise ing	Has precise ingredient (RxNorm)	0	0	Precise ing of	44818715
Has precondition	Has precondition (SNOMED)	0	0	Precondition of	5065
Has priority	Has priority (SNOMED)	0	0	Priority of	44818744
Has proc context	Has procedure context (SNOMED)	0	0	Proc context of	44818790
Has proc device	Has procedure device (SNOMED)	0	0	Proc device of	44818787
Has proc morph	Has procedure morphology (SNOMED)	0	0	Proc morph of	44818788
Has proc site	Has procedure site (SNOMED)	0	0	Proc site of	44818743
Has process output	Has process output (SNOMED)	0	0	Process output of	5073
Has property	Has property (SNOMED)	0	0	Property of	44818772
Has property type	Has property type (SNOMED)	0	0	Property type of	5075
Has recipient cat	Has recipient category (SNOMED)	0	0	Recipient cat of	44818742
Has relat context	Has subject relationship context (SNOMED)	0	0	Relat context of	44818781
Has relative part	Has relative part (SNOMED)	0	0	Relative part of	5071
Has release charact	Has dose form release characteristic (SNOMED)	0	0	Release charact of	581467
Has revision status	Has revision status (SNOMED)	0	0	Revision status of	44818748
Has role	Has role (LOINC)	0	0	Role of	32458
Has route	Has route (DM+D)	0	0	Route of	45905744
Has route of admin	Has route of administration (SNOMED)	0	0	Route of admin of	44818799
Has scale type	Has scale type (SNOMED)	0	0	Scale type of	44818773
Has setting	Has setting (LOINC)	0	0	Setting of	32462
Has severity	Has severity (SNOMED)	0	0	Severity of	44818747
Has spec active ing	Has specific active ingredient (SNOMED)	0	0	Spec active ing of	45905737
Has specimen	Has specimen (SNOMED)	0	0	Specimen of	44818756
Has specimen morph	Has specimen source morphology (SNOMED)	0	0	Specimen morph of	44818777
Has specimen proc	Has specimen procedure (SNOMED)	0	0	Specimen proc of	44818775
Has specimen source	Has specimen source identity (SNOMED)	0	0	Specimen identity of	44818776
Has specimen subst	Has specimen substance (SNOMED)	0	0	Specimen subst of	44818779
Has specimen topo	Has specimen source topography (SNOMED)	0	0	Specimen topo of	44818778
Has stage	Has Stage (SNOMED)	0	0	Stage of	45754814
Has standard brand	Has standard Brand Name (OMOP)	0	0	Is standard brand of	228
Has standard form	Has standard Dose Form (OMOP)	0	0	Is standard form of	230
Has standard ing	Has standard ingredient (OMOP)	0	0	Is standard ing of	226
Has state of matter	Has state of matter (SNOMED)	0	0	State of matter of	581471
Has subject matter	Has subject matter domain (LOINC)	0	0	Subject matter of	32454
Has supplier	Has supplier or manufacturer (OMOP)	0	0	Supplier of	248
Has surgical appr	Has surgical approach (SNOMED)	0	0	Surgical appr of	44818793
Has technique	Has technique (SNOMED)	0	0	Technique of	5069
Has temp finding	Has temporal finding (SNOMED)	0	0	Temp related to	581474
Has temporal context	Has temporal context (SNOMED)	0	0	Temporal context of	44818791
Has therap class	Has therapeutic class (NDF)	0	0	Therap class of	44818912
Has time aspect	Has time aspect (SNOMED)	0	0	Time aspect of	44818774
Has Topic	Has Topic	0	0	Topic of	581415
Has Topography ICDO	Has Topography ICDO	0	0	Topography of ICDO	581429
Has trade family grp	Has trade family group (SNOMED)	0	0	Trade family grp of	45905747
Has transformation	Has dose form transformation (SNOMED)	0	0	Transformation of	581469
Has type of service	Has type of service (LOINC)	0	0	Type of service of	32456
Has unit of admin	Has unit of administration (SNOMED)	0	0	Unit of admin of	32409
Has unit of presen	Has unit of presentation (SNOMED)	0	0	Unit of presen of	32429
Has unit of prod use	Has unit relating to the entity that can be handled (DM+D)	0	0	Unit of prod use of	45905743
Has VMP	Has Virtual Medicinal Product (SNOMED)	0	0	VMP of	45905739
Has VRP	Has VRP (SNOMED)	0	0	VRP of	45905798
Histology of ICDO	Histology of ICDO	0	0	Has Histology ICDO	581428
ICD9CM - FDB Ind	ICD-9-CM to FDB Indication/Contraindication (FDB)	0	0	FDB Ind - ICD9CM	44819288
ICD9CM - MedDRA	ICD-9-CM to MedDRA (MSSO)	0	0	MedDRA - ICD9CM	44819286
ICD9P - SNOMED eq	ICD-9-Procedure to SNOMED equivalent (OMOP)	0	0	SNOMED - ICD9P eq	44818802
ICD9P replaced by	Concept replaced by (ICD-9-Procedure)	0	0	ICD9P replaces	44818971
ICD9P replaces	Concept replaces (ICD-9-Procedure)	0	0	ICD9P replaced by	44818972
ICDO - SNOMED	ICDO - SNOMED	0	0	SNOMED - ICDO	581431
Incipient of	Incipient of (DM+D)	0	0	Has incipient	45905752
Included in map from	Standard to Non-standard include child (OMOP)	0	0	Map includes child	44818973
Ind/CI - SNOMED	Indication/Contra-indication to SNOMED	0	0	SNOMED - ind/CI	44818910
Indir device of	Indirect device of (SNOMED)	0	0	Has indir device	44818853
Indir morph of	Indirect morphology of (SNOMED)	0	0	Has indir morph	44818852
Indir proc site of	Indirect procedure site of (SNOMED)	0	0	Has indir proc site	44818884
Inherent location of	Inherent location of (SNOMED)	0	0	Has inherent loc	5068
Inheres in	Inheres in (SNOMED)	0	0	Has inherent	5077
Intended site of	Dose form intended site of (SNOMED)	0	0	Has intended site	581466
Intent of	Intent of (SNOMED)	0	0	Has intent	44818856
Interpretation of	Interpretation of (SNOMED)	0	0	Has interpretation	44818855
Interprets of	Interprets of (SNOMED)	0	0	Has interprets	44818851
Is characterized by	Is characterized by (SNOMED)	0	0	Characterizes	5082
Is CI of	Is contra-indication of (FDB)	0	0	Has CI	44818906
Is pack of	Is pack of (SNOMED)	0	0	Has pack	45905746
Is standard brand of	Is standard Brand Name of (OMOP)	0	0	Has standard brand	227
Is standard form of	Is standard Dose Form of (OMOP)	0	0	Has standard form	229
Kind of	Kind of (LOINC)	0	0	Has kind	32461
Laterality of	Laterality of (SNOMED)	0	0	Has laterality	44818850
Legal category of	Legal category of (SNOMED)	0	0	Has legal category	45905813
Licensed route of	Licensed route of (DM+D)	0	0	Has licensed route	45905753
LOINC - CPT4 eq	LOINC to CPT4 equivalent (SNOMED)	0	0	CPT4 - LOINC eq	45956697
LOINC - SNOMED eq	LOINC Hierarchy to SNOMED equivalent (LOINC)	0	0	SNOMED - LOINC eq	45956695
LOINC replaced by	Concept replaced by (LOINC)	0	0	LOINC replaces	44818714
LOINC replaces	Concept replaces (LOINC)	0	0	LOINC replaced by	44818812
Manifestation of	Definitional manifestation of (SNOMED)	0	0	Has manifestation	44818858
Map excludes child	Non-standard to Standard exclude child (OMOP)	0	0	Excluded in map from	44818974
Map includes child	Non-standard to Standard include child (OMOP)	0	0	Included in map from	44818975
Mapped from	Standard to Non-standard map (OMOP)	0	0	Maps to	44818976
Maps to	Non-standard to Standard map (OMOP)	0	0	Mapped from	44818977
Maps to number	Non-standard to value_as_number map (OMOP)	0	0	Number mapped from	45754885
Maps to operator	Non-standard to operator concept map (OMOP)	0	0	Operator mapped from	45754883
Maps to type	Non-standard to type concept map (OMOP)	0	0	Type mapped from	44819237
Maps to unit	Non-standard to unit concept map (OMOP)	0	0	Unit mapped from	44819238
Maps to value	Non-standard to value_as_concept map (OMOP)	0	0	Value mapped from	44819239
Meas component of	Measured Component of (SNOMED)	0	0	Has meas component	45754809
Measurement of	Measurement method of (SNOMED)	0	0	Has measurement	44818869
MedDRA - ICD9CM	MedDRA to ICD-9-CM (MSSO)	0	0	ICD9CM - MedDRA	44819287
MedDRA - SMQ	MedDRA contained in SMQ (MedDRA)	0	0	SMQ - MedDRA	44818909
Method of	Method of (SNOMED)	0	0	Has method	44818849
Modification of	Is modification of (SNOMED)	0	0	Has modification	32439
Morphology of	Morphology of (SNOMED)	0	0	Has morphology	45754807
MS-DRG - DRG eq	MS-DRG to DRG equivalent (CMS)	0	0	DRG - MS-DRG eq	44818937
Multilex has ing	Has ingredient (Multilex)	0	0	Multilex ing of	44818950
Multilex ing of	Ingredient of (Multilex)	0	0	Multilex has ing	44818951
NDFRT - SNOMED eq	NDF-RT to SNOMED equivalent (RxNorm)	0	0	SNOMED - NDFRT eq	45754846
NDFRT - VAProd	NDF-RT to VA Product (NDF-RT)	0	0	VAProd - NDFRT	44818943
NDFRT to ATC eq	NDFRT to ATC equivalent (NDF-RT)	0	0	ATC to NDFRT eq	45754837
NDFRT to VA Class eq	NDFRT to VA Class equivalent (NDF-RT)	0	0	VA Class to NDFRT eq	45754840
Non-avail ind of	VMP non-availability indicator of (SNOMED)	0	0	Has non-avail ind	45905795
Number mapped from	Value_as_number to non-standard map (OMOP)	0	0	Maps to number	45754886
Numerator unit of	Presentation strength numerator unit of (SNOMED)	0	0	Has numerator unit	581421
Numerator value of	Presentation strength numerator value of (SNOMED)	0	0	Has numerator value	581423
Occurrence of	Occurrence of (SNOMED)	0	0	Has occurrence	44818848
Occurs after	Occurs after (SNOMED)	0	0	Occurs before	44818783
Occurs before	Occurs before (SNOMED)	0	0	Occurs after	44818881
Operator mapped from	Operator concept to non-standard map (OMOP)	0	0	Maps to operator	45754884
Part of	Part of (SNOMED)	0	0	Has part of	44818844
Pathology of	Pathological process of (SNOMED)	0	0	Has pathology	44818843
PPI parent code of	PPI parent code of	0	0	Has PPI parent code	32470
Prec ingredient of	Precise active ingredient of (SNOMED)	0	0	Has prec ingredient	32428
Precise ing of	Precise ingredient of (RxNorm)	0	0	Has precise ing	44818813
Precondition of	Precondition of (SNOMED)	0	0	Has precondition	5066
Prep to Chem eq	Pharmaceutical Preparation to Chemical Structure equivalent (NDF-RT)	0	0	Chem to Prep eq	45754842
Priority of	Priority of (SNOMED)	0	0	Has priority	44818842
Proc context of	Procedure context of (SNOMED)	0	0	Has proc context	44818888
Proc device of	Procedure device of (SNOMED)	0	0	Has proc device	44818885
Proc morph of	Procedure morphology of (SNOMED)	0	0	Has proc morph	44818886
Proc site of	Procedure site of (SNOMED)	0	0	Has proc site	44818841
Process output of	Process output of (SNOMED)	0	0	Has process output	5074
Property of	Property of (SNOMED)	0	0	Has property	44818870
Property type of	Property type of (SNOMED)	0	0	Has property type	5076
Quantified form of	Quantified form of (RxNorm)	0	0	Has quantified form	45754828
Recipient cat of	Recipient category of (SNOMED)	0	0	Has recipient cat	44818840
Reformulation of	Reformulation of (RxNorm)	0	0	Reformulated in	44818722
Relat context of	Subject relationship context of (SNOMED)	0	0	Has relat context	44818879
Relative part of	Relative part of (SNOMED)	0	0	Has relative part	5072
Release charact of	Dose form release characteristic of (SNOMED)	0	0	Has release charact	581468
Revision status of	Revision status of (SNOMED)	0	0	Has revision status	44818846
Role of	Role of (LOINC)	0	0	Has role	32459
Route of	Route of (DM+D)	0	0	Has route	45905756
Route of admin of	Route of administration of (SNOMED)	0	0	Has route of admin	44818897
RxNorm - ATC	RxNorm to ATC	0	0	ATC - RxNorm	44818908
RxNorm - ATC name	RxNorm to ATC equivalent by concept_name (OMOP)	0	0	ATC - RxNorm name	44818927
RxNorm - ETC name	RxNorm to ETC equivalent by concept_name (OMOP)	0	0	ETC - RxNorm name	44818925
RxNorm - NDFRT eq	RxNorm to NDF-RT equivalent (RxNorm)	0	0	NDFRT - RxNorm eq	44818839
RxNorm - NDFRT name	RxNorm to NDF-RT equivalent by concept_name (OMOP)	0	0	NDFRT - RxNorm name	44818922
RxNorm - SNOMED eq	RxNorm to SNOMED equivalent (RxNorm)	0	0	SNOMED - RxNorm eq	45754844
RxNorm - Source eq	RxNorm to Drug Source equivalent (OMOP)	0	0	Source - RxNorm eq	44818952
RxNorm - VAProd eq	RxNorm to VA Product equivalent (NDF-RT)	0	0	VAProd - RxNorm eq	44818945
RxNorm replaced by	Concept replaced by (RxNorm)	0	0	RxNorm replaces	44818946
RxNorm replaces	Concept replaces (RxNorm)	0	0	RxNorm replaced by	44818947
Scale type of	Scale type of (SNOMED)	0	0	Has scale type	44818871
Setting of	Setting of (LOINC)	0	0	Has setting	32463
Severity of	Severity of (SNOMED)	0	0	Has severity	44818845
SMQ - MedDRA	SMQ consists of MedDRA (MedDRA)	0	0	MedDRA - SMQ	44818811
SNOMED - ATC eq	SNOMED to ATC equivalent (RxNorm)	0	0	ATC - SNOMED eq	45754849
SNOMED - ICDO	SNOMED - ICDO	0	0	ICDO - SNOMED	581432
SNOMED - ind/CI	SNOMED to Indication/Contra-indication	0	0	Ind/CI - SNOMED	44818911
SNOMED - LOINC eq	SNOMED to LOINC Hierarchy equivalent (LOINC)	0	0	LOINC - SNOMED eq	45956696
SNOMED - MedDRA eq	SNOMED to MedDRA equivalent (OMOP)	0	0	MedDRA - SNOMED eq	44818903
SNOMED - NDFRT eq	SNOMED to NDF-RT equivalent (RxNorm)	0	0	NDFRT - SNOMED eq	45754845
SNOMED - RxNorm eq	SNOMED to RxNorm equivalent (RxNorm)	0	0	RxNorm - SNOMED eq	45754843
SNOMED - VA Class eq	SNOMED to VA Class equivalent (RxNorm)	0	0	VA Class - SNOMED eq	45754847
Box of	Prepackaged box of (OMOP)	1	0	Available as box	224
Brand name of	Brand name of (OMOP)	1	0	Has brand name	222
Chem to Prep eq	Chemical Structure to Pharmaceutical Preparation equivalent (NDF-RT)	1	0	Prep to Chem eq	45754841
CI by	Contraindicated by (NDF-RT)	1	0	CI to	44818833
CI chem class of	Contraindicating chemical class of (NDF-RT)	1	0	Has CI chem class	44818828
CI MoA of	Contraindicating mechanism of action of (NDF-RT)	1	0	Has CI MoA	44818830
CI physiol effect by	Contraindicating physiological effect induced by (NDF-RT)	1	0	Has CI physio effect	44818826
CI to	Contraindication to (NDF-RT)	1	0	CI by	44818735
CMS Specialty - NUCC	CMS Specialty to NUCC (CMS)	1	0	NUCC - CMS Specialty	44818935
Consists of	Consists of (RxNorm)	1	0	Constitutes	44818818
Contained in panel	Contained in panel (LOINC)	1	0	Panel contains	46233679
Contains	Contains (RxNorm)	1	0	Contained in	44818721
CPT4 - SNOMED cat	CPT-4 to SNOMED category (OMOP)	1	0	SNOMED cat - CPT4	44818803
Diagnosed through	Diagnosed through (NDF-RT)	1	0	May diagnose	44818824
Domain subsumes	Domain subsumes (OMOP)	1	0	Is domain	44818968
DRG - MDC cat	DRG to MDC category (CMS)	1	0	MDC cat - DRG	44818938
Drug has drug class	Drug has drug class (OMOP)	1	0	Drug class of drug	234
Version contains	OMOP CDM Version contains table/field (OMOP)	1	0	Contained in version	32520
Has brand name	Has brand name (OMOP)	1	0	Brand name of	221
Has chem structure	Has chemical structure (NDF-RT)	1	0	Chem structure of	44818740
Has CI chem class	Has contraindicating chemical class (NDF-RT)	1	0	CI chem class of	44818730
Has CI MoA	Has contraindicating mechanism of action (NDF-RT)	1	0	CI MoA of	44818732
Has CI physio effect	Has contraindicating physiological effect (NDF-RT)	1	0	CI physiol effect by	44818728
Has dose form group	Has dose form group (RxNorm)	1	0	Dose form group of	5027
Has FDA-appr ind	Has FDA-approved drug indication (FDB)	1	0	Is FDA-appr ind of	44818806
Has inferred class	Has inferred drug class (OMOP)	1	0	Inferred class of	44818919
Has metabolism	Has site of metabolism (NDF-RT)	1	0	Metabolism of	44818738
Has metabolites	Has active metabolites (NDF-RT)	1	0	Metabolite of	44818737
Has MoA	Has mechanism of action (NDF-RT)	1	0	MoA of	44818731
Has off-label ind	Has off-label drug indication (FDB)	1	0	Is off-label ind of	44818807
Has physio effect	Has physiological effect (NDF-RT)	1	0	Physiol effect by	44818727
Has PK	Has pharmacokinetics (NDF-RT)	1	0	PK of	44818733
Has product comp	Has product component (NDF-RT)	1	0	Product comp of	45754851
HCPCS - SNOMED meas	HCPCS is a SNOMED measurement (OMOP)	1	0	SNOMED meas - HCPCS	44818967
HCPCS - SNOMED proc	HCPCS is a SNOMED procedure (OMOP)	1	0	SNOMED proc - HCPCS	44818921
HOI - MedDRA	HOI contains MedDRA (OMOP)	1	0	MedDRA - HOI	44818932
Induced by	Induced by (NDF-RT)	1	0	Induces	44818823
Induces	Induces (NDF-RT)	1	0	Induced by	44818725
Inhibits effect	Inhibits effect (NDF-RT)	1	0	May be inhibited by	44818837
Is a	Is a	1	0	Subsumes	44818821
Is domain	Is a domain (OMOP)	1	0	Domain subsumes	44818969
Marketed form of	Marketed form of (OMOP)	1	0	Has marketed form	247
May be inhibited by	Effect may be inhibited by (NDF-RT)	1	0	Inhibits effect	44818739
May diagnose	May diagnose (NDF-RT)	1	0	Diagnosed through	44818726
May prevent	May prevent (NDF-RT)	1	0	May be prevented by	44818736
May treat	May treat (NDF-RT)	1	0	May be treated by	44818734
MedDRA - HOI	MedDRA contained in HOI (OMOP)	1	0	HOI - MedDRA	44818933
Metabolism of	Site of metabolism of (NDF-RT)	1	0	Has metabolism	44818836
Metabolite of	Active metabolite of (NDF-RT)	1	0	Has metabolites	44818835
NDFRT dose form of	Dose form of (NDF-RT)	1	0	NDFRT has dose form	44818822
NDFRT has dose form	Has dose form (NDF-RT)	1	0	NDFRT dose form of	44818724
NDFRT has ing	Has ingredient (NDF-RT)	1	0	NDFRT ing of	44818729
OPCS4 - SNOMED	OPCS4 to SNOMED equivalent or categorical (NHS)	1	0	SNOMED - OPCS4	45956699
PK of	Pharmacokinetics of (NDF-RT)	1	0	Has PK	44818831
PoS - Visit cat	Place of Service to Visit category (OMOP)	1	0	Visit cat - PoS	44818941
RxNorm - CVX	RxNorm - CVX (OMOP)	1	0	CVX - RxNorm	581402
RxNorm - DOI	RxNorm contained in DOI (OMOP)	1	0	DOI - RxNorm	44818931
RxNorm - ETC	RxNorm to ETC (FDB)	1	0	ETC - RxNorm	44818907
RxNorm - SPL	RxNorm to SPL (NLM)	1	0	SPL - RxNorm	45754867
RxNorm dose form of	Dose form of (RxNorm)	1	0	RxNorm has dose form	44818815
RxNorm has dose form	Has dose form (RxNorm)	1	0	RxNorm dose form of	44818717
RxNorm has ing	Has ingredient (RxNorm)	1	0	RxNorm ing of	44818719
RxNorm is a	Is a (RxNorm)	1	0	RxNorm inverse is a	45754829
SNOMED - HOI	SNOMED contained in HOI (OMOP)	1	0	HOI - SNOMED	44818929
ATC - RxNorm	ATC to RxNorm	0	1	RxNorm - ATC	44818810
ATC - RxNorm name	ATC to RxNorm equivalent by concept_name (OMOP)	0	1	RxNorm - ATC name	44818926
Available as box	Is available in a prepackaged box (OMOP)	1	1	Box of	223
Chem structure of	Chemical structure of (NDF-RT)	1	1	Has chem structure	44818838
Constitutes	Constitutes (RxNorm)	1	1	Consists of	44818720
Contained in	Is contained in (RxNorm)	1	1	Contains	44818819
Contained in version	Table/field contained in OMOP CDM Version (OMOP)	1	1	Version contains	32521
CVX - RxNorm	CVX - RxNorm (OMOP)	1	1	RxNorm - CVX	581403
DOI - RxNorm	DOI contains RxNorm (OMOP)	1	1	RxNorm - DOI	44818930
Dose form group of	Dose form group of (RxNorm)	1	1	Has dose form group	5026
Drug class of drug	Drug class of drug (OMOP)	1	1	Drug has drug class	233
ETC - RxNorm	ETC to RxNorm (FDB)	1	1	RxNorm - ETC	44818809
ETC - RxNorm name	ETC to RxNorm equivalent by concept_name (OMOP)	1	1	RxNorm - ETC name	44818924
Source - RxNorm eq	Drug Source to RxNorm equivalent (OMOP)	0	1	RxNorm - Source eq	44818953
SPL - RxNorm	SPL to RxNorm (NLM)	1	1	RxNorm - SPL	45754866
Subsumes	Subsumes	1	1	Is a	44818723
Therap class of	Therapeutic class of (NDF)	1	1	Has therap class	44818913
Topic of	Topic of	1	1	Has Topic	581414
VAProd - RxNorm eq	VA Product to RxNorm equivalent (NDF-RT)	0	1	RxNorm - VAProd eq	44818944
Visit cat - PoS	Visit category to Place of Service (OMOP)	1	1	PoS - Visit cat	44818940
Has marketed form	Has marketed form (OMOP)	1	1	Marketed form of	246
Has quantified form	Has quantified form (RxNorm)	0	1	Quantified form of	45754827
Has tradename	Has tradename (RxNorm)	0	1	Tradename of	44818716
HOI - SNOMED	HOI contains SNOMED (OMOP)	1	1	SNOMED - HOI	44818928
Inferred class of	Inferred drug class of (OMOP)	1	1	Has inferred class	44818918
Is FDA-appr ind of	Is FDA-approved indication of (FDB)	1	1	Has FDA-appr ind	44818904
Is off-label ind of	Is off-label indication of (FDB)	1	1	Has off-label ind	44818905
Is standard ing of	Is standard ingredient of ingredient (OMOP)	1	1	Has standard ing	225
May be prevented by	May be prevented by (NDF-RT)	1	1	May prevent	44818834
May be treated by	May be treated by (NDF-RT)	1	1	May treat	44818832
MDC cat - DRG	MDC category to DRG (CMS)	1	1	DRG - MDC cat	44818939
MedDRA - SNOMED eq	MedDRA to SNOMED equivalent (OMOP)	0	1	SNOMED - MedDRA eq	44818805
MoA of	Mechanism of action of (NDF-RT)	1	1	Has MoA	44818829
Module of	Module of	1	1	Has Module	581405
NDFRT - RxNorm eq	NDF-RT to RxNorm equivalent (RxNorm)	1	1	RxNorm - NDFRT eq	44818741
NDFRT - RxNorm name	NDF-RT to RxNorm equivalent by concept_name (OMOP)	1	1	RxNorm - NDFRT name	44818923
NDFRT ing of	Ingredient of (NDF-RT)	1	1	NDFRT has ing	44818827
NUCC - CMS Specialty	NUCC to CMS Specialty (CMS)	1	1	CMS Specialty - NUCC	44818934
Panel contains	Panel contains (LOINC)	1	1	Contained in panel	46233678
Pharma prep in	Pharmaceutical preparation contained in (NDF)	1	1	Has pharma prep	44818917
Physiol effect by	Physiological effect induced by (NDF-RT)	1	1	Has physio effect	44818825
Product comp of	Product component of (NDF-RT)	1	1	Has product comp	45754852
Reformulated in	Reformulated in (RxNorm)	0	1	Reformulation of	44818820
RxNorm ing of	Ingredient of (RxNorm)	1	1	RxNorm has ing	44818817
RxNorm inverse is a	Inverse is a (RxNorm)	1	1	RxNorm is a	45754830
SNOMED - CPT4 eq	SNOMED to CPT-4 equivalent (OMOP)	0	1	CPT4 - SNOMED eq	44818902
SNOMED - ICD9P eq	SNOMED to ICD-9-Procedure equivalent (OMOP)	0	1	ICD9P - SNOMED eq	44818900
SNOMED - OPCS4	SNOMED to OPCS4 equivalent or categorical (NHS)	1	1	OPCS4 - SNOMED	45956700
SNOMED cat - CPT4	SNOMED category to CPT-4 (OMOP)	1	1	CPT4 - SNOMED cat	44818901
SNOMED meas - HCPCS	SNOMED measurement subsumes HCPCS (OMOP)	1	1	HCPCS - SNOMED meas	44818966
SNOMED proc - HCPCS	SNOMED procedure subsumes HCPCS (OMOP)	1	1	HCPCS - SNOMED proc	44818920
Acc device used by	Access device used by (SNOMED)	0	0	Using acc device	44818895
Access of	Access of (SNOMED)	0	0	Has access	44818847
Active ing of	Active ingredient of (SNOMED)	0	0	Has active ing	44818859
Admin method of	Dose form administration method of (SNOMED)	0	0	Has admin method	581464
AMP of	Actual Medicinal Product of (SNOMED)	0	0	Has AMP	45905757
Answer of	Answer of (LOINC)	0	0	Has Answer	45754684
Answer of (PPI)	Answer of (PPI)	0	0	Has answer (PPI)	32443
Approach of	Approach of (SNOMED)	0	0	Has approach	45754821
ARP of	ARP of (SNOMED)	0	0	Has ARP	45905797
Asso finding of	Associated finding of (SNOMED)	0	0	Has asso finding	44818868
Asso morph of	Associated morphology of (SNOMED)	0	0	Has asso morph	44818867
Asso proc of	Associated procedure of (SNOMED)	0	0	Has asso proc	44818882
Asso with finding	Associated with finding (SNOMED)	0	0	Finding asso with	44818792
ATC - SNOMED eq	ATC to SNOMED equivalent (RxNorm)	0	0	SNOMED - ATC eq	45754850
ATC to NDFRT eq	ATC to NDFRT equivalent (NDF-RT)	0	0	NDFRT to ATC eq	45754838
ATC to VA Class eq	ATC to VA Class equivalent (NDF-RT)	0	0	VA Class to ATC eq	45754836
Basic dose form of	Basic dose form of (SNOMED)	0	0	Has basic dose form	581460
Basis str subst of	Basis of strength substance of (SNOMED)	0	0	Has basis str subst	45905750
Causative agent of	Causative agent of (SNOMED)	0	0	Has causative agent	44818866
Caused by	Caused by (SNOMED)	0	0	Causes	45754810
Causes	Causes (SNOMED)	0	0	Caused by	45754811
Characterizes	Characterizes (SNOMED)	0	0	Is characterized by	5081
Clinical course of	Has clinical course of (SNOMED)	0	0	Has clinical course	44818896
Component of	Component of (SNOMED)	0	0	Has component	44818865
Conc denom unit of	Concentration strength denominator unit of (SNOMED)	0	0	Has conc denom unit	32436
Conc denom val of	Concentration strength denominator value of (SNOMED)	0	0	Has conc denom val	32434
Conc num unit of	Concentration strength numerator unit of (SNOMED)	0	0	Has conc num unit	32438
Conc num val of	Concentration strength numerator value of (SNOMED)	0	0	Has conc num val	32432
Concept alt_to from	Active alternative_to inactive (SNOMED)	0	0	Concept alt_to to	44818961
Concept alt_to to	Inactive alternative_to active (SNOMED)	0	0	Concept alt_to from	44818960
Concept poss_eq from	Active possibly_equivalent_to inactive (SNOMED)	0	0	Concept poss_eq to	44818963
Concept poss_eq to	Inactive possibly_equivalent_to active (SNOMED)	0	0	Concept poss_eq from	44818962
Concept replaced by	Concept replaced by	0	0	Concept replaces	44818956
Concept replaces	Concept replaces	0	0	Concept replaced by	44818957
Concept same_as from	Active same_as inactive (SNOMED)	0	0	Concept same_as to	44818959
Concept same_as to	Inactive same_as active (SNOMED)	0	0	Concept same_as from	44818958
Concept was_a from	Active was_a inactive (SNOMED)	0	0	Concept was_a to	44818965
Concept was_a to	Inactive was_a active (SNOMED)	0	0	Concept was_a from	44818964
Count of ing of	Count of base of active ingredient of (SNOMED)	0	0	Has count of ing	32442
CPT4 - LOINC eq	CPT4 to LOINC equivalent (SNOMED)	0	0	LOINC - CPT4 eq	45956698
CPT4 - SNOMED eq	CPT-4 to SNOMED equivalent (OMOP)	0	0	SNOMED - CPT4 eq	44818804
Denom value of	Presentation strength denominator value of (SNOMED)	0	0	Has denomin value	581419
Denominator unit of	Presentation strength denominator unit of (SNOMED)	0	0	Has denominator unit	581417
Device used by	Device used by (SNOMED)	0	0	Using device	44818892
Dir device of	Direct device of (SNOMED)	0	0	Has dir device	44818864
Dir morph of	Direct morphology of (SNOMED)	0	0	Has dir morph	44818863
Dir proc site of	Direct procedure site of (SNOMED)	0	0	Has dir proc site	44818883
Dir subst of	Direct substance of (SNOMED)	0	0	Has dir subst	44818862
Direct site of	Direct site of (SNOMED)	0	0	Has direct site	5080
Disc indicator of	Discontinued indicator of (SNOMED)	0	0	Has disc indicator	45905805
Disp dose form of	Dispensed dose form of (SNOMED)	0	0	Has disp dose form	45905748
Disposition of	Disposition of (SNOMED)	0	0	Has disposition	581462
Dose form of	Dose form of (SNOMED)	0	0	Has dose form	44818880
Dose form unit of	Unit relating to the size of (DM+D)	0	0	Has dose form unit	45905754
DRG - MS-DRG eq	DRG to MS-DRG equivalent (CMS)	0	0	MS-DRG - DRG eq	44818936
Drug-drug inter for	Drug-drug interaction for (NDF)	0	0	Has drug-drug inter	44818914
Due to of	Due to of (SNOMED)	0	0	Has due to	44818878
During	During (SNOMED)	0	0	Has complication	581424
Energy used by	Energy used by (SNOMED)	0	0	Using energy	44818893
Episodicity of	Episodicity of (SNOMED)	0	0	Has episodicity	44818861
Etiology of	Etiology of (SNOMED)	0	0	Has etiology	45754813
Excipient of	Excipient of (SNOMED)	0	0	Has excipient	45905790
Excluded in map from	Standard to Non-standard exclude child (OMOP)	0	0	Map excludes child	44818970
Extent of	Extent of (SNOMED)	0	0	Has extent	45754817
FDB Ind - ICD9CM	FDB Indication/Contraindication to ICD-9-CM (FDB)	0	0	ICD9CM - FDB Ind	44819289
Finding asso with	Finding associated with (SNOMED)	0	0	Asso with finding	44818890
Finding context of	Finding context of (SNOMED)	0	0	Has finding context	44818887
Finding inform of	Finding informer of (SNOMED)	0	0	Using finding inform	44818899
Finding method of	Finding method of (SNOMED)	0	0	Using finding method	44818898
Spec active ing of	Specific active ingredient of (SNOMED)	0	0	Has spec active ing	45905749
Specimen identity of	Specimen source identity of (SNOMED)	0	0	Has specimen source	44818874
Specimen morph of	Specimen source morphology of (SNOMED)	0	0	Has specimen morph	44818875
Specimen of	Specimen of (SNOMED)	0	0	Has specimen	44818854
Specimen proc of	Specimen procedure of (SNOMED)	0	0	Has specimen proc	44818873
Specimen subst of	Specimen substance of (SNOMED)	0	0	Has specimen subst	44818877
Specimen topo of	Specimen source topography of (SNOMED)	0	0	Has specimen topo	44818876
Stage of	Stage of (SNOMED)	0	0	Has stage	45754815
State of matter of	State of matter of (SNOMED)	0	0	Has state of matter	581472
Subject matter of	Subject matter domain of (LOINC)	0	0	Has subject matter	32455
Subst used by	Substance used by (SNOMED)	0	0	Using subst	44818894
Supplier of	Supplier or manufacturer of (OMOP)	0	0	Has supplier	249
Surgical appr of	Surgical approach of (SNOMED)	0	0	Has surgical appr	44818891
Technique of	Technique of (SNOMED)	0	0	Has technique	5070
Temp related to	Temporally related to (SNOMED)	0	0	Has temp finding	581473
Temporal context of	Temporal context of (SNOMED)	0	0	Has temporal context	44818889
Time aspect of	Time aspect of (SNOMED)	0	0	Has time aspect	44818872
Topography of ICDO	Topography of ICDO	0	0	Has Topography ICDO	581430
Trade family grp of	Trade family group of (SNOMED)	0	0	Has trade family grp	45905759
Tradename of	Tradename of (RxNorm)	0	0	Has tradename	44818814
Transformation of	Dose form transformation of (SNOMED)	0	0	Has transformation	581470
Typ bill - Freq Code	Typ bill Full to Frequency code (UB04)	0	0	Freq Code - Typ bill	32403
Typ bill - Typ bill3	Typ bill Full to Typ bill 3 digits (UB04)	0	0	Typ bill3 - Typ bill	32405
Typ bill3 - Typ bill	Typ bill 3 digits to Typ bill Full (UB04)	0	0	Typ bill - Typ bill3	32406
Type mapped from	Type concept to non-standard map (OMOP)	0	0	Maps to type	44819240
Type of service of	Type of service of (LOINC)	0	0	Has type of service	32457
UCUM replaced by	Concept replaced by (UCUM)	0	0	UCUM replaces	44818978
UCUM replaces	Concept replaces (UCUM)	0	0	UCUM replaced by	44818979
Unit mapped from	Unit concept to non-standard map (OMOP)	0	0	Maps to unit	44819241
Unit of admin of	Unit of administration of (SNOMED)	0	0	Has unit of admin	32410
Unit of presen of	Unit of presentation of (SNOMED)	0	0	Has unit of presen	32430
Unit of prod use of	Unit relating to the entity that can be handled of (DM+D)	0	0	Has unit of prod use	45905755
Using acc device	Using access device (SNOMED)	0	0	Acc device used by	44818797
Using device	Using device (SNOMED)	0	0	Device used by	44818794
Using energy	Using energy (SNOMED)	0	0	Energy used by	44818795
Using finding inform	Using finding informer (SNOMED)	0	0	Finding inform of	44818801
Using finding method	Using finding method (SNOMED)	0	0	Finding method of	44818800
Using subst	Using substance (SNOMED)	0	0	Subst used by	44818796
VA Class - SNOMED eq	VA Class to SNOMED equivalent (RxNorm)	0	0	SNOMED - VA Class eq	45754848
VA Class to ATC eq	VA Class to ATC equivalent (NDF-RT)	0	0	ATC to VA Class eq	45754835
VA Class to NDFRT eq	VA Class to NDFRT equivalent (NDF-RT)	0	0	NDFRT to VA Class eq	45754839
Value mapped from	Value_as_concept to non-standard map (OMOP)	0	0	Maps to value	44819242
VAProd - NDFRT	VA Product to NDF-RT (NDF-RT)	0	0	NDFRT - VAProd	44818942
VMP has prescr stat	VMP has prescribing status (SNOMED)	0	0	VMP prescr stat of	45905810
VMP of	Virtual Medicinal Product of (SNOMED)	0	0	Has VMP	45905751
VMP prescr stat of	VMP prescribing status of (SNOMED)	0	0	VMP has prescr stat	45905811
VRP has prescr stat	VRP has prescribing status (SNOMED)	0	0	VRP prescr stat of	45905806
VRP of	VRP of (SNOMED)	0	0	Has VRP	45905799
VRP prescr stat of	VRP prescribing status of (SNOMED)	0	0	VRP has prescr stat	45905807
Finding site of	Finding site of (SNOMED)	0	0	Has finding site	44818860
Flavor of	Flavor of (SNOMED)	0	0	Has flavor	45905803
Focus of	Focus of (SNOMED)	0	0	Has focus	44818857
Followed by	Followed by (SNOMED)	0	0	Follows	45905793
Follows	Follows (SNOMED)	0	0	Followed by	45905792
Form of	Form of (RxNorm)	0	0	Has form	44818816
Freq Code - Typ bill	Frequency code to Typ bill Full (UB04)	0	0	Typ bill - Freq Code	32404
Has access	Has access (SNOMED)	0	0	Access of	44818749
Has active ing	Has active ingredient (SNOMED)	0	0	Active ing of	44818761
Has admin method	Has dose form administration method (SNOMED)	0	0	Admin method of	581463
Has AMP	Has Actual Medicinal Product (SNOMED)	0	0	AMP of	45905745
Has Answer	Has Answer (LOINC)	0	0	Answer of	45754683
Has answer (PPI)	Has answer (PPI)	0	0	Answer of (PPI)	32444
Has approach	Has Approach (SNOMED)	0	0	Approach of	45754820
Has ARP	Has ARP (SNOMED)	0	0	ARP of	45905796
Has asso finding	Has associated finding (SNOMED)	0	0	Asso finding of	44818770
Has asso morph	Has associated morphology (SNOMED)	0	0	Asso morph of	44818769
Has asso proc	Has associated procedure (SNOMED)	0	0	Asso proc of	44818784
Has basic dose form	Has basic dose form (SNOMED)	0	0	Basic dose form of	581459
Has basis str subst	Has basis of strength substance (SNOMED)	0	0	Basis str subst of	45905738
Has causative agent	Has causative agent (SNOMED)	0	0	Causative agent of	44818768
Has CI	Has drug contra-indication (FDB)	0	0	Is CI of	44818808
Has clinical course	Has clinical course (SNOMED)	0	0	Clinical course of	44818798
Has complication	Has complication (SNOMED)	0	0	During	581425
Has component	Has component (SNOMED)	0	0	Component of	44818767
Has conc denom unit	Has concentration strength denominator unit (SNOMED)	0	0	Conc denom unit of	32435
Has conc denom val	Has concentration strength denominator value (SNOMED)	0	0	Conc denom val of	32433
Has conc num unit	Has concentration strength numerator unit (SNOMED)	0	0	Conc num unit of	32437
Has conc num val	Has concentration strength numerator value (SNOMED)	0	0	Conc num val of	32431
Has count of ing	Has count of base of active ingredient (SNOMED)	0	0	Count of ing of	32441
Has denomin value	Has presentation strength denominator value (SNOMED)	0	0	Denom value of	581418
Has denominator unit	Has presentation strength denominator unit (SNOMED)	0	0	Denominator unit of	581416
Has dir device	Has direct device (SNOMED)	0	0	Dir device of	44818766
Has dir morph	Has direct morphology (SNOMED)	0	0	Dir morph of	44818765
Has dir proc site	Has direct procedure site (SNOMED)	0	0	Dir proc site of	44818785
Has dir subst	Has direct substance (SNOMED)	0	0	Dir subst of	44818764
Has direct site	Has direct site (SNOMED)	0	0	Direct site of	5079
Has disc indicator	Has discontinued indicator (SNOMED)	0	0	Disc indicator of	45905804
Has disp dose form	Has dispensed dose form (SNOMED)	0	0	Disp dose form of	45905736
Has disposition	Has disposition (SNOMED)	0	0	Disposition of	581461
Has dose form	Has dose form (SNOMED)	0	0	Dose form of	44818782
Has dose form unit	Has unit relating to the size (DM+D)	0	0	Dose form unit of	45905742
Has drug-drug inter	Is involved in drug-drug interaction (NDF)	0	0	Drug-drug inter for	44818915
Has due to	Has due to (SNOMED)	0	0	Due to of	44818780
Has episodicity	Has episodicity (SNOMED)	0	0	Episodicity of	44818763
Has etiology	Has Etiology (SNOMED)	0	0	Etiology of	45754812
Has excipient	Has excipient (SNOMED)	0	0	Excipient of	45905791
Has extent	Has Extent (SNOMED)	0	0	Extent of	45754816
Has finding context	Has finding context (SNOMED)	0	0	Finding context of	44818789
Has finding site	Has finding site (SNOMED)	0	0	Finding site of	44818762
Has flavor	Has flavor (SNOMED)	0	0	Flavor of	45905802
Has focus	Has focus (SNOMED)	0	0	Focus of	44818759
Has form	Has form (RxNorm)	0	0	Form of	44818718
Has Histology ICDO	Has Histology ICDO	0	0	Histology of ICDO	581427
Has incipient	Has incipient (DM+D)	0	0	Incipient of	45905740
Has indir device	Has indirect device (SNOMED)	0	0	Indir device of	44818755
Has indir morph	Has indirect morphology (SNOMED)	0	0	Indir morph of	44818754
Has indir proc site	Has indirect procedure site (SNOMED)	0	0	Indir proc site of	44818786
Has inherent	Has inherent (SNOMED)	0	0	Inheres in	5078
Has inherent loc	Has inherent location (SNOMED)	0	0	Inherent location of	5067
Has intended site	Has dose form intended site (SNOMED)	0	0	Intended site of	581465
Has intent	Has intent (SNOMED)	0	0	Intent of	44818758
Has interpretation	Has interpretation (SNOMED)	0	0	Interpretation of	44818757
Has interprets	Has interprets (SNOMED)	0	0	Interprets of	44818753
Has kind	Has kind (LOINC)	0	0	Kind of	32460
Has laterality	Has laterality (SNOMED)	0	0	Laterality of	44818752
Has legal category	Has legal category (SNOMED)	0	0	Legal category of	45905812
Has licensed route	Has licensed route (DM+D)	0	0	Licensed route of	45905741
Has manifestation	Has definitional manifestation (SNOMED)	0	0	Manifestation of	44818760
Has meas component	Has Measured Component (SNOMED)	0	0	Meas component of	45754808
Has measurement	Has measurement method (SNOMED)	0	0	Measurement of	44818771
Has method	Has method (SNOMED)	0	0	Method of	44818751
Has modification	Has modification of (SNOMED)	0	0	Modification of	32440
Has Module	Has Module	0	0	Module of	581406
Has morphology	Has Morphology (SNOMED)	0	0	Morphology of	45754806
Has non-avail ind	Has VMP non-availability indicator (SNOMED)	0	0	Non-avail ind of	45905794
Has numerator unit	Has presentation strength numerator unit (SNOMED)	0	0	Numerator unit of	581420
Has numerator value	Has presentation strength numerator value (SNOMED)	0	0	Numerator value of	581422
Has occurrence	Has occurrence (SNOMED)	0	0	Occurrence of	44818750
Has pack	Has pack (SNOMED)	0	0	Is pack of	45905758
Has part of	Has part of (SNOMED)	0	0	Part of	44818746
Has pathology	Has pathological process (SNOMED)	0	0	Pathology of	44818745
Has pharma prep	Has pharmaceutical preparation (NDF)	0	0	Pharma prep in	44818916
Has PPI parent code	Has PPI parent code	0	0	PPI parent code of	32469
Has prec ingredient	Has precise active ingredient (SNOMED)	0	0	Prec ingredient of	32427
Has precise ing	Has precise ingredient (RxNorm)	0	0	Precise ing of	44818715
Has precondition	Has precondition (SNOMED)	0	0	Precondition of	5065
Has priority	Has priority (SNOMED)	0	0	Priority of	44818744
Has proc context	Has procedure context (SNOMED)	0	0	Proc context of	44818790
Has proc device	Has procedure device (SNOMED)	0	0	Proc device of	44818787
Has proc morph	Has procedure morphology (SNOMED)	0	0	Proc morph of	44818788
Has proc site	Has procedure site (SNOMED)	0	0	Proc site of	44818743
Has process output	Has process output (SNOMED)	0	0	Process output of	5073
Has property	Has property (SNOMED)	0	0	Property of	44818772
Has property type	Has property type (SNOMED)	0	0	Property type of	5075
Has recipient cat	Has recipient category (SNOMED)	0	0	Recipient cat of	44818742
Has relat context	Has subject relationship context (SNOMED)	0	0	Relat context of	44818781
Has relative part	Has relative part (SNOMED)	0	0	Relative part of	5071
Has release charact	Has dose form release characteristic (SNOMED)	0	0	Release charact of	581467
Has revision status	Has revision status (SNOMED)	0	0	Revision status of	44818748
Has role	Has role (LOINC)	0	0	Role of	32458
Has route	Has route (DM+D)	0	0	Route of	45905744
Has route of admin	Has route of administration (SNOMED)	0	0	Route of admin of	44818799
Has scale type	Has scale type (SNOMED)	0	0	Scale type of	44818773
Has setting	Has setting (LOINC)	0	0	Setting of	32462
Has severity	Has severity (SNOMED)	0	0	Severity of	44818747
Has spec active ing	Has specific active ingredient (SNOMED)	0	0	Spec active ing of	45905737
Has specimen	Has specimen (SNOMED)	0	0	Specimen of	44818756
Has specimen morph	Has specimen source morphology (SNOMED)	0	0	Specimen morph of	44818777
Has specimen proc	Has specimen procedure (SNOMED)	0	0	Specimen proc of	44818775
Has specimen source	Has specimen source identity (SNOMED)	0	0	Specimen identity of	44818776
Has specimen subst	Has specimen substance (SNOMED)	0	0	Specimen subst of	44818779
Has specimen topo	Has specimen source topography (SNOMED)	0	0	Specimen topo of	44818778
Has stage	Has Stage (SNOMED)	0	0	Stage of	45754814
Has standard brand	Has standard Brand Name (OMOP)	0	0	Is standard brand of	228
Has standard form	Has standard Dose Form (OMOP)	0	0	Is standard form of	230
Has standard ing	Has standard ingredient (OMOP)	0	0	Is standard ing of	226
Has state of matter	Has state of matter (SNOMED)	0	0	State of matter of	581471
Has subject matter	Has subject matter domain (LOINC)	0	0	Subject matter of	32454
Has supplier	Has supplier or manufacturer (OMOP)	0	0	Supplier of	248
Has surgical appr	Has surgical approach (SNOMED)	0	0	Surgical appr of	44818793
Has technique	Has technique (SNOMED)	0	0	Technique of	5069
Has temp finding	Has temporal finding (SNOMED)	0	0	Temp related to	581474
Has temporal context	Has temporal context (SNOMED)	0	0	Temporal context of	44818791
Has therap class	Has therapeutic class (NDF)	0	0	Therap class of	44818912
Has time aspect	Has time aspect (SNOMED)	0	0	Time aspect of	44818774
Has Topic	Has Topic	0	0	Topic of	581415
Has Topography ICDO	Has Topography ICDO	0	0	Topography of ICDO	581429
Has trade family grp	Has trade family group (SNOMED)	0	0	Trade family grp of	45905747
Has transformation	Has dose form transformation (SNOMED)	0	0	Transformation of	581469
Has type of service	Has type of service (LOINC)	0	0	Type of service of	32456
Has unit of admin	Has unit of administration (SNOMED)	0	0	Unit of admin of	32409
Has unit of presen	Has unit of presentation (SNOMED)	0	0	Unit of presen of	32429
Has unit of prod use	Has unit relating to the entity that can be handled (DM+D)	0	0	Unit of prod use of	45905743
Has VMP	Has Virtual Medicinal Product (SNOMED)	0	0	VMP of	45905739
Has VRP	Has VRP (SNOMED)	0	0	VRP of	45905798
Histology of ICDO	Histology of ICDO	0	0	Has Histology ICDO	581428
ICD9CM - FDB Ind	ICD-9-CM to FDB Indication/Contraindication (FDB)	0	0	FDB Ind - ICD9CM	44819288
ICD9CM - MedDRA	ICD-9-CM to MedDRA (MSSO)	0	0	MedDRA - ICD9CM	44819286
ICD9P - SNOMED eq	ICD-9-Procedure to SNOMED equivalent (OMOP)	0	0	SNOMED - ICD9P eq	44818802
ICD9P replaced by	Concept replaced by (ICD-9-Procedure)	0	0	ICD9P replaces	44818971
ICD9P replaces	Concept replaces (ICD-9-Procedure)	0	0	ICD9P replaced by	44818972
ICDO - SNOMED	ICDO - SNOMED	0	0	SNOMED - ICDO	581431
Incipient of	Incipient of (DM+D)	0	0	Has incipient	45905752
Included in map from	Standard to Non-standard include child (OMOP)	0	0	Map includes child	44818973
Ind/CI - SNOMED	Indication/Contra-indication to SNOMED	0	0	SNOMED - ind/CI	44818910
Indir device of	Indirect device of (SNOMED)	0	0	Has indir device	44818853
Indir morph of	Indirect morphology of (SNOMED)	0	0	Has indir morph	44818852
Indir proc site of	Indirect procedure site of (SNOMED)	0	0	Has indir proc site	44818884
Inherent location of	Inherent location of (SNOMED)	0	0	Has inherent loc	5068
Inheres in	Inheres in (SNOMED)	0	0	Has inherent	5077
Intended site of	Dose form intended site of (SNOMED)	0	0	Has intended site	581466
Intent of	Intent of (SNOMED)	0	0	Has intent	44818856
Interpretation of	Interpretation of (SNOMED)	0	0	Has interpretation	44818855
Interprets of	Interprets of (SNOMED)	0	0	Has interprets	44818851
Is characterized by	Is characterized by (SNOMED)	0	0	Characterizes	5082
Is CI of	Is contra-indication of (FDB)	0	0	Has CI	44818906
Is pack of	Is pack of (SNOMED)	0	0	Has pack	45905746
Is standard brand of	Is standard Brand Name of (OMOP)	0	0	Has standard brand	227
Is standard form of	Is standard Dose Form of (OMOP)	0	0	Has standard form	229
Kind of	Kind of (LOINC)	0	0	Has kind	32461
Laterality of	Laterality of (SNOMED)	0	0	Has laterality	44818850
Legal category of	Legal category of (SNOMED)	0	0	Has legal category	45905813
Licensed route of	Licensed route of (DM+D)	0	0	Has licensed route	45905753
LOINC - CPT4 eq	LOINC to CPT4 equivalent (SNOMED)	0	0	CPT4 - LOINC eq	45956697
LOINC - SNOMED eq	LOINC Hierarchy to SNOMED equivalent (LOINC)	0	0	SNOMED - LOINC eq	45956695
LOINC replaced by	Concept replaced by (LOINC)	0	0	LOINC replaces	44818714
LOINC replaces	Concept replaces (LOINC)	0	0	LOINC replaced by	44818812
Manifestation of	Definitional manifestation of (SNOMED)	0	0	Has manifestation	44818858
Map excludes child	Non-standard to Standard exclude child (OMOP)	0	0	Excluded in map from	44818974
Map includes child	Non-standard to Standard include child (OMOP)	0	0	Included in map from	44818975
Mapped from	Standard to Non-standard map (OMOP)	0	0	Maps to	44818976
Maps to	Non-standard to Standard map (OMOP)	0	0	Mapped from	44818977
Maps to number	Non-standard to value_as_number map (OMOP)	0	0	Number mapped from	45754885
Maps to operator	Non-standard to operator concept map (OMOP)	0	0	Operator mapped from	45754883
Maps to type	Non-standard to type concept map (OMOP)	0	0	Type mapped from	44819237
Maps to unit	Non-standard to unit concept map (OMOP)	0	0	Unit mapped from	44819238
Maps to value	Non-standard to value_as_concept map (OMOP)	0	0	Value mapped from	44819239
Meas component of	Measured Component of (SNOMED)	0	0	Has meas component	45754809
Measurement of	Measurement method of (SNOMED)	0	0	Has measurement	44818869
MedDRA - ICD9CM	MedDRA to ICD-9-CM (MSSO)	0	0	ICD9CM - MedDRA	44819287
MedDRA - SMQ	MedDRA contained in SMQ (MedDRA)	0	0	SMQ - MedDRA	44818909
Method of	Method of (SNOMED)	0	0	Has method	44818849
Modification of	Is modification of (SNOMED)	0	0	Has modification	32439
Morphology of	Morphology of (SNOMED)	0	0	Has morphology	45754807
MS-DRG - DRG eq	MS-DRG to DRG equivalent (CMS)	0	0	DRG - MS-DRG eq	44818937
Multilex has ing	Has ingredient (Multilex)	0	0	Multilex ing of	44818950
Multilex ing of	Ingredient of (Multilex)	0	0	Multilex has ing	44818951
NDFRT - SNOMED eq	NDF-RT to SNOMED equivalent (RxNorm)	0	0	SNOMED - NDFRT eq	45754846
NDFRT - VAProd	NDF-RT to VA Product (NDF-RT)	0	0	VAProd - NDFRT	44818943
NDFRT to ATC eq	NDFRT to ATC equivalent (NDF-RT)	0	0	ATC to NDFRT eq	45754837
NDFRT to VA Class eq	NDFRT to VA Class equivalent (NDF-RT)	0	0	VA Class to NDFRT eq	45754840
Non-avail ind of	VMP non-availability indicator of (SNOMED)	0	0	Has non-avail ind	45905795
Number mapped from	Value_as_number to non-standard map (OMOP)	0	0	Maps to number	45754886
Numerator unit of	Presentation strength numerator unit of (SNOMED)	0	0	Has numerator unit	581421
Has metabolism	Has site of metabolism (NDF-RT)	1	0	Metabolism of	44818738
Numerator value of	Presentation strength numerator value of (SNOMED)	0	0	Has numerator value	581423
Occurrence of	Occurrence of (SNOMED)	0	0	Has occurrence	44818848
Occurs after	Occurs after (SNOMED)	0	0	Occurs before	44818783
Occurs before	Occurs before (SNOMED)	0	0	Occurs after	44818881
Operator mapped from	Operator concept to non-standard map (OMOP)	0	0	Maps to operator	45754884
Part of	Part of (SNOMED)	0	0	Has part of	44818844
Pathology of	Pathological process of (SNOMED)	0	0	Has pathology	44818843
PPI parent code of	PPI parent code of	0	0	Has PPI parent code	32470
Prec ingredient of	Precise active ingredient of (SNOMED)	0	0	Has prec ingredient	32428
Precise ing of	Precise ingredient of (RxNorm)	0	0	Has precise ing	44818813
Precondition of	Precondition of (SNOMED)	0	0	Has precondition	5066
Prep to Chem eq	Pharmaceutical Preparation to Chemical Structure equivalent (NDF-RT)	0	0	Chem to Prep eq	45754842
Priority of	Priority of (SNOMED)	0	0	Has priority	44818842
Proc context of	Procedure context of (SNOMED)	0	0	Has proc context	44818888
Proc device of	Procedure device of (SNOMED)	0	0	Has proc device	44818885
Proc morph of	Procedure morphology of (SNOMED)	0	0	Has proc morph	44818886
Proc site of	Procedure site of (SNOMED)	0	0	Has proc site	44818841
Process output of	Process output of (SNOMED)	0	0	Has process output	5074
Property of	Property of (SNOMED)	0	0	Has property	44818870
Property type of	Property type of (SNOMED)	0	0	Has property type	5076
Quantified form of	Quantified form of (RxNorm)	0	0	Has quantified form	45754828
Recipient cat of	Recipient category of (SNOMED)	0	0	Has recipient cat	44818840
Reformulation of	Reformulation of (RxNorm)	0	0	Reformulated in	44818722
Relat context of	Subject relationship context of (SNOMED)	0	0	Has relat context	44818879
Relative part of	Relative part of (SNOMED)	0	0	Has relative part	5072
Release charact of	Dose form release characteristic of (SNOMED)	0	0	Has release charact	581468
Revision status of	Revision status of (SNOMED)	0	0	Has revision status	44818846
Role of	Role of (LOINC)	0	0	Has role	32459
Route of	Route of (DM+D)	0	0	Has route	45905756
Route of admin of	Route of administration of (SNOMED)	0	0	Has route of admin	44818897
RxNorm - ATC	RxNorm to ATC	0	0	ATC - RxNorm	44818908
RxNorm - ATC name	RxNorm to ATC equivalent by concept_name (OMOP)	0	0	ATC - RxNorm name	44818927
RxNorm - ETC name	RxNorm to ETC equivalent by concept_name (OMOP)	0	0	ETC - RxNorm name	44818925
RxNorm - NDFRT eq	RxNorm to NDF-RT equivalent (RxNorm)	0	0	NDFRT - RxNorm eq	44818839
RxNorm - NDFRT name	RxNorm to NDF-RT equivalent by concept_name (OMOP)	0	0	NDFRT - RxNorm name	44818922
RxNorm - SNOMED eq	RxNorm to SNOMED equivalent (RxNorm)	0	0	SNOMED - RxNorm eq	45754844
RxNorm - Source eq	RxNorm to Drug Source equivalent (OMOP)	0	0	Source - RxNorm eq	44818952
RxNorm - VAProd eq	RxNorm to VA Product equivalent (NDF-RT)	0	0	VAProd - RxNorm eq	44818945
RxNorm replaced by	Concept replaced by (RxNorm)	0	0	RxNorm replaces	44818946
RxNorm replaces	Concept replaces (RxNorm)	0	0	RxNorm replaced by	44818947
Scale type of	Scale type of (SNOMED)	0	0	Has scale type	44818871
Setting of	Setting of (LOINC)	0	0	Has setting	32463
Severity of	Severity of (SNOMED)	0	0	Has severity	44818845
SMQ - MedDRA	SMQ consists of MedDRA (MedDRA)	0	0	MedDRA - SMQ	44818811
SNOMED - ATC eq	SNOMED to ATC equivalent (RxNorm)	0	0	ATC - SNOMED eq	45754849
SNOMED - ICDO	SNOMED - ICDO	0	0	ICDO - SNOMED	581432
SNOMED - ind/CI	SNOMED to Indication/Contra-indication	0	0	Ind/CI - SNOMED	44818911
SNOMED - LOINC eq	SNOMED to LOINC Hierarchy equivalent (LOINC)	0	0	LOINC - SNOMED eq	45956696
SNOMED - MedDRA eq	SNOMED to MedDRA equivalent (OMOP)	0	0	MedDRA - SNOMED eq	44818903
SNOMED - NDFRT eq	SNOMED to NDF-RT equivalent (RxNorm)	0	0	NDFRT - SNOMED eq	45754845
SNOMED - RxNorm eq	SNOMED to RxNorm equivalent (RxNorm)	0	0	RxNorm - SNOMED eq	45754843
SNOMED - VA Class eq	SNOMED to VA Class equivalent (RxNorm)	0	0	VA Class - SNOMED eq	45754847
Box of	Prepackaged box of (OMOP)	1	0	Available as box	224
Brand name of	Brand name of (OMOP)	1	0	Has brand name	222
Chem to Prep eq	Chemical Structure to Pharmaceutical Preparation equivalent (NDF-RT)	1	0	Prep to Chem eq	45754841
CI by	Contraindicated by (NDF-RT)	1	0	CI to	44818833
CI chem class of	Contraindicating chemical class of (NDF-RT)	1	0	Has CI chem class	44818828
CI MoA of	Contraindicating mechanism of action of (NDF-RT)	1	0	Has CI MoA	44818830
CI physiol effect by	Contraindicating physiological effect induced by (NDF-RT)	1	0	Has CI physio effect	44818826
CI to	Contraindication to (NDF-RT)	1	0	CI by	44818735
CMS Specialty - NUCC	CMS Specialty to NUCC (CMS)	1	0	NUCC - CMS Specialty	44818935
Consists of	Consists of (RxNorm)	1	0	Constitutes	44818818
Contained in panel	Contained in panel (LOINC)	1	0	Panel contains	46233679
Contains	Contains (RxNorm)	1	0	Contained in	44818721
CPT4 - SNOMED cat	CPT-4 to SNOMED category (OMOP)	1	0	SNOMED cat - CPT4	44818803
Diagnosed through	Diagnosed through (NDF-RT)	1	0	May diagnose	44818824
Domain subsumes	Domain subsumes (OMOP)	1	0	Is domain	44818968
DRG - MDC cat	DRG to MDC category (CMS)	1	0	MDC cat - DRG	44818938
Drug has drug class	Drug has drug class (OMOP)	1	0	Drug class of drug	234
Version contains	OMOP CDM Version contains table/field (OMOP)	1	0	Contained in version	32520
Has brand name	Has brand name (OMOP)	1	0	Brand name of	221
Has chem structure	Has chemical structure (NDF-RT)	1	0	Chem structure of	44818740
Has CI chem class	Has contraindicating chemical class (NDF-RT)	1	0	CI chem class of	44818730
Has CI MoA	Has contraindicating mechanism of action (NDF-RT)	1	0	CI MoA of	44818732
Has CI physio effect	Has contraindicating physiological effect (NDF-RT)	1	0	CI physiol effect by	44818728
Has dose form group	Has dose form group (RxNorm)	1	0	Dose form group of	5027
Has FDA-appr ind	Has FDA-approved drug indication (FDB)	1	0	Is FDA-appr ind of	44818806
Has inferred class	Has inferred drug class (OMOP)	1	0	Inferred class of	44818919
Has metabolites	Has active metabolites (NDF-RT)	1	0	Metabolite of	44818737
Has MoA	Has mechanism of action (NDF-RT)	1	0	MoA of	44818731
Has off-label ind	Has off-label drug indication (FDB)	1	0	Is off-label ind of	44818807
Has physio effect	Has physiological effect (NDF-RT)	1	0	Physiol effect by	44818727
Has PK	Has pharmacokinetics (NDF-RT)	1	0	PK of	44818733
Has product comp	Has product component (NDF-RT)	1	0	Product comp of	45754851
HCPCS - SNOMED meas	HCPCS is a SNOMED measurement (OMOP)	1	0	SNOMED meas - HCPCS	44818967
HCPCS - SNOMED proc	HCPCS is a SNOMED procedure (OMOP)	1	0	SNOMED proc - HCPCS	44818921
HOI - MedDRA	HOI contains MedDRA (OMOP)	1	0	MedDRA - HOI	44818932
Induced by	Induced by (NDF-RT)	1	0	Induces	44818823
Induces	Induces (NDF-RT)	1	0	Induced by	44818725
Inhibits effect	Inhibits effect (NDF-RT)	1	0	May be inhibited by	44818837
Is a	Is a	1	0	Subsumes	44818821
Is domain	Is a domain (OMOP)	1	0	Domain subsumes	44818969
Marketed form of	Marketed form of (OMOP)	1	0	Has marketed form	247
May be inhibited by	Effect may be inhibited by (NDF-RT)	1	0	Inhibits effect	44818739
May diagnose	May diagnose (NDF-RT)	1	0	Diagnosed through	44818726
May prevent	May prevent (NDF-RT)	1	0	May be prevented by	44818736
May treat	May treat (NDF-RT)	1	0	May be treated by	44818734
MedDRA - HOI	MedDRA contained in HOI (OMOP)	1	0	HOI - MedDRA	44818933
Metabolism of	Site of metabolism of (NDF-RT)	1	0	Has metabolism	44818836
Metabolite of	Active metabolite of (NDF-RT)	1	0	Has metabolites	44818835
NDFRT dose form of	Dose form of (NDF-RT)	1	0	NDFRT has dose form	44818822
NDFRT has dose form	Has dose form (NDF-RT)	1	0	NDFRT dose form of	44818724
NDFRT has ing	Has ingredient (NDF-RT)	1	0	NDFRT ing of	44818729
OPCS4 - SNOMED	OPCS4 to SNOMED equivalent or categorical (NHS)	1	0	SNOMED - OPCS4	45956699
PK of	Pharmacokinetics of (NDF-RT)	1	0	Has PK	44818831
PoS - Visit cat	Place of Service to Visit category (OMOP)	1	0	Visit cat - PoS	44818941
RxNorm - CVX	RxNorm - CVX (OMOP)	1	0	CVX - RxNorm	581402
RxNorm - DOI	RxNorm contained in DOI (OMOP)	1	0	DOI - RxNorm	44818931
RxNorm - ETC	RxNorm to ETC (FDB)	1	0	ETC - RxNorm	44818907
RxNorm - SPL	RxNorm to SPL (NLM)	1	0	SPL - RxNorm	45754867
RxNorm dose form of	Dose form of (RxNorm)	1	0	RxNorm has dose form	44818815
RxNorm has dose form	Has dose form (RxNorm)	1	0	RxNorm dose form of	44818717
RxNorm has ing	Has ingredient (RxNorm)	1	0	RxNorm ing of	44818719
RxNorm is a	Is a (RxNorm)	1	0	RxNorm inverse is a	45754829
SNOMED - HOI	SNOMED contained in HOI (OMOP)	1	0	HOI - SNOMED	44818929
ATC - RxNorm	ATC to RxNorm	0	1	RxNorm - ATC	44818810
ATC - RxNorm name	ATC to RxNorm equivalent by concept_name (OMOP)	0	1	RxNorm - ATC name	44818926
Available as box	Is available in a prepackaged box (OMOP)	1	1	Box of	223
Chem structure of	Chemical structure of (NDF-RT)	1	1	Has chem structure	44818838
Constitutes	Constitutes (RxNorm)	1	1	Consists of	44818720
Contained in	Is contained in (RxNorm)	1	1	Contains	44818819
Contained in version	Table/field contained in OMOP CDM Version (OMOP)	1	1	Version contains	32521
CVX - RxNorm	CVX - RxNorm (OMOP)	1	1	RxNorm - CVX	581403
DOI - RxNorm	DOI contains RxNorm (OMOP)	1	1	RxNorm - DOI	44818930
Dose form group of	Dose form group of (RxNorm)	1	1	Has dose form group	5026
Drug class of drug	Drug class of drug (OMOP)	1	1	Drug has drug class	233
ETC - RxNorm	ETC to RxNorm (FDB)	1	1	RxNorm - ETC	44818809
ETC - RxNorm name	ETC to RxNorm equivalent by concept_name (OMOP)	1	1	RxNorm - ETC name	44818924
Source - RxNorm eq	Drug Source to RxNorm equivalent (OMOP)	0	1	RxNorm - Source eq	44818953
SPL - RxNorm	SPL to RxNorm (NLM)	1	1	RxNorm - SPL	45754866
Subsumes	Subsumes	1	1	Is a	44818723
Therap class of	Therapeutic class of (NDF)	1	1	Has therap class	44818913
Topic of	Topic of	1	1	Has Topic	581414
VAProd - RxNorm eq	VA Product to RxNorm equivalent (NDF-RT)	0	1	RxNorm - VAProd eq	44818944
Visit cat - PoS	Visit category to Place of Service (OMOP)	1	1	PoS - Visit cat	44818940
Has marketed form	Has marketed form (OMOP)	1	1	Marketed form of	246
Has quantified form	Has quantified form (RxNorm)	0	1	Quantified form of	45754827
Has tradename	Has tradename (RxNorm)	0	1	Tradename of	44818716
HOI - SNOMED	HOI contains SNOMED (OMOP)	1	1	SNOMED - HOI	44818928
Inferred class of	Inferred drug class of (OMOP)	1	1	Has inferred class	44818918
Is FDA-appr ind of	Is FDA-approved indication of (FDB)	1	1	Has FDA-appr ind	44818904
Is off-label ind of	Is off-label indication of (FDB)	1	1	Has off-label ind	44818905
Is standard ing of	Is standard ingredient of ingredient (OMOP)	1	1	Has standard ing	225
May be prevented by	May be prevented by (NDF-RT)	1	1	May prevent	44818834
May be treated by	May be treated by (NDF-RT)	1	1	May treat	44818832
MDC cat - DRG	MDC category to DRG (CMS)	1	1	DRG - MDC cat	44818939
MedDRA - SNOMED eq	MedDRA to SNOMED equivalent (OMOP)	0	1	SNOMED - MedDRA eq	44818805
MoA of	Mechanism of action of (NDF-RT)	1	1	Has MoA	44818829
Module of	Module of	1	1	Has Module	581405
NDFRT - RxNorm eq	NDF-RT to RxNorm equivalent (RxNorm)	1	1	RxNorm - NDFRT eq	44818741
NDFRT - RxNorm name	NDF-RT to RxNorm equivalent by concept_name (OMOP)	1	1	RxNorm - NDFRT name	44818923
NDFRT ing of	Ingredient of (NDF-RT)	1	1	NDFRT has ing	44818827
NUCC - CMS Specialty	NUCC to CMS Specialty (CMS)	1	1	CMS Specialty - NUCC	44818934
Panel contains	Panel contains (LOINC)	1	1	Contained in panel	46233678
Pharma prep in	Pharmaceutical preparation contained in (NDF)	1	1	Has pharma prep	44818917
Physiol effect by	Physiological effect induced by (NDF-RT)	1	1	Has physio effect	44818825
Product comp of	Product component of (NDF-RT)	1	1	Has product comp	45754852
Reformulated in	Reformulated in (RxNorm)	0	1	Reformulation of	44818820
RxNorm ing of	Ingredient of (RxNorm)	1	1	RxNorm has ing	44818817
RxNorm inverse is a	Inverse is a (RxNorm)	1	1	RxNorm is a	45754830
SNOMED - CPT4 eq	SNOMED to CPT-4 equivalent (OMOP)	0	1	CPT4 - SNOMED eq	44818902
SNOMED - ICD9P eq	SNOMED to ICD-9-Procedure equivalent (OMOP)	0	1	ICD9P - SNOMED eq	44818900
SNOMED - OPCS4	SNOMED to OPCS4 equivalent or categorical (NHS)	1	1	OPCS4 - SNOMED	45956700
SNOMED cat - CPT4	SNOMED category to CPT-4 (OMOP)	1	1	CPT4 - SNOMED cat	44818901
SNOMED meas - HCPCS	SNOMED measurement subsumes HCPCS (OMOP)	1	1	HCPCS - SNOMED meas	44818966
SNOMED proc - HCPCS	SNOMED procedure subsumes HCPCS (OMOP)	1	1	HCPCS - SNOMED proc	44818920
\.


--
-- TOC entry 3913 (class 0 OID 3185592)
-- Dependencies: 235
-- Data for Name: source_to_concept_map; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".source_to_concept_map (source_code, source_concept_id, source_vocabulary_id, source_code_description, target_concept_id, target_vocabulary_id, valid_start_date, valid_end_date, invalid_reason) FROM stdin;
\.


--
-- TOC entry 3914 (class 0 OID 3185595)
-- Dependencies: 236
-- Data for Name: specimen; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".specimen (specimen_id, person_id, specimen_concept_id, specimen_type_concept_id, specimen_date, specimen_datetime, quantity, unit_concept_id, anatomic_site_concept_id, disease_status_concept_id, specimen_source_id, specimen_source_value, unit_source_value, anatomic_site_source_value, disease_status_source_value) FROM stdin;
\.


--
-- TOC entry 3915 (class 0 OID 3185601)
-- Dependencies: 237
-- Data for Name: visit_detail; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".visit_detail (visit_detail_id, person_id, visit_detail_concept_id, visit_detail_start_date, visit_detail_start_datetime, visit_detail_end_date, visit_detail_end_datetime, visit_detail_type_concept_id, provider_id, care_site_id, admitting_source_concept_id, discharge_to_concept_id, preceding_visit_detail_id, visit_detail_source_value, visit_detail_source_concept_id, admitting_source_value, discharge_to_source_value, visit_detail_parent_id, visit_occurrence_id) FROM stdin;
\.


--
-- TOC entry 3916 (class 0 OID 3185604)
-- Dependencies: 238
-- Data for Name: visit_occurrence; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".visit_occurrence (visit_occurrence_id, person_id, visit_concept_id, visit_start_date, visit_start_datetime, visit_end_date, visit_end_datetime, visit_type_concept_id, provider_id, care_site_id, visit_source_value, visit_source_concept_id, admitting_source_concept_id, admitting_source_value, discharge_to_concept_id, discharge_to_source_value, preceding_visit_occurrence_id) FROM stdin;
65475	986	9201	1996-08-21	1996-08-21 00:00:00	1996-08-22	1996-08-22 00:00:00	44818517	\N	\N	b2a6f7d3-bed4-4e23-aaf3-74bc5ad2d0c6	0	0		0		65444
14930	222	9201	1988-03-28	1988-03-28 00:00:00	1988-03-29	1988-03-29 00:00:00	44818517	\N	\N	67a46c8d-32aa-433e-8406-d95462fb6ffe	0	0		0		14926
25743	392	9201	2012-05-14	2012-05-14 00:00:00	2012-05-15	2012-05-15 00:00:00	44818517	\N	\N	395c608c-95f8-45e4-857f-1b779df88017	0	0		0		25750
14888	222	9201	2003-09-14	2003-09-14 00:00:00	2003-09-15	2003-09-15 00:00:00	44818517	\N	\N	c3876985-adb3-46fb-9e00-7f3e5281d307	0	0		0		14934
84571	1280	9201	1976-03-04	1976-03-04 00:00:00	1976-03-06	1976-03-06 00:00:00	44818517	\N	\N	c6a32385-94fd-4c30-baa3-61610c1ac9e4	0	0		0		84558
328052	4935	9201	1999-02-14	1999-02-14 00:00:00	1999-02-15	1999-02-15 00:00:00	44818517	\N	\N	c3633de2-20ed-4bb0-b4cc-cbfbd82b30b3	0	0		0		328156
215454	3241	9201	1998-09-14	1998-09-14 00:00:00	1998-09-15	1998-09-15 00:00:00	44818517	\N	\N	3a9b2a5a-1b69-4c20-b316-6300b33bd2ce	0	0		0		215512
48642	733	9201	1980-07-22	1980-07-22 00:00:00	1980-07-23	1980-07-23 00:00:00	44818517	\N	\N	c5d56bc1-6e6d-4823-a5b3-052cae987432	0	0		0		48608
48620	733	9201	2003-09-12	2003-09-12 00:00:00	2003-09-13	2003-09-13 00:00:00	44818517	\N	\N	5c85185a-dd90-4e39-bcdc-753e4bfe5e4f	0	0		0		48643
350015	5259	9201	2008-04-27	2008-04-27 00:00:00	2008-04-28	2008-04-28 00:00:00	44818517	\N	\N	e98670da-3163-453d-83ef-006b7fae37af	0	0		0		350005
82830	1257	9201	1976-10-28	1976-10-28 00:00:00	1976-10-30	1976-10-30 00:00:00	44818517	\N	\N	cb0f18b3-3356-4d05-94d9-be432cdead87	0	0		0		82824
94795	1425	9201	1954-06-25	1954-06-25 00:00:00	1954-06-26	1954-06-26 00:00:00	44818517	\N	\N	26b37c32-f43c-4eaa-a005-847a6beb8d91	0	0		0		94731
112284	1672	9201	1989-06-20	1989-06-20 00:00:00	1989-06-21	1989-06-21 00:00:00	44818517	\N	\N	7bcde92d-f4af-41c1-b2fb-541d035daf81	0	0		0		112241
262673	3951	9201	1986-09-17	1986-09-17 00:00:00	1986-09-18	1986-09-18 00:00:00	44818517	\N	\N	85e4c724-a9b6-4cdc-af4c-346c9e1d3a61	0	0		0		262684
224903	3391	9201	1997-06-10	1997-06-10 00:00:00	1997-06-11	1997-06-11 00:00:00	44818517	\N	\N	99e4979c-2091-488c-8c96-5ee36296387a	0	0		0		224920
284277	4283	9201	1955-11-26	1955-11-26 00:00:00	1955-11-27	1955-11-27 00:00:00	44818517	\N	\N	056421a1-bef2-47db-a4c8-2840e30ab42e	0	0		0		284228
177275	2675	9201	1996-01-23	1996-01-23 00:00:00	1996-01-25	1996-01-25 00:00:00	44818517	\N	\N	ffadf3e8-6edc-4a18-aff6-41aff42ea7c0	0	0		0		177240
284276	4283	9201	1991-03-03	1991-03-03 00:00:00	1991-03-04	1991-03-04 00:00:00	44818517	\N	\N	0f7b6203-86cc-49b9-93eb-5b5f86fcf50b	0	0		0		284270
237446	3572	9201	1993-11-20	1993-11-20 00:00:00	1993-11-21	1993-11-21 00:00:00	44818517	\N	\N	c631ac6a-c69f-48a8-89b7-1f9145fc1bf8	0	0		0		237509
283316	4269	9201	1976-05-01	1976-05-01 00:00:00	1976-05-03	1976-05-03 00:00:00	44818517	\N	\N	30e2bc21-158a-42bf-be60-bd1568d5d625	0	0		0		283314
69405	1058	9201	2004-06-06	2004-06-06 00:00:00	2004-06-07	2004-06-07 00:00:00	44818517	\N	\N	31022197-97fa-4264-af90-2172f450155f	0	0		0		69406
17268	260	9201	2010-04-04	2010-04-04 00:00:00	2010-04-05	2010-04-05 00:00:00	44818517	\N	\N	d125b004-6266-4cd5-b708-b87ce0b9780f	0	0		0		17209
178605	2697	9201	1976-01-06	1976-01-06 00:00:00	1976-01-07	1976-01-07 00:00:00	44818517	\N	\N	de2f8e41-b9b1-4628-8f16-c29e42261948	0	0		0		178650
160719	2423	9201	1998-09-29	1998-09-29 00:00:00	1998-09-30	1998-09-30 00:00:00	44818517	\N	\N	a61e7586-ab07-48eb-a08d-5871a4590d85	0	0		0		160768
193667	2906	9201	1929-01-24	1929-01-24 00:00:00	1929-01-25	1929-01-25 00:00:00	44818517	\N	\N	19f755fb-d205-4926-b203-247f3c2fe74e	0	0		0		193743
44415	672	9201	2000-02-24	2000-02-24 00:00:00	2000-02-26	2000-02-26 00:00:00	44818517	\N	\N	59dc3081-23ec-46b2-af81-441a2cabedba	0	0		0		44414
143995	2160	9201	1998-09-24	1998-09-24 00:00:00	1998-09-25	1998-09-25 00:00:00	44818517	\N	\N	9258f9bf-92eb-4226-b6a1-f98f5b02b14f	0	0		0		143938
149423	2244	9201	1964-07-23	1964-07-23 00:00:00	1964-07-27	1964-07-27 00:00:00	44818517	\N	\N	22553b8d-a895-44a0-a036-f399bf4ae711	0	0		0		149380
105773	1576	9201	2007-06-28	2007-06-28 00:00:00	2007-06-29	2007-06-29 00:00:00	44818517	\N	\N	713a8700-c846-4eda-9e5e-032734b87c81	0	0		0		105778
192595	2894	9201	1923-01-14	1923-01-14 00:00:00	1923-01-15	1923-01-15 00:00:00	44818517	\N	\N	7254da7b-a650-4948-a035-5b228399c48b	0	0		0		192620
167005	2526	9201	1996-07-07	1996-07-07 00:00:00	1996-07-08	1996-07-08 00:00:00	44818517	\N	\N	648f3084-317b-4502-bf87-04a3fd1ff3ed	0	0		0		167003
246071	3701	9201	1984-12-25	1984-12-25 00:00:00	1984-12-26	1984-12-26 00:00:00	44818517	\N	\N	2bc3695e-2d7f-4940-a721-09dea3ca07e1	0	0		0		246068
227090	3423	9201	2007-03-14	2007-03-14 00:00:00	2007-03-16	2007-03-16 00:00:00	44818517	\N	\N	153ec38a-7cde-4543-a7a3-d2203cc516a8	0	0		0		227096
71835	1092	9201	1997-03-20	1997-03-20 00:00:00	1997-03-21	1997-03-21 00:00:00	44818517	\N	\N	613901f8-d37d-4568-babc-d4b446c7a3b5	0	0		0		71800
251498	3784	9201	1986-10-07	1986-10-07 00:00:00	1986-10-08	1986-10-08 00:00:00	44818517	\N	\N	956ec697-d1a5-4d82-9914-6efffc3e7d9d	0	0		0		251476
198747	2976	9201	2006-12-08	2006-12-08 00:00:00	2006-12-09	2006-12-09 00:00:00	44818517	\N	\N	5418d2e2-f8ec-4d9a-aafa-4f9858c6dc20	0	0		0		198776
6727	99	9201	2000-03-11	2000-03-11 00:00:00	2000-03-12	2000-03-12 00:00:00	44818517	\N	\N	3105a9ed-f494-4d51-ae32-dfbcae0caf91	0	0		0		6747
71268	1085	9201	1968-11-19	1968-11-19 00:00:00	1968-11-21	1968-11-21 00:00:00	44818517	\N	\N	6ca8223d-6847-4a3b-b9eb-85970a097cbd	0	0		0		71265
159286	2395	9201	1996-09-13	1996-09-13 00:00:00	1996-09-14	1996-09-14 00:00:00	44818517	\N	\N	e3c9ef12-81c4-498b-a211-6c8acb34b6b2	0	0		0		159232
265271	3989	9201	1965-02-06	1965-02-06 00:00:00	1965-02-07	1965-02-07 00:00:00	44818517	\N	\N	d00940f8-0035-44e9-a752-9dab565bf8ca	0	0		0		265203
281640	4240	9201	1965-07-17	1965-07-17 00:00:00	1965-07-19	1965-07-19 00:00:00	44818517	\N	\N	a3fc88e7-9f14-4dba-a4b7-083621eaba61	0	0		0		281592
311	3	9201	1958-01-29	1958-01-29 00:00:00	1958-01-30	1958-01-30 00:00:00	44818517	\N	\N	70f73afd-cca4-4482-9a97-7b61d1b153ef	0	0		0		248
250387	3767	9201	2018-12-07	2018-12-07 00:00:00	2018-12-08	2018-12-08 00:00:00	44818517	\N	\N	e5ff36e4-4ca7-47c5-9457-7b9f4e484a43	0	0		0		250352
28717	432	9201	1973-01-24	1973-01-24 00:00:00	1973-01-25	1973-01-25 00:00:00	44818517	\N	\N	ce5254f6-2c58-4436-aa5a-2a64185563f3	0	0		0		28766
171195	2586	9201	2007-11-24	2007-11-24 00:00:00	2007-11-25	2007-11-25 00:00:00	44818517	\N	\N	7d85a091-83c4-4bff-b541-3da14024fb9e	0	0		0		171224
56555	856	9201	1971-12-07	1971-12-07 00:00:00	1971-12-08	1971-12-08 00:00:00	44818517	\N	\N	8e15dc87-36f0-4f5b-923a-7e388f5c25bf	0	0		0		56517
15596	232	9201	1959-02-12	1959-02-12 00:00:00	1959-02-14	1959-02-14 00:00:00	44818517	\N	\N	f017e21a-900a-4946-9e89-9fb69837612e	0	0		0		15614
224071	3376	9201	1994-07-02	1994-07-02 00:00:00	1994-07-03	1994-07-03 00:00:00	44818517	\N	\N	b27242c6-8db6-4e0f-940d-ed9ce720157c	0	0		0		224034
287617	4337	9201	2006-04-26	2006-04-26 00:00:00	2006-04-27	2006-04-27 00:00:00	44818517	\N	\N	b882b2bd-cc0c-4cf1-96b9-5e480edd6f4f	0	0		0		287624
215818	3246	9201	2017-02-16	2017-02-16 00:00:00	2017-02-17	2017-02-17 00:00:00	44818517	\N	\N	0bbe404c-3f21-48e9-b45b-b23d465b556c	0	0		0		215778
199326	2986	9201	1997-03-18	1997-03-18 00:00:00	1997-03-19	1997-03-19 00:00:00	44818517	\N	\N	461b92ca-a3e6-4491-9bda-f25851c5a14b	0	0		0		199293
85356	1292	9201	1999-01-22	1999-01-22 00:00:00	1999-01-23	1999-01-23 00:00:00	44818517	\N	\N	ccb63211-4e76-4a23-a411-8993aabd977b	0	0		0		85417
133519	2005	9201	2010-02-12	2010-02-12 00:00:00	2010-02-13	2010-02-13 00:00:00	44818517	\N	\N	51dc828e-04e1-463a-b451-0344e045af51	0	0		0		133500
17410	262	9201	1999-12-29	1999-12-29 00:00:00	1999-12-30	1999-12-30 00:00:00	44818517	\N	\N	07d08600-ce31-4ed1-a97e-b5e9e11da514	0	0		0		17358
49194	742	9201	1986-12-16	1986-12-16 00:00:00	1986-12-17	1986-12-17 00:00:00	44818517	\N	\N	d9f7db05-462c-4421-bb10-31d160a064f6	0	0		0		49115
272577	4102	9201	1973-11-04	1973-11-04 00:00:00	1973-11-05	1973-11-05 00:00:00	44818517	\N	\N	dda042e9-ca1f-49f8-93a1-a42ba8938242	0	0		0		272586
85	1	9201	1981-08-18	1981-08-18 00:00:00	1981-08-19	1981-08-19 00:00:00	44818517	\N	\N	7879d5b2-1af2-49a7-a801-121de124c6af	0	0		0		82
81342	1235	9201	2009-05-19	2009-05-19 00:00:00	2009-05-23	2009-05-23 00:00:00	44818517	\N	\N	c6e3b392-64a0-4ee3-8e10-73395f8eb7c8	0	0		0		81341
222016	3347	9201	1993-10-30	1993-10-30 00:00:00	1993-10-31	1993-10-31 00:00:00	44818517	\N	\N	fc71717c-043d-41f9-b3f6-e96366f2360b	0	0		0		222019
233189	3514	9201	2015-08-12	2015-08-12 00:00:00	2015-08-16	2015-08-16 00:00:00	44818517	\N	\N	f3ea7735-3d0c-44de-ac5b-f88a680cf62b	0	0		0		233214
138115	2075	9201	2006-05-05	2006-05-05 00:00:00	2006-05-06	2006-05-06 00:00:00	44818517	\N	\N	498e7f04-e135-4d91-aa92-2e29e0afaeaa	0	0		0		138014
14547	213	9201	1977-04-29	1977-04-29 00:00:00	1977-04-30	1977-04-30 00:00:00	44818517	\N	\N	1fc3d5d4-c990-4a95-ad7b-9b945600ea6d	0	0		0		14506
39643	600	9201	2018-07-24	2018-07-24 00:00:00	2018-07-25	2018-07-25 00:00:00	44818517	\N	\N	557dd072-2804-4fb1-a4d3-6c82ce53d6ec	0	0		0		39652
288789	4353	9201	1972-11-10	1972-11-10 00:00:00	1972-11-11	1972-11-11 00:00:00	44818517	\N	\N	fb96dfb1-43ef-49b5-a689-9d8a87974394	0	0		0		288786
236418	3561	9201	1944-01-20	1944-01-20 00:00:00	1944-01-21	1944-01-21 00:00:00	44818517	\N	\N	cd098732-c5c1-4d5a-939b-d34baca6dfda	0	0		0		236499
300941	4520	9201	1981-12-27	1981-12-27 00:00:00	1981-12-28	1981-12-28 00:00:00	44818517	\N	\N	d6bdf25f-7295-43b0-bec3-cf012f12f3e4	0	0		0		300936
6947	101	9201	1978-11-03	1978-11-03 00:00:00	1978-11-04	1978-11-04 00:00:00	44818517	\N	\N	2c52731d-171c-4ded-b078-99528f5a6d08	0	0		0		6898
162403	2448	9201	2000-08-10	2000-08-10 00:00:00	2000-08-11	2000-08-11 00:00:00	44818517	\N	\N	fb7456f5-fd64-4298-8500-0857801d5b60	0	0		0		162366
328153	4935	9201	1995-09-18	1995-09-18 00:00:00	1995-09-20	1995-09-20 00:00:00	44818517	\N	\N	ea51902e-2e53-4261-9f0e-1e6b6d44af23	0	0		0		328155
334575	5035	9201	1969-07-27	1969-07-27 00:00:00	1969-07-28	1969-07-28 00:00:00	44818517	\N	\N	8479f1d4-8a5d-44d8-934d-c1f8176af261	0	0		0		334625
128724	1935	9201	2009-04-10	2009-04-10 00:00:00	2009-04-11	2009-04-11 00:00:00	44818517	\N	\N	b695a4b5-b61c-44be-9f4b-db8057e0bacd	0	0		0		128694
101347	1516	9201	1956-01-01	1956-01-01 00:00:00	1956-01-02	1956-01-02 00:00:00	44818517	\N	\N	1f7d4904-c3f2-48c2-a62d-bdcb9ca362f8	0	0		0		101345
348938	5245	9201	2016-02-01	2016-02-01 00:00:00	2016-02-02	2016-02-02 00:00:00	44818517	\N	\N	82e9c58c-ea23-4599-a072-0097a4ab9a54	0	0		0		349005
19503	293	9201	2005-10-04	2005-10-04 00:00:00	2005-10-06	2005-10-06 00:00:00	44818517	\N	\N	985c8b8a-cda8-4a09-9ee7-a2a6e1386c4f	0	0		0		19482
194718	2921	9201	1991-08-06	1991-08-06 00:00:00	1991-08-07	1991-08-07 00:00:00	44818517	\N	\N	41ea00df-05c7-4609-a84e-418b96f6b228	0	0		0		194766
307859	4622	9201	1997-08-31	1997-08-31 00:00:00	1997-09-01	1997-09-01 00:00:00	44818517	\N	\N	3950302f-4857-42ce-8884-c8119e53efca	0	0		0		307781
350477	5267	9201	2006-04-03	2006-04-03 00:00:00	2006-04-04	2006-04-04 00:00:00	44818517	\N	\N	4f11e110-6514-487e-aceb-d15c4a559ce2	0	0		0		350426
216908	3263	9201	1985-04-21	1985-04-21 00:00:00	1985-04-22	1985-04-22 00:00:00	44818517	\N	\N	f1fa7339-d4f1-4186-8f0b-5c7b9c1f6863	0	0		0		216882
290600	4375	9201	1946-07-07	1946-07-07 00:00:00	1946-07-10	1946-07-10 00:00:00	44818517	\N	\N	adda12b3-75d3-4cf1-aa08-611c03897adb	0	0		0		290693
60789	915	9201	1995-09-17	1995-09-17 00:00:00	1995-09-18	1995-09-18 00:00:00	44818517	\N	\N	db930d42-a1a3-48af-ae18-854baaabd659	0	0		0		60795
157859	2372	9201	1967-04-02	1967-04-02 00:00:00	1967-04-04	1967-04-04 00:00:00	44818517	\N	\N	1518dc57-6357-46dc-a06a-b168b12d049d	0	0		0		157839
168045	2541	9201	2017-12-17	2017-12-17 00:00:00	2017-12-18	2017-12-18 00:00:00	44818517	\N	\N	7984e0fb-6891-46e7-a561-9f6c42c533c0	0	0		0		168049
36450	550	9201	2002-06-17	2002-06-17 00:00:00	2002-06-18	2002-06-18 00:00:00	44818517	\N	\N	eba95d8d-c6d1-4ed1-a56a-fb0e77da47dd	0	0		0		36517
341703	5142	9201	1985-05-17	1985-05-17 00:00:00	1985-05-18	1985-05-18 00:00:00	44818517	\N	\N	0c1e4312-8f1a-4b24-bfba-823ebc2993c4	0	0		0		341761
291750	4388	9201	1996-10-28	1996-10-28 00:00:00	1996-10-29	1996-10-29 00:00:00	44818517	\N	\N	1cd69ec6-3b02-458a-ba5c-2988080ddada	0	0		0		291643
170783	2579	9201	1992-06-04	1992-06-04 00:00:00	1992-06-05	1992-06-05 00:00:00	44818517	\N	\N	4a2d22b1-1324-4519-9ba2-1d56cc6e096f	0	0		0		170842
201331	3019	9201	2015-11-29	2015-11-29 00:00:00	2015-11-30	2015-11-30 00:00:00	44818517	\N	\N	10700199-9139-436c-8a42-d13d18990d1f	0	0		0		201361
38558	582	9201	2005-04-04	2005-04-04 00:00:00	2005-04-05	2005-04-05 00:00:00	44818517	\N	\N	9c12fa32-eef1-44f7-ab26-7ad01d9580f3	0	0		0		38566
149316	2243	9201	2005-10-16	2005-10-16 00:00:00	2005-10-17	2005-10-17 00:00:00	44818517	\N	\N	e04d9a74-06ad-4c30-837b-0952655d22d7	0	0		0		149357
235837	3552	9201	1965-07-08	1965-07-08 00:00:00	1965-07-09	1965-07-09 00:00:00	44818517	\N	\N	bd1d3bf3-8c43-4908-8cdd-12c3ea526746	0	0		0		235786
200170	3000	9201	1975-09-04	1975-09-04 00:00:00	1975-09-05	1975-09-05 00:00:00	44818517	\N	\N	96f95f26-49c1-4e3d-8b5c-8ca02f2a77b4	0	0		0		200179
296175	4451	9201	1992-11-11	1992-11-11 00:00:00	1992-11-12	1992-11-12 00:00:00	44818517	\N	\N	388dfb41-d2a7-4535-bf78-f9ed6c8e7508	0	0		0		296123
11282	164	9201	2009-02-27	2009-02-27 00:00:00	2009-02-28	2009-02-28 00:00:00	44818517	\N	\N	c35f422c-5d9b-4d32-bc2c-c75feccdc09b	0	0		0		11276
192594	2894	9201	1932-08-06	1932-08-06 00:00:00	1932-08-07	1932-08-07 00:00:00	44818517	\N	\N	2bf520d4-1511-443f-a1c2-08f4e158697d	0	0		0		192622
170512	2574	9201	2005-08-01	2005-08-01 00:00:00	2005-08-02	2005-08-02 00:00:00	44818517	\N	\N	d09d8a9f-fa92-4eed-b97b-a455a2c33d3b	0	0		0		170470
71836	1092	9201	1962-08-11	1962-08-11 00:00:00	1962-08-13	1962-08-13 00:00:00	44818517	\N	\N	841ea271-f02d-44ee-b786-907d4e9f0061	0	0		0		71796
199401	2987	9201	2015-07-03	2015-07-03 00:00:00	2015-07-04	2015-07-04 00:00:00	44818517	\N	\N	669a557f-dd0b-4cd3-885e-b716b4d3ba2f	0	0		0		199367
293806	4419	9201	1991-01-20	1991-01-20 00:00:00	1991-01-21	1991-01-21 00:00:00	44818517	\N	\N	82386eb1-377c-4137-991f-26d399f8cfba	0	0		0		293852
20029	299	9201	2000-10-07	2000-10-07 00:00:00	2000-10-08	2000-10-08 00:00:00	44818517	\N	\N	3b1fe373-244a-4154-80e3-045c35f726d5	0	0		0		19989
72384	1102	9201	2003-02-21	2003-02-21 00:00:00	2003-02-22	2003-02-22 00:00:00	44818517	\N	\N	e6d307bf-1b18-4af6-bd48-76453e8ace06	0	0		0		72428
6780	99	9201	2014-10-25	2014-10-25 00:00:00	2014-10-26	2014-10-26 00:00:00	44818517	\N	\N	b7bdcf53-a0f1-47f5-9381-2e5245468e02	0	0		0		6758
249294	3752	9201	1998-01-01	1998-01-01 00:00:00	1998-01-02	1998-01-02 00:00:00	44818517	\N	\N	ae14ad59-d35d-4b6c-ae63-48eef06d5d89	0	0		0		249365
121708	1820	9201	2015-01-31	2015-01-31 00:00:00	2015-02-03	2015-02-03 00:00:00	44818517	\N	\N	43e1bb44-ebc3-46fe-a52f-ca598b4493f3	0	0		0		121737
337528	5078	9201	2001-09-23	2001-09-23 00:00:00	2001-09-24	2001-09-24 00:00:00	44818517	\N	\N	98afd1c9-f154-466c-b68c-d84e32c56334	0	0		0		337591
302707	4544	9201	1984-06-02	1984-06-02 00:00:00	1984-06-03	1984-06-03 00:00:00	44818517	\N	\N	317cb0dc-2f91-4a0d-923a-b2df35018659	0	0		0		302656
208085	3128	9201	1984-09-15	1984-09-15 00:00:00	1984-09-16	1984-09-16 00:00:00	44818517	\N	\N	967b2c36-c1a9-4114-a753-f8b97224309d	0	0		0		208164
353160	5309	9201	1955-08-14	1955-08-14 00:00:00	1955-08-15	1955-08-15 00:00:00	44818517	\N	\N	84a4e800-ae18-4955-bda9-3068ab08e7a4	0	0		0		353143
312	3	9201	1972-12-20	1972-12-20 00:00:00	1972-12-21	1972-12-21 00:00:00	44818517	\N	\N	5d035dd1-30d9-4389-b94c-64947bf1f18c	0	0		0		347
22971	343	9201	2005-11-12	2005-11-12 00:00:00	2005-11-13	2005-11-13 00:00:00	44818517	\N	\N	02e354d0-4a1e-4dbe-9de5-37d845e77e40	0	0		0		22955
347870	5229	9201	2004-05-03	2004-05-03 00:00:00	2004-05-04	2004-05-04 00:00:00	44818517	\N	\N	ee61f4ce-7dd1-4647-aa24-ffc21d75f200	0	0		0		347936
15612	232	9201	1963-10-30	1963-10-30 00:00:00	1963-11-01	1963-11-01 00:00:00	44818517	\N	\N	ac9c442f-92f4-48af-9a22-1d18dea7fe4a	0	0		0		15576
184453	2782	9201	1955-05-10	1955-05-10 00:00:00	1955-05-11	1955-05-11 00:00:00	44818517	\N	\N	8410fabf-6b54-4e76-ab60-3c6fd20e0b03	0	0		0		184405
181453	2743	9201	1992-04-27	1992-04-27 00:00:00	1992-04-28	1992-04-28 00:00:00	44818517	\N	\N	8286f109-85f0-4662-bc68-7eef3c586599	0	0		0		181483
70098	1070	9201	2009-10-30	2009-10-30 00:00:00	2009-10-31	2009-10-31 00:00:00	44818517	\N	\N	16a7072c-6178-40f8-bafd-10a705ec1b5a	0	0		0		70091
66860	1015	9201	1984-10-19	1984-10-19 00:00:00	1984-10-23	1984-10-23 00:00:00	44818517	\N	\N	04bfd7f0-888e-4911-bd7e-2e3d617fb094	0	0		0		66815
293364	4412	9201	2000-09-21	2000-09-21 00:00:00	2000-09-22	2000-09-22 00:00:00	44818517	\N	\N	9c9f910c-c3de-4a28-b33f-83440412f472	0	0		0		293285
105541	1571	9201	1998-08-27	1998-08-27 00:00:00	1998-08-28	1998-08-28 00:00:00	44818517	\N	\N	71cfa8bc-172a-43ac-ba6e-83bb133c5394	0	0		0		105452
2615	36	9201	2001-03-30	2001-03-30 00:00:00	2001-04-01	2001-04-01 00:00:00	44818517	\N	\N	3b6aec70-e097-43dd-ad49-ba7aad89373c	0	0		0		2611
21205	320	9201	1974-03-01	1974-03-01 00:00:00	1974-03-02	1974-03-02 00:00:00	44818517	\N	\N	89466a50-f60f-444c-a75f-d7c79cda769f	0	0		0		21236
116475	1743	9201	2011-01-26	2011-01-26 00:00:00	2011-01-27	2011-01-27 00:00:00	44818517	\N	\N	85d6684b-989c-45af-b831-09158f8313be	0	0		0		116542
45079	680	9201	2012-07-25	2012-07-25 00:00:00	2012-07-26	2012-07-26 00:00:00	44818517	\N	\N	7b578e9d-3d74-44fd-adf3-8fb116c3829c	0	0		0		45095
185957	2806	9201	1983-03-13	1983-03-13 00:00:00	1983-03-14	1983-03-14 00:00:00	44818517	\N	\N	677c8fc5-8b06-4691-abcf-1c0fd4c9e28a	0	0		0		185961
290161	4370	9201	1991-11-22	1991-11-22 00:00:00	1991-11-23	1991-11-23 00:00:00	44818517	\N	\N	3d55eb7f-439a-44ca-8764-52cd4b643fe2	0	0		0		290127
200604	3007	9201	1998-05-18	1998-05-18 00:00:00	1998-05-21	1998-05-21 00:00:00	44818517	\N	\N	6d7d20ad-f23f-4e27-adcd-3e7d0368a73c	0	0		0		200602
343739	5170	9201	1981-02-12	1981-02-12 00:00:00	1981-02-13	1981-02-13 00:00:00	44818517	\N	\N	b91e1b12-1504-489a-ad4f-5f27e73aa203	0	0		0		343735
140857	2116	9201	1990-10-19	1990-10-19 00:00:00	1990-10-20	1990-10-20 00:00:00	44818517	\N	\N	99663541-d23f-4738-bc41-9ce0c0f33987	0	0		0		140805
62204	935	9201	1972-07-04	1972-07-04 00:00:00	1972-07-05	1972-07-05 00:00:00	44818517	\N	\N	c196ddce-d8db-4adf-be0c-a98f33d05fac	0	0		0		62234
149939	2256	9201	2012-05-31	2012-05-31 00:00:00	2012-06-01	2012-06-01 00:00:00	44818517	\N	\N	3d08a367-020c-4d3b-b6d6-ff88883cf99e	0	0		0		149935
212225	3189	9201	1985-09-27	1985-09-27 00:00:00	1985-09-28	1985-09-28 00:00:00	44818517	\N	\N	a1e3c562-bced-4e35-af49-8b0d9e5a38d3	0	0		0		212271
156438	2349	9201	2005-02-03	2005-02-03 00:00:00	2005-02-04	2005-02-04 00:00:00	44818517	\N	\N	eef79a2b-8823-4862-a959-6731cfed4b33	0	0		0		156407
108288	1611	9201	1989-05-31	1989-05-31 00:00:00	1989-06-01	1989-06-01 00:00:00	44818517	\N	\N	388267fa-677e-4729-90b8-1ace54489b07	0	0		0		108312
162353	2448	9201	2003-07-07	2003-07-07 00:00:00	2003-07-09	2003-07-09 00:00:00	44818517	\N	\N	79c86558-9251-4b72-9cfe-b267919e7e0a	0	0		0		162352
196837	2949	9201	1974-10-24	1974-10-24 00:00:00	1974-10-25	1974-10-25 00:00:00	44818517	\N	\N	377c089f-eb86-41f4-bd6a-dda3de48a321	0	0		0		196879
124406	1860	9201	1996-12-25	1996-12-25 00:00:00	1996-12-26	1996-12-26 00:00:00	44818517	\N	\N	7a29d005-f593-4588-988d-1582bb1b5492	0	0		0		124372
42242	639	9201	2007-04-27	2007-04-27 00:00:00	2007-04-28	2007-04-28 00:00:00	44818517	\N	\N	6a48dd8b-9537-41c9-9f6f-a3cea9445803	0	0		0		42244
101254	1516	9201	1960-08-12	1960-08-12 00:00:00	1960-08-13	1960-08-13 00:00:00	44818517	\N	\N	bbbebf23-86dd-432b-91ee-6e6044826df8	0	0		0		101265
334574	5035	9201	2014-10-06	2014-10-06 00:00:00	2014-10-07	2014-10-07 00:00:00	44818517	\N	\N	14cc1c30-1e4c-4f36-8056-5db84dbd65bb	0	0		0		334604
70519	1076	9201	2013-09-07	2013-09-07 00:00:00	2013-09-08	2013-09-08 00:00:00	44818517	\N	\N	2d5e0e27-5f66-4ce2-8256-e33c4c3e0a22	0	0		0		70584
227679	3434	9201	1951-06-13	1951-06-13 00:00:00	1951-06-15	1951-06-15 00:00:00	44818517	\N	\N	55c9b633-8550-461a-8d1f-2f95e9bf414b	0	0		0		227681
82801	1257	9201	2010-04-21	2010-04-21 00:00:00	2010-04-22	2010-04-22 00:00:00	44818517	\N	\N	01740747-9001-4ffa-ace4-5bd375aa030d	0	0		0		82816
64048	962	9201	1995-07-09	1995-07-09 00:00:00	1995-07-10	1995-07-10 00:00:00	44818517	\N	\N	2ce8a87b-7471-4c9c-ad66-59e94683f43f	0	0		0		64089
188337	2835	9201	1989-10-28	1989-10-28 00:00:00	1989-10-29	1989-10-29 00:00:00	44818517	\N	\N	8807ea15-3336-47bf-8bd9-7a7f07ed49b2	0	0		0		188344
261165	3929	9201	2005-03-07	2005-03-07 00:00:00	2005-03-08	2005-03-08 00:00:00	44818517	\N	\N	6caa1b6f-fb68-410e-be6a-62ab1a525621	0	0		0		261222
298776	4487	9201	1988-03-26	1988-03-26 00:00:00	1988-03-27	1988-03-27 00:00:00	44818517	\N	\N	8ab8da6e-48cf-4620-8d6d-5c37b367e3ce	0	0		0		298752
84024	1273	9201	2016-12-26	2016-12-26 00:00:00	2016-12-27	2016-12-27 00:00:00	44818517	\N	\N	cd115cdc-919e-4218-844e-7e96cc106d8a	0	0		0		84033
112389	1674	9201	2012-04-27	2012-04-27 00:00:00	2012-04-28	2012-04-28 00:00:00	44818517	\N	\N	ef3ac43a-fbce-4a5c-b030-ce26abfce557	0	0		0		112355
333798	5023	9201	1994-04-20	1994-04-20 00:00:00	1994-04-21	1994-04-21 00:00:00	44818517	\N	\N	276d1259-fecd-4de4-943b-f8911f1b6f92	0	0		0		333770
17174	260	9201	1990-08-17	1990-08-17 00:00:00	1990-08-18	1990-08-18 00:00:00	44818517	\N	\N	740a3c89-b6c4-4e14-8872-cd77357fe4a6	0	0		0		17267
145442	2180	9201	2017-09-28	2017-09-28 00:00:00	2017-09-29	2017-09-29 00:00:00	44818517	\N	\N	f429a55b-d2b2-4b64-b2b3-20bfb4ca2128	0	0		0		145436
170789	2579	9201	2008-04-08	2008-04-08 00:00:00	2008-04-09	2008-04-09 00:00:00	44818517	\N	\N	d6c27b19-281c-4d7d-94d8-13472e30b2ba	0	0		0		170792
214815	3232	9201	2004-07-15	2004-07-15 00:00:00	2004-07-16	2004-07-16 00:00:00	44818517	\N	\N	5c648c1f-8096-4bad-a8f6-a312b45553da	0	0		0		214844
127949	1923	9201	2018-04-09	2018-04-09 00:00:00	2018-04-10	2018-04-10 00:00:00	44818517	\N	\N	b9511fdd-5140-4b7c-bce9-efe2e7327e1f	0	0		0		127976
333312	5014	9201	1943-03-03	1943-03-03 00:00:00	1943-03-05	1943-03-05 00:00:00	44818517	\N	\N	ace6cba3-543a-4c23-a981-a9aa684e7d70	0	0		0		333253
193727	2906	9201	1965-07-07	1965-07-07 00:00:00	1965-07-08	1965-07-08 00:00:00	44818517	\N	\N	7796a629-04cd-42e1-a278-74f9fe77cccb	0	0		0		193713
233390	3516	9201	1950-07-26	1950-07-26 00:00:00	1950-07-29	1950-07-29 00:00:00	44818517	\N	\N	f8fcdde7-8c8b-4830-bad7-540124d4813a	0	0		0		233336
296176	4451	9201	1997-03-04	1997-03-04 00:00:00	1997-03-05	1997-03-05 00:00:00	44818517	\N	\N	92cd5b1b-821d-47a3-8946-6785474c7df4	0	0		0		296140
58948	884	9201	1981-08-23	1981-08-23 00:00:00	1981-08-25	1981-08-25 00:00:00	44818517	\N	\N	380c64d2-8ef0-45d6-b82f-9ce378c1866f	0	0		0		58927
192623	2894	9201	1997-02-20	1997-02-20 00:00:00	1997-02-21	1997-02-21 00:00:00	44818517	\N	\N	6227bd70-4b69-4452-8033-b3aa5b414e97	0	0		0		192603
143420	2152	9201	1962-02-03	1962-02-03 00:00:00	1962-02-05	1962-02-05 00:00:00	44818517	\N	\N	0614cc7f-efd7-4025-935b-eeeb602a289d	0	0		0		143417
188474	2837	9201	1996-07-28	1996-07-28 00:00:00	1996-07-31	1996-07-31 00:00:00	44818517	\N	\N	a7cf5dc5-dc3d-445e-824e-cf1f01428e65	0	0		0		188447
58929	884	9201	2012-01-05	2012-01-05 00:00:00	2012-01-07	2012-01-07 00:00:00	44818517	\N	\N	28d63781-566b-456a-b2b1-8939a80b7c18	0	0		0		58955
250956	3776	9201	2007-11-18	2007-11-18 00:00:00	2007-11-19	2007-11-19 00:00:00	44818517	\N	\N	2d9c1bf8-457e-475e-ba5d-baf431d797fa	0	0		0		250967
32404	484	9201	1974-08-11	1974-08-11 00:00:00	1974-08-12	1974-08-12 00:00:00	44818517	\N	\N	0b62f087-39fb-4290-a814-6a52183187c6	0	0		0		32392
23243	349	9201	1983-07-10	1983-07-10 00:00:00	1983-07-11	1983-07-11 00:00:00	44818517	\N	\N	4f42cec7-8fe0-47c2-8950-c00d8f8e0433	0	0		0		23174
203944	3064	9201	1975-06-27	1975-06-27 00:00:00	1975-06-28	1975-06-28 00:00:00	44818517	\N	\N	bd3b3ce1-3bfe-41f6-b764-738116dbffd9	0	0		0		203933
272405	4100	9201	1980-03-19	1980-03-19 00:00:00	1980-03-20	1980-03-20 00:00:00	44818517	\N	\N	53a2ab45-ac0f-429b-91ff-a5649f77f7af	0	0		0		272413
71299	1085	9201	2004-11-22	2004-11-22 00:00:00	2004-11-23	2004-11-23 00:00:00	44818517	\N	\N	673a1a31-569d-45f2-ae9b-9f9b7a05660b	0	0		0		71290
59289	890	9201	1997-11-11	1997-11-11 00:00:00	1997-11-12	1997-11-12 00:00:00	44818517	\N	\N	86560dbb-d671-4bc7-87fc-cdeaab45d707	0	0		0		59366
346377	5207	9201	1995-05-04	1995-05-04 00:00:00	1995-05-05	1995-05-05 00:00:00	44818517	\N	\N	6ca33e6a-cdaf-4df9-8557-fbba798173c8	0	0		0		346393
192188	2889	9201	2017-03-07	2017-03-07 00:00:00	2017-03-10	2017-03-10 00:00:00	44818517	\N	\N	1480bc1d-fbcf-4b22-9408-51048dba81d0	0	0		0		192148
181241	2739	9201	2015-11-17	2015-11-17 00:00:00	2015-11-18	2015-11-18 00:00:00	44818517	\N	\N	08a7a84b-fc04-4baf-958c-1505ade96fa9	0	0		0		181230
324523	4881	9201	1981-12-25	1981-12-25 00:00:00	1981-12-26	1981-12-26 00:00:00	44818517	\N	\N	7f06f21b-cd89-403b-b99c-e6072ce9e0df	0	0		0		324545
232331	3504	9201	1956-05-19	1956-05-19 00:00:00	1956-05-20	1956-05-20 00:00:00	44818517	\N	\N	9e296474-6b55-43f3-a2ce-c21291a7ab19	0	0		0		232328
93829	1409	9201	1960-04-29	1960-04-29 00:00:00	1960-04-30	1960-04-30 00:00:00	44818517	\N	\N	928d117c-075e-4bce-bc89-905cc1ed99d5	0	0		0		93712
47128	711	9201	1978-08-04	1978-08-04 00:00:00	1978-08-05	1978-08-05 00:00:00	44818517	\N	\N	b967bd79-a2bb-4a77-9292-53e9cd850577	0	0		0		47197
315275	4732	9201	1970-07-21	1970-07-21 00:00:00	1970-07-23	1970-07-23 00:00:00	44818517	\N	\N	f428ed29-87c3-45b8-8ce4-f791cc2cd6bb	0	0		0		315274
162157	2444	9201	1963-03-05	1963-03-05 00:00:00	1963-03-06	1963-03-06 00:00:00	44818517	\N	\N	e497a488-110c-493e-a61c-029e43f84b00	0	0		0		162153
283936	4278	9201	2000-06-09	2000-06-09 00:00:00	2000-06-10	2000-06-10 00:00:00	44818517	\N	\N	5de08cbe-50e8-4e1f-bebf-caf9bd2f1a05	0	0		0		283886
255559	3851	9201	1927-10-11	1927-10-11 00:00:00	1927-10-12	1927-10-12 00:00:00	44818517	\N	\N	2c06e66e-e949-422c-b54e-84a2cca455e0	0	0		0		255592
293415	4412	9201	2010-07-22	2010-07-22 00:00:00	2010-07-24	2010-07-24 00:00:00	44818517	\N	\N	50f857d3-ba98-42aa-b333-5ab7a3fe7c3a	0	0		0		293287
214795	3231	9201	1983-10-09	1983-10-09 00:00:00	1983-10-14	1983-10-14 00:00:00	44818517	\N	\N	a3eb5a75-30c9-4ba7-83e0-f776c0acb51f	0	0		0		214728
185618	2801	9201	2002-04-05	2002-04-05 00:00:00	2002-04-06	2002-04-06 00:00:00	44818517	\N	\N	6dca7050-a6c2-4e87-9170-04942cf73b62	0	0		0		185617
21180	320	9201	1995-10-19	1995-10-19 00:00:00	1995-10-20	1995-10-20 00:00:00	44818517	\N	\N	da0224bc-ccd8-4223-adb9-7a19330adc6e	0	0		0		21237
113250	1691	9201	1970-05-22	1970-05-22 00:00:00	1970-05-23	1970-05-23 00:00:00	44818517	\N	\N	6db4eb0d-99e2-4d12-8850-7c20bd5f8656	0	0		0		113293
54376	821	9201	1985-02-18	1985-02-18 00:00:00	1985-02-19	1985-02-19 00:00:00	44818517	\N	\N	c81a2e27-d3c7-4cdc-8056-815d43b1eee9	0	0		0		54372
34218	512	9201	1970-02-01	1970-02-01 00:00:00	1970-02-02	1970-02-02 00:00:00	44818517	\N	\N	80d3cef3-9e58-4225-a7b8-4b7a9e22c20a	0	0		0		34170
288294	4347	9201	1993-04-06	1993-04-06 00:00:00	1993-04-07	1993-04-07 00:00:00	44818517	\N	\N	432fc057-2969-4eb0-9c73-f75feb199f71	0	0		0		288292
12413	183	9201	1986-10-22	1986-10-22 00:00:00	1986-10-24	1986-10-24 00:00:00	44818517	\N	\N	ae58e360-93f6-482c-8250-040eb82d196b	0	0		0		12348
323690	4867	9201	2011-03-15	2011-03-15 00:00:00	2011-03-16	2011-03-16 00:00:00	44818517	\N	\N	27ae03b3-4a8d-4204-95bc-60e33b459571	0	0		0		323691
195638	2933	9201	1998-10-16	1998-10-16 00:00:00	1998-10-17	1998-10-17 00:00:00	44818517	\N	\N	3b01e236-25a2-4119-9a3c-9068af598448	0	0		0		195610
81491	1237	9201	1950-09-30	1950-09-30 00:00:00	1950-10-02	1950-10-02 00:00:00	44818517	\N	\N	c25ead5f-cc79-4162-bb45-4b494cf052ef	0	0		0		81552
118775	1776	9201	2018-04-24	2018-04-24 00:00:00	2018-04-25	2018-04-25 00:00:00	44818517	\N	\N	b578f1ea-85e2-4fc5-9b79-6b5087794ff7	0	0		0		118776
212303	3189	9201	1991-04-18	1991-04-18 00:00:00	1991-04-19	1991-04-19 00:00:00	44818517	\N	\N	15899a38-439a-45f8-b291-eb7f49d1375f	0	0		0		212302
2415	35	9201	1997-07-25	1997-07-25 00:00:00	1997-07-26	1997-07-26 00:00:00	44818517	\N	\N	d7ea1dcc-9bcc-404d-8201-6aefbe2a12d4	0	0		0		2406
173410	2622	9201	1975-05-23	1975-05-23 00:00:00	1975-05-24	1975-05-24 00:00:00	44818517	\N	\N	39ba3361-9911-4dbe-8b97-4f5f93452bc8	0	0		0		173467
273074	4109	9201	2002-03-25	2002-03-25 00:00:00	2002-03-26	2002-03-26 00:00:00	44818517	\N	\N	08d614c0-83ba-4c1d-80d0-17a29e4f55c6	0	0		0		273159
278066	4190	9201	1977-07-31	1977-07-31 00:00:00	1977-08-04	1977-08-04 00:00:00	44818517	\N	\N	16efb4db-6919-4e9a-b4e2-0014f7fd6ee3	0	0		0		278063
155091	2332	9201	1996-12-05	1996-12-05 00:00:00	1996-12-06	1996-12-06 00:00:00	44818517	\N	\N	a35d43c0-deb7-4c86-896c-b05647620992	0	0		0		155117
195736	2936	9201	1989-03-10	1989-03-10 00:00:00	1989-03-11	1989-03-11 00:00:00	44818517	\N	\N	8c5b4049-af7b-4802-add6-a73a6a8ca674	0	0		0		195769
53141	800	9201	1994-06-11	1994-06-11 00:00:00	1994-06-12	1994-06-12 00:00:00	44818517	\N	\N	125935d8-ef33-4bc1-a2f8-44d95f72358b	0	0		0		53127
175934	2657	9201	2016-01-24	2016-01-24 00:00:00	2016-01-25	2016-01-25 00:00:00	44818517	\N	\N	51031ec3-100e-4f3a-b0ee-1624b484d61a	0	0		0		175951
52010	782	9201	1954-06-19	1954-06-19 00:00:00	1954-06-20	1954-06-20 00:00:00	44818517	\N	\N	b2b76431-27dc-46c6-b245-bcd27fbb3500	0	0		0		52018
325255	4890	9201	1972-02-17	1972-02-17 00:00:00	1972-02-18	1972-02-18 00:00:00	44818517	\N	\N	0817d287-ce3f-4cf0-a913-78a1d4ac14a1	0	0		0		325145
256552	3865	9201	2004-11-20	2004-11-20 00:00:00	2004-11-21	2004-11-21 00:00:00	44818517	\N	\N	9302eb84-1c13-401f-8b69-0234c67e7313	0	0		0		256557
24176	364	9201	1983-08-31	1983-08-31 00:00:00	1983-09-01	1983-09-01 00:00:00	44818517	\N	\N	3063ba27-1ef2-486f-bda3-fad513652063	0	0		0		24191
217749	3278	9201	1994-02-17	1994-02-17 00:00:00	1994-02-18	1994-02-18 00:00:00	44818517	\N	\N	7f96abeb-55df-4ef1-be6c-978cda97bb50	0	0		0		217770
253603	3820	9201	2005-08-10	2005-08-10 00:00:00	2005-08-11	2005-08-11 00:00:00	44818517	\N	\N	a7f42fce-e0a7-4b82-9807-3241b4d56c3c	0	0		0		253678
112072	1669	9201	2014-06-09	2014-06-09 00:00:00	2014-06-10	2014-06-10 00:00:00	44818517	\N	\N	24507a28-fed9-4864-b235-f92c9ef7f14b	0	0		0		112117
210250	3161	9201	1990-01-04	1990-01-04 00:00:00	1990-01-05	1990-01-05 00:00:00	44818517	\N	\N	e8785cb6-aab0-43a2-9d84-4fc6b3284a75	0	0		0		210234
184231	2780	9201	2001-12-20	2001-12-20 00:00:00	2001-12-21	2001-12-21 00:00:00	44818517	\N	\N	6df56d29-7064-41d6-a2ea-fd7a32220690	0	0		0		184222
303328	4551	9201	2015-12-30	2015-12-30 00:00:00	2015-12-31	2015-12-31 00:00:00	44818517	\N	\N	8c9cee7e-9e7e-40fd-aad1-70fa76c05085	0	0		0		303324
269273	4051	9201	2009-10-14	2009-10-14 00:00:00	2009-10-15	2009-10-15 00:00:00	44818517	\N	\N	4ee9b89b-425c-48d7-991e-b0336de9ebef	0	0		0		269283
281189	4235	9201	2007-03-16	2007-03-16 00:00:00	2007-03-17	2007-03-17 00:00:00	44818517	\N	\N	a71f09ae-a2f2-4dff-b948-dd7a77ce203b	0	0		0		281212
41147	616	9201	1962-01-03	1962-01-03 00:00:00	1962-01-08	1962-01-08 00:00:00	44818517	\N	\N	5ee09c00-ce88-48e4-bf8f-d45da12d109e	0	0		0		41086
315516	4736	9201	2002-08-30	2002-08-30 00:00:00	2002-08-31	2002-08-31 00:00:00	44818517	\N	\N	04b84943-35c9-4204-a698-cd05524b4370	0	0		0		315514
339633	5111	9201	1980-02-02	1980-02-02 00:00:00	1980-02-03	1980-02-03 00:00:00	44818517	\N	\N	853a26d4-f906-4f2c-aff5-9f58c0396594	0	0		0		339629
333250	5014	9201	1949-01-08	1949-01-08 00:00:00	1949-01-09	1949-01-09 00:00:00	44818517	\N	\N	47a7d07d-e269-4973-bd51-6c5380e0cc2e	0	0		0		333314
291618	4387	9201	1972-07-15	1972-07-15 00:00:00	1972-07-16	1972-07-16 00:00:00	44818517	\N	\N	c9ad2014-6105-43b7-a993-93433351566a	0	0		0		291587
23632	357	9201	1997-10-04	1997-10-04 00:00:00	1997-10-05	1997-10-05 00:00:00	44818517	\N	\N	3389a009-d095-409a-ade4-e14861780982	0	0		0		23639
173403	2621	9201	1999-06-17	1999-06-17 00:00:00	1999-06-18	1999-06-18 00:00:00	44818517	\N	\N	a95e6db2-7698-4dfb-b60b-7b167c527ade	0	0		0		173402
20209	304	9201	2017-12-14	2017-12-14 00:00:00	2017-12-15	2017-12-15 00:00:00	44818517	\N	\N	146ee6bf-6258-4e3f-888d-66f69b2f9800	0	0		0		20257
192596	2894	9201	1998-03-24	1998-03-24 00:00:00	1998-03-25	1998-03-25 00:00:00	44818517	\N	\N	5f497fc7-186c-4d74-94ac-dd4e100603d0	0	0		0		192604
87342	1318	9201	2018-12-22	2018-12-22 00:00:00	2018-12-23	2018-12-23 00:00:00	44818517	\N	\N	da2325c6-3c54-42da-ac62-c427cd352c95	0	0		0		87408
11002	160	9201	2006-02-19	2006-02-19 00:00:00	2006-02-20	2006-02-20 00:00:00	44818517	\N	\N	6a232075-8ad3-4fd6-9e0c-0e8f742be799	0	0		0		10999
254405	3831	9201	1991-05-04	1991-05-04 00:00:00	1991-05-05	1991-05-05 00:00:00	44818517	\N	\N	8e8bc977-1ee4-4192-a943-73f73db0db2c	0	0		0		254349
250955	3776	9201	2010-11-27	2010-11-27 00:00:00	2010-11-28	2010-11-28 00:00:00	44818517	\N	\N	032081ea-2853-44fe-b132-2b37b52320b2	0	0		0		250981
299863	4503	9201	2001-02-18	2001-02-18 00:00:00	2001-02-19	2001-02-19 00:00:00	44818517	\N	\N	b8f1a13c-d5fd-44cd-b201-b612120cdc58	0	0		0		299862
262038	3941	9201	1999-08-10	1999-08-10 00:00:00	1999-08-11	1999-08-11 00:00:00	44818517	\N	\N	32e9e0d6-8f8d-4a9e-8bd8-2e0c0956498f	0	0		0		262017
332854	5004	9201	2012-09-13	2012-09-13 00:00:00	2012-09-14	2012-09-14 00:00:00	44818517	\N	\N	ece03153-f514-4bc3-94c7-c697e2c5c65d	0	0		0		332812
81480	1236	9201	1967-01-05	1967-01-05 00:00:00	1967-01-06	1967-01-06 00:00:00	44818517	\N	\N	9be4a4fe-332b-4a32-a435-f54b54501f37	0	0		0		81484
171728	2594	9201	2015-05-22	2015-05-22 00:00:00	2015-05-23	2015-05-23 00:00:00	44818517	\N	\N	b13d7c6f-cbda-46e5-8cb9-98de794c1622	0	0		0		171725
320665	4820	9201	1995-10-24	1995-10-24 00:00:00	1995-10-25	1995-10-25 00:00:00	44818517	\N	\N	fe541664-6252-4eca-a9a7-2ffe35c4f69a	0	0		0		320626
99931	1498	9201	2007-05-02	2007-05-02 00:00:00	2007-05-03	2007-05-03 00:00:00	44818517	\N	\N	9389000b-5291-46a7-8872-9a42c46970d7	0	0		0		99928
65021	975	9201	1979-12-18	1979-12-18 00:00:00	1979-12-19	1979-12-19 00:00:00	44818517	\N	\N	4249f3e5-002e-4ce0-aad1-64aaa054f677	0	0		0		65022
205572	3087	9201	1976-05-09	1976-05-09 00:00:00	1976-05-10	1976-05-10 00:00:00	44818517	\N	\N	cc3d77b5-f385-4989-9c82-2769121b3871	0	0		0		205597
302360	4538	9201	1972-10-09	1972-10-09 00:00:00	1972-10-10	1972-10-10 00:00:00	44818517	\N	\N	ad201480-9657-4fdb-a0af-5709865ca884	0	0		0		302314
228225	3440	9201	1995-10-06	1995-10-06 00:00:00	1995-10-07	1995-10-07 00:00:00	44818517	\N	\N	ff965561-e343-4cfa-9db5-0e30f9c31569	0	0		0		228262
339225	5104	9201	2017-06-24	2017-06-24 00:00:00	2017-06-25	2017-06-25 00:00:00	44818517	\N	\N	0ea8cb90-c2c1-4391-9634-0f1c1ac45dff	0	0		0		339192
214129	3221	9201	1967-06-02	1967-06-02 00:00:00	1967-06-05	1967-06-05 00:00:00	44818517	\N	\N	efd93da5-f04c-42df-8626-0003166a7a67	0	0		0		214119
27965	422	9201	2001-03-05	2001-03-05 00:00:00	2001-03-06	2001-03-06 00:00:00	44818517	\N	\N	64f23a50-df4e-43f8-9ddc-152c81e924e6	0	0		0		27939
52798	795	9201	1982-09-03	1982-09-03 00:00:00	1982-09-04	1982-09-04 00:00:00	44818517	\N	\N	a629ec46-dd4a-4a9c-ad70-497245d2e9dd	0	0		0		52792
202811	3048	9201	2008-09-03	2008-09-03 00:00:00	2008-09-04	2008-09-04 00:00:00	44818517	\N	\N	cf9886ea-271b-4e1b-af69-d1bb9f8af6bd	0	0		0		202792
255596	3851	9201	2000-09-14	2000-09-14 00:00:00	2000-09-15	2000-09-15 00:00:00	44818517	\N	\N	b45acbf3-1cbe-48c9-a7ab-a5132ae23681	0	0		0		255591
320081	4811	9201	1995-04-10	1995-04-10 00:00:00	1995-04-13	1995-04-13 00:00:00	44818517	\N	\N	68f4e3d1-fc78-43a7-ac53-615680f98bb7	0	0		0		320052
267032	4017	9201	1934-01-25	1934-01-25 00:00:00	1934-01-26	1934-01-26 00:00:00	44818517	\N	\N	515405c5-119a-44a0-933f-60c6a86b2bae	0	0		0		267029
294884	4436	9201	2017-06-29	2017-06-29 00:00:00	2017-06-30	2017-06-30 00:00:00	44818517	\N	\N	4c70fe8f-01c0-4b9c-a687-b60802445bac	0	0		0		294883
183028	2767	9201	1975-01-20	1975-01-20 00:00:00	1975-01-21	1975-01-21 00:00:00	44818517	\N	\N	ca382418-6e4e-48b9-8009-da06e3aae659	0	0		0		183066
113251	1691	9201	1985-10-20	1985-10-20 00:00:00	1985-10-21	1985-10-21 00:00:00	44818517	\N	\N	0f84f9c8-ba4c-4656-a162-fb60f3a49f2d	0	0		0		113247
123196	1844	9201	2002-12-16	2002-12-16 00:00:00	2002-12-17	2002-12-17 00:00:00	44818517	\N	\N	a1831d57-a208-4bff-b797-04819723ad34	0	0		0		123168
52374	787	9201	2017-04-02	2017-04-02 00:00:00	2017-04-03	2017-04-03 00:00:00	44818517	\N	\N	3fab9707-c5e3-469f-ba5e-65351c564a84	0	0		0		52349
273877	4119	9201	1976-07-15	1976-07-15 00:00:00	1976-07-19	1976-07-19 00:00:00	44818517	\N	\N	72838374-3fe7-4222-8228-e202fade1127	0	0		0		273810
133372	2002	9201	1983-08-09	1983-08-09 00:00:00	1983-08-10	1983-08-10 00:00:00	44818517	\N	\N	81fbfd6d-7f9d-4254-b266-29de89e0b54c	0	0		0		133380
34139	510	9201	2005-06-12	2005-06-12 00:00:00	2005-06-13	2005-06-13 00:00:00	44818517	\N	\N	54774454-2c2b-43fc-a75a-0f6b3b0e255d	0	0		0		34083
192788	2896	9201	2002-05-25	2002-05-25 00:00:00	2002-05-26	2002-05-26 00:00:00	44818517	\N	\N	23906e64-3123-48e0-a5b6-4b0666516391	0	0		0		192861
130743	1967	9201	1994-05-17	1994-05-17 00:00:00	1994-05-18	1994-05-18 00:00:00	44818517	\N	\N	49a4f6c3-02ba-4026-8e64-15f9dbc62e2e	0	0		0		130834
130030	1954	9201	1960-05-14	1960-05-14 00:00:00	1960-05-15	1960-05-15 00:00:00	44818517	\N	\N	e0b87090-6441-45c6-9513-21e4df39a1b5	0	0		0		130035
166577	2518	9201	2010-11-12	2010-11-12 00:00:00	2010-11-13	2010-11-13 00:00:00	44818517	\N	\N	1ec0a99e-4c1d-45f6-bf14-24f556363e6b	0	0		0		166570
296056	4450	9201	2009-03-03	2009-03-03 00:00:00	2009-03-04	2009-03-04 00:00:00	44818517	\N	\N	49f65356-5c78-4170-951f-9b3f6a55bc4e	0	0		0		296046
209503	3149	9201	1965-10-30	1965-10-30 00:00:00	1965-10-31	1965-10-31 00:00:00	44818517	\N	\N	015f5715-9bc3-478a-a90b-21925cf1ffb4	0	0		0		209566
342648	5152	9201	2012-06-20	2012-06-20 00:00:00	2012-06-21	2012-06-21 00:00:00	44818517	\N	\N	1d7f2a48-9573-412b-a672-fdbf50cbed4b	0	0		0		342599
74979	1137	9201	1992-01-14	1992-01-14 00:00:00	1992-01-15	1992-01-15 00:00:00	44818517	\N	\N	ec9ac189-9c64-41e5-bee7-36a637a849a6	0	0		0		74966
203510	3059	9201	1990-04-15	1990-04-15 00:00:00	1990-04-17	1990-04-17 00:00:00	44818517	\N	\N	d0f83453-7d8a-4dec-a1bd-c218dce60fb6	0	0		0		203511
33974	507	9201	1977-10-30	1977-10-30 00:00:00	1977-10-31	1977-10-31 00:00:00	44818517	\N	\N	eb13354c-4d6e-42cb-8e8b-64f13d081b14	0	0		0		33914
301116	4522	9201	2017-11-08	2017-11-08 00:00:00	2017-11-09	2017-11-09 00:00:00	44818517	\N	\N	0b9d61d4-2fc5-4a65-8bce-95c8d466986f	0	0		0		301110
177219	2674	9201	2013-09-07	2013-09-07 00:00:00	2013-09-08	2013-09-08 00:00:00	44818517	\N	\N	e60e3bc6-e664-42f3-aec5-cb2b181e8b61	0	0		0		177181
101271	1516	9201	2015-06-10	2015-06-10 00:00:00	2015-06-11	2015-06-11 00:00:00	44818517	\N	\N	2cad1e01-83a5-4fe0-8df3-9a2ae3065337	0	0		0		101309
322476	4847	9201	1950-12-13	1950-12-13 00:00:00	1950-12-14	1950-12-14 00:00:00	44818517	\N	\N	1a7291d6-a649-4188-a433-dca6dd14cdef	0	0		0		322423
256553	3865	9201	2009-06-04	2009-06-04 00:00:00	2009-06-05	2009-06-05 00:00:00	44818517	\N	\N	5d57d2c7-02fe-4166-80fe-397bf5d31d63	0	0		0		256558
329959	4963	9201	2009-05-25	2009-05-25 00:00:00	2009-05-26	2009-05-26 00:00:00	44818517	\N	\N	a538ced4-364a-4617-8dd2-e5ad91df7f45	0	0		0		329877
292656	4403	9201	1999-08-28	1999-08-28 00:00:00	1999-08-29	1999-08-29 00:00:00	44818517	\N	\N	2bae7844-e634-4694-99e3-315bde9b1050	0	0		0		292697
301559	4529	9201	1997-09-09	1997-09-09 00:00:00	1997-09-10	1997-09-10 00:00:00	44818517	\N	\N	5a4ff761-0410-4bb7-ac12-d2da7032a3cd	0	0		0		301561
204284	3069	9201	1986-08-08	1986-08-08 00:00:00	1986-08-09	1986-08-09 00:00:00	44818517	\N	\N	0849f11e-3cee-481a-9462-8f043bc37063	0	0		0		204312
221134	3332	9201	2014-06-15	2014-06-15 00:00:00	2014-06-16	2014-06-16 00:00:00	44818517	\N	\N	3484420f-72c2-4cd2-9706-77e3d460732f	0	0		0		221133
237187	3569	9201	1999-10-03	1999-10-03 00:00:00	1999-10-04	1999-10-04 00:00:00	44818517	\N	\N	4f80f913-ac35-4830-9ee0-fe6fbe6c23cf	0	0		0		237180
155931	2342	9201	2018-07-10	2018-07-10 00:00:00	2018-07-11	2018-07-11 00:00:00	44818517	\N	\N	ea649aad-5eb8-4ff5-bbab-08eca21c9d43	0	0		0		155909
229946	3464	9201	2017-07-22	2017-07-22 00:00:00	2017-07-23	2017-07-23 00:00:00	44818517	\N	\N	04337ef1-f590-4164-a8d4-6655f495743c	0	0		0		229921
238165	3582	9201	2001-10-27	2001-10-27 00:00:00	2001-10-28	2001-10-28 00:00:00	44818517	\N	\N	c4699408-1fc6-4ff6-b8df-cd1cb081e663	0	0		0		238141
41110	616	9201	2001-03-05	2001-03-05 00:00:00	2001-03-06	2001-03-06 00:00:00	44818517	\N	\N	9845435c-b89c-4d50-8d69-999613decdc9	0	0		0		41098
131970	1982	9201	1957-05-25	1957-05-25 00:00:00	1957-05-26	1957-05-26 00:00:00	44818517	\N	\N	d38c5cf6-79bc-4b3b-9913-5a7eb7e44e5f	0	0		0		131972
47660	720	9201	2000-11-02	2000-11-02 00:00:00	2000-11-03	2000-11-03 00:00:00	44818517	\N	\N	1f3421bf-fa4c-484c-a431-83e9d5e60121	0	0		0		47649
27844	421	9201	2001-07-24	2001-07-24 00:00:00	2001-07-25	2001-07-25 00:00:00	44818517	\N	\N	fd3e93e5-a540-41fb-9dce-22ef28f365c7	0	0		0		27874
6484	96	9201	1985-04-13	1985-04-13 00:00:00	1985-04-14	1985-04-14 00:00:00	44818517	\N	\N	131412d3-73ba-4f23-8cfb-529b165505d3	0	0		0		6526
72272	1100	9201	2010-11-22	2010-11-22 00:00:00	2010-11-23	2010-11-23 00:00:00	44818517	\N	\N	f54ec1c8-bda4-474a-8993-0578047d6e8a	0	0		0		72276
311416	4674	9201	2017-06-28	2017-06-28 00:00:00	2017-06-29	2017-06-29 00:00:00	44818517	\N	\N	6787e752-a41b-4645-a8c3-48545178ffa1	0	0		0		311419
28295	426	9201	2007-01-04	2007-01-04 00:00:00	2007-01-05	2007-01-05 00:00:00	44818517	\N	\N	29e53dc5-ea5e-4177-a56c-2fd5a5a19e67	0	0		0		28313
5360	80	9201	1974-10-27	1974-10-27 00:00:00	1974-10-28	1974-10-28 00:00:00	44818517	\N	\N	f83b86c1-412e-4fd0-8b79-988dc3d9dc4e	0	0		0		5404
45895	693	9201	1995-09-01	1995-09-01 00:00:00	1995-09-02	1995-09-02 00:00:00	44818517	\N	\N	530c2d01-06d7-4370-8652-ddd9a50628cd	0	0		0		45931
71241	1084	9201	2016-08-25	2016-08-25 00:00:00	2016-08-26	2016-08-26 00:00:00	44818517	\N	\N	4ca8bc1f-9e1a-4779-889d-b554a79bfffa	0	0		0		71236
263743	3967	9201	1993-04-25	1993-04-25 00:00:00	1993-04-29	1993-04-29 00:00:00	44818517	\N	\N	077d78fd-aa45-4ab4-b47a-66a3a28b19f2	0	0		0		263724
224534	3383	9201	2018-08-30	2018-08-30 00:00:00	2018-08-31	2018-08-31 00:00:00	44818517	\N	\N	ca6b0ce9-997b-4a93-b9b8-d4286f6dd29b	0	0		0		224502
117439	1756	9201	2013-07-14	2013-07-14 00:00:00	2013-07-15	2013-07-15 00:00:00	44818517	\N	\N	5c1c6df0-d3ca-4458-b8cf-7e1d35be9c4d	0	0		0		117422
318306	4781	9201	2002-09-29	2002-09-29 00:00:00	2002-10-01	2002-10-01 00:00:00	44818517	\N	\N	2a320001-7c51-462e-90de-436bc6c607d4	0	0		0		318271
342654	5153	9201	1963-12-25	1963-12-25 00:00:00	1963-12-29	1963-12-29 00:00:00	44818517	\N	\N	fad89297-1cbb-4515-9967-787f963f5cc8	0	0		0		342737
297104	4466	9201	2008-04-25	2008-04-25 00:00:00	2008-04-26	2008-04-26 00:00:00	44818517	\N	\N	4d96b3d3-b949-4b06-b4b1-21297d2e0c32	0	0		0		297147
201476	3022	9201	1978-11-13	1978-11-13 00:00:00	1978-11-14	1978-11-14 00:00:00	44818517	\N	\N	c8f6220b-357a-4b5a-9960-4ef564fa8466	0	0		0		201478
190913	2869	9201	1954-10-31	1954-10-31 00:00:00	1954-11-01	1954-11-01 00:00:00	44818517	\N	\N	1feb30ec-b86c-459e-8c76-1aa36ac8da79	0	0		0		190822
20892	316	9201	1975-12-21	1975-12-21 00:00:00	1975-12-22	1975-12-22 00:00:00	44818517	\N	\N	789d73d1-f602-47e2-8c83-55831194dbf5	0	0		0		20889
159151	2394	9201	1992-02-04	1992-02-04 00:00:00	1992-02-05	1992-02-05 00:00:00	44818517	\N	\N	8eecc719-24bd-49bc-8d2a-6bef06d5d49d	0	0		0		159216
228775	3446	9201	1953-12-12	1953-12-12 00:00:00	1953-12-13	1953-12-13 00:00:00	44818517	\N	\N	84e609fc-a0e0-4017-af37-fc4cee2ccf1e	0	0		0		228795
313780	4712	9201	1972-01-20	1972-01-20 00:00:00	1972-01-21	1972-01-21 00:00:00	44818517	\N	\N	0cddb755-e8ed-40d6-b2f3-1d8fde141c0e	0	0		0		313755
54143	817	9201	1999-09-21	1999-09-21 00:00:00	1999-09-22	1999-09-22 00:00:00	44818517	\N	\N	9d50c44b-af62-4de0-b6e3-7af8b8328dea	0	0		0		54177
351130	5278	9201	2013-10-23	2013-10-23 00:00:00	2013-10-24	2013-10-24 00:00:00	44818517	\N	\N	d6d7db0d-5ed5-40a4-917d-63f158b2a007	0	0		0		351079
75978	1149	9201	1986-11-26	1986-11-26 00:00:00	1986-11-27	1986-11-27 00:00:00	44818517	\N	\N	e2aac1fe-bf91-407a-ac96-54cce8f6f963	0	0		0		75945
276155	4156	9201	1997-04-03	1997-04-03 00:00:00	1997-04-04	1997-04-04 00:00:00	44818517	\N	\N	a6c5baf9-2fb2-4745-877f-e313381f68c0	0	0		0		276208
183929	2777	9201	1999-12-05	1999-12-05 00:00:00	1999-12-06	1999-12-06 00:00:00	44818517	\N	\N	1c7990ad-07f5-4b96-b228-11ec4d77076b	0	0		0		183936
256340	3860	9201	1978-07-09	1978-07-09 00:00:00	1978-07-12	1978-07-12 00:00:00	44818517	\N	\N	6e263d4e-1df9-4604-bf43-76b96d0a4a28	0	0		0		256294
213499	3214	9201	2009-01-25	2009-01-25 00:00:00	2009-01-26	2009-01-26 00:00:00	44818517	\N	\N	5c267f86-d509-4928-a89f-15d995183be2	0	0		0		213548
320049	4811	9201	1999-12-04	1999-12-04 00:00:00	1999-12-05	1999-12-05 00:00:00	44818517	\N	\N	c109f155-0234-4157-af6e-468eba56eaaf	0	0		0		320046
39389	596	9201	2005-06-13	2005-06-13 00:00:00	2005-06-14	2005-06-14 00:00:00	44818517	\N	\N	9b374d81-ebc0-4e08-9374-092173c4de2f	0	0		0		39318
55003	830	9201	1973-11-24	1973-11-24 00:00:00	1973-11-25	1973-11-25 00:00:00	44818517	\N	\N	12409d79-f80d-4f02-86f2-3b3a46115037	0	0		0		55001
119898	1789	9201	2017-04-02	2017-04-02 00:00:00	2017-04-03	2017-04-03 00:00:00	44818517	\N	\N	2109fb2a-7553-4087-9e79-66aeb3c132ff	0	0		0		119933
231109	3483	9201	1989-01-07	1989-01-07 00:00:00	1989-01-08	1989-01-08 00:00:00	44818517	\N	\N	0c77044d-68e2-435a-9b85-756743bfc489	0	0		0		231004
262942	3956	9201	1952-10-30	1952-10-30 00:00:00	1952-11-03	1952-11-03 00:00:00	44818517	\N	\N	11819c5d-a0e1-44df-ad23-9f7cf7210f5b	0	0		0		262974
131306	1975	9201	1957-06-15	1957-06-15 00:00:00	1957-06-16	1957-06-16 00:00:00	44818517	\N	\N	58599d01-aba4-439b-a6d2-4f5031f27ab9	0	0		0		131282
327123	4923	9201	2000-06-14	2000-06-14 00:00:00	2000-06-15	2000-06-15 00:00:00	44818517	\N	\N	ddd6644b-5953-4832-b47f-96646053a6db	0	0		0		327084
283417	4270	9201	2005-09-15	2005-09-15 00:00:00	2005-09-16	2005-09-16 00:00:00	44818517	\N	\N	5e88752e-00de-4cf1-90d9-a221a0c67d9c	0	0		0		283401
29639	445	9201	1996-05-26	1996-05-26 00:00:00	1996-05-27	1996-05-27 00:00:00	44818517	\N	\N	de90f7eb-2f81-4d0e-8a59-67d2d4a2b713	0	0		0		29574
333436	5017	9201	2015-08-17	2015-08-17 00:00:00	2015-08-18	2015-08-18 00:00:00	44818517	\N	\N	ff766d39-e817-46ec-90b7-ab8f0a2f1b5d	0	0		0		333460
332614	5001	9201	1975-05-02	1975-05-02 00:00:00	1975-05-03	1975-05-03 00:00:00	44818517	\N	\N	b01733b7-11a7-4b75-a8df-5c77065a6406	0	0		0		332670
141239	2123	9201	1994-10-28	1994-10-28 00:00:00	1994-10-29	1994-10-29 00:00:00	44818517	\N	\N	a27a40e8-d141-4f67-bf34-dd3d7a106ac8	0	0		0		141319
69975	1068	9201	2015-02-20	2015-02-20 00:00:00	2015-02-21	2015-02-21 00:00:00	44818517	\N	\N	24dfa15b-1d7a-4724-8735-f450a74b9af5	0	0		0		69972
240660	3621	9201	1955-11-19	1955-11-19 00:00:00	1955-11-20	1955-11-20 00:00:00	44818517	\N	\N	27e33144-bc5c-416c-a18a-bea50eaf95d6	0	0		0		240574
267176	4019	9201	2005-05-08	2005-05-08 00:00:00	2005-05-09	2005-05-09 00:00:00	44818517	\N	\N	71d73147-b85a-4206-933a-ff68896ebb80	0	0		0		267186
300975	4521	9201	1958-11-18	1958-11-18 00:00:00	1958-11-19	1958-11-19 00:00:00	44818517	\N	\N	3563f259-5c64-4fa4-927a-fd389c081a87	0	0		0		300979
468	5	9201	1990-04-07	1990-04-07 00:00:00	1990-04-08	1990-04-08 00:00:00	44818517	\N	\N	bca8ba94-5bc8-4e6c-916f-d19913ce9bde	0	0		0		492
169427	2556	9201	2004-08-16	2004-08-16 00:00:00	2004-08-17	2004-08-17 00:00:00	44818517	\N	\N	a8b5b6d0-7c97-4b61-85f1-615fef519d84	0	0		0		169385
248757	3744	9201	1994-12-25	1994-12-25 00:00:00	1994-12-26	1994-12-26 00:00:00	44818517	\N	\N	5f47aaf3-e5d3-48cc-b090-ba34b444dd7b	0	0		0		248852
184618	2786	9201	1959-12-27	1959-12-27 00:00:00	1959-12-28	1959-12-28 00:00:00	44818517	\N	\N	092d4c01-6b38-4b05-b6e1-300905636a19	0	0		0		184573
323003	4855	9201	2014-08-22	2014-08-22 00:00:00	2014-08-23	2014-08-23 00:00:00	44818517	\N	\N	01520f23-0b97-4287-bab3-2e6b4d04eb05	0	0		0		323050
256560	3865	9201	1990-06-09	1990-06-09 00:00:00	1990-06-10	1990-06-10 00:00:00	44818517	\N	\N	4cbfbc86-e2c4-405a-ae71-32189a7bdf2a	0	0		0		256652
195189	2926	9201	2017-11-28	2017-11-28 00:00:00	2017-11-29	2017-11-29 00:00:00	44818517	\N	\N	efad0bb7-8f6e-402e-b2a2-5714ff207bb9	0	0		0		195177
206704	3109	9201	1990-07-16	1990-07-16 00:00:00	1990-07-17	1990-07-17 00:00:00	44818517	\N	\N	984d21a8-b78b-45d9-88ae-d1ae574eab62	0	0		0		206725
339731	5113	9201	1974-02-23	1974-02-23 00:00:00	1974-02-24	1974-02-24 00:00:00	44818517	\N	\N	b5d5f490-8c09-4f03-8579-196f2df5a8f9	0	0		0		339722
321666	4835	9201	1985-04-27	1985-04-27 00:00:00	1985-04-28	1985-04-28 00:00:00	44818517	\N	\N	4f0185fd-01fb-4954-9525-f32a1549437d	0	0		0		321673
301614	4529	9201	1998-10-05	1998-10-05 00:00:00	1998-10-07	1998-10-07 00:00:00	44818517	\N	\N	2ba6b54a-ecdb-44dc-be84-1ebed65ba287	0	0		0		301615
228045	3438	9201	1947-03-07	1947-03-07 00:00:00	1947-03-08	1947-03-08 00:00:00	44818517	\N	\N	6105101f-c638-4b2d-9cb1-8e946c5d86a9	0	0		0		228122
263314	3960	9201	1997-06-12	1997-06-12 00:00:00	1997-06-13	1997-06-13 00:00:00	44818517	\N	\N	6d5f05ff-c7ab-4f50-8938-a02522522dde	0	0		0		263272
273392	4113	9201	1992-06-03	1992-06-03 00:00:00	1992-06-04	1992-06-04 00:00:00	44818517	\N	\N	3c18c894-bddd-43a8-89b7-08a59dabf4e4	0	0		0		273460
214340	3224	9201	2002-01-26	2002-01-26 00:00:00	2002-01-27	2002-01-27 00:00:00	44818517	\N	\N	d3d656e9-58ae-48b4-880c-672a77368009	0	0		0		214334
295119	4439	9201	1995-07-02	1995-07-02 00:00:00	1995-07-03	1995-07-03 00:00:00	44818517	\N	\N	ee3212e3-730c-4e44-8609-c4904ecac56e	0	0		0		295097
238164	3582	9201	2015-09-13	2015-09-13 00:00:00	2015-09-14	2015-09-14 00:00:00	44818517	\N	\N	e34e1302-f21e-4656-8b3d-30632ca7cdce	0	0		0		238153
172591	2610	9201	1992-07-12	1992-07-12 00:00:00	1992-07-13	1992-07-13 00:00:00	44818517	\N	\N	f9750d22-de89-42a2-b9b8-eaa6598fcb99	0	0		0		172599
200984	3013	9201	1976-07-01	1976-07-01 00:00:00	1976-07-02	1976-07-02 00:00:00	44818517	\N	\N	0ab095f1-132a-44f5-9f99-be18a9fe2816	0	0		0		200945
140275	2105	9201	2013-04-19	2013-04-19 00:00:00	2013-04-20	2013-04-20 00:00:00	44818517	\N	\N	e70814d6-1cc5-4d30-81b2-6e61585c6a52	0	0		0		140257
339107	5103	9201	1984-09-30	1984-09-30 00:00:00	1984-10-01	1984-10-01 00:00:00	44818517	\N	\N	b18549fa-b11e-4163-bf9b-1299a292af69	0	0		0		339134
18192	273	9201	2011-10-10	2011-10-10 00:00:00	2011-10-11	2011-10-11 00:00:00	44818517	\N	\N	ad268ec8-d670-4ad8-8009-704a4ece6cd6	0	0		0		18233
76534	1158	9201	2016-12-28	2016-12-28 00:00:00	2016-12-29	2016-12-29 00:00:00	44818517	\N	\N	37498974-0234-48c5-96b7-034c8653264d	0	0		0		76518
162561	2450	9201	1986-06-04	1986-06-04 00:00:00	1986-06-05	1986-06-05 00:00:00	44818517	\N	\N	0f731956-91fa-487c-a344-d0d5d58e3dae	0	0		0		162501
87438	1318	9201	1953-03-06	1953-03-06 00:00:00	1953-03-08	1953-03-08 00:00:00	44818517	\N	\N	d61b63cc-c0f1-435a-bf75-f84b6ce32903	0	0		0		87378
23368	351	9201	2016-11-21	2016-11-21 00:00:00	2016-11-23	2016-11-23 00:00:00	44818517	\N	\N	a0d44a50-c916-43ca-a70b-d19c964ef3f2	0	0		0		23369
45884	693	9201	1999-09-11	1999-09-11 00:00:00	1999-09-12	1999-09-12 00:00:00	44818517	\N	\N	da992368-eca6-4561-9ff5-4f82457caf10	0	0		0		45894
125350	1878	9201	2004-03-10	2004-03-10 00:00:00	2004-03-14	2004-03-14 00:00:00	44818517	\N	\N	2cbd476f-61be-4654-a3b8-8d6446554d64	0	0		0		125349
344727	5185	9201	2000-01-11	2000-01-11 00:00:00	2000-01-12	2000-01-12 00:00:00	44818517	\N	\N	b47b13ba-32af-476f-be64-db95faf74914	0	0		0		344724
24680	371	9201	2008-05-28	2008-05-28 00:00:00	2008-05-29	2008-05-29 00:00:00	44818517	\N	\N	c0395772-4ab7-4b5b-b8e1-b26d14af771a	0	0		0		24691
148548	2232	9201	2005-12-05	2005-12-05 00:00:00	2005-12-06	2005-12-06 00:00:00	44818517	\N	\N	22374fc5-37b4-4034-8b0f-0bcf719ca7a6	0	0		0		148491
65549	987	9201	1988-02-16	1988-02-16 00:00:00	1988-02-17	1988-02-17 00:00:00	44818517	\N	\N	830b636b-720c-4d78-bfab-aeced1df8b1b	0	0		0		65546
229697	3462	9201	1985-06-21	1985-06-21 00:00:00	1985-06-22	1985-06-22 00:00:00	44818517	\N	\N	5f99694d-bdf3-4c5f-a0b3-a3f55a8ab4b4	0	0		0		229739
345574	5197	9201	1995-11-13	1995-11-13 00:00:00	1995-11-14	1995-11-14 00:00:00	44818517	\N	\N	027d30ef-2782-4b94-ad73-c3cacd9f2538	0	0		0		345576
204069	3065	9201	1982-05-26	1982-05-26 00:00:00	1982-05-27	1982-05-27 00:00:00	44818517	\N	\N	1fd5805d-08f2-4771-a701-5a0ea22a111c	0	0		0		204043
107363	1599	9201	1998-02-23	1998-02-23 00:00:00	1998-02-24	1998-02-24 00:00:00	44818517	\N	\N	aadfe065-d732-4981-88c9-0d475ab9cf9c	0	0		0		107308
346506	5210	9201	2015-08-12	2015-08-12 00:00:00	2015-08-13	2015-08-13 00:00:00	44818517	\N	\N	c62b1328-f39d-46d5-aa1f-1b9d24829ae6	0	0		0		346453
62811	946	9201	1976-04-04	1976-04-04 00:00:00	1976-04-06	1976-04-06 00:00:00	44818517	\N	\N	a137116a-e99c-42d0-a9b8-05a19ad4e89a	0	0		0		62810
235321	3542	9201	2002-09-22	2002-09-22 00:00:00	2002-09-23	2002-09-23 00:00:00	44818517	\N	\N	68fbf2a5-4da1-44e6-a3f6-20169ddb3ec9	0	0		0		235324
117862	1762	9201	1979-12-16	1979-12-16 00:00:00	1979-12-17	1979-12-17 00:00:00	44818517	\N	\N	c030fbd0-8259-4c2e-99a2-95dcb8b1bbec	0	0		0		117841
302313	4538	9201	1987-06-01	1987-06-01 00:00:00	1987-06-02	1987-06-02 00:00:00	44818517	\N	\N	27204385-272e-427a-993c-2f9e343329a3	0	0		0		302315
38298	579	9201	1999-11-06	1999-11-06 00:00:00	1999-11-07	1999-11-07 00:00:00	44818517	\N	\N	9e6dbbeb-d715-4e60-b073-db4e5287cc47	0	0		0		38338
62467	939	9201	2003-07-07	2003-07-07 00:00:00	2003-07-10	2003-07-10 00:00:00	44818517	\N	\N	5b98a098-f3f0-4f2b-b35c-ce5f0aa4bd16	0	0		0		62434
80893	1228	9201	2016-06-26	2016-06-26 00:00:00	2016-06-29	2016-06-29 00:00:00	44818517	\N	\N	2f8ad9eb-5561-41c1-9ed4-afe3c156c1e4	0	0		0		80932
102033	1525	9201	1998-12-23	1998-12-23 00:00:00	1998-12-24	1998-12-24 00:00:00	44818517	\N	\N	e5486acc-3c4c-435c-b393-92987c938e87	0	0		0		101983
55547	841	9201	1991-06-27	1991-06-27 00:00:00	1991-06-28	1991-06-28 00:00:00	44818517	\N	\N	4dbb9363-bcae-4cad-972f-84461359ec59	0	0		0		55515
327006	4922	9201	2013-08-01	2013-08-01 00:00:00	2013-08-02	2013-08-02 00:00:00	44818517	\N	\N	320568bf-b97f-4d04-ae44-b7ecba86af1a	0	0		0		327044
329003	4949	9201	2013-04-01	2013-04-01 00:00:00	2013-04-02	2013-04-02 00:00:00	44818517	\N	\N	fa47d217-ee87-415d-800a-158414e75504	0	0		0		329008
199561	2989	9201	1987-06-16	1987-06-16 00:00:00	1987-06-17	1987-06-17 00:00:00	44818517	\N	\N	a59054bc-fc79-493e-8295-2de49326256a	0	0		0		199515
214794	3231	9201	1989-04-06	1989-04-06 00:00:00	1989-04-08	1989-04-08 00:00:00	44818517	\N	\N	0f34a59f-174a-4b8a-887e-db43e553ab7a	0	0		0		214800
251767	3787	9201	1981-11-07	1981-11-07 00:00:00	1981-11-08	1981-11-08 00:00:00	44818517	\N	\N	702a013f-42cb-413a-a3c9-36fbe861fd62	0	0		0		251787
316779	4755	9201	1933-11-06	1933-11-06 00:00:00	1933-11-08	1933-11-08 00:00:00	44818517	\N	\N	54c4231b-d63c-4bb6-a6aa-e8cbc425f20f	0	0		0		316708
204357	3070	9201	2000-01-19	2000-01-19 00:00:00	2000-01-20	2000-01-20 00:00:00	44818517	\N	\N	f35c3e89-5667-40b6-9511-1ceb1703badf	0	0		0		204342
242058	3639	9201	2010-03-27	2010-03-27 00:00:00	2010-03-28	2010-03-28 00:00:00	44818517	\N	\N	ff02a47c-6e6b-4f71-bac6-158f058c00be	0	0		0		242039
291146	4381	9201	1965-05-05	1965-05-05 00:00:00	1965-05-06	1965-05-06 00:00:00	44818517	\N	\N	13b2bacf-5540-4d91-88e6-e4a56d0a0f4b	0	0		0		291142
192513	2893	9201	1959-05-30	1959-05-30 00:00:00	1959-06-01	1959-06-01 00:00:00	44818517	\N	\N	a9b18ef8-c5c1-4c51-8a08-133eaee50269	0	0		0		192461
73223	1112	9201	2007-08-17	2007-08-17 00:00:00	2007-08-18	2007-08-18 00:00:00	44818517	\N	\N	2c42dcdf-7670-4667-be36-2ad800885536	0	0		0		73229
44416	673	9201	2005-11-29	2005-11-29 00:00:00	2005-11-30	2005-11-30 00:00:00	44818517	\N	\N	cbf55513-ab79-4b9e-835a-335fb487b2bd	0	0		0		44439
153871	2314	9201	1961-01-22	1961-01-22 00:00:00	1961-01-24	1961-01-24 00:00:00	44818517	\N	\N	1c6c5315-2ca6-4c63-8957-6ecf9419bfc9	0	0		0		153863
144208	2165	9201	1989-09-24	1989-09-24 00:00:00	1989-09-25	1989-09-25 00:00:00	44818517	\N	\N	be1b1263-6807-4a7f-8b09-d4ff6d73a9ae	0	0		0		144206
352548	5299	9201	2007-03-28	2007-03-28 00:00:00	2007-03-29	2007-03-29 00:00:00	44818517	\N	\N	6c09e8b3-e458-4f14-81c1-3cb8bda57988	0	0		0		352490
240589	3621	9201	1987-12-19	1987-12-19 00:00:00	1987-12-20	1987-12-20 00:00:00	44818517	\N	\N	cda95d23-b1c5-4108-8850-d8210c96cc22	0	0		0		240595
44638	675	9201	1984-04-21	1984-04-21 00:00:00	1984-04-22	1984-04-22 00:00:00	44818517	\N	\N	9c5819e6-1c8d-4349-be97-c499e06fc927	0	0		0		44681
193101	2898	9201	2016-09-04	2016-09-04 00:00:00	2016-09-05	2016-09-05 00:00:00	44818517	\N	\N	71226335-865d-472d-919f-c9a2af3e6b4c	0	0		0		193099
348605	5239	9201	2011-10-26	2011-10-26 00:00:00	2011-10-27	2011-10-27 00:00:00	44818517	\N	\N	262601b9-f046-4fa1-9d1a-a18b0f75d412	0	0		0		348559
172461	2609	9201	1967-05-02	1967-05-02 00:00:00	1967-05-05	1967-05-05 00:00:00	44818517	\N	\N	95281eaa-c0a3-4b9e-b130-573834c3cbf9	0	0		0		172494
151844	2283	9201	1975-10-06	1975-10-06 00:00:00	1975-10-07	1975-10-07 00:00:00	44818517	\N	\N	f6171187-1312-48f9-b06d-8db6e824a301	0	0		0		151945
282590	4256	9201	2010-01-02	2010-01-02 00:00:00	2010-01-03	2010-01-03 00:00:00	44818517	\N	\N	bf2f76bf-2787-4695-8f58-5417ab77aadc	0	0		0		282635
281438	4238	9201	2013-06-25	2013-06-25 00:00:00	2013-06-26	2013-06-26 00:00:00	44818517	\N	\N	c2fe5660-f840-4f61-82f2-2e54424805b6	0	0		0		281411
74511	1132	9201	1963-04-19	1963-04-19 00:00:00	1963-04-21	1963-04-21 00:00:00	44818517	\N	\N	8fd3a41d-bffe-464c-8acd-0c2148daf1cc	0	0		0		74510
180098	2715	9201	1989-01-08	1989-01-08 00:00:00	1989-01-12	1989-01-12 00:00:00	44818517	\N	\N	ed73f603-7539-4ee1-acf4-a88b49eefd4b	0	0		0		179969
147012	2206	9201	2008-04-09	2008-04-09 00:00:00	2008-04-10	2008-04-10 00:00:00	44818517	\N	\N	04f78447-0644-494c-b507-3ca75ce64663	0	0		0		146998
234830	3536	9201	2000-02-18	2000-02-18 00:00:00	2000-02-19	2000-02-19 00:00:00	44818517	\N	\N	2c8ce650-73b3-47e8-9db4-9cc0c2e38b3f	0	0		0		234816
219076	3296	9201	1938-09-27	1938-09-27 00:00:00	1938-09-28	1938-09-28 00:00:00	44818517	\N	\N	42b87a3d-de52-4b66-afb3-88f93b852c20	0	0		0		218998
260442	3916	9201	2007-08-08	2007-08-08 00:00:00	2007-08-09	2007-08-09 00:00:00	44818517	\N	\N	c05893a7-83ba-4851-9517-4f61c2cba080	0	0		0		260440
185857	2804	9201	1983-04-17	1983-04-17 00:00:00	1983-04-18	1983-04-18 00:00:00	44818517	\N	\N	4ab84ff9-1564-4721-bae3-6aa389204ae9	0	0		0		185851
171450	2591	9201	1974-09-17	1974-09-17 00:00:00	1974-09-18	1974-09-18 00:00:00	44818517	\N	\N	5fec397c-8718-4968-bd8e-3416e6e4fa93	0	0		0		171507
137646	2070	9201	2008-08-15	2008-08-15 00:00:00	2008-08-16	2008-08-16 00:00:00	44818517	\N	\N	59e42ee0-130a-4471-a1b9-26e0de9cba57	0	0		0		137753
138386	2078	9201	2014-01-20	2014-01-20 00:00:00	2014-01-21	2014-01-21 00:00:00	44818517	\N	\N	45c5c6f6-cb39-42ce-a8be-f7f2267f82dc	0	0		0		138384
30580	457	9201	1998-07-11	1998-07-11 00:00:00	1998-07-12	1998-07-12 00:00:00	44818517	\N	\N	880e4dfc-8303-49cf-aa74-2d9a8156e590	0	0		0		30593
81898	1245	9201	1985-08-27	1985-08-27 00:00:00	1985-08-31	1985-08-31 00:00:00	44818517	\N	\N	d75e08c8-ebdd-436c-b194-8951ff78c447	0	0		0		81915
211686	3181	9201	1987-12-17	1987-12-17 00:00:00	1987-12-18	1987-12-18 00:00:00	44818517	\N	\N	92d1ce9e-be50-416b-b80d-c043b339462f	0	0		0		211624
310574	4657	9201	1995-06-13	1995-06-13 00:00:00	1995-06-14	1995-06-14 00:00:00	44818517	\N	\N	e1043bbf-1381-40ae-9556-5f7891666156	0	0		0		310510
297389	4470	9201	2010-12-31	2010-12-31 00:00:00	2011-01-04	2011-01-04 00:00:00	44818517	\N	\N	eeedca14-36a3-4ce3-9f6e-43d4edb7e93c	0	0		0		297388
130487	1962	9201	1999-02-25	1999-02-25 00:00:00	1999-02-26	1999-02-26 00:00:00	44818517	\N	\N	9d6aaa4b-1a04-4772-8431-3c33f1e8177f	0	0		0		130499
34393	515	9201	1976-11-20	1976-11-20 00:00:00	1976-11-21	1976-11-21 00:00:00	44818517	\N	\N	e089ef41-71c3-4bb0-b881-76253cc5d1da	0	0		0		34389
117574	1759	9201	2019-04-03	2019-04-03 00:00:00	2019-04-04	2019-04-04 00:00:00	44818517	\N	\N	d45f62a6-91ec-4cf2-9da6-28520024a561	0	0		0		117598
133925	2012	9201	1978-03-04	1978-03-04 00:00:00	1978-03-05	1978-03-05 00:00:00	44818517	\N	\N	9d5a25c7-1bcf-45e3-8a8a-c51f8f8cca70	0	0		0		133865
169200	2554	9201	1968-03-30	1968-03-30 00:00:00	1968-03-31	1968-03-31 00:00:00	44818517	\N	\N	ddd57b43-b7c0-4dfe-ac33-66818909cc8b	0	0		0		169263
23432	351	9201	2018-06-28	2018-06-28 00:00:00	2018-06-29	2018-06-29 00:00:00	44818517	\N	\N	136ce991-7c36-4334-8e74-48cd53e207b1	0	0		0		23348
235600	3547	9201	2014-07-17	2014-07-17 00:00:00	2014-07-18	2014-07-18 00:00:00	44818517	\N	\N	a29999df-aced-436f-b594-5ba91e41c497	0	0		0		235579
125323	1878	9201	2010-10-08	2010-10-08 00:00:00	2010-10-09	2010-10-09 00:00:00	44818517	\N	\N	f6783366-4f6f-4924-965b-c11359eab961	0	0		0		125330
344657	5185	9201	2002-12-03	2002-12-03 00:00:00	2002-12-04	2002-12-04 00:00:00	44818517	\N	\N	d646b0ea-5711-4502-bc05-4ee7f637de65	0	0		0		344725
194178	2914	9201	1997-05-23	1997-05-23 00:00:00	1997-05-24	1997-05-24 00:00:00	44818517	\N	\N	bb3db8cb-ecda-4282-bce0-0e54cb44368f	0	0		0		194232
343915	5172	9201	1980-05-04	1980-05-04 00:00:00	1980-05-05	1980-05-05 00:00:00	44818517	\N	\N	7a5d932e-4943-4178-89dd-2dbea52c9360	0	0		0		343876
195382	2929	9201	1990-10-29	1990-10-29 00:00:00	1990-10-30	1990-10-30 00:00:00	44818517	\N	\N	511564b8-c2e0-4418-a747-0cd01e1657d7	0	0		0		195377
261147	3928	9201	1995-12-07	1995-12-07 00:00:00	1995-12-09	1995-12-09 00:00:00	44818517	\N	\N	188acaa1-086a-4f14-8b92-7120eb7a1ce1	0	0		0		261132
212590	3195	9201	1984-10-22	1984-10-22 00:00:00	1984-10-23	1984-10-23 00:00:00	44818517	\N	\N	7312df78-9f53-433c-a006-9cc1aaa5d095	0	0		0		212554
279143	4204	9201	1988-12-26	1988-12-26 00:00:00	1988-12-27	1988-12-27 00:00:00	44818517	\N	\N	0de3f04a-7822-4d58-a812-7f9b2154018d	0	0		0		279111
206163	3098	9201	1996-02-19	1996-02-19 00:00:00	1996-02-20	1996-02-20 00:00:00	44818517	\N	\N	2e78a20e-8f3d-44be-8b00-78d289a88615	0	0		0		206214
72202	1099	9201	1990-10-06	1990-10-06 00:00:00	1990-10-07	1990-10-07 00:00:00	44818517	\N	\N	9cc8aac5-06d9-4643-aa37-ae1f70f5ea21	0	0		0		72176
266431	4009	9201	1992-06-12	1992-06-12 00:00:00	1992-06-13	1992-06-13 00:00:00	44818517	\N	\N	dd5f7807-a028-4172-85cc-ef04ff7a19e8	0	0		0		266436
8166	123	9201	1962-07-15	1962-07-15 00:00:00	1962-07-16	1962-07-16 00:00:00	44818517	\N	\N	6f3c2240-91cd-48c6-96a8-5c0a05ddc90b	0	0		0		8165
117863	1762	9201	1982-04-22	1982-04-22 00:00:00	1982-04-23	1982-04-23 00:00:00	44818517	\N	\N	70e6ba86-d466-4580-b4ca-7689d381ef9a	0	0		0		117873
80757	1227	9201	1961-09-05	1961-09-05 00:00:00	1961-09-06	1961-09-06 00:00:00	44818517	\N	\N	d9748f81-39aa-47fe-9b75-c6c23ba3580a	0	0		0		80821
48405	729	9201	2000-04-28	2000-04-28 00:00:00	2000-04-29	2000-04-29 00:00:00	44818517	\N	\N	f2d8ad91-9380-4b94-80f0-369c7cea8d5a	0	0		0		48365
199546	2989	9201	1960-02-04	1960-02-04 00:00:00	1960-02-05	1960-02-05 00:00:00	44818517	\N	\N	7aadd165-1a28-46b9-866d-29ab60721b62	0	0		0		199586
272062	4092	9201	2015-04-29	2015-04-29 00:00:00	2015-04-30	2015-04-30 00:00:00	44818517	\N	\N	e983daf6-cb9a-490c-858c-bdf257a4a012	0	0		0		272043
134108	2016	9201	2017-04-14	2017-04-14 00:00:00	2017-04-15	2017-04-15 00:00:00	44818517	\N	\N	0354edc3-2b12-4d07-b8e4-362d126e0bc7	0	0		0		134142
244429	3675	9201	2009-01-09	2009-01-09 00:00:00	2009-01-10	2009-01-10 00:00:00	44818517	\N	\N	a82f51a4-28f2-46cb-831c-1744ace221f0	0	0		0		244471
314540	4722	9201	1924-02-24	1924-02-24 00:00:00	1924-02-25	1924-02-25 00:00:00	44818517	\N	\N	63290db7-6e29-46d6-8fd6-2e2724b503e1	0	0		0		314610
246007	3700	9201	1971-07-14	1971-07-14 00:00:00	1971-07-15	1971-07-15 00:00:00	44818517	\N	\N	054d9691-0ba8-4a5f-b1b6-2454aaf07b7a	0	0		0		245972
274773	4133	9201	2009-11-26	2009-11-26 00:00:00	2009-11-27	2009-11-27 00:00:00	44818517	\N	\N	fecd2418-0665-491b-acef-694c546ff3f9	0	0		0		274812
165130	2495	9201	2006-08-09	2006-08-09 00:00:00	2006-08-10	2006-08-10 00:00:00	44818517	\N	\N	1974b35e-9a56-4475-81b0-598a0c325a12	0	0		0		165158
214304	3223	9201	1949-07-12	1949-07-12 00:00:00	1949-07-16	1949-07-16 00:00:00	44818517	\N	\N	83f1b320-009a-4df9-95d0-5b855374d208	0	0		0		214310
316705	4755	9201	1963-11-29	1963-11-29 00:00:00	1963-11-30	1963-11-30 00:00:00	44818517	\N	\N	f1c1ea50-921d-4b42-8ebd-47d66d353d4f	0	0		0		316660
220134	3315	9201	2006-09-25	2006-09-25 00:00:00	2006-09-26	2006-09-26 00:00:00	44818517	\N	\N	fba15edc-40d8-48cc-ae59-fcfbd1ae1651	0	0		0		220132
130734	1966	9201	2010-05-07	2010-05-07 00:00:00	2010-05-08	2010-05-08 00:00:00	44818517	\N	\N	229e62e5-111d-4740-8b83-5cfffb5242eb	0	0		0		130740
117994	1764	9201	2008-12-08	2008-12-08 00:00:00	2008-12-09	2008-12-09 00:00:00	44818517	\N	\N	d43b48ac-79b5-4796-86fa-8ab62189e60f	0	0		0		117992
233127	3513	9201	2008-01-02	2008-01-02 00:00:00	2008-01-03	2008-01-03 00:00:00	44818517	\N	\N	d9925ecb-4737-406a-a14f-07b8724ab899	0	0		0		233119
237934	3579	9201	1996-04-28	1996-04-28 00:00:00	1996-04-29	1996-04-29 00:00:00	44818517	\N	\N	e4ebb2df-27e2-413c-a3f3-6c42c792a8a2	0	0		0		237962
58762	882	9201	2013-06-27	2013-06-27 00:00:00	2013-06-28	2013-06-28 00:00:00	44818517	\N	\N	22f51411-bd76-4468-833a-20e3e951afd5	0	0		0		58723
177767	2682	9201	2016-06-01	2016-06-01 00:00:00	2016-06-02	2016-06-02 00:00:00	44818517	\N	\N	6d27b3a7-7d71-4e0f-9970-76cd6c768b23	0	0		0		177723
144219	2165	9201	2009-12-15	2009-12-15 00:00:00	2009-12-16	2009-12-16 00:00:00	44818517	\N	\N	033ac829-1b95-4356-adfa-a2bf580fc2bb	0	0		0		144209
208992	3141	9201	1978-02-06	1978-02-06 00:00:00	1978-02-10	1978-02-10 00:00:00	44818517	\N	\N	77c4b1bb-febb-47e8-a0e1-be17b7d4afa9	0	0		0		208987
253824	3822	9201	1986-11-13	1986-11-13 00:00:00	1986-11-14	1986-11-14 00:00:00	44818517	\N	\N	90907765-aa5b-4e91-ac4e-7425f2adae57	0	0		0		253815
27713	419	9201	1995-12-02	1995-12-02 00:00:00	1995-12-03	1995-12-03 00:00:00	44818517	\N	\N	f4013188-ab50-44dc-a0e9-0bc60188c810	0	0		0		27811
212606	3196	9201	2008-07-06	2008-07-06 00:00:00	2008-07-07	2008-07-07 00:00:00	44818517	\N	\N	ee8b5ba1-6960-41d4-bea1-ddd32f31c648	0	0		0		212609
300974	4521	9201	2009-04-22	2009-04-22 00:00:00	2009-04-23	2009-04-23 00:00:00	44818517	\N	\N	82ba2266-b23f-4086-ae2a-808fefa8c87b	0	0		0		301028
62271	936	9201	2002-05-22	2002-05-22 00:00:00	2002-05-23	2002-05-23 00:00:00	44818517	\N	\N	a2ef6955-b63a-4eaf-a830-bd05d2ffee38	0	0		0		62259
151886	2283	9201	1987-03-07	1987-03-07 00:00:00	1987-03-08	1987-03-08 00:00:00	44818517	\N	\N	658ad37e-2acb-408b-814a-cc92fd1e38f2	0	0		0		151882
129357	1946	9201	1963-02-13	1963-02-13 00:00:00	1963-02-14	1963-02-14 00:00:00	44818517	\N	\N	3ab59b8e-8496-41c0-9549-52fa0368f372	0	0		0		129339
103232	1540	9201	1994-05-06	1994-05-06 00:00:00	1994-05-07	1994-05-07 00:00:00	44818517	\N	\N	b8234135-22a2-4a76-bb3e-f7b4f70155cc	0	0		0		103201
136612	2054	9201	2010-10-05	2010-10-05 00:00:00	2010-10-06	2010-10-06 00:00:00	44818517	\N	\N	4444b6b7-fde2-4682-b73c-155731396923	0	0		0		136622
331835	4988	9201	1991-06-06	1991-06-06 00:00:00	1991-06-07	1991-06-07 00:00:00	44818517	\N	\N	0f6e6374-a6c2-4cb9-ba79-a00c62580cde	0	0		0		331868
87253	1317	9201	2001-12-22	2001-12-22 00:00:00	2001-12-23	2001-12-23 00:00:00	44818517	\N	\N	7eea8a2a-49ed-4606-84c9-48054f695ba9	0	0		0		87313
50106	756	9201	1995-09-01	1995-09-01 00:00:00	1995-09-02	1995-09-02 00:00:00	44818517	\N	\N	020a5564-bc60-40ff-afe2-999e812bfb68	0	0		0		50104
252116	3791	9201	1947-12-25	1947-12-25 00:00:00	1947-12-26	1947-12-26 00:00:00	44818517	\N	\N	e0a34e62-56bc-450b-9e63-a3b8493d149f	0	0		0		252142
13015	190	9201	2016-03-25	2016-03-25 00:00:00	2016-03-26	2016-03-26 00:00:00	44818517	\N	\N	2d5eaad0-7961-4e39-bccd-aa41c6e31174	0	0		0		12955
120296	1794	9201	1972-02-06	1972-02-06 00:00:00	1972-02-09	1972-02-09 00:00:00	44818517	\N	\N	bb058518-723a-46b7-bbb9-8105c5544332	0	0		0		120289
175271	2649	9201	1993-02-14	1993-02-14 00:00:00	1993-02-15	1993-02-15 00:00:00	44818517	\N	\N	7da5ae05-0058-43d8-9a84-8ecbb1561a77	0	0		0		175263
179817	2712	9201	1998-11-30	1998-11-30 00:00:00	1998-12-02	1998-12-02 00:00:00	44818517	\N	\N	fc0f1d6c-2d77-4256-8fdd-a8c19d8fdae7	0	0		0		179884
290783	4376	9201	1999-06-19	1999-06-19 00:00:00	1999-06-20	1999-06-20 00:00:00	44818517	\N	\N	31e085c7-af2f-4c3c-bd69-0e66b6b7dddb	0	0		0		290734
87081	1315	9201	1962-06-05	1962-06-05 00:00:00	1962-06-06	1962-06-06 00:00:00	44818517	\N	\N	834bb624-6139-4ca0-95f5-56e89a2a16ad	0	0		0		87105
8962	133	9201	2019-04-05	2019-04-05 00:00:00	2019-04-06	2019-04-06 00:00:00	44818517	\N	\N	2462e556-0cff-4a2c-98a8-da2ea066aa0b	0	0		0		8972
14546	213	9201	2003-10-18	2003-10-18 00:00:00	2003-10-19	2003-10-19 00:00:00	44818517	\N	\N	15808bdf-146f-49a4-baa0-3a25fd444fb8	0	0		0		14501
273735	4117	9201	1996-08-08	1996-08-08 00:00:00	1996-08-09	1996-08-09 00:00:00	44818517	\N	\N	f2070c68-3d8c-4879-be96-74deaa74a58a	0	0		0		273737
311069	4668	9201	1987-06-30	1987-06-30 00:00:00	1987-07-01	1987-07-01 00:00:00	44818517	\N	\N	6539bb74-103c-4afe-9b07-62e15f3ee71e	0	0		0		311086
17584	264	9201	1984-06-22	1984-06-22 00:00:00	1984-06-23	1984-06-23 00:00:00	44818517	\N	\N	a20c8eb7-5c24-4a7d-88d3-54c4624d4cf0	0	0		0		17547
112766	1683	9201	1997-05-23	1997-05-23 00:00:00	1997-05-24	1997-05-24 00:00:00	44818517	\N	\N	1e80e24d-b1d6-4399-9eb1-e8154a44fcc3	0	0		0		112803
200365	3002	9201	2013-01-01	2013-01-01 00:00:00	2013-01-02	2013-01-02 00:00:00	44818517	\N	\N	1352d5ee-5725-43a6-bf2e-c0db637e8ddf	0	0		0		200380
133915	2012	9201	1996-01-25	1996-01-25 00:00:00	1996-01-28	1996-01-28 00:00:00	44818517	\N	\N	641709ca-e96c-4f3e-854d-74034f0733a5	0	0		0		133851
219244	3300	9201	1986-08-06	1986-08-06 00:00:00	1986-08-08	1986-08-08 00:00:00	44818517	\N	\N	40a78d02-b9c4-4d19-ac6b-69295d9d1307	0	0		0		219258
231786	3494	9201	1999-02-24	1999-02-24 00:00:00	1999-02-25	1999-02-25 00:00:00	44818517	\N	\N	65b1c674-0a1d-46c6-8afa-735bef84a7f5	0	0		0		231722
105233	1569	9201	1987-04-13	1987-04-13 00:00:00	1987-04-14	1987-04-14 00:00:00	44818517	\N	\N	f7fd7808-705a-4f62-9c50-e07bb2772d5a	0	0		0		105228
110178	1641	9201	1962-06-24	1962-06-24 00:00:00	1962-06-26	1962-06-26 00:00:00	44818517	\N	\N	071d4668-9332-4f65-b088-4516f568c6f5	0	0		0		110173
344656	5185	9201	2019-02-18	2019-02-18 00:00:00	2019-02-19	2019-02-19 00:00:00	44818517	\N	\N	c581a2fc-8733-432e-932e-19c58a199345	0	0		0		344702
139175	2088	9201	1945-04-25	1945-04-25 00:00:00	1945-04-26	1945-04-26 00:00:00	44818517	\N	\N	21cb95b1-f167-4919-bc96-39350f5b749f	0	0		0		139313
156889	2356	9201	2017-02-27	2017-02-27 00:00:00	2017-02-28	2017-02-28 00:00:00	44818517	\N	\N	42c04fa7-ef3c-4fa9-a254-ee3bc8d9ecbd	0	0		0		156898
123735	1850	9201	1998-09-29	1998-09-29 00:00:00	1998-09-30	1998-09-30 00:00:00	44818517	\N	\N	f8faf1fb-8033-4743-91fd-550d7d6aac8f	0	0		0		123742
212562	3195	9201	2015-09-14	2015-09-14 00:00:00	2015-09-15	2015-09-15 00:00:00	44818517	\N	\N	0135fb3d-34ed-4ae5-ba8e-829debd48818	0	0		0		212594
97567	1464	9201	2002-11-02	2002-11-02 00:00:00	2002-11-03	2002-11-03 00:00:00	44818517	\N	\N	a286919c-eeaf-4d34-80d3-0388f5fc4018	0	0		0		97550
51436	775	9201	2016-05-31	2016-05-31 00:00:00	2016-06-01	2016-06-01 00:00:00	44818517	\N	\N	f96fb833-a00d-4b66-bcbb-0abde6226ab6	0	0		0		51435
323338	4860	9201	2011-11-05	2011-11-05 00:00:00	2011-11-06	2011-11-06 00:00:00	44818517	\N	\N	44f3c793-d225-4efe-a425-2f8dbf5d3085	0	0		0		323311
107603	1604	9201	1973-04-22	1973-04-22 00:00:00	1973-04-24	1973-04-24 00:00:00	44818517	\N	\N	a20beaaf-cd9c-4208-a185-5d0fa2979bad	0	0		0		107605
298617	4485	9201	1994-12-14	1994-12-14 00:00:00	1994-12-15	1994-12-15 00:00:00	44818517	\N	\N	7b94e90c-a17c-4edf-8b7b-ab2ddb8f8464	0	0		0		298605
164626	2485	9201	1953-04-30	1953-04-30 00:00:00	1953-05-01	1953-05-01 00:00:00	44818517	\N	\N	7ad89ef5-120b-4913-9437-0b4e0bd65b00	0	0		0		164688
93977	1411	9201	1996-03-29	1996-03-29 00:00:00	1996-03-30	1996-03-30 00:00:00	44818517	\N	\N	eb3018c0-9048-4056-b7e1-840bdcda0dfe	0	0		0		93966
239071	3599	9201	2015-03-23	2015-03-23 00:00:00	2015-03-24	2015-03-24 00:00:00	44818517	\N	\N	11f33b80-d1c7-41a7-8feb-c9ef9cd20f09	0	0		0		239072
118160	1766	9201	2014-01-22	2014-01-22 00:00:00	2014-01-23	2014-01-23 00:00:00	44818517	\N	\N	b508fa7a-7805-4d5e-a25f-eb38444bc093	0	0		0		118185
55546	841	9201	1961-01-14	1961-01-14 00:00:00	1961-01-15	1961-01-15 00:00:00	44818517	\N	\N	ae81ee48-c6ce-4a83-ab0f-786bb0426e83	0	0		0		55508
251015	3777	9201	1990-05-02	1990-05-02 00:00:00	1990-05-03	1990-05-03 00:00:00	44818517	\N	\N	893e3176-de75-4b6f-a422-2cc2ddc6dcb8	0	0		0		251032
115806	1733	9201	2016-02-02	2016-02-02 00:00:00	2016-02-03	2016-02-03 00:00:00	44818517	\N	\N	a644e031-e43f-4562-b88e-71eff1ab3a26	0	0		0		115830
245974	3700	9201	2011-08-23	2011-08-23 00:00:00	2011-08-27	2011-08-27 00:00:00	44818517	\N	\N	e5abf181-d4dc-4625-93fb-3fd885e6d624	0	0		0		245983
227967	3437	9201	1955-04-24	1955-04-24 00:00:00	1955-04-25	1955-04-25 00:00:00	44818517	\N	\N	a442df63-38b5-4e3b-bd23-34f4c10a9887	0	0		0		227954
261311	3930	9201	1958-01-03	1958-01-03 00:00:00	1958-01-04	1958-01-04 00:00:00	44818517	\N	\N	1d086ce6-a2e7-433c-a410-635c9bba6254	0	0		0		261287
345407	5194	9201	1982-09-26	1982-09-26 00:00:00	1982-09-27	1982-09-27 00:00:00	44818517	\N	\N	b72a535b-9523-4b83-98cb-11d6af4c7d18	0	0		0		345342
89863	1356	9201	2007-09-29	2007-09-29 00:00:00	2007-09-30	2007-09-30 00:00:00	44818517	\N	\N	6e3aaae0-2198-49a3-a189-ee8f2ad84ea7	0	0		0		89862
222985	3363	9201	1995-10-29	1995-10-29 00:00:00	1995-10-30	1995-10-30 00:00:00	44818517	\N	\N	e9cd0fa0-9c60-468d-b2c6-644f1e7a5cdd	0	0		0		222967
193908	2909	9201	1970-12-29	1970-12-29 00:00:00	1970-12-30	1970-12-30 00:00:00	44818517	\N	\N	6900a583-c427-4f60-8cbf-feb759d0683e	0	0		0		193876
349449	5252	9201	1995-12-19	1995-12-19 00:00:00	1995-12-20	1995-12-20 00:00:00	44818517	\N	\N	392e1390-fb2d-49b2-9c43-53d782aa283b	0	0		0		349478
148	2	9201	2008-03-15	2008-03-15 00:00:00	2008-03-16	2008-03-16 00:00:00	44818517	\N	\N	6bdcdc0b-c096-4934-bbde-8bd6dd6253c3	0	0		0		110
58696	882	9201	2015-05-25	2015-05-25 00:00:00	2015-05-26	2015-05-26 00:00:00	44818517	\N	\N	d74c545e-c84b-4255-a863-80765199ae35	0	0		0		58724
205178	3081	9201	1984-05-30	1984-05-30 00:00:00	1984-05-31	1984-05-31 00:00:00	44818517	\N	\N	406f1d85-95a7-4325-96c9-0933f26be8dd	0	0		0		205089
199956	2997	9201	2004-12-23	2004-12-23 00:00:00	2004-12-24	2004-12-24 00:00:00	44818517	\N	\N	c57641ae-c007-4d71-857f-3221689a5787	0	0		0		199962
209008	3141	9201	2010-11-18	2010-11-18 00:00:00	2010-11-19	2010-11-19 00:00:00	44818517	\N	\N	edac1767-fdb3-45f1-8f14-e095c31c9489	0	0		0		208981
168411	2545	9201	2008-01-06	2008-01-06 00:00:00	2008-01-07	2008-01-07 00:00:00	44818517	\N	\N	159e23ba-6fe8-442a-a31d-6b58b78dc005	0	0		0		168426
276038	4153	9201	1999-11-09	1999-11-09 00:00:00	1999-11-10	1999-11-10 00:00:00	44818517	\N	\N	55b9d51d-4089-41c3-9a75-5233262b1270	0	0		0		276007
77329	1174	9201	1963-03-03	1963-03-03 00:00:00	1963-03-04	1963-03-04 00:00:00	44818517	\N	\N	2fa6de8e-df57-465d-a703-ab309f432ee8	0	0		0		77373
278527	4197	9201	2009-12-15	2009-12-15 00:00:00	2009-12-16	2009-12-16 00:00:00	44818517	\N	\N	09fd7f21-dd8a-4dd4-9bd6-d4ea4004c85b	0	0		0		278540
182873	2765	9201	1994-05-08	1994-05-08 00:00:00	1994-05-13	1994-05-13 00:00:00	44818517	\N	\N	0d5186f9-2627-4214-b914-5b3be9431907	0	0		0		182893
211446	3178	9201	1994-10-07	1994-10-07 00:00:00	1994-10-08	1994-10-08 00:00:00	44818517	\N	\N	8e125115-9687-49e7-85c1-8730fc644ca9	0	0		0		211374
196434	2944	9201	2006-10-23	2006-10-23 00:00:00	2006-10-24	2006-10-24 00:00:00	44818517	\N	\N	3a8b5b0a-7e81-4737-bcf7-6c69605567f4	0	0		0		196397
52651	793	9201	2010-06-18	2010-06-18 00:00:00	2010-06-19	2010-06-19 00:00:00	44818517	\N	\N	3e2fc2ef-5e63-4783-aa21-ea7f837d1def	0	0		0		52604
146877	2204	9201	1957-04-11	1957-04-11 00:00:00	1957-04-12	1957-04-12 00:00:00	44818517	\N	\N	c9da443f-d52d-4728-811a-e516a17cc342	0	0		0		146926
199488	2988	9201	1993-01-10	1993-01-10 00:00:00	1993-01-11	1993-01-11 00:00:00	44818517	\N	\N	2fb11a50-dea6-4217-8b3c-3772ea02471b	0	0		0		199427
330663	4972	9201	1991-01-04	1991-01-04 00:00:00	1991-01-07	1991-01-07 00:00:00	44818517	\N	\N	34e9abc5-c06d-4cb1-85a8-2d56fb045966	0	0		0		330723
39475	597	9201	1987-04-14	1987-04-14 00:00:00	1987-04-15	1987-04-15 00:00:00	44818517	\N	\N	95abc600-571a-4cb2-a3e3-4a1cd925be06	0	0		0		39396
222324	3352	9201	2003-08-02	2003-08-02 00:00:00	2003-08-03	2003-08-03 00:00:00	44818517	\N	\N	e4e04728-35d5-4b42-a0bc-b354daa0b73d	0	0		0		222270
100876	1511	9201	2010-04-15	2010-04-15 00:00:00	2010-04-19	2010-04-19 00:00:00	44818517	\N	\N	e92cfc6d-a552-4e54-bd16-54cc77faadcb	0	0		0		100936
316226	4749	9201	1999-08-09	1999-08-09 00:00:00	1999-08-10	1999-08-10 00:00:00	44818517	\N	\N	257a4d32-3097-4d00-a740-57fe60544e9b	0	0		0		316223
273679	4116	9201	1996-11-06	1996-11-06 00:00:00	1996-11-07	1996-11-07 00:00:00	44818517	\N	\N	89a6aa48-d429-4ca8-9b85-28d28a288e81	0	0		0		273677
228046	3438	9201	1991-12-23	1991-12-23 00:00:00	1991-12-24	1991-12-24 00:00:00	44818517	\N	\N	23805ea0-b61b-4e02-8022-8d33b117e958	0	0		0		228106
249610	3756	9201	2017-12-03	2017-12-03 00:00:00	2017-12-05	2017-12-05 00:00:00	44818517	\N	\N	afb97fad-4b2f-4bbd-9de3-874523cfbb92	0	0		0		249666
266148	4006	9201	1995-01-10	1995-01-10 00:00:00	1995-01-11	1995-01-11 00:00:00	44818517	\N	\N	8de42d6d-81fc-424c-82de-56070ca4f04c	0	0		0		266162
296951	4462	9201	1990-10-24	1990-10-24 00:00:00	1990-10-25	1990-10-25 00:00:00	44818517	\N	\N	32a1702a-9656-4abb-966b-5d5b9112bc74	0	0		0		296905
43127	651	9201	2012-06-08	2012-06-08 00:00:00	2012-06-09	2012-06-09 00:00:00	44818517	\N	\N	ebbc52dd-4223-494f-9e00-a32864b141a0	0	0		0		43096
239802	3609	9201	2018-09-11	2018-09-11 00:00:00	2018-09-12	2018-09-12 00:00:00	44818517	\N	\N	f9258b30-5906-40db-ba5b-cb895e3508e1	0	0		0		239789
336277	5058	9201	2014-07-24	2014-07-24 00:00:00	2014-07-25	2014-07-25 00:00:00	44818517	\N	\N	774350f1-fdb4-421a-8b79-8842c101db32	0	0		0		336348
10104	149	9201	1982-12-10	1982-12-10 00:00:00	1982-12-11	1982-12-11 00:00:00	44818517	\N	\N	3c252cba-9ba5-4dd8-b6cd-07390e30591e	0	0		0		10074
311415	4674	9201	1978-08-20	1978-08-20 00:00:00	1978-08-21	1978-08-21 00:00:00	44818517	\N	\N	84008438-e8f8-4938-a29f-158135686ed1	0	0		0		311402
293743	4418	9201	1954-07-27	1954-07-27 00:00:00	1954-07-30	1954-07-30 00:00:00	44818517	\N	\N	31ac6792-3892-434a-9477-20b337f07736	0	0		0		293694
140751	2115	9201	2004-09-05	2004-09-05 00:00:00	2004-09-06	2004-09-06 00:00:00	44818517	\N	\N	1b3b9b7d-0c6f-49a6-acc8-6d9c02aeabed	0	0		0		140705
208379	3132	9201	2007-05-01	2007-05-01 00:00:00	2007-05-02	2007-05-02 00:00:00	44818517	\N	\N	7c56ccdf-cc7b-4954-8613-77f2b1e2d95b	0	0		0		208441
150619	2265	9201	2002-06-16	2002-06-16 00:00:00	2002-06-17	2002-06-17 00:00:00	44818517	\N	\N	d6b46428-8d19-45d2-8908-102fc5d48e1c	0	0		0		150581
105232	1569	9201	1998-12-18	1998-12-18 00:00:00	1998-12-19	1998-12-19 00:00:00	44818517	\N	\N	44672c46-c898-4177-96a5-cfc4e3590b98	0	0		0		105229
88495	1334	9201	1972-08-11	1972-08-11 00:00:00	1972-08-12	1972-08-12 00:00:00	44818517	\N	\N	c3f9e1d0-0762-4818-b606-c83a7bcd31ba	0	0		0		88529
324938	4886	9201	2002-05-01	2002-05-01 00:00:00	2002-05-02	2002-05-02 00:00:00	44818517	\N	\N	f589f31e-7529-40c2-b198-f367d6104b1b	0	0		0		324945
6779	99	9201	1996-10-17	1996-10-17 00:00:00	1996-10-21	1996-10-21 00:00:00	44818517	\N	\N	48104275-5e4d-4873-ae5c-347c5e89d182	0	0		0		6764
18686	280	9201	1991-02-02	1991-02-02 00:00:00	1991-02-03	1991-02-03 00:00:00	44818517	\N	\N	7a618cec-b545-4f2c-ad95-0a01ab76a85b	0	0		0		18766
47519	718	9201	1970-04-04	1970-04-04 00:00:00	1970-04-05	1970-04-05 00:00:00	44818517	\N	\N	b2a4d681-b3be-489f-afad-1ecccb9204ba	0	0		0		47524
12671	187	9201	1985-02-09	1985-02-09 00:00:00	1985-02-10	1985-02-10 00:00:00	44818517	\N	\N	ecb28876-4016-4a63-a238-238b170c09e3	0	0		0		12684
279517	4210	9201	2017-02-18	2017-02-18 00:00:00	2017-02-19	2017-02-19 00:00:00	44818517	\N	\N	db04da5d-1c59-4b45-bd0e-a4a729536a31	0	0		0		279540
113481	1695	9201	2003-06-26	2003-06-26 00:00:00	2003-06-28	2003-06-28 00:00:00	44818517	\N	\N	7db3aa99-cea5-4678-9bd7-5cd9c4167de3	0	0		0		113483
107602	1604	9201	1991-04-13	1991-04-13 00:00:00	1991-04-14	1991-04-14 00:00:00	44818517	\N	\N	0bbf154c-7a3c-4c78-a438-8bc2cd7cc5a7	0	0		0		107649
179452	2709	9201	1984-04-03	1984-04-03 00:00:00	1984-04-04	1984-04-04 00:00:00	44818517	\N	\N	5e0c7eb2-503a-4368-b88b-35deeca84ae7	0	0		0		179449
308767	4633	9201	1974-01-13	1974-01-13 00:00:00	1974-01-14	1974-01-14 00:00:00	44818517	\N	\N	49aba50d-4a78-4e99-9448-1880c902a9a0	0	0		0		308763
139779	2097	9201	2014-04-17	2014-04-17 00:00:00	2014-04-18	2014-04-18 00:00:00	44818517	\N	\N	5876fa01-e9f6-4dbb-a588-1e73851838bd	0	0		0		139794
201034	3014	9201	2013-06-12	2013-06-12 00:00:00	2013-06-13	2013-06-13 00:00:00	44818517	\N	\N	b3c6229d-1ab4-4483-b90e-c25616105620	0	0		0		201001
220539	3321	9201	2013-05-11	2013-05-11 00:00:00	2013-05-12	2013-05-12 00:00:00	44818517	\N	\N	7dea9121-ce35-4649-a19c-88877b2f8bee	0	0		0		220497
327005	4922	9201	1983-06-05	1983-06-05 00:00:00	1983-06-06	1983-06-06 00:00:00	44818517	\N	\N	3b092108-699e-4006-bbbe-b85ad489da12	0	0		0		327002
251031	3777	9201	2018-09-19	2018-09-19 00:00:00	2018-09-20	2018-09-20 00:00:00	44818517	\N	\N	ba629334-94db-48d8-bd8c-157f8825fe4a	0	0		0		251040
297940	4477	9201	2012-07-02	2012-07-02 00:00:00	2012-07-03	2012-07-03 00:00:00	44818517	\N	\N	794ee346-3cc7-4470-b21d-b22078e4e48e	0	0		0		297915
238707	3593	9201	1988-03-27	1988-03-27 00:00:00	1988-03-28	1988-03-28 00:00:00	44818517	\N	\N	27d47679-6fa6-4763-a673-55901f2c6579	0	0		0		238688
240878	3623	9201	2009-06-06	2009-06-06 00:00:00	2009-06-08	2009-06-08 00:00:00	44818517	\N	\N	be30c20b-32da-4370-b516-7cdc73d00f7a	0	0		0		240937
142417	2138	9201	1976-10-06	1976-10-06 00:00:00	1976-10-08	1976-10-08 00:00:00	44818517	\N	\N	ea4f8d54-5c94-476e-97de-5a7a49c7a734	0	0		0		142403
204358	3070	9201	1967-08-28	1967-08-28 00:00:00	1967-08-29	1967-08-29 00:00:00	44818517	\N	\N	45f259f8-0388-4b96-b5dd-099ba80753d5	0	0		0		204366
246499	3708	9201	2015-08-08	2015-08-08 00:00:00	2015-08-09	2015-08-09 00:00:00	44818517	\N	\N	b1a4091d-a430-414f-b377-082b2f9c6e5f	0	0		0		246528
283770	4276	9201	2006-12-15	2006-12-15 00:00:00	2006-12-16	2006-12-16 00:00:00	44818517	\N	\N	0fb6a15e-c5c7-46ee-afa0-068b03c31563	0	0		0		283729
193907	2909	9201	1986-09-23	1986-09-23 00:00:00	1986-09-24	1986-09-24 00:00:00	44818517	\N	\N	3ba23f60-984e-431e-b6e4-cbdce48d275d	0	0		0		193924
291070	4380	9201	2001-10-25	2001-10-25 00:00:00	2001-10-26	2001-10-26 00:00:00	44818517	\N	\N	6df7e756-0e35-467e-87d6-35a26150fdbd	0	0		0		291004
128902	1937	9201	1977-07-20	1977-07-20 00:00:00	1977-07-21	1977-07-21 00:00:00	44818517	\N	\N	5a9f8023-74fd-484f-9f21-f09c6628484e	0	0		0		128905
159014	2392	9201	1976-04-02	1976-04-02 00:00:00	1976-04-04	1976-04-04 00:00:00	44818517	\N	\N	41ee258a-0876-43a8-a5ce-e84a18e94891	0	0		0		159085
300038	4505	9201	1981-11-16	1981-11-16 00:00:00	1981-11-17	1981-11-17 00:00:00	44818517	\N	\N	08ce15c0-7c89-4013-b31a-dd26caaf2a39	0	0		0		300120
331270	4979	9201	2014-10-23	2014-10-23 00:00:00	2014-10-24	2014-10-24 00:00:00	44818517	\N	\N	291ff41f-bc33-41b2-976f-52cf9e718ed8	0	0		0		331279
288015	4343	9201	1958-08-05	1958-08-05 00:00:00	1958-08-06	1958-08-06 00:00:00	44818517	\N	\N	a49e9e2b-3ae0-41f8-827a-2ed259452453	0	0		0		288076
207387	3117	9201	2008-05-12	2008-05-12 00:00:00	2008-05-13	2008-05-13 00:00:00	44818517	\N	\N	a51f7e8d-728e-41a9-bbc7-28783f1c7757	0	0		0		207340
276037	4153	9201	2001-10-31	2001-10-31 00:00:00	2001-11-01	2001-11-01 00:00:00	44818517	\N	\N	d20270c8-ab1c-4462-bd6a-3b91b11fdca1	0	0		0		276038
73603	1117	9201	1978-11-29	1978-11-29 00:00:00	1978-11-30	1978-11-30 00:00:00	44818517	\N	\N	7393adf6-312c-412b-bffd-a1a046bbc04a	0	0		0		73599
154829	2328	9201	1999-06-28	1999-06-28 00:00:00	1999-06-29	1999-06-29 00:00:00	44818517	\N	\N	04b05b0f-fc62-4f2f-988b-8374cd4a9d85	0	0		0		154884
291997	4391	9201	1978-08-14	1978-08-14 00:00:00	1978-08-15	1978-08-15 00:00:00	44818517	\N	\N	c684ba1e-2a2e-42e8-8d40-bf8ad94a79cd	0	0		0		291972
353616	5316	9201	1995-08-02	1995-08-02 00:00:00	1995-08-03	1995-08-03 00:00:00	44818517	\N	\N	bbeda8fd-354e-45ac-8094-148adfd3e19f	0	0		0		353554
33973	507	9201	2016-04-19	2016-04-19 00:00:00	2016-04-20	2016-04-20 00:00:00	44818517	\N	\N	59fff60e-894e-4866-843b-e8502012227b	0	0		0		33964
52650	793	9201	2012-02-20	2012-02-20 00:00:00	2012-02-22	2012-02-22 00:00:00	44818517	\N	\N	310f9ee4-8895-45e4-a1ff-6c1771f40f3c	0	0		0		52612
309245	4639	9201	2004-09-05	2004-09-05 00:00:00	2004-09-06	2004-09-06 00:00:00	44818517	\N	\N	8ce944fb-0248-4b88-8902-b2eabd4249df	0	0		0		309210
136811	2058	9201	2013-08-16	2013-08-16 00:00:00	2013-08-17	2013-08-17 00:00:00	44818517	\N	\N	5b990170-b14a-44d9-ba14-90664ddec9b8	0	0		0		136800
210877	3172	9201	1999-01-17	1999-01-17 00:00:00	1999-01-18	1999-01-18 00:00:00	44818517	\N	\N	2aefa423-04f1-4855-b777-dc41c9d8f0fd	0	0		0		210821
66407	1005	9201	1989-03-04	1989-03-04 00:00:00	1989-03-06	1989-03-06 00:00:00	44818517	\N	\N	36565954-8caa-4071-bfc1-91092f6d3a58	0	0		0		66473
177515	2680	9201	1986-02-15	1986-02-15 00:00:00	1986-02-16	1986-02-16 00:00:00	44818517	\N	\N	0b675340-9298-43e5-8adc-17f31b3e9fa3	0	0		0		177555
191208	2872	9201	1979-03-07	1979-03-07 00:00:00	1979-03-08	1979-03-08 00:00:00	44818517	\N	\N	7d4bc122-fe03-499d-a0c4-a54fe14b0d93	0	0		0		191174
316275	4749	9201	2014-02-26	2014-02-26 00:00:00	2014-02-27	2014-02-27 00:00:00	44818517	\N	\N	2d900146-1105-4138-9ebb-97549098d58b	0	0		0		316225
273635	4116	9201	2012-07-20	2012-07-20 00:00:00	2012-07-21	2012-07-21 00:00:00	44818517	\N	\N	05cd56f2-2bdf-4cf4-ae68-33614571481d	0	0		0		273636
230292	3469	9201	1993-03-29	1993-03-29 00:00:00	1993-03-30	1993-03-30 00:00:00	44818517	\N	\N	7a0b2a1f-86f9-41d2-b2e2-d8cb3f354ac0	0	0		0		230254
305004	4578	9201	2000-04-25	2000-04-25 00:00:00	2000-04-26	2000-04-26 00:00:00	44818517	\N	\N	fa3716d5-edd7-4cf6-ba44-ef833adca27a	0	0		0		304963
291912	4390	9201	1994-11-21	1994-11-21 00:00:00	1994-11-22	1994-11-22 00:00:00	44818517	\N	\N	5eaf629a-91ec-47d1-b73f-b3d39dd674ad	0	0		0		291829
296902	4462	9201	2010-05-14	2010-05-14 00:00:00	2010-05-15	2010-05-15 00:00:00	44818517	\N	\N	dab9e525-44ca-43d3-ae3b-fcd2eece3825	0	0		0		296881
29414	442	9201	1985-09-10	1985-09-10 00:00:00	1985-09-11	1985-09-11 00:00:00	44818517	\N	\N	d8fb098b-aeaa-4d24-a29d-30c6e204f583	0	0		0		29303
353460	5315	9201	1957-05-08	1957-05-08 00:00:00	1957-05-09	1957-05-09 00:00:00	44818517	\N	\N	091218d8-973d-4f3d-9f13-b8238ba13f86	0	0		0		353514
100396	1506	9201	1952-09-05	1952-09-05 00:00:00	1952-09-06	1952-09-06 00:00:00	44818517	\N	\N	502284e4-5972-4fa1-82cf-6ae14198d8aa	0	0		0		100393
287399	4333	9201	1980-08-22	1980-08-22 00:00:00	1980-08-25	1980-08-25 00:00:00	44818517	\N	\N	92009203-7280-476a-b090-947d0aad7477	0	0		0		287412
64969	974	9201	1993-06-16	1993-06-16 00:00:00	1993-06-20	1993-06-20 00:00:00	44818517	\N	\N	02017e1e-8c1a-47ce-aa82-9900d6c19d0e	0	0		0		64966
21527	326	9201	2004-04-10	2004-04-10 00:00:00	2004-04-11	2004-04-11 00:00:00	44818517	\N	\N	852528dc-f751-40a1-bd0b-6eaf6c817a12	0	0		0		21557
248971	3745	9201	1935-03-13	1935-03-13 00:00:00	1935-03-17	1935-03-17 00:00:00	44818517	\N	\N	e65c0ef5-47da-4c6d-860b-c43095ef4adf	0	0		0		248901
45498	687	9201	1992-01-17	1992-01-17 00:00:00	1992-01-18	1992-01-18 00:00:00	44818517	\N	\N	da5c4f7c-3b2d-4787-b930-345ff697efa4	0	0		0		45462
201862	3028	9201	1978-04-20	1978-04-20 00:00:00	1978-04-24	1978-04-24 00:00:00	44818517	\N	\N	b6699a70-edf7-4760-97ea-081c47482de2	0	0		0		201860
162230	2445	9201	1979-09-24	1979-09-24 00:00:00	1979-09-25	1979-09-25 00:00:00	44818517	\N	\N	f17ff0c4-8d11-4d0f-af08-35615c08f652	0	0		0		162234
235864	3553	9201	1966-11-09	1966-11-09 00:00:00	1966-11-10	1966-11-10 00:00:00	44818517	\N	\N	27e48102-c5ad-4e4a-86b0-4f8081b30881	0	0		0		235944
263348	3961	9201	1974-11-05	1974-11-05 00:00:00	1974-11-06	1974-11-06 00:00:00	44818517	\N	\N	bd2ee6dd-7cae-47ef-b001-eee18c396bb0	0	0		0		263350
188371	2836	9201	2019-03-21	2019-03-21 00:00:00	2019-03-22	2019-03-22 00:00:00	44818517	\N	\N	a3202776-2bdd-4fb5-9908-b8049786766c	0	0		0		188385
243113	3652	9201	1999-07-12	1999-07-12 00:00:00	1999-07-13	1999-07-13 00:00:00	44818517	\N	\N	fb1b17f4-8a7e-4264-b32e-b8d4a876cc70	0	0		0		243085
321316	4829	9201	2012-07-04	2012-07-04 00:00:00	2012-07-05	2012-07-05 00:00:00	44818517	\N	\N	451c8de1-27b8-4024-b6b9-66312a52e71c	0	0		0		321321
324461	4878	9201	2011-12-25	2011-12-25 00:00:00	2011-12-27	2011-12-27 00:00:00	44818517	\N	\N	a2d8135c-146b-4ac0-a0e8-106b53392759	0	0		0		324423
174030	2631	9201	1993-01-09	1993-01-09 00:00:00	1993-01-10	1993-01-10 00:00:00	44818517	\N	\N	08635b9e-e0e0-420f-9865-1df596338de8	0	0		0		174102
113498	1695	9201	2010-07-26	2010-07-26 00:00:00	2010-07-27	2010-07-27 00:00:00	44818517	\N	\N	fd0a5bef-b8d4-4b2a-a43a-b81539a69c2d	0	0		0		113490
184722	2788	9201	2017-12-02	2017-12-02 00:00:00	2017-12-03	2017-12-03 00:00:00	44818517	\N	\N	d7cd3165-2d18-4bc7-9e7c-c09722ef5609	0	0		0		184724
116047	1737	9201	1950-09-18	1950-09-18 00:00:00	1950-09-19	1950-09-19 00:00:00	44818517	\N	\N	2b1776b2-9c6f-4b85-9ddc-5acc9039a31e	0	0		0		116050
308807	4633	9201	1992-09-28	1992-09-28 00:00:00	1992-09-29	1992-09-29 00:00:00	44818517	\N	\N	96a0b207-e4ec-45b3-bd05-027ad3d21d83	0	0		0		308768
260702	3921	9201	2014-09-04	2014-09-04 00:00:00	2014-09-05	2014-09-05 00:00:00	44818517	\N	\N	f6681782-2d25-46bb-9869-c24a674e0a15	0	0		0		260749
241433	3629	9201	1973-05-27	1973-05-27 00:00:00	1973-05-28	1973-05-28 00:00:00	44818517	\N	\N	293bec17-9c8b-4d98-a015-5663c21c1e5d	0	0		0		241471
211126	3176	9201	1997-10-12	1997-10-12 00:00:00	1997-10-13	1997-10-13 00:00:00	44818517	\N	\N	4b4a2f3e-7c13-4810-95e7-83bd6c45b260	0	0		0		211103
127460	1916	9201	1982-05-30	1982-05-30 00:00:00	1982-05-31	1982-05-31 00:00:00	44818517	\N	\N	5216eb90-8c13-41a1-9f04-9f673001b87d	0	0		0		127442
127417	1916	9201	2007-06-07	2007-06-07 00:00:00	2007-06-08	2007-06-08 00:00:00	44818517	\N	\N	4d46f564-fc68-47d1-8937-2db6b87fb846	0	0		0		127498
121820	1821	9201	1982-11-04	1982-11-04 00:00:00	1982-11-05	1982-11-05 00:00:00	44818517	\N	\N	ec6ffa78-93a6-4d97-b440-5bc7831145fc	0	0		0		121784
213686	3216	9201	1995-12-22	1995-12-22 00:00:00	1995-12-23	1995-12-23 00:00:00	44818517	\N	\N	06c3634f-e75d-4c07-9ae8-329c1a01c81e	0	0		0		213732
142418	2138	9201	1990-07-14	1990-07-14 00:00:00	1990-07-15	1990-07-15 00:00:00	44818517	\N	\N	b4b26ffc-5bc8-49da-9df6-c761556af936	0	0		0		142387
3109	42	9201	1933-10-30	1933-10-30 00:00:00	1933-10-31	1933-10-31 00:00:00	44818517	\N	\N	b48c7d8d-58cc-4e97-a35d-fa4df891f811	0	0		0		3025
272621	4102	9201	1997-09-27	1997-09-27 00:00:00	1997-09-28	1997-09-28 00:00:00	44818517	\N	\N	e07cbcd8-d899-4895-94f9-36c72b26cd45	0	0		0		272581
75935	1148	9201	2010-06-10	2010-06-10 00:00:00	2010-06-11	2010-06-11 00:00:00	44818517	\N	\N	4f090916-7237-452a-9c98-83716a2b4711	0	0		0		75934
193892	2909	9201	1988-06-27	1988-06-27 00:00:00	1988-06-28	1988-06-28 00:00:00	44818517	\N	\N	accbd998-04aa-4e10-a306-c922e2732946	0	0		0		193852
58983	885	9201	2012-04-05	2012-04-05 00:00:00	2012-04-08	2012-04-08 00:00:00	44818517	\N	\N	480a2b16-0f27-4ae1-b459-3be75293185b	0	0		0		59012
176391	2662	9201	2002-07-12	2002-07-12 00:00:00	2002-07-13	2002-07-13 00:00:00	44818517	\N	\N	663c56e3-395c-4dfe-b554-8353519b0e25	0	0		0		176431
324677	4883	9201	1986-04-19	1986-04-19 00:00:00	1986-04-20	1986-04-20 00:00:00	44818517	\N	\N	095bf61c-90c1-4a3c-8047-02921b1ecbcf	0	0		0		324692
126050	1892	9201	2015-10-29	2015-10-29 00:00:00	2015-10-30	2015-10-30 00:00:00	44818517	\N	\N	fa2e3b27-6058-415b-8613-c2bb9bdab548	0	0		0		126016
212740	3199	9201	2006-01-25	2006-01-25 00:00:00	2006-01-27	2006-01-27 00:00:00	44818517	\N	\N	80452a8b-598f-4eb3-b1b1-fb619e450260	0	0		0		212771
263666	3966	9201	2003-05-31	2003-05-31 00:00:00	2003-06-01	2003-06-01 00:00:00	44818517	\N	\N	bee95f35-ae3e-4297-b5a0-92374b916ec7	0	0		0		263706
285715	4308	9201	1992-11-10	1992-11-10 00:00:00	1992-11-11	1992-11-11 00:00:00	44818517	\N	\N	f7e98b65-05b0-4d84-bf59-7684eada2b9b	0	0		0		285815
247996	3732	9201	2015-11-16	2015-11-16 00:00:00	2015-11-17	2015-11-17 00:00:00	44818517	\N	\N	31b4ee95-9497-4482-be81-c2aab407b95d	0	0		0		247988
342949	5157	9201	1985-04-06	1985-04-06 00:00:00	1985-04-09	1985-04-09 00:00:00	44818517	\N	\N	78abcb46-03c0-4285-a983-4c25238b40cc	0	0		0		342947
300402	4509	9201	2007-01-25	2007-01-25 00:00:00	2007-01-26	2007-01-26 00:00:00	44818517	\N	\N	69fac297-19ad-4aa6-b0e2-34e9da049bbc	0	0		0		300398
355125	5333	9201	1986-09-07	1986-09-07 00:00:00	1986-09-08	1986-09-08 00:00:00	44818517	\N	\N	941d36ec-54d4-4773-9d5a-4065408265b2	0	0		0		355092
4183	61	9201	2005-09-15	2005-09-15 00:00:00	2005-09-16	2005-09-16 00:00:00	44818517	\N	\N	591464ad-4503-4cf2-862c-ad06f23bc88f	0	0		0		4136
334457	5034	9201	1971-03-15	1971-03-15 00:00:00	1971-03-16	1971-03-16 00:00:00	44818517	\N	\N	778c0dc5-2afc-4874-8deb-480fc3bd9afe	0	0		0		334461
123649	1848	9201	1982-10-11	1982-10-11 00:00:00	1982-10-12	1982-10-12 00:00:00	44818517	\N	\N	da52c6d8-0a1f-4ab9-a612-1a15037ca47a	0	0		0		123685
220115	3314	9201	2003-09-23	2003-09-23 00:00:00	2003-09-24	2003-09-24 00:00:00	44818517	\N	\N	8723ee39-c32b-405d-80e6-9161962458fd	0	0		0		220105
316216	4748	9201	1997-07-26	1997-07-26 00:00:00	1997-07-28	1997-07-28 00:00:00	44818517	\N	\N	4e7b80e6-e513-4842-80cf-8d5466870f62	0	0		0		316222
322422	4847	9201	2001-09-26	2001-09-26 00:00:00	2001-09-27	2001-09-27 00:00:00	44818517	\N	\N	3d02b831-21bb-4610-80b3-d64a95c820d3	0	0		0		322449
316780	4756	9201	1985-04-21	1985-04-21 00:00:00	1985-04-22	1985-04-22 00:00:00	44818517	\N	\N	4633e8c5-6362-429c-949d-a95944736a42	0	0		0		316847
339717	5113	9201	2017-03-06	2017-03-06 00:00:00	2017-03-08	2017-03-08 00:00:00	44818517	\N	\N	b39a8ad5-9340-4235-9e86-0883556002f6	0	0		0		339732
151692	2280	9201	1997-04-16	1997-04-16 00:00:00	1997-04-17	1997-04-17 00:00:00	44818517	\N	\N	c139c514-6806-484e-add7-e5c2255de7ce	0	0		0		151558
290729	4376	9201	1961-02-23	1961-02-23 00:00:00	1961-02-24	1961-02-24 00:00:00	44818517	\N	\N	f9c66844-577c-4e47-89c4-6092646f1e60	0	0		0		290777
142027	2134	9201	1997-09-01	1997-09-01 00:00:00	1997-09-03	1997-09-03 00:00:00	44818517	\N	\N	98b9ba67-20de-4319-bb58-7d283061918e	0	0		0		141949
306147	4595	9201	1996-02-22	1996-02-22 00:00:00	1996-02-23	1996-02-23 00:00:00	44818517	\N	\N	bf33ca7c-a57e-4ef2-b82d-1d3f5cb0aa34	0	0		0		306179
34628	518	9201	2007-05-21	2007-05-21 00:00:00	2007-05-22	2007-05-22 00:00:00	44818517	\N	\N	cfde1eee-7894-43bd-af03-856eb56e4bd5	0	0		0		34647
100221	1504	9201	1960-06-07	1960-06-07 00:00:00	1960-06-10	1960-06-10 00:00:00	44818517	\N	\N	e20097c1-5db7-4cad-ba1d-e802926353bf	0	0		0		100238
309697	4644	9201	2001-02-16	2001-02-16 00:00:00	2001-02-17	2001-02-17 00:00:00	44818517	\N	\N	0bcbccd3-e4c2-4943-a09b-bcb33378229c	0	0		0		309678
138476	2079	9201	1956-12-17	1956-12-17 00:00:00	1956-12-19	1956-12-19 00:00:00	44818517	\N	\N	a4d7ab8a-dd60-4581-a732-33cb3ec079e5	0	0		0		138460
50186	757	9201	1950-01-22	1950-01-22 00:00:00	1950-01-23	1950-01-23 00:00:00	44818517	\N	\N	ca7b1747-ca47-4554-b653-3a8f59a53987	0	0		0		50285
287398	4333	9201	1994-08-13	1994-08-13 00:00:00	1994-08-14	1994-08-14 00:00:00	44818517	\N	\N	be9858c0-d1e8-4454-b18c-5a16dbf6b3be	0	0		0		287379
233370	3516	9201	1978-04-15	1978-04-15 00:00:00	1978-04-16	1978-04-16 00:00:00	44818517	\N	\N	9a51ad36-1ed7-4770-bc0f-d7ab4d415ffe	0	0		0		233379
20213	304	9201	1998-05-03	1998-05-03 00:00:00	1998-05-04	1998-05-04 00:00:00	44818517	\N	\N	9c3f82ff-8f8d-4595-b887-4cffa88293c2	0	0		0		20251
141894	2133	9201	1996-11-28	1996-11-28 00:00:00	1996-11-30	1996-11-30 00:00:00	44818517	\N	\N	882e5166-e069-4f16-be49-72ac0039ed31	0	0		0		141933
145186	2177	9201	2005-07-04	2005-07-04 00:00:00	2005-07-05	2005-07-05 00:00:00	44818517	\N	\N	42ee7d06-f9ee-439b-8a4b-65190ffe2d5b	0	0		0		145178
201893	3028	9201	2000-08-08	2000-08-08 00:00:00	2000-08-09	2000-08-09 00:00:00	44818517	\N	\N	c28920f9-f7f3-4cfe-a69a-f471bbd7e85d	0	0		0		201864
135432	2034	9201	2011-09-02	2011-09-02 00:00:00	2011-09-03	2011-09-03 00:00:00	44818517	\N	\N	e0d81d4d-0517-4575-ade6-f46568e24bcd	0	0		0		135430
301940	4532	9201	1946-04-10	1946-04-10 00:00:00	1946-04-11	1946-04-11 00:00:00	44818517	\N	\N	8f484749-6bf6-40f7-9331-c3ef541c78cc	0	0		0		301938
263349	3961	9201	2011-11-24	2011-11-24 00:00:00	2011-11-25	2011-11-25 00:00:00	44818517	\N	\N	55b5f16b-b1a8-4b54-bde3-ca827c5ca9e6	0	0		0		263386
270692	4072	9201	2004-08-31	2004-08-31 00:00:00	2004-09-04	2004-09-04 00:00:00	44818517	\N	\N	0d42f3e5-bf8b-424a-9b3a-66d5f6f13471	0	0		0		270690
214447	3226	9201	2012-08-04	2012-08-04 00:00:00	2012-08-05	2012-08-05 00:00:00	44818517	\N	\N	0d2c1d36-97a1-44a8-989f-a5df8b6d9bdd	0	0		0		214475
120834	1804	9201	1972-06-05	1972-06-05 00:00:00	1972-06-06	1972-06-06 00:00:00	44818517	\N	\N	5c32649b-c37f-4d34-a74d-1e98d62724f2	0	0		0		120843
255094	3843	9201	2008-06-27	2008-06-27 00:00:00	2008-06-28	2008-06-28 00:00:00	44818517	\N	\N	d4cec2fc-2168-4f85-b4ba-a3c534ca8532	0	0		0		255096
117072	1751	9201	2017-11-13	2017-11-13 00:00:00	2017-11-14	2017-11-14 00:00:00	44818517	\N	\N	de4a6149-7e8e-44af-971a-5a030a12c311	0	0		0		117052
33504	500	9201	1998-12-03	1998-12-03 00:00:00	1998-12-04	1998-12-04 00:00:00	44818517	\N	\N	b14e8de7-c570-445a-9490-6be1369cc859	0	0		0		33498
53555	807	9201	1971-01-13	1971-01-13 00:00:00	1971-01-14	1971-01-14 00:00:00	44818517	\N	\N	662158fb-7343-4296-928b-86ec5e0c2e9a	0	0		0		53560
246786	3714	9201	1958-09-08	1958-09-08 00:00:00	1958-09-09	1958-09-09 00:00:00	44818517	\N	\N	dc7659b6-ac7d-430b-99c9-9012b42d450c	0	0		0		246832
260969	3926	9201	1957-05-16	1957-05-16 00:00:00	1957-05-17	1957-05-17 00:00:00	44818517	\N	\N	c91a2aaf-2b85-4840-9692-7f35545af6ca	0	0		0		261006
211352	3177	9201	1950-07-05	1950-07-05 00:00:00	1950-07-06	1950-07-06 00:00:00	44818517	\N	\N	ee6b622c-9dbf-4f2a-84e3-c72b3f78202a	0	0		0		211297
290374	4373	9201	2018-02-04	2018-02-04 00:00:00	2018-02-05	2018-02-05 00:00:00	44818517	\N	\N	fd9764dc-e4c0-4f7e-b157-24f94928407a	0	0		0		290340
183940	2777	9201	1985-11-14	1985-11-14 00:00:00	1985-11-15	1985-11-15 00:00:00	44818517	\N	\N	3920233e-7cba-44b4-a94d-d878b29e0006	0	0		0		183933
127181	1911	9201	2002-12-02	2002-12-02 00:00:00	2002-12-03	2002-12-03 00:00:00	44818517	\N	\N	558a63b2-023c-4dce-9034-3c2285ffc0e9	0	0		0		127195
155255	2333	9201	2010-04-03	2010-04-03 00:00:00	2010-04-04	2010-04-04 00:00:00	44818517	\N	\N	c2dd5b27-c896-4a65-8fe7-913418fcbb67	0	0		0		155254
114706	1716	9201	2009-07-01	2009-07-01 00:00:00	2009-07-02	2009-07-02 00:00:00	44818517	\N	\N	8b51aa3e-ca32-49d7-994a-c1d17294c070	0	0		0		114708
175747	2654	9201	1983-04-20	1983-04-20 00:00:00	1983-04-21	1983-04-21 00:00:00	44818517	\N	\N	3cf0ce9f-7e4e-4e2f-bc29-79965f064034	0	0		0		175722
252325	3795	9201	2010-08-11	2010-08-11 00:00:00	2010-08-12	2010-08-12 00:00:00	44818517	\N	\N	62327211-121c-4472-8705-9556320142dc	0	0		0		252351
88486	1333	9201	2002-05-25	2002-05-25 00:00:00	2002-05-26	2002-05-26 00:00:00	44818517	\N	\N	ef7f3337-3aa9-46b7-b3c5-c3c27edff461	0	0		0		88417
272622	4102	9201	2006-08-11	2006-08-11 00:00:00	2006-08-12	2006-08-12 00:00:00	44818517	\N	\N	9b525b90-c7f1-41d4-a855-21213db712a7	0	0		0		272550
140185	2103	9201	2010-11-02	2010-11-02 00:00:00	2010-11-03	2010-11-03 00:00:00	44818517	\N	\N	c2e39486-e08c-48ae-9947-a721b678250c	0	0		0		140163
81606	1238	9201	1982-08-25	1982-08-25 00:00:00	1982-08-26	1982-08-26 00:00:00	44818517	\N	\N	bc15fe1f-bf3e-4899-8fbb-160440d603a4	0	0		0		81582
80042	1215	9201	2009-06-07	2009-06-07 00:00:00	2009-06-08	2009-06-08 00:00:00	44818517	\N	\N	52225ff3-5647-47c6-86ad-7a70cb101517	0	0		0		80060
100787	1510	9201	1978-08-15	1978-08-15 00:00:00	1978-08-16	1978-08-16 00:00:00	44818517	\N	\N	ce0993e8-39a3-4201-80c1-709c9bb7e604	0	0		0		100789
144177	2164	9201	2012-10-14	2012-10-14 00:00:00	2012-10-15	2012-10-15 00:00:00	44818517	\N	\N	a5a0dcb0-2987-414d-bc94-fa75b5c3b00c	0	0		0		144151
305892	4591	9201	1995-04-10	1995-04-10 00:00:00	1995-04-11	1995-04-11 00:00:00	44818517	\N	\N	dfbe94ad-0fe3-46c9-b49c-66fa0864ac28	0	0		0		305960
35859	539	9201	1956-01-03	1956-01-03 00:00:00	1956-01-04	1956-01-04 00:00:00	44818517	\N	\N	696fe55d-c105-4f5c-9913-e3ebf4611277	0	0		0		35824
123479	1846	9201	1987-12-07	1987-12-07 00:00:00	1987-12-08	1987-12-08 00:00:00	44818517	\N	\N	5d9faf74-6a71-439a-8646-65118497ec1c	0	0		0		123439
40694	613	9201	1977-02-09	1977-02-09 00:00:00	1977-02-10	1977-02-10 00:00:00	44818517	\N	\N	e6167352-3e0c-4b40-a360-9d78b85828d4	0	0		0		40685
282429	4253	9201	2018-10-25	2018-10-25 00:00:00	2018-10-26	2018-10-26 00:00:00	44818517	\N	\N	c128fe0b-b4b2-4387-bcd7-a26603e43116	0	0		0		282473
212007	3184	9201	2000-02-24	2000-02-24 00:00:00	2000-02-25	2000-02-25 00:00:00	44818517	\N	\N	5501f194-e751-4678-9c28-bb092698c6f9	0	0		0		211993
355124	5333	9201	2002-11-09	2002-11-09 00:00:00	2002-11-10	2002-11-10 00:00:00	44818517	\N	\N	3cb2d219-f670-4b9b-bc35-cdbfb1c44ff9	0	0		0		355120
63225	951	9201	1985-11-07	1985-11-07 00:00:00	1985-11-08	1985-11-08 00:00:00	44818517	\N	\N	03e2781f-5de2-4ff0-b9c4-bd6b90a38f5f	0	0		0		63146
332957	5005	9201	2010-03-24	2010-03-24 00:00:00	2010-03-25	2010-03-25 00:00:00	44818517	\N	\N	db731fc5-0b8b-4eed-b67c-555e60ee71ca	0	0		0		332910
283708	4275	9201	1992-05-17	1992-05-17 00:00:00	1992-05-18	1992-05-18 00:00:00	44818517	\N	\N	9774ae21-579c-47ca-9572-dd3a5644190f	0	0		0		283715
226550	3415	9201	1983-09-09	1983-09-09 00:00:00	1983-09-10	1983-09-10 00:00:00	44818517	\N	\N	2818a680-69ac-4bd5-9f25-3091e7785ee2	0	0		0		226518
327926	4933	9201	1998-11-04	1998-11-04 00:00:00	1998-11-05	1998-11-05 00:00:00	44818517	\N	\N	0bfd9e93-6487-4725-b2f8-65bee9fe1402	0	0		0		327970
203625	3060	9201	1945-09-12	1945-09-12 00:00:00	1945-09-13	1945-09-13 00:00:00	44818517	\N	\N	9eadccad-26d1-45e8-9bd3-8d4c69dbfbfe	0	0		0		203626
213928	3219	9201	2015-01-11	2015-01-11 00:00:00	2015-01-14	2015-01-14 00:00:00	44818517	\N	\N	3810f875-5598-4598-b8bb-9450a4bc55da	0	0		0		213932
333656	5022	9201	2005-06-20	2005-06-20 00:00:00	2005-06-21	2005-06-21 00:00:00	44818517	\N	\N	0ebc9db9-d834-4a71-b9a3-f7c750d3a5d3	0	0		0		333684
184230	2780	9201	1957-01-18	1957-01-18 00:00:00	1957-01-22	1957-01-22 00:00:00	44818517	\N	\N	e31cb255-83e3-442e-b7ba-b30952a770a7	0	0		0		184274
128324	1928	9201	2018-02-27	2018-02-27 00:00:00	2018-02-28	2018-02-28 00:00:00	44818517	\N	\N	82205d6d-c74c-4c40-a97d-78658ee2ff27	0	0		0		128379
290531	4374	9201	2013-04-13	2013-04-13 00:00:00	2013-04-14	2013-04-14 00:00:00	44818517	\N	\N	15efea3a-f83d-4d26-8d6f-28469e1c365a	0	0		0		290510
273393	4113	9201	1997-01-24	1997-01-24 00:00:00	1997-01-26	1997-01-26 00:00:00	44818517	\N	\N	c43190e4-6742-43a5-80cc-c15901813354	0	0		0		273388
139975	2100	9201	1976-06-11	1976-06-11 00:00:00	1976-06-12	1976-06-12 00:00:00	44818517	\N	\N	53570e9e-92eb-4b02-a210-73dd9fd03962	0	0		0		139971
86893	1313	9201	2011-09-04	2011-09-04 00:00:00	2011-09-05	2011-09-05 00:00:00	44818517	\N	\N	f244a9c2-4b1c-4768-8e25-d9b3a384b4fd	0	0		0		86924
95124	1430	9201	1965-11-18	1965-11-18 00:00:00	1965-11-22	1965-11-22 00:00:00	44818517	\N	\N	46eec365-a592-449e-aa1b-11704734df67	0	0		0		95189
17779	268	9201	1989-02-16	1989-02-16 00:00:00	1989-02-19	1989-02-19 00:00:00	44818517	\N	\N	ffa68bbf-8f35-445c-a83c-90d3ae622600	0	0		0		17798
50187	757	9201	1998-10-17	1998-10-17 00:00:00	1998-10-18	1998-10-18 00:00:00	44818517	\N	\N	a4eeae9f-4fa7-41a2-89db-9c406b7f1699	0	0		0		50232
323495	4865	9201	1977-11-15	1977-11-15 00:00:00	1977-11-16	1977-11-16 00:00:00	44818517	\N	\N	f546a2a9-8013-4834-b1ed-f2e3c65be96d	0	0		0		323500
111399	1658	9201	1948-01-29	1948-01-29 00:00:00	1948-01-30	1948-01-30 00:00:00	44818517	\N	\N	7f9f5efd-1e77-4e2b-9809-2abc10aea081	0	0		0		111322
196179	2942	9201	2005-07-17	2005-07-17 00:00:00	2005-07-18	2005-07-18 00:00:00	44818517	\N	\N	e2e1949d-379e-4f6c-a0d0-55edbd559e05	0	0		0		196060
143996	2160	9201	2012-07-03	2012-07-03 00:00:00	2012-07-04	2012-07-04 00:00:00	44818517	\N	\N	5c1409ab-55bb-4b14-80c3-eff1444b8d9f	0	0		0		143922
240061	3614	9201	2011-03-21	2011-03-21 00:00:00	2011-03-22	2011-03-22 00:00:00	44818517	\N	\N	4c3efa64-0b18-4f31-bd03-fe93ca15a95b	0	0		0		240069
19002	285	9201	2006-08-16	2006-08-16 00:00:00	2006-08-17	2006-08-17 00:00:00	44818517	\N	\N	c27930c2-6282-4d22-aca5-0b4d6447f938	0	0		0		19031
249514	3754	9201	2017-05-26	2017-05-26 00:00:00	2017-05-27	2017-05-27 00:00:00	44818517	\N	\N	052229b1-e9f4-402d-bb29-62fb1d65baa8	0	0		0		249553
15938	236	9201	1990-12-21	1990-12-21 00:00:00	1990-12-22	1990-12-22 00:00:00	44818517	\N	\N	329928b5-a61d-42f9-951e-539088eb1b84	0	0		0		15857
157132	2358	9201	2007-10-15	2007-10-15 00:00:00	2007-10-16	2007-10-16 00:00:00	44818517	\N	\N	e69ae9d4-f45d-40c3-86a2-1c434c9e092b	0	0		0		157106
270678	4072	9201	2012-01-09	2012-01-09 00:00:00	2012-01-10	2012-01-10 00:00:00	44818517	\N	\N	743a9459-e641-4ff7-9945-9023303dc91b	0	0		0		270672
225610	3401	9201	1965-10-21	1965-10-21 00:00:00	1965-10-22	1965-10-22 00:00:00	44818517	\N	\N	222ddedb-edfd-49fc-ab89-d9f2d4ccc676	0	0		0		225623
2282	32	9201	1987-06-09	1987-06-09 00:00:00	1987-06-10	1987-06-10 00:00:00	44818517	\N	\N	3ff2b157-69cd-452b-b3b5-6838e27d9b19	0	0		0		2198
163798	2470	9201	1992-12-29	1992-12-29 00:00:00	1992-12-30	1992-12-30 00:00:00	44818517	\N	\N	c91d1a70-a8b6-46d2-8f3b-3e8ca02cab2e	0	0		0		163828
167926	2540	9201	1975-01-29	1975-01-29 00:00:00	1975-01-30	1975-01-30 00:00:00	44818517	\N	\N	0583619e-36fa-4380-a316-f633d7ae8c4b	0	0		0		167913
179069	2703	9201	2014-05-11	2014-05-11 00:00:00	2014-05-12	2014-05-12 00:00:00	44818517	\N	\N	854b98aa-842c-487f-8cd7-b548e32ea5a9	0	0		0		179096
53556	807	9201	1994-11-04	1994-11-04 00:00:00	1994-11-05	1994-11-05 00:00:00	44818517	\N	\N	44e10a9d-10ef-4ef3-948a-cec0184173bc	0	0		0		53550
91727	1384	9201	1994-01-20	1994-01-20 00:00:00	1994-01-21	1994-01-21 00:00:00	44818517	\N	\N	4b3d8956-081c-4750-b521-894ff1e59542	0	0		0		91725
304206	4565	9201	1962-07-21	1962-07-21 00:00:00	1962-07-22	1962-07-22 00:00:00	44818517	\N	\N	674e5ec5-925f-4f89-bc86-755ff691f4f0	0	0		0		304259
319699	4805	9201	2003-08-19	2003-08-19 00:00:00	2003-08-20	2003-08-20 00:00:00	44818517	\N	\N	d19ab2a6-266c-4bdb-a28a-0f903c850649	0	0		0		319709
164454	2482	9201	1995-03-03	1995-03-03 00:00:00	1995-03-05	1995-03-05 00:00:00	44818517	\N	\N	03310366-0ee2-4320-a181-56be79e9b947	0	0		0		164426
64469	969	9201	2004-08-07	2004-08-07 00:00:00	2004-08-08	2004-08-08 00:00:00	44818517	\N	\N	f03af7f2-be4a-417d-a90a-40d5a2c05e60	0	0		0		64448
328563	4943	9201	1979-11-23	1979-11-23 00:00:00	1979-11-24	1979-11-24 00:00:00	44818517	\N	\N	9ca43f96-ee8a-42be-bae3-ee17e7ed805c	0	0		0		328622
15092	224	9201	1977-03-03	1977-03-03 00:00:00	1977-03-04	1977-03-04 00:00:00	44818517	\N	\N	e2c85638-b7f7-49f9-a69c-057a6329e853	0	0		0		15100
204715	3077	9201	1992-05-08	1992-05-08 00:00:00	1992-05-09	1992-05-09 00:00:00	44818517	\N	\N	10c0abe7-f80f-4dc5-8364-29abd2b34e28	0	0		0		204723
263146	3958	9201	2001-12-09	2001-12-09 00:00:00	2001-12-10	2001-12-10 00:00:00	44818517	\N	\N	92f5c856-c8a3-4246-9410-a20b027191be	0	0		0		263194
140300	2108	9201	1978-08-31	1978-08-31 00:00:00	1978-09-01	1978-09-01 00:00:00	44818517	\N	\N	45318c96-8a1d-4707-9da7-9cbafb91c56d	0	0		0		140348
79284	1206	9201	1972-02-11	1972-02-11 00:00:00	1972-02-15	1972-02-15 00:00:00	44818517	\N	\N	009c1ba5-c735-4c29-bc9e-6620f8ad3c07	0	0		0		79259
24837	374	9201	2015-09-06	2015-09-06 00:00:00	2015-09-07	2015-09-07 00:00:00	44818517	\N	\N	a929932d-7bf6-49e0-a0cf-580695f97fed	0	0		0		24836
113361	1692	9201	2017-01-28	2017-01-28 00:00:00	2017-01-29	2017-01-29 00:00:00	44818517	\N	\N	a2f4eb97-a705-410a-96ec-409ed8ce6648	0	0		0		113359
296241	4452	9201	1996-12-04	1996-12-04 00:00:00	1996-12-05	1996-12-05 00:00:00	44818517	\N	\N	e6c93422-220a-4484-a09b-1a3e12edf382	0	0		0		296268
235169	3540	9201	2013-07-26	2013-07-26 00:00:00	2013-07-27	2013-07-27 00:00:00	44818517	\N	\N	b5a7f1bf-5222-4c45-83d3-f284d1b3e27a	0	0		0		235163
147270	2210	9201	1969-10-19	1969-10-19 00:00:00	1969-10-20	1969-10-20 00:00:00	44818517	\N	\N	88927a4c-1b8c-4cff-ae48-b7cb39f8e563	0	0		0		147198
231480	3489	9201	1998-09-06	1998-09-06 00:00:00	1998-09-07	1998-09-07 00:00:00	44818517	\N	\N	85d7cd51-e791-4951-96b7-dbd6f2a469fe	0	0		0		231450
35793	539	9201	1969-01-19	1969-01-19 00:00:00	1969-01-20	1969-01-20 00:00:00	44818517	\N	\N	9b45de10-a880-4e7c-b478-d0dbd37ec9d5	0	0		0		35805
211482	3179	9201	2002-02-14	2002-02-14 00:00:00	2002-02-15	2002-02-15 00:00:00	44818517	\N	\N	6797fe1d-6bf9-463f-93f7-0f597ad55e3f	0	0		0		211525
130031	1954	9201	2006-04-16	2006-04-16 00:00:00	2006-04-17	2006-04-17 00:00:00	44818517	\N	\N	75062dc3-8b3e-4aab-abf4-b674721ac040	0	0		0		129998
340509	5121	9201	2000-04-10	2000-04-10 00:00:00	2000-04-11	2000-04-11 00:00:00	44818517	\N	\N	846eb5d4-5b47-48ea-b710-80d00c0dd6ff	0	0		0		340507
258556	3890	9201	1993-03-25	1993-03-25 00:00:00	1993-03-26	1993-03-26 00:00:00	44818517	\N	\N	d992d274-2f18-48c2-a099-cec55855c81f	0	0		0		258569
23549	354	9201	2011-04-22	2011-04-22 00:00:00	2011-04-23	2011-04-23 00:00:00	44818517	\N	\N	f46d0dff-4983-42dd-8576-4ee07e421638	0	0		0		23578
112881	1685	9201	2016-01-14	2016-01-14 00:00:00	2016-01-15	2016-01-15 00:00:00	44818517	\N	\N	91cb6505-09dd-4a5c-8003-768ed477c657	0	0		0		112907
338170	5086	9201	2010-03-26	2010-03-26 00:00:00	2010-03-27	2010-03-27 00:00:00	44818517	\N	\N	4fa4c88f-c146-4411-bcc2-6c745b108107	0	0		0		338180
283264	4268	9201	1970-05-04	1970-05-04 00:00:00	1970-05-05	1970-05-05 00:00:00	44818517	\N	\N	327ffa4d-6177-449c-8395-96032e8d8ec6	0	0		0		283209
184662	2786	9201	2015-12-03	2015-12-03 00:00:00	2015-12-04	2015-12-04 00:00:00	44818517	\N	\N	c9b9153e-04ae-4c78-97a6-60d4757447e2	0	0		0		184631
234721	3533	9201	2001-01-14	2001-01-14 00:00:00	2001-01-15	2001-01-15 00:00:00	44818517	\N	\N	9a9dc0f4-cee7-46c9-bfaa-e3a978ce7ebb	0	0		0		234705
332122	4992	9201	2007-05-12	2007-05-12 00:00:00	2007-05-16	2007-05-16 00:00:00	44818517	\N	\N	0244a26b-2718-4f30-8d44-0e97c03843d0	0	0		0		332117
260357	3916	9201	1997-06-24	1997-06-24 00:00:00	1997-06-25	1997-06-25 00:00:00	44818517	\N	\N	22f430de-bea0-47f2-a380-33ce402e797c	0	0		0		260435
168845	2550	9201	2018-02-09	2018-02-09 00:00:00	2018-02-10	2018-02-10 00:00:00	44818517	\N	\N	993a6030-a834-47c7-90e4-037be3083511	0	0		0		168792
136098	2046	9201	1969-12-30	1969-12-30 00:00:00	1969-12-31	1969-12-31 00:00:00	44818517	\N	\N	ec6ecaf0-b051-4599-bbc4-39d7b1a2b531	0	0		0		136088
304551	4571	9201	2001-03-25	2001-03-25 00:00:00	2001-03-26	2001-03-26 00:00:00	44818517	\N	\N	41ab2a2b-e921-4744-96ab-45ca7ecd4838	0	0		0		304555
99457	1491	9201	2006-05-25	2006-05-25 00:00:00	2006-05-26	2006-05-26 00:00:00	44818517	\N	\N	1ebd2d05-d501-4b4d-b45a-8ef96354adca	0	0		0		99420
116868	1748	9201	1989-07-10	1989-07-10 00:00:00	1989-07-12	1989-07-12 00:00:00	44818517	\N	\N	9648723f-7f0f-4977-ac17-98d185de9fe1	0	0		0		116870
191471	2878	9201	2019-04-11	2019-04-11 00:00:00	2019-04-12	2019-04-12 00:00:00	44818517	\N	\N	189726a1-78f1-4694-a4d4-27692032b22e	0	0		0		191453
345484	5195	9201	1995-07-26	1995-07-26 00:00:00	1995-07-27	1995-07-27 00:00:00	44818517	\N	\N	c2bb9567-bf0d-412d-8c50-fd0ce0605823	0	0		0		345424
323552	4865	9201	1981-12-01	1981-12-01 00:00:00	1981-12-02	1981-12-02 00:00:00	44818517	\N	\N	cb15418e-8e62-4878-acc6-1d9ff286944c	0	0		0		323501
54874	828	9201	1971-04-21	1971-04-21 00:00:00	1971-04-22	1971-04-22 00:00:00	44818517	\N	\N	ccba647a-6702-456c-ad37-b59fa12d91a3	0	0		0		54863
172938	2615	9201	1987-05-12	1987-05-12 00:00:00	1987-05-13	1987-05-13 00:00:00	44818517	\N	\N	6fda0db2-4ff4-4caf-9d09-8f8e051cea61	0	0		0		172919
132477	1989	9201	1988-10-29	1988-10-29 00:00:00	1988-10-30	1988-10-30 00:00:00	44818517	\N	\N	9c7b9edf-7090-4f0e-a4e6-eee914d691b4	0	0		0		132479
146580	2199	9201	1995-07-19	1995-07-19 00:00:00	1995-07-23	1995-07-23 00:00:00	44818517	\N	\N	40dc9779-049c-4ca6-87d1-16d77611f0ad	0	0		0		146578
152494	2291	9201	1966-10-15	1966-10-15 00:00:00	1966-10-19	1966-10-19 00:00:00	44818517	\N	\N	b68ba7a3-1eae-4efb-aa85-a9c621c92eb8	0	0		0		152488
252863	3804	9201	2003-07-05	2003-07-05 00:00:00	2003-07-06	2003-07-06 00:00:00	44818517	\N	\N	93adfa3c-5a76-43cd-8480-59c1ad327507	0	0		0		252844
74640	1133	9201	2000-09-05	2000-09-05 00:00:00	2000-09-06	2000-09-06 00:00:00	44818517	\N	\N	215be8d1-b5f0-4414-ab01-a10c809b68a9	0	0		0		74630
235968	3553	9201	2012-09-21	2012-09-21 00:00:00	2012-09-22	2012-09-22 00:00:00	44818517	\N	\N	2d328665-a891-4f70-b01d-6e2a2990414f	0	0		0		235921
36419	549	9201	1987-12-29	1987-12-29 00:00:00	1987-12-30	1987-12-30 00:00:00	44818517	\N	\N	21771e33-8eb5-4315-b113-0614935144b8	0	0		0		36387
275749	4149	9201	2002-10-13	2002-10-13 00:00:00	2002-10-14	2002-10-14 00:00:00	44818517	\N	\N	127274cf-0ccd-453d-bacc-21c538461e51	0	0		0		275727
207423	3118	9201	1972-08-30	1972-08-30 00:00:00	1972-08-31	1972-08-31 00:00:00	44818517	\N	\N	26c931f4-66e8-460e-9525-a91e16d20185	0	0		0		207534
284194	4282	9201	1978-04-05	1978-04-05 00:00:00	1978-04-09	1978-04-09 00:00:00	44818517	\N	\N	485fac5b-0b3e-49fd-8df3-76998ae34d15	0	0		0		284193
280548	4224	9201	1950-11-21	1950-11-21 00:00:00	1950-11-22	1950-11-22 00:00:00	44818517	\N	\N	1253dca4-f228-4b71-87a8-a177f4d691af	0	0		0		280589
218561	3290	9201	2004-06-30	2004-06-30 00:00:00	2004-07-01	2004-07-01 00:00:00	44818517	\N	\N	aca2fe44-a986-4016-9808-8001af16c2d7	0	0		0		218613
91728	1384	9201	1996-04-16	1996-04-16 00:00:00	1996-04-17	1996-04-17 00:00:00	44818517	\N	\N	164f15b5-812d-4301-b123-745186d97fb7	0	0		0		91748
150658	2266	9201	2008-07-01	2008-07-01 00:00:00	2008-07-02	2008-07-02 00:00:00	44818517	\N	\N	4f452565-2599-40b6-8171-6c1e506af17e	0	0		0		150678
80915	1228	9201	1980-01-13	1980-01-13 00:00:00	1980-01-14	1980-01-14 00:00:00	44818517	\N	\N	0c36fdba-0d08-4b24-acc0-e69a0d784989	0	0		0		80894
198165	2966	9201	2001-02-25	2001-02-25 00:00:00	2001-02-26	2001-02-26 00:00:00	44818517	\N	\N	dbdea316-5ad9-41f5-96bf-657b61280dc9	0	0		0		198119
237632	3573	9201	1963-12-21	1963-12-21 00:00:00	1963-12-22	1963-12-22 00:00:00	44818517	\N	\N	d3482fd2-01b4-4449-b1e1-1d80daeaf76f	0	0		0		237521
126520	1900	9201	1996-01-05	1996-01-05 00:00:00	1996-01-06	1996-01-06 00:00:00	44818517	\N	\N	d781c44f-25d9-417c-92ce-0af4b09f4db9	0	0		0		126491
227361	3430	9201	2005-05-14	2005-05-14 00:00:00	2005-05-15	2005-05-15 00:00:00	44818517	\N	\N	28c48248-5221-4e3a-8b15-b041cdc7d57c	0	0		0		227340
11188	163	9201	2010-04-25	2010-04-25 00:00:00	2010-04-26	2010-04-26 00:00:00	44818517	\N	\N	dd772383-9c15-4711-920f-9dbb8974596f	0	0		0		11212
183852	2776	9201	2014-02-22	2014-02-22 00:00:00	2014-02-23	2014-02-23 00:00:00	44818517	\N	\N	0bebecbb-61af-4c60-850a-9ae3535e3bbf	0	0		0		183851
99646	1496	9201	1998-05-02	1998-05-02 00:00:00	1998-05-03	1998-05-03 00:00:00	44818517	\N	\N	b3618407-ebb6-45b9-ae00-4e2a4c002f47	0	0		0		99651
32984	492	9201	1979-12-05	1979-12-05 00:00:00	1979-12-07	1979-12-07 00:00:00	44818517	\N	\N	f873b025-5b35-4af9-90b4-96c46598e9d0	0	0		0		32910
129643	1950	9201	2002-02-01	2002-02-01 00:00:00	2002-02-02	2002-02-02 00:00:00	44818517	\N	\N	fb2d93d7-a028-4936-86fc-445414165013	0	0		0		129619
88166	1328	9201	1971-05-28	1971-05-28 00:00:00	1971-05-29	1971-05-29 00:00:00	44818517	\N	\N	1f0d98cb-dd3c-4418-807f-bf6517cc113f	0	0		0		88138
214559	3227	9201	1998-07-30	1998-07-30 00:00:00	1998-07-31	1998-07-31 00:00:00	44818517	\N	\N	87780bd9-0b97-46f2-8727-9cbd8a40ea6d	0	0		0		214543
235332	3543	9201	1978-07-21	1978-07-21 00:00:00	1978-07-22	1978-07-22 00:00:00	44818517	\N	\N	19ab509b-c798-47ad-89bd-cadddfd6312d	0	0		0		235330
177922	2685	9201	1993-01-28	1993-01-28 00:00:00	1993-01-29	1993-01-29 00:00:00	44818517	\N	\N	fd9fddaa-e398-49de-ae96-6fa3ff303470	0	0		0		177928
339318	5107	9201	2011-07-10	2011-07-10 00:00:00	2011-07-11	2011-07-11 00:00:00	44818517	\N	\N	3e7812ad-788f-4886-b0e1-12a7bd388232	0	0		0		339336
143743	2156	9201	2009-05-07	2009-05-07 00:00:00	2009-05-08	2009-05-08 00:00:00	44818517	\N	\N	b8565368-fda5-4a3b-841d-13390b68d92d	0	0		0		143729
281510	4239	9201	1993-08-06	1993-08-06 00:00:00	1993-08-07	1993-08-07 00:00:00	44818517	\N	\N	fa6dc64d-3cb6-4c57-8a08-ff905606451b	0	0		0		281507
317196	4760	9201	1956-10-23	1956-10-23 00:00:00	1956-10-24	1956-10-24 00:00:00	44818517	\N	\N	64de8698-08dd-4a19-92af-a6a1bab19147	0	0		0		317194
42243	639	9201	1989-06-08	1989-06-08 00:00:00	1989-06-09	1989-06-09 00:00:00	44818517	\N	\N	c9609877-42bd-420e-a85a-2f055d740938	0	0		0		42292
82979	1259	9201	1981-10-16	1981-10-16 00:00:00	1981-10-17	1981-10-17 00:00:00	44818517	\N	\N	1351cff5-cd1c-40c3-b440-9ae34221aa80	0	0		0		82976
262599	3950	9201	2008-09-23	2008-09-23 00:00:00	2008-09-24	2008-09-24 00:00:00	44818517	\N	\N	2f905bb2-9ecc-4b7f-83ca-d8065fbff2b1	0	0		0		262526
320435	4816	9201	1982-11-11	1982-11-11 00:00:00	1982-11-12	1982-11-12 00:00:00	44818517	\N	\N	8ba3020b-0b69-4e14-887b-8dc8021da114	0	0		0		320398
56120	847	9201	2011-06-27	2011-06-27 00:00:00	2011-06-28	2011-06-28 00:00:00	44818517	\N	\N	43656963-3718-4cf1-9ced-6f76336e3499	0	0		0		56118
79555	1211	9201	1971-10-23	1971-10-23 00:00:00	1971-10-24	1971-10-24 00:00:00	44818517	\N	\N	a7b2e0f0-1336-445e-93a3-c3bf631868ac	0	0		0		79551
286639	4320	9201	2010-03-23	2010-03-23 00:00:00	2010-03-24	2010-03-24 00:00:00	44818517	\N	\N	33af2f79-ec45-4d2a-9210-727a21155703	0	0		0		286654
55949	844	9201	2002-10-10	2002-10-10 00:00:00	2002-10-11	2002-10-11 00:00:00	44818517	\N	\N	959b5a22-120a-4fc2-8b27-1265eb298040	0	0		0		56005
227919	3436	9201	2003-05-03	2003-05-03 00:00:00	2003-05-04	2003-05-04 00:00:00	44818517	\N	\N	6ce8ee92-ad85-446e-8f25-b8e68a46b01f	0	0		0		227918
240341	3618	9201	1994-07-29	1994-07-29 00:00:00	1994-07-30	1994-07-30 00:00:00	44818517	\N	\N	b82c55f4-e229-4516-876a-19076da7f50b	0	0		0		240446
17537	264	9201	1969-10-25	1969-10-25 00:00:00	1969-10-26	1969-10-26 00:00:00	44818517	\N	\N	747393e2-eeae-447d-be07-6b1aa2a62dcc	0	0		0		17534
201763	3026	9201	2019-06-07	2019-06-07 00:00:00	2019-06-08	2019-06-08 00:00:00	44818517	\N	\N	3e06e041-8292-4443-8736-208fa78d112d	0	0		0		201730
350926	5276	9201	2011-01-07	2011-01-07 00:00:00	2011-01-08	2011-01-08 00:00:00	44818517	\N	\N	98a18652-2922-49c9-80c7-a11266ce63b0	0	0		0		350933
117573	1758	9201	2002-11-07	2002-11-07 00:00:00	2002-11-08	2002-11-08 00:00:00	44818517	\N	\N	4de4589a-ee5e-4c7b-8c70-40fd0e6ec2a8	0	0		0		117528
233350	3516	9201	2017-03-15	2017-03-15 00:00:00	2017-03-16	2017-03-16 00:00:00	44818517	\N	\N	4db032e7-4bfc-43fe-a430-45d40f01fc7c	0	0		0		233369
293793	4418	9201	2006-10-07	2006-10-07 00:00:00	2006-10-08	2006-10-08 00:00:00	44818517	\N	\N	9f44339d-3134-4941-bf10-0015f383b1fe	0	0		0		293748
30394	455	9201	1977-01-25	1977-01-25 00:00:00	1977-01-27	1977-01-27 00:00:00	44818517	\N	\N	bfe3692b-6a58-4f71-9e01-f1d1bcd4fa5d	0	0		0		30469
152405	2291	9201	1971-02-26	1971-02-26 00:00:00	1971-02-27	1971-02-27 00:00:00	44818517	\N	\N	6373d3db-0042-4531-abc3-ab88c41cc5da	0	0		0		152490
145620	2184	9201	2003-02-26	2003-02-26 00:00:00	2003-02-27	2003-02-27 00:00:00	44818517	\N	\N	d87e5ff0-c174-4a43-a0cd-0228b8f209bf	0	0		0		145529
5509	81	9201	1984-03-15	1984-03-15 00:00:00	1984-03-18	1984-03-18 00:00:00	44818517	\N	\N	a074a2ea-9918-4277-b9c3-a090c3c159a3	0	0		0		5508
301937	4532	9201	1998-10-13	1998-10-13 00:00:00	1998-10-14	1998-10-14 00:00:00	44818517	\N	\N	4ac2a92c-f8a6-42d6-b44e-de74c3079fa9	0	0		0		301894
13878	202	9201	1982-05-16	1982-05-16 00:00:00	1982-05-17	1982-05-17 00:00:00	44818517	\N	\N	b25eb484-7d7c-4c4f-bf58-2072927a31cf	0	0		0		13822
81442	1236	9201	1939-10-24	1939-10-24 00:00:00	1939-10-25	1939-10-25 00:00:00	44818517	\N	\N	770a66b5-a792-43ff-99b0-76cc95ead7b4	0	0		0		81482
126608	1902	9201	1985-11-17	1985-11-17 00:00:00	1985-11-18	1985-11-18 00:00:00	44818517	\N	\N	6583ead1-a69f-4dab-8a2d-d8268f05bd3f	0	0		0		126638
24416	366	9201	1954-11-28	1954-11-28 00:00:00	1954-11-29	1954-11-29 00:00:00	44818517	\N	\N	c875ca51-3128-4304-8185-e651203d1c0a	0	0		0		24353
76733	1162	9201	2007-01-02	2007-01-02 00:00:00	2007-01-03	2007-01-03 00:00:00	44818517	\N	\N	411c44d9-2d60-4eb8-a89b-baa675808a3e	0	0		0		76781
244325	3672	9201	1986-03-13	1986-03-13 00:00:00	1986-03-15	1986-03-15 00:00:00	44818517	\N	\N	49cf41c7-3d6d-430b-9c1d-66cd6c39c112	0	0		0		244327
54130	817	9201	2013-01-03	2013-01-03 00:00:00	2013-01-04	2013-01-04 00:00:00	44818517	\N	\N	289c6d49-706f-468f-8d28-271784173fb0	0	0		0		54111
24968	377	9201	2003-04-02	2003-04-02 00:00:00	2003-04-03	2003-04-03 00:00:00	44818517	\N	\N	2d12dbf9-52e4-4bdc-bc3f-d6bf2d238f6a	0	0		0		25005
181336	2740	9201	2010-05-13	2010-05-13 00:00:00	2010-05-14	2010-05-14 00:00:00	44818517	\N	\N	1ff40754-d8a1-4dbe-add2-f0b5e6fbe058	0	0		0		181319
153618	2309	9201	2018-01-13	2018-01-13 00:00:00	2018-01-14	2018-01-14 00:00:00	44818517	\N	\N	f596bdf6-c127-4fd5-8e69-99b017104597	0	0		0		153636
242624	3647	9201	1970-01-07	1970-01-07 00:00:00	1970-01-08	1970-01-08 00:00:00	44818517	\N	\N	45c732ba-945f-49c2-a9fb-e15a82fdcb85	0	0		0		242692
267047	4018	9201	2001-09-10	2001-09-10 00:00:00	2001-09-11	2001-09-11 00:00:00	44818517	\N	\N	8ed45e20-91e6-47fc-8860-2af48188e3d4	0	0		0		267055
39523	598	9201	2010-01-22	2010-01-22 00:00:00	2010-01-23	2010-01-23 00:00:00	44818517	\N	\N	5a8a6c63-7baf-4cbf-bdeb-81c88c95f501	0	0		0		39500
303812	4560	9201	1977-10-30	1977-10-30 00:00:00	1977-11-01	1977-11-01 00:00:00	44818517	\N	\N	4b377570-1d6d-4332-8765-95ba24d73481	0	0		0		303809
21813	331	9201	1942-09-29	1942-09-29 00:00:00	1942-10-01	1942-10-01 00:00:00	44818517	\N	\N	b159f05f-0302-4b5b-908e-fa4acf005a0c	0	0		0		21807
206555	3106	9201	1990-05-10	1990-05-10 00:00:00	1990-05-11	1990-05-11 00:00:00	44818517	\N	\N	58c42796-b9de-456b-a929-9e8b6373ce23	0	0		0		206581
88155	1328	9201	2001-11-15	2001-11-15 00:00:00	2001-11-16	2001-11-16 00:00:00	44818517	\N	\N	419d143e-9e54-41af-916c-3679f5321854	0	0		0		88169
106105	1579	9201	1988-05-25	1988-05-25 00:00:00	1988-05-26	1988-05-26 00:00:00	44818517	\N	\N	8ed42856-460a-45f3-8df9-848261fffa19	0	0		0		106070
302080	4534	9201	1998-06-17	1998-06-17 00:00:00	1998-06-18	1998-06-18 00:00:00	44818517	\N	\N	1e1b9409-9a86-4354-89a6-3b5ea90cedd0	0	0		0		302078
219439	3304	9201	2001-06-09	2001-06-09 00:00:00	2001-06-10	2001-06-10 00:00:00	44818517	\N	\N	35428338-b61e-4c91-89c5-e2ffb3ba0f1f	0	0		0		219442
154340	2320	9201	1980-03-23	1980-03-23 00:00:00	1980-03-24	1980-03-24 00:00:00	44818517	\N	\N	2986f819-7849-42ff-a6e4-062f0ef52f70	0	0		0		154331
262206	3943	9201	1973-03-21	1973-03-21 00:00:00	1973-03-22	1973-03-22 00:00:00	44818517	\N	\N	885f54fd-3f00-43f9-a4b3-49bc2e80e190	0	0		0		262137
271905	4090	9201	1955-01-21	1955-01-21 00:00:00	1955-01-22	1955-01-22 00:00:00	44818517	\N	\N	ab291788-93d0-4c06-81ea-178f030fccca	0	0		0		271933
51374	774	9201	2008-06-22	2008-06-22 00:00:00	2008-06-23	2008-06-23 00:00:00	44818517	\N	\N	7554ef47-9dba-441f-9723-c094c4fc54b4	0	0		0		51404
79031	1201	9201	2008-01-19	2008-01-19 00:00:00	2008-01-20	2008-01-20 00:00:00	44818517	\N	\N	207afc96-58cd-4c75-9293-8cc700f5cc3f	0	0		0		79006
151092	2273	9201	2016-06-25	2016-06-25 00:00:00	2016-06-26	2016-06-26 00:00:00	44818517	\N	\N	ec4332ba-7d3d-4195-8140-07cbb6829f30	0	0		0		151130
262576	3950	9201	2015-01-14	2015-01-14 00:00:00	2015-01-15	2015-01-15 00:00:00	44818517	\N	\N	55d6b7ab-65b7-49e2-b919-3fe05006d586	0	0		0		262580
305634	4587	9201	1960-04-08	1960-04-08 00:00:00	1960-04-09	1960-04-09 00:00:00	44818517	\N	\N	e9b42f3f-79b6-4038-87bc-a498f0f42986	0	0		0		305567
144977	2175	9201	1979-01-29	1979-01-29 00:00:00	1979-01-31	1979-01-31 00:00:00	44818517	\N	\N	339dc0e2-037f-4f28-9fe3-9412c73bfd5b	0	0		0		145066
172819	2613	9201	2003-05-03	2003-05-03 00:00:00	2003-05-07	2003-05-07 00:00:00	44818517	\N	\N	52882382-2620-45f9-93ec-e361dc1f0268	0	0		0		172771
11904	176	9201	1975-05-23	1975-05-23 00:00:00	1975-05-25	1975-05-25 00:00:00	44818517	\N	\N	ce61e801-2dcb-4cc2-a58e-3095822f109f	0	0		0		11929
219061	3296	9201	1980-07-16	1980-07-16 00:00:00	1980-07-17	1980-07-17 00:00:00	44818517	\N	\N	c2459326-1cbb-44bf-aead-eb0f5e77e722	0	0		0		219038
59484	893	9201	1993-11-09	1993-11-09 00:00:00	1993-11-10	1993-11-10 00:00:00	44818517	\N	\N	9294d722-254b-4239-920a-19b223c5bd84	0	0		0		59516
9022	135	9201	2010-02-02	2010-02-02 00:00:00	2010-02-03	2010-02-03 00:00:00	44818517	\N	\N	32b5834a-b81c-48bf-a856-97bdc97962f2	0	0		0		9078
350950	5276	9201	2015-05-21	2015-05-21 00:00:00	2015-05-22	2015-05-22 00:00:00	44818517	\N	\N	a568b2d4-3067-4f20-93cb-38380bab6214	0	0		0		350921
337811	5081	9201	2006-11-08	2006-11-08 00:00:00	2006-11-09	2006-11-09 00:00:00	44818517	\N	\N	7d950512-c983-4942-b3bc-68ffb9acafe7	0	0		0		337928
233391	3516	9201	2017-12-31	2017-12-31 00:00:00	2018-01-01	2018-01-01 00:00:00	44818517	\N	\N	b4f5e9fb-cc71-4ba7-9643-633b91d5a415	0	0		0		233349
198629	2975	9201	1975-04-06	1975-04-06 00:00:00	1975-04-10	1975-04-10 00:00:00	44818517	\N	\N	d978f052-7973-4112-9527-d13d781f71dc	0	0		0		198648
48274	728	9201	1960-01-22	1960-01-22 00:00:00	1960-01-25	1960-01-25 00:00:00	44818517	\N	\N	99165cea-2366-457d-9380-f089fe0eda4d	0	0		0		48319
237906	3578	9201	1979-08-03	1979-08-03 00:00:00	1979-08-04	1979-08-04 00:00:00	44818517	\N	\N	53db7e31-ff79-4c57-9de3-2a129dbfa903	0	0		0		237858
225746	3403	9201	2008-09-06	2008-09-06 00:00:00	2008-09-07	2008-09-07 00:00:00	44818517	\N	\N	2e292726-928f-44a4-83fd-5012d566695f	0	0		0		225757
144893	2173	9201	2010-07-04	2010-07-04 00:00:00	2010-07-05	2010-07-05 00:00:00	44818517	\N	\N	2d88f065-b865-43be-a716-0ab4ef7692a5	0	0		0		144892
90207	1359	9201	2008-09-06	2008-09-06 00:00:00	2008-09-07	2008-09-07 00:00:00	44818517	\N	\N	880ad51b-3bea-4ea4-919d-5d57d3a4464c	0	0		0		90178
243454	3658	9201	1999-09-01	1999-09-01 00:00:00	1999-09-02	1999-09-02 00:00:00	44818517	\N	\N	4bb25567-67a9-4459-b863-116da2e02fbc	0	0		0		243441
82136	1246	9201	1980-11-07	1980-11-07 00:00:00	1980-11-08	1980-11-08 00:00:00	44818517	\N	\N	8243d5df-c5a3-44ec-8110-16033d3557c4	0	0		0		82077
208694	3135	9201	2005-11-30	2005-11-30 00:00:00	2005-12-01	2005-12-01 00:00:00	44818517	\N	\N	30db481e-c032-4748-8369-53694376027a	0	0		0		208719
348689	5240	9201	1979-04-13	1979-04-13 00:00:00	1979-04-14	1979-04-14 00:00:00	44818517	\N	\N	d3e4e44f-4b86-42a0-94ad-51992ffa839c	0	0		0		348611
108784	1618	9201	2013-06-07	2013-06-07 00:00:00	2013-06-08	2013-06-08 00:00:00	44818517	\N	\N	b3499fc3-52b0-49ee-a01f-16b9db65040a	0	0		0		108811
104985	1566	9201	2003-01-01	2003-01-01 00:00:00	2003-01-02	2003-01-02 00:00:00	44818517	\N	\N	dc0bd146-ba8a-4d67-be7b-5429a7b867d7	0	0		0		105034
242487	3644	9201	1981-12-09	1981-12-09 00:00:00	1981-12-10	1981-12-10 00:00:00	44818517	\N	\N	0f15e441-d762-455e-af65-c4762b090428	0	0		0		242481
325807	4899	9201	1964-06-13	1964-06-13 00:00:00	1964-06-14	1964-06-14 00:00:00	44818517	\N	\N	98a37672-3437-4e3a-ba6d-3867628e87b2	0	0		0		325791
215273	3238	9201	1997-05-27	1997-05-27 00:00:00	1997-05-28	1997-05-28 00:00:00	44818517	\N	\N	a3d6d739-bde3-48be-8680-1a097930a5c2	0	0		0		215317
168219	2543	9201	2001-06-21	2001-06-21 00:00:00	2001-06-22	2001-06-22 00:00:00	44818517	\N	\N	de4372f2-0818-45e4-b4d0-1707b3451b53	0	0		0		168273
218109	3283	9201	2016-07-03	2016-07-03 00:00:00	2016-07-04	2016-07-04 00:00:00	44818517	\N	\N	0c177a60-d91e-4a10-85fc-566d19cdce62	0	0		0		218122
349328	5251	9201	1962-05-29	1962-05-29 00:00:00	1962-05-30	1962-05-30 00:00:00	44818517	\N	\N	2c7c4404-c965-4f7d-970c-45686afc92aa	0	0		0		349311
231359	3488	9201	2008-04-26	2008-04-26 00:00:00	2008-04-27	2008-04-27 00:00:00	44818517	\N	\N	4b3e34f1-9528-40f9-8a97-b2b4c018bd57	0	0		0		231411
152036	2286	9201	1971-08-31	1971-08-31 00:00:00	1971-09-04	1971-09-04 00:00:00	44818517	\N	\N	78a8d6d7-fe37-4510-8544-5900233dba9c	0	0		0		152078
240060	3613	9201	1989-01-23	1989-01-23 00:00:00	1989-01-27	1989-01-27 00:00:00	44818517	\N	\N	b843b010-3aa6-43a2-91b6-6b0d90f93a38	0	0		0		240021
114477	1713	9201	2010-07-22	2010-07-22 00:00:00	2010-07-23	2010-07-23 00:00:00	44818517	\N	\N	22680880-fb57-417b-be65-944d907bd0d3	0	0		0		114450
245778	3697	9201	1955-02-08	1955-02-08 00:00:00	1955-02-10	1955-02-10 00:00:00	44818517	\N	\N	d6a8ddfc-0eeb-499a-b048-cb3f456e853b	0	0		0		245719
117691	1760	9201	2017-09-23	2017-09-23 00:00:00	2017-09-24	2017-09-24 00:00:00	44818517	\N	\N	df82e23a-2458-4510-8290-4ea9b7db1063	0	0		0		117659
329971	4964	9201	2016-01-30	2016-01-30 00:00:00	2016-01-31	2016-01-31 00:00:00	44818517	\N	\N	47b895e7-91b9-4e08-b41c-f998d9460924	0	0		0		329987
169794	2563	9201	1972-04-18	1972-04-18 00:00:00	1972-04-19	1972-04-19 00:00:00	44818517	\N	\N	1519e038-8da3-4524-9423-9a2a3de8e721	0	0		0		169790
335153	5043	9201	1994-09-02	1994-09-02 00:00:00	1994-09-03	1994-09-03 00:00:00	44818517	\N	\N	c2c6de35-2168-4474-bb82-2fee7f973347	0	0		0		335130
269034	4045	9201	2015-07-17	2015-07-17 00:00:00	2015-07-18	2015-07-18 00:00:00	44818517	\N	\N	24ff878e-9894-417d-a10a-425debf0f7b4	0	0		0		269007
7634	115	9201	2001-04-15	2001-04-15 00:00:00	2001-04-16	2001-04-16 00:00:00	44818517	\N	\N	155e2489-8e5f-4310-9d9b-3b55cdbd1e69	0	0		0		7591
63217	951	9201	2011-12-20	2011-12-20 00:00:00	2011-12-21	2011-12-21 00:00:00	44818517	\N	\N	ab4b1f50-f773-4492-a69b-f4eaeeef8782	0	0		0		63205
308630	4631	9201	1934-08-05	1934-08-05 00:00:00	1934-08-08	1934-08-08 00:00:00	44818517	\N	\N	77d4c3f5-676f-4aaa-81d1-c7d004e56022	0	0		0		308581
23063	347	9201	2009-02-01	2009-02-01 00:00:00	2009-02-02	2009-02-02 00:00:00	44818517	\N	\N	8ec317b6-aa5c-4edc-8744-2b01e38f1f55	0	0		0		23088
349844	5257	9201	2014-04-10	2014-04-10 00:00:00	2014-04-11	2014-04-11 00:00:00	44818517	\N	\N	fd3eafd1-df20-433c-9154-ab7d65adc0cf	0	0		0		349786
35103	526	9201	2008-02-17	2008-02-17 00:00:00	2008-02-20	2008-02-20 00:00:00	44818517	\N	\N	3d6dc2f8-0fa5-4702-9d71-3b19b2592661	0	0		0		35106
112060	1669	9201	1998-12-29	1998-12-29 00:00:00	1998-12-30	1998-12-30 00:00:00	44818517	\N	\N	10570271-394f-4de1-90f1-0b8b74bd3a1e	0	0		0		112053
304868	4577	9201	2002-04-07	2002-04-07 00:00:00	2002-04-09	2002-04-09 00:00:00	44818517	\N	\N	0411dc4f-ddd5-4e6f-a6a6-71a7800af5a4	0	0		0		304857
190672	2866	9201	2006-01-05	2006-01-05 00:00:00	2006-01-06	2006-01-06 00:00:00	44818517	\N	\N	97f8fa3b-705c-4fa0-883b-01d92dd1a78e	0	0		0		190665
79459	1209	9201	2004-09-23	2004-09-23 00:00:00	2004-09-24	2004-09-24 00:00:00	44818517	\N	\N	058602cf-e70d-4256-b557-57e1215157f3	0	0		0		79458
106624	1588	9201	1981-12-01	1981-12-01 00:00:00	1981-12-05	1981-12-05 00:00:00	44818517	\N	\N	3f4f0119-9c43-4e43-a206-93e7bb522759	0	0		0		106636
22119	334	9201	2017-11-05	2017-11-05 00:00:00	2017-11-06	2017-11-06 00:00:00	44818517	\N	\N	1bafb579-fc49-42f7-8a08-3b6d0190c8a8	0	0		0		22154
186958	2821	9201	2010-06-29	2010-06-29 00:00:00	2010-06-30	2010-06-30 00:00:00	44818517	\N	\N	86f8a8a5-9232-4211-974e-f7d307f67305	0	0		0		186906
12813	188	9201	2000-02-09	2000-02-09 00:00:00	2000-02-10	2000-02-10 00:00:00	44818517	\N	\N	88973cfd-be4a-455a-b847-f40b2f106749	0	0		0		12809
89608	1352	9201	1989-09-23	1989-09-23 00:00:00	1989-09-24	1989-09-24 00:00:00	44818517	\N	\N	3c08a42c-9ce0-43f4-be9d-11821a92afbd	0	0		0		89617
218313	3287	9201	1980-07-02	1980-07-02 00:00:00	1980-07-03	1980-07-03 00:00:00	44818517	\N	\N	76b92f51-69d1-4ec0-84e6-4b31e90283f8	0	0		0		218342
73715	1118	9201	2014-07-07	2014-07-07 00:00:00	2014-07-08	2014-07-08 00:00:00	44818517	\N	\N	f4b2dae2-530a-4d62-8648-7e8ae1367b58	0	0		0		73745
261146	3928	9201	2012-09-12	2012-09-12 00:00:00	2012-09-13	2012-09-13 00:00:00	44818517	\N	\N	469f9a06-cfb5-4f6d-adb9-03170065150d	0	0		0		261144
342655	5153	9201	1987-03-14	1987-03-14 00:00:00	1987-03-15	1987-03-15 00:00:00	44818517	\N	\N	6b0637ed-5d0b-4416-b4f3-5b94e514f2c6	0	0		0		342690
193482	2903	9201	1975-09-13	1975-09-13 00:00:00	1975-09-16	1975-09-16 00:00:00	44818517	\N	\N	ffcd778a-7874-4636-a74c-3d21bef86ea5	0	0		0		193436
232332	3504	9201	2008-11-21	2008-11-21 00:00:00	2008-11-22	2008-11-22 00:00:00	44818517	\N	\N	9a82d3f9-c57e-431e-9464-bbce93c89185	0	0		0		232293
325851	4899	9201	1976-10-22	1976-10-22 00:00:00	1976-10-23	1976-10-23 00:00:00	44818517	\N	\N	e149d808-5626-4f28-b832-84db082f5825	0	0		0		325810
242933	3650	9201	1984-12-20	1984-12-20 00:00:00	1984-12-21	1984-12-21 00:00:00	44818517	\N	\N	f95fb42e-d65f-4cd0-b1d9-9af98293af73	0	0		0		242936
71435	1088	9201	1995-12-14	1995-12-14 00:00:00	1995-12-15	1995-12-15 00:00:00	44818517	\N	\N	6efe8fc4-5fc7-4dcb-a7b3-ac6e9140911a	0	0		0		71417
156016	2343	9201	1996-02-10	1996-02-10 00:00:00	1996-02-11	1996-02-11 00:00:00	44818517	\N	\N	c04bd749-50d9-4c27-b66f-3d8683b78949	0	0		0		155941
349327	5251	9201	1980-03-03	1980-03-03 00:00:00	1980-03-04	1980-03-04 00:00:00	44818517	\N	\N	2d512584-1c3f-42a0-bb92-eb8f2fd4e066	0	0		0		349350
68381	1039	9201	1996-10-05	1996-10-05 00:00:00	1996-10-06	1996-10-06 00:00:00	44818517	\N	\N	49218601-295b-40b1-bbd1-44211e67b876	0	0		0		68332
124120	1854	9201	2012-05-19	2012-05-19 00:00:00	2012-05-20	2012-05-20 00:00:00	44818517	\N	\N	49f90e3f-a32d-4d78-a41a-c7c71bea65b3	0	0		0		124118
144363	2167	9201	2017-10-03	2017-10-03 00:00:00	2017-10-04	2017-10-04 00:00:00	44818517	\N	\N	03ca0e60-1c1d-4858-9a28-1b9dc4151e3a	0	0		0		144388
287783	4340	9201	2010-04-28	2010-04-28 00:00:00	2010-04-29	2010-04-29 00:00:00	44818517	\N	\N	1db01cee-11dc-4c07-8946-64fa0a738d54	0	0		0		287764
332698	5002	9201	2019-05-25	2019-05-25 00:00:00	2019-05-26	2019-05-26 00:00:00	44818517	\N	\N	334c1f66-88fd-473b-ac90-1812261ba2f5	0	0		0		332700
309327	4641	9201	1993-05-14	1993-05-14 00:00:00	1993-05-15	1993-05-15 00:00:00	44818517	\N	\N	a365aa15-863c-466d-8f9d-255953eadbc1	0	0		0		309330
200795	3010	9201	2004-03-09	2004-03-09 00:00:00	2004-03-10	2004-03-10 00:00:00	44818517	\N	\N	82b2992c-ffaa-46c6-a15e-74d41f9691df	0	0		0		200753
177356	2677	9201	2007-01-27	2007-01-27 00:00:00	2007-01-28	2007-01-28 00:00:00	44818517	\N	\N	fb1b354c-2040-4fe7-9dfe-32ec848d2838	0	0		0		177387
351149	5279	9201	1985-03-02	1985-03-02 00:00:00	1985-03-03	1985-03-03 00:00:00	44818517	\N	\N	4df4b1e1-576d-4236-8b31-046908441960	0	0		0		351166
265650	3996	9201	1989-05-16	1989-05-16 00:00:00	1989-05-17	1989-05-17 00:00:00	44818517	\N	\N	b323568c-b4ed-4b97-87f3-d5c2fb4425ea	0	0		0		265696
326167	4907	9201	1948-02-03	1948-02-03 00:00:00	1948-02-06	1948-02-06 00:00:00	44818517	\N	\N	bc35883a-e994-431b-b22f-686101fb119b	0	0		0		326106
72299	1101	9201	1985-08-17	1985-08-17 00:00:00	1985-08-20	1985-08-20 00:00:00	44818517	\N	\N	c98fe1c2-71c5-4802-89f3-c7e97c68b99f	0	0		0		72311
62902	948	9201	1964-05-27	1964-05-27 00:00:00	1964-05-28	1964-05-28 00:00:00	44818517	\N	\N	655e5471-aab7-4691-a23b-77187292a3ac	0	0		0		62960
307064	4608	9201	2010-03-18	2010-03-18 00:00:00	2010-03-19	2010-03-19 00:00:00	44818517	\N	\N	4d6a4166-6c20-4462-902c-413a2dbcce37	0	0		0		306943
83400	1265	9201	2018-02-20	2018-02-20 00:00:00	2018-02-21	2018-02-21 00:00:00	44818517	\N	\N	7cac07f0-e078-4b4e-b0af-b0476d1b7bc7	0	0		0		83392
352697	5301	9201	1953-03-02	1953-03-02 00:00:00	1953-03-03	1953-03-03 00:00:00	44818517	\N	\N	18d477bc-0bc3-4dd3-bc6e-b065e091ad02	0	0		0		352741
213847	3218	9201	1992-11-29	1992-11-29 00:00:00	1992-11-30	1992-11-30 00:00:00	44818517	\N	\N	547b0b10-e99b-4576-899f-5557adfa621b	0	0		0		213824
325676	4898	9201	1998-01-09	1998-01-09 00:00:00	1998-01-10	1998-01-10 00:00:00	44818517	\N	\N	3e3ba4ed-1197-4da9-aa97-008dbc7050c9	0	0		0		325734
149694	2250	9201	1995-05-12	1995-05-12 00:00:00	1995-05-13	1995-05-13 00:00:00	44818517	\N	\N	86973c46-9358-444a-82cd-99be2feae549	0	0		0		149683
218835	3294	9201	1977-10-13	1977-10-13 00:00:00	1977-10-17	1977-10-17 00:00:00	44818517	\N	\N	7f81e64d-5d55-4863-9fb6-42ad6af1239f	0	0		0		218814
187515	2827	9201	2001-10-02	2001-10-02 00:00:00	2001-10-03	2001-10-03 00:00:00	44818517	\N	\N	92b79a06-5d69-4e31-9e58-2dbaa3274517	0	0		0		187456
89558	1352	9201	2000-05-28	2000-05-28 00:00:00	2000-05-29	2000-05-29 00:00:00	44818517	\N	\N	d73ca6a0-62df-4de4-acb6-42b20b712363	0	0		0		89576
218312	3287	9201	1988-11-12	1988-11-12 00:00:00	1988-11-14	1988-11-14 00:00:00	44818517	\N	\N	141fa3d5-3993-4d99-8ed6-8ed9b05e5736	0	0		0		218391
249022	3746	9201	1987-02-28	1987-02-28 00:00:00	1987-03-01	1987-03-01 00:00:00	44818517	\N	\N	eef925c8-b3ae-48d3-bdaf-f7d78629c914	0	0		0		249015
337258	5073	9201	1947-04-11	1947-04-11 00:00:00	1947-04-12	1947-04-12 00:00:00	44818517	\N	\N	efb64782-8532-477b-919c-2fdc93a73506	0	0		0		337162
342742	5153	9201	2014-06-21	2014-06-21 00:00:00	2014-06-22	2014-06-22 00:00:00	44818517	\N	\N	d7052e07-bd61-433f-87be-82a1f2fff825	0	0		0		342653
11981	177	9201	2002-05-14	2002-05-14 00:00:00	2002-05-15	2002-05-15 00:00:00	44818517	\N	\N	63174c7b-dde9-4bb0-9b57-cd801403b835	0	0		0		11955
325808	4899	9201	1979-09-11	1979-09-11 00:00:00	1979-09-12	1979-09-12 00:00:00	44818517	\N	\N	a9065f88-3bb2-44bf-a34f-c21bd775463a	0	0		0		325828
348733	5241	9201	2001-04-15	2001-04-15 00:00:00	2001-04-16	2001-04-16 00:00:00	44818517	\N	\N	d5a914cc-ac5f-4cd6-a7c3-2083f4b17074	0	0		0		348736
71436	1088	9201	2011-09-10	2011-09-10 00:00:00	2011-09-11	2011-09-11 00:00:00	44818517	\N	\N	943f02aa-8058-4aba-ab4f-e2951ef4b520	0	0		0		71411
123480	1847	9201	1958-04-09	1958-04-09 00:00:00	1958-04-10	1958-04-10 00:00:00	44818517	\N	\N	5d4a9c51-3b16-4172-b78a-a46ba9ea6736	0	0		0		123512
294732	4433	9201	1982-08-14	1982-08-14 00:00:00	1982-08-15	1982-08-15 00:00:00	44818517	\N	\N	c82eff09-e5fe-453f-9d6b-635acde98f0a	0	0		0		294644
314352	4720	9201	2014-04-25	2014-04-25 00:00:00	2014-04-26	2014-04-26 00:00:00	44818517	\N	\N	dc4e2175-6c87-468b-a488-b2ceb7e3f24b	0	0		0		314372
247205	3719	9201	2003-11-03	2003-11-03 00:00:00	2003-11-04	2003-11-04 00:00:00	44818517	\N	\N	7ee5d0c6-81ee-4a13-8cef-2ca99b462061	0	0		0		247196
345720	5199	9201	2001-04-19	2001-04-19 00:00:00	2001-04-20	2001-04-20 00:00:00	44818517	\N	\N	e0c7a9f9-bc58-4528-a4b3-18d88a16aeb8	0	0		0		345749
204183	3067	9201	1976-10-06	1976-10-06 00:00:00	1976-10-07	1976-10-07 00:00:00	44818517	\N	\N	1af093f3-5771-4e0d-8406-23f0e177f784	0	0		0		204145
309347	4641	9201	2004-12-29	2004-12-29 00:00:00	2004-12-30	2004-12-30 00:00:00	44818517	\N	\N	4741116f-f757-4af5-bead-92231578ec68	0	0		0		309351
42969	648	9201	1971-09-24	1971-09-24 00:00:00	1971-09-25	1971-09-25 00:00:00	44818517	\N	\N	e13a8394-3f1b-457d-a401-821c87c69e16	0	0		0		42865
13043	191	9201	1929-09-19	1929-09-19 00:00:00	1929-09-20	1929-09-20 00:00:00	44818517	\N	\N	87be4a18-27ca-4786-ab3f-b6e1f115d3e4	0	0		0		13038
10924	159	9201	1997-12-30	1997-12-30 00:00:00	1997-12-31	1997-12-31 00:00:00	44818517	\N	\N	18c0aa7f-c6e5-4aad-a093-ff409443e8d4	0	0		0		10922
351724	5285	9201	1981-02-06	1981-02-06 00:00:00	1981-02-07	1981-02-07 00:00:00	44818517	\N	\N	135e9430-85f7-4713-a0c4-95ac1984ee93	0	0		0		351656
233585	3518	9201	1978-09-15	1978-09-15 00:00:00	1978-09-16	1978-09-16 00:00:00	44818517	\N	\N	5a0f0634-f9c9-4576-baf8-a6d00c165715	0	0		0		233582
306947	4608	9201	1987-10-15	1987-10-15 00:00:00	1987-10-16	1987-10-16 00:00:00	44818517	\N	\N	23df5081-0458-4e6c-b641-9937a3fc2385	0	0		0		307066
25772	393	9201	1997-10-01	1997-10-01 00:00:00	1997-10-02	1997-10-02 00:00:00	44818517	\N	\N	a5ab16b0-8c4e-4f09-9cca-7e8ad72f53a5	0	0		0		25804
194614	2919	9201	1965-08-17	1965-08-17 00:00:00	1965-08-19	1965-08-19 00:00:00	44818517	\N	\N	7bd57835-615e-418e-ab99-901bab99a4c7	0	0		0		194611
49371	744	9201	2004-03-17	2004-03-17 00:00:00	2004-03-19	2004-03-19 00:00:00	44818517	\N	\N	5917695a-86e9-4b9c-9ef1-54ac56309cb0	0	0		0		49323
208378	3132	9201	1976-07-05	1976-07-05 00:00:00	1976-07-07	1976-07-07 00:00:00	44818517	\N	\N	4136d7a5-d5b3-45d2-814d-9783edc7a709	0	0		0		208403
168202	2542	9201	2003-04-24	2003-04-24 00:00:00	2003-04-25	2003-04-25 00:00:00	44818517	\N	\N	d7087693-9b46-4276-8f42-24d5fe0bac49	0	0		0		168183
197702	2961	9201	1972-09-26	1972-09-26 00:00:00	1972-09-27	1972-09-27 00:00:00	44818517	\N	\N	d7a243d8-11ef-41ef-a19f-3423f721a2ec	0	0		0		197766
248907	3745	9201	1997-03-02	1997-03-02 00:00:00	1997-03-03	1997-03-03 00:00:00	44818517	\N	\N	4f890fc4-470c-4f7b-bec6-871b099667a6	0	0		0		248878
104536	1560	9201	1975-02-16	1975-02-16 00:00:00	1975-02-17	1975-02-17 00:00:00	44818517	\N	\N	60e32085-c106-4605-bcb2-3981b2c56e68	0	0		0		104524
337257	5073	9201	2012-06-22	2012-06-22 00:00:00	2012-06-23	2012-06-23 00:00:00	44818517	\N	\N	9a1b9df1-6a62-41d6-89f8-cae7fbfca34c	0	0		0		337236
110393	1646	9201	1982-11-22	1982-11-22 00:00:00	1982-11-23	1982-11-23 00:00:00	44818517	\N	\N	247623be-6c06-4e70-bc4b-877f08f80140	0	0		0		110449
280380	4223	9201	1989-11-01	1989-11-01 00:00:00	1989-11-02	1989-11-02 00:00:00	44818517	\N	\N	3637ada7-bfbf-48c0-bfac-9536c8cbeb8f	0	0		0		280436
239405	3603	9201	1967-02-08	1967-02-08 00:00:00	1967-02-10	1967-02-10 00:00:00	44818517	\N	\N	8ba0b358-62ef-423f-af89-29d0d564214e	0	0		0		239335
27160	410	9201	1951-09-02	1951-09-02 00:00:00	1951-09-03	1951-09-03 00:00:00	44818517	\N	\N	431ec837-69aa-45d7-aad8-5f922de81bb0	0	0		0		27163
123520	1847	9201	1995-06-15	1995-06-15 00:00:00	1995-06-16	1995-06-16 00:00:00	44818517	\N	\N	f556bbeb-d2a2-4077-8fb8-c4d9f4500c54	0	0		0		123591
235493	3545	9201	2012-03-07	2012-03-07 00:00:00	2012-03-08	2012-03-08 00:00:00	44818517	\N	\N	18e88c5b-8849-42aa-8838-3d120514b82f	0	0		0		235450
230685	3477	9201	1997-02-13	1997-02-13 00:00:00	1997-02-14	1997-02-14 00:00:00	44818517	\N	\N	38cf458e-ba22-42c8-b071-cce86291c265	0	0		0		230736
310666	4661	9201	2018-04-27	2018-04-27 00:00:00	2018-04-28	2018-04-28 00:00:00	44818517	\N	\N	dee51a67-5db1-49ca-939c-7ec30167afa9	0	0		0		310692
256026	3857	9201	1999-09-08	1999-09-08 00:00:00	1999-09-09	1999-09-09 00:00:00	44818517	\N	\N	53a01385-958a-4a6c-89df-f087b435e7c1	0	0		0		255994
195027	2925	9201	2015-03-19	2015-03-19 00:00:00	2015-03-20	2015-03-20 00:00:00	44818517	\N	\N	eb573d20-abef-4a80-9e7e-9c03bfaef8cd	0	0		0		195124
309348	4641	9201	2017-09-14	2017-09-14 00:00:00	2017-09-15	2017-09-15 00:00:00	44818517	\N	\N	97e88f2a-3e26-46d6-bc00-d276bd986673	0	0		0		309338
264166	3972	9201	1999-08-16	1999-08-16 00:00:00	1999-08-17	1999-08-17 00:00:00	44818517	\N	\N	0a294a28-92fe-476a-81cf-26c279061485	0	0		0		264153
113888	1703	9201	2019-05-18	2019-05-18 00:00:00	2019-05-19	2019-05-19 00:00:00	44818517	\N	\N	2a11eb6f-bd6f-4627-a952-b39a077b0b78	0	0		0		113933
216671	3259	9201	1999-11-21	1999-11-21 00:00:00	1999-11-22	1999-11-22 00:00:00	44818517	\N	\N	f29ea87e-78f8-4e78-bad9-c1219723a225	0	0		0		216678
322575	4848	9201	1996-11-19	1996-11-19 00:00:00	1996-11-20	1996-11-20 00:00:00	44818517	\N	\N	f55a8ace-c9a4-4135-adfe-a02a4001715e	0	0		0		322541
37006	558	9201	2002-03-22	2002-03-22 00:00:00	2002-03-23	2002-03-23 00:00:00	44818517	\N	\N	4e010b60-6318-4618-9c48-730b997312e3	0	0		0		37039
57281	864	9201	2011-03-20	2011-03-20 00:00:00	2011-03-21	2011-03-21 00:00:00	44818517	\N	\N	9cd50f95-3267-461c-8869-b40359c9c450	0	0		0		57348
289496	4364	9201	1963-10-02	1963-10-02 00:00:00	1963-10-03	1963-10-03 00:00:00	44818517	\N	\N	b1972e08-0b9f-4ec3-bb1b-1a8ef2880958	0	0		0		289490
237907	3578	9201	2017-01-08	2017-01-08 00:00:00	2017-01-09	2017-01-09 00:00:00	44818517	\N	\N	5a26e195-32d3-4163-8923-3325f4cd526a	0	0		0		237851
254498	3833	9201	2002-01-27	2002-01-27 00:00:00	2002-01-28	2002-01-28 00:00:00	44818517	\N	\N	f0babc01-3964-4e6b-a2b2-ab3495644a40	0	0		0		254486
18671	280	9201	1975-02-02	1975-02-02 00:00:00	1975-02-03	1975-02-03 00:00:00	44818517	\N	\N	f28e1dfc-49ed-4764-9b4a-ff6af370e828	0	0		0		18681
294782	4435	9201	2000-11-16	2000-11-16 00:00:00	2000-11-17	2000-11-17 00:00:00	44818517	\N	\N	22c082e9-cd70-4821-b165-6a4939d597b3	0	0		0		294819
24351	366	9201	1944-10-06	1944-10-06 00:00:00	1944-10-07	1944-10-07 00:00:00	44818517	\N	\N	e812af27-6618-4b3d-8904-12c1731a15dc	0	0		0		24337
188166	2834	9201	1972-03-16	1972-03-16 00:00:00	1972-03-17	1972-03-17 00:00:00	44818517	\N	\N	461e4ec6-9d36-4530-914e-d06c02a1330e	0	0		0		188163
7655	116	9201	1970-03-12	1970-03-12 00:00:00	1970-03-13	1970-03-13 00:00:00	44818517	\N	\N	52b3b9b5-2fbc-42e0-bea7-37a94dd79327	0	0		0		7687
160468	2418	9201	1995-09-01	1995-09-01 00:00:00	1995-09-04	1995-09-04 00:00:00	44818517	\N	\N	a6c0499f-fbfc-477d-9b9f-a166de7fc7cf	0	0		0		160466
130616	1965	9201	2010-05-27	2010-05-27 00:00:00	2010-05-28	2010-05-28 00:00:00	44818517	\N	\N	96c374ac-3516-4d97-8aa7-e5ccaa40bc3d	0	0		0		130666
247956	3731	9201	1984-08-04	1984-08-04 00:00:00	1984-08-05	1984-08-05 00:00:00	44818517	\N	\N	f5f5115a-c2eb-4486-9852-fc0a1fac807b	0	0		0		247955
103501	1545	9201	2006-07-22	2006-07-22 00:00:00	2006-07-23	2006-07-23 00:00:00	44818517	\N	\N	07383067-847b-46b8-88a9-0488a27f44b7	0	0		0		103533
230380	3470	9201	1998-08-10	1998-08-10 00:00:00	1998-08-11	1998-08-11 00:00:00	44818517	\N	\N	f4ee1b42-b4f1-4ed5-88b1-975722687977	0	0		0		230329
130274	1958	9201	2010-10-01	2010-10-01 00:00:00	2010-10-02	2010-10-02 00:00:00	44818517	\N	\N	1a958c9d-7f65-482a-8000-5dfdf0d3f5fa	0	0		0		130276
160193	2414	9201	1957-05-09	1957-05-09 00:00:00	1957-05-10	1957-05-10 00:00:00	44818517	\N	\N	b1afa625-9426-459d-b8cc-2e8aeebaf1f0	0	0		0		160179
92252	1390	9201	2006-12-19	2006-12-19 00:00:00	2006-12-20	2006-12-20 00:00:00	44818517	\N	\N	34b41d3d-50af-4ed2-99b7-83541a54d479	0	0		0		92292
29952	449	9201	1968-10-27	1968-10-27 00:00:00	1968-10-28	1968-10-28 00:00:00	44818517	\N	\N	e4105e99-2d8a-4b9d-996f-2c378147508e	0	0		0		29959
223887	3375	9201	1967-03-04	1967-03-04 00:00:00	1967-03-06	1967-03-06 00:00:00	44818517	\N	\N	b533346c-41c1-4594-a0bc-fea174f7e835	0	0		0		223877
144721	2173	9201	1975-04-22	1975-04-22 00:00:00	1975-04-23	1975-04-23 00:00:00	44818517	\N	\N	ababbf80-9b7b-441b-a88f-a8bab49ab321	0	0		0		144842
107797	1606	9201	1989-06-03	1989-06-03 00:00:00	1989-06-04	1989-06-04 00:00:00	44818517	\N	\N	ffd146c2-f6b4-4a6f-b489-c910ef22f116	0	0		0		107837
258361	3887	9201	1990-06-23	1990-06-23 00:00:00	1990-06-24	1990-06-24 00:00:00	44818517	\N	\N	a6bef892-6cc5-44c4-87aa-5e7b772dd552	0	0		0		258342
69704	1062	9201	1969-02-11	1969-02-11 00:00:00	1969-02-12	1969-02-12 00:00:00	44818517	\N	\N	04b8bf0d-c9c7-4a96-a310-327e6e7eba93	0	0		0		69661
253239	3811	9201	2016-12-24	2016-12-24 00:00:00	2016-12-25	2016-12-25 00:00:00	44818517	\N	\N	f5e6dc8b-23ab-42ff-a035-ac7e88fe1e13	0	0		0		253183
142596	2141	9201	1961-09-09	1961-09-09 00:00:00	1961-09-10	1961-09-10 00:00:00	44818517	\N	\N	a39854f7-fcfc-4f44-a3ff-e88b24026790	0	0		0		142598
43505	656	9201	1996-12-28	1996-12-28 00:00:00	1996-12-29	1996-12-29 00:00:00	44818517	\N	\N	a567b8d8-f05a-4e93-aea7-03aa170c2df2	0	0		0		43441
214333	3223	9201	1998-07-03	1998-07-03 00:00:00	1998-07-04	1998-07-04 00:00:00	44818517	\N	\N	b5c38d99-c5c2-4c08-9ad0-7ed8b39a4fff	0	0		0		214231
271950	4091	9201	2009-06-12	2009-06-12 00:00:00	2009-06-13	2009-06-13 00:00:00	44818517	\N	\N	29b97d92-4771-40b8-a2e4-3b76c23e439c	0	0		0		272002
287103	4329	9201	2014-10-26	2014-10-26 00:00:00	2014-10-27	2014-10-27 00:00:00	44818517	\N	\N	e36088c0-bc47-4c67-8146-6b0fbd082fd4	0	0		0		287106
281511	4239	9201	2019-04-20	2019-04-20 00:00:00	2019-04-21	2019-04-21 00:00:00	44818517	\N	\N	20bc9e1b-7b29-4f3e-be48-b674446d64e6	0	0		0		281553
233586	3518	9201	2016-03-17	2016-03-17 00:00:00	2016-03-21	2016-03-21 00:00:00	44818517	\N	\N	a37717ce-97b5-4a2c-b8ac-b56efe5c86e7	0	0		0		233546
347756	5228	9201	1969-01-22	1969-01-22 00:00:00	1969-01-23	1969-01-23 00:00:00	44818517	\N	\N	cdf06652-1f80-4dc5-b41e-803d3657a02e	0	0		0		347793
171074	2583	9201	2001-06-08	2001-06-08 00:00:00	2001-06-12	2001-06-12 00:00:00	44818517	\N	\N	2461e9c5-9bfd-42ed-89c1-af2f07409eef	0	0		0		171046
28548	430	9201	2012-10-07	2012-10-07 00:00:00	2012-10-08	2012-10-08 00:00:00	44818517	\N	\N	c7460827-8e0b-4b0a-a5eb-930520385775	0	0		0		28547
280343	4222	9201	1987-02-17	1987-02-17 00:00:00	1987-02-18	1987-02-18 00:00:00	44818517	\N	\N	a6eb25b2-d503-44a4-9644-bef5c87b4ef2	0	0		0		280298
19088	286	9201	1976-10-11	1976-10-11 00:00:00	1976-10-12	1976-10-12 00:00:00	44818517	\N	\N	7a74202d-5a3b-43f1-93b6-8dc111199596	0	0		0		19038
95489	1433	9201	1995-11-08	1995-11-08 00:00:00	1995-11-09	1995-11-09 00:00:00	44818517	\N	\N	15f296c6-50d2-457d-b964-1f326c39de0b	0	0		0		95480
43504	656	9201	2011-03-31	2011-03-31 00:00:00	2011-04-01	2011-04-01 00:00:00	44818517	\N	\N	27b0dc4a-af66-42b0-9ad9-a6f64faa3172	0	0		0		43496
261310	3930	9201	1972-10-07	1972-10-07 00:00:00	1972-10-08	1972-10-08 00:00:00	44818517	\N	\N	4e522fd7-8e77-4705-83dd-b5343a8952f4	0	0		0		261271
207242	3115	9201	2006-05-28	2006-05-28 00:00:00	2006-05-29	2006-05-29 00:00:00	44818517	\N	\N	5cada6f6-0973-4989-b7ac-f59b949be7da	0	0		0		207259
348231	5234	9201	1977-08-24	1977-08-24 00:00:00	1977-08-25	1977-08-25 00:00:00	44818517	\N	\N	42beaccc-76f5-465f-bcd8-74edb4d863e9	0	0		0		348221
312397	4689	9201	2007-12-13	2007-12-13 00:00:00	2007-12-14	2007-12-14 00:00:00	44818517	\N	\N	e8412c66-60e4-4cb6-9e20-55d72c1b8908	0	0		0		312450
330922	4976	9201	1996-03-24	1996-03-24 00:00:00	1996-03-25	1996-03-25 00:00:00	44818517	\N	\N	362491b2-d9f8-4433-a1ed-3d4100c705b6	0	0		0		331056
128626	1934	9201	2000-09-08	2000-09-08 00:00:00	2000-09-09	2000-09-09 00:00:00	44818517	\N	\N	8b08ee07-413d-46b2-a97b-6cbee8b3e304	0	0		0		128663
54560	823	9201	1977-11-14	1977-11-14 00:00:00	1977-11-18	1977-11-18 00:00:00	44818517	\N	\N	1d0088f3-e908-4466-95c4-8a772b05eed7	0	0		0		54565
19049	286	9201	1979-01-06	1979-01-06 00:00:00	1979-01-07	1979-01-07 00:00:00	44818517	\N	\N	965ac1ba-1ea5-4cf2-9c8f-2dded0772afb	0	0		0		19040
209420	3147	9201	2003-04-28	2003-04-28 00:00:00	2003-04-30	2003-04-30 00:00:00	44818517	\N	\N	35d2552e-730e-4fec-bfa2-01dcdb2206a6	0	0		0		209366
115833	1733	9201	1989-08-11	1989-08-11 00:00:00	1989-08-12	1989-08-12 00:00:00	44818517	\N	\N	68aeac5d-8c44-4cdf-8d94-655711aa9235	0	0		0		115804
227226	3427	9201	1970-02-22	1970-02-22 00:00:00	1970-02-23	1970-02-23 00:00:00	44818517	\N	\N	d9fc5423-8ce8-4559-b887-135d4f2f0754	0	0		0		227245
87609	1321	9201	1995-06-24	1995-06-24 00:00:00	1995-06-27	1995-06-27 00:00:00	44818517	\N	\N	7d0b2737-cd60-4d76-9691-430aea9e35db	0	0		0		87599
245081	3686	9201	2009-12-16	2009-12-16 00:00:00	2009-12-17	2009-12-17 00:00:00	44818517	\N	\N	3343e7c2-7693-44f6-b597-612a3ab55d4b	0	0		0		245027
83822	1271	9201	2010-11-13	2010-11-13 00:00:00	2010-11-14	2010-11-14 00:00:00	44818517	\N	\N	6c5511de-3f8d-43ad-ae91-45b7ee30652e	0	0		0		83838
245608	3695	9201	2013-12-22	2013-12-22 00:00:00	2013-12-23	2013-12-23 00:00:00	44818517	\N	\N	04a00154-c90b-4be8-b931-0fda3d64de08	0	0		0		245581
164533	2483	9201	1984-11-07	1984-11-07 00:00:00	1984-11-08	1984-11-08 00:00:00	44818517	\N	\N	1f97272a-5119-453a-ac16-1b6b90b2b651	0	0		0		164509
309885	4646	9201	1964-07-29	1964-07-29 00:00:00	1964-08-02	1964-08-02 00:00:00	44818517	\N	\N	4e286ef2-c16e-4f56-bf2f-ccaba49929f5	0	0		0		309738
285101	4295	9201	2007-12-11	2007-12-11 00:00:00	2007-12-12	2007-12-12 00:00:00	44818517	\N	\N	04fd6e60-56c9-44ab-8888-35f17a43c79b	0	0		0		285096
101909	1524	9201	1969-01-12	1969-01-12 00:00:00	1969-01-16	1969-01-16 00:00:00	44818517	\N	\N	51ee680b-03f7-42e3-95f0-7f1de977537b	0	0		0		101915
110190	1641	9201	1997-11-10	1997-11-10 00:00:00	1997-11-11	1997-11-11 00:00:00	44818517	\N	\N	9d819f03-db5b-4bd4-803a-341143e33edd	0	0		0		110130
171815	2596	9201	2017-04-02	2017-04-02 00:00:00	2017-04-03	2017-04-03 00:00:00	44818517	\N	\N	4a758350-f2a4-4dfd-9081-1ce8aa1f92e4	0	0		0		171765
236131	3556	9201	2013-10-15	2013-10-15 00:00:00	2013-10-16	2013-10-16 00:00:00	44818517	\N	\N	fd769cfd-d021-427c-9ac4-4bcf36e04030	0	0		0		236116
257656	3879	9201	1981-05-08	1981-05-08 00:00:00	1981-05-09	1981-05-09 00:00:00	44818517	\N	\N	9cb81b44-3d53-4522-be38-1c07d089dbb5	0	0		0		257699
\.


--
-- TOC entry 3917 (class 0 OID 3185607)
-- Dependencies: 239
-- Data for Name: vocabulary; Type: TABLE DATA; Schema: OMOP_cdm_eunomia; Owner: juanma
--

COPY "OMOP_cdm_eunomia".vocabulary (vocabulary_id, vocabulary_name, vocabulary_reference, vocabulary_version, vocabulary_concept_id) FROM stdin;
ABMS	Provider Specialty (American Board of Medical Specialties)	http://www.abms.org/member-boards/specialty-subspecialty-certificates	2018-06-26 ABMS	45756746
AMT	Australian Medicines Terminology (NEHTA)	https://www.nehta.gov.au/implementation-resources/terminology-access	AMT 01-SEP-17	238
APC	Ambulatory Payment Classification (CMS)	http://www.cms.gov/Medicare/Medicare-Fee-for-Service-Payment/HospitalOutpatientPPS/Hospital-Outpatient-Regulations-and-Notices.html	2018-January-Addendum-A	44819132
ATC	WHO Anatomic Therapeutic Chemical Classification	FDB UK distribution package	RXNORM 2018-08-12	44819117
BDPM	Public Database of Medications (Social-Sante)	http://base-donnees-publique.medicaments.gouv.fr/telechargement.php	BDPM 17-JUL-17	236
CDM	OMOP Common DataModel	https://github.com/OHDSI/CommonDataModel	CDM v6.0.0	32485
CDT	Current Dental Terminology (ADA)	http://www.nlm.nih.gov/research/umls/licensedcontent/umlsknowledgesources.html	2018 Release	581438
CIEL	Columbia International eHealth Laboratory (Columbia University)	https://wiki.openmrs.org/display/docs/Getting+and+Using+the+MVP-CIEL+Concept+Dictionary	Openmrs 1.11.0 20150227	45905710
Cohort	Legacy OMOP HOI or DOI cohort	OMOP generated		44819123
Cohort Type	OMOP Cohort Type	OMOP generated		44819234
Concept Class	OMOP Concept Class	OMOP generated		44819233
Condition Type	OMOP Condition Occurrence Type	OMOP generated		44819127
Cost	OMOP Cost	OMOP generated		581457
Cost Type	OMOP Cost Type	OMOP generated		5029
CPT4	Current Procedural Terminology version 4 (AMA)	http://www.nlm.nih.gov/research/umls/licensedcontent/umlsknowledgesources.html	2018 Release	44819100
Currency	International Currency Symbol (ISO 4217)	http://www.iso.org/iso/home/standards/currency_codes.htm	2008	44819153
CVX	CDC Vaccine Administered CVX (NCIRD)	https://www2a.cdc.gov/vaccines/iis/iisstandards/vaccines.asp?rpt=cvx	CVX code set 31-JUL-17	581400
DA_France	Disease Analyzer France (IMS)	IMS proprietary	DA_France2018-11-19	204
Death Type	OMOP Death Type	OMOP generated		44819135
Device Type	OMOP Device Type	OMOP generated		44819151
dm+d	Dictionary of Medicines and Devices (NHS)	https://isd.hscic.gov.uk/trud3/user/authenticated/group/0/pack/1/subpack/24/releases	dm+d Version 6.0.0 20180604	232
Domain	OMOP Domain	OMOP generated		44819147
DPD	Drug Product Database (Health Canada)	http://open.canada.ca/data/en/dataset/bf55e42a-63cb-4556-bfd8-44f26e5a36fe	DPD 25-JUN-17	231
DRG	Diagnosis-related group (CMS)	http://www.cms.gov/Medicare/Medicare-Fee-for-Service-Payment/AcuteInpatientPPS/Acute-Inpatient-Files-for-Download.html	2011-18-02	44819130
Drug Type	OMOP Drug Exposure Type	OMOP generated		44819126
EphMRA ATC	Anatomical Classification of Pharmaceutical Products (EphMRA)	http://www.ephmra.org/Anatomical-Classification	EphMRA ATC 2016	243
Episode	OMOP Episode	OMOP generated		32523
ETC	Enhanced Therapeutic Classification (FDB)	FDB US distribution package	20151119 Release	44819116
Ethnicity	OMOP Ethnicity	OMOP generated		44819134
GCN_SEQNO	Clinical Formulation ID (FDB)	FDB US distribution package	20151119 Release	44819141
Gemscript	Gemscript (Resip)	http://www.whocc.no/atc_ddd_index/	Gemscript 2018-07-01	44819144
Gender	OMOP Gender	OMOP generated		44819108
GGR	Commented Drug Directory (BCFI)	http://www.bcfi.be/nl/download	GGR 20180901	581450
GPI	Medi-Span Generic Product Identifier (Wolters Kluwer Health)	Medi-Span distribution package	GPI 2017	44819106
GRR	Global Reference Repository (IMS)	IMS proprietary	GRR 2019-01-17	5047
HCPCS	Healthcare Common Procedure Coding System (CMS)	http://www.nlm.nih.gov/research/umls/licensedcontent/umlsknowledgesources.html	20180101 Alpha Numeric HCPCS File	44819101
HES Specialty	Hospital Episode Statistics Specialty (NHS)	http://www.datadictionary.nhs.uk/data_dictionary/attributes/m/main_specialty_code_de.asp?shownav=0	2018-06-26 HES Specialty	44819145
ICD10	International Classification of Diseases, Tenth Revision (WHO)	http://www.who.int/classifications/icd/icdonlineversions/en/	2016 Release	44819124
ICD10CM	International Classification of Diseases, Tenth Revision, Clinical Modification (NCHS)	http://www.cdc.gov/nchs/icd/icd10cm.htm	ICD10CM FY2019 code descriptions	44819098
ICD10PCS	ICD-10 Procedure Coding System (CMS)	http://www.cms.gov/Medicare/Coding/ICD10/index.html	ICD10PCS 2019	44819125
ICD9CM	International Classification of Diseases, Ninth Revision, Clinical Modification, Volume 1 and 2 (NCHS)	http://www.cms.gov/Medicare/Coding/ICD9ProviderDiagnosticCodes/codes.html	ICD9CM v32 master descriptions	5046
ICD9Proc	International Classification of Diseases, Ninth Revision, Clinical Modification, Volume 3 (NCHS)	http://www.cms.gov/Medicare/Coding/ICD9ProviderDiagnosticCodes/codes.html	ICD9CM v32 master descriptions	44819099
ICDO3	International Classification of Diseases for Oncology, Third Edition (WHO)	https://seer.cancer.gov/icd-o-3/	ICDO3 SEER Site/Histology Released 09/18/2015	581426
Indication	Indications and Contraindications (FDB)	FDB US distribution package	20151119 Release	44819115
JNJ_CPRD_ET_LOINC	CPRD Additional Enttypes Mapped to LOINC Concepts			0
JNJ_CPRD_GS_RXN	CPRD Prodcode (Gemscript Dictionary) Mapped to RxNorm Concepts			0
JNJ_CPRD_HES_LOINC	CPRD HES Observation Fields to LOINC			0
JNJ_CPRD_PROV_CMS2	CPRD Provider to CMS2			0
JNJ_CPRD_PROV_SPEC	CPRD Provider Roles Mapped to CMS Specialty			0
JNJ_CPRD_SCORE_LOINC	CPRD Scoring Method Plus Read Codes Mapped to LOINC			0
JNJ_CPRD_T_ET_LOINC	CPRD Test Enttypes Mapped to LOINC Concepts			0
JNJ_DEATH	Death Source Code List			0
JNJ_JMDC_DRUGS	JMDC Drug codes			0
JNJ_JMDC_OBSERVATION	JMDC Observation codes			0
JNJ_JMDC_SPECIALTIES	JMDC Specialty codes			0
JNJ_LAB_UNIT	Lab Unit			0
JNJ_NHANES_DRUG	NHANES Drug Codes			0
JNJ_OPTUM_DPOS	OPTUM Discharge Codes			0
JNJ_OPTUM_EHR_LABNAM	OPTUM Oncology EHR Lab Names			0
JNJ_OPTUM_EHR_LABRES	OPTUM Oncology EHR Lab Results			0
JNJ_OPTUM_EHR_OBTYPE	OPTUM Oncology EHR Observation Type			0
JNJ_OPTUM_EHR_ROUTE	OPTUM Oncology EHR Route			0
JNJ_OPTUM_EHR_SPCLTY	OPTUM Oncology EHR Specialty			0
JNJ_OPTUM_EHR_VISIT	OPTUM Oncology EHR Visit			0
JNJ_OPTUM_NLP_DRUG	OPTUM Oncology EHR Drug			0
JNJ_OPTUM_P_SPCLTY	Optum Provider Specialty			0
JNJ_PMR_COST_CHRG_CD	Premier Cost Charge Codes			0
JNJ_PMR_DRUG_CHRG_CD	Premier Standard Charge Code - Drugs			0
JNJ_PMR_OBS_CODE	Premier Observation Code			0
JNJ_PMR_P_SPCLTY	Premier Provider Specialty			0
JNJ_PMR_PROC_CHRG_CD	Premier Standard Charge Code - Procedures			0
JNJ_TREAT_OBS	TREAT Observations			0
JNJ_TRU_HRA	Truven Health Risk Assessment (HRA)			0
JNJ_TRU_HRA_QUESTION	Truven Health Risk Assessment (HRA) Questions			0
JNJ_TRU_P_SPCLTY	Truven Provider Specialty			0
LOINC	Logical Observation Identifiers Names and Codes (Regenstrief Institute)	http://loinc.org/downloads/loinc	2.65	44819102
LPD_Australia	Longitudinal Patient Data Australia (IMS)	IMS proprietary	LPD_Australia_052018	5045
LPD_Belgium	LPD_Belgium	IMS proprietary	LPD_Belgium 18-JAN-18	581451
MDC	Major Diagnostic Categories (CMS)	http://www.cms.gov/Medicare/Medicare-Fee-for-Service-Payment/AcuteInpatientPPS/Acute-Inpatient-Files-for-Download.html	2013-01-06	44819131
Meas Type	OMOP Measurement Type	OMOP generated		44819152
MedDRA	Medical Dictionary for Regulatory Activities (MSSO)	http://www.meddramsso.com/subscriber_download.asp	MedDRA version 19.1	44819111
MEDRT	Medication Reference Terminology MED-RT (VA)	https://nciterms.nci.nih.gov/ncitbrowser/pages/vocabulary.jsf?dictionary=MED-RT	MED-RT 2018-09-04	32537
MeSH	Medical Subject Headings (NLM)	http://www.nlm.nih.gov/research/umls/licensedcontent/umlsknowledgesources.html	2018 Release	44819136
MMI	Modernizing Medicine (MMI)	MMI proprietary		581367
Multilex	Multilex (FDB)	http://www.nlm.nih.gov/research/umls/rxnorm/docs/rxnormfiles.html	2013-05-06	44819118
Multum	Cerner Multum (Cerner)	http://www.nlm.nih.gov/research/umls/rxnorm/docs/rxnormfiles.html	2013-07-10	44819112
NDC	National Drug Code (FDA and manufacturers)	http://www.nlm.nih.gov/research/umls/rxnorm/docs/rxnormfiles.html, http://www.fda.gov/downloads/Drugs/DevelopmentApprovalProcess/UCM070838.zip	NDC 20190113	44819105
NDFRT	National Drug File - Reference Terminology (VA)	http://www.nlm.nih.gov/research/umls/rxnorm/docs/rxnormfiles.html	RXNORM 2018-08-12	44819103
NFC	New Form Code (EphMRA)	http://www.ephmra.org/New-Form-Codes-Classification	NFC 20160704	245
None	OMOP Standardized Vocabularies	OMOP generated	v5.0 18-JAN-19	44819096
Note Type	OMOP Note Type	OMOP generated		44819146
NUCC	National Uniform Claim Committee Health Care Provider Taxonomy Code Set (NUCC)	http://www.nucc.org/index.php?option=com_content&view=article&id=107&Itemid=132	2018-06-26 NUCC	44819137
Obs Period Type	OMOP Observation Period Type	OMOP generated		44819149
Observation Type	OMOP Observation Type	OMOP generated		44819129
OPCS4	OPCS Classification of Interventions and Procedures version 4 (NHS)	http://systems.hscic.gov.uk/data/clinicalcoding/codingstandards/opcs4	2018 Release	44819143
OXMIS	Oxford Medical Information System (OCHP)	Codes extracted from GPRD database, courtesy of GSK		44819114
PCORNet	National Patient-Centered Clinical Research Network (PCORI)	OMOP generated		44819148
PHDSC	Source of Payment Typology (PHDSC)	http://www.phdsc.org/standards/payer-typology-source.asp	Version 3.0	32473
Place of Service	Place of Service Codes for Professional Claims (CMS)	http://www.cms.gov/Medicare/Medicare-Fee-for-Service-Payment/PhysicianFeeSched/downloads//Website_POS_database.pdf	2009-01-11	44819110
Plan	Health Plan - contract to administer healthcare transactions by the payer, facilitated by the sponsor			32471
Plan Stop Reason	Plan Stop Reason - Reason for termination of the Health Plan			32474
PPI	AllOfUs_PPI (Columbia)	http://terminology.pmi-ops.org/CodeSystem/ppi	Codebook Version 0.3.12	581404
Procedure Type	OMOP Procedure Occurrence Type	OMOP generated		44819128
Race	Race and Ethnicity Code Set (USBC)	http://www.cdc.gov/nchs/data/dvs/Race_Ethnicity_CodeSet.pdf	Version 1.0	44819109
Read	NHS UK Read Codes Version 2 (HSCIC)	http://www.nlm.nih.gov/research/umls/licensedcontent/umlsknowledgesources.html	NHS READV2 21.0.0 20160401000001 + DATAMIGRATION_25.0.0_20180403000001	44819113
Relationship	OMOP Relationship	OMOP generated		44819235
Revenue Code	UB04/CMS1450 Revenue Codes (CMS)	http://www.mpca.net/?page=ERC_finance	2010 Release	44819133
RxNorm	RxNorm (NLM)	http://www.nlm.nih.gov/research/umls/rxnorm/docs/rxnormfiles.html	RxNorm 20181203	44819104
RxNorm Extension	RxNorm Extension (OMOP)	OMOP generated	RxNorm Extension 2019-01-17	252
SMQ	Standardised MedDRA Queries (MSSO)	http://www.meddramsso.com/secure/smq/SMQ_Spreadsheet_14_0_English_update.xlsx	Version 14.0	44819121
SNOMED	Systematic Nomenclature of Medicine - Clinical Terms (IHTSDO)	http://www.nlm.nih.gov/research/umls/licensedcontent/umlsknowledgesources.html	Snomed Release 20180731	44819097
Specialty	Medicare provider/supplier specialty codes (CMS)	http://www.cms.gov/Medicare/Provider-Enrollment-and-Certification/MedicareProviderSupEnroll/Taxonomy.html	2018-06-26 Specialty	44819138
Specimen Type	OMOP Specimen Type	OMOP generated		581376
SPL	Structured Product Labeling (FDA)	http://www.fda.gov/Drugs/InformationOnDrugs/ucm142438.htm	NDC 20190113	44819140
Sponsor	Sponsor - institution or individual financing healthcare transactions			32472
UB04 Point of Origin	UB04 Claim Source Inpatient Admission Code (CMS)	https://www.resdac.org/cms-data/variables/Claim-Source-Inpatient-Admission-Code		32045
UB04 Pri Typ of Adm	UB04 Claim Inpatient Admission Type Code (CMS)	https://www.resdac.org/cms-data/variables/Claim-Inpatient-Admission-Type-Code		32046
UB04 Pt dis status	UB04 Patient Discharge Status Code (CMS)	https://www.resdac.org/cms-data/variables/patient-discharge-status-code		32047
UB04 Typ bill	UB04 Type of Bill - Institutional (USHIK)	https://ushik.ahrq.gov/ViewItemDetails?&system=apcd&itemKey=196987000		32044
UCUM	Unified Code for Units of Measure (Regenstrief Institute)	http://aurora.regenstrief.org/~ucum/ucum.html#section-Alphabetic-Index	Version 1.8.2	44819107
VA Class	VA National Drug File Class (VA)	http://www.nlm.nih.gov/research/umls/rxnorm/docs/rxnormfiles.html	RXNORM 2018-08-12	44819122
VA Product	VA National Drug File Product (VA)	http://www.nlm.nih.gov/research/umls/rxnorm/docs/rxnormfiles.html	RXNORM 2018-08-12	44819120
Visit	OMOP Visit	OMOP generated		44819119
Visit Type	OMOP Visit Type	OMOP generated		44819150
Vocabulary	OMOP Vocabulary	OMOP generated		44819232
\.


-- Completed on 2022-05-12 18:18:26 CEST

--
-- PostgreSQL database dump complete
--

